-- MySQL dump 10.13  Distrib 5.6.17, for linux-glibc2.5 (x86_64)
--
-- Host: localhost    Database: mrzj
-- ------------------------------------------------------
-- Server version	5.6.17-log

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `acc_share_data`
--

DROP TABLE IF EXISTS `acc_share_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `acc_share_data` (
  `accid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '平台账号id',
  `accname` varchar(50) NOT NULL DEFAULT '' COMMENT '平台账号',
  `gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '元宝',
  `total_charge` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '帐号累计充值值(元宝)',
  `day_charge` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '玩家历史单日最高充值元宝数',
  PRIMARY KEY (`accid`,`accname`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='帐号共享数据表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `acc_share_data`
--

LOCK TABLES `acc_share_data` WRITE;
/*!40000 ALTER TABLE `acc_share_data` DISABLE KEYS */;
/*!40000 ALTER TABLE `acc_share_data` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `achievement`
--

DROP TABLE IF EXISTS `achievement`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `achievement` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '成就id',
  `progress` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '进度',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '状态',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
  PRIMARY KEY (`role_id`,`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家成就数据';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `achievement`
--

LOCK TABLES `achievement` WRITE;
/*!40000 ALTER TABLE `achievement` DISABLE KEYS */;
/*!40000 ALTER TABLE `achievement` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `achievement_logout`
--

DROP TABLE IF EXISTS `achievement_logout`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `achievement_logout` (
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `event_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '事件ID',
  `update_list` varchar(1024) NOT NULL COMMENT '成就更新列表',
  PRIMARY KEY (`player_id`,`event_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='成就离线数据';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `achievement_logout`
--

LOCK TABLES `achievement_logout` WRITE;
/*!40000 ALTER TABLE `achievement_logout` DISABLE KEYS */;
/*!40000 ALTER TABLE `achievement_logout` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `achievement_star_reward`
--

DROP TABLE IF EXISTS `achievement_star_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `achievement_star_reward` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `star` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '累计星数',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '状态',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`role_id`,`star`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `achievement_star_reward`
--

LOCK TABLES `achievement_star_reward` WRITE;
/*!40000 ALTER TABLE `achievement_star_reward` DISABLE KEYS */;
/*!40000 ALTER TABLE `achievement_star_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `act_boss_born`
--

DROP TABLE IF EXISTS `act_boss_born`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `act_boss_born` (
  `scene_id` int(10) unsigned NOT NULL COMMENT '场景id',
  `x` int(10) unsigned NOT NULL COMMENT 'x坐标',
  `y` int(10) unsigned NOT NULL COMMENT 'y坐标',
  `mon_type` int(10) unsigned NOT NULL COMMENT '怪物类型',
  `mon_id` bigint(10) unsigned NOT NULL COMMENT '怪物id',
  `sub_type` int(10) unsigned NOT NULL COMMENT '活动子类型',
  `is_died` tinyint(2) unsigned NOT NULL COMMENT '是否已死亡（1是 0否）',
  `create_time` int(10) unsigned NOT NULL COMMENT '创建时间',
  PRIMARY KEY (`scene_id`,`x`,`y`,`mon_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `act_boss_born`
--

LOCK TABLES `act_boss_born` WRITE;
/*!40000 ALTER TABLE `act_boss_born` DISABLE KEYS */;
/*!40000 ALTER TABLE `act_boss_born` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `advance_payment_account`
--

DROP TABLE IF EXISTS `advance_payment_account`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `advance_payment_account` (
  `ref` varchar(63) NOT NULL COMMENT '唯一引用',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `cost_list` varchar(1000) NOT NULL COMMENT '消耗记录',
  `consume_id` int(10) unsigned NOT NULL COMMENT '消耗类型id',
  `about` varchar(255) NOT NULL DEFAULT '' COMMENT '备注',
  `other` varchar(255) NOT NULL DEFAULT '[]' COMMENT '其它数据',
  PRIMARY KEY (`ref`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='预付款记账表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `advance_payment_account`
--

LOCK TABLES `advance_payment_account` WRITE;
/*!40000 ALTER TABLE `advance_payment_account` DISABLE KEYS */;
/*!40000 ALTER TABLE `advance_payment_account` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `adventure_book`
--

DROP TABLE IF EXISTS `adventure_book`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `adventure_book` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '书本类型',
  `subtype` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '书本子类型',
  `progress` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '进度',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '状态',
  PRIMARY KEY (`role_id`,`type`,`subtype`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='冒险之书';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `adventure_book`
--

LOCK TABLES `adventure_book` WRITE;
/*!40000 ALTER TABLE `adventure_book` DISABLE KEYS */;
/*!40000 ALTER TABLE `adventure_book` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `auction`
--

DROP TABLE IF EXISTS `auction`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `auction` (
  `auction_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖场次id',
  `auction_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖类型',
  `cfg_id` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖会配置Id',
  `module_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `auction_status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖状态',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖时间',
  `last_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '场次更新时间',
  PRIMARY KEY (`auction_id`),
  KEY `time` (`time`),
  KEY `last_time` (`last_time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='拍卖场次表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `auction`
--

LOCK TABLES `auction` WRITE;
/*!40000 ALTER TABLE `auction` DISABLE KEYS */;
/*!40000 ALTER TABLE `auction` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `auction_goods`
--

DROP TABLE IF EXISTS `auction_goods`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `auction_goods` (
  `goods_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖物id',
  `auction_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖场次id',
  `goods_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型id',
  `goods_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品数量',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品大类',
  `auction_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖类型',
  `cfg_id` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖会配置Id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '竞拍物品拥有者id',
  `module_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `goods_status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖物状态',
  `bonus_tax_rate` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分红税率',
  `start_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开始拍卖时间',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
  PRIMARY KEY (`goods_id`),
  KEY `auction_id` (`auction_id`),
  KEY `auction_type` (`auction_type`),
  KEY `guild_id` (`guild_id`),
  KEY `module_id` (`module_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='拍卖物品表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `auction_goods`
--

LOCK TABLES `auction_goods` WRITE;
/*!40000 ALTER TABLE `auction_goods` DISABLE KEYS */;
/*!40000 ALTER TABLE `auction_goods` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `auction_guild_award`
--

DROP TABLE IF EXISTS `auction_guild_award`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `auction_guild_award` (
  `auction_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖场次id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `award_status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '奖励状态',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`auction_id`,`guild_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='拍卖：公会奖励信息';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `auction_guild_award`
--

LOCK TABLES `auction_guild_award` WRITE;
/*!40000 ALTER TABLE `auction_guild_award` DISABLE KEYS */;
/*!40000 ALTER TABLE `auction_guild_award` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `auction_info`
--

DROP TABLE IF EXISTS `auction_info`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `auction_info` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `goods_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖物id',
  `auction_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖场次id',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '竞拍人id',
  `price_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '竞拍类型',
  `price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '竞价',
  `price_list` varchar(256) NOT NULL DEFAULT '' COMMENT '竞价详细',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
  PRIMARY KEY (`id`),
  KEY `goods_id` (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='拍卖记录表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `auction_info`
--

LOCK TABLES `auction_info` WRITE;
/*!40000 ALTER TABLE `auction_info` DISABLE KEYS */;
/*!40000 ALTER TABLE `auction_info` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `auction_log`
--

DROP TABLE IF EXISTS `auction_log`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `auction_log` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `auction_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖类型',
  `module_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `goods_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型id',
  `goods_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品数量',
  `money_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '价格类型',
  `price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '成交价格',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
  `to_world` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否流拍至世界',
  PRIMARY KEY (`id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='拍卖成交记录';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `auction_log`
--

LOCK TABLES `auction_log` WRITE;
/*!40000 ALTER TABLE `auction_log` DISABLE KEYS */;
/*!40000 ALTER TABLE `auction_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `auto_id`
--

DROP TABLE IF EXISTS `auto_id`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `auto_id` (
  `type` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '类型 1角色 2物品 3帮派',
  `count` int(11) NOT NULL DEFAULT '0' COMMENT '计数',
  PRIMARY KEY (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='id计数表（合服保留主服数据）';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `auto_id`
--

LOCK TABLES `auto_id` WRITE;
/*!40000 ALTER TABLE `auto_id` DISABLE KEYS */;
/*!40000 ALTER TABLE `auto_id` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `awakening`
--

DROP TABLE IF EXISTS `awakening`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `awakening` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `cell_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '命格类型',
  `cell_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '点亮的命格id',
  PRIMARY KEY (`role_id`,`cell_type`,`cell_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='天命觉醒';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `awakening`
--

LOCK TABLES `awakening` WRITE;
/*!40000 ALTER TABLE `awakening` DISABLE KEYS */;
/*!40000 ALTER TABLE `awakening` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `baby`
--

DROP TABLE IF EXISTS `baby`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `baby` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '角色id',
  `stage` smallint(5) unsigned NOT NULL COMMENT '阶数',
  `star` smallint(5) unsigned NOT NULL COMMENT '星数',
  `exp` int(11) unsigned NOT NULL COMMENT '当前经验',
  `upgrade_list` varchar(512) NOT NULL COMMENT '养育列表（[{物品id,使用次数},...]）',
  `mount_id` smallint(5) unsigned NOT NULL COMMENT '坐骑幻化id',
  `fashion_id` smallint(5) unsigned NOT NULL COMMENT '时装幻化id',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='宝宝-玩家宝宝数据表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `baby`
--

LOCK TABLES `baby` WRITE;
/*!40000 ALTER TABLE `baby` DISABLE KEYS */;
/*!40000 ALTER TABLE `baby` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `baby_fashion`
--

DROP TABLE IF EXISTS `baby_fashion`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `baby_fashion` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `fashion_id` int(11) unsigned NOT NULL COMMENT '时装id',
  `star` smallint(5) unsigned NOT NULL COMMENT '星数',
  `expire_time` int(11) unsigned NOT NULL COMMENT '过期时间',
  PRIMARY KEY (`role_id`,`fashion_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='宝宝-宝宝时装数据表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `baby_fashion`
--

LOCK TABLES `baby_fashion` WRITE;
/*!40000 ALTER TABLE `baby_fashion` DISABLE KEYS */;
/*!40000 ALTER TABLE `baby_fashion` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `baby_mount`
--

DROP TABLE IF EXISTS `baby_mount`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `baby_mount` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '角色id',
  `mount_id` smallint(5) unsigned NOT NULL COMMENT '坐骑id',
  `stage` smallint(5) unsigned NOT NULL COMMENT '阶数',
  `star` smallint(5) unsigned NOT NULL COMMENT '星数',
  `exp` int(11) unsigned NOT NULL COMMENT '当前经验',
  `expire_time` int(11) unsigned NOT NULL COMMENT '有效期',
  PRIMARY KEY (`role_id`,`mount_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='宝宝-宝宝坐骑数据表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `baby_mount`
--

LOCK TABLES `baby_mount` WRITE;
/*!40000 ALTER TABLE `baby_mount` DISABLE KEYS */;
/*!40000 ALTER TABLE `baby_mount` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ban_info`
--

DROP TABLE IF EXISTS `ban_info`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ban_info` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '禁止序号',
  `type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '禁止类型(1:ip)',
  `value` varchar(20) NOT NULL COMMENT '禁止的值',
  PRIMARY KEY (`id`),
  KEY `type` (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='禁止数据';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ban_info`
--

LOCK TABLES `ban_info` WRITE;
/*!40000 ALTER TABLE `ban_info` DISABLE KEYS */;
/*!40000 ALTER TABLE `ban_info` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_ac`
--

DROP TABLE IF EXISTS `base_ac`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_ac` (
  `module` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能ID',
  `module_sub` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '子功能ID',
  `ac_sub` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类',
  `ac_name` varchar(1024) NOT NULL COMMENT '活动名称@lang@',
  `ac_icon` varchar(50) NOT NULL DEFAULT '0' COMMENT '活动图标',
  `num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '人数标记',
  `start_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动开启等级',
  `end_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动消失等级',
  `ac_type` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '活动类型',
  `week` varchar(255) NOT NULL DEFAULT '[]' COMMENT '每日每周',
  `month` varchar(255) NOT NULL DEFAULT '[]' COMMENT '每月第几天',
  `time` varchar(255) NOT NULL DEFAULT '[]' COMMENT '固定日期',
  `time_region` varchar(255) NOT NULL DEFAULT '[]' COMMENT '具体时间段',
  `open_day` varchar(255) NOT NULL DEFAULT '[]' COMMENT '开服第几天',
  `merge_day` varchar(255) NOT NULL DEFAULT '[]' COMMENT '合服第几天',
  `about` varchar(1024) NOT NULL COMMENT '活动描述@lang@',
  `reward` varchar(2048) NOT NULL DEFAULT '[]' COMMENT '活动奖励显示',
  `ask` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '“问号”按钮',
  `look` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '“查看活动”按钮',
  `other` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '其他条件',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排序值',
  `jump_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '跳转id(客户端用)',
  `filter_list` varchar(50) NOT NULL DEFAULT '[]' COMMENT '筛选id',
  PRIMARY KEY (`module`,`module_sub`,`ac_sub`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='活动日历';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_ac`
--

LOCK TABLES `base_ac` WRITE;
/*!40000 ALTER TABLE `base_ac` DISABLE KEYS */;
INSERT INTO `base_ac` VALUES (132,0,1,'野外挂机','13200',1,125,9999,1,'[]','[]','[]','[]','[]','[]','可前往与等级匹配的地点在线自动挂机，挂机不停歇，经验蹭蹭蹭！','[{1,[{0,1008040100,1},{0,38190001,1},{0,38040010,1},{0,38330001,1},{0,38130001,1},{0,11020001,1},{0,18020001,1}]},{100,[{0,1010040200,1},{0,17010001,1},{0,38190001,1},{0,38040010,1},{0,38330001,1},{0,38130001,1},{0,11020001,1},{0,18020001,1}]},{200,[{0,1010020300,1},{0,17010002,1},{0,38190001,1},{0,38040010,1},{0,38330001,1},{0,38130001,1},{0,11020001,1},{0,18020001,1}]},{300,[{0,1002020400,1},{0,17010002,1},{0,38190001,1},{0,38040010,1},{0,38330001,1},{0,38130001,1},{0,11020001,1},{0,18020001,1}]},{400,[{0,1010040500,1},{0,17010002,1},{0,38190001,1},{0,38040010,1},{0,38330001,1},{0,38130001,1},{0,11020001,1},{0,18020001,1}]},{500,[{0,1006010600,1},{0,17010002,1},{0,38190001,1},{0,38040010,1},{0,38330001,1},{0,38130001,1},{0,11020001,1},{0,18020001,1}]},{550,[{0,1004020700,1},{0,17010002,1},{0,38190001,1},{0,38040010,1},{0,38330001,1},{0,38130001,1},{0,11020001,1},{0,18020001,1}]},{600,[{0,1008020800,1},{0,17010002,1},{0,38190001,1},{0,38040010,1},{0,38330001,1},{0,38130001,1},{0,11020001,1},{0,18020001,1}]},{650,[{0,1006010900,1},{0,17010002,1},{0,38190001,1},{0,38040010,1},{0,38330001,1},{0,38130001,1},{0,11020001,1},{0,18020001,1}]},{700,[{0,1008021000,1},{0,17010002,1},{0,38190001,1},{0,38040010,1},{0,38330001,1},{0,38130001,1},{0,11020001,1},{0,18020001,1}]},{750,[{0,1010011100,1},{0,17010002,1},{0,38190001,1},{0,38040010,1},{0,38330001,1},{0,38130001,1},{0,11020001,1},{0,18020001,1}]},{800,[{0,1008011200,1},{0,17010003,1},{0,38190001,1},{0,38040010,1},{0,38330001,1},{0,38130001,1},{0,11020001,1},{0,18020001,1}]},{850,[{0,1006041300,1},{0,17010003,1},{0,38190001,1},{0,38040010,1},{0,38330001,1},{0,38130001,1},{0,11020001,1},{0,18020001,1}]},{900,[{0,1010011400,1},{0,17010003,1},{0,38190001,1},{0,38040010,1},{0,38330001,1},{0,38130001,1},{0,11020001,1},{0,18020001,1}]},{1000,[{0,1006021500,1},{0,17010003,1},{0,38190001,1},{0,38040010,1},{0,38330001,1},{0,38130001,1},{0,11020001,1},{0,18020001,1}]}]',0,0,'[]',0,0,'[1,2,4]'),(137,0,1,'钻石大战','icon_66_zsdz',1,340,9999,2,'[6]','[]','[]','[{{21,0},{21,25}}]','[{8,9999}]','[{0,0}]','参与钻石大战，获得海量绑钻奖励\r\n参与的场次越多，累计奖励越高哦\r\n除了参加比赛，还可以进行竞猜哦','[{340,[{2,36020001,1}]}]',0,0,'[]',0,0,'[3]'),(137,0,2,'钻石大战','icon_66_zsdz',1,340,9999,2,'[6]','[]','[]','[{{21,0},{21,25}}]','[]','[{8,9999}]','参与钻石大战，获得海量绑钻奖励\r\n参与的场次越多，累计奖励越高哦\r\n除了参加比赛，还可以进行竞猜哦','[{340,[{2,36020001,1}]}]',0,0,'[]',0,0,'[3]'),(152,1,1,'每日强化','15201',1,65,300,1,'[]','[]','[]','[]','[]','[]','每日装备强化进阶，助你轻松提升战力','[]',0,0,'[]',100,1,'[2]'),(174,0,1,'智慧达人','icon_rightTop_28',1,110,9999,2,'[2,4,6]','[]','[]','[{{12,0},{12,30}}]','[{1,9999}]','[{0,0}]','答题时间内走到对应区域选择答案，第一名还能获得专属称号','[{110,[{0,36060001,1}]}]',0,0,'[]',0,0,'[1]'),(174,0,2,'智慧达人','icon_rightTop_28',1,110,9999,2,'[2,4,6]','[]','[]','[{{12,0},{12,30}}]','[]','[{1,9999}]','答题时间内走到对应区域选择答案，第一名还能获得专属称号','[{110,[{0,36060001,1}]}]',0,0,'[]',0,0,'[1]'),(221,1,1,'每日点赞','paihangbang',1,120,99999,1,'[]','[]','[]','[]','[]','[]','每日在排行榜中找寻崇拜的对象并点赞，还可以获得奖励哦','[{120,[{0,38100001,1}]}]',0,0,'[]',101,100,'[4]'),(280,0,1,'竞技场','icon_74_zjc',1,115,9999,1,'[]','[]','[]','[]','[]','[]','单人挑战，与其他玩家对战提升排名，排名越高奖励越丰厚呦','[{115,[{0,36160001,1},{0,36020001,1}]}]',0,0,'[]',95,0,'[1]'),(281,0,1,'巅峰竞技','28100',1,140,9999,2,'[]','[]','[]','[{{21,0},{21,20}}]','[{1,3}]','[{0,0}]','1V1匹配对战，还可与其他服玩家同台竞技，段位越高奖励越丰厚哦','[{140,[{0,24010001,1},{0,24010002,1},{0,24010003,1},{0,15020201,1},{0,15020202,1}]}]',0,0,'[]',0,0,'[2]'),(281,0,2,'巅峰竞技','28100',1,140,9999,2,'[1,3,5,6,7]','[]','[]','[{{21,0},{21,20}}]','[{4,7}]','[{0,0}]','1V1匹配对战，还可与其他服玩家同台竞技，段位越高奖励越丰厚哦','[{140,[{0,24010001,1},{0,24010002,1},{0,24010003,1},{0,15020201,1},{0,15020202,1}]}]',0,0,'[]',0,0,'[2]'),(281,0,3,'巅峰竞技','28100',1,140,9999,2,'[1,3,5,7]','[]','[]','[{{21,0},{21,20}}]','[{8,14}]','[{0,0}]','1V1匹配对战，还可与其他服玩家同台竞技，段位越高奖励越丰厚哦','[{140,[{0,24010001,1},{0,24010002,1},{0,24010003,1},{0,15020201,1},{0,15020202,1}]}]',0,0,'[]',0,0,'[2]'),(281,0,4,'巅峰竞技','28100',1,140,9999,2,'[1,5]','[]','[]','[{{21,0},{21,20}}]','[{15,9999}]','[{0,0}]','1V1匹配对战，还可与其他服玩家同台竞技，段位越高奖励越丰厚哦','[{140,[{0,24010001,1},{0,24010002,1},{0,24010003,1},{0,15020201,1},{0,15020202,1}]}]',0,0,'[]',0,0,'[2]'),(281,0,5,'巅峰竞技','28100',1,140,9999,2,'[]','[]','[]','[{{21,0},{21,20}}]','[]','[{1,3}]','1V1匹配对战，还可与其他服玩家同台竞技，段位越高奖励越丰厚哦','[{140,[{0,24010001,1},{0,24010002,1},{0,24010003,1},{0,15020201,1},{0,15020202,1}]}]',0,0,'[]',0,0,'[2]'),(281,0,6,'巅峰竞技','28100',1,140,9999,2,'[1,3,5,6,7]','[]','[]','[{{21,0},{21,20}}]','[]','[{4,7}]','1V1匹配对战，还可与其他服玩家同台竞技，段位越高奖励越丰厚哦','[{140,[{0,24010001,1},{0,24010002,1},{0,24010003,1},{0,15020201,1},{0,15020202,1}]}]',0,0,'[]',0,0,'[2]'),(281,0,7,'巅峰竞技','28100',1,140,9999,2,'[1,3,5,7]','[]','[]','[{{21,0},{21,20}}]','[]','[{8,14}]','1V1匹配对战，还可与其他服玩家同台竞技，段位越高奖励越丰厚哦','[{140,[{0,24010001,1},{0,24010002,1},{0,24010003,1},{0,15020201,1},{0,15020202,1}]}]',0,0,'[]',0,0,'[2]'),(281,0,8,'巅峰竞技','28100',1,140,9999,2,'[1,5]','[]','[]','[{{21,0},{21,20}}]','[]','[{15,9999}]','1V1匹配对战，还可与其他服玩家同台竞技，段位越高奖励越丰厚哦','[{140,[{0,24010001,1},{0,24010002,1},{0,24010003,1},{0,15020201,1},{0,15020202,1}]}]',0,0,'[]',0,0,'[2]'),(300,6,1,'公会任务','30006',1,150,9999,1,'[]','[]','[]','[]','[]','[]','完成公会任务，获取大量公会贡献，金币和经验奖励','[{150,[{0,36060001,1},{0,36050001,1}]}]',0,0,'[]',98,2,'[1,3]'),(300,7,1,'日常任务','30007',1,55,9999,1,'[]','[]','[]','[]','[]','[]','完成日常任务，获取海量的经验和金币奖励','[{55,[{0,36060001,1},{3,0,1}]}]',0,0,'[]',99,1,'[1,3]'),(402,3,1,'公会守卫','40203',3,150,9999,2,'[]','[]','[]','[{{20,30},{20,50}}]','[{2,2},{4,4},{6,6}]','[{0,0}]','参与守卫公会，有机会获得海量经验奖励和道具奖励','[{150,[{0,36060001,1},{0,11020001,1},{0,11020002,1},{0,11020003,1},{0,18020001,1},{0,18020002,1},{0,18020003,1}]}]',0,0,'[]',0,3,'[1]'),(402,3,2,'公会守卫','40203',3,150,9999,2,'[2,4,6]','[]','[]','[{{20,30},{20,50}}]','[{8,9999}]','[{0,0}]','参与守卫公会，有机会获得海量经验奖励和道具奖励','[{150,[{0,36060001,1},{0,11020001,1},{0,11020002,1},{0,11020003,1},{0,18020001,1},{0,18020002,1},{0,18020003,1}]}]',0,0,'[]',0,3,'[1]'),(402,3,3,'公会守卫','40203',3,150,9999,2,'[]','[]','[]','[{{20,30},{20,50}}]','[]','[{2,2},{4,4},{6,6}]','参与守卫公会，有机会获得海量经验奖励和道具奖励','[{150,[{0,36060001,1},{0,11020001,1},{0,11020002,1},{0,11020003,1},{0,18020001,1},{0,18020002,1},{0,18020003,1}]}]',0,0,'[]',0,3,'[1]'),(402,3,4,'公会守卫','40203',3,150,9999,2,'[2,4,6]','[]','[]','[{{20,30},{20,50}}]','[]','[{8,9999}]','参与守卫公会，有机会获得海量经验奖励和道具奖励','[{150,[{0,36060001,1},{0,11020001,1},{0,11020002,1},{0,11020003,1},{0,18020001,1},{0,18020002,1},{0,18020003,1}]}]',0,0,'[]',0,3,'[1]'),(402,4,1,'公会争霸','40204',3,150,9999,2,'[]','[]','[]','[{{20,30},{20,50}}]','[{3,3},{7,7}]','[{0,0}]','公会争霸，决出最强公会，胜利的公会成员将获得丰厚奖励','[{150,[{0,32000011,1},{0,32000012,1},{0,32000013,1},{0,32000036,1}]}]',0,0,'[]',0,4,'[1,2,3,4]'),(402,4,2,'公会争霸','40204',3,150,9999,2,'[3,7]','[]','[]','[{{20,30},{20,50}}]','[{8,13}]','[{0,0}]','公会争霸，决出最强公会，胜利的公会成员将获得丰厚奖励','[{150,[{0,32000011,1},{0,32000012,1},{0,32000013,1},{0,32000036,1}]}]',0,0,'[]',0,4,'[1,2,3,4]'),(402,4,3,'公会争霸','40204',3,150,9999,2,'[7]','[]','[]','[{{20,30},{20,50}}]','[{14,9999}]','[{0,0}]','公会争霸，决出最强公会，胜利的公会成员将获得丰厚奖励','[{150,[{0,32000011,1},{0,32000012,1},{0,32000013,1},{0,32000036,1}]}]',0,0,'[]',0,4,'[1,2,3,4]'),(402,4,4,'公会争霸','40204',3,150,9999,2,'[]','[]','[]','[{{20,30},{20,50}}]','[]','[{3,3},{7,7}]','公会争霸，决出最强公会，胜利的公会成员将获得丰厚奖励','[{150,[{0,32000011,1},{0,32000012,1},{0,32000013,1},{0,32000036,1}]}]',0,0,'[]',0,4,'[1,2,3,4]'),(402,4,5,'公会争霸','40204',3,150,9999,2,'[3,7]','[]','[]','[{{20,30},{20,50}}]','[]','[{8,13}]','公会争霸，决出最强公会，胜利的公会成员将获得丰厚奖励','[{150,[{0,32000011,1},{0,32000012,1},{0,32000013,1},{0,32000036,1}]}]',0,0,'[]',0,4,'[1,2,3,4]'),(402,4,6,'公会争霸','40204',3,150,9999,2,'[7]','[]','[]','[{{20,30},{20,50}}]','[]','[{14,9999}]','公会争霸，决出最强公会，胜利的公会成员将获得丰厚奖励','[{150,[{0,32000011,1},{0,32000012,1},{0,32000013,1},{0,32000036,1}]}]',0,0,'[]',0,4,'[1,2,3,4]'),(403,0,1,'公会篝火','icon_47_ghgh',3,150,9999,2,'[]','[]','[]','[{{20,30},{20,50}}]','[{1,1},{5,5}]','[{0,0}]','参与公会篝火，可以获得大量经验奖励；期间还有答题活动可获得额外奖励哦！','[{150,[{0,36060001,1},{0,36020001,1}]}]',0,0,'[]',0,0,'[1]'),(403,0,2,'公会篝火','icon_47_ghgh',3,150,9999,2,'[1,5]','[]','[]','[{{20,30},{20,50}}]','[{8,9999}]','[{0,0}]','参与公会篝火，可以获得大量经验奖励；期间还有答题活动可获得额外奖励哦！','[{150,[{0,36060001,1},{0,36020001,1}]}]',0,0,'[]',0,0,'[1]'),(403,0,3,'公会篝火','icon_47_ghgh',3,150,9999,2,'[]','[]','[]','[{{20,30},{20,50}}]','[]','[{1,1},{5,5}]','参与公会篝火，可以获得大量经验奖励；期间还有答题活动可获得额外奖励哦！','[{150,[{0,36060001,1},{0,36020001,1}]}]',0,0,'[]',0,0,'[1]'),(403,0,4,'公会篝火','icon_47_ghgh',3,150,9999,2,'[1,5]','[]','[]','[{{20,30},{20,50}}]','[]','[{8,9999}]','参与公会篝火，可以获得大量经验奖励；期间还有答题活动可获得额外奖励哦！','[{150,[{0,36060001,1},{0,36020001,1}]}]',0,0,'[]',0,0,'[1]'),(418,0,1,'魅力海滩','icon_rightTop_19',1,110,9999,2,'[1,3,5,7]','[]','[]','[{{12,0},{12,30}}]','[{1,9999}]','[{0,0}]','海量经验大放送，贵族更有额外加成，魅力值第一名还能获得专属称号','[{110,[{0,36060001,1},{0,36070001,1}]}]',0,0,'[]',0,0,'[1]'),(418,0,2,'魅力海滩','icon_rightTop_19',1,110,9999,2,'[1,3,5,7]','[]','[]','[{{12,0},{12,30}}]','[]','[{1,9999}]','海量经验大放送，贵族更有额外加成，魅力值第一名还能获得专属称号','[{110,[{0,36060001,1},{0,36070001,1}]}]',0,0,'[]',0,0,'[1]'),(429,0,1,'捕蝶','42901',1,115,9999,2,'[2,4]','[]','[]','[{{15,30},{15,50}},{{21,30},{21,50}}]','[{1,9999}]','[{0,0}]','抓蝴蝶，赚积分，不仅可以获得积分奖励，前十名还能获得额外奖励哦','[{115,[{0,36060001,1},{0,18020001,1},{0,18020002,1},{0,18020003,1}]}]',0,0,'[]',0,0,'[4]'),(429,0,2,'捕蝶','42901',1,115,9999,2,'[2,4]','[]','[]','[{{15,30},{15,50}},{{21,30},{21,50}}]','[]','[{1,9999}]','抓蝴蝶，赚积分，不仅可以获得积分奖励，前十名还能获得额外奖励哦','[{115,[{0,36060001,1},{0,18020001,1},{0,18020002,1},{0,18020003,1}]}]',0,0,'[]',0,0,'[4]'),(436,0,1,'星灵争霸','icon_97_xlzb',1,420,9999,2,'[3]','[]','[]','[{{21,0},{21,20}}]','[{15,9999}]','[{0,0}]','参与星灵争霸，体验星灵之间的战斗；参与的场次越多，获得的奖励越高！','[{300,[{0,18020001,1}]}]',0,0,'[]',0,0,'[4]'),(436,0,2,'星灵争霸','icon_97_xlzb',1,420,9999,2,'[3]','[]','[]','[{{21,0},{21,20}}]','[]','[{15,9999}]','参与星灵争霸，体验星灵之间的战斗；参与的场次越多，获得的奖励越高！','[{300,[{0,18020001,1}]}]',0,0,'[]',0,0,'[4]'),(460,4,1,'混乱魔域','icon_112_hlmy',1,240,9999,1,'[]','[]','[]','[]','[]','[]','前往混乱魔域击杀首领，将其击败可以获得大量奖励哦','[{240,[{0,32020112,1},{0,32020113,1},{0,32020114,1},{0,32020122,1},{0,32020123,1},{0,32020124,1}]}]',0,0,'[]',74,8,'[2]'),(460,5,1,'首领遗迹','icon_59_yzjt',1,95,9999,1,'[]','[]','[]','[]','[]','[]','前往首领遗迹击杀首领，将其击败可以获得大量奖励，每日可以击杀3次哦','[{95,[{0,36060001,1},{0,24030001,1},{0,20010021,1},{0,20010041,1},{0,20010011,1}]}]',0,0,'[]',89,1,'[2]'),(461,0,1,'时空乱流','icon_82_kfsl',1,335,9999,1,'[]','[]','[]','[]','[{12,9999}]','[]','前往跨服场景击杀首领，将其击败可以获得大量奖励，每日可以击杀3次哦','[{440,[{0,21010104,1},{0,21010202,1},{0,1002040842,1},{0,1010020842,1},{0,1010010842,1},{0,1001040842,1},{0,1004010832,1},{0,1010010832,1},{0,1001020832,1},{0,1007010832,1}]}]',0,0,'[]',73,0,'[2]'),(500,0,1,'飞艇护送','icon_rightTop_33',1,130,9999,1,'[]','[]','[]','[]','[]','[]','护送飞艇即可获得海量经验和金币，最高品质更有绑钻奖励哦','[{130,[{0,36060001,1},{3,0,1}]}]',0,0,'[]',85,0,'[1,3]'),(500,0,2,'飞艇护送','icon_rightTop_33',1,130,9999,1,'[]','[]','[]','[]','[]','[{1,9999}]','护送飞艇即可获得海量经验和金币，最高品质更有绑钻奖励哦','[{130,[{0,36060001,1},{3,0,1}]}]',0,0,'[]',85,0,'[1,3]'),(500,1,1,'双倍护送','icon_rightTop_33',1,130,9999,2,'[1,3,5,6,7]','[]','[]','[{{15,30},{16,0}},{{21,30},{22,0}}]','[{1,9999}]','[]','活动期间内，飞艇护送可获得双倍奖励','[{130,[{0,36060001,1},{3,0,1}]}]',0,0,'[]',0,1,'[1,3]'),(500,1,2,'双倍护送','icon_rightTop_33',1,130,9999,2,'[1,3,5,6,7]','[]','[]','[{{15,30},{16,0}},{{21,30},{22,0}}]','[]','[{1,9999}]','活动期间内，飞艇护送可获得双倍奖励','[{130,[{0,36060001,1},{3,0,1}]}]',0,0,'[]',0,1,'[1,3]'),(604,0,1,'三英会战','icon_214_syhz',1,140,9999,2,'[2,4,6]','[]','[]','[{{20,0},{20,20}}]','[{1,9999}]','[{0,0}]','三英会战是团队PVP占领式玩法，在该玩法中有多种途径可以获得个人积分，积分可以换取不同的奖励。','[{140,[{0,24010003,1},{0,24020001,1},{0,17020001,1},{0,24010002,1},{0,24010001,1},{0,38260001,1},{0,17010001,1}]}]',0,0,'[]',0,0,'[1]'),(604,0,2,'三英会战','icon_214_syhz',1,140,9999,2,'[2,4,6]','[]','[]','[{{20,0},{20,20}}]','[]','[{1,9999}]','三英会战是团队PVP占领式玩法，在该玩法中有多种途径可以获得个人积分，积分可以换取不同的奖励。','[{140,[{0,24010003,1},{0,24020001,1},{0,17020001,1},{0,24010002,1},{0,24010001,1},{0,38260001,1},{0,17010001,1}]}]',0,0,'[]',0,0,'[1]'),(606,0,1,'丛林突围','icon_64_cltw',1,140,9999,2,'[1,3,5,7]','[]','[]','[{{20,0},{20,20}}]','[{1,9999}]','[{0,0}]','丛林突围是个人PVP玩法，击杀其他玩家获得积分；积分可以换取不同的奖励','[{140,[{0,36060001,1},{0,24010001,1},{0,24010002,1},{0,24010003,1}]}]',0,0,'[]',0,0,'[1]'),(606,0,2,'丛林突围','icon_64_cltw',1,140,9999,2,'[1,3,5,7]','[]','[]','[{{20,0},{20,20}}]','[]','[{1,9999}]','丛林突围是个人PVP玩法，击杀其他玩家获得积分；积分可以换取不同的奖励','[{140,[{0,36060001,1},{0,24010001,1},{0,24010002,1},{0,24010003,1}]}]',0,0,'[]',0,0,'[1]'),(607,0,1,'无尽海域','icon_71_wjhy',1,350,9999,2,'[3]','[]','[]','[{{20,30},{20,50}}]','[{14,9999}]','[]','在无尽海域和其他公会进行战斗吧，完成活动可以获得大量奖励','[{60,[{0,36060001,1},{0,36090001,1}]}]',0,0,'[]',0,0,'[1]'),(607,0,2,'无尽海域','icon_71_wjhy',1,350,9999,2,'[3]','[]','[]','[{{20,30},{20,50}}]','[]','[{14,9999}]','在无尽海域和其他公会进行战斗吧，完成活动可以获得大量奖励','[{60,[{0,36060001,1},{0,36090001,1}]}]',0,0,'[]',0,0,'[1]'),(609,1,1,'限时boss','icon_115_xsbb',2,440,9999,2,'[2,4]','[]','[]','[{{22,0},{22,20}}]','[{10,9999}]','[{0,0}]','跨服首领来袭，击杀跨服首领可以获得大量服务器积分和奖励','[{440,[{0,36060001,1},{0,16040130,1}]}]',0,0,'[]',0,0,'[4]'),(609,1,2,'限时boss','icon_115_xsbb',2,440,9999,2,'[2,4]','[]','[]','[{{22,0},{22,20}}]','[]','[{10,9999}]','跨服首领来袭，击杀跨服首领可以获得大量服务器积分和奖励','[{440,[{0,36060001,1},{0,16040130,1}]}]',0,0,'[]',0,0,'[4]'),(610,4,1,'经验宝库','61004',2,75,9999,1,'[]','[]','[]','[]','[]','[]','参与经验宝库，获得海量经验奖励，伤害越高经验越多','[{70,[{0,36060001,1}]}]',0,0,'[]',99,31,'[1]'),(610,5,1,'装备副本','61005',2,105,9999,1,'[]','[]','[]','[]','[]','[]','限定时间内击败怪物能提高首领难度，难度越高奖励越丰厚哦','[{100,[{0,1001010441,1},{0,1004010441,1},{0,1001010432,1},{0,1004010432,1}]}]',0,0,'[]',90,32,'[2,4]'),(610,18,1,'星灵副本','icon_92_xlfb',1,85,9999,1,'[]','[]','[]','[]','[]','[]','抵御怪物的进攻，获得大量星灵升级道具','[{85,[{0,18020001,1},{0,18020002,1},{0,18020003,1}]}]',0,0,'[]',88,35,'[4]'),(610,20,1,'魂珠副本','icon_142_hzt',1,70,9999,1,'[]','[]','[]','[]','[]','[{0,0}]','参与魂珠副本，可获得大量魂珠道具哦','[{70,[{0,5201013,1},{0,5201023,1},{0,5201033,1},{0,5201043,1},{0,5201053,1}]}]',0,0,'[]',76,40,'[4]'),(621,0,1,'跨服1VN','icon_67_kf1vn',1,360,9999,2,'[7]','[]','[]','[{{21,0},{21,20}}]','[{15,9999}]','[{0,0}]','参与跨服1VN，获得海量多重奖励；参与守擂赛，还会有额外奖励哦；除了参加比赛，还可以进行竞拍呢','[{360,[{0,36060001,1},{0,14020208,1},{0,14020209,1},{0,14010108,1},{0,14010109,1},{0,14010308,1},{0,14010309,1},{0,14020408,1},{0,14020409,1}]}]',0,0,'[]',0,0,'[4]'),(621,0,2,'跨服1VN','icon_67_kf1vn',1,360,9999,2,'[7]','[]','[]','[{{21,0},{21,20}}]','[]','[{15,9999}]','参与跨服1VN，获得海量多重奖励；参与守擂赛，还会有额外奖励哦；除了参加比赛，还可以进行竞拍呢','[{360,[{0,36060001,1},{0,14020208,1},{0,14020209,1},{0,14010108,1},{0,14010109,1},{0,14010308,1},{0,14010309,1},{0,14020408,1},{0,14020409,1}]}]',0,0,'[]',0,0,'[4]'),(650,1,1,'跨服3V3','icon_65_kf3v3',2,270,9999,2,'[2,4]','[]','[]','[{{21,0},{21,20}}]','[{4,9999}]','[{0,0}]','寻找你的最强队友一起站上跨服3V3巅峰吧!丰厚的奖励在等你哦!','[{270,[{255,36160002,1}]}]',0,0,'[]',0,1,'[4]'),(650,1,2,'跨服3V3','icon_65_kf3v3',2,270,9999,2,'[2,4]','[]','[]','[{{21,0},{21,20}}]','[]','[{4,9999}]','寻找你的最强队友一起站上跨服3V3巅峰吧!丰厚的奖励在等你哦!','[{270,[{255,36160002,1}]}]',0,0,'[]',0,1,'[4]');
/*!40000 ALTER TABLE `base_ac` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_ac_cuscom`
--

DROP TABLE IF EXISTS `base_ac_cuscom`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_ac_cuscom` (
  `module_sub` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '子功能ID',
  `ac_sub` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类',
  `ac_name` varchar(1024) NOT NULL COMMENT '活动名称@lang@',
  `week` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '每日每周',
  `month` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '每月第几天',
  `time` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '固定日期',
  `time_region` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '具体时间段',
  `start_timestamp` varchar(1024) NOT NULL DEFAULT '0' COMMENT '开始时间',
  `end_timestamp` varchar(1024) NOT NULL DEFAULT '0' COMMENT '结束时间',
  `open_day` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '开服第几天',
  `merge_day` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '合服第几天',
  `about` varchar(1024) NOT NULL COMMENT '活动描述@lang@',
  `other` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '其他条件',
  PRIMARY KEY (`module_sub`,`ac_sub`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='定制活动（官服）';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_ac_cuscom`
--

LOCK TABLES `base_ac_cuscom` WRITE;
/*!40000 ALTER TABLE `base_ac_cuscom` DISABLE KEYS */;
INSERT INTO `base_ac_cuscom` VALUES (1,1,'公会排行','[]','[]','[]','[]','','','[{1,11}]','[]','根据公会排行发放奖励，必需在结算两天之前加入公会才有奖励','[{timer_trigger,23,59},{look_lv,11}]'),(2,1,'战力排行','[]','[]','[]','[]','','','[{1,15}]','[]','活动结算时，每个职业排行前三的玩家可获得奖励','[{timer_trigger,23,59},{look_lv,10}]'),(3,1,'等级冲刺','[]','[]','[]','[]','','','[{1,12}]','[]','活动时间内，前100名达到目标42级的玩家可获得奖励，越早达到，奖励越丰厚','[{timer_trigger,23,59},{look_lv,10},{lv_trigger, 42}]'),(4,1,'随机奖励活动','[]','[]','[]','[]','2017-07-27 02:13:52','2017-07-27 02:13:54','[]','[]','竞技场奖励领取','[]'),(4,2,'随机奖励活动','[]','[]','[]','[]','2017-05-27 14:17:18','2017-05-31 14:17:22','[]','[]','活跃度领取，30活跃值奖励领取','[]'),(4,3,'随机奖励活动','[]','[]','[]','[]','2017-05-27 14:17:55','2017-05-31 14:17:56','[]','[]','商会任务领取奖励','[]'),(5,1,'20人团购','[]','[]','[]','[]','0','0','[{1,7}]','[]','每日本服首充人数达到一定数量，可以获得奖励哦','[{timer_trigger,23,59}]'),(5,2,'50人团购','[]','[]','[]','[]','0','0','[{1,7}]','[]','每日本服首充人数达到一定数量，可以获得奖励哦','[{timer_trigger,23,59}]'),(5,3,'100人团购','[]','[]','[]','[]','0','0','[{1,7}]','[]','每日本服首充人数达到一定数量，可以获得奖励哦','[{timer_trigger,23,59}]'),(5,4,'200人团购','[]','[]','[]','[]','0','0','[{1,7}]','[]','每日本服首充人数达到一定数量，可以获得奖励哦','[{timer_trigger,23,59}]'),(5,5,'300人团购','[]','[]','[]','[]','0','0','[{1,3}]','[]','每日本服首充人数达到一定数量，可以获得奖励哦','[{timer_trigger,23,59}]'),(6,1,'累充大奖','[]','[]','[]','[]','0','0','[{1,7}]','[]','活动期间内，累计充值达到一定金额，可以获得丰厚奖励哦','[{timer_trigger,23,59}]'),(7,1,'招财猫','[]','[]','[]','[]','0','0','[{1,7}]','[]','让您的钻石迅速翻倍！','[{timer_trigger,23,59}]'),(100,1,'带标题公告','[]','[]','[]','[]','2017-07-02 00:06:12','2017-07-02 00:06:13','[]','[]','111每日充值累计达到对应档位，可领取对应奖励!累积充值每日清零，请及时领取充值奖励哦！\r\n又双叒叕是测试文字。又双叒叕是测试文字。又双叒叕是测试文字。又双叒叕是测试文字。又双叒叕是<a@goods@110104></a>测试文字。\r\n<image><color@2>标题</color></image>\r\n<a@goods@200126></a>测试文字测试文字测试文字测试文字测试文字测试文字测试文字<a@goods@200121></a>测试文字\r\n<button@参加@157></button>\r\n<image><color@2><i>标题</i></color>上线送好礼\r\n<button@前往@157></button>','[]'),(101,1,'封测公告','[]','[]','[]','[]','2017-07-27 02:14:13','2017-07-27 02:14:15','[]','[]','本次测试为删档测试，测试期间不放开充值功能\r\n封测期间，福利界面的<color@3>每日礼包</color>、<color@3>钻石大礼</color>，及所有宝箱','[]');
/*!40000 ALTER TABLE `base_ac_cuscom` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_ac_kv`
--

DROP TABLE IF EXISTS `base_ac_kv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_ac_kv` (
  `key` int(11) NOT NULL DEFAULT '0' COMMENT 'key',
  `value` varchar(1024) NOT NULL DEFAULT '0' COMMENT 'value',
  `about` varchar(1024) NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='活动日历KV';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_ac_kv`
--

LOCK TABLES `base_ac_kv` WRITE;
/*!40000 ALTER TABLE `base_ac_kv` DISABLE KEYS */;
INSERT INTO `base_ac_kv` VALUES (1,'[{241301,1}]','物品241301增加1点活跃度');
/*!40000 ALTER TABLE `base_ac_kv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_acc_check_in`
--

DROP TABLE IF EXISTS `base_acc_check_in`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_acc_check_in` (
  `month` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '月份',
  `acc_days` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '累计天数',
  `acc_reward` varchar(512) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `state` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '领取状态',
  PRIMARY KEY (`month`,`acc_days`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='累计签到配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_acc_check_in`
--

LOCK TABLES `base_acc_check_in` WRITE;
/*!40000 ALTER TABLE `base_acc_check_in` DISABLE KEYS */;
/*!40000 ALTER TABLE `base_acc_check_in` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_achievement`
--

DROP TABLE IF EXISTS `base_achievement`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_achievement` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '成就id',
  `category` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '成就大类',
  `sub_category` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '成就小类',
  `type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '成就类型',
  `star` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '成就品质',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '成就名字@lang@',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '成就描述@lang@',
  `next_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '下一个成就id 0:表示完成当前子类型的所有成就',
  `is_hide` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否是隐藏成就 0:不是 1:是',
  `is_inherit` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否继承前一成就的进度 0:不继承 1:继承',
  `show_progress` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否显示成就进度 0:不显示 1:显示',
  `condition` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '达成条件',
  `reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `designation` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '称号奖励',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='成就配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_achievement`
--

LOCK TABLES `base_achievement` WRITE;
/*!40000 ALTER TABLE `base_achievement` DISABLE KEYS */;
INSERT INTO `base_achievement` VALUES (1010101,1,101,10101,1,'升级达人','等级达到100级',1010102,0,1,1,'[{role_lv,100}]','[{2,36020001,10}]',0),(1010102,1,101,10101,2,'升级达人','等级达到200级',1010103,1,1,1,'[{role_lv,200}]','[{2,36020001,15}]',0),(1010103,1,101,10101,3,'升级达人','等级达到300级',1010104,1,1,1,'[{role_lv,300}]','[{2,36020001,20}]',0),(1010104,1,101,10101,4,'升级达人','等级达传奇1级',0,1,1,1,'[{role_lv,371}]','[{2,36020001,30}]',0),(1010201,1,101,10102,1,'巅峰境界','等级达传奇100级',1010202,0,1,1,'[{role_lv,470}]','[{2,36020001,50}]',0),(1010202,1,101,10102,2,'巅峰境界','等级达传奇200级',1010203,1,1,1,'[{role_lv,570}]','[{2,36020001,50}]',0),(1010203,1,101,10102,3,'巅峰境界','等级达传奇300级',1010204,1,1,1,'[{role_lv,670}]','[{2,36020001,50}]',0),(1010204,1,101,10102,4,'巅峰境界','等级达传奇350级',1010205,1,1,1,'[{role_lv,720}]','[{2,36020001,50}]',0),(1010205,1,101,10102,5,'巅峰境界','等级达传奇390级',1010206,1,1,1,'[{role_lv,760}]','[{2,36020001,50}]',0),(1010206,1,101,10102,5,'巅峰境界','等级达传奇430级',0,1,1,1,'[{role_lv,800}]','[{2,36020001,50}]',0),(1010301,1,101,10103,1,'角色转职','完成1次转职',1010302,0,1,1,'[{role_transfer,1}]','[{2,36020001,10}]',0),(1010302,1,101,10103,2,'角色转职','完成2次转职',1010303,1,1,1,'[{role_transfer,2}]','[{2,36020001,20}]',0),(1010303,1,101,10103,3,'角色转职','完成3次转职',1010304,1,1,1,'[{role_transfer,3}]','[{2,36020001,30}]',0),(1010304,1,101,10103,4,'角色转职','完成4次转职',1010305,1,1,1,'[{role_transfer,4}]','[{2,36020001,40}]',0),(1010305,1,101,10103,5,'角色转职','完成5次转职',0,1,1,1,'[{role_transfer,5}]','[{2,36020001,50}]',0),(1020101,1,102,10201,1,'宝具升级','宝具达到20级',1020102,0,1,1,'[{talisman_lv,20}]','[{0,24010001,5}]',0),(1020102,1,102,10201,2,'宝具升级','宝具达到50级',1020103,1,1,1,'[{talisman_lv,50}]','[{0,24010001,10}]',0),(1020103,1,102,10201,3,'宝具升级','宝具达到100级',1020104,1,1,1,'[{talisman_lv,100}]','[{0,24010002,5}]',0),(1020104,1,102,10201,4,'宝具升级','宝具达到160级',1020105,1,1,1,'[{talisman_lv,160}]','[{0,24010002,10}]',0),(1020105,1,102,10201,5,'宝具升级','宝具达到240级',0,1,1,1,'[{talisman_lv,240}]','[{2,36020001,100}]',0),(1020201,1,102,10202,1,'翅膀升级','培育出1代翅膀',1020202,0,1,0,'[{wing_generation,1}]','[{2,36020001,10}]',0),(1020202,1,102,10202,2,'翅膀升级','培育出2代翅膀',1020203,1,1,0,'[{wing_generation,2}]','[{2,36020001,20}]',0),(1020203,1,102,10202,3,'翅膀升级','培育出3代翅膀',1020204,1,1,0,'[{wing_generation,3}]','[{2,36020001,40}]',0),(1020204,1,102,10202,4,'翅膀升级','培育出4代翅膀',1020205,1,1,0,'[{wing_generation,4}]','[{2,36020001,60}]',0),(1020205,1,102,10202,5,'翅膀升级','培育出5代翅膀',1020206,1,1,0,'[{wing_generation,5}]','[{2,36020001,80}]',0),(1020206,1,102,10202,5,'翅膀升级','培育出6代翅膀',0,1,1,0,'[{wing_generation,6}]','[{2,36020001,100}]',0),(1020301,1,102,10203,1,'神格晋升','神格等级达到15级',1020302,0,1,1,'[{deity_lv,15}]','[{0,17010001,50}]',0),(1020302,1,102,10203,2,'神格晋升','神格等级达到30级',1020303,1,1,1,'[{deity_lv,30}]','[{0,17010001,80}]',0),(1020303,1,102,10203,3,'神格晋升','神格等级达到45级',1020304,1,1,1,'[{deity_lv,45}]','[{0,17010002,40}]',0),(1020304,1,102,10203,3,'神格晋升','神格等级达到60级',1020305,1,1,1,'[{deity_lv,60}]','[{0,17010002,60}]',0),(1020305,1,102,10203,4,'神格晋升','神格等级达到70级',1020306,1,1,1,'[{deity_lv,70}]','[{0,17010002,80}]',0),(1020306,1,102,10203,5,'神格晋升','神格等级达到80级',1020307,1,1,1,'[{deity_lv,80}]','[{0,17010003,50}]',0),(1020307,1,102,10203,5,'神格晋升','神格等级达到90级',0,1,1,1,'[{deity_lv,90}]','[{2,36020001,100}]',0),(2010101,2,201,20101,1,'星灵收集','拥有1只星灵',2010102,0,1,1,'[{star_soul_num,1}]','[{2,36020001,10}]',0),(2010102,2,201,20101,2,'星灵收集','拥有2只星灵',2010103,1,1,1,'[{star_soul_num,2}]','[{2,36020001,15}]',0),(2010103,2,201,20101,2,'星灵收集','拥有3只星灵',2010104,1,1,1,'[{star_soul_num,3}]','[{2,36020001,20}]',0),(2010104,2,201,20101,3,'星灵收集','拥有4只星灵',2010105,1,1,1,'[{star_soul_num,4}]','[{2,36020001,20}]',0),(2010105,2,201,20101,3,'星灵收集','拥有5只星灵',2010106,1,1,1,'[{star_soul_num,5}]','[{2,36020001,30}]',0),(2010106,2,201,20101,4,'星灵收集','拥有6只星灵',2010107,1,1,1,'[{star_soul_num,6}]','[{2,36020001,30}]',0),(2010107,2,201,20101,4,'星灵收集','拥有7只星灵',2010108,1,1,1,'[{star_soul_num,7}]','[{2,36020001,40}]',0),(2010108,2,201,20101,5,'星灵收集','拥有8只星灵',2010109,1,1,1,'[{star_soul_num,8}]','[{2,36020001,40}]',0),(2010109,2,201,20101,5,'星灵收集','拥有9只星灵',0,1,1,1,'[{star_soul_num,9}]','[{2,36020001,50}]',0),(2010201,2,201,20102,1,'星灵进阶','拥有1只3阶星灵',2010202,0,0,1,'[{star_soul_num,1},{star_soul_class,3}]','[{0,18020001,5}]',0),(2010202,2,201,20102,2,'星灵进阶','拥有1只8阶星灵',2010203,1,1,1,'[{star_soul_num,1},{star_soul_class,8}]','[{0,18020001,10}]',0),(2010203,2,201,20102,3,'星灵进阶','拥有1只15阶星灵',2010204,1,1,1,'[{star_soul_num,1},{star_soul_class,15}]','[{0,18020002,5}]',0),(2010204,2,201,20102,4,'星灵进阶','拥有1只25阶星灵',0,1,1,1,'[{star_soul_num,1},{star_soul_class,25}]','[{2,36020001,100}]',0),(2010301,2,201,20103,1,'星灵进阶','拥有2只3阶星灵',2010302,0,0,1,'[{star_soul_num,2},{star_soul_class,3}]','[{0,18020001,5}]',0),(2010302,2,201,20103,2,'星灵进阶','拥有2只8阶星灵',2010303,1,1,1,'[{star_soul_num,2},{star_soul_class,8}]','[{0,18020001,10}]',0),(2010303,2,201,20103,3,'星灵进阶','拥有2只15阶星灵',2010304,1,1,1,'[{star_soul_num,2},{star_soul_class,15}]','[{0,18020002,5}]',0),(2010304,2,201,20103,4,'星灵进阶','拥有2只25阶星灵',0,1,1,1,'[{star_soul_num,2},{star_soul_class,25}]','[{2,36020001,100}]',0),(2010401,2,201,20104,1,'星灵进阶','拥有4只3阶星灵',2010402,0,0,1,'[{star_soul_num,4},{star_soul_class,3}]','[{0,18020001,10}]',0),(2010402,2,201,20104,2,'星灵进阶','拥有4只8阶星灵',2010403,1,1,1,'[{star_soul_num,4},{star_soul_class,8}]','[{0,18020001,20}]',0),(2010403,2,201,20104,3,'星灵进阶','拥有4只15阶星灵',2010404,1,1,1,'[{star_soul_num,4},{star_soul_class,15}]','[{0,18020002,10}]',0),(2010404,2,201,20104,4,'星灵进阶','拥有4只25阶星灵',0,1,1,1,'[{star_soul_num,4},{star_soul_class,25}]','[{2,36020001,200}]',0),(2010501,2,201,20105,1,'星灵进阶','拥有6只3阶星灵',2010502,0,0,1,'[{star_soul_num,6},{star_soul_class,3}]','[{0,18020001,15}]',0),(2010502,2,201,20105,2,'星灵进阶','拥有6只8阶星灵',2010503,1,1,1,'[{star_soul_num,6},{star_soul_class,8}]','[{0,18020001,25}]',0),(2010503,2,201,20105,3,'星灵进阶','拥有6只15阶星灵',2010504,1,1,1,'[{star_soul_num,6},{star_soul_class,15}]','[{0,18020002,15}]',0),(2010504,2,201,20105,4,'星灵进阶','拥有6只25阶星灵',0,1,1,1,'[{star_soul_num,6},{star_soul_class,25}]','[{2,36020001,200}]',0),(2010601,2,201,20106,1,'星灵星级','拥有1只2星星灵',2010602,0,1,1,'[{star_soul_num,1},{star_soul_lv,2}]','[{2,36020001,50}]',0),(2010602,2,201,20106,2,'星灵星级','拥有2只2星星灵',2010603,1,1,1,'[{star_soul_num,2},{star_soul_lv,2}]','[{2,36020001,50}]',0),(2010603,2,201,20106,3,'星灵星级','拥有4只3星星灵',2010604,1,1,1,'[{star_soul_num,4},{star_soul_lv,3}]','[{2,36020001,100}]',0),(2010604,2,201,20106,4,'星灵星级','拥有6只3星星灵',0,1,1,1,'[{star_soul_num,6},{star_soul_lv,3}]','[{2,36020001,100}]',0),(2020101,2,202,20201,1,'坐骑进阶','坐骑达到3阶',2020102,0,1,1,'[{mount_class,3}]','[{0,16020001,5}]',0),(2020102,2,202,20201,2,'坐骑进阶','坐骑达到5阶',2020103,1,1,1,'[{mount_class,5}]','[{0,16020001,10}]',0),(2020103,2,202,20201,3,'坐骑进阶','坐骑达到7阶',2020104,1,1,1,'[{mount_class,7}]','[{0,16020002,5}]',0),(2020104,2,202,20201,4,'坐骑进阶','坐骑达到9阶',2020105,1,1,1,'[{mount_class,9}]','[{0,16020002,10}]',0),(2020105,2,202,20201,5,'坐骑进阶','坐骑达到11阶',0,1,1,1,'[{mount_class,11}]','[{2,36020001,200}]',0),(2020201,2,202,20202,1,'坐骑幻化','拥有2只幻化坐骑',2020202,0,1,1,'[{mount_num,2}]','[{2,36020001,10}]',2),(2020202,2,202,20202,2,'坐骑幻化','拥有3只幻化坐骑',2020203,1,1,1,'[{mount_num,3}]','[{2,36020001,30}]',3),(2020203,2,202,20202,3,'坐骑幻化','拥有4只幻化坐骑',0,1,1,1,'[{mount_num,4}]','[{2,36020001,50}]',4),(2020301,2,202,20203,1,'坐骑装备','穿戴1件蓝1星以上坐骑装备',2020302,0,1,1,'[{mount_equip_num,1},{mount_equip_color,1},{mount_equip_star,1}]','[{0,16050001,5}]',0),(2020302,2,202,20203,2,'坐骑装备','穿戴1件紫1星以上坐骑装备',2020303,1,1,1,'[{mount_equip_num,1},{mount_equip_color,2},{mount_equip_star,1}]','[{0,16050001,10}]',0),(2020303,2,202,20203,2,'坐骑装备','穿戴2件紫1星以上坐骑装备',2020304,1,1,1,'[{mount_equip_num,2},{mount_equip_color,2},{mount_equip_star,1}]','[{0,16050001,15}]',0),(2020304,2,202,20203,3,'坐骑装备','穿戴3件橙1星以上坐骑装备',2020305,1,1,1,'[{mount_equip_num,3},{mount_equip_color,3},{mount_equip_star,1}]','[{0,16050001,20}]',0),(2020305,2,202,20203,3,'坐骑装备','穿戴3件橙2星以上坐骑装备',2020306,1,1,1,'[{mount_equip_num,3},{mount_equip_color,3},{mount_equip_star,2}]','[{0,16050001,25}]',0),(2020306,2,202,20203,4,'坐骑装备','穿戴3件红1星级以上坐骑装备',2020307,1,1,1,'[{mount_equip_num,3},{mount_equip_color,4},{mount_equip_star,1}]','[{0,16050001,30}]',0),(2020307,2,202,20203,4,'坐骑装备','穿戴4件红2星级以上坐骑装备',2020308,1,1,1,'[{mount_equip_num,4},{mount_equip_color,4},{mount_equip_star,2}]','[{0,16050001,35}]',0),(2020308,2,202,20203,5,'坐骑装备','穿戴5件粉3星以上坐骑装备',2020309,1,1,1,'[{mount_equip_num,5},{mount_equip_color,4},{mount_equip_star,3}]','[{0,16050001,40}]',0),(2020309,2,202,20203,5,'坐骑装备','穿戴6件粉3星以上坐骑装备',0,1,1,1,'[{mount_equip_num,6},{mount_equip_color,5},{mount_equip_star,3}]','[{0,16050001,45}]',0),(2030101,2,203,20301,1,'圣灵收集','拥有3只圣灵',0,1,1,1,'[{holy_spirit_num,3}]','[{2,36020001,20}]',0),(2030201,2,203,20302,1,'暴怒之火','暴怒之火达到20级',2030202,0,1,1,'[{holy_spirit_class,20},{holy_spirit_id,1}]','[{0,15020101,5}]',0),(2030202,2,203,20302,2,'暴怒之火','暴怒之火达到50级',2030203,1,1,1,'[{holy_spirit_class,50},{holy_spirit_id,1}]','[{0,15020101,5}]',0),(2030203,2,203,20302,3,'暴怒之火','暴怒之火达到80级',2030204,1,1,1,'[{holy_spirit_class,80},{holy_spirit_id,1}]','[{0,15020102,5}]',0),(2030204,2,203,20302,4,'暴怒之火','暴怒之火达到100级',2030205,1,1,1,'[{holy_spirit_class,100},{holy_spirit_id,1}]','[{0,15020102,5}]',0),(2030205,2,203,20302,5,'暴怒之火','暴怒之火达到120级',0,1,1,1,'[{holy_spirit_class,120},{holy_spirit_id,1}]','[{2,36020001,200}]',0),(2030301,2,203,20303,1,'温润之水','温润之水达到20级',2030302,1,1,1,'[{holy_spirit_class,20},{holy_spirit_id,2}]','[{0,15020201,5}]',0),(2030302,2,203,20303,2,'温润之水','温润之水达到50级',2030303,1,1,1,'[{holy_spirit_class,50},{holy_spirit_id,2}]','[{0,15020201,5}]',0),(2030303,2,203,20303,3,'温润之水','温润之水达到80级',2030304,1,1,1,'[{holy_spirit_class,80},{holy_spirit_id,2}]','[{0,15020202,5}]',0),(2030304,2,203,20303,4,'温润之水','温润之水达到100级',2030305,1,1,1,'[{holy_spirit_class,100},{holy_spirit_id,2}]','[{0,15020202,5}]',0),(2030305,2,203,20303,5,'温润之水','温润之水达到120级',0,1,1,1,'[{holy_spirit_class,120},{holy_spirit_id,2}]','[{2,36020001,200}]',0),(2030401,2,203,20304,1,'摄魂行者','摄魂行者达到20级',2030402,1,1,1,'[{holy_spirit_class,20},{holy_spirit_id,3}]','[{0,15020301,5}]',0),(2030402,2,203,20304,2,'摄魂行者','摄魂行者达到50级',2030403,1,1,1,'[{holy_spirit_class,50},{holy_spirit_id,3}]','[{0,15020301,5}]',0),(2030403,2,203,20304,3,'摄魂行者','摄魂行者达到80级',2030404,1,1,1,'[{holy_spirit_class,80},{holy_spirit_id,3}]','[{0,15020302,5}]',0),(2030404,2,203,20304,4,'摄魂行者','摄魂行者达到100级',2030405,1,1,1,'[{holy_spirit_class,100},{holy_spirit_id,3}]','[{0,15020302,5}]',0),(2030405,2,203,20304,5,'摄魂行者','摄魂行者达到120级',0,1,1,1,'[{holy_spirit_class,120},{holy_spirit_id,3}]','[{2,36020001,200}]',0),(2030501,2,203,20305,1,'圣器收集','拥有2个圣器',2030502,0,1,1,'[{holy_equip_num,2}]','[{2,36020001,10}]',0),(2030502,2,203,20305,2,'圣器收集','拥有4个圣器',2030503,1,1,1,'[{holy_equip_num,4}]','[{2,36020001,10}]',0),(2030503,2,203,20305,3,'圣器收集','拥有6个圣器',2030504,1,1,1,'[{holy_equip_num,6}]','[{2,36020001,10}]',0),(2030504,2,203,20305,4,'圣器收集','拥有9个圣器',2030505,1,1,1,'[{holy_equip_num,9}]','[{2,36020001,10}]',0),(2030505,2,203,20305,5,'圣器收集','拥有12个圣器',0,1,1,1,'[{holy_equip_num,12}]','[{2,36020001,10}]',0),(2040101,2,204,20401,1,'降神进阶','降神·光辉神达到5阶',2040102,0,0,1,'[{god_class,5},{god_id,1001}]','[{0,11020001,5}]',0),(2040102,2,204,20401,2,'降神进阶','降神·光辉神达到10阶',2040103,1,1,1,'[{god_class,10},{god_id,1001}]','[{0,11020002,5}]',0),(2040103,2,204,20401,3,'降神进阶','降神·光辉神达到15阶',2040104,1,1,1,'[{god_class,15},{god_id,1001}]','[{0,11020002,10}]',0),(2040104,2,204,20401,4,'降神进阶','降神·光辉神达到20阶',2040105,1,1,1,'[{god_class,20},{god_id,1001}]','[{0,11020003,10}]',0),(2040105,2,204,20401,5,'降神进阶','降神·光辉神达到25阶',0,1,1,1,'[{god_class,25},{god_id,1001}]','[{2,36020001,200}]',0),(2040201,2,204,20402,1,'降神进阶','降神·冰雪女王达到5阶',2040202,0,0,1,'[{god_class,5},{god_id,1002}]','[{0,11020001,5}]',0),(2040202,2,204,20402,2,'降神进阶','降神·冰雪女王达到10阶',2040203,1,1,1,'[{god_class,10},{god_id,1002}]','[{0,11020002,5}]',0),(2040203,2,204,20402,3,'降神进阶','降神·冰雪女王达到15阶',2040204,1,1,1,'[{god_class,15},{god_id,1002}]','[{0,11020002,10}]',0),(2040204,2,204,20402,4,'降神进阶','降神·冰雪女王达到20阶',2040205,1,1,1,'[{god_class,20},{god_id,1002}]','[{0,11020003,10}]',0),(2040205,2,204,20402,5,'降神进阶','降神·冰雪女王达到25阶',0,1,1,1,'[{god_class,25},{god_id,1002}]','[{2,36020001,200}]',0),(2040301,2,204,20403,1,'降神进阶','降神·月神达到5阶',2040302,0,0,1,'[{god_class,5},{god_id,1003}]','[{0,11020001,5}]',0),(2040302,2,204,20403,2,'降神进阶','降神·月神达到10阶',2040303,1,1,1,'[{god_class,10},{god_id,1003}]','[{0,11020002,5}]',0),(2040303,2,204,20403,3,'降神进阶','降神·月神达到15阶',2040304,1,1,1,'[{god_class,15},{god_id,1003}]','[{0,11020002,10}]',0),(2040304,2,204,20403,4,'降神进阶','降神·月神达到20阶',2040305,1,1,1,'[{god_class,20},{god_id,1003}]','[{0,11020003,10}]',0),(2040305,2,204,20403,5,'降神进阶','降神·月神达到25阶',0,1,1,1,'[{god_class,25},{god_id,1003}]','[{2,36020001,200}]',0),(2040401,2,204,20404,1,'符文之力','符文强化总等级达到30级',2040402,0,0,1,'[{god_rune_total_lv,30}]','[{2,36020001,20},{0,11070001,5}]',0),(2040402,2,204,20404,2,'符文之力','符文强化总等级达到60级',2040403,1,1,1,'[{god_rune_total_lv,60}]','[{2,36020001,40},{0,11070001,15}]',0),(2040403,2,204,20404,3,'符文之力','符文强化总等级达到100级',2040404,1,1,1,'[{god_rune_total_lv,100}]','[{2,36020001,70},{0,11070002,10}]',0),(2040404,2,204,20404,4,'符文之力','符文强化总等级达到200级',2040405,1,1,1,'[{god_rune_total_lv,200}]','[{2,36020001,100},{0,11070002,20}]',0),(2040405,2,204,20404,5,'符文之力','符文强化总等级达到500级',0,1,1,1,'[{god_rune_total_lv,500}]','[{2,36020001,150},{0,11070003,10}]',0),(2040501,2,204,20405,1,'唤神之印','同时装备3个2级及以上印记',2040502,0,1,0,'[{god_mark_num,3},{god_mark_lv,2}]','[{2,36020001,15},{0,11070010,1}]',0),(2040502,2,204,20405,2,'唤神之印','同时装备3个3级及以上印记',2040503,1,1,0,'[{god_mark_num,3},{god_mark_lv,3}]','[{2,36020001,40},{0,11070010,2}]',0),(2040503,2,204,20405,3,'唤神之印','同时装备3个4级及以上印记',2040504,1,1,0,'[{god_mark_num,3},{god_mark_lv,4}]','[{2,36020001,80},{0,11070010,3}]',0),(2040504,2,204,20405,4,'唤神之印','同时装备3个5级及以上印记',2040505,1,1,0,'[{god_mark_num,3},{god_mark_lv,5}]','[{2,36020001,120},{0,11070010,4}]',0),(2040505,2,204,20405,5,'唤神之印','同时装备3个6级印记',0,1,1,0,'[{god_mark_num,3},{god_mark_lv,6}]','[{2,36020001,160},{0,11070010,5}]',0),(2040601,2,204,20406,3,'驭火者','解锁符文技能火神之炎',0,0,1,0,'[{god_mark_skill_id,16002030}]','[{2,36020001,100},{0,11070003,5}]',0),(2040701,2,204,20407,3,'庇护者','解锁符文技能生命之护',0,0,1,0,'[{god_mark_skill_id,16002040}]','[{2,36020001,100},{0,11070003,5}]',0),(2040801,2,204,20408,3,'神赐者','解锁符文技能众神之怒',0,0,1,0,'[{god_mark_skill_id,16002050}]','[{2,36020001,100},{0,11070003,5}]',0),(2040901,2,204,20409,3,'唤雷者','解锁符文技能雷神之罚',0,0,0,0,'[{god_mark_skill_id,16002020}]','[{2,36020001,100},{0,11070003,5}]',0),(3010101,3,301,30101,1,'全副武装','穿戴2件1阶红色以上装备',3010102,0,1,1,'[{equip_num,2},{equip_class,1},{equip_color,4}]','[{2,36020001,10}]',0),(3010102,3,301,30101,1,'全副武装','穿戴3件3阶红色以上装备',3010103,1,1,1,'[{equip_num,3},{equip_class,3},{equip_color,4}]','[{2,36020001,15}]',0),(3010103,3,301,30101,2,'全副武装','穿戴4件6阶红色以上装备',3010104,1,1,1,'[{equip_num,4},{equip_class,6},{equip_color,4}]','[{2,36020001,20}]',0),(3010104,3,301,30101,2,'全副武装','穿戴5件8阶红色以上装备',3010105,1,1,1,'[{equip_num,5},{equip_class,8},{equip_color,4}]','[{2,36020001,30}]',0),(3010105,3,301,30101,3,'全副武装','穿戴6件10阶红色以上装备',3010106,1,1,1,'[{equip_num,6},{equip_class,10},{equip_color,4}]','[{2,36020001,40}]',0),(3010106,3,301,30101,3,'全副武装','穿戴6件11阶红色以上装备',3010107,1,1,1,'[{equip_num,6},{equip_class,11},{equip_color,4}]','[{2,36020001,50}]',0),(3010107,3,301,30101,4,'全副武装','穿戴8件12阶红色以上装备',3010108,1,1,1,'[{equip_num,8},{equip_class,12},{equip_color,4}]','[{2,36020001,60}]',0),(3010108,3,301,30101,4,'全副武装','穿戴8件13阶红色以上装备',3010109,1,1,1,'[{equip_num,8},{equip_class,13},{equip_color,4}]','[{2,36020001,80}]',0),(3010109,3,301,30101,5,'全副武装','穿戴10件14阶红色以上装备',3010110,1,1,1,'[{equip_num,10},{equip_class,14},{equip_color,4}]','[{2,36020001,100}]',0),(3010110,3,301,30101,5,'全副武装','穿戴10件15阶红色以上装备',3010111,1,1,1,'[{equip_num,10},{equip_class,15},{equip_color,4}]','[{2,36020001,150}]',0),(3010111,3,301,30101,5,'全副武装','穿戴10件16阶红色以上装备',0,1,1,1,'[{equip_num,10},{equip_class,16},{equip_color,4}]','[{2,36020001,200}]',0),(3010201,3,301,30102,1,'究极武装','穿戴2件6阶粉装装备',3010202,1,1,1,'[{equip_num,2},{equip_class,6},{equip_color,5}]','[{2,36020001,200}]',0),(3010202,3,301,30102,2,'究极武装','穿戴4件9阶粉装装备',3010203,1,1,1,'[{equip_num,4},{equip_class,9},{equip_color,5}]','[{2,36020001,200}]',0),(3010203,3,301,30102,3,'究极武装','穿戴5件12阶粉装装备',3010204,1,1,1,'[{equip_num,5},{equip_class,12},{equip_color,5}]','[{2,36020001,200}]',0),(3010204,3,301,30102,4,'究极武装','穿戴2件6阶神装装备',3010205,1,1,1,'[{equip_num,2},{equip_class,6},{equip_color,6}]','[{2,36020001,200}]',0),(3010205,3,301,30102,5,'究极武装','穿戴4件9阶神装装备',3010206,1,1,1,'[{equip_num,4},{equip_class,9},{equip_color,6}]','[{2,36020001,200}]',0),(3010206,3,301,30102,5,'究极武装','穿戴5件12阶神装装备',0,1,1,1,'[{equip_num,5},{equip_class,12},{equip_color,6}]','[{2,36020001,200}]',0),(3010301,3,301,30103,1,'修罗套装','锻造1件霸者套装装备',3010302,0,0,1,'[{suit_num,1},{suit_id,1},{suit_color,1}]','[{0,32020112,5}]',0),(3010302,3,301,30103,3,'修罗套装','锻造3件霸者套装装备',3010303,1,1,1,'[{suit_num,3},{suit_id,1},{suit_color,1}]','[{0,32020112,10}]',0),(3010303,3,301,30103,5,'修罗套装','锻造5件霸者套装装备',0,1,1,1,'[{suit_num,5},{suit_id,1},{suit_color,1}]','[{0,32020112,20}]',0),(3010401,3,301,30104,1,'霸者套装','锻造1件修罗套装装备',3010402,0,0,1,'[{suit_num,1},{suit_id,1},{suit_color,2}]','[{0,32020122,5}]',0),(3010402,3,301,30104,3,'霸者套装','锻造3件修罗套装装备',3010403,1,1,1,'[{suit_num,3},{suit_id,1},{suit_color,2}]','[{0,32020122,10}]',0),(3010403,3,301,30104,5,'霸者套装','锻造5件修罗套装装备',0,1,1,1,'[{suit_num,5},{suit_id,1},{suit_color,2}]','[{0,32020122,15}]',0),(3010501,3,301,30105,1,'战神套装','锻造1件泰坦套装装备',3010502,0,0,1,'[{suit_num,1},{suit_id,2},{suit_color,1}]','[{0,32020113,5}]',0),(3010502,3,301,30105,3,'战神套装','锻造3件泰坦套装装备',3010503,1,1,1,'[{suit_num,3},{suit_id,2},{suit_color,1}]','[{0,32020113,10}]',0),(3010503,3,301,30105,5,'战神套装','锻造5件泰坦套装装备',0,1,1,1,'[{suit_num,5},{suit_id,2},{suit_color,1}]','[{0,32020113,20}]',0),(3010601,3,301,30106,1,'泰坦套装','锻造1件战神套装装备',3010602,0,0,1,'[{suit_num,1},{suit_id,2},{suit_color,2}]','[{0,32020123,5}]',0),(3010602,3,301,30106,3,'泰坦套装','锻造3件战神套装装备',3010603,1,1,1,'[{suit_num,3},{suit_id,2},{suit_color,2}]','[{0,32020123,10}]',0),(3010603,3,301,30106,5,'泰坦套装','锻造5件战神套装装备',0,1,1,1,'[{suit_num,5},{suit_id,2},{suit_color,2}]','[{0,32020123,15}]',0),(3010701,3,301,30107,1,'装备洗炼','洗练出10条紫色或以上属性',3010702,0,1,1,'[{property_num,10},{property_color,2}]','[{2,36020001,10}]',0),(3010702,3,301,30107,2,'装备洗炼','洗练出20条紫色或以上属性',3010703,1,1,1,'[{property_num,20},{property_color,2}]','[{2,36020001,20}]',0),(3010703,3,301,30107,2,'装备洗炼','洗练出30条紫色或以上属性',3010704,1,1,1,'[{property_num,30},{property_color,2}]','[{2,36020001,30}]',0),(3010704,3,301,30107,3,'装备洗炼','洗练出10条橙色或以上属性',3010705,1,1,1,'[{property_num,10},{property_color,3}]','[{2,36020001,40}]',0),(3010705,3,301,30107,4,'装备洗炼','洗练出20条橙色或以上属性',3010706,1,1,1,'[{property_num,20},{property_color,3}]','[{2,36020001,50}]',0),(3010706,3,301,30107,4,'装备洗炼','洗练出30条橙色或以上属性',3010707,1,1,1,'[{property_num,30},{property_color,3}]','[{2,36020001,60}]',0),(3010707,3,301,30107,5,'装备洗炼','洗练出10条红色或以上属性',3010708,1,1,1,'[{property_num,10},{property_color,4}]','[{2,36020001,70}]',0),(3010708,3,301,30107,5,'装备洗炼','洗练出15条红色或以上属性',0,1,1,1,'[{property_num,15},{property_color,4}]','[{2,36020001,80}]',0),(3010801,3,301,30108,1,'装备强化','强化1件装备到20级',3010802,0,1,1,'[{strengthen_num,1},{strengthen_lv,20}]','[{2,36020001,10}]',0),(3010802,3,301,30108,1,'装备强化','强化2件装备到50级',3010803,1,1,1,'[{strengthen_num,2},{strengthen_lv,50}]','[{2,36020001,20}]',0),(3010803,3,301,30108,2,'装备强化','强化3件装备到100级',3010804,1,1,1,'[{strengthen_num,3},{strengthen_lv,100}]','[{2,36020001,30}]',0),(3010804,3,301,30108,2,'装备强化','强化4件装备到150级',3010805,1,1,1,'[{strengthen_num,4},{strengthen_lv,150}]','[{2,36020001,40}]',0),(3010805,3,301,30108,3,'装备强化','强化5件装备到200级',3010806,1,1,1,'[{strengthen_num,5},{strengthen_lv,200}]','[{2,36020001,50}]',0),(3010806,3,301,30108,3,'装备强化','强化6件装备到250级',3010807,1,1,1,'[{strengthen_num,6},{strengthen_lv,250}]','[{2,36020001,60}]',0),(3010807,3,301,30108,4,'装备强化','强化7件装备到300级',3010808,1,1,1,'[{strengthen_num,7},{strengthen_lv,300}]','[{2,36020001,70}]',0),(3010808,3,301,30108,4,'装备强化','强化8件装备到350级',3010809,1,1,1,'[{strengthen_num,8},{strengthen_lv,350}]','[{2,36020001,80}]',0),(3010809,3,301,30108,5,'装备强化','强化9件装备到400级',3010810,1,1,1,'[{strengthen_num,9},{strengthen_lv,400}]','[{2,36020001,90}]',0),(3010810,3,301,30108,5,'装备强化','强化10件装备到450级',0,1,1,1,'[{strengthen_num,10},{strengthen_lv,450}]','[{2,36020001,100}]',0),(3020101,3,302,30201,1,'宝石数量','镶嵌5颗宝石',3020102,0,1,1,'[{jewel_num,5}]','[{0,14120001,10}]',0),(3020102,3,302,30201,2,'宝石数量','镶嵌15颗宝石',3020103,1,1,1,'[{jewel_num,15}]','[{0,14120001,10}]',0),(3020103,3,302,30201,3,'宝石数量','镶嵌30颗宝石',3020104,1,1,1,'[{jewel_num,30}]','[{0,14120001,10}]',0),(3020104,3,302,30201,4,'宝石数量','镶嵌50颗宝石',3020105,1,1,1,'[{jewel_num,50}]','[{0,14120001,10}]',0),(3020105,3,302,30201,5,'宝石数量','镶嵌60颗宝石',0,1,1,1,'[{jewel_num,60}]','[{0,14120001,10}]',0),(3020201,3,302,30202,1,'宝石等级','镶嵌10颗2级以上的宝石',3020202,0,1,1,'[{jewel_num,10},{jewel_lv,2}]','[{0,14120001,10}]',0),(3020202,3,302,30202,1,'宝石等级','镶嵌9颗3级以上的宝石',3020203,1,1,1,'[{jewel_num,9},{jewel_lv,3}]','[{0,14120001,20}]',0),(3020203,3,302,30202,1,'宝石等级','镶嵌8颗4级以上的宝石',3020204,1,1,1,'[{jewel_num,8},{jewel_lv,4}]','[{0,14120001,30}]',0),(3020204,3,302,30202,2,'宝石等级','镶嵌7颗5级以上的宝石',3020205,1,1,1,'[{jewel_num,7},{jewel_lv,5}]','[{0,14120001,40}]',0),(3020205,3,302,30202,2,'宝石等级','镶嵌6颗6级以上的宝石',3020206,1,1,1,'[{jewel_num,6},{jewel_lv,6}]','[{0,14120001,50}]',0),(3020206,3,302,30202,2,'宝石等级','镶嵌7颗7级以上的宝石',3020207,1,1,1,'[{jewel_num,7},{jewel_lv,7}]','[{0,14120001,60}]',0),(3020207,3,302,30202,3,'宝石等级','镶嵌8颗8级以上的宝石',3020208,1,1,1,'[{jewel_num,8},{jewel_lv,8}]','[{0,14120001,70}]',0),(3020208,3,302,30202,3,'宝石等级','镶嵌9颗9级以上的宝石',3020209,1,1,1,'[{jewel_num,9},{jewel_lv,9}]','[{0,14120001,80}]',0),(3020209,3,302,30202,3,'宝石等级','镶嵌10颗10级以上的宝石',3020210,1,1,1,'[{jewel_num,10},{jewel_lv,10}]','[{0,14120001,90}]',0),(3020210,3,302,30202,4,'宝石等级','镶嵌9颗11级以上的宝石',3020211,1,1,1,'[{jewel_num,9},{jewel_lv,11}]','[{0,14120001,100}]',0),(3020211,3,302,30202,4,'宝石等级','镶嵌8颗12级以上的宝石',3020212,1,1,1,'[{jewel_num,8},{jewel_lv,12}]','[{0,14120001,110}]',0),(3020212,3,302,30202,4,'宝石等级','镶嵌7颗13级以上的宝石',3020213,1,1,1,'[{jewel_num,7},{jewel_lv,13}]','[{0,14120001,120}]',0),(3020213,3,302,30202,5,'宝石等级','镶嵌6颗14级以上的宝石',3020214,1,1,1,'[{jewel_num,6},{jewel_lv,14}]','[{0,14120001,130}]',0),(3020214,3,302,30202,5,'宝石等级','镶嵌5颗15级以上的宝石',3020215,1,1,1,'[{jewel_num,5},{jewel_lv,15}]','[{0,14120001,140}]',0),(3020215,3,302,30202,5,'宝石等级','镶嵌4颗16级以上的宝石',3020216,1,1,1,'[{jewel_num,4},{jewel_lv,16}]','[{0,14120001,150}]',0),(3020216,3,302,30202,5,'宝石等级','镶嵌3颗17级以上的宝石',0,1,1,1,'[{jewel_num,3},{jewel_lv,17}]','[{0,14120001,160}]',0),(4010101,4,401,40101,1,'签到次数','累积签到1次',4010102,0,1,1,'[{sign_count,1}]','[{2,36020001,10}]',0),(4010102,4,401,40101,1,'签到次数','累积签到2次',4010103,1,1,1,'[{sign_count,2}]','[{2,36020001,10}]',0),(4010103,4,401,40101,1,'签到次数','累积签到3次',4010104,1,1,1,'[{sign_count,3}]','[{2,36020001,10}]',0),(4010104,4,401,40101,1,'签到次数','累积签到5次',4010105,1,1,1,'[{sign_count,5}]','[{2,36020001,10}]',0),(4010105,4,401,40101,1,'签到次数','累积签到7次',4010106,1,1,1,'[{sign_count,7}]','[{2,36020001,10}]',0),(4010106,4,401,40101,2,'签到次数','累积签到15次',4010107,1,1,1,'[{sign_count,15}]','[{2,36020001,20}]',0),(4010107,4,401,40101,2,'签到次数','累积签到30次',4010108,1,1,1,'[{sign_count,30}]','[{2,36020001,20}]',0),(4010108,4,401,40101,2,'签到次数','累积签到60次',4010109,1,1,1,'[{sign_count,60}]','[{2,36020001,20}]',0),(4010109,4,401,40101,2,'签到次数','累积签到90次',4010110,1,1,1,'[{sign_count,90}]','[{2,36020001,20}]',0),(4010110,4,401,40101,2,'签到次数','累积签到120次',4010111,1,1,1,'[{sign_count,120}]','[{2,36020001,30}]',0),(4010111,4,401,40101,3,'签到次数','累积签到150次',4010112,1,1,1,'[{sign_count,150}]','[{2,36020001,30}]',0),(4010112,4,401,40101,3,'签到次数','累积签到180次',4010113,1,1,1,'[{sign_count,180}]','[{2,36020001,30}]',0),(4010113,4,401,40101,3,'签到次数','累积签到230次',4010114,1,1,1,'[{sign_count,230}]','[{2,36020001,40}]',0),(4010114,4,401,40101,3,'签到次数','累积签到280次',4010115,1,1,1,'[{sign_count,280}]','[{2,36020001,40}]',0),(4010115,4,401,40101,3,'签到次数','累积签到330次',4010116,1,1,1,'[{sign_count,330}]','[{2,36020001,40}]',0),(4010116,4,401,40101,4,'签到次数','累积签到380次',4010117,1,1,1,'[{sign_count,380}]','[{2,36020001,40}]',0),(4010117,4,401,40101,4,'签到次数','累积签到430次',4010118,1,1,1,'[{sign_count,430}]','[{2,36020001,40}]',0),(4010118,4,401,40101,4,'签到次数','累积签到480次',4010119,1,1,1,'[{sign_count,480}]','[{2,36020001,50}]',0),(4010119,4,401,40101,4,'签到次数','累积签到530次',4010120,1,1,1,'[{sign_count,530}]','[{2,36020001,50}]',0),(4010120,4,401,40101,4,'签到次数','累积签到580次',4010121,1,1,1,'[{sign_count,580}]','[{2,36020001,50}]',0),(4010121,4,401,40101,5,'签到次数','累积签到630次',4010122,1,1,1,'[{sign_count,630}]','[{2,36020001,50}]',0),(4010122,4,401,40101,5,'签到次数','累积签到680次',4010123,1,1,1,'[{sign_count,680}]','[{2,36020001,50}]',0),(4010123,4,401,40101,5,'签到次数','累积签到730次',4010124,1,1,1,'[{sign_count,730}]','[{2,36020001,50}]',0),(4010124,4,401,40101,5,'签到次数','累积签到780次',4010125,1,1,1,'[{sign_count,780}]','[{2,36020001,50}]',0),(4010125,4,401,40101,5,'签到次数','累积签到830次',4010126,1,1,1,'[{sign_count,830}]','[{2,36020001,50}]',0),(4010126,4,401,40101,5,'签到次数','累积签到999次',0,1,1,1,'[{sign_count,999}]','[{2,36020001,50}]',0),(4020101,4,402,40201,1,'巅峰竞技','巅峰竞技达到白银段位',4020102,0,1,1,'[{dan_race,2}]','[{2,36020001,10}]',0),(4020102,4,402,40201,2,'巅峰竞技','巅峰竞技达到黄金段位',4020103,1,1,1,'[{dan_race,3}]','[{2,36020001,20}]',0),(4020103,4,402,40201,3,'巅峰竞技','巅峰竞技达到铂金段位',4020104,1,1,1,'[{dan_race,4}]','[{2,36020001,30}]',0),(4020104,4,402,40201,4,'巅峰竞技','巅峰竞技达到钻石段位',4020105,1,1,1,'[{dan_race,5}]','[{2,36020001,50}]',0),(4020105,4,402,40201,5,'巅峰竞技','巅峰竞技达到王者段位',0,1,1,1,'[{dan_race,6}]','[{2,36020001,80}]',0),(4020201,4,402,40202,1,'博学之冠','中午答题单次最高正确5次',4020202,0,1,1,'[{quiz_correct,5}]','[{2,36020001,10}]',0),(4020202,4,402,40202,2,'博学之冠','中午答题单次最高正确10次',4020203,1,1,1,'[{quiz_correct,10}]','[{2,36020001,20}]',0),(4020203,4,402,40202,3,'博学之冠','中午答题单次最高正确15次',4020204,1,1,1,'[{quiz_correct,15}]','[{2,36020001,30}]',0),(4020204,4,402,40202,4,'博学之冠','中午答题单次最高正确20次',0,1,1,1,'[{quiz_correct,20}]','[{2,36020001,50}]',0),(4020301,4,402,40203,1,'荆棘战神','丛林突围累计击败1个玩家',4020302,0,1,1,'[{beat_num,1}]','[{2,36020001,10}]',0),(4020302,4,402,40203,1,'荆棘战神','丛林突围累计击败10个玩家',4020303,1,1,1,'[{beat_num,10}]','[{2,36020001,10}]',0),(4020303,4,402,40203,2,'荆棘战神','丛林突围累计击败20个玩家',4020304,1,1,1,'[{beat_num,20}]','[{2,36020001,10}]',0),(4020304,4,402,40203,2,'荆棘战神','丛林突围累计击败50个玩家',4020305,1,1,1,'[{beat_num,50}]','[{2,36020001,20}]',0),(4020305,4,402,40203,3,'荆棘战神','丛林突围累计击败100个玩家',4020306,1,1,1,'[{beat_num,100}]','[{2,36020001,20}]',0),(4020306,4,402,40203,3,'荆棘战神','丛林突围累计击败500个玩家',4020307,1,1,1,'[{beat_num,500}]','[{2,36020001,20}]',0),(4020307,4,402,40203,4,'荆棘战神','丛林突围累计击败999个玩家',4020308,1,1,1,'[{beat_num,999}]','[{2,36020001,30}]',0),(4020308,4,402,40203,4,'荆棘战神','丛林突围累计击败2000个玩家',4020309,1,1,1,'[{beat_num,2000}]','[{2,36020001,30}]',0),(4020309,4,402,40203,5,'荆棘战神','丛林突围累计击败3000个玩家',4020310,1,1,1,'[{beat_num,3000}]','[{2,36020001,30}]',0),(4020310,4,402,40203,5,'荆棘战神','丛林突围累计击败5000个玩家',4020311,1,1,1,'[{beat_num,5000}]','[{2,36020001,50}]',0),(4020311,4,402,40203,5,'荆棘战神','丛林突围累计击败9999个玩家',0,1,1,1,'[{beat_num,9999}]','[{2,36020001,50}]',0),(4020401,4,402,40204,1,'竞技排名','竞技场最高达到1000名',4020402,0,1,1,'[{competitive_ranking,1000}]','[{2,36020001,10}]',0),(4020402,4,402,40204,2,'竞技排名','竞技场最高达到600名',4020403,1,1,1,'[{competitive_ranking,600}]','[{2,36020001,15}]',0),(4020403,4,402,40204,2,'竞技排名','竞技场最高达到300名',4020404,1,1,1,'[{competitive_ranking,300}]','[{2,36020001,20}]',0),(4020404,4,402,40204,3,'竞技排名','竞技场最高达到100名',4020405,1,1,1,'[{competitive_ranking,100}]','[{2,36020001,25}]',0),(4020405,4,402,40204,3,'竞技排名','竞技场最高达到50名',4020406,1,1,1,'[{competitive_ranking,50}]','[{2,36020001,30}]',0),(4020406,4,402,40204,4,'竞技排名','竞技场最高达到20名',4020407,1,1,1,'[{competitive_ranking,20}]','[{2,36020001,40}]',0),(4020407,4,402,40204,4,'竞技排名','竞技场最高达到10名',4020408,1,1,1,'[{competitive_ranking,10}]','[{2,36020001,60}]',0),(4020408,4,402,40204,5,'竞技排名','竞技场最高达到5名',4020409,1,1,1,'[{competitive_ranking,5}]','[{2,36020001,80}]',0),(4020409,4,402,40204,5,'竞技排名','竞技场最高达到1名',0,1,1,1,'[{competitive_ranking,1}]','[{2,36020001,100}]',0),(4020501,4,402,40205,1,'魅力海滩','参与魅力海滩1次',4020502,0,1,1,'[{join_beach,1}]','[{2,36020001,10}]',0),(4020502,4,402,40205,2,'魅力海滩','参与魅力海滩2次',4020503,1,1,1,'[{join_beach,2}]','[{2,36020001,10}]',0),(4020503,4,402,40205,2,'魅力海滩','参与魅力海滩5次',4020504,1,1,1,'[{join_beach,5}]','[{2,36020001,10}]',0),(4020504,4,402,40205,3,'魅力海滩','参与魅力海滩10次',4020505,1,1,1,'[{join_beach,10}]','[{2,36020001,20}]',0),(4020505,4,402,40205,3,'魅力海滩','参与魅力海滩30次',4020506,1,1,1,'[{join_beach,30}]','[{2,36020001,20}]',0),(4020506,4,402,40205,4,'魅力海滩','参与魅力海滩100次',4020507,1,1,1,'[{join_beach,100}]','[{2,36020001,30}]',0),(4020507,4,402,40205,4,'魅力海滩','参与魅力海滩200次',4020508,1,1,1,'[{join_beach,200}]','[{2,36020001,30}]',0),(4020508,4,402,40205,5,'魅力海滩','参与魅力海滩520次',4020509,1,1,1,'[{join_beach,520}]','[{2,36020001,50}]',0),(4020509,4,402,40205,5,'魅力海滩','参与魅力海滩1314次',0,1,1,1,'[{join_beach,1314}]','[{2,36020001,100}]',0),(4020601,4,402,40206,1,'屡败屡战','竞技场累计失败5次',4020602,0,1,1,'[{competitive_failure,5}]','[{2,36020001,10}]',0),(4020602,4,402,40206,2,'屡败屡战','竞技场累计失败20次',4020603,1,1,1,'[{competitive_failure,20}]','[{2,36020001,20}]',0),(4020603,4,402,40206,3,'屡败屡战','竞技场累计失败50次',4020604,1,1,1,'[{competitive_failure,50}]','[{2,36020001,30}]',0),(4020604,4,402,40206,4,'屡败屡战','竞技场累计失败100次',4020605,1,1,1,'[{competitive_failure,100}]','[{2,36020001,40}]',0),(4020605,4,402,40206,5,'屡败屡战','竞技场累计失败200次',0,1,1,1,'[{competitive_failure,200}]','[{2,36020001,50}]',0),(5010101,5,501,50101,1,'公会之星','参与公会战1次',5010102,0,1,1,'[{guild_war,1}]','[{2,36020001,10}]',0),(5010102,5,501,50101,2,'公会之星','参与公会战2次',5010103,1,1,1,'[{guild_war,2}]','[{2,36020001,15}]',0),(5010103,5,501,50101,3,'公会之星','参与公会战5次',5010104,1,1,1,'[{guild_war,5}]','[{2,36020001,20}]',0),(5010104,5,501,50101,3,'公会之星','参与公会战10次',5010105,1,1,1,'[{guild_war,10}]','[{2,36020001,30}]',0),(5010105,5,501,50101,4,'公会之星','参与公会战30次',5010106,1,1,1,'[{guild_war,30}]','[{2,36020001,40}]',0),(5010106,5,501,50101,5,'公会之星','参与公会战50次',5010107,1,1,1,'[{guild_war,50}]','[{2,36020001,50}]',0),(5010107,5,501,50101,5,'公会之星','参与公会战100次',0,1,1,1,'[{guild_war,100}]','[{2,36020001,80}]',0),(5010201,5,501,50102,1,'胜利之师','公会战胜利1次',5010202,0,1,1,'[{guild_war_victory,1}]','[{2,36020001,20}]',0),(5010202,5,501,50102,2,'胜利之师','公会战胜利10次',5010203,1,1,1,'[{guild_war_victory,10}]','[{2,36020001,40}]',0),(5010203,5,501,50102,3,'胜利之师','公会战胜利30次',5010204,1,1,1,'[{guild_war_victory,30}]','[{2,36020001,60}]',0),(5010204,5,501,50102,4,'胜利之师','公会战胜利50次',5010205,1,1,1,'[{guild_war_victory,50}]','[{2,36020001,100}]',0),(5010205,5,501,50102,5,'胜利之师','公会战胜利100次',0,1,1,1,'[{guild_war_victory,100}]','[{2,36020001,150}]',0),(5010301,5,501,50103,1,'晚宴狂欢','参加公会晚宴1次',5010302,0,1,1,'[{guild_dinner,1}]','[{2,36020001,10}]',0),(5010302,5,501,50103,2,'晚宴狂欢','参加公会晚宴8次',5010303,1,1,1,'[{guild_dinner,8}]','[{2,36020001,20}]',0),(5010303,5,501,50103,3,'晚宴狂欢','参加公会晚宴16次',5010304,1,1,1,'[{guild_dinner,16}]','[{2,36020001,30}]',0),(5010304,5,501,50103,3,'晚宴狂欢','参加公会晚宴50次',5010305,1,1,1,'[{guild_dinner,50}]','[{2,36020001,40}]',0),(5010305,5,501,50103,4,'晚宴狂欢','参加公会晚宴99次',5010306,1,1,1,'[{guild_dinner,99}]','[{2,36020001,50}]',0),(5010306,5,501,50103,5,'晚宴狂欢','参加公会晚宴166次',5010307,1,1,1,'[{guild_dinner,166}]','[{2,36020001,75}]',0),(5010307,5,501,50103,5,'晚宴狂欢','参加公会晚宴520次',0,1,1,1,'[{guild_dinner,520}]','[{2,36020001,100}]',0),(5010401,5,501,50104,1,'公会红包','发红包1次',5010402,0,1,1,'[{guild_red_packet,1}]','[{2,36020001,10}]',0),(5010402,5,501,50104,2,'公会红包','发红包6次',5010403,1,1,1,'[{guild_red_packet,6}]','[{2,36020001,20}]',0),(5010403,5,501,50104,3,'公会红包','发红包18次',5010404,1,1,1,'[{guild_red_packet,18}]','[{2,36020001,30}]',0),(5010404,5,501,50104,3,'公会红包','发红包66次',5010405,1,1,1,'[{guild_red_packet,66}]','[{2,36020001,40}]',0),(5010405,5,501,50104,4,'公会红包','发红包101次',5010406,1,1,1,'[{guild_red_packet,101}]','[{2,36020001,50}]',0),(5010406,5,501,50104,5,'公会红包','发红包233次',5010407,1,1,1,'[{guild_red_packet,233}]','[{2,36020001,75}]',0),(5010407,5,501,50104,5,'公会红包','发红包666次',0,1,1,1,'[{guild_red_packet,666}]','[{2,36020001,100}]',0),(5010501,5,501,50105,1,'公会任务','公会任务10个',5010502,0,1,1,'[{guild_task,10}]','[{2,36020001,10}]',0),(5010502,5,501,50105,2,'公会任务','公会任务30个',5010503,1,1,1,'[{guild_task,30}]','[{2,36020001,20}]',0),(5010503,5,501,50105,2,'公会任务','公会任务50个',5010504,1,1,1,'[{guild_task,50}]','[{2,36020001,30}]',0),(5010504,5,501,50105,3,'公会任务','公会任务70个',5010505,1,1,1,'[{guild_task,70}]','[{2,36020001,40}]',0),(5010505,5,501,50105,4,'公会任务','公会任务100个',5010506,1,1,1,'[{guild_task,100}]','[{2,36020001,50}]',0),(5010506,5,501,50105,4,'公会任务','公会任务300个',5010507,1,1,1,'[{guild_task,300}]','[{2,36020001,50}]',0),(5010507,5,501,50105,5,'公会任务','公会任务600个',5010508,1,1,1,'[{guild_task,600}]','[{2,36020001,60}]',0),(5010508,5,501,50105,5,'公会任务','公会任务1000个',0,1,1,1,'[{guild_task,1000}]','[{2,36020001,80}]',0),(5010601,5,501,50106,1,'公会一员','加入公会1次',5010602,0,1,1,'[{join_guild,1}]','[{2,36020001,10}]',0),(5010602,5,501,50106,2,'公会一员','加入公会2次',5010603,1,1,1,'[{join_guild,2}]','[{2,36020001,10}]',0),(5010603,5,501,50106,3,'七进七出','加入公会7次',0,1,1,1,'[{join_guild,7}]','[{2,36020001,20}]',0),(5020101,5,502,50201,1,'你好世界','世界频道发言1次',5020102,0,1,1,'[{world_channel,1}]','[{2,36020001,10}]',0),(5020102,5,502,50201,2,'你好世界','世界频道发言15次',5020103,1,1,1,'[{world_channel,15}]','[{2,36020001,10}]',0),(5020103,5,502,50201,3,'你好世界','世界频道发言100次',5020104,1,1,1,'[{world_channel,100}]','[{2,36020001,10}]',0),(5020104,5,502,50201,3,'你好世界','世界频道发言222次',5020105,1,1,1,'[{world_channel,222}]','[{2,36020001,15}]',0),(5020105,5,502,50201,4,'你好世界','世界频道发言555次',5020106,1,1,1,'[{world_channel,555}]','[{2,36020001,15}]',0),(5020106,5,502,50201,5,'你好世界','世界频道发言999次',5020107,1,1,1,'[{world_channel,999}]','[{2,36020001,20}]',0),(5020107,5,502,50201,5,'你好世界','世界频道发言10000次',0,1,1,1,'[{world_channel,10000}]','[{2,36020001,50}]',0),(5020201,5,502,50202,1,'交友广泛','好友数量达到2个',5020202,0,1,1,'[{add_friend,2}]','[{2,36020001,10}]',0),(5020202,5,502,50202,2,'交友广泛','好友数量达到6个',5020203,1,1,1,'[{add_friend,6}]','[{2,36020001,10}]',0),(5020203,5,502,50202,3,'交友广泛','好友数量达到8个',5020204,1,1,1,'[{add_friend,8}]','[{2,36020001,10}]',0),(5020204,5,502,50202,4,'交友广泛','好友数量达到18个',5020205,1,1,1,'[{add_friend,18}]','[{2,36020001,15}]',0),(5020205,5,502,50202,5,'交友广泛','好友数量达到38个',0,1,1,1,'[{add_friend,38}]','[{2,36020001,20}]',0),(5020301,5,502,50203,1,'花香满身','花香值达到1',5020302,0,1,1,'[{flower_send,1}]','[{2,36020001,10}]',0),(5020302,5,502,50203,2,'花香满身','花香值达到500',5020303,1,1,1,'[{flower_send,500}]','[{2,36020001,15}]',0),(5020303,5,502,50203,3,'花香满身','花香值达到999',5020304,1,1,1,'[{flower_send,999}]','[{2,36020001,20}]',0),(5020304,5,502,50203,4,'花香满身','花香值达到5000',5020305,1,1,1,'[{flower_send,5000}]','[{2,36020001,40}]',0),(5020305,5,502,50203,5,'花香满身','花香值达到10000',0,1,1,1,'[{flower_send,10000}]','[{2,36020001,60}]',0),(5020401,5,502,50204,1,'浪漫婚礼','结婚1次',5020402,0,1,1,'[{married,1}]','[{2,36020001,20}]',0),(5020402,5,502,50204,2,'浪漫婚礼','结婚2次',5020403,1,1,0,'[{married,2}]','[{2,36020001,40}]',0),(5020403,5,502,50204,3,'浪漫婚礼','结婚3次',0,1,1,0,'[{married,3}]','[{2,36020001,60}]',0),(5020501,5,502,50205,1,'懒得理你','拉黑1次',5020502,0,1,1,'[{blacklist,1}]','[{2,36020001,10}]',0),(5020502,5,502,50205,2,'懒得理你','拉黑9次',5020503,1,1,1,'[{blacklist,9}]','[{2,36020001,15}]',0),(5020503,5,502,50205,3,'懒得理你','拉黑44次',5020504,1,1,1,'[{blacklist,44}]','[{2,36020001,20}]',0),(5020504,5,502,50205,4,'懒得理你','拉黑144次',0,1,1,1,'[{blacklist,144}]','[{2,36020001,30}]',0),(5030101,5,503,50301,1,'我是杀手','击杀1个玩家',5030102,0,1,1,'[{kill_player,1}]','[{2,36020001,10}]',0),(5030102,5,503,50301,2,'我是杀手','击杀10个玩家',5030103,1,1,1,'[{kill_player,10}]','[{2,36020001,10}]',0),(5030103,5,503,50301,3,'我是杀手','击杀100个玩家',5030104,1,1,1,'[{kill_player,100}]','[{2,36020001,20}]',0),(5030104,5,503,50301,4,'我是杀手','击杀1000个玩家',5030105,1,1,1,'[{kill_player,1000}]','[{2,36020001,40}]',0),(5030105,5,503,50301,5,'我是杀手','击杀10000个玩家',0,1,1,1,'[{kill_player,10000}]','[{2,36020001,80}]',0),(5030201,5,503,50302,1,'百战不殆','死亡1次',5030202,0,1,1,'[{death,1}]','[{2,36020001,10}]',0),(5030202,5,503,50302,2,'百战不殆','死亡10次',5030203,1,1,1,'[{death,10}]','[{2,36020001,10}]',0),(5030203,5,503,50302,3,'百战不殆','死亡100次',5030204,1,1,1,'[{death,100}]','[{2,36020001,20}]',0),(5030204,5,503,50302,4,'百战不殆','死亡1000次',5030205,1,1,1,'[{death,1000}]','[{2,36020001,40}]',0),(5030205,5,503,50302,5,'百战不殆','死亡10000次',0,1,1,1,'[{death,10000}]','[{2,36020001,80}]',0),(5030301,5,503,50303,1,'罪恶克星','击杀1个红名玩家',5030302,0,1,1,'[{kill_red_player,1}]','[{2,36020001,20}]',0),(5030302,5,503,50303,2,'罪恶克星','击杀100个红名玩家',5030303,1,1,1,'[{kill_red_player,100}]','[{2,36020001,40}]',0),(5030303,5,503,50303,3,'罪恶克星','击杀1000个红名玩家',0,1,1,1,'[{kill_red_player,1000}]','[{2,36020001,80}]',0),(5030401,5,503,50304,1,'做个好人','洗红名1次',5030402,0,1,1,'[{wash_red_name,1}]','[{2,36020001,20}]',0),(5030402,5,503,50304,2,'做个好人','洗红名16次',5030403,1,1,1,'[{wash_red_name,16}]','[{2,36020001,30}]',0),(5030403,5,503,50304,3,'做个好人','洗红名66次',0,1,1,1,'[{wash_red_name,66}]','[{2,36020001,50}]',0),(6010101,6,601,60101,1,'定个目标','累计获得8888888金币',6010102,0,1,0,'[{cumulative_coin,8888888}]','[{2,36020001,10}]',0),(6010102,6,601,60101,2,'定个目标','累计获得66666666金币',6010103,1,1,0,'[{cumulative_coin,66666666}]','[{2,36020001,15}]',0),(6010103,6,601,60101,3,'定个目标','累计获得128888888金币',6010104,1,1,0,'[{cumulative_coin,128888888}]','[{2,36020001,20}]',0),(6010104,6,601,60101,3,'定个目标','累计获得366666666金币',6010105,1,1,0,'[{cumulative_coin,366666666}]','[{2,36020001,25}]',0),(6010105,6,601,60101,4,'定个目标','累计获得888888888金币',6010106,1,1,0,'[{cumulative_coin,888888888}]','[{2,36020001,30}]',0),(6010106,6,601,60101,5,'定个目标','累计获得1200000000金币',6010107,1,1,0,'[{cumulative_coin,1200000000}]','[{2,36020001,40}]',0),(6010107,6,601,60101,5,'定个目标','累计获得1888888888金币',0,1,1,0,'[{cumulative_coin,1888888888}]','[{2,36020001,50}]',0),(6010201,6,601,60102,1,'钻石大亨','累计获得100钻石',6010202,0,1,0,'[{cumulative_gold,100}]','[{2,36020001,10}]',0),(6010202,6,601,60102,1,'钻石大亨','累计获得800钻石',6010203,1,1,0,'[{cumulative_gold,800}]','[{2,36020001,10}]',0),(6010203,6,601,60102,1,'钻石大亨','累计获得3000钻石',6010204,1,1,0,'[{cumulative_gold,3000}]','[{2,36020001,10}]',0),(6010204,6,601,60102,2,'钻石大亨','累计获得6000钻石',6010205,1,1,0,'[{cumulative_gold,6000}]','[{2,36020001,10}]',0),(6010205,6,601,60102,2,'钻石大亨','累计获得10000钻石',6010206,1,1,0,'[{cumulative_gold,10000}]','[{2,36020001,10}]',0),(6010206,6,601,60102,2,'钻石大亨','累计获得20000钻石',6010207,1,1,0,'[{cumulative_gold,20000}]','[{2,36020001,10}]',0),(6010207,6,601,60102,3,'钻石大亨','累计获得30000钻石',6010208,1,1,0,'[{cumulative_gold,30000}]','[{2,36020001,10}]',0),(6010208,6,601,60102,3,'钻石大亨','累计获得50000钻石',6010209,1,1,0,'[{cumulative_gold,50000}]','[{2,36020001,10}]',0),(6010209,6,601,60102,3,'钻石大亨','累计获得100000钻石',6010210,1,1,0,'[{cumulative_gold,100000}]','[{2,36020001,20}]',0),(6010210,6,601,60102,4,'钻石大亨','累计获得180000钻石',6010211,1,1,0,'[{cumulative_gold,180000}]','[{2,36020001,20}]',0),(6010211,6,601,60102,4,'钻石大亨','累计获得300000钻石',6010212,1,1,0,'[{cumulative_gold,300000}]','[{2,36020001,30}]',0),(6010212,6,601,60102,4,'钻石大亨','累计获得500000钻石',6010213,1,1,0,'[{cumulative_gold,500000}]','[{2,36020001,40}]',0),(6010213,6,601,60102,5,'钻石大亨','累计获得800000钻石',6010214,1,1,0,'[{cumulative_gold,800000}]','[{2,36020001,50}]',0),(6010214,6,601,60102,5,'钻石大亨','累计获得1200000钻石',6010215,1,1,0,'[{cumulative_gold,1200000}]','[{2,36020001,60}]',0),(6010215,6,601,60102,5,'钻石大亨','累计获得1800000钻石',0,1,1,0,'[{cumulative_gold,1800000}]','[{2,36020001,70}]',0),(6020101,6,602,60201,1,'世界首领','击杀1只世界首领',6020102,0,1,1,'[{kill_princes,1}]','[{2,36020001,10}]',0),(6020102,6,602,60201,2,'世界首领','击杀6只世界首领',6020103,1,1,1,'[{kill_princes,6}]','[{2,36020001,15}]',0),(6020103,6,602,60201,2,'世界首领','击杀14只世界首领',6020104,1,1,1,'[{kill_princes,14}]','[{2,36020001,20}]',0),(6020104,6,602,60201,3,'世界首领','击杀28只世界首领',6020105,1,1,1,'[{kill_princes,28}]','[{2,36020001,25}]',0),(6020105,6,602,60201,3,'世界首领','击杀60只世界首领',6020106,1,1,1,'[{kill_princes,60}]','[{2,36020001,30}]',0),(6020106,6,602,60201,4,'世界首领','击杀120只世界首领',6020107,1,1,1,'[{kill_princes,120}]','[{2,36020001,35}]',0),(6020107,6,602,60201,4,'世界首领','击杀200只世界首领',6020108,1,1,1,'[{kill_princes,200}]','[{2,36020001,40}]',0),(6020108,6,602,60201,5,'世界首领','击杀500只世界首领',6020109,1,1,1,'[{kill_princes,500}]','[{2,36020001,60}]',0),(6020109,6,602,60201,5,'世界首领','击杀1000只世界首领',0,1,1,1,'[{kill_princes,1000}]','[{2,36020001,80}]',0),(6020201,6,602,60202,1,'荣耀战神','参与击杀1次荣耀战神',6020202,0,1,1,'[{kill_war_god,1}]','[{2,36020001,10}]',0),(6020202,6,602,60202,2,'荣耀战神','参与击杀2次荣耀战神',6020203,1,1,1,'[{kill_war_god,2}]','[{2,36020001,15}]',0),(6020203,6,602,60202,2,'荣耀战神','参与击杀5次荣耀战神',6020204,1,1,1,'[{kill_war_god,5}]','[{2,36020001,20}]',0),(6020204,6,602,60202,3,'荣耀战神','参与击杀10次荣耀战神',6020205,1,1,1,'[{kill_war_god,10}]','[{2,36020001,25}]',0),(6020205,6,602,60202,3,'荣耀战神','参与击杀20次荣耀战神',6020206,1,1,1,'[{kill_war_god,20}]','[{2,36020001,30}]',0),(6020206,6,602,60202,4,'荣耀战神','参与击杀50次荣耀战神',6020207,1,1,1,'[{kill_war_god,50}]','[{2,36020001,35}]',0),(6020207,6,602,60202,4,'荣耀战神','参与击杀80次荣耀战神',6020208,1,1,1,'[{kill_war_god,80}]','[{2,36020001,40}]',0),(6020208,6,602,60202,5,'荣耀战神','参与击杀100次荣耀战神',6020209,1,1,1,'[{kill_war_god,100}]','[{2,36020001,60}]',0),(6020209,6,602,60202,5,'荣耀战神','参与击杀200次荣耀战神',0,1,1,1,'[{kill_war_god,200}]','[{2,36020001,80}]',0),(6020301,6,602,60203,1,'首领狩猎','击杀1个首领狩猎的首领',6020302,0,1,1,'[{kill_personal_boss,1}]','[{2,36020001,10}]',0),(6020302,6,602,60203,1,'首领狩猎','击杀2个首领狩猎的首领',6020303,1,1,1,'[{kill_personal_boss,2}]','[{2,36020001,15}]',0),(6020303,6,602,60203,2,'首领狩猎','击杀10个首领狩猎的首领',6020304,1,1,1,'[{kill_personal_boss,10}]','[{2,36020001,20}]',0),(6020304,6,602,60203,2,'首领狩猎','击杀30个首领狩猎的首领',6020305,1,1,1,'[{kill_personal_boss,30}]','[{2,36020001,25}]',0),(6020305,6,602,60203,3,'首领狩猎','击杀80个首领狩猎的首领',6020306,1,1,1,'[{kill_personal_boss,80}]','[{2,36020001,30}]',0),(6020306,6,602,60203,3,'首领狩猎','击杀100个首领狩猎的首领',6020307,1,1,1,'[{kill_personal_boss,100}]','[{2,36020001,35}]',0),(6020307,6,602,60203,4,'首领狩猎','击杀250个首领狩猎的首领',6020308,1,1,1,'[{kill_personal_boss,250}]','[{2,36020001,40}]',0),(6020308,6,602,60203,4,'首领狩猎','击杀500首领狩猎的首领',6020309,1,1,1,'[{kill_personal_boss,500}]','[{2,36020001,60}]',0),(6020309,6,602,60203,5,'首领狩猎','击杀888个首领狩猎的首领',6020310,1,1,1,'[{kill_personal_boss,888}]','[{2,36020001,80}]',0),(6020310,6,602,60203,5,'首领狩猎','击杀2000个首领狩猎的首领',0,1,1,1,'[{kill_personal_boss,2000}]','[{2,36020001,100}]',0),(6020401,6,602,60204,1,'原罪祭坛','击杀5个原罪祭坛的首领',6020402,0,1,1,'[{kill_altar_boss,5}]','[{2,36020001,10}]',0),(6020402,6,602,60204,1,'原罪祭坛','击杀10个原罪祭坛的首领',6020403,1,1,1,'[{kill_altar_boss,10}]','[{2,36020001,15}]',0),(6020403,6,602,60204,2,'原罪祭坛','击杀30个原罪祭坛的首领',6020404,1,1,1,'[{kill_altar_boss,30}]','[{2,36020001,20}]',0),(6020404,6,602,60204,2,'原罪祭坛','击杀50个原罪祭坛的首领',6020405,1,1,1,'[{kill_altar_boss,50}]','[{2,36020001,25}]',0),(6020405,6,602,60204,3,'原罪祭坛','击杀100个原罪祭坛的首领',6020406,1,1,1,'[{kill_altar_boss,100}]','[{2,36020001,30}]',0),(6020406,6,602,60204,3,'原罪祭坛','击杀200个原罪祭坛的首领',6020407,1,1,1,'[{kill_altar_boss,200}]','[{2,36020001,35}]',0),(6020407,6,602,60204,4,'原罪祭坛','击杀500个原罪祭坛的首领',6020408,1,1,1,'[{kill_altar_boss,500}]','[{2,36020001,40}]',0),(6020408,6,602,60204,4,'原罪祭坛','击杀1000个原罪祭坛的首领',6020409,1,1,1,'[{kill_altar_boss,1000}]','[{2,36020001,60}]',0),(6020409,6,602,60204,5,'原罪祭坛','击杀2000个原罪祭坛的首领',6020410,1,1,1,'[{kill_altar_boss,2000}]','[{2,36020001,80}]',0),(6020410,6,602,60204,5,'原罪祭坛','击杀5000个原罪祭坛的首领',0,1,1,1,'[{kill_altar_boss,5000}]','[{2,36020001,100}]',0),(6020501,6,602,60205,1,'首领会所','击杀5个首领会所的首领',6020502,0,1,1,'[{princes_home,5}]','[{2,36020001,10}]',0),(6020502,6,602,60205,1,'首领会所','击杀10个首领会所的首领',6020503,1,1,1,'[{princes_home,10}]','[{2,36020001,15}]',0),(6020503,6,602,60205,2,'首领会所','击杀30个首领会所的首领',6020504,1,1,1,'[{princes_home,30}]','[{2,36020001,20}]',0),(6020504,6,602,60205,2,'首领会所','击杀50个首领会所的首领',6020505,1,1,1,'[{princes_home,50}]','[{2,36020001,25}]',0),(6020505,6,602,60205,3,'首领会所','击杀100个首领会所的首领',6020506,1,1,1,'[{princes_home,100}]','[{2,36020001,30}]',0),(6020506,6,602,60205,3,'首领会所','击杀200个首领会所的首领',6020507,1,1,1,'[{princes_home,200}]','[{2,36020001,35}]',0),(6020507,6,602,60205,4,'首领会所','击杀500个首领会所的首领',6020508,1,1,1,'[{princes_home,500}]','[{2,36020001,40}]',0),(6020508,6,602,60205,4,'首领会所','击杀1000个首领会所的首领',6020509,1,1,1,'[{princes_home,1000}]','[{2,36020001,60}]',0),(6020509,6,602,60205,5,'首领会所','击杀2000个首领会所的首领',6020510,1,1,1,'[{princes_home,2000}]','[{2,36020001,80}]',0),(6020510,6,602,60205,5,'首领会所','击杀5000个首领会所的首领',0,1,1,1,'[{princes_home,5000}]','[{2,36020001,100}]',0),(6020601,6,602,60206,1,'混乱魔域','击杀1个混乱魔域的首领',6020602,0,1,1,'[{chaos_moyu,1}]','[{2,36020001,10}]',0),(6020602,6,602,60206,2,'混乱魔域','击杀5个混乱魔域的首领',6020603,1,1,1,'[{chaos_moyu,5}]','[{2,36020001,15}]',0),(6020603,6,602,60206,2,'混乱魔域','击杀10个混乱魔域首领',6020604,1,1,1,'[{chaos_moyu,10}]','[{2,36020001,20}]',0),(6020604,6,602,60206,3,'混乱魔域','击杀30个混乱魔域首领',6020605,1,1,1,'[{chaos_moyu,30}]','[{2,36020001,25}]',0),(6020605,6,602,60206,3,'混乱魔域','击杀50个混乱魔域首领',6020606,1,1,1,'[{chaos_moyu,50}]','[{2,36020001,30}]',0),(6020606,6,602,60206,4,'混乱魔域','击杀100个混乱魔域首领',6020607,1,1,1,'[{chaos_moyu,100}]','[{2,36020001,35}]',0),(6020607,6,602,60206,4,'混乱魔域','击杀200个混乱魔域首领',6020608,1,1,1,'[{chaos_moyu,200}]','[{2,36020001,40}]',0),(6020608,6,602,60206,5,'混乱魔域','击杀500个混乱魔域首领',6020609,1,1,1,'[{chaos_moyu,500}]','[{2,36020001,60}]',0),(6020609,6,602,60206,5,'混乱魔域','击杀1000个混乱魔域首领',0,1,1,1,'[{chaos_moyu,1000}]','[{2,36020001,80}]',0),(6030101,6,603,60301,1,'一路同行','在线1小时',6030102,0,1,1,'[{online,1}]','[{2,36020001,10}]',0),(6030102,6,603,60301,1,'一路同行','在线10小时',6030103,1,1,1,'[{online,10}]','[{2,36020001,10}]',0),(6030103,6,603,60301,2,'一路同行','在线20小时',6030104,1,1,1,'[{online,20}]','[{2,36020001,10}]',0),(6030104,6,603,60301,2,'一路同行','在线40小时',6030105,1,1,1,'[{online,40}]','[{2,36020001,20}]',0),(6030105,6,603,60301,2,'一路同行','在线80小时',6030106,1,1,1,'[{online,80}]','[{2,36020001,20}]',0),(6030106,6,603,60301,3,'一路同行','在线150小时',6030107,1,1,1,'[{online,150}]','[{2,36020001,20}]',0),(6030107,6,603,60301,3,'一路同行','在线300小时',6030108,1,1,1,'[{online,300}]','[{2,36020001,30}]',0),(6030108,6,603,60301,3,'一路同行','在线500小时',6030109,1,1,1,'[{online,500}]','[{2,36020001,30}]',0),(6030109,6,603,60301,4,'一路同行','在线800小时',6030110,1,1,1,'[{online,800}]','[{2,36020001,40}]',0),(6030110,6,603,60301,4,'一路同行','在线1200小时',6030111,1,1,1,'[{online,1200}]','[{2,36020001,40}]',0),(6030111,6,603,60301,4,'一路同行','在线1600小时',6030112,1,1,1,'[{online,1600}]','[{2,36020001,40}]',0),(6030112,6,603,60301,5,'一路同行','在线2000小时',6030113,1,1,1,'[{online,2000}]','[{2,36020001,50}]',0),(6030113,6,603,60301,5,'一路同行','在线3000小时',6030114,1,1,1,'[{online,3000}]','[{2,36020001,60}]',0),(6030114,6,603,60301,5,'一路同行','在线5000小时',0,1,1,1,'[{online,5000}]','[{2,36020001,80}]',0);
/*!40000 ALTER TABLE `base_achievement` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_achievement_category`
--

DROP TABLE IF EXISTS `base_achievement_category`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_achievement_category` (
  `category` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '成就大类',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '名称@lang@',
  PRIMARY KEY (`category`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='成就标签页配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_achievement_category`
--

LOCK TABLES `base_achievement_category` WRITE;
/*!40000 ALTER TABLE `base_achievement_category` DISABLE KEYS */;
INSERT INTO `base_achievement_category` VALUES (1,'个人成长'),(2,'伙伴培养'),(3,'装备打造'),(4,'活动日常'),(5,'社交关系'),(6,'精彩历程');
/*!40000 ALTER TABLE `base_achievement_category` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_achievement_star_reward`
--

DROP TABLE IF EXISTS `base_achievement_star_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_achievement_star_reward` (
  `star` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '总星数',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '名字@lang@',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '描述@lang@',
  `reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `designation` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '称号奖励',
  PRIMARY KEY (`star`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='成就星级奖励';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_achievement_star_reward`
--

LOCK TABLES `base_achievement_star_reward` WRITE;
/*!40000 ALTER TABLE `base_achievement_star_reward` DISABLE KEYS */;
INSERT INTO `base_achievement_star_reward` VALUES (30,'初心者','成就总星级达到30星','[{3,36020001,30}]',0),(60,'初心者','成就总星级达到60星','[{0,12010005,1}]',0),(90,'初级士兵','成就总星级达到90星','[{3,36020001,40}]',0),(120,'初级士兵','成就总星级达到120星','[{0,12020005,1}]',4903001),(150,'中级士兵','成就总星级达到150星','[{3,36020001,50}]',0),(180,'中级士兵','成就总星级达到180星','[{0,12030005,1}]',0),(210,'高级士兵','成就总星级达到210星','[{3,36020001,60}]',4903002),(240,'高级士兵','成就总星级达到240星','[{0,12040005,1}]',0),(270,'骑士学徒','成就总星级达到270星','[{3,36020001,70}]',0),(300,'初级骑士','成就总星级达到300星','[{0,12010005,1}]',4903003),(330,'中级骑士','成就总星级达到330星','[{3,36020001,80}]',0),(360,'高级骑士','成就总星级达到360星','[{0,12020005,1}]',0),(390,'荣誉骑士','成就总星级达到390星','[{0,12030005,1}]',0),(420,'神圣骑士','成就总星级达到420星','[{0,12040005,1}]',4903004);
/*!40000 ALTER TABLE `base_achievement_star_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_achievement_sub_category`
--

DROP TABLE IF EXISTS `base_achievement_sub_category`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_achievement_sub_category` (
  `sub_category` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '成就小类',
  `category` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '成就大类',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '名称@lang@',
  PRIMARY KEY (`sub_category`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='成就子标签配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_achievement_sub_category`
--

LOCK TABLES `base_achievement_sub_category` WRITE;
/*!40000 ALTER TABLE `base_achievement_sub_category` DISABLE KEYS */;
INSERT INTO `base_achievement_sub_category` VALUES (101,1,'人物'),(102,1,'神器'),(201,2,'星灵'),(202,2,'坐骑'),(203,2,'圣灵'),(204,2,'降神'),(301,3,'装备'),(302,3,'宝石'),(401,4,'日常'),(402,4,'活动'),(501,5,'公会'),(502,5,'交友'),(503,5,'PK'),(601,6,'财富'),(602,6,'首领'),(603,6,'时光');
/*!40000 ALTER TABLE `base_achievement_sub_category` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_achievement_type`
--

DROP TABLE IF EXISTS `base_achievement_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_achievement_type` (
  `type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `category` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '成就大类',
  `sub_category` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '成就小类',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '名称@lang@',
  PRIMARY KEY (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='成就类型配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_achievement_type`
--

LOCK TABLES `base_achievement_type` WRITE;
/*!40000 ALTER TABLE `base_achievement_type` DISABLE KEYS */;
INSERT INTO `base_achievement_type` VALUES (10101,1,101,'升级达人'),(10102,1,101,'巅峰境界'),(10103,1,101,'角色转职'),(10201,1,102,'宝具升级'),(10202,1,102,'翅膀升级'),(10203,1,102,'神格晋升'),(20101,2,201,'星灵收集'),(20102,2,201,'星灵进阶Ⅰ'),(20103,2,201,'星灵进阶Ⅱ'),(20104,2,201,'星灵进阶Ⅲ'),(20105,2,201,'星灵进阶Ⅳ'),(20106,2,201,'星灵星级'),(20201,2,202,'坐骑进阶'),(20202,2,202,'坐骑幻化'),(20203,2,202,'坐骑装备'),(20301,2,203,'圣灵收集'),(20302,2,203,'暴怒之火'),(20303,2,203,'温润之水'),(20304,2,203,'摄魂行者'),(20305,2,203,'圣器收集'),(20401,2,204,'光辉神'),(20402,2,204,'冰雪女王'),(20403,2,204,'月神'),(20404,2,204,'符文强化'),(20405,2,204,'符文印记'),(20406,2,204,'火神之炎'),(20407,2,204,'生命之护'),(20408,2,204,'众神之怒'),(20409,2,204,'雷神之罚'),(30101,3,301,'全副武装'),(30102,3,301,'究极武装'),(30103,3,301,'修罗套装'),(30104,3,301,'霸者套装'),(30105,3,301,'战神套装'),(30106,3,301,'泰坦套装'),(30107,3,301,'装备洗炼'),(30108,3,301,'装备强化'),(30201,3,302,'宝石数量'),(30202,3,302,'宝石等级'),(40101,4,401,'签到次数'),(40201,4,402,'巅峰竞技'),(40202,4,402,'博学之冠'),(40203,4,402,'荆棘战神'),(40204,4,402,'竞技排名'),(40205,4,402,'魅力海滩'),(40206,4,402,'屡败屡战'),(50101,5,501,'公会之星'),(50102,5,501,'胜利之师'),(50103,5,501,'晚宴狂欢'),(50104,5,501,'公会红包'),(50105,5,501,'公会任务'),(50106,5,501,'公会一员'),(50201,5,502,'你好世界'),(50202,5,502,'交友广泛'),(50203,5,502,'花香满身'),(50204,5,502,'浪漫婚礼'),(50205,5,502,'懒得理你'),(50301,5,503,'我是杀手'),(50302,5,503,'百战不殆'),(50303,5,503,'罪恶克星'),(50304,5,503,'做个好人'),(60101,6,601,'定个目标'),(60102,6,601,'钻石大亨'),(60201,6,602,'世界首领'),(60202,6,602,'荣耀战神'),(60203,6,602,'首领狩猎'),(60204,6,602,'原罪祭坛'),(60205,6,602,'首领会所'),(60206,6,602,'混乱魔域'),(60301,6,603,'一路同行');
/*!40000 ALTER TABLE `base_achievement_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_act_boss_constant`
--

DROP TABLE IF EXISTS `base_act_boss_constant`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_act_boss_constant` (
  `id` int(10) unsigned NOT NULL COMMENT 'id',
  `value` varchar(255) NOT NULL COMMENT '值',
  `remark` varchar(255) NOT NULL COMMENT '备注',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='活动boss-常量表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_act_boss_constant`
--

LOCK TABLES `base_act_boss_constant` WRITE;
/*!40000 ALTER TABLE `base_act_boss_constant` DISABLE KEYS */;
/*!40000 ALTER TABLE `base_act_boss_constant` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_act_boss_refresh`
--

DROP TABLE IF EXISTS `base_act_boss_refresh`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_act_boss_refresh` (
  `mon_type` int(10) unsigned NOT NULL COMMENT '怪物类型',
  `scene_id` int(10) unsigned NOT NULL COMMENT '场景id',
  `location` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '刷新坐标',
  PRIMARY KEY (`mon_type`,`scene_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='活动boss-怪物刷新表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_act_boss_refresh`
--

LOCK TABLES `base_act_boss_refresh` WRITE;
/*!40000 ALTER TABLE `base_act_boss_refresh` DISABLE KEYS */;
INSERT INTO `base_act_boss_refresh` VALUES (1,1005,'[{10893,3314},{8248,4593},{5960,7263},{4741,9196},{4505,11374},{8864,15471},{10638,10964},{11940,9191},{20609,7814},{17171,8302}]'),(1,1006,'[{17569,7661},{16478,8237},{14641,7326},{12189,6166},{13034,3266},{10388,11735},{5973,12881},{4571,14705},{2765,15505},{7008,8570}]'),(1,1007,'[{18365,8383},{14451,6115},{13139,5286},{10273,6861},{8648,7749},{3812,5201},{4888,3939},{12227,8492},{12901,10978},{9293,10205}]'),(1,1008,'[{10983,2554},{10721,3802},{14985,4902},{12714,5812},{19036,10688},{11410,13657},{9390,16124},{4222,13222},{2932,2453},{11679,8310}]'),(2,1005,'[{11056,3383},{10917,3902},{9620,4350},{8344,4617},{7599,5090},{6643,6125},{5995,7104},{4974,8112},{3859,9921},{4462,11316},{5332,12191},{6487,14444},{8595,15168},{9311,15552},{9514,13410},{10703,11397},{11617,9807},{12956,9085},{17517,8247},{18731,7057}]'),(2,1006,'[{17417,7039},{16830,8229},{15517,8176},{13612,8683},{14576,7207},{12821,5887},{11816,6903},{7322,8916},{8580,10749},{6155,12495},{5315,13450},{4214,15382},{3120,15802},{4343,16229},{10346,11685},{9461,10101},{6649,8236},{10147,8630},{13081,3392},{12056,6224}]'),(2,1007,'[{16895,8273},{17300,7221},{14451,6303},{12504,5456},{13336,7310},{12331,8232},{10514,6801},{8542,7695},{4923,4825},{3820,5171},{4754,3765},{13088,10703},{14075,11200},{10665,10130},{9194,10130},{5951,10623},{4280,11322},{8424,10410},{14511,10503},{14008,9896}]'),(2,1008,'[{10470,3018},{11083,3439},{11208,4364},{12562,5564},{13990,3905},{15350,5158},{17027,7764},{17978,8950},{18843,10747},{16532,11435},{15186,10335},{12043,12284},{10670,13498},{9549,15538},{7088,11438},{5980,11159},{9220,9976},{9796,9369},{7103,7943},{2667,3089}]');
/*!40000 ALTER TABLE `base_act_boss_refresh` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_activity_liveness`
--

DROP TABLE IF EXISTS `base_activity_liveness`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_activity_liveness` (
  `module` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `module_sub` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '子功能ID',
  `act_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '活动类型：1-非限时活动；2-限时活动',
  `name` varchar(1024) NOT NULL COMMENT '名称@lang@',
  `start_lv` int(11) NOT NULL DEFAULT '0' COMMENT '开始等级',
  `end_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消失等级',
  `max` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '单项活动获得活跃度的总次数',
  `res_max` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '可找回的次数上限',
  PRIMARY KEY (`module`,`module_sub`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='活跃度配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_activity_liveness`
--

LOCK TABLES `base_activity_liveness` WRITE;
/*!40000 ALTER TABLE `base_activity_liveness` DISABLE KEYS */;
INSERT INTO `base_activity_liveness` VALUES (132,0,1,'野外挂机',125,9999,0,0),(137,0,2,'钻石大战',340,9999,1,0),(152,1,1,'每日强化',65,300,5,0),(174,0,2,'智慧达人',110,9999,1,1),(221,1,1,'每日点赞',120,9999,1,0),(280,0,1,'竞技场',115,9999,10,10),(281,0,2,'巅峰竞技',115,9999,10,1),(300,6,1,'公会任务',150,9999,10,10),(300,7,1,'日常任务',55,9999,20,20),(402,3,2,'守卫公会',150,9999,1,1),(402,4,2,'公会争霸',150,9999,1,1),(403,0,2,'公会晚宴',150,9999,1,1),(418,0,2,'魅力海滩',110,9999,1,1),(429,0,2,'捕蝶',115,9999,1,1),(436,0,2,'星灵争霸',420,9999,1,0),(460,4,1,'混乱魔域',240,9999,2,0),(460,5,1,'首领遗迹',95,9999,3,3),(461,0,1,'时空乱流',335,9999,3,0),(500,0,1,'飞艇护送',130,9999,3,3),(500,1,2,'双倍护送',130,9999,3,3),(604,0,2,'三英会战',140,9999,1,0),(606,0,2,'大乱斗',140,9999,1,1),(607,0,2,'跨服城战',350,9999,1,1),(609,1,2,'限时boss',440,9999,1,0),(610,4,1,'经验宝库',75,9999,2,2),(610,5,1,'装备副本',105,9999,2,2),(610,18,1,'星灵副本',85,9999,2,1),(610,20,1,'魂珠副本',70,9999,1,0),(621,0,2,'跨服1VN',360,9999,1,1),(650,1,2,'跨服3V3',270,9999,1,1);
/*!40000 ALTER TABLE `base_activity_liveness` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_activity_power_live`
--

DROP TABLE IF EXISTS `base_activity_power_live`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_activity_power_live` (
  `id` int(11) NOT NULL DEFAULT '0' COMMENT '序号',
  `module` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `sub_module` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '子功能id',
  `min_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最低等级',
  `max_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最高等级',
  `live` int(11) NOT NULL DEFAULT '0' COMMENT '活跃度',
  `power_live` int(11) NOT NULL DEFAULT '0' COMMENT '活力',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_activity_power_live`
--

LOCK TABLES `base_activity_power_live` WRITE;
/*!40000 ALTER TABLE `base_activity_power_live` DISABLE KEYS */;
INSERT INTO `base_activity_power_live` VALUES (1,132,0,1,1000,0,0),(2,137,0,1,1000,20,0),(3,152,1,1,250,3,0),(4,152,1,251,1000,0,0),(5,174,0,1,1000,15,0),(6,280,0,1,1000,1,5),(7,281,0,1,1000,2,0),(8,300,6,1,1000,1,10),(9,300,7,1,1000,1,5),(10,402,3,1,1000,20,0),(11,402,4,1,1000,20,0),(12,403,0,1,1000,20,0),(13,418,0,1,1000,15,0),(14,429,0,1,1000,15,0),(15,436,0,1,1000,20,0),(16,460,4,1,370,0,0),(17,460,4,371,500,10,0),(18,460,4,501,1000,0,0),(19,460,5,1,1000,10,25),(20,461,0,1,1000,8,0),(21,500,0,1,1000,5,25),(22,500,1,1,1000,0,0),(23,605,0,1,1000,10,0),(24,606,0,1,1000,20,0),(25,607,0,1,1000,20,0),(26,609,1,1,1000,0,0),(27,610,4,1,1000,5,50),(28,610,5,1,1000,5,25),(29,610,13,1,1000,0,25),(30,610,20,1,1000,0,25),(31,610,18,1,1000,5,25),(32,610,19,1,1000,0,25),(33,610,21,1,1000,0,25),(34,610,22,1,1000,0,25),(35,610,12,1,1000,0,25),(36,621,0,1,1000,20,0),(37,650,1,1,1000,20,0),(38,221,1,1,1000,3,15),(39,604,0,1,1000,20,0);
/*!40000 ALTER TABLE `base_activity_power_live` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_activity_power_live_limit`
--

DROP TABLE IF EXISTS `base_activity_power_live_limit`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_activity_power_live_limit` (
  `min_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级下限',
  `max_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级上限',
  `limit` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活力上限',
  PRIMARY KEY (`min_lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_activity_power_live_limit`
--

LOCK TABLES `base_activity_power_live_limit` WRITE;
/*!40000 ALTER TABLE `base_activity_power_live_limit` DISABLE KEYS */;
INSERT INTO `base_activity_power_live_limit` VALUES (1,1000,1500);
/*!40000 ALTER TABLE `base_activity_power_live_limit` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_activity_push`
--

DROP TABLE IF EXISTS `base_activity_push`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_activity_push` (
  `module` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能ID',
  `module_sub` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '子功能ID',
  `push` int(1) unsigned NOT NULL DEFAULT '0' COMMENT '活动推送',
  `push_msg` varchar(1024) NOT NULL COMMENT '推送消息@lang@',
  PRIMARY KEY (`module`,`module_sub`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='活动推送配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_activity_push`
--

LOCK TABLES `base_activity_push` WRITE;
/*!40000 ALTER TABLE `base_activity_push` DISABLE KEYS */;
INSERT INTO `base_activity_push` VALUES (155,0,0,'夺旗战场还有5分钟开始'),(646,0,0,'野外领主还有5分钟开始');
/*!40000 ALTER TABLE `base_activity_push` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_activity_reward`
--

DROP TABLE IF EXISTS `base_activity_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_activity_reward` (
  `sort` int(11) NOT NULL DEFAULT '0' COMMENT '序号',
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'ID',
  `min_lv` int(11) NOT NULL DEFAULT '0' COMMENT '玩家等级下限',
  `max_lv` int(11) NOT NULL DEFAULT '0' COMMENT '玩家等级上限',
  `live` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活跃度',
  `reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`sort`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='活跃度奖励';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_activity_reward`
--

LOCK TABLES `base_activity_reward` WRITE;
/*!40000 ALTER TABLE `base_activity_reward` DISABLE KEYS */;
INSERT INTO `base_activity_reward` VALUES (1,1,1,1000,30,'[{0,38040010,1}]'),(2,2,1,1000,60,'[{0,38070001,1}]'),(3,3,1,1000,90,'[{0,38330002,2}]'),(4,4,1,1000,120,'[{0,38070002,1}]'),(5,5,1,1000,150,'[{2,36020001,50}]');
/*!40000 ALTER TABLE `base_activity_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_adventure_book`
--

DROP TABLE IF EXISTS `base_adventure_book`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_adventure_book` (
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `subtype` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '子类型',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '名字',
  `title` varchar(50) NOT NULL DEFAULT '' COMMENT '标题',
  `desc` varchar(1024) NOT NULL DEFAULT '' COMMENT '描述',
  `icon` varchar(255) NOT NULL DEFAULT '' COMMENT '图标',
  `picture` varchar(255) NOT NULL DEFAULT '' COMMENT '插图',
  `unlock_condition` varchar(255) NOT NULL DEFAULT '[]' COMMENT '解锁条件',
  `active_condition` varchar(255) NOT NULL DEFAULT '[]' COMMENT '激活条件',
  `attr` varchar(255) NOT NULL DEFAULT '' COMMENT '激活属性',
  `reward_name` varchar(255) NOT NULL COMMENT '奖励名称',
  `active_reward` varchar(512) NOT NULL DEFAULT '[]' COMMENT '激活奖励',
  `reward` varchar(255) NOT NULL COMMENT '奖励内容',
  `skill_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT ' 技能列表',
  PRIMARY KEY (`type`,`subtype`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='冒险之书';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_adventure_book`
--

LOCK TABLES `base_adventure_book` WRITE;
/*!40000 ALTER TABLE `base_adventure_book` DISABLE KEYS */;
INSERT INTO `base_adventure_book` VALUES (1,1,'朔月海岸','海岛奇遇','劫后余生的你，被自称是抵抗军的组织所救，原来他们也在寻找陨落在各地的星辰之力，虽然他们盛意邀请你加入其阵营，不过在这陌生的地方，一切都要谨慎为妙，当务之急是找到唤醒萌羊座的方法！','bigicon_1_1','0','[]','[{chapter_task,1}]','[{2,500},{1,25}]','小行星称号','[{0,4904001,1}]','[{6,4904001}]','[]'),(1,2,'抵抗军营','恶魔侵袭','沉浸在战胜强大降神的你，缓过神来才发现自己的双手颤抖不已，那是一种对强大力量的敬畏吗？还是恐惧呢？降神托付给自己的力量，是否能够合理运用呢？','bigicon_1_2','0','[{book,1,1}]','[{chapter_task,2}]','[{1,40},{6,25}]','青钢宝具石','[{0,24020002,1}]','[{7,16010003}]','[]'),(1,3,'迷雾沼泽','凶险之地','亲眼见证了抵抗军的大本营后，你正式成为了其中的一员，为了对抗野心膨胀的帝国军，抵抗军正在四处谋求联合，首要目标就是洛亚王城。不过在那之前，我们必须平安无事地穿过这片迷雾沼泽，危机四伏的凶险之地！','bigicon_1_3','0','[{book,1,2}]','[{chapter_task,3}]','[{2,800},{1,40},{7,10},{8,10}]','暗星云称号','[{0,4904002,1}]','[{6,4904002}]','[]'),(1,4,'洛亚王城','结盟请求','宏伟繁盛的王城，热情好客的人们，这里是聚集各国贸易的港口城市，是大陆腹地最为繁盛的势力，洛亚王城！','bigicon_1_4','168','[{book,1,3}]','[{chapter_task,4}]','[{2,1500},{1,75},{61,50},{60,50}]','瑟银宝具石','[{0,24020003,1}]','[{7,24020004}]','[]'),(1,5,'蘑菇林','森林奇遇','童话般的森林，各式奇异的动物、植物，宛如仙境一般的地方，很难相信暗裔层级把这里烧成灰烬，大自然的生命力真是顽强。不过，作为外乡人的我们，貌似不太受欢迎的样子~','bigicon_1_5','0','[{book,1,4}]','[{chapter_task,5}]','[{2,1500},{1,75},{7,20},{8,20}]','原恒星称号','[{0,4904003,1}]','[{6,4904003}]','[]'),(1,6,'森林神殿','精灵女王','在我们的四处奔波和真诚努力之下，精灵各族终于摒弃前嫌，达成一致，共同抗击帝国军势力！距离完全的统一战线又更近了一步，战胜帝国军的胜算又多了一分！','bigicon_1_6','0','[{book,1,5}]','[{chapter_task,6}]','[{2,2000},{1,100},{7,40},{8,40}]','主序星称号','[{0,4904004,1}]','[{6,4904004}]','[]'),(1,7,'寒鸦峡谷','冰原狂兽','寒鸦峡谷，极寒之地，传说冰龙与泰坦在此进行了一场旷世决战，冰龙用尽全力吐出寒冰气息，遍及之处都被冻结，就连这里的气候也被永久影响……而愤怒的泰坦因此拧下了冰龙的头颅，数万年过去，这里依旧能够看见史前的战斗痕迹！','bigicon_1_1','0','[{book,1,6}]','[{chapter_task,7}]','[{2,3000},{1,150},{5,60},{6,60}]','超巨星称号','[{0,4904005,1}]','[{6,4904005}]','[]'),(1,8,'风蚀台地','覆灭王朝','风沙漫天，断壁残垣，你可能想象不到这里曾是土地肥沃，人口繁盛的绿洲王朝。然而人的贪欲会让其做出想要成为神的举动，永生，一个触犯生死戒律的追求，在末代法老的疯狂暴行之下，王朝根基尽数崩塌，枯竭的大源命脉顷刻间就将这个繁盛的王朝毁于一旦……','bigicon_1_2','0','[{book,1,7}]','[{chapter_task,8}]','[{2,5000},{1,250},{5,80},{6,80}]','辉耀星称号','[{0,4904006,1}]','[{6,4904006}]','[]'),(1,9,'暗裔秘所','深入腹地','抵抗军的规模已足够巨大，抵抗军开始筹划下一步的行动，他们计划搞清楚帝国军的暗裔研究，并且试图破坏研究暗裔的设施，在机械师安娜和情报员露易丝的帮助下，抵抗军深入帝国军的腹地，准备制止邪恶的暗裔研究！','bigicon_1_3','0','[{book,1,8}]','[{chapter_task,9}]','[{2,6000},{1,300},{3,200},{4,200}]','超新星称号','[{0,4904007,1}]','[{6,4904007}]','[]');
/*!40000 ALTER TABLE `base_adventure_book` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_adventure_book_type`
--

DROP TABLE IF EXISTS `base_adventure_book_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_adventure_book_type` (
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '名字',
  PRIMARY KEY (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='冒险之书类型';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_adventure_book_type`
--

LOCK TABLES `base_adventure_book_type` WRITE;
/*!40000 ALTER TABLE `base_adventure_book_type` DISABLE KEYS */;
INSERT INTO `base_adventure_book_type` VALUES (1,'地图志');
/*!40000 ALTER TABLE `base_adventure_book_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_ai`
--

DROP TABLE IF EXISTS `base_ai`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_ai` (
  `type` int(11) unsigned NOT NULL COMMENT '类型',
  `mon_id` int(10) unsigned NOT NULL COMMENT '怪物ID',
  `param` varchar(255) NOT NULL COMMENT '参数，多个需要分隔',
  `ai` text NOT NULL COMMENT '1.发送传闻 AI类型:cw 参数:  [传闻类型(1世界,2场景), <<"文字内容">>]  2.怪物说话 AI类型:msg 参数:  [怪物id, <<"文字内容">>]  3.创建怪物 AI类型 create_mon 参数:  [怪物id,最小x坐标,最大x坐标,最小y坐标,最大y坐标,是否主动,高阶参数]',
  `remark` varchar(255) NOT NULL COMMENT '描述',
  PRIMARY KEY (`mon_id`,`type`,`param`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='AI配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_ai`
--

LOCK TABLES `base_ai` WRITE;
/*!40000 ALTER TABLE `base_ai` DISABLE KEYS */;
INSERT INTO `base_ai` VALUES (0,2,'0','{nochange,0,0}',''),(2,2,'0','{nochange,0,cycle}',''),(5,2,'0','{nochange,0,3000},{ac_skill,[{1110000002, 1}],0},{nochange,0,cycle}',''),(0,600001,'0','{path,[[{60000,5792,8226},{60000,5779,8015},{60000,5785,7774},{60000,5787,7564},{60000,5793,7356},{60000,5790,7160},{60000,5804,6956},{60000,5801,6743},{60000,5808,6524},{60000,5823,6291},{60000,5834,6074},{60000,5845,5837},{60000,5856,5584},{60000,5876,5353},{60000,5905,5129},{60000,5930,4895},{60000,5970,4678},{60000,6018,4492},{60000,6097,4291}],0],0}',''),(0,600002,'0','{path,[[{60000,9277,6984},{60000,9129,6853},{60000,9006,6720},{60000,8890,6604},{60000,8752,6469},{60000,8616,6341},{60000,8473,6223},{60000,8347,6077},{60000,8218,5942},{60000,8098,5794},{60000,7959,5658},{60000,7835,5529},{60000,7694,5405},{60000,7559,5264},{60000,7428,5133},{60000,7300,5003},{60000,7166,4884},{60000,7016,4772},{60000,6874,4643},{60000,6714,4501},{60000,6569,4362},{60000,6442,4229}],0],0}',''),(0,600003,'0','{path,[[{60000,10292,3459},{60000,10088,3445},{60000,9889,3439},{60000,9705,3440},{60000,9495,3439},{60000,9282,3435},{60000,9068,3423},{60000,8834,3425},{60000,8619,3426},{60000,8410,3432},{60000,8195,3460},{60000,8007,3486},{60000,7799,3522},{60000,7581,3563},{60000,7362,3603},{60000,7157,3630},{60000,6965,3677},{60000,6786,3731},{60000,6606,3794},{60000,6446,3885}],0],0}',''),(0,600004,'0','{path,[[{60000,5792,8226},{60000,5779,8015},{60000,5785,7774},{60000,5787,7564},{60000,5793,7356},{60000,5790,7160},{60000,5804,6956},{60000,5801,6743},{60000,5808,6524},{60000,5823,6291},{60000,5834,6074},{60000,5845,5837},{60000,5856,5584},{60000,5876,5353},{60000,5905,5129},{60000,5930,4895},{60000,5970,4678},{60000,6018,4492},{60000,6097,4291}],0],0}',''),(0,600005,'0','{path,[[{60000,9277,6984},{60000,9129,6853},{60000,9006,6720},{60000,8890,6604},{60000,8752,6469},{60000,8616,6341},{60000,8473,6223},{60000,8347,6077},{60000,8218,5942},{60000,8098,5794},{60000,7959,5658},{60000,7835,5529},{60000,7694,5405},{60000,7559,5264},{60000,7428,5133},{60000,7300,5003},{60000,7166,4884},{60000,7016,4772},{60000,6874,4643},{60000,6714,4501},{60000,6569,4362},{60000,6442,4229}],0],0}',''),(0,600006,'0','{path,[[{60000,10292,3459},{60000,10088,3445},{60000,9889,3439},{60000,9705,3440},{60000,9495,3439},{60000,9282,3435},{60000,9068,3423},{60000,8834,3425},{60000,8619,3426},{60000,8410,3432},{60000,8195,3460},{60000,8007,3486},{60000,7799,3522},{60000,7581,3563},{60000,7362,3603},{60000,7157,3630},{60000,6965,3677},{60000,6786,3731},{60000,6606,3794},{60000,6446,3885}],0],0}',''),(0,600007,'0','{path,[[{60000,5792,8226},{60000,5779,8015},{60000,5785,7774},{60000,5787,7564},{60000,5793,7356},{60000,5790,7160},{60000,5804,6956},{60000,5801,6743},{60000,5808,6524},{60000,5823,6291},{60000,5834,6074},{60000,5845,5837},{60000,5856,5584},{60000,5876,5353},{60000,5905,5129},{60000,5930,4895},{60000,5970,4678},{60000,6018,4492},{60000,6097,4291}],0],0}',''),(0,600008,'0','{path,[[{60000,9277,6984},{60000,9129,6853},{60000,9006,6720},{60000,8890,6604},{60000,8752,6469},{60000,8616,6341},{60000,8473,6223},{60000,8347,6077},{60000,8218,5942},{60000,8098,5794},{60000,7959,5658},{60000,7835,5529},{60000,7694,5405},{60000,7559,5264},{60000,7428,5133},{60000,7300,5003},{60000,7166,4884},{60000,7016,4772},{60000,6874,4643},{60000,6714,4501},{60000,6569,4362},{60000,6442,4229}],0],0}',''),(0,600009,'0','{path,[[{60000,10292,3459},{60000,10088,3445},{60000,9889,3439},{60000,9705,3440},{60000,9495,3439},{60000,9282,3435},{60000,9068,3423},{60000,8834,3425},{60000,8619,3426},{60000,8410,3432},{60000,8195,3460},{60000,8007,3486},{60000,7799,3522},{60000,7581,3563},{60000,7362,3603},{60000,7157,3630},{60000,6965,3677},{60000,6786,3731},{60000,6606,3794},{60000,6446,3885}],0],0}',''),(0,600010,'0','{path,[[{60000,5792,8226},{60000,5779,8015},{60000,5785,7774},{60000,5787,7564},{60000,5793,7356},{60000,5790,7160},{60000,5804,6956},{60000,5801,6743},{60000,5808,6524},{60000,5823,6291},{60000,5834,6074},{60000,5845,5837},{60000,5856,5584},{60000,5876,5353},{60000,5905,5129},{60000,5930,4895},{60000,5970,4678},{60000,6018,4492},{60000,6097,4291}],0],0}',''),(0,600011,'0','{path,[[{60000,9277,6984},{60000,9129,6853},{60000,9006,6720},{60000,8890,6604},{60000,8752,6469},{60000,8616,6341},{60000,8473,6223},{60000,8347,6077},{60000,8218,5942},{60000,8098,5794},{60000,7959,5658},{60000,7835,5529},{60000,7694,5405},{60000,7559,5264},{60000,7428,5133},{60000,7300,5003},{60000,7166,4884},{60000,7016,4772},{60000,6874,4643},{60000,6714,4501},{60000,6569,4362},{60000,6442,4229}],0],0}',''),(0,600012,'0','{path,[[{60000,10292,3459},{60000,10088,3445},{60000,9889,3439},{60000,9705,3440},{60000,9495,3439},{60000,9282,3435},{60000,9068,3423},{60000,8834,3425},{60000,8619,3426},{60000,8410,3432},{60000,8195,3460},{60000,8007,3486},{60000,7799,3522},{60000,7581,3563},{60000,7362,3603},{60000,7157,3630},{60000,6965,3677},{60000,6786,3731},{60000,6606,3794},{60000,6446,3885}],0],0}',''),(0,600013,'0','{path,[[{60000,5792,8226},{60000,5779,8015},{60000,5785,7774},{60000,5787,7564},{60000,5793,7356},{60000,5790,7160},{60000,5804,6956},{60000,5801,6743},{60000,5808,6524},{60000,5823,6291},{60000,5834,6074},{60000,5845,5837},{60000,5856,5584},{60000,5876,5353},{60000,5905,5129},{60000,5930,4895},{60000,5970,4678},{60000,6018,4492},{60000,6097,4291}],0],0}',''),(0,600014,'0','{path,[[{60000,9277,6984},{60000,9129,6853},{60000,9006,6720},{60000,8890,6604},{60000,8752,6469},{60000,8616,6341},{60000,8473,6223},{60000,8347,6077},{60000,8218,5942},{60000,8098,5794},{60000,7959,5658},{60000,7835,5529},{60000,7694,5405},{60000,7559,5264},{60000,7428,5133},{60000,7300,5003},{60000,7166,4884},{60000,7016,4772},{60000,6874,4643},{60000,6714,4501},{60000,6569,4362},{60000,6442,4229}],0],0}',''),(0,600015,'0','{path,[[{60000,10292,3459},{60000,10088,3445},{60000,9889,3439},{60000,9705,3440},{60000,9495,3439},{60000,9282,3435},{60000,9068,3423},{60000,8834,3425},{60000,8619,3426},{60000,8410,3432},{60000,8195,3460},{60000,8007,3486},{60000,7799,3522},{60000,7581,3563},{60000,7362,3603},{60000,7157,3630},{60000,6965,3677},{60000,6786,3731},{60000,6606,3794},{60000,6446,3885}],0],0}',''),(0,600016,'0','{path,[[{60000,5792,8226},{60000,5779,8015},{60000,5785,7774},{60000,5787,7564},{60000,5793,7356},{60000,5790,7160},{60000,5804,6956},{60000,5801,6743},{60000,5808,6524},{60000,5823,6291},{60000,5834,6074},{60000,5845,5837},{60000,5856,5584},{60000,5876,5353},{60000,5905,5129},{60000,5930,4895},{60000,5970,4678},{60000,6018,4492},{60000,6097,4291}],0],0}',''),(0,600017,'0','{path,[[{60000,9277,6984},{60000,9129,6853},{60000,9006,6720},{60000,8890,6604},{60000,8752,6469},{60000,8616,6341},{60000,8473,6223},{60000,8347,6077},{60000,8218,5942},{60000,8098,5794},{60000,7959,5658},{60000,7835,5529},{60000,7694,5405},{60000,7559,5264},{60000,7428,5133},{60000,7300,5003},{60000,7166,4884},{60000,7016,4772},{60000,6874,4643},{60000,6714,4501},{60000,6569,4362},{60000,6442,4229}],0],0}',''),(0,600018,'0','{path,[[{60000,10292,3459},{60000,10088,3445},{60000,9889,3439},{60000,9705,3440},{60000,9495,3439},{60000,9282,3435},{60000,9068,3423},{60000,8834,3425},{60000,8619,3426},{60000,8410,3432},{60000,8195,3460},{60000,8007,3486},{60000,7799,3522},{60000,7581,3563},{60000,7362,3603},{60000,7157,3630},{60000,6965,3677},{60000,6786,3731},{60000,6606,3794},{60000,6446,3885}],0],0}',''),(0,600021,'0','{path,[[{60000,5792,8226},{60000,5779,8015},{60000,5785,7774},{60000,5787,7564},{60000,5793,7356},{60000,5790,7160},{60000,5804,6956},{60000,5801,6743},{60000,5808,6524},{60000,5823,6291},{60000,5834,6074},{60000,5845,5837},{60000,5856,5584},{60000,5876,5353},{60000,5905,5129},{60000,5930,4895},{60000,5970,4678},{60000,6018,4492},{60000,6097,4291}],0],0}',''),(0,600022,'0','{path,[[{60000,9277,6984},{60000,9129,6853},{60000,9006,6720},{60000,8890,6604},{60000,8752,6469},{60000,8616,6341},{60000,8473,6223},{60000,8347,6077},{60000,8218,5942},{60000,8098,5794},{60000,7959,5658},{60000,7835,5529},{60000,7694,5405},{60000,7559,5264},{60000,7428,5133},{60000,7300,5003},{60000,7166,4884},{60000,7016,4772},{60000,6874,4643},{60000,6714,4501},{60000,6569,4362},{60000,6442,4229}],0],0}',''),(0,600023,'0','{path,[[{60000,10292,3459},{60000,10088,3445},{60000,9889,3439},{60000,9705,3440},{60000,9495,3439},{60000,9282,3435},{60000,9068,3423},{60000,8834,3425},{60000,8619,3426},{60000,8410,3432},{60000,8195,3460},{60000,8007,3486},{60000,7799,3522},{60000,7581,3563},{60000,7362,3603},{60000,7157,3630},{60000,6965,3677},{60000,6786,3731},{60000,6606,3794},{60000,6446,3885}],0],0}',''),(0,600024,'0','{path,[[{60000,5792,8226},{60000,5779,8015},{60000,5785,7774},{60000,5787,7564},{60000,5793,7356},{60000,5790,7160},{60000,5804,6956},{60000,5801,6743},{60000,5808,6524},{60000,5823,6291},{60000,5834,6074},{60000,5845,5837},{60000,5856,5584},{60000,5876,5353},{60000,5905,5129},{60000,5930,4895},{60000,5970,4678},{60000,6018,4492},{60000,6097,4291}],0],0}',''),(0,600025,'0','{path,[[{60000,9277,6984},{60000,9129,6853},{60000,9006,6720},{60000,8890,6604},{60000,8752,6469},{60000,8616,6341},{60000,8473,6223},{60000,8347,6077},{60000,8218,5942},{60000,8098,5794},{60000,7959,5658},{60000,7835,5529},{60000,7694,5405},{60000,7559,5264},{60000,7428,5133},{60000,7300,5003},{60000,7166,4884},{60000,7016,4772},{60000,6874,4643},{60000,6714,4501},{60000,6569,4362},{60000,6442,4229}],0],0}',''),(0,600026,'0','{path,[[{60000,10292,3459},{60000,10088,3445},{60000,9889,3439},{60000,9705,3440},{60000,9495,3439},{60000,9282,3435},{60000,9068,3423},{60000,8834,3425},{60000,8619,3426},{60000,8410,3432},{60000,8195,3460},{60000,8007,3486},{60000,7799,3522},{60000,7581,3563},{60000,7362,3603},{60000,7157,3630},{60000,6965,3677},{60000,6786,3731},{60000,6606,3794},{60000,6446,3885}],0],0}',''),(0,600027,'0','{path,[[{60000,5792,8226},{60000,5779,8015},{60000,5785,7774},{60000,5787,7564},{60000,5793,7356},{60000,5790,7160},{60000,5804,6956},{60000,5801,6743},{60000,5808,6524},{60000,5823,6291},{60000,5834,6074},{60000,5845,5837},{60000,5856,5584},{60000,5876,5353},{60000,5905,5129},{60000,5930,4895},{60000,5970,4678},{60000,6018,4492},{60000,6097,4291}],0],0}',''),(0,600028,'0','{path,[[{60000,9277,6984},{60000,9129,6853},{60000,9006,6720},{60000,8890,6604},{60000,8752,6469},{60000,8616,6341},{60000,8473,6223},{60000,8347,6077},{60000,8218,5942},{60000,8098,5794},{60000,7959,5658},{60000,7835,5529},{60000,7694,5405},{60000,7559,5264},{60000,7428,5133},{60000,7300,5003},{60000,7166,4884},{60000,7016,4772},{60000,6874,4643},{60000,6714,4501},{60000,6569,4362},{60000,6442,4229}],0],0}',''),(0,600029,'0','{path,[[{60000,10292,3459},{60000,10088,3445},{60000,9889,3439},{60000,9705,3440},{60000,9495,3439},{60000,9282,3435},{60000,9068,3423},{60000,8834,3425},{60000,8619,3426},{60000,8410,3432},{60000,8195,3460},{60000,8007,3486},{60000,7799,3522},{60000,7581,3563},{60000,7362,3603},{60000,7157,3630},{60000,6965,3677},{60000,6786,3731},{60000,6606,3794},{60000,6446,3885}],0],0}',''),(0,600030,'0','{path,[[{60000,5792,8226},{60000,5779,8015},{60000,5785,7774},{60000,5787,7564},{60000,5793,7356},{60000,5790,7160},{60000,5804,6956},{60000,5801,6743},{60000,5808,6524},{60000,5823,6291},{60000,5834,6074},{60000,5845,5837},{60000,5856,5584},{60000,5876,5353},{60000,5905,5129},{60000,5930,4895},{60000,5970,4678},{60000,6018,4492},{60000,6097,4291}],0],0}',''),(0,600031,'0','{path,[[{60000,9277,6984},{60000,9129,6853},{60000,9006,6720},{60000,8890,6604},{60000,8752,6469},{60000,8616,6341},{60000,8473,6223},{60000,8347,6077},{60000,8218,5942},{60000,8098,5794},{60000,7959,5658},{60000,7835,5529},{60000,7694,5405},{60000,7559,5264},{60000,7428,5133},{60000,7300,5003},{60000,7166,4884},{60000,7016,4772},{60000,6874,4643},{60000,6714,4501},{60000,6569,4362},{60000,6442,4229}],0],0}',''),(0,600032,'0','{path,[[{60000,10292,3459},{60000,10088,3445},{60000,9889,3439},{60000,9705,3440},{60000,9495,3439},{60000,9282,3435},{60000,9068,3423},{60000,8834,3425},{60000,8619,3426},{60000,8410,3432},{60000,8195,3460},{60000,8007,3486},{60000,7799,3522},{60000,7581,3563},{60000,7362,3603},{60000,7157,3630},{60000,6965,3677},{60000,6786,3731},{60000,6606,3794},{60000,6446,3885}],0],0}',''),(0,600033,'0','{path,[[{60000,5792,8226},{60000,5779,8015},{60000,5785,7774},{60000,5787,7564},{60000,5793,7356},{60000,5790,7160},{60000,5804,6956},{60000,5801,6743},{60000,5808,6524},{60000,5823,6291},{60000,5834,6074},{60000,5845,5837},{60000,5856,5584},{60000,5876,5353},{60000,5905,5129},{60000,5930,4895},{60000,5970,4678},{60000,6018,4492},{60000,6097,4291}],0],0}',''),(0,600034,'0','{path,[[{60000,9277,6984},{60000,9129,6853},{60000,9006,6720},{60000,8890,6604},{60000,8752,6469},{60000,8616,6341},{60000,8473,6223},{60000,8347,6077},{60000,8218,5942},{60000,8098,5794},{60000,7959,5658},{60000,7835,5529},{60000,7694,5405},{60000,7559,5264},{60000,7428,5133},{60000,7300,5003},{60000,7166,4884},{60000,7016,4772},{60000,6874,4643},{60000,6714,4501},{60000,6569,4362},{60000,6442,4229}],0],0}',''),(0,600035,'0','{path,[[{60000,10292,3459},{60000,10088,3445},{60000,9889,3439},{60000,9705,3440},{60000,9495,3439},{60000,9282,3435},{60000,9068,3423},{60000,8834,3425},{60000,8619,3426},{60000,8410,3432},{60000,8195,3460},{60000,8007,3486},{60000,7799,3522},{60000,7581,3563},{60000,7362,3603},{60000,7157,3630},{60000,6965,3677},{60000,6786,3731},{60000,6606,3794},{60000,6446,3885}],0],0}',''),(0,600036,'0','{path,[[{60000,5792,8226},{60000,5779,8015},{60000,5785,7774},{60000,5787,7564},{60000,5793,7356},{60000,5790,7160},{60000,5804,6956},{60000,5801,6743},{60000,5808,6524},{60000,5823,6291},{60000,5834,6074},{60000,5845,5837},{60000,5856,5584},{60000,5876,5353},{60000,5905,5129},{60000,5930,4895},{60000,5970,4678},{60000,6018,4492},{60000,6097,4291}],0],0}',''),(0,600037,'0','{path,[[{60000,9277,6984},{60000,9129,6853},{60000,9006,6720},{60000,8890,6604},{60000,8752,6469},{60000,8616,6341},{60000,8473,6223},{60000,8347,6077},{60000,8218,5942},{60000,8098,5794},{60000,7959,5658},{60000,7835,5529},{60000,7694,5405},{60000,7559,5264},{60000,7428,5133},{60000,7300,5003},{60000,7166,4884},{60000,7016,4772},{60000,6874,4643},{60000,6714,4501},{60000,6569,4362},{60000,6442,4229}],0],0}',''),(0,600038,'0','{path,[[{60000,10292,3459},{60000,10088,3445},{60000,9889,3439},{60000,9705,3440},{60000,9495,3439},{60000,9282,3435},{60000,9068,3423},{60000,8834,3425},{60000,8619,3426},{60000,8410,3432},{60000,8195,3460},{60000,8007,3486},{60000,7799,3522},{60000,7581,3563},{60000,7362,3603},{60000,7157,3630},{60000,6965,3677},{60000,6786,3731},{60000,6606,3794},{60000,6446,3885}],0],0}',''),(0,600041,'0','{path,[[{60000,5792,8226},{60000,5779,8015},{60000,5785,7774},{60000,5787,7564},{60000,5793,7356},{60000,5790,7160},{60000,5804,6956},{60000,5801,6743},{60000,5808,6524},{60000,5823,6291},{60000,5834,6074},{60000,5845,5837},{60000,5856,5584},{60000,5876,5353},{60000,5905,5129},{60000,5930,4895},{60000,5970,4678},{60000,6018,4492},{60000,6097,4291}],0],0}',''),(0,600042,'0','{path,[[{60000,9277,6984},{60000,9129,6853},{60000,9006,6720},{60000,8890,6604},{60000,8752,6469},{60000,8616,6341},{60000,8473,6223},{60000,8347,6077},{60000,8218,5942},{60000,8098,5794},{60000,7959,5658},{60000,7835,5529},{60000,7694,5405},{60000,7559,5264},{60000,7428,5133},{60000,7300,5003},{60000,7166,4884},{60000,7016,4772},{60000,6874,4643},{60000,6714,4501},{60000,6569,4362},{60000,6442,4229}],0],0}',''),(0,600043,'0','{path,[[{60000,10292,3459},{60000,10088,3445},{60000,9889,3439},{60000,9705,3440},{60000,9495,3439},{60000,9282,3435},{60000,9068,3423},{60000,8834,3425},{60000,8619,3426},{60000,8410,3432},{60000,8195,3460},{60000,8007,3486},{60000,7799,3522},{60000,7581,3563},{60000,7362,3603},{60000,7157,3630},{60000,6965,3677},{60000,6786,3731},{60000,6606,3794},{60000,6446,3885}],0],0}',''),(0,600044,'0','{path,[[{60000,5792,8226},{60000,5779,8015},{60000,5785,7774},{60000,5787,7564},{60000,5793,7356},{60000,5790,7160},{60000,5804,6956},{60000,5801,6743},{60000,5808,6524},{60000,5823,6291},{60000,5834,6074},{60000,5845,5837},{60000,5856,5584},{60000,5876,5353},{60000,5905,5129},{60000,5930,4895},{60000,5970,4678},{60000,6018,4492},{60000,6097,4291}],0],0}',''),(0,600045,'0','{path,[[{60000,9277,6984},{60000,9129,6853},{60000,9006,6720},{60000,8890,6604},{60000,8752,6469},{60000,8616,6341},{60000,8473,6223},{60000,8347,6077},{60000,8218,5942},{60000,8098,5794},{60000,7959,5658},{60000,7835,5529},{60000,7694,5405},{60000,7559,5264},{60000,7428,5133},{60000,7300,5003},{60000,7166,4884},{60000,7016,4772},{60000,6874,4643},{60000,6714,4501},{60000,6569,4362},{60000,6442,4229}],0],0}',''),(0,600046,'0','{path,[[{60000,10292,3459},{60000,10088,3445},{60000,9889,3439},{60000,9705,3440},{60000,9495,3439},{60000,9282,3435},{60000,9068,3423},{60000,8834,3425},{60000,8619,3426},{60000,8410,3432},{60000,8195,3460},{60000,8007,3486},{60000,7799,3522},{60000,7581,3563},{60000,7362,3603},{60000,7157,3630},{60000,6965,3677},{60000,6786,3731},{60000,6606,3794},{60000,6446,3885}],0],0}',''),(0,600047,'0','{path,[[{60000,5792,8226},{60000,5779,8015},{60000,5785,7774},{60000,5787,7564},{60000,5793,7356},{60000,5790,7160},{60000,5804,6956},{60000,5801,6743},{60000,5808,6524},{60000,5823,6291},{60000,5834,6074},{60000,5845,5837},{60000,5856,5584},{60000,5876,5353},{60000,5905,5129},{60000,5930,4895},{60000,5970,4678},{60000,6018,4492},{60000,6097,4291}],0],0}',''),(0,600048,'0','{path,[[{60000,9277,6984},{60000,9129,6853},{60000,9006,6720},{60000,8890,6604},{60000,8752,6469},{60000,8616,6341},{60000,8473,6223},{60000,8347,6077},{60000,8218,5942},{60000,8098,5794},{60000,7959,5658},{60000,7835,5529},{60000,7694,5405},{60000,7559,5264},{60000,7428,5133},{60000,7300,5003},{60000,7166,4884},{60000,7016,4772},{60000,6874,4643},{60000,6714,4501},{60000,6569,4362},{60000,6442,4229}],0],0}',''),(0,600049,'0','{path,[[{60000,10292,3459},{60000,10088,3445},{60000,9889,3439},{60000,9705,3440},{60000,9495,3439},{60000,9282,3435},{60000,9068,3423},{60000,8834,3425},{60000,8619,3426},{60000,8410,3432},{60000,8195,3460},{60000,8007,3486},{60000,7799,3522},{60000,7581,3563},{60000,7362,3603},{60000,7157,3630},{60000,6965,3677},{60000,6786,3731},{60000,6606,3794},{60000,6446,3885}],0],0}',''),(0,600050,'0','{path,[[{60000,5792,8226},{60000,5779,8015},{60000,5785,7774},{60000,5787,7564},{60000,5793,7356},{60000,5790,7160},{60000,5804,6956},{60000,5801,6743},{60000,5808,6524},{60000,5823,6291},{60000,5834,6074},{60000,5845,5837},{60000,5856,5584},{60000,5876,5353},{60000,5905,5129},{60000,5930,4895},{60000,5970,4678},{60000,6018,4492},{60000,6097,4291}],0],0}',''),(0,600051,'0','{path,[[{60000,9277,6984},{60000,9129,6853},{60000,9006,6720},{60000,8890,6604},{60000,8752,6469},{60000,8616,6341},{60000,8473,6223},{60000,8347,6077},{60000,8218,5942},{60000,8098,5794},{60000,7959,5658},{60000,7835,5529},{60000,7694,5405},{60000,7559,5264},{60000,7428,5133},{60000,7300,5003},{60000,7166,4884},{60000,7016,4772},{60000,6874,4643},{60000,6714,4501},{60000,6569,4362},{60000,6442,4229}],0],0}',''),(0,600052,'0','{path,[[{60000,10292,3459},{60000,10088,3445},{60000,9889,3439},{60000,9705,3440},{60000,9495,3439},{60000,9282,3435},{60000,9068,3423},{60000,8834,3425},{60000,8619,3426},{60000,8410,3432},{60000,8195,3460},{60000,8007,3486},{60000,7799,3522},{60000,7581,3563},{60000,7362,3603},{60000,7157,3630},{60000,6965,3677},{60000,6786,3731},{60000,6606,3794},{60000,6446,3885}],0],0}',''),(0,600053,'0','{path,[[{60000,5792,8226},{60000,5779,8015},{60000,5785,7774},{60000,5787,7564},{60000,5793,7356},{60000,5790,7160},{60000,5804,6956},{60000,5801,6743},{60000,5808,6524},{60000,5823,6291},{60000,5834,6074},{60000,5845,5837},{60000,5856,5584},{60000,5876,5353},{60000,5905,5129},{60000,5930,4895},{60000,5970,4678},{60000,6018,4492},{60000,6097,4291}],0],0}',''),(0,600054,'0','{path,[[{60000,9277,6984},{60000,9129,6853},{60000,9006,6720},{60000,8890,6604},{60000,8752,6469},{60000,8616,6341},{60000,8473,6223},{60000,8347,6077},{60000,8218,5942},{60000,8098,5794},{60000,7959,5658},{60000,7835,5529},{60000,7694,5405},{60000,7559,5264},{60000,7428,5133},{60000,7300,5003},{60000,7166,4884},{60000,7016,4772},{60000,6874,4643},{60000,6714,4501},{60000,6569,4362},{60000,6442,4229}],0],0}',''),(0,600055,'0','{path,[[{60000,10292,3459},{60000,10088,3445},{60000,9889,3439},{60000,9705,3440},{60000,9495,3439},{60000,9282,3435},{60000,9068,3423},{60000,8834,3425},{60000,8619,3426},{60000,8410,3432},{60000,8195,3460},{60000,8007,3486},{60000,7799,3522},{60000,7581,3563},{60000,7362,3603},{60000,7157,3630},{60000,6965,3677},{60000,6786,3731},{60000,6606,3794},{60000,6446,3885}],0],0}',''),(0,600056,'0','{path,[[{60000,5792,8226},{60000,5779,8015},{60000,5785,7774},{60000,5787,7564},{60000,5793,7356},{60000,5790,7160},{60000,5804,6956},{60000,5801,6743},{60000,5808,6524},{60000,5823,6291},{60000,5834,6074},{60000,5845,5837},{60000,5856,5584},{60000,5876,5353},{60000,5905,5129},{60000,5930,4895},{60000,5970,4678},{60000,6018,4492},{60000,6097,4291}],0],0}',''),(0,600057,'0','{path,[[{60000,9277,6984},{60000,9129,6853},{60000,9006,6720},{60000,8890,6604},{60000,8752,6469},{60000,8616,6341},{60000,8473,6223},{60000,8347,6077},{60000,8218,5942},{60000,8098,5794},{60000,7959,5658},{60000,7835,5529},{60000,7694,5405},{60000,7559,5264},{60000,7428,5133},{60000,7300,5003},{60000,7166,4884},{60000,7016,4772},{60000,6874,4643},{60000,6714,4501},{60000,6569,4362},{60000,6442,4229}],0],0}',''),(0,600058,'0','{path,[[{60000,10292,3459},{60000,10088,3445},{60000,9889,3439},{60000,9705,3440},{60000,9495,3439},{60000,9282,3435},{60000,9068,3423},{60000,8834,3425},{60000,8619,3426},{60000,8410,3432},{60000,8195,3460},{60000,8007,3486},{60000,7799,3522},{60000,7581,3563},{60000,7362,3603},{60000,7157,3630},{60000,6965,3677},{60000,6786,3731},{60000,6606,3794},{60000,6446,3885}],0],0}',''),(0,600061,'0','{path,[[{60000,5792,8226},{60000,5779,8015},{60000,5785,7774},{60000,5787,7564},{60000,5793,7356},{60000,5790,7160},{60000,5804,6956},{60000,5801,6743},{60000,5808,6524},{60000,5823,6291},{60000,5834,6074},{60000,5845,5837},{60000,5856,5584},{60000,5876,5353},{60000,5905,5129},{60000,5930,4895},{60000,5970,4678},{60000,6018,4492},{60000,6097,4291}],0],0}',''),(0,600062,'0','{path,[[{60000,9277,6984},{60000,9129,6853},{60000,9006,6720},{60000,8890,6604},{60000,8752,6469},{60000,8616,6341},{60000,8473,6223},{60000,8347,6077},{60000,8218,5942},{60000,8098,5794},{60000,7959,5658},{60000,7835,5529},{60000,7694,5405},{60000,7559,5264},{60000,7428,5133},{60000,7300,5003},{60000,7166,4884},{60000,7016,4772},{60000,6874,4643},{60000,6714,4501},{60000,6569,4362},{60000,6442,4229}],0],0}',''),(0,600063,'0','{path,[[{60000,10292,3459},{60000,10088,3445},{60000,9889,3439},{60000,9705,3440},{60000,9495,3439},{60000,9282,3435},{60000,9068,3423},{60000,8834,3425},{60000,8619,3426},{60000,8410,3432},{60000,8195,3460},{60000,8007,3486},{60000,7799,3522},{60000,7581,3563},{60000,7362,3603},{60000,7157,3630},{60000,6965,3677},{60000,6786,3731},{60000,6606,3794},{60000,6446,3885}],0],0}',''),(0,600064,'0','{path,[[{60000,5792,8226},{60000,5779,8015},{60000,5785,7774},{60000,5787,7564},{60000,5793,7356},{60000,5790,7160},{60000,5804,6956},{60000,5801,6743},{60000,5808,6524},{60000,5823,6291},{60000,5834,6074},{60000,5845,5837},{60000,5856,5584},{60000,5876,5353},{60000,5905,5129},{60000,5930,4895},{60000,5970,4678},{60000,6018,4492},{60000,6097,4291}],0],0}',''),(0,600065,'0','{path,[[{60000,9277,6984},{60000,9129,6853},{60000,9006,6720},{60000,8890,6604},{60000,8752,6469},{60000,8616,6341},{60000,8473,6223},{60000,8347,6077},{60000,8218,5942},{60000,8098,5794},{60000,7959,5658},{60000,7835,5529},{60000,7694,5405},{60000,7559,5264},{60000,7428,5133},{60000,7300,5003},{60000,7166,4884},{60000,7016,4772},{60000,6874,4643},{60000,6714,4501},{60000,6569,4362},{60000,6442,4229}],0],0}',''),(0,600066,'0','{path,[[{60000,10292,3459},{60000,10088,3445},{60000,9889,3439},{60000,9705,3440},{60000,9495,3439},{60000,9282,3435},{60000,9068,3423},{60000,8834,3425},{60000,8619,3426},{60000,8410,3432},{60000,8195,3460},{60000,8007,3486},{60000,7799,3522},{60000,7581,3563},{60000,7362,3603},{60000,7157,3630},{60000,6965,3677},{60000,6786,3731},{60000,6606,3794},{60000,6446,3885}],0],0}',''),(0,600067,'0','{path,[[{60000,5792,8226},{60000,5779,8015},{60000,5785,7774},{60000,5787,7564},{60000,5793,7356},{60000,5790,7160},{60000,5804,6956},{60000,5801,6743},{60000,5808,6524},{60000,5823,6291},{60000,5834,6074},{60000,5845,5837},{60000,5856,5584},{60000,5876,5353},{60000,5905,5129},{60000,5930,4895},{60000,5970,4678},{60000,6018,4492},{60000,6097,4291}],0],0}',''),(0,600068,'0','{path,[[{60000,9277,6984},{60000,9129,6853},{60000,9006,6720},{60000,8890,6604},{60000,8752,6469},{60000,8616,6341},{60000,8473,6223},{60000,8347,6077},{60000,8218,5942},{60000,8098,5794},{60000,7959,5658},{60000,7835,5529},{60000,7694,5405},{60000,7559,5264},{60000,7428,5133},{60000,7300,5003},{60000,7166,4884},{60000,7016,4772},{60000,6874,4643},{60000,6714,4501},{60000,6569,4362},{60000,6442,4229}],0],0}',''),(0,600069,'0','{path,[[{60000,10292,3459},{60000,10088,3445},{60000,9889,3439},{60000,9705,3440},{60000,9495,3439},{60000,9282,3435},{60000,9068,3423},{60000,8834,3425},{60000,8619,3426},{60000,8410,3432},{60000,8195,3460},{60000,8007,3486},{60000,7799,3522},{60000,7581,3563},{60000,7362,3603},{60000,7157,3630},{60000,6965,3677},{60000,6786,3731},{60000,6606,3794},{60000,6446,3885}],0],0}',''),(0,600070,'0','{path,[[{60000,5792,8226},{60000,5779,8015},{60000,5785,7774},{60000,5787,7564},{60000,5793,7356},{60000,5790,7160},{60000,5804,6956},{60000,5801,6743},{60000,5808,6524},{60000,5823,6291},{60000,5834,6074},{60000,5845,5837},{60000,5856,5584},{60000,5876,5353},{60000,5905,5129},{60000,5930,4895},{60000,5970,4678},{60000,6018,4492},{60000,6097,4291}],0],0}',''),(0,600071,'0','{path,[[{60000,9277,6984},{60000,9129,6853},{60000,9006,6720},{60000,8890,6604},{60000,8752,6469},{60000,8616,6341},{60000,8473,6223},{60000,8347,6077},{60000,8218,5942},{60000,8098,5794},{60000,7959,5658},{60000,7835,5529},{60000,7694,5405},{60000,7559,5264},{60000,7428,5133},{60000,7300,5003},{60000,7166,4884},{60000,7016,4772},{60000,6874,4643},{60000,6714,4501},{60000,6569,4362},{60000,6442,4229}],0],0}',''),(0,600072,'0','{path,[[{60000,10292,3459},{60000,10088,3445},{60000,9889,3439},{60000,9705,3440},{60000,9495,3439},{60000,9282,3435},{60000,9068,3423},{60000,8834,3425},{60000,8619,3426},{60000,8410,3432},{60000,8195,3460},{60000,8007,3486},{60000,7799,3522},{60000,7581,3563},{60000,7362,3603},{60000,7157,3630},{60000,6965,3677},{60000,6786,3731},{60000,6606,3794},{60000,6446,3885}],0],0}',''),(0,600073,'0','{path,[[{60000,5792,8226},{60000,5779,8015},{60000,5785,7774},{60000,5787,7564},{60000,5793,7356},{60000,5790,7160},{60000,5804,6956},{60000,5801,6743},{60000,5808,6524},{60000,5823,6291},{60000,5834,6074},{60000,5845,5837},{60000,5856,5584},{60000,5876,5353},{60000,5905,5129},{60000,5930,4895},{60000,5970,4678},{60000,6018,4492},{60000,6097,4291}],0],0}',''),(0,600074,'0','{path,[[{60000,9277,6984},{60000,9129,6853},{60000,9006,6720},{60000,8890,6604},{60000,8752,6469},{60000,8616,6341},{60000,8473,6223},{60000,8347,6077},{60000,8218,5942},{60000,8098,5794},{60000,7959,5658},{60000,7835,5529},{60000,7694,5405},{60000,7559,5264},{60000,7428,5133},{60000,7300,5003},{60000,7166,4884},{60000,7016,4772},{60000,6874,4643},{60000,6714,4501},{60000,6569,4362},{60000,6442,4229}],0],0}',''),(0,600075,'0','{path,[[{60000,10292,3459},{60000,10088,3445},{60000,9889,3439},{60000,9705,3440},{60000,9495,3439},{60000,9282,3435},{60000,9068,3423},{60000,8834,3425},{60000,8619,3426},{60000,8410,3432},{60000,8195,3460},{60000,8007,3486},{60000,7799,3522},{60000,7581,3563},{60000,7362,3603},{60000,7157,3630},{60000,6965,3677},{60000,6786,3731},{60000,6606,3794},{60000,6446,3885}],0],0}',''),(0,600076,'0','{path,[[{60000,5792,8226},{60000,5779,8015},{60000,5785,7774},{60000,5787,7564},{60000,5793,7356},{60000,5790,7160},{60000,5804,6956},{60000,5801,6743},{60000,5808,6524},{60000,5823,6291},{60000,5834,6074},{60000,5845,5837},{60000,5856,5584},{60000,5876,5353},{60000,5905,5129},{60000,5930,4895},{60000,5970,4678},{60000,6018,4492},{60000,6097,4291}],0],0}',''),(0,600077,'0','{path,[[{60000,9277,6984},{60000,9129,6853},{60000,9006,6720},{60000,8890,6604},{60000,8752,6469},{60000,8616,6341},{60000,8473,6223},{60000,8347,6077},{60000,8218,5942},{60000,8098,5794},{60000,7959,5658},{60000,7835,5529},{60000,7694,5405},{60000,7559,5264},{60000,7428,5133},{60000,7300,5003},{60000,7166,4884},{60000,7016,4772},{60000,6874,4643},{60000,6714,4501},{60000,6569,4362},{60000,6442,4229}],0],0}',''),(0,600078,'0','{path,[[{60000,10292,3459},{60000,10088,3445},{60000,9889,3439},{60000,9705,3440},{60000,9495,3439},{60000,9282,3435},{60000,9068,3423},{60000,8834,3425},{60000,8619,3426},{60000,8410,3432},{60000,8195,3460},{60000,8007,3486},{60000,7799,3522},{60000,7581,3563},{60000,7362,3603},{60000,7157,3630},{60000,6965,3677},{60000,6786,3731},{60000,6606,3794},{60000,6446,3885}],0],0}',''),(0,600081,'0','{path,[[{60000,5792,8226},{60000,5779,8015},{60000,5785,7774},{60000,5787,7564},{60000,5793,7356},{60000,5790,7160},{60000,5804,6956},{60000,5801,6743},{60000,5808,6524},{60000,5823,6291},{60000,5834,6074},{60000,5845,5837},{60000,5856,5584},{60000,5876,5353},{60000,5905,5129},{60000,5930,4895},{60000,5970,4678},{60000,6018,4492},{60000,6097,4291}],0],0}',''),(0,600082,'0','{path,[[{60000,9277,6984},{60000,9129,6853},{60000,9006,6720},{60000,8890,6604},{60000,8752,6469},{60000,8616,6341},{60000,8473,6223},{60000,8347,6077},{60000,8218,5942},{60000,8098,5794},{60000,7959,5658},{60000,7835,5529},{60000,7694,5405},{60000,7559,5264},{60000,7428,5133},{60000,7300,5003},{60000,7166,4884},{60000,7016,4772},{60000,6874,4643},{60000,6714,4501},{60000,6569,4362},{60000,6442,4229}],0],0}',''),(0,600083,'0','{path,[[{60000,10292,3459},{60000,10088,3445},{60000,9889,3439},{60000,9705,3440},{60000,9495,3439},{60000,9282,3435},{60000,9068,3423},{60000,8834,3425},{60000,8619,3426},{60000,8410,3432},{60000,8195,3460},{60000,8007,3486},{60000,7799,3522},{60000,7581,3563},{60000,7362,3603},{60000,7157,3630},{60000,6965,3677},{60000,6786,3731},{60000,6606,3794},{60000,6446,3885}],0],0}',''),(0,600084,'0','{path,[[{60000,5792,8226},{60000,5779,8015},{60000,5785,7774},{60000,5787,7564},{60000,5793,7356},{60000,5790,7160},{60000,5804,6956},{60000,5801,6743},{60000,5808,6524},{60000,5823,6291},{60000,5834,6074},{60000,5845,5837},{60000,5856,5584},{60000,5876,5353},{60000,5905,5129},{60000,5930,4895},{60000,5970,4678},{60000,6018,4492},{60000,6097,4291}],0],0}',''),(0,600085,'0','{path,[[{60000,9277,6984},{60000,9129,6853},{60000,9006,6720},{60000,8890,6604},{60000,8752,6469},{60000,8616,6341},{60000,8473,6223},{60000,8347,6077},{60000,8218,5942},{60000,8098,5794},{60000,7959,5658},{60000,7835,5529},{60000,7694,5405},{60000,7559,5264},{60000,7428,5133},{60000,7300,5003},{60000,7166,4884},{60000,7016,4772},{60000,6874,4643},{60000,6714,4501},{60000,6569,4362},{60000,6442,4229}],0],0}',''),(0,600086,'0','{path,[[{60000,10292,3459},{60000,10088,3445},{60000,9889,3439},{60000,9705,3440},{60000,9495,3439},{60000,9282,3435},{60000,9068,3423},{60000,8834,3425},{60000,8619,3426},{60000,8410,3432},{60000,8195,3460},{60000,8007,3486},{60000,7799,3522},{60000,7581,3563},{60000,7362,3603},{60000,7157,3630},{60000,6965,3677},{60000,6786,3731},{60000,6606,3794},{60000,6446,3885}],0],0}',''),(0,600087,'0','{path,[[{60000,5792,8226},{60000,5779,8015},{60000,5785,7774},{60000,5787,7564},{60000,5793,7356},{60000,5790,7160},{60000,5804,6956},{60000,5801,6743},{60000,5808,6524},{60000,5823,6291},{60000,5834,6074},{60000,5845,5837},{60000,5856,5584},{60000,5876,5353},{60000,5905,5129},{60000,5930,4895},{60000,5970,4678},{60000,6018,4492},{60000,6097,4291}],0],0}',''),(0,600088,'0','{path,[[{60000,9277,6984},{60000,9129,6853},{60000,9006,6720},{60000,8890,6604},{60000,8752,6469},{60000,8616,6341},{60000,8473,6223},{60000,8347,6077},{60000,8218,5942},{60000,8098,5794},{60000,7959,5658},{60000,7835,5529},{60000,7694,5405},{60000,7559,5264},{60000,7428,5133},{60000,7300,5003},{60000,7166,4884},{60000,7016,4772},{60000,6874,4643},{60000,6714,4501},{60000,6569,4362},{60000,6442,4229}],0],0}',''),(0,600089,'0','{path,[[{60000,10292,3459},{60000,10088,3445},{60000,9889,3439},{60000,9705,3440},{60000,9495,3439},{60000,9282,3435},{60000,9068,3423},{60000,8834,3425},{60000,8619,3426},{60000,8410,3432},{60000,8195,3460},{60000,8007,3486},{60000,7799,3522},{60000,7581,3563},{60000,7362,3603},{60000,7157,3630},{60000,6965,3677},{60000,6786,3731},{60000,6606,3794},{60000,6446,3885}],0],0}',''),(0,600090,'0','{path,[[{60000,5792,8226},{60000,5779,8015},{60000,5785,7774},{60000,5787,7564},{60000,5793,7356},{60000,5790,7160},{60000,5804,6956},{60000,5801,6743},{60000,5808,6524},{60000,5823,6291},{60000,5834,6074},{60000,5845,5837},{60000,5856,5584},{60000,5876,5353},{60000,5905,5129},{60000,5930,4895},{60000,5970,4678},{60000,6018,4492},{60000,6097,4291}],0],0}',''),(0,600091,'0','{path,[[{60000,9277,6984},{60000,9129,6853},{60000,9006,6720},{60000,8890,6604},{60000,8752,6469},{60000,8616,6341},{60000,8473,6223},{60000,8347,6077},{60000,8218,5942},{60000,8098,5794},{60000,7959,5658},{60000,7835,5529},{60000,7694,5405},{60000,7559,5264},{60000,7428,5133},{60000,7300,5003},{60000,7166,4884},{60000,7016,4772},{60000,6874,4643},{60000,6714,4501},{60000,6569,4362},{60000,6442,4229}],0],0}',''),(0,600092,'0','{path,[[{60000,10292,3459},{60000,10088,3445},{60000,9889,3439},{60000,9705,3440},{60000,9495,3439},{60000,9282,3435},{60000,9068,3423},{60000,8834,3425},{60000,8619,3426},{60000,8410,3432},{60000,8195,3460},{60000,8007,3486},{60000,7799,3522},{60000,7581,3563},{60000,7362,3603},{60000,7157,3630},{60000,6965,3677},{60000,6786,3731},{60000,6606,3794},{60000,6446,3885}],0],0}',''),(0,600093,'0','{path,[[{60000,5792,8226},{60000,5779,8015},{60000,5785,7774},{60000,5787,7564},{60000,5793,7356},{60000,5790,7160},{60000,5804,6956},{60000,5801,6743},{60000,5808,6524},{60000,5823,6291},{60000,5834,6074},{60000,5845,5837},{60000,5856,5584},{60000,5876,5353},{60000,5905,5129},{60000,5930,4895},{60000,5970,4678},{60000,6018,4492},{60000,6097,4291}],0],0}',''),(0,600094,'0','{path,[[{60000,9277,6984},{60000,9129,6853},{60000,9006,6720},{60000,8890,6604},{60000,8752,6469},{60000,8616,6341},{60000,8473,6223},{60000,8347,6077},{60000,8218,5942},{60000,8098,5794},{60000,7959,5658},{60000,7835,5529},{60000,7694,5405},{60000,7559,5264},{60000,7428,5133},{60000,7300,5003},{60000,7166,4884},{60000,7016,4772},{60000,6874,4643},{60000,6714,4501},{60000,6569,4362},{60000,6442,4229}],0],0}',''),(0,600095,'0','{path,[[{60000,10292,3459},{60000,10088,3445},{60000,9889,3439},{60000,9705,3440},{60000,9495,3439},{60000,9282,3435},{60000,9068,3423},{60000,8834,3425},{60000,8619,3426},{60000,8410,3432},{60000,8195,3460},{60000,8007,3486},{60000,7799,3522},{60000,7581,3563},{60000,7362,3603},{60000,7157,3630},{60000,6965,3677},{60000,6786,3731},{60000,6606,3794},{60000,6446,3885}],0],0}',''),(0,600096,'0','{path,[[{60000,5792,8226},{60000,5779,8015},{60000,5785,7774},{60000,5787,7564},{60000,5793,7356},{60000,5790,7160},{60000,5804,6956},{60000,5801,6743},{60000,5808,6524},{60000,5823,6291},{60000,5834,6074},{60000,5845,5837},{60000,5856,5584},{60000,5876,5353},{60000,5905,5129},{60000,5930,4895},{60000,5970,4678},{60000,6018,4492},{60000,6097,4291}],0],0}',''),(0,600097,'0','{path,[[{60000,9277,6984},{60000,9129,6853},{60000,9006,6720},{60000,8890,6604},{60000,8752,6469},{60000,8616,6341},{60000,8473,6223},{60000,8347,6077},{60000,8218,5942},{60000,8098,5794},{60000,7959,5658},{60000,7835,5529},{60000,7694,5405},{60000,7559,5264},{60000,7428,5133},{60000,7300,5003},{60000,7166,4884},{60000,7016,4772},{60000,6874,4643},{60000,6714,4501},{60000,6569,4362},{60000,6442,4229}],0],0}',''),(0,600098,'0','{path,[[{60000,10292,3459},{60000,10088,3445},{60000,9889,3439},{60000,9705,3440},{60000,9495,3439},{60000,9282,3435},{60000,9068,3423},{60000,8834,3425},{60000,8619,3426},{60000,8410,3432},{60000,8195,3460},{60000,8007,3486},{60000,7799,3522},{60000,7581,3563},{60000,7362,3603},{60000,7157,3630},{60000,6965,3677},{60000,6786,3731},{60000,6606,3794},{60000,6446,3885}],0],0}',''),(1,1202008,'','{clear_scene_mon,[5600120],0}','移除小怪'),(4,1202008,'0.2','{ac_skill,[{20005604,1}],0},{msg,[6105600],10000}',''),(4,1202008,'0.3','{create_mon,[10000,5600120,20,600,100,50,0,[]],0},{msg,[6105601],10000}',''),(4,1202008,'0.4','{ac_skill,[{20005604,1}],0},{msg,[6105600],10000}',''),(4,1202008,'0.5','{create_mon,[10000,5600120,20,600,100,50,0,[]],0},{msg,[6105601],10000}',''),(4,1202008,'0.55','{skill,[{20005600,1},{20005601,1},{20005602,1},{20005603,1},{20005604,1}],0}',''),(4,1202008,'0.6','{ac_skill,[{20005604,1}],0},{msg,[6105600],10000}',''),(4,1202008,'0.7','{create_mon,[10000,5600120,20,600,100,50,0,[]],0},{msg,[6105601],10000}',''),(4,1202008,'0.8','{ac_skill,[{20005604,1}],0},{msg,[6105600],10000}',''),(4,1202008,'0.9','{create_mon,[10000,5600120,20,600,100,50,0,[]],0},{msg,[6105601],10000}',''),(4,1203008,'0.8','{ac_skill,[{20001005 ,1}],0}','放技能'),(0,1701001,'0','{path,[[{1701,695,1651},{1701,695,1551},{1701,695,1451},{1701,695,1351},{1701,751,1243},{1701,695,1143},{1701,695,951},{1701,931,679}],0],0}',''),(0,1701002,'0','{path, [[{1701,1984,1368},{1701,1888,1307},{1701,1719,1148},{1701,1602,1159},{1701,1502,1039},{1701,1337,920},{1701,1119,771}],0],0}',''),(0,1701003,'0','{path, [[{1701,2388,456},{1701,2263,402},{1701,2092,407},{1701,1992,405},{1701,1880,422},{1701,1680,422},{1701,1480,422},{1701,1257,509}],0],0}',''),(0,1701004,'0','{path,[[{1701,695,1651},{1701,695,1551},{1701,695,1451},{1701,695,1351},{1701,751,1243},{1701,695,1143},{1701,695,951},{1701,931,679}],0],0}',''),(0,1701005,'0','{path, [[{1701,1984,1368},{1701,1888,1307},{1701,1719,1148},{1701,1602,1159},{1701,1502,1039},{1701,1337,920},{1701,1119,771}],0],0}',''),(0,1701006,'0','{path, [[{1701,2388,456},{1701,2263,402},{1701,2092,407},{1701,1992,405},{1701,1880,422},{1701,1680,422},{1701,1480,422},{1701,1257,509}],0],0}',''),(0,1701007,'0','{path,[[{1701,695,1651},{1701,695,1551},{1701,695,1451},{1701,695,1351},{1701,751,1243},{1701,695,1143},{1701,695,951},{1701,931,679}],0],0}',''),(0,1701008,'0','{path, [[{1701,1984,1368},{1701,1888,1307},{1701,1719,1148},{1701,1602,1159},{1701,1502,1039},{1701,1337,920},{1701,1119,771}],0],0}',''),(0,1701009,'0','{path, [[{1701,2388,456},{1701,2263,402},{1701,2092,407},{1701,1992,405},{1701,1880,422},{1701,1680,422},{1701,1480,422},{1701,1257,509}],0],0}',''),(0,1701010,'0','{path,[[{1701,695,1651},{1701,695,1551},{1701,695,1451},{1701,695,1351},{1701,751,1243},{1701,695,1143},{1701,695,951},{1701,931,679}],0],0}',''),(0,1701011,'0','{path, [[{1701,1984,1368},{1701,1888,1307},{1701,1719,1148},{1701,1602,1159},{1701,1502,1039},{1701,1337,920},{1701,1119,771}],0],0}',''),(0,1701012,'0','{path, [[{1701,2388,456},{1701,2263,402},{1701,2092,407},{1701,1992,405},{1701,1880,422},{1701,1680,422},{1701,1480,422},{1701,1257,509}],0],0}',''),(0,1701013,'0','{path,[[{1701,695,1651},{1701,695,1551},{1701,695,1451},{1701,695,1351},{1701,751,1243},{1701,695,1143},{1701,695,951},{1701,931,679}],0],0}',''),(0,1701014,'0','{path, [[{1701,1984,1368},{1701,1888,1307},{1701,1719,1148},{1701,1602,1159},{1701,1502,1039},{1701,1337,920},{1701,1119,771}],0],0}',''),(0,1701015,'0','{path, [[{1701,2388,456},{1701,2263,402},{1701,2092,407},{1701,1992,405},{1701,1880,422},{1701,1680,422},{1701,1480,422},{1701,1257,509}],0],0}',''),(0,1701016,'0','{path,[[{1701,695,1651},{1701,695,1551},{1701,695,1451},{1701,695,1351},{1701,751,1243},{1701,695,1143},{1701,695,951},{1701,931,679}],0],0}',''),(0,1701017,'0','{path, [[{1701,1984,1368},{1701,1888,1307},{1701,1719,1148},{1701,1602,1159},{1701,1502,1039},{1701,1337,920},{1701,1119,771}],0],0}',''),(0,1701018,'0','{path, [[{1701,2388,456},{1701,2263,402},{1701,2092,407},{1701,1992,405},{1701,1880,422},{1701,1680,422},{1701,1480,422},{1701,1257,509}],0],0}',''),(0,1701019,'0','{path, [[{1701,1984,1368},{1701,1888,1307},{1701,1719,1148},{1701,1602,1159},{1701,1502,1039},{1701,1337,920},{1701,1119,771}],0],0}',''),(0,1701020,'0','{path, [[{1701,1984,1368},{1701,1888,1307},{1701,1719,1148},{1701,1602,1159},{1701,1502,1039},{1701,1337,920},{1701,1119,771}],0],0}',''),(0,1701021,'0','{path, [[{1701,1984,1368},{1701,1888,1307},{1701,1719,1148},{1701,1602,1159},{1701,1502,1039},{1701,1337,920},{1701,1119,771}],0],0}',''),(0,1701022,'0','{path, [[{1701,1984,1368},{1701,1888,1307},{1701,1719,1148},{1701,1602,1159},{1701,1502,1039},{1701,1337,920},{1701,1119,771}],0],0}',''),(0,1701023,'0','{path, [[{1701,1984,1368},{1701,1888,1307},{1701,1719,1148},{1701,1602,1159},{1701,1502,1039},{1701,1337,920},{1701,1119,771}],0],0}',''),(0,1701024,'0','{path, [[{1701,1984,1368},{1701,1888,1307},{1701,1719,1148},{1701,1602,1159},{1701,1502,1039},{1701,1337,920},{1701,1119,771}],0],0}',''),(0,1701025,'0','{path, [[{1701,1984,1368},{1701,1888,1307},{1701,1719,1148},{1701,1602,1159},{1701,1502,1039},{1701,1337,920},{1701,1119,771}],0],0}',''),(0,1701026,'0','{path, [[{1701,1984,1368},{1701,1888,1307},{1701,1719,1148},{1701,1602,1159},{1701,1502,1039},{1701,1337,920},{1701,1119,771}],0],0}',''),(0,1701027,'0','{path, [[{1701,1984,1368},{1701,1888,1307},{1701,1719,1148},{1701,1602,1159},{1701,1502,1039},{1701,1337,920},{1701,1119,771}],0],0}',''),(0,1701028,'0','{path, [[{1701,1984,1368},{1701,1888,1307},{1701,1719,1148},{1701,1602,1159},{1701,1502,1039},{1701,1337,920},{1701,1119,771}],0],0}',''),(0,1701029,'0','{path, [[{1701,1984,1368},{1701,1888,1307},{1701,1719,1148},{1701,1602,1159},{1701,1502,1039},{1701,1337,920},{1701,1119,771}],0],0}',''),(0,1701030,'0','{path, [[{1701,1984,1368},{1701,1888,1307},{1701,1719,1148},{1701,1602,1159},{1701,1502,1039},{1701,1337,920},{1701,1119,771}],0],0}',''),(0,1701031,'0','{path, [[{1701,1984,1368},{1701,1888,1307},{1701,1719,1148},{1701,1602,1159},{1701,1502,1039},{1701,1337,920},{1701,1119,771}],0],0}',''),(0,1701032,'0','{path, [[{1701,1984,1368},{1701,1888,1307},{1701,1719,1148},{1701,1602,1159},{1701,1502,1039},{1701,1337,920},{1701,1119,771}],0],0}',''),(0,1701033,'0','{path, [[{1701,1984,1368},{1701,1888,1307},{1701,1719,1148},{1701,1602,1159},{1701,1502,1039},{1701,1337,920},{1701,1119,771}],0],0}',''),(0,1701034,'0','{path, [[{1701,1984,1368},{1701,1888,1307},{1701,1719,1148},{1701,1602,1159},{1701,1502,1039},{1701,1337,920},{1701,1119,771}],0],0}',''),(0,1701035,'0','{path, [[{1701,1984,1368},{1701,1888,1307},{1701,1719,1148},{1701,1602,1159},{1701,1502,1039},{1701,1337,920},{1701,1119,771}],0],0}',''),(0,1701036,'0','{path, [[{1701,1984,1368},{1701,1888,1307},{1701,1719,1148},{1701,1602,1159},{1701,1502,1039},{1701,1337,920},{1701,1119,771}],0],0}',''),(0,1790001,'','{msg,[51510002],10000},{nochange,0,cycle}',''),(5,1790001,'0','{msg,[51510002],10000},{nochange,0,cycle}',''),(0,2401001,'0','{path,[[{5500,3132,4361},{5500,3255,4361},{5500,3378,4361},{5500,3501,4361},{5500,3624,4361},{5500,3747,4361},{5500,3870,4361},{5500,3993,4361},{5500,4116,4361},{5500,4239,4361},{5500,4362,4361},{5500,4485,4361},{5500,4608,4361},{5500,4731,4361},{5500,4854,4361},{5500,4977,4361},{5500,5100,4361},{5500,5223,4361},{5500,5346,4361},{5500,5469,4361},{5500,5592,4361},{5500,5715,4361},{5500,5838,4361},{5500,5961,4361},{5500,6084,4361},{5500,6207,4361},{5500,6330,4361},{5500,6453,4361},{5500,6576,4361},{5500,6699,4361},{5500,6822,4361},{5500,6929,4361}],0],0}',''),(6,2401001,'0','{remove,0,0}',''),(0,2401002,'0','{path,[[{5500,3132,4361},{5500,3255,4361},{5500,3378,4361},{5500,3501,4361},{5500,3624,4361},{5500,3747,4361},{5500,3870,4361},{5500,3993,4361},{5500,4116,4361},{5500,4239,4361},{5500,4362,4361},{5500,4485,4361},{5500,4608,4361},{5500,4731,4361},{5500,4854,4361},{5500,4977,4361},{5500,5100,4361},{5500,5223,4361},{5500,5346,4361},{5500,5469,4361},{5500,5592,4361},{5500,5715,4361},{5500,5838,4361},{5500,5961,4361},{5500,6084,4361},{5500,6207,4361},{5500,6330,4361},{5500,6453,4361},{5500,6576,4361},{5500,6699,4361},{5500,6822,4361},{5500,6929,4361}],0],0}',''),(6,2401002,'0','{remove,0,0}',''),(0,2401003,'0','{path,[[{5500,3132,4361},{5500,3255,4361},{5500,3378,4361},{5500,3501,4361},{5500,3624,4361},{5500,3747,4361},{5500,3870,4361},{5500,3993,4361},{5500,4116,4361},{5500,4239,4361},{5500,4362,4361},{5500,4485,4361},{5500,4608,4361},{5500,4731,4361},{5500,4854,4361},{5500,4977,4361},{5500,5100,4361},{5500,5223,4361},{5500,5346,4361},{5500,5469,4361},{5500,5592,4361},{5500,5715,4361},{5500,5838,4361},{5500,5961,4361},{5500,6084,4361},{5500,6207,4361},{5500,6330,4361},{5500,6453,4361},{5500,6576,4361},{5500,6699,4361},{5500,6822,4361},{5500,6929,4361}],0],0}',''),(6,2401003,'0','{remove,0,0}',''),(0,2401004,'0','{path,[[{5500,3132,4361},{5500,3255,4361},{5500,3378,4361},{5500,3501,4361},{5500,3624,4361},{5500,3747,4361},{5500,3870,4361},{5500,3993,4361},{5500,4116,4361},{5500,4239,4361},{5500,4362,4361},{5500,4485,4361},{5500,4608,4361},{5500,4731,4361},{5500,4854,4361},{5500,4977,4361},{5500,5100,4361},{5500,5223,4361},{5500,5346,4361},{5500,5469,4361},{5500,5592,4361},{5500,5715,4361},{5500,5838,4361},{5500,5961,4361},{5500,6084,4361},{5500,6207,4361},{5500,6330,4361},{5500,6453,4361},{5500,6576,4361},{5500,6699,4361},{5500,6822,4361},{5500,6929,4361}],0],0}',''),(6,2401004,'0','{remove,0,0}',''),(0,2401005,'0','{path,[[{5500,3132,4361},{5500,3255,4361},{5500,3378,4361},{5500,3501,4361},{5500,3624,4361},{5500,3747,4361},{5500,3870,4361},{5500,3993,4361},{5500,4116,4361},{5500,4239,4361},{5500,4362,4361},{5500,4485,4361},{5500,4608,4361},{5500,4731,4361},{5500,4854,4361},{5500,4977,4361},{5500,5100,4361},{5500,5223,4361},{5500,5346,4361},{5500,5469,4361},{5500,5592,4361},{5500,5715,4361},{5500,5838,4361},{5500,5961,4361},{5500,6084,4361},{5500,6207,4361},{5500,6330,4361},{5500,6453,4361},{5500,6576,4361},{5500,6699,4361},{5500,6822,4361},{5500,6929,4361}],0],0}',''),(6,2401005,'0','{remove,0,0}',''),(0,2401006,'0','{path,[[{5500,3132,4361},{5500,3255,4361},{5500,3378,4361},{5500,3501,4361},{5500,3624,4361},{5500,3747,4361},{5500,3870,4361},{5500,3993,4361},{5500,4116,4361},{5500,4239,4361},{5500,4362,4361},{5500,4485,4361},{5500,4608,4361},{5500,4731,4361},{5500,4854,4361},{5500,4977,4361},{5500,5100,4361},{5500,5223,4361},{5500,5346,4361},{5500,5469,4361},{5500,5592,4361},{5500,5715,4361},{5500,5838,4361},{5500,5961,4361},{5500,6084,4361},{5500,6207,4361},{5500,6330,4361},{5500,6453,4361},{5500,6576,4361},{5500,6699,4361},{5500,6822,4361},{5500,6929,4361}],0],0}',''),(6,2401006,'0','{remove,0,0}',''),(0,2401007,'0','{path,[[{5500,3132,4361},{5500,3255,4361},{5500,3378,4361},{5500,3501,4361},{5500,3624,4361},{5500,3747,4361},{5500,3870,4361},{5500,3993,4361},{5500,4116,4361},{5500,4239,4361},{5500,4362,4361},{5500,4485,4361},{5500,4608,4361},{5500,4731,4361},{5500,4854,4361},{5500,4977,4361},{5500,5100,4361},{5500,5223,4361},{5500,5346,4361},{5500,5469,4361},{5500,5592,4361},{5500,5715,4361},{5500,5838,4361},{5500,5961,4361},{5500,6084,4361},{5500,6207,4361},{5500,6330,4361},{5500,6453,4361},{5500,6576,4361},{5500,6699,4361},{5500,6822,4361},{5500,6929,4361}],0],0}',''),(6,2401007,'0','{remove,0,0}',''),(0,2401008,'0','{path,[[{5500,3132,4361},{5500,3255,4361},{5500,3378,4361},{5500,3501,4361},{5500,3624,4361},{5500,3747,4361},{5500,3870,4361},{5500,3993,4361},{5500,4116,4361},{5500,4239,4361},{5500,4362,4361},{5500,4485,4361},{5500,4608,4361},{5500,4731,4361},{5500,4854,4361},{5500,4977,4361},{5500,5100,4361},{5500,5223,4361},{5500,5346,4361},{5500,5469,4361},{5500,5592,4361},{5500,5715,4361},{5500,5838,4361},{5500,5961,4361},{5500,6084,4361},{5500,6207,4361},{5500,6330,4361},{5500,6453,4361},{5500,6576,4361},{5500,6699,4361},{5500,6822,4361},{5500,6929,4361}],0],0}',''),(6,2401008,'0','{remove,0,0}',''),(2,3101002,'0','{msg,[31010020],1000},{nochange,0,cycle}',''),(5,3101002,'0','{msg,[31010021],500},{create_mon,[10000,3101010,1136,1136,3073,3073,1,[] ],0},{create_mon,[10000,3101010,806,806,2887,2887,1,[] ],0},{create_mon,[10000,3101010,1077,1077,2640,2640,1,[] ],0},{create_mon,[10000,3101010,1460,1460,2847,2847,1,[] ],30000},{nochange,0,cycle}',''),(2,3101003,'0','{msg,[31010020],1000},{nochange,0,cycle}',''),(5,3101003,'0','{msg,[31010021],500},{create_mon,[10000,3101010,1136,1136,3073,3073,1,[] ],0},{create_mon,[10000,3101010,806,806,2887,2887,1,[] ],0},{create_mon,[10000,3101010,1077,1077,2640,2640,1,[] ],0},{create_mon,[10000,3101010,1460,1460,2847,2847,1,[] ],30000},{nochange,0,cycle}',''),(2,3101004,'0','{msg,[31010020],1000},{nochange,0,cycle}',''),(5,3101004,'0','{msg,[31010021],500},{create_mon,[10000,3101010,1136,1136,3073,3073,1,[] ],0},{create_mon,[10000,3101010,806,806,2887,2887,1,[] ],0},{create_mon,[10000,3101010,1077,1077,2640,2640,1,[] ],0},{create_mon,[10000,3101010,1460,1460,2847,2847,1,[] ],30000},{nochange,0,cycle}',''),(2,3101005,'0','{msg,[31010020],1000},{nochange,0,cycle}',''),(5,3101005,'0','{msg,[31010021],500},{create_mon,[10000,3101010,1136,1136,3073,3073,1,[] ],0},{create_mon,[10000,3101010,806,806,2887,2887,1,[] ],0},{create_mon,[10000,3101010,1077,1077,2640,2640,1,[] ],0},{create_mon,[10000,3101010,1460,1460,2847,2847,1,[] ],30000},{nochange,0,cycle}',''),(2,3101006,'0','{msg,[31010020],1000},{nochange,0,cycle}',''),(5,3101006,'0','{msg,[31010021],500},{create_mon,[10000,3101010,1136,1136,3073,3073,1,[] ],0},{create_mon,[10000,3101010,806,806,2887,2887,1,[] ],0},{create_mon,[10000,3101010,1077,1077,2640,2640,1,[] ],0},{create_mon,[10000,3101010,1460,1460,2847,2847,1,[] ],30000},{nochange,0,cycle}',''),(2,3102002,'0','{msg,[31010022],10000},{nochange,0,cycle}',''),(5,3102002,'0','{msg,[31010023],500},{ac_skill,[{25000003,1}],15000},{nochange,0,cycle}',''),(2,3102003,'0','{msg,[31010022],10000},{nochange,0,cycle}',''),(5,3102003,'0','{msg,[31010023],500},{ac_skill,[{25000003,1}],15000},{nochange,0,cycle}',''),(2,3102004,'0','{msg,[31010022],10000},{nochange,0,cycle}',''),(5,3102004,'0','{msg,[31010023],500},{ac_skill,[{25000003,1}],15000},{nochange,0,cycle}',''),(2,3102005,'0','{msg,[31010022],10000},{nochange,0,cycle}',''),(5,3102005,'0','{msg,[31010023],500},{ac_skill,[{25000003,1}],15000},{nochange,0,cycle}',''),(2,3102006,'0','{msg,[31010022],10000},{nochange,0,cycle}',''),(5,3102006,'0','{msg,[31010023],500},{ac_skill,[{25000003,1}],15000},{nochange,0,cycle}',''),(2,3103002,'0','{msg,[31010024],10000},{nochange,0,cycle}',''),(5,3103002,'0','{msg,[31010025],500},{create_mon,[10000,3103010,-3,-3,-3,-3,0,[] ],20000},{nochange,0,cycle}',''),(2,3103003,'0','{msg,[31010024],10000},{nochange,0,cycle}',''),(5,3103003,'0','{msg,[31010025],500},{create_mon,[10000,3103010,-3,-3,-3,-3,0,[] ],10000},{nochange,0,cycle}',''),(2,3103004,'0','{msg,[31010024],10000},{nochange,0,cycle}',''),(5,3103004,'0','{msg,[31010025],500},{create_mon,[10000,3103010,-3,-3,-3,-3,0,[] ],10000},{nochange,0,cycle}',''),(2,3103005,'0','{msg,[31010024],10000},{nochange,0,cycle}',''),(5,3103005,'0','{msg,[31010025],500},{create_mon,[10000,3103010,-3,-3,-3,-3,0,[] ],10000},{nochange,0,cycle}',''),(2,3103006,'0','{msg,[31010024],10000},{nochange,0,cycle}',''),(5,3103006,'0','{msg,[31010025],500},{create_mon,[10000,3103010,-3,-3,-3,-3,0,[] ],10000},{nochange,0,cycle}',''),(0,3103010,'0','{remove,1000,500},{ac_skill,{act_now,25000002,1},0}',''),(2,3104002,'0','{msg,[31010026],10000},{nochange,0,cycle}',''),(5,3104002,'0','{ac_skill,[{25000003,1}],10000},{nochange,0,cycle}',''),(2,3104003,'0','{msg,[31010026],10000},{nochange,0,cycle}',''),(5,3104003,'0','{ac_skill,[{25000003,1}],10000},{nochange,0,cycle}',''),(2,3104004,'0','{msg,[31010026],10000},{nochange,0,cycle}',''),(5,3104004,'0','{ac_skill,[{25000003,1}],10000},{nochange,0,cycle}',''),(2,3104005,'0','{msg,[31010026],10000},{nochange,0,cycle}',''),(5,3104005,'0','{ac_skill,[{25000003,1}],10000},{nochange,0,cycle}',''),(2,3104006,'0','{msg,[31010026],10000},{nochange,0,cycle}',''),(5,3104006,'0','{ac_skill,[{25000003,1}],10000},{nochange,0,cycle}',''),(2,3105002,'0','{msg,[31010027],10000},{nochange,0,cycle}',''),(5,3105002,'0','{msg,[31010028],500},{create_mon,[10000,3105010,3054,3054,2300,2300,1,[] ],0},{create_mon,[10000,3105010,3224,3224,1978,1978,1,[] ],0},{create_mon,[10000,3105010,3652,3652,2234,2234,1,[] ],20000},{nochange,0,cycle}',''),(2,3105003,'0','{msg,[31010027],10000},{nochange,0,cycle}',''),(5,3105003,'0','{msg,[31010028],500},{create_mon,[10000,3105010,3054,3054,2300,2300,1,[] ],0},{create_mon,[10000,3105010,3224,3224,1978,1978,1,[] ],0},{create_mon,[10000,3105010,3652,3652,2234,2234,1,[] ],20000},{nochange,0,cycle}',''),(2,3105004,'0','{msg,[31010027],10000},{nochange,0,cycle}',''),(5,3105004,'0','{msg,[31010028],500},{create_mon,[10000,3105010,3054,3054,2300,2300,1,[] ],0},{create_mon,[10000,3105010,3224,3224,1978,1978,1,[] ],0},{create_mon,[10000,3105010,3652,3652,2234,2234,1,[] ],20000},{nochange,0,cycle}',''),(2,3105005,'0','{msg,[31010027],10000},{nochange,0,cycle}',''),(5,3105005,'0','{msg,[31010028],500},{create_mon,[10000,3105010,3054,3054,2300,2300,1,[] ],0},{create_mon,[10000,3105010,3224,3224,1978,1978,1,[] ],0},{create_mon,[10000,3105010,3652,3652,2234,2234,1,[] ],20000},{nochange,0,cycle}',''),(2,3105006,'0','{msg,[31010027],10000},{nochange,0,cycle}',''),(5,3105006,'0','{msg,[31010028],500},{create_mon,[10000,3105010,3054,3054,2300,2300,1,[] ],0},{create_mon,[10000,3105010,3224,3224,1978,1978,1,[] ],0},{create_mon,[10000,3105010,3652,3652,2234,2234,1,[] ],20000},{nochange,0,cycle}',''),(2,3106002,'0','{msg,[31010029],10000},{nochange,0,cycle}',''),(5,3106002,'0','{msg,[31010030],500},{ac_skill,[{25000004,1}],20000},{nochange,0,cycle}',''),(2,3106003,'0','{msg,[31010029],10000},{nochange,0,cycle}',''),(5,3106003,'0','{msg,[31010030],500},{ac_skill,[{25000004,1}],20000},{nochange,0,cycle}',''),(2,3106004,'0','{msg,[31010029],10000},{nochange,0,cycle}',''),(5,3106004,'0','{msg,[31010030],500},{ac_skill,[{25000004,1}],20000},{nochange,0,cycle}',''),(2,3106005,'0','{msg,[31010029],10000},{nochange,0,cycle}',''),(5,3106005,'0','{msg,[31010030],500},{ac_skill,[{25000004,1}],20000},{nochange,0,cycle}',''),(2,3106006,'0','{msg,[31010029],10000},{nochange,0,cycle}',''),(5,3106006,'0','{msg,[31010030],500},{ac_skill,[{25000004,1}],20000},{nochange,0,cycle}',''),(2,3107002,'0','{msg,[31070020],10000},{nochange,0,cycle}',''),(5,3107002,'0','{msg,[31070021],500},{ac_skill,[{25000008,1}],10000},{nochange,0,cycle}',''),(2,3107003,'0','{msg,[31070020],10000},{nochange,0,cycle}',''),(5,3107003,'0','{msg,[31070021],500},{ac_skill,[{25000008,1}],10000},{nochange,0,cycle}',''),(2,3107004,'0','{msg,[31070020],10000},{nochange,0,cycle}',''),(5,3107004,'0','{msg,[31070021],500},{ac_skill,[{25000008,1}],10000},{nochange,0,cycle}',''),(2,3107005,'0','{msg,[31070020],10000},{nochange,0,cycle}',''),(5,3107005,'0','{msg,[31070021],500},{ac_skill,[{25000008,1}],10000},{nochange,0,cycle}',''),(2,3107006,'0','{msg,[31070020],10000},{nochange,0,cycle}',''),(5,3107006,'0','{msg,[31070021],500},{ac_skill,[{25000008,1}],10000},{nochange,0,cycle}',''),(2,3108002,'0','{msg,[31080020],10000},{nochange,0,cycle}',''),(5,3108002,'0','{msg,[31080021],500},{create_mon,[10000,3108010,-3,-3,-3,-3,1,[] ],15000},{nochange,0,cycle}',''),(2,3108003,'0','{msg,[31080020],10000},{nochange,0,cycle}',''),(5,3108003,'0','{msg,[31080021],500},{create_mon,[10000,3108010,-3,-3,-3,-3,1,[] ],15000},{nochange,0,cycle}',''),(2,3108004,'0','{msg,[31080020],10000},{nochange,0,cycle}',''),(5,3108004,'0','{msg,[31080021],500},{create_mon,[10000,3108010,-3,-3,-3,-3,1,[] ],15000},{nochange,0,cycle}',''),(2,3108005,'0','{msg,[31080020],10000},{nochange,0,cycle}',''),(5,3108005,'0','{msg,[31080021],500},{create_mon,[10000,3108010,-3,-3,-3,-3,1,[] ],15000},{nochange,0,cycle}',''),(2,3108006,'0','{msg,[31080020],10000},{nochange,0,cycle}',''),(5,3108006,'0','{msg,[31080021],500},{create_mon,[10000,3108010,-3,-3,-3,-3,1,[] ],15000},{nochange,0,cycle}',''),(0,3108010,'0','{remove,1000,500},{ac_skill,{act_now,25000002,1},0}',''),(2,3109002,'0','{msg,[31090020],10000},{nochange,0,cycle}',''),(5,3109002,'0','{msg,[31090021],500},{ac_skill,[{25000009,1}],10000},{nochange,0,cycle}',''),(2,3109003,'0','{msg,[31090020],10000},{nochange,0,cycle}',''),(5,3109003,'0','{msg,[31090021],500},{ac_skill,[{25000009,1}],10000},{nochange,0,cycle}',''),(2,3109004,'0','{msg,[31090020],10000},{nochange,0,cycle}',''),(5,3109004,'0','{msg,[31090021],500},{ac_skill,[{25000009,1}],10000},{nochange,0,cycle}',''),(2,3109005,'0','{msg,[31090020],10000},{nochange,0,cycle}',''),(5,3109005,'0','{msg,[31090021],500},{ac_skill,[{25000009,1}],10000},{nochange,0,cycle}',''),(2,3109006,'0','{msg,[31090020],10000},{nochange,0,cycle}',''),(5,3109006,'0','{msg,[31090021],500},{ac_skill,[{25000009,1}],10000},{nochange,0,cycle}',''),(0,4201111,'0','{path,[[{42011,5783,11557},{42011,5775,11491},{42011,5771,11424},{42011,5766,11358},{42011,5762,11291},{42011,5760,11224},{42011,5758,11157},{42011,5756,11090},{42011,5754,11024},{42011,5752,10957},{42011,5751,10890},{42011,5751,10823},{42011,5752,10756},{42011,5753,10689},{42011,5754,10622},{42011,5755,10556},{42011,5756,10489},{42011,5756,10422},{42011,5756,10355},{42011,5756,10288},{42011,5756,10221},{42011,5756,10154},{42011,5756,10088},{42011,5756,10021},{42011,5756,9954},{42011,5756,9887},{42011,5756,9820},{42011,5756,9753},{42011,5756,9686},{42011,5756,9620},{42011,5756,9553},{42011,5756,9486},{42011,5756,9419},{42011,5756,9352},{42011,5756,9285},{42011,5756,9218},{42011,5756,9151},{42011,5756,9085},{42011,5756,9018},{42011,5756,8951},{42011,5756,8884},{42011,5756,8817},{42011,5756,8750},{42011,5756,8683},{42011,5756,8617},{42011,5756,8550},{42011,5756,8483},{42011,5756,8416},{42011,5756,8349},{42011,5756,8282},{42011,5756,8215},{42011,5756,8148},{42011,5756,8082},{42011,5756,8015},{42011,5756,7948},{42011,5756,7881},{42011,5756,7814},{42011,5756,7747},{42011,5756,7680},{42011,5756,7614},{42011,5756,7547},{42011,5756,7480},{42011,5756,7413},{42011,5756,7346},{42011,5756,7279},{42011,5756,7212},{42011,5756,7146},{42011,5756,7079},{42011,5756,7012},{42011,5756,6945},{42011,5756,6878},{42011,5756,6811},{42011,5756,6744},{42011,5756,6677},{42011,5756,6611},{42011,5756,6544},{42011,5756,6477},{42011,5756,6410},{42011,5756,6343},{42011,5756,6276},{42011,5756,6209},{42011,5756,6143},{42011,5756,6076},{42011,5756,6009},{42011,5756,5942},{42011,5756,5875},{42011,5756,5808},{42011,5756,5741},{42011,5756,5675},{42011,5756,5608},{42011,5756,5541},{42011,5756,5474},{42011,5756,5407},{42011,5756,5340},{42011,5756,5273},{42011,5756,5206},{42011,5756,5140},{42011,5756,5073},{42011,5757,5006},{42011,5760,4939},{42011,5771,4873},{42011,5790,4809},{42011,5810,4745},{42011,5830,4681},{42011,5864,4614},{42011,5903,4547},{42011,5941,4481},{42011,5979,4415},{42011,6017,4349},{42011,6056,4283},{42011,6097,4218},{42011,6138,4154},{42011,6180,4090},{42011,6221,4026},{42011,6221,4026}],0],0}',''),(0,4201112,'0','{path,[[{42011,5783,11557},{42011,5775,11491},{42011,5771,11424},{42011,5766,11358},{42011,5762,11291},{42011,5760,11224},{42011,5758,11157},{42011,5756,11090},{42011,5754,11024},{42011,5752,10957},{42011,5751,10890},{42011,5751,10823},{42011,5752,10756},{42011,5753,10689},{42011,5754,10622},{42011,5755,10556},{42011,5756,10489},{42011,5756,10422},{42011,5756,10355},{42011,5756,10288},{42011,5756,10221},{42011,5756,10154},{42011,5756,10088},{42011,5756,10021},{42011,5756,9954},{42011,5756,9887},{42011,5756,9820},{42011,5756,9753},{42011,5756,9686},{42011,5756,9620},{42011,5756,9553},{42011,5756,9486},{42011,5756,9419},{42011,5756,9352},{42011,5756,9285},{42011,5756,9218},{42011,5756,9151},{42011,5756,9085},{42011,5756,9018},{42011,5756,8951},{42011,5756,8884},{42011,5756,8817},{42011,5756,8750},{42011,5756,8683},{42011,5756,8617},{42011,5756,8550},{42011,5756,8483},{42011,5756,8416},{42011,5756,8349},{42011,5756,8282},{42011,5756,8215},{42011,5756,8148},{42011,5756,8082},{42011,5756,8015},{42011,5756,7948},{42011,5756,7881},{42011,5756,7814},{42011,5756,7747},{42011,5756,7680},{42011,5756,7614},{42011,5756,7547},{42011,5756,7480},{42011,5756,7413},{42011,5756,7346},{42011,5756,7279},{42011,5756,7212},{42011,5756,7146},{42011,5756,7079},{42011,5756,7012},{42011,5756,6945},{42011,5756,6878},{42011,5756,6811},{42011,5756,6744},{42011,5756,6677},{42011,5756,6611},{42011,5756,6544},{42011,5756,6477},{42011,5756,6410},{42011,5756,6343},{42011,5756,6276},{42011,5756,6209},{42011,5756,6143},{42011,5756,6076},{42011,5756,6009},{42011,5756,5942},{42011,5756,5875},{42011,5756,5808},{42011,5756,5741},{42011,5756,5675},{42011,5756,5608},{42011,5756,5541},{42011,5756,5474},{42011,5756,5407},{42011,5756,5340},{42011,5756,5273},{42011,5756,5206},{42011,5756,5140},{42011,5756,5073},{42011,5757,5006},{42011,5760,4939},{42011,5771,4873},{42011,5790,4809},{42011,5810,4745},{42011,5830,4681},{42011,5864,4614},{42011,5903,4547},{42011,5941,4481},{42011,5979,4415},{42011,6017,4349},{42011,6056,4283},{42011,6097,4218},{42011,6138,4154},{42011,6180,4090},{42011,6221,4026},{42011,6221,4026}],0],0}',''),(0,4201121,'0','{path,[[{42011,5783,11557},{42011,5775,11491},{42011,5771,11424},{42011,5766,11358},{42011,5762,11291},{42011,5760,11224},{42011,5758,11157},{42011,5756,11090},{42011,5754,11024},{42011,5752,10957},{42011,5751,10890},{42011,5751,10823},{42011,5752,10756},{42011,5753,10689},{42011,5754,10622},{42011,5755,10556},{42011,5756,10489},{42011,5756,10422},{42011,5756,10355},{42011,5756,10288},{42011,5756,10221},{42011,5756,10154},{42011,5756,10088},{42011,5756,10021},{42011,5756,9954},{42011,5756,9887},{42011,5756,9820},{42011,5756,9753},{42011,5756,9686},{42011,5756,9620},{42011,5756,9553},{42011,5756,9486},{42011,5756,9419},{42011,5756,9352},{42011,5756,9285},{42011,5756,9218},{42011,5756,9151},{42011,5756,9085},{42011,5756,9018},{42011,5756,8951},{42011,5756,8884},{42011,5756,8817},{42011,5756,8750},{42011,5756,8683},{42011,5756,8617},{42011,5756,8550},{42011,5756,8483},{42011,5756,8416},{42011,5756,8349},{42011,5756,8282},{42011,5756,8215},{42011,5756,8148},{42011,5756,8082},{42011,5756,8015},{42011,5756,7948},{42011,5756,7881},{42011,5756,7814},{42011,5756,7747},{42011,5756,7680},{42011,5756,7614},{42011,5756,7547},{42011,5756,7480},{42011,5756,7413},{42011,5756,7346},{42011,5756,7279},{42011,5756,7212},{42011,5756,7146},{42011,5756,7079},{42011,5756,7012},{42011,5756,6945},{42011,5756,6878},{42011,5756,6811},{42011,5756,6744},{42011,5756,6677},{42011,5756,6611},{42011,5756,6544},{42011,5756,6477},{42011,5756,6410},{42011,5756,6343},{42011,5756,6276},{42011,5756,6209},{42011,5756,6143},{42011,5756,6076},{42011,5756,6009},{42011,5756,5942},{42011,5756,5875},{42011,5756,5808},{42011,5756,5741},{42011,5756,5675},{42011,5756,5608},{42011,5756,5541},{42011,5756,5474},{42011,5756,5407},{42011,5756,5340},{42011,5756,5273},{42011,5756,5206},{42011,5756,5140},{42011,5756,5073},{42011,5757,5006},{42011,5760,4939},{42011,5771,4873},{42011,5790,4809},{42011,5810,4745},{42011,5830,4681},{42011,5864,4614},{42011,5903,4547},{42011,5941,4481},{42011,5979,4415},{42011,6017,4349},{42011,6056,4283},{42011,6097,4218},{42011,6138,4154},{42011,6180,4090},{42011,6221,4026},{42011,6221,4026}],0],0}',''),(0,4201122,'0','{path,[[{42011,5783,11557},{42011,5775,11491},{42011,5771,11424},{42011,5766,11358},{42011,5762,11291},{42011,5760,11224},{42011,5758,11157},{42011,5756,11090},{42011,5754,11024},{42011,5752,10957},{42011,5751,10890},{42011,5751,10823},{42011,5752,10756},{42011,5753,10689},{42011,5754,10622},{42011,5755,10556},{42011,5756,10489},{42011,5756,10422},{42011,5756,10355},{42011,5756,10288},{42011,5756,10221},{42011,5756,10154},{42011,5756,10088},{42011,5756,10021},{42011,5756,9954},{42011,5756,9887},{42011,5756,9820},{42011,5756,9753},{42011,5756,9686},{42011,5756,9620},{42011,5756,9553},{42011,5756,9486},{42011,5756,9419},{42011,5756,9352},{42011,5756,9285},{42011,5756,9218},{42011,5756,9151},{42011,5756,9085},{42011,5756,9018},{42011,5756,8951},{42011,5756,8884},{42011,5756,8817},{42011,5756,8750},{42011,5756,8683},{42011,5756,8617},{42011,5756,8550},{42011,5756,8483},{42011,5756,8416},{42011,5756,8349},{42011,5756,8282},{42011,5756,8215},{42011,5756,8148},{42011,5756,8082},{42011,5756,8015},{42011,5756,7948},{42011,5756,7881},{42011,5756,7814},{42011,5756,7747},{42011,5756,7680},{42011,5756,7614},{42011,5756,7547},{42011,5756,7480},{42011,5756,7413},{42011,5756,7346},{42011,5756,7279},{42011,5756,7212},{42011,5756,7146},{42011,5756,7079},{42011,5756,7012},{42011,5756,6945},{42011,5756,6878},{42011,5756,6811},{42011,5756,6744},{42011,5756,6677},{42011,5756,6611},{42011,5756,6544},{42011,5756,6477},{42011,5756,6410},{42011,5756,6343},{42011,5756,6276},{42011,5756,6209},{42011,5756,6143},{42011,5756,6076},{42011,5756,6009},{42011,5756,5942},{42011,5756,5875},{42011,5756,5808},{42011,5756,5741},{42011,5756,5675},{42011,5756,5608},{42011,5756,5541},{42011,5756,5474},{42011,5756,5407},{42011,5756,5340},{42011,5756,5273},{42011,5756,5206},{42011,5756,5140},{42011,5756,5073},{42011,5757,5006},{42011,5760,4939},{42011,5771,4873},{42011,5790,4809},{42011,5810,4745},{42011,5830,4681},{42011,5864,4614},{42011,5903,4547},{42011,5941,4481},{42011,5979,4415},{42011,6017,4349},{42011,6056,4283},{42011,6097,4218},{42011,6138,4154},{42011,6180,4090},{42011,6221,4026},{42011,6221,4026}],0],0}',''),(0,4201131,'0','{path,[[{42011,5783,11557},{42011,5775,11491},{42011,5771,11424},{42011,5766,11358},{42011,5762,11291},{42011,5760,11224},{42011,5758,11157},{42011,5756,11090},{42011,5754,11024},{42011,5752,10957},{42011,5751,10890},{42011,5751,10823},{42011,5752,10756},{42011,5753,10689},{42011,5754,10622},{42011,5755,10556},{42011,5756,10489},{42011,5756,10422},{42011,5756,10355},{42011,5756,10288},{42011,5756,10221},{42011,5756,10154},{42011,5756,10088},{42011,5756,10021},{42011,5756,9954},{42011,5756,9887},{42011,5756,9820},{42011,5756,9753},{42011,5756,9686},{42011,5756,9620},{42011,5756,9553},{42011,5756,9486},{42011,5756,9419},{42011,5756,9352},{42011,5756,9285},{42011,5756,9218},{42011,5756,9151},{42011,5756,9085},{42011,5756,9018},{42011,5756,8951},{42011,5756,8884},{42011,5756,8817},{42011,5756,8750},{42011,5756,8683},{42011,5756,8617},{42011,5756,8550},{42011,5756,8483},{42011,5756,8416},{42011,5756,8349},{42011,5756,8282},{42011,5756,8215},{42011,5756,8148},{42011,5756,8082},{42011,5756,8015},{42011,5756,7948},{42011,5756,7881},{42011,5756,7814},{42011,5756,7747},{42011,5756,7680},{42011,5756,7614},{42011,5756,7547},{42011,5756,7480},{42011,5756,7413},{42011,5756,7346},{42011,5756,7279},{42011,5756,7212},{42011,5756,7146},{42011,5756,7079},{42011,5756,7012},{42011,5756,6945},{42011,5756,6878},{42011,5756,6811},{42011,5756,6744},{42011,5756,6677},{42011,5756,6611},{42011,5756,6544},{42011,5756,6477},{42011,5756,6410},{42011,5756,6343},{42011,5756,6276},{42011,5756,6209},{42011,5756,6143},{42011,5756,6076},{42011,5756,6009},{42011,5756,5942},{42011,5756,5875},{42011,5756,5808},{42011,5756,5741},{42011,5756,5675},{42011,5756,5608},{42011,5756,5541},{42011,5756,5474},{42011,5756,5407},{42011,5756,5340},{42011,5756,5273},{42011,5756,5206},{42011,5756,5140},{42011,5756,5073},{42011,5757,5006},{42011,5760,4939},{42011,5771,4873},{42011,5790,4809},{42011,5810,4745},{42011,5830,4681},{42011,5864,4614},{42011,5903,4547},{42011,5941,4481},{42011,5979,4415},{42011,6017,4349},{42011,6056,4283},{42011,6097,4218},{42011,6138,4154},{42011,6180,4090},{42011,6221,4026},{42011,6221,4026}],0],0}',''),(0,4201132,'0','{path,[[{42011,5783,11557},{42011,5775,11491},{42011,5771,11424},{42011,5766,11358},{42011,5762,11291},{42011,5760,11224},{42011,5758,11157},{42011,5756,11090},{42011,5754,11024},{42011,5752,10957},{42011,5751,10890},{42011,5751,10823},{42011,5752,10756},{42011,5753,10689},{42011,5754,10622},{42011,5755,10556},{42011,5756,10489},{42011,5756,10422},{42011,5756,10355},{42011,5756,10288},{42011,5756,10221},{42011,5756,10154},{42011,5756,10088},{42011,5756,10021},{42011,5756,9954},{42011,5756,9887},{42011,5756,9820},{42011,5756,9753},{42011,5756,9686},{42011,5756,9620},{42011,5756,9553},{42011,5756,9486},{42011,5756,9419},{42011,5756,9352},{42011,5756,9285},{42011,5756,9218},{42011,5756,9151},{42011,5756,9085},{42011,5756,9018},{42011,5756,8951},{42011,5756,8884},{42011,5756,8817},{42011,5756,8750},{42011,5756,8683},{42011,5756,8617},{42011,5756,8550},{42011,5756,8483},{42011,5756,8416},{42011,5756,8349},{42011,5756,8282},{42011,5756,8215},{42011,5756,8148},{42011,5756,8082},{42011,5756,8015},{42011,5756,7948},{42011,5756,7881},{42011,5756,7814},{42011,5756,7747},{42011,5756,7680},{42011,5756,7614},{42011,5756,7547},{42011,5756,7480},{42011,5756,7413},{42011,5756,7346},{42011,5756,7279},{42011,5756,7212},{42011,5756,7146},{42011,5756,7079},{42011,5756,7012},{42011,5756,6945},{42011,5756,6878},{42011,5756,6811},{42011,5756,6744},{42011,5756,6677},{42011,5756,6611},{42011,5756,6544},{42011,5756,6477},{42011,5756,6410},{42011,5756,6343},{42011,5756,6276},{42011,5756,6209},{42011,5756,6143},{42011,5756,6076},{42011,5756,6009},{42011,5756,5942},{42011,5756,5875},{42011,5756,5808},{42011,5756,5741},{42011,5756,5675},{42011,5756,5608},{42011,5756,5541},{42011,5756,5474},{42011,5756,5407},{42011,5756,5340},{42011,5756,5273},{42011,5756,5206},{42011,5756,5140},{42011,5756,5073},{42011,5757,5006},{42011,5760,4939},{42011,5771,4873},{42011,5790,4809},{42011,5810,4745},{42011,5830,4681},{42011,5864,4614},{42011,5903,4547},{42011,5941,4481},{42011,5979,4415},{42011,6017,4349},{42011,6056,4283},{42011,6097,4218},{42011,6138,4154},{42011,6180,4090},{42011,6221,4026},{42011,6221,4026}],0],0}',''),(0,4201141,'0','{path,[[{42011,5783,11557},{42011,5775,11491},{42011,5771,11424},{42011,5766,11358},{42011,5762,11291},{42011,5760,11224},{42011,5758,11157},{42011,5756,11090},{42011,5754,11024},{42011,5752,10957},{42011,5751,10890},{42011,5751,10823},{42011,5752,10756},{42011,5753,10689},{42011,5754,10622},{42011,5755,10556},{42011,5756,10489},{42011,5756,10422},{42011,5756,10355},{42011,5756,10288},{42011,5756,10221},{42011,5756,10154},{42011,5756,10088},{42011,5756,10021},{42011,5756,9954},{42011,5756,9887},{42011,5756,9820},{42011,5756,9753},{42011,5756,9686},{42011,5756,9620},{42011,5756,9553},{42011,5756,9486},{42011,5756,9419},{42011,5756,9352},{42011,5756,9285},{42011,5756,9218},{42011,5756,9151},{42011,5756,9085},{42011,5756,9018},{42011,5756,8951},{42011,5756,8884},{42011,5756,8817},{42011,5756,8750},{42011,5756,8683},{42011,5756,8617},{42011,5756,8550},{42011,5756,8483},{42011,5756,8416},{42011,5756,8349},{42011,5756,8282},{42011,5756,8215},{42011,5756,8148},{42011,5756,8082},{42011,5756,8015},{42011,5756,7948},{42011,5756,7881},{42011,5756,7814},{42011,5756,7747},{42011,5756,7680},{42011,5756,7614},{42011,5756,7547},{42011,5756,7480},{42011,5756,7413},{42011,5756,7346},{42011,5756,7279},{42011,5756,7212},{42011,5756,7146},{42011,5756,7079},{42011,5756,7012},{42011,5756,6945},{42011,5756,6878},{42011,5756,6811},{42011,5756,6744},{42011,5756,6677},{42011,5756,6611},{42011,5756,6544},{42011,5756,6477},{42011,5756,6410},{42011,5756,6343},{42011,5756,6276},{42011,5756,6209},{42011,5756,6143},{42011,5756,6076},{42011,5756,6009},{42011,5756,5942},{42011,5756,5875},{42011,5756,5808},{42011,5756,5741},{42011,5756,5675},{42011,5756,5608},{42011,5756,5541},{42011,5756,5474},{42011,5756,5407},{42011,5756,5340},{42011,5756,5273},{42011,5756,5206},{42011,5756,5140},{42011,5756,5073},{42011,5757,5006},{42011,5760,4939},{42011,5771,4873},{42011,5790,4809},{42011,5810,4745},{42011,5830,4681},{42011,5864,4614},{42011,5903,4547},{42011,5941,4481},{42011,5979,4415},{42011,6017,4349},{42011,6056,4283},{42011,6097,4218},{42011,6138,4154},{42011,6180,4090},{42011,6221,4026},{42011,6221,4026}],0],0}',''),(0,4201142,'0','{path,[[{42011,5783,11557},{42011,5775,11491},{42011,5771,11424},{42011,5766,11358},{42011,5762,11291},{42011,5760,11224},{42011,5758,11157},{42011,5756,11090},{42011,5754,11024},{42011,5752,10957},{42011,5751,10890},{42011,5751,10823},{42011,5752,10756},{42011,5753,10689},{42011,5754,10622},{42011,5755,10556},{42011,5756,10489},{42011,5756,10422},{42011,5756,10355},{42011,5756,10288},{42011,5756,10221},{42011,5756,10154},{42011,5756,10088},{42011,5756,10021},{42011,5756,9954},{42011,5756,9887},{42011,5756,9820},{42011,5756,9753},{42011,5756,9686},{42011,5756,9620},{42011,5756,9553},{42011,5756,9486},{42011,5756,9419},{42011,5756,9352},{42011,5756,9285},{42011,5756,9218},{42011,5756,9151},{42011,5756,9085},{42011,5756,9018},{42011,5756,8951},{42011,5756,8884},{42011,5756,8817},{42011,5756,8750},{42011,5756,8683},{42011,5756,8617},{42011,5756,8550},{42011,5756,8483},{42011,5756,8416},{42011,5756,8349},{42011,5756,8282},{42011,5756,8215},{42011,5756,8148},{42011,5756,8082},{42011,5756,8015},{42011,5756,7948},{42011,5756,7881},{42011,5756,7814},{42011,5756,7747},{42011,5756,7680},{42011,5756,7614},{42011,5756,7547},{42011,5756,7480},{42011,5756,7413},{42011,5756,7346},{42011,5756,7279},{42011,5756,7212},{42011,5756,7146},{42011,5756,7079},{42011,5756,7012},{42011,5756,6945},{42011,5756,6878},{42011,5756,6811},{42011,5756,6744},{42011,5756,6677},{42011,5756,6611},{42011,5756,6544},{42011,5756,6477},{42011,5756,6410},{42011,5756,6343},{42011,5756,6276},{42011,5756,6209},{42011,5756,6143},{42011,5756,6076},{42011,5756,6009},{42011,5756,5942},{42011,5756,5875},{42011,5756,5808},{42011,5756,5741},{42011,5756,5675},{42011,5756,5608},{42011,5756,5541},{42011,5756,5474},{42011,5756,5407},{42011,5756,5340},{42011,5756,5273},{42011,5756,5206},{42011,5756,5140},{42011,5756,5073},{42011,5757,5006},{42011,5760,4939},{42011,5771,4873},{42011,5790,4809},{42011,5810,4745},{42011,5830,4681},{42011,5864,4614},{42011,5903,4547},{42011,5941,4481},{42011,5979,4415},{42011,6017,4349},{42011,6056,4283},{42011,6097,4218},{42011,6138,4154},{42011,6180,4090},{42011,6221,4026},{42011,6221,4026}],0],0}',''),(0,4201151,'0','{path,[[{42011,5783,11557},{42011,5775,11491},{42011,5771,11424},{42011,5766,11358},{42011,5762,11291},{42011,5760,11224},{42011,5758,11157},{42011,5756,11090},{42011,5754,11024},{42011,5752,10957},{42011,5751,10890},{42011,5751,10823},{42011,5752,10756},{42011,5753,10689},{42011,5754,10622},{42011,5755,10556},{42011,5756,10489},{42011,5756,10422},{42011,5756,10355},{42011,5756,10288},{42011,5756,10221},{42011,5756,10154},{42011,5756,10088},{42011,5756,10021},{42011,5756,9954},{42011,5756,9887},{42011,5756,9820},{42011,5756,9753},{42011,5756,9686},{42011,5756,9620},{42011,5756,9553},{42011,5756,9486},{42011,5756,9419},{42011,5756,9352},{42011,5756,9285},{42011,5756,9218},{42011,5756,9151},{42011,5756,9085},{42011,5756,9018},{42011,5756,8951},{42011,5756,8884},{42011,5756,8817},{42011,5756,8750},{42011,5756,8683},{42011,5756,8617},{42011,5756,8550},{42011,5756,8483},{42011,5756,8416},{42011,5756,8349},{42011,5756,8282},{42011,5756,8215},{42011,5756,8148},{42011,5756,8082},{42011,5756,8015},{42011,5756,7948},{42011,5756,7881},{42011,5756,7814},{42011,5756,7747},{42011,5756,7680},{42011,5756,7614},{42011,5756,7547},{42011,5756,7480},{42011,5756,7413},{42011,5756,7346},{42011,5756,7279},{42011,5756,7212},{42011,5756,7146},{42011,5756,7079},{42011,5756,7012},{42011,5756,6945},{42011,5756,6878},{42011,5756,6811},{42011,5756,6744},{42011,5756,6677},{42011,5756,6611},{42011,5756,6544},{42011,5756,6477},{42011,5756,6410},{42011,5756,6343},{42011,5756,6276},{42011,5756,6209},{42011,5756,6143},{42011,5756,6076},{42011,5756,6009},{42011,5756,5942},{42011,5756,5875},{42011,5756,5808},{42011,5756,5741},{42011,5756,5675},{42011,5756,5608},{42011,5756,5541},{42011,5756,5474},{42011,5756,5407},{42011,5756,5340},{42011,5756,5273},{42011,5756,5206},{42011,5756,5140},{42011,5756,5073},{42011,5757,5006},{42011,5760,4939},{42011,5771,4873},{42011,5790,4809},{42011,5810,4745},{42011,5830,4681},{42011,5864,4614},{42011,5903,4547},{42011,5941,4481},{42011,5979,4415},{42011,6017,4349},{42011,6056,4283},{42011,6097,4218},{42011,6138,4154},{42011,6180,4090},{42011,6221,4026},{42011,6221,4026}],0],0}',''),(0,4201152,'0','{path,[[{42011,5783,11557},{42011,5775,11491},{42011,5771,11424},{42011,5766,11358},{42011,5762,11291},{42011,5760,11224},{42011,5758,11157},{42011,5756,11090},{42011,5754,11024},{42011,5752,10957},{42011,5751,10890},{42011,5751,10823},{42011,5752,10756},{42011,5753,10689},{42011,5754,10622},{42011,5755,10556},{42011,5756,10489},{42011,5756,10422},{42011,5756,10355},{42011,5756,10288},{42011,5756,10221},{42011,5756,10154},{42011,5756,10088},{42011,5756,10021},{42011,5756,9954},{42011,5756,9887},{42011,5756,9820},{42011,5756,9753},{42011,5756,9686},{42011,5756,9620},{42011,5756,9553},{42011,5756,9486},{42011,5756,9419},{42011,5756,9352},{42011,5756,9285},{42011,5756,9218},{42011,5756,9151},{42011,5756,9085},{42011,5756,9018},{42011,5756,8951},{42011,5756,8884},{42011,5756,8817},{42011,5756,8750},{42011,5756,8683},{42011,5756,8617},{42011,5756,8550},{42011,5756,8483},{42011,5756,8416},{42011,5756,8349},{42011,5756,8282},{42011,5756,8215},{42011,5756,8148},{42011,5756,8082},{42011,5756,8015},{42011,5756,7948},{42011,5756,7881},{42011,5756,7814},{42011,5756,7747},{42011,5756,7680},{42011,5756,7614},{42011,5756,7547},{42011,5756,7480},{42011,5756,7413},{42011,5756,7346},{42011,5756,7279},{42011,5756,7212},{42011,5756,7146},{42011,5756,7079},{42011,5756,7012},{42011,5756,6945},{42011,5756,6878},{42011,5756,6811},{42011,5756,6744},{42011,5756,6677},{42011,5756,6611},{42011,5756,6544},{42011,5756,6477},{42011,5756,6410},{42011,5756,6343},{42011,5756,6276},{42011,5756,6209},{42011,5756,6143},{42011,5756,6076},{42011,5756,6009},{42011,5756,5942},{42011,5756,5875},{42011,5756,5808},{42011,5756,5741},{42011,5756,5675},{42011,5756,5608},{42011,5756,5541},{42011,5756,5474},{42011,5756,5407},{42011,5756,5340},{42011,5756,5273},{42011,5756,5206},{42011,5756,5140},{42011,5756,5073},{42011,5757,5006},{42011,5760,4939},{42011,5771,4873},{42011,5790,4809},{42011,5810,4745},{42011,5830,4681},{42011,5864,4614},{42011,5903,4547},{42011,5941,4481},{42011,5979,4415},{42011,6017,4349},{42011,6056,4283},{42011,6097,4218},{42011,6138,4154},{42011,6180,4090},{42011,6221,4026},{42011,6221,4026}],0],0}',''),(0,4201161,'0','{path,[[{42011,5783,11557},{42011,5775,11491},{42011,5771,11424},{42011,5766,11358},{42011,5762,11291},{42011,5760,11224},{42011,5758,11157},{42011,5756,11090},{42011,5754,11024},{42011,5752,10957},{42011,5751,10890},{42011,5751,10823},{42011,5752,10756},{42011,5753,10689},{42011,5754,10622},{42011,5755,10556},{42011,5756,10489},{42011,5756,10422},{42011,5756,10355},{42011,5756,10288},{42011,5756,10221},{42011,5756,10154},{42011,5756,10088},{42011,5756,10021},{42011,5756,9954},{42011,5756,9887},{42011,5756,9820},{42011,5756,9753},{42011,5756,9686},{42011,5756,9620},{42011,5756,9553},{42011,5756,9486},{42011,5756,9419},{42011,5756,9352},{42011,5756,9285},{42011,5756,9218},{42011,5756,9151},{42011,5756,9085},{42011,5756,9018},{42011,5756,8951},{42011,5756,8884},{42011,5756,8817},{42011,5756,8750},{42011,5756,8683},{42011,5756,8617},{42011,5756,8550},{42011,5756,8483},{42011,5756,8416},{42011,5756,8349},{42011,5756,8282},{42011,5756,8215},{42011,5756,8148},{42011,5756,8082},{42011,5756,8015},{42011,5756,7948},{42011,5756,7881},{42011,5756,7814},{42011,5756,7747},{42011,5756,7680},{42011,5756,7614},{42011,5756,7547},{42011,5756,7480},{42011,5756,7413},{42011,5756,7346},{42011,5756,7279},{42011,5756,7212},{42011,5756,7146},{42011,5756,7079},{42011,5756,7012},{42011,5756,6945},{42011,5756,6878},{42011,5756,6811},{42011,5756,6744},{42011,5756,6677},{42011,5756,6611},{42011,5756,6544},{42011,5756,6477},{42011,5756,6410},{42011,5756,6343},{42011,5756,6276},{42011,5756,6209},{42011,5756,6143},{42011,5756,6076},{42011,5756,6009},{42011,5756,5942},{42011,5756,5875},{42011,5756,5808},{42011,5756,5741},{42011,5756,5675},{42011,5756,5608},{42011,5756,5541},{42011,5756,5474},{42011,5756,5407},{42011,5756,5340},{42011,5756,5273},{42011,5756,5206},{42011,5756,5140},{42011,5756,5073},{42011,5757,5006},{42011,5760,4939},{42011,5771,4873},{42011,5790,4809},{42011,5810,4745},{42011,5830,4681},{42011,5864,4614},{42011,5903,4547},{42011,5941,4481},{42011,5979,4415},{42011,6017,4349},{42011,6056,4283},{42011,6097,4218},{42011,6138,4154},{42011,6180,4090},{42011,6221,4026},{42011,6221,4026}],0],0}',''),(0,4201162,'0','{path,[[{42011,5783,11557},{42011,5775,11491},{42011,5771,11424},{42011,5766,11358},{42011,5762,11291},{42011,5760,11224},{42011,5758,11157},{42011,5756,11090},{42011,5754,11024},{42011,5752,10957},{42011,5751,10890},{42011,5751,10823},{42011,5752,10756},{42011,5753,10689},{42011,5754,10622},{42011,5755,10556},{42011,5756,10489},{42011,5756,10422},{42011,5756,10355},{42011,5756,10288},{42011,5756,10221},{42011,5756,10154},{42011,5756,10088},{42011,5756,10021},{42011,5756,9954},{42011,5756,9887},{42011,5756,9820},{42011,5756,9753},{42011,5756,9686},{42011,5756,9620},{42011,5756,9553},{42011,5756,9486},{42011,5756,9419},{42011,5756,9352},{42011,5756,9285},{42011,5756,9218},{42011,5756,9151},{42011,5756,9085},{42011,5756,9018},{42011,5756,8951},{42011,5756,8884},{42011,5756,8817},{42011,5756,8750},{42011,5756,8683},{42011,5756,8617},{42011,5756,8550},{42011,5756,8483},{42011,5756,8416},{42011,5756,8349},{42011,5756,8282},{42011,5756,8215},{42011,5756,8148},{42011,5756,8082},{42011,5756,8015},{42011,5756,7948},{42011,5756,7881},{42011,5756,7814},{42011,5756,7747},{42011,5756,7680},{42011,5756,7614},{42011,5756,7547},{42011,5756,7480},{42011,5756,7413},{42011,5756,7346},{42011,5756,7279},{42011,5756,7212},{42011,5756,7146},{42011,5756,7079},{42011,5756,7012},{42011,5756,6945},{42011,5756,6878},{42011,5756,6811},{42011,5756,6744},{42011,5756,6677},{42011,5756,6611},{42011,5756,6544},{42011,5756,6477},{42011,5756,6410},{42011,5756,6343},{42011,5756,6276},{42011,5756,6209},{42011,5756,6143},{42011,5756,6076},{42011,5756,6009},{42011,5756,5942},{42011,5756,5875},{42011,5756,5808},{42011,5756,5741},{42011,5756,5675},{42011,5756,5608},{42011,5756,5541},{42011,5756,5474},{42011,5756,5407},{42011,5756,5340},{42011,5756,5273},{42011,5756,5206},{42011,5756,5140},{42011,5756,5073},{42011,5757,5006},{42011,5760,4939},{42011,5771,4873},{42011,5790,4809},{42011,5810,4745},{42011,5830,4681},{42011,5864,4614},{42011,5903,4547},{42011,5941,4481},{42011,5979,4415},{42011,6017,4349},{42011,6056,4283},{42011,6097,4218},{42011,6138,4154},{42011,6180,4090},{42011,6221,4026},{42011,6221,4026}],0],0}',''),(0,4201171,'0','{path,[[{42011,5783,11557},{42011,5775,11491},{42011,5771,11424},{42011,5766,11358},{42011,5762,11291},{42011,5760,11224},{42011,5758,11157},{42011,5756,11090},{42011,5754,11024},{42011,5752,10957},{42011,5751,10890},{42011,5751,10823},{42011,5752,10756},{42011,5753,10689},{42011,5754,10622},{42011,5755,10556},{42011,5756,10489},{42011,5756,10422},{42011,5756,10355},{42011,5756,10288},{42011,5756,10221},{42011,5756,10154},{42011,5756,10088},{42011,5756,10021},{42011,5756,9954},{42011,5756,9887},{42011,5756,9820},{42011,5756,9753},{42011,5756,9686},{42011,5756,9620},{42011,5756,9553},{42011,5756,9486},{42011,5756,9419},{42011,5756,9352},{42011,5756,9285},{42011,5756,9218},{42011,5756,9151},{42011,5756,9085},{42011,5756,9018},{42011,5756,8951},{42011,5756,8884},{42011,5756,8817},{42011,5756,8750},{42011,5756,8683},{42011,5756,8617},{42011,5756,8550},{42011,5756,8483},{42011,5756,8416},{42011,5756,8349},{42011,5756,8282},{42011,5756,8215},{42011,5756,8148},{42011,5756,8082},{42011,5756,8015},{42011,5756,7948},{42011,5756,7881},{42011,5756,7814},{42011,5756,7747},{42011,5756,7680},{42011,5756,7614},{42011,5756,7547},{42011,5756,7480},{42011,5756,7413},{42011,5756,7346},{42011,5756,7279},{42011,5756,7212},{42011,5756,7146},{42011,5756,7079},{42011,5756,7012},{42011,5756,6945},{42011,5756,6878},{42011,5756,6811},{42011,5756,6744},{42011,5756,6677},{42011,5756,6611},{42011,5756,6544},{42011,5756,6477},{42011,5756,6410},{42011,5756,6343},{42011,5756,6276},{42011,5756,6209},{42011,5756,6143},{42011,5756,6076},{42011,5756,6009},{42011,5756,5942},{42011,5756,5875},{42011,5756,5808},{42011,5756,5741},{42011,5756,5675},{42011,5756,5608},{42011,5756,5541},{42011,5756,5474},{42011,5756,5407},{42011,5756,5340},{42011,5756,5273},{42011,5756,5206},{42011,5756,5140},{42011,5756,5073},{42011,5757,5006},{42011,5760,4939},{42011,5771,4873},{42011,5790,4809},{42011,5810,4745},{42011,5830,4681},{42011,5864,4614},{42011,5903,4547},{42011,5941,4481},{42011,5979,4415},{42011,6017,4349},{42011,6056,4283},{42011,6097,4218},{42011,6138,4154},{42011,6180,4090},{42011,6221,4026},{42011,6221,4026}],0],0}',''),(0,4201172,'0','{path,[[{42011,5783,11557},{42011,5775,11491},{42011,5771,11424},{42011,5766,11358},{42011,5762,11291},{42011,5760,11224},{42011,5758,11157},{42011,5756,11090},{42011,5754,11024},{42011,5752,10957},{42011,5751,10890},{42011,5751,10823},{42011,5752,10756},{42011,5753,10689},{42011,5754,10622},{42011,5755,10556},{42011,5756,10489},{42011,5756,10422},{42011,5756,10355},{42011,5756,10288},{42011,5756,10221},{42011,5756,10154},{42011,5756,10088},{42011,5756,10021},{42011,5756,9954},{42011,5756,9887},{42011,5756,9820},{42011,5756,9753},{42011,5756,9686},{42011,5756,9620},{42011,5756,9553},{42011,5756,9486},{42011,5756,9419},{42011,5756,9352},{42011,5756,9285},{42011,5756,9218},{42011,5756,9151},{42011,5756,9085},{42011,5756,9018},{42011,5756,8951},{42011,5756,8884},{42011,5756,8817},{42011,5756,8750},{42011,5756,8683},{42011,5756,8617},{42011,5756,8550},{42011,5756,8483},{42011,5756,8416},{42011,5756,8349},{42011,5756,8282},{42011,5756,8215},{42011,5756,8148},{42011,5756,8082},{42011,5756,8015},{42011,5756,7948},{42011,5756,7881},{42011,5756,7814},{42011,5756,7747},{42011,5756,7680},{42011,5756,7614},{42011,5756,7547},{42011,5756,7480},{42011,5756,7413},{42011,5756,7346},{42011,5756,7279},{42011,5756,7212},{42011,5756,7146},{42011,5756,7079},{42011,5756,7012},{42011,5756,6945},{42011,5756,6878},{42011,5756,6811},{42011,5756,6744},{42011,5756,6677},{42011,5756,6611},{42011,5756,6544},{42011,5756,6477},{42011,5756,6410},{42011,5756,6343},{42011,5756,6276},{42011,5756,6209},{42011,5756,6143},{42011,5756,6076},{42011,5756,6009},{42011,5756,5942},{42011,5756,5875},{42011,5756,5808},{42011,5756,5741},{42011,5756,5675},{42011,5756,5608},{42011,5756,5541},{42011,5756,5474},{42011,5756,5407},{42011,5756,5340},{42011,5756,5273},{42011,5756,5206},{42011,5756,5140},{42011,5756,5073},{42011,5757,5006},{42011,5760,4939},{42011,5771,4873},{42011,5790,4809},{42011,5810,4745},{42011,5830,4681},{42011,5864,4614},{42011,5903,4547},{42011,5941,4481},{42011,5979,4415},{42011,6017,4349},{42011,6056,4283},{42011,6097,4218},{42011,6138,4154},{42011,6180,4090},{42011,6221,4026},{42011,6221,4026}],0],0}',''),(0,4201181,'0','{path,[[{42011,5783,11557},{42011,5775,11491},{42011,5771,11424},{42011,5766,11358},{42011,5762,11291},{42011,5760,11224},{42011,5758,11157},{42011,5756,11090},{42011,5754,11024},{42011,5752,10957},{42011,5751,10890},{42011,5751,10823},{42011,5752,10756},{42011,5753,10689},{42011,5754,10622},{42011,5755,10556},{42011,5756,10489},{42011,5756,10422},{42011,5756,10355},{42011,5756,10288},{42011,5756,10221},{42011,5756,10154},{42011,5756,10088},{42011,5756,10021},{42011,5756,9954},{42011,5756,9887},{42011,5756,9820},{42011,5756,9753},{42011,5756,9686},{42011,5756,9620},{42011,5756,9553},{42011,5756,9486},{42011,5756,9419},{42011,5756,9352},{42011,5756,9285},{42011,5756,9218},{42011,5756,9151},{42011,5756,9085},{42011,5756,9018},{42011,5756,8951},{42011,5756,8884},{42011,5756,8817},{42011,5756,8750},{42011,5756,8683},{42011,5756,8617},{42011,5756,8550},{42011,5756,8483},{42011,5756,8416},{42011,5756,8349},{42011,5756,8282},{42011,5756,8215},{42011,5756,8148},{42011,5756,8082},{42011,5756,8015},{42011,5756,7948},{42011,5756,7881},{42011,5756,7814},{42011,5756,7747},{42011,5756,7680},{42011,5756,7614},{42011,5756,7547},{42011,5756,7480},{42011,5756,7413},{42011,5756,7346},{42011,5756,7279},{42011,5756,7212},{42011,5756,7146},{42011,5756,7079},{42011,5756,7012},{42011,5756,6945},{42011,5756,6878},{42011,5756,6811},{42011,5756,6744},{42011,5756,6677},{42011,5756,6611},{42011,5756,6544},{42011,5756,6477},{42011,5756,6410},{42011,5756,6343},{42011,5756,6276},{42011,5756,6209},{42011,5756,6143},{42011,5756,6076},{42011,5756,6009},{42011,5756,5942},{42011,5756,5875},{42011,5756,5808},{42011,5756,5741},{42011,5756,5675},{42011,5756,5608},{42011,5756,5541},{42011,5756,5474},{42011,5756,5407},{42011,5756,5340},{42011,5756,5273},{42011,5756,5206},{42011,5756,5140},{42011,5756,5073},{42011,5757,5006},{42011,5760,4939},{42011,5771,4873},{42011,5790,4809},{42011,5810,4745},{42011,5830,4681},{42011,5864,4614},{42011,5903,4547},{42011,5941,4481},{42011,5979,4415},{42011,6017,4349},{42011,6056,4283},{42011,6097,4218},{42011,6138,4154},{42011,6180,4090},{42011,6221,4026},{42011,6221,4026}],0],0}',''),(0,4201182,'0','{path,[[{42011,5783,11557},{42011,5775,11491},{42011,5771,11424},{42011,5766,11358},{42011,5762,11291},{42011,5760,11224},{42011,5758,11157},{42011,5756,11090},{42011,5754,11024},{42011,5752,10957},{42011,5751,10890},{42011,5751,10823},{42011,5752,10756},{42011,5753,10689},{42011,5754,10622},{42011,5755,10556},{42011,5756,10489},{42011,5756,10422},{42011,5756,10355},{42011,5756,10288},{42011,5756,10221},{42011,5756,10154},{42011,5756,10088},{42011,5756,10021},{42011,5756,9954},{42011,5756,9887},{42011,5756,9820},{42011,5756,9753},{42011,5756,9686},{42011,5756,9620},{42011,5756,9553},{42011,5756,9486},{42011,5756,9419},{42011,5756,9352},{42011,5756,9285},{42011,5756,9218},{42011,5756,9151},{42011,5756,9085},{42011,5756,9018},{42011,5756,8951},{42011,5756,8884},{42011,5756,8817},{42011,5756,8750},{42011,5756,8683},{42011,5756,8617},{42011,5756,8550},{42011,5756,8483},{42011,5756,8416},{42011,5756,8349},{42011,5756,8282},{42011,5756,8215},{42011,5756,8148},{42011,5756,8082},{42011,5756,8015},{42011,5756,7948},{42011,5756,7881},{42011,5756,7814},{42011,5756,7747},{42011,5756,7680},{42011,5756,7614},{42011,5756,7547},{42011,5756,7480},{42011,5756,7413},{42011,5756,7346},{42011,5756,7279},{42011,5756,7212},{42011,5756,7146},{42011,5756,7079},{42011,5756,7012},{42011,5756,6945},{42011,5756,6878},{42011,5756,6811},{42011,5756,6744},{42011,5756,6677},{42011,5756,6611},{42011,5756,6544},{42011,5756,6477},{42011,5756,6410},{42011,5756,6343},{42011,5756,6276},{42011,5756,6209},{42011,5756,6143},{42011,5756,6076},{42011,5756,6009},{42011,5756,5942},{42011,5756,5875},{42011,5756,5808},{42011,5756,5741},{42011,5756,5675},{42011,5756,5608},{42011,5756,5541},{42011,5756,5474},{42011,5756,5407},{42011,5756,5340},{42011,5756,5273},{42011,5756,5206},{42011,5756,5140},{42011,5756,5073},{42011,5757,5006},{42011,5760,4939},{42011,5771,4873},{42011,5790,4809},{42011,5810,4745},{42011,5830,4681},{42011,5864,4614},{42011,5903,4547},{42011,5941,4481},{42011,5979,4415},{42011,6017,4349},{42011,6056,4283},{42011,6097,4218},{42011,6138,4154},{42011,6180,4090},{42011,6221,4026},{42011,6221,4026}],0],0}',''),(0,4201211,'0','{path,[[{42011,11667,9320},{42011,11593,9259},{42011,11523,9195},{42011,11453,9130},{42011,11383,9064},{42011,11314,8999},{42011,11245,8932},{42011,11185,8871},{42011,11125,8809},{42011,11066,8747},{42011,11007,8685},{42011,10947,8622},{42011,10888,8560},{42011,10829,8498},{42011,10770,8436},{42011,10709,8374},{42011,10639,8310},{42011,10568,8245},{42011,10498,8181},{42011,10428,8116},{42011,10357,8051},{42011,10287,7986},{42011,10217,7922},{42011,10147,7857},{42011,10078,7791},{42011,10008,7726},{42011,9939,7660},{42011,9870,7594},{42011,9801,7527},{42011,9733,7461},{42011,9664,7395},{42011,9595,7328},{42011,9526,7262},{42011,9457,7196},{42011,9389,7130},{42011,9320,7063},{42011,9251,6997},{42011,9182,6931},{42011,9114,6864},{42011,9045,6798},{42011,8976,6732},{42011,8908,6665},{42011,8847,6604},{42011,8787,6543},{42011,8727,6481},{42011,8666,6420},{42011,8606,6359},{42011,8546,6297},{42011,8486,6236},{42011,8425,6175},{42011,8361,6109},{42011,8300,6047},{42011,8240,5986},{42011,8179,5924},{42011,8119,5863},{42011,8059,5802},{42011,7999,5740},{42011,7938,5679},{42011,7878,5618},{42011,7818,5556},{42011,7758,5495},{42011,7697,5434},{42011,7637,5372},{42011,7577,5311},{42011,7517,5250},{42011,7456,5188},{42011,7396,5127},{42011,7336,5066},{42011,7276,5004},{42011,7216,4943},{42011,7155,4882},{42011,7095,4820},{42011,7035,4759},{42011,6975,4698},{42011,6914,4636},{42011,6854,4575},{42011,6794,4514},{42011,6734,4452},{42011,6673,4391},{42011,6613,4330},{42011,6553,4268},{42011,6493,4207},{42011,6432,4146},{42011,6372,4084},{42011,6312,4023},{42011,6285,3996}],0],0}',''),(0,4201212,'0','{path,[[{42011,11667,9320},{42011,11593,9259},{42011,11523,9195},{42011,11453,9130},{42011,11383,9064},{42011,11314,8999},{42011,11245,8932},{42011,11185,8871},{42011,11125,8809},{42011,11066,8747},{42011,11007,8685},{42011,10947,8622},{42011,10888,8560},{42011,10829,8498},{42011,10770,8436},{42011,10709,8374},{42011,10639,8310},{42011,10568,8245},{42011,10498,8181},{42011,10428,8116},{42011,10357,8051},{42011,10287,7986},{42011,10217,7922},{42011,10147,7857},{42011,10078,7791},{42011,10008,7726},{42011,9939,7660},{42011,9870,7594},{42011,9801,7527},{42011,9733,7461},{42011,9664,7395},{42011,9595,7328},{42011,9526,7262},{42011,9457,7196},{42011,9389,7130},{42011,9320,7063},{42011,9251,6997},{42011,9182,6931},{42011,9114,6864},{42011,9045,6798},{42011,8976,6732},{42011,8908,6665},{42011,8847,6604},{42011,8787,6543},{42011,8727,6481},{42011,8666,6420},{42011,8606,6359},{42011,8546,6297},{42011,8486,6236},{42011,8425,6175},{42011,8361,6109},{42011,8300,6047},{42011,8240,5986},{42011,8179,5924},{42011,8119,5863},{42011,8059,5802},{42011,7999,5740},{42011,7938,5679},{42011,7878,5618},{42011,7818,5556},{42011,7758,5495},{42011,7697,5434},{42011,7637,5372},{42011,7577,5311},{42011,7517,5250},{42011,7456,5188},{42011,7396,5127},{42011,7336,5066},{42011,7276,5004},{42011,7216,4943},{42011,7155,4882},{42011,7095,4820},{42011,7035,4759},{42011,6975,4698},{42011,6914,4636},{42011,6854,4575},{42011,6794,4514},{42011,6734,4452},{42011,6673,4391},{42011,6613,4330},{42011,6553,4268},{42011,6493,4207},{42011,6432,4146},{42011,6372,4084},{42011,6312,4023},{42011,6285,3996}],0],0}',''),(0,4201221,'0','{path,[[{42011,11667,9320},{42011,11593,9259},{42011,11523,9195},{42011,11453,9130},{42011,11383,9064},{42011,11314,8999},{42011,11245,8932},{42011,11185,8871},{42011,11125,8809},{42011,11066,8747},{42011,11007,8685},{42011,10947,8622},{42011,10888,8560},{42011,10829,8498},{42011,10770,8436},{42011,10709,8374},{42011,10639,8310},{42011,10568,8245},{42011,10498,8181},{42011,10428,8116},{42011,10357,8051},{42011,10287,7986},{42011,10217,7922},{42011,10147,7857},{42011,10078,7791},{42011,10008,7726},{42011,9939,7660},{42011,9870,7594},{42011,9801,7527},{42011,9733,7461},{42011,9664,7395},{42011,9595,7328},{42011,9526,7262},{42011,9457,7196},{42011,9389,7130},{42011,9320,7063},{42011,9251,6997},{42011,9182,6931},{42011,9114,6864},{42011,9045,6798},{42011,8976,6732},{42011,8908,6665},{42011,8847,6604},{42011,8787,6543},{42011,8727,6481},{42011,8666,6420},{42011,8606,6359},{42011,8546,6297},{42011,8486,6236},{42011,8425,6175},{42011,8361,6109},{42011,8300,6047},{42011,8240,5986},{42011,8179,5924},{42011,8119,5863},{42011,8059,5802},{42011,7999,5740},{42011,7938,5679},{42011,7878,5618},{42011,7818,5556},{42011,7758,5495},{42011,7697,5434},{42011,7637,5372},{42011,7577,5311},{42011,7517,5250},{42011,7456,5188},{42011,7396,5127},{42011,7336,5066},{42011,7276,5004},{42011,7216,4943},{42011,7155,4882},{42011,7095,4820},{42011,7035,4759},{42011,6975,4698},{42011,6914,4636},{42011,6854,4575},{42011,6794,4514},{42011,6734,4452},{42011,6673,4391},{42011,6613,4330},{42011,6553,4268},{42011,6493,4207},{42011,6432,4146},{42011,6372,4084},{42011,6312,4023},{42011,6285,3996}],0],0}',''),(0,4201222,'0','{path,[[{42011,11667,9320},{42011,11593,9259},{42011,11523,9195},{42011,11453,9130},{42011,11383,9064},{42011,11314,8999},{42011,11245,8932},{42011,11185,8871},{42011,11125,8809},{42011,11066,8747},{42011,11007,8685},{42011,10947,8622},{42011,10888,8560},{42011,10829,8498},{42011,10770,8436},{42011,10709,8374},{42011,10639,8310},{42011,10568,8245},{42011,10498,8181},{42011,10428,8116},{42011,10357,8051},{42011,10287,7986},{42011,10217,7922},{42011,10147,7857},{42011,10078,7791},{42011,10008,7726},{42011,9939,7660},{42011,9870,7594},{42011,9801,7527},{42011,9733,7461},{42011,9664,7395},{42011,9595,7328},{42011,9526,7262},{42011,9457,7196},{42011,9389,7130},{42011,9320,7063},{42011,9251,6997},{42011,9182,6931},{42011,9114,6864},{42011,9045,6798},{42011,8976,6732},{42011,8908,6665},{42011,8847,6604},{42011,8787,6543},{42011,8727,6481},{42011,8666,6420},{42011,8606,6359},{42011,8546,6297},{42011,8486,6236},{42011,8425,6175},{42011,8361,6109},{42011,8300,6047},{42011,8240,5986},{42011,8179,5924},{42011,8119,5863},{42011,8059,5802},{42011,7999,5740},{42011,7938,5679},{42011,7878,5618},{42011,7818,5556},{42011,7758,5495},{42011,7697,5434},{42011,7637,5372},{42011,7577,5311},{42011,7517,5250},{42011,7456,5188},{42011,7396,5127},{42011,7336,5066},{42011,7276,5004},{42011,7216,4943},{42011,7155,4882},{42011,7095,4820},{42011,7035,4759},{42011,6975,4698},{42011,6914,4636},{42011,6854,4575},{42011,6794,4514},{42011,6734,4452},{42011,6673,4391},{42011,6613,4330},{42011,6553,4268},{42011,6493,4207},{42011,6432,4146},{42011,6372,4084},{42011,6312,4023},{42011,6285,3996}],0],0}',''),(0,4201231,'0','{path,[[{42011,11667,9320},{42011,11593,9259},{42011,11523,9195},{42011,11453,9130},{42011,11383,9064},{42011,11314,8999},{42011,11245,8932},{42011,11185,8871},{42011,11125,8809},{42011,11066,8747},{42011,11007,8685},{42011,10947,8622},{42011,10888,8560},{42011,10829,8498},{42011,10770,8436},{42011,10709,8374},{42011,10639,8310},{42011,10568,8245},{42011,10498,8181},{42011,10428,8116},{42011,10357,8051},{42011,10287,7986},{42011,10217,7922},{42011,10147,7857},{42011,10078,7791},{42011,10008,7726},{42011,9939,7660},{42011,9870,7594},{42011,9801,7527},{42011,9733,7461},{42011,9664,7395},{42011,9595,7328},{42011,9526,7262},{42011,9457,7196},{42011,9389,7130},{42011,9320,7063},{42011,9251,6997},{42011,9182,6931},{42011,9114,6864},{42011,9045,6798},{42011,8976,6732},{42011,8908,6665},{42011,8847,6604},{42011,8787,6543},{42011,8727,6481},{42011,8666,6420},{42011,8606,6359},{42011,8546,6297},{42011,8486,6236},{42011,8425,6175},{42011,8361,6109},{42011,8300,6047},{42011,8240,5986},{42011,8179,5924},{42011,8119,5863},{42011,8059,5802},{42011,7999,5740},{42011,7938,5679},{42011,7878,5618},{42011,7818,5556},{42011,7758,5495},{42011,7697,5434},{42011,7637,5372},{42011,7577,5311},{42011,7517,5250},{42011,7456,5188},{42011,7396,5127},{42011,7336,5066},{42011,7276,5004},{42011,7216,4943},{42011,7155,4882},{42011,7095,4820},{42011,7035,4759},{42011,6975,4698},{42011,6914,4636},{42011,6854,4575},{42011,6794,4514},{42011,6734,4452},{42011,6673,4391},{42011,6613,4330},{42011,6553,4268},{42011,6493,4207},{42011,6432,4146},{42011,6372,4084},{42011,6312,4023},{42011,6285,3996}],0],0}',''),(0,4201232,'0','{path,[[{42011,11667,9320},{42011,11593,9259},{42011,11523,9195},{42011,11453,9130},{42011,11383,9064},{42011,11314,8999},{42011,11245,8932},{42011,11185,8871},{42011,11125,8809},{42011,11066,8747},{42011,11007,8685},{42011,10947,8622},{42011,10888,8560},{42011,10829,8498},{42011,10770,8436},{42011,10709,8374},{42011,10639,8310},{42011,10568,8245},{42011,10498,8181},{42011,10428,8116},{42011,10357,8051},{42011,10287,7986},{42011,10217,7922},{42011,10147,7857},{42011,10078,7791},{42011,10008,7726},{42011,9939,7660},{42011,9870,7594},{42011,9801,7527},{42011,9733,7461},{42011,9664,7395},{42011,9595,7328},{42011,9526,7262},{42011,9457,7196},{42011,9389,7130},{42011,9320,7063},{42011,9251,6997},{42011,9182,6931},{42011,9114,6864},{42011,9045,6798},{42011,8976,6732},{42011,8908,6665},{42011,8847,6604},{42011,8787,6543},{42011,8727,6481},{42011,8666,6420},{42011,8606,6359},{42011,8546,6297},{42011,8486,6236},{42011,8425,6175},{42011,8361,6109},{42011,8300,6047},{42011,8240,5986},{42011,8179,5924},{42011,8119,5863},{42011,8059,5802},{42011,7999,5740},{42011,7938,5679},{42011,7878,5618},{42011,7818,5556},{42011,7758,5495},{42011,7697,5434},{42011,7637,5372},{42011,7577,5311},{42011,7517,5250},{42011,7456,5188},{42011,7396,5127},{42011,7336,5066},{42011,7276,5004},{42011,7216,4943},{42011,7155,4882},{42011,7095,4820},{42011,7035,4759},{42011,6975,4698},{42011,6914,4636},{42011,6854,4575},{42011,6794,4514},{42011,6734,4452},{42011,6673,4391},{42011,6613,4330},{42011,6553,4268},{42011,6493,4207},{42011,6432,4146},{42011,6372,4084},{42011,6312,4023},{42011,6285,3996}],0],0}',''),(0,4201241,'0','{path,[[{42011,11667,9320},{42011,11593,9259},{42011,11523,9195},{42011,11453,9130},{42011,11383,9064},{42011,11314,8999},{42011,11245,8932},{42011,11185,8871},{42011,11125,8809},{42011,11066,8747},{42011,11007,8685},{42011,10947,8622},{42011,10888,8560},{42011,10829,8498},{42011,10770,8436},{42011,10709,8374},{42011,10639,8310},{42011,10568,8245},{42011,10498,8181},{42011,10428,8116},{42011,10357,8051},{42011,10287,7986},{42011,10217,7922},{42011,10147,7857},{42011,10078,7791},{42011,10008,7726},{42011,9939,7660},{42011,9870,7594},{42011,9801,7527},{42011,9733,7461},{42011,9664,7395},{42011,9595,7328},{42011,9526,7262},{42011,9457,7196},{42011,9389,7130},{42011,9320,7063},{42011,9251,6997},{42011,9182,6931},{42011,9114,6864},{42011,9045,6798},{42011,8976,6732},{42011,8908,6665},{42011,8847,6604},{42011,8787,6543},{42011,8727,6481},{42011,8666,6420},{42011,8606,6359},{42011,8546,6297},{42011,8486,6236},{42011,8425,6175},{42011,8361,6109},{42011,8300,6047},{42011,8240,5986},{42011,8179,5924},{42011,8119,5863},{42011,8059,5802},{42011,7999,5740},{42011,7938,5679},{42011,7878,5618},{42011,7818,5556},{42011,7758,5495},{42011,7697,5434},{42011,7637,5372},{42011,7577,5311},{42011,7517,5250},{42011,7456,5188},{42011,7396,5127},{42011,7336,5066},{42011,7276,5004},{42011,7216,4943},{42011,7155,4882},{42011,7095,4820},{42011,7035,4759},{42011,6975,4698},{42011,6914,4636},{42011,6854,4575},{42011,6794,4514},{42011,6734,4452},{42011,6673,4391},{42011,6613,4330},{42011,6553,4268},{42011,6493,4207},{42011,6432,4146},{42011,6372,4084},{42011,6312,4023},{42011,6285,3996}],0],0}',''),(0,4201242,'0','{path,[[{42011,11667,9320},{42011,11593,9259},{42011,11523,9195},{42011,11453,9130},{42011,11383,9064},{42011,11314,8999},{42011,11245,8932},{42011,11185,8871},{42011,11125,8809},{42011,11066,8747},{42011,11007,8685},{42011,10947,8622},{42011,10888,8560},{42011,10829,8498},{42011,10770,8436},{42011,10709,8374},{42011,10639,8310},{42011,10568,8245},{42011,10498,8181},{42011,10428,8116},{42011,10357,8051},{42011,10287,7986},{42011,10217,7922},{42011,10147,7857},{42011,10078,7791},{42011,10008,7726},{42011,9939,7660},{42011,9870,7594},{42011,9801,7527},{42011,9733,7461},{42011,9664,7395},{42011,9595,7328},{42011,9526,7262},{42011,9457,7196},{42011,9389,7130},{42011,9320,7063},{42011,9251,6997},{42011,9182,6931},{42011,9114,6864},{42011,9045,6798},{42011,8976,6732},{42011,8908,6665},{42011,8847,6604},{42011,8787,6543},{42011,8727,6481},{42011,8666,6420},{42011,8606,6359},{42011,8546,6297},{42011,8486,6236},{42011,8425,6175},{42011,8361,6109},{42011,8300,6047},{42011,8240,5986},{42011,8179,5924},{42011,8119,5863},{42011,8059,5802},{42011,7999,5740},{42011,7938,5679},{42011,7878,5618},{42011,7818,5556},{42011,7758,5495},{42011,7697,5434},{42011,7637,5372},{42011,7577,5311},{42011,7517,5250},{42011,7456,5188},{42011,7396,5127},{42011,7336,5066},{42011,7276,5004},{42011,7216,4943},{42011,7155,4882},{42011,7095,4820},{42011,7035,4759},{42011,6975,4698},{42011,6914,4636},{42011,6854,4575},{42011,6794,4514},{42011,6734,4452},{42011,6673,4391},{42011,6613,4330},{42011,6553,4268},{42011,6493,4207},{42011,6432,4146},{42011,6372,4084},{42011,6312,4023},{42011,6285,3996}],0],0}',''),(0,4201251,'0','{path,[[{42011,11667,9320},{42011,11593,9259},{42011,11523,9195},{42011,11453,9130},{42011,11383,9064},{42011,11314,8999},{42011,11245,8932},{42011,11185,8871},{42011,11125,8809},{42011,11066,8747},{42011,11007,8685},{42011,10947,8622},{42011,10888,8560},{42011,10829,8498},{42011,10770,8436},{42011,10709,8374},{42011,10639,8310},{42011,10568,8245},{42011,10498,8181},{42011,10428,8116},{42011,10357,8051},{42011,10287,7986},{42011,10217,7922},{42011,10147,7857},{42011,10078,7791},{42011,10008,7726},{42011,9939,7660},{42011,9870,7594},{42011,9801,7527},{42011,9733,7461},{42011,9664,7395},{42011,9595,7328},{42011,9526,7262},{42011,9457,7196},{42011,9389,7130},{42011,9320,7063},{42011,9251,6997},{42011,9182,6931},{42011,9114,6864},{42011,9045,6798},{42011,8976,6732},{42011,8908,6665},{42011,8847,6604},{42011,8787,6543},{42011,8727,6481},{42011,8666,6420},{42011,8606,6359},{42011,8546,6297},{42011,8486,6236},{42011,8425,6175},{42011,8361,6109},{42011,8300,6047},{42011,8240,5986},{42011,8179,5924},{42011,8119,5863},{42011,8059,5802},{42011,7999,5740},{42011,7938,5679},{42011,7878,5618},{42011,7818,5556},{42011,7758,5495},{42011,7697,5434},{42011,7637,5372},{42011,7577,5311},{42011,7517,5250},{42011,7456,5188},{42011,7396,5127},{42011,7336,5066},{42011,7276,5004},{42011,7216,4943},{42011,7155,4882},{42011,7095,4820},{42011,7035,4759},{42011,6975,4698},{42011,6914,4636},{42011,6854,4575},{42011,6794,4514},{42011,6734,4452},{42011,6673,4391},{42011,6613,4330},{42011,6553,4268},{42011,6493,4207},{42011,6432,4146},{42011,6372,4084},{42011,6312,4023},{42011,6285,3996}],0],0}',''),(0,4201252,'0','{path,[[{42011,11667,9320},{42011,11593,9259},{42011,11523,9195},{42011,11453,9130},{42011,11383,9064},{42011,11314,8999},{42011,11245,8932},{42011,11185,8871},{42011,11125,8809},{42011,11066,8747},{42011,11007,8685},{42011,10947,8622},{42011,10888,8560},{42011,10829,8498},{42011,10770,8436},{42011,10709,8374},{42011,10639,8310},{42011,10568,8245},{42011,10498,8181},{42011,10428,8116},{42011,10357,8051},{42011,10287,7986},{42011,10217,7922},{42011,10147,7857},{42011,10078,7791},{42011,10008,7726},{42011,9939,7660},{42011,9870,7594},{42011,9801,7527},{42011,9733,7461},{42011,9664,7395},{42011,9595,7328},{42011,9526,7262},{42011,9457,7196},{42011,9389,7130},{42011,9320,7063},{42011,9251,6997},{42011,9182,6931},{42011,9114,6864},{42011,9045,6798},{42011,8976,6732},{42011,8908,6665},{42011,8847,6604},{42011,8787,6543},{42011,8727,6481},{42011,8666,6420},{42011,8606,6359},{42011,8546,6297},{42011,8486,6236},{42011,8425,6175},{42011,8361,6109},{42011,8300,6047},{42011,8240,5986},{42011,8179,5924},{42011,8119,5863},{42011,8059,5802},{42011,7999,5740},{42011,7938,5679},{42011,7878,5618},{42011,7818,5556},{42011,7758,5495},{42011,7697,5434},{42011,7637,5372},{42011,7577,5311},{42011,7517,5250},{42011,7456,5188},{42011,7396,5127},{42011,7336,5066},{42011,7276,5004},{42011,7216,4943},{42011,7155,4882},{42011,7095,4820},{42011,7035,4759},{42011,6975,4698},{42011,6914,4636},{42011,6854,4575},{42011,6794,4514},{42011,6734,4452},{42011,6673,4391},{42011,6613,4330},{42011,6553,4268},{42011,6493,4207},{42011,6432,4146},{42011,6372,4084},{42011,6312,4023},{42011,6285,3996}],0],0}',''),(0,4201261,'0','{path,[[{42011,11667,9320},{42011,11593,9259},{42011,11523,9195},{42011,11453,9130},{42011,11383,9064},{42011,11314,8999},{42011,11245,8932},{42011,11185,8871},{42011,11125,8809},{42011,11066,8747},{42011,11007,8685},{42011,10947,8622},{42011,10888,8560},{42011,10829,8498},{42011,10770,8436},{42011,10709,8374},{42011,10639,8310},{42011,10568,8245},{42011,10498,8181},{42011,10428,8116},{42011,10357,8051},{42011,10287,7986},{42011,10217,7922},{42011,10147,7857},{42011,10078,7791},{42011,10008,7726},{42011,9939,7660},{42011,9870,7594},{42011,9801,7527},{42011,9733,7461},{42011,9664,7395},{42011,9595,7328},{42011,9526,7262},{42011,9457,7196},{42011,9389,7130},{42011,9320,7063},{42011,9251,6997},{42011,9182,6931},{42011,9114,6864},{42011,9045,6798},{42011,8976,6732},{42011,8908,6665},{42011,8847,6604},{42011,8787,6543},{42011,8727,6481},{42011,8666,6420},{42011,8606,6359},{42011,8546,6297},{42011,8486,6236},{42011,8425,6175},{42011,8361,6109},{42011,8300,6047},{42011,8240,5986},{42011,8179,5924},{42011,8119,5863},{42011,8059,5802},{42011,7999,5740},{42011,7938,5679},{42011,7878,5618},{42011,7818,5556},{42011,7758,5495},{42011,7697,5434},{42011,7637,5372},{42011,7577,5311},{42011,7517,5250},{42011,7456,5188},{42011,7396,5127},{42011,7336,5066},{42011,7276,5004},{42011,7216,4943},{42011,7155,4882},{42011,7095,4820},{42011,7035,4759},{42011,6975,4698},{42011,6914,4636},{42011,6854,4575},{42011,6794,4514},{42011,6734,4452},{42011,6673,4391},{42011,6613,4330},{42011,6553,4268},{42011,6493,4207},{42011,6432,4146},{42011,6372,4084},{42011,6312,4023},{42011,6285,3996}],0],0}',''),(0,4201262,'0','{path,[[{42011,11667,9320},{42011,11593,9259},{42011,11523,9195},{42011,11453,9130},{42011,11383,9064},{42011,11314,8999},{42011,11245,8932},{42011,11185,8871},{42011,11125,8809},{42011,11066,8747},{42011,11007,8685},{42011,10947,8622},{42011,10888,8560},{42011,10829,8498},{42011,10770,8436},{42011,10709,8374},{42011,10639,8310},{42011,10568,8245},{42011,10498,8181},{42011,10428,8116},{42011,10357,8051},{42011,10287,7986},{42011,10217,7922},{42011,10147,7857},{42011,10078,7791},{42011,10008,7726},{42011,9939,7660},{42011,9870,7594},{42011,9801,7527},{42011,9733,7461},{42011,9664,7395},{42011,9595,7328},{42011,9526,7262},{42011,9457,7196},{42011,9389,7130},{42011,9320,7063},{42011,9251,6997},{42011,9182,6931},{42011,9114,6864},{42011,9045,6798},{42011,8976,6732},{42011,8908,6665},{42011,8847,6604},{42011,8787,6543},{42011,8727,6481},{42011,8666,6420},{42011,8606,6359},{42011,8546,6297},{42011,8486,6236},{42011,8425,6175},{42011,8361,6109},{42011,8300,6047},{42011,8240,5986},{42011,8179,5924},{42011,8119,5863},{42011,8059,5802},{42011,7999,5740},{42011,7938,5679},{42011,7878,5618},{42011,7818,5556},{42011,7758,5495},{42011,7697,5434},{42011,7637,5372},{42011,7577,5311},{42011,7517,5250},{42011,7456,5188},{42011,7396,5127},{42011,7336,5066},{42011,7276,5004},{42011,7216,4943},{42011,7155,4882},{42011,7095,4820},{42011,7035,4759},{42011,6975,4698},{42011,6914,4636},{42011,6854,4575},{42011,6794,4514},{42011,6734,4452},{42011,6673,4391},{42011,6613,4330},{42011,6553,4268},{42011,6493,4207},{42011,6432,4146},{42011,6372,4084},{42011,6312,4023},{42011,6285,3996}],0],0}',''),(0,4201271,'0','{path,[[{42011,11667,9320},{42011,11593,9259},{42011,11523,9195},{42011,11453,9130},{42011,11383,9064},{42011,11314,8999},{42011,11245,8932},{42011,11185,8871},{42011,11125,8809},{42011,11066,8747},{42011,11007,8685},{42011,10947,8622},{42011,10888,8560},{42011,10829,8498},{42011,10770,8436},{42011,10709,8374},{42011,10639,8310},{42011,10568,8245},{42011,10498,8181},{42011,10428,8116},{42011,10357,8051},{42011,10287,7986},{42011,10217,7922},{42011,10147,7857},{42011,10078,7791},{42011,10008,7726},{42011,9939,7660},{42011,9870,7594},{42011,9801,7527},{42011,9733,7461},{42011,9664,7395},{42011,9595,7328},{42011,9526,7262},{42011,9457,7196},{42011,9389,7130},{42011,9320,7063},{42011,9251,6997},{42011,9182,6931},{42011,9114,6864},{42011,9045,6798},{42011,8976,6732},{42011,8908,6665},{42011,8847,6604},{42011,8787,6543},{42011,8727,6481},{42011,8666,6420},{42011,8606,6359},{42011,8546,6297},{42011,8486,6236},{42011,8425,6175},{42011,8361,6109},{42011,8300,6047},{42011,8240,5986},{42011,8179,5924},{42011,8119,5863},{42011,8059,5802},{42011,7999,5740},{42011,7938,5679},{42011,7878,5618},{42011,7818,5556},{42011,7758,5495},{42011,7697,5434},{42011,7637,5372},{42011,7577,5311},{42011,7517,5250},{42011,7456,5188},{42011,7396,5127},{42011,7336,5066},{42011,7276,5004},{42011,7216,4943},{42011,7155,4882},{42011,7095,4820},{42011,7035,4759},{42011,6975,4698},{42011,6914,4636},{42011,6854,4575},{42011,6794,4514},{42011,6734,4452},{42011,6673,4391},{42011,6613,4330},{42011,6553,4268},{42011,6493,4207},{42011,6432,4146},{42011,6372,4084},{42011,6312,4023},{42011,6285,3996}],0],0}',''),(0,4201272,'0','{path,[[{42011,11667,9320},{42011,11593,9259},{42011,11523,9195},{42011,11453,9130},{42011,11383,9064},{42011,11314,8999},{42011,11245,8932},{42011,11185,8871},{42011,11125,8809},{42011,11066,8747},{42011,11007,8685},{42011,10947,8622},{42011,10888,8560},{42011,10829,8498},{42011,10770,8436},{42011,10709,8374},{42011,10639,8310},{42011,10568,8245},{42011,10498,8181},{42011,10428,8116},{42011,10357,8051},{42011,10287,7986},{42011,10217,7922},{42011,10147,7857},{42011,10078,7791},{42011,10008,7726},{42011,9939,7660},{42011,9870,7594},{42011,9801,7527},{42011,9733,7461},{42011,9664,7395},{42011,9595,7328},{42011,9526,7262},{42011,9457,7196},{42011,9389,7130},{42011,9320,7063},{42011,9251,6997},{42011,9182,6931},{42011,9114,6864},{42011,9045,6798},{42011,8976,6732},{42011,8908,6665},{42011,8847,6604},{42011,8787,6543},{42011,8727,6481},{42011,8666,6420},{42011,8606,6359},{42011,8546,6297},{42011,8486,6236},{42011,8425,6175},{42011,8361,6109},{42011,8300,6047},{42011,8240,5986},{42011,8179,5924},{42011,8119,5863},{42011,8059,5802},{42011,7999,5740},{42011,7938,5679},{42011,7878,5618},{42011,7818,5556},{42011,7758,5495},{42011,7697,5434},{42011,7637,5372},{42011,7577,5311},{42011,7517,5250},{42011,7456,5188},{42011,7396,5127},{42011,7336,5066},{42011,7276,5004},{42011,7216,4943},{42011,7155,4882},{42011,7095,4820},{42011,7035,4759},{42011,6975,4698},{42011,6914,4636},{42011,6854,4575},{42011,6794,4514},{42011,6734,4452},{42011,6673,4391},{42011,6613,4330},{42011,6553,4268},{42011,6493,4207},{42011,6432,4146},{42011,6372,4084},{42011,6312,4023},{42011,6285,3996}],0],0}',''),(0,4201281,'0','{path,[[{42011,11667,9320},{42011,11593,9259},{42011,11523,9195},{42011,11453,9130},{42011,11383,9064},{42011,11314,8999},{42011,11245,8932},{42011,11185,8871},{42011,11125,8809},{42011,11066,8747},{42011,11007,8685},{42011,10947,8622},{42011,10888,8560},{42011,10829,8498},{42011,10770,8436},{42011,10709,8374},{42011,10639,8310},{42011,10568,8245},{42011,10498,8181},{42011,10428,8116},{42011,10357,8051},{42011,10287,7986},{42011,10217,7922},{42011,10147,7857},{42011,10078,7791},{42011,10008,7726},{42011,9939,7660},{42011,9870,7594},{42011,9801,7527},{42011,9733,7461},{42011,9664,7395},{42011,9595,7328},{42011,9526,7262},{42011,9457,7196},{42011,9389,7130},{42011,9320,7063},{42011,9251,6997},{42011,9182,6931},{42011,9114,6864},{42011,9045,6798},{42011,8976,6732},{42011,8908,6665},{42011,8847,6604},{42011,8787,6543},{42011,8727,6481},{42011,8666,6420},{42011,8606,6359},{42011,8546,6297},{42011,8486,6236},{42011,8425,6175},{42011,8361,6109},{42011,8300,6047},{42011,8240,5986},{42011,8179,5924},{42011,8119,5863},{42011,8059,5802},{42011,7999,5740},{42011,7938,5679},{42011,7878,5618},{42011,7818,5556},{42011,7758,5495},{42011,7697,5434},{42011,7637,5372},{42011,7577,5311},{42011,7517,5250},{42011,7456,5188},{42011,7396,5127},{42011,7336,5066},{42011,7276,5004},{42011,7216,4943},{42011,7155,4882},{42011,7095,4820},{42011,7035,4759},{42011,6975,4698},{42011,6914,4636},{42011,6854,4575},{42011,6794,4514},{42011,6734,4452},{42011,6673,4391},{42011,6613,4330},{42011,6553,4268},{42011,6493,4207},{42011,6432,4146},{42011,6372,4084},{42011,6312,4023},{42011,6285,3996}],0],0}',''),(0,4201282,'0','{path,[[{42011,11667,9320},{42011,11593,9259},{42011,11523,9195},{42011,11453,9130},{42011,11383,9064},{42011,11314,8999},{42011,11245,8932},{42011,11185,8871},{42011,11125,8809},{42011,11066,8747},{42011,11007,8685},{42011,10947,8622},{42011,10888,8560},{42011,10829,8498},{42011,10770,8436},{42011,10709,8374},{42011,10639,8310},{42011,10568,8245},{42011,10498,8181},{42011,10428,8116},{42011,10357,8051},{42011,10287,7986},{42011,10217,7922},{42011,10147,7857},{42011,10078,7791},{42011,10008,7726},{42011,9939,7660},{42011,9870,7594},{42011,9801,7527},{42011,9733,7461},{42011,9664,7395},{42011,9595,7328},{42011,9526,7262},{42011,9457,7196},{42011,9389,7130},{42011,9320,7063},{42011,9251,6997},{42011,9182,6931},{42011,9114,6864},{42011,9045,6798},{42011,8976,6732},{42011,8908,6665},{42011,8847,6604},{42011,8787,6543},{42011,8727,6481},{42011,8666,6420},{42011,8606,6359},{42011,8546,6297},{42011,8486,6236},{42011,8425,6175},{42011,8361,6109},{42011,8300,6047},{42011,8240,5986},{42011,8179,5924},{42011,8119,5863},{42011,8059,5802},{42011,7999,5740},{42011,7938,5679},{42011,7878,5618},{42011,7818,5556},{42011,7758,5495},{42011,7697,5434},{42011,7637,5372},{42011,7577,5311},{42011,7517,5250},{42011,7456,5188},{42011,7396,5127},{42011,7336,5066},{42011,7276,5004},{42011,7216,4943},{42011,7155,4882},{42011,7095,4820},{42011,7035,4759},{42011,6975,4698},{42011,6914,4636},{42011,6854,4575},{42011,6794,4514},{42011,6734,4452},{42011,6673,4391},{42011,6613,4330},{42011,6553,4268},{42011,6493,4207},{42011,6432,4146},{42011,6372,4084},{42011,6312,4023},{42011,6285,3996}],0],0}',''),(0,4201311,'0','{path,[[{42011,13711,3467},{42011,13587,3456},{42011,13463,3454},{42011,13339,3453},{42011,13214,3451},{42011,13090,3450},{42011,12966,3448},{42011,12842,3447},{42011,12718,3446},{42011,12594,3444},{42011,12469,3443},{42011,12345,3442},{42011,12221,3440},{42011,12097,3439},{42011,11973,3437},{42011,11848,3436},{42011,11724,3435},{42011,11600,3433},{42011,11476,3432},{42011,11352,3431},{42011,11228,3429},{42011,11103,3428},{42011,10979,3426},{42011,10855,3425},{42011,10731,3424},{42011,10607,3422},{42011,10483,3421},{42011,10358,3419},{42011,10234,3418},{42011,10110,3417},{42011,9986,3415},{42011,9862,3414},{42011,9738,3413},{42011,9613,3411},{42011,9489,3410},{42011,9365,3408},{42011,9241,3407},{42011,9117,3406},{42011,8993,3404},{42011,8868,3403},{42011,8744,3402},{42011,8620,3400},{42011,8496,3399},{42011,8372,3397},{42011,8248,3396},{42011,8123,3395},{42011,7999,3393},{42011,7875,3392},{42011,7751,3391},{42011,7627,3389},{42011,7503,3388},{42011,7379,3397},{42011,7258,3424},{42011,7136,3476},{42011,7062,3537},{42011,6990,3600},{42011,6918,3663},{42011,6835,3727},{42011,6738,3789},{42011,6621,3852},{42011,6493,3916},{42011,6371,3973},{42011,6285,4013}],0],0}',''),(0,4201312,'0','{path,[[{42011,13711,3467},{42011,13587,3456},{42011,13463,3454},{42011,13339,3453},{42011,13214,3451},{42011,13090,3450},{42011,12966,3448},{42011,12842,3447},{42011,12718,3446},{42011,12594,3444},{42011,12469,3443},{42011,12345,3442},{42011,12221,3440},{42011,12097,3439},{42011,11973,3437},{42011,11848,3436},{42011,11724,3435},{42011,11600,3433},{42011,11476,3432},{42011,11352,3431},{42011,11228,3429},{42011,11103,3428},{42011,10979,3426},{42011,10855,3425},{42011,10731,3424},{42011,10607,3422},{42011,10483,3421},{42011,10358,3419},{42011,10234,3418},{42011,10110,3417},{42011,9986,3415},{42011,9862,3414},{42011,9738,3413},{42011,9613,3411},{42011,9489,3410},{42011,9365,3408},{42011,9241,3407},{42011,9117,3406},{42011,8993,3404},{42011,8868,3403},{42011,8744,3402},{42011,8620,3400},{42011,8496,3399},{42011,8372,3397},{42011,8248,3396},{42011,8123,3395},{42011,7999,3393},{42011,7875,3392},{42011,7751,3391},{42011,7627,3389},{42011,7503,3388},{42011,7379,3397},{42011,7258,3424},{42011,7136,3476},{42011,7062,3537},{42011,6990,3600},{42011,6918,3663},{42011,6835,3727},{42011,6738,3789},{42011,6621,3852},{42011,6493,3916},{42011,6371,3973},{42011,6285,4013}],0],0}',''),(0,4201321,'0','{path,[[{42011,13711,3467},{42011,13587,3456},{42011,13463,3454},{42011,13339,3453},{42011,13214,3451},{42011,13090,3450},{42011,12966,3448},{42011,12842,3447},{42011,12718,3446},{42011,12594,3444},{42011,12469,3443},{42011,12345,3442},{42011,12221,3440},{42011,12097,3439},{42011,11973,3437},{42011,11848,3436},{42011,11724,3435},{42011,11600,3433},{42011,11476,3432},{42011,11352,3431},{42011,11228,3429},{42011,11103,3428},{42011,10979,3426},{42011,10855,3425},{42011,10731,3424},{42011,10607,3422},{42011,10483,3421},{42011,10358,3419},{42011,10234,3418},{42011,10110,3417},{42011,9986,3415},{42011,9862,3414},{42011,9738,3413},{42011,9613,3411},{42011,9489,3410},{42011,9365,3408},{42011,9241,3407},{42011,9117,3406},{42011,8993,3404},{42011,8868,3403},{42011,8744,3402},{42011,8620,3400},{42011,8496,3399},{42011,8372,3397},{42011,8248,3396},{42011,8123,3395},{42011,7999,3393},{42011,7875,3392},{42011,7751,3391},{42011,7627,3389},{42011,7503,3388},{42011,7379,3397},{42011,7258,3424},{42011,7136,3476},{42011,7062,3537},{42011,6990,3600},{42011,6918,3663},{42011,6835,3727},{42011,6738,3789},{42011,6621,3852},{42011,6493,3916},{42011,6371,3973},{42011,6285,4013}],0],0}',''),(0,4201322,'0','{path,[[{42011,13711,3467},{42011,13587,3456},{42011,13463,3454},{42011,13339,3453},{42011,13214,3451},{42011,13090,3450},{42011,12966,3448},{42011,12842,3447},{42011,12718,3446},{42011,12594,3444},{42011,12469,3443},{42011,12345,3442},{42011,12221,3440},{42011,12097,3439},{42011,11973,3437},{42011,11848,3436},{42011,11724,3435},{42011,11600,3433},{42011,11476,3432},{42011,11352,3431},{42011,11228,3429},{42011,11103,3428},{42011,10979,3426},{42011,10855,3425},{42011,10731,3424},{42011,10607,3422},{42011,10483,3421},{42011,10358,3419},{42011,10234,3418},{42011,10110,3417},{42011,9986,3415},{42011,9862,3414},{42011,9738,3413},{42011,9613,3411},{42011,9489,3410},{42011,9365,3408},{42011,9241,3407},{42011,9117,3406},{42011,8993,3404},{42011,8868,3403},{42011,8744,3402},{42011,8620,3400},{42011,8496,3399},{42011,8372,3397},{42011,8248,3396},{42011,8123,3395},{42011,7999,3393},{42011,7875,3392},{42011,7751,3391},{42011,7627,3389},{42011,7503,3388},{42011,7379,3397},{42011,7258,3424},{42011,7136,3476},{42011,7062,3537},{42011,6990,3600},{42011,6918,3663},{42011,6835,3727},{42011,6738,3789},{42011,6621,3852},{42011,6493,3916},{42011,6371,3973},{42011,6285,4013}],0],0}',''),(0,4201331,'0','{path,[[{42011,13711,3467},{42011,13587,3456},{42011,13463,3454},{42011,13339,3453},{42011,13214,3451},{42011,13090,3450},{42011,12966,3448},{42011,12842,3447},{42011,12718,3446},{42011,12594,3444},{42011,12469,3443},{42011,12345,3442},{42011,12221,3440},{42011,12097,3439},{42011,11973,3437},{42011,11848,3436},{42011,11724,3435},{42011,11600,3433},{42011,11476,3432},{42011,11352,3431},{42011,11228,3429},{42011,11103,3428},{42011,10979,3426},{42011,10855,3425},{42011,10731,3424},{42011,10607,3422},{42011,10483,3421},{42011,10358,3419},{42011,10234,3418},{42011,10110,3417},{42011,9986,3415},{42011,9862,3414},{42011,9738,3413},{42011,9613,3411},{42011,9489,3410},{42011,9365,3408},{42011,9241,3407},{42011,9117,3406},{42011,8993,3404},{42011,8868,3403},{42011,8744,3402},{42011,8620,3400},{42011,8496,3399},{42011,8372,3397},{42011,8248,3396},{42011,8123,3395},{42011,7999,3393},{42011,7875,3392},{42011,7751,3391},{42011,7627,3389},{42011,7503,3388},{42011,7379,3397},{42011,7258,3424},{42011,7136,3476},{42011,7062,3537},{42011,6990,3600},{42011,6918,3663},{42011,6835,3727},{42011,6738,3789},{42011,6621,3852},{42011,6493,3916},{42011,6371,3973},{42011,6285,4013}],0],0}',''),(0,4201332,'0','{path,[[{42011,13711,3467},{42011,13587,3456},{42011,13463,3454},{42011,13339,3453},{42011,13214,3451},{42011,13090,3450},{42011,12966,3448},{42011,12842,3447},{42011,12718,3446},{42011,12594,3444},{42011,12469,3443},{42011,12345,3442},{42011,12221,3440},{42011,12097,3439},{42011,11973,3437},{42011,11848,3436},{42011,11724,3435},{42011,11600,3433},{42011,11476,3432},{42011,11352,3431},{42011,11228,3429},{42011,11103,3428},{42011,10979,3426},{42011,10855,3425},{42011,10731,3424},{42011,10607,3422},{42011,10483,3421},{42011,10358,3419},{42011,10234,3418},{42011,10110,3417},{42011,9986,3415},{42011,9862,3414},{42011,9738,3413},{42011,9613,3411},{42011,9489,3410},{42011,9365,3408},{42011,9241,3407},{42011,9117,3406},{42011,8993,3404},{42011,8868,3403},{42011,8744,3402},{42011,8620,3400},{42011,8496,3399},{42011,8372,3397},{42011,8248,3396},{42011,8123,3395},{42011,7999,3393},{42011,7875,3392},{42011,7751,3391},{42011,7627,3389},{42011,7503,3388},{42011,7379,3397},{42011,7258,3424},{42011,7136,3476},{42011,7062,3537},{42011,6990,3600},{42011,6918,3663},{42011,6835,3727},{42011,6738,3789},{42011,6621,3852},{42011,6493,3916},{42011,6371,3973},{42011,6285,4013}],0],0}',''),(0,4201341,'0','{path,[[{42011,13711,3467},{42011,13587,3456},{42011,13463,3454},{42011,13339,3453},{42011,13214,3451},{42011,13090,3450},{42011,12966,3448},{42011,12842,3447},{42011,12718,3446},{42011,12594,3444},{42011,12469,3443},{42011,12345,3442},{42011,12221,3440},{42011,12097,3439},{42011,11973,3437},{42011,11848,3436},{42011,11724,3435},{42011,11600,3433},{42011,11476,3432},{42011,11352,3431},{42011,11228,3429},{42011,11103,3428},{42011,10979,3426},{42011,10855,3425},{42011,10731,3424},{42011,10607,3422},{42011,10483,3421},{42011,10358,3419},{42011,10234,3418},{42011,10110,3417},{42011,9986,3415},{42011,9862,3414},{42011,9738,3413},{42011,9613,3411},{42011,9489,3410},{42011,9365,3408},{42011,9241,3407},{42011,9117,3406},{42011,8993,3404},{42011,8868,3403},{42011,8744,3402},{42011,8620,3400},{42011,8496,3399},{42011,8372,3397},{42011,8248,3396},{42011,8123,3395},{42011,7999,3393},{42011,7875,3392},{42011,7751,3391},{42011,7627,3389},{42011,7503,3388},{42011,7379,3397},{42011,7258,3424},{42011,7136,3476},{42011,7062,3537},{42011,6990,3600},{42011,6918,3663},{42011,6835,3727},{42011,6738,3789},{42011,6621,3852},{42011,6493,3916},{42011,6371,3973},{42011,6285,4013}],0],0}',''),(0,4201342,'0','{path,[[{42011,13711,3467},{42011,13587,3456},{42011,13463,3454},{42011,13339,3453},{42011,13214,3451},{42011,13090,3450},{42011,12966,3448},{42011,12842,3447},{42011,12718,3446},{42011,12594,3444},{42011,12469,3443},{42011,12345,3442},{42011,12221,3440},{42011,12097,3439},{42011,11973,3437},{42011,11848,3436},{42011,11724,3435},{42011,11600,3433},{42011,11476,3432},{42011,11352,3431},{42011,11228,3429},{42011,11103,3428},{42011,10979,3426},{42011,10855,3425},{42011,10731,3424},{42011,10607,3422},{42011,10483,3421},{42011,10358,3419},{42011,10234,3418},{42011,10110,3417},{42011,9986,3415},{42011,9862,3414},{42011,9738,3413},{42011,9613,3411},{42011,9489,3410},{42011,9365,3408},{42011,9241,3407},{42011,9117,3406},{42011,8993,3404},{42011,8868,3403},{42011,8744,3402},{42011,8620,3400},{42011,8496,3399},{42011,8372,3397},{42011,8248,3396},{42011,8123,3395},{42011,7999,3393},{42011,7875,3392},{42011,7751,3391},{42011,7627,3389},{42011,7503,3388},{42011,7379,3397},{42011,7258,3424},{42011,7136,3476},{42011,7062,3537},{42011,6990,3600},{42011,6918,3663},{42011,6835,3727},{42011,6738,3789},{42011,6621,3852},{42011,6493,3916},{42011,6371,3973},{42011,6285,4013}],0],0}',''),(0,4201351,'0','{path,[[{42011,13711,3467},{42011,13587,3456},{42011,13463,3454},{42011,13339,3453},{42011,13214,3451},{42011,13090,3450},{42011,12966,3448},{42011,12842,3447},{42011,12718,3446},{42011,12594,3444},{42011,12469,3443},{42011,12345,3442},{42011,12221,3440},{42011,12097,3439},{42011,11973,3437},{42011,11848,3436},{42011,11724,3435},{42011,11600,3433},{42011,11476,3432},{42011,11352,3431},{42011,11228,3429},{42011,11103,3428},{42011,10979,3426},{42011,10855,3425},{42011,10731,3424},{42011,10607,3422},{42011,10483,3421},{42011,10358,3419},{42011,10234,3418},{42011,10110,3417},{42011,9986,3415},{42011,9862,3414},{42011,9738,3413},{42011,9613,3411},{42011,9489,3410},{42011,9365,3408},{42011,9241,3407},{42011,9117,3406},{42011,8993,3404},{42011,8868,3403},{42011,8744,3402},{42011,8620,3400},{42011,8496,3399},{42011,8372,3397},{42011,8248,3396},{42011,8123,3395},{42011,7999,3393},{42011,7875,3392},{42011,7751,3391},{42011,7627,3389},{42011,7503,3388},{42011,7379,3397},{42011,7258,3424},{42011,7136,3476},{42011,7062,3537},{42011,6990,3600},{42011,6918,3663},{42011,6835,3727},{42011,6738,3789},{42011,6621,3852},{42011,6493,3916},{42011,6371,3973},{42011,6285,4013}],0],0}',''),(0,4201352,'0','{path,[[{42011,13711,3467},{42011,13587,3456},{42011,13463,3454},{42011,13339,3453},{42011,13214,3451},{42011,13090,3450},{42011,12966,3448},{42011,12842,3447},{42011,12718,3446},{42011,12594,3444},{42011,12469,3443},{42011,12345,3442},{42011,12221,3440},{42011,12097,3439},{42011,11973,3437},{42011,11848,3436},{42011,11724,3435},{42011,11600,3433},{42011,11476,3432},{42011,11352,3431},{42011,11228,3429},{42011,11103,3428},{42011,10979,3426},{42011,10855,3425},{42011,10731,3424},{42011,10607,3422},{42011,10483,3421},{42011,10358,3419},{42011,10234,3418},{42011,10110,3417},{42011,9986,3415},{42011,9862,3414},{42011,9738,3413},{42011,9613,3411},{42011,9489,3410},{42011,9365,3408},{42011,9241,3407},{42011,9117,3406},{42011,8993,3404},{42011,8868,3403},{42011,8744,3402},{42011,8620,3400},{42011,8496,3399},{42011,8372,3397},{42011,8248,3396},{42011,8123,3395},{42011,7999,3393},{42011,7875,3392},{42011,7751,3391},{42011,7627,3389},{42011,7503,3388},{42011,7379,3397},{42011,7258,3424},{42011,7136,3476},{42011,7062,3537},{42011,6990,3600},{42011,6918,3663},{42011,6835,3727},{42011,6738,3789},{42011,6621,3852},{42011,6493,3916},{42011,6371,3973},{42011,6285,4013}],0],0}',''),(0,4201361,'0','{path,[[{42011,13711,3467},{42011,13587,3456},{42011,13463,3454},{42011,13339,3453},{42011,13214,3451},{42011,13090,3450},{42011,12966,3448},{42011,12842,3447},{42011,12718,3446},{42011,12594,3444},{42011,12469,3443},{42011,12345,3442},{42011,12221,3440},{42011,12097,3439},{42011,11973,3437},{42011,11848,3436},{42011,11724,3435},{42011,11600,3433},{42011,11476,3432},{42011,11352,3431},{42011,11228,3429},{42011,11103,3428},{42011,10979,3426},{42011,10855,3425},{42011,10731,3424},{42011,10607,3422},{42011,10483,3421},{42011,10358,3419},{42011,10234,3418},{42011,10110,3417},{42011,9986,3415},{42011,9862,3414},{42011,9738,3413},{42011,9613,3411},{42011,9489,3410},{42011,9365,3408},{42011,9241,3407},{42011,9117,3406},{42011,8993,3404},{42011,8868,3403},{42011,8744,3402},{42011,8620,3400},{42011,8496,3399},{42011,8372,3397},{42011,8248,3396},{42011,8123,3395},{42011,7999,3393},{42011,7875,3392},{42011,7751,3391},{42011,7627,3389},{42011,7503,3388},{42011,7379,3397},{42011,7258,3424},{42011,7136,3476},{42011,7062,3537},{42011,6990,3600},{42011,6918,3663},{42011,6835,3727},{42011,6738,3789},{42011,6621,3852},{42011,6493,3916},{42011,6371,3973},{42011,6285,4013}],0],0}',''),(0,4201362,'0','{path,[[{42011,13711,3467},{42011,13587,3456},{42011,13463,3454},{42011,13339,3453},{42011,13214,3451},{42011,13090,3450},{42011,12966,3448},{42011,12842,3447},{42011,12718,3446},{42011,12594,3444},{42011,12469,3443},{42011,12345,3442},{42011,12221,3440},{42011,12097,3439},{42011,11973,3437},{42011,11848,3436},{42011,11724,3435},{42011,11600,3433},{42011,11476,3432},{42011,11352,3431},{42011,11228,3429},{42011,11103,3428},{42011,10979,3426},{42011,10855,3425},{42011,10731,3424},{42011,10607,3422},{42011,10483,3421},{42011,10358,3419},{42011,10234,3418},{42011,10110,3417},{42011,9986,3415},{42011,9862,3414},{42011,9738,3413},{42011,9613,3411},{42011,9489,3410},{42011,9365,3408},{42011,9241,3407},{42011,9117,3406},{42011,8993,3404},{42011,8868,3403},{42011,8744,3402},{42011,8620,3400},{42011,8496,3399},{42011,8372,3397},{42011,8248,3396},{42011,8123,3395},{42011,7999,3393},{42011,7875,3392},{42011,7751,3391},{42011,7627,3389},{42011,7503,3388},{42011,7379,3397},{42011,7258,3424},{42011,7136,3476},{42011,7062,3537},{42011,6990,3600},{42011,6918,3663},{42011,6835,3727},{42011,6738,3789},{42011,6621,3852},{42011,6493,3916},{42011,6371,3973},{42011,6285,4013}],0],0}',''),(0,4201371,'0','{path,[[{42011,13711,3467},{42011,13587,3456},{42011,13463,3454},{42011,13339,3453},{42011,13214,3451},{42011,13090,3450},{42011,12966,3448},{42011,12842,3447},{42011,12718,3446},{42011,12594,3444},{42011,12469,3443},{42011,12345,3442},{42011,12221,3440},{42011,12097,3439},{42011,11973,3437},{42011,11848,3436},{42011,11724,3435},{42011,11600,3433},{42011,11476,3432},{42011,11352,3431},{42011,11228,3429},{42011,11103,3428},{42011,10979,3426},{42011,10855,3425},{42011,10731,3424},{42011,10607,3422},{42011,10483,3421},{42011,10358,3419},{42011,10234,3418},{42011,10110,3417},{42011,9986,3415},{42011,9862,3414},{42011,9738,3413},{42011,9613,3411},{42011,9489,3410},{42011,9365,3408},{42011,9241,3407},{42011,9117,3406},{42011,8993,3404},{42011,8868,3403},{42011,8744,3402},{42011,8620,3400},{42011,8496,3399},{42011,8372,3397},{42011,8248,3396},{42011,8123,3395},{42011,7999,3393},{42011,7875,3392},{42011,7751,3391},{42011,7627,3389},{42011,7503,3388},{42011,7379,3397},{42011,7258,3424},{42011,7136,3476},{42011,7062,3537},{42011,6990,3600},{42011,6918,3663},{42011,6835,3727},{42011,6738,3789},{42011,6621,3852},{42011,6493,3916},{42011,6371,3973},{42011,6285,4013}],0],0}',''),(0,4201372,'0','{path,[[{42011,13711,3467},{42011,13587,3456},{42011,13463,3454},{42011,13339,3453},{42011,13214,3451},{42011,13090,3450},{42011,12966,3448},{42011,12842,3447},{42011,12718,3446},{42011,12594,3444},{42011,12469,3443},{42011,12345,3442},{42011,12221,3440},{42011,12097,3439},{42011,11973,3437},{42011,11848,3436},{42011,11724,3435},{42011,11600,3433},{42011,11476,3432},{42011,11352,3431},{42011,11228,3429},{42011,11103,3428},{42011,10979,3426},{42011,10855,3425},{42011,10731,3424},{42011,10607,3422},{42011,10483,3421},{42011,10358,3419},{42011,10234,3418},{42011,10110,3417},{42011,9986,3415},{42011,9862,3414},{42011,9738,3413},{42011,9613,3411},{42011,9489,3410},{42011,9365,3408},{42011,9241,3407},{42011,9117,3406},{42011,8993,3404},{42011,8868,3403},{42011,8744,3402},{42011,8620,3400},{42011,8496,3399},{42011,8372,3397},{42011,8248,3396},{42011,8123,3395},{42011,7999,3393},{42011,7875,3392},{42011,7751,3391},{42011,7627,3389},{42011,7503,3388},{42011,7379,3397},{42011,7258,3424},{42011,7136,3476},{42011,7062,3537},{42011,6990,3600},{42011,6918,3663},{42011,6835,3727},{42011,6738,3789},{42011,6621,3852},{42011,6493,3916},{42011,6371,3973},{42011,6285,4013}],0],0}',''),(0,4201381,'0','{path,[[{42011,13711,3467},{42011,13587,3456},{42011,13463,3454},{42011,13339,3453},{42011,13214,3451},{42011,13090,3450},{42011,12966,3448},{42011,12842,3447},{42011,12718,3446},{42011,12594,3444},{42011,12469,3443},{42011,12345,3442},{42011,12221,3440},{42011,12097,3439},{42011,11973,3437},{42011,11848,3436},{42011,11724,3435},{42011,11600,3433},{42011,11476,3432},{42011,11352,3431},{42011,11228,3429},{42011,11103,3428},{42011,10979,3426},{42011,10855,3425},{42011,10731,3424},{42011,10607,3422},{42011,10483,3421},{42011,10358,3419},{42011,10234,3418},{42011,10110,3417},{42011,9986,3415},{42011,9862,3414},{42011,9738,3413},{42011,9613,3411},{42011,9489,3410},{42011,9365,3408},{42011,9241,3407},{42011,9117,3406},{42011,8993,3404},{42011,8868,3403},{42011,8744,3402},{42011,8620,3400},{42011,8496,3399},{42011,8372,3397},{42011,8248,3396},{42011,8123,3395},{42011,7999,3393},{42011,7875,3392},{42011,7751,3391},{42011,7627,3389},{42011,7503,3388},{42011,7379,3397},{42011,7258,3424},{42011,7136,3476},{42011,7062,3537},{42011,6990,3600},{42011,6918,3663},{42011,6835,3727},{42011,6738,3789},{42011,6621,3852},{42011,6493,3916},{42011,6371,3973},{42011,6285,4013}],0],0}',''),(0,4201382,'0','{path,[[{42011,13711,3467},{42011,13587,3456},{42011,13463,3454},{42011,13339,3453},{42011,13214,3451},{42011,13090,3450},{42011,12966,3448},{42011,12842,3447},{42011,12718,3446},{42011,12594,3444},{42011,12469,3443},{42011,12345,3442},{42011,12221,3440},{42011,12097,3439},{42011,11973,3437},{42011,11848,3436},{42011,11724,3435},{42011,11600,3433},{42011,11476,3432},{42011,11352,3431},{42011,11228,3429},{42011,11103,3428},{42011,10979,3426},{42011,10855,3425},{42011,10731,3424},{42011,10607,3422},{42011,10483,3421},{42011,10358,3419},{42011,10234,3418},{42011,10110,3417},{42011,9986,3415},{42011,9862,3414},{42011,9738,3413},{42011,9613,3411},{42011,9489,3410},{42011,9365,3408},{42011,9241,3407},{42011,9117,3406},{42011,8993,3404},{42011,8868,3403},{42011,8744,3402},{42011,8620,3400},{42011,8496,3399},{42011,8372,3397},{42011,8248,3396},{42011,8123,3395},{42011,7999,3393},{42011,7875,3392},{42011,7751,3391},{42011,7627,3389},{42011,7503,3388},{42011,7379,3397},{42011,7258,3424},{42011,7136,3476},{42011,7062,3537},{42011,6990,3600},{42011,6918,3663},{42011,6835,3727},{42011,6738,3789},{42011,6621,3852},{42011,6493,3916},{42011,6371,3973},{42011,6285,4013}],0],0}',''),(4,4401001,'80','{msg,[51510007],10000}',''),(5,4401001,'80','{msg,[51510007],10000}',''),(0,5151005,'0','{msg,[51510001],10000},{nochange,0,cycle}',''),(5,5151005,'0','{msg,[51510001],10000},{nochange,0,cycle}',''),(0,5151006,'0','{msg,[51510002],10000},{nochange,0,cycle}',''),(5,5151006,'0','{msg,[51510002],10000},{nochange,0,cycle}',''),(2,5152001,'0','{msg,[51510004],10000},{nochange,0,cycle}',''),(5,5152001,'0','{msg,[51510004],10000},{nochange,0,cycle}',''),(2,5152002,'0','{msg,[51510004],10000},{nochange,0,cycle}',''),(5,5152002,'0','{msg,[51510004],10000},{nochange,0,cycle}',''),(2,5152003,'0','{msg,[51510005],10000},{nochange,0,cycle}',''),(5,5152003,'0','{msg,[51510005],10000},{nochange,0,cycle}',''),(2,5152004,'0','{msg,[51510005],10000},{nochange,0,cycle}',''),(5,5152004,'0','{msg,[51510005],10000},{nochange,0,cycle}',''),(2,5152005,'0','{msg,[51510006],10000},{nochange,0,cycle}',''),(5,5152005,'0','{msg,[51510006],10000},{nochange,0,cycle}',''),(2,5152006,'0','{msg,[51510006],10000},{nochange,0,cycle}',''),(5,5152006,'0','{msg,[51510006],10000},{nochange,0,cycle}',''),(2,5152007,'0','{msg,[51510007],10000},{nochange,0,cycle}',''),(5,5152007,'0','{msg,[51510007],10000},{nochange,0,cycle}',''),(0,5300101,'0','{path,[[{5502,6201,4264},{5502,6081,4222},{5502,5955,4173},{5502,5872,4112},{5502,5779,4051},{5502,5686,3990},{5502,5585,3926},{5502,5491,3866},{5502,5398,3805},{5502,5306,3743},{5502,5214,3681},{5502,5122,3618},{5502,5030,3555},{5502,4919,3493},{5502,4796,3437},{5502,4674,3379},{5502,4552,3320},{5502,4433,3256},{5502,4331,3194},{5502,4230,3131},{5502,4128,3069},{5502,4025,3009},{5502,3914,2946},{5502,3804,2882},{5502,3694,2819},{5502,3583,2756},{5502,3473,2692},{5502,3371,2631},{5502,3261,2567},{5502,3150,2505},{5502,3039,2442},{5502,2928,2380},{5502,2816,2319},{5502,2704,2259},{5502,2593,2197},{5502,2482,2134},{5502,2371,2072},{5502,2260,2010},{5502,2150,1947},{5502,2040,1883},{5502,1937,1823},{5502,1930,1819}],0],0}',''),(0,5300102,'0','{path,[[{5502,6201,4264},{5502,6081,4222},{5502,5955,4173},{5502,5872,4112},{5502,5779,4051},{5502,5686,3990},{5502,5585,3926},{5502,5491,3866},{5502,5398,3805},{5502,5306,3743},{5502,5214,3681},{5502,5122,3618},{5502,5030,3555},{5502,4919,3493},{5502,4796,3437},{5502,4674,3379},{5502,4552,3320},{5502,4433,3256},{5502,4331,3194},{5502,4230,3131},{5502,4128,3069},{5502,4025,3009},{5502,3914,2946},{5502,3804,2882},{5502,3694,2819},{5502,3583,2756},{5502,3473,2692},{5502,3371,2631},{5502,3261,2567},{5502,3150,2505},{5502,3039,2442},{5502,2928,2380},{5502,2816,2319},{5502,2704,2259},{5502,2593,2197},{5502,2482,2134},{5502,2371,2072},{5502,2260,2010},{5502,2150,1947},{5502,2040,1883},{5502,1937,1823},{5502,1930,1819}],0],0}',''),(0,5300103,'0','{path,[[{5502,6201,4264},{5502,6081,4222},{5502,5955,4173},{5502,5872,4112},{5502,5779,4051},{5502,5686,3990},{5502,5585,3926},{5502,5491,3866},{5502,5398,3805},{5502,5306,3743},{5502,5214,3681},{5502,5122,3618},{5502,5030,3555},{5502,4919,3493},{5502,4796,3437},{5502,4674,3379},{5502,4552,3320},{5502,4433,3256},{5502,4331,3194},{5502,4230,3131},{5502,4128,3069},{5502,4025,3009},{5502,3914,2946},{5502,3804,2882},{5502,3694,2819},{5502,3583,2756},{5502,3473,2692},{5502,3371,2631},{5502,3261,2567},{5502,3150,2505},{5502,3039,2442},{5502,2928,2380},{5502,2816,2319},{5502,2704,2259},{5502,2593,2197},{5502,2482,2134},{5502,2371,2072},{5502,2260,2010},{5502,2150,1947},{5502,2040,1883},{5502,1937,1823},{5502,1930,1819}],0],0}',''),(0,5301101,'0','{path,[[{5502,6201,4264},{5502,6081,4222},{5502,5955,4173},{5502,5872,4112},{5502,5779,4051},{5502,5686,3990},{5502,5585,3926},{5502,5491,3866},{5502,5398,3805},{5502,5306,3743},{5502,5214,3681},{5502,5122,3618},{5502,5030,3555},{5502,4919,3493},{5502,4796,3437},{5502,4674,3379},{5502,4552,3320},{5502,4433,3256},{5502,4331,3194},{5502,4230,3131},{5502,4128,3069},{5502,4025,3009},{5502,3914,2946},{5502,3804,2882},{5502,3694,2819},{5502,3583,2756},{5502,3473,2692},{5502,3371,2631},{5502,3261,2567},{5502,3150,2505},{5502,3039,2442},{5502,2928,2380},{5502,2816,2319},{5502,2704,2259},{5502,2593,2197},{5502,2482,2134},{5502,2371,2072},{5502,2260,2010},{5502,2150,1947},{5502,2040,1883},{5502,1937,1823},{5502,1930,1819}],0],0}',''),(0,5301102,'0','{path,[[{5502,6201,4264},{5502,6081,4222},{5502,5955,4173},{5502,5872,4112},{5502,5779,4051},{5502,5686,3990},{5502,5585,3926},{5502,5491,3866},{5502,5398,3805},{5502,5306,3743},{5502,5214,3681},{5502,5122,3618},{5502,5030,3555},{5502,4919,3493},{5502,4796,3437},{5502,4674,3379},{5502,4552,3320},{5502,4433,3256},{5502,4331,3194},{5502,4230,3131},{5502,4128,3069},{5502,4025,3009},{5502,3914,2946},{5502,3804,2882},{5502,3694,2819},{5502,3583,2756},{5502,3473,2692},{5502,3371,2631},{5502,3261,2567},{5502,3150,2505},{5502,3039,2442},{5502,2928,2380},{5502,2816,2319},{5502,2704,2259},{5502,2593,2197},{5502,2482,2134},{5502,2371,2072},{5502,2260,2010},{5502,2150,1947},{5502,2040,1883},{5502,1937,1823},{5502,1930,1819}],0],0}',''),(0,5301103,'0','{path,[[{5502,6201,4264},{5502,6081,4222},{5502,5955,4173},{5502,5872,4112},{5502,5779,4051},{5502,5686,3990},{5502,5585,3926},{5502,5491,3866},{5502,5398,3805},{5502,5306,3743},{5502,5214,3681},{5502,5122,3618},{5502,5030,3555},{5502,4919,3493},{5502,4796,3437},{5502,4674,3379},{5502,4552,3320},{5502,4433,3256},{5502,4331,3194},{5502,4230,3131},{5502,4128,3069},{5502,4025,3009},{5502,3914,2946},{5502,3804,2882},{5502,3694,2819},{5502,3583,2756},{5502,3473,2692},{5502,3371,2631},{5502,3261,2567},{5502,3150,2505},{5502,3039,2442},{5502,2928,2380},{5502,2816,2319},{5502,2704,2259},{5502,2593,2197},{5502,2482,2134},{5502,2371,2072},{5502,2260,2010},{5502,2150,1947},{5502,2040,1883},{5502,1937,1823},{5502,1930,1819}],0],0}',''),(0,5302101,'0','{path,[[{5502,6201,4264},{5502,6081,4222},{5502,5955,4173},{5502,5872,4112},{5502,5779,4051},{5502,5686,3990},{5502,5585,3926},{5502,5491,3866},{5502,5398,3805},{5502,5306,3743},{5502,5214,3681},{5502,5122,3618},{5502,5030,3555},{5502,4919,3493},{5502,4796,3437},{5502,4674,3379},{5502,4552,3320},{5502,4433,3256},{5502,4331,3194},{5502,4230,3131},{5502,4128,3069},{5502,4025,3009},{5502,3914,2946},{5502,3804,2882},{5502,3694,2819},{5502,3583,2756},{5502,3473,2692},{5502,3371,2631},{5502,3261,2567},{5502,3150,2505},{5502,3039,2442},{5502,2928,2380},{5502,2816,2319},{5502,2704,2259},{5502,2593,2197},{5502,2482,2134},{5502,2371,2072},{5502,2260,2010},{5502,2150,1947},{5502,2040,1883},{5502,1937,1823},{5502,1930,1819}],0],0}',''),(0,5302102,'0','{path,[[{5502,6201,4264},{5502,6081,4222},{5502,5955,4173},{5502,5872,4112},{5502,5779,4051},{5502,5686,3990},{5502,5585,3926},{5502,5491,3866},{5502,5398,3805},{5502,5306,3743},{5502,5214,3681},{5502,5122,3618},{5502,5030,3555},{5502,4919,3493},{5502,4796,3437},{5502,4674,3379},{5502,4552,3320},{5502,4433,3256},{5502,4331,3194},{5502,4230,3131},{5502,4128,3069},{5502,4025,3009},{5502,3914,2946},{5502,3804,2882},{5502,3694,2819},{5502,3583,2756},{5502,3473,2692},{5502,3371,2631},{5502,3261,2567},{5502,3150,2505},{5502,3039,2442},{5502,2928,2380},{5502,2816,2319},{5502,2704,2259},{5502,2593,2197},{5502,2482,2134},{5502,2371,2072},{5502,2260,2010},{5502,2150,1947},{5502,2040,1883},{5502,1937,1823},{5502,1930,1819}],0],0}',''),(0,5302103,'0','{path,[[{5502,6201,4264},{5502,6081,4222},{5502,5955,4173},{5502,5872,4112},{5502,5779,4051},{5502,5686,3990},{5502,5585,3926},{5502,5491,3866},{5502,5398,3805},{5502,5306,3743},{5502,5214,3681},{5502,5122,3618},{5502,5030,3555},{5502,4919,3493},{5502,4796,3437},{5502,4674,3379},{5502,4552,3320},{5502,4433,3256},{5502,4331,3194},{5502,4230,3131},{5502,4128,3069},{5502,4025,3009},{5502,3914,2946},{5502,3804,2882},{5502,3694,2819},{5502,3583,2756},{5502,3473,2692},{5502,3371,2631},{5502,3261,2567},{5502,3150,2505},{5502,3039,2442},{5502,2928,2380},{5502,2816,2319},{5502,2704,2259},{5502,2593,2197},{5502,2482,2134},{5502,2371,2072},{5502,2260,2010},{5502,2150,1947},{5502,2040,1883},{5502,1937,1823},{5502,1930,1819}],0],0}',''),(0,5303101,'0','{path,[[{5502,6201,4264},{5502,6081,4222},{5502,5955,4173},{5502,5872,4112},{5502,5779,4051},{5502,5686,3990},{5502,5585,3926},{5502,5491,3866},{5502,5398,3805},{5502,5306,3743},{5502,5214,3681},{5502,5122,3618},{5502,5030,3555},{5502,4919,3493},{5502,4796,3437},{5502,4674,3379},{5502,4552,3320},{5502,4433,3256},{5502,4331,3194},{5502,4230,3131},{5502,4128,3069},{5502,4025,3009},{5502,3914,2946},{5502,3804,2882},{5502,3694,2819},{5502,3583,2756},{5502,3473,2692},{5502,3371,2631},{5502,3261,2567},{5502,3150,2505},{5502,3039,2442},{5502,2928,2380},{5502,2816,2319},{5502,2704,2259},{5502,2593,2197},{5502,2482,2134},{5502,2371,2072},{5502,2260,2010},{5502,2150,1947},{5502,2040,1883},{5502,1937,1823},{5502,1930,1819}],0],0}',''),(0,5303102,'0','{path,[[{5502,6201,4264},{5502,6081,4222},{5502,5955,4173},{5502,5872,4112},{5502,5779,4051},{5502,5686,3990},{5502,5585,3926},{5502,5491,3866},{5502,5398,3805},{5502,5306,3743},{5502,5214,3681},{5502,5122,3618},{5502,5030,3555},{5502,4919,3493},{5502,4796,3437},{5502,4674,3379},{5502,4552,3320},{5502,4433,3256},{5502,4331,3194},{5502,4230,3131},{5502,4128,3069},{5502,4025,3009},{5502,3914,2946},{5502,3804,2882},{5502,3694,2819},{5502,3583,2756},{5502,3473,2692},{5502,3371,2631},{5502,3261,2567},{5502,3150,2505},{5502,3039,2442},{5502,2928,2380},{5502,2816,2319},{5502,2704,2259},{5502,2593,2197},{5502,2482,2134},{5502,2371,2072},{5502,2260,2010},{5502,2150,1947},{5502,2040,1883},{5502,1937,1823},{5502,1930,1819}],0],0}',''),(0,5303103,'0','{path,[[{5502,6201,4264},{5502,6081,4222},{5502,5955,4173},{5502,5872,4112},{5502,5779,4051},{5502,5686,3990},{5502,5585,3926},{5502,5491,3866},{5502,5398,3805},{5502,5306,3743},{5502,5214,3681},{5502,5122,3618},{5502,5030,3555},{5502,4919,3493},{5502,4796,3437},{5502,4674,3379},{5502,4552,3320},{5502,4433,3256},{5502,4331,3194},{5502,4230,3131},{5502,4128,3069},{5502,4025,3009},{5502,3914,2946},{5502,3804,2882},{5502,3694,2819},{5502,3583,2756},{5502,3473,2692},{5502,3371,2631},{5502,3261,2567},{5502,3150,2505},{5502,3039,2442},{5502,2928,2380},{5502,2816,2319},{5502,2704,2259},{5502,2593,2197},{5502,2482,2134},{5502,2371,2072},{5502,2260,2010},{5502,2150,1947},{5502,2040,1883},{5502,1937,1823},{5502,1930,1819}],0],0}',''),(0,5304101,'0','{path,[[{5502,6201,4264},{5502,6081,4222},{5502,5955,4173},{5502,5872,4112},{5502,5779,4051},{5502,5686,3990},{5502,5585,3926},{5502,5491,3866},{5502,5398,3805},{5502,5306,3743},{5502,5214,3681},{5502,5122,3618},{5502,5030,3555},{5502,4919,3493},{5502,4796,3437},{5502,4674,3379},{5502,4552,3320},{5502,4433,3256},{5502,4331,3194},{5502,4230,3131},{5502,4128,3069},{5502,4025,3009},{5502,3914,2946},{5502,3804,2882},{5502,3694,2819},{5502,3583,2756},{5502,3473,2692},{5502,3371,2631},{5502,3261,2567},{5502,3150,2505},{5502,3039,2442},{5502,2928,2380},{5502,2816,2319},{5502,2704,2259},{5502,2593,2197},{5502,2482,2134},{5502,2371,2072},{5502,2260,2010},{5502,2150,1947},{5502,2040,1883},{5502,1937,1823},{5502,1930,1819}],0],0}',''),(0,5304102,'0','{path,[[{5502,6201,4264},{5502,6081,4222},{5502,5955,4173},{5502,5872,4112},{5502,5779,4051},{5502,5686,3990},{5502,5585,3926},{5502,5491,3866},{5502,5398,3805},{5502,5306,3743},{5502,5214,3681},{5502,5122,3618},{5502,5030,3555},{5502,4919,3493},{5502,4796,3437},{5502,4674,3379},{5502,4552,3320},{5502,4433,3256},{5502,4331,3194},{5502,4230,3131},{5502,4128,3069},{5502,4025,3009},{5502,3914,2946},{5502,3804,2882},{5502,3694,2819},{5502,3583,2756},{5502,3473,2692},{5502,3371,2631},{5502,3261,2567},{5502,3150,2505},{5502,3039,2442},{5502,2928,2380},{5502,2816,2319},{5502,2704,2259},{5502,2593,2197},{5502,2482,2134},{5502,2371,2072},{5502,2260,2010},{5502,2150,1947},{5502,2040,1883},{5502,1937,1823},{5502,1930,1819}],0],0}',''),(0,5304103,'0','{path,[[{5502,6201,4264},{5502,6081,4222},{5502,5955,4173},{5502,5872,4112},{5502,5779,4051},{5502,5686,3990},{5502,5585,3926},{5502,5491,3866},{5502,5398,3805},{5502,5306,3743},{5502,5214,3681},{5502,5122,3618},{5502,5030,3555},{5502,4919,3493},{5502,4796,3437},{5502,4674,3379},{5502,4552,3320},{5502,4433,3256},{5502,4331,3194},{5502,4230,3131},{5502,4128,3069},{5502,4025,3009},{5502,3914,2946},{5502,3804,2882},{5502,3694,2819},{5502,3583,2756},{5502,3473,2692},{5502,3371,2631},{5502,3261,2567},{5502,3150,2505},{5502,3039,2442},{5502,2928,2380},{5502,2816,2319},{5502,2704,2259},{5502,2593,2197},{5502,2482,2134},{5502,2371,2072},{5502,2260,2010},{5502,2150,1947},{5502,2040,1883},{5502,1937,1823},{5502,1930,1819}],0],0}',''),(0,5600120,'','{auto_att,2,0}',''),(5,5600120,'0','{msg,[6105602],0}',''),(0,400010001,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010001,'0','{remove,0,0}',''),(0,400010002,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010002,'0','{remove,0,0}',''),(0,400010003,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010003,'0','{remove,0,0}',''),(0,400010004,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010004,'0','{remove,0,0}',''),(0,400010005,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010005,'0','{remove,0,0}',''),(0,400010006,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010006,'0','{remove,0,0}',''),(0,400010007,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010007,'0','{remove,0,0}',''),(0,400010008,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010008,'0','{remove,0,0}',''),(0,400010009,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010009,'0','{remove,0,0}',''),(0,400010010,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010010,'0','{remove,0,0}',''),(0,400010011,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010011,'0','{remove,0,0}',''),(0,400010012,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010012,'0','{remove,0,0}',''),(0,400010013,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010013,'0','{remove,0,0}',''),(0,400010014,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010014,'0','{remove,0,0}',''),(0,400010015,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010015,'0','{remove,0,0}',''),(0,400010016,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010016,'0','{remove,0,0}',''),(0,400010017,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010017,'0','{remove,0,0}',''),(0,400010018,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010018,'0','{remove,0,0}',''),(0,400010019,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010019,'0','{remove,0,0}',''),(0,400010020,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010020,'0','{remove,0,0}',''),(0,400010021,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010021,'0','{remove,0,0}',''),(0,400010022,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010022,'0','{remove,0,0}',''),(0,400010023,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010023,'0','{remove,0,0}',''),(0,400010024,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010024,'0','{remove,0,0}',''),(0,400010025,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010025,'0','{remove,0,0}',''),(0,400010026,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010026,'0','{remove,0,0}',''),(0,400010027,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010027,'0','{remove,0,0}',''),(0,400010028,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010028,'0','{remove,0,0}',''),(0,400010029,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010029,'0','{remove,0,0}',''),(0,400010030,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010030,'0','{remove,0,0}',''),(0,400010031,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010031,'0','{remove,0,0}',''),(0,400010032,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010032,'0','{remove,0,0}',''),(0,400010033,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010033,'0','{remove,0,0}',''),(0,400010034,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010034,'0','{remove,0,0}',''),(0,400010035,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010035,'0','{remove,0,0}',''),(0,400010036,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010036,'0','{remove,0,0}',''),(0,400010037,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010037,'0','{remove,0,0}',''),(0,400010038,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010038,'0','{remove,0,0}',''),(0,400010039,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010039,'0','{remove,0,0}',''),(0,400010040,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010040,'0','{remove,0,0}',''),(0,400010041,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010041,'0','{remove,0,0}',''),(0,400010042,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010042,'0','{remove,0,0}',''),(0,400010043,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010043,'0','{remove,0,0}',''),(0,400010044,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010044,'0','{remove,0,0}',''),(0,400010045,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010045,'0','{remove,0,0}',''),(0,400010046,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010046,'0','{remove,0,0}',''),(0,400010047,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010047,'0','{remove,0,0}',''),(0,400010048,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010048,'0','{remove,0,0}',''),(0,400010049,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010049,'0','{remove,0,0}',''),(0,400010050,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010050,'0','{remove,0,0}',''),(0,400010051,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010051,'0','{remove,0,0}',''),(0,400010052,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010052,'0','{remove,0,0}',''),(0,400010053,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010053,'0','{remove,0,0}',''),(0,400010054,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010054,'0','{remove,0,0}',''),(0,400010055,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010055,'0','{remove,0,0}',''),(0,400010056,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010056,'0','{remove,0,0}',''),(0,400010057,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010057,'0','{remove,0,0}',''),(0,400010058,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010058,'0','{remove,0,0}',''),(0,400010059,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010059,'0','{remove,0,0}',''),(0,400010060,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010060,'0','{remove,0,0}',''),(0,400010061,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010061,'0','{remove,0,0}',''),(0,400010062,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010062,'0','{remove,0,0}',''),(0,400010063,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010063,'0','{remove,0,0}',''),(0,400010064,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010064,'0','{remove,0,0}',''),(0,400010065,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010065,'0','{remove,0,0}',''),(0,400010066,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010066,'0','{remove,0,0}',''),(0,400010067,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010067,'0','{remove,0,0}',''),(0,400010068,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010068,'0','{remove,0,0}',''),(0,400010069,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010069,'0','{remove,0,0}',''),(0,400010070,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010070,'0','{remove,0,0}',''),(0,400010071,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010071,'0','{remove,0,0}',''),(0,400010072,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010072,'0','{remove,0,0}',''),(0,400010073,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010073,'0','{remove,0,0}',''),(0,400010074,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010074,'0','{remove,0,0}',''),(0,400010075,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010075,'0','{remove,0,0}',''),(0,400010076,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010076,'0','{remove,0,0}',''),(0,400010077,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010077,'0','{remove,0,0}',''),(0,400010078,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010078,'0','{remove,0,0}',''),(0,400010079,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010079,'0','{remove,0,0}',''),(0,400010080,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010080,'0','{remove,0,0}',''),(0,400010081,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010081,'0','{remove,0,0}',''),(0,400010082,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010082,'0','{remove,0,0}',''),(0,400010083,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010083,'0','{remove,0,0}',''),(0,400010084,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010084,'0','{remove,0,0}',''),(0,400010085,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010085,'0','{remove,0,0}',''),(0,400010086,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010086,'0','{remove,0,0}',''),(0,400010087,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010087,'0','{remove,0,0}',''),(0,400010088,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010088,'0','{remove,0,0}',''),(0,400010089,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010089,'0','{remove,0,0}',''),(0,400010090,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010090,'0','{remove,0,0}',''),(0,400010091,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010091,'0','{remove,0,0}',''),(0,400010092,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010092,'0','{remove,0,0}',''),(0,400010093,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010093,'0','{remove,0,0}',''),(0,400010094,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010094,'0','{remove,0,0}',''),(0,400010095,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010095,'0','{remove,0,0}',''),(0,400010096,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010096,'0','{remove,0,0}',''),(0,400010097,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010097,'0','{remove,0,0}',''),(0,400010098,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010098,'0','{remove,0,0}',''),(0,400010099,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010099,'0','{remove,0,0}',''),(0,400010100,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400010100,'0','{remove,0,0}',''),(0,400020001,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020001,'0','{remove,0,0}',''),(0,400020002,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020002,'0','{remove,0,0}',''),(0,400020003,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020003,'0','{remove,0,0}',''),(0,400020004,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020004,'0','{remove,0,0}',''),(0,400020005,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020005,'0','{remove,0,0}',''),(0,400020006,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020006,'0','{remove,0,0}',''),(0,400020007,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020007,'0','{remove,0,0}',''),(0,400020008,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020008,'0','{remove,0,0}',''),(0,400020009,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020009,'0','{remove,0,0}',''),(0,400020010,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020010,'0','{remove,0,0}',''),(0,400020011,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020011,'0','{remove,0,0}',''),(0,400020012,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020012,'0','{remove,0,0}',''),(0,400020013,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020013,'0','{remove,0,0}',''),(0,400020014,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020014,'0','{remove,0,0}',''),(0,400020015,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020015,'0','{remove,0,0}',''),(0,400020016,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020016,'0','{remove,0,0}',''),(0,400020017,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020017,'0','{remove,0,0}',''),(0,400020018,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020018,'0','{remove,0,0}',''),(0,400020019,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020019,'0','{remove,0,0}',''),(0,400020020,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020020,'0','{remove,0,0}',''),(0,400020021,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020021,'0','{remove,0,0}',''),(0,400020022,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020022,'0','{remove,0,0}',''),(0,400020023,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020023,'0','{remove,0,0}',''),(0,400020024,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020024,'0','{remove,0,0}',''),(0,400020025,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020025,'0','{remove,0,0}',''),(0,400020026,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020026,'0','{remove,0,0}',''),(0,400020027,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020027,'0','{remove,0,0}',''),(0,400020028,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020028,'0','{remove,0,0}',''),(0,400020029,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020029,'0','{remove,0,0}',''),(0,400020030,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020030,'0','{remove,0,0}',''),(0,400020031,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020031,'0','{remove,0,0}',''),(0,400020032,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020032,'0','{remove,0,0}',''),(0,400020033,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020033,'0','{remove,0,0}',''),(0,400020034,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020034,'0','{remove,0,0}',''),(0,400020035,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020035,'0','{remove,0,0}',''),(0,400020036,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020036,'0','{remove,0,0}',''),(0,400020037,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020037,'0','{remove,0,0}',''),(0,400020038,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020038,'0','{remove,0,0}',''),(0,400020039,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020039,'0','{remove,0,0}',''),(0,400020040,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020040,'0','{remove,0,0}',''),(0,400020041,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020041,'0','{remove,0,0}',''),(0,400020042,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020042,'0','{remove,0,0}',''),(0,400020043,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020043,'0','{remove,0,0}',''),(0,400020044,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020044,'0','{remove,0,0}',''),(0,400020045,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020045,'0','{remove,0,0}',''),(0,400020046,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020046,'0','{remove,0,0}',''),(0,400020047,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020047,'0','{remove,0,0}',''),(0,400020048,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020048,'0','{remove,0,0}',''),(0,400020049,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020049,'0','{remove,0,0}',''),(0,400020050,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020050,'0','{remove,0,0}',''),(0,400020051,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020051,'0','{remove,0,0}',''),(0,400020052,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020052,'0','{remove,0,0}',''),(0,400020053,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020053,'0','{remove,0,0}',''),(0,400020054,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020054,'0','{remove,0,0}',''),(0,400020055,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020055,'0','{remove,0,0}',''),(0,400020056,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020056,'0','{remove,0,0}',''),(0,400020057,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020057,'0','{remove,0,0}',''),(0,400020058,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020058,'0','{remove,0,0}',''),(0,400020059,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020059,'0','{remove,0,0}',''),(0,400020060,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020060,'0','{remove,0,0}',''),(0,400020061,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020061,'0','{remove,0,0}',''),(0,400020062,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020062,'0','{remove,0,0}',''),(0,400020063,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020063,'0','{remove,0,0}',''),(0,400020064,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020064,'0','{remove,0,0}',''),(0,400020065,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020065,'0','{remove,0,0}',''),(0,400020066,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020066,'0','{remove,0,0}',''),(0,400020067,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020067,'0','{remove,0,0}',''),(0,400020068,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020068,'0','{remove,0,0}',''),(0,400020069,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020069,'0','{remove,0,0}',''),(0,400020070,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020070,'0','{remove,0,0}',''),(0,400020071,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020071,'0','{remove,0,0}',''),(0,400020072,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020072,'0','{remove,0,0}',''),(0,400020073,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020073,'0','{remove,0,0}',''),(0,400020074,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020074,'0','{remove,0,0}',''),(0,400020075,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020075,'0','{remove,0,0}',''),(0,400020076,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020076,'0','{remove,0,0}',''),(0,400020077,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020077,'0','{remove,0,0}',''),(0,400020078,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020078,'0','{remove,0,0}',''),(0,400020079,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020079,'0','{remove,0,0}',''),(0,400020080,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020080,'0','{remove,0,0}',''),(0,400020081,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020081,'0','{remove,0,0}',''),(0,400020082,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020082,'0','{remove,0,0}',''),(0,400020083,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020083,'0','{remove,0,0}',''),(0,400020084,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020084,'0','{remove,0,0}',''),(0,400020085,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020085,'0','{remove,0,0}',''),(0,400020086,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020086,'0','{remove,0,0}',''),(0,400020087,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020087,'0','{remove,0,0}',''),(0,400020088,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020088,'0','{remove,0,0}',''),(0,400020089,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020089,'0','{remove,0,0}',''),(0,400020090,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020090,'0','{remove,0,0}',''),(0,400020091,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020091,'0','{remove,0,0}',''),(0,400020092,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020092,'0','{remove,0,0}',''),(0,400020093,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020093,'0','{remove,0,0}',''),(0,400020094,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020094,'0','{remove,0,0}',''),(0,400020095,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020095,'0','{remove,0,0}',''),(0,400020096,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020096,'0','{remove,0,0}',''),(0,400020097,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020097,'0','{remove,0,0}',''),(0,400020098,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020098,'0','{remove,0,0}',''),(0,400020099,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020099,'0','{remove,0,0}',''),(0,400020100,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400020100,'0','{remove,0,0}',''),(0,400030001,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030001,'0','{remove,0,0}',''),(0,400030002,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030002,'0','{remove,0,0}',''),(0,400030003,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030003,'0','{remove,0,0}',''),(0,400030004,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030004,'0','{remove,0,0}',''),(0,400030005,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030005,'0','{remove,0,0}',''),(0,400030006,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030006,'0','{remove,0,0}',''),(0,400030007,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030007,'0','{remove,0,0}',''),(0,400030008,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030008,'0','{remove,0,0}',''),(0,400030009,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030009,'0','{remove,0,0}',''),(0,400030010,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030010,'0','{remove,0,0}',''),(0,400030011,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030011,'0','{remove,0,0}',''),(0,400030012,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030012,'0','{remove,0,0}',''),(0,400030013,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030013,'0','{remove,0,0}',''),(0,400030014,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030014,'0','{remove,0,0}',''),(0,400030015,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030015,'0','{remove,0,0}',''),(0,400030016,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030016,'0','{remove,0,0}',''),(0,400030017,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030017,'0','{remove,0,0}',''),(0,400030018,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030018,'0','{remove,0,0}',''),(0,400030019,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030019,'0','{remove,0,0}',''),(0,400030020,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030020,'0','{remove,0,0}',''),(0,400030021,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030021,'0','{remove,0,0}',''),(0,400030022,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030022,'0','{remove,0,0}',''),(0,400030023,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030023,'0','{remove,0,0}',''),(0,400030024,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030024,'0','{remove,0,0}',''),(0,400030025,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030025,'0','{remove,0,0}',''),(0,400030026,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030026,'0','{remove,0,0}',''),(0,400030027,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030027,'0','{remove,0,0}',''),(0,400030028,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030028,'0','{remove,0,0}',''),(0,400030029,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030029,'0','{remove,0,0}',''),(0,400030030,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030030,'0','{remove,0,0}',''),(0,400030031,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030031,'0','{remove,0,0}',''),(0,400030032,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030032,'0','{remove,0,0}',''),(0,400030033,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030033,'0','{remove,0,0}',''),(0,400030034,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030034,'0','{remove,0,0}',''),(0,400030035,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030035,'0','{remove,0,0}',''),(0,400030036,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030036,'0','{remove,0,0}',''),(0,400030037,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030037,'0','{remove,0,0}',''),(0,400030038,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030038,'0','{remove,0,0}',''),(0,400030039,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030039,'0','{remove,0,0}',''),(0,400030040,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030040,'0','{remove,0,0}',''),(0,400030041,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030041,'0','{remove,0,0}',''),(0,400030042,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030042,'0','{remove,0,0}',''),(0,400030043,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030043,'0','{remove,0,0}',''),(0,400030044,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030044,'0','{remove,0,0}',''),(0,400030045,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030045,'0','{remove,0,0}',''),(0,400030046,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030046,'0','{remove,0,0}',''),(0,400030047,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030047,'0','{remove,0,0}',''),(0,400030048,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030048,'0','{remove,0,0}',''),(0,400030049,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030049,'0','{remove,0,0}',''),(0,400030050,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030050,'0','{remove,0,0}',''),(0,400030051,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030051,'0','{remove,0,0}',''),(0,400030052,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030052,'0','{remove,0,0}',''),(0,400030053,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030053,'0','{remove,0,0}',''),(0,400030054,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030054,'0','{remove,0,0}',''),(0,400030055,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030055,'0','{remove,0,0}',''),(0,400030056,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030056,'0','{remove,0,0}',''),(0,400030057,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030057,'0','{remove,0,0}',''),(0,400030058,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030058,'0','{remove,0,0}',''),(0,400030059,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030059,'0','{remove,0,0}',''),(0,400030060,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030060,'0','{remove,0,0}',''),(0,400030061,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030061,'0','{remove,0,0}',''),(0,400030062,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030062,'0','{remove,0,0}',''),(0,400030063,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030063,'0','{remove,0,0}',''),(0,400030064,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030064,'0','{remove,0,0}',''),(0,400030065,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030065,'0','{remove,0,0}',''),(0,400030066,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030066,'0','{remove,0,0}',''),(0,400030067,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030067,'0','{remove,0,0}',''),(0,400030068,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030068,'0','{remove,0,0}',''),(0,400030069,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030069,'0','{remove,0,0}',''),(0,400030070,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030070,'0','{remove,0,0}',''),(0,400030071,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030071,'0','{remove,0,0}',''),(0,400030072,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030072,'0','{remove,0,0}',''),(0,400030073,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030073,'0','{remove,0,0}',''),(0,400030074,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030074,'0','{remove,0,0}',''),(0,400030075,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030075,'0','{remove,0,0}',''),(0,400030076,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030076,'0','{remove,0,0}',''),(0,400030077,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030077,'0','{remove,0,0}',''),(0,400030078,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030078,'0','{remove,0,0}',''),(0,400030079,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030079,'0','{remove,0,0}',''),(0,400030080,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030080,'0','{remove,0,0}',''),(0,400030081,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030081,'0','{remove,0,0}',''),(0,400030082,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030082,'0','{remove,0,0}',''),(0,400030083,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030083,'0','{remove,0,0}',''),(0,400030084,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030084,'0','{remove,0,0}',''),(0,400030085,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030085,'0','{remove,0,0}',''),(0,400030086,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030086,'0','{remove,0,0}',''),(0,400030087,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030087,'0','{remove,0,0}',''),(0,400030088,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030088,'0','{remove,0,0}',''),(0,400030089,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030089,'0','{remove,0,0}',''),(0,400030090,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030090,'0','{remove,0,0}',''),(0,400030091,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030091,'0','{remove,0,0}',''),(0,400030092,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030092,'0','{remove,0,0}',''),(0,400030093,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030093,'0','{remove,0,0}',''),(0,400030094,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030094,'0','{remove,0,0}',''),(0,400030095,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030095,'0','{remove,0,0}',''),(0,400030096,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030096,'0','{remove,0,0}',''),(0,400030097,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030097,'0','{remove,0,0}',''),(0,400030098,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030098,'0','{remove,0,0}',''),(0,400030099,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030099,'0','{remove,0,0}',''),(0,400030100,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400030100,'0','{remove,0,0}',''),(0,400040001,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040001,'0','{remove,0,0}',''),(0,400040002,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040002,'0','{remove,0,0}',''),(0,400040003,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040003,'0','{remove,0,0}',''),(0,400040004,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040004,'0','{remove,0,0}',''),(0,400040005,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040005,'0','{remove,0,0}',''),(0,400040006,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040006,'0','{remove,0,0}',''),(0,400040007,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040007,'0','{remove,0,0}',''),(0,400040008,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040008,'0','{remove,0,0}',''),(0,400040009,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040009,'0','{remove,0,0}',''),(0,400040010,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040010,'0','{remove,0,0}',''),(0,400040011,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040011,'0','{remove,0,0}',''),(0,400040012,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040012,'0','{remove,0,0}',''),(0,400040013,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040013,'0','{remove,0,0}',''),(0,400040014,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040014,'0','{remove,0,0}',''),(0,400040015,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040015,'0','{remove,0,0}',''),(0,400040016,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040016,'0','{remove,0,0}',''),(0,400040017,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040017,'0','{remove,0,0}',''),(0,400040018,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040018,'0','{remove,0,0}',''),(0,400040019,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040019,'0','{remove,0,0}',''),(0,400040020,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040020,'0','{remove,0,0}',''),(0,400040021,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040021,'0','{remove,0,0}',''),(0,400040022,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040022,'0','{remove,0,0}',''),(0,400040023,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040023,'0','{remove,0,0}',''),(0,400040024,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040024,'0','{remove,0,0}',''),(0,400040025,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040025,'0','{remove,0,0}',''),(0,400040026,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040026,'0','{remove,0,0}',''),(0,400040027,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040027,'0','{remove,0,0}',''),(0,400040028,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040028,'0','{remove,0,0}',''),(0,400040029,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040029,'0','{remove,0,0}',''),(0,400040030,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040030,'0','{remove,0,0}',''),(0,400040031,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040031,'0','{remove,0,0}',''),(0,400040032,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040032,'0','{remove,0,0}',''),(0,400040033,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040033,'0','{remove,0,0}',''),(0,400040034,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040034,'0','{remove,0,0}',''),(0,400040035,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040035,'0','{remove,0,0}',''),(0,400040036,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040036,'0','{remove,0,0}',''),(0,400040037,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040037,'0','{remove,0,0}',''),(0,400040038,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040038,'0','{remove,0,0}',''),(0,400040039,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040039,'0','{remove,0,0}',''),(0,400040040,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040040,'0','{remove,0,0}',''),(0,400040041,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040041,'0','{remove,0,0}',''),(0,400040042,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040042,'0','{remove,0,0}',''),(0,400040043,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040043,'0','{remove,0,0}',''),(0,400040044,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040044,'0','{remove,0,0}',''),(0,400040045,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040045,'0','{remove,0,0}',''),(0,400040046,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040046,'0','{remove,0,0}',''),(0,400040047,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040047,'0','{remove,0,0}',''),(0,400040048,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040048,'0','{remove,0,0}',''),(0,400040049,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040049,'0','{remove,0,0}',''),(0,400040050,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040050,'0','{remove,0,0}',''),(0,400040051,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040051,'0','{remove,0,0}',''),(0,400040052,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040052,'0','{remove,0,0}',''),(0,400040053,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040053,'0','{remove,0,0}',''),(0,400040054,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040054,'0','{remove,0,0}',''),(0,400040055,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040055,'0','{remove,0,0}',''),(0,400040056,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040056,'0','{remove,0,0}',''),(0,400040057,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040057,'0','{remove,0,0}',''),(0,400040058,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040058,'0','{remove,0,0}',''),(0,400040059,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040059,'0','{remove,0,0}',''),(0,400040060,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040060,'0','{remove,0,0}',''),(0,400040061,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040061,'0','{remove,0,0}',''),(0,400040062,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040062,'0','{remove,0,0}',''),(0,400040063,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040063,'0','{remove,0,0}',''),(0,400040064,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040064,'0','{remove,0,0}',''),(0,400040065,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040065,'0','{remove,0,0}',''),(0,400040066,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040066,'0','{remove,0,0}',''),(0,400040067,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040067,'0','{remove,0,0}',''),(0,400040068,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040068,'0','{remove,0,0}',''),(0,400040069,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040069,'0','{remove,0,0}',''),(0,400040070,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040070,'0','{remove,0,0}',''),(0,400040071,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040071,'0','{remove,0,0}',''),(0,400040072,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040072,'0','{remove,0,0}',''),(0,400040073,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040073,'0','{remove,0,0}',''),(0,400040074,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040074,'0','{remove,0,0}',''),(0,400040075,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040075,'0','{remove,0,0}',''),(0,400040076,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040076,'0','{remove,0,0}',''),(0,400040077,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040077,'0','{remove,0,0}',''),(0,400040078,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040078,'0','{remove,0,0}',''),(0,400040079,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040079,'0','{remove,0,0}',''),(0,400040080,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040080,'0','{remove,0,0}',''),(0,400040081,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040081,'0','{remove,0,0}',''),(0,400040082,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040082,'0','{remove,0,0}',''),(0,400040083,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040083,'0','{remove,0,0}',''),(0,400040084,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040084,'0','{remove,0,0}',''),(0,400040085,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040085,'0','{remove,0,0}',''),(0,400040086,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040086,'0','{remove,0,0}',''),(0,400040087,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040087,'0','{remove,0,0}',''),(0,400040088,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040088,'0','{remove,0,0}',''),(0,400040089,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040089,'0','{remove,0,0}',''),(0,400040090,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040090,'0','{remove,0,0}',''),(0,400040091,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040091,'0','{remove,0,0}',''),(0,400040092,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040092,'0','{remove,0,0}',''),(0,400040093,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040093,'0','{remove,0,0}',''),(0,400040094,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040094,'0','{remove,0,0}',''),(0,400040095,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040095,'0','{remove,0,0}',''),(0,400040096,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040096,'0','{remove,0,0}',''),(0,400040097,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040097,'0','{remove,0,0}',''),(0,400040098,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040098,'0','{remove,0,0}',''),(0,400040099,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040099,'0','{remove,0,0}',''),(0,400040100,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400040100,'0','{remove,0,0}',''),(0,400050001,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050001,'0','{remove,0,0}',''),(0,400050002,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050002,'0','{remove,0,0}',''),(0,400050003,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050003,'0','{remove,0,0}',''),(0,400050004,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050004,'0','{remove,0,0}',''),(0,400050005,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050005,'0','{remove,0,0}',''),(0,400050006,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050006,'0','{remove,0,0}',''),(0,400050007,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050007,'0','{remove,0,0}',''),(0,400050008,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050008,'0','{remove,0,0}',''),(0,400050009,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050009,'0','{remove,0,0}',''),(0,400050010,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050010,'0','{remove,0,0}',''),(0,400050011,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050011,'0','{remove,0,0}',''),(0,400050012,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050012,'0','{remove,0,0}',''),(0,400050013,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050013,'0','{remove,0,0}',''),(0,400050014,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050014,'0','{remove,0,0}',''),(0,400050015,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050015,'0','{remove,0,0}',''),(0,400050016,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050016,'0','{remove,0,0}',''),(0,400050017,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050017,'0','{remove,0,0}',''),(0,400050018,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050018,'0','{remove,0,0}',''),(0,400050019,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050019,'0','{remove,0,0}',''),(0,400050020,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050020,'0','{remove,0,0}',''),(0,400050021,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050021,'0','{remove,0,0}',''),(0,400050022,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050022,'0','{remove,0,0}',''),(0,400050023,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050023,'0','{remove,0,0}',''),(0,400050024,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050024,'0','{remove,0,0}',''),(0,400050025,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050025,'0','{remove,0,0}',''),(0,400050026,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050026,'0','{remove,0,0}',''),(0,400050027,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050027,'0','{remove,0,0}',''),(0,400050028,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050028,'0','{remove,0,0}',''),(0,400050029,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050029,'0','{remove,0,0}',''),(0,400050030,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050030,'0','{remove,0,0}',''),(0,400050031,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050031,'0','{remove,0,0}',''),(0,400050032,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050032,'0','{remove,0,0}',''),(0,400050033,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050033,'0','{remove,0,0}',''),(0,400050034,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050034,'0','{remove,0,0}',''),(0,400050035,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050035,'0','{remove,0,0}',''),(0,400050036,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050036,'0','{remove,0,0}',''),(0,400050037,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050037,'0','{remove,0,0}',''),(0,400050038,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050038,'0','{remove,0,0}',''),(0,400050039,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050039,'0','{remove,0,0}',''),(0,400050040,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050040,'0','{remove,0,0}',''),(0,400050041,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050041,'0','{remove,0,0}',''),(0,400050042,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050042,'0','{remove,0,0}',''),(0,400050043,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050043,'0','{remove,0,0}',''),(0,400050044,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050044,'0','{remove,0,0}',''),(0,400050045,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050045,'0','{remove,0,0}',''),(0,400050046,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050046,'0','{remove,0,0}',''),(0,400050047,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050047,'0','{remove,0,0}',''),(0,400050048,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050048,'0','{remove,0,0}',''),(0,400050049,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050049,'0','{remove,0,0}',''),(0,400050050,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050050,'0','{remove,0,0}',''),(0,400050051,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050051,'0','{remove,0,0}',''),(0,400050052,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050052,'0','{remove,0,0}',''),(0,400050053,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050053,'0','{remove,0,0}',''),(0,400050054,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050054,'0','{remove,0,0}',''),(0,400050055,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050055,'0','{remove,0,0}',''),(0,400050056,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050056,'0','{remove,0,0}',''),(0,400050057,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050057,'0','{remove,0,0}',''),(0,400050058,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050058,'0','{remove,0,0}',''),(0,400050059,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050059,'0','{remove,0,0}',''),(0,400050060,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050060,'0','{remove,0,0}',''),(0,400050061,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050061,'0','{remove,0,0}',''),(0,400050062,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050062,'0','{remove,0,0}',''),(0,400050063,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050063,'0','{remove,0,0}',''),(0,400050064,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050064,'0','{remove,0,0}',''),(0,400050065,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050065,'0','{remove,0,0}',''),(0,400050066,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050066,'0','{remove,0,0}',''),(0,400050067,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050067,'0','{remove,0,0}',''),(0,400050068,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050068,'0','{remove,0,0}',''),(0,400050069,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050069,'0','{remove,0,0}',''),(0,400050070,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050070,'0','{remove,0,0}',''),(0,400050071,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050071,'0','{remove,0,0}',''),(0,400050072,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050072,'0','{remove,0,0}',''),(0,400050073,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050073,'0','{remove,0,0}',''),(0,400050074,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050074,'0','{remove,0,0}',''),(0,400050075,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050075,'0','{remove,0,0}',''),(0,400050076,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050076,'0','{remove,0,0}',''),(0,400050077,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050077,'0','{remove,0,0}',''),(0,400050078,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050078,'0','{remove,0,0}',''),(0,400050079,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050079,'0','{remove,0,0}',''),(0,400050080,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050080,'0','{remove,0,0}',''),(0,400050081,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050081,'0','{remove,0,0}',''),(0,400050082,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050082,'0','{remove,0,0}',''),(0,400050083,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050083,'0','{remove,0,0}',''),(0,400050084,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050084,'0','{remove,0,0}',''),(0,400050085,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050085,'0','{remove,0,0}',''),(0,400050086,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050086,'0','{remove,0,0}',''),(0,400050087,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050087,'0','{remove,0,0}',''),(0,400050088,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050088,'0','{remove,0,0}',''),(0,400050089,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050089,'0','{remove,0,0}',''),(0,400050090,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050090,'0','{remove,0,0}',''),(0,400050091,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050091,'0','{remove,0,0}',''),(0,400050092,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050092,'0','{remove,0,0}',''),(0,400050093,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050093,'0','{remove,0,0}',''),(0,400050094,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050094,'0','{remove,0,0}',''),(0,400050095,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050095,'0','{remove,0,0}',''),(0,400050096,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050096,'0','{remove,0,0}',''),(0,400050097,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050097,'0','{remove,0,0}',''),(0,400050098,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050098,'0','{remove,0,0}',''),(0,400050099,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050099,'0','{remove,0,0}',''),(0,400050100,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400050100,'0','{remove,0,0}',''),(0,400060001,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060001,'0','{remove,0,0}',''),(0,400060002,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060002,'0','{remove,0,0}',''),(0,400060003,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060003,'0','{remove,0,0}',''),(0,400060004,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060004,'0','{remove,0,0}',''),(0,400060005,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060005,'0','{remove,0,0}',''),(0,400060006,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060006,'0','{remove,0,0}',''),(0,400060007,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060007,'0','{remove,0,0}',''),(0,400060008,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060008,'0','{remove,0,0}',''),(0,400060009,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060009,'0','{remove,0,0}',''),(0,400060010,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060010,'0','{remove,0,0}',''),(0,400060011,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060011,'0','{remove,0,0}',''),(0,400060012,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060012,'0','{remove,0,0}',''),(0,400060013,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060013,'0','{remove,0,0}',''),(0,400060014,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060014,'0','{remove,0,0}',''),(0,400060015,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060015,'0','{remove,0,0}',''),(0,400060016,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060016,'0','{remove,0,0}',''),(0,400060017,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060017,'0','{remove,0,0}',''),(0,400060018,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060018,'0','{remove,0,0}',''),(0,400060019,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060019,'0','{remove,0,0}',''),(0,400060020,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060020,'0','{remove,0,0}',''),(0,400060021,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060021,'0','{remove,0,0}',''),(0,400060022,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060022,'0','{remove,0,0}',''),(0,400060023,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060023,'0','{remove,0,0}',''),(0,400060024,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060024,'0','{remove,0,0}',''),(0,400060025,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060025,'0','{remove,0,0}',''),(0,400060026,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060026,'0','{remove,0,0}',''),(0,400060027,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060027,'0','{remove,0,0}',''),(0,400060028,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060028,'0','{remove,0,0}',''),(0,400060029,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060029,'0','{remove,0,0}',''),(0,400060030,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060030,'0','{remove,0,0}',''),(0,400060031,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060031,'0','{remove,0,0}',''),(0,400060032,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060032,'0','{remove,0,0}',''),(0,400060033,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060033,'0','{remove,0,0}',''),(0,400060034,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060034,'0','{remove,0,0}',''),(0,400060035,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060035,'0','{remove,0,0}',''),(0,400060036,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060036,'0','{remove,0,0}',''),(0,400060037,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060037,'0','{remove,0,0}',''),(0,400060038,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060038,'0','{remove,0,0}',''),(0,400060039,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060039,'0','{remove,0,0}',''),(0,400060040,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060040,'0','{remove,0,0}',''),(0,400060041,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060041,'0','{remove,0,0}',''),(0,400060042,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060042,'0','{remove,0,0}',''),(0,400060043,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060043,'0','{remove,0,0}',''),(0,400060044,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060044,'0','{remove,0,0}',''),(0,400060045,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060045,'0','{remove,0,0}',''),(0,400060046,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060046,'0','{remove,0,0}',''),(0,400060047,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060047,'0','{remove,0,0}',''),(0,400060048,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060048,'0','{remove,0,0}',''),(0,400060049,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060049,'0','{remove,0,0}',''),(0,400060050,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060050,'0','{remove,0,0}',''),(0,400060051,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060051,'0','{remove,0,0}',''),(0,400060052,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060052,'0','{remove,0,0}',''),(0,400060053,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060053,'0','{remove,0,0}',''),(0,400060054,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060054,'0','{remove,0,0}',''),(0,400060055,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060055,'0','{remove,0,0}',''),(0,400060056,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060056,'0','{remove,0,0}',''),(0,400060057,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060057,'0','{remove,0,0}',''),(0,400060058,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060058,'0','{remove,0,0}',''),(0,400060059,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060059,'0','{remove,0,0}',''),(0,400060060,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060060,'0','{remove,0,0}',''),(0,400060061,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060061,'0','{remove,0,0}',''),(0,400060062,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060062,'0','{remove,0,0}',''),(0,400060063,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060063,'0','{remove,0,0}',''),(0,400060064,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060064,'0','{remove,0,0}',''),(0,400060065,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060065,'0','{remove,0,0}',''),(0,400060066,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060066,'0','{remove,0,0}',''),(0,400060067,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060067,'0','{remove,0,0}',''),(0,400060068,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060068,'0','{remove,0,0}',''),(0,400060069,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060069,'0','{remove,0,0}',''),(0,400060070,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060070,'0','{remove,0,0}',''),(0,400060071,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060071,'0','{remove,0,0}',''),(0,400060072,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060072,'0','{remove,0,0}',''),(0,400060073,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060073,'0','{remove,0,0}',''),(0,400060074,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060074,'0','{remove,0,0}',''),(0,400060075,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060075,'0','{remove,0,0}',''),(0,400060076,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060076,'0','{remove,0,0}',''),(0,400060077,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060077,'0','{remove,0,0}',''),(0,400060078,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060078,'0','{remove,0,0}',''),(0,400060079,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060079,'0','{remove,0,0}',''),(0,400060080,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060080,'0','{remove,0,0}',''),(0,400060081,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060081,'0','{remove,0,0}',''),(0,400060082,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060082,'0','{remove,0,0}',''),(0,400060083,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060083,'0','{remove,0,0}',''),(0,400060084,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060084,'0','{remove,0,0}',''),(0,400060085,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060085,'0','{remove,0,0}',''),(0,400060086,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060086,'0','{remove,0,0}',''),(0,400060087,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060087,'0','{remove,0,0}',''),(0,400060088,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060088,'0','{remove,0,0}',''),(0,400060089,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060089,'0','{remove,0,0}',''),(0,400060090,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060090,'0','{remove,0,0}',''),(0,400060091,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060091,'0','{remove,0,0}',''),(0,400060092,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060092,'0','{remove,0,0}',''),(0,400060093,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060093,'0','{remove,0,0}',''),(0,400060094,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060094,'0','{remove,0,0}',''),(0,400060095,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060095,'0','{remove,0,0}',''),(0,400060096,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060096,'0','{remove,0,0}',''),(0,400060097,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060097,'0','{remove,0,0}',''),(0,400060098,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060098,'0','{remove,0,0}',''),(0,400060099,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060099,'0','{remove,0,0}',''),(0,400060100,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400060100,'0','{remove,0,0}',''),(0,400070001,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070001,'0','{remove,0,0}',''),(0,400070002,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070002,'0','{remove,0,0}',''),(0,400070003,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070003,'0','{remove,0,0}',''),(0,400070004,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070004,'0','{remove,0,0}',''),(0,400070005,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070005,'0','{remove,0,0}',''),(0,400070006,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070006,'0','{remove,0,0}',''),(0,400070007,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070007,'0','{remove,0,0}',''),(0,400070008,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070008,'0','{remove,0,0}',''),(0,400070009,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070009,'0','{remove,0,0}',''),(0,400070010,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070010,'0','{remove,0,0}',''),(0,400070011,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070011,'0','{remove,0,0}',''),(0,400070012,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070012,'0','{remove,0,0}',''),(0,400070013,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070013,'0','{remove,0,0}',''),(0,400070014,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070014,'0','{remove,0,0}',''),(0,400070015,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070015,'0','{remove,0,0}',''),(0,400070016,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070016,'0','{remove,0,0}',''),(0,400070017,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070017,'0','{remove,0,0}',''),(0,400070018,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070018,'0','{remove,0,0}',''),(0,400070019,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070019,'0','{remove,0,0}',''),(0,400070020,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070020,'0','{remove,0,0}',''),(0,400070021,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070021,'0','{remove,0,0}',''),(0,400070022,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070022,'0','{remove,0,0}',''),(0,400070023,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070023,'0','{remove,0,0}',''),(0,400070024,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070024,'0','{remove,0,0}',''),(0,400070025,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070025,'0','{remove,0,0}',''),(0,400070026,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070026,'0','{remove,0,0}',''),(0,400070027,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070027,'0','{remove,0,0}',''),(0,400070028,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070028,'0','{remove,0,0}',''),(0,400070029,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070029,'0','{remove,0,0}',''),(0,400070030,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070030,'0','{remove,0,0}',''),(0,400070031,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070031,'0','{remove,0,0}',''),(0,400070032,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070032,'0','{remove,0,0}',''),(0,400070033,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070033,'0','{remove,0,0}',''),(0,400070034,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070034,'0','{remove,0,0}',''),(0,400070035,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070035,'0','{remove,0,0}',''),(0,400070036,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070036,'0','{remove,0,0}',''),(0,400070037,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070037,'0','{remove,0,0}',''),(0,400070038,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070038,'0','{remove,0,0}',''),(0,400070039,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070039,'0','{remove,0,0}',''),(0,400070040,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070040,'0','{remove,0,0}',''),(0,400070041,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070041,'0','{remove,0,0}',''),(0,400070042,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070042,'0','{remove,0,0}',''),(0,400070043,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070043,'0','{remove,0,0}',''),(0,400070044,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070044,'0','{remove,0,0}',''),(0,400070045,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070045,'0','{remove,0,0}',''),(0,400070046,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070046,'0','{remove,0,0}',''),(0,400070047,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070047,'0','{remove,0,0}',''),(0,400070048,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070048,'0','{remove,0,0}',''),(0,400070049,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070049,'0','{remove,0,0}',''),(0,400070050,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070050,'0','{remove,0,0}',''),(0,400070051,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070051,'0','{remove,0,0}',''),(0,400070052,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070052,'0','{remove,0,0}',''),(0,400070053,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070053,'0','{remove,0,0}',''),(0,400070054,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070054,'0','{remove,0,0}',''),(0,400070055,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070055,'0','{remove,0,0}',''),(0,400070056,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070056,'0','{remove,0,0}',''),(0,400070057,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070057,'0','{remove,0,0}',''),(0,400070058,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070058,'0','{remove,0,0}',''),(0,400070059,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070059,'0','{remove,0,0}',''),(0,400070060,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070060,'0','{remove,0,0}',''),(0,400070061,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070061,'0','{remove,0,0}',''),(0,400070062,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070062,'0','{remove,0,0}',''),(0,400070063,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070063,'0','{remove,0,0}',''),(0,400070064,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070064,'0','{remove,0,0}',''),(0,400070065,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070065,'0','{remove,0,0}',''),(0,400070066,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070066,'0','{remove,0,0}',''),(0,400070067,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070067,'0','{remove,0,0}',''),(0,400070068,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070068,'0','{remove,0,0}',''),(0,400070069,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070069,'0','{remove,0,0}',''),(0,400070070,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070070,'0','{remove,0,0}',''),(0,400070071,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070071,'0','{remove,0,0}',''),(0,400070072,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070072,'0','{remove,0,0}',''),(0,400070073,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070073,'0','{remove,0,0}',''),(0,400070074,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070074,'0','{remove,0,0}',''),(0,400070075,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070075,'0','{remove,0,0}',''),(0,400070076,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070076,'0','{remove,0,0}',''),(0,400070077,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070077,'0','{remove,0,0}',''),(0,400070078,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070078,'0','{remove,0,0}',''),(0,400070079,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070079,'0','{remove,0,0}',''),(0,400070080,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070080,'0','{remove,0,0}',''),(0,400070081,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070081,'0','{remove,0,0}',''),(0,400070082,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070082,'0','{remove,0,0}',''),(0,400070083,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070083,'0','{remove,0,0}',''),(0,400070084,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070084,'0','{remove,0,0}',''),(0,400070085,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070085,'0','{remove,0,0}',''),(0,400070086,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070086,'0','{remove,0,0}',''),(0,400070087,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070087,'0','{remove,0,0}',''),(0,400070088,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070088,'0','{remove,0,0}',''),(0,400070089,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070089,'0','{remove,0,0}',''),(0,400070090,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070090,'0','{remove,0,0}',''),(0,400070091,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070091,'0','{remove,0,0}',''),(0,400070092,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070092,'0','{remove,0,0}',''),(0,400070093,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070093,'0','{remove,0,0}',''),(0,400070094,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070094,'0','{remove,0,0}',''),(0,400070095,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070095,'0','{remove,0,0}',''),(0,400070096,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070096,'0','{remove,0,0}',''),(0,400070097,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070097,'0','{remove,0,0}',''),(0,400070098,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070098,'0','{remove,0,0}',''),(0,400070099,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070099,'0','{remove,0,0}',''),(0,400070100,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400070100,'0','{remove,0,0}',''),(0,400080001,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080001,'0','{remove,0,0}',''),(0,400080002,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080002,'0','{remove,0,0}',''),(0,400080003,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080003,'0','{remove,0,0}',''),(0,400080004,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080004,'0','{remove,0,0}',''),(0,400080005,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080005,'0','{remove,0,0}',''),(0,400080006,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080006,'0','{remove,0,0}',''),(0,400080007,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080007,'0','{remove,0,0}',''),(0,400080008,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080008,'0','{remove,0,0}',''),(0,400080009,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080009,'0','{remove,0,0}',''),(0,400080010,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080010,'0','{remove,0,0}',''),(0,400080011,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080011,'0','{remove,0,0}',''),(0,400080012,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080012,'0','{remove,0,0}',''),(0,400080013,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080013,'0','{remove,0,0}',''),(0,400080014,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080014,'0','{remove,0,0}',''),(0,400080015,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080015,'0','{remove,0,0}',''),(0,400080016,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080016,'0','{remove,0,0}',''),(0,400080017,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080017,'0','{remove,0,0}',''),(0,400080018,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080018,'0','{remove,0,0}',''),(0,400080019,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080019,'0','{remove,0,0}',''),(0,400080020,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080020,'0','{remove,0,0}',''),(0,400080021,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080021,'0','{remove,0,0}',''),(0,400080022,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080022,'0','{remove,0,0}',''),(0,400080023,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080023,'0','{remove,0,0}',''),(0,400080024,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080024,'0','{remove,0,0}',''),(0,400080025,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080025,'0','{remove,0,0}',''),(0,400080026,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080026,'0','{remove,0,0}',''),(0,400080027,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080027,'0','{remove,0,0}',''),(0,400080028,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080028,'0','{remove,0,0}',''),(0,400080029,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080029,'0','{remove,0,0}',''),(0,400080030,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080030,'0','{remove,0,0}',''),(0,400080031,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080031,'0','{remove,0,0}',''),(0,400080032,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080032,'0','{remove,0,0}',''),(0,400080033,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080033,'0','{remove,0,0}',''),(0,400080034,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080034,'0','{remove,0,0}',''),(0,400080035,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080035,'0','{remove,0,0}',''),(0,400080036,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080036,'0','{remove,0,0}',''),(0,400080037,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080037,'0','{remove,0,0}',''),(0,400080038,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080038,'0','{remove,0,0}',''),(0,400080039,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080039,'0','{remove,0,0}',''),(0,400080040,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080040,'0','{remove,0,0}',''),(0,400080041,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080041,'0','{remove,0,0}',''),(0,400080042,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080042,'0','{remove,0,0}',''),(0,400080043,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080043,'0','{remove,0,0}',''),(0,400080044,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080044,'0','{remove,0,0}',''),(0,400080045,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080045,'0','{remove,0,0}',''),(0,400080046,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080046,'0','{remove,0,0}',''),(0,400080047,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080047,'0','{remove,0,0}',''),(0,400080048,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080048,'0','{remove,0,0}',''),(0,400080049,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080049,'0','{remove,0,0}',''),(0,400080050,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080050,'0','{remove,0,0}',''),(0,400080051,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080051,'0','{remove,0,0}',''),(0,400080052,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080052,'0','{remove,0,0}',''),(0,400080053,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080053,'0','{remove,0,0}',''),(0,400080054,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080054,'0','{remove,0,0}',''),(0,400080055,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080055,'0','{remove,0,0}',''),(0,400080056,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080056,'0','{remove,0,0}',''),(0,400080057,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080057,'0','{remove,0,0}',''),(0,400080058,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080058,'0','{remove,0,0}',''),(0,400080059,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080059,'0','{remove,0,0}',''),(0,400080060,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080060,'0','{remove,0,0}',''),(0,400080061,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080061,'0','{remove,0,0}',''),(0,400080062,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080062,'0','{remove,0,0}',''),(0,400080063,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080063,'0','{remove,0,0}',''),(0,400080064,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080064,'0','{remove,0,0}',''),(0,400080065,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080065,'0','{remove,0,0}',''),(0,400080066,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080066,'0','{remove,0,0}',''),(0,400080067,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080067,'0','{remove,0,0}',''),(0,400080068,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080068,'0','{remove,0,0}',''),(0,400080069,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080069,'0','{remove,0,0}',''),(0,400080070,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080070,'0','{remove,0,0}',''),(0,400080071,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080071,'0','{remove,0,0}',''),(0,400080072,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080072,'0','{remove,0,0}',''),(0,400080073,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080073,'0','{remove,0,0}',''),(0,400080074,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080074,'0','{remove,0,0}',''),(0,400080075,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080075,'0','{remove,0,0}',''),(0,400080076,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080076,'0','{remove,0,0}',''),(0,400080077,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080077,'0','{remove,0,0}',''),(0,400080078,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080078,'0','{remove,0,0}',''),(0,400080079,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080079,'0','{remove,0,0}',''),(0,400080080,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080080,'0','{remove,0,0}',''),(0,400080081,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080081,'0','{remove,0,0}',''),(0,400080082,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080082,'0','{remove,0,0}',''),(0,400080083,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080083,'0','{remove,0,0}',''),(0,400080084,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080084,'0','{remove,0,0}',''),(0,400080085,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080085,'0','{remove,0,0}',''),(0,400080086,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080086,'0','{remove,0,0}',''),(0,400080087,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080087,'0','{remove,0,0}',''),(0,400080088,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080088,'0','{remove,0,0}',''),(0,400080089,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080089,'0','{remove,0,0}',''),(0,400080090,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080090,'0','{remove,0,0}',''),(0,400080091,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080091,'0','{remove,0,0}',''),(0,400080092,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080092,'0','{remove,0,0}',''),(0,400080093,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080093,'0','{remove,0,0}',''),(0,400080094,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080094,'0','{remove,0,0}',''),(0,400080095,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080095,'0','{remove,0,0}',''),(0,400080096,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080096,'0','{remove,0,0}',''),(0,400080097,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080097,'0','{remove,0,0}',''),(0,400080098,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080098,'0','{remove,0,0}',''),(0,400080099,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080099,'0','{remove,0,0}',''),(0,400080100,'0','{path,[[{40001,5491,3866},{40001,5398,3805},{40001,5306,3743},{40001,5214,3681},{40001,5122,3618},{40001,5030,3555},{40001,4919,3493},{40001,4796,3437},{40001,4674,3379},{40001,4552,3320},{40001,4433,3256},{40001,4331,3194},{40001,4230,3131},{40001,4128,3069},{40001,4025,3009},{40001,3914,2946},{40001,3804,2882},{40001,3694,2819},{40001,3583,2756},{40001,3473,2692},{40001,3371,2631},{40001,3261,2567},{40001,3150,2505},{40001,3039,2442},{40001,2928,2380},{40001,2816,2319},{40001,2704,2259},{40001,2593,2197},{40001,2482,2134},{40001,2371,2072},{40001,2260,2010},{40001,2150,1947},{40001,2040,1883},{40001,1937,1823},{40001,1930,1819}],0],0}',''),(6,400080100,'0','{remove,0,0}','');
/*!40000 ALTER TABLE `base_ai` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_ai_content`
--

DROP TABLE IF EXISTS `base_ai_content`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_ai_content` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'AI库id',
  `content` text NOT NULL COMMENT '1.发送传闻 AI类型:cw 参数:  [传闻类型(1世界,2场景), <<"文字内容">>]  2.怪物说话 AI类型:msg 参数:  [怪物id, <<"文字内容">>]  3.创建怪物 AI类型 create_mon 参数:  [怪物id,最小x坐标,最大x坐标,最小y坐标,最大y坐标,是否主动,高阶参数]',
  `remark` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_ai_content`
--

LOCK TABLES `base_ai_content` WRITE;
/*!40000 ALTER TABLE `base_ai_content` DISABLE KEYS */;
INSERT INTO `base_ai_content` VALUES (1,'{create_bonfire,[1000, 1],0}','100%创建普通篝火'),(2,'{create_mon,[50,20000,0,0,0,0,0,[]],0}',''),(3,'{create_bonfire,[0, 3],0}','五芒星篝火测试怪'),(4,'{create_bonfire,[1000, 4],0}','篝火已经转移到了怪物表，生成篝火的字段');
/*!40000 ALTER TABLE `base_ai_content` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_auction_act`
--

DROP TABLE IF EXISTS `base_auction_act`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_auction_act` (
  `opday_slot` varchar(100) NOT NULL COMMENT '开服天数',
  `cfg_id` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '配置ID',
  `sys_goods` varchar(5120) NOT NULL COMMENT '系统物品',
  `start_time` varchar(256) NOT NULL COMMENT '开始时间',
  `end_time` varchar(256) NOT NULL COMMENT '结束时间',
  PRIMARY KEY (`opday_slot`,`cfg_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='系统拍卖活动';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_auction_act`
--

LOCK TABLES `base_auction_act` WRITE;
/*!40000 ALTER TABLE `base_auction_act` DISABLE KEYS */;
/*!40000 ALTER TABLE `base_auction_act` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_auction_catalog`
--

DROP TABLE IF EXISTS `base_auction_catalog`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_auction_catalog` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `name` varchar(255) NOT NULL COMMENT '类目名称@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='拍卖类目';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_auction_catalog`
--

LOCK TABLES `base_auction_catalog` WRITE;
/*!40000 ALTER TABLE `base_auction_catalog` DISABLE KEYS */;
INSERT INTO `base_auction_catalog` VALUES (1,'装备'),(2,'宝物');
/*!40000 ALTER TABLE `base_auction_catalog` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_auction_common_args`
--

DROP TABLE IF EXISTS `base_auction_common_args`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_auction_common_args` (
  `module_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `zone` int(11) NOT NULL DEFAULT '0' COMMENT '战区',
  `min_rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名下限',
  `max_rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名上限',
  `reward_list` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '参数设定',
  PRIMARY KEY (`module_id`,`zone`,`min_rank`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_auction_common_args`
--

LOCK TABLES `base_auction_common_args` WRITE;
/*!40000 ALTER TABLE `base_auction_common_args` DISABLE KEYS */;
INSERT INTO `base_auction_common_args` VALUES (402,1,1,1,'[{1,120,3},{2,720,3},{3,1440,2},{4,2400,2}]'),(402,1,2,2,'[{1,120,3},{2,720,3},{3,1440,2}]'),(402,1,3,3,'[{1,120,3},{2,720,3},{3,1440,1}]'),(402,2,1,1,'[{1,120,3},{2,720,3}]'),(605,1,1,1,'[{1,120,3},{2,360,3},{3,1200,2}]'),(605,1,2,3,'[{1,120,3},{2,360,2},{3,1200,1}]'),(605,1,4,5,'[{1,120,3},{2,360,1}]'),(605,1,6,8,'[{1,120,2}]');
/*!40000 ALTER TABLE `base_auction_common_args` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_auction_common_liveness`
--

DROP TABLE IF EXISTS `base_auction_common_liveness`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_auction_common_liveness` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '序号',
  `min_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家等级下限',
  `max_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家等级上限',
  `min_liveness` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活跃度下限',
  `max_liveness` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活跃度上限',
  `reward_list` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '奖池价值参数',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_auction_common_liveness`
--

LOCK TABLES `base_auction_common_liveness` WRITE;
/*!40000 ALTER TABLE `base_auction_common_liveness` DISABLE KEYS */;
INSERT INTO `base_auction_common_liveness` VALUES (1,1,175,1,25,'[{1,10},{2,20},{3,30},{4,40}]'),(2,1,175,26,50,'[{1,20},{2,30},{3,40},{4,50}]'),(3,1,175,51,75,'[{1,40},{2,60},{3,80},{4,100}]'),(4,1,175,76,100,'[{1,60},{2,90},{3,120},{4,150}]'),(5,1,175,101,125,'[{1,90},{2,135},{3,180},{4,225}]'),(6,1,175,126,9999,'[{1,120},{2,180},{3,240},{4,300}]'),(7,176,275,1,25,'[{1,10},{2,20},{3,30},{4,40}]'),(8,176,275,26,50,'[{1,20},{2,30},{3,40},{4,50}]'),(9,176,275,51,75,'[{1,40},{2,60},{3,80},{4,100}]'),(10,176,275,76,100,'[{1,60},{2,90},{3,120},{4,150}]'),(11,176,275,101,125,'[{1,90},{2,135},{3,180},{4,225}]'),(12,176,275,126,9999,'[{1,120},{2,180},{3,240},{4,300}]'),(13,276,375,1,25,'[{1,10},{2,20},{3,30},{4,40}]'),(14,276,375,26,50,'[{1,20},{2,30},{3,40},{4,50}]'),(15,276,375,51,75,'[{1,40},{2,60},{3,80},{4,100}]'),(16,276,375,76,100,'[{1,60},{2,90},{3,120},{4,150}]'),(17,276,375,101,125,'[{1,90},{2,135},{3,180},{4,225}]'),(18,276,375,126,9999,'[{1,120},{2,180},{3,240},{4,300}]'),(19,376,475,1,25,'[{1,10},{2,20},{3,30},{4,40}]'),(20,376,475,26,50,'[{1,20},{2,30},{3,40},{4,50}]'),(21,376,475,51,75,'[{1,40},{2,60},{3,80},{4,100}]'),(22,376,475,76,100,'[{1,60},{2,90},{3,120},{4,150}]'),(23,376,475,101,125,'[{1,90},{2,135},{3,180},{4,225}]'),(24,376,475,126,9999,'[{1,120},{2,180},{3,240},{4,300}]'),(25,476,540,1,25,'[{1,10},{2,20},{3,30},{4,40}]'),(26,476,540,26,50,'[{1,20},{2,30},{3,40},{4,50}]'),(27,476,540,51,75,'[{1,40},{2,60},{3,80},{4,100}]'),(28,476,540,76,100,'[{1,60},{2,90},{3,120},{4,150}]'),(29,476,540,101,125,'[{1,90},{2,135},{3,180},{4,225}]'),(30,476,540,126,9999,'[{1,120},{2,180},{3,240},{4,300}]'),(31,541,585,1,25,'[{1,10},{2,20},{3,30},{4,40}]'),(32,541,585,26,50,'[{1,20},{2,30},{3,40},{4,50}]'),(33,541,585,51,75,'[{1,40},{2,60},{3,80},{4,100}]'),(34,541,585,76,100,'[{1,60},{2,90},{3,120},{4,150}]'),(35,541,585,101,125,'[{1,90},{2,135},{3,180},{4,225}]'),(36,541,585,126,9999,'[{1,120},{2,180},{3,240},{4,300}]'),(37,586,635,1,25,'[{1,10},{2,20},{3,30},{4,40}]'),(38,586,635,26,50,'[{1,20},{2,30},{3,40},{4,50}]'),(39,586,635,51,75,'[{1,40},{2,60},{3,80},{4,100}]'),(40,586,635,76,100,'[{1,60},{2,90},{3,120},{4,150}]'),(41,586,635,101,125,'[{1,90},{2,135},{3,180},{4,225}]'),(42,586,635,126,9999,'[{1,120},{2,180},{3,240},{4,300}]'),(43,636,685,1,25,'[{1,10},{2,20},{3,30},{4,40}]'),(44,636,685,26,50,'[{1,20},{2,30},{3,40},{4,50}]'),(45,636,685,51,75,'[{1,40},{2,60},{3,80},{4,100}]'),(46,636,685,76,100,'[{1,60},{2,90},{3,120},{4,150}]'),(47,636,685,101,125,'[{1,90},{2,135},{3,180},{4,225}]'),(48,636,685,126,9999,'[{1,120},{2,180},{3,240},{4,300}]'),(49,686,735,1,25,'[{1,10},{2,20},{3,30},{4,40}]'),(50,686,735,26,50,'[{1,20},{2,30},{3,40},{4,50}]'),(51,686,735,51,75,'[{1,40},{2,60},{3,80},{4,100}]'),(52,686,735,76,100,'[{1,60},{2,90},{3,120},{4,150}]'),(53,686,735,101,125,'[{1,90},{2,135},{3,180},{4,225}]'),(54,686,735,126,9999,'[{1,120},{2,180},{3,240},{4,300}]'),(55,736,785,1,25,'[{1,10},{2,20},{3,30},{4,40}]'),(56,736,785,26,50,'[{1,20},{2,30},{3,40},{4,50}]'),(57,736,785,51,75,'[{1,40},{2,60},{3,80},{4,100}]'),(58,736,785,76,100,'[{1,60},{2,90},{3,120},{4,150}]'),(59,736,785,101,125,'[{1,90},{2,135},{3,180},{4,225}]'),(60,736,785,126,9999,'[{1,120},{2,180},{3,240},{4,300}]'),(61,786,835,1,25,'[{1,10},{2,20},{3,30},{4,40}]'),(62,786,835,26,50,'[{1,20},{2,30},{3,40},{4,50}]'),(63,786,835,51,75,'[{1,40},{2,60},{3,80},{4,100}]'),(64,786,835,76,100,'[{1,60},{2,90},{3,120},{4,150}]'),(65,786,835,101,125,'[{1,90},{2,135},{3,180},{4,225}]'),(66,786,835,126,9999,'[{1,120},{2,180},{3,240},{4,300}]'),(67,836,885,1,25,'[{1,10},{2,20},{3,30},{4,40}]'),(68,836,885,26,50,'[{1,20},{2,30},{3,40},{4,50}]'),(69,836,885,51,75,'[{1,40},{2,60},{3,80},{4,100}]'),(70,836,885,76,100,'[{1,60},{2,90},{3,120},{4,150}]'),(71,836,885,101,125,'[{1,90},{2,135},{3,180},{4,225}]'),(72,836,885,126,9999,'[{1,120},{2,180},{3,240},{4,300}]'),(73,886,935,1,25,'[{1,10},{2,20},{3,30},{4,40}]'),(74,886,935,26,50,'[{1,20},{2,30},{3,40},{4,50}]'),(75,886,935,51,75,'[{1,40},{2,60},{3,80},{4,100}]'),(76,886,935,76,100,'[{1,60},{2,90},{3,120},{4,150}]'),(77,886,935,101,125,'[{1,90},{2,135},{3,180},{4,225}]'),(78,886,935,126,9999,'[{1,120},{2,180},{3,240},{4,300}]'),(79,936,1000,1,25,'[{1,10},{2,20},{3,30},{4,40}]'),(80,936,1000,26,50,'[{1,20},{2,30},{3,40},{4,50}]'),(81,936,1000,51,75,'[{1,40},{2,60},{3,80},{4,100}]'),(82,936,1000,76,100,'[{1,60},{2,90},{3,120},{4,150}]'),(83,936,1000,101,125,'[{1,90},{2,135},{3,180},{4,225}]'),(84,936,1000,126,9999,'[{1,120},{2,180},{3,240},{4,300}]');
/*!40000 ALTER TABLE `base_auction_common_liveness` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_auction_common_reward`
--

DROP TABLE IF EXISTS `base_auction_common_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_auction_common_reward` (
  `module_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `zone` int(11) unsigned NOT NULL DEFAULT '1' COMMENT '战区',
  `min_world_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '世界等级下限',
  `max_world_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '世界等级上限',
  `min_rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名下限',
  `max_rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名上限',
  `reward_list` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '奖池',
  PRIMARY KEY (`module_id`,`zone`,`min_world_lv`,`min_rank`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_auction_common_reward`
--

LOCK TABLES `base_auction_common_reward` WRITE;
/*!40000 ALTER TABLE `base_auction_common_reward` DISABLE KEYS */;
INSERT INTO `base_auction_common_reward` VALUES (402,1,1,200,1,1,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{32080532,1,480}]},{2,[{32080533,1,640},{32080542,1,720}]},{3,[{32080543,1,1440}]}]'),(402,1,1,200,2,2,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{32080532,1,480}]},{2,[{32080533,1,640},{32080542,1,720}]},{3,[{32080543,1,1440}]}]'),(402,1,1,200,3,3,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{32080532,1,480}]},{2,[{32080533,1,640},{32080542,1,720}]},{3,[{32080543,1,1440}]}]'),(402,1,201,260,1,1,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{32080632,1,480}]},{2,[{32080633,1,640},{32080642,1,720}]},{3,[{32080643,1,1440}]}]'),(402,1,201,260,2,2,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{32080632,1,480}]},{2,[{32080633,1,640},{32080642,1,720}]},{3,[{32080643,1,1440}]}]'),(402,1,201,260,3,3,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{32080632,1,480}]},{2,[{32080633,1,640},{32080642,1,720}]},{3,[{32080643,1,1440}]}]'),(402,1,261,290,1,1,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{32080732,1,480}]},{2,[{32080733,1,640},{32080742,1,720}]},{3,[{32080743,1,1440}]}]'),(402,1,261,290,2,2,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{32080732,1,480}]},{2,[{32080733,1,640},{32080742,1,720}]},{3,[{32080743,1,1440}]}]'),(402,1,261,290,3,3,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{32080732,1,480}]},{2,[{32080733,1,640},{32080742,1,720}]},{3,[{32080743,1,1440}]}]'),(402,1,291,320,1,1,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{32080832,1,480}]},{2,[{32080833,1,640},{32080842,1,720}]},{3,[{32080843,1,1440}]}]'),(402,1,291,320,2,2,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{32080832,1,480}]},{2,[{32080833,1,640},{32080842,1,720}]},{3,[{32080843,1,1440}]}]'),(402,1,291,320,3,3,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{32080832,1,480}]},{2,[{32080833,1,640},{32080842,1,720}]},{3,[{32080843,1,1440}]}]'),(402,1,321,350,1,1,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{32080832,1,480}]},{2,[{32080833,1,640},{32080842,1,720}]},{3,[{32080843,1,1440}]}]'),(402,1,321,350,2,2,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{32080832,1,480}]},{2,[{32080833,1,640},{32080842,1,720}]},{3,[{32080843,1,1440}]}]'),(402,1,321,350,3,3,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{32080832,1,480}]},{2,[{32080833,1,640},{32080842,1,720}]},{3,[{32080843,1,1440}]}]'),(402,1,351,370,1,1,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{32080932,1,480}]},{2,[{32080933,1,640},{32080942,1,720}]},{3,[{32080943,1,1440}]}]'),(402,1,351,370,2,2,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{32080932,1,480}]},{2,[{32080933,1,640},{32080942,1,720}]},{3,[{32080943,1,1440}]}]'),(402,1,351,370,3,3,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{32080932,1,480}]},{2,[{32080933,1,640},{32080942,1,720}]},{3,[{32080943,1,1440}]}]'),(402,1,371,390,1,1,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{32081032,1,480}]},{2,[{32081033,1,640},{32081042,1,720}]},{3,[{32081043,1,1440},{38280620,1,1440}]},{4,[{34010001,1,1600}]}]'),(402,1,371,390,2,2,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{32081032,1,480}]},{2,[{32081033,1,640},{32081042,1,720}]},{3,[{32081043,1,1440},{38280620,1,1440}]},{4,[{34010001,1,1600}]}]'),(402,1,371,390,3,3,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{32081032,1,480}]},{2,[{32081033,1,640},{32081042,1,720}]},{3,[{32081043,1,1440},{38280620,1,1440}]},{4,[{34010001,1,1600}]}]'),(402,1,391,430,1,1,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{20040004,1,550},{32081132,1,480}]},{2,[{32081133,1,640},{32081142,1,720}]},{3,[{32081143,1,1440},{38280620,1,1440}]},{4,[{34010001,1,1600}]}]'),(402,1,391,430,2,2,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{20040004,1,550},{32081132,1,480}]},{2,[{32081133,1,640},{32081142,1,720}]},{3,[{32081143,1,1440},{38280620,1,1440}]},{4,[{34010001,1,1600}]}]'),(402,1,391,430,3,3,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{20040004,1,550},{32081132,1,480}]},{2,[{32081133,1,640},{32081142,1,720}]},{3,[{32081143,1,1440},{38280620,1,1440}]},{4,[{34010001,1,1600}]}]'),(402,1,431,500,1,1,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{20040004,1,550},{32081132,1,480}]},{2,[{32081133,1,640},{32081142,1,720}]},{3,[{32081143,1,1440},{38280620,1,1440}]},{4,[{34010001,1,1600}]}]'),(402,1,431,500,2,2,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{20040004,1,550},{32081132,1,480}]},{2,[{32081133,1,640},{32081142,1,720}]},{3,[{32081143,1,1440},{38280620,1,1440}]},{4,[{34010001,1,1600}]}]'),(402,1,431,500,3,3,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{20040004,1,550},{32081132,1,480}]},{2,[{32081133,1,640},{32081142,1,720}]},{3,[{32081143,1,1440},{38280620,1,1440}]},{4,[{34010001,1,1600}]}]'),(402,1,501,560,1,1,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{20040004,1,550},{32081232,1,480}]},{2,[{32081233,1,640},{32081242,1,720}]},{3,[{32081243,1,1440},{38280620,1,1440}]},{4,[{34010001,1,1600}]}]'),(402,1,501,560,2,2,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{20040004,1,550},{32081232,1,480}]},{2,[{32081233,1,640},{32081242,1,720}]},{3,[{32081243,1,1440},{38280620,1,1440}]},{4,[{34010001,1,1600}]}]'),(402,1,501,560,3,3,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{20040004,1,550},{32081232,1,480}]},{2,[{32081233,1,640},{32081242,1,720}]},{3,[{32081243,1,1440},{38280620,1,1440}]},{4,[{34010001,1,1600}]}]'),(402,1,561,610,1,1,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{20040004,1,550},{32081332,1,480}]},{2,[{32081333,1,640},{32081342,1,720}]},{3,[{32081343,1,1440},{38280620,1,1440}]},{4,[{34010001,1,1600}]}]'),(402,1,561,610,2,2,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{20040004,1,550},{32081332,1,480}]},{2,[{32081333,1,640},{32081342,1,720}]},{3,[{32081343,1,1440},{38280620,1,1440}]},{4,[{34010001,1,1600}]}]'),(402,1,561,610,3,3,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{20040004,1,550},{32081332,1,480}]},{2,[{32081333,1,640},{32081342,1,720}]},{3,[{32081343,1,1440},{38280620,1,1440}]},{4,[{34010001,1,1600}]}]'),(402,1,611,660,1,1,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{20040004,1,550},{32081432,1,480}]},{2,[{32081433,1,640},{32081442,1,720}]},{3,[{32081443,1,1440},{38280620,1,1440}]},{4,[{34010001,1,1600}]}]'),(402,1,611,660,2,2,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{20040004,1,550},{32081432,1,480}]},{2,[{32081433,1,640},{32081442,1,720}]},{3,[{32081443,1,1440},{38280620,1,1440}]},{4,[{34010001,1,1600}]}]'),(402,1,611,660,3,3,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{20040004,1,550},{32081432,1,480}]},{2,[{32081433,1,640},{32081442,1,720}]},{3,[{32081443,1,1440},{38280620,1,1440}]},{4,[{34010001,1,1600}]}]'),(402,1,661,750,1,1,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{20040004,1,550},{32081532,1,480}]},{2,[{32081533,1,640},{32081542,1,720}]},{3,[{32081543,1,1440},{38280620,1,1440}]},{4,[{34010001,1,1600}]}]'),(402,1,661,750,2,2,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{20040004,1,550},{32081532,1,480}]},{2,[{32081533,1,640},{32081542,1,720}]},{3,[{32081543,1,1440},{38280620,1,1440}]},{4,[{34010001,1,1600}]}]'),(402,1,661,750,3,3,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{20040004,1,550},{32081532,1,480}]},{2,[{32081533,1,640},{32081542,1,720}]},{3,[{32081543,1,1440},{38280620,1,1440}]},{4,[{34010001,1,1600}]}]'),(402,1,751,1000,1,1,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{20040004,1,550},{32081632,1,480}]},{2,[{32081633,1,640},{32081642,1,720}]},{3,[{32081643,1,1440},{38280620,1,1440}]},{4,[{34010001,1,1600}]}]'),(402,1,751,1000,2,2,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{20040004,1,550},{32081632,1,480}]},{2,[{32081633,1,640},{32081642,1,720}]},{3,[{32081643,1,1440},{38280620,1,1440}]},{4,[{34010001,1,1600}]}]'),(402,1,751,1000,3,3,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{20040004,1,550},{32081632,1,480}]},{2,[{32081633,1,640},{32081642,1,720}]},{3,[{32081643,1,1440},{38280620,1,1440}]},{4,[{34010001,1,1600}]}]'),(402,2,1,200,1,1,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{32080532,1,480}]},{2,[{32080533,1,640},{32080542,1,720}]},{3,[{32080543,1,1440}]}]'),(402,2,201,260,1,1,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{32080632,1,480}]},{2,[{32080633,1,640},{32080642,1,720}]},{3,[{32080643,1,1440}]}]'),(402,2,261,290,1,1,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{32080732,1,480}]},{2,[{32080733,1,640},{32080742,1,720}]},{3,[{32080743,1,1440}]}]'),(402,2,291,320,1,1,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{32080832,1,480}]},{2,[{32080833,1,640},{32080842,1,720}]},{3,[{32080843,1,1440}]}]'),(402,2,321,350,1,1,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{32080832,1,480}]},{2,[{32080833,1,640},{32080842,1,720}]},{3,[{32080843,1,1440}]}]'),(402,2,351,370,1,1,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{32080932,1,480}]},{2,[{32080933,1,640},{32080942,1,720}]},{3,[{32080943,1,1440}]}]'),(402,2,371,390,1,1,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{32081032,1,480}]},{2,[{32081033,1,640},{32081042,1,720}]},{3,[{32081043,1,1440},{38280620,1,1440}]},{4,[{34010001,1,1600}]}]'),(402,2,391,430,1,1,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{20040004,1,550},{32081132,1,480}]},{2,[{32081133,1,640},{32081142,1,720}]},{3,[{32081143,1,1440},{38280620,1,1440}]},{4,[{34010001,1,1600}]}]'),(402,2,431,500,1,1,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{20040004,1,550},{32081132,1,480}]},{2,[{32081133,1,640},{32081142,1,720}]},{3,[{32081143,1,1440},{38280620,1,1440}]},{4,[{34010001,1,1600}]}]'),(402,2,501,560,1,1,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{20040004,1,550},{32081232,1,480}]},{2,[{32081233,1,640},{32081242,1,720}]},{3,[{32081243,1,1440},{38280620,1,1440}]},{4,[{34010001,1,1600}]}]'),(402,2,561,610,1,1,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{20040004,1,550},{32081332,1,480}]},{2,[{32081333,1,640},{32081342,1,720}]},{3,[{32081343,1,1440},{38280620,1,1440}]},{4,[{34010001,1,1600}]}]'),(402,2,611,660,1,1,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{20040004,1,550},{32081432,1,480}]},{2,[{32081433,1,640},{32081442,1,720}]},{3,[{32081443,1,1440},{38280620,1,1440}]},{4,[{34010001,1,1600}]}]'),(402,2,661,750,1,1,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{20040004,1,550},{32081532,1,480}]},{2,[{32081533,1,640},{32081542,1,720}]},{3,[{32081543,1,1440},{38280620,1,1440}]},{4,[{34010001,1,1600}]}]'),(402,2,751,1000,1,1,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{20040004,1,550},{32081632,1,480}]},{2,[{32081633,1,640},{32081642,1,720}]},{3,[{32081643,1,1440},{38280620,1,1440}]},{4,[{34010001,1,1600}]}]'),(605,57000001,1,200,1,1,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{32080532,1,480}]},{2,[{32080533,1,640},{32080542,1,720}]},{3,[{32080543,1,1440}]}]'),(605,57000001,1,200,2,2,'[{1,[{32090001,1,300}]},{2,[{32080001,1,400},{32080002,1,500},{32080512,1,500},{32080513,1,650}]},{3,[{32080532,1,1350},{32080533,1,1600}]}]'),(605,57000001,1,200,3,3,'[{1,[{32090001,1,300}]},{2,[{32080001,1,400},{32080002,1,500},{32080512,1,500},{32080513,1,650}]},{3,[{32080532,1,1350},{32080533,1,1600}]}]'),(605,57000001,1,200,4,5,'[{1,[{32090001,1,300}]},{2,[{32080001,1,400},{32080002,1,500},{32080512,1,500},{32080513,1,650}]},{3,[{32080532,1,1350},{32080533,1,1600}]}]'),(605,57000001,1,200,6,8,'[{1,[{32090001,1,300}]},{2,[{32080001,1,400},{32080002,1,500},{32080512,1,500},{32080513,1,650}]},{3,[{32080532,1,1350},{32080533,1,1600}]}]'),(605,57000002,201,260,1,1,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{32080632,1,480}]},{2,[{32080633,1,640},{32080642,1,720}]},{3,[{32080643,1,1440}]}]'),(605,57000002,201,260,2,2,'[{1,[{32090001,1,300}]},{2,[{32080001,1,400},{32080002,1,500},{32080612,1,500},{32080613,1,650}]},{3,[{32080632,1,1350},{32080633,1,1600}]}]'),(605,57000002,201,260,3,3,'[{1,[{32090001,1,300}]},{2,[{32080001,1,400},{32080002,1,500},{32080612,1,500},{32080613,1,650}]},{3,[{32080632,1,1350},{32080633,1,1600}]}]'),(605,57000002,201,260,4,5,'[{1,[{32090001,1,300}]},{2,[{32080001,1,400},{32080002,1,500},{32080612,1,500},{32080613,1,650}]},{3,[{32080632,1,1350},{32080633,1,1600}]}]'),(605,57000002,201,260,6,8,'[{1,[{32090001,1,300}]},{2,[{32080001,1,400},{32080002,1,500},{32080612,1,500},{32080613,1,650}]},{3,[{32080632,1,1350},{32080633,1,1600}]}]'),(605,57000003,261,290,1,1,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{32080732,1,480}]},{2,[{32080733,1,640},{32080742,1,720}]},{3,[{32080743,1,1440}]}]'),(605,57000003,261,290,2,2,'[{1,[{32090001,1,300}]},{2,[{32080003,1,450},{32080004,1,550},{32080712,1,500},{32080713,1,650}]},{3,[{32080732,1,1350},{32080733,1,1600}]}]'),(605,57000003,261,290,3,3,'[{1,[{32090001,1,300}]},{2,[{32080003,1,450},{32080004,1,550},{32080712,1,500},{32080713,1,650}]},{3,[{32080732,1,1350},{32080733,1,1600}]}]'),(605,57000003,261,290,4,5,'[{1,[{32090001,1,300}]},{2,[{32080003,1,450},{32080004,1,550},{32080712,1,500},{32080713,1,650}]},{3,[{32080732,1,1350},{32080733,1,1600}]}]'),(605,57000003,261,290,6,8,'[{1,[{32090001,1,300}]},{2,[{32080003,1,450},{32080004,1,550},{32080712,1,500},{32080713,1,650}]},{3,[{32080732,1,1350},{32080733,1,1600}]}]'),(605,57000004,291,320,1,1,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{32080832,1,480}]},{2,[{32080833,1,640},{32080842,1,720}]},{3,[{32080843,1,1440}]}]'),(605,57000004,291,320,2,2,'[{1,[{32090001,1,300}]},{2,[{32080005,1,500},{32080006,1,600},{32080812,1,500},{32080813,1,650}]},{3,[{32080832,1,1350},{32080833,1,1600}]}]'),(605,57000004,291,320,3,3,'[{1,[{32090001,1,300}]},{2,[{32080005,1,500},{32080006,1,600},{32080812,1,500},{32080813,1,650}]},{3,[{32080832,1,1350},{32080833,1,1600}]}]'),(605,57000004,291,320,4,5,'[{1,[{32090001,1,300}]},{2,[{32080005,1,500},{32080006,1,600},{32080812,1,500},{32080813,1,650}]},{3,[{32080832,1,1350},{32080833,1,1600}]}]'),(605,57000004,291,320,6,8,'[{1,[{32090001,1,300}]},{2,[{32080005,1,500},{32080006,1,600},{32080812,1,500},{32080813,1,650}]},{3,[{32080832,1,1350},{32080833,1,1600}]}]'),(605,57000005,321,350,1,1,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{32080832,1,480}]},{2,[{32080833,1,640},{32080842,1,720}]},{3,[{32080843,1,1440}]}]'),(605,57000005,321,350,2,2,'[{1,[{32090001,1,300}]},{2,[{32080007,1,550},{32080008,1,650},{32080812,1,500},{32080813,1,650}]},{3,[{32080832,1,1350},{32080833,1,1600}]}]'),(605,57000005,321,350,3,3,'[{1,[{32090001,1,300}]},{2,[{32080007,1,550},{32080008,1,650},{32080812,1,500},{32080813,1,650}]},{3,[{32080832,1,1350},{32080833,1,1600}]}]'),(605,57000005,321,350,4,5,'[{1,[{32090001,1,300}]},{2,[{32080007,1,550},{32080008,1,650},{32080812,1,500},{32080813,1,650}]},{3,[{32080832,1,1350},{32080833,1,1600}]}]'),(605,57000005,321,350,6,8,'[{1,[{32090001,1,300}]},{2,[{32080007,1,550},{32080008,1,650},{32080812,1,500},{32080813,1,650}]},{3,[{32080832,1,1350},{32080833,1,1600}]}]'),(605,57000006,351,370,1,1,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{32080932,1,480}]},{2,[{32080933,1,640},{32080942,1,720}]},{3,[{32080943,1,1440}]}]'),(605,57000006,351,370,2,2,'[{1,[{32090002,1,300}]},{2,[{32080007,1,550},{32080008,1,650},{32080912,1,500},{32080913,1,650}]},{3,[{32080932,1,1350},{32080933,1,1600}]}]'),(605,57000006,351,370,3,3,'[{1,[{32090002,1,300}]},{2,[{32080007,1,550},{32080008,1,650},{32080912,1,500},{32080913,1,650}]},{3,[{32080932,1,1350},{32080933,1,1600}]}]'),(605,57000006,351,370,4,5,'[{1,[{32090002,1,300}]},{2,[{32080007,1,550},{32080008,1,650},{32080912,1,500},{32080913,1,650}]},{3,[{32080932,1,1350},{32080933,1,1600}]}]'),(605,57000006,351,370,6,8,'[{1,[{32090002,1,300}]},{2,[{32080007,1,550},{32080008,1,650},{32080912,1,500},{32080913,1,650}]},{3,[{32080932,1,1350},{32080933,1,1600}]}]'),(605,57000007,371,390,1,1,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{32081032,1,480}]},{2,[{32081033,1,640},{32081042,1,720}]},{3,[{32081043,1,1440},{38280620,1,1440}]},{4,[{34010001,1,1600}]}]'),(605,57000007,371,390,2,2,'[{1,[{32090002,1,300}]},{2,[{32080007,1,550},{32080008,1,650},{32081012,1,500},{32081013,1,650}]},{3,[{32081032,1,1350},{32081033,1,1600}]}]'),(605,57000007,371,390,3,3,'[{1,[{32090002,1,300}]},{2,[{32080007,1,550},{32080008,1,650},{32081012,1,500},{32081013,1,650}]},{3,[{32081032,1,1350},{32081033,1,1600}]}]'),(605,57000007,371,390,4,5,'[{1,[{32090002,1,300}]},{2,[{32080007,1,550},{32080008,1,650},{32081012,1,500},{32081013,1,650}]},{3,[{32081032,1,1350},{32081033,1,1600}]}]'),(605,57000007,371,390,6,8,'[{1,[{32090002,1,300}]},{2,[{32080007,1,550},{32080008,1,650},{32081012,1,500},{32081013,1,650}]},{3,[{32081032,1,1350},{32081033,1,1600}]}]'),(605,57000008,391,430,1,1,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{20040004,1,550},{32081132,1,480}]},{2,[{32081133,1,640},{32081142,1,720}]},{3,[{32081143,1,1440},{38280620,1,1440}]},{4,[{34010001,1,1600}]}]'),(605,57000008,391,430,2,2,'[{1,[{32090002,1,300}]},{2,[{32080007,1,550},{32080008,1,650},{32081112,1,500},{32081113,1,650}]},{3,[{32081132,1,1350},{32081133,1,1600}]}]'),(605,57000008,391,430,3,3,'[{1,[{32090002,1,300}]},{2,[{32080007,1,550},{32080008,1,650},{32081112,1,500},{32081113,1,650}]},{3,[{32081132,1,1350},{32081133,1,1600}]}]'),(605,57000008,391,430,4,5,'[{1,[{32090002,1,300}]},{2,[{32080007,1,550},{32080008,1,650},{32081112,1,500},{32081113,1,650}]},{3,[{32081132,1,1350},{32081133,1,1600}]}]'),(605,57000008,391,430,6,8,'[{1,[{32090002,1,300}]},{2,[{32080007,1,550},{32080008,1,650},{32081112,1,500},{32081113,1,650}]},{3,[{32081132,1,1350},{32081133,1,1600}]}]'),(605,57000009,431,500,1,1,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{20040004,1,550},{32081132,1,480}]},{2,[{32081133,1,640},{32081142,1,720}]},{3,[{32081143,1,1440},{38280620,1,1440}]},{4,[{34010001,1,1600}]}]'),(605,57000009,431,500,2,2,'[{1,[{32090002,1,300}]},{2,[{32080007,1,550},{32080008,1,650},{32081112,1,500},{32081113,1,650}]},{3,[{32081132,1,1350},{32081133,1,1600}]}]'),(605,57000009,431,500,3,3,'[{1,[{32090002,1,300}]},{2,[{32080007,1,550},{32080008,1,650},{32081112,1,500},{32081113,1,650}]},{3,[{32081132,1,1350},{32081133,1,1600}]}]'),(605,57000009,431,500,4,5,'[{1,[{32090002,1,300}]},{2,[{32080007,1,550},{32080008,1,650},{32081112,1,500},{32081113,1,650}]},{3,[{32081132,1,1350},{32081133,1,1600}]}]'),(605,57000009,431,500,6,8,'[{1,[{32090002,1,300}]},{2,[{32080007,1,550},{32080008,1,650},{32081112,1,500},{32081113,1,650}]},{3,[{32081132,1,1350},{32081133,1,1600}]}]'),(605,57000010,501,560,1,1,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{20040004,1,550},{32081232,1,480}]},{2,[{32081233,1,640},{32081242,1,720}]},{3,[{32081243,1,1440},{38280620,1,1440}]},{4,[{34010001,1,1600}]}]'),(605,57000010,501,560,2,2,'[{1,[{32090002,1,300}]},{2,[{32080007,1,550},{32080008,1,650},{32081212,1,500},{32081213,1,650}]},{3,[{32081232,1,1350},{32081233,1,1600}]}]'),(605,57000010,501,560,3,3,'[{1,[{32090002,1,300}]},{2,[{32080007,1,550},{32080008,1,650},{32081212,1,500},{32081213,1,650}]},{3,[{32081232,1,1350},{32081233,1,1600}]}]'),(605,57000010,501,560,4,5,'[{1,[{32090002,1,300}]},{2,[{32080007,1,550},{32080008,1,650},{32081212,1,500},{32081213,1,650}]},{3,[{32081232,1,1350},{32081233,1,1600}]}]'),(605,57000010,501,560,6,8,'[{1,[{32090002,1,300}]},{2,[{32080007,1,550},{32080008,1,650},{32081212,1,500},{32081213,1,650}]},{3,[{32081232,1,1350},{32081233,1,1600}]}]'),(605,57000011,561,610,1,1,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{20040004,1,550},{32081332,1,480}]},{2,[{32081333,1,640},{32081342,1,720}]},{3,[{32081343,1,1440},{38280620,1,1440}]},{4,[{34010001,1,1600}]}]'),(605,57000011,561,610,2,2,'[{1,[{32090003,1,300}]},{2,[{32080007,1,550},{32080008,1,650},{32081312,1,500},{32081313,1,650}]},{3,[{32081332,1,1350},{32081333,1,1600}]}]'),(605,57000011,561,610,3,3,'[{1,[{32090003,1,300}]},{2,[{32080007,1,550},{32080008,1,650},{32081312,1,500},{32081313,1,650}]},{3,[{32081332,1,1350},{32081333,1,1600}]}]'),(605,57000011,561,610,4,5,'[{1,[{32090003,1,300}]},{2,[{32080007,1,550},{32080008,1,650},{32081312,1,500},{32081313,1,650}]},{3,[{32081332,1,1350},{32081333,1,1600}]}]'),(605,57000011,561,610,6,8,'[{1,[{32090003,1,300}]},{2,[{32080007,1,550},{32080008,1,650},{32081312,1,500},{32081313,1,650}]},{3,[{32081332,1,1350},{32081333,1,1600}]}]'),(605,57000012,611,660,1,1,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{20040004,1,550},{32081432,1,480}]},{2,[{32081433,1,640},{32081442,1,720}]},{3,[{32081443,1,1440},{38280620,1,1440}]},{4,[{34010001,1,1600}]}]'),(605,57000012,611,660,2,2,'[{1,[{32090003,1,300}]},{2,[{32080007,1,550},{32080008,1,650},{32081412,1,500},{32081413,1,650}]},{3,[{32081432,1,1350},{32081433,1,1600}]}]'),(605,57000012,611,660,3,3,'[{1,[{32090003,1,300}]},{2,[{32080007,1,550},{32080008,1,650},{32081412,1,500},{32081413,1,650}]},{3,[{32081432,1,1350},{32081433,1,1600}]}]'),(605,57000012,611,660,4,5,'[{1,[{32090003,1,300}]},{2,[{32080007,1,550},{32080008,1,650},{32081412,1,500},{32081413,1,650}]},{3,[{32081432,1,1350},{32081433,1,1600}]}]'),(605,57000012,611,660,6,8,'[{1,[{32090003,1,300}]},{2,[{32080007,1,550},{32080008,1,650},{32081412,1,500},{32081413,1,650}]},{3,[{32081432,1,1350},{32081433,1,1600}]}]'),(605,57000013,661,750,1,1,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{20040004,1,550},{32081532,1,480}]},{2,[{32081533,1,640},{32081542,1,720}]},{3,[{32081543,1,1440},{38280620,1,1440}]},{4,[{34010001,1,1600}]}]'),(605,57000013,661,750,2,2,'[{1,[{32090003,1,300}]},{2,[{32080007,1,550},{32080008,1,650},{32081512,1,500},{32081513,1,650}]},{3,[{32081532,1,1350},{32081533,1,1600}]}]'),(605,57000013,661,750,3,3,'[{1,[{32090003,1,300}]},{2,[{32080007,1,550},{32080008,1,650},{32081512,1,500},{32081513,1,650}]},{3,[{32081532,1,1350},{32081533,1,1600}]}]'),(605,57000013,661,750,4,5,'[{1,[{32090003,1,300}]},{2,[{32080007,1,550},{32080008,1,650},{32081512,1,500},{32081513,1,650}]},{3,[{32081532,1,1350},{32081533,1,1600}]}]'),(605,57000013,661,750,6,8,'[{1,[{32090003,1,300}]},{2,[{32080007,1,550},{32080008,1,650},{32081512,1,500},{32081513,1,650}]},{3,[{32081532,1,1350},{32081533,1,1600}]}]'),(605,57000014,751,1000,1,1,'[{1,[{17020003,1,350},{17020004,1,550},{24020003,1,350},{24020004,1,550},{20040002,1,350},{20040003,1,450},{20040004,1,550},{32081632,1,480}]},{2,[{32081633,1,640},{32081642,1,720}]},{3,[{32081643,1,1440},{38280620,1,1440}]},{4,[{34010001,1,1600}]}]'),(605,57000014,751,1000,2,2,'[{1,[{32090003,1,300}]},{2,[{32080007,1,550},{32080008,1,650},{32081612,1,500},{32081613,1,650}]},{3,[{32081632,1,1350},{32081633,1,1600}]}]'),(605,57000014,751,1000,3,3,'[{1,[{32090003,1,300}]},{2,[{32080007,1,550},{32080008,1,650},{32081612,1,500},{32081613,1,650}]},{3,[{32081632,1,1350},{32081633,1,1600}]}]'),(605,57000014,751,1000,4,5,'[{1,[{32090003,1,300}]},{2,[{32080007,1,550},{32080008,1,650},{32081612,1,500},{32081613,1,650}]},{3,[{32081632,1,1350},{32081633,1,1600}]}]'),(605,57000014,751,1000,6,8,'[{1,[{32090003,1,300}]},{2,[{32080007,1,550},{32080008,1,650},{32081612,1,500},{32081613,1,650}]},{3,[{32081632,1,1350},{32081633,1,1600}]}]');
/*!40000 ALTER TABLE `base_auction_common_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_auction_goods`
--

DROP TABLE IF EXISTS `base_auction_goods`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_auction_goods` (
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品id',
  `server_lv_min` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小世界等级',
  `server_lv_max` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大世界等级',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商品大类',
  `guild_price_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '公会拍卖价格类型',
  `guild_base_price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '公会拍卖基础价',
  `guild_add_price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '公会拍卖单次加价',
  `guild_one_price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '公会拍卖一口价',
  `world_price_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '世界拍卖价格类型',
  `world_base_price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '世界拍卖基础价',
  `world_add_price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '世界拍卖单次加价',
  `world_one_price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '世界拍卖一口价',
  `price_add_ratio` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '竞拍加价比例',
  `server_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器等级',
  `gold_type` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '消耗钻石类型',
  `price_types` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '世界价格类型',
  `world_price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '世界拍卖价格',
  `personal_base_price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '个人拍卖价格',
  `personal_one_price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '个人拍卖一口价',
  PRIMARY KEY (`goods_id`,`server_lv_min`,`server_lv_max`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='拍卖配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_auction_goods`
--

LOCK TABLES `base_auction_goods` WRITE;
/*!40000 ALTER TABLE `base_auction_goods` DISABLE KEYS */;
INSERT INTO `base_auction_goods` VALUES (17020003,1,1000,2,1,100,10,200,1,100,10,200,0,0,1,'1',200,100,200),(17020004,1,1000,2,1,200,20,400,1,200,20,400,0,0,1,'1',400,200,400),(20040002,1,1000,2,1,200,20,400,1,200,20,400,0,0,1,'1',400,200,400),(20040003,1,1000,2,1,500,20,1000,1,500,20,1000,0,0,1,'1',1000,500,1000),(20040004,1,1000,2,1,800,20,1500,1,800,20,1500,0,0,1,'1',15000,800,1500),(24020003,1,1000,2,1,100,10,200,1,100,10,200,0,0,1,'1',200,100,200),(24020004,1,1000,2,1,200,20,400,1,200,20,400,0,0,1,'1',400,200,400),(32080001,1,1000,2,1,48,5,80,1,48,5,80,0,0,1,'1',80,48,80),(32080002,1,1000,2,1,60,10,100,1,60,10,100,0,0,1,'1',100,60,100),(32080003,1,1000,2,1,48,5,80,1,48,5,80,0,0,1,'1',80,48,80),(32080004,1,1000,2,1,60,10,100,1,60,10,100,0,0,1,'1',100,60,100),(32080005,1,1000,2,1,60,10,100,1,60,10,100,0,0,1,'1',100,60,100),(32080006,1,1000,2,1,72,10,120,1,72,10,120,0,0,1,'1',120,72,120),(32080007,1,1000,2,1,72,10,120,1,72,10,120,0,0,1,'1',120,72,120),(32080008,1,1000,2,1,84,10,140,1,84,10,140,0,0,1,'1',140,84,140),(32080112,1,1000,1,1,30,5,60,1,30,5,60,0,0,1,'1',60,30,60),(32080113,1,1000,1,1,50,5,100,1,50,5,100,0,0,1,'1',100,50,100),(32080114,1,1000,1,1,100,5,200,1,100,5,200,0,0,1,'1',200,100,200),(32080132,1,1000,1,1,75,5,150,1,75,5,150,0,0,1,'1',150,75,150),(32080133,1,1000,1,1,125,5,250,1,125,5,250,0,0,1,'1',250,125,250),(32080134,1,1000,1,1,300,10,600,1,300,10,600,0,0,1,'1',600,300,600),(32080142,1,1000,1,1,188,10,375,1,188,10,375,0,0,1,'1',375,188,375),(32080143,1,1000,1,1,313,10,625,1,313,10,625,0,0,1,'1',625,313,625),(32080144,1,1000,1,1,900,15,1800,1,900,15,1800,0,0,1,'1',1800,900,1800),(32080212,1,1000,1,1,30,5,60,1,30,5,60,0,0,1,'1',60,30,60),(32080213,1,1000,1,1,50,5,100,1,50,5,100,0,0,1,'1',100,50,100),(32080214,1,1000,1,1,100,5,200,1,100,5,200,0,0,1,'1',200,100,200),(32080232,1,1000,1,1,75,5,150,1,75,5,150,0,0,1,'1',150,75,150),(32080233,1,1000,1,1,125,5,250,1,125,5,250,0,0,1,'1',250,125,250),(32080234,1,1000,1,1,300,10,600,1,300,10,600,0,0,1,'1',600,300,600),(32080242,1,1000,1,1,188,10,375,1,188,10,375,0,0,1,'1',375,188,375),(32080243,1,1000,1,1,313,10,625,1,313,10,625,0,0,1,'1',625,313,625),(32080244,1,1000,1,1,900,15,1800,1,900,15,1800,0,0,1,'1',1800,900,1800),(32080312,1,1000,1,1,30,5,60,1,30,5,60,0,0,1,'1',60,30,60),(32080313,1,1000,1,1,50,5,100,1,50,5,100,0,0,1,'1',100,50,100),(32080314,1,1000,1,1,100,5,200,1,100,5,200,0,0,1,'1',200,100,200),(32080332,1,1000,1,1,75,10,150,1,75,10,150,0,0,1,'1',150,75,150),(32080333,1,1000,1,1,125,10,250,1,125,10,250,0,0,1,'1',250,125,250),(32080334,1,1000,1,1,300,15,600,1,300,15,600,0,0,1,'1',600,300,600),(32080342,1,1000,1,1,188,15,375,1,188,15,375,0,0,1,'1',375,188,375),(32080343,1,1000,1,1,313,15,625,1,313,15,625,0,0,1,'1',625,313,625),(32080344,1,1000,1,1,900,20,1800,1,900,20,1800,0,0,1,'1',1800,900,1800),(32080412,1,1000,1,1,30,5,60,1,30,5,60,0,0,1,'1',60,30,60),(32080413,1,1000,1,1,50,5,100,1,50,5,100,0,0,1,'1',100,50,100),(32080414,1,1000,1,1,100,10,200,1,100,10,200,0,0,1,'1',200,100,200),(32080432,1,1000,1,1,75,10,150,1,75,10,150,0,0,1,'1',150,75,150),(32080433,1,1000,1,1,125,10,250,1,125,10,250,0,0,1,'1',250,125,250),(32080434,1,1000,1,1,300,15,600,1,300,15,600,0,0,1,'1',600,300,600),(32080442,1,1000,1,1,188,20,375,1,188,20,375,0,0,1,'1',375,188,375),(32080443,1,1000,1,1,313,20,625,1,313,20,625,0,0,1,'1',625,313,625),(32080444,1,1000,1,1,900,20,1800,1,900,20,1800,0,0,1,'1',1800,900,1800),(32080512,1,1000,1,1,30,5,60,1,30,5,60,0,0,1,'1',60,30,60),(32080513,1,1000,1,1,50,5,100,1,50,5,100,0,0,1,'1',100,50,100),(32080514,1,1000,1,1,100,10,200,1,100,10,200,0,0,1,'1',200,100,200),(32080532,1,1000,1,1,75,10,150,1,75,10,150,0,0,1,'1',150,75,150),(32080533,1,1000,1,1,125,15,250,1,125,15,250,0,0,1,'1',250,125,250),(32080534,1,1000,1,1,300,20,600,1,300,20,600,0,0,1,'1',600,300,600),(32080542,1,1000,1,1,188,20,375,1,188,20,375,0,0,1,'1',375,188,375),(32080543,1,1000,1,1,313,20,625,1,313,20,625,0,0,1,'1',625,313,625),(32080544,1,1000,1,1,900,20,1800,1,900,20,1800,0,0,1,'1',1800,900,1800),(32080612,1,1000,1,1,40,5,80,1,40,5,80,0,0,1,'1',80,40,80),(32080613,1,1000,1,1,65,10,130,1,65,10,130,0,0,1,'1',130,65,130),(32080614,1,1000,1,1,125,10,250,1,125,10,250,0,0,1,'1',250,125,250),(32080632,1,1000,1,1,100,15,200,1,100,15,200,0,0,1,'1',200,100,200),(32080633,1,1000,1,1,163,15,325,1,163,15,325,0,0,1,'1',325,163,325),(32080634,1,1000,1,1,375,20,750,1,375,20,750,0,0,1,'1',750,375,750),(32080642,1,1000,1,1,250,20,500,1,250,20,500,0,0,1,'1',500,250,500),(32080643,1,1000,1,1,400,20,800,1,400,20,800,0,0,1,'1',800,400,800),(32080644,1,1000,1,1,1125,20,2250,1,1125,20,2250,0,0,1,'1',2250,1125,2250),(32080712,1,1000,1,1,50,10,100,1,50,10,100,0,0,1,'1',100,50,100),(32080713,1,1000,1,1,80,10,160,1,80,10,160,0,0,1,'1',160,80,160),(32080714,1,1000,1,1,150,15,300,1,150,15,300,0,0,1,'1',300,150,300),(32080732,1,1000,1,1,125,20,250,1,125,20,250,0,0,1,'1',250,125,250),(32080733,1,1000,1,1,200,20,400,1,200,20,400,0,0,1,'1',400,200,400),(32080734,1,1000,1,1,450,20,900,1,450,20,900,0,0,1,'1',900,450,900),(32080742,1,1000,1,1,313,20,625,1,313,20,625,0,0,1,'1',625,313,625),(32080743,1,1000,1,1,500,20,1000,1,500,20,1000,0,0,1,'1',1000,500,1000),(32080744,1,1000,1,1,1350,20,2700,1,1350,20,2700,0,0,1,'1',2700,1350,2700),(32080812,1,1000,1,1,60,10,120,1,60,10,120,0,0,1,'1',120,60,120),(32080813,1,1000,1,1,95,10,190,1,95,10,190,0,0,1,'1',190,95,190),(32080814,1,1000,1,1,175,15,350,1,175,15,350,0,0,1,'1',350,175,350),(32080832,1,1000,1,1,150,20,300,1,150,20,300,0,0,1,'1',300,150,300),(32080833,1,1000,1,1,238,20,475,1,238,20,475,0,0,1,'1',475,238,475),(32080834,1,1000,1,1,525,20,1050,1,525,20,1050,0,0,1,'1',1050,525,1050),(32080842,1,1000,1,1,375,20,750,1,375,20,750,0,0,1,'1',750,375,750),(32080843,1,1000,1,1,575,20,1150,1,575,20,1150,0,0,1,'1',1150,575,1150),(32080844,1,1000,1,1,1575,20,3150,1,1575,20,3150,0,0,1,'1',3150,1575,3150),(32080912,1,1000,1,1,70,10,140,1,70,10,140,0,0,1,'1',140,70,140),(32080913,1,1000,1,1,110,10,220,1,110,10,220,0,0,1,'1',220,110,220),(32080914,1,1000,1,1,200,10,400,1,200,10,400,0,0,1,'1',400,200,400),(32080932,1,1000,1,1,175,10,350,1,175,10,350,0,0,1,'1',350,175,350),(32080933,1,1000,1,1,275,20,550,1,275,20,550,0,0,1,'1',550,275,550),(32080934,1,1000,1,1,600,20,1200,1,600,20,1200,0,0,1,'1',1200,600,1200),(32080942,1,1000,1,1,438,20,875,1,438,20,875,0,0,1,'1',875,438,875),(32080943,1,1000,1,1,688,20,1375,1,688,20,1375,0,0,1,'1',1375,688,1375),(32080944,1,1000,1,1,1800,20,3600,1,1800,20,3600,0,0,1,'1',3600,1800,3600),(32081012,1,1000,1,1,80,10,160,1,80,10,160,0,0,1,'1',160,80,160),(32081013,1,1000,1,1,125,10,250,1,125,10,250,0,0,1,'1',250,125,250),(32081014,1,1000,1,1,225,10,450,1,225,10,450,0,0,1,'1',450,225,450),(32081032,1,1000,1,1,200,10,400,1,200,10,400,0,0,1,'1',400,200,400),(32081033,1,1000,1,1,313,20,625,1,313,20,625,0,0,1,'1',625,313,625),(32081034,1,1000,1,1,675,20,1350,1,675,20,1350,0,0,1,'1',1350,675,1350),(32081042,1,1000,1,1,500,20,1000,1,500,20,1000,0,0,1,'1',1000,500,1000),(32081043,1,1000,1,1,770,20,1540,1,770,20,1540,0,0,1,'1',1540,770,1540),(32081044,1,1000,1,1,2025,20,4050,1,2025,20,4050,0,0,1,'1',4050,2025,4050),(32081112,1,1000,1,1,90,10,180,1,90,10,180,0,0,1,'1',180,90,180),(32081113,1,1000,1,1,140,10,280,1,140,10,280,0,0,1,'1',280,140,280),(32081114,1,1000,1,1,250,10,500,1,250,10,500,0,0,1,'1',500,250,500),(32081132,1,1000,1,1,225,10,450,1,225,10,450,0,0,1,'1',450,225,450),(32081133,1,1000,1,1,350,20,700,1,350,20,700,0,0,1,'1',700,350,700),(32081134,1,1000,1,1,750,20,1500,1,750,20,1500,0,0,1,'1',1500,750,1500),(32081142,1,1000,1,1,563,20,1125,1,563,20,1125,0,0,1,'1',1125,563,1125),(32081143,1,1000,1,1,875,20,1750,1,875,20,1750,0,0,1,'1',1750,875,1750),(32081144,1,1000,1,1,2250,20,4500,1,2250,20,4500,0,0,1,'1',4500,2250,4500),(32081212,1,1000,1,1,100,10,200,1,100,10,200,0,0,1,'1',200,100,200),(32081213,1,1000,1,1,160,10,320,1,160,10,320,0,0,1,'1',320,160,320),(32081214,1,1000,1,1,275,10,550,1,275,10,550,0,0,1,'1',550,275,550),(32081232,1,1000,1,1,250,10,500,1,250,10,500,0,0,1,'1',500,250,500),(32081233,1,1000,1,1,400,20,800,1,400,20,800,0,0,1,'1',800,400,800),(32081234,1,1000,1,1,825,20,1650,1,825,20,1650,0,0,1,'1',1650,825,1650),(32081242,1,1000,1,1,625,20,1250,1,625,20,1250,0,0,1,'1',1250,625,1250),(32081243,1,1000,1,1,1000,20,2000,1,1000,20,2000,0,0,1,'1',2000,1000,2000),(32081244,1,1000,1,1,2475,20,4950,1,2475,20,4950,0,0,1,'1',4950,2475,4950),(32081312,1,1000,1,1,100,10,200,1,100,10,200,0,0,1,'1',200,100,200),(32081313,1,1000,1,1,160,10,320,1,160,10,320,0,0,1,'1',320,160,320),(32081314,1,1000,1,1,275,10,550,1,275,10,550,0,0,1,'1',550,275,550),(32081332,1,1000,1,1,250,10,500,1,250,10,500,0,0,1,'1',500,250,500),(32081333,1,1000,1,1,400,20,800,1,400,20,800,0,0,1,'1',800,400,800),(32081334,1,1000,1,1,825,20,1650,1,825,20,1650,0,0,1,'1',1650,825,1650),(32081342,1,1000,1,1,625,20,1250,1,625,20,1250,0,0,1,'1',1250,625,1250),(32081343,1,1000,1,1,1000,20,2000,1,1000,20,2000,0,0,1,'1',2000,1000,2000),(32081344,1,1000,1,1,2475,20,4950,1,2475,20,4950,0,0,1,'1',4950,2475,4950),(32081412,1,1000,1,1,100,10,200,1,100,10,200,0,0,1,'1',200,100,200),(32081413,1,1000,1,1,160,10,320,1,160,10,320,0,0,1,'1',320,160,320),(32081414,1,1000,1,1,275,10,550,1,275,10,550,0,0,1,'1',550,275,550),(32081432,1,1000,1,1,250,10,500,1,250,10,500,0,0,1,'1',500,250,500),(32081433,1,1000,1,1,400,20,800,1,400,20,800,0,0,1,'1',800,400,800),(32081434,1,1000,1,1,825,20,1650,1,825,20,1650,0,0,1,'1',1650,825,1650),(32081442,1,1000,1,1,625,20,1250,1,625,20,1250,0,0,1,'1',1250,625,1250),(32081443,1,1000,1,1,1000,20,2000,1,1000,20,2000,0,0,1,'1',2000,1000,2000),(32081444,1,1000,1,1,2475,20,4950,1,2475,20,4950,0,0,1,'1',4950,2475,4950),(32081512,1,1000,1,1,100,10,200,1,100,10,200,0,0,1,'1',200,100,200),(32081513,1,1000,1,1,160,10,320,1,160,10,320,0,0,1,'1',320,160,320),(32081514,1,1000,1,1,275,10,550,1,275,10,550,0,0,1,'1',550,275,550),(32081532,1,1000,1,1,250,10,500,1,250,10,500,0,0,1,'1',500,250,500),(32081533,1,1000,1,1,400,20,800,1,400,20,800,0,0,1,'1',800,400,800),(32081534,1,1000,1,1,825,20,1650,1,825,20,1650,0,0,1,'1',1650,825,1650),(32081542,1,1000,1,1,625,20,1250,1,625,20,1250,0,0,1,'1',1250,625,1250),(32081543,1,1000,1,1,1000,20,2000,1,1000,20,2000,0,0,1,'1',2000,1000,2000),(32081544,1,1000,1,1,2475,20,4950,1,2475,20,4950,0,0,1,'1',4950,2475,4950),(32081612,1,1000,1,1,100,10,200,1,100,10,200,0,0,1,'1',200,100,200),(32081613,1,1000,1,1,160,10,320,1,160,10,320,0,0,1,'1',320,160,320),(32081614,1,1000,1,1,275,10,550,1,275,10,550,0,0,1,'1',550,275,550),(32081632,1,1000,1,1,250,10,500,1,250,10,500,0,0,1,'1',500,250,500),(32081633,1,1000,1,1,400,20,800,1,400,20,800,0,0,1,'1',800,400,800),(32081634,1,1000,1,1,825,20,1650,1,825,20,1650,0,0,1,'1',1650,825,1650),(32081642,1,1000,1,1,625,20,1250,1,625,20,1250,0,0,1,'1',1250,625,1250),(32081643,1,1000,1,1,1000,20,2000,1,1000,20,2000,0,0,1,'1',2000,1000,2000),(32081644,1,1000,1,1,2475,20,4950,1,2475,20,4950,0,0,1,'1',4950,2475,4950),(32090001,1,1000,2,1,24,5,48,1,24,5,48,0,0,1,'1',48,24,48),(32090002,1,1000,2,1,45,5,75,1,45,5,75,0,0,1,'1',75,45,75),(32090003,1,1000,2,1,80,10,130,1,80,10,130,0,0,1,'1',130,80,130),(34010001,1,390,1,1,1000,20,2000,1,1000,20,2000,0,0,1,'1',1600,1000,2000),(34010001,391,430,1,1,900,20,1800,1,900,20,1800,0,0,1,'1',1600,900,1800),(34010001,431,500,1,1,800,20,1600,1,800,20,1600,0,0,1,'1',1500,800,1600),(34010001,501,560,1,1,750,20,1500,1,750,20,1500,0,0,1,'1',1500,750,1500),(34010001,561,610,1,1,700,20,1400,1,700,20,1400,0,0,1,'1',1400,700,1400),(34010001,611,660,1,1,650,20,1300,1,650,20,1300,0,0,1,'1',1400,650,1300),(34010001,661,750,1,1,600,20,1200,1,600,20,1200,0,0,1,'1',1300,600,1200),(34010001,751,1000,1,1,500,20,1000,1,500,20,1000,0,0,1,'1',1300,500,1000),(34010002,1,390,1,1,1500,20,3000,1,1500,20,3000,0,0,1,'1',2400,1500,3000),(34010002,391,430,1,1,1350,20,2700,1,1350,20,2700,0,0,1,'1',2400,1350,2700),(34010002,431,500,1,1,1200,20,2400,1,1200,20,2400,0,0,1,'1',2250,1200,2400),(34010002,501,560,1,1,1125,20,2250,1,1125,20,2250,0,0,1,'1',2250,1125,2250),(34010002,561,610,1,1,1050,20,2100,1,1050,20,2100,0,0,1,'1',2100,1050,2100),(34010002,611,660,1,1,975,20,1950,1,975,20,1950,0,0,1,'1',2100,975,1950),(34010002,661,750,1,1,900,20,1800,1,900,20,1800,0,0,1,'1',1950,900,1800),(34010002,751,1000,1,1,750,20,1500,1,750,20,1500,0,0,1,'1',1950,750,1500),(38280620,1,1000,2,1,200,20,400,1,200,20,400,0,0,1,'1',400,200,400);
/*!40000 ALTER TABLE `base_auction_goods` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_auction_keyvalues`
--

DROP TABLE IF EXISTS `base_auction_keyvalues`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_auction_keyvalues` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '常量Id',
  `value` varchar(512) NOT NULL COMMENT '常量值',
  `about` varchar(512) NOT NULL COMMENT '常量描述@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='拍卖常量配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_auction_keyvalues`
--

LOCK TABLES `base_auction_keyvalues` WRITE;
/*!40000 ALTER TABLE `base_auction_keyvalues` DISABLE KEYS */;
INSERT INTO `base_auction_keyvalues` VALUES (1,'60','流拍分红折扣(百分制，60表示只取拍出分红的60%)');
/*!40000 ALTER TABLE `base_auction_keyvalues` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_auction_liveness_tax`
--

DROP TABLE IF EXISTS `base_auction_liveness_tax`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_auction_liveness_tax` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '编号',
  `min_liveness` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小公会活跃度',
  `max_liveness` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大公会活跃度',
  `tax_value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '税率',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会拍卖活跃度税率配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_auction_liveness_tax`
--

LOCK TABLES `base_auction_liveness_tax` WRITE;
/*!40000 ALTER TABLE `base_auction_liveness_tax` DISABLE KEYS */;
INSERT INTO `base_auction_liveness_tax` VALUES (1,0,16,100),(2,17,33,99),(3,34,50,98),(4,51,67,97),(5,68,84,96),(6,85,101,95),(7,102,118,93),(8,119,135,92),(9,136,152,90),(10,153,169,89),(11,170,186,87),(12,187,197,85),(13,198,208,84),(14,209,219,82),(15,220,230,80),(16,231,241,78),(17,242,252,77),(18,253,263,75),(19,264,271,73),(20,272,279,72),(21,280,287,70),(22,288,295,69),(23,296,303,67),(24,304,311,65),(25,312,319,64),(26,320,327,62),(27,328,335,61),(28,336,343,59),(29,344,349,58),(30,350,355,56),(31,356,361,55),(32,362,367,54),(33,368,373,52),(34,374,379,51),(35,380,385,50),(36,386,391,48),(37,392,397,47),(38,398,403,45),(39,404,409,44),(40,410,415,43),(41,416,421,41),(42,422,427,40),(43,428,432,39),(44,433,437,38),(45,438,442,36),(46,443,447,35),(47,448,452,34),(48,453,457,33),(49,458,462,32),(50,463,467,31),(51,468,472,29),(52,473,477,28),(53,478,482,27),(54,483,487,26),(55,488,492,25),(56,493,497,24),(57,498,502,22),(58,503,507,21),(59,508,512,20),(60,513,597,20),(61,598,682,19),(62,683,767,18),(63,768,852,17),(64,853,937,16),(65,938,1022,15),(66,1023,1359,15),(67,1360,1696,14),(68,1697,2033,13),(69,2034,2370,12),(70,2371,2707,11),(71,2708,3044,10),(72,3045,3381,9),(73,3382,3802,8),(74,3803,4223,7),(75,4224,4644,6),(76,4645,5065,5),(77,5066,5486,4),(78,5487,84363,4),(79,84364,163240,3),(80,163241,263240,3),(81,263241,363240,3),(82,363241,463240,3),(83,463241,563240,3),(84,563241,663240,3);
/*!40000 ALTER TABLE `base_auction_liveness_tax` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_auction_mem_tax`
--

DROP TABLE IF EXISTS `base_auction_mem_tax`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_auction_mem_tax` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '编号',
  `min_mem` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小公会人数',
  `max_mem` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大公会人数',
  `tax_value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '税率',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会拍卖人数税率配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_auction_mem_tax`
--

LOCK TABLES `base_auction_mem_tax` WRITE;
/*!40000 ALTER TABLE `base_auction_mem_tax` DISABLE KEYS */;
INSERT INTO `base_auction_mem_tax` VALUES (1,1,1,80),(2,2,3,40),(3,4,5,20),(4,6,10,15),(5,11,15,10),(6,16,20,5),(7,21,999,3);
/*!40000 ALTER TABLE `base_auction_mem_tax` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_awakening_cell_cfg`
--

DROP TABLE IF EXISTS `base_awakening_cell_cfg`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_awakening_cell_cfg` (
  `cell_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '命格类型',
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '命格id',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '命格名字@lang@',
  `turn` int(11) unsigned NOT NULL COMMENT '转生数',
  `pre_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '前置id',
  `next_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '下一个id',
  `priority_consume` varchar(255) NOT NULL DEFAULT '[]' COMMENT '优先消耗',
  `exp_consume` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消耗经验',
  `attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '属性',
  PRIMARY KEY (`cell_type`,`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='天命觉醒配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_awakening_cell_cfg`
--

LOCK TABLES `base_awakening_cell_cfg` WRITE;
/*!40000 ALTER TABLE `base_awakening_cell_cfg` DISABLE KEYS */;
INSERT INTO `base_awakening_cell_cfg` VALUES (1,1,'白羊座',3,0,2,'[{0,38110004,10}]',0,'[{1,283},{3,210}]'),(1,2,'金牛座',3,1,3,'[{0,38110004,10}]',0,'[{1,283},{4,210}]'),(1,3,'双子座',3,2,4,'[{0,38110004,10}]',0,'[{2,5670},{3,210}]'),(1,4,'巨蟹座',3,3,5,'[{0,38110004,10}]',0,'[{2,5670},{4,210}]'),(1,5,'狮子座',3,4,6,'[{0,38110004,10}]',0,'[{1,273},{2,5460}]'),(1,6,'处女座',3,5,7,'[{0,38110004,10}]',0,'[{1,283},{3,210}]'),(1,7,'天秤座',3,6,8,'[{0,38110004,10}]',0,'[{1,283},{4,210}]'),(1,8,'天蝎座',3,7,9,'[{0,38110004,10}]',0,'[{2,5670},{3,210}]'),(1,9,'射手座',3,8,10,'[{0,38110004,10}]',0,'[{2,5670},{4,210}]'),(1,10,'摩羯座',3,9,11,'[{0,38110004,10}]',0,'[{1,273},{2,5460}]'),(1,11,'水瓶座',3,10,12,'[{0,38110004,10}]',0,'[{1,283},{3,210}]'),(1,12,'双鱼座',3,11,13,'[{0,38110004,10}]',0,'[{1,283},{4,210}]'),(1,13,'蛇夫座',3,12,14,'[{0,38110004,10}]',0,'[{2,5670},{3,210}]'),(1,14,'英仙座',3,13,15,'[{0,38110004,10}]',0,'[{2,5670},{4,210}]'),(1,15,'武仙座',3,14,0,'[{0,38110004,10}]',0,'[{1,273},{2,5460}]'),(2,1,'火魂1',4,0,2,'[{0,38110005,10}]',0,'[{1,57},{2,1135},{3,28},{4,28}]'),(2,2,'火魂2',4,1,3,'[{0,38110005,10}]',0,'[{1,57},{2,1135},{3,28},{4,28}]'),(2,3,'火魂3',4,2,4,'[{0,38110005,10}]',0,'[{1,57},{2,1135},{3,28},{4,28}]'),(2,4,'火魂4',4,3,5,'[{0,38110005,12}]',0,'[{1,62},{2,1249},{3,31},{4,31}]'),(2,5,'火魂5',4,4,6,'[{0,38110005,12}]',0,'[{1,62},{2,1249},{3,31},{4,31}]'),(2,6,'火魂6',4,5,7,'[{0,38110005,12}]',0,'[{1,62},{2,1249},{3,31},{4,31}]'),(2,7,'火魂7',4,6,8,'[{0,38110005,14}]',0,'[{1,68},{2,1362},{3,34},{4,34}]'),(2,8,'火魂8',4,7,9,'[{0,38110005,14}]',0,'[{1,68},{2,1362},{3,34},{4,34}]'),(2,9,'火魂9',4,8,0,'[{0,38110005,14}]',0,'[{1,68},{2,1362},{3,34},{4,34}]'),(3,1,'水魂1',4,0,2,'[{0,38110006,10}]',0,'[{1,85},{2,1703},{3,43},{4,43}]'),(3,2,'水魂2',4,1,3,'[{0,38110006,10}]',0,'[{1,85},{2,1703},{3,43},{4,43}]'),(3,3,'水魂3',4,2,4,'[{0,38110006,10}]',0,'[{1,85},{2,1703},{3,43},{4,43}]'),(3,4,'水魂4',4,3,5,'[{0,38110006,12}]',0,'[{1,91},{2,1816},{3,45},{4,45}]'),(3,5,'水魂5',4,4,6,'[{0,38110006,12}]',0,'[{1,91},{2,1816},{3,45},{4,45}]'),(3,6,'水魂6',4,5,7,'[{0,38110006,12}]',0,'[{1,91},{2,1816},{3,45},{4,45}]'),(3,7,'水魂7',4,6,8,'[{0,38110006,14}]',0,'[{1,102},{2,2043},{3,51},{4,51}]'),(3,8,'水魂8',4,7,9,'[{0,38110006,14}]',0,'[{1,102},{2,2043},{3,51},{4,51}]'),(3,9,'水魂9',4,8,0,'[{0,38110006,14}]',0,'[{1,102},{2,2043},{3,51},{4,51}]'),(4,1,'圣魂1',4,0,2,'[{0,38110007,10}]',0,'[{1,119},{2,2384},{3,60},{4,60}]'),(4,2,'圣魂2',4,1,3,'[{0,38110007,10}]',0,'[{1,119},{2,2384},{3,60},{4,60}]'),(4,3,'圣魂3',4,2,4,'[{0,38110007,10}]',0,'[{1,119},{2,2384},{3,60},{4,60}]'),(4,4,'圣魂4',4,3,5,'[{0,38110007,12}]',0,'[{1,125},{2,2497},{3,62},{4,62}]'),(4,5,'圣魂5',4,4,6,'[{0,38110007,12}]',0,'[{1,125},{2,2497},{3,62},{4,62}]'),(4,6,'圣魂6',4,5,7,'[{0,38110007,12}]',0,'[{1,125},{2,2497},{3,62},{4,62}]'),(4,7,'圣魂7',4,6,8,'[{0,38110007,14}]',0,'[{1,131},{2,2611},{3,65},{4,65}]'),(4,8,'圣魂8',4,7,9,'[{0,38110007,14}]',0,'[{1,131},{2,2611},{3,65},{4,65}]'),(4,9,'圣魂9',4,8,0,'[{0,38110007,14}]',0,'[{1,131},{2,2611},{3,65},{4,65}]');
/*!40000 ALTER TABLE `base_awakening_cell_cfg` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_baby_building_show`
--

DROP TABLE IF EXISTS `base_baby_building_show`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_baby_building_show` (
  `building_id` int(10) unsigned NOT NULL COMMENT '建筑类型',
  `pos` varchar(215) NOT NULL COMMENT '坐标',
  `remark` varchar(255) NOT NULL DEFAULT '[]' COMMENT '备注@lang@',
  PRIMARY KEY (`building_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='宝宝驻守显示表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_baby_building_show`
--

LOCK TABLES `base_baby_building_show` WRITE;
/*!40000 ALTER TABLE `base_baby_building_show` DISABLE KEYS */;
INSERT INTO `base_baby_building_show` VALUES (1,'[{11963,13685}]','[]'),(2,'[{11853,7021}]','[]'),(3,'[{5507,11518}]','[]'),(4,'[{7853,8090}]','[]'),(5,'[{9987,5934}]','[]'),(6,'[{13145,8224}]','[]'),(7,'[{16287,9783}]','[]'),(8,'[{10319,12772}]','[]'),(9,'[{9512,16792}]','[]'),(10,'[{6395,14935}]','[]');
/*!40000 ALTER TABLE `base_baby_building_show` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_baby_constant`
--

DROP TABLE IF EXISTS `base_baby_constant`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_baby_constant` (
  `id` int(11) unsigned NOT NULL COMMENT '编号',
  `constant` varchar(255) NOT NULL COMMENT '常量',
  `remark` varchar(255) NOT NULL COMMENT '备注@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='宝宝-常量配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_baby_constant`
--

LOCK TABLES `base_baby_constant` WRITE;
/*!40000 ALTER TABLE `base_baby_constant` DISABLE KEYS */;
INSERT INTO `base_baby_constant` VALUES (1,'315','宝宝开放等级'),(2,'[{1790101,2200000001},{1790102,2200000002},{1790103,2200000003},{1790104,2200000004}]','宝宝主动技能列表'),(3,'1790101','宝宝本体模型id'),(4,'315','宝宝时装页签开放等级');
/*!40000 ALTER TABLE `base_baby_constant` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_baby_cost`
--

DROP TABLE IF EXISTS `base_baby_cost`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_baby_cost` (
  `id` bigint(10) unsigned NOT NULL COMMENT '物品ID',
  `goods_id` bigint(10) unsigned NOT NULL DEFAULT '0' COMMENT '物品id',
  `exp` int(10) unsigned NOT NULL COMMENT '增加经验值',
  `grade` varchar(255) NOT NULL COMMENT '适用宝宝品阶',
  PRIMARY KEY (`id`),
  UNIQUE KEY `goods_id` (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='宝宝-升级道具配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_baby_cost`
--

LOCK TABLES `base_baby_cost` WRITE;
/*!40000 ALTER TABLE `base_baby_cost` DISABLE KEYS */;
INSERT INTO `base_baby_cost` VALUES (1,40030101,10,'[1,2,3]'),(2,40030201,20,'[1,2,3]'),(3,40030301,30,'[1,2,3]');
/*!40000 ALTER TABLE `base_baby_cost` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_baby_figure`
--

DROP TABLE IF EXISTS `base_baby_figure`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_baby_figure` (
  `type` tinyint(1) unsigned NOT NULL COMMENT '类型',
  `sub_type` smallint(5) unsigned NOT NULL COMMENT '子类型',
  `name` varchar(256) NOT NULL COMMENT '形象名称@lang@',
  `model_id` int(11) unsigned NOT NULL COMMENT '模型id',
  `skill_list` varchar(512) NOT NULL COMMENT '技能列表',
  `broadcast` tinyint(1) unsigned NOT NULL COMMENT '激活是否有传闻（1有 0无）',
  `goods_list` varchar(512) NOT NULL COMMENT '激活道具（[{道具id,时间},...]）',
  PRIMARY KEY (`type`,`sub_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='宝宝-幻化配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_baby_figure`
--

LOCK TABLES `base_baby_figure` WRITE;
/*!40000 ALTER TABLE `base_baby_figure` DISABLE KEYS */;
INSERT INTO `base_baby_figure` VALUES (2,1,'童年滑板',1790201,'[2200000221,2200000222,2200000223,2200000224]',1,'[{54030001,0},{54030051,600}]'),(2,2,'大眼萌云',1790202,'[2200000231,2200000232,2200000233,2200000234]',1,'[{54030002,0}]'),(2,3,'极速飞行',1790203,'[2200000241,2200000242,2200000243,2200000244]',1,'[{54030003,0}]'),(2,4,'海贼王船',1790204,'[2200000251,2200000252,2200000253,2200000254]',1,'[{54030004,0}]'),(3,1,'蛋蛋壳菲菲',1790103,'[]',1,'[{54050001,0}]'),(3,2,'蘑菇屋娜娜',1790102,'[]',1,'[{54050002,0}]'),(3,3,'小法师露露',1790104,'[]',1,'[{54050003,0},{54050053,600}]');
/*!40000 ALTER TABLE `base_baby_figure` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_baby_figure_up_stage`
--

DROP TABLE IF EXISTS `base_baby_figure_up_stage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_baby_figure_up_stage` (
  `type` tinyint(1) unsigned NOT NULL COMMENT '类型',
  `sub_type` smallint(5) unsigned NOT NULL COMMENT '子类型',
  `stage` smallint(5) unsigned NOT NULL COMMENT '阶数',
  `star` smallint(5) unsigned NOT NULL COMMENT '星数',
  `exp` int(11) unsigned NOT NULL COMMENT '升星所需经验',
  `attr` varchar(512) NOT NULL COMMENT '属性',
  `goods_list` varchar(512) NOT NULL COMMENT '升星道具经验（[{道具id,提供经验},...]）',
  PRIMARY KEY (`type`,`sub_type`,`stage`,`star`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='宝宝-幻化升阶配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_baby_figure_up_stage`
--

LOCK TABLES `base_baby_figure_up_stage` WRITE;
/*!40000 ALTER TABLE `base_baby_figure_up_stage` DISABLE KEYS */;
INSERT INTO `base_baby_figure_up_stage` VALUES (2,1,1,1,6627,'[{1,495},{2,9900},{5,198},{6,198},{203,100}]','[{54030001,6650},{54040001,30}]'),(2,1,2,1,6627,'[{1,905},{2,18101},{5,362},{6,362},{203,120}]','[{54030001,6650},{54040001,30}]'),(2,1,3,1,9940,'[{1,1408},{2,28165},{5,563},{6,563},{203,140}]','[{54030001,6650},{54040001,30}]'),(2,1,4,1,13253,'[{1,1980},{2,39596},{5,792},{6,792},{203,160}]','[{54030001,6650},{54040001,30}]'),(2,1,5,1,16567,'[{1,2601},{2,52021},{5,1041},{6,1041},{203,180}]','[{54030001,6650},{54040001,30}]'),(2,1,6,1,19880,'[{1,3272},{2,65440},{5,1309},{6,1309},{203,200}]','[{54030001,6650},{54040002,90}]'),(2,1,7,1,26507,'[{1,4067},{2,81344},{5,1627},{6,1627},{203,220}]','[{54030001,6650},{54040002,90}]'),(2,1,8,1,33133,'[{1,4999},{2,99982},{5,2000},{6,2000},{203,240}]','[{54030001,6650},{54040002,90}]'),(2,1,9,1,39760,'[{1,6043},{2,120856},{5,2417},{6,2417},{203,260}]','[{54030001,6650},{54040003,270}]'),(2,1,10,1,0,'[{1,7174},{2,143470},{5,2869},{6,2869},{203,280}]','[{54030001,6650},{54040003,270}]'),(2,2,1,1,13960,'[{1,1047},{2,20940},{5,419},{6,419},{61,80},{50,200}]','[{54030002,14000},{54040001,30}]'),(2,2,2,1,13960,'[{1,1911},{2,38216},{5,765},{6,765},{61,160},{50,240}]','[{54030002,14000},{54040001,30}]'),(2,2,3,1,20940,'[{1,2971},{2,59418},{5,1189},{6,1189},{61,240},{50,280}]','[{54030002,14000},{54040001,30}]'),(2,2,4,1,27920,'[{1,4175},{2,83499},{5,1671},{6,1671},{61,320},{50,320}]','[{54030002,14000},{54040001,30}]'),(2,2,5,1,34900,'[{1,5484},{2,109674},{5,2195},{6,2195},{61,400},{50,360}]','[{54030002,14000},{54040001,30}]'),(2,2,6,1,41880,'[{1,6897},{2,137943},{5,2760},{6,2760},{61,480},{50,400}]','[{54030002,14000},{54040002,90}]'),(2,2,7,1,55840,'[{1,8572},{2,171447},{5,3430},{6,3430},{61,560},{50,440}]','[{54030002,14000},{54040002,90}]'),(2,2,8,1,69800,'[{1,10535},{2,210710},{5,4215},{6,4215},{61,640},{50,480}]','[{54030002,14000},{54040002,90}]'),(2,2,9,1,83760,'[{1,12734},{2,254684},{5,5094},{6,5094},{61,720},{50,520}]','[{54030002,14000},{54040003,270}]'),(2,2,10,1,0,'[{1,15116},{2,302323},{5,6047},{6,6047},{61,800},{50,560}]','[{54030002,14000},{54040003,270}]'),(2,3,1,1,15627,'[{1,1172},{2,23440},{5,469},{6,469},{60,90},{51,200}]','[{54030003,15700},{54040001,30}]'),(2,3,2,1,15627,'[{1,2139},{2,42778},{5,856},{6,856},{60,180},{51,240}]','[{54030003,15700},{54040001,30}]'),(2,3,3,1,23440,'[{1,3326},{2,66511},{5,1331},{6,1331},{60,270},{51,280}]','[{54030003,15700},{54040001,30}]'),(2,3,4,1,31253,'[{1,4674},{2,93467},{5,1870},{6,1870},{60,360},{51,320}]','[{54030003,15700},{54040001,30}]'),(2,3,5,1,39067,'[{1,6139},{2,122767},{5,2456},{6,2456},{60,450},{51,360}]','[{54030003,15700},{54040001,30}]'),(2,3,6,1,46880,'[{1,7721},{2,154411},{5,3089},{6,3089},{60,540},{51,400}]','[{54030003,15700},{54040002,90}]'),(2,3,7,1,62507,'[{1,9596},{2,191915},{5,3839},{6,3839},{60,630},{51,440}]','[{54030003,15700},{54040002,90}]'),(2,3,8,1,78133,'[{1,11794},{2,235865},{5,4718},{6,4718},{60,720},{51,480}]','[{54030003,15700},{54040002,90}]'),(2,3,9,1,93760,'[{1,14255},{2,285089},{5,5702},{6,5702},{60,810},{51,520}]','[{54030003,15700},{54040003,270}]'),(2,3,10,1,0,'[{1,16921},{2,338415},{5,6769},{6,6769},{60,900},{51,560}]','[{54030003,15700},{54040003,270}]'),(2,4,1,1,17627,'[{1,1322},{2,26440},{5,529},{6,529},{64,100},{27,200}]','[{54030004,17650},{54040001,30}]'),(2,4,2,1,17627,'[{1,2413},{2,48253},{5,965},{6,965},{64,200},{27,240}]','[{54030004,17650},{54040001,30}]'),(2,4,3,1,26440,'[{1,3752},{2,75024},{5,1500},{6,1500},{64,300},{27,280}]','[{54030004,17650},{54040001,30}]'),(2,4,4,1,35253,'[{1,5272},{2,105430},{5,2108},{6,2108},{64,400},{27,320}]','[{54030004,17650},{54040001,30}]'),(2,4,5,1,44067,'[{1,6925},{2,138480},{5,2769},{6,2769},{64,500},{27,360}]','[{54030004,17650},{54040001,30}]'),(2,4,6,1,52880,'[{1,8710},{2,174174},{5,3483},{6,3483},{64,600},{27,400}]','[{54030004,17650},{54040002,90}]'),(2,4,7,1,70507,'[{1,10825},{2,216478},{5,4329},{6,4329},{64,700},{27,440}]','[{54030004,17650},{54040002,90}]'),(2,4,8,1,88133,'[{1,13304},{2,266053},{5,5321},{6,5321},{64,800},{27,480}]','[{54030004,17650},{54040002,90}]'),(2,4,9,1,105760,'[{1,16080},{2,321577},{5,6431},{6,6431},{64,900},{27,520}]','[{54030004,17650},{54040003,270}]'),(2,4,10,1,0,'[{1,19088},{2,381728},{5,7634},{6,7634},{64,1000},{27,560}]','[{54030004,17650},{54040003,270}]'),(3,1,1,0,0,'[{1,946},{2,18920},{3,757},{4,757},{23,100}]','[{0,54050001,1}]'),(3,1,1,1,0,'[{1,1703},{2,34070},{3,1363},{4,1363},{23,200}]','[{0,54050001,2}]'),(3,1,1,2,0,'[{1,2839},{2,56795},{3,2272},{4,2272},{23,300}]','[{0,54050001,4}]'),(3,1,1,3,0,'[{1,4449},{2,88989},{3,3560},{4,3560},{23,400}]','[{0,54050001,6}]'),(3,1,1,4,0,'[{1,6437},{2,128758},{3,5151},{4,5151},{23,550}]','[{0,54050001,8}]'),(3,1,1,5,0,'[{1,8709},{2,174208},{3,6969},{4,6969},{23,700}]','[{0,54050001,0}]'),(3,2,1,0,0,'[{1,997},{2,19937},{7,399},{8,399},{24,100}]','[{0,54050002,1}]'),(3,2,1,1,0,'[{1,1794},{2,35887},{7,718},{8,718},{24,200}]','[{0,54050002,2}]'),(3,2,1,2,0,'[{1,2990},{2,59812},{7,1196},{8,1196},{24,300}]','[{0,54050002,4}]'),(3,2,1,3,0,'[{1,4685},{2,93706},{7,1874},{8,1874},{24,400}]','[{0,54050002,6}]'),(3,2,1,4,0,'[{1,6778},{2,135574},{7,2711},{8,2711},{24,550}]','[{0,54050002,8}]'),(3,2,1,5,0,'[{1,9170},{2,183424},{7,3668},{8,3668},{24,700}]','[{0,54050002,0}]'),(3,3,1,0,0,'[{1,1097},{2,21937},{3,878},{4,878},{25,100}]','[{0,54050003,1}]'),(3,3,1,1,0,'[{1,1974},{2,39487},{3,1580},{4,1580},{25,200}]','[{0,54050003,2}]'),(3,3,1,2,0,'[{1,3290},{2,65812},{3,2633},{4,2633},{25,300}]','[{0,54050003,4}]'),(3,3,1,3,0,'[{1,5155},{2,103105},{3,4125},{4,4125},{25,400}]','[{0,54050003,6}]'),(3,3,1,4,0,'[{1,7458},{2,149173},{3,5968},{4,5968},{25,550}]','[{0,54050003,8}]'),(3,3,1,5,0,'[{1,10090},{2,201822},{3,8075},{4,8075},{25,700}]','[{0,54050003,0}]');
/*!40000 ALTER TABLE `base_baby_figure_up_stage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_baby_skill_unlock`
--

DROP TABLE IF EXISTS `base_baby_skill_unlock`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_baby_skill_unlock` (
  `skill_id` bigint(20) unsigned NOT NULL COMMENT '技能id',
  `type` tinyint(1) unsigned NOT NULL COMMENT '类型',
  `owner_id` int(11) unsigned NOT NULL COMMENT '归属id',
  `unlock_stage` smallint(5) unsigned NOT NULL COMMENT '解锁阶段',
  PRIMARY KEY (`skill_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='宝宝-技能解锁配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_baby_skill_unlock`
--

LOCK TABLES `base_baby_skill_unlock` WRITE;
/*!40000 ALTER TABLE `base_baby_skill_unlock` DISABLE KEYS */;
INSERT INTO `base_baby_skill_unlock` VALUES (2200000111,1,0,4),(2200000112,1,0,9),(2200000113,1,0,12),(2200000114,1,0,18),(2200000115,1,0,24),(2200000221,2,1,3),(2200000222,2,1,6),(2200000223,2,1,8),(2200000224,2,1,10),(2200000231,2,2,3),(2200000232,2,2,6),(2200000233,2,2,8),(2200000234,2,2,10),(2200000241,2,3,3),(2200000242,2,3,6),(2200000243,2,3,8),(2200000244,2,3,10),(2200000251,2,4,3),(2200000252,2,4,6),(2200000253,2,4,8),(2200000254,2,4,10);
/*!40000 ALTER TABLE `base_baby_skill_unlock` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_baby_talent`
--

DROP TABLE IF EXISTS `base_baby_talent`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_baby_talent` (
  `id` int(10) unsigned NOT NULL COMMENT '编号',
  `talent_type` int(10) unsigned NOT NULL COMMENT '天赋类型',
  `talent_name` varchar(215) NOT NULL COMMENT '天赋名称@lang@',
  `image_id` int(10) unsigned NOT NULL COMMENT '图标ID',
  `grade` int(10) unsigned NOT NULL COMMENT '天赋品质',
  `planet` int(10) unsigned NOT NULL COMMENT '归属星球',
  `planet_name` varchar(215) NOT NULL COMMENT '星球名字@lang@',
  `talent` varchar(512) NOT NULL COMMENT '天赋效果',
  `learn_time` int(10) unsigned NOT NULL COMMENT '学习耗时',
  `learn_cost` varchar(512) NOT NULL COMMENT '学习消耗',
  `reset_time` int(10) unsigned NOT NULL COMMENT '重置耗时',
  `reset_cost` varchar(512) NOT NULL COMMENT '重置消耗',
  `up_time` int(10) unsigned NOT NULL COMMENT '提升耗时',
  `up_cost` varchar(512) NOT NULL COMMENT '提升消耗',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='宝宝-天赋配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_baby_talent`
--

LOCK TABLES `base_baby_talent` WRITE;
/*!40000 ALTER TABLE `base_baby_talent` DISABLE KEYS */;
INSERT INTO `base_baby_talent` VALUES (1,1,'天赋1',101,1,1,'勤劳星','[{2,1,{5,60}}]',10,'[{0,40040101,1}]',10,'[{0,40040101,1}]',10,'[{0,40060101,1}]'),(2,2,'天赋2',102,1,1,'勤劳星','[{3,1,{5,60}}]',10,'[{0,40040101,1}]',10,'[{0,40040101,1}]',10,'[{0,40060101,1}]'),(3,3,'天赋3',103,1,1,'勤劳星','[{4,1,{5,60}}]',10,'[{0,40040101,1}]',10,'[{0,40040101,1}]',10,'[{0,40060101,1}]'),(4,4,'天赋4',201,1,2,'坚硬星','[{2,2,5}]',10,'[{0,40040101,1}]',10,'[{0,40040101,1}]',10,'[{0,40060101,1}]'),(5,5,'天赋5',202,1,2,'坚硬星','[{3,2,5}]',10,'[{0,40040101,1}]',10,'[{0,40040101,1}]',10,'[{0,40060101,1}]'),(6,6,'天赋6',203,1,2,'坚硬星','[{4,2,5}]',10,'[{0,40040101,1}]',10,'[{0,40040101,1}]',10,'[{0,40060101,1}]'),(7,7,'天赋7',301,1,3,'祈愿星','[{6,1,5}]',10,'[{0,40040101,1}]',10,'[{0,40040101,1}]',10,'[{0,40060101,1}]'),(8,8,'天赋8',302,1,3,'祈愿星','[{6,2,5}]',10,'[{0,40040101,1}]',10,'[{0,40040101,1}]',10,'[{0,40060101,1}]'),(9,9,'天赋9',303,1,3,'祈愿星','[{6,1,10}]',10,'[{0,40040101,1}]',10,'[{0,40040101,1}]',10,'[{0,40060101,1}]'),(10,10,'天赋10',401,1,4,'管理星','[{2,1,{5,60}}]',10,'[{0,40040101,1}]',10,'[{0,40040101,1}]',10,'[{0,40060101,1}]'),(11,11,'天赋11',402,1,4,'管理星','[{3,1,{5,60}}]',10,'[{0,40040101,1}]',10,'[{0,40040101,1}]',10,'[{0,40060101,1}]'),(12,12,'天赋12',403,1,4,'管理星','[{4,1,{5,60}}]',10,'[{0,40040101,1}]',10,'[{0,40040101,1}]',10,'[{0,40060101,1}]'),(13,13,'天赋13',501,1,5,'意志星','[{2,2,5}]',10,'[{0,40040101,1}]',10,'[{0,40040101,1}]',10,'[{0,40060101,1}]'),(14,14,'天赋14',502,1,5,'意志星','[{3,2,5}]',10,'[{0,40040101,1}]',10,'[{0,40040101,1}]',10,'[{0,40060101,1}]'),(15,15,'天赋15',503,1,5,'意志星','[{4,2,5}]',10,'[{0,40040101,1}]',10,'[{0,40040101,1}]',10,'[{0,40060101,1}]'),(16,16,'天赋16',601,1,6,'磐石星','[{6,1,5}]',10,'[{0,40040101,1}]',10,'[{0,40040101,1}]',10,'[{0,40060101,1}]'),(17,17,'天赋17',602,1,6,'磐石星','[{6,2,5}]',10,'[{0,40040101,1}]',10,'[{0,40040101,1}]',10,'[{0,40060101,1}]'),(18,18,'天赋18',603,1,6,'磐石星','[{6,1,10}]',10,'[{0,40040101,1}]',10,'[{0,40040101,1}]',10,'[{0,40060101,1}]'),(19,1,'天赋1',101,2,1,'勤劳星','[{2,1,{10,60}}]',20,'[]',20,'[{0,40040101,2}]',20,'[{0,40060102,1}]'),(20,2,'天赋2',102,2,1,'勤劳星','[{3,1,{10,60}}]',20,'[]',20,'[{0,40040101,2}]',20,'[{0,40060102,1}]'),(21,3,'天赋3',103,2,1,'勤劳星','[{4,1,{10,60}}]',20,'[]',20,'[{0,40040101,2}]',20,'[{0,40060102,1}]'),(22,4,'天赋4',201,2,2,'坚硬星','[{2,2,10}]',20,'[]',20,'[{0,40040101,2}]',20,'[{0,40060102,1}]'),(23,5,'天赋5',202,2,2,'坚硬星','[{3,2,10}]',20,'[]',20,'[{0,40040101,2}]',20,'[{0,40060102,1}]'),(24,6,'天赋6',203,2,2,'坚硬星','[{4,2,10}]',20,'[]',20,'[{0,40040101,2}]',20,'[{0,40060102,1}]'),(25,7,'天赋7',301,2,3,'祈愿星','[{6,1,10}]',20,'[]',20,'[{0,40040101,2}]',20,'[{0,40060102,1}]'),(26,8,'天赋8',302,2,3,'祈愿星','[{6,2,10}]',20,'[]',20,'[{0,40040101,2}]',20,'[{0,40060102,1}]'),(27,9,'天赋9',303,2,3,'祈愿星','[{6,1,20}]',20,'[]',20,'[{0,40040101,2}]',20,'[{0,40060102,1}]'),(28,10,'天赋10',401,2,4,'管理星','[{2,1,{10,60}}]',20,'[]',20,'[{0,40040101,2}]',20,'[{0,40060102,1}]'),(29,11,'天赋11',402,2,4,'管理星','[{3,1,{10,60}}]',20,'[]',20,'[{0,40040101,2}]',20,'[{0,40060102,1}]'),(30,12,'天赋12',403,2,4,'管理星','[{4,1,{10,60}}]',20,'[]',20,'[{0,40040101,2}]',20,'[{0,40060102,1}]'),(31,13,'天赋13',501,2,5,'意志星','[{2,2,10}]',20,'[]',20,'[{0,40040101,2}]',20,'[{0,40060102,1}]'),(32,14,'天赋14',502,2,5,'意志星','[{3,2,10}]',20,'[]',20,'[{0,40040101,2}]',20,'[{0,40060102,1}]'),(33,15,'天赋15',503,2,5,'意志星','[{4,2,10}]',20,'[]',20,'[{0,40040101,2}]',20,'[{0,40060102,1}]'),(34,16,'天赋16',601,2,6,'磐石星','[{6,1,10}]',20,'[]',20,'[{0,40040101,2}]',20,'[{0,40060102,1}]'),(35,17,'天赋17',602,2,6,'磐石星','[{6,2,10}]',20,'[]',20,'[{0,40040101,2}]',20,'[{0,40060102,1}]'),(36,18,'天赋18',603,2,6,'磐石星','[{6,1,20}]',20,'[]',20,'[{0,40040101,2}]',20,'[{0,40060102,1}]'),(37,1,'天赋1',101,3,1,'勤劳星','[{2,1,{20,60}}]',30,'[]',30,'[{0,40040101,3}]',30,'[{0,40060103,1}]'),(38,2,'天赋2',102,3,1,'勤劳星','[{3,1,{20,60}}]',30,'[]',30,'[{0,40040101,3}]',30,'[{0,40060103,1}]'),(39,3,'天赋3',103,3,1,'勤劳星','[{4,1,{20,60}}]',30,'[]',30,'[{0,40040101,3}]',30,'[{0,40060103,1}]'),(40,4,'天赋4',201,3,2,'坚硬星','[{2,2,20}]',30,'[]',30,'[{0,40040101,3}]',30,'[{0,40060103,1}]'),(41,5,'天赋5',202,3,2,'坚硬星','[{3,2,20}]',30,'[]',30,'[{0,40040101,3}]',30,'[{0,40060103,1}]'),(42,6,'天赋6',203,3,2,'坚硬星','[{4,2,20}]',30,'[]',30,'[{0,40040101,3}]',30,'[{0,40060103,1}]'),(43,7,'天赋7',301,3,3,'祈愿星','[{6,1,20}]',30,'[]',30,'[{0,40040101,3}]',30,'[{0,40060103,1}]'),(44,8,'天赋8',302,3,3,'祈愿星','[{6,2,20}]',30,'[]',30,'[{0,40040101,3}]',30,'[{0,40060103,1}]'),(45,9,'天赋9',303,3,3,'祈愿星','[{6,1,40}]',30,'[]',30,'[{0,40040101,3}]',30,'[{0,40060103,1}]'),(46,10,'天赋10',401,3,4,'管理星','[{2,1,{20,60}}]',30,'[]',30,'[{0,40040101,3}]',30,'[{0,40060103,1}]'),(47,11,'天赋11',402,3,4,'管理星','[{3,1,{20,60}}]',30,'[]',30,'[{0,40040101,3}]',30,'[{0,40060103,1}]'),(48,12,'天赋12',403,3,4,'管理星','[{4,1,{20,60}}]',30,'[]',30,'[{0,40040101,3}]',30,'[{0,40060103,1}]'),(49,13,'天赋13',501,3,5,'意志星','[{2,2,20}]',30,'[]',30,'[{0,40040101,3}]',30,'[{0,40060103,1}]'),(50,14,'天赋14',502,3,5,'意志星','[{3,2,20}]',30,'[]',30,'[{0,40040101,3}]',30,'[{0,40060103,1}]'),(51,15,'天赋15',503,3,5,'意志星','[{4,2,20}]',30,'[]',30,'[{0,40040101,3}]',30,'[{0,40060103,1}]'),(52,16,'天赋16',601,3,6,'磐石星','[{6,1,20}]',30,'[]',30,'[{0,40040101,3}]',30,'[{0,40060103,1}]'),(53,17,'天赋17',602,3,6,'磐石星','[{6,2,20}]',30,'[]',30,'[{0,40040101,3}]',30,'[{0,40060103,1}]'),(54,18,'天赋18',603,3,6,'磐石星','[{6,1,40}]',30,'[]',30,'[{0,40040101,3}]',30,'[{0,40060103,1}]'),(55,1,'天赋1',101,4,1,'勤劳星','[{2,1,{30,60}}]',40,'[]',40,'[{0,40040101,4}]',40,'[]'),(56,2,'天赋2',102,4,1,'勤劳星','[{3,1,{30,60}}]',40,'[]',40,'[{0,40040101,4}]',40,'[]'),(57,3,'天赋3',103,4,1,'勤劳星','[{4,1,{30,60}}]',40,'[]',40,'[{0,40040101,4}]',40,'[]'),(58,4,'天赋4',201,4,2,'坚硬星','[{2,2,30}]',40,'[]',40,'[{0,40040101,4}]',40,'[]'),(59,5,'天赋5',202,4,2,'坚硬星','[{3,2,30}]',40,'[]',40,'[{0,40040101,4}]',40,'[]'),(60,6,'天赋6',203,4,2,'坚硬星','[{4,2,30}]',40,'[]',40,'[{0,40040101,4}]',40,'[]'),(61,7,'天赋7',301,4,3,'祈愿星','[{6,1,30}]',40,'[]',40,'[{0,40040101,4}]',40,'[]'),(62,8,'天赋8',302,4,3,'祈愿星','[{6,2,30}]',40,'[]',40,'[{0,40040101,4}]',40,'[]'),(63,9,'天赋9',303,4,3,'祈愿星','[{6,1,80}]',40,'[]',40,'[{0,40040101,4}]',40,'[]'),(64,10,'天赋10',401,4,4,'管理星','[{2,1,{30,60}}]',40,'[]',40,'[{0,40040101,4}]',40,'[]'),(65,11,'天赋11',402,4,4,'管理星','[{3,1,{30,60}}]',40,'[]',40,'[{0,40040101,4}]',40,'[]'),(66,12,'天赋12',403,4,4,'管理星','[{4,1,{30,60}}]',40,'[]',40,'[{0,40040101,4}]',40,'[]'),(67,13,'天赋13',501,4,5,'意志星','[{2,2,30}]',40,'[]',40,'[{0,40040101,4}]',40,'[]'),(68,14,'天赋14',502,4,5,'意志星','[{3,2,30}]',40,'[]',40,'[{0,40040101,4}]',40,'[]'),(69,15,'天赋15',503,4,5,'意志星','[{4,2,30}]',40,'[]',40,'[{0,40040101,4}]',40,'[]'),(70,16,'天赋16',601,4,6,'磐石星','[{6,1,30}]',40,'[]',40,'[{0,40040101,4}]',40,'[]'),(71,17,'天赋17',602,4,6,'磐石星','[{6,2,30}]',40,'[]',40,'[{0,40040101,4}]',40,'[]'),(72,18,'天赋18',603,4,6,'磐石星','[{6,1,80}]',40,'[]',40,'[{0,40040101,4}]',40,'[]');
/*!40000 ALTER TABLE `base_baby_talent` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_baby_type`
--

DROP TABLE IF EXISTS `base_baby_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_baby_type` (
  `id` int(10) unsigned NOT NULL COMMENT '宝宝ID',
  `grade` int(10) unsigned NOT NULL COMMENT '品阶',
  `name` varchar(215) NOT NULL COMMENT '名称@lang@',
  `resource_id` int(10) unsigned NOT NULL COMMENT '模型ID',
  `mid` bigint(10) unsigned NOT NULL COMMENT '宝宝怪物ID',
  `image_source` varchar(255) NOT NULL COMMENT '头像资源',
  `cost` varchar(512) NOT NULL COMMENT '激活消耗',
  `open_num` varchar(512) NOT NULL COMMENT '天赋格子开启',
  `open_grade` varchar(512) NOT NULL COMMENT '天赋品质开启',
  `learn_grade` varchar(255) NOT NULL COMMENT '学习品质开启',
  `skill` varchar(512) NOT NULL COMMENT '技能',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='宝宝-种类配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_baby_type`
--

LOCK TABLES `base_baby_type` WRITE;
/*!40000 ALTER TABLE `base_baby_type` DISABLE KEYS */;
INSERT INTO `base_baby_type` VALUES (1,1,'布布小偶',1790001,1790001,'icon_tx_bb','[{0,40070401,1}]','[{1,1},{5,2}]','[{1,5,1},{6,20,2}]','[{1,20,1}]','[2200000001]'),(2,2,'大耳布偶',1790002,1790002,'icon_tx_dr','[{0,40070201,1}]','[{1,1},{5,2}]','[{1,5,1},{6,10,2},{11,20,3}]','[{1,20,1}]','[2200000001]'),(3,2,'卷耳布偶',202031,1790001,'icon_tx_ff','[{0,40070202,1}]','[{1,1},{5,2}]','[{1,5,1},{6,10,2},{11,20,3}]','[{1,20,1}]','[2200000001]'),(4,3,'飞天布偶',202032,1790002,'icon_tx_ft','[{0,40070301,1}]','[{1,1},{5,2},{10,3}]','[{1,5,1},{6,10,2},{11,15,3},{16,20,4}]','[{1,20,1}]','[2200000001]'),(5,3,'肥肥布偶',202033,1790001,'icon_tx_gt','[{0,40070302,1}]','[{1,1},{5,2},{10,3}]','[{1,5,1},{6,10,2},{11,15,3},{16,20,4}]','[{1,20,1}]','[2200000001]'),(6,3,'哥特布偶',202034,1790002,'icon_tx_jr','[{0,40070303,1}]','[{1,1},{5,2},{10,3}]','[{1,5,1},{6,10,2},{11,15,3},{16,20,4}]','[{1,20,1}]','[2200000001]');
/*!40000 ALTER TABLE `base_baby_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_baby_up_grade`
--

DROP TABLE IF EXISTS `base_baby_up_grade`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_baby_up_grade` (
  `goods_id` bigint(20) unsigned NOT NULL COMMENT '道具id',
  `attr` varchar(512) NOT NULL COMMENT '属性',
  `times_limit` varchar(512) NOT NULL COMMENT '使用上限（[{lv下限,lv上限,上限},...]）',
  PRIMARY KEY (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='宝宝-养育配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_baby_up_grade`
--

LOCK TABLES `base_baby_up_grade` WRITE;
/*!40000 ALTER TABLE `base_baby_up_grade` DISABLE KEYS */;
INSERT INTO `base_baby_up_grade` VALUES (54020001,'[{2,2000}]','[{1,1000,500}]'),(54020002,'[{1,100}]','[{1,1000,500}]'),(54020003,'[{5,40},{6,40},{68,100}]','[{1,1000,150}]');
/*!40000 ALTER TABLE `base_baby_up_grade` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_baby_up_stage`
--

DROP TABLE IF EXISTS `base_baby_up_stage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_baby_up_stage` (
  `stage` smallint(5) unsigned NOT NULL COMMENT '阶数',
  `star` smallint(5) unsigned NOT NULL COMMENT '星数',
  `exp` int(11) unsigned NOT NULL COMMENT '升星所需经验',
  `attr` varchar(512) NOT NULL COMMENT '属性',
  `goods_list` varchar(512) NOT NULL COMMENT '升星道具经验（[{道具id,提供经验},...]）',
  PRIMARY KEY (`stage`,`star`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='宝宝-升阶配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_baby_up_stage`
--

LOCK TABLES `base_baby_up_stage` WRITE;
/*!40000 ALTER TABLE `base_baby_up_stage` DISABLE KEYS */;
INSERT INTO `base_baby_up_stage` VALUES (1,1,90,'[{2,4000},{1,200},{5,80},{6,80}]','[{54010001,30}]'),(1,2,111,'[{2,5400},{1,270},{5,108},{6,108}]','[{54010001,30}]'),(1,3,132,'[{2,6850},{1,343},{5,137},{6,137}]','[{54010001,30}]'),(1,4,153,'[{2,8350},{1,418},{5,167},{6,167}]','[{54010001,30}]'),(1,5,174,'[{2,9900},{1,496},{5,198},{6,198}]','[{54010001,30}]'),(1,6,195,'[{2,11500},{1,576},{5,230},{6,230}]','[{54010001,30}]'),(1,7,216,'[{2,13150},{1,659},{5,263},{6,263}]','[{54010001,30}]'),(1,8,237,'[{2,14850},{1,744},{5,297},{6,297}]','[{54010001,30}]'),(1,9,258,'[{2,16600},{1,832},{5,332},{6,332}]','[{54010001,30}]'),(1,10,279,'[{2,18400},{1,922},{5,368},{6,368}]','[{54010001,30}]'),(2,1,300,'[{2,20600},{1,1032},{5,412},{6,412}]','[{54010001,30}]'),(2,2,321,'[{2,22452},{1,1125},{5,449},{6,449}]','[{54010001,30}]'),(2,3,342,'[{2,24356},{1,1220},{5,487},{6,487}]','[{54010001,30}]'),(2,4,363,'[{2,26312},{1,1318},{5,526},{6,526}]','[{54010001,30}]'),(2,5,384,'[{2,28320},{1,1418},{5,566},{6,566}]','[{54010001,30}]'),(2,6,405,'[{2,30380},{1,1521},{5,607},{6,607}]','[{54010001,30}]'),(2,7,426,'[{2,32492},{1,1627},{5,649},{6,649}]','[{54010001,30}]'),(2,8,447,'[{2,34656},{1,1735},{5,692},{6,692}]','[{54010001,30}]'),(2,9,468,'[{2,36872},{1,1846},{5,736},{6,736}]','[{54010001,30}]'),(2,10,489,'[{2,39140},{1,1959},{5,781},{6,781}]','[{54010001,30}]'),(3,1,510,'[{2,41928},{1,2098},{5,837},{6,837}]','[{54010001,30}]'),(3,2,531,'[{2,44250},{1,2214},{5,883},{6,883}]','[{54010001,30}]'),(3,3,552,'[{2,46626},{1,2333},{5,931},{6,931}]','[{54010001,30}]'),(3,4,573,'[{2,49056},{1,2455},{5,980},{6,980}]','[{54010001,30}]'),(3,5,594,'[{2,51540},{1,2579},{5,1030},{6,1030}]','[{54010001,30}]'),(3,6,615,'[{2,54078},{1,2706},{5,1081},{6,1081}]','[{54010001,30}]'),(3,7,636,'[{2,56670},{1,2836},{5,1133},{6,1133}]','[{54010001,30}]'),(3,8,657,'[{2,59316},{1,2968},{5,1186},{6,1186}]','[{54010001,30}]'),(3,9,678,'[{2,62016},{1,3103},{5,1240},{6,1240}]','[{54010001,30}]'),(3,10,699,'[{2,64770},{1,3241},{5,1295},{6,1295}]','[{54010001,30}]'),(4,1,720,'[{2,68164},{1,3411},{5,1363},{6,1363}]','[{54010001,30}]'),(4,2,741,'[{2,70974},{1,3552},{5,1419},{6,1419}]','[{54010001,30}]'),(4,3,762,'[{2,73840},{1,3695},{5,1476},{6,1476}]','[{54010001,30}]'),(4,4,783,'[{2,76762},{1,3841},{5,1534},{6,1534}]','[{54010001,30}]'),(4,5,804,'[{2,79740},{1,3990},{5,1594},{6,1594}]','[{54010001,30}]'),(4,6,825,'[{2,82774},{1,4142},{5,1655},{6,1655}]','[{54010001,30}]'),(4,7,846,'[{2,85864},{1,4297},{5,1717},{6,1717}]','[{54010001,30}]'),(4,8,867,'[{2,89010},{1,4454},{5,1780},{6,1780}]','[{54010001,30}]'),(4,9,888,'[{2,92212},{1,4614},{5,1844},{6,1844}]','[{54010001,30}]'),(4,10,909,'[{2,95470},{1,4777},{5,1909},{6,1909}]','[{54010001,30}]'),(5,1,930,'[{2,99488},{1,4978},{5,1989},{6,1989}]','[{54010001,30}]'),(5,2,951,'[{2,102804},{1,5144},{5,2055},{6,2055}]','[{54010001,30}]'),(5,3,972,'[{2,106178},{1,5313},{5,2122},{6,2122}]','[{54010001,30}]'),(5,4,993,'[{2,109610},{1,5485},{5,2191},{6,2191}]','[{54010001,30}]'),(5,5,1014,'[{2,113100},{1,5660},{5,2261},{6,2261}]','[{54010001,30}]'),(5,6,1035,'[{2,116648},{1,5837},{5,2332},{6,2332}]','[{54010001,30}]'),(5,7,1056,'[{2,120254},{1,6017},{5,2404},{6,2404}]','[{54010001,30}]'),(5,8,1077,'[{2,123918},{1,6200},{5,2477},{6,2477}]','[{54010001,30}]'),(5,9,1098,'[{2,127640},{1,6386},{5,2551},{6,2551}]','[{54010001,30}]'),(5,10,1119,'[{2,131420},{1,6575},{5,2627},{6,2627}]','[{54010001,30}]'),(6,1,1140,'[{2,136080},{1,6808},{5,2720},{6,2720}]','[{54010001,30}]'),(6,2,1161,'[{2,139920},{1,7000},{5,2797},{6,2797}]','[{54010001,30}]'),(6,3,1182,'[{2,143820},{1,7195},{5,2875},{6,2875}]','[{54010001,30}]'),(6,4,1203,'[{2,147780},{1,7393},{5,2954},{6,2954}]','[{54010001,30}]'),(6,5,1224,'[{2,151800},{1,7594},{5,3034},{6,3034}]','[{54010001,30}]'),(6,6,1245,'[{2,155880},{1,7798},{5,3116},{6,3116}]','[{54010001,30}]'),(6,7,1266,'[{2,160020},{1,8005},{5,3199},{6,3199}]','[{54010001,30}]'),(6,8,1287,'[{2,164220},{1,8215},{5,3283},{6,3283}]','[{54010001,30}]'),(6,9,1308,'[{2,168480},{1,8428},{5,3368},{6,3368}]','[{54010001,30}]'),(6,10,1329,'[{2,172800},{1,8644},{5,3454},{6,3454}]','[{54010001,30}]'),(7,1,1350,'[{2,178120},{1,8910},{5,3560},{6,3560}]','[{54010001,30}]'),(7,2,1371,'[{2,182500},{1,9129},{5,3648},{6,3648}]','[{54010001,30}]'),(7,3,1392,'[{2,186940},{1,9351},{5,3737},{6,3737}]','[{54010001,30}]'),(7,4,1413,'[{2,191440},{1,9576},{5,3827},{6,3827}]','[{54010001,30}]'),(7,5,1434,'[{2,196000},{1,9804},{5,3918},{6,3918}]','[{54010001,30}]'),(7,6,1455,'[{2,200620},{1,10035},{5,4010},{6,4010}]','[{54010001,30}]'),(7,7,1476,'[{2,205300},{1,10269},{5,4104},{6,4104}]','[{54010001,30}]'),(7,8,1497,'[{2,210040},{1,10506},{5,4199},{6,4199}]','[{54010001,30}]'),(7,9,1518,'[{2,214840},{1,10746},{5,4295},{6,4295}]','[{54010001,30}]'),(7,10,1539,'[{2,219700},{1,10989},{5,4392},{6,4392}]','[{54010001,30}]'),(8,1,1560,'[{2,225680},{1,11288},{5,4512},{6,4512}]','[{54010001,30}]'),(8,2,1581,'[{2,230600},{1,11534},{5,4610},{6,4610}]','[{54010001,30}]'),(8,3,1602,'[{2,235580},{1,11783},{5,4710},{6,4710}]','[{54010001,30}]'),(8,4,1623,'[{2,240620},{1,12035},{5,4811},{6,4811}]','[{54010001,30}]'),(8,5,1644,'[{2,245720},{1,12290},{5,4913},{6,4913}]','[{54010001,30}]'),(8,6,1665,'[{2,250880},{1,12548},{5,5016},{6,5016}]','[{54010001,30}]'),(8,7,1686,'[{2,256100},{1,12809},{5,5120},{6,5120}]','[{54010001,30}]'),(8,8,1707,'[{2,261380},{1,13073},{5,5226},{6,5226}]','[{54010001,30}]'),(8,9,1728,'[{2,266720},{1,13340},{5,5333},{6,5333}]','[{54010001,30}]'),(8,10,1749,'[{2,272120},{1,13610},{5,5441},{6,5441}]','[{54010001,30}]'),(9,1,1770,'[{2,278760},{1,13942},{5,5574},{6,5574}]','[{54010001,30}]'),(9,2,1791,'[{2,284220},{1,14215},{5,5683},{6,5683}]','[{54010001,30}]'),(9,3,1812,'[{2,289740},{1,14491},{5,5793},{6,5793}]','[{54010001,30}]'),(9,4,1833,'[{2,295320},{1,14770},{5,5905},{6,5905}]','[{54010001,30}]'),(9,5,1854,'[{2,300960},{1,15052},{5,6018},{6,6018}]','[{54010001,30}]'),(9,6,1875,'[{2,306660},{1,15337},{5,6132},{6,6132}]','[{54010001,30}]'),(9,7,1896,'[{2,312420},{1,15625},{5,6247},{6,6247}]','[{54010001,30}]'),(9,8,1917,'[{2,318240},{1,15916},{5,6363},{6,6363}]','[{54010001,30}]'),(9,9,1938,'[{2,324120},{1,16210},{5,6481},{6,6481}]','[{54010001,30}]'),(9,10,1959,'[{2,330060},{1,16507},{5,6600},{6,6600}]','[{54010001,30}]'),(10,1,1980,'[{2,337360},{1,16872},{5,6746},{6,6746}]','[{54010002,90}]'),(10,2,2001,'[{2,343360},{1,17172},{5,6866},{6,6866}]','[{54010002,90}]'),(10,3,2022,'[{2,349420},{1,17475},{5,6987},{6,6987}]','[{54010002,90}]'),(10,4,2043,'[{2,355540},{1,17781},{5,7109},{6,7109}]','[{54010002,90}]'),(10,5,2064,'[{2,361720},{1,18090},{5,7233},{6,7233}]','[{54010002,90}]'),(10,6,2085,'[{2,367960},{1,18402},{5,7358},{6,7358}]','[{54010002,90}]'),(10,7,2106,'[{2,374260},{1,18717},{5,7484},{6,7484}]','[{54010002,90}]'),(10,8,2127,'[{2,380620},{1,19035},{5,7611},{6,7611}]','[{54010002,90}]'),(10,9,2148,'[{2,387040},{1,19356},{5,7739},{6,7739}]','[{54010002,90}]'),(10,10,2169,'[{2,393520},{1,19680},{5,7869},{6,7869}]','[{54010002,90}]'),(11,1,2190,'[{2,401480},{1,20078},{5,8028},{6,8028}]','[{54010002,90}]'),(11,2,2211,'[{2,408020},{1,20405},{5,8159},{6,8159}]','[{54010002,90}]'),(11,3,2232,'[{2,414620},{1,20735},{5,8291},{6,8291}]','[{54010002,90}]'),(11,4,2253,'[{2,421280},{1,21068},{5,8424},{6,8424}]','[{54010002,90}]'),(11,5,2274,'[{2,428000},{1,21404},{5,8558},{6,8558}]','[{54010002,90}]'),(11,6,2295,'[{2,434780},{1,21743},{5,8694},{6,8694}]','[{54010002,90}]'),(11,7,2316,'[{2,441620},{1,22085},{5,8831},{6,8831}]','[{54010002,90}]'),(11,8,2337,'[{2,448520},{1,22430},{5,8969},{6,8969}]','[{54010002,90}]'),(11,9,2358,'[{2,455480},{1,22778},{5,9108},{6,9108}]','[{54010002,90}]'),(11,10,2379,'[{2,462500},{1,23129},{5,9248},{6,9248}]','[{54010002,90}]'),(12,1,2400,'[{2,471120},{1,23560},{5,9420},{6,9420}]','[{54010002,90}]'),(12,2,2421,'[{2,478200},{1,23914},{5,9562},{6,9562}]','[{54010002,90}]'),(12,3,2442,'[{2,485340},{1,24271},{5,9705},{6,9705}]','[{54010002,90}]'),(12,4,2463,'[{2,492540},{1,24631},{5,9849},{6,9849}]','[{54010002,90}]'),(12,5,2484,'[{2,499800},{1,24994},{5,9994},{6,9994}]','[{54010002,90}]'),(12,6,2505,'[{2,507120},{1,25360},{5,10140},{6,10140}]','[{54010002,90}]'),(12,7,2526,'[{2,514500},{1,25729},{5,10288},{6,10288}]','[{54010002,90}]'),(12,8,2547,'[{2,521940},{1,26101},{5,10437},{6,10437}]','[{54010002,90}]'),(12,9,2568,'[{2,529440},{1,26476},{5,10587},{6,10587}]','[{54010002,90}]'),(12,10,2589,'[{2,537000},{1,26854},{5,10738},{6,10738}]','[{54010002,90}]'),(13,1,2610,'[{2,546280},{1,27318},{5,10924},{6,10924}]','[{54010002,90}]'),(13,2,2631,'[{2,553900},{1,27699},{5,11076},{6,11076}]','[{54010002,90}]'),(13,3,2652,'[{2,561580},{1,28083},{5,11230},{6,11230}]','[{54010002,90}]'),(13,4,2673,'[{2,569320},{1,28470},{5,11385},{6,11385}]','[{54010002,90}]'),(13,5,2694,'[{2,577120},{1,28860},{5,11541},{6,11541}]','[{54010002,90}]'),(13,6,2715,'[{2,584980},{1,29253},{5,11698},{6,11698}]','[{54010002,90}]'),(13,7,2736,'[{2,592900},{1,29649},{5,11856},{6,11856}]','[{54010002,90}]'),(13,8,2757,'[{2,600880},{1,30048},{5,12016},{6,12016}]','[{54010002,90}]'),(13,9,2778,'[{2,608920},{1,30450},{5,12177},{6,12177}]','[{54010002,90}]'),(13,10,2799,'[{2,617020},{1,30855},{5,12339},{6,12339}]','[{54010002,90}]'),(14,1,2820,'[{2,626960},{1,31352},{5,12538},{6,12538}]','[{54010002,90}]'),(14,2,2841,'[{2,635120},{1,31760},{5,12701},{6,12701}]','[{54010002,90}]'),(14,3,2862,'[{2,643340},{1,32171},{5,12865},{6,12865}]','[{54010002,90}]'),(14,4,2883,'[{2,651620},{1,32585},{5,13031},{6,13031}]','[{54010002,90}]'),(14,5,2904,'[{2,659960},{1,33002},{5,13198},{6,13198}]','[{54010002,90}]'),(14,6,2925,'[{2,668360},{1,33422},{5,13366},{6,13366}]','[{54010002,90}]'),(14,7,2946,'[{2,676820},{1,33845},{5,13535},{6,13535}]','[{54010002,90}]'),(14,8,2967,'[{2,685340},{1,34271},{5,13705},{6,13705}]','[{54010002,90}]'),(14,9,2988,'[{2,693920},{1,34700},{5,13877},{6,13877}]','[{54010002,90}]'),(14,10,3009,'[{2,702560},{1,35132},{5,14050},{6,14050}]','[{54010002,90}]'),(15,1,3030,'[{2,713160},{1,35662},{5,14262},{6,14262}]','[{54010002,90}]'),(15,2,3051,'[{2,721860},{1,36097},{5,14436},{6,14436}]','[{54010002,90}]'),(15,3,3072,'[{2,730620},{1,36535},{5,14611},{6,14611}]','[{54010002,90}]'),(15,4,3093,'[{2,739440},{1,36976},{5,14787},{6,14787}]','[{54010002,90}]'),(15,5,3114,'[{2,748320},{1,37420},{5,14965},{6,14965}]','[{54010002,90}]'),(15,6,3135,'[{2,757260},{1,37867},{5,15144},{6,15144}]','[{54010002,90}]'),(15,7,3156,'[{2,766260},{1,38317},{5,15324},{6,15324}]','[{54010002,90}]'),(15,8,3177,'[{2,775320},{1,38770},{5,15505},{6,15505}]','[{54010002,90}]'),(15,9,3198,'[{2,784440},{1,39226},{5,15687},{6,15687}]','[{54010002,90}]'),(15,10,3219,'[{2,793620},{1,39685},{5,15871},{6,15871}]','[{54010002,90}]'),(16,1,3240,'[{2,804880},{1,40248},{5,16096},{6,16096}]','[{54010002,90}]'),(16,2,3261,'[{2,814120},{1,40710},{5,16281},{6,16281}]','[{54010002,90}]'),(16,3,3282,'[{2,823420},{1,41175},{5,16467},{6,16467}]','[{54010002,90}]'),(16,4,3303,'[{2,832780},{1,41643},{5,16654},{6,16654}]','[{54010002,90}]'),(16,5,3324,'[{2,842200},{1,42114},{5,16842},{6,16842}]','[{54010002,90}]'),(16,6,3345,'[{2,851680},{1,42588},{5,17032},{6,17032}]','[{54010002,90}]'),(16,7,3366,'[{2,861220},{1,43065},{5,17223},{6,17223}]','[{54010002,90}]'),(16,8,3387,'[{2,870820},{1,43545},{5,17415},{6,17415}]','[{54010002,90}]'),(16,9,3408,'[{2,880480},{1,44028},{5,17608},{6,17608}]','[{54010002,90}]'),(16,10,3429,'[{2,890200},{1,44514},{5,17802},{6,17802}]','[{54010002,90}]'),(17,1,3450,'[{2,902120},{1,45110},{5,18040},{6,18040}]','[{54010002,90}]'),(17,2,3471,'[{2,911900},{1,45599},{5,18236},{6,18236}]','[{54010002,90}]'),(17,3,3492,'[{2,921740},{1,46091},{5,18433},{6,18433}]','[{54010002,90}]'),(17,4,3513,'[{2,931640},{1,46586},{5,18631},{6,18631}]','[{54010002,90}]'),(17,5,3534,'[{2,941600},{1,47084},{5,18830},{6,18830}]','[{54010002,90}]'),(17,6,3555,'[{2,951620},{1,47585},{5,19030},{6,19030}]','[{54010002,90}]'),(17,7,3576,'[{2,961700},{1,48089},{5,19232},{6,19232}]','[{54010002,90}]'),(17,8,3597,'[{2,971840},{1,48596},{5,19435},{6,19435}]','[{54010002,90}]'),(17,9,3618,'[{2,982040},{1,49106},{5,19639},{6,19639}]','[{54010002,90}]'),(17,10,3639,'[{2,992300},{1,49619},{5,19844},{6,19844}]','[{54010002,90}]'),(18,1,3660,'[{2,1004880},{1,50248},{5,20096},{6,20096}]','[{54010002,90}]'),(18,2,3681,'[{2,1015200},{1,50764},{5,20302},{6,20302}]','[{54010002,90}]'),(18,3,3702,'[{2,1025580},{1,51283},{5,20510},{6,20510}]','[{54010002,90}]'),(18,4,3723,'[{2,1036020},{1,51805},{5,20719},{6,20719}]','[{54010002,90}]'),(18,5,3744,'[{2,1046520},{1,52330},{5,20929},{6,20929}]','[{54010002,90}]'),(18,6,3765,'[{2,1057080},{1,52858},{5,21140},{6,21140}]','[{54010002,90}]'),(18,7,3786,'[{2,1067700},{1,53389},{5,21352},{6,21352}]','[{54010002,90}]'),(18,8,3807,'[{2,1078380},{1,53923},{5,21566},{6,21566}]','[{54010002,90}]'),(18,9,3828,'[{2,1089120},{1,54460},{5,21781},{6,21781}]','[{54010002,90}]'),(18,10,3849,'[{2,1099920},{1,55000},{5,21997},{6,21997}]','[{54010002,90}]'),(19,1,3870,'[{2,1113160},{1,55662},{5,22262},{6,22262}]','[{54010003,270}]'),(19,2,3891,'[{2,1124020},{1,56205},{5,22479},{6,22479}]','[{54010003,270}]'),(19,3,3912,'[{2,1134940},{1,56751},{5,22697},{6,22697}]','[{54010003,270}]'),(19,4,3933,'[{2,1145920},{1,57300},{5,22917},{6,22917}]','[{54010003,270}]'),(19,5,3954,'[{2,1156960},{1,57852},{5,23138},{6,23138}]','[{54010003,270}]'),(19,6,3975,'[{2,1168060},{1,58407},{5,23360},{6,23360}]','[{54010003,270}]'),(19,7,3996,'[{2,1179220},{1,58965},{5,23583},{6,23583}]','[{54010003,270}]'),(19,8,4017,'[{2,1190440},{1,59526},{5,23807},{6,23807}]','[{54010003,270}]'),(19,9,4038,'[{2,1201720},{1,60090},{5,24033},{6,24033}]','[{54010003,270}]'),(19,10,4059,'[{2,1213060},{1,60657},{5,24260},{6,24260}]','[{54010003,270}]'),(20,1,4080,'[{2,1226960},{1,61352},{5,24538},{6,24538}]','[{54010003,270}]'),(20,2,4101,'[{2,1238360},{1,61922},{5,24766},{6,24766}]','[{54010003,270}]'),(20,3,4122,'[{2,1249820},{1,62495},{5,24995},{6,24995}]','[{54010003,270}]'),(20,4,4143,'[{2,1261340},{1,63071},{5,25225},{6,25225}]','[{54010003,270}]'),(20,5,4164,'[{2,1272920},{1,63650},{5,25457},{6,25457}]','[{54010003,270}]'),(20,6,4185,'[{2,1284560},{1,64232},{5,25690},{6,25690}]','[{54010003,270}]'),(20,7,4206,'[{2,1296260},{1,64817},{5,25924},{6,25924}]','[{54010003,270}]'),(20,8,4227,'[{2,1308020},{1,65405},{5,26159},{6,26159}]','[{54010003,270}]'),(20,9,4248,'[{2,1319840},{1,65996},{5,26395},{6,26395}]','[{54010003,270}]'),(20,10,4269,'[{2,1331720},{1,66590},{5,26633},{6,26633}]','[{54010003,270}]'),(21,1,4290,'[{2,1346280},{1,67318},{5,26924},{6,26924}]','[{54010003,270}]'),(21,2,4311,'[{2,1358220},{1,67915},{5,27163},{6,27163}]','[{54010003,270}]'),(21,3,4332,'[{2,1370220},{1,68515},{5,27403},{6,27403}]','[{54010003,270}]'),(21,4,4353,'[{2,1382280},{1,69118},{5,27644},{6,27644}]','[{54010003,270}]'),(21,5,4374,'[{2,1394400},{1,69724},{5,27886},{6,27886}]','[{54010003,270}]'),(21,6,4395,'[{2,1406580},{1,70333},{5,28130},{6,28130}]','[{54010003,270}]'),(21,7,4416,'[{2,1418820},{1,70945},{5,28375},{6,28375}]','[{54010003,270}]'),(21,8,4437,'[{2,1431120},{1,71560},{5,28621},{6,28621}]','[{54010003,270}]'),(21,9,4458,'[{2,1443480},{1,72178},{5,28868},{6,28868}]','[{54010003,270}]'),(21,10,4479,'[{2,1455900},{1,72799},{5,29116},{6,29116}]','[{54010003,270}]'),(22,1,4500,'[{2,1471120},{1,73560},{5,29420},{6,29420}]','[{54010003,270}]'),(22,2,4521,'[{2,1483600},{1,74184},{5,29670},{6,29670}]','[{54010003,270}]'),(22,3,4542,'[{2,1496140},{1,74811},{5,29921},{6,29921}]','[{54010003,270}]'),(22,4,4563,'[{2,1508740},{1,75441},{5,30173},{6,30173}]','[{54010003,270}]'),(22,5,4584,'[{2,1521400},{1,76074},{5,30426},{6,30426}]','[{54010003,270}]'),(22,6,4605,'[{2,1534120},{1,76710},{5,30680},{6,30680}]','[{54010003,270}]'),(22,7,4626,'[{2,1546900},{1,77349},{5,30936},{6,30936}]','[{54010003,270}]'),(22,8,4647,'[{2,1559740},{1,77991},{5,31193},{6,31193}]','[{54010003,270}]'),(22,9,4668,'[{2,1572640},{1,78636},{5,31451},{6,31451}]','[{54010003,270}]'),(22,10,4689,'[{2,1585600},{1,79284},{5,31710},{6,31710}]','[{54010003,270}]'),(23,1,4710,'[{2,1601480},{1,80078},{5,32028},{6,32028}]','[{54010003,270}]'),(23,2,4731,'[{2,1614500},{1,80729},{5,32288},{6,32288}]','[{54010003,270}]'),(23,3,4752,'[{2,1627580},{1,81383},{5,32550},{6,32550}]','[{54010003,270}]'),(23,4,4773,'[{2,1640720},{1,82040},{5,32813},{6,32813}]','[{54010003,270}]'),(23,5,4794,'[{2,1653920},{1,82700},{5,33077},{6,33077}]','[{54010003,270}]'),(23,6,4815,'[{2,1667180},{1,83363},{5,33342},{6,33342}]','[{54010003,270}]'),(23,7,4836,'[{2,1680500},{1,84029},{5,33608},{6,33608}]','[{54010003,270}]'),(23,8,4857,'[{2,1693880},{1,84698},{5,33876},{6,33876}]','[{54010003,270}]'),(23,9,4878,'[{2,1707320},{1,85370},{5,34145},{6,34145}]','[{54010003,270}]'),(23,10,4899,'[{2,1720820},{1,86045},{5,34415},{6,34415}]','[{54010003,270}]'),(24,1,4920,'[{2,1737360},{1,86872},{5,34746},{6,34746}]','[{54010003,270}]'),(24,2,4941,'[{2,1750920},{1,87550},{5,35017},{6,35017}]','[{54010003,270}]'),(24,3,4962,'[{2,1764540},{1,88231},{5,35289},{6,35289}]','[{54010003,270}]'),(24,4,4983,'[{2,1778220},{1,88915},{5,35563},{6,35563}]','[{54010003,270}]'),(24,5,5004,'[{2,1791960},{1,89602},{5,35838},{6,35838}]','[{54010003,270}]'),(24,6,5025,'[{2,1805760},{1,90292},{5,36114},{6,36114}]','[{54010003,270}]'),(24,7,5046,'[{2,1819620},{1,90985},{5,36391},{6,36391}]','[{54010003,270}]'),(24,8,5067,'[{2,1833540},{1,91681},{5,36669},{6,36669}]','[{54010003,270}]'),(24,9,5088,'[{2,1847520},{1,92380},{5,36949},{6,36949}]','[{54010003,270}]'),(24,10,5109,'[{2,1861560},{1,93082},{5,37230},{6,37230}]','[{54010003,270}]'),(25,1,5130,'[{2,1878760},{1,93942},{5,37574},{6,37574}]','[{54010003,270}]'),(25,2,5151,'[{2,1892860},{1,94647},{5,37856},{6,37856}]','[{54010003,270}]'),(25,3,5172,'[{2,1907020},{1,95355},{5,38139},{6,38139}]','[{54010003,270}]'),(25,4,5193,'[{2,1921240},{1,96066},{5,38423},{6,38423}]','[{54010003,270}]'),(25,5,5214,'[{2,1935520},{1,96780},{5,38709},{6,38709}]','[{54010003,270}]'),(25,6,5235,'[{2,1949860},{1,97497},{5,38996},{6,38996}]','[{54010003,270}]'),(25,7,5256,'[{2,1964260},{1,98217},{5,39284},{6,39284}]','[{54010003,270}]'),(25,8,5277,'[{2,1978720},{1,98940},{5,39573},{6,39573}]','[{54010003,270}]'),(25,9,5298,'[{2,1993240},{1,99666},{5,39863},{6,39863}]','[{54010003,270}]'),(25,10,0,'[{2,2007820},{1,100395},{5,40155},{6,40155}]','[{54010003,270}]');
/*!40000 ALTER TABLE `base_baby_up_stage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_baby_uplv`
--

DROP TABLE IF EXISTS `base_baby_uplv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_baby_uplv` (
  `id` int(10) unsigned NOT NULL COMMENT '编号',
  `grade` int(10) unsigned NOT NULL COMMENT '品阶',
  `baby_id` int(10) unsigned NOT NULL COMMENT '宝宝ID',
  `name` varchar(215) NOT NULL COMMENT '名字@lang@',
  `lv` int(10) unsigned NOT NULL COMMENT '等级',
  `exp` int(10) unsigned NOT NULL COMMENT '升到下一级所需经验',
  `attr` varchar(512) NOT NULL COMMENT '属性加成',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='宝宝-升级配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_baby_uplv`
--

LOCK TABLES `base_baby_uplv` WRITE;
/*!40000 ALTER TABLE `base_baby_uplv` DISABLE KEYS */;
INSERT INTO `base_baby_uplv` VALUES (1,1,1,'小苍宝宝',1,20,'[{1,100}]'),(2,1,1,'小苍宝宝',2,50,'[{1,200}]'),(3,1,1,'小苍宝宝',3,100,'[{1,300}]'),(4,1,1,'小苍宝宝',4,150,'[{1,400}]'),(5,1,1,'小苍宝宝',5,200,'[{1,500}]'),(6,1,1,'小苍宝宝',6,250,'[{1,600},{2,100}]'),(7,1,1,'小苍宝宝',7,300,'[{1,700},{2,300}]'),(8,1,1,'小苍宝宝',8,350,'[{1,800},{2,500}]'),(9,1,1,'小苍宝宝',9,400,'[{1,900},{2,700}]'),(10,1,1,'小苍宝宝',10,450,'[{1,1000},{2,900}]'),(11,1,1,'小苍宝宝',11,500,'[{1,1100},{2,1100}]'),(12,1,1,'小苍宝宝',12,550,'[{1,1200},{2,1300}]'),(13,1,1,'小苍宝宝',13,600,'[{1,1300},{2,1500}]'),(14,1,1,'小苍宝宝',14,650,'[{1,1400},{2,1700}]'),(15,1,1,'小苍宝宝',15,700,'[{1,1500},{2,1900}]'),(16,1,1,'小苍宝宝',16,750,'[{1,1600},{2,2100}]'),(17,1,1,'小苍宝宝',17,800,'[{1,1700},{2,2300}]'),(18,1,1,'小苍宝宝',18,850,'[{1,1800},{2,2500}]'),(19,1,1,'小苍宝宝',19,900,'[{1,1900},{2,2700}]'),(20,1,1,'小苍宝宝',20,0,'[{1,2000},{2,2900}]'),(21,2,2,'JY宝宝',1,100,'[{1,100}]'),(22,2,2,'JY宝宝',2,150,'[{1,200}]'),(23,2,2,'JY宝宝',3,200,'[{1,300}]'),(24,2,2,'JY宝宝',4,250,'[{1,400}]'),(25,2,2,'JY宝宝',5,300,'[{1,500}]'),(26,2,2,'JY宝宝',6,350,'[{1,600},{2,100}]'),(27,2,2,'JY宝宝',7,400,'[{1,700},{2,300}]'),(28,2,2,'JY宝宝',8,450,'[{1,800},{2,500}]'),(29,2,2,'JY宝宝',9,500,'[{1,900},{2,700}]'),(30,2,2,'JY宝宝',10,550,'[{1,1000},{2,900}]'),(31,2,2,'JY宝宝',11,600,'[{1,1100},{2,1100}]'),(32,2,2,'JY宝宝',12,650,'[{1,1200},{2,1300}]'),(33,2,2,'JY宝宝',13,700,'[{1,1300},{2,1500}]'),(34,2,2,'JY宝宝',14,750,'[{1,1400},{2,1700}]'),(35,2,2,'JY宝宝',15,800,'[{1,1500},{2,1900}]'),(36,2,2,'JY宝宝',16,850,'[{1,1600},{2,2100}]'),(37,2,2,'JY宝宝',17,900,'[{1,1700},{2,2300}]'),(38,2,2,'JY宝宝',18,950,'[{1,1800},{2,2500}]'),(39,2,2,'JY宝宝',19,1000,'[{1,1900},{2,2700}]'),(40,2,2,'JY宝宝',20,0,'[{1,2000},{2,2900}]'),(41,2,3,'囚徒宝宝',1,100,'[{1,100}]'),(42,2,3,'囚徒宝宝',2,150,'[{1,200}]'),(43,2,3,'囚徒宝宝',3,200,'[{1,300}]'),(44,2,3,'囚徒宝宝',4,250,'[{1,400}]'),(45,2,3,'囚徒宝宝',5,300,'[{1,500}]'),(46,2,3,'囚徒宝宝',6,350,'[{1,600},{2,100}]'),(47,2,3,'囚徒宝宝',7,400,'[{1,700},{2,300}]'),(48,2,3,'囚徒宝宝',8,450,'[{1,800},{2,500}]'),(49,2,3,'囚徒宝宝',9,500,'[{1,900},{2,700}]'),(50,2,3,'囚徒宝宝',10,550,'[{1,1000},{2,900}]'),(51,2,3,'囚徒宝宝',11,600,'[{1,1100},{2,1100}]'),(52,2,3,'囚徒宝宝',12,650,'[{1,1200},{2,1300}]'),(53,2,3,'囚徒宝宝',13,700,'[{1,1300},{2,1500}]'),(54,2,3,'囚徒宝宝',14,750,'[{1,1400},{2,1700}]'),(55,2,3,'囚徒宝宝',15,800,'[{1,1500},{2,1900}]'),(56,2,3,'囚徒宝宝',16,850,'[{1,1600},{2,2100}]'),(57,2,3,'囚徒宝宝',17,900,'[{1,1700},{2,2300}]'),(58,2,3,'囚徒宝宝',18,950,'[{1,1800},{2,2500}]'),(59,2,3,'囚徒宝宝',19,1000,'[{1,1900},{2,2700}]'),(60,2,3,'囚徒宝宝',20,0,'[{1,2000},{2,2900}]'),(61,3,4,'鼠大王宝宝',1,100,'[{1,100}]'),(62,3,4,'鼠大王宝宝',2,150,'[{1,200}]'),(63,3,4,'鼠大王宝宝',3,200,'[{1,300}]'),(64,3,4,'鼠大王宝宝',4,250,'[{1,400}]'),(65,3,4,'鼠大王宝宝',5,300,'[{1,500}]'),(66,3,4,'鼠大王宝宝',6,350,'[{1,600},{2,100}]'),(67,3,4,'鼠大王宝宝',7,400,'[{1,700},{2,300}]'),(68,3,4,'鼠大王宝宝',8,450,'[{1,800},{2,500}]'),(69,3,4,'鼠大王宝宝',9,500,'[{1,900},{2,700}]'),(70,3,4,'鼠大王宝宝',10,550,'[{1,1000},{2,900}]'),(71,3,4,'鼠大王宝宝',11,600,'[{1,1100},{2,1100}]'),(72,3,4,'鼠大王宝宝',12,650,'[{1,1200},{2,1300}]'),(73,3,4,'鼠大王宝宝',13,700,'[{1,1300},{2,1500}]'),(74,3,4,'鼠大王宝宝',14,750,'[{1,1400},{2,1700}]'),(75,3,4,'鼠大王宝宝',15,800,'[{1,1500},{2,1900}]'),(76,3,4,'鼠大王宝宝',16,850,'[{1,1600},{2,2100}]'),(77,3,4,'鼠大王宝宝',17,900,'[{1,1700},{2,2300}]'),(78,3,4,'鼠大王宝宝',18,950,'[{1,1800},{2,2500}]'),(79,3,4,'鼠大王宝宝',19,1000,'[{1,1900},{2,2700}]'),(80,3,4,'鼠大王宝宝',20,0,'[{1,2000},{2,2900}]'),(81,3,5,'酒神宝宝',1,20,'[{1,100}]'),(82,3,5,'酒神宝宝',2,50,'[{1,200}]'),(83,3,5,'酒神宝宝',3,100,'[{1,300}]'),(84,3,5,'酒神宝宝',4,150,'[{1,400}]'),(85,3,5,'酒神宝宝',5,200,'[{1,500}]'),(86,3,5,'酒神宝宝',6,250,'[{1,600},{2,100}]'),(87,3,5,'酒神宝宝',7,300,'[{1,700},{2,300}]'),(88,3,5,'酒神宝宝',8,350,'[{1,800},{2,500}]'),(89,3,5,'酒神宝宝',9,400,'[{1,900},{2,700}]'),(90,3,5,'酒神宝宝',10,450,'[{1,1000},{2,900}]'),(91,3,5,'酒神宝宝',11,500,'[{1,1100},{2,1100}]'),(92,3,5,'酒神宝宝',12,550,'[{1,1200},{2,1300}]'),(93,3,5,'酒神宝宝',13,600,'[{1,1300},{2,1500}]'),(94,3,5,'酒神宝宝',14,650,'[{1,1400},{2,1700}]'),(95,3,5,'酒神宝宝',15,700,'[{1,1500},{2,1900}]'),(96,3,5,'酒神宝宝',16,750,'[{1,1600},{2,2100}]'),(97,3,5,'酒神宝宝',17,800,'[{1,1700},{2,2300}]'),(98,3,5,'酒神宝宝',18,850,'[{1,1800},{2,2500}]'),(99,3,5,'酒神宝宝',19,900,'[{1,1900},{2,2700}]'),(100,3,5,'酒神宝宝',20,0,'[{1,2000},{2,2900}]'),(101,3,6,'skr宝宝',1,100,'[{1,100}]'),(102,3,6,'skr宝宝',2,150,'[{1,200}]'),(103,3,6,'skr宝宝',3,200,'[{1,300}]'),(104,3,6,'skr宝宝',4,250,'[{1,400}]'),(105,3,6,'skr宝宝',5,300,'[{1,500}]'),(106,3,6,'skr宝宝',6,350,'[{1,600},{2,100}]'),(107,3,6,'skr宝宝',7,400,'[{1,700},{2,300}]'),(108,3,6,'skr宝宝',8,450,'[{1,800},{2,500}]'),(109,3,6,'skr宝宝',9,500,'[{1,900},{2,700}]'),(110,3,6,'skr宝宝',10,550,'[{1,1000},{2,900}]'),(111,3,6,'skr宝宝',11,600,'[{1,1100},{2,1100}]'),(112,3,6,'skr宝宝',12,650,'[{1,1200},{2,1300}]'),(113,3,6,'skr宝宝',13,700,'[{1,1300},{2,1500}]'),(114,3,6,'skr宝宝',14,750,'[{1,1400},{2,1700}]'),(115,3,6,'skr宝宝',15,800,'[{1,1500},{2,1900}]'),(116,3,6,'skr宝宝',16,850,'[{1,1600},{2,2100}]'),(117,3,6,'skr宝宝',17,900,'[{1,1700},{2,2300}]'),(118,3,6,'skr宝宝',18,950,'[{1,1800},{2,2500}]'),(119,3,6,'skr宝宝',19,1000,'[{1,1900},{2,2700}]'),(120,3,6,'skr宝宝',20,0,'[{1,2000},{2,2900}]');
/*!40000 ALTER TABLE `base_baby_uplv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_battle_factor`
--

DROP TABLE IF EXISTS `base_battle_factor`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_battle_factor` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '参数Id',
  `value` varchar(512) NOT NULL COMMENT '参数值',
  `about` varchar(512) NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='战斗参数配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_battle_factor`
--

LOCK TABLES `base_battle_factor` WRITE;
/*!40000 ALTER TABLE `base_battle_factor` DISABLE KEYS */;
INSERT INTO `base_battle_factor` VALUES (1,'2.4','等级参数'),(2,'0.6','闪避参数'),(3,'0.7','暴击参数A'),(4,'0.0004','暴击闪避参数B'),(5,'0.0016','暴击闪避参数C'),(6,'0.2','暴击闪避临界补偿参数'),(7,'0.3','爆伤参数A'),(8,'8000','爆伤参数B'),(9,'1','基础伤害系数'),(10,'0.002','伤害通用参数B'),(12,'0.6','PVE参数A'),(13,'0.5','PVP参数A'),(14,'1.5','基础暴击倍率'),(15,'2.5','基础会心倍率'),(16,'4','基础致命倍率'),(17,'200','等级修正参数');
/*!40000 ALTER TABLE `base_battle_factor` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_beach_exp`
--

DROP TABLE IF EXISTS `base_beach_exp`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_beach_exp` (
  `lv_ll` int(20) NOT NULL COMMENT '等级下限',
  `lv_ul` int(20) NOT NULL COMMENT '等级上限',
  `gift_exp` int(20) NOT NULL COMMENT '送礼物经验',
  `time_exp` int(11) NOT NULL DEFAULT '0' COMMENT '每跳经验值',
  `date_exp` int(11) NOT NULL DEFAULT '0' COMMENT '约会每跳经验',
  PRIMARY KEY (`lv_ll`,`lv_ul`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='经验配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_beach_exp`
--

LOCK TABLES `base_beach_exp` WRITE;
/*!40000 ALTER TABLE `base_beach_exp` DISABLE KEYS */;
INSERT INTO `base_beach_exp` VALUES (1,200,783199,147938,73969),(201,220,945079,178515,89257),(221,240,1169103,220831,110415),(241,260,1265243,238990,119495),(261,280,1316766,248722,124361),(281,300,1416239,267512,133756),(301,320,1494881,282366,141183),(321,340,1591389,300596,150298),(341,360,1823101,344364,172182),(361,380,3475921,656563,328281),(381,400,4235921,800118,400059),(401,420,4995921,943674,471837),(421,440,5727691,1081897,540948),(441,460,7323019,1383237,691618),(461,480,8278441,1563706,781853),(481,500,8848441,1671372,835686),(501,520,10158688,1918863,959431),(521,540,13252015,2503158,1251579),(541,560,16244461,3068398,1534199),(561,580,17764461,3355509,1677754),(581,600,19284461,3642620,1821310),(601,620,20804461,3929731,1964865),(621,640,22324461,4216843,2108421),(641,660,23844461,4503954,2251977),(661,680,25364461,4791065,2395532),(681,700,26884461,5078176,2539088),(701,720,28404461,5365287,2682643),(721,740,29924461,5652398,2826199),(741,760,31444461,5939509,2969754),(761,780,32964461,6226620,3113310),(781,800,33724461,6370176,3185088),(801,820,33724461,6370176,3185088),(821,840,33724461,6370176,3185088),(841,860,33724461,6370176,3185088),(861,880,33724461,6370176,3185088),(881,900,33724461,6370176,3185088),(901,920,33724461,6370176,3185088),(921,940,33724461,6370176,3185088),(941,960,33724461,6370176,3185088),(961,980,33724461,6370176,3185088),(981,1000,33724461,6370176,3185088);
/*!40000 ALTER TABLE `base_beach_exp` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_beach_kv`
--

DROP TABLE IF EXISTS `base_beach_kv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_beach_kv` (
  `id` smallint(5) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `key` varchar(255) NOT NULL COMMENT '键',
  `value` varchar(255) NOT NULL COMMENT '值',
  `desc` varchar(255) NOT NULL COMMENT '描述',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=19 DEFAULT CHARSET=utf8 COMMENT='魅力海滩常量配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_beach_kv`
--

LOCK TABLES `base_beach_kv` WRITE;
/*!40000 ALTER TABLE `base_beach_kv` DISABLE KEYS */;
INSERT INTO `base_beach_kv` VALUES (1,'open_day_to_kf','6','魅力海滩多少天后进入跨服'),(2,'buy_times_money','[{1,5},{2,5},{3,10},{4,10},{5,20},{6,20},{7,30},{8,30},{9,40},{10,40},{11,50},{12,50}]','魅力海滩购买赠送次数价格（绑钻）'),(3,'send_exp_time','20','魅力海滩获得经验时间间隔（秒）'),(4,'reward_to_over_time','10','魅力海滩结算到结束的时间'),(5,'first_dsgt_id','400003','魅力海滩魅力榜第一名称号id'),(6,'send_gift_times','{60,4}','海滩提示送礼间隔次数{间隔(秒),次数}'),(7,'free_gift_times','3','海滩免费送礼次数'),(8,'put_vote_cost','[{1, [{1, 0, 5}]}, {2, [{1, 0, 10}]}, {3, [{1, 0, 15}]},{4, [{1, 0, 15}]},{5, [{1, 0, 15}]},{6, [{1, 0, 15}]},{7, [{1, 0, 15}]},{8, [{1, 0, 15}]},{9, [{1, 0, 15}]},{10, [{1, 0, 15}]},{11, [{1, 0, 15}]},{12, [{1, 0, 15}]}]','拉票消耗[{次数, 消耗列表}]'),(9,'stick_vote_time','120','拉票置顶间隔时间'),(10,'vote_times','10','可投票次数'),(11,'vote_max','40','单条拉票信息可获得最大投票次数'),(12,'max_put_vote_times','3','最大可拉票次数'),(13,'max_exp_reward','1200','最多可获得经验时间（s）'),(14,'kf_scene','5164','跨服场景'),(15,'bf_scene','5163','本服场景'),(16,'max_people','30','每个房间最大人数'),(17,'born_loc','[{9676,5635,500},{11278,5344,500},{9489,12452,500},{14000,9100,500}]','出生点[{x, y, radius}]，会在列表的圆中随机一个点'),(18,'rooms_num_each_pool_id','5','多少房间一个pool_id');
/*!40000 ALTER TABLE `base_beach_kv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_beach_props`
--

DROP TABLE IF EXISTS `base_beach_props`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_beach_props` (
  `props_type` int(20) NOT NULL COMMENT '道具类型',
  `props_name` varchar(256) NOT NULL COMMENT '道具名称',
  `charm_v` int(20) NOT NULL COMMENT '魅力值',
  PRIMARY KEY (`props_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='魅力值道具配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_beach_props`
--

LOCK TABLES `base_beach_props` WRITE;
/*!40000 ALTER TABLE `base_beach_props` DISABLE KEYS */;
INSERT INTO `base_beach_props` VALUES (1,'小黄鸭',5),(2,'海滩礼物',5),(3,'海滩礼物2',5),(4,'海滩礼物3',5);
/*!40000 ALTER TABLE `base_beach_props` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_beach_reward`
--

DROP TABLE IF EXISTS `base_beach_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_beach_reward` (
  `rank_ll` int(20) NOT NULL COMMENT '等级下限',
  `rank_ul` int(20) NOT NULL COMMENT '等级上限',
  `reward` varchar(1024) NOT NULL COMMENT '奖励内容',
  PRIMARY KEY (`rank_ll`,`rank_ul`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='魅力值排行榜奖励配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_beach_reward`
--

LOCK TABLES `base_beach_reward` WRITE;
/*!40000 ALTER TABLE `base_beach_reward` DISABLE KEYS */;
INSERT INTO `base_beach_reward` VALUES (1,1,'[{0,4905002,1},{0,40010011,8}]'),(2,2,'[{0,40010011,6}]'),(3,3,'[{0,40010011,5}]'),(4,5,'[{0,40010011,4}]'),(6,20,'[{0,40010011,3}]');
/*!40000 ALTER TABLE `base_beach_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_boss_cfg`
--

DROP TABLE IF EXISTS `base_boss_cfg`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_boss_cfg` (
  `boss_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'bossid',
  `type` tinyint(1) unsigned DEFAULT '0' COMMENT 'boss类型',
  `scene` int(11) unsigned DEFAULT '0' COMMENT 'boss出生场景id',
  `x` int(11) unsigned DEFAULT '0' COMMENT '出生x坐标',
  `y` int(11) unsigned DEFAULT '0' COMMENT '出生y坐标',
  `range` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '伤害计算范围',
  `rand_xy` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '随机坐标',
  `num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '生成上限',
  `layers` smallint(5) unsigned DEFAULT '0' COMMENT 'boss层数',
  `drop_lv` int(11) unsigned DEFAULT '0' COMMENT '掉落等级差距',
  `reborn_time` varchar(1000) DEFAULT '[]' COMMENT '重生时间[{开服时间, 重生间隔}...]',
  `goods` varchar(1000) DEFAULT '[]' COMMENT '固定掉落',
  `ratio_goods` varchar(1000) DEFAULT '[]' COMMENT '随机掉落',
  `cost` varchar(1000) DEFAULT '[]' COMMENT '单个boss进入消耗',
  `condition` varchar(1000) DEFAULT '[]' COMMENT '进入条件',
  `stage` varchar(50) NOT NULL DEFAULT '[]' COMMENT '阶数',
  `dun_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '个人boss对应的副本id',
  `crush_attr` varchar(512) NOT NULL DEFAULT '[]' COMMENT '碾压属性',
  `recommend_attr` varchar(512) NOT NULL DEFAULT '[]' COMMENT '推荐属性',
  `recommend_lv` varchar(50) NOT NULL DEFAULT '[]' COMMENT '推荐等级',
  `recommend_power` int(11) NOT NULL DEFAULT '0' COMMENT '推荐战力',
  `image` varchar(255) NOT NULL DEFAULT '""' COMMENT 'boss半身像',
  `peace_type` tinyint(1) NOT NULL DEFAULT '0' COMMENT '和平状态',
  `drop_stage` tinyint(1) NOT NULL DEFAULT '0' COMMENT '掉率级别',
  PRIMARY KEY (`boss_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_boss_cfg`
--

LOCK TABLES `base_boss_cfg` WRITE;
/*!40000 ALTER TABLE `base_boss_cfg` DISABLE KEYS */;
INSERT INTO `base_boss_cfg` VALUES (1202000,5,10010,12381,4466,0,'[]',0,1,100,'[{1,60}]','[]','[{1,{20040001,1001010342,1001020342,1001040342,1007010342,1002010342,1004010342,1006010342,1003000332}},{2,{20040001,1001010342,1001020342,1001040342,1007020342,1002020342,1004020342,1006020342,1003000332}},{4,{20040001,1001010342,1001020342,1001040342,1007040342,1002040342,1004040342,1006040342,1003000332}}]','[]','[{lv,90}]','[3]',0,'[]','[]','[{90,115}]',0,'1201001',0,1),(1202001,5,1310,12381,4466,0,'[]',0,1,100,'[{1,60}]','[]','[{0,{20040001,1001040342,1007010342,1002020342,1004040342,1006010342,1008040342,1010010332,1003000332}}]','[]','[{lv,90}]','[3]',0,'[]','[]','[{90,115}]',139102,'1201001',0,1),(1202002,5,1311,12381,4466,0,'[]',0,1,100,'[{1,60}]','[]','[{0,{20040001,1001010342,1007020342,1002040342,1004040342,1006040342,1010040342,1010010332,1003000332}}]','[]','[{lv,90}]','[3]',0,'[]','[]','[{90,115}]',139102,'1201001',1,0),(1202003,5,1310,6383,2090,0,'[]',0,1,100,'[{1,60}]','[]','[{0,{20040001,1001010442,1007010442,1002020442,1004040442,1006020442,1010040442,1010040432,1003000432}}]','[]','[{lv,90}]','[4]',0,'[]','[]','[{120,160}]',200480,'1201002',0,1),(1202004,5,1311,6383,2090,0,'[]',0,1,100,'[{1,120}]','[]','[{0,{20040001,1001010442,1007040442,1002020442,1004040442,1006010442,1008020442,1010010432,1003000432}}]','[]','[{lv,90}]','[4]',0,'[]','[]','[{120,160}]',200480,'1201002',1,0),(1202005,5,1310,16810,9443,0,'[]',0,1,100,'[{1,120}]','[]','[{0,{20040001,1001020442,1007040442,1002010442,1004020442,1006040442,1010040442,1010020432,1003000432}}]','[]','[{lv,90}]','[4]',0,'[]','[]','[{120,170}]',212499,'1201003',0,2),(1202006,5,1311,16810,9443,0,'[]',0,1,100,'[{1,480}]','[]','[{0,{20040001,1001040442,1007020442,1002020442,1004040442,1006020442,1010010442,1010040432,1003000432}}]','[]','[{lv,90}]','[4]',0,'[]','[]','[{120,170}]',212499,'1201003',1,0),(1202007,5,1310,11462,8089,0,'[]',0,1,100,'[{1,480}]','[]','[{0,{20040001,1001010442,1007010442,1002020442,1004020442,1006010442,1008010442,1010040432,1003000432}}]','[]','[{lv,90}]','[4]',0,'[]','[]','[{120,180}]',230833,'1201004',0,3),(1202008,5,1311,11462,8089,0,'[]',0,1,100,'[{1,540}]','[]','[{0,{20040001,1001010442,1007020442,1002010442,1004040442,1006020442,1008010442,1010020432,1003000432}}]','[]','[{lv,90}]','[4]',0,'[]','[]','[{120,180}]',230833,'1201004',1,0),(1202009,5,1310,21993,11478,0,'[]',0,1,100,'[{1,540}]','[]','[{0,{20040001,1001010542,1007040542,1002040542,1004020542,1006020542,1010040542,1010020532,1003000532}}]','[]','[{lv,90}]','[5]',0,'[]','[]','[{180,220}]',437282,'1201005',0,1),(1202010,5,1311,21993,11478,0,'[]',0,1,100,'[{1,600}]','[]','[{0,{20040001,1001020542,1007010542,1002020542,1004020542,1006020542,1010010542,1010020532,1003000532}}]','[]','[{lv,90}]','[5]',0,'[]','[]','[{180,220}]',437282,'1201005',1,0),(1202011,5,1310,10824,15454,0,'[]',0,1,100,'[{1,600}]','[]','[{0,{20040001,1001020542,1007010542,1002040542,1004020542,1006040542,1008040542,1010010532,1003000532}}]','[]','[{lv,90}]','[5]',0,'[]','[]','[{180,230}]',483401,'1202004',0,2),(1202012,5,1311,10824,15454,0,'[]',0,1,100,'[{1,600}]','[]','[{0,{20040001,1001040542,1007020542,1002040542,1004010542,1006020542,1008010542,1010040532,1003000532}}]','[]','[{lv,90}]','[5]',0,'[]','[]','[{180,230}]',483401,'1202004',1,0),(1202013,5,1310,3645,9908,0,'[]',0,1,100,'[{1,900}]','[]','[{0,{20040001,1001020542,1007040542,1002010542,1004020542,1006020542,1008020542,1010040532,1003000532}}]','[]','[{lv,90}]','[5]',0,'[]','[]','[{180,240}]',529520,'1203001',0,3),(1202014,5,1311,3645,9908,0,'[]',0,1,100,'[{1,900}]','[]','[{0,{20040001,1001010542,1007040542,1002010542,1004010542,1006010542,1010010542,1010010532,1003000532}}]','[]','[{lv,90}]','[5]',0,'[]','[]','[{180,240}]',529520,'1203001',1,0),(1202015,5,1310,5518,15294,0,'[]',0,1,100,'[{1,900}]','[]','[{0,{20040002,1001040642,1007020642,1002020642,1004020642,1006040642,1008040642,1010010632,1003000632}}]','[]','[{lv,90}]','[6]',0,'[]','[]','[{200,270}]',926190,'1201006',0,1),(1202016,5,1311,5518,15294,0,'[]',0,1,100,'[{1,900}]','[]','[{0,{20040002,1001020642,1007010642,1002020642,1004010642,1006040642,1008040642,1010040632,1003000632}}]','[]','[{lv,90}]','[6]',0,'[]','[]','[{200,270}]',926190,'1201006',1,0),(1203001,5,1312,12381,4466,0,'[]',0,2,100,'[{1,900}]','[]','[{0,{20040002,1001020642,1007020642,1002020642,1004010642,1006040642,1008020642,1010040632,1003000632}}]','[]','[{lv,200}]','[6]',0,'[]','[]','[{200,270}]',1046144,'1202003',0,1),(1203002,5,1313,12381,4466,0,'[]',0,2,100,'[{1,900}]','[]','[{0,{20040002,1001010642,1007040642,1002010642,1004040642,1006010642,1010010642,1010040632,1003000632}}]','[]','[{lv,200}]','[6]',0,'[]','[]','[{200,270}]',1046144,'1202003',1,0),(1203003,5,1312,6383,2090,0,'[]',0,2,100,'[{1,900}]','[]','[{0,{20040002,1001020642,1007040642,1002020642,1004040642,1006010642,1010010642,1010020632,1003000632}}]','[]','[{lv,200}]','[6]',0,'[]','[]','[{200,275}]',1166098,'1203002',0,2),(1203004,5,1313,6383,2090,0,'[]',0,2,100,'[{1,900}]','[]','[{0,{20040002,1001020642,1007020642,1002020642,1004020642,1006020642,1008020642,1010040632,1003000632}}]','[]','[{lv,200}]','[6]',0,'[]','[]','[{200,275}]',1166098,'1203002',1,0),(1203005,5,1312,16810,9443,0,'[]',0,2,100,'[{1,900}]','[]','[{0,{20040002,1001010642,1007010642,1002020642,1004020642,1006020642,1008020642,1010010632,1003000632}}]','[]','[{lv,200}]','[6]',0,'[]','[]','[{200,280}]',1286052,'1203003',0,3),(1203006,5,1313,16810,9443,0,'[]',0,2,100,'[{1,900}]','[]','[{0,{20040002,1001010642,1007020642,1002010642,1004010642,1006020642,1008040642,1010040632,1003000632}}]','[]','[{lv,200}]','[6]',0,'[]','[]','[{200,280}]',1286052,'1203003',1,0),(1203007,5,1312,11462,8089,0,'[]',0,2,100,'[{1,900}]','[]','[{0,{20040002,1001010642,1007040642,1002020642,1004040642,1006010642,1010040642,1010040632,1003000632}}]','[]','[{lv,200}]','[6]',0,'[]','[]','[{250,310}]',1390672,'1203004',0,3),(1203008,5,1313,11462,8089,0,'[]',0,2,100,'[{1,900}]','[]','[{0,{20040002,1001010642,1007040642,1002040642,1004040642,1006010642,1008040642,1010040632,1003000632}}]','[]','[{lv,200}]','[6]',0,'[]','[]','[{200,280}]',1390672,'1203004',1,0),(1203009,5,1312,21993,11478,0,'[]',0,2,100,'[{1,900}]','[]','[{0,{20040002,1001020742,1007010742,1002020742,1004010742,1006010742,1010020742,1010020732,1003000732}}]','[]','[{lv,200}]','[7]',0,'[]','[]','[{250,320}]',1913772,'1203005',0,1),(1203010,5,1313,21993,11478,0,'[]',0,2,100,'[{1,900}]','[]','[{0,{20040002,1001010742,1007040742,1002040742,1004010742,1006040742,1010040742,1010010732,1003000732}}]','[]','[{lv,200}]','[7]',0,'[]','[]','[{250,310}]',1913772,'1203005',1,0),(1203011,5,1312,10824,15454,0,'[]',0,2,100,'[{1,900}]','[]','[{0,{20040002,1001010742,1007020742,1002040742,1004040742,1006020742,1008020742,1010040732,1003000732}}]','[]','[{lv,200}]','[7]',0,'[]','[]','[{250,330}]',2123012,'1203006',0,1),(1203012,5,1313,10824,15454,0,'[]',0,2,100,'[{1,900}]','[]','[{0,{20040002,1001040742,1007010742,1002010742,1004020742,1006020742,1008020742,1010010732,1003000732}}]','[]','[{lv,200}]','[7]',0,'[]','[]','[{250,320}]',2123012,'1203006',1,0),(1203013,5,1312,3645,9908,0,'[]',0,2,100,'[{1,900}]','[]','[{0,{20040002,1001040742,1007040742,1002010742,1004020742,1006040742,1008010742,1010040732,1003000732}}]','[]','[{lv,200}]','[7]',0,'[]','[]','[{280,340}]',2332252,'1203007',0,2),(1203014,5,1312,5518,15294,0,'[]',0,2,100,'[{1,900}]','[]','[{0,{18030001,20040003,1001020742,1007040742,1002020742,1004020742,1006010742,1010010732,1003000732}}]','[]','[{lv,200}]','[7]',0,'[]','[]','[{280,350}]',2605424,'1203008',0,3),(1204001,5,1314,12381,4466,0,'[]',0,3,100,'[{1,900}]','[]','[{0,{18030001,20040003,1001010742,1007020742,1002020742,1004010742,1006040742,1010010732,1003000732}}]','[]','[{lv,300}]','[7]',0,'[]','[]','[{300,370}]',2878597,'1201007',0,1),(1204002,5,1315,12381,4466,0,'[]',0,3,100,'[{1,900}]','[]','[{0,{18030001,20040003,1001020742,1007010742,1002040742,1004010742,1006010742,1010040732,1003000732}}]','[]','[{lv,300}]','[7]',0,'[]','[]','[{300,370}]',2878597,'1203009',1,0),(1204003,5,1314,6383,2090,0,'[]',0,3,100,'[{1,900}]','[]','[{0,{18030001,20040003,1001020842,1007040842,1002020842,1004040842,1006020842,1010020832,1003000832}}]','[]','[{lv,300}]','[8]',0,'[]','[]','[{300,370}]',3561528,'1202001',0,1),(1204004,5,1315,6383,2090,0,'[]',0,3,100,'[{1,900}]','[]','[{0,{18030001,20040003,1001040842,1007010842,1002040842,1004010842,1006010842,1010040832,1003000832}}]','[]','[{lv,300}]','[8]',0,'[]','[]','[{300,370}]',3698115,'1202002',1,0),(1204005,5,1314,16810,9443,0,'[]',0,3,100,'[{1,900}]','[]','[{0,{18030001,20040003,1001020842,1007010842,1002040842,1004010842,1006010842,1010020832,1003000832}}]','[]','[{lv,300}]','[8]',0,'[]','[]','[{350,400}]',3898649,'1202005',0,2),(1204006,5,1315,16810,9443,0,'[]',0,3,100,'[{1,900}]','[]','[{0,{18030001,20040003,1001020842,1007010842,1002040842,1004020842,1006020842,1010040832,1003000832}}]','[]','[{lv,300}]','[8]',0,'[]','[]','[{350,400}]',3898649,'1203010',1,0),(1204007,5,1314,11462,8089,0,'[]',0,3,100,'[{1,900}]','[]','[{0,{18030001,20040003,1001040842,1007010842,1002040842,1004040842,1006020842,1010010832,1003000832}}]','[]','[{lv,300}]','[8]',0,'[]','[]','[{350,410}]',4099183,'1201008',0,3),(1204008,5,1315,11462,8089,0,'[]',0,3,100,'[{1,900}]','[]','[{0,{18030001,20040003,1001020942,1007040942,1002040942,1004040942,1006020942,1010010932,1003000932}}]','[]','[{lv,300}]','[9]',0,'[]','[]','[{390,440}]',5502922,'1203011',1,0),(1204009,5,1314,21993,11478,0,'[]',0,3,100,'[{1,900}]','[]','[{0,{18030001,20040003,1001010942,1007020942,1002020942,1004020942,1006010942,1010010932,1003000932}}]','[]','[{lv,300}]','[9]',0,'[]','[]','[{390,450}]',5703457,'1203008',0,1),(1204010,5,1314,10824,15454,0,'[]',0,3,100,'[{1,900}]','[]','[{0,{18030001,20040004,1001010942,1007020942,1002020942,1004040942,1006010942,1010040932,1003000932}}]','[]','[{lv,300}]','[9]',0,'[]','[]','[{390,460}]',5876700,'1202003',0,2),(1204011,5,1314,3645,9908,0,'[]',0,3,100,'[{1,900}]','[]','[{0,{18030001,20040004,1001010942,1007010942,1002020942,1004010942,1006040942,1010020932,1003000932}}]','[]','[{lv,300}]','[9]',0,'[]','[]','[{400,470}]',6049943,'1203002',0,3),(1204012,5,1315,3645,9908,0,'[]',0,3,100,'[{1,900}]','[]','[{0,{18030001,20040004,1001020942,1007040942,1002040942,1004020942,1006020942,1010010932,1003000932}}]','[]','[{lv,300}]','[9]',0,'[]','[]','[{400,470}]',6223186,'1203003',1,0),(1204013,5,1314,5518,15294,0,'[]',0,3,100,'[{1,900}]','[]','[{0,{18030001,20040004,1001021042,1007041042,1002041042,1004011042,1006041042,1010021032,1003001032}}]','[]','[{lv,300}]','[10]',0,'[]','[]','[{430,460}]',7262646,'1203004',0,1),(1204014,5,1314,13000,11220,0,'[]',0,3,100,'[{1,900}]','[]','[{0,{18030001,20040004,1001041042,1007011042,1002011042,1004011042,1006041042,1010011032,1003001032}}]','[]','[{lv,300}]','[10]',0,'[]','[]','[{430,470}]',7435890,'1203001',0,1),(1205001,5,1316,12381,4466,0,'[]',0,4,100,'[{1,900}]','[]','[{0,{18030001,20040004,1001021042,1007011042,1002011042,1004011042,1006021042,1010011032,1003001032}}]','[]','[{lv,420}]','[10]',0,'[]','[]','[{450,485}]',7699896,'1203003',0,2),(1205002,5,1316,6383,2090,0,'[]',0,4,100,'[{1,900}]','[]','[{0,{18030001,20040004,1001041042,1007011042,1002011042,1004021042,1006041042,1010021032,1003001032}}]','[]','[{lv,420}]','[10]',0,'[]','[]','[{450,490}]',7963902,'1203004',0,3),(1205003,5,1316,16810,9443,0,'[]',0,4,100,'[{1,900}]','[]','[{0,{18030001,20040004,1001021142,1007011142,1002011142,1004011142,1006041142,1010041132,1003001132}}]','[]','[{lv,420}]','[11]',0,'[]','[]','[{500,530}]',10075953,'1203005',0,1),(1205004,5,1316,11462,8089,0,'[]',0,4,100,'[{1,900}]','[]','[{0,{18030001,20040005,1001021142,1007021142,1002021142,1004011142,1006021142,1010011132,1003001132}}]','[]','[{lv,420}]','[11]',0,'[]','[]','[{500,535}]',10408791,'1203006',0,1),(1205005,5,1316,21993,11478,0,'[]',0,4,100,'[{1,900}]','[]','[{0,{18030001,20040005,1001021142,1007041142,1002041142,1004011142,1006021142,1010011132,1003001132}}]','[]','[{lv,420}]','[11]',0,'[]','[]','[{500,540}]',10741629,'1203007',0,2),(1205006,5,1316,10888,15618,0,'[]',0,4,100,'[{1,900}]','[]','[{0,{18030001,20040005,1001021142,1007041142,1002041142,1004011142,1006041142,1010041132,1003001132}}]','[]','[{lv,420}]','[11]',0,'[]','[]','[{500,560}]',12072981,'1203008',0,3),(1205007,5,1316,3645,9908,0,'[]',0,4,100,'[{1,900}]','[]','[{0,{18030001,20040005,1001041242,1007021242,1002041242,1004021242,1006041242,1010021232,1003001232}}]','[]','[{lv,420}]','[12]',0,'[]','[]','[{550,575}]',13071495,'1202003',0,1),(1205008,5,1316,5518,15294,0,'[]',0,4,100,'[{1,900}]','[]','[{0,{18030001,20040005,1001041242,1007041242,1002011242,1004011242,1006041242,1010011232,1003001232}}]','[]','[{lv,420}]','[12]',0,'[]','[]','[{550,580}]',13404334,'1203002',0,1),(1206001,5,1317,12381,4466,0,'[]',0,5,100,'[{1,900}]','[]','[{0,{18030001,20040005,1001021242,1007021242,1002011242,1004021242,1006011242,1010041232,1003001232}}]','[]','[{lv,570}]','[12]',0,'[]','[]','[{560,590}]',14048885,'1201007',0,2),(1206002,5,1317,6383,2090,0,'[]',0,5,100,'[{1,900}]','[]','[{0,{18030001,20040005,1001041242,1007011242,1002021242,1004041242,1006021242,1010041232,1003001232}}]','[]','[{lv,570}]','[12]',0,'[]','[]','[{570,600}]',14693437,'1203009',0,3),(1206003,5,1317,16810,9443,0,'[]',0,5,100,'[{1,900}]','[]','[{0,{18030001,20040005,1001011342,1007041342,1002011342,1004041342,1006011342,1010021332,1003001332}}]','[]','[{lv,570}]','[13]',0,'[]','[]','[{600,630}]',16627093,'1202001',0,1),(1206004,5,1317,11462,8089,0,'[]',0,5,100,'[{1,900}]','[]','[{0,{18030001,20040005,1001011342,1007041342,1002011342,1004011342,1006011342,1010041332,1003001332}}]','[]','[{lv,570}]','[13]',0,'[]','[]','[{605,635}]',17005320,'1202002',0,2),(1206005,5,1317,21993,11478,0,'[]',0,5,100,'[{1,900}]','[]','[{0,{18030001,20040005,1001021342,1007011342,1002011342,1004011342,1006011342,1010011332,1003001332}}]','[]','[{lv,570}]','[13]',0,'[]','[]','[{610,640}]',17383548,'1202005',0,2),(1206006,5,1317,10888,15618,0,'[]',0,5,100,'[{1,900}]','[]','[{0,{18030001,20040005,1001021342,1007021342,1002021342,1004011342,1006011342,1010011332,1003001332}}]','[]','[{lv,570}]','[13]',0,'[]','[]','[{630,660}]',18896459,'1203010',0,3),(1206007,5,1317,3645,9908,0,'[]',0,5,100,'[{1,900}]','[]','[{0,{18030001,20040005,1001021442,1007011442,1002021442,1004041442,1006011442,1010041432,1003001432}}]','[]','[{lv,570}]','[14]',0,'[]','[]','[{650,680}]',20409371,'1201008',0,1),(1206008,5,1317,5518,15294,0,'[]',0,5,100,'[{1,900}]','[]','[{0,{18030001,20040005,1001011442,1007041442,1002041442,1004011442,1006021442,1010021432,1003001432}}]','[]','[{lv,570}]','[14]',0,'[]','[]','[{655,685}]',20833966,'1203011',0,2),(1207001,5,1318,12381,4466,0,'[]',0,6,100,'[{1,900}]','[]','[{0,{18030001,20040005,1001021542,1007041542,1002021542,1004041542,1006011542,1010021532,1003001532}}]','[]','[{lv,680}]','[15]',0,'[]','[]','[{700,730}]',24655327,'1202003',0,1),(1207002,5,1318,6383,2090,0,'[]',0,6,100,'[{1,900}]','[]','[{0,{18030001,20040005,1001021542,1007021542,1002011542,1004021542,1006041542,1010011532,1003001532}}]','[]','[{lv,680}]','[15]',0,'[]','[]','[{705,735}]',25039249,'1203002',0,2),(1207003,5,1318,16810,9443,0,'[]',0,6,100,'[{1,900}]','[]','[{0,{18030001,20040005,1001011542,1007041542,1002021542,1004021542,1006011542,1010011532,1003001532}}]','[]','[{lv,680}]','[15]',0,'[]','[]','[{710,740}]',25423172,'1203003',0,3),(1207004,5,1318,11462,8089,0,'[]',0,6,100,'[{1,900}]','[]','[{0,{18030001,20040005,1001041642,1007021642,1002041642,1004021642,1006041642,1010021632,1003001632}}]','[]','[{lv,680}]','[16]',0,'[]','[]','[{745,775}]',28110630,'1203004',0,1),(1207005,5,1318,21993,11478,0,'[]',0,6,100,'[{1,900}]','[]','[{0,{18030001,20040005,1001021642,1007011642,1002041642,1004011642,1006011642,1010011632,1003001632}}]','[]','[{lv,680}]','[16]',0,'[]','[]','[{750,780}]',28494553,'1203005',0,2),(1207006,5,1318,10888,15618,0,'[]',0,6,100,'[{1,900}]','[]','[{0,{18030001,20040005,1001011642,1007041642,1002021642,1004041642,1006021642,1010041632,1003001632}}]','[]','[{lv,680}]','[16]',0,'[]','[]','[{755,785}]',28935707,'1203006',0,3),(1251001,3,1251,14087,3512,0,'[]',0,1,100,'[{1,600}]','[]','[{0,{24030001,1001020542,1007010542,1002010542,1004010542,1006040542,1008020542,1010020532,1003000532}}]','[{2,36020001,200}]','[{lv,160},{vip,4}]','[5]',0,'[]','[]','[{200,300}]',529520,'1201001',0,1),(1251002,3,1251,4015,11856,0,'[]',0,1,100,'[{1,600}]','[]','[{0,{24030001,1001040542,1007040542,1002020542,1004040542,1006010542,1010040542,1010020532,1003000532}}]','[{2,36020001,200}]','[{lv,160},{vip,4}]','[5]',0,'[]','[]','[{205,305}]',575640,'1203009',0,2),(1251003,3,1251,13505,13391,0,'[]',0,1,100,'[{1,900}]','[]','[{0,{24030001,1001020642,1007020642,1002040642,1004020642,1006040642,1008040642,1010040632,1003000632}}]','[{2,36020001,200}]','[{lv,160},{vip,4}]','[6]',0,'[]','[]','[{250,350}]',1286052,'1203003',0,1),(1251004,3,1251,7182,17323,0,'[]',0,1,100,'[{1,900}]','[]','[{0,{24030001,1001010642,1007020642,1002020642,1004020642,1006020642,1010040642,1010010632,1003000632}}]','[{2,36020001,200}]','[{lv,160},{vip,4}]','[6]',0,'[]','[]','[{260,360}]',1495292,'1203004',0,2),(1251005,3,1251,19789,10574,0,'[]',0,1,100,'[{1,1200}]','[]','[{0,{24030001,1001010742,1007040742,1002040742,1004010742,1006040742,1008010742,1010020732,1003000732}}]','[{2,36020001,200}]','[{lv,160},{vip,4}]','[7]',0,'[]','[]','[{290,390}]',2123012,'1203010',0,1),(1251006,3,1251,23217,13705,0,'[]',0,1,100,'[{1,1200}]','[]','[{0,{24030001,1001020742,1007020742,1002020742,1004010742,1006040742,1010010742,1010010732,1003000732}}]','[{2,36020001,200}]','[{lv,160},{vip,4}]','[7]',0,'[]','[]','[{310,410}]',2605424,'1201004',0,2),(1251007,3,1251,19155,18011,0,'[]',0,1,100,'[{1,1500}]','[]','[{0,{24030001,1001010842,1007040842,1002040842,1004010842,1006020842,1010040842,1010010832,1003000832}}]','[{2,36020001,200}]','[{lv,160},{vip,4}]','[8]',0,'[]','[]','[{350,450}]',3698115,'1201007',0,1),(1252001,3,1252,14087,3512,0,'[]',0,2,100,'[{1,1200}]','[]','[{0,{24030002,1001040642,1007010642,1002040642,1004010642,1006020642,1010020642,1010040632,1003000632}}]','[{2,36020001,200}]','[{lv,160},{vip,5}]','[6]',0,'[]','[]','[{250,370}]',1286052,'1203010',0,1),(1252002,3,1252,4015,11856,0,'[]',0,2,100,'[{1,1500}]','[]','[{0,{24030002,1001020642,1007020642,1002010642,1004040642,1006010642,1010040642,1010010632,1003000632}}]','[{2,36020001,200}]','[{lv,180},{vip,5}]','[6]',0,'[]','[]','[{260,380}]',1495292,'1203011',0,2),(1252003,3,1252,13505,13391,0,'[]',0,2,100,'[{1,1800}]','[]','[{0,{24030002,1001040742,1007020742,1002040742,1004040742,1006040742,1010040742,1010040732,1003000732}}]','[{2,36020001,200}]','[{lv,180},{vip,5}]','[7]',0,'[]','[]','[{300,420}]',2332252,'1201003',0,1),(1252004,3,1252,7182,17323,0,'[]',0,2,100,'[{1,2400}]','[]','[{0,{24030002,1001020842,1007010842,1002020842,1004020842,1006010842,1010020842,1010020832,1003000832}}]','[{2,36020001,200}]','[{lv,180},{vip,5}]','[8]',0,'[]','[]','[{350,470}]',3698115,'1203001',0,1),(1252005,3,1252,19789,10574,0,'[]',0,2,100,'[{1,2700}]','[]','[{0,{24030002,1001010942,1007010942,1002010942,1004010942,1006040942,1008020942,1010040932,1003000932}}]','[{2,36020001,200}]','[{lv,180},{vip,5}]','[9]',0,'[]','[]','[{400,520}]',4901320,'1202003',0,1),(1253001,3,1253,14087,3512,0,'[]',0,3,100,'[{1,1800}]','[]','[{0,{24030003,1001010742,1007040742,1002020742,1004040742,1006010742,1010020742,1010020732,1003000732}}]','[{2,36020001,200}]','[{lv,180},{vip,6}]','[7]',0,'[]','[]','[{310,470}]',1286052,'1203003',0,3),(1253002,3,1253,4015,11856,0,'[]',0,3,100,'[{1,2700}]','[]','[{0,{24030003,1001020842,1007040842,1002010842,1004020842,1006010842,1008040842,1010040832,1003000832}}]','[{2,36020001,200}]','[{lv,180},{vip,6}]','[8]',0,'[]','[]','[{360,520}]',1495292,'1202003',0,2),(1253003,3,1253,13505,13391,0,'[]',0,3,100,'[{1,3600}]','[]','[{0,{24030003,1001010942,1007040942,1002040942,1004020942,1006010942,1008040942,1010020932,1003000932}}]','[{2,36020001,200}]','[{lv,180},{vip,6}]','[9]',0,'[]','[]','[{390,550}]',2332252,'1201002',0,1),(1253004,3,1253,7182,17323,0,'[]',0,3,100,'[{1,3600}]','[]','[{0,{24030003,1001010942,1007020942,1002020942,1004040942,1006040942,1008040942,1010020932,1003000932}}]','[{2,36020001,200}]','[{lv,180},{vip,6}]','[9]',0,'[]','[]','[{400,560}]',3698115,'1203003',0,2),(1253005,3,1253,19789,10574,0,'[]',0,3,100,'[{1,7200}]','[]','[{0,{24030003,1001041042,1007041042,1002011042,1004011042,1006041042,1008011042,1010021032,1003001032}}]','[{2,36020001,200}]','[{lv,180},{vip,6}]','[10]',0,'[]','[]','[{440,600}]',4901320,'1202004',0,1),(1254001,3,1254,14087,3512,0,'[]',0,4,100,'[{1,7200}]','[]','[{0,{24030004,1001010942,1007010942,1002040942,1004020942,1006010942,1010040942,1010040932,1003000932}}]','[{2,36020001,200}]','[{lv,180},{vip,7}]','[9]',0,'[]','[]','[{410,610}]',6049943,'1201002',0,1),(1254002,3,1254,4015,11856,0,'[]',0,4,100,'[{1,7200}]','[]','[{0,{24030004,1001041042,1007011042,1002021042,1004011042,1006011042,1008011042,1010011032,1003001032}}]','[{2,36020001,200}]','[{lv,180},{vip,7}]','[10]',0,'[]','[]','[{450,650}]',7435890,'1201004',0,1),(1254003,3,1254,13505,13391,0,'[]',0,4,100,'[{1,7200}]','[]','[{0,{24030004,1001041042,1007021042,1002021042,1004021042,1006021042,1010021042,1010021032,1003001032}}]','[{2,36020001,200}]','[{lv,180},{vip,7}]','[10]',0,'[]','[]','[{460,660}]',7963902,'1202002',0,1),(1254004,3,1254,7182,17323,0,'[]',0,4,100,'[{1,7200}]','[]','[{0,{24030004,1001041142,1007011142,1002021142,1004021142,1006011142,1010041142,1010041132,1003001132}}]','[{2,36020001,200}]','[{lv,180},{vip,7}]','[11]',0,'[]','[]','[{500,700}]',10075953,'1203001',0,1),(1254005,3,1254,19789,10574,0,'[]',0,4,100,'[{1,7200}]','[]','[{0,{24030004,1001011242,1007011242,1002021242,1004021242,1006041242,1010021242,1010021232,1003001232}}]','[{2,36020001,200}]','[{lv,180},{vip,7}]','[12]',0,'[]','[]','[{540,740}]',12738657,'1202001',0,1),(1255001,3,1255,14087,3512,0,'[]',0,5,100,'[{1,7200}]','[]','[{0,{24030005,1001041142,1007041142,1002021142,1004041142,1006041142,1008011142,1010011132,1003001132}}]','[{2,36020001,200}]','[{lv,180},{vip,8}]','[11]',0,'[]','[]','[{505,750}]',10408791,'1203001',0,1),(1255002,3,1255,4015,11856,0,'[]',0,5,100,'[{1,7200}]','[]','[{0,{24030005,1001021142,1007041142,1002011142,1004011142,1006011142,1008021142,1010011132,1003001132}}]','[{2,36020001,200}]','[{lv,180},{vip,8}]','[11]',0,'[]','[]','[{510,750}]',10741629,'1201005',0,1),(1255003,3,1255,13505,13391,0,'[]',0,5,100,'[{1,7200}]','[]','[{0,{24030005,1001041242,1007021242,1002011242,1004021242,1006011242,1008021242,1010021232,1003001232}}]','[{2,36020001,200}]','[{lv,180},{vip,8}]','[12]',0,'[]','[]','[{550,750}]',13404334,'1202001',0,1),(1255004,3,1255,7182,17323,0,'[]',0,5,100,'[{1,7200}]','[]','[{0,{24030005,1001021342,1007011342,1002021342,1004011342,1006021342,1008041342,1010041332,1003001332}}]','[{2,36020001,200}]','[{lv,180},{vip,8}]','[13]',0,'[]','[]','[{600,750}]',16627093,'1201008',0,1),(1255005,3,1255,19789,10574,0,'[]',0,5,100,'[{1,7200}]','[]','[{0,{24030005,1001021442,1007011442,1002011442,1004021442,1006011442,1010021442,1010041432,1003001432}}]','[{2,36020001,200}]','[{lv,180},{vip,8}]','[13]',0,'[]','[]','[{650,750}]',20409371,'1201001',0,1),(1256001,3,1256,14087,3512,0,'[]',0,6,100,'[{1,7200}]','[]','[{0,{24030006,1001011242,1007041242,1002021242,1004021242,1006021242,1010011242,1010011232,1003001232}}]','[{2,36020001,200}]','[{lv,180},{vip,9}]','[12]',0,'[]','[]','[{505,750}]',14048885,'1203008',0,1),(1256002,3,1256,4015,11856,0,'[]',0,6,100,'[{1,7200}]','[]','[{0,{24030006,1001021342,1007041342,1002011342,1004041342,1006041342,1008021342,1010041332,1003001332}}]','[{2,36020001,200}]','[{lv,180},{vip,9}]','[13]',0,'[]','[]','[{510,750}]',17383548,'1201006',0,1),(1256003,3,1256,13505,13391,0,'[]',0,6,100,'[{1,7200}]','[]','[{0,{24030006,1001011342,1007021342,1002021342,1004041342,1006011342,1010021342,1010041332,1003001332}}]','[{2,36020001,200}]','[{lv,180},{vip,9}]','[13]',0,'[]','[]','[{550,750}]',18140004,'1201003',0,1),(1256004,3,1256,7182,17323,0,'[]',0,6,100,'[{1,7200}]','[]','[{0,{24030006,1001021442,1007011442,1002021442,1004041442,1006041442,1010011442,1010041432,1003001432}}]','[{2,36020001,200}]','[{lv,180},{vip,9}]','[14]',0,'[]','[]','[{600,750}]',20031143,'1203005',0,1),(1256005,3,1256,19789,10574,0,'[]',0,6,100,'[{1,7200}]','[]','[{0,{24030006,1001041442,1007021442,1002021442,1004021442,1006011442,1008011442,1010021432,1003001432}}]','[{2,36020001,200}]','[{lv,180},{vip,9}]','[14]',0,'[]','[]','[{650,750}]',20409371,'1202005',0,1),(1257001,3,1254,14087,3512,0,'[]',0,7,100,'[{1,7200}]','[]','[{0,{24030007,1001011342,1007021342,1002011342,1004021342,1006041342,1008011342,1010021332,1003001332}}]','[{2,36020001,200}]','[{lv,180},{vip,10}]','[13]',0,'[]','[]','[{625,750}]',18518232,'1201002',0,1),(1257002,3,1254,4015,11856,0,'[]',0,7,100,'[{1,7200}]','[]','[{0,{24030007,1001041442,1007041442,1002011442,1004011442,1006041442,1010021442,1010011432,1003001432}}]','[{2,36020001,200}]','[{lv,180},{vip,10}]','[14]',0,'[]','[]','[{655,750}]',20833966,'1201004',0,1),(1257003,3,1254,13505,13391,0,'[]',0,7,100,'[{1,7200}]','[]','[{0,{24030007,1001011442,1007021442,1002041442,1004021442,1006041442,1008021442,1010011432,1003001432}}]','[{2,36020001,200}]','[{lv,180},{vip,10}]','[14]',0,'[]','[]','[{660,750}]',21258562,'1202002',0,1),(1257004,3,1254,7182,17323,0,'[]',0,7,100,'[{1,7200}]','[]','[{0,{24030007,1001041542,1007011542,1002041542,1004011542,1006011542,1010041542,1010041532,1003001532}}]','[{2,36020001,200}]','[{lv,180},{vip,10}]','[15]',0,'[]','[]','[{700,750}]',24655327,'1203001',0,1),(1257005,3,1254,19789,10574,0,'[]',0,7,100,'[{1,7200}]','[]','[{0,{24030007,1001021642,1007041642,1002021642,1004011642,1006021642,1008021642,1010011632,1003001632}}]','[{2,36020001,200}]','[{lv,180},{vip,10}]','[16]',0,'[]','[]','[{700,750}]',28494553,'1202001',0,1),(1301001,4,1301,12461,4496,0,'[]',0,1,1000,'[{1,900}]','[]','[{0,{38270012,38270021,38240001,38230207,38230202,38230404,38230206,38230110,38230210}}]','[0,38030003,1]','[{lv,240}]','[6]',0,'[]','[]','[{260,290}]',1495292,'1201006',0,1),(1301002,4,1301,7003,2938,0,'[]',0,1,1000,'[{1,900}]','[]','[{0,{38270011,38270022,38240001,38230107,38230402,38230104,38230406,38230208,38230410}}]','[0,38030003,1]','[{lv,240}]','[7]',0,'[]','[]','[{280,310}]',1913772,'1203005',0,1),(1301003,4,1301,16810,9443,0,'[]',0,1,1000,'[{1,900}]','[]','[{0,{38270012,38270023,38240001,38230407,38230402,38230204,38230206,38230110,38230410}}]','[0,38030003,1]','[{lv,240}]','[7]',0,'[]','[]','[{300,330}]',2332252,'1201005',0,2),(1301004,4,1301,10460,8613,0,'[]',0,1,1000,'[{1,900}]','[]','[{0,{38270012,38270021,38240001,38230207,38230202,38230204,38230106,38230108,38230110}}]','[0,38030003,1]','[{lv,240}]','[7]',0,'[]','[]','[{320,350}]',2878597,'1201008',0,3),(1301005,4,1301,21993,11578,0,'[]',0,1,1000,'[{1,900}]','[]','[{0,{38270011,38270022,38240001,38230207,38230202,38230404,38230106,38230410,38230110}}]','[0,38030003,1]','[{lv,240}]','[8]',0,'[]','[]','[{340,370}]',3424942,'1203007',0,1),(1301006,4,1301,11088,15618,0,'[]',0,1,1000,'[{1,900}]','[]','[{0,{38270012,38270023,38240001,38230107,38230102,38230204,38230106,38230108,38230110}}]','[0,38030003,1]','[{lv,240}]','[8]',0,'[]','[]','[{360,390}]',4099183,'1203003',0,2),(1301007,4,1301,3645,9908,0,'[]',0,1,1000,'[{1,900}]','[]','[{0,{38270012,38270021,38240001,38230407,38230402,38230404,38230206,38230408,38230410}}]','[0,38030003,1]','[{lv,240}]','[9]',0,'[]','[]','[{380,410}]',4901320,'1202002',0,1),(1301008,4,1301,5669,16070,0,'[]',0,1,1000,'[{1,900}]','[]','[{0,{38270011,38270022,38240001,38230407,38230402,38230204,38230206,38230408,38230210}}]','[0,38030003,1]','[{lv,240}]','[9]',0,'[]','[]','[{400,430}]',5703457,'1201007',0,2),(1302001,4,1302,12461,4496,0,'[]',0,2,1000,'[{1,900}]','[]','[{0,{38270012,38270021,38240001,38230407,38230202,38230404,38230106,38230408,38230110}}]','[0,38030003,1]','[{lv,400}]','[10]',0,'[]','[]','[{425,455}]',6569673,'1201007',0,1),(1302002,4,1302,7003,2938,0,'[]',0,2,1000,'[{1,900}]','[]','[{0,{38270011,38270022,38240001,38230107,38230102,38230104,38230106,38230208,38230210}}]','[0,38030003,1]','[{lv,400}]','[10]',0,'[]','[]','[{450,480}]',7435890,'1201001',0,1),(1302003,4,1302,16810,9443,0,'[]',0,2,1000,'[{1,900}]','[]','[{0,{38270012,38270023,38240001,38230107,38230202,38230404,38230406,38230208,38230210}}]','[0,38030003,1]','[{lv,400}]','[11]',0,'[]','[]','[{475,505}]',8755921,'1202002',0,2),(1302004,4,1302,10460,8613,0,'[]',0,2,1000,'[{1,900}]','[]','[{0,{38270012,38270021,38240001,38230207,38230202,38230104,38230106,38230108,38230210}}]','[0,38030003,1]','[{lv,400}]','[11]',0,'[]','[]','[{500,530}]',10075953,'1201008',0,3),(1302005,4,1302,21993,11578,0,'[]',0,2,1000,'[{1,900}]','[]','[{0,{38270011,38270022,38240001,38230107,38230102,38230204,38230206,38230410,38230210}}]','[0,38030003,1]','[{lv,400}]','[11]',0,'[]','[]','[{525,555}]',11740143,'1202003',0,1),(1302006,4,1302,11088,15618,0,'[]',0,2,1000,'[{1,900}]','[]','[{0,{38270012,38270023,38240001,38230207,38230402,38230404,38230106,38230408,38230110}}]','[0,38030003,1]','[{lv,400}]','[12]',0,'[]','[]','[{550,580}]',13404334,'1201004',0,2),(1302007,4,1302,3645,9908,0,'[]',0,2,1000,'[{1,900}]','[]','[{0,{38270012,38270021,38240001,38230207,38230402,38230204,38230206,38230210,38230110}}]','[0,38030003,1]','[{lv,400}]','[12]',0,'[]','[]','[{575,605}]',15015713,'1203006',0,1),(1302008,4,1302,5669,16070,0,'[]',0,2,1000,'[{1,900}]','[]','[{0,{38270011,38270022,38240001,38230107,38230102,38230104,38230106,38230210,38230410}}]','[0,38030003,1]','[{lv,400}]','[12]',0,'[]','[]','[{600,630}]',16627093,'1201003',0,2),(1303001,4,1303,12461,4496,0,'[]',0,3,1000,'[{1,900}]','[]','[{0,{38270011,38270022,38240001,38230207,38230202,38230204,38230406,38230108,38230210}}]','[0,38030003,1]','[{lv,560}]','[12]',0,'[]','[]','[{550,580}]',13404334,'1203003',0,1),(1303002,4,1303,7003,2938,0,'[]',0,3,1000,'[{1,900}]','[]','[{0,{38270012,38270023,38240001,38230407,38230202,38230104,38230106,38230408,38230110}}]','[0,38030003,1]','[{lv,560}]','[12]',0,'[]','[]','[{570,600}]',14693437,'1201004',0,1),(1303003,4,1303,16810,9443,0,'[]',0,3,1000,'[{1,900}]','[]','[{0,{38270012,38270021,38240001,38230207,38230202,38230404,38230206,38230408,38230410}}]','[0,38030003,1]','[{lv,560}]','[12]',0,'[]','[]','[{590,620}]',15982541,'1201007',0,2),(1303004,4,1303,10460,8613,0,'[]',0,3,1000,'[{1,900}]','[]','[{0,{38270011,38270022,38240001,38230107,38230402,38230204,38230406,38230110,38230210}}]','[0,38030003,1]','[{lv,560}]','[13]',0,'[]','[]','[{610,640}]',17383548,'1203011',0,3),(1303005,4,1303,21993,11578,0,'[]',0,3,1000,'[{1,900}]','[]','[{0,{38270012,38270023,38240001,38230107,38230402,38230204,38230206,38230208,38230410}}]','[0,38030003,1]','[{lv,560}]','[13]',0,'[]','[]','[{630,660}]',18896459,'1202001',0,1),(1303006,4,1303,11088,15618,0,'[]',0,3,1000,'[{1,900}]','[]','[{0,{38270012,38270021,38240001,38230207,38230102,38230204,38230406,38230408,38230210}}]','[0,38030003,1]','[{lv,560}]','[13]',0,'[]','[]','[{645,675}]',20031143,'1201002',0,2),(1303007,4,1303,3645,9908,0,'[]',0,3,1000,'[{1,900}]','[]','[{0,{38270011,38270022,38240001,38230407,38230202,38230404,38230406,38230208,38230110}}]','[0,38030003,1]','[{lv,560}]','[14]',0,'[]','[]','[{670,700}]',22107753,'1203006',0,1),(1303008,4,1303,5669,16070,0,'[]',0,3,1000,'[{1,900}]','[]','[{0,{38270012,38270023,38240001,38230107,38230102,38230404,38230106,38230110,38230210}}]','[0,38030003,1]','[{lv,560}]','[14]',0,'[]','[]','[{690,720}]',23806135,'1201003',0,2),(1304001,4,1304,12461,4496,0,'[]',0,4,1000,'[{1,900}]','[]','[{0,{38270012,38270021,38240001,38230107,38230102,38230204,38230206,38230210,38230410}}]','[0,38030003,1]','[{lv,660}]','[14]',0,'[]','[]','[{660,690}]',21258562,'1203003',0,1),(1304002,4,1304,7003,2938,0,'[]',0,4,1000,'[{1,900}]','[]','[{0,{38270011,38270022,38240001,38230107,38230402,38230404,38230206,38230208,38230210}}]','[0,38030003,1]','[{lv,660}]','[14]',0,'[]','[]','[{675,705}]',22532349,'1201004',0,2),(1304003,4,1304,16810,9443,0,'[]',0,4,1000,'[{1,900}]','[]','[{0,{38270012,38270023,38240001,38230407,38230202,38230104,38230406,38230208,38230110}}]','[0,38030003,1]','[{lv,660}]','[14]',0,'[]','[]','[{690,720}]',23806135,'1201002',0,3),(1304004,4,1304,10460,8613,0,'[]',0,4,1000,'[{1,900}]','[]','[{0,{38270012,38270021,38240001,38230407,38230202,38230204,38230406,38230408,38230410}}]','[0,38030003,1]','[{lv,660}]','[15]',0,'[]','[]','[{700,730}]',24655327,'1202005',0,1),(1304005,4,1304,21993,11578,0,'[]',0,4,1000,'[{1,900}]','[]','[{0,{38270011,38270022,38240001,38230207,38230202,38230204,38230106,38230210,38230110}}]','[0,38030003,1]','[{lv,660}]','[15]',0,'[]','[]','[{710,740}]',25423172,'1202004',0,2),(1304006,4,1304,11088,15618,0,'[]',0,4,1000,'[{1,900}]','[]','[{0,{38270012,38270023,38240001,38230407,38230402,38230104,38230206,38230210,38230110}}]','[0,38030003,1]','[{lv,660}]','[15]',0,'[]','[]','[{720,750}]',26191017,'1203004',0,3),(1304007,4,1304,3645,9908,0,'[]',0,4,1000,'[{1,900}]','[]','[{0,{38270012,38270021,38240001,38230207,38230102,38230404,38230406,38230408,38230110}}]','[0,38030003,1]','[{lv,660}]','[16]',0,'[]','[]','[{730,750}]',27726707,'1202003',0,1),(1304008,4,1304,5669,16070,0,'[]',0,4,1000,'[{1,900}]','[]','[{0,{38270011,38270022,38240001,38230107,38230402,38230104,38230206,38230208,38230110}}]','[0,38030003,1]','[{lv,660}]','[16]',0,'[]','[]','[{740,750}]',28494553,'1203009',0,2),(1341002,2,1341,2913,2886,0,'[]',0,0,1000,'[]','[{0,32000028,1},{0,15020301,1}]','[{0,{20040001,1001010442,1007040442,1002040442,1004020442,1006040442,1008020442,1010010432,1003000432}}]','[0,38030002,1]','[{vip,4},{lv,120}]','[4]',134102,'[]','[]','[{120,140}]',0,'1201001',0,3),(1341003,2,1341,2913,2886,0,'[]',0,0,1000,'[]','[{0,32000028,1},{0,15020301,1}]','[{0,{20040001,1001020542,1007020542,1002040542,1004040542,1006010542,1008020542,1010040532,1003000532}}]','[0,38030002,1]','[{vip,4},{lv,150}]','[5]',134103,'[]','[]','[{150,170}]',0,'1203001',0,3),(1341004,2,1341,2913,2886,0,'[]',0,0,1000,'[]','[{0,32000028,1},{0,15020301,1}]','[{0,{20040001,1001010542,1007020542,1002010542,1004020542,1006010542,1008040542,1010040532,1003000532}}]','[0,38030002,1]','[{vip,4},{lv,200}]','[5,6]',134104,'[]','[]','[{200,240}]',0,'1203004',0,3),(1341005,2,1341,2913,2886,0,'[]',0,0,1000,'[]','[{0,32000028,1},{0,15020301,1}]','[{0,{18041001,20040002,1001040642,1007020642,1002040642,1004020642,1006010642,1008010642,1003000632}}]','[0,38030002,1]','[{vip,4},{lv,250}]','[6,7]',134105,'[]','[]','[{250,290}]',0,'1202002',0,3),(1341006,2,1341,2913,2886,0,'[]',0,0,1000,'[]','[{0,32000028,1},{0,15020301,1}]','[{0,{18041001,20040002,1001040742,1007020742,1002040742,1004040742,1006020742,1008020742,1003000732}}]','[0,38030002,1]','[{vip,4},{lv,300}]','[7,8]',134106,'[]','[]','[{300,340}]',0,'1201008',0,3),(1341007,2,1341,2913,2886,0,'[]',0,0,1000,'[]','[{0,32000028,1},{0,15020301,1}]','[{0,{18041003,20040003,1001010842,1007010842,1002020842,1004020842,1006010842,1008040842,1003000832}}]','[0,38030002,1]','[{vip,4},{lv,350}]','[8,9]',134107,'[]','[]','[{350,390}]',0,'1201003',0,3),(1341008,2,1341,2913,2886,0,'[]',0,0,1000,'[]','[{0,32000028,1},{0,15020301,1}]','[{0,{18041003,20040003,1001040942,1007020942,1002020942,1004020942,1006020942,1010010942,1003000932}}]','[0,38030002,1]','[{vip,4},{lv,400}]','[9,10]',134108,'[]','[]','[{400,440}]',0,'1203008',0,3),(1341009,2,1341,2913,2886,0,'[]',0,0,1000,'[]','[{0,32000028,1},{0,15020301,1}]','[{0,{18041003,20040004,1001021042,1007041042,1002021042,1004041042,1006041042,1008011042,1003001032}}]','[0,38030002,1]','[{vip,4},{lv,450}]','[10,11]',134109,'[]','[]','[{450,490}]',0,'1203003',0,3),(1341010,2,1341,2913,2886,0,'[]',0,0,1000,'[]','[{0,32000028,1},{0,15020301,1}]','[{0,{18041002,20040004,1001011142,1007021142,1002041142,1004011142,1006021142,1008011142,1003001132}}]','[0,38030002,1]','[{vip,4},{lv,500}]','[11,12]',134110,'[]','[]','[{500,540}]',0,'1203010',0,3),(1341011,2,1341,2913,2886,0,'[]',0,0,1000,'[]','[{0,32000028,1},{0,15020301,1}]','[{0,{18041002,20040005,1001021242,1007021242,1002041242,1004041242,1006021242,1010011242,1003001232}}]','[0,38030002,1]','[{vip,4},{lv,550}]','[12,13]',134111,'[]','[]','[{550,590}]',0,'1202003',0,3),(1341012,2,1341,2913,2886,0,'[]',0,0,1000,'[]','[{0,32000028,1},{0,15020301,1}]','[{0,{18041002,20040005,1001041342,1007041342,1002011342,1004021342,1006011342,1008041342,1003001332}}]','[0,38030002,1]','[{vip,4},{lv,600}]','[13,14]',134112,'[]','[]','[{600,640}]',0,'1203001',0,3),(1341013,2,1341,2913,2886,0,'[]',0,0,1000,'[]','[{0,32000028,1},{0,15020301,1}]','[{0,{18041002,20040005,1001041442,1007011442,1002011442,1004041442,1006011442,1008011442,1003001432}}]','[0,38030002,1]','[{vip,4},{lv,650}]','[14,15]',134113,'[]','[]','[{650,690}]',0,'1203010',0,3),(1341014,2,1341,2913,2886,0,'[]',0,0,1000,'[]','[{0,32000028,1},{0,15020301,1}]','[{0,{18041002,20040005,1001021442,1007041442,1002021442,1004021442,1006011442,1008011442,1003001432}}]','[0,38030002,1]','[{vip,4},{lv,700}]','[14,15]',134114,'[]','[]','[{700,740}]',0,'1203003',0,3),(1341015,2,1341,2913,2886,0,'[]',0,0,1000,'[]','[{0,32000028,1},{0,15020301,1}]','[{0,{18041002,20040005,1001011542,1007041542,1002011542,1004011542,1006011542,1008021542,1003001532}}]','[0,38030002,1]','[{vip,4},{lv,750}]','[15,16]',134115,'[]','[]','[{750,790}]',0,'1201003',0,3),(1341016,2,1341,2913,2886,0,'[]',0,0,1000,'[]','[{0,32000028,1},{0,15020301,1}]','[{0,{18041002,20040005,1001011542,1007011542,1002041542,1004011542,1006021542,1008041542,1003001532}}]','[0,38030002,1]','[{vip,4},{lv,800}]','[15,16]',134117,'[]','[]','[{800,840}]',0,'1201008',0,3);
/*!40000 ALTER TABLE `base_boss_cfg` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_boss_crush_r`
--

DROP TABLE IF EXISTS `base_boss_crush_r`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_boss_crush_r` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '属性',
  `attr_r` double unsigned NOT NULL DEFAULT '0' COMMENT '属性比',
  `crush_r` double unsigned NOT NULL DEFAULT '0' COMMENT '碾压参数',
  PRIMARY KEY (`id`,`attr_r`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_boss_crush_r`
--

LOCK TABLES `base_boss_crush_r` WRITE;
/*!40000 ALTER TABLE `base_boss_crush_r` DISABLE KEYS */;
INSERT INTO `base_boss_crush_r` VALUES (1,0.02,0.15),(1,0.05,0.3),(1,0.08,0.45),(1,0.11,0.6),(1,0.14,0.75),(1,0.17,0.9),(1,0.2,1.05),(1,0.23,1.2),(1,0.26,1.35),(1,0.29,1.5),(1,0.32,1.6),(1,0.35,1.7),(1,0.38,1.8),(1,0.41,1.9),(1,0.44,2),(1,0.47,2.1),(1,0.5,2.2),(1,1,2.5),(2,0.02,0.15),(2,0.05,0.3),(2,0.08,0.45),(2,0.11,0.6),(2,0.14,0.75),(2,0.17,0.9),(2,0.2,1.05),(2,0.23,1.2),(2,0.26,1.35),(2,0.29,1.5),(2,0.32,1.6),(2,0.35,1.7),(2,0.38,1.8),(2,0.41,1.9),(2,0.44,2),(2,0.47,2.1),(2,0.5,2.2),(2,1,2.5),(3,0.02,0.15),(3,0.05,0.3),(3,0.08,0.45),(3,0.11,0.6),(3,0.14,0.75),(3,0.17,0.9),(3,0.2,1.05),(3,0.23,1.2),(3,0.26,1.35),(3,0.29,1.5),(3,0.32,1.6),(3,0.35,1.7),(3,0.38,1.8),(3,0.41,1.9),(3,0.44,2),(3,0.47,2.1),(3,0.5,2.2),(3,1,2.5),(4,0.02,0.15),(4,0.05,0.3),(4,0.08,0.45),(4,0.11,0.6),(4,0.14,0.75),(4,0.17,0.9),(4,0.2,1.05),(4,0.23,1.2),(4,0.26,1.35),(4,0.29,1.5),(4,0.32,1.6),(4,0.35,1.7),(4,0.38,1.8),(4,0.41,1.9),(4,0.44,2),(4,0.47,2.1),(4,0.5,2.2),(4,1,2.5),(5,0.02,0.15),(5,0.05,0.3),(5,0.08,0.45),(5,0.11,0.6),(5,0.14,0.75),(5,0.17,0.9),(5,0.2,1.05),(5,0.23,1.2),(5,0.26,1.35),(5,0.29,1.5),(5,0.32,1.6),(5,0.35,1.7),(5,0.38,1.8),(5,0.41,1.9),(5,0.44,2),(5,0.47,2.1),(5,0.5,2.2),(5,1,2.5),(6,0.02,0.15),(6,0.05,0.3),(6,0.08,0.45),(6,0.11,0.6),(6,0.14,0.75),(6,0.17,0.9),(6,0.2,1.05),(6,0.23,1.2),(6,0.26,1.35),(6,0.29,1.5),(6,0.32,1.6),(6,0.35,1.7),(6,0.38,1.8),(6,0.41,1.9),(6,0.44,2),(6,0.47,2.1),(6,0.5,2.2),(6,1,2.5),(7,0.02,0.15),(7,0.05,0.3),(7,0.08,0.45),(7,0.11,0.6),(7,0.14,0.75),(7,0.17,0.9),(7,0.2,1.05),(7,0.23,1.2),(7,0.26,1.35),(7,0.29,1.5),(7,0.32,1.6),(7,0.35,1.7),(7,0.38,1.8),(7,0.41,1.9),(7,0.44,2),(7,0.47,2.1),(7,0.5,2.2),(7,1,2.5),(8,0.02,0.15),(8,0.05,0.3),(8,0.08,0.45),(8,0.11,0.6),(8,0.14,0.75),(8,0.17,0.9),(8,0.2,1.05),(8,0.23,1.2),(8,0.26,1.35),(8,0.29,1.5),(8,0.32,1.6),(8,0.35,1.7),(8,0.38,1.8),(8,0.41,1.9),(8,0.44,2),(8,0.47,2.1),(8,0.5,2.2),(8,1,2.5);
/*!40000 ALTER TABLE `base_boss_crush_r` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_boss_kv`
--

DROP TABLE IF EXISTS `base_boss_kv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_boss_kv` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '键',
  `val` varchar(255) NOT NULL DEFAULT '' COMMENT '值',
  `description` varchar(50) NOT NULL DEFAULT '' COMMENT '描述',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_boss_kv`
--

LOCK TABLES `base_boss_kv` WRITE;
/*!40000 ALTER TABLE `base_boss_kv` DISABLE KEYS */;
INSERT INTO `base_boss_kv` VALUES (1,'{240100101,30,[{2,0,50}]}','诛魔之地的鼓舞:格式{技能id,上限,消耗[{类型,物品id,数量}]}'),(2,'600','离线保存时间（秒/s）'),(3,'100','原罪祭坛等级差不能攻击'),(4,'10','参与奖人数'),(5,'1202000','新手boss_id'),(6,'134116','新手boss副本id'),(7,'4','boss之家vip下限'),(8,'25','原罪boss上限上数'),(9,'10','分房boss的房间上限'),(10,'4','分房临界人数'),(11,'10','分房房间上限人数');
/*!40000 ALTER TABLE `base_boss_kv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_boss_lv_crush_r`
--

DROP TABLE IF EXISTS `base_boss_lv_crush_r`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_boss_lv_crush_r` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '序号',
  `min_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '人物等级下限',
  `max_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '人物等级上限',
  `diff_min_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '怪物-人物等级下限',
  `diff_max_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '怪物-人物等级上限',
  `crush_r` double unsigned NOT NULL DEFAULT '0' COMMENT '碾压参数',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_boss_lv_crush_r`
--

LOCK TABLES `base_boss_lv_crush_r` WRITE;
/*!40000 ALTER TABLE `base_boss_lv_crush_r` DISABLE KEYS */;
INSERT INTO `base_boss_lv_crush_r` VALUES (1,0,1000,1,5,0.05),(2,0,1000,6,10,0.1),(3,0,1000,11,15,0.2),(4,0,1000,16,20,0.4),(5,0,1000,21,25,0.8),(6,0,1000,26,26,1.2),(7,0,1000,27,27,1.6),(8,0,1000,28,28,2),(9,0,1000,29,29,3),(10,0,1000,30,30,4),(11,0,1000,31,31,6),(12,0,1000,32,32,8),(13,0,1000,33,33,10),(14,0,1000,34,34,12),(15,0,1000,35,35,15),(16,0,1000,36,40,18),(17,0,1000,41,45,21),(18,0,1000,46,50,24),(19,0,1000,51,55,26),(20,0,1000,56,60,28),(21,0,1000,61,65,30),(22,0,1000,66,70,32),(23,0,1000,71,75,34),(24,0,1000,76,80,36),(25,0,1000,81,85,38),(26,0,1000,86,90,40),(27,0,1000,91,95,42),(28,0,1000,96,100,44),(29,0,1000,101,105,46),(30,0,1000,106,1000,48);
/*!40000 ALTER TABLE `base_boss_lv_crush_r` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_boss_power_crush`
--

DROP TABLE IF EXISTS `base_boss_power_crush`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_boss_power_crush` (
  `power_r` double NOT NULL DEFAULT '0' COMMENT '战力比',
  `crush_r` double unsigned NOT NULL DEFAULT '0' COMMENT '碾压参数',
  PRIMARY KEY (`power_r`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='boss战力碾压配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_boss_power_crush`
--

LOCK TABLES `base_boss_power_crush` WRITE;
/*!40000 ALTER TABLE `base_boss_power_crush` DISABLE KEYS */;
INSERT INTO `base_boss_power_crush` VALUES (0,0),(0.05,0.05),(0.09,0.1),(0.13,0.2),(0.17,0.3),(0.2,0.45),(0.23,0.6),(0.26,0.7),(0.29,0.8),(0.31,0.9),(0.33,1),(0.35,1.1),(0.38,1.2),(0.39,1.3),(0.41,1.4),(0.43,1.5),(0.44,1.6),(0.46,1.7),(0.47,1.8),(0.49,1.9),(0.5,2),(1,2.1);
/*!40000 ALTER TABLE `base_boss_power_crush` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_boss_rank_reward`
--

DROP TABLE IF EXISTS `base_boss_rank_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_boss_rank_reward` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `boss_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'boss_id',
  `min_rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小排名',
  `max_rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大排名',
  `reward_list` varchar(512) NOT NULL DEFAULT '[]' COMMENT '奖励列表',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=536 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_boss_rank_reward`
--

LOCK TABLES `base_boss_rank_reward` WRITE;
/*!40000 ALTER TABLE `base_boss_rank_reward` DISABLE KEYS */;
INSERT INTO `base_boss_rank_reward` VALUES (1,1202001,1,1,'1|2020301:1=0;1|2020501:1=450;1|2020601:1=90;1|2020302:1=0;1|2020502:1=104;1|2020602:1=23;1|1020303:1=23;1|1020503:1=2;0|1020603:1=2;1|13:1=0;1|10:1=0;1|39:1=10000;1|1020303:1=174;1|1020503:1=22;1|165:1=10000;1|170:1=9000;4|1020101:1=6000,1020102:1=1500,1020103:1=2500;0|2020401:0=1550,1020402:1=1018,1010403:1=317,1020201:1=4100,1020202:1=1018,1010203:1=317,1020201:1=0'),(2,1202001,2,2,'1|2020301:1=0;1|2020501:1=450;1|2020601:1=90;1|2020302:1=0;1|2020502:1=97;1|2020602:1=23;1|1020303:1=22;1|1020503:1=2;0|1020603:1=2;1|13:1=0;1|10:1=0;1|39:1=10000;1|1020303:1=163;1|1020503:1=20;1|165:1=9000;1|170:1=8000;4|1020101:1=6000,1020102:1=1500,1020103:1=2500;0|2020401:0=1550,1020402:1=1018,1010403:1=317,1020201:1=4100,1020202:1=1018,1010203:1=317,1020201:1=0'),(3,1202001,3,3,'1|2020301:1=0;1|2020501:1=360;1|2020601:1=90;1|2020302:1=0;1|2020502:1=90;1|2020602:1=23;1|1020303:1=20;1|1020503:1=2;0|1020603:1=2;1|13:1=0;1|10:1=0;1|39:1=10000;1|1020303:1=151;1|1020503:1=19;1|165:1=8000;1|170:1=7000;4|1020101:1=6000,1020102:1=1500,1020103:1=2500;0|2020401:0=1550,1020402:1=1018,1010403:1=317,1020201:1=4100,1020202:1=1018,1010203:1=317,1020201:1=0'),(4,1202001,4,5,'1|2020301:1=0;1|2020501:1=270;1|2020601:1=90;1|2020302:1=0;1|2020502:1=77;1|2020602:1=23;1|1020303:1=17;1|1020503:1=2;0|1020603:1=2;1|13:1=0;1|10:1=0;1|39:1=10000;1|1020303:1=129;1|1020503:1=16;1|165:1=8000;1|170:1=7000;4|1020101:1=6000,1020102:1=1500,1020103:1=2500;0|2020401:0=1550,1020402:1=1018,1010403:1=317,1020201:1=4100,1020202:1=1018,1010203:1=317,1020201:1=0'),(5,1202001,6,10,'1|2020301:1=0;1|2020501:1=270;1|2020601:1=90;1|2020302:1=0;1|2020502:1=72;1|2020602:1=23;1|1020303:1=16;1|1020503:1=2;0|1020603:1=2;1|13:1=0;1|10:1=0;1|39:1=10000;1|1020303:1=121;1|1020503:1=15;1|165:1=8000;1|170:1=6000;4|1020101:1=6000,1020102:1=1500,1020103:1=2500;0|2020401:0=1550,1020402:1=1018,1010403:1=317,1020201:1=4100,1020202:1=1018,1010203:1=317,1020201:1=0'),(6,1202002,1,1,'1|2020301:1=0;1|2020501:1=245;1|2020601:1=49;1|2020302:1=0;1|2020502:1=56;1|2020602:1=12;1|1020303:1=13;1|1020503:1=1;0|1020603:1=1;1|13:1=0;1|10:1=0;1|39:1=10000;1|1020303:1=95;1|1020503:1=12;1|165:1=10000;1|170:1=9000;4|1020101:1=6000,1020102:1=1500,1020103:1=2500;0|2020401:0=1550,1020402:1=1018,1010403:1=317,1020201:1=4100,1020202:1=1018,1010203:1=317,1020201:1=0'),(7,1202002,2,2,'1|2020301:1=0;1|2020501:1=245;1|2020601:1=49;1|2020302:1=0;1|2020502:1=53;1|2020602:1=12;1|1020303:1=12;1|1020503:1=1;0|1020603:1=1;1|13:1=0;1|10:1=0;1|39:1=10000;1|1020303:1=89;1|1020503:1=11;1|165:1=9000;1|170:1=8000;4|1020101:1=6000,1020102:1=1500,1020103:1=2500;0|2020401:0=1550,1020402:1=1018,1010403:1=317,1020201:1=4100,1020202:1=1018,1010203:1=317,1020201:1=0'),(8,1202002,3,3,'1|2020301:1=0;1|2020501:1=196;1|2020601:1=49;1|2020302:1=0;1|2020502:1=49;1|2020602:1=12;1|1020303:1=11;1|1020503:1=1;0|1020603:1=1;1|13:1=0;1|10:1=0;1|39:1=10000;1|1020303:1=82;1|1020503:1=10;1|165:1=8000;1|170:1=7000;4|1020101:1=6000,1020102:1=1500,1020103:1=2500;0|2020401:0=1550,1020402:1=1018,1010403:1=317,1020201:1=4100,1020202:1=1018,1010203:1=317,1020201:1=0'),(9,1202002,4,5,'1|2020301:1=0;1|2020501:1=147;1|2020601:1=49;1|2020302:1=0;1|2020502:1=42;1|2020602:1=12;1|1020303:1=9;1|1020503:1=1;0|1020603:1=1;1|13:1=0;1|10:1=0;1|39:1=10000;1|1020303:1=70;1|1020503:1=9;1|165:1=8000;1|170:1=7000;4|1020101:1=6000,1020102:1=1500,1020103:1=2500;0|2020401:0=1550,1020402:1=1018,1010403:1=317,1020201:1=4100,1020202:1=1018,1010203:1=317,1020201:1=0'),(10,1202002,6,10,'1|2020301:1=0;1|2020501:1=147;1|2020601:1=49;1|2020302:1=0;1|2020502:1=39;1|2020602:1=12;1|1020303:1=9;1|1020503:1=1;0|1020603:1=1;1|13:1=0;1|10:1=0;1|39:1=10000;1|1020303:1=66;1|1020503:1=8;1|165:1=8000;1|170:1=6000;4|1020101:1=6000,1020102:1=1500,1020103:1=2500;0|2020401:0=1550,1020402:1=1018,1010403:1=317,1020201:1=4100,1020202:1=1018,1010203:1=317,1020201:1=0'),(11,1202003,1,1,'1|2020301:1=0;1|2020501:1=530;1|2020601:1=106;1|2020302:1=0;1|2020502:1=122;1|2020602:1=27;1|1020303:1=27;1|1020503:1=3;0|1020603:1=2;1|13:1=0;1|10:1=0;3|39:1=10000;1|1020303:1=205;1|1020503:1=26;1|165:1=10000;1|170:1=9000;4|1020101:1=6000,1020102:1=1500,1020103:1=2500;0|2020401:0=1550,1020402:1=1018,1010403:1=317,1020201:1=4100,1020202:1=1018,1010203:1=317,1020201:1=0'),(12,1202003,2,2,'1|2020301:1=0;1|2020501:1=530;1|2020601:1=106;1|2020302:1=0;1|2020502:1=114;1|2020602:1=27;1|1020303:1=26;1|1020503:1=3;0|1020603:1=2;1|13:1=0;1|10:1=0;3|39:1=10000;1|1020303:1=192;1|1020503:1=24;1|165:1=9000;1|170:1=8000;4|1020101:1=6000,1020102:1=1500,1020103:1=2500;0|2020401:0=1550,1020402:1=1018,1010403:1=317,1020201:1=4100,1020202:1=1018,1010203:1=317,1020201:1=0'),(13,1202003,3,3,'1|2020301:1=0;1|2020501:1=424;1|2020601:1=106;1|2020302:1=0;1|2020502:1=106;1|2020602:1=27;1|1020303:1=24;1|1020503:1=2;0|1020603:1=2;1|13:1=0;1|10:1=0;2|39:1=10000;1|1020303:1=178;1|1020503:1=22;1|165:1=8000;1|170:1=7000;4|1020101:1=6000,1020102:1=1500,1020103:1=2500;0|2020401:0=1550,1020402:1=1018,1010403:1=317,1020201:1=4100,1020202:1=1018,1010203:1=317,1020201:1=0'),(14,1202003,4,5,'1|2020301:1=0;1|2020501:1=318;1|2020601:1=106;1|2020302:1=0;1|2020502:1=90;1|2020602:1=27;1|1020303:1=20;1|1020503:1=2;0|1020603:1=2;1|13:1=0;1|10:1=0;2|39:1=10000;1|1020303:1=151;1|1020503:1=19;1|165:1=8000;1|170:1=7000;4|1020101:1=6000,1020102:1=1500,1020103:1=2500;0|2020401:0=1550,1020402:1=1018,1010403:1=317,1020201:1=4100,1020202:1=1018,1010203:1=317,1020201:1=0'),(15,1202003,6,10,'1|2020301:1=0;1|2020501:1=318;1|2020601:1=106;1|2020302:1=0;1|2020502:1=85;1|2020602:1=27;1|1020303:1=19;1|1020503:1=2;0|1020603:1=2;1|13:1=0;1|10:1=0;2|39:1=10000;1|1020303:1=142;1|1020503:1=18;1|165:1=8000;1|170:1=6000;4|1020101:1=6000,1020102:1=1500,1020103:1=2500;0|2020401:0=1550,1020402:1=1018,1010403:1=317,1020201:1=4100,1020202:1=1018,1010203:1=317,1020201:1=0'),(16,1202004,1,1,'1|2020301:1=0;1|2020501:1=570;1|2020601:1=114;1|2020302:1=0;1|2020502:1=131;1|2020602:1=29;1|1020303:1=29;1|1020503:1=3;0|1020603:1=2;1|13:1=0;1|10:1=0;3|39:1=10000;1|1020303:1=220;1|1020503:1=28;1|165:1=10000;1|170:1=9000;4|1020101:1=6000,1020102:1=1500,1020103:1=2500;0|2020401:0=1550,1020402:1=1018,1010403:1=317,1020201:1=4100,1020202:1=1018,1010203:1=317,1020201:1=0'),(17,1202004,2,2,'1|2020301:1=0;1|2020501:1=570;1|2020601:1=114;1|2020302:1=0;1|2020502:1=123;1|2020602:1=29;1|1020303:1=28;1|1020503:1=3;0|1020603:1=2;1|13:1=0;1|10:1=0;3|39:1=10000;1|1020303:1=207;1|1020503:1=26;1|165:1=9000;1|170:1=8000;4|1020101:1=6000,1020102:1=1500,1020103:1=2500;0|2020401:0=1550,1020402:1=1018,1010403:1=317,1020201:1=4100,1020202:1=1018,1010203:1=317,1020201:1=0'),(18,1202004,3,3,'1|2020301:1=0;1|2020501:1=456;1|2020601:1=114;1|2020302:1=0;1|2020502:1=114;1|2020602:1=29;1|1020303:1=26;1|1020503:1=3;0|1020603:1=2;1|13:1=0;1|10:1=0;3|39:1=10000;1|1020303:1=192;1|1020503:1=24;1|165:1=8000;1|170:1=7000;4|1020101:1=6000,1020102:1=1500,1020103:1=2500;0|2020401:0=1550,1020402:1=1018,1010403:1=317,1020201:1=4100,1020202:1=1018,1010203:1=317,1020201:1=0'),(19,1202004,4,5,'1|2020301:1=0;1|2020501:1=342;1|2020601:1=114;1|2020302:1=0;1|2020502:1=97;1|2020602:1=29;1|1020303:1=22;1|1020503:1=2;0|1020603:1=2;1|13:1=0;1|10:1=0;2|39:1=10000;1|1020303:1=163;1|1020503:1=20;1|165:1=8000;1|170:1=7000;4|1020101:1=6000,1020102:1=1500,1020103:1=2500;0|2020401:0=1550,1020402:1=1018,1010403:1=317,1020201:1=4100,1020202:1=1018,1010203:1=317,1020201:1=0'),(20,1202004,6,10,'1|2020301:1=0;1|2020501:1=342;1|2020601:1=114;1|2020302:1=0;1|2020502:1=91;1|2020602:1=29;1|1020303:1=21;1|1020503:1=2;0|1020603:1=2;1|13:1=0;1|10:1=0;2|39:1=10000;1|1020303:1=153;1|1020503:1=19;1|165:1=8000;1|170:1=6000;4|1020101:1=6000,1020102:1=1500,1020103:1=2500;0|2020401:0=1550,1020402:1=1018,1010403:1=317,1020201:1=4100,1020202:1=1018,1010203:1=317,1020201:1=0'),(21,1202005,1,1,'1|2020301:1=0;1|2020501:1=305;1|2020601:1=61;1|2020302:1=0;1|2020502:1=70;1|2020602:1=15;1|1020303:1=16;1|1020503:1=2;0|1020603:1=1;1|13:1=0;1|10:1=0;4|39:1=10000;1|1020303:1=118;1|1020503:1=15;1|165:1=10000;1|170:1=9000;4|1020101:1=6000,1020102:1=1500,1020103:1=2500;0|2020401:0=1550,1020402:1=1018,1010403:1=317,1020201:1=4100,1020202:1=1018,1010203:1=317,1020201:1=0'),(22,1202005,2,2,'1|2020301:1=0;1|2020501:1=305;1|2020601:1=61;1|2020302:1=0;1|2020502:1=66;1|2020602:1=15;1|1020303:1=15;1|1020503:1=1;0|1020603:1=1;1|13:1=0;1|10:1=0;3|39:1=10000;1|1020303:1=111;1|1020503:1=14;1|165:1=9000;1|170:1=8000;4|1020101:1=6000,1020102:1=1500,1020103:1=2500;0|2020401:0=1550,1020402:1=1018,1010403:1=317,1020201:1=4100,1020202:1=1018,1010203:1=317,1020201:1=0'),(23,1202005,3,3,'1|2020301:1=0;1|2020501:1=244;1|2020601:1=61;1|2020302:1=0;1|2020502:1=61;1|2020602:1=15;1|1020303:1=14;1|1020503:1=1;0|1020603:1=1;1|13:1=0;1|10:1=0;3|39:1=10000;1|1020303:1=102;1|1020503:1=13;1|165:1=8000;1|170:1=7000;4|1020101:1=6000,1020102:1=1500,1020103:1=2500;0|2020401:0=1550,1020402:1=1018,1010403:1=317,1020201:1=4100,1020202:1=1018,1010203:1=317,1020201:1=0'),(24,1202005,4,5,'1|2020301:1=0;1|2020501:1=183;1|2020601:1=61;1|2020302:1=0;1|2020502:1=52;1|2020602:1=15;1|1020303:1=12;1|1020503:1=1;0|1020603:1=1;1|13:1=0;1|10:1=0;2|39:1=10000;1|1020303:1=87;1|1020503:1=11;1|165:1=8000;1|170:1=7000;4|1020101:1=6000,1020102:1=1500,1020103:1=2500;0|2020401:0=1550,1020402:1=1018,1010403:1=317,1020201:1=4100,1020202:1=1018,1010203:1=317,1020201:1=0'),(25,1202005,6,10,'1|2020301:1=0;1|2020501:1=183;1|2020601:1=61;1|2020302:1=0;1|2020502:1=49;1|2020602:1=15;1|1020303:1=11;1|1020503:1=1;0|1020603:1=1;1|13:1=0;1|10:1=0;2|39:1=10000;1|1020303:1=82;1|1020503:1=10;1|165:1=8000;1|170:1=6000;4|1020101:1=6000,1020102:1=1500,1020103:1=2500;0|2020401:0=1550,1020402:1=1018,1010403:1=317,1020201:1=4100,1020202:1=1018,1010203:1=317,1020201:1=0'),(26,1202006,1,1,'1|2020301:1=0;1|2020501:1=650;1|2020601:1=130;1|2020302:1=0;1|2020502:1=150;1|2020602:1=33;1|1020303:1=34;1|1020503:1=3;0|1020603:1=2;1|13:1=0;1|10:1=0;4|39:1=10000;1|1020303:1=251;1|1020503:1=31;1|165:1=10000;1|170:1=9000;4|1020101:1=6000,1020102:1=1500,1020103:1=2500;0|2020401:0=1550,1020402:1=1018,1010403:1=317,1020201:1=4100,1020202:1=1018,1010203:1=317,1020201:1=0'),(27,1202006,2,2,'1|2020301:1=0;1|2020501:1=650;1|2020601:1=130;1|2020302:1=0;1|2020502:1=140;1|2020602:1=33;1|1020303:1=32;1|1020503:1=3;0|1020603:1=2;1|13:1=0;1|10:1=0;4|39:1=10000;1|1020303:1=236;1|1020503:1=29;1|165:1=9000;1|170:1=8000;4|1020101:1=6000,1020102:1=1500,1020103:1=2500;0|2020401:0=1550,1020402:1=1018,1010403:1=317,1020201:1=4100,1020202:1=1018,1010203:1=317,1020201:1=0'),(28,1202006,3,3,'1|2020301:1=0;1|2020501:1=520;1|2020601:1=130;1|2020302:1=0;1|2020502:1=130;1|2020602:1=33;1|1020303:1=29;1|1020503:1=3;0|1020603:1=2;1|13:1=0;1|10:1=0;3|39:1=10000;1|1020303:1=218;1|1020503:1=27;1|165:1=8000;1|170:1=7000;4|1020101:1=6000,1020102:1=1500,1020103:1=2500;0|2020401:0=1550,1020402:1=1018,1010403:1=317,1020201:1=4100,1020202:1=1018,1010203:1=317,1020201:1=0'),(29,1202006,4,5,'1|2020301:1=0;1|2020501:1=390;1|2020601:1=130;1|2020302:1=0;1|2020502:1=111;1|2020602:1=33;1|1020303:1=25;1|1020503:1=2;0|1020603:1=2;1|13:1=0;1|10:1=0;3|39:1=10000;1|1020303:1=186;1|1020503:1=23;1|165:1=8000;1|170:1=7000;4|1020101:1=6000,1020102:1=1500,1020103:1=2500;0|2020401:0=1550,1020402:1=1018,1010403:1=317,1020201:1=4100,1020202:1=1018,1010203:1=317,1020201:1=0'),(30,1202006,6,10,'1|2020301:1=0;1|2020501:1=390;1|2020601:1=130;1|2020302:1=0;1|2020502:1=104;1|2020602:1=33;1|1020303:1=23;1|1020503:1=2;0|1020603:1=2;1|13:1=0;1|10:1=0;2|39:1=10000;1|1020303:1=175;1|1020503:1=22;1|165:1=8000;1|170:1=6000;4|1020101:1=6000,1020102:1=1500,1020103:1=2500;0|2020401:0=1550,1020402:1=1018,1010403:1=317,1020201:1=4100,1020202:1=1018,1010203:1=317,1020201:1=0'),(31,1203001,1,1,'1|2030301:1=0;1|2030501:1=450;1|2030601:1=90;1|2030302:1=0;1|2030502:1=104;1|2030602:1=23;1|1030303:1=23;1|1030503:1=2;0|1030603:1=2;1|13:1=0;1|10:1=0;7|39:1=10000;1|1020303:1=174;1|1020503:1=22;1|166:1=8000;1|171:1=7000;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;0|2030401:0=1563,1030402:1=981,1020403:1=306,1030201:1=4366,1030202:1=981,1020203:1=306,1030201:1=0'),(32,1203001,2,2,'1|2030301:1=0;1|2030501:1=450;1|2030601:1=90;1|2030302:1=0;1|2030502:1=97;1|2030602:1=23;1|1030303:1=22;1|1030503:1=2;0|1030603:1=2;1|13:1=0;1|10:1=0;6|39:1=10000;1|1020303:1=163;1|1020503:1=20;1|166:1=7500;1|171:1=6500;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;0|2030401:0=1563,1030402:1=981,1020403:1=306,1030201:1=4366,1030202:1=981,1020203:1=306,1030201:1=0'),(33,1203001,3,3,'1|2030301:1=0;1|2030501:1=360;1|2030601:1=90;1|2030302:1=0;1|2030502:1=90;1|2030602:1=23;1|1030303:1=20;1|1030503:1=2;0|1030603:1=2;1|13:1=0;1|10:1=0;5|39:1=10000;1|1020303:1=151;1|1020503:1=19;1|166:1=7000;1|171:1=6000;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;0|2030401:0=1563,1030402:1=981,1020403:1=306,1030201:1=4366,1030202:1=981,1020203:1=306,1030201:1=0'),(34,1203001,4,5,'1|2030301:1=0;1|2030501:1=270;1|2030601:1=90;1|2030302:1=0;1|2030502:1=77;1|2030602:1=23;1|1030303:1=17;1|1030503:1=2;0|1030603:1=2;1|13:1=0;1|10:1=0;5|39:1=10000;1|1020303:1=129;1|1020503:1=16;1|166:1=6000;1|171:1=6000;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;0|2030401:0=1563,1030402:1=981,1020403:1=306,1030201:1=4366,1030202:1=981,1020203:1=306,1030201:1=0'),(35,1203001,6,10,'1|2030301:1=0;1|2030501:1=270;1|2030601:1=90;1|2030302:1=0;1|2030502:1=72;1|2030602:1=23;1|1030303:1=16;1|1030503:1=2;0|1030603:1=2;1|13:1=0;1|10:1=0;4|39:1=10000;1|1020303:1=121;1|1020503:1=15;1|166:1=6000;1|171:1=5000;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;0|2030401:0=1563,1030402:1=981,1020403:1=306,1030201:1=4366,1030202:1=981,1020203:1=306,1030201:1=0'),(36,1203002,1,1,'1|2030301:1=0;1|2030501:1=245;1|2030601:1=49;1|2030302:1=0;1|2030502:1=56;1|2030602:1=12;1|1030303:1=13;1|1030503:1=1;0|1030603:1=1;1|13:1=0;1|10:1=0;8|39:1=10000;1|1020303:1=95;1|1020503:1=12;1|166:1=8000;1|171:1=7000;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;0|2030401:0=1563,1030402:1=981,1020403:1=306,1030201:1=4366,1030202:1=981,1020203:1=306,1030201:1=0'),(37,1203002,2,2,'1|2030301:1=0;1|2030501:1=245;1|2030601:1=49;1|2030302:1=0;1|2030502:1=53;1|2030602:1=12;1|1030303:1=12;1|1030503:1=1;0|1030603:1=1;1|13:1=0;1|10:1=0;7|39:1=10000;1|1020303:1=89;1|1020503:1=11;1|166:1=7500;1|171:1=6500;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;0|2030401:0=1563,1030402:1=981,1020403:1=306,1030201:1=4366,1030202:1=981,1020203:1=306,1030201:1=0'),(38,1203002,3,3,'1|2030301:1=0;1|2030501:1=196;1|2030601:1=49;1|2030302:1=0;1|2030502:1=49;1|2030602:1=12;1|1030303:1=11;1|1030503:1=1;0|1030603:1=1;1|13:1=0;1|10:1=0;6|39:1=10000;1|1020303:1=82;1|1020503:1=10;1|166:1=7000;1|171:1=6000;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;0|2030401:0=1563,1030402:1=981,1020403:1=306,1030201:1=4366,1030202:1=981,1020203:1=306,1030201:1=0'),(39,1203002,4,5,'1|2030301:1=0;1|2030501:1=147;1|2030601:1=49;1|2030302:1=0;1|2030502:1=42;1|2030602:1=12;1|1030303:1=9;1|1030503:1=1;0|1030603:1=1;1|13:1=0;1|10:1=0;5|39:1=10000;1|1020303:1=70;1|1020503:1=9;1|166:1=6000;1|171:1=6000;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;0|2030401:0=1563,1030402:1=981,1020403:1=306,1030201:1=4366,1030202:1=981,1020203:1=306,1030201:1=0'),(40,1203002,6,10,'1|2030301:1=0;1|2030501:1=147;1|2030601:1=49;1|2030302:1=0;1|2030502:1=39;1|2030602:1=12;1|1030303:1=9;1|1030503:1=1;0|1030603:1=1;1|13:1=0;1|10:1=0;5|39:1=10000;1|1020303:1=66;1|1020503:1=8;1|166:1=6000;1|171:1=5000;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;0|2030401:0=1563,1030402:1=981,1020403:1=306,1030201:1=4366,1030202:1=981,1020203:1=306,1030201:1=0'),(41,1203003,1,1,'1|2030301:1=0;1|2030501:1=530;1|2030601:1=106;1|2030302:1=0;1|2030502:1=122;1|2030602:1=27;1|1030303:1=27;1|1030503:1=3;0|1030603:1=2;1|13:1=0;1|10:1=0;1|42:1=10000;1|1020303:1=205;1|1020503:1=26;1|166:1=8000;1|171:1=7000;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;0|2030401:0=1563,1030402:1=981,1020403:1=306,1030201:1=4366,1030202:1=981,1020203:1=306,1030201:1=0'),(42,1203003,2,2,'1|2030301:1=0;1|2030501:1=530;1|2030601:1=106;1|2030302:1=0;1|2030502:1=114;1|2030602:1=27;1|1030303:1=26;1|1030503:1=3;0|1030603:1=2;1|13:1=0;1|10:1=0;9|39:1=10000;1|1020303:1=192;1|1020503:1=24;1|166:1=7500;1|171:1=6500;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;0|2030401:0=1563,1030402:1=981,1020403:1=306,1030201:1=4366,1030202:1=981,1020203:1=306,1030201:1=0'),(43,1203003,3,3,'1|2030301:1=0;1|2030501:1=424;1|2030601:1=106;1|2030302:1=0;1|2030502:1=106;1|2030602:1=27;1|1030303:1=24;1|1030503:1=2;0|1030603:1=2;1|13:1=0;1|10:1=0;8|39:1=10000;1|1020303:1=178;1|1020503:1=22;1|166:1=7000;1|171:1=6000;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;0|2030401:0=1563,1030402:1=981,1020403:1=306,1030201:1=4366,1030202:1=981,1020203:1=306,1030201:1=0'),(44,1203003,4,5,'1|2030301:1=0;1|2030501:1=318;1|2030601:1=106;1|2030302:1=0;1|2030502:1=90;1|2030602:1=27;1|1030303:1=20;1|1030503:1=2;0|1030603:1=2;1|13:1=0;1|10:1=0;7|39:1=10000;1|1020303:1=151;1|1020503:1=19;1|166:1=6000;1|171:1=6000;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;0|2030401:0=1563,1030402:1=981,1020403:1=306,1030201:1=4366,1030202:1=981,1020203:1=306,1030201:1=0'),(45,1203003,6,10,'1|2030301:1=0;1|2030501:1=318;1|2030601:1=106;1|2030302:1=0;1|2030502:1=85;1|2030602:1=27;1|1030303:1=19;1|1030503:1=2;0|1030603:1=2;1|13:1=0;1|10:1=0;6|39:1=10000;1|1020303:1=142;1|1020503:1=18;1|166:1=6000;1|171:1=5000;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;0|2030401:0=1563,1030402:1=981,1020403:1=306,1030201:1=4366,1030202:1=981,1020203:1=306,1030201:1=0'),(46,1203004,1,1,'1|2030301:1=0;1|2030501:1=570;1|2030601:1=114;1|2030302:1=0;1|2030502:1=131;1|2030602:1=29;1|1030303:1=29;1|1030503:1=3;0|1030603:1=2;1|13:1=0;1|10:1=0;1|42:1=10000;2|39:1=10000;1|1020303:1=220;1|1020503:1=28;1|166:1=8000;1|171:1=7000;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;0|2030401:0=1563,1030402:1=981,1020403:1=306,1030201:1=4366,1030202:1=981,1020203:1=306,1030201:1=0'),(47,1203004,2,2,'1|2030301:1=0;1|2030501:1=570;1|2030601:1=114;1|2030302:1=0;1|2030502:1=123;1|2030602:1=29;1|1030303:1=28;1|1030503:1=3;0|1030603:1=2;1|13:1=0;1|10:1=0;1|42:1=10000;1|1020303:1=207;1|1020503:1=26;1|166:1=7500;1|171:1=6500;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;0|2030401:0=1563,1030402:1=981,1020403:1=306,1030201:1=4366,1030202:1=981,1020203:1=306,1030201:1=0'),(48,1203004,3,3,'1|2030301:1=0;1|2030501:1=456;1|2030601:1=114;1|2030302:1=0;1|2030502:1=114;1|2030602:1=29;1|1030303:1=26;1|1030503:1=3;0|1030603:1=2;1|13:1=0;1|10:1=0;9|39:1=10000;1|1020303:1=192;1|1020503:1=24;1|166:1=7000;1|171:1=6000;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;0|2030401:0=1563,1030402:1=981,1020403:1=306,1030201:1=4366,1030202:1=981,1020203:1=306,1030201:1=0'),(49,1203004,4,5,'1|2030301:1=0;1|2030501:1=342;1|2030601:1=114;1|2030302:1=0;1|2030502:1=97;1|2030602:1=29;1|1030303:1=22;1|1030503:1=2;0|1030603:1=2;1|13:1=0;1|10:1=0;8|39:1=10000;1|1020303:1=163;1|1020503:1=20;1|166:1=6000;1|171:1=6000;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;0|2030401:0=1563,1030402:1=981,1020403:1=306,1030201:1=4366,1030202:1=981,1020203:1=306,1030201:1=0'),(50,1203004,6,10,'1|2030301:1=0;1|2030501:1=342;1|2030601:1=114;1|2030302:1=0;1|2030502:1=91;1|2030602:1=29;1|1030303:1=21;1|1030503:1=2;0|1030603:1=2;1|13:1=0;1|10:1=0;7|39:1=10000;1|1020303:1=153;1|1020503:1=19;1|166:1=6000;1|171:1=5000;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;0|2030401:0=1563,1030402:1=981,1020403:1=306,1030201:1=4366,1030202:1=981,1020203:1=306,1030201:1=0'),(51,1203005,1,1,'1|2030301:1=0;1|2030501:1=305;1|2030601:1=61;1|2030302:1=0;1|2030502:1=70;1|2030602:1=15;1|1030303:1=16;1|1030503:1=2;0|1030603:1=1;1|13:1=0;1|10:1=0;3|41:1=10000;1|39:1=10000;1|1020303:1=118;1|1020503:1=15;1|166:1=8000;1|171:1=7000;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;0|2030401:0=1563,1030402:1=981,1020403:1=306,1030201:1=4366,1030202:1=981,1020203:1=306,1030201:1=0'),(52,1203005,2,2,'1|2030301:1=0;1|2030501:1=305;1|2030601:1=61;1|2030302:1=0;1|2030502:1=66;1|2030602:1=15;1|1030303:1=15;1|1030503:1=1;0|1030603:1=1;1|13:1=0;1|10:1=0;3|41:1=10000;1|1020303:1=111;1|1020503:1=14;1|166:1=7500;1|171:1=6500;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;0|2030401:0=1563,1030402:1=981,1020403:1=306,1030201:1=4366,1030202:1=981,1020203:1=306,1030201:1=0'),(53,1203005,3,3,'1|2030301:1=0;1|2030501:1=244;1|2030601:1=61;1|2030302:1=0;1|2030502:1=61;1|2030602:1=15;1|1030303:1=14;1|1030503:1=1;0|1030603:1=1;1|13:1=0;1|10:1=0;2|41:1=10000;3|39:1=10000;1|1020303:1=102;1|1020503:1=13;1|166:1=7000;1|171:1=6000;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;0|2030401:0=1563,1030402:1=981,1020403:1=306,1030201:1=4366,1030202:1=981,1020203:1=306,1030201:1=0'),(54,1203005,4,5,'1|2030301:1=0;1|2030501:1=183;1|2030601:1=61;1|2030302:1=0;1|2030502:1=52;1|2030602:1=15;1|1030303:1=12;1|1030503:1=1;0|1030603:1=1;1|13:1=0;1|10:1=0;1|42:1=10000;1|39:1=10000;1|1020303:1=87;1|1020503:1=11;1|166:1=6000;1|171:1=6000;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;0|2030401:0=1563,1030402:1=981,1020403:1=306,1030201:1=4366,1030202:1=981,1020203:1=306,1030201:1=0'),(55,1203005,6,10,'1|2030301:1=0;1|2030501:1=183;1|2030601:1=61;1|2030302:1=0;1|2030502:1=49;1|2030602:1=15;1|1030303:1=11;1|1030503:1=1;0|1030603:1=1;1|13:1=0;1|10:1=0;1|42:1=10000;1|1020303:1=82;1|1020503:1=10;1|166:1=6000;1|171:1=5000;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;0|2030401:0=1563,1030402:1=981,1020403:1=306,1030201:1=4366,1030202:1=981,1020203:1=306,1030201:1=0'),(56,1203006,1,1,'1|2030301:1=0;1|2030501:1=650;1|2030601:1=130;1|2030302:1=0;1|2030502:1=150;1|2030602:1=33;1|1030303:1=34;1|1030503:1=3;0|1030603:1=2;1|13:1=0;1|10:1=0;2|42:1=10000;3|39:1=10000;1|1020303:1=251;1|1020503:1=31;1|166:1=8000;1|171:1=7000;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;0|2030401:0=1563,1030402:1=981,1020403:1=306,1030201:1=4366,1030202:1=981,1020203:1=306,1030201:1=0'),(57,1203006,2,2,'1|2030301:1=0;1|2030501:1=650;1|2030601:1=130;1|2030302:1=0;1|2030502:1=140;1|2030602:1=33;1|1030303:1=32;1|1030503:1=3;0|1030603:1=2;1|13:1=0;1|10:1=0;2|42:1=10000;1|39:1=10000;1|1020303:1=236;1|1020503:1=29;1|166:1=7500;1|171:1=6500;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;0|2030401:0=1563,1030402:1=981,1020403:1=306,1030201:1=4366,1030202:1=981,1020203:1=306,1030201:1=0'),(58,1203006,3,3,'1|2030301:1=0;1|2030501:1=520;1|2030601:1=130;1|2030302:1=0;1|2030502:1=130;1|2030602:1=33;1|1030303:1=29;1|1030503:1=3;0|1030603:1=2;1|13:1=0;1|10:1=0;1|42:1=10000;4|40:1=10000;1|1020303:1=218;1|1020503:1=27;1|166:1=7000;1|171:1=6000;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;0|2030401:0=1563,1030402:1=981,1020403:1=306,1030201:1=4366,1030202:1=981,1020203:1=306,1030201:1=0'),(59,1203006,4,5,'1|2030301:1=0;1|2030501:1=390;1|2030601:1=130;1|2030302:1=0;1|2030502:1=111;1|2030602:1=33;1|1030303:1=25;1|1030503:1=2;0|1030603:1=2;1|13:1=0;1|10:1=0;1|42:1=10000;3|40:1=10000;1|1020303:1=186;1|1020503:1=23;1|166:1=6000;1|171:1=6000;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;0|2030401:0=1563,1030402:1=981,1020403:1=306,1030201:1=4366,1030202:1=981,1020203:1=306,1030201:1=0'),(60,1203006,6,10,'1|2030301:1=0;1|2030501:1=390;1|2030601:1=130;1|2030302:1=0;1|2030502:1=104;1|2030602:1=33;1|1030303:1=23;1|1030503:1=2;0|1030603:1=2;1|13:1=0;1|10:1=0;1|42:1=10000;2|40:1=10000;1|1020303:1=175;1|1020503:1=22;1|166:1=6000;1|171:1=5000;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;0|2030401:0=1563,1030402:1=981,1020403:1=306,1030201:1=4366,1030202:1=981,1020203:1=306,1030201:1=0'),(61,1204001,1,1,'1|2040301:1=0;1|2040501:1=405;1|2040601:1=90;1|2040302:1=0;1|2040502:1=62;1|2040602:1=9;1|1040303:1=75;1|1040503:1=9;0|1040603:1=1;1|13:1=0;1|10:1=0;3|42:1=10000;1|40:1=10000;1|1030303:1=174;1|1030503:1=22;1|167:1=6000;1|172:1=5000;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;0|1040401:0=1577,1040402:1=943,1030403:1=294,1040201:1=4628,1040202:1=943,1030203:1=294,1040201:1=0'),(62,1204001,2,2,'1|2040301:1=0;1|2040501:1=360;1|2040601:1=90;1|2040302:1=0;1|2040502:1=58;1|2040602:1=9;1|1040303:1=70;1|1040503:1=9;0|1040603:1=1;1|13:1=0;1|10:1=0;2|42:1=10000;4|40:1=10000;1|1030303:1=163;1|1030503:1=20;1|167:1=5000;1|172:1=4500;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;0|1040401:0=1577,1040402:1=943,1030403:1=294,1040201:1=4628,1040202:1=943,1030203:1=294,1040201:1=0'),(63,1204001,3,3,'1|2040301:1=0;1|2040501:1=315;1|2040601:1=90;1|2040302:1=0;1|2040502:1=54;1|2040602:1=9;1|1040303:1=65;1|1040503:1=8;0|1040603:1=1;1|13:1=0;1|10:1=0;2|42:1=10000;3|40:1=10000;1|1030303:1=151;1|1030503:1=19;1|167:1=4500;1|172:1=4000;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;0|1040401:0=1577,1040402:1=943,1030403:1=294,1040201:1=4628,1040202:1=943,1030203:1=294,1040201:1=0'),(64,1204001,4,5,'1|2040301:1=0;1|2040501:1=270;1|2040601:1=81;1|2040302:1=0;1|2040502:1=46;1|2040602:1=9;1|1040303:1=55;1|1040503:1=7;0|1040603:1=1;1|13:1=0;1|10:1=0;2|42:1=10000;1|40:1=10000;1|1030303:1=129;1|1030503:1=16;1|167:1=4000;1|172:1=3500;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;0|1040401:0=1577,1040402:1=943,1030403:1=294,1040201:1=4628,1040202:1=943,1030203:1=294,1040201:1=0'),(65,1204001,6,10,'1|2040301:1=0;1|2040501:1=225;1|2040601:1=72;1|2040302:1=0;1|2040502:1=43;1|2040602:1=9;1|1040303:1=52;1|1040503:1=6;0|1040603:1=1;1|13:1=0;1|10:1=0;2|42:1=10000;1|1030303:1=121;1|1030503:1=15;1|167:1=3500;1|172:1=3000;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;0|1040401:0=1577,1040402:1=943,1030403:1=294,1040201:1=4628,1040202:1=943,1030203:1=294,1040201:1=0'),(66,1204002,1,1,'1|2040301:1=0;1|2040501:1=441;1|2040601:1=98;1|2040302:1=0;1|2040502:1=68;1|2040602:1=10;1|1040303:1=81;1|1040503:1=10;0|1040603:1=1;1|13:1=0;1|10:1=0;3|42:1=10000;4|40:1=10000;1|1030303:1=189;1|1030503:1=24;1|167:1=6000;1|172:1=5000;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;0|1040401:0=1577,1040402:1=943,1030403:1=294,1040201:1=4628,1040202:1=943,1030203:1=294,1040201:1=0'),(67,1204002,2,2,'1|2040301:1=0;1|2040501:1=392;1|2040601:1=98;1|2040302:1=0;1|2040502:1=64;1|2040602:1=10;1|1040303:1=76;1|1040503:1=10;0|1040603:1=1;1|13:1=0;1|10:1=0;3|42:1=10000;2|40:1=10000;1|1030303:1=178;1|1030503:1=22;1|167:1=5000;1|172:1=4500;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;0|1040401:0=1577,1040402:1=943,1030403:1=294,1040201:1=4628,1040202:1=943,1030203:1=294,1040201:1=0'),(68,1204002,3,3,'1|2040301:1=0;1|2040501:1=343;1|2040601:1=98;1|2040302:1=0;1|2040502:1=59;1|2040602:1=10;1|1040303:1=71;1|1040503:1=9;0|1040603:1=1;1|13:1=0;1|10:1=0;3|42:1=10000;1|1030303:1=165;1|1030503:1=21;1|167:1=4500;1|172:1=4000;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;0|1040401:0=1577,1040402:1=943,1030403:1=294,1040201:1=4628,1040202:1=943,1030203:1=294,1040201:1=0'),(69,1204002,4,5,'1|2040301:1=0;1|2040501:1=294;1|2040601:1=88;1|2040302:1=0;1|2040502:1=50;1|2040602:1=10;1|1040303:1=60;1|1040503:1=7;0|1040603:1=1;1|13:1=0;1|10:1=0;2|42:1=10000;3|40:1=10000;1|1030303:1=140;1|1030503:1=17;1|167:1=4000;1|172:1=3500;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;0|1040401:0=1577,1040402:1=943,1030403:1=294,1040201:1=4628,1040202:1=943,1030203:1=294,1040201:1=0'),(70,1204002,6,10,'1|2040301:1=0;1|2040501:1=245;1|2040601:1=78;1|2040302:1=0;1|2040502:1=47;1|2040602:1=10;1|1040303:1=56;1|1040503:1=7;0|1040603:1=1;1|13:1=0;1|10:1=0;2|42:1=10000;1|40:1=10000;1|1030303:1=132;1|1030503:1=16;1|167:1=3500;1|172:1=3000;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;0|1040401:0=1577,1040402:1=943,1030403:1=294,1040201:1=4628,1040202:1=943,1030203:1=294,1040201:1=0'),(71,1204003,1,1,'1|2040301:1=0;1|2040501:1=239;1|2040601:1=53;1|2040302:1=0;1|2040502:1=37;1|2040602:1=5;1|1040303:1=44;1|1040503:1=5;0|1040603:1=1;1|13:1=0;1|10:1=0;2|43:1=10000;3|39:1=10000;1|1030303:1=102;1|1030503:1=13;1|167:1=6000;1|172:1=5000;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;0|1040401:0=1577,1040402:1=943,1030403:1=294,1040201:1=4628,1040202:1=943,1030203:1=294,1040201:1=0'),(72,1204003,2,2,'1|2040301:1=0;1|2040501:1=212;1|2040601:1=53;1|2040302:1=0;1|2040502:1=34;1|2040602:1=5;1|1040303:1=41;1|1040503:1=5;0|1040603:1=1;1|13:1=0;1|10:1=0;3|42:1=10000;4|40:1=10000;1|1030303:1=96;1|1030503:1=12;1|167:1=5000;1|172:1=4500;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;0|1040401:0=1577,1040402:1=943,1030403:1=294,1040201:1=4628,1040202:1=943,1030203:1=294,1040201:1=0'),(73,1204003,3,3,'1|2040301:1=0;1|2040501:1=186;1|2040601:1=53;1|2040302:1=0;1|2040502:1=32;1|2040602:1=5;1|1040303:1=38;1|1040503:1=5;0|1040603:1=1;1|13:1=0;1|10:1=0;3|42:1=10000;2|40:1=10000;1|1030303:1=89;1|1030503:1=11;1|167:1=4500;1|172:1=4000;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;0|1040401:0=1577,1040402:1=943,1030403:1=294,1040201:1=4628,1040202:1=943,1030203:1=294,1040201:1=0'),(74,1204003,4,5,'1|2040301:1=0;1|2040501:1=159;1|2040601:1=48;1|2040302:1=0;1|2040502:1=27;1|2040602:1=5;1|1040303:1=32;1|1040503:1=4;0|1040603:1=1;1|13:1=0;1|10:1=0;3|42:1=10000;1|1030303:1=76;1|1030503:1=9;1|167:1=4000;1|172:1=3500;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;0|1040401:0=1577,1040402:1=943,1030403:1=294,1040201:1=4628,1040202:1=943,1030203:1=294,1040201:1=0'),(75,1204003,6,10,'1|2040301:1=0;1|2040501:1=133;1|2040601:1=42;1|2040302:1=0;1|2040502:1=25;1|2040602:1=5;1|1040303:1=31;1|1040503:1=4;0|1040603:1=1;1|13:1=0;1|10:1=0;2|42:1=10000;1|41:1=10000;1|1030303:1=71;1|1030503:1=9;1|167:1=3500;1|172:1=3000;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;0|1040401:0=1577,1040402:1=943,1030403:1=294,1040201:1=4628,1040202:1=943,1030203:1=294,1040201:1=0'),(76,1204004,1,1,'1|2040301:1=0;1|2040501:1=513;1|2040601:1=114;1|2040302:1=0;1|2040502:1=79;1|2040602:1=11;1|1040303:1=94;1|1040503:1=12;0|1040603:1=2;1|13:1=0;1|10:1=0;4|42:1=10000;1|41:1=10000;1|1030303:1=220;1|1030503:1=28;1|167:1=6000;1|172:1=5000;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;0|1040401:0=1577,1040402:1=943,1030403:1=294,1040201:1=4628,1040202:1=943,1030203:1=294,1040201:1=0'),(77,1204004,2,2,'1|2040301:1=0;1|2040501:1=456;1|2040601:1=114;1|2040302:1=0;1|2040502:1=74;1|2040602:1=11;1|1040303:1=89;1|1040503:1=11;0|1040603:1=2;1|13:1=0;1|10:1=0;4|42:1=10000;1|1030303:1=207;1|1030503:1=26;1|167:1=5000;1|172:1=4500;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;0|1040401:0=1577,1040402:1=943,1030403:1=294,1040201:1=4628,1040202:1=943,1030203:1=294,1040201:1=0'),(78,1204004,3,3,'1|2040301:1=0;1|2040501:1=399;1|2040601:1=114;1|2040302:1=0;1|2040502:1=68;1|2040602:1=11;1|1040303:1=82;1|1040503:1=10;0|1040603:1=2;1|13:1=0;1|10:1=0;3|42:1=10000;3|40:1=10000;1|1030303:1=192;1|1030503:1=24;1|167:1=4500;1|172:1=4000;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;0|1040401:0=1577,1040402:1=943,1030403:1=294,1040201:1=4628,1040202:1=943,1030203:1=294,1040201:1=0'),(79,1204004,4,5,'1|2040301:1=0;1|2040501:1=342;1|2040601:1=103;1|2040302:1=0;1|2040502:1=58;1|2040602:1=11;1|1040303:1=70;1|1040503:1=9;0|1040603:1=2;1|13:1=0;1|10:1=0;3|42:1=10000;1|39:1=10000;1|1030303:1=163;1|1030503:1=20;1|167:1=4000;1|172:1=3500;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;0|1040401:0=1577,1040402:1=943,1030403:1=294,1040201:1=4628,1040202:1=943,1030203:1=294,1040201:1=0'),(80,1204004,6,10,'1|2040301:1=0;1|2040501:1=285;1|2040601:1=91;1|2040302:1=0;1|2040502:1=55;1|2040602:1=11;1|1040303:1=66;1|1040503:1=8;0|1040603:1=2;1|13:1=0;1|10:1=0;2|42:1=10000;7|39:1=10000;1|1030303:1=153;1|1030503:1=19;1|167:1=3500;1|172:1=3000;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;0|1040401:0=1577,1040402:1=943,1030403:1=294,1040201:1=4628,1040202:1=943,1030203:1=294,1040201:1=0'),(81,1204005,1,1,'1|2040301:1=0;1|2040501:1=549;1|2040601:1=122;1|2040302:1=0;1|2040502:1=84;1|2040602:1=12;1|1040303:1=101;1|1040503:1=13;0|1040603:1=2;1|13:1=0;1|10:1=0;5|42:1=10000;1|1030303:1=236;1|1030503:1=29;1|167:1=6000;1|172:1=5000;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;0|1040401:0=1577,1040402:1=943,1030403:1=294,1040201:1=4628,1040202:1=943,1030203:1=294,1040201:1=0'),(82,1204005,2,2,'1|2040301:1=0;1|2040501:1=488;1|2040601:1=122;1|2040302:1=0;1|2040502:1=79;1|2040602:1=12;1|1040303:1=95;1|1040503:1=12;0|1040603:1=2;1|13:1=0;1|10:1=0;4|42:1=10000;2|40:1=10000;1|1030303:1=221;1|1030503:1=28;1|167:1=5000;1|172:1=4500;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;0|1040401:0=1577,1040402:1=943,1030403:1=294,1040201:1=4628,1040202:1=943,1030203:1=294,1040201:1=0'),(83,1204005,3,3,'1|2040301:1=0;1|2040501:1=427;1|2040601:1=122;1|2040302:1=0;1|2040502:1=73;1|2040602:1=12;1|1040303:1=88;1|1040503:1=11;0|1040603:1=2;1|13:1=0;1|10:1=0;4|42:1=10000;1|1030303:1=205;1|1030503:1=26;1|167:1=4500;1|172:1=4000;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;0|1040401:0=1577,1040402:1=943,1030403:1=294,1040201:1=4628,1040202:1=943,1030203:1=294,1040201:1=0'),(84,1204005,4,5,'1|2040301:1=0;1|2040501:1=366;1|2040601:1=110;1|2040302:1=0;1|2040502:1=62;1|2040602:1=12;1|1040303:1=75;1|1040503:1=9;0|1040603:1=2;1|13:1=0;1|10:1=0;3|42:1=10000;2|40:1=10000;1|1030303:1=174;1|1030503:1=22;1|167:1=4000;1|172:1=3500;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;0|1040401:0=1577,1040402:1=943,1030403:1=294,1040201:1=4628,1040202:1=943,1030203:1=294,1040201:1=0'),(85,1204005,6,10,'1|2040301:1=0;1|2040501:1=305;1|2040601:1=98;1|2040302:1=0;1|2040502:1=59;1|2040602:1=12;1|1040303:1=70;1|1040503:1=9;0|1040603:1=2;1|13:1=0;1|10:1=0;3|42:1=10000;1|1030303:1=164;1|1030503:1=20;1|167:1=3500;1|172:1=3000;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;0|1040401:0=1577,1040402:1=943,1030403:1=294,1040201:1=4628,1040202:1=943,1030203:1=294,1040201:1=0'),(86,1204006,1,1,'1|2040301:1=0;1|2040501:1=585;1|2040601:1=130;1|2040302:1=0;1|2040502:1=90;1|2040602:1=13;1|1040303:1=108;1|1040503:1=13;0|1040603:1=2;1|13:1=0;1|10:1=0;3|43:1=10000;1|40:1=10000;1|1030303:1=251;1|1030503:1=31;1|167:1=6000;1|172:1=5000;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;0|1040401:0=1577,1040402:1=943,1030403:1=294,1040201:1=4628,1040202:1=943,1030203:1=294,1040201:1=0'),(87,1204006,2,2,'1|2040301:1=0;1|2040501:1=520;1|2040601:1=130;1|2040302:1=0;1|2040502:1=84;1|2040602:1=13;1|1040303:1=101;1|1040503:1=13;0|1040603:1=2;1|13:1=0;1|10:1=0;1|44:1=10000;1|41:1=10000;1|1030303:1=236;1|1030503:1=29;1|167:1=5000;1|172:1=4500;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;0|1040401:0=1577,1040402:1=943,1030403:1=294,1040201:1=4628,1040202:1=943,1030203:1=294,1040201:1=0'),(88,1204006,3,3,'1|2040301:1=0;1|2040501:1=455;1|2040601:1=130;1|2040302:1=0;1|2040502:1=78;1|2040602:1=13;1|1040303:1=94;1|1040503:1=12;0|1040603:1=2;1|13:1=0;1|10:1=0;1|44:1=10000;1|1030303:1=218;1|1030503:1=27;1|167:1=4500;1|172:1=4000;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;0|1040401:0=1577,1040402:1=943,1030403:1=294,1040201:1=4628,1040202:1=943,1030203:1=294,1040201:1=0'),(89,1204006,4,5,'1|2040301:1=0;1|2040501:1=390;1|2040601:1=117;1|2040302:1=0;1|2040502:1=66;1|2040602:1=13;1|1040303:1=80;1|1040503:1=10;0|1040603:1=2;1|13:1=0;1|10:1=0;2|43:1=10000;3|39:1=10000;1|1030303:1=186;1|1030503:1=23;1|167:1=4000;1|172:1=3500;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;0|1040401:0=1577,1040402:1=943,1030403:1=294,1040201:1=4628,1040202:1=943,1030203:1=294,1040201:1=0'),(90,1204006,6,10,'1|2040301:1=0;1|2040501:1=325;1|2040601:1=104;1|2040302:1=0;1|2040502:1=62;1|2040602:1=13;1|1040303:1=75;1|1040503:1=9;0|1040603:1=2;1|13:1=0;1|10:1=0;3|42:1=10000;3|40:1=10000;1|1030303:1=175;1|1030503:1=22;1|167:1=3500;1|172:1=3000;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;0|1040401:0=1577,1040402:1=943,1030403:1=294,1040201:1=4628,1040202:1=943,1030203:1=294,1040201:1=0'),(91,1205001,1,1,'1|1050301:1=0;1|1050501:1=225;1|2050601:1=72;1|1050302:1=0;1|1050502:1=62;1|2050602:1=9;1|1050303:1=65;1|1050503:1=7;0|1050603:1=1;1|13:1=6259;1|10:1=1177;3|43:1=10000;3|41:1=10000;1|1040303:1=174;1|1040503:1=22;1|168:1=5000;1|173:1=3000;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;0|1050401:0=1591,1050402:1=905,1040403:1=283,1050201:1=4892,1050202:1=905,1040203:1=283,1050201:1=0'),(92,1205001,2,2,'1|1050301:1=0;1|1050501:1=216;1|2050601:1=72;1|1050302:1=0;1|1050502:1=58;1|2050602:1=9;1|1050303:1=61;1|1050503:1=7;0|1050603:1=1;1|13:1=6259;1|10:1=1177;3|43:1=10000;4|40:1=10000;1|1040303:1=163;1|1040503:1=20;1|168:1=4500;1|173:1=2500;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;0|1050401:0=1591,1050402:1=905,1040403:1=283,1050201:1=4892,1050202:1=905,1040203:1=283,1050201:1=0'),(93,1205001,3,3,'1|1050301:1=0;1|1050501:1=189;1|2050601:1=72;1|1050302:1=0;1|1050502:1=54;1|2050602:1=9;1|1050303:1=57;1|1050503:1=6;0|1050603:1=1;1|13:1=6259;1|10:1=1177;3|43:1=10000;1|1040303:1=151;1|1040503:1=19;1|168:1=4000;1|173:1=2000;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;0|1050401:0=1591,1050402:1=905,1040403:1=283,1050201:1=4892,1050202:1=905,1040203:1=283,1050201:1=0'),(94,1205001,4,5,'1|1050301:1=0;1|1050501:1=162;1|2050601:1=72;1|1050302:1=0;1|1050502:1=46;1|2050602:1=9;1|1050303:1=48;1|1050503:1=6;0|1050603:1=1;1|13:1=6259;1|10:1=1177;1|44:1=10000;3|39:1=10000;1|1040303:1=129;1|1040503:1=16;1|168:1=3500;1|173:1=1500;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;0|1050401:0=1591,1050402:1=905,1040403:1=283,1050201:1=4892,1050202:1=905,1040203:1=283,1050201:1=0'),(95,1205001,6,10,'1|1050301:1=0;1|1050501:1=135;1|2050601:1=63;1|1050302:1=0;1|1050502:1=43;1|2050602:1=9;1|1050303:1=45;1|1050503:1=5;0|1050603:1=1;1|13:1=6259;1|10:1=1177;2|43:1=10000;1|41:1=10000;1|1040303:1=121;1|1040503:1=15;1|168:1=3000;1|173:1=1500;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;0|1050401:0=1591,1050402:1=905,1040403:1=283,1050201:1=4892,1050202:1=905,1040203:1=283,1050201:1=0'),(96,1205002,1,1,'1|1050301:1=0;1|1050501:1=123;1|2050601:1=39;1|1050302:1=0;1|1050502:1=34;1|2050602:1=5;1|1050303:1=36;1|1050503:1=4;0|1050603:1=1;1|13:1=6282;1|10:1=1190;1|44:1=10000;2|43:1=10000;1|1040303:1=95;1|1040503:1=12;1|168:1=5000;1|173:1=3000;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;0|1050401:0=1591,1050402:1=905,1040403:1=283,1050201:1=4892,1050202:1=905,1040203:1=283,1050201:1=0'),(97,1205002,2,2,'1|1050301:1=0;1|1050501:1=118;1|2050601:1=39;1|1050302:1=0;1|1050502:1=32;1|2050602:1=5;1|1050303:1=33;1|1050503:1=4;0|1050603:1=1;1|13:1=6282;1|10:1=1190;4|43:1=10000;2|39:1=10000;1|1040303:1=89;1|1040503:1=11;1|168:1=4500;1|173:1=2500;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;0|1050401:0=1591,1050402:1=905,1040403:1=283,1050201:1=4892,1050202:1=905,1040203:1=283,1050201:1=0'),(98,1205002,3,3,'1|1050301:1=0;1|1050501:1=103;1|2050601:1=39;1|1050302:1=0;1|1050502:1=29;1|2050602:1=5;1|1050303:1=31;1|1050503:1=4;0|1050603:1=1;1|13:1=6282;1|10:1=1190;3|43:1=10000;6|40:1=10000;1|1040303:1=82;1|1040503:1=10;1|168:1=4000;1|173:1=2000;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;0|1050401:0=1591,1050402:1=905,1040403:1=283,1050201:1=4892,1050202:1=905,1040203:1=283,1050201:1=0'),(99,1205002,4,5,'1|1050301:1=0;1|1050501:1=88;1|2050601:1=39;1|1050302:1=0;1|1050502:1=25;1|2050602:1=5;1|1050303:1=26;1|1050503:1=3;0|1050603:1=1;1|13:1=6282;1|10:1=1190;3|43:1=10000;3|39:1=10000;1|1040303:1=70;1|1040503:1=9;1|168:1=3500;1|173:1=1500;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;0|1050401:0=1591,1050402:1=905,1040403:1=283,1050201:1=4892,1050202:1=905,1040203:1=283,1050201:1=0'),(100,1205002,6,10,'1|1050301:1=0;1|1050501:1=74;1|2050601:1=34;1|1050302:1=0;1|1050502:1=24;1|2050602:1=5;1|1050303:1=25;1|1050503:1=3;0|1050603:1=1;1|13:1=6282;1|10:1=1190;1|44:1=10000;1|41:1=10000;1|1040303:1=66;1|1040503:1=8;1|168:1=3000;1|173:1=1500;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;0|1050401:0=1591,1050402:1=905,1040403:1=283,1050201:1=4892,1050202:1=905,1040203:1=283,1050201:1=0'),(101,1205003,1,1,'1|1050301:1=0;1|1050501:1=265;1|2050601:1=85;1|1050302:1=0;1|1050502:1=73;1|2050602:1=11;1|1050303:1=77;1|1050503:1=9;0|1050603:1=2;1|13:1=6305;1|10:1=1203;2|44:1=10000;1|1040303:1=205;1|1040503:1=26;1|168:1=5000;1|173:1=3000;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;0|1050401:0=1591,1050402:1=905,1040403:1=283,1050201:1=4892,1050202:1=905,1040203:1=283,1050201:1=0'),(102,1205003,2,2,'1|1050301:1=0;1|1050501:1=254;1|2050601:1=85;1|1050302:1=0;1|1050502:1=69;1|2050602:1=11;1|1050303:1=72;1|1050503:1=8;0|1050603:1=2;1|13:1=6305;1|10:1=1203;1|44:1=10000;2|43:1=10000;1|1040303:1=192;1|1040503:1=24;1|168:1=4500;1|173:1=2500;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;0|1050401:0=1591,1050402:1=905,1040403:1=283,1050201:1=4892,1050202:1=905,1040203:1=283,1050201:1=0'),(103,1205003,3,3,'1|1050301:1=0;1|1050501:1=223;1|2050601:1=85;1|1050302:1=0;1|1050502:1=64;1|2050602:1=11;1|1050303:1=67;1|1050503:1=8;0|1050603:1=2;1|13:1=6305;1|10:1=1203;1|44:1=10000;3|42:1=10000;1|1040303:1=178;1|1040503:1=22;1|168:1=4000;1|173:1=2000;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;0|1050401:0=1591,1050402:1=905,1040403:1=283,1050201:1=4892,1050202:1=905,1040203:1=283,1050201:1=0'),(104,1205003,4,5,'1|1050301:1=0;1|1050501:1=191;1|2050601:1=85;1|1050302:1=0;1|1050502:1=54;1|2050602:1=11;1|1050303:1=57;1|1050503:1=6;0|1050603:1=2;1|13:1=6305;1|10:1=1203;1|44:1=10000;2|42:1=10000;1|1040303:1=151;1|1040503:1=19;1|168:1=3500;1|173:1=1500;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;0|1050401:0=1591,1050402:1=905,1040403:1=283,1050201:1=4892,1050202:1=905,1040203:1=283,1050201:1=0'),(105,1205003,6,10,'1|1050301:1=0;1|1050501:1=159;1|2050601:1=74;1|1050302:1=0;1|1050502:1=51;1|2050602:1=11;1|1050303:1=53;1|1050503:1=6;0|1050603:1=2;1|13:1=6305;1|10:1=1203;1|44:1=10000;1|42:1=10000;1|1040303:1=142;1|1040503:1=18;1|168:1=3000;1|173:1=1500;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;0|1050401:0=1591,1050402:1=905,1040403:1=283,1050201:1=4892,1050202:1=905,1040203:1=283,1050201:1=0'),(106,1205004,1,1,'1|1050301:1=0;1|1050501:1=285;1|2050601:1=91;1|1050302:1=0;1|1050502:1=79;1|2050602:1=11;1|1050303:1=83;1|1050503:1=9;0|1050603:1=2;1|13:1=6327;1|10:1=1215;1|45:1=10000;1|43:1=10000;1|1040303:1=220;1|1040503:1=28;1|168:1=5000;1|173:1=3000;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;0|1050401:0=1591,1050402:1=905,1040403:1=283,1050201:1=4892,1050202:1=905,1040203:1=283,1050201:1=0'),(107,1205004,2,2,'1|1050301:1=0;1|1050501:1=274;1|2050601:1=91;1|1050302:1=0;1|1050502:1=74;1|2050602:1=11;1|1050303:1=78;1|1050503:1=9;0|1050603:1=2;1|13:1=6327;1|10:1=1215;1|45:1=10000;1|1040303:1=207;1|1040503:1=26;1|168:1=4500;1|173:1=2500;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;0|1050401:0=1591,1050402:1=905,1040403:1=283,1050201:1=4892,1050202:1=905,1040203:1=283,1050201:1=0'),(108,1205004,3,3,'1|1050301:1=0;1|1050501:1=239;1|2050601:1=91;1|1050302:1=0;1|1050502:1=68;1|2050602:1=11;1|1050303:1=72;1|1050503:1=8;0|1050603:1=2;1|13:1=6327;1|10:1=1215;1|44:1=10000;2|43:1=10000;1|1040303:1=192;1|1040503:1=24;1|168:1=4000;1|173:1=2000;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;0|1050401:0=1591,1050402:1=905,1040403:1=283,1050201:1=4892,1050202:1=905,1040203:1=283,1050201:1=0'),(109,1205004,4,5,'1|1050301:1=0;1|1050501:1=205;1|2050601:1=91;1|1050302:1=0;1|1050502:1=58;1|2050602:1=11;1|1050303:1=61;1|1050503:1=7;0|1050603:1=2;1|13:1=6327;1|10:1=1215;1|44:1=10000;3|42:1=10000;1|1040303:1=163;1|1040503:1=20;1|168:1=3500;1|173:1=1500;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;0|1050401:0=1591,1050402:1=905,1040403:1=283,1050201:1=4892,1050202:1=905,1040203:1=283,1050201:1=0'),(110,1205004,6,10,'1|1050301:1=0;1|1050501:1=171;1|2050601:1=80;1|1050302:1=0;1|1050502:1=55;1|2050602:1=11;1|1050303:1=57;1|1050503:1=7;0|1050603:1=2;1|13:1=6327;1|10:1=1215;1|44:1=10000;2|42:1=10000;1|1040303:1=153;1|1040503:1=19;1|168:1=3000;1|173:1=1500;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;0|1050401:0=1591,1050402:1=905,1040403:1=283,1050201:1=4892,1050202:1=905,1040203:1=283,1050201:1=0'),(111,1206001,1,1,'1|1060301:1=0;1|1060501:1=225;1|2060601:1=72;1|1060302:1=0;1|1060502:1=31;1|2060602:1=9;1|1060303:1=37;1|1060503:1=4;0|1060603:1=1;1|13:1=6349;1|10:1=1228;1|45:1=10000;1|44:1=10000;1|1050303:1=152;1|1050503:1=17;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;0|1060401:0=1605,1060402:1=867,1050403:1=271,1060201:1=5154,1060202:1=867,1050203:1=271,1060201:1=0'),(112,1206001,2,2,'1|1060301:1=0;1|1060501:1=216;1|2060601:1=72;1|1060302:1=0;1|1060502:1=29;1|2060602:1=9;1|1060303:1=35;1|1060503:1=3;0|1060603:1=1;1|13:1=6349;1|10:1=1228;1|45:1=10000;3|42:1=10000;1|1050303:1=143;1|1050503:1=16;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;0|1060401:0=1605,1060402:1=867,1050403:1=271,1060201:1=5154,1060202:1=867,1050203:1=271,1060201:1=0'),(113,1206001,3,3,'1|1060301:1=0;1|1060501:1=189;1|2060601:1=72;1|1060302:1=0;1|1060502:1=27;1|2060602:1=9;1|1060303:1=32;1|1060503:1=3;0|1060603:1=1;1|13:1=6349;1|10:1=1228;1|45:1=10000;2|42:1=10000;1|1050303:1=132;1|1050503:1=15;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;0|1060401:0=1605,1060402:1=867,1050403:1=271,1060201:1=5154,1060202:1=867,1050203:1=271,1060201:1=0'),(114,1206001,4,5,'1|1060301:1=0;1|1060501:1=162;1|2060601:1=72;1|1060302:1=0;1|1060502:1=23;1|2060602:1=9;1|1060303:1=28;1|1060503:1=3;0|1060603:1=1;1|13:1=6349;1|10:1=1228;1|45:1=10000;1|1050303:1=112;1|1050503:1=13;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;0|1060401:0=1605,1060402:1=867,1050403:1=271,1060201:1=5154,1060202:1=867,1050203:1=271,1060201:1=0'),(115,1206001,6,10,'1|1060301:1=0;1|1060501:1=135;1|2060601:1=63;1|1060302:1=0;1|1060502:1=22;1|2060602:1=9;1|1060303:1=26;1|1060503:1=3;0|1060603:1=1;1|13:1=6349;1|10:1=1228;1|44:1=10000;2|43:1=10000;1|1050303:1=106;1|1050503:1=12;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;0|1060401:0=1605,1060402:1=867,1050403:1=271,1060201:1=5154,1060202:1=867,1050203:1=271,1060201:1=0'),(116,1206002,1,1,'1|1060301:1=0;1|1060501:1=245;1|2060601:1=78;1|1060302:1=0;1|1060502:1=34;1|2060602:1=10;1|1060303:1=41;1|1060503:1=4;0|1060603:1=1;1|13:1=6372;1|10:1=1241;3|44:1=10000;1|42:1=10000;1|1050303:1=166;1|1050503:1=19;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;0|1060401:0=1605,1060402:1=867,1050403:1=271,1060201:1=5154,1060202:1=867,1050203:1=271,1060201:1=0'),(117,1206002,2,2,'1|1060301:1=0;1|1060501:1=235;1|2060601:1=78;1|1060302:1=0;1|1060502:1=32;1|2060602:1=10;1|1060303:1=38;1|1060503:1=4;0|1060603:1=1;1|13:1=6372;1|10:1=1241;1|45:1=10000;2|43:1=10000;1|1050303:1=156;1|1050503:1=18;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;0|1060401:0=1605,1060402:1=867,1050403:1=271,1060201:1=5154,1060202:1=867,1050203:1=271,1060201:1=0'),(118,1206002,3,3,'1|1060301:1=0;1|1060501:1=206;1|2060601:1=78;1|1060302:1=0;1|1060502:1=29;1|2060602:1=10;1|1060303:1=35;1|1060503:1=4;0|1060603:1=1;1|13:1=6372;1|10:1=1241;1|45:1=10000;3|42:1=10000;1|1050303:1=144;1|1050503:1=16;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;0|1060401:0=1605,1060402:1=867,1050403:1=271,1060201:1=5154,1060202:1=867,1050203:1=271,1060201:1=0'),(119,1206002,4,5,'1|1060301:1=0;1|1060501:1=176;1|2060601:1=78;1|1060302:1=0;1|1060502:1=25;1|2060602:1=10;1|1060303:1=30;1|1060503:1=3;0|1060603:1=1;1|13:1=6372;1|10:1=1241;1|45:1=10000;1|42:1=10000;1|1050303:1=122;1|1050503:1=14;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;0|1060401:0=1605,1060402:1=867,1050403:1=271,1060201:1=5154,1060202:1=867,1050203:1=271,1060201:1=0'),(120,1206002,6,10,'1|1060301:1=0;1|1060501:1=147;1|2060601:1=69;1|1060302:1=0;1|1060502:1=24;1|2060602:1=10;1|1060303:1=28;1|1060503:1=3;0|1060603:1=1;1|13:1=6372;1|10:1=1241;1|44:1=10000;2|43:1=10000;1|1050303:1=115;1|1050503:1=13;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;0|1060401:0=1605,1060402:1=867,1050403:1=271,1060201:1=5154,1060202:1=867,1050203:1=271,1060201:1=0'),(121,1206003,1,1,'1|1060301:1=0;1|1060501:1=265;1|2060601:1=85;1|1060302:1=0;1|1060502:1=37;1|2060602:1=11;1|1060303:1=44;1|1060503:1=4;0|1060603:1=1;1|13:1=6394;1|10:1=1254;3|44:1=10000;1|43:1=10000;1|1050303:1=179;1|1050503:1=20;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;0|1060401:0=1605,1060402:1=867,1050403:1=271,1060201:1=5154,1060202:1=867,1050203:1=271,1060201:1=0'),(122,1206003,2,2,'1|1060301:1=0;1|1060501:1=254;1|2060601:1=85;1|1060302:1=0;1|1060502:1=34;1|2060602:1=11;1|1060303:1=41;1|1060503:1=4;0|1060603:1=1;1|13:1=6394;1|10:1=1254;3|44:1=10000;3|39:1=10000;1|1050303:1=168;1|1050503:1=19;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;0|1060401:0=1605,1060402:1=867,1050403:1=271,1060201:1=5154,1060202:1=867,1050203:1=271,1060201:1=0'),(123,1206003,3,3,'1|1060301:1=0;1|1060501:1=223;1|2060601:1=85;1|1060302:1=0;1|1060502:1=32;1|2060602:1=11;1|1060303:1=38;1|1060503:1=4;0|1060603:1=1;1|13:1=6394;1|10:1=1254;1|45:1=10000;3|42:1=10000;1|1050303:1=156;1|1050503:1=18;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;0|1060401:0=1605,1060402:1=867,1050403:1=271,1060201:1=5154,1060202:1=867,1050203:1=271,1060201:1=0'),(124,1206003,4,5,'1|1060301:1=0;1|1060501:1=191;1|2060601:1=85;1|1060302:1=0;1|1060502:1=27;1|2060602:1=11;1|1060303:1=32;1|1060503:1=3;0|1060603:1=1;1|13:1=6394;1|10:1=1254;1|45:1=10000;2|42:1=10000;1|1050303:1=132;1|1050503:1=15;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;0|1060401:0=1605,1060402:1=867,1050403:1=271,1060201:1=5154,1060202:1=867,1050203:1=271,1060201:1=0'),(125,1206003,6,10,'1|1060301:1=0;1|1060501:1=159;1|2060601:1=74;1|1060302:1=0;1|1060502:1=25;1|2060602:1=11;1|1060303:1=31;1|1060503:1=3;0|1060603:1=1;1|13:1=6394;1|10:1=1254;1|45:1=10000;1|1050303:1=125;1|1050503:1=14;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;0|1060401:0=1605,1060402:1=867,1050403:1=271,1060201:1=5154,1060202:1=867,1050203:1=271,1060201:1=0'),(126,1207001,1,1,'1|1070301:1=2250;1|1070501:1=180;1|2070601:1=54;1|1070302:1=207;1|1070502:1=21;1|2070602:1=5;1|1070303:1=37;1|1070503:1=4;0|1070603:1=1;1|13:1=6417;1|10:1=1267;3|44:1=10000;1|43:1=10000;1|1060303:1=87;1|1060503:1=9;4|1070101:1=6000,1070102:1=1500,1070103:1=2500;0|1070401:0=1618,1070402:1=830,1060403:1=260,1070201:1=5420,1070202:1=830,1060203:1=260,1070201:1=0'),(127,1207001,2,2,'1|1070301:1=1800;1|1070501:1=216;1|2070601:1=54;1|1070302:1=194;1|1070502:1=19;1|2070602:1=5;1|1070303:1=35;1|1070503:1=3;0|1070603:1=1;1|13:1=6417;1|10:1=1267;3|44:1=10000;1|42:1=10000;1|1060303:1=82;1|1060503:1=8;4|1070101:1=6000,1070102:1=1500,1070103:1=2500;0|1070401:0=1618,1070402:1=830,1060403:1=260,1070201:1=5420,1070202:1=830,1060203:1=260,1070201:1=0'),(128,1207001,3,3,'1|1070301:1=1350;1|1070501:1=189;1|2070601:1=54;1|1070302:1=180;1|1070502:1=18;1|2070602:1=5;1|1070303:1=32;1|1070503:1=3;0|1070603:1=1;1|13:1=6417;1|10:1=1267;2|44:1=10000;2|43:1=10000;1|1060303:1=76;1|1060503:1=8;4|1070101:1=6000,1070102:1=1500,1070103:1=2500;0|1070401:0=1618,1070402:1=830,1060403:1=260,1070201:1=5420,1070202:1=830,1060203:1=260,1070201:1=0'),(129,1207001,4,5,'1|1070301:1=900;1|1070501:1=162;1|2070601:1=54;1|1070302:1=153;1|1070502:1=15;1|2070602:1=5;1|1070303:1=28;1|1070503:1=3;0|1070603:1=1;1|13:1=6417;1|10:1=1267;2|44:1=10000;1|43:1=10000;1|1060303:1=64;1|1060503:1=6;4|1070101:1=6000,1070102:1=1500,1070103:1=2500;0|1070401:0=1618,1070402:1=830,1060403:1=260,1070201:1=5420,1070202:1=830,1060203:1=260,1070201:1=0'),(130,1207001,6,10,'1|1070301:1=900;1|1070501:1=135;1|2070601:1=54;1|1070302:1=144;1|1070502:1=14;1|2070602:1=5;1|1070303:1=26;1|1070503:1=3;0|1070603:1=1;1|13:1=6417;1|10:1=1267;1|45:1=10000;1|1060303:1=60;1|1060503:1=6;4|1070101:1=6000,1070102:1=1500,1070103:1=2500;0|1070401:0=1618,1070402:1=830,1060403:1=260,1070201:1=5420,1070202:1=830,1060203:1=260,1070201:1=0'),(131,1207002,1,1,'1|1070301:1=2450;1|1070501:1=196;1|2070601:1=59;1|1070302:1=225;1|1070502:1=23;1|2070602:1=5;1|1070303:1=41;1|1070503:1=4;0|1070603:1=1;1|13:1=6439;1|10:1=1279;3|44:1=10000;3|42:1=10000;1|1060303:1=95;1|1060503:1=9;4|1070101:1=6000,1070102:1=1500,1070103:1=2500;0|1070401:0=1618,1070402:1=830,1060403:1=260,1070201:1=5420,1070202:1=830,1060203:1=260,1070201:1=0'),(132,1207002,2,2,'1|1070301:1=1960;1|1070501:1=235;1|2070601:1=59;1|1070302:1=212;1|1070502:1=21;1|2070602:1=5;1|1070303:1=38;1|1070503:1=4;0|1070603:1=1;1|13:1=6439;1|10:1=1279;3|44:1=10000;1|42:1=10000;1|1060303:1=89;1|1060503:1=9;4|1070101:1=6000,1070102:1=1500,1070103:1=2500;0|1070401:0=1618,1070402:1=830,1060403:1=260,1070201:1=5420,1070202:1=830,1060203:1=260,1070201:1=0'),(133,1207002,3,3,'1|1070301:1=1470;1|1070501:1=206;1|2070601:1=59;1|1070302:1=196;1|1070502:1=20;1|2070602:1=5;1|1070303:1=35;1|1070503:1=4;0|1070603:1=1;1|13:1=6439;1|10:1=1279;3|44:1=10000;1|1060303:1=82;1|1060503:1=8;4|1070101:1=6000,1070102:1=1500,1070103:1=2500;0|1070401:0=1618,1070402:1=830,1060403:1=260,1070201:1=5420,1070202:1=830,1060203:1=260,1070201:1=0'),(134,1207002,4,5,'1|1070301:1=980;1|1070501:1=176;1|2070601:1=59;1|1070302:1=167;1|1070502:1=17;1|2070602:1=5;1|1070303:1=30;1|1070503:1=3;0|1070603:1=1;1|13:1=6439;1|10:1=1279;2|44:1=10000;3|42:1=10000;1|1060303:1=70;1|1060503:1=7;4|1070101:1=6000,1070102:1=1500,1070103:1=2500;0|1070401:0=1618,1070402:1=830,1060403:1=260,1070201:1=5420,1070202:1=830,1060203:1=260,1070201:1=0'),(135,1207002,6,10,'1|1070301:1=980;1|1070501:1=147;1|2070601:1=59;1|1070302:1=157;1|1070502:1=16;1|2070602:1=5;1|1070303:1=28;1|1070503:1=3;0|1070603:1=1;1|13:1=6439;1|10:1=1279;2|44:1=10000;1|42:1=10000;1|1060303:1=66;1|1060503:1=7;4|1070101:1=6000,1070102:1=1500,1070103:1=2500;0|1070401:0=1618,1070402:1=830,1060403:1=260,1070201:1=5420,1070202:1=830,1060203:1=260,1070201:1=0'),(136,1207003,1,1,'1|1070301:1=2650;1|1070501:1=212;1|2070601:1=64;1|1070302:1=244;1|1070502:1=24;1|2070602:1=5;1|1070303:1=44;1|1070503:1=4;0|1070603:1=1;1|13:1=6461;1|10:1=1292;4|44:1=10000;1|1060303:1=102;1|1060503:1=10;4|1070101:1=6000,1070102:1=1500,1070103:1=2500;0|1070401:0=1618,1070402:1=830,1060403:1=260,1070201:1=5420,1070202:1=830,1060203:1=260,1070201:1=0'),(137,1207003,2,2,'1|1070301:1=2120;1|1070501:1=254;1|2070601:1=64;1|1070302:1=229;1|1070502:1=23;1|2070602:1=5;1|1070303:1=41;1|1070503:1=4;0|1070603:1=1;1|13:1=6461;1|10:1=1292;3|44:1=10000;3|42:1=10000;1|1060303:1=96;1|1060503:1=10;4|1070101:1=6000,1070102:1=1500,1070103:1=2500;0|1070401:0=1618,1070402:1=830,1060403:1=260,1070201:1=5420,1070202:1=830,1060203:1=260,1070201:1=0'),(138,1207003,3,3,'1|1070301:1=1590;1|1070501:1=223;1|2070601:1=64;1|1070302:1=212;1|1070502:1=21;1|2070602:1=5;1|1070303:1=38;1|1070503:1=4;0|1070603:1=1;1|13:1=6461;1|10:1=1292;3|44:1=10000;1|42:1=10000;1|1060303:1=89;1|1060503:1=9;4|1070101:1=6000,1070102:1=1500,1070103:1=2500;0|1070401:0=1618,1070402:1=830,1060403:1=260,1070201:1=5420,1070202:1=830,1060203:1=260,1070201:1=0'),(139,1207003,4,5,'1|1070301:1=1060;1|1070501:1=191;1|2070601:1=64;1|1070302:1=180;1|1070502:1=18;1|2070602:1=5;1|1070303:1=32;1|1070503:1=3;0|1070603:1=1;1|13:1=6461;1|10:1=1292;1|45:1=10000;4|42:1=10000;1|1060303:1=76;1|1060503:1=8;4|1070101:1=6000,1070102:1=1500,1070103:1=2500;0|1070401:0=1618,1070402:1=830,1060403:1=260,1070201:1=5420,1070202:1=830,1060203:1=260,1070201:1=0'),(140,1207003,6,10,'1|1070301:1=1060;1|1070501:1=159;1|2070601:1=64;1|1070302:1=170;1|1070502:1=17;1|2070602:1=5;1|1070303:1=31;1|1070503:1=3;0|1070603:1=1;1|13:1=6461;1|10:1=1292;1|45:1=10000;2|42:1=10000;1|1060303:1=71;1|1060503:1=7;4|1070101:1=6000,1070102:1=1500,1070103:1=2500;0|1070401:0=1618,1070402:1=830,1060403:1=260,1070201:1=5420,1070202:1=830,1060203:1=260,1070201:1=0'),(141,1208001,1,1,'1|1080301:1=1800;1|1080501:1=135;1|2080601:1=36;1|1080302:1=259;1|1080502:1=21;1|2080602:1=5;1|1080303:1=47;1|1080503:1=4;0|1080603:1=1;1|13:1=6484;1|10:1=1305;2|45:1=10000;1|1070303:1=87;1|1070503:1=9;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;0|1080401:0=1632,1080402:1=792,1070403:1=249,1080201:1=5680,1080202:1=792,1070203:1=249,1080201:1=0'),(142,1208001,2,2,'1|1080301:1=1620;1|1080501:1=108;1|2080601:1=36;1|1080302:1=243;1|1080502:1=19;1|2080602:1=5;1|1080303:1=44;1|1080503:1=3;0|1080603:1=1;1|13:1=6484;1|10:1=1305;3|44:1=10000;3|42:1=10000;1|1070303:1=82;1|1070503:1=8;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;0|1080401:0=1632,1080402:1=792,1070403:1=249,1080201:1=5680,1080202:1=792,1070203:1=249,1080201:1=0'),(143,1208001,3,3,'1|1080301:1=1350;1|1080501:1=117;1|2080601:1=36;1|1080302:1=225;1|1080502:1=18;1|2080602:1=5;1|1080303:1=41;1|1080503:1=3;0|1080603:1=1;1|13:1=6484;1|10:1=1305;3|44:1=10000;1|42:1=10000;1|1070303:1=76;1|1070503:1=8;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;0|1080401:0=1632,1080402:1=792,1070403:1=249,1080201:1=5680,1080202:1=792,1070203:1=249,1080201:1=0'),(144,1208001,4,5,'1|1080301:1=1080;1|1080501:1=108;1|2080601:1=36;1|1080302:1=191;1|1080502:1=15;1|2080602:1=5;1|1080303:1=34;1|1080503:1=3;0|1080603:1=1;1|13:1=6484;1|10:1=1305;2|44:1=10000;4|42:1=10000;1|1070303:1=64;1|1070503:1=6;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;0|1080401:0=1632,1080402:1=792,1070403:1=249,1080201:1=5680,1080202:1=792,1070203:1=249,1080201:1=0'),(145,1208001,6,10,'1|1080301:1=900;1|1080501:1=90;1|2080601:1=36;1|1080302:1=180;1|1080502:1=14;1|2080602:1=5;1|1080303:1=32;1|1080503:1=3;0|1080603:1=1;1|13:1=6484;1|10:1=1305;2|44:1=10000;2|42:1=10000;1|1070303:1=60;1|1070503:1=6;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;0|1080401:0=1632,1080402:1=792,1070403:1=249,1080201:1=5680,1080202:1=792,1070203:1=249,1080201:1=0'),(146,1208002,1,1,'1|1080301:1=1960;1|1080501:1=147;1|2080601:1=39;1|1080302:1=282;1|1080502:1=23;1|2080602:1=5;1|1080303:1=51;1|1080503:1=4;0|1080603:1=1;1|13:1=6507;1|10:1=1318;2|45:1=10000;1|42:1=10000;1|1070303:1=95;1|1070503:1=9;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;0|1080401:0=1632,1080402:1=792,1070403:1=249,1080201:1=5680,1080202:1=792,1070203:1=249,1080201:1=0'),(147,1208002,2,2,'1|1080301:1=1764;1|1080501:1=118;1|2080601:1=39;1|1080302:1=265;1|1080502:1=21;1|2080602:1=5;1|1080303:1=48;1|1080503:1=4;0|1080603:1=1;1|13:1=6507;1|10:1=1318;2|45:1=10000;1|1070303:1=89;1|1070503:1=9;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;0|1080401:0=1632,1080402:1=792,1070403:1=249,1080201:1=5680,1080202:1=792,1070203:1=249,1080201:1=0'),(148,1208002,3,3,'1|1080301:1=1470;1|1080501:1=127;1|2080601:1=39;1|1080302:1=245;1|1080502:1=20;1|2080602:1=5;1|1080303:1=44;1|1080503:1=4;0|1080603:1=1;1|13:1=6507;1|10:1=1318;3|44:1=10000;2|42:1=10000;1|1070303:1=82;1|1070503:1=8;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;0|1080401:0=1632,1080402:1=792,1070403:1=249,1080201:1=5680,1080202:1=792,1070203:1=249,1080201:1=0'),(149,1208002,4,5,'1|1080301:1=1176;1|1080501:1=118;1|2080601:1=39;1|1080302:1=208;1|1080502:1=17;1|2080602:1=5;1|1080303:1=37;1|1080503:1=3;0|1080603:1=1;1|13:1=6507;1|10:1=1318;3|44:1=10000;1|1070303:1=70;1|1070503:1=7;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;0|1080401:0=1632,1080402:1=792,1070403:1=249,1080201:1=5680,1080202:1=792,1070203:1=249,1080201:1=0'),(150,1208002,6,10,'1|1080301:1=980;1|1080501:1=98;1|2080601:1=39;1|1080302:1=196;1|1080502:1=16;1|2080602:1=5;1|1080303:1=35;1|1080503:1=3;0|1080603:1=1;1|13:1=6507;1|10:1=1318;2|44:1=10000;3|42:1=10000;1|1070303:1=66;1|1070503:1=7;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;0|1080401:0=1632,1080402:1=792,1070403:1=249,1080201:1=5680,1080202:1=792,1070203:1=249,1080201:1=0'),(151,1208003,1,1,'1|1080301:1=2120;1|1080501:1=159;1|2080601:1=42;1|1080302:1=305;1|1080502:1=24;1|2080602:1=5;1|1080303:1=55;1|1080503:1=4;0|1080603:1=1;1|13:1=6529;1|10:1=1331;2|45:1=10000;3|42:1=10000;1|1070303:1=102;1|1070503:1=10;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;0|1080401:0=1632,1080402:1=792,1070403:1=249,1080201:1=5680,1080202:1=792,1070203:1=249,1080201:1=0'),(152,1208003,2,2,'1|1080301:1=1908;1|1080501:1=127;1|2080601:1=42;1|1080302:1=286;1|1080502:1=23;1|2080602:1=5;1|1080303:1=52;1|1080503:1=4;0|1080603:1=1;1|13:1=6529;1|10:1=1331;2|45:1=10000;1|42:1=10000;1|1070303:1=96;1|1070503:1=10;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;0|1080401:0=1632,1080402:1=792,1070403:1=249,1080201:1=5680,1080202:1=792,1070203:1=249,1080201:1=0'),(153,1208003,3,3,'1|1080301:1=1590;1|1080501:1=138;1|2080601:1=42;1|1080302:1=265;1|1080502:1=21;1|2080602:1=5;1|1080303:1=48;1|1080503:1=4;0|1080603:1=1;1|13:1=6529;1|10:1=1331;3|44:1=10000;2|43:1=10000;1|1070303:1=89;1|1070503:1=9;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;0|1080401:0=1632,1080402:1=792,1070403:1=249,1080201:1=5680,1080202:1=792,1070203:1=249,1080201:1=0'),(154,1208003,4,5,'1|1080301:1=1272;1|1080501:1=127;1|2080601:1=42;1|1080302:1=225;1|1080502:1=18;1|2080602:1=5;1|1080303:1=41;1|1080503:1=3;0|1080603:1=1;1|13:1=6529;1|10:1=1331;3|44:1=10000;1|42:1=10000;1|1070303:1=76;1|1070503:1=8;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;0|1080401:0=1632,1080402:1=792,1070403:1=249,1080201:1=5680,1080202:1=792,1070203:1=249,1080201:1=0'),(155,1208003,6,10,'1|1080301:1=1060;1|1080501:1=106;1|2080601:1=42;1|1080302:1=212;1|1080502:1=17;1|2080602:1=5;1|1080303:1=38;1|1080503:1=3;0|1080603:1=1;1|13:1=6529;1|10:1=1331;2|44:1=10000;2|43:1=10000;1|1070303:1=71;1|1070503:1=7;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;0|1080401:0=1632,1080402:1=792,1070403:1=249,1080201:1=5680,1080202:1=792,1070203:1=249,1080201:1=0'),(156,1209001,1,1,'1|1090301:1=1350;1|1090501:1=108;1|2090601:1=18;1|1090302:1=311;1|1090502:1=16;1|2090602:1=5;1|1090303:1=75;1|1090503:1=3;0|1090603:1=1;1|13:1=6551;1|10:1=1343;2|45:1=10000;1|44:1=10000;1|1080303:1=109;1|1080503:1=9;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;0|1090401:0=1646,1090402:1=754,1080403:1=238,1090201:1=5940,1090202:1=754,1080203:1=238,1090201:1=0'),(157,1209001,2,2,'1|1090301:1=1080;1|1090501:1=90;1|2090601:1=18;1|1090302:1=292;1|1090502:1=15;1|2090602:1=5;1|1090303:1=70;1|1090503:1=3;0|1090603:1=1;1|13:1=6551;1|10:1=1343;2|45:1=10000;1|43:1=10000;1|1080303:1=102;1|1080503:1=8;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;0|1090401:0=1646,1090402:1=754,1080403:1=238,1090201:1=5940,1090202:1=754,1080203:1=238,1090201:1=0'),(158,1209001,3,3,'1|1090301:1=900;1|1090501:1=81;1|2090601:1=18;1|1090302:1=270;1|1090502:1=14;1|2090602:1=5;1|1090303:1=65;1|1090503:1=2;0|1090603:1=1;1|13:1=6551;1|10:1=1343;2|45:1=10000;1|1080303:1=95;1|1080503:1=8;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;0|1090401:0=1646,1090402:1=754,1080403:1=238,1090201:1=5940,1090202:1=754,1080203:1=238,1090201:1=0'),(159,1209001,4,5,'1|1090301:1=720;1|1090501:1=63;1|2090601:1=18;1|1090302:1=230;1|1090502:1=11;1|2090602:1=5;1|1090303:1=55;1|1090503:1=2;0|1090603:1=1;1|13:1=6551;1|10:1=1343;3|44:1=10000;1|43:1=10000;1|1080303:1=80;1|1080503:1=6;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;0|1090401:0=1646,1090402:1=754,1080403:1=238,1090201:1=5940,1090202:1=754,1080203:1=238,1090201:1=0'),(160,1209001,6,10,'1|1090301:1=720;1|1090501:1=54;1|2090601:1=18;1|1090302:1=216;1|1090502:1=11;1|2090602:1=5;1|1090303:1=52;1|1090503:1=2;0|1090603:1=1;1|13:1=6551;1|10:1=1343;3|44:1=10000;1|1080303:1=76;1|1080503:1=6;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;0|1090401:0=1646,1090402:1=754,1080403:1=238,1090201:1=5940,1090202:1=754,1080203:1=238,1090201:1=0'),(161,1209002,1,1,'1|1090301:1=1470;1|1090501:1=118;1|2090601:1=20;1|1090302:1=338;1|1090502:1=17;1|2090602:1=5;1|1090303:1=81;1|1090503:1=3;0|1090603:1=1;1|13:1=6574;1|10:1=1357;2|45:1=10000;4|43:1=10000;1|1080303:1=118;1|1080503:1=9;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;0|1090401:0=1646,1090402:1=754,1080403:1=238,1090201:1=5940,1090202:1=754,1080203:1=238,1090201:1=0'),(162,1209002,2,2,'1|1090301:1=1176;1|1090501:1=98;1|2090601:1=20;1|1090302:1=318;1|1090502:1=16;1|2090602:1=5;1|1090303:1=76;1|1090503:1=3;0|1090603:1=1;1|13:1=6574;1|10:1=1357;5|44:1=10000;1|1080303:1=111;1|1080503:1=9;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;0|1090401:0=1646,1090402:1=754,1080403:1=238,1090201:1=5940,1090202:1=754,1080203:1=238,1090201:1=0'),(163,1209002,3,3,'1|1090301:1=980;1|1090501:1=88;1|2090601:1=20;1|1090302:1=294;1|1090502:1=15;1|2090602:1=5;1|1090303:1=71;1|1090503:1=3;0|1090603:1=1;1|13:1=6574;1|10:1=1357;2|45:1=10000;3|42:1=10000;1|1080303:1=103;1|1080503:1=8;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;0|1090401:0=1646,1090402:1=754,1080403:1=238,1090201:1=5940,1090202:1=754,1080203:1=238,1090201:1=0'),(164,1209002,4,5,'1|1090301:1=784;1|1090501:1=69;1|2090601:1=20;1|1090302:1=250;1|1090502:1=12;1|2090602:1=5;1|1090303:1=60;1|1090503:1=2;0|1090603:1=1;1|13:1=6574;1|10:1=1357;2|45:1=10000;1|1080303:1=87;1|1080503:1=7;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;0|1090401:0=1646,1090402:1=754,1080403:1=238,1090201:1=5940,1090202:1=754,1080203:1=238,1090201:1=0'),(165,1209002,6,10,'1|1090301:1=784;1|1090501:1=59;1|2090601:1=20;1|1090302:1=235;1|1090502:1=12;1|2090602:1=5;1|1090303:1=56;1|1090503:1=2;0|1090603:1=1;1|13:1=6574;1|10:1=1357;3|44:1=10000;1|43:1=10000;1|1080303:1=82;1|1080503:1=7;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;0|1090401:0=1646,1090402:1=754,1080403:1=238,1090201:1=5940,1090202:1=754,1080203:1=238,1090201:1=0'),(166,1209003,1,1,'1|1090301:1=1590;1|1090501:1=127;1|2090601:1=21;1|1090302:1=366;1|1090502:1=18;1|2090602:1=5;1|1090303:1=88;1|1090503:1=3;0|1090603:1=1;1|13:1=6596;1|10:1=1369;3|45:1=10000;1|43:1=10000;1|1080303:1=128;1|1080503:1=10;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;0|1090401:0=1646,1090402:1=754,1080403:1=238,1090201:1=5940,1090202:1=754,1080203:1=238,1090201:1=0'),(167,1209003,2,2,'1|1090301:1=1272;1|1090501:1=106;1|2090601:1=21;1|1090302:1=343;1|1090502:1=17;1|2090602:1=5;1|1090303:1=82;1|1090503:1=3;0|1090603:1=1;1|13:1=6596;1|10:1=1369;3|45:1=10000;1|1080303:1=120;1|1080503:1=10;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;0|1090401:0=1646,1090402:1=754,1080403:1=238,1090201:1=5940,1090202:1=754,1080203:1=238,1090201:1=0'),(168,1209003,3,3,'1|1090301:1=1060;1|1090501:1=95;1|2090601:1=21;1|1090302:1=318;1|1090502:1=16;1|2090602:1=5;1|1090303:1=76;1|1090503:1=3;0|1090603:1=1;1|13:1=6596;1|10:1=1369;2|45:1=10000;3|43:1=10000;1|1080303:1=111;1|1080503:1=9;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;0|1090401:0=1646,1090402:1=754,1080403:1=238,1090201:1=5940,1090202:1=754,1080203:1=238,1090201:1=0'),(169,1209003,4,5,'1|1090301:1=848;1|1090501:1=74;1|2090601:1=21;1|1090302:1=270;1|1090502:1=14;1|2090602:1=5;1|1090303:1=65;1|1090503:1=2;0|1090603:1=1;1|13:1=6596;1|10:1=1369;2|45:1=10000;3|42:1=10000;1|1080303:1=95;1|1080503:1=8;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;0|1090401:0=1646,1090402:1=754,1080403:1=238,1090201:1=5940,1090202:1=754,1080203:1=238,1090201:1=0'),(170,1209003,6,10,'1|1090301:1=848;1|1090501:1=64;1|2090601:1=21;1|1090302:1=254;1|1090502:1=13;1|2090602:1=5;1|1090303:1=61;1|1090503:1=2;0|1090603:1=1;1|13:1=6596;1|10:1=1369;2|45:1=10000;1|1080303:1=89;1|1080503:1=7;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;0|1090401:0=1646,1090402:1=754,1080403:1=238,1090201:1=5940,1090202:1=754,1080203:1=238,1090201:1=0'),(171,1210001,1,1,'1|1100301:1=900;1|1100501:1=90;1|2100601:1=18;1|1100302:1=311;1|1100502:1=16;1|2100602:1=5;1|1100303:1=75;1|1100503:1=3;0|1100603:1=1;1|13:1=6619;1|10:1=1382;3|45:1=10000;3|42:1=10000;1|1090303:1=174;1|1090503:1=7;4|1100101:1=6000,1100102:1=1500,1100103:1=2500;0|1100401:0=1659,1100402:1=717,1090403:1=226,1100201:1=6206,1100202:1=717,1090203:1=226,1100201:1=0'),(172,1210001,2,2,'1|1100301:1=900;1|1100501:1=81;1|2100601:1=18;1|1100302:1=292;1|1100502:1=15;1|2100602:1=5;1|1100303:1=70;1|1100503:1=3;0|1100603:1=1;1|13:1=6619;1|10:1=1382;3|45:1=10000;1|1090303:1=163;1|1090503:1=6;4|1100101:1=6000,1100102:1=1500,1100103:1=2500;0|1100401:0=1659,1100402:1=717,1090403:1=226,1100201:1=6206,1100202:1=717,1090203:1=226,1100201:1=0'),(173,1210001,3,3,'1|1100301:1=810;1|1100501:1=72;1|2100601:1=18;1|1100302:1=270;1|1100502:1=14;1|2100602:1=5;1|1100303:1=65;1|1100503:1=2;0|1100603:1=1;1|13:1=6619;1|10:1=1382;5|44:1=10000;2|42:1=10000;1|1090303:1=151;1|1090503:1=6;4|1100101:1=6000,1100102:1=1500,1100103:1=2500;0|1100401:0=1659,1100402:1=717,1090403:1=226,1100201:1=6206,1100202:1=717,1090203:1=226,1100201:1=0'),(174,1210001,4,5,'1|1100301:1=720;1|1100501:1=63;1|2100601:1=18;1|1100302:1=230;1|1100502:1=11;1|2100602:1=5;1|1100303:1=55;1|1100503:1=2;0|1100603:1=1;1|13:1=6619;1|10:1=1382;2|45:1=10000;3|42:1=10000;1|1090303:1=129;1|1090503:1=5;4|1100101:1=6000,1100102:1=1500,1100103:1=2500;0|1100401:0=1659,1100402:1=717,1090403:1=226,1100201:1=6206,1100202:1=717,1090203:1=226,1100201:1=0'),(175,1210001,6,10,'1|1100301:1=630;1|1100501:1=54;1|2100601:1=18;1|1100302:1=216;1|1100502:1=11;1|2100602:1=5;1|1100303:1=52;1|1100503:1=2;0|1100603:1=1;1|13:1=6619;1|10:1=1382;2|45:1=10000;1|1090303:1=121;1|1090503:1=5;4|1100101:1=6000,1100102:1=1500,1100103:1=2500;0|1100401:0=1659,1100402:1=717,1090403:1=226,1100201:1=6206,1100202:1=717,1090203:1=226,1100201:1=0'),(176,1210002,1,1,'1|1100301:1=980;1|1100501:1=98;1|2100601:1=20;1|1100302:1=338;1|1100502:1=17;1|2100602:1=5;1|1100303:1=81;1|1100503:1=3;0|1100603:1=1;1|13:1=6641;1|10:1=1395;2|46:1=10000;1|1090303:1=189;1|1090503:1=7;4|1100101:1=6000,1100102:1=1500,1100103:1=2500;0|1100401:0=1659,1100402:1=717,1090403:1=226,1100201:1=6206,1100202:1=717,1090203:1=226,1100201:1=0'),(177,1210002,2,2,'1|1100301:1=980;1|1100501:1=88;1|2100601:1=20;1|1100302:1=318;1|1100502:1=16;1|2100602:1=5;1|1100303:1=76;1|1100503:1=3;0|1100603:1=1;1|13:1=6641;1|10:1=1395;1|46:1=10000;3|44:1=10000;1|1090303:1=178;1|1090503:1=7;4|1100101:1=6000,1100102:1=1500,1100103:1=2500;0|1100401:0=1659,1100402:1=717,1090403:1=226,1100201:1=6206,1100202:1=717,1090203:1=226,1100201:1=0'),(178,1210002,3,3,'1|1100301:1=882;1|1100501:1=78;1|2100601:1=20;1|1100302:1=294;1|1100502:1=15;1|2100602:1=5;1|1100303:1=71;1|1100503:1=3;0|1100603:1=1;1|13:1=6641;1|10:1=1395;1|46:1=10000;2|44:1=10000;1|1090303:1=165;1|1090503:1=6;4|1100101:1=6000,1100102:1=1500,1100103:1=2500;0|1100401:0=1659,1100402:1=717,1090403:1=226,1100201:1=6206,1100202:1=717,1090203:1=226,1100201:1=0'),(179,1210002,4,5,'1|1100301:1=784;1|1100501:1=69;1|2100601:1=20;1|1100302:1=250;1|1100502:1=12;1|2100602:1=5;1|1100303:1=60;1|1100503:1=2;0|1100603:1=1;1|13:1=6641;1|10:1=1395;5|44:1=10000;2|42:1=10000;1|1090303:1=140;1|1090503:1=5;4|1100101:1=6000,1100102:1=1500,1100103:1=2500;0|1100401:0=1659,1100402:1=717,1090403:1=226,1100201:1=6206,1100202:1=717,1090203:1=226,1100201:1=0'),(180,1210002,6,10,'1|1100301:1=686;1|1100501:1=59;1|2100601:1=20;1|1100302:1=235;1|1100502:1=12;1|2100602:1=5;1|1100303:1=56;1|1100503:1=2;0|1100603:1=1;1|13:1=6641;1|10:1=1395;4|44:1=10000;3|42:1=10000;1|1090303:1=132;1|1090503:1=5;4|1100101:1=6000,1100102:1=1500,1100103:1=2500;0|1100401:0=1659,1100402:1=717,1090403:1=226,1100201:1=6206,1100202:1=717,1090203:1=226,1100201:1=0'),(181,1210003,1,1,'1|1100301:1=1060;1|1100501:1=106;1|2100601:1=21;1|1100302:1=366;1|1100502:1=18;1|2100602:1=5;1|1100303:1=88;1|1100503:1=3;0|1100603:1=1;1|13:1=6663;1|10:1=1408;2|46:1=10000;1|44:1=10000;1|1090303:1=205;1|1090503:1=8;4|1100101:1=6000,1100102:1=1500,1100103:1=2500;0|1100401:0=1659,1100402:1=717,1090403:1=226,1100201:1=6206,1100202:1=717,1090203:1=226,1100201:1=0'),(182,1210003,2,2,'1|1100301:1=1060;1|1100501:1=95;1|2100601:1=21;1|1100302:1=343;1|1100502:1=17;1|2100602:1=5;1|1100303:1=82;1|1100503:1=3;0|1100603:1=1;1|13:1=6663;1|10:1=1408;2|46:1=10000;1|42:1=10000;1|1090303:1=192;1|1090503:1=7;4|1100101:1=6000,1100102:1=1500,1100103:1=2500;0|1100401:0=1659,1100402:1=717,1090403:1=226,1100201:1=6206,1100202:1=717,1090203:1=226,1100201:1=0'),(183,1210003,3,3,'1|1100301:1=954;1|1100501:1=85;1|2100601:1=21;1|1100302:1=318;1|1100502:1=16;1|2100602:1=5;1|1100303:1=76;1|1100503:1=3;0|1100603:1=1;1|13:1=6663;1|10:1=1408;3|45:1=10000;3|43:1=10000;1|1090303:1=178;1|1090503:1=7;4|1100101:1=6000,1100102:1=1500,1100103:1=2500;0|1100401:0=1659,1100402:1=717,1090403:1=226,1100201:1=6206,1100202:1=717,1090203:1=226,1100201:1=0'),(184,1210003,4,5,'1|1100301:1=848;1|1100501:1=74;1|2100601:1=21;1|1100302:1=270;1|1100502:1=14;1|2100602:1=5;1|1100303:1=65;1|1100503:1=2;0|1100603:1=1;1|13:1=6663;1|10:1=1408;3|45:1=10000;1|43:1=10000;1|1090303:1=151;1|1090503:1=6;4|1100101:1=6000,1100102:1=1500,1100103:1=2500;0|1100401:0=1659,1100402:1=717,1090403:1=226,1100201:1=6206,1100202:1=717,1090203:1=226,1100201:1=0'),(185,1210003,6,10,'1|1100301:1=742;1|1100501:1=64;1|2100601:1=21;1|1100302:1=254;1|1100502:1=13;1|2100602:1=5;1|1100303:1=61;1|1100503:1=2;0|1100603:1=1;1|13:1=6663;1|10:1=1408;5|44:1=10000;1|43:1=10000;1|1090303:1=142;1|1090503:1=5;4|1100101:1=6000,1100102:1=1500,1100103:1=2500;0|1100401:0=1659,1100402:1=717,1090403:1=226,1100201:1=6206,1100202:1=717,1090203:1=226,1100201:1=0'),(186,1211001,1,1,'1|1110301:1=900;1|1110501:1=90;1|2110601:1=18;1|1110302:1=311;1|1110502:1=16;1|2110602:1=5;1|1110303:1=37;1|1110503:1=2;0|1110603:1=1;1|13:1=6686;1|10:1=1421;2|46:1=10000;4|43:1=10000;1|1100303:1=174;1|1100503:1=7;4|1110101:1=6000,1110102:1=1500,1110103:1=2500;0|1110401:0=1673,1110402:1=679,1100403:1=215,1110201:1=6468,1110202:1=679,1100203:1=215,1110201:1=0'),(187,1211001,2,2,'1|1110301:1=900;1|1110501:1=81;1|2110601:1=18;1|1110302:1=292;1|1110502:1=15;1|2110602:1=5;1|1110303:1=35;1|1110503:1=2;0|1110603:1=1;1|13:1=6686;1|10:1=1421;2|46:1=10000;3|42:1=10000;1|1100303:1=163;1|1100503:1=6;4|1110101:1=6000,1110102:1=1500,1110103:1=2500;0|1110401:0=1673,1110402:1=679,1100403:1=215,1110201:1=6468,1110202:1=679,1100203:1=215,1110201:1=0'),(188,1211001,3,3,'1|1110301:1=810;1|1110501:1=72;1|2110601:1=18;1|1110302:1=270;1|1110502:1=14;1|2110602:1=5;1|1110303:1=32;1|1110503:1=2;0|1110603:1=1;1|13:1=6686;1|10:1=1421;2|46:1=10000;1|1100303:1=151;1|1100503:1=6;4|1110101:1=6000,1110102:1=1500,1110103:1=2500;0|1110401:0=1673,1110402:1=679,1100403:1=215,1110201:1=6468,1110202:1=679,1100203:1=215,1110201:1=0'),(189,1211001,4,5,'1|1110301:1=720;1|1110501:1=63;1|2110601:1=18;1|1110302:1=230;1|1110502:1=11;1|2110602:1=5;1|1110303:1=28;1|1110503:1=1;0|1110603:1=1;1|13:1=6686;1|10:1=1421;3|45:1=10000;2|43:1=10000;1|1100303:1=129;1|1100503:1=5;4|1110101:1=6000,1110102:1=1500,1110103:1=2500;0|1110401:0=1673,1110402:1=679,1100403:1=215,1110201:1=6468,1110202:1=679,1100203:1=215,1110201:1=0'),(190,1211001,6,10,'1|1110301:1=630;1|1110501:1=54;1|2110601:1=18;1|1110302:1=216;1|1110502:1=11;1|2110602:1=5;1|1110303:1=26;1|1110503:1=1;0|1110603:1=1;1|13:1=6686;1|10:1=1421;3|45:1=10000;1|1100303:1=121;1|1100503:1=5;4|1110101:1=6000,1110102:1=1500,1110103:1=2500;0|1110401:0=1673,1110402:1=679,1100403:1=215,1110201:1=6468,1110202:1=679,1100203:1=215,1110201:1=0'),(191,1211002,1,1,'1|1110301:1=980;1|1110501:1=98;1|2110601:1=20;1|1110302:1=338;1|1110502:1=17;1|2110602:1=5;1|1110303:1=41;1|1110503:1=2;0|1110603:1=1;1|13:1=6709;1|10:1=1433;1|47:1=10000;3|43:1=10000;1|1100303:1=189;1|1100503:1=7;4|1110101:1=6000,1110102:1=1500,1110103:1=2500;0|1110401:0=1673,1110402:1=679,1100403:1=215,1110201:1=6468,1110202:1=679,1100203:1=215,1110201:1=0'),(192,1211002,2,2,'1|1110301:1=980;1|1110501:1=88;1|2110601:1=20;1|1110302:1=318;1|1110502:1=16;1|2110602:1=5;1|1110303:1=38;1|1110503:1=2;0|1110603:1=1;1|13:1=6709;1|10:1=1433;1|47:1=10000;1|1100303:1=178;1|1100503:1=7;4|1110101:1=6000,1110102:1=1500,1110103:1=2500;0|1110401:0=1673,1110402:1=679,1100403:1=215,1110201:1=6468,1110202:1=679,1100203:1=215,1110201:1=0'),(193,1211002,3,3,'1|1110301:1=882;1|1110501:1=78;1|2110601:1=20;1|1110302:1=294;1|1110502:1=15;1|2110602:1=5;1|1110303:1=35;1|1110503:1=2;0|1110603:1=1;1|13:1=6709;1|10:1=1433;4|45:1=10000;1|44:1=10000;1|1100303:1=165;1|1100503:1=6;4|1110101:1=6000,1110102:1=1500,1110103:1=2500;0|1110401:0=1673,1110402:1=679,1100403:1=215,1110201:1=6468,1110202:1=679,1100203:1=215,1110201:1=0'),(194,1211002,4,5,'1|1110301:1=784;1|1110501:1=69;1|2110601:1=20;1|1110302:1=250;1|1110502:1=12;1|2110602:1=5;1|1110303:1=30;1|1110503:1=1;0|1110603:1=1;1|13:1=6709;1|10:1=1433;4|45:1=10000;1|1100303:1=140;1|1100503:1=5;4|1110101:1=6000,1110102:1=1500,1110103:1=2500;0|1110401:0=1673,1110402:1=679,1100403:1=215,1110201:1=6468,1110202:1=679,1100203:1=215,1110201:1=0'),(195,1211002,6,10,'1|1110301:1=686;1|1110501:1=59;1|2110601:1=20;1|1110302:1=235;1|1110502:1=12;1|2110602:1=5;1|1110303:1=28;1|1110503:1=1;0|1110603:1=1;1|13:1=6709;1|10:1=1433;3|45:1=10000;2|43:1=10000;1|1100303:1=132;1|1100503:1=5;4|1110101:1=6000,1110102:1=1500,1110103:1=2500;0|1110401:0=1673,1110402:1=679,1100403:1=215,1110201:1=6468,1110202:1=679,1100203:1=215,1110201:1=0'),(196,1211003,1,1,'1|1110301:1=1060;1|1110501:1=106;1|2110601:1=21;1|1110302:1=366;1|1110502:1=18;1|2110602:1=5;1|1110303:1=44;1|1110503:1=2;0|1110603:1=1;1|13:1=6731;1|10:1=1446;3|46:1=10000;4|43:1=10000;1|1100303:1=205;1|1100503:1=8;4|1110101:1=6000,1110102:1=1500,1110103:1=2500;0|1110401:0=1673,1110402:1=679,1100403:1=215,1110201:1=6468,1110202:1=679,1100203:1=215,1110201:1=0'),(197,1211003,2,2,'1|1110301:1=1060;1|1110501:1=95;1|2110601:1=21;1|1110302:1=343;1|1110502:1=17;1|2110602:1=5;1|1110303:1=41;1|1110503:1=2;0|1110603:1=1;1|13:1=6731;1|10:1=1446;3|46:1=10000;1|42:1=10000;1|1100303:1=192;1|1100503:1=7;4|1110101:1=6000,1110102:1=1500,1110103:1=2500;0|1110401:0=1673,1110402:1=679,1100403:1=215,1110201:1=6468,1110202:1=679,1100203:1=215,1110201:1=0'),(198,1211003,3,3,'1|1110301:1=954;1|1110501:1=85;1|2110601:1=21;1|1110302:1=318;1|1110502:1=16;1|2110602:1=5;1|1110303:1=38;1|1110503:1=2;0|1110603:1=1;1|13:1=6731;1|10:1=1446;1|47:1=10000;2|43:1=10000;1|1100303:1=178;1|1100503:1=7;4|1110101:1=6000,1110102:1=1500,1110103:1=2500;0|1110401:0=1673,1110402:1=679,1100403:1=215,1110201:1=6468,1110202:1=679,1100203:1=215,1110201:1=0'),(199,1211003,4,5,'1|1110301:1=848;1|1110501:1=74;1|2110601:1=21;1|1110302:1=270;1|1110502:1=14;1|2110602:1=5;1|1110303:1=32;1|1110503:1=2;0|1110603:1=1;1|13:1=6731;1|10:1=1446;2|46:1=10000;4|43:1=10000;1|1100303:1=151;1|1100503:1=6;4|1110101:1=6000,1110102:1=1500,1110103:1=2500;0|1110401:0=1673,1110402:1=679,1100403:1=215,1110201:1=6468,1110202:1=679,1100203:1=215,1110201:1=0'),(200,1211003,6,10,'1|1110301:1=742;1|1110501:1=64;1|2110601:1=21;1|1110302:1=254;1|1110502:1=13;1|2110602:1=5;1|1110303:1=31;1|1110503:1=2;0|1110603:1=1;1|13:1=6731;1|10:1=1446;2|46:1=10000;1|1100303:1=142;1|1100503:1=5;4|1110101:1=6000,1110102:1=1500,1110103:1=2500;0|1110401:0=1673,1110402:1=679,1100403:1=215,1110201:1=6468,1110202:1=679,1100203:1=215,1110201:1=0'),(201,1212001,1,1,'1|1120301:1=900;1|1120501:1=90;1|2120601:1=18;1|1120302:1=207;1|1120502:1=10;1|2120602:1=5;1|1120303:1=37;1|1120503:1=2;0|1120603:1=1;1|13:1=6753;1|10:1=1459;1|47:1=10000;1|46:1=10000;1|1110303:1=87;1|1110503:1=4;4|1120101:1=6000,1120102:1=1500,1120103:1=2500;0|1120401:0=1687,1120402:1=641,1110403:1=204,1120201:1=6732,1120202:1=641,1110203:1=204,1120201:1=0'),(202,1212001,2,2,'1|1120301:1=900;1|1120501:1=81;1|2120601:1=18;1|1120302:1=194;1|1120502:1=10;1|2120602:1=5;1|1120303:1=35;1|1120503:1=2;0|1120603:1=1;1|13:1=6753;1|10:1=1459;3|46:1=10000;3|42:1=10000;1|1110303:1=82;1|1110503:1=4;4|1120101:1=6000,1120102:1=1500,1120103:1=2500;0|1120401:0=1687,1120402:1=641,1110403:1=204,1120201:1=6732,1120202:1=641,1110203:1=204,1120201:1=0'),(203,1212001,3,3,'1|1120301:1=810;1|1120501:1=72;1|2120601:1=18;1|1120302:1=180;1|1120502:1=9;1|2120602:1=5;1|1120303:1=32;1|1120503:1=2;0|1120603:1=1;1|13:1=6753;1|10:1=1459;1|47:1=10000;3|43:1=10000;1|1110303:1=76;1|1110503:1=4;4|1120101:1=6000,1120102:1=1500,1120103:1=2500;0|1120401:0=1687,1120402:1=641,1110403:1=204,1120201:1=6732,1120202:1=641,1110203:1=204,1120201:1=0'),(204,1212001,4,5,'1|1120301:1=720;1|1120501:1=63;1|2120601:1=18;1|1120302:1=153;1|1120502:1=8;1|2120602:1=5;1|1120303:1=28;1|1120503:1=1;0|1120603:1=1;1|13:1=6753;1|10:1=1459;1|47:1=10000;1|1110303:1=64;1|1110503:1=3;4|1120101:1=6000,1120102:1=1500,1120103:1=2500;0|1120401:0=1687,1120402:1=641,1110403:1=204,1120201:1=6732,1120202:1=641,1110203:1=204,1120201:1=0'),(205,1212001,6,10,'1|1120301:1=630;1|1120501:1=54;1|2120601:1=18;1|1120302:1=144;1|1120502:1=7;1|2120602:1=5;1|1120303:1=26;1|1120503:1=1;0|1120603:1=1;1|13:1=6753;1|10:1=1459;2|46:1=10000;1|43:1=10000;1|1110303:1=60;1|1110503:1=3;4|1120101:1=6000,1120102:1=1500,1120103:1=2500;0|1120401:0=1687,1120402:1=641,1110403:1=204,1120201:1=6732,1120202:1=641,1110203:1=204,1120201:1=0'),(206,1212002,1,1,'1|1120301:1=980;1|1120501:1=98;1|2120601:1=20;1|1120302:1=225;1|1120502:1=11;1|2120602:1=5;1|1120303:1=41;1|1120503:1=2;0|1120603:1=1;1|13:1=6775;1|10:1=1472;1|47:1=10000;3|45:1=10000;1|1110303:1=95;1|1110503:1=5;4|1120101:1=6000,1120102:1=1500,1120103:1=2500;0|1120401:0=1687,1120402:1=641,1110403:1=204,1120201:1=6732,1120202:1=641,1110203:1=204,1120201:1=0'),(207,1212002,2,2,'1|1120301:1=980;1|1120501:1=88;1|2120601:1=20;1|1120302:1=212;1|1120502:1=11;1|2120602:1=5;1|1120303:1=38;1|1120503:1=2;0|1120603:1=1;1|13:1=6775;1|10:1=1472;1|47:1=10000;1|46:1=10000;1|1110303:1=89;1|1110503:1=4;4|1120101:1=6000,1120102:1=1500,1120103:1=2500;0|1120401:0=1687,1120402:1=641,1110403:1=204,1120201:1=6732,1120202:1=641,1110203:1=204,1120201:1=0'),(208,1212002,3,3,'1|1120301:1=882;1|1120501:1=78;1|2120601:1=20;1|1120302:1=196;1|1120502:1=10;1|2120602:1=5;1|1120303:1=35;1|1120503:1=2;0|1120603:1=1;1|13:1=6775;1|10:1=1472;1|47:1=10000;3|44:1=10000;1|1110303:1=82;1|1110503:1=4;4|1120101:1=6000,1120102:1=1500,1120103:1=2500;0|1120401:0=1687,1120402:1=641,1110403:1=204,1120201:1=6732,1120202:1=641,1110203:1=204,1120201:1=0'),(209,1212002,4,5,'1|1120301:1=784;1|1120501:1=69;1|2120601:1=20;1|1120302:1=167;1|1120502:1=8;1|2120602:1=5;1|1120303:1=30;1|1120503:1=1;0|1120603:1=1;1|13:1=6775;1|10:1=1472;1|47:1=10000;3|43:1=10000;1|1110303:1=70;1|1110503:1=3;4|1120101:1=6000,1120102:1=1500,1120103:1=2500;0|1120401:0=1687,1120402:1=641,1110403:1=204,1120201:1=6732,1120202:1=641,1110203:1=204,1120201:1=0'),(210,1212002,6,10,'1|1120301:1=686;1|1120501:1=59;1|2120601:1=20;1|1120302:1=157;1|1120502:1=8;1|2120602:1=5;1|1120303:1=28;1|1120503:1=1;0|1120603:1=1;1|13:1=6775;1|10:1=1472;2|46:1=10000;4|43:1=10000;1|1110303:1=66;1|1110503:1=3;4|1120101:1=6000,1120102:1=1500,1120103:1=2500;0|1120401:0=1687,1120402:1=641,1110403:1=204,1120201:1=6732,1120202:1=641,1110203:1=204,1120201:1=0'),(211,1212003,1,1,'1|1120301:1=1060;1|1120501:1=106;1|2120601:1=21;1|1120302:1=244;1|1120502:1=12;1|2120602:1=5;1|1120303:1=44;1|1120503:1=2;0|1120603:1=1;1|13:1=6798;1|10:1=1485;1|47:1=10000;2|46:1=10000;1|1110303:1=102;1|1110503:1=5;4|1120101:1=6000,1120102:1=1500,1120103:1=2500;0|1120401:0=1687,1120402:1=641,1110403:1=204,1120201:1=6732,1120202:1=641,1110203:1=204,1120201:1=0'),(212,1212003,2,2,'1|1120301:1=1060;1|1120501:1=95;1|2120601:1=21;1|1120302:1=229;1|1120502:1=11;1|2120602:1=5;1|1120303:1=41;1|1120503:1=2;0|1120603:1=1;1|13:1=6798;1|10:1=1485;1|47:1=10000;3|45:1=10000;1|1110303:1=96;1|1110503:1=5;4|1120101:1=6000,1120102:1=1500,1120103:1=2500;0|1120401:0=1687,1120402:1=641,1110403:1=204,1120201:1=6732,1120202:1=641,1110203:1=204,1120201:1=0'),(213,1212003,3,3,'1|1120301:1=954;1|1120501:1=85;1|2120601:1=21;1|1120302:1=212;1|1120502:1=11;1|2120602:1=5;1|1120303:1=38;1|1120503:1=2;0|1120603:1=1;1|13:1=6798;1|10:1=1485;1|47:1=10000;1|46:1=10000;1|1110303:1=89;1|1110503:1=4;4|1120101:1=6000,1120102:1=1500,1120103:1=2500;0|1120401:0=1687,1120402:1=641,1110403:1=204,1120201:1=6732,1120202:1=641,1110203:1=204,1120201:1=0'),(214,1212003,4,5,'1|1120301:1=848;1|1120501:1=74;1|2120601:1=21;1|1120302:1=180;1|1120502:1=9;1|2120602:1=5;1|1120303:1=32;1|1120503:1=2;0|1120603:1=1;1|13:1=6798;1|10:1=1485;3|46:1=10000;1|43:1=10000;1|1110303:1=76;1|1110503:1=4;4|1120101:1=6000,1120102:1=1500,1120103:1=2500;0|1120401:0=1687,1120402:1=641,1110403:1=204,1120201:1=6732,1120202:1=641,1110203:1=204,1120201:1=0'),(215,1212003,6,10,'1|1120301:1=742;1|1120501:1=64;1|2120601:1=21;1|1120302:1=170;1|1120502:1=8;1|2120602:1=5;1|1120303:1=31;1|1120503:1=2;0|1120603:1=1;1|13:1=6798;1|10:1=1485;1|47:1=10000;3|42:1=10000;1|1110303:1=71;1|1110503:1=4;4|1120101:1=6000,1120102:1=1500,1120103:1=2500;0|1120401:0=1687,1120402:1=641,1110403:1=204,1120201:1=6732,1120202:1=641,1110203:1=204,1120201:1=0'),(216,1213001,1,1,'1|1130301:1=1080;1|1130501:1=90;1|2130601:1=9;1|1130302:1=207;1|1130502:1=10;1|2130602:1=5;1|1130303:1=56;1|1130503:1=2;0|1130603:1=1;1|13:1=6821;1|10:1=1497;1|47:1=10000;2|46:1=10000;1|1120303:1=87;1|1120503:1=4;4|1130101:1=6000,1130102:1=1500,1130103:1=2500;0|1130401:0=1701,1130402:1=603,1120403:1=192,1130201:1=6994,1130202:1=603,1120203:1=192,1130201:1=0'),(217,1213001,2,2,'1|1130301:1=900;1|1130501:1=81;1|2130601:1=9;1|1130302:1=194;1|1130502:1=10;1|2130602:1=5;1|1130303:1=52;1|1130503:1=2;0|1130603:1=1;1|13:1=6821;1|10:1=1497;1|47:1=10000;3|45:1=10000;1|1120303:1=82;1|1120503:1=4;4|1130101:1=6000,1130102:1=1500,1130103:1=2500;0|1130401:0=1701,1130402:1=603,1120403:1=192,1130201:1=6994,1130202:1=603,1120203:1=192,1130201:1=0'),(218,1213001,3,3,'1|1130301:1=810;1|1130501:1=63;1|2130601:1=9;1|1130302:1=180;1|1130502:1=9;1|2130602:1=5;1|1130303:1=49;1|1130503:1=2;0|1130603:1=1;1|13:1=6821;1|10:1=1497;1|47:1=10000;5|44:1=10000;1|1120303:1=76;1|1120503:1=4;4|1130101:1=6000,1130102:1=1500,1130103:1=2500;0|1130401:0=1701,1130402:1=603,1120403:1=192,1130201:1=6994,1130202:1=603,1120203:1=192,1130201:1=0'),(219,1213001,4,5,'1|1130301:1=720;1|1130501:1=54;1|2130601:1=9;1|1130302:1=153;1|1130502:1=8;1|2130602:1=5;1|1130303:1=41;1|1130503:1=1;0|1130603:1=1;1|13:1=6821;1|10:1=1497;1|47:1=10000;3|44:1=10000;1|1120303:1=64;1|1120503:1=3;4|1130101:1=6000,1130102:1=1500,1130103:1=2500;0|1130401:0=1701,1130402:1=603,1120403:1=192,1130201:1=6994,1130202:1=603,1120203:1=192,1130201:1=0'),(220,1213001,6,10,'1|1130301:1=630;1|1130501:1=36;1|2130601:1=9;1|1130302:1=144;1|1130502:1=7;1|2130602:1=5;1|1130303:1=39;1|1130503:1=1;0|1130603:1=1;1|13:1=6821;1|10:1=1497;1|47:1=10000;3|43:1=10000;1|1120303:1=60;1|1120503:1=3;4|1130101:1=6000,1130102:1=1500,1130103:1=2500;0|1130401:0=1701,1130402:1=603,1120403:1=192,1130201:1=6994,1130202:1=603,1120203:1=192,1130201:1=0'),(221,1213002,1,1,'1|1130301:1=1176;1|1130501:1=98;1|2130601:1=10;1|1130302:1=225;1|1130502:1=11;1|2130602:1=5;1|1130303:1=61;1|1130503:1=2;0|1130603:1=1;1|13:1=6843;1|10:1=1510;2|47:1=10000;1|44:1=10000;1|1120303:1=95;1|1120503:1=5;4|1130101:1=6000,1130102:1=1500,1130103:1=2500;0|1130401:0=1701,1130402:1=603,1120403:1=192,1130201:1=6994,1130202:1=603,1120203:1=192,1130201:1=0'),(222,1213002,2,2,'1|1130301:1=980;1|1130501:1=88;1|2130601:1=10;1|1130302:1=212;1|1130502:1=11;1|2130602:1=5;1|1130303:1=57;1|1130503:1=2;0|1130603:1=1;1|13:1=6843;1|10:1=1510;2|47:1=10000;1|1120303:1=89;1|1120503:1=4;4|1130101:1=6000,1130102:1=1500,1130103:1=2500;0|1130401:0=1701,1130402:1=603,1120403:1=192,1130201:1=6994,1130202:1=603,1120203:1=192,1130201:1=0'),(223,1213002,3,3,'1|1130301:1=882;1|1130501:1=69;1|2130601:1=10;1|1130302:1=196;1|1130502:1=10;1|2130602:1=5;1|1130303:1=53;1|1130503:1=2;0|1130603:1=1;1|13:1=6843;1|10:1=1510;4|46:1=10000;3|43:1=10000;1|1120303:1=82;1|1120503:1=4;4|1130101:1=6000,1130102:1=1500,1130103:1=2500;0|1130401:0=1701,1130402:1=603,1120403:1=192,1130201:1=6994,1130202:1=603,1120203:1=192,1130201:1=0'),(224,1213002,4,5,'1|1130301:1=784;1|1130501:1=59;1|2130601:1=10;1|1130302:1=167;1|1130502:1=8;1|2130602:1=5;1|1130303:1=45;1|1130503:1=1;0|1130603:1=1;1|13:1=6843;1|10:1=1510;3|46:1=10000;3|44:1=10000;1|1120303:1=70;1|1120503:1=3;4|1130101:1=6000,1130102:1=1500,1130103:1=2500;0|1130401:0=1701,1130402:1=603,1120403:1=192,1130201:1=6994,1130202:1=603,1120203:1=192,1130201:1=0'),(225,1213002,6,10,'1|1130301:1=686;1|1130501:1=39;1|2130601:1=10;1|1130302:1=157;1|1130502:1=8;1|2130602:1=5;1|1130303:1=42;1|1130503:1=1;0|1130603:1=1;1|13:1=6843;1|10:1=1510;3|46:1=10000;2|43:1=10000;1|1120303:1=66;1|1120503:1=3;4|1130101:1=6000,1130102:1=1500,1130103:1=2500;0|1130401:0=1701,1130402:1=603,1120403:1=192,1130201:1=6994,1130202:1=603,1120203:1=192,1130201:1=0'),(226,1213003,1,1,'1|1130301:1=1272;1|1130501:1=106;1|2130601:1=11;1|1130302:1=244;1|1130502:1=12;1|2130602:1=5;1|1130303:1=66;1|1130503:1=2;0|1130603:1=1;1|13:1=6865;1|10:1=1523;3|47:1=10000;1|1120303:1=102;1|1120503:1=5;4|1130101:1=6000,1130102:1=1500,1130103:1=2500;0|1130401:0=1701,1130402:1=603,1120403:1=192,1130201:1=6994,1130202:1=603,1120203:1=192,1130201:1=0'),(227,1213003,2,2,'1|1130301:1=1060;1|1130501:1=95;1|2130601:1=11;1|1130302:1=229;1|1130502:1=11;1|2130602:1=5;1|1130303:1=62;1|1130503:1=2;0|1130603:1=1;1|13:1=6865;1|10:1=1523;2|47:1=10000;3|45:1=10000;1|1120303:1=96;1|1120503:1=5;4|1130101:1=6000,1130102:1=1500,1130103:1=2500;0|1130401:0=1701,1130402:1=603,1120403:1=192,1130201:1=6994,1130202:1=603,1120203:1=192,1130201:1=0'),(228,1213003,3,3,'1|1130301:1=954;1|1130501:1=74;1|2130601:1=11;1|1130302:1=212;1|1130502:1=11;1|2130602:1=5;1|1130303:1=57;1|1130503:1=2;0|1130603:1=1;1|13:1=6865;1|10:1=1523;2|47:1=10000;3|44:1=10000;1|1120303:1=89;1|1120503:1=4;4|1130101:1=6000,1130102:1=1500,1130103:1=2500;0|1130401:0=1701,1130402:1=603,1120403:1=192,1130201:1=6994,1130202:1=603,1120203:1=192,1130201:1=0'),(229,1213003,4,5,'1|1130301:1=848;1|1130501:1=64;1|2130601:1=11;1|1130302:1=180;1|1130502:1=9;1|2130602:1=5;1|1130303:1=49;1|1130503:1=2;0|1130603:1=1;1|13:1=6865;1|10:1=1523;2|47:1=10000;1|1120303:1=76;1|1120503:1=4;4|1130101:1=6000,1130102:1=1500,1130103:1=2500;0|1130401:0=1701,1130402:1=603,1120403:1=192,1130201:1=6994,1130202:1=603,1120203:1=192,1130201:1=0'),(230,1213003,6,10,'1|1130301:1=742;1|1130501:1=42;1|2130601:1=11;1|1130302:1=170;1|1130502:1=8;1|2130602:1=5;1|1130303:1=46;1|1130503:1=2;0|1130603:1=1;1|13:1=6865;1|10:1=1523;4|46:1=10000;4|43:1=10000;1|1120303:1=71;1|1120503:1=4;4|1130101:1=6000,1130102:1=1500,1130103:1=2500;0|1130401:0=1701,1130402:1=603,1120403:1=192,1130201:1=6994,1130202:1=603,1120203:1=192,1130201:1=0'),(231,1214001,1,1,'1|1140301:1=900;1|1140501:1=90;1|2140601:1=9;1|1140302:1=207;1|1140502:1=10;1|2140602:1=5;1|1140303:1=56;1|1140503:1=2;0|1140603:1=1;1|13:1=6888;1|10:1=1536;3|47:1=10000;1|1130303:1=130;1|1130503:1=4;4|1140101:1=6000,1140102:1=1500,1140103:1=2500;0|1140401:0=1714,1140402:1=566,1130403:1=181,1140201:1=7260,1140202:1=566,1130203:1=181,1140201:1=0'),(232,1214001,2,2,'1|1140301:1=810;1|1140501:1=81;1|2140601:1=9;1|1140302:1=194;1|1140502:1=10;1|2140602:1=5;1|1140303:1=52;1|1140503:1=2;0|1140603:1=1;1|13:1=6888;1|10:1=1536;2|47:1=10000;3|45:1=10000;1|1130303:1=122;1|1130503:1=4;4|1140101:1=6000,1140102:1=1500,1140103:1=2500;0|1140401:0=1714,1140402:1=566,1130403:1=181,1140201:1=7260,1140202:1=566,1130203:1=181,1140201:1=0'),(233,1214001,3,3,'1|1140301:1=720;1|1140501:1=63;1|2140601:1=9;1|1140302:1=180;1|1140502:1=9;1|2140602:1=5;1|1140303:1=49;1|1140503:1=2;0|1140603:1=1;1|13:1=6888;1|10:1=1536;2|47:1=10000;2|45:1=10000;1|1130303:1=113;1|1130503:1=4;4|1140101:1=6000,1140102:1=1500,1140103:1=2500;0|1140401:0=1714,1140402:1=566,1130403:1=181,1140201:1=7260,1140202:1=566,1130203:1=181,1140201:1=0'),(234,1214001,4,5,'1|1140301:1=630;1|1140501:1=54;1|2140601:1=9;1|1140302:1=153;1|1140502:1=8;1|2140602:1=5;1|1140303:1=41;1|1140503:1=1;0|1140603:1=1;1|13:1=6888;1|10:1=1536;2|47:1=10000;2|43:1=10000;1|1130303:1=96;1|1130503:1=3;4|1140101:1=6000,1140102:1=1500,1140103:1=2500;0|1140401:0=1714,1140402:1=566,1130403:1=181,1140201:1=7260,1140202:1=566,1130203:1=181,1140201:1=0'),(235,1214001,6,10,'1|1140301:1=540;1|1140501:1=36;1|2140601:1=9;1|1140302:1=144;1|1140502:1=7;1|2140602:1=5;1|1140303:1=39;1|1140503:1=1;0|1140603:1=1;1|13:1=6888;1|10:1=1536;1|47:1=10000;2|46:1=10000;1|1130303:1=91;1|1130503:1=3;4|1140101:1=6000,1140102:1=1500,1140103:1=2500;0|1140401:0=1714,1140402:1=566,1130403:1=181,1140201:1=7260,1140202:1=566,1130203:1=181,1140201:1=0'),(236,1214002,1,1,'1|1140301:1=980;1|1140501:1=98;1|2140601:1=10;1|1140302:1=225;1|1140502:1=11;1|2140602:1=5;1|1140303:1=61;1|1140503:1=2;0|1140603:1=1;1|13:1=6910;1|10:1=1549;3|47:1=10000;2|43:1=10000;1|1130303:1=142;1|1130503:1=5;4|1140101:1=6000,1140102:1=1500,1140103:1=2500;0|1140401:0=1714,1140402:1=566,1130403:1=181,1140201:1=7260,1140202:1=566,1130203:1=181,1140201:1=0'),(237,1214002,2,2,'1|1140301:1=882;1|1140501:1=88;1|2140601:1=10;1|1140302:1=212;1|1140502:1=11;1|2140602:1=5;1|1140303:1=57;1|1140503:1=2;0|1140603:1=1;1|13:1=6910;1|10:1=1549;2|47:1=10000;2|46:1=10000;1|1130303:1=133;1|1130503:1=4;4|1140101:1=6000,1140102:1=1500,1140103:1=2500;0|1140401:0=1714,1140402:1=566,1130403:1=181,1140201:1=7260,1140202:1=566,1130203:1=181,1140201:1=0'),(238,1214002,3,3,'1|1140301:1=784;1|1140501:1=69;1|2140601:1=10;1|1140302:1=196;1|1140502:1=10;1|2140602:1=5;1|1140303:1=53;1|1140503:1=2;0|1140603:1=1;1|13:1=6910;1|10:1=1549;2|47:1=10000;1|46:1=10000;1|1130303:1=123;1|1130503:1=4;4|1140101:1=6000,1140102:1=1500,1140103:1=2500;0|1140401:0=1714,1140402:1=566,1130403:1=181,1140201:1=7260,1140202:1=566,1130203:1=181,1140201:1=0'),(239,1214002,4,5,'1|1140301:1=686;1|1140501:1=59;1|2140601:1=10;1|1140302:1=167;1|1140502:1=8;1|2140602:1=5;1|1140303:1=45;1|1140503:1=1;0|1140603:1=1;1|13:1=6910;1|10:1=1549;2|47:1=10000;1|44:1=10000;1|1130303:1=105;1|1130503:1=3;4|1140101:1=6000,1140102:1=1500,1140103:1=2500;0|1140401:0=1714,1140402:1=566,1130403:1=181,1140201:1=7260,1140202:1=566,1130203:1=181,1140201:1=0'),(240,1214002,6,10,'1|1140301:1=588;1|1140501:1=39;1|2140601:1=10;1|1140302:1=157;1|1140502:1=8;1|2140602:1=5;1|1140303:1=42;1|1140503:1=1;0|1140603:1=1;1|13:1=6910;1|10:1=1549;1|47:1=10000;2|46:1=10000;1|1130303:1=99;1|1130503:1=3;4|1140101:1=6000,1140102:1=1500,1140103:1=2500;0|1140401:0=1714,1140402:1=566,1130403:1=181,1140201:1=7260,1140202:1=566,1130203:1=181,1140201:1=0'),(241,1214003,1,1,'1|1140301:1=1060;1|1140501:1=106;1|2140601:1=11;1|1140302:1=244;1|1140502:1=12;1|2140602:1=5;1|1140303:1=66;1|1140503:1=2;0|1140603:1=1;1|13:1=6933;1|10:1=1561;3|47:1=10000;4|43:1=10000;1|1130303:1=154;1|1130503:1=5;4|1140101:1=6000,1140102:1=1500,1140103:1=2500;0|1140401:0=1714,1140402:1=566,1130403:1=181,1140201:1=7260,1140202:1=566,1130203:1=181,1140201:1=0'),(242,1214003,2,2,'1|1140301:1=954;1|1140501:1=95;1|2140601:1=11;1|1140302:1=229;1|1140502:1=11;1|2140602:1=5;1|1140303:1=62;1|1140503:1=2;0|1140603:1=1;1|13:1=6933;1|10:1=1561;2|47:1=10000;2|46:1=10000;1|1130303:1=144;1|1130503:1=5;4|1140101:1=6000,1140102:1=1500,1140103:1=2500;0|1140401:0=1714,1140402:1=566,1130403:1=181,1140201:1=7260,1140202:1=566,1130203:1=181,1140201:1=0'),(243,1214003,3,3,'1|1140301:1=848;1|1140501:1=74;1|2140601:1=11;1|1140302:1=212;1|1140502:1=11;1|2140602:1=5;1|1140303:1=57;1|1140503:1=2;0|1140603:1=1;1|13:1=6933;1|10:1=1561;2|47:1=10000;3|45:1=10000;1|1130303:1=134;1|1130503:1=4;4|1140101:1=6000,1140102:1=1500,1140103:1=2500;0|1140401:0=1714,1140402:1=566,1130403:1=181,1140201:1=7260,1140202:1=566,1130203:1=181,1140201:1=0'),(244,1214003,4,5,'1|1140301:1=742;1|1140501:1=64;1|2140601:1=11;1|1140302:1=180;1|1140502:1=9;1|2140602:1=5;1|1140303:1=49;1|1140503:1=2;0|1140603:1=1;1|13:1=6933;1|10:1=1561;2|47:1=10000;1|45:1=10000;1|1130303:1=114;1|1130503:1=4;4|1140101:1=6000,1140102:1=1500,1140103:1=2500;0|1140401:0=1714,1140402:1=566,1130403:1=181,1140201:1=7260,1140202:1=566,1130203:1=181,1140201:1=0'),(245,1214003,6,10,'1|1140301:1=636;1|1140501:1=42;1|2140601:1=11;1|1140302:1=170;1|1140502:1=8;1|2140602:1=5;1|1140303:1=46;1|1140503:1=2;0|1140603:1=1;1|13:1=6933;1|10:1=1561;1|47:1=10000;2|46:1=10000;1|1130303:1=107;1|1130503:1=4;4|1140101:1=6000,1140102:1=1500,1140103:1=2500;0|1140401:0=1714,1140402:1=566,1130403:1=181,1140201:1=7260,1140202:1=566,1130203:1=181,1140201:1=0'),(246,1215001,1,1,'1|1150301:1=900;1|1150501:1=90;1|2150601:1=9;1|1150302:1=207;1|1150502:1=10;1|2150602:1=5;1|1150303:1=56;1|1150503:1=2;0|1150603:1=1;1|13:1=6955;1|10:1=1575;3|47:1=10000;1|45:1=10000;1|1140303:1=130;1|1140503:1=4;4|1150101:1=6000,1150102:1=1500,1150103:1=2500;0|1150401:0=1728,1150402:1=528,1140403:1=170,1150201:1=7520,1150202:1=528,1140203:1=170,1150201:1=0'),(247,1215001,2,2,'1|1150301:1=810;1|1150501:1=81;1|2150601:1=9;1|1150302:1=194;1|1150502:1=10;1|2150602:1=5;1|1150303:1=52;1|1150503:1=2;0|1150603:1=1;1|13:1=6955;1|10:1=1575;2|47:1=10000;2|46:1=10000;1|1140303:1=122;1|1140503:1=4;4|1150101:1=6000,1150102:1=1500,1150103:1=2500;0|1150401:0=1728,1150402:1=528,1140403:1=170,1150201:1=7520,1150202:1=528,1140203:1=170,1150201:1=0'),(248,1215001,3,3,'1|1150301:1=720;1|1150501:1=63;1|2150601:1=9;1|1150302:1=180;1|1150502:1=9;1|2150602:1=5;1|1150303:1=49;1|1150503:1=2;0|1150603:1=1;1|13:1=6955;1|10:1=1575;2|47:1=10000;3|45:1=10000;1|1140303:1=113;1|1140503:1=4;4|1150101:1=6000,1150102:1=1500,1150103:1=2500;0|1150401:0=1728,1150402:1=528,1140403:1=170,1150201:1=7520,1150202:1=528,1140203:1=170,1150201:1=0'),(249,1215001,4,5,'1|1150301:1=630;1|1150501:1=54;1|2150601:1=9;1|1150302:1=153;1|1150502:1=8;1|2150602:1=5;1|1150303:1=41;1|1150503:1=1;0|1150603:1=1;1|13:1=6955;1|10:1=1575;2|47:1=10000;1|45:1=10000;1|1140303:1=96;1|1140503:1=3;4|1150101:1=6000,1150102:1=1500,1150103:1=2500;0|1150401:0=1728,1150402:1=528,1140403:1=170,1150201:1=7520,1150202:1=528,1140203:1=170,1150201:1=0'),(250,1215001,6,10,'1|1150301:1=540;1|1150501:1=36;1|2150601:1=9;1|1150302:1=144;1|1150502:1=7;1|2150602:1=5;1|1150303:1=39;1|1150503:1=1;0|1150603:1=1;1|13:1=6955;1|10:1=1575;2|47:1=10000;1|1140303:1=91;1|1140503:1=3;4|1150101:1=6000,1150102:1=1500,1150103:1=2500;0|1150401:0=1728,1150402:1=528,1140403:1=170,1150201:1=7520,1150202:1=528,1140203:1=170,1150201:1=0'),(251,1215002,1,1,'1|1150301:1=980;1|1150501:1=98;1|2150601:1=10;1|1150302:1=225;1|1150502:1=11;1|2150602:1=5;1|1150303:1=61;1|1150503:1=2;0|1150603:1=1;1|13:1=6977;1|10:1=1587;3|47:1=10000;3|44:1=10000;1|1140303:1=142;1|1140503:1=5;4|1150101:1=6000,1150102:1=1500,1150103:1=2500;0|1150401:0=1728,1150402:1=528,1140403:1=170,1150201:1=7520,1150202:1=528,1140203:1=170,1150201:1=0'),(252,1215002,2,2,'1|1150301:1=882;1|1150501:1=88;1|2150601:1=10;1|1150302:1=212;1|1150502:1=11;1|2150602:1=5;1|1150303:1=57;1|1150503:1=2;0|1150603:1=1;1|13:1=6977;1|10:1=1587;3|47:1=10000;1|1140303:1=133;1|1140503:1=4;4|1150101:1=6000,1150102:1=1500,1150103:1=2500;0|1150401:0=1728,1150402:1=528,1140403:1=170,1150201:1=7520,1150202:1=528,1140203:1=170,1150201:1=0'),(253,1215002,3,3,'1|1150301:1=784;1|1150501:1=69;1|2150601:1=10;1|1150302:1=196;1|1150502:1=10;1|2150602:1=5;1|1150303:1=53;1|1150503:1=2;0|1150603:1=1;1|13:1=6977;1|10:1=1587;2|47:1=10000;3|45:1=10000;1|1140303:1=123;1|1140503:1=4;4|1150101:1=6000,1150102:1=1500,1150103:1=2500;0|1150401:0=1728,1150402:1=528,1140403:1=170,1150201:1=7520,1150202:1=528,1140203:1=170,1150201:1=0'),(254,1215002,4,5,'1|1150301:1=686;1|1150501:1=59;1|2150601:1=10;1|1150302:1=167;1|1150502:1=8;1|2150602:1=5;1|1150303:1=45;1|1150503:1=1;0|1150603:1=1;1|13:1=6977;1|10:1=1587;2|47:1=10000;3|44:1=10000;1|1140303:1=105;1|1140503:1=3;4|1150101:1=6000,1150102:1=1500,1150103:1=2500;0|1150401:0=1728,1150402:1=528,1140403:1=170,1150201:1=7520,1150202:1=528,1140203:1=170,1150201:1=0'),(255,1215002,6,10,'1|1150301:1=588;1|1150501:1=39;1|2150601:1=10;1|1150302:1=157;1|1150502:1=8;1|2150602:1=5;1|1150303:1=42;1|1150503:1=1;0|1150603:1=1;1|13:1=6977;1|10:1=1587;2|47:1=10000;1|1140303:1=99;1|1140503:1=3;4|1150101:1=6000,1150102:1=1500,1150103:1=2500;0|1150401:0=1728,1150402:1=528,1140403:1=170,1150201:1=7520,1150202:1=528,1140203:1=170,1150201:1=0'),(256,1215003,1,1,'1|1150301:1=1060;1|1150501:1=106;1|2150601:1=11;1|1150302:1=244;1|1150502:1=12;1|2150602:1=5;1|1150303:1=66;1|1150503:1=2;0|1150603:1=1;1|13:1=7000;1|10:1=1600;3|47:1=10000;2|45:1=10000;1|1140303:1=154;1|1140503:1=5;4|1150101:1=6000,1150102:1=1500,1150103:1=2500;0|1150401:0=1728,1150402:1=528,1140403:1=170,1150201:1=7520,1150202:1=528,1140203:1=170,1150201:1=0'),(257,1215003,2,2,'1|1150301:1=954;1|1150501:1=95;1|2150601:1=11;1|1150302:1=229;1|1150502:1=11;1|2150602:1=5;1|1150303:1=62;1|1150503:1=2;0|1150603:1=1;1|13:1=7000;1|10:1=1600;3|47:1=10000;1|1140303:1=144;1|1140503:1=5;4|1150101:1=6000,1150102:1=1500,1150103:1=2500;0|1150401:0=1728,1150402:1=528,1140403:1=170,1150201:1=7520,1150202:1=528,1140203:1=170,1150201:1=0'),(258,1215003,3,3,'1|1150301:1=848;1|1150501:1=74;1|2150601:1=11;1|1150302:1=212;1|1150502:1=11;1|2150602:1=5;1|1150303:1=57;1|1150503:1=2;0|1150603:1=1;1|13:1=7000;1|10:1=1600;2|47:1=10000;4|45:1=10000;1|1140303:1=134;1|1140503:1=4;4|1150101:1=6000,1150102:1=1500,1150103:1=2500;0|1150401:0=1728,1150402:1=528,1140403:1=170,1150201:1=7520,1150202:1=528,1140203:1=170,1150201:1=0'),(259,1215003,4,5,'1|1150301:1=742;1|1150501:1=64;1|2150601:1=11;1|1150302:1=180;1|1150502:1=9;1|2150602:1=5;1|1150303:1=49;1|1150503:1=2;0|1150603:1=1;1|13:1=7000;1|10:1=1600;2|47:1=10000;2|45:1=10000;1|1140303:1=114;1|1140503:1=4;4|1150101:1=6000,1150102:1=1500,1150103:1=2500;0|1150401:0=1728,1150402:1=528,1140403:1=170,1150201:1=7520,1150202:1=528,1140203:1=170,1150201:1=0'),(260,1215003,6,10,'1|1150301:1=636;1|1150501:1=42;1|2150601:1=11;1|1150302:1=170;1|1150502:1=8;1|2150602:1=5;1|1150303:1=46;1|1150503:1=2;0|1150603:1=1;1|13:1=7000;1|10:1=1600;2|47:1=10000;2|42:1=10000;1|1140303:1=107;1|1140503:1=4;4|1150101:1=6000,1150102:1=1500,1150103:1=2500;0|1150401:0=1728,1150402:1=528,1140403:1=170,1150201:1=7520,1150202:1=528,1140203:1=170,1150201:1=0'),(286,1351006,1,1,'1|1090301:1=660;1|1090501:1=50;1|2100601:1=10;1|1090302:1=221;1|1090502:1=9;1|2100602:1=3;1|1090303:1=633;1|1090503:1=13;1|1090603:1=5;2|13:=0;1|14:1=0;1|50:1=10000;3|47:1=10000;1|45:1=10000;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;2|1090401:1=1028,1090402:1=472,1090403:1=142,1090201:1=3713,1090202:1=472,1090203:1=142,1090201:1=0;1|1100301:1=660;1|1100501:1=40;1|1100601:1=10;1|1100302:1=221;1|1100502:1=9;1|1100602:1=3;1|1100303:1=633;1|1100503:1=13;1|1100603:1=5'),(287,1351006,2,2,'1|1090301:1=600;1|1090501:1=45;1|2100601:1=10;1|1090302:1=208;1|1090502:1=9;1|2100602:1=3;1|1090303:1=594;1|1090503:1=12;1|1090603:1=5;2|13:=0;1|14:1=0;1|50:1=10000;1|48:1=10000;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;2|1090401:1=1028,1090402:1=472,1090403:1=142,1090201:1=3713,1090202:1=472,1090203:1=142,1090201:1=0;1|1100301:1=600;1|1100501:1=40;1|1100601:1=10;1|1100302:1=208;1|1100502:1=9;1|1100602:1=3;1|1100303:1=594;1|1100503:1=12;1|1100603:1=5'),(288,1351006,3,3,'1|1090301:1=560;1|1090501:1=40;1|2100601:1=5;1|1090302:1=193;1|1090502:1=8;1|2100602:1=3;1|1090303:1=550;1|1090503:1=11;1|1090603:1=5;2|13:=0;1|14:1=0;1|50:1=10000;3|45:1=10000;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;2|1090401:1=1028,1090402:1=472,1090403:1=142,1090201:1=3713,1090202:1=472,1090203:1=142,1090201:1=0;1|1100301:1=560;1|1100501:1=35;1|1100601:1=5;1|1100302:1=193;1|1100502:1=8;1|1100602:1=3;1|1100303:1=550;1|1100503:1=11;1|1100603:1=5'),(289,1351006,4,5,'1|1090301:1=500;1|1090501:1=40;1|2100601:1=5;1|1090302:1=175;1|1090502:1=8;1|2100602:1=3;1|1090303:1=500;1|1090503:1=10;1|1090603:1=5;2|13:=0;1|14:1=0;2|49:1=10000;3|46:1=10000;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;2|1090401:1=1028,1090402:1=472,1090403:1=142,1090201:1=3713,1090202:1=472,1090203:1=142,1090201:1=0;1|1100301:1=500;1|1100501:1=30;1|1100601:1=5;1|1100302:1=175;1|1100502:1=8;1|1100602:1=3;1|1100303:1=500;1|1100503:1=10;1|1100603:1=5'),(290,1351006,6,10,'1|1090301:1=400;1|1090501:1=30;1|2100601:1=5;1|1090302:1=158;1|1090502:1=7;1|2100602:1=3;1|1090303:1=450;1|1090503:1=9;1|1090603:1=5;2|13:=0;1|14:1=0;2|49:1=10000;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;2|1090401:1=1028,1090402:1=472,1090403:1=142,1090201:1=3713,1090202:1=472,1090203:1=142,1090201:1=0;1|1100301:1=400;1|1100501:1=25;1|1100601:1=5;1|1100302:1=158;1|1100502:1=7;1|1100602:1=3;1|1100303:1=450;1|1100503:1=9;1|1100603:1=5'),(291,1351007,1,1,'1|1110301:1=660;1|1110501:1=40;1|2120601:1=10;1|1110302:1=221;1|1110502:1=9;1|2120602:1=3;1|1110303:1=380;1|1110503:1=9;1|1110603:1=3;2|13:=0;1|14:1=0;2|50:1=10000;3|47:1=10000;4|1110101:1=6000,1110102:1=1500,1110103:1=2500;2|1110401:1=1046,1110402:1=424,1110403:1=127,1110201:1=4042,1110202:1=424,1110203:1=127,1110201:1=0;1|1120301:1=660;1|1120501:1=40;1|1120601:1=10;1|1120302:1=127;1|1120502:1=6;1|1120602:1=3;1|1120303:1=380;1|1120503:1=6;1|1120603:1=3'),(292,1351007,2,2,'1|1110301:1=600;1|1110501:1=40;1|2120601:1=10;1|1110302:1=208;1|1110502:1=9;1|2120602:1=3;1|1110303:1=356;1|1110503:1=9;1|1110603:1=3;2|13:=0;1|14:1=0;2|50:1=10000;1|47:1=10000;4|1110101:1=6000,1110102:1=1500,1110103:1=2500;2|1110401:1=1046,1110402:1=424,1110403:1=127,1110201:1=4042,1110202:1=424,1110203:1=127,1110201:1=0;1|1120301:1=600;1|1120501:1=40;1|1120601:1=10;1|1120302:1=119;1|1120502:1=6;1|1120602:1=3;1|1120303:1=356;1|1120503:1=6;1|1120603:1=3'),(293,1351007,3,3,'1|1110301:1=560;1|1110501:1=35;1|2120601:1=5;1|1110302:1=193;1|1110502:1=8;1|2120602:1=3;1|1110303:1=330;1|1110503:1=8;1|1110603:1=3;2|13:=0;1|14:1=0;1|50:1=10000;2|49:1=10000;3|45:1=10000;4|1110101:1=6000,1110102:1=1500,1110103:1=2500;2|1110401:1=1046,1110402:1=424,1110403:1=127,1110201:1=4042,1110202:1=424,1110203:1=127,1110201:1=0;1|1120301:1=560;1|1120501:1=35;1|1120601:1=5;1|1120302:1=110;1|1120502:1=6;1|1120602:1=3;1|1120303:1=330;1|1120503:1=6;1|1120603:1=3'),(294,1351007,4,5,'1|1110301:1=500;1|1110501:1=30;1|2120601:1=5;1|1110302:1=175;1|1110502:1=8;1|2120602:1=3;1|1110303:1=300;1|1110503:1=8;1|1110603:1=3;2|13:=0;1|14:1=0;1|50:1=10000;1|49:1=10000;1|48:1=10000;4|1110101:1=6000,1110102:1=1500,1110103:1=2500;2|1110401:1=1046,1110402:1=424,1110403:1=127,1110201:1=4042,1110202:1=424,1110203:1=127,1110201:1=0;1|1120301:1=500;1|1120501:1=30;1|1120601:1=5;1|1120302:1=100;1|1120502:1=5;1|1120602:1=3;1|1120303:1=300;1|1120503:1=5;1|1120603:1=3'),(295,1351007,6,10,'1|1110301:1=400;1|1110501:1=25;1|2120601:1=5;1|1110302:1=158;1|1110502:1=7;1|2120602:1=3;1|1110303:1=270;1|1110503:1=7;1|1110603:1=3;2|13:=0;1|14:1=0;1|50:1=10000;1|49:1=10000;4|1110101:1=6000,1110102:1=1500,1110103:1=2500;2|1110401:1=1046,1110402:1=424,1110403:1=127,1110201:1=4042,1110202:1=424,1110203:1=127,1110201:1=0;1|1120301:1=400;1|1120501:1=25;1|1120601:1=5;1|1120302:1=90;1|1120502:1=5;1|1120602:1=3;1|1120303:1=270;1|1120503:1=5;1|1120603:1=3'),(296,1251001,1,1,'1|1020301:1=2500;1|1020501:1=250;1|1020302:1=575;1|1020502:1=58;1|1020303:1=72;1|1020503:1=7;1|1020303:1=97;1|1020503:1=12;4|1020101:1=6000,1020102:1=1500,1020103:1=2500;1|1020401:1=969,1020402:1=637,1010403:1=198,1020201:1=2564,1020202:1=637,1010203:1=198,1020201:1=0'),(297,1251001,2,2,'1|1020301:1=2250;1|1020501:1=250;1|1020302:1=540;1|1020502:1=54;1|1020303:1=68;1|1020503:1=7;1|1020303:1=91;1|1020503:1=11;4|1020101:1=6000,1020102:1=1500,1020103:1=2500;1|1020401:1=969,1020402:1=637,1010403:1=198,1020201:1=2564,1020202:1=637,1010203:1=198,1020201:1=0'),(298,1251001,3,3,'1|1020301:1=2000;1|1020501:1=200;1|1020302:1=500;1|1020502:1=50;1|1020303:1=63;1|1020503:1=6;1|1020303:1=84;1|1020503:1=11;4|1020101:1=6000,1020102:1=1500,1020103:1=2500;1|1020401:1=969,1020402:1=637,1010403:1=198,1020201:1=2564,1020202:1=637,1010203:1=198,1020201:1=0'),(299,1251001,4,5,'1|1020301:1=1750;1|1020501:1=150;1|1020302:1=425;1|1020502:1=43;1|1020303:1=53;1|1020503:1=5;1|1020303:1=71;1|1020503:1=9;4|1020101:1=6000,1020102:1=1500,1020103:1=2500;1|1020401:1=969,1020402:1=637,1010403:1=198,1020201:1=2564,1020202:1=637,1010203:1=198,1020201:1=0'),(300,1251001,6,10,'1|1020301:1=1500;1|1020501:1=150;1|1020302:1=400;1|1020502:1=40;1|1020303:1=50;1|1020503:1=5;1|1020303:1=67;1|1020503:1=8;4|1020101:1=6000,1020102:1=1500,1020103:1=2500;1|1020401:1=969,1020402:1=637,1010403:1=198,1020201:1=2564,1020202:1=637,1010203:1=198,1020201:1=0'),(301,1251002,1,1,'1|1020301:1=2500;1|1020501:1=250;1|1020302:1=575;1|1020502:1=58;1|1020303:1=72;1|1020503:1=7;1|1020303:1=97;1|1020503:1=12;4|1020101:1=6000,1020102:1=1500,1020103:1=2500;1|1020401:1=969,1020402:1=637,1010403:1=198,1020201:1=2564,1020202:1=637,1010203:1=198,1020201:1=0'),(302,1251002,2,2,'1|1020301:1=2250;1|1020501:1=250;1|1020302:1=540;1|1020502:1=54;1|1020303:1=68;1|1020503:1=7;1|1020303:1=91;1|1020503:1=11;4|1020101:1=6000,1020102:1=1500,1020103:1=2500;1|1020401:1=969,1020402:1=637,1010403:1=198,1020201:1=2564,1020202:1=637,1010203:1=198,1020201:1=0'),(303,1251002,3,3,'1|1020301:1=2000;1|1020501:1=200;1|1020302:1=500;1|1020502:1=50;1|1020303:1=63;1|1020503:1=6;1|1020303:1=84;1|1020503:1=11;4|1020101:1=6000,1020102:1=1500,1020103:1=2500;1|1020401:1=969,1020402:1=637,1010403:1=198,1020201:1=2564,1020202:1=637,1010203:1=198,1020201:1=0'),(304,1251002,4,5,'1|1020301:1=1750;1|1020501:1=150;1|1020302:1=425;1|1020502:1=43;1|1020303:1=53;1|1020503:1=5;1|1020303:1=71;1|1020503:1=9;4|1020101:1=6000,1020102:1=1500,1020103:1=2500;1|1020401:1=969,1020402:1=637,1010403:1=198,1020201:1=2564,1020202:1=637,1010203:1=198,1020201:1=0'),(305,1251002,6,10,'1|1020301:1=1500;1|1020501:1=150;1|1020302:1=400;1|1020502:1=40;1|1020303:1=50;1|1020503:1=5;1|1020303:1=67;1|1020503:1=8;4|1020101:1=6000,1020102:1=1500,1020103:1=2500;1|1020401:1=969,1020402:1=637,1010403:1=198,1020201:1=2564,1020202:1=637,1010203:1=198,1020201:1=0'),(306,1251003,1,1,'1|1030301:1=2500;1|1030501:1=250;1|1030302:1=575;1|1030502:1=58;1|1030303:1=72;1|1030503:1=7;1|1020303:1=97;1|1020503:1=12;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;1|1030401:1=978,1030402:1=613,1020403:1=191,1030201:1=2730,1030202:1=613,1020203:1=191,1030201:1=0'),(307,1251003,2,2,'1|1030301:1=2250;1|1030501:1=250;1|1030302:1=540;1|1030502:1=54;1|1030303:1=68;1|1030503:1=7;1|1020303:1=91;1|1020503:1=11;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;1|1030401:1=978,1030402:1=613,1020403:1=191,1030201:1=2730,1030202:1=613,1020203:1=191,1030201:1=0'),(308,1251003,3,3,'1|1030301:1=2000;1|1030501:1=200;1|1030302:1=500;1|1030502:1=50;1|1030303:1=63;1|1030503:1=6;1|1020303:1=84;1|1020503:1=11;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;1|1030401:1=978,1030402:1=613,1020403:1=191,1030201:1=2730,1030202:1=613,1020203:1=191,1030201:1=0'),(309,1251003,4,5,'1|1030301:1=1750;1|1030501:1=150;1|1030302:1=425;1|1030502:1=43;1|1030303:1=53;1|1030503:1=5;1|1020303:1=71;1|1020503:1=9;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;1|1030401:1=978,1030402:1=613,1020403:1=191,1030201:1=2730,1030202:1=613,1020203:1=191,1030201:1=0'),(310,1251003,6,10,'1|1030301:1=1500;1|1030501:1=150;1|1030302:1=400;1|1030502:1=40;1|1030303:1=50;1|1030503:1=5;1|1020303:1=67;1|1020503:1=8;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;1|1030401:1=978,1030402:1=613,1020403:1=191,1030201:1=2730,1030202:1=613,1020203:1=191,1030201:1=0'),(311,1251004,1,1,'1|1030301:1=2500;1|1030501:1=250;1|1030302:1=575;1|1030502:1=58;1|1030303:1=72;1|1030503:1=7;1|1020303:1=97;1|1020503:1=12;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;1|1030401:1=978,1030402:1=613,1020403:1=191,1030201:1=2730,1030202:1=613,1020203:1=191,1030201:1=0'),(312,1251004,2,2,'1|1030301:1=2250;1|1030501:1=250;1|1030302:1=540;1|1030502:1=54;1|1030303:1=68;1|1030503:1=7;1|1020303:1=91;1|1020503:1=11;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;1|1030401:1=978,1030402:1=613,1020403:1=191,1030201:1=2730,1030202:1=613,1020203:1=191,1030201:1=0'),(313,1251004,3,3,'1|1030301:1=2000;1|1030501:1=200;1|1030302:1=500;1|1030502:1=50;1|1030303:1=63;1|1030503:1=6;1|1020303:1=84;1|1020503:1=11;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;1|1030401:1=978,1030402:1=613,1020403:1=191,1030201:1=2730,1030202:1=613,1020203:1=191,1030201:1=0'),(314,1251004,4,5,'1|1030301:1=1750;1|1030501:1=150;1|1030302:1=425;1|1030502:1=43;1|1030303:1=53;1|1030503:1=5;1|1020303:1=71;1|1020503:1=9;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;1|1030401:1=978,1030402:1=613,1020403:1=191,1030201:1=2730,1030202:1=613,1020203:1=191,1030201:1=0'),(315,1251004,6,10,'1|1030301:1=1500;1|1030501:1=150;1|1030302:1=400;1|1030502:1=40;1|1030303:1=50;1|1030503:1=5;1|1020303:1=67;1|1020503:1=8;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;1|1030401:1=978,1030402:1=613,1020403:1=191,1030201:1=2730,1030202:1=613,1020203:1=191,1030201:1=0'),(316,1251005,1,1,'1|1040301:1=1750;1|1040501:1=225;1|1040302:1=345;1|1040502:1=35;1|1040303:1=230;1|1040503:1=29;1|1030303:1=97;1|1030503:1=12;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;1|1040401:1=986,1040402:1=589,1030403:1=184,1040201:1=2892,1040202:1=589,1030203:1=184,1040201:1=0'),(317,1251005,2,2,'1|1040301:1=1500;1|1040501:1=200;1|1040302:1=324;1|1040502:1=32;1|1040303:1=216;1|1040503:1=27;1|1030303:1=91;1|1030503:1=11;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;1|1040401:1=986,1040402:1=589,1030403:1=184,1040201:1=2892,1040202:1=589,1030203:1=184,1040201:1=0'),(318,1251005,3,3,'1|1040301:1=1250;1|1040501:1=175;1|1040302:1=300;1|1040502:1=30;1|1040303:1=200;1|1040503:1=25;1|1030303:1=84;1|1030503:1=11;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;1|1040401:1=986,1040402:1=589,1030403:1=184,1040201:1=2892,1040202:1=589,1030203:1=184,1040201:1=0'),(319,1251005,4,5,'1|1040301:1=1000;1|1040501:1=150;1|1040302:1=255;1|1040502:1=26;1|1040303:1=170;1|1040503:1=21;1|1030303:1=71;1|1030503:1=9;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;1|1040401:1=986,1040402:1=589,1030403:1=184,1040201:1=2892,1040202:1=589,1030203:1=184,1040201:1=0'),(320,1251005,6,10,'1|1040301:1=1000;1|1040501:1=125;1|1040302:1=240;1|1040502:1=24;1|1040303:1=160;1|1040503:1=20;1|1030303:1=67;1|1030503:1=8;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;1|1040401:1=986,1040402:1=589,1030403:1=184,1040201:1=2892,1040202:1=589,1030203:1=184,1040201:1=0'),(321,1251006,1,1,'1|1040301:1=1750;1|1040501:1=225;1|1040302:1=345;1|1040502:1=35;1|1040303:1=230;1|1040503:1=29;1|1030303:1=97;1|1030503:1=12;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;1|1040401:1=986,1040402:1=589,1030403:1=184,1040201:1=2892,1040202:1=589,1030203:1=184,1040201:1=0'),(322,1251006,2,2,'1|1040301:1=1500;1|1040501:1=200;1|1040302:1=324;1|1040502:1=32;1|1040303:1=216;1|1040503:1=27;1|1030303:1=91;1|1030503:1=11;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;1|1040401:1=986,1040402:1=589,1030403:1=184,1040201:1=2892,1040202:1=589,1030203:1=184,1040201:1=0'),(323,1251006,3,3,'1|1040301:1=1250;1|1040501:1=175;1|1040302:1=300;1|1040502:1=30;1|1040303:1=200;1|1040503:1=25;1|1030303:1=84;1|1030503:1=11;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;1|1040401:1=986,1040402:1=589,1030403:1=184,1040201:1=2892,1040202:1=589,1030203:1=184,1040201:1=0'),(324,1251006,4,5,'1|1040301:1=1000;1|1040501:1=150;1|1040302:1=255;1|1040502:1=26;1|1040303:1=170;1|1040503:1=21;1|1030303:1=71;1|1030503:1=9;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;1|1040401:1=986,1040402:1=589,1030403:1=184,1040201:1=2892,1040202:1=589,1030203:1=184,1040201:1=0'),(325,1251006,6,10,'1|1040301:1=1000;1|1040501:1=125;1|1040302:1=240;1|1040502:1=24;1|1040303:1=160;1|1040503:1=20;1|1030303:1=67;1|1030503:1=8;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;1|1040401:1=986,1040402:1=589,1030403:1=184,1040201:1=2892,1040202:1=589,1030203:1=184,1040201:1=0'),(326,1251007,1,1,'1|1050301:1=1500;1|1050501:1=125;1|1050302:1=403;1|1050502:1=35;1|1050303:1=201;1|1050503:1=23;1|1040303:1=85;1|1040503:1=10;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;1|1050401:1=994,1050402:1=566,1040403:1=177,1050201:1=3058,1050202:1=566,1040203:1=177,1050201:1=0'),(327,1251007,2,2,'1|1050301:1=1250;1|1050501:1=120;1|1050302:1=378;1|1050502:1=32;1|1050303:1=189;1|1050503:1=22;1|1040303:1=79;1|1040503:1=9;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;1|1050401:1=994,1050402:1=566,1040403:1=177,1050201:1=3058,1050202:1=566,1040203:1=177,1050201:1=0'),(328,1251007,3,3,'1|1050301:1=1000;1|1050501:1=105;1|1050302:1=350;1|1050502:1=30;1|1050303:1=175;1|1050503:1=20;1|1040303:1=74;1|1040503:1=8;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;1|1050401:1=994,1050402:1=566,1040403:1=177,1050201:1=3058,1050202:1=566,1040203:1=177,1050201:1=0'),(329,1251007,4,5,'1|1050301:1=750;1|1050501:1=90;1|1050302:1=298;1|1050502:1=26;1|1050303:1=149;1|1050503:1=17;1|1040303:1=62;1|1040503:1=7;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;1|1050401:1=994,1050402:1=566,1040403:1=177,1050201:1=3058,1050202:1=566,1040203:1=177,1050201:1=0'),(330,1251007,6,10,'1|1050301:1=750;1|1050501:1=75;1|1050302:1=280;1|1050502:1=24;1|1050303:1=140;1|1050503:1=16;1|1040303:1=59;1|1040503:1=7;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;1|1050401:1=994,1050402:1=566,1040403:1=177,1050201:1=3058,1050202:1=566,1040203:1=177,1050201:1=0'),(331,1251008,1,1,'1|1050301:1=1500;1|1050501:1=125;1|1050302:1=403;1|1050502:1=35;1|1050303:1=201;1|1050503:1=23;1|1040303:1=85;1|1040503:1=10;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;1|1050401:1=994,1050402:1=566,1040403:1=177,1050201:1=3058,1050202:1=566,1040203:1=177,1050201:1=0'),(332,1251008,2,2,'1|1050301:1=1250;1|1050501:1=120;1|1050302:1=378;1|1050502:1=32;1|1050303:1=189;1|1050503:1=22;1|1040303:1=79;1|1040503:1=9;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;1|1050401:1=994,1050402:1=566,1040403:1=177,1050201:1=3058,1050202:1=566,1040203:1=177,1050201:1=0'),(333,1251008,3,3,'1|1050301:1=1000;1|1050501:1=105;1|1050302:1=350;1|1050502:1=30;1|1050303:1=175;1|1050503:1=20;1|1040303:1=74;1|1040503:1=8;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;1|1050401:1=994,1050402:1=566,1040403:1=177,1050201:1=3058,1050202:1=566,1040203:1=177,1050201:1=0'),(334,1251008,4,5,'1|1050301:1=750;1|1050501:1=90;1|1050302:1=298;1|1050502:1=26;1|1050303:1=149;1|1050503:1=17;1|1040303:1=62;1|1040503:1=7;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;1|1050401:1=994,1050402:1=566,1040403:1=177,1050201:1=3058,1050202:1=566,1040203:1=177,1050201:1=0'),(335,1251008,6,10,'1|1050301:1=750;1|1050501:1=75;1|1050302:1=280;1|1050502:1=24;1|1050303:1=140;1|1050503:1=16;1|1040303:1=59;1|1040503:1=7;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;1|1050401:1=994,1050402:1=566,1040403:1=177,1050201:1=3058,1050202:1=566,1040203:1=177,1050201:1=0'),(336,1252001,1,1,'1|1030301:1=2500;1|1030501:1=250;1|1030302:1=575;1|1030502:1=58;1|1030303:1=72;1|1030503:1=7;1|1020303:1=97;1|1020503:1=12;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;1|1030401:1=978,1030402:1=613,1020403:1=191,1030201:1=2730,1030202:1=613,1020203:1=191,1030201:1=0'),(337,1252001,2,2,'1|1030301:1=2250;1|1030501:1=250;1|1030302:1=540;1|1030502:1=54;1|1030303:1=68;1|1030503:1=7;1|1020303:1=91;1|1020503:1=11;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;1|1030401:1=978,1030402:1=613,1020403:1=191,1030201:1=2730,1030202:1=613,1020203:1=191,1030201:1=0'),(338,1252001,3,3,'1|1030301:1=2000;1|1030501:1=200;1|1030302:1=500;1|1030502:1=50;1|1030303:1=63;1|1030503:1=6;1|1020303:1=84;1|1020503:1=11;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;1|1030401:1=978,1030402:1=613,1020403:1=191,1030201:1=2730,1030202:1=613,1020203:1=191,1030201:1=0'),(339,1252001,4,5,'1|1030301:1=1750;1|1030501:1=150;1|1030302:1=425;1|1030502:1=43;1|1030303:1=53;1|1030503:1=5;1|1020303:1=71;1|1020503:1=9;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;1|1030401:1=978,1030402:1=613,1020403:1=191,1030201:1=2730,1030202:1=613,1020203:1=191,1030201:1=0'),(340,1252001,6,10,'1|1030301:1=1500;1|1030501:1=150;1|1030302:1=400;1|1030502:1=40;1|1030303:1=50;1|1030503:1=5;1|1020303:1=67;1|1020503:1=8;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;1|1030401:1=978,1030402:1=613,1020403:1=191,1030201:1=2730,1030202:1=613,1020203:1=191,1030201:1=0'),(341,1252002,1,1,'1|1030301:1=2500;1|1030501:1=250;1|1030302:1=575;1|1030502:1=58;1|1030303:1=72;1|1030503:1=7;1|1020303:1=97;1|1020503:1=12;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;1|1030401:1=978,1030402:1=613,1020403:1=191,1030201:1=2730,1030202:1=613,1020203:1=191,1030201:1=0'),(342,1252002,2,2,'1|1030301:1=2250;1|1030501:1=250;1|1030302:1=540;1|1030502:1=54;1|1030303:1=68;1|1030503:1=7;1|1020303:1=91;1|1020503:1=11;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;1|1030401:1=978,1030402:1=613,1020403:1=191,1030201:1=2730,1030202:1=613,1020203:1=191,1030201:1=0'),(343,1252002,3,3,'1|1030301:1=2000;1|1030501:1=200;1|1030302:1=500;1|1030502:1=50;1|1030303:1=63;1|1030503:1=6;1|1020303:1=84;1|1020503:1=11;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;1|1030401:1=978,1030402:1=613,1020403:1=191,1030201:1=2730,1030202:1=613,1020203:1=191,1030201:1=0'),(344,1252002,4,5,'1|1030301:1=1750;1|1030501:1=150;1|1030302:1=425;1|1030502:1=43;1|1030303:1=53;1|1030503:1=5;1|1020303:1=71;1|1020503:1=9;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;1|1030401:1=978,1030402:1=613,1020403:1=191,1030201:1=2730,1030202:1=613,1020203:1=191,1030201:1=0'),(345,1252002,6,10,'1|1030301:1=1500;1|1030501:1=150;1|1030302:1=400;1|1030502:1=40;1|1030303:1=50;1|1030503:1=5;1|1020303:1=67;1|1020503:1=8;4|1030101:1=6000,1030102:1=1500,1030103:1=2500;1|1030401:1=978,1030402:1=613,1020403:1=191,1030201:1=2730,1030202:1=613,1020203:1=191,1030201:1=0'),(346,1252003,1,1,'1|1040301:1=1750;1|1040501:1=225;1|1040302:1=345;1|1040502:1=35;1|1040303:1=230;1|1040503:1=29;1|1030303:1=97;1|1030503:1=12;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;1|1040401:1=986,1040402:1=589,1030403:1=184,1040201:1=2892,1040202:1=589,1030203:1=184,1040201:1=0'),(347,1252003,2,2,'1|1040301:1=1500;1|1040501:1=200;1|1040302:1=324;1|1040502:1=32;1|1040303:1=216;1|1040503:1=27;1|1030303:1=91;1|1030503:1=11;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;1|1040401:1=986,1040402:1=589,1030403:1=184,1040201:1=2892,1040202:1=589,1030203:1=184,1040201:1=0'),(348,1252003,3,3,'1|1040301:1=1250;1|1040501:1=175;1|1040302:1=300;1|1040502:1=30;1|1040303:1=200;1|1040503:1=25;1|1030303:1=84;1|1030503:1=11;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;1|1040401:1=986,1040402:1=589,1030403:1=184,1040201:1=2892,1040202:1=589,1030203:1=184,1040201:1=0'),(349,1252003,4,5,'1|1040301:1=1000;1|1040501:1=150;1|1040302:1=255;1|1040502:1=26;1|1040303:1=170;1|1040503:1=21;1|1030303:1=71;1|1030503:1=9;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;1|1040401:1=986,1040402:1=589,1030403:1=184,1040201:1=2892,1040202:1=589,1030203:1=184,1040201:1=0'),(350,1252003,6,10,'1|1040301:1=1000;1|1040501:1=125;1|1040302:1=240;1|1040502:1=24;1|1040303:1=160;1|1040503:1=20;1|1030303:1=67;1|1030503:1=8;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;1|1040401:1=986,1040402:1=589,1030403:1=184,1040201:1=2892,1040202:1=589,1030203:1=184,1040201:1=0'),(351,1252004,1,1,'1|1040301:1=1750;1|1040501:1=225;1|1040302:1=345;1|1040502:1=35;1|1040303:1=230;1|1040503:1=29;1|1030303:1=97;1|1030503:1=12;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;1|1040401:1=986,1040402:1=589,1030403:1=184,1040201:1=2892,1040202:1=589,1030203:1=184,1040201:1=0'),(352,1252004,2,2,'1|1040301:1=1500;1|1040501:1=200;1|1040302:1=324;1|1040502:1=32;1|1040303:1=216;1|1040503:1=27;1|1030303:1=91;1|1030503:1=11;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;1|1040401:1=986,1040402:1=589,1030403:1=184,1040201:1=2892,1040202:1=589,1030203:1=184,1040201:1=0'),(353,1252004,3,3,'1|1040301:1=1250;1|1040501:1=175;1|1040302:1=300;1|1040502:1=30;1|1040303:1=200;1|1040503:1=25;1|1030303:1=84;1|1030503:1=11;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;1|1040401:1=986,1040402:1=589,1030403:1=184,1040201:1=2892,1040202:1=589,1030203:1=184,1040201:1=0'),(354,1252004,4,5,'1|1040301:1=1000;1|1040501:1=150;1|1040302:1=255;1|1040502:1=26;1|1040303:1=170;1|1040503:1=21;1|1030303:1=71;1|1030503:1=9;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;1|1040401:1=986,1040402:1=589,1030403:1=184,1040201:1=2892,1040202:1=589,1030203:1=184,1040201:1=0'),(355,1252004,6,10,'1|1040301:1=1000;1|1040501:1=125;1|1040302:1=240;1|1040502:1=24;1|1040303:1=160;1|1040503:1=20;1|1030303:1=67;1|1030503:1=8;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;1|1040401:1=986,1040402:1=589,1030403:1=184,1040201:1=2892,1040202:1=589,1030203:1=184,1040201:1=0'),(356,1252005,1,1,'1|1050301:1=1500;1|1050501:1=125;1|1050302:1=403;1|1050502:1=35;1|1050303:1=201;1|1050503:1=23;1|1040303:1=85;1|1040503:1=10;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;1|1050401:1=994,1050402:1=566,1040403:1=177,1050201:1=3058,1050202:1=566,1040203:1=177,1050201:1=0'),(357,1252005,2,2,'1|1050301:1=1250;1|1050501:1=120;1|1050302:1=378;1|1050502:1=32;1|1050303:1=189;1|1050503:1=22;1|1040303:1=79;1|1040503:1=9;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;1|1050401:1=994,1050402:1=566,1040403:1=177,1050201:1=3058,1050202:1=566,1040203:1=177,1050201:1=0'),(358,1252005,3,3,'1|1050301:1=1000;1|1050501:1=105;1|1050302:1=350;1|1050502:1=30;1|1050303:1=175;1|1050503:1=20;1|1040303:1=74;1|1040503:1=8;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;1|1050401:1=994,1050402:1=566,1040403:1=177,1050201:1=3058,1050202:1=566,1040203:1=177,1050201:1=0'),(359,1252005,4,5,'1|1050301:1=750;1|1050501:1=90;1|1050302:1=298;1|1050502:1=26;1|1050303:1=149;1|1050503:1=17;1|1040303:1=62;1|1040503:1=7;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;1|1050401:1=994,1050402:1=566,1040403:1=177,1050201:1=3058,1050202:1=566,1040203:1=177,1050201:1=0'),(360,1252005,6,10,'1|1050301:1=750;1|1050501:1=75;1|1050302:1=280;1|1050502:1=24;1|1050303:1=140;1|1050503:1=16;1|1040303:1=59;1|1040503:1=7;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;1|1050401:1=994,1050402:1=566,1040403:1=177,1050201:1=3058,1050202:1=566,1040203:1=177,1050201:1=0'),(361,1252006,1,1,'1|1050301:1=1500;1|1050501:1=125;1|1050302:1=403;1|1050502:1=35;1|1050303:1=201;1|1050503:1=23;1|1040303:1=85;1|1040503:1=10;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;1|1050401:1=994,1050402:1=566,1040403:1=177,1050201:1=3058,1050202:1=566,1040203:1=177,1050201:1=0'),(362,1252006,2,2,'1|1050301:1=1250;1|1050501:1=120;1|1050302:1=378;1|1050502:1=32;1|1050303:1=189;1|1050503:1=22;1|1040303:1=79;1|1040503:1=9;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;1|1050401:1=994,1050402:1=566,1040403:1=177,1050201:1=3058,1050202:1=566,1040203:1=177,1050201:1=0'),(363,1252006,3,3,'1|1050301:1=1000;1|1050501:1=105;1|1050302:1=350;1|1050502:1=30;1|1050303:1=175;1|1050503:1=20;1|1040303:1=74;1|1040503:1=8;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;1|1050401:1=994,1050402:1=566,1040403:1=177,1050201:1=3058,1050202:1=566,1040203:1=177,1050201:1=0'),(364,1252006,4,5,'1|1050301:1=750;1|1050501:1=90;1|1050302:1=298;1|1050502:1=26;1|1050303:1=149;1|1050503:1=17;1|1040303:1=62;1|1040503:1=7;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;1|1050401:1=994,1050402:1=566,1040403:1=177,1050201:1=3058,1050202:1=566,1040203:1=177,1050201:1=0'),(365,1252006,6,10,'1|1050301:1=750;1|1050501:1=75;1|1050302:1=280;1|1050502:1=24;1|1050303:1=140;1|1050503:1=16;1|1040303:1=59;1|1040503:1=7;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;1|1050401:1=994,1050402:1=566,1040403:1=177,1050201:1=3058,1050202:1=566,1040203:1=177,1050201:1=0'),(366,1252007,1,1,'1|1060301:1=1250;1|1060501:1=125;1|1060302:1=230;1|1060502:1=17;1|1060303:1=115;1|1060503:1=12;1|1050303:1=48;1|1050503:1=5;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;1|1060401:1=1003,1060402:1=543,1050403:1=170,1060201:1=3222,1060202:1=543,1050203:1=170,1060201:1=0'),(367,1252007,2,2,'1|1060301:1=1000;1|1060501:1=120;1|1060302:1=216;1|1060502:1=16;1|1060303:1=108;1|1060503:1=11;1|1050303:1=45;1|1050503:1=5;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;1|1060401:1=1003,1060402:1=543,1050403:1=170,1060201:1=3222,1060202:1=543,1050203:1=170,1060201:1=0'),(368,1252007,3,3,'1|1060301:1=750;1|1060501:1=105;1|1060302:1=200;1|1060502:1=15;1|1060303:1=100;1|1060503:1=10;1|1050303:1=42;1|1050503:1=4;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;1|1060401:1=1003,1060402:1=543,1050403:1=170,1060201:1=3222,1060202:1=543,1050203:1=170,1060201:1=0'),(369,1252007,4,5,'1|1060301:1=500;1|1060501:1=90;1|1060302:1=170;1|1060502:1=13;1|1060303:1=85;1|1060503:1=9;1|1050303:1=36;1|1050503:1=4;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;1|1060401:1=1003,1060402:1=543,1050403:1=170,1060201:1=3222,1060202:1=543,1050203:1=170,1060201:1=0'),(370,1252007,6,10,'1|1060301:1=500;1|1060501:1=75;1|1060302:1=160;1|1060502:1=12;1|1060303:1=80;1|1060503:1=8;1|1050303:1=34;1|1050503:1=3;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;1|1060401:1=1003,1060402:1=543,1050403:1=170,1060201:1=3222,1060202:1=543,1050203:1=170,1060201:1=0'),(371,1252008,1,1,'1|1070301:1=625;1|1070501:1=50;1|1070302:1=58;1|1070502:1=6;1|1070303:1=58;1|1070503:1=6;1|1060301:1=625;1|1060501:1=63;0|1060302:1=115;1|1060502:1=9;1|1060303:1=58;1|1060503:1=6;1|1050303:1=24;1|1050503:1=2;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;1|1060401:1=1003,1060402:1=543,1050403:1=170,1060201:1=3222,1060202:1=543,1050203:1=170,1060201:1=0'),(372,1252008,2,2,'1|1070301:1=500;1|1070501:1=60;1|1070302:1=54;1|1070502:1=5;1|1070303:1=54;1|1070503:1=5;1|1060301:1=500;1|1060501:1=60;0|1060302:1=108;1|1060502:1=8;1|1060303:1=54;1|1060503:1=5;1|1050303:1=23;1|1050503:1=2;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;1|1060401:1=1003,1060402:1=543,1050403:1=170,1060201:1=3222,1060202:1=543,1050203:1=170,1060201:1=0'),(373,1252008,3,3,'1|1070301:1=375;1|1070501:1=53;1|1070302:1=50;1|1070502:1=5;1|1070303:1=50;1|1070503:1=5;1|1060301:1=375;1|1060501:1=53;0|1060302:1=100;1|1060502:1=8;1|1060303:1=50;1|1060503:1=5;1|1050303:1=21;1|1050503:1=2;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;1|1060401:1=1003,1060402:1=543,1050403:1=170,1060201:1=3222,1060202:1=543,1050203:1=170,1060201:1=0'),(374,1252008,4,5,'1|1070301:1=250;1|1070501:1=45;1|1070302:1=43;1|1070502:1=4;1|1070303:1=43;1|1070503:1=4;1|1060301:1=250;1|1060501:1=45;0|1060302:1=85;1|1060502:1=6;1|1060303:1=43;1|1060503:1=4;1|1050303:1=18;1|1050503:1=2;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;1|1060401:1=1003,1060402:1=543,1050403:1=170,1060201:1=3222,1060202:1=543,1050203:1=170,1060201:1=0'),(375,1252008,6,10,'1|1070301:1=250;1|1070501:1=38;1|1070302:1=40;1|1070502:1=4;1|1070303:1=40;1|1070503:1=4;1|1060301:1=250;1|1060501:1=38;0|1060302:1=80;1|1060502:1=6;1|1060303:1=40;1|1060503:1=4;1|1050303:1=17;1|1050503:1=2;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;1|1060401:1=1003,1060402:1=543,1050403:1=170,1060201:1=3222,1060202:1=543,1050203:1=170,1060201:1=0'),(376,1253001,1,1,'1|1040301:1=1750;1|1040501:1=225;1|1040302:1=345;1|1040502:1=35;1|1040303:1=230;1|1040503:1=29;1|1030303:1=97;1|1030503:1=12;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;1|1040401:1=986,1040402:1=589,1030403:1=184,1040201:1=2892,1040202:1=589,1030203:1=184,1040201:1=0'),(377,1253001,2,2,'1|1040301:1=1500;1|1040501:1=200;1|1040302:1=324;1|1040502:1=32;1|1040303:1=216;1|1040503:1=27;1|1030303:1=91;1|1030503:1=11;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;1|1040401:1=986,1040402:1=589,1030403:1=184,1040201:1=2892,1040202:1=589,1030203:1=184,1040201:1=0'),(378,1253001,3,3,'1|1040301:1=1250;1|1040501:1=175;1|1040302:1=300;1|1040502:1=30;1|1040303:1=200;1|1040503:1=25;1|1030303:1=84;1|1030503:1=11;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;1|1040401:1=986,1040402:1=589,1030403:1=184,1040201:1=2892,1040202:1=589,1030203:1=184,1040201:1=0'),(379,1253001,4,5,'1|1040301:1=1000;1|1040501:1=150;1|1040302:1=255;1|1040502:1=26;1|1040303:1=170;1|1040503:1=21;1|1030303:1=71;1|1030503:1=9;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;1|1040401:1=986,1040402:1=589,1030403:1=184,1040201:1=2892,1040202:1=589,1030203:1=184,1040201:1=0'),(380,1253001,6,10,'1|1040301:1=1000;1|1040501:1=125;1|1040302:1=240;1|1040502:1=24;1|1040303:1=160;1|1040503:1=20;1|1030303:1=67;1|1030503:1=8;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;1|1040401:1=986,1040402:1=589,1030403:1=184,1040201:1=2892,1040202:1=589,1030203:1=184,1040201:1=0'),(381,1253002,1,1,'1|1040301:1=1750;1|1040501:1=225;1|1040302:1=345;1|1040502:1=35;1|1040303:1=230;1|1040503:1=29;1|1030303:1=97;1|1030503:1=12;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;1|1040401:1=986,1040402:1=589,1030403:1=184,1040201:1=2892,1040202:1=589,1030203:1=184,1040201:1=0'),(382,1253002,2,2,'1|1040301:1=1500;1|1040501:1=200;1|1040302:1=324;1|1040502:1=32;1|1040303:1=216;1|1040503:1=27;1|1030303:1=91;1|1030503:1=11;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;1|1040401:1=986,1040402:1=589,1030403:1=184,1040201:1=2892,1040202:1=589,1030203:1=184,1040201:1=0'),(383,1253002,3,3,'1|1040301:1=1250;1|1040501:1=175;1|1040302:1=300;1|1040502:1=30;1|1040303:1=200;1|1040503:1=25;1|1030303:1=84;1|1030503:1=11;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;1|1040401:1=986,1040402:1=589,1030403:1=184,1040201:1=2892,1040202:1=589,1030203:1=184,1040201:1=0'),(384,1253002,4,5,'1|1040301:1=1000;1|1040501:1=150;1|1040302:1=255;1|1040502:1=26;1|1040303:1=170;1|1040503:1=21;1|1030303:1=71;1|1030503:1=9;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;1|1040401:1=986,1040402:1=589,1030403:1=184,1040201:1=2892,1040202:1=589,1030203:1=184,1040201:1=0'),(385,1253002,6,10,'1|1040301:1=1000;1|1040501:1=125;1|1040302:1=240;1|1040502:1=24;1|1040303:1=160;1|1040503:1=20;1|1030303:1=67;1|1030503:1=8;4|1040101:1=6000,1040102:1=1500,1040103:1=2500;1|1040401:1=986,1040402:1=589,1030403:1=184,1040201:1=2892,1040202:1=589,1030203:1=184,1040201:1=0'),(386,1253003,1,1,'1|1050301:1=1500;1|1050501:1=125;1|1050302:1=403;1|1050502:1=35;1|1050303:1=201;1|1050503:1=23;1|1040303:1=85;1|1040503:1=10;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;1|1050401:1=994,1050402:1=566,1040403:1=177,1050201:1=3058,1050202:1=566,1040203:1=177,1050201:1=0'),(387,1253003,2,2,'1|1050301:1=1250;1|1050501:1=120;1|1050302:1=378;1|1050502:1=32;1|1050303:1=189;1|1050503:1=22;1|1040303:1=79;1|1040503:1=9;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;1|1050401:1=994,1050402:1=566,1040403:1=177,1050201:1=3058,1050202:1=566,1040203:1=177,1050201:1=0'),(388,1253003,3,3,'1|1050301:1=1000;1|1050501:1=105;1|1050302:1=350;1|1050502:1=30;1|1050303:1=175;1|1050503:1=20;1|1040303:1=74;1|1040503:1=8;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;1|1050401:1=994,1050402:1=566,1040403:1=177,1050201:1=3058,1050202:1=566,1040203:1=177,1050201:1=0'),(389,1253003,4,5,'1|1050301:1=750;1|1050501:1=90;1|1050302:1=298;1|1050502:1=26;1|1050303:1=149;1|1050503:1=17;1|1040303:1=62;1|1040503:1=7;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;1|1050401:1=994,1050402:1=566,1040403:1=177,1050201:1=3058,1050202:1=566,1040203:1=177,1050201:1=0'),(390,1253003,6,10,'1|1050301:1=750;1|1050501:1=75;1|1050302:1=280;1|1050502:1=24;1|1050303:1=140;1|1050503:1=16;1|1040303:1=59;1|1040503:1=7;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;1|1050401:1=994,1050402:1=566,1040403:1=177,1050201:1=3058,1050202:1=566,1040203:1=177,1050201:1=0'),(391,1253004,1,1,'1|1050301:1=1500;1|1050501:1=125;1|1050302:1=403;1|1050502:1=35;1|1050303:1=201;1|1050503:1=23;1|1040303:1=85;1|1040503:1=10;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;1|1050401:1=994,1050402:1=566,1040403:1=177,1050201:1=3058,1050202:1=566,1040203:1=177,1050201:1=0'),(392,1253004,2,2,'1|1050301:1=1250;1|1050501:1=120;1|1050302:1=378;1|1050502:1=32;1|1050303:1=189;1|1050503:1=22;1|1040303:1=79;1|1040503:1=9;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;1|1050401:1=994,1050402:1=566,1040403:1=177,1050201:1=3058,1050202:1=566,1040203:1=177,1050201:1=0'),(393,1253004,3,3,'1|1050301:1=1000;1|1050501:1=105;1|1050302:1=350;1|1050502:1=30;1|1050303:1=175;1|1050503:1=20;1|1040303:1=74;1|1040503:1=8;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;1|1050401:1=994,1050402:1=566,1040403:1=177,1050201:1=3058,1050202:1=566,1040203:1=177,1050201:1=0'),(394,1253004,4,5,'1|1050301:1=750;1|1050501:1=90;1|1050302:1=298;1|1050502:1=26;1|1050303:1=149;1|1050503:1=17;1|1040303:1=62;1|1040503:1=7;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;1|1050401:1=994,1050402:1=566,1040403:1=177,1050201:1=3058,1050202:1=566,1040203:1=177,1050201:1=0'),(395,1253004,6,10,'1|1050301:1=750;1|1050501:1=75;1|1050302:1=280;1|1050502:1=24;1|1050303:1=140;1|1050503:1=16;1|1040303:1=59;1|1040503:1=7;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;1|1050401:1=994,1050402:1=566,1040403:1=177,1050201:1=3058,1050202:1=566,1040203:1=177,1050201:1=0'),(396,1253005,1,1,'1|1060301:1=1250;1|1060501:1=125;1|1060302:1=230;1|1060502:1=17;1|1060303:1=115;1|1060503:1=12;1|1050303:1=48;1|1050503:1=5;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;1|1060401:1=1003,1060402:1=543,1050403:1=170,1060201:1=3222,1060202:1=543,1050203:1=170,1060201:1=0'),(397,1253005,2,2,'1|1060301:1=1000;1|1060501:1=120;1|1060302:1=216;1|1060502:1=16;1|1060303:1=108;1|1060503:1=11;1|1050303:1=45;1|1050503:1=5;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;1|1060401:1=1003,1060402:1=543,1050403:1=170,1060201:1=3222,1060202:1=543,1050203:1=170,1060201:1=0'),(398,1253005,3,3,'1|1060301:1=750;1|1060501:1=105;1|1060302:1=200;1|1060502:1=15;1|1060303:1=100;1|1060503:1=10;1|1050303:1=42;1|1050503:1=4;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;1|1060401:1=1003,1060402:1=543,1050403:1=170,1060201:1=3222,1060202:1=543,1050203:1=170,1060201:1=0'),(399,1253005,4,5,'1|1060301:1=500;1|1060501:1=90;1|1060302:1=170;1|1060502:1=13;1|1060303:1=85;1|1060503:1=9;1|1050303:1=36;1|1050503:1=4;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;1|1060401:1=1003,1060402:1=543,1050403:1=170,1060201:1=3222,1060202:1=543,1050203:1=170,1060201:1=0'),(400,1253005,6,10,'1|1060301:1=500;1|1060501:1=75;1|1060302:1=160;1|1060502:1=12;1|1060303:1=80;1|1060503:1=8;1|1050303:1=34;1|1050503:1=3;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;1|1060401:1=1003,1060402:1=543,1050403:1=170,1060201:1=3222,1060202:1=543,1050203:1=170,1060201:1=0'),(401,1253006,1,1,'1|1070301:1=625;1|1070501:1=50;1|1070302:1=58;1|1070502:1=6;1|1070303:1=58;1|1070503:1=6;1|1060301:1=625;1|1060501:1=63;0|1060302:1=115;1|1060502:1=9;1|1060303:1=58;1|1060503:1=6;1|1050303:1=24;1|1050503:1=2;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;1|1060401:1=1003,1060402:1=543,1050403:1=170,1060201:1=3222,1060202:1=543,1050203:1=170,1060201:1=0'),(402,1253006,2,2,'1|1070301:1=500;1|1070501:1=60;1|1070302:1=54;1|1070502:1=5;1|1070303:1=54;1|1070503:1=5;1|1060301:1=500;1|1060501:1=60;0|1060302:1=108;1|1060502:1=8;1|1060303:1=54;1|1060503:1=5;1|1050303:1=23;1|1050503:1=2;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;1|1060401:1=1003,1060402:1=543,1050403:1=170,1060201:1=3222,1060202:1=543,1050203:1=170,1060201:1=0'),(403,1253006,3,3,'1|1070301:1=375;1|1070501:1=53;1|1070302:1=50;1|1070502:1=5;1|1070303:1=50;1|1070503:1=5;1|1060301:1=375;1|1060501:1=53;0|1060302:1=100;1|1060502:1=8;1|1060303:1=50;1|1060503:1=5;1|1050303:1=21;1|1050503:1=2;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;1|1060401:1=1003,1060402:1=543,1050403:1=170,1060201:1=3222,1060202:1=543,1050203:1=170,1060201:1=0'),(404,1253006,4,5,'1|1070301:1=250;1|1070501:1=45;1|1070302:1=43;1|1070502:1=4;1|1070303:1=43;1|1070503:1=4;1|1060301:1=250;1|1060501:1=45;0|1060302:1=85;1|1060502:1=6;1|1060303:1=43;1|1060503:1=4;1|1050303:1=18;1|1050503:1=2;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;1|1060401:1=1003,1060402:1=543,1050403:1=170,1060201:1=3222,1060202:1=543,1050203:1=170,1060201:1=0'),(405,1253006,6,10,'1|1070301:1=250;1|1070501:1=38;1|1070302:1=40;1|1070502:1=4;1|1070303:1=40;1|1070503:1=4;1|1060301:1=250;1|1060501:1=38;0|1060302:1=80;1|1060502:1=6;1|1060303:1=40;1|1060503:1=4;1|1050303:1=17;1|1050503:1=2;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;1|1060401:1=1003,1060402:1=543,1050403:1=170,1060201:1=3222,1060202:1=543,1050203:1=170,1060201:1=0'),(406,1253007,1,1,'1|1080301:1=500;1|1080501:1=38;1|1080302:1=72;1|1080502:1=6;1|1080303:1=72;1|1080503:1=6;1|1070301:1=625;1|1070501:1=50;0|1070302:1=58;1|1070502:1=6;1|1070303:1=58;1|1070503:1=6;1|1060303:1=24;1|1060503:1=2;4|1070101:1=6000,1070102:1=1500,1070103:1=2500;1|1070401:1=1012,1070402:1=519,1060403:1=163,1070201:1=3388,1070202:1=519,1060203:1=163,1070201:1=0'),(407,1253007,2,2,'1|1080301:1=450;1|1080501:1=30;1|1080302:1=68;1|1080502:1=5;1|1080303:1=68;1|1080503:1=5;1|1070301:1=500;1|1070501:1=60;0|1070302:1=54;1|1070502:1=5;1|1070303:1=54;1|1070503:1=5;1|1060303:1=23;1|1060503:1=2;4|1070101:1=6000,1070102:1=1500,1070103:1=2500;1|1070401:1=1012,1070402:1=519,1060403:1=163,1070201:1=3388,1070202:1=519,1060203:1=163,1070201:1=0'),(408,1253007,3,3,'1|1080301:1=375;1|1080501:1=33;1|1080302:1=63;1|1080502:1=5;1|1080303:1=63;1|1080503:1=5;1|1070301:1=375;1|1070501:1=53;0|1070302:1=50;1|1070502:1=5;1|1070303:1=50;1|1070503:1=5;1|1060303:1=21;1|1060503:1=2;4|1070101:1=6000,1070102:1=1500,1070103:1=2500;1|1070401:1=1012,1070402:1=519,1060403:1=163,1070201:1=3388,1070202:1=519,1060203:1=163,1070201:1=0'),(409,1253007,4,5,'1|1080301:1=300;1|1080501:1=30;1|1080302:1=53;1|1080502:1=4;1|1080303:1=53;1|1080503:1=4;1|1070301:1=250;1|1070501:1=45;0|1070302:1=43;1|1070502:1=4;1|1070303:1=43;1|1070503:1=4;1|1060303:1=18;1|1060503:1=2;4|1070101:1=6000,1070102:1=1500,1070103:1=2500;1|1070401:1=1012,1070402:1=519,1060403:1=163,1070201:1=3388,1070202:1=519,1060203:1=163,1070201:1=0'),(410,1253007,6,10,'1|1080301:1=250;1|1080501:1=25;1|1080302:1=50;1|1080502:1=4;1|1080303:1=50;1|1080503:1=4;1|1070301:1=250;1|1070501:1=38;0|1070302:1=40;1|1070502:1=4;1|1070303:1=40;1|1070503:1=4;1|1060303:1=17;1|1060503:1=2;4|1070101:1=6000,1070102:1=1500,1070103:1=2500;1|1070401:1=1012,1070402:1=519,1060403:1=163,1070201:1=3388,1070202:1=519,1060203:1=163,1070201:1=0'),(411,1253008,1,1,'1|1090301:1=375;1|1090501:1=30;1|1090302:1=86;1|1090502:1=4;1|1090303:1=115;1|1090503:1=4;1|1080301:1=500;1|1080501:1=38;0|1080302:1=72;1|1080502:1=6;1|1080303:1=72;1|1080503:1=6;1|1070303:1=30;1|1070503:1=2;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;1|1080401:1=1020,1080402:1=495,1070403:1=156,1080201:1=3550,1080202:1=495,1070203:1=156,1080201:1=0'),(412,1253008,2,2,'1|1090301:1=300;1|1090501:1=25;1|1090302:1=81;1|1090502:1=4;1|1090303:1=108;1|1090503:1=4;1|1080301:1=450;1|1080501:1=30;0|1080302:1=68;1|1080502:1=5;1|1080303:1=68;1|1080503:1=5;1|1070303:1=28;1|1070503:1=2;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;1|1080401:1=1020,1080402:1=495,1070403:1=156,1080201:1=3550,1080202:1=495,1070203:1=156,1080201:1=0'),(413,1253008,3,3,'1|1090301:1=250;1|1090501:1=23;1|1090302:1=75;1|1090502:1=4;1|1090303:1=100;1|1090503:1=4;1|1080301:1=375;1|1080501:1=33;0|1080302:1=63;1|1080502:1=5;1|1080303:1=63;1|1080503:1=5;1|1070303:1=26;1|1070503:1=2;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;1|1080401:1=1020,1080402:1=495,1070403:1=156,1080201:1=3550,1080202:1=495,1070203:1=156,1080201:1=0'),(414,1253008,4,5,'1|1090301:1=200;1|1090501:1=18;1|1090302:1=64;1|1090502:1=3;1|1090303:1=85;1|1090503:1=3;1|1080301:1=300;1|1080501:1=30;0|1080302:1=53;1|1080502:1=4;1|1080303:1=53;1|1080503:1=4;1|1070303:1=22;1|1070503:1=2;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;1|1080401:1=1020,1080402:1=495,1070403:1=156,1080201:1=3550,1080202:1=495,1070203:1=156,1080201:1=0'),(415,1253008,6,10,'1|1090301:1=200;1|1090501:1=15;1|1090302:1=60;1|1090502:1=3;1|1090303:1=80;1|1090503:1=3;1|1080301:1=250;1|1080501:1=25;0|1080302:1=50;1|1080502:1=4;1|1080303:1=50;1|1080503:1=4;1|1070303:1=21;1|1070503:1=2;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;1|1080401:1=1020,1080402:1=495,1070403:1=156,1080201:1=3550,1080202:1=495,1070203:1=156,1080201:1=0'),(416,1254001,1,1,'1|1050301:1=1500;1|1050501:1=125;1|1050302:1=403;1|1050502:1=35;1|1050303:1=201;1|1050503:1=23;1|1040303:1=85;1|1040503:1=10;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;1|1050401:1=994,1050402:1=566,1040403:1=177,1050201:1=3058,1050202:1=566,1040203:1=177,1050201:1=0'),(417,1254001,2,2,'1|1050301:1=1250;1|1050501:1=120;1|1050302:1=378;1|1050502:1=32;1|1050303:1=189;1|1050503:1=22;1|1040303:1=79;1|1040503:1=9;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;1|1050401:1=994,1050402:1=566,1040403:1=177,1050201:1=3058,1050202:1=566,1040203:1=177,1050201:1=0'),(418,1254001,3,3,'1|1050301:1=1000;1|1050501:1=105;1|1050302:1=350;1|1050502:1=30;1|1050303:1=175;1|1050503:1=20;1|1040303:1=74;1|1040503:1=8;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;1|1050401:1=994,1050402:1=566,1040403:1=177,1050201:1=3058,1050202:1=566,1040203:1=177,1050201:1=0'),(419,1254001,4,5,'1|1050301:1=750;1|1050501:1=90;1|1050302:1=298;1|1050502:1=26;1|1050303:1=149;1|1050503:1=17;1|1040303:1=62;1|1040503:1=7;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;1|1050401:1=994,1050402:1=566,1040403:1=177,1050201:1=3058,1050202:1=566,1040203:1=177,1050201:1=0'),(420,1254001,6,10,'1|1050301:1=750;1|1050501:1=75;1|1050302:1=280;1|1050502:1=24;1|1050303:1=140;1|1050503:1=16;1|1040303:1=59;1|1040503:1=7;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;1|1050401:1=994,1050402:1=566,1040403:1=177,1050201:1=3058,1050202:1=566,1040203:1=177,1050201:1=0'),(421,1254002,1,1,'1|1050301:1=1500;1|1050501:1=125;1|1050302:1=403;1|1050502:1=35;1|1050303:1=201;1|1050503:1=23;1|1040303:1=85;1|1040503:1=10;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;1|1050401:1=994,1050402:1=566,1040403:1=177,1050201:1=3058,1050202:1=566,1040203:1=177,1050201:1=0'),(422,1254002,2,2,'1|1050301:1=1250;1|1050501:1=120;1|1050302:1=378;1|1050502:1=32;1|1050303:1=189;1|1050503:1=22;1|1040303:1=79;1|1040503:1=9;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;1|1050401:1=994,1050402:1=566,1040403:1=177,1050201:1=3058,1050202:1=566,1040203:1=177,1050201:1=0'),(423,1254002,3,3,'1|1050301:1=1000;1|1050501:1=105;1|1050302:1=350;1|1050502:1=30;1|1050303:1=175;1|1050503:1=20;1|1040303:1=74;1|1040503:1=8;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;1|1050401:1=994,1050402:1=566,1040403:1=177,1050201:1=3058,1050202:1=566,1040203:1=177,1050201:1=0'),(424,1254002,4,5,'1|1050301:1=750;1|1050501:1=90;1|1050302:1=298;1|1050502:1=26;1|1050303:1=149;1|1050503:1=17;1|1040303:1=62;1|1040503:1=7;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;1|1050401:1=994,1050402:1=566,1040403:1=177,1050201:1=3058,1050202:1=566,1040203:1=177,1050201:1=0'),(425,1254002,6,10,'1|1050301:1=750;1|1050501:1=75;1|1050302:1=280;1|1050502:1=24;1|1050303:1=140;1|1050503:1=16;1|1040303:1=59;1|1040503:1=7;4|1050101:1=6000,1050102:1=1500,1050103:1=2500;1|1050401:1=994,1050402:1=566,1040403:1=177,1050201:1=3058,1050202:1=566,1040203:1=177,1050201:1=0'),(426,1254003,1,1,'1|1060301:1=1250;1|1060501:1=125;1|1060302:1=230;1|1060502:1=17;1|1060303:1=115;1|1060503:1=12;1|1050303:1=48;1|1050503:1=5;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;1|1060401:1=1003,1060402:1=543,1050403:1=170,1060201:1=3222,1060202:1=543,1050203:1=170,1060201:1=0'),(427,1254003,2,2,'1|1060301:1=1000;1|1060501:1=120;1|1060302:1=216;1|1060502:1=16;1|1060303:1=108;1|1060503:1=11;1|1050303:1=45;1|1050503:1=5;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;1|1060401:1=1003,1060402:1=543,1050403:1=170,1060201:1=3222,1060202:1=543,1050203:1=170,1060201:1=0'),(428,1254003,3,3,'1|1060301:1=750;1|1060501:1=105;1|1060302:1=200;1|1060502:1=15;1|1060303:1=100;1|1060503:1=10;1|1050303:1=42;1|1050503:1=4;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;1|1060401:1=1003,1060402:1=543,1050403:1=170,1060201:1=3222,1060202:1=543,1050203:1=170,1060201:1=0'),(429,1254003,4,5,'1|1060301:1=500;1|1060501:1=90;1|1060302:1=170;1|1060502:1=13;1|1060303:1=85;1|1060503:1=9;1|1050303:1=36;1|1050503:1=4;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;1|1060401:1=1003,1060402:1=543,1050403:1=170,1060201:1=3222,1060202:1=543,1050203:1=170,1060201:1=0'),(430,1254003,6,10,'1|1060301:1=500;1|1060501:1=75;1|1060302:1=160;1|1060502:1=12;1|1060303:1=80;1|1060503:1=8;1|1050303:1=34;1|1050503:1=3;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;1|1060401:1=1003,1060402:1=543,1050403:1=170,1060201:1=3222,1060202:1=543,1050203:1=170,1060201:1=0'),(431,1254004,1,1,'1|1070301:1=625;1|1070501:1=50;1|1070302:1=58;1|1070502:1=6;1|1070303:1=58;1|1070503:1=6;1|1060301:1=625;1|1060501:1=63;0|1060302:1=115;1|1060502:1=9;1|1060303:1=58;1|1060503:1=6;1|1050303:1=24;1|1050503:1=2;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;1|1060401:1=1003,1060402:1=543,1050403:1=170,1060201:1=3222,1060202:1=543,1050203:1=170,1060201:1=0'),(432,1254004,2,2,'1|1070301:1=500;1|1070501:1=60;1|1070302:1=54;1|1070502:1=5;1|1070303:1=54;1|1070503:1=5;1|1060301:1=500;1|1060501:1=60;0|1060302:1=108;1|1060502:1=8;1|1060303:1=54;1|1060503:1=5;1|1050303:1=23;1|1050503:1=2;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;1|1060401:1=1003,1060402:1=543,1050403:1=170,1060201:1=3222,1060202:1=543,1050203:1=170,1060201:1=0'),(433,1254004,3,3,'1|1070301:1=375;1|1070501:1=53;1|1070302:1=50;1|1070502:1=5;1|1070303:1=50;1|1070503:1=5;1|1060301:1=375;1|1060501:1=53;0|1060302:1=100;1|1060502:1=8;1|1060303:1=50;1|1060503:1=5;1|1050303:1=21;1|1050503:1=2;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;1|1060401:1=1003,1060402:1=543,1050403:1=170,1060201:1=3222,1060202:1=543,1050203:1=170,1060201:1=0'),(434,1254004,4,5,'1|1070301:1=250;1|1070501:1=45;1|1070302:1=43;1|1070502:1=4;1|1070303:1=43;1|1070503:1=4;1|1060301:1=250;1|1060501:1=45;0|1060302:1=85;1|1060502:1=6;1|1060303:1=43;1|1060503:1=4;1|1050303:1=18;1|1050503:1=2;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;1|1060401:1=1003,1060402:1=543,1050403:1=170,1060201:1=3222,1060202:1=543,1050203:1=170,1060201:1=0'),(435,1254004,6,10,'1|1070301:1=250;1|1070501:1=38;1|1070302:1=40;1|1070502:1=4;1|1070303:1=40;1|1070503:1=4;1|1060301:1=250;1|1060501:1=38;0|1060302:1=80;1|1060502:1=6;1|1060303:1=40;1|1060503:1=4;1|1050303:1=17;1|1050503:1=2;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;1|1060401:1=1003,1060402:1=543,1050403:1=170,1060201:1=3222,1060202:1=543,1050203:1=170,1060201:1=0'),(436,1254005,1,1,'1|1080301:1=500;1|1080501:1=38;1|1080302:1=72;1|1080502:1=6;1|1080303:1=72;1|1080503:1=6;1|1070301:1=625;1|1070501:1=50;0|1070302:1=58;1|1070502:1=6;1|1070303:1=58;1|1070503:1=6;1|1060303:1=24;1|1060503:1=2;4|1070101:1=6000,1070102:1=1500,1070103:1=2500;1|1070401:1=1012,1070402:1=519,1060403:1=163,1070201:1=3388,1070202:1=519,1060203:1=163,1070201:1=0'),(437,1254005,2,2,'1|1080301:1=450;1|1080501:1=30;1|1080302:1=68;1|1080502:1=5;1|1080303:1=68;1|1080503:1=5;1|1070301:1=500;1|1070501:1=60;0|1070302:1=54;1|1070502:1=5;1|1070303:1=54;1|1070503:1=5;1|1060303:1=23;1|1060503:1=2;4|1070101:1=6000,1070102:1=1500,1070103:1=2500;1|1070401:1=1012,1070402:1=519,1060403:1=163,1070201:1=3388,1070202:1=519,1060203:1=163,1070201:1=0'),(438,1254005,3,3,'1|1080301:1=375;1|1080501:1=33;1|1080302:1=63;1|1080502:1=5;1|1080303:1=63;1|1080503:1=5;1|1070301:1=375;1|1070501:1=53;0|1070302:1=50;1|1070502:1=5;1|1070303:1=50;1|1070503:1=5;1|1060303:1=21;1|1060503:1=2;4|1070101:1=6000,1070102:1=1500,1070103:1=2500;1|1070401:1=1012,1070402:1=519,1060403:1=163,1070201:1=3388,1070202:1=519,1060203:1=163,1070201:1=0'),(439,1254005,4,5,'1|1080301:1=300;1|1080501:1=30;1|1080302:1=53;1|1080502:1=4;1|1080303:1=53;1|1080503:1=4;1|1070301:1=250;1|1070501:1=45;0|1070302:1=43;1|1070502:1=4;1|1070303:1=43;1|1070503:1=4;1|1060303:1=18;1|1060503:1=2;4|1070101:1=6000,1070102:1=1500,1070103:1=2500;1|1070401:1=1012,1070402:1=519,1060403:1=163,1070201:1=3388,1070202:1=519,1060203:1=163,1070201:1=0'),(440,1254005,6,10,'1|1080301:1=250;1|1080501:1=25;1|1080302:1=50;1|1080502:1=4;1|1080303:1=50;1|1080503:1=4;1|1070301:1=250;1|1070501:1=38;0|1070302:1=40;1|1070502:1=4;1|1070303:1=40;1|1070503:1=4;1|1060303:1=17;1|1060503:1=2;4|1070101:1=6000,1070102:1=1500,1070103:1=2500;1|1070401:1=1012,1070402:1=519,1060403:1=163,1070201:1=3388,1070202:1=519,1060203:1=163,1070201:1=0'),(441,1254006,1,1,'1|1090301:1=375;1|1090501:1=30;1|1090302:1=86;1|1090502:1=4;1|1090303:1=115;1|1090503:1=4;1|1080301:1=500;1|1080501:1=38;0|1080302:1=72;1|1080502:1=6;1|1080303:1=72;1|1080503:1=6;1|1070303:1=30;1|1070503:1=2;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;1|1080401:1=1020,1080402:1=495,1070403:1=156,1080201:1=3550,1080202:1=495,1070203:1=156,1080201:1=0'),(442,1254006,2,2,'1|1090301:1=300;1|1090501:1=25;1|1090302:1=81;1|1090502:1=4;1|1090303:1=108;1|1090503:1=4;1|1080301:1=450;1|1080501:1=30;0|1080302:1=68;1|1080502:1=5;1|1080303:1=68;1|1080503:1=5;1|1070303:1=28;1|1070503:1=2;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;1|1080401:1=1020,1080402:1=495,1070403:1=156,1080201:1=3550,1080202:1=495,1070203:1=156,1080201:1=0'),(443,1254006,3,3,'1|1090301:1=250;1|1090501:1=23;1|1090302:1=75;1|1090502:1=4;1|1090303:1=100;1|1090503:1=4;1|1080301:1=375;1|1080501:1=33;0|1080302:1=63;1|1080502:1=5;1|1080303:1=63;1|1080503:1=5;1|1070303:1=26;1|1070503:1=2;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;1|1080401:1=1020,1080402:1=495,1070403:1=156,1080201:1=3550,1080202:1=495,1070203:1=156,1080201:1=0'),(444,1254006,4,5,'1|1090301:1=200;1|1090501:1=18;1|1090302:1=64;1|1090502:1=3;1|1090303:1=85;1|1090503:1=3;1|1080301:1=300;1|1080501:1=30;0|1080302:1=53;1|1080502:1=4;1|1080303:1=53;1|1080503:1=4;1|1070303:1=22;1|1070503:1=2;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;1|1080401:1=1020,1080402:1=495,1070403:1=156,1080201:1=3550,1080202:1=495,1070203:1=156,1080201:1=0'),(445,1254006,6,10,'1|1090301:1=200;1|1090501:1=15;1|1090302:1=60;1|1090502:1=3;1|1090303:1=80;1|1090503:1=3;1|1080301:1=250;1|1080501:1=25;0|1080302:1=50;1|1080502:1=4;1|1080303:1=50;1|1080503:1=4;1|1070303:1=21;1|1070503:1=2;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;1|1080401:1=1020,1080402:1=495,1070403:1=156,1080201:1=3550,1080202:1=495,1070203:1=156,1080201:1=0'),(446,1254007,1,1,'1|1100301:1=250;1|1100501:1=25;1|1100302:1=86;1|1100502:1=4;1|1100303:1=115;1|1100503:1=4;1|1090301:1=375;1|1090501:1=30;0|1090302:1=86;1|1090502:1=4;1|1090303:1=115;1|1090503:1=4;1|1080303:1=48;1|1080503:1=2;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;1|1090401:1=1029,1090402:1=472,1080403:1=149,1090201:1=3714,1090202:1=472,1080203:1=149,1090201:1=0'),(447,1254007,2,2,'1|1100301:1=250;1|1100501:1=23;1|1100302:1=81;1|1100502:1=4;1|1100303:1=108;1|1100503:1=4;1|1090301:1=300;1|1090501:1=25;0|1090302:1=81;1|1090502:1=4;1|1090303:1=108;1|1090503:1=4;1|1080303:1=45;1|1080503:1=2;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;1|1090401:1=1029,1090402:1=472,1080403:1=149,1090201:1=3714,1090202:1=472,1080203:1=149,1090201:1=0'),(448,1254007,3,3,'1|1100301:1=225;1|1100501:1=20;1|1100302:1=75;1|1100502:1=4;1|1100303:1=100;1|1100503:1=4;1|1090301:1=250;1|1090501:1=23;0|1090302:1=75;1|1090502:1=4;1|1090303:1=100;1|1090503:1=4;1|1080303:1=42;1|1080503:1=2;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;1|1090401:1=1029,1090402:1=472,1080403:1=149,1090201:1=3714,1090202:1=472,1080203:1=149,1090201:1=0'),(449,1254007,4,5,'1|1100301:1=200;1|1100501:1=18;1|1100302:1=64;1|1100502:1=3;1|1100303:1=85;1|1100503:1=3;1|1090301:1=200;1|1090501:1=18;0|1090302:1=64;1|1090502:1=3;1|1090303:1=85;1|1090503:1=3;1|1080303:1=36;1|1080503:1=1;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;1|1090401:1=1029,1090402:1=472,1080403:1=149,1090201:1=3714,1090202:1=472,1080203:1=149,1090201:1=0'),(450,1254007,6,10,'1|1100301:1=175;1|1100501:1=15;1|1100302:1=60;1|1100502:1=3;1|1100303:1=80;1|1100503:1=3;1|1090301:1=200;1|1090501:1=15;0|1090302:1=60;1|1090502:1=3;1|1090303:1=80;1|1090503:1=3;1|1080303:1=34;1|1080503:1=1;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;1|1090401:1=1029,1090402:1=472,1080403:1=149,1090201:1=3714,1090202:1=472,1080203:1=149,1090201:1=0'),(451,1254008,1,1,'1|1110301:1=250;1|1110501:1=25;1|1110302:1=86;1|1110502:1=4;1|1110303:1=58;1|1110503:1=3;1|1100301:1=250;1|1100501:1=25;0|1100302:1=86;1|1100502:1=4;1|1100303:1=115;1|1100503:1=4;1|1090303:1=48;1|1090503:1=2;4|1100101:1=6000,1100102:1=1500,1100103:1=2500;1|1100401:1=1038,1100402:1=448,1090403:1=142,1100201:1=3880,1100202:1=448,1090203:1=142,1100201:1=0'),(452,1254008,2,2,'1|1110301:1=250;1|1110501:1=23;1|1110302:1=81;1|1110502:1=4;1|1110303:1=54;1|1110503:1=3;1|1100301:1=250;1|1100501:1=23;0|1100302:1=81;1|1100502:1=4;1|1100303:1=108;1|1100503:1=4;1|1090303:1=45;1|1090503:1=2;4|1100101:1=6000,1100102:1=1500,1100103:1=2500;1|1100401:1=1038,1100402:1=448,1090403:1=142,1100201:1=3880,1100202:1=448,1090203:1=142,1100201:1=0'),(453,1254008,3,3,'1|1110301:1=225;1|1110501:1=20;1|1110302:1=75;1|1110502:1=4;1|1110303:1=50;1|1110503:1=3;1|1100301:1=225;1|1100501:1=20;0|1100302:1=75;1|1100502:1=4;1|1100303:1=100;1|1100503:1=4;1|1090303:1=42;1|1090503:1=2;4|1100101:1=6000,1100102:1=1500,1100103:1=2500;1|1100401:1=1038,1100402:1=448,1090403:1=142,1100201:1=3880,1100202:1=448,1090203:1=142,1100201:1=0'),(454,1254008,4,5,'1|1110301:1=200;1|1110501:1=18;1|1110302:1=64;1|1110502:1=3;1|1110303:1=43;1|1110503:1=2;1|1100301:1=200;1|1100501:1=18;0|1100302:1=64;1|1100502:1=3;1|1100303:1=85;1|1100503:1=3;1|1090303:1=36;1|1090503:1=1;4|1100101:1=6000,1100102:1=1500,1100103:1=2500;1|1100401:1=1038,1100402:1=448,1090403:1=142,1100201:1=3880,1100202:1=448,1090203:1=142,1100201:1=0'),(455,1254008,6,10,'1|1110301:1=175;1|1110501:1=15;1|1110302:1=60;1|1110502:1=3;1|1110303:1=40;1|1110503:1=2;1|1100301:1=175;1|1100501:1=15;0|1100302:1=60;1|1100502:1=3;1|1100303:1=80;1|1100503:1=3;1|1090303:1=34;1|1090503:1=1;4|1100101:1=6000,1100102:1=1500,1100103:1=2500;1|1100401:1=1038,1100402:1=448,1090403:1=142,1100201:1=3880,1100202:1=448,1090203:1=142,1100201:1=0'),(456,1255001,1,1,'1|1060301:1=1250;1|1060501:1=125;1|1060302:1=230;1|1060502:1=17;1|1060303:1=115;1|1060503:1=12;1|1050303:1=48;1|1050503:1=5;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;1|1060401:1=1003,1060402:1=543,1050403:1=170,1060201:1=3222,1060202:1=543,1050203:1=170,1060201:1=0'),(457,1255001,2,2,'1|1060301:1=1000;1|1060501:1=120;1|1060302:1=216;1|1060502:1=16;1|1060303:1=108;1|1060503:1=11;1|1050303:1=45;1|1050503:1=5;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;1|1060401:1=1003,1060402:1=543,1050403:1=170,1060201:1=3222,1060202:1=543,1050203:1=170,1060201:1=0'),(458,1255001,3,3,'1|1060301:1=750;1|1060501:1=105;1|1060302:1=200;1|1060502:1=15;1|1060303:1=100;1|1060503:1=10;1|1050303:1=42;1|1050503:1=4;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;1|1060401:1=1003,1060402:1=543,1050403:1=170,1060201:1=3222,1060202:1=543,1050203:1=170,1060201:1=0'),(459,1255001,4,5,'1|1060301:1=500;1|1060501:1=90;1|1060302:1=170;1|1060502:1=13;1|1060303:1=85;1|1060503:1=9;1|1050303:1=36;1|1050503:1=4;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;1|1060401:1=1003,1060402:1=543,1050403:1=170,1060201:1=3222,1060202:1=543,1050203:1=170,1060201:1=0'),(460,1255001,6,10,'1|1060301:1=500;1|1060501:1=75;1|1060302:1=160;1|1060502:1=12;1|1060303:1=80;1|1060503:1=8;1|1050303:1=34;1|1050503:1=3;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;1|1060401:1=1003,1060402:1=543,1050403:1=170,1060201:1=3222,1060202:1=543,1050203:1=170,1060201:1=0'),(461,1255002,1,1,'1|1070301:1=625;1|1070501:1=50;1|1070302:1=58;1|1070502:1=6;1|1070303:1=58;1|1070503:1=6;1|1060301:1=625;1|1060501:1=63;0|1060302:1=115;1|1060502:1=9;1|1060303:1=58;1|1060503:1=6;1|1050303:1=24;1|1050503:1=2;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;1|1060401:1=1003,1060402:1=543,1050403:1=170,1060201:1=3222,1060202:1=543,1050203:1=170,1060201:1=0'),(462,1255002,2,2,'1|1070301:1=500;1|1070501:1=60;1|1070302:1=54;1|1070502:1=5;1|1070303:1=54;1|1070503:1=5;1|1060301:1=500;1|1060501:1=60;0|1060302:1=108;1|1060502:1=8;1|1060303:1=54;1|1060503:1=5;1|1050303:1=23;1|1050503:1=2;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;1|1060401:1=1003,1060402:1=543,1050403:1=170,1060201:1=3222,1060202:1=543,1050203:1=170,1060201:1=0'),(463,1255002,3,3,'1|1070301:1=375;1|1070501:1=53;1|1070302:1=50;1|1070502:1=5;1|1070303:1=50;1|1070503:1=5;1|1060301:1=375;1|1060501:1=53;0|1060302:1=100;1|1060502:1=8;1|1060303:1=50;1|1060503:1=5;1|1050303:1=21;1|1050503:1=2;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;1|1060401:1=1003,1060402:1=543,1050403:1=170,1060201:1=3222,1060202:1=543,1050203:1=170,1060201:1=0'),(464,1255002,4,5,'1|1070301:1=250;1|1070501:1=45;1|1070302:1=43;1|1070502:1=4;1|1070303:1=43;1|1070503:1=4;1|1060301:1=250;1|1060501:1=45;0|1060302:1=85;1|1060502:1=6;1|1060303:1=43;1|1060503:1=4;1|1050303:1=18;1|1050503:1=2;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;1|1060401:1=1003,1060402:1=543,1050403:1=170,1060201:1=3222,1060202:1=543,1050203:1=170,1060201:1=0'),(465,1255002,6,10,'1|1070301:1=250;1|1070501:1=38;1|1070302:1=40;1|1070502:1=4;1|1070303:1=40;1|1070503:1=4;1|1060301:1=250;1|1060501:1=38;0|1060302:1=80;1|1060502:1=6;1|1060303:1=40;1|1060503:1=4;1|1050303:1=17;1|1050503:1=2;4|1060101:1=6000,1060102:1=1500,1060103:1=2500;1|1060401:1=1003,1060402:1=543,1050403:1=170,1060201:1=3222,1060202:1=543,1050203:1=170,1060201:1=0'),(466,1255003,1,1,'1|1080301:1=500;1|1080501:1=38;1|1080302:1=72;1|1080502:1=6;1|1080303:1=72;1|1080503:1=6;1|1070301:1=625;1|1070501:1=50;0|1070302:1=58;1|1070502:1=6;1|1070303:1=58;1|1070503:1=6;1|1060303:1=24;1|1060503:1=2;4|1070101:1=6000,1070102:1=1500,1070103:1=2500;1|1070401:1=1012,1070402:1=519,1060403:1=163,1070201:1=3388,1070202:1=519,1060203:1=163,1070201:1=0'),(467,1255003,2,2,'1|1080301:1=450;1|1080501:1=30;1|1080302:1=68;1|1080502:1=5;1|1080303:1=68;1|1080503:1=5;1|1070301:1=500;1|1070501:1=60;0|1070302:1=54;1|1070502:1=5;1|1070303:1=54;1|1070503:1=5;1|1060303:1=23;1|1060503:1=2;4|1070101:1=6000,1070102:1=1500,1070103:1=2500;1|1070401:1=1012,1070402:1=519,1060403:1=163,1070201:1=3388,1070202:1=519,1060203:1=163,1070201:1=0'),(468,1255003,3,3,'1|1080301:1=375;1|1080501:1=33;1|1080302:1=63;1|1080502:1=5;1|1080303:1=63;1|1080503:1=5;1|1070301:1=375;1|1070501:1=53;0|1070302:1=50;1|1070502:1=5;1|1070303:1=50;1|1070503:1=5;1|1060303:1=21;1|1060503:1=2;4|1070101:1=6000,1070102:1=1500,1070103:1=2500;1|1070401:1=1012,1070402:1=519,1060403:1=163,1070201:1=3388,1070202:1=519,1060203:1=163,1070201:1=0'),(469,1255003,4,5,'1|1080301:1=300;1|1080501:1=30;1|1080302:1=53;1|1080502:1=4;1|1080303:1=53;1|1080503:1=4;1|1070301:1=250;1|1070501:1=45;0|1070302:1=43;1|1070502:1=4;1|1070303:1=43;1|1070503:1=4;1|1060303:1=18;1|1060503:1=2;4|1070101:1=6000,1070102:1=1500,1070103:1=2500;1|1070401:1=1012,1070402:1=519,1060403:1=163,1070201:1=3388,1070202:1=519,1060203:1=163,1070201:1=0'),(470,1255003,6,10,'1|1080301:1=250;1|1080501:1=25;1|1080302:1=50;1|1080502:1=4;1|1080303:1=50;1|1080503:1=4;1|1070301:1=250;1|1070501:1=38;0|1070302:1=40;1|1070502:1=4;1|1070303:1=40;1|1070503:1=4;1|1060303:1=17;1|1060503:1=2;4|1070101:1=6000,1070102:1=1500,1070103:1=2500;1|1070401:1=1012,1070402:1=519,1060403:1=163,1070201:1=3388,1070202:1=519,1060203:1=163,1070201:1=0'),(471,1255004,1,1,'1|1090301:1=375;1|1090501:1=30;1|1090302:1=86;1|1090502:1=4;1|1090303:1=115;1|1090503:1=4;1|1080301:1=500;1|1080501:1=38;0|1080302:1=72;1|1080502:1=6;1|1080303:1=72;1|1080503:1=6;1|1070303:1=30;1|1070503:1=2;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;1|1080401:1=1020,1080402:1=495,1070403:1=156,1080201:1=3550,1080202:1=495,1070203:1=156,1080201:1=0'),(472,1255004,2,2,'1|1090301:1=300;1|1090501:1=25;1|1090302:1=81;1|1090502:1=4;1|1090303:1=108;1|1090503:1=4;1|1080301:1=450;1|1080501:1=30;0|1080302:1=68;1|1080502:1=5;1|1080303:1=68;1|1080503:1=5;1|1070303:1=28;1|1070503:1=2;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;1|1080401:1=1020,1080402:1=495,1070403:1=156,1080201:1=3550,1080202:1=495,1070203:1=156,1080201:1=0'),(473,1255004,3,3,'1|1090301:1=250;1|1090501:1=23;1|1090302:1=75;1|1090502:1=4;1|1090303:1=100;1|1090503:1=4;1|1080301:1=375;1|1080501:1=33;0|1080302:1=63;1|1080502:1=5;1|1080303:1=63;1|1080503:1=5;1|1070303:1=26;1|1070503:1=2;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;1|1080401:1=1020,1080402:1=495,1070403:1=156,1080201:1=3550,1080202:1=495,1070203:1=156,1080201:1=0'),(474,1255004,4,5,'1|1090301:1=200;1|1090501:1=18;1|1090302:1=64;1|1090502:1=3;1|1090303:1=85;1|1090503:1=3;1|1080301:1=300;1|1080501:1=30;0|1080302:1=53;1|1080502:1=4;1|1080303:1=53;1|1080503:1=4;1|1070303:1=22;1|1070503:1=2;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;1|1080401:1=1020,1080402:1=495,1070403:1=156,1080201:1=3550,1080202:1=495,1070203:1=156,1080201:1=0'),(475,1255004,6,10,'1|1090301:1=200;1|1090501:1=15;1|1090302:1=60;1|1090502:1=3;1|1090303:1=80;1|1090503:1=3;1|1080301:1=250;1|1080501:1=25;0|1080302:1=50;1|1080502:1=4;1|1080303:1=50;1|1080503:1=4;1|1070303:1=21;1|1070503:1=2;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;1|1080401:1=1020,1080402:1=495,1070403:1=156,1080201:1=3550,1080202:1=495,1070203:1=156,1080201:1=0'),(476,1255005,1,1,'1|1100301:1=250;1|1100501:1=25;1|1100302:1=86;1|1100502:1=4;1|1100303:1=115;1|1100503:1=4;1|1090301:1=375;1|1090501:1=30;0|1090302:1=86;1|1090502:1=4;1|1090303:1=115;1|1090503:1=4;1|1080303:1=48;1|1080503:1=2;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;1|1090401:1=1029,1090402:1=472,1080403:1=149,1090201:1=3714,1090202:1=472,1080203:1=149,1090201:1=0'),(477,1255005,2,2,'1|1100301:1=250;1|1100501:1=23;1|1100302:1=81;1|1100502:1=4;1|1100303:1=108;1|1100503:1=4;1|1090301:1=300;1|1090501:1=25;0|1090302:1=81;1|1090502:1=4;1|1090303:1=108;1|1090503:1=4;1|1080303:1=45;1|1080503:1=2;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;1|1090401:1=1029,1090402:1=472,1080403:1=149,1090201:1=3714,1090202:1=472,1080203:1=149,1090201:1=0'),(478,1255005,3,3,'1|1100301:1=225;1|1100501:1=20;1|1100302:1=75;1|1100502:1=4;1|1100303:1=100;1|1100503:1=4;1|1090301:1=250;1|1090501:1=23;0|1090302:1=75;1|1090502:1=4;1|1090303:1=100;1|1090503:1=4;1|1080303:1=42;1|1080503:1=2;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;1|1090401:1=1029,1090402:1=472,1080403:1=149,1090201:1=3714,1090202:1=472,1080203:1=149,1090201:1=0'),(479,1255005,4,5,'1|1100301:1=200;1|1100501:1=18;1|1100302:1=64;1|1100502:1=3;1|1100303:1=85;1|1100503:1=3;1|1090301:1=200;1|1090501:1=18;0|1090302:1=64;1|1090502:1=3;1|1090303:1=85;1|1090503:1=3;1|1080303:1=36;1|1080503:1=1;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;1|1090401:1=1029,1090402:1=472,1080403:1=149,1090201:1=3714,1090202:1=472,1080203:1=149,1090201:1=0'),(480,1255005,6,10,'1|1100301:1=175;1|1100501:1=15;1|1100302:1=60;1|1100502:1=3;1|1100303:1=80;1|1100503:1=3;1|1090301:1=200;1|1090501:1=15;0|1090302:1=60;1|1090502:1=3;1|1090303:1=80;1|1090503:1=3;1|1080303:1=34;1|1080503:1=1;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;1|1090401:1=1029,1090402:1=472,1080403:1=149,1090201:1=3714,1090202:1=472,1080203:1=149,1090201:1=0'),(481,1255006,1,1,'1|1110301:1=250;1|1110501:1=25;1|1110302:1=86;1|1110502:1=4;1|1110303:1=58;1|1110503:1=3;1|1100301:1=250;1|1100501:1=25;0|1100302:1=86;1|1100502:1=4;1|1100303:1=115;1|1100503:1=4;1|1090303:1=48;1|1090503:1=2;4|1100101:1=6000,1100102:1=1500,1100103:1=2500;1|1100401:1=1038,1100402:1=448,1090403:1=142,1100201:1=3880,1100202:1=448,1090203:1=142,1100201:1=0'),(482,1255006,2,2,'1|1110301:1=250;1|1110501:1=23;1|1110302:1=81;1|1110502:1=4;1|1110303:1=54;1|1110503:1=3;1|1100301:1=250;1|1100501:1=23;0|1100302:1=81;1|1100502:1=4;1|1100303:1=108;1|1100503:1=4;1|1090303:1=45;1|1090503:1=2;4|1100101:1=6000,1100102:1=1500,1100103:1=2500;1|1100401:1=1038,1100402:1=448,1090403:1=142,1100201:1=3880,1100202:1=448,1090203:1=142,1100201:1=0'),(483,1255006,3,3,'1|1110301:1=225;1|1110501:1=20;1|1110302:1=75;1|1110502:1=4;1|1110303:1=50;1|1110503:1=3;1|1100301:1=225;1|1100501:1=20;0|1100302:1=75;1|1100502:1=4;1|1100303:1=100;1|1100503:1=4;1|1090303:1=42;1|1090503:1=2;4|1100101:1=6000,1100102:1=1500,1100103:1=2500;1|1100401:1=1038,1100402:1=448,1090403:1=142,1100201:1=3880,1100202:1=448,1090203:1=142,1100201:1=0'),(484,1255006,4,5,'1|1110301:1=200;1|1110501:1=18;1|1110302:1=64;1|1110502:1=3;1|1110303:1=43;1|1110503:1=2;1|1100301:1=200;1|1100501:1=18;0|1100302:1=64;1|1100502:1=3;1|1100303:1=85;1|1100503:1=3;1|1090303:1=36;1|1090503:1=1;4|1100101:1=6000,1100102:1=1500,1100103:1=2500;1|1100401:1=1038,1100402:1=448,1090403:1=142,1100201:1=3880,1100202:1=448,1090203:1=142,1100201:1=0'),(485,1255006,6,10,'1|1110301:1=175;1|1110501:1=15;1|1110302:1=60;1|1110502:1=3;1|1110303:1=40;1|1110503:1=2;1|1100301:1=175;1|1100501:1=15;0|1100302:1=60;1|1100502:1=3;1|1100303:1=80;1|1100503:1=3;1|1090303:1=34;1|1090503:1=1;4|1100101:1=6000,1100102:1=1500,1100103:1=2500;1|1100401:1=1038,1100402:1=448,1090403:1=142,1100201:1=3880,1100202:1=448,1090203:1=142,1100201:1=0'),(486,1255007,1,1,'1|1120301:1=250;1|1120501:1=25;1|1120302:1=58;1|1120502:1=3;1|1120303:1=58;1|1120503:1=3;1|1110301:1=250;1|1110501:1=25;0|1110302:1=86;1|1110502:1=4;1|1110303:1=58;1|1110503:1=3;1|1100303:1=24;1|1100503:1=1;4|1110101:1=6000,1110102:1=1500,1110103:1=2500;1|1110401:1=1046,1110402:1=424,1100403:1=135,1110201:1=4042,1110202:1=424,1100203:1=135,1110201:1=0'),(487,1255007,2,2,'1|1120301:1=250;1|1120501:1=23;1|1120302:1=54;1|1120502:1=3;1|1120303:1=54;1|1120503:1=3;1|1110301:1=250;1|1110501:1=23;0|1110302:1=81;1|1110502:1=4;1|1110303:1=54;1|1110503:1=3;1|1100303:1=23;1|1100503:1=1;4|1110101:1=6000,1110102:1=1500,1110103:1=2500;1|1110401:1=1046,1110402:1=424,1100403:1=135,1110201:1=4042,1110202:1=424,1100203:1=135,1110201:1=0'),(488,1255007,3,3,'1|1120301:1=225;1|1120501:1=20;1|1120302:1=50;1|1120502:1=3;1|1120303:1=50;1|1120503:1=3;1|1110301:1=225;1|1110501:1=20;0|1110302:1=75;1|1110502:1=4;1|1110303:1=50;1|1110503:1=3;1|1100303:1=21;1|1100503:1=1;4|1110101:1=6000,1110102:1=1500,1110103:1=2500;1|1110401:1=1046,1110402:1=424,1100403:1=135,1110201:1=4042,1110202:1=424,1100203:1=135,1110201:1=0'),(489,1255007,4,5,'1|1120301:1=200;1|1120501:1=18;1|1120302:1=43;1|1120502:1=2;1|1120303:1=43;1|1120503:1=2;1|1110301:1=200;1|1110501:1=18;0|1110302:1=64;1|1110502:1=3;1|1110303:1=43;1|1110503:1=2;1|1100303:1=18;1|1100503:1=1;4|1110101:1=6000,1110102:1=1500,1110103:1=2500;1|1110401:1=1046,1110402:1=424,1100403:1=135,1110201:1=4042,1110202:1=424,1100203:1=135,1110201:1=0'),(490,1255007,6,10,'1|1120301:1=175;1|1120501:1=15;1|1120302:1=40;1|1120502:1=2;1|1120303:1=40;1|1120503:1=2;1|1110301:1=175;1|1110501:1=15;0|1110302:1=60;1|1110502:1=3;1|1110303:1=40;1|1110503:1=2;1|1100303:1=17;1|1100503:1=1;4|1110101:1=6000,1110102:1=1500,1110103:1=2500;1|1110401:1=1046,1110402:1=424,1100403:1=135,1110201:1=4042,1110202:1=424,1100203:1=135,1110201:1=0'),(491,1255008,1,1,'1|1130301:1=300;1|1130501:1=25;1|1130302:1=58;1|1130502:1=3;1|1130303:1=86;1|1130503:1=3;1|1120301:1=250;1|1120501:1=25;0|1120302:1=58;1|1120502:1=3;1|1120303:1=58;1|1120503:1=3;1|1110303:1=24;1|1110503:1=1;4|1120101:1=6000,1120102:1=1500,1120103:1=2500;1|1120401:1=1054,1120402:1=401,1110403:1=127,1120201:1=4208,1120202:1=401,1110203:1=127,1120201:1=0'),(492,1255008,2,2,'1|1130301:1=250;1|1130501:1=23;1|1130302:1=54;1|1130502:1=3;1|1130303:1=81;1|1130503:1=3;1|1120301:1=250;1|1120501:1=23;0|1120302:1=54;1|1120502:1=3;1|1120303:1=54;1|1120503:1=3;1|1110303:1=23;1|1110503:1=1;4|1120101:1=6000,1120102:1=1500,1120103:1=2500;1|1120401:1=1054,1120402:1=401,1110403:1=127,1120201:1=4208,1120202:1=401,1110203:1=127,1120201:1=0'),(493,1255008,3,3,'1|1130301:1=225;1|1130501:1=18;1|1130302:1=50;1|1130502:1=3;1|1130303:1=75;1|1130503:1=3;1|1120301:1=225;1|1120501:1=20;0|1120302:1=50;1|1120502:1=3;1|1120303:1=50;1|1120503:1=3;1|1110303:1=21;1|1110503:1=1;4|1120101:1=6000,1120102:1=1500,1120103:1=2500;1|1120401:1=1054,1120402:1=401,1110403:1=127,1120201:1=4208,1120202:1=401,1110203:1=127,1120201:1=0'),(494,1255008,4,5,'1|1130301:1=200;1|1130501:1=15;1|1130302:1=43;1|1130502:1=2;1|1130303:1=64;1|1130503:1=2;1|1120301:1=200;1|1120501:1=18;0|1120302:1=43;1|1120502:1=2;1|1120303:1=43;1|1120503:1=2;1|1110303:1=18;1|1110503:1=1;4|1120101:1=6000,1120102:1=1500,1120103:1=2500;1|1120401:1=1054,1120402:1=401,1110403:1=127,1120201:1=4208,1120202:1=401,1110203:1=127,1120201:1=0'),(495,1255008,6,10,'1|1130301:1=175;1|1130501:1=10;1|1130302:1=40;1|1130502:1=2;1|1130303:1=60;1|1130503:1=2;1|1120301:1=175;1|1120501:1=15;0|1120302:1=40;1|1120502:1=2;1|1120303:1=40;1|1120503:1=2;1|1110303:1=17;1|1110503:1=1;4|1120101:1=6000,1120102:1=1500,1120103:1=2500;1|1120401:1=1054,1120402:1=401,1110403:1=127,1120201:1=4208,1120202:1=401,1110203:1=127,1120201:1=0'),(496,1256001,1,1,'1|1080301:1=1000;1|1080501:1=75;1|1080302:1=144;1|1080502:1=12;1|1080303:1=144;1|1080503:1=12;1|1070303:1=60;1|1070503:1=5;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;1|1080401:1=1020,1080402:1=495,1070403:1=156,1080201:1=3550,1080202:1=495,1070203:1=156,1080201:1=0'),(497,1256001,2,2,'1|1080301:1=900;1|1080501:1=60;1|1080302:1=135;1|1080502:1=11;1|1080303:1=135;1|1080503:1=11;1|1070303:1=57;1|1070503:1=5;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;1|1080401:1=1020,1080402:1=495,1070403:1=156,1080201:1=3550,1080202:1=495,1070203:1=156,1080201:1=0'),(498,1256001,3,3,'1|1080301:1=750;1|1080501:1=65;1|1080302:1=125;1|1080502:1=10;1|1080303:1=125;1|1080503:1=10;1|1070303:1=53;1|1070503:1=4;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;1|1080401:1=1020,1080402:1=495,1070403:1=156,1080201:1=3550,1080202:1=495,1070203:1=156,1080201:1=0'),(499,1256001,4,5,'1|1080301:1=600;1|1080501:1=60;1|1080302:1=106;1|1080502:1=9;1|1080303:1=106;1|1080503:1=9;1|1070303:1=45;1|1070503:1=4;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;1|1080401:1=1020,1080402:1=495,1070403:1=156,1080201:1=3550,1080202:1=495,1070203:1=156,1080201:1=0'),(500,1256001,6,10,'1|1080301:1=500;1|1080501:1=50;1|1080302:1=100;1|1080502:1=8;1|1080303:1=100;1|1080503:1=8;1|1070303:1=42;1|1070503:1=3;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;1|1080401:1=1020,1080402:1=495,1070403:1=156,1080201:1=3550,1080202:1=495,1070203:1=156,1080201:1=0'),(501,1256002,1,1,'1|1090301:1=375;1|1090501:1=30;1|1090302:1=86;1|1090502:1=4;1|1090303:1=115;1|1090503:1=4;1|1080301:1=500;1|1080501:1=38;0|1080302:1=72;1|1080502:1=6;1|1080303:1=72;1|1080503:1=6;1|1070303:1=30;1|1070503:1=2;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;1|1080401:1=1020,1080402:1=495,1070403:1=156,1080201:1=3550,1080202:1=495,1070203:1=156,1080201:1=0'),(502,1256002,2,2,'1|1090301:1=300;1|1090501:1=25;1|1090302:1=81;1|1090502:1=4;1|1090303:1=108;1|1090503:1=4;1|1080301:1=450;1|1080501:1=30;0|1080302:1=68;1|1080502:1=5;1|1080303:1=68;1|1080503:1=5;1|1070303:1=28;1|1070503:1=2;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;1|1080401:1=1020,1080402:1=495,1070403:1=156,1080201:1=3550,1080202:1=495,1070203:1=156,1080201:1=0'),(503,1256002,3,3,'1|1090301:1=250;1|1090501:1=23;1|1090302:1=75;1|1090502:1=4;1|1090303:1=100;1|1090503:1=4;1|1080301:1=375;1|1080501:1=33;0|1080302:1=63;1|1080502:1=5;1|1080303:1=63;1|1080503:1=5;1|1070303:1=26;1|1070503:1=2;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;1|1080401:1=1020,1080402:1=495,1070403:1=156,1080201:1=3550,1080202:1=495,1070203:1=156,1080201:1=0'),(504,1256002,4,5,'1|1090301:1=200;1|1090501:1=18;1|1090302:1=64;1|1090502:1=3;1|1090303:1=85;1|1090503:1=3;1|1080301:1=300;1|1080501:1=30;0|1080302:1=53;1|1080502:1=4;1|1080303:1=53;1|1080503:1=4;1|1070303:1=22;1|1070503:1=2;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;1|1080401:1=1020,1080402:1=495,1070403:1=156,1080201:1=3550,1080202:1=495,1070203:1=156,1080201:1=0'),(505,1256002,6,10,'1|1090301:1=200;1|1090501:1=15;1|1090302:1=60;1|1090502:1=3;1|1090303:1=80;1|1090503:1=3;1|1080301:1=250;1|1080501:1=25;0|1080302:1=50;1|1080502:1=4;1|1080303:1=50;1|1080503:1=4;1|1070303:1=21;1|1070503:1=2;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;1|1080401:1=1020,1080402:1=495,1070403:1=156,1080201:1=3550,1080202:1=495,1070203:1=156,1080201:1=0'),(506,1256003,1,1,'1|1100301:1=250;1|1100501:1=25;1|1100302:1=86;1|1100502:1=4;1|1100303:1=115;1|1100503:1=4;1|1090301:1=375;1|1090501:1=30;0|1090302:1=86;1|1090502:1=4;1|1090303:1=115;1|1090503:1=4;1|1080303:1=48;1|1080503:1=2;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;1|1090401:1=1029,1090402:1=472,1080403:1=149,1090201:1=3714,1090202:1=472,1080203:1=149,1090201:1=0'),(507,1256003,2,2,'1|1100301:1=250;1|1100501:1=23;1|1100302:1=81;1|1100502:1=4;1|1100303:1=108;1|1100503:1=4;1|1090301:1=300;1|1090501:1=25;0|1090302:1=81;1|1090502:1=4;1|1090303:1=108;1|1090503:1=4;1|1080303:1=45;1|1080503:1=2;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;1|1090401:1=1029,1090402:1=472,1080403:1=149,1090201:1=3714,1090202:1=472,1080203:1=149,1090201:1=0'),(508,1256003,3,3,'1|1100301:1=225;1|1100501:1=20;1|1100302:1=75;1|1100502:1=4;1|1100303:1=100;1|1100503:1=4;1|1090301:1=250;1|1090501:1=23;0|1090302:1=75;1|1090502:1=4;1|1090303:1=100;1|1090503:1=4;1|1080303:1=42;1|1080503:1=2;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;1|1090401:1=1029,1090402:1=472,1080403:1=149,1090201:1=3714,1090202:1=472,1080203:1=149,1090201:1=0'),(509,1256003,4,5,'1|1100301:1=200;1|1100501:1=18;1|1100302:1=64;1|1100502:1=3;1|1100303:1=85;1|1100503:1=3;1|1090301:1=200;1|1090501:1=18;0|1090302:1=64;1|1090502:1=3;1|1090303:1=85;1|1090503:1=3;1|1080303:1=36;1|1080503:1=1;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;1|1090401:1=1029,1090402:1=472,1080403:1=149,1090201:1=3714,1090202:1=472,1080203:1=149,1090201:1=0'),(510,1256003,6,10,'1|1100301:1=175;1|1100501:1=15;1|1100302:1=60;1|1100502:1=3;1|1100303:1=80;1|1100503:1=3;1|1090301:1=200;1|1090501:1=15;0|1090302:1=60;1|1090502:1=3;1|1090303:1=80;1|1090503:1=3;1|1080303:1=34;1|1080503:1=1;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;1|1090401:1=1029,1090402:1=472,1080403:1=149,1090201:1=3714,1090202:1=472,1080203:1=149,1090201:1=0'),(511,1256004,1,1,'1|1110301:1=250;1|1110501:1=25;1|1110302:1=86;1|1110502:1=4;1|1110303:1=58;1|1110503:1=3;1|1100301:1=250;1|1100501:1=25;0|1100302:1=86;1|1100502:1=4;1|1100303:1=115;1|1100503:1=4;1|1090303:1=48;1|1090503:1=2;4|1100101:1=6000,1100102:1=1500,1100103:1=2500;1|1100401:1=1038,1100402:1=448,1090403:1=142,1100201:1=3880,1100202:1=448,1090203:1=142,1100201:1=0'),(512,1256004,2,2,'1|1110301:1=250;1|1110501:1=23;1|1110302:1=81;1|1110502:1=4;1|1110303:1=54;1|1110503:1=3;1|1100301:1=250;1|1100501:1=23;0|1100302:1=81;1|1100502:1=4;1|1100303:1=108;1|1100503:1=4;1|1090303:1=45;1|1090503:1=2;4|1100101:1=6000,1100102:1=1500,1100103:1=2500;1|1100401:1=1038,1100402:1=448,1090403:1=142,1100201:1=3880,1100202:1=448,1090203:1=142,1100201:1=0'),(513,1256004,3,3,'1|1110301:1=225;1|1110501:1=20;1|1110302:1=75;1|1110502:1=4;1|1110303:1=50;1|1110503:1=3;1|1100301:1=225;1|1100501:1=20;0|1100302:1=75;1|1100502:1=4;1|1100303:1=100;1|1100503:1=4;1|1090303:1=42;1|1090503:1=2;4|1100101:1=6000,1100102:1=1500,1100103:1=2500;1|1100401:1=1038,1100402:1=448,1090403:1=142,1100201:1=3880,1100202:1=448,1090203:1=142,1100201:1=0'),(514,1256004,4,5,'1|1110301:1=200;1|1110501:1=18;1|1110302:1=64;1|1110502:1=3;1|1110303:1=43;1|1110503:1=2;1|1100301:1=200;1|1100501:1=18;0|1100302:1=64;1|1100502:1=3;1|1100303:1=85;1|1100503:1=3;1|1090303:1=36;1|1090503:1=1;4|1100101:1=6000,1100102:1=1500,1100103:1=2500;1|1100401:1=1038,1100402:1=448,1090403:1=142,1100201:1=3880,1100202:1=448,1090203:1=142,1100201:1=0'),(515,1256004,6,10,'1|1110301:1=175;1|1110501:1=15;1|1110302:1=60;1|1110502:1=3;1|1110303:1=40;1|1110503:1=2;1|1100301:1=175;1|1100501:1=15;0|1100302:1=60;1|1100502:1=3;1|1100303:1=80;1|1100503:1=3;1|1090303:1=34;1|1090503:1=1;4|1100101:1=6000,1100102:1=1500,1100103:1=2500;1|1100401:1=1038,1100402:1=448,1090403:1=142,1100201:1=3880,1100202:1=448,1090203:1=142,1100201:1=0'),(516,1256005,1,1,'1|1120301:1=250;1|1120501:1=25;1|1120302:1=58;1|1120502:1=3;1|1120303:1=58;1|1120503:1=3;1|1110301:1=250;1|1110501:1=25;0|1110302:1=86;1|1110502:1=4;1|1110303:1=58;1|1110503:1=3;1|1100303:1=24;1|1100503:1=1;4|1110101:1=6000,1110102:1=1500,1110103:1=2500;1|1110401:1=1046,1110402:1=424,1100403:1=135,1110201:1=4042,1110202:1=424,1100203:1=135,1110201:1=0'),(517,1256005,2,2,'1|1120301:1=250;1|1120501:1=23;1|1120302:1=54;1|1120502:1=3;1|1120303:1=54;1|1120503:1=3;1|1110301:1=250;1|1110501:1=23;0|1110302:1=81;1|1110502:1=4;1|1110303:1=54;1|1110503:1=3;1|1100303:1=23;1|1100503:1=1;4|1110101:1=6000,1110102:1=1500,1110103:1=2500;1|1110401:1=1046,1110402:1=424,1100403:1=135,1110201:1=4042,1110202:1=424,1100203:1=135,1110201:1=0'),(518,1256005,3,3,'1|1120301:1=225;1|1120501:1=20;1|1120302:1=50;1|1120502:1=3;1|1120303:1=50;1|1120503:1=3;1|1110301:1=225;1|1110501:1=20;0|1110302:1=75;1|1110502:1=4;1|1110303:1=50;1|1110503:1=3;1|1100303:1=21;1|1100503:1=1;4|1110101:1=6000,1110102:1=1500,1110103:1=2500;1|1110401:1=1046,1110402:1=424,1100403:1=135,1110201:1=4042,1110202:1=424,1100203:1=135,1110201:1=0'),(519,1256005,4,5,'1|1120301:1=200;1|1120501:1=18;1|1120302:1=43;1|1120502:1=2;1|1120303:1=43;1|1120503:1=2;1|1110301:1=200;1|1110501:1=18;0|1110302:1=64;1|1110502:1=3;1|1110303:1=43;1|1110503:1=2;1|1100303:1=18;1|1100503:1=1;4|1110101:1=6000,1110102:1=1500,1110103:1=2500;1|1110401:1=1046,1110402:1=424,1100403:1=135,1110201:1=4042,1110202:1=424,1100203:1=135,1110201:1=0'),(520,1256005,6,10,'1|1120301:1=175;1|1120501:1=15;1|1120302:1=40;1|1120502:1=2;1|1120303:1=40;1|1120503:1=2;1|1110301:1=175;1|1110501:1=15;0|1110302:1=60;1|1110502:1=3;1|1110303:1=40;1|1110503:1=2;1|1100303:1=17;1|1100503:1=1;4|1110101:1=6000,1110102:1=1500,1110103:1=2500;1|1110401:1=1046,1110402:1=424,1100403:1=135,1110201:1=4042,1110202:1=424,1100203:1=135,1110201:1=0'),(521,1256006,1,1,'1|1130301:1=300;1|1130501:1=25;1|1130302:1=58;1|1130502:1=3;1|1130303:1=86;1|1130503:1=3;1|1120301:1=250;1|1120501:1=25;0|1120302:1=58;1|1120502:1=3;1|1120303:1=58;1|1120503:1=3;1|1110303:1=24;1|1110503:1=1;4|1120101:1=6000,1120102:1=1500,1120103:1=2500;1|1120401:1=1054,1120402:1=401,1110403:1=127,1120201:1=4208,1120202:1=401,1110203:1=127,1120201:1=0'),(522,1256006,2,2,'1|1130301:1=250;1|1130501:1=23;1|1130302:1=54;1|1130502:1=3;1|1130303:1=81;1|1130503:1=3;1|1120301:1=250;1|1120501:1=23;0|1120302:1=54;1|1120502:1=3;1|1120303:1=54;1|1120503:1=3;1|1110303:1=23;1|1110503:1=1;4|1120101:1=6000,1120102:1=1500,1120103:1=2500;1|1120401:1=1054,1120402:1=401,1110403:1=127,1120201:1=4208,1120202:1=401,1110203:1=127,1120201:1=0'),(523,1256006,3,3,'1|1130301:1=225;1|1130501:1=18;1|1130302:1=50;1|1130502:1=3;1|1130303:1=75;1|1130503:1=3;1|1120301:1=225;1|1120501:1=20;0|1120302:1=50;1|1120502:1=3;1|1120303:1=50;1|1120503:1=3;1|1110303:1=21;1|1110503:1=1;4|1120101:1=6000,1120102:1=1500,1120103:1=2500;1|1120401:1=1054,1120402:1=401,1110403:1=127,1120201:1=4208,1120202:1=401,1110203:1=127,1120201:1=0'),(524,1256006,4,5,'1|1130301:1=200;1|1130501:1=15;1|1130302:1=43;1|1130502:1=2;1|1130303:1=64;1|1130503:1=2;1|1120301:1=200;1|1120501:1=18;0|1120302:1=43;1|1120502:1=2;1|1120303:1=43;1|1120503:1=2;1|1110303:1=18;1|1110503:1=1;4|1120101:1=6000,1120102:1=1500,1120103:1=2500;1|1120401:1=1054,1120402:1=401,1110403:1=127,1120201:1=4208,1120202:1=401,1110203:1=127,1120201:1=0'),(525,1256006,6,10,'1|1130301:1=175;1|1130501:1=10;1|1130302:1=40;1|1130502:1=2;1|1130303:1=60;1|1130503:1=2;1|1120301:1=175;1|1120501:1=15;0|1120302:1=40;1|1120502:1=2;1|1120303:1=40;1|1120503:1=2;1|1110303:1=17;1|1110503:1=1;4|1120101:1=6000,1120102:1=1500,1120103:1=2500;1|1120401:1=1054,1120402:1=401,1110403:1=127,1120201:1=4208,1120202:1=401,1110203:1=127,1120201:1=0'),(526,1256007,1,1,'1|1140301:1=250;1|1140501:1=25;1|1140302:1=58;1|1140502:1=3;1|1140303:1=86;1|1140503:1=3;1|1130301:1=300;1|1130501:1=25;0|1130302:1=58;1|1130502:1=3;1|1130303:1=86;1|1130503:1=3;1|1120303:1=36;1|1120503:1=1;4|1130101:1=6000,1130102:1=1500,1130103:1=2500;1|1130401:1=1063,1130402:1=378,1120403:1=120,1130201:1=4372,1130202:1=378,1120203:1=120,1130201:1=0'),(527,1256007,2,2,'1|1140301:1=225;1|1140501:1=23;1|1140302:1=54;1|1140502:1=3;1|1140303:1=81;1|1140503:1=3;1|1130301:1=250;1|1130501:1=23;0|1130302:1=54;1|1130502:1=3;1|1130303:1=81;1|1130503:1=3;1|1120303:1=34;1|1120503:1=1;4|1130101:1=6000,1130102:1=1500,1130103:1=2500;1|1130401:1=1063,1130402:1=378,1120403:1=120,1130201:1=4372,1130202:1=378,1120203:1=120,1130201:1=0'),(528,1256007,3,3,'1|1140301:1=200;1|1140501:1=18;1|1140302:1=50;1|1140502:1=3;1|1140303:1=75;1|1140503:1=3;1|1130301:1=225;1|1130501:1=18;0|1130302:1=50;1|1130502:1=3;1|1130303:1=75;1|1130503:1=3;1|1120303:1=32;1|1120503:1=1;4|1130101:1=6000,1130102:1=1500,1130103:1=2500;1|1130401:1=1063,1130402:1=378,1120403:1=120,1130201:1=4372,1130202:1=378,1120203:1=120,1130201:1=0'),(529,1256007,4,5,'1|1140301:1=175;1|1140501:1=15;1|1140302:1=43;1|1140502:1=2;1|1140303:1=64;1|1140503:1=2;1|1130301:1=200;1|1130501:1=15;0|1130302:1=43;1|1130502:1=2;1|1130303:1=64;1|1130503:1=2;1|1120303:1=27;1|1120503:1=1;4|1130101:1=6000,1130102:1=1500,1130103:1=2500;1|1130401:1=1063,1130402:1=378,1120403:1=120,1130201:1=4372,1130202:1=378,1120203:1=120,1130201:1=0'),(530,1256007,6,10,'1|1140301:1=150;1|1140501:1=10;1|1140302:1=40;1|1140502:1=2;1|1140303:1=60;1|1140503:1=2;1|1130301:1=175;1|1130501:1=10;0|1130302:1=40;1|1130502:1=2;1|1130303:1=60;1|1130503:1=2;1|1120303:1=25;1|1120503:1=1;4|1130101:1=6000,1130102:1=1500,1130103:1=2500;1|1130401:1=1063,1130402:1=378,1120403:1=120,1130201:1=4372,1130202:1=378,1120203:1=120,1130201:1=0'),(531,1256008,1,1,'1|1150301:1=250;1|1150501:1=25;1|1150302:1=58;1|1150502:1=3;1|1150303:1=86;1|1150503:1=3;1|1140301:1=250;1|1140501:1=25;0|1140302:1=58;1|1140502:1=3;1|1140303:1=86;1|1140503:1=3;1|1130303:1=36;1|1130503:1=1;4|1140101:1=6000,1140102:1=1500,1140103:1=2500;1|1140401:1=1072,1140402:1=354,1130403:1=114,1140201:1=4538,1140202:1=354,1130203:1=114,1140201:1=0'),(532,1256008,2,2,'1|1150301:1=225;1|1150501:1=23;1|1150302:1=54;1|1150502:1=3;1|1150303:1=81;1|1150503:1=3;1|1140301:1=225;1|1140501:1=23;0|1140302:1=54;1|1140502:1=3;1|1140303:1=81;1|1140503:1=3;1|1130303:1=34;1|1130503:1=1;4|1140101:1=6000,1140102:1=1500,1140103:1=2500;1|1140401:1=1072,1140402:1=354,1130403:1=114,1140201:1=4538,1140202:1=354,1130203:1=114,1140201:1=0'),(533,1256008,3,3,'1|1150301:1=200;1|1150501:1=18;1|1150302:1=50;1|1150502:1=3;1|1150303:1=75;1|1150503:1=3;1|1140301:1=200;1|1140501:1=18;0|1140302:1=50;1|1140502:1=3;1|1140303:1=75;1|1140503:1=3;1|1130303:1=32;1|1130503:1=1;4|1140101:1=6000,1140102:1=1500,1140103:1=2500;1|1140401:1=1072,1140402:1=354,1130403:1=114,1140201:1=4538,1140202:1=354,1130203:1=114,1140201:1=0'),(534,1256008,4,5,'1|1150301:1=175;1|1150501:1=15;1|1150302:1=43;1|1150502:1=2;1|1150303:1=64;1|1150503:1=2;1|1140301:1=175;1|1140501:1=15;0|1140302:1=43;1|1140502:1=2;1|1140303:1=64;1|1140503:1=2;1|1130303:1=27;1|1130503:1=1;4|1140101:1=6000,1140102:1=1500,1140103:1=2500;1|1140401:1=1072,1140402:1=354,1130403:1=114,1140201:1=4538,1140202:1=354,1130203:1=114,1140201:1=0'),(535,1256008,6,10,'1|1150301:1=150;1|1150501:1=10;1|1150302:1=40;1|1150502:1=2;1|1150303:1=60;1|1150503:1=2;1|1140301:1=150;1|1140501:1=10;0|1140302:1=40;1|1140502:1=2;1|1140303:1=60;1|1140503:1=2;1|1130303:1=25;1|1130503:1=1;4|1140101:1=6000,1140102:1=1500,1140103:1=2500;1|1140401:1=1072,1140402:1=354,1130403:1=114,1140201:1=4538,1140202:1=354,1130203:1=114,1140201:1=0');
/*!40000 ALTER TABLE `base_boss_rank_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_boss_type`
--

DROP TABLE IF EXISTS `base_boss_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_boss_type` (
  `boss_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT 'boss类型##1:世界Boss;2:个人Boss;3:Boss之家;4:蛮荒禁地',
  `count` int(11) unsigned DEFAULT '0' COMMENT '每天限制次数',
  `module` int(11) unsigned DEFAULT '0' COMMENT '模块id',
  `daily_id` smallint(5) unsigned DEFAULT '0' COMMENT '计数器id',
  `max_anger` int(11) unsigned DEFAULT '0' COMMENT '最大怒气值',
  `tired` int(11) unsigned DEFAULT '0' COMMENT '最大疲劳值',
  `cost` varchar(1000) DEFAULT '[]' COMMENT '该类型boss进入的消耗',
  `condition` varchar(1000) DEFAULT '[]' COMMENT '该类型boss进入的条件',
  `mon_ids` varchar(300) NOT NULL DEFAULT '[]' COMMENT '蛮荒禁地的小怪id',
  `refresh_time` varchar(255) NOT NULL DEFAULT '[]' COMMENT '定时刷新的时间点',
  `enter_reward_times` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '参与奖次数',
  `revive_cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '原地复活消耗',
  PRIMARY KEY (`boss_type`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_boss_type`
--

LOCK TABLES `base_boss_type` WRITE;
/*!40000 ALTER TABLE `base_boss_type` DISABLE KEYS */;
INSERT INTO `base_boss_type` VALUES (1,0,460,1,0,0,'[]','[{lv,9999}]','[]','[{16,0},{22,0}]',0,'[{2,0,10}]'),(2,2,610,10,0,0,'[{1,[{0,38030002,1}]}]','[{lv,150}]','[]','[]',0,'[]'),(3,0,460,3,0,0,'[{1,[{0,38030009,1}]}]','[{lv,170},{vip,4}]','[]','[]',0,'[]'),(4,2,460,4,100,0,'[{1,[{0,38030003,2}]},{2,[{0,38030003,3}]},{3,[{0,38030003,4}]},{4,[{0,38030003,5}]},{5,[{0,38030003,6}]},{6,[{0,38030003,7}]},{7,[{0,38030003,8}]},{8,[{0,38030003,8}]},{9,[{0,38030003,8}]},{10,[{0,38030003,8}]},{11,[{0,38030003,8}]},{12,[{0,38030003,8}]},{13,[{0,38030003,8}]},{14,[{0,38030003,8}]},{15,[{0,38030003,8}]},{16,[{0,38030003,8}]}]','[{lv,240}]','[1301901,1301902,1301903,1301904,1301905,1301906,1301907,1302901,1302902,1302903,1302904,1302905,1302906,1302907,1302908,1303901,1303902,1303903,1303904,1303905,1303906,1304901,1304902,1304903,1304904,1304905,1304906]','[]',0,'[{2,0,10}]'),(5,0,460,5,0,3,'[]','[{lv,94}]','[]','[]',0,'[{2,0,10}]');
/*!40000 ALTER TABLE `base_boss_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_butterfly_integration_reward`
--

DROP TABLE IF EXISTS `base_butterfly_integration_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_butterfly_integration_reward` (
  `reward_id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '奖励id',
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励阶段ID',
  `min_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小世界等级',
  `max_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大世界等级',
  `condition` varchar(255) NOT NULL COMMENT '达成条件',
  `reward` varchar(255) NOT NULL COMMENT '奖励内容',
  PRIMARY KEY (`reward_id`)
) ENGINE=InnoDB AUTO_INCREMENT=161 DEFAULT CHARSET=utf8 COMMENT='捕蝶积分奖励';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_butterfly_integration_reward`
--

LOCK TABLES `base_butterfly_integration_reward` WRITE;
/*!40000 ALTER TABLE `base_butterfly_integration_reward` DISABLE KEYS */;
INSERT INTO `base_butterfly_integration_reward` VALUES (1,1,1,200,'[{1,10}]','[{5,36060001,2936996},{0,18020001,5}]'),(2,1,201,230,'[{1,10}]','[{5,36060001,2936996},{0,18020001,5}]'),(3,1,231,260,'[{1,10}]','[{5,36060001,3736429},{0,18020001,5}]'),(4,1,261,290,'[{1,10}]','[{5,36060001,4744662},{0,18020001,6}]'),(5,1,291,320,'[{1,10}]','[{5,36060001,5204732},{0,18020001,6}]'),(6,1,321,335,'[{1,10}]','[{5,36060001,5605803},{0,18020001,7}]'),(7,1,336,350,'[{1,10}]','[{5,36060001,5943386},{0,18020001,7}]'),(8,1,351,360,'[{1,10}]','[{5,36060001,6410766},{0,18020001,8}]'),(9,1,361,370,'[{1,10}]','[{5,36060001,6836629},{0,18020001,8}]'),(10,1,371,380,'[{1,10}]','[{5,36060001,10358805},{0,18020001,8}]'),(11,1,381,390,'[{1,10}]','[{5,36060001,13034705},{0,18020001,8}]'),(12,1,391,400,'[{1,10}]','[{5,36060001,14459705},{0,18020001,8}]'),(13,1,401,420,'[{1,10}]','[{5,36060001,15884705},{0,18020001,9}]'),(14,1,421,440,'[{1,10}]','[{5,36060001,18734705},{0,18020001,9}]'),(15,1,441,460,'[{1,10}]','[{5,36060001,21478841},{0,18020001,9}]'),(16,1,461,480,'[{1,10}]','[{5,36060001,27461321},{0,18020002,3}]'),(17,1,481,500,'[{1,10}]','[{5,36060001,31044154},{0,18020002,3}]'),(18,1,501,520,'[{1,10}]','[{5,36060001,33181654},{0,18020002,3}]'),(19,1,521,540,'[{1,10}]','[{5,36060001,38095080},{0,18020002,3}]'),(20,1,541,560,'[{1,10}]','[{5,36060001,49695055},{0,18020002,3}]'),(21,1,561,580,'[{1,10}]','[{5,36060001,60916727},{0,18020002,3}]'),(22,1,581,600,'[{1,10}]','[{5,36060001,66616727},{0,18020002,3}]'),(23,1,601,620,'[{1,10}]','[{5,36060001,72316727},{0,18020002,4}]'),(24,1,621,640,'[{1,10}]','[{5,36060001,78016727},{0,18020002,4}]'),(25,1,641,660,'[{1,10}]','[{5,36060001,83716727},{0,18020002,4}]'),(26,1,661,680,'[{1,10}]','[{5,36060001,89416727},{0,18020002,4}]'),(27,1,681,700,'[{1,10}]','[{5,36060001,95116727},{0,18020002,4}]'),(28,1,701,720,'[{1,10}]','[{5,36060001,100816727},{0,18020002,4}]'),(29,1,721,740,'[{1,10}]','[{5,36060001,106516727},{0,18020002,4}]'),(30,1,741,760,'[{1,10}]','[{5,36060001,112216727},{0,18020002,4}]'),(31,1,761,780,'[{1,10}]','[{5,36060001,117916727},{0,18020002,4}]'),(32,1,781,1000,'[{1,10}]','[{5,36060001,123616727},{0,18020002,4}]'),(33,2,1,200,'[{1,20}]','[{5,36060001,2936996},{0,18020001,5}]'),(34,2,201,230,'[{1,20}]','[{5,36060001,2936996},{0,18020001,5}]'),(35,2,231,260,'[{1,20}]','[{5,36060001,3736429},{0,18020001,5}]'),(36,2,261,290,'[{1,20}]','[{5,36060001,4744662},{0,18020001,6}]'),(37,2,291,320,'[{1,20}]','[{5,36060001,5204732},{0,18020001,6}]'),(38,2,321,335,'[{1,20}]','[{5,36060001,5605803},{0,18020001,7}]'),(39,2,336,350,'[{1,20}]','[{5,36060001,5943386},{0,18020001,7}]'),(40,2,351,360,'[{1,20}]','[{5,36060001,6410766},{0,18020001,8}]'),(41,2,361,370,'[{1,20}]','[{5,36060001,6836629},{0,18020001,8}]'),(42,2,371,380,'[{1,20}]','[{5,36060001,10358805},{0,18020001,8}]'),(43,2,381,390,'[{1,20}]','[{5,36060001,13034705},{0,18020001,8}]'),(44,2,391,400,'[{1,20}]','[{5,36060001,14459705},{0,18020001,8}]'),(45,2,401,420,'[{1,20}]','[{5,36060001,15884705},{0,18020001,9}]'),(46,2,421,440,'[{1,20}]','[{5,36060001,18734705},{0,18020001,9}]'),(47,2,441,460,'[{1,20}]','[{5,36060001,21478841},{0,18020001,9}]'),(48,2,461,480,'[{1,20}]','[{5,36060001,27461321},{0,18020002,3}]'),(49,2,481,500,'[{1,20}]','[{5,36060001,31044154},{0,18020002,3}]'),(50,2,501,520,'[{1,20}]','[{5,36060001,33181654},{0,18020002,3}]'),(51,2,521,540,'[{1,20}]','[{5,36060001,38095080},{0,18020002,3}]'),(52,2,541,560,'[{1,20}]','[{5,36060001,49695055},{0,18020002,3}]'),(53,2,561,580,'[{1,20}]','[{5,36060001,60916727},{0,18020002,3}]'),(54,2,581,600,'[{1,20}]','[{5,36060001,66616727},{0,18020002,3}]'),(55,2,601,620,'[{1,20}]','[{5,36060001,72316727},{0,18020002,4}]'),(56,2,621,640,'[{1,20}]','[{5,36060001,78016727},{0,18020002,4}]'),(57,2,641,660,'[{1,20}]','[{5,36060001,83716727},{0,18020002,4}]'),(58,2,661,680,'[{1,20}]','[{5,36060001,89416727},{0,18020002,4}]'),(59,2,681,700,'[{1,20}]','[{5,36060001,95116727},{0,18020002,4}]'),(60,2,701,720,'[{1,20}]','[{5,36060001,100816727},{0,18020002,4}]'),(61,2,721,740,'[{1,20}]','[{5,36060001,106516727},{0,18020002,4}]'),(62,2,741,760,'[{1,20}]','[{5,36060001,112216727},{0,18020002,4}]'),(63,2,761,780,'[{1,20}]','[{5,36060001,117916727},{0,18020002,4}]'),(64,2,781,1000,'[{1,20}]','[{5,36060001,123616727},{0,18020002,4}]'),(65,3,1,200,'[{1,50}]','[{5,36060001,3915995},{0,18020001,5}]'),(66,3,201,230,'[{1,50}]','[{5,36060001,3915995},{0,18020001,5}]'),(67,3,231,260,'[{1,50}]','[{5,36060001,4981905},{0,18020001,5}]'),(68,3,261,290,'[{1,50}]','[{5,36060001,6326216},{0,18020001,6}]'),(69,3,291,320,'[{1,50}]','[{5,36060001,6939643},{0,18020001,6}]'),(70,3,321,335,'[{1,50}]','[{5,36060001,7474404},{0,18020001,7}]'),(71,3,336,350,'[{1,50}]','[{5,36060001,7924514},{0,18020001,7}]'),(72,3,351,360,'[{1,50}]','[{5,36060001,8547688},{0,18020001,8}]'),(73,3,361,370,'[{1,50}]','[{5,36060001,9115505},{0,18020001,8}]'),(74,3,371,380,'[{1,50}]','[{5,36060001,13811740},{0,18020001,8}]'),(75,3,381,390,'[{1,50}]','[{5,36060001,17379606},{0,18020001,8}]'),(76,3,391,400,'[{1,50}]','[{5,36060001,19279606},{0,18020001,8}]'),(77,3,401,420,'[{1,50}]','[{5,36060001,21179606},{0,18020001,9}]'),(78,3,421,440,'[{1,50}]','[{5,36060001,24979606},{0,18020001,9}]'),(79,3,441,460,'[{1,50}]','[{5,36060001,28638455},{0,18020001,9}]'),(80,3,461,480,'[{1,50}]','[{5,36060001,36615095},{0,18020002,3}]'),(81,3,481,500,'[{1,50}]','[{5,36060001,41392205},{0,18020002,3}]'),(82,3,501,520,'[{1,50}]','[{5,36060001,44242205},{0,18020002,3}]'),(83,3,521,540,'[{1,50}]','[{5,36060001,50793440},{0,18020002,3}]'),(84,3,541,560,'[{1,50}]','[{5,36060001,66260073},{0,18020002,4}]'),(85,3,561,580,'[{1,50}]','[{5,36060001,81222303},{0,18020002,4}]'),(86,3,581,600,'[{1,50}]','[{5,36060001,88822303},{0,18020002,4}]'),(87,3,601,620,'[{1,50}]','[{5,36060001,96422303},{0,18020002,4}]'),(88,3,621,640,'[{1,50}]','[{5,36060001,104022303},{0,18020002,4}]'),(89,3,641,660,'[{1,50}]','[{5,36060001,111622303},{0,18020002,4}]'),(90,3,661,680,'[{1,50}]','[{5,36060001,119222303},{0,18020002,4}]'),(91,3,681,700,'[{1,50}]','[{5,36060001,126822303},{0,18020002,4}]'),(92,3,701,720,'[{1,50}]','[{5,36060001,134422303},{0,18020002,4}]'),(93,3,721,740,'[{1,50}]','[{5,36060001,142022303},{0,18020002,4}]'),(94,3,741,760,'[{1,50}]','[{5,36060001,149622303},{0,18020002,4}]'),(95,3,761,780,'[{1,50}]','[{5,36060001,157222303},{0,18020002,4}]'),(96,3,781,1000,'[{1,50}]','[{5,36060001,164822303},{0,18020002,4}]'),(97,4,1,200,'[{1,80}]','[{5,36060001,4894994},{0,18020001,5}]'),(98,4,201,230,'[{1,80}]','[{5,36060001,4894994},{0,18020001,5}]'),(99,4,231,260,'[{1,80}]','[{5,36060001,6227382},{0,18020001,5}]'),(100,4,261,290,'[{1,80}]','[{5,36060001,7907770},{0,18020001,6}]'),(101,4,291,320,'[{1,80}]','[{5,36060001,8674554},{0,18020001,6}]'),(102,4,321,335,'[{1,80}]','[{5,36060001,9343005},{0,18020001,7}]'),(103,4,336,350,'[{1,80}]','[{5,36060001,9905643},{0,18020001,7}]'),(104,4,351,360,'[{1,80}]','[{5,36060001,10684610},{0,18020001,8}]'),(105,4,361,370,'[{1,80}]','[{5,36060001,11394382},{0,18020001,8}]'),(106,4,371,380,'[{1,80}]','[{5,36060001,17264676},{0,18020001,8}]'),(107,4,381,390,'[{1,80}]','[{5,36060001,21724508},{0,18020001,8}]'),(108,4,391,400,'[{1,80}]','[{5,36060001,24099508},{0,18020001,8}]'),(109,4,401,420,'[{1,80}]','[{5,36060001,26474508},{0,18020001,9}]'),(110,4,421,440,'[{1,80}]','[{5,36060001,31224508},{0,18020001,9}]'),(111,4,441,460,'[{1,80}]','[{5,36060001,35798069},{0,18020001,9}]'),(112,4,461,480,'[{1,80}]','[{5,36060001,45768868},{0,18020002,3}]'),(113,4,481,500,'[{1,80}]','[{5,36060001,51740256},{0,18020002,3}]'),(114,4,501,520,'[{1,80}]','[{5,36060001,55302756},{0,18020002,4}]'),(115,4,521,540,'[{1,80}]','[{5,36060001,63491800},{0,18020002,4}]'),(116,4,541,560,'[{1,80}]','[{5,36060001,82825091},{0,18020002,4}]'),(117,4,561,580,'[{1,80}]','[{5,36060001,101527879},{0,18020002,4}]'),(118,4,581,600,'[{1,80}]','[{5,36060001,111027879},{0,18020002,4}]'),(119,4,601,620,'[{1,80}]','[{5,36060001,120527879},{0,18020002,4}]'),(120,4,621,640,'[{1,80}]','[{5,36060001,130027879},{0,18020002,4}]'),(121,4,641,660,'[{1,80}]','[{5,36060001,139527879},{0,18020002,4}]'),(122,4,661,680,'[{1,80}]','[{5,36060001,149027879},{0,18020002,4}]'),(123,4,681,700,'[{1,80}]','[{5,36060001,158527879},{0,18020002,4}]'),(124,4,701,720,'[{1,80}]','[{5,36060001,168027879},{0,18020002,5}]'),(125,4,721,740,'[{1,80}]','[{5,36060001,177527879},{0,18020002,5}]'),(126,4,741,760,'[{1,80}]','[{5,36060001,187027879},{0,18020002,5}]'),(127,4,761,780,'[{1,80}]','[{5,36060001,196527879},{0,18020002,5}]'),(128,4,781,1000,'[{1,80}]','[{5,36060001,206027879},{0,18020002,5}]'),(129,5,1,200,'[{1,100}]','[{5,36060001,4894994},{0,18020001,5}]'),(130,5,201,230,'[{1,100}]','[{5,36060001,4894994},{0,18020001,5}]'),(131,5,231,260,'[{1,100}]','[{5,36060001,6227382},{0,18020001,5}]'),(132,5,261,290,'[{1,100}]','[{5,36060001,7907770},{0,18020001,6}]'),(133,5,291,320,'[{1,100}]','[{5,36060001,8674554},{0,18020001,6}]'),(134,5,321,335,'[{1,100}]','[{5,36060001,9343005},{0,18020001,7}]'),(135,5,336,350,'[{1,100}]','[{5,36060001,9905643},{0,18020001,7}]'),(136,5,351,360,'[{1,100}]','[{5,36060001,10684610},{0,18020001,8}]'),(137,5,361,370,'[{1,100}]','[{5,36060001,11394382},{0,18020001,8}]'),(138,5,371,380,'[{1,100}]','[{5,36060001,17264676},{0,18020001,8}]'),(139,5,381,390,'[{1,100}]','[{5,36060001,21724508},{0,18020001,8}]'),(140,5,391,400,'[{1,100}]','[{5,36060001,24099508},{0,18020001,8}]'),(141,5,401,420,'[{1,100}]','[{5,36060001,26474508},{0,18020001,9}]'),(142,5,421,440,'[{1,100}]','[{5,36060001,31224508},{0,18020001,9}]'),(143,5,441,460,'[{1,100}]','[{5,36060001,35798069},{0,18020001,9}]'),(144,5,461,480,'[{1,100}]','[{5,36060001,45768868},{0,18020002,3}]'),(145,5,481,500,'[{1,100}]','[{5,36060001,51740256},{0,18020002,3}]'),(146,5,501,520,'[{1,100}]','[{5,36060001,55302756},{0,18020002,4}]'),(147,5,521,540,'[{1,100}]','[{5,36060001,63491800},{0,18020002,4}]'),(148,5,541,560,'[{1,100}]','[{5,36060001,82825091},{0,18020002,4}]'),(149,5,561,580,'[{1,100}]','[{5,36060001,101527879},{0,18020002,4}]'),(150,5,581,600,'[{1,100}]','[{5,36060001,111027879},{0,18020002,4}]'),(151,5,601,620,'[{1,100}]','[{5,36060001,120527879},{0,18020002,4}]'),(152,5,621,640,'[{1,100}]','[{5,36060001,130027879},{0,18020002,4}]'),(153,5,641,660,'[{1,100}]','[{5,36060001,139527879},{0,18020002,4}]'),(154,5,661,680,'[{1,100}]','[{5,36060001,149027879},{0,18020002,4}]'),(155,5,681,700,'[{1,100}]','[{5,36060001,158527879},{0,18020002,4}]'),(156,5,701,720,'[{1,100}]','[{5,36060001,168027879},{0,18020002,5}]'),(157,5,721,740,'[{1,100}]','[{5,36060001,177527879},{0,18020002,5}]'),(158,5,741,760,'[{1,100}]','[{5,36060001,187027879},{0,18020002,5}]'),(159,5,761,780,'[{1,100}]','[{5,36060001,196527879},{0,18020002,5}]'),(160,5,781,1000,'[{1,100}]','[{5,36060001,206027879},{0,18020002,5}]');
/*!40000 ALTER TABLE `base_butterfly_integration_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_butterfly_kv`
--

DROP TABLE IF EXISTS `base_butterfly_kv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_butterfly_kv` (
  `key` varchar(255) NOT NULL COMMENT '键',
  `value` varchar(255) NOT NULL COMMENT '值',
  PRIMARY KEY (`key`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_butterfly_kv`
--

LOCK TABLES `base_butterfly_kv` WRITE;
/*!40000 ALTER TABLE `base_butterfly_kv` DISABLE KEYS */;
INSERT INTO `base_butterfly_kv` VALUES ('act_time','20'),('open_lv','115'),('player_location','[{4846,12820},{9992,13423},{3502,9605},{4054,5851},{9639,1802},{15216,6148},{15690,9639},{14389,12824}]'),('room_limit','25'),('rotate_num','50'),('rotate_time','5'),('scene_id','3010'),('tired_limit','100');
/*!40000 ALTER TABLE `base_butterfly_kv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_butterfly_rank_reward`
--

DROP TABLE IF EXISTS `base_butterfly_rank_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_butterfly_rank_reward` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '名次I',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '名次',
  `min_lv` int(11) NOT NULL DEFAULT '0' COMMENT '最小世界等级',
  `max_lv` int(11) NOT NULL DEFAULT '0' COMMENT '最大世界等级',
  `reward` varchar(255) NOT NULL COMMENT '奖励内容',
  `extra_reward` varchar(255) NOT NULL COMMENT '额外奖励',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='捕蝶结算排行奖励';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_butterfly_rank_reward`
--

LOCK TABLES `base_butterfly_rank_reward` WRITE;
/*!40000 ALTER TABLE `base_butterfly_rank_reward` DISABLE KEYS */;
INSERT INTO `base_butterfly_rank_reward` VALUES (1,1,1,260,'[{0,18020001,24},{0,4905004,1}]','[]'),(2,1,261,320,'[{0,18020001,24},{0,4905004,1}]','[]'),(3,1,321,350,'[{0,18020001,28},{0,4905004,1}]','[]'),(4,1,351,370,'[{0,18020001,28},{0,4905004,1}]','[]'),(5,1,371,390,'[{0,18020001,35},{0,4905004,1}]','[]'),(6,1,391,430,'[{0,18020001,40},{0,4905004,1}]','[]'),(7,1,431,500,'[{0,18020001,45},{0,4905004,1}]','[]'),(8,1,501,560,'[{0,18020002,24},{0,4905004,1}]','[]'),(9,1,561,610,'[{0,18020002,24},{0,4905004,1}]','[]'),(10,1,611,660,'[{0,18020002,24},{0,4905004,1}]','[]'),(11,1,661,700,'[{0,18020002,28},{0,4905004,1}]','[]'),(12,1,701,750,'[{0,18020002,28},{0,4905004,1}]','[]'),(13,1,751,1000,'[{0,18020002,28},{0,4905004,1}]','[]'),(14,2,1,260,'[{0,18020001,20}]','[]'),(15,2,261,320,'[{0,18020001,20}]','[]'),(16,2,321,350,'[{0,18020001,25}]','[]'),(17,2,351,370,'[{0,18020001,25}]','[]'),(18,2,371,390,'[{0,18020001,30}]','[]'),(19,2,391,430,'[{0,18020001,35}]','[]'),(20,2,431,500,'[{0,18020001,40}]','[]'),(21,2,501,560,'[{0,18020002,20}]','[]'),(22,2,561,610,'[{0,18020002,20}]','[]'),(23,2,611,660,'[{0,18020002,20}]','[]'),(24,2,661,700,'[{0,18020002,25}]','[]'),(25,2,701,750,'[{0,18020002,25}]','[]'),(26,2,751,1000,'[{0,18020002,25}]','[]'),(27,3,1,260,'[{0,18020001,18}]','[]'),(28,3,261,320,'[{0,18020001,18}]','[]'),(29,3,321,350,'[{0,18020001,22}]','[]'),(30,3,351,370,'[{0,18020001,22}]','[]'),(31,3,371,390,'[{0,18020001,27}]','[]'),(32,3,391,430,'[{0,18020001,31}]','[]'),(33,3,431,500,'[{0,18020001,36}]','[]'),(34,3,501,560,'[{0,18020002,18}]','[]'),(35,3,561,610,'[{0,18020002,18}]','[]'),(36,3,611,660,'[{0,18020002,18}]','[]'),(37,3,661,700,'[{0,18020002,22}]','[]'),(38,3,701,750,'[{0,18020002,22}]','[]'),(39,3,751,1000,'[{0,18020002,22}]','[]'),(40,4,1,260,'[{0,18020001,16}]','[]'),(41,4,261,320,'[{0,18020001,16}]','[]'),(42,4,321,350,'[{0,18020001,20}]','[]'),(43,4,351,370,'[{0,18020001,20}]','[]'),(44,4,371,390,'[{0,18020001,24}]','[]'),(45,4,391,430,'[{0,18020001,28}]','[]'),(46,4,431,500,'[{0,18020001,32}]','[]'),(47,4,501,560,'[{0,18020002,16}]','[]'),(48,4,561,610,'[{0,18020002,16}]','[]'),(49,4,611,660,'[{0,18020002,16}]','[]'),(50,4,661,700,'[{0,18020002,20}]','[]'),(51,4,701,750,'[{0,18020002,20}]','[]'),(52,4,751,1000,'[{0,18020002,20}]','[]'),(53,5,1,260,'[{0,18020001,16}]','[]'),(54,5,261,320,'[{0,18020001,16}]','[]'),(55,5,321,350,'[{0,18020001,20}]','[]'),(56,5,351,370,'[{0,18020001,20}]','[]'),(57,5,371,390,'[{0,18020001,24}]','[]'),(58,5,391,430,'[{0,18020001,28}]','[]'),(59,5,431,500,'[{0,18020001,32}]','[]'),(60,5,501,560,'[{0,18020002,16}]','[]'),(61,5,561,610,'[{0,18020002,16}]','[]'),(62,5,611,660,'[{0,18020002,16}]','[]'),(63,5,661,700,'[{0,18020002,20}]','[]'),(64,5,701,750,'[{0,18020002,20}]','[]'),(65,5,751,1000,'[{0,18020002,20}]','[]'),(66,6,1,260,'[{0,18020001,14}]','[]'),(67,6,261,320,'[{0,18020001,14}]','[]'),(68,6,321,350,'[{0,18020001,18}]','[]'),(69,6,351,370,'[{0,18020001,18}]','[]'),(70,6,371,390,'[{0,18020001,22}]','[]'),(71,6,391,430,'[{0,18020001,26}]','[]'),(72,6,431,500,'[{0,18020001,30}]','[]'),(73,6,501,560,'[{0,18020002,14}]','[]'),(74,6,561,610,'[{0,18020002,14}]','[]'),(75,6,611,660,'[{0,18020002,14}]','[]'),(76,6,661,700,'[{0,18020002,18}]','[]'),(77,6,701,750,'[{0,18020002,18}]','[]'),(78,6,751,1000,'[{0,18020002,18}]','[]'),(79,7,1,260,'[{0,18020001,14}]','[]'),(80,7,261,320,'[{0,18020001,14}]','[]'),(81,7,321,350,'[{0,18020001,18}]','[]'),(82,7,351,370,'[{0,18020001,18}]','[]'),(83,7,371,390,'[{0,18020001,22}]','[]'),(84,7,391,430,'[{0,18020001,26}]','[]'),(85,7,431,500,'[{0,18020001,30}]','[]'),(86,7,501,560,'[{0,18020002,14}]','[]'),(87,7,561,610,'[{0,18020002,14}]','[]'),(88,7,611,660,'[{0,18020002,14}]','[]'),(89,7,661,700,'[{0,18020002,18}]','[]'),(90,7,701,750,'[{0,18020002,18}]','[]'),(91,7,751,1000,'[{0,18020002,18}]','[]'),(92,8,1,260,'[{0,18020001,14}]','[]'),(93,8,261,320,'[{0,18020001,14}]','[]'),(94,8,321,350,'[{0,18020001,18}]','[]'),(95,8,351,370,'[{0,18020001,18}]','[]'),(96,8,371,390,'[{0,18020001,22}]','[]'),(97,8,391,430,'[{0,18020001,26}]','[]'),(98,8,431,500,'[{0,18020001,30}]','[]'),(99,8,501,560,'[{0,18020002,14}]','[]'),(100,8,561,610,'[{0,18020002,14}]','[]'),(101,8,611,660,'[{0,18020002,14}]','[]'),(102,8,661,700,'[{0,18020002,18}]','[]'),(103,8,701,750,'[{0,18020002,18}]','[]'),(104,8,751,1000,'[{0,18020002,18}]','[]'),(105,9,1,260,'[{0,18020001,14}]','[]'),(106,9,261,320,'[{0,18020001,14}]','[]'),(107,9,321,350,'[{0,18020001,18}]','[]'),(108,9,351,370,'[{0,18020001,18}]','[]'),(109,9,371,390,'[{0,18020001,22}]','[]'),(110,9,391,430,'[{0,18020001,26}]','[]'),(111,9,431,500,'[{0,18020001,30}]','[]'),(112,9,501,560,'[{0,18020002,14}]','[]'),(113,9,561,610,'[{0,18020002,14}]','[]'),(114,9,611,660,'[{0,18020002,14}]','[]'),(115,9,661,700,'[{0,18020002,18}]','[]'),(116,9,701,750,'[{0,18020002,18}]','[]'),(117,9,751,1000,'[{0,18020002,18}]','[]'),(118,10,1,260,'[{0,18020001,14}]','[]'),(119,10,261,320,'[{0,18020001,14}]','[]'),(120,10,321,350,'[{0,18020001,18}]','[]'),(121,10,351,370,'[{0,18020001,18}]','[]'),(122,10,371,390,'[{0,18020001,22}]','[]'),(123,10,391,430,'[{0,18020001,26}]','[]'),(124,10,431,500,'[{0,18020001,30}]','[]'),(125,10,501,560,'[{0,18020002,14}]','[]'),(126,10,561,610,'[{0,18020002,14}]','[]'),(127,10,611,660,'[{0,18020002,14}]','[]'),(128,10,661,700,'[{0,18020002,18}]','[]'),(129,10,701,750,'[{0,18020002,18}]','[]'),(130,10,751,1000,'[{0,18020002,18}]','[]'),(131,11,1,260,'[{0,18020001,12}]','[]'),(132,11,261,320,'[{0,18020001,12}]','[]'),(133,11,321,350,'[{0,18020001,16}]','[]'),(134,11,351,370,'[{0,18020001,16}]','[]'),(135,11,371,390,'[{0,18020001,20}]','[]'),(136,11,391,430,'[{0,18020001,24}]','[]'),(137,11,431,500,'[{0,18020001,28}]','[]'),(138,11,501,560,'[{0,18020002,12}]','[]'),(139,11,561,610,'[{0,18020002,12}]','[]'),(140,11,611,660,'[{0,18020002,12}]','[]'),(141,11,661,700,'[{0,18020002,16}]','[]'),(142,11,701,750,'[{0,18020002,16}]','[]'),(143,11,751,1000,'[{0,18020002,16}]','[]'),(144,12,1,260,'[{0,18020001,12}]','[]'),(145,12,261,320,'[{0,18020001,12}]','[]'),(146,12,321,350,'[{0,18020001,16}]','[]'),(147,12,351,370,'[{0,18020001,16}]','[]'),(148,12,371,390,'[{0,18020001,20}]','[]'),(149,12,391,430,'[{0,18020001,24}]','[]'),(150,12,431,500,'[{0,18020001,28}]','[]'),(151,12,501,560,'[{0,18020002,12}]','[]'),(152,12,561,610,'[{0,18020002,12}]','[]'),(153,12,611,660,'[{0,18020002,12}]','[]'),(154,12,661,700,'[{0,18020002,16}]','[]'),(155,12,701,750,'[{0,18020002,16}]','[]'),(156,12,751,1000,'[{0,18020002,16}]','[]'),(157,13,1,260,'[{0,18020001,12}]','[]'),(158,13,261,320,'[{0,18020001,12}]','[]'),(159,13,321,350,'[{0,18020001,16}]','[]'),(160,13,351,370,'[{0,18020001,16}]','[]'),(161,13,371,390,'[{0,18020001,20}]','[]'),(162,13,391,430,'[{0,18020001,24}]','[]'),(163,13,431,500,'[{0,18020001,28}]','[]'),(164,13,501,560,'[{0,18020002,12}]','[]'),(165,13,561,610,'[{0,18020002,12}]','[]'),(166,13,611,660,'[{0,18020002,12}]','[]'),(167,13,661,700,'[{0,18020002,16}]','[]'),(168,13,701,750,'[{0,18020002,16}]','[]'),(169,13,751,1000,'[{0,18020002,16}]','[]'),(170,14,1,260,'[{0,18020001,12}]','[]'),(171,14,261,320,'[{0,18020001,12}]','[]'),(172,14,321,350,'[{0,18020001,16}]','[]'),(173,14,351,370,'[{0,18020001,16}]','[]'),(174,14,371,390,'[{0,18020001,20}]','[]'),(175,14,391,430,'[{0,18020001,24}]','[]'),(176,14,431,500,'[{0,18020001,28}]','[]'),(177,14,501,560,'[{0,18020002,12}]','[]'),(178,14,561,610,'[{0,18020002,12}]','[]'),(179,14,611,660,'[{0,18020002,12}]','[]'),(180,14,661,700,'[{0,18020002,16}]','[]'),(181,14,701,750,'[{0,18020002,16}]','[]'),(182,14,751,1000,'[{0,18020002,16}]','[]'),(183,15,1,260,'[{0,18020001,12}]','[]'),(184,15,261,320,'[{0,18020001,12}]','[]'),(185,15,321,350,'[{0,18020001,16}]','[]'),(186,15,351,370,'[{0,18020001,16}]','[]'),(187,15,371,390,'[{0,18020001,20}]','[]'),(188,15,391,430,'[{0,18020001,24}]','[]'),(189,15,431,500,'[{0,18020001,28}]','[]'),(190,15,501,560,'[{0,18020002,12}]','[]'),(191,15,561,610,'[{0,18020002,12}]','[]'),(192,15,611,660,'[{0,18020002,12}]','[]'),(193,15,661,700,'[{0,18020002,16}]','[]'),(194,15,701,750,'[{0,18020002,16}]','[]'),(195,15,751,1000,'[{0,18020002,16}]','[]');
/*!40000 ALTER TABLE `base_butterfly_rank_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_butterfly_refresh_a`
--

DROP TABLE IF EXISTS `base_butterfly_refresh_a`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_butterfly_refresh_a` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '蝴蝶id',
  `join_min` int(11) unsigned NOT NULL DEFAULT '0' COMMENT ' 参与人数下限',
  `join_max` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '参与人数上限',
  `refresh_point` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '刷新点数',
  PRIMARY KEY (`id`,`join_min`,`join_max`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='捕蝶刷新配置a';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_butterfly_refresh_a`
--

LOCK TABLES `base_butterfly_refresh_a` WRITE;
/*!40000 ALTER TABLE `base_butterfly_refresh_a` DISABLE KEYS */;
INSERT INTO `base_butterfly_refresh_a` VALUES (1,1,9999,12),(2,1,3,2),(2,4,6,4),(2,7,9,6),(2,10,12,8),(2,13,15,10),(2,16,9999,12),(3,1,9,1),(3,10,18,2),(3,19,27,3),(3,28,36,4),(3,37,45,5),(3,46,54,6),(3,55,63,7),(3,64,72,8),(3,73,81,9),(3,82,90,10),(3,91,99,11),(3,100,108,12),(3,109,9999,12);
/*!40000 ALTER TABLE `base_butterfly_refresh_a` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_butterfly_refresh_c`
--

DROP TABLE IF EXISTS `base_butterfly_refresh_c`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_butterfly_refresh_c` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '蝴蝶id',
  `join_min` int(11) unsigned NOT NULL DEFAULT '0' COMMENT ' 参与人数下限',
  `join_max` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '参与人数上限',
  `refresh_num` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '刷新数量',
  PRIMARY KEY (`id`,`join_min`,`join_max`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='捕蝶刷新配置c';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_butterfly_refresh_c`
--

LOCK TABLES `base_butterfly_refresh_c` WRITE;
/*!40000 ALTER TABLE `base_butterfly_refresh_c` DISABLE KEYS */;
INSERT INTO `base_butterfly_refresh_c` VALUES (1,1,3,12),(1,4,6,24),(1,7,9,36),(1,10,12,48),(1,13,15,60),(1,16,18,72),(1,19,21,84),(1,22,24,96),(1,25,27,108),(1,28,30,120),(1,31,33,132),(1,34,36,144),(1,37,39,156),(1,40,42,168),(1,43,45,180),(1,46,48,192),(1,49,51,204),(1,52,54,216),(1,55,57,228),(1,58,60,240),(1,61,63,252),(1,64,66,264),(1,67,69,276),(1,70,72,288),(1,73,75,300),(1,76,78,312),(1,79,81,324),(1,82,84,336),(1,85,87,348),(1,88,90,360),(1,91,93,372),(1,94,96,384),(1,97,99,396),(1,100,102,408),(1,103,105,420),(1,106,108,432),(1,109,9999,432),(2,1,3,2),(2,4,6,4),(2,7,9,6),(2,10,12,8),(2,13,15,10),(2,16,18,12),(2,19,21,14),(2,22,24,16),(2,25,27,18),(2,28,30,20),(2,31,33,22),(2,34,36,24),(2,37,39,26),(2,40,42,28),(2,43,45,30),(2,46,48,32),(2,49,51,34),(2,52,54,36),(2,55,9999,36),(3,1,9,1),(3,10,18,2),(3,19,27,3),(3,28,36,4),(3,37,45,5),(3,46,54,6),(3,55,63,7),(3,64,72,8),(3,73,81,9),(3,82,90,10),(3,91,100,11),(3,101,108,12),(3,109,9999,12);
/*!40000 ALTER TABLE `base_butterfly_refresh_c` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_butterfly_refresh_total`
--

DROP TABLE IF EXISTS `base_butterfly_refresh_total`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_butterfly_refresh_total` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '蝴蝶ID',
  `kind` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '蝴蝶种类',
  `hp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '生命值',
  `location` varchar(2048) NOT NULL COMMENT '刷新位置',
  `refresh_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '刷新时间',
  `tired` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '疲劳值',
  `integration` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  PRIMARY KEY (`kind`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='捕蝶刷新配置s';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_butterfly_refresh_total`
--

LOCK TABLES `base_butterfly_refresh_total` WRITE;
/*!40000 ALTER TABLE `base_butterfly_refresh_total` DISABLE KEYS */;
INSERT INTO `base_butterfly_refresh_total` VALUES (3005001,1,1,'[{1,{4259,5588,4587,5635}},{2,{13901,14717,4273,5848}},{3,{13588,15549,7786,9275}},{4,{13009,15134,10460,12142}},{5,{9048,10042,6174,7010}},{6,{8752,10914,11747,13064}},{7,{4208,6248,10389,11778}},{8,{3925,5843,7895,9026}},{9,{8903,10452,2117,3473}},{10,{5693,7131,2531,3591}},{11,{12618,13806,2444,3720}},{12,{8574,10557,8716,9834}}]',20,1,1),(3005002,2,3,'[{1,{4259,5588,4587,5635}},{2,{13901,14717,4273,5848}},{3,{13588,15549,7786,9275}},{4,{13009,15134,10460,12142}},{5,{9048,10042,6174,7010}},{6,{8752,10914,11747,13064}},{7,{4208,6248,10389,11778}},{8,{3925,5843,7895,9026}},{9,{8903,10452,2117,3473}},{10,{5693,7131,2531,3591}},{11,{12618,13806,2444,3720}},{12,{8574,10557,8716,9834}}]',20,2,3),(3005003,3,5,'[{1,{4259,5588,4587,5635}},{2,{13901,14717,4273,5848}},{3,{13588,15549,7786,9275}},{4,{13009,15134,10460,12142}},{5,{9048,10042,6174,7010}},{6,{8752,10914,11747,13064}},{7,{4208,6248,10389,11778}},{8,{3925,5843,7895,9026}},{9,{8903,10452,2117,3473}},{10,{5693,7131,2531,3591}},{11,{12618,13806,2444,3720}},{12,{8574,10557,8716,9834}}]',20,3,5),(3005004,4,10,'[{13,{9749,9749,9325,9325}}]',180,5,10);
/*!40000 ALTER TABLE `base_butterfly_refresh_total` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_butterfly_rotate_reward`
--

DROP TABLE IF EXISTS `base_butterfly_rotate_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_butterfly_rotate_reward` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励id',
  `num` varchar(205) NOT NULL COMMENT '显示数量',
  `times` varchar(255) NOT NULL COMMENT '转盘倍数',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='捕蝶转盘奖励';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_butterfly_rotate_reward`
--

LOCK TABLES `base_butterfly_rotate_reward` WRITE;
/*!40000 ALTER TABLE `base_butterfly_rotate_reward` DISABLE KEYS */;
INSERT INTO `base_butterfly_rotate_reward` VALUES (1,'{100,1,[{0,32070003,1}]}','{3200,1,1}'),(2,'{800,2,[{0,37020001,1}]}','{3200,2,2}'),(3,'{200,3,[{0,37020002,1}]}','{2000,3,3}'),(4,'{1000,4,[{0,18020001,1}]}','{800,4,4}'),(5,'{1500,5,[{0,38070001,1}]}','{400,5,5}'),(6,'{400,6,[{0,38070002,1}]}','{200,6,6}'),(7,'{1500,7,[{0,38330002,1}]}','{130,7,8}'),(8,'{500,8,[{0,38330003,1}]}','{40,8,10}'),(9,'{2000,9,[{0,38040010,1}]}','{20,9,15}'),(10,'{2000,10,[{0,36020001,2}]}','{10,10,20}');
/*!40000 ALTER TABLE `base_butterfly_rotate_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_butterfly_skill`
--

DROP TABLE IF EXISTS `base_butterfly_skill`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_butterfly_skill` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能ID',
  `name` varchar(255) NOT NULL COMMENT '技能名称	',
  `order` smallint(255) unsigned NOT NULL DEFAULT '0' COMMENT '解锁顺序',
  `condition` varchar(255) NOT NULL COMMENT '解锁条件',
  `opera_way` varchar(255) NOT NULL COMMENT '操作方法',
  `effect` varchar(255) NOT NULL COMMENT '技能效果',
  `cd` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '冷却时间',
  `limit` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '使用上限',
  `range` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '	有效范围',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='捕蝶技能';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_butterfly_skill`
--

LOCK TABLES `base_butterfly_skill` WRITE;
/*!40000 ALTER TABLE `base_butterfly_skill` DISABLE KEYS */;
INSERT INTO `base_butterfly_skill` VALUES (1,'普攻',1,'[]','点击选取蝴蝶','对蝴蝶造成1点伤害',0,9999999,0);
/*!40000 ALTER TABLE `base_butterfly_skill` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_capsule_toys_constant`
--

DROP TABLE IF EXISTS `base_capsule_toys_constant`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_capsule_toys_constant` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '序号ID',
  `key` varchar(50) NOT NULL DEFAULT '' COMMENT '关键词',
  `value` varchar(128) NOT NULL DEFAULT '' COMMENT '值',
  `describe` varchar(1024) NOT NULL DEFAULT '' COMMENT '描述@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='扭蛋常量表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_capsule_toys_constant`
--

LOCK TABLES `base_capsule_toys_constant` WRITE;
/*!40000 ALTER TABLE `base_capsule_toys_constant` DISABLE KEYS */;
INSERT INTO `base_capsule_toys_constant` VALUES (1,'one','[{0,38180012,1}]','扭蛋1次消耗的道具'),(2,'ten','[{0,38180012,10}]','扭蛋10次消耗的道具');
/*!40000 ALTER TABLE `base_capsule_toys_constant` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_capsule_toys_reward`
--

DROP TABLE IF EXISTS `base_capsule_toys_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_capsule_toys_reward` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励id',
  `lower_wlv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '世界等级下限(包含）',
  `upper_wlv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '世界等级上限(包含)',
  `reward_type` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '奖励格式',
  `rewards` varchar(256) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `goods_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品数量',
  `weight` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '权重',
  `special_effects` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否有特效',
  `broadcast` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否传闻',
  `rare` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否珍藏',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='扭蛋奖励配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_capsule_toys_reward`
--

LOCK TABLES `base_capsule_toys_reward` WRITE;
/*!40000 ALTER TABLE `base_capsule_toys_reward` DISABLE KEYS */;
INSERT INTO `base_capsule_toys_reward` VALUES (1,1,1000,5,'[{1,[{0,53010101,1}]},{2,[{0,53010201,1}]},{4,[{0,53010401,1}]}]',1,10,1,1,1),(2,1,1000,1,'[{0,16030013,1}]',1,10,1,1,1),(3,1,1000,1,'[{0,24030005,1}]',1,5,1,1,1),(4,1,1000,1,'[{0,24030004,1}]',1,10,1,1,1),(5,1,1000,1,'[{0,24030002,1}]',1,10,1,1,1),(6,1,1000,5,'[{1,[{0,53040101,2}]},{2,[{0,53040201,2}]},{4,[{0,53040401,2}]}]',2,150,1,1,1),(7,1,1000,1,'[{0,18041002,1}]',1,200,1,1,1),(8,1,1000,1,'[{0,18041005,1}]',1,200,1,1,1),(9,1,1000,1,'[{0,53030030,1}]',1,20,1,1,1),(10,1,1000,1,'[{0,20020004,1}]',1,20,1,1,1),(11,1,1000,1,'[{0,24020004,1}]',1,20,1,1,1),(12,1,1000,1,'[{0,16010004,1}]',1,20,1,1,1),(13,1,1000,1,'[{0,38180012,3}]',3,40,1,1,1),(14,1,1000,1,'[{0,38180012,2}]',2,90,1,1,1),(15,1,1000,1,'[{0,38180012,1}]',1,130,1,1,1),(16,1,1000,1,'[{0,38220009,20}]',20,300,1,1,1),(17,1,1000,1,'[{0,38220009,10}]',10,1300,1,1,1),(18,1,1000,1,'[{0,38220009,5}]',5,3179,1,1,1),(19,1,1000,1,'[{0,38240003,1}]',1,20,1,1,1),(20,1,1000,1,'[{0,38240001,1}]',1,50,1,1,1),(21,1,1000,1,'[{0,38240007,1}]',1,50,1,1,1),(22,1,1000,1,'[{0,53030010,2}]',2,70,0,0,0),(23,1,1000,1,'[{0,53030020,2}]',2,70,0,0,0),(24,1,1000,1,'[{0,20020003,1}]',1,40,1,1,1),(25,1,1000,1,'[{0,20020001,2}]',2,70,0,0,0),(26,1,1000,1,'[{0,20020002,2}]',2,70,0,0,0),(27,1,1000,1,'[{0,24020003,1}]',1,40,1,1,1),(28,1,1000,1,'[{0,24020001,2}]',2,70,0,0,0),(29,1,1000,1,'[{0,24020002,2}]',2,70,0,0,0),(30,1,1000,1,'[{0,16010003,1}]',1,40,1,1,1),(31,1,1000,1,'[{0,16010001,2}]',2,70,0,0,0),(32,1,1000,1,'[{0,16010002,2}]',2,70,0,0,0),(33,1,1000,1,'[{0,54010001,10}]',10,560,0,0,0),(34,1,1000,1,'[{0,18020001,10}]',10,560,0,0,0),(35,1,1000,1,'[{0,53020010,10}]',10,560,0,0,0),(36,1,1000,1,'[{0,15020301,5}]',5,560,0,0,0),(37,1,1000,1,'[{0,14010106,1}]',1,20,1,1,1),(38,1,1000,1,'[{0,14020206,1}]',1,20,1,1,1),(39,1,1000,1,'[{0,14010105,1}]',1,70,0,0,0),(40,1,1000,1,'[{0,14020205,1}]',1,70,0,0,0),(41,1,1000,1,'[{0,14010104,1}]',1,250,0,0,0),(42,1,1000,1,'[{0,14020204,1}]',1,250,0,0,0),(43,1,1000,1,'[{0,38240002,1}]',1,100,1,1,1),(44,1,1000,1,'[{0,38240004,1}]',1,100,1,1,1),(45,1,1000,1,'[{0,38240006,1}]',1,100,1,1,1),(46,1,1000,1,'[{0,38240008,1}]',1,100,1,1,1),(47,1,1000,1,'[{0,38240010,1}]',1,100,1,1,1),(48,1,1000,1,'[{0,32020112,10}]',10,20,0,0,0),(49,1,1000,1,'[{0,32020112,20}]',20,10,0,0,0),(50,1,1000,1,'[{0,32020113,5}]',5,10,0,0,0),(51,1,1000,1,'[{0,32020113,3}]',3,20,0,0,0),(52,1,1000,1,'[{0,32020114,1}]',1,3,0,0,0),(53,1,1000,1,'[{0,32020114,2}]',2,2,0,0,0),(54,1,1000,1,'[{0,32020114,3}]',3,1,1,1,1);
/*!40000 ALTER TABLE `base_capsule_toys_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_career`
--

DROP TABLE IF EXISTS `base_career`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_career` (
  `career_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '职业编号',
  `career_name` varchar(255) NOT NULL COMMENT '职业名字',
  `sex` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '性别',
  PRIMARY KEY (`career_id`,`sex`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='职业类型表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_career`
--

LOCK TABLES `base_career` WRITE;
/*!40000 ALTER TABLE `base_career` DISABLE KEYS */;
INSERT INTO `base_career` VALUES (1,'魔剑士',1),(2,'龙骑士',1),(3,'魔导师',2),(4,'重炮手',2);
/*!40000 ALTER TABLE `base_career` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_change_name`
--

DROP TABLE IF EXISTS `base_change_name`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_change_name` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '配置id',
  `value` varchar(255) NOT NULL COMMENT '值',
  `desc` varchar(255) NOT NULL COMMENT '描述',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8 COMMENT='角色改名';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_change_name`
--

LOCK TABLES `base_change_name` WRITE;
/*!40000 ALTER TABLE `base_change_name` DISABLE KEYS */;
INSERT INTO `base_change_name` VALUES (1,'{1,30}','免费改名等级范围'),(2,'38210001','免费卡id'),(3,'688','消耗钻石总数');
/*!40000 ALTER TABLE `base_change_name` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_charm_week_reward`
--

DROP TABLE IF EXISTS `base_charm_week_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_charm_week_reward` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励id',
  `rank_min` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '名次下限',
  `rank_max` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '名次上限',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '名次奖励',
  `fame_reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '额外奖励',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='魅力周榜奖励配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_charm_week_reward`
--

LOCK TABLES `base_charm_week_reward` WRITE;
/*!40000 ALTER TABLE `base_charm_week_reward` DISABLE KEYS */;
INSERT INTO `base_charm_week_reward` VALUES (1,1,1,'[{7,0,800}]','[{7,0,150}]'),(2,2,3,'[{7,0,600}]','[]'),(3,4,10,'[{7,0,400}]','[]'),(4,11,20,'[{7,0,200}]','[]');
/*!40000 ALTER TABLE `base_charm_week_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_check_in`
--

DROP TABLE IF EXISTS `base_check_in`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_check_in` (
  `month` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '月份',
  `days` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '天数',
  `reward` varchar(512) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `vip` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT 'VIP等级',
  `state` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '领取状态',
  PRIMARY KEY (`month`,`days`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='月签到配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_check_in`
--

LOCK TABLES `base_check_in` WRITE;
/*!40000 ALTER TABLE `base_check_in` DISABLE KEYS */;
/*!40000 ALTER TABLE `base_check_in` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_checkin_daily_retroactive`
--

DROP TABLE IF EXISTS `base_checkin_daily_retroactive`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_checkin_daily_retroactive` (
  `retro_times` int(20) NOT NULL COMMENT '补签次数',
  `money_type` int(8) NOT NULL COMMENT '货币类型',
  `price` int(20) NOT NULL COMMENT '价格',
  PRIMARY KEY (`retro_times`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='每日签到补签配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_checkin_daily_retroactive`
--

LOCK TABLES `base_checkin_daily_retroactive` WRITE;
/*!40000 ALTER TABLE `base_checkin_daily_retroactive` DISABLE KEYS */;
INSERT INTO `base_checkin_daily_retroactive` VALUES (1,2,5),(2,2,10),(3,2,15),(4,2,20),(5,2,30),(6,2,30),(7,2,30),(8,2,30),(9,2,30),(10,2,30),(11,2,30),(12,2,30),(13,2,30),(14,2,30),(15,2,30),(16,2,30),(17,2,30),(18,2,30),(19,2,30),(20,2,30),(21,2,30),(22,2,30),(23,2,30),(24,2,30),(25,2,30),(26,2,30),(27,2,30),(28,2,30),(29,2,30),(30,2,30),(31,2,30);
/*!40000 ALTER TABLE `base_checkin_daily_retroactive` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_checkin_daily_rewards`
--

DROP TABLE IF EXISTS `base_checkin_daily_rewards`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_checkin_daily_rewards` (
  `month` tinyint(2) unsigned NOT NULL DEFAULT '1' COMMENT '第几月',
  `day` int(8) NOT NULL COMMENT '当月第几天',
  `rewards` varchar(1024) NOT NULL COMMENT '奖励内容',
  `vip_lv` int(8) NOT NULL COMMENT 'vip奖励需要达到的等级',
  `vip_multiple` int(8) NOT NULL COMMENT 'vip奖励倍数',
  PRIMARY KEY (`month`,`day`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='每日签到奖励配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_checkin_daily_rewards`
--

LOCK TABLES `base_checkin_daily_rewards` WRITE;
/*!40000 ALTER TABLE `base_checkin_daily_rewards` DISABLE KEYS */;
INSERT INTO `base_checkin_daily_rewards` VALUES (1,1,'[{3,36030001,50000}]',0,0),(1,2,'[{0,38330003,1}]',0,0),(1,3,'[{2,36020001,50}]',4,2),(1,4,'[{0,11020001,10}]',0,0),(1,5,'[{2,36020001,50}]',4,2),(1,6,'[{0,24010001,10}]',0,0),(1,7,'[{0,5203003,2}]',4,2),(1,8,'[{3,36030001,200000}]',0,0),(1,9,'[{0,38330003,1}]',0,0),(1,10,'[{2,36020001,50}]',4,2),(1,11,'[{0,11020001,10}]',0,0),(1,12,'[{2,36020001,50}]',4,2),(1,13,'[{0,24010001,10}]',0,0),(1,14,'[{0,5203003,2}]',4,2),(1,15,'[{3,36030001,250000}]',0,0),(1,16,'[{0,38330004,1}]',0,0),(1,17,'[{2,36020001,50}]',4,2),(1,18,'[{0,11020001,10}]',0,0),(1,19,'[{2,36020001,50}]',4,2),(1,20,'[{0,24010001,10}]',0,0),(1,21,'[{0,5203003,2}]',4,2),(1,22,'[{3,36030001,250000}]',0,0),(1,23,'[{0,38330004,1}]',0,0),(1,24,'[{2,36020001,50}]',4,2),(1,25,'[{0,11020001,10}]',0,0),(1,26,'[{2,36020001,50}]',4,2),(1,27,'[{0,24010001,10}]',0,0),(1,28,'[{0,5203003,2}]',4,2),(1,29,'[{3,36030001,250000}]',0,0),(1,30,'[{0,38330004,1}]',0,0),(1,31,'[{2,36020001,50}]',4,2),(2,1,'[{3,36030001,250000}]',0,0),(2,2,'[{0,38330003,1}]',0,0),(2,3,'[{2,36020001,50}]',4,2),(2,4,'[{0,11020001,10}]',0,0),(2,5,'[{2,36020001,50}]',4,2),(2,6,'[{0,24010001,10}]',0,0),(2,7,'[{0,5203003,2}]',4,2),(2,8,'[{3,36030001,250000}]',0,0),(2,9,'[{0,38330003,1}]',0,0),(2,10,'[{2,36020001,50}]',4,2),(2,11,'[{0,11020001,10}]',0,0),(2,12,'[{2,36020001,50}]',4,2),(2,13,'[{0,24010001,10}]',0,0),(2,14,'[{0,5203003,2}]',4,2),(2,15,'[{3,36030001,250000}]',0,0),(2,16,'[{0,38330004,1}]',0,0),(2,17,'[{2,36020001,50}]',4,2),(2,18,'[{0,11020001,10}]',0,0),(2,19,'[{2,36020001,50}]',4,2),(2,20,'[{0,24010001,10}]',0,0),(2,21,'[{0,5203003,2}]',4,2),(2,22,'[{3,36030001,250000}]',0,0),(2,23,'[{0,38330004,1}]',0,0),(2,24,'[{2,36020001,50}]',4,2),(2,25,'[{0,11020001,10}]',0,0),(2,26,'[{2,36020001,50}]',4,2),(2,27,'[{0,24010001,10}]',0,0),(2,28,'[{0,5203003,2}]',4,2),(2,29,'[{3,36030001,250000}]',0,0),(2,30,'[{0,38330004,1}]',0,0),(2,31,'[{2,36020001,50}]',4,2),(3,1,'[{3,36030001,250000}]',0,0),(3,2,'[{0,38330003,1}]',0,0),(3,3,'[{2,36020001,50}]',4,2),(3,4,'[{0,11020001,10}]',0,0),(3,5,'[{2,36020001,50}]',4,2),(3,6,'[{0,24010001,10}]',0,0),(3,7,'[{0,5203003,2}]',4,2),(3,8,'[{3,36030001,250000}]',0,0),(3,9,'[{0,38330003,1}]',0,0),(3,10,'[{2,36020001,50}]',4,2),(3,11,'[{0,11020001,10}]',0,0),(3,12,'[{2,36020001,50}]',4,2),(3,13,'[{0,24010001,10}]',0,0),(3,14,'[{0,5203003,2}]',4,2),(3,15,'[{3,36030001,250000}]',0,0),(3,16,'[{0,38330004,1}]',0,0),(3,17,'[{2,36020001,50}]',4,2),(3,18,'[{0,11020001,10}]',0,0),(3,19,'[{2,36020001,50}]',4,2),(3,20,'[{0,24010001,10}]',0,0),(3,21,'[{0,5203003,2}]',4,2),(3,22,'[{3,36030001,250000}]',0,0),(3,23,'[{0,38330004,1}]',0,0),(3,24,'[{2,36020001,50}]',4,2),(3,25,'[{0,11020001,10}]',0,0),(3,26,'[{2,36020001,50}]',4,2),(3,27,'[{0,24010001,10}]',0,0),(3,28,'[{0,5203003,2}]',4,2),(3,29,'[{3,36030001,250000}]',0,0),(3,30,'[{0,38330004,1}]',0,0),(3,31,'[{2,36020001,50}]',4,2),(4,1,'[{3,36030001,250000}]',0,0),(4,2,'[{0,38330003,1}]',0,0),(4,3,'[{2,36020001,50}]',4,2),(4,4,'[{0,11020002,10}]',0,0),(4,5,'[{2,36020001,50}]',4,2),(4,6,'[{0,24010002,10}]',0,0),(4,7,'[{0,5203003,2}]',4,2),(4,8,'[{3,36030001,250000}]',0,0),(4,9,'[{0,38330003,1}]',0,0),(4,10,'[{2,36020001,50}]',4,2),(4,11,'[{0,11020002,10}]',0,0),(4,12,'[{2,36020001,50}]',4,2),(4,13,'[{0,24010002,10}]',0,0),(4,14,'[{0,5203003,2}]',4,2),(4,15,'[{3,36030001,250000}]',0,0),(4,16,'[{0,38330004,1}]',0,0),(4,17,'[{2,36020001,50}]',4,2),(4,18,'[{0,11020002,10}]',0,0),(4,19,'[{2,36020001,50}]',4,2),(4,20,'[{0,24010002,10}]',0,0),(4,21,'[{0,5203003,2}]',4,2),(4,22,'[{3,36030001,250000}]',0,0),(4,23,'[{0,38330004,1}]',0,0),(4,24,'[{2,36020001,50}]',4,2),(4,25,'[{0,11020002,10}]',0,0),(4,26,'[{2,36020001,50}]',4,2),(4,27,'[{0,24010002,10}]',0,0),(4,28,'[{0,5203003,2}]',4,2),(4,29,'[{3,36030001,250000}]',0,0),(4,30,'[{0,38330004,1}]',0,0),(4,31,'[{2,36020001,50}]',4,2),(5,1,'[{3,36030001,250000}]',0,0),(5,2,'[{0,38330003,1}]',0,0),(5,3,'[{2,36020001,50}]',4,2),(5,4,'[{0,11020002,10}]',0,0),(5,5,'[{2,36020001,50}]',4,2),(5,6,'[{0,24010002,10}]',0,0),(5,7,'[{0,5203003,2}]',4,2),(5,8,'[{3,36030001,250000}]',0,0),(5,9,'[{0,38330003,1}]',0,0),(5,10,'[{2,36020001,50}]',4,2),(5,11,'[{0,11020002,10}]',0,0),(5,12,'[{2,36020001,50}]',4,2),(5,13,'[{0,24010002,10}]',0,0),(5,14,'[{0,5203003,2}]',4,2),(5,15,'[{3,36030001,250000}]',0,0),(5,16,'[{0,38330004,1}]',0,0),(5,17,'[{2,36020001,50}]',4,2),(5,18,'[{0,11020002,10}]',0,0),(5,19,'[{2,36020001,50}]',4,2),(5,20,'[{0,24010002,10}]',0,0),(5,21,'[{0,5203003,2}]',4,2),(5,22,'[{3,36030001,250000}]',0,0),(5,23,'[{0,38330004,1}]',0,0),(5,24,'[{2,36020001,50}]',4,2),(5,25,'[{0,11020002,10}]',0,0),(5,26,'[{2,36020001,50}]',4,2),(5,27,'[{0,24010002,10}]',0,0),(5,28,'[{0,5203003,2}]',4,2),(5,29,'[{3,36030001,250000}]',0,0),(5,30,'[{0,38330004,1}]',0,0),(5,31,'[{2,36020001,50}]',4,2),(6,1,'[{3,36030001,250000}]',0,0),(6,2,'[{0,38330003,1}]',0,0),(6,3,'[{2,36020001,50}]',4,2),(6,4,'[{0,11020002,10}]',0,0),(6,5,'[{2,36020001,50}]',4,2),(6,6,'[{0,24010002,10}]',0,0),(6,7,'[{0,5203003,2}]',4,2),(6,8,'[{3,36030001,250000}]',0,0),(6,9,'[{0,38330003,1}]',0,0),(6,10,'[{2,36020001,50}]',4,2),(6,11,'[{0,11020002,10}]',0,0),(6,12,'[{2,36020001,50}]',4,2),(6,13,'[{0,24010002,10}]',0,0),(6,14,'[{0,5203003,2}]',4,2),(6,15,'[{3,36030001,250000}]',0,0),(6,16,'[{0,38330004,1}]',0,0),(6,17,'[{2,36020001,50}]',4,2),(6,18,'[{0,11020002,10}]',0,0),(6,19,'[{2,36020001,50}]',4,2),(6,20,'[{0,24010002,10}]',0,0),(6,21,'[{0,5203003,2}]',4,2),(6,22,'[{3,36030001,250000}]',0,0),(6,23,'[{0,38330004,1}]',0,0),(6,24,'[{2,36020001,50}]',4,2),(6,25,'[{0,11020002,10}]',0,0),(6,26,'[{2,36020001,50}]',4,2),(6,27,'[{0,24010002,10}]',0,0),(6,28,'[{0,5203003,2}]',4,2),(6,29,'[{3,36030001,250000}]',0,0),(6,30,'[{0,38330004,1}]',0,0),(6,31,'[{2,36020001,50}]',4,2),(7,1,'[{3,36030001,250000}]',0,0),(7,2,'[{0,38330003,1}]',0,0),(7,3,'[{2,36020001,50}]',4,2),(7,4,'[{0,11020002,10}]',0,0),(7,5,'[{2,36020001,50}]',4,2),(7,6,'[{0,24010002,10}]',0,0),(7,7,'[{0,5203003,2}]',4,2),(7,8,'[{3,36030001,250000}]',0,0),(7,9,'[{0,38330003,1}]',0,0),(7,10,'[{2,36020001,50}]',4,2),(7,11,'[{0,11020002,10}]',0,0),(7,12,'[{2,36020001,50}]',4,2),(7,13,'[{0,24010002,10}]',0,0),(7,14,'[{0,5203003,2}]',4,2),(7,15,'[{3,36030001,250000}]',0,0),(7,16,'[{0,38330004,1}]',0,0),(7,17,'[{2,36020001,50}]',4,2),(7,18,'[{0,11020002,10}]',0,0),(7,19,'[{2,36020001,50}]',4,2),(7,20,'[{0,24010002,10}]',0,0),(7,21,'[{0,5203003,2}]',4,2),(7,22,'[{3,36030001,250000}]',0,0),(7,23,'[{0,38330004,1}]',0,0),(7,24,'[{2,36020001,50}]',4,2),(7,25,'[{0,11020002,10}]',0,0),(7,26,'[{2,36020001,50}]',4,2),(7,27,'[{0,24010002,10}]',0,0),(7,28,'[{0,5203003,2}]',4,2),(7,29,'[{3,36030001,250000}]',0,0),(7,30,'[{0,38330004,1}]',0,0),(7,31,'[{2,36020001,50}]',4,2),(8,1,'[{3,36030001,250000}]',0,0),(8,2,'[{0,38330003,1}]',0,0),(8,3,'[{2,36020001,50}]',4,2),(8,4,'[{0,11020002,10}]',0,0),(8,5,'[{2,36020001,50}]',4,2),(8,6,'[{0,24010002,10}]',0,0),(8,7,'[{0,5203003,2}]',4,2),(8,8,'[{3,36030001,250000}]',0,0),(8,9,'[{0,38330003,1}]',0,0),(8,10,'[{2,36020001,50}]',4,2),(8,11,'[{0,11020002,10}]',0,0),(8,12,'[{2,36020001,50}]',4,2),(8,13,'[{0,24010002,10}]',0,0),(8,14,'[{0,5203003,2}]',4,2),(8,15,'[{3,36030001,250000}]',0,0),(8,16,'[{0,38330004,1}]',0,0),(8,17,'[{2,36020001,50}]',4,2),(8,18,'[{0,11020002,10}]',0,0),(8,19,'[{2,36020001,50}]',4,2),(8,20,'[{0,24010002,10}]',0,0),(8,21,'[{0,5203003,2}]',4,2),(8,22,'[{3,36030001,250000}]',0,0),(8,23,'[{0,38330004,1}]',0,0),(8,24,'[{2,36020001,50}]',4,2),(8,25,'[{0,11020002,10}]',0,0),(8,26,'[{2,36020001,50}]',4,2),(8,27,'[{0,24010002,10}]',0,0),(8,28,'[{0,5203003,2}]',4,2),(8,29,'[{3,36030001,250000}]',0,0),(8,30,'[{0,38330004,1}]',0,0),(8,31,'[{2,36020001,50}]',4,2),(9,1,'[{3,36030001,250000}]',0,0),(9,2,'[{0,38330003,1}]',0,0),(9,3,'[{2,36020001,50}]',4,2),(9,4,'[{0,11020002,10}]',0,0),(9,5,'[{2,36020001,50}]',4,2),(9,6,'[{0,24010002,10}]',0,0),(9,7,'[{0,5203003,2}]',4,2),(9,8,'[{3,36030001,250000}]',0,0),(9,9,'[{0,38330003,1}]',0,0),(9,10,'[{2,36020001,50}]',4,2),(9,11,'[{0,11020002,10}]',0,0),(9,12,'[{2,36020001,50}]',4,2),(9,13,'[{0,24010002,10}]',0,0),(9,14,'[{0,5203003,2}]',4,2),(9,15,'[{3,36030001,250000}]',0,0),(9,16,'[{0,38330004,1}]',0,0),(9,17,'[{2,36020001,50}]',4,2),(9,18,'[{0,11020002,10}]',0,0),(9,19,'[{2,36020001,50}]',4,2),(9,20,'[{0,24010002,10}]',0,0),(9,21,'[{0,5203003,2}]',4,2),(9,22,'[{3,36030001,250000}]',0,0),(9,23,'[{0,38330004,1}]',0,0),(9,24,'[{2,36020001,50}]',4,2),(9,25,'[{0,11020002,10}]',0,0),(9,26,'[{2,36020001,50}]',4,2),(9,27,'[{0,24010002,10}]',0,0),(9,28,'[{0,5203003,2}]',4,2),(9,29,'[{3,36030001,250000}]',0,0),(9,30,'[{0,38330004,1}]',0,0),(9,31,'[{2,36020001,50}]',4,2),(10,1,'[{3,36030001,250000}]',0,0),(10,2,'[{0,38330003,1}]',0,0),(10,3,'[{2,36020001,50}]',4,2),(10,4,'[{0,11020002,10}]',0,0),(10,5,'[{2,36020001,50}]',4,2),(10,6,'[{0,24010002,10}]',0,0),(10,7,'[{0,5203003,2}]',4,2),(10,8,'[{3,36030001,250000}]',0,0),(10,9,'[{0,38330003,1}]',0,0),(10,10,'[{2,36020001,50}]',4,2),(10,11,'[{0,11020002,10}]',0,0),(10,12,'[{2,36020001,50}]',4,2),(10,13,'[{0,24010002,10}]',0,0),(10,14,'[{0,5203003,2}]',4,2),(10,15,'[{3,36030001,250000}]',0,0),(10,16,'[{0,38330004,1}]',0,0),(10,17,'[{2,36020001,50}]',4,2),(10,18,'[{0,11020002,10}]',0,0),(10,19,'[{2,36020001,50}]',4,2),(10,20,'[{0,24010002,10}]',0,0),(10,21,'[{0,5203003,2}]',4,2),(10,22,'[{3,36030001,250000}]',0,0),(10,23,'[{0,38330004,1}]',0,0),(10,24,'[{2,36020001,50}]',4,2),(10,25,'[{0,11020002,10}]',0,0),(10,26,'[{2,36020001,50}]',4,2),(10,27,'[{0,24010002,10}]',0,0),(10,28,'[{0,5203003,2}]',4,2),(10,29,'[{3,36030001,250000}]',0,0),(10,30,'[{0,38330004,1}]',0,0),(10,31,'[{2,36020001,50}]',4,2),(11,1,'[{3,36030001,250000}]',0,0),(11,2,'[{0,38330003,1}]',0,0),(11,3,'[{2,36020001,50}]',4,2),(11,4,'[{0,11020002,10}]',0,0),(11,5,'[{2,36020001,50}]',4,2),(11,6,'[{0,24010002,10}]',0,0),(11,7,'[{0,5203003,2}]',4,2),(11,8,'[{3,36030001,250000}]',0,0),(11,9,'[{0,38330003,1}]',0,0),(11,10,'[{2,36020001,50}]',4,2),(11,11,'[{0,11020002,10}]',0,0),(11,12,'[{2,36020001,50}]',4,2),(11,13,'[{0,24010002,10}]',0,0),(11,14,'[{0,5203003,2}]',4,2),(11,15,'[{3,36030001,250000}]',0,0),(11,16,'[{0,38330004,1}]',0,0),(11,17,'[{2,36020001,50}]',4,2),(11,18,'[{0,11020002,10}]',0,0),(11,19,'[{2,36020001,50}]',4,2),(11,20,'[{0,24010002,10}]',0,0),(11,21,'[{0,5203003,2}]',4,2),(11,22,'[{3,36030001,250000}]',0,0),(11,23,'[{0,38330004,1}]',0,0),(11,24,'[{2,36020001,50}]',4,2),(11,25,'[{0,11020002,10}]',0,0),(11,26,'[{2,36020001,50}]',4,2),(11,27,'[{0,24010002,10}]',0,0),(11,28,'[{0,5203003,2}]',4,2),(11,29,'[{3,36030001,250000}]',0,0),(11,30,'[{0,38330004,1}]',0,0),(11,31,'[{2,36020001,50}]',4,2),(12,1,'[{3,36030001,250000}]',0,0),(12,2,'[{0,38330003,1}]',0,0),(12,3,'[{2,36020001,50}]',4,2),(12,4,'[{0,11020002,10}]',0,0),(12,5,'[{2,36020001,50}]',4,2),(12,6,'[{0,24010002,10}]',0,0),(12,7,'[{0,5203003,2}]',4,2),(12,8,'[{3,36030001,250000}]',0,0),(12,9,'[{0,38330003,1}]',0,0),(12,10,'[{2,36020001,50}]',4,2),(12,11,'[{0,11020002,10}]',0,0),(12,12,'[{2,36020001,50}]',4,2),(12,13,'[{0,24010002,10}]',0,0),(12,14,'[{0,5203003,2}]',4,2),(12,15,'[{3,36030001,250000}]',0,0),(12,16,'[{0,38330004,1}]',0,0),(12,17,'[{2,36020001,50}]',4,2),(12,18,'[{0,11020002,10}]',0,0),(12,19,'[{2,36020001,50}]',4,2),(12,20,'[{0,24010002,10}]',0,0),(12,21,'[{0,5203003,2}]',4,2),(12,22,'[{3,36030001,250000}]',0,0),(12,23,'[{0,38330004,1}]',0,0),(12,24,'[{2,36020001,50}]',4,2),(12,25,'[{0,11020002,10}]',0,0),(12,26,'[{2,36020001,50}]',4,2),(12,27,'[{0,24010002,10}]',0,0),(12,28,'[{0,5203003,2}]',4,2),(12,29,'[{3,36030001,250000}]',0,0),(12,30,'[{0,38330004,1}]',0,0),(12,31,'[{2,36020001,50}]',4,2),(13,1,'[{3,36030001,250000}]',0,0),(13,2,'[{0,38330003,1}]',0,0),(13,3,'[{2,36020001,50}]',4,2),(13,4,'[{0,11020002,10}]',0,0),(13,5,'[{2,36020001,50}]',4,2),(13,6,'[{0,24010002,10}]',0,0),(13,7,'[{0,5203003,2}]',4,2),(13,8,'[{3,36030001,250000}]',0,0),(13,9,'[{0,38330003,1}]',0,0),(13,10,'[{2,36020001,50}]',4,2),(13,11,'[{0,11020002,10}]',0,0),(13,12,'[{2,36020001,50}]',4,2),(13,13,'[{0,24010002,10}]',0,0),(13,14,'[{0,5203003,2}]',4,2),(13,15,'[{3,36030001,250000}]',0,0),(13,16,'[{0,38330004,1}]',0,0),(13,17,'[{2,36020001,50}]',4,2),(13,18,'[{0,11020002,10}]',0,0),(13,19,'[{2,36020001,50}]',4,2),(13,20,'[{0,24010002,10}]',0,0),(13,21,'[{0,5203003,2}]',4,2),(13,22,'[{3,36030001,250000}]',0,0),(13,23,'[{0,38330004,1}]',0,0),(13,24,'[{2,36020001,50}]',4,2),(13,25,'[{0,11020002,10}]',0,0),(13,26,'[{2,36020001,50}]',4,2),(13,27,'[{0,24010002,10}]',0,0),(13,28,'[{0,5203003,2}]',4,2),(13,29,'[{3,36030001,250000}]',0,0),(13,30,'[{0,38330004,1}]',0,0),(13,31,'[{2,36020001,50}]',4,2),(14,1,'[{3,36030001,250000}]',0,0),(14,2,'[{0,38330003,1}]',0,0),(14,3,'[{2,36020001,50}]',4,2),(14,4,'[{0,11020002,10}]',0,0),(14,5,'[{2,36020001,50}]',4,2),(14,6,'[{0,24010002,10}]',0,0),(14,7,'[{0,5203003,2}]',4,2),(14,8,'[{3,36030001,250000}]',0,0),(14,9,'[{0,38330003,1}]',0,0),(14,10,'[{2,36020001,50}]',4,2),(14,11,'[{0,11020002,10}]',0,0),(14,12,'[{2,36020001,50}]',4,2),(14,13,'[{0,24010002,10}]',0,0),(14,14,'[{0,5203003,2}]',4,2),(14,15,'[{3,36030001,250000}]',0,0),(14,16,'[{0,38330004,1}]',0,0),(14,17,'[{2,36020001,50}]',4,2),(14,18,'[{0,11020002,10}]',0,0),(14,19,'[{2,36020001,50}]',4,2),(14,20,'[{0,24010002,10}]',0,0),(14,21,'[{0,5203003,2}]',4,2),(14,22,'[{3,36030001,250000}]',0,0),(14,23,'[{0,38330004,1}]',0,0),(14,24,'[{2,36020001,50}]',4,2),(14,25,'[{0,11020002,10}]',0,0),(14,26,'[{2,36020001,50}]',4,2),(14,27,'[{0,24010002,10}]',0,0),(14,28,'[{0,5203003,2}]',4,2),(14,29,'[{3,36030001,250000}]',0,0),(14,30,'[{0,38330004,1}]',0,0),(14,31,'[{2,36020001,50}]',4,2),(15,1,'[{3,36030001,250000}]',0,0),(15,2,'[{0,38330003,1}]',0,0),(15,3,'[{2,36020001,50}]',4,2),(15,4,'[{0,11020002,10}]',0,0),(15,5,'[{2,36020001,50}]',4,2),(15,6,'[{0,24010002,10}]',0,0),(15,7,'[{0,5203003,2}]',4,2),(15,8,'[{3,36030001,250000}]',0,0),(15,9,'[{0,38330003,1}]',0,0),(15,10,'[{2,36020001,50}]',4,2),(15,11,'[{0,11020002,10}]',0,0),(15,12,'[{2,36020001,50}]',4,2),(15,13,'[{0,24010002,10}]',0,0),(15,14,'[{0,5203003,2}]',4,2),(15,15,'[{3,36030001,250000}]',0,0),(15,16,'[{0,38330004,1}]',0,0),(15,17,'[{2,36020001,50}]',4,2),(15,18,'[{0,11020002,10}]',0,0),(15,19,'[{2,36020001,50}]',4,2),(15,20,'[{0,24010002,10}]',0,0),(15,21,'[{0,5203003,2}]',4,2),(15,22,'[{3,36030001,250000}]',0,0),(15,23,'[{0,38330004,1}]',0,0),(15,24,'[{2,36020001,50}]',4,2),(15,25,'[{0,11020002,10}]',0,0),(15,26,'[{2,36020001,50}]',4,2),(15,27,'[{0,24010002,10}]',0,0),(15,28,'[{0,5203003,2}]',4,2),(15,29,'[{3,36030001,250000}]',0,0),(15,30,'[{0,38330004,1}]',0,0),(15,31,'[{2,36020001,50}]',4,2),(16,1,'[{3,36030001,250000}]',0,0),(16,2,'[{0,38330003,1}]',0,0),(16,3,'[{2,36020001,50}]',4,2),(16,4,'[{0,11020002,10}]',0,0),(16,5,'[{2,36020001,50}]',4,2),(16,6,'[{0,24010002,10}]',0,0),(16,7,'[{0,5203003,2}]',4,2),(16,8,'[{3,36030001,250000}]',0,0),(16,9,'[{0,38330003,1}]',0,0),(16,10,'[{2,36020001,50}]',4,2),(16,11,'[{0,11020002,10}]',0,0),(16,12,'[{2,36020001,50}]',4,2),(16,13,'[{0,24010002,10}]',0,0),(16,14,'[{0,5203003,2}]',4,2),(16,15,'[{3,36030001,250000}]',0,0),(16,16,'[{0,38330004,1}]',0,0),(16,17,'[{2,36020001,50}]',4,2),(16,18,'[{0,11020002,10}]',0,0),(16,19,'[{2,36020001,50}]',4,2),(16,20,'[{0,24010002,10}]',0,0),(16,21,'[{0,5203003,2}]',4,2),(16,22,'[{3,36030001,250000}]',0,0),(16,23,'[{0,38330004,1}]',0,0),(16,24,'[{2,36020001,50}]',4,2),(16,25,'[{0,11020002,10}]',0,0),(16,26,'[{2,36020001,50}]',4,2),(16,27,'[{0,24010002,10}]',0,0),(16,28,'[{0,5203003,2}]',4,2),(16,29,'[{3,36030001,250000}]',0,0),(16,30,'[{0,38330004,1}]',0,0),(16,31,'[{2,36020001,50}]',4,2);
/*!40000 ALTER TABLE `base_checkin_daily_rewards` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_checkin_total_rewards`
--

DROP TABLE IF EXISTS `base_checkin_total_rewards`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_checkin_total_rewards` (
  `total_round` tinyint(2) NOT NULL COMMENT '累计签到轮数',
  `days` int(8) NOT NULL COMMENT '累计签到天数',
  `rewards` varchar(1024) NOT NULL COMMENT '累计签到奖励',
  PRIMARY KEY (`total_round`,`days`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='累计签到奖励配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_checkin_total_rewards`
--

LOCK TABLES `base_checkin_total_rewards` WRITE;
/*!40000 ALTER TABLE `base_checkin_total_rewards` DISABLE KEYS */;
INSERT INTO `base_checkin_total_rewards` VALUES (1,2,'[{2,36020001,100}]'),(1,7,'[{0,18041003,5}]'),(1,14,'[{2,36020001,200}]'),(1,21,'[{0,18041003,10}]'),(1,28,'[{0,20040002,1}]'),(2,2,'[{2,36020001,100}]'),(2,7,'[{0,18041003,5}]'),(2,14,'[{2,36020001,200}]'),(2,21,'[{0,18041003,15}]'),(2,28,'[{0,20040002,1}]'),(3,2,'[{2,36020001,100}]'),(3,7,'[{0,18041003,5}]'),(3,14,'[{2,36020001,200}]'),(3,21,'[{0,18041003,15}]'),(3,28,'[{0,20040002,1}]'),(4,2,'[{2,36020001,100}]'),(4,7,'[{0,18041002,5}]'),(4,14,'[{2,36020001,200}]'),(4,21,'[{0,18041002,10}]'),(4,28,'[{0,20040002,1}]'),(5,2,'[{2,36020001,100}]'),(5,7,'[{0,18041002,5}]'),(5,14,'[{2,36020001,200}]'),(5,21,'[{0,18041002,10}]'),(5,28,'[{0,20040002,1}]'),(6,2,'[{2,36020001,100}]'),(6,7,'[{0,18041002,5}]'),(6,14,'[{2,36020001,200}]'),(6,21,'[{0,18041002,10}]'),(6,28,'[{0,20040002,1}]'),(7,2,'[{2,36020001,100}]'),(7,7,'[{0,18041003,5}]'),(7,14,'[{2,36020001,200}]'),(7,21,'[{0,18041003,10}]'),(7,28,'[{0,20040002,1}]'),(8,2,'[{2,36020001,100}]'),(8,7,'[{0,18041003,5}]'),(8,14,'[{2,36020001,200}]'),(8,21,'[{0,18041003,15}]'),(8,28,'[{0,20040002,1}]'),(9,2,'[{2,36020001,100}]'),(9,7,'[{0,18041003,5}]'),(9,14,'[{2,36020001,200}]'),(9,21,'[{0,18041003,15}]'),(9,28,'[{0,20040002,1}]'),(10,2,'[{2,36020001,100}]'),(10,7,'[{0,18041002,5}]'),(10,14,'[{2,36020001,200}]'),(10,21,'[{0,18041002,10}]'),(10,28,'[{0,20040002,1}]'),(11,2,'[{2,36020001,100}]'),(11,7,'[{0,18041002,5}]'),(11,14,'[{2,36020001,200}]'),(11,21,'[{0,18041002,10}]'),(11,28,'[{0,20040002,1}]'),(12,2,'[{2,36020001,100}]'),(12,7,'[{0,18041002,5}]'),(12,14,'[{2,36020001,200}]'),(12,21,'[{0,18041002,10}]'),(12,28,'[{0,20040002,1}]');
/*!40000 ALTER TABLE `base_checkin_total_rewards` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_cloud_buy`
--

DROP TABLE IF EXISTS `base_cloud_buy`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_cloud_buy` (
  `id` smallint(5) unsigned NOT NULL COMMENT '大奖id',
  `reward_type` tinyint(3) unsigned NOT NULL DEFAULT '1' COMMENT '奖励类型',
  `rewards` varchar(1000) NOT NULL COMMENT '奖励内容',
  `resouce_id` varchar(255) NOT NULL DEFAULT '[]' COMMENT '资源id',
  `resouce_size` int(10) NOT NULL COMMENT '大奖模型尺寸',
  `resouce_height` varchar(50) NOT NULL COMMENT '大奖模型坐标',
  `total_count` int(10) unsigned NOT NULL COMMENT '总份数',
  `cost` varchar(1000) NOT NULL COMMENT '购买消耗',
  `worth` varchar(255) NOT NULL COMMENT '价值',
  `award_count` smallint(5) unsigned NOT NULL COMMENT '开奖份数',
  `happy_awards` varchar(1000) NOT NULL COMMENT '保底奖励##[{权重, {goods,Id,Num}}]',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='众仙云购配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_cloud_buy`
--

LOCK TABLES `base_cloud_buy` WRITE;
/*!40000 ALTER TABLE `base_cloud_buy` DISABLE KEYS */;
INSERT INTO `base_cloud_buy` VALUES (1,2,'[{1,[{0,1107010653,1}]},{2,[{0,1107020653,1}]},{4,[{0,1107040653,1}]}]','[{1,5110101},{2,5010102},{4,5110104}]',50,'{0,-100}',200,'[{0, 38180005,1}]','5000',1,'[{1,1},{3,2},{5,3},{10,4},{10,5},{10,6},{10,7},{40,8},{40,9},{40,10},{40,11},{40,12},{40,13},{40,14}]'),(2,2,'[{1,[{0,1103000653 ,1}]},{2,[{0,1103000653 ,1}]},{4,[{0,1103000653 ,1}]}]','[{1,5070101},{2,5070101},{4,5070101}]',400,'{0,-50}',200,'[{0, 38180005,1}]','5000',1,'[{1,15},{3,16},{5,17},{10,18},{10,19},{10,20},{10,21},{40,22},{40,23},{40,24},{40,25},{40,26},{40,27},{40,28}]'),(3,2,'[{1,[{0,1105000653,1}]},{2,[{0,1105000653,1}]},{4,[{0,1105000653,1}]}]','[{1,5090101},{2,5090101},{4,5090101}]',300,'{0,-100}',200,'[{0, 38180005,1}]','5000',1,'[{1,29},{3,30},{5,31},{10,32},{10,33},{10,34},{10,35},{40,36},{40,37},{40,38},{40,39},{40,40},{40,41},{40,42}]'),(4,2,'[{1,[{0,1109000653,1}]},{2,[{0,1109000653,1}]},{4,[{0,1109000653,1}]}]','[{1,5080101},{2,5080101},{4,5080101}]',300,'{0,20}',200,'[{0, 38180005,1}]','5000',1,'[{1,43},{3,44},{5,45},{10,46},{10,47},{10,48},{10,49},{40,50},{40,51},{40,52},{40,53},{40,54},{40,55},{40,56}]');
/*!40000 ALTER TABLE `base_cloud_buy` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_cloud_buy_reward`
--

DROP TABLE IF EXISTS `base_cloud_buy_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_cloud_buy_reward` (
  `reward_id` int(10) unsigned NOT NULL COMMENT '奖励id',
  `reward_type` tinyint(3) unsigned NOT NULL DEFAULT '1' COMMENT '奖励类型',
  `reward_list` varchar(500) NOT NULL COMMENT '奖励列表',
  PRIMARY KEY (`reward_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='众仙云购普通奖励配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_cloud_buy_reward`
--

LOCK TABLES `base_cloud_buy_reward` WRITE;
/*!40000 ALTER TABLE `base_cloud_buy_reward` DISABLE KEYS */;
INSERT INTO `base_cloud_buy_reward` VALUES (1,2,'[{1,[{0,1107010643,1}]},{2,[{0,1107020643,1}]},{4,[{0,1107040643,1}]}]'),(2,2,'[{1,[{0,1107010642,1}]},{2,[{0,1107020642,1}]},{4,[{0,1107040642,1}]}]'),(3,2,'[{1,[{0,1107010542,1}]},{2,[{0,1107020542,1}]},{4,[{0,1107040542,1}]}]'),(4,1,'[{0,14020203,1}]'),(5,1,'[{0,14010103,1}]'),(6,1,'[{0,14010303,1}]'),(7,1,'[{0,14020403,1}]'),(8,1,'[{0,17020001,4}]'),(9,1,'[{0,24020001,2}]'),(10,1,'[{0,16020001,2}]'),(11,1,'[{0,18020001,4}]'),(12,1,'[{0,17010001,60}]'),(13,1,'[{0,15020101,2}]'),(14,1,'[{0,15020201,2}]'),(15,1,'[{0,1103000643,1}]'),(16,1,'[{0,1103000642,1}]'),(17,1,'[{0,1103000542,1}]'),(18,1,'[{0,14020203,1}]'),(19,1,'[{0,14010103,1}]'),(20,1,'[{0,14010303,1}]'),(21,1,'[{0,14020403,1}]'),(22,1,'[{0,17020001,4}]'),(23,1,'[{0,24020001,2}]'),(24,1,'[{0,16020001,2}]'),(25,1,'[{0,18020001,4}]'),(26,1,'[{0,17010001,60}]'),(27,1,'[{0,15020101,2}]'),(28,1,'[{0,15020201,2}]'),(29,1,'[{0,1105000643,1}]'),(30,1,'[{0,1105000642,1}]'),(31,1,'[{0,1105000542,1}]'),(32,1,'[{0,14020203,1}]'),(33,1,'[{0,14010103,1}]'),(34,1,'[{0,14010303,1}]'),(35,1,'[{0,14020403,1}]'),(36,1,'[{0,17020001,4}]'),(37,1,'[{0,24020001,2}]'),(38,1,'[{0,16020001,2}]'),(39,1,'[{0,18020001,4}]'),(40,1,'[{0,17010001,60}]'),(41,1,'[{0,15020101,2}]'),(42,1,'[{0,15020201,2}]'),(43,1,'[{0,1109000643,1}]'),(44,1,'[{0,1109000642,1}]'),(45,1,'[{0,1109000542,1}]'),(46,1,'[{0,14020203,1}]'),(47,1,'[{0,14010103,1}]'),(48,1,'[{0,14010303,1}]'),(49,1,'[{0,14020403,1}]'),(50,1,'[{0,17020001,4}]'),(51,1,'[{0,24020001,2}]'),(52,1,'[{0,16020001,2}]'),(53,1,'[{0,18020001,4}]'),(54,1,'[{0,17010001,60}]'),(55,1,'[{0,15020101,2}]'),(56,1,'[{0,15020201,2}]');
/*!40000 ALTER TABLE `base_cloud_buy_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_collect_all_reward`
--

DROP TABLE IF EXISTS `base_collect_all_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_collect_all_reward` (
  `subtype` varchar(255) NOT NULL COMMENT '子类型',
  `reward_id` int(10) unsigned NOT NULL COMMENT '奖励id',
  `type` int(10) unsigned NOT NULL COMMENT '奖励类型（1经验双倍 2副本双倍 3首领重置 4物品奖励）',
  `point` int(10) unsigned NOT NULL COMMENT '心动值',
  `time` int(10) unsigned NOT NULL COMMENT '持续时间',
  `goods_list` varchar(500) NOT NULL COMMENT '物品列表',
  PRIMARY KEY (`subtype`,`reward_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='收集活动全服奖励配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_collect_all_reward`
--

LOCK TABLES `base_collect_all_reward` WRITE;
/*!40000 ALTER TABLE `base_collect_all_reward` DISABLE KEYS */;
INSERT INTO `base_collect_all_reward` VALUES ('1',1,2,150,43200,'[]'),('1',2,4,300,0,'[{100,14010003,1},{100,32010047,1},{100,38040036,2}]'),('1',3,1,750,14400,'[]'),('1',4,3,1500,0,'[]'),('1',5,4,2400,0,'[{100,14020003,1},{100,32010044,1},{100,38040036,4}]');
/*!40000 ALTER TABLE `base_collect_all_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_collect_self_reward`
--

DROP TABLE IF EXISTS `base_collect_self_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_collect_self_reward` (
  `subtype` int(10) unsigned NOT NULL COMMENT '子类型',
  `type` int(10) unsigned NOT NULL COMMENT '类型（1普通 2累计）',
  `reward_id` int(10) unsigned NOT NULL COMMENT '奖励id',
  `weight` int(10) unsigned NOT NULL COMMENT '权重',
  `goods_list` varchar(500) NOT NULL COMMENT '物品列表',
  `stage_points` int(10) unsigned NOT NULL COMMENT '累计数',
  PRIMARY KEY (`subtype`,`type`,`reward_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='收集活动个人奖励配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_collect_self_reward`
--

LOCK TABLES `base_collect_self_reward` WRITE;
/*!40000 ALTER TABLE `base_collect_self_reward` DISABLE KEYS */;
INSERT INTO `base_collect_self_reward` VALUES (1,1,1,10,'[{100,32010031,1}]',0),(1,1,2,10,'[{100,32010032,1}]',0),(1,1,3,5,'[{100,32010033,1}]',0),(1,1,4,10,'[{100,32010048,1}]',0),(1,1,5,10,'[{100,32010041,1}]',0),(1,1,6,5,'[{100,32010042,1}]',0),(1,1,7,10,'[{100,38040002,1}]',0),(1,1,8,10,'[{100,38100001,1}]',0),(1,1,9,20,'[{100,38040003,1}]',0),(1,1,10,10,'[{100,37020001,1}]',0),(1,2,1,1,'[{100,12020008,1}]',68),(1,2,2,2,'[{100,12010008,1}]',168),(1,2,3,5,'[{100,12030008,1}]',288),(1,2,4,2,'[{100,12040008,1}]',428);
/*!40000 ALTER TABLE `base_collect_self_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_color_type`
--

DROP TABLE IF EXISTS `base_color_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_color_type` (
  `color_id` int(11) NOT NULL COMMENT '颜色ID',
  `color_type` varchar(20) NOT NULL COMMENT '颜色RGB',
  `color_name` varchar(20) NOT NULL COMMENT '颜色名称@lang@',
  PRIMARY KEY (`color_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='颜色配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_color_type`
--

LOCK TABLES `base_color_type` WRITE;
/*!40000 ALTER TABLE `base_color_type` DISABLE KEYS */;
INSERT INTO `base_color_type` VALUES (0,'#62e874','绿色'),(1,'#5dc4ef','蓝色'),(2,'#cf5afb','紫色'),(3,'#fba65a','橙色'),(4,'#ff4f4f','红色'),(5,'#ff539c','粉色'),(6,'#a35c09','幻彩'),(7,'#4eae1a','新绿色');
/*!40000 ALTER TABLE `base_color_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_common_rank_kv`
--

DROP TABLE IF EXISTS `base_common_rank_kv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_common_rank_kv` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `key` varchar(50) NOT NULL DEFAULT '' COMMENT '键',
  `value` varchar(255) NOT NULL DEFAULT '' COMMENT '值',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '描述',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8 COMMENT='排行榜键值表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_common_rank_kv`
--

LOCK TABLES `base_common_rank_kv` WRITE;
/*!40000 ALTER TABLE `base_common_rank_kv` DISABLE KEYS */;
INSERT INTO `base_common_rank_kv` VALUES (1,'charm_rank_rewards','[{boy,4907003},{girl,4907004}]','魅力榜首位称号奖励'),(2,'open_day','8','跨服榜单开启天数（开服天数）'),(3,'fabulous_rewards','[{0,38100001,1},{0,38100008,1}]','榜单点赞反馈奖励');
/*!40000 ALTER TABLE `base_common_rank_kv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_common_seal_soul_lv`
--

DROP TABLE IF EXISTS `base_common_seal_soul_lv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_common_seal_soul_lv` (
  `seal_soul_quality` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '魂珠品质',
  `grow_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '成长类型',
  `seal_soul_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '魂珠等级',
  `grow_ratio` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '属性成长万分比',
  `cost` varchar(128) NOT NULL DEFAULT '[]' COMMENT '消耗',
  PRIMARY KEY (`seal_soul_lv`,`seal_soul_quality`,`grow_type`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='通用魂珠升级配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_common_seal_soul_lv`
--

LOCK TABLES `base_common_seal_soul_lv` WRITE;
/*!40000 ALTER TABLE `base_common_seal_soul_lv` DISABLE KEYS */;
INSERT INTO `base_common_seal_soul_lv` VALUES (0,1,1,0,'[{255,36160007,1925}]'),(0,2,1,0,'[{255,36160007,1925}]'),(0,3,1,0,'[{255,36160007,1925}]'),(1,1,1,0,'[{255,36160007,2275}]'),(1,2,1,0,'[{255,36160007,2275}]'),(1,3,1,0,'[{255,36160007,2275}]'),(2,1,1,0,'[{255,36160007,2450}]'),(2,2,1,0,'[{255,36160007,2450}]'),(2,3,1,0,'[{255,36160007,2450}]'),(3,1,1,0,'[{255,36160007,2975}]'),(3,2,1,0,'[{255,36160007,2975}]'),(3,3,1,0,'[{255,36160007,2975}]'),(4,1,1,0,'[{255,36160007,3500}]'),(4,2,1,0,'[{255,36160007,3500}]'),(4,3,1,0,'[{255,36160007,3500}]'),(0,1,2,60,'[{255,36160007,2016}]'),(0,2,2,50,'[{255,36160007,2016}]'),(0,3,2,100,'[{255,36160007,2016}]'),(1,1,2,60,'[{255,36160007,2383}]'),(1,2,2,50,'[{255,36160007,2383}]'),(1,3,2,100,'[{255,36160007,2383}]'),(2,1,2,60,'[{255,36160007,2566}]'),(2,2,2,50,'[{255,36160007,2566}]'),(2,3,2,90,'[{255,36160007,2566}]'),(3,1,2,60,'[{255,36160007,3116}]'),(3,2,2,50,'[{255,36160007,3116}]'),(3,3,2,90,'[{255,36160007,3116}]'),(4,1,2,60,'[{255,36160007,3666}]'),(4,2,2,50,'[{255,36160007,3666}]'),(4,3,2,90,'[{255,36160007,3666}]'),(0,1,3,120,'[{255,36160007,2111}]'),(0,2,3,100,'[{255,36160007,2111}]'),(0,3,3,200,'[{255,36160007,2111}]'),(1,1,3,120,'[{255,36160007,2495}]'),(1,2,3,100,'[{255,36160007,2495}]'),(1,3,3,200,'[{255,36160007,2495}]'),(2,1,3,120,'[{255,36160007,2687}]'),(2,2,3,100,'[{255,36160007,2687}]'),(2,3,3,180,'[{255,36160007,2687}]'),(3,1,3,120,'[{255,36160007,3262}]'),(3,2,3,100,'[{255,36160007,3262}]'),(3,3,3,180,'[{255,36160007,3262}]'),(4,1,3,120,'[{255,36160007,3838}]'),(4,2,3,100,'[{255,36160007,3838}]'),(4,3,3,180,'[{255,36160007,3838}]'),(0,1,4,182,'[{255,36160007,2209}]'),(0,2,4,152,'[{255,36160007,2209}]'),(0,3,4,300,'[{255,36160007,2209}]'),(1,1,4,182,'[{255,36160007,2610}]'),(1,2,4,152,'[{255,36160007,2610}]'),(1,3,4,300,'[{255,36160007,2610}]'),(2,1,4,182,'[{255,36160007,2811}]'),(2,2,4,152,'[{255,36160007,2811}]'),(2,3,4,270,'[{255,36160007,2811}]'),(3,1,4,182,'[{255,36160007,3414}]'),(3,2,4,152,'[{255,36160007,3414}]'),(3,3,4,270,'[{255,36160007,3414}]'),(4,1,4,182,'[{255,36160007,4016}]'),(4,2,4,152,'[{255,36160007,4016}]'),(4,3,4,270,'[{255,36160007,4016}]'),(0,1,5,244,'[{255,36160007,2310}]'),(0,2,5,205,'[{255,36160007,2310}]'),(0,3,5,400,'[{255,36160007,2310}]'),(1,1,5,244,'[{255,36160007,2730}]'),(1,2,5,205,'[{255,36160007,2730}]'),(1,3,5,400,'[{255,36160007,2730}]'),(2,1,5,244,'[{255,36160007,2940}]'),(2,2,5,205,'[{255,36160007,2940}]'),(2,3,5,360,'[{255,36160007,2940}]'),(3,1,5,244,'[{255,36160007,3570}]'),(3,2,5,205,'[{255,36160007,3570}]'),(3,3,5,360,'[{255,36160007,3570}]'),(4,1,5,244,'[{255,36160007,4200}]'),(4,2,5,205,'[{255,36160007,4200}]'),(4,3,5,360,'[{255,36160007,4200}]'),(0,1,6,308,'[{255,36160007,2415}]'),(0,2,6,259,'[{255,36160007,2415}]'),(0,3,6,500,'[{255,36160007,2415}]'),(1,1,6,308,'[{255,36160007,2854}]'),(1,2,6,259,'[{255,36160007,2854}]'),(1,3,6,500,'[{255,36160007,2854}]'),(2,1,6,308,'[{255,36160007,3074}]'),(2,2,6,259,'[{255,36160007,3074}]'),(2,3,6,450,'[{255,36160007,3074}]'),(3,1,6,308,'[{255,36160007,3732}]'),(3,2,6,259,'[{255,36160007,3732}]'),(3,3,6,450,'[{255,36160007,3732}]'),(4,1,6,308,'[{255,36160007,4391}]'),(4,2,6,259,'[{255,36160007,4391}]'),(4,3,6,450,'[{255,36160007,4391}]'),(0,1,7,372,'[{255,36160007,2524}]'),(0,2,7,314,'[{255,36160007,2524}]'),(0,3,7,600,'[{255,36160007,2524}]'),(1,1,7,372,'[{255,36160007,2983}]'),(1,2,7,314,'[{255,36160007,2983}]'),(1,3,7,600,'[{255,36160007,2983}]'),(2,1,7,372,'[{255,36160007,3212}]'),(2,2,7,314,'[{255,36160007,3212}]'),(2,3,7,540,'[{255,36160007,3212}]'),(3,1,7,372,'[{255,36160007,3901}]'),(3,2,7,314,'[{255,36160007,3901}]'),(3,3,7,540,'[{255,36160007,3901}]'),(4,1,7,372,'[{255,36160007,4589}]'),(4,2,7,314,'[{255,36160007,4589}]'),(4,3,7,540,'[{255,36160007,4589}]'),(0,1,8,436,'[{255,36160007,2637}]'),(0,2,8,369,'[{255,36160007,2637}]'),(0,3,8,700,'[{255,36160007,2637}]'),(1,1,8,436,'[{255,36160007,3116}]'),(1,2,8,369,'[{255,36160007,3116}]'),(1,3,8,700,'[{255,36160007,3116}]'),(2,1,8,436,'[{255,36160007,3356}]'),(2,2,8,369,'[{255,36160007,3356}]'),(2,3,8,630,'[{255,36160007,3356}]'),(3,1,8,436,'[{255,36160007,4075}]'),(3,2,8,369,'[{255,36160007,4075}]'),(3,3,8,630,'[{255,36160007,4075}]'),(4,1,8,436,'[{255,36160007,4794}]'),(4,2,8,369,'[{255,36160007,4794}]'),(4,3,8,630,'[{255,36160007,4794}]'),(0,1,9,502,'[{255,36160007,2754}]'),(0,2,9,426,'[{255,36160007,2754}]'),(0,3,9,800,'[{255,36160007,2754}]'),(1,1,9,502,'[{255,36160007,3255}]'),(1,2,9,426,'[{255,36160007,3255}]'),(1,3,9,800,'[{255,36160007,3255}]'),(2,1,9,502,'[{255,36160007,3506}]'),(2,2,9,426,'[{255,36160007,3506}]'),(2,3,9,720,'[{255,36160007,3506}]'),(3,1,9,502,'[{255,36160007,4257}]'),(3,2,9,426,'[{255,36160007,4257}]'),(3,3,9,720,'[{255,36160007,4257}]'),(4,1,9,502,'[{255,36160007,5008}]'),(4,2,9,426,'[{255,36160007,5008}]'),(4,3,9,720,'[{255,36160007,5008}]'),(0,1,10,568,'[{255,36160007,2876}]'),(0,2,10,484,'[{255,36160007,2876}]'),(0,3,10,900,'[{255,36160007,2876}]'),(1,1,10,568,'[{255,36160007,3399}]'),(1,2,10,484,'[{255,36160007,3399}]'),(1,3,10,900,'[{255,36160007,3399}]'),(2,1,10,568,'[{255,36160007,3660}]'),(2,2,10,484,'[{255,36160007,3660}]'),(2,3,10,810,'[{255,36160007,3660}]'),(3,1,10,568,'[{255,36160007,4445}]'),(3,2,10,484,'[{255,36160007,4445}]'),(3,3,10,810,'[{255,36160007,4445}]'),(4,1,10,568,'[{255,36160007,5229}]'),(4,2,10,484,'[{255,36160007,5229}]'),(4,3,10,810,'[{255,36160007,5229}]'),(0,1,11,636,'[{255,36160007,3003}]'),(0,2,11,542,'[{255,36160007,3003}]'),(0,3,11,1000,'[{255,36160007,3003}]'),(1,1,11,636,'[{255,36160007,3549}]'),(1,2,11,542,'[{255,36160007,3549}]'),(1,3,11,1000,'[{255,36160007,3549}]'),(2,1,11,636,'[{255,36160007,3822}]'),(2,2,11,542,'[{255,36160007,3822}]'),(2,3,11,900,'[{255,36160007,3822}]'),(3,1,11,636,'[{255,36160007,4641}]'),(3,2,11,542,'[{255,36160007,4641}]'),(3,3,11,900,'[{255,36160007,4641}]'),(4,1,11,636,'[{255,36160007,5460}]'),(4,2,11,542,'[{255,36160007,5460}]'),(4,3,11,900,'[{255,36160007,5460}]'),(0,1,12,704,'[{255,36160007,3135}]'),(0,2,12,602,'[{255,36160007,3135}]'),(0,3,12,1100,'[{255,36160007,3135}]'),(1,1,12,704,'[{255,36160007,3705}]'),(1,2,12,602,'[{255,36160007,3705}]'),(1,3,12,1100,'[{255,36160007,3705}]'),(2,1,12,704,'[{255,36160007,3990}]'),(2,2,12,602,'[{255,36160007,3990}]'),(2,3,12,990,'[{255,36160007,3990}]'),(3,1,12,704,'[{255,36160007,4845}]'),(3,2,12,602,'[{255,36160007,4845}]'),(3,3,12,990,'[{255,36160007,4845}]'),(4,1,12,704,'[{255,36160007,5700}]'),(4,2,12,602,'[{255,36160007,5700}]'),(4,3,12,990,'[{255,36160007,5700}]'),(0,1,13,772,'[{255,36160007,3273}]'),(0,2,13,662,'[{255,36160007,3273}]'),(0,3,13,1200,'[{255,36160007,3273}]'),(1,1,13,772,'[{255,36160007,3868}]'),(1,2,13,662,'[{255,36160007,3868}]'),(1,3,13,1200,'[{255,36160007,3868}]'),(2,1,13,772,'[{255,36160007,4165}]'),(2,2,13,662,'[{255,36160007,4165}]'),(2,3,13,1080,'[{255,36160007,4165}]'),(3,1,13,772,'[{255,36160007,5058}]'),(3,2,13,662,'[{255,36160007,5058}]'),(3,3,13,1080,'[{255,36160007,5058}]'),(4,1,13,772,'[{255,36160007,5950}]'),(4,2,13,662,'[{255,36160007,5950}]'),(4,3,13,1080,'[{255,36160007,5950}]'),(0,1,14,842,'[{255,36160007,3416}]'),(0,2,14,724,'[{255,36160007,3416}]'),(0,3,14,1300,'[{255,36160007,3416}]'),(1,1,14,842,'[{255,36160007,4037}]'),(1,2,14,724,'[{255,36160007,4037}]'),(1,3,14,1300,'[{255,36160007,4037}]'),(2,1,14,842,'[{255,36160007,4348}]'),(2,2,14,724,'[{255,36160007,4348}]'),(2,3,14,1170,'[{255,36160007,4348}]'),(3,1,14,842,'[{255,36160007,5279}]'),(3,2,14,724,'[{255,36160007,5279}]'),(3,3,14,1170,'[{255,36160007,5279}]'),(4,1,14,842,'[{255,36160007,6211}]'),(4,2,14,724,'[{255,36160007,6211}]'),(4,3,14,1170,'[{255,36160007,6211}]'),(0,1,15,912,'[{255,36160007,3566}]'),(0,2,15,786,'[{255,36160007,3566}]'),(0,3,15,1400,'[{255,36160007,3566}]'),(1,1,15,912,'[{255,36160007,4214}]'),(1,2,15,786,'[{255,36160007,4214}]'),(1,3,15,1400,'[{255,36160007,4214}]'),(2,1,15,912,'[{255,36160007,4538}]'),(2,2,15,786,'[{255,36160007,4538}]'),(2,3,15,1260,'[{255,36160007,4538}]'),(3,1,15,912,'[{255,36160007,5511}]'),(3,2,15,786,'[{255,36160007,5511}]'),(3,3,15,1260,'[{255,36160007,5511}]'),(4,1,15,912,'[{255,36160007,6483}]'),(4,2,15,786,'[{255,36160007,6483}]'),(4,3,15,1260,'[{255,36160007,6483}]'),(0,1,16,984,'[{255,36160007,3722}]'),(0,2,16,849,'[{255,36160007,3722}]'),(0,3,16,1500,'[{255,36160007,3722}]'),(1,1,16,984,'[{255,36160007,4399}]'),(1,2,16,849,'[{255,36160007,4399}]'),(1,3,16,1500,'[{255,36160007,4399}]'),(2,1,16,984,'[{255,36160007,4737}]'),(2,2,16,849,'[{255,36160007,4737}]'),(2,3,16,1350,'[{255,36160007,4737}]'),(3,1,16,984,'[{255,36160007,5752}]'),(3,2,16,849,'[{255,36160007,5752}]'),(3,3,16,1350,'[{255,36160007,5752}]'),(4,1,16,984,'[{255,36160007,6767}]'),(4,2,16,849,'[{255,36160007,6767}]'),(4,3,16,1350,'[{255,36160007,6767}]'),(0,1,17,1056,'[{255,36160007,3885}]'),(0,2,17,914,'[{255,36160007,3885}]'),(0,3,17,1600,'[{255,36160007,3885}]'),(1,1,17,1056,'[{255,36160007,4592}]'),(1,2,17,914,'[{255,36160007,4592}]'),(1,3,17,1600,'[{255,36160007,4592}]'),(2,1,17,1056,'[{255,36160007,4945}]'),(2,2,17,914,'[{255,36160007,4945}]'),(2,3,17,1440,'[{255,36160007,4945}]'),(3,1,17,1056,'[{255,36160007,6004}]'),(3,2,17,914,'[{255,36160007,6004}]'),(3,3,17,1440,'[{255,36160007,6004}]'),(4,1,17,1056,'[{255,36160007,7064}]'),(4,2,17,914,'[{255,36160007,7064}]'),(4,3,17,1440,'[{255,36160007,7064}]'),(0,1,18,1128,'[{255,36160007,4056}]'),(0,2,18,979,'[{255,36160007,4056}]'),(0,3,18,1700,'[{255,36160007,4056}]'),(1,1,18,1128,'[{255,36160007,4793}]'),(1,2,18,979,'[{255,36160007,4793}]'),(1,3,18,1700,'[{255,36160007,4793}]'),(2,1,18,1128,'[{255,36160007,5162}]'),(2,2,18,979,'[{255,36160007,5162}]'),(2,3,18,1530,'[{255,36160007,5162}]'),(3,1,18,1128,'[{255,36160007,6268}]'),(3,2,18,979,'[{255,36160007,6268}]'),(3,3,18,1530,'[{255,36160007,6268}]'),(4,1,18,1128,'[{255,36160007,7374}]'),(4,2,18,979,'[{255,36160007,7374}]'),(4,3,18,1530,'[{255,36160007,7374}]'),(0,1,19,1202,'[{255,36160007,4235}]'),(0,2,19,1045,'[{255,36160007,4235}]'),(0,3,19,1800,'[{255,36160007,4235}]'),(1,1,19,1202,'[{255,36160007,5005}]'),(1,2,19,1045,'[{255,36160007,5005}]'),(1,3,19,1800,'[{255,36160007,5005}]'),(2,1,19,1202,'[{255,36160007,5390}]'),(2,2,19,1045,'[{255,36160007,5390}]'),(2,3,19,1620,'[{255,36160007,5390}]'),(3,1,19,1202,'[{255,36160007,6545}]'),(3,2,19,1045,'[{255,36160007,6545}]'),(3,3,19,1620,'[{255,36160007,6545}]'),(4,1,19,1202,'[{255,36160007,7700}]'),(4,2,19,1045,'[{255,36160007,7700}]'),(4,3,19,1620,'[{255,36160007,7700}]'),(0,1,20,1276,'[{255,36160007,4423}]'),(0,2,20,1112,'[{255,36160007,4423}]'),(0,3,20,1900,'[{255,36160007,4423}]'),(1,1,20,1276,'[{255,36160007,5227}]'),(1,2,20,1112,'[{255,36160007,5227}]'),(1,3,20,1900,'[{255,36160007,5227}]'),(2,1,20,1276,'[{255,36160007,5629}]'),(2,2,20,1112,'[{255,36160007,5629}]'),(2,3,20,1710,'[{255,36160007,5629}]'),(3,1,20,1276,'[{255,36160007,6835}]'),(3,2,20,1112,'[{255,36160007,6835}]'),(3,3,20,1710,'[{255,36160007,6835}]'),(4,1,20,1276,'[{255,36160007,8041}]'),(4,2,20,1112,'[{255,36160007,8041}]'),(4,3,20,1710,'[{255,36160007,8041}]'),(0,1,21,1352,'[{255,36160007,4620}]'),(0,2,21,1180,'[{255,36160007,4620}]'),(0,3,21,2000,'[{255,36160007,4620}]'),(1,1,21,1352,'[{255,36160007,5460}]'),(1,2,21,1180,'[{255,36160007,5460}]'),(1,3,21,2000,'[{255,36160007,5460}]'),(2,1,21,1352,'[{255,36160007,5880}]'),(2,2,21,1180,'[{255,36160007,5880}]'),(2,3,21,1800,'[{255,36160007,5880}]'),(3,1,21,1352,'[{255,36160007,7140}]'),(3,2,21,1180,'[{255,36160007,7140}]'),(3,3,21,1800,'[{255,36160007,7140}]'),(4,1,21,1352,'[{255,36160007,8400}]'),(4,2,21,1180,'[{255,36160007,8400}]'),(4,3,21,1800,'[{255,36160007,8400}]'),(0,1,22,1428,'[{255,36160007,4766}]'),(0,2,22,1249,'[{255,36160007,4766}]'),(0,3,22,2100,'[{255,36160007,4766}]'),(1,1,22,1428,'[{255,36160007,5633}]'),(1,2,22,1249,'[{255,36160007,5633}]'),(1,3,22,2100,'[{255,36160007,5633}]'),(2,1,22,1428,'[{255,36160007,6066}]'),(2,2,22,1249,'[{255,36160007,6066}]'),(2,3,22,1890,'[{255,36160007,6066}]'),(3,1,22,1428,'[{255,36160007,7366}]'),(3,2,22,1249,'[{255,36160007,7366}]'),(3,3,22,1890,'[{255,36160007,7366}]'),(4,1,22,1428,'[{255,36160007,8666}]'),(4,2,22,1249,'[{255,36160007,8666}]'),(4,3,22,1890,'[{255,36160007,8666}]'),(0,1,23,1504,'[{255,36160007,4916}]'),(0,2,23,1319,'[{255,36160007,4916}]'),(0,3,23,2200,'[{255,36160007,4916}]'),(1,1,23,1504,'[{255,36160007,5810}]'),(1,2,23,1319,'[{255,36160007,5810}]'),(1,3,23,2200,'[{255,36160007,5810}]'),(2,1,23,1504,'[{255,36160007,6257}]'),(2,2,23,1319,'[{255,36160007,6257}]'),(2,3,23,1980,'[{255,36160007,6257}]'),(3,1,23,1504,'[{255,36160007,7597}]'),(3,2,23,1319,'[{255,36160007,7597}]'),(3,3,23,1980,'[{255,36160007,7597}]'),(4,1,23,1504,'[{255,36160007,8938}]'),(4,2,23,1319,'[{255,36160007,8938}]'),(4,3,23,1980,'[{255,36160007,8938}]'),(0,1,24,1582,'[{255,36160007,5070}]'),(0,2,24,1390,'[{255,36160007,5070}]'),(0,3,24,2300,'[{255,36160007,5070}]'),(1,1,24,1582,'[{255,36160007,5992}]'),(1,2,24,1390,'[{255,36160007,5992}]'),(1,3,24,2300,'[{255,36160007,5992}]'),(2,1,24,1582,'[{255,36160007,6453}]'),(2,2,24,1390,'[{255,36160007,6453}]'),(2,3,24,2070,'[{255,36160007,6453}]'),(3,1,24,1582,'[{255,36160007,7835}]'),(3,2,24,1390,'[{255,36160007,7835}]'),(3,3,24,2070,'[{255,36160007,7835}]'),(4,1,24,1582,'[{255,36160007,9218}]'),(4,2,24,1390,'[{255,36160007,9218}]'),(4,3,24,2070,'[{255,36160007,9218}]'),(0,1,25,1660,'[{255,36160007,5228}]'),(0,2,25,1462,'[{255,36160007,5228}]'),(0,3,25,2400,'[{255,36160007,5228}]'),(1,1,25,1660,'[{255,36160007,6178}]'),(1,2,25,1462,'[{255,36160007,6178}]'),(1,3,25,2400,'[{255,36160007,6178}]'),(2,1,25,1660,'[{255,36160007,6654}]'),(2,2,25,1462,'[{255,36160007,6654}]'),(2,3,25,2160,'[{255,36160007,6654}]'),(3,1,25,1660,'[{255,36160007,8079}]'),(3,2,25,1462,'[{255,36160007,8079}]'),(3,3,25,2160,'[{255,36160007,8079}]'),(4,1,25,1660,'[{255,36160007,9505}]'),(4,2,25,1462,'[{255,36160007,9505}]'),(4,3,25,2160,'[{255,36160007,9505}]'),(0,1,26,1740,'[{255,36160007,5390}]'),(0,2,26,1535,'[{255,36160007,5390}]'),(0,3,26,2500,'[{255,36160007,5390}]'),(1,1,26,1740,'[{255,36160007,6370}]'),(1,2,26,1535,'[{255,36160007,6370}]'),(1,3,26,2500,'[{255,36160007,6370}]'),(2,1,26,1740,'[{255,36160007,6860}]'),(2,2,26,1535,'[{255,36160007,6860}]'),(2,3,26,2250,'[{255,36160007,6860}]'),(3,1,26,1740,'[{255,36160007,8330}]'),(3,2,26,1535,'[{255,36160007,8330}]'),(3,3,26,2250,'[{255,36160007,8330}]'),(4,1,26,1740,'[{255,36160007,9800}]'),(4,2,26,1535,'[{255,36160007,9800}]'),(4,3,26,2250,'[{255,36160007,9800}]'),(0,1,27,1820,'[{255,36160007,5557}]'),(0,2,27,1608,'[{255,36160007,5557}]'),(0,3,27,2600,'[{255,36160007,5557}]'),(1,1,27,1820,'[{255,36160007,6567}]'),(1,2,27,1608,'[{255,36160007,6567}]'),(1,3,27,2600,'[{255,36160007,6567}]'),(2,1,27,1820,'[{255,36160007,7072}]'),(2,2,27,1608,'[{255,36160007,7072}]'),(2,3,27,2340,'[{255,36160007,7072}]'),(3,1,27,1820,'[{255,36160007,8588}]'),(3,2,27,1608,'[{255,36160007,8588}]'),(3,3,27,2340,'[{255,36160007,8588}]'),(4,1,27,1820,'[{255,36160007,10103}]'),(4,2,27,1608,'[{255,36160007,10103}]'),(4,3,27,2340,'[{255,36160007,10103}]'),(0,1,28,1900,'[{255,36160007,5728}]'),(0,2,28,1683,'[{255,36160007,5728}]'),(0,3,28,2700,'[{255,36160007,5728}]'),(1,1,28,1900,'[{255,36160007,6769}]'),(1,2,28,1683,'[{255,36160007,6769}]'),(1,3,28,2700,'[{255,36160007,6769}]'),(2,1,28,1900,'[{255,36160007,7290}]'),(2,2,28,1683,'[{255,36160007,7290}]'),(2,3,28,2430,'[{255,36160007,7290}]'),(3,1,28,1900,'[{255,36160007,8852}]'),(3,2,28,1683,'[{255,36160007,8852}]'),(3,3,28,2430,'[{255,36160007,8852}]'),(4,1,28,1900,'[{255,36160007,10414}]'),(4,2,28,1683,'[{255,36160007,10414}]'),(4,3,28,2430,'[{255,36160007,10414}]'),(0,1,29,1982,'[{255,36160007,5903}]'),(0,2,29,1759,'[{255,36160007,5903}]'),(0,3,29,2800,'[{255,36160007,5903}]'),(1,1,29,1982,'[{255,36160007,6976}]'),(1,2,29,1759,'[{255,36160007,6976}]'),(1,3,29,2800,'[{255,36160007,6976}]'),(2,1,29,1982,'[{255,36160007,7513}]'),(2,2,29,1759,'[{255,36160007,7513}]'),(2,3,29,2520,'[{255,36160007,7513}]'),(3,1,29,1982,'[{255,36160007,9123}]'),(3,2,29,1759,'[{255,36160007,9123}]'),(3,3,29,2520,'[{255,36160007,9123}]'),(4,1,29,1982,'[{255,36160007,10733}]'),(4,2,29,1759,'[{255,36160007,10733}]'),(4,3,29,2520,'[{255,36160007,10733}]'),(0,1,30,2064,'[{255,36160007,6084}]'),(0,2,30,1835,'[{255,36160007,6084}]'),(0,3,30,2900,'[{255,36160007,6084}]'),(1,1,30,2064,'[{255,36160007,7190}]'),(1,2,30,1835,'[{255,36160007,7190}]'),(1,3,30,2900,'[{255,36160007,7190}]'),(2,1,30,2064,'[{255,36160007,7743}]'),(2,2,30,1835,'[{255,36160007,7743}]'),(2,3,30,2610,'[{255,36160007,7743}]'),(3,1,30,2064,'[{255,36160007,9403}]'),(3,2,30,1835,'[{255,36160007,9403}]'),(3,3,30,2610,'[{255,36160007,9403}]'),(4,1,30,2064,'[{255,36160007,11062}]'),(4,2,30,1835,'[{255,36160007,11062}]'),(4,3,30,2610,'[{255,36160007,11062}]'),(0,1,31,2148,'[{255,36160007,6270}]'),(0,2,31,1913,'[{255,36160007,6270}]'),(0,3,31,3000,'[{255,36160007,6270}]'),(1,1,31,2148,'[{255,36160007,7410}]'),(1,2,31,1913,'[{255,36160007,7410}]'),(1,3,31,3000,'[{255,36160007,7410}]'),(2,1,31,2148,'[{255,36160007,7980}]'),(2,2,31,1913,'[{255,36160007,7980}]'),(2,3,31,2700,'[{255,36160007,7980}]'),(3,1,31,2148,'[{255,36160007,9690}]'),(3,2,31,1913,'[{255,36160007,9690}]'),(3,3,31,2700,'[{255,36160007,9690}]'),(4,1,31,2148,'[{255,36160007,11400}]'),(4,2,31,1913,'[{255,36160007,11400}]'),(4,3,31,2700,'[{255,36160007,11400}]'),(0,1,32,2232,'[{255,36160007,6461}]'),(0,2,32,1991,'[{255,36160007,6461}]'),(0,3,32,3100,'[{255,36160007,6461}]'),(1,1,32,2232,'[{255,36160007,7636}]'),(1,2,32,1991,'[{255,36160007,7636}]'),(1,3,32,3100,'[{255,36160007,7636}]'),(2,1,32,2232,'[{255,36160007,8224}]'),(2,2,32,1991,'[{255,36160007,8224}]'),(2,3,32,2790,'[{255,36160007,8224}]'),(3,1,32,2232,'[{255,36160007,9986}]'),(3,2,32,1991,'[{255,36160007,9986}]'),(3,3,32,2790,'[{255,36160007,9986}]'),(4,1,32,2232,'[{255,36160007,11748}]'),(4,2,32,1991,'[{255,36160007,11748}]'),(4,3,32,2790,'[{255,36160007,11748}]'),(0,1,33,2316,'[{255,36160007,6658}]'),(0,2,33,2071,'[{255,36160007,6658}]'),(0,3,33,3200,'[{255,36160007,6658}]'),(1,1,33,2316,'[{255,36160007,7869}]'),(1,2,33,2071,'[{255,36160007,7869}]'),(1,3,33,3200,'[{255,36160007,7869}]'),(2,1,33,2316,'[{255,36160007,8474}]'),(2,2,33,2071,'[{255,36160007,8474}]'),(2,3,33,2880,'[{255,36160007,8474}]'),(3,1,33,2316,'[{255,36160007,10290}]'),(3,2,33,2071,'[{255,36160007,10290}]'),(3,3,33,2880,'[{255,36160007,10290}]'),(4,1,33,2316,'[{255,36160007,12106}]'),(4,2,33,2071,'[{255,36160007,12106}]'),(4,3,33,2880,'[{255,36160007,12106}]'),(0,1,34,2402,'[{255,36160007,6861}]'),(0,2,34,2151,'[{255,36160007,6861}]'),(0,3,34,3300,'[{255,36160007,6861}]'),(1,1,34,2402,'[{255,36160007,8109}]'),(1,2,34,2151,'[{255,36160007,8109}]'),(1,3,34,3300,'[{255,36160007,8109}]'),(2,1,34,2402,'[{255,36160007,8733}]'),(2,2,34,2151,'[{255,36160007,8733}]'),(2,3,34,2970,'[{255,36160007,8733}]'),(3,1,34,2402,'[{255,36160007,10604}]'),(3,2,34,2151,'[{255,36160007,10604}]'),(3,3,34,2970,'[{255,36160007,10604}]'),(4,1,34,2402,'[{255,36160007,12475}]'),(4,2,34,2151,'[{255,36160007,12475}]'),(4,3,34,2970,'[{255,36160007,12475}]'),(0,1,35,2488,'[{255,36160007,7070}]'),(0,2,35,2232,'[{255,36160007,7070}]'),(0,3,35,3400,'[{255,36160007,7070}]'),(1,1,35,2488,'[{255,36160007,8356}]'),(1,2,35,2232,'[{255,36160007,8356}]'),(1,3,35,3400,'[{255,36160007,8356}]'),(2,1,35,2488,'[{255,36160007,8999}]'),(2,2,35,2232,'[{255,36160007,8999}]'),(2,3,35,3060,'[{255,36160007,8999}]'),(3,1,35,2488,'[{255,36160007,10927}]'),(3,2,35,2232,'[{255,36160007,10927}]'),(3,3,35,3060,'[{255,36160007,10927}]'),(4,1,35,2488,'[{255,36160007,12855}]'),(4,2,35,2232,'[{255,36160007,12855}]'),(4,3,35,3060,'[{255,36160007,12855}]'),(0,1,36,2576,'[{255,36160007,7285}]'),(0,2,36,2315,'[{255,36160007,7285}]'),(0,3,36,3500,'[{255,36160007,7285}]'),(1,1,36,2576,'[{255,36160007,8610}]'),(1,2,36,2315,'[{255,36160007,8610}]'),(1,3,36,3500,'[{255,36160007,8610}]'),(2,1,36,2576,'[{255,36160007,9272}]'),(2,2,36,2315,'[{255,36160007,9272}]'),(2,3,36,3150,'[{255,36160007,9272}]'),(3,1,36,2576,'[{255,36160007,11259}]'),(3,2,36,2315,'[{255,36160007,11259}]'),(3,3,36,3150,'[{255,36160007,11259}]'),(4,1,36,2576,'[{255,36160007,13246}]'),(4,2,36,2315,'[{255,36160007,13246}]'),(4,3,36,3150,'[{255,36160007,13246}]'),(0,1,37,2664,'[{255,36160007,7508}]'),(0,2,37,2398,'[{255,36160007,7508}]'),(0,3,37,3600,'[{255,36160007,7508}]'),(1,1,37,2664,'[{255,36160007,8873}]'),(1,2,37,2398,'[{255,36160007,8873}]'),(1,3,37,3600,'[{255,36160007,8873}]'),(2,1,37,2664,'[{255,36160007,9555}]'),(2,2,37,2398,'[{255,36160007,9555}]'),(2,3,37,3240,'[{255,36160007,9555}]'),(3,1,37,2664,'[{255,36160007,11603}]'),(3,2,37,2398,'[{255,36160007,11603}]'),(3,3,37,3240,'[{255,36160007,11603}]'),(4,1,37,2664,'[{255,36160007,13650}]'),(4,2,37,2398,'[{255,36160007,13650}]'),(4,3,37,3240,'[{255,36160007,13650}]'),(0,1,38,2752,'[{255,36160007,7737}]'),(0,2,38,2482,'[{255,36160007,7737}]'),(0,3,38,3700,'[{255,36160007,7737}]'),(1,1,38,2752,'[{255,36160007,9144}]'),(1,2,38,2482,'[{255,36160007,9144}]'),(1,3,38,3700,'[{255,36160007,9144}]'),(2,1,38,2752,'[{255,36160007,9847}]'),(2,2,38,2482,'[{255,36160007,9847}]'),(2,3,38,3330,'[{255,36160007,9847}]'),(3,1,38,2752,'[{255,36160007,11957}]'),(3,2,38,2482,'[{255,36160007,11957}]'),(3,3,38,3330,'[{255,36160007,11957}]'),(4,1,38,2752,'[{255,36160007,14067}]'),(4,2,38,2482,'[{255,36160007,14067}]'),(4,3,38,3330,'[{255,36160007,14067}]'),(0,1,39,2842,'[{255,36160007,7973}]'),(0,2,39,2567,'[{255,36160007,7973}]'),(0,3,39,3800,'[{255,36160007,7973}]'),(1,1,39,2842,'[{255,36160007,9423}]'),(1,2,39,2567,'[{255,36160007,9423}]'),(1,3,39,3800,'[{255,36160007,9423}]'),(2,1,39,2842,'[{255,36160007,10148}]'),(2,2,39,2567,'[{255,36160007,10148}]'),(2,3,39,3420,'[{255,36160007,10148}]'),(3,1,39,2842,'[{255,36160007,12322}]'),(3,2,39,2567,'[{255,36160007,12322}]'),(3,3,39,3420,'[{255,36160007,12322}]'),(4,1,39,2842,'[{255,36160007,14497}]'),(4,2,39,2567,'[{255,36160007,14497}]'),(4,3,39,3420,'[{255,36160007,14497}]'),(0,1,40,2932,'[{255,36160007,8218}]'),(0,2,40,2653,'[{255,36160007,8218}]'),(0,3,40,3900,'[{255,36160007,8218}]'),(1,1,40,2932,'[{255,36160007,9712}]'),(1,2,40,2653,'[{255,36160007,9712}]'),(1,3,40,3900,'[{255,36160007,9712}]'),(2,1,40,2932,'[{255,36160007,10459}]'),(2,2,40,2653,'[{255,36160007,10459}]'),(2,3,40,3510,'[{255,36160007,10459}]'),(3,1,40,2932,'[{255,36160007,12700}]'),(3,2,40,2653,'[{255,36160007,12700}]'),(3,3,40,3510,'[{255,36160007,12700}]'),(4,1,40,2932,'[{255,36160007,14941}]'),(4,2,40,2653,'[{255,36160007,14941}]'),(4,3,40,3510,'[{255,36160007,14941}]'),(0,1,41,3024,'[{255,36160007,8470}]'),(0,2,41,2741,'[{255,36160007,8470}]'),(0,3,41,4000,'[{255,36160007,8470}]'),(1,1,41,3024,'[{255,36160007,10010}]'),(1,2,41,2741,'[{255,36160007,10010}]'),(1,3,41,4000,'[{255,36160007,10010}]'),(2,1,41,3024,'[{255,36160007,10780}]'),(2,2,41,2741,'[{255,36160007,10780}]'),(2,3,41,3600,'[{255,36160007,10780}]'),(3,1,41,3024,'[{255,36160007,13090}]'),(3,2,41,2741,'[{255,36160007,13090}]'),(3,3,41,3600,'[{255,36160007,13090}]'),(4,1,41,3024,'[{255,36160007,15400}]'),(4,2,41,2741,'[{255,36160007,15400}]'),(4,3,41,3600,'[{255,36160007,15400}]'),(0,1,42,3116,'[{255,36160007,8672}]'),(0,2,42,2829,'[{255,36160007,8672}]'),(0,3,42,4100,'[{255,36160007,8672}]'),(1,1,42,3116,'[{255,36160007,10249}]'),(1,2,42,2829,'[{255,36160007,10249}]'),(1,3,42,4100,'[{255,36160007,10249}]'),(2,1,42,3116,'[{255,36160007,11038}]'),(2,2,42,2829,'[{255,36160007,11038}]'),(2,3,42,3690,'[{255,36160007,11038}]'),(3,1,42,3116,'[{255,36160007,13403}]'),(3,2,42,2829,'[{255,36160007,13403}]'),(3,3,42,3690,'[{255,36160007,13403}]'),(4,1,42,3116,'[{255,36160007,15768}]'),(4,2,42,2829,'[{255,36160007,15768}]'),(4,3,42,3690,'[{255,36160007,15768}]'),(0,1,43,3208,'[{255,36160007,8879}]'),(0,2,43,2917,'[{255,36160007,8879}]'),(0,3,43,4200,'[{255,36160007,8879}]'),(1,1,43,3208,'[{255,36160007,10493}]'),(1,2,43,2917,'[{255,36160007,10493}]'),(1,3,43,4200,'[{255,36160007,10493}]'),(2,1,43,3208,'[{255,36160007,11300}]'),(2,2,43,2917,'[{255,36160007,11300}]'),(2,3,43,3780,'[{255,36160007,11300}]'),(3,1,43,3208,'[{255,36160007,13722}]'),(3,2,43,2917,'[{255,36160007,13722}]'),(3,3,43,3780,'[{255,36160007,13722}]'),(4,1,43,3208,'[{255,36160007,16143}]'),(4,2,43,2917,'[{255,36160007,16143}]'),(4,3,43,3780,'[{255,36160007,16143}]'),(0,1,44,3302,'[{255,36160007,9089}]'),(0,2,44,3007,'[{255,36160007,9089}]'),(0,3,44,4300,'[{255,36160007,9089}]'),(1,1,44,3302,'[{255,36160007,10742}]'),(1,2,44,3007,'[{255,36160007,10742}]'),(1,3,44,4300,'[{255,36160007,10742}]'),(2,1,44,3302,'[{255,36160007,11568}]'),(2,2,44,3007,'[{255,36160007,11568}]'),(2,3,44,3870,'[{255,36160007,11568}]'),(3,1,44,3302,'[{255,36160007,14047}]'),(3,2,44,3007,'[{255,36160007,14047}]'),(3,3,44,3870,'[{255,36160007,14047}]'),(4,1,44,3302,'[{255,36160007,16526}]'),(4,2,44,3007,'[{255,36160007,16526}]'),(4,3,44,3870,'[{255,36160007,16526}]'),(0,1,45,3396,'[{255,36160007,9304}]'),(0,2,45,3098,'[{255,36160007,9304}]'),(0,3,45,4400,'[{255,36160007,9304}]'),(1,1,45,3396,'[{255,36160007,10996}]'),(1,2,45,3098,'[{255,36160007,10996}]'),(1,3,45,4400,'[{255,36160007,10996}]'),(2,1,45,3396,'[{255,36160007,11842}]'),(2,2,45,3098,'[{255,36160007,11842}]'),(2,3,45,3960,'[{255,36160007,11842}]'),(3,1,45,3396,'[{255,36160007,14379}]'),(3,2,45,3098,'[{255,36160007,14379}]'),(3,3,45,3960,'[{255,36160007,14379}]'),(4,1,45,3396,'[{255,36160007,16917}]'),(4,2,45,3098,'[{255,36160007,16917}]'),(4,3,45,3960,'[{255,36160007,16917}]'),(0,1,46,3492,'[{255,36160007,9524}]'),(0,2,46,3190,'[{255,36160007,9524}]'),(0,3,46,4500,'[{255,36160007,9524}]'),(1,1,46,3492,'[{255,36160007,11255}]'),(1,2,46,3190,'[{255,36160007,11255}]'),(1,3,46,4500,'[{255,36160007,11255}]'),(2,1,46,3492,'[{255,36160007,12121}]'),(2,2,46,3190,'[{255,36160007,12121}]'),(2,3,46,4050,'[{255,36160007,12121}]'),(3,1,46,3492,'[{255,36160007,14719}]'),(3,2,46,3190,'[{255,36160007,14719}]'),(3,3,46,4050,'[{255,36160007,14719}]'),(4,1,46,3492,'[{255,36160007,17316}]'),(4,2,46,3190,'[{255,36160007,17316}]'),(4,3,46,4050,'[{255,36160007,17316}]'),(0,1,47,3588,'[{255,36160007,9748}]'),(0,2,47,3283,'[{255,36160007,9748}]'),(0,3,47,4600,'[{255,36160007,9748}]'),(1,1,47,3588,'[{255,36160007,11520}]'),(1,2,47,3283,'[{255,36160007,11520}]'),(1,3,47,4600,'[{255,36160007,11520}]'),(2,1,47,3588,'[{255,36160007,12406}]'),(2,2,47,3283,'[{255,36160007,12406}]'),(2,3,47,4140,'[{255,36160007,12406}]'),(3,1,47,3588,'[{255,36160007,15065}]'),(3,2,47,3283,'[{255,36160007,15065}]'),(3,3,47,4140,'[{255,36160007,15065}]'),(4,1,47,3588,'[{255,36160007,17723}]'),(4,2,47,3283,'[{255,36160007,17723}]'),(4,3,47,4140,'[{255,36160007,17723}]'),(0,1,48,3684,'[{255,36160007,9977}]'),(0,2,48,3376,'[{255,36160007,9977}]'),(0,3,48,4700,'[{255,36160007,9977}]'),(1,1,48,3684,'[{255,36160007,11791}]'),(1,2,48,3376,'[{255,36160007,11791}]'),(1,3,48,4700,'[{255,36160007,11791}]'),(2,1,48,3684,'[{255,36160007,12698}]'),(2,2,48,3376,'[{255,36160007,12698}]'),(2,3,48,4230,'[{255,36160007,12698}]'),(3,1,48,3684,'[{255,36160007,15419}]'),(3,2,48,3376,'[{255,36160007,15419}]'),(3,3,48,4230,'[{255,36160007,15419}]'),(4,1,48,3684,'[{255,36160007,18140}]'),(4,2,48,3376,'[{255,36160007,18140}]'),(4,3,48,4230,'[{255,36160007,18140}]'),(0,1,49,3782,'[{255,36160007,10211}]'),(0,2,49,3471,'[{255,36160007,10211}]'),(0,3,49,4800,'[{255,36160007,10211}]'),(1,1,49,3782,'[{255,36160007,12067}]'),(1,2,49,3471,'[{255,36160007,12067}]'),(1,3,49,4800,'[{255,36160007,12067}]'),(2,1,49,3782,'[{255,36160007,12996}]'),(2,2,49,3471,'[{255,36160007,12996}]'),(2,3,49,4320,'[{255,36160007,12996}]'),(3,1,49,3782,'[{255,36160007,15780}]'),(3,2,49,3471,'[{255,36160007,15780}]'),(3,3,49,4320,'[{255,36160007,15780}]'),(4,1,49,3782,'[{255,36160007,18565}]'),(4,2,49,3471,'[{255,36160007,18565}]'),(4,3,49,4320,'[{255,36160007,18565}]'),(0,1,50,3880,'[{255,36160007,10450}]'),(0,2,50,3567,'[{255,36160007,10450}]'),(0,3,50,4900,'[{255,36160007,10450}]'),(1,1,50,3880,'[{255,36160007,12350}]'),(1,2,50,3567,'[{255,36160007,12350}]'),(1,3,50,4900,'[{255,36160007,12350}]'),(2,1,50,3880,'[{255,36160007,13300}]'),(2,2,50,3567,'[{255,36160007,13300}]'),(2,3,50,4410,'[{255,36160007,13300}]'),(3,1,50,3880,'[{255,36160007,16150}]'),(3,2,50,3567,'[{255,36160007,16150}]'),(3,3,50,4410,'[{255,36160007,16150}]'),(4,1,50,3880,'[{255,36160007,19000}]'),(4,2,50,3567,'[{255,36160007,19000}]'),(4,3,50,4410,'[{255,36160007,19000}]'),(0,1,51,3980,'[{255,36160007,10694}]'),(0,2,51,3663,'[{255,36160007,10694}]'),(0,3,51,5000,'[{255,36160007,10694}]'),(1,1,51,3980,'[{255,36160007,12639}]'),(1,2,51,3663,'[{255,36160007,12639}]'),(1,3,51,5000,'[{255,36160007,12639}]'),(2,1,51,3980,'[{255,36160007,13611}]'),(2,2,51,3663,'[{255,36160007,13611}]'),(2,3,51,4500,'[{255,36160007,13611}]'),(3,1,51,3980,'[{255,36160007,16527}]'),(3,2,51,3663,'[{255,36160007,16527}]'),(3,3,51,4500,'[{255,36160007,16527}]'),(4,1,51,3980,'[{255,36160007,19444}]'),(4,2,51,3663,'[{255,36160007,19444}]'),(4,3,51,4500,'[{255,36160007,19444}]'),(0,1,52,4080,'[{255,36160007,10944}]'),(0,2,52,3761,'[{255,36160007,10944}]'),(0,3,52,5100,'[{255,36160007,10944}]'),(1,1,52,4080,'[{255,36160007,12934}]'),(1,2,52,3761,'[{255,36160007,12934}]'),(1,3,52,5100,'[{255,36160007,12934}]'),(2,1,52,4080,'[{255,36160007,13929}]'),(2,2,52,3761,'[{255,36160007,13929}]'),(2,3,52,4590,'[{255,36160007,13929}]'),(3,1,52,4080,'[{255,36160007,16914}]'),(3,2,52,3761,'[{255,36160007,16914}]'),(3,3,52,4590,'[{255,36160007,16914}]'),(4,1,52,4080,'[{255,36160007,19899}]'),(4,2,52,3761,'[{255,36160007,19899}]'),(4,3,52,4590,'[{255,36160007,19899}]'),(0,1,53,4180,'[{255,36160007,11200}]'),(0,2,53,3859,'[{255,36160007,11200}]'),(0,3,53,5200,'[{255,36160007,11200}]'),(1,1,53,4180,'[{255,36160007,13237}]'),(1,2,53,3859,'[{255,36160007,13237}]'),(1,3,53,5200,'[{255,36160007,13237}]'),(2,1,53,4180,'[{255,36160007,14255}]'),(2,2,53,3859,'[{255,36160007,14255}]'),(2,3,53,4680,'[{255,36160007,14255}]'),(3,1,53,4180,'[{255,36160007,17309}]'),(3,2,53,3859,'[{255,36160007,17309}]'),(3,3,53,4680,'[{255,36160007,17309}]'),(4,1,53,4180,'[{255,36160007,20364}]'),(4,2,53,3859,'[{255,36160007,20364}]'),(4,3,53,4680,'[{255,36160007,20364}]'),(0,1,54,4282,'[{255,36160007,11461}]'),(0,2,54,3959,'[{255,36160007,11461}]'),(0,3,54,5300,'[{255,36160007,11461}]'),(1,1,54,4282,'[{255,36160007,13545}]'),(1,2,54,3959,'[{255,36160007,13545}]'),(1,3,54,5300,'[{255,36160007,13545}]'),(2,1,54,4282,'[{255,36160007,14587}]'),(2,2,54,3959,'[{255,36160007,14587}]'),(2,3,54,4770,'[{255,36160007,14587}]'),(3,1,54,4282,'[{255,36160007,17713}]'),(3,2,54,3959,'[{255,36160007,17713}]'),(3,3,54,4770,'[{255,36160007,17713}]'),(4,1,54,4282,'[{255,36160007,20839}]'),(4,2,54,3959,'[{255,36160007,20839}]'),(4,3,54,4770,'[{255,36160007,20839}]'),(0,1,55,4384,'[{255,36160007,11729}]'),(0,2,55,4059,'[{255,36160007,11729}]'),(0,3,55,5400,'[{255,36160007,11729}]'),(1,1,55,4384,'[{255,36160007,13862}]'),(1,2,55,4059,'[{255,36160007,13862}]'),(1,3,55,5400,'[{255,36160007,13862}]'),(2,1,55,4384,'[{255,36160007,14928}]'),(2,2,55,4059,'[{255,36160007,14928}]'),(2,3,55,4860,'[{255,36160007,14928}]'),(3,1,55,4384,'[{255,36160007,18127}]'),(3,2,55,4059,'[{255,36160007,18127}]'),(3,3,55,4860,'[{255,36160007,18127}]'),(4,1,55,4384,'[{255,36160007,21326}]'),(4,2,55,4059,'[{255,36160007,21326}]'),(4,3,55,4860,'[{255,36160007,21326}]'),(0,1,56,4488,'[{255,36160007,12003}]'),(0,2,56,4160,'[{255,36160007,12003}]'),(0,3,56,5500,'[{255,36160007,12003}]'),(1,1,56,4488,'[{255,36160007,14186}]'),(1,2,56,4160,'[{255,36160007,14186}]'),(1,3,56,5500,'[{255,36160007,14186}]'),(2,1,56,4488,'[{255,36160007,15277}]'),(2,2,56,4160,'[{255,36160007,15277}]'),(2,3,56,4950,'[{255,36160007,15277}]'),(3,1,56,4488,'[{255,36160007,18550}]'),(3,2,56,4160,'[{255,36160007,18550}]'),(3,3,56,4950,'[{255,36160007,18550}]'),(4,1,56,4488,'[{255,36160007,21824}]'),(4,2,56,4160,'[{255,36160007,21824}]'),(4,3,56,4950,'[{255,36160007,21824}]'),(0,1,57,4592,'[{255,36160007,12283}]'),(0,2,57,4262,'[{255,36160007,12283}]'),(0,3,57,5600,'[{255,36160007,12283}]'),(1,1,57,4592,'[{255,36160007,14516}]'),(1,2,57,4262,'[{255,36160007,14516}]'),(1,3,57,5600,'[{255,36160007,14516}]'),(2,1,57,4592,'[{255,36160007,15633}]'),(2,2,57,4262,'[{255,36160007,15633}]'),(2,3,57,5040,'[{255,36160007,15633}]'),(3,1,57,4592,'[{255,36160007,18983}]'),(3,2,57,4262,'[{255,36160007,18983}]'),(3,3,57,5040,'[{255,36160007,18983}]'),(4,1,57,4592,'[{255,36160007,22333}]'),(4,2,57,4262,'[{255,36160007,22333}]'),(4,3,57,5040,'[{255,36160007,22333}]'),(0,1,58,4696,'[{255,36160007,12570}]'),(0,2,58,4366,'[{255,36160007,12570}]'),(0,3,58,5700,'[{255,36160007,12570}]'),(1,1,58,4696,'[{255,36160007,14856}]'),(1,2,58,4366,'[{255,36160007,14856}]'),(1,3,58,5700,'[{255,36160007,14856}]'),(2,1,58,4696,'[{255,36160007,15999}]'),(2,2,58,4366,'[{255,36160007,15999}]'),(2,3,58,5130,'[{255,36160007,15999}]'),(3,1,58,4696,'[{255,36160007,19427}]'),(3,2,58,4366,'[{255,36160007,19427}]'),(3,3,58,5130,'[{255,36160007,19427}]'),(4,1,58,4696,'[{255,36160007,22855}]'),(4,2,58,4366,'[{255,36160007,22855}]'),(4,3,58,5130,'[{255,36160007,22855}]'),(0,1,59,4802,'[{255,36160007,12865}]'),(0,2,59,4470,'[{255,36160007,12865}]'),(0,3,59,5800,'[{255,36160007,12865}]'),(1,1,59,4802,'[{255,36160007,15204}]'),(1,2,59,4470,'[{255,36160007,15204}]'),(1,3,59,5800,'[{255,36160007,15204}]'),(2,1,59,4802,'[{255,36160007,16373}]'),(2,2,59,4470,'[{255,36160007,16373}]'),(2,3,59,5220,'[{255,36160007,16373}]'),(3,1,59,4802,'[{255,36160007,19882}]'),(3,2,59,4470,'[{255,36160007,19882}]'),(3,3,59,5220,'[{255,36160007,19882}]'),(4,1,59,4802,'[{255,36160007,23390}]'),(4,2,59,4470,'[{255,36160007,23390}]'),(4,3,59,5220,'[{255,36160007,23390}]'),(0,1,60,4908,'[{255,36160007,13166}]'),(0,2,60,4575,'[{255,36160007,13166}]'),(0,3,60,5900,'[{255,36160007,13166}]'),(1,1,60,4908,'[{255,36160007,15560}]'),(1,2,60,4575,'[{255,36160007,15560}]'),(1,3,60,5900,'[{255,36160007,15560}]'),(2,1,60,4908,'[{255,36160007,16757}]'),(2,2,60,4575,'[{255,36160007,16757}]'),(2,3,60,5310,'[{255,36160007,16757}]'),(3,1,60,4908,'[{255,36160007,20347}]'),(3,2,60,4575,'[{255,36160007,20347}]'),(3,3,60,5310,'[{255,36160007,20347}]'),(4,1,60,4908,'[{255,36160007,23938}]'),(4,2,60,4575,'[{255,36160007,23938}]'),(4,3,60,5310,'[{255,36160007,23938}]'),(0,1,61,5016,'[{255,36160007,13475}]'),(0,2,61,4681,'[{255,36160007,13475}]'),(0,3,61,6000,'[{255,36160007,13475}]'),(1,1,61,5016,'[{255,36160007,15925}]'),(1,2,61,4681,'[{255,36160007,15925}]'),(1,3,61,6000,'[{255,36160007,15925}]'),(2,1,61,5016,'[{255,36160007,17150}]'),(2,2,61,4681,'[{255,36160007,17150}]'),(2,3,61,5400,'[{255,36160007,17150}]'),(3,1,61,5016,'[{255,36160007,20825}]'),(3,2,61,4681,'[{255,36160007,20825}]'),(3,3,61,5400,'[{255,36160007,20825}]'),(4,1,61,5016,'[{255,36160007,24500}]'),(4,2,61,4681,'[{255,36160007,24500}]'),(4,3,61,5400,'[{255,36160007,24500}]'),(0,1,62,5124,'[{255,36160007,13792}]'),(0,2,62,4788,'[{255,36160007,13792}]'),(0,3,62,6100,'[{255,36160007,13792}]'),(1,1,62,5124,'[{255,36160007,16299}]'),(1,2,62,4788,'[{255,36160007,16299}]'),(1,3,62,6100,'[{255,36160007,16299}]'),(2,1,62,5124,'[{255,36160007,17553}]'),(2,2,62,4788,'[{255,36160007,17553}]'),(2,3,62,5490,'[{255,36160007,17553}]'),(3,1,62,5124,'[{255,36160007,21315}]'),(3,2,62,4788,'[{255,36160007,21315}]'),(3,3,62,5490,'[{255,36160007,21315}]'),(4,1,62,5124,'[{255,36160007,25076}]'),(4,2,62,4788,'[{255,36160007,25076}]'),(4,3,62,5490,'[{255,36160007,25076}]'),(0,1,63,5232,'[{255,36160007,14117}]'),(0,2,63,4896,'[{255,36160007,14117}]'),(0,3,63,6200,'[{255,36160007,14117}]'),(1,1,63,5232,'[{255,36160007,16684}]'),(1,2,63,4896,'[{255,36160007,16684}]'),(1,3,63,6200,'[{255,36160007,16684}]'),(2,1,63,5232,'[{255,36160007,17967}]'),(2,2,63,4896,'[{255,36160007,17967}]'),(2,3,63,5580,'[{255,36160007,17967}]'),(3,1,63,5232,'[{255,36160007,21817}]'),(3,2,63,4896,'[{255,36160007,21817}]'),(3,3,63,5580,'[{255,36160007,21817}]'),(4,1,63,5232,'[{255,36160007,25667}]'),(4,2,63,4896,'[{255,36160007,25667}]'),(4,3,63,5580,'[{255,36160007,25667}]'),(0,1,64,5342,'[{255,36160007,14450}]'),(0,2,64,5005,'[{255,36160007,14450}]'),(0,3,64,6300,'[{255,36160007,14450}]'),(1,1,64,5342,'[{255,36160007,17077}]'),(1,2,64,5005,'[{255,36160007,17077}]'),(1,3,64,6300,'[{255,36160007,17077}]'),(2,1,64,5342,'[{255,36160007,18391}]'),(2,2,64,5005,'[{255,36160007,18391}]'),(2,3,64,5670,'[{255,36160007,18391}]'),(3,1,64,5342,'[{255,36160007,22332}]'),(3,2,64,5005,'[{255,36160007,22332}]'),(3,3,64,5670,'[{255,36160007,22332}]'),(4,1,64,5342,'[{255,36160007,26273}]'),(4,2,64,5005,'[{255,36160007,26273}]'),(4,3,64,5670,'[{255,36160007,26273}]'),(0,1,65,5452,'[{255,36160007,14792}]'),(0,2,65,5115,'[{255,36160007,14792}]'),(0,3,65,6400,'[{255,36160007,14792}]'),(1,1,65,5452,'[{255,36160007,17482}]'),(1,2,65,5115,'[{255,36160007,17482}]'),(1,3,65,6400,'[{255,36160007,17482}]'),(2,1,65,5452,'[{255,36160007,18827}]'),(2,2,65,5115,'[{255,36160007,18827}]'),(2,3,65,5760,'[{255,36160007,18827}]'),(3,1,65,5452,'[{255,36160007,22861}]'),(3,2,65,5115,'[{255,36160007,22861}]'),(3,3,65,5760,'[{255,36160007,22861}]'),(4,1,65,5452,'[{255,36160007,26895}]'),(4,2,65,5115,'[{255,36160007,26895}]'),(4,3,65,5760,'[{255,36160007,26895}]'),(0,1,66,5564,'[{255,36160007,15143}]'),(0,2,66,5225,'[{255,36160007,15143}]'),(0,3,66,6500,'[{255,36160007,15143}]'),(1,1,66,5564,'[{255,36160007,17896}]'),(1,2,66,5225,'[{255,36160007,17896}]'),(1,3,66,6500,'[{255,36160007,17896}]'),(2,1,66,5564,'[{255,36160007,19273}]'),(2,2,66,5225,'[{255,36160007,19273}]'),(2,3,66,5850,'[{255,36160007,19273}]'),(3,1,66,5564,'[{255,36160007,23403}]'),(3,2,66,5225,'[{255,36160007,23403}]'),(3,3,66,5850,'[{255,36160007,23403}]'),(4,1,66,5564,'[{255,36160007,27533}]'),(4,2,66,5225,'[{255,36160007,27533}]'),(4,3,66,5850,'[{255,36160007,27533}]'),(0,1,67,5676,'[{255,36160007,15504}]'),(0,2,67,5337,'[{255,36160007,15504}]'),(0,3,67,6600,'[{255,36160007,15504}]'),(1,1,67,5676,'[{255,36160007,18323}]'),(1,2,67,5337,'[{255,36160007,18323}]'),(1,3,67,6600,'[{255,36160007,18323}]'),(2,1,67,5676,'[{255,36160007,19732}]'),(2,2,67,5337,'[{255,36160007,19732}]'),(2,3,67,5940,'[{255,36160007,19732}]'),(3,1,67,5676,'[{255,36160007,23961}]'),(3,2,67,5337,'[{255,36160007,23961}]'),(3,3,67,5940,'[{255,36160007,23961}]'),(4,1,67,5676,'[{255,36160007,28189}]'),(4,2,67,5337,'[{255,36160007,28189}]'),(4,3,67,5940,'[{255,36160007,28189}]'),(0,1,68,5788,'[{255,36160007,15875}]'),(0,2,68,5450,'[{255,36160007,15875}]'),(0,3,68,6700,'[{255,36160007,15875}]'),(1,1,68,5788,'[{255,36160007,18761}]'),(1,2,68,5450,'[{255,36160007,18761}]'),(1,3,68,6700,'[{255,36160007,18761}]'),(2,1,68,5788,'[{255,36160007,20204}]'),(2,2,68,5450,'[{255,36160007,20204}]'),(2,3,68,6030,'[{255,36160007,20204}]'),(3,1,68,5788,'[{255,36160007,24534}]'),(3,2,68,5450,'[{255,36160007,24534}]'),(3,3,68,6030,'[{255,36160007,24534}]'),(4,1,68,5788,'[{255,36160007,28863}]'),(4,2,68,5450,'[{255,36160007,28863}]'),(4,3,68,6030,'[{255,36160007,28863}]'),(0,1,69,5902,'[{255,36160007,16256}]'),(0,2,69,5564,'[{255,36160007,16256}]'),(0,3,69,6800,'[{255,36160007,16256}]'),(1,1,69,5902,'[{255,36160007,19211}]'),(1,2,69,5564,'[{255,36160007,19211}]'),(1,3,69,6800,'[{255,36160007,19211}]'),(2,1,69,5902,'[{255,36160007,20689}]'),(2,2,69,5564,'[{255,36160007,20689}]'),(2,3,69,6120,'[{255,36160007,20689}]'),(3,1,69,5902,'[{255,36160007,25123}]'),(3,2,69,5564,'[{255,36160007,25123}]'),(3,3,69,6120,'[{255,36160007,25123}]'),(4,1,69,5902,'[{255,36160007,29556}]'),(4,2,69,5564,'[{255,36160007,29556}]'),(4,3,69,6120,'[{255,36160007,29556}]'),(0,1,70,6016,'[{255,36160007,16647}]'),(0,2,70,5678,'[{255,36160007,16647}]'),(0,3,70,6900,'[{255,36160007,16647}]'),(1,1,70,6016,'[{255,36160007,19674}]'),(1,2,70,5678,'[{255,36160007,19674}]'),(1,3,70,6900,'[{255,36160007,19674}]'),(2,1,70,6016,'[{255,36160007,21188}]'),(2,2,70,5678,'[{255,36160007,21188}]'),(2,3,70,6210,'[{255,36160007,21188}]'),(3,1,70,6016,'[{255,36160007,25728}]'),(3,2,70,5678,'[{255,36160007,25728}]'),(3,3,70,6210,'[{255,36160007,25728}]'),(4,1,70,6016,'[{255,36160007,30268}]'),(4,2,70,5678,'[{255,36160007,30268}]'),(4,3,70,6210,'[{255,36160007,30268}]'),(0,1,71,6132,'[{255,36160007,17050}]'),(0,2,71,5794,'[{255,36160007,17050}]'),(0,3,71,7000,'[{255,36160007,17050}]'),(1,1,71,6132,'[{255,36160007,20150}]'),(1,2,71,5794,'[{255,36160007,20150}]'),(1,3,71,7000,'[{255,36160007,20150}]'),(2,1,71,6132,'[{255,36160007,21700}]'),(2,2,71,5794,'[{255,36160007,21700}]'),(2,3,71,6300,'[{255,36160007,21700}]'),(3,1,71,6132,'[{255,36160007,26350}]'),(3,2,71,5794,'[{255,36160007,26350}]'),(3,3,71,6300,'[{255,36160007,26350}]'),(4,1,71,6132,'[{255,36160007,31000}]'),(4,2,71,5794,'[{255,36160007,31000}]'),(4,3,71,6300,'[{255,36160007,31000}]'),(0,1,72,6248,'[{255,36160007,17465}]'),(0,2,72,5910,'[{255,36160007,17465}]'),(0,3,72,7100,'[{255,36160007,17465}]'),(1,1,72,6248,'[{255,36160007,20640}]'),(1,2,72,5910,'[{255,36160007,20640}]'),(1,3,72,7100,'[{255,36160007,20640}]'),(2,1,72,6248,'[{255,36160007,22228}]'),(2,2,72,5910,'[{255,36160007,22228}]'),(2,3,72,6390,'[{255,36160007,22228}]'),(3,1,72,6248,'[{255,36160007,26991}]'),(3,2,72,5910,'[{255,36160007,26991}]'),(3,3,72,6390,'[{255,36160007,26991}]'),(4,1,72,6248,'[{255,36160007,31754}]'),(4,2,72,5910,'[{255,36160007,31754}]'),(4,3,72,6390,'[{255,36160007,31754}]'),(0,1,73,6364,'[{255,36160007,17891}]'),(0,2,73,6028,'[{255,36160007,17891}]'),(0,3,73,7200,'[{255,36160007,17891}]'),(1,1,73,6364,'[{255,36160007,21144}]'),(1,2,73,6028,'[{255,36160007,21144}]'),(1,3,73,7200,'[{255,36160007,21144}]'),(2,1,73,6364,'[{255,36160007,22770}]'),(2,2,73,6028,'[{255,36160007,22770}]'),(2,3,73,6480,'[{255,36160007,22770}]'),(3,1,73,6364,'[{255,36160007,27650}]'),(3,2,73,6028,'[{255,36160007,27650}]'),(3,3,73,6480,'[{255,36160007,27650}]'),(4,1,73,6364,'[{255,36160007,32529}]'),(4,2,73,6028,'[{255,36160007,32529}]'),(4,3,73,6480,'[{255,36160007,32529}]'),(0,1,74,6482,'[{255,36160007,18330}]'),(0,2,74,6146,'[{255,36160007,18330}]'),(0,3,74,7300,'[{255,36160007,18330}]'),(1,1,74,6482,'[{255,36160007,21663}]'),(1,2,74,6146,'[{255,36160007,21663}]'),(1,3,74,7300,'[{255,36160007,21663}]'),(2,1,74,6482,'[{255,36160007,23330}]'),(2,2,74,6146,'[{255,36160007,23330}]'),(2,3,74,6570,'[{255,36160007,23330}]'),(3,1,74,6482,'[{255,36160007,28329}]'),(3,2,74,6146,'[{255,36160007,28329}]'),(3,3,74,6570,'[{255,36160007,28329}]'),(4,1,74,6482,'[{255,36160007,33328}]'),(4,2,74,6146,'[{255,36160007,33328}]'),(4,3,74,6570,'[{255,36160007,33328}]'),(0,1,75,6600,'[{255,36160007,18784}]'),(0,2,75,6265,'[{255,36160007,18784}]'),(0,3,75,7400,'[{255,36160007,18784}]'),(1,1,75,6600,'[{255,36160007,22199}]'),(1,2,75,6265,'[{255,36160007,22199}]'),(1,3,75,7400,'[{255,36160007,22199}]'),(2,1,75,6600,'[{255,36160007,23906}]'),(2,2,75,6265,'[{255,36160007,23906}]'),(2,3,75,6660,'[{255,36160007,23906}]'),(3,1,75,6600,'[{255,36160007,29029}]'),(3,2,75,6265,'[{255,36160007,29029}]'),(3,3,75,6660,'[{255,36160007,29029}]'),(4,1,75,6600,'[{255,36160007,34152}]'),(4,2,75,6265,'[{255,36160007,34152}]'),(4,3,75,6660,'[{255,36160007,34152}]'),(0,1,76,6720,'[{255,36160007,19152}]'),(0,2,76,6386,'[{255,36160007,19152}]'),(0,3,76,7500,'[{255,36160007,19152}]'),(1,1,76,6720,'[{255,36160007,22634}]'),(1,2,76,6386,'[{255,36160007,22634}]'),(1,3,76,7500,'[{255,36160007,22634}]'),(2,1,76,6720,'[{255,36160007,24375}]'),(2,2,76,6386,'[{255,36160007,24375}]'),(2,3,76,6750,'[{255,36160007,24375}]'),(3,1,76,6720,'[{255,36160007,29598}]'),(3,2,76,6386,'[{255,36160007,29598}]'),(3,3,76,6750,'[{255,36160007,29598}]'),(4,1,76,6720,'[{255,36160007,34821}]'),(4,2,76,6386,'[{255,36160007,34821}]'),(4,3,76,6750,'[{255,36160007,34821}]'),(0,1,77,6840,'[{255,36160007,19528}]'),(0,2,77,6507,'[{255,36160007,19528}]'),(0,3,77,7600,'[{255,36160007,19528}]'),(1,1,77,6840,'[{255,36160007,23078}]'),(1,2,77,6507,'[{255,36160007,23078}]'),(1,3,77,7600,'[{255,36160007,23078}]'),(2,1,77,6840,'[{255,36160007,24854}]'),(2,2,77,6507,'[{255,36160007,24854}]'),(2,3,77,6840,'[{255,36160007,24854}]'),(3,1,77,6840,'[{255,36160007,30179}]'),(3,2,77,6507,'[{255,36160007,30179}]'),(3,3,77,6840,'[{255,36160007,30179}]'),(4,1,77,6840,'[{255,36160007,35505}]'),(4,2,77,6507,'[{255,36160007,35505}]'),(4,3,77,6840,'[{255,36160007,35505}]'),(0,1,78,6960,'[{255,36160007,19912}]'),(0,2,78,6629,'[{255,36160007,19912}]'),(0,3,78,7700,'[{255,36160007,19912}]'),(1,1,78,6960,'[{255,36160007,23532}]'),(1,2,78,6629,'[{255,36160007,23532}]'),(1,3,78,7700,'[{255,36160007,23532}]'),(2,1,78,6960,'[{255,36160007,25342}]'),(2,2,78,6629,'[{255,36160007,25342}]'),(2,3,78,6930,'[{255,36160007,25342}]'),(3,1,78,6960,'[{255,36160007,30773}]'),(3,2,78,6629,'[{255,36160007,30773}]'),(3,3,78,6930,'[{255,36160007,30773}]'),(4,1,78,6960,'[{255,36160007,36203}]'),(4,2,78,6629,'[{255,36160007,36203}]'),(4,3,78,6930,'[{255,36160007,36203}]'),(0,1,79,7082,'[{255,36160007,20304}]'),(0,2,79,6752,'[{255,36160007,20304}]'),(0,3,79,7800,'[{255,36160007,20304}]'),(1,1,79,7082,'[{255,36160007,23995}]'),(1,2,79,6752,'[{255,36160007,23995}]'),(1,3,79,7800,'[{255,36160007,23995}]'),(2,1,79,7082,'[{255,36160007,25841}]'),(2,2,79,6752,'[{255,36160007,25841}]'),(2,3,79,7020,'[{255,36160007,25841}]'),(3,1,79,7082,'[{255,36160007,31379}]'),(3,2,79,6752,'[{255,36160007,31379}]'),(3,3,79,7020,'[{255,36160007,31379}]'),(4,1,79,7082,'[{255,36160007,36916}]'),(4,2,79,6752,'[{255,36160007,36916}]'),(4,3,79,7020,'[{255,36160007,36916}]'),(0,1,80,7204,'[{255,36160007,20704}]'),(0,2,80,6876,'[{255,36160007,20704}]'),(0,3,80,7900,'[{255,36160007,20704}]'),(1,1,80,7204,'[{255,36160007,24469}]'),(1,2,80,6876,'[{255,36160007,24469}]'),(1,3,80,7900,'[{255,36160007,24469}]'),(2,1,80,7204,'[{255,36160007,26351}]'),(2,2,80,6876,'[{255,36160007,26351}]'),(2,3,80,7110,'[{255,36160007,26351}]'),(3,1,80,7204,'[{255,36160007,31997}]'),(3,2,80,6876,'[{255,36160007,31997}]'),(3,3,80,7110,'[{255,36160007,31997}]'),(4,1,80,7204,'[{255,36160007,37644}]'),(4,2,80,6876,'[{255,36160007,37644}]'),(4,3,80,7110,'[{255,36160007,37644}]'),(0,1,81,7328,'[{255,36160007,21113}]'),(0,2,81,7001,'[{255,36160007,21113}]'),(0,3,81,8000,'[{255,36160007,21113}]'),(1,1,81,7328,'[{255,36160007,24952}]'),(1,2,81,7001,'[{255,36160007,24952}]'),(1,3,81,8000,'[{255,36160007,24952}]'),(2,1,81,7328,'[{255,36160007,26871}]'),(2,2,81,7001,'[{255,36160007,26871}]'),(2,3,81,7200,'[{255,36160007,26871}]'),(3,1,81,7328,'[{255,36160007,32629}]'),(3,2,81,7001,'[{255,36160007,32629}]'),(3,3,81,7200,'[{255,36160007,32629}]'),(4,1,81,7328,'[{255,36160007,38387}]'),(4,2,81,7001,'[{255,36160007,38387}]'),(4,3,81,7200,'[{255,36160007,38387}]'),(0,1,82,7452,'[{255,36160007,21531}]'),(0,2,82,7127,'[{255,36160007,21531}]'),(0,3,82,8100,'[{255,36160007,21531}]'),(1,1,82,7452,'[{255,36160007,25446}]'),(1,2,82,7127,'[{255,36160007,25446}]'),(1,3,82,8100,'[{255,36160007,25446}]'),(2,1,82,7452,'[{255,36160007,27403}]'),(2,2,82,7127,'[{255,36160007,27403}]'),(2,3,82,7290,'[{255,36160007,27403}]'),(3,1,82,7452,'[{255,36160007,33275}]'),(3,2,82,7127,'[{255,36160007,33275}]'),(3,3,82,7290,'[{255,36160007,33275}]'),(4,1,82,7452,'[{255,36160007,39147}]'),(4,2,82,7127,'[{255,36160007,39147}]'),(4,3,82,7290,'[{255,36160007,39147}]'),(0,1,83,7576,'[{255,36160007,21958}]'),(0,2,83,7254,'[{255,36160007,21958}]'),(0,3,83,8200,'[{255,36160007,21958}]'),(1,1,83,7576,'[{255,36160007,25950}]'),(1,2,83,7254,'[{255,36160007,25950}]'),(1,3,83,8200,'[{255,36160007,25950}]'),(2,1,83,7576,'[{255,36160007,27946}]'),(2,2,83,7254,'[{255,36160007,27946}]'),(2,3,83,7380,'[{255,36160007,27946}]'),(3,1,83,7576,'[{255,36160007,33935}]'),(3,2,83,7254,'[{255,36160007,33935}]'),(3,3,83,7380,'[{255,36160007,33935}]'),(4,1,83,7576,'[{255,36160007,39923}]'),(4,2,83,7254,'[{255,36160007,39923}]'),(4,3,83,7380,'[{255,36160007,39923}]'),(0,1,84,7702,'[{255,36160007,22394}]'),(0,2,84,7382,'[{255,36160007,22394}]'),(0,3,84,8300,'[{255,36160007,22394}]'),(1,1,84,7702,'[{255,36160007,26466}]'),(1,2,84,7382,'[{255,36160007,26466}]'),(1,3,84,8300,'[{255,36160007,26466}]'),(2,1,84,7702,'[{255,36160007,28502}]'),(2,2,84,7382,'[{255,36160007,28502}]'),(2,3,84,7470,'[{255,36160007,28502}]'),(3,1,84,7702,'[{255,36160007,34609}]'),(3,2,84,7382,'[{255,36160007,34609}]'),(3,3,84,7470,'[{255,36160007,34609}]'),(4,1,84,7702,'[{255,36160007,40717}]'),(4,2,84,7382,'[{255,36160007,40717}]'),(4,3,84,7470,'[{255,36160007,40717}]'),(0,1,85,7828,'[{255,36160007,22840}]'),(0,2,85,7511,'[{255,36160007,22840}]'),(0,3,85,8400,'[{255,36160007,22840}]'),(1,1,85,7828,'[{255,36160007,26993}]'),(1,2,85,7511,'[{255,36160007,26993}]'),(1,3,85,8400,'[{255,36160007,26993}]'),(2,1,85,7828,'[{255,36160007,29070}]'),(2,2,85,7511,'[{255,36160007,29070}]'),(2,3,85,7560,'[{255,36160007,29070}]'),(3,1,85,7828,'[{255,36160007,35299}]'),(3,2,85,7511,'[{255,36160007,35299}]'),(3,3,85,7560,'[{255,36160007,35299}]'),(4,1,85,7828,'[{255,36160007,41528}]'),(4,2,85,7511,'[{255,36160007,41528}]'),(4,3,85,7560,'[{255,36160007,41528}]'),(0,1,86,7956,'[{255,36160007,23297}]'),(0,2,86,7641,'[{255,36160007,23297}]'),(0,3,86,8500,'[{255,36160007,23297}]'),(1,1,86,7956,'[{255,36160007,27533}]'),(1,2,86,7641,'[{255,36160007,27533}]'),(1,3,86,8500,'[{255,36160007,27533}]'),(2,1,86,7956,'[{255,36160007,29651}]'),(2,2,86,7641,'[{255,36160007,29651}]'),(2,3,86,7650,'[{255,36160007,29651}]'),(3,1,86,7956,'[{255,36160007,36004}]'),(3,2,86,7641,'[{255,36160007,36004}]'),(3,3,86,7650,'[{255,36160007,36004}]'),(4,1,86,7956,'[{255,36160007,42358}]'),(4,2,86,7641,'[{255,36160007,42358}]'),(4,3,86,7650,'[{255,36160007,42358}]'),(0,1,87,8084,'[{255,36160007,23764}]'),(0,2,87,7772,'[{255,36160007,23764}]'),(0,3,87,8600,'[{255,36160007,23764}]'),(1,1,87,8084,'[{255,36160007,28085}]'),(1,2,87,7772,'[{255,36160007,28085}]'),(1,3,87,8600,'[{255,36160007,28085}]'),(2,1,87,8084,'[{255,36160007,30245}]'),(2,2,87,7772,'[{255,36160007,30245}]'),(2,3,87,7740,'[{255,36160007,30245}]'),(3,1,87,8084,'[{255,36160007,36726}]'),(3,2,87,7772,'[{255,36160007,36726}]'),(3,3,87,7740,'[{255,36160007,36726}]'),(4,1,87,8084,'[{255,36160007,43207}]'),(4,2,87,7772,'[{255,36160007,43207}]'),(4,3,87,7740,'[{255,36160007,43207}]'),(0,1,88,8212,'[{255,36160007,24242}]'),(0,2,88,7903,'[{255,36160007,24242}]'),(0,3,88,8700,'[{255,36160007,24242}]'),(1,1,88,8212,'[{255,36160007,28649}]'),(1,2,88,7903,'[{255,36160007,28649}]'),(1,3,88,8700,'[{255,36160007,28649}]'),(2,1,88,8212,'[{255,36160007,30853}]'),(2,2,88,7903,'[{255,36160007,30853}]'),(2,3,88,7830,'[{255,36160007,30853}]'),(3,1,88,8212,'[{255,36160007,37465}]'),(3,2,88,7903,'[{255,36160007,37465}]'),(3,3,88,7830,'[{255,36160007,37465}]'),(4,1,88,8212,'[{255,36160007,44076}]'),(4,2,88,7903,'[{255,36160007,44076}]'),(4,3,88,7830,'[{255,36160007,44076}]'),(0,1,89,8342,'[{255,36160007,24731}]'),(0,2,89,8036,'[{255,36160007,24731}]'),(0,3,89,8800,'[{255,36160007,24731}]'),(1,1,89,8342,'[{255,36160007,29227}]'),(1,2,89,8036,'[{255,36160007,29227}]'),(1,3,89,8800,'[{255,36160007,29227}]'),(2,1,89,8342,'[{255,36160007,31476}]'),(2,2,89,8036,'[{255,36160007,31476}]'),(2,3,89,7920,'[{255,36160007,31476}]'),(3,1,89,8342,'[{255,36160007,38220}]'),(3,2,89,8036,'[{255,36160007,38220}]'),(3,3,89,7920,'[{255,36160007,38220}]'),(4,1,89,8342,'[{255,36160007,44965}]'),(4,2,89,8036,'[{255,36160007,44965}]'),(4,3,89,7920,'[{255,36160007,44965}]'),(0,1,90,8472,'[{255,36160007,25231}]'),(0,2,90,8170,'[{255,36160007,25231}]'),(0,3,90,8900,'[{255,36160007,25231}]'),(1,1,90,8472,'[{255,36160007,29819}]'),(1,2,90,8170,'[{255,36160007,29819}]'),(1,3,90,8900,'[{255,36160007,29819}]'),(2,1,90,8472,'[{255,36160007,32113}]'),(2,2,90,8170,'[{255,36160007,32113}]'),(2,3,90,8010,'[{255,36160007,32113}]'),(3,1,90,8472,'[{255,36160007,38994}]'),(3,2,90,8170,'[{255,36160007,38994}]'),(3,3,90,8010,'[{255,36160007,38994}]'),(4,1,90,8472,'[{255,36160007,45875}]'),(4,2,90,8170,'[{255,36160007,45875}]'),(4,3,90,8010,'[{255,36160007,45875}]'),(0,1,91,8604,'[{255,36160007,25744}]'),(0,2,91,8304,'[{255,36160007,25744}]'),(0,3,91,9000,'[{255,36160007,25744}]'),(1,1,91,8604,'[{255,36160007,30425}]'),(1,2,91,8304,'[{255,36160007,30425}]'),(1,3,91,9000,'[{255,36160007,30425}]'),(2,1,91,8604,'[{255,36160007,32765}]'),(2,2,91,8304,'[{255,36160007,32765}]'),(2,3,91,8100,'[{255,36160007,32765}]'),(3,1,91,8604,'[{255,36160007,39786}]'),(3,2,91,8304,'[{255,36160007,39786}]'),(3,3,91,8100,'[{255,36160007,39786}]'),(4,1,91,8604,'[{255,36160007,46807}]'),(4,2,91,8304,'[{255,36160007,46807}]'),(4,3,91,8100,'[{255,36160007,46807}]'),(0,1,92,8736,'[{255,36160007,26269}]'),(0,2,92,8440,'[{255,36160007,26269}]'),(0,3,92,9100,'[{255,36160007,26269}]'),(1,1,92,8736,'[{255,36160007,31045}]'),(1,2,92,8440,'[{255,36160007,31045}]'),(1,3,92,9100,'[{255,36160007,31045}]'),(2,1,92,8736,'[{255,36160007,33433}]'),(2,2,92,8440,'[{255,36160007,33433}]'),(2,3,92,8190,'[{255,36160007,33433}]'),(3,1,92,8736,'[{255,36160007,40598}]'),(3,2,92,8440,'[{255,36160007,40598}]'),(3,3,92,8190,'[{255,36160007,40598}]'),(4,1,92,8736,'[{255,36160007,47762}]'),(4,2,92,8440,'[{255,36160007,47762}]'),(4,3,92,8190,'[{255,36160007,47762}]'),(0,1,93,8868,'[{255,36160007,26808}]'),(0,2,93,8576,'[{255,36160007,26808}]'),(0,3,93,9200,'[{255,36160007,26808}]'),(1,1,93,8868,'[{255,36160007,31682}]'),(1,2,93,8576,'[{255,36160007,31682}]'),(1,3,93,9200,'[{255,36160007,31682}]'),(2,1,93,8868,'[{255,36160007,34119}]'),(2,2,93,8576,'[{255,36160007,34119}]'),(2,3,93,8280,'[{255,36160007,34119}]'),(3,1,93,8868,'[{255,36160007,41430}]'),(3,2,93,8576,'[{255,36160007,41430}]'),(3,3,93,8280,'[{255,36160007,41430}]'),(4,1,93,8868,'[{255,36160007,48741}]'),(4,2,93,8576,'[{255,36160007,48741}]'),(4,3,93,8280,'[{255,36160007,48741}]'),(0,1,94,9002,'[{255,36160007,27359}]'),(0,2,94,8714,'[{255,36160007,27359}]'),(0,3,94,9300,'[{255,36160007,27359}]'),(1,1,94,9002,'[{255,36160007,32334}]'),(1,2,94,8714,'[{255,36160007,32334}]'),(1,3,94,9300,'[{255,36160007,32334}]'),(2,1,94,9002,'[{255,36160007,34821}]'),(2,2,94,8714,'[{255,36160007,34821}]'),(2,3,94,8370,'[{255,36160007,34821}]'),(3,1,94,9002,'[{255,36160007,42282}]'),(3,2,94,8714,'[{255,36160007,42282}]'),(3,3,94,8370,'[{255,36160007,42282}]'),(4,1,94,9002,'[{255,36160007,49744}]'),(4,2,94,8714,'[{255,36160007,49744}]'),(4,3,94,8370,'[{255,36160007,49744}]'),(0,1,95,9136,'[{255,36160007,27925}]'),(0,2,95,8852,'[{255,36160007,27925}]'),(0,3,95,9400,'[{255,36160007,27925}]'),(1,1,95,9136,'[{255,36160007,33002}]'),(1,2,95,8852,'[{255,36160007,33002}]'),(1,3,95,9400,'[{255,36160007,33002}]'),(2,1,95,9136,'[{255,36160007,35540}]'),(2,2,95,8852,'[{255,36160007,35540}]'),(2,3,95,8460,'[{255,36160007,35540}]'),(3,1,95,9136,'[{255,36160007,43156}]'),(3,2,95,8852,'[{255,36160007,43156}]'),(3,3,95,8460,'[{255,36160007,43156}]'),(4,1,95,9136,'[{255,36160007,50772}]'),(4,2,95,8852,'[{255,36160007,50772}]'),(4,3,95,8460,'[{255,36160007,50772}]'),(0,1,96,9272,'[{255,36160007,28505}]'),(0,2,96,8991,'[{255,36160007,28505}]'),(0,3,96,9500,'[{255,36160007,28505}]'),(1,1,96,9272,'[{255,36160007,33688}]'),(1,2,96,8991,'[{255,36160007,33688}]'),(1,3,96,9500,'[{255,36160007,33688}]'),(2,1,96,9272,'[{255,36160007,36279}]'),(2,2,96,8991,'[{255,36160007,36279}]'),(2,3,96,8550,'[{255,36160007,36279}]'),(3,1,96,9272,'[{255,36160007,44053}]'),(3,2,96,8991,'[{255,36160007,44053}]'),(3,3,96,8550,'[{255,36160007,44053}]'),(4,1,96,9272,'[{255,36160007,51827}]'),(4,2,96,8991,'[{255,36160007,51827}]'),(4,3,96,8550,'[{255,36160007,51827}]'),(0,1,97,9408,'[{255,36160007,29100}]'),(0,2,97,9131,'[{255,36160007,29100}]'),(0,3,97,9600,'[{255,36160007,29100}]'),(1,1,97,9408,'[{255,36160007,34391}]'),(1,2,97,9131,'[{255,36160007,34391}]'),(1,3,97,9600,'[{255,36160007,34391}]'),(2,1,97,9408,'[{255,36160007,37036}]'),(2,2,97,9131,'[{255,36160007,37036}]'),(2,3,97,8640,'[{255,36160007,37036}]'),(3,1,97,9408,'[{255,36160007,44973}]'),(3,2,97,9131,'[{255,36160007,44973}]'),(3,3,97,8640,'[{255,36160007,44973}]'),(4,1,97,9408,'[{255,36160007,52909}]'),(4,2,97,9131,'[{255,36160007,52909}]'),(4,3,97,8640,'[{255,36160007,52909}]'),(0,1,98,9544,'[{255,36160007,29711}]'),(0,2,98,9273,'[{255,36160007,29711}]'),(0,3,98,9700,'[{255,36160007,29711}]'),(1,1,98,9544,'[{255,36160007,35113}]'),(1,2,98,9273,'[{255,36160007,35113}]'),(1,3,98,9700,'[{255,36160007,35113}]'),(2,1,98,9544,'[{255,36160007,37814}]'),(2,2,98,9273,'[{255,36160007,37814}]'),(2,3,98,8730,'[{255,36160007,37814}]'),(3,1,98,9544,'[{255,36160007,45917}]'),(3,2,98,9273,'[{255,36160007,45917}]'),(3,3,98,8730,'[{255,36160007,45917}]'),(4,1,98,9544,'[{255,36160007,54020}]'),(4,2,98,9273,'[{255,36160007,54020}]'),(4,3,98,8730,'[{255,36160007,54020}]'),(0,1,99,9682,'[{255,36160007,30338}]'),(0,2,99,9415,'[{255,36160007,30338}]'),(0,3,99,9800,'[{255,36160007,30338}]'),(1,1,99,9682,'[{255,36160007,35854}]'),(1,2,99,9415,'[{255,36160007,35854}]'),(1,3,99,9800,'[{255,36160007,35854}]'),(2,1,99,9682,'[{255,36160007,38612}]'),(2,2,99,9415,'[{255,36160007,38612}]'),(2,3,99,8820,'[{255,36160007,38612}]'),(3,1,99,9682,'[{255,36160007,46886}]'),(3,2,99,9415,'[{255,36160007,46886}]'),(3,3,99,8820,'[{255,36160007,46886}]'),(4,1,99,9682,'[{255,36160007,55160}]'),(4,2,99,9415,'[{255,36160007,55160}]'),(4,3,99,8820,'[{255,36160007,55160}]'),(0,1,100,9820,'[{255,36160007,0}]'),(0,2,100,9558,'[{255,36160007,0}]'),(0,3,100,9900,'[{255,36160007,0}]'),(1,1,100,9820,'[{255,36160007,0}]'),(1,2,100,9558,'[{255,36160007,0}]'),(1,3,100,9900,'[{255,36160007,0}]'),(2,1,100,9820,'[{255,36160007,0}]'),(2,2,100,9558,'[{255,36160007,0}]'),(2,3,100,8910,'[{255,36160007,0}]'),(3,1,100,9820,'[{255,36160007,0}]'),(3,2,100,9558,'[{255,36160007,0}]'),(3,3,100,8910,'[{255,36160007,0}]'),(4,1,100,9820,'[{255,36160007,0}]'),(4,2,100,9558,'[{255,36160007,0}]'),(4,3,100,8910,'[{255,36160007,0}]');
/*!40000 ALTER TABLE `base_common_seal_soul_lv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_compose_menu`
--

DROP TABLE IF EXISTS `base_compose_menu`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_compose_menu` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '菜单id',
  `open_condition` varchar(255) NOT NULL DEFAULT '[]' COMMENT '开启条件',
  `is_bottom` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '有无子菜单 0:没有、1:有',
  `list` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '子菜单id列表',
  `module_id` smallint(5) unsigned NOT NULL DEFAULT '150' COMMENT '功能id',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='合成菜单';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_compose_menu`
--

LOCK TABLES `base_compose_menu` WRITE;
/*!40000 ALTER TABLE `base_compose_menu` DISABLE KEYS */;
INSERT INTO `base_compose_menu` VALUES (10000000,'[{lv,110}]',1,'[11000000,12000000,13000000,14000000,15000000,16000000,17000000,18000000,19000000,19100000,19200000]',150),(11000000,'[{lv,110}]',0,'[11000001,11000002,11000003,11000004,11000005,11000006,11000007,11000008,11000009]',150),(12000000,'[{lv,110}]',0,'[12000001,12000002,12000003,12000004,12000005,12000006,12000007,12000008,12000009]',150),(13000000,'[{lv,110}]',0,'[13000001,13000002,13000003,13000004,13000005,13000006,13000007,13000008,13000009]',150),(14000000,'[{lv,110}]',0,'[14000001,14000002,14000003,14000004,14000005,14000006,14000007,14000008,14000009]',150),(15000000,'[{lv,9999}]',0,'[15000001,15000002,15000003,15000004,15000005,15000006,15000007,15000008,15000009]',150),(16000000,'[{lv,9999}]',0,'[16000001,16000002,16000003,16000004,16000005,16000006,16000007,16000008,16000009]',150),(17000000,'[{lv,360}]',0,'[17000001,17000002,17000003,17000004,17000005,17000006,17000007,17000008,17000009]',150),(18000000,'[{lv,360}]',0,'[18000001,18000002,18000003,18000004,18000005,18000006,18000007,18000008,18000009]',150),(19000000,'[{lv,360}]',0,'[19000001,19000002,19000003,19000004,19000005,19000006,19000007,19000008,19000009,19000010,19000011,19000012]',150),(19100000,'[{lv,360},{vip_lv,5}]',0,'[19100001,19100002,19100003,19100004,19100005,19100006,19100007,19100008]',150),(19200000,'[{lv,360},{vip_lv,5}]',0,'[19200001,19200002,19200003,19200004,19200005,19200006,19200007,19200008]',150),(20000000,'[{lv,75}]',1,'[21000000,22000000,23000000,24000000,25000000,26000000,27000000,28000000,29000000]',150),(21000000,'[{lv,75}]',0,'[21000001,21000002,21000003,21000004,21000005,21000006,21000007,21000008,21000009]',150),(22000000,'[{lv,75}]',0,'[22002001,22000001,22000002,22000003,22000004,22000005,22000006,22000007,22001001,22001002,22001003,22001004,22001005]',150),(23000000,'[{lv,75}]',0,'[23000001,23000002,23000003,23000004,23000005,23000006,23000007,23000008,23000009,23000010,23000011,23000012,23000013]',150),(24000000,'[{lv,75}]',0,'[24000001,24000002,24000003,24000004,24000005]',150),(25000000,'[{lv,75}]',0,'[25000001,25000002,25000003,25000004,25000005]',150),(26000000,'[{lv,75}]',0,'[26000001,26000002,26000003,26000004,26000005,26000006,26000007,26000008,26000009,26000010]',150),(27000000,'[{lv,130}]',0,'[27000001,27000002,27000003,27000004,27000005,27000006,27000007,27000008,27000009,27000010,27000011,27000012,27000013,27000014,27000015]',150),(28000000,'[{lv,315}]',0,'[28000001,28000002,28000003,28000004]',150),(29000000,'[{lv,315}]',0,'[29000001,29000002,29000003]',150),(30000000,'[{lv,160}]',1,'[31000000,32000000,33000000,34000000]',150),(31000000,'[{lv,160}]',1,'[31070000,31080000,31090000,31100000]',150),(31070000,'[{lv,160}]',1,'[31070300,31070400,31070500,31070600,31070700,31070800,31070900,31071000,31071100,31071200,31071300,31071400,31071500,31071600]',150),(31070300,'[{lv,9999}]',0,'[31070301,31070302,31070303,31070304,31070306,31070307,31070308,31070310]',150),(31070400,'[{lv,160}]',0,'[31070401,31070402,31070403,31070404,31070406,31070407,31070408,31070410]',150),(31070500,'[{lv,160}]',0,'[31070501,31070502,31070503,31070504,31070506,31070507,31070508,31070510]',150),(31070600,'[{lv,180}]',0,'[31070601,31070602,31070603,31070604,31070606,31070607,31070608,31070610]',150),(31070700,'[{lv,220}]',0,'[31070701,31070702,31070703,31070704,31070706,31070707,31070708,31070710]',150),(31070800,'[{lv,260}]',0,'[31070801,31070802,31070803,31070804,31070806,31070807,31070808,31070810]',150),(31070900,'[{lv,300}]',0,'[31070901,31070902,31070903,31070904,31070906,31070907,31070908,31070910]',150),(31071000,'[{lv,355}]',0,'[31071001,31071002,31071003,31071004,31071006,31071007,31071008,31071010]',150),(31071100,'[{lv,400}]',0,'[31071101,31071102,31071103,31071104,31071106,31071107,31071108,31071110]',150),(31071200,'[{lv,500}]',0,'[31071201,31071202,31071203,31071204,31071206,31071207,31071208,31071210]',150),(31071300,'[{lv,520}]',0,'[31071301,31071302,31071303,31071304,31071306,31071307,31071308,31071310]',150),(31071400,'[{lv,620}]',0,'[31071401,31071402,31071403,31071404,31071406,31071407,31071408,31071410]',150),(31071500,'[{lv,650}]',0,'[31071501,31071502,31071503,31071504,31071506,31071507,31071508,31071510]',150),(31071600,'[{lv,700}]',0,'[31071601,31071602,31071603,31071604,31071606,31071607,31071608,31071610]',150),(31080000,'[{lv,160}]',1,'[31080300,31080400,31080500,31080600,31080700,31080800,31080900,31081000,31081100,31081200,31081300,31081400,31081500,31081600]',150),(31080300,'[{lv,9999}]',0,'[31080301,31080302,31080303,31080304,31080306,31080307,31080308,31080310]',150),(31080400,'[{lv,160}]',0,'[31080401,31080402,31080403,31080404,31080406,31080407,31080408,31080410]',150),(31080500,'[{lv,160}]',0,'[31080501,31080502,31080503,31080504,31080506,31080507,31080508,31080510]',150),(31080600,'[{lv,180}]',0,'[31080601,31080602,31080603,31080604,31080606,31080607,31080608,31080610]',150),(31080700,'[{lv,220}]',0,'[31080701,31080702,31080703,31080704,31080706,31080707,31080708,31080710]',150),(31080800,'[{lv,260}]',0,'[31080801,31080802,31080803,31080804,31080806,31080807,31080808,31080810]',150),(31080900,'[{lv,300}]',0,'[31080901,31080902,31080903,31080904,31080906,31080907,31080908,31080910]',150),(31081000,'[{lv,355}]',0,'[31081001,31081002,31081003,31081004,31081006,31081007,31081008,31081010]',150),(31081100,'[{lv,400}]',0,'[31081101,31081102,31081103,31081104,31081106,31081107,31081108,31081110]',150),(31081200,'[{lv,500}]',0,'[31081201,31081202,31081203,31081204,31081206,31081207,31081208,31081210]',150),(31081300,'[{lv,520}]',0,'[31081301,31081302,31081303,31081304,31081306,31081307,31081308,31081310]',150),(31081400,'[{lv,620}]',0,'[31081401,31081402,31081403,31081404,31081406,31081407,31081408,31081410]',150),(31081500,'[{lv,650}]',0,'[31081501,31081502,31081503,31081504,31081506,31081507,31081508,31081510]',150),(31081600,'[{lv,700}]',0,'[31081601,31081602,31081603,31081604,31081606,31081607,31081608,31081610]',150),(31090000,'[{lv,380}]',1,'[31090800,31090900,31091000,31091100,31091200,31091300,31091400,31091500,31091600]',152),(31090300,'[{lv,9999}]',0,'[31090301,31090302,31090303,31090304,31090306,31090307,31090308,31090310]',152),(31090400,'[{lv,9999}]',0,'[31090401,31090402,31090403,31090404,31090406,31090407,31090408,31090410]',152),(31090500,'[{lv,9999}]',0,'[31090501,31090502,31090503,31090504,31090506,31090507,31090508,31090510]',152),(31090600,'[{lv,9999}]',0,'[31090601,31090602,31090603,31090604,31090606,31090607,31090608,31090610]',152),(31090700,'[{lv,9999}]',0,'[31090701,31090702,31090703,31090704,31090706,31090707,31090708,31090710]',152),(31090800,'[{lv,260}]',0,'[31090801,31090802,31090803,31090804,31090806,31090807,31090808,31090810]',152),(31090900,'[{lv,300}]',0,'[31090901,31090902,31090903,31090904,31090906,31090907,31090908,31090910]',152),(31091000,'[{lv,355}]',0,'[31091001,31091002,31091003,31091004,31091006,31091007,31091008,31091010]',152),(31091100,'[{lv,400}]',0,'[31091101,31091102,31091103,31091104,31091106,31091107,31091108,31091110]',152),(31091200,'[{lv,500}]',0,'[31091201,31091202,31091203,31091204,31091206,31091207,31091208,31091210]',152),(31091300,'[{lv,520}]',0,'[31091301,31091302,31091303,31091304,31091306,31091307,31091308,31091310]',152),(31091400,'[{lv,620}]',0,'[31091401,31091402,31091403,31091404,31091406,31091407,31091408,31091410]',152),(31091500,'[{lv,650}]',0,'[31091501,31091502,31091503,31091504,31091506,31091507,31091508,31091510]',152),(31091600,'[{lv,700}]',0,'[31091601,31091602,31091603,31091604,31091606,31091607,31091608,31091610]',152),(31100000,'[{lv,380}]',1,'[31100800,31100900,31101000,31101100,31101200,31101300,31101400,31101500,31101600]',152),(31100300,'[{lv,9999}]',0,'[31100301,31100303,31100305,31100307,31100309]',152),(31100400,'[{lv,9999}]',0,'[31100401,31100403,31100405,31100407,31100409]',152),(31100500,'[{lv,9999}]',0,'[31100501,31100503,31100505,31100507,31100509]',152),(31100600,'[{lv,9999}]',0,'[31100601,31100603,31100605,31100607,31100609]',152),(31100700,'[{lv,9999}]',0,'[31100701,31100703,31100705,31100707,31100709]',152),(31100800,'[{lv,9999}]',0,'[31100801,31100803,31100805,31100807,31100809]',152),(31100900,'[{lv,300}]',0,'[31100901,31100903,31100905,31100907,31100909]',152),(31101000,'[{lv,355}]',0,'[31101001,31101003,31101005,31101007,31101009]',152),(31101100,'[{lv,400}]',0,'[31101101,31101103,31101105,31101107,31101109]',152),(31101200,'[{lv,500}]',0,'[31101201,31101203,31101205,31101207,31101209]',152),(31101300,'[{lv,520}]',0,'[31101301,31101303,31101305,31101307,31101309]',152),(31101400,'[{lv,620}]',0,'[31101401,31101403,31101405,31101407,31101409]',152),(31101500,'[{lv,650}]',0,'[31101501,31101503,31101505,31101507,31101509]',152),(31101600,'[{lv,700}]',0,'[31101601,31101603,31101605,31101607,31101609]',152),(32000000,'[{lv,160}]',1,'[32070000,32080000,32090000,32100000]',150),(32070000,'[{lv,160}]',1,'[32070300,32070400,32070500,32070600,32070700,32070800,32070900,32071000,32071100,32071200,32071300,32071400,32071500,32071600]',150),(32070300,'[{lv,9999}]',0,'[32070301,32070302,32070303,32070304,32070306,32070307,32070308,32070310]',150),(32070400,'[{lv,160}]',0,'[32070401,32070402,32070403,32070404,32070406,32070407,32070408,32070410]',150),(32070500,'[{lv,160}]',0,'[32070501,32070502,32070503,32070504,32070506,32070507,32070508,32070510]',150),(32070600,'[{lv,180}]',0,'[32070601,32070602,32070603,32070604,32070606,32070607,32070608,32070610]',150),(32070700,'[{lv,220}]',0,'[32070701,32070702,32070703,32070704,32070706,32070707,32070708,32070710]',150),(32070800,'[{lv,260}]',0,'[32070801,32070802,32070803,32070804,32070806,32070807,32070808,32070810]',150),(32070900,'[{lv,300}]',0,'[32070901,32070902,32070903,32070904,32070906,32070907,32070908,32070910]',150),(32071000,'[{lv,355}]',0,'[32071001,32071002,32071003,32071004,32071006,32071007,32071008,32071010]',150),(32071100,'[{lv,400}]',0,'[32071101,32071102,32071103,32071104,32071106,32071107,32071108,32071110]',150),(32071200,'[{lv,500}]',0,'[32071201,32071202,32071203,32071204,32071206,32071207,32071208,32071210]',150),(32071300,'[{lv,520}]',0,'[32071301,32071302,32071303,32071304,32071306,32071307,32071308,32071310]',150),(32071400,'[{lv,620}]',0,'[32071401,32071402,32071403,32071404,32071406,32071407,32071408,32071410]',150),(32071500,'[{lv,650}]',0,'[32071501,32071502,32071503,32071504,32071506,32071507,32071508,32071510]',150),(32071600,'[{lv,700}]',0,'[32071601,32071602,32071603,32071604,32071606,32071607,32071608,32071610]',150),(32080000,'[{lv,160}]',1,'[32080300,32080400,32080500,32080600,32080700,32080800,32080900,32081000,32081100,32081200,32081300,32081400,32081500,32081600]',150),(32080300,'[{lv,9999}]',0,'[32080301,32080302,32080303,32080304,32080306,32080307,32080308,32080310]',150),(32080400,'[{lv,160}]',0,'[32080401,32080402,32080403,32080404,32080406,32080407,32080408,32080410]',150),(32080500,'[{lv,160}]',0,'[32080501,32080502,32080503,32080504,32080506,32080507,32080508,32080510]',150),(32080600,'[{lv,180}]',0,'[32080601,32080602,32080603,32080604,32080606,32080607,32080608,32080610]',150),(32080700,'[{lv,220}]',0,'[32080701,32080702,32080703,32080704,32080706,32080707,32080708,32080710]',150),(32080800,'[{lv,260}]',0,'[32080801,32080802,32080803,32080804,32080806,32080807,32080808,32080810]',150),(32080900,'[{lv,300}]',0,'[32080901,32080902,32080903,32080904,32080906,32080907,32080908,32080910]',150),(32081000,'[{lv,355}]',0,'[32081001,32081002,32081003,32081004,32081006,32081007,32081008,32081010]',150),(32081100,'[{lv,400}]',0,'[32081101,32081102,32081103,32081104,32081106,32081107,32081108,32081110]',150),(32081200,'[{lv,500}]',0,'[32081201,32081202,32081203,32081204,32081206,32081207,32081208,32081210]',150),(32081300,'[{lv,520}]',0,'[32081301,32081302,32081303,32081304,32081306,32081307,32081308,32081310]',150),(32081400,'[{lv,620}]',0,'[32081401,32081402,32081403,32081404,32081406,32081407,32081408,32081410]',150),(32081500,'[{lv,650}]',0,'[32081501,32081502,32081503,32081504,32081506,32081507,32081508,32081510]',150),(32081600,'[{lv,700}]',0,'[32081601,32081602,32081603,32081604,32081606,32081607,32081608,32081610]',150),(32090000,'[{lv,380}]',1,'[32090800,32090900,32091000,32091100,32091200,32091300,32091400,32091500,32091600]',152),(32090300,'[{lv,9999}]',0,'[32090301,32090302,32090303,32090304,32090306,32090307,32090308,32090310]',152),(32090400,'[{lv,9999}]',0,'[32090401,32090402,32090403,32090404,32090406,32090407,32090408,32090410]',152),(32090500,'[{lv,9999}]',0,'[32090501,32090502,32090503,32090504,32090506,32090507,32090508,32090510]',152),(32090600,'[{lv,9999}]',0,'[32090601,32090602,32090603,32090604,32090606,32090607,32090608,32090610]',152),(32090700,'[{lv,9999}]',0,'[32090701,32090702,32090703,32090704,32090706,32090707,32090708,32090710]',152),(32090800,'[{lv,260}]',0,'[32090801,32090802,32090803,32090804,32090806,32090807,32090808,32090810]',152),(32090900,'[{lv,300}]',0,'[32090901,32090902,32090903,32090904,32090906,32090907,32090908,32090910]',152),(32091000,'[{lv,355}]',0,'[32091001,32091002,32091003,32091004,32091006,32091007,32091008,32091010]',152),(32091100,'[{lv,400}]',0,'[32091101,32091102,32091103,32091104,32091106,32091107,32091108,32091110]',152),(32091200,'[{lv,500}]',0,'[32091201,32091202,32091203,32091204,32091206,32091207,32091208,32091210]',152),(32091300,'[{lv,520}]',0,'[32091301,32091302,32091303,32091304,32091306,32091307,32091308,32091310]',152),(32091400,'[{lv,620}]',0,'[32091401,32091402,32091403,32091404,32091406,32091407,32091408,32091410]',152),(32091500,'[{lv,650}]',0,'[32091501,32091502,32091503,32091504,32091506,32091507,32091508,32091510]',152),(32091600,'[{lv,700}]',0,'[32091601,32091602,32091603,32091604,32091606,32091607,32091608,32091610]',152),(32100000,'[{lv,380}]',1,'[32100800,32100900,32101000,32101100,32101200,32101300,32101400,32101500,32101600]',152),(32100300,'[{lv,9999}]',0,'[32100301,32100303,32100305,32100307,32100309]',152),(32100400,'[{lv,9999}]',0,'[32100401,32100403,32100405,32100407,32100409]',152),(32100500,'[{lv,9999}]',0,'[32100501,32100503,32100505,32100507,32100509]',152),(32100600,'[{lv,9999}]',0,'[32100601,32100603,32100605,32100607,32100609]',152),(32100700,'[{lv,9999}]',0,'[32100701,32100703,32100705,32100707,32100709]',152),(32100800,'[{lv,9999}]',0,'[32100801,32100803,32100805,32100807,32100809]',152),(32100900,'[{lv,300}]',0,'[32100901,32100903,32100905,32100907,32100909]',152),(32101000,'[{lv,355}]',0,'[32101001,32101003,32101005,32101007,32101009]',152),(32101100,'[{lv,400}]',0,'[32101101,32101103,32101105,32101107,32101109]',152),(32101200,'[{lv,500}]',0,'[32101201,32101203,32101205,32101207,32101209]',152),(32101300,'[{lv,520}]',0,'[32101301,32101303,32101305,32101307,32101309]',152),(32101400,'[{lv,620}]',0,'[32101401,32101403,32101405,32101407,32101409]',152),(32101500,'[{lv,650}]',0,'[32101501,32101503,32101505,32101507,32101509]',152),(32101600,'[{lv,700}]',0,'[32101601,32101603,32101605,32101607,32101609]',152),(33000000,'[{lv,9999}]',1,'[33070000,33080000,33090000,33100000]',150),(33070000,'[{lv,1001}]',1,'[33070300,33070400,33070500,33070600,33070700,33070800,33070900,33071000,33071100,33071200,33071300,33071400,33071500,33071600]',150),(33070300,'[{lv,9999}]',0,'[33070301,33070302,33070303,33070304,33070306,33070307,33070308,33070310]',150),(33070400,'[{lv,160}]',0,'[33070401,33070402,33070403,33070404,33070406,33070407,33070408,33070410]',150),(33070500,'[{lv,160}]',0,'[33070501,33070502,33070503,33070504,33070506,33070507,33070508,33070510]',150),(33070600,'[{lv,180}]',0,'[33070601,33070602,33070603,33070604,33070606,33070607,33070608,33070610]',150),(33070700,'[{lv,220}]',0,'[33070701,33070702,33070703,33070704,33070706,33070707,33070708,33070710]',150),(33070800,'[{lv,260}]',0,'[33070801,33070802,33070803,33070804,33070806,33070807,33070808,33070810]',150),(33070900,'[{lv,300}]',0,'[33070901,33070902,33070903,33070904,33070906,33070907,33070908,33070910]',150),(33071000,'[{lv,355}]',0,'[33071001,33071002,33071003,33071004,33071006,33071007,33071008,33071010]',150),(33071100,'[{lv,400}]',0,'[33071101,33071102,33071103,33071104,33071106,33071107,33071108,33071110]',150),(33071200,'[{lv,500}]',0,'[33071201,33071202,33071203,33071204,33071206,33071207,33071208,33071210]',150),(33071300,'[{lv,520}]',0,'[33071301,33071302,33071303,33071304,33071306,33071307,33071308,33071310]',150),(33071400,'[{lv,620}]',0,'[33071401,33071402,33071403,33071404,33071406,33071407,33071408,33071410]',150),(33071500,'[{lv,650}]',0,'[33071501,33071502,33071503,33071504,33071506,33071507,33071508,33071510]',150),(33071600,'[{lv,700}]',0,'[33071601,33071602,33071603,33071604,33071606,33071607,33071608,33071610]',150),(33080000,'[{lv,1001}]',1,'[33080300,33080400,33080500,33080600,33080700,33080800,33080900,33081000,33081100,33081200,33081300,33081400,33081500,33081600]',150),(33080300,'[{lv,9999}]',0,'[33080301,33080302,33080303,33080304,33080306,33080307,33080308,33080310]',150),(33080400,'[{lv,160}]',0,'[33080401,33080402,33080403,33080404,33080406,33080407,33080408,33080410]',150),(33080500,'[{lv,160}]',0,'[33080501,33080502,33080503,33080504,33080506,33080507,33080508,33080510]',150),(33080600,'[{lv,180}]',0,'[33080601,33080602,33080603,33080604,33080606,33080607,33080608,33080610]',150),(33080700,'[{lv,220}]',0,'[33080701,33080702,33080703,33080704,33080706,33080707,33080708,33080710]',150),(33080800,'[{lv,260}]',0,'[33080801,33080802,33080803,33080804,33080806,33080807,33080808,33080810]',150),(33080900,'[{lv,300}]',0,'[33080901,33080902,33080903,33080904,33080906,33080907,33080908,33080910]',150),(33081000,'[{lv,355}]',0,'[33081001,33081002,33081003,33081004,33081006,33081007,33081008,33081010]',150),(33081100,'[{lv,400}]',0,'[33081101,33081102,33081103,33081104,33081106,33081107,33081108,33081110]',150),(33081200,'[{lv,500}]',0,'[33081201,33081202,33081203,33081204,33081206,33081207,33081208,33081210]',150),(33081300,'[{lv,520}]',0,'[33081301,33081302,33081303,33081304,33081306,33081307,33081308,33081310]',150),(33081400,'[{lv,620}]',0,'[33081401,33081402,33081403,33081404,33081406,33081407,33081408,33081410]',150),(33081500,'[{lv,650}]',0,'[33081501,33081502,33081503,33081504,33081506,33081507,33081508,33081510]',150),(33081600,'[{lv,700}]',0,'[33081601,33081602,33081603,33081604,33081606,33081607,33081608,33081610]',150),(33090000,'[{lv,1001}]',1,'[33090800,33090900,33091000,33091100,33091200,33091300,33091400,33091500,33091600]',152),(33090300,'[{lv,9999}]',0,'[33090301,33090302,33090303,33090304,33090306,33090307,33090308,33090310]',152),(33090400,'[{lv,160}]',0,'[33090401,33090402,33090403,33090404,33090406,33090407,33090408,33090410]',152),(33090500,'[{lv,160}]',0,'[33090501,33090502,33090503,33090504,33090506,33090507,33090508,33090510]',152),(33090600,'[{lv,180}]',0,'[33090601,33090602,33090603,33090604,33090606,33090607,33090608,33090610]',152),(33090700,'[{lv,220}]',0,'[33090701,33090702,33090703,33090704,33090706,33090707,33090708,33090710]',152),(33090800,'[{lv,260}]',0,'[33090801,33090802,33090803,33090804,33090806,33090807,33090808,33090810]',152),(33090900,'[{lv,300}]',0,'[33090901,33090902,33090903,33090904,33090906,33090907,33090908,33090910]',152),(33091000,'[{lv,355}]',0,'[33091001,33091002,33091003,33091004,33091006,33091007,33091008,33091010]',152),(33091100,'[{lv,400}]',0,'[33091101,33091102,33091103,33091104,33091106,33091107,33091108,33091110]',152),(33091200,'[{lv,500}]',0,'[33091201,33091202,33091203,33091204,33091206,33091207,33091208,33091210]',152),(33091300,'[{lv,520}]',0,'[33091301,33091302,33091303,33091304,33091306,33091307,33091308,33091310]',152),(33091400,'[{lv,620}]',0,'[33091401,33091402,33091403,33091404,33091406,33091407,33091408,33091410]',152),(33091500,'[{lv,650}]',0,'[33091501,33091502,33091503,33091504,33091506,33091507,33091508,33091510]',152),(33091600,'[{lv,700}]',0,'[33091601,33091602,33091603,33091604,33091606,33091607,33091608,33091610]',152),(33100000,'[{lv,1001}]',1,'[33100800,33100900,33101000,33101100,33101200,33101300,33101400,33101500,33101600]',152),(33100300,'[{lv,9999}]',0,'[33100301,33100303,33100305,33100307,33100309]',152),(33100400,'[{lv,160}]',0,'[33100401,33100403,33100405,33100407,33100409]',152),(33100500,'[{lv,160}]',0,'[33100501,33100503,33100505,33100507,33100509]',152),(33100600,'[{lv,180}]',0,'[33100601,33100603,33100605,33100607,33100609]',152),(33100700,'[{lv,220}]',0,'[33100701,33100703,33100705,33100707,33100709]',152),(33100800,'[{lv,260}]',0,'[33100801,33100803,33100805,33100807,33100809]',152),(33100900,'[{lv,300}]',0,'[33100901,33100903,33100905,33100907,33100909]',152),(33101000,'[{lv,355}]',0,'[33101001,33101003,33101005,33101007,33101009]',152),(33101100,'[{lv,400}]',0,'[33101101,33101103,33101105,33101107,33101109]',152),(33101200,'[{lv,500}]',0,'[33101201,33101203,33101205,33101207,33101209]',152),(33101300,'[{lv,520}]',0,'[33101301,33101303,33101305,33101307,33101309]',152),(33101400,'[{lv,620}]',0,'[33101401,33101403,33101405,33101407,33101409]',152),(33101500,'[{lv,650}]',0,'[33101501,33101503,33101505,33101507,33101509]',152),(33101600,'[{lv,700}]',0,'[33101601,33101603,33101605,33101607,33101609]',152),(34000000,'[{lv,160}]',1,'[34070000,34080000,34090000,34100000]',150),(34070000,'[{lv,160}]',1,'[34070300,34070400,34070500,34070600,34070700,34070800,34070900,34071000,34071100,34071200,34071300,34071400,34071500,34071600]',150),(34070300,'[{lv,9999}]',0,'[34070301,34070302,34070303,34070304,34070306,34070307,34070308,34070310]',150),(34070400,'[{lv,160}]',0,'[34070401,34070402,34070403,34070404,34070406,34070407,34070408,34070410]',150),(34070500,'[{lv,160}]',0,'[34070501,34070502,34070503,34070504,34070506,34070507,34070508,34070510]',150),(34070600,'[{lv,180}]',0,'[34070601,34070602,34070603,34070604,34070606,34070607,34070608,34070610]',150),(34070700,'[{lv,220}]',0,'[34070701,34070702,34070703,34070704,34070706,34070707,34070708,34070710]',150),(34070800,'[{lv,260}]',0,'[34070801,34070802,34070803,34070804,34070806,34070807,34070808,34070810]',150),(34070900,'[{lv,300}]',0,'[34070901,34070902,34070903,34070904,34070906,34070907,34070908,34070910]',150),(34071000,'[{lv,355}]',0,'[34071001,34071002,34071003,34071004,34071006,34071007,34071008,34071010]',150),(34071100,'[{lv,400}]',0,'[34071101,34071102,34071103,34071104,34071106,34071107,34071108,34071110]',150),(34071200,'[{lv,500}]',0,'[34071201,34071202,34071203,34071204,34071206,34071207,34071208,34071210]',150),(34071300,'[{lv,520}]',0,'[34071301,34071302,34071303,34071304,34071306,34071307,34071308,34071310]',150),(34071400,'[{lv,620}]',0,'[34071401,34071402,34071403,34071404,34071406,34071407,34071408,34071410]',150),(34071500,'[{lv,650}]',0,'[34071501,34071502,34071503,34071504,34071506,34071507,34071508,34071510]',150),(34071600,'[{lv,700}]',0,'[34071601,34071602,34071603,34071604,34071606,34071607,34071608,34071610]',150),(34080000,'[{lv,160}]',1,'[34080300,34080400,34080500,34080600,34080700,34080800,34080900,34081000,34081100,34081200,34081300,34081400,34081500,34081600]',150),(34080300,'[{lv,9999}]',0,'[34080301,34080302,34080303,34080304,34080306,34080307,34080308,34080310]',150),(34080400,'[{lv,160}]',0,'[34080401,34080402,34080403,34080404,34080406,34080407,34080408,34080410]',150),(34080500,'[{lv,160}]',0,'[34080501,34080502,34080503,34080504,34080506,34080507,34080508,34080510]',150),(34080600,'[{lv,180}]',0,'[34080601,34080602,34080603,34080604,34080606,34080607,34080608,34080610]',150),(34080700,'[{lv,220}]',0,'[34080701,34080702,34080703,34080704,34080706,34080707,34080708,34080710]',150),(34080800,'[{lv,260}]',0,'[34080801,34080802,34080803,34080804,34080806,34080807,34080808,34080810]',150),(34080900,'[{lv,300}]',0,'[34080901,34080902,34080903,34080904,34080906,34080907,34080908,34080910]',150),(34081000,'[{lv,355}]',0,'[34081001,34081002,34081003,34081004,34081006,34081007,34081008,34081010]',150),(34081100,'[{lv,400}]',0,'[34081101,34081102,34081103,34081104,34081106,34081107,34081108,34081110]',150),(34081200,'[{lv,500}]',0,'[34081201,34081202,34081203,34081204,34081206,34081207,34081208,34081210]',150),(34081300,'[{lv,520}]',0,'[34081301,34081302,34081303,34081304,34081306,34081307,34081308,34081310]',150),(34081400,'[{lv,620}]',0,'[34081401,34081402,34081403,34081404,34081406,34081407,34081408,34081410]',150),(34081500,'[{lv,650}]',0,'[34081501,34081502,34081503,34081504,34081506,34081507,34081508,34081510]',150),(34081600,'[{lv,700}]',0,'[34081601,34081602,34081603,34081604,34081606,34081607,34081608,34081610]',150),(34090000,'[{lv,380}]',1,'[34090800,34090900,34091000,34091100,34091200,34091300,34091400,34091500,34091600]',152),(34090300,'[{lv,9999}]',0,'[34090301,34090302,34090303,34090304,34090306,34090307,34090308,34090310]',152),(34090400,'[{lv,9999}]',0,'[34090401,34090402,34090403,34090404,34090406,34090407,34090408,34090410]',152),(34090500,'[{lv,9999}]',0,'[34090501,34090502,34090503,34090504,34090506,34090507,34090508,34090510]',152),(34090600,'[{lv,9999}]',0,'[34090601,34090602,34090603,34090604,34090606,34090607,34090608,34090610]',152),(34090700,'[{lv,9999}]',0,'[34090701,34090702,34090703,34090704,34090706,34090707,34090708,34090710]',152),(34090800,'[{lv,260}]',0,'[34090801,34090802,34090803,34090804,34090806,34090807,34090808,34090810]',152),(34090900,'[{lv,300}]',0,'[34090901,34090902,34090903,34090904,34090906,34090907,34090908,34090910]',152),(34091000,'[{lv,355}]',0,'[34091001,34091002,34091003,34091004,34091006,34091007,34091008,34091010]',152),(34091100,'[{lv,400}]',0,'[34091101,34091102,34091103,34091104,34091106,34091107,34091108,34091110]',152),(34091200,'[{lv,500}]',0,'[34091201,34091202,34091203,34091204,34091206,34091207,34091208,34091210]',152),(34091300,'[{lv,520}]',0,'[34091301,34091302,34091303,34091304,34091306,34091307,34091308,34091310]',152),(34091400,'[{lv,620}]',0,'[34091401,34091402,34091403,34091404,34091406,34091407,34091408,34091410]',152),(34091500,'[{lv,650}]',0,'[34091501,34091502,34091503,34091504,34091506,34091507,34091508,34091510]',152),(34091600,'[{lv,700}]',0,'[34091601,34091602,34091603,34091604,34091606,34091607,34091608,34091610]',152),(34100000,'[{lv,380}]',1,'[34100800,34100900,34101000,34101100,34101200,34101300,34101400,34101500,34101600]',152),(34100300,'[{lv,9999}]',0,'[34100301,34100303,34100305,34100307,34100309]',152),(34100400,'[{lv,9999}]',0,'[34100401,34100403,34100405,34100407,34100409]',152),(34100500,'[{lv,9999}]',0,'[34100501,34100503,34100505,34100507,34100509]',152),(34100600,'[{lv,9999}]',0,'[34100601,34100603,34100605,34100607,34100609]',152),(34100700,'[{lv,9999}]',0,'[34100701,34100703,34100705,34100707,34100709]',152),(34100800,'[{lv,9999}]',0,'[34100801,34100803,34100805,34100807,34100809]',152),(34100900,'[{lv,300}]',0,'[34100901,34100903,34100905,34100907,34100909]',152),(34101000,'[{lv,355}]',0,'[34101001,34101003,34101005,34101007,34101009]',152),(34101100,'[{lv,400}]',0,'[34101101,34101103,34101105,34101107,34101109]',152),(34101200,'[{lv,500}]',0,'[34101201,34101203,34101205,34101207,34101209]',152),(34101300,'[{lv,520}]',0,'[34101301,34101303,34101305,34101307,34101309]',152),(34101400,'[{lv,620}]',0,'[34101401,34101403,34101405,34101407,34101409]',152),(34101500,'[{lv,650}]',0,'[34101501,34101503,34101505,34101507,34101509]',152),(34101600,'[{lv,700}]',0,'[34101601,34101603,34101605,34101607,34101609]',152),(40000000,'[{lv,240}]',1,'[41000000,42000000,43000000,44000000]',150),(41000000,'[{lv,240}]',1,'[41101000,41102000,41201000,41202000]',150),(41101000,'[{lv,240}]',0,'[41101002,41101004,41101006,41101008,41101010]',150),(41102000,'[{lv,240}]',0,'[41102001,41102003,41102005,41102007,41102009]',150),(41201000,'[{lv,240}]',0,'[41201002,41201004,41201006,41201008,41201010]',150),(41202000,'[{lv,240}]',0,'[41202001,41202003,41202005,41202007,41202009]',150),(42000000,'[{lv,240}]',1,'[42101000,42102000,42201000,42202000]',150),(42101000,'[{lv,240}]',0,'[42101002,42101004,42101006,42101008,42101010]',150),(42102000,'[{lv,240}]',0,'[42102001,42102003,42102005,42102007,42102009]',150),(42201000,'[{lv,240}]',0,'[42201002,42201004,42201006,42201008,42201010]',150),(42202000,'[{lv,240}]',0,'[42202001,42202003,42202005,42202007,42202009]',150),(43000000,'[{lv,1001}]',1,'[43101000,43102000,43201000,43202000]',150),(43101000,'[{lv,240}]',0,'[43101002,43101004,43101006,43101008,43101010]',150),(43102000,'[{lv,240}]',0,'[43102001,43102003,43102005,43102007,43102009]',150),(43201000,'[{lv,240}]',0,'[43201002,43201004,43201006,43201008,43201010]',150),(43202000,'[{lv,240}]',0,'[43202001,43202003,43202005,43202007,43202009]',150),(44000000,'[{lv,240}]',1,'[44101000,44102000,44201000,44202000]',150),(44101000,'[{lv,240}]',0,'[44101002,44101004,44101006,44101008,44101010]',150),(44102000,'[{lv,240}]',0,'[44102001,44102003,44102005,44102007,44102009]',150),(44201000,'[{lv,240}]',0,'[44201002,44201004,44201006,44201008,44201010]',150),(44202000,'[{lv,240}]',0,'[44202001,44202003,44202005,44202007,44202009]',150),(50000000,'[{lv,25}]',1,'[59000000,51000000,52000000,53000000,54000000,55000000,60000000,58000000,59100000,57000000,56000000]',150),(51000000,'[{lv,25}]',0,'[51000002,51000003]',150),(52000000,'[{lv,30}]',0,'[52000002,52000003]',150),(53000000,'[{lv,120}]',0,'[53000002,53000003]',150),(54000000,'[{lv,80}]',0,'[54000002,54000003]',150),(55000000,'[{lv,90}]',0,'[55000002,55000003]',150),(56000000,'[{lv,300}]',0,'[56000011,56000012,56000021]',150),(57000000,'[{lv,180}]',0,'[57000001,57000002,57000003,57000004,57000005,57000006]',150),(58000000,'[{lv,50}]',0,'[58000001]',150),(59000000,'[{lv,75}]',0,'[59000001,59000002,59000003,59000004,59000005,59000006,59000007,59000008,59000009]',150),(59100000,'[{lv,315}]',0,'[59100001,59100002,59100003,59100004]',150),(60000000,'[{lv,9999}]',0,'[60001002,60001003,60001004,60001005,60002002,60002003,60002004,60002005,60003002,60003003,60003004,60003005,60004002,60004003,60004004,60004005]',150),(70000000,'[{lv,270}]',1,'[71000000,72000000]',181),(71000000,'[{lv,270}]',0,'[71000001,71000002,71000003,71000004,71000005,71000006,71000007,71000008]',181),(72000000,'[{lv,270}]',0,'[72000001,72000002,72000003,72000004,72000005,72000006,72000007,72000008]',181);
/*!40000 ALTER TABLE `base_compose_menu` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_compose_menu_id`
--

DROP TABLE IF EXISTS `base_compose_menu_id`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_compose_menu_id` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '菜单id',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '名字@lang@',
  `open_condition` varchar(255) NOT NULL DEFAULT '[]' COMMENT '开启条件',
  `extra` varchar(255) NOT NULL DEFAULT '' COMMENT '备注@lang@',
  `module_id` smallint(5) unsigned NOT NULL DEFAULT '150' COMMENT '功能id',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='合成菜单类型';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_compose_menu_id`
--

LOCK TABLES `base_compose_menu_id` WRITE;
/*!40000 ALTER TABLE `base_compose_menu_id` DISABLE KEYS */;
INSERT INTO `base_compose_menu_id` VALUES (10000000,'宝石合成','[{lv,110}]','宝石合成',150),(11000000,'攻击宝石','[{lv,110}]','攻击宝石',150),(12000000,'生命宝石','[{lv,110}]','生命宝石',150),(13000000,'破甲宝石','[{lv,110}]','破甲宝石',150),(14000000,'防御宝石','[{lv,110}]','防御宝石',150),(15000000,'命中宝石','[{lv,9999}]','命中宝石',150),(16000000,'闪避宝石','[{lv,9999}]','闪避宝石',150),(17000000,'暴击宝石','[{lv,360}]','暴击宝石',150),(18000000,'韧性宝石','[{lv,360}]','韧性宝石',150),(19000000,'双属性宝石','[{lv,360}]','双属性宝石',150),(19100000,'霸主攻击宝石','[{lv,360},{vip_lv,5}]','霸主攻击宝石',150),(19200000,'霸主防御宝石','[{lv,360},{vip_lv,5}]','霸主防御宝石',150),(20000000,'进阶合成','[{lv,75}]','道具合成',150),(21000000,'宝具幻化','[{lv,75}]','宝具幻化',150),(22000000,'星灵召唤','[{lv,75}]','星灵召唤',150),(23000000,'坐骑幻化','[{lv,75}]','坐骑幻化',150),(24000000,'降神形象','[{lv,75}]','降神形象',150),(25000000,'降神圣器','[{lv,75}]','降神圣器',150),(26000000,'翅膀幻化','[{lv,75}]','翅膀幻化',150),(27000000,'光武幻化','[{lv,130}]','光武幻化',150),(28000000,'宝宝坐骑','[{lv,315}]','宝宝坐骑',150),(29000000,'宝宝外观','[{lv,315}]','宝宝外观',150),(30000000,'职业装备','[{lv,160}]','职业装备',150),(31000000,'魔剑士','[{lv,160}]','魔剑士',150),(31070000,'红2星','[{lv,160}]','魔剑士红2星',150),(31070300,'3阶装备','[{lv,9999}]','魔剑士红2星3阶',150),(31070400,'4阶装备','[{lv,160}]','魔剑士红2星4阶',150),(31070500,'5阶装备','[{lv,160}]','魔剑士红2星5阶',150),(31070600,'6阶装备','[{lv,180}]','魔剑士红2星6阶',150),(31070700,'7阶装备','[{lv,220}]','魔剑士红2星7阶',150),(31070800,'8阶装备','[{lv,260}]','魔剑士红2星8阶',150),(31070900,'9阶装备','[{lv,300}]','魔剑士红2星9阶',150),(31071000,'10阶装备','[{lv,355}]','魔剑士红2星10阶',150),(31071100,'11阶装备','[{lv,400}]','魔剑士红2星11阶',150),(31071200,'12阶装备','[{lv,500}]','魔剑士红2星12阶',150),(31071300,'13阶装备','[{lv,520}]','魔剑士红2星13阶',150),(31071400,'14阶装备','[{lv,620}]','魔剑士红2星14阶',150),(31071500,'15阶装备','[{lv,650}]','魔剑士红2星15阶',150),(31071600,'16阶装备','[{lv,700}]','魔剑士红2星16阶',150),(31080000,'红3星','[{lv,160}]','魔剑士红3星',150),(31080300,'3阶装备','[{lv,9999}]','魔剑士红3星3阶',150),(31080400,'4阶装备','[{lv,160}]','魔剑士红3星4阶',150),(31080500,'5阶装备','[{lv,160}]','魔剑士红3星5阶',150),(31080600,'6阶装备','[{lv,180}]','魔剑士红3星6阶',150),(31080700,'7阶装备','[{lv,220}]','魔剑士红3星7阶',150),(31080800,'8阶装备','[{lv,260}]','魔剑士红3星8阶',150),(31080900,'9阶装备','[{lv,300}]','魔剑士红3星9阶',150),(31081000,'10阶装备','[{lv,355}]','魔剑士红3星10阶',150),(31081100,'11阶装备','[{lv,400}]','魔剑士红3星11阶',150),(31081200,'12阶装备','[{lv,500}]','魔剑士红3星12阶',150),(31081300,'13阶装备','[{lv,520}]','魔剑士红3星13阶',150),(31081400,'14阶装备','[{lv,620}]','魔剑士红3星14阶',150),(31081500,'15阶装备','[{lv,650}]','魔剑士红3星15阶',150),(31081600,'16阶装备','[{lv,700}]','魔剑士红3星16阶',150),(31090000,'粉色','[{lv,380}]','魔剑士粉色',152),(31090300,'3阶装备','[{lv,9999}]','魔剑士粉色3阶',152),(31090400,'4阶装备','[{lv,9999}]','魔剑士粉色4阶',152),(31090500,'5阶装备','[{lv,9999}]','魔剑士粉色5阶',152),(31090600,'6阶装备','[{lv,9999}]','魔剑士粉色6阶',152),(31090700,'7阶装备','[{lv,9999}]','魔剑士粉色7阶',152),(31090800,'8阶装备','[{lv,260}]','魔剑士粉色8阶',152),(31090900,'9阶装备','[{lv,300}]','魔剑士粉色9阶',152),(31091000,'10阶装备','[{lv,355}]','魔剑士粉色10阶',152),(31091100,'11阶装备','[{lv,400}]','魔剑士粉色11阶',152),(31091200,'12阶装备','[{lv,500}]','魔剑士粉色12阶',152),(31091300,'13阶装备','[{lv,520}]','魔剑士粉色13阶',152),(31091400,'14阶装备','[{lv,620}]','魔剑士粉色14阶',152),(31091500,'15阶装备','[{lv,650}]','魔剑士粉色15阶',152),(31091600,'16阶装备','[{lv,700}]','魔剑士粉色16阶',152),(31100000,'神装','[{lv,380}]','魔剑士神装',152),(31100300,'3阶装备','[{lv,9999}]','魔剑士神装3阶',152),(31100400,'4阶装备','[{lv,9999}]','魔剑士神装4阶',152),(31100500,'5阶装备','[{lv,9999}]','魔剑士神装5阶',152),(31100600,'6阶装备','[{lv,9999}]','魔剑士神装6阶',152),(31100700,'7阶装备','[{lv,9999}]','魔剑士神装7阶',152),(31100800,'8阶装备','[{lv,9999}]','魔剑士神装8阶',152),(31100900,'9阶装备','[{lv,300}]','魔剑士神装9阶',152),(31101000,'10阶装备','[{lv,355}]','魔剑士神装10阶',152),(31101100,'11阶装备','[{lv,400}]','魔剑士神装11阶',152),(31101200,'12阶装备','[{lv,500}]','魔剑士神装12阶',152),(31101300,'13阶装备','[{lv,520}]','魔剑士神装13阶',152),(31101400,'14阶装备','[{lv,620}]','魔剑士神装14阶',152),(31101500,'15阶装备','[{lv,650}]','魔剑士神装15阶',152),(31101600,'16阶装备','[{lv,700}]','魔剑士神装16阶',152),(32000000,'龙骑士','[{lv,160}]','龙骑士',150),(32070000,'红2星','[{lv,160}]','龙骑士红2星',150),(32070300,'3阶装备','[{lv,9999}]','龙骑士红2星3阶',150),(32070400,'4阶装备','[{lv,160}]','龙骑士红2星4阶',150),(32070500,'5阶装备','[{lv,160}]','龙骑士红2星5阶',150),(32070600,'6阶装备','[{lv,180}]','龙骑士红2星6阶',150),(32070700,'7阶装备','[{lv,220}]','龙骑士红2星7阶',150),(32070800,'8阶装备','[{lv,260}]','龙骑士红2星8阶',150),(32070900,'9阶装备','[{lv,300}]','龙骑士红2星9阶',150),(32071000,'10阶装备','[{lv,355}]','龙骑士红2星10阶',150),(32071100,'11阶装备','[{lv,400}]','龙骑士红2星11阶',150),(32071200,'12阶装备','[{lv,500}]','龙骑士红2星12阶',150),(32071300,'13阶装备','[{lv,520}]','龙骑士红2星13阶',150),(32071400,'14阶装备','[{lv,620}]','龙骑士红2星14阶',150),(32071500,'15阶装备','[{lv,650}]','龙骑士红2星15阶',150),(32071600,'16阶装备','[{lv,700}]','龙骑士红2星16阶',150),(32080000,'红3星','[{lv,160}]','龙骑士红3星',150),(32080300,'3阶装备','[{lv,9999}]','龙骑士红3星3阶',150),(32080400,'4阶装备','[{lv,160}]','龙骑士红3星4阶',150),(32080500,'5阶装备','[{lv,160}]','龙骑士红3星5阶',150),(32080600,'6阶装备','[{lv,180}]','龙骑士红3星6阶',150),(32080700,'7阶装备','[{lv,220}]','龙骑士红3星7阶',150),(32080800,'8阶装备','[{lv,260}]','龙骑士红3星8阶',150),(32080900,'9阶装备','[{lv,300}]','龙骑士红3星9阶',150),(32081000,'10阶装备','[{lv,355}]','龙骑士红3星10阶',150),(32081100,'11阶装备','[{lv,400}]','龙骑士红3星11阶',150),(32081200,'12阶装备','[{lv,500}]','龙骑士红3星12阶',150),(32081300,'13阶装备','[{lv,520}]','龙骑士红3星13阶',150),(32081400,'14阶装备','[{lv,620}]','龙骑士红3星14阶',150),(32081500,'15阶装备','[{lv,650}]','龙骑士红3星15阶',150),(32081600,'16阶装备','[{lv,700}]','龙骑士红3星16阶',150),(32090000,'粉色','[{lv,380}]','龙骑士粉色',152),(32090300,'3阶装备','[{lv,9999}]','龙骑士粉色3阶',152),(32090400,'4阶装备','[{lv,9999}]','龙骑士粉色4阶',152),(32090500,'5阶装备','[{lv,9999}]','龙骑士粉色5阶',152),(32090600,'6阶装备','[{lv,9999}]','龙骑士粉色6阶',152),(32090700,'7阶装备','[{lv,9999}]','龙骑士粉色7阶',152),(32090800,'8阶装备','[{lv,260}]','龙骑士粉色8阶',152),(32090900,'9阶装备','[{lv,300}]','龙骑士粉色9阶',152),(32091000,'10阶装备','[{lv,355}]','龙骑士粉色10阶',152),(32091100,'11阶装备','[{lv,400}]','龙骑士粉色11阶',152),(32091200,'12阶装备','[{lv,500}]','龙骑士粉色12阶',152),(32091300,'13阶装备','[{lv,520}]','龙骑士粉色13阶',152),(32091400,'14阶装备','[{lv,620}]','龙骑士粉色14阶',152),(32091500,'15阶装备','[{lv,650}]','龙骑士粉色15阶',152),(32091600,'16阶装备','[{lv,700}]','龙骑士粉色16阶',152),(32100000,'神装','[{lv,380}]','龙骑士神装',152),(32100300,'3阶装备','[{lv,9999}]','龙骑士神装3阶',152),(32100400,'4阶装备','[{lv,9999}]','龙骑士神装4阶',152),(32100500,'5阶装备','[{lv,9999}]','龙骑士神装5阶',152),(32100600,'6阶装备','[{lv,9999}]','龙骑士神装6阶',152),(32100700,'7阶装备','[{lv,9999}]','龙骑士神装7阶',152),(32100800,'8阶装备','[{lv,9999}]','龙骑士神装8阶',152),(32100900,'9阶装备','[{lv,300}]','龙骑士神装9阶',152),(32101000,'10阶装备','[{lv,355}]','龙骑士神装10阶',152),(32101100,'11阶装备','[{lv,400}]','龙骑士神装11阶',152),(32101200,'12阶装备','[{lv,500}]','龙骑士神装12阶',152),(32101300,'13阶装备','[{lv,520}]','龙骑士神装13阶',152),(32101400,'14阶装备','[{lv,620}]','龙骑士神装14阶',152),(32101500,'15阶装备','[{lv,650}]','龙骑士神装15阶',152),(32101600,'16阶装备','[{lv,700}]','龙骑士神装16阶',152),(33000000,'魔导师','[{lv,9999}]','魔导师',150),(33070000,'红2星','[{lv,1001}]','魔导师红2星',150),(33070300,'3阶装备','[{lv,9999}]','魔导师红2星3阶',150),(33070400,'4阶装备','[{lv,160}]','魔导师红2星4阶',150),(33070500,'5阶装备','[{lv,160}]','魔导师红2星5阶',150),(33070600,'6阶装备','[{lv,180}]','魔导师红2星6阶',150),(33070700,'7阶装备','[{lv,220}]','魔导师红2星7阶',150),(33070800,'8阶装备','[{lv,260}]','魔导师红2星8阶',150),(33070900,'9阶装备','[{lv,300}]','魔导师红2星9阶',150),(33071000,'10阶装备','[{lv,355}]','魔导师红2星10阶',150),(33071100,'11阶装备','[{lv,400}]','魔导师红2星11阶',150),(33071200,'12阶装备','[{lv,500}]','魔导师红2星12阶',150),(33071300,'13阶装备','[{lv,520}]','魔导师红2星13阶',150),(33071400,'14阶装备','[{lv,620}]','魔导师红2星14阶',150),(33071500,'15阶装备','[{lv,650}]','魔导师红2星15阶',150),(33071600,'16阶装备','[{lv,700}]','魔导师红2星16阶',150),(33080000,'红3星','[{lv,1001}]','魔导师红3星',150),(33080300,'3阶装备','[{lv,9999}]','魔导师红3星3阶',150),(33080400,'4阶装备','[{lv,160}]','魔导师红3星4阶',150),(33080500,'5阶装备','[{lv,160}]','魔导师红3星5阶',150),(33080600,'6阶装备','[{lv,180}]','魔导师红3星6阶',150),(33080700,'7阶装备','[{lv,220}]','魔导师红3星7阶',150),(33080800,'8阶装备','[{lv,260}]','魔导师红3星8阶',150),(33080900,'9阶装备','[{lv,300}]','魔导师红3星9阶',150),(33081000,'10阶装备','[{lv,355}]','魔导师红3星10阶',150),(33081100,'11阶装备','[{lv,400}]','魔导师红3星11阶',150),(33081200,'12阶装备','[{lv,500}]','魔导师红3星12阶',150),(33081300,'13阶装备','[{lv,520}]','魔导师红3星13阶',150),(33081400,'14阶装备','[{lv,620}]','魔导师红3星14阶',150),(33081500,'15阶装备','[{lv,650}]','魔导师红3星15阶',150),(33081600,'16阶装备','[{lv,700}]','魔导师红3星16阶',150),(33090000,'粉色','[{lv,1001}]','魔导师粉色',152),(33090300,'3阶装备','[{lv,9999}]','魔导师粉色3阶',152),(33090400,'4阶装备','[{lv,160}]','魔导师粉色4阶',152),(33090500,'5阶装备','[{lv,160}]','魔导师粉色5阶',152),(33090600,'6阶装备','[{lv,180}]','魔导师粉色6阶',152),(33090700,'7阶装备','[{lv,220}]','魔导师粉色7阶',152),(33090800,'8阶装备','[{lv,260}]','魔导师粉色8阶',152),(33090900,'9阶装备','[{lv,300}]','魔导师粉色9阶',152),(33091000,'10阶装备','[{lv,355}]','魔导师粉色10阶',152),(33091100,'11阶装备','[{lv,400}]','魔导师粉色11阶',152),(33091200,'12阶装备','[{lv,500}]','魔导师粉色12阶',152),(33091300,'13阶装备','[{lv,520}]','魔导师粉色13阶',152),(33091400,'14阶装备','[{lv,620}]','魔导师粉色14阶',152),(33091500,'15阶装备','[{lv,650}]','魔导师粉色15阶',152),(33091600,'16阶装备','[{lv,700}]','魔导师粉色16阶',152),(33100000,'神装','[{lv,1001}]','魔导师神装',152),(33100300,'3阶装备','[{lv,9999}]','魔导师神装3阶',152),(33100400,'4阶装备','[{lv,160}]','魔导师神装4阶',152),(33100500,'5阶装备','[{lv,160}]','魔导师神装5阶',152),(33100600,'6阶装备','[{lv,180}]','魔导师神装6阶',152),(33100700,'7阶装备','[{lv,220}]','魔导师神装7阶',152),(33100800,'8阶装备','[{lv,260}]','魔导师神装8阶',152),(33100900,'9阶装备','[{lv,300}]','魔导师神装9阶',152),(33101000,'10阶装备','[{lv,355}]','魔导师神装10阶',152),(33101100,'11阶装备','[{lv,400}]','魔导师神装11阶',152),(33101200,'12阶装备','[{lv,500}]','魔导师神装12阶',152),(33101300,'13阶装备','[{lv,520}]','魔导师神装13阶',152),(33101400,'14阶装备','[{lv,620}]','魔导师神装14阶',152),(33101500,'15阶装备','[{lv,650}]','魔导师神装15阶',152),(33101600,'16阶装备','[{lv,700}]','魔导师神装16阶',152),(34000000,'重炮手','[{lv,160}]','重炮手',150),(34070000,'红2星','[{lv,160}]','重炮手红2星',150),(34070300,'3阶装备','[{lv,9999}]','重炮手红2星3阶',150),(34070400,'4阶装备','[{lv,160}]','重炮手红2星4阶',150),(34070500,'5阶装备','[{lv,160}]','重炮手红2星5阶',150),(34070600,'6阶装备','[{lv,180}]','重炮手红2星6阶',150),(34070700,'7阶装备','[{lv,220}]','重炮手红2星7阶',150),(34070800,'8阶装备','[{lv,260}]','重炮手红2星8阶',150),(34070900,'9阶装备','[{lv,300}]','重炮手红2星9阶',150),(34071000,'10阶装备','[{lv,355}]','重炮手红2星10阶',150),(34071100,'11阶装备','[{lv,400}]','重炮手红2星11阶',150),(34071200,'12阶装备','[{lv,500}]','重炮手红2星12阶',150),(34071300,'13阶装备','[{lv,520}]','重炮手红2星13阶',150),(34071400,'14阶装备','[{lv,620}]','重炮手红2星14阶',150),(34071500,'15阶装备','[{lv,650}]','重炮手红2星15阶',150),(34071600,'16阶装备','[{lv,700}]','重炮手红2星16阶',150),(34080000,'红3星','[{lv,160}]','重炮手红3星',150),(34080300,'3阶装备','[{lv,9999}]','重炮手红3星3阶',150),(34080400,'4阶装备','[{lv,160}]','重炮手红3星4阶',150),(34080500,'5阶装备','[{lv,160}]','重炮手红3星5阶',150),(34080600,'6阶装备','[{lv,180}]','重炮手红3星6阶',150),(34080700,'7阶装备','[{lv,220}]','重炮手红3星7阶',150),(34080800,'8阶装备','[{lv,260}]','重炮手红3星8阶',150),(34080900,'9阶装备','[{lv,300}]','重炮手红3星9阶',150),(34081000,'10阶装备','[{lv,355}]','重炮手红3星10阶',150),(34081100,'11阶装备','[{lv,400}]','重炮手红3星11阶',150),(34081200,'12阶装备','[{lv,500}]','重炮手红3星12阶',150),(34081300,'13阶装备','[{lv,520}]','重炮手红3星13阶',150),(34081400,'14阶装备','[{lv,620}]','重炮手红3星14阶',150),(34081500,'15阶装备','[{lv,650}]','重炮手红3星15阶',150),(34081600,'16阶装备','[{lv,700}]','重炮手红3星16阶',150),(34090000,'粉色','[{lv,380}]','重炮手粉色',152),(34090300,'3阶装备','[{lv,9999}]','重炮手粉色3阶',152),(34090400,'4阶装备','[{lv,9999}]','重炮手粉色4阶',152),(34090500,'5阶装备','[{lv,9999}]','重炮手粉色5阶',152),(34090600,'6阶装备','[{lv,9999}]','重炮手粉色6阶',152),(34090700,'7阶装备','[{lv,9999}]','重炮手粉色7阶',152),(34090800,'8阶装备','[{lv,260}]','重炮手粉色8阶',152),(34090900,'9阶装备','[{lv,300}]','重炮手粉色9阶',152),(34091000,'10阶装备','[{lv,355}]','重炮手粉色10阶',152),(34091100,'11阶装备','[{lv,400}]','重炮手粉色11阶',152),(34091200,'12阶装备','[{lv,500}]','重炮手粉色12阶',152),(34091300,'13阶装备','[{lv,520}]','重炮手粉色13阶',152),(34091400,'14阶装备','[{lv,620}]','重炮手粉色14阶',152),(34091500,'15阶装备','[{lv,650}]','重炮手粉色15阶',152),(34091600,'16阶装备','[{lv,700}]','重炮手粉色16阶',152),(34100000,'神装','[{lv,380}]','重炮手神装',152),(34100300,'3阶装备','[{lv,9999}]','重炮手神装3阶',152),(34100400,'4阶装备','[{lv,9999}]','重炮手神装4阶',152),(34100500,'5阶装备','[{lv,9999}]','重炮手神装5阶',152),(34100600,'6阶装备','[{lv,9999}]','重炮手神装6阶',152),(34100700,'7阶装备','[{lv,9999}]','重炮手神装7阶',152),(34100800,'8阶装备','[{lv,9999}]','重炮手神装8阶',152),(34100900,'9阶装备','[{lv,300}]','重炮手神装9阶',152),(34101000,'10阶装备','[{lv,355}]','重炮手神装10阶',152),(34101100,'11阶装备','[{lv,400}]','重炮手神装11阶',152),(34101200,'12阶装备','[{lv,500}]','重炮手神装12阶',152),(34101300,'13阶装备','[{lv,520}]','重炮手神装13阶',152),(34101400,'14阶装备','[{lv,620}]','重炮手神装14阶',152),(34101500,'15阶装备','[{lv,650}]','重炮手神装15阶',152),(34101600,'16阶装备','[{lv,700}]','重炮手神装16阶',152),(40000000,'套装石','[{lv,240}]','套装石',150),(41000000,'魔剑士','[{lv,240}]','魔剑士套装石',150),(41101000,'霸者套装石','[{lv,240}]','霸者套装石',150),(41102000,'修罗套装石','[{lv,240}]','修罗套装石',150),(41201000,'泰坦套装石','[{lv,240}]','泰坦套装石',150),(41202000,'战神套装石','[{lv,240}]','战神套装石',150),(42000000,'龙骑士','[{lv,240}]','龙骑士套装石',150),(42101000,'霸者套装石','[{lv,240}]','霸者套装石',150),(42102000,'修罗套装石','[{lv,240}]','修罗套装石',150),(42201000,'泰坦套装石','[{lv,240}]','泰坦套装石',150),(42202000,'战神套装石','[{lv,240}]','战神套装石',150),(43000000,'魔导师','[{lv,1001}]','魔导师套装石',150),(43101000,'霸者套装石','[{lv,240}]','霸者套装石',150),(43102000,'修罗套装石','[{lv,240}]','修罗套装石',150),(43201000,'泰坦套装石','[{lv,240}]','泰坦套装石',150),(43202000,'战神套装石','[{lv,240}]','战神套装石',150),(44000000,'重炮手','[{lv,240}]','重炮手套装石',150),(44101000,'霸者套装石','[{lv,240}]','霸者套装石',150),(44102000,'修罗套装石','[{lv,240}]','修罗套装石',150),(44201000,'泰坦套装石','[{lv,240}]','泰坦套装石',150),(44202000,'战神套装石','[{lv,240}]','战神套装石',150),(50000000,'道具合成','[{lv,25}]','进阶材料',150),(51000000,'降神进阶','[{lv,25}]','降神进阶',150),(52000000,'坐骑进阶','[{lv,30}]','坐骑进阶',150),(53000000,'神格晋升','[{lv,9999}]','神格晋升',150),(54000000,'星灵升级','[{lv,80}]','星灵升级',150),(55000000,'宝具升级','[{lv,90}]','宝具升级',150),(56000000,'幻彩魔石','[{lv,300}]','幻彩魔石',150),(57000000,'翅膀羽毛','[{lv,180}]','翅膀羽毛',150),(58000000,'宇宙晋升','[{lv,50}]','宇宙晋升',150),(59000000,'门票鲜花','[{lv,75}]','门票鲜花',150),(59100000,'宝宝提升','[{lv,315}]','宝宝提升',150),(60000000,'神格法则','[{lv,9999}]','神格法则',150),(70000000,'双属性魂珠','[{lv,270}]','双属性魂珠合成',181),(71000000,'橙色融合魂珠','[{lv,270}]','橙色双属性魂珠合成',181),(72000000,'红色融合魂珠','[{lv,270}]','红色双属性魂珠合成',181);
/*!40000 ALTER TABLE `base_compose_menu_id` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_consume_type`
--

DROP TABLE IF EXISTS `base_consume_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_consume_type` (
  `type` varchar(255) NOT NULL COMMENT '类型',
  `id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `about` varchar(255) NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='消耗类型配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_consume_type`
--

LOCK TABLES `base_consume_type` WRITE;
/*!40000 ALTER TABLE `base_consume_type` DISABLE KEYS */;
INSERT INTO `base_consume_type` VALUES ('unkown',0,'未知类型'),('goods_use',1,'背包使用'),('equip_wash',2,'装备洗练'),('equip_stren',3,'装备强化'),('stren_break',4,'强化突破'),('offline_exp',5,'获取离线经验消耗物品'),('shop_normal',6,'常用道具商城'),('goods_compose',7,'物品合成'),('change_name',8,'角色改名'),('open_lv_gift',10,'打开等级宝箱'),('create_guild',11,'创建公会'),('mount_add_exp_cost',12,'坐骑升级消耗'),('send_flower',13,'花语鲜花'),('enabled_dress',14,'激活装扮'),('awakening',15,'天命觉醒点亮星格'),('extend_bag',16,'开启背包或者仓库格子'),('modify_announce',17,'修改公会公告'),('revive',18,'玩家复活'),('red_name_be_kill',19,'红名被杀掉绑定钻石'),('gskill_research_cost',20,'公会技能研究'),('gskill_learn_cost',21,'公会技能学习'),('mount_upgrade_star',22,'坐骑升星'),('goods_decompose',25,'物品分解'),('equip_upgrade_stage',26,'装备进阶'),('depot_donate',27,'公会仓库捐献'),('equip_unlock_wash_pos',28,'开启洗炼槽'),('dungeon_enter_cost',29,'副本进入消耗'),('dungeon_count_buy_cost',30,'副本次数购买消耗'),('equip_upgrade_division',31,'装备神锻'),('dungeon_count_sweep_cost',32,'副本扫荡消耗'),('equip_stone_refine',34,'宝石精炼'),('goods_renew',35,'物品续费'),('fashion_active',36,'时装激活'),('mount_active_figure',37,'坐骑激活幻形形象'),('fly_shoes',38,'小飞鞋'),('mount_figure_upgrade_stage',40,'坐骑幻形升阶'),('fashion_color',42,'时装解锁颜色'),('fashion_star',43,'时装升星'),('make_equip_suit',44,'装备套装打造消耗'),('dungeon_encourage',45,'副本鼓舞消耗'),('shop_week',46,'每周限购商城'),('shop_bgold',47,'绑钻商城'),('shop_fashion',48,'时装外形商城'),('wing_active_figure',49,'翅膀化形形象激活'),('wing_upgrade_lv',50,'翅膀升级'),('wing_upgrade_star',51,'翅膀化形升星'),('talent_skill_reset',52,'天赋技能重置消耗'),('boss_home',53,'boss之家'),('boss_forbidden',54,'蛮荒禁地'),('fashion_resolve',55,'时装分解'),('gboss_mat_turn_in',56,'公会Boss魔粉捐献'),('vip_turn_on',57,'使用钻石开通vip'),('vip_renew',58,'使用钻石vip续费'),('finish_task',59,'任务提交消耗'),('wing_use_feather',60,'翅膀羽毛培养'),('personals_send',61,'征友大厅发消息'),('ring_polish',63,'戒指打磨'),('ring_pray',64,'戒指祝福'),('sell_up',68,'市场上架'),('talisman_active_figure',69,'宝具化形形象激活'),('talisman_upgrade_lv',70,'宝具升级'),('talisman_upgrade_star',71,'宝具化形升星'),('talisman_use_feather',72,'宝具培养'),('propose',77,'求婚'),('break_up',78,'分手'),('divorce',79,'离婚'),('jjc_buy_num',81,'竞技购买次数'),('shop_honour',82,'荣誉商城'),('finish_daily_task',83,'直接完成赏金任务'),('finish_guild_task',84,'直接完成公会周任务'),('show_love',85,'秀恩爱'),('send_goods_red_envelopes',86,'使用物品红包'),('top_pk_buy_cost',87,'巅峰竞技购买次数消耗'),('pay_sell',88,'市场购买商品'),('wedding_order',89,'预约婚礼'),('wedding_buy_guest_max',90,'婚礼购买宾客上限'),('wedding_fires',91,'婚礼烟花'),('wedding_candies',92,'婚礼喜糖'),('treasure_hunt',93,'寻宝'),('investment_buy',94,'投资活动消耗'),('goods_exchange',95,'物品兑换'),('baby_aptitude',96,'宝宝资质培养'),('baby_active',97,'激活宝宝'),('baby_knowledge_pray',98,'宝宝学识祝福'),('baby_image_active',99,'宝宝幻形激活'),('baby_image_pray',100,'宝宝幻形培养'),('pray',101,'祈愿'),('use_gift',102,'使用礼包'),('equip_casting_spirit',105,'装备铸灵'),('equip_upgrade_spirit',106,'装备护灵'),('red_envelopes',107,'发红包'),('resource_back',108,'资源找回'),('husong_reflesh',109,'护送刷新'),('retro_checkin',110,'每日签到补签'),('upgrade_dress',111,'装扮升星'),('upgrade_illu',112,'装扮图鉴升级'),('col_world_act',113,'开服集字消耗'),('jjc_inspire',114,'竞技战力鼓舞消耗'),('equip_awakening',115,'装备觉醒'),('guild_rename',116,'公会重命名'),('marriage_life_train',119,'培养一生一世'),('shop_bglod',120,'绑钻商城'),('goods_timeout',121,'物品过期'),('chat',122,'聊天'),('upgrade_guild',123,'升级建筑'),('limit_buy',124,'特惠商城'),('smashed_egg',125,'砸蛋'),('smashed_egg_refresh',126,'砸蛋刷新'),('cloud_buy',127,'众仙云购'),('exchange_act',128,'活动兑换'),('red_name_cost',129,'消除红名扣除钻石'),('redemption_exp',130,'经验赎回'),('buy_gift_times',131,'海滩购买送礼次数'),('fireworks_act',133,'烟花活动'),('buy_goods',134,'购买物品'),('star_active',135,'星图激活'),('limit_shop_buy',136,'神秘限购购买'),('soul_seal_treasure_hunt',137,'魂珠寻宝'),('honor_treasure_hunt',138,'至尊寻宝'),('top_treasure_hunt',139,'巅峰寻宝'),('transfer',140,'转职'),('pay_tax',141,'市场交易税(不能参与任何消费活动)'),('treasure_evaluation',142,'幸运鉴宝'),('quick_buy',143,'快速购买'),('advance_payment',144,'预付款'),('propose_answer_aa',145,'回应求婚aa消耗'),('dungeon_slown_mons',146,'副本减速怪物'),('diamond_league_apply_cost',147,'星钻联赛报名'),('boss_temple',148,'上古神庙'),('collect_put',149,'提交收集活动'),('add_equip_skill',150,'唤魔技能附加'),('remove_equip_skill',151,'拆除唤魔技能'),('upgrade_equip_skill',152,'升级唤魔技能'),('aircraft_active',153,'精灵飞行器激活'),('aircra_stage',154,'精灵飞行器进阶'),('diamond_league_buy_life',155,'星钻联赛购买生命'),('diamond_league_guess',156,'星钻联赛竞猜消耗'),('login_return_reward_buy',157,'0元豪礼'),('deity_level_up',158,'神格升级'),('pyx_active_up',159,'圣器激活'),('pyx_level_up',160,'圣灵培养'),('twing',161,'翅膀'),('god',162,'降神'),('guild_bonfire',163,'公会篝火'),('picture',164,'图鉴激活升级'),('guild_buy_goods',165,'公会商店购买'),('dungeon_sweep_buy_cost',166,'副本扫荡次数购买消耗'),('equip_refine',167,'精炼消耗'),('guild_donate',168,'公会捐献'),('boss_skill',169,'boss鼓舞技能'),('treasure',170,'宝藏系统快速领取奖励消耗'),('pay_auction',171,'竞拍'),('add_personal_goods',172,'上架个人拍卖'),('star_soul_active',173,'星灵激活'),('star_soul_stage',174,'星灵升阶'),('star_soul_star',175,'星灵升星'),('war_god_encourage',176,'荣耀战神鼓舞'),('star_soul_universe',177,'星灵小宇宙突破'),('guild_guard_boss',178,'公会守护召唤boss'),('guild_guard_mon_buff',179,'公会守护基地加固'),('upgrade_rune_skill',180,'升级符文技能'),('throwing_eggs',181,'砸蛋'),('guild_war_inspire',182,'公会鼓舞消耗'),('dungoen_flop',183,'副本翻牌'),('buy_vip_limit_giftbag',184,'购买vip限量礼包'),('shop_3v3',185,'3v3商店'),('beach_put_vote',186,'魅力海滩拉票花费'),('dungoen_rotate',187,'副本转盘'),('husong',188,'护送租用飞艇消耗'),('drumwar_sign',189,'钻石大战报名'),('drumwar_live',190,'钻石大战购买命数'),('drumwar_choose',191,'钻石大战竞猜'),('drumwar_skill',192,'钻石大战技能使用'),('task_double',193,'主线任务双倍奖励'),('mount_stren',194,'坐骑装备升级'),('mount_smelt',195,'坐骑装备熔炼'),('mount_make',196,'坐骑装备打造'),('kf_town_war_buy_good',197,'跨服城战商店'),('buy_fishing_gear',198,'购买渔具'),('fishing_consume',199,'钓鱼消耗'),('kf_town_war_assist',200,'宣战应援'),('dstone_upstage',201,'双属性宝石升阶消耗'),('star_soul_treasure_lucky_draw',202,'星灵宝箱幸运抽奖'),('discount_giftbag',203,'巨折献礼'),('spec_sell_act',204,'精品特卖'),('custom_act_investment',206,'运营活动投资消耗'),('daily_turntable',207,'每日转盘'),('active_miner',208,'雇佣矿工'),('parade_order',209,'巡游预约'),('build_pink_equip',210,'粉装、神装打造'),('role_home',211,'家园'),('kf_cloud_buy',212,'跨服云购购买'),('parade_strew_flower',213,'巡游撒花'),('live_skill',214,'生活技能'),('parade_fires',215,'巡游放烟花'),('mold_soul_upgrade',216,'星痕铸魂升级'),('stren_star_shadow',217,'星痕强化'),('equip_devour',218,'装备吞噬'),('star_soul_study_skill',219,'星灵学习技能'),('star_soul_upgrade_skill',220,'星灵升级技能'),('activate_baby',221,'激活宝宝'),('upgrade_baby',222,'升级宝宝'),('baby_learn_talent',223,'宝宝学习天赋'),('baby_reset_talent',224,'宝宝重置天赋'),('star_soul_equip_stren',225,'星灵装备强化'),('upgrade_baby_talent',226,'宝宝天赋提升'),('star_soul_war_buy_sweep',227,'星灵试炼购买扫荡次数'),('star_soul_drum_choose',228,'星灵争霸竞猜'),('star_soul_equip_resolve',229,'星灵装备分解'),('star_soul_equip_stren_break',230,'星灵装备强化突破'),('shop_star_war',231,'星灵试炼商店'),('kf_1vn_bet',232,'跨服1vn押注'),('shop_invade',233,'入侵商店'),('lucky_flop_cost',234,'幸运翻牌'),('lucky_flop_refresh',235,'幸运翻牌刷新'),('sp_shop_refresh',236,'黑市商店刷新'),('sp_shop_resolve',237,'黑市商店分解'),('sp_shop_buy',238,'黑市商店购买'),('kf_1vn_auction',239,'跨服1vn竞拍'),('vip_gift_card',240,'vip认证礼包'),('guild_war',241,'公会争霸'),('shop_1vn',242,'1vn商城购买'),('send_parade',243,'发起巡游'),('send_parade_aa',244,'发起AA制巡游'),('answer_wedding_aa',245,'答应AA制婚礼'),('answer_parade_aa',246,'答应AA制巡游'),('send_wedding',247,'发起婚礼'),('send_wedding_aa',248,'发起AA制婚礼'),('fish_illustration',249,'鱼类图鉴'),('onhook_card',250,'购买挂机时长卡'),('treasure_guardian',251,'购买宝藏守护'),('overflow_gift_act',252,'超值礼包'),('seal_soul_resolve',253,'分解魂珠'),('supplication',254,'祈愿'),('seal_soul_stren',255,'魂珠升级'),('capsule_toys',256,'超级扭蛋'),('goldmine_upgrade',257,'矿洞升级'),('twing_plume',258,'翅膀羽化'),('race_act',259,'竞榜抽奖'),('shop_diamond_vip',260,'至尊vip商店'),('buy_love_box',261,'购买爱情宝盒'),('race_act_buy',262,'竞榜快速购买'),('upgrade_prefix',263,'装备重铸'),('joy_wish',264,'欢乐许愿'),('twing_figure_up',265,'翅膀幻化升星'),('activate_light_weapon_normal',266,'激活专武'),('light_weapon_normal_uplv',267,'专武升级'),('light_weapon_normal_upgrade',268,'专武提升'),('light_weapon_figure_activate',269,'光武激活'),('light_weapon_figure_upstar',270,'光武升星'),('baby_up_stage',271,'宝宝升阶'),('baby_up_grade',272,'宝宝养育'),('baby_figure_up_stage',273,'宝宝幻形升阶'),('vip_bag_onsale',274,'VIP特惠'),('baby_lv_cost',275,'宝宝升阶'),('baby_mount_lv_cost',276,'宝宝坐骑升阶'),('god_stren_rune',277,'降神升级符文'),('gm_cost',278,'秘籍消耗');
/*!40000 ALTER TABLE `base_consume_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_counter`
--

DROP TABLE IF EXISTS `base_counter`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_counter` (
  `module` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '次数id',
  `limit` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上限',
  `about` varchar(255) NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`module`,`id`),
  KEY `id` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='终生次数id配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_counter`
--

LOCK TABLES `base_counter` WRITE;
/*!40000 ALTER TABLE `base_counter` DISABLE KEYS */;
INSERT INTO `base_counter` VALUES (150,16010001,0,'气血兽魂'),(150,16010002,0,'防御兽魂'),(150,16010003,0,'全能兽魂'),(150,16010004,0,'攻击兽魂'),(150,16010005,0,'暴击兽魂'),(150,16010006,0,'破甲兽魂'),(150,18010001,2,'小兽魂'),(150,18010002,2,'中兽魂'),(150,18010003,2,'大兽魂'),(150,20020001,0,'生命神羽'),(150,20020002,0,'闪避神羽'),(150,20020003,0,'全能神羽'),(150,22020001,0,'暴击剑灵'),(150,22020002,0,'坚韧剑灵'),(150,22020003,0,'全能剑灵'),(150,24020001,0,'攻击魂珠'),(150,24020002,0,'命中魂珠'),(150,24020003,0,'全能魂珠'),(150,24020004,0,'大全能圣魂'),(157,2,1,'活力值'),(172,1,1,'征友大厅免费次数'),(172,2,2,'成为过情侣或夫妻'),(173,1,0,'幻兽出战槽位'),(331,1,0,'五星评价'),(331,11,0,'五星评价'),(412,2,1,'伙伴招募次数'),(416,1,0,'符文寻宝次数'),(416,2,0,'下次免费寻宝时间'),(416,3,0,'装备寻宝次数'),(417,1,1,'下载礼包领取记录'),(423,1,0,'开服集字今日已兑次数'),(430,1,1,'免费固定奖励'),(431,1,1,'系统赠送星痕次数'),(450,3,0,'玩家登陆获得的总vip经验'),(450,4,0,'通过消耗钻石获得的vip经验'),(450,5,0,'使用道具获得的vip经验'),(460,1,1,'新手boss副本'),(500,1,10,'天数护送完成最高品质天使护送次数获得称号'),(500,2,1,'第一次刷新护送天使（第一次护送有效）'),(500,3,1,'第一次打开护送');
/*!40000 ALTER TABLE `base_counter` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_counter_daily`
--

DROP TABLE IF EXISTS `base_counter_daily`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_counter_daily` (
  `module` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '次数id',
  `limit` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上限',
  `clock` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '清理时间',
  `write_db` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否入库',
  `about` varchar(255) NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`module`,`id`),
  KEY `id` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='每日次数id配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_counter_daily`
--

LOCK TABLES `base_counter_daily` WRITE;
/*!40000 ALTER TABLE `base_counter_daily` DISABLE KEYS */;
INSERT INTO `base_counter_daily` VALUES (110,1,999,4,1,'跨服聊天次数'),(110,2,999,4,1,'跨服vip聊天次数'),(132,1,0,4,1,'今日累计离线挂机奖励时间'),(151,1,10,4,1,'玩家每日交易次数上限'),(152,1,3,24,1,'免费洗练次数'),(153,1,1,4,1,'宠物防御精华'),(153,2,1,4,1,'坐骑防御精华'),(153,3,1,4,1,'30绑钻'),(153,4,1,4,1,'密室入场券'),(153,5,1,4,1,'天使令'),(153,6,1,4,1,'1.5倍经验药水'),(153,7,1,4,1,'小飞鞋'),(153,8,20,4,1,'主线1圣器碎片'),(153,9,20,4,1,'主线2圣器碎片'),(153,10,20,4,1,'主线3圣器碎片'),(153,11,20,4,1,'主线4圣器碎片'),(153,12,20,4,1,'圣灵1初级材料'),(153,13,10,4,1,'圣灵1中级材料'),(153,14,5,4,1,'圣灵1高级材料'),(153,15,2,4,1,'活力红茶'),(153,16,1,4,1,'绑钻'),(153,17,1,4,1,'紫色护送令牌'),(157,1,150,4,1,'玩家活跃度'),(157,2,0,4,1,'玩家活力'),(221,1,1,4,1,'榜单点赞次数'),(223,15,0,4,1,'砸一个鸡蛋的次数'),(223,16,30,4,1,'砸一筐鸡蛋的次数'),(226,1,1,4,1,'榜单点赞次数'),(280,1,10,4,1,'竞技鼓舞次数'),(280,2,10,4,1,'竞技挑战使用次数'),(280,3,0,4,1,'竞技购买次数'),(281,1,0,24,1,'巅峰竞技奖励日常领取'),(281,2,10,24,1,'巅峰竞技每日可参与次数'),(281,3,0,24,1,'购买次数'),(281,4,0,24,1,'每日次数奖励领取'),(300,1,15,4,1,'每日日常任务'),(300,2,10,4,1,'每日公会任务'),(331,20,10,24,1,'活动boss采集数量'),(331,31,600,24,1,'幸运鉴宝幸运值'),(400,1,1,4,1,'公会捐献方式1'),(400,2,0,4,1,'公会捐献方式2'),(400,3,10,4,1,'公会仓库额外商品兑换'),(402,1,1,4,1,'主宰公会俸禄'),(415,1,0,4,1,'金币祈愿'),(415,2,0,4,1,'经验祈愿'),(416,3,24,4,1,'免费魂珠寻宝次数限制'),(416,4,5000,4,1,'魂珠寻宝次数限制'),(416,11,5000,4,1,'装备付费寻宝次数限制'),(416,21,5000,4,1,'巅峰寻宝'),(416,31,5000,4,1,'至尊寻宝'),(417,2,0,24,1,'每日签到签到次数'),(417,3,0,4,1,'夜间福利领取状态'),(423,2,3,24,1,'钻石矿车免费试用次数'),(423,3,3,24,1,'钻石书馆免费试用次数'),(429,1,1,4,1,'捕蝶参加次数'),(432,2,1,4,1,'每日扫荡购买次数'),(432,3,1,4,1,'每日扫荡消耗次数'),(450,1,0,4,1,'每日登录增加vip经验次数'),(450,2,0,24,1,'至尊vip商城13001限购'),(450,3,0,24,1,'至尊vip商城13002限购'),(450,4,0,24,1,'至尊vip商城13003限购'),(450,5,0,24,1,'至尊vip商城13004限购'),(450,6,0,24,1,'至尊vip商城13005限购'),(450,7,0,24,1,'至尊vip商城13006限购'),(450,8,0,24,1,'至尊vip商城13007限购'),(450,9,0,24,1,'至尊vip商城13008限购'),(450,10,0,24,1,'至尊vip商城13009限购'),(450,11,0,24,1,'至尊vip商城13010限购'),(450,12,0,24,1,'至尊vip商城13011限购'),(450,13,0,24,1,'至尊vip商城13012限购'),(450,14,0,24,1,'至尊vip商城13000限购'),(450,15,1,4,1,'至尊vip无敌buff次数'),(450,16,0,24,1,'至尊vip商城13013限购'),(450,17,0,24,1,'至尊vip限购13014'),(450,18,0,24,1,'至尊vip限购13015'),(450,19,0,24,1,'至尊vip限购13016'),(450,20,0,24,1,'至尊vip限购13017'),(450,21,0,24,1,'至尊vip限购13018'),(450,22,0,24,1,'至尊vip限购13019'),(450,23,0,24,1,'至尊vip限购13020'),(450,24,0,24,1,'至尊vip限购13021'),(450,25,0,24,1,'至尊vip限购13022'),(460,1,3,4,1,'世界BOSS疲劳值'),(460,4,5,4,1,'蛮荒禁地进入次数'),(460,5,1,4,1,'诛魔之地疲劳'),(460,100,0,4,1,'世界boss参与奖次数'),(460,300,0,4,1,'首领会所参与奖次数'),(460,500,0,4,1,'诛魔之地参与奖次数'),(461,1,10,4,1,'跨服boss采集次数'),(461,2,3,4,1,'跨服boss疲劳值'),(500,2,3,4,1,'天使护送每日可护送次数'),(500,3,5,4,1,'天使护送每日可拦截次数'),(500,4,0,4,1,'天使护送每日拦截获得经验'),(500,5,0,4,1,'天使护送每日拦截获得铜币'),(500,6,10,4,1,'护送每日协助奖励次数'),(609,1,0,4,1,'限时boss伤害奖励次数'),(609,2,0,4,1,'非限时采集奖励次数'),(609,3,0,4,1,'限时采集奖励次数'),(610,1,0,4,1,'进入次数'),(610,2,0,4,1,'助战次数'),(610,3,0,4,1,'副本完成次数（和副本进入次数保持一致）,进入次数可能被玩家重置，完成次数不会'),(610,4,0,4,1,'副本购买次数'),(610,5,0,4,1,'重置次数'),(610,6,0,4,1,'助战奖励次数'),(610,7,0,4,1,'副本扫荡购买次数'),(610,8,0,4,1,'副本扫荡次数'),(610,10,3,4,1,'个人BOSS进入次数'),(621,1,5,4,1,'擂主商店1级攻击宝石'),(621,2,5,4,1,'擂主商店2级攻击宝石'),(621,3,5,4,1,'擂主商店3级攻击宝石'),(621,4,5,4,1,'擂主商店4级攻击宝石'),(621,5,5,4,1,'擂主商店5级攻击宝石'),(621,6,5,4,1,'擂主商店6级攻击宝石'),(621,7,5,4,1,'擂主商店7级攻击宝石'),(621,8,5,4,1,'擂主商店8级攻击宝石'),(621,9,5,4,1,'擂主商店9级攻击宝石'),(621,10,5,4,1,'挑战者商店1级防御宝石'),(621,11,5,4,1,'挑战者商店2级防御宝石'),(621,12,5,4,1,'挑战者商店3级防御宝石'),(621,13,5,4,1,'挑战者商店4级防御宝石'),(621,14,5,4,1,'挑战者商店5级防御宝石'),(621,15,5,4,1,'挑战者商店6级防御宝石'),(621,16,5,4,1,'挑战者商店7级防御宝石'),(621,17,5,4,1,'挑战者商店8级防御宝石'),(621,18,5,4,1,'挑战者商店9级防御宝石'),(650,1,50,24,1,'3v3商店普通防具石箱子'),(650,2,25,24,1,'3v3商店普通武器石箱子'),(650,3,50,24,1,'3v3商店完美防具石箱子'),(650,4,25,24,1,'3v3商店完美防具石箱子'),(650,5,20,24,1,'3v3商店初级烈火晶核'),(650,6,10,24,1,'3v3商店中级烈火晶核'),(650,7,5,24,1,'3v3商店高级烈火晶核'),(650,8,10,24,1,'3v3商店月神印记'),(650,9,10,24,1,'3v3商店冰雪印记'),(650,10,10,24,1,'3v3商店光明神印记');
/*!40000 ALTER TABLE `base_counter_daily` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_counter_daily_extra`
--

DROP TABLE IF EXISTS `base_counter_daily_extra`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_counter_daily_extra` (
  `module` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `sub_module` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能子id',
  `limit` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上限',
  `clock` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '清理时间',
  `write_db` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否入库',
  `about` varchar(255) NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`module`,`sub_module`),
  KEY `sub_module` (`sub_module`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='每日次数id配置(额外版)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_counter_daily_extra`
--

LOCK TABLES `base_counter_daily_extra` WRITE;
/*!40000 ALTER TABLE `base_counter_daily_extra` DISABLE KEYS */;
INSERT INTO `base_counter_daily_extra` VALUES (140,1,5,4,1,'组队通关副本增加亲密度'),(140,2,5,4,1,'组队杀怪增加亲密度'),(150,1,0,4,1,'单个物品掉落次数'),(150,2,1,4,1,'礼包每天次数上限'),(157,1,0,4,1,'活动完成次数'),(157,2,1,4,1,'活跃度奖励'),(159,1,1,4,1,'福利卡领取次数'),(159,2,1,4,1,'成长基金领取次数'),(331,28,0,24,1,'幸运抽奖次数'),(331,31,800,24,1,'幸运鉴宝幸运值'),(331,45,0,24,1,'每日推送最大数量'),(339,1,1,24,1,'触发式红包'),(339,2,1,4,1,'物品红包使用上限'),(339,3,1,24,1,'活动物品红包使用上限'),(417,2,1,24,1,'每日在线时长礼包领取次数'),(450,1,1,4,1,'vip每日礼包'),(461,1,0,4,1,'采集怪采集次数'),(606,1,0,4,1,'宝箱采集次数'),(610,1,0,4,1,'副本进入'),(610,2,0,4,1,'副本协助'),(610,3,0,4,1,'副本完成次数（和副本进入次数保持一致）,进入次数可能被玩家重置，完成次数不会'),(610,4,0,4,1,'副本购买次数'),(610,5,0,4,1,'重置次数'),(610,6,0,4,1,'副本协助奖励次数'),(610,7,0,4,1,'副本扫荡购买次数'),(610,8,0,4,1,'副本扫荡次数'),(610,9,1,4,1,'副本道具增加次数'),(610,10,1,4,1,'副本道具已使用次数'),(610,12,1,4,1,'使用道具增加特殊扫荡次数(宝石)');
/*!40000 ALTER TABLE `base_counter_daily_extra` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_counter_extra`
--

DROP TABLE IF EXISTS `base_counter_extra`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_counter_extra` (
  `module` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `sub_module` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能子id',
  `limit` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上限',
  `about` varchar(255) NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`module`,`sub_module`),
  KEY `sub_module` (`sub_module`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='终生次数id配置(额外版)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_counter_extra`
--

LOCK TABLES `base_counter_extra` WRITE;
/*!40000 ALTER TABLE `base_counter_extra` DISABLE KEYS */;
INSERT INTO `base_counter_extra` VALUES (155,3,0,'圣魂使用次数'),(159,2,0,'用来保存每日累充的周期时间'),(300,1,1,'新手触发长剧情次数'),(339,1,1,'触发式红包上限'),(339,2,1,'物品红包使用上限'),(450,1,1,'特权礼包'),(450,3,0,'当日消耗钻石增加vip经验值，2点重置'),(450,4,0,'当日登录增加的vip经验值，2点重置'),(610,1,0,'副本进入'),(610,3,0,'副本挑战胜利'),(610,11,1,'副本首次进入');
/*!40000 ALTER TABLE `base_counter_extra` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_counter_week`
--

DROP TABLE IF EXISTS `base_counter_week`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_counter_week` (
  `module` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '次数id',
  `limit` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上限',
  `about` varchar(255) NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`module`,`id`),
  KEY `id` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='每周次数id配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_counter_week`
--

LOCK TABLES `base_counter_week` WRITE;
/*!40000 ALTER TABLE `base_counter_week` DISABLE KEYS */;
INSERT INTO `base_counter_week` VALUES (153,1,10,'初级神晶'),(153,2,10,'初级圣物石'),(153,3,6,'圣灵1初级材料'),(153,4,5,'圣灵2初级材料'),(153,5,10,'星灵粉尘'),(153,6,5,'坐骑祝福券'),(153,7,1,'2倍经验符'),(153,8,1,'2.5倍经验符'),(153,9,10,'4级攻击向宝石包'),(153,10,10,'4级防御向宝石包'),(153,11,10,'中级神晶'),(153,12,10,'中级圣物石'),(153,13,6,'圣灵1中级材料'),(153,14,5,'圣灵2中级材料'),(153,15,10,'星灵晶石'),(153,16,5,'坐骑祝福券'),(153,17,1,'2倍经验符'),(153,18,1,'2.5倍经验符'),(153,19,10,'5级攻击向宝石包'),(153,20,10,'5级防御向宝石包'),(153,21,9,'星灵召唤卷'),(153,22,5,'中级符文升级材料'),(339,1,1,'每周活动'),(417,3,1,'周一礼包'),(432,1,1,'每周免费扫荡次数'),(450,1,15,'vip每周礼包领取次数'),(621,1,15,'利刃精粹'),(621,2,15,'坚盾精粹'),(621,3,4,'致命原石'),(621,4,4,'神佑原石'),(621,5,10,'6阶宝石包'),(621,6,6,'利刃精粹'),(621,7,6,'坚盾精粹'),(621,8,4,'5阶宝石包'),(621,9,15,'利刃精粹'),(621,10,15,'坚盾精粹'),(621,11,4,'5阶宝石包'),(621,12,4,'利刃精粹'),(621,13,10,'坚盾精粹'),(621,14,6,'4阶宝石包'),(621,15,6,'利刃精粹'),(621,16,4,'坚盾精粹'),(621,17,10,'致命原石'),(621,18,10,'神佑原石'),(621,19,4,'7阶宝石包'),(621,20,4,'利刃精粹'),(621,21,4,'坚盾精粹'),(621,22,2,'6阶宝石包'),(621,23,10,'利刃精粹'),(621,24,10,'坚盾精粹'),(621,25,4,'6阶宝石宝'),(621,26,4,'利刃精粹'),(621,27,4,'坚盾精粹'),(621,28,2,'5阶宝石包'),(650,1,50,'道具1'),(650,2,25,'道具2'),(650,3,20,'道具3'),(650,4,10,'道具4'),(650,5,20,'道具5'),(650,6,10,'道具6'),(650,7,5,'道具7'),(650,8,10,'道具8'),(650,9,10,'道具9'),(650,10,10,'道具10');
/*!40000 ALTER TABLE `base_counter_week` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_counter_week_extra`
--

DROP TABLE IF EXISTS `base_counter_week_extra`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_counter_week_extra` (
  `module` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `sub_module` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能子id',
  `limit` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上限',
  `about` varchar(255) NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`module`,`sub_module`),
  KEY `sub_module` (`sub_module`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='每周次数id配置(额外版)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_counter_week_extra`
--

LOCK TABLES `base_counter_week_extra` WRITE;
/*!40000 ALTER TABLE `base_counter_week_extra` DISABLE KEYS */;
INSERT INTO `base_counter_week_extra` VALUES (150,1,0,'单个物品掉落次数'),(339,1,1,'触发式红包上限'),(339,2,1,'物品红包使用上限'),(432,4,10,'商城每周购买物品次数'),(610,1,0,'副本进入');
/*!40000 ALTER TABLE `base_counter_week_extra` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_custom_act`
--

DROP TABLE IF EXISTS `base_custom_act`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_custom_act` (
  `type` smallint(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动主类型',
  `subtype` smallint(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `act_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '活动类型',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '活动名字@lang@',
  `desc` varchar(1024) NOT NULL DEFAULT '' COMMENT '活动描述@lang@',
  `opday_lim` varchar(255) NOT NULL DEFAULT '[]' COMMENT '开服天数限制',
  `merday_lim` varchar(255) NOT NULL DEFAULT '[]' COMMENT '合服天数限制',
  `optype` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '开启类型',
  `opday` varchar(255) NOT NULL DEFAULT '[]' COMMENT '开启日期',
  `optime` varchar(255) NOT NULL DEFAULT '[]' COMMENT '开启时间段',
  `start_time` varchar(255) NOT NULL DEFAULT '0' COMMENT '开始时间',
  `end_time` varchar(255) NOT NULL DEFAULT '0' COMMENT '结束时间',
  `clear_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '清理类型',
  `condition` varchar(2048) NOT NULL DEFAULT '[]' COMMENT '条件',
  PRIMARY KEY (`type`,`subtype`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='定制活动';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_custom_act`
--

LOCK TABLES `base_custom_act` WRITE;
/*!40000 ALTER TABLE `base_custom_act` DISABLE KEYS */;
INSERT INTO `base_custom_act` VALUES (1,1,3,'魅力榜','送礼就对了','[]','[]',1,'[]','[]','2019-02-14 12:00:00','2019-02-16 12:00:00',1,'[{rank_len, 50},{rank_limit, 100},{role_lv,75}]'),(2,1,4,'跨服魅力榜','跨服魅力榜','[{8,9999}]','[]',1,'[]','[]','2019-06-25 00:00:00','2019-06-25 23:59:59',3,'[{rank_len,100},{rank_limit, 200},{rank_show_len, 50},{role_lv,150}]'),(3,1,4,'婚礼大比拼','活动期间内，排名前二十的婚礼双方即可获得奖励！','[{8,9999}]','[]',1,'[]','[]','2019-06-25 00:00:00','2019-06-25 23:59:59',3,'[{rank_len, 20},{reward_times, [{1,1},{2,2}, {3,3}]},{discount,80},{role_lv,200}]'),(4,1,1,'信物有礼','活动时间内，野外挂机击杀小怪即可掉落星灵信物，收集信物即可兑换豪礼，活动过期道具作废（秘境远征同样能获得道具）','[{1,8}]','[]',1,'[]','[]','0','0',3,'[{role_lv, 80},{sp_gap_time, 7}, {clear_type, day}]'),(4,2,3,'我爱地球','活动期间，野外挂机击杀小怪可掉落文字道具—“携”“手”“爱”“地”“球”，收集道具即可兑换豪礼，活动过期道具作废（离线挂机也能获得道具）','[{8,999}]','[]',1,'[]','[]','2019-06-04 00:00:00','2019-06-06 00:00:00',1,'[{role_lv, 1001},{sp_gap_time,3}]'),(4,4,3,'集字掉落','活动时间内，野外挂机击杀小怪即可掉落文字道具—“开”“服”“嗨”“翻”“天”，收集道具即可兑换豪礼，活动过期道具作废（离线挂机同样能获得道具）','[{8,999}]','[]',1,'[]','[]','2019-06-04 00:00:00','2019-06-06 00:00:00',3,'[{role_lv, 80},{sp_gap_time, 7}, {clear_type, day}]'),(4,101,2,'合服集字掉落','活动时间内，野外挂机击杀小怪即可掉落文字道具—“合”“服”“倍”“儿”“爽”，收集道具即可兑换豪礼，活动过期道具作废（离线挂机同样能获得道具）','[]','[]',1,'[]','[]','2019-03-27 00:00:00','2019-03-28 00:00:00',3,'[{role_lv, 80},{sp_gap_time, 7}]'),(6,1,4,'每日累充','每日累充+累计充值','[]','[]',1,'[]','[]','2019-04-03 00:00:00','2021-08-03 00:00:00',1,'[]'),(7,1,1,'七日累充','开服七天内，累计充值可领取豪华大礼——炫酷背饰、绝版光武等你来拿~','[{1,7}]','[]',1,'[]','[]','2018-04-09 00:00:00','2023-04-10 23:59:59',2,'[]'),(7,2,1,'经验返利','活动期间，每日累充到一定金额，即可领取丰厚的返利奖励！','[{1,1}]','[]',1,'[]','[]','2019-04-19 00:00:00','2023-04-21 23:59:59',2,'[{role_lv,40}]'),(7,3,1,'经验返利','活动期间，每日累充到一定金额，即可领取丰厚的返利奖励！','[{2,2}]','[]',1,'[]','[]','2019-04-11 00:00:00','2023-04-11 23:59:59',2,'[{role_lv,40}]'),(7,4,1,'坐骑返利','活动期间，每日累充到一定金额，即可领取丰厚的返利奖励！','[{3,3}]','[]',1,'[]','[]','2019-04-23 00:00:00','2023-04-23 23:59:59',2,'[{role_lv,40}]'),(7,5,1,'降神返利','活动期间，每日累充到一定金额，即可领取丰厚的返利奖励！','[{4,4}]','[]',1,'[]','[]','2019-04-23 00:00:00','2023-04-23 23:59:59',2,'[{role_lv,40}]'),(7,6,1,'魂珠返利','活动期间，每日累充到一定金额，即可领取丰厚的返利奖励！','[{5,5}]','[]',1,'[]','[]','2019-04-23 00:00:00','2023-04-23 23:59:59',2,'[{role_lv,40}]'),(7,7,1,'宝石返利','活动期间，每日累充到一定金额，即可领取丰厚的返利奖励！','[{6,6}]','[]',1,'[]','[]','2019-04-23 00:00:00','2023-04-23 23:59:59',2,'[{role_lv,40}]'),(7,8,1,'装备返利','活动期间，每日累充到一定金额，即可领取丰厚的返利奖励！','[{6,6}]','[]',1,'[]','[]','2019-04-23 00:00:00','2023-04-23 23:59:59',2,'[{role_lv,40}]'),(7,9,1,'专武返利','活动期间，每日累充到一定金额，即可领取丰厚的返利奖励！','[{7,7}]','[]',1,'[]','[]','2019-04-23 00:00:00','2023-04-23 23:59:59',2,'[{role_lv,40}]'),(7,10,1,'每日累充','活动期间，每日累充到一定金额，即可领取丰厚的返利奖励！','[{8,8}]','[]',1,'[]','[]','2019-04-23 00:00:00','2023-04-23 23:59:59',2,'[{role_lv,40}]'),(7,11,3,'每日累充','活动期间，每日累充到一定金额，即可领取丰厚的返利奖励！','[{9,9}]','[]',1,'[]','[]','2019-04-23 00:00:00','2023-04-23 23:59:59',2,'[{role_lv,40}]'),(7,12,3,'每日累充','活动期间，每日累充到一定金额，即可领取丰厚的返利奖励！','[{10,10}]','[]',1,'[]','[]','2019-04-23 00:00:00','2023-04-23 23:59:59',2,'[{role_lv,40}]'),(7,13,3,'每日累充','活动期间，每日累充到一定金额，即可领取丰厚的返利奖励！','[{11,11}]','[]',1,'[]','[]','2019-04-23 00:00:00','2023-04-23 23:59:59',2,'[{role_lv,40}]'),(7,14,3,'每日累充','活动期间，每日累充到一定金额，即可领取丰厚的返利奖励！','[{12,12}]','[]',1,'[]','[]','2019-04-23 00:00:00','2023-04-23 23:59:59',2,'[{role_lv,40}]'),(7,15,3,'每日累充','活动期间，每日累充到一定金额，即可领取丰厚的返利奖励！','[{13,13}]','[]',1,'[]','[]','2019-04-23 00:00:00','2023-04-23 23:59:59',2,'[{role_lv,40}]'),(7,16,3,'每日累充','活动期间，每日累充到一定金额，即可领取丰厚的返利奖励！','[{14,14}]','[]',1,'[]','[]','2019-04-23 00:00:00','2023-04-23 23:59:59',2,'[{role_lv,40}]'),(7,17,3,'每日累充','活动期间，每日累充到一定金额，即可领取丰厚的返利奖励！','[{15,15}]','[]',1,'[]','[]','2019-04-23 00:00:00','2023-04-23 23:59:59',2,'[{role_lv,40}]'),(7,18,3,'每日累充','活动期间，每日累充到一定金额，即可领取丰厚的返利奖励！','[{16,16}]','[]',1,'[]','[]','2019-04-23 00:00:00','2023-04-23 23:59:59',2,'[{role_lv,40}]'),(7,19,3,'每日累充','活动期间，每日累充到一定金额，即可领取丰厚的返利奖励！','[{17,17}]','[]',1,'[]','[]','2019-04-23 00:00:00','2023-04-23 23:59:59',2,'[{role_lv,40}]'),(7,20,3,'每日累充','活动期间，每日累充到一定金额，即可领取丰厚的返利奖励！','[{18,18}]','[]',1,'[]','[]','2019-04-23 00:00:00','2023-04-23 23:59:59',2,'[{role_lv,40}]'),(7,21,3,'每日累充','活动期间，每日累充到一定金额，即可领取丰厚的返利奖励！','[{19,19}]','[]',1,'[]','[]','2019-04-23 00:00:00','2023-04-23 23:59:59',2,'[{role_lv,40}]'),(7,22,3,'每日累充','活动期间，每日累充到一定金额，即可领取丰厚的返利奖励！','[{20,20}]','[]',1,'[]','[]','2019-04-23 00:00:00','2023-04-23 23:59:59',2,'[{role_lv,40}]'),(7,23,3,'每日累充','活动期间，每日累充到一定金额，即可领取丰厚的返利奖励！','[{21,21}]','[]',1,'[]','[]','2019-04-23 00:00:00','2023-04-23 23:59:59',2,'[{role_lv,40}]'),(7,24,3,'每日累充','活动期间，每日累充到一定金额，即可领取丰厚的返利奖励！','[{22,22}]','[]',1,'[]','[]','2019-04-23 00:00:00','2023-04-23 23:59:59',2,'[{role_lv,40}]'),(7,25,3,'每日累充','活动期间，每日累充到一定金额，即可领取丰厚的返利奖励！','[{23,23}]','[]',1,'[]','[]','2019-04-23 00:00:00','2023-04-23 23:59:59',2,'[{role_lv,40}]'),(7,26,3,'每日累充','活动期间，每日累充到一定金额，即可领取丰厚的返利奖励！','[{24,24}]','[]',1,'[]','[]','2019-04-23 00:00:00','2023-04-23 23:59:59',2,'[{role_lv,40}]'),(7,27,3,'每日累充','活动期间，每日累充到一定金额，即可领取丰厚的返利奖励！','[{25,25}]','[]',1,'[]','[]','2019-04-23 00:00:00','2023-04-23 23:59:59',2,'[{role_lv,40}]'),(7,28,3,'每日累充','活动期间，每日累充到一定金额，即可领取丰厚的返利奖励！','[{26,26}]','[]',1,'[]','[]','2019-04-23 00:00:00','2023-04-23 23:59:59',2,'[{role_lv,40}]'),(7,29,3,'每日累充','活动期间，每日累充到一定金额，即可领取丰厚的返利奖励！','[{27,27}]','[]',1,'[]','[]','2019-04-23 00:00:00','2023-04-23 23:59:59',2,'[{role_lv,40}]'),(7,30,3,'每日累充','活动期间，每日累充到一定金额，即可领取丰厚的返利奖励！','[{28,28}]','[]',1,'[]','[]','2019-04-23 00:00:00','2023-04-23 23:59:59',2,'[{role_lv,40}]'),(7,31,6,'每日累充','活动期间，每日累充到一定金额，即可领取丰厚的返利奖励！','[{5,999}]','[]',1,'[]','[]','2019-08-09 00:30:00','2019-08-09 23:59:59',2,'[{role_lv,40}]'),(7,32,6,'每日累充','活动期间，每日累充到一定金额，即可领取丰厚的返利奖励！','[{5,999}]','[]',1,'[]','[]','2019-08-10 00:00:00','2019-08-10 23:59:59',2,'[{role_lv,40}]'),(7,33,6,'每日累充','活动期间，每日累充到一定金额，即可领取丰厚的返利奖励！','[{5,999}]','[]',1,'[]','[]','2019-08-11 00:00:00','2019-08-11 23:59:59',2,'[{role_lv,40}]'),(7,34,6,'每日累充','活动期间，每日累充到一定金额，即可领取丰厚的返利奖励！','[{5,999}]','[]',1,'[]','[]','2019-08-12 00:00:00','2019-08-12 23:59:59',2,'[{role_lv,40}]'),(8,1,3,'金榜题名掉落','金榜题名掉落','[{4,9999}]','[]',1,'[]','[]','2018-05-01 00:00:00','2018-05-02 23:59:59',1,'[]'),(9,1,3,'节日活动—跨服','节日活动—跨服','[]','[]',1,'[]','[{{0,0,0},{23,59,59}}]','2018-01-11 00:00:00','2018-03-25 23:59:59',1,'[]'),(10,1,1,'开服冲榜','开服冲榜领好礼','[{1,8}]','[]',1,'[]','[]','0','0',2,'[{role_lv,1}]'),(11,1,3,'五星评价','活动期间，只需花几秒钟前往appstore写下五星好评，即可领取礼包，您的支持就是我们的最大动力！','[{1,9999}]','[]',1,'[]','[{{0,0,0},{23,59,59}}]','2018-01-31 00:00:00','2018-03-25 23:59:59',1,'[]'),(12,1,3,'双倍掉落','星灵副本，降神副本掉落翻倍','[{8,9999}]','[]',1,'[]','[]','2019-06-25 00:00:00','2019-06-25 23:59:59',1,'[{role_lv,150},{types,[{18,2},{19,2}]}]'),(13,1,6,'欢乐砸蛋','砸蛋','[{5,9999}]','[]',1,'[]','[]','2019-08-09 00:30:00','2019-08-09 23:59:59',3,'[{role_lv,150},{free_refresh_times,0},{smashed_times_lim,9999}, {all_use_num,160}, {refresh_cost,20}, {smash_goods, 38180015}, {smash_goods_num,20}]'),(13,2,6,'欢乐砸蛋','砸蛋','[{5,9999}]','[]',1,'[]','[]','2019-08-10 00:00:00','2019-08-10 23:59:59',2,'[{role_lv,150},{free_refresh_times,0},{smashed_times_lim,9999}, {all_use_num,160}, {refresh_cost,20}, {smash_goods, 38180015}, {smash_goods_num,20}]'),(13,3,6,'欢乐砸蛋','砸蛋','[{5,9999}]','[]',1,'[]','[]','2019-08-11 00:00:00','2019-08-11 23:59:59',2,'[{role_lv,150},{free_refresh_times,0},{smashed_times_lim,9999}, {all_use_num,160}, {refresh_cost,20}, {smash_goods, 38180015}, {smash_goods_num,20}]'),(13,4,6,'欢乐砸蛋','砸蛋','[{5,9999}]','[]',1,'[]','[]','2019-08-12 00:00:00','2019-08-12 23:59:59',2,'[{role_lv,150},{free_refresh_times,0},{smashed_times_lim,9999}, {all_use_num,160}, {refresh_cost,20}, {smash_goods, 38180015}, {smash_goods_num,20}]'),(14,1,6,'充值有礼','活动期间，充值任意金额即可领取奖励，每人仅限领取一次！','[{8,9999}]','[]',1,'[]','[{{0,0,0},{23,59,59}}]','2019-08-06 00:00:00','2019-08-06 23:59:59',1,'[{role_lv, 150},{gold,1}]'),(14,2,3,'七夕充值礼','活动期间，充值任意金额，即可领取七夕时装（衣服），每人仅限领取一次！花费980钻石打开鹊桥相会礼盒更能获得七夕时装（武器和头部）！机会难得，不要错过！','[{8,9999}]','[]',1,'[]','[{{0,0,0},{23,59,59}}]','2018-08-17 00:00:00','2018-08-19 23:59:59',1,'[{role_lv, 150},{gold,1}]'),(14,3,3,'八月充值礼','活动期间，充值任意金额，即可领取获得时装自选礼盒（头），每人仅限领取一次！花费980钻石打开皇家礼盒更可获得时装自选礼盒（衣，武），仅限一次，机会难得，不要错过！','[{8,9999}]','[]',1,'[]','[{{0,0,0},{23,59,59}}]','2018-08-03 00:00:00','2018-08-05 23:59:59',1,'[{role_lv, 150},{gold,1}]'),(14,4,6,'充值有礼','活动期间，充值任意金额即可领取奖励，每人仅限领取一次！','[{5,999}]','[]',1,'[]','[{{0,0,0},{23,59,59}}]','2019-08-09 00:30:00','2019-08-09 23:59:59',1,'[{role_lv, 150},{gold,1}]'),(14,5,6,'充值有礼','活动期间，充值任意金额即可领取奖励，每人仅限领取一次！','[{5,999}]','[]',1,'[]','[{{0,0,0},{23,59,59}}]','2019-08-10 00:00:00','2019-08-10 23:59:59',1,'[{role_lv, 150},{gold,1}]'),(14,6,6,'充值有礼','活动期间，充值任意金额即可领取奖励，每人仅限领取一次！','[{5,999}]','[]',1,'[]','[{{0,0,0},{23,59,59}}]','2019-08-11 00:00:00','2019-08-11 23:59:59',1,'[{role_lv, 150},{gold,1}]'),(14,7,6,'充值有礼','活动期间，充值任意金额即可领取奖励，每人仅限领取一次！','[{5,999}]','[]',1,'[]','[{{0,0,0},{23,59,59}}]','2019-08-12 00:00:00','2019-08-12 23:59:59',1,'[{role_lv, 150},{gold,1}]'),(15,2,3,'登录有礼','活动期间，开服8天以上的玩家周末每日登陆可以领取奖励，连续登陆3天可额外领取累计奖励','[{8,9999}]','[]',5,'[]','[]','2018-03-26 00:00:00','2018-11-28 23:59:59',3,'[{role_lv,150}]'),(16,2,3,'双倍经验','活动首日18:00-24:00，经验副本的基础经验奖励翻倍！（建议与经验药水一起使用，可以叠加哦！）','[{8,9999}]','[]',1,'[]','[]','2019-06-25 00:00:00','2019-06-25 23:59:59',1,'[{role_lv,150},{types,[{4,10000}]},{time,{{18,0,0},{23,59,59}}}]'),(17,1,3,'特惠商城','特惠商城','[{8,9999}]','[]',1,'[]','[]','2019-04-01 00:00:00','2019-04-09 00:00:00',1,'[]'),(17,2,3,'特惠商城','特惠商城','[{8,9999}]','[]',1,'[]','[]','2019-04-01 00:00:00','2019-04-02 00:00:00',1,'[]'),(17,3,3,'特惠商城','特惠商城','[{8,9999}]','[]',1,'[]','[]','2019-04-01 00:00:00','2019-04-02 00:00:00',1,'[]'),(17,11,1,'特惠商场','活动期间，冲榜材料打折出售，祝你一飞冲天!','[{1,1}]','[]',1,'[]','[]','0','0',1,'[{clear_type, day}]'),(17,12,1,'特惠商场','活动期间，冲榜材料打折出售，祝你一飞冲天!','[{2,2}]','[]',1,'[]','[]','0','0',1,'[{clear_type, day}]'),(17,13,1,'特惠商场','活动期间，冲榜材料打折出售，祝你一飞冲天!','[{3,3}]','[]',1,'[]','[]','0','0',1,'[{clear_type, day}]'),(17,14,1,'特惠商场','活动期间，冲榜材料打折出售，祝你一飞冲天!','[{4,4}]','[]',1,'[]','[]','0','0',1,'[{clear_type, day}]'),(17,15,1,'特惠商场','活动期间，冲榜材料打折出售，祝你一飞冲天!','[{5,5}]','[]',1,'[]','[]','0','0',1,'[{clear_type, day}]'),(17,16,1,'特惠商场','活动期间，冲榜材料打折出售，祝你一飞冲天!','[{6,6}]','[]',1,'[]','[]','0','0',1,'[{clear_type, day}]'),(17,17,1,'特惠商场','活动期间，冲榜材料打折出售，祝你一飞冲天!','[{7,7}]','[]',1,'[]','[]','0','0',1,'[{clear_type, day}]'),(17,21,1,'特惠商场','特惠商场','[{8,8}]','[]',1,'[]','[]','0','0',1,'[{role_lv, 150},{clear_type, day}]'),(17,22,3,'特惠商场','特惠商场','[{9,9}]','[]',1,'[]','[]','0','0',1,'[{role_lv, 150},{clear_type, day}]'),(17,23,3,'特惠商场','特惠商场','[{10,10}]','[]',1,'[]','[]','0','0',1,'[{role_lv, 150},{clear_type, day}]'),(17,24,3,'特惠商场','特惠商场','[{11,11}]','[]',1,'[]','[]','0','0',1,'[{role_lv, 150},{clear_type, day}]'),(17,25,3,'特惠商场','特惠商场','[{12,12}]','[]',1,'[]','[]','0','0',1,'[{role_lv, 150},{clear_type, day}]'),(17,26,3,'特惠商场','特惠商场','[{13,13}]','[]',1,'[]','[]','0','0',1,'[{role_lv, 150},{clear_type, day}]'),(17,27,3,'特惠商场','特惠商场','[{14,14}]','[]',1,'[]','[]','0','0',1,'[{role_lv, 150},{clear_type, day}]'),(17,28,3,'特惠商场','特惠商场','[{15,15}]','[]',1,'[]','[]','0','0',1,'[{role_lv, 150},{clear_type, day}]'),(17,29,3,'特惠商场','特惠商场','[{16,16}]','[]',1,'[]','[]','0','0',1,'[{role_lv, 150},{clear_type, day}]'),(17,30,3,'特惠商场','特惠商场','[{17,17}]','[]',1,'[]','[]','0','0',1,'[{role_lv, 150},{clear_type, day}]'),(17,31,3,'特惠商场','特惠商场','[{18,18}]','[]',1,'[]','[]','0','0',1,'[{role_lv, 150},{clear_type, day}]'),(17,32,3,'特惠商场','特惠商场','[{19,19}]','[]',1,'[]','[]','0','0',1,'[{role_lv, 150},{clear_type, day}]'),(17,33,3,'特惠商场','特惠商场','[{20,20}]','[]',1,'[]','[]','0','0',1,'[{role_lv, 150},{clear_type, day}]'),(17,34,3,'特惠商场','特惠商场','[{21,21}]','[]',1,'[]','[]','0','0',1,'[{role_lv, 150},{clear_type, day}]'),(17,35,3,'特惠商场','特惠商场','[{22,22}]','[]',1,'[]','[]','0','0',1,'[{role_lv, 150},{clear_type, day}]'),(17,36,3,'特惠商场','特惠商场','[{23,23}]','[]',1,'[]','[]','0','0',1,'[{role_lv, 150},{clear_type, day}]'),(17,37,3,'特惠商场','特惠商场','[{24,24}]','[]',1,'[]','[]','0','0',1,'[{role_lv, 150},{clear_type, day}]'),(17,38,3,'特惠商场','特惠商场','[{25,25}]','[]',1,'[]','[]','0','0',1,'[{role_lv, 150},{clear_type, day}]'),(17,39,3,'特惠商场','特惠商场','[{26,26}]','[]',1,'[]','[]','0','0',1,'[{role_lv, 150},{clear_type, day}]'),(17,40,3,'特惠商场','特惠商场','[{27,27}]','[]',1,'[]','[]','0','0',1,'[{role_lv, 150},{clear_type, day}]'),(17,41,3,'特惠商场','特惠商场','[{28,28}]','[]',1,'[]','[]','0','0',1,'[{role_lv, 150},{clear_type, day}]'),(17,101,2,'合服特惠','活动期间，稀有礼包亏本清仓友情价出售！','[]','[]',1,'[]','[]','0','0',1,'[]'),(17,102,2,'合服特惠','活动期间，稀有礼包亏本清仓友情价出售！','[]','[]',1,'[]','[]','0','0',1,'[]'),(17,103,2,'合服特惠','活动期间，稀有礼包亏本清仓友情价出售！','[]','[]',1,'[]','[]','0','0',1,'[]'),(17,104,2,'合服特惠','活动期间，稀有礼包亏本清仓友情价出售！','[]','[]',1,'[]','[]','0','0',1,'[]'),(17,105,2,'合服特惠','活动期间，稀有礼包亏本清仓友情价出售！','[]','[]',1,'[]','[]','0','0',1,'[]'),(18,2,4,'幸运之星','购买幸运之星，可随机获得一份保底奖励，更有机会中到大奖，快来参与吧，也许下一个幸运之星就是你！','[{9999,9999}]','[]',1,'[]','[]','2019-05-01 00:00:00','2019-06-01 23:59:59',1,'[{unlimited_time,[18,00]},{award_time,[22,00]},{big_award_ids, [1,2,3,4]}, {if_kf,0}]'),(20,1,3,'活动BOSS','1、在活动期间，活动boss每天将于<color=\'#fff845\'>10:00—16:00，17:00—17:30</color>在各野外挂机场景出现，击杀boss后有机会获得丰厚奖励！！（所有boss只在每个场景的1线刷新）2、活动期间除了击杀boss，还可以在各个场景内找寻指定采集物，采集后也会获得活动奖励哦','[{8,9999}]','[]',1,'[]','[]','2019-06-26 00:00:00','2019-06-26 23:59:59',1,'[\n{role_lv,150}, \n{cfg_list, \n  [\n    [{mon_type, 1},{scene, 1007},{mon_id, [20100001]},{mon_num, 3},{times_point, [{{10,00,00},{16,00,00}},{{17,00,00},{17,30,00}}]}],\n    [{mon_type, 2},{scene, 1007},{mon_id, [20100005]},{mon_num, 6},{times_point, [{{10,00,00},{16,00,00}},{{17,00,00},{17,30,00}}]}],\n    [{mon_type, 1},{scene, 1005},{mon_id, [20100002]},{mon_num, 3},{times_point, [{{10,00,00},{16,00,00}},{{17,00,00},{17,30,00}}]}],\n    [{mon_type, 2},{scene, 1005},{mon_id, [20100006]},{mon_num, 6},{times_point, [{{10,00,00},{16,00,00}},{{17,00,00},{17,30,00}}]}],\n    [{mon_type, 1},{scene, 1006},{mon_id, [20100003]},{mon_num, 3},{times_point, [{{10,00,00},{16,00,00}},{{17,00,00},{17,30,00}}]}],\n    [{mon_type, 2},{scene, 1006},{mon_id, [20100007]},{mon_num, 5},{times_point, [{{10,00,00},{16,00,00}},{{17,00,00},{17,30,00}}]}],\n    [{mon_type, 1},{scene, 1008},{mon_id, [20100004]},{mon_num, 3},{times_point, [{{10,00,00},{16,00,00}},{{17,00,00},{17,30,00}}]}],\n    [{mon_type, 2},{scene, 1008},{mon_id, [20100008]},{mon_num, 5},{times_point, [{{10,00,00},{16,00,00}},{{17,00,00},{17,30,00}}]}]\n  ]\n}\n]'),(20,2,3,'野外首领','阿拉丁灯神听着世界杯的呐喊声来了，给大家也带来了福利。灯神预报将于<color=\'#31ee4a\'>14:00—14:30，19:00—19:30</color>在各野外挂机场景出现，用蛮力抚慰灯神后有机会获得丰厚奖励！！（小恶魔无法自动拾取）。','[{8,9999}]','[]',1,'[]','[]','2018-06-22 00:00:00','2018-06-24 23:59:59',1,'[{time_points, [{{14,00,00},{14,30,00}},{{19,00,00},{19,30,00}}]},{num_lim,50},{single_scene_max_num,13},{boss_id, 9950000}]'),(21,1,6,'活动兑换','走过路过别错过！活动期间内，参与各类精彩活动收集兑换材料，可兑换超值<color=#62e874>限量道具</color>，众多精美好礼等你来拿！','[{5,999}]','[]',1,'[]','[]','2019-08-09 00:30:00','2019-08-12 23:59:59',1,'[{role_lv, 150},{clear_type, act}]'),(22,1,6,'超级扭蛋','使用扭蛋币扭蛋可获得丰厚奖励','[{5,9999}]','[]',1,'[]','[]','2019-08-09 00:30:00','2019-08-10 23:59:59',2,'[{role_lv, 150}]'),(22,2,6,'超级扭蛋','使用扭蛋币扭蛋可获得丰厚奖励','[{5,9999}]','[]',1,'[]','[]','2019-08-11 00:00:00','2019-08-12 23:59:59',2,'[{role_lv, 150}]'),(23,1,6,'狂欢庆典','玩日常活动，奖狂欢嗨点，领豪华奖品！','[{5,999}]','[]',1,'[]','[]','2019-08-09 00:30:00','2019-08-12 23:59:59',1,'[{role_lv,150}]'),(24,1,1,'勇者盟约','活动期间，创建公会即可领取豪华大礼，公会达到一定条件还有更多豪礼！赶快召集勇士，铸造辉煌！（奖励只有会长可领取）','[{1,7}]','[]',1,'[]','[]','0','0',1,'[]'),(25,1,1,'三世恋人','活动期间，与心仪的玩家举行3场不同档次的婚礼，达到条件后双方均可获得【三世恋人】称号，活动期间称号每人只能获得一次（需和同一个玩家举行婚礼，无需离婚也可重复结婚）','[{1,7}]','[]',1,'[]','[]','0','0',2,'[{reward, [{0,4908019, 1}]}]'),(26,1,1,'首领首杀','活动期间，全服<color=#ffee35>首次</color>击败指定首领时获得<color=#ffee35>掉落归属</color>的个人或队伍可以领取首次掉落归属奖励！','[{1,7}]','[]',1,'[]','[]','0','0',1,'[]'),(27,1,1,'公会争霸','开服第4天20:30开启公会争霸赛！\n在公会争霸中获得冠军的王者公会可获得王国颁发的豪华奖励！为了荣耀，冒险者们加油呀~','[{1,5}]','[]',1,'[]','[{{0,0,0},{23,59,59}}]','0','0',1,'[{need_opday,4}]'),(27,101,2,'公会争霸','合服第5天20:30开启，最终的王者公会将获得大量奖励','[]','[]',1,'[]','[]','0','0',1,'[{need_opday,5}]'),(29,1,3,'七夕红包雨','全服普天同庆，红包不要停！活动期间击杀本服首领（<color=#62e874>世界首领、个人首领、首领之家和时空裂缝</color>）可获得红包道具！','[{4,9999}]','[]',1,'[]','[]','2018-08-17 00:00:00','2018-08-17 23:59:59',1,'[]'),(29,2,3,'红包活动','全服普天同庆，红包不要停！活动期间击杀本服首领（<color=#62e874>世界首领、个人首领、首领之家和时空裂缝</color>）可获得红包道具！','[{4,9999}]','[]',1,'[]','[]','2018-06-29 00:00:00','2018-07-01 23:59:59',1,'[]'),(30,1,6,'累计消费','活动期间，累计消费达到对应额度，即可获得丰厚奖励！<color=#62e874>精美时装，宝宝外观，各种珍稀材料</color>等你来拿！','[{5,9999}]','[]',1,'[]','[{{0,0,0},{23,59,59}}]','2019-08-09 00:30:00','2019-08-10 23:59:59',2,'[{role_lv, 150},{money_types,[gold,fgold]}]'),(30,2,6,'累计消费','活动期间，累计消费达到对应额度，即可获得丰厚奖励！<color=#62e874>精美时装，宝宝外观，各种珍稀材料</color>等你来拿！','[{5,9999}]','[]',1,'[]','[{{0,0,0},{23,59,59}}]','2019-08-11 00:00:00','2019-08-12 23:59:59',2,'[{role_lv, 150},{money_types,[gold,fgold]}]'),(30,101,2,'合服消费','合服期间，累计消费达到对应额度，即可获得大量奖励！','[]','[]',1,'[]','[]','0','0',2,'[{role_lv, 150},{money_types,[gold]}]'),(31,1,4,'赤焰飓风','满幸运值鉴宝必出大奖！','[{8,999}]','[]',1,'[]','[]','2019-07-23 00:00:00','2019-07-24 23:59:59',2,'[{role_lv,150},{main_reward_id, 1},{open_day,8}]'),(31,2,4,'旋翼飞空艇','满幸运值鉴宝必出大奖！','[{8,999}]','[]',1,'[]','[]','2019-03-26 00:00:00','2019-03-28 00:00:00',2,'[{role_lv,150},{main_reward_id, 2},{open_day,9}]'),(31,3,4,'呆萌兔','满幸运值鉴宝必出大奖！','[{8,999}]','[]',1,'[]','[]','2019-03-26 00:00:00','2019-03-27 00:00:00',2,'[{role_lv,150},{main_reward_id, 3},{open_day,10}]'),(31,4,4,'啸天神犬','满幸运值鉴宝必出大奖！','[{8,999}]','[]',1,'[]','[]','2019-03-26 00:00:00','2019-03-27 00:00:00',2,'[{role_lv,150},{main_reward_id, 4},{open_day,11}]'),(31,5,4,'海神圣杯','满幸运值鉴宝必出大奖！','[{8,999}]','[]',1,'[]','[]','2019-03-26 00:00:00','2019-03-27 00:00:00',2,'[{role_lv,150},{main_reward_id, 5},{open_day,12}]'),(31,6,4,'萌娃黑崎','满幸运值鉴宝必出大奖！','[{8,999}]','[]',1,'[]','[]','2019-03-26 00:00:00','2019-03-27 00:00:00',2,'[{role_lv,150},{main_reward_id, 6},{open_day,13}]'),(31,7,4,'圣灵羽蝶','满幸运值鉴宝必出大奖！','[{999,999}]','[]',1,'[]','[]','2018-08-11 00:00:00','2018-08-11 23:59:59',2,'[{role_lv,150},{main_reward_id, 7},{open_day,14}]'),(31,8,3,'幸运鉴宝','满幸运值鉴宝必出大奖！','[{999,999}]','[]',1,'[]','[]','8/16/18 0:00','2018-08-19 23:59:59',2,'[{role_lv,150},{main_reward_id, 8}]'),(31,9,4,'精灵王子','满幸运值鉴宝必出大奖！','[{999,999}]','[]',1,'[]','[]','2019-03-26 00:00:00','2019-03-27 00:00:00',1,'[{role_lv,150},{main_reward_id, 9},{open_day,15}]'),(32,1,3,'母亲节献礼','母亲节献礼','[]','[]',1,'[]','[]','2018-05-11 00:00:00','2018-05-13 23:59:59',1,'[{put_goods_list,[{0,38040036,1}]},{put_money_list,[{1,36010001,10}]},{exp_types,1},{drop_types, [{2,2},{3,2}]}]'),(33,1,3,'充值排行','活动期间，充值300钻石即可获得“皇家守卫”称号，上榜更有机会获得稀有时装！','[{8,9999}]','[]',1,'[]','[]','2019-06-27 00:00:00','2019-06-28 23:59:59',1,'[{role_lv,150},{rank_len,20},{rank_limit,300},{reward_num,300},{participate_reward,[5]}]'),(33,101,2,'合服充值排行','合服期间，根据本服玩家充值排行获得对应的奖励，千万不要错过！','[]','[]',1,'[]','[]','0','0',1,'[{role_lv,150},{rank_len,20},{rank_limit,300},{reward_num,300}]'),(34,1,4,'登高有礼','登高有礼','[{8,9999}]','[]',1,'[]','[]','2019-06-26 00:00:00','2019-06-26 23:59:59',1,'[{money_type, gold},{role_lv,150}]'),(35,1,4,'幸运翻牌','幸运翻牌','[{8,9999}]','[]',1,'[]','[]','2019-07-16 00:00:00','2019-07-17 23:59:59',1,'[{role_lv,150},{refresh_gid,38180008},{flop_gid, 38180009},{times_lim, 1000},{refresh_cost,[{[1,1],0},{[2,2],1},{[3,3],2},{[4,9999],3}]},{flop_cost, [{[1,2],1},{[3,5],2},{[6,8],3}]}]'),(35,2,4,'许愿神树','许愿神树树','[{8,9999}]','[]',1,'[]','[]','2019-07-31 00:00:00','2019-08-03 23:59:59',1,'[{role_lv,150},{draw_cost, [{1,1,1},{2,2,2},{3,3,4},{4,5,8},{6,7,18},{8,9,28}]},{reset_cost, [{1,2,0},{3,3,1},{4,5,2},{6,9999,3}]},{draw_gid,38180009},{reset_gid,38180008},{reset_times,9} ,{select_limit, [{1,2},{2,3},{3,4}]}]'),(36,1,1,'0元豪礼','0元豪礼','[{1,999}]','[]',1,'[]','[]','','',1,'[{role_lv,75},{buy_day, 3},{open_day, 3}]'),(36,2,4,'0元圣器','0元豪礼','[{3,999}]','[]',1,'[]','[]','','',1,'[{role_lv,200},{buy_day,5},{open_day,7}]'),(37,1,1,'至尊专场','','[{8,9999}]','[]',1,'[]','[]','2019-04-19 00:00:00','2019-04-19 23:59:59',1,'[{draw_time, [{2018,11,1,10,00}]}]'),(37,2,1,'跨服云购','','[{999,999}]','[]',1,'[]','[]','2019-07-03 00:00:00','2029-07-03 00:00:00',1,'[{role_lv,150},{draw_time,[{22, 00}]},{unlimit_time,[{18,00}]},{cost, [{0,38180013,1}]}]'),(37,3,1,'至尊专场','','[]','[]',1,'[]','[]','2018-08-17 00:00:00','2018-08-18 00:00:00',1,'[{draw_time, [{2018,8,17,19,00}]}]'),(37,4,1,'至尊专场','','[]','[]',1,'[]','[]','2018-08-17 00:00:00','2018-08-18 00:00:00',1,'[{draw_time, [{2018,8,17,23,00}]}]'),(37,5,1,'至尊专场','','[]','[]',1,'[]','[]','2018-08-18 00:00:00','2018-08-19 00:00:00',1,'[{draw_time, [{2018,8,18,10,00}]}]'),(37,6,1,'至尊专场','','[]','[]',1,'[]','[]','2018-08-18 00:00:00','2018-08-19 00:00:00',1,'[{draw_time, [{2018,8,18,14,00}]}]'),(37,7,1,'至尊专场','','[]','[]',1,'[]','[]','2018-08-18 00:00:00','2018-08-19 00:00:00',1,'[{draw_time, [{2018,8,18,19,00}]}]'),(37,8,1,'至尊专场','','[]','[]',1,'[]','[]','2018-08-18 00:00:00','2018-08-19 00:00:00',1,'[{draw_time, [{2018,8,18,23,00}]}]'),(37,9,1,'至尊专场','','[]','[]',1,'[]','[]','2018-08-19 00:00:00','2018-08-20 00:00:00',1,'[{draw_time, [{2018,8,19,10,00}]}]'),(37,10,1,'至尊专场','','[]','[]',1,'[]','[]','2018-08-19 00:00:00','2018-08-20 00:00:00',1,'[{draw_time, [{2018,8,19,14,00}]}]'),(37,11,1,'至尊专场','','[]','[]',1,'[]','[]','2018-08-19 00:00:00','2018-08-20 00:00:00',1,'[{draw_time, [{2018,8,19,19,00}]}]'),(37,12,1,'至尊专场','','[]','[]',1,'[]','[]','2018-08-19 00:00:00','2018-08-20 00:00:00',1,'[{draw_time, [{2018,8,19,23,00}]}]'),(38,1,1,'豪华专场','','[{8,9999}]','[]',1,'[]','[]','2019-04-19 00:00:00','2019-04-19 23:59:59',1,'[{draw_time, [{2018,8,17,10,00}]}]'),(38,2,1,'豪华专场','','[{8,9999}]','[]',1,'[]','[]','2019-05-21 00:00:00','2019-05-21 23:59:59',1,'[{role_lv,150},{draw_time,[{2019,5,21,18, 00}]},{unlimit_time,[{2019,5,21,16,0}]},{cost, [{0,38180013,1}]}]'),(38,3,1,'豪华专场','','[]','[]',1,'[]','[]','2018-08-17 00:00:00','2018-08-18 00:00:00',1,'[{draw_time, [{2018,8,17,19,00}]}]'),(38,4,1,'豪华专场','','[]','[]',1,'[]','[]','2018-08-17 00:00:00','2018-08-18 00:00:00',1,'[{draw_time, [{2018,8,17,23,00}]}]'),(38,5,1,'豪华专场','','[]','[]',1,'[]','[]','2018-08-18 00:00:00','2018-08-19 00:00:00',1,'[{draw_time, [{2018,8,18,10,00}]}]'),(38,6,1,'豪华专场','','[]','[]',1,'[]','[]','2018-08-18 00:00:00','2018-08-19 00:00:00',1,'[{draw_time, [{2018,8,18,14,00}]}]'),(38,7,1,'豪华专场','','[]','[]',1,'[]','[]','2018-08-18 00:00:00','2018-08-19 00:00:00',1,'[{draw_time, [{2018,8,18,19,00}]}]'),(38,8,1,'豪华专场','','[]','[]',1,'[]','[]','2018-08-18 00:00:00','2018-08-19 00:00:00',1,'[{draw_time, [{2018,8,18,23,00}]}]'),(38,9,1,'豪华专场','','[]','[]',1,'[]','[]','2018-08-19 00:00:00','2018-08-20 00:00:00',1,'[{draw_time, [{2018,8,19,10,00}]}]'),(38,10,1,'豪华专场','','[]','[]',1,'[]','[]','2018-08-19 00:00:00','2018-08-20 00:00:00',1,'[{draw_time, [{2018,8,19,14,00}]}]'),(38,11,1,'豪华专场','','[]','[]',1,'[]','[]','2018-08-19 00:00:00','2018-08-20 00:00:00',1,'[{draw_time, [{2018,8,19,19,00}]}]'),(38,12,1,'豪华专场','','[]','[]',1,'[]','[]','2018-08-19 00:00:00','2018-08-20 00:00:00',1,'[{draw_time, [{2018,8,19,23,00}]}]'),(39,1,3,'七夕消费榜','活动期间，消费300钻石即可获得“牛郎织女”称号，上榜更有机会获得稀有翅膀幻形，附带特殊属性！','[{8,9999}]','[]',1,'[]','[]','2019-06-26 00:00:00','2019-06-28 23:59:59',1,'[{role_lv,150},{rank_len, 20},{rank_limit, 300},{reward_num, 300},{participate_reward,[5]}]'),(40,1,1,'连续消费','连续消费','[{8,9999}]','[]',1,'[]','[]','2019-04-01 00:00:00','2019-04-04 23:59:59',1,'[{role_lv,150}]'),(41,1,4,'折上巨献','花费钻石可以购买超值道具','[{5,6}]','[]',1,'[]','[]','2019-04-22 00:00:00','2023-04-22 00:00:00',2,'[{role_lv,150},{buy_day,2}]'),(41,2,4,'折上巨献','花费钻石可以购买超值道具','[{6,7}]','[]',1,'[]','[]','2019-03-27 00:00:00','2023-03-29 00:00:00',2,'[{role_lv,150},{buy_day,2}]'),(41,3,4,'折上巨献','花费钻石可以购买超值道具','[{7,8}]','[]',1,'[]','[]','2019-04-22 00:00:00','2023-04-22 00:00:00',2,'[{role_lv,150},{buy_day,2}]'),(41,4,4,'折上巨献','花费钻石可以购买超值道具','[{9999, 9999}]','[]',1,'[]','[]','2019-04-22 00:00:00','2019-04-23 00:00:00',2,'[{role_lv,150},{buy_day, 1}]'),(41,5,4,'折上巨献','花费钻石可以购买超值道具','[{9999, 9999}]','[]',1,'[]','[]','2019-04-22 00:00:00','2019-04-23 00:00:00',2,'[{role_lv,150},{buy_day, 1}]'),(41,6,4,'折上巨献','花费钻石可以购买超值道具','[{9999, 9999}]','[]',1,'[]','[]','2019-04-22 00:00:00','2019-04-23 00:00:00',2,'[{role_lv,150},{buy_day, 1}]'),(41,7,4,'折上巨献','花费钻石可以购买超值道具','[{9999, 9999}]','[]',1,'[]','[]','2019-04-22 00:00:00','2019-06-23 00:00:00',2,'[{role_lv,150},{buy_day, 1}]'),(41,8,4,'折上巨献','花费钻石可以购买超值道具','[{9999, 9999}]','[]',1,'[]','[]','2019-04-22 00:00:00','2019-04-23 00:00:00',2,'[{role_lv,150},{buy_day, 1}]'),(41,9,4,'折上巨献','花费钻石可以购买超值道具','[{9999, 9999}]','[]',1,'[]','[]','2019-04-22 00:00:00','2019-04-23 00:00:00',2,'[{role_lv,150},{buy_day, 1}]'),(41,10,4,'折上巨献','花费钻石可以购买超值道具','[{9999, 9999}]','[]',1,'[]','[]','2019-04-22 00:00:00','2019-04-23 00:00:00',2,'[{role_lv,150},{buy_day, 1}]'),(41,11,4,'折上巨献','花费钻石可以购买超值道具','[{5, 9999}]','[]',1,'[]','[]','2019-08-09 00:30:00','2019-08-12 23:59:59',2,'[{role_lv,150},{buy_day,4}]'),(41,12,4,'折上巨献','花费钻石可以购买超值道具','[{9999, 9999}]','[]',1,'[]','[]','2019-04-29 00:00:00','2019-04-30 00:00:00',2,'[{role_lv,150},{buy_day, 1}]'),(41,21,4,'折上巨献','花费钻石可以购买超值道具','[{9999,9999}]','[]',1,'[]','[]','2019-08-06 00:00:00','2019-08-09 23:59:59',2,'[{role_lv,150},{buy_day,4}]'),(42,1,4,'精品特卖','精品特卖','[{8,9999}]','[]',1,'[]','[]','2019-06-21 00:00:00','2019-06-21 23:59:59',2,'[{role_lv,150}]'),(42,2,1,'魂珠特卖','魂珠特卖','[{8,9999}]','[]',1,'[]','[]','2019-03-27 00:00:00','2019-03-29 00:00:00',1,'[{role_lv,150}]'),(42,3,4,'纹章特卖','纹章特卖','[{8,9999}]','[]',1,'[]','[]','2019-03-27 00:00:00','2019-03-29 00:00:00',1,'[{role_lv,150}]'),(42,4,1,'纹章特卖','纹章特卖','[{999,9999}]','[]',1,'[]','[]','0','0',1,'[{role_lv,150}]'),(44,1,2,'公会争霸·定级赛','合服第三天公会争霸定级赛结束后，晋级王者赛区的公会会长和会员有奖励，其他参与玩家也有参与奖','[]','[]',1,'[]','[]','0','0',1,'[{need_opday,3}]'),(46,1,4,'超值投资','超值投资','[{5,999}]','[]',1,'[]','[]','2019-08-09 00:30:00','2019-08-22 23:59:59',1,'[{gear, [1,2,3]},{cost, [{1,[{1,0,188}]},{2, [{1,0,488}]},{3,[{1,0,1288}]}]},{buy_time,345600},{role_lv, 150}]'),(54,1,3,'累积在线','每天累积在线领福利！','[]','[]',1,'[]','[]','2019-06-28 00:00:00','2019-06-28 23:59:59',2,'[{role_lv,80},{reward_multiple_date_range,[{2019,6,13},{2019,6,13}],2}]'),(54,2,3,'累积在线','日常在线','[]','[]',1,'[]','[]','2019-03-08 00:00:00','2019-03-10 00:00:00',2,'[{role_lv,80},{reward_multiple_date_range,[{2019,3,6},{2019,3,8}],2}]'),(55,1,4,'周一大放送','1.抽奖时间：<color=#f18310>周一12:00~24:00</color> \n2.每日可完成任务累积<color=#f18310>祈愿券</color>,抽取丰厚奖励\n3.每祈愿10次，必得1次二等奖或以上奖励','[{1,9999}]','[]',1,'[]','[]','2019-04-11 00:00:00','2023-04-19 00:00:00',1,'[{role_lv, 150}, {supplication_cost, [{0, 38180011, 1}]}, {cost_day, [{1,{12,0},{24,0}}]}, {reward_limit, [{0, 2, 5000, 1},{1, 2, 1000, 1}]},\n{reward_day, [1,2,3,4,5,6,7]}, {guaranty, {10, 2}}, {task, [{1, {daily_login}, 101}, {2, {daily_charge}, 102}, {3, {liveness, 140}, 103}]}]'),(56,1,1,'日常活跃','活动期间，获得活跃度达到目标值，即可领取活跃奖励！（活动仅统计活动期间新增的活跃度，若今日日常已完成，请在凌晨4点日常刷新后再进行）','[{2,8}]','[]',1,'[]','[]','2019-05-27 00:00:00','2024-05-28 23:59:59',2,'[{role_lv, 150}]'),(56,2,3,'日常活跃','活动期间，获得活跃度达到目标值，即可领取活跃奖励！（活动仅统计活动期间新增的活跃度，若今日日常已完成，请在凌晨4点日常刷新后再进行）','[{9,9999}]','[]',1,'[]','[]','0','0',2,'[{role_lv, 150}]'),(57,1,3,'单充有礼','活动期间，每充值300钻石即可领取一份奖励。','[{8,9999}]','[]',1,'[]','[]','2019-06-27 00:00:00','2019-06-27 23:59:59',1,'[{role_lv, 150},{recharge, 300},{show_type, 4},{show_id,12040004}]'),(58,1,3,'充值转盘','活动期间，每充值300钻石可获得1次抽奖次数！','[{8,9999}]','[]',1,'[]','[]','2019-06-14 00:00:00','2019-06-17 23:59:59',1,'[{role_lv, 150},{recharge, 300}]'),(59,1,1,'等级目标','完成目标领奖励','[{1, 1}]','[]',1,'[]','[]','0','0',1,'[{role_lv, 40}]'),(59,2,1,'等级冲刺','完成目标领奖励','[{2, 2}]','[]',1,'[]','[]','0','0',1,'[{role_lv, 40}]'),(59,3,1,'坐骑升战','完成目标领奖励','[{3, 3}]','[]',1,'[]','[]','0','0',1,'[{role_lv, 40}]'),(59,4,1,'降神升战','完成目标领奖励','[{4, 4}]','[]',1,'[]','[]','0','0',1,'[{role_lv, 40}]'),(59,5,1,'魂珠培养','完成目标领奖励','[{5, 5}]','[]',1,'[]','[]','0','0',1,'[{role_lv, 40}]'),(59,6,1,'装备升战','完成目标领奖励','[{6, 6}]','[]',1,'[]','[]','0','0',1,'[{role_lv, 40}]'),(59,7,1,'宝石升级','完成目标领奖励','[{6, 6}]','[]',1,'[]','[]','0','0',1,'[{role_lv, 40}]'),(59,8,1,'战力目标','完成目标领奖励','[{7, 7}]','[]',1,'[]','[]','0','0',1,'[{role_lv, 40}]'),(59,9,1,'降神升战','完成目标领奖励','[{8,8}]','[]',1,'[]','[]','0','0',1,'[{role_lv, 40}]'),(59,10,3,'星灵升战','完成目标领奖励','[{9,10}]','[]',1,'[]','[]','0','0',1,'[{role_lv, 40}]'),(59,11,3,'降神升战','完成目标领奖励','[{11,12}]','[]',1,'[]','[]','0','0',1,'[{role_lv, 40}]'),(59,12,3,'星灵升战','完成目标领奖励','[{13,14}]','[]',1,'[]','[]','0','0',1,'[{role_lv, 40}]'),(59,13,3,'坐骑升战','完成目标领奖励','[{15,16}]','[]',1,'[]','[]','0','0',1,'[{role_lv, 40}]'),(59,14,3,'降神升战','完成目标领奖励','[{17,18}]','[]',1,'[]','[]','0','0',1,'[{role_lv, 40}]'),(59,15,3,'星灵升战','完成目标领奖励','[{19,20}]','[]',1,'[]','[]','0','0',1,'[{role_lv, 40}]'),(59,16,3,'降神升战','完成目标领奖励','[{21,22}]','[]',1,'[]','[]','0','0',1,'[{role_lv, 40}]'),(59,17,3,'星灵升战','完成目标领奖励','[{23,24}]','[]',1,'[]','[]','0','0',1,'[{role_lv, 40}]'),(59,18,3,'翅膀升战','完成目标领奖励','[{25,26}]','[]',1,'[]','[]','0','0',1,'[{role_lv, 40}]'),(59,19,3,'降神升战','完成目标领奖励','[{27,28}]','[]',1,'[]','[]','0','0',1,'[{role_lv, 40}]'),(59,20,3,'时装升星','完成目标领奖励','[{8,999}]','[]',1,'[]','[]','2019-08-07 00:00:00','2019-08-07 23:59:59',1,'[{role_lv, 40}]'),(59,21,3,'时装升战','完成目标领奖励','[{5,999}]','[]',1,'[]','[]','2019-08-09 00:00:00','2019-08-12 23:59:59',1,'[{role_lv, 40}]'),(59,22,3,'时装升星','完成目标领奖励','[{5,999}]','[]',1,'[]','[]','2019-08-09 00:00:00','2019-08-09 23:59:59',1,'[{role_lv, 40}]'),(59,23,3,'时装升星','完成目标领奖励','[{5,999}]','[]',1,'[]','[]','2019-08-10 00:00:00','2019-08-10 23:59:59',1,'[{role_lv, 40}]'),(59,24,3,'时装升星','完成目标领奖励','[{5,999}]','[]',1,'[]','[]','2019-08-11 00:00:00','2019-08-11 23:59:59',1,'[{role_lv, 40}]'),(59,25,3,'时装升星','完成目标领奖励','[{5,999}]','[]',1,'[]','[]','2019-08-12 00:00:00','2019-08-12 23:59:59',1,'[{role_lv, 40}]'),(60,1,3,'降神积分','消耗神源之火升阶降神可获得相应的积分，达到指定的积分可领取奖励<color=#81ff3c>（初级神源之火1积分，中级神源之火2积分，高级神源之火4积分）</color>','[{9999, 9999}]','[]',1,'[]','[]','0','0',2,'[{role_lv, 150},{score,[{11020001,1},{11020002,2},{11020003,4}]}]'),(60,2,1,'星灵积分','消耗星辰之砂升阶星灵可获得相应的积分，达到指定的积分可领取奖励<color=#81ff3c>（初级星辰之砂1积分，中级星辰之砂3积分，高级星辰之砂9积分）</color>','[{9999, 9999}]','[]',1,'[]','[]','0','0',2,'[{role_lv, 150},{score,[{18020001,1},{18020002,3},{18020003,9}]}]'),(60,3,3,'坐骑积分','消耗坐骑树果升阶坐骑可获得相应的积分，达到指定的积分可领取奖励<color=#81ff3c>（初级坐骑树果1积分，中级坐骑树果3积分，高级坐骑树果9积分）</color>','[{9999, 9999}]','[]',1,'[]','[]','0','0',2,'[{role_lv, 150},{score,[{16020001,1},{16020002,3},{16020002,9}]}]'),(60,4,3,'圣灵积分','消耗晶核升级圣灵可获得相应的积分，达到指定的积分可领取奖励<color=#81ff3c>（初级晶核1积分，中级晶核3积分，高级晶核9积分）</color>','[{9999, 9999}]','[]',1,'[]','[]','0','0',2,'[{role_lv, 150},{score,[{15020101,1},{15020102,3},{15020103,9},{15020201,1},{15020202,3},{15020203,9},{15020301,1},{15020302,3},{15020303,9}]}]'),(60,5,3,'宝具积分','消耗宝具纹章升级宝具可获得相应的积分，达到指定的积分可领取奖励<color=#81ff3c>（初级宝具纹章1积分，中级宝具纹章3积分，高级宝具纹章9积分）</color>','[{9999, 9999}]','[]',1,'[]','[]','0','0',2,'[{role_lv, 150},{score,[{24010001,1},{24010002,3},{24010003,9}]}]'),(60,6,3,'降神积分','消耗神源之火升阶降神可获得相应的积分，达到指定的积分可领取奖励<color=#81ff3c>（初级神源之火1积分，中级神源之火2积分，高级神源之火4积分）</color>','[{9999, 9999}]','[]',1,'[]','[]','0','0',2,'[{role_lv, 150},{score,[{11020001,1},{11020002,2},{11020003,4}]}]'),(60,7,3,'星灵积分','消耗星辰之砂升阶星灵可获得相应的积分，达到指定的积分可领取奖励<color=#81ff3c>（初级星辰之砂1积分，中级星辰之砂3积分，高级星辰之砂9积分）</color>','[{9999, 9999}]','[]',1,'[]','[]','0','0',2,'[{role_lv, 150},{score,[{18020001,1},{18020002,3},{18020003,9}]}]'),(60,8,3,'坐骑积分','消耗坐骑树果升阶坐骑可获得相应的积分，达到指定的积分可领取奖励<color=#81ff3c>（初级坐骑树果1积分，中级坐骑树果3积分，高级坐骑树果9积分）</color>','[{9999, 9999}]','[]',1,'[]','[]','0','0',2,'[{role_lv, 150},{score,[{16020001,1},{16020002,3},{16020002,9}]}]'),(60,9,3,'圣灵积分','消耗晶核升级圣灵可获得相应的积分，达到指定的积分可领取奖励<color=#81ff3c>（初级晶核1积分，中级晶核3积分，高级晶核9积分）</color>','[{9999, 9999}]','[]',1,'[]','[]','0','0',2,'[{role_lv, 150},{score,[{15020101,1},{15020102,3},{15020103,9},{15020201,1},{15020202,3},{15020203,9},{15020301,1},{15020302,3},{15020303,9}]}]'),(60,10,3,'宝具积分','消耗宝具纹章升级宝具可获得相应的积分，达到指定的积分可领取奖励<color=#81ff3c>（初级宝具纹章1积分，中级宝具纹章3积分，高级宝具纹章9积分）</color>','[{9999, 9999}]','[]',1,'[]','[]','0','0',2,'[{role_lv, 150},{score,[{24010001,1},{24010002,3},{24010003,9}]}]'),(60,11,3,'降神积分','消耗神源之火升阶降神可获得相应的积分，达到指定的积分可领取奖励<color=#81ff3c>（初级神源之火1积分，中级神源之火2积分，高级神源之火4积分）</color>','[{9999, 9999}]','[]',1,'[]','[]','0','0',2,'[{role_lv, 150},{score,[{11020001,1},{11020002,2},{11020003,4}]}]'),(60,12,3,'星灵积分','消耗星辰之砂升阶星灵可获得相应的积分，达到指定的积分可领取奖励<color=#81ff3c>（初级星辰之砂1积分，中级星辰之砂3积分，高级星辰之砂9积分）</color>','[{9999, 9999}]','[]',1,'[]','[]','0','0',2,'[{role_lv, 150},{score,[{18020001,1},{18020002,3},{18020003,9}]}]'),(60,13,3,'坐骑积分','消耗坐骑树果升阶坐骑可获得相应的积分，达到指定的积分可领取奖励<color=#81ff3c>（初级坐骑树果1积分，中级坐骑树果3积分，高级坐骑树果9积分）</color>','[{9999, 9999}]','[]',1,'[]','[]','0','0',2,'[{role_lv, 150},{score,[{16020001,1},{16020002,3},{16020002,9}]}]'),(60,14,3,'圣灵积分','消耗晶核升级圣灵可获得相应的积分，达到指定的积分可领取奖励<color=#81ff3c>（初级晶核1积分，中级晶核3积分，高级晶核9积分）</color>','[{9999, 9999}]','[]',1,'[]','[]','0','0',2,'[{role_lv, 150},{score,[{15020101,1},{15020102,3},{15020103,9},{15020201,1},{15020202,3},{15020203,9},{15020301,1},{15020302,3},{15020303,9}]}]'),(60,15,3,'宝具积分','消耗宝具纹章升级宝具可获得相应的积分，达到指定的积分可领取奖励<color=#81ff3c>（初级宝具纹章1积分，中级宝具纹章3积分，高级宝具纹章9积分）</color>','[{9999, 9999}]','[]',1,'[]','[]','0','0',2,'[{role_lv, 150},{score,[{24010001,1},{24010002,3},{24010003,9}]}]'),(60,16,1,'降神积分','消耗神源之火升阶降神可获得相应的积分，达到指定的积分可领取奖励<color=#81ff3c>（初级神源之火1积分，中级神源之火2积分，高级神源之火4积分）</color>','[{8,8}]','[]',1,'[]','[]','0','0',2,'[{role_lv, 150},{score,[{11020001,1},{11020002,2},{11020003,4}]}]'),(60,17,3,'星灵积分','消耗星辰之砂升阶星灵可获得相应的积分，达到指定的积分可领取奖励<color=#81ff3c>（初级星辰之砂1积分，中级星辰之砂3积分，高级星辰之砂9积分）</color>','[{9,10}]','[]',1,'[]','[]','0','0',2,'[{role_lv, 150},{score,[{18020001,1},{18020002,3},{18020003,9}]}]'),(60,18,3,'降神积分','消耗神源之火升阶降神可获得相应的积分，达到指定的积分可领取奖励<color=#81ff3c>（初级神源之火1积分，中级神源之火2积分，高级神源之火4积分）</color>','[{11,12}]','[]',1,'[]','[]','0','0',2,'[{role_lv, 150},{score,[{11020001,1},{11020002,2},{11020003,4}]}]'),(60,19,3,'星灵积分','消耗星辰之砂升阶星灵可获得相应的积分，达到指定的积分可领取奖励<color=#81ff3c>（初级星辰之砂1积分，中级星辰之砂3积分，高级星辰之砂9积分）</color>','[{13,14}]','[]',1,'[]','[]','0','0',2,'[{role_lv, 150},{score,[{18020001,1},{18020002,3},{18020003,9}]}]'),(60,20,3,'坐骑积分','消耗坐骑树果升阶坐骑可获得相应的积分，达到指定的积分可领取奖励<color=#81ff3c>（初级坐骑树果1积分，中级坐骑树果3积分，高级坐骑树果9积分）</color>','[{15,16}]','[]',1,'[]','[]','0','0',2,'[{role_lv, 150},{score,[{16020001,1},{16020002,3},{16020002,9}]}]'),(60,21,3,'降神积分','消耗神源之火升阶降神可获得相应的积分，达到指定的积分可领取奖励<color=#81ff3c>（初级神源之火1积分，中级神源之火2积分，高级神源之火4积分）</color>','[{17,18}]','[]',1,'[]','[]','0','0',2,'[{role_lv, 150},{score,[{11020001,1},{11020002,2},{11020003,4}]}]'),(60,22,3,'星灵积分','消耗星辰之砂升阶星灵可获得相应的积分，达到指定的积分可领取奖励<color=#81ff3c>（初级星辰之砂1积分，中级星辰之砂3积分，高级星辰之砂9积分）</color>','[{19,20}]','[]',1,'[]','[]','0','0',2,'[{role_lv, 150},{score,[{18020001,1},{18020002,3},{18020003,9}]}]'),(60,23,3,'降神积分','消耗神源之火升阶降神可获得相应的积分，达到指定的积分可领取奖励<color=#81ff3c>（初级神源之火1积分，中级神源之火2积分，高级神源之火4积分）</color>','[{21,22}]','[]',1,'[]','[]','0','0',2,'[{role_lv, 150},{score,[{11020001,1},{11020002,2},{11020003,4}]}]'),(60,24,3,'星灵积分','消耗星辰之砂升阶星灵可获得相应的积分，达到指定的积分可领取奖励<color=#81ff3c>（初级星辰之砂1积分，中级星辰之砂3积分，高级星辰之砂9积分）</color>','[{23,24}]','[]',1,'[]','[]','0','0',2,'[{role_lv, 150},{score,[{18020001,1},{18020002,3},{18020003,9}]}]'),(60,25,3,'翅膀积分','消耗羽翼纹章升阶翅膀可获得相应的积分，达到指定的积分可领取奖励<color=#81ff3c>（初级羽翼纹章1积分，中级羽翼纹章3积分，高级羽翼纹章9积分）</color>','[{25,26}]','[]',1,'[]','[]','0','0',2,'[{role_lv, 150},{score,[{20060001,1},{20060002,3},{20060003,9}]}]'),(60,26,3,'降神积分','消耗神源之火升阶降神可获得相应的积分，达到指定的积分可领取奖励<color=#81ff3c>（初级神源之火1积分，中级神源之火2积分，高级神源之火4积分）</color>','[{27,28}]','[]',1,'[]','[]','0','0',2,'[{role_lv, 150},{score,[{11020001,1},{11020002,2},{11020003,4}]}]'),(61,1,3,'坐骑许愿','坐骑许愿','[{2,3}]','[]',1,'[]','[]','2019-06-01 00:00:00','2025-06-18 23:59:59',2,'[{role_lv, 150},{once_wish, [{0,38180015,20}]},{ten_wish, [{0,38180015,188}]}]'),(61,2,3,'降神许愿','降神许愿','[{4,4}]','[]',1,'[]','[]','0','0',2,'[{role_lv, 150},{once_wish, [{0,38180015,20}]},{ten_wish, [{0,38180015,188}]}]'),(61,3,3,'坐骑许愿','坐骑许愿','[{5,6}]','[]',1,'[]','[]','0','0',2,'[{role_lv, 150},{once_wish, [{0,38180015,20}]},{ten_wish, [{0,38180015,188}]}]'),(61,4,3,'星灵许愿','星灵许愿','[{7,8}]','[]',1,'[]','[]','0','0',2,'[{role_lv, 150},{once_wish, [{0,38180015,20}]},{ten_wish, [{0,38180015,188}]}]'),(61,5,3,'坐骑许愿','坐骑许愿','[{9,10}]','[]',1,'[]','[]','0','0',2,'[{role_lv, 150},{once_wish, [{0,38180015,20}]},{ten_wish, [{0,38180015,188}]}]'),(61,6,3,'降神许愿','降神许愿','[{11,12}]','[]',1,'[]','[]','0','0',2,'[{role_lv, 150},{once_wish, [{0,38180015,20}]},{ten_wish, [{0,38180015,188}]}]'),(61,7,3,'坐骑许愿','坐骑许愿','[{13,14}]','[]',1,'[]','[]','0','0',2,'[{role_lv, 150},{once_wish, [{0,38180015,20}]},{ten_wish, [{0,38180015,188}]}]'),(61,8,3,'星灵许愿','星灵许愿','[{15,16}]','[]',1,'[]','[]','0','0',2,'[{role_lv, 150},{once_wish, [{0,38180015,20}]},{ten_wish, [{0,38180015,188}]}]'),(61,9,3,'坐骑许愿','坐骑许愿','[{17,18}]','[]',1,'[]','[]','0','0',2,'[{role_lv, 150},{once_wish, [{0,38180015,20}]},{ten_wish, [{0,38180015,188}]}]'),(61,10,3,'降神许愿','降神许愿','[{19,20}]','[]',1,'[]','[]','0','0',2,'[{role_lv, 150},{once_wish, [{0,38180015,20}]},{ten_wish, [{0,38180015,188}]}]'),(61,11,3,'坐骑许愿','坐骑许愿','[{21,22}]','[]',1,'[]','[]','0','0',2,'[{role_lv, 150},{once_wish, [{0,38180015,20}]},{ten_wish, [{0,38180015,188}]}]'),(61,12,3,'星灵许愿','星灵许愿','[{23,24}]','[]',1,'[]','[]','0','0',2,'[{role_lv, 150},{once_wish, [{0,38180015,20}]},{ten_wish, [{0,38180015,188}]}]'),(61,13,3,'坐骑许愿','坐骑许愿','[{25,26}]','[]',1,'[]','[]','0','0',2,'[{role_lv, 150},{once_wish, [{0,38180015,20}]},{ten_wish, [{0,38180015,188}]}]'),(61,14,3,'降神许愿','降神许愿','[{27,28}]','[]',1,'[]','[]','0','0',2,'[{role_lv, 150},{once_wish, [{0,38180015,20}]},{ten_wish, [{0,38180015,188}]}]'),(61,15,3,'坐骑许愿','坐骑许愿','[{999,999}]','[]',1,'[]','[]','0','0',2,'[{role_lv, 150},{once_wish, [{0,38180015,20}]},{ten_wish, [{0,38180015,188}]}]'),(61,16,3,'星灵许愿','星灵许愿','[{999,999}]','[]',1,'[]','[]','0','0',2,'[{role_lv, 150},{once_wish, [{0,38180015,20}]},{ten_wish, [{0,38180015,188}]}]'),(62,1,3,'荣耀战神','荣耀战神','[{2,999}]','[]',1,'[]','[]','2019-06-12 00:00:00','2019-06-18 23:59:59',1,'[{time_region,[{{12,0},{12,10}},{{20,0},{20,10}}]}]'),(63,1,3,'vip特惠','vip特惠','[{8,999}]','[]',1,'[]','[]','2019-07-22 00:00:00','2019-07-22 23:59:59',1,'[]');
/*!40000 ALTER TABLE `base_custom_act` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_custom_act_reward`
--

DROP TABLE IF EXISTS `base_custom_act_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_custom_act_reward` (
  `type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动主类型',
  `subtype` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `grade` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '奖励档次',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '奖励名称@lang@',
  `desc` varchar(1024) NOT NULL DEFAULT '' COMMENT '奖励描述@lang@',
  `condition` varchar(255) NOT NULL DEFAULT '[]' COMMENT '领取条件',
  `format` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '奖励格式类型',
  `reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`type`,`subtype`,`grade`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='定制活动奖励配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_custom_act_reward`
--

LOCK TABLES `base_custom_act_reward` WRITE;
/*!40000 ALTER TABLE `base_custom_act_reward` DISABLE KEYS */;
INSERT INTO `base_custom_act_reward` VALUES (1,1,1,'第1名奖励','排名第1基础奖励','[{rank,{1,1}}]',1,'[{100,38140003,7},{100,38150003,7},{100,38100005,1},{100,40010001,3},{100,40010011,20}]'),(1,1,2,'第2名奖励','排名第2基础奖励','[{rank,{2,2}}]',1,'[{100,38140003,3},{100,38150003,3},{100,38100004,1},{100,40010001,2},{100,40010011,20}]'),(1,1,3,'第3名奖励','排名第3基础奖励','[{rank,{3,3}}]',1,'[{100,38140003,1},{100,38150003,1},{100,38100004,1},{100,40010001,1},{100,40010011,20}]'),(1,1,4,'第4-10名奖励','排名第4-10基础奖励','[{rank,{4,10}}]',1,'[{100,38140003,1},{100,38100003,1},{100,40010011,20}]'),(1,1,5,'第11-20名奖励','排名第11-20基础奖励','[{rank,{11,20}}]',1,'[{100,38150003,1},{100,38100002,1},{100,40010011,10}]'),(1,1,6,'第21-50名奖励','排名第21-50基础奖励','[{rank,{21,50}}]',1,'[{100,38100001,1},{100,40010011,10}]'),(1,1,11,'男榜第1名额外奖励','男榜排名第1额外奖励','[{rank,{1,1}},{sex,1}]',1,'[{100,4905002,1}]'),(1,1,12,'女榜第1名额外奖励','女榜排名第1额外奖励','[{rank,{1,1}},{sex,2}]',1,'[{100,4905002,1}]'),(2,1,1,'第1名奖励','排名第1基础奖励','[{rank,{1,1}}]',1,'[{100,38140004,15},{100,38150004,15},{100,40010002,3},{100,38100005,1},{100,40010011,50}]'),(2,1,2,'第2名奖励','排名第2-3基础奖励','[{rank,{2,3}}]',1,'[{100,38140004,7},{100,38150004,7},{100,40010002,2},{100,38100004,1},{100,40010011,40}]'),(2,1,3,'第4-10名奖励','排名第4-10基础奖励','[{rank,{4,10}}]',1,'[{100,38140004,3},{100,38150004,3},{100,40010002,1},{100,38100003,1},{100,40010011,40}]'),(2,1,4,'第11-20名奖励','排名第11-20基础奖励','[{rank,{11,20}}]',1,'[{100,38140004,1},{100,38150004,1},{100,38100002,1},{100,40010011,30}]'),(2,1,5,'第21-50名奖励','排名第21-50基础奖励','[{rank,{21,50}}]',1,'[{100,38140004,1},{100,38150004,1},{100,40010011,20}]'),(2,1,11,'男榜第1名额外奖励','男榜排名第1额外奖励','[{rank,{1,1}},{sex,1}]',1,'[{100,4905002,1}]'),(2,1,12,'女榜第1名额外奖励','女榜排名第1额外奖励','[{rank,{1,1}},{sex,2}]',1,'[{100,4905002,1}]'),(3,1,1,'第1名奖励','排名第1奖励','[{rank,{1,1}}]',1,'[{100,12040001,1},{100,38150001,1},{100,40010012,5}]'),(3,1,2,'第2-3名奖励','排名第2-3奖励','[{rank,{2,3}}]',1,'[{100,12040001,1},{100,38150001,1},{100,40010012,1}]'),(3,1,4,'第4-20名奖励','排名第4-20奖励','[{rank,{4,20}}]',1,'[{100,12040001,1},{100,40010012,1}]'),(4,1,1,'星界','星界','[{goods_exchange,[{0,38040013,1},{0,38040014,1}],0,0},{exchange_limit, 15}]',1,'[{0,11020001,1}]'),(4,1,2,'冒险','冒险','[{goods_exchange,[{0,38040015,1},{0,38040016,1}],0,0},{exchange_limit, 8}]',1,'[{0,16020001,1}]'),(4,1,3,'大冒险','大冒险','[{goods_exchange,[{0,38040013,1},{0,38040014,1},{0,38040015,1},{0,38040016,1}],0,0},{exchange_limit,4}]',1,'[{0,16010002,1}]'),(4,1,4,'星界大冒险','星界大冒险','[{goods_exchange,[{0,38040013,1},{0,38040014,1},{0,38040015,1},{0,38040016,1},{0,38040017,1}],331,4},{exchange_limit, 1}]',1,'[{0,24020004,1}]'),(4,2,1,'地球','地球','[{goods_exchange,[{0,38040013,1},{0,38040014,1}],0,0},{exchange_limit, 12}]',1,'[{100,24010001,1}]'),(4,2,2,'携手','携手','[{goods_exchange,[{0,38040015,1},{0,38040016,1}],0,0},{exchange_limit, 12}]',1,'[{100,20010001,1}]'),(4,2,3,'爱地球','爱地球','[{goods_exchange,[{0,38040013,1},{0,38040014,1},{0,38040015,1},{0,38040016,1}],0,0},{exchange_limit,8}]',1,'[{100,14010003,1}]'),(4,2,4,'携手爱','携手爱','[{goods_exchange,[{0,38040013,1},{0,38040014,1},{0,38040015,1},{0,38040016,1},{0,38040017,1}],331,4},{exchange_limit, 1}]',1,'[{100,14020003,1}]'),(4,2,5,'携手爱地球','携手爱地球','[{goods_exchange,[{0,38040028,1},{0,38040029,1},{0,38040030,1},{0,38040031,1},{0,38040032,1}],0,0}]',1,'[{100,38060017,1}]'),(4,4,1,'星界','星界','[{goods_exchange,[{0,38040013,1},{0,38040014,1}],0,0},{exchange_limit, 12}]',1,'[{0,11020001,1}]'),(4,4,2,'冒险','冒险','[{goods_exchange,[{0,38040015,1},{0,38040016,1}],0,0},{exchange_limit, 12}]',1,'[{0,24010001,1}]'),(4,4,3,'大冒险','大冒险','[{goods_exchange,[{0,38040013,1},{0,38040014,1},{0,38040015,1},{0,38040016,1}],0,0},{exchange_limit,8}]',1,'[{0,16020001,1}]'),(4,4,4,'星界大冒险','星界大冒险','[{goods_exchange,[{0,38040013,1},{0,38040014,1},{0,38040015,1},{0,38040016,1},{0,38040017,1}],331,4},{exchange_limit, 1}]',1,'[{0,32150004,1}]'),(4,101,1,'合服','合服','[{goods_exchange,[{0,38040052,1},{0,38040053,1}],0,0}]',1,'[{100,24010001,1}]'),(4,101,2,'合服爽','合服爽','[{goods_exchange,[{0,38040052,1},{0,38040053,1},{0,38040056,1}],0,0}]',1,'[{100,20010002,1}]'),(4,101,3,'倍儿爽','倍儿爽','[{goods_exchange,[{0,38040054,1},{0,38040055,1},{0,38040056,1}],0,0}]',1,'[{100,24020002,1}]'),(4,101,4,'合服倍儿爽','合服倍儿爽','[{goods_exchange,[{0,38040052,1},{0,38040053,1},{0,38040054,1},{0,38040055,1},{0,38040056,1}],0,0}]',1,'[{100,24020003,1}]'),(6,1,1,'累充60钻石','累充60钻石','[{type,1},{gold,60}]',1,'[{0,38180001,1},{0,37020002,1},{2,36020001,38},{0,53020020,1},{0,38030002,1},{0,36040009,1}]'),(6,1,2,'累充300钻石','累充300钻石','[{type,1},{gold,300}]',1,'[{0,38180001,1},{0,38330004,1},{0,38030002,1},{0,38030003,1},{2,36020001,88},{0,36040010,1}]'),(6,1,3,'累充680钻石','累充680钻石','[{type,1},{gold,680}]',1,'[{0,38180010,1},{0,38180001,1},{0,32160006,1},{0,53020020,3},{0,14010102,1},{0,14020202,1}]'),(6,1,4,'累充1280钻石','累充1280钻石','[{type,1},{gold,1280}]',1,'[{0,38160001,1},{0,38180010,1},{0,38180001,1},{0,53020020,3},{2,36020001,288},{0,38100007,1}]'),(6,1,11,'累计1天充值300钻石','累计1天充值300钻石','[{type,2},{gold,300},{day,1}]',1,'[{0,53030010,1}]'),(6,1,12,'累计2天充值300钻石','累计2天充值300钻石','[{type,2},{gold,300},{day,2}]',1,'[{0,53030020,1}]'),(6,1,13,'累计3天充值300钻石','累计3天充值300钻石','[{type,2},{gold,300},{day,3},{cycle,1}]',1,'[{0,53030030,1}]'),(7,1,1,'累充980钻石','累充980钻石','[{gold,980}]',5,'[{1,[{0,12010003,1},{100,1107010543,1},{0,32030201,1},{0,37020002,2},{0,17010001,20}]},{2,[{0,12010003,1},{100,1107020543,1},{0,32030201,1},{0,37020002,2},{0,17010001,20}]},{3,[{0,12010003,1},{100,1107030543,1},{0,32030201,1},{0,37020002,2},{0,17010001,20}]},{4,[{0,12010003,1},{100,1107040543,1},{0,32030201,1},{0,37020002,2},{0,17010001,20}]}]'),(7,1,2,'累充1960钻石','累充1960钻石','[{gold,1960}]',1,'[{0,5201143,1},{100,1103000543,1},{0,24010001,6},{0,20060002,1},{0,17010001,30}]'),(7,1,3,'累充4680钻石','累充4680钻石','[{gold,4680}]',1,'[{0,16030002,1},{0,12030003,1},{0,16020001,15},{0,14010103,1},{0,14020203,1}]'),(7,1,4,'累充9680钻石','累充9680钻石','[{gold,9680}]',1,'[{0,12020003,1},{255,36160008,1500},{0,24010001,30},{0,20060003,1},{0,32160005,5}]'),(7,1,5,'累充19600钻石','累充19600钻石','[{gold,19600}]',1,'[{0,20030009,1},{0,12010003,1},{0,14010104,1},{0,14020204,1},{0,17010001,50}]'),(7,1,6,'累充29800钻石','累充29800钻石','[{gold,29800}]',1,'[{0,24030001,1},{0,12020003,1},{0,24010001,90},{0,20060003,3},{0,37020004,1}]'),(7,1,7,'累充49600钻石','累充49600钻石','[{gold,49600}]',1,'[{0,20030001,1},{255,36160008,1500},{0,12030003,1},{0,16010001,3},{0,16010003,3}]'),(7,1,8,'累充99800钻石','累充99800钻石','[{gold,99800}]',1,'[{0,24030002,1},{0,12020003,1},{0,24010001,150},{0,20060003,3},{0,32160005,10}]'),(7,1,9,'累充149600钻石','累充149600钻石','[{gold,149600}]',1,'[{0,5201144,1},{255,36160008,1500},{0,12010003,1},{0,20020001,5},{0,20020002,5}]'),(7,1,10,'累充199800钻石','累充199800钻石','[{gold,199800}]',5,'[{1,[{0,53010101,1},{0,53030030,1},{0,12020003,1},{0,14010105,1},{0,14020205,1}]},{2,[{0,53010201,1},{0,53030030,1},{0,12020003,1},{0,14010105,1},{0,14020205,1}]},{4,[{0,53010401,1},{0,53030030,1},{0,12020003,1},{0,14010105,1},{0,14020205,1}]}]'),(7,2,1,'累充100钻石','累充100钻石','[{gold, 100}]',1,'[{0,37010101,2},{0,38100001,5},{0,20060001,2}]'),(7,2,2,'累充500钻石','累充500钻石','[{gold,500}]',1,'[{0,37010102,1},{0,37020001,1},{0,20060001,5}]'),(7,2,3,'累充1000钻石','累充1000钻石','[{gold,1000}]',1,'[{0,37010103,1},{0,37020002,1},{0,20060001,10}]'),(7,2,4,'累充2000钻石','累充2000钻石','[{gold,2000}]',1,'[{0,37010201,1},{0,38180010,1},{0,20060001,15}]'),(7,2,5,'累充5000钻石','累充5000钻石','[{gold,5000}]',1,'[{0,37010202,1},{0,38180001,5},{0,20060001,20}]'),(7,2,6,'累充10000钻石','累充10000钻石','[{gold,10000}]',1,'[{0,37010001,1},{0,38180016,1},{0,38340001,1}]'),(7,3,1,'累充100钻石','累充100钻石','[{gold, 100}]',1,'[{0,37010103,1},{0,38100001,5},{0,24010001,2}]'),(7,3,2,'累充500钻石','累充500钻石','[{gold,500}]',1,'[{0,37010201,1},{0,38180001,1},{0,24010001,5}]'),(7,3,3,'累充1000钻石','累充1000钻石','[{gold,1000}]',1,'[{0,37010202,1},{0,38180001,2},{0,24010001,10}]'),(7,3,4,'累充2000钻石','累充2000钻石','[{gold,2000}]',1,'[{0,37010001,1},{0,38180010,2},{0,24010001,15}]'),(7,3,5,'累充5000钻石','累充5000钻石','[{gold,5000}]',1,'[{0,37010001,1},{0,38180001,5},{0,24010001,30}]'),(7,3,6,'累充10000钻石','累充10000钻石','[{gold,10000}]',1,'[{0,37010002,1},{0,38180010,5},{0,24010001,50}]'),(7,4,1,'累充100钻石','累充100钻石','[{gold, 100}]',1,'[{0,38180015,20},{0,38100001,5},{0,16020001,2}]'),(7,4,2,'累充500钻石','累充500钻石','[{gold,500}]',1,'[{0,16090001,1},{0,38180001,1},{0,16020001,4}]'),(7,4,3,'累充1000钻石','累充1000钻石','[{gold,1000}]',1,'[{0,16090001,2},{0,38180001,2},{0,16020001,8}]'),(7,4,4,'累充2000钻石','累充2000钻石','[{gold,2000}]',1,'[{0,16090001,3},{0,38180010,2},{0,16020001,12}]'),(7,4,5,'累充5000钻石','累充5000钻石','[{gold,5000}]',1,'[{0,16090001,4},{0,38180001,5},{0,16020001,18}]'),(7,4,6,'累充10000钻石','累充10000钻石','[{gold,10000}]',1,'[{0,16090001,5},{0,38180010,5},{0,16020001,28}]'),(7,5,1,'累充100钻石','累充100钻石','[{gold, 100}]',1,'[{0,38180015,20},{0,38100001,5},{0,11020001,2}]'),(7,5,2,'累充500钻石','累充500钻石','[{gold,500}]',1,'[{0,11050004,1},{0,38180001,1},{0,11020001,5}]'),(7,5,3,'累充1000钻石','累充1000钻石','[{gold,1000}]',1,'[{0,11050004,2},{0,38180001,2},{0,11020001,10}]'),(7,5,4,'累充2000钻石','累充2000钻石','[{gold,2000}]',1,'[{0,11050004,3},{0,38180010,2},{0,11020001,15}]'),(7,5,5,'累充5000钻石','累充5000钻石','[{gold,5000}]',1,'[{0,11050004,4},{0,38180001,5},{0,11020001,30}]'),(7,5,6,'累充10000钻石','累充10000钻石','[{gold,10000}]',1,'[{0,11050004,5},{0,38180010,5},{0,11020001,50}]'),(7,6,1,'累充100钻石','累充100钻石','[{gold, 100}]',1,'[{0,38180015,20},{0,38100001,5},{0,5203003,1}]'),(7,6,2,'累充500钻石','累充500钻石','[{gold,500}]',1,'[{255,36160008,100},{0,38180010,2},{0,5203004,1}]'),(7,6,3,'累充1000钻石','累充1000钻石','[{gold,1000}]',1,'[{255,36160008,200},{0,38180010,3},{0,5203004,2}]'),(7,6,4,'累充2000钻石','累充2000钻石','[{gold,2000}]',1,'[{255,36160008,300},{255,36160007,12000},{0,5203004,3}]'),(7,6,5,'累充5000钻石','累充5000钻石','[{gold,5000}]',1,'[{255,36160008,400},{0,38180010,4},{0,5203004,5}]'),(7,6,6,'累充10000钻石','累充10000钻石','[{gold,10000}]',1,'[{255,36160008,500},{0,38180016,1},{0,5203004,10}]'),(7,7,1,'累充100钻石','累充100钻石','[{gold, 100}]',1,'[{0,14010102,1},{0,14020202,1},{0,38100001,5}]'),(7,7,2,'累充500钻石','累充500钻石','[{gold,500}]',1,'[{0,14010102,2},{0,14020202,2},{0,38180001,1}]'),(7,7,3,'累充1000钻石','累充1000钻石','[{gold,1000}]',1,'[{0,14010103,1},{0,14020203,1},{0,38180001,2}]'),(7,7,4,'累充2000钻石','累充2000钻石','[{gold,2000}]',1,'[{0,14010103,2},{0,14020203,2},{0,38180010,2}]'),(7,7,5,'累充5000钻石','累充5000钻石','[{gold,5000}]',1,'[{0,14010104,1},{0,14020204,1},{0,38180001,5}]'),(7,7,6,'累充10000钻石','累充10000钻石','[{gold,10000}]',1,'[{0,14010105,1},{0,14020205,1},{0,38180010,5}]'),(7,8,1,'累充100钻石','累充100钻石','[{gold, 100}]',1,'[{0,32020113,1},{0,32020112,2},{0,38100001,5}]'),(7,8,2,'累充500钻石','累充500钻石','[{gold,500}]',1,'[{0,32020113,2},{0,32020112,5},{0,38180001,1}]'),(7,8,3,'累充1000钻石','累充1000钻石','[{gold,1000}]',1,'[{0,32020113,5},{0,32020112,10},{0,38180001,2}]'),(7,8,4,'累充2000钻石','累充2000钻石','[{gold,2000}]',1,'[{0,32020113,8},{0,32020112,15},{0,38180010,2}]'),(7,8,5,'累充5000钻石','累充5000钻石','[{gold,5000}]',1,'[{0,32020113,10},{0,32020112,30},{0,38180001,5}]'),(7,8,6,'累充10000钻石','累充10000钻石','[{gold,10000}]',1,'[{0,32020114,5},{0,32020112,50},{0,38180010,5}]'),(7,9,1,'累充100钻石','累充100钻石','[{gold, 100}]',1,'[{0,53020030,1},{0,53020010,2},{0,38100001,5}]'),(7,9,2,'累充500钻石','累充500钻石','[{gold,500}]',1,'[{0,53020030,1},{0,53020010,5},{0,38180001,1}]'),(7,9,3,'累充1000钻石','累充1000钻石','[{gold,1000}]',1,'[{0,53020030,2},{0,53020010,10},{0,38180001,2}]'),(7,9,4,'累充2000钻石','累充2000钻石','[{gold,2000}]',1,'[{0,53020030,3},{0,53020010,15},{0,38180010,2}]'),(7,9,5,'累充5000钻石','累充5000钻石','[{gold,5000}]',1,'[{0,53020030,4},{0,53020010,30},{0,38180001,5}]'),(7,9,6,'累充10000钻石','累充10000钻石','[{gold,10000}]',1,'[{0,53020030,5},{0,53020010,50},{0,38180010,5}]'),(7,10,1,'累充500钻石','累充500钻石','[{gold,500}]',1,'[{0,40010011,2},{0,38260001,10}]'),(7,10,2,'累充1000钻石','累充1000钻石','[{gold,1000}]',1,'[{0,20060002,2},{0,38260001,20},{0,38180001,1}]'),(7,10,3,'累充2000钻石','累充2000钻石','[{gold,2000}]',1,'[{0,24010001,15},{0,38260001,30},{0,38180001,2}]'),(7,10,4,'累充5000钻石','累充5000钻石','[{gold,5000}]',1,'[{0,16020001,18},{0,38260001,40},{0,38180001,5}]'),(7,10,5,'累充10000钻石','累充10000钻石','[{gold,10000}]',1,'[{0,11020001,45},{0,38260001,50},{0,38180010,1}]'),(7,10,6,'累充20000钻石','累充20000钻石','[{gold,20000}]',1,'[{0,18020001,45},{0,24020003,1},{0,38260001,60},{0,38180010,1}]'),(7,11,1,'累充500钻石','累充500钻石','[{gold,500}]',1,'[{0,40010011,2},{0,38260001,10}]'),(7,11,2,'累充1000钻石','累充1000钻石','[{gold,1000}]',1,'[{0,20060002,2},{0,38260001,20},{0,38180001,1}]'),(7,11,3,'累充2000钻石','累充2000钻石','[{gold,2000}]',1,'[{0,24010001,15},{0,38260001,30},{0,38180001,2}]'),(7,11,4,'累充5000钻石','累充5000钻石','[{gold,5000}]',1,'[{0,16020001,18},{0,38260001,40},{0,38180001,5}]'),(7,11,5,'累充10000钻石','累充10000钻石','[{gold,10000}]',1,'[{0,11020001,45},{0,38260001,50},{0,38180010,1}]'),(7,11,6,'累充20000钻石','累充20000钻石','[{gold,20000}]',1,'[{0,18020001,45},{0,24020003,1},{0,38260001,60},{0,38180010,1}]'),(7,12,1,'累充500钻石','累充500钻石','[{gold,500}]',1,'[{0,40010011,2},{0,38260001,10}]'),(7,12,2,'累充1000钻石','累充1000钻石','[{gold,1000}]',1,'[{0,20060002,2},{0,38260001,20},{0,38180001,1}]'),(7,12,3,'累充2000钻石','累充2000钻石','[{gold,2000}]',1,'[{0,24010001,15},{0,38260001,30},{0,38180001,2}]'),(7,12,4,'累充5000钻石','累充5000钻石','[{gold,5000}]',1,'[{0,16020001,18},{0,38260001,40},{0,38180001,5}]'),(7,12,5,'累充10000钻石','累充10000钻石','[{gold,10000}]',1,'[{0,11020001,45},{0,38260001,50},{0,38180010,1}]'),(7,12,6,'累充20000钻石','累充20000钻石','[{gold,20000}]',1,'[{0,18020001,45},{0,24020003,1},{0,38260001,60},{0,38180010,1}]'),(7,13,1,'累充500钻石','累充500钻石','[{gold,500}]',1,'[{0,40010011,2},{0,38260001,10}]'),(7,13,2,'累充1000钻石','累充1000钻石','[{gold,1000}]',1,'[{0,20060002,2},{0,38260001,20},{0,38180001,1}]'),(7,13,3,'累充2000钻石','累充2000钻石','[{gold,2000}]',1,'[{0,24010001,15},{0,38260001,30},{0,38180001,2}]'),(7,13,4,'累充5000钻石','累充5000钻石','[{gold,5000}]',1,'[{0,16020001,18},{0,38260001,40},{0,38180001,5}]'),(7,13,5,'累充10000钻石','累充10000钻石','[{gold,10000}]',1,'[{0,11020001,45},{0,38260001,50},{0,38180010,1}]'),(7,13,6,'累充20000钻石','累充20000钻石','[{gold,20000}]',1,'[{0,18020001,45},{0,24020003,1},{0,38260001,60},{0,38180010,1}]'),(7,14,1,'累充500钻石','累充500钻石','[{gold,500}]',1,'[{0,40010011,2},{0,38260001,10}]'),(7,14,2,'累充1000钻石','累充1000钻石','[{gold,1000}]',1,'[{0,20060002,2},{0,38260001,20},{0,38180001,1}]'),(7,14,3,'累充2000钻石','累充2000钻石','[{gold,2000}]',1,'[{0,24010001,15},{0,38260001,30},{0,38180001,2}]'),(7,14,4,'累充5000钻石','累充5000钻石','[{gold,5000}]',1,'[{0,16020001,18},{0,38260001,40},{0,38180001,5}]'),(7,14,5,'累充10000钻石','累充10000钻石','[{gold,10000}]',1,'[{0,11020001,45},{0,38260001,50},{0,38180010,1}]'),(7,14,6,'累充20000钻石','累充20000钻石','[{gold,20000}]',1,'[{0,18020001,45},{0,24020003,1},{0,38260001,60},{0,38180010,1}]'),(7,15,1,'累充500钻石','累充500钻石','[{gold,500}]',1,'[{0,40010011,2},{0,38260001,10}]'),(7,15,2,'累充1000钻石','累充1000钻石','[{gold,1000}]',1,'[{0,20060002,2},{0,38260001,20},{0,38180001,1}]'),(7,15,3,'累充2000钻石','累充2000钻石','[{gold,2000}]',1,'[{0,24010001,15},{0,38260001,30},{0,38180001,2}]'),(7,15,4,'累充5000钻石','累充5000钻石','[{gold,5000}]',1,'[{0,16020001,18},{0,38260001,40},{0,38180001,5}]'),(7,15,5,'累充10000钻石','累充10000钻石','[{gold,10000}]',1,'[{0,11020001,45},{0,38260001,50},{0,38180010,1}]'),(7,15,6,'累充20000钻石','累充20000钻石','[{gold,20000}]',1,'[{0,18020001,45},{0,24020003,1},{0,38260001,60},{0,38180010,1}]'),(7,16,1,'累充500钻石','累充500钻石','[{gold,500}]',1,'[{0,40010011,2},{0,38260001,10}]'),(7,16,2,'累充1000钻石','累充1000钻石','[{gold,1000}]',1,'[{0,20060002,2},{0,38260001,20},{0,38180001,1}]'),(7,16,3,'累充2000钻石','累充2000钻石','[{gold,2000}]',1,'[{0,24010001,15},{0,38260001,30},{0,38180001,2}]'),(7,16,4,'累充5000钻石','累充5000钻石','[{gold,5000}]',1,'[{0,16020001,18},{0,38260001,40},{0,38180001,5}]'),(7,16,5,'累充10000钻石','累充10000钻石','[{gold,10000}]',1,'[{0,11020001,45},{0,38260001,50},{0,38180010,1}]'),(7,16,6,'累充20000钻石','累充20000钻石','[{gold,20000}]',1,'[{0,18020001,45},{0,24020003,1},{0,38260001,60},{0,38180010,1}]'),(7,17,1,'累充500钻石','累充500钻石','[{gold,500}]',1,'[{0,40010011,2},{0,38260001,10}]'),(7,17,2,'累充1000钻石','累充1000钻石','[{gold,1000}]',1,'[{0,20060002,2},{0,38260001,20},{0,38180001,1}]'),(7,17,3,'累充2000钻石','累充2000钻石','[{gold,2000}]',1,'[{0,24010001,15},{0,38260001,30},{0,38180001,2}]'),(7,17,4,'累充5000钻石','累充5000钻石','[{gold,5000}]',1,'[{0,16020001,18},{0,38260001,40},{0,38180001,5}]'),(7,17,5,'累充10000钻石','累充10000钻石','[{gold,10000}]',1,'[{0,11020001,45},{0,38260001,50},{0,38180010,1}]'),(7,17,6,'累充20000钻石','累充20000钻石','[{gold,20000}]',1,'[{0,18020001,45},{0,24020003,1},{0,38260001,60},{0,38180010,1}]'),(7,18,1,'累充500钻石','累充500钻石','[{gold,500}]',1,'[{0,40010011,2},{0,38260001,10}]'),(7,18,2,'累充1000钻石','累充1000钻石','[{gold,1000}]',1,'[{0,20060002,2},{0,38260001,20},{0,38180001,1}]'),(7,18,3,'累充2000钻石','累充2000钻石','[{gold,2000}]',1,'[{0,24010001,15},{0,38260001,30},{0,38180001,2}]'),(7,18,4,'累充5000钻石','累充5000钻石','[{gold,5000}]',1,'[{0,16020001,18},{0,38260001,40},{0,38180001,5}]'),(7,18,5,'累充10000钻石','累充10000钻石','[{gold,10000}]',1,'[{0,11020001,45},{0,38260001,50},{0,38180010,1}]'),(7,18,6,'累充20000钻石','累充20000钻石','[{gold,20000}]',1,'[{0,18020001,45},{0,24020003,1},{0,38260001,60},{0,38180010,1}]'),(7,19,1,'累充500钻石','累充500钻石','[{gold,500}]',1,'[{0,40010011,2},{0,38260001,10}]'),(7,19,2,'累充1000钻石','累充1000钻石','[{gold,1000}]',1,'[{0,20060002,2},{0,38260001,20},{0,38180001,1}]'),(7,19,3,'累充2000钻石','累充2000钻石','[{gold,2000}]',1,'[{0,24010001,15},{0,38260001,30},{0,38180001,2}]'),(7,19,4,'累充5000钻石','累充5000钻石','[{gold,5000}]',1,'[{0,16020001,18},{0,38260001,40},{0,38180001,5}]'),(7,19,5,'累充10000钻石','累充10000钻石','[{gold,10000}]',1,'[{0,11020001,45},{0,38260001,50},{0,38180010,1}]'),(7,19,6,'累充20000钻石','累充20000钻石','[{gold,20000}]',1,'[{0,18020001,45},{0,24020003,1},{0,38260001,60},{0,38180010,1}]'),(7,20,1,'累充500钻石','累充500钻石','[{gold,500}]',1,'[{0,40010011,2},{0,38260001,10}]'),(7,20,2,'累充1000钻石','累充1000钻石','[{gold,1000}]',1,'[{0,20060002,2},{0,38260001,20},{0,38180001,1}]'),(7,20,3,'累充2000钻石','累充2000钻石','[{gold,2000}]',1,'[{0,24010001,15},{0,38260001,30},{0,38180001,2}]'),(7,20,4,'累充5000钻石','累充5000钻石','[{gold,5000}]',1,'[{0,16020001,18},{0,38260001,40},{0,38180001,5}]'),(7,20,5,'累充10000钻石','累充10000钻石','[{gold,10000}]',1,'[{0,11020001,45},{0,38260001,50},{0,38180010,1}]'),(7,20,6,'累充20000钻石','累充20000钻石','[{gold,20000}]',1,'[{0,18020001,45},{0,24020003,1},{0,38260001,60},{0,38180010,1}]'),(7,21,1,'累充500钻石','累充500钻石','[{gold,500}]',1,'[{0,40010011,2},{0,38260001,10}]'),(7,21,2,'累充1000钻石','累充1000钻石','[{gold,1000}]',1,'[{0,20060002,2},{0,38260001,20},{0,38180001,1}]'),(7,21,3,'累充2000钻石','累充2000钻石','[{gold,2000}]',1,'[{0,24010001,15},{0,38260001,30},{0,38180001,2}]'),(7,21,4,'累充5000钻石','累充5000钻石','[{gold,5000}]',1,'[{0,16020001,18},{0,38260001,40},{0,38180001,5}]'),(7,21,5,'累充10000钻石','累充10000钻石','[{gold,10000}]',1,'[{0,11020001,45},{0,38260001,50},{0,38180010,1}]'),(7,21,6,'累充20000钻石','累充20000钻石','[{gold,20000}]',1,'[{0,18020001,45},{0,24020003,1},{0,38260001,60},{0,38180010,1}]'),(7,22,1,'累充500钻石','累充500钻石','[{gold,500}]',1,'[{0,40010011,2},{0,38260001,10}]'),(7,22,2,'累充1000钻石','累充1000钻石','[{gold,1000}]',1,'[{0,20060002,2},{0,38260001,20},{0,38180001,1}]'),(7,22,3,'累充2000钻石','累充2000钻石','[{gold,2000}]',1,'[{0,24010001,15},{0,38260001,30},{0,38180001,2}]'),(7,22,4,'累充5000钻石','累充5000钻石','[{gold,5000}]',1,'[{0,16020001,18},{0,38260001,40},{0,38180001,5}]'),(7,22,5,'累充10000钻石','累充10000钻石','[{gold,10000}]',1,'[{0,11020001,45},{0,38260001,50},{0,38180010,1}]'),(7,22,6,'累充20000钻石','累充20000钻石','[{gold,20000}]',1,'[{0,18020001,45},{0,24020003,1},{0,38260001,60},{0,38180010,1}]'),(7,23,1,'累充500钻石','累充500钻石','[{gold,500}]',1,'[{0,40010011,2},{0,38260001,10}]'),(7,23,2,'累充1000钻石','累充1000钻石','[{gold,1000}]',1,'[{0,20060002,2},{0,38260001,20},{0,38180001,1}]'),(7,23,3,'累充2000钻石','累充2000钻石','[{gold,2000}]',1,'[{0,24010001,15},{0,38260001,30},{0,38180001,2}]'),(7,23,4,'累充5000钻石','累充5000钻石','[{gold,5000}]',1,'[{0,16020001,18},{0,38260001,40},{0,38180001,5}]'),(7,23,5,'累充10000钻石','累充10000钻石','[{gold,10000}]',1,'[{0,11020001,45},{0,38260001,50},{0,38180010,1}]'),(7,23,6,'累充20000钻石','累充20000钻石','[{gold,20000}]',1,'[{0,18020001,45},{0,24020003,1},{0,38260001,60},{0,38180010,1}]'),(7,24,1,'累充500钻石','累充500钻石','[{gold,500}]',1,'[{0,40010011,2},{0,38260001,10}]'),(7,24,2,'累充1000钻石','累充1000钻石','[{gold,1000}]',1,'[{0,20060002,2},{0,38260001,20},{0,38180001,1}]'),(7,24,3,'累充2000钻石','累充2000钻石','[{gold,2000}]',1,'[{0,24010001,15},{0,38260001,30},{0,38180001,2}]'),(7,24,4,'累充5000钻石','累充5000钻石','[{gold,5000}]',1,'[{0,16020001,18},{0,38260001,40},{0,38180001,5}]'),(7,24,5,'累充10000钻石','累充10000钻石','[{gold,10000}]',1,'[{0,11020001,45},{0,38260001,50},{0,38180010,1}]'),(7,24,6,'累充20000钻石','累充20000钻石','[{gold,20000}]',1,'[{0,18020001,45},{0,24020003,1},{0,38260001,60},{0,38180010,1}]'),(7,25,1,'累充500钻石','累充500钻石','[{gold,500}]',1,'[{0,40010011,2},{0,38260001,10}]'),(7,25,2,'累充1000钻石','累充1000钻石','[{gold,1000}]',1,'[{0,20060002,2},{0,38260001,20},{0,38180001,1}]'),(7,25,3,'累充2000钻石','累充2000钻石','[{gold,2000}]',1,'[{0,24010001,15},{0,38260001,30},{0,38180001,2}]'),(7,25,4,'累充5000钻石','累充5000钻石','[{gold,5000}]',1,'[{0,16020001,18},{0,38260001,40},{0,38180001,5}]'),(7,25,5,'累充10000钻石','累充10000钻石','[{gold,10000}]',1,'[{0,11020001,45},{0,38260001,50},{0,38180010,1}]'),(7,25,6,'累充20000钻石','累充20000钻石','[{gold,20000}]',1,'[{0,18020001,45},{0,24020003,1},{0,38260001,60},{0,38180010,1}]'),(7,26,1,'累充500钻石','累充500钻石','[{gold,500}]',1,'[{0,40010011,2},{0,38260001,10}]'),(7,26,2,'累充1000钻石','累充1000钻石','[{gold,1000}]',1,'[{0,20060002,2},{0,38260001,20},{0,38180001,1}]'),(7,26,3,'累充2000钻石','累充2000钻石','[{gold,2000}]',1,'[{0,24010001,15},{0,38260001,30},{0,38180001,2}]'),(7,26,4,'累充5000钻石','累充5000钻石','[{gold,5000}]',1,'[{0,16020001,18},{0,38260001,40},{0,38180001,5}]'),(7,26,5,'累充10000钻石','累充10000钻石','[{gold,10000}]',1,'[{0,11020001,45},{0,38260001,50},{0,38180010,1}]'),(7,26,6,'累充20000钻石','累充20000钻石','[{gold,20000}]',1,'[{0,18020001,45},{0,24020003,1},{0,38260001,60},{0,38180010,1}]'),(7,27,1,'累充500钻石','累充500钻石','[{gold,500}]',1,'[{0,40010011,2},{0,38260001,10}]'),(7,27,2,'累充1000钻石','累充1000钻石','[{gold,1000}]',1,'[{0,20060002,2},{0,38260001,20},{0,38180001,1}]'),(7,27,3,'累充2000钻石','累充2000钻石','[{gold,2000}]',1,'[{0,24010001,15},{0,38260001,30},{0,38180001,2}]'),(7,27,4,'累充5000钻石','累充5000钻石','[{gold,5000}]',1,'[{0,16020001,18},{0,38260001,40},{0,38180001,5}]'),(7,27,5,'累充10000钻石','累充10000钻石','[{gold,10000}]',1,'[{0,11020001,45},{0,38260001,50},{0,38180010,1}]'),(7,27,6,'累充20000钻石','累充20000钻石','[{gold,20000}]',1,'[{0,18020001,45},{0,24020003,1},{0,38260001,60},{0,38180010,1}]'),(7,28,1,'累充500钻石','累充500钻石','[{gold,500}]',1,'[{0,40010011,2},{0,38260001,10}]'),(7,28,2,'累充1000钻石','累充1000钻石','[{gold,1000}]',1,'[{0,20060002,2},{0,38260001,20},{0,38180001,1}]'),(7,28,3,'累充2000钻石','累充2000钻石','[{gold,2000}]',1,'[{0,24010001,15},{0,38260001,30},{0,38180001,2}]'),(7,28,4,'累充5000钻石','累充5000钻石','[{gold,5000}]',1,'[{0,16020001,18},{0,38260001,40},{0,38180001,5}]'),(7,28,5,'累充10000钻石','累充10000钻石','[{gold,10000}]',1,'[{0,11020001,45},{0,38260001,50},{0,38180010,1}]'),(7,28,6,'累充20000钻石','累充20000钻石','[{gold,20000}]',1,'[{0,18020001,45},{0,24020003,1},{0,38260001,60},{0,38180010,1}]'),(7,29,1,'累充500钻石','累充500钻石','[{gold,500}]',1,'[{0,40010011,2},{0,38260001,11}]'),(7,29,2,'累充1000钻石','累充1000钻石','[{gold,1000}]',1,'[{0,20060002,2},{0,38260001,20},{0,38180001,2}]'),(7,29,3,'累充2000钻石','累充2000钻石','[{gold,2000}]',1,'[{0,24010001,15},{0,38260001,30},{0,38180001,3}]'),(7,29,4,'累充5000钻石','累充5000钻石','[{gold,5000}]',1,'[{0,16020001,18},{0,38260001,40},{0,38180001,6}]'),(7,29,5,'累充10000钻石','累充10000钻石','[{gold,10000}]',1,'[{0,11020001,45},{0,38260001,50},{0,38180010,2}]'),(7,29,6,'累充20000钻石','累充20000钻石','[{gold,20000}]',1,'[{0,18020001,45},{0,24020003,1},{0,38260001,60},{0,38180010,2}]'),(7,30,1,'累充500钻石','累充500钻石','[{gold,500}]',1,'[{0,40010011,2},{0,38260001,11}]'),(7,30,2,'累充1000钻石','累充1000钻石','[{gold,1000}]',1,'[{0,20060002,2},{0,38260001,20},{0,38180001,2}]'),(7,30,3,'累充2000钻石','累充2000钻石','[{gold,2000}]',1,'[{0,24010001,15},{0,38260001,30},{0,38180001,3}]'),(7,30,4,'累充5000钻石','累充5000钻石','[{gold,5000}]',1,'[{0,16020001,18},{0,38260001,40},{0,38180001,6}]'),(7,30,5,'累充10000钻石','累充10000钻石','[{gold,10000}]',1,'[{0,11020001,45},{0,38260001,50},{0,38180010,2}]'),(7,30,6,'累充20000钻石','累充20000钻石','[{gold,20000}]',1,'[{0,18020001,45},{0,24020003,1},{0,38260001,60},{0,38180010,2}]'),(7,31,1,'累充188钻石','累充188钻石','[{gold,188}]',1,'[{0,38220009,5},{0,38160001,1},{0,12030011,1},{0,24020002,1},{0,18041002,1}]'),(7,31,2,'累充288钻石','累充288钻石','[{gold,288}]',1,'[{0,38220009,10},{0,16010003,1},{0,16010001,1},{0,16010002,1},{0,18041002,2}]'),(7,31,3,'累充588钻石','累充588钻石','[{gold,588}]',1,'[{0,38220009,15},{0,17020003,1},{0,17020001,1},{0,17020002,1},{0,18041002,3},{0,18020001,10}]'),(7,31,4,'累充888钻石','累充888钻石','[{gold,888}]',1,'[{0,38220009,20},{10,36010002,88},{0,12020011,1},{255,36160008,100},{0,36040009,1},{0,18020001,15}]'),(7,31,5,'累充1688钻石','累充1688钻石','[{gold,1688}]',1,'[{0,38220009,25},{10,36010002,188},{255,36160008,200},{0,38180002,10},{0,36040010,1},{0,18020001,20}]'),(7,31,6,'累充2888钻石','累充2888钻石','[{gold,2888}]',1,'[{0,38220009,30},{10,36010002,288},{0,38180012,5},{0,18041005,3},{0,12010011,1},{0,54010001,30}]'),(7,31,7,'累充5888钻石','累充5888钻石','[{gold,5888}]',1,'[{0,38220009,35},{10,36010002,588},{0,18041005,3},{0,54030002,1},{0,54040001,30},{0,54020002,1}]'),(7,31,8,'累充8888钻石','累充8888钻石','[{gold,8888}]',1,'[{0,38220009,40},{10,36010002,688},{0,20020003,2},{0,20020001,4},{0,36040010,1},{0,54020003,1}]'),(7,31,9,'累充12888钻石','累充12888钻石','[{gold,12888}]',1,'[{0,38220009,50},{10,36010002,888},{0,24020003,2},{0,24020001,4},{0,32020113,10},{0,11070003,10}]'),(7,31,10,'累充16888钻石','累充16888钻石','[{gold,16888}]',1,'[{0,38220009,60},{10,36010002,1088},{0,53030030,1},{0,53030010,4},{0,32020114,10},{0,11070003,30}]'),(7,32,1,'累充188钻石','累充188钻石','[{gold,188}]',1,'[{0,38220009,5},{0,38160001,1},{0,12030011,1},{0,24020002,1},{0,18041005,1}]'),(7,32,2,'累充288钻石','累充288钻石','[{gold,288}]',1,'[{0,38220009,10},{0,16010003,1},{0,16010001,1},{0,16010002,1},{0,18041005,2}]'),(7,32,3,'累充588钻石','累充588钻石','[{gold,588}]',1,'[{0,38220009,15},{0,17020003,1},{0,17020001,1},{0,17020002,1},{0,18041005,3},{0,18020001,10}]'),(7,32,4,'累充888钻石','累充888钻石','[{gold,888}]',1,'[{0,38220009,20},{10,36010002,88},{0,12020011,1},{255,36160008,100},{0,36040009,1},{0,18020001,15}]'),(7,32,5,'累充1688钻石','累充1688钻石','[{gold,1688}]',1,'[{0,38220009,25},{10,36010002,188},{255,36160008,200},{0,38180002,10},{0,36040010,1},{0,18020001,20}]'),(7,32,6,'累充2888钻石','累充2888钻石','[{gold,2888}]',1,'[{0,38220009,30},{10,36010002,288},{0,38180012,5},{0,18041005,3},{0,12010011,1},{0,54010001,30}]'),(7,32,7,'累充5888钻石','累充5888钻石','[{gold,5888}]',1,'[{0,38220009,35},{10,36010002,588},{0,18041002,3},{0,54050001,1},{0,54020003,1},{0,54020002,1}]'),(7,32,8,'累充8888钻石','累充8888钻石','[{gold,8888}]',1,'[{0,38220009,40},{10,36010002,688},{0,20020003,2},{0,20020001,4},{0,36040010,1},{0,54020003,1}]'),(7,32,9,'累充12888钻石','累充12888钻石','[{gold,12888}]',1,'[{0,38220009,50},{10,36010002,888},{0,24020003,2},{0,24020001,4},{0,32020113,10},{0,11070003,10}]'),(7,32,10,'累充16888钻石','累充16888钻石','[{gold,16888}]',1,'[{0,38220009,60},{10,36010002,1088},{0,53030030,1},{0,53030010,4},{0,32020114,10},{0,11070003,30}]'),(7,33,1,'累充188钻石','累充188钻石','[{gold,188}]',1,'[{0,38220009,5},{0,38160001,1},{0,12030011,1},{0,24020002,1},{0,18041002,1}]'),(7,33,2,'累充288钻石','累充288钻石','[{gold,288}]',1,'[{0,38220009,10},{0,16010003,1},{0,16010001,1},{0,16010002,1},{0,18041002,2}]'),(7,33,3,'累充588钻石','累充588钻石','[{gold,588}]',1,'[{0,38220009,15},{0,17020003,1},{0,17020001,1},{0,17020002,1},{0,18041002,3},{0,18020001,10}]'),(7,33,4,'累充888钻石','累充888钻石','[{gold,888}]',1,'[{0,38220009,20},{10,36010002,88},{0,12020011,1},{255,36160008,100},{0,36040009,1},{0,18020001,15}]'),(7,33,5,'累充1688钻石','累充1688钻石','[{gold,1688}]',1,'[{0,38220009,25},{10,36010002,188},{255,36160008,200},{0,38180002,10},{0,36040010,1},{0,18020001,20}]'),(7,33,6,'累充2888钻石','累充2888钻石','[{gold,2888}]',1,'[{0,38220009,30},{10,36010002,288},{0,38180012,5},{0,18041005,3},{0,12010011,1},{0,54010001,30}]'),(7,33,7,'累充5888钻石','累充5888钻石','[{gold,5888}]',1,'[{0,38220009,35},{10,36010002,588},{0,18041005,3},{0,54050001,1},{0,54020003,1},{0,54020002,1}]'),(7,33,8,'累充8888钻石','累充8888钻石','[{gold,8888}]',1,'[{0,38220009,40},{10,36010002,688},{0,20020003,2},{0,20020001,4},{0,36040010,1},{0,54020003,1}]'),(7,33,9,'累充12888钻石','累充12888钻石','[{gold,12888}]',1,'[{0,38220009,50},{10,36010002,888},{0,24020003,2},{0,24020001,4},{0,32020113,10},{0,11070003,10}]'),(7,33,10,'累充16888钻石','累充16888钻石','[{gold,16888}]',1,'[{0,38220009,60},{10,36010002,1088},{0,53030030,1},{0,53030010,4},{0,32020114,10},{0,11070003,30}]'),(7,34,1,'累充188钻石','累充188钻石','[{gold,188}]',1,'[{0,38220009,5},{0,38160001,1},{0,12030011,1},{0,24020002,1},{0,18041005,1}]'),(7,34,2,'累充288钻石','累充288钻石','[{gold,288}]',1,'[{0,38220009,10},{0,16010003,1},{0,16010001,1},{0,16010002,1},{0,18041005,2}]'),(7,34,3,'累充588钻石','累充588钻石','[{gold,588}]',1,'[{0,38220009,15},{0,17020003,1},{0,17020001,1},{0,17020002,1},{0,18041005,3},{0,18020001,10}]'),(7,34,4,'累充888钻石','累充888钻石','[{gold,888}]',1,'[{0,38220009,20},{10,36010002,88},{0,12020011,1},{255,36160008,100},{0,36040009,1},{0,18020001,15}]'),(7,34,5,'累充1688钻石','累充1688钻石','[{gold,1688}]',1,'[{0,38220009,25},{10,36010002,188},{255,36160008,200},{0,38180002,10},{0,36040010,1},{0,18020001,20}]'),(7,34,6,'累充2888钻石','累充2888钻石','[{gold,2888}]',1,'[{0,38220009,30},{10,36010002,288},{0,38180012,5},{0,18041005,3},{0,12010011,1},{0,54010001,30}]'),(7,34,7,'累充5888钻石','累充5888钻石','[{gold,5888}]',1,'[{0,38220009,35},{10,36010002,588},{0,18041002,3},{0,54050001,1},{0,54020003,1},{0,54020002,1}]'),(7,34,8,'累充8888钻石','累充8888钻石','[{gold,8888}]',1,'[{0,38220009,40},{10,36010002,688},{0,20020003,2},{0,20020001,4},{0,36040010,1},{0,54020003,1}]'),(7,34,9,'累充12888钻石','累充12888钻石','[{gold,12888}]',1,'[{0,38220009,50},{10,36010002,888},{0,24020003,2},{0,24020001,4},{0,32020113,10},{0,11070003,10}]'),(7,34,10,'累充16888钻石','累充16888钻石','[{gold,16888}]',1,'[{0,38220009,60},{10,36010002,1088},{0,53030030,1},{0,53030010,4},{0,32020114,10},{0,11070003,30}]'),(11,1,1,'好评礼包','好评礼包','[]',1,'[{100,16020001,2},{100,37020001,1},{100,36030001,20000}]'),(14,1,1,'充值有礼','充值有礼','[]',1,'[{100,38140007,1},{100,38150007,1},{100,20020001,1},{100,37020002,1}]'),(14,2,1,'绿茵场充值礼','绿茵场充值礼','[]',1,'[{100,20020001,1},{100,37020002,1}]'),(14,3,1,'八月充值礼','八月充值礼','[]',1,'[{100,34010008,1},{100,37020002,2},{100,20020001,1}]'),(14,4,1,'充值有礼D1','充值有礼D1','[]',1,'[{0,38220009,5},{0,38030002,1},{0,12010002,1},{0,32020112,3},{0,38040010,2},{2,36020001,60}]'),(14,5,1,'充值有礼D2','充值有礼D2','[]',1,'[{0,38220009,5},{0,38030002,1},{0,38180015,88},{0,32020112,3},{0,38040010,2},{2,36020001,60}]'),(14,6,1,'充值有礼D3','充值有礼D3','[]',1,'[{0,38220009,5},{0,38030002,1},{0,38180015,88},{0,32020112,3},{0,38040010,2},{2,36020001,60}]'),(14,7,1,'充值有礼D4','充值有礼D4','[]',1,'[{0,38220009,5},{0,38030002,1},{0,38180015,88},{0,32020112,3},{0,38040010,2},{2,36020001,60}]'),(15,2,1,'周五礼','周五的奖励','[{sign_day, 1}]',1,'[{0,38070002,1},{0,38040001,2},{0,38040010,4}]'),(15,2,2,'周六礼','周六的奖励','[{sign_day, 2}]',1,'[{0,38030003,2},{0,38040001,2},{0,37020001,2}]'),(15,2,3,'周日礼','周日的奖励','[{sign_day, 3}]',1,'[{0,37020002,2},{0,38040001,2},{0,38040101,2}]'),(15,2,101,'连续登陆2天','连续登陆2天','[{sign_count, 2}]',1,'[{0,38180001,1}]'),(15,2,102,'连续登陆3天','连续登陆3天','[{sign_count, 3}]',1,'[{2,36020001,80}]'),(15,3,1,'第一天','第一天的奖励','[{sign_day, 1}]',1,'[{100,16020001,5},{100,38100001,5},{100,37020001,2},{100,32010042,1}]'),(15,3,2,'第二天','第二天的奖励','[{sign_day, 2}]',1,'[{100,18020001,10},{100,38100001,5},{100,37020001,2},{100,32010042,1}]'),(15,3,3,'第三天','第三天的奖励','[{sign_day, 3}]',1,'[{100,16020001,5},{100,38100001,5},{100,37020001,2},{100,32010042,1}]'),(15,3,101,'连续登陆3天','连续登陆3天','[{sign_count, 3}]',1,'[{100,18010001,1},{100,16010001,1}]'),(15,4,1,'第一天','第一天的奖励','[{sign_day, 1}]',1,'[{100,14010002,2},{100,38040040,2},{100,37020001,2},{100,32010042,1}]'),(15,4,2,'第二天','第二天的奖励','[{sign_day, 2}]',1,'[{100,14020002,2},{100,38040040,2},{100,37020001,2},{100,32010042,1}]'),(15,4,3,'第三天','第三天的奖励','[{sign_day, 3}]',1,'[{100,14010002,2},{100,38040040,2},{100,37020001,2},{100,32010042,1}]'),(15,4,101,'连续登陆3天','连续登陆3天','[{sign_count, 3}]',1,'[{100,14010002,2},{100,38040040,2},{100,37020001,2},{100,32010042,1}]'),(15,101,1,'第1天','第一天的奖励','[{sign_day, 1}]',1,'[{100,18020002,1},{100,38100001,9},{100,37020001,2},{100,32010042,1}]'),(15,101,2,'第2天','第二天的奖励','[{sign_day, 2}]',1,'[{100,16020002,1},{100,38100001,9},{100,37020001,2},{100,32010042,1}]'),(15,101,3,'第3天','第三天的奖励','[{sign_day, 3}]',1,'[{100,20010002,1},{100,38100001,9},{100,37020001,2},{100,32010042,1}]'),(15,101,4,'第4天','第四天的奖励','[{sign_day, 4}]',1,'[{100,22010002,1},{100,38100001,9},{100,37020001,2},{100,32010042,1}]'),(15,101,5,'第5天','第五天的奖励','[{sign_day, 5}]',1,'[{100,24010002,1},{100,38100001,9},{100,37020001,2},{100,32010042,1}]'),(15,101,101,'连续登陆3天','连续登陆3天','[{sign_count, 3}]',1,'[{100,18010001,1},{100,18010002,1}]'),(15,101,102,'连续登陆5天','连续登陆5天','[{sign_count, 5}]',1,'[{100,18010002,1},{100,16010002,1}]'),(17,1,1,'7阶红2武器','7阶红2武器','[{cost, [{1, 36010001,500}]}, {discount,90}, {limit,5},{self_limit,2}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,1,2,'7阶红2衣服','7阶红2衣服','[{cost, [{1, 36010001,500}]}, {discount,90}, {limit,5},{self_limit,2}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,1,3,'7阶红2项链','7阶红2项链','[{cost, [{1, 36010001,722}]}, {discount,90}, {limit,10},{self_limit,3}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,1,4,'7阶红2护符','7阶红2护符','[{cost, [{1, 36010001,722}]}, {discount,90}, {limit,10},{self_limit,3}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,1,5,'8阶红2武器','8阶红2武器','[{cost, [{1, 36010001,556}]}, {discount,90}, {limit,5},{self_limit,2}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,1,6,'8阶红2衣服','8阶红2衣服','[{cost, [{1, 36010001,556}]}, {discount,90}, {limit,5},{self_limit,2}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,1,7,'8阶红2项链','8阶红2项链','[{cost, [{1, 36010001,778}]}, {discount,90}, {limit,10},{self_limit,3}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,1,8,'8阶红2护符','8阶红2护符','[{cost, [{1, 36010001,778}]}, {discount,90}, {limit,10},{self_limit,3}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,1,9,'9阶红2武器','9阶红2武器','[{cost, [{1, 36010001,611}]}, {discount,90}, {limit,5},{self_limit,2}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,1,10,'9阶红2衣服','9阶红2衣服','[{cost, [{1, 36010001,611}]}, {discount,90}, {limit,5},{self_limit,2}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,1,11,'9阶红2项链','9阶红2项链','[{cost, [{1, 36010001,833}]}, {discount,90}, {limit,10},{self_limit,3}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,1,12,'9阶红2护符','9阶红2护符','[{cost, [{1, 36010001,833}]}, {discount,90}, {limit,10},{self_limit,3}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,1,13,'10阶红2武器','10阶红2武器','[{cost, [{1, 36010001,667}]}, {discount,90}, {limit,5},{self_limit,2}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,1,14,'10阶红2衣服','10阶红2衣服','[{cost, [{1, 36010001,667}]}, {discount,90}, {limit,5},{self_limit,2}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,1,15,'10阶红2项链','10阶红2项链','[{cost, [{1, 36010001,889}]}, {discount,90}, {limit,10},{self_limit,3}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,1,16,'10阶红2护符','10阶红2护符','[{cost, [{1, 36010001,889}]}, {discount,90}, {limit,10},{self_limit,3}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,1,17,'11阶红2武器','11阶红2武器','[{cost, [{1, 36010001,722}]}, {discount,90}, {limit,5},{self_limit,2}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,1,18,'11阶红2衣服','11阶红2衣服','[{cost, [{1, 36010001,722}]}, {discount,90}, {limit,5},{self_limit,2}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,1,19,'11阶红2项链','11阶红2项链','[{cost, [{1, 36010001,944}]}, {discount,90}, {limit,10},{self_limit,3}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,1,20,'11阶红2护符','11阶红2护符','[{cost, [{1, 36010001,944}]}, {discount,90}, {limit,10},{self_limit,3}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,1,21,'12阶红2武器','12阶红2武器','[{cost, [{1, 36010001,778}]}, {discount,90}, {limit,5},{self_limit,2}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,1,22,'12阶红2衣服','12阶红2衣服','[{cost, [{1, 36010001,778}]}, {discount,90}, {limit,5},{self_limit,2}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,1,23,'12阶红2项链','12阶红2项链','[{cost, [{1, 36010001,1000}]}, {discount,90}, {limit,10},{self_limit,3}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,1,24,'12阶红2护符','12阶红2护符','[{cost, [{1, 36010001,1000}]}, {discount,90}, {limit,10},{self_limit,3}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,1,25,'变性秘卷','武器','[{cost, [{1, 36010001,1680}]}, {discount,60}, {limit,2},{self_limit,1}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,1,26,'个人改名卡','时装','[{cost, [{1, 36010001,680}]}, {discount,60}, {limit,2},{self_limit,1}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,2,1,'7阶红2裤子','7阶红2裤子','[{cost, [{1, 36010001,500}]}, {discount,90}, {limit,5},{self_limit,2}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,2,2,'7阶红2头盔','7阶红2头盔','[{cost, [{1, 36010001,500}]}, {discount,90}, {limit,5},{self_limit,2}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,2,3,'7阶红2鞋子','7阶红2鞋子','[{cost, [{1, 36010001,500}]}, {discount,90}, {limit,5},{self_limit,2}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,2,4,'7阶红2手腕','7阶红2手腕','[{cost, [{1, 36010001,500}]}, {discount,90}, {limit,5},{self_limit,2}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,2,5,'8阶红2裤子','8阶红2裤子','[{cost, [{1, 36010001,556}]}, {discount,90}, {limit,5},{self_limit,2}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,2,6,'8阶红2头盔','8阶红2头盔','[{cost, [{1, 36010001,556}]}, {discount,90}, {limit,5},{self_limit,2}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,2,7,'8阶红2鞋子','8阶红2鞋子','[{cost, [{1, 36010001,556}]}, {discount,90}, {limit,5},{self_limit,2}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,2,8,'8阶红2手腕','8阶红2手腕','[{cost, [{1, 36010001,556}]}, {discount,90}, {limit,5},{self_limit,2}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,2,9,'9阶红2裤子','9阶红2裤子','[{cost, [{1, 36010001,611}]}, {discount,90}, {limit,5},{self_limit,2}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,2,10,'9阶红2头盔','9阶红2头盔','[{cost, [{1, 36010001,611}]}, {discount,90}, {limit,5},{self_limit,2}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,2,11,'9阶红2鞋子','9阶红2鞋子','[{cost, [{1, 36010001,611}]}, {discount,90}, {limit,5},{self_limit,2}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,2,12,'9阶红2手腕','9阶红2手腕','[{cost, [{1, 36010001,611}]}, {discount,90}, {limit,5},{self_limit,2}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,2,13,'10阶红2裤子','10阶红2裤子','[{cost, [{1, 36010001,667}]}, {discount,90}, {limit,5},{self_limit,2}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,2,14,'10阶红2头盔','10阶红2头盔','[{cost, [{1, 36010001,667}]}, {discount,90}, {limit,5},{self_limit,2}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,2,15,'10阶红2鞋子','10阶红2鞋子','[{cost, [{1, 36010001,667}]}, {discount,90}, {limit,5},{self_limit,2}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,2,16,'10阶红2手腕','10阶红2手腕','[{cost, [{1, 36010001,667}]}, {discount,90}, {limit,5},{self_limit,2}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,2,17,'11阶红2裤子','11阶红2裤子','[{cost, [{1, 36010001,722}]}, {discount,90}, {limit,5},{self_limit,2}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,2,18,'11阶红2头盔','11阶红2头盔','[{cost, [{1, 36010001,722}]}, {discount,90}, {limit,5},{self_limit,2}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,2,19,'11阶红2鞋子','11阶红2鞋子','[{cost, [{1, 36010001,722}]}, {discount,90}, {limit,5},{self_limit,2}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,2,20,'11阶红2手腕','11阶红2手腕','[{cost, [{1, 36010001,722}]}, {discount,90}, {limit,5},{self_limit,2}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,2,21,'12阶红2裤子','12阶红2裤子','[{cost, [{1, 36010001,778}]}, {discount,90}, {limit,5},{self_limit,2}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,2,22,'12阶红2头盔','12阶红2头盔','[{cost, [{1, 36010001,778}]}, {discount,90}, {limit,5},{self_limit,2}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,2,23,'12阶红2鞋子','12阶红2鞋子','[{cost, [{1, 36010001,778}]}, {discount,90}, {limit,5},{self_limit,2}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,2,24,'12阶红2手腕','12阶红2手腕','[{cost, [{1, 36010001,778}]}, {discount,90}, {limit,5},{self_limit,2}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,2,25,'变性秘卷','变性秘卷','[{cost, [{1, 36010001,1680}]}, {discount,60}, {limit,2},{self_limit,1}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,2,26,'个人改名卡','个人改名卡','[{cost, [{1, 36010001,680}]}, {discount,60}, {limit,2},{self_limit,1}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,3,1,'7阶红2武器','7阶红2武器','[{cost, [{1, 36010001,500}]}, {discount,90}, {limit,5},{self_limit,2}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,3,2,'7阶红2衣服','7阶红2衣服','[{cost, [{1, 36010001,500}]}, {discount,90}, {limit,5},{self_limit,2}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,3,3,'7阶红2项链','7阶红2项链','[{cost, [{1, 36010001,722}]}, {discount,90}, {limit,10},{self_limit,3}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,3,4,'7阶红2护符','7阶红2护符','[{cost, [{1, 36010001,722}]}, {discount,90}, {limit,10},{self_limit,3}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,3,5,'8阶红2武器','8阶红2武器','[{cost, [{1, 36010001,556}]}, {discount,90}, {limit,5},{self_limit,2}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,3,6,'8阶红2衣服','8阶红2衣服','[{cost, [{1, 36010001,556}]}, {discount,90}, {limit,5},{self_limit,2}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,3,7,'8阶红2项链','8阶红2项链','[{cost, [{1, 36010001,778}]}, {discount,90}, {limit,10},{self_limit,3}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,3,8,'8阶红2护符','8阶红2护符','[{cost, [{1, 36010001,778}]}, {discount,90}, {limit,10},{self_limit,3}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,3,9,'9阶红2武器','9阶红2武器','[{cost, [{1, 36010001,611}]}, {discount,90}, {limit,5},{self_limit,2}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,3,10,'9阶红2衣服','9阶红2衣服','[{cost, [{1, 36010001,611}]}, {discount,90}, {limit,5},{self_limit,2}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,3,11,'9阶红2项链','9阶红2项链','[{cost, [{1, 36010001,833}]}, {discount,90}, {limit,10},{self_limit,3}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,3,12,'9阶红2护符','9阶红2护符','[{cost, [{1, 36010001,833}]}, {discount,90}, {limit,10},{self_limit,3}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,3,13,'10阶红2武器','10阶红2武器','[{cost, [{1, 36010001,667}]}, {discount,90}, {limit,5},{self_limit,2}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,3,14,'10阶红2衣服','10阶红2衣服','[{cost, [{1, 36010001,667}]}, {discount,90}, {limit,5},{self_limit,2}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,3,15,'10阶红2项链','10阶红2项链','[{cost, [{1, 36010001,889}]}, {discount,90}, {limit,10},{self_limit,3}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,3,16,'10阶红2护符','10阶红2护符','[{cost, [{1, 36010001,889}]}, {discount,90}, {limit,10},{self_limit,3}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,3,17,'11阶红2武器','11阶红2武器','[{cost, [{1, 36010001,722}]}, {discount,90}, {limit,5},{self_limit,2}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,3,18,'11阶红2衣服','11阶红2衣服','[{cost, [{1, 36010001,722}]}, {discount,90}, {limit,5},{self_limit,2}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,3,19,'11阶红2项链','11阶红2项链','[{cost, [{1, 36010001,944}]}, {discount,90}, {limit,10},{self_limit,3}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,3,20,'11阶红2护符','11阶红2护符','[{cost, [{1, 36010001,944}]}, {discount,90}, {limit,10},{self_limit,3}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,3,21,'12阶红2武器','12阶红2武器','[{cost, [{1, 36010001,778}]}, {discount,90}, {limit,5},{self_limit,2}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,3,22,'12阶红2衣服','12阶红2衣服','[{cost, [{1, 36010001,778}]}, {discount,90}, {limit,5},{self_limit,2}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,3,23,'12阶红2项链','12阶红2项链','[{cost, [{1, 36010001,1000}]}, {discount,90}, {limit,10},{self_limit,3}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,3,24,'12阶红2护符','12阶红2护符','[{cost, [{1, 36010001,1000}]}, {discount,90}, {limit,10},{self_limit,3}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,3,25,'变性秘卷','变性秘卷','[{cost, [{1, 36010001,1680}]}, {discount,60}, {limit,2},{self_limit,1}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,3,26,'个人改名卡','个人改名卡','[{cost, [{1, 36010001,680}]}, {discount,60}, {limit,2},{self_limit,1}]',8,'[{[75,1000],[{1,[{100,1101010742,1}]},{2,[{100,1101020742,1}]},{3,[{100,1101030742,1}]},{4,[{100,1101040742,1}]}]}]'),(17,4,1,'商品1','商品1','[{cost, [{1, 36010001,450}]}, {discount,80}, {limit,99},{self_limit,20}]',1,'[{100,45020005,1}]'),(17,4,2,'商品2','商品2','[{cost, [{1, 36010001,450}]}, {discount,80}, {limit,99},{self_limit,20}]',1,'[{100,45020006,1}]'),(17,4,3,'商品3','商品3','[{cost, [{1, 36010001,900}]}, {discount,80}, {limit,99},{self_limit,20}]',1,'[{100,45020009,1}]'),(17,4,4,'商品4','商品4','[{cost, [{1, 36010001,900}]}, {discount,80}, {limit,99},{self_limit,20}]',1,'[{100,45020010,1}]'),(17,4,5,'商品5','商品5','[{cost, [{1, 36010001,1500}]}, {discount,80}, {limit,99},{self_limit,20}]',1,'[{100,45040007,1}]'),(17,4,6,'商品6','商品6','[{cost, [{1, 36010001,900}]}, {discount,80}, {limit,99},{self_limit,20}]',1,'[{100,45040003,1}]'),(17,5,1,'商品1','商品1','[{cost, [{1, 36010001,900}]}, {discount,80}, {limit,99},{self_limit,20}]',1,'[{100,45020007,1}]'),(17,5,2,'商品2','商品2','[{cost, [{1, 36010001,900}]}, {discount,80}, {limit,99},{self_limit,20}]',1,'[{100,45030012,1}]'),(17,5,3,'商品3','商品3','[{cost, [{1, 36010001,900}]}, {discount,80}, {limit,99},{self_limit,20}]',1,'[{100,45040004,1}]'),(17,5,4,'商品4','商品4','[{cost, [{1, 36010001,900}]}, {discount,80}, {limit,99},{self_limit,20}]',1,'[{100,45040005,1}]'),(17,5,5,'商品5','商品5','[{cost, [{1, 36010001,900}]}, {discount,80}, {limit,99},{self_limit,20}]',1,'[{100,45010006,1}]'),(17,5,6,'商品6','商品6','[{cost, [{1, 36010001,1500}]}, {discount,80}, {limit,99},{self_limit,20}]',1,'[{100,45030013,1}]'),(17,6,1,'商品1','商品1','[{cost, [{1, 36010001,1500}]}, {discount,80}, {limit,99},{self_limit,20}]',1,'[{100,45040006,1}]'),(17,6,2,'商品2','商品2','[{cost, [{1, 36010001,450}]}, {discount,80}, {limit,99},{self_limit,20}]',1,'[{100,45030010,1}]'),(17,6,3,'商品3','商品3','[{cost, [{1, 36010001,1500}]}, {discount,80}, {limit,99},{self_limit,20}]',1,'[{100,45010007,1}]'),(17,6,4,'商品4','商品4','[{cost, [{1, 36010001,1500}]}, {discount,80}, {limit,99},{self_limit,20}]',1,'[{100,45010008,1}]'),(17,6,5,'商品5','商品5','[{cost, [{1, 36010001,450}]}, {discount,80}, {limit,99},{self_limit,20}]',1,'[{100,45030003,1}]'),(17,6,6,'商品6','商品6','[{cost, [{1, 36010001,900}]}, {discount,80}, {limit,99},{self_limit,20}]',1,'[{100,45030004,1}]'),(17,11,1,'橙色飞艇护送券','橙色飞艇护送券','[{cost,[{2,36020001,60}]},{discount,75},{limit,999},{self_limit,1}]',1,'[{100,38330004,1}]'),(17,11,2,'直升1级书[220]*1','直升1级书[220]*1','[{cost,[{2,36020001,250}]},{discount,80},{limit,999},{self_limit,1}]',1,'[{100,37010001,1}]'),(17,11,3,'3阶经验书*5','3阶经验书*5','[{cost,[{1,36010001,24}]},{discount,50},{limit,999},{self_limit,1}]',1,'[{0,37010103,5}]'),(17,11,4,'4阶经验书*5','4阶经验书*5','[{cost,[{1,36010001,100}]},{discount,50},{limit,999},{self_limit,1}]',1,'[{0,37010201,5}]'),(17,11,5,'4阶经验书*5','4阶经验书*5','[{cost,[{1,36010001,100}]},{discount,60},{limit,999},{self_limit,1}]',1,'[{0,37010201,5}]'),(17,11,6,'5阶经验书*5','5阶经验书*5','[{cost,[{1,36010001,250}]},{discount,70},{limit,999},{self_limit,1}]',1,'[{0,37010202,5}]'),(17,11,7,'5阶经验书*5','5阶经验书*5','[{cost,[{1,36010001,250}]},{discount,80},{limit,999},{self_limit,1}]',1,'[{0,37010202,5}]'),(17,11,8,'直升1级丹（220级）','直升1级丹（220级）','[{cost,[{1,36010001,250}]},{discount,84},{limit,999},{self_limit,1}]',1,'[{0,37010001,1}]'),(17,12,1,'橙色飞艇护送券','橙色飞艇护送券','[{cost,[{2,36020001,60}]},{discount,75},{limit,999},{self_limit,1}]',1,'[{100,38330004,1}]'),(17,12,2,'直升1级书[280]*1','直升1级书[280]*1','[{cost,[{2,36020001,250}]},{discount,80},{limit,999},{self_limit,1}]',1,'[{100,37010002,1}]'),(17,12,3,'3阶经验书','3阶经验书','[{cost,[{1,36010001,24}]},{discount,50},{limit,999},{self_limit,1}]',1,'[{0,37010103,5}]'),(17,12,4,'4阶经验书','4阶经验书','[{cost,[{1,36010001,100}]},{discount,60},{limit,999},{self_limit,1}]',1,'[{0,37010201,5}]'),(17,12,5,'5阶经验书','5阶经验书','[{cost,[{1,36010001,250}]},{discount,70},{limit,999},{self_limit,1}]',1,'[{0,37010202,5}]'),(17,12,6,'直升1级丹（280级）','直升1级丹（280级）','[{cost,[{1,36010001,250}]},{discount,72},{limit,999},{self_limit,1}]',1,'[{0,37010002,1}]'),(17,12,7,'经验副本次数券','经验副本次数券','[{cost,[{1,36010001,300}]},{discount,83},{limit,999},{self_limit,1}]',1,'[{0,38340001,1}]'),(17,12,8,'直升1级丹（280级）','直升1级丹（280级）','[{cost,[{1,36010001,250}]},{discount,84},{limit,999},{self_limit,1}]',1,'[{0,37010002,1}]'),(17,13,1,'初级坐骑树果*20','初级坐骑树果*20','[{cost,[{2,36020001,400}]},{discount,60},{limit,999},{self_limit,1}]',1,'[{100,16020001,20}]'),(17,13,2,'初级坐骑树果*20','初级坐骑树果*20','[{cost,[{2,36020001,400}]},{discount,70},{limit,999},{self_limit,2}]',1,'[{100,16020001,20}]'),(17,13,3,'初级坐骑树果*20','初级坐骑树果*20','[{cost,[{2,36020001,400}]},{discount,80},{limit,999},{self_limit,5}]',1,'[{100,16020001,20}]'),(17,13,4,'初级坐骑树果','初级坐骑树果','[{cost,[{1,36010001,100}]},{discount,20},{limit,999},{self_limit,2}]',1,'[{0,16020001,5}]'),(17,13,5,'初级坐骑树果','初级坐骑树果','[{cost,[{1,36010001,400}]},{discount,30},{limit,999},{self_limit,5}]',1,'[{0,16020001,20}]'),(17,13,6,'初级坐骑树果','初级坐骑树果','[{cost,[{1,36010001,600}]},{discount,50},{limit,999},{self_limit,10}]',1,'[{0,16020001,30}]'),(17,13,7,'坐骑培养道具1','坐骑培养道具1','[{cost,[{1,36010001,200}]},{discount,30},{limit,999},{self_limit,2}]',1,'[{0,16010001,1}]'),(17,13,8,'初级坐骑树果','初级坐骑树果','[{cost,[{1,36010001,1500}]},{discount,50},{limit,999},{self_limit,5}]',1,'[{0,16020001,75}]'),(17,13,9,'初级坐骑树果','初级坐骑树果','[{cost,[{1,36010001,3000}]},{discount,60},{limit,999},{self_limit,10}]',1,'[{0,16020001,150}]'),(17,14,1,'初级神源之火*10','初级神源之火*10','[{cost,[{2,36020001,100}]},{discount,80},{limit,999},{self_limit,2}]',1,'[{100,11020001,10}]'),(17,14,2,'初级神源之火*30','初级神源之火*30','[{cost,[{2,36020001,300}]},{discount,80},{limit,999},{self_limit,5}]',1,'[{100,11020001,30}]'),(17,14,3,'初级神源之火','初级神源之火','[{cost,[{1,36010001,50}]},{discount,20},{limit,999},{self_limit,2}]',1,'[{0,11020001,5}]'),(17,14,4,'初级神源之火','初级神源之火','[{cost,[{1,36010001,200}]},{discount,30},{limit,999},{self_limit,5}]',1,'[{0,11020001,20}]'),(17,14,5,'初级神源之火','初级神源之火','[{cost,[{1,36010001,300}]},{discount,50},{limit,999},{self_limit,10}]',1,'[{0,11020001,30}]'),(17,14,6,'羽翼培养道具1','羽翼培养道具1','[{cost,[{1,36010001,200}]},{discount,30},{limit,999},{self_limit,2}]',1,'[{0,20020001,1}]'),(17,14,7,'初级神源之火','初级神源之火','[{cost,[{1,36010001,750}]},{discount,50},{limit,999},{self_limit,5}]',1,'[{0,11020001,75}]'),(17,14,8,'初级神源之火','初级神源之火','[{cost,[{1,36010001,1500}]},{discount,60},{limit,999},{self_limit,10}]',1,'[{0,11020001,150}]'),(17,15,1,'魂珠寻宝券*5','魂珠寻宝券*5','[{cost,[{2,36020001,250}]},{discount,80},{limit,999},{self_limit,1}]',1,'[{100,38180010,5}]'),(17,15,2,'紫色供养魂珠*10','紫色供养魂珠*10','[{cost,[{2,36020001,400}]},{discount,80},{limit,999},{self_limit,5}]',1,'[{100,5203003,10}]'),(17,15,3,'橙色供养魂珠*2','橙色供养魂珠*2','[{cost,[{1,36010001,200}]},{discount,25},{limit,999},{self_limit,2}]',1,'[{0,5203004,2}]'),(17,15,4,'橙色供养魂珠*5','橙色供养魂珠*5','[{cost,[{1,36010001,500}]},{discount,30},{limit,999},{self_limit,5}]',1,'[{0,5203004,5}]'),(17,15,5,'橙色供养魂珠*10','橙色供养魂珠*10','[{cost,[{1,36010001,1000}]},{discount,50},{limit,999},{self_limit,10}]',1,'[{0,5203004,10}]'),(17,15,6,'魂珠寻宝券*2','魂珠寻宝券*2','[{cost,[{1,36010001,100}]},{discount,90},{limit,999},{self_limit,2}]',1,'[{0,38180010,2}]'),(17,15,7,'魂珠寻宝券*5','魂珠寻宝券*5','[{cost,[{1,36010001,250}]},{discount,50},{limit,999},{self_limit,5}]',1,'[{0,38180010,5}]'),(17,15,8,'魂珠寻宝券*10','魂珠寻宝券*10','[{cost,[{1,36010001,500}]},{discount,60},{limit,999},{self_limit,10}]',1,'[{0,38180010,10}]'),(17,16,1,'宝石碎片*90','宝石碎片*90','[{cost,[{2,36020001,300}]},{discount,80},{limit,999},{self_limit,1}]',1,'[{100,14120001,90}]'),(17,16,2,'普通防具套装石箱*5','普通防具套装石箱*5','[{cost,[{1,36010001,50}]},{discount,40},{limit,999},{self_limit,5}]',1,'[{0,32020112,5}]'),(17,16,3,'普通防具套装石箱*10','普通防具套装石箱*10','[{cost,[{1,36010001,100}]},{discount,40},{limit,999},{self_limit,10}]',1,'[{0,32020112,10}]'),(17,16,4,'普通防具套装石箱*25','普通防具套装石箱*25','[{cost,[{1,36010001,250}]},{discount,50},{limit,999},{self_limit,20}]',1,'[{0,32020112,25}]'),(17,16,5,'普通武器套装石箱*2','普通武器套装石箱*2','[{cost,[{1,36010001,40}]},{discount,50},{limit,999},{self_limit,2}]',1,'[{0,32020113,2}]'),(17,16,6,'普通武器套装石箱*5','普通武器套装石箱*5','[{cost,[{1,36010001,100}]},{discount,60},{limit,999},{self_limit,5}]',1,'[{0,32020113,5}]'),(17,16,7,'普通首饰套装石箱*5','普通首饰套装石箱*5','[{cost,[{1,36010001,500}]},{discount,60},{limit,999},{self_limit,5}]',1,'[{0,32020114,5}]'),(17,17,1,'初级专武髓液*20','初级专武髓液*20','[{cost,[{2,36020001,300}]},{discount,80},{limit,999},{self_limit,1}]',1,'[{100,53020010,20}]'),(17,17,2,'高级光武纹章','高级光武纹章','[{cost,[{1,36010001,150}]},{discount,20},{limit,999},{self_limit,2}]',1,'[{0,53020030,1}]'),(17,17,3,'高级光武纹章','高级光武纹章','[{cost,[{1,36010001,300}]},{discount,30},{limit,999},{self_limit,5}]',1,'[{0,53020030,2}]'),(17,17,4,'高级光武纹章','高级光武纹章','[{cost,[{1,36010001,750}]},{discount,50},{limit,999},{self_limit,10}]',1,'[{0,53020030,5}]'),(17,17,5,'光武培养道具1','光武培养道具1','[{cost,[{1,36010001,500}]},{discount,30},{limit,999},{self_limit,2}]',1,'[{0,53030010,1}]'),(17,17,6,'光武培养道具2','光武培养道具2','[{cost,[{1,36010001,500}]},{discount,50},{limit,999},{self_limit,3}]',1,'[{0,53030020,1}]'),(17,17,7,'光武培养道具3','光武培养道具3','[{cost,[{1,36010001,3000}]},{discount,60},{limit,999},{self_limit,5}]',1,'[{0,53030030,1}]'),(17,21,1,'初级神源之火','初级神源之火','[{cost,[{2,36020001,500}]},{discount,80},{limit,999},{self_limit,1}]',1,'[{100,11020001,50}]'),(17,21,2,'初级神源之火','初级神源之火','[{cost,[{1,36010001,200}]},{discount,20},{limit,999},{self_limit,1}]',1,'[{101,11020001,20,[{expire_time,86400}]}]'),(17,21,3,'初级神源之火','初级神源之火','[{cost,[{1,36010001,300}]},{discount,30},{limit,999},{self_limit,1}]',1,'[{101,11020001,30,[{expire_time,86400}]}]'),(17,21,4,'初级神源之火','初级神源之火','[{cost,[{1,36010001,600}]},{discount,50},{limit,999},{self_limit,1}]',1,'[{100,11020001,60}]'),(17,21,5,'初级神源之火','初级神源之火','[{cost,[{1,36010001,1200}]},{discount,70},{limit,999},{self_limit,3}]',1,'[{100,11020001,120}]'),(17,22,1,'初级星辰之砂','初级星辰之砂','[{cost,[{2,36020001,500}]},{discount,80},{limit,999},{self_limit,1}]',1,'[{100,18020001,50}]'),(17,22,2,'初级星辰之砂','初级星辰之砂','[{cost,[{1,36010001,200}]},{discount,20},{limit,999},{self_limit,1}]',1,'[{101,18020001,20,[{expire_time,86400}]}]'),(17,22,3,'初级星辰之砂','初级星辰之砂','[{cost,[{1,36010001,300}]},{discount,30},{limit,999},{self_limit,1}]',1,'[{101,18020001,30,[{expire_time,86400}]}]'),(17,22,4,'初级星辰之砂','初级星辰之砂','[{cost,[{1,36010001,600}]},{discount,50},{limit,999},{self_limit,1}]',1,'[{100,18020001,60}]'),(17,22,5,'初级星辰之砂','初级星辰之砂','[{cost,[{1,36010001,1200}]},{discount,70},{limit,999},{self_limit,3}]',1,'[{100,18020001,120}]'),(17,23,1,'初级星辰之砂','初级星辰之砂','[{cost,[{2,36020001,500}]},{discount,80},{limit,999},{self_limit,1}]',1,'[{100,18020001,50}]'),(17,23,2,'初级星辰之砂','初级星辰之砂','[{cost,[{1,36010001,200}]},{discount,20},{limit,999},{self_limit,1}]',1,'[{101,18020001,20,[{expire_time,86400}]}]'),(17,23,3,'初级星辰之砂','初级星辰之砂','[{cost,[{1,36010001,300}]},{discount,30},{limit,999},{self_limit,1}]',1,'[{101,18020001,30,[{expire_time,86400}]}]'),(17,23,4,'初级星辰之砂','初级星辰之砂','[{cost,[{1,36010001,600}]},{discount,50},{limit,999},{self_limit,1}]',1,'[{100,18020001,60}]'),(17,23,5,'初级星辰之砂','初级星辰之砂','[{cost,[{1,36010001,1200}]},{discount,70},{limit,999},{self_limit,3}]',1,'[{100,18020001,120}]'),(17,24,1,'初级神源之火','初级神源之火','[{cost,[{2,36020001,500}]},{discount,80},{limit,999},{self_limit,1}]',1,'[{100,11020001,50}]'),(17,24,2,'初级神源之火','初级神源之火','[{cost,[{1,36010001,200}]},{discount,20},{limit,999},{self_limit,1}]',1,'[{101,11020001,20,[{expire_time,86400}]}]'),(17,24,3,'初级神源之火','初级神源之火','[{cost,[{1,36010001,300}]},{discount,30},{limit,999},{self_limit,1}]',1,'[{101,11020001,30,[{expire_time,86400}]}]'),(17,24,4,'初级神源之火','初级神源之火','[{cost,[{1,36010001,600}]},{discount,50},{limit,999},{self_limit,1}]',1,'[{100,11020001,60}]'),(17,24,5,'初级神源之火','初级神源之火','[{cost,[{1,36010001,1200}]},{discount,70},{limit,999},{self_limit,3}]',1,'[{100,11020001,120}]'),(17,25,1,'初级神源之火','初级神源之火','[{cost,[{2,36020001,500}]},{discount,80},{limit,999},{self_limit,1}]',1,'[{100,11020001,50}]'),(17,25,2,'初级神源之火','初级神源之火','[{cost,[{1,36010001,200}]},{discount,20},{limit,999},{self_limit,1}]',1,'[{101,11020001,20,[{expire_time,86400}]}]'),(17,25,3,'初级神源之火','初级神源之火','[{cost,[{1,36010001,300}]},{discount,30},{limit,999},{self_limit,1}]',1,'[{101,11020001,30,[{expire_time,86400}]}]'),(17,25,4,'初级神源之火','初级神源之火','[{cost,[{1,36010001,600}]},{discount,50},{limit,999},{self_limit,1}]',1,'[{100,11020001,60}]'),(17,25,5,'初级神源之火','初级神源之火','[{cost,[{1,36010001,1200}]},{discount,70},{limit,999},{self_limit,3}]',1,'[{100,11020001,120}]'),(17,26,1,'初级星辰之砂','初级星辰之砂','[{cost,[{2,36020001,500}]},{discount,80},{limit,999},{self_limit,1}]',1,'[{100,18020001,50}]'),(17,26,2,'初级星辰之砂','初级星辰之砂','[{cost,[{1,36010001,200}]},{discount,20},{limit,999},{self_limit,1}]',1,'[{101,18020001,20,[{expire_time,86400}]}]'),(17,26,3,'初级星辰之砂','初级星辰之砂','[{cost,[{1,36010001,300}]},{discount,30},{limit,999},{self_limit,1}]',1,'[{101,18020001,30,[{expire_time,86400}]}]'),(17,26,4,'初级星辰之砂','初级星辰之砂','[{cost,[{1,36010001,600}]},{discount,50},{limit,999},{self_limit,1}]',1,'[{100,18020001,60}]'),(17,26,5,'初级星辰之砂','初级星辰之砂','[{cost,[{1,36010001,1200}]},{discount,70},{limit,999},{self_limit,3}]',1,'[{100,18020001,120}]'),(17,27,1,'初级星辰之砂','初级星辰之砂','[{cost,[{2,36020001,500}]},{discount,80},{limit,999},{self_limit,1}]',1,'[{100,18020001,50}]'),(17,27,2,'初级星辰之砂','初级星辰之砂','[{cost,[{1,36010001,200}]},{discount,20},{limit,999},{self_limit,1}]',1,'[{101,18020001,20,[{expire_time,86400}]}]'),(17,27,3,'初级星辰之砂','初级星辰之砂','[{cost,[{1,36010001,300}]},{discount,30},{limit,999},{self_limit,1}]',1,'[{101,18020001,30,[{expire_time,86400}]}]'),(17,27,4,'初级星辰之砂','初级星辰之砂','[{cost,[{1,36010001,600}]},{discount,50},{limit,999},{self_limit,1}]',1,'[{100,18020001,60}]'),(17,27,5,'初级星辰之砂','初级星辰之砂','[{cost,[{1,36010001,1200}]},{discount,70},{limit,999},{self_limit,3}]',1,'[{100,18020001,120}]'),(17,28,1,'初级坐骑树果','初级坐骑树果','[{cost,[{2,36020001,500}]},{discount,80},{limit,999},{self_limit,1}]',1,'[{100,16020001,25}]'),(17,28,2,'初级坐骑树果','初级坐骑树果','[{cost,[{1,36010001,200}]},{discount,20},{limit,999},{self_limit,1}]',1,'[{101,16020001,10,[{expire_time,86400}]}]'),(17,28,3,'初级坐骑树果','初级坐骑树果','[{cost,[{1,36010001,300}]},{discount,30},{limit,999},{self_limit,1}]',1,'[{101,16020001,15,[{expire_time,86400}]}]'),(17,28,4,'初级坐骑树果','初级坐骑树果','[{cost,[{1,36010001,600}]},{discount,50},{limit,999},{self_limit,1}]',1,'[{100,16020001,30}]'),(17,28,5,'初级坐骑树果','初级坐骑树果','[{cost,[{1,36010001,1200}]},{discount,70},{limit,999},{self_limit,3}]',1,'[{100,16020001,60}]'),(17,29,1,'初级坐骑树果','初级坐骑树果','[{cost,[{2,36020001,500}]},{discount,80},{limit,999},{self_limit,1}]',1,'[{100,16020001,25}]'),(17,29,2,'初级坐骑树果','初级坐骑树果','[{cost,[{1,36010001,200}]},{discount,20},{limit,999},{self_limit,1}]',1,'[{101,16020001,10,[{expire_time,86400}]}]'),(17,29,3,'初级坐骑树果','初级坐骑树果','[{cost,[{1,36010001,300}]},{discount,30},{limit,999},{self_limit,1}]',1,'[{101,16020001,15,[{expire_time,86400}]}]'),(17,29,4,'初级坐骑树果','初级坐骑树果','[{cost,[{1,36010001,600}]},{discount,50},{limit,999},{self_limit,1}]',1,'[{100,16020001,30}]'),(17,29,5,'初级坐骑树果','初级坐骑树果','[{cost,[{1,36010001,1200}]},{discount,70},{limit,999},{self_limit,3}]',1,'[{100,16020001,60}]'),(17,30,1,'初级神源之火','初级神源之火','[{cost,[{2,36020001,500}]},{discount,80},{limit,999},{self_limit,1}]',1,'[{100,11020001,50}]'),(17,30,2,'初级神源之火','初级神源之火','[{cost,[{1,36010001,200}]},{discount,20},{limit,999},{self_limit,1}]',1,'[{101,11020001,20,[{expire_time,86400}]}]'),(17,30,3,'初级神源之火','初级神源之火','[{cost,[{1,36010001,300}]},{discount,30},{limit,999},{self_limit,1}]',1,'[{101,11020001,30,[{expire_time,86400}]}]'),(17,30,4,'初级神源之火','初级神源之火','[{cost,[{1,36010001,600}]},{discount,50},{limit,999},{self_limit,1}]',1,'[{100,11020001,60}]'),(17,30,5,'初级神源之火','初级神源之火','[{cost,[{1,36010001,1200}]},{discount,70},{limit,999},{self_limit,3}]',1,'[{100,11020001,120}]'),(17,31,1,'初级神源之火','初级神源之火','[{cost,[{2,36020001,500}]},{discount,80},{limit,999},{self_limit,1}]',1,'[{100,11020001,50}]'),(17,31,2,'初级神源之火','初级神源之火','[{cost,[{1,36010001,200}]},{discount,20},{limit,999},{self_limit,1}]',1,'[{101,11020001,20,[{expire_time,86400}]}]'),(17,31,3,'初级神源之火','初级神源之火','[{cost,[{1,36010001,300}]},{discount,30},{limit,999},{self_limit,1}]',1,'[{101,11020001,30,[{expire_time,86400}]}]'),(17,31,4,'初级神源之火','初级神源之火','[{cost,[{1,36010001,600}]},{discount,50},{limit,999},{self_limit,1}]',1,'[{100,11020001,60}]'),(17,31,5,'初级神源之火','初级神源之火','[{cost,[{1,36010001,1200}]},{discount,70},{limit,999},{self_limit,3}]',1,'[{100,11020001,120}]'),(17,32,1,'初级星辰之砂','初级星辰之砂','[{cost,[{2,36020001,500}]},{discount,80},{limit,999},{self_limit,1}]',1,'[{100,18020001,50}]'),(17,32,2,'初级星辰之砂','初级星辰之砂','[{cost,[{1,36010001,200}]},{discount,20},{limit,999},{self_limit,1}]',1,'[{101,18020001,20,[{expire_time,86400}]}]'),(17,32,3,'初级星辰之砂','初级星辰之砂','[{cost,[{1,36010001,300}]},{discount,30},{limit,999},{self_limit,1}]',1,'[{101,18020001,30,[{expire_time,86400}]}]'),(17,32,4,'初级星辰之砂','初级星辰之砂','[{cost,[{1,36010001,600}]},{discount,50},{limit,999},{self_limit,1}]',1,'[{100,18020001,60}]'),(17,32,5,'初级星辰之砂','初级星辰之砂','[{cost,[{1,36010001,1200}]},{discount,70},{limit,999},{self_limit,3}]',1,'[{100,18020001,120}]'),(17,33,1,'初级星辰之砂','初级星辰之砂','[{cost,[{2,36020001,500}]},{discount,80},{limit,999},{self_limit,1}]',1,'[{100,18020001,50}]'),(17,33,2,'初级星辰之砂','初级星辰之砂','[{cost,[{1,36010001,200}]},{discount,20},{limit,999},{self_limit,1}]',1,'[{101,18020001,20,[{expire_time,86400}]}]'),(17,33,3,'初级星辰之砂','初级星辰之砂','[{cost,[{1,36010001,300}]},{discount,30},{limit,999},{self_limit,1}]',1,'[{101,18020001,30,[{expire_time,86400}]}]'),(17,33,4,'初级星辰之砂','初级星辰之砂','[{cost,[{1,36010001,600}]},{discount,50},{limit,999},{self_limit,1}]',1,'[{100,18020001,60}]'),(17,33,5,'初级星辰之砂','初级星辰之砂','[{cost,[{1,36010001,1200}]},{discount,70},{limit,999},{self_limit,3}]',1,'[{100,18020001,120}]'),(17,34,1,'初级神源之火','初级神源之火','[{cost,[{2,36020001,500}]},{discount,80},{limit,999},{self_limit,1}]',1,'[{100,11020001,50}]'),(17,34,2,'初级神源之火','初级神源之火','[{cost,[{1,36010001,200}]},{discount,20},{limit,999},{self_limit,1}]',1,'[{101,11020001,20,[{expire_time,86400}]}]'),(17,34,3,'初级神源之火','初级神源之火','[{cost,[{1,36010001,300}]},{discount,30},{limit,999},{self_limit,1}]',1,'[{101,11020001,30,[{expire_time,86400}]}]'),(17,34,4,'初级神源之火','初级神源之火','[{cost,[{1,36010001,600}]},{discount,50},{limit,999},{self_limit,1}]',1,'[{100,11020001,60}]'),(17,34,5,'初级神源之火','初级神源之火','[{cost,[{1,36010001,1200}]},{discount,70},{limit,999},{self_limit,3}]',1,'[{100,11020001,120}]'),(17,35,1,'初级神源之火','初级神源之火','[{cost,[{2,36020001,500}]},{discount,80},{limit,999},{self_limit,1}]',1,'[{100,11020001,50}]'),(17,35,2,'初级神源之火','初级神源之火','[{cost,[{1,36010001,200}]},{discount,20},{limit,999},{self_limit,1}]',1,'[{101,11020001,20,[{expire_time,86400}]}]'),(17,35,3,'初级神源之火','初级神源之火','[{cost,[{1,36010001,300}]},{discount,30},{limit,999},{self_limit,1}]',1,'[{101,11020001,30,[{expire_time,86400}]}]'),(17,35,4,'初级神源之火','初级神源之火','[{cost,[{1,36010001,600}]},{discount,50},{limit,999},{self_limit,1}]',1,'[{100,11020001,60}]'),(17,35,5,'初级神源之火','初级神源之火','[{cost,[{1,36010001,1200}]},{discount,70},{limit,999},{self_limit,3}]',1,'[{100,11020001,120}]'),(17,36,1,'初级星辰之砂','初级星辰之砂','[{cost,[{2,36020001,500}]},{discount,80},{limit,999},{self_limit,1}]',1,'[{100,18020001,50}]'),(17,36,2,'初级星辰之砂','初级星辰之砂','[{cost,[{1,36010001,200}]},{discount,20},{limit,999},{self_limit,1}]',1,'[{101,18020001,20,[{expire_time,86400}]}]'),(17,36,3,'初级星辰之砂','初级星辰之砂','[{cost,[{1,36010001,300}]},{discount,30},{limit,999},{self_limit,1}]',1,'[{101,18020001,30,[{expire_time,86400}]}]'),(17,36,4,'初级星辰之砂','初级星辰之砂','[{cost,[{1,36010001,600}]},{discount,50},{limit,999},{self_limit,1}]',1,'[{100,18020001,60}]'),(17,36,5,'初级星辰之砂','初级星辰之砂','[{cost,[{1,36010001,1200}]},{discount,70},{limit,999},{self_limit,3}]',1,'[{100,18020001,120}]'),(17,37,1,'初级星辰之砂','初级星辰之砂','[{cost,[{2,36020001,500}]},{discount,80},{limit,999},{self_limit,1}]',1,'[{100,18020001,50}]'),(17,37,2,'初级星辰之砂','初级星辰之砂','[{cost,[{1,36010001,200}]},{discount,20},{limit,999},{self_limit,1}]',1,'[{101,18020001,20,[{expire_time,86400}]}]'),(17,37,3,'初级星辰之砂','初级星辰之砂','[{cost,[{1,36010001,300}]},{discount,30},{limit,999},{self_limit,1}]',1,'[{101,18020001,30,[{expire_time,86400}]}]'),(17,37,4,'初级星辰之砂','初级星辰之砂','[{cost,[{1,36010001,600}]},{discount,50},{limit,999},{self_limit,1}]',1,'[{100,18020001,60}]'),(17,37,5,'初级星辰之砂','初级星辰之砂','[{cost,[{1,36010001,1200}]},{discount,70},{limit,999},{self_limit,3}]',1,'[{100,18020001,120}]'),(17,38,1,'初级羽翼纹章','初级羽翼纹章','[{cost,[{2,36020001,500}]},{discount,80},{limit,999},{self_limit,1}]',1,'[{100,20060001,50}]'),(17,38,2,'初级羽翼纹章','初级羽翼纹章','[{cost,[{1,36010001,200}]},{discount,20},{limit,999},{self_limit,1}]',1,'[{101,20060001,20,[{expire_time,86400}]}]'),(17,38,3,'初级羽翼纹章','初级羽翼纹章','[{cost,[{1,36010001,300}]},{discount,30},{limit,999},{self_limit,1}]',1,'[{101,20060001,30,[{expire_time,86400}]}]'),(17,38,4,'初级羽翼纹章','初级羽翼纹章','[{cost,[{1,36010001,600}]},{discount,50},{limit,999},{self_limit,1}]',1,'[{100,20060001,60}]'),(17,38,5,'初级羽翼纹章','初级羽翼纹章','[{cost,[{1,36010001,1200}]},{discount,70},{limit,999},{self_limit,3}]',1,'[{100,20060001,120}]'),(17,39,1,'初级羽翼纹章','初级羽翼纹章','[{cost,[{2,36020001,500}]},{discount,80},{limit,999},{self_limit,1}]',1,'[{100,20060001,50}]'),(17,39,2,'初级羽翼纹章','初级羽翼纹章','[{cost,[{1,36010001,200}]},{discount,20},{limit,999},{self_limit,1}]',1,'[{101,20060001,20,[{expire_time,86400}]}]'),(17,39,3,'初级羽翼纹章','初级羽翼纹章','[{cost,[{1,36010001,300}]},{discount,30},{limit,999},{self_limit,1}]',1,'[{101,20060001,30,[{expire_time,86400}]}]'),(17,39,4,'初级羽翼纹章','初级羽翼纹章','[{cost,[{1,36010001,600}]},{discount,50},{limit,999},{self_limit,1}]',1,'[{100,20060001,60}]'),(17,39,5,'初级羽翼纹章','初级羽翼纹章','[{cost,[{1,36010001,1200}]},{discount,70},{limit,999},{self_limit,3}]',1,'[{100,20060001,120}]'),(17,40,1,'初级神源之火','初级神源之火','[{cost,[{2,36020001,500}]},{discount,80},{limit,999},{self_limit,1}]',1,'[{100,11020001,50}]'),(17,40,2,'初级神源之火','初级神源之火','[{cost,[{1,36010001,200}]},{discount,20},{limit,999},{self_limit,1}]',1,'[{101,11020001,20,[{expire_time,86400}]}]'),(17,40,3,'初级神源之火','初级神源之火','[{cost,[{1,36010001,300}]},{discount,30},{limit,999},{self_limit,1}]',1,'[{101,11020001,30,[{expire_time,86400}]}]'),(17,40,4,'初级神源之火','初级神源之火','[{cost,[{1,36010001,600}]},{discount,50},{limit,999},{self_limit,1}]',1,'[{100,11020001,60}]'),(17,40,5,'初级神源之火','初级神源之火','[{cost,[{1,36010001,1200}]},{discount,70},{limit,999},{self_limit,3}]',1,'[{100,11020001,120}]'),(17,41,1,'初级神源之火','初级神源之火','[{cost,[{2,36020001,500}]},{discount,80},{limit,999},{self_limit,1}]',1,'[{100,11020001,50}]'),(17,41,2,'初级神源之火','初级神源之火','[{cost,[{1,36010001,200}]},{discount,20},{limit,999},{self_limit,1}]',1,'[{101,11020001,20,[{expire_time,86400}]}]'),(17,41,3,'初级神源之火','初级神源之火','[{cost,[{1,36010001,300}]},{discount,30},{limit,999},{self_limit,1}]',1,'[{101,11020001,30,[{expire_time,86400}]}]'),(17,41,4,'初级神源之火','初级神源之火','[{cost,[{1,36010001,600}]},{discount,50},{limit,999},{self_limit,1}]',1,'[{100,11020001,60}]'),(17,41,5,'初级神源之火','初级神源之火','[{cost,[{1,36010001,1200}]},{discount,70},{limit,999},{self_limit,3}]',1,'[{100,11020001,120}]'),(17,101,1,'翅膀特惠礼包','翅膀特惠礼包','[{cost, [{1, 36010001,200}]}, {discount,80}, {limit,20},{self_limit,3}]',1,'[{100,32010301,1}]'),(17,101,2,'圣物特惠礼包','圣物特惠礼包','[{cost, [{1, 36010001,200}]}, {discount,80}, {limit,20},{self_limit,3}]',1,'[{100,32010302,1}]'),(17,101,3,'坐骑装备特惠礼包','坐骑装备特惠礼包','[{cost, [{1, 36010001,200}]}, {discount,80}, {limit,200},{self_limit,20}]',1,'[{100,32010303,1}]'),(17,101,4,'精灵羽翼特惠礼包','精灵羽翼特惠礼包','[{cost, [{1, 36010001,150}]}, {discount,80}, {limit,20},{self_limit,3}]',1,'[{100,32010304,1}]'),(17,101,5,'天行者套装石特惠礼包','天行者套装石特惠礼包','[{cost, [{1, 36010001,100}]}, {discount,30}, {limit,30},{self_limit,3}]',1,'[{100,32010305,10}]'),(17,101,6,'神选者套装石特惠礼包','神选者套装石特惠礼包','[{cost, [{1, 36010001,100}]}, {discount,60}, {limit,30},{self_limit,3}]',1,'[{100,32010306,5}]'),(17,102,1,'翅膀特惠礼包','翅膀特惠礼包','[{cost, [{1, 36010001,200}]}, {discount,80}, {limit,20},{self_limit,3}]',1,'[{100,32010301,1}]'),(17,102,2,'圣物特惠礼包','圣物特惠礼包','[{cost, [{1, 36010001,200}]}, {discount,80}, {limit,20},{self_limit,3}]',1,'[{100,32010302,1}]'),(17,102,3,'坐骑装备特惠礼包','坐骑装备特惠礼包','[{cost, [{1, 36010001,200}]}, {discount,80}, {limit,200},{self_limit,20}]',1,'[{100,32010303,1}]'),(17,102,4,'精灵羽翼特惠礼包','精灵羽翼特惠礼包','[{cost, [{1, 36010001,150}]}, {discount,80}, {limit,20},{self_limit,3}]',1,'[{100,32010304,1}]'),(17,102,5,'天行者套装石特惠礼包','天行者套装石特惠礼包','[{cost, [{1, 36010001,100}]}, {discount,30}, {limit,30},{self_limit,3}]',1,'[{100,32010305,10}]'),(17,102,6,'神选者套装石特惠礼包','神选者套装石特惠礼包','[{cost, [{1, 36010001,100}]}, {discount,60}, {limit,30},{self_limit,3}]',1,'[{100,32010306,5}]'),(17,103,1,'翅膀特惠礼包','翅膀特惠礼包','[{cost, [{1, 36010001,200}]}, {discount,80}, {limit,20},{self_limit,3}]',1,'[{100,32010301,1}]'),(17,103,2,'圣物特惠礼包','圣物特惠礼包','[{cost, [{1, 36010001,200}]}, {discount,80}, {limit,20},{self_limit,3}]',1,'[{100,32010302,1}]'),(17,103,3,'坐骑装备特惠礼包','坐骑装备特惠礼包','[{cost, [{1, 36010001,200}]}, {discount,80}, {limit,200},{self_limit,20}]',1,'[{100,32010303,1}]'),(17,103,4,'精灵羽翼特惠礼包','精灵羽翼特惠礼包','[{cost, [{1, 36010001,150}]}, {discount,80}, {limit,20},{self_limit,3}]',1,'[{100,32010304,1}]'),(17,103,5,'天行者套装石特惠礼包','天行者套装石特惠礼包','[{cost, [{1, 36010001,100}]}, {discount,30}, {limit,30},{self_limit,3}]',1,'[{100,32010305,10}]'),(17,103,6,'神选者套装石特惠礼包','神选者套装石特惠礼包','[{cost, [{1, 36010001,100}]}, {discount,60}, {limit,30},{self_limit,3}]',1,'[{100,32010306,5}]'),(17,104,1,'翅膀特惠礼包','翅膀特惠礼包','[{cost, [{1, 36010001,200}]}, {discount,80}, {limit,20},{self_limit,3}]',1,'[{100,32010301,1}]'),(17,104,2,'圣物特惠礼包','圣物特惠礼包','[{cost, [{1, 36010001,200}]}, {discount,80}, {limit,20},{self_limit,3}]',1,'[{100,32010302,1}]'),(17,104,3,'坐骑装备特惠礼包','坐骑装备特惠礼包','[{cost, [{1, 36010001,200}]}, {discount,80}, {limit,200},{self_limit,20}]',1,'[{100,32010303,1}]'),(17,104,4,'精灵羽翼特惠礼包','精灵羽翼特惠礼包','[{cost, [{1, 36010001,150}]}, {discount,80}, {limit,20},{self_limit,3}]',1,'[{100,32010304,1}]'),(17,104,5,'天行者套装石特惠礼包','天行者套装石特惠礼包','[{cost, [{1, 36010001,100}]}, {discount,30}, {limit,30},{self_limit,3}]',1,'[{100,32010305,10}]'),(17,104,6,'神选者套装石特惠礼包','神选者套装石特惠礼包','[{cost, [{1, 36010001,100}]}, {discount,60}, {limit,30},{self_limit,3}]',1,'[{100,32010306,5}]'),(17,105,1,'翅膀特惠礼包','翅膀特惠礼包','[{cost, [{1, 36010001,200}]}, {discount,80}, {limit,20},{self_limit,3}]',1,'[{100,32010301,1}]'),(17,105,2,'圣物特惠礼包','圣物特惠礼包','[{cost, [{1, 36010001,200}]}, {discount,80}, {limit,20},{self_limit,3}]',1,'[{100,32010302,1}]'),(17,105,3,'坐骑装备特惠礼包','坐骑装备特惠礼包','[{cost, [{1, 36010001,200}]}, {discount,80}, {limit,200},{self_limit,20}]',1,'[{100,32010303,1}]'),(17,105,4,'精灵羽翼特惠礼包','精灵羽翼特惠礼包','[{cost, [{1, 36010001,150}]}, {discount,80}, {limit,20},{self_limit,3}]',1,'[{100,32010304,1}]'),(17,105,5,'天行者套装石特惠礼包','天行者套装石特惠礼包','[{cost, [{1, 36010001,100}]}, {discount,30}, {limit,30},{self_limit,3}]',1,'[{100,32010305,10}]'),(17,105,6,'神选者套装石特惠礼包','神选者套装石特惠礼包','[{cost, [{1, 36010001,100}]}, {discount,60}, {limit,30},{self_limit,3}]',1,'[{100,32010306,5}]'),(18,1,1,'240级首领遗迹首领首杀','240级首领遗迹首领首杀','[{boss_id,1203002}]',1,'[{0,12040004,1},{0,38160001,1},{0,38080050,1}]'),(19,1,1,'第1名奖励','第1名奖励','[{hurt_rank,{1,1}}]',4,'[{1,[{100,32010060,10},{100,32010044,1}]},{251,[{100,32010061,10},{100,32010044,1}]},{301,[{100,32010062,10},{100,32010044,1}]},{351,[{100,32010063,10},{100,32010044,1}]},{401,[{100,32010064,10},{100,32010044,1}]},{451,[{100,32010065,10},{100,32010044,1}]},{501,[{100,32010066,10},{100,32010044,1}]},{551,[{100,32010080,10},{100,32010044,1}]},{601,[{100,32010081,10},{100,32010044,1}]}]'),(19,1,2,'第2-3名奖励','第2-3名奖励','[{hurt_rank,{2,3}}]',4,'[{1,[{100,32010060,8},{100,32010047,1}]},{251,[{100,32010061,8},{100,32010047,1}]},{301,[{100,32010062,8},{100,32010047,1}]},{351,[{100,32010063,8},{100,32010047,1}]},{401,[{100,32010064,8},{100,32010047,1}]},{451,[{100,32010065,8},{100,32010047,1}]},{501,[{100,32010066,8},{100,32010047,1}]},{551,[{100,32010080,8},{100,32010047,1}]},{601,[{100,32010081,8},{100,32010047,1}]}]'),(19,1,3,'第4-10名奖励','第4-10名奖励','[{hurt_rank,{4,10}}]',4,'[{1,[{100,32010060,5},{100,32010043,1}]},{251,[{100,32010061,5},{100,32010043,1}]},{301,[{100,32010062,5},{100,32010043,1}]},{351,[{100,32010063,5},{100,32010043,1}]},{401,[{100,32010064,5},{100,32010043,1}]},{451,[{100,32010065,5},{100,32010043,1}]},{501,[{100,32010066,5},{100,32010043,1}]},{551,[{100,32010080,5},{100,32010043,1}]},{601,[{100,32010081,5},{100,32010043,1}]}]'),(19,1,4,'第11-20名奖励','第11-20名奖励','[{hurt_rank,{11,20}}]',4,'[{1,[{100,32010060,2},{100,32010042,1}]},{251,[{100,32010061,2},{100,32010042,1}]},{301,[{100,32010062,2},{100,32010042,1}]},{351,[{100,32010063,2},{100,32010042,1}]},{401,[{100,32010064,2},{100,32010042,1}]},{451,[{100,32010065,2},{100,32010042,1}]},{501,[{100,32010066,2},{100,32010042,1}]},{551,[{100,32010080,2},{100,32010042,1}]},{601,[{100,32010081,2},{100,32010042,1}]}]'),(19,2,1,'第1名奖励','第1名奖励','[{hurt_rank,{1,1}}]',4,'[{1,[{100,32010060,10},{100,32010044,1}]},{251,[{100,32010061,10},{100,32010044,1}]},{301,[{100,32010062,10},{100,32010044,1}]},{351,[{100,32010063,10},{100,32010044,1}]},{401,[{100,32010064,10},{100,32010044,1}]},{451,[{100,32010065,10},{100,32010044,1}]},{501,[{100,32010066,10},{100,32010044,1}]},{551,[{100,32010080,10},{100,32010044,1}]},{601,[{100,32010081,10},{100,32010044,1}]}]'),(19,2,2,'第2-3名奖励','第2-3名奖励','[{hurt_rank,{2,3}}]',4,'[{1,[{100,32010060,8},{100,32010047,1}]},{251,[{100,32010061,8},{100,32010047,1}]},{301,[{100,32010062,8},{100,32010047,1}]},{351,[{100,32010063,8},{100,32010047,1}]},{401,[{100,32010064,8},{100,32010047,1}]},{451,[{100,32010065,8},{100,32010047,1}]},{501,[{100,32010066,8},{100,32010047,1}]},{551,[{100,32010080,8},{100,32010047,1}]},{601,[{100,32010081,8},{100,32010047,1}]}]'),(19,2,3,'第4-10名奖励','第4-10名奖励','[{hurt_rank,{4,10}}]',4,'[{1,[{100,32010060,5},{100,32010043,1}]},{251,[{100,32010061,5},{100,32010043,1}]},{301,[{100,32010062,5},{100,32010043,1}]},{351,[{100,32010063,5},{100,32010043,1}]},{401,[{100,32010064,5},{100,32010043,1}]},{451,[{100,32010065,5},{100,32010043,1}]},{501,[{100,32010066,5},{100,32010043,1}]},{551,[{100,32010080,5},{100,32010043,1}]},{601,[{100,32010081,5},{100,32010043,1}]}]'),(19,2,4,'第11-20名奖励','第11-20名奖励','[{hurt_rank,{11,20}}]',4,'[{1,[{100,32010060,2},{100,32010042,1}]},{251,[{100,32010061,2},{100,32010042,1}]},{301,[{100,32010062,2},{100,32010042,1}]},{351,[{100,32010063,2},{100,32010042,1}]},{401,[{100,32010064,2},{100,32010042,1}]},{451,[{100,32010065,2},{100,32010042,1}]},{501,[{100,32010066,2},{100,32010042,1}]},{551,[{100,32010080,2},{100,32010042,1}]},{601,[{100,32010081,2},{100,32010042,1}]}]'),(20,1,1,'BOSS掉落展示','BOSS掉落展示','[]',4,'[{1,[{0,14010101,1},{0,14010102,1},{0,14010103,1},{0,14010104,1},{0,14010105,1}]},{501,[{0,14010105,1},{0,14010106,1},{0,14010107,1},{0,14010108,1},{0,14010109,1}]}]'),(20,2,1,'奖励展示','奖励展示','[]',4,'[{1,[{0,14010101,1},{0,14010102,1},{0,14010103,1},{0,14010104,1},{0,14010105,1}]},{501,[{0,14010105,1},{0,14010106,1},{0,14010107,1},{0,14010108,1},{0,14010109,1}]}]'),(21,1,1,'童心玩具','童心玩具','[{goods_exchange, [{0,38220009,78}], 0, 0},{exchange_limit,15}]',1,'[{0,12020011,1}]'),(21,1,2,'战国武器','战国武器','[{goods_exchange, [{0,38220009,48}], 0, 0},{exchange_limit,15}]',1,'[{0,12020002,1}]'),(21,1,3,'童心未泯','童心未泯','[{goods_exchange, [{0,38220009,78}], 0, 0},{exchange_limit,15}]',1,'[{0,12010011,1}]'),(21,1,4,'战国甲胄','战国甲胄','[{goods_exchange, [{0,38220009,48}], 0, 0},{exchange_limit,15}]',1,'[{0,12010002,1}]'),(21,1,5,'童心发饰','童心发饰','[{goods_exchange, [{0,38220009,78}], 0, 0},{exchange_limit,15}]',1,'[{0,12030011,1}]'),(21,1,6,'战国头盔','战国头盔','[{goods_exchange, [{0,38220009,48}], 0, 0},{exchange_limit,15}]',1,'[{0,12030002,1}]'),(21,1,7,'旅行蜗牛碎片','旅行蜗牛碎片','[{goods_exchange, [{0,38220009,10}], 0, 0},{exchange_limit,30}]',1,'[{0,16090006,1}]'),(21,1,8,'背饰-马戏团柯基','背饰-马戏团柯基','[{goods_exchange, [{0,38220009,238}], 0, 0},{exchange_limit,10}]',1,'[{0,20030014,1}]'),(21,1,9,'188绑钻','188绑钻','[{goods_exchange, [{0,38220009,16}], 0, 0},{exchange_limit,10}]',1,'[{2,36020001,188}]'),(21,1,10,'万能幸运券*88','万能幸运券*88','[{goods_exchange, [{0,38220009,16}], 0, 0},{exchange_limit,20}]',1,'[{0,38180015,88}]'),(21,1,11,'扭蛋币','扭蛋币','[{goods_exchange, [{0,38220009,22}], 0, 0},{exchange_limit,10}]',1,'[{0,38180012,1}]'),(21,1,12,'神炼石','神炼石','[{goods_exchange, [{0,38220009,5}], 0, 0},{exchange_limit,8}]',1,'[{0,38250001,1}]'),(21,1,13,'橙色洗炼石','橙色洗炼石','[{goods_exchange, [{0,38220009,10}], 0, 0},{exchange_limit,8}]',1,'[{0,38260002,1}]'),(21,1,14,'红色洗炼石','红色洗炼石','[{goods_exchange, [{0,38220009,15}], 0, 0},{exchange_limit,8}]',1,'[{0,38260003,1}]'),(21,1,15,'中级摄魂晶核','中级摄魂晶核','[{goods_exchange, [{0,38220009,10}], 0, 0},{exchange_limit,10}]',1,'[{0,15020302,1}]'),(21,1,16,'普通防具套装石箱','普通防具套装石箱','[{goods_exchange, [{0,38220009,1}], 0, 0},{exchange_limit,10}]',1,'[{0,32020112,1}]'),(23,1,1,'225狂欢值奖励','225狂欢值奖励','[{hi_points, 100}]',4,'[{1,[{0,38220009,3},{0,37020001,2},{2,36020001,28},{0,20060002,1}]}]'),(23,1,2,'450狂欢值奖励','450狂欢值奖励','[{hi_points, 200}]',4,'[{1,[{0,38220009,6},{0,38180001,1},{0,32020112,2},{0,24010001,5}]}]'),(23,1,3,'675狂欢值奖励','675狂欢值奖励','[{hi_points, 400}]',4,'[{1,[{0,38220009,9},{0,16010002,1},{0,32020112,3},{0,14020402,1}]}]'),(23,1,4,'900狂欢值奖励','900狂欢值奖励','[{hi_points, 600}]',4,'[{1,[{0,38220009,15},{0,24020003,1},{0,24020002,1},{0,24010001,5}]}]'),(23,1,5,'1100狂欢值奖励','1100狂欢值奖励','[{hi_points, 900}]',4,'[{1,[{0,38220009,25},{0,38180015,68},{0,18041002,1},{0,38180002,2}]}]'),(23,1,6,'1300狂欢值奖励','1300狂欢值奖励','[{hi_points, 1150}]',4,'[{1,[{0,38220009,30},{0,24020004,1},{0,18041002,2},{0,38180012,3}]}]'),(23,1,7,'1300狂欢值奖励','1300狂欢值奖励','[{hi_points, 1300}]',4,'[{1,[{0,38220009,50},{0,18041002,3},{0,18041005,3},{0,32030501,1}]}]'),(24,1,1,'创建公会','创建公会','[{count,20}]',1,'[{0,11020001,5},{4,36050001,800}]'),(24,1,2,'任命1名副会长','任命1名副会长','[{count,10},{vice_count,1}]',1,'[{0,11020001,5},{4,36050001,800}]'),(24,1,3,'公会成员达到20人','公会成员达到20人','[{count,5},{member,20}]',1,'[{0,1103000532,1},{4,36050001,1000}]'),(24,1,4,'公会成员达到30人','公会成员达到30人','[{count,3},{member,30}]',5,'[{1,[{0,1107010532,1},{4,36050001,1000}]},{2,[{0,1107020532,1},{4,36050001,1000}]},{3,[{0,1107030532,1},{4,36050001,1000}]},{4,[{0,1107040532,1},{4,36050001,1000}]}]'),(24,1,5,'公会达到2级','公会达到2级','[{count,5},{guild_lv,2}]',1,'[{2,36020001,20},{4,36050001,2000}]'),(24,1,6,'公会达到3级','公会达到3级','[{count,3},{guild_lv,3}]',1,'[{2,36020001,50},{4,36050001,2000}]'),(25,1,1,'简约婚礼','简约婚礼奖励','[]',1,'[{255,40040001,80},{0,40010011,8}]'),(25,1,2,'隆重婚礼','隆重婚礼奖励','[]',1,'[{255,40040001,150},{0,40010011,15},{0,40010001,3}]'),(25,1,3,'豪华婚礼','豪华婚礼奖励','[]',1,'[{255,40040001,300},{0,40010011,30},{0,40010002,3}]'),(26,1,1,'240级首领遗迹首领首杀','240级首领遗迹首领首杀','[{boss_id,1203001}]',1,'[{0,12040004,1},{0,38160001,1},{0,38080050,1}]'),(26,1,2,'280级首领遗迹首领首杀','280级首领遗迹首领首杀','[{boss_id,1203009}]',1,'[{0,12040004,1},{0,38160001,1},{0,38080050,1}]'),(26,1,3,'310级首领遗迹首领首杀','310级首领遗迹首领首杀','[{boss_id,1203014}]',1,'[{0,12040004,1},{0,38160001,1},{0,38080050,1}]'),(26,1,4,'345级首领遗迹首领首杀','345级首领遗迹首领首杀','[{boss_id,1204003}]',1,'[{0,12040004,1},{0,38160001,1},{0,38080050,1}]'),(26,1,5,'360级首领遗迹首领首杀','360级首领遗迹首领首杀','[{boss_id,1204007}]',1,'[{0,12040004,1},{0,38160001,1},{0,38080050,1}]'),(26,1,6,'200级首领会所一层首领首杀','200级首领会所一层首领首杀','[{boss_id,1251001}]',1,'[{0,12040004,1},{0,38160001,1},{0,38080050,1}]'),(26,1,7,'350级首领会所一层首领首杀','350级首领会所一层首领首杀','[{boss_id,1251007}]',1,'[{0,12040004,1},{0,38160001,1},{0,38080050,1}]'),(26,1,8,'350级首领会所二层首领首杀','350级首领会所二层首领首杀','[{boss_id,1252004}]',1,'[{0,12040004,1},{0,38160001,1},{0,38080050,1}]'),(26,1,9,'380级首领会所二层首领首杀','380级首领会所二层首领首杀','[{boss_id,1252005}]',1,'[{0,12040004,1},{0,38160001,1},{0,38080050,1}]'),(27,1,1,'王者公会会长','王者公会会长','[]',1,'[{2,36020001,500},{0,14010103,1},{0,14020203,1}]'),(27,1,2,'王者公会成员','王者公会成员','[]',1,'[{0,14010102,2},{0,14020202,2}]'),(27,1,3,'其他参与过的玩家','其他参与过的玩家','[]',1,'[{0,14010102,1},{0,14020202,1}]'),(27,101,1,'王者公会会长','王者公会会长','[]',1,'[{100,32010045,5},{100,14010005,1},{100,14020005,1}]'),(27,101,2,'王者公会成员','王者公会成员','[]',1,'[{100,32010045,3},{100,14010004,1},{100,14020004,1}]'),(27,101,3,'其他参与过的玩家','其他参与过的玩家','[]',1,'[{100,32010045,1},{100,14010003,1},{100,14020003,1}]'),(28,1,1,'','','[{weight,1},{n_times,1}]',1,'[{2,36020001,38}]'),(28,1,2,'','','[{weight,2},{n_times,2}]',1,'[{2,36020001,38}]'),(28,1,3,'','','[{weight,3},{n_times,3}]',1,'[{2,36020001,38}]'),(28,1,4,'','','[{weight,4},{n_times,5}]',1,'[{2,36020001,38}]'),(28,1,5,'','','[{weight,45},{n_times,8}]',1,'[{2,36020001,38}]'),(28,1,6,'','','[{weight,45},{n_times,10}]',1,'[{2,36020001,38}]'),(28,1,7,'','','[{weight,1},{n_times,1}]',1,'[{2,36020001,68}]'),(28,1,8,'','','[{weight,2},{n_times,2}]',1,'[{2,36020001,68}]'),(28,1,9,'','','[{weight,4},{n_times,3}]',1,'[{2,36020001,68}]'),(28,1,10,'','','[{weight,45},{n_times,5}]',1,'[{2,36020001,68}]'),(28,1,11,'','','[{weight,100},{n_times,8}]',1,'[{2,36020001,68}]'),(28,1,12,'','','[{weight,100},{n_times,10}]',1,'[{2,36020001,68}]'),(28,1,13,'','','[{weight,2},{n_times,1}]',1,'[{2,36020001,128}]'),(28,1,14,'','','[{weight,3},{n_times,2}]',1,'[{2,36020001,128}]'),(28,1,15,'','','[{weight,50},{n_times,3}]',1,'[{2,36020001,128}]'),(28,1,16,'','','[{weight,100},{n_times,5}]',1,'[{2,36020001,128}]'),(28,1,17,'','','[{weight,40},{n_times,8}]',1,'[{2,36020001,128}]'),(28,1,18,'','','[{weight,10},{n_times,10}]',1,'[{2,36020001,128}]'),(28,1,19,'','','[{weight,4},{n_times,1}]',1,'[{2,36020001,188}]'),(28,1,20,'','','[{weight,50},{n_times,2}]',1,'[{2,36020001,188}]'),(28,1,21,'','','[{weight,100},{n_times,3}]',1,'[{2,36020001,188}]'),(28,1,22,'','','[{weight,50},{n_times,5}]',1,'[{2,36020001,188}]'),(28,1,23,'','','[{weight,5},{n_times,8}]',1,'[{2,36020001,188}]'),(28,1,24,'','','[{weight,5},{n_times,10}]',1,'[{2,36020001,188}]'),(28,1,25,'','','[{weight,50},{n_times,1}]',1,'[{2,36020001,428}]'),(28,1,26,'','','[{weight,50},{n_times,2}]',1,'[{2,36020001,428}]'),(28,1,27,'','','[{weight,5},{n_times,3}]',1,'[{2,36020001,428}]'),(28,1,28,'','','[{weight,4},{n_times,5}]',1,'[{2,36020001,428}]'),(28,1,29,'','','[{weight,3},{n_times,8}]',1,'[{2,36020001,428}]'),(28,1,30,'','','[{weight,2},{n_times,10}]',1,'[{2,36020001,428}]'),(28,1,31,'','','[{weight,100},{n_times,1}]',1,'[{2,36020001,688}]'),(28,1,32,'','','[{weight,5},{n_times,2}]',1,'[{2,36020001,688}]'),(28,1,33,'','','[{weight,4},{n_times,3}]',1,'[{2,36020001,688}]'),(28,1,34,'','','[{weight,3},{n_times,5}]',1,'[{2,36020001,688}]'),(28,1,35,'','','[{weight,2},{n_times,8}]',1,'[{2,36020001,688}]'),(28,1,36,'','','[{weight,1},{n_times,10}]',1,'[{2,36020001,688}]'),(28,2,1,'','','[{weight,1},{n_times,1}]',1,'[{2,36020001,38}]'),(28,2,2,'','','[{weight,2},{n_times,2}]',1,'[{2,36020001,38}]'),(28,2,3,'','','[{weight,3},{n_times,3}]',1,'[{2,36020001,38}]'),(28,2,4,'','','[{weight,4},{n_times,5}]',1,'[{2,36020001,38}]'),(28,2,5,'','','[{weight,100},{n_times,8}]',1,'[{2,36020001,38}]'),(28,2,6,'','','[{weight,100},{n_times,10}]',1,'[{2,36020001,38}]'),(28,2,7,'','','[{weight,1},{n_times,1}]',1,'[{2,36020001,68}]'),(28,2,8,'','','[{weight,2},{n_times,2}]',1,'[{2,36020001,68}]'),(28,2,9,'','','[{weight,4},{n_times,3}]',1,'[{2,36020001,68}]'),(28,2,10,'','','[{weight,70},{n_times,5}]',1,'[{2,36020001,68}]'),(28,2,11,'','','[{weight,45},{n_times,8}]',1,'[{2,36020001,68}]'),(28,2,12,'','','[{weight,20},{n_times,10}]',1,'[{2,36020001,68}]'),(28,2,13,'','','[{weight,2},{n_times,1}]',1,'[{2,36020001,98}]'),(28,2,14,'','','[{weight,3},{n_times,2}]',1,'[{2,36020001,98}]'),(28,2,15,'','','[{weight,140},{n_times,3}]',1,'[{2,36020001,98}]'),(28,2,16,'','','[{weight,30},{n_times,5}]',1,'[{2,36020001,98}]'),(28,2,17,'','','[{weight,20},{n_times,8}]',1,'[{2,36020001,98}]'),(28,2,18,'','','[{weight,10},{n_times,10}]',1,'[{2,36020001,98}]'),(28,2,19,'','','[{weight,4},{n_times,1}]',1,'[{2,36020001,128}]'),(28,2,20,'','','[{weight,50},{n_times,2}]',1,'[{2,36020001,128}]'),(28,2,21,'','','[{weight,120},{n_times,3}]',1,'[{2,36020001,128}]'),(28,2,22,'','','[{weight,30},{n_times,5}]',1,'[{2,36020001,128}]'),(28,2,23,'','','[{weight,5},{n_times,8}]',1,'[{2,36020001,128}]'),(28,2,24,'','','[{weight,5},{n_times,10}]',1,'[{2,36020001,128}]'),(28,2,25,'','','[{weight,50},{n_times,1}]',1,'[{2,36020001,188}]'),(28,2,26,'','','[{weight,50},{n_times,2}]',1,'[{2,36020001,188}]'),(28,2,27,'','','[{weight,5},{n_times,3}]',1,'[{2,36020001,188}]'),(28,2,28,'','','[{weight,4},{n_times,5}]',1,'[{2,36020001,188}]'),(28,2,29,'','','[{weight,3},{n_times,8}]',1,'[{2,36020001,188}]'),(28,2,30,'','','[{weight,2},{n_times,10}]',1,'[{2,36020001,188}]'),(28,2,31,'','','[{weight,100},{n_times,1}]',1,'[{2,36020001,328}]'),(28,2,32,'','','[{weight,5},{n_times,2}]',1,'[{2,36020001,328}]'),(28,2,33,'','','[{weight,4},{n_times,3}]',1,'[{2,36020001,328}]'),(28,2,34,'','','[{weight,3},{n_times,5}]',1,'[{2,36020001,328}]'),(28,2,35,'','','[{weight,2},{n_times,8}]',1,'[{2,36020001,328}]'),(28,2,36,'','','[{weight,1},{n_times,10}]',1,'[{2,36020001,328}]'),(28,3,1,'','','[{weight,1},{n_times,1}]',1,'[{2,36020001,38}]'),(28,3,2,'','','[{weight,2},{n_times,2}]',1,'[{2,36020001,38}]'),(28,3,3,'','','[{weight,3},{n_times,3}]',1,'[{2,36020001,38}]'),(28,3,4,'','','[{weight,4},{n_times,5}]',1,'[{2,36020001,38}]'),(28,3,5,'','','[{weight,100},{n_times,8}]',1,'[{2,36020001,38}]'),(28,3,6,'','','[{weight,100},{n_times,10}]',1,'[{2,36020001,38}]'),(28,3,7,'','','[{weight,1},{n_times,1}]',1,'[{2,36020001,68}]'),(28,3,8,'','','[{weight,2},{n_times,2}]',1,'[{2,36020001,68}]'),(28,3,9,'','','[{weight,4},{n_times,3}]',1,'[{2,36020001,68}]'),(28,3,10,'','','[{weight,70},{n_times,5}]',1,'[{2,36020001,68}]'),(28,3,11,'','','[{weight,45},{n_times,8}]',1,'[{2,36020001,68}]'),(28,3,12,'','','[{weight,20},{n_times,10}]',1,'[{2,36020001,68}]'),(28,3,13,'','','[{weight,2},{n_times,1}]',1,'[{2,36020001,98}]'),(28,3,14,'','','[{weight,3},{n_times,2}]',1,'[{2,36020001,98}]'),(28,3,15,'','','[{weight,140},{n_times,3}]',1,'[{2,36020001,98}]'),(28,3,16,'','','[{weight,30},{n_times,5}]',1,'[{2,36020001,98}]'),(28,3,17,'','','[{weight,20},{n_times,8}]',1,'[{2,36020001,98}]'),(28,3,18,'','','[{weight,10},{n_times,10}]',1,'[{2,36020001,98}]'),(28,3,19,'','','[{weight,4},{n_times,1}]',1,'[{2,36020001,128}]'),(28,3,20,'','','[{weight,50},{n_times,2}]',1,'[{2,36020001,128}]'),(28,3,21,'','','[{weight,120},{n_times,3}]',1,'[{2,36020001,128}]'),(28,3,22,'','','[{weight,30},{n_times,5}]',1,'[{2,36020001,128}]'),(28,3,23,'','','[{weight,5},{n_times,8}]',1,'[{2,36020001,128}]'),(28,3,24,'','','[{weight,5},{n_times,10}]',1,'[{2,36020001,128}]'),(28,3,25,'','','[{weight,50},{n_times,1}]',1,'[{2,36020001,188}]'),(28,3,26,'','','[{weight,50},{n_times,2}]',1,'[{2,36020001,188}]'),(28,3,27,'','','[{weight,5},{n_times,3}]',1,'[{2,36020001,188}]'),(28,3,28,'','','[{weight,4},{n_times,5}]',1,'[{2,36020001,188}]'),(28,3,29,'','','[{weight,3},{n_times,8}]',1,'[{2,36020001,188}]'),(28,3,30,'','','[{weight,2},{n_times,10}]',1,'[{2,36020001,188}]'),(28,3,31,'','','[{weight,100},{n_times,1}]',1,'[{2,36020001,328}]'),(28,3,32,'','','[{weight,5},{n_times,2}]',1,'[{2,36020001,328}]'),(28,3,33,'','','[{weight,4},{n_times,3}]',1,'[{2,36020001,328}]'),(28,3,34,'','','[{weight,3},{n_times,5}]',1,'[{2,36020001,328}]'),(28,3,35,'','','[{weight,2},{n_times,8}]',1,'[{2,36020001,328}]'),(28,3,36,'','','[{weight,1},{n_times,10}]',1,'[{2,36020001,328}]'),(30,1,1,'累消288钻石','累消288钻石','[{money_type, gold,288}]',1,'[{0,38220009,3},{2,36020001,188},{0,32020112,5},{0,11040003,2},{0,11040004,2}]'),(30,1,2,'累消888钻石','累消888钻石','[{money_type, gold,888}]',1,'[{0,38220009,5},{0,12030002,1},{0,16010001,1},{0,16010002,1},{0,15020301,10},{0,18020001,5}]'),(30,1,3,'累消1888钻石','累消1888钻石','[{money_type, gold,1888}]',1,'[{0,38220009,8},{0,38180010,3},{0,38180001,3},{0,17020001,1},{0,17020002,1},{0,54010001,5}]'),(30,1,4,'累消2888钻石','累消2888钻石','[{money_type, gold,2888}]',1,'[{0,38220009,12},{0,12020002,1},{0,38180002,3},{0,38180012,3},{0,15020302,10},{0,11070002,3}]'),(30,1,5,'累消5888钻石','累消5888钻石','[{money_type, gold,5888}]',1,'[{0,38220009,15},{0,16010004,1},{0,38180002,5},{0,32020112,10},{0,14010104,1},{0,14020204,1},{0,11070002,5}]'),(30,1,6,'累消9888钻石','累消9888钻石','[{money_type, gold,9888}]',1,'[{0,38220009,20},{0,12010002,1},{0,38260002,3},{0,32020112,15},{0,15020303,10},{0,32030501,1},{0,54010001,10}]'),(30,1,7,'累消12888钻石','累消12888钻石','[{money_type, gold,12888}]',1,'[{0,38220009,25},{0,24020004,1},{0,38180016,1},{0,32020112,20},{0,24020003,1},{0,38260003,3},{0,11070003,5}]'),(30,1,8,'累消18888钻石','累消18888钻石','[{money_type, gold,18888}]',1,'[{0,38220009,30},{0,38180002,10},{0,20020004,1},{0,20020003,1},{0,20020001,2},{0,20020002,2},{0,54010001,20}]'),(30,1,9,'累消28888钻石','累消28888钻石','[{money_type, gold,28888}]',1,'[{0,38220009,40},{0,54030002,1},{0,54040001,50},{0,53030010,2},{0,53030020,2},{0,32020114,5},{0,11070003,10}]'),(30,2,1,'累消288钻石','累消288钻石','[{money_type, gold,288}]',1,'[{0,38220009,3},{2,36020001,188},{0,32020112,5},{0,11040003,2},{0,11040004,2}]'),(30,2,2,'累消888钻石','累消888钻石','[{money_type, gold,888}]',1,'[{0,38220009,5},{0,12030007,1},{0,16010001,1},{0,16010002,1},{0,15020301,10},{0,18020001,5}]'),(30,2,3,'累消1888钻石','累消1888钻石','[{money_type, gold,1888}]',1,'[{0,38220009,8},{0,38180010,3},{0,38180001,3},{0,17020001,1},{0,17020002,1},{0,54010001,5}]'),(30,2,4,'累消2888钻石','累消2888钻石','[{money_type, gold,2888}]',1,'[{0,38220009,12},{0,12020007,1},{0,38180002,3},{0,38180012,3},{0,15020302,10},{0,11070002,3}]'),(30,2,5,'累消5888钻石','累消5888钻石','[{money_type, gold,5888}]',1,'[{0,38220009,15},{0,16010004,1},{0,38180002,5},{0,32020112,10},{0,14010104,1},{0,14020204,1},{0,11070002,5}]'),(30,2,6,'累消9888钻石','累消9888钻石','[{money_type, gold,9888}]',1,'[{0,38220009,20},{0,12010007,1},{0,38260002,3},{0,32020112,15},{0,15020303,10},{0,32030501,1},{0,54010001,10}]'),(30,2,7,'累消12888钻石','累消12888钻石','[{money_type, gold,12888}]',1,'[{0,38220009,25},{0,24020004,1},{0,38180016,1},{0,32020112,20},{0,24020003,1},{0,38260003,3},{0,11070003,5}]'),(30,2,8,'累消18888钻石','累消18888钻石','[{money_type, gold,18888}]',1,'[{0,38220009,30},{0,38180002,10},{0,20020004,1},{0,20020003,1},{0,20020001,2},{0,20020002,2},{0,54010001,20}]'),(30,2,9,'累消28888钻石','累消28888钻石','[{money_type, gold,28888}]',1,'[{0,38220009,40},{0,54050001,1},{0,54020003,1},{0,53030010,2},{0,53030020,2},{0,32020114,5},{0,11070003,10}]'),(30,101,1,'累消388钻石','累消388钻石','[{money_type, gold, 388}]',1,'[{0,12010003,5},{0,11020001,3},{0,14010102,1},{0,14020202,1},{3,36030001,20000}]'),(30,101,2,'累消988钻石','累消988钻石','[{money_type, gold, 988}]',1,'[{0,12010003,1},{0,11020001,3},{0,14010102,1},{0,14020202,1},{3,36030001,20000}]'),(30,101,3,'累消1588钻石','累消1588钻石','[{money_type, gold, 1588}]',1,'[{0,12010003,1},{0,11020001,3},{0,14010102,1},{0,14020202,1},{3,36030001,20000}]'),(30,101,4,'累消2288钻石','累消2288钻石','[{money_type, gold, 2288}]',1,'[{0,12010003,1},{0,11020001,3},{0,14010102,1},{0,14020202,1},{3,36030001,20000}]'),(30,101,5,'累消2888钻石','累消2888钻石','[{money_type, gold, 2888}]',1,'[{0,12010003,1},{0,11020001,3},{0,14010102,1},{0,14020202,1},{3,36030001,20000}]'),(30,101,6,'累消3688钻石','累消3688钻石','[{money_type, gold, 3688}]',1,'[{0,12010003,1},{0,11020001,3},{0,14010102,1},{0,14020202,1},{3,36030001,20000}]'),(30,101,7,'累消6288钻石','累消6288钻石','[{money_type, gold, 6288}]',1,'[{0,12010003,1},{0,11020001,3},{0,14010102,1},{0,14020202,1},{3,36030001,20000}]'),(30,101,8,'累消9888钻石','累消9888钻石','[{money_type, gold, 9888}]',1,'[{0,12010003,1},{0,11020001,3},{0,14010102,1},{0,14020202,1},{3,36030001,20000}]'),(33,1,1,'第1名奖励','第1名奖励','[{rank,{1,1}}]',1,'[{100,38140004,15},{100,38150004,15},{100,40010002,3},{100,38100005,1},{100,40010011,50}]'),(33,1,2,'第2-3名奖励','第2-3名奖励','[{rank,{2,3}}]',1,'[{100,38140004,7},{100,38150004,7},{100,40010002,2},{100,38100004,1},{100,40010011,40}]'),(33,1,3,'第4-10名奖励','第4-10名奖励','[{rank,{4,10}}]',1,'[{100,38140004,3},{100,38150004,3},{100,40010002,1},{100,38100003,1},{100,40010011,40}]'),(33,1,4,'第11-20名奖励','第11-20名奖励','[{rank,{11,20}}]',1,'[{100,38140004,1},{100,38150004,1},{100,38100002,1},{100,40010011,30}]'),(33,1,5,'安慰奖励','安慰奖励','[{rank,{0,0}}]',1,'[{100,38140004,1},{100,38150004,1}]'),(33,101,1,'第1名奖励','第1名奖励','[{rank,{1,1}}]',1,'[{100,38140004,15},{100,38150004,15},{100,40010002,3},{100,38100005,1},{100,40010011,50}]'),(33,101,2,'第2-3名奖励','第2-3名奖励','[{rank,{2,3}}]',1,'[{100,38140004,7},{100,38150004,7},{100,40010002,2},{100,38100004,1},{100,40010011,40}]'),(33,101,3,'第4-10名奖励','第4-10名奖励','[{rank,{4,10}}]',1,'[{100,38140004,3},{100,38150004,3},{100,40010002,1},{100,38100003,1},{100,40010011,40}]'),(33,101,4,'第11-20名奖励','第11-20名奖励','[{rank,{11,20}}]',1,'[{100,38140004,1},{100,38150004,1},{100,38100002,1},{100,40010011,30}]'),(33,101,5,'安慰奖励','安慰奖励','[{rank,{0,0}}]',1,'[{100,4905002,1}]'),(34,1,1,'充值288钻石礼包','充值288钻石','[{recharge, 288}]',1,'[{0,11020001,1},{0,11020002,2},{0,11020003,1}]'),(34,1,2,'充值588钻石礼包','充值588钻石','[{recharge, 588}]',1,'[{0,24010001,1},{0,24010002,2},{0,24010002,1}]'),(34,1,3,'充值988钻石礼包','充值988钻石','[{recharge, 988}]',1,'[{0,15020101,100},{0,15020102,200},{0,15020103,100}]'),(34,1,4,'充值1999钻石礼包','充值1999钻石','[{recharge, 1999}]',1,'[{0,12010002,1},{0,12020002,1},{0,12030002,1}]'),(34,1,5,'充值2599钻石礼包','充值2599钻石','[{recharge, 2599}]',1,'[{0,12010009,2},{0,12020009,2},{0,12030009,2}]'),(34,1,6,'消费288钻石礼包','消费288钻石','[{consume,gold,288}]',1,'[{0,11020001,1},{0,11020002,2},{0,11020003,1}]'),(34,1,7,'消费588钻石礼包','消费588钻石','[{consume,gold,588}]',1,'[{0,24010001,1},{0,24010002,2},{0,24010002,1}]'),(34,1,8,'消费988钻石礼包','消费988钻石','[{consume,gold,988}]',1,'[{0,15020101,100},{0,15020102,200},{0,15020103,100}]'),(34,1,9,'消费1999钻石礼包','消费1999钻石','[{consume,gold,1999}]',1,'[{0,12010002,1},{0,12020002,1},{0,12030002,1}]'),(34,1,10,'消费2599钻石礼包','消费2599钻石','[{consume,gold,2599}]',1,'[{0,12010009,2},{0,12020009,2},{0,12030009,2}]'),(34,1,11,'充值、消费3344钻石礼包','充值、消费3344钻石','[{recharge, 3344},{consume,gold,3344}]',1,'[{0,12040005,1},{1,16030001,1}]'),(35,1,1,'奖励1','奖励1','[{rweight,50},{sweight,10},{is_tv,1}]',1,'[{0,24020003,1}]'),(35,1,2,'奖励2','奖励2','[{rweight,50},{sweight,30},{is_tv,1}]',1,'[{0,24020001,1}]'),(35,1,3,'奖励3','奖励3','[{rweight,50},{sweight,30},{is_tv,1}]',1,'[{0,24020002,1}]'),(35,1,4,'奖励4','奖励4','[{rweight,50},{sweight,100},{is_tv,0}]',1,'[{0,24010001,1}]'),(35,1,5,'奖励5','奖励5','[{rweight,50},{sweight,100},{is_tv,0}]',1,'[{0,24010001,2}]'),(35,1,6,'奖励6','奖励6','[{rweight,50},{sweight,100},{is_tv,0}]',1,'[{0,24010001,3}]'),(35,1,7,'奖励7','奖励7','[{rweight,50},{sweight,30},{is_tv,1}]',1,'[{0,24010002,1}]'),(35,1,8,'奖励8','奖励8','[{rweight,50},{sweight,100},{is_tv,0}]',1,'[{0,32010034,10}]'),(35,1,9,'奖励9','奖励9','[{rweight,50},{sweight,100},{is_tv,0}]',1,'[{0,32010034,20}]'),(35,1,10,'奖励10','奖励10','[{rweight,50},{sweight,100},{is_tv,0}]',1,'[{0,32010034,30}]'),(35,1,11,'奖励11','奖励11','[{rweight,50},{sweight,10},{is_tv,1}]',1,'[{0,32010034,1}]'),(35,1,12,'奖励12','奖励12','[{rweight,50},{sweight,100},{is_tv,0}]',1,'[{0,32010034,10}]'),(35,1,13,'奖励13','奖励13','[{rweight,50},{sweight,100},{is_tv,0}]',1,'[{0,32010033,1}]'),(35,1,14,'奖励14','奖励14','[{rweight,50},{sweight,100},{is_tv,0}]',1,'[{0,32010034,1}]'),(35,1,15,'奖励15','奖励15','[{rweight,50},{sweight,100},{is_tv,0}]',1,'[{0,32010042,1}]'),(35,1,16,'奖励16','奖励16','[{rweight,50},{sweight,100},{is_tv,0}]',1,'[{0,32010043,1}]'),(35,1,17,'奖励17','奖励17','[{rweight,50},{sweight,30},{is_tv,1}]',1,'[{0,32010044,1}]'),(35,1,18,'奖励18','奖励18','[{rweight,50},{sweight,30},{is_tv,1}]',1,'[{0,32010034,1}]'),(35,1,19,'奖励19','奖励19','[{rweight,50},{sweight,30},{is_tv,1}]',1,'[{0,32010034,1}]'),(35,1,20,'奖励20','奖励20','[{rweight,50},{sweight,30},{is_tv,1}]',1,'[{0,32010034,1}]'),(35,2,1,'累计奖励1','累计2次奖励','[{extra_reward, true},{times_limit, 2}]',1,'[{0,16020002,1}]'),(35,2,2,'累计奖励2','累计4次奖励','[{extra_reward, true},{times_limit, 4}]',1,'[{0,16020002,2}]'),(35,2,3,'累计奖励3','累计6次奖励','[{extra_reward, true},{times_limit, 6}]',1,'[{0,16020002,3}]'),(35,2,4,'累计奖励4','累计9次奖励','[{extra_reward, true},{times_limit, 9}]',1,'[{0,16020002,4}]'),(35,2,5,'极品奖励池','极品奖励池','[{reward_lv, 1},{weight, 10}]',1,'[{0,16030008,1}]'),(35,2,6,'极品奖励池','极品奖励池','[{reward_lv, 1},{weight, 10}]',1,'[{0,18040008,1}]'),(35,2,7,'极品奖励池','极品奖励池','[{reward_lv, 1},{weight, 10}]',1,'[{0,20030001,1}]'),(35,2,8,'极品奖励池','极品奖励池','[{reward_lv, 1},{weight, 10}]',1,'[{0,20040002,1}]'),(35,2,9,'珍品奖励池','珍品奖励池','[{reward_lv, 2},{weight, 200}]',1,'[{0,12010005,1}]'),(35,2,10,'珍品奖励池','珍品奖励池','[{reward_lv, 2},{weight, 200}]',1,'[{0,12020005,1}]'),(35,2,11,'珍品奖励池','珍品奖励池','[{reward_lv, 2},{weight, 200}]',1,'[{0,32160006,5}]'),(35,2,12,'珍品奖励池','珍品奖励池','[{reward_lv, 2},{weight, 200}]',1,'[{0,18041103,15}]'),(35,2,13,'珍品奖励池','珍品奖励池','[{reward_lv, 2},{weight, 200}]',1,'[{0,11050004,25}]'),(35,2,14,'精品奖励池','精品奖励池','[{reward_lv, 3},{weight, 5000}]',1,'[{0,32160006,3}]'),(35,2,15,'精品奖励池','精品奖励池','[{reward_lv, 3},{weight, 5000}]',1,'[{0,18041002,5}]'),(35,2,16,'精品奖励池','精品奖励池','[{reward_lv, 3},{weight, 5000}]',1,'[{0,18041103,10}]'),(35,2,17,'精品奖励池','精品奖励池','[{reward_lv, 3},{weight, 5000}]',1,'[{0,20040001,1}]'),(35,2,18,'精品奖励池','精品奖励池','[{reward_lv, 3},{weight, 5000}]',1,'[{0,38030001,3}]'),(35,2,19,'精品奖励池','精品奖励池','[{reward_lv, 3},{weight, 5000}]',1,'[{0,38330004,2}]'),(36,1,1,'坐骑二阶','坐骑二阶','[{lv,150}, {receive_day, 2}, {return_reward, [{2,0,288}]},{model,3,[{1,302010},{2,302010},{4,302010}]}]',1,'[{0,16020001,8},{0,16020001,8},{3,36030001,250000},{0,14010102,1},{0,14020202,1},{2,36020001,88}]'),(36,1,2,'寻宝礼包','寻宝礼包','[ {cost, [{1,0,188}]},{receive_day,3}, {return_reward, [{1,0,188}]},{icon,[{0,4908026,1}]}]',1,'[{0,4908026,1},{0,38180010,3},{0,38180001,5},{0,38030002,2},{0,16020001,15},{0,11020001,15}]'),(36,1,3,'爱情礼包','爱情礼包','[ {cost, [{1,0,588}]},{receive_day, 6}, {return_reward, [{1,0,588}]},{icon,[{0,38150002,1}]}]',1,'[{0,38150002,1},{0,38100005,1},{0,40010011,5},{0,32030301,1},{0,24010001,30},{0,20060001,30}]'),(36,1,4,'帅气时装','帅气时装','[ {cost, [{1,0,2888}]},{receive_day, 14}, {return_reward, [{1,0,2888}]},{model,1,[{0,12010002,1}]}]',1,'[{0,12010002,1},{0,20060001,30},{0,24010001,30},{0,16020001,15},{0,11020001,15},{0,32030401,1}]'),(36,2,1,'免费圣器','免费圣器','[{lv,250}, {receive_day,1}, {return_reward, [{2,0,388}]},{model,2,[{0,203021,1}]}]',1,'[{0,11030003,1},{0,11040003,4},{0,11020001,10},{0,14010102,1},{0,14020202,1},{3,36030001,200000}]'),(36,2,2,'降神印记','降神印记','[ {cost, [{1,0,88}]},{receive_day, 4}, {return_reward, [{1,0,88}]},{icon,[{0,zerogift_big1,1}]}]',1,'[{0,11040003,12},{0,11040003,12},{0,11020001,15},{0,32030301,1},{2,36020001,88},{3,36030001,300000}]'),(36,2,3,'二阶圣器','二阶圣器','[ {cost, [{1,0,188}]},{receive_day, 10}, {return_reward, [{1,0,188}]},{model,2,[{0,203021,1}]}]',1,'[{0,11030003,1},{0,11040003,18},{0,11020001,25},{0,16010003,1},{2,36020001,188},{3,36030001,500000}]'),(36,2,4,'自带BGM','自带BGM','[ {cost, [{1,0,588}]},{receive_day, 14}, {return_reward, [{1,0,588}]},{icon,[{0,zerogift_big2,1}]}]',1,'[{0,4917002,1},{0,11040004,18},{0,11020001,35},{0,16010004,1},{2,36020001,288},{3,36030001,800000}]'),(37,1,1,'神晶石','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim,10}]',1,'[{100,38040005,1}]'),(37,1,2,'神星石','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim, 5}]',1,'[{100,38040006,1}]'),(37,1,3,'星空之翼','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 10}]',1,'[{100,38040005,1}]'),(37,1,4,'丛林之翼','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 5}]',1,'[{100,38040005,1}]'),(37,1,5,'烈焰之翼','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 2}]',1,'[{100,38040005,1}]'),(37,1,6,'2000绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 8}]',1,'[{2,36020001,2000}]'),(37,1,7,'1000绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 15}]',1,'[{2,36020001,1000}]'),(37,1,8,'500绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 25}]',1,'[{2,36020001,500}]'),(37,2,1,'红色经验魂珠','幸运大奖','[{is_main_reward,true},{buy_num_lim,20},\n{total_buy_num_lim, 300},{winner_num_lim, 1},\n{draw_num, [{50, 101},{150, 102}]},{icon,expBig}]',1,'[{100,5201144,1}]'),(37,2,101,'魂珠寻宝券','体验奖','[{is_main_reward, false},  \n{winner_num_lim, 5}]',1,'[{100,38180010,1}]'),(37,2,102,'橙色经验魂珠','惊喜奖','[{is_main_reward, false}, {winner_num_lim, 2}]',1,'[{100,5201143,1}]'),(37,3,1,'神晶石','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim,10}]',1,'[{100,38040005,1}]'),(37,3,2,'神星石','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim, 5}]',1,'[{100,38040006,1}]'),(37,3,3,'星空之翼','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 10}]',1,'[{100,38040006,1}]'),(37,3,4,'丛林之翼','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 5}]',1,'[{100,38040006,1}]'),(37,3,5,'烈焰之翼','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 2}]',1,'[{100,38040006,1}]'),(37,3,6,'2000绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 8}]',1,'[{2,36020001,2000}]'),(37,3,7,'1000绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 15}]',1,'[{2,36020001,1000}]'),(37,3,8,'500绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 25}]',1,'[{2,36020001,500}]'),(37,4,1,'兽星石','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim,5}]',1,'[{100,38040006,1}]'),(37,4,2,'驯兽秘卷','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim,2}]',1,'[{100,38040006,1}]'),(37,4,3,'上古王冠','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 10}]',1,'[{100,24030002,1}]'),(37,4,4,'海神圣杯','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 5}]',1,'[{100,24030003,1}]'),(37,4,5,'苍龙徽章','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 2}]',1,'[{100,24030004,1}]'),(37,4,6,'2000绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 8}]',1,'[{2,36020001,2000}]'),(37,4,7,'1000绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 15}]',1,'[{2,36020001,1000}]'),(37,4,8,'500绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 25}]',1,'[{2,36020001,500}]'),(37,5,1,'神晶石','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim,10}]',1,'[{100,38040005,1}]'),(37,5,2,'神星石','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim, 5}]',1,'[{100,38040006,1}]'),(37,5,3,'星空之翼','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 10}]',1,'[{100,38040006,1}]'),(37,5,4,'丛林之翼','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 5}]',1,'[{100,38040006,1}]'),(37,5,5,'烈焰之翼','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 2}]',1,'[{100,38040006,1}]'),(37,5,6,'2000绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 8}]',1,'[{2,36020001,2000}]'),(37,5,7,'1000绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 15}]',1,'[{2,36020001,1000}]'),(37,5,8,'500绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 25}]',1,'[{2,36020001,500}]'),(37,6,1,'兽星石','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim,5}]',1,'[{100,38040006,1}]'),(37,6,2,'驯兽秘卷','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim,2}]',1,'[{100,38040006,1}]'),(37,6,3,'上古王冠','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 10}]',1,'[{100,24030002,1}]'),(37,6,4,'海神圣杯','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 5}]',1,'[{100,24030003,1}]'),(37,6,5,'苍龙徽章','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 2}]',1,'[{100,24030004,1}]'),(37,6,6,'2000绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 8}]',1,'[{2,36020001,2000}]'),(37,6,7,'1000绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 15}]',1,'[{2,36020001,1000}]'),(37,6,8,'500绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 25}]',1,'[{2,36020001,500}]'),(37,7,1,'神晶石','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim,10}]',1,'[{100,38040005,1}]'),(37,7,2,'神星石','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim, 5}]',1,'[{100,38040006,1}]'),(37,7,3,'星空之翼','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 10}]',1,'[{100,38040006,1}]'),(37,7,4,'丛林之翼','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 5}]',1,'[{100,38040006,1}]'),(37,7,5,'烈焰之翼','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 2}]',1,'[{100,38040006,1}]'),(37,7,6,'2000绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 8}]',1,'[{2,36020001,2000}]'),(37,7,7,'1000绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 15}]',1,'[{2,36020001,1000}]'),(37,7,8,'500绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 25}]',1,'[{2,36020001,500}]'),(37,8,1,'兽星石','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim,5}]',1,'[{100,38040006,1}]'),(37,8,2,'驯兽秘卷','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim,2}]',1,'[{100,38040006,1}]'),(37,8,3,'上古王冠','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 10}]',1,'[{100,24030002,1}]'),(37,8,4,'海神圣杯','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 5}]',1,'[{100,24030003,1}]'),(37,8,5,'苍龙徽章','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 2}]',1,'[{100,24030004,1}]'),(37,8,6,'2000绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 8}]',1,'[{2,36020001,2000}]'),(37,8,7,'1000绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 15}]',1,'[{2,36020001,1000}]'),(37,8,8,'500绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 25}]',1,'[{2,36020001,500}]'),(37,9,1,'神晶石','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim,10}]',1,'[{100,38040005,1}]'),(37,9,2,'神星石','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim, 5}]',1,'[{100,38040006,1}]'),(37,9,3,'星空之翼','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 10}]',1,'[{100,38040006,1}]'),(37,9,4,'丛林之翼','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 5}]',1,'[{100,38040006,1}]'),(37,9,5,'烈焰之翼','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 2}]',1,'[{100,38040006,1}]'),(37,9,6,'2000绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 8}]',1,'[{2,36020001,2000}]'),(37,9,7,'1000绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 15}]',1,'[{2,36020001,1000}]'),(37,9,8,'500绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 25}]',1,'[{2,36020001,500}]'),(37,10,1,'兽星石','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim,5}]',1,'[{100,38040006,1}]'),(37,10,2,'驯兽秘卷','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim,2}]',1,'[{100,38040006,1}]'),(37,10,3,'上古王冠','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 10}]',1,'[{100,24030002,1}]'),(37,10,4,'海神圣杯','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 5}]',1,'[{100,24030003,1}]'),(37,10,5,'苍龙徽章','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 2}]',1,'[{100,24030004,1}]'),(37,10,6,'2000绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 8}]',1,'[{2,36020001,2000}]'),(37,10,7,'1000绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 15}]',1,'[{2,36020001,1000}]'),(37,10,8,'500绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 500},{winner_num_lim, 25}]',1,'[{2,36020001,500}]'),(38,1,1,'2000绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim, 9}]',1,'[{2,36020001,2000}]'),(38,1,2,'1500绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim, 12}]',1,'[{2,36020001,1500}]'),(38,1,3,'1000绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim, 16}]',1,'[{2,36020001,1000}]'),(38,1,4,'500绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim, 32}]',1,'[{2,36020001,500}]'),(38,2,1,'利维坦','幸运大奖1','[{is_main_reward,true},{buy_num_lim,30},\n{total_buy_num_lim, 200},{winner_num_lim, 2},\n{draw_num, [{60, 101},{120, 102}]}]',1,'[{100,16030005,1}]'),(38,2,2,'尸烬龙','幸运大奖2','[{is_main_reward, true},{buy_num_lim,30}, {total_buy_num_lim, 300},{winner_num_lim, 3},{draw_num, [{100, 101},{200, 102}]}]',1,'[{100,16030004,1}]'),(38,2,101,'失落魔方','惊喜奖','[{is_main_reward, false},  \n{winner_num_lim, 2}]',1,'[{100,24030002,1}]'),(38,2,102,'龙魂宝珠','体验奖','[{is_main_reward, false}, {winner_num_lim, 2}]',1,'[{100,24030001,1}]'),(38,3,1,'2000绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim, 9}]',1,'[{2,36020001,2000}]'),(38,3,2,'1500绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim, 12}]',1,'[{2,36020001,1500}]'),(38,3,3,'1000绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim, 16}]',1,'[{2,36020001,1000}]'),(38,3,4,'500绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim, 32}]',1,'[{2,36020001,500}]'),(38,4,1,'2000绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim, 9}]',1,'[{2,36020001,2000}]'),(38,4,2,'1500绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim, 12}]',1,'[{2,36020001,1500}]'),(38,4,3,'1000绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim, 16}]',1,'[{2,36020001,1000}]'),(38,4,4,'500绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim, 32}]',1,'[{2,36020001,500}]'),(38,5,1,'2000绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim, 9}]',1,'[{2,36020001,2000}]'),(38,5,2,'1500绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim, 12}]',1,'[{2,36020001,1500}]'),(38,5,3,'1000绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim, 16}]',1,'[{2,36020001,1000}]'),(38,5,4,'500绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim, 32}]',1,'[{2,36020001,500}]'),(38,6,1,'2000绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim, 9}]',1,'[{2,36020001,2000}]'),(38,6,2,'1500绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim, 12}]',1,'[{2,36020001,1500}]'),(38,6,3,'1000绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim, 16}]',1,'[{2,36020001,1000}]'),(38,6,4,'500绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim, 32}]',1,'[{2,36020001,500}]'),(38,7,1,'2000绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim, 9}]',1,'[{2,36020001,2000}]'),(38,7,2,'1500绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim, 12}]',1,'[{2,36020001,1500}]'),(38,7,3,'1000绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim, 16}]',1,'[{2,36020001,1000}]'),(38,7,4,'500绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim, 32}]',1,'[{2,36020001,500}]'),(38,8,1,'2000绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim, 9}]',1,'[{2,36020001,2000}]'),(38,8,2,'1500绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim, 12}]',1,'[{2,36020001,1500}]'),(38,8,3,'1000绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim, 16}]',1,'[{2,36020001,1000}]'),(38,8,4,'500绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim, 32}]',1,'[{2,36020001,500}]'),(38,9,1,'2000绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim, 9}]',1,'[{2,36020001,2000}]'),(38,9,2,'1500绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim, 12}]',1,'[{2,36020001,1500}]'),(38,9,3,'1000绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim, 16}]',1,'[{2,36020001,1000}]'),(38,9,4,'500绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim, 32}]',1,'[{2,36020001,500}]'),(38,10,1,'2000绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim, 9}]',1,'[{2,36020001,2000}]'),(38,10,2,'1500绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim, 12}]',1,'[{2,36020001,1500}]'),(38,10,3,'1000绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim, 16}]',1,'[{2,36020001,1000}]'),(38,10,4,'500绑钻','','[{buy_num_lim, 5},{total_buy_num_lim, 1000},{winner_num_lim, 32}]',1,'[{2,36020001,500}]'),(39,1,1,'第1名奖励','第1名奖励','[{rank,{1,1}}]',1,'[{100,16030004,1},{100,20020003,3},{100,24020003,3},{100,20020002,6},{100,24020002,6}]'),(39,1,2,'第2-3名奖励','第2-3名奖励','[{rank,{2,3}}]',1,'[{100,16030004,1},{100,20020003,2},{100,24020003,2},{100,20020002,5},{100,24020002,5}]'),(39,1,3,'第4-10名奖励','第4-10名奖励','[{rank,{4,10}}]',1,'[{100,38140004,3},{100,38150004,3},{100,40010002,1},{100,38100003,1},{100,40010011,40}]'),(39,1,4,'第11-20名奖励','第11-20名奖励','[{rank,{11,20}}]',1,'[{100,38140004,3},{100,38150004,3},{100,40010002,1},{100,38100003,1},{100,40010011,40}]'),(39,1,5,'安慰奖励','安慰奖励','[{rank,{0,0}}]',1,'[{100,20020002,1},{100,24020002,1}]'),(40,1,1,'消费60钻石','消费60钻石','[{type,1},{gold,60}]',1,'[{0,17010001,30},{0,38030003,2},{0,38180010,1},{0,48060103,1},{0,50010202,5},{0,48040002,100}]'),(40,1,2,'消费300钻石','消费300钻石','[{type,1},{gold,300}]',1,'[{0,5203003,4},{0,38160001,1},{0,38180010,1},{0,48060103,2},{0,50010202,8},{0,48040002,200}]'),(40,1,3,'消费680钻石','消费680钻石','[{type,1},{gold,680}]',1,'[{0,16020001,15},{0,38340007,2},{0,38180010,1},{0,48060103,4},{0,50010202,12},{0,48040002,300}]'),(40,1,4,'消费1280钻石','消费1280钻石','[{type,1},{gold,1280}]',1,'[{0,38160001,1},{0,38180001,1},{0,37020002,1},{0,15020301,10},{0,15020302,3},{0,15020303,1}]'),(40,1,11,'累计1天消费300钻石','累计1天消费300钻石','[{type,2},{gold,300},{day,1}]',1,'[{0,20020002,1}]'),(40,1,12,'累计2天消费300钻石','累计2天消费300钻石','[{type,2},{gold,300},{day,2}]',1,'[{0,20020003,1}]'),(40,1,13,'累计3天消费300钻石','累计3天消费300钻石','[{type,2},{gold,300},{day,3},{cycle,1}]',1,'[{0,20020004,1}]'),(41,1,1,'强力破甲','消耗288钻石购买获得','[{old_price,[{1,0,700}]},{now_price,[{1,0,288}]},{icon,[jz_1_1]}]',1,'[{0,5201033,1},{0,38180010,1},{0,5203004,1},{255,36160007,12000},{0,38260001,5},{2,36020001,188}]'),(41,1,2,'买一送一','消耗1288钻石购买获得','[{old_price,[{1,0,3288}]},{now_price,[{1,0,1288}]},{icon,[jz_1_2]}]',1,'[{0,38180016,1},{0,38180016,1},{0,12030002,1},{0,38180001,2},{0,38260001,10},{2,36020001,688}]'),(41,1,3,'极品秒杀','消耗2888钻石购买获得','[{old_price,[{1,0,8088}]},{now_price,[{1,0,2888}]},{icon,[jz_1_3]}]',1,'[{0,5201024,1},{0,12020002,1},{0,38180010,3},{0,38180001,3},{0,38260001,15},{2,36020001,2188}]'),(41,2,1,'炫酷发型','消耗188钻石购买获得','[{old_price,[{1,0,528}]},{now_price,[{1,0,188}]},{fashion_model,[{1,12030007}, {2,12030007}, {3,12030007}, {4,12030007}]}]',1,'[{0,12030007,1},{0,32030201,2},{0,38180001,1},{0,14010101,3},{0,14020201,1},{2,36020001,88}]'),(41,2,2,'青春时装','消耗688钻石购买获得','[{old_price,[{1,0,1988}]},{now_price,[{1,0,688}]},{fashion_model,[{1,12010007}, {2,12010007}, {3,12010007}, {4,12010007}]}]',1,'[{0,12010007,1},{0,32030301,2},{0,38180001,2},{0,14010102,2},{0,14020202,2},{2,36020001,288}]'),(41,2,3,'特价宝石','消耗1288钻石购买获得','[{old_price,[{1,0,3888}]},{now_price,[{1,0,1288}]},{icon,[jz_2_3]}]',1,'[{0,32030501,1},{0,12020007,1},{0,38180001,5},{0,14010103,2},{0,14020203,2},{2,36020001,688}]'),(41,2,4,'宝石壕强','消耗2888钻石购买获得','[{old_price,[{1,0,8088}]},{now_price,[{1,0,2888}]},{icon,[jz_2_4]}]',1,'[{0,32030601,1},{0,12040007,1},{0,38180001,10},{0,14010104,1},{0,14020204,1},{2,36020001,988}]'),(41,3,1,'修罗送礼','消耗488绑定钻石购买获得','[{old_price,[{1,0,800}]},{now_price,[{2,0,488}]},{part_model,[202029]}]',1,'[{0,18040104,1},{0,18050601,1},{0,18020001,10},{0,18060001,10},{0,38180010,1},{3,36030001,200000}]'),(41,3,2,'绝世神技','消耗488钻石购买获得','[{old_price,[{1,0,1750}]},{now_price,[{1,0,488}]},{icon,[jz_3_1]}]',1,'[{0,18050901,1},{0,18030001,2},{0,18020001,30},{0,18060002,20},{0,38180010,5},{3,36030001,500000}]'),(41,3,3,'萌萌巨蟹','消耗2188钻石购买获得','[{old_price,[{1,0,3250}]},{now_price,[{1,0,1088}]},{part_model,[501006]}]',1,'[{0,18040005,1},{0,18030001,3},{0,18020001,50},{0,18060003,25},{0,38180016,1},{3,36030001,600000}]'),(41,4,1,'武器套装礼包','消耗288钻石购买获得','[{old_price,[{1,0,1440}]},{now_price,[{1,0,288}]},{icon,[wz01]}]',1,'[{0,32020113,20},{0,38160001,1},{0,38180010,1},{0,38180001,1},{3,36030001,500000},{2,36020001,88}]'),(41,4,2,'首饰套装礼包','消耗688钻石购买获得','[{old_price,[{1,0,2298}]},{now_price,[{1,0,688}]},{icon,[wz01]}]',1,'[{0,32020114,10},{0,38030002,2},{0,38180010,2},{0,38180001,2},{3,36030001,1000000},{2,36020001,188}]'),(41,4,3,'粉装防具礼包','消耗1288钻石购买获得','[{old_price,[{1,0,3220}]},{now_price,[{1,0,1288}]},{icon,[wz01]}]',1,'[{0,38280510,3},{0,38030003,10},{0,38180010,5},{0,38180001,5},{3,36030001,2000000},{2,36020001,488}]'),(41,5,1,'月神印记礼包','消耗288钻石购买获得','[{old_price,[{1,0,1440}]},{now_price,[{1,0,288}]},{icon,[wz01]}]',1,'[{0,11020001,25},{0,11040005,8},{0,38180010,1},{0,38180001,1},{3,36030001,500000},{2,36020001,88}]'),(41,5,2,'冰雪女王礼包','消耗688钻石购买获得','[{old_price,[{1,0,2298}]},{now_price,[{1,0,688}]},{icon,[wz01]}]',1,'[{0,11020002,20},{0,11040004,12},{0,38180010,2},{0,38180001,2},{3,36030001,1000000},{2,36020001,188}]'),(41,5,3,'雅典娜礼包','消耗1288钻石购买获得','[{old_price,[{1,0,3220}]},{now_price,[{1,0,1288}]},{icon,[wz01]}]',1,'[{0,11020002,30},{0,11040002,20},{0,38180010,5},{0,38180001,5},{3,36030001,2000000},{2,36020001,488}]'),(41,6,1,'初级星灵礼包','消耗328钻石购买获得','[{old_price,[{1,0,1640}]},{now_price,[{1,0,328}]},{icon,[wz01]}]',1,'[{0,32060003,1},{0,18060002,15},{0,38180010,1},{0,38180001,1},{3,36030001,500000},{2,36020001,88}]'),(41,6,2,'中级星灵礼包','消耗888钻石购买获得','[{old_price,[{1,0,2988}]},{now_price,[{1,0,888}]},{icon,[wz01]}]',1,'[{0,34010022,1},{0,18020002,15},{0,38180010,2},{0,38180001,2},{3,36030001,1000000},{2,36020001,188}]'),(41,6,3,'高级星灵礼包','消耗1388钻石购买获得','[{old_price,[{1,0,3488}]},{now_price,[{1,0,1388}]},{icon,[wz01]}]',1,'[{0,32110041,1},{255,36160004,1500},{0,38180010,5},{0,38180001,5},{3,36030001,2000000},{2,36020001,488}]'),(41,7,1,'初级精粹礼包','消耗288钻石购买获得','[{old_price,[{1,0,1440}]},{now_price,[{1,0,288}]},{icon,[wz01]}]',1,'[{0,14110001,4},{0,14110002,4},{0,38180010,1},{0,38180001,1},{3,36030001,500000},{2,36020001,88}]'),(41,7,2,'中级精粹礼包','消耗688钻石购买获得','[{old_price,[{1,0,2298}]},{now_price,[{1,0,688}]},{icon,[wz01]}]',1,'[{0,14110001,8},{0,14110002,8},{0,38180010,2},{0,38180001,2},{3,36030001,1000000},{2,36020001,188}]'),(41,7,3,'高级晶石礼包','消耗1288钻石购买获得','[{old_price,[{1,0,3220}]},{now_price,[{1,0,1288}]},{icon,[wz01]}]',1,'[{0,14110003,4},{0,14110004,4},{0,38180010,5},{0,38180001,5},{3,36030001,2000000},{2,36020001,488}]'),(41,8,1,'初级锻造礼包','消耗288钻石购买获得','[{old_price,[{1,0,1440}]},{now_price,[{1,0,288}]},{icon,[wz01]}]',1,'[{0,38260001,8},{0,38260001,32},{0,38180010,1},{0,38180001,1},{3,36030001,500000},{2,36020001,88}]'),(41,8,2,'中级锻造礼包','消耗688钻石购买获得','[{old_price,[{1,0,2298}]},{now_price,[{1,0,688}]},{icon,[wz01]}]',1,'[{0,38260001,15},{0,38260001,60},{0,38180010,2},{0,38180001,2},{3,36030001,1000000},{2,36020001,188}]'),(41,8,3,'高级星痕礼包','消耗1288钻石购买获得','[{old_price,[{1,0,3220}]},{now_price,[{1,0,1288}]},{icon,[wz01]}]',1,'[{0,32040401,1},{0,21040003,2},{0,38180010,5},{0,38180001,5},{3,36030001,2000000},{2,36020001,488}]'),(41,9,1,'初级铭文礼包','消耗288钻石购买获得','[{old_price,[{1,0,1440}]},{now_price,[{1,0,288}]},{icon,[wz01]}]',1,'[{0,32080002,2},{0,11040005,10},{0,38180010,1},{0,38180001,1},{3,36030001,500000},{2,36020001,88}]'),(41,9,2,'中级铭文礼包','消耗688钻石购买获得','[{old_price,[{1,0,2298}]},{now_price,[{1,0,688}]},{icon,[wz01]}]',1,'[{0,32080004,4},{0,11040004,12},{0,38180010,2},{0,38180001,2},{3,36030001,1000000},{2,36020001,188}]'),(41,9,3,'高级铭文礼包','消耗1288钻石购买获得','[{old_price,[{1,0,3220}]},{now_price,[{1,0,1288}]},{icon,[wz01]}]',1,'[{0,32080006,6},{0,11040002,20},{0,38180010,5},{0,38180001,5},{3,36030001,2000000},{2,36020001,488}]'),(41,10,1,'失落魔方礼包','消耗288钻石购买获得','[{old_price,[{1,0,1440}]},{now_price,[{1,0,288}]},{part_model,[607003]}]',1,'[{0,24031002,5},{0,24010001,18},{0,38180010,1},{0,38180001,1},{3,36030001,500000},{2,36020001,88}]'),(41,10,2,'古神典籍礼包','消耗688钻石购买获得','[{old_price,[{1,0,2298}]},{now_price,[{1,0,688}]},{part_model,[607006]}]',1,'[{0,24031003,5},{0,24010001,30},{0,38180010,2},{0,38180001,2},{3,36030001,1000000},{2,36020001,188}]'),(41,10,3,'海洋之心礼包','消耗1288钻石购买获得','[{old_price,[{1,0,3220}]},{now_price,[{1,0,1288}]},{part_model,[607007]}]',1,'[{0,24031004,5},{0,24010002,20},{0,38180010,5},{0,38180001,5},{3,36030001,2000000},{2,36020001,488}]'),(41,11,1,'称号砸蛋','消耗288钻石购买获得','[{old_price,[{1,0,888}]},{now_price,[{1,0,288}]},{icon,[jz_11_1]}]',1,'[{0,4917013,1},{0,38180015,188},{0,11040003,2},{0,38030003,1},{0,38220009,5},{2,36020001,108}]'),(41,11,2,'扭蛋发型','消耗588钻石购买获得','[{old_price,[{1,0,1888}]},{now_price,[{1,0,588}]},{fashion_model,[{1,12030011}, {2,12030011}, {3,12030011}, {4,12030011}]}]',1,'[{0,12030011,1},{0,38180012,10},{0,53030020,1},{0,54010001,10},{0,38220009,10},{2,36020001,158}]'),(41,11,3,'吃瓜群众','消耗888钻石购买获得','[{old_price,[{1,0,2888}]},{now_price,[{1,0,888}]},{icon,[jz_11_3]}]',1,'[{0,38140007,1},{0,38150007,1},{0,17020003,1},{0,38180001,9},{0,38220009,15},{2,36020001,218}]'),(41,11,4,'巅峰寻宝','消耗1788钻石购买获得','[{old_price,[{1,0,6888}]},{now_price,[{1,0,1788}]},{fashion_model,[{1,12010011}, {2,12010011}, {3,12010011}, {4,12010011}]}]',1,'[{0,12010011,1},{0,38180012,5},{0,38180002,9},{0,38180016,1},{0,38220009,30},{2,36020001,418}]'),(41,11,5,'酷炫足迹','消耗2388钻石购买获得','[{old_price,[{1,0,8888}]},{now_price,[{1,0,2388}]},{fashion_model,[{1,12040002}, {2,12040002}, {3,12040002}, {4,12040002}]}]',1,'[{0,12040002,1},{0,17020004,1},{0,38180015,188},{0,38180012,10},{0,38220009,35},{2,36020001,618}]'),(41,12,1,'武器套装礼包','消耗288钻石购买获得','[{old_price,[{1,0,1440}]},{now_price,[{1,0,288}]},{icon,[wz01]}]',1,'[{0,32020123,12},{0,32020113,48},{0,38180010,1},{0,38180001,1},{3,36030001,500000},{2,36020001,88}]'),(41,12,2,'首饰套装礼包','消耗688钻石购买获得','[{old_price,[{1,0,2298}]},{now_price,[{1,0,688}]},{icon,[wz01]}]',1,'[{0,32020124,4},{0,32020114,16},{0,38180010,2},{0,38180001,2},{3,36030001,1000000},{2,36020001,188}]'),(41,12,3,'粉装锻造礼包','消耗1288钻石购买获得','[{old_price,[{1,0,3220}]},{now_price,[{1,0,1288}]},{icon,[wz01]}]',1,'[{0,38280510,2},{0,38280520,2},{0,38180010,5},{0,38180001,5},{3,36030001,2000000},{2,36020001,488}]'),(41,21,1,'称号砸蛋','消耗288钻石购买获得','[{old_price,[{1,0,888}]},{now_price,[{1,0,288}]},{icon,[wz01]}]',1,'[{0,4917013,1},{0,38180015,188},{0,11040003,2},{0,38030003,1},{0,38220009,5},{2,36020001,108}]'),(41,21,2,'扭蛋发型','消耗588钻石购买获得','[{old_price,[{1,0,1888}]},{now_price,[{1,0,588}]},{fashion_model,[{1,12030011}, {2,12030011}, {3,12030011}, {4,12030011}]}]',1,'[{0,12030011,1},{0,38180012,10},{0,53030020,1},{0,54010001,10},{0,38220009,10},{2,36020001,158}]'),(41,21,3,'吃瓜群众','消耗888钻石购买获得','[{old_price,[{1,0,2888}]},{now_price,[{1,0,888}]},{icon,[wz01]}]',1,'[{0,38140007,1},{0,38150007,1},{0,17020003,1},{0,38180001,9},{0,38220009,15},{2,36020001,218}]'),(41,21,4,'巅峰寻宝','消耗1788钻石购买获得','[{old_price,[{1,0,6888}]},{now_price,[{1,0,1788}]},{fashion_model,[{1,12010011}, {2,12010011}, {3,12010011}, {4,12010011}]}]',1,'[{0,12010011,1},{0,38180012,5},{0,38180002,9},{0,38180016,1},{0,38220009,30},{2,36020001,418}]'),(41,21,5,'酷炫足迹','消耗2388钻石购买获得','[{old_price,[{1,0,8888}]},{now_price,[{1,0,2388}]},{fashion_model,[{1,12040002}, {2,12040002}, {3,12040002}, {4,12040002}]}]',1,'[{0,12040002,1},{0,17020004,1},{0,38180015,188},{0,38180012,10},{0,38220009,35},{2,36020001,618}]'),(42,1,1,'赤焰飓风','<color=#fba65a>战力+10000</color>','[{now_price, [{1,0,388}]}]',1,'[{100,16030001,1}]'),(42,1,2,'旋翼飞空艇','<color=#fba65a>战力+10000</color>','[{now_price, [{1,0,388}]}]',1,'[{100,16030002,1}]'),(42,1,3,'呆萌兔','<color=#fba65a>战力+20000</color>','[{now_price, [{1,0,388}]}]',1,'[{100,16030003,1}]'),(42,1,4,'旋翼飞空艇','<color=#fba65a>战力+50000</color>','[{now_price, [{1,0,388}]}]',1,'[{100,16030002,2}]'),(42,2,1,'宝具石','命中+1809','[{now_price, [{1,0,388}]}]',1,'[{100,24020001,1}]'),(42,2,2,'红色闪避魂珠','闪避+1809','[{now_price, [{1,0,388}]}]',1,'[{100,24020002,1}]'),(42,2,3,'宝具石','暴击+1809','[{now_price, [{1,0,388}]}]',1,'[{100,24020003,1}]'),(42,2,4,'宝具石','坚韧+1809','[{now_price, [{1,0,388}]}]',1,'[{100,24020004,1}]'),(42,3,1,'赤焰飓风','攻击+603','[{now_price, [{1,0,388}]}]',1,'[{100,16030001,1}]'),(42,3,2,'红色气血纹章','气血+14460','[{now_price, [{1,0,588}]},{icon,10}]',1,'[{100,28020004,1}]'),(42,3,3,'红色破甲纹章','破甲+723','[{now_price, [{1,0,588}]},{icon,11}]',1,'[{100,28030004,1}]'),(42,3,4,'红色防御纹章','防御+723','[{now_price, [{1,0,588}]},{icon,12}]',1,'[{100,28040004,1}]'),(42,4,1,'基础攻击纹章','基础攻击+33.8%','[{now_price, [{1,0,588}]},{icon,13}]',1,'[{100,28090004,1}]'),(42,4,2,'基础气血纹章','基础气血+33.8%','[{now_price, [{1,0,588}]},{icon,14}]',1,'[{100,28100004,1}]'),(42,4,3,'基础破甲纹章','基础破甲+67.5%','[{now_price, [{1,0,588}]},{icon,15}]',1,'[{100,28110004,1}]'),(42,4,4,'基础防御纹章','基础防御+67.5%','[{now_price, [{1,0,588}]},{icon,16}]',1,'[{100,28120004,1}]'),(43,1,1,'','','[{weight,2},{is_tv,1},{is_rare,1},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,18100005,1}]'),(43,1,2,'','','[{weight,4},{is_tv,1},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,18080001,1}]'),(43,1,3,'','','[{weight,4},{is_tv,1},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,18080002,1}]'),(43,1,4,'','','[{weight,10},{is_tv,1},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,18090004,1}]'),(43,1,5,'','','[{weight,65},{is_tv,0},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,18090003,1}]'),(43,1,6,'','','[{weight,100},{is_tv,0},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,18090002,6}]'),(43,1,7,'','','[{weight,100},{is_tv,0},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,18090002,4}]'),(43,1,8,'','','[{weight,100},{is_tv,0},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,18090002,2}]'),(43,1,9,'','','[{weight,10},{is_tv,1},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,18060004,1}]'),(43,1,10,'','','[{weight,65},{is_tv,0},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,18060003,1}]'),(43,1,11,'','','[{weight,100},{is_tv,0},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,18060002,6}]'),(43,1,12,'','','[{weight,100},{is_tv,0},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,18060002,4}]'),(43,1,13,'','','[{weight,100},{is_tv,0},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,18060002,2}]'),(43,1,14,'','','[{weight,50},{is_tv,0},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,18010001,1}]'),(43,1,15,'','','[{weight,50},{is_tv,0},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,18010002,1}]'),(43,1,16,'','','[{weight,20},{is_tv,1},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,18010003,1}]'),(43,1,17,'','','[{weight,60},{is_tv,0},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,38040010,1}]'),(43,1,18,'','','[{weight,60},{is_tv,0},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,38030003,1}]'),(43,1,101,'','','[{liveness,50}]',1,'[{100,38180011,1}]'),(43,1,102,'','','[{liveness,100}]',1,'[{100,38180011,1}]'),(43,1,103,'','','[{liveness,150}]',1,'[{100,38180011,1}]'),(43,2,1,'','','[{weight,6},{is_tv,1},{is_rare,1},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,32090012,1}]'),(43,2,2,'','','[{weight,50},{is_tv,0},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,32090011,1}]'),(43,2,3,'','','[{weight,200},{is_tv,0},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,32090010,1}]'),(43,2,4,'','','[{weight,2},{is_tv,1},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,46090004,1}]'),(43,2,5,'','','[{weight,10},{is_tv,1},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,46090003,1}]'),(43,2,6,'','','[{weight,40},{is_tv,0},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,46090002,1}]'),(43,2,7,'','','[{weight,65},{is_tv,0},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,46090001,2}]'),(43,2,8,'','','[{weight,65},{is_tv,0},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,46090001,1}]'),(43,2,9,'','','[{weight,2},{is_tv,1},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,46080004,1}]'),(43,2,10,'','','[{weight,10},{is_tv,0},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,46080003,1}]'),(43,2,11,'','','[{weight,40},{is_tv,0},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,46080002,1}]'),(43,2,12,'','','[{weight,10},{is_tv,1},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,46070003,1}]'),(43,2,13,'','','[{weight,80},{is_tv,0},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,46070002,1}]'),(43,2,14,'','','[{weight,100},{is_tv,0},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,46070001,3}]'),(43,2,15,'','','[{weight,100},{is_tv,0},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,46070001,2}]'),(43,2,16,'','','[{weight,100},{is_tv,0},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,46070001,1}]'),(43,2,17,'','','[{weight,60},{is_tv,0},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,38040010,1}]'),(43,2,18,'','','[{weight,60},{is_tv,0},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,38030003,1}]'),(43,2,101,'','','[{liveness,50}]',1,'[{100,38180011,1}]'),(43,2,102,'','','[{liveness,100}]',1,'[{100,38180011,1}]'),(43,2,103,'','','[{liveness,150}]',1,'[{100,38180011,1}]'),(43,3,1,'','','[{weight,5},{is_tv,1},{is_rare,1},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,32100002,1}]'),(43,3,2,'','','[{weight,15},{is_tv,0},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,50010001,1}]'),(43,3,3,'','','[{weight,15},{is_tv,1},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,50020001,1}]'),(43,3,4,'','','[{weight,15},{is_tv,1},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,50030001,1}]'),(43,3,5,'','','[{weight,15},{is_tv,1},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,50040001,1}]'),(43,3,6,'','','[{weight,15},{is_tv,1},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,50050001,1}]'),(43,3,7,'','','[{weight,15},{is_tv,1},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,50060001,1}]'),(43,3,8,'','','[{weight,10},{is_tv,1},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,32100004,1}]'),(43,3,9,'','','[{weight,10},{is_tv,1},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,32100005,1}]'),(43,3,10,'','','[{weight,30},{is_tv,0},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,18060004,1}]'),(43,3,11,'','','[{weight,75},{is_tv,0},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,18060003,1}]'),(43,3,12,'','','[{weight,200},{is_tv,0},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,18060002,2}]'),(43,3,13,'','','[{weight,200},{is_tv,0},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,18060002,1}]'),(43,3,14,'','','[{weight,120},{is_tv,0},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,18010001,1}]'),(43,3,15,'','','[{weight,120},{is_tv,0},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,18010002,1}]'),(43,3,16,'','','[{weight,20},{is_tv,0},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,18010003,1}]'),(43,3,17,'','','[{weight,60},{is_tv,0},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,38040010,1}]'),(43,3,18,'','','[{weight,60},{is_tv,0},{is_rare,0},{limit_type,0},{refresh_num,0},{limit_num,0}]',1,'[{100,38030003,1}]'),(43,3,101,'','','[{liveness,50}]',1,'[{100,38180011,1}]'),(43,3,102,'','','[{liveness,100}]',1,'[{100,38180011,1}]'),(43,3,103,'','','[{liveness,150}]',1,'[{100,38180011,1}]'),(44,1,1,'晋级王者赛区公会的会长','王者赛区公会会长','[]',1,'[{100,32010045,3},{100,14010004,1},{100,14020004,1}]'),(44,1,2,'晋级王者赛区公会的会员','王者赛区公会成员','[]',1,'[{100,32010045,2},{100,14010003,1},{100,14020003,1}]'),(44,1,3,'其他参与过的玩家','其他参与过的玩家','[]',1,'[{100,32010044,1},{100,14010002,1},{100,14020002,1}]'),(45,1,1,'白鸽速递专属包裹','白鸽速递专属包裹','[ {lv_region,[50,150]}, {vip_region,[0,1]}, {old_price,18}, {now_price,6} ]',3,'[{1,[{100,18020001,5},{100,16020001,5},{100,38100009,3},{100,32010033,1}]},{1,[{100,18020001,30},{100,38100009,3},{100,32010033,1}]},\n{1,[{100,16020001,15},{100,38100009,3},{100,32010033,1}]}]'),(45,1,2,'白鸽速递专属包裹','白鸽速递专属包裹','[ {lv_region,[151,250]}, {vip_region,[0,1]}, {old_price,18}, {now_price,6} ]',3,'[\n{1,[{100,18020001,5},{100,16020001,5},{100,38100009,3},{100,32010033,1}]},{1,[{100,37020002,2},{100,32010002,1},{100,32010033,5}]},\n{1,[{100,20010001,5},{100,24010001,5},{100,22010001,5},{100,32010033,5}]}\n]'),(45,1,3,'白鸽速递专属包裹','白鸽速递专属包裹','[ {lv_region,[251,320]}, {vip_region,[0,1]}, {old_price,20}, {now_price,6} ]',3,'[\n{1,[{100,18020001,5},{100,16020001,5},{100,14010001,4},{100,32010033,2}]},\n{1,[{100,18020001,5},{100,16020001,5},{100,14020001,4},{100,32010033,2}]}\n]'),(45,1,4,'白鸽速递专属包裹','白鸽速递专属包裹','[{lv_region,[50,150]}, {vip_region,[2,3]}, {old_price,68}, {now_price,30}]',3,'[\n{1,[{100,18020001,15},{100,16020001,15},{100,38040010,5},{100,32010033,5}]},{1,[{100,18020001,60},{100,38100009,8},{100,32010033,6}]},\n{1,[{100,16020001,30},{100,38100009,8},{100,32010033,6}]}\n]'),(45,1,5,'白鸽速递专属包裹','白鸽速递专属包裹','[{lv_region,[151,250]}, {vip_region,[2,3]}, {old_price,68}, {now_price,30}]',3,'[\n{1,[{100,16020001,30},{100,38100009,8},{100,32010033,6}]},\n{1,[{100,20010001,10},{100,24010001,10},{100,22010001,10},{100,32010033,5}]}\n]'),(45,1,6,'白鸽速递专属包裹','白鸽速递专属包裹','[{lv_region,[251,320]}, {vip_region,[2,3]}, {old_price,68}, {now_price,30}]',3,'[\n{1,[{100,14010001,8},{100,14020001,8},{100,32010033,2}]},\n{1,[{100,20010001,10},{100,24010001,10},{100,22010001,10},{100,32010033,5}]}\n]'),(45,1,7,'白鸽速递专属包裹','白鸽速递专属包裹','[{lv_region,[321,999]}, {vip_region,[0,3]}, {old_price,68}, {now_price,30}]',3,'[\n{1,[{100,18020001,15},{100,16020001,15},{100,32010033,10}]},\n{1,[{100,20010001,10},{100,24010001,10},{100,22010001,10},{100,32010033,10}]}\n]'),(45,1,8,'白鸽速递专属包裹','白鸽速递专属包裹','[{lv_region,[50,150]}, {vip_region,[4,6]}, {old_price,198}, {now_price,68}]',3,'[\n{1,[{100,16020002,5},{100,38040010,5},{100,16010001,1},{100,32010033,10}]},\n{1,[{100,18020002,10},{100,38040010,5},{100,18010001,1},{100,32010033,10}]},\n{1,[{100,18020002,6},{100,16020002,6},{100,38040010,5},{100,32010033,10}]}\n]'),(45,1,9,'白鸽速递专属包裹','白鸽速递专属包裹','[{lv_region,[151,250]}, {vip_region,[4,4]}, {old_price,198}, {now_price,68}]',3,'[\n{1,[{100,14010001,15},{100,18010001,1},{100,16010001,1},{100,32010033,10}]},\n{1,[{100,14020001,15},{100,18010001,1},{100,16010001,1},{100,32010033,10}]}\n]'),(45,1,10,'白鸽速递专属包裹','白鸽速递专属包裹','[{lv_region,[251,320]}, {vip_region,[4,4]}, {old_price,198}, {now_price,68}]',3,'[\n{1,[{100,14010001,15},{100,14020001,1},{100,32010033,10}]},\n{1,[{100,18020001,20},{100,16020001,20},{100,32010002,2},{100,32010033,10}]}\n]'),(45,1,11,'白鸽速递专属包裹','白鸽速递专属包裹','[{lv_region,[251,320]}, {vip_region,[5,8]}, {old_price,328}, {now_price,128}]',3,'[\n{1,[{100,18020002,10},{100,16020002,10},{100,32010013,5},{100,32010033,10}]},\n{1,[{100,14010003,1},{100,14020003,1},{100,32010013,5},{100,32010033,10}]}\n]'),(45,1,12,'白鸽速递专属包裹','白鸽速递专属包裹','[{lv_region,[321,999]}, {vip_region,[4,4]}, {old_price,198}, {now_price,68}]',3,'[\n{1,[{100,32010002,3},{100,38040002,1},{100,18010002,1},{100,32010033,20}]},\n{1,[{100,32010002,3},{100,38040002,1},{100,16010002,1},{100,32010033,20}]}\n]'),(45,1,13,'白鸽速递专属包裹','白鸽速递专属包裹','[{lv_region,[321,999]}, {vip_region,[5,8]}, {old_price,328}, {now_price,128}]',3,'[\n{1,[{100,18010001,1},{100,18010002,1},{100,32010013,10},{100,32010033,25}]},\n{1,[{100,16010001,1},{100,16010002,1},{100,32010013,10},{100,32010033,25}]}\n]'),(46,1,1,'投资购买立即领取','星灵投资','[{day,0},{gear,1},{timeout_cost, []}]',1,'[{0,18041103,5}]'),(46,1,2,'购买后第1天登陆领取','星灵投资','[{day,1},{gear,1},{timeout_cost, []}]',1,'[{0,18020001,10}]'),(46,1,3,'购买后第2天登陆领取','星灵投资','[{day,2},{gear,1},{timeout_cost, []}]',1,'[{0,18041103,2}]'),(46,1,4,'购买后第3天登陆领取','星灵投资','[{day,3},{gear,1},{timeout_cost, []}]',1,'[{0,18020001,10}]'),(46,1,5,'购买后第4天登陆领取','星灵投资','[{day,4},{gear,1},{timeout_cost, []}]',1,'[{0,18041103,3}]'),(46,1,6,'购买后第5天登陆领取','星灵投资','[{day,5},{gear,1},{timeout_cost, []}]',1,'[{0,18020001,10}]'),(46,1,7,'购买后第6天登陆领取','星灵投资','[{day,6},{gear,1},{timeout_cost, []}]',1,'[{0,38180015,38}]'),(46,1,8,'投资购买立即领取','扭蛋投资','[{day,0},{gear,2},{timeout_cost, []}]',1,'[{0,38180012,5}]'),(46,1,9,'购买后第1天登陆领取','扭蛋投资','[{day,1},{gear,2},{timeout_cost, []}]',1,'[{0,37020002,1}]'),(46,1,10,'购买后第2天登陆领取','扭蛋投资','[{day,2},{gear,2},{timeout_cost, []}]',1,'[{0,38180015,18}]'),(46,1,11,'购买后第3天登陆领取','扭蛋投资','[{day,3},{gear,2},{timeout_cost, []}]',1,'[{0,38180001,5}]'),(46,1,12,'购买后第4天登陆领取','扭蛋投资','[{day,4},{gear,2},{timeout_cost, []}]',1,'[{0,38180015,18}]'),(46,1,13,'购买后第5天登陆领取','扭蛋投资','[{day,5},{gear,2},{timeout_cost, []}]',1,'[{0,38180001,5}]'),(46,1,14,'购买后第6天登陆领取','扭蛋投资','[{day,6},{gear,2},{timeout_cost, []}]',1,'[{0,38180015,18}]'),(46,1,15,'投资购买立即领取','坐骑投资','[{day,0},{gear,3},{timeout_cost, []}]',1,'[{0,16090006,15}]'),(46,1,16,'购买后第1天登陆领取','坐骑投资','[{day,1},{gear,3},{timeout_cost, []}]',1,'[{0,16020001,15}]'),(46,1,17,'购买后第2天登陆领取','坐骑投资','[{day,2},{gear,3},{timeout_cost, []}]',1,'[{0,16090006,5}]'),(46,1,18,'购买后第3天登陆领取','坐骑投资','[{day,3},{gear,3},{timeout_cost, []}]',1,'[{0,16090006,5}]'),(46,1,19,'购买后第4天登陆领取','坐骑投资','[{day,4},{gear,3},{timeout_cost, []}]',1,'[{0,16020001,15}]'),(46,1,20,'购买后第6天登陆领取','坐骑投资','[{day,5},{gear,3},{timeout_cost, []}]',1,'[{0,16020001,15}]'),(46,1,21,'购买后第6天登陆领取','坐骑投资','[{day,6},{gear,3},{timeout_cost, []}]',1,'[{0,16090006,5}]'),(47,1,2,'欢乐储值699','欢乐储值699','[{gold,699}]',1,'[{100,38140003,3},{100,38150003,3},{100,38100004,1},{100,40010001,2},{100,40010011,20}]'),(47,1,3,'欢乐储值999','欢乐储值999','[{gold,999}]',1,'[{100,38140003,7},{100,38150003,7},{100,38100005,1},{100,40010001,3},{100,40010011,21}]'),(47,1,4,'欢乐储值1299','欢乐储值1299','[{gold,1299}]',1,'[{100,38140003,3},{100,38150003,3},{100,38100004,1},{100,40010001,2},{100,40010011,21}]'),(47,1,5,'欢乐储值1699','欢乐储值1699','[{gold,1699}]',1,'[{100,38140003,7},{100,38150003,7},{100,38100005,1},{100,40010001,3},{100,40010011,22}]'),(48,1,1,'每日单笔储值60','每日单笔储值60','[{gold_range,[60,299]},{times_lim,3}]',1,'[{100,38140003,7},{100,38150003,7},{100,38100005,1},{100,40010001,3},{100,40010011,20}]'),(48,1,2,'每日单笔储值300','每日单笔储值300','[{gold_range,[300,599]},{times_lim,6}]',1,'[{100,38140003,3},{100,38150003,3},{100,38100004,1},{100,40010001,2},{100,40010011,20}]'),(48,1,3,'每日单笔储值600','每日单笔储值600','[{gold_range,[600,1299]},{times_lim,9}]',1,'[{100,38140003,7},{100,38150003,7},{100,38100005,1},{100,40010001,3},{100,40010011,20}]'),(48,1,4,'每日单笔储值1300','每日单笔储值1300','[{gold_range,[1300,1999]},{times_lim,12}]',1,'[{100,38140003,3},{100,38150003,3},{100,38100004,1},{100,40010001,2},{100,40010011,20}]'),(48,1,5,'每日单笔储值2000','每日单笔储值2000','[{gold_range,[2000,9999]},{times_lim,15}]',1,'[{100,38140003,3},{100,38150003,3},{100,38100004,1},{100,40010001,2},{100,40010011,20}]'),(51,1,1,'一等奖奖励','一等奖奖励','[]',1,'[{0,16030004,1}]'),(51,1,2,'二等奖奖励','二等奖奖励','[]',1,'[{0,18040005,1}]'),(51,1,3,'三等奖奖励','三等奖奖励','[]',1,'[{0,12040015,1}]'),(53,1,1,'第一名奖励','第一名奖励','[]',1,'[{100,20030009,1}]'),(53,1,2,'第二、三名奖励','第二、三名奖励','[]',1,'[{100,20030008,1}]'),(53,1,3,'第四至十名奖励','第四至十名奖励','[]',1,'[{100,20030007,1}]'),(53,1,14,'参与奖','参与奖','[]',1,'[{100,20030006,1}]'),(54,1,1,'累积在线3分钟奖励','累积在线3分钟奖励','[{onlinetime,3}]',1,'[{3,36030001,3000}]'),(54,1,2,'累积在线5分钟奖励','累积在线5分钟奖励','[{onlinetime,5}]',1,'[{3,36030001,5000}]'),(54,1,3,'累积在线10分钟奖励','累积在线10分钟奖励','[{onlinetime,10}]',1,'[{3,36030001,10000}]'),(54,1,4,'累积在线30分钟奖励','累积在线30分钟奖励','[{onlinetime,30}]',1,'[{3,36030001,30000}]'),(54,1,5,'累积在线40分钟奖励','累积在线40分钟奖励','[{onlinetime,40}]',1,'[{3,36030001,40000}]'),(54,1,6,'累积在线60分钟奖励','累积在线60分钟奖励','[{onlinetime,60}]',1,'[{3,36030001,60000}]'),(54,2,1,'在线1分钟','在线一分钟','[{onlinetime,1}]',1,'[{3,36030001,3000}]'),(54,2,2,'在线3分钟','在线3分钟','[{onlinetime,3}]',1,'[{3,36030001,3000}]'),(54,2,3,'在线5分钟','在线5分钟','[{onlinetime,5}]',1,'[{3,36030001,3000}]'),(55,1,1,'特等奖','特等奖1','[{reward_lv, 0}, {weight,50}, {effect, 4}, {broadcast, 1}]',1,'[{2,36020001,6888}]'),(55,1,2,'一等奖','一等奖1','[{reward_lv, 1}, {weight, 100}, {effect, 3}, {broadcast, 1}]',1,'[{2,36020001,688}]'),(55,1,3,'一等奖','一等奖2','[{reward_lv, 1}, {weight, 100}, {effect, 3}, {broadcast, 1}]',1,'[{0,38180010,3}]'),(55,1,4,'二等奖','二等奖1','[{reward_lv, 2}, {weight, 500}, {effect, 3}, {broadcast, 1}]',1,'[{2,36020001,188}]'),(55,1,5,'二等奖','二等奖2','[{reward_lv, 2}, {weight, 500}, {effect, 3}, {broadcast, 0}]',1,'[{0,38180010,1}]'),(55,1,6,'二等奖','二等奖3','[{reward_lv, 2}, {weight, 500}, {effect, 3}, {broadcast, 0}]',1,'[{0,38180001,1}]'),(55,1,7,'三等奖','三等奖1','[{reward_lv, 3}, {weight, 2000}, {effect, 2}, {broadcast, 0}]',1,'[{2,36020001,20}]'),(55,1,8,'三等奖','三等奖2','[{reward_lv, 3}, {weight, 2000}, {effect, 1}, {broadcast, 0}]',1,'[{0,18020001,3}]'),(55,1,9,'三等奖','三等奖3','[{reward_lv, 3}, {weight, 2000}, {effect, 1}, {broadcast, 0}]',1,'[{0,11020001,3}]'),(55,1,10,'三等奖','三等奖2','[{reward_lv, 3}, {weight, 2000}, {effect, 2}, {broadcast, 0}]',1,'[{0,38330003,2}]'),(55,1,101,'每日登录','[]','[]',1,'[{100,38180011,1}]'),(55,1,102,'充值任意金额','159,1','[]',1,'[{100,38180011,1}]'),(55,1,103,'活跃度','999,3','[]',1,'[{100,38180011,1}]'),(56,1,1,'活跃度达到30','活跃度达到30','[{need_live,30}]',1,'[{101,38180015,5,[{expire_time, 172800}]}]'),(56,1,2,'活跃度达到60','活跃度达到60','[{need_live,60}]',1,'[{101,38180015,5,[{expire_time,172800}]},{101,38180015,5,[{expire_time,172800}]}]'),(56,1,3,'活跃度达到90','活跃度达到90','[{need_live,90}]',1,'[{101,38180015,10,[{expire_time,172800}]},{101,38180015,5,[{expire_time,172800}]},{101,38180015,5,[{expire_time,172800}]}]'),(56,1,4,'活跃度达到120','活跃度达到120','[{need_live,120}]',1,'[{101,38180015,10,[{expire_time,172800}]},{101,38180015,10,[{expire_time,172800}]},{101,38180015,5,[{expire_time,172800}]},{101,38180015,5,[{expire_time,172800}]}]'),(56,2,1,'活跃度达到30','活跃度达到30','[{need_live,30}]',1,'[{101,38180015,4,[{expire_time,172800}]}]'),(56,2,2,'活跃度达到60','活跃度达到60','[{need_live,60}]',1,'[{101,38180015,4,[{expire_time,172800}]},{101,38180015,3,[{expire_time,172800}]}]'),(56,2,3,'活跃度达到90','活跃度达到90','[{need_live,90}]',1,'[{101,38180015,4,[{expire_time,172800}]},{101,38180015,4,[{expire_time,172800}]},{101,38180015,2,[{expire_time,172800}]}]'),(56,2,4,'活跃度达到120','活跃度达到120','[{need_live,120}]',1,'[{101,38180015,4,[{expire_time,172800}]},{101,38180015,4,[{expire_time,172800}]},{101,38180015,4,[{expire_time,172800}]},{101,38180015,2,[{expire_time,172800}]}]'),(57,1,1,'充值有礼','充值有礼','[{recharge, 300}]',1,'[{100,38140007,1},{100,38150007,1},{100,20020001,1},{100,37020002,1}]'),(58,1,1,'1','1','[{wlv, [1,1000]}, {weight, 150}, {is_tv, 0}]',1,'[{100,14010101,1}]'),(58,1,2,'2','2','[{wlv, [1,1000]}, {weight, 30}, {is_tv, 1}]',1,'[{100,14010104,1}]'),(58,1,3,'3','3','[{wlv, [1,1000]}, {weight, 100}, {is_tv, 0}]',1,'[{100,14010102,1}]'),(58,1,4,'4','4','[{wlv, [1,1000]}, {weight, 50}, {is_tv, 1}]',1,'[{100,14010103,1}]'),(58,1,5,'5','5','[{wlv, [1,1000]}, {weight, 20}, {is_tv, 1}]',1,'[{100,14010105,1}]'),(58,1,6,'6','6','[{wlv, [1,1000]}, {weight, 150}, {is_tv, 0}]',1,'[{100,14020201,1}]'),(58,1,7,'7','7','[{wlv, [1,1000]}, {weight, 100}, {is_tv, 0}]',1,'[{100,14020202,1}]'),(58,1,8,'8','8','[{wlv, [1,1000]}, {weight, 50}, {is_tv, 1}]',1,'[{100,14020203,1}]'),(59,1,1,'第一天第一档','等级','[{day, 1}, {target_type, 9}, {first_val,150}]',1,'[{100,20060001,5}]'),(59,1,2,'第一天第二档','等级','[{day, 1}, {target_type, 9}, {first_val,170}]',1,'[{100,20060001,5},{100,20060001,5}]'),(59,1,3,'第一天第三档','等级','[{day, 1}, {target_type, 9}, {first_val,185}]',1,'[{100,20060001,5},{100,20060001,5},{100,20060001,5}]'),(59,1,4,'第一天第四档','等级','[{day, 1}, {target_type, 9}, {first_val,195}]',1,'[{100,20060001,10},{100,20060001,5},{100,20060001,5},{100,38180001,5}]'),(59,2,1,'第二天第一档','等级','[{day,1},{target_type,9},{first_val, 200}]',1,'[{100,24010001,5}]'),(59,2,2,'第二天第二档','等级','[{day,1},{target_type,9},{first_val, 215}]',1,'[{100,24010001,5},{100,24010001,5}]'),(59,2,3,'第二天第三档','等级','[{day,1},{target_type,9},{first_val, 225}]',1,'[{100,24010001,5},{100,24010001,5},{100,24010001,5}]'),(59,2,4,'第二天第四档','等级','[{day,1},{target_type,9},{first_val, 235}]',1,'[{100,24010001,10},{100,24010001,5},{100,24010001,5},{100,38180010,3}]'),(59,3,1,'第三天第一档','坐骑战力','[{day,1},{target_type, 3},{first_val, 30000}]',1,'[{100,16020001,5}]'),(59,3,2,'第三天第二档','坐骑战力','[{day,1},{target_type, 3},{first_val, 60000}]',1,'[{100,16020001,5},{100,16020001,5}]'),(59,3,3,'第三天第三档','坐骑战力','[{day,1},{target_type, 3},{first_val, 100000}]',1,'[{100,16020001,5},{100,16020001,5},{100,16020001,5}]'),(59,3,4,'第三天第四档','坐骑战力','[{day,1},{target_type, 3},{first_val, 145000}]',1,'[{100,16020001,10},{100,16020001,5},{100,16020001,5},{100,24031003,2}]'),(59,4,1,'第四天第一档','降神战力','[{day,1},{target_type, 1},{first_val, 40000}]',1,'[{100,11020001,5},{100,32160020,1}]'),(59,4,2,'第四天第二档','降神战力','[{day,1},{target_type, 1},{first_val, 60000}]',1,'[{100,11020001,5},{100,11020001,5},{100,32160020,1}]'),(59,4,3,'第四天第三档','降神战力','[{day,1},{target_type, 1},{first_val, 100000}]',1,'[{100,11020001,5},{100,11020001,5},{100,11020001,5},{100,32160020,1}]'),(59,4,4,'第四天第四档','降神战力','[{day,1},{target_type, 1},{first_val, 150000}]',1,'[{100,11020001,10},{100,11020001,5},{100,11020001,5},{100,24031003,2}]'),(59,5,1,'第五天第一档','魂珠战力','[{day,1},{target_type, 10},{first_val, 70000}]',1,'[{100,5203003,2}]'),(59,5,2,'第五天第二档','魂珠战力','[{day,1},{target_type, 10},{first_val, 80000}]',1,'[{100,5203004,1},{100,5203003,1}]'),(59,5,3,'第五天第三档','魂珠战力','[{day,1},{target_type, 10},{first_val, 120000}]',1,'[{100,5203004,1},{100,5203003,3}]'),(59,5,4,'第五天第四档','魂珠战力','[{day,1},{target_type, 10},{first_val, 250000}]',1,'[{100,5203004,5},{100,5203003,3},{100,24031003,2}]'),(59,6,1,'第六天第一档1','装备战力','[{day,1},{target_type, 11},{first_val, 1000000}]',1,'[{100,32020111,2},{100,38260001,10}]'),(59,6,2,'第六天第二档1','装备战力','[{day,1},{target_type, 11},{first_val, 1200000}]',1,'[{100,32020111,5},{100,38260001,20}]'),(59,6,3,'第六天第三档1','装备战力','[{day,1},{target_type, 11},{first_val, 1600000}]',1,'[{100,32020111,5},{100,32020111,5},{100,38260001,30}]'),(59,6,4,'第六天第四档1','装备战力','[{day,1},{target_type, 11},{first_val, 2000000}]',1,'[{100,32020111,10},{100,32020111,5},{100,38260001,50},{100,24031003,2}]'),(59,7,1,'第六天第一档2','宝石总等级','[{day,1},{target_type, 12},{first_val, 30}]',1,'[{100,14010102,1},{100,14020202,1}]'),(59,7,2,'第六天第二档2','宝石总等级','[{day,1},{target_type, 12},{first_val, 60}]',1,'[{100,14010102,2},{100,14020202,2}]'),(59,7,3,'第六天第三档2','宝石总等级','[{day,1},{target_type, 12},{first_val, 80}]',1,'[{100,14010103,1},{100,14020203,1}]'),(59,7,4,'第六天第四档2','宝石总等级','[{day,1},{target_type, 12},{first_val, 100}]',1,'[{100,14010104,1},{100,14020204,1}]'),(59,8,1,'第七天第一档','角色战力','[{day,1}, {target_type, 7}, {first_val,2200000}]',1,'[{100,53020010,5},{100,38260001,10}]'),(59,8,2,'第七天第二档','角色战力','[{day,1}, {target_type, 7}, {first_val,2600000}]',1,'[{100,53020010,10},{100,38260001,20}]'),(59,8,3,'第七天第三档','角色战力','[{day,1}, {target_type, 7}, {first_val,3200000}]',1,'[{100,53020010,10},{100,53020010,5},{100,38260001,30}]'),(59,8,4,'第七天第四档','角色战力','[{day,1}, {target_type, 7}, {first_val,4000000}]',1,'[{100,53020010,10},{100,53020010,5},{100,53020010,5},{100,24031003,2}]'),(59,9,1,'第八天第一档','降神战力','[{day,1},{target_type, 1},{first_val, 80000}]',1,'[{101,11020001,6,[{expire_time,86400}]}]'),(59,9,2,'第八天第二档','降神战力','[{day,1},{target_type, 1},{first_val, 150000}]',1,'[{101,11020001,8,[{expire_time,86400}]}]'),(59,9,3,'第八天第三档','降神战力','[{day,1},{target_type, 1},{first_val, 200000}]',1,'[{101,11020001,10,[{expire_time,86400}]}]'),(59,9,4,'第八天第四档','降神战力','[{day,1},{target_type, 1},{first_val, 250000}]',1,'[{101,11020001,12,[{expire_time,86400}]},{100,32160020,1}]'),(59,9,5,'第八天第五档','降神战力','[{day,1},{target_type, 1},{first_val, 300000}]',1,'[{101,11020001,15,[{expire_time,86400}]},{100,32160019,1}]'),(59,9,6,'第八天第六档','降神战力','[{day,1},{target_type, 1},{first_val, 350000}]',1,'[{101,11020001,18,[{expire_time,86400}]},{100,32160018,1},{100,24020001,1}]'),(59,9,7,'第八天第七档','降神战力','[{day,1},{target_type, 1},{first_val, 400000}]',1,'[{101,11020001,21,[{expire_time,86400}]},{100,32160018,1},{100,24020001,1},{100,24020002,1}]'),(59,10,1,'第9-10天第一档2','星灵战力','[{day,1},{target_type, 2},{first_val, 60000}]',1,'[{101,18020001,10,[{expire_time,86400}]}]'),(59,10,2,'第9-10天第二档2','星灵战力','[{day,1},{target_type, 2},{first_val, 100000}]',1,'[{101,18020001,15,[{expire_time,86400}]}]'),(59,10,3,'第9-10天第三档2','星灵战力','[{day,1},{target_type, 2},{first_val, 150000}]',1,'[{101,18020001,20,[{expire_time,86400}]}]'),(59,10,4,'第9-10天第四档2','星灵战力','[{day,1},{target_type, 2},{first_val, 200000}]',1,'[{101,18020001,25,[{expire_time,86400}]}]'),(59,10,5,'第9-10天第五档2','星灵战力','[{day,1},{target_type, 2},{first_val, 250000}]',1,'[{101,18020001,30,[{expire_time,86400}]}]'),(59,10,6,'第9-10天第六档2','星灵战力','[{day,1},{target_type, 2},{first_val, 300000}]',1,'[{101,18020001,35,[{expire_time,86400}]},{100,16010001,1}]'),(59,10,7,'第9-10天第七档2','星灵战力','[{day,1},{target_type, 2},{first_val, 350000}]',1,'[{101,18020001,40,[{expire_time,86400}]},{100,16010001,1},{100,16010002,1}]'),(59,11,1,'第11-12天第一档','降神战力','[{day,1},{target_type, 1},{first_val, 80000}]',1,'[{101,11020001,8,[{expire_time,86400}]}]'),(59,11,2,'第11-12天第二档','降神战力','[{day,1},{target_type, 1},{first_val, 200000}]',1,'[{101,11020001,10,[{expire_time,86400}]}]'),(59,11,3,'第11-12天第三档','降神战力','[{day,1},{target_type, 1},{first_val, 280000}]',1,'[{101,11020001,13,[{expire_time,86400}]}]'),(59,11,4,'第11-12天第四档','降神战力','[{day,1},{target_type, 1},{first_val, 350000}]',1,'[{101,11020001,18,[{expire_time,86400}]},{100,32160020,1}]'),(59,11,5,'第11-12天第五档','降神战力','[{day,1},{target_type, 1},{first_val, 420000}]',1,'[{101,11020001,24,[{expire_time,86400}]},{100,32160019,1}]'),(59,11,6,'第11-12天第六档','降神战力','[{day,1},{target_type, 1},{first_val, 480000}]',1,'[{101,11020001,27,[{expire_time,86400}]},{100,32160018,1},{100,24020001,1}]'),(59,11,7,'第11-12天第七档','降神战力','[{day,1},{target_type, 1},{first_val, 550000}]',1,'[{101,11020001,30,[{expire_time,86400}]},{100,32160018,1},{100,24020001,1},{100,24020002,1}]'),(59,12,1,'第13-14天第一档2','星灵战力','[{day,1},{target_type, 2},{first_val, 60000}]',1,'[{101,18020001,10,[{expire_time,86400}]}]'),(59,12,2,'第13-14天第二档2','星灵战力','[{day,1},{target_type, 2},{first_val, 150000}]',1,'[{101,18020001,15,[{expire_time,86400}]}]'),(59,12,3,'第13-14天第三档2','星灵战力','[{day,1},{target_type, 2},{first_val, 210000}]',1,'[{101,18020001,20,[{expire_time,86400}]}]'),(59,12,4,'第13-14天第四档2','星灵战力','[{day,1},{target_type, 2},{first_val, 280000}]',1,'[{101,18020001,25,[{expire_time,86400}]}]'),(59,12,5,'第13-14天第五档2','星灵战力','[{day,1},{target_type, 2},{first_val, 350000}]',1,'[{101,18020001,30,[{expire_time,86400}]}]'),(59,12,6,'第13-14天第六档2','星灵战力','[{day,1},{target_type, 2},{first_val, 420000}]',1,'[{101,18020001,35,[{expire_time,86400}]},{100,16010001,1}]'),(59,12,7,'第13-14天第七档2','星灵战力','[{day,1},{target_type, 2},{first_val, 480000}]',1,'[{101,18020001,40,[{expire_time,86400}]},{100,16010001,1},{100,16010002,1}]'),(59,13,1,'第15-16天第一档','坐骑战力','[{day,1},{target_type, 3},{first_val, 40000}]',1,'[{101,16020001,5,[{expire_time,86400}]}]'),(59,13,2,'第15-16天第二档','坐骑战力','[{day,1},{target_type, 3},{first_val, 120000}]',1,'[{101,16020001,9,[{expire_time,86400}]}]'),(59,13,3,'第15-16天第三档','坐骑战力','[{day,1},{target_type, 3},{first_val, 240000}]',1,'[{101,16020001,11,[{expire_time,86400}]}]'),(59,13,4,'第15-16天第四档','坐骑战力','[{day,1},{target_type, 3},{first_val, 360000}]',1,'[{101,16020001,13,[{expire_time,86400}]}]'),(59,13,5,'第15-16天第五档','坐骑战力','[{day,1},{target_type, 3},{first_val, 480000}]',1,'[{101,16020001,16,[{expire_time,86400}]}]'),(59,13,6,'第15-16天第六档','坐骑战力','[{day,1},{target_type, 3},{first_val, 600000}]',1,'[{101,16020001,22,[{expire_time,86400}]},{100,16010001,1}]'),(59,13,7,'第15-16天第七档','坐骑战力','[{day,1},{target_type, 3},{first_val, 750000}]',1,'[{101,16020001,24,[{expire_time,86400}]},{100,16010001,1},{100,16010002,1}]'),(59,14,1,'第17-18天第一档2','降神战力','[{day,1},{target_type, 1},{first_val, 80000}]',1,'[{101,11020001,8,[{expire_time,86400}]}]'),(59,14,2,'第17-18天第二档2','降神战力','[{day,1},{target_type, 1},{first_val, 280000}]',1,'[{101,11020001,10,[{expire_time,86400}]}]'),(59,14,3,'第17-18天第三档2','降神战力','[{day,1},{target_type, 1},{first_val, 360000}]',1,'[{101,11020001,13,[{expire_time,86400}]}]'),(59,14,4,'第17-18天第四档2','降神战力','[{day,1},{target_type, 1},{first_val, 440000}]',1,'[{101,11020001,18,[{expire_time,86400}]},{100,32160020,1}]'),(59,14,5,'第17-18天第五档2','降神战力','[{day,1},{target_type, 1},{first_val, 520000}]',1,'[{101,11020001,24,[{expire_time,86400}]},{100,32160019,1}]'),(59,14,6,'第17-18天第六档2','降神战力','[{day,1},{target_type, 1},{first_val, 600000}]',1,'[{101,11020001,27,[{expire_time,86400}]},{100,32160018,1},{100,24020001,1}]'),(59,14,7,'第17-18天第七档2','降神战力','[{day,1},{target_type, 1},{first_val, 700000}]',1,'[{101,11020001,30,[{expire_time,86400}]},{100,32160018,1},{100,24020001,1},{100,24020002,1}]'),(59,15,1,'第19-20天第一档','星灵战力','[{day,1},{target_type, 2},{first_val, 60000}]',1,'[{101,18020001,10,[{expire_time,86400}]}]'),(59,15,2,'第19-20天第二档','星灵战力','[{day,1},{target_type, 2},{first_val, 240000}]',1,'[{101,18020001,15,[{expire_time,86400}]}]'),(59,15,3,'第19-20天第三档','星灵战力','[{day,1},{target_type, 2},{first_val, 320000}]',1,'[{101,18020001,20,[{expire_time,86400}]}]'),(59,15,4,'第19-20天第四档','星灵战力','[{day,1},{target_type, 2},{first_val, 400000}]',1,'[{101,18020001,25,[{expire_time,86400}]}]'),(59,15,5,'第19-20天第五档','星灵战力','[{day,1},{target_type, 2},{first_val, 480000}]',1,'[{101,18020001,30,[{expire_time,86400}]}]'),(59,15,6,'第19-20天第六档','星灵战力','[{day,1},{target_type, 2},{first_val, 560000}]',1,'[{101,18020001,35,[{expire_time,86400}]},{100,16010001,1}]'),(59,15,7,'第19-20天第七档','星灵战力','[{day,1},{target_type, 2},{first_val, 650000}]',1,'[{101,18020001,40,[{expire_time,86400}]},{100,16010001,1},{100,16010002,1}]'),(59,16,1,'第21-22天第一档2','降神战力','[{day,1},{target_type, 1},{first_val, 80000}]',1,'[{101,11020001,8,[{expire_time,86400}]}]'),(59,16,2,'第21-22天第二档2','降神战力','[{day,1},{target_type, 1},{first_val, 360000}]',1,'[{101,11020001,10,[{expire_time,86400}]}]'),(59,16,3,'第21-22天第三档2','降神战力','[{day,1},{target_type, 1},{first_val, 460000}]',1,'[{101,11020001,13,[{expire_time,86400}]}]'),(59,16,4,'第21-22天第四档2','降神战力','[{day,1},{target_type, 1},{first_val, 560000}]',1,'[{101,11020001,18,[{expire_time,86400}]},{100,32160020,1}]'),(59,16,5,'第21-22天第五档2','降神战力','[{day,1},{target_type, 1},{first_val, 660000}]',1,'[{101,11020001,24,[{expire_time,86400}]},{100,32160019,1}]'),(59,16,6,'第21-22天第六档2','降神战力','[{day,1},{target_type, 1},{first_val, 760000}]',1,'[{101,11020001,27,[{expire_time,86400}]},{100,32160018,1},{100,24020001,1}]'),(59,16,7,'第21-22天第七档2','降神战力','[{day,1},{target_type, 1},{first_val, 860000}]',1,'[{101,11020001,30,[{expire_time,86400}]},{100,32160018,1},{100,24020001,1},{100,24020002,1}]'),(59,17,1,'第23-24天第一档','星灵战力','[{day,1},{target_type, 2},{first_val, 60000}]',1,'[{101,18020001,10,[{expire_time,86400}]}]'),(59,17,2,'第23-24天第二档','星灵战力','[{day,1},{target_type, 2},{first_val, 320000}]',1,'[{101,18020001,15,[{expire_time,86400}]}]'),(59,17,3,'第23-24天第三档','星灵战力','[{day,1},{target_type, 2},{first_val, 420000}]',1,'[{101,18020001,20,[{expire_time,86400}]}]'),(59,17,4,'第23-24天第四档','星灵战力','[{day,1},{target_type, 2},{first_val, 550000}]',1,'[{101,18020001,25,[{expire_time,86400}]}]'),(59,17,5,'第23-24天第五档','星灵战力','[{day,1},{target_type, 2},{first_val, 650000}]',1,'[{101,18020001,30,[{expire_time,86400}]}]'),(59,17,6,'第23-24天第六档','星灵战力','[{day,1},{target_type, 2},{first_val, 750000}]',1,'[{101,18020001,35,[{expire_time,86400}]},{100,16010001,1}]'),(59,17,7,'第23-24天第七档','星灵战力','[{day,1},{target_type, 2},{first_val, 850000}]',1,'[{101,18020001,40,[{expire_time,86400}]},{100,16010001,1},{100,16010002,1}]'),(59,18,1,'第25-26天第一档2','翅膀战力','[{day,1},{target_type, 13},{first_val, 50000}]',1,'[{101,20060001,3,[{expire_time,86400}]}]'),(59,18,2,'第25-26天第二档2','翅膀战力','[{day,1},{target_type, 13},{first_val, 120000}]',1,'[{101,20060001,4,[{expire_time,86400}]}]'),(59,18,3,'第25-26天第三档2','翅膀战力','[{day,1},{target_type, 13},{first_val, 200000}]',1,'[{101,20060001,5,[{expire_time,86400}]}]'),(59,18,4,'第25-26天第四档2','翅膀战力','[{day,1},{target_type, 13},{first_val, 300000}]',1,'[{101,20060001,8,[{expire_time,86400}]}]'),(59,18,5,'第25-26天第五档2','翅膀战力','[{day,1},{target_type, 13},{first_val, 400000}]',1,'[{101,20060001,10,[{expire_time,86400}]}]'),(59,18,6,'第25-26天第六档2','翅膀战力','[{day,1},{target_type, 13},{first_val, 500000}]',1,'[{101,20060001,12,[{expire_time,86400}]},{100,20020001,1}]'),(59,18,7,'第25-26天第七档2','翅膀战力','[{day,1},{target_type, 13},{first_val, 600000}]',1,'[{101,20060001,15,[{expire_time,86400}]},{100,20020001,1},{100,20020002,1}]'),(59,19,1,'第27-28天第一档','降神战力','[{day,1},{target_type, 1},{first_val, 80000}]',1,'[{101,11020001,8,[{expire_time,86400}]}]'),(59,19,2,'第27-28天第二档','降神战力','[{day,1},{target_type, 1},{first_val, 400000}]',1,'[{101,11020001,10,[{expire_time,86400}]}]'),(59,19,3,'第27-28天第三档','降神战力','[{day,1},{target_type, 1},{first_val, 520000}]',1,'[{101,11020001,13,[{expire_time,86400}]}]'),(59,19,4,'第27-28天第四档','降神战力','[{day,1},{target_type, 1},{first_val, 650000}]',1,'[{101,11020001,18,[{expire_time,86400}]},{100,32160020,1}]'),(59,19,5,'第27-28天第五档','降神战力','[{day,1},{target_type, 1},{first_val, 750000}]',1,'[{101,11020001,24,[{expire_time,86400}]},{100,32160019,1}]'),(59,19,6,'第27-28天第六档','降神战力','[{day,1},{target_type, 1},{first_val, 850000}]',1,'[{101,11020001,27,[{expire_time,86400}]},{100,32160018,1},{100,24020001,1}]'),(59,19,7,'第27-28天第七档','降神战力','[{day,1},{target_type, 1},{first_val, 1000000}]',1,'[{101,11020001,30,[{expire_time,86400}]},{100,32160018,1},{100,24020001,1},{100,24020002,1}]'),(59,20,1,'时装第1档','时装升星','[{day,1},{target_type, 8},{second_val, 1}]',1,'[{0,20060001,10},{0,38180015,25}]'),(59,20,2,'时装第2档','时装升星','[{day,1},{target_type, 8},{second_val, 2}]',1,'[{0,24010001,13},{0,38180015,30}]'),(59,20,3,'时装第3档','时装升星','[{day,1},{target_type, 8},{second_val, 4}]',1,'[{0,20060001,30},{0,38180015,40},{0,20020001,1}]'),(59,20,4,'时装第4档','时装升星','[{day,1},{target_type, 8},{second_val, 8}]',1,'[{0,24010001,35},{0,38180015,60},{0,24020001,1}]'),(59,20,5,'时装第5档','时装升星','[{day,1},{target_type, 8},{second_val, 14}]',1,'[{0,20060001,80},{0,38180015,80},{0,20020002,1},{0,20020001,1},{0,38180012,2}]'),(59,21,1,'时装第1档','时装升战','[{day,1},{target_type, 8},{first_val, 10000}]',1,'[{0,38260001,8},{0,40010011,2}]'),(59,21,2,'时装第2档','时装升战','[{day,1},{target_type, 8},{first_val, 50000}]',1,'[{0,38260001,20},{0,40010011,5}]'),(59,21,3,'时装第3档','时装升战','[{day,1},{target_type, 8},{first_val,80000}]',1,'[{0,38260001,30},{0,40010011,8}]'),(59,21,4,'时装第4档','时装升战','[{day,1},{target_type, 8},{first_val, 110000}]',1,'[{0,38260001,50},{0,40010011,10},{0,54010001,5}]'),(59,21,5,'时装第5档','时装升战','[{day,1},{target_type, 8},{first_val, 150000}]',1,'[{0,38260001,80},{0,40010011,15},{0,54010001,8}]'),(59,21,6,'时装第6档','时装升战','[{day,1},{target_type, 8},{first_val, 200000}]',1,'[{0,38260001,150},{0,40010011,20},{0,54010001,10},{0,32020113,5},{0,38180012,2}]'),(59,22,1,'时装第1档','时装升星','[{day,1},{target_type, 8},{second_val, 1}]',1,'[{0,20060001,10},{0,38180015,25}]'),(59,22,2,'时装第2档','时装升星','[{day,1},{target_type, 8},{second_val, 2}]',1,'[{0,24010001,13},{0,38180015,30}]'),(59,22,3,'时装第3档','时装升星','[{day,1},{target_type, 8},{second_val, 4}]',1,'[{0,20060001,30},{0,38180015,40},{0,20020001,1}]'),(59,22,4,'时装第4档','时装升星','[{day,1},{target_type, 8},{second_val, 8}]',1,'[{0,24010001,35},{0,38180015,60},{0,24020001,1},{0,38180012,1}]'),(59,23,1,'时装第1档','时装升星','[{day,1},{target_type, 8},{second_val, 1}]',1,'[{0,20060001,10},{0,38180015,25}]'),(59,23,2,'时装第2档','时装升星','[{day,1},{target_type, 8},{second_val, 2}]',1,'[{0,24010001,13},{0,38180015,30}]'),(59,23,3,'时装第3档','时装升星','[{day,1},{target_type, 8},{second_val, 4}]',1,'[{0,20060001,30},{0,38180015,40},{0,20020001,1}]'),(59,23,4,'时装第4档','时装升星','[{day,1},{target_type, 8},{second_val, 8}]',1,'[{0,24010001,35},{0,38180015,60},{0,24020001,1},{0,38180012,1}]'),(59,24,1,'时装第1档','时装升星','[{day,1},{target_type, 8},{second_val, 1}]',1,'[{0,20060001,10},{0,38180015,25}]'),(59,24,2,'时装第2档','时装升星','[{day,1},{target_type, 8},{second_val, 2}]',1,'[{0,24010001,13},{0,38180015,30}]'),(59,24,3,'时装第3档','时装升星','[{day,1},{target_type, 8},{second_val, 4}]',1,'[{0,20060001,30},{0,38180015,40},{0,20020001,1}]'),(59,24,4,'时装第4档','时装升星','[{day,1},{target_type, 8},{second_val, 8}]',1,'[{0,24010001,35},{0,38180015,60},{0,24020001,1},{0,38180012,1}]'),(59,25,1,'时装第1档','时装升星','[{day,1},{target_type, 8},{second_val, 1}]',1,'[{0,20060001,10},{0,38180015,25}]'),(59,25,2,'时装第2档','时装升星','[{day,1},{target_type, 8},{second_val, 2}]',1,'[{0,24010001,13},{0,38180015,30}]'),(59,25,3,'时装第3档','时装升星','[{day,1},{target_type, 8},{second_val, 4}]',1,'[{0,20060001,30},{0,38180015,40},{0,20020001,1}]'),(59,25,4,'时装第4档','时装升星','[{day,1},{target_type, 8},{second_val, 8}]',1,'[{0,24010001,35},{0,38180015,60},{0,24020001,1},{0,38180012,1}]'),(60,1,1,'降神积分','降神积分','[{score, 50}]',1,'[{100,11020001,10},{0,5203001,10},{3,36030001,500000}]'),(60,1,2,'降神积分','降神积分','[{score, 100}]',1,'[{0,11020001,20},{0,5203001,15},{3,36030001,800000},{0,5203002,10}]'),(60,1,3,'降神积分','降神积分','[{score, 200}]',1,'[{0,11020002,15},{0,5203001,20},{3,36030001,1200000},{0,5203002,15},{100,32160001,1}]'),(60,2,1,'星灵积分','星灵积分','[{score, 50}]',1,'[{0,18020001,10},{0,20060001,10},{3,36030001,500000}]'),(60,2,2,'星灵积分','星灵积分','[{score, 100}]',1,'[{0,18020001,20},{0,20060001,15},{3,36030001,800000},{0,20060002,8}]'),(60,2,3,'星灵积分','星灵积分','[{score, 200}]',1,'[{0,18020002,15},{0,20060001,20},{3,36030001,1200000},{0,20060002,12},{0,32160002,1}]'),(60,3,1,'坐骑积分','坐骑积分','[{score, 30}]',1,'[{0,16020001,8},{0,5203001,10},{3,36030001,500000}]'),(60,3,2,'坐骑积分','坐骑积分','[{score, 75}]',1,'[{0,16020001,12},{0,5203001,15},{3,36030001,800000},{0,5203002,10}]'),(60,3,3,'坐骑积分','坐骑积分','[{score, 150}]',1,'[{0,16020001,20},{0,5203001,20},{3,36030001,1200000},{0,5203002,15},{0,32160001,1}]'),(60,4,1,'圣灵积分','圣灵积分','[{score, 40}]',1,'[{0,15020101,10},{0,20060001,10},{3,36030001,500000}]'),(60,4,2,'圣灵积分','圣灵积分','[{score, 80}]',1,'[{0,15020101,15},{0,20060001,15},{3,36030001,800000},{0,20060002,8}]'),(60,4,3,'圣灵积分','圣灵积分','[{score, 160}]',1,'[{0,15020102,10},{0,20060001,20},{3,36030001,1200000},{0,20060002,12},{0,32160002,1}]'),(60,5,1,'宝具积分','宝具积分','[{score, 50}]',1,'[{0,24010001,10},{0,5203001,10},{3,36030001,500000}]'),(60,5,2,'宝具积分','宝具积分','[{score, 100}]',1,'[{0,24010001,20},{0,5203001,15},{3,36030001,800000},{0,5203002,10}]'),(60,5,3,'宝具积分','宝具积分','[{score, 200}]',1,'[{0,24010002,15},{0,5203001,20},{3,36030001,1200000},{0,5203002,15},{0,32160001,1}]'),(60,6,1,'降神积分','降神积分','[{score, 75}]',1,'[{0,11020001,20},{0,20060001,15},{3,36030001,750000}]'),(60,6,2,'降神积分','降神积分','[{score, 120}]',1,'[{0,11020002,15},{0,20060001,20},{3,36030001,1000000},{0,20060002,8}]'),(60,6,3,'降神积分','降神积分','[{score, 250}]',1,'[{0,11020002,25},{0,20060001,25},{3,36030001,1500000},{0,20060002,12},{0,32160002,1}]'),(60,7,1,'星灵积分','星灵积分','[{score, 80}]',1,'[{0,18020001,20},{0,5203001,15},{3,36030001,750000}]'),(60,7,2,'星灵积分','星灵积分','[{score, 135}]',1,'[{0,18020002,15},{0,5203001,20},{3,36030001,1000000},{0,5203002,10}]'),(60,7,3,'星灵积分','星灵积分','[{score, 270}]',1,'[{0,18020002,20},{0,5203001,25},{3,36030001,1500000},{0,5203002,15},{0,32160001,1}]'),(60,8,1,'坐骑积分','坐骑积分','[{score, 30}]',1,'[{0,16020001,10},{0,20060001,15},{3,36030001,750000}]'),(60,8,2,'坐骑积分','坐骑积分','[{score, 75}]',1,'[{0,16050001,300},{0,20060001,20},{3,36030001,1000000},{0,20060002,8}]'),(60,8,3,'坐骑积分','坐骑积分','[{score, 150}]',1,'[{0,16020001,24},{0,20060001,25},{3,36030001,1500000},{0,20060002,12},{0,32160002,1}]'),(60,9,1,'圣灵积分','圣灵积分','[{score, 30}]',1,'[{0,15020101,15},{0,32020112,30},{3,36030001,750000}]'),(60,9,2,'圣灵积分','圣灵积分','[{score, 90}]',1,'[{0,15020102,10},{0,32020113,20},{3,36030001,1000000},{0,5203002,10}]'),(60,9,3,'圣灵积分','圣灵积分','[{score, 180}]',1,'[{0,15020102,15},{0,32020112,50},{3,36030001,1500000},{0,5203002,15},{0,32160001,1}]'),(60,10,1,'宝具积分','宝具积分','[{score, 45}]',1,'[{0,24010001,15},{0,20060001,15},{3,36030001,750000}]'),(60,10,2,'宝具积分','宝具积分','[{score, 100}]',1,'[{0,24010001,25},{0,20060001,20},{3,36030001,1000000},{0,20060002,8}]'),(60,10,3,'宝具积分','宝具积分','[{score, 200}]',1,'[{0,24010002,15},{0,20060001,25},{3,36030001,1500000},{0,20060002,12},{0,32160002,1}]'),(60,11,1,'降神积分','降神积分','[{score, 90}]',1,'[{0,11020001,25},{0,5203001,20},{3,36030001,900000}]'),(60,11,2,'降神积分','降神积分','[{score, 160}]',1,'[{0,11020002,20},{0,5203001,25},{3,36030001,1200000},{0,5203002,10}]'),(60,11,3,'降神积分','降神积分','[{score, 320}]',1,'[{0,11020002,30},{0,5203001,30},{3,36030001,1750000},{0,5203002,15},{0,32160001,1}]'),(60,12,1,'星灵积分','星灵积分','[{score, 80}]',1,'[{0,18020001,25},{0,18060001,15},{3,36030001,900000}]'),(60,12,2,'星灵积分','星灵积分','[{score, 135}]',1,'[{0,18020002,18},{0,18060001,20},{3,36030001,1200000},{0,18060002,10}]'),(60,12,3,'星灵积分','星灵积分','[{score, 270}]',1,'[{0,18020002,24},{0,18060001,25},{3,36030001,1750000},{0,18060002,15},{0,32160003,1}]'),(60,13,1,'坐骑积分','坐骑积分','[{score, 30}]',1,'[{0,16020001,10},{255,16050001,150},{3,36030001,900000}]'),(60,13,2,'坐骑积分','坐骑积分','[{score, 75}]',1,'[{0,16020001,15},{0,16050001,200},{3,36030001,1200000},{0,5203002,10}]'),(60,13,3,'坐骑积分','坐骑积分','[{score, 150}]',1,'[{0,16020001,24},{0,16050001,250},{3,36030001,1750000},{0,5203002,15},{0,32160001,1}]'),(60,14,1,'圣灵积分','圣灵积分','[{score, 40}]',1,'[{0,15020101,15},{0,38260001,20},{3,36030001,900000}]'),(60,14,2,'圣灵积分','圣灵积分','[{score, 100}]',1,'[{0,15020102,10},{0,38260001,30},{3,36030001,1200000},{0,20060002,8}]'),(60,14,3,'圣灵积分','圣灵积分','[{score, 200}]',1,'[{0,15020102,15},{0,38260001,40},{3,36030001,1750000},{0,20060002,12},{0,32160002,1}]'),(60,15,1,'宝具积分','宝具积分','[{score, 45}]',1,'[{0,24010001,15},{0,5203001,20},{3,36030001,900000}]'),(60,15,2,'宝具积分','宝具积分','[{score, 100}]',1,'[{0,24010001,25},{0,5203001,25},{3,36030001,1200000},{0,5203002,10}]'),(60,15,3,'宝具积分','宝具积分','[{score, 200}]',1,'[{0,24010002,15},{0,5203001,30},{3,36030001,1750000},{0,5203002,15},{0,32160001,1}]'),(60,16,1,'降神积分','降神积分','[{score,40}]',1,'[{101,11020001,8,[{expire_time,86400}]}]'),(60,16,2,'降神积分','降神积分','[{score,60}]',1,'[{101,11020001,10,[{expire_time,86400}]},{100,38180015,20}]'),(60,16,3,'降神积分','降神积分','[{score,90}]',1,'[{101,11020001,12,[{expire_time,86400}]},{100,38180015,30}]'),(60,16,4,'降神积分','降神积分','[{score,120}]',1,'[{101,11020001,14,[{expire_time,86400}]},{100,38180015,30},{100,32160020,1}]'),(60,16,5,'降神积分','降神积分','[{score,160}]',1,'[{101,11020001,16,[{expire_time,86400}]},{100,38180015,50},{100,32160019,1}]'),(60,16,6,'降神积分','降神积分','[{score,200}]',1,'[{101,11020001,18,[{expire_time,86400}]},{100,38180015,80},{100,32160018,1},{100,24020001,1}]'),(60,16,7,'降神积分','降神积分','[{score,250}]',1,'[{101,11020001,20,[{expire_time,86400}]},{100,38180015,120},{100,32160018,1},{100,24020001,1},{100,24020002,1}]'),(60,17,1,'星灵积分','星灵积分','[{score,120}]',1,'[{101,18020001,15,[{expire_time,86400}]}]'),(60,17,2,'星灵积分','星灵积分','[{score,180}]',1,'[{101,18020001,20,[{expire_time,86400}]},{100,38180015,20}]'),(60,17,3,'星灵积分','星灵积分','[{score,240}]',1,'[{101,18020001,22,[{expire_time,86400}]},{100,38180015,30}]'),(60,17,4,'星灵积分','星灵积分','[{score,320}]',1,'[{101,18020001,24,[{expire_time,86400}]},{100,38180015,30}]'),(60,17,5,'星灵积分','星灵积分','[{score,400}]',1,'[{101,18020001,28,[{expire_time,86400}]},{100,38180015,50}]'),(60,17,6,'星灵积分','星灵积分','[{score,480}]',1,'[{101,18020001,32,[{expire_time,86400}]},{100,38180015,80},{100,16010001,1}]'),(60,17,7,'星灵积分','星灵积分','[{score,560}]',1,'[{101,18020001,36,[{expire_time,86400}]},{100,38180015,120},{100,16010001,1},{100,16010002,1}]'),(60,18,1,'降神积分','降神积分','[{score,60}]',1,'[{101,11020001,10,[{expire_time,86400}]}]'),(60,18,2,'降神积分','降神积分','[{score,100}]',1,'[{101,11020001,12,[{expire_time,86400}]},{100,38180015,20}]'),(60,18,3,'降神积分','降神积分','[{score,150}]',1,'[{101,11020001,15,[{expire_time,86400}]},{100,38180015,30}]'),(60,18,4,'降神积分','降神积分','[{score,200}]',1,'[{101,11020001,18,[{expire_time,86400}]},{100,38180015,30},{100,32160020,1}]'),(60,18,5,'降神积分','降神积分','[{score,250}]',1,'[{101,11020001,21,[{expire_time,86400}]},{100,38180015,50},{100,32160019,1}]'),(60,18,6,'降神积分','降神积分','[{score,300}]',1,'[{101,11020001,25,[{expire_time,86400}]},{100,38180015,80},{100,32160018,1},{100,24020001,1}]'),(60,18,7,'降神积分','降神积分','[{score,350}]',1,'[{101,11020001,30,[{expire_time,86400}]},{100,38180015,120},{100,32160018,1},{100,24020001,1},{100,24020002,1}]'),(60,19,1,'星灵积分','星灵积分','[{score,120}]',1,'[{101,18020001,15,[{expire_time,86400}]}]'),(60,19,2,'星灵积分','星灵积分','[{score,180}]',1,'[{101,18020001,20,[{expire_time,86400}]},{100,38180015,20}]'),(60,19,3,'星灵积分','星灵积分','[{score,240}]',1,'[{101,18020001,22,[{expire_time,86400}]},{100,38180015,30}]'),(60,19,4,'星灵积分','星灵积分','[{score,320}]',1,'[{101,18020001,24,[{expire_time,86400}]},{100,38180015,30}]'),(60,19,5,'星灵积分','星灵积分','[{score,400}]',1,'[{101,18020001,28,[{expire_time,86400}]},{100,38180015,50}]'),(60,19,6,'星灵积分','星灵积分','[{score,480}]',1,'[{101,18020001,32,[{expire_time,86400}]},{100,38180015,80},{100,16010001,1}]'),(60,19,7,'星灵积分','星灵积分','[{score,560}]',1,'[{101,18020001,36,[{expire_time,86400}]},{100,38180015,120},{100,16010001,1},{100,16010002,1}]'),(60,20,1,'坐骑积分','坐骑积分','[{score,10}]',1,'[{101,16020001,8,[{expire_time,86400}]}]'),(60,20,2,'坐骑积分','坐骑积分','[{score,25}]',1,'[{101,16020001,10,[{expire_time,86400}]},{100,38180015,20}]'),(60,20,3,'坐骑积分','坐骑积分','[{score,40}]',1,'[{101,16020001,11,[{expire_time,86400}]},{100,38180015,30}]'),(60,20,4,'坐骑积分','坐骑积分','[{score,60}]',1,'[{101,16020001,12,[{expire_time,86400}]},{100,38180015,30}]'),(60,20,5,'坐骑积分','坐骑积分','[{score,80}]',1,'[{101,16020001,14,[{expire_time,86400}]},{100,38180015,50}]'),(60,20,6,'坐骑积分','坐骑积分','[{score,100}]',1,'[{101,16020001,16,[{expire_time,86400}]},{100,38180015,80},{100,16010001,1}]'),(60,20,7,'坐骑积分','坐骑积分','[{score,120}]',1,'[{101,16020001,18,[{expire_time,86400}]},{100,38180015,120},{100,16010001,1},{100,16010002,1}]'),(60,21,1,'降神积分','降神积分','[{score,60}]',1,'[{101,11020001,10,[{expire_time,86400}]}]'),(60,21,2,'降神积分','降神积分','[{score,100}]',1,'[{101,11020001,12,[{expire_time,86400}]},{100,38180015,20}]'),(60,21,3,'降神积分','降神积分','[{score,150}]',1,'[{101,11020001,15,[{expire_time,86400}]},{100,38180015,30}]'),(60,21,4,'降神积分','降神积分','[{score,200}]',1,'[{101,11020001,18,[{expire_time,86400}]},{100,38180015,30},{100,32160020,1}]'),(60,21,5,'降神积分','降神积分','[{score,250}]',1,'[{101,11020001,21,[{expire_time,86400}]},{100,38180015,50},{100,32160019,1}]'),(60,21,6,'降神积分','降神积分','[{score,300}]',1,'[{101,11020001,25,[{expire_time,86400}]},{100,38180015,80},{100,32160018,1},{100,24020001,1}]'),(60,21,7,'降神积分','降神积分','[{score,350}]',1,'[{101,11020001,30,[{expire_time,86400}]},{100,38180015,120},{100,32160018,1},{100,24020001,1},{100,24020002,1}]'),(60,22,1,'星灵积分','星灵积分','[{score,120}]',1,'[{101,18020001,15,[{expire_time,86400}]}]'),(60,22,2,'星灵积分','星灵积分','[{score,180}]',1,'[{101,18020001,20,[{expire_time,86400}]},{100,38180015,20}]'),(60,22,3,'星灵积分','星灵积分','[{score,240}]',1,'[{101,18020001,22,[{expire_time,86400}]},{100,38180015,30}]'),(60,22,4,'星灵积分','星灵积分','[{score,320}]',1,'[{101,18020001,24,[{expire_time,86400}]},{100,38180015,30}]'),(60,22,5,'星灵积分','星灵积分','[{score,400}]',1,'[{101,18020001,28,[{expire_time,86400}]},{100,38180015,50}]'),(60,22,6,'星灵积分','星灵积分','[{score,480}]',1,'[{101,18020001,32,[{expire_time,86400}]},{100,38180015,80},{100,16010001,1}]'),(60,22,7,'星灵积分','星灵积分','[{score,560}]',1,'[{101,18020001,36,[{expire_time,86400}]},{100,38180015,120},{100,16010001,1},{100,16010002,1}]'),(60,23,1,'降神积分','降神积分','[{score,60}]',1,'[{101,11020001,10,[{expire_time,86400}]}]'),(60,23,2,'降神积分','降神积分','[{score,100}]',1,'[{101,11020001,12,[{expire_time,86400}]},{100,38180015,20}]'),(60,23,3,'降神积分','降神积分','[{score,150}]',1,'[{101,11020001,15,[{expire_time,86400}]},{100,38180015,30}]'),(60,23,4,'降神积分','降神积分','[{score,200}]',1,'[{101,11020001,18,[{expire_time,86400}]},{100,38180015,30},{100,32160020,1}]'),(60,23,5,'降神积分','降神积分','[{score,250}]',1,'[{101,11020001,21,[{expire_time,86400}]},{100,38180015,50},{100,32160019,1}]'),(60,23,6,'降神积分','降神积分','[{score,300}]',1,'[{101,11020001,25,[{expire_time,86400}]},{100,38180015,80},{100,32160018,1},{100,24020001,1}]'),(60,23,7,'降神积分','降神积分','[{score,350}]',1,'[{101,11020001,30,[{expire_time,86400}]},{100,38180015,120},{100,32160018,1},{100,24020001,1},{100,24020002,1}]'),(60,24,1,'星灵积分','星灵积分','[{score,120}]',1,'[{101,18020001,15,[{expire_time,86400}]}]'),(60,24,2,'星灵积分','星灵积分','[{score,180}]',1,'[{101,18020001,20,[{expire_time,86400}]},{100,38180015,20}]'),(60,24,3,'星灵积分','星灵积分','[{score,240}]',1,'[{101,18020001,22,[{expire_time,86400}]},{100,38180015,30}]'),(60,24,4,'星灵积分','星灵积分','[{score,320}]',1,'[{101,18020001,24,[{expire_time,86400}]},{100,38180015,30}]'),(60,24,5,'星灵积分','星灵积分','[{score,400}]',1,'[{101,18020001,28,[{expire_time,86400}]},{100,38180015,50}]'),(60,24,6,'星灵积分','星灵积分','[{score,480}]',1,'[{101,18020001,32,[{expire_time,86400}]},{100,38180015,80},{100,16010001,1}]'),(60,24,7,'星灵积分','星灵积分','[{score,560}]',1,'[{101,18020001,36,[{expire_time,86400}]},{100,38180015,120},{100,16010001,1},{100,16010002,1}]'),(60,25,1,'翅膀积分','翅膀积分','[{score,20}]',1,'[{101,20060001,4,[{expire_time,86400}]}]'),(60,25,2,'翅膀积分','翅膀积分','[{score,30}]',1,'[{101,20060001,5,[{expire_time,86400}]},{100,38180015,20}]'),(60,25,3,'翅膀积分','翅膀积分','[{score,45}]',1,'[{101,20060001,6,[{expire_time,86400}]},{100,38180015,30}]'),(60,25,4,'翅膀积分','翅膀积分','[{score,60}]',1,'[{101,20060001,8,[{expire_time,86400}]},{100,38180015,30}]'),(60,25,5,'翅膀积分','翅膀积分','[{score,80}]',1,'[{101,20060001,10,[{expire_time,86400}]},{100,38180015,50}]'),(60,25,6,'翅膀积分','翅膀积分','[{score,100}]',1,'[{101,20060001,12,[{expire_time,86400}]},{100,38180015,80},{100,20020001,1}]'),(60,25,7,'翅膀积分','翅膀积分','[{score,120}]',1,'[{101,20060001,14,[{expire_time,86400}]},{100,38180015,120},{100,20020001,1},{100,20020002,1}]'),(60,26,1,'降神积分','降神积分','[{score,60}]',1,'[{101,11020001,10,[{expire_time,86400}]}]'),(60,26,2,'降神积分','降神积分','[{score,100}]',1,'[{101,11020001,12,[{expire_time,86400}]},{100,38180015,20}]'),(60,26,3,'降神积分','降神积分','[{score,150}]',1,'[{101,11020001,15,[{expire_time,86400}]},{100,38180015,30}]'),(60,26,4,'降神积分','降神积分','[{score,200}]',1,'[{101,11020001,18,[{expire_time,86400}]},{100,38180015,30},{100,32160020,1}]'),(60,26,5,'降神积分','降神积分','[{score,250}]',1,'[{101,11020001,21,[{expire_time,86400}]},{100,38180015,50},{100,32160019,1}]'),(60,26,6,'降神积分','降神积分','[{score,300}]',1,'[{101,11020001,25,[{expire_time,86400}]},{100,38180015,80},{100,32160018,1},{100,24020001,1}]'),(60,26,7,'降神积分','降神积分','[{score,350}]',1,'[{101,11020001,30,[{expire_time,86400}]},{100,38180015,120},{100,32160018,1},{100,24020001,1},{100,24020002,1}]'),(61,1,1,'赤焰飓风','大奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 2},{is_effects,1},{is_tv,1}]',1,'[{0,16030001,1}]'),(61,1,2,'魔兽源石','珍稀奖励','[{wlv, [1,1000]},{reward_type, 0},{weight, 2},{is_effects,1},{is_tv,1}]',1,'[{0,16010004,1}]'),(61,1,3,'5级攻击宝石','珍稀奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 2},{is_effects,1},{is_tv,1}]',1,'[{0,14010105,1}]'),(61,1,4,'赤焰飓风碎片','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,1}]',1,'[{0,16090001,5}]'),(61,1,5,'巨兽源石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 20},{is_effects,1},{is_tv,1}]',1,'[{0,16010003,1}]'),(61,1,6,'4级攻击宝石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,1}]',1,'[{0,14010104,1}]'),(61,1,7,'4级生命宝石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,1}]',1,'[{0,14020204,1}]'),(61,1,8,'蛮兽源石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 25},{is_effects,1},{is_tv,0}]',1,'[{0,16010002,1}]'),(61,1,9,'赤焰飓风碎片','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 15},{is_effects,1},{is_tv,1}]',1,'[{0,16090001,2}]'),(61,1,10,'凶兽源石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 25},{is_effects,1},{is_tv,0}]',1,'[{0,16010001,1}]'),(61,1,11,'赤焰飓风碎片','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 22},{is_effects,1},{is_tv,1}]',1,'[{0,16090001,1}]'),(61,1,12,'初级坐骑树果','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 15},{is_effects,1},{is_tv,0}]',1,'[{0,16020001,10}]'),(61,1,13,'初级坐骑树果','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 25},{is_effects,1},{is_tv,0}]',1,'[{0,16020001,8}]'),(61,1,14,'2倍经验药水','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 20},{is_effects,1},{is_tv,0}]',1,'[{0,37020002,1}]'),(61,1,15,'紫色供养魂珠','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 60},{is_effects,1},{is_tv,0}]',1,'[{0,5203003,1}]'),(61,1,16,'初级坐骑树果','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 100},{is_effects,1},{is_tv,0}]',1,'[{0,16020001,5}]'),(61,1,17,'2级攻击宝石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 50},{is_effects,1},{is_tv,0}]',1,'[{0,14010102,1}]'),(61,1,18,'2级生命宝石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 50},{is_effects,1},{is_tv,0}]',1,'[{0,14020202,1}]'),(61,1,19,'初级坐骑树果','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 140},{is_effects,1},{is_tv,0}]',1,'[{0,16020001,3}]'),(61,1,20,'初级坐骑树果','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 397},{is_effects,1},{is_tv,0}]',1,'[{0,16020001,2}]'),(61,1,101,'凶兽源石','许愿10次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,10}]',1,'[{0,16010001,1}]'),(61,1,102,'蛮兽源石','许愿30次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,30}]',1,'[{0,16010002,2}]'),(61,1,103,'巨兽源石','许愿60次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,60}]',1,'[{0,16010003,1}]'),(61,1,104,'赤焰飓风碎片','许愿150次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,150}]',1,'[{0,16090001,15}]'),(61,2,1,'月神','大奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 1},{is_effects,1},{is_tv,1}]',1,'[{0,11010005,1}]'),(61,2,2,'碎片·月神','珍稀奖励','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,1}]',1,'[{0,11050004,5}]'),(61,2,3,'碎片·月牙天冲','珍稀奖励','[{wlv, [1,1000]},{reward_type, 0},{weight, 2},{is_effects,1},{is_tv,1}]',1,'[{0,11060004,15}]'),(61,2,4,'武器套装石宝箱','珍稀奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 2},{is_effects,1},{is_tv,0}]',1,'[{0,32020113,5}]'),(61,2,5,'碎片·月神','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 15},{is_effects,1},{is_tv,1}]',1,'[{0,11050004,2}]'),(61,2,6,'普通武器套装石箱','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 5},{is_effects,1},{is_tv,0}]',1,'[{0,32020113,3}]'),(61,2,7,'碎片·月牙天冲','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,1}]',1,'[{0,11060004,5}]'),(61,2,8,'4级攻击宝石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,1}]',1,'[{0,14010104,1}]'),(61,2,9,'4级生命宝石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,1}]',1,'[{0,14020204,1}]'),(61,2,10,'碎片·月牙天冲','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 15},{is_effects,1},{is_tv,1}]',1,'[{0,11060004,2}]'),(61,2,11,'普通防具套装石箱','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,0}]',1,'[{0,32020112,5}]'),(61,2,12,'2倍经验药水','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 20},{is_effects,1},{is_tv,0}]',1,'[{0,37020002,1}]'),(61,2,13,'碎片·月牙天冲','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 20},{is_effects,1},{is_tv,1}]',1,'[{0,11060004,1}]'),(61,2,14,'碎片·月神','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 20},{is_effects,1},{is_tv,1}]',1,'[{0,11050004,1}]'),(61,2,15,'普通防具套装石箱','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 60},{is_effects,1},{is_tv,0}]',1,'[{0,32020112,3}]'),(61,2,16,'初级神源之火','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 200},{is_effects,1},{is_tv,0}]',1,'[{0,11020001,3}]'),(61,2,17,'普通防具套装石箱','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 3},{is_effects,1},{is_tv,0}]',1,'[{0,32020112,10}]'),(61,2,18,'初级神源之火','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 100},{is_effects,1},{is_tv,0}]',1,'[{0,11020001,5}]'),(61,2,19,'普通防具套装石箱','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 90},{is_effects,1},{is_tv,0}]',1,'[{0,32020112,2}]'),(61,2,20,'初级神源之火','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 397},{is_effects,1},{is_tv,0}]',1,'[{0,11020001,2}]'),(61,2,101,'月神印记*6','许愿10次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,10}]',1,'[{0,11040005,6}]'),(61,2,102,'月神印记*10','许愿30次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,30}]',1,'[{0,11040005,10}]'),(61,2,103,'月神碎片*3','许愿60次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,60}]',1,'[{0,11050004,3}]'),(61,2,104,'月神碎片*12','许愿150次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,150}]',1,'[{0,11050004,12}]'),(61,3,1,'利维坦','大奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 2},{is_effects,1},{is_tv,1}]',1,'[{0,16030005,1}]'),(61,3,2,'魔兽源石','珍稀奖励','[{wlv, [1,1000]},{reward_type, 0},{weight, 2},{is_effects,1},{is_tv,1}]',1,'[{0,16010004,1}]'),(61,3,3,'5级攻击宝石','珍稀奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 2},{is_effects,1},{is_tv,1}]',1,'[{0,14010105,1}]'),(61,3,4,'利维坦碎片','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,1}]',1,'[{0,16090005,5}]'),(61,3,5,'巨兽源石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 20},{is_effects,1},{is_tv,1}]',1,'[{0,16010003,1}]'),(61,3,6,'4级攻击宝石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,1}]',1,'[{0,14010104,1}]'),(61,3,7,'4级生命宝石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,1}]',1,'[{0,14020204,1}]'),(61,3,8,'蛮兽源石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 25},{is_effects,1},{is_tv,0}]',1,'[{0,16010002,1}]'),(61,3,9,'利维坦碎片碎片','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 15},{is_effects,1},{is_tv,1}]',1,'[{0,16090005,2}]'),(61,3,10,'凶兽源石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 25},{is_effects,1},{is_tv,0}]',1,'[{0,16010001,1}]'),(61,3,11,'利维坦碎片碎片','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 22},{is_effects,1},{is_tv,1}]',1,'[{0,16090005,1}]'),(61,3,12,'初级坐骑树果','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 15},{is_effects,1},{is_tv,0}]',1,'[{0,16020001,10}]'),(61,3,13,'初级坐骑树果','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 25},{is_effects,1},{is_tv,0}]',1,'[{0,16020001,8}]'),(61,3,14,'2倍经验药水','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 20},{is_effects,1},{is_tv,0}]',1,'[{0,37020002,1}]'),(61,3,15,'橙色供养魂珠','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 60},{is_effects,1},{is_tv,0}]',1,'[{0,5203004,1}]'),(61,3,16,'初级坐骑树果','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 100},{is_effects,1},{is_tv,0}]',1,'[{0,16020001,5}]'),(61,3,17,'2级攻击宝石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 50},{is_effects,1},{is_tv,0}]',1,'[{0,14010102,1}]'),(61,3,18,'2级生命宝石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 50},{is_effects,1},{is_tv,0}]',1,'[{0,14020202,1}]'),(61,3,19,'初级坐骑树果','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 140},{is_effects,1},{is_tv,0}]',1,'[{0,16020001,3}]'),(61,3,20,'初级坐骑树果','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 397},{is_effects,1},{is_tv,0}]',1,'[{0,16020001,2}]'),(61,3,101,'凶兽源石','许愿10次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,10}]',1,'[{0,16010001,1}]'),(61,3,102,'蛮兽源石','许愿30次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,30}]',1,'[{0,16010002,2}]'),(61,3,103,'巨兽源石','许愿60次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,60}]',1,'[{0,16010003,1}]'),(61,3,104,'魔兽源石','许愿100次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,100}]',1,'[{0,16010004,1}]'),(61,4,1,'双子座','大奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 2},{is_effects,1},{is_tv,1}]',1,'[{0,18040004,1}]'),(61,4,2,'双子座碎片','珍稀奖励','[{wlv, [1,1000]},{reward_type, 0},{weight, 6},{is_effects,1},{is_tv,1}]',1,'[{0,18041004,4}]'),(61,4,3,'小宇宙星核','珍稀奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 2},{is_effects,1},{is_tv,1}]',1,'[{0,18030001,1}]'),(61,4,4,'双子座碎片','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 23},{is_effects,1},{is_tv,1}]',1,'[{0,18041004,1}]'),(61,4,5,'圣水印记','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 2},{is_effects,1},{is_tv,1}]',1,'[{0,18054401,1}]'),(61,4,6,'通用学习宝典','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 12},{is_effects,1},{is_tv,0}]',1,'[{0,18060003,5}]'),(61,4,7,'普通首饰套装石箱','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 3},{is_effects,1},{is_tv,0}]',1,'[{0,32020114,4}]'),(61,4,8,'4级攻击宝石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 8},{is_effects,1},{is_tv,1}]',1,'[{0,14010104,1}]'),(61,4,9,'通用学习手册','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 100},{is_effects,1},{is_tv,0}]',1,'[{0,18060002,5}]'),(61,4,10,'4级生命宝石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 8},{is_effects,1},{is_tv,1}]',1,'[{0,14020204,1}]'),(61,4,11,'双子座碎片','珍稀奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,1}]',1,'[{0,18041004,2}]'),(61,4,12,'普通首饰套装石箱','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 6},{is_effects,1},{is_tv,0}]',1,'[{0,32020114,2}]'),(61,4,13,'2倍经验药水','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 20},{is_effects,1},{is_tv,0}]',1,'[{0,37020002,1}]'),(61,4,14,'普通装备套装石箱','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 160},{is_effects,1},{is_tv,0}]',1,'[{0,32020111,2}]'),(61,4,15,'初级星辰之砂','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 8},{is_effects,1},{is_tv,0}]',1,'[{0,18020001,10}]'),(61,4,16,'普通首饰套装石箱','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,0}]',1,'[{0,32020114,1}]'),(61,4,17,'初级星辰之砂','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 50},{is_effects,1},{is_tv,0}]',1,'[{0,18020001,5}]'),(61,4,18,'初级星辰之砂','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 350},{is_effects,1},{is_tv,0}]',1,'[{0,18020001,3}]'),(61,4,19,'通用学习笔记','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 200},{is_effects,1},{is_tv,0}]',1,'[{0,18060001,5}]'),(61,4,101,'初级星辰之砂*5','许愿10次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,10}]',1,'[{0,18020001,5}]'),(61,4,102,'小萌羊碎片*4','许愿30次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,30}]',1,'[{0,18041001,4}]'),(61,4,103,'双子座碎片*2','许愿60次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,60}]',1,'[{0,18041004,2}]'),(61,4,104,'双子座碎片*3','许愿100次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,100}]',1,'[{0,18041004,3}]'),(61,5,1,'机械达人','大奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 2},{is_effects,1},{is_tv,1}]',1,'[{0,16030007,1}]'),(61,5,2,'魔兽源石','珍稀奖励','[{wlv, [1,1000]},{reward_type, 0},{weight, 2},{is_effects,1},{is_tv,1}]',1,'[{0,16010004,1}]'),(61,5,3,'5级攻击宝石','珍稀奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 2},{is_effects,1},{is_tv,1}]',1,'[{0,14010105,1}]'),(61,5,4,'机械达人碎片','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,1}]',1,'[{0,16090007,5}]'),(61,5,5,'巨兽源石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 20},{is_effects,1},{is_tv,1}]',1,'[{0,16010003,1}]'),(61,5,6,'4级攻击宝石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,1}]',1,'[{0,14010104,1}]'),(61,5,7,'4级生命宝石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,1}]',1,'[{0,14020204,1}]'),(61,5,8,'蛮兽源石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 25},{is_effects,1},{is_tv,0}]',1,'[{0,16010002,1}]'),(61,5,9,'机械达人碎片','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 15},{is_effects,1},{is_tv,1}]',1,'[{0,16090007,2}]'),(61,5,10,'凶兽源石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 25},{is_effects,1},{is_tv,0}]',1,'[{0,16010001,1}]'),(61,5,11,'机械达人碎片','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 22},{is_effects,1},{is_tv,1}]',1,'[{0,16090007,1}]'),(61,5,12,'初级坐骑树果','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 15},{is_effects,1},{is_tv,0}]',1,'[{0,16020001,10}]'),(61,5,13,'初级坐骑树果','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 25},{is_effects,1},{is_tv,0}]',1,'[{0,16020001,8}]'),(61,5,14,'2倍经验药水','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 20},{is_effects,1},{is_tv,0}]',1,'[{0,37020002,1}]'),(61,5,15,'橙色供养魂珠','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 60},{is_effects,1},{is_tv,0}]',1,'[{0,5203004,1}]'),(61,5,16,'初级坐骑树果','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 100},{is_effects,1},{is_tv,0}]',1,'[{0,16020001,5}]'),(61,5,17,'2级攻击宝石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 50},{is_effects,1},{is_tv,0}]',1,'[{0,14010102,1}]'),(61,5,18,'凶兽源石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 30},{is_effects,1},{is_tv,0}]',1,'[{0,16010001,1}]'),(61,5,101,'凶兽源石','许愿10次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,10}]',1,'[{0,16010001,1}]'),(61,5,102,'蛮兽源石','许愿30次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,30}]',1,'[{0,16010002,2}]'),(61,5,103,'巨兽源石','许愿60次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,60}]',1,'[{0,16010003,1}]'),(61,5,104,'魔兽源石','许愿100次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,100}]',1,'[{0,16010004,1}]'),(61,6,1,'波塞冬','大奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 1},{is_effects,1},{is_tv,1}]',1,'[{0,11010001,1}]'),(61,6,2,'碎片·波塞冬','珍稀奖励','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,1}]',1,'[{0,11050001,5}]'),(61,6,3,'碎片·海神三叉戟','珍稀奖励','[{wlv, [1,1000]},{reward_type, 0},{weight, 2},{is_effects,1},{is_tv,1}]',1,'[{0,11060001,15}]'),(61,6,4,'武器套装石宝箱','珍稀奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 2},{is_effects,1},{is_tv,0}]',1,'[{0,32020113,5}]'),(61,6,5,'碎片·波塞冬','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 15},{is_effects,1},{is_tv,1}]',1,'[{0,11050001,2}]'),(61,6,6,'普通武器套装石箱','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 5},{is_effects,1},{is_tv,0}]',1,'[{0,32020113,3}]'),(61,6,7,'碎片·海神三叉戟','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,1}]',1,'[{0,11060001,5}]'),(61,6,8,'4级攻击宝石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,1}]',1,'[{0,14010104,1}]'),(61,6,9,'4级生命宝石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,1}]',1,'[{0,14020204,1}]'),(61,6,10,'碎片·海神三叉戟','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 15},{is_effects,1},{is_tv,1}]',1,'[{0,11060001,2}]'),(61,6,11,'普通防具套装石箱','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,0}]',1,'[{0,32020112,5}]'),(61,6,12,'2倍经验药水','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 20},{is_effects,1},{is_tv,0}]',1,'[{0,37020002,1}]'),(61,6,13,'碎片·海神三叉戟','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 20},{is_effects,1},{is_tv,1}]',1,'[{0,11060001,1}]'),(61,6,14,'碎片·波塞冬','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 20},{is_effects,1},{is_tv,1}]',1,'[{0,11050001,1}]'),(61,6,15,'普通防具套装石箱','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 60},{is_effects,1},{is_tv,0}]',1,'[{0,32020112,3}]'),(61,6,16,'初级神源之火','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 200},{is_effects,1},{is_tv,0}]',1,'[{0,11020001,3}]'),(61,6,17,'普通防具套装石箱','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 3},{is_effects,1},{is_tv,0}]',1,'[{0,32020112,10}]'),(61,6,18,'初级神源之火','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 100},{is_effects,1},{is_tv,0}]',1,'[{0,11020001,5}]'),(61,6,19,'普通防具套装石箱','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 90},{is_effects,1},{is_tv,0}]',1,'[{0,32020112,2}]'),(61,6,101,'波塞冬印记*6','许愿10次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,10}]',1,'[{0,11040001,6}]'),(61,6,102,'波塞冬印记*10','许愿30次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,30}]',1,'[{0,11040001,10}]'),(61,6,103,'波塞冬碎片*2','许愿60次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,60}]',1,'[{0,11050001,2}]'),(61,6,104,'波塞冬碎片*6','许愿100次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,100}]',1,'[{0,11050001,6}]'),(61,7,1,'坐骑--猫咪飞椅','大奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 2},{is_effects,1},{is_tv,1}]',1,'[{0,16030008,1}]'),(61,7,2,'魔兽源石','珍稀奖励','[{wlv, [1,1000]},{reward_type, 0},{weight, 2},{is_effects,1},{is_tv,1}]',1,'[{0,16010004,1}]'),(61,7,3,'5级攻击宝石','珍稀奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 2},{is_effects,1},{is_tv,1}]',1,'[{0,14010105,1}]'),(61,7,4,'坐骑--猫咪飞椅碎片','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,1}]',1,'[{0,16090008,5}]'),(61,7,5,'巨兽源石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 20},{is_effects,1},{is_tv,1}]',1,'[{0,16010003,1}]'),(61,7,6,'4级攻击宝石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,1}]',1,'[{0,14010104,1}]'),(61,7,7,'4级生命宝石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,1}]',1,'[{0,14020204,1}]'),(61,7,8,'蛮兽源石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 25},{is_effects,1},{is_tv,0}]',1,'[{0,16010002,1}]'),(61,7,9,'坐骑--猫咪飞椅碎片','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 15},{is_effects,1},{is_tv,1}]',1,'[{0,16090008,2}]'),(61,7,10,'凶兽源石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 25},{is_effects,1},{is_tv,0}]',1,'[{0,16010001,1}]'),(61,7,11,'坐骑--猫咪飞椅碎片','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 22},{is_effects,1},{is_tv,1}]',1,'[{0,16090008,1}]'),(61,7,12,'初级坐骑树果','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 15},{is_effects,1},{is_tv,0}]',1,'[{0,16020001,10}]'),(61,7,13,'初级坐骑树果','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 25},{is_effects,1},{is_tv,0}]',1,'[{0,16020001,8}]'),(61,7,14,'2倍经验药水','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 20},{is_effects,1},{is_tv,0}]',1,'[{0,37020002,1}]'),(61,7,15,'橙色供养魂珠','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 60},{is_effects,1},{is_tv,0}]',1,'[{0,5203004,1}]'),(61,7,16,'初级坐骑树果','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 100},{is_effects,1},{is_tv,0}]',1,'[{0,16020001,5}]'),(61,7,17,'2级攻击宝石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 50},{is_effects,1},{is_tv,0}]',1,'[{0,14010102,1}]'),(61,7,18,'2级生命宝石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 50},{is_effects,1},{is_tv,0}]',1,'[{0,14020202,1}]'),(61,7,19,'初级坐骑树果','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 140},{is_effects,1},{is_tv,0}]',1,'[{0,16020001,3}]'),(61,7,20,'初级坐骑树果','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 397},{is_effects,1},{is_tv,0}]',1,'[{0,16020001,2}]'),(61,7,101,'凶兽源石','许愿10次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,10}]',1,'[{0,16010001,1}]'),(61,7,102,'蛮兽源石','许愿30次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,30}]',1,'[{0,16010002,2}]'),(61,7,103,'巨兽源石','许愿60次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,60}]',1,'[{0,16010003,1}]'),(61,7,104,'魔兽源石','许愿100次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,100}]',1,'[{0,16010004,1}]'),(61,8,1,'处女座','大奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 2},{is_effects,1},{is_tv,1}]',1,'[{0,18040007,1}]'),(61,8,2,'处女座碎片','珍稀奖励','[{wlv, [1,1000]},{reward_type, 0},{weight, 6},{is_effects,1},{is_tv,1}]',1,'[{0,18041007,4}]'),(61,8,3,'小宇宙星核','珍稀奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 2},{is_effects,1},{is_tv,1}]',1,'[{0,18030001,1}]'),(61,8,4,'处女座碎片','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 23},{is_effects,1},{is_tv,1}]',1,'[{0,18041007,1}]'),(61,8,5,'圣水印记','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 2},{is_effects,1},{is_tv,1}]',1,'[{0,18054401,1}]'),(61,8,6,'通用学习宝典','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 12},{is_effects,1},{is_tv,0}]',1,'[{0,18060003,5}]'),(61,8,7,'普通首饰套装石箱','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 3},{is_effects,1},{is_tv,0}]',1,'[{0,32020114,4}]'),(61,8,8,'4级攻击宝石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 8},{is_effects,1},{is_tv,1}]',1,'[{0,14010104,1}]'),(61,8,9,'通用学习手册','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 100},{is_effects,1},{is_tv,0}]',1,'[{0,18060002,5}]'),(61,8,10,'4级生命宝石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 8},{is_effects,1},{is_tv,1}]',1,'[{0,14020204,1}]'),(61,8,11,'处女座碎片','珍稀奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,1}]',1,'[{0,18041007,2}]'),(61,8,12,'普通首饰套装石箱','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 6},{is_effects,1},{is_tv,0}]',1,'[{0,32020114,2}]'),(61,8,13,'2倍经验药水','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 20},{is_effects,1},{is_tv,0}]',1,'[{0,37020002,1}]'),(61,8,14,'普通装备套装石箱','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 160},{is_effects,1},{is_tv,0}]',1,'[{0,32020111,2}]'),(61,8,15,'初级星辰之砂','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 50},{is_effects,1},{is_tv,0}]',1,'[{0,18020001,5}]'),(61,8,16,'普通首饰套装石箱','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,0}]',1,'[{0,32020114,1}]'),(61,8,17,'初级星辰之砂','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 8},{is_effects,1},{is_tv,0}]',1,'[{0,18020001,10}]'),(61,8,18,'初级星辰之砂','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 350},{is_effects,1},{is_tv,0}]',1,'[{0,18020001,3}]'),(61,8,101,'初级星辰之砂*5','许愿10次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,10}]',1,'[{0,18020001,5}]'),(61,8,102,'小萌羊碎片*4','许愿30次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,30}]',1,'[{0,18041001,4}]'),(61,8,103,'处女座碎片*2','许愿60次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,60}]',1,'[{0,18041007,2}]'),(61,8,104,'处女座碎片*3','许愿100次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,100}]',1,'[{0,18041007,3}]'),(61,9,1,'魔法飞毯','大奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 2},{is_effects,1},{is_tv,1}]',1,'[{0,16030009,1}]'),(61,9,2,'魔兽源石','珍稀奖励','[{wlv, [1,1000]},{reward_type, 0},{weight, 2},{is_effects,1},{is_tv,1}]',1,'[{0,16010004,1}]'),(61,9,3,'5级攻击宝石','珍稀奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 2},{is_effects,1},{is_tv,1}]',1,'[{0,14010105,1}]'),(61,9,4,'魔法飞毯碎片','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,1}]',1,'[{0,16090009,5}]'),(61,9,5,'巨兽源石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 20},{is_effects,1},{is_tv,1}]',1,'[{0,16010003,1}]'),(61,9,6,'4级攻击宝石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,1}]',1,'[{0,14010104,1}]'),(61,9,7,'4级生命宝石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,1}]',1,'[{0,14020204,1}]'),(61,9,8,'蛮兽源石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 25},{is_effects,1},{is_tv,0}]',1,'[{0,16010002,1}]'),(61,9,9,'魔法飞毯碎片','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 15},{is_effects,1},{is_tv,1}]',1,'[{0,16090009,2}]'),(61,9,10,'凶兽源石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 25},{is_effects,1},{is_tv,0}]',1,'[{0,16010001,1}]'),(61,9,11,'魔法飞毯碎片','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 22},{is_effects,1},{is_tv,1}]',1,'[{0,16090009,1}]'),(61,9,12,'初级坐骑树果','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 15},{is_effects,1},{is_tv,0}]',1,'[{0,16020001,10}]'),(61,9,13,'初级坐骑树果','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 25},{is_effects,1},{is_tv,0}]',1,'[{0,16020001,8}]'),(61,9,14,'2倍经验药水','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 20},{is_effects,1},{is_tv,0}]',1,'[{0,37020002,1}]'),(61,9,15,'橙色供养魂珠','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 60},{is_effects,1},{is_tv,0}]',1,'[{0,5203004,1}]'),(61,9,16,'初级坐骑树果','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 100},{is_effects,1},{is_tv,0}]',1,'[{0,16020001,5}]'),(61,9,17,'2级攻击宝石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 50},{is_effects,1},{is_tv,0}]',1,'[{0,14010102,1}]'),(61,9,18,'2级生命宝石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 50},{is_effects,1},{is_tv,0}]',1,'[{0,14020202,1}]'),(61,9,19,'初级坐骑树果','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 140},{is_effects,1},{is_tv,0}]',1,'[{0,16020001,3}]'),(61,9,20,'初级坐骑树果','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 397},{is_effects,1},{is_tv,0}]',1,'[{0,16020001,2}]'),(61,9,101,'凶兽源石','许愿10次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,10}]',1,'[{0,16010001,1}]'),(61,9,102,'蛮兽源石','许愿30次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,30}]',1,'[{0,16010002,2}]'),(61,9,103,'巨兽源石','许愿60次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,60}]',1,'[{0,16010003,1}]'),(61,9,104,'魔兽源石','许愿100次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,100}]',1,'[{0,16010004,1}]'),(61,10,1,'哈迪斯','大奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 1},{is_effects,1},{is_tv,1}]',1,'[{0,11010006,1}]'),(61,10,2,'碎片·哈迪斯','珍稀奖励','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,1}]',1,'[{0,11050005,5}]'),(61,10,3,'碎片·王者黑镰','珍稀奖励','[{wlv, [1,1000]},{reward_type, 0},{weight, 2},{is_effects,1},{is_tv,1}]',1,'[{0,11060005,15}]'),(61,10,4,'武器套装石宝箱','珍稀奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 2},{is_effects,1},{is_tv,0}]',1,'[{0,32020113,5}]'),(61,10,5,'碎片·哈迪斯','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 15},{is_effects,1},{is_tv,1}]',1,'[{0,11050005,2}]'),(61,10,6,'普通武器套装石箱','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 5},{is_effects,1},{is_tv,0}]',1,'[{0,32020113,3}]'),(61,10,7,'碎片·王者黑镰','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,1}]',1,'[{0,11060005,5}]'),(61,10,8,'4级攻击宝石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,1}]',1,'[{0,14010104,1}]'),(61,10,9,'4级生命宝石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,1}]',1,'[{0,14020204,1}]'),(61,10,10,'碎片·王者黑镰','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 15},{is_effects,1},{is_tv,1}]',1,'[{0,11060005,2}]'),(61,10,11,'普通防具套装石箱','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,0}]',1,'[{0,32020112,5}]'),(61,10,12,'2倍经验药水','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 20},{is_effects,1},{is_tv,0}]',1,'[{0,37020002,1}]'),(61,10,13,'碎片·王者黑镰','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 20},{is_effects,1},{is_tv,1}]',1,'[{0,11060005,1}]'),(61,10,14,'碎片·哈迪斯','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 20},{is_effects,1},{is_tv,1}]',1,'[{0,11050005,1}]'),(61,10,15,'普通防具套装石箱','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 60},{is_effects,1},{is_tv,0}]',1,'[{0,32020112,3}]'),(61,10,16,'初级神源之火','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 200},{is_effects,1},{is_tv,0}]',1,'[{0,11020001,3}]'),(61,10,17,'普通防具套装石箱','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 3},{is_effects,1},{is_tv,0}]',1,'[{0,32020112,10}]'),(61,10,18,'初级神源之火','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 100},{is_effects,1},{is_tv,0}]',1,'[{0,11020001,5}]'),(61,10,19,'普通防具套装石箱','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 90},{is_effects,1},{is_tv,0}]',1,'[{0,32020112,2}]'),(61,10,20,'初级神源之火','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 397},{is_effects,1},{is_tv,0}]',1,'[{0,11020001,2}]'),(61,10,101,'死神印记*6','许愿10次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,10}]',1,'[{0,11040006,6}]'),(61,10,102,'死神印记*10','许愿30次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,30}]',1,'[{0,11040006,10}]'),(61,10,103,'碎片·哈迪斯','许愿60次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,60}]',1,'[{0,11050005,2}]'),(61,10,104,'碎片·哈迪斯','许愿100次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,100}]',1,'[{0,11050005,6}]'),(61,11,1,'白熊首领','大奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 2},{is_effects,1},{is_tv,1}]',1,'[{0,16030010,1}]'),(61,11,2,'魔兽源石','珍稀奖励','[{wlv, [1,1000]},{reward_type, 0},{weight, 2},{is_effects,1},{is_tv,1}]',1,'[{0,16010004,1}]'),(61,11,3,'5级攻击宝石','珍稀奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 2},{is_effects,1},{is_tv,1}]',1,'[{0,14010105,1}]'),(61,11,4,'白熊首领 碎片','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,1}]',1,'[{0,16090010,5}]'),(61,11,5,'巨兽源石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 20},{is_effects,1},{is_tv,1}]',1,'[{0,16010003,1}]'),(61,11,6,'4级攻击宝石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,1}]',1,'[{0,14010104,1}]'),(61,11,7,'4级生命宝石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,1}]',1,'[{0,14020204,1}]'),(61,11,8,'蛮兽源石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 25},{is_effects,1},{is_tv,0}]',1,'[{0,16010002,1}]'),(61,11,9,'白熊首领 碎片','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 15},{is_effects,1},{is_tv,1}]',1,'[{0,16090010,2}]'),(61,11,10,'凶兽源石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 25},{is_effects,1},{is_tv,0}]',1,'[{0,16010001,1}]'),(61,11,11,'白熊首领 碎片','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 22},{is_effects,1},{is_tv,1}]',1,'[{0,16090010,1}]'),(61,11,12,'初级坐骑树果','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 15},{is_effects,1},{is_tv,0}]',1,'[{0,16020001,10}]'),(61,11,13,'初级坐骑树果','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 25},{is_effects,1},{is_tv,0}]',1,'[{0,16020001,8}]'),(61,11,14,'2倍经验药水','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 20},{is_effects,1},{is_tv,0}]',1,'[{0,37020002,1}]'),(61,11,15,'橙色供养魂珠','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 60},{is_effects,1},{is_tv,0}]',1,'[{0,5203004,1}]'),(61,11,16,'初级坐骑树果','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 100},{is_effects,1},{is_tv,0}]',1,'[{0,16020001,5}]'),(61,11,17,'2级攻击宝石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 50},{is_effects,1},{is_tv,0}]',1,'[{0,14010102,1}]'),(61,11,18,'2级生命宝石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 50},{is_effects,1},{is_tv,0}]',1,'[{0,14020202,1}]'),(61,11,101,'凶兽源石','许愿10次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,10}]',1,'[{0,16010001,1}]'),(61,11,102,'蛮兽源石','许愿30次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,30}]',1,'[{0,16010002,2}]'),(61,11,103,'巨兽源石','许愿60次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,60}]',1,'[{0,16010003,1}]'),(61,11,104,'魔兽源石','许愿100次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,100}]',1,'[{0,16010004,1}]'),(61,12,1,'双子座','大奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 2},{is_effects,1},{is_tv,1}]',1,'[{0,18040004,1}]'),(61,12,2,'双子座碎片','珍稀奖励','[{wlv, [1,1000]},{reward_type, 0},{weight, 6},{is_effects,1},{is_tv,1}]',1,'[{0,18041004,4}]'),(61,12,3,'小宇宙星核','珍稀奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 2},{is_effects,1},{is_tv,1}]',1,'[{0,18030001,1}]'),(61,12,4,'双子座碎片','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 23},{is_effects,1},{is_tv,1}]',1,'[{0,18041004,1}]'),(61,12,5,'圣水印记','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 2},{is_effects,1},{is_tv,1}]',1,'[{0,18054401,1}]'),(61,12,6,'通用学习宝典','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 12},{is_effects,1},{is_tv,0}]',1,'[{0,18060003,5}]'),(61,12,7,'普通首饰套装石箱','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 3},{is_effects,1},{is_tv,0}]',1,'[{0,32020114,4}]'),(61,12,8,'4级攻击宝石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 8},{is_effects,1},{is_tv,1}]',1,'[{0,14010104,1}]'),(61,12,9,'通用学习手册','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 100},{is_effects,1},{is_tv,0}]',1,'[{0,18060002,5}]'),(61,12,10,'4级生命宝石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 8},{is_effects,1},{is_tv,1}]',1,'[{0,14020204,1}]'),(61,12,11,'双子座碎片','珍稀奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,1}]',1,'[{0,18041004,2}]'),(61,12,12,'普通首饰套装石箱','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 6},{is_effects,1},{is_tv,0}]',1,'[{0,32020114,2}]'),(61,12,13,'2倍经验药水','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 20},{is_effects,1},{is_tv,0}]',1,'[{0,37020002,1}]'),(61,12,14,'普通装备套装石箱','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 160},{is_effects,1},{is_tv,0}]',1,'[{0,32020111,2}]'),(61,12,15,'初级星辰之砂','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 50},{is_effects,1},{is_tv,0}]',1,'[{0,18020001,5}]'),(61,12,16,'普通首饰套装石箱','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,0}]',1,'[{0,32020114,1}]'),(61,12,17,'初级星辰之砂','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 8},{is_effects,1},{is_tv,0}]',1,'[{0,18020001,10}]'),(61,12,18,'初级星辰之砂','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 350},{is_effects,1},{is_tv,0}]',1,'[{0,18020001,3}]'),(61,12,101,'初级星辰之砂*5','许愿10次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,10}]',1,'[{0,18020001,5}]'),(61,12,102,'小萌羊碎片*4','许愿30次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,30}]',1,'[{0,18041001,4}]'),(61,12,103,'双子座碎片*2','许愿60次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,60}]',1,'[{0,18041004,2}]'),(61,12,104,'双子座碎片*3','许愿100次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,100}]',1,'[{0,18041004,3}]'),(61,13,1,'机械达人','大奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 2},{is_effects,1},{is_tv,1}]',1,'[{0,16030007,1}]'),(61,13,2,'魔兽源石','珍稀奖励','[{wlv, [1,1000]},{reward_type, 0},{weight, 2},{is_effects,1},{is_tv,1}]',1,'[{0,16010004,1}]'),(61,13,3,'5级攻击宝石','珍稀奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 2},{is_effects,1},{is_tv,1}]',1,'[{0,14010105,1}]'),(61,13,4,'机械达人碎片','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,1}]',1,'[{0,16090007,5}]'),(61,13,5,'巨兽源石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 20},{is_effects,1},{is_tv,1}]',1,'[{0,16010003,1}]'),(61,13,6,'4级攻击宝石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,1}]',1,'[{0,14010104,1}]'),(61,13,7,'4级生命宝石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,1}]',1,'[{0,14020204,1}]'),(61,13,8,'蛮兽源石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 25},{is_effects,1},{is_tv,0}]',1,'[{0,16010002,1}]'),(61,13,9,'机械达人碎片','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 15},{is_effects,1},{is_tv,1}]',1,'[{0,16090007,2}]'),(61,13,10,'凶兽源石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 25},{is_effects,1},{is_tv,0}]',1,'[{0,16010001,1}]'),(61,13,11,'机械达人碎片','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 22},{is_effects,1},{is_tv,1}]',1,'[{0,16090007,1}]'),(61,13,12,'初级坐骑树果','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 15},{is_effects,1},{is_tv,0}]',1,'[{0,16020001,10}]'),(61,13,13,'初级坐骑树果','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 25},{is_effects,1},{is_tv,0}]',1,'[{0,16020001,8}]'),(61,13,14,'2倍经验药水','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 20},{is_effects,1},{is_tv,0}]',1,'[{0,37020002,1}]'),(61,13,15,'橙色供养魂珠','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 60},{is_effects,1},{is_tv,0}]',1,'[{0,5203004,1}]'),(61,13,16,'初级坐骑树果','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 100},{is_effects,1},{is_tv,0}]',1,'[{0,16020001,5}]'),(61,13,17,'2级攻击宝石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 50},{is_effects,1},{is_tv,0}]',1,'[{0,14010102,1}]'),(61,13,18,'凶兽源石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 30},{is_effects,1},{is_tv,0}]',1,'[{0,16010001,1}]'),(61,13,101,'凶兽源石','许愿10次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,10}]',1,'[{0,16010001,1}]'),(61,13,102,'蛮兽源石','许愿30次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,30}]',1,'[{0,16010002,2}]'),(61,13,103,'巨兽源石','许愿60次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,60}]',1,'[{0,16010003,1}]'),(61,13,104,'魔兽源石','许愿100次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,100}]',1,'[{0,16010004,1}]'),(61,14,1,'波塞冬','大奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 1},{is_effects,1},{is_tv,1}]',1,'[{0,11010001,1}]'),(61,14,2,'碎片·波塞冬','珍稀奖励','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,1}]',1,'[{0,11050001,5}]'),(61,14,3,'碎片·海神三叉戟','珍稀奖励','[{wlv, [1,1000]},{reward_type, 0},{weight, 2},{is_effects,1},{is_tv,1}]',1,'[{0,11060001,15}]'),(61,14,4,'武器套装石宝箱','珍稀奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 2},{is_effects,1},{is_tv,0}]',1,'[{0,32020113,5}]'),(61,14,5,'碎片·波塞冬','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 15},{is_effects,1},{is_tv,1}]',1,'[{0,11050001,2}]'),(61,14,6,'普通武器套装石箱','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 5},{is_effects,1},{is_tv,0}]',1,'[{0,32020113,3}]'),(61,14,7,'碎片·海神三叉戟','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,1}]',1,'[{0,11060001,5}]'),(61,14,8,'4级攻击宝石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,1}]',1,'[{0,14010104,1}]'),(61,14,9,'4级生命宝石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,1}]',1,'[{0,14020204,1}]'),(61,14,10,'碎片·海神三叉戟','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 15},{is_effects,1},{is_tv,1}]',1,'[{0,11060001,2}]'),(61,14,11,'普通防具套装石箱','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,0}]',1,'[{0,32020112,5}]'),(61,14,12,'2倍经验药水','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 20},{is_effects,1},{is_tv,0}]',1,'[{0,37020002,1}]'),(61,14,13,'碎片·海神三叉戟','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 20},{is_effects,1},{is_tv,1}]',1,'[{0,11060001,1}]'),(61,14,14,'碎片·波塞冬','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 20},{is_effects,1},{is_tv,1}]',1,'[{0,11050001,1}]'),(61,14,15,'普通防具套装石箱','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 60},{is_effects,1},{is_tv,0}]',1,'[{0,32020112,3}]'),(61,14,16,'初级神源之火','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 200},{is_effects,1},{is_tv,0}]',1,'[{0,11020001,3}]'),(61,14,17,'普通防具套装石箱','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 3},{is_effects,1},{is_tv,0}]',1,'[{0,32020112,10}]'),(61,14,18,'初级神源之火','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 100},{is_effects,1},{is_tv,0}]',1,'[{0,11020001,5}]'),(61,14,19,'普通防具套装石箱','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 90},{is_effects,1},{is_tv,0}]',1,'[{0,32020112,2}]'),(61,14,101,'波塞冬印记*6','许愿10次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,10}]',1,'[{0,11040001,6}]'),(61,14,102,'波塞冬印记*10','许愿30次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,30}]',1,'[{0,11040001,10}]'),(61,14,103,'波塞冬碎片*2','许愿60次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,60}]',1,'[{0,11050001,2}]'),(61,14,104,'波塞冬碎片*6','许愿100次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,100}]',1,'[{0,11050001,6}]'),(61,15,1,'坐骑--猫咪飞椅','大奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 2},{is_effects,1},{is_tv,1}]',1,'[{0,16030008,1}]'),(61,15,2,'魔兽源石','珍稀奖励','[{wlv, [1,1000]},{reward_type, 0},{weight, 2},{is_effects,1},{is_tv,1}]',1,'[{0,16010004,1}]'),(61,15,3,'5级攻击宝石','珍稀奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 2},{is_effects,1},{is_tv,1}]',1,'[{0,14010105,1}]'),(61,15,4,'坐骑--猫咪飞椅碎片','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,1}]',1,'[{0,16090008,5}]'),(61,15,5,'巨兽源石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 20},{is_effects,1},{is_tv,1}]',1,'[{0,16010003,1}]'),(61,15,6,'4级攻击宝石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,1}]',1,'[{0,14010104,1}]'),(61,15,7,'4级生命宝石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,1}]',1,'[{0,14020204,1}]'),(61,15,8,'蛮兽源石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 25},{is_effects,1},{is_tv,0}]',1,'[{0,16010002,1}]'),(61,15,9,'坐骑--猫咪飞椅碎片','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 15},{is_effects,1},{is_tv,1}]',1,'[{0,16090008,2}]'),(61,15,10,'凶兽源石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 25},{is_effects,1},{is_tv,0}]',1,'[{0,16010001,1}]'),(61,15,11,'坐骑--猫咪飞椅碎片','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 22},{is_effects,1},{is_tv,1}]',1,'[{0,16090008,1}]'),(61,15,12,'初级坐骑树果','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 15},{is_effects,1},{is_tv,0}]',1,'[{0,16020001,10}]'),(61,15,13,'初级坐骑树果','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 25},{is_effects,1},{is_tv,0}]',1,'[{0,16020001,8}]'),(61,15,14,'2倍经验药水','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 20},{is_effects,1},{is_tv,0}]',1,'[{0,37020002,1}]'),(61,15,15,'橙色供养魂珠','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 60},{is_effects,1},{is_tv,0}]',1,'[{0,5203004,1}]'),(61,15,16,'初级坐骑树果','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 100},{is_effects,1},{is_tv,0}]',1,'[{0,16020001,5}]'),(61,15,17,'2级攻击宝石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 50},{is_effects,1},{is_tv,0}]',1,'[{0,14010102,1}]'),(61,15,18,'2级生命宝石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 50},{is_effects,1},{is_tv,0}]',1,'[{0,14020202,1}]'),(61,15,19,'初级坐骑树果','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 140},{is_effects,1},{is_tv,0}]',1,'[{0,16020001,3}]'),(61,15,20,'初级坐骑树果','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 397},{is_effects,1},{is_tv,0}]',1,'[{0,16020001,2}]'),(61,15,101,'凶兽源石','许愿10次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,10}]',1,'[{0,16010001,1}]'),(61,15,102,'蛮兽源石','许愿30次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,30}]',1,'[{0,16010002,2}]'),(61,15,103,'巨兽源石','许愿60次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,60}]',1,'[{0,16010003,1}]'),(61,15,104,'魔兽源石','许愿100次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,100}]',1,'[{0,16010004,1}]'),(61,16,1,'处女座','大奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 2},{is_effects,1},{is_tv,1}]',1,'[{0,18040007,1}]'),(61,16,2,'处女座碎片','珍稀奖励','[{wlv, [1,1000]},{reward_type, 0},{weight, 6},{is_effects,1},{is_tv,1}]',1,'[{0,18041007,4}]'),(61,16,3,'小宇宙星核','珍稀奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 2},{is_effects,1},{is_tv,1}]',1,'[{0,18030001,1}]'),(61,16,4,'处女座碎片','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 23},{is_effects,1},{is_tv,1}]',1,'[{0,18041007,1}]'),(61,16,5,'圣水印记','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 2},{is_effects,1},{is_tv,1}]',1,'[{0,18054401,1}]'),(61,16,6,'通用学习宝典','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 12},{is_effects,1},{is_tv,0}]',1,'[{0,18060003,5}]'),(61,16,7,'普通首饰套装石箱','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 3},{is_effects,1},{is_tv,0}]',1,'[{0,32020114,4}]'),(61,16,8,'4级攻击宝石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 8},{is_effects,1},{is_tv,1}]',1,'[{0,14010104,1}]'),(61,16,9,'通用学习手册','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 100},{is_effects,1},{is_tv,0}]',1,'[{0,18060002,5}]'),(61,16,10,'4级生命宝石','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 8},{is_effects,1},{is_tv,1}]',1,'[{0,14020204,1}]'),(61,16,11,'处女座碎片','珍稀奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,1}]',1,'[{0,18041007,2}]'),(61,16,12,'普通首饰套装石箱','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 6},{is_effects,1},{is_tv,0}]',1,'[{0,32020114,2}]'),(61,16,13,'2倍经验药水','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 20},{is_effects,1},{is_tv,0}]',1,'[{0,37020002,1}]'),(61,16,14,'普通装备套装石箱','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 160},{is_effects,1},{is_tv,0}]',1,'[{0,32020111,2}]'),(61,16,15,'初级星辰之砂','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 50},{is_effects,1},{is_tv,0}]',1,'[{0,18020001,5}]'),(61,16,16,'普通首饰套装石箱','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 10},{is_effects,1},{is_tv,0}]',1,'[{0,32020114,1}]'),(61,16,17,'初级星辰之砂','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 8},{is_effects,1},{is_tv,0}]',1,'[{0,18020001,10}]'),(61,16,18,'初级星辰之砂','普通奖','[{wlv, [1,1000]},{reward_type, 0},{weight, 350},{is_effects,1},{is_tv,0}]',1,'[{0,18020001,3}]'),(61,16,101,'初级星辰之砂*5','许愿10次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,10}]',1,'[{0,18020001,5}]'),(61,16,102,'小萌羊碎片*4','许愿30次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,30}]',1,'[{0,18041001,4}]'),(61,16,103,'处女座碎片*2','许愿60次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,60}]',1,'[{0,18041007,2}]'),(61,16,104,'处女座碎片*3','许愿100次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,100}]',1,'[{0,18041007,3}]'),(63,1,2,'超值vip2','超值vip2','[{bag_type,0},{viplv,1},{normal_price,999},{price_limit,[50,60]},{percent_range,[94,98]}]',1,'[{0,36040002,1},{100,11020001,1},{100,11020001,1},{100,11020001,1}]'),(63,1,3,'超值vip4','超值vip4','[{bag_type,0},{viplv,2},{normal_price,999},{price_limit,[80,100]},{percent_range,[94,98]}]',1,'[{0,36040003,1},{100,11020001,1},{100,11020001,1},{100,11020001,1}]'),(63,1,4,'超值vip4','超值vip4','[{bag_type,0},{viplv,3},{normal_price,999},{price_limit,[80,100]},{percent_range,[94,98]}]',1,'[{0,36040003,1},{100,11020001,1},{100,11020001,1},{100,11020001,1}]'),(63,1,5,'vip0礼包','vip0礼包','[{bag_type,1},{viplv,0},{normal_price,999},{price_limit,[50,60]},{percent_range,[94,98]}]',1,'[{0,14010105,1},{0,14010104,1},{0,14010103,1},{0,14010102,2}]'),(63,1,6,'vip1礼包','vip1礼包','[{bag_type,1},{viplv,1},{normal_price,1999},{price_limit,[100,120]},{percent_range,[90,99]}]',1,'[{0,14010105,1},{0,14010104,1},{0,14010103,1},{0,14010102,2}]'),(63,1,7,'vip2礼包','vip2礼包','[{bag_type,1},{viplv,2},{normal_price,1999},{price_limit,[100,120]},{percent_range,[90,99]}]',1,'[{0,14010105,1},{0,14010104,1},{0,14010103,1},{0,14010102,2}]'),(63,1,8,'vip3礼包','vip3礼包','[{bag_type,1},{viplv,3},{normal_price,1999},{price_limit,[100,120]},{percent_range,[90,99]}]',1,'[{0,14010105,1},{0,14010104,1},{0,14010103,1},{0,14010102,2}]'),(63,1,9,'vip4礼包','vip4礼包','[{bag_type,1},{viplv,4},{normal_price,1999},{price_limit,[100,120]},{percent_range,[90,99]}]',1,'[{0,14010105,1},{0,14010104,1},{0,14010103,1},{0,14010102,2}]'),(63,1,10,'vip5礼包','vip5礼包','[{bag_type,1},{viplv,5},{normal_price,1999},{price_limit,[100,120]},{percent_range,[90,99]}]',1,'[{0,14010105,1},{0,14010104,1},{0,14010103,1},{0,14010102,2}]'),(63,1,11,'vip6礼包','vip6礼包','[{bag_type,1},{viplv,6},{normal_price,1999},{price_limit,[100,120]},{percent_range,[90,99]}]',1,'[{0,14010105,1},{0,14010104,1},{0,14010103,1},{0,14010102,2}]'),(63,1,104,'双子座碎片*3','许愿100次','[{wlv, [1,1000]},{reward_type,1},{is_effects,1},{wish_times,100}]',1,'[{100,18041004,3}]');
/*!40000 ALTER TABLE `base_custom_act_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_custom_act_type`
--

DROP TABLE IF EXISTS `base_custom_act_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_custom_act_type` (
  `type` smallint(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动主类型',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '活动名字@lang@',
  PRIMARY KEY (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='定制活动类型';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_custom_act_type`
--

LOCK TABLES `base_custom_act_type` WRITE;
/*!40000 ALTER TABLE `base_custom_act_type` DISABLE KEYS */;
INSERT INTO `base_custom_act_type` VALUES (1,'魅力榜'),(2,'跨服魅力榜'),(3,'结婚榜'),(4,'集字活动（子类1勿动）（不支持额外定制）'),(6,'每日累充（勿动，不支持额外定制）'),(7,'累积充值（子类1勿动）'),(8,'节日掉落—本服（不支持额外定制）'),(9,'节日掉落-跨服（不支持额外定制）'),(10,'开服冲榜（不支持额外定制）'),(11,'好评礼包（待IOS包处理）'),(12,'副本多倍掉落'),(13,'砸蛋活动'),(14,'充值有礼'),(15,'登录送礼'),(16,'副本多倍经验'),(17,'特惠商城'),(18,'众仙云购/幸运之星'),(19,'幻兽入侵活动'),(20,'活动Boss（额外定制无法改变BOSS掉落）'),(21,'活动兑换'),(22,'烟花盛典(不支持额外定制)'),(23,'嗨点（额外定制无法改变嗨点值）'),(24,'勇者盟约'),(25,'完美恋人'),(26,'首领首杀'),(27,'公会争霸开服活动(只有一个子类型生效)'),(28,'幸运转盘'),(29,'活动红包 同时只能有一个子类型生效'),(30,'累计消费'),(31,'幸运鉴宝'),(32,'收集活动（不支持额外定制）'),(33,'本服充值排行'),(34,'充值消费活动'),(35,'幸运翻牌'),(36,'0元豪礼（不支持额外定制，超过开服7天开启的合服有问题）'),(37,'跨服云购(消耗钻石)'),(38,'跨服云购(消耗绑钻)'),(39,'本服消费排行'),(40,'连续消费'),(41,'超值礼包'),(42,'精品特卖'),(43,'每日转盘'),(44,'公会争霸定级赛合服活动(只有一个子类型生效,只能是合服活动)'),(45,'白鸽传信'),(46,'运营投资活动'),(47,'每日累充(每日重置版)'),(48,'每日单笔充值'),(49,'货币赚赚赚'),(50,'幸运转盘'),(51,'幸运奖券机'),(52,'首领翻倍'),(53,'最佳时装师'),(54,'累积在线'),(55,'祈愿'),(56,'每日活跃'),(57,'反复充值有礼'),(58,'反复充值转盘'),(59,'每日目标活动'),(60,'成长积分'),(61,'欢乐许愿'),(62,'荣耀战神'),(63,'VIP特惠');
/*!40000 ALTER TABLE `base_custom_act_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_customer_service`
--

DROP TABLE IF EXISTS `base_customer_service`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_customer_service` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `display` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '1:显示 0:隐藏',
  `display_code` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否显示二维码',
  `keyword` varchar(100) NOT NULL DEFAULT '' COMMENT '关键字',
  `medium` varchar(255) NOT NULL DEFAULT '' COMMENT '渠道',
  `link_info_1` varchar(1024) NOT NULL DEFAULT '' COMMENT '联系方式1',
  `link_info_2` varchar(1024) NOT NULL DEFAULT '' COMMENT '联系方式2',
  `work_time` varchar(255) NOT NULL DEFAULT '' COMMENT '工作时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='客服信息配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_customer_service`
--

LOCK TABLES `base_customer_service` WRITE;
/*!40000 ALTER TABLE `base_customer_service` DISABLE KEYS */;
INSERT INTO `base_customer_service` VALUES (1,1,1,'ml','bf_ml','微信公众号：mlgame','客服电话：4008018738','10:00-22:00'),(2,1,1,'suyou','bf_suyou','客服QQ：3257596149','微信公众号：zisugame','09:00-20:00'),(3,1,1,'ml','bf_ml_1340040','微信公众号：mlgame','客服电话：4008018738','10:00-22:00'),(4,1,1,'ml','bf_ml_1340137','微信公众号：mlgame','客服电话：4008018738','10:00-22:00'),(5,1,1,'ml','bf_ml_1340140','微信公众号：mlgame','客服电话：4008018738','10:00-22:00'),(6,1,1,'ml','bf_ml_1340237','微信公众号：mlgame','客服电话：4008018738','10:00-22:00'),(7,1,1,'ml','bf_ml_1340240','微信公众号：mlgame','客服电话：4008018738','10:00-22:00'),(8,1,1,'ml','bf_ml_ios','微信公众号：mlgame','客服电话：4008018738','10:00-22:00'),(9,1,1,'ml','bf_ml_ios_1340940','微信公众号：mlgame','客服电话：4008018738','10:00-22:00'),(10,1,1,'suyou','bf_suyou_wzqst','微信公众号：zisugame','','09:00-20:00'),(11,1,0,'bf_ml_qzxd','bf_ml_qzxd','微信公众号：huotuwan','','09:00-20:00'),(12,1,0,'bf_ml_gwzx','bf_ml_gwzx','微信公众号：huotuwan','','09:00-20:00'),(13,1,0,'bf_ml_mhwy','bf_ml_mhwy','微信公众号：chaoshenwan','','09:00-20:00');
/*!40000 ALTER TABLE `base_customer_service` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_customer_service_vip`
--

DROP TABLE IF EXISTS `base_customer_service_vip`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_customer_service_vip` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `display` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '1:显示 0:隐藏',
  `keyword` varchar(100) NOT NULL DEFAULT '' COMMENT '关键字',
  `medium` varchar(255) NOT NULL DEFAULT '' COMMENT '平台',
  `menu_gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '界面显示金额',
  `qq_gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'qq显示金额',
  `qq` varchar(255) NOT NULL DEFAULT '' COMMENT 'QQ',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='超级vip客服信息配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_customer_service_vip`
--

LOCK TABLES `base_customer_service_vip` WRITE;
/*!40000 ALTER TABLE `base_customer_service_vip` DISABLE KEYS */;
INSERT INTO `base_customer_service_vip` VALUES (1,1,'ml','bf_ml',5000,10000,'800081361'),(2,1,'ml','bf_ml_1340040',5000,10000,'800081361'),(3,1,'ml','bf_ml_1340137',5000,10000,'800081361'),(4,1,'ml','bf_ml_1340140',5000,10000,'800081361'),(5,1,'ml','bf_ml_1340237',5000,10000,'800081361'),(6,1,'ml','bf_ml_1340240',5000,10000,'800081361'),(7,1,'ml','bf_ml_ios',5000,10000,'800081361'),(8,1,'ml','bf_ml_ios_1340940',5000,10000,'800081361'),(9,1,'suyou','bf_suyou_wzqst',3000,5000,'1472631382');
/*!40000 ALTER TABLE `base_customer_service_vip` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_deity`
--

DROP TABLE IF EXISTS `base_deity`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_deity` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '编号',
  `name` varchar(50) NOT NULL COMMENT '神格名称',
  `color` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '神格颜色',
  `condition` varchar(255) NOT NULL COMMENT '晋升条件',
  `cost` varchar(255) NOT NULL COMMENT '晋升消耗',
  `attr` varchar(255) NOT NULL COMMENT '晋升增加属性',
  `combat` int(255) unsigned NOT NULL DEFAULT '0' COMMENT '晋升战力',
  `devour` varchar(255) NOT NULL DEFAULT '[]' COMMENT '吞噬数量',
  `source_id` varchar(255) NOT NULL DEFAULT '[]' COMMENT '资源id',
  `resource_name` varchar(255) NOT NULL DEFAULT '[]' COMMENT '头衔资源',
  `resource_lv` int(10) unsigned NOT NULL COMMENT '罗马等级',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_deity`
--

LOCK TABLES `base_deity` WRITE;
/*!40000 ALTER TABLE `base_deity` DISABLE KEYS */;
INSERT INTO `base_deity` VALUES (1,'凡人',0,'[{1,1}]','[]','[{1,13},{2,255},{3,8},{4,8}]',915,'[{1,200},{2,100},{3,40},{4,20}]','icon_sg1','icon_sgmc1',1),(2,'凡人',0,'[{1,2}]','[]','[{1,27},{2,536},{3,17},{4,17}]',1926,'[{1,200},{2,100},{3,40},{4,20}]','icon_sg1','icon_sgmc1',2),(3,'凡人',0,'[{1,3}]','[]','[{1,42},{2,842},{3,27},{4,27}]',3032,'[{1,200},{2,100},{3,40},{4,20}]','icon_sg1','icon_sgmc1',3),(4,'凡人',0,'[{1,4}]','[]','[{1,59},{2,1174},{3,37},{4,37}]',4204,'[{1,200},{2,100},{3,40},{4,20}]','icon_sg1','icon_sgmc1',4),(5,'凡人',0,'[{1,5}]','[{0,17010001,100}]','[{1,114},{2,2271},{3,71},{4,71}]',8101,'[{1,200},{2,100},{3,40},{4,20}]','icon_sg1','icon_sgmc1',5),(6,'凡人',0,'[{1,6}]','[]','[{1,133},{2,2654},{3,83},{4,83}]',9464,'[{1,200},{2,100},{3,40},{4,20}]','icon_sg1','icon_sgmc1',6),(7,'凡人',0,'[{1,7}]','[]','[{1,155},{2,3088},{3,97},{4,97}]',11038,'[{1,200},{2,100},{3,40},{4,20}]','icon_sg1','icon_sgmc1',7),(8,'凡人',0,'[{1,8}]','[]','[{1,179},{2,3573},{3,112},{4,112}]',12753,'[{1,200},{2,100},{3,40},{4,20}]','icon_sg1','icon_sgmc1',8),(9,'凡人',0,'[{1,9}]','[]','[{1,206},{2,4109},{3,129},{4,129}]',14679,'[{1,200},{2,100},{3,40},{4,20}]','icon_sg1','icon_sgmc1',9),(10,'凡人',0,'[{1,10}]','[{0,17010001,200}]','[{1,309},{2,6175},{3,194},{4,194}]',22055,'[{1,200},{2,100},{3,40},{4,20}]','icon_sg1','icon_sgmc1',10),(11,'先知',0,'[{1,11}]','[]','[{1,340},{2,6787},{3,213},{4,213}]',24237,'[{1,200},{2,100},{3,40},{4,20}]','icon_sg2','icon_sgmc2',1),(12,'先知',0,'[{1,12}]','[]','[{1,374},{2,7476},{3,235},{4,235}]',26706,'[{1,200},{2,100},{3,40},{4,20}]','icon_sg2','icon_sgmc2',2),(13,'先知',0,'[{1,13}]','[]','[{1,412},{2,8241},{3,259},{4,259}]',29431,'[{1,200},{2,100},{3,40},{4,20}]','icon_sg2','icon_sgmc2',3),(14,'先知',0,'[{1,14}]','[]','[{1,454},{2,9083},{3,285},{4,285}]',32413,'[{1,200},{2,100},{3,40},{4,20}]','icon_sg2','icon_sgmc2',4),(15,'先知',0,'[{1,15}]','[{0,17010001,350}]','[{1,624},{2,12475},{3,391},{4,391}]',44505,'[{1,200},{2,100},{3,40},{4,20}]','icon_sg2','icon_sgmc2',5),(16,'先知',0,'[{1,16}]','[]','[{1,671},{2,13419},{3,420},{4,420}]',47839,'[{1,200},{2,100},{3,40},{4,20}]','icon_sg2','icon_sgmc2',6),(17,'先知',0,'[{1,17}]','[]','[{1,723},{2,14465},{3,453},{4,453}]',51575,'[{1,200},{2,100},{3,40},{4,20}]','icon_sg2','icon_sgmc2',7),(18,'先知',0,'[{1,18}]','[]','[{1,780},{2,15613},{3,489},{4,489}]',55663,'[{1,200},{2,100},{3,40},{4,20}]','icon_sg2','icon_sgmc2',8),(19,'先知',0,'[{1,19}]','[]','[{1,842},{2,16863},{3,528},{4,528}]',60103,'[{1,200},{2,100},{3,40},{4,20}]','icon_sg2','icon_sgmc2',9),(20,'先知',0,'[{1,20}]','[{0,17010001,500}]','[{1,1096},{2,21939},{3,687},{4,687}]',78209,'[{1,200},{2,100},{3,40},{4,20}]','icon_sg2','icon_sgmc2',10),(21,'圣人',1,'[{1,21}]','[]','[{1,1165},{2,23316},{3,730},{4,730}]',83116,'[{1,400},{2,200},{3,80},{4,40}]','icon_sg3','icon_sgmc3',1),(22,'圣人',1,'[{1,22}]','[]','[{1,1240},{2,24821},{3,777},{4,777}]',88471,'[{1,400},{2,200},{3,80},{4,40}]','icon_sg3','icon_sgmc3',2),(23,'圣人',1,'[{1,23}]','[]','[{1,1322},{2,26453},{3,828},{4,828}]',94293,'[{1,400},{2,200},{3,80},{4,40}]','icon_sg3','icon_sgmc3',3),(24,'圣人',1,'[{1,24}]','[]','[{1,1410},{2,28213},{3,883},{4,883}]',100563,'[{1,400},{2,200},{3,80},{4,40}]','icon_sg3','icon_sgmc3',4),(25,'圣人',1,'[{1,25}]','[{0,17010001,800}]','[{1,1753},{2,35074},{3,1097},{4,1097}]',124984,'[{1,400},{2,200},{3,80},{4,40}]','icon_sg3','icon_sgmc3',5),(26,'圣人',1,'[{1,26}]','[]','[{1,1850},{2,37012},{3,1158},{4,1158}]',131912,'[{1,400},{2,200},{3,80},{4,40}]','icon_sg3','icon_sgmc3',6),(27,'圣人',1,'[{1,27}]','[]','[{1,1956},{2,39129},{3,1224},{4,1224}]',139449,'[{1,400},{2,200},{3,80},{4,40}]','icon_sg3','icon_sgmc3',7),(28,'圣人',1,'[{1,28}]','[]','[{1,2071},{2,41425},{3,1296},{4,1296}]',147645,'[{1,400},{2,200},{3,80},{4,40}]','icon_sg3','icon_sgmc3',8),(29,'圣人',1,'[{1,29}]','[]','[{1,2195},{2,43899},{3,1373},{4,1373}]',156449,'[{1,400},{2,200},{3,80},{4,40}]','icon_sg3','icon_sgmc3',9),(30,'圣人',1,'[{1,30}]','[{0,17010001,1200}]','[{1,2676},{2,53515},{3,1673},{4,1673}]',190685,'[{1,400},{2,200},{3,80},{4,40}]','icon_sg3','icon_sgmc3',10),(31,'主宰',1,'[{1,31}]','[]','[{1,2811},{2,56219},{3,1757},{4,1757}]',200289,'[{1,400},{2,200},{3,80},{4,40}]','icon_sg4','icon_sgmc4',1),(32,'主宰',1,'[{1,32}]','[]','[{1,2958},{2,59152},{3,1849},{4,1849}]',210762,'[{1,400},{2,200},{3,80},{4,40}]','icon_sg4','icon_sgmc4',2),(33,'主宰',1,'[{1,33}]','[]','[{1,3116},{2,62315},{3,1948},{4,1948}]',222035,'[{1,400},{2,200},{3,80},{4,40}]','icon_sg4','icon_sgmc4',3),(34,'主宰',1,'[{1,34}]','[]','[{1,3286},{2,65707},{3,2054},{4,2054}]',234127,'[{1,400},{2,200},{3,80},{4,40}]','icon_sg4','icon_sgmc4',4),(35,'主宰',1,'[{1,35}]','[{0,17010002,160}]','[{1,3915},{2,78282},{3,2447},{4,2447}]',278932,'[{1,400},{2,200},{3,80},{4,40}]','icon_sg4','icon_sgmc4',5),(36,'主宰',1,'[{1,36}]','[]','[{1,4099},{2,81955},{3,2562},{4,2562}]',292035,'[{1,400},{2,200},{3,80},{4,40}]','icon_sg4','icon_sgmc4',6),(37,'主宰',1,'[{1,37}]','[]','[{1,4297},{2,85908},{3,2686},{4,2686}]',306148,'[{1,400},{2,200},{3,80},{4,40}]','icon_sg4','icon_sgmc4',7),(38,'主宰',1,'[{1,38}]','[]','[{1,4509},{2,90142},{3,2818},{4,2818}]',321222,'[{1,400},{2,200},{3,80},{4,40}]','icon_sg4','icon_sgmc4',8),(39,'主宰',1,'[{1,39}]','[]','[{1,4735},{2,94657},{3,2959},{4,2959}]',337307,'[{1,400},{2,200},{3,80},{4,40}]','icon_sg4','icon_sgmc4',9),(40,'主宰',1,'[{1,40}]','[{0,17010002,200}]','[{1,5522},{2,110394},{3,3451},{4,3451}]',393384,'[{1,400},{2,200},{3,80},{4,40}]','icon_sg4','icon_sgmc4',10),(41,'天启',2,'[{1,41}]','[]','[{1,5764},{2,115240},{3,3602},{4,3602}]',410620,'[{1,600},{2,300},{3,120},{4,60}]','icon_sg5','icon_sgmc5',1),(42,'天启',2,'[{1,42}]','[]','[{1,6023},{2,120418},{3,3764},{4,3764}]',429078,'[{1,600},{2,300},{3,120},{4,60}]','icon_sg5','icon_sgmc5',2),(43,'天启',2,'[{1,43}]','[]','[{1,6298},{2,125927},{3,3936},{4,3936}]',448687,'[{1,600},{2,300},{3,120},{4,60}]','icon_sg5','icon_sgmc5',3),(44,'天启',2,'[{1,44}]','[]','[{1,6590},{2,131768},{3,4119},{4,4119}]',469518,'[{1,600},{2,300},{3,120},{4,60}]','icon_sg5','icon_sgmc5',4),(45,'天启',2,'[{1,45}]','[{0,17010002,250}]','[{1,7545},{2,150872},{3,4716},{4,4716}]',537572,'[{1,600},{2,300},{3,120},{4,60}]','icon_sg5','icon_sgmc5',5),(46,'天启',2,'[{1,46}]','[]','[{1,7856},{2,157095},{3,4910},{4,4910}]',559715,'[{1,600},{2,300},{3,120},{4,60}]','icon_sg5','icon_sgmc5',6),(47,'天启',2,'[{1,47}]','[]','[{1,8186},{2,163701},{3,5116},{4,5116}]',583221,'[{1,600},{2,300},{3,120},{4,60}]','icon_sg5','icon_sgmc5',7),(48,'天启',2,'[{1,48}]','[]','[{1,8535},{2,170690},{3,5334},{4,5334}]',608090,'[{1,600},{2,300},{3,120},{4,60}]','icon_sg5','icon_sgmc5',8),(49,'天启',2,'[{1,49}]','[]','[{1,8904},{2,178061},{3,5564},{4,5564}]',634341,'[{1,600},{2,300},{3,120},{4,60}]','icon_sg5','icon_sgmc5',9),(50,'天启',2,'[{1,50}]','[{0,17010002,320}]','[{1,10038},{2,200736},{3,6273},{4,6273}]',715146,'[{1,600},{2,300},{3,120},{4,60}]','icon_sg5','icon_sgmc5',10),(51,'圣灵',2,'[{1,51}]','[]','[{1,10430},{2,208566},{3,6518},{4,6518}]',743066,'[{1,600},{2,300},{3,120},{4,60}]','icon_sg6','icon_sgmc6',1),(52,'圣灵',2,'[{1,52}]','[]','[{1,10844},{2,216855},{3,6777},{4,6777}]',772585,'[{1,600},{2,300},{3,120},{4,60}]','icon_sg6','icon_sgmc6',2),(53,'圣灵',2,'[{1,53}]','[]','[{1,11281},{2,225604},{3,7050},{4,7050}]',803724,'[{1,600},{2,300},{3,120},{4,60}]','icon_sg6','icon_sgmc6',3),(54,'圣灵',2,'[{1,54}]','[]','[{1,11741},{2,234812},{3,7338},{4,7338}]',836532,'[{1,600},{2,300},{3,120},{4,60}]','icon_sg6','icon_sgmc6',4),(55,'圣灵',2,'[{1,55}]','[{0,17010002,400}]','[{1,13120},{2,262384},{3,8200},{4,8200}]',934784,'[{1,600},{2,300},{3,120},{4,60}]','icon_sg6','icon_sgmc6',5),(56,'圣灵',2,'[{1,56}]','[]','[{1,13607},{2,272127},{3,8504},{4,8504}]',969467,'[{1,600},{2,300},{3,120},{4,60}]','icon_sg6','icon_sgmc6',6),(57,'圣灵',2,'[{1,57}]','[]','[{1,14121},{2,282406},{3,8825},{4,8825}]',1006076,'[{1,600},{2,300},{3,120},{4,60}]','icon_sg6','icon_sgmc6',7),(58,'圣灵',2,'[{1,58}]','[]','[{1,14662},{2,293221},{3,9163},{4,9163}]',1044611,'[{1,600},{2,300},{3,120},{4,60}]','icon_sg6','icon_sgmc6',8),(59,'圣灵',2,'[{1,59}]','[]','[{1,15230},{2,304571},{3,9518},{4,9518}]',1085071,'[{1,600},{2,300},{3,120},{4,60}]','icon_sg6','icon_sgmc6',9),(60,'圣灵',2,'[{1,60}]','[{0,17010002,500}]','[{1,16869},{2,337346},{3,10542},{4,10542}]',1201826,'[{1,600},{2,300},{3,120},{4,60}]','icon_sg6','icon_sgmc6',10),(61,'神子',3,'[{1,61}]','[]','[{1,17467},{2,349308},{3,10916},{4,10916}]',1244448,'[{1,800},{2,400},{3,160},{4,80}]','icon_sg7','icon_sgmc7',1),(62,'神子',3,'[{1,62}]','[]','[{1,18096},{2,361883},{3,11309},{4,11309}]',1289253,'[{1,800},{2,400},{3,160},{4,80}]','icon_sg7','icon_sgmc7',2),(63,'神子',3,'[{1,63}]','[]','[{1,18755},{2,375070},{3,11721},{4,11721}]',1336220,'[{1,800},{2,400},{3,160},{4,80}]','icon_sg7','icon_sgmc7',3),(64,'神子',3,'[{1,64}]','[]','[{1,19445},{2,388869},{3,12152},{4,12152}]',1385369,'[{1,800},{2,400},{3,160},{4,80}]','icon_sg7','icon_sgmc7',4),(65,'神子',3,'[{1,65}]','[{0,17010002,650}]','[{1,21359},{2,427154},{3,13348},{4,13348}]',1521734,'[{1,800},{2,400},{3,160},{4,80}]','icon_sg7','icon_sgmc7',5),(66,'神子',3,'[{1,66}]','[]','[{1,22083},{2,441641},{3,13801},{4,13801}]',1573351,'[{1,800},{2,400},{3,160},{4,80}]','icon_sg7','icon_sgmc7',6),(67,'神子',3,'[{1,67}]','[]','[{1,22842},{2,456817},{3,14275},{4,14275}]',1627407,'[{1,800},{2,400},{3,160},{4,80}]','icon_sg7','icon_sgmc7',7),(68,'神子',3,'[{1,68}]','[]','[{1,23635},{2,472682},{3,14771},{4,14771}]',1683932,'[{1,800},{2,400},{3,160},{4,80}]','icon_sg7','icon_sgmc7',8),(69,'神子',3,'[{1,69}]','[]','[{1,24463},{2,489235},{3,15288},{4,15288}]',1742895,'[{1,800},{2,400},{3,160},{4,80}]','icon_sg7','icon_sgmc7',9),(70,'神子',3,'[{1,70}]','[{0,17010002,800}]','[{1,26668},{2,533335},{3,16666},{4,16666}]',1899995,'[{1,800},{2,400},{3,160},{4,80}]','icon_sg7','icon_sgmc7',10),(71,'半身',3,'[{1,71}]','[]','[{1,27534},{2,550654},{3,17207},{4,17207}]',1961684,'[{1,800},{2,400},{3,160},{4,80}]','icon_sg8','icon_sgmc8',1),(72,'半身',3,'[{1,72}]','[]','[{1,28438},{2,568738},{3,17772},{4,17772}]',2026098,'[{1,800},{2,400},{3,160},{4,80}]','icon_sg8','icon_sgmc8',2),(73,'半身',3,'[{1,73}]','[]','[{1,29380},{2,587587},{3,18361},{4,18361}]',2093237,'[{1,800},{2,400},{3,160},{4,80}]','icon_sg8','icon_sgmc8',3),(74,'半身',3,'[{1,74}]','[]','[{1,30361},{2,607201},{3,18974},{4,18974}]',2163121,'[{1,800},{2,400},{3,160},{4,80}]','icon_sg8','icon_sgmc8',4),(75,'半身',3,'[{1,75}]','[{0,17010003,100}]','[{1,32872},{2,657423},{3,20543},{4,20543}]',2342013,'[{1,800},{2,400},{3,160},{4,80}]','icon_sg8','icon_sgmc8',5),(76,'半身',3,'[{1,76}]','[]','[{1,33895},{2,677879},{3,21182},{4,21182}]',2414879,'[{1,800},{2,400},{3,160},{4,80}]','icon_sg8','icon_sgmc8',6),(77,'半身',3,'[{1,77}]','[]','[{1,34960},{2,699177},{3,21848},{4,21848}]',2490777,'[{1,800},{2,400},{3,160},{4,80}]','icon_sg8','icon_sgmc8',7),(78,'半身',3,'[{1,78}]','[]','[{1,36067},{2,721316},{3,22540},{4,22540}]',2569656,'[{1,800},{2,400},{3,160},{4,80}]','icon_sg8','icon_sgmc8',8),(79,'半身',3,'[{1,79}]','[]','[{1,37216},{2,744297},{3,23258},{4,23258}]',2651517,'[{1,800},{2,400},{3,160},{4,80}]','icon_sg8','icon_sgmc8',9),(80,'半身',3,'[{1,80}]','[{0,17010003,125}]','[{1,40048},{2,800946},{3,25028},{4,25028}]',2853306,'[{1,800},{2,400},{3,160},{4,80}]','icon_sg8','icon_sgmc8',10),(81,'真神',3,'[{1,81}]','[]','[{1,41243},{2,824845},{3,25775},{4,25775}]',2938455,'[{1,1000},{2,500},{3,200},{4,100}]','icon_sg9','icon_sgmc9',1),(82,'真神',3,'[{1,82}]','[]','[{1,42484},{2,849662},{3,26551},{4,26551}]',3026892,'[{1,1000},{2,500},{3,200},{4,100}]','icon_sg9','icon_sgmc9',2),(83,'真神',3,'[{1,83}]','[]','[{1,43771},{2,875398},{3,27355},{4,27355}]',3118568,'[{1,1000},{2,500},{3,200},{4,100}]','icon_sg9','icon_sgmc9',3),(84,'真神',3,'[{1,84}]','[]','[{1,45104},{2,902052},{3,28188},{4,28188}]',3213532,'[{1,1000},{2,500},{3,200},{4,100}]','icon_sg9','icon_sgmc9',4),(85,'真神',3,'[{1,85}]','[{0,17010003,160}]','[{1,48273},{2,965435},{3,30169},{4,30169}]',3439345,'[{1,1000},{2,500},{3,200},{4,100}]','icon_sg9','icon_sgmc9',5),(86,'真神',3,'[{1,86}]','[]','[{1,49655},{2,993084},{3,31033},{4,31033}]',3537834,'[{1,1000},{2,500},{3,200},{4,100}]','icon_sg9','icon_sgmc9',6),(87,'真神',3,'[{1,87}]','[]','[{1,51087},{2,1021727},{3,31928},{4,31928}]',3639867,'[{1,1000},{2,500},{3,200},{4,100}]','icon_sg9','icon_sgmc9',7),(88,'真神',3,'[{1,88}]','[]','[{1,52569},{2,1051365},{3,32854},{4,32854}]',3745445,'[{1,1000},{2,500},{3,200},{4,100}]','icon_sg9','icon_sgmc9',8),(89,'真神',3,'[{1,89}]','[]','[{1,54101},{2,1081998},{3,33811},{4,33811}]',3854568,'[{1,1000},{2,500},{3,200},{4,100}]','icon_sg9','icon_sgmc9',9),(90,'真神',3,'[{1,90}]','[{0,17010003,200}]','[{1,57622},{2,1152420},{3,36012},{4,36012}]',4105460,'[{1,1000},{2,500},{3,200},{4,100}]','icon_sg9','icon_sgmc9',10),(91,'神主',4,'[{1,91}]','[]','[{1,59207},{2,1184124},{3,37003},{4,37003}]',4218414,'[{1,1000},{2,500},{3,200},{4,100}]','icon_sg10','icon_sgmc10',1),(92,'神主',4,'[{1,92}]','[]','[{1,60846},{2,1216899},{3,38027},{4,38027}]',4335169,'[{1,1000},{2,500},{3,200},{4,100}]','icon_sg10','icon_sgmc10',2),(93,'神主',4,'[{1,93}]','[]','[{1,62538},{2,1250746},{3,39085},{4,39085}]',4455756,'[{1,1000},{2,500},{3,200},{4,100}]','icon_sg10','icon_sgmc10',3),(94,'神主',4,'[{1,94}]','[]','[{1,64284},{2,1285664},{3,40176},{4,40176}]',4580144,'[{1,1000},{2,500},{3,200},{4,100}]','icon_sg10','icon_sgmc10',4),(95,'神主',4,'[{1,95}]','[{0,17010003,250}]','[{1,68172},{2,1363432},{3,42606},{4,42606}]',4857172,'[{1,1000},{2,500},{3,200},{4,100}]','icon_sg10','icon_sgmc10',5),(96,'神主',4,'[{1,96}]','[]','[{1,69975},{2,1399498},{3,43733},{4,43733}]',4985648,'[{1,1000},{2,500},{3,200},{4,100}]','icon_sg10','icon_sgmc10',6),(97,'神主',4,'[{1,97}]','[]','[{1,71836},{2,1436711},{3,44896},{4,44896}]',5118231,'[{1,1000},{2,500},{3,200},{4,100}]','icon_sg10','icon_sgmc10',7),(98,'神主',4,'[{1,98}]','[]','[{1,73754},{2,1475072},{3,46095},{4,46095}]',5254902,'[{1,1000},{2,500},{3,200},{4,100}]','icon_sg10','icon_sgmc10',8),(99,'神主',4,'[{1,99}]','[]','[{1,75729},{2,1514581},{3,47330},{4,47330}]',5395661,'[{1,1000},{2,500},{3,200},{4,100}]','icon_sg10','icon_sgmc10',9),(100,'神主',4,'[{1,100}]','[{0,17010003,300}]','[{1,80000},{2,1600000},{3,50000},{4,50000}]',5700000,'[{1,1000},{2,500},{3,200},{4,100}]','icon_sg10','icon_sgmc10',10);
/*!40000 ALTER TABLE `base_deity` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_deity_place`
--

DROP TABLE IF EXISTS `base_deity_place`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_deity_place` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '部位ID',
  `name` varchar(255) NOT NULL COMMENT '部位名@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8 COMMENT='神格部位名配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_deity_place`
--

LOCK TABLES `base_deity_place` WRITE;
/*!40000 ALTER TABLE `base_deity_place` DISABLE KEYS */;
INSERT INTO `base_deity_place` VALUES (1,'雷霆'),(2,'生命'),(3,'光明'),(4,'大地');
/*!40000 ALTER TABLE `base_deity_place` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_deity_principle`
--

DROP TABLE IF EXISTS `base_deity_principle`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_deity_principle` (
  `goods_id` int(32) unsigned NOT NULL COMMENT '物品ID',
  `rank` int(10) unsigned NOT NULL COMMENT '阶数',
  `place` int(10) unsigned NOT NULL COMMENT '部位',
  `star` int(10) unsigned NOT NULL COMMENT '星级',
  `combat` int(32) unsigned NOT NULL COMMENT '评分',
  `attr` varchar(1024) NOT NULL COMMENT '属性',
  `skill_id` int(32) unsigned NOT NULL COMMENT '技能ID',
  PRIMARY KEY (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='神格-法则表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_deity_principle`
--

LOCK TABLES `base_deity_principle` WRITE;
/*!40000 ALTER TABLE `base_deity_principle` DISABLE KEYS */;
INSERT INTO `base_deity_principle` VALUES (17030101,1,1,3,218000,'[{1,2400,2},{3,1200,2},{20,200,3},{19,200,3}]',80100101),(17030102,2,1,3,540000,'[{1,4800,2},{3,2400,2},{20,300,3},{19,300,3}]',80100101),(17030103,3,1,3,1080000,'[{1,9600,2},{3,4800,2},{20,400,3},{19,400,3},{55,200,3}]',80100101),(17030104,4,1,3,1760000,'[{1,19200,2},{3,9600,2},{20,600,3},{19,600,3},{55,400,3}]',80100101),(17030105,5,1,3,2520000,'[{1,38400,2},{3,19200,2},{20,800,3},{19,800,3},{55,600,3}]',80100101),(17030201,1,2,3,218000,'[{2,48000,2},{4,1200,2},{20,200,3},{19,200,3}]',80100201),(17030202,2,2,3,540000,'[{2,96000,2},{4,2400,2},{20,300,3},{19,300,3}]',80100201),(17030203,3,2,3,1080000,'[{2,192000,2},{4,4800,2},{20,400,3},{19,400,3},{55,200,3}]',80100201),(17030204,4,2,3,1760000,'[{2,384000,2},{4,9600,2},{20,600,3},{19,600,3},{55,400,3}]',80100201),(17030205,5,2,3,2520000,'[{2,768000,2},{4,19200,2},{20,800,3},{19,800,3},{55,600,3}]',80100201),(17030301,1,3,3,218000,'[{1,2400,2},{3,1200,2},{20,200,3},{19,200,3}]',80100301),(17030302,2,3,3,540000,'[{1,4800,2},{3,2400,2},{20,300,3},{19,300,3}]',80100301),(17030303,3,3,3,1080000,'[{1,9600,2},{3,4800,2},{20,400,3},{19,400,3},{55,200,3}]',80100301),(17030304,4,3,3,1760000,'[{1,19200,2},{3,9600,2},{20,600,3},{19,600,3},{55,400,3}]',80100301),(17030305,5,3,3,2520000,'[{1,38400,2},{3,19200,2},{20,800,3},{19,800,3},{55,600,3}]',80100301),(17030401,1,4,3,218000,'[{2,48000,2},{4,1200,2},{20,200,3},{19,200,3}]',80100401),(17030402,2,4,3,540000,'[{2,96000,2},{4,2400,2},{20,300,3},{19,300,3}]',80100401),(17030403,3,4,3,1080000,'[{2,192000,2},{4,4800,2},{20,400,3},{19,400,3},{55,200,3}]',80100401),(17030404,4,4,3,1760000,'[{2,384000,2},{4,9600,2},{20,600,3},{19,600,3},{55,400,3}]',80100401),(17030405,5,4,3,2520000,'[{2,768000,2},{4,19200,2},{20,800,3},{19,800,3},{55,600,3}]',80100401);
/*!40000 ALTER TABLE `base_deity_principle` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_demon_shop_discount`
--

DROP TABLE IF EXISTS `base_demon_shop_discount`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_demon_shop_discount` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '对应商品id',
  `discount` varchar(512) NOT NULL DEFAULT '[]' COMMENT '折扣价',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_demon_shop_discount`
--

LOCK TABLES `base_demon_shop_discount` WRITE;
/*!40000 ALTER TABLE `base_demon_shop_discount` DISABLE KEYS */;
INSERT INTO `base_demon_shop_discount` VALUES (1,'[{10,1000}]'),(2,'[{8,400},{9,600}]'),(3,'[{8,400},{9,600}]'),(4,'[{8,400},{9,600}]'),(5,'[{8,400},{9,600}]'),(6,'[{8,400},{9,600}]'),(7,'[{8,400},{9,600}]'),(8,'[{8,400},{9,600}]'),(9,'[{8,400},{9,600}]'),(10,'[{8,400},{9,600}]'),(11,'[{8,400},{9,600}]'),(12,'[{8,400},{9,600}]'),(13,'[{8,400},{9,600}]'),(14,'[{8,400},{9,600}]'),(15,'[{8,400},{9,600}]'),(16,'[{9,1000}]'),(17,'[{8,400},{9,600}]'),(18,'[{8,400},{9,600}]'),(19,'[{8,400},{9,600}]'),(20,'[{7,400},{8,600}]'),(21,'[{7,400},{8,600}]'),(22,'[{7,400},{8,600}]'),(23,'[{7,400},{8,600}]'),(24,'[{7,400},{8,600}]'),(25,'[{7,400},{8,600}]'),(26,'[{7,400},{8,600}]'),(27,'[{7,400},{8,600}]'),(28,'[{10,1000}]'),(29,'[{7,400},{8,600}]'),(30,'[{7,400},{8,600}]'),(31,'[{7,400},{8,600}]'),(32,'[{7,400},{8,600}]'),(33,'[{7,400},{8,600}]'),(34,'[{7,400},{8,600}]'),(35,'[{9,1000}]'),(36,'[{7,400},{8,600}]'),(37,'[{7,400},{8,600}]'),(38,'[{7,400},{8,600}]'),(39,'[{9,1000}]');
/*!40000 ALTER TABLE `base_demon_shop_discount` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_demon_shop_good`
--

DROP TABLE IF EXISTS `base_demon_shop_good`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_demon_shop_good` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '配置id',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `career` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '职业',
  `goods` varchar(512) NOT NULL DEFAULT '[]' COMMENT '商品',
  `price_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '购买类型',
  `old_price` varchar(255) NOT NULL DEFAULT '''[]''' COMMENT '原价',
  `weight` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '权重',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_demon_shop_good`
--

LOCK TABLES `base_demon_shop_good` WRITE;
/*!40000 ALTER TABLE `base_demon_shop_good` DISABLE KEYS */;
INSERT INTO `base_demon_shop_good` VALUES (1,1,0,'[{0,18020001,5}]',2,'[{255,36160005,750}]',300),(2,1,0,'[{0,18041001,1}]',2,'[{255,36160005,500}]',150),(3,1,0,'[{0,18041101,1}]',2,'[{255,36160005,500}]',150),(4,1,0,'[{0,18041105,1}]',2,'[{255,36160005,500}]',150),(5,1,0,'[{0,18041002,1}]',2,'[{255,36160005,1600}]',150),(6,1,0,'[{0,18041003,1}]',2,'[{255,36160005,1600}]',150),(7,1,0,'[{0,18041004,1}]',2,'[{255,36160005,1600}]',150),(8,1,0,'[{0,18054801,1}]',2,'[{255,36160005,6000}]',80),(9,1,0,'[{0,18050801,1}]',2,'[{255,36160005,6000}]',80),(10,1,0,'[{0,18050901,1}]',2,'[{255,36160005,6000}]',80),(11,1,0,'[{0,18051001,1}]',2,'[{255,36160005,6000}]',80),(12,1,0,'[{0,18051101,1}]',2,'[{255,36160005,6000}]',80),(13,1,0,'[{0,18051201,1}]',2,'[{255,36160005,6000}]',80),(14,1,0,'[{0,18051301,1}]',2,'[{255,36160005,6000}]',80),(15,1,0,'[{0,18051401,1}]',2,'[{255,36160005,6000}]',80),(16,1,0,'[{0,18060001,5}]',2,'[{255,36160005,1000}]',300),(17,1,0,'[{0,18041002,1}]',1,'[{1,0,80}]',120),(18,1,0,'[{0,18041003,1}]',1,'[{1,0,80}]',120),(19,1,0,'[{0,18041004,1}]',1,'[{1,0,80}]',120),(20,1,0,'[{0,18054801,1}]',1,'[{1,0,300}]',60),(21,1,0,'[{0,18050801,1}]',1,'[{1,0,300}]',60),(22,1,0,'[{0,18050901,1}]',1,'[{1,0,300}]',60),(23,1,0,'[{0,18051001,1}]',1,'[{1,0,300}]',60),(24,1,0,'[{0,18051101,1}]',1,'[{1,0,300}]',60),(25,1,0,'[{0,18051201,1}]',1,'[{1,0,300}]',60),(26,1,0,'[{0,18051301,1}]',1,'[{1,0,300}]',60),(27,1,0,'[{0,18051401,1}]',1,'[{1,0,300}]',60),(28,1,0,'[{0,18060001,5}]',1,'[{1,0,75}]',200),(29,1,0,'[{0,18041001,5}]',2,'[{255,36160005,2500}]',100),(30,1,0,'[{0,18041101,5}]',2,'[{255,36160005,2500}]',100),(31,1,0,'[{0,18041105,5}]',2,'[{255,36160005,2500}]',100),(32,1,0,'[{0,18041002,3}]',2,'[{255,36160005,4500}]',100),(33,1,0,'[{0,18041003,3}]',2,'[{255,36160005,4500}]',100),(34,1,0,'[{0,18041004,3}]',2,'[{255,36160005,4500}]',100),(35,1,0,'[{0,18030002,1}]',2,'[{255,36160005,500}]',80),(36,1,0,'[{0,18041002,3}]',1,'[{1,0,240}]',80),(37,1,0,'[{0,18041003,3}]',1,'[{1,0,240}]',80),(38,1,0,'[{0,18041004,3}]',1,'[{1,0,240}]',80),(39,1,0,'[{0,18030002,5}]',2,'[{1,0,80}]',50);
/*!40000 ALTER TABLE `base_demon_shop_good` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_demon_shop_hit`
--

DROP TABLE IF EXISTS `base_demon_shop_hit`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_demon_shop_hit` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `min` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小次数',
  `max` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大次数',
  `cost` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消耗钻石',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_demon_shop_hit`
--

LOCK TABLES `base_demon_shop_hit` WRITE;
/*!40000 ALTER TABLE `base_demon_shop_hit` DISABLE KEYS */;
INSERT INTO `base_demon_shop_hit` VALUES (1,1,1,1,20),(2,1,2,2,30),(3,1,3,3,40),(4,1,4,10,50),(5,1,11,20,80),(6,1,21,99999,100);
/*!40000 ALTER TABLE `base_demon_shop_hit` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_demon_shop_resolve`
--

DROP TABLE IF EXISTS `base_demon_shop_resolve`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_demon_shop_resolve` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '道具ID',
  `coins` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分解币数',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_demon_shop_resolve`
--

LOCK TABLES `base_demon_shop_resolve` WRITE;
/*!40000 ALTER TABLE `base_demon_shop_resolve` DISABLE KEYS */;
INSERT INTO `base_demon_shop_resolve` VALUES (18041001,250),(18041002,900),(18041003,900),(18041004,900),(18041005,900),(18041006,900),(18041007,900),(18041101,250),(18041102,250),(18041103,250),(18041104,250),(18041105,250);
/*!40000 ALTER TABLE `base_demon_shop_resolve` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_demon_shop_type`
--

DROP TABLE IF EXISTS `base_demon_shop_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_demon_shop_type` (
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商店类型',
  `career` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '职业',
  `refresh_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '每隔时间',
  `discount` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '折扣状态',
  `num` int(11) NOT NULL DEFAULT '0' COMMENT '上架商品数量',
  PRIMARY KEY (`type`,`career`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_demon_shop_type`
--

LOCK TABLES `base_demon_shop_type` WRITE;
/*!40000 ALTER TABLE `base_demon_shop_type` DISABLE KEYS */;
INSERT INTO `base_demon_shop_type` VALUES (1,0,10800,1,8);
/*!40000 ALTER TABLE `base_demon_shop_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_distri_scene`
--

DROP TABLE IF EXISTS `base_distri_scene`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_distri_scene` (
  `id` int(32) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增ID',
  `distri_scene_id` int(32) unsigned NOT NULL COMMENT '场景ID',
  `scene_name` varchar(128) DEFAULT '""' COMMENT '场景名称',
  `scene_type` int(3) unsigned NOT NULL DEFAULT '0' COMMENT '场景类型',
  `transfer_coordinate` varchar(512) NOT NULL DEFAULT '[]' COMMENT '传送坐标',
  `coordinate` varchar(128) NOT NULL DEFAULT '[]' COMMENT '钓鱼区范围',
  `near_water_area` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '近水域',
  `middle_water_area` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '中水域',
  `far_water_area` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '远水域',
  `open_role_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开放等级',
  `open_mastery_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '钓鱼等级',
  `home_fish_pond_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '家园鱼塘等级',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=64 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_distri_scene`
--

LOCK TABLES `base_distri_scene` WRITE;
/*!40000 ALTER TABLE `base_distri_scene` DISABLE KEYS */;
INSERT INTO `base_distri_scene` VALUES (1,1000,'朔月海岸',1,'[{1,[{13180,8361}]}]','[{1,{13925,8923,1000}}]','[50020101,50020102,50020103,50020104,50020105,50020106,50020107,50030101,50030102,50030103,50030104,50030105,50030106]','[50020101,50020102,50020103,50020104,50020105,50020106,50020107,50030101,50030102,50030103,50030104,50030105,50030106]','[50020101,50020102,50020103,50020104,50020105,50020106,50020107,50030101,50030102,50030103,50030104,50030105,50030106]',170,1,0),(2,1004,'诺亚王城',1,'[{1,[{1234,4618}]},{2,[{10854,3959}]}]','[{1,{694,5361,1100}},{2,{11670,3469,1000}}]','[50020101,50020102,50020103,50020104,50020105,50020106,50020107,50020108,50020109,50030101,50030102,50030103,50030104,50030105,50030106,50030107]','[50020101,50020102,50020103,50020104,50020105,50020106,50020107,50020108,50020109,50030101,50030102,50030103,50030104,50030105,50030106,50030107]','[50020101,50020102,50020103,50020104,50020105,50020106,50020107,50020108,50020109,50030101,50030102,50030103,50030104,50030105,50030106,50030107]',170,1,0),(3,1010,'失落之海',1,'[{1,[{6592,5960}]}]','[{1,{6741,6570,700}}]','[50020101,50020102,50020103,50020104,50020105,50020106,50020107,50020108,50020109,50020110,50020111,50030101,50030102,50030103,50030104,50030105,50030106,50030107,50030108,50040101,50040102,50040103,50040104]','[50020101,50020102,50020103,50020104,50020105,50020106,50020107,50020108,50020109,50020110,50020111,50030101,50030102,50030103,50030104,50030105,50030106,50030107,50030108,50040101,50040102,50040103,50040104]','[50020101,50020102,50020103,50020104,50020105,50020106,50020107,50020108,50020109,50020110,50020111,50030101,50030102,50030103,50030104,50030105,50030106,50030107,50030108,50040101,50040102,50040103,50040104]',350,1,0),(4,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[50020101,50020102]','[50020101,50020102]','[50020101,50020102]',250,1,1),(5,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[50030101,50020103]','[50030101,50020103]','[50030101,50020103]',250,1,2),(6,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[50020104,50020105]','[50020104,50020105]','[50020104,50020105]',250,1,3),(7,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[50020106,50020107]','[50020106,50020107]','[50020106,50020107]',250,1,4),(8,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[50030102,50020108]','[50030102,50020108]','[50030102,50020108]',250,1,5),(9,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[50030103,50020109]','[50030103,50020109]','[50030103,50020109]',250,1,6),(10,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[50030104,50040101]','[50030104,50040101]','[50030104,50040101]',250,1,7),(11,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[50020110,50030105]','[50020110,50030105]','[50020110,50030105]',250,1,8),(12,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[50020111,50030106]','[50020111,50030106]','[50020111,50030106]',250,1,9),(13,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[50030107,50030108]','[50030107,50030108]','[50030107,50030108]',250,1,10),(14,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[50040102]','[50040102]','[50040102]',250,1,11),(15,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[50040103]','[50040103]','[50040103]',250,1,12),(16,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[50040104]','[50040104]','[50040104]',250,1,13),(17,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[]','[]','[]',250,1,14),(18,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[]','[]','[]',250,1,15),(19,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[]','[]','[]',250,1,16),(20,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[]','[]','[]',250,1,17),(21,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[]','[]','[]',250,1,18),(22,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[]','[]','[]',250,1,19),(23,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[]','[]','[]',250,1,20),(24,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[]','[]','[]',250,1,21),(25,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[]','[]','[]',250,1,22),(26,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[]','[]','[]',250,1,23),(27,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[]','[]','[]',250,1,24),(28,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[]','[]','[]',250,1,25),(29,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[]','[]','[]',250,1,26),(30,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[]','[]','[]',250,1,27),(31,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[]','[]','[]',250,1,28),(32,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[]','[]','[]',250,1,29),(33,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[]','[]','[]',250,1,30),(34,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[]','[]','[]',250,1,31),(35,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[]','[]','[]',250,1,32),(36,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[]','[]','[]',250,1,33),(37,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[]','[]','[]',250,1,34),(38,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[]','[]','[]',250,1,35),(39,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[]','[]','[]',250,1,36),(40,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[]','[]','[]',250,1,37),(41,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[]','[]','[]',250,1,38),(42,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[]','[]','[]',250,1,39),(43,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[]','[]','[]',250,1,40),(44,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[]','[]','[]',250,1,41),(45,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[]','[]','[]',250,1,42),(46,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[]','[]','[]',250,1,43),(47,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[]','[]','[]',250,1,44),(48,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[]','[]','[]',250,1,45),(49,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[]','[]','[]',250,1,46),(50,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[]','[]','[]',250,1,47),(51,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[]','[]','[]',250,1,48),(52,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[]','[]','[]',250,1,49),(53,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[]','[]','[]',250,1,50),(54,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[]','[]','[]',250,1,51),(55,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[]','[]','[]',250,1,52),(56,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[]','[]','[]',250,1,53),(57,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[]','[]','[]',250,1,54),(58,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[]','[]','[]',250,1,55),(59,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[]','[]','[]',250,1,56),(60,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[]','[]','[]',250,1,57),(61,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[]','[]','[]',250,1,58),(62,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[]','[]','[]',250,1,59),(63,7406,'家园鱼塘',18,'[{1,[{8918,6803}]}]','[{1,{8140,6386,900}}]','[]','[]','[]',250,1,60);
/*!40000 ALTER TABLE `base_distri_scene` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_double_attr_gem_stage`
--

DROP TABLE IF EXISTS `base_double_attr_gem_stage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_double_attr_gem_stage` (
  `gem_type` tinyint(3) unsigned NOT NULL DEFAULT '8' COMMENT '宝石子类型',
  `stage` tinyint(3) unsigned NOT NULL COMMENT '阶数',
  `attr_ratio` tinyint(3) unsigned NOT NULL COMMENT '属性加成',
  `cost` varchar(255) NOT NULL COMMENT '升阶消耗',
  `color` tinyint(3) unsigned NOT NULL COMMENT '加成颜色',
  `extra_attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '附加属性',
  `tips` varchar(255) NOT NULL DEFAULT '[]' COMMENT '描述@lang@',
  PRIMARY KEY (`gem_type`,`stage`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='双属性宝石升阶配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_double_attr_gem_stage`
--

LOCK TABLES `base_double_attr_gem_stage` WRITE;
/*!40000 ALTER TABLE `base_double_attr_gem_stage` DISABLE KEYS */;
INSERT INTO `base_double_attr_gem_stage` VALUES (9,1,10,'[{0,14110001,4}]',0,'[]','该宝石属性 +10%'),(9,2,20,'[{0,14110001,6},{0,14110003,2}]',0,'[]','该宝石属性 +20%'),(9,3,35,'[{0,14110001,10},{0,14110003,4}]',1,'[{2,55,50}]','该宝石属性 +35%'),(9,4,50,'[{0,14110001,15},{0,14110003,6}]',2,'[{3,55,100}]','该宝石属性 +50%'),(9,5,65,'[{0,14110001,20},{0,14110003,8}]',3,'[{3,55,150}]','该宝石属性 +65%'),(9,6,80,'[]',4,'[{4,55,200}]','该宝石属性 +80%'),(10,1,10,'[{0,14110002,4}]',0,'[]','该宝石属性 +10%'),(10,2,20,'[{0,14110002,6},{0,14110004,2}]',0,'[]','该宝石属性 +20%'),(10,3,35,'[{0,14110002,10},{0,14110004,4}]',1,'[{2,57,50}]','该宝石属性 +35%'),(10,4,50,'[{0,14110002,15},{0,14110004,6}]',2,'[{3,57,100}]','该宝石属性 +50%'),(10,5,65,'[{0,14110002,20},{0,14110004,8}]',3,'[{3,57,150}]','该宝石属性 +65%'),(10,6,80,'[]',4,'[{4,57,200}]','该宝石属性 +80%');
/*!40000 ALTER TABLE `base_double_attr_gem_stage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_dress_act_rising`
--

DROP TABLE IF EXISTS `base_dress_act_rising`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_dress_act_rising` (
  `dress_id` int(11) NOT NULL COMMENT '装扮id',
  `dress_star_lv` int(10) NOT NULL COMMENT '装扮星级',
  `dress_type` smallint(2) NOT NULL COMMENT '装扮类型',
  `dress_name` varchar(255) NOT NULL COMMENT '装扮名称',
  `dress_desc` varchar(255) NOT NULL COMMENT '装扮描述',
  `dress_consume_id` int(10) NOT NULL DEFAULT '0' COMMENT '图鉴(装扮)消耗材料id',
  `dress_acti_exp` int(20) NOT NULL DEFAULT '0' COMMENT '单个材料提供升星经验',
  `dress_starup_exp` int(20) NOT NULL DEFAULT '0' COMMENT '装扮升星经验',
  `dress_starup_attr` varchar(1024) CHARACTER SET latin1 NOT NULL COMMENT '装扮升星属性',
  `is_gm` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT 'GM专属',
  PRIMARY KEY (`dress_id`,`dress_star_lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装扮激活升星配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_dress_act_rising`
--

LOCK TABLES `base_dress_act_rising` WRITE;
/*!40000 ALTER TABLE `base_dress_act_rising` DISABLE KEYS */;
INSERT INTO `base_dress_act_rising` VALUES (38140001,0,1,'华丽单身狗','如果不是真的喜欢……',38140001,1,1,'[{2,3400},{3,85}]',0),(38140001,1,1,'华丽单身狗','如果不是真的喜欢……',38140001,1,1,'[{2,6120},{3,153}]',0),(38140001,2,1,'华丽单身狗','如果不是真的喜欢……',38140001,1,2,'[{2,9520},{3,238}]',0),(38140001,3,1,'华丽单身狗','如果不是真的喜欢……',38140001,1,4,'[{2,13600},{3,340}]',0),(38140001,4,1,'华丽单身狗','如果不是真的喜欢……',38140001,1,6,'[{2,18360},{3,459}]',0),(38140001,5,1,'华丽单身狗','如果不是真的喜欢……',38140001,1,8,'[{2,23800},{3,595}]',0),(38140002,0,1,'萌羊星座','来自星星的我，咩',38140002,1,1,'[{2,2200},{3,55}]',0),(38140002,1,1,'萌羊星座','来自星星的我，咩',38140002,1,1,'[{2,3960},{3,99}]',0),(38140002,2,1,'萌羊星座','来自星星的我，咩',38140002,1,2,'[{2,6160},{3,154}]',0),(38140002,3,1,'萌羊星座','来自星星的我，咩',38140002,1,4,'[{2,8800},{3,220}]',0),(38140002,4,1,'萌羊星座','来自星星的我，咩',38140002,1,6,'[{2,11880},{3,297}]',0),(38140002,5,1,'萌羊星座','来自星星的我，咩',38140002,1,8,'[{2,15400},{3,385}]',0),(38140003,0,1,'高级贵族','感受到我的贵族气质了吗',38140003,1,1,'[{2,4880},{3,122}]',0),(38140003,1,1,'高级贵族','感受到我的贵族气质了吗',38140003,1,1,'[{2,8780},{3,220}]',0),(38140003,2,1,'高级贵族','感受到我的贵族气质了吗',38140003,1,2,'[{2,13660},{3,342}]',0),(38140003,3,1,'高级贵族','感受到我的贵族气质了吗',38140003,1,4,'[{2,19500},{3,488}]',0),(38140003,4,1,'高级贵族','感受到我的贵族气质了吗',38140003,1,6,'[{2,26320},{3,659}]',0),(38140003,5,1,'高级贵族','感受到我的贵族气质了吗',38140003,1,8,'[{2,34120},{3,854}]',0),(38140004,0,1,'中级贵族','我的小目标已经实现了',38140004,1,1,'[{2,3580},{3,90}]',0),(38140004,1,1,'中级贵族','我的小目标已经实现了',38140004,1,1,'[{2,6440},{3,162}]',0),(38140004,2,1,'中级贵族','我的小目标已经实现了',38140004,1,2,'[{2,10020},{3,252}]',0),(38140004,3,1,'中级贵族','我的小目标已经实现了',38140004,1,4,'[{2,14320},{3,360}]',0),(38140004,4,1,'中级贵族','我的小目标已经实现了',38140004,1,6,'[{2,19340},{3,486}]',0),(38140004,5,1,'中级贵族','我的小目标已经实现了',38140004,1,8,'[{2,25080},{3,630}]',0),(38140005,0,1,'初级贵族','交个朋友吧',38140005,1,1,'[{2,2280},{3,57}]',0),(38140005,1,1,'初级贵族','交个朋友吧',38140005,1,1,'[{2,4120},{3,103}]',0),(38140005,2,1,'初级贵族','交个朋友吧',38140005,1,2,'[{2,6400},{3,160}]',0),(38140005,3,1,'初级贵族','交个朋友吧',38140005,1,4,'[{2,9140},{3,229}]',0),(38140005,4,1,'初级贵族','交个朋友吧',38140005,1,6,'[{2,12340},{3,309}]',0),(38140005,5,1,'初级贵族','交个朋友吧',38140005,1,8,'[{2,16000},{3,401}]',0),(38140006,0,1,'玫瑰之约','玫瑰之约，浪漫之约',38140006,1,1,'[{2,3960},{3,99}]',0),(38140006,1,1,'玫瑰之约','玫瑰之约，浪漫之约',38140006,1,1,'[{2,7120},{3,178}]',0),(38140006,2,1,'玫瑰之约','玫瑰之约，浪漫之约',38140006,1,2,'[{2,11080},{3,277}]',0),(38140006,3,1,'玫瑰之约','玫瑰之约，浪漫之约',38140006,1,4,'[{2,15820},{3,396}]',0),(38140006,4,1,'玫瑰之约','玫瑰之约，浪漫之约',38140006,1,6,'[{2,21360},{3,535}]',0),(38140006,5,1,'玫瑰之约','玫瑰之约，浪漫之约',38140006,1,8,'[{2,27680},{3,693}]',0),(38140007,0,1,'吃瓜群众','哪里有瓜，哪里就有我',38140007,1,1,'[{2,2380},{3,60}]',0),(38140007,1,1,'吃瓜群众','哪里有瓜，哪里就有我',38140007,1,1,'[{2,4280},{3,108}]',0),(38140007,2,1,'吃瓜群众','哪里有瓜，哪里就有我',38140007,1,2,'[{2,6660},{3,168}]',0),(38140007,3,1,'吃瓜群众','哪里有瓜，哪里就有我',38140007,1,4,'[{2,9520},{3,240}]',0),(38140007,4,1,'吃瓜群众','哪里有瓜，哪里就有我',38140007,1,6,'[{2,12860},{3,324}]',0),(38140007,5,1,'吃瓜群众','哪里有瓜，哪里就有我',38140007,1,8,'[{2,16680},{3,420}]',0),(38140008,0,1,'自然之力','感受大自然的愤怒吧',38140008,1,1,'[{2,3580},{3,90}]',0),(38140008,1,1,'自然之力','感受大自然的愤怒吧',38140008,1,1,'[{2,6440},{3,162}]',0),(38140008,2,1,'自然之力','感受大自然的愤怒吧',38140008,1,2,'[{2,10020},{3,252}]',0),(38140008,3,1,'自然之力','感受大自然的愤怒吧',38140008,1,4,'[{2,14320},{3,360}]',0),(38140008,4,1,'自然之力','感受大自然的愤怒吧',38140008,1,6,'[{2,19340},{3,486}]',0),(38140008,5,1,'自然之力','感受大自然的愤怒吧',38140008,1,8,'[{2,25080},{3,630}]',0),(38141000,0,1,'萌羊接线生','你们好啊',38140002,1,1,'[{1,0},{4,0}]',1),(38141000,1,1,'萌羊接线生','你们好啊',38140002,1,1,'[{1,0},{4,0}]',1),(38141000,2,1,'萌羊接线生','你们好啊',38140002,1,2,'[{1,0},{4,0}]',1),(38141000,3,1,'萌羊接线生','你们好啊',38140002,1,4,'[{1,0},{4,0}]',1),(38141000,4,1,'萌羊接线生','你们好啊',38140002,1,6,'[{1,0},{4,0}]',1),(38141000,5,1,'萌羊接线生','你们好啊',38140002,1,8,'[{1,0},{4,0}]',1),(38142000,0,1,'萌羊指导员','你们好啊',38140002,1,1,'[{1,0},{4,0}]',2),(38142000,1,1,'萌羊指导员','你们好啊',38140002,1,1,'[{1,0},{4,0}]',2),(38142000,2,1,'萌羊指导员','你们好啊',38140002,1,2,'[{1,0},{4,0}]',2),(38142000,3,1,'萌羊指导员','你们好啊',38140002,1,4,'[{1,0},{4,0}]',2),(38142000,4,1,'萌羊指导员','你们好啊',38140002,1,6,'[{1,0},{4,0}]',2),(38142000,5,1,'萌羊指导员','你们好啊',38140002,1,8,'[{1,0},{4,0}]',2),(38150001,0,2,'华丽单身狗','如果不是真的喜欢……',38150001,1,1,'[{1,170},{4,85}]',0),(38150001,1,2,'华丽单身狗','如果不是真的喜欢……',38150001,1,1,'[{1,306},{4,153}]',0),(38150001,2,2,'华丽单身狗','如果不是真的喜欢……',38150001,1,2,'[{1,476},{4,238}]',0),(38150001,3,2,'华丽单身狗','如果不是真的喜欢……',38150001,1,4,'[{1,680},{4,340}]',0),(38150001,4,2,'华丽单身狗','如果不是真的喜欢……',38150001,1,6,'[{1,918},{4,459}]',0),(38150001,5,2,'华丽单身狗','如果不是真的喜欢……',38150001,1,8,'[{1,1190},{4,595}]',0),(38150002,0,2,'萌羊星座','来自星星的我，咩',38150002,1,1,'[{1,110},{4,55}]',0),(38150002,1,2,'萌羊星座','来自星星的我，咩',38150002,1,1,'[{1,198},{4,99}]',0),(38150002,2,2,'萌羊星座','来自星星的我，咩',38150002,1,2,'[{1,308},{4,154}]',0),(38150002,3,2,'萌羊星座','来自星星的我，咩',38150002,1,4,'[{1,440},{4,220}]',0),(38150002,4,2,'萌羊星座','来自星星的我，咩',38150002,1,6,'[{1,594},{4,297}]',0),(38150002,5,2,'萌羊星座','来自星星的我，咩',38150002,1,8,'[{1,770},{4,385}]',0),(38150003,0,2,'高级贵族','感受到我的贵族气质了吗',38150003,1,1,'[{1,244},{4,122}]',0),(38150003,1,2,'高级贵族','感受到我的贵族气质了吗',38150003,1,1,'[{1,439},{4,220}]',0),(38150003,2,2,'高级贵族','感受到我的贵族气质了吗',38150003,1,2,'[{1,683},{4,342}]',0),(38150003,3,2,'高级贵族','感受到我的贵族气质了吗',38150003,1,4,'[{1,975},{4,488}]',0),(38150003,4,2,'高级贵族','感受到我的贵族气质了吗',38150003,1,6,'[{1,1316},{4,659}]',0),(38150003,5,2,'高级贵族','感受到我的贵族气质了吗',38150003,1,8,'[{1,1706},{4,854}]',0),(38150004,0,2,'中级贵族','我的小目标已经实现了',38150004,1,1,'[{1,179},{4,90}]',0),(38150004,1,2,'中级贵族','我的小目标已经实现了',38150004,1,1,'[{1,322},{4,162}]',0),(38150004,2,2,'中级贵族','我的小目标已经实现了',38150004,1,2,'[{1,501},{4,252}]',0),(38150004,3,2,'中级贵族','我的小目标已经实现了',38150004,1,4,'[{1,716},{4,360}]',0),(38150004,4,2,'中级贵族','我的小目标已经实现了',38150004,1,6,'[{1,967},{4,486}]',0),(38150004,5,2,'中级贵族','我的小目标已经实现了',38150004,1,8,'[{1,1254},{4,630}]',0),(38150005,0,2,'初级贵族','交个朋友吧',38150005,1,1,'[{1,114},{4,57}]',0),(38150005,1,2,'初级贵族','交个朋友吧',38150005,1,1,'[{1,206},{4,103}]',0),(38150005,2,2,'初级贵族','交个朋友吧',38150005,1,2,'[{1,320},{4,160}]',0),(38150005,3,2,'初级贵族','交个朋友吧',38150005,1,4,'[{1,457},{4,229}]',0),(38150005,4,2,'初级贵族','交个朋友吧',38150005,1,6,'[{1,617},{4,309}]',0),(38150005,5,2,'初级贵族','交个朋友吧',38150005,1,8,'[{1,800},{4,401}]',0),(38150006,0,2,'玫瑰之约','玫瑰之约，浪漫之约',38150006,1,1,'[{1,198},{4,99}]',0),(38150006,1,2,'玫瑰之约','玫瑰之约，浪漫之约',38150006,1,1,'[{1,356},{4,178}]',0),(38150006,2,2,'玫瑰之约','玫瑰之约，浪漫之约',38150006,1,2,'[{1,554},{4,277}]',0),(38150006,3,2,'玫瑰之约','玫瑰之约，浪漫之约',38150006,1,4,'[{1,791},{4,396}]',0),(38150006,4,2,'玫瑰之约','玫瑰之约，浪漫之约',38150006,1,6,'[{1,1068},{4,535}]',0),(38150006,5,2,'玫瑰之约','玫瑰之约，浪漫之约',38150006,1,8,'[{1,1384},{4,693}]',0),(38150007,0,2,'吃瓜群众','哪里有瓜，哪里就有我',38150007,1,1,'[{1,119},{4,60}]',0),(38150007,1,2,'吃瓜群众','哪里有瓜，哪里就有我',38150007,1,1,'[{1,214},{4,108}]',0),(38150007,2,2,'吃瓜群众','哪里有瓜，哪里就有我',38150007,1,2,'[{1,333},{4,168}]',0),(38150007,3,2,'吃瓜群众','哪里有瓜，哪里就有我',38150007,1,4,'[{1,476},{4,240}]',0),(38150007,4,2,'吃瓜群众','哪里有瓜，哪里就有我',38150007,1,6,'[{1,643},{4,324}]',0),(38150007,5,2,'吃瓜群众','哪里有瓜，哪里就有我',38150007,1,8,'[{1,834},{4,420}]',0),(38150008,0,2,'自然之力','感受大自然的愤怒吧',38150008,1,1,'[{1,179},{4,90}]',0),(38150008,1,2,'自然之力','感受大自然的愤怒吧',38150008,1,1,'[{1,322},{4,162}]',0),(38150008,2,2,'自然之力','感受大自然的愤怒吧',38150008,1,2,'[{1,501},{4,252}]',0),(38150008,3,2,'自然之力','感受大自然的愤怒吧',38150008,1,4,'[{1,716},{4,360}]',0),(38150008,4,2,'自然之力','感受大自然的愤怒吧',38150008,1,6,'[{1,967},{4,486}]',0),(38150008,5,2,'自然之力','感受大自然的愤怒吧',38150008,1,8,'[{1,1254},{4,630}]',0),(38151000,0,2,'萌羊接线生','你们好啊',38140002,1,1,'[{1,0},{4,0}]',1),(38151000,1,2,'萌羊接线生','你们好啊',38140002,1,1,'[{1,0},{4,0}]',1),(38151000,2,2,'萌羊接线生','你们好啊',38140002,1,2,'[{1,0},{4,0}]',1),(38151000,3,2,'萌羊接线生','你们好啊',38140002,1,4,'[{1,0},{4,0}]',1),(38151000,4,2,'萌羊接线生','你们好啊',38140002,1,6,'[{1,0},{4,0}]',1),(38151000,5,2,'萌羊接线生','你们好啊',38140002,1,8,'[{1,0},{4,0}]',1),(38152000,0,2,'萌羊指导员','你们好啊',38140002,1,1,'[{1,0},{4,0}]',2),(38152000,1,2,'萌羊指导员','你们好啊',38140002,1,1,'[{1,0},{4,0}]',2),(38152000,2,2,'萌羊指导员','你们好啊',38140002,1,2,'[{1,0},{4,0}]',2),(38152000,3,2,'萌羊指导员','你们好啊',38140002,1,4,'[{1,0},{4,0}]',2),(38152000,4,2,'萌羊指导员','你们好啊',38140002,1,6,'[{1,0},{4,0}]',2),(38152000,5,2,'萌羊指导员','你们好啊',38140002,1,8,'[{1,0},{4,0}]',2);
/*!40000 ALTER TABLE `base_dress_act_rising` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_dress_illustration`
--

DROP TABLE IF EXISTS `base_dress_illustration`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_dress_illustration` (
  `illu_lv` int(10) NOT NULL COMMENT '图鉴等级',
  `illu_lvup_exp` int(20) NOT NULL DEFAULT '0' COMMENT '图鉴升级经验',
  `illu_lvup_sttr` varchar(1024) NOT NULL COMMENT '图鉴升级属性',
  PRIMARY KEY (`illu_lv`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COMMENT='图鉴升级配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_dress_illustration`
--

LOCK TABLES `base_dress_illustration` WRITE;
/*!40000 ALTER TABLE `base_dress_illustration` DISABLE KEYS */;
INSERT INTO `base_dress_illustration` VALUES (0,280,'[{68,0}]'),(1,350,'[{68,100}]'),(2,420,'[{68,200}]'),(3,490,'[{68,300}]'),(4,560,'[{68,400}]'),(5,630,'[{68,500}]'),(6,700,'[{68,600}]'),(7,770,'[{68,700}]'),(8,840,'[{68,800}]'),(9,910,'[{68,900}]'),(10,980,'[{68,1000}]'),(11,1050,'[{68,1100}]'),(12,1120,'[{68,1200}]'),(13,1190,'[{68,1300}]'),(14,1260,'[{68,1400}]'),(15,1330,'[{68,1500}]'),(16,1400,'[{68,1600}]'),(17,1470,'[{68,1700}]'),(18,1540,'[{68,1800}]'),(19,1610,'[{68,1900}]'),(20,1680,'[{68,2000}]'),(21,1750,'[{68,2100}]'),(22,1820,'[{68,2200}]'),(23,1890,'[{68,2300}]'),(24,1960,'[{68,2400}]'),(25,2035,'[{68,2500}]'),(26,2105,'[{68,2600}]'),(27,2175,'[{68,2700}]'),(28,2245,'[{68,2800}]'),(29,2315,'[{68,2900}]'),(30,2385,'[{68,3000}]'),(31,2455,'[{68,3100}]'),(32,2525,'[{68,3200}]'),(33,2595,'[{68,3300}]'),(34,2665,'[{68,3400}]'),(35,2735,'[{68,3500}]'),(36,2805,'[{68,3600}]'),(37,2875,'[{68,3700}]'),(38,2945,'[{68,3800}]'),(39,3015,'[{68,3900}]'),(40,3085,'[{68,4000}]'),(41,3155,'[{68,4100}]'),(42,3225,'[{68,4200}]'),(43,3295,'[{68,4300}]'),(44,3365,'[{68,4400}]'),(45,3435,'[{68,4500}]'),(46,3505,'[{68,4600}]'),(47,3575,'[{68,4700}]'),(48,3645,'[{68,4800}]'),(49,3715,'[{68,4900}]'),(50,0,'[{68,5000}]');
/*!40000 ALTER TABLE `base_dress_illustration` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_dress_illustration_mat`
--

DROP TABLE IF EXISTS `base_dress_illustration_mat`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_dress_illustration_mat` (
  `illu_debris_id` int(10) NOT NULL COMMENT '物品id',
  `illu_exp` int(20) NOT NULL DEFAULT '0' COMMENT '图鉴经验',
  PRIMARY KEY (`illu_debris_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='图鉴(装扮)消耗材料';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_dress_illustration_mat`
--

LOCK TABLES `base_dress_illustration_mat` WRITE;
/*!40000 ALTER TABLE `base_dress_illustration_mat` DISABLE KEYS */;
INSERT INTO `base_dress_illustration_mat` VALUES (38140001,288),(38140002,288),(38140003,288),(38140004,288),(38140005,288),(38140006,288),(38140007,288),(38140008,288),(38141000,0),(38142000,0),(38150001,288),(38150002,288),(38150003,288),(38150004,288),(38150005,288),(38150006,288),(38150007,288),(38150008,288),(38151000,0),(38152000,0);
/*!40000 ALTER TABLE `base_dress_illustration_mat` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_drop_goods`
--

DROP TABLE IF EXISTS `base_drop_goods`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_drop_goods` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '类型，0 随机掉落物品，1 固定掉落物品，2 任务物品',
  `drop_thing_type` smallint(6) unsigned NOT NULL DEFAULT '0' COMMENT '掉落物类型',
  `list_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '列表ID',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品ID',
  `ratio` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '机率',
  `career_ratio_list` varchar(512) NOT NULL DEFAULT '[]' COMMENT '职业机率列表',
  `num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大掉落数',
  `min_num` int(11) DEFAULT '0' COMMENT '最小掉落数',
  `cond_list` varchar(512) NOT NULL DEFAULT '[]' COMMENT '条件列表',
  `get_way` tinyint(1) NOT NULL COMMENT '获得方式',
  `drop_icon` varchar(255) DEFAULT NULL COMMENT '掉落在地上显示的图标0：无图标；>0:掉落图标id',
  `drop_leff` varchar(255) DEFAULT NULL COMMENT '掉落在地上显示的光效：0：无光效；>0:光效id',
  `bind` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '绑定状态',
  `notice` varchar(255) NOT NULL COMMENT '传闻@lang@',
  `hour_start` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '时间段限制，0为无',
  `hour_end` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '时间段限制，0为无',
  `time_start` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '日期限制，0为无',
  `time_end` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '日期限制，0为无',
  `replace_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT '职业替换列表',
  PRIMARY KEY (`id`),
  KEY `type` (`type`),
  KEY `list_id` (`list_id`),
  KEY `goods_id` (`goods_id`)
) ENGINE=InnoDB AUTO_INCREMENT=400004749 DEFAULT CHARSET=utf8 COMMENT='掉落物品表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_drop_goods`
--

LOCK TABLES `base_drop_goods` WRITE;
/*!40000 ALTER TABLE `base_drop_goods` DISABLE KEYS */;
INSERT INTO `base_drop_goods` VALUES (1001,0,0,1,38250001,0,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(2001,0,0,2,38260001,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(3001,0,0,3,38270011,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(4001,0,0,4,38270012,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(5001,0,0,5,38270013,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(6001,0,0,6,38270011,18,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(6002,0,0,6,38270012,6,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(6003,0,0,6,38270013,1,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(7001,0,0,7,38230102,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(7002,0,0,7,38230202,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(7003,0,0,7,38230302,0,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(7004,0,0,7,38230402,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(7005,0,0,7,38230104,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(7006,0,0,7,38230204,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(7007,0,0,7,38230304,0,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(7008,0,0,7,38230404,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(7009,0,0,7,38230106,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(7010,0,0,7,38230206,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(7011,0,0,7,38230306,0,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(7012,0,0,7,38230406,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(7013,0,0,7,38230108,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(7014,0,0,7,38230208,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(7015,0,0,7,38230308,0,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(7016,0,0,7,38230408,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(7017,0,0,7,38230110,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(7018,0,0,7,38230210,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(7019,0,0,7,38230310,0,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(7020,0,0,7,38230410,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(8001,0,0,8,38230101,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(8002,0,0,8,38230201,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(8003,0,0,8,38230301,0,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(8004,0,0,8,38230401,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(8005,0,0,8,38230107,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(8006,0,0,8,38230207,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(8007,0,0,8,38230307,0,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(8008,0,0,8,38230407,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(9001,0,0,9,38230003,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(9002,0,0,9,38230005,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(9003,0,0,9,38230009,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(10001,0,0,10,38240002,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(10002,0,0,10,38240004,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(10003,0,0,10,38240006,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(10004,0,0,10,38240008,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(10005,0,0,10,38240010,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(11001,0,0,11,38240001,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(11002,0,0,11,38240007,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(12001,0,0,12,38240003,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(12002,0,0,12,38240005,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(12003,0,0,12,38240009,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(13001,0,0,13,38230102,18,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(13002,0,0,13,38230202,18,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(13003,0,0,13,38230302,0,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(13004,0,0,13,38230402,18,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(13005,0,0,13,38230104,18,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(13006,0,0,13,38230204,18,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(13007,0,0,13,38230304,0,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(13008,0,0,13,38230404,18,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(13009,0,0,13,38230106,18,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(13010,0,0,13,38230206,18,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(13011,0,0,13,38230306,0,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(13012,0,0,13,38230406,18,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(13013,0,0,13,38230108,18,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(13014,0,0,13,38230208,18,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(13015,0,0,13,38230308,0,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(13016,0,0,13,38230408,18,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(13017,0,0,13,38230110,18,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(13018,0,0,13,38230210,18,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(13019,0,0,13,38230310,0,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(13020,0,0,13,38230410,18,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(13021,0,0,13,38230101,6,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(13022,0,0,13,38230201,6,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(13023,0,0,13,38230301,0,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(13024,0,0,13,38230401,6,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(13025,0,0,13,38230107,6,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(13026,0,0,13,38230207,6,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(13027,0,0,13,38230307,0,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(13028,0,0,13,38230407,6,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(13029,0,0,13,38230003,1,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(13030,0,0,13,38230005,1,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(13031,0,0,13,38230009,1,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(14001,0,0,14,38240002,60,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(14002,0,0,14,38240004,60,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(14003,0,0,14,38240006,60,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(14004,0,0,14,38240008,60,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(14005,0,0,14,38240010,60,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(14006,0,0,14,38240001,39,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(14007,0,0,14,38240007,39,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(14008,0,0,14,38240003,8,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(14009,0,0,14,38240005,8,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(14010,0,0,14,38240009,8,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(15001,0,0,15,0,100,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[{1,1002010331},{2,1002020331},{3,1002030331},{4,1002040331}]'),(16001,0,0,16,0,100,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[{1,1004010331},{2,1004020331},{3,1004030331},{4,1004040331}]'),(17001,0,0,17,15020301,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(18001,0,0,18,32000028,100,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(19001,0,0,19,38230102,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(19002,0,0,19,38230104,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(19003,0,0,19,38230106,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(19004,0,0,19,38230108,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(19005,0,0,19,38230110,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(20001,0,0,20,38230202,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(20002,0,0,20,38230204,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(20003,0,0,20,38230206,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(20004,0,0,20,38230208,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(20005,0,0,20,38230210,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(21001,0,0,21,38230302,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(21002,0,0,21,38230304,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(21003,0,0,21,38230306,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(21004,0,0,21,38230308,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(21005,0,0,21,38230310,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(22001,0,0,22,38230402,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(22002,0,0,22,38230404,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(22003,0,0,22,38230406,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(22004,0,0,22,38230408,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(22005,0,0,22,38230410,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(23001,0,0,23,38230101,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(23002,0,0,23,38230107,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(24001,0,0,24,38230201,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(24002,0,0,24,38230207,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(25001,0,0,25,38230301,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(25002,0,0,25,38230307,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(26001,0,0,26,38230401,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(26002,0,0,26,38230407,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(27001,0,3,27,36030001,100,'[]',100,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(28001,0,3,28,36030001,100,'[]',1000,50,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(29001,0,3,29,36030001,100,'[]',2000,100,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(30001,0,3,30,36030001,100,'[]',10000,10000,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(31001,0,0,31,38130001,224,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(31002,0,0,31,11020001,75,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(32001,0,0,32,38030006,19,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(32002,0,0,32,38030007,19,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(32003,0,0,32,38130001,144,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(32004,0,0,32,11020001,48,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(32005,0,0,32,38040102,288,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(32006,0,0,32,38100001,29,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(32007,0,0,32,38190001,96,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(33001,0,0,33,17010001,252,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(33002,0,0,33,38030006,17,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(33003,0,0,33,38030007,17,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(33004,0,0,33,38130001,126,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(33005,0,0,33,11020001,42,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(33006,0,0,33,18020001,59,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(33007,0,0,33,38040102,252,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(33008,0,0,33,38100001,25,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(33009,0,0,33,38190001,84,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(34001,0,0,34,17010001,244,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(34002,0,0,34,38330001,122,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(34003,0,0,34,38030006,16,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(34004,0,0,34,38030007,16,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(34005,0,0,34,38130001,122,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(34006,0,0,34,11020001,41,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(34007,0,0,34,18020001,57,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(34008,0,0,34,38040102,244,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(34009,0,0,34,38100001,24,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(34010,0,0,34,38190001,81,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(35001,0,0,35,17010001,244,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(35002,0,0,35,38040010,33,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(35003,0,0,35,38330001,122,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(35004,0,0,35,38030006,16,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(35005,0,0,35,38030007,16,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(35006,0,0,35,38130001,122,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(35007,0,0,35,11020001,41,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(35008,0,0,35,18020001,57,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(35009,0,0,35,38040102,244,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(35010,0,0,35,38100001,24,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(35011,0,0,35,38190001,81,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(36001,0,0,36,17010001,236,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(36002,0,0,36,17010002,31,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(36003,0,0,36,38040010,31,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(36004,0,0,36,38330001,118,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(36005,0,0,36,38030006,16,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(36006,0,0,36,38030007,16,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(36007,0,0,36,38130001,118,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(36008,0,0,36,11020001,39,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(36009,0,0,36,18020001,55,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(36010,0,0,36,38040102,236,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(36011,0,0,36,38100001,24,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(36012,0,0,36,38190001,79,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(37001,0,0,37,17010002,31,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(37002,0,0,37,17010003,8,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(37003,0,0,37,38040010,31,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(37004,0,0,37,38330001,117,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(37005,0,0,37,38030006,16,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(37006,0,0,37,38030007,16,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(37007,0,0,37,38130001,117,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(37008,0,0,37,11020001,39,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(37009,0,0,37,18020001,55,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(37010,0,0,37,38040102,234,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(37011,0,0,37,38100001,23,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(37012,0,0,37,38190001,78,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(38001,0,0,38,38130001,500,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(38002,0,3,38,36030001,260,'[]',50,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(38003,0,0,38,1002010100,0,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(38004,0,0,38,1002020100,0,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(38005,0,0,38,1002040100,0,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(38006,0,0,38,1004010100,0,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(38007,0,0,38,1004020100,0,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(38008,0,0,38,1004040100,0,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(38009,0,0,38,1006010100,0,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(38010,0,0,38,1006020100,0,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(38011,0,0,38,1006040100,0,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(38012,0,0,38,1008010100,0,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(38013,0,0,38,1008020100,0,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(38014,0,0,38,1008040100,0,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(38015,0,0,38,1010010100,0,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(38016,0,0,38,1010020100,0,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(38017,0,0,38,1010040100,0,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(38018,0,0,38,1001010100,0,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(38019,0,0,38,1001020100,0,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(38020,0,0,38,1001040100,0,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(38021,0,0,38,1007010100,0,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(38022,0,0,38,1007020100,0,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(38023,0,0,38,1007040100,0,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(38024,0,0,38,1003000100,0,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(38025,0,0,38,1005000100,0,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(38026,0,0,38,1009000100,0,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(39001,0,0,39,37010501,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(40001,0,0,40,37010502,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(41001,0,0,41,37010503,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(42001,0,0,42,37010504,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(43001,0,0,43,37010505,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(44001,0,0,44,37010506,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(45001,0,0,45,37010507,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(46001,0,0,46,37010508,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(47001,0,0,47,37010509,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(48001,0,0,48,37010510,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(49001,0,0,49,37010511,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(50001,0,0,50,37010512,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(51001,0,0,51,0,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[{1,38230102},{2,38230202},{3,38230302},{4,38230402}]'),(51002,0,0,51,0,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[{1,38230104},{2,38230204},{3,38230304},{4,38230404}]'),(51003,0,0,51,0,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[{1,38230106},{2,38230206},{3,38230306},{4,38230406}]'),(51004,0,0,51,0,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[{1,38230108},{2,38230208},{3,38230308},{4,38230408}]'),(51005,0,0,51,0,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[{1,38230110},{2,38230210},{3,38230310},{4,38230410}]'),(52001,0,0,52,0,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[{1,38230101},{2,38230201},{3,38230301},{4,38230401}]'),(52002,0,0,52,0,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[{1,38230107},{2,38230207},{3,38230307},{4,38230407}]'),(53001,0,0,53,0,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[{1,1002010100},{2,1002020100},{3,1002030100},{4,1002040100}]'),(54001,0,0,54,0,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[{1,1004010100},{2,1004020100},{3,1004030100},{4,1004040100}]'),(55001,0,0,55,0,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[{1,1006010100},{2,1006020100},{3,1006030100},{4,1006040100}]'),(56001,0,0,56,0,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[{1,1008010100},{2,1008020100},{3,1008030100},{4,1008040100}]'),(57001,0,0,57,0,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[{1,1010010100},{2,1010020100},{3,1010030100},{4,1010040100}]'),(58001,0,0,58,0,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[{1,1001010100},{2,1001020100},{3,1001030100},{4,1001040100}]'),(59001,0,0,59,0,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[{1,1007010100},{2,1007020100},{3,1007030100},{4,1007040100}]'),(60001,0,0,60,1003000100,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(61001,0,0,61,1005000100,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(62001,0,0,62,1009000100,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(63001,0,0,63,0,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[{1,1002010110},{2,1002020110},{3,1002030110},{4,1002040110}]'),(64001,0,0,64,0,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[{1,1004010110},{2,1004020110},{3,1004030110},{4,1004040110}]'),(65001,0,0,65,0,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[{1,1006010110},{2,1006020110},{3,1006030110},{4,1006040110}]'),(66001,0,0,66,0,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[{1,1008010110},{2,1008020110},{3,1008030110},{4,1008040110}]'),(67001,0,0,67,0,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[{1,1010010110},{2,1010020110},{3,1010030110},{4,1010040110}]'),(68001,0,0,68,0,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[{1,1001010110},{2,1001020110},{3,1001030110},{4,1001040110}]'),(69001,0,0,69,0,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[{1,1007010110},{2,1007020110},{3,1007030110},{4,1007040110}]'),(70001,0,0,70,1003000110,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(71001,0,0,71,1005000110,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(72001,0,0,72,1009000110,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(73001,0,0,73,0,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[{1,1002010120},{2,1002020120},{3,1002030120},{4,1002040120}]'),(74001,0,0,74,0,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[{1,1004010120},{2,1004020120},{3,1004030120},{4,1004040120}]'),(75001,0,0,75,0,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[{1,1006010120},{2,1006020120},{3,1006030120},{4,1006040120}]'),(76001,0,0,76,0,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[{1,1008010120},{2,1008020120},{3,1008030120},{4,1008040120}]'),(77001,0,0,77,0,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[{1,1010010120},{2,1010020120},{3,1010030120},{4,1010040120}]'),(78001,0,0,78,0,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[{1,1001010120},{2,1001020120},{3,1001030120},{4,1001040120}]'),(79001,0,0,79,0,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[{1,1007010120},{2,1007020120},{3,1007030120},{4,1007040120}]'),(80001,0,0,80,1003000120,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(81001,0,0,81,1005000120,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(82001,0,0,82,1009000120,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(83001,0,0,83,0,18,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[{1,38230102},{2,38230202},{3,38230302},{4,38230402}]'),(83002,0,0,83,0,18,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[{1,38230104},{2,38230204},{3,38230304},{4,38230404}]'),(83003,0,0,83,0,18,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[{1,38230106},{2,38230206},{3,38230306},{4,38230406}]'),(83004,0,0,83,0,18,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[{1,38230108},{2,38230208},{3,38230308},{4,38230408}]'),(83005,0,0,83,0,18,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[{1,38230110},{2,38230210},{3,38230310},{4,38230410}]'),(83006,0,0,83,0,6,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[{1,38230101},{2,38230201},{3,38230301},{4,38230401}]'),(83007,0,0,83,0,6,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[{1,38230107},{2,38230207},{3,38230307},{4,38230407}]'),(83008,0,0,83,38230003,1,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(83009,0,0,83,38230005,1,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(83010,0,0,83,38230009,1,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(84001,0,0,84,38100001,50,'[]',5,5,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(84002,0,0,84,38100009,20,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(84003,0,0,84,38100010,1,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(84004,0,0,84,38100008,15,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(84005,0,0,84,38100007,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(84006,0,0,84,40010012,4,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(85001,0,0,85,38110001,100,'[]',1,1,'[{turn,[0]},{turn_tasks, [4]}]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(86001,0,0,86,38110002,100,'[]',1,1,'[{turn,[1]},{turn_tasks, [9]}]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(87001,0,0,87,38110003,100,'[]',1,1,'[{turn,[2]},{turn_tasks, [14]}]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(88001,0,0,88,38110004,100,'[]',1,1,'[{turn,[3]}]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(89001,0,0,89,38110005,60,'[]',1,1,'[{turn,[4]},{turn_tasks, [16]}]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(89002,0,0,89,38110006,45,'[]',1,1,'[{turn,[4]},{turn_tasks, [16]}]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(89003,0,0,89,38110007,30,'[]',1,1,'[{turn,[4]},{turn_tasks, [16]}]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(90001,0,0,90,38110001,100,'[]',1,1,'[{turn,[5]},{turn_tasks, [17]}]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(91001,0,0,91,38110002,100,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(92001,0,0,92,38040013,20,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(92002,0,0,92,38040014,20,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(92003,0,0,92,38040015,13,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(92004,0,0,92,38040016,13,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(92005,0,0,92,38040017,1,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(93001,0,0,93,20040001,10,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(94001,0,0,94,20040002,10,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(95001,0,0,95,20040002,10,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(95002,0,0,95,20040003,10,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(96001,0,0,96,20040002,10,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(96002,0,0,96,20040003,10,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(96003,0,0,96,20040004,10,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(97001,0,0,97,20040003,10,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(97002,0,0,97,20040004,10,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(97003,0,0,97,20040005,10,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(97004,0,0,97,20040000,5,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(98001,0,0,98,24031001,20,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(98002,0,0,98,24031002,20,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(98003,0,0,98,24031003,20,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(98004,0,0,98,24031004,20,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(98005,0,0,98,24031005,20,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(98006,0,0,98,24031006,20,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(98007,0,0,98,24031007,20,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(98008,0,0,98,24031008,0,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(98009,0,0,98,24031009,0,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(98010,0,0,98,24030001,3,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(98011,0,0,98,24030002,3,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(98012,0,0,98,24030003,3,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(98013,0,0,98,24030004,3,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(98014,0,0,98,24030005,3,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(98015,0,0,98,24030006,3,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(98016,0,0,98,24030007,3,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(98017,0,0,98,24030008,0,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(98018,0,0,98,24030009,0,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(99001,0,0,99,18030001,10,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(100001,0,0,100,45010001,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(100002,0,0,100,45010002,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(100003,0,0,100,45010003,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(100004,0,0,100,45010004,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(100005,0,0,100,45010005,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(101001,0,0,101,45010001,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(101002,0,0,101,45010002,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(101003,0,0,101,45010003,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(101004,0,0,101,45010004,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(101005,0,0,101,45010005,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(101006,0,0,101,45010006,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(101007,0,0,101,45010007,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(101008,0,0,101,45010008,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(101009,0,0,101,45010009,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(101010,0,0,101,45010010,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(102001,0,0,102,45010001,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(102002,0,0,102,45010002,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(102003,0,0,102,45010003,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(102004,0,0,102,45010004,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(102005,0,0,102,45010005,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(102006,0,0,102,45010006,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(102007,0,0,102,45010007,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(102008,0,0,102,45010008,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(102009,0,0,102,45010009,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(102010,0,0,102,45010010,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(102011,0,0,102,45010011,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(102012,0,0,102,45010012,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(102013,0,0,102,45010013,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(102014,0,0,102,45010014,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(102015,0,0,102,45010015,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(103001,0,0,103,45010001,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(103002,0,0,103,45010002,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(103003,0,0,103,45010003,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(103004,0,0,103,45010004,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(103005,0,0,103,45010005,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(103006,0,0,103,45010006,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(103007,0,0,103,45010007,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(103008,0,0,103,45010008,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(103009,0,0,103,45010009,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(103010,0,0,103,45010010,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(103011,0,0,103,45010011,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(103012,0,0,103,45010012,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(103013,0,0,103,45010013,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(103014,0,0,103,45010014,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(103015,0,0,103,45010015,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(103016,0,0,103,45010016,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(103017,0,0,103,45010101,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(103018,0,0,103,45010102,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(103019,0,0,103,45010103,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(103020,0,0,103,45010104,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(104001,0,0,104,45010001,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(104002,0,0,104,45010002,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(104003,0,0,104,45010003,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(104004,0,0,104,45010004,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(104005,0,0,104,45010005,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(104006,0,0,104,45010006,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(104007,0,0,104,45010007,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(104008,0,0,104,45010008,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(104009,0,0,104,45010009,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(104010,0,0,104,45010010,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(104011,0,0,104,45010011,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(104012,0,0,104,45010012,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(104013,0,0,104,45010013,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(104014,0,0,104,45010014,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(104015,0,0,104,45010015,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(104016,0,0,104,45010016,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(104017,0,0,104,45010101,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(104018,0,0,104,45010102,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(104019,0,0,104,45010103,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(104020,0,0,104,45010104,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(104021,0,0,104,45010105,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(104022,0,0,104,45010106,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(104023,0,0,104,45010107,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(104024,0,0,104,45010108,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(104025,0,0,104,45010109,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(105001,0,0,105,45010001,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(105002,0,0,105,45010002,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(105003,0,0,105,45010003,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(105004,0,0,105,45010004,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(105005,0,0,105,45010005,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(105006,0,0,105,45010006,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(105007,0,0,105,45010007,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(105008,0,0,105,45010008,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(105009,0,0,105,45010009,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(105010,0,0,105,45010010,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(105011,0,0,105,45010011,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(105012,0,0,105,45010012,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(105013,0,0,105,45010013,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(105014,0,0,105,45010014,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(105015,0,0,105,45010015,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(105016,0,0,105,45010016,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(105017,0,0,105,45010101,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(105018,0,0,105,45010102,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(105019,0,0,105,45010103,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(105020,0,0,105,45010104,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(105021,0,0,105,45010105,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(105022,0,0,105,45010106,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(105023,0,0,105,45010107,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(105024,0,0,105,45010108,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(105025,0,0,105,45010109,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(105026,0,0,105,45010110,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(105027,0,0,105,45010111,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(105028,0,0,105,45010112,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(105029,0,0,105,45010113,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(105030,0,0,105,45010114,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(106001,0,0,106,45010001,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(106002,0,0,106,45010002,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(106003,0,0,106,45010003,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(106004,0,0,106,45010004,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(106005,0,0,106,45010005,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(106006,0,0,106,45010006,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(106007,0,0,106,45010007,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(106008,0,0,106,45010008,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(106009,0,0,106,45010009,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(106010,0,0,106,45010010,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(106011,0,0,106,45010011,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(106012,0,0,106,45010012,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(106013,0,0,106,45010013,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(106014,0,0,106,45010014,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(106015,0,0,106,45010015,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(106016,0,0,106,45010016,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(106017,0,0,106,45010101,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(106018,0,0,106,45010102,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(106019,0,0,106,45010103,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(106020,0,0,106,45010104,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(106021,0,0,106,45010105,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(106022,0,0,106,45010106,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(106023,0,0,106,45010107,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(106024,0,0,106,45010108,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(106025,0,0,106,45010109,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(106026,0,0,106,45010110,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(106027,0,0,106,45010111,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(106028,0,0,106,45010112,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(106029,0,0,106,45010113,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(106030,0,0,106,45010114,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(106031,0,0,106,45010115,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(106032,0,0,106,45010116,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(106033,0,0,106,45010117,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(106034,0,0,106,45010118,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(106035,0,0,106,45010201,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(107001,0,0,107,45010001,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(107002,0,0,107,45010002,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(107003,0,0,107,45010003,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(107004,0,0,107,45010004,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(107005,0,0,107,45010005,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(107006,0,0,107,45010006,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(107007,0,0,107,45010007,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(107008,0,0,107,45010008,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(107009,0,0,107,45010009,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(107010,0,0,107,45010010,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(107011,0,0,107,45010011,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(107012,0,0,107,45010012,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(107013,0,0,107,45010013,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(107014,0,0,107,45010014,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(107015,0,0,107,45010015,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(107016,0,0,107,45010016,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(107017,0,0,107,45010101,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(107018,0,0,107,45010102,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(107019,0,0,107,45010103,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(107020,0,0,107,45010104,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(107021,0,0,107,45010105,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(107022,0,0,107,45010106,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(107023,0,0,107,45010107,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(107024,0,0,107,45010108,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(107025,0,0,107,45010109,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(107026,0,0,107,45010110,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(107027,0,0,107,45010111,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(107028,0,0,107,45010112,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(107029,0,0,107,45010113,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(107030,0,0,107,45010114,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(107031,0,0,107,45010115,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(107032,0,0,107,45010116,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(107033,0,0,107,45010117,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(107034,0,0,107,45010118,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(107035,0,0,107,45010201,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(107036,0,0,107,45010202,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(107037,0,0,107,45010203,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(107038,0,0,107,45010204,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(107039,0,0,107,45010205,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(107040,0,0,107,45010206,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(108001,0,0,108,45010201,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(108002,0,0,108,45010202,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(108003,0,0,108,45010203,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(109001,0,0,109,45010201,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(109002,0,0,109,45010202,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(109003,0,0,109,45010203,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(110001,0,0,110,45010201,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(110002,0,0,110,45010202,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(110003,0,0,110,45010203,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(110004,0,0,110,45010204,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(110005,0,0,110,45010205,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(110006,0,0,110,45010206,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(111001,0,0,111,45010201,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(111002,0,0,111,45010202,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(111003,0,0,111,45010203,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(111004,0,0,111,45010204,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(111005,0,0,111,45010205,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(111006,0,0,111,45010206,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(111007,0,0,111,45010301,10,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111008,0,0,111,45010302,10,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111009,0,0,111,45010303,10,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112001,0,0,112,45010201,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(112002,0,0,112,45010202,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(112003,0,0,112,45010203,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(112004,0,0,112,45010204,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(112005,0,0,112,45010205,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(112006,0,0,112,45010206,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(112007,0,0,112,45010301,10,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112008,0,0,112,45010302,10,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112009,0,0,112,45010303,10,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113001,0,0,113,45010201,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(113002,0,0,113,45010202,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(113003,0,0,113,45010203,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(113004,0,0,113,45010204,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(113005,0,0,113,45010205,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(113006,0,0,113,45010206,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(113007,0,0,113,45010301,10,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113008,0,0,113,45010302,10,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113009,0,0,113,45010303,10,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113010,0,0,113,45010304,10,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113011,0,0,113,45010305,10,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113012,0,0,113,45010306,10,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114001,0,0,114,45010201,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(114002,0,0,114,45010202,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(114003,0,0,114,45010203,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(114004,0,0,114,45010204,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(114005,0,0,114,45010205,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(114006,0,0,114,45010206,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(114007,0,0,114,45010301,10,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114008,0,0,114,45010302,10,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114009,0,0,114,45010303,10,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114010,0,0,114,45010304,10,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114011,0,0,114,45010305,10,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114012,0,0,114,45010306,10,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114013,0,0,114,45010401,10,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114014,0,0,114,45010402,10,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114015,0,0,114,45010403,10,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115001,0,0,115,45010201,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(115002,0,0,115,45010202,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(115003,0,0,115,45010203,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(115004,0,0,115,45010204,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(115005,0,0,115,45010205,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(115006,0,0,115,45010206,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(115007,0,0,115,45010301,10,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115008,0,0,115,45010302,10,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115009,0,0,115,45010303,10,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115010,0,0,115,45010304,10,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115011,0,0,115,45010305,10,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115012,0,0,115,45010306,10,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115013,0,0,115,45010401,10,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115014,0,0,115,45010402,10,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115015,0,0,115,45010403,10,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116001,0,0,116,38330002,10,'[]',1,1,'[]',0,'0','0',1,'[]',0,0,0,0,'[]'),(116002,0,0,116,38040010,10,'[]',1,1,'[]',0,'0','0',1,'[]',0,0,0,0,'[]'),(116003,0,0,116,38040102,10,'[]',1,1,'[]',0,'0','0',1,'[]',0,0,0,0,'[]'),(117001,0,0,117,38330002,10,'[]',1,1,'[]',0,'0','0',1,'[]',0,0,0,0,'[]'),(117002,0,0,117,38040010,10,'[]',1,1,'[]',0,'0','0',1,'[]',0,0,0,0,'[]'),(117003,0,0,117,38040102,10,'[]',1,1,'[]',0,'0','0',1,'[]',0,0,0,0,'[]'),(118001,0,0,118,17010001,10,'[]',40,40,'[]',0,'0','0',1,'[]',0,0,0,0,'[]'),(118002,0,0,118,11020001,10,'[]',1,1,'[]',0,'0','0',1,'[]',0,0,0,0,'[]'),(118003,0,0,118,18020001,10,'[]',1,1,'[]',0,'0','0',1,'[]',0,0,0,0,'[]'),(119001,0,0,119,24010001,10,'[]',1,1,'[]',0,'0','0',1,'[]',0,0,0,0,'[]'),(119002,0,0,119,15020101,10,'[]',1,1,'[]',0,'0','0',1,'[]',0,0,0,0,'[]'),(120001,0,0,120,38330003,10,'[]',1,1,'[]',0,'0','function_getobj_perple',1,'[]',0,0,0,0,'[]'),(120002,0,0,120,37020001,10,'[]',1,1,'[]',0,'0','0',1,'[]',0,0,0,0,'[]'),(120003,0,0,120,38040101,10,'[]',1,1,'[]',0,'0','function_getobj_perple',1,'[]',0,0,0,0,'[]'),(121001,0,0,121,38330003,10,'[]',1,1,'[]',0,'0','function_getobj_perple',1,'[]',0,0,0,0,'[]'),(121002,0,0,121,37020001,10,'[]',1,1,'[]',0,'0','0',1,'[]',0,0,0,0,'[]'),(121003,0,0,121,38040101,10,'[]',1,1,'[]',0,'0','function_getobj_perple',1,'[]',0,0,0,0,'[]'),(122001,0,0,122,17010001,10,'[]',50,50,'[]',0,'0','0',1,'[]',0,0,0,0,'[]'),(122002,0,0,122,11020001,10,'[]',2,2,'[]',0,'0','0',1,'[]',0,0,0,0,'[]'),(122003,0,0,122,18020001,10,'[]',2,2,'[]',0,'0','0',1,'[]',0,0,0,0,'[]'),(123001,0,0,123,24010001,30,'[]',2,2,'[]',0,'0','0',1,'[]',0,0,0,0,'[]'),(123002,0,0,123,15020101,30,'[]',2,2,'[]',0,'0','0',1,'[]',0,0,0,0,'[]'),(124001,0,0,124,38330004,10,'[]',1,1,'[]',0,'0','function_getobj_yellow',1,'[{150,1}]',0,0,0,0,'[]'),(124002,0,0,124,37020002,10,'[]',1,1,'[]',0,'0','function_getobj_perple',1,'[]',0,0,0,0,'[]'),(125001,0,0,125,38330004,10,'[]',1,1,'[]',0,'0','function_getobj_yellow',1,'[{150,1}]',0,0,0,0,'[]'),(125002,0,0,125,37020002,10,'[]',1,1,'[]',0,'0','function_getobj_perple',1,'[]',0,0,0,0,'[]'),(126001,0,0,126,24020001,20,'[]',1,1,'[]',0,'0','function_getobj_perple',1,'[{150,1}]',0,0,0,0,'[]'),(126002,0,0,126,17020001,20,'[]',1,1,'[]',0,'0','function_getobj_perple',1,'[{150,1}]',0,0,0,0,'[]'),(126003,0,0,126,24020002,10,'[]',1,1,'[]',0,'0','function_getobj_perple',1,'[{150,1}]',0,0,0,0,'[]'),(126004,0,0,126,17020002,10,'[]',1,1,'[]',0,'0','function_getobj_perple',1,'[{150,1}]',0,0,0,0,'[]'),(127001,0,0,127,24020003,10,'[]',1,1,'[]',0,'0','function_getobj_yellow',1,'[{150,1}]',0,0,0,0,'[]'),(127002,0,0,127,17020003,10,'[]',1,1,'[]',0,'0','function_getobj_yellow',1,'[{150,1}]',0,0,0,0,'[]'),(128001,0,0,128,21020001,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(129001,0,0,129,32120101,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(130001,0,0,130,32120102,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(131001,0,0,131,32120201,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(132001,0,0,132,32120202,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(133001,0,0,133,32120301,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(134001,0,0,134,32120302,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(135001,0,0,135,32120401,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(136001,0,0,136,32120402,10,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(137001,0,0,137,16050001,10,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(138001,0,0,138,16040101,320,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(138002,0,0,138,16040102,80,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(138003,0,0,138,16040111,160,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(138004,0,0,138,16040112,40,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(138005,0,0,138,16040121,80,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(138006,0,0,138,16040122,20,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(139001,0,0,139,16040201,320,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(139002,0,0,139,16040202,80,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(139003,0,0,139,16040211,160,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(139004,0,0,139,16040212,40,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(139005,0,0,139,16040221,80,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(139006,0,0,139,16040222,20,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(140001,0,0,140,16040301,320,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(140002,0,0,140,16040302,80,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(140003,0,0,140,16040311,160,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(140004,0,0,140,16040312,40,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(140005,0,0,140,16040321,80,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(140006,0,0,140,16040322,20,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(141001,0,0,141,16040401,320,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(141002,0,0,141,16040402,80,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(141003,0,0,141,16040411,160,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(141004,0,0,141,16040412,40,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(141005,0,0,141,16040421,80,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(141006,0,0,141,16040422,20,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(142001,0,0,142,16040501,320,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(142002,0,0,142,16040502,80,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(142003,0,0,142,16040511,160,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(142004,0,0,142,16040512,40,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(142005,0,0,142,16040521,80,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(142006,0,0,142,16040522,20,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(143001,0,0,143,16040601,320,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(143002,0,0,143,16040602,80,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(143003,0,0,143,16040611,160,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(143004,0,0,143,16040612,40,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(143005,0,0,143,16040621,80,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(143006,0,0,143,16040622,20,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(144001,0,0,144,16040101,320,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(144002,0,0,144,16040102,80,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(144003,0,0,144,16040111,160,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(144004,0,0,144,16040112,40,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(144005,0,0,144,16040121,80,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(144006,0,0,144,16040122,20,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(144007,0,0,144,16040201,320,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(144008,0,0,144,16040202,80,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(144009,0,0,144,16040211,160,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(144010,0,0,144,16040212,40,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(144011,0,0,144,16040221,80,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(144012,0,0,144,16040222,20,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(144013,0,0,144,16040301,320,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(144014,0,0,144,16040302,80,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(144015,0,0,144,16040311,160,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(144016,0,0,144,16040312,40,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(144017,0,0,144,16040321,80,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(144018,0,0,144,16040322,20,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(144019,0,0,144,16040401,320,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(144020,0,0,144,16040402,80,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(144021,0,0,144,16040411,160,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(144022,0,0,144,16040412,40,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(144023,0,0,144,16040421,80,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(144024,0,0,144,16040422,20,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(144025,0,0,144,16040501,320,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(144026,0,0,144,16040502,80,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(144027,0,0,144,16040511,160,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(144028,0,0,144,16040512,40,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(144029,0,0,144,16040521,80,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(144030,0,0,144,16040522,20,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(144031,0,0,144,16040601,320,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(144032,0,0,144,16040602,80,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(144033,0,0,144,16040611,160,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(144034,0,0,144,16040612,40,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(144035,0,0,144,16040621,80,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(144036,0,0,144,16040622,20,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(145001,0,0,145,16040103,30,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(145002,0,0,145,16040105,30,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(145003,0,0,145,16040112,30,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(145004,0,0,145,16040113,5,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(145005,0,0,145,16040122,4,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(145006,0,0,145,16040123,1,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(145007,0,0,145,16040203,30,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(145008,0,0,145,16040205,30,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(145009,0,0,145,16040212,30,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(145010,0,0,145,16040213,5,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(145011,0,0,145,16040222,4,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(145012,0,0,145,16040223,1,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(145013,0,0,145,16040303,30,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(145014,0,0,145,16040305,30,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(145015,0,0,145,16040312,30,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(145016,0,0,145,16040313,5,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(145017,0,0,145,16040322,4,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(145018,0,0,145,16040323,1,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(145019,0,0,145,16040403,30,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(145020,0,0,145,16040405,30,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(145021,0,0,145,16040412,30,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(145022,0,0,145,16040413,5,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(145023,0,0,145,16040422,4,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(145024,0,0,145,16040423,1,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(145025,0,0,145,16040503,30,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(145026,0,0,145,16040505,30,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(145027,0,0,145,16040512,30,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(145028,0,0,145,16040513,5,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(145029,0,0,145,16040522,4,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(145030,0,0,145,16040523,1,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(145031,0,0,145,16040603,30,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(145032,0,0,145,16040605,30,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(145033,0,0,145,16040612,30,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(145034,0,0,145,16040613,5,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(145035,0,0,145,16040622,4,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(145036,0,0,145,16040623,1,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(146001,0,0,146,24031001,20,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(146002,0,0,146,24030001,3,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(147001,0,0,147,24031001,20,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(147002,0,0,147,24031002,20,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(147003,0,0,147,24030001,3,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(147004,0,0,147,24030002,3,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(148001,0,0,148,24031001,20,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(148002,0,0,148,24031002,20,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(148003,0,0,148,24031003,20,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(148004,0,0,148,24030001,3,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(148005,0,0,148,24030002,3,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(148006,0,0,148,24030003,3,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(149001,0,0,149,24031001,20,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(149002,0,0,149,24031002,20,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(149003,0,0,149,24031003,20,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(149004,0,0,149,24031004,20,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(149005,0,0,149,24030001,3,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(149006,0,0,149,24030002,3,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(149007,0,0,149,24030003,3,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(149008,0,0,149,24030004,3,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(150001,0,0,150,24031001,20,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(150002,0,0,150,24031002,20,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(150003,0,0,150,24031003,20,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(150004,0,0,150,24031004,20,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(150005,0,0,150,24031005,20,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(150006,0,0,150,24030001,3,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(150007,0,0,150,24030002,3,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(150008,0,0,150,24030003,3,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(150009,0,0,150,24030004,3,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(150010,0,0,150,24030005,3,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(151001,0,0,151,24031001,20,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(151002,0,0,151,24031002,20,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(151003,0,0,151,24031003,20,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(151004,0,0,151,24031004,20,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(151005,0,0,151,24031005,20,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(151006,0,0,151,24031006,20,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(151007,0,0,151,24030001,3,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(151008,0,0,151,24030002,3,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(151009,0,0,151,24030003,3,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(151010,0,0,151,24030004,3,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(151011,0,0,151,24030005,3,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(151012,0,0,151,24030006,3,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(152001,0,0,152,24031001,20,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(152002,0,0,152,24031002,20,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(152003,0,0,152,24031003,20,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(152004,0,0,152,24031004,20,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(152005,0,0,152,24031005,20,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(152006,0,0,152,24031006,20,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(152007,0,0,152,24031007,20,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(152008,0,0,152,24030001,3,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(152009,0,0,152,24030002,3,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(152010,0,0,152,24030003,3,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(152011,0,0,152,24030004,3,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(152012,0,0,152,24030005,3,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(152013,0,0,152,24030006,3,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(152014,0,0,152,24030007,3,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(153001,0,0,153,20060001,9,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(153002,0,0,153,20060002,1,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(154001,0,0,154,0,10,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[{1,1002010131},{2,1002020131},{3,1002030131},{4,1002040131}]'),(155001,0,0,155,0,10,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[{1,1004010131},{2,1004020131},{3,1004030131},{4,1004040131}]'),(156001,0,0,156,0,10,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[{1,1006010131},{2,1006020131},{3,1006030131},{4,1006040131}]'),(157001,0,0,157,0,10,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[{1,1008010131},{2,1008020131},{3,1008030131},{4,1008040131}]'),(158001,0,0,158,0,10,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[{1,1010010131},{2,1010020131},{3,1010030131},{4,1010040131}]'),(159001,0,0,159,0,10,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[{1,1001010131},{2,1001020131},{3,1001030131},{4,1001040131}]'),(160001,0,0,160,0,10,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[{1,1007010131},{2,1007020131},{3,1007030131},{4,1007040131}]'),(161001,0,0,161,1003000131,10,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(162001,0,0,162,1005000131,10,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(163001,0,0,163,1009000131,10,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(164001,0,0,164,0,14,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[{1,1002010132},{2,1002020132},{3,1002030132},{4,1002040132}]'),(164002,0,0,164,0,14,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[{1,1004010132},{2,1004020132},{3,1004030132},{4,1004040132}]'),(164003,0,0,164,0,14,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[{1,1006010132},{2,1006020132},{3,1006030132},{4,1006040132}]'),(164004,0,0,164,0,14,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[{1,1008010132},{2,1008020132},{3,1008030132},{4,1008040132}]'),(164005,0,0,164,0,14,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[{1,1010010132},{2,1010020132},{3,1010030132},{4,1010040132}]'),(164006,0,0,164,0,15,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[{1,1001010132},{2,1001020132},{3,1001030132},{4,1001040132}]'),(164007,0,0,164,0,15,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[{1,1007010132},{2,1007020132},{3,1007030132},{4,1007040132}]'),(164008,0,0,164,0,56,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[{1,1002010141},{2,1002020141},{3,1002030141},{4,1002040141}]'),(164009,0,0,164,0,56,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[{1,1004010141},{2,1004020141},{3,1004030141},{4,1004040141}]'),(164010,0,0,164,0,56,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[{1,1006010141},{2,1006020141},{3,1006030141},{4,1006040141}]'),(164011,0,0,164,0,56,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[{1,1008010141},{2,1008020141},{3,1008030141},{4,1008040141}]'),(164012,0,0,164,0,56,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[{1,1010010141},{2,1010020141},{3,1010030141},{4,1010040141}]'),(164013,0,0,164,0,60,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[{1,1001010141},{2,1001020141},{3,1001030141},{4,1001040141}]'),(164014,0,0,164,0,60,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[{1,1007010141},{2,1007020141},{3,1007030141},{4,1007040141}]'),(165001,0,0,165,0,14,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[{1,1002010232},{2,1002020232},{3,1002030232},{4,1002040232}]'),(165002,0,0,165,0,14,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[{1,1004010232},{2,1004020232},{3,1004030232},{4,1004040232}]'),(165003,0,0,165,0,14,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[{1,1006010232},{2,1006020232},{3,1006030232},{4,1006040232}]'),(165004,0,0,165,0,14,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[{1,1008010232},{2,1008020232},{3,1008030232},{4,1008040232}]'),(165005,0,0,165,0,14,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[{1,1010010232},{2,1010020232},{3,1010030232},{4,1010040232}]'),(165006,0,0,165,0,15,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[{1,1001010232},{2,1001020232},{3,1001030232},{4,1001040232}]'),(165007,0,0,165,0,15,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[{1,1007010232},{2,1007020232},{3,1007030232},{4,1007040232}]'),(165008,0,0,165,0,56,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[{1,1002010241},{2,1002020241},{3,1002030241},{4,1002040241}]'),(165009,0,0,165,0,56,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[{1,1004010241},{2,1004020241},{3,1004030241},{4,1004040241}]'),(165010,0,0,165,0,56,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[{1,1006010241},{2,1006020241},{3,1006030241},{4,1006040241}]'),(165011,0,0,165,0,56,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[{1,1008010241},{2,1008020241},{3,1008030241},{4,1008040241}]'),(165012,0,0,165,0,56,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[{1,1010010241},{2,1010020241},{3,1010030241},{4,1010040241}]'),(165013,0,0,165,0,60,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[{1,1001010241},{2,1001020241},{3,1001030241},{4,1001040241}]'),(165014,0,0,165,0,60,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[{1,1007010241},{2,1007020241},{3,1007030241},{4,1007040241}]'),(166001,0,0,166,0,28,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[{1,1002010332},{2,1002020332},{3,1002030332},{4,1002040332}]'),(166002,0,0,166,0,28,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[{1,1004010332},{2,1004020332},{3,1004030332},{4,1004040332}]'),(166003,0,0,166,0,28,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[{1,1006010332},{2,1006020332},{3,1006030332},{4,1006040332}]'),(166004,0,0,166,0,28,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[{1,1008010332},{2,1008020332},{3,1008030332},{4,1008040332}]'),(166005,0,0,166,0,28,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[{1,1010010332},{2,1010020332},{3,1010030332},{4,1010040332}]'),(166006,0,0,166,0,30,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[{1,1001010332},{2,1001020332},{3,1001030332},{4,1001040332}]'),(166007,0,0,166,0,30,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[{1,1007010332},{2,1007020332},{3,1007030332},{4,1007040332}]'),(166008,0,0,166,0,42,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[{1,1002010341},{2,1002020341},{3,1002030341},{4,1002040341}]'),(166009,0,0,166,0,42,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[{1,1004010341},{2,1004020341},{3,1004030341},{4,1004040341}]'),(166010,0,0,166,0,42,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[{1,1006010341},{2,1006020341},{3,1006030341},{4,1006040341}]'),(166011,0,0,166,0,42,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[{1,1008010341},{2,1008020341},{3,1008030341},{4,1008040341}]'),(166012,0,0,166,0,42,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[{1,1010010341},{2,1010020341},{3,1010030341},{4,1010040341}]'),(166013,0,0,166,0,45,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[{1,1001010341},{2,1001020341},{3,1001030341},{4,1001040341}]'),(166014,0,0,166,0,45,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[{1,1007010341},{2,1007020341},{3,1007030341},{4,1007040341}]'),(167001,0,0,167,0,126,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[{1,1002010432},{2,1002020432},{3,1002030432},{4,1002040432}]'),(167002,0,0,167,0,126,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[{1,1004010432},{2,1004020432},{3,1004030432},{4,1004040432}]'),(167003,0,0,167,0,126,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[{1,1006010432},{2,1006020432},{3,1006030432},{4,1006040432}]'),(167004,0,0,167,0,126,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[{1,1008010432},{2,1008020432},{3,1008030432},{4,1008040432}]'),(167005,0,0,167,0,126,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[{1,1010010432},{2,1010020432},{3,1010030432},{4,1010040432}]'),(167006,0,0,167,0,135,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[{1,1001010432},{2,1001020432},{3,1001030432},{4,1001040432}]'),(167007,0,0,167,0,135,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[{1,1007010432},{2,1007020432},{3,1007030432},{4,1007040432}]'),(167008,0,0,167,0,14,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[{1,1002010441},{2,1002020441},{3,1002030441},{4,1002040441}]'),(167009,0,0,167,0,14,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[{1,1004010441},{2,1004020441},{3,1004030441},{4,1004040441}]'),(167010,0,0,167,0,14,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[{1,1006010441},{2,1006020441},{3,1006030441},{4,1006040441}]'),(167011,0,0,167,0,14,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[{1,1008010441},{2,1008020441},{3,1008030441},{4,1008040441}]'),(167012,0,0,167,0,14,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[{1,1010010441},{2,1010020441},{3,1010030441},{4,1010040441}]'),(167013,0,0,167,0,15,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[{1,1001010441},{2,1001020441},{3,1001030441},{4,1001040441}]'),(167014,0,0,167,0,15,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[{1,1007010441},{2,1007020441},{3,1007030441},{4,1007040441}]'),(168001,0,0,168,0,70,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[{1,1002010532},{2,1002020532},{3,1002030532},{4,1002040532}]'),(168002,0,0,168,0,70,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[{1,1004010532},{2,1004020532},{3,1004030532},{4,1004040532}]'),(168003,0,0,168,0,70,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[{1,1006010532},{2,1006020532},{3,1006030532},{4,1006040532}]'),(168004,0,0,168,0,70,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[{1,1008010532},{2,1008020532},{3,1008030532},{4,1008040532}]'),(168005,0,0,168,0,70,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[{1,1010010532},{2,1010020532},{3,1010030532},{4,1010040532}]'),(168006,0,0,168,0,75,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[{1,1001010532},{2,1001020532},{3,1001030532},{4,1001040532}]'),(168007,0,0,168,0,75,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[{1,1007010532},{2,1007020532},{3,1007030532},{4,1007040532}]'),(168008,0,0,168,0,0,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[{1,1002010541},{2,1002020541},{3,1002030541},{4,1002040541}]'),(168009,0,0,168,0,0,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[{1,1004010541},{2,1004020541},{3,1004030541},{4,1004040541}]'),(168010,0,0,168,0,0,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[{1,1006010541},{2,1006020541},{3,1006030541},{4,1006040541}]'),(168011,0,0,168,0,0,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[{1,1008010541},{2,1008020541},{3,1008030541},{4,1008040541}]'),(168012,0,0,168,0,0,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[{1,1010010541},{2,1010020541},{3,1010030541},{4,1010040541}]'),(168013,0,0,168,0,0,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[{1,1001010541},{2,1001020541},{3,1001030541},{4,1001040541}]'),(168014,0,0,168,0,0,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[{1,1007010541},{2,1007020541},{3,1007030541},{4,1007040541}]'),(169001,0,0,169,1002010132,224,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(169002,0,0,169,1002020132,224,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(169003,0,0,169,1002030132,0,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(169004,0,0,169,1002040132,224,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(169005,0,0,169,1004010132,224,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(169006,0,0,169,1004020132,224,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(169007,0,0,169,1004030132,0,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(169008,0,0,169,1004040132,224,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(169009,0,0,169,1006010132,224,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(169010,0,0,169,1006020132,224,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(169011,0,0,169,1006030132,0,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(169012,0,0,169,1006040132,224,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(169013,0,0,169,1008010132,224,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(169014,0,0,169,1008020132,224,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(169015,0,0,169,1008030132,0,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(169016,0,0,169,1008040132,224,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(169017,0,0,169,1010010132,224,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(169018,0,0,169,1010020132,224,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(169019,0,0,169,1010030132,0,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(169020,0,0,169,1010040132,224,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(169021,0,0,169,1001010132,240,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(169022,0,0,169,1001020132,240,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(169023,0,0,169,1001030132,0,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(169024,0,0,169,1001040132,240,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(169025,0,0,169,1007010132,240,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(169026,0,0,169,1007020132,240,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(169027,0,0,169,1007030132,0,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(169028,0,0,169,1007040132,240,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(169029,0,0,169,1002010141,56,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(169030,0,0,169,1002020141,56,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(169031,0,0,169,1002030141,0,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(169032,0,0,169,1002040141,56,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(169033,0,0,169,1004010141,56,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(169034,0,0,169,1004020141,56,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(169035,0,0,169,1004030141,0,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(169036,0,0,169,1004040141,56,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(169037,0,0,169,1006010141,56,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(169038,0,0,169,1006020141,56,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(169039,0,0,169,1006030141,0,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(169040,0,0,169,1006040141,56,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(169041,0,0,169,1008010141,56,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(169042,0,0,169,1008020141,56,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(169043,0,0,169,1008030141,0,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(169044,0,0,169,1008040141,56,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(169045,0,0,169,1010010141,56,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(169046,0,0,169,1010020141,56,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(169047,0,0,169,1010030141,0,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(169048,0,0,169,1010040141,56,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(169049,0,0,169,1001010141,60,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(169050,0,0,169,1001020141,60,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(169051,0,0,169,1001030141,0,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(169052,0,0,169,1001040141,60,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(169053,0,0,169,1007010141,60,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(169054,0,0,169,1007020141,60,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(169055,0,0,169,1007030141,0,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(169056,0,0,169,1007040141,60,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(170001,0,0,170,1002010232,224,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(170002,0,0,170,1002020232,224,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(170003,0,0,170,1002030232,0,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(170004,0,0,170,1002040232,224,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(170005,0,0,170,1004010232,224,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(170006,0,0,170,1004020232,224,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(170007,0,0,170,1004030232,0,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(170008,0,0,170,1004040232,224,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(170009,0,0,170,1006010232,224,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(170010,0,0,170,1006020232,224,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(170011,0,0,170,1006030232,0,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(170012,0,0,170,1006040232,224,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(170013,0,0,170,1008010232,224,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(170014,0,0,170,1008020232,224,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(170015,0,0,170,1008030232,0,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(170016,0,0,170,1008040232,224,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(170017,0,0,170,1010010232,224,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(170018,0,0,170,1010020232,224,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(170019,0,0,170,1010030232,0,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(170020,0,0,170,1010040232,224,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(170021,0,0,170,1001010232,240,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(170022,0,0,170,1001020232,240,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(170023,0,0,170,1001030232,0,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(170024,0,0,170,1001040232,240,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(170025,0,0,170,1007010232,240,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(170026,0,0,170,1007020232,240,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(170027,0,0,170,1007030232,0,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(170028,0,0,170,1007040232,240,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(170029,0,0,170,1002010241,56,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(170030,0,0,170,1002020241,56,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(170031,0,0,170,1002030241,0,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(170032,0,0,170,1002040241,56,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(170033,0,0,170,1004010241,56,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(170034,0,0,170,1004020241,56,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(170035,0,0,170,1004030241,0,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(170036,0,0,170,1004040241,56,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(170037,0,0,170,1006010241,56,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(170038,0,0,170,1006020241,56,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(170039,0,0,170,1006030241,0,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(170040,0,0,170,1006040241,56,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(170041,0,0,170,1008010241,56,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(170042,0,0,170,1008020241,56,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(170043,0,0,170,1008030241,0,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(170044,0,0,170,1008040241,56,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(170045,0,0,170,1010010241,56,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(170046,0,0,170,1010020241,56,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(170047,0,0,170,1010030241,0,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(170048,0,0,170,1010040241,56,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(170049,0,0,170,1001010241,60,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(170050,0,0,170,1001020241,60,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(170051,0,0,170,1001030241,0,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(170052,0,0,170,1001040241,60,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(170053,0,0,170,1007010241,60,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(170054,0,0,170,1007020241,60,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(170055,0,0,170,1007030241,0,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(170056,0,0,170,1007040241,60,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(171001,0,0,171,1002010332,168,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(171002,0,0,171,1002020332,168,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(171003,0,0,171,1002030332,0,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(171004,0,0,171,1002040332,168,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(171005,0,0,171,1004010332,168,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(171006,0,0,171,1004020332,168,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(171007,0,0,171,1004030332,0,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(171008,0,0,171,1004040332,168,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(171009,0,0,171,1006010332,168,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(171010,0,0,171,1006020332,168,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(171011,0,0,171,1006030332,0,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(171012,0,0,171,1006040332,168,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(171013,0,0,171,1008010332,168,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(171014,0,0,171,1008020332,168,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(171015,0,0,171,1008030332,0,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(171016,0,0,171,1008040332,168,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(171017,0,0,171,1010010332,168,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(171018,0,0,171,1010020332,168,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(171019,0,0,171,1010030332,0,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(171020,0,0,171,1010040332,168,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(171021,0,0,171,1001010332,180,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(171022,0,0,171,1001020332,180,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(171023,0,0,171,1001030332,0,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(171024,0,0,171,1001040332,180,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(171025,0,0,171,1007010332,180,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(171026,0,0,171,1007020332,180,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(171027,0,0,171,1007030332,0,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(171028,0,0,171,1007040332,180,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(171029,0,0,171,1002010341,112,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(171030,0,0,171,1002020341,112,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(171031,0,0,171,1002030341,0,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(171032,0,0,171,1002040341,112,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(171033,0,0,171,1004010341,112,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(171034,0,0,171,1004020341,112,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(171035,0,0,171,1004030341,0,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(171036,0,0,171,1004040341,112,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(171037,0,0,171,1006010341,112,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(171038,0,0,171,1006020341,112,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(171039,0,0,171,1006030341,0,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(171040,0,0,171,1006040341,112,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(171041,0,0,171,1008010341,112,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(171042,0,0,171,1008020341,112,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(171043,0,0,171,1008030341,0,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(171044,0,0,171,1008040341,112,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(171045,0,0,171,1010010341,112,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(171046,0,0,171,1010020341,112,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(171047,0,0,171,1010030341,0,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(171048,0,0,171,1010040341,112,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(171049,0,0,171,1001010341,120,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(171050,0,0,171,1001020341,120,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(171051,0,0,171,1001030341,0,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(171052,0,0,171,1001040341,120,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(171053,0,0,171,1007010341,120,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(171054,0,0,171,1007020341,120,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(171055,0,0,171,1007030341,0,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(171056,0,0,171,1007040341,120,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(172001,0,0,172,1002010432,70,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(172002,0,0,172,1002020432,70,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(172003,0,0,172,1002030432,0,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(172004,0,0,172,1002040432,70,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(172005,0,0,172,1004010432,70,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(172006,0,0,172,1004020432,70,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(172007,0,0,172,1004030432,0,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(172008,0,0,172,1004040432,70,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(172009,0,0,172,1006010432,70,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(172010,0,0,172,1006020432,70,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(172011,0,0,172,1006030432,0,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(172012,0,0,172,1006040432,70,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(172013,0,0,172,1008010432,70,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(172014,0,0,172,1008020432,70,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(172015,0,0,172,1008030432,0,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(172016,0,0,172,1008040432,70,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(172017,0,0,172,1010010432,70,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(172018,0,0,172,1010020432,70,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(172019,0,0,172,1010030432,0,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(172020,0,0,172,1010040432,70,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(172021,0,0,172,1001010432,75,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(172022,0,0,172,1001020432,75,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(172023,0,0,172,1001030432,0,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(172024,0,0,172,1001040432,75,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(172025,0,0,172,1007010432,75,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(172026,0,0,172,1007020432,75,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(172027,0,0,172,1007030432,0,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(172028,0,0,172,1007040432,75,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(172029,0,0,172,1002010441,210,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(172030,0,0,172,1002020441,210,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(172031,0,0,172,1002030441,0,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(172032,0,0,172,1002040441,210,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(172033,0,0,172,1004010441,210,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(172034,0,0,172,1004020441,210,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(172035,0,0,172,1004030441,0,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(172036,0,0,172,1004040441,210,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(172037,0,0,172,1006010441,210,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(172038,0,0,172,1006020441,210,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(172039,0,0,172,1006030441,0,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(172040,0,0,172,1006040441,210,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(172041,0,0,172,1008010441,210,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(172042,0,0,172,1008020441,210,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(172043,0,0,172,1008030441,0,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(172044,0,0,172,1008040441,210,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(172045,0,0,172,1010010441,210,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(172046,0,0,172,1010020441,210,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(172047,0,0,172,1010030441,0,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(172048,0,0,172,1010040441,210,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(172049,0,0,172,1001010441,225,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(172050,0,0,172,1001020441,225,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(172051,0,0,172,1001030441,0,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(172052,0,0,172,1001040441,225,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(172053,0,0,172,1007010441,225,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(172054,0,0,172,1007020441,225,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(172055,0,0,172,1007030441,0,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(172056,0,0,172,1007040441,225,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(173001,0,0,173,1002010532,28,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(173002,0,0,173,1002020532,28,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(173003,0,0,173,1002030532,0,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(173004,0,0,173,1002040532,28,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(173005,0,0,173,1004010532,28,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(173006,0,0,173,1004020532,28,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(173007,0,0,173,1004030532,0,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(173008,0,0,173,1004040532,28,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(173009,0,0,173,1006010532,28,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(173010,0,0,173,1006020532,28,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(173011,0,0,173,1006030532,0,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(173012,0,0,173,1006040532,28,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(173013,0,0,173,1008010532,28,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(173014,0,0,173,1008020532,28,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(173015,0,0,173,1008030532,0,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(173016,0,0,173,1008040532,28,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(173017,0,0,173,1010010532,28,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(173018,0,0,173,1010020532,28,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(173019,0,0,173,1010030532,0,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(173020,0,0,173,1010040532,28,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(173021,0,0,173,1001010532,30,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(173022,0,0,173,1001020532,30,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(173023,0,0,173,1001030532,0,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(173024,0,0,173,1001040532,30,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(173025,0,0,173,1007010532,30,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(173026,0,0,173,1007020532,30,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(173027,0,0,173,1007030532,0,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(173028,0,0,173,1007040532,30,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(173029,0,0,173,1002010541,252,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(173030,0,0,173,1002020541,252,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(173031,0,0,173,1002030541,0,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(173032,0,0,173,1002040541,252,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(173033,0,0,173,1004010541,252,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(173034,0,0,173,1004020541,252,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(173035,0,0,173,1004030541,0,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(173036,0,0,173,1004040541,252,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(173037,0,0,173,1006010541,252,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(173038,0,0,173,1006020541,252,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(173039,0,0,173,1006030541,0,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(173040,0,0,173,1006040541,252,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(173041,0,0,173,1008010541,252,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(173042,0,0,173,1008020541,252,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(173043,0,0,173,1008030541,0,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(173044,0,0,173,1008040541,252,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(173045,0,0,173,1010010541,252,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(173046,0,0,173,1010020541,252,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(173047,0,0,173,1010030541,0,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(173048,0,0,173,1010040541,252,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(173049,0,0,173,1001010541,270,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(173050,0,0,173,1001020541,270,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(173051,0,0,173,1001030541,0,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(173052,0,0,173,1001040541,270,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(173053,0,0,173,1007010541,270,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(173054,0,0,173,1007020541,270,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(173055,0,0,173,1007030541,0,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(173056,0,0,173,1007040541,270,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(174001,0,0,174,0,5,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[{1,1002010232},{2,1002020232},{3,1002030232},{4,1002040232}]'),(174002,0,0,174,0,5,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[{1,1004010232},{2,1004020232},{3,1004030232},{4,1004040232}]'),(174003,0,0,174,0,5,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[{1,1006010232},{2,1006020232},{3,1006030232},{4,1006040232}]'),(174004,0,0,174,0,5,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[{1,1008010232},{2,1008020232},{3,1008030232},{4,1008040232}]'),(174005,0,0,174,0,5,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[{1,1010010232},{2,1010020232},{3,1010030232},{4,1010040232}]'),(174006,0,0,174,0,5,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[{1,1002010241},{2,1002020241},{3,1002030241},{4,1002040241}]'),(174007,0,0,174,0,5,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[{1,1004010241},{2,1004020241},{3,1004030241},{4,1004040241}]'),(174008,0,0,174,0,5,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[{1,1006010241},{2,1006020241},{3,1006030241},{4,1006040241}]'),(174009,0,0,174,0,5,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[{1,1008010241},{2,1008020241},{3,1008030241},{4,1008040241}]'),(174010,0,0,174,0,5,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[{1,1010010241},{2,1010020241},{3,1010030241},{4,1010040241}]'),(175001,0,0,175,1003000320,5,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(176001,0,0,176,18041001,5,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[{150,1}]',0,0,0,0,'[]'),(177001,0,0,177,18041002,5,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(178001,0,0,178,18041003,5,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(179001,0,0,179,21040001,5,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(180001,0,0,180,21040002,5,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(181001,0,0,181,21040003,5,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(182001,0,0,182,21040004,5,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[]',0,0,0,0,'[]'),(183001,0,0,183,21030001,5,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101010001,0,0,1010100,1002010110,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(101010002,0,0,1010100,1002020110,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(101010003,0,0,1010100,1002040110,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(101010004,0,0,1010100,1004010110,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(101010005,0,0,1010100,1004020110,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(101010006,0,0,1010100,1004040110,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(101010007,0,0,1010100,1006010110,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(101010008,0,0,1010100,1006020110,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(101010009,0,0,1010100,1006040110,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(101010010,0,0,1010100,1008010110,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(101010011,0,0,1010100,1008020110,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(101010012,0,0,1010100,1008040110,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(101010013,0,0,1010100,1010010110,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(101010014,0,0,1010100,1010020110,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(101010015,0,0,1010100,1010040110,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(101010016,0,0,1010100,1001010110,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(101010017,0,0,1010100,1001020110,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000201','0',0,'[]',0,0,0,0,'[]'),(101010018,0,0,1010100,1001040110,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000401','0',0,'[]',0,0,0,0,'[]'),(101010019,0,0,1010100,1007010110,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(101010020,0,0,1010100,1007020110,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000207','0',0,'[]',0,0,0,0,'[]'),(101010021,0,0,1010100,1007040110,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000407','0',0,'[]',0,0,0,0,'[]'),(101010022,0,0,1010100,1003000110,300,'[{1,75},{2,75},{4,75}]',1,1,'[]',0,'1000003','0',0,'[]',0,0,0,0,'[]'),(101010023,0,0,1010100,1002010120,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(101010024,0,0,1010100,1002020120,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(101010025,0,0,1010100,1002040120,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(101010026,0,0,1010100,1004010120,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(101010027,0,0,1010100,1004020120,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(101010028,0,0,1010100,1004040120,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(101010029,0,0,1010100,1006010120,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(101010030,0,0,1010100,1006020120,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(101010031,0,0,1010100,1006040120,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(101010032,0,0,1010100,1008010120,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(101010033,0,0,1010100,1008020120,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(101010034,0,0,1010100,1008040120,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(101010035,0,0,1010100,1010010120,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(101010036,0,0,1010100,1010020120,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(101010037,0,0,1010100,1010040120,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(101010038,0,0,1010100,1001010120,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(101010039,0,0,1010100,1001020120,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000201','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(101010040,0,0,1010100,1001040120,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000401','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(101010041,0,0,1010100,1007010120,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(101010042,0,0,1010100,1007020120,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000207','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(101010043,0,0,1010100,1007040120,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000407','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(101010044,0,0,1010100,1003000120,300,'[{1,75},{2,75},{4,75}]',1,1,'[]',0,'1000003','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(101020001,0,0,1010200,1002010131,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(101020002,0,0,1010200,1002020131,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(101020003,0,0,1010200,1002040131,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(101020004,0,0,1010200,1004010131,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(101020005,0,0,1010200,1004020131,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(101020006,0,0,1010200,1004040131,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(101020007,0,0,1010200,1006010131,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(101020008,0,0,1010200,1006020131,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(101020009,0,0,1010200,1006040131,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(101020010,0,0,1010200,1008010131,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(101020011,0,0,1010200,1008020131,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(101020012,0,0,1010200,1008040131,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(101020013,0,0,1010200,1010010131,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(101020014,0,0,1010200,1010020131,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(101020015,0,0,1010200,1010040131,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(101020016,0,0,1010200,1001010131,1000,'[{1,50},{2,25},{4,25}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(101020017,0,0,1010200,1001020131,1000,'[{1,25},{2,50},{4,25}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(101020018,0,0,1010200,1001040131,1000,'[{1,25},{2,25},{4,50}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(101020019,0,0,1010200,1007010131,1000,'[{1,50},{2,25},{4,25}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(101020020,0,0,1010200,1007020131,1000,'[{1,25},{2,50},{4,25}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(101020021,0,0,1010200,1007040131,1000,'[{1,25},{2,25},{4,50}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(101020022,0,0,1010200,1003000131,1000,'[{1,25},{2,25},{4,25}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(101020023,0,0,1010200,1002010141,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(101020024,0,0,1010200,1002020141,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(101020025,0,0,1010200,1002040141,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(101020026,0,0,1010200,1004010141,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(101020027,0,0,1010200,1004020141,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(101020028,0,0,1010200,1004040141,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(101020029,0,0,1010200,1006010141,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(101020030,0,0,1010200,1006020141,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(101020031,0,0,1010200,1006040141,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(101020032,0,0,1010200,1008010141,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(101020033,0,0,1010200,1008020141,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(101020034,0,0,1010200,1008040141,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(101020035,0,0,1010200,1010010141,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(101020036,0,0,1010200,1010020141,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(101020037,0,0,1010200,1010040141,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(101020038,0,0,1010200,1001010141,1000,'[{1,20},{2,10},{4,10}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(101020039,0,0,1010200,1001020141,1000,'[{1,10},{2,20},{4,10}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[]',0,0,0,0,'[]'),(101020040,0,0,1010200,1001040141,1000,'[{1,10},{2,10},{4,20}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[]',0,0,0,0,'[]'),(101020041,0,0,1010200,1007010141,1000,'[{1,20},{2,10},{4,10}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(101020042,0,0,1010200,1007020141,1000,'[{1,10},{2,20},{4,10}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[]',0,0,0,0,'[]'),(101020043,0,0,1010200,1007040141,1000,'[{1,10},{2,10},{4,20}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[]',0,0,0,0,'[]'),(101020044,0,0,1010200,1003000141,1000,'[{1,10},{2,10},{4,10}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[]',0,0,0,0,'[]'),(101030101,0,0,1010301,1002010132,1000,'[{1,152},{2,76},{4,76}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101030102,0,0,1010301,1002020132,1000,'[{1,76},{2,152},{4,76}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101030103,0,0,1010301,1002040132,1000,'[{1,76},{2,76},{4,152}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101030104,0,0,1010301,1004010132,1000,'[{1,152},{2,76},{4,76}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101030105,0,0,1010301,1004020132,1000,'[{1,76},{2,152},{4,76}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101030106,0,0,1010301,1004040132,1000,'[{1,76},{2,76},{4,152}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101030107,0,0,1010301,1006010132,1000,'[{1,152},{2,76},{4,76}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101030108,0,0,1010301,1006020132,1000,'[{1,76},{2,152},{4,76}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101030109,0,0,1010301,1006040132,1000,'[{1,76},{2,76},{4,152}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101030110,0,0,1010301,1008010132,1000,'[{1,152},{2,76},{4,76}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101030111,0,0,1010301,1008020132,1000,'[{1,76},{2,152},{4,76}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101030112,0,0,1010301,1008040132,1000,'[{1,76},{2,76},{4,152}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101030113,0,0,1010301,1010010132,1000,'[{1,152},{2,76},{4,76}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101030114,0,0,1010301,1010020132,1000,'[{1,76},{2,152},{4,76}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101030115,0,0,1010301,1010040132,1000,'[{1,76},{2,76},{4,152}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101030116,0,0,1010301,1002010142,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101030117,0,0,1010301,1002020142,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101030118,0,0,1010301,1002040142,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101030119,0,0,1010301,1004010142,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101030120,0,0,1010301,1004020142,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101030121,0,0,1010301,1004040142,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101030122,0,0,1010301,1006010142,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101030123,0,0,1010301,1006020142,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101030124,0,0,1010301,1006040142,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101030125,0,0,1010301,1008010142,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101030126,0,0,1010301,1008020142,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101030127,0,0,1010301,1008040142,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101030128,0,0,1010301,1010010142,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101030129,0,0,1010301,1010020142,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101030130,0,0,1010301,1010040142,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101030201,0,0,1010302,1001010132,1000,'[{1,76},{2,38},{4,38}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101030202,0,0,1010302,1001020132,1000,'[{1,38},{2,76},{4,38}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101030203,0,0,1010302,1001040132,1000,'[{1,38},{2,38},{4,76}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101030204,0,0,1010302,1007010132,1000,'[{1,76},{2,38},{4,38}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101030205,0,0,1010302,1007020132,1000,'[{1,38},{2,76},{4,38}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101030206,0,0,1010302,1007040132,1000,'[{1,38},{2,38},{4,76}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101030207,0,0,1010302,1003000132,1000,'[{1,38},{2,38},{4,38}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101030208,0,0,1010302,1001010142,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101030209,0,0,1010302,1001020142,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101030210,0,0,1010302,1001040142,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101030211,0,0,1010302,1007010142,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101030212,0,0,1010302,1007020142,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101030213,0,0,1010302,1007040142,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101030214,0,0,1010302,1003000142,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101040101,0,0,1010401,1002010132,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101040102,0,0,1010401,1002020132,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101040103,0,0,1010401,1002040132,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101040104,0,0,1010401,1004010132,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101040105,0,0,1010401,1004020132,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101040106,0,0,1010401,1004040132,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101040107,0,0,1010401,1006010132,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101040108,0,0,1010401,1006020132,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101040109,0,0,1010401,1006040132,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101040110,0,0,1010401,1008010132,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101040111,0,0,1010401,1008020132,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101040112,0,0,1010401,1008040132,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101040113,0,0,1010401,1010010132,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101040114,0,0,1010401,1010020132,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101040115,0,0,1010401,1010040132,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101040116,0,0,1010401,1002010142,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101040117,0,0,1010401,1002020142,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101040118,0,0,1010401,1002040142,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101040119,0,0,1010401,1004010142,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101040120,0,0,1010401,1004020142,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101040121,0,0,1010401,1004040142,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101040122,0,0,1010401,1006010142,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101040123,0,0,1010401,1006020142,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101040124,0,0,1010401,1006040142,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101040125,0,0,1010401,1008010142,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101040126,0,0,1010401,1008020142,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101040127,0,0,1010401,1008040142,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101040128,0,0,1010401,1010010142,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101040129,0,0,1010401,1010020142,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101040130,0,0,1010401,1010040142,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101040201,0,0,1010402,1001010132,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101040202,0,0,1010402,1001020132,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101040203,0,0,1010402,1001040132,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101040204,0,0,1010402,1007010132,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101040205,0,0,1010402,1007020132,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101040206,0,0,1010402,1007040132,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101040207,0,0,1010402,1003000132,1000,'[{1,60},{2,60},{4,60}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101040208,0,0,1010402,1001010142,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101040209,0,0,1010402,1001020142,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101040210,0,0,1010402,1001040142,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101040211,0,0,1010402,1007010142,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101040212,0,0,1010402,1007020142,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101040213,0,0,1010402,1007040142,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101040214,0,0,1010402,1003000142,1000,'[{1,60},{2,60},{4,60}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101050101,0,0,1010501,1002010132,1000,'[{1,285},{2,143},{4,143}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101050102,0,0,1010501,1002020132,1000,'[{1,143},{2,285},{4,143}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101050103,0,0,1010501,1002040132,1000,'[{1,143},{2,143},{4,285}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101050104,0,0,1010501,1004010132,1000,'[{1,285},{2,143},{4,143}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101050105,0,0,1010501,1004020132,1000,'[{1,143},{2,285},{4,143}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101050106,0,0,1010501,1004040132,1000,'[{1,143},{2,143},{4,285}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101050107,0,0,1010501,1006010132,1000,'[{1,285},{2,143},{4,143}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101050108,0,0,1010501,1006020132,1000,'[{1,143},{2,285},{4,143}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101050109,0,0,1010501,1006040132,1000,'[{1,143},{2,143},{4,285}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101050110,0,0,1010501,1008010132,1000,'[{1,285},{2,143},{4,143}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101050111,0,0,1010501,1008020132,1000,'[{1,143},{2,285},{4,143}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101050112,0,0,1010501,1008040132,1000,'[{1,143},{2,143},{4,285}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101050113,0,0,1010501,1010010132,1000,'[{1,285},{2,143},{4,143}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101050114,0,0,1010501,1010020132,1000,'[{1,143},{2,285},{4,143}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101050115,0,0,1010501,1010040132,1000,'[{1,143},{2,143},{4,285}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101050116,0,0,1010501,1002010142,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101050117,0,0,1010501,1002020142,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101050118,0,0,1010501,1002040142,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101050119,0,0,1010501,1004010142,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101050120,0,0,1010501,1004020142,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101050121,0,0,1010501,1004040142,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101050122,0,0,1010501,1006010142,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101050123,0,0,1010501,1006020142,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101050124,0,0,1010501,1006040142,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101050125,0,0,1010501,1008010142,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101050126,0,0,1010501,1008020142,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101050127,0,0,1010501,1008040142,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101050128,0,0,1010501,1010010142,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101050129,0,0,1010501,1010020142,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101050130,0,0,1010501,1010040142,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101050201,0,0,1010502,1001010132,1000,'[{1,143},{2,71},{4,71}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101050202,0,0,1010502,1001020132,1000,'[{1,71},{2,143},{4,71}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101050203,0,0,1010502,1001040132,1000,'[{1,71},{2,71},{4,143}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101050204,0,0,1010502,1007010132,1000,'[{1,143},{2,71},{4,71}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101050205,0,0,1010502,1007020132,1000,'[{1,71},{2,143},{4,71}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101050206,0,0,1010502,1007040132,1000,'[{1,71},{2,71},{4,143}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101050207,0,0,1010502,1003000132,1000,'[{1,71},{2,71},{4,71}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101050208,0,0,1010502,1001010142,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101050209,0,0,1010502,1001020142,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101050210,0,0,1010502,1001040142,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101050211,0,0,1010502,1007010142,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101050212,0,0,1010502,1007020142,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101050213,0,0,1010502,1007040142,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101050214,0,0,1010502,1003000142,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101060101,0,0,1010601,1002010132,1000,'[{1,75},{2,38},{4,38}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101060102,0,0,1010601,1002020132,1000,'[{1,38},{2,75},{4,38}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101060103,0,0,1010601,1002040132,1000,'[{1,38},{2,38},{4,75}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101060104,0,0,1010601,1004010132,1000,'[{1,75},{2,38},{4,38}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101060105,0,0,1010601,1004020132,1000,'[{1,38},{2,75},{4,38}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101060106,0,0,1010601,1004040132,1000,'[{1,38},{2,38},{4,75}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101060107,0,0,1010601,1006010132,1000,'[{1,75},{2,38},{4,38}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101060108,0,0,1010601,1006020132,1000,'[{1,38},{2,75},{4,38}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101060109,0,0,1010601,1006040132,1000,'[{1,38},{2,38},{4,75}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101060110,0,0,1010601,1008010132,1000,'[{1,75},{2,38},{4,38}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101060111,0,0,1010601,1008020132,1000,'[{1,38},{2,75},{4,38}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101060112,0,0,1010601,1008040132,1000,'[{1,38},{2,38},{4,75}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101060113,0,0,1010601,1010010132,1000,'[{1,75},{2,38},{4,38}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101060114,0,0,1010601,1010020132,1000,'[{1,38},{2,75},{4,38}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101060115,0,0,1010601,1010040132,1000,'[{1,38},{2,38},{4,75}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101060116,0,0,1010601,1002010142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101060117,0,0,1010601,1002020142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101060118,0,0,1010601,1002040142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101060119,0,0,1010601,1004010142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101060120,0,0,1010601,1004020142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101060121,0,0,1010601,1004040142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101060122,0,0,1010601,1006010142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101060123,0,0,1010601,1006020142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101060124,0,0,1010601,1006040142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101060125,0,0,1010601,1008010142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101060126,0,0,1010601,1008020142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101060127,0,0,1010601,1008040142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101060128,0,0,1010601,1010010142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101060129,0,0,1010601,1010020142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101060130,0,0,1010601,1010040142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101060201,0,0,1010602,1001010132,1000,'[{1,38},{2,19},{4,19}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101060202,0,0,1010602,1001020132,1000,'[{1,19},{2,38},{4,19}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101060203,0,0,1010602,1001040132,1000,'[{1,19},{2,19},{4,38}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101060204,0,0,1010602,1007010132,1000,'[{1,38},{2,19},{4,19}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101060205,0,0,1010602,1007020132,1000,'[{1,19},{2,38},{4,19}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101060206,0,0,1010602,1007040132,1000,'[{1,19},{2,19},{4,38}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101060207,0,0,1010602,1003000132,1000,'[{1,19},{2,19},{4,19}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101060208,0,0,1010602,1001010142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101060209,0,0,1010602,1001020142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101060210,0,0,1010602,1001040142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101060211,0,0,1010602,1007010142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101060212,0,0,1010602,1007020142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101060213,0,0,1010602,1007040142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101060214,0,0,1010602,1003000142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101070101,0,0,1010701,1002010132,1000,'[{1,85},{2,43},{4,43}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101070102,0,0,1010701,1002020132,1000,'[{1,43},{2,85},{4,43}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101070103,0,0,1010701,1002040132,1000,'[{1,43},{2,43},{4,85}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101070104,0,0,1010701,1004010132,1000,'[{1,85},{2,43},{4,43}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101070105,0,0,1010701,1004020132,1000,'[{1,43},{2,85},{4,43}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101070106,0,0,1010701,1004040132,1000,'[{1,43},{2,43},{4,85}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101070107,0,0,1010701,1006010132,1000,'[{1,85},{2,43},{4,43}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101070108,0,0,1010701,1006020132,1000,'[{1,43},{2,85},{4,43}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101070109,0,0,1010701,1006040132,1000,'[{1,43},{2,43},{4,85}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101070110,0,0,1010701,1008010132,1000,'[{1,85},{2,43},{4,43}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101070111,0,0,1010701,1008020132,1000,'[{1,43},{2,85},{4,43}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101070112,0,0,1010701,1008040132,1000,'[{1,43},{2,43},{4,85}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101070113,0,0,1010701,1010010132,1000,'[{1,85},{2,43},{4,43}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101070114,0,0,1010701,1010020132,1000,'[{1,43},{2,85},{4,43}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101070115,0,0,1010701,1010040132,1000,'[{1,43},{2,43},{4,85}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101070116,0,0,1010701,1002010142,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101070117,0,0,1010701,1002020142,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101070118,0,0,1010701,1002040142,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101070119,0,0,1010701,1004010142,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101070120,0,0,1010701,1004020142,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101070121,0,0,1010701,1004040142,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101070122,0,0,1010701,1006010142,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101070123,0,0,1010701,1006020142,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101070124,0,0,1010701,1006040142,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101070125,0,0,1010701,1008010142,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101070126,0,0,1010701,1008020142,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101070127,0,0,1010701,1008040142,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101070128,0,0,1010701,1010010142,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101070129,0,0,1010701,1010020142,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101070130,0,0,1010701,1010040142,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101070201,0,0,1010702,1001010132,1000,'[{1,68},{2,34},{4,34}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101070202,0,0,1010702,1001020132,1000,'[{1,34},{2,68},{4,34}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101070203,0,0,1010702,1001040132,1000,'[{1,34},{2,34},{4,68}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101070204,0,0,1010702,1007010132,1000,'[{1,68},{2,34},{4,34}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101070205,0,0,1010702,1007020132,1000,'[{1,34},{2,68},{4,34}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101070206,0,0,1010702,1007040132,1000,'[{1,34},{2,34},{4,68}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101070207,0,0,1010702,1003000132,1000,'[{1,34},{2,34},{4,34}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101070208,0,0,1010702,1001010142,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101070209,0,0,1010702,1001020142,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101070210,0,0,1010702,1001040142,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101070211,0,0,1010702,1007010142,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101070212,0,0,1010702,1007020142,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101070213,0,0,1010702,1007040142,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101070214,0,0,1010702,1003000142,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101080101,0,0,1010801,1002010132,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101080102,0,0,1010801,1002020132,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101080103,0,0,1010801,1002040132,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101080104,0,0,1010801,1004010132,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101080105,0,0,1010801,1004020132,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101080106,0,0,1010801,1004040132,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101080107,0,0,1010801,1006010132,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101080108,0,0,1010801,1006020132,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101080109,0,0,1010801,1006040132,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101080110,0,0,1010801,1008010132,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101080111,0,0,1010801,1008020132,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101080112,0,0,1010801,1008040132,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101080113,0,0,1010801,1010010132,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101080114,0,0,1010801,1010020132,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101080115,0,0,1010801,1010040132,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101080116,0,0,1010801,1002010142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101080117,0,0,1010801,1002020142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101080118,0,0,1010801,1002040142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101080119,0,0,1010801,1004010142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101080120,0,0,1010801,1004020142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101080121,0,0,1010801,1004040142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101080122,0,0,1010801,1006010142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101080123,0,0,1010801,1006020142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101080124,0,0,1010801,1006040142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101080125,0,0,1010801,1008010142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101080126,0,0,1010801,1008020142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101080127,0,0,1010801,1008040142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101080128,0,0,1010801,1010010142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101080129,0,0,1010801,1010020142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101080130,0,0,1010801,1010040142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101080201,0,0,1010802,1001010132,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101080202,0,0,1010802,1001020132,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101080203,0,0,1010802,1001040132,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101080204,0,0,1010802,1007010132,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101080205,0,0,1010802,1007020132,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101080206,0,0,1010802,1007040132,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101080207,0,0,1010802,1003000132,1000,'[{1,163},{2,163},{4,163}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(101080208,0,0,1010802,1001010142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101080209,0,0,1010802,1001020142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101080210,0,0,1010802,1001040142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101080211,0,0,1010802,1007010142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101080212,0,0,1010802,1007020142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101080213,0,0,1010802,1007040142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(101080214,0,0,1010802,1003000142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102010001,0,0,1020100,1002010210,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(102010002,0,0,1020100,1002020210,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(102010003,0,0,1020100,1002040210,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(102010004,0,0,1020100,1004010210,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(102010005,0,0,1020100,1004020210,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(102010006,0,0,1020100,1004040210,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(102010007,0,0,1020100,1006010210,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(102010008,0,0,1020100,1006020210,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(102010009,0,0,1020100,1006040210,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(102010010,0,0,1020100,1008010210,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(102010011,0,0,1020100,1008020210,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(102010012,0,0,1020100,1008040210,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(102010013,0,0,1020100,1010010210,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(102010014,0,0,1020100,1010020210,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(102010015,0,0,1020100,1010040210,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(102010016,0,0,1020100,1001010210,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(102010017,0,0,1020100,1001020210,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000201','0',0,'[]',0,0,0,0,'[]'),(102010018,0,0,1020100,1001040210,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000401','0',0,'[]',0,0,0,0,'[]'),(102010019,0,0,1020100,1007010210,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(102010020,0,0,1020100,1007020210,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000207','0',0,'[]',0,0,0,0,'[]'),(102010021,0,0,1020100,1007040210,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000407','0',0,'[]',0,0,0,0,'[]'),(102010022,0,0,1020100,1003000210,300,'[{1,75},{2,75},{4,75}]',1,1,'[]',0,'1000003','0',0,'[]',0,0,0,0,'[]'),(102010023,0,0,1020100,1002010220,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(102010024,0,0,1020100,1002020220,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(102010025,0,0,1020100,1002040220,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(102010026,0,0,1020100,1004010220,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(102010027,0,0,1020100,1004020220,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(102010028,0,0,1020100,1004040220,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(102010029,0,0,1020100,1006010220,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(102010030,0,0,1020100,1006020220,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(102010031,0,0,1020100,1006040220,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(102010032,0,0,1020100,1008010220,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(102010033,0,0,1020100,1008020220,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(102010034,0,0,1020100,1008040220,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(102010035,0,0,1020100,1010010220,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(102010036,0,0,1020100,1010020220,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(102010037,0,0,1020100,1010040220,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(102010038,0,0,1020100,1001010220,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(102010039,0,0,1020100,1001020220,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000201','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(102010040,0,0,1020100,1001040220,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000401','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(102010041,0,0,1020100,1007010220,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(102010042,0,0,1020100,1007020220,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000207','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(102010043,0,0,1020100,1007040220,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000407','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(102010044,0,0,1020100,1003000220,300,'[{1,75},{2,75},{4,75}]',1,1,'[]',0,'1000003','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(102020001,0,0,1020200,1002010231,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(102020002,0,0,1020200,1002020231,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(102020003,0,0,1020200,1002040231,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(102020004,0,0,1020200,1004010231,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(102020005,0,0,1020200,1004020231,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(102020006,0,0,1020200,1004040231,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(102020007,0,0,1020200,1006010231,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(102020008,0,0,1020200,1006020231,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(102020009,0,0,1020200,1006040231,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(102020010,0,0,1020200,1008010231,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(102020011,0,0,1020200,1008020231,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(102020012,0,0,1020200,1008040231,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(102020013,0,0,1020200,1010010231,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(102020014,0,0,1020200,1010020231,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(102020015,0,0,1020200,1010040231,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(102020016,0,0,1020200,1001010231,1000,'[{1,50},{2,25},{4,25}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(102020017,0,0,1020200,1001020231,1000,'[{1,25},{2,50},{4,25}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(102020018,0,0,1020200,1001040231,1000,'[{1,25},{2,25},{4,50}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(102020019,0,0,1020200,1007010231,1000,'[{1,50},{2,25},{4,25}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(102020020,0,0,1020200,1007020231,1000,'[{1,25},{2,50},{4,25}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(102020021,0,0,1020200,1007040231,1000,'[{1,25},{2,25},{4,50}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(102020022,0,0,1020200,1003000231,1000,'[{1,25},{2,25},{4,25}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(102020023,0,0,1020200,1002010241,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(102020024,0,0,1020200,1002020241,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(102020025,0,0,1020200,1002040241,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(102020026,0,0,1020200,1004010241,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(102020027,0,0,1020200,1004020241,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(102020028,0,0,1020200,1004040241,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(102020029,0,0,1020200,1006010241,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(102020030,0,0,1020200,1006020241,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(102020031,0,0,1020200,1006040241,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(102020032,0,0,1020200,1008010241,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(102020033,0,0,1020200,1008020241,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(102020034,0,0,1020200,1008040241,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(102020035,0,0,1020200,1010010241,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(102020036,0,0,1020200,1010020241,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(102020037,0,0,1020200,1010040241,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(102020038,0,0,1020200,1001010241,1000,'[{1,20},{2,10},{4,10}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(102020039,0,0,1020200,1001020241,1000,'[{1,10},{2,20},{4,10}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[]',0,0,0,0,'[]'),(102020040,0,0,1020200,1001040241,1000,'[{1,10},{2,10},{4,20}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[]',0,0,0,0,'[]'),(102020041,0,0,1020200,1007010241,1000,'[{1,20},{2,10},{4,10}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(102020042,0,0,1020200,1007020241,1000,'[{1,10},{2,20},{4,10}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[]',0,0,0,0,'[]'),(102020043,0,0,1020200,1007040241,1000,'[{1,10},{2,10},{4,20}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[]',0,0,0,0,'[]'),(102020044,0,0,1020200,1003000241,1000,'[{1,10},{2,10},{4,10}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[]',0,0,0,0,'[]'),(102030101,0,0,1020301,1002010232,1000,'[{1,152},{2,76},{4,76}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102030102,0,0,1020301,1002020232,1000,'[{1,76},{2,152},{4,76}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102030103,0,0,1020301,1002040232,1000,'[{1,76},{2,76},{4,152}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102030104,0,0,1020301,1004010232,1000,'[{1,152},{2,76},{4,76}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102030105,0,0,1020301,1004020232,1000,'[{1,76},{2,152},{4,76}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102030106,0,0,1020301,1004040232,1000,'[{1,76},{2,76},{4,152}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102030107,0,0,1020301,1006010232,1000,'[{1,152},{2,76},{4,76}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102030108,0,0,1020301,1006020232,1000,'[{1,76},{2,152},{4,76}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102030109,0,0,1020301,1006040232,1000,'[{1,76},{2,76},{4,152}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102030110,0,0,1020301,1008010232,1000,'[{1,152},{2,76},{4,76}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102030111,0,0,1020301,1008020232,1000,'[{1,76},{2,152},{4,76}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102030112,0,0,1020301,1008040232,1000,'[{1,76},{2,76},{4,152}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102030113,0,0,1020301,1010010232,1000,'[{1,152},{2,76},{4,76}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102030114,0,0,1020301,1010020232,1000,'[{1,76},{2,152},{4,76}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102030115,0,0,1020301,1010040232,1000,'[{1,76},{2,76},{4,152}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102030116,0,0,1020301,1002010242,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102030117,0,0,1020301,1002020242,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102030118,0,0,1020301,1002040242,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102030119,0,0,1020301,1004010242,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102030120,0,0,1020301,1004020242,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102030121,0,0,1020301,1004040242,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102030122,0,0,1020301,1006010242,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102030123,0,0,1020301,1006020242,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102030124,0,0,1020301,1006040242,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102030125,0,0,1020301,1008010242,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102030126,0,0,1020301,1008020242,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102030127,0,0,1020301,1008040242,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102030128,0,0,1020301,1010010242,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102030129,0,0,1020301,1010020242,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102030130,0,0,1020301,1010040242,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102030201,0,0,1020302,1001010232,1000,'[{1,76},{2,38},{4,38}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102030202,0,0,1020302,1001020232,1000,'[{1,38},{2,76},{4,38}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102030203,0,0,1020302,1001040232,1000,'[{1,38},{2,38},{4,76}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102030204,0,0,1020302,1007010232,1000,'[{1,76},{2,38},{4,38}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102030205,0,0,1020302,1007020232,1000,'[{1,38},{2,76},{4,38}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102030206,0,0,1020302,1007040232,1000,'[{1,38},{2,38},{4,76}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102030207,0,0,1020302,1003000232,1000,'[{1,38},{2,38},{4,38}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102030208,0,0,1020302,1001010242,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102030209,0,0,1020302,1001020242,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102030210,0,0,1020302,1001040242,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102030211,0,0,1020302,1007010242,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102030212,0,0,1020302,1007020242,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102030213,0,0,1020302,1007040242,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102030214,0,0,1020302,1003000242,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102040101,0,0,1020401,1002010232,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102040102,0,0,1020401,1002020232,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102040103,0,0,1020401,1002040232,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102040104,0,0,1020401,1004010232,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102040105,0,0,1020401,1004020232,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102040106,0,0,1020401,1004040232,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102040107,0,0,1020401,1006010232,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102040108,0,0,1020401,1006020232,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102040109,0,0,1020401,1006040232,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102040110,0,0,1020401,1008010232,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102040111,0,0,1020401,1008020232,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102040112,0,0,1020401,1008040232,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102040113,0,0,1020401,1010010232,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102040114,0,0,1020401,1010020232,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102040115,0,0,1020401,1010040232,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102040116,0,0,1020401,1002010242,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102040117,0,0,1020401,1002020242,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102040118,0,0,1020401,1002040242,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102040119,0,0,1020401,1004010242,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102040120,0,0,1020401,1004020242,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102040121,0,0,1020401,1004040242,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102040122,0,0,1020401,1006010242,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102040123,0,0,1020401,1006020242,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102040124,0,0,1020401,1006040242,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102040125,0,0,1020401,1008010242,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102040126,0,0,1020401,1008020242,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102040127,0,0,1020401,1008040242,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102040128,0,0,1020401,1010010242,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102040129,0,0,1020401,1010020242,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102040130,0,0,1020401,1010040242,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102040201,0,0,1020402,1001010232,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102040202,0,0,1020402,1001020232,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102040203,0,0,1020402,1001040232,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102040204,0,0,1020402,1007010232,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102040205,0,0,1020402,1007020232,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102040206,0,0,1020402,1007040232,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102040207,0,0,1020402,1003000232,1000,'[{1,60},{2,60},{4,60}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102040208,0,0,1020402,1001010242,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102040209,0,0,1020402,1001020242,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102040210,0,0,1020402,1001040242,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102040211,0,0,1020402,1007010242,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102040212,0,0,1020402,1007020242,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102040213,0,0,1020402,1007040242,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102040214,0,0,1020402,1003000242,1000,'[{1,60},{2,60},{4,60}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102050101,0,0,1020501,1002010232,1000,'[{1,285},{2,143},{4,143}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102050102,0,0,1020501,1002020232,1000,'[{1,143},{2,285},{4,143}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102050103,0,0,1020501,1002040232,1000,'[{1,143},{2,143},{4,285}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102050104,0,0,1020501,1004010232,1000,'[{1,285},{2,143},{4,143}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102050105,0,0,1020501,1004020232,1000,'[{1,143},{2,285},{4,143}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102050106,0,0,1020501,1004040232,1000,'[{1,143},{2,143},{4,285}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102050107,0,0,1020501,1006010232,1000,'[{1,285},{2,143},{4,143}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102050108,0,0,1020501,1006020232,1000,'[{1,143},{2,285},{4,143}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102050109,0,0,1020501,1006040232,1000,'[{1,143},{2,143},{4,285}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102050110,0,0,1020501,1008010232,1000,'[{1,285},{2,143},{4,143}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102050111,0,0,1020501,1008020232,1000,'[{1,143},{2,285},{4,143}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102050112,0,0,1020501,1008040232,1000,'[{1,143},{2,143},{4,285}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102050113,0,0,1020501,1010010232,1000,'[{1,285},{2,143},{4,143}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102050114,0,0,1020501,1010020232,1000,'[{1,143},{2,285},{4,143}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102050115,0,0,1020501,1010040232,1000,'[{1,143},{2,143},{4,285}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102050116,0,0,1020501,1002010242,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102050117,0,0,1020501,1002020242,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102050118,0,0,1020501,1002040242,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102050119,0,0,1020501,1004010242,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102050120,0,0,1020501,1004020242,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102050121,0,0,1020501,1004040242,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102050122,0,0,1020501,1006010242,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102050123,0,0,1020501,1006020242,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102050124,0,0,1020501,1006040242,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102050125,0,0,1020501,1008010242,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102050126,0,0,1020501,1008020242,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102050127,0,0,1020501,1008040242,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102050128,0,0,1020501,1010010242,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102050129,0,0,1020501,1010020242,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102050130,0,0,1020501,1010040242,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102050201,0,0,1020502,1001010232,1000,'[{1,143},{2,71},{4,71}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102050202,0,0,1020502,1001020232,1000,'[{1,71},{2,143},{4,71}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102050203,0,0,1020502,1001040232,1000,'[{1,71},{2,71},{4,143}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102050204,0,0,1020502,1007010232,1000,'[{1,143},{2,71},{4,71}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102050205,0,0,1020502,1007020232,1000,'[{1,71},{2,143},{4,71}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102050206,0,0,1020502,1007040232,1000,'[{1,71},{2,71},{4,143}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102050207,0,0,1020502,1003000232,1000,'[{1,71},{2,71},{4,71}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102050208,0,0,1020502,1001010242,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102050209,0,0,1020502,1001020242,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102050210,0,0,1020502,1001040242,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102050211,0,0,1020502,1007010242,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102050212,0,0,1020502,1007020242,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102050213,0,0,1020502,1007040242,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102050214,0,0,1020502,1003000242,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102060101,0,0,1020601,1002010232,1000,'[{1,75},{2,38},{4,38}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102060102,0,0,1020601,1002020232,1000,'[{1,38},{2,75},{4,38}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102060103,0,0,1020601,1002040232,1000,'[{1,38},{2,38},{4,75}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102060104,0,0,1020601,1004010232,1000,'[{1,75},{2,38},{4,38}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102060105,0,0,1020601,1004020232,1000,'[{1,38},{2,75},{4,38}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102060106,0,0,1020601,1004040232,1000,'[{1,38},{2,38},{4,75}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102060107,0,0,1020601,1006010232,1000,'[{1,75},{2,38},{4,38}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102060108,0,0,1020601,1006020232,1000,'[{1,38},{2,75},{4,38}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102060109,0,0,1020601,1006040232,1000,'[{1,38},{2,38},{4,75}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102060110,0,0,1020601,1008010232,1000,'[{1,75},{2,38},{4,38}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102060111,0,0,1020601,1008020232,1000,'[{1,38},{2,75},{4,38}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102060112,0,0,1020601,1008040232,1000,'[{1,38},{2,38},{4,75}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102060113,0,0,1020601,1010010232,1000,'[{1,75},{2,38},{4,38}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102060114,0,0,1020601,1010020232,1000,'[{1,38},{2,75},{4,38}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102060115,0,0,1020601,1010040232,1000,'[{1,38},{2,38},{4,75}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102060116,0,0,1020601,1002010242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102060117,0,0,1020601,1002020242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102060118,0,0,1020601,1002040242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102060119,0,0,1020601,1004010242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102060120,0,0,1020601,1004020242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102060121,0,0,1020601,1004040242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102060122,0,0,1020601,1006010242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102060123,0,0,1020601,1006020242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102060124,0,0,1020601,1006040242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102060125,0,0,1020601,1008010242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102060126,0,0,1020601,1008020242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102060127,0,0,1020601,1008040242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102060128,0,0,1020601,1010010242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102060129,0,0,1020601,1010020242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102060130,0,0,1020601,1010040242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102060201,0,0,1020602,1001010232,1000,'[{1,38},{2,19},{4,19}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102060202,0,0,1020602,1001020232,1000,'[{1,19},{2,38},{4,19}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102060203,0,0,1020602,1001040232,1000,'[{1,19},{2,19},{4,38}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102060204,0,0,1020602,1007010232,1000,'[{1,38},{2,19},{4,19}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102060205,0,0,1020602,1007020232,1000,'[{1,19},{2,38},{4,19}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102060206,0,0,1020602,1007040232,1000,'[{1,19},{2,19},{4,38}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102060207,0,0,1020602,1003000232,1000,'[{1,19},{2,19},{4,19}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102060208,0,0,1020602,1001010242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102060209,0,0,1020602,1001020242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102060210,0,0,1020602,1001040242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102060211,0,0,1020602,1007010242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102060212,0,0,1020602,1007020242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102060213,0,0,1020602,1007040242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102060214,0,0,1020602,1003000242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102070101,0,0,1020701,1002010232,1000,'[{1,85},{2,43},{4,43}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102070102,0,0,1020701,1002020232,1000,'[{1,43},{2,85},{4,43}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102070103,0,0,1020701,1002040232,1000,'[{1,43},{2,43},{4,85}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102070104,0,0,1020701,1004010232,1000,'[{1,85},{2,43},{4,43}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102070105,0,0,1020701,1004020232,1000,'[{1,43},{2,85},{4,43}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102070106,0,0,1020701,1004040232,1000,'[{1,43},{2,43},{4,85}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102070107,0,0,1020701,1006010232,1000,'[{1,85},{2,43},{4,43}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102070108,0,0,1020701,1006020232,1000,'[{1,43},{2,85},{4,43}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102070109,0,0,1020701,1006040232,1000,'[{1,43},{2,43},{4,85}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102070110,0,0,1020701,1008010232,1000,'[{1,85},{2,43},{4,43}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102070111,0,0,1020701,1008020232,1000,'[{1,43},{2,85},{4,43}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102070112,0,0,1020701,1008040232,1000,'[{1,43},{2,43},{4,85}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102070113,0,0,1020701,1010010232,1000,'[{1,85},{2,43},{4,43}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102070114,0,0,1020701,1010020232,1000,'[{1,43},{2,85},{4,43}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102070115,0,0,1020701,1010040232,1000,'[{1,43},{2,43},{4,85}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102070116,0,0,1020701,1002010242,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102070117,0,0,1020701,1002020242,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102070118,0,0,1020701,1002040242,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102070119,0,0,1020701,1004010242,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102070120,0,0,1020701,1004020242,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102070121,0,0,1020701,1004040242,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102070122,0,0,1020701,1006010242,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102070123,0,0,1020701,1006020242,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102070124,0,0,1020701,1006040242,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102070125,0,0,1020701,1008010242,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102070126,0,0,1020701,1008020242,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102070127,0,0,1020701,1008040242,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102070128,0,0,1020701,1010010242,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102070129,0,0,1020701,1010020242,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102070130,0,0,1020701,1010040242,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102070201,0,0,1020702,1001010232,1000,'[{1,68},{2,34},{4,34}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102070202,0,0,1020702,1001020232,1000,'[{1,34},{2,68},{4,34}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102070203,0,0,1020702,1001040232,1000,'[{1,34},{2,34},{4,68}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102070204,0,0,1020702,1007010232,1000,'[{1,68},{2,34},{4,34}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102070205,0,0,1020702,1007020232,1000,'[{1,34},{2,68},{4,34}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102070206,0,0,1020702,1007040232,1000,'[{1,34},{2,34},{4,68}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102070207,0,0,1020702,1003000232,1000,'[{1,34},{2,34},{4,34}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102070208,0,0,1020702,1001010242,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102070209,0,0,1020702,1001020242,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102070210,0,0,1020702,1001040242,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102070211,0,0,1020702,1007010242,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102070212,0,0,1020702,1007020242,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102070213,0,0,1020702,1007040242,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102070214,0,0,1020702,1003000242,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102080101,0,0,1020801,1002010232,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102080102,0,0,1020801,1002020232,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102080103,0,0,1020801,1002040232,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102080104,0,0,1020801,1004010232,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102080105,0,0,1020801,1004020232,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102080106,0,0,1020801,1004040232,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102080107,0,0,1020801,1006010232,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102080108,0,0,1020801,1006020232,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102080109,0,0,1020801,1006040232,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102080110,0,0,1020801,1008010232,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102080111,0,0,1020801,1008020232,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102080112,0,0,1020801,1008040232,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102080113,0,0,1020801,1010010232,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102080114,0,0,1020801,1010020232,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102080115,0,0,1020801,1010040232,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102080116,0,0,1020801,1002010242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102080117,0,0,1020801,1002020242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102080118,0,0,1020801,1002040242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102080119,0,0,1020801,1004010242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102080120,0,0,1020801,1004020242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102080121,0,0,1020801,1004040242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102080122,0,0,1020801,1006010242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102080123,0,0,1020801,1006020242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102080124,0,0,1020801,1006040242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102080125,0,0,1020801,1008010242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102080126,0,0,1020801,1008020242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102080127,0,0,1020801,1008040242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102080128,0,0,1020801,1010010242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102080129,0,0,1020801,1010020242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102080130,0,0,1020801,1010040242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102080201,0,0,1020802,1001010232,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102080202,0,0,1020802,1001020232,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102080203,0,0,1020802,1001040232,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102080204,0,0,1020802,1007010232,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102080205,0,0,1020802,1007020232,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102080206,0,0,1020802,1007040232,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102080207,0,0,1020802,1003000232,1000,'[{1,163},{2,163},{4,163}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(102080208,0,0,1020802,1001010242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102080209,0,0,1020802,1001020242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102080210,0,0,1020802,1001040242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102080211,0,0,1020802,1007010242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102080212,0,0,1020802,1007020242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102080213,0,0,1020802,1007040242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(102080214,0,0,1020802,1003000242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103010001,0,0,1030100,1002010310,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(103010002,0,0,1030100,1002020310,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(103010003,0,0,1030100,1002040310,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(103010004,0,0,1030100,1004010310,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(103010005,0,0,1030100,1004020310,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(103010006,0,0,1030100,1004040310,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(103010007,0,0,1030100,1006010310,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(103010008,0,0,1030100,1006020310,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(103010009,0,0,1030100,1006040310,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(103010010,0,0,1030100,1008010310,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(103010011,0,0,1030100,1008020310,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(103010012,0,0,1030100,1008040310,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(103010013,0,0,1030100,1010010310,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(103010014,0,0,1030100,1010020310,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(103010015,0,0,1030100,1010040310,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(103010016,0,0,1030100,1001010310,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(103010017,0,0,1030100,1001020310,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000201','0',0,'[]',0,0,0,0,'[]'),(103010018,0,0,1030100,1001040310,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000401','0',0,'[]',0,0,0,0,'[]'),(103010019,0,0,1030100,1007010310,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(103010020,0,0,1030100,1007020310,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000207','0',0,'[]',0,0,0,0,'[]'),(103010021,0,0,1030100,1007040310,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000407','0',0,'[]',0,0,0,0,'[]'),(103010022,0,0,1030100,1003000310,300,'[{1,75},{2,75},{4,75}]',1,1,'[]',0,'1000003','0',0,'[]',0,0,0,0,'[]'),(103010023,0,0,1030100,1002010320,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(103010024,0,0,1030100,1002020320,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(103010025,0,0,1030100,1002040320,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(103010026,0,0,1030100,1004010320,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(103010027,0,0,1030100,1004020320,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(103010028,0,0,1030100,1004040320,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(103010029,0,0,1030100,1006010320,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(103010030,0,0,1030100,1006020320,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(103010031,0,0,1030100,1006040320,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(103010032,0,0,1030100,1008010320,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(103010033,0,0,1030100,1008020320,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(103010034,0,0,1030100,1008040320,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(103010035,0,0,1030100,1010010320,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(103010036,0,0,1030100,1010020320,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(103010037,0,0,1030100,1010040320,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(103010038,0,0,1030100,1001010320,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(103010039,0,0,1030100,1001020320,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000201','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(103010040,0,0,1030100,1001040320,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000401','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(103010041,0,0,1030100,1007010320,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(103010042,0,0,1030100,1007020320,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000207','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(103010043,0,0,1030100,1007040320,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000407','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(103010044,0,0,1030100,1003000320,300,'[{1,75},{2,75},{4,75}]',1,1,'[]',0,'1000003','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(103020001,0,0,1030200,1002010331,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(103020002,0,0,1030200,1002020331,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(103020003,0,0,1030200,1002040331,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(103020004,0,0,1030200,1004010331,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(103020005,0,0,1030200,1004020331,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(103020006,0,0,1030200,1004040331,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(103020007,0,0,1030200,1006010331,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(103020008,0,0,1030200,1006020331,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(103020009,0,0,1030200,1006040331,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(103020010,0,0,1030200,1008010331,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(103020011,0,0,1030200,1008020331,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(103020012,0,0,1030200,1008040331,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(103020013,0,0,1030200,1010010331,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(103020014,0,0,1030200,1010020331,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(103020015,0,0,1030200,1010040331,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(103020016,0,0,1030200,1001010331,1000,'[{1,50},{2,25},{4,25}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(103020017,0,0,1030200,1001020331,1000,'[{1,25},{2,50},{4,25}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(103020018,0,0,1030200,1001040331,1000,'[{1,25},{2,25},{4,50}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(103020019,0,0,1030200,1007010331,1000,'[{1,50},{2,25},{4,25}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(103020020,0,0,1030200,1007020331,1000,'[{1,25},{2,50},{4,25}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(103020021,0,0,1030200,1007040331,1000,'[{1,25},{2,25},{4,50}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(103020022,0,0,1030200,1003000331,1000,'[{1,25},{2,25},{4,25}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(103020023,0,0,1030200,1002010341,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(103020024,0,0,1030200,1002020341,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(103020025,0,0,1030200,1002040341,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(103020026,0,0,1030200,1004010341,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(103020027,0,0,1030200,1004020341,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(103020028,0,0,1030200,1004040341,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(103020029,0,0,1030200,1006010341,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(103020030,0,0,1030200,1006020341,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(103020031,0,0,1030200,1006040341,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(103020032,0,0,1030200,1008010341,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(103020033,0,0,1030200,1008020341,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(103020034,0,0,1030200,1008040341,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(103020035,0,0,1030200,1010010341,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(103020036,0,0,1030200,1010020341,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(103020037,0,0,1030200,1010040341,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(103020038,0,0,1030200,1001010341,1000,'[{1,20},{2,10},{4,10}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(103020039,0,0,1030200,1001020341,1000,'[{1,10},{2,20},{4,10}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[]',0,0,0,0,'[]'),(103020040,0,0,1030200,1001040341,1000,'[{1,10},{2,10},{4,20}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[]',0,0,0,0,'[]'),(103020041,0,0,1030200,1007010341,1000,'[{1,20},{2,10},{4,10}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(103020042,0,0,1030200,1007020341,1000,'[{1,10},{2,20},{4,10}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[]',0,0,0,0,'[]'),(103020043,0,0,1030200,1007040341,1000,'[{1,10},{2,10},{4,20}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[]',0,0,0,0,'[]'),(103020044,0,0,1030200,1003000341,1000,'[{1,10},{2,10},{4,10}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[]',0,0,0,0,'[]'),(103030101,0,0,1030301,1002010332,1000,'[{1,152},{2,76},{4,76}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103030102,0,0,1030301,1002020332,1000,'[{1,76},{2,152},{4,76}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103030103,0,0,1030301,1002040332,1000,'[{1,76},{2,76},{4,152}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103030104,0,0,1030301,1004010332,1000,'[{1,152},{2,76},{4,76}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103030105,0,0,1030301,1004020332,1000,'[{1,76},{2,152},{4,76}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103030106,0,0,1030301,1004040332,1000,'[{1,76},{2,76},{4,152}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103030107,0,0,1030301,1006010332,1000,'[{1,152},{2,76},{4,76}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103030108,0,0,1030301,1006020332,1000,'[{1,76},{2,152},{4,76}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103030109,0,0,1030301,1006040332,1000,'[{1,76},{2,76},{4,152}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103030110,0,0,1030301,1008010332,1000,'[{1,152},{2,76},{4,76}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103030111,0,0,1030301,1008020332,1000,'[{1,76},{2,152},{4,76}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103030112,0,0,1030301,1008040332,1000,'[{1,76},{2,76},{4,152}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103030113,0,0,1030301,1010010332,1000,'[{1,152},{2,76},{4,76}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103030114,0,0,1030301,1010020332,1000,'[{1,76},{2,152},{4,76}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103030115,0,0,1030301,1010040332,1000,'[{1,76},{2,76},{4,152}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103030116,0,0,1030301,1002010342,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103030117,0,0,1030301,1002020342,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103030118,0,0,1030301,1002040342,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103030119,0,0,1030301,1004010342,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103030120,0,0,1030301,1004020342,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103030121,0,0,1030301,1004040342,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103030122,0,0,1030301,1006010342,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103030123,0,0,1030301,1006020342,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103030124,0,0,1030301,1006040342,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103030125,0,0,1030301,1008010342,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103030126,0,0,1030301,1008020342,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103030127,0,0,1030301,1008040342,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103030128,0,0,1030301,1010010342,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103030129,0,0,1030301,1010020342,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103030130,0,0,1030301,1010040342,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103030201,0,0,1030302,1001010332,1000,'[{1,76},{2,38},{4,38}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103030202,0,0,1030302,1001020332,1000,'[{1,38},{2,76},{4,38}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103030203,0,0,1030302,1001040332,1000,'[{1,38},{2,38},{4,76}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103030204,0,0,1030302,1007010332,1000,'[{1,76},{2,38},{4,38}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103030205,0,0,1030302,1007020332,1000,'[{1,38},{2,76},{4,38}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103030206,0,0,1030302,1007040332,1000,'[{1,38},{2,38},{4,76}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103030207,0,0,1030302,1003000332,1000,'[{1,38},{2,38},{4,38}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103030208,0,0,1030302,1001010342,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103030209,0,0,1030302,1001020342,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103030210,0,0,1030302,1001040342,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103030211,0,0,1030302,1007010342,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103030212,0,0,1030302,1007020342,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103030213,0,0,1030302,1007040342,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103030214,0,0,1030302,1003000342,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103040101,0,0,1030401,1002010332,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103040102,0,0,1030401,1002020332,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103040103,0,0,1030401,1002040332,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103040104,0,0,1030401,1004010332,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103040105,0,0,1030401,1004020332,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103040106,0,0,1030401,1004040332,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103040107,0,0,1030401,1006010332,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103040108,0,0,1030401,1006020332,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103040109,0,0,1030401,1006040332,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103040110,0,0,1030401,1008010332,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103040111,0,0,1030401,1008020332,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103040112,0,0,1030401,1008040332,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103040113,0,0,1030401,1010010332,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103040114,0,0,1030401,1010020332,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103040115,0,0,1030401,1010040332,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103040116,0,0,1030401,1002010342,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103040117,0,0,1030401,1002020342,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103040118,0,0,1030401,1002040342,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103040119,0,0,1030401,1004010342,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103040120,0,0,1030401,1004020342,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103040121,0,0,1030401,1004040342,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103040122,0,0,1030401,1006010342,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103040123,0,0,1030401,1006020342,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103040124,0,0,1030401,1006040342,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103040125,0,0,1030401,1008010342,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103040126,0,0,1030401,1008020342,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103040127,0,0,1030401,1008040342,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103040128,0,0,1030401,1010010342,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103040129,0,0,1030401,1010020342,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103040130,0,0,1030401,1010040342,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103040201,0,0,1030402,1001010332,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103040202,0,0,1030402,1001020332,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103040203,0,0,1030402,1001040332,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103040204,0,0,1030402,1007010332,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103040205,0,0,1030402,1007020332,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103040206,0,0,1030402,1007040332,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103040207,0,0,1030402,1003000332,1000,'[{1,60},{2,60},{4,60}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103040208,0,0,1030402,1001010342,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103040209,0,0,1030402,1001020342,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103040210,0,0,1030402,1001040342,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103040211,0,0,1030402,1007010342,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103040212,0,0,1030402,1007020342,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103040213,0,0,1030402,1007040342,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103040214,0,0,1030402,1003000342,1000,'[{1,60},{2,60},{4,60}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103050101,0,0,1030501,1002010332,1000,'[{1,285},{2,143},{4,143}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103050102,0,0,1030501,1002020332,1000,'[{1,143},{2,285},{4,143}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103050103,0,0,1030501,1002040332,1000,'[{1,143},{2,143},{4,285}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103050104,0,0,1030501,1004010332,1000,'[{1,285},{2,143},{4,143}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103050105,0,0,1030501,1004020332,1000,'[{1,143},{2,285},{4,143}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103050106,0,0,1030501,1004040332,1000,'[{1,143},{2,143},{4,285}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103050107,0,0,1030501,1006010332,1000,'[{1,285},{2,143},{4,143}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103050108,0,0,1030501,1006020332,1000,'[{1,143},{2,285},{4,143}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103050109,0,0,1030501,1006040332,1000,'[{1,143},{2,143},{4,285}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103050110,0,0,1030501,1008010332,1000,'[{1,285},{2,143},{4,143}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103050111,0,0,1030501,1008020332,1000,'[{1,143},{2,285},{4,143}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103050112,0,0,1030501,1008040332,1000,'[{1,143},{2,143},{4,285}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103050113,0,0,1030501,1010010332,1000,'[{1,285},{2,143},{4,143}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103050114,0,0,1030501,1010020332,1000,'[{1,143},{2,285},{4,143}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103050115,0,0,1030501,1010040332,1000,'[{1,143},{2,143},{4,285}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103050116,0,0,1030501,1002010342,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103050117,0,0,1030501,1002020342,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103050118,0,0,1030501,1002040342,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103050119,0,0,1030501,1004010342,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103050120,0,0,1030501,1004020342,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103050121,0,0,1030501,1004040342,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103050122,0,0,1030501,1006010342,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103050123,0,0,1030501,1006020342,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103050124,0,0,1030501,1006040342,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103050125,0,0,1030501,1008010342,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103050126,0,0,1030501,1008020342,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103050127,0,0,1030501,1008040342,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103050128,0,0,1030501,1010010342,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103050129,0,0,1030501,1010020342,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103050130,0,0,1030501,1010040342,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103050201,0,0,1030502,1001010332,1000,'[{1,143},{2,71},{4,71}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103050202,0,0,1030502,1001020332,1000,'[{1,71},{2,143},{4,71}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103050203,0,0,1030502,1001040332,1000,'[{1,71},{2,71},{4,143}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103050204,0,0,1030502,1007010332,1000,'[{1,143},{2,71},{4,71}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103050205,0,0,1030502,1007020332,1000,'[{1,71},{2,143},{4,71}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103050206,0,0,1030502,1007040332,1000,'[{1,71},{2,71},{4,143}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103050207,0,0,1030502,1003000332,1000,'[{1,71},{2,71},{4,71}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103050208,0,0,1030502,1001010342,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103050209,0,0,1030502,1001020342,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103050210,0,0,1030502,1001040342,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103050211,0,0,1030502,1007010342,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103050212,0,0,1030502,1007020342,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103050213,0,0,1030502,1007040342,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103050214,0,0,1030502,1003000342,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103060101,0,0,1030601,1002010332,1000,'[{1,75},{2,38},{4,38}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103060102,0,0,1030601,1002020332,1000,'[{1,38},{2,75},{4,38}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103060103,0,0,1030601,1002040332,1000,'[{1,38},{2,38},{4,75}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103060104,0,0,1030601,1004010332,1000,'[{1,75},{2,38},{4,38}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103060105,0,0,1030601,1004020332,1000,'[{1,38},{2,75},{4,38}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103060106,0,0,1030601,1004040332,1000,'[{1,38},{2,38},{4,75}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103060107,0,0,1030601,1006010332,1000,'[{1,75},{2,38},{4,38}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103060108,0,0,1030601,1006020332,1000,'[{1,38},{2,75},{4,38}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103060109,0,0,1030601,1006040332,1000,'[{1,38},{2,38},{4,75}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103060110,0,0,1030601,1008010332,1000,'[{1,75},{2,38},{4,38}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103060111,0,0,1030601,1008020332,1000,'[{1,38},{2,75},{4,38}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103060112,0,0,1030601,1008040332,1000,'[{1,38},{2,38},{4,75}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103060113,0,0,1030601,1010010332,1000,'[{1,75},{2,38},{4,38}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103060114,0,0,1030601,1010020332,1000,'[{1,38},{2,75},{4,38}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103060115,0,0,1030601,1010040332,1000,'[{1,38},{2,38},{4,75}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103060116,0,0,1030601,1002010342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103060117,0,0,1030601,1002020342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103060118,0,0,1030601,1002040342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103060119,0,0,1030601,1004010342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103060120,0,0,1030601,1004020342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103060121,0,0,1030601,1004040342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103060122,0,0,1030601,1006010342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103060123,0,0,1030601,1006020342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103060124,0,0,1030601,1006040342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103060125,0,0,1030601,1008010342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103060126,0,0,1030601,1008020342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103060127,0,0,1030601,1008040342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103060128,0,0,1030601,1010010342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103060129,0,0,1030601,1010020342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103060130,0,0,1030601,1010040342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103060201,0,0,1030602,1001010332,1000,'[{1,38},{2,19},{4,19}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103060202,0,0,1030602,1001020332,1000,'[{1,19},{2,38},{4,19}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103060203,0,0,1030602,1001040332,1000,'[{1,19},{2,19},{4,38}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103060204,0,0,1030602,1007010332,1000,'[{1,38},{2,19},{4,19}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103060205,0,0,1030602,1007020332,1000,'[{1,19},{2,38},{4,19}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103060206,0,0,1030602,1007040332,1000,'[{1,19},{2,19},{4,38}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103060207,0,0,1030602,1003000332,1000,'[{1,19},{2,19},{4,19}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103060208,0,0,1030602,1001010342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103060209,0,0,1030602,1001020342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103060210,0,0,1030602,1001040342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103060211,0,0,1030602,1007010342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103060212,0,0,1030602,1007020342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103060213,0,0,1030602,1007040342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103060214,0,0,1030602,1003000342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103070101,0,0,1030701,1002010332,1000,'[{1,85},{2,43},{4,43}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103070102,0,0,1030701,1002020332,1000,'[{1,43},{2,85},{4,43}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103070103,0,0,1030701,1002040332,1000,'[{1,43},{2,43},{4,85}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103070104,0,0,1030701,1004010332,1000,'[{1,85},{2,43},{4,43}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103070105,0,0,1030701,1004020332,1000,'[{1,43},{2,85},{4,43}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103070106,0,0,1030701,1004040332,1000,'[{1,43},{2,43},{4,85}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103070107,0,0,1030701,1006010332,1000,'[{1,85},{2,43},{4,43}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103070108,0,0,1030701,1006020332,1000,'[{1,43},{2,85},{4,43}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103070109,0,0,1030701,1006040332,1000,'[{1,43},{2,43},{4,85}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103070110,0,0,1030701,1008010332,1000,'[{1,85},{2,43},{4,43}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103070111,0,0,1030701,1008020332,1000,'[{1,43},{2,85},{4,43}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103070112,0,0,1030701,1008040332,1000,'[{1,43},{2,43},{4,85}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103070113,0,0,1030701,1010010332,1000,'[{1,85},{2,43},{4,43}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103070114,0,0,1030701,1010020332,1000,'[{1,43},{2,85},{4,43}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103070115,0,0,1030701,1010040332,1000,'[{1,43},{2,43},{4,85}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103070116,0,0,1030701,1002010342,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103070117,0,0,1030701,1002020342,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103070118,0,0,1030701,1002040342,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103070119,0,0,1030701,1004010342,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103070120,0,0,1030701,1004020342,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103070121,0,0,1030701,1004040342,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103070122,0,0,1030701,1006010342,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103070123,0,0,1030701,1006020342,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103070124,0,0,1030701,1006040342,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103070125,0,0,1030701,1008010342,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103070126,0,0,1030701,1008020342,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103070127,0,0,1030701,1008040342,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103070128,0,0,1030701,1010010342,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103070129,0,0,1030701,1010020342,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103070130,0,0,1030701,1010040342,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103070201,0,0,1030702,1001010332,1000,'[{1,68},{2,34},{4,34}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103070202,0,0,1030702,1001020332,1000,'[{1,34},{2,68},{4,34}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103070203,0,0,1030702,1001040332,1000,'[{1,34},{2,34},{4,68}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103070204,0,0,1030702,1007010332,1000,'[{1,68},{2,34},{4,34}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103070205,0,0,1030702,1007020332,1000,'[{1,34},{2,68},{4,34}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103070206,0,0,1030702,1007040332,1000,'[{1,34},{2,34},{4,68}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103070207,0,0,1030702,1003000332,1000,'[{1,34},{2,34},{4,34}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103070208,0,0,1030702,1001010342,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103070209,0,0,1030702,1001020342,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103070210,0,0,1030702,1001040342,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103070211,0,0,1030702,1007010342,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103070212,0,0,1030702,1007020342,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103070213,0,0,1030702,1007040342,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103070214,0,0,1030702,1003000342,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103080101,0,0,1030801,1002010332,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103080102,0,0,1030801,1002020332,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103080103,0,0,1030801,1002040332,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103080104,0,0,1030801,1004010332,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103080105,0,0,1030801,1004020332,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103080106,0,0,1030801,1004040332,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103080107,0,0,1030801,1006010332,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103080108,0,0,1030801,1006020332,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103080109,0,0,1030801,1006040332,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103080110,0,0,1030801,1008010332,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103080111,0,0,1030801,1008020332,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103080112,0,0,1030801,1008040332,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103080113,0,0,1030801,1010010332,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103080114,0,0,1030801,1010020332,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103080115,0,0,1030801,1010040332,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103080116,0,0,1030801,1002010342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103080117,0,0,1030801,1002020342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103080118,0,0,1030801,1002040342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103080119,0,0,1030801,1004010342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103080120,0,0,1030801,1004020342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103080121,0,0,1030801,1004040342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103080122,0,0,1030801,1006010342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103080123,0,0,1030801,1006020342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103080124,0,0,1030801,1006040342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103080125,0,0,1030801,1008010342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103080126,0,0,1030801,1008020342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103080127,0,0,1030801,1008040342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103080128,0,0,1030801,1010010342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103080129,0,0,1030801,1010020342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103080130,0,0,1030801,1010040342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103080201,0,0,1030802,1001010332,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103080202,0,0,1030802,1001020332,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103080203,0,0,1030802,1001040332,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103080204,0,0,1030802,1007010332,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103080205,0,0,1030802,1007020332,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103080206,0,0,1030802,1007040332,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103080207,0,0,1030802,1003000332,1000,'[{1,163},{2,163},{4,163}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(103080208,0,0,1030802,1001010342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103080209,0,0,1030802,1001020342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103080210,0,0,1030802,1001040342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103080211,0,0,1030802,1007010342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103080212,0,0,1030802,1007020342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103080213,0,0,1030802,1007040342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(103080214,0,0,1030802,1003000342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104010001,0,0,1040100,1002010410,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(104010002,0,0,1040100,1002020410,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(104010003,0,0,1040100,1002040410,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(104010004,0,0,1040100,1004010410,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(104010005,0,0,1040100,1004020410,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(104010006,0,0,1040100,1004040410,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(104010007,0,0,1040100,1006010410,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(104010008,0,0,1040100,1006020410,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(104010009,0,0,1040100,1006040410,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(104010010,0,0,1040100,1008010410,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(104010011,0,0,1040100,1008020410,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(104010012,0,0,1040100,1008040410,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(104010013,0,0,1040100,1010010410,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(104010014,0,0,1040100,1010020410,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(104010015,0,0,1040100,1010040410,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(104010016,0,0,1040100,1001010410,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(104010017,0,0,1040100,1001020410,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000201','0',0,'[]',0,0,0,0,'[]'),(104010018,0,0,1040100,1001040410,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000401','0',0,'[]',0,0,0,0,'[]'),(104010019,0,0,1040100,1007010410,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(104010020,0,0,1040100,1007020410,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000207','0',0,'[]',0,0,0,0,'[]'),(104010021,0,0,1040100,1007040410,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000407','0',0,'[]',0,0,0,0,'[]'),(104010022,0,0,1040100,1003000410,300,'[{1,75},{2,75},{4,75}]',1,1,'[]',0,'1000003','0',0,'[]',0,0,0,0,'[]'),(104010023,0,0,1040100,1002010420,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(104010024,0,0,1040100,1002020420,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(104010025,0,0,1040100,1002040420,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(104010026,0,0,1040100,1004010420,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(104010027,0,0,1040100,1004020420,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(104010028,0,0,1040100,1004040420,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(104010029,0,0,1040100,1006010420,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(104010030,0,0,1040100,1006020420,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(104010031,0,0,1040100,1006040420,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(104010032,0,0,1040100,1008010420,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(104010033,0,0,1040100,1008020420,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(104010034,0,0,1040100,1008040420,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(104010035,0,0,1040100,1010010420,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(104010036,0,0,1040100,1010020420,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(104010037,0,0,1040100,1010040420,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(104010038,0,0,1040100,1001010420,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(104010039,0,0,1040100,1001020420,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000201','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(104010040,0,0,1040100,1001040420,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000401','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(104010041,0,0,1040100,1007010420,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(104010042,0,0,1040100,1007020420,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000207','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(104010043,0,0,1040100,1007040420,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000407','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(104010044,0,0,1040100,1003000420,300,'[{1,75},{2,75},{4,75}]',1,1,'[]',0,'1000003','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(104020001,0,0,1040200,1002010431,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(104020002,0,0,1040200,1002020431,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(104020003,0,0,1040200,1002040431,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(104020004,0,0,1040200,1004010431,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(104020005,0,0,1040200,1004020431,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(104020006,0,0,1040200,1004040431,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(104020007,0,0,1040200,1006010431,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(104020008,0,0,1040200,1006020431,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(104020009,0,0,1040200,1006040431,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(104020010,0,0,1040200,1008010431,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(104020011,0,0,1040200,1008020431,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(104020012,0,0,1040200,1008040431,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(104020013,0,0,1040200,1010010431,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(104020014,0,0,1040200,1010020431,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(104020015,0,0,1040200,1010040431,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(104020016,0,0,1040200,1001010431,1000,'[{1,50},{2,25},{4,25}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(104020017,0,0,1040200,1001020431,1000,'[{1,25},{2,50},{4,25}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(104020018,0,0,1040200,1001040431,1000,'[{1,25},{2,25},{4,50}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(104020019,0,0,1040200,1007010431,1000,'[{1,50},{2,25},{4,25}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(104020020,0,0,1040200,1007020431,1000,'[{1,25},{2,50},{4,25}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(104020021,0,0,1040200,1007040431,1000,'[{1,25},{2,25},{4,50}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(104020022,0,0,1040200,1003000431,1000,'[{1,25},{2,25},{4,25}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(104020023,0,0,1040200,1002010441,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(104020024,0,0,1040200,1002020441,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(104020025,0,0,1040200,1002040441,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(104020026,0,0,1040200,1004010441,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(104020027,0,0,1040200,1004020441,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(104020028,0,0,1040200,1004040441,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(104020029,0,0,1040200,1006010441,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(104020030,0,0,1040200,1006020441,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(104020031,0,0,1040200,1006040441,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(104020032,0,0,1040200,1008010441,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(104020033,0,0,1040200,1008020441,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(104020034,0,0,1040200,1008040441,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(104020035,0,0,1040200,1010010441,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(104020036,0,0,1040200,1010020441,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(104020037,0,0,1040200,1010040441,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(104020038,0,0,1040200,1001010441,1000,'[{1,20},{2,10},{4,10}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(104020039,0,0,1040200,1001020441,1000,'[{1,10},{2,20},{4,10}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[]',0,0,0,0,'[]'),(104020040,0,0,1040200,1001040441,1000,'[{1,10},{2,10},{4,20}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[]',0,0,0,0,'[]'),(104020041,0,0,1040200,1007010441,1000,'[{1,20},{2,10},{4,10}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(104020042,0,0,1040200,1007020441,1000,'[{1,10},{2,20},{4,10}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[]',0,0,0,0,'[]'),(104020043,0,0,1040200,1007040441,1000,'[{1,10},{2,10},{4,20}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[]',0,0,0,0,'[]'),(104020044,0,0,1040200,1003000441,1000,'[{1,10},{2,10},{4,10}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[]',0,0,0,0,'[]'),(104030101,0,0,1040301,1002010432,1000,'[{1,152},{2,76},{4,76}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104030102,0,0,1040301,1002020432,1000,'[{1,76},{2,152},{4,76}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104030103,0,0,1040301,1002040432,1000,'[{1,76},{2,76},{4,152}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104030104,0,0,1040301,1004010432,1000,'[{1,152},{2,76},{4,76}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104030105,0,0,1040301,1004020432,1000,'[{1,76},{2,152},{4,76}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104030106,0,0,1040301,1004040432,1000,'[{1,76},{2,76},{4,152}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104030107,0,0,1040301,1006010432,1000,'[{1,152},{2,76},{4,76}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104030108,0,0,1040301,1006020432,1000,'[{1,76},{2,152},{4,76}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104030109,0,0,1040301,1006040432,1000,'[{1,76},{2,76},{4,152}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104030110,0,0,1040301,1008010432,1000,'[{1,152},{2,76},{4,76}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104030111,0,0,1040301,1008020432,1000,'[{1,76},{2,152},{4,76}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104030112,0,0,1040301,1008040432,1000,'[{1,76},{2,76},{4,152}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104030113,0,0,1040301,1010010432,1000,'[{1,152},{2,76},{4,76}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104030114,0,0,1040301,1010020432,1000,'[{1,76},{2,152},{4,76}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104030115,0,0,1040301,1010040432,1000,'[{1,76},{2,76},{4,152}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104030116,0,0,1040301,1002010442,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104030117,0,0,1040301,1002020442,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104030118,0,0,1040301,1002040442,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104030119,0,0,1040301,1004010442,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104030120,0,0,1040301,1004020442,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104030121,0,0,1040301,1004040442,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104030122,0,0,1040301,1006010442,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104030123,0,0,1040301,1006020442,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104030124,0,0,1040301,1006040442,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104030125,0,0,1040301,1008010442,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104030126,0,0,1040301,1008020442,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104030127,0,0,1040301,1008040442,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104030128,0,0,1040301,1010010442,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104030129,0,0,1040301,1010020442,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104030130,0,0,1040301,1010040442,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104030201,0,0,1040302,1001010432,1000,'[{1,76},{2,38},{4,38}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104030202,0,0,1040302,1001020432,1000,'[{1,38},{2,76},{4,38}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104030203,0,0,1040302,1001040432,1000,'[{1,38},{2,38},{4,76}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104030204,0,0,1040302,1007010432,1000,'[{1,76},{2,38},{4,38}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104030205,0,0,1040302,1007020432,1000,'[{1,38},{2,76},{4,38}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104030206,0,0,1040302,1007040432,1000,'[{1,38},{2,38},{4,76}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104030207,0,0,1040302,1003000432,1000,'[{1,38},{2,38},{4,38}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104030208,0,0,1040302,1001010442,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104030209,0,0,1040302,1001020442,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104030210,0,0,1040302,1001040442,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104030211,0,0,1040302,1007010442,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104030212,0,0,1040302,1007020442,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104030213,0,0,1040302,1007040442,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104030214,0,0,1040302,1003000442,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104040101,0,0,1040401,1002010432,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104040102,0,0,1040401,1002020432,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104040103,0,0,1040401,1002040432,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104040104,0,0,1040401,1004010432,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104040105,0,0,1040401,1004020432,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104040106,0,0,1040401,1004040432,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104040107,0,0,1040401,1006010432,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104040108,0,0,1040401,1006020432,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104040109,0,0,1040401,1006040432,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104040110,0,0,1040401,1008010432,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104040111,0,0,1040401,1008020432,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104040112,0,0,1040401,1008040432,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104040113,0,0,1040401,1010010432,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104040114,0,0,1040401,1010020432,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104040115,0,0,1040401,1010040432,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104040116,0,0,1040401,1002010442,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104040117,0,0,1040401,1002020442,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104040118,0,0,1040401,1002040442,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104040119,0,0,1040401,1004010442,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104040120,0,0,1040401,1004020442,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104040121,0,0,1040401,1004040442,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104040122,0,0,1040401,1006010442,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104040123,0,0,1040401,1006020442,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104040124,0,0,1040401,1006040442,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104040125,0,0,1040401,1008010442,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104040126,0,0,1040401,1008020442,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104040127,0,0,1040401,1008040442,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104040128,0,0,1040401,1010010442,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104040129,0,0,1040401,1010020442,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104040130,0,0,1040401,1010040442,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104040201,0,0,1040402,1001010432,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104040202,0,0,1040402,1001020432,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104040203,0,0,1040402,1001040432,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104040204,0,0,1040402,1007010432,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104040205,0,0,1040402,1007020432,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104040206,0,0,1040402,1007040432,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104040207,0,0,1040402,1003000432,1000,'[{1,60},{2,60},{4,60}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104040208,0,0,1040402,1001010442,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104040209,0,0,1040402,1001020442,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104040210,0,0,1040402,1001040442,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104040211,0,0,1040402,1007010442,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104040212,0,0,1040402,1007020442,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104040213,0,0,1040402,1007040442,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104040214,0,0,1040402,1003000442,1000,'[{1,60},{2,60},{4,60}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104050101,0,0,1040501,1002010432,1000,'[{1,285},{2,143},{4,143}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104050102,0,0,1040501,1002020432,1000,'[{1,143},{2,285},{4,143}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104050103,0,0,1040501,1002040432,1000,'[{1,143},{2,143},{4,285}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104050104,0,0,1040501,1004010432,1000,'[{1,285},{2,143},{4,143}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104050105,0,0,1040501,1004020432,1000,'[{1,143},{2,285},{4,143}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104050106,0,0,1040501,1004040432,1000,'[{1,143},{2,143},{4,285}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104050107,0,0,1040501,1006010432,1000,'[{1,285},{2,143},{4,143}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104050108,0,0,1040501,1006020432,1000,'[{1,143},{2,285},{4,143}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104050109,0,0,1040501,1006040432,1000,'[{1,143},{2,143},{4,285}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104050110,0,0,1040501,1008010432,1000,'[{1,285},{2,143},{4,143}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104050111,0,0,1040501,1008020432,1000,'[{1,143},{2,285},{4,143}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104050112,0,0,1040501,1008040432,1000,'[{1,143},{2,143},{4,285}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104050113,0,0,1040501,1010010432,1000,'[{1,285},{2,143},{4,143}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104050114,0,0,1040501,1010020432,1000,'[{1,143},{2,285},{4,143}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104050115,0,0,1040501,1010040432,1000,'[{1,143},{2,143},{4,285}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104050116,0,0,1040501,1002010442,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104050117,0,0,1040501,1002020442,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104050118,0,0,1040501,1002040442,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104050119,0,0,1040501,1004010442,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104050120,0,0,1040501,1004020442,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104050121,0,0,1040501,1004040442,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104050122,0,0,1040501,1006010442,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104050123,0,0,1040501,1006020442,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104050124,0,0,1040501,1006040442,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104050125,0,0,1040501,1008010442,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104050126,0,0,1040501,1008020442,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104050127,0,0,1040501,1008040442,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104050128,0,0,1040501,1010010442,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104050129,0,0,1040501,1010020442,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104050130,0,0,1040501,1010040442,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104050201,0,0,1040502,1001010432,1000,'[{1,143},{2,71},{4,71}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104050202,0,0,1040502,1001020432,1000,'[{1,71},{2,143},{4,71}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104050203,0,0,1040502,1001040432,1000,'[{1,71},{2,71},{4,143}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104050204,0,0,1040502,1007010432,1000,'[{1,143},{2,71},{4,71}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104050205,0,0,1040502,1007020432,1000,'[{1,71},{2,143},{4,71}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104050206,0,0,1040502,1007040432,1000,'[{1,71},{2,71},{4,143}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104050207,0,0,1040502,1003000432,1000,'[{1,71},{2,71},{4,71}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104050208,0,0,1040502,1001010442,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104050209,0,0,1040502,1001020442,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104050210,0,0,1040502,1001040442,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104050211,0,0,1040502,1007010442,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104050212,0,0,1040502,1007020442,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104050213,0,0,1040502,1007040442,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104050214,0,0,1040502,1003000442,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104060101,0,0,1040601,1002010432,1000,'[{1,75},{2,38},{4,38}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104060102,0,0,1040601,1002020432,1000,'[{1,38},{2,75},{4,38}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104060103,0,0,1040601,1002040432,1000,'[{1,38},{2,38},{4,75}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104060104,0,0,1040601,1004010432,1000,'[{1,75},{2,38},{4,38}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104060105,0,0,1040601,1004020432,1000,'[{1,38},{2,75},{4,38}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104060106,0,0,1040601,1004040432,1000,'[{1,38},{2,38},{4,75}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104060107,0,0,1040601,1006010432,1000,'[{1,75},{2,38},{4,38}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104060108,0,0,1040601,1006020432,1000,'[{1,38},{2,75},{4,38}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104060109,0,0,1040601,1006040432,1000,'[{1,38},{2,38},{4,75}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104060110,0,0,1040601,1008010432,1000,'[{1,75},{2,38},{4,38}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104060111,0,0,1040601,1008020432,1000,'[{1,38},{2,75},{4,38}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104060112,0,0,1040601,1008040432,1000,'[{1,38},{2,38},{4,75}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104060113,0,0,1040601,1010010432,1000,'[{1,75},{2,38},{4,38}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104060114,0,0,1040601,1010020432,1000,'[{1,38},{2,75},{4,38}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104060115,0,0,1040601,1010040432,1000,'[{1,38},{2,38},{4,75}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104060116,0,0,1040601,1002010442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104060117,0,0,1040601,1002020442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104060118,0,0,1040601,1002040442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104060119,0,0,1040601,1004010442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104060120,0,0,1040601,1004020442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104060121,0,0,1040601,1004040442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104060122,0,0,1040601,1006010442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104060123,0,0,1040601,1006020442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104060124,0,0,1040601,1006040442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104060125,0,0,1040601,1008010442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104060126,0,0,1040601,1008020442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104060127,0,0,1040601,1008040442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104060128,0,0,1040601,1010010442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104060129,0,0,1040601,1010020442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104060130,0,0,1040601,1010040442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104060201,0,0,1040602,1001010432,1000,'[{1,38},{2,19},{4,19}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104060202,0,0,1040602,1001020432,1000,'[{1,19},{2,38},{4,19}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104060203,0,0,1040602,1001040432,1000,'[{1,19},{2,19},{4,38}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104060204,0,0,1040602,1007010432,1000,'[{1,38},{2,19},{4,19}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104060205,0,0,1040602,1007020432,1000,'[{1,19},{2,38},{4,19}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104060206,0,0,1040602,1007040432,1000,'[{1,19},{2,19},{4,38}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104060207,0,0,1040602,1003000432,1000,'[{1,19},{2,19},{4,19}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104060208,0,0,1040602,1001010442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104060209,0,0,1040602,1001020442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104060210,0,0,1040602,1001040442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104060211,0,0,1040602,1007010442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104060212,0,0,1040602,1007020442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104060213,0,0,1040602,1007040442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104060214,0,0,1040602,1003000442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104070101,0,0,1040701,1002010432,1000,'[{1,85},{2,43},{4,43}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104070102,0,0,1040701,1002020432,1000,'[{1,43},{2,85},{4,43}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104070103,0,0,1040701,1002040432,1000,'[{1,43},{2,43},{4,85}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104070104,0,0,1040701,1004010432,1000,'[{1,85},{2,43},{4,43}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104070105,0,0,1040701,1004020432,1000,'[{1,43},{2,85},{4,43}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104070106,0,0,1040701,1004040432,1000,'[{1,43},{2,43},{4,85}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104070107,0,0,1040701,1006010432,1000,'[{1,85},{2,43},{4,43}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104070108,0,0,1040701,1006020432,1000,'[{1,43},{2,85},{4,43}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104070109,0,0,1040701,1006040432,1000,'[{1,43},{2,43},{4,85}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104070110,0,0,1040701,1008010432,1000,'[{1,85},{2,43},{4,43}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104070111,0,0,1040701,1008020432,1000,'[{1,43},{2,85},{4,43}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104070112,0,0,1040701,1008040432,1000,'[{1,43},{2,43},{4,85}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104070113,0,0,1040701,1010010432,1000,'[{1,85},{2,43},{4,43}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104070114,0,0,1040701,1010020432,1000,'[{1,43},{2,85},{4,43}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104070115,0,0,1040701,1010040432,1000,'[{1,43},{2,43},{4,85}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104070116,0,0,1040701,1002010442,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104070117,0,0,1040701,1002020442,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104070118,0,0,1040701,1002040442,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104070119,0,0,1040701,1004010442,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104070120,0,0,1040701,1004020442,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104070121,0,0,1040701,1004040442,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104070122,0,0,1040701,1006010442,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104070123,0,0,1040701,1006020442,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104070124,0,0,1040701,1006040442,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104070125,0,0,1040701,1008010442,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104070126,0,0,1040701,1008020442,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104070127,0,0,1040701,1008040442,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104070128,0,0,1040701,1010010442,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104070129,0,0,1040701,1010020442,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104070130,0,0,1040701,1010040442,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104070201,0,0,1040702,1001010432,1000,'[{1,68},{2,34},{4,34}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104070202,0,0,1040702,1001020432,1000,'[{1,34},{2,68},{4,34}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104070203,0,0,1040702,1001040432,1000,'[{1,34},{2,34},{4,68}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104070204,0,0,1040702,1007010432,1000,'[{1,68},{2,34},{4,34}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104070205,0,0,1040702,1007020432,1000,'[{1,34},{2,68},{4,34}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104070206,0,0,1040702,1007040432,1000,'[{1,34},{2,34},{4,68}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104070207,0,0,1040702,1003000432,1000,'[{1,34},{2,34},{4,34}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104070208,0,0,1040702,1001010442,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104070209,0,0,1040702,1001020442,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104070210,0,0,1040702,1001040442,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104070211,0,0,1040702,1007010442,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104070212,0,0,1040702,1007020442,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104070213,0,0,1040702,1007040442,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104070214,0,0,1040702,1003000442,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104080101,0,0,1040801,1002010432,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104080102,0,0,1040801,1002020432,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104080103,0,0,1040801,1002040432,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104080104,0,0,1040801,1004010432,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104080105,0,0,1040801,1004020432,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104080106,0,0,1040801,1004040432,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104080107,0,0,1040801,1006010432,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104080108,0,0,1040801,1006020432,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104080109,0,0,1040801,1006040432,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104080110,0,0,1040801,1008010432,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104080111,0,0,1040801,1008020432,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104080112,0,0,1040801,1008040432,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104080113,0,0,1040801,1010010432,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104080114,0,0,1040801,1010020432,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104080115,0,0,1040801,1010040432,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104080116,0,0,1040801,1002010442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104080117,0,0,1040801,1002020442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104080118,0,0,1040801,1002040442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104080119,0,0,1040801,1004010442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104080120,0,0,1040801,1004020442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104080121,0,0,1040801,1004040442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104080122,0,0,1040801,1006010442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104080123,0,0,1040801,1006020442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104080124,0,0,1040801,1006040442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104080125,0,0,1040801,1008010442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104080126,0,0,1040801,1008020442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104080127,0,0,1040801,1008040442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104080128,0,0,1040801,1010010442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104080129,0,0,1040801,1010020442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104080130,0,0,1040801,1010040442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104080201,0,0,1040802,1001010432,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104080202,0,0,1040802,1001020432,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104080203,0,0,1040802,1001040432,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104080204,0,0,1040802,1007010432,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104080205,0,0,1040802,1007020432,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104080206,0,0,1040802,1007040432,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104080207,0,0,1040802,1003000432,1000,'[{1,163},{2,163},{4,163}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(104080208,0,0,1040802,1001010442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104080209,0,0,1040802,1001020442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104080210,0,0,1040802,1001040442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104080211,0,0,1040802,1007010442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104080212,0,0,1040802,1007020442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104080213,0,0,1040802,1007040442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(104080214,0,0,1040802,1003000442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105010001,0,0,1050100,1002010510,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(105010002,0,0,1050100,1002020510,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(105010003,0,0,1050100,1002040510,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(105010004,0,0,1050100,1004010510,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(105010005,0,0,1050100,1004020510,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(105010006,0,0,1050100,1004040510,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(105010007,0,0,1050100,1006010510,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(105010008,0,0,1050100,1006020510,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(105010009,0,0,1050100,1006040510,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(105010010,0,0,1050100,1008010510,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(105010011,0,0,1050100,1008020510,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(105010012,0,0,1050100,1008040510,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(105010013,0,0,1050100,1010010510,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(105010014,0,0,1050100,1010020510,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(105010015,0,0,1050100,1010040510,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(105010016,0,0,1050100,1001010510,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(105010017,0,0,1050100,1001020510,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000201','0',0,'[]',0,0,0,0,'[]'),(105010018,0,0,1050100,1001040510,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000401','0',0,'[]',0,0,0,0,'[]'),(105010019,0,0,1050100,1007010510,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(105010020,0,0,1050100,1007020510,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000207','0',0,'[]',0,0,0,0,'[]'),(105010021,0,0,1050100,1007040510,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000407','0',0,'[]',0,0,0,0,'[]'),(105010022,0,0,1050100,1003000510,300,'[{1,75},{2,75},{4,75}]',1,1,'[]',0,'1000003','0',0,'[]',0,0,0,0,'[]'),(105010023,0,0,1050100,1002010520,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(105010024,0,0,1050100,1002020520,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(105010025,0,0,1050100,1002040520,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(105010026,0,0,1050100,1004010520,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(105010027,0,0,1050100,1004020520,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(105010028,0,0,1050100,1004040520,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(105010029,0,0,1050100,1006010520,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(105010030,0,0,1050100,1006020520,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(105010031,0,0,1050100,1006040520,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(105010032,0,0,1050100,1008010520,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(105010033,0,0,1050100,1008020520,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(105010034,0,0,1050100,1008040520,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(105010035,0,0,1050100,1010010520,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(105010036,0,0,1050100,1010020520,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(105010037,0,0,1050100,1010040520,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(105010038,0,0,1050100,1001010520,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(105010039,0,0,1050100,1001020520,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000201','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(105010040,0,0,1050100,1001040520,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000401','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(105010041,0,0,1050100,1007010520,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(105010042,0,0,1050100,1007020520,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000207','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(105010043,0,0,1050100,1007040520,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000407','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(105010044,0,0,1050100,1003000520,300,'[{1,75},{2,75},{4,75}]',1,1,'[]',0,'1000003','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(105020001,0,0,1050200,1002010531,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(105020002,0,0,1050200,1002020531,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(105020003,0,0,1050200,1002040531,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(105020004,0,0,1050200,1004010531,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(105020005,0,0,1050200,1004020531,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(105020006,0,0,1050200,1004040531,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(105020007,0,0,1050200,1006010531,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(105020008,0,0,1050200,1006020531,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(105020009,0,0,1050200,1006040531,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(105020010,0,0,1050200,1008010531,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(105020011,0,0,1050200,1008020531,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(105020012,0,0,1050200,1008040531,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(105020013,0,0,1050200,1010010531,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(105020014,0,0,1050200,1010020531,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(105020015,0,0,1050200,1010040531,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(105020016,0,0,1050200,1001010531,1000,'[{1,50},{2,25},{4,25}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(105020017,0,0,1050200,1001020531,1000,'[{1,25},{2,50},{4,25}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(105020018,0,0,1050200,1001040531,1000,'[{1,25},{2,25},{4,50}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(105020019,0,0,1050200,1007010531,1000,'[{1,50},{2,25},{4,25}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(105020020,0,0,1050200,1007020531,1000,'[{1,25},{2,50},{4,25}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(105020021,0,0,1050200,1007040531,1000,'[{1,25},{2,25},{4,50}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(105020022,0,0,1050200,1003000531,1000,'[{1,25},{2,25},{4,25}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(105020023,0,0,1050200,1002010541,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(105020024,0,0,1050200,1002020541,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(105020025,0,0,1050200,1002040541,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(105020026,0,0,1050200,1004010541,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(105020027,0,0,1050200,1004020541,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(105020028,0,0,1050200,1004040541,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(105020029,0,0,1050200,1006010541,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(105020030,0,0,1050200,1006020541,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(105020031,0,0,1050200,1006040541,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(105020032,0,0,1050200,1008010541,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(105020033,0,0,1050200,1008020541,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(105020034,0,0,1050200,1008040541,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(105020035,0,0,1050200,1010010541,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(105020036,0,0,1050200,1010020541,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(105020037,0,0,1050200,1010040541,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(105020038,0,0,1050200,1001010541,1000,'[{1,20},{2,10},{4,10}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(105020039,0,0,1050200,1001020541,1000,'[{1,10},{2,20},{4,10}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[]',0,0,0,0,'[]'),(105020040,0,0,1050200,1001040541,1000,'[{1,10},{2,10},{4,20}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[]',0,0,0,0,'[]'),(105020041,0,0,1050200,1007010541,1000,'[{1,20},{2,10},{4,10}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(105020042,0,0,1050200,1007020541,1000,'[{1,10},{2,20},{4,10}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[]',0,0,0,0,'[]'),(105020043,0,0,1050200,1007040541,1000,'[{1,10},{2,10},{4,20}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[]',0,0,0,0,'[]'),(105020044,0,0,1050200,1003000541,1000,'[{1,10},{2,10},{4,10}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[]',0,0,0,0,'[]'),(105030101,0,0,1050301,1002010532,1000,'[{1,112},{2,56},{4,56}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105030102,0,0,1050301,1002020532,1000,'[{1,56},{2,112},{4,56}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105030103,0,0,1050301,1002040532,1000,'[{1,56},{2,56},{4,112}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105030104,0,0,1050301,1004010532,1000,'[{1,112},{2,56},{4,56}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105030105,0,0,1050301,1004020532,1000,'[{1,56},{2,112},{4,56}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105030106,0,0,1050301,1004040532,1000,'[{1,56},{2,56},{4,112}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105030107,0,0,1050301,1006010532,1000,'[{1,112},{2,56},{4,56}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105030108,0,0,1050301,1006020532,1000,'[{1,56},{2,112},{4,56}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105030109,0,0,1050301,1006040532,1000,'[{1,56},{2,56},{4,112}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105030110,0,0,1050301,1008010532,1000,'[{1,112},{2,56},{4,56}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105030111,0,0,1050301,1008020532,1000,'[{1,56},{2,112},{4,56}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105030112,0,0,1050301,1008040532,1000,'[{1,56},{2,56},{4,112}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105030113,0,0,1050301,1010010532,1000,'[{1,112},{2,56},{4,56}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105030114,0,0,1050301,1010020532,1000,'[{1,56},{2,112},{4,56}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105030115,0,0,1050301,1010040532,1000,'[{1,56},{2,56},{4,112}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105030116,0,0,1050301,1002010542,1000,'[{1,5},{2,2},{4,2}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105030117,0,0,1050301,1002020542,1000,'[{1,2},{2,5},{4,2}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105030118,0,0,1050301,1002040542,1000,'[{1,2},{2,2},{4,5}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105030119,0,0,1050301,1004010542,1000,'[{1,5},{2,2},{4,2}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105030120,0,0,1050301,1004020542,1000,'[{1,2},{2,5},{4,2}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105030121,0,0,1050301,1004040542,1000,'[{1,2},{2,2},{4,5}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105030122,0,0,1050301,1006010542,1000,'[{1,5},{2,2},{4,2}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105030123,0,0,1050301,1006020542,1000,'[{1,2},{2,5},{4,2}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105030124,0,0,1050301,1006040542,1000,'[{1,2},{2,2},{4,5}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105030125,0,0,1050301,1008010542,1000,'[{1,5},{2,2},{4,2}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105030126,0,0,1050301,1008020542,1000,'[{1,2},{2,5},{4,2}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105030127,0,0,1050301,1008040542,1000,'[{1,2},{2,2},{4,5}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105030128,0,0,1050301,1010010542,1000,'[{1,5},{2,2},{4,2}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105030129,0,0,1050301,1010020542,1000,'[{1,2},{2,5},{4,2}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105030130,0,0,1050301,1010040542,1000,'[{1,2},{2,2},{4,5}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105030201,0,0,1050302,1001010532,1000,'[{1,56},{2,28},{4,28}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105030202,0,0,1050302,1001020532,1000,'[{1,28},{2,56},{4,28}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105030203,0,0,1050302,1001040532,1000,'[{1,28},{2,28},{4,56}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105030204,0,0,1050302,1007010532,1000,'[{1,56},{2,28},{4,28}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105030205,0,0,1050302,1007020532,1000,'[{1,28},{2,56},{4,28}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105030206,0,0,1050302,1007040532,1000,'[{1,28},{2,28},{4,56}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105030207,0,0,1050302,1003000532,1000,'[{1,28},{2,28},{4,28}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105030208,0,0,1050302,1001010542,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105030209,0,0,1050302,1001020542,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105030210,0,0,1050302,1001040542,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105030211,0,0,1050302,1007010542,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105030212,0,0,1050302,1007020542,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105030213,0,0,1050302,1007040542,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105030214,0,0,1050302,1003000542,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105040101,0,0,1050401,1002010532,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105040102,0,0,1050401,1002020532,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105040103,0,0,1050401,1002040532,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105040104,0,0,1050401,1004010532,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105040105,0,0,1050401,1004020532,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105040106,0,0,1050401,1004040532,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105040107,0,0,1050401,1006010532,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105040108,0,0,1050401,1006020532,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105040109,0,0,1050401,1006040532,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105040110,0,0,1050401,1008010532,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105040111,0,0,1050401,1008020532,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105040112,0,0,1050401,1008040532,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105040113,0,0,1050401,1010010532,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105040114,0,0,1050401,1010020532,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105040115,0,0,1050401,1010040532,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105040116,0,0,1050401,1002010542,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105040117,0,0,1050401,1002020542,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105040118,0,0,1050401,1002040542,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105040119,0,0,1050401,1004010542,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105040120,0,0,1050401,1004020542,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105040121,0,0,1050401,1004040542,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105040122,0,0,1050401,1006010542,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105040123,0,0,1050401,1006020542,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105040124,0,0,1050401,1006040542,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105040125,0,0,1050401,1008010542,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105040126,0,0,1050401,1008020542,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105040127,0,0,1050401,1008040542,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105040128,0,0,1050401,1010010542,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105040129,0,0,1050401,1010020542,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105040130,0,0,1050401,1010040542,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105040201,0,0,1050402,1001010532,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105040202,0,0,1050402,1001020532,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105040203,0,0,1050402,1001040532,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105040204,0,0,1050402,1007010532,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105040205,0,0,1050402,1007020532,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105040206,0,0,1050402,1007040532,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105040207,0,0,1050402,1003000532,1000,'[{1,60},{2,60},{4,60}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105040208,0,0,1050402,1001010542,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105040209,0,0,1050402,1001020542,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105040210,0,0,1050402,1001040542,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105040211,0,0,1050402,1007010542,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105040212,0,0,1050402,1007020542,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105040213,0,0,1050402,1007040542,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105040214,0,0,1050402,1003000542,1000,'[{1,60},{2,60},{4,60}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105050101,0,0,1050501,1002010532,1000,'[{1,212},{2,106},{4,106}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105050102,0,0,1050501,1002020532,1000,'[{1,106},{2,212},{4,106}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105050103,0,0,1050501,1002040532,1000,'[{1,106},{2,106},{4,212}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105050104,0,0,1050501,1004010532,1000,'[{1,212},{2,106},{4,106}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105050105,0,0,1050501,1004020532,1000,'[{1,106},{2,212},{4,106}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105050106,0,0,1050501,1004040532,1000,'[{1,106},{2,106},{4,212}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105050107,0,0,1050501,1006010532,1000,'[{1,212},{2,106},{4,106}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105050108,0,0,1050501,1006020532,1000,'[{1,106},{2,212},{4,106}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105050109,0,0,1050501,1006040532,1000,'[{1,106},{2,106},{4,212}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105050110,0,0,1050501,1008010532,1000,'[{1,212},{2,106},{4,106}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105050111,0,0,1050501,1008020532,1000,'[{1,106},{2,212},{4,106}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105050112,0,0,1050501,1008040532,1000,'[{1,106},{2,106},{4,212}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105050113,0,0,1050501,1010010532,1000,'[{1,212},{2,106},{4,106}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105050114,0,0,1050501,1010020532,1000,'[{1,106},{2,212},{4,106}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105050115,0,0,1050501,1010040532,1000,'[{1,106},{2,106},{4,212}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105050116,0,0,1050501,1002010542,1000,'[{1,5},{2,2},{4,2}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105050117,0,0,1050501,1002020542,1000,'[{1,2},{2,5},{4,2}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105050118,0,0,1050501,1002040542,1000,'[{1,2},{2,2},{4,5}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105050119,0,0,1050501,1004010542,1000,'[{1,5},{2,2},{4,2}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105050120,0,0,1050501,1004020542,1000,'[{1,2},{2,5},{4,2}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105050121,0,0,1050501,1004040542,1000,'[{1,2},{2,2},{4,5}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105050122,0,0,1050501,1006010542,1000,'[{1,5},{2,2},{4,2}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105050123,0,0,1050501,1006020542,1000,'[{1,2},{2,5},{4,2}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105050124,0,0,1050501,1006040542,1000,'[{1,2},{2,2},{4,5}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105050125,0,0,1050501,1008010542,1000,'[{1,5},{2,2},{4,2}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105050126,0,0,1050501,1008020542,1000,'[{1,2},{2,5},{4,2}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105050127,0,0,1050501,1008040542,1000,'[{1,2},{2,2},{4,5}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105050128,0,0,1050501,1010010542,1000,'[{1,5},{2,2},{4,2}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105050129,0,0,1050501,1010020542,1000,'[{1,2},{2,5},{4,2}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105050130,0,0,1050501,1010040542,1000,'[{1,2},{2,2},{4,5}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105050201,0,0,1050502,1001010532,1000,'[{1,106},{2,53},{4,53}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105050202,0,0,1050502,1001020532,1000,'[{1,53},{2,106},{4,53}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105050203,0,0,1050502,1001040532,1000,'[{1,53},{2,53},{4,106}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105050204,0,0,1050502,1007010532,1000,'[{1,106},{2,53},{4,53}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105050205,0,0,1050502,1007020532,1000,'[{1,53},{2,106},{4,53}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105050206,0,0,1050502,1007040532,1000,'[{1,53},{2,53},{4,106}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105050207,0,0,1050502,1003000532,1000,'[{1,53},{2,53},{4,53}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105050208,0,0,1050502,1001010542,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105050209,0,0,1050502,1001020542,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105050210,0,0,1050502,1001040542,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105050211,0,0,1050502,1007010542,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105050212,0,0,1050502,1007020542,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105050213,0,0,1050502,1007040542,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105050214,0,0,1050502,1003000542,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105060101,0,0,1050601,1002010532,1000,'[{1,57},{2,28},{4,28}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105060102,0,0,1050601,1002020532,1000,'[{1,28},{2,57},{4,28}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105060103,0,0,1050601,1002040532,1000,'[{1,28},{2,28},{4,57}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105060104,0,0,1050601,1004010532,1000,'[{1,57},{2,28},{4,28}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105060105,0,0,1050601,1004020532,1000,'[{1,28},{2,57},{4,28}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105060106,0,0,1050601,1004040532,1000,'[{1,28},{2,28},{4,57}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105060107,0,0,1050601,1006010532,1000,'[{1,57},{2,28},{4,28}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105060108,0,0,1050601,1006020532,1000,'[{1,28},{2,57},{4,28}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105060109,0,0,1050601,1006040532,1000,'[{1,28},{2,28},{4,57}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105060110,0,0,1050601,1008010532,1000,'[{1,57},{2,28},{4,28}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105060111,0,0,1050601,1008020532,1000,'[{1,28},{2,57},{4,28}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105060112,0,0,1050601,1008040532,1000,'[{1,28},{2,28},{4,57}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105060113,0,0,1050601,1010010532,1000,'[{1,57},{2,28},{4,28}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105060114,0,0,1050601,1010020532,1000,'[{1,28},{2,57},{4,28}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105060115,0,0,1050601,1010040532,1000,'[{1,28},{2,28},{4,57}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105060116,0,0,1050601,1002010542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105060117,0,0,1050601,1002020542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105060118,0,0,1050601,1002040542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105060119,0,0,1050601,1004010542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105060120,0,0,1050601,1004020542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105060121,0,0,1050601,1004040542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105060122,0,0,1050601,1006010542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105060123,0,0,1050601,1006020542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105060124,0,0,1050601,1006040542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105060125,0,0,1050601,1008010542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105060126,0,0,1050601,1008020542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105060127,0,0,1050601,1008040542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105060128,0,0,1050601,1010010542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105060129,0,0,1050601,1010020542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105060130,0,0,1050601,1010040542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105060201,0,0,1050602,1001010532,1000,'[{1,28},{2,14},{4,14}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105060202,0,0,1050602,1001020532,1000,'[{1,14},{2,28},{4,14}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105060203,0,0,1050602,1001040532,1000,'[{1,14},{2,14},{4,28}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105060204,0,0,1050602,1007010532,1000,'[{1,28},{2,14},{4,14}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105060205,0,0,1050602,1007020532,1000,'[{1,14},{2,28},{4,14}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105060206,0,0,1050602,1007040532,1000,'[{1,14},{2,14},{4,28}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105060207,0,0,1050602,1003000532,1000,'[{1,14},{2,14},{4,14}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105060208,0,0,1050602,1001010542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105060209,0,0,1050602,1001020542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105060210,0,0,1050602,1001040542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105060211,0,0,1050602,1007010542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105060212,0,0,1050602,1007020542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105060213,0,0,1050602,1007040542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105060214,0,0,1050602,1003000542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105070101,0,0,1050701,1002010532,1000,'[{1,62},{2,31},{4,31}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105070102,0,0,1050701,1002020532,1000,'[{1,31},{2,62},{4,31}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105070103,0,0,1050701,1002040532,1000,'[{1,31},{2,31},{4,62}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105070104,0,0,1050701,1004010532,1000,'[{1,62},{2,31},{4,31}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105070105,0,0,1050701,1004020532,1000,'[{1,31},{2,62},{4,31}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105070106,0,0,1050701,1004040532,1000,'[{1,31},{2,31},{4,62}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105070107,0,0,1050701,1006010532,1000,'[{1,62},{2,31},{4,31}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105070108,0,0,1050701,1006020532,1000,'[{1,31},{2,62},{4,31}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105070109,0,0,1050701,1006040532,1000,'[{1,31},{2,31},{4,62}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105070110,0,0,1050701,1008010532,1000,'[{1,62},{2,31},{4,31}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105070111,0,0,1050701,1008020532,1000,'[{1,31},{2,62},{4,31}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105070112,0,0,1050701,1008040532,1000,'[{1,31},{2,31},{4,62}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105070113,0,0,1050701,1010010532,1000,'[{1,62},{2,31},{4,31}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105070114,0,0,1050701,1010020532,1000,'[{1,31},{2,62},{4,31}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105070115,0,0,1050701,1010040532,1000,'[{1,31},{2,31},{4,62}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105070116,0,0,1050701,1002010542,1000,'[{1,5},{2,2},{4,2}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105070117,0,0,1050701,1002020542,1000,'[{1,2},{2,5},{4,2}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105070118,0,0,1050701,1002040542,1000,'[{1,2},{2,2},{4,5}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105070119,0,0,1050701,1004010542,1000,'[{1,5},{2,2},{4,2}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105070120,0,0,1050701,1004020542,1000,'[{1,2},{2,5},{4,2}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105070121,0,0,1050701,1004040542,1000,'[{1,2},{2,2},{4,5}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105070122,0,0,1050701,1006010542,1000,'[{1,5},{2,2},{4,2}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105070123,0,0,1050701,1006020542,1000,'[{1,2},{2,5},{4,2}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105070124,0,0,1050701,1006040542,1000,'[{1,2},{2,2},{4,5}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105070125,0,0,1050701,1008010542,1000,'[{1,5},{2,2},{4,2}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105070126,0,0,1050701,1008020542,1000,'[{1,2},{2,5},{4,2}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105070127,0,0,1050701,1008040542,1000,'[{1,2},{2,2},{4,5}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105070128,0,0,1050701,1010010542,1000,'[{1,5},{2,2},{4,2}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105070129,0,0,1050701,1010020542,1000,'[{1,2},{2,5},{4,2}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105070130,0,0,1050701,1010040542,1000,'[{1,2},{2,2},{4,5}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105070201,0,0,1050702,1001010532,1000,'[{1,50},{2,25},{4,25}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105070202,0,0,1050702,1001020532,1000,'[{1,25},{2,50},{4,25}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105070203,0,0,1050702,1001040532,1000,'[{1,25},{2,25},{4,50}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105070204,0,0,1050702,1007010532,1000,'[{1,50},{2,25},{4,25}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105070205,0,0,1050702,1007020532,1000,'[{1,25},{2,50},{4,25}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105070206,0,0,1050702,1007040532,1000,'[{1,25},{2,25},{4,50}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105070207,0,0,1050702,1003000532,1000,'[{1,25},{2,25},{4,25}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105070208,0,0,1050702,1001010542,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105070209,0,0,1050702,1001020542,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105070210,0,0,1050702,1001040542,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105070211,0,0,1050702,1007010542,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105070212,0,0,1050702,1007020542,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105070213,0,0,1050702,1007040542,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105070214,0,0,1050702,1003000542,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105080101,0,0,1050801,1002010532,1000,'[{1,275},{2,138},{4,138}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105080102,0,0,1050801,1002020532,1000,'[{1,138},{2,275},{4,138}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105080103,0,0,1050801,1002040532,1000,'[{1,138},{2,138},{4,275}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105080104,0,0,1050801,1004010532,1000,'[{1,275},{2,138},{4,138}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105080105,0,0,1050801,1004020532,1000,'[{1,138},{2,275},{4,138}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105080106,0,0,1050801,1004040532,1000,'[{1,138},{2,138},{4,275}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105080107,0,0,1050801,1006010532,1000,'[{1,275},{2,138},{4,138}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105080108,0,0,1050801,1006020532,1000,'[{1,138},{2,275},{4,138}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105080109,0,0,1050801,1006040532,1000,'[{1,138},{2,138},{4,275}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105080110,0,0,1050801,1008010532,1000,'[{1,275},{2,138},{4,138}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105080111,0,0,1050801,1008020532,1000,'[{1,138},{2,275},{4,138}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105080112,0,0,1050801,1008040532,1000,'[{1,138},{2,138},{4,275}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105080113,0,0,1050801,1010010532,1000,'[{1,275},{2,138},{4,138}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105080114,0,0,1050801,1010020532,1000,'[{1,138},{2,275},{4,138}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105080115,0,0,1050801,1010040532,1000,'[{1,138},{2,138},{4,275}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105080116,0,0,1050801,1002010542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105080117,0,0,1050801,1002020542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105080118,0,0,1050801,1002040542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105080119,0,0,1050801,1004010542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105080120,0,0,1050801,1004020542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105080121,0,0,1050801,1004040542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105080122,0,0,1050801,1006010542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105080123,0,0,1050801,1006020542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105080124,0,0,1050801,1006040542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105080125,0,0,1050801,1008010542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105080126,0,0,1050801,1008020542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105080127,0,0,1050801,1008040542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105080128,0,0,1050801,1010010542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105080129,0,0,1050801,1010020542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105080130,0,0,1050801,1010040542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105080201,0,0,1050802,1001010532,1000,'[{1,275},{2,138},{4,138}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105080202,0,0,1050802,1001020532,1000,'[{1,138},{2,275},{4,138}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105080203,0,0,1050802,1001040532,1000,'[{1,138},{2,138},{4,275}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105080204,0,0,1050802,1007010532,1000,'[{1,275},{2,138},{4,138}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105080205,0,0,1050802,1007020532,1000,'[{1,138},{2,275},{4,138}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105080206,0,0,1050802,1007040532,1000,'[{1,138},{2,138},{4,275}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105080207,0,0,1050802,1003000532,1000,'[{1,138},{2,138},{4,138}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(105080208,0,0,1050802,1001010542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105080209,0,0,1050802,1001020542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105080210,0,0,1050802,1001040542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105080211,0,0,1050802,1007010542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105080212,0,0,1050802,1007020542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105080213,0,0,1050802,1007040542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(105080214,0,0,1050802,1003000542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106010001,0,0,1060100,1002010610,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(106010002,0,0,1060100,1002020610,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(106010003,0,0,1060100,1002040610,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(106010004,0,0,1060100,1004010610,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(106010005,0,0,1060100,1004020610,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(106010006,0,0,1060100,1004040610,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(106010007,0,0,1060100,1006010610,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(106010008,0,0,1060100,1006020610,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(106010009,0,0,1060100,1006040610,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(106010010,0,0,1060100,1008010610,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(106010011,0,0,1060100,1008020610,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(106010012,0,0,1060100,1008040610,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(106010013,0,0,1060100,1010010610,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(106010014,0,0,1060100,1010020610,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(106010015,0,0,1060100,1010040610,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(106010016,0,0,1060100,1001010610,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(106010017,0,0,1060100,1001020610,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000201','0',0,'[]',0,0,0,0,'[]'),(106010018,0,0,1060100,1001040610,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000401','0',0,'[]',0,0,0,0,'[]'),(106010019,0,0,1060100,1007010610,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(106010020,0,0,1060100,1007020610,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000207','0',0,'[]',0,0,0,0,'[]'),(106010021,0,0,1060100,1007040610,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000407','0',0,'[]',0,0,0,0,'[]'),(106010022,0,0,1060100,1003000610,300,'[{1,75},{2,75},{4,75}]',1,1,'[]',0,'1000003','0',0,'[]',0,0,0,0,'[]'),(106010023,0,0,1060100,1002010620,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(106010024,0,0,1060100,1002020620,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(106010025,0,0,1060100,1002040620,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(106010026,0,0,1060100,1004010620,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(106010027,0,0,1060100,1004020620,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(106010028,0,0,1060100,1004040620,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(106010029,0,0,1060100,1006010620,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(106010030,0,0,1060100,1006020620,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(106010031,0,0,1060100,1006040620,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(106010032,0,0,1060100,1008010620,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(106010033,0,0,1060100,1008020620,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(106010034,0,0,1060100,1008040620,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(106010035,0,0,1060100,1010010620,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(106010036,0,0,1060100,1010020620,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(106010037,0,0,1060100,1010040620,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(106010038,0,0,1060100,1001010620,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(106010039,0,0,1060100,1001020620,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000201','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(106010040,0,0,1060100,1001040620,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000401','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(106010041,0,0,1060100,1007010620,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(106010042,0,0,1060100,1007020620,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000207','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(106010043,0,0,1060100,1007040620,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000407','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(106010044,0,0,1060100,1003000620,300,'[{1,75},{2,75},{4,75}]',1,1,'[]',0,'1000003','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(106020001,0,0,1060200,1002010631,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(106020002,0,0,1060200,1002020631,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(106020003,0,0,1060200,1002040631,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(106020004,0,0,1060200,1004010631,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(106020005,0,0,1060200,1004020631,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(106020006,0,0,1060200,1004040631,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(106020007,0,0,1060200,1006010631,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(106020008,0,0,1060200,1006020631,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(106020009,0,0,1060200,1006040631,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(106020010,0,0,1060200,1008010631,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(106020011,0,0,1060200,1008020631,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(106020012,0,0,1060200,1008040631,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(106020013,0,0,1060200,1010010631,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(106020014,0,0,1060200,1010020631,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(106020015,0,0,1060200,1010040631,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(106020016,0,0,1060200,1001010631,1000,'[{1,50},{2,25},{4,25}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(106020017,0,0,1060200,1001020631,1000,'[{1,25},{2,50},{4,25}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(106020018,0,0,1060200,1001040631,1000,'[{1,25},{2,25},{4,50}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(106020019,0,0,1060200,1007010631,1000,'[{1,50},{2,25},{4,25}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(106020020,0,0,1060200,1007020631,1000,'[{1,25},{2,50},{4,25}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(106020021,0,0,1060200,1007040631,1000,'[{1,25},{2,25},{4,50}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(106020022,0,0,1060200,1003000631,1000,'[{1,25},{2,25},{4,25}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(106020023,0,0,1060200,1002010641,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(106020024,0,0,1060200,1002020641,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(106020025,0,0,1060200,1002040641,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(106020026,0,0,1060200,1004010641,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(106020027,0,0,1060200,1004020641,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(106020028,0,0,1060200,1004040641,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(106020029,0,0,1060200,1006010641,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(106020030,0,0,1060200,1006020641,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(106020031,0,0,1060200,1006040641,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(106020032,0,0,1060200,1008010641,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(106020033,0,0,1060200,1008020641,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(106020034,0,0,1060200,1008040641,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(106020035,0,0,1060200,1010010641,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(106020036,0,0,1060200,1010020641,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(106020037,0,0,1060200,1010040641,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(106020038,0,0,1060200,1001010641,1000,'[{1,20},{2,10},{4,10}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(106020039,0,0,1060200,1001020641,1000,'[{1,10},{2,20},{4,10}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[]',0,0,0,0,'[]'),(106020040,0,0,1060200,1001040641,1000,'[{1,10},{2,10},{4,20}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[]',0,0,0,0,'[]'),(106020041,0,0,1060200,1007010641,1000,'[{1,20},{2,10},{4,10}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(106020042,0,0,1060200,1007020641,1000,'[{1,10},{2,20},{4,10}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[]',0,0,0,0,'[]'),(106020043,0,0,1060200,1007040641,1000,'[{1,10},{2,10},{4,20}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[]',0,0,0,0,'[]'),(106020044,0,0,1060200,1003000641,1000,'[{1,10},{2,10},{4,10}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[]',0,0,0,0,'[]'),(106030101,0,0,1060301,1002010632,1000,'[{1,142},{2,71},{4,71}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106030102,0,0,1060301,1002020632,1000,'[{1,71},{2,142},{4,71}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106030103,0,0,1060301,1002040632,1000,'[{1,71},{2,71},{4,142}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106030104,0,0,1060301,1004010632,1000,'[{1,142},{2,71},{4,71}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106030105,0,0,1060301,1004020632,1000,'[{1,71},{2,142},{4,71}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106030106,0,0,1060301,1004040632,1000,'[{1,71},{2,71},{4,142}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106030107,0,0,1060301,1006010632,1000,'[{1,142},{2,71},{4,71}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106030108,0,0,1060301,1006020632,1000,'[{1,71},{2,142},{4,71}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106030109,0,0,1060301,1006040632,1000,'[{1,71},{2,71},{4,142}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106030110,0,0,1060301,1008010632,1000,'[{1,142},{2,71},{4,71}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106030111,0,0,1060301,1008020632,1000,'[{1,71},{2,142},{4,71}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106030112,0,0,1060301,1008040632,1000,'[{1,71},{2,71},{4,142}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106030113,0,0,1060301,1010010632,1000,'[{1,142},{2,71},{4,71}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106030114,0,0,1060301,1010020632,1000,'[{1,71},{2,142},{4,71}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106030115,0,0,1060301,1010040632,1000,'[{1,71},{2,71},{4,142}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106030116,0,0,1060301,1002010642,1000,'[{1,4},{2,2},{4,2}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106030117,0,0,1060301,1002020642,1000,'[{1,2},{2,4},{4,2}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106030118,0,0,1060301,1002040642,1000,'[{1,2},{2,2},{4,4}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106030119,0,0,1060301,1004010642,1000,'[{1,4},{2,2},{4,2}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106030120,0,0,1060301,1004020642,1000,'[{1,2},{2,4},{4,2}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106030121,0,0,1060301,1004040642,1000,'[{1,2},{2,2},{4,4}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106030122,0,0,1060301,1006010642,1000,'[{1,4},{2,2},{4,2}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106030123,0,0,1060301,1006020642,1000,'[{1,2},{2,4},{4,2}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106030124,0,0,1060301,1006040642,1000,'[{1,2},{2,2},{4,4}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106030125,0,0,1060301,1008010642,1000,'[{1,4},{2,2},{4,2}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106030126,0,0,1060301,1008020642,1000,'[{1,2},{2,4},{4,2}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106030127,0,0,1060301,1008040642,1000,'[{1,2},{2,2},{4,4}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106030128,0,0,1060301,1010010642,1000,'[{1,4},{2,2},{4,2}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106030129,0,0,1060301,1010020642,1000,'[{1,2},{2,4},{4,2}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106030130,0,0,1060301,1010040642,1000,'[{1,2},{2,2},{4,4}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106030201,0,0,1060302,1001010632,1000,'[{1,45},{2,22},{4,22}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106030202,0,0,1060302,1001020632,1000,'[{1,22},{2,45},{4,22}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106030203,0,0,1060302,1001040632,1000,'[{1,22},{2,22},{4,45}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106030204,0,0,1060302,1007010632,1000,'[{1,45},{2,22},{4,22}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106030205,0,0,1060302,1007020632,1000,'[{1,22},{2,45},{4,22}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106030206,0,0,1060302,1007040632,1000,'[{1,22},{2,22},{4,45}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106030207,0,0,1060302,1003000632,1000,'[{1,22},{2,22},{4,22}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106030208,0,0,1060302,1001010642,1000,'[{1,2},{2,1},{4,1}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106030209,0,0,1060302,1001020642,1000,'[{1,1},{2,2},{4,1}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106030210,0,0,1060302,1001040642,1000,'[{1,1},{2,1},{4,2}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106030211,0,0,1060302,1007010642,1000,'[{1,2},{2,1},{4,1}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106030212,0,0,1060302,1007020642,1000,'[{1,1},{2,2},{4,1}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106030213,0,0,1060302,1007040642,1000,'[{1,1},{2,1},{4,2}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106030214,0,0,1060302,1003000642,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106040101,0,0,1060401,1002010632,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106040102,0,0,1060401,1002020632,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106040103,0,0,1060401,1002040632,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106040104,0,0,1060401,1004010632,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106040105,0,0,1060401,1004020632,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106040106,0,0,1060401,1004040632,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106040107,0,0,1060401,1006010632,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106040108,0,0,1060401,1006020632,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106040109,0,0,1060401,1006040632,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106040110,0,0,1060401,1008010632,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106040111,0,0,1060401,1008020632,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106040112,0,0,1060401,1008040632,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106040113,0,0,1060401,1010010632,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106040114,0,0,1060401,1010020632,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106040115,0,0,1060401,1010040632,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106040116,0,0,1060401,1002010642,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106040117,0,0,1060401,1002020642,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106040118,0,0,1060401,1002040642,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106040119,0,0,1060401,1004010642,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106040120,0,0,1060401,1004020642,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106040121,0,0,1060401,1004040642,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106040122,0,0,1060401,1006010642,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106040123,0,0,1060401,1006020642,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106040124,0,0,1060401,1006040642,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106040125,0,0,1060401,1008010642,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106040126,0,0,1060401,1008020642,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106040127,0,0,1060401,1008040642,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106040128,0,0,1060401,1010010642,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106040129,0,0,1060401,1010020642,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106040130,0,0,1060401,1010040642,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106040201,0,0,1060402,1001010632,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106040202,0,0,1060402,1001020632,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106040203,0,0,1060402,1001040632,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106040204,0,0,1060402,1007010632,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106040205,0,0,1060402,1007020632,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106040206,0,0,1060402,1007040632,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106040207,0,0,1060402,1003000632,1000,'[{1,60},{2,60},{4,60}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106040208,0,0,1060402,1001010642,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106040209,0,0,1060402,1001020642,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106040210,0,0,1060402,1001040642,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106040211,0,0,1060402,1007010642,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106040212,0,0,1060402,1007020642,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106040213,0,0,1060402,1007040642,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106040214,0,0,1060402,1003000642,1000,'[{1,60},{2,60},{4,60}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106050101,0,0,1060501,1002010632,1000,'[{1,267},{2,133},{4,133}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106050102,0,0,1060501,1002020632,1000,'[{1,133},{2,267},{4,133}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106050103,0,0,1060501,1002040632,1000,'[{1,133},{2,133},{4,267}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106050104,0,0,1060501,1004010632,1000,'[{1,267},{2,133},{4,133}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106050105,0,0,1060501,1004020632,1000,'[{1,133},{2,267},{4,133}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106050106,0,0,1060501,1004040632,1000,'[{1,133},{2,133},{4,267}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106050107,0,0,1060501,1006010632,1000,'[{1,267},{2,133},{4,133}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106050108,0,0,1060501,1006020632,1000,'[{1,133},{2,267},{4,133}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106050109,0,0,1060501,1006040632,1000,'[{1,133},{2,133},{4,267}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106050110,0,0,1060501,1008010632,1000,'[{1,267},{2,133},{4,133}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106050111,0,0,1060501,1008020632,1000,'[{1,133},{2,267},{4,133}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106050112,0,0,1060501,1008040632,1000,'[{1,133},{2,133},{4,267}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106050113,0,0,1060501,1010010632,1000,'[{1,267},{2,133},{4,133}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106050114,0,0,1060501,1010020632,1000,'[{1,133},{2,267},{4,133}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106050115,0,0,1060501,1010040632,1000,'[{1,133},{2,133},{4,267}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106050116,0,0,1060501,1002010642,1000,'[{1,4},{2,2},{4,2}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106050117,0,0,1060501,1002020642,1000,'[{1,2},{2,4},{4,2}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106050118,0,0,1060501,1002040642,1000,'[{1,2},{2,2},{4,4}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106050119,0,0,1060501,1004010642,1000,'[{1,4},{2,2},{4,2}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106050120,0,0,1060501,1004020642,1000,'[{1,2},{2,4},{4,2}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106050121,0,0,1060501,1004040642,1000,'[{1,2},{2,2},{4,4}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106050122,0,0,1060501,1006010642,1000,'[{1,4},{2,2},{4,2}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106050123,0,0,1060501,1006020642,1000,'[{1,2},{2,4},{4,2}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106050124,0,0,1060501,1006040642,1000,'[{1,2},{2,2},{4,4}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106050125,0,0,1060501,1008010642,1000,'[{1,4},{2,2},{4,2}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106050126,0,0,1060501,1008020642,1000,'[{1,2},{2,4},{4,2}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106050127,0,0,1060501,1008040642,1000,'[{1,2},{2,2},{4,4}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106050128,0,0,1060501,1010010642,1000,'[{1,4},{2,2},{4,2}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106050129,0,0,1060501,1010020642,1000,'[{1,2},{2,4},{4,2}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106050130,0,0,1060501,1010040642,1000,'[{1,2},{2,2},{4,4}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106050201,0,0,1060502,1001010632,1000,'[{1,87},{2,43},{4,43}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106050202,0,0,1060502,1001020632,1000,'[{1,43},{2,87},{4,43}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106050203,0,0,1060502,1001040632,1000,'[{1,43},{2,43},{4,87}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106050204,0,0,1060502,1007010632,1000,'[{1,87},{2,43},{4,43}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106050205,0,0,1060502,1007020632,1000,'[{1,43},{2,87},{4,43}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106050206,0,0,1060502,1007040632,1000,'[{1,43},{2,43},{4,87}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106050207,0,0,1060502,1003000632,1000,'[{1,43},{2,43},{4,43}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106050208,0,0,1060502,1001010642,1000,'[{1,2},{2,1},{4,1}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106050209,0,0,1060502,1001020642,1000,'[{1,1},{2,2},{4,1}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106050210,0,0,1060502,1001040642,1000,'[{1,1},{2,1},{4,2}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106050211,0,0,1060502,1007010642,1000,'[{1,2},{2,1},{4,1}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106050212,0,0,1060502,1007020642,1000,'[{1,1},{2,2},{4,1}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106050213,0,0,1060502,1007040642,1000,'[{1,1},{2,1},{4,2}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106050214,0,0,1060502,1003000642,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106060101,0,0,1060601,1002010632,1000,'[{1,71},{2,35},{4,35}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106060102,0,0,1060601,1002020632,1000,'[{1,35},{2,71},{4,35}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106060103,0,0,1060601,1002040632,1000,'[{1,35},{2,35},{4,71}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106060104,0,0,1060601,1004010632,1000,'[{1,71},{2,35},{4,35}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106060105,0,0,1060601,1004020632,1000,'[{1,35},{2,71},{4,35}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106060106,0,0,1060601,1004040632,1000,'[{1,35},{2,35},{4,71}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106060107,0,0,1060601,1006010632,1000,'[{1,71},{2,35},{4,35}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106060108,0,0,1060601,1006020632,1000,'[{1,35},{2,71},{4,35}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106060109,0,0,1060601,1006040632,1000,'[{1,35},{2,35},{4,71}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106060110,0,0,1060601,1008010632,1000,'[{1,71},{2,35},{4,35}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106060111,0,0,1060601,1008020632,1000,'[{1,35},{2,71},{4,35}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106060112,0,0,1060601,1008040632,1000,'[{1,35},{2,35},{4,71}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106060113,0,0,1060601,1010010632,1000,'[{1,71},{2,35},{4,35}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106060114,0,0,1060601,1010020632,1000,'[{1,35},{2,71},{4,35}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106060115,0,0,1060601,1010040632,1000,'[{1,35},{2,35},{4,71}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106060116,0,0,1060601,1002010642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106060117,0,0,1060601,1002020642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106060118,0,0,1060601,1002040642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106060119,0,0,1060601,1004010642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106060120,0,0,1060601,1004020642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106060121,0,0,1060601,1004040642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106060122,0,0,1060601,1006010642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106060123,0,0,1060601,1006020642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106060124,0,0,1060601,1006040642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106060125,0,0,1060601,1008010642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106060126,0,0,1060601,1008020642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106060127,0,0,1060601,1008040642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106060128,0,0,1060601,1010010642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106060129,0,0,1060601,1010020642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106060130,0,0,1060601,1010040642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106060201,0,0,1060602,1001010632,1000,'[{1,24},{2,12},{4,12}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106060202,0,0,1060602,1001020632,1000,'[{1,12},{2,24},{4,12}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106060203,0,0,1060602,1001040632,1000,'[{1,12},{2,12},{4,24}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106060204,0,0,1060602,1007010632,1000,'[{1,24},{2,12},{4,12}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106060205,0,0,1060602,1007020632,1000,'[{1,12},{2,24},{4,12}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106060206,0,0,1060602,1007040632,1000,'[{1,12},{2,12},{4,24}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106060207,0,0,1060602,1003000632,1000,'[{1,12},{2,12},{4,12}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106060208,0,0,1060602,1001010642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106060209,0,0,1060602,1001020642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106060210,0,0,1060602,1001040642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106060211,0,0,1060602,1007010642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106060212,0,0,1060602,1007020642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106060213,0,0,1060602,1007040642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106060214,0,0,1060602,1003000642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106070101,0,0,1060701,1002010632,1000,'[{1,79},{2,40},{4,40}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106070102,0,0,1060701,1002020632,1000,'[{1,40},{2,79},{4,40}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106070103,0,0,1060701,1002040632,1000,'[{1,40},{2,40},{4,79}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106070104,0,0,1060701,1004010632,1000,'[{1,79},{2,40},{4,40}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106070105,0,0,1060701,1004020632,1000,'[{1,40},{2,79},{4,40}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106070106,0,0,1060701,1004040632,1000,'[{1,40},{2,40},{4,79}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106070107,0,0,1060701,1006010632,1000,'[{1,79},{2,40},{4,40}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106070108,0,0,1060701,1006020632,1000,'[{1,40},{2,79},{4,40}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106070109,0,0,1060701,1006040632,1000,'[{1,40},{2,40},{4,79}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106070110,0,0,1060701,1008010632,1000,'[{1,79},{2,40},{4,40}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106070111,0,0,1060701,1008020632,1000,'[{1,40},{2,79},{4,40}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106070112,0,0,1060701,1008040632,1000,'[{1,40},{2,40},{4,79}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106070113,0,0,1060701,1010010632,1000,'[{1,79},{2,40},{4,40}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106070114,0,0,1060701,1010020632,1000,'[{1,40},{2,79},{4,40}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106070115,0,0,1060701,1010040632,1000,'[{1,40},{2,40},{4,79}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106070116,0,0,1060701,1002010642,1000,'[{1,4},{2,2},{4,2}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106070117,0,0,1060701,1002020642,1000,'[{1,2},{2,4},{4,2}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106070118,0,0,1060701,1002040642,1000,'[{1,2},{2,2},{4,4}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106070119,0,0,1060701,1004010642,1000,'[{1,4},{2,2},{4,2}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106070120,0,0,1060701,1004020642,1000,'[{1,2},{2,4},{4,2}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106070121,0,0,1060701,1004040642,1000,'[{1,2},{2,2},{4,4}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106070122,0,0,1060701,1006010642,1000,'[{1,4},{2,2},{4,2}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106070123,0,0,1060701,1006020642,1000,'[{1,2},{2,4},{4,2}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106070124,0,0,1060701,1006040642,1000,'[{1,2},{2,2},{4,4}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106070125,0,0,1060701,1008010642,1000,'[{1,4},{2,2},{4,2}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106070126,0,0,1060701,1008020642,1000,'[{1,2},{2,4},{4,2}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106070127,0,0,1060701,1008040642,1000,'[{1,2},{2,2},{4,4}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106070128,0,0,1060701,1010010642,1000,'[{1,4},{2,2},{4,2}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106070129,0,0,1060701,1010020642,1000,'[{1,2},{2,4},{4,2}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106070130,0,0,1060701,1010040642,1000,'[{1,2},{2,2},{4,4}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106070201,0,0,1060702,1001010632,1000,'[{1,40},{2,20},{4,20}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106070202,0,0,1060702,1001020632,1000,'[{1,20},{2,40},{4,20}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106070203,0,0,1060702,1001040632,1000,'[{1,20},{2,20},{4,40}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106070204,0,0,1060702,1007010632,1000,'[{1,40},{2,20},{4,20}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106070205,0,0,1060702,1007020632,1000,'[{1,20},{2,40},{4,20}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106070206,0,0,1060702,1007040632,1000,'[{1,20},{2,20},{4,40}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106070207,0,0,1060702,1003000632,1000,'[{1,20},{2,20},{4,20}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106070208,0,0,1060702,1001010642,1000,'[{1,2},{2,1},{4,1}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106070209,0,0,1060702,1001020642,1000,'[{1,1},{2,2},{4,1}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106070210,0,0,1060702,1001040642,1000,'[{1,1},{2,1},{4,2}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106070211,0,0,1060702,1007010642,1000,'[{1,2},{2,1},{4,1}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106070212,0,0,1060702,1007020642,1000,'[{1,1},{2,2},{4,1}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106070213,0,0,1060702,1007040642,1000,'[{1,1},{2,1},{4,2}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106070214,0,0,1060702,1003000642,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106080101,0,0,1060801,1002010632,1000,'[{1,225},{2,113},{4,113}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106080102,0,0,1060801,1002020632,1000,'[{1,113},{2,225},{4,113}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106080103,0,0,1060801,1002040632,1000,'[{1,113},{2,113},{4,225}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106080104,0,0,1060801,1004010632,1000,'[{1,225},{2,113},{4,113}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106080105,0,0,1060801,1004020632,1000,'[{1,113},{2,225},{4,113}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106080106,0,0,1060801,1004040632,1000,'[{1,113},{2,113},{4,225}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106080107,0,0,1060801,1006010632,1000,'[{1,225},{2,113},{4,113}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106080108,0,0,1060801,1006020632,1000,'[{1,113},{2,225},{4,113}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106080109,0,0,1060801,1006040632,1000,'[{1,113},{2,113},{4,225}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106080110,0,0,1060801,1008010632,1000,'[{1,225},{2,113},{4,113}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106080111,0,0,1060801,1008020632,1000,'[{1,113},{2,225},{4,113}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106080112,0,0,1060801,1008040632,1000,'[{1,113},{2,113},{4,225}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106080113,0,0,1060801,1010010632,1000,'[{1,225},{2,113},{4,113}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106080114,0,0,1060801,1010020632,1000,'[{1,113},{2,225},{4,113}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106080115,0,0,1060801,1010040632,1000,'[{1,113},{2,113},{4,225}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106080116,0,0,1060801,1002010642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106080117,0,0,1060801,1002020642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106080118,0,0,1060801,1002040642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106080119,0,0,1060801,1004010642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106080120,0,0,1060801,1004020642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106080121,0,0,1060801,1004040642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106080122,0,0,1060801,1006010642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106080123,0,0,1060801,1006020642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106080124,0,0,1060801,1006040642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106080125,0,0,1060801,1008010642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106080126,0,0,1060801,1008020642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106080127,0,0,1060801,1008040642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106080128,0,0,1060801,1010010642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106080129,0,0,1060801,1010020642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106080130,0,0,1060801,1010040642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106080201,0,0,1060802,1001010632,1000,'[{1,225},{2,113},{4,113}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106080202,0,0,1060802,1001020632,1000,'[{1,113},{2,225},{4,113}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106080203,0,0,1060802,1001040632,1000,'[{1,113},{2,113},{4,225}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106080204,0,0,1060802,1007010632,1000,'[{1,225},{2,113},{4,113}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106080205,0,0,1060802,1007020632,1000,'[{1,113},{2,225},{4,113}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106080206,0,0,1060802,1007040632,1000,'[{1,113},{2,113},{4,225}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106080207,0,0,1060802,1003000632,1000,'[{1,113},{2,113},{4,113}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(106080208,0,0,1060802,1001010642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106080209,0,0,1060802,1001020642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106080210,0,0,1060802,1001040642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106080211,0,0,1060802,1007010642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106080212,0,0,1060802,1007020642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106080213,0,0,1060802,1007040642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(106080214,0,0,1060802,1003000642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107010001,0,0,1070100,1002010710,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(107010002,0,0,1070100,1002020710,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(107010003,0,0,1070100,1002040710,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(107010004,0,0,1070100,1004010710,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(107010005,0,0,1070100,1004020710,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(107010006,0,0,1070100,1004040710,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(107010007,0,0,1070100,1006010710,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(107010008,0,0,1070100,1006020710,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(107010009,0,0,1070100,1006040710,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(107010010,0,0,1070100,1008010710,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(107010011,0,0,1070100,1008020710,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(107010012,0,0,1070100,1008040710,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(107010013,0,0,1070100,1010010710,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(107010014,0,0,1070100,1010020710,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(107010015,0,0,1070100,1010040710,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(107010016,0,0,1070100,1001010710,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(107010017,0,0,1070100,1001020710,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000201','0',0,'[]',0,0,0,0,'[]'),(107010018,0,0,1070100,1001040710,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000401','0',0,'[]',0,0,0,0,'[]'),(107010019,0,0,1070100,1007010710,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(107010020,0,0,1070100,1007020710,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000207','0',0,'[]',0,0,0,0,'[]'),(107010021,0,0,1070100,1007040710,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000407','0',0,'[]',0,0,0,0,'[]'),(107010022,0,0,1070100,1003000710,300,'[{1,75},{2,75},{4,75}]',1,1,'[]',0,'1000003','0',0,'[]',0,0,0,0,'[]'),(107010023,0,0,1070100,1002010720,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(107010024,0,0,1070100,1002020720,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(107010025,0,0,1070100,1002040720,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(107010026,0,0,1070100,1004010720,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(107010027,0,0,1070100,1004020720,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(107010028,0,0,1070100,1004040720,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(107010029,0,0,1070100,1006010720,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(107010030,0,0,1070100,1006020720,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(107010031,0,0,1070100,1006040720,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(107010032,0,0,1070100,1008010720,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(107010033,0,0,1070100,1008020720,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(107010034,0,0,1070100,1008040720,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(107010035,0,0,1070100,1010010720,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(107010036,0,0,1070100,1010020720,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(107010037,0,0,1070100,1010040720,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(107010038,0,0,1070100,1001010720,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(107010039,0,0,1070100,1001020720,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000201','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(107010040,0,0,1070100,1001040720,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000401','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(107010041,0,0,1070100,1007010720,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(107010042,0,0,1070100,1007020720,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000207','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(107010043,0,0,1070100,1007040720,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000407','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(107010044,0,0,1070100,1003000720,300,'[{1,75},{2,75},{4,75}]',1,1,'[]',0,'1000003','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(107020001,0,0,1070200,1002010731,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(107020002,0,0,1070200,1002020731,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(107020003,0,0,1070200,1002040731,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(107020004,0,0,1070200,1004010731,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(107020005,0,0,1070200,1004020731,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(107020006,0,0,1070200,1004040731,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(107020007,0,0,1070200,1006010731,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(107020008,0,0,1070200,1006020731,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(107020009,0,0,1070200,1006040731,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(107020010,0,0,1070200,1008010731,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(107020011,0,0,1070200,1008020731,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(107020012,0,0,1070200,1008040731,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(107020013,0,0,1070200,1010010731,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(107020014,0,0,1070200,1010020731,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(107020015,0,0,1070200,1010040731,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(107020016,0,0,1070200,1001010731,1000,'[{1,50},{2,25},{4,25}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(107020017,0,0,1070200,1001020731,1000,'[{1,25},{2,50},{4,25}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(107020018,0,0,1070200,1001040731,1000,'[{1,25},{2,25},{4,50}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(107020019,0,0,1070200,1007010731,1000,'[{1,50},{2,25},{4,25}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(107020020,0,0,1070200,1007020731,1000,'[{1,25},{2,50},{4,25}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(107020021,0,0,1070200,1007040731,1000,'[{1,25},{2,25},{4,50}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(107020022,0,0,1070200,1003000731,1000,'[{1,25},{2,25},{4,25}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(107020023,0,0,1070200,1002010741,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(107020024,0,0,1070200,1002020741,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(107020025,0,0,1070200,1002040741,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(107020026,0,0,1070200,1004010741,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(107020027,0,0,1070200,1004020741,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(107020028,0,0,1070200,1004040741,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(107020029,0,0,1070200,1006010741,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(107020030,0,0,1070200,1006020741,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(107020031,0,0,1070200,1006040741,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(107020032,0,0,1070200,1008010741,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(107020033,0,0,1070200,1008020741,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(107020034,0,0,1070200,1008040741,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(107020035,0,0,1070200,1010010741,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(107020036,0,0,1070200,1010020741,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(107020037,0,0,1070200,1010040741,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(107020038,0,0,1070200,1001010741,1000,'[{1,20},{2,10},{4,10}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(107020039,0,0,1070200,1001020741,1000,'[{1,10},{2,20},{4,10}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[]',0,0,0,0,'[]'),(107020040,0,0,1070200,1001040741,1000,'[{1,10},{2,10},{4,20}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[]',0,0,0,0,'[]'),(107020041,0,0,1070200,1007010741,1000,'[{1,20},{2,10},{4,10}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(107020042,0,0,1070200,1007020741,1000,'[{1,10},{2,20},{4,10}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[]',0,0,0,0,'[]'),(107020043,0,0,1070200,1007040741,1000,'[{1,10},{2,10},{4,20}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[]',0,0,0,0,'[]'),(107020044,0,0,1070200,1003000741,1000,'[{1,10},{2,10},{4,10}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[]',0,0,0,0,'[]'),(107030101,0,0,1070301,1002010732,1000,'[{1,121},{2,61},{4,61}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107030102,0,0,1070301,1002020732,1000,'[{1,61},{2,121},{4,61}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107030103,0,0,1070301,1002040732,1000,'[{1,61},{2,61},{4,121}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107030104,0,0,1070301,1004010732,1000,'[{1,121},{2,61},{4,61}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107030105,0,0,1070301,1004020732,1000,'[{1,61},{2,121},{4,61}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107030106,0,0,1070301,1004040732,1000,'[{1,61},{2,61},{4,121}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107030107,0,0,1070301,1006010732,1000,'[{1,121},{2,61},{4,61}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107030108,0,0,1070301,1006020732,1000,'[{1,61},{2,121},{4,61}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107030109,0,0,1070301,1006040732,1000,'[{1,61},{2,61},{4,121}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107030110,0,0,1070301,1008010732,1000,'[{1,121},{2,61},{4,61}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107030111,0,0,1070301,1008020732,1000,'[{1,61},{2,121},{4,61}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107030112,0,0,1070301,1008040732,1000,'[{1,61},{2,61},{4,121}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107030113,0,0,1070301,1010010732,1000,'[{1,121},{2,61},{4,61}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107030114,0,0,1070301,1010020732,1000,'[{1,61},{2,121},{4,61}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107030115,0,0,1070301,1010040732,1000,'[{1,61},{2,61},{4,121}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107030116,0,0,1070301,1002010742,1000,'[{1,4},{2,2},{4,2}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107030117,0,0,1070301,1002020742,1000,'[{1,2},{2,4},{4,2}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107030118,0,0,1070301,1002040742,1000,'[{1,2},{2,2},{4,4}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107030119,0,0,1070301,1004010742,1000,'[{1,4},{2,2},{4,2}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107030120,0,0,1070301,1004020742,1000,'[{1,2},{2,4},{4,2}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107030121,0,0,1070301,1004040742,1000,'[{1,2},{2,2},{4,4}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107030122,0,0,1070301,1006010742,1000,'[{1,4},{2,2},{4,2}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107030123,0,0,1070301,1006020742,1000,'[{1,2},{2,4},{4,2}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107030124,0,0,1070301,1006040742,1000,'[{1,2},{2,2},{4,4}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107030125,0,0,1070301,1008010742,1000,'[{1,4},{2,2},{4,2}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107030126,0,0,1070301,1008020742,1000,'[{1,2},{2,4},{4,2}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107030127,0,0,1070301,1008040742,1000,'[{1,2},{2,2},{4,4}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107030128,0,0,1070301,1010010742,1000,'[{1,4},{2,2},{4,2}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107030129,0,0,1070301,1010020742,1000,'[{1,2},{2,4},{4,2}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107030130,0,0,1070301,1010040742,1000,'[{1,2},{2,2},{4,4}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107030201,0,0,1070302,1001010732,1000,'[{1,38},{2,19},{4,19}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107030202,0,0,1070302,1001020732,1000,'[{1,19},{2,38},{4,19}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107030203,0,0,1070302,1001040732,1000,'[{1,19},{2,19},{4,38}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107030204,0,0,1070302,1007010732,1000,'[{1,38},{2,19},{4,19}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107030205,0,0,1070302,1007020732,1000,'[{1,19},{2,38},{4,19}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107030206,0,0,1070302,1007040732,1000,'[{1,19},{2,19},{4,38}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107030207,0,0,1070302,1003000732,1000,'[{1,19},{2,19},{4,19}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107030208,0,0,1070302,1001010742,1000,'[{1,2},{2,1},{4,1}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107030209,0,0,1070302,1001020742,1000,'[{1,1},{2,2},{4,1}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107030210,0,0,1070302,1001040742,1000,'[{1,1},{2,1},{4,2}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107030211,0,0,1070302,1007010742,1000,'[{1,2},{2,1},{4,1}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107030212,0,0,1070302,1007020742,1000,'[{1,1},{2,2},{4,1}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107030213,0,0,1070302,1007040742,1000,'[{1,1},{2,1},{4,2}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107030214,0,0,1070302,1003000742,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107040101,0,0,1070401,1002010732,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107040102,0,0,1070401,1002020732,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107040103,0,0,1070401,1002040732,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107040104,0,0,1070401,1004010732,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107040105,0,0,1070401,1004020732,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107040106,0,0,1070401,1004040732,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107040107,0,0,1070401,1006010732,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107040108,0,0,1070401,1006020732,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107040109,0,0,1070401,1006040732,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107040110,0,0,1070401,1008010732,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107040111,0,0,1070401,1008020732,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107040112,0,0,1070401,1008040732,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107040113,0,0,1070401,1010010732,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107040114,0,0,1070401,1010020732,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107040115,0,0,1070401,1010040732,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107040116,0,0,1070401,1002010742,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107040117,0,0,1070401,1002020742,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107040118,0,0,1070401,1002040742,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107040119,0,0,1070401,1004010742,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107040120,0,0,1070401,1004020742,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107040121,0,0,1070401,1004040742,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107040122,0,0,1070401,1006010742,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107040123,0,0,1070401,1006020742,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107040124,0,0,1070401,1006040742,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107040125,0,0,1070401,1008010742,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107040126,0,0,1070401,1008020742,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107040127,0,0,1070401,1008040742,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107040128,0,0,1070401,1010010742,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107040129,0,0,1070401,1010020742,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107040130,0,0,1070401,1010040742,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107040201,0,0,1070402,1001010732,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107040202,0,0,1070402,1001020732,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107040203,0,0,1070402,1001040732,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107040204,0,0,1070402,1007010732,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107040205,0,0,1070402,1007020732,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107040206,0,0,1070402,1007040732,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107040207,0,0,1070402,1003000732,1000,'[{1,60},{2,60},{4,60}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107040208,0,0,1070402,1001010742,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107040209,0,0,1070402,1001020742,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107040210,0,0,1070402,1001040742,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107040211,0,0,1070402,1007010742,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107040212,0,0,1070402,1007020742,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107040213,0,0,1070402,1007040742,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107040214,0,0,1070402,1003000742,1000,'[{1,60},{2,60},{4,60}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107050101,0,0,1070501,1002010732,1000,'[{1,228},{2,114},{4,114}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107050102,0,0,1070501,1002020732,1000,'[{1,114},{2,228},{4,114}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107050103,0,0,1070501,1002040732,1000,'[{1,114},{2,114},{4,228}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107050104,0,0,1070501,1004010732,1000,'[{1,228},{2,114},{4,114}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107050105,0,0,1070501,1004020732,1000,'[{1,114},{2,228},{4,114}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107050106,0,0,1070501,1004040732,1000,'[{1,114},{2,114},{4,228}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107050107,0,0,1070501,1006010732,1000,'[{1,228},{2,114},{4,114}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107050108,0,0,1070501,1006020732,1000,'[{1,114},{2,228},{4,114}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107050109,0,0,1070501,1006040732,1000,'[{1,114},{2,114},{4,228}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107050110,0,0,1070501,1008010732,1000,'[{1,228},{2,114},{4,114}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107050111,0,0,1070501,1008020732,1000,'[{1,114},{2,228},{4,114}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107050112,0,0,1070501,1008040732,1000,'[{1,114},{2,114},{4,228}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107050113,0,0,1070501,1010010732,1000,'[{1,228},{2,114},{4,114}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107050114,0,0,1070501,1010020732,1000,'[{1,114},{2,228},{4,114}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107050115,0,0,1070501,1010040732,1000,'[{1,114},{2,114},{4,228}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107050116,0,0,1070501,1002010742,1000,'[{1,4},{2,2},{4,2}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107050117,0,0,1070501,1002020742,1000,'[{1,2},{2,4},{4,2}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107050118,0,0,1070501,1002040742,1000,'[{1,2},{2,2},{4,4}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107050119,0,0,1070501,1004010742,1000,'[{1,4},{2,2},{4,2}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107050120,0,0,1070501,1004020742,1000,'[{1,2},{2,4},{4,2}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107050121,0,0,1070501,1004040742,1000,'[{1,2},{2,2},{4,4}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107050122,0,0,1070501,1006010742,1000,'[{1,4},{2,2},{4,2}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107050123,0,0,1070501,1006020742,1000,'[{1,2},{2,4},{4,2}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107050124,0,0,1070501,1006040742,1000,'[{1,2},{2,2},{4,4}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107050125,0,0,1070501,1008010742,1000,'[{1,4},{2,2},{4,2}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107050126,0,0,1070501,1008020742,1000,'[{1,2},{2,4},{4,2}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107050127,0,0,1070501,1008040742,1000,'[{1,2},{2,2},{4,4}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107050128,0,0,1070501,1010010742,1000,'[{1,4},{2,2},{4,2}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107050129,0,0,1070501,1010020742,1000,'[{1,2},{2,4},{4,2}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107050130,0,0,1070501,1010040742,1000,'[{1,2},{2,2},{4,4}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107050201,0,0,1070502,1001010732,1000,'[{1,74},{2,37},{4,37}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107050202,0,0,1070502,1001020732,1000,'[{1,37},{2,74},{4,37}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107050203,0,0,1070502,1001040732,1000,'[{1,37},{2,37},{4,74}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107050204,0,0,1070502,1007010732,1000,'[{1,74},{2,37},{4,37}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107050205,0,0,1070502,1007020732,1000,'[{1,37},{2,74},{4,37}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107050206,0,0,1070502,1007040732,1000,'[{1,37},{2,37},{4,74}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107050207,0,0,1070502,1003000732,1000,'[{1,37},{2,37},{4,37}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107050208,0,0,1070502,1001010742,1000,'[{1,2},{2,1},{4,1}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107050209,0,0,1070502,1001020742,1000,'[{1,1},{2,2},{4,1}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107050210,0,0,1070502,1001040742,1000,'[{1,1},{2,1},{4,2}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107050211,0,0,1070502,1007010742,1000,'[{1,2},{2,1},{4,1}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107050212,0,0,1070502,1007020742,1000,'[{1,1},{2,2},{4,1}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107050213,0,0,1070502,1007040742,1000,'[{1,1},{2,1},{4,2}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107050214,0,0,1070502,1003000742,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107060101,0,0,1070601,1002010732,1000,'[{1,61},{2,30},{4,30}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107060102,0,0,1070601,1002020732,1000,'[{1,30},{2,61},{4,30}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107060103,0,0,1070601,1002040732,1000,'[{1,30},{2,30},{4,61}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107060104,0,0,1070601,1004010732,1000,'[{1,61},{2,30},{4,30}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107060105,0,0,1070601,1004020732,1000,'[{1,30},{2,61},{4,30}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107060106,0,0,1070601,1004040732,1000,'[{1,30},{2,30},{4,61}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107060107,0,0,1070601,1006010732,1000,'[{1,61},{2,30},{4,30}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107060108,0,0,1070601,1006020732,1000,'[{1,30},{2,61},{4,30}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107060109,0,0,1070601,1006040732,1000,'[{1,30},{2,30},{4,61}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107060110,0,0,1070601,1008010732,1000,'[{1,61},{2,30},{4,30}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107060111,0,0,1070601,1008020732,1000,'[{1,30},{2,61},{4,30}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107060112,0,0,1070601,1008040732,1000,'[{1,30},{2,30},{4,61}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107060113,0,0,1070601,1010010732,1000,'[{1,61},{2,30},{4,30}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107060114,0,0,1070601,1010020732,1000,'[{1,30},{2,61},{4,30}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107060115,0,0,1070601,1010040732,1000,'[{1,30},{2,30},{4,61}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107060116,0,0,1070601,1002010742,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107060117,0,0,1070601,1002020742,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107060118,0,0,1070601,1002040742,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107060119,0,0,1070601,1004010742,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107060120,0,0,1070601,1004020742,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107060121,0,0,1070601,1004040742,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107060122,0,0,1070601,1006010742,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107060123,0,0,1070601,1006020742,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107060124,0,0,1070601,1006040742,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107060125,0,0,1070601,1008010742,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107060126,0,0,1070601,1008020742,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107060127,0,0,1070601,1008040742,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107060128,0,0,1070601,1010010742,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107060129,0,0,1070601,1010020742,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107060130,0,0,1070601,1010040742,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107060201,0,0,1070602,1001010732,1000,'[{1,20},{2,10},{4,10}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107060202,0,0,1070602,1001020732,1000,'[{1,10},{2,20},{4,10}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107060203,0,0,1070602,1001040732,1000,'[{1,10},{2,10},{4,20}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107060204,0,0,1070602,1007010732,1000,'[{1,20},{2,10},{4,10}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107060205,0,0,1070602,1007020732,1000,'[{1,10},{2,20},{4,10}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107060206,0,0,1070602,1007040732,1000,'[{1,10},{2,10},{4,20}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107060207,0,0,1070602,1003000732,1000,'[{1,10},{2,10},{4,10}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107060208,0,0,1070602,1001010742,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107060209,0,0,1070602,1001020742,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107060210,0,0,1070602,1001040742,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107060211,0,0,1070602,1007010742,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107060212,0,0,1070602,1007020742,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107060213,0,0,1070602,1007040742,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107060214,0,0,1070602,1003000742,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107070101,0,0,1070701,1002010732,1000,'[{1,67},{2,34},{4,34}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107070102,0,0,1070701,1002020732,1000,'[{1,34},{2,67},{4,34}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107070103,0,0,1070701,1002040732,1000,'[{1,34},{2,34},{4,67}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107070104,0,0,1070701,1004010732,1000,'[{1,67},{2,34},{4,34}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107070105,0,0,1070701,1004020732,1000,'[{1,34},{2,67},{4,34}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107070106,0,0,1070701,1004040732,1000,'[{1,34},{2,34},{4,67}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107070107,0,0,1070701,1006010732,1000,'[{1,67},{2,34},{4,34}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107070108,0,0,1070701,1006020732,1000,'[{1,34},{2,67},{4,34}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107070109,0,0,1070701,1006040732,1000,'[{1,34},{2,34},{4,67}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107070110,0,0,1070701,1008010732,1000,'[{1,67},{2,34},{4,34}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107070111,0,0,1070701,1008020732,1000,'[{1,34},{2,67},{4,34}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107070112,0,0,1070701,1008040732,1000,'[{1,34},{2,34},{4,67}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107070113,0,0,1070701,1010010732,1000,'[{1,67},{2,34},{4,34}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107070114,0,0,1070701,1010020732,1000,'[{1,34},{2,67},{4,34}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107070115,0,0,1070701,1010040732,1000,'[{1,34},{2,34},{4,67}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107070116,0,0,1070701,1002010742,1000,'[{1,4},{2,2},{4,2}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107070117,0,0,1070701,1002020742,1000,'[{1,2},{2,4},{4,2}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107070118,0,0,1070701,1002040742,1000,'[{1,2},{2,2},{4,4}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107070119,0,0,1070701,1004010742,1000,'[{1,4},{2,2},{4,2}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107070120,0,0,1070701,1004020742,1000,'[{1,2},{2,4},{4,2}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107070121,0,0,1070701,1004040742,1000,'[{1,2},{2,2},{4,4}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107070122,0,0,1070701,1006010742,1000,'[{1,4},{2,2},{4,2}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107070123,0,0,1070701,1006020742,1000,'[{1,2},{2,4},{4,2}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107070124,0,0,1070701,1006040742,1000,'[{1,2},{2,2},{4,4}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107070125,0,0,1070701,1008010742,1000,'[{1,4},{2,2},{4,2}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107070126,0,0,1070701,1008020742,1000,'[{1,2},{2,4},{4,2}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107070127,0,0,1070701,1008040742,1000,'[{1,2},{2,2},{4,4}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107070128,0,0,1070701,1010010742,1000,'[{1,4},{2,2},{4,2}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107070129,0,0,1070701,1010020742,1000,'[{1,2},{2,4},{4,2}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107070130,0,0,1070701,1010040742,1000,'[{1,2},{2,2},{4,4}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107070201,0,0,1070702,1001010732,1000,'[{1,34},{2,17},{4,17}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107070202,0,0,1070702,1001020732,1000,'[{1,17},{2,34},{4,17}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107070203,0,0,1070702,1001040732,1000,'[{1,17},{2,17},{4,34}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107070204,0,0,1070702,1007010732,1000,'[{1,34},{2,17},{4,17}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107070205,0,0,1070702,1007020732,1000,'[{1,17},{2,34},{4,17}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107070206,0,0,1070702,1007040732,1000,'[{1,17},{2,17},{4,34}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107070207,0,0,1070702,1003000732,1000,'[{1,17},{2,17},{4,17}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107070208,0,0,1070702,1001010742,1000,'[{1,2},{2,1},{4,1}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107070209,0,0,1070702,1001020742,1000,'[{1,1},{2,2},{4,1}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107070210,0,0,1070702,1001040742,1000,'[{1,1},{2,1},{4,2}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107070211,0,0,1070702,1007010742,1000,'[{1,2},{2,1},{4,1}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107070212,0,0,1070702,1007020742,1000,'[{1,1},{2,2},{4,1}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107070213,0,0,1070702,1007040742,1000,'[{1,1},{2,1},{4,2}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107070214,0,0,1070702,1003000742,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107080101,0,0,1070801,1002010732,1000,'[{1,175},{2,88},{4,88}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107080102,0,0,1070801,1002020732,1000,'[{1,88},{2,175},{4,88}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107080103,0,0,1070801,1002040732,1000,'[{1,88},{2,88},{4,175}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107080104,0,0,1070801,1004010732,1000,'[{1,175},{2,88},{4,88}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107080105,0,0,1070801,1004020732,1000,'[{1,88},{2,175},{4,88}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107080106,0,0,1070801,1004040732,1000,'[{1,88},{2,88},{4,175}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107080107,0,0,1070801,1006010732,1000,'[{1,175},{2,88},{4,88}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107080108,0,0,1070801,1006020732,1000,'[{1,88},{2,175},{4,88}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107080109,0,0,1070801,1006040732,1000,'[{1,88},{2,88},{4,175}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107080110,0,0,1070801,1008010732,1000,'[{1,175},{2,88},{4,88}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107080111,0,0,1070801,1008020732,1000,'[{1,88},{2,175},{4,88}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107080112,0,0,1070801,1008040732,1000,'[{1,88},{2,88},{4,175}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107080113,0,0,1070801,1010010732,1000,'[{1,175},{2,88},{4,88}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107080114,0,0,1070801,1010020732,1000,'[{1,88},{2,175},{4,88}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107080115,0,0,1070801,1010040732,1000,'[{1,88},{2,88},{4,175}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107080116,0,0,1070801,1002010742,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107080117,0,0,1070801,1002020742,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107080118,0,0,1070801,1002040742,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107080119,0,0,1070801,1004010742,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107080120,0,0,1070801,1004020742,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107080121,0,0,1070801,1004040742,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107080122,0,0,1070801,1006010742,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107080123,0,0,1070801,1006020742,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107080124,0,0,1070801,1006040742,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107080125,0,0,1070801,1008010742,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107080126,0,0,1070801,1008020742,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107080127,0,0,1070801,1008040742,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107080128,0,0,1070801,1010010742,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107080129,0,0,1070801,1010020742,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107080130,0,0,1070801,1010040742,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107080201,0,0,1070802,1001010732,1000,'[{1,175},{2,88},{4,88}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107080202,0,0,1070802,1001020732,1000,'[{1,88},{2,175},{4,88}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107080203,0,0,1070802,1001040732,1000,'[{1,88},{2,88},{4,175}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107080204,0,0,1070802,1007010732,1000,'[{1,175},{2,88},{4,88}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107080205,0,0,1070802,1007020732,1000,'[{1,88},{2,175},{4,88}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107080206,0,0,1070802,1007040732,1000,'[{1,88},{2,88},{4,175}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107080207,0,0,1070802,1003000732,1000,'[{1,88},{2,88},{4,88}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(107080208,0,0,1070802,1001010742,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107080209,0,0,1070802,1001020742,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107080210,0,0,1070802,1001040742,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107080211,0,0,1070802,1007010742,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107080212,0,0,1070802,1007020742,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107080213,0,0,1070802,1007040742,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(107080214,0,0,1070802,1003000742,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108010001,0,0,1080100,1002010810,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(108010002,0,0,1080100,1002020810,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(108010003,0,0,1080100,1002040810,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(108010004,0,0,1080100,1004010810,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(108010005,0,0,1080100,1004020810,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(108010006,0,0,1080100,1004040810,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(108010007,0,0,1080100,1006010810,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(108010008,0,0,1080100,1006020810,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(108010009,0,0,1080100,1006040810,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(108010010,0,0,1080100,1008010810,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(108010011,0,0,1080100,1008020810,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(108010012,0,0,1080100,1008040810,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(108010013,0,0,1080100,1010010810,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(108010014,0,0,1080100,1010020810,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(108010015,0,0,1080100,1010040810,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(108010016,0,0,1080100,1001010810,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(108010017,0,0,1080100,1001020810,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000201','0',0,'[]',0,0,0,0,'[]'),(108010018,0,0,1080100,1001040810,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000401','0',0,'[]',0,0,0,0,'[]'),(108010019,0,0,1080100,1007010810,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(108010020,0,0,1080100,1007020810,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000207','0',0,'[]',0,0,0,0,'[]'),(108010021,0,0,1080100,1007040810,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000407','0',0,'[]',0,0,0,0,'[]'),(108010022,0,0,1080100,1003000810,300,'[{1,75},{2,75},{4,75}]',1,1,'[]',0,'1000003','0',0,'[]',0,0,0,0,'[]'),(108010023,0,0,1080100,1002010820,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(108010024,0,0,1080100,1002020820,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(108010025,0,0,1080100,1002040820,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(108010026,0,0,1080100,1004010820,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(108010027,0,0,1080100,1004020820,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(108010028,0,0,1080100,1004040820,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(108010029,0,0,1080100,1006010820,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(108010030,0,0,1080100,1006020820,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(108010031,0,0,1080100,1006040820,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(108010032,0,0,1080100,1008010820,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(108010033,0,0,1080100,1008020820,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(108010034,0,0,1080100,1008040820,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(108010035,0,0,1080100,1010010820,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(108010036,0,0,1080100,1010020820,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(108010037,0,0,1080100,1010040820,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(108010038,0,0,1080100,1001010820,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(108010039,0,0,1080100,1001020820,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000201','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(108010040,0,0,1080100,1001040820,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000401','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(108010041,0,0,1080100,1007010820,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(108010042,0,0,1080100,1007020820,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000207','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(108010043,0,0,1080100,1007040820,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000407','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(108010044,0,0,1080100,1003000820,300,'[{1,75},{2,75},{4,75}]',1,1,'[]',0,'1000003','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(108020001,0,0,1080200,1002010831,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(108020002,0,0,1080200,1002020831,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(108020003,0,0,1080200,1002040831,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(108020004,0,0,1080200,1004010831,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(108020005,0,0,1080200,1004020831,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(108020006,0,0,1080200,1004040831,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(108020007,0,0,1080200,1006010831,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(108020008,0,0,1080200,1006020831,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(108020009,0,0,1080200,1006040831,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(108020010,0,0,1080200,1008010831,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(108020011,0,0,1080200,1008020831,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(108020012,0,0,1080200,1008040831,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(108020013,0,0,1080200,1010010831,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(108020014,0,0,1080200,1010020831,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(108020015,0,0,1080200,1010040831,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(108020016,0,0,1080200,1001010831,1000,'[{1,50},{2,25},{4,25}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(108020017,0,0,1080200,1001020831,1000,'[{1,25},{2,50},{4,25}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(108020018,0,0,1080200,1001040831,1000,'[{1,25},{2,25},{4,50}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(108020019,0,0,1080200,1007010831,1000,'[{1,50},{2,25},{4,25}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(108020020,0,0,1080200,1007020831,1000,'[{1,25},{2,50},{4,25}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(108020021,0,0,1080200,1007040831,1000,'[{1,25},{2,25},{4,50}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(108020022,0,0,1080200,1003000831,1000,'[{1,25},{2,25},{4,25}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(108020023,0,0,1080200,1002010841,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(108020024,0,0,1080200,1002020841,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(108020025,0,0,1080200,1002040841,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(108020026,0,0,1080200,1004010841,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(108020027,0,0,1080200,1004020841,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(108020028,0,0,1080200,1004040841,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(108020029,0,0,1080200,1006010841,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(108020030,0,0,1080200,1006020841,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(108020031,0,0,1080200,1006040841,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(108020032,0,0,1080200,1008010841,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(108020033,0,0,1080200,1008020841,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(108020034,0,0,1080200,1008040841,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(108020035,0,0,1080200,1010010841,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(108020036,0,0,1080200,1010020841,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(108020037,0,0,1080200,1010040841,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(108020038,0,0,1080200,1001010841,1000,'[{1,20},{2,10},{4,10}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(108020039,0,0,1080200,1001020841,1000,'[{1,10},{2,20},{4,10}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[]',0,0,0,0,'[]'),(108020040,0,0,1080200,1001040841,1000,'[{1,10},{2,10},{4,20}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[]',0,0,0,0,'[]'),(108020041,0,0,1080200,1007010841,1000,'[{1,20},{2,10},{4,10}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(108020042,0,0,1080200,1007020841,1000,'[{1,10},{2,20},{4,10}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[]',0,0,0,0,'[]'),(108020043,0,0,1080200,1007040841,1000,'[{1,10},{2,10},{4,20}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[]',0,0,0,0,'[]'),(108020044,0,0,1080200,1003000841,1000,'[{1,10},{2,10},{4,10}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[]',0,0,0,0,'[]'),(108030101,0,0,1080301,1002010832,1000,'[{1,95},{2,47},{4,47}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108030102,0,0,1080301,1002020832,1000,'[{1,47},{2,95},{4,47}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108030103,0,0,1080301,1002040832,1000,'[{1,47},{2,47},{4,95}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108030104,0,0,1080301,1004010832,1000,'[{1,95},{2,47},{4,47}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108030105,0,0,1080301,1004020832,1000,'[{1,47},{2,95},{4,47}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108030106,0,0,1080301,1004040832,1000,'[{1,47},{2,47},{4,95}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108030107,0,0,1080301,1006010832,1000,'[{1,95},{2,47},{4,47}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108030108,0,0,1080301,1006020832,1000,'[{1,47},{2,95},{4,47}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108030109,0,0,1080301,1006040832,1000,'[{1,47},{2,47},{4,95}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108030110,0,0,1080301,1008010832,1000,'[{1,95},{2,47},{4,47}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108030111,0,0,1080301,1008020832,1000,'[{1,47},{2,95},{4,47}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108030112,0,0,1080301,1008040832,1000,'[{1,47},{2,47},{4,95}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108030113,0,0,1080301,1010010832,1000,'[{1,95},{2,47},{4,47}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108030114,0,0,1080301,1010020832,1000,'[{1,47},{2,95},{4,47}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108030115,0,0,1080301,1010040832,1000,'[{1,47},{2,47},{4,95}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108030116,0,0,1080301,1002010842,1000,'[{1,3},{2,2},{4,2}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108030117,0,0,1080301,1002020842,1000,'[{1,2},{2,3},{4,2}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108030118,0,0,1080301,1002040842,1000,'[{1,2},{2,2},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108030119,0,0,1080301,1004010842,1000,'[{1,3},{2,2},{4,2}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108030120,0,0,1080301,1004020842,1000,'[{1,2},{2,3},{4,2}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108030121,0,0,1080301,1004040842,1000,'[{1,2},{2,2},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108030122,0,0,1080301,1006010842,1000,'[{1,3},{2,2},{4,2}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108030123,0,0,1080301,1006020842,1000,'[{1,2},{2,3},{4,2}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108030124,0,0,1080301,1006040842,1000,'[{1,2},{2,2},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108030125,0,0,1080301,1008010842,1000,'[{1,3},{2,2},{4,2}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108030126,0,0,1080301,1008020842,1000,'[{1,2},{2,3},{4,2}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108030127,0,0,1080301,1008040842,1000,'[{1,2},{2,2},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108030128,0,0,1080301,1010010842,1000,'[{1,3},{2,2},{4,2}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108030129,0,0,1080301,1010020842,1000,'[{1,2},{2,3},{4,2}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108030130,0,0,1080301,1010040842,1000,'[{1,2},{2,2},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108030201,0,0,1080302,1001010832,1000,'[{1,30},{2,15},{4,15}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108030202,0,0,1080302,1001020832,1000,'[{1,15},{2,30},{4,15}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108030203,0,0,1080302,1001040832,1000,'[{1,15},{2,15},{4,30}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108030204,0,0,1080302,1007010832,1000,'[{1,30},{2,15},{4,15}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108030205,0,0,1080302,1007020832,1000,'[{1,15},{2,30},{4,15}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108030206,0,0,1080302,1007040832,1000,'[{1,15},{2,15},{4,30}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108030207,0,0,1080302,1003000832,1000,'[{1,15},{2,15},{4,15}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108030208,0,0,1080302,1001010842,1000,'[{1,2},{2,1},{4,1}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108030209,0,0,1080302,1001020842,1000,'[{1,1},{2,2},{4,1}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108030210,0,0,1080302,1001040842,1000,'[{1,1},{2,1},{4,2}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108030211,0,0,1080302,1007010842,1000,'[{1,2},{2,1},{4,1}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108030212,0,0,1080302,1007020842,1000,'[{1,1},{2,2},{4,1}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108030213,0,0,1080302,1007040842,1000,'[{1,1},{2,1},{4,2}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108030214,0,0,1080302,1003000842,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108040101,0,0,1080401,1002010832,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108040102,0,0,1080401,1002020832,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108040103,0,0,1080401,1002040832,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108040104,0,0,1080401,1004010832,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108040105,0,0,1080401,1004020832,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108040106,0,0,1080401,1004040832,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108040107,0,0,1080401,1006010832,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108040108,0,0,1080401,1006020832,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108040109,0,0,1080401,1006040832,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108040110,0,0,1080401,1008010832,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108040111,0,0,1080401,1008020832,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108040112,0,0,1080401,1008040832,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108040113,0,0,1080401,1010010832,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108040114,0,0,1080401,1010020832,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108040115,0,0,1080401,1010040832,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108040116,0,0,1080401,1002010842,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108040117,0,0,1080401,1002020842,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108040118,0,0,1080401,1002040842,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108040119,0,0,1080401,1004010842,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108040120,0,0,1080401,1004020842,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108040121,0,0,1080401,1004040842,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108040122,0,0,1080401,1006010842,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108040123,0,0,1080401,1006020842,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108040124,0,0,1080401,1006040842,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108040125,0,0,1080401,1008010842,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108040126,0,0,1080401,1008020842,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108040127,0,0,1080401,1008040842,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108040128,0,0,1080401,1010010842,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108040129,0,0,1080401,1010020842,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108040130,0,0,1080401,1010040842,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108040201,0,0,1080402,1001010832,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108040202,0,0,1080402,1001020832,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108040203,0,0,1080402,1001040832,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108040204,0,0,1080402,1007010832,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108040205,0,0,1080402,1007020832,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108040206,0,0,1080402,1007040832,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108040207,0,0,1080402,1003000832,1000,'[{1,60},{2,60},{4,60}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108040208,0,0,1080402,1001010842,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108040209,0,0,1080402,1001020842,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108040210,0,0,1080402,1001040842,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108040211,0,0,1080402,1007010842,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108040212,0,0,1080402,1007020842,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108040213,0,0,1080402,1007040842,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108040214,0,0,1080402,1003000842,1000,'[{1,60},{2,60},{4,60}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108050101,0,0,1080501,1002010832,1000,'[{1,180},{2,90},{4,90}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108050102,0,0,1080501,1002020832,1000,'[{1,90},{2,180},{4,90}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108050103,0,0,1080501,1002040832,1000,'[{1,90},{2,90},{4,180}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108050104,0,0,1080501,1004010832,1000,'[{1,180},{2,90},{4,90}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108050105,0,0,1080501,1004020832,1000,'[{1,90},{2,180},{4,90}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108050106,0,0,1080501,1004040832,1000,'[{1,90},{2,90},{4,180}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108050107,0,0,1080501,1006010832,1000,'[{1,180},{2,90},{4,90}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108050108,0,0,1080501,1006020832,1000,'[{1,90},{2,180},{4,90}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108050109,0,0,1080501,1006040832,1000,'[{1,90},{2,90},{4,180}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108050110,0,0,1080501,1008010832,1000,'[{1,180},{2,90},{4,90}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108050111,0,0,1080501,1008020832,1000,'[{1,90},{2,180},{4,90}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108050112,0,0,1080501,1008040832,1000,'[{1,90},{2,90},{4,180}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108050113,0,0,1080501,1010010832,1000,'[{1,180},{2,90},{4,90}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108050114,0,0,1080501,1010020832,1000,'[{1,90},{2,180},{4,90}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108050115,0,0,1080501,1010040832,1000,'[{1,90},{2,90},{4,180}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108050116,0,0,1080501,1002010842,1000,'[{1,3},{2,2},{4,2}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108050117,0,0,1080501,1002020842,1000,'[{1,2},{2,3},{4,2}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108050118,0,0,1080501,1002040842,1000,'[{1,2},{2,2},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108050119,0,0,1080501,1004010842,1000,'[{1,3},{2,2},{4,2}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108050120,0,0,1080501,1004020842,1000,'[{1,2},{2,3},{4,2}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108050121,0,0,1080501,1004040842,1000,'[{1,2},{2,2},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108050122,0,0,1080501,1006010842,1000,'[{1,3},{2,2},{4,2}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108050123,0,0,1080501,1006020842,1000,'[{1,2},{2,3},{4,2}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108050124,0,0,1080501,1006040842,1000,'[{1,2},{2,2},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108050125,0,0,1080501,1008010842,1000,'[{1,3},{2,2},{4,2}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108050126,0,0,1080501,1008020842,1000,'[{1,2},{2,3},{4,2}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108050127,0,0,1080501,1008040842,1000,'[{1,2},{2,2},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108050128,0,0,1080501,1010010842,1000,'[{1,3},{2,2},{4,2}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108050129,0,0,1080501,1010020842,1000,'[{1,2},{2,3},{4,2}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108050130,0,0,1080501,1010040842,1000,'[{1,2},{2,2},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108050201,0,0,1080502,1001010832,1000,'[{1,58},{2,29},{4,29}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108050202,0,0,1080502,1001020832,1000,'[{1,29},{2,58},{4,29}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108050203,0,0,1080502,1001040832,1000,'[{1,29},{2,29},{4,58}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108050204,0,0,1080502,1007010832,1000,'[{1,58},{2,29},{4,29}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108050205,0,0,1080502,1007020832,1000,'[{1,29},{2,58},{4,29}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108050206,0,0,1080502,1007040832,1000,'[{1,29},{2,29},{4,58}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108050207,0,0,1080502,1003000832,1000,'[{1,29},{2,29},{4,29}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108050208,0,0,1080502,1001010842,1000,'[{1,2},{2,1},{4,1}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108050209,0,0,1080502,1001020842,1000,'[{1,1},{2,2},{4,1}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108050210,0,0,1080502,1001040842,1000,'[{1,1},{2,1},{4,2}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108050211,0,0,1080502,1007010842,1000,'[{1,2},{2,1},{4,1}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108050212,0,0,1080502,1007020842,1000,'[{1,1},{2,2},{4,1}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108050213,0,0,1080502,1007040842,1000,'[{1,1},{2,1},{4,2}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108050214,0,0,1080502,1003000842,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108060101,0,0,1080601,1002010832,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108060102,0,0,1080601,1002020832,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108060103,0,0,1080601,1002040832,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108060104,0,0,1080601,1004010832,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108060105,0,0,1080601,1004020832,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108060106,0,0,1080601,1004040832,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108060107,0,0,1080601,1006010832,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108060108,0,0,1080601,1006020832,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108060109,0,0,1080601,1006040832,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108060110,0,0,1080601,1008010832,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108060111,0,0,1080601,1008020832,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108060112,0,0,1080601,1008040832,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108060113,0,0,1080601,1010010832,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108060114,0,0,1080601,1010020832,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108060115,0,0,1080601,1010040832,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108060116,0,0,1080601,1002010842,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108060117,0,0,1080601,1002020842,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108060118,0,0,1080601,1002040842,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108060119,0,0,1080601,1004010842,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108060120,0,0,1080601,1004020842,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108060121,0,0,1080601,1004040842,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108060122,0,0,1080601,1006010842,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108060123,0,0,1080601,1006020842,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108060124,0,0,1080601,1006040842,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108060125,0,0,1080601,1008010842,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108060126,0,0,1080601,1008020842,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108060127,0,0,1080601,1008040842,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108060128,0,0,1080601,1010010842,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108060129,0,0,1080601,1010020842,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108060130,0,0,1080601,1010040842,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108060201,0,0,1080602,1001010832,1000,'[{1,16},{2,8},{4,8}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108060202,0,0,1080602,1001020832,1000,'[{1,8},{2,16},{4,8}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108060203,0,0,1080602,1001040832,1000,'[{1,8},{2,8},{4,16}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108060204,0,0,1080602,1007010832,1000,'[{1,16},{2,8},{4,8}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108060205,0,0,1080602,1007020832,1000,'[{1,8},{2,16},{4,8}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108060206,0,0,1080602,1007040832,1000,'[{1,8},{2,8},{4,16}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108060207,0,0,1080602,1003000832,1000,'[{1,8},{2,8},{4,8}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108060208,0,0,1080602,1001010842,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108060209,0,0,1080602,1001020842,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108060210,0,0,1080602,1001040842,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108060211,0,0,1080602,1007010842,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108060212,0,0,1080602,1007020842,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108060213,0,0,1080602,1007040842,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108060214,0,0,1080602,1003000842,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108070101,0,0,1080701,1002010832,1000,'[{1,52},{2,26},{4,26}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108070102,0,0,1080701,1002020832,1000,'[{1,26},{2,52},{4,26}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108070103,0,0,1080701,1002040832,1000,'[{1,26},{2,26},{4,52}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108070104,0,0,1080701,1004010832,1000,'[{1,52},{2,26},{4,26}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108070105,0,0,1080701,1004020832,1000,'[{1,26},{2,52},{4,26}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108070106,0,0,1080701,1004040832,1000,'[{1,26},{2,26},{4,52}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108070107,0,0,1080701,1006010832,1000,'[{1,52},{2,26},{4,26}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108070108,0,0,1080701,1006020832,1000,'[{1,26},{2,52},{4,26}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108070109,0,0,1080701,1006040832,1000,'[{1,26},{2,26},{4,52}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108070110,0,0,1080701,1008010832,1000,'[{1,52},{2,26},{4,26}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108070111,0,0,1080701,1008020832,1000,'[{1,26},{2,52},{4,26}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108070112,0,0,1080701,1008040832,1000,'[{1,26},{2,26},{4,52}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108070113,0,0,1080701,1010010832,1000,'[{1,52},{2,26},{4,26}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108070114,0,0,1080701,1010020832,1000,'[{1,26},{2,52},{4,26}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108070115,0,0,1080701,1010040832,1000,'[{1,26},{2,26},{4,52}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108070116,0,0,1080701,1002010842,1000,'[{1,3},{2,2},{4,2}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108070117,0,0,1080701,1002020842,1000,'[{1,2},{2,3},{4,2}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108070118,0,0,1080701,1002040842,1000,'[{1,2},{2,2},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108070119,0,0,1080701,1004010842,1000,'[{1,3},{2,2},{4,2}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108070120,0,0,1080701,1004020842,1000,'[{1,2},{2,3},{4,2}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108070121,0,0,1080701,1004040842,1000,'[{1,2},{2,2},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108070122,0,0,1080701,1006010842,1000,'[{1,3},{2,2},{4,2}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108070123,0,0,1080701,1006020842,1000,'[{1,2},{2,3},{4,2}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108070124,0,0,1080701,1006040842,1000,'[{1,2},{2,2},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108070125,0,0,1080701,1008010842,1000,'[{1,3},{2,2},{4,2}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108070126,0,0,1080701,1008020842,1000,'[{1,2},{2,3},{4,2}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108070127,0,0,1080701,1008040842,1000,'[{1,2},{2,2},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108070128,0,0,1080701,1010010842,1000,'[{1,3},{2,2},{4,2}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108070129,0,0,1080701,1010020842,1000,'[{1,2},{2,3},{4,2}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108070130,0,0,1080701,1010040842,1000,'[{1,2},{2,2},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108070201,0,0,1080702,1001010832,1000,'[{1,26},{2,13},{4,13}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108070202,0,0,1080702,1001020832,1000,'[{1,13},{2,26},{4,13}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108070203,0,0,1080702,1001040832,1000,'[{1,13},{2,13},{4,26}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108070204,0,0,1080702,1007010832,1000,'[{1,26},{2,13},{4,13}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108070205,0,0,1080702,1007020832,1000,'[{1,13},{2,26},{4,13}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108070206,0,0,1080702,1007040832,1000,'[{1,13},{2,13},{4,26}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108070207,0,0,1080702,1003000832,1000,'[{1,13},{2,13},{4,13}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108070208,0,0,1080702,1001010842,1000,'[{1,2},{2,1},{4,1}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108070209,0,0,1080702,1001020842,1000,'[{1,1},{2,2},{4,1}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108070210,0,0,1080702,1001040842,1000,'[{1,1},{2,1},{4,2}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108070211,0,0,1080702,1007010842,1000,'[{1,2},{2,1},{4,1}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108070212,0,0,1080702,1007020842,1000,'[{1,1},{2,2},{4,1}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108070213,0,0,1080702,1007040842,1000,'[{1,1},{2,1},{4,2}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108070214,0,0,1080702,1003000842,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108080101,0,0,1080801,1002010832,1000,'[{1,125},{2,63},{4,63}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108080102,0,0,1080801,1002020832,1000,'[{1,63},{2,125},{4,63}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108080103,0,0,1080801,1002040832,1000,'[{1,63},{2,63},{4,125}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108080104,0,0,1080801,1004010832,1000,'[{1,125},{2,63},{4,63}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108080105,0,0,1080801,1004020832,1000,'[{1,63},{2,125},{4,63}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108080106,0,0,1080801,1004040832,1000,'[{1,63},{2,63},{4,125}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108080107,0,0,1080801,1006010832,1000,'[{1,125},{2,63},{4,63}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108080108,0,0,1080801,1006020832,1000,'[{1,63},{2,125},{4,63}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108080109,0,0,1080801,1006040832,1000,'[{1,63},{2,63},{4,125}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108080110,0,0,1080801,1008010832,1000,'[{1,125},{2,63},{4,63}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108080111,0,0,1080801,1008020832,1000,'[{1,63},{2,125},{4,63}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108080112,0,0,1080801,1008040832,1000,'[{1,63},{2,63},{4,125}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108080113,0,0,1080801,1010010832,1000,'[{1,125},{2,63},{4,63}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108080114,0,0,1080801,1010020832,1000,'[{1,63},{2,125},{4,63}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108080115,0,0,1080801,1010040832,1000,'[{1,63},{2,63},{4,125}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108080116,0,0,1080801,1002010842,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108080117,0,0,1080801,1002020842,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108080118,0,0,1080801,1002040842,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108080119,0,0,1080801,1004010842,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108080120,0,0,1080801,1004020842,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108080121,0,0,1080801,1004040842,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108080122,0,0,1080801,1006010842,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108080123,0,0,1080801,1006020842,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108080124,0,0,1080801,1006040842,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108080125,0,0,1080801,1008010842,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108080126,0,0,1080801,1008020842,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108080127,0,0,1080801,1008040842,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108080128,0,0,1080801,1010010842,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108080129,0,0,1080801,1010020842,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108080130,0,0,1080801,1010040842,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108080201,0,0,1080802,1001010832,1000,'[{1,125},{2,63},{4,63}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108080202,0,0,1080802,1001020832,1000,'[{1,63},{2,125},{4,63}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108080203,0,0,1080802,1001040832,1000,'[{1,63},{2,63},{4,125}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108080204,0,0,1080802,1007010832,1000,'[{1,125},{2,63},{4,63}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108080205,0,0,1080802,1007020832,1000,'[{1,63},{2,125},{4,63}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108080206,0,0,1080802,1007040832,1000,'[{1,63},{2,63},{4,125}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108080207,0,0,1080802,1003000832,1000,'[{1,63},{2,63},{4,63}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(108080208,0,0,1080802,1001010842,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108080209,0,0,1080802,1001020842,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108080210,0,0,1080802,1001040842,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108080211,0,0,1080802,1007010842,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108080212,0,0,1080802,1007020842,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108080213,0,0,1080802,1007040842,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(108080214,0,0,1080802,1003000842,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109010001,0,0,1090100,1002010910,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(109010002,0,0,1090100,1002020910,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(109010003,0,0,1090100,1002040910,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(109010004,0,0,1090100,1004010910,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(109010005,0,0,1090100,1004020910,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(109010006,0,0,1090100,1004040910,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(109010007,0,0,1090100,1006010910,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(109010008,0,0,1090100,1006020910,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(109010009,0,0,1090100,1006040910,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(109010010,0,0,1090100,1008010910,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(109010011,0,0,1090100,1008020910,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(109010012,0,0,1090100,1008040910,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(109010013,0,0,1090100,1010010910,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(109010014,0,0,1090100,1010020910,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(109010015,0,0,1090100,1010040910,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(109010016,0,0,1090100,1001010910,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(109010017,0,0,1090100,1001020910,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000201','0',0,'[]',0,0,0,0,'[]'),(109010018,0,0,1090100,1001040910,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000401','0',0,'[]',0,0,0,0,'[]'),(109010019,0,0,1090100,1007010910,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(109010020,0,0,1090100,1007020910,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000207','0',0,'[]',0,0,0,0,'[]'),(109010021,0,0,1090100,1007040910,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000407','0',0,'[]',0,0,0,0,'[]'),(109010022,0,0,1090100,1003000910,300,'[{1,75},{2,75},{4,75}]',1,1,'[]',0,'1000003','0',0,'[]',0,0,0,0,'[]'),(109010023,0,0,1090100,1002010920,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(109010024,0,0,1090100,1002020920,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(109010025,0,0,1090100,1002040920,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(109010026,0,0,1090100,1004010920,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(109010027,0,0,1090100,1004020920,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(109010028,0,0,1090100,1004040920,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(109010029,0,0,1090100,1006010920,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(109010030,0,0,1090100,1006020920,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(109010031,0,0,1090100,1006040920,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(109010032,0,0,1090100,1008010920,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(109010033,0,0,1090100,1008020920,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(109010034,0,0,1090100,1008040920,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(109010035,0,0,1090100,1010010920,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(109010036,0,0,1090100,1010020920,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(109010037,0,0,1090100,1010040920,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(109010038,0,0,1090100,1001010920,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(109010039,0,0,1090100,1001020920,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000201','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(109010040,0,0,1090100,1001040920,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000401','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(109010041,0,0,1090100,1007010920,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(109010042,0,0,1090100,1007020920,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000207','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(109010043,0,0,1090100,1007040920,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000407','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(109010044,0,0,1090100,1003000920,300,'[{1,75},{2,75},{4,75}]',1,1,'[]',0,'1000003','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(109020001,0,0,1090200,1002010931,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(109020002,0,0,1090200,1002020931,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(109020003,0,0,1090200,1002040931,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(109020004,0,0,1090200,1004010931,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(109020005,0,0,1090200,1004020931,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(109020006,0,0,1090200,1004040931,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(109020007,0,0,1090200,1006010931,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(109020008,0,0,1090200,1006020931,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(109020009,0,0,1090200,1006040931,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(109020010,0,0,1090200,1008010931,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(109020011,0,0,1090200,1008020931,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(109020012,0,0,1090200,1008040931,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(109020013,0,0,1090200,1010010931,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(109020014,0,0,1090200,1010020931,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(109020015,0,0,1090200,1010040931,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(109020016,0,0,1090200,1001010931,1000,'[{1,50},{2,25},{4,25}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(109020017,0,0,1090200,1001020931,1000,'[{1,25},{2,50},{4,25}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(109020018,0,0,1090200,1001040931,1000,'[{1,25},{2,25},{4,50}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(109020019,0,0,1090200,1007010931,1000,'[{1,50},{2,25},{4,25}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(109020020,0,0,1090200,1007020931,1000,'[{1,25},{2,50},{4,25}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(109020021,0,0,1090200,1007040931,1000,'[{1,25},{2,25},{4,50}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(109020022,0,0,1090200,1003000931,1000,'[{1,25},{2,25},{4,25}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(109020023,0,0,1090200,1002010941,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(109020024,0,0,1090200,1002020941,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(109020025,0,0,1090200,1002040941,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(109020026,0,0,1090200,1004010941,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(109020027,0,0,1090200,1004020941,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(109020028,0,0,1090200,1004040941,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(109020029,0,0,1090200,1006010941,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(109020030,0,0,1090200,1006020941,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(109020031,0,0,1090200,1006040941,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(109020032,0,0,1090200,1008010941,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(109020033,0,0,1090200,1008020941,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(109020034,0,0,1090200,1008040941,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(109020035,0,0,1090200,1010010941,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(109020036,0,0,1090200,1010020941,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(109020037,0,0,1090200,1010040941,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(109020038,0,0,1090200,1001010941,1000,'[{1,20},{2,10},{4,10}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(109020039,0,0,1090200,1001020941,1000,'[{1,10},{2,20},{4,10}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[]',0,0,0,0,'[]'),(109020040,0,0,1090200,1001040941,1000,'[{1,10},{2,10},{4,20}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[]',0,0,0,0,'[]'),(109020041,0,0,1090200,1007010941,1000,'[{1,20},{2,10},{4,10}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(109020042,0,0,1090200,1007020941,1000,'[{1,10},{2,20},{4,10}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[]',0,0,0,0,'[]'),(109020043,0,0,1090200,1007040941,1000,'[{1,10},{2,10},{4,20}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[]',0,0,0,0,'[]'),(109020044,0,0,1090200,1003000941,1000,'[{1,10},{2,10},{4,10}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[]',0,0,0,0,'[]'),(109030101,0,0,1090301,1002010932,1000,'[{1,71},{2,36},{4,36}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109030102,0,0,1090301,1002020932,1000,'[{1,36},{2,71},{4,36}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109030103,0,0,1090301,1002040932,1000,'[{1,36},{2,36},{4,71}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109030104,0,0,1090301,1004010932,1000,'[{1,71},{2,36},{4,36}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109030105,0,0,1090301,1004020932,1000,'[{1,36},{2,71},{4,36}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109030106,0,0,1090301,1004040932,1000,'[{1,36},{2,36},{4,71}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109030107,0,0,1090301,1006010932,1000,'[{1,71},{2,36},{4,36}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109030108,0,0,1090301,1006020932,1000,'[{1,36},{2,71},{4,36}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109030109,0,0,1090301,1006040932,1000,'[{1,36},{2,36},{4,71}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109030110,0,0,1090301,1008010932,1000,'[{1,71},{2,36},{4,36}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109030111,0,0,1090301,1008020932,1000,'[{1,36},{2,71},{4,36}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109030112,0,0,1090301,1008040932,1000,'[{1,36},{2,36},{4,71}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109030113,0,0,1090301,1010010932,1000,'[{1,71},{2,36},{4,36}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109030114,0,0,1090301,1010020932,1000,'[{1,36},{2,71},{4,36}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109030115,0,0,1090301,1010040932,1000,'[{1,36},{2,36},{4,71}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109030116,0,0,1090301,1002010942,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109030117,0,0,1090301,1002020942,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109030118,0,0,1090301,1002040942,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109030119,0,0,1090301,1004010942,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109030120,0,0,1090301,1004020942,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109030121,0,0,1090301,1004040942,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109030122,0,0,1090301,1006010942,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109030123,0,0,1090301,1006020942,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109030124,0,0,1090301,1006040942,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109030125,0,0,1090301,1008010942,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109030126,0,0,1090301,1008020942,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109030127,0,0,1090301,1008040942,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109030128,0,0,1090301,1010010942,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109030129,0,0,1090301,1010020942,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109030130,0,0,1090301,1010040942,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109030201,0,0,1090302,1001010932,1000,'[{1,22},{2,11},{4,11}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109030202,0,0,1090302,1001020932,1000,'[{1,11},{2,22},{4,11}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109030203,0,0,1090302,1001040932,1000,'[{1,11},{2,11},{4,22}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109030204,0,0,1090302,1007010932,1000,'[{1,22},{2,11},{4,11}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109030205,0,0,1090302,1007020932,1000,'[{1,11},{2,22},{4,11}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109030206,0,0,1090302,1007040932,1000,'[{1,11},{2,11},{4,22}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109030207,0,0,1090302,1003000932,1000,'[{1,11},{2,11},{4,11}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109030208,0,0,1090302,1001010942,1000,'[{1,2},{2,1},{4,1}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109030209,0,0,1090302,1001020942,1000,'[{1,1},{2,2},{4,1}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109030210,0,0,1090302,1001040942,1000,'[{1,1},{2,1},{4,2}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109030211,0,0,1090302,1007010942,1000,'[{1,2},{2,1},{4,1}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109030212,0,0,1090302,1007020942,1000,'[{1,1},{2,2},{4,1}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109030213,0,0,1090302,1007040942,1000,'[{1,1},{2,1},{4,2}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109030214,0,0,1090302,1003000942,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109040101,0,0,1090401,1002010932,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109040102,0,0,1090401,1002020932,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109040103,0,0,1090401,1002040932,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109040104,0,0,1090401,1004010932,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109040105,0,0,1090401,1004020932,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109040106,0,0,1090401,1004040932,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109040107,0,0,1090401,1006010932,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109040108,0,0,1090401,1006020932,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109040109,0,0,1090401,1006040932,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109040110,0,0,1090401,1008010932,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109040111,0,0,1090401,1008020932,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109040112,0,0,1090401,1008040932,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109040113,0,0,1090401,1010010932,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109040114,0,0,1090401,1010020932,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109040115,0,0,1090401,1010040932,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109040116,0,0,1090401,1002010942,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109040117,0,0,1090401,1002020942,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109040118,0,0,1090401,1002040942,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109040119,0,0,1090401,1004010942,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109040120,0,0,1090401,1004020942,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109040121,0,0,1090401,1004040942,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109040122,0,0,1090401,1006010942,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109040123,0,0,1090401,1006020942,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109040124,0,0,1090401,1006040942,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109040125,0,0,1090401,1008010942,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109040126,0,0,1090401,1008020942,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109040127,0,0,1090401,1008040942,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109040128,0,0,1090401,1010010942,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109040129,0,0,1090401,1010020942,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109040130,0,0,1090401,1010040942,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109040201,0,0,1090402,1001010932,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109040202,0,0,1090402,1001020932,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109040203,0,0,1090402,1001040932,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109040204,0,0,1090402,1007010932,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109040205,0,0,1090402,1007020932,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109040206,0,0,1090402,1007040932,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109040207,0,0,1090402,1003000932,1000,'[{1,60},{2,60},{4,60}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109040208,0,0,1090402,1001010942,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109040209,0,0,1090402,1001020942,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109040210,0,0,1090402,1001040942,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109040211,0,0,1090402,1007010942,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109040212,0,0,1090402,1007020942,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109040213,0,0,1090402,1007040942,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109040214,0,0,1090402,1003000942,1000,'[{1,60},{2,60},{4,60}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109050101,0,0,1090501,1002010932,1000,'[{1,138},{2,69},{4,69}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109050102,0,0,1090501,1002020932,1000,'[{1,69},{2,138},{4,69}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109050103,0,0,1090501,1002040932,1000,'[{1,69},{2,69},{4,138}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109050104,0,0,1090501,1004010932,1000,'[{1,138},{2,69},{4,69}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109050105,0,0,1090501,1004020932,1000,'[{1,69},{2,138},{4,69}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109050106,0,0,1090501,1004040932,1000,'[{1,69},{2,69},{4,138}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109050107,0,0,1090501,1006010932,1000,'[{1,138},{2,69},{4,69}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109050108,0,0,1090501,1006020932,1000,'[{1,69},{2,138},{4,69}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109050109,0,0,1090501,1006040932,1000,'[{1,69},{2,69},{4,138}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109050110,0,0,1090501,1008010932,1000,'[{1,138},{2,69},{4,69}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109050111,0,0,1090501,1008020932,1000,'[{1,69},{2,138},{4,69}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109050112,0,0,1090501,1008040932,1000,'[{1,69},{2,69},{4,138}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109050113,0,0,1090501,1010010932,1000,'[{1,138},{2,69},{4,69}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109050114,0,0,1090501,1010020932,1000,'[{1,69},{2,138},{4,69}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109050115,0,0,1090501,1010040932,1000,'[{1,69},{2,69},{4,138}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109050116,0,0,1090501,1002010942,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109050117,0,0,1090501,1002020942,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109050118,0,0,1090501,1002040942,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109050119,0,0,1090501,1004010942,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109050120,0,0,1090501,1004020942,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109050121,0,0,1090501,1004040942,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109050122,0,0,1090501,1006010942,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109050123,0,0,1090501,1006020942,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109050124,0,0,1090501,1006040942,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109050125,0,0,1090501,1008010942,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109050126,0,0,1090501,1008020942,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109050127,0,0,1090501,1008040942,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109050128,0,0,1090501,1010010942,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109050129,0,0,1090501,1010020942,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109050130,0,0,1090501,1010040942,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109050201,0,0,1090502,1001010932,1000,'[{1,44},{2,22},{4,22}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109050202,0,0,1090502,1001020932,1000,'[{1,22},{2,44},{4,22}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109050203,0,0,1090502,1001040932,1000,'[{1,22},{2,22},{4,44}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109050204,0,0,1090502,1007010932,1000,'[{1,44},{2,22},{4,22}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109050205,0,0,1090502,1007020932,1000,'[{1,22},{2,44},{4,22}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109050206,0,0,1090502,1007040932,1000,'[{1,22},{2,22},{4,44}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109050207,0,0,1090502,1003000932,1000,'[{1,22},{2,22},{4,22}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109050208,0,0,1090502,1001010942,1000,'[{1,2},{2,1},{4,1}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109050209,0,0,1090502,1001020942,1000,'[{1,1},{2,2},{4,1}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109050210,0,0,1090502,1001040942,1000,'[{1,1},{2,1},{4,2}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109050211,0,0,1090502,1007010942,1000,'[{1,2},{2,1},{4,1}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109050212,0,0,1090502,1007020942,1000,'[{1,1},{2,2},{4,1}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109050213,0,0,1090502,1007040942,1000,'[{1,1},{2,1},{4,2}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109050214,0,0,1090502,1003000942,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109060101,0,0,1090601,1002010932,1000,'[{1,38},{2,19},{4,19}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109060102,0,0,1090601,1002020932,1000,'[{1,19},{2,38},{4,19}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109060103,0,0,1090601,1002040932,1000,'[{1,19},{2,19},{4,38}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109060104,0,0,1090601,1004010932,1000,'[{1,38},{2,19},{4,19}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109060105,0,0,1090601,1004020932,1000,'[{1,19},{2,38},{4,19}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109060106,0,0,1090601,1004040932,1000,'[{1,19},{2,19},{4,38}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109060107,0,0,1090601,1006010932,1000,'[{1,38},{2,19},{4,19}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109060108,0,0,1090601,1006020932,1000,'[{1,19},{2,38},{4,19}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109060109,0,0,1090601,1006040932,1000,'[{1,19},{2,19},{4,38}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109060110,0,0,1090601,1008010932,1000,'[{1,38},{2,19},{4,19}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109060111,0,0,1090601,1008020932,1000,'[{1,19},{2,38},{4,19}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109060112,0,0,1090601,1008040932,1000,'[{1,19},{2,19},{4,38}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109060113,0,0,1090601,1010010932,1000,'[{1,38},{2,19},{4,19}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109060114,0,0,1090601,1010020932,1000,'[{1,19},{2,38},{4,19}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109060115,0,0,1090601,1010040932,1000,'[{1,19},{2,19},{4,38}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109060116,0,0,1090601,1002010942,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109060117,0,0,1090601,1002020942,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109060118,0,0,1090601,1002040942,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109060119,0,0,1090601,1004010942,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109060120,0,0,1090601,1004020942,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109060121,0,0,1090601,1004040942,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109060122,0,0,1090601,1006010942,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109060123,0,0,1090601,1006020942,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109060124,0,0,1090601,1006040942,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109060125,0,0,1090601,1008010942,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109060126,0,0,1090601,1008020942,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109060127,0,0,1090601,1008040942,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109060128,0,0,1090601,1010010942,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109060129,0,0,1090601,1010020942,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109060130,0,0,1090601,1010040942,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109060201,0,0,1090602,1001010932,1000,'[{1,13},{2,6},{4,6}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109060202,0,0,1090602,1001020932,1000,'[{1,6},{2,13},{4,6}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109060203,0,0,1090602,1001040932,1000,'[{1,6},{2,6},{4,13}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109060204,0,0,1090602,1007010932,1000,'[{1,13},{2,6},{4,6}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109060205,0,0,1090602,1007020932,1000,'[{1,6},{2,13},{4,6}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109060206,0,0,1090602,1007040932,1000,'[{1,6},{2,6},{4,13}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109060207,0,0,1090602,1003000932,1000,'[{1,6},{2,6},{4,6}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109060208,0,0,1090602,1001010942,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109060209,0,0,1090602,1001020942,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109060210,0,0,1090602,1001040942,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109060211,0,0,1090602,1007010942,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109060212,0,0,1090602,1007020942,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109060213,0,0,1090602,1007040942,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109060214,0,0,1090602,1003000942,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109070101,0,0,1090701,1002010932,1000,'[{1,38},{2,19},{4,19}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109070102,0,0,1090701,1002020932,1000,'[{1,19},{2,38},{4,19}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109070103,0,0,1090701,1002040932,1000,'[{1,19},{2,19},{4,38}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109070104,0,0,1090701,1004010932,1000,'[{1,38},{2,19},{4,19}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109070105,0,0,1090701,1004020932,1000,'[{1,19},{2,38},{4,19}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109070106,0,0,1090701,1004040932,1000,'[{1,19},{2,19},{4,38}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109070107,0,0,1090701,1006010932,1000,'[{1,38},{2,19},{4,19}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109070108,0,0,1090701,1006020932,1000,'[{1,19},{2,38},{4,19}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109070109,0,0,1090701,1006040932,1000,'[{1,19},{2,19},{4,38}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109070110,0,0,1090701,1008010932,1000,'[{1,38},{2,19},{4,19}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109070111,0,0,1090701,1008020932,1000,'[{1,19},{2,38},{4,19}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109070112,0,0,1090701,1008040932,1000,'[{1,19},{2,19},{4,38}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109070113,0,0,1090701,1010010932,1000,'[{1,38},{2,19},{4,19}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109070114,0,0,1090701,1010020932,1000,'[{1,19},{2,38},{4,19}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109070115,0,0,1090701,1010040932,1000,'[{1,19},{2,19},{4,38}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109070116,0,0,1090701,1002010942,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109070117,0,0,1090701,1002020942,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109070118,0,0,1090701,1002040942,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109070119,0,0,1090701,1004010942,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109070120,0,0,1090701,1004020942,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109070121,0,0,1090701,1004040942,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109070122,0,0,1090701,1006010942,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109070123,0,0,1090701,1006020942,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109070124,0,0,1090701,1006040942,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109070125,0,0,1090701,1008010942,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109070126,0,0,1090701,1008020942,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109070127,0,0,1090701,1008040942,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109070128,0,0,1090701,1010010942,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109070129,0,0,1090701,1010020942,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109070130,0,0,1090701,1010040942,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109070201,0,0,1090702,1001010932,1000,'[{1,19},{2,10},{4,10}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109070202,0,0,1090702,1001020932,1000,'[{1,10},{2,19},{4,10}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109070203,0,0,1090702,1001040932,1000,'[{1,10},{2,10},{4,19}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109070204,0,0,1090702,1007010932,1000,'[{1,19},{2,10},{4,10}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109070205,0,0,1090702,1007020932,1000,'[{1,10},{2,19},{4,10}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109070206,0,0,1090702,1007040932,1000,'[{1,10},{2,10},{4,19}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109070207,0,0,1090702,1003000932,1000,'[{1,10},{2,10},{4,10}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109070208,0,0,1090702,1001010942,1000,'[{1,2},{2,1},{4,1}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109070209,0,0,1090702,1001020942,1000,'[{1,1},{2,2},{4,1}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109070210,0,0,1090702,1001040942,1000,'[{1,1},{2,1},{4,2}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109070211,0,0,1090702,1007010942,1000,'[{1,2},{2,1},{4,1}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109070212,0,0,1090702,1007020942,1000,'[{1,1},{2,2},{4,1}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109070213,0,0,1090702,1007040942,1000,'[{1,1},{2,1},{4,2}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109070214,0,0,1090702,1003000942,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109080101,0,0,1090801,1002010932,1000,'[{1,75},{2,38},{4,38}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109080102,0,0,1090801,1002020932,1000,'[{1,38},{2,75},{4,38}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109080103,0,0,1090801,1002040932,1000,'[{1,38},{2,38},{4,75}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109080104,0,0,1090801,1004010932,1000,'[{1,75},{2,38},{4,38}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109080105,0,0,1090801,1004020932,1000,'[{1,38},{2,75},{4,38}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109080106,0,0,1090801,1004040932,1000,'[{1,38},{2,38},{4,75}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109080107,0,0,1090801,1006010932,1000,'[{1,75},{2,38},{4,38}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109080108,0,0,1090801,1006020932,1000,'[{1,38},{2,75},{4,38}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109080109,0,0,1090801,1006040932,1000,'[{1,38},{2,38},{4,75}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109080110,0,0,1090801,1008010932,1000,'[{1,75},{2,38},{4,38}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109080111,0,0,1090801,1008020932,1000,'[{1,38},{2,75},{4,38}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109080112,0,0,1090801,1008040932,1000,'[{1,38},{2,38},{4,75}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109080113,0,0,1090801,1010010932,1000,'[{1,75},{2,38},{4,38}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109080114,0,0,1090801,1010020932,1000,'[{1,38},{2,75},{4,38}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109080115,0,0,1090801,1010040932,1000,'[{1,38},{2,38},{4,75}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109080116,0,0,1090801,1002010942,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109080117,0,0,1090801,1002020942,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109080118,0,0,1090801,1002040942,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109080119,0,0,1090801,1004010942,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109080120,0,0,1090801,1004020942,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109080121,0,0,1090801,1004040942,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109080122,0,0,1090801,1006010942,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109080123,0,0,1090801,1006020942,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109080124,0,0,1090801,1006040942,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109080125,0,0,1090801,1008010942,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109080126,0,0,1090801,1008020942,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109080127,0,0,1090801,1008040942,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109080128,0,0,1090801,1010010942,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109080129,0,0,1090801,1010020942,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109080130,0,0,1090801,1010040942,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109080201,0,0,1090802,1001010932,1000,'[{1,75},{2,38},{4,38}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109080202,0,0,1090802,1001020932,1000,'[{1,38},{2,75},{4,38}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109080203,0,0,1090802,1001040932,1000,'[{1,38},{2,38},{4,75}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109080204,0,0,1090802,1007010932,1000,'[{1,75},{2,38},{4,38}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109080205,0,0,1090802,1007020932,1000,'[{1,38},{2,75},{4,38}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109080206,0,0,1090802,1007040932,1000,'[{1,38},{2,38},{4,75}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109080207,0,0,1090802,1003000932,1000,'[{1,38},{2,38},{4,38}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(109080208,0,0,1090802,1001010942,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109080209,0,0,1090802,1001020942,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109080210,0,0,1090802,1001040942,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109080211,0,0,1090802,1007010942,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109080212,0,0,1090802,1007020942,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109080213,0,0,1090802,1007040942,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(109080214,0,0,1090802,1003000942,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110010001,0,0,1100100,1002011010,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(110010002,0,0,1100100,1002021010,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(110010003,0,0,1100100,1002041010,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(110010004,0,0,1100100,1004011010,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(110010005,0,0,1100100,1004021010,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(110010006,0,0,1100100,1004041010,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(110010007,0,0,1100100,1006011010,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(110010008,0,0,1100100,1006021010,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(110010009,0,0,1100100,1006041010,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(110010010,0,0,1100100,1008011010,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(110010011,0,0,1100100,1008021010,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(110010012,0,0,1100100,1008041010,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(110010013,0,0,1100100,1010011010,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(110010014,0,0,1100100,1010021010,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(110010015,0,0,1100100,1010041010,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(110010016,0,0,1100100,1001011010,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(110010017,0,0,1100100,1001021010,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000201','0',0,'[]',0,0,0,0,'[]'),(110010018,0,0,1100100,1001041010,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000401','0',0,'[]',0,0,0,0,'[]'),(110010019,0,0,1100100,1007011010,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(110010020,0,0,1100100,1007021010,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000207','0',0,'[]',0,0,0,0,'[]'),(110010021,0,0,1100100,1007041010,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000407','0',0,'[]',0,0,0,0,'[]'),(110010022,0,0,1100100,1003001010,300,'[{1,75},{2,75},{4,75}]',1,1,'[]',0,'1000003','0',0,'[]',0,0,0,0,'[]'),(110010023,0,0,1100100,1002011020,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(110010024,0,0,1100100,1002021020,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(110010025,0,0,1100100,1002041020,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(110010026,0,0,1100100,1004011020,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(110010027,0,0,1100100,1004021020,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(110010028,0,0,1100100,1004041020,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(110010029,0,0,1100100,1006011020,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(110010030,0,0,1100100,1006021020,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(110010031,0,0,1100100,1006041020,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(110010032,0,0,1100100,1008011020,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(110010033,0,0,1100100,1008021020,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(110010034,0,0,1100100,1008041020,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(110010035,0,0,1100100,1010011020,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(110010036,0,0,1100100,1010021020,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(110010037,0,0,1100100,1010041020,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(110010038,0,0,1100100,1001011020,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(110010039,0,0,1100100,1001021020,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000201','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(110010040,0,0,1100100,1001041020,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000401','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(110010041,0,0,1100100,1007011020,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(110010042,0,0,1100100,1007021020,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000207','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(110010043,0,0,1100100,1007041020,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000407','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(110010044,0,0,1100100,1003001020,300,'[{1,75},{2,75},{4,75}]',1,1,'[]',0,'1000003','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(110020001,0,0,1100200,1002011031,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(110020002,0,0,1100200,1002021031,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(110020003,0,0,1100200,1002041031,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(110020004,0,0,1100200,1004011031,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(110020005,0,0,1100200,1004021031,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(110020006,0,0,1100200,1004041031,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(110020007,0,0,1100200,1006011031,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(110020008,0,0,1100200,1006021031,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(110020009,0,0,1100200,1006041031,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(110020010,0,0,1100200,1008011031,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(110020011,0,0,1100200,1008021031,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(110020012,0,0,1100200,1008041031,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(110020013,0,0,1100200,1010011031,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(110020014,0,0,1100200,1010021031,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(110020015,0,0,1100200,1010041031,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(110020016,0,0,1100200,1001011031,1000,'[{1,50},{2,25},{4,25}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(110020017,0,0,1100200,1001021031,1000,'[{1,25},{2,50},{4,25}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(110020018,0,0,1100200,1001041031,1000,'[{1,25},{2,25},{4,50}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(110020019,0,0,1100200,1007011031,1000,'[{1,50},{2,25},{4,25}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(110020020,0,0,1100200,1007021031,1000,'[{1,25},{2,50},{4,25}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(110020021,0,0,1100200,1007041031,1000,'[{1,25},{2,25},{4,50}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(110020022,0,0,1100200,1003001031,1000,'[{1,25},{2,25},{4,25}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(110020023,0,0,1100200,1002011041,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(110020024,0,0,1100200,1002021041,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(110020025,0,0,1100200,1002041041,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(110020026,0,0,1100200,1004011041,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(110020027,0,0,1100200,1004021041,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(110020028,0,0,1100200,1004041041,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(110020029,0,0,1100200,1006011041,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(110020030,0,0,1100200,1006021041,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(110020031,0,0,1100200,1006041041,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(110020032,0,0,1100200,1008011041,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(110020033,0,0,1100200,1008021041,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(110020034,0,0,1100200,1008041041,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(110020035,0,0,1100200,1010011041,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(110020036,0,0,1100200,1010021041,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(110020037,0,0,1100200,1010041041,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(110020038,0,0,1100200,1001011041,1000,'[{1,20},{2,10},{4,10}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(110020039,0,0,1100200,1001021041,1000,'[{1,10},{2,20},{4,10}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[]',0,0,0,0,'[]'),(110020040,0,0,1100200,1001041041,1000,'[{1,10},{2,10},{4,20}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[]',0,0,0,0,'[]'),(110020041,0,0,1100200,1007011041,1000,'[{1,20},{2,10},{4,10}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(110020042,0,0,1100200,1007021041,1000,'[{1,10},{2,20},{4,10}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[]',0,0,0,0,'[]'),(110020043,0,0,1100200,1007041041,1000,'[{1,10},{2,10},{4,20}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[]',0,0,0,0,'[]'),(110020044,0,0,1100200,1003001041,1000,'[{1,10},{2,10},{4,10}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[]',0,0,0,0,'[]'),(110030101,0,0,1100301,1002011032,1000,'[{1,63},{2,32},{4,32}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110030102,0,0,1100301,1002021032,1000,'[{1,32},{2,63},{4,32}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110030103,0,0,1100301,1002041032,1000,'[{1,32},{2,32},{4,63}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110030104,0,0,1100301,1004011032,1000,'[{1,63},{2,32},{4,32}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110030105,0,0,1100301,1004021032,1000,'[{1,32},{2,63},{4,32}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110030106,0,0,1100301,1004041032,1000,'[{1,32},{2,32},{4,63}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110030107,0,0,1100301,1006011032,1000,'[{1,63},{2,32},{4,32}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110030108,0,0,1100301,1006021032,1000,'[{1,32},{2,63},{4,32}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110030109,0,0,1100301,1006041032,1000,'[{1,32},{2,32},{4,63}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110030110,0,0,1100301,1008011032,1000,'[{1,63},{2,32},{4,32}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110030111,0,0,1100301,1008021032,1000,'[{1,32},{2,63},{4,32}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110030112,0,0,1100301,1008041032,1000,'[{1,32},{2,32},{4,63}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110030113,0,0,1100301,1010011032,1000,'[{1,63},{2,32},{4,32}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110030114,0,0,1100301,1010021032,1000,'[{1,32},{2,63},{4,32}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110030115,0,0,1100301,1010041032,1000,'[{1,32},{2,32},{4,63}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110030116,0,0,1100301,1002011042,1000,'[{1,2},{2,1},{4,1}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110030117,0,0,1100301,1002021042,1000,'[{1,1},{2,2},{4,1}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110030118,0,0,1100301,1002041042,1000,'[{1,1},{2,1},{4,2}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110030119,0,0,1100301,1004011042,1000,'[{1,2},{2,1},{4,1}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110030120,0,0,1100301,1004021042,1000,'[{1,1},{2,2},{4,1}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110030121,0,0,1100301,1004041042,1000,'[{1,1},{2,1},{4,2}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110030122,0,0,1100301,1006011042,1000,'[{1,2},{2,1},{4,1}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110030123,0,0,1100301,1006021042,1000,'[{1,1},{2,2},{4,1}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110030124,0,0,1100301,1006041042,1000,'[{1,1},{2,1},{4,2}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110030125,0,0,1100301,1008011042,1000,'[{1,2},{2,1},{4,1}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110030126,0,0,1100301,1008021042,1000,'[{1,1},{2,2},{4,1}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110030127,0,0,1100301,1008041042,1000,'[{1,1},{2,1},{4,2}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110030128,0,0,1100301,1010011042,1000,'[{1,2},{2,1},{4,1}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110030129,0,0,1100301,1010021042,1000,'[{1,1},{2,2},{4,1}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110030130,0,0,1100301,1010041042,1000,'[{1,1},{2,1},{4,2}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110030201,0,0,1100302,1001011032,1000,'[{1,19},{2,10},{4,10}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110030202,0,0,1100302,1001021032,1000,'[{1,10},{2,19},{4,10}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110030203,0,0,1100302,1001041032,1000,'[{1,10},{2,10},{4,19}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110030204,0,0,1100302,1007011032,1000,'[{1,19},{2,10},{4,10}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110030205,0,0,1100302,1007021032,1000,'[{1,10},{2,19},{4,10}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110030206,0,0,1100302,1007041032,1000,'[{1,10},{2,10},{4,19}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110030207,0,0,1100302,1003001032,1000,'[{1,10},{2,10},{4,10}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110030208,0,0,1100302,1001011042,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110030209,0,0,1100302,1001021042,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110030210,0,0,1100302,1001041042,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110030211,0,0,1100302,1007011042,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110030212,0,0,1100302,1007021042,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110030213,0,0,1100302,1007041042,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110030214,0,0,1100302,1003001042,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110040101,0,0,1100401,1002011032,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110040102,0,0,1100401,1002021032,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110040103,0,0,1100401,1002041032,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110040104,0,0,1100401,1004011032,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110040105,0,0,1100401,1004021032,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110040106,0,0,1100401,1004041032,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110040107,0,0,1100401,1006011032,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110040108,0,0,1100401,1006021032,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110040109,0,0,1100401,1006041032,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110040110,0,0,1100401,1008011032,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110040111,0,0,1100401,1008021032,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110040112,0,0,1100401,1008041032,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110040113,0,0,1100401,1010011032,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110040114,0,0,1100401,1010021032,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110040115,0,0,1100401,1010041032,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110040116,0,0,1100401,1002011042,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110040117,0,0,1100401,1002021042,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110040118,0,0,1100401,1002041042,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110040119,0,0,1100401,1004011042,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110040120,0,0,1100401,1004021042,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110040121,0,0,1100401,1004041042,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110040122,0,0,1100401,1006011042,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110040123,0,0,1100401,1006021042,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110040124,0,0,1100401,1006041042,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110040125,0,0,1100401,1008011042,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110040126,0,0,1100401,1008021042,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110040127,0,0,1100401,1008041042,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110040128,0,0,1100401,1010011042,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110040129,0,0,1100401,1010021042,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110040130,0,0,1100401,1010041042,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110040201,0,0,1100402,1001011032,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110040202,0,0,1100402,1001021032,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110040203,0,0,1100402,1001041032,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110040204,0,0,1100402,1007011032,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110040205,0,0,1100402,1007021032,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110040206,0,0,1100402,1007041032,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110040207,0,0,1100402,1003001032,1000,'[{1,60},{2,60},{4,60}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110040208,0,0,1100402,1001011042,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110040209,0,0,1100402,1001021042,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110040210,0,0,1100402,1001041042,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110040211,0,0,1100402,1007011042,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110040212,0,0,1100402,1007021042,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110040213,0,0,1100402,1007041042,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110040214,0,0,1100402,1003001042,1000,'[{1,60},{2,60},{4,60}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110050101,0,0,1100501,1002011032,1000,'[{1,123},{2,62},{4,62}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110050102,0,0,1100501,1002021032,1000,'[{1,62},{2,123},{4,62}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110050103,0,0,1100501,1002041032,1000,'[{1,62},{2,62},{4,123}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110050104,0,0,1100501,1004011032,1000,'[{1,123},{2,62},{4,62}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110050105,0,0,1100501,1004021032,1000,'[{1,62},{2,123},{4,62}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110050106,0,0,1100501,1004041032,1000,'[{1,62},{2,62},{4,123}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110050107,0,0,1100501,1006011032,1000,'[{1,123},{2,62},{4,62}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110050108,0,0,1100501,1006021032,1000,'[{1,62},{2,123},{4,62}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110050109,0,0,1100501,1006041032,1000,'[{1,62},{2,62},{4,123}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110050110,0,0,1100501,1008011032,1000,'[{1,123},{2,62},{4,62}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110050111,0,0,1100501,1008021032,1000,'[{1,62},{2,123},{4,62}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110050112,0,0,1100501,1008041032,1000,'[{1,62},{2,62},{4,123}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110050113,0,0,1100501,1010011032,1000,'[{1,123},{2,62},{4,62}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110050114,0,0,1100501,1010021032,1000,'[{1,62},{2,123},{4,62}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110050115,0,0,1100501,1010041032,1000,'[{1,62},{2,62},{4,123}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110050116,0,0,1100501,1002011042,1000,'[{1,2},{2,1},{4,1}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110050117,0,0,1100501,1002021042,1000,'[{1,1},{2,2},{4,1}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110050118,0,0,1100501,1002041042,1000,'[{1,1},{2,1},{4,2}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110050119,0,0,1100501,1004011042,1000,'[{1,2},{2,1},{4,1}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110050120,0,0,1100501,1004021042,1000,'[{1,1},{2,2},{4,1}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110050121,0,0,1100501,1004041042,1000,'[{1,1},{2,1},{4,2}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110050122,0,0,1100501,1006011042,1000,'[{1,2},{2,1},{4,1}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110050123,0,0,1100501,1006021042,1000,'[{1,1},{2,2},{4,1}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110050124,0,0,1100501,1006041042,1000,'[{1,1},{2,1},{4,2}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110050125,0,0,1100501,1008011042,1000,'[{1,2},{2,1},{4,1}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110050126,0,0,1100501,1008021042,1000,'[{1,1},{2,2},{4,1}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110050127,0,0,1100501,1008041042,1000,'[{1,1},{2,1},{4,2}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110050128,0,0,1100501,1010011042,1000,'[{1,2},{2,1},{4,1}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110050129,0,0,1100501,1010021042,1000,'[{1,1},{2,2},{4,1}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110050130,0,0,1100501,1010041042,1000,'[{1,1},{2,1},{4,2}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110050201,0,0,1100502,1001011032,1000,'[{1,39},{2,20},{4,20}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110050202,0,0,1100502,1001021032,1000,'[{1,20},{2,39},{4,20}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110050203,0,0,1100502,1001041032,1000,'[{1,20},{2,20},{4,39}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110050204,0,0,1100502,1007011032,1000,'[{1,39},{2,20},{4,20}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110050205,0,0,1100502,1007021032,1000,'[{1,20},{2,39},{4,20}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110050206,0,0,1100502,1007041032,1000,'[{1,20},{2,20},{4,39}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110050207,0,0,1100502,1003001032,1000,'[{1,20},{2,20},{4,20}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110050208,0,0,1100502,1001011042,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110050209,0,0,1100502,1001021042,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110050210,0,0,1100502,1001041042,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110050211,0,0,1100502,1007011042,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110050212,0,0,1100502,1007021042,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110050213,0,0,1100502,1007041042,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110050214,0,0,1100502,1003001042,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110060101,0,0,1100601,1002011032,1000,'[{1,34},{2,17},{4,17}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110060102,0,0,1100601,1002021032,1000,'[{1,17},{2,34},{4,17}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110060103,0,0,1100601,1002041032,1000,'[{1,17},{2,17},{4,34}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110060104,0,0,1100601,1004011032,1000,'[{1,34},{2,17},{4,17}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110060105,0,0,1100601,1004021032,1000,'[{1,17},{2,34},{4,17}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110060106,0,0,1100601,1004041032,1000,'[{1,17},{2,17},{4,34}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110060107,0,0,1100601,1006011032,1000,'[{1,34},{2,17},{4,17}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110060108,0,0,1100601,1006021032,1000,'[{1,17},{2,34},{4,17}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110060109,0,0,1100601,1006041032,1000,'[{1,17},{2,17},{4,34}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110060110,0,0,1100601,1008011032,1000,'[{1,34},{2,17},{4,17}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110060111,0,0,1100601,1008021032,1000,'[{1,17},{2,34},{4,17}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110060112,0,0,1100601,1008041032,1000,'[{1,17},{2,17},{4,34}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110060113,0,0,1100601,1010011032,1000,'[{1,34},{2,17},{4,17}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110060114,0,0,1100601,1010021032,1000,'[{1,17},{2,34},{4,17}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110060115,0,0,1100601,1010041032,1000,'[{1,17},{2,17},{4,34}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110060116,0,0,1100601,1002011042,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110060117,0,0,1100601,1002021042,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110060118,0,0,1100601,1002041042,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110060119,0,0,1100601,1004011042,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110060120,0,0,1100601,1004021042,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110060121,0,0,1100601,1004041042,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110060122,0,0,1100601,1006011042,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110060123,0,0,1100601,1006021042,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110060124,0,0,1100601,1006041042,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110060125,0,0,1100601,1008011042,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110060126,0,0,1100601,1008021042,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110060127,0,0,1100601,1008041042,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110060128,0,0,1100601,1010011042,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110060129,0,0,1100601,1010021042,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110060130,0,0,1100601,1010041042,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110060201,0,0,1100602,1001011032,1000,'[{1,12},{2,6},{4,6}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110060202,0,0,1100602,1001021032,1000,'[{1,6},{2,12},{4,6}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110060203,0,0,1100602,1001041032,1000,'[{1,6},{2,6},{4,12}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110060204,0,0,1100602,1007011032,1000,'[{1,12},{2,6},{4,6}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110060205,0,0,1100602,1007021032,1000,'[{1,6},{2,12},{4,6}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110060206,0,0,1100602,1007041032,1000,'[{1,6},{2,6},{4,12}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110060207,0,0,1100602,1003001032,1000,'[{1,6},{2,6},{4,6}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110060208,0,0,1100602,1001011042,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110060209,0,0,1100602,1001021042,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110060210,0,0,1100602,1001041042,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110060211,0,0,1100602,1007011042,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110060212,0,0,1100602,1007021042,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110060213,0,0,1100602,1007041042,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110060214,0,0,1100602,1003001042,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110070101,0,0,1100701,1002011032,1000,'[{1,33},{2,17},{4,17}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110070102,0,0,1100701,1002021032,1000,'[{1,17},{2,33},{4,17}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110070103,0,0,1100701,1002041032,1000,'[{1,17},{2,17},{4,33}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110070104,0,0,1100701,1004011032,1000,'[{1,33},{2,17},{4,17}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110070105,0,0,1100701,1004021032,1000,'[{1,17},{2,33},{4,17}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110070106,0,0,1100701,1004041032,1000,'[{1,17},{2,17},{4,33}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110070107,0,0,1100701,1006011032,1000,'[{1,33},{2,17},{4,17}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110070108,0,0,1100701,1006021032,1000,'[{1,17},{2,33},{4,17}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110070109,0,0,1100701,1006041032,1000,'[{1,17},{2,17},{4,33}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110070110,0,0,1100701,1008011032,1000,'[{1,33},{2,17},{4,17}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110070111,0,0,1100701,1008021032,1000,'[{1,17},{2,33},{4,17}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110070112,0,0,1100701,1008041032,1000,'[{1,17},{2,17},{4,33}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110070113,0,0,1100701,1010011032,1000,'[{1,33},{2,17},{4,17}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110070114,0,0,1100701,1010021032,1000,'[{1,17},{2,33},{4,17}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110070115,0,0,1100701,1010041032,1000,'[{1,17},{2,17},{4,33}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110070116,0,0,1100701,1002011042,1000,'[{1,2},{2,1},{4,1}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110070117,0,0,1100701,1002021042,1000,'[{1,1},{2,2},{4,1}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110070118,0,0,1100701,1002041042,1000,'[{1,1},{2,1},{4,2}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110070119,0,0,1100701,1004011042,1000,'[{1,2},{2,1},{4,1}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110070120,0,0,1100701,1004021042,1000,'[{1,1},{2,2},{4,1}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110070121,0,0,1100701,1004041042,1000,'[{1,1},{2,1},{4,2}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110070122,0,0,1100701,1006011042,1000,'[{1,2},{2,1},{4,1}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110070123,0,0,1100701,1006021042,1000,'[{1,1},{2,2},{4,1}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110070124,0,0,1100701,1006041042,1000,'[{1,1},{2,1},{4,2}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110070125,0,0,1100701,1008011042,1000,'[{1,2},{2,1},{4,1}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110070126,0,0,1100701,1008021042,1000,'[{1,1},{2,2},{4,1}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110070127,0,0,1100701,1008041042,1000,'[{1,1},{2,1},{4,2}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110070128,0,0,1100701,1010011042,1000,'[{1,2},{2,1},{4,1}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110070129,0,0,1100701,1010021042,1000,'[{1,1},{2,2},{4,1}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110070130,0,0,1100701,1010041042,1000,'[{1,1},{2,1},{4,2}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110070201,0,0,1100702,1001011032,1000,'[{1,17},{2,8},{4,8}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110070202,0,0,1100702,1001021032,1000,'[{1,8},{2,17},{4,8}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110070203,0,0,1100702,1001041032,1000,'[{1,8},{2,8},{4,17}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110070204,0,0,1100702,1007011032,1000,'[{1,17},{2,8},{4,8}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110070205,0,0,1100702,1007021032,1000,'[{1,8},{2,17},{4,8}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110070206,0,0,1100702,1007041032,1000,'[{1,8},{2,8},{4,17}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110070207,0,0,1100702,1003001032,1000,'[{1,8},{2,8},{4,8}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110070208,0,0,1100702,1001011042,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110070209,0,0,1100702,1001021042,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110070210,0,0,1100702,1001041042,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110070211,0,0,1100702,1007011042,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110070212,0,0,1100702,1007021042,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110070213,0,0,1100702,1007041042,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110070214,0,0,1100702,1003001042,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110080101,0,0,1100801,1002011032,1000,'[{1,68},{2,34},{4,34}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110080102,0,0,1100801,1002021032,1000,'[{1,34},{2,68},{4,34}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110080103,0,0,1100801,1002041032,1000,'[{1,34},{2,34},{4,68}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110080104,0,0,1100801,1004011032,1000,'[{1,68},{2,34},{4,34}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110080105,0,0,1100801,1004021032,1000,'[{1,34},{2,68},{4,34}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110080106,0,0,1100801,1004041032,1000,'[{1,34},{2,34},{4,68}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110080107,0,0,1100801,1006011032,1000,'[{1,68},{2,34},{4,34}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110080108,0,0,1100801,1006021032,1000,'[{1,34},{2,68},{4,34}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110080109,0,0,1100801,1006041032,1000,'[{1,34},{2,34},{4,68}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110080110,0,0,1100801,1008011032,1000,'[{1,68},{2,34},{4,34}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110080111,0,0,1100801,1008021032,1000,'[{1,34},{2,68},{4,34}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110080112,0,0,1100801,1008041032,1000,'[{1,34},{2,34},{4,68}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110080113,0,0,1100801,1010011032,1000,'[{1,68},{2,34},{4,34}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110080114,0,0,1100801,1010021032,1000,'[{1,34},{2,68},{4,34}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110080115,0,0,1100801,1010041032,1000,'[{1,34},{2,34},{4,68}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110080116,0,0,1100801,1002011042,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110080117,0,0,1100801,1002021042,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110080118,0,0,1100801,1002041042,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110080119,0,0,1100801,1004011042,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110080120,0,0,1100801,1004021042,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110080121,0,0,1100801,1004041042,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110080122,0,0,1100801,1006011042,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110080123,0,0,1100801,1006021042,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110080124,0,0,1100801,1006041042,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110080125,0,0,1100801,1008011042,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110080126,0,0,1100801,1008021042,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110080127,0,0,1100801,1008041042,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110080128,0,0,1100801,1010011042,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110080129,0,0,1100801,1010021042,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110080130,0,0,1100801,1010041042,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110080201,0,0,1100802,1001011032,1000,'[{1,68},{2,34},{4,34}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110080202,0,0,1100802,1001021032,1000,'[{1,34},{2,68},{4,34}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110080203,0,0,1100802,1001041032,1000,'[{1,34},{2,34},{4,68}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110080204,0,0,1100802,1007011032,1000,'[{1,68},{2,34},{4,34}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110080205,0,0,1100802,1007021032,1000,'[{1,34},{2,68},{4,34}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110080206,0,0,1100802,1007041032,1000,'[{1,34},{2,34},{4,68}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110080207,0,0,1100802,1003001032,1000,'[{1,34},{2,34},{4,34}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(110080208,0,0,1100802,1001011042,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110080209,0,0,1100802,1001021042,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110080210,0,0,1100802,1001041042,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110080211,0,0,1100802,1007011042,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110080212,0,0,1100802,1007021042,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110080213,0,0,1100802,1007041042,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(110080214,0,0,1100802,1003001042,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111010001,0,0,1110100,1002011110,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(111010002,0,0,1110100,1002021110,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(111010003,0,0,1110100,1002041110,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(111010004,0,0,1110100,1004011110,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(111010005,0,0,1110100,1004021110,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(111010006,0,0,1110100,1004041110,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(111010007,0,0,1110100,1006011110,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(111010008,0,0,1110100,1006021110,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(111010009,0,0,1110100,1006041110,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(111010010,0,0,1110100,1008011110,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(111010011,0,0,1110100,1008021110,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(111010012,0,0,1110100,1008041110,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(111010013,0,0,1110100,1010011110,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(111010014,0,0,1110100,1010021110,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(111010015,0,0,1110100,1010041110,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(111010016,0,0,1110100,1001011110,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(111010017,0,0,1110100,1001021110,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000201','0',0,'[]',0,0,0,0,'[]'),(111010018,0,0,1110100,1001041110,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000401','0',0,'[]',0,0,0,0,'[]'),(111010019,0,0,1110100,1007011110,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(111010020,0,0,1110100,1007021110,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000207','0',0,'[]',0,0,0,0,'[]'),(111010021,0,0,1110100,1007041110,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000407','0',0,'[]',0,0,0,0,'[]'),(111010022,0,0,1110100,1003001110,300,'[{1,75},{2,75},{4,75}]',1,1,'[]',0,'1000003','0',0,'[]',0,0,0,0,'[]'),(111010023,0,0,1110100,1002011120,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(111010024,0,0,1110100,1002021120,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(111010025,0,0,1110100,1002041120,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(111010026,0,0,1110100,1004011120,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(111010027,0,0,1110100,1004021120,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(111010028,0,0,1110100,1004041120,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(111010029,0,0,1110100,1006011120,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(111010030,0,0,1110100,1006021120,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(111010031,0,0,1110100,1006041120,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(111010032,0,0,1110100,1008011120,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(111010033,0,0,1110100,1008021120,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(111010034,0,0,1110100,1008041120,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(111010035,0,0,1110100,1010011120,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(111010036,0,0,1110100,1010021120,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(111010037,0,0,1110100,1010041120,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(111010038,0,0,1110100,1001011120,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(111010039,0,0,1110100,1001021120,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000201','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(111010040,0,0,1110100,1001041120,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000401','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(111010041,0,0,1110100,1007011120,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(111010042,0,0,1110100,1007021120,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000207','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(111010043,0,0,1110100,1007041120,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000407','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(111010044,0,0,1110100,1003001120,300,'[{1,75},{2,75},{4,75}]',1,1,'[]',0,'1000003','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(111020001,0,0,1110200,1002011131,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(111020002,0,0,1110200,1002021131,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(111020003,0,0,1110200,1002041131,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(111020004,0,0,1110200,1004011131,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(111020005,0,0,1110200,1004021131,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(111020006,0,0,1110200,1004041131,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(111020007,0,0,1110200,1006011131,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(111020008,0,0,1110200,1006021131,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(111020009,0,0,1110200,1006041131,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(111020010,0,0,1110200,1008011131,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(111020011,0,0,1110200,1008021131,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(111020012,0,0,1110200,1008041131,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(111020013,0,0,1110200,1010011131,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(111020014,0,0,1110200,1010021131,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(111020015,0,0,1110200,1010041131,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(111020016,0,0,1110200,1001011131,1000,'[{1,50},{2,25},{4,25}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(111020017,0,0,1110200,1001021131,1000,'[{1,25},{2,50},{4,25}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(111020018,0,0,1110200,1001041131,1000,'[{1,25},{2,25},{4,50}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(111020019,0,0,1110200,1007011131,1000,'[{1,50},{2,25},{4,25}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(111020020,0,0,1110200,1007021131,1000,'[{1,25},{2,50},{4,25}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(111020021,0,0,1110200,1007041131,1000,'[{1,25},{2,25},{4,50}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(111020022,0,0,1110200,1003001131,1000,'[{1,25},{2,25},{4,25}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(111020023,0,0,1110200,1002011141,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(111020024,0,0,1110200,1002021141,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(111020025,0,0,1110200,1002041141,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(111020026,0,0,1110200,1004011141,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(111020027,0,0,1110200,1004021141,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(111020028,0,0,1110200,1004041141,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(111020029,0,0,1110200,1006011141,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(111020030,0,0,1110200,1006021141,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(111020031,0,0,1110200,1006041141,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(111020032,0,0,1110200,1008011141,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(111020033,0,0,1110200,1008021141,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(111020034,0,0,1110200,1008041141,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(111020035,0,0,1110200,1010011141,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(111020036,0,0,1110200,1010021141,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(111020037,0,0,1110200,1010041141,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(111020038,0,0,1110200,1001011141,1000,'[{1,20},{2,10},{4,10}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(111020039,0,0,1110200,1001021141,1000,'[{1,10},{2,20},{4,10}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[]',0,0,0,0,'[]'),(111020040,0,0,1110200,1001041141,1000,'[{1,10},{2,10},{4,20}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[]',0,0,0,0,'[]'),(111020041,0,0,1110200,1007011141,1000,'[{1,20},{2,10},{4,10}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(111020042,0,0,1110200,1007021141,1000,'[{1,10},{2,20},{4,10}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[]',0,0,0,0,'[]'),(111020043,0,0,1110200,1007041141,1000,'[{1,10},{2,10},{4,20}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[]',0,0,0,0,'[]'),(111020044,0,0,1110200,1003001141,1000,'[{1,10},{2,10},{4,10}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[]',0,0,0,0,'[]'),(111030101,0,0,1110301,1002011132,1000,'[{1,152},{2,76},{4,76}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111030102,0,0,1110301,1002021132,1000,'[{1,76},{2,152},{4,76}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111030103,0,0,1110301,1002041132,1000,'[{1,76},{2,76},{4,152}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111030104,0,0,1110301,1004011132,1000,'[{1,152},{2,76},{4,76}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111030105,0,0,1110301,1004021132,1000,'[{1,76},{2,152},{4,76}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111030106,0,0,1110301,1004041132,1000,'[{1,76},{2,76},{4,152}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111030107,0,0,1110301,1006011132,1000,'[{1,152},{2,76},{4,76}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111030108,0,0,1110301,1006021132,1000,'[{1,76},{2,152},{4,76}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111030109,0,0,1110301,1006041132,1000,'[{1,76},{2,76},{4,152}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111030110,0,0,1110301,1008011132,1000,'[{1,152},{2,76},{4,76}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111030111,0,0,1110301,1008021132,1000,'[{1,76},{2,152},{4,76}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111030112,0,0,1110301,1008041132,1000,'[{1,76},{2,76},{4,152}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111030113,0,0,1110301,1010011132,1000,'[{1,152},{2,76},{4,76}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111030114,0,0,1110301,1010021132,1000,'[{1,76},{2,152},{4,76}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111030115,0,0,1110301,1010041132,1000,'[{1,76},{2,76},{4,152}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111030116,0,0,1110301,1002011142,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111030117,0,0,1110301,1002021142,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111030118,0,0,1110301,1002041142,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111030119,0,0,1110301,1004011142,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111030120,0,0,1110301,1004021142,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111030121,0,0,1110301,1004041142,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111030122,0,0,1110301,1006011142,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111030123,0,0,1110301,1006021142,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111030124,0,0,1110301,1006041142,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111030125,0,0,1110301,1008011142,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111030126,0,0,1110301,1008021142,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111030127,0,0,1110301,1008041142,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111030128,0,0,1110301,1010011142,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111030129,0,0,1110301,1010021142,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111030130,0,0,1110301,1010041142,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111030201,0,0,1110302,1001011132,1000,'[{1,76},{2,38},{4,38}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111030202,0,0,1110302,1001021132,1000,'[{1,38},{2,76},{4,38}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111030203,0,0,1110302,1001041132,1000,'[{1,38},{2,38},{4,76}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111030204,0,0,1110302,1007011132,1000,'[{1,76},{2,38},{4,38}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111030205,0,0,1110302,1007021132,1000,'[{1,38},{2,76},{4,38}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111030206,0,0,1110302,1007041132,1000,'[{1,38},{2,38},{4,76}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111030207,0,0,1110302,1003001132,1000,'[{1,38},{2,38},{4,38}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111030208,0,0,1110302,1001011142,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111030209,0,0,1110302,1001021142,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111030210,0,0,1110302,1001041142,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111030211,0,0,1110302,1007011142,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111030212,0,0,1110302,1007021142,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111030213,0,0,1110302,1007041142,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111030214,0,0,1110302,1003001142,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111040101,0,0,1110401,1002011132,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111040102,0,0,1110401,1002021132,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111040103,0,0,1110401,1002041132,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111040104,0,0,1110401,1004011132,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111040105,0,0,1110401,1004021132,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111040106,0,0,1110401,1004041132,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111040107,0,0,1110401,1006011132,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111040108,0,0,1110401,1006021132,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111040109,0,0,1110401,1006041132,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111040110,0,0,1110401,1008011132,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111040111,0,0,1110401,1008021132,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111040112,0,0,1110401,1008041132,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111040113,0,0,1110401,1010011132,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111040114,0,0,1110401,1010021132,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111040115,0,0,1110401,1010041132,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111040116,0,0,1110401,1002011142,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111040117,0,0,1110401,1002021142,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111040118,0,0,1110401,1002041142,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111040119,0,0,1110401,1004011142,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111040120,0,0,1110401,1004021142,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111040121,0,0,1110401,1004041142,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111040122,0,0,1110401,1006011142,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111040123,0,0,1110401,1006021142,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111040124,0,0,1110401,1006041142,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111040125,0,0,1110401,1008011142,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111040126,0,0,1110401,1008021142,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111040127,0,0,1110401,1008041142,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111040128,0,0,1110401,1010011142,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111040129,0,0,1110401,1010021142,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111040130,0,0,1110401,1010041142,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111040201,0,0,1110402,1001011132,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111040202,0,0,1110402,1001021132,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111040203,0,0,1110402,1001041132,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111040204,0,0,1110402,1007011132,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111040205,0,0,1110402,1007021132,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111040206,0,0,1110402,1007041132,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111040207,0,0,1110402,1003001132,1000,'[{1,60},{2,60},{4,60}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111040208,0,0,1110402,1001011142,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111040209,0,0,1110402,1001021142,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111040210,0,0,1110402,1001041142,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111040211,0,0,1110402,1007011142,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111040212,0,0,1110402,1007021142,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111040213,0,0,1110402,1007041142,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111040214,0,0,1110402,1003001142,1000,'[{1,60},{2,60},{4,60}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111050101,0,0,1110501,1002011132,1000,'[{1,285},{2,143},{4,143}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111050102,0,0,1110501,1002021132,1000,'[{1,143},{2,285},{4,143}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111050103,0,0,1110501,1002041132,1000,'[{1,143},{2,143},{4,285}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111050104,0,0,1110501,1004011132,1000,'[{1,285},{2,143},{4,143}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111050105,0,0,1110501,1004021132,1000,'[{1,143},{2,285},{4,143}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111050106,0,0,1110501,1004041132,1000,'[{1,143},{2,143},{4,285}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111050107,0,0,1110501,1006011132,1000,'[{1,285},{2,143},{4,143}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111050108,0,0,1110501,1006021132,1000,'[{1,143},{2,285},{4,143}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111050109,0,0,1110501,1006041132,1000,'[{1,143},{2,143},{4,285}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111050110,0,0,1110501,1008011132,1000,'[{1,285},{2,143},{4,143}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111050111,0,0,1110501,1008021132,1000,'[{1,143},{2,285},{4,143}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111050112,0,0,1110501,1008041132,1000,'[{1,143},{2,143},{4,285}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111050113,0,0,1110501,1010011132,1000,'[{1,285},{2,143},{4,143}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111050114,0,0,1110501,1010021132,1000,'[{1,143},{2,285},{4,143}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111050115,0,0,1110501,1010041132,1000,'[{1,143},{2,143},{4,285}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111050116,0,0,1110501,1002011142,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111050117,0,0,1110501,1002021142,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111050118,0,0,1110501,1002041142,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111050119,0,0,1110501,1004011142,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111050120,0,0,1110501,1004021142,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111050121,0,0,1110501,1004041142,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111050122,0,0,1110501,1006011142,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111050123,0,0,1110501,1006021142,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111050124,0,0,1110501,1006041142,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111050125,0,0,1110501,1008011142,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111050126,0,0,1110501,1008021142,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111050127,0,0,1110501,1008041142,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111050128,0,0,1110501,1010011142,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111050129,0,0,1110501,1010021142,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111050130,0,0,1110501,1010041142,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111050201,0,0,1110502,1001011132,1000,'[{1,143},{2,71},{4,71}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111050202,0,0,1110502,1001021132,1000,'[{1,71},{2,143},{4,71}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111050203,0,0,1110502,1001041132,1000,'[{1,71},{2,71},{4,143}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111050204,0,0,1110502,1007011132,1000,'[{1,143},{2,71},{4,71}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111050205,0,0,1110502,1007021132,1000,'[{1,71},{2,143},{4,71}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111050206,0,0,1110502,1007041132,1000,'[{1,71},{2,71},{4,143}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111050207,0,0,1110502,1003001132,1000,'[{1,71},{2,71},{4,71}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111050208,0,0,1110502,1001011142,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111050209,0,0,1110502,1001021142,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111050210,0,0,1110502,1001041142,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111050211,0,0,1110502,1007011142,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111050212,0,0,1110502,1007021142,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111050213,0,0,1110502,1007041142,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111050214,0,0,1110502,1003001142,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111060101,0,0,1110601,1002011132,1000,'[{1,75},{2,38},{4,38}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111060102,0,0,1110601,1002021132,1000,'[{1,38},{2,75},{4,38}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111060103,0,0,1110601,1002041132,1000,'[{1,38},{2,38},{4,75}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111060104,0,0,1110601,1004011132,1000,'[{1,75},{2,38},{4,38}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111060105,0,0,1110601,1004021132,1000,'[{1,38},{2,75},{4,38}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111060106,0,0,1110601,1004041132,1000,'[{1,38},{2,38},{4,75}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111060107,0,0,1110601,1006011132,1000,'[{1,75},{2,38},{4,38}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111060108,0,0,1110601,1006021132,1000,'[{1,38},{2,75},{4,38}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111060109,0,0,1110601,1006041132,1000,'[{1,38},{2,38},{4,75}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111060110,0,0,1110601,1008011132,1000,'[{1,75},{2,38},{4,38}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111060111,0,0,1110601,1008021132,1000,'[{1,38},{2,75},{4,38}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111060112,0,0,1110601,1008041132,1000,'[{1,38},{2,38},{4,75}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111060113,0,0,1110601,1010011132,1000,'[{1,75},{2,38},{4,38}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111060114,0,0,1110601,1010021132,1000,'[{1,38},{2,75},{4,38}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111060115,0,0,1110601,1010041132,1000,'[{1,38},{2,38},{4,75}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111060116,0,0,1110601,1002011142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111060117,0,0,1110601,1002021142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111060118,0,0,1110601,1002041142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111060119,0,0,1110601,1004011142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111060120,0,0,1110601,1004021142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111060121,0,0,1110601,1004041142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111060122,0,0,1110601,1006011142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111060123,0,0,1110601,1006021142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111060124,0,0,1110601,1006041142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111060125,0,0,1110601,1008011142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111060126,0,0,1110601,1008021142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111060127,0,0,1110601,1008041142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111060128,0,0,1110601,1010011142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111060129,0,0,1110601,1010021142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111060130,0,0,1110601,1010041142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111060201,0,0,1110602,1001011132,1000,'[{1,38},{2,19},{4,19}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111060202,0,0,1110602,1001021132,1000,'[{1,19},{2,38},{4,19}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111060203,0,0,1110602,1001041132,1000,'[{1,19},{2,19},{4,38}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111060204,0,0,1110602,1007011132,1000,'[{1,38},{2,19},{4,19}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111060205,0,0,1110602,1007021132,1000,'[{1,19},{2,38},{4,19}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111060206,0,0,1110602,1007041132,1000,'[{1,19},{2,19},{4,38}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111060207,0,0,1110602,1003001132,1000,'[{1,19},{2,19},{4,19}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111060208,0,0,1110602,1001011142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111060209,0,0,1110602,1001021142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111060210,0,0,1110602,1001041142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111060211,0,0,1110602,1007011142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111060212,0,0,1110602,1007021142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111060213,0,0,1110602,1007041142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111060214,0,0,1110602,1003001142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111070101,0,0,1110701,1002011132,1000,'[{1,85},{2,43},{4,43}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111070102,0,0,1110701,1002021132,1000,'[{1,43},{2,85},{4,43}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111070103,0,0,1110701,1002041132,1000,'[{1,43},{2,43},{4,85}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111070104,0,0,1110701,1004011132,1000,'[{1,85},{2,43},{4,43}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111070105,0,0,1110701,1004021132,1000,'[{1,43},{2,85},{4,43}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111070106,0,0,1110701,1004041132,1000,'[{1,43},{2,43},{4,85}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111070107,0,0,1110701,1006011132,1000,'[{1,85},{2,43},{4,43}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111070108,0,0,1110701,1006021132,1000,'[{1,43},{2,85},{4,43}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111070109,0,0,1110701,1006041132,1000,'[{1,43},{2,43},{4,85}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111070110,0,0,1110701,1008011132,1000,'[{1,85},{2,43},{4,43}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111070111,0,0,1110701,1008021132,1000,'[{1,43},{2,85},{4,43}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111070112,0,0,1110701,1008041132,1000,'[{1,43},{2,43},{4,85}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111070113,0,0,1110701,1010011132,1000,'[{1,85},{2,43},{4,43}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111070114,0,0,1110701,1010021132,1000,'[{1,43},{2,85},{4,43}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111070115,0,0,1110701,1010041132,1000,'[{1,43},{2,43},{4,85}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111070116,0,0,1110701,1002011142,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111070117,0,0,1110701,1002021142,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111070118,0,0,1110701,1002041142,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111070119,0,0,1110701,1004011142,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111070120,0,0,1110701,1004021142,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111070121,0,0,1110701,1004041142,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111070122,0,0,1110701,1006011142,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111070123,0,0,1110701,1006021142,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111070124,0,0,1110701,1006041142,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111070125,0,0,1110701,1008011142,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111070126,0,0,1110701,1008021142,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111070127,0,0,1110701,1008041142,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111070128,0,0,1110701,1010011142,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111070129,0,0,1110701,1010021142,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111070130,0,0,1110701,1010041142,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111070201,0,0,1110702,1001011132,1000,'[{1,68},{2,34},{4,34}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111070202,0,0,1110702,1001021132,1000,'[{1,34},{2,68},{4,34}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111070203,0,0,1110702,1001041132,1000,'[{1,34},{2,34},{4,68}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111070204,0,0,1110702,1007011132,1000,'[{1,68},{2,34},{4,34}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111070205,0,0,1110702,1007021132,1000,'[{1,34},{2,68},{4,34}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111070206,0,0,1110702,1007041132,1000,'[{1,34},{2,34},{4,68}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111070207,0,0,1110702,1003001132,1000,'[{1,34},{2,34},{4,34}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111070208,0,0,1110702,1001011142,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111070209,0,0,1110702,1001021142,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111070210,0,0,1110702,1001041142,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111070211,0,0,1110702,1007011142,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111070212,0,0,1110702,1007021142,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111070213,0,0,1110702,1007041142,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111070214,0,0,1110702,1003001142,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111080101,0,0,1110801,1002011132,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111080102,0,0,1110801,1002021132,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111080103,0,0,1110801,1002041132,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111080104,0,0,1110801,1004011132,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111080105,0,0,1110801,1004021132,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111080106,0,0,1110801,1004041132,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111080107,0,0,1110801,1006011132,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111080108,0,0,1110801,1006021132,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111080109,0,0,1110801,1006041132,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111080110,0,0,1110801,1008011132,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111080111,0,0,1110801,1008021132,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111080112,0,0,1110801,1008041132,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111080113,0,0,1110801,1010011132,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111080114,0,0,1110801,1010021132,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111080115,0,0,1110801,1010041132,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111080116,0,0,1110801,1002011142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111080117,0,0,1110801,1002021142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111080118,0,0,1110801,1002041142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111080119,0,0,1110801,1004011142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111080120,0,0,1110801,1004021142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111080121,0,0,1110801,1004041142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111080122,0,0,1110801,1006011142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111080123,0,0,1110801,1006021142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111080124,0,0,1110801,1006041142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111080125,0,0,1110801,1008011142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111080126,0,0,1110801,1008021142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111080127,0,0,1110801,1008041142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111080128,0,0,1110801,1010011142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111080129,0,0,1110801,1010021142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111080130,0,0,1110801,1010041142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111080201,0,0,1110802,1001011132,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111080202,0,0,1110802,1001021132,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111080203,0,0,1110802,1001041132,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111080204,0,0,1110802,1007011132,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111080205,0,0,1110802,1007021132,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111080206,0,0,1110802,1007041132,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111080207,0,0,1110802,1003001132,1000,'[{1,163},{2,163},{4,163}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(111080208,0,0,1110802,1001011142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111080209,0,0,1110802,1001021142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111080210,0,0,1110802,1001041142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111080211,0,0,1110802,1007011142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111080212,0,0,1110802,1007021142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111080213,0,0,1110802,1007041142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(111080214,0,0,1110802,1003001142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112010001,0,0,1120100,1002011210,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(112010002,0,0,1120100,1002021210,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(112010003,0,0,1120100,1002041210,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(112010004,0,0,1120100,1004011210,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(112010005,0,0,1120100,1004021210,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(112010006,0,0,1120100,1004041210,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(112010007,0,0,1120100,1006011210,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(112010008,0,0,1120100,1006021210,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(112010009,0,0,1120100,1006041210,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(112010010,0,0,1120100,1008011210,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(112010011,0,0,1120100,1008021210,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(112010012,0,0,1120100,1008041210,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(112010013,0,0,1120100,1010011210,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(112010014,0,0,1120100,1010021210,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(112010015,0,0,1120100,1010041210,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(112010016,0,0,1120100,1001011210,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(112010017,0,0,1120100,1001021210,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000201','0',0,'[]',0,0,0,0,'[]'),(112010018,0,0,1120100,1001041210,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000401','0',0,'[]',0,0,0,0,'[]'),(112010019,0,0,1120100,1007011210,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(112010020,0,0,1120100,1007021210,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000207','0',0,'[]',0,0,0,0,'[]'),(112010021,0,0,1120100,1007041210,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000407','0',0,'[]',0,0,0,0,'[]'),(112010022,0,0,1120100,1003001210,300,'[{1,75},{2,75},{4,75}]',1,1,'[]',0,'1000003','0',0,'[]',0,0,0,0,'[]'),(112010023,0,0,1120100,1002011220,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(112010024,0,0,1120100,1002021220,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(112010025,0,0,1120100,1002041220,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(112010026,0,0,1120100,1004011220,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(112010027,0,0,1120100,1004021220,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(112010028,0,0,1120100,1004041220,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(112010029,0,0,1120100,1006011220,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(112010030,0,0,1120100,1006021220,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(112010031,0,0,1120100,1006041220,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(112010032,0,0,1120100,1008011220,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(112010033,0,0,1120100,1008021220,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(112010034,0,0,1120100,1008041220,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(112010035,0,0,1120100,1010011220,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(112010036,0,0,1120100,1010021220,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(112010037,0,0,1120100,1010041220,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(112010038,0,0,1120100,1001011220,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(112010039,0,0,1120100,1001021220,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000201','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(112010040,0,0,1120100,1001041220,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000401','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(112010041,0,0,1120100,1007011220,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(112010042,0,0,1120100,1007021220,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000207','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(112010043,0,0,1120100,1007041220,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000407','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(112010044,0,0,1120100,1003001220,300,'[{1,75},{2,75},{4,75}]',1,1,'[]',0,'1000003','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(112020001,0,0,1120200,1002011231,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(112020002,0,0,1120200,1002021231,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(112020003,0,0,1120200,1002041231,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(112020004,0,0,1120200,1004011231,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(112020005,0,0,1120200,1004021231,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(112020006,0,0,1120200,1004041231,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(112020007,0,0,1120200,1006011231,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(112020008,0,0,1120200,1006021231,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(112020009,0,0,1120200,1006041231,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(112020010,0,0,1120200,1008011231,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(112020011,0,0,1120200,1008021231,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(112020012,0,0,1120200,1008041231,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(112020013,0,0,1120200,1010011231,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(112020014,0,0,1120200,1010021231,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(112020015,0,0,1120200,1010041231,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(112020016,0,0,1120200,1001011231,1000,'[{1,50},{2,25},{4,25}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(112020017,0,0,1120200,1001021231,1000,'[{1,25},{2,50},{4,25}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(112020018,0,0,1120200,1001041231,1000,'[{1,25},{2,25},{4,50}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(112020019,0,0,1120200,1007011231,1000,'[{1,50},{2,25},{4,25}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(112020020,0,0,1120200,1007021231,1000,'[{1,25},{2,50},{4,25}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(112020021,0,0,1120200,1007041231,1000,'[{1,25},{2,25},{4,50}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(112020022,0,0,1120200,1003001231,1000,'[{1,25},{2,25},{4,25}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(112020023,0,0,1120200,1002011241,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(112020024,0,0,1120200,1002021241,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(112020025,0,0,1120200,1002041241,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(112020026,0,0,1120200,1004011241,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(112020027,0,0,1120200,1004021241,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(112020028,0,0,1120200,1004041241,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(112020029,0,0,1120200,1006011241,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(112020030,0,0,1120200,1006021241,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(112020031,0,0,1120200,1006041241,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(112020032,0,0,1120200,1008011241,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(112020033,0,0,1120200,1008021241,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(112020034,0,0,1120200,1008041241,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(112020035,0,0,1120200,1010011241,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(112020036,0,0,1120200,1010021241,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(112020037,0,0,1120200,1010041241,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(112020038,0,0,1120200,1001011241,1000,'[{1,20},{2,10},{4,10}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(112020039,0,0,1120200,1001021241,1000,'[{1,10},{2,20},{4,10}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[]',0,0,0,0,'[]'),(112020040,0,0,1120200,1001041241,1000,'[{1,10},{2,10},{4,20}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[]',0,0,0,0,'[]'),(112020041,0,0,1120200,1007011241,1000,'[{1,20},{2,10},{4,10}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(112020042,0,0,1120200,1007021241,1000,'[{1,10},{2,20},{4,10}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[]',0,0,0,0,'[]'),(112020043,0,0,1120200,1007041241,1000,'[{1,10},{2,10},{4,20}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[]',0,0,0,0,'[]'),(112020044,0,0,1120200,1003001241,1000,'[{1,10},{2,10},{4,10}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[]',0,0,0,0,'[]'),(112030101,0,0,1120301,1002011232,1000,'[{1,152},{2,76},{4,76}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112030102,0,0,1120301,1002021232,1000,'[{1,76},{2,152},{4,76}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112030103,0,0,1120301,1002041232,1000,'[{1,76},{2,76},{4,152}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112030104,0,0,1120301,1004011232,1000,'[{1,152},{2,76},{4,76}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112030105,0,0,1120301,1004021232,1000,'[{1,76},{2,152},{4,76}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112030106,0,0,1120301,1004041232,1000,'[{1,76},{2,76},{4,152}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112030107,0,0,1120301,1006011232,1000,'[{1,152},{2,76},{4,76}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112030108,0,0,1120301,1006021232,1000,'[{1,76},{2,152},{4,76}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112030109,0,0,1120301,1006041232,1000,'[{1,76},{2,76},{4,152}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112030110,0,0,1120301,1008011232,1000,'[{1,152},{2,76},{4,76}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112030111,0,0,1120301,1008021232,1000,'[{1,76},{2,152},{4,76}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112030112,0,0,1120301,1008041232,1000,'[{1,76},{2,76},{4,152}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112030113,0,0,1120301,1010011232,1000,'[{1,152},{2,76},{4,76}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112030114,0,0,1120301,1010021232,1000,'[{1,76},{2,152},{4,76}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112030115,0,0,1120301,1010041232,1000,'[{1,76},{2,76},{4,152}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112030116,0,0,1120301,1002011242,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112030117,0,0,1120301,1002021242,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112030118,0,0,1120301,1002041242,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112030119,0,0,1120301,1004011242,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112030120,0,0,1120301,1004021242,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112030121,0,0,1120301,1004041242,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112030122,0,0,1120301,1006011242,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112030123,0,0,1120301,1006021242,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112030124,0,0,1120301,1006041242,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112030125,0,0,1120301,1008011242,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112030126,0,0,1120301,1008021242,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112030127,0,0,1120301,1008041242,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112030128,0,0,1120301,1010011242,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112030129,0,0,1120301,1010021242,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112030130,0,0,1120301,1010041242,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112030201,0,0,1120302,1001011232,1000,'[{1,76},{2,38},{4,38}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112030202,0,0,1120302,1001021232,1000,'[{1,38},{2,76},{4,38}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112030203,0,0,1120302,1001041232,1000,'[{1,38},{2,38},{4,76}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112030204,0,0,1120302,1007011232,1000,'[{1,76},{2,38},{4,38}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112030205,0,0,1120302,1007021232,1000,'[{1,38},{2,76},{4,38}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112030206,0,0,1120302,1007041232,1000,'[{1,38},{2,38},{4,76}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112030207,0,0,1120302,1003001232,1000,'[{1,38},{2,38},{4,38}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112030208,0,0,1120302,1001011242,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112030209,0,0,1120302,1001021242,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112030210,0,0,1120302,1001041242,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112030211,0,0,1120302,1007011242,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112030212,0,0,1120302,1007021242,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112030213,0,0,1120302,1007041242,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112030214,0,0,1120302,1003001242,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112040101,0,0,1120401,1002011232,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112040102,0,0,1120401,1002021232,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112040103,0,0,1120401,1002041232,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112040104,0,0,1120401,1004011232,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112040105,0,0,1120401,1004021232,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112040106,0,0,1120401,1004041232,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112040107,0,0,1120401,1006011232,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112040108,0,0,1120401,1006021232,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112040109,0,0,1120401,1006041232,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112040110,0,0,1120401,1008011232,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112040111,0,0,1120401,1008021232,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112040112,0,0,1120401,1008041232,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112040113,0,0,1120401,1010011232,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112040114,0,0,1120401,1010021232,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112040115,0,0,1120401,1010041232,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112040116,0,0,1120401,1002011242,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112040117,0,0,1120401,1002021242,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112040118,0,0,1120401,1002041242,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112040119,0,0,1120401,1004011242,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112040120,0,0,1120401,1004021242,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112040121,0,0,1120401,1004041242,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112040122,0,0,1120401,1006011242,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112040123,0,0,1120401,1006021242,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112040124,0,0,1120401,1006041242,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112040125,0,0,1120401,1008011242,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112040126,0,0,1120401,1008021242,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112040127,0,0,1120401,1008041242,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112040128,0,0,1120401,1010011242,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112040129,0,0,1120401,1010021242,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112040130,0,0,1120401,1010041242,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112040201,0,0,1120402,1001011232,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112040202,0,0,1120402,1001021232,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112040203,0,0,1120402,1001041232,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112040204,0,0,1120402,1007011232,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112040205,0,0,1120402,1007021232,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112040206,0,0,1120402,1007041232,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112040207,0,0,1120402,1003001232,1000,'[{1,60},{2,60},{4,60}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112040208,0,0,1120402,1001011242,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112040209,0,0,1120402,1001021242,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112040210,0,0,1120402,1001041242,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112040211,0,0,1120402,1007011242,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112040212,0,0,1120402,1007021242,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112040213,0,0,1120402,1007041242,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112040214,0,0,1120402,1003001242,1000,'[{1,60},{2,60},{4,60}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112050101,0,0,1120501,1002011232,1000,'[{1,285},{2,143},{4,143}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112050102,0,0,1120501,1002021232,1000,'[{1,143},{2,285},{4,143}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112050103,0,0,1120501,1002041232,1000,'[{1,143},{2,143},{4,285}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112050104,0,0,1120501,1004011232,1000,'[{1,285},{2,143},{4,143}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112050105,0,0,1120501,1004021232,1000,'[{1,143},{2,285},{4,143}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112050106,0,0,1120501,1004041232,1000,'[{1,143},{2,143},{4,285}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112050107,0,0,1120501,1006011232,1000,'[{1,285},{2,143},{4,143}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112050108,0,0,1120501,1006021232,1000,'[{1,143},{2,285},{4,143}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112050109,0,0,1120501,1006041232,1000,'[{1,143},{2,143},{4,285}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112050110,0,0,1120501,1008011232,1000,'[{1,285},{2,143},{4,143}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112050111,0,0,1120501,1008021232,1000,'[{1,143},{2,285},{4,143}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112050112,0,0,1120501,1008041232,1000,'[{1,143},{2,143},{4,285}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112050113,0,0,1120501,1010011232,1000,'[{1,285},{2,143},{4,143}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112050114,0,0,1120501,1010021232,1000,'[{1,143},{2,285},{4,143}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112050115,0,0,1120501,1010041232,1000,'[{1,143},{2,143},{4,285}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112050116,0,0,1120501,1002011242,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112050117,0,0,1120501,1002021242,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112050118,0,0,1120501,1002041242,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112050119,0,0,1120501,1004011242,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112050120,0,0,1120501,1004021242,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112050121,0,0,1120501,1004041242,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112050122,0,0,1120501,1006011242,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112050123,0,0,1120501,1006021242,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112050124,0,0,1120501,1006041242,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112050125,0,0,1120501,1008011242,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112050126,0,0,1120501,1008021242,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112050127,0,0,1120501,1008041242,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112050128,0,0,1120501,1010011242,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112050129,0,0,1120501,1010021242,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112050130,0,0,1120501,1010041242,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112050201,0,0,1120502,1001011232,1000,'[{1,143},{2,71},{4,71}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112050202,0,0,1120502,1001021232,1000,'[{1,71},{2,143},{4,71}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112050203,0,0,1120502,1001041232,1000,'[{1,71},{2,71},{4,143}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112050204,0,0,1120502,1007011232,1000,'[{1,143},{2,71},{4,71}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112050205,0,0,1120502,1007021232,1000,'[{1,71},{2,143},{4,71}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112050206,0,0,1120502,1007041232,1000,'[{1,71},{2,71},{4,143}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112050207,0,0,1120502,1003001232,1000,'[{1,71},{2,71},{4,71}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112050208,0,0,1120502,1001011242,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112050209,0,0,1120502,1001021242,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112050210,0,0,1120502,1001041242,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112050211,0,0,1120502,1007011242,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112050212,0,0,1120502,1007021242,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112050213,0,0,1120502,1007041242,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112050214,0,0,1120502,1003001242,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112060101,0,0,1120601,1002011232,1000,'[{1,75},{2,38},{4,38}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112060102,0,0,1120601,1002021232,1000,'[{1,38},{2,75},{4,38}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112060103,0,0,1120601,1002041232,1000,'[{1,38},{2,38},{4,75}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112060104,0,0,1120601,1004011232,1000,'[{1,75},{2,38},{4,38}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112060105,0,0,1120601,1004021232,1000,'[{1,38},{2,75},{4,38}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112060106,0,0,1120601,1004041232,1000,'[{1,38},{2,38},{4,75}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112060107,0,0,1120601,1006011232,1000,'[{1,75},{2,38},{4,38}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112060108,0,0,1120601,1006021232,1000,'[{1,38},{2,75},{4,38}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112060109,0,0,1120601,1006041232,1000,'[{1,38},{2,38},{4,75}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112060110,0,0,1120601,1008011232,1000,'[{1,75},{2,38},{4,38}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112060111,0,0,1120601,1008021232,1000,'[{1,38},{2,75},{4,38}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112060112,0,0,1120601,1008041232,1000,'[{1,38},{2,38},{4,75}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112060113,0,0,1120601,1010011232,1000,'[{1,75},{2,38},{4,38}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112060114,0,0,1120601,1010021232,1000,'[{1,38},{2,75},{4,38}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112060115,0,0,1120601,1010041232,1000,'[{1,38},{2,38},{4,75}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112060116,0,0,1120601,1002011242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112060117,0,0,1120601,1002021242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112060118,0,0,1120601,1002041242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112060119,0,0,1120601,1004011242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112060120,0,0,1120601,1004021242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112060121,0,0,1120601,1004041242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112060122,0,0,1120601,1006011242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112060123,0,0,1120601,1006021242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112060124,0,0,1120601,1006041242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112060125,0,0,1120601,1008011242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112060126,0,0,1120601,1008021242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112060127,0,0,1120601,1008041242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112060128,0,0,1120601,1010011242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112060129,0,0,1120601,1010021242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112060130,0,0,1120601,1010041242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112060201,0,0,1120602,1001011232,1000,'[{1,38},{2,19},{4,19}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112060202,0,0,1120602,1001021232,1000,'[{1,19},{2,38},{4,19}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112060203,0,0,1120602,1001041232,1000,'[{1,19},{2,19},{4,38}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112060204,0,0,1120602,1007011232,1000,'[{1,38},{2,19},{4,19}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112060205,0,0,1120602,1007021232,1000,'[{1,19},{2,38},{4,19}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112060206,0,0,1120602,1007041232,1000,'[{1,19},{2,19},{4,38}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112060207,0,0,1120602,1003001232,1000,'[{1,19},{2,19},{4,19}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112060208,0,0,1120602,1001011242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112060209,0,0,1120602,1001021242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112060210,0,0,1120602,1001041242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112060211,0,0,1120602,1007011242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112060212,0,0,1120602,1007021242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112060213,0,0,1120602,1007041242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112060214,0,0,1120602,1003001242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112070101,0,0,1120701,1002011232,1000,'[{1,85},{2,43},{4,43}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112070102,0,0,1120701,1002021232,1000,'[{1,43},{2,85},{4,43}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112070103,0,0,1120701,1002041232,1000,'[{1,43},{2,43},{4,85}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112070104,0,0,1120701,1004011232,1000,'[{1,85},{2,43},{4,43}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112070105,0,0,1120701,1004021232,1000,'[{1,43},{2,85},{4,43}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112070106,0,0,1120701,1004041232,1000,'[{1,43},{2,43},{4,85}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112070107,0,0,1120701,1006011232,1000,'[{1,85},{2,43},{4,43}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112070108,0,0,1120701,1006021232,1000,'[{1,43},{2,85},{4,43}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112070109,0,0,1120701,1006041232,1000,'[{1,43},{2,43},{4,85}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112070110,0,0,1120701,1008011232,1000,'[{1,85},{2,43},{4,43}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112070111,0,0,1120701,1008021232,1000,'[{1,43},{2,85},{4,43}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112070112,0,0,1120701,1008041232,1000,'[{1,43},{2,43},{4,85}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112070113,0,0,1120701,1010011232,1000,'[{1,85},{2,43},{4,43}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112070114,0,0,1120701,1010021232,1000,'[{1,43},{2,85},{4,43}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112070115,0,0,1120701,1010041232,1000,'[{1,43},{2,43},{4,85}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112070116,0,0,1120701,1002011242,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112070117,0,0,1120701,1002021242,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112070118,0,0,1120701,1002041242,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112070119,0,0,1120701,1004011242,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112070120,0,0,1120701,1004021242,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112070121,0,0,1120701,1004041242,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112070122,0,0,1120701,1006011242,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112070123,0,0,1120701,1006021242,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112070124,0,0,1120701,1006041242,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112070125,0,0,1120701,1008011242,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112070126,0,0,1120701,1008021242,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112070127,0,0,1120701,1008041242,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112070128,0,0,1120701,1010011242,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112070129,0,0,1120701,1010021242,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112070130,0,0,1120701,1010041242,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112070201,0,0,1120702,1001011232,1000,'[{1,68},{2,34},{4,34}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112070202,0,0,1120702,1001021232,1000,'[{1,34},{2,68},{4,34}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112070203,0,0,1120702,1001041232,1000,'[{1,34},{2,34},{4,68}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112070204,0,0,1120702,1007011232,1000,'[{1,68},{2,34},{4,34}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112070205,0,0,1120702,1007021232,1000,'[{1,34},{2,68},{4,34}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112070206,0,0,1120702,1007041232,1000,'[{1,34},{2,34},{4,68}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112070207,0,0,1120702,1003001232,1000,'[{1,34},{2,34},{4,34}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112070208,0,0,1120702,1001011242,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112070209,0,0,1120702,1001021242,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112070210,0,0,1120702,1001041242,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112070211,0,0,1120702,1007011242,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112070212,0,0,1120702,1007021242,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112070213,0,0,1120702,1007041242,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112070214,0,0,1120702,1003001242,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112080101,0,0,1120801,1002011232,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112080102,0,0,1120801,1002021232,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112080103,0,0,1120801,1002041232,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112080104,0,0,1120801,1004011232,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112080105,0,0,1120801,1004021232,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112080106,0,0,1120801,1004041232,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112080107,0,0,1120801,1006011232,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112080108,0,0,1120801,1006021232,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112080109,0,0,1120801,1006041232,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112080110,0,0,1120801,1008011232,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112080111,0,0,1120801,1008021232,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112080112,0,0,1120801,1008041232,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112080113,0,0,1120801,1010011232,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112080114,0,0,1120801,1010021232,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112080115,0,0,1120801,1010041232,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112080116,0,0,1120801,1002011242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112080117,0,0,1120801,1002021242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112080118,0,0,1120801,1002041242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112080119,0,0,1120801,1004011242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112080120,0,0,1120801,1004021242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112080121,0,0,1120801,1004041242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112080122,0,0,1120801,1006011242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112080123,0,0,1120801,1006021242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112080124,0,0,1120801,1006041242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112080125,0,0,1120801,1008011242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112080126,0,0,1120801,1008021242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112080127,0,0,1120801,1008041242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112080128,0,0,1120801,1010011242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112080129,0,0,1120801,1010021242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112080130,0,0,1120801,1010041242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112080201,0,0,1120802,1001011232,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112080202,0,0,1120802,1001021232,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112080203,0,0,1120802,1001041232,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112080204,0,0,1120802,1007011232,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112080205,0,0,1120802,1007021232,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112080206,0,0,1120802,1007041232,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112080207,0,0,1120802,1003001232,1000,'[{1,163},{2,163},{4,163}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(112080208,0,0,1120802,1001011242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112080209,0,0,1120802,1001021242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112080210,0,0,1120802,1001041242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112080211,0,0,1120802,1007011242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112080212,0,0,1120802,1007021242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112080213,0,0,1120802,1007041242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(112080214,0,0,1120802,1003001242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113010001,0,0,1130100,1002011310,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(113010002,0,0,1130100,1002021310,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(113010003,0,0,1130100,1002041310,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(113010004,0,0,1130100,1004011310,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(113010005,0,0,1130100,1004021310,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(113010006,0,0,1130100,1004041310,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(113010007,0,0,1130100,1006011310,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(113010008,0,0,1130100,1006021310,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(113010009,0,0,1130100,1006041310,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(113010010,0,0,1130100,1008011310,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(113010011,0,0,1130100,1008021310,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(113010012,0,0,1130100,1008041310,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(113010013,0,0,1130100,1010011310,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(113010014,0,0,1130100,1010021310,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(113010015,0,0,1130100,1010041310,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(113010016,0,0,1130100,1001011310,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(113010017,0,0,1130100,1001021310,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000201','0',0,'[]',0,0,0,0,'[]'),(113010018,0,0,1130100,1001041310,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000401','0',0,'[]',0,0,0,0,'[]'),(113010019,0,0,1130100,1007011310,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(113010020,0,0,1130100,1007021310,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000207','0',0,'[]',0,0,0,0,'[]'),(113010021,0,0,1130100,1007041310,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000407','0',0,'[]',0,0,0,0,'[]'),(113010022,0,0,1130100,1003001310,300,'[{1,75},{2,75},{4,75}]',1,1,'[]',0,'1000003','0',0,'[]',0,0,0,0,'[]'),(113010023,0,0,1130100,1002011320,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(113010024,0,0,1130100,1002021320,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(113010025,0,0,1130100,1002041320,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(113010026,0,0,1130100,1004011320,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(113010027,0,0,1130100,1004021320,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(113010028,0,0,1130100,1004041320,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(113010029,0,0,1130100,1006011320,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(113010030,0,0,1130100,1006021320,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(113010031,0,0,1130100,1006041320,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(113010032,0,0,1130100,1008011320,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(113010033,0,0,1130100,1008021320,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(113010034,0,0,1130100,1008041320,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(113010035,0,0,1130100,1010011320,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(113010036,0,0,1130100,1010021320,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(113010037,0,0,1130100,1010041320,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(113010038,0,0,1130100,1001011320,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(113010039,0,0,1130100,1001021320,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000201','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(113010040,0,0,1130100,1001041320,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000401','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(113010041,0,0,1130100,1007011320,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(113010042,0,0,1130100,1007021320,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000207','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(113010043,0,0,1130100,1007041320,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000407','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(113010044,0,0,1130100,1003001320,300,'[{1,75},{2,75},{4,75}]',1,1,'[]',0,'1000003','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(113020001,0,0,1130200,1002011331,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(113020002,0,0,1130200,1002021331,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(113020003,0,0,1130200,1002041331,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(113020004,0,0,1130200,1004011331,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(113020005,0,0,1130200,1004021331,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(113020006,0,0,1130200,1004041331,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(113020007,0,0,1130200,1006011331,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(113020008,0,0,1130200,1006021331,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(113020009,0,0,1130200,1006041331,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(113020010,0,0,1130200,1008011331,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(113020011,0,0,1130200,1008021331,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(113020012,0,0,1130200,1008041331,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(113020013,0,0,1130200,1010011331,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(113020014,0,0,1130200,1010021331,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(113020015,0,0,1130200,1010041331,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(113020016,0,0,1130200,1001011331,1000,'[{1,50},{2,25},{4,25}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(113020017,0,0,1130200,1001021331,1000,'[{1,25},{2,50},{4,25}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(113020018,0,0,1130200,1001041331,1000,'[{1,25},{2,25},{4,50}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(113020019,0,0,1130200,1007011331,1000,'[{1,50},{2,25},{4,25}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(113020020,0,0,1130200,1007021331,1000,'[{1,25},{2,50},{4,25}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(113020021,0,0,1130200,1007041331,1000,'[{1,25},{2,25},{4,50}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(113020022,0,0,1130200,1003001331,1000,'[{1,25},{2,25},{4,25}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(113020023,0,0,1130200,1002011341,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(113020024,0,0,1130200,1002021341,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(113020025,0,0,1130200,1002041341,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(113020026,0,0,1130200,1004011341,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(113020027,0,0,1130200,1004021341,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(113020028,0,0,1130200,1004041341,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(113020029,0,0,1130200,1006011341,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(113020030,0,0,1130200,1006021341,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(113020031,0,0,1130200,1006041341,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(113020032,0,0,1130200,1008011341,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(113020033,0,0,1130200,1008021341,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(113020034,0,0,1130200,1008041341,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(113020035,0,0,1130200,1010011341,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(113020036,0,0,1130200,1010021341,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(113020037,0,0,1130200,1010041341,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(113020038,0,0,1130200,1001011341,1000,'[{1,20},{2,10},{4,10}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(113020039,0,0,1130200,1001021341,1000,'[{1,10},{2,20},{4,10}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[]',0,0,0,0,'[]'),(113020040,0,0,1130200,1001041341,1000,'[{1,10},{2,10},{4,20}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[]',0,0,0,0,'[]'),(113020041,0,0,1130200,1007011341,1000,'[{1,20},{2,10},{4,10}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(113020042,0,0,1130200,1007021341,1000,'[{1,10},{2,20},{4,10}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[]',0,0,0,0,'[]'),(113020043,0,0,1130200,1007041341,1000,'[{1,10},{2,10},{4,20}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[]',0,0,0,0,'[]'),(113020044,0,0,1130200,1003001341,1000,'[{1,10},{2,10},{4,10}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[]',0,0,0,0,'[]'),(113030101,0,0,1130301,1002011332,1000,'[{1,152},{2,76},{4,76}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113030102,0,0,1130301,1002021332,1000,'[{1,76},{2,152},{4,76}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113030103,0,0,1130301,1002041332,1000,'[{1,76},{2,76},{4,152}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113030104,0,0,1130301,1004011332,1000,'[{1,152},{2,76},{4,76}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113030105,0,0,1130301,1004021332,1000,'[{1,76},{2,152},{4,76}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113030106,0,0,1130301,1004041332,1000,'[{1,76},{2,76},{4,152}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113030107,0,0,1130301,1006011332,1000,'[{1,152},{2,76},{4,76}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113030108,0,0,1130301,1006021332,1000,'[{1,76},{2,152},{4,76}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113030109,0,0,1130301,1006041332,1000,'[{1,76},{2,76},{4,152}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113030110,0,0,1130301,1008011332,1000,'[{1,152},{2,76},{4,76}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113030111,0,0,1130301,1008021332,1000,'[{1,76},{2,152},{4,76}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113030112,0,0,1130301,1008041332,1000,'[{1,76},{2,76},{4,152}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113030113,0,0,1130301,1010011332,1000,'[{1,152},{2,76},{4,76}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113030114,0,0,1130301,1010021332,1000,'[{1,76},{2,152},{4,76}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113030115,0,0,1130301,1010041332,1000,'[{1,76},{2,76},{4,152}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113030116,0,0,1130301,1002011342,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113030117,0,0,1130301,1002021342,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113030118,0,0,1130301,1002041342,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113030119,0,0,1130301,1004011342,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113030120,0,0,1130301,1004021342,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113030121,0,0,1130301,1004041342,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113030122,0,0,1130301,1006011342,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113030123,0,0,1130301,1006021342,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113030124,0,0,1130301,1006041342,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113030125,0,0,1130301,1008011342,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113030126,0,0,1130301,1008021342,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113030127,0,0,1130301,1008041342,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113030128,0,0,1130301,1010011342,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113030129,0,0,1130301,1010021342,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113030130,0,0,1130301,1010041342,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113030201,0,0,1130302,1001011332,1000,'[{1,76},{2,38},{4,38}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113030202,0,0,1130302,1001021332,1000,'[{1,38},{2,76},{4,38}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113030203,0,0,1130302,1001041332,1000,'[{1,38},{2,38},{4,76}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113030204,0,0,1130302,1007011332,1000,'[{1,76},{2,38},{4,38}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113030205,0,0,1130302,1007021332,1000,'[{1,38},{2,76},{4,38}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113030206,0,0,1130302,1007041332,1000,'[{1,38},{2,38},{4,76}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113030207,0,0,1130302,1003001332,1000,'[{1,38},{2,38},{4,38}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113030208,0,0,1130302,1001011342,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113030209,0,0,1130302,1001021342,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113030210,0,0,1130302,1001041342,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113030211,0,0,1130302,1007011342,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113030212,0,0,1130302,1007021342,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113030213,0,0,1130302,1007041342,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113030214,0,0,1130302,1003001342,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113040101,0,0,1130401,1002011332,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113040102,0,0,1130401,1002021332,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113040103,0,0,1130401,1002041332,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113040104,0,0,1130401,1004011332,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113040105,0,0,1130401,1004021332,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113040106,0,0,1130401,1004041332,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113040107,0,0,1130401,1006011332,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113040108,0,0,1130401,1006021332,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113040109,0,0,1130401,1006041332,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113040110,0,0,1130401,1008011332,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113040111,0,0,1130401,1008021332,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113040112,0,0,1130401,1008041332,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113040113,0,0,1130401,1010011332,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113040114,0,0,1130401,1010021332,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113040115,0,0,1130401,1010041332,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113040116,0,0,1130401,1002011342,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113040117,0,0,1130401,1002021342,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113040118,0,0,1130401,1002041342,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113040119,0,0,1130401,1004011342,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113040120,0,0,1130401,1004021342,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113040121,0,0,1130401,1004041342,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113040122,0,0,1130401,1006011342,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113040123,0,0,1130401,1006021342,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113040124,0,0,1130401,1006041342,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113040125,0,0,1130401,1008011342,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113040126,0,0,1130401,1008021342,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113040127,0,0,1130401,1008041342,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113040128,0,0,1130401,1010011342,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113040129,0,0,1130401,1010021342,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113040130,0,0,1130401,1010041342,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113040201,0,0,1130402,1001011332,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113040202,0,0,1130402,1001021332,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113040203,0,0,1130402,1001041332,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113040204,0,0,1130402,1007011332,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113040205,0,0,1130402,1007021332,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113040206,0,0,1130402,1007041332,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113040207,0,0,1130402,1003001332,1000,'[{1,60},{2,60},{4,60}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113040208,0,0,1130402,1001011342,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113040209,0,0,1130402,1001021342,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113040210,0,0,1130402,1001041342,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113040211,0,0,1130402,1007011342,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113040212,0,0,1130402,1007021342,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113040213,0,0,1130402,1007041342,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113040214,0,0,1130402,1003001342,1000,'[{1,60},{2,60},{4,60}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113050101,0,0,1130501,1002011332,1000,'[{1,285},{2,143},{4,143}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113050102,0,0,1130501,1002021332,1000,'[{1,143},{2,285},{4,143}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113050103,0,0,1130501,1002041332,1000,'[{1,143},{2,143},{4,285}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113050104,0,0,1130501,1004011332,1000,'[{1,285},{2,143},{4,143}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113050105,0,0,1130501,1004021332,1000,'[{1,143},{2,285},{4,143}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113050106,0,0,1130501,1004041332,1000,'[{1,143},{2,143},{4,285}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113050107,0,0,1130501,1006011332,1000,'[{1,285},{2,143},{4,143}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113050108,0,0,1130501,1006021332,1000,'[{1,143},{2,285},{4,143}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113050109,0,0,1130501,1006041332,1000,'[{1,143},{2,143},{4,285}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113050110,0,0,1130501,1008011332,1000,'[{1,285},{2,143},{4,143}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113050111,0,0,1130501,1008021332,1000,'[{1,143},{2,285},{4,143}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113050112,0,0,1130501,1008041332,1000,'[{1,143},{2,143},{4,285}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113050113,0,0,1130501,1010011332,1000,'[{1,285},{2,143},{4,143}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113050114,0,0,1130501,1010021332,1000,'[{1,143},{2,285},{4,143}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113050115,0,0,1130501,1010041332,1000,'[{1,143},{2,143},{4,285}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113050116,0,0,1130501,1002011342,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113050117,0,0,1130501,1002021342,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113050118,0,0,1130501,1002041342,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113050119,0,0,1130501,1004011342,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113050120,0,0,1130501,1004021342,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113050121,0,0,1130501,1004041342,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113050122,0,0,1130501,1006011342,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113050123,0,0,1130501,1006021342,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113050124,0,0,1130501,1006041342,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113050125,0,0,1130501,1008011342,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113050126,0,0,1130501,1008021342,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113050127,0,0,1130501,1008041342,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113050128,0,0,1130501,1010011342,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113050129,0,0,1130501,1010021342,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113050130,0,0,1130501,1010041342,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113050201,0,0,1130502,1001011332,1000,'[{1,143},{2,71},{4,71}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113050202,0,0,1130502,1001021332,1000,'[{1,71},{2,143},{4,71}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113050203,0,0,1130502,1001041332,1000,'[{1,71},{2,71},{4,143}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113050204,0,0,1130502,1007011332,1000,'[{1,143},{2,71},{4,71}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113050205,0,0,1130502,1007021332,1000,'[{1,71},{2,143},{4,71}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113050206,0,0,1130502,1007041332,1000,'[{1,71},{2,71},{4,143}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113050207,0,0,1130502,1003001332,1000,'[{1,71},{2,71},{4,71}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113050208,0,0,1130502,1001011342,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113050209,0,0,1130502,1001021342,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113050210,0,0,1130502,1001041342,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113050211,0,0,1130502,1007011342,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113050212,0,0,1130502,1007021342,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113050213,0,0,1130502,1007041342,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113050214,0,0,1130502,1003001342,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113060101,0,0,1130601,1002011332,1000,'[{1,75},{2,38},{4,38}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113060102,0,0,1130601,1002021332,1000,'[{1,38},{2,75},{4,38}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113060103,0,0,1130601,1002041332,1000,'[{1,38},{2,38},{4,75}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113060104,0,0,1130601,1004011332,1000,'[{1,75},{2,38},{4,38}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113060105,0,0,1130601,1004021332,1000,'[{1,38},{2,75},{4,38}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113060106,0,0,1130601,1004041332,1000,'[{1,38},{2,38},{4,75}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113060107,0,0,1130601,1006011332,1000,'[{1,75},{2,38},{4,38}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113060108,0,0,1130601,1006021332,1000,'[{1,38},{2,75},{4,38}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113060109,0,0,1130601,1006041332,1000,'[{1,38},{2,38},{4,75}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113060110,0,0,1130601,1008011332,1000,'[{1,75},{2,38},{4,38}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113060111,0,0,1130601,1008021332,1000,'[{1,38},{2,75},{4,38}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113060112,0,0,1130601,1008041332,1000,'[{1,38},{2,38},{4,75}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113060113,0,0,1130601,1010011332,1000,'[{1,75},{2,38},{4,38}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113060114,0,0,1130601,1010021332,1000,'[{1,38},{2,75},{4,38}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113060115,0,0,1130601,1010041332,1000,'[{1,38},{2,38},{4,75}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113060116,0,0,1130601,1002011342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113060117,0,0,1130601,1002021342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113060118,0,0,1130601,1002041342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113060119,0,0,1130601,1004011342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113060120,0,0,1130601,1004021342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113060121,0,0,1130601,1004041342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113060122,0,0,1130601,1006011342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113060123,0,0,1130601,1006021342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113060124,0,0,1130601,1006041342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113060125,0,0,1130601,1008011342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113060126,0,0,1130601,1008021342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113060127,0,0,1130601,1008041342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113060128,0,0,1130601,1010011342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113060129,0,0,1130601,1010021342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113060130,0,0,1130601,1010041342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113060201,0,0,1130602,1001011332,1000,'[{1,38},{2,19},{4,19}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113060202,0,0,1130602,1001021332,1000,'[{1,19},{2,38},{4,19}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113060203,0,0,1130602,1001041332,1000,'[{1,19},{2,19},{4,38}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113060204,0,0,1130602,1007011332,1000,'[{1,38},{2,19},{4,19}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113060205,0,0,1130602,1007021332,1000,'[{1,19},{2,38},{4,19}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113060206,0,0,1130602,1007041332,1000,'[{1,19},{2,19},{4,38}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113060207,0,0,1130602,1003001332,1000,'[{1,19},{2,19},{4,19}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113060208,0,0,1130602,1001011342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113060209,0,0,1130602,1001021342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113060210,0,0,1130602,1001041342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113060211,0,0,1130602,1007011342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113060212,0,0,1130602,1007021342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113060213,0,0,1130602,1007041342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113060214,0,0,1130602,1003001342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113070101,0,0,1130701,1002011332,1000,'[{1,85},{2,43},{4,43}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113070102,0,0,1130701,1002021332,1000,'[{1,43},{2,85},{4,43}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113070103,0,0,1130701,1002041332,1000,'[{1,43},{2,43},{4,85}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113070104,0,0,1130701,1004011332,1000,'[{1,85},{2,43},{4,43}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113070105,0,0,1130701,1004021332,1000,'[{1,43},{2,85},{4,43}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113070106,0,0,1130701,1004041332,1000,'[{1,43},{2,43},{4,85}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113070107,0,0,1130701,1006011332,1000,'[{1,85},{2,43},{4,43}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113070108,0,0,1130701,1006021332,1000,'[{1,43},{2,85},{4,43}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113070109,0,0,1130701,1006041332,1000,'[{1,43},{2,43},{4,85}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113070110,0,0,1130701,1008011332,1000,'[{1,85},{2,43},{4,43}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113070111,0,0,1130701,1008021332,1000,'[{1,43},{2,85},{4,43}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113070112,0,0,1130701,1008041332,1000,'[{1,43},{2,43},{4,85}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113070113,0,0,1130701,1010011332,1000,'[{1,85},{2,43},{4,43}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113070114,0,0,1130701,1010021332,1000,'[{1,43},{2,85},{4,43}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113070115,0,0,1130701,1010041332,1000,'[{1,43},{2,43},{4,85}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113070116,0,0,1130701,1002011342,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113070117,0,0,1130701,1002021342,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113070118,0,0,1130701,1002041342,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113070119,0,0,1130701,1004011342,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113070120,0,0,1130701,1004021342,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113070121,0,0,1130701,1004041342,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113070122,0,0,1130701,1006011342,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113070123,0,0,1130701,1006021342,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113070124,0,0,1130701,1006041342,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113070125,0,0,1130701,1008011342,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113070126,0,0,1130701,1008021342,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113070127,0,0,1130701,1008041342,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113070128,0,0,1130701,1010011342,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113070129,0,0,1130701,1010021342,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113070130,0,0,1130701,1010041342,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113070201,0,0,1130702,1001011332,1000,'[{1,68},{2,34},{4,34}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113070202,0,0,1130702,1001021332,1000,'[{1,34},{2,68},{4,34}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113070203,0,0,1130702,1001041332,1000,'[{1,34},{2,34},{4,68}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113070204,0,0,1130702,1007011332,1000,'[{1,68},{2,34},{4,34}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113070205,0,0,1130702,1007021332,1000,'[{1,34},{2,68},{4,34}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113070206,0,0,1130702,1007041332,1000,'[{1,34},{2,34},{4,68}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113070207,0,0,1130702,1003001332,1000,'[{1,34},{2,34},{4,34}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113070208,0,0,1130702,1001011342,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113070209,0,0,1130702,1001021342,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113070210,0,0,1130702,1001041342,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113070211,0,0,1130702,1007011342,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113070212,0,0,1130702,1007021342,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113070213,0,0,1130702,1007041342,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113070214,0,0,1130702,1003001342,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113080101,0,0,1130801,1002011332,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113080102,0,0,1130801,1002021332,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113080103,0,0,1130801,1002041332,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113080104,0,0,1130801,1004011332,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113080105,0,0,1130801,1004021332,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113080106,0,0,1130801,1004041332,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113080107,0,0,1130801,1006011332,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113080108,0,0,1130801,1006021332,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113080109,0,0,1130801,1006041332,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113080110,0,0,1130801,1008011332,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113080111,0,0,1130801,1008021332,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113080112,0,0,1130801,1008041332,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113080113,0,0,1130801,1010011332,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113080114,0,0,1130801,1010021332,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113080115,0,0,1130801,1010041332,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113080116,0,0,1130801,1002011342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113080117,0,0,1130801,1002021342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113080118,0,0,1130801,1002041342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113080119,0,0,1130801,1004011342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113080120,0,0,1130801,1004021342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113080121,0,0,1130801,1004041342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113080122,0,0,1130801,1006011342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113080123,0,0,1130801,1006021342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113080124,0,0,1130801,1006041342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113080125,0,0,1130801,1008011342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113080126,0,0,1130801,1008021342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113080127,0,0,1130801,1008041342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113080128,0,0,1130801,1010011342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113080129,0,0,1130801,1010021342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113080130,0,0,1130801,1010041342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113080201,0,0,1130802,1001011332,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113080202,0,0,1130802,1001021332,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113080203,0,0,1130802,1001041332,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113080204,0,0,1130802,1007011332,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113080205,0,0,1130802,1007021332,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113080206,0,0,1130802,1007041332,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113080207,0,0,1130802,1003001332,1000,'[{1,163},{2,163},{4,163}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(113080208,0,0,1130802,1001011342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113080209,0,0,1130802,1001021342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113080210,0,0,1130802,1001041342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113080211,0,0,1130802,1007011342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113080212,0,0,1130802,1007021342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113080213,0,0,1130802,1007041342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(113080214,0,0,1130802,1003001342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114010001,0,0,1140100,1002011410,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(114010002,0,0,1140100,1002021410,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(114010003,0,0,1140100,1002041410,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(114010004,0,0,1140100,1004011410,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(114010005,0,0,1140100,1004021410,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(114010006,0,0,1140100,1004041410,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(114010007,0,0,1140100,1006011410,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(114010008,0,0,1140100,1006021410,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(114010009,0,0,1140100,1006041410,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(114010010,0,0,1140100,1008011410,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(114010011,0,0,1140100,1008021410,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(114010012,0,0,1140100,1008041410,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(114010013,0,0,1140100,1010011410,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(114010014,0,0,1140100,1010021410,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(114010015,0,0,1140100,1010041410,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(114010016,0,0,1140100,1001011410,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(114010017,0,0,1140100,1001021410,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000201','0',0,'[]',0,0,0,0,'[]'),(114010018,0,0,1140100,1001041410,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000401','0',0,'[]',0,0,0,0,'[]'),(114010019,0,0,1140100,1007011410,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(114010020,0,0,1140100,1007021410,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000207','0',0,'[]',0,0,0,0,'[]'),(114010021,0,0,1140100,1007041410,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000407','0',0,'[]',0,0,0,0,'[]'),(114010022,0,0,1140100,1003001410,300,'[{1,75},{2,75},{4,75}]',1,1,'[]',0,'1000003','0',0,'[]',0,0,0,0,'[]'),(114010023,0,0,1140100,1002011420,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(114010024,0,0,1140100,1002021420,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(114010025,0,0,1140100,1002041420,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(114010026,0,0,1140100,1004011420,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(114010027,0,0,1140100,1004021420,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(114010028,0,0,1140100,1004041420,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(114010029,0,0,1140100,1006011420,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(114010030,0,0,1140100,1006021420,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(114010031,0,0,1140100,1006041420,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(114010032,0,0,1140100,1008011420,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(114010033,0,0,1140100,1008021420,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(114010034,0,0,1140100,1008041420,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(114010035,0,0,1140100,1010011420,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(114010036,0,0,1140100,1010021420,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(114010037,0,0,1140100,1010041420,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(114010038,0,0,1140100,1001011420,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(114010039,0,0,1140100,1001021420,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000201','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(114010040,0,0,1140100,1001041420,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000401','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(114010041,0,0,1140100,1007011420,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(114010042,0,0,1140100,1007021420,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000207','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(114010043,0,0,1140100,1007041420,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000407','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(114010044,0,0,1140100,1003001420,300,'[{1,75},{2,75},{4,75}]',1,1,'[]',0,'1000003','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(114020001,0,0,1140200,1002011431,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(114020002,0,0,1140200,1002021431,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(114020003,0,0,1140200,1002041431,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(114020004,0,0,1140200,1004011431,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(114020005,0,0,1140200,1004021431,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(114020006,0,0,1140200,1004041431,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(114020007,0,0,1140200,1006011431,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(114020008,0,0,1140200,1006021431,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(114020009,0,0,1140200,1006041431,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(114020010,0,0,1140200,1008011431,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(114020011,0,0,1140200,1008021431,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(114020012,0,0,1140200,1008041431,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(114020013,0,0,1140200,1010011431,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(114020014,0,0,1140200,1010021431,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(114020015,0,0,1140200,1010041431,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(114020016,0,0,1140200,1001011431,1000,'[{1,50},{2,25},{4,25}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(114020017,0,0,1140200,1001021431,1000,'[{1,25},{2,50},{4,25}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(114020018,0,0,1140200,1001041431,1000,'[{1,25},{2,25},{4,50}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(114020019,0,0,1140200,1007011431,1000,'[{1,50},{2,25},{4,25}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(114020020,0,0,1140200,1007021431,1000,'[{1,25},{2,50},{4,25}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(114020021,0,0,1140200,1007041431,1000,'[{1,25},{2,25},{4,50}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(114020022,0,0,1140200,1003001431,1000,'[{1,25},{2,25},{4,25}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(114020023,0,0,1140200,1002011441,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(114020024,0,0,1140200,1002021441,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(114020025,0,0,1140200,1002041441,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(114020026,0,0,1140200,1004011441,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(114020027,0,0,1140200,1004021441,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(114020028,0,0,1140200,1004041441,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(114020029,0,0,1140200,1006011441,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(114020030,0,0,1140200,1006021441,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(114020031,0,0,1140200,1006041441,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(114020032,0,0,1140200,1008011441,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(114020033,0,0,1140200,1008021441,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(114020034,0,0,1140200,1008041441,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(114020035,0,0,1140200,1010011441,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(114020036,0,0,1140200,1010021441,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(114020037,0,0,1140200,1010041441,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(114020038,0,0,1140200,1001011441,1000,'[{1,20},{2,10},{4,10}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(114020039,0,0,1140200,1001021441,1000,'[{1,10},{2,20},{4,10}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[]',0,0,0,0,'[]'),(114020040,0,0,1140200,1001041441,1000,'[{1,10},{2,10},{4,20}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[]',0,0,0,0,'[]'),(114020041,0,0,1140200,1007011441,1000,'[{1,20},{2,10},{4,10}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(114020042,0,0,1140200,1007021441,1000,'[{1,10},{2,20},{4,10}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[]',0,0,0,0,'[]'),(114020043,0,0,1140200,1007041441,1000,'[{1,10},{2,10},{4,20}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[]',0,0,0,0,'[]'),(114020044,0,0,1140200,1003001441,1000,'[{1,10},{2,10},{4,10}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[]',0,0,0,0,'[]'),(114030101,0,0,1140301,1002011432,1000,'[{1,152},{2,76},{4,76}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114030102,0,0,1140301,1002021432,1000,'[{1,76},{2,152},{4,76}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114030103,0,0,1140301,1002041432,1000,'[{1,76},{2,76},{4,152}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114030104,0,0,1140301,1004011432,1000,'[{1,152},{2,76},{4,76}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114030105,0,0,1140301,1004021432,1000,'[{1,76},{2,152},{4,76}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114030106,0,0,1140301,1004041432,1000,'[{1,76},{2,76},{4,152}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114030107,0,0,1140301,1006011432,1000,'[{1,152},{2,76},{4,76}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114030108,0,0,1140301,1006021432,1000,'[{1,76},{2,152},{4,76}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114030109,0,0,1140301,1006041432,1000,'[{1,76},{2,76},{4,152}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114030110,0,0,1140301,1008011432,1000,'[{1,152},{2,76},{4,76}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114030111,0,0,1140301,1008021432,1000,'[{1,76},{2,152},{4,76}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114030112,0,0,1140301,1008041432,1000,'[{1,76},{2,76},{4,152}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114030113,0,0,1140301,1010011432,1000,'[{1,152},{2,76},{4,76}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114030114,0,0,1140301,1010021432,1000,'[{1,76},{2,152},{4,76}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114030115,0,0,1140301,1010041432,1000,'[{1,76},{2,76},{4,152}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114030116,0,0,1140301,1002011442,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114030117,0,0,1140301,1002021442,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114030118,0,0,1140301,1002041442,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114030119,0,0,1140301,1004011442,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114030120,0,0,1140301,1004021442,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114030121,0,0,1140301,1004041442,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114030122,0,0,1140301,1006011442,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114030123,0,0,1140301,1006021442,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114030124,0,0,1140301,1006041442,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114030125,0,0,1140301,1008011442,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114030126,0,0,1140301,1008021442,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114030127,0,0,1140301,1008041442,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114030128,0,0,1140301,1010011442,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114030129,0,0,1140301,1010021442,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114030130,0,0,1140301,1010041442,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114030201,0,0,1140302,1001011432,1000,'[{1,76},{2,38},{4,38}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114030202,0,0,1140302,1001021432,1000,'[{1,38},{2,76},{4,38}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114030203,0,0,1140302,1001041432,1000,'[{1,38},{2,38},{4,76}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114030204,0,0,1140302,1007011432,1000,'[{1,76},{2,38},{4,38}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114030205,0,0,1140302,1007021432,1000,'[{1,38},{2,76},{4,38}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114030206,0,0,1140302,1007041432,1000,'[{1,38},{2,38},{4,76}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114030207,0,0,1140302,1003001432,1000,'[{1,38},{2,38},{4,38}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114030208,0,0,1140302,1001011442,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114030209,0,0,1140302,1001021442,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114030210,0,0,1140302,1001041442,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114030211,0,0,1140302,1007011442,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114030212,0,0,1140302,1007021442,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114030213,0,0,1140302,1007041442,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114030214,0,0,1140302,1003001442,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114040101,0,0,1140401,1002011432,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114040102,0,0,1140401,1002021432,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114040103,0,0,1140401,1002041432,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114040104,0,0,1140401,1004011432,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114040105,0,0,1140401,1004021432,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114040106,0,0,1140401,1004041432,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114040107,0,0,1140401,1006011432,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114040108,0,0,1140401,1006021432,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114040109,0,0,1140401,1006041432,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114040110,0,0,1140401,1008011432,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114040111,0,0,1140401,1008021432,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114040112,0,0,1140401,1008041432,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114040113,0,0,1140401,1010011432,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114040114,0,0,1140401,1010021432,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114040115,0,0,1140401,1010041432,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114040116,0,0,1140401,1002011442,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114040117,0,0,1140401,1002021442,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114040118,0,0,1140401,1002041442,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114040119,0,0,1140401,1004011442,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114040120,0,0,1140401,1004021442,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114040121,0,0,1140401,1004041442,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114040122,0,0,1140401,1006011442,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114040123,0,0,1140401,1006021442,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114040124,0,0,1140401,1006041442,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114040125,0,0,1140401,1008011442,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114040126,0,0,1140401,1008021442,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114040127,0,0,1140401,1008041442,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114040128,0,0,1140401,1010011442,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114040129,0,0,1140401,1010021442,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114040130,0,0,1140401,1010041442,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114040201,0,0,1140402,1001011432,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114040202,0,0,1140402,1001021432,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114040203,0,0,1140402,1001041432,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114040204,0,0,1140402,1007011432,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114040205,0,0,1140402,1007021432,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114040206,0,0,1140402,1007041432,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114040207,0,0,1140402,1003001432,1000,'[{1,60},{2,60},{4,60}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114040208,0,0,1140402,1001011442,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114040209,0,0,1140402,1001021442,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114040210,0,0,1140402,1001041442,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114040211,0,0,1140402,1007011442,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114040212,0,0,1140402,1007021442,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114040213,0,0,1140402,1007041442,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114040214,0,0,1140402,1003001442,1000,'[{1,60},{2,60},{4,60}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114050101,0,0,1140501,1002011432,1000,'[{1,285},{2,143},{4,143}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114050102,0,0,1140501,1002021432,1000,'[{1,143},{2,285},{4,143}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114050103,0,0,1140501,1002041432,1000,'[{1,143},{2,143},{4,285}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114050104,0,0,1140501,1004011432,1000,'[{1,285},{2,143},{4,143}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114050105,0,0,1140501,1004021432,1000,'[{1,143},{2,285},{4,143}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114050106,0,0,1140501,1004041432,1000,'[{1,143},{2,143},{4,285}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114050107,0,0,1140501,1006011432,1000,'[{1,285},{2,143},{4,143}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114050108,0,0,1140501,1006021432,1000,'[{1,143},{2,285},{4,143}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114050109,0,0,1140501,1006041432,1000,'[{1,143},{2,143},{4,285}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114050110,0,0,1140501,1008011432,1000,'[{1,285},{2,143},{4,143}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114050111,0,0,1140501,1008021432,1000,'[{1,143},{2,285},{4,143}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114050112,0,0,1140501,1008041432,1000,'[{1,143},{2,143},{4,285}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114050113,0,0,1140501,1010011432,1000,'[{1,285},{2,143},{4,143}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114050114,0,0,1140501,1010021432,1000,'[{1,143},{2,285},{4,143}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114050115,0,0,1140501,1010041432,1000,'[{1,143},{2,143},{4,285}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114050116,0,0,1140501,1002011442,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114050117,0,0,1140501,1002021442,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114050118,0,0,1140501,1002041442,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114050119,0,0,1140501,1004011442,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114050120,0,0,1140501,1004021442,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114050121,0,0,1140501,1004041442,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114050122,0,0,1140501,1006011442,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114050123,0,0,1140501,1006021442,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114050124,0,0,1140501,1006041442,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114050125,0,0,1140501,1008011442,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114050126,0,0,1140501,1008021442,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114050127,0,0,1140501,1008041442,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114050128,0,0,1140501,1010011442,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114050129,0,0,1140501,1010021442,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114050130,0,0,1140501,1010041442,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114050201,0,0,1140502,1001011432,1000,'[{1,143},{2,71},{4,71}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114050202,0,0,1140502,1001021432,1000,'[{1,71},{2,143},{4,71}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114050203,0,0,1140502,1001041432,1000,'[{1,71},{2,71},{4,143}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114050204,0,0,1140502,1007011432,1000,'[{1,143},{2,71},{4,71}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114050205,0,0,1140502,1007021432,1000,'[{1,71},{2,143},{4,71}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114050206,0,0,1140502,1007041432,1000,'[{1,71},{2,71},{4,143}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114050207,0,0,1140502,1003001432,1000,'[{1,71},{2,71},{4,71}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114050208,0,0,1140502,1001011442,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114050209,0,0,1140502,1001021442,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114050210,0,0,1140502,1001041442,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114050211,0,0,1140502,1007011442,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114050212,0,0,1140502,1007021442,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114050213,0,0,1140502,1007041442,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114050214,0,0,1140502,1003001442,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114060101,0,0,1140601,1002011432,1000,'[{1,75},{2,38},{4,38}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114060102,0,0,1140601,1002021432,1000,'[{1,38},{2,75},{4,38}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114060103,0,0,1140601,1002041432,1000,'[{1,38},{2,38},{4,75}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114060104,0,0,1140601,1004011432,1000,'[{1,75},{2,38},{4,38}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114060105,0,0,1140601,1004021432,1000,'[{1,38},{2,75},{4,38}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114060106,0,0,1140601,1004041432,1000,'[{1,38},{2,38},{4,75}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114060107,0,0,1140601,1006011432,1000,'[{1,75},{2,38},{4,38}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114060108,0,0,1140601,1006021432,1000,'[{1,38},{2,75},{4,38}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114060109,0,0,1140601,1006041432,1000,'[{1,38},{2,38},{4,75}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114060110,0,0,1140601,1008011432,1000,'[{1,75},{2,38},{4,38}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114060111,0,0,1140601,1008021432,1000,'[{1,38},{2,75},{4,38}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114060112,0,0,1140601,1008041432,1000,'[{1,38},{2,38},{4,75}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114060113,0,0,1140601,1010011432,1000,'[{1,75},{2,38},{4,38}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114060114,0,0,1140601,1010021432,1000,'[{1,38},{2,75},{4,38}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114060115,0,0,1140601,1010041432,1000,'[{1,38},{2,38},{4,75}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114060116,0,0,1140601,1002011442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114060117,0,0,1140601,1002021442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114060118,0,0,1140601,1002041442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114060119,0,0,1140601,1004011442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114060120,0,0,1140601,1004021442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114060121,0,0,1140601,1004041442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114060122,0,0,1140601,1006011442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114060123,0,0,1140601,1006021442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114060124,0,0,1140601,1006041442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114060125,0,0,1140601,1008011442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114060126,0,0,1140601,1008021442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114060127,0,0,1140601,1008041442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114060128,0,0,1140601,1010011442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114060129,0,0,1140601,1010021442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114060130,0,0,1140601,1010041442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114060201,0,0,1140602,1001011432,1000,'[{1,38},{2,19},{4,19}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114060202,0,0,1140602,1001021432,1000,'[{1,19},{2,38},{4,19}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114060203,0,0,1140602,1001041432,1000,'[{1,19},{2,19},{4,38}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114060204,0,0,1140602,1007011432,1000,'[{1,38},{2,19},{4,19}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114060205,0,0,1140602,1007021432,1000,'[{1,19},{2,38},{4,19}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114060206,0,0,1140602,1007041432,1000,'[{1,19},{2,19},{4,38}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114060207,0,0,1140602,1003001432,1000,'[{1,19},{2,19},{4,19}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114060208,0,0,1140602,1001011442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114060209,0,0,1140602,1001021442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114060210,0,0,1140602,1001041442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114060211,0,0,1140602,1007011442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114060212,0,0,1140602,1007021442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114060213,0,0,1140602,1007041442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114060214,0,0,1140602,1003001442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114070101,0,0,1140701,1002011432,1000,'[{1,85},{2,43},{4,43}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114070102,0,0,1140701,1002021432,1000,'[{1,43},{2,85},{4,43}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114070103,0,0,1140701,1002041432,1000,'[{1,43},{2,43},{4,85}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114070104,0,0,1140701,1004011432,1000,'[{1,85},{2,43},{4,43}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114070105,0,0,1140701,1004021432,1000,'[{1,43},{2,85},{4,43}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114070106,0,0,1140701,1004041432,1000,'[{1,43},{2,43},{4,85}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114070107,0,0,1140701,1006011432,1000,'[{1,85},{2,43},{4,43}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114070108,0,0,1140701,1006021432,1000,'[{1,43},{2,85},{4,43}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114070109,0,0,1140701,1006041432,1000,'[{1,43},{2,43},{4,85}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114070110,0,0,1140701,1008011432,1000,'[{1,85},{2,43},{4,43}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114070111,0,0,1140701,1008021432,1000,'[{1,43},{2,85},{4,43}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114070112,0,0,1140701,1008041432,1000,'[{1,43},{2,43},{4,85}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114070113,0,0,1140701,1010011432,1000,'[{1,85},{2,43},{4,43}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114070114,0,0,1140701,1010021432,1000,'[{1,43},{2,85},{4,43}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114070115,0,0,1140701,1010041432,1000,'[{1,43},{2,43},{4,85}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114070116,0,0,1140701,1002011442,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114070117,0,0,1140701,1002021442,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114070118,0,0,1140701,1002041442,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114070119,0,0,1140701,1004011442,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114070120,0,0,1140701,1004021442,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114070121,0,0,1140701,1004041442,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114070122,0,0,1140701,1006011442,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114070123,0,0,1140701,1006021442,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114070124,0,0,1140701,1006041442,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114070125,0,0,1140701,1008011442,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114070126,0,0,1140701,1008021442,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114070127,0,0,1140701,1008041442,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114070128,0,0,1140701,1010011442,1000,'[{1,5},{2,3},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114070129,0,0,1140701,1010021442,1000,'[{1,3},{2,5},{4,3}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114070130,0,0,1140701,1010041442,1000,'[{1,3},{2,3},{4,5}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114070201,0,0,1140702,1001011432,1000,'[{1,68},{2,34},{4,34}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114070202,0,0,1140702,1001021432,1000,'[{1,34},{2,68},{4,34}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114070203,0,0,1140702,1001041432,1000,'[{1,34},{2,34},{4,68}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114070204,0,0,1140702,1007011432,1000,'[{1,68},{2,34},{4,34}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114070205,0,0,1140702,1007021432,1000,'[{1,34},{2,68},{4,34}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114070206,0,0,1140702,1007041432,1000,'[{1,34},{2,34},{4,68}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114070207,0,0,1140702,1003001432,1000,'[{1,34},{2,34},{4,34}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114070208,0,0,1140702,1001011442,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114070209,0,0,1140702,1001021442,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114070210,0,0,1140702,1001041442,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114070211,0,0,1140702,1007011442,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114070212,0,0,1140702,1007021442,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114070213,0,0,1140702,1007041442,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114070214,0,0,1140702,1003001442,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114080101,0,0,1140801,1002011432,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114080102,0,0,1140801,1002021432,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114080103,0,0,1140801,1002041432,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114080104,0,0,1140801,1004011432,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114080105,0,0,1140801,1004021432,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114080106,0,0,1140801,1004041432,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114080107,0,0,1140801,1006011432,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114080108,0,0,1140801,1006021432,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114080109,0,0,1140801,1006041432,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114080110,0,0,1140801,1008011432,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114080111,0,0,1140801,1008021432,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114080112,0,0,1140801,1008041432,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114080113,0,0,1140801,1010011432,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114080114,0,0,1140801,1010021432,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114080115,0,0,1140801,1010041432,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114080116,0,0,1140801,1002011442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114080117,0,0,1140801,1002021442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114080118,0,0,1140801,1002041442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114080119,0,0,1140801,1004011442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114080120,0,0,1140801,1004021442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114080121,0,0,1140801,1004041442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114080122,0,0,1140801,1006011442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114080123,0,0,1140801,1006021442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114080124,0,0,1140801,1006041442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114080125,0,0,1140801,1008011442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114080126,0,0,1140801,1008021442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114080127,0,0,1140801,1008041442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114080128,0,0,1140801,1010011442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114080129,0,0,1140801,1010021442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114080130,0,0,1140801,1010041442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114080201,0,0,1140802,1001011432,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114080202,0,0,1140802,1001021432,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114080203,0,0,1140802,1001041432,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114080204,0,0,1140802,1007011432,1000,'[{1,325},{2,163},{4,163}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114080205,0,0,1140802,1007021432,1000,'[{1,163},{2,325},{4,163}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114080206,0,0,1140802,1007041432,1000,'[{1,163},{2,163},{4,325}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114080207,0,0,1140802,1003001432,1000,'[{1,163},{2,163},{4,163}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(114080208,0,0,1140802,1001011442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114080209,0,0,1140802,1001021442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114080210,0,0,1140802,1001041442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114080211,0,0,1140802,1007011442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114080212,0,0,1140802,1007021442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114080213,0,0,1140802,1007041442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(114080214,0,0,1140802,1003001442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115010001,0,0,1150100,1002011510,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(115010002,0,0,1150100,1002021510,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(115010003,0,0,1150100,1002041510,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(115010004,0,0,1150100,1004011510,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(115010005,0,0,1150100,1004021510,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(115010006,0,0,1150100,1004041510,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(115010007,0,0,1150100,1006011510,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(115010008,0,0,1150100,1006021510,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(115010009,0,0,1150100,1006041510,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(115010010,0,0,1150100,1008011510,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(115010011,0,0,1150100,1008021510,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(115010012,0,0,1150100,1008041510,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(115010013,0,0,1150100,1010011510,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(115010014,0,0,1150100,1010021510,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(115010015,0,0,1150100,1010041510,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(115010016,0,0,1150100,1001011510,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(115010017,0,0,1150100,1001021510,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000201','0',0,'[]',0,0,0,0,'[]'),(115010018,0,0,1150100,1001041510,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000401','0',0,'[]',0,0,0,0,'[]'),(115010019,0,0,1150100,1007011510,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(115010020,0,0,1150100,1007021510,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000207','0',0,'[]',0,0,0,0,'[]'),(115010021,0,0,1150100,1007041510,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000407','0',0,'[]',0,0,0,0,'[]'),(115010022,0,0,1150100,1003001510,300,'[{1,75},{2,75},{4,75}]',1,1,'[]',0,'1000003','0',0,'[]',0,0,0,0,'[]'),(115010023,0,0,1150100,1002011520,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(115010024,0,0,1150100,1002021520,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(115010025,0,0,1150100,1002041520,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(115010026,0,0,1150100,1004011520,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(115010027,0,0,1150100,1004021520,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(115010028,0,0,1150100,1004041520,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(115010029,0,0,1150100,1006011520,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(115010030,0,0,1150100,1006021520,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(115010031,0,0,1150100,1006041520,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(115010032,0,0,1150100,1008011520,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(115010033,0,0,1150100,1008021520,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(115010034,0,0,1150100,1008041520,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(115010035,0,0,1150100,1010011520,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(115010036,0,0,1150100,1010021520,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(115010037,0,0,1150100,1010041520,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(115010038,0,0,1150100,1001011520,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(115010039,0,0,1150100,1001021520,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000201','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(115010040,0,0,1150100,1001041520,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000401','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(115010041,0,0,1150100,1007011520,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(115010042,0,0,1150100,1007021520,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000207','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(115010043,0,0,1150100,1007041520,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000407','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(115010044,0,0,1150100,1003001520,300,'[{1,75},{2,75},{4,75}]',1,1,'[]',0,'1000003','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(115020001,0,0,1150200,1002011531,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(115020002,0,0,1150200,1002021531,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(115020003,0,0,1150200,1002041531,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(115020004,0,0,1150200,1004011531,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(115020005,0,0,1150200,1004021531,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(115020006,0,0,1150200,1004041531,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(115020007,0,0,1150200,1006011531,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(115020008,0,0,1150200,1006021531,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(115020009,0,0,1150200,1006041531,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(115020010,0,0,1150200,1008011531,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(115020011,0,0,1150200,1008021531,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(115020012,0,0,1150200,1008041531,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(115020013,0,0,1150200,1010011531,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(115020014,0,0,1150200,1010021531,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(115020015,0,0,1150200,1010041531,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(115020016,0,0,1150200,1001011531,1000,'[{1,50},{2,25},{4,25}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(115020017,0,0,1150200,1001021531,1000,'[{1,25},{2,50},{4,25}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(115020018,0,0,1150200,1001041531,1000,'[{1,25},{2,25},{4,50}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(115020019,0,0,1150200,1007011531,1000,'[{1,50},{2,25},{4,25}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(115020020,0,0,1150200,1007021531,1000,'[{1,25},{2,50},{4,25}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(115020021,0,0,1150200,1007041531,1000,'[{1,25},{2,25},{4,50}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(115020022,0,0,1150200,1003001531,1000,'[{1,25},{2,25},{4,25}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(115020023,0,0,1150200,1002011541,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(115020024,0,0,1150200,1002021541,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(115020025,0,0,1150200,1002041541,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(115020026,0,0,1150200,1004011541,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(115020027,0,0,1150200,1004021541,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(115020028,0,0,1150200,1004041541,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(115020029,0,0,1150200,1006011541,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(115020030,0,0,1150200,1006021541,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(115020031,0,0,1150200,1006041541,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(115020032,0,0,1150200,1008011541,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(115020033,0,0,1150200,1008021541,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(115020034,0,0,1150200,1008041541,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(115020035,0,0,1150200,1010011541,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(115020036,0,0,1150200,1010021541,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(115020037,0,0,1150200,1010041541,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(115020038,0,0,1150200,1001011541,1000,'[{1,20},{2,10},{4,10}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(115020039,0,0,1150200,1001021541,1000,'[{1,10},{2,20},{4,10}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[]',0,0,0,0,'[]'),(115020040,0,0,1150200,1001041541,1000,'[{1,10},{2,10},{4,20}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[]',0,0,0,0,'[]'),(115020041,0,0,1150200,1007011541,1000,'[{1,20},{2,10},{4,10}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(115020042,0,0,1150200,1007021541,1000,'[{1,10},{2,20},{4,10}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[]',0,0,0,0,'[]'),(115020043,0,0,1150200,1007041541,1000,'[{1,10},{2,10},{4,20}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[]',0,0,0,0,'[]'),(115020044,0,0,1150200,1003001541,1000,'[{1,10},{2,10},{4,10}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[]',0,0,0,0,'[]'),(115030101,0,0,1150301,1002011532,1000,'[{1,112},{2,56},{4,56}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115030102,0,0,1150301,1002021532,1000,'[{1,56},{2,112},{4,56}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115030103,0,0,1150301,1002041532,1000,'[{1,56},{2,56},{4,112}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115030104,0,0,1150301,1004011532,1000,'[{1,112},{2,56},{4,56}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115030105,0,0,1150301,1004021532,1000,'[{1,56},{2,112},{4,56}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115030106,0,0,1150301,1004041532,1000,'[{1,56},{2,56},{4,112}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115030107,0,0,1150301,1006011532,1000,'[{1,112},{2,56},{4,56}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115030108,0,0,1150301,1006021532,1000,'[{1,56},{2,112},{4,56}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115030109,0,0,1150301,1006041532,1000,'[{1,56},{2,56},{4,112}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115030110,0,0,1150301,1008011532,1000,'[{1,112},{2,56},{4,56}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115030111,0,0,1150301,1008021532,1000,'[{1,56},{2,112},{4,56}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115030112,0,0,1150301,1008041532,1000,'[{1,56},{2,56},{4,112}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115030113,0,0,1150301,1010011532,1000,'[{1,112},{2,56},{4,56}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115030114,0,0,1150301,1010021532,1000,'[{1,56},{2,112},{4,56}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115030115,0,0,1150301,1010041532,1000,'[{1,56},{2,56},{4,112}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115030116,0,0,1150301,1002011542,1000,'[{1,5},{2,2},{4,2}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115030117,0,0,1150301,1002021542,1000,'[{1,2},{2,5},{4,2}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115030118,0,0,1150301,1002041542,1000,'[{1,2},{2,2},{4,5}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115030119,0,0,1150301,1004011542,1000,'[{1,5},{2,2},{4,2}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115030120,0,0,1150301,1004021542,1000,'[{1,2},{2,5},{4,2}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115030121,0,0,1150301,1004041542,1000,'[{1,2},{2,2},{4,5}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115030122,0,0,1150301,1006011542,1000,'[{1,5},{2,2},{4,2}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115030123,0,0,1150301,1006021542,1000,'[{1,2},{2,5},{4,2}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115030124,0,0,1150301,1006041542,1000,'[{1,2},{2,2},{4,5}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115030125,0,0,1150301,1008011542,1000,'[{1,5},{2,2},{4,2}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115030126,0,0,1150301,1008021542,1000,'[{1,2},{2,5},{4,2}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115030127,0,0,1150301,1008041542,1000,'[{1,2},{2,2},{4,5}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115030128,0,0,1150301,1010011542,1000,'[{1,5},{2,2},{4,2}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115030129,0,0,1150301,1010021542,1000,'[{1,2},{2,5},{4,2}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115030130,0,0,1150301,1010041542,1000,'[{1,2},{2,2},{4,5}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115030201,0,0,1150302,1001011532,1000,'[{1,56},{2,28},{4,28}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115030202,0,0,1150302,1001021532,1000,'[{1,28},{2,56},{4,28}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115030203,0,0,1150302,1001041532,1000,'[{1,28},{2,28},{4,56}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115030204,0,0,1150302,1007011532,1000,'[{1,56},{2,28},{4,28}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115030205,0,0,1150302,1007021532,1000,'[{1,28},{2,56},{4,28}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115030206,0,0,1150302,1007041532,1000,'[{1,28},{2,28},{4,56}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115030207,0,0,1150302,1003001532,1000,'[{1,28},{2,28},{4,28}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115030208,0,0,1150302,1001011542,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115030209,0,0,1150302,1001021542,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115030210,0,0,1150302,1001041542,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115030211,0,0,1150302,1007011542,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115030212,0,0,1150302,1007021542,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115030213,0,0,1150302,1007041542,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115030214,0,0,1150302,1003001542,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115040101,0,0,1150401,1002011532,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115040102,0,0,1150401,1002021532,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115040103,0,0,1150401,1002041532,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115040104,0,0,1150401,1004011532,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115040105,0,0,1150401,1004021532,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115040106,0,0,1150401,1004041532,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115040107,0,0,1150401,1006011532,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115040108,0,0,1150401,1006021532,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115040109,0,0,1150401,1006041532,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115040110,0,0,1150401,1008011532,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115040111,0,0,1150401,1008021532,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115040112,0,0,1150401,1008041532,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115040113,0,0,1150401,1010011532,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115040114,0,0,1150401,1010021532,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115040115,0,0,1150401,1010041532,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115040116,0,0,1150401,1002011542,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115040117,0,0,1150401,1002021542,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115040118,0,0,1150401,1002041542,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115040119,0,0,1150401,1004011542,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115040120,0,0,1150401,1004021542,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115040121,0,0,1150401,1004041542,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115040122,0,0,1150401,1006011542,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115040123,0,0,1150401,1006021542,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115040124,0,0,1150401,1006041542,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115040125,0,0,1150401,1008011542,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115040126,0,0,1150401,1008021542,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115040127,0,0,1150401,1008041542,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115040128,0,0,1150401,1010011542,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115040129,0,0,1150401,1010021542,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115040130,0,0,1150401,1010041542,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115040201,0,0,1150402,1001011532,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115040202,0,0,1150402,1001021532,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115040203,0,0,1150402,1001041532,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115040204,0,0,1150402,1007011532,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115040205,0,0,1150402,1007021532,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115040206,0,0,1150402,1007041532,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115040207,0,0,1150402,1003001532,1000,'[{1,60},{2,60},{4,60}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115040208,0,0,1150402,1001011542,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115040209,0,0,1150402,1001021542,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115040210,0,0,1150402,1001041542,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115040211,0,0,1150402,1007011542,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115040212,0,0,1150402,1007021542,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115040213,0,0,1150402,1007041542,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115040214,0,0,1150402,1003001542,1000,'[{1,60},{2,60},{4,60}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115050101,0,0,1150501,1002011532,1000,'[{1,212},{2,106},{4,106}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115050102,0,0,1150501,1002021532,1000,'[{1,106},{2,212},{4,106}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115050103,0,0,1150501,1002041532,1000,'[{1,106},{2,106},{4,212}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115050104,0,0,1150501,1004011532,1000,'[{1,212},{2,106},{4,106}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115050105,0,0,1150501,1004021532,1000,'[{1,106},{2,212},{4,106}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115050106,0,0,1150501,1004041532,1000,'[{1,106},{2,106},{4,212}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115050107,0,0,1150501,1006011532,1000,'[{1,212},{2,106},{4,106}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115050108,0,0,1150501,1006021532,1000,'[{1,106},{2,212},{4,106}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115050109,0,0,1150501,1006041532,1000,'[{1,106},{2,106},{4,212}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115050110,0,0,1150501,1008011532,1000,'[{1,212},{2,106},{4,106}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115050111,0,0,1150501,1008021532,1000,'[{1,106},{2,212},{4,106}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115050112,0,0,1150501,1008041532,1000,'[{1,106},{2,106},{4,212}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115050113,0,0,1150501,1010011532,1000,'[{1,212},{2,106},{4,106}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115050114,0,0,1150501,1010021532,1000,'[{1,106},{2,212},{4,106}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115050115,0,0,1150501,1010041532,1000,'[{1,106},{2,106},{4,212}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115050116,0,0,1150501,1002011542,1000,'[{1,5},{2,2},{4,2}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115050117,0,0,1150501,1002021542,1000,'[{1,2},{2,5},{4,2}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115050118,0,0,1150501,1002041542,1000,'[{1,2},{2,2},{4,5}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115050119,0,0,1150501,1004011542,1000,'[{1,5},{2,2},{4,2}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115050120,0,0,1150501,1004021542,1000,'[{1,2},{2,5},{4,2}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115050121,0,0,1150501,1004041542,1000,'[{1,2},{2,2},{4,5}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115050122,0,0,1150501,1006011542,1000,'[{1,5},{2,2},{4,2}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115050123,0,0,1150501,1006021542,1000,'[{1,2},{2,5},{4,2}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115050124,0,0,1150501,1006041542,1000,'[{1,2},{2,2},{4,5}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115050125,0,0,1150501,1008011542,1000,'[{1,5},{2,2},{4,2}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115050126,0,0,1150501,1008021542,1000,'[{1,2},{2,5},{4,2}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115050127,0,0,1150501,1008041542,1000,'[{1,2},{2,2},{4,5}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115050128,0,0,1150501,1010011542,1000,'[{1,5},{2,2},{4,2}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115050129,0,0,1150501,1010021542,1000,'[{1,2},{2,5},{4,2}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115050130,0,0,1150501,1010041542,1000,'[{1,2},{2,2},{4,5}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115050201,0,0,1150502,1001011532,1000,'[{1,106},{2,53},{4,53}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115050202,0,0,1150502,1001021532,1000,'[{1,53},{2,106},{4,53}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115050203,0,0,1150502,1001041532,1000,'[{1,53},{2,53},{4,106}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115050204,0,0,1150502,1007011532,1000,'[{1,106},{2,53},{4,53}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115050205,0,0,1150502,1007021532,1000,'[{1,53},{2,106},{4,53}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115050206,0,0,1150502,1007041532,1000,'[{1,53},{2,53},{4,106}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115050207,0,0,1150502,1003001532,1000,'[{1,53},{2,53},{4,53}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115050208,0,0,1150502,1001011542,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115050209,0,0,1150502,1001021542,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115050210,0,0,1150502,1001041542,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115050211,0,0,1150502,1007011542,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115050212,0,0,1150502,1007021542,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115050213,0,0,1150502,1007041542,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115050214,0,0,1150502,1003001542,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115060101,0,0,1150601,1002011532,1000,'[{1,57},{2,28},{4,28}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115060102,0,0,1150601,1002021532,1000,'[{1,28},{2,57},{4,28}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115060103,0,0,1150601,1002041532,1000,'[{1,28},{2,28},{4,57}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115060104,0,0,1150601,1004011532,1000,'[{1,57},{2,28},{4,28}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115060105,0,0,1150601,1004021532,1000,'[{1,28},{2,57},{4,28}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115060106,0,0,1150601,1004041532,1000,'[{1,28},{2,28},{4,57}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115060107,0,0,1150601,1006011532,1000,'[{1,57},{2,28},{4,28}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115060108,0,0,1150601,1006021532,1000,'[{1,28},{2,57},{4,28}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115060109,0,0,1150601,1006041532,1000,'[{1,28},{2,28},{4,57}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115060110,0,0,1150601,1008011532,1000,'[{1,57},{2,28},{4,28}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115060111,0,0,1150601,1008021532,1000,'[{1,28},{2,57},{4,28}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115060112,0,0,1150601,1008041532,1000,'[{1,28},{2,28},{4,57}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115060113,0,0,1150601,1010011532,1000,'[{1,57},{2,28},{4,28}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115060114,0,0,1150601,1010021532,1000,'[{1,28},{2,57},{4,28}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115060115,0,0,1150601,1010041532,1000,'[{1,28},{2,28},{4,57}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115060116,0,0,1150601,1002011542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115060117,0,0,1150601,1002021542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115060118,0,0,1150601,1002041542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115060119,0,0,1150601,1004011542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115060120,0,0,1150601,1004021542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115060121,0,0,1150601,1004041542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115060122,0,0,1150601,1006011542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115060123,0,0,1150601,1006021542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115060124,0,0,1150601,1006041542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115060125,0,0,1150601,1008011542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115060126,0,0,1150601,1008021542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115060127,0,0,1150601,1008041542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115060128,0,0,1150601,1010011542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115060129,0,0,1150601,1010021542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115060130,0,0,1150601,1010041542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115060201,0,0,1150602,1001011532,1000,'[{1,28},{2,14},{4,14}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115060202,0,0,1150602,1001021532,1000,'[{1,14},{2,28},{4,14}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115060203,0,0,1150602,1001041532,1000,'[{1,14},{2,14},{4,28}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115060204,0,0,1150602,1007011532,1000,'[{1,28},{2,14},{4,14}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115060205,0,0,1150602,1007021532,1000,'[{1,14},{2,28},{4,14}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115060206,0,0,1150602,1007041532,1000,'[{1,14},{2,14},{4,28}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115060207,0,0,1150602,1003001532,1000,'[{1,14},{2,14},{4,14}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115060208,0,0,1150602,1001011542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115060209,0,0,1150602,1001021542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115060210,0,0,1150602,1001041542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115060211,0,0,1150602,1007011542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115060212,0,0,1150602,1007021542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115060213,0,0,1150602,1007041542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115060214,0,0,1150602,1003001542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115070101,0,0,1150701,1002011532,1000,'[{1,62},{2,31},{4,31}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115070102,0,0,1150701,1002021532,1000,'[{1,31},{2,62},{4,31}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115070103,0,0,1150701,1002041532,1000,'[{1,31},{2,31},{4,62}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115070104,0,0,1150701,1004011532,1000,'[{1,62},{2,31},{4,31}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115070105,0,0,1150701,1004021532,1000,'[{1,31},{2,62},{4,31}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115070106,0,0,1150701,1004041532,1000,'[{1,31},{2,31},{4,62}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115070107,0,0,1150701,1006011532,1000,'[{1,62},{2,31},{4,31}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115070108,0,0,1150701,1006021532,1000,'[{1,31},{2,62},{4,31}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115070109,0,0,1150701,1006041532,1000,'[{1,31},{2,31},{4,62}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115070110,0,0,1150701,1008011532,1000,'[{1,62},{2,31},{4,31}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115070111,0,0,1150701,1008021532,1000,'[{1,31},{2,62},{4,31}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115070112,0,0,1150701,1008041532,1000,'[{1,31},{2,31},{4,62}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115070113,0,0,1150701,1010011532,1000,'[{1,62},{2,31},{4,31}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115070114,0,0,1150701,1010021532,1000,'[{1,31},{2,62},{4,31}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115070115,0,0,1150701,1010041532,1000,'[{1,31},{2,31},{4,62}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115070116,0,0,1150701,1002011542,1000,'[{1,5},{2,2},{4,2}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115070117,0,0,1150701,1002021542,1000,'[{1,2},{2,5},{4,2}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115070118,0,0,1150701,1002041542,1000,'[{1,2},{2,2},{4,5}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115070119,0,0,1150701,1004011542,1000,'[{1,5},{2,2},{4,2}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115070120,0,0,1150701,1004021542,1000,'[{1,2},{2,5},{4,2}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115070121,0,0,1150701,1004041542,1000,'[{1,2},{2,2},{4,5}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115070122,0,0,1150701,1006011542,1000,'[{1,5},{2,2},{4,2}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115070123,0,0,1150701,1006021542,1000,'[{1,2},{2,5},{4,2}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115070124,0,0,1150701,1006041542,1000,'[{1,2},{2,2},{4,5}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115070125,0,0,1150701,1008011542,1000,'[{1,5},{2,2},{4,2}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115070126,0,0,1150701,1008021542,1000,'[{1,2},{2,5},{4,2}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115070127,0,0,1150701,1008041542,1000,'[{1,2},{2,2},{4,5}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115070128,0,0,1150701,1010011542,1000,'[{1,5},{2,2},{4,2}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115070129,0,0,1150701,1010021542,1000,'[{1,2},{2,5},{4,2}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115070130,0,0,1150701,1010041542,1000,'[{1,2},{2,2},{4,5}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115070201,0,0,1150702,1001011532,1000,'[{1,50},{2,25},{4,25}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115070202,0,0,1150702,1001021532,1000,'[{1,25},{2,50},{4,25}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115070203,0,0,1150702,1001041532,1000,'[{1,25},{2,25},{4,50}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115070204,0,0,1150702,1007011532,1000,'[{1,50},{2,25},{4,25}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115070205,0,0,1150702,1007021532,1000,'[{1,25},{2,50},{4,25}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115070206,0,0,1150702,1007041532,1000,'[{1,25},{2,25},{4,50}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115070207,0,0,1150702,1003001532,1000,'[{1,25},{2,25},{4,25}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115070208,0,0,1150702,1001011542,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115070209,0,0,1150702,1001021542,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115070210,0,0,1150702,1001041542,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115070211,0,0,1150702,1007011542,1000,'[{1,3},{2,1},{4,1}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115070212,0,0,1150702,1007021542,1000,'[{1,1},{2,3},{4,1}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115070213,0,0,1150702,1007041542,1000,'[{1,1},{2,1},{4,3}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115070214,0,0,1150702,1003001542,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115080101,0,0,1150801,1002011532,1000,'[{1,275},{2,138},{4,138}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115080102,0,0,1150801,1002021532,1000,'[{1,138},{2,275},{4,138}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115080103,0,0,1150801,1002041532,1000,'[{1,138},{2,138},{4,275}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115080104,0,0,1150801,1004011532,1000,'[{1,275},{2,138},{4,138}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115080105,0,0,1150801,1004021532,1000,'[{1,138},{2,275},{4,138}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115080106,0,0,1150801,1004041532,1000,'[{1,138},{2,138},{4,275}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115080107,0,0,1150801,1006011532,1000,'[{1,275},{2,138},{4,138}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115080108,0,0,1150801,1006021532,1000,'[{1,138},{2,275},{4,138}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115080109,0,0,1150801,1006041532,1000,'[{1,138},{2,138},{4,275}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115080110,0,0,1150801,1008011532,1000,'[{1,275},{2,138},{4,138}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115080111,0,0,1150801,1008021532,1000,'[{1,138},{2,275},{4,138}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115080112,0,0,1150801,1008041532,1000,'[{1,138},{2,138},{4,275}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115080113,0,0,1150801,1010011532,1000,'[{1,275},{2,138},{4,138}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115080114,0,0,1150801,1010021532,1000,'[{1,138},{2,275},{4,138}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115080115,0,0,1150801,1010041532,1000,'[{1,138},{2,138},{4,275}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115080116,0,0,1150801,1002011542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115080117,0,0,1150801,1002021542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115080118,0,0,1150801,1002041542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115080119,0,0,1150801,1004011542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115080120,0,0,1150801,1004021542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115080121,0,0,1150801,1004041542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115080122,0,0,1150801,1006011542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115080123,0,0,1150801,1006021542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115080124,0,0,1150801,1006041542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115080125,0,0,1150801,1008011542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115080126,0,0,1150801,1008021542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115080127,0,0,1150801,1008041542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115080128,0,0,1150801,1010011542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115080129,0,0,1150801,1010021542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115080130,0,0,1150801,1010041542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115080201,0,0,1150802,1001011532,1000,'[{1,275},{2,138},{4,138}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115080202,0,0,1150802,1001021532,1000,'[{1,138},{2,275},{4,138}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115080203,0,0,1150802,1001041532,1000,'[{1,138},{2,138},{4,275}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115080204,0,0,1150802,1007011532,1000,'[{1,275},{2,138},{4,138}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115080205,0,0,1150802,1007021532,1000,'[{1,138},{2,275},{4,138}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115080206,0,0,1150802,1007041532,1000,'[{1,138},{2,138},{4,275}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115080207,0,0,1150802,1003001532,1000,'[{1,138},{2,138},{4,138}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(115080208,0,0,1150802,1001011542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115080209,0,0,1150802,1001021542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115080210,0,0,1150802,1001041542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115080211,0,0,1150802,1007011542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115080212,0,0,1150802,1007021542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115080213,0,0,1150802,1007041542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(115080214,0,0,1150802,1003001542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116010001,0,0,1160100,1002011610,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(116010002,0,0,1160100,1002021610,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(116010003,0,0,1160100,1002041610,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(116010004,0,0,1160100,1004011610,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(116010005,0,0,1160100,1004021610,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(116010006,0,0,1160100,1004041610,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(116010007,0,0,1160100,1006011610,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(116010008,0,0,1160100,1006021610,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(116010009,0,0,1160100,1006041610,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(116010010,0,0,1160100,1008011610,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(116010011,0,0,1160100,1008021610,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(116010012,0,0,1160100,1008041610,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(116010013,0,0,1160100,1010011610,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(116010014,0,0,1160100,1010021610,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(116010015,0,0,1160100,1010041610,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(116010016,0,0,1160100,1001011610,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(116010017,0,0,1160100,1001021610,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000201','0',0,'[]',0,0,0,0,'[]'),(116010018,0,0,1160100,1001041610,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000401','0',0,'[]',0,0,0,0,'[]'),(116010019,0,0,1160100,1007011610,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(116010020,0,0,1160100,1007021610,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000207','0',0,'[]',0,0,0,0,'[]'),(116010021,0,0,1160100,1007041610,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000407','0',0,'[]',0,0,0,0,'[]'),(116010022,0,0,1160100,1003001610,300,'[{1,75},{2,75},{4,75}]',1,1,'[]',0,'1000003','0',0,'[]',0,0,0,0,'[]'),(116010023,0,0,1160100,1002011620,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(116010024,0,0,1160100,1002021620,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(116010025,0,0,1160100,1002041620,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(116010026,0,0,1160100,1004011620,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(116010027,0,0,1160100,1004021620,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(116010028,0,0,1160100,1004041620,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(116010029,0,0,1160100,1006011620,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(116010030,0,0,1160100,1006021620,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(116010031,0,0,1160100,1006041620,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(116010032,0,0,1160100,1008011620,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(116010033,0,0,1160100,1008021620,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(116010034,0,0,1160100,1008041620,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(116010035,0,0,1160100,1010011620,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(116010036,0,0,1160100,1010021620,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(116010037,0,0,1160100,1010041620,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(116010038,0,0,1160100,1001011620,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(116010039,0,0,1160100,1001021620,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000201','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(116010040,0,0,1160100,1001041620,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000401','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(116010041,0,0,1160100,1007011620,300,'[{1,150},{2,75},{4,75}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(116010042,0,0,1160100,1007021620,300,'[{1,75},{2,150},{4,75}]',1,1,'[]',0,'1000207','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(116010043,0,0,1160100,1007041620,300,'[{1,75},{2,75},{4,150}]',1,1,'[]',0,'1000407','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(116010044,0,0,1160100,1003001620,300,'[{1,75},{2,75},{4,75}]',1,1,'[]',0,'1000003','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(116020001,0,0,1160200,1002011631,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(116020002,0,0,1160200,1002021631,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(116020003,0,0,1160200,1002041631,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(116020004,0,0,1160200,1004011631,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(116020005,0,0,1160200,1004021631,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(116020006,0,0,1160200,1004041631,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(116020007,0,0,1160200,1006011631,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(116020008,0,0,1160200,1006021631,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(116020009,0,0,1160200,1006041631,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(116020010,0,0,1160200,1008011631,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(116020011,0,0,1160200,1008021631,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(116020012,0,0,1160200,1008041631,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(116020013,0,0,1160200,1010011631,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(116020014,0,0,1160200,1010021631,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(116020015,0,0,1160200,1010041631,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(116020016,0,0,1160200,1001011631,1000,'[{1,50},{2,25},{4,25}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(116020017,0,0,1160200,1001021631,1000,'[{1,25},{2,50},{4,25}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(116020018,0,0,1160200,1001041631,1000,'[{1,25},{2,25},{4,50}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(116020019,0,0,1160200,1007011631,1000,'[{1,50},{2,25},{4,25}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(116020020,0,0,1160200,1007021631,1000,'[{1,25},{2,50},{4,25}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(116020021,0,0,1160200,1007041631,1000,'[{1,25},{2,25},{4,50}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(116020022,0,0,1160200,1003001631,1000,'[{1,25},{2,25},{4,25}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(116020023,0,0,1160200,1002011641,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(116020024,0,0,1160200,1002021641,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(116020025,0,0,1160200,1002041641,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(116020026,0,0,1160200,1004011641,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(116020027,0,0,1160200,1004021641,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(116020028,0,0,1160200,1004041641,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(116020029,0,0,1160200,1006011641,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(116020030,0,0,1160200,1006021641,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(116020031,0,0,1160200,1006041641,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(116020032,0,0,1160200,1008011641,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(116020033,0,0,1160200,1008021641,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(116020034,0,0,1160200,1008041641,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(116020035,0,0,1160200,1010011641,1000,'[{1,48},{2,24},{4,24}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(116020036,0,0,1160200,1010021641,1000,'[{1,24},{2,48},{4,24}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(116020037,0,0,1160200,1010041641,1000,'[{1,24},{2,24},{4,48}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(116020038,0,0,1160200,1001011641,1000,'[{1,20},{2,10},{4,10}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(116020039,0,0,1160200,1001021641,1000,'[{1,10},{2,20},{4,10}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[]',0,0,0,0,'[]'),(116020040,0,0,1160200,1001041641,1000,'[{1,10},{2,10},{4,20}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[]',0,0,0,0,'[]'),(116020041,0,0,1160200,1007011641,1000,'[{1,20},{2,10},{4,10}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(116020042,0,0,1160200,1007021641,1000,'[{1,10},{2,20},{4,10}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[]',0,0,0,0,'[]'),(116020043,0,0,1160200,1007041641,1000,'[{1,10},{2,10},{4,20}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[]',0,0,0,0,'[]'),(116020044,0,0,1160200,1003001641,1000,'[{1,10},{2,10},{4,10}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[]',0,0,0,0,'[]'),(116030101,0,0,1160301,1002011632,1000,'[{1,142},{2,71},{4,71}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116030102,0,0,1160301,1002021632,1000,'[{1,71},{2,142},{4,71}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116030103,0,0,1160301,1002041632,1000,'[{1,71},{2,71},{4,142}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116030104,0,0,1160301,1004011632,1000,'[{1,142},{2,71},{4,71}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116030105,0,0,1160301,1004021632,1000,'[{1,71},{2,142},{4,71}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116030106,0,0,1160301,1004041632,1000,'[{1,71},{2,71},{4,142}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116030107,0,0,1160301,1006011632,1000,'[{1,142},{2,71},{4,71}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116030108,0,0,1160301,1006021632,1000,'[{1,71},{2,142},{4,71}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116030109,0,0,1160301,1006041632,1000,'[{1,71},{2,71},{4,142}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116030110,0,0,1160301,1008011632,1000,'[{1,142},{2,71},{4,71}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116030111,0,0,1160301,1008021632,1000,'[{1,71},{2,142},{4,71}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116030112,0,0,1160301,1008041632,1000,'[{1,71},{2,71},{4,142}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116030113,0,0,1160301,1010011632,1000,'[{1,142},{2,71},{4,71}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116030114,0,0,1160301,1010021632,1000,'[{1,71},{2,142},{4,71}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116030115,0,0,1160301,1010041632,1000,'[{1,71},{2,71},{4,142}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116030116,0,0,1160301,1002011642,1000,'[{1,4},{2,2},{4,2}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116030117,0,0,1160301,1002021642,1000,'[{1,2},{2,4},{4,2}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116030118,0,0,1160301,1002041642,1000,'[{1,2},{2,2},{4,4}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116030119,0,0,1160301,1004011642,1000,'[{1,4},{2,2},{4,2}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116030120,0,0,1160301,1004021642,1000,'[{1,2},{2,4},{4,2}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116030121,0,0,1160301,1004041642,1000,'[{1,2},{2,2},{4,4}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116030122,0,0,1160301,1006011642,1000,'[{1,4},{2,2},{4,2}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116030123,0,0,1160301,1006021642,1000,'[{1,2},{2,4},{4,2}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116030124,0,0,1160301,1006041642,1000,'[{1,2},{2,2},{4,4}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116030125,0,0,1160301,1008011642,1000,'[{1,4},{2,2},{4,2}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116030126,0,0,1160301,1008021642,1000,'[{1,2},{2,4},{4,2}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116030127,0,0,1160301,1008041642,1000,'[{1,2},{2,2},{4,4}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116030128,0,0,1160301,1010011642,1000,'[{1,4},{2,2},{4,2}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116030129,0,0,1160301,1010021642,1000,'[{1,2},{2,4},{4,2}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116030130,0,0,1160301,1010041642,1000,'[{1,2},{2,2},{4,4}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116030201,0,0,1160302,1001011632,1000,'[{1,45},{2,22},{4,22}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116030202,0,0,1160302,1001021632,1000,'[{1,22},{2,45},{4,22}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116030203,0,0,1160302,1001041632,1000,'[{1,22},{2,22},{4,45}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116030204,0,0,1160302,1007011632,1000,'[{1,45},{2,22},{4,22}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116030205,0,0,1160302,1007021632,1000,'[{1,22},{2,45},{4,22}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116030206,0,0,1160302,1007041632,1000,'[{1,22},{2,22},{4,45}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116030207,0,0,1160302,1003001632,1000,'[{1,22},{2,22},{4,22}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116030208,0,0,1160302,1001011642,1000,'[{1,2},{2,1},{4,1}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116030209,0,0,1160302,1001021642,1000,'[{1,1},{2,2},{4,1}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116030210,0,0,1160302,1001041642,1000,'[{1,1},{2,1},{4,2}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116030211,0,0,1160302,1007011642,1000,'[{1,2},{2,1},{4,1}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116030212,0,0,1160302,1007021642,1000,'[{1,1},{2,2},{4,1}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116030213,0,0,1160302,1007041642,1000,'[{1,1},{2,1},{4,2}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116030214,0,0,1160302,1003001642,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116040101,0,0,1160401,1002011632,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116040102,0,0,1160401,1002021632,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116040103,0,0,1160401,1002041632,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116040104,0,0,1160401,1004011632,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116040105,0,0,1160401,1004021632,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116040106,0,0,1160401,1004041632,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116040107,0,0,1160401,1006011632,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116040108,0,0,1160401,1006021632,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116040109,0,0,1160401,1006041632,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116040110,0,0,1160401,1008011632,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116040111,0,0,1160401,1008021632,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116040112,0,0,1160401,1008041632,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116040113,0,0,1160401,1010011632,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116040114,0,0,1160401,1010021632,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116040115,0,0,1160401,1010041632,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116040116,0,0,1160401,1002011642,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116040117,0,0,1160401,1002021642,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116040118,0,0,1160401,1002041642,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116040119,0,0,1160401,1004011642,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116040120,0,0,1160401,1004021642,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116040121,0,0,1160401,1004041642,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116040122,0,0,1160401,1006011642,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116040123,0,0,1160401,1006021642,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116040124,0,0,1160401,1006041642,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116040125,0,0,1160401,1008011642,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116040126,0,0,1160401,1008021642,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116040127,0,0,1160401,1008041642,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116040128,0,0,1160401,1010011642,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116040129,0,0,1160401,1010021642,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116040130,0,0,1160401,1010041642,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116040201,0,0,1160402,1001011632,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116040202,0,0,1160402,1001021632,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116040203,0,0,1160402,1001041632,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116040204,0,0,1160402,1007011632,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116040205,0,0,1160402,1007021632,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116040206,0,0,1160402,1007041632,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116040207,0,0,1160402,1003001632,1000,'[{1,60},{2,60},{4,60}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116040208,0,0,1160402,1001011642,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116040209,0,0,1160402,1001021642,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116040210,0,0,1160402,1001041642,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116040211,0,0,1160402,1007011642,1000,'[{1,120},{2,60},{4,60}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116040212,0,0,1160402,1007021642,1000,'[{1,60},{2,120},{4,60}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116040213,0,0,1160402,1007041642,1000,'[{1,60},{2,60},{4,120}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116040214,0,0,1160402,1003001642,1000,'[{1,60},{2,60},{4,60}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116050101,0,0,1160501,1002011632,1000,'[{1,267},{2,133},{4,133}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116050102,0,0,1160501,1002021632,1000,'[{1,133},{2,267},{4,133}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116050103,0,0,1160501,1002041632,1000,'[{1,133},{2,133},{4,267}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116050104,0,0,1160501,1004011632,1000,'[{1,267},{2,133},{4,133}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116050105,0,0,1160501,1004021632,1000,'[{1,133},{2,267},{4,133}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116050106,0,0,1160501,1004041632,1000,'[{1,133},{2,133},{4,267}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116050107,0,0,1160501,1006011632,1000,'[{1,267},{2,133},{4,133}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116050108,0,0,1160501,1006021632,1000,'[{1,133},{2,267},{4,133}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116050109,0,0,1160501,1006041632,1000,'[{1,133},{2,133},{4,267}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116050110,0,0,1160501,1008011632,1000,'[{1,267},{2,133},{4,133}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116050111,0,0,1160501,1008021632,1000,'[{1,133},{2,267},{4,133}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116050112,0,0,1160501,1008041632,1000,'[{1,133},{2,133},{4,267}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116050113,0,0,1160501,1010011632,1000,'[{1,267},{2,133},{4,133}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116050114,0,0,1160501,1010021632,1000,'[{1,133},{2,267},{4,133}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116050115,0,0,1160501,1010041632,1000,'[{1,133},{2,133},{4,267}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116050116,0,0,1160501,1002011642,1000,'[{1,4},{2,2},{4,2}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116050117,0,0,1160501,1002021642,1000,'[{1,2},{2,4},{4,2}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116050118,0,0,1160501,1002041642,1000,'[{1,2},{2,2},{4,4}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116050119,0,0,1160501,1004011642,1000,'[{1,4},{2,2},{4,2}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116050120,0,0,1160501,1004021642,1000,'[{1,2},{2,4},{4,2}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116050121,0,0,1160501,1004041642,1000,'[{1,2},{2,2},{4,4}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116050122,0,0,1160501,1006011642,1000,'[{1,4},{2,2},{4,2}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116050123,0,0,1160501,1006021642,1000,'[{1,2},{2,4},{4,2}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116050124,0,0,1160501,1006041642,1000,'[{1,2},{2,2},{4,4}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116050125,0,0,1160501,1008011642,1000,'[{1,4},{2,2},{4,2}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116050126,0,0,1160501,1008021642,1000,'[{1,2},{2,4},{4,2}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116050127,0,0,1160501,1008041642,1000,'[{1,2},{2,2},{4,4}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116050128,0,0,1160501,1010011642,1000,'[{1,4},{2,2},{4,2}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116050129,0,0,1160501,1010021642,1000,'[{1,2},{2,4},{4,2}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116050130,0,0,1160501,1010041642,1000,'[{1,2},{2,2},{4,4}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116050201,0,0,1160502,1001011632,1000,'[{1,87},{2,43},{4,43}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116050202,0,0,1160502,1001021632,1000,'[{1,43},{2,87},{4,43}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116050203,0,0,1160502,1001041632,1000,'[{1,43},{2,43},{4,87}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116050204,0,0,1160502,1007011632,1000,'[{1,87},{2,43},{4,43}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116050205,0,0,1160502,1007021632,1000,'[{1,43},{2,87},{4,43}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116050206,0,0,1160502,1007041632,1000,'[{1,43},{2,43},{4,87}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116050207,0,0,1160502,1003001632,1000,'[{1,43},{2,43},{4,43}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116050208,0,0,1160502,1001011642,1000,'[{1,2},{2,1},{4,1}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116050209,0,0,1160502,1001021642,1000,'[{1,1},{2,2},{4,1}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116050210,0,0,1160502,1001041642,1000,'[{1,1},{2,1},{4,2}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116050211,0,0,1160502,1007011642,1000,'[{1,2},{2,1},{4,1}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116050212,0,0,1160502,1007021642,1000,'[{1,1},{2,2},{4,1}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116050213,0,0,1160502,1007041642,1000,'[{1,1},{2,1},{4,2}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116050214,0,0,1160502,1003001642,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116060101,0,0,1160601,1002011632,1000,'[{1,71},{2,35},{4,35}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116060102,0,0,1160601,1002021632,1000,'[{1,35},{2,71},{4,35}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116060103,0,0,1160601,1002041632,1000,'[{1,35},{2,35},{4,71}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116060104,0,0,1160601,1004011632,1000,'[{1,71},{2,35},{4,35}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116060105,0,0,1160601,1004021632,1000,'[{1,35},{2,71},{4,35}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116060106,0,0,1160601,1004041632,1000,'[{1,35},{2,35},{4,71}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116060107,0,0,1160601,1006011632,1000,'[{1,71},{2,35},{4,35}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116060108,0,0,1160601,1006021632,1000,'[{1,35},{2,71},{4,35}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116060109,0,0,1160601,1006041632,1000,'[{1,35},{2,35},{4,71}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116060110,0,0,1160601,1008011632,1000,'[{1,71},{2,35},{4,35}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116060111,0,0,1160601,1008021632,1000,'[{1,35},{2,71},{4,35}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116060112,0,0,1160601,1008041632,1000,'[{1,35},{2,35},{4,71}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116060113,0,0,1160601,1010011632,1000,'[{1,71},{2,35},{4,35}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116060114,0,0,1160601,1010021632,1000,'[{1,35},{2,71},{4,35}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116060115,0,0,1160601,1010041632,1000,'[{1,35},{2,35},{4,71}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116060116,0,0,1160601,1002011642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116060117,0,0,1160601,1002021642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116060118,0,0,1160601,1002041642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116060119,0,0,1160601,1004011642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116060120,0,0,1160601,1004021642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116060121,0,0,1160601,1004041642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116060122,0,0,1160601,1006011642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116060123,0,0,1160601,1006021642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116060124,0,0,1160601,1006041642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116060125,0,0,1160601,1008011642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116060126,0,0,1160601,1008021642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116060127,0,0,1160601,1008041642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116060128,0,0,1160601,1010011642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116060129,0,0,1160601,1010021642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116060130,0,0,1160601,1010041642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116060201,0,0,1160602,1001011632,1000,'[{1,24},{2,12},{4,12}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116060202,0,0,1160602,1001021632,1000,'[{1,12},{2,24},{4,12}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116060203,0,0,1160602,1001041632,1000,'[{1,12},{2,12},{4,24}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116060204,0,0,1160602,1007011632,1000,'[{1,24},{2,12},{4,12}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116060205,0,0,1160602,1007021632,1000,'[{1,12},{2,24},{4,12}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116060206,0,0,1160602,1007041632,1000,'[{1,12},{2,12},{4,24}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116060207,0,0,1160602,1003001632,1000,'[{1,12},{2,12},{4,12}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116060208,0,0,1160602,1001011642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116060209,0,0,1160602,1001021642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116060210,0,0,1160602,1001041642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116060211,0,0,1160602,1007011642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116060212,0,0,1160602,1007021642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116060213,0,0,1160602,1007041642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116060214,0,0,1160602,1003001642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116070101,0,0,1160701,1002011632,1000,'[{1,79},{2,40},{4,40}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116070102,0,0,1160701,1002021632,1000,'[{1,40},{2,79},{4,40}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116070103,0,0,1160701,1002041632,1000,'[{1,40},{2,40},{4,79}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116070104,0,0,1160701,1004011632,1000,'[{1,79},{2,40},{4,40}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116070105,0,0,1160701,1004021632,1000,'[{1,40},{2,79},{4,40}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116070106,0,0,1160701,1004041632,1000,'[{1,40},{2,40},{4,79}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116070107,0,0,1160701,1006011632,1000,'[{1,79},{2,40},{4,40}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116070108,0,0,1160701,1006021632,1000,'[{1,40},{2,79},{4,40}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116070109,0,0,1160701,1006041632,1000,'[{1,40},{2,40},{4,79}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116070110,0,0,1160701,1008011632,1000,'[{1,79},{2,40},{4,40}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116070111,0,0,1160701,1008021632,1000,'[{1,40},{2,79},{4,40}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116070112,0,0,1160701,1008041632,1000,'[{1,40},{2,40},{4,79}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116070113,0,0,1160701,1010011632,1000,'[{1,79},{2,40},{4,40}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116070114,0,0,1160701,1010021632,1000,'[{1,40},{2,79},{4,40}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116070115,0,0,1160701,1010041632,1000,'[{1,40},{2,40},{4,79}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116070116,0,0,1160701,1002011642,1000,'[{1,4},{2,2},{4,2}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116070117,0,0,1160701,1002021642,1000,'[{1,2},{2,4},{4,2}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116070118,0,0,1160701,1002041642,1000,'[{1,2},{2,2},{4,4}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116070119,0,0,1160701,1004011642,1000,'[{1,4},{2,2},{4,2}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116070120,0,0,1160701,1004021642,1000,'[{1,2},{2,4},{4,2}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116070121,0,0,1160701,1004041642,1000,'[{1,2},{2,2},{4,4}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116070122,0,0,1160701,1006011642,1000,'[{1,4},{2,2},{4,2}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116070123,0,0,1160701,1006021642,1000,'[{1,2},{2,4},{4,2}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116070124,0,0,1160701,1006041642,1000,'[{1,2},{2,2},{4,4}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116070125,0,0,1160701,1008011642,1000,'[{1,4},{2,2},{4,2}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116070126,0,0,1160701,1008021642,1000,'[{1,2},{2,4},{4,2}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116070127,0,0,1160701,1008041642,1000,'[{1,2},{2,2},{4,4}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116070128,0,0,1160701,1010011642,1000,'[{1,4},{2,2},{4,2}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116070129,0,0,1160701,1010021642,1000,'[{1,2},{2,4},{4,2}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116070130,0,0,1160701,1010041642,1000,'[{1,2},{2,2},{4,4}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116070201,0,0,1160702,1001011632,1000,'[{1,40},{2,20},{4,20}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116070202,0,0,1160702,1001021632,1000,'[{1,20},{2,40},{4,20}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116070203,0,0,1160702,1001041632,1000,'[{1,20},{2,20},{4,40}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116070204,0,0,1160702,1007011632,1000,'[{1,40},{2,20},{4,20}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116070205,0,0,1160702,1007021632,1000,'[{1,20},{2,40},{4,20}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116070206,0,0,1160702,1007041632,1000,'[{1,20},{2,20},{4,40}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116070207,0,0,1160702,1003001632,1000,'[{1,20},{2,20},{4,20}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116070208,0,0,1160702,1001011642,1000,'[{1,2},{2,1},{4,1}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116070209,0,0,1160702,1001021642,1000,'[{1,1},{2,2},{4,1}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116070210,0,0,1160702,1001041642,1000,'[{1,1},{2,1},{4,2}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116070211,0,0,1160702,1007011642,1000,'[{1,2},{2,1},{4,1}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116070212,0,0,1160702,1007021642,1000,'[{1,1},{2,2},{4,1}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116070213,0,0,1160702,1007041642,1000,'[{1,1},{2,1},{4,2}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116070214,0,0,1160702,1003001642,1000,'[{1,1},{2,1},{4,1}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116080101,0,0,1160801,1002011632,1000,'[{1,225},{2,113},{4,113}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116080102,0,0,1160801,1002021632,1000,'[{1,113},{2,225},{4,113}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116080103,0,0,1160801,1002041632,1000,'[{1,113},{2,113},{4,225}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116080104,0,0,1160801,1004011632,1000,'[{1,225},{2,113},{4,113}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116080105,0,0,1160801,1004021632,1000,'[{1,113},{2,225},{4,113}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116080106,0,0,1160801,1004041632,1000,'[{1,113},{2,113},{4,225}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116080107,0,0,1160801,1006011632,1000,'[{1,225},{2,113},{4,113}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116080108,0,0,1160801,1006021632,1000,'[{1,113},{2,225},{4,113}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116080109,0,0,1160801,1006041632,1000,'[{1,113},{2,113},{4,225}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116080110,0,0,1160801,1008011632,1000,'[{1,225},{2,113},{4,113}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116080111,0,0,1160801,1008021632,1000,'[{1,113},{2,225},{4,113}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116080112,0,0,1160801,1008041632,1000,'[{1,113},{2,113},{4,225}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116080113,0,0,1160801,1010011632,1000,'[{1,225},{2,113},{4,113}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116080114,0,0,1160801,1010021632,1000,'[{1,113},{2,225},{4,113}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116080115,0,0,1160801,1010041632,1000,'[{1,113},{2,113},{4,225}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116080116,0,0,1160801,1002011642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116080117,0,0,1160801,1002021642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116080118,0,0,1160801,1002041642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116080119,0,0,1160801,1004011642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116080120,0,0,1160801,1004021642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116080121,0,0,1160801,1004041642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116080122,0,0,1160801,1006011642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116080123,0,0,1160801,1006021642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116080124,0,0,1160801,1006041642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116080125,0,0,1160801,1008011642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116080126,0,0,1160801,1008021642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116080127,0,0,1160801,1008041642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116080128,0,0,1160801,1010011642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116080129,0,0,1160801,1010021642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116080130,0,0,1160801,1010041642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116080201,0,0,1160802,1001011632,1000,'[{1,225},{2,113},{4,113}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116080202,0,0,1160802,1001021632,1000,'[{1,113},{2,225},{4,113}]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116080203,0,0,1160802,1001041632,1000,'[{1,113},{2,113},{4,225}]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116080204,0,0,1160802,1007011632,1000,'[{1,225},{2,113},{4,113}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116080205,0,0,1160802,1007021632,1000,'[{1,113},{2,225},{4,113}]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116080206,0,0,1160802,1007041632,1000,'[{1,113},{2,113},{4,225}]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116080207,0,0,1160802,1003001632,1000,'[{1,113},{2,113},{4,113}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(116080208,0,0,1160802,1001011642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116080209,0,0,1160802,1001021642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116080210,0,0,1160802,1001041642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116080211,0,0,1160802,1007011642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116080212,0,0,1160802,1007021642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116080213,0,0,1160802,1007041642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(116080214,0,0,1160802,1003001642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(201010001,0,0,2010100,1002010110,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(201010002,0,0,2010100,1002020110,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(201010003,0,0,2010100,1002040110,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(201010004,0,0,2010100,1004010110,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(201010005,0,0,2010100,1004020110,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(201010006,0,0,2010100,1004040110,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(201010007,0,0,2010100,1006010110,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(201010008,0,0,2010100,1006020110,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(201010009,0,0,2010100,1006040110,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(201010010,0,0,2010100,1008010110,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(201010011,0,0,2010100,1008020110,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(201010012,0,0,2010100,1008040110,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(201010013,0,0,2010100,1010010110,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(201010014,0,0,2010100,1010020110,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(201010015,0,0,2010100,1010040110,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(201010016,0,0,2010100,1001010110,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(201010017,0,0,2010100,1001020110,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(201010018,0,0,2010100,1001040110,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(201010019,0,0,2010100,1007010110,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(201010020,0,0,2010100,1007020110,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(201010021,0,0,2010100,1007040110,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(201010022,0,0,2010100,1003000110,300,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','0',0,'[]',0,0,0,0,'[]'),(201010023,0,0,2010100,1002010120,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(201010024,0,0,2010100,1002020120,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(201010025,0,0,2010100,1002040120,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(201010026,0,0,2010100,1004010120,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(201010027,0,0,2010100,1004020120,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(201010028,0,0,2010100,1004040120,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(201010029,0,0,2010100,1006010120,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(201010030,0,0,2010100,1006020120,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(201010031,0,0,2010100,1006040120,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(201010032,0,0,2010100,1008010120,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(201010033,0,0,2010100,1008020120,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(201010034,0,0,2010100,1008040120,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(201010035,0,0,2010100,1010010120,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(201010036,0,0,2010100,1010020120,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(201010037,0,0,2010100,1010040120,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(201010038,0,0,2010100,1001010120,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(201010039,0,0,2010100,1001020120,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(201010040,0,0,2010100,1001040120,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(201010041,0,0,2010100,1007010120,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(201010042,0,0,2010100,1007020120,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(201010043,0,0,2010100,1007040120,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(201010044,0,0,2010100,1003000120,300,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(201020001,0,0,2010200,1002010131,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(201020002,0,0,2010200,1002020131,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(201020003,0,0,2010200,1002040131,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(201020004,0,0,2010200,1004010131,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(201020005,0,0,2010200,1004020131,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(201020006,0,0,2010200,1004040131,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(201020007,0,0,2010200,1006010131,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(201020008,0,0,2010200,1006020131,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(201020009,0,0,2010200,1006040131,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(201020010,0,0,2010200,1008010131,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(201020011,0,0,2010200,1008020131,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(201020012,0,0,2010200,1008040131,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(201020013,0,0,2010200,1010010131,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(201020014,0,0,2010200,1010020131,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(201020015,0,0,2010200,1010040131,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(201020016,0,0,2010200,1001010131,1000,'[{1,60},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(201020017,0,0,2010200,1001020131,1000,'[{1,0},{2,60},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(201020018,0,0,2010200,1001040131,1000,'[{1,0},{2,0},{4,60}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(201020019,0,0,2010200,1007010131,1000,'[{1,60},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(201020020,0,0,2010200,1007020131,1000,'[{1,0},{2,60},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(201020021,0,0,2010200,1007040131,1000,'[{1,0},{2,0},{4,60}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(201020022,0,0,2010200,1003000131,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(201020023,0,0,2010200,1002010141,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(201020024,0,0,2010200,1002020141,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(201020025,0,0,2010200,1002040141,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(201020026,0,0,2010200,1004010141,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(201020027,0,0,2010200,1004020141,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(201020028,0,0,2010200,1004040141,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(201020029,0,0,2010200,1006010141,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(201020030,0,0,2010200,1006020141,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(201020031,0,0,2010200,1006040141,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(201020032,0,0,2010200,1008010141,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(201020033,0,0,2010200,1008020141,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(201020034,0,0,2010200,1008040141,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(201020035,0,0,2010200,1010010141,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(201020036,0,0,2010200,1010020141,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(201020037,0,0,2010200,1010040141,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(201020038,0,0,2010200,1001010141,1000,'[{1,40},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(201020039,0,0,2010200,1001020141,1000,'[{1,0},{2,40},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(201020040,0,0,2010200,1001040141,1000,'[{1,0},{2,0},{4,40}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(201020041,0,0,2010200,1007010141,1000,'[{1,40},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(201020042,0,0,2010200,1007020141,1000,'[{1,0},{2,40},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(201020043,0,0,2010200,1007040141,1000,'[{1,0},{2,0},{4,40}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(201020044,0,0,2010200,1003000141,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[]',0,0,0,0,'[]'),(201030101,0,0,2010301,1002010132,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(201030102,0,0,2010301,1002020132,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(201030103,0,0,2010301,1002040132,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(201030104,0,0,2010301,1004010132,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(201030105,0,0,2010301,1004020132,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(201030106,0,0,2010301,1004040132,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(201030107,0,0,2010301,1006010132,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(201030108,0,0,2010301,1006020132,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(201030109,0,0,2010301,1006040132,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(201030110,0,0,2010301,1008010132,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(201030111,0,0,2010301,1008020132,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(201030112,0,0,2010301,1008040132,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(201030113,0,0,2010301,1010010132,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(201030114,0,0,2010301,1010020132,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(201030115,0,0,2010301,1010040132,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(201030116,0,0,2010301,1002010142,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(201030117,0,0,2010301,1002020142,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(201030118,0,0,2010301,1002040142,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(201030119,0,0,2010301,1004010142,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(201030120,0,0,2010301,1004020142,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(201030121,0,0,2010301,1004040142,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(201030122,0,0,2010301,1006010142,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(201030123,0,0,2010301,1006020142,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(201030124,0,0,2010301,1006040142,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(201030125,0,0,2010301,1008010142,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(201030126,0,0,2010301,1008020142,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(201030127,0,0,2010301,1008040142,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(201030128,0,0,2010301,1010010142,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(201030129,0,0,2010301,1010020142,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(201030130,0,0,2010301,1010040142,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(201030201,0,0,2010302,1001010132,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(201030202,0,0,2010302,1001020132,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(201030203,0,0,2010302,1001040132,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(201030204,0,0,2010302,1007010132,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(201030205,0,0,2010302,1007020132,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(201030206,0,0,2010302,1007040132,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(201030207,0,0,2010302,1003000132,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(201030208,0,0,2010302,1001010142,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(201030209,0,0,2010302,1001020142,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(201030210,0,0,2010302,1001040142,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(201030211,0,0,2010302,1007010142,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(201030212,0,0,2010302,1007020142,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(201030213,0,0,2010302,1007040142,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(201030214,0,0,2010302,1003000142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(202010001,0,0,2020100,1002010210,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(202010002,0,0,2020100,1002020210,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(202010003,0,0,2020100,1002040210,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(202010004,0,0,2020100,1004010210,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(202010005,0,0,2020100,1004020210,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(202010006,0,0,2020100,1004040210,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(202010007,0,0,2020100,1006010210,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(202010008,0,0,2020100,1006020210,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(202010009,0,0,2020100,1006040210,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(202010010,0,0,2020100,1008010210,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(202010011,0,0,2020100,1008020210,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(202010012,0,0,2020100,1008040210,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(202010013,0,0,2020100,1010010210,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(202010014,0,0,2020100,1010020210,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(202010015,0,0,2020100,1010040210,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(202010016,0,0,2020100,1001010210,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(202010017,0,0,2020100,1001020210,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(202010018,0,0,2020100,1001040210,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(202010019,0,0,2020100,1007010210,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(202010020,0,0,2020100,1007020210,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(202010021,0,0,2020100,1007040210,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(202010022,0,0,2020100,1003000210,300,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','0',0,'[]',0,0,0,0,'[]'),(202010023,0,0,2020100,1002010220,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(202010024,0,0,2020100,1002020220,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(202010025,0,0,2020100,1002040220,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(202010026,0,0,2020100,1004010220,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(202010027,0,0,2020100,1004020220,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(202010028,0,0,2020100,1004040220,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(202010029,0,0,2020100,1006010220,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(202010030,0,0,2020100,1006020220,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(202010031,0,0,2020100,1006040220,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(202010032,0,0,2020100,1008010220,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(202010033,0,0,2020100,1008020220,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(202010034,0,0,2020100,1008040220,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(202010035,0,0,2020100,1010010220,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(202010036,0,0,2020100,1010020220,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(202010037,0,0,2020100,1010040220,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(202010038,0,0,2020100,1001010220,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(202010039,0,0,2020100,1001020220,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(202010040,0,0,2020100,1001040220,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(202010041,0,0,2020100,1007010220,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(202010042,0,0,2020100,1007020220,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(202010043,0,0,2020100,1007040220,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(202010044,0,0,2020100,1003000220,300,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(202020001,0,0,2020200,1002010231,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(202020002,0,0,2020200,1002020231,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(202020003,0,0,2020200,1002040231,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(202020004,0,0,2020200,1004010231,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(202020005,0,0,2020200,1004020231,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(202020006,0,0,2020200,1004040231,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(202020007,0,0,2020200,1006010231,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(202020008,0,0,2020200,1006020231,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(202020009,0,0,2020200,1006040231,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(202020010,0,0,2020200,1008010231,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(202020011,0,0,2020200,1008020231,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(202020012,0,0,2020200,1008040231,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(202020013,0,0,2020200,1010010231,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(202020014,0,0,2020200,1010020231,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(202020015,0,0,2020200,1010040231,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(202020016,0,0,2020200,1001010231,1000,'[{1,60},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(202020017,0,0,2020200,1001020231,1000,'[{1,0},{2,60},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(202020018,0,0,2020200,1001040231,1000,'[{1,0},{2,0},{4,60}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(202020019,0,0,2020200,1007010231,1000,'[{1,60},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(202020020,0,0,2020200,1007020231,1000,'[{1,0},{2,60},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(202020021,0,0,2020200,1007040231,1000,'[{1,0},{2,0},{4,60}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(202020022,0,0,2020200,1003000231,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(202020023,0,0,2020200,1002010241,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(202020024,0,0,2020200,1002020241,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(202020025,0,0,2020200,1002040241,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(202020026,0,0,2020200,1004010241,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(202020027,0,0,2020200,1004020241,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(202020028,0,0,2020200,1004040241,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(202020029,0,0,2020200,1006010241,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(202020030,0,0,2020200,1006020241,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(202020031,0,0,2020200,1006040241,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(202020032,0,0,2020200,1008010241,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(202020033,0,0,2020200,1008020241,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(202020034,0,0,2020200,1008040241,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(202020035,0,0,2020200,1010010241,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(202020036,0,0,2020200,1010020241,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(202020037,0,0,2020200,1010040241,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(202020038,0,0,2020200,1001010241,1000,'[{1,40},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(202020039,0,0,2020200,1001020241,1000,'[{1,0},{2,40},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(202020040,0,0,2020200,1001040241,1000,'[{1,0},{2,0},{4,40}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(202020041,0,0,2020200,1007010241,1000,'[{1,40},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(202020042,0,0,2020200,1007020241,1000,'[{1,0},{2,40},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(202020043,0,0,2020200,1007040241,1000,'[{1,0},{2,0},{4,40}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(202020044,0,0,2020200,1003000241,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[]',0,0,0,0,'[]'),(202030101,0,0,2020301,1002010232,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(202030102,0,0,2020301,1002020232,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(202030103,0,0,2020301,1002040232,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(202030104,0,0,2020301,1004010232,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(202030105,0,0,2020301,1004020232,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(202030106,0,0,2020301,1004040232,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(202030107,0,0,2020301,1006010232,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(202030108,0,0,2020301,1006020232,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(202030109,0,0,2020301,1006040232,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(202030110,0,0,2020301,1008010232,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(202030111,0,0,2020301,1008020232,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(202030112,0,0,2020301,1008040232,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(202030113,0,0,2020301,1010010232,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(202030114,0,0,2020301,1010020232,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(202030115,0,0,2020301,1010040232,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(202030116,0,0,2020301,1002010242,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(202030117,0,0,2020301,1002020242,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(202030118,0,0,2020301,1002040242,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(202030119,0,0,2020301,1004010242,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(202030120,0,0,2020301,1004020242,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(202030121,0,0,2020301,1004040242,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(202030122,0,0,2020301,1006010242,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(202030123,0,0,2020301,1006020242,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(202030124,0,0,2020301,1006040242,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(202030125,0,0,2020301,1008010242,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(202030126,0,0,2020301,1008020242,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(202030127,0,0,2020301,1008040242,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(202030128,0,0,2020301,1010010242,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(202030129,0,0,2020301,1010020242,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(202030130,0,0,2020301,1010040242,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(202030201,0,0,2020302,1001010232,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(202030202,0,0,2020302,1001020232,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(202030203,0,0,2020302,1001040232,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(202030204,0,0,2020302,1007010232,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(202030205,0,0,2020302,1007020232,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(202030206,0,0,2020302,1007040232,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(202030207,0,0,2020302,1003000232,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(202030208,0,0,2020302,1001010242,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(202030209,0,0,2020302,1001020242,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(202030210,0,0,2020302,1001040242,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(202030211,0,0,2020302,1007010242,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(202030212,0,0,2020302,1007020242,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(202030213,0,0,2020302,1007040242,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(202030214,0,0,2020302,1003000242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(203010001,0,0,2030100,1002010310,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(203010002,0,0,2030100,1002020310,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(203010003,0,0,2030100,1002040310,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(203010004,0,0,2030100,1004010310,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(203010005,0,0,2030100,1004020310,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(203010006,0,0,2030100,1004040310,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(203010007,0,0,2030100,1006010310,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(203010008,0,0,2030100,1006020310,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(203010009,0,0,2030100,1006040310,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(203010010,0,0,2030100,1008010310,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(203010011,0,0,2030100,1008020310,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(203010012,0,0,2030100,1008040310,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(203010013,0,0,2030100,1010010310,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(203010014,0,0,2030100,1010020310,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(203010015,0,0,2030100,1010040310,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(203010016,0,0,2030100,1001010310,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(203010017,0,0,2030100,1001020310,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(203010018,0,0,2030100,1001040310,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(203010019,0,0,2030100,1007010310,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(203010020,0,0,2030100,1007020310,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(203010021,0,0,2030100,1007040310,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(203010022,0,0,2030100,1003000310,300,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','0',0,'[]',0,0,0,0,'[]'),(203010023,0,0,2030100,1002010320,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(203010024,0,0,2030100,1002020320,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(203010025,0,0,2030100,1002040320,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(203010026,0,0,2030100,1004010320,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(203010027,0,0,2030100,1004020320,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(203010028,0,0,2030100,1004040320,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(203010029,0,0,2030100,1006010320,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(203010030,0,0,2030100,1006020320,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(203010031,0,0,2030100,1006040320,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(203010032,0,0,2030100,1008010320,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(203010033,0,0,2030100,1008020320,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(203010034,0,0,2030100,1008040320,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(203010035,0,0,2030100,1010010320,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(203010036,0,0,2030100,1010020320,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(203010037,0,0,2030100,1010040320,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(203010038,0,0,2030100,1001010320,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(203010039,0,0,2030100,1001020320,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(203010040,0,0,2030100,1001040320,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(203010041,0,0,2030100,1007010320,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(203010042,0,0,2030100,1007020320,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(203010043,0,0,2030100,1007040320,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(203010044,0,0,2030100,1003000320,300,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(203020001,0,0,2030200,1002010331,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(203020002,0,0,2030200,1002020331,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(203020003,0,0,2030200,1002040331,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(203020004,0,0,2030200,1004010331,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(203020005,0,0,2030200,1004020331,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(203020006,0,0,2030200,1004040331,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(203020007,0,0,2030200,1006010331,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(203020008,0,0,2030200,1006020331,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(203020009,0,0,2030200,1006040331,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(203020010,0,0,2030200,1008010331,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(203020011,0,0,2030200,1008020331,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(203020012,0,0,2030200,1008040331,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(203020013,0,0,2030200,1010010331,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(203020014,0,0,2030200,1010020331,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(203020015,0,0,2030200,1010040331,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(203020016,0,0,2030200,1001010331,1000,'[{1,60},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(203020017,0,0,2030200,1001020331,1000,'[{1,0},{2,60},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(203020018,0,0,2030200,1001040331,1000,'[{1,0},{2,0},{4,60}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(203020019,0,0,2030200,1007010331,1000,'[{1,60},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(203020020,0,0,2030200,1007020331,1000,'[{1,0},{2,60},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(203020021,0,0,2030200,1007040331,1000,'[{1,0},{2,0},{4,60}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(203020022,0,0,2030200,1003000331,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(203020023,0,0,2030200,1002010341,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(203020024,0,0,2030200,1002020341,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(203020025,0,0,2030200,1002040341,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(203020026,0,0,2030200,1004010341,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(203020027,0,0,2030200,1004020341,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(203020028,0,0,2030200,1004040341,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(203020029,0,0,2030200,1006010341,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(203020030,0,0,2030200,1006020341,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(203020031,0,0,2030200,1006040341,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(203020032,0,0,2030200,1008010341,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(203020033,0,0,2030200,1008020341,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(203020034,0,0,2030200,1008040341,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(203020035,0,0,2030200,1010010341,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(203020036,0,0,2030200,1010020341,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(203020037,0,0,2030200,1010040341,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(203020038,0,0,2030200,1001010341,1000,'[{1,40},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(203020039,0,0,2030200,1001020341,1000,'[{1,0},{2,40},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(203020040,0,0,2030200,1001040341,1000,'[{1,0},{2,0},{4,40}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(203020041,0,0,2030200,1007010341,1000,'[{1,40},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(203020042,0,0,2030200,1007020341,1000,'[{1,0},{2,40},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(203020043,0,0,2030200,1007040341,1000,'[{1,0},{2,0},{4,40}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(203020044,0,0,2030200,1003000341,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[]',0,0,0,0,'[]'),(203030101,0,0,2030301,1002010332,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(203030102,0,0,2030301,1002020332,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(203030103,0,0,2030301,1002040332,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(203030104,0,0,2030301,1004010332,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(203030105,0,0,2030301,1004020332,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(203030106,0,0,2030301,1004040332,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(203030107,0,0,2030301,1006010332,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(203030108,0,0,2030301,1006020332,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(203030109,0,0,2030301,1006040332,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(203030110,0,0,2030301,1008010332,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(203030111,0,0,2030301,1008020332,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(203030112,0,0,2030301,1008040332,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(203030113,0,0,2030301,1010010332,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(203030114,0,0,2030301,1010020332,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(203030115,0,0,2030301,1010040332,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(203030116,0,0,2030301,1002010342,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(203030117,0,0,2030301,1002020342,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(203030118,0,0,2030301,1002040342,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(203030119,0,0,2030301,1004010342,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(203030120,0,0,2030301,1004020342,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(203030121,0,0,2030301,1004040342,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(203030122,0,0,2030301,1006010342,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(203030123,0,0,2030301,1006020342,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(203030124,0,0,2030301,1006040342,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(203030125,0,0,2030301,1008010342,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(203030126,0,0,2030301,1008020342,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(203030127,0,0,2030301,1008040342,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(203030128,0,0,2030301,1010010342,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(203030129,0,0,2030301,1010020342,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(203030130,0,0,2030301,1010040342,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(203030201,0,0,2030302,1001010332,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(203030202,0,0,2030302,1001020332,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(203030203,0,0,2030302,1001040332,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(203030204,0,0,2030302,1007010332,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(203030205,0,0,2030302,1007020332,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(203030206,0,0,2030302,1007040332,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(203030207,0,0,2030302,1003000332,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(203030208,0,0,2030302,1001010342,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(203030209,0,0,2030302,1001020342,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(203030210,0,0,2030302,1001040342,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(203030211,0,0,2030302,1007010342,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(203030212,0,0,2030302,1007020342,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(203030213,0,0,2030302,1007040342,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(203030214,0,0,2030302,1003000342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(204010001,0,0,2040100,1002010410,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(204010002,0,0,2040100,1002020410,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(204010003,0,0,2040100,1002040410,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(204010004,0,0,2040100,1004010410,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(204010005,0,0,2040100,1004020410,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(204010006,0,0,2040100,1004040410,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(204010007,0,0,2040100,1006010410,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(204010008,0,0,2040100,1006020410,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(204010009,0,0,2040100,1006040410,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(204010010,0,0,2040100,1008010410,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(204010011,0,0,2040100,1008020410,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(204010012,0,0,2040100,1008040410,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(204010013,0,0,2040100,1010010410,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(204010014,0,0,2040100,1010020410,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(204010015,0,0,2040100,1010040410,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(204010016,0,0,2040100,1001010410,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(204010017,0,0,2040100,1001020410,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(204010018,0,0,2040100,1001040410,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(204010019,0,0,2040100,1007010410,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(204010020,0,0,2040100,1007020410,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(204010021,0,0,2040100,1007040410,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(204010022,0,0,2040100,1003000410,300,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','0',0,'[]',0,0,0,0,'[]'),(204010023,0,0,2040100,1002010420,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(204010024,0,0,2040100,1002020420,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(204010025,0,0,2040100,1002040420,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(204010026,0,0,2040100,1004010420,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(204010027,0,0,2040100,1004020420,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(204010028,0,0,2040100,1004040420,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(204010029,0,0,2040100,1006010420,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(204010030,0,0,2040100,1006020420,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(204010031,0,0,2040100,1006040420,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(204010032,0,0,2040100,1008010420,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(204010033,0,0,2040100,1008020420,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(204010034,0,0,2040100,1008040420,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(204010035,0,0,2040100,1010010420,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(204010036,0,0,2040100,1010020420,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(204010037,0,0,2040100,1010040420,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(204010038,0,0,2040100,1001010420,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(204010039,0,0,2040100,1001020420,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(204010040,0,0,2040100,1001040420,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(204010041,0,0,2040100,1007010420,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(204010042,0,0,2040100,1007020420,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(204010043,0,0,2040100,1007040420,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(204010044,0,0,2040100,1003000420,300,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(204020001,0,0,2040200,1002010431,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(204020002,0,0,2040200,1002020431,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(204020003,0,0,2040200,1002040431,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(204020004,0,0,2040200,1004010431,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(204020005,0,0,2040200,1004020431,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(204020006,0,0,2040200,1004040431,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(204020007,0,0,2040200,1006010431,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(204020008,0,0,2040200,1006020431,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(204020009,0,0,2040200,1006040431,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(204020010,0,0,2040200,1008010431,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(204020011,0,0,2040200,1008020431,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(204020012,0,0,2040200,1008040431,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(204020013,0,0,2040200,1010010431,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(204020014,0,0,2040200,1010020431,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(204020015,0,0,2040200,1010040431,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(204020016,0,0,2040200,1001010431,1000,'[{1,60},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(204020017,0,0,2040200,1001020431,1000,'[{1,0},{2,60},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(204020018,0,0,2040200,1001040431,1000,'[{1,0},{2,0},{4,60}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(204020019,0,0,2040200,1007010431,1000,'[{1,60},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(204020020,0,0,2040200,1007020431,1000,'[{1,0},{2,60},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(204020021,0,0,2040200,1007040431,1000,'[{1,0},{2,0},{4,60}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(204020022,0,0,2040200,1003000431,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(204020023,0,0,2040200,1002010441,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(204020024,0,0,2040200,1002020441,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(204020025,0,0,2040200,1002040441,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(204020026,0,0,2040200,1004010441,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(204020027,0,0,2040200,1004020441,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(204020028,0,0,2040200,1004040441,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(204020029,0,0,2040200,1006010441,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(204020030,0,0,2040200,1006020441,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(204020031,0,0,2040200,1006040441,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(204020032,0,0,2040200,1008010441,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(204020033,0,0,2040200,1008020441,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(204020034,0,0,2040200,1008040441,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(204020035,0,0,2040200,1010010441,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(204020036,0,0,2040200,1010020441,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(204020037,0,0,2040200,1010040441,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(204020038,0,0,2040200,1001010441,1000,'[{1,40},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(204020039,0,0,2040200,1001020441,1000,'[{1,0},{2,40},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(204020040,0,0,2040200,1001040441,1000,'[{1,0},{2,0},{4,40}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(204020041,0,0,2040200,1007010441,1000,'[{1,40},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(204020042,0,0,2040200,1007020441,1000,'[{1,0},{2,40},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(204020043,0,0,2040200,1007040441,1000,'[{1,0},{2,0},{4,40}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(204020044,0,0,2040200,1003000441,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[]',0,0,0,0,'[]'),(204030101,0,0,2040301,1002010432,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(204030102,0,0,2040301,1002020432,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(204030103,0,0,2040301,1002040432,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(204030104,0,0,2040301,1004010432,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(204030105,0,0,2040301,1004020432,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(204030106,0,0,2040301,1004040432,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(204030107,0,0,2040301,1006010432,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(204030108,0,0,2040301,1006020432,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(204030109,0,0,2040301,1006040432,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(204030110,0,0,2040301,1008010432,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(204030111,0,0,2040301,1008020432,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(204030112,0,0,2040301,1008040432,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(204030113,0,0,2040301,1010010432,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(204030114,0,0,2040301,1010020432,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(204030115,0,0,2040301,1010040432,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(204030116,0,0,2040301,1002010442,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(204030117,0,0,2040301,1002020442,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(204030118,0,0,2040301,1002040442,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(204030119,0,0,2040301,1004010442,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(204030120,0,0,2040301,1004020442,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(204030121,0,0,2040301,1004040442,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(204030122,0,0,2040301,1006010442,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(204030123,0,0,2040301,1006020442,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(204030124,0,0,2040301,1006040442,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(204030125,0,0,2040301,1008010442,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(204030126,0,0,2040301,1008020442,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(204030127,0,0,2040301,1008040442,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(204030128,0,0,2040301,1010010442,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(204030129,0,0,2040301,1010020442,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(204030130,0,0,2040301,1010040442,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(204030201,0,0,2040302,1001010432,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(204030202,0,0,2040302,1001020432,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(204030203,0,0,2040302,1001040432,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(204030204,0,0,2040302,1007010432,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(204030205,0,0,2040302,1007020432,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(204030206,0,0,2040302,1007040432,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(204030207,0,0,2040302,1003000432,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(204030208,0,0,2040302,1001010442,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(204030209,0,0,2040302,1001020442,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(204030210,0,0,2040302,1001040442,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(204030211,0,0,2040302,1007010442,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(204030212,0,0,2040302,1007020442,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(204030213,0,0,2040302,1007040442,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(204030214,0,0,2040302,1003000442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(205010001,0,0,2050100,1002010510,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(205010002,0,0,2050100,1002020510,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(205010003,0,0,2050100,1002040510,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(205010004,0,0,2050100,1004010510,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(205010005,0,0,2050100,1004020510,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(205010006,0,0,2050100,1004040510,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(205010007,0,0,2050100,1006010510,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(205010008,0,0,2050100,1006020510,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(205010009,0,0,2050100,1006040510,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(205010010,0,0,2050100,1008010510,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(205010011,0,0,2050100,1008020510,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(205010012,0,0,2050100,1008040510,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(205010013,0,0,2050100,1010010510,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(205010014,0,0,2050100,1010020510,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(205010015,0,0,2050100,1010040510,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(205010016,0,0,2050100,1001010510,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(205010017,0,0,2050100,1001020510,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(205010018,0,0,2050100,1001040510,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(205010019,0,0,2050100,1007010510,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(205010020,0,0,2050100,1007020510,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(205010021,0,0,2050100,1007040510,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(205010022,0,0,2050100,1003000510,300,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','0',0,'[]',0,0,0,0,'[]'),(205010023,0,0,2050100,1002010520,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(205010024,0,0,2050100,1002020520,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(205010025,0,0,2050100,1002040520,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(205010026,0,0,2050100,1004010520,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(205010027,0,0,2050100,1004020520,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(205010028,0,0,2050100,1004040520,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(205010029,0,0,2050100,1006010520,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(205010030,0,0,2050100,1006020520,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(205010031,0,0,2050100,1006040520,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(205010032,0,0,2050100,1008010520,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(205010033,0,0,2050100,1008020520,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(205010034,0,0,2050100,1008040520,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(205010035,0,0,2050100,1010010520,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(205010036,0,0,2050100,1010020520,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(205010037,0,0,2050100,1010040520,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(205010038,0,0,2050100,1001010520,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(205010039,0,0,2050100,1001020520,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(205010040,0,0,2050100,1001040520,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(205010041,0,0,2050100,1007010520,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(205010042,0,0,2050100,1007020520,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(205010043,0,0,2050100,1007040520,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(205010044,0,0,2050100,1003000520,300,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(205020001,0,0,2050200,1002010531,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(205020002,0,0,2050200,1002020531,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(205020003,0,0,2050200,1002040531,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(205020004,0,0,2050200,1004010531,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(205020005,0,0,2050200,1004020531,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(205020006,0,0,2050200,1004040531,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(205020007,0,0,2050200,1006010531,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(205020008,0,0,2050200,1006020531,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(205020009,0,0,2050200,1006040531,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(205020010,0,0,2050200,1008010531,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(205020011,0,0,2050200,1008020531,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(205020012,0,0,2050200,1008040531,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(205020013,0,0,2050200,1010010531,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(205020014,0,0,2050200,1010020531,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(205020015,0,0,2050200,1010040531,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(205020016,0,0,2050200,1001010531,1000,'[{1,60},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(205020017,0,0,2050200,1001020531,1000,'[{1,0},{2,60},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(205020018,0,0,2050200,1001040531,1000,'[{1,0},{2,0},{4,60}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(205020019,0,0,2050200,1007010531,1000,'[{1,60},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(205020020,0,0,2050200,1007020531,1000,'[{1,0},{2,60},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(205020021,0,0,2050200,1007040531,1000,'[{1,0},{2,0},{4,60}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(205020022,0,0,2050200,1003000531,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(205020023,0,0,2050200,1002010541,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(205020024,0,0,2050200,1002020541,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(205020025,0,0,2050200,1002040541,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(205020026,0,0,2050200,1004010541,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(205020027,0,0,2050200,1004020541,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(205020028,0,0,2050200,1004040541,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(205020029,0,0,2050200,1006010541,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(205020030,0,0,2050200,1006020541,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(205020031,0,0,2050200,1006040541,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(205020032,0,0,2050200,1008010541,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(205020033,0,0,2050200,1008020541,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(205020034,0,0,2050200,1008040541,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(205020035,0,0,2050200,1010010541,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(205020036,0,0,2050200,1010020541,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(205020037,0,0,2050200,1010040541,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(205020038,0,0,2050200,1001010541,1000,'[{1,40},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(205020039,0,0,2050200,1001020541,1000,'[{1,0},{2,40},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(205020040,0,0,2050200,1001040541,1000,'[{1,0},{2,0},{4,40}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(205020041,0,0,2050200,1007010541,1000,'[{1,40},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(205020042,0,0,2050200,1007020541,1000,'[{1,0},{2,40},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(205020043,0,0,2050200,1007040541,1000,'[{1,0},{2,0},{4,40}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(205020044,0,0,2050200,1003000541,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[]',0,0,0,0,'[]'),(205030101,0,0,2050301,1002010532,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(205030102,0,0,2050301,1002020532,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(205030103,0,0,2050301,1002040532,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(205030104,0,0,2050301,1004010532,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(205030105,0,0,2050301,1004020532,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(205030106,0,0,2050301,1004040532,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(205030107,0,0,2050301,1006010532,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(205030108,0,0,2050301,1006020532,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(205030109,0,0,2050301,1006040532,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(205030110,0,0,2050301,1008010532,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(205030111,0,0,2050301,1008020532,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(205030112,0,0,2050301,1008040532,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(205030113,0,0,2050301,1010010532,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(205030114,0,0,2050301,1010020532,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(205030115,0,0,2050301,1010040532,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(205030116,0,0,2050301,1002010542,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(205030117,0,0,2050301,1002020542,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(205030118,0,0,2050301,1002040542,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(205030119,0,0,2050301,1004010542,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(205030120,0,0,2050301,1004020542,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(205030121,0,0,2050301,1004040542,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(205030122,0,0,2050301,1006010542,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(205030123,0,0,2050301,1006020542,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(205030124,0,0,2050301,1006040542,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(205030125,0,0,2050301,1008010542,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(205030126,0,0,2050301,1008020542,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(205030127,0,0,2050301,1008040542,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(205030128,0,0,2050301,1010010542,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(205030129,0,0,2050301,1010020542,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(205030130,0,0,2050301,1010040542,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(205030201,0,0,2050302,1001010532,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(205030202,0,0,2050302,1001020532,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(205030203,0,0,2050302,1001040532,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(205030204,0,0,2050302,1007010532,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(205030205,0,0,2050302,1007020532,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(205030206,0,0,2050302,1007040532,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(205030207,0,0,2050302,1003000532,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(205030208,0,0,2050302,1001010542,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(205030209,0,0,2050302,1001020542,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(205030210,0,0,2050302,1001040542,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(205030211,0,0,2050302,1007010542,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(205030212,0,0,2050302,1007020542,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(205030213,0,0,2050302,1007040542,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(205030214,0,0,2050302,1003000542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(206010001,0,0,2060100,1002010610,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(206010002,0,0,2060100,1002020610,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(206010003,0,0,2060100,1002040610,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(206010004,0,0,2060100,1004010610,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(206010005,0,0,2060100,1004020610,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(206010006,0,0,2060100,1004040610,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(206010007,0,0,2060100,1006010610,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(206010008,0,0,2060100,1006020610,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(206010009,0,0,2060100,1006040610,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(206010010,0,0,2060100,1008010610,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(206010011,0,0,2060100,1008020610,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(206010012,0,0,2060100,1008040610,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(206010013,0,0,2060100,1010010610,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(206010014,0,0,2060100,1010020610,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(206010015,0,0,2060100,1010040610,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(206010016,0,0,2060100,1001010610,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(206010017,0,0,2060100,1001020610,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(206010018,0,0,2060100,1001040610,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(206010019,0,0,2060100,1007010610,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(206010020,0,0,2060100,1007020610,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(206010021,0,0,2060100,1007040610,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(206010022,0,0,2060100,1003000610,300,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','0',0,'[]',0,0,0,0,'[]'),(206010023,0,0,2060100,1002010620,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(206010024,0,0,2060100,1002020620,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(206010025,0,0,2060100,1002040620,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(206010026,0,0,2060100,1004010620,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(206010027,0,0,2060100,1004020620,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(206010028,0,0,2060100,1004040620,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(206010029,0,0,2060100,1006010620,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(206010030,0,0,2060100,1006020620,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(206010031,0,0,2060100,1006040620,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(206010032,0,0,2060100,1008010620,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(206010033,0,0,2060100,1008020620,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(206010034,0,0,2060100,1008040620,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(206010035,0,0,2060100,1010010620,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(206010036,0,0,2060100,1010020620,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(206010037,0,0,2060100,1010040620,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(206010038,0,0,2060100,1001010620,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(206010039,0,0,2060100,1001020620,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(206010040,0,0,2060100,1001040620,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(206010041,0,0,2060100,1007010620,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(206010042,0,0,2060100,1007020620,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(206010043,0,0,2060100,1007040620,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(206010044,0,0,2060100,1003000620,300,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(206020001,0,0,2060200,1002010631,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(206020002,0,0,2060200,1002020631,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(206020003,0,0,2060200,1002040631,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(206020004,0,0,2060200,1004010631,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(206020005,0,0,2060200,1004020631,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(206020006,0,0,2060200,1004040631,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(206020007,0,0,2060200,1006010631,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(206020008,0,0,2060200,1006020631,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(206020009,0,0,2060200,1006040631,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(206020010,0,0,2060200,1008010631,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(206020011,0,0,2060200,1008020631,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(206020012,0,0,2060200,1008040631,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(206020013,0,0,2060200,1010010631,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(206020014,0,0,2060200,1010020631,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(206020015,0,0,2060200,1010040631,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(206020016,0,0,2060200,1001010631,1000,'[{1,60},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(206020017,0,0,2060200,1001020631,1000,'[{1,0},{2,60},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(206020018,0,0,2060200,1001040631,1000,'[{1,0},{2,0},{4,60}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(206020019,0,0,2060200,1007010631,1000,'[{1,60},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(206020020,0,0,2060200,1007020631,1000,'[{1,0},{2,60},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(206020021,0,0,2060200,1007040631,1000,'[{1,0},{2,0},{4,60}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(206020022,0,0,2060200,1003000631,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(206020023,0,0,2060200,1002010641,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(206020024,0,0,2060200,1002020641,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(206020025,0,0,2060200,1002040641,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(206020026,0,0,2060200,1004010641,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(206020027,0,0,2060200,1004020641,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(206020028,0,0,2060200,1004040641,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(206020029,0,0,2060200,1006010641,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(206020030,0,0,2060200,1006020641,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(206020031,0,0,2060200,1006040641,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(206020032,0,0,2060200,1008010641,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(206020033,0,0,2060200,1008020641,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(206020034,0,0,2060200,1008040641,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(206020035,0,0,2060200,1010010641,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(206020036,0,0,2060200,1010020641,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(206020037,0,0,2060200,1010040641,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(206020038,0,0,2060200,1001010641,1000,'[{1,40},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(206020039,0,0,2060200,1001020641,1000,'[{1,0},{2,40},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(206020040,0,0,2060200,1001040641,1000,'[{1,0},{2,0},{4,40}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(206020041,0,0,2060200,1007010641,1000,'[{1,40},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(206020042,0,0,2060200,1007020641,1000,'[{1,0},{2,40},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(206020043,0,0,2060200,1007040641,1000,'[{1,0},{2,0},{4,40}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(206020044,0,0,2060200,1003000641,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[]',0,0,0,0,'[]'),(206030101,0,0,2060301,1002010632,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(206030102,0,0,2060301,1002020632,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(206030103,0,0,2060301,1002040632,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(206030104,0,0,2060301,1004010632,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(206030105,0,0,2060301,1004020632,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(206030106,0,0,2060301,1004040632,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(206030107,0,0,2060301,1006010632,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(206030108,0,0,2060301,1006020632,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(206030109,0,0,2060301,1006040632,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(206030110,0,0,2060301,1008010632,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(206030111,0,0,2060301,1008020632,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(206030112,0,0,2060301,1008040632,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(206030113,0,0,2060301,1010010632,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(206030114,0,0,2060301,1010020632,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(206030115,0,0,2060301,1010040632,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(206030116,0,0,2060301,1002010642,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(206030117,0,0,2060301,1002020642,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(206030118,0,0,2060301,1002040642,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(206030119,0,0,2060301,1004010642,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(206030120,0,0,2060301,1004020642,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(206030121,0,0,2060301,1004040642,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(206030122,0,0,2060301,1006010642,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(206030123,0,0,2060301,1006020642,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(206030124,0,0,2060301,1006040642,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(206030125,0,0,2060301,1008010642,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(206030126,0,0,2060301,1008020642,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(206030127,0,0,2060301,1008040642,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(206030128,0,0,2060301,1010010642,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(206030129,0,0,2060301,1010020642,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(206030130,0,0,2060301,1010040642,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(206030201,0,0,2060302,1001010632,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(206030202,0,0,2060302,1001020632,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(206030203,0,0,2060302,1001040632,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(206030204,0,0,2060302,1007010632,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(206030205,0,0,2060302,1007020632,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(206030206,0,0,2060302,1007040632,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(206030207,0,0,2060302,1003000632,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(206030208,0,0,2060302,1001010642,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(206030209,0,0,2060302,1001020642,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(206030210,0,0,2060302,1001040642,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(206030211,0,0,2060302,1007010642,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(206030212,0,0,2060302,1007020642,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(206030213,0,0,2060302,1007040642,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(206030214,0,0,2060302,1003000642,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(207010001,0,0,2070100,1002010710,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(207010002,0,0,2070100,1002020710,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(207010003,0,0,2070100,1002040710,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(207010004,0,0,2070100,1004010710,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(207010005,0,0,2070100,1004020710,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(207010006,0,0,2070100,1004040710,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(207010007,0,0,2070100,1006010710,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(207010008,0,0,2070100,1006020710,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(207010009,0,0,2070100,1006040710,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(207010010,0,0,2070100,1008010710,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(207010011,0,0,2070100,1008020710,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(207010012,0,0,2070100,1008040710,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(207010013,0,0,2070100,1010010710,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(207010014,0,0,2070100,1010020710,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(207010015,0,0,2070100,1010040710,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(207010016,0,0,2070100,1001010710,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(207010017,0,0,2070100,1001020710,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(207010018,0,0,2070100,1001040710,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(207010019,0,0,2070100,1007010710,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(207010020,0,0,2070100,1007020710,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(207010021,0,0,2070100,1007040710,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(207010022,0,0,2070100,1003000710,300,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','0',0,'[]',0,0,0,0,'[]'),(207010023,0,0,2070100,1002010720,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(207010024,0,0,2070100,1002020720,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(207010025,0,0,2070100,1002040720,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(207010026,0,0,2070100,1004010720,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(207010027,0,0,2070100,1004020720,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(207010028,0,0,2070100,1004040720,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(207010029,0,0,2070100,1006010720,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(207010030,0,0,2070100,1006020720,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(207010031,0,0,2070100,1006040720,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(207010032,0,0,2070100,1008010720,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(207010033,0,0,2070100,1008020720,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(207010034,0,0,2070100,1008040720,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(207010035,0,0,2070100,1010010720,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(207010036,0,0,2070100,1010020720,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(207010037,0,0,2070100,1010040720,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(207010038,0,0,2070100,1001010720,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(207010039,0,0,2070100,1001020720,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(207010040,0,0,2070100,1001040720,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(207010041,0,0,2070100,1007010720,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(207010042,0,0,2070100,1007020720,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(207010043,0,0,2070100,1007040720,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(207010044,0,0,2070100,1003000720,300,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(207020001,0,0,2070200,1002010731,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(207020002,0,0,2070200,1002020731,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(207020003,0,0,2070200,1002040731,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(207020004,0,0,2070200,1004010731,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(207020005,0,0,2070200,1004020731,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(207020006,0,0,2070200,1004040731,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(207020007,0,0,2070200,1006010731,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(207020008,0,0,2070200,1006020731,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(207020009,0,0,2070200,1006040731,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(207020010,0,0,2070200,1008010731,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(207020011,0,0,2070200,1008020731,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(207020012,0,0,2070200,1008040731,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(207020013,0,0,2070200,1010010731,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(207020014,0,0,2070200,1010020731,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(207020015,0,0,2070200,1010040731,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(207020016,0,0,2070200,1001010731,1000,'[{1,60},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(207020017,0,0,2070200,1001020731,1000,'[{1,0},{2,60},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(207020018,0,0,2070200,1001040731,1000,'[{1,0},{2,0},{4,60}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(207020019,0,0,2070200,1007010731,1000,'[{1,60},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(207020020,0,0,2070200,1007020731,1000,'[{1,0},{2,60},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(207020021,0,0,2070200,1007040731,1000,'[{1,0},{2,0},{4,60}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(207020022,0,0,2070200,1003000731,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(207020023,0,0,2070200,1002010741,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(207020024,0,0,2070200,1002020741,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(207020025,0,0,2070200,1002040741,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(207020026,0,0,2070200,1004010741,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(207020027,0,0,2070200,1004020741,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(207020028,0,0,2070200,1004040741,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(207020029,0,0,2070200,1006010741,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(207020030,0,0,2070200,1006020741,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(207020031,0,0,2070200,1006040741,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(207020032,0,0,2070200,1008010741,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(207020033,0,0,2070200,1008020741,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(207020034,0,0,2070200,1008040741,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(207020035,0,0,2070200,1010010741,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(207020036,0,0,2070200,1010020741,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(207020037,0,0,2070200,1010040741,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(207020038,0,0,2070200,1001010741,1000,'[{1,40},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(207020039,0,0,2070200,1001020741,1000,'[{1,0},{2,40},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(207020040,0,0,2070200,1001040741,1000,'[{1,0},{2,0},{4,40}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(207020041,0,0,2070200,1007010741,1000,'[{1,40},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(207020042,0,0,2070200,1007020741,1000,'[{1,0},{2,40},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(207020043,0,0,2070200,1007040741,1000,'[{1,0},{2,0},{4,40}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(207020044,0,0,2070200,1003000741,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[]',0,0,0,0,'[]'),(207030101,0,0,2070301,1002010732,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(207030102,0,0,2070301,1002020732,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(207030103,0,0,2070301,1002040732,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(207030104,0,0,2070301,1004010732,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(207030105,0,0,2070301,1004020732,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(207030106,0,0,2070301,1004040732,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(207030107,0,0,2070301,1006010732,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(207030108,0,0,2070301,1006020732,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(207030109,0,0,2070301,1006040732,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(207030110,0,0,2070301,1008010732,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(207030111,0,0,2070301,1008020732,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(207030112,0,0,2070301,1008040732,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(207030113,0,0,2070301,1010010732,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(207030114,0,0,2070301,1010020732,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(207030115,0,0,2070301,1010040732,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(207030116,0,0,2070301,1002010742,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(207030117,0,0,2070301,1002020742,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(207030118,0,0,2070301,1002040742,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(207030119,0,0,2070301,1004010742,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(207030120,0,0,2070301,1004020742,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(207030121,0,0,2070301,1004040742,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(207030122,0,0,2070301,1006010742,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(207030123,0,0,2070301,1006020742,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(207030124,0,0,2070301,1006040742,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(207030125,0,0,2070301,1008010742,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(207030126,0,0,2070301,1008020742,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(207030127,0,0,2070301,1008040742,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(207030128,0,0,2070301,1010010742,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(207030129,0,0,2070301,1010020742,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(207030130,0,0,2070301,1010040742,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(207030201,0,0,2070302,1001010732,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(207030202,0,0,2070302,1001020732,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(207030203,0,0,2070302,1001040732,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(207030204,0,0,2070302,1007010732,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(207030205,0,0,2070302,1007020732,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(207030206,0,0,2070302,1007040732,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(207030207,0,0,2070302,1003000732,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(207030208,0,0,2070302,1001010742,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(207030209,0,0,2070302,1001020742,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(207030210,0,0,2070302,1001040742,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(207030211,0,0,2070302,1007010742,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(207030212,0,0,2070302,1007020742,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(207030213,0,0,2070302,1007040742,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(207030214,0,0,2070302,1003000742,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(208010001,0,0,2080100,1002010810,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(208010002,0,0,2080100,1002020810,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(208010003,0,0,2080100,1002040810,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(208010004,0,0,2080100,1004010810,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(208010005,0,0,2080100,1004020810,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(208010006,0,0,2080100,1004040810,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(208010007,0,0,2080100,1006010810,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(208010008,0,0,2080100,1006020810,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(208010009,0,0,2080100,1006040810,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(208010010,0,0,2080100,1008010810,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(208010011,0,0,2080100,1008020810,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(208010012,0,0,2080100,1008040810,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(208010013,0,0,2080100,1010010810,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(208010014,0,0,2080100,1010020810,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(208010015,0,0,2080100,1010040810,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(208010016,0,0,2080100,1001010810,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(208010017,0,0,2080100,1001020810,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(208010018,0,0,2080100,1001040810,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(208010019,0,0,2080100,1007010810,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(208010020,0,0,2080100,1007020810,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(208010021,0,0,2080100,1007040810,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(208010022,0,0,2080100,1003000810,300,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','0',0,'[]',0,0,0,0,'[]'),(208010023,0,0,2080100,1002010820,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(208010024,0,0,2080100,1002020820,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(208010025,0,0,2080100,1002040820,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(208010026,0,0,2080100,1004010820,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(208010027,0,0,2080100,1004020820,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(208010028,0,0,2080100,1004040820,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(208010029,0,0,2080100,1006010820,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(208010030,0,0,2080100,1006020820,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(208010031,0,0,2080100,1006040820,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(208010032,0,0,2080100,1008010820,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(208010033,0,0,2080100,1008020820,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(208010034,0,0,2080100,1008040820,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(208010035,0,0,2080100,1010010820,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(208010036,0,0,2080100,1010020820,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(208010037,0,0,2080100,1010040820,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(208010038,0,0,2080100,1001010820,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(208010039,0,0,2080100,1001020820,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(208010040,0,0,2080100,1001040820,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(208010041,0,0,2080100,1007010820,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(208010042,0,0,2080100,1007020820,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(208010043,0,0,2080100,1007040820,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(208010044,0,0,2080100,1003000820,300,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(208020001,0,0,2080200,1002010831,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(208020002,0,0,2080200,1002020831,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(208020003,0,0,2080200,1002040831,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(208020004,0,0,2080200,1004010831,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(208020005,0,0,2080200,1004020831,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(208020006,0,0,2080200,1004040831,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(208020007,0,0,2080200,1006010831,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(208020008,0,0,2080200,1006020831,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(208020009,0,0,2080200,1006040831,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(208020010,0,0,2080200,1008010831,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(208020011,0,0,2080200,1008020831,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(208020012,0,0,2080200,1008040831,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(208020013,0,0,2080200,1010010831,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(208020014,0,0,2080200,1010020831,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(208020015,0,0,2080200,1010040831,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(208020016,0,0,2080200,1001010831,1000,'[{1,60},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(208020017,0,0,2080200,1001020831,1000,'[{1,0},{2,60},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(208020018,0,0,2080200,1001040831,1000,'[{1,0},{2,0},{4,60}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(208020019,0,0,2080200,1007010831,1000,'[{1,60},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(208020020,0,0,2080200,1007020831,1000,'[{1,0},{2,60},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(208020021,0,0,2080200,1007040831,1000,'[{1,0},{2,0},{4,60}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(208020022,0,0,2080200,1003000831,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(208020023,0,0,2080200,1002010841,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(208020024,0,0,2080200,1002020841,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(208020025,0,0,2080200,1002040841,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(208020026,0,0,2080200,1004010841,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(208020027,0,0,2080200,1004020841,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(208020028,0,0,2080200,1004040841,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(208020029,0,0,2080200,1006010841,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(208020030,0,0,2080200,1006020841,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(208020031,0,0,2080200,1006040841,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(208020032,0,0,2080200,1008010841,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(208020033,0,0,2080200,1008020841,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(208020034,0,0,2080200,1008040841,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(208020035,0,0,2080200,1010010841,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(208020036,0,0,2080200,1010020841,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(208020037,0,0,2080200,1010040841,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(208020038,0,0,2080200,1001010841,1000,'[{1,40},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(208020039,0,0,2080200,1001020841,1000,'[{1,0},{2,40},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(208020040,0,0,2080200,1001040841,1000,'[{1,0},{2,0},{4,40}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(208020041,0,0,2080200,1007010841,1000,'[{1,40},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(208020042,0,0,2080200,1007020841,1000,'[{1,0},{2,40},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(208020043,0,0,2080200,1007040841,1000,'[{1,0},{2,0},{4,40}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(208020044,0,0,2080200,1003000841,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[]',0,0,0,0,'[]'),(208030101,0,0,2080301,1002010832,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(208030102,0,0,2080301,1002020832,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(208030103,0,0,2080301,1002040832,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(208030104,0,0,2080301,1004010832,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(208030105,0,0,2080301,1004020832,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(208030106,0,0,2080301,1004040832,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(208030107,0,0,2080301,1006010832,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(208030108,0,0,2080301,1006020832,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(208030109,0,0,2080301,1006040832,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(208030110,0,0,2080301,1008010832,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(208030111,0,0,2080301,1008020832,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(208030112,0,0,2080301,1008040832,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(208030113,0,0,2080301,1010010832,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(208030114,0,0,2080301,1010020832,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(208030115,0,0,2080301,1010040832,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(208030116,0,0,2080301,1002010842,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(208030117,0,0,2080301,1002020842,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(208030118,0,0,2080301,1002040842,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(208030119,0,0,2080301,1004010842,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(208030120,0,0,2080301,1004020842,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(208030121,0,0,2080301,1004040842,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(208030122,0,0,2080301,1006010842,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(208030123,0,0,2080301,1006020842,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(208030124,0,0,2080301,1006040842,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(208030125,0,0,2080301,1008010842,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(208030126,0,0,2080301,1008020842,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(208030127,0,0,2080301,1008040842,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(208030128,0,0,2080301,1010010842,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(208030129,0,0,2080301,1010020842,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(208030130,0,0,2080301,1010040842,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(208030201,0,0,2080302,1001010832,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(208030202,0,0,2080302,1001020832,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(208030203,0,0,2080302,1001040832,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(208030204,0,0,2080302,1007010832,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(208030205,0,0,2080302,1007020832,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(208030206,0,0,2080302,1007040832,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(208030207,0,0,2080302,1003000832,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(208030208,0,0,2080302,1001010842,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(208030209,0,0,2080302,1001020842,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(208030210,0,0,2080302,1001040842,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(208030211,0,0,2080302,1007010842,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(208030212,0,0,2080302,1007020842,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(208030213,0,0,2080302,1007040842,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(208030214,0,0,2080302,1003000842,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(209010001,0,0,2090100,1002010910,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(209010002,0,0,2090100,1002020910,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(209010003,0,0,2090100,1002040910,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(209010004,0,0,2090100,1004010910,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(209010005,0,0,2090100,1004020910,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(209010006,0,0,2090100,1004040910,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(209010007,0,0,2090100,1006010910,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(209010008,0,0,2090100,1006020910,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(209010009,0,0,2090100,1006040910,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(209010010,0,0,2090100,1008010910,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(209010011,0,0,2090100,1008020910,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(209010012,0,0,2090100,1008040910,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(209010013,0,0,2090100,1010010910,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(209010014,0,0,2090100,1010020910,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(209010015,0,0,2090100,1010040910,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(209010016,0,0,2090100,1001010910,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(209010017,0,0,2090100,1001020910,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(209010018,0,0,2090100,1001040910,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(209010019,0,0,2090100,1007010910,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(209010020,0,0,2090100,1007020910,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(209010021,0,0,2090100,1007040910,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(209010022,0,0,2090100,1003000910,300,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','0',0,'[]',0,0,0,0,'[]'),(209010023,0,0,2090100,1002010920,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(209010024,0,0,2090100,1002020920,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(209010025,0,0,2090100,1002040920,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(209010026,0,0,2090100,1004010920,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(209010027,0,0,2090100,1004020920,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(209010028,0,0,2090100,1004040920,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(209010029,0,0,2090100,1006010920,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(209010030,0,0,2090100,1006020920,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(209010031,0,0,2090100,1006040920,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(209010032,0,0,2090100,1008010920,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(209010033,0,0,2090100,1008020920,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(209010034,0,0,2090100,1008040920,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(209010035,0,0,2090100,1010010920,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(209010036,0,0,2090100,1010020920,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(209010037,0,0,2090100,1010040920,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(209010038,0,0,2090100,1001010920,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(209010039,0,0,2090100,1001020920,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(209010040,0,0,2090100,1001040920,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(209010041,0,0,2090100,1007010920,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(209010042,0,0,2090100,1007020920,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(209010043,0,0,2090100,1007040920,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(209010044,0,0,2090100,1003000920,300,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(209020001,0,0,2090200,1002010931,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(209020002,0,0,2090200,1002020931,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(209020003,0,0,2090200,1002040931,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(209020004,0,0,2090200,1004010931,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(209020005,0,0,2090200,1004020931,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(209020006,0,0,2090200,1004040931,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(209020007,0,0,2090200,1006010931,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(209020008,0,0,2090200,1006020931,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(209020009,0,0,2090200,1006040931,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(209020010,0,0,2090200,1008010931,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(209020011,0,0,2090200,1008020931,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(209020012,0,0,2090200,1008040931,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(209020013,0,0,2090200,1010010931,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(209020014,0,0,2090200,1010020931,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(209020015,0,0,2090200,1010040931,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(209020016,0,0,2090200,1001010931,1000,'[{1,60},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(209020017,0,0,2090200,1001020931,1000,'[{1,0},{2,60},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(209020018,0,0,2090200,1001040931,1000,'[{1,0},{2,0},{4,60}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(209020019,0,0,2090200,1007010931,1000,'[{1,60},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(209020020,0,0,2090200,1007020931,1000,'[{1,0},{2,60},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(209020021,0,0,2090200,1007040931,1000,'[{1,0},{2,0},{4,60}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(209020022,0,0,2090200,1003000931,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(209020023,0,0,2090200,1002010941,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(209020024,0,0,2090200,1002020941,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(209020025,0,0,2090200,1002040941,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(209020026,0,0,2090200,1004010941,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(209020027,0,0,2090200,1004020941,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(209020028,0,0,2090200,1004040941,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(209020029,0,0,2090200,1006010941,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(209020030,0,0,2090200,1006020941,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(209020031,0,0,2090200,1006040941,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(209020032,0,0,2090200,1008010941,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(209020033,0,0,2090200,1008020941,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(209020034,0,0,2090200,1008040941,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(209020035,0,0,2090200,1010010941,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(209020036,0,0,2090200,1010020941,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(209020037,0,0,2090200,1010040941,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(209020038,0,0,2090200,1001010941,1000,'[{1,40},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(209020039,0,0,2090200,1001020941,1000,'[{1,0},{2,40},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(209020040,0,0,2090200,1001040941,1000,'[{1,0},{2,0},{4,40}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(209020041,0,0,2090200,1007010941,1000,'[{1,40},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(209020042,0,0,2090200,1007020941,1000,'[{1,0},{2,40},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(209020043,0,0,2090200,1007040941,1000,'[{1,0},{2,0},{4,40}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(209020044,0,0,2090200,1003000941,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[]',0,0,0,0,'[]'),(209030101,0,0,2090301,1002010932,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(209030102,0,0,2090301,1002020932,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(209030103,0,0,2090301,1002040932,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(209030104,0,0,2090301,1004010932,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(209030105,0,0,2090301,1004020932,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(209030106,0,0,2090301,1004040932,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(209030107,0,0,2090301,1006010932,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(209030108,0,0,2090301,1006020932,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(209030109,0,0,2090301,1006040932,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(209030110,0,0,2090301,1008010932,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(209030111,0,0,2090301,1008020932,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(209030112,0,0,2090301,1008040932,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(209030113,0,0,2090301,1010010932,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(209030114,0,0,2090301,1010020932,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(209030115,0,0,2090301,1010040932,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(209030116,0,0,2090301,1002010942,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(209030117,0,0,2090301,1002020942,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(209030118,0,0,2090301,1002040942,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(209030119,0,0,2090301,1004010942,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(209030120,0,0,2090301,1004020942,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(209030121,0,0,2090301,1004040942,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(209030122,0,0,2090301,1006010942,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(209030123,0,0,2090301,1006020942,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(209030124,0,0,2090301,1006040942,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(209030125,0,0,2090301,1008010942,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(209030126,0,0,2090301,1008020942,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(209030127,0,0,2090301,1008040942,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(209030128,0,0,2090301,1010010942,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(209030129,0,0,2090301,1010020942,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(209030130,0,0,2090301,1010040942,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(209030201,0,0,2090302,1001010932,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(209030202,0,0,2090302,1001020932,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(209030203,0,0,2090302,1001040932,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(209030204,0,0,2090302,1007010932,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(209030205,0,0,2090302,1007020932,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(209030206,0,0,2090302,1007040932,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(209030207,0,0,2090302,1003000932,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(209030208,0,0,2090302,1001010942,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(209030209,0,0,2090302,1001020942,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(209030210,0,0,2090302,1001040942,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(209030211,0,0,2090302,1007010942,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(209030212,0,0,2090302,1007020942,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(209030213,0,0,2090302,1007040942,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(209030214,0,0,2090302,1003000942,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(210010001,0,0,2100100,1002011010,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(210010002,0,0,2100100,1002021010,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(210010003,0,0,2100100,1002041010,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(210010004,0,0,2100100,1004011010,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(210010005,0,0,2100100,1004021010,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(210010006,0,0,2100100,1004041010,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(210010007,0,0,2100100,1006011010,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(210010008,0,0,2100100,1006021010,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(210010009,0,0,2100100,1006041010,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(210010010,0,0,2100100,1008011010,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(210010011,0,0,2100100,1008021010,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(210010012,0,0,2100100,1008041010,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(210010013,0,0,2100100,1010011010,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(210010014,0,0,2100100,1010021010,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(210010015,0,0,2100100,1010041010,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(210010016,0,0,2100100,1001011010,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(210010017,0,0,2100100,1001021010,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(210010018,0,0,2100100,1001041010,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(210010019,0,0,2100100,1007011010,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(210010020,0,0,2100100,1007021010,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(210010021,0,0,2100100,1007041010,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(210010022,0,0,2100100,1003001010,300,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','0',0,'[]',0,0,0,0,'[]'),(210010023,0,0,2100100,1002011020,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(210010024,0,0,2100100,1002021020,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(210010025,0,0,2100100,1002041020,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(210010026,0,0,2100100,1004011020,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(210010027,0,0,2100100,1004021020,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(210010028,0,0,2100100,1004041020,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(210010029,0,0,2100100,1006011020,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(210010030,0,0,2100100,1006021020,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(210010031,0,0,2100100,1006041020,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(210010032,0,0,2100100,1008011020,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(210010033,0,0,2100100,1008021020,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(210010034,0,0,2100100,1008041020,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(210010035,0,0,2100100,1010011020,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(210010036,0,0,2100100,1010021020,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(210010037,0,0,2100100,1010041020,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(210010038,0,0,2100100,1001011020,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(210010039,0,0,2100100,1001021020,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(210010040,0,0,2100100,1001041020,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(210010041,0,0,2100100,1007011020,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(210010042,0,0,2100100,1007021020,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(210010043,0,0,2100100,1007041020,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(210010044,0,0,2100100,1003001020,300,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(210020001,0,0,2100200,1002011031,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(210020002,0,0,2100200,1002021031,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(210020003,0,0,2100200,1002041031,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(210020004,0,0,2100200,1004011031,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(210020005,0,0,2100200,1004021031,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(210020006,0,0,2100200,1004041031,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(210020007,0,0,2100200,1006011031,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(210020008,0,0,2100200,1006021031,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(210020009,0,0,2100200,1006041031,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(210020010,0,0,2100200,1008011031,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(210020011,0,0,2100200,1008021031,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(210020012,0,0,2100200,1008041031,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(210020013,0,0,2100200,1010011031,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(210020014,0,0,2100200,1010021031,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(210020015,0,0,2100200,1010041031,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(210020016,0,0,2100200,1001011031,1000,'[{1,60},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(210020017,0,0,2100200,1001021031,1000,'[{1,0},{2,60},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(210020018,0,0,2100200,1001041031,1000,'[{1,0},{2,0},{4,60}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(210020019,0,0,2100200,1007011031,1000,'[{1,60},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(210020020,0,0,2100200,1007021031,1000,'[{1,0},{2,60},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(210020021,0,0,2100200,1007041031,1000,'[{1,0},{2,0},{4,60}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(210020022,0,0,2100200,1003001031,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(210020023,0,0,2100200,1002011041,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(210020024,0,0,2100200,1002021041,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(210020025,0,0,2100200,1002041041,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(210020026,0,0,2100200,1004011041,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(210020027,0,0,2100200,1004021041,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(210020028,0,0,2100200,1004041041,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(210020029,0,0,2100200,1006011041,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(210020030,0,0,2100200,1006021041,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(210020031,0,0,2100200,1006041041,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(210020032,0,0,2100200,1008011041,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(210020033,0,0,2100200,1008021041,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(210020034,0,0,2100200,1008041041,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(210020035,0,0,2100200,1010011041,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(210020036,0,0,2100200,1010021041,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(210020037,0,0,2100200,1010041041,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(210020038,0,0,2100200,1001011041,1000,'[{1,40},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(210020039,0,0,2100200,1001021041,1000,'[{1,0},{2,40},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(210020040,0,0,2100200,1001041041,1000,'[{1,0},{2,0},{4,40}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(210020041,0,0,2100200,1007011041,1000,'[{1,40},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(210020042,0,0,2100200,1007021041,1000,'[{1,0},{2,40},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(210020043,0,0,2100200,1007041041,1000,'[{1,0},{2,0},{4,40}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(210020044,0,0,2100200,1003001041,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[]',0,0,0,0,'[]'),(210030101,0,0,2100301,1002011032,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(210030102,0,0,2100301,1002021032,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(210030103,0,0,2100301,1002041032,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(210030104,0,0,2100301,1004011032,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(210030105,0,0,2100301,1004021032,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(210030106,0,0,2100301,1004041032,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(210030107,0,0,2100301,1006011032,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(210030108,0,0,2100301,1006021032,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(210030109,0,0,2100301,1006041032,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(210030110,0,0,2100301,1008011032,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(210030111,0,0,2100301,1008021032,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(210030112,0,0,2100301,1008041032,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(210030113,0,0,2100301,1010011032,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(210030114,0,0,2100301,1010021032,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(210030115,0,0,2100301,1010041032,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(210030116,0,0,2100301,1002011042,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(210030117,0,0,2100301,1002021042,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(210030118,0,0,2100301,1002041042,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(210030119,0,0,2100301,1004011042,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(210030120,0,0,2100301,1004021042,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(210030121,0,0,2100301,1004041042,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(210030122,0,0,2100301,1006011042,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(210030123,0,0,2100301,1006021042,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(210030124,0,0,2100301,1006041042,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(210030125,0,0,2100301,1008011042,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(210030126,0,0,2100301,1008021042,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(210030127,0,0,2100301,1008041042,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(210030128,0,0,2100301,1010011042,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(210030129,0,0,2100301,1010021042,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(210030130,0,0,2100301,1010041042,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(210030201,0,0,2100302,1001011032,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(210030202,0,0,2100302,1001021032,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(210030203,0,0,2100302,1001041032,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(210030204,0,0,2100302,1007011032,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(210030205,0,0,2100302,1007021032,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(210030206,0,0,2100302,1007041032,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(210030207,0,0,2100302,1003001032,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(210030208,0,0,2100302,1001011042,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(210030209,0,0,2100302,1001021042,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(210030210,0,0,2100302,1001041042,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(210030211,0,0,2100302,1007011042,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(210030212,0,0,2100302,1007021042,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(210030213,0,0,2100302,1007041042,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(210030214,0,0,2100302,1003001042,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(211010001,0,0,2110100,1002011110,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(211010002,0,0,2110100,1002021110,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(211010003,0,0,2110100,1002041110,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(211010004,0,0,2110100,1004011110,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(211010005,0,0,2110100,1004021110,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(211010006,0,0,2110100,1004041110,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(211010007,0,0,2110100,1006011110,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(211010008,0,0,2110100,1006021110,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(211010009,0,0,2110100,1006041110,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(211010010,0,0,2110100,1008011110,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(211010011,0,0,2110100,1008021110,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(211010012,0,0,2110100,1008041110,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(211010013,0,0,2110100,1010011110,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(211010014,0,0,2110100,1010021110,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(211010015,0,0,2110100,1010041110,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(211010016,0,0,2110100,1001011110,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(211010017,0,0,2110100,1001021110,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(211010018,0,0,2110100,1001041110,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(211010019,0,0,2110100,1007011110,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(211010020,0,0,2110100,1007021110,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(211010021,0,0,2110100,1007041110,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(211010022,0,0,2110100,1003001110,300,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','0',0,'[]',0,0,0,0,'[]'),(211010023,0,0,2110100,1002011120,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(211010024,0,0,2110100,1002021120,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(211010025,0,0,2110100,1002041120,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(211010026,0,0,2110100,1004011120,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(211010027,0,0,2110100,1004021120,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(211010028,0,0,2110100,1004041120,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(211010029,0,0,2110100,1006011120,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(211010030,0,0,2110100,1006021120,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(211010031,0,0,2110100,1006041120,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(211010032,0,0,2110100,1008011120,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(211010033,0,0,2110100,1008021120,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(211010034,0,0,2110100,1008041120,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(211010035,0,0,2110100,1010011120,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(211010036,0,0,2110100,1010021120,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(211010037,0,0,2110100,1010041120,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(211010038,0,0,2110100,1001011120,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(211010039,0,0,2110100,1001021120,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(211010040,0,0,2110100,1001041120,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(211010041,0,0,2110100,1007011120,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(211010042,0,0,2110100,1007021120,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(211010043,0,0,2110100,1007041120,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(211010044,0,0,2110100,1003001120,300,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(211020001,0,0,2110200,1002011131,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(211020002,0,0,2110200,1002021131,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(211020003,0,0,2110200,1002041131,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(211020004,0,0,2110200,1004011131,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(211020005,0,0,2110200,1004021131,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(211020006,0,0,2110200,1004041131,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(211020007,0,0,2110200,1006011131,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(211020008,0,0,2110200,1006021131,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(211020009,0,0,2110200,1006041131,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(211020010,0,0,2110200,1008011131,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(211020011,0,0,2110200,1008021131,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(211020012,0,0,2110200,1008041131,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(211020013,0,0,2110200,1010011131,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(211020014,0,0,2110200,1010021131,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(211020015,0,0,2110200,1010041131,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(211020016,0,0,2110200,1001011131,1000,'[{1,60},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(211020017,0,0,2110200,1001021131,1000,'[{1,0},{2,60},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(211020018,0,0,2110200,1001041131,1000,'[{1,0},{2,0},{4,60}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(211020019,0,0,2110200,1007011131,1000,'[{1,60},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(211020020,0,0,2110200,1007021131,1000,'[{1,0},{2,60},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(211020021,0,0,2110200,1007041131,1000,'[{1,0},{2,0},{4,60}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(211020022,0,0,2110200,1003001131,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(211020023,0,0,2110200,1002011141,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(211020024,0,0,2110200,1002021141,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(211020025,0,0,2110200,1002041141,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(211020026,0,0,2110200,1004011141,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(211020027,0,0,2110200,1004021141,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(211020028,0,0,2110200,1004041141,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(211020029,0,0,2110200,1006011141,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(211020030,0,0,2110200,1006021141,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(211020031,0,0,2110200,1006041141,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(211020032,0,0,2110200,1008011141,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(211020033,0,0,2110200,1008021141,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(211020034,0,0,2110200,1008041141,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(211020035,0,0,2110200,1010011141,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(211020036,0,0,2110200,1010021141,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(211020037,0,0,2110200,1010041141,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(211020038,0,0,2110200,1001011141,1000,'[{1,40},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(211020039,0,0,2110200,1001021141,1000,'[{1,0},{2,40},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(211020040,0,0,2110200,1001041141,1000,'[{1,0},{2,0},{4,40}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(211020041,0,0,2110200,1007011141,1000,'[{1,40},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(211020042,0,0,2110200,1007021141,1000,'[{1,0},{2,40},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(211020043,0,0,2110200,1007041141,1000,'[{1,0},{2,0},{4,40}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(211020044,0,0,2110200,1003001141,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[]',0,0,0,0,'[]'),(211030101,0,0,2110301,1002011132,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(211030102,0,0,2110301,1002021132,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(211030103,0,0,2110301,1002041132,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(211030104,0,0,2110301,1004011132,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(211030105,0,0,2110301,1004021132,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(211030106,0,0,2110301,1004041132,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(211030107,0,0,2110301,1006011132,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]');
INSERT INTO `base_drop_goods` VALUES (211030108,0,0,2110301,1006021132,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(211030109,0,0,2110301,1006041132,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(211030110,0,0,2110301,1008011132,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(211030111,0,0,2110301,1008021132,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(211030112,0,0,2110301,1008041132,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(211030113,0,0,2110301,1010011132,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(211030114,0,0,2110301,1010021132,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(211030115,0,0,2110301,1010041132,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(211030116,0,0,2110301,1002011142,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(211030117,0,0,2110301,1002021142,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(211030118,0,0,2110301,1002041142,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(211030119,0,0,2110301,1004011142,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(211030120,0,0,2110301,1004021142,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(211030121,0,0,2110301,1004041142,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(211030122,0,0,2110301,1006011142,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(211030123,0,0,2110301,1006021142,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(211030124,0,0,2110301,1006041142,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(211030125,0,0,2110301,1008011142,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(211030126,0,0,2110301,1008021142,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(211030127,0,0,2110301,1008041142,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(211030128,0,0,2110301,1010011142,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(211030129,0,0,2110301,1010021142,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(211030130,0,0,2110301,1010041142,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(211030201,0,0,2110302,1001011132,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(211030202,0,0,2110302,1001021132,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(211030203,0,0,2110302,1001041132,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(211030204,0,0,2110302,1007011132,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(211030205,0,0,2110302,1007021132,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(211030206,0,0,2110302,1007041132,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(211030207,0,0,2110302,1003001132,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(211030208,0,0,2110302,1001011142,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(211030209,0,0,2110302,1001021142,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(211030210,0,0,2110302,1001041142,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(211030211,0,0,2110302,1007011142,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(211030212,0,0,2110302,1007021142,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(211030213,0,0,2110302,1007041142,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(211030214,0,0,2110302,1003001142,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(212010001,0,0,2120100,1002011210,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(212010002,0,0,2120100,1002021210,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(212010003,0,0,2120100,1002041210,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(212010004,0,0,2120100,1004011210,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(212010005,0,0,2120100,1004021210,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(212010006,0,0,2120100,1004041210,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(212010007,0,0,2120100,1006011210,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(212010008,0,0,2120100,1006021210,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(212010009,0,0,2120100,1006041210,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(212010010,0,0,2120100,1008011210,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(212010011,0,0,2120100,1008021210,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(212010012,0,0,2120100,1008041210,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(212010013,0,0,2120100,1010011210,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(212010014,0,0,2120100,1010021210,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(212010015,0,0,2120100,1010041210,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(212010016,0,0,2120100,1001011210,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(212010017,0,0,2120100,1001021210,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(212010018,0,0,2120100,1001041210,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(212010019,0,0,2120100,1007011210,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(212010020,0,0,2120100,1007021210,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(212010021,0,0,2120100,1007041210,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(212010022,0,0,2120100,1003001210,300,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','0',0,'[]',0,0,0,0,'[]'),(212010023,0,0,2120100,1002011220,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(212010024,0,0,2120100,1002021220,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(212010025,0,0,2120100,1002041220,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(212010026,0,0,2120100,1004011220,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(212010027,0,0,2120100,1004021220,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(212010028,0,0,2120100,1004041220,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(212010029,0,0,2120100,1006011220,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(212010030,0,0,2120100,1006021220,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(212010031,0,0,2120100,1006041220,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(212010032,0,0,2120100,1008011220,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(212010033,0,0,2120100,1008021220,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(212010034,0,0,2120100,1008041220,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(212010035,0,0,2120100,1010011220,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(212010036,0,0,2120100,1010021220,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(212010037,0,0,2120100,1010041220,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(212010038,0,0,2120100,1001011220,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(212010039,0,0,2120100,1001021220,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(212010040,0,0,2120100,1001041220,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(212010041,0,0,2120100,1007011220,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(212010042,0,0,2120100,1007021220,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(212010043,0,0,2120100,1007041220,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(212010044,0,0,2120100,1003001220,300,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(212020001,0,0,2120200,1002011231,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(212020002,0,0,2120200,1002021231,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(212020003,0,0,2120200,1002041231,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(212020004,0,0,2120200,1004011231,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(212020005,0,0,2120200,1004021231,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(212020006,0,0,2120200,1004041231,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(212020007,0,0,2120200,1006011231,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(212020008,0,0,2120200,1006021231,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(212020009,0,0,2120200,1006041231,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(212020010,0,0,2120200,1008011231,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(212020011,0,0,2120200,1008021231,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(212020012,0,0,2120200,1008041231,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(212020013,0,0,2120200,1010011231,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(212020014,0,0,2120200,1010021231,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(212020015,0,0,2120200,1010041231,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(212020016,0,0,2120200,1001011231,1000,'[{1,60},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(212020017,0,0,2120200,1001021231,1000,'[{1,0},{2,60},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(212020018,0,0,2120200,1001041231,1000,'[{1,0},{2,0},{4,60}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(212020019,0,0,2120200,1007011231,1000,'[{1,60},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(212020020,0,0,2120200,1007021231,1000,'[{1,0},{2,60},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(212020021,0,0,2120200,1007041231,1000,'[{1,0},{2,0},{4,60}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(212020022,0,0,2120200,1003001231,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(212020023,0,0,2120200,1002011241,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(212020024,0,0,2120200,1002021241,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(212020025,0,0,2120200,1002041241,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(212020026,0,0,2120200,1004011241,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(212020027,0,0,2120200,1004021241,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(212020028,0,0,2120200,1004041241,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(212020029,0,0,2120200,1006011241,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(212020030,0,0,2120200,1006021241,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(212020031,0,0,2120200,1006041241,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(212020032,0,0,2120200,1008011241,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(212020033,0,0,2120200,1008021241,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(212020034,0,0,2120200,1008041241,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(212020035,0,0,2120200,1010011241,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(212020036,0,0,2120200,1010021241,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(212020037,0,0,2120200,1010041241,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(212020038,0,0,2120200,1001011241,1000,'[{1,40},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(212020039,0,0,2120200,1001021241,1000,'[{1,0},{2,40},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(212020040,0,0,2120200,1001041241,1000,'[{1,0},{2,0},{4,40}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(212020041,0,0,2120200,1007011241,1000,'[{1,40},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(212020042,0,0,2120200,1007021241,1000,'[{1,0},{2,40},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(212020043,0,0,2120200,1007041241,1000,'[{1,0},{2,0},{4,40}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(212020044,0,0,2120200,1003001241,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[]',0,0,0,0,'[]'),(212030101,0,0,2120301,1002011232,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(212030102,0,0,2120301,1002021232,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(212030103,0,0,2120301,1002041232,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(212030104,0,0,2120301,1004011232,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(212030105,0,0,2120301,1004021232,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(212030106,0,0,2120301,1004041232,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(212030107,0,0,2120301,1006011232,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(212030108,0,0,2120301,1006021232,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(212030109,0,0,2120301,1006041232,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(212030110,0,0,2120301,1008011232,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(212030111,0,0,2120301,1008021232,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(212030112,0,0,2120301,1008041232,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(212030113,0,0,2120301,1010011232,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(212030114,0,0,2120301,1010021232,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(212030115,0,0,2120301,1010041232,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(212030116,0,0,2120301,1002011242,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(212030117,0,0,2120301,1002021242,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(212030118,0,0,2120301,1002041242,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(212030119,0,0,2120301,1004011242,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(212030120,0,0,2120301,1004021242,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(212030121,0,0,2120301,1004041242,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(212030122,0,0,2120301,1006011242,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(212030123,0,0,2120301,1006021242,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(212030124,0,0,2120301,1006041242,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(212030125,0,0,2120301,1008011242,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(212030126,0,0,2120301,1008021242,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(212030127,0,0,2120301,1008041242,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(212030128,0,0,2120301,1010011242,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(212030129,0,0,2120301,1010021242,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(212030130,0,0,2120301,1010041242,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(212030201,0,0,2120302,1001011232,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(212030202,0,0,2120302,1001021232,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(212030203,0,0,2120302,1001041232,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(212030204,0,0,2120302,1007011232,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(212030205,0,0,2120302,1007021232,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(212030206,0,0,2120302,1007041232,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(212030207,0,0,2120302,1003001232,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(212030208,0,0,2120302,1001011242,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(212030209,0,0,2120302,1001021242,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(212030210,0,0,2120302,1001041242,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(212030211,0,0,2120302,1007011242,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(212030212,0,0,2120302,1007021242,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(212030213,0,0,2120302,1007041242,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(212030214,0,0,2120302,1003001242,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(213010001,0,0,2130100,1002011310,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(213010002,0,0,2130100,1002021310,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(213010003,0,0,2130100,1002041310,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(213010004,0,0,2130100,1004011310,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(213010005,0,0,2130100,1004021310,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(213010006,0,0,2130100,1004041310,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(213010007,0,0,2130100,1006011310,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(213010008,0,0,2130100,1006021310,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(213010009,0,0,2130100,1006041310,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(213010010,0,0,2130100,1008011310,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(213010011,0,0,2130100,1008021310,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(213010012,0,0,2130100,1008041310,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(213010013,0,0,2130100,1010011310,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(213010014,0,0,2130100,1010021310,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(213010015,0,0,2130100,1010041310,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(213010016,0,0,2130100,1001011310,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(213010017,0,0,2130100,1001021310,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(213010018,0,0,2130100,1001041310,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(213010019,0,0,2130100,1007011310,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(213010020,0,0,2130100,1007021310,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(213010021,0,0,2130100,1007041310,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(213010022,0,0,2130100,1003001310,300,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','0',0,'[]',0,0,0,0,'[]'),(213010023,0,0,2130100,1002011320,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(213010024,0,0,2130100,1002021320,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(213010025,0,0,2130100,1002041320,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(213010026,0,0,2130100,1004011320,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(213010027,0,0,2130100,1004021320,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(213010028,0,0,2130100,1004041320,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(213010029,0,0,2130100,1006011320,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(213010030,0,0,2130100,1006021320,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(213010031,0,0,2130100,1006041320,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(213010032,0,0,2130100,1008011320,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(213010033,0,0,2130100,1008021320,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(213010034,0,0,2130100,1008041320,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(213010035,0,0,2130100,1010011320,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(213010036,0,0,2130100,1010021320,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(213010037,0,0,2130100,1010041320,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(213010038,0,0,2130100,1001011320,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(213010039,0,0,2130100,1001021320,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(213010040,0,0,2130100,1001041320,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(213010041,0,0,2130100,1007011320,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(213010042,0,0,2130100,1007021320,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(213010043,0,0,2130100,1007041320,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(213010044,0,0,2130100,1003001320,300,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(213020001,0,0,2130200,1002011331,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(213020002,0,0,2130200,1002021331,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(213020003,0,0,2130200,1002041331,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(213020004,0,0,2130200,1004011331,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(213020005,0,0,2130200,1004021331,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(213020006,0,0,2130200,1004041331,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(213020007,0,0,2130200,1006011331,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(213020008,0,0,2130200,1006021331,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(213020009,0,0,2130200,1006041331,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(213020010,0,0,2130200,1008011331,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(213020011,0,0,2130200,1008021331,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(213020012,0,0,2130200,1008041331,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(213020013,0,0,2130200,1010011331,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(213020014,0,0,2130200,1010021331,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(213020015,0,0,2130200,1010041331,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(213020016,0,0,2130200,1001011331,1000,'[{1,60},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(213020017,0,0,2130200,1001021331,1000,'[{1,0},{2,60},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(213020018,0,0,2130200,1001041331,1000,'[{1,0},{2,0},{4,60}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(213020019,0,0,2130200,1007011331,1000,'[{1,60},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(213020020,0,0,2130200,1007021331,1000,'[{1,0},{2,60},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(213020021,0,0,2130200,1007041331,1000,'[{1,0},{2,0},{4,60}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(213020022,0,0,2130200,1003001331,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(213020023,0,0,2130200,1002011341,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(213020024,0,0,2130200,1002021341,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(213020025,0,0,2130200,1002041341,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(213020026,0,0,2130200,1004011341,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(213020027,0,0,2130200,1004021341,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(213020028,0,0,2130200,1004041341,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(213020029,0,0,2130200,1006011341,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(213020030,0,0,2130200,1006021341,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(213020031,0,0,2130200,1006041341,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(213020032,0,0,2130200,1008011341,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(213020033,0,0,2130200,1008021341,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(213020034,0,0,2130200,1008041341,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(213020035,0,0,2130200,1010011341,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(213020036,0,0,2130200,1010021341,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(213020037,0,0,2130200,1010041341,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(213020038,0,0,2130200,1001011341,1000,'[{1,40},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(213020039,0,0,2130200,1001021341,1000,'[{1,0},{2,40},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(213020040,0,0,2130200,1001041341,1000,'[{1,0},{2,0},{4,40}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(213020041,0,0,2130200,1007011341,1000,'[{1,40},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(213020042,0,0,2130200,1007021341,1000,'[{1,0},{2,40},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(213020043,0,0,2130200,1007041341,1000,'[{1,0},{2,0},{4,40}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(213020044,0,0,2130200,1003001341,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[]',0,0,0,0,'[]'),(213030101,0,0,2130301,1002011332,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(213030102,0,0,2130301,1002021332,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(213030103,0,0,2130301,1002041332,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(213030104,0,0,2130301,1004011332,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(213030105,0,0,2130301,1004021332,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(213030106,0,0,2130301,1004041332,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(213030107,0,0,2130301,1006011332,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(213030108,0,0,2130301,1006021332,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(213030109,0,0,2130301,1006041332,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(213030110,0,0,2130301,1008011332,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(213030111,0,0,2130301,1008021332,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(213030112,0,0,2130301,1008041332,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(213030113,0,0,2130301,1010011332,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(213030114,0,0,2130301,1010021332,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(213030115,0,0,2130301,1010041332,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(213030116,0,0,2130301,1002011342,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(213030117,0,0,2130301,1002021342,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(213030118,0,0,2130301,1002041342,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(213030119,0,0,2130301,1004011342,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(213030120,0,0,2130301,1004021342,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(213030121,0,0,2130301,1004041342,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(213030122,0,0,2130301,1006011342,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(213030123,0,0,2130301,1006021342,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(213030124,0,0,2130301,1006041342,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(213030125,0,0,2130301,1008011342,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(213030126,0,0,2130301,1008021342,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(213030127,0,0,2130301,1008041342,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(213030128,0,0,2130301,1010011342,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(213030129,0,0,2130301,1010021342,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(213030130,0,0,2130301,1010041342,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(213030201,0,0,2130302,1001011332,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(213030202,0,0,2130302,1001021332,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(213030203,0,0,2130302,1001041332,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(213030204,0,0,2130302,1007011332,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(213030205,0,0,2130302,1007021332,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(213030206,0,0,2130302,1007041332,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(213030207,0,0,2130302,1003001332,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(213030208,0,0,2130302,1001011342,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(213030209,0,0,2130302,1001021342,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(213030210,0,0,2130302,1001041342,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(213030211,0,0,2130302,1007011342,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(213030212,0,0,2130302,1007021342,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(213030213,0,0,2130302,1007041342,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(213030214,0,0,2130302,1003001342,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(214010001,0,0,2140100,1002011410,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(214010002,0,0,2140100,1002021410,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(214010003,0,0,2140100,1002041410,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(214010004,0,0,2140100,1004011410,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(214010005,0,0,2140100,1004021410,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(214010006,0,0,2140100,1004041410,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(214010007,0,0,2140100,1006011410,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(214010008,0,0,2140100,1006021410,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(214010009,0,0,2140100,1006041410,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(214010010,0,0,2140100,1008011410,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(214010011,0,0,2140100,1008021410,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(214010012,0,0,2140100,1008041410,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(214010013,0,0,2140100,1010011410,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(214010014,0,0,2140100,1010021410,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(214010015,0,0,2140100,1010041410,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(214010016,0,0,2140100,1001011410,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(214010017,0,0,2140100,1001021410,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(214010018,0,0,2140100,1001041410,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(214010019,0,0,2140100,1007011410,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(214010020,0,0,2140100,1007021410,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(214010021,0,0,2140100,1007041410,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(214010022,0,0,2140100,1003001410,300,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','0',0,'[]',0,0,0,0,'[]'),(214010023,0,0,2140100,1002011420,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(214010024,0,0,2140100,1002021420,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(214010025,0,0,2140100,1002041420,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(214010026,0,0,2140100,1004011420,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(214010027,0,0,2140100,1004021420,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(214010028,0,0,2140100,1004041420,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(214010029,0,0,2140100,1006011420,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(214010030,0,0,2140100,1006021420,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(214010031,0,0,2140100,1006041420,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(214010032,0,0,2140100,1008011420,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(214010033,0,0,2140100,1008021420,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(214010034,0,0,2140100,1008041420,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(214010035,0,0,2140100,1010011420,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(214010036,0,0,2140100,1010021420,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(214010037,0,0,2140100,1010041420,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(214010038,0,0,2140100,1001011420,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(214010039,0,0,2140100,1001021420,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(214010040,0,0,2140100,1001041420,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(214010041,0,0,2140100,1007011420,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(214010042,0,0,2140100,1007021420,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(214010043,0,0,2140100,1007041420,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(214010044,0,0,2140100,1003001420,300,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(214020001,0,0,2140200,1002011431,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(214020002,0,0,2140200,1002021431,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(214020003,0,0,2140200,1002041431,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(214020004,0,0,2140200,1004011431,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(214020005,0,0,2140200,1004021431,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(214020006,0,0,2140200,1004041431,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(214020007,0,0,2140200,1006011431,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(214020008,0,0,2140200,1006021431,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(214020009,0,0,2140200,1006041431,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(214020010,0,0,2140200,1008011431,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(214020011,0,0,2140200,1008021431,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(214020012,0,0,2140200,1008041431,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(214020013,0,0,2140200,1010011431,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(214020014,0,0,2140200,1010021431,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(214020015,0,0,2140200,1010041431,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(214020016,0,0,2140200,1001011431,1000,'[{1,60},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(214020017,0,0,2140200,1001021431,1000,'[{1,0},{2,60},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(214020018,0,0,2140200,1001041431,1000,'[{1,0},{2,0},{4,60}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(214020019,0,0,2140200,1007011431,1000,'[{1,60},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(214020020,0,0,2140200,1007021431,1000,'[{1,0},{2,60},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(214020021,0,0,2140200,1007041431,1000,'[{1,0},{2,0},{4,60}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(214020022,0,0,2140200,1003001431,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(214020023,0,0,2140200,1002011441,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(214020024,0,0,2140200,1002021441,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(214020025,0,0,2140200,1002041441,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(214020026,0,0,2140200,1004011441,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(214020027,0,0,2140200,1004021441,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(214020028,0,0,2140200,1004041441,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(214020029,0,0,2140200,1006011441,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(214020030,0,0,2140200,1006021441,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(214020031,0,0,2140200,1006041441,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(214020032,0,0,2140200,1008011441,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(214020033,0,0,2140200,1008021441,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(214020034,0,0,2140200,1008041441,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(214020035,0,0,2140200,1010011441,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(214020036,0,0,2140200,1010021441,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(214020037,0,0,2140200,1010041441,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(214020038,0,0,2140200,1001011441,1000,'[{1,40},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(214020039,0,0,2140200,1001021441,1000,'[{1,0},{2,40},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(214020040,0,0,2140200,1001041441,1000,'[{1,0},{2,0},{4,40}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(214020041,0,0,2140200,1007011441,1000,'[{1,40},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(214020042,0,0,2140200,1007021441,1000,'[{1,0},{2,40},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(214020043,0,0,2140200,1007041441,1000,'[{1,0},{2,0},{4,40}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(214020044,0,0,2140200,1003001441,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[]',0,0,0,0,'[]'),(214030101,0,0,2140301,1002011432,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(214030102,0,0,2140301,1002021432,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(214030103,0,0,2140301,1002041432,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(214030104,0,0,2140301,1004011432,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(214030105,0,0,2140301,1004021432,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(214030106,0,0,2140301,1004041432,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(214030107,0,0,2140301,1006011432,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(214030108,0,0,2140301,1006021432,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(214030109,0,0,2140301,1006041432,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(214030110,0,0,2140301,1008011432,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(214030111,0,0,2140301,1008021432,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(214030112,0,0,2140301,1008041432,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(214030113,0,0,2140301,1010011432,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(214030114,0,0,2140301,1010021432,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(214030115,0,0,2140301,1010041432,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(214030116,0,0,2140301,1002011442,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(214030117,0,0,2140301,1002021442,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(214030118,0,0,2140301,1002041442,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(214030119,0,0,2140301,1004011442,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(214030120,0,0,2140301,1004021442,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(214030121,0,0,2140301,1004041442,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(214030122,0,0,2140301,1006011442,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(214030123,0,0,2140301,1006021442,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(214030124,0,0,2140301,1006041442,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(214030125,0,0,2140301,1008011442,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(214030126,0,0,2140301,1008021442,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(214030127,0,0,2140301,1008041442,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(214030128,0,0,2140301,1010011442,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(214030129,0,0,2140301,1010021442,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(214030130,0,0,2140301,1010041442,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(214030201,0,0,2140302,1001011432,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(214030202,0,0,2140302,1001021432,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(214030203,0,0,2140302,1001041432,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(214030204,0,0,2140302,1007011432,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(214030205,0,0,2140302,1007021432,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(214030206,0,0,2140302,1007041432,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(214030207,0,0,2140302,1003001432,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(214030208,0,0,2140302,1001011442,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(214030209,0,0,2140302,1001021442,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(214030210,0,0,2140302,1001041442,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(214030211,0,0,2140302,1007011442,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(214030212,0,0,2140302,1007021442,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(214030213,0,0,2140302,1007041442,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(214030214,0,0,2140302,1003001442,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(215010001,0,0,2150100,1002011510,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(215010002,0,0,2150100,1002021510,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(215010003,0,0,2150100,1002041510,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(215010004,0,0,2150100,1004011510,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(215010005,0,0,2150100,1004021510,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(215010006,0,0,2150100,1004041510,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(215010007,0,0,2150100,1006011510,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(215010008,0,0,2150100,1006021510,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(215010009,0,0,2150100,1006041510,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(215010010,0,0,2150100,1008011510,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(215010011,0,0,2150100,1008021510,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(215010012,0,0,2150100,1008041510,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(215010013,0,0,2150100,1010011510,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(215010014,0,0,2150100,1010021510,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(215010015,0,0,2150100,1010041510,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(215010016,0,0,2150100,1001011510,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(215010017,0,0,2150100,1001021510,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(215010018,0,0,2150100,1001041510,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(215010019,0,0,2150100,1007011510,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(215010020,0,0,2150100,1007021510,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(215010021,0,0,2150100,1007041510,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(215010022,0,0,2150100,1003001510,300,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','0',0,'[]',0,0,0,0,'[]'),(215010023,0,0,2150100,1002011520,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(215010024,0,0,2150100,1002021520,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(215010025,0,0,2150100,1002041520,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(215010026,0,0,2150100,1004011520,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(215010027,0,0,2150100,1004021520,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(215010028,0,0,2150100,1004041520,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(215010029,0,0,2150100,1006011520,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(215010030,0,0,2150100,1006021520,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(215010031,0,0,2150100,1006041520,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(215010032,0,0,2150100,1008011520,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(215010033,0,0,2150100,1008021520,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(215010034,0,0,2150100,1008041520,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(215010035,0,0,2150100,1010011520,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(215010036,0,0,2150100,1010021520,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(215010037,0,0,2150100,1010041520,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(215010038,0,0,2150100,1001011520,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(215010039,0,0,2150100,1001021520,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(215010040,0,0,2150100,1001041520,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(215010041,0,0,2150100,1007011520,300,'[{1,300},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(215010042,0,0,2150100,1007021520,300,'[{1,0},{2,300},{4,0}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(215010043,0,0,2150100,1007041520,300,'[{1,0},{2,0},{4,300}]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(215010044,0,0,2150100,1003001520,300,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(215020001,0,0,2150200,1002011531,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(215020002,0,0,2150200,1002021531,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(215020003,0,0,2150200,1002041531,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(215020004,0,0,2150200,1004011531,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(215020005,0,0,2150200,1004021531,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(215020006,0,0,2150200,1004041531,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(215020007,0,0,2150200,1006011531,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(215020008,0,0,2150200,1006021531,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(215020009,0,0,2150200,1006041531,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(215020010,0,0,2150200,1008011531,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(215020011,0,0,2150200,1008021531,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(215020012,0,0,2150200,1008041531,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(215020013,0,0,2150200,1010011531,1000,'[{1,144},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(215020014,0,0,2150200,1010021531,1000,'[{1,0},{2,144},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(215020015,0,0,2150200,1010041531,1000,'[{1,0},{2,0},{4,144}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(215020016,0,0,2150200,1001011531,1000,'[{1,60},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(215020017,0,0,2150200,1001021531,1000,'[{1,0},{2,60},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(215020018,0,0,2150200,1001041531,1000,'[{1,0},{2,0},{4,60}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(215020019,0,0,2150200,1007011531,1000,'[{1,60},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(215020020,0,0,2150200,1007021531,1000,'[{1,0},{2,60},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(215020021,0,0,2150200,1007041531,1000,'[{1,0},{2,0},{4,60}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(215020022,0,0,2150200,1003001531,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(215020023,0,0,2150200,1002011541,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(215020024,0,0,2150200,1002021541,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(215020025,0,0,2150200,1002041541,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[]',0,0,0,0,'[]'),(215020026,0,0,2150200,1004011541,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(215020027,0,0,2150200,1004021541,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(215020028,0,0,2150200,1004041541,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[]',0,0,0,0,'[]'),(215020029,0,0,2150200,1006011541,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(215020030,0,0,2150200,1006021541,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(215020031,0,0,2150200,1006041541,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(215020032,0,0,2150200,1008011541,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(215020033,0,0,2150200,1008021541,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(215020034,0,0,2150200,1008041541,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(215020035,0,0,2150200,1010011541,1000,'[{1,96},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(215020036,0,0,2150200,1010021541,1000,'[{1,0},{2,96},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(215020037,0,0,2150200,1010041541,1000,'[{1,0},{2,0},{4,96}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(215020038,0,0,2150200,1001011541,1000,'[{1,40},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(215020039,0,0,2150200,1001021541,1000,'[{1,0},{2,40},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(215020040,0,0,2150200,1001041541,1000,'[{1,0},{2,0},{4,40}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(215020041,0,0,2150200,1007011541,1000,'[{1,40},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(215020042,0,0,2150200,1007021541,1000,'[{1,0},{2,40},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(215020043,0,0,2150200,1007041541,1000,'[{1,0},{2,0},{4,40}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[]',0,0,0,0,'[]'),(215020044,0,0,2150200,1003001541,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[]',0,0,0,0,'[]'),(215030101,0,0,2150301,1002011532,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(215030102,0,0,2150301,1002021532,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(215030103,0,0,2150301,1002041532,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(215030104,0,0,2150301,1004011532,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(215030105,0,0,2150301,1004021532,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(215030106,0,0,2150301,1004041532,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(215030107,0,0,2150301,1006011532,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(215030108,0,0,2150301,1006021532,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(215030109,0,0,2150301,1006041532,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(215030110,0,0,2150301,1008011532,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(215030111,0,0,2150301,1008021532,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(215030112,0,0,2150301,1008041532,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(215030113,0,0,2150301,1010011532,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(215030114,0,0,2150301,1010021532,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(215030115,0,0,2150301,1010041532,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(215030116,0,0,2150301,1002011542,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(215030117,0,0,2150301,1002021542,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(215030118,0,0,2150301,1002041542,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(215030119,0,0,2150301,1004011542,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(215030120,0,0,2150301,1004021542,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(215030121,0,0,2150301,1004041542,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(215030122,0,0,2150301,1006011542,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(215030123,0,0,2150301,1006021542,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(215030124,0,0,2150301,1006041542,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000006','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(215030125,0,0,2150301,1008011542,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(215030126,0,0,2150301,1008021542,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(215030127,0,0,2150301,1008041542,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000008','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(215030128,0,0,2150301,1010011542,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(215030129,0,0,2150301,1010021542,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(215030130,0,0,2150301,1010041542,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000010','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(215030201,0,0,2150302,1001011532,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(215030202,0,0,2150302,1001021532,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(215030203,0,0,2150302,1001041532,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(215030204,0,0,2150302,1007011532,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(215030205,0,0,2150302,1007021532,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(215030206,0,0,2150302,1007041532,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(215030207,0,0,2150302,1003001532,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(215030208,0,0,2150302,1001011542,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(215030209,0,0,2150302,1001021542,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(215030210,0,0,2150302,1001041542,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000101','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(215030211,0,0,2150302,1007011542,1000,'[{1,1000},{2,0},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(215030212,0,0,2150302,1007021542,1000,'[{1,0},{2,1000},{4,0}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(215030213,0,0,2150302,1007041542,1000,'[{1,0},{2,0},{4,1000}]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(215030214,0,0,2150302,1003001542,1000,'[{1,0},{2,0},{4,0}]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(300001001,0,0,3000010,16040101,1000,'[]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(300001002,0,0,3000010,16040201,1000,'[]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(300001003,0,0,3000010,16040301,1000,'[]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(300001004,0,0,3000010,16040401,1000,'[]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(300001005,0,0,3000010,16040501,1000,'[]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(300001006,0,0,3000010,16040601,1000,'[]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(300002001,0,0,3000020,16040102,1000,'[]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(300002002,0,0,3000020,16040202,1000,'[]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(300002003,0,0,3000020,16040302,1000,'[]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(300002004,0,0,3000020,16040402,1000,'[]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(300002005,0,0,3000020,16040502,1000,'[]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(300002006,0,0,3000020,16040602,1000,'[]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(300003001,0,0,3000030,16040103,1000,'[]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(300003002,0,0,3000030,16040203,1000,'[]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(300003003,0,0,3000030,16040303,1000,'[]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(300003004,0,0,3000030,16040403,1000,'[]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(300003005,0,0,3000030,16040503,1000,'[]',1,1,'[]',0,'1000201','0',0,'[]',0,0,0,0,'[]'),(300003006,0,0,3000030,16040603,1000,'[]',1,1,'[]',0,'1000401','0',0,'[]',0,0,0,0,'[]'),(300004001,0,0,3000040,16040104,1000,'[]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(300004002,0,0,3000040,16040204,1000,'[]',1,1,'[]',0,'1000207','0',0,'[]',0,0,0,0,'[]'),(300004003,0,0,3000040,16040304,1000,'[]',1,1,'[]',0,'1000407','0',0,'[]',0,0,0,0,'[]'),(300004004,0,0,3000040,16040404,1000,'[]',1,1,'[]',0,'1000003','0',0,'[]',0,0,0,0,'[]'),(300004005,0,0,3000040,16040504,1000,'[]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(300004006,0,0,3000040,16040604,1000,'[]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(300005001,0,0,3000050,16040105,1000,'[]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(300005002,0,0,3000050,16040205,1000,'[]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(300005003,0,0,3000050,16040305,1000,'[]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(300005004,0,0,3000050,16040405,1000,'[]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(300005005,0,0,3000050,16040505,1000,'[]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(300005006,0,0,3000050,16040605,1000,'[]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(300011001,0,0,3000110,16040111,1000,'[]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(300011002,0,0,3000110,16040211,1000,'[]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(300011003,0,0,3000110,16040311,1000,'[]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(300011004,0,0,3000110,16040411,1000,'[]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(300011005,0,0,3000110,16040511,1000,'[]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(300011006,0,0,3000110,16040611,1000,'[]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(300012001,0,0,3000120,16040112,1000,'[]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(300012002,0,0,3000120,16040212,1000,'[]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(300012003,0,0,3000120,16040312,1000,'[]',1,1,'[]',0,'1000201','0',0,'[]',0,0,0,0,'[]'),(300012004,0,0,3000120,16040412,1000,'[]',1,1,'[]',0,'1000401','0',0,'[]',0,0,0,0,'[]'),(300012005,0,0,3000120,16040512,1000,'[]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(300012006,0,0,3000120,16040612,1000,'[]',1,1,'[]',0,'1000207','0',0,'[]',0,0,0,0,'[]'),(300013001,0,0,3000130,16040113,1000,'[]',1,1,'[]',0,'1000407','0',0,'[]',0,0,0,0,'[]'),(300013002,0,0,3000130,16040213,1000,'[]',1,1,'[]',0,'1000003','0',0,'[]',0,0,0,0,'[]'),(300013003,0,0,3000130,16040313,1000,'[]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(300013004,0,0,3000130,16040413,1000,'[]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(300013005,0,0,3000130,16040513,1000,'[]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(300013006,0,0,3000130,16040613,1000,'[]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(300014001,0,0,3000140,16040114,1000,'[]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(300014002,0,0,3000140,16040214,1000,'[]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(300014003,0,0,3000140,16040314,1000,'[]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(300014004,0,0,3000140,16040414,1000,'[]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(300014005,0,0,3000140,16040514,1000,'[]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(300014006,0,0,3000140,16040614,1000,'[]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(300015001,0,0,3000150,16040115,1000,'[]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(300015002,0,0,3000150,16040215,1000,'[]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(300015003,0,0,3000150,16040315,1000,'[]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(300015004,0,0,3000150,16040415,1000,'[]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(300015005,0,0,3000150,16040515,1000,'[]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(300015006,0,0,3000150,16040615,1000,'[]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(300021001,0,0,3000210,16040121,1000,'[]',1,1,'[]',0,'1000201','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(300021002,0,0,3000210,16040221,1000,'[]',1,1,'[]',0,'1000401','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(300021003,0,0,3000210,16040321,1000,'[]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(300021004,0,0,3000210,16040421,1000,'[]',1,1,'[]',0,'1000207','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(300021005,0,0,3000210,16040521,1000,'[]',1,1,'[]',0,'1000407','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(300021006,0,0,3000210,16040621,1000,'[]',1,1,'[]',0,'1000003','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(300022001,0,0,3000220,16040122,1000,'[]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(300022002,0,0,3000220,16040222,1000,'[]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(300022003,0,0,3000220,16040322,1000,'[]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(300022004,0,0,3000220,16040422,1000,'[]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(300022005,0,0,3000220,16040522,1000,'[]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(300022006,0,0,3000220,16040622,1000,'[]',1,1,'[]',0,'1000004','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(300023001,0,0,3000230,16040123,1000,'[]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(300023002,0,0,3000230,16040223,1000,'[]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(300023003,0,0,3000230,16040323,1000,'[]',1,1,'[]',0,'1000006','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(300023004,0,0,3000230,16040423,1000,'[]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(300023005,0,0,3000230,16040523,1000,'[]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(300023006,0,0,3000230,16040623,1000,'[]',1,1,'[]',0,'1000008','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(300024001,0,0,3000240,16040124,1000,'[]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(300024002,0,0,3000240,16040224,1000,'[]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(300024003,0,0,3000240,16040324,1000,'[]',1,1,'[]',0,'1000010','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(300024004,0,0,3000240,16040424,1000,'[]',1,1,'[]',0,'1000101','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(300024005,0,0,3000240,16040524,1000,'[]',1,1,'[]',0,'1000201','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(300024006,0,0,3000240,16040624,1000,'[]',1,1,'[]',0,'1000401','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(300025001,0,0,3000250,16040125,1000,'[]',1,1,'[]',0,'1000107','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(300025002,0,0,3000250,16040225,1000,'[]',1,1,'[]',0,'1000207','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(300025003,0,0,3000250,16040325,1000,'[]',1,1,'[]',0,'1000407','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(300025004,0,0,3000250,16040425,1000,'[]',1,1,'[]',0,'1000003','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(300025005,0,0,3000250,16040525,1000,'[]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(300025006,0,0,3000250,16040625,1000,'[]',1,1,'[]',0,'1000002','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(300031001,0,0,3000310,16040131,1000,'[]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(300031002,0,0,3000310,16040231,1000,'[]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(300031003,0,0,3000310,16040331,1000,'[]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(300031004,0,0,3000310,16040431,1000,'[]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(300031005,0,0,3000310,16040531,1000,'[]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(300031006,0,0,3000310,16040631,1000,'[]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(300032001,0,0,3000320,16040132,1000,'[]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(300032002,0,0,3000320,16040232,1000,'[]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(300032003,0,0,3000320,16040332,1000,'[]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(300032004,0,0,3000320,16040432,1000,'[]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(300032005,0,0,3000320,16040532,1000,'[]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(300032006,0,0,3000320,16040632,1000,'[]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(300033001,0,0,3000330,16040133,1000,'[]',1,1,'[]',0,'1000010','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(300033002,0,0,3000330,16040233,1000,'[]',1,1,'[]',0,'1000101','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(300033003,0,0,3000330,16040333,1000,'[]',1,1,'[]',0,'1000201','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(300033004,0,0,3000330,16040433,1000,'[]',1,1,'[]',0,'1000401','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(300033005,0,0,3000330,16040533,1000,'[]',1,1,'[]',0,'1000107','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(300033006,0,0,3000330,16040633,1000,'[]',1,1,'[]',0,'1000207','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(300034001,0,0,3000340,16040134,1000,'[]',1,1,'[]',0,'1000407','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(300034002,0,0,3000340,16040234,1000,'[]',1,1,'[]',0,'1000003','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(300034003,0,0,3000340,16040334,1000,'[]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(300034004,0,0,3000340,16040434,1000,'[]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(300034005,0,0,3000340,16040534,1000,'[]',1,1,'[]',0,'1000002','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(300034006,0,0,3000340,16040634,1000,'[]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(300035001,0,0,3000350,16040135,1000,'[]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(300035002,0,0,3000350,16040235,1000,'[]',1,1,'[]',0,'1000004','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(300035003,0,0,3000350,16040335,1000,'[]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(300035004,0,0,3000350,16040435,1000,'[]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(300035005,0,0,3000350,16040535,1000,'[]',1,1,'[]',0,'1000006','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(300035006,0,0,3000350,16040635,1000,'[]',1,1,'[]',0,'1000008','function_getobj_yellow',0,'[]',0,0,0,0,'[]'),(300041001,0,0,3000410,16040141,1000,'[]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(300041002,0,0,3000410,16040241,1000,'[]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(300041003,0,0,3000410,16040341,1000,'[]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(300041004,0,0,3000410,16040441,1000,'[]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(300041005,0,0,3000410,16040541,1000,'[]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(300041006,0,0,3000410,16040641,1000,'[]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(300042001,0,0,3000420,16040142,1000,'[]',1,1,'[]',0,'1000201','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(300042002,0,0,3000420,16040242,1000,'[]',1,1,'[]',0,'1000401','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(300042003,0,0,3000420,16040342,1000,'[]',1,1,'[]',0,'1000107','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(300042004,0,0,3000420,16040442,1000,'[]',1,1,'[]',0,'1000207','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(300042005,0,0,3000420,16040542,1000,'[]',1,1,'[]',0,'1000407','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(300042006,0,0,3000420,16040642,1000,'[]',1,1,'[]',0,'1000003','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(300043001,0,0,3000430,16040143,1000,'[]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(300043002,0,0,3000430,16040243,1000,'[]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(300043003,0,0,3000430,16040343,1000,'[]',1,1,'[]',0,'1000002','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(300043004,0,0,3000430,16040443,1000,'[]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(300043005,0,0,3000430,16040543,1000,'[]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(300043006,0,0,3000430,16040643,1000,'[]',1,1,'[]',0,'1000004','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(300044001,0,0,3000440,16040144,1000,'[]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(300044002,0,0,3000440,16040244,1000,'[]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(300044003,0,0,3000440,16040344,1000,'[]',1,1,'[]',0,'1000006','function_getobj_red',0,'[]',0,0,0,0,'[]'),(300044004,0,0,3000440,16040444,1000,'[]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(300044005,0,0,3000440,16040544,1000,'[]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(300044006,0,0,3000440,16040644,1000,'[]',1,1,'[]',0,'1000008','function_getobj_red',0,'[]',0,0,0,0,'[]'),(300045001,0,0,3000450,16040145,1000,'[]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(300045002,0,0,3000450,16040245,1000,'[]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(300045003,0,0,3000450,16040345,1000,'[]',1,1,'[]',0,'1000010','function_getobj_red',0,'[]',0,0,0,0,'[]'),(300045004,0,0,3000450,16040445,1000,'[]',1,1,'[]',0,'1000101','function_getobj_red',0,'[]',0,0,0,0,'[]'),(300045005,0,0,3000450,16040545,1000,'[]',1,1,'[]',0,'1000201','function_getobj_red',0,'[]',0,0,0,0,'[]'),(300045006,0,0,3000450,16040645,1000,'[]',1,1,'[]',0,'1000401','function_getobj_red',0,'[]',0,0,0,0,'[]'),(300051001,0,0,3000510,16040151,1000,'[]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(300051002,0,0,3000510,16040251,1000,'[]',1,1,'[]',0,'1000207','0',0,'[]',0,0,0,0,'[]'),(300051003,0,0,3000510,16040351,1000,'[]',1,1,'[]',0,'1000407','0',0,'[]',0,0,0,0,'[]'),(300051004,0,0,3000510,16040451,1000,'[]',1,1,'[]',0,'1000003','0',0,'[]',0,0,0,0,'[]'),(300051005,0,0,3000510,16040551,1000,'[]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(300051006,0,0,3000510,16040651,1000,'[]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(300052001,0,0,3000520,16040152,1000,'[]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(300052002,0,0,3000520,16040252,1000,'[]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(300052003,0,0,3000520,16040352,1000,'[]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(300052004,0,0,3000520,16040452,1000,'[]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(300052005,0,0,3000520,16040552,1000,'[]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(300052006,0,0,3000520,16040652,1000,'[]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(300053001,0,0,3000530,16040153,1000,'[]',1,1,'[]',0,'1000006','0',0,'[]',0,0,0,0,'[]'),(300053002,0,0,3000530,16040253,1000,'[]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(300053003,0,0,3000530,16040353,1000,'[]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(300053004,0,0,3000530,16040453,1000,'[]',1,1,'[]',0,'1000008','0',0,'[]',0,0,0,0,'[]'),(300053005,0,0,3000530,16040553,1000,'[]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(300053006,0,0,3000530,16040653,1000,'[]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(300054001,0,0,3000540,16040154,1000,'[]',1,1,'[]',0,'1000010','0',0,'[]',0,0,0,0,'[]'),(300054002,0,0,3000540,16040254,1000,'[]',1,1,'[]',0,'1000101','0',0,'[]',0,0,0,0,'[]'),(300054003,0,0,3000540,16040354,1000,'[]',1,1,'[]',0,'1000201','0',0,'[]',0,0,0,0,'[]'),(300054004,0,0,3000540,16040454,1000,'[]',1,1,'[]',0,'1000401','0',0,'[]',0,0,0,0,'[]'),(300054005,0,0,3000540,16040554,1000,'[]',1,1,'[]',0,'1000107','0',0,'[]',0,0,0,0,'[]'),(300054006,0,0,3000540,16040654,1000,'[]',1,1,'[]',0,'1000207','0',0,'[]',0,0,0,0,'[]'),(300055001,0,0,3000550,16040155,1000,'[]',1,1,'[]',0,'1000407','0',0,'[]',0,0,0,0,'[]'),(300055002,0,0,3000550,16040255,1000,'[]',1,1,'[]',0,'1000003','0',0,'[]',0,0,0,0,'[]'),(300055003,0,0,3000550,16040355,1000,'[]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(300055004,0,0,3000550,16040455,1000,'[]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(300055005,0,0,3000550,16040555,1000,'[]',1,1,'[]',0,'1000002','0',0,'[]',0,0,0,0,'[]'),(300055006,0,0,3000550,16040655,1000,'[]',1,1,'[]',0,'1000004','0',0,'[]',0,0,0,0,'[]'),(400000101,0,0,4000001,21010101,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400000102,0,0,4000001,21010102,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400000103,0,0,4000001,21010103,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400000104,0,0,4000001,21010104,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400000105,0,0,4000001,21010105,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400000106,0,0,4000001,21010106,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400000107,0,0,4000001,21010107,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400000201,0,0,4000002,21010101,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400000202,0,0,4000002,21010102,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400000203,0,0,4000002,21010103,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400000204,0,0,4000002,21010104,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400000205,0,0,4000002,21010105,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400000206,0,0,4000002,21010106,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400000207,0,0,4000002,21010107,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400000208,0,0,4000002,21010108,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400000209,0,0,4000002,21010109,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400000210,0,0,4000002,21010110,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400000301,0,0,4000003,21010201,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400000302,0,0,4000003,21010202,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400000401,0,0,4000004,21010201,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400000402,0,0,4000004,21010202,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400000403,0,0,4000004,21010203,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400000404,0,0,4000004,21010204,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400000501,0,0,4000005,21010203,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400000502,0,0,4000005,21010204,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400000503,0,0,4000005,21010205,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400000504,0,0,4000005,21010206,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400000505,0,0,4000005,21010207,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400000601,0,0,4000006,21010205,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400000602,0,0,4000006,21010206,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400000603,0,0,4000006,21010207,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400000701,0,0,4000007,21010205,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400000702,0,0,4000007,21010206,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400000703,0,0,4000007,21010207,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400000704,0,0,4000007,21010208,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400000705,0,0,4000007,21010209,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400000706,0,0,4000007,21010210,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400000801,0,0,4000008,21010208,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400000802,0,0,4000008,21010209,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400000803,0,0,4000008,21010210,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400000804,0,0,4000008,21010301,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400000805,0,0,4000008,21010302,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400000806,0,0,4000008,21010303,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400000807,0,0,4000008,21010304,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400000901,0,0,4000009,21010301,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400000902,0,0,4000009,21010302,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400000903,0,0,4000009,21010303,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400000904,0,0,4000009,21010304,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001001,0,0,4000010,21010301,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001002,0,0,4000010,21010302,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001003,0,0,4000010,21010303,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001004,0,0,4000010,21010304,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001005,0,0,4000010,21010305,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001006,0,0,4000010,21010306,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001007,0,0,4000010,21010307,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001008,0,0,4000010,21010308,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001009,0,0,4000010,21010309,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001010,0,0,4000010,21010310,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001101,0,0,4000011,21010305,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001102,0,0,4000011,21010306,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001103,0,0,4000011,21010307,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001104,0,0,4000011,21010308,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001105,0,0,4000011,21010309,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001106,0,0,4000011,21010310,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001201,0,0,4000012,21010401,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001202,0,0,4000012,21010402,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001203,0,0,4000012,21010403,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001204,0,0,4000012,21010404,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001205,0,0,4000012,21010411,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001206,0,0,4000012,21010412,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001301,0,0,4000013,21010405,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001302,0,0,4000013,21010406,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001303,0,0,4000013,21010407,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001304,0,0,4000013,21010408,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001305,0,0,4000013,21010409,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001306,0,0,4000013,21010410,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001401,0,0,4000014,21010201,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001402,0,0,4000014,21010202,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001403,0,0,4000014,21010205,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001404,0,0,4000014,21010206,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001405,0,0,4000014,21010207,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001406,0,0,4000014,21010301,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001407,0,0,4000014,21010302,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001408,0,0,4000014,21010303,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001409,0,0,4000014,21010304,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001501,0,0,4000015,21010203,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001502,0,0,4000015,21010204,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001503,0,0,4000015,21010208,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001504,0,0,4000015,21010209,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001505,0,0,4000015,21010210,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001506,0,0,4000015,21010305,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001507,0,0,4000015,21010306,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001508,0,0,4000015,21010307,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001509,0,0,4000015,21010308,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001510,0,0,4000015,21010309,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001511,0,0,4000015,21010310,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001601,0,0,4000016,21010401,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001602,0,0,4000016,21010402,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001603,0,0,4000016,21010403,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001604,0,0,4000016,21010404,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001605,0,0,4000016,21010411,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001606,0,0,4000016,21010412,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001607,0,0,4000016,21010405,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001608,0,0,4000016,21010406,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001609,0,0,4000016,21010407,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001610,0,0,4000016,21010408,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001611,0,0,4000016,21010409,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001612,0,0,4000016,21010410,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001701,0,0,4000017,21010201,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001702,0,0,4000017,21010202,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001703,0,0,4000017,21010203,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001704,0,0,4000017,21010204,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001705,0,0,4000017,21010205,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001706,0,0,4000017,21010206,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001707,0,0,4000017,21010207,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001708,0,0,4000017,21010208,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001709,0,0,4000017,21010209,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001710,0,0,4000017,21010210,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001801,0,0,4000018,21010301,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001802,0,0,4000018,21010302,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001803,0,0,4000018,21010303,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001804,0,0,4000018,21010304,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001805,0,0,4000018,21010305,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001806,0,0,4000018,21010306,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001807,0,0,4000018,21010307,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001808,0,0,4000018,21010308,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001809,0,0,4000018,21010309,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001810,0,0,4000018,21010310,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001811,0,0,4000018,21010401,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001812,0,0,4000018,21010402,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001813,0,0,4000018,21010403,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001814,0,0,4000018,21010404,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001815,0,0,4000018,21010411,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001816,0,0,4000018,21010412,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001817,0,0,4000018,21010405,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001818,0,0,4000018,21010406,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001819,0,0,4000018,21010407,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001820,0,0,4000018,21010408,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001821,0,0,4000018,21010409,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001822,0,0,4000018,21010410,600,'[]',1,1,'[]',0,'0','0',0,'[]',0,0,0,0,'[]'),(400001901,0,0,4000019,21010502,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400001902,0,0,4000019,21010505,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400001903,0,0,4000019,21010506,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400001904,0,0,4000019,21010507,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002001,0,0,4000020,21010502,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002002,0,0,4000020,21010505,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002003,0,0,4000020,21010506,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002004,0,0,4000020,21010507,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002005,0,0,4000020,21010503,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002006,0,0,4000020,21010508,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002007,0,0,4000020,21010509,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002008,0,0,4000020,21010510,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002101,0,0,4000021,21010503,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002102,0,0,4000021,21010508,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002103,0,0,4000021,21010509,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002104,0,0,4000021,21010510,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002201,0,0,4000022,21010503,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002202,0,0,4000022,21010508,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002203,0,0,4000022,21010509,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002204,0,0,4000022,21010510,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002205,0,0,4000022,21010501,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002206,0,0,4000022,21010504,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002207,0,0,4000022,21010511,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002208,0,0,4000022,21010512,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002301,0,0,4000023,21010501,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002302,0,0,4000023,21010504,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002303,0,0,4000023,21010511,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002304,0,0,4000023,21010512,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002401,0,0,4000024,21010501,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002402,0,0,4000024,21010504,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002403,0,0,4000024,21010511,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002404,0,0,4000024,21010512,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002405,0,0,4000024,21010601,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002406,0,0,4000024,21010602,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002407,0,0,4000024,21010603,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002408,0,0,4000024,21010604,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002501,0,0,4000025,21010601,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002502,0,0,4000025,21010602,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002503,0,0,4000025,21010603,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002504,0,0,4000025,21010604,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002601,0,0,4000026,21010601,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002602,0,0,4000026,21010602,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002603,0,0,4000026,21010603,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002604,0,0,4000026,21010604,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002605,0,0,4000026,21010605,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002606,0,0,4000026,21010606,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002607,0,0,4000026,21010607,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002608,0,0,4000026,21010608,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002609,0,0,4000026,21010609,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002610,0,0,4000026,21010610,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002701,0,0,4000027,21010605,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002702,0,0,4000027,21010606,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002703,0,0,4000027,21010607,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002704,0,0,4000027,21010608,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002705,0,0,4000027,21010609,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002706,0,0,4000027,21010610,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002801,0,0,4000028,21010605,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002802,0,0,4000028,21010606,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002803,0,0,4000028,21010607,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002804,0,0,4000028,21010608,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002805,0,0,4000028,21010609,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002806,0,0,4000028,21010610,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002807,0,0,4000028,21010701,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002808,0,0,4000028,21010702,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002809,0,0,4000028,21010705,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002810,0,0,4000028,21010706,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002811,0,0,4000028,21010707,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002901,0,0,4000029,21010701,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002902,0,0,4000029,21010702,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002903,0,0,4000029,21010705,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002904,0,0,4000029,21010706,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400002905,0,0,4000029,21010707,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003001,0,0,4000030,21010502,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003002,0,0,4000030,21010505,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003003,0,0,4000030,21010506,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003004,0,0,4000030,21010507,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003005,0,0,4000030,21010503,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003006,0,0,4000030,21010508,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003007,0,0,4000030,21010509,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003008,0,0,4000030,21010510,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003009,0,0,4000030,21010501,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003010,0,0,4000030,21010504,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003011,0,0,4000030,21010511,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003012,0,0,4000030,21010512,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003013,0,0,4000030,21010703,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003014,0,0,4000030,21010704,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003015,0,0,4000030,21010708,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003016,0,0,4000030,21010709,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003017,0,0,4000030,21010710,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003101,0,0,4000031,21010601,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003102,0,0,4000031,21010602,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003103,0,0,4000031,21010603,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003104,0,0,4000031,21010604,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003105,0,0,4000031,21010605,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003106,0,0,4000031,21010606,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003107,0,0,4000031,21010607,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003108,0,0,4000031,21010608,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003109,0,0,4000031,21010609,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003110,0,0,4000031,21010610,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003111,0,0,4000031,21010701,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003112,0,0,4000031,21010702,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003113,0,0,4000031,21010705,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003114,0,0,4000031,21010706,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003115,0,0,4000031,21010707,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003116,0,0,4000031,21010801,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003117,0,0,4000031,21010802,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003118,0,0,4000031,21010803,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003119,0,0,4000031,21010804,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003120,0,0,4000031,21010811,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003121,0,0,4000031,21010812,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003201,0,0,4000032,21010502,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003202,0,0,4000032,21010505,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003203,0,0,4000032,21010506,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003204,0,0,4000032,21010507,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003205,0,0,4000032,21010501,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003206,0,0,4000032,21010504,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003207,0,0,4000032,21010511,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003208,0,0,4000032,21010512,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003209,0,0,4000032,21010605,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003210,0,0,4000032,21010606,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003211,0,0,4000032,21010607,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003212,0,0,4000032,21010608,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003213,0,0,4000032,21010609,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003214,0,0,4000032,21010610,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003215,0,0,4000032,21010703,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003216,0,0,4000032,21010704,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003217,0,0,4000032,21010708,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003218,0,0,4000032,21010709,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003219,0,0,4000032,21010710,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003301,0,0,4000033,21010503,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003302,0,0,4000033,21010508,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003303,0,0,4000033,21010509,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003304,0,0,4000033,21010510,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003305,0,0,4000033,21010601,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003306,0,0,4000033,21010602,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003307,0,0,4000033,21010603,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003308,0,0,4000033,21010604,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003309,0,0,4000033,21010701,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003310,0,0,4000033,21010702,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003311,0,0,4000033,21010705,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003312,0,0,4000033,21010706,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003313,0,0,4000033,21010707,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003314,0,0,4000033,21010801,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003315,0,0,4000033,21010802,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003316,0,0,4000033,21010803,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003317,0,0,4000033,21010804,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003318,0,0,4000033,21010811,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003319,0,0,4000033,21010812,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003401,0,0,4000034,21010502,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003402,0,0,4000034,21010505,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003403,0,0,4000034,21010506,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003404,0,0,4000034,21010507,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003405,0,0,4000034,21010503,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003406,0,0,4000034,21010508,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003407,0,0,4000034,21010509,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003408,0,0,4000034,21010510,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003409,0,0,4000034,21010501,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003410,0,0,4000034,21010504,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003411,0,0,4000034,21010511,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003412,0,0,4000034,21010512,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003413,0,0,4000034,21010601,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003414,0,0,4000034,21010602,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003415,0,0,4000034,21010603,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003416,0,0,4000034,21010604,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003417,0,0,4000034,21010605,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003418,0,0,4000034,21010606,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003419,0,0,4000034,21010607,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003420,0,0,4000034,21010608,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003421,0,0,4000034,21010609,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003422,0,0,4000034,21010610,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003423,0,0,4000034,21010701,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003424,0,0,4000034,21010702,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003425,0,0,4000034,21010705,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003426,0,0,4000034,21010706,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003427,0,0,4000034,21010707,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003428,0,0,4000034,21010703,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003429,0,0,4000034,21010704,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003430,0,0,4000034,21010708,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003431,0,0,4000034,21010709,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003432,0,0,4000034,21010710,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003433,0,0,4000034,21010801,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003434,0,0,4000034,21010802,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003435,0,0,4000034,21010803,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003436,0,0,4000034,21010804,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003437,0,0,4000034,21010811,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003438,0,0,4000034,21010812,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003439,0,0,4000034,21010805,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003440,0,0,4000034,21010806,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003441,0,0,4000034,21010807,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003442,0,0,4000034,21010808,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003443,0,0,4000034,21010809,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003444,0,0,4000034,21010810,600,'[]',1,1,'[]',0,'0','function_getobj_perple',0,'[]',0,0,0,0,'[]'),(400003501,0,0,4000035,21010902,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400003502,0,0,4000035,21010905,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400003503,0,0,4000035,21010906,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400003504,0,0,4000035,21010907,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400003601,0,0,4000036,21010902,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400003602,0,0,4000036,21010905,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400003603,0,0,4000036,21010906,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400003604,0,0,4000036,21010907,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400003605,0,0,4000036,21010903,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400003606,0,0,4000036,21010908,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400003607,0,0,4000036,21010909,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400003608,0,0,4000036,21010910,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400003701,0,0,4000037,21010903,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400003702,0,0,4000037,21010908,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400003703,0,0,4000037,21010909,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400003704,0,0,4000037,21010910,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400003801,0,0,4000038,21010903,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400003802,0,0,4000038,21010908,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400003803,0,0,4000038,21010909,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400003804,0,0,4000038,21010910,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400003805,0,0,4000038,21010901,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400003806,0,0,4000038,21010904,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400003807,0,0,4000038,21010911,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400003808,0,0,4000038,21010912,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400003901,0,0,4000039,21010901,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400003902,0,0,4000039,21010904,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400003903,0,0,4000039,21010911,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400003904,0,0,4000039,21010912,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400004001,0,0,4000040,21010901,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400004002,0,0,4000040,21010904,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400004003,0,0,4000040,21010911,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400004004,0,0,4000040,21010912,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400004005,0,0,4000040,21011001,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400004006,0,0,4000040,21011002,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400004007,0,0,4000040,21011003,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400004008,0,0,4000040,21011004,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400004101,0,0,4000041,21011001,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400004102,0,0,4000041,21011002,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400004103,0,0,4000041,21011003,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400004104,0,0,4000041,21011004,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400004201,0,0,4000042,21011005,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400004202,0,0,4000042,21011006,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400004203,0,0,4000042,21011007,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400004204,0,0,4000042,21011008,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400004205,0,0,4000042,21011009,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400004206,0,0,4000042,21011010,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400004301,0,0,4000043,21011101,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400004302,0,0,4000043,21011102,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400004303,0,0,4000043,21011105,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400004304,0,0,4000043,21011106,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400004305,0,0,4000043,21011107,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400004401,0,0,4000044,21011103,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400004402,0,0,4000044,21011104,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400004403,0,0,4000044,21011108,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400004404,0,0,4000044,21011109,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400004405,0,0,4000044,21011110,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400004501,0,0,4000045,21011201,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400004502,0,0,4000045,21011202,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400004503,0,0,4000045,21011203,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400004504,0,0,4000045,21011204,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400004505,0,0,4000045,21011211,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400004506,0,0,4000045,21011212,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400004601,0,0,4000046,21011205,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400004602,0,0,4000046,21011206,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400004603,0,0,4000046,21011207,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400004604,0,0,4000046,21011208,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400004605,0,0,4000046,21011209,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400004606,0,0,4000046,21011210,600,'[]',1,1,'[]',0,'0','function_getobj_yellow',0,'[{150,1}]',0,0,0,0,'[]'),(400004701,0,0,4000047,21011401,600,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(400004702,0,0,4000047,21011402,600,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(400004703,0,0,4000047,21011403,600,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(400004704,0,0,4000047,21011404,600,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(400004705,0,0,4000047,21011405,600,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(400004706,0,0,4000047,21011406,600,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(400004707,0,0,4000047,21011407,600,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(400004708,0,0,4000047,21011408,600,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(400004709,0,0,4000047,21011409,600,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(400004710,0,0,4000047,21011410,600,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(400004711,0,0,4000047,21011411,600,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(400004712,0,0,4000047,21011412,600,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(400004713,0,0,4000047,21011501,600,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(400004714,0,0,4000047,21011502,600,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(400004715,0,0,4000047,21011503,600,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(400004716,0,0,4000047,21011504,600,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(400004717,0,0,4000047,21011505,600,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(400004718,0,0,4000047,21011506,600,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(400004719,0,0,4000047,21011507,600,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(400004720,0,0,4000047,21011508,600,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(400004721,0,0,4000047,21011509,600,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(400004722,0,0,4000047,21011510,600,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(400004723,0,0,4000047,21011511,600,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(400004724,0,0,4000047,21011512,600,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(400004725,0,0,4000047,21011601,600,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(400004726,0,0,4000047,21011602,600,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(400004727,0,0,4000047,21011603,600,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(400004728,0,0,4000047,21011604,600,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(400004729,0,0,4000047,21011605,600,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(400004730,0,0,4000047,21011606,600,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(400004731,0,0,4000047,21011607,600,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(400004732,0,0,4000047,21011608,600,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(400004733,0,0,4000047,21011609,600,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(400004734,0,0,4000047,21011610,600,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(400004735,0,0,4000047,21011611,600,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(400004736,0,0,4000047,21011612,600,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(400004737,0,0,4000047,21011701,600,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(400004738,0,0,4000047,21011702,600,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(400004739,0,0,4000047,21011703,600,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(400004740,0,0,4000047,21011704,600,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(400004741,0,0,4000047,21011705,600,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(400004742,0,0,4000047,21011706,600,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(400004743,0,0,4000047,21011707,600,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(400004744,0,0,4000047,21011708,600,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(400004745,0,0,4000047,21011709,600,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(400004746,0,0,4000047,21011710,600,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(400004747,0,0,4000047,21011711,600,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]'),(400004748,0,0,4000047,21011712,600,'[]',1,1,'[]',0,'0','function_getobj_red',0,'[{150,1}]',0,0,0,0,'[]');
/*!40000 ALTER TABLE `base_drop_goods` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_drop_limit`
--

DROP TABLE IF EXISTS `base_drop_limit`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_drop_limit` (
  `drop_thing_type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '掉落类型',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '掉落物品id',
  `limit_type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '限制类型',
  `limit_day` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '限制天数##0：玩家单个物品Id限制；1：全服单个物品Id限制',
  `limit_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '限制数量##（玩家单个物品限制只能填1和7）',
  PRIMARY KEY (`drop_thing_type`,`goods_id`,`limit_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='掉落上限配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_drop_limit`
--

LOCK TABLES `base_drop_limit` WRITE;
/*!40000 ALTER TABLE `base_drop_limit` DISABLE KEYS */;
INSERT INTO `base_drop_limit` VALUES (0,11020001,0,1,20),(0,17010001,0,1,20),(0,17010002,0,1,20),(0,17010003,0,1,20),(0,18020001,0,1,20),(0,18030001,1,5,96),(0,20040000,1,14,1),(0,20040001,1,14,40),(0,20040002,1,14,15),(0,20040003,1,14,3),(0,20040004,1,14,1),(0,20040005,1,14,1),(0,20040006,1,14,1),(0,24030001,1,14,1),(0,24030002,1,14,1),(0,24030003,1,14,1),(0,24030004,1,14,1),(0,24030005,1,14,1),(0,24030006,1,14,1),(0,24030007,1,14,1),(0,24030008,1,14,1),(0,24030009,1,14,1),(0,24031001,1,7,10),(0,24031002,1,7,10),(0,24031003,1,7,10),(0,24031004,1,7,10),(0,24031005,1,7,10),(0,24031006,1,7,10),(0,24031007,1,7,10),(0,24031008,1,7,10),(0,24031009,1,7,10),(0,38030006,0,1,6),(0,38030007,0,1,6),(0,38040010,0,1,20),(0,38040013,0,1,25),(0,38040014,0,1,25),(0,38040015,0,1,16),(0,38040016,0,1,16),(0,38040017,0,7,10),(0,38040102,0,1,20),(0,38110001,0,1,200),(0,38110004,0,1,2),(0,38110005,0,1,2),(0,38110006,0,1,1),(0,38110007,0,1,1),(0,38130001,0,1,30),(0,38190001,0,1,15),(0,38330001,0,1,29);
/*!40000 ALTER TABLE `base_drop_limit` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_drop_mon_list`
--

DROP TABLE IF EXISTS `base_drop_mon_list`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_drop_mon_list` (
  `mon_id` int(11) NOT NULL COMMENT '怪物ID',
  `list_id` int(11) NOT NULL COMMENT '列表ID',
  UNIQUE KEY `mon_id` (`mon_id`,`list_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品掉落怪物相关列表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_drop_mon_list`
--

LOCK TABLES `base_drop_mon_list` WRITE;
/*!40000 ALTER TABLE `base_drop_mon_list` DISABLE KEYS */;
/*!40000 ALTER TABLE `base_drop_mon_list` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_drop_rule`
--

DROP TABLE IF EXISTS `base_drop_rule`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_drop_rule` (
  `mon_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '怪物ID',
  `alloc` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '分配方式：1队长独占，2队伍随机，3队伍均等',
  `min_lv` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '等级下限',
  `max_lv` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '等级上限',
  `bltype` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '归属类型：分配方式4：启作用 0：伤害最高获得 1：第一击获得 2：最后一击获得 3：无归属；配置“无归属”后所有玩家都可以拾取列表中的道具',
  `task` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否有任务物品，1 有，0 无',
  `broad` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '广播场景，0不广播，1队伍广播，2场景广播',
  `drop_rule` varchar(2000) NOT NULL COMMENT '掉落规则，格式：包:掉落数+包:掉落数=机率, ...',
  `drop_range` varchar(256) NOT NULL COMMENT '掉落范围',
  PRIMARY KEY (`mon_id`,`alloc`,`min_lv`,`max_lv`),
  KEY `task` (`task`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品掉落规则表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_drop_rule`
--

LOCK TABLES `base_drop_rule` WRITE;
/*!40000 ALTER TABLE `base_drop_rule` DISABLE KEYS */;
INSERT INTO `base_drop_rule` VALUES (1202000,1,0,1000,0,0,1,'1|15:1=10000;1|16:1=10000;5|1030100:1=10000;2|1030200:1=10000','{10000,10000}'),(1202001,1,0,1000,0,0,1,'1|1030100:10=10000;2|1030100:1=5000;2|1030200:1=10000;1|1030200:1=5000;1|1030301:1=3943,1030302:1=130','{10000,10000}'),(1202002,1,0,1000,0,0,1,'1|1030100:5=10000;2|1030100:1=5000;2|1030200:1=10000;1|1030200:1=5000;1|1030301:1=1972,1030302:1=65','{10000,10000}'),(1202003,1,0,1000,0,0,1,'1|1040100:10=10000;2|1040100:1=5000;2|1040200:1=10000;1|1040200:1=5000;1|93:1=158;1|1040301:1=3033,1040302:1=100','{10000,10000}'),(1202004,1,0,1000,0,0,1,'1|1040100:5=10000;2|1040100:1=5000;2|1040200:1=10000;1|1040200:1=5000;1|93:1=158;1|1040301:1=1517,1040302:1=50','{10000,10000}'),(1202005,1,0,1000,0,0,1,'1|1040100:14=10000;2|1040100:1=5000;3|1040200:1=10000;1|1040200:1=5000;1|93:1=158;1|1040301:1=3337,1040302:1=110','{10000,10000}'),(1202006,1,0,1000,0,0,1,'1|1040100:5=10000;2|1040100:1=5000;2|1040200:1=10000;1|1040200:1=5000;1|93:1=158;1|1040301:1=1517,1040302:1=50','{10000,10000}'),(1202007,1,0,1000,0,0,1,'1|1040100:18=10000;2|1040100:1=5000;3|1040200:1=10000;2|1040200:1=5000;1|93:1=158;1|1040301:1=3640,1040302:1=120','{10000,10000}'),(1202008,1,0,1000,0,0,1,'1|1040100:5=10000;2|1040100:1=5000;2|1040200:1=10000;1|1040200:1=5000;1|93:1=158;1|1040301:1=1517,1040302:1=50','{10000,10000}'),(1202009,1,0,1000,0,0,1,'1|1050100:10=10000;2|1050100:1=5000;2|1050200:1=10000;1|1050200:1=5000;1|93:1=158;1|1050301:1=2230,1050302:1=90','{10000,10000}'),(1202010,1,0,1000,0,0,1,'1|1050100:5=10000;2|1050100:1=5000;2|1050200:1=10000;1|1050200:1=5000;1|93:1=158;1|1050301:1=1115,1050302:1=45','{10000,10000}'),(1202011,1,0,1000,0,0,1,'1|1050100:14=10000;2|1050100:1=5000;3|1050200:1=10000;1|1050200:1=5000;1|93:1=158;1|1050301:1=2453,1050302:1=99','{10000,10000}'),(1202012,1,0,1000,0,0,1,'1|1050100:5=10000;2|1050100:1=5000;2|1050200:1=10000;1|1050200:1=5000;1|93:1=158;1|1050301:1=1115,1050302:1=45','{10000,10000}'),(1202013,1,0,1000,0,0,1,'1|1050100:18=10000;2|1050100:1=5000;3|1050200:1=10000;2|1050200:1=5000;1|93:1=158;1|1050301:1=2676,1050302:1=108','{10000,10000}'),(1202014,1,0,1000,0,0,1,'1|1050100:5=10000;2|1050100:1=5000;2|1050200:1=10000;1|1050200:1=5000;1|93:1=158;1|1050301:1=1115,1050302:1=45','{10000,10000}'),(1202015,1,0,1000,0,0,1,'1|1060100:10=10000;2|1060100:1=5000;2|1060200:1=10000;1|1060200:1=5000;1|94:1=80;1|1060301:1=2825,1060302:1=80','{10000,10000}'),(1202016,1,0,1000,0,0,1,'1|1060100:5=10000;2|1060100:1=5000;2|1060200:1=10000;1|1060200:1=5000;1|94:1=80;1|1060301:1=1413,1060302:1=40','{10000,10000}'),(1203001,1,0,1000,0,0,1,'1|1060100:10=10000;2|1060100:1=5000;2|1060200:1=10000;1|1060200:1=5000;1|94:1=80;1|1060301:1=2825,1060302:1=80','{10000,10000}'),(1203002,1,0,1000,0,0,1,'1|1060100:5=10000;2|1060100:1=5000;2|1060200:1=10000;1|1060200:1=5000;1|94:1=80;1|1060301:1=1413,1060302:1=40','{10000,10000}'),(1203003,1,0,1000,0,0,1,'1|1060100:14=10000;2|1060100:1=5000;3|1060200:1=10000;1|1060200:1=5000;1|13:1=8700;1|10:1=1400;1|94:1=80;1|1060301:1=3108,1060302:1=88','{10000,10000}'),(1203004,1,0,1000,0,0,1,'1|1060100:5=10000;2|1060100:1=5000;2|1060200:1=10000;1|1060200:1=5000;1|13:1=8738;1|10:1=1485;1|94:1=80;1|1060301:1=1413,1060302:1=40','{10000,10000}'),(1203005,1,0,1000,0,0,1,'1|1060100:18=10000;2|1060100:1=5000;3|1060200:1=10000;2|1060200:1=5000;1|13:1=8777;1|10:1=1570;1|94:1=80;1|1060301:1=3390,1060302:1=96','{10000,10000}'),(1203006,1,0,1000,0,0,1,'1|1060100:5=10000;2|1060100:1=5000;2|1060200:1=10000;1|1060200:1=5000;1|13:1=8815;1|10:1=1655;1|94:1=80;1|1060301:1=1413,1060302:1=40','{10000,10000}'),(1203007,1,0,1000,0,0,1,'1|1060100:18=10000;2|1060100:1=5000;3|1060200:1=10000;2|1060200:1=5000;1|13:1=8853;1|10:1=1740;1|94:1=80;1|1060301:1=3390,1060302:1=96','{10000,10000}'),(1203008,1,0,1000,0,0,1,'1|1060100:5=10000;2|1060100:1=5000;2|1060200:1=10000;1|1060200:1=5000;1|13:1=8891;1|10:1=1826;1|94:1=80;1|1060301:1=1413,1060302:1=40','{10000,10000}'),(1203009,1,0,1000,0,0,1,'1|1070100:10=10000;2|1070100:1=5000;2|1070200:1=10000;1|1070200:1=5000;1|13:1=8930;1|10:1=1911;1|94:1=80;1|1070301:1=2416,1070302:1=70','{10000,10000}'),(1203010,1,0,1000,0,0,1,'1|1070100:5=10000;2|1070100:1=5000;2|1070200:1=10000;1|1070200:1=5000;1|13:1=8968;1|10:1=1996;1|94:1=80;1|1070301:1=1208,1070302:1=35','{10000,10000}'),(1203011,1,0,1000,0,0,1,'1|1070100:10=10000;2|1070100:1=5000;2|1070200:1=10000;1|1070200:1=5000;1|13:1=9006;1|10:1=2081;1|94:1=80;1|1070301:1=2416,1070302:1=70','{10000,10000}'),(1203012,1,0,1000,0,0,1,'1|1070100:5=10000;2|1070100:1=5000;2|1070200:1=10000;1|1070200:1=5000;1|13:1=9045;1|10:1=2166;1|94:1=80;1|1070301:1=1208,1070302:1=35','{10000,10000}'),(1203013,1,0,1000,0,0,1,'1|1070100:14=10000;2|1070100:1=5000;3|1070200:1=10000;1|1070200:1=5000;1|13:1=9083;1|10:1=2251;1|94:1=80;1|1070301:1=2658,1070302:1=77','{10000,10000}'),(1203014,1,0,1000,0,0,1,'1|1070100:18=10000;2|1070100:1=5000;3|1070200:1=10000;2|1070200:1=5000;1|13:1=9121;1|10:1=2336;1|95:1=2;1|1070301:1=2899,1070302:1=84','{10000,10000}'),(1204001,1,0,1000,0,0,1,'1|1070100:10=10000;2|1070100:1=5000;2|1070200:1=10000;1|1070200:1=5000;1|13:1=9160;1|10:1=2421;1|95:1=2;1|1070301:1=2416,1070302:1=70','{10000,10000}'),(1204002,1,0,1000,0,0,1,'1|1070100:5=10000;2|1070100:1=5000;2|1070200:1=10000;1|1070200:1=5000;1|13:1=9198;1|10:1=2506;1|95:1=2;1|1070301:1=1208,1070302:1=35','{10000,10000}'),(1204003,1,0,1000,0,0,1,'1|1080100:10=10000;2|1080100:1=5000;2|1080200:1=10000;1|1080200:1=5000;1|13:1=9236;1|10:1=2591;1|95:1=2;1|99:1=158;1|1080301:1=1886,1080302:1=60','{10000,10000}'),(1204004,1,0,1000,0,0,1,'1|1080100:5=10000;2|1080100:1=5000;2|1080200:1=10000;1|1080200:1=5000;1|13:1=9274;1|10:1=2677;1|95:1=2;1|99:1=158;1|1080301:1=943,1080302:1=30','{10000,10000}'),(1204005,1,0,1000,0,0,1,'1|1080100:14=10000;2|1080100:1=5000;3|1080200:1=10000;1|1080200:1=5000;1|13:1=9313;1|10:1=2762;1|95:1=2;1|99:1=158;1|1080301:1=2074,1080302:1=66','{10000,10000}'),(1204006,1,0,1000,0,0,1,'1|1080100:5=10000;2|1080100:1=5000;2|1080200:1=10000;1|1080200:1=5000;1|13:1=9351;1|10:1=2847;1|95:1=2;1|99:1=158;1|1080301:1=943,1080302:1=30','{10000,10000}'),(1204007,1,0,1000,0,0,1,'1|1080100:18=10000;2|1080100:1=5000;3|1080200:1=10000;2|1080200:1=5000;1|13:1=9389;1|10:1=2932;1|95:1=2;1|99:1=158;1|1080301:1=2263,1080302:1=72','{10000,10000}'),(1204008,1,0,1000,0,0,1,'1|1090100:5=10000;2|1090100:1=5000;2|1090200:1=10000;1|1090200:1=5000;1|13:1=9428;1|10:1=3017;1|95:1=2;1|99:1=158;1|1090301:1=708,1090302:1=25','{10000,10000}'),(1204009,1,0,1000,0,0,1,'1|1090100:10=10000;2|1090100:1=5000;2|1090200:1=10000;1|1090200:1=5000;1|13:1=9466;1|10:1=3102;1|95:1=2;1|99:1=158;1|1090301:1=1417,1090302:1=50','{10000,10000}'),(1204010,1,0,1000,0,0,1,'1|1090100:14=10000;2|1090100:1=5000;3|1090200:1=10000;1|1090200:1=5000;1|13:1=9504;1|10:1=3187;1|96:1=1;1|99:1=158;1|1090301:1=1558,1090302:1=55','{10000,10000}'),(1204011,1,0,1000,0,0,1,'1|1090100:18=10000;2|1090100:1=5000;3|1090200:1=10000;2|1090200:1=5000;1|13:1=9543;1|10:1=3272;1|96:1=1;1|99:1=158;1|1090301:1=1700,1090302:1=60','{10000,10000}'),(1204012,1,0,1000,0,0,1,'1|1090100:5=10000;2|1090100:1=5000;2|1090200:1=10000;1|1090200:1=5000;1|13:1=9581;1|10:1=3357;1|96:1=1;1|99:1=158;1|1090301:1=708,1090302:1=25','{10000,10000}'),(1204013,1,0,1000,0,0,1,'1|1100100:10=10000;2|1100100:1=5000;2|1100200:1=10000;1|1100200:1=5000;1|13:1=9619;1|10:1=3443;1|96:1=1;1|99:1=158;1|1100301:1=1260,1100302:1=40','{10000,10000}'),(1204014,1,0,1000,0,0,1,'1|1100100:10=10000;2|1100100:1=5000;2|1100200:1=10000;1|1100200:1=5000;1|13:1=9657;1|10:1=3528;1|96:1=1;1|99:1=158;1|1100301:1=1260,1100302:1=40','{10000,10000}'),(1205001,1,0,1000,0,0,1,'1|1100100:14=10000;2|1100100:1=5000;3|1100200:1=10000;1|1100200:1=5000;1|13:1=9696;1|10:1=3613;1|96:1=1;1|99:1=158;1|1100301:1=1386,1100302:1=44','{10000,10000}'),(1205002,1,0,1000,0,0,1,'1|1100100:18=10000;2|1100100:1=5000;3|1100200:1=10000;2|1100200:1=5000;1|13:1=9734;1|10:1=3698;1|96:1=1;1|99:1=158;1|1100301:1=1512,1100302:1=48','{10000,10000}'),(1205003,1,0,1000,0,0,1,'1|1110100:10=10000;2|1110100:1=5000;2|1110200:1=10000;1|1110200:1=5000;1|13:1=9772;1|10:1=3783;1|96:1=1;1|99:1=158;1|1110301:1=1153,1110302:1=30','{10000,10000}'),(1205004,1,0,1000,0,0,1,'1|1110100:10=10000;2|1110100:1=5000;2|1110200:1=10000;1|1110200:1=5000;1|13:1=9811;1|10:1=3868;1|97:1=1;1|99:1=158;1|1110301:1=1153,1110302:1=30','{10000,10000}'),(1205005,1,0,1000,0,0,1,'1|1110100:14=10000;2|1110100:1=5000;3|1110200:1=10000;1|1110200:1=5000;1|13:1=9849;1|10:1=3953;1|97:1=1;1|99:1=158;1|1110301:1=1269,1110302:1=33','{10000,10000}'),(1205006,1,0,1000,0,0,1,'1|1110100:18=10000;2|1110100:1=5000;3|1110200:1=10000;2|1110200:1=5000;1|13:1=9887;1|10:1=4038;1|97:1=1;1|99:1=158;1|1110301:1=1384,1110302:1=36','{10000,10000}'),(1205007,1,0,1000,0,0,1,'1|1120100:10=10000;2|1120100:1=5000;2|1120200:1=10000;1|1120200:1=5000;1|13:1=9926;1|10:1=4123;1|97:1=1;1|99:1=158;1|1120301:1=680,1120302:1=20','{10000,10000}'),(1205008,1,0,1000,0,0,1,'1|1120100:10=10000;2|1120100:1=5000;2|1120200:1=10000;1|1120200:1=5000;1|13:1=9964;1|10:1=4209;1|97:1=1;1|99:1=158;1|1120301:1=680,1120302:1=20','{10000,10000}'),(1206001,1,0,1000,0,0,1,'1|1120100:14=10000;2|1120100:1=5000;3|1120200:1=10000;1|1120200:1=5000;1|13:1=10000;2|13:1=2;1|10:1=4294;1|153:1=10000;1|97:1=1;1|99:1=158;1|1120301:1=748,1120302:1=22','{10000,10000}'),(1206002,1,0,1000,0,0,1,'1|1120100:18=10000;2|1120100:1=5000;3|1120200:1=10000;2|1120200:1=5000;1|13:1=10000;3|13:1=40;1|10:1=4379;1|153:1=10000;1|97:1=1;1|99:1=158;1|1120301:1=816,1120302:1=24','{10000,10000}'),(1206003,1,0,1000,0,0,1,'1|1130100:10=10000;2|1130100:1=5000;2|1130200:1=10000;1|1130200:1=5000;1|13:1=10000;4|13:1=79;1|10:1=4464;1|153:1=10000;1|97:1=1;1|99:1=158;1|1130301:1=511,1130302:1=10','{10000,10000}'),(1206004,1,0,1000,0,0,1,'1|1130100:14=10000;2|1130100:1=5000;3|1130200:1=10000;1|1130200:1=5000;1|13:1=10000;5|13:1=117;1|10:1=4549;1|153:1=10000;1|97:1=1;1|99:1=158;1|1130301:1=563,1130302:1=11','{10000,10000}'),(1206005,1,0,1000,0,0,1,'1|1130100:14=10000;2|1130100:1=5000;3|1130200:1=10000;1|1130200:1=5000;1|13:1=10000;6|13:1=155;1|10:1=4634;1|153:1=10000;1|97:1=1;1|99:1=158;1|1130301:1=563,1130302:1=11','{10000,10000}'),(1206006,1,0,1000,0,0,1,'1|1130100:18=10000;2|1130100:1=5000;3|1130200:1=10000;2|1130200:1=5000;1|13:1=10000;7|13:1=194;1|10:1=4719;1|153:1=10000;1|97:1=1;1|99:1=158;1|1130301:1=614,1130302:1=12','{10000,10000}'),(1206007,1,0,1000,0,0,1,'1|1140100:10=10000;2|1140100:1=5000;2|1140200:1=10000;1|1140200:1=5000;1|13:1=10000;8|13:1=232;1|10:1=4804;1|153:1=10000;1|97:1=1;1|99:1=158;1|1140301:1=641,1140302:1=10','{10000,10000}'),(1206008,1,0,1000,0,0,1,'1|1140100:14=10000;2|1140100:1=5000;3|1140200:1=10000;1|1140200:1=5000;1|13:1=10000;9|13:1=270;1|10:1=4889;1|153:1=10000;1|97:1=1;1|99:1=158;1|1140301:1=705,1140302:1=11','{10000,10000}'),(1207001,1,0,1000,0,0,1,'1|1150100:10=10000;2|1150100:1=5000;2|1150200:1=10000;1|1150200:1=5000;1|13:1=10000;10|13:1=309;1|10:1=4974;1|153:1=10000;1|97:1=1;1|99:1=158;1|1150301:1=567,1150302:1=10','{10000,10000}'),(1207002,1,0,1000,0,0,1,'1|1150100:14=10000;2|1150100:1=5000;3|1150200:1=10000;1|1150200:1=5000;1|13:1=10000;11|13:1=347;1|10:1=5060;1|153:1=10000;1|97:1=1;1|99:1=158;1|1150301:1=623,1150302:1=11','{10000,10000}'),(1207003,1,0,1000,0,0,1,'1|1150100:18=10000;2|1150100:1=5000;3|1150200:1=10000;2|1150200:1=5000;1|13:1=10000;12|13:1=385;1|10:1=5145;3|153:1=10000;1|97:1=1;1|99:1=158;1|1150301:1=680,1150302:1=12','{10000,10000}'),(1207004,1,0,1000,0,0,1,'1|1160100:10=10000;2|1160100:1=5000;2|1160200:1=10000;1|1160200:1=5000;1|13:1=10000;13|13:1=423;1|10:1=5230;3|153:1=10000;1|97:1=1;1|99:1=158;1|1160301:1=456,1160302:1=10','{10000,10000}'),(1207005,1,0,1000,0,0,1,'1|1160100:14=10000;2|1160100:1=5000;3|1160200:1=10000;1|1160200:1=5000;1|13:1=10000;14|13:1=462;1|10:1=5315;2|153:1=10000;1|97:1=1;1|99:1=158;1|1160301:1=501,1160302:1=11','{10000,10000}'),(1207006,1,0,1000,0,0,1,'1|1160100:18=10000;2|1160100:1=5000;3|1160200:1=10000;2|1160200:1=5000;1|13:1=10000;15|13:1=500;1|10:1=5400;2|153:1=10000;1|97:1=1;1|99:1=158;1|1160301:1=547,1160302:1=12','{10000,10000}'),(1251001,1,0,1000,0,0,1,'1|1050100:10=10000;2|1050100:1=5000;1|1050200:2=10000;2|1050200:1=3333;1|146:1=300;1|1050401:1=1125,1050402:1=750','{10000,10000}'),(1251002,1,0,1000,0,0,1,'1|1050100:14=10000;2|1050100:1=5000;1|1050200:2=10000;2|1050200:1=3333;1|146:1=300;1|1050401:1=1238,1050402:1=825','{10000,10000}'),(1251003,1,0,1000,0,0,1,'1|1060100:10=10000;2|1060100:1=5000;1|1060200:2=10000;2|1060200:1=3333;1|146:1=300;1|1060401:1=1406,1060402:1=625','{10000,10000}'),(1251004,1,0,1000,0,0,1,'1|1060100:14=10000;2|1060100:1=5000;1|1060200:2=10000;2|1060200:1=3333;1|13:1=10000;1|83:1=2500;1|14:1=2000;1|146:1=300;1|1060401:1=1547,1060402:1=688','{10000,10000}'),(1251005,1,0,1000,0,0,1,'1|1070100:10=10000;2|1070100:1=5000;1|1070200:2=10000;2|1070200:1=3333;1|13:1=10000;1|83:1=2550;1|14:1=1947;1|146:1=300;1|1070401:1=1205,1070402:1=536','{10000,10000}'),(1251006,1,0,1000,0,0,1,'1|1070100:14=10000;2|1070100:1=5000;1|1070200:2=10000;2|1070200:1=3333;1|13:1=10000;1|83:1=2600;1|14:1=1894;1|146:1=300;1|1070401:1=1326,1070402:1=589','{10000,10000}'),(1251007,1,0,1000,0,0,1,'1|1080100:10=10000;2|1080100:1=5000;1|1080200:2=10000;2|1080200:1=3333;1|13:1=10000;1|83:1=2650;1|14:1=1842;1|146:1=300;1|1080401:1=964,1080402:1=429','{10000,10000}'),(1252001,1,0,1000,0,0,1,'1|1060100:10=10000;2|1060100:1=5000;1|1060200:2=10000;2|1060200:1=3333;1|13:1=10000;1|83:1=2700;1|14:1=1789;1|147:1=300;1|1060401:1=1406,1060402:1=625','{10000,10000}'),(1252002,1,0,1000,0,0,1,'1|1060100:14=10000;2|1060100:1=5000;1|1060200:2=10000;2|1060200:1=3333;1|13:1=10000;1|83:1=2750;1|14:1=1736;1|147:1=300;1|1060401:1=1547,1060402:1=688','{10000,10000}'),(1252003,1,0,1000,0,0,1,'1|1070100:10=10000;2|1070100:1=5000;1|1070200:2=10000;2|1070200:1=3333;1|13:1=10000;1|83:1=2800;1|14:1=1684;1|147:1=300;1|1070401:1=1205,1070402:1=536','{10000,10000}'),(1252004,1,0,1000,0,0,1,'1|1080100:10=10000;2|1080100:1=5000;1|1080200:2=10000;2|1080200:1=3333;1|13:1=10000;1|83:1=2850;1|14:1=1631;1|147:1=300;1|1080401:1=964,1080402:1=429','{10000,10000}'),(1252005,1,0,1000,0,0,1,'1|1090100:10=10000;2|1090100:1=5000;1|1090200:2=10000;2|1090200:1=3333;1|13:1=10000;1|83:1=2900;1|14:1=1578;1|147:1=300;1|1090401:1=750,1090402:1=333','{10000,10000}'),(1253001,1,0,1000,0,0,1,'1|1070100:18=10000;2|1070100:1=5000;1|1070200:2=10000;2|1070200:1=3333;1|13:1=10000;1|83:1=2950;1|14:1=1526;1|148:1=300;1|1070401:1=1446,1070402:1=643','{10000,10000}'),(1253002,1,0,1000,0,0,1,'1|1080100:14=10000;2|1080100:1=5000;1|1080200:2=10000;2|1080200:1=3333;1|13:1=10000;1|83:1=3000;1|14:1=1473;1|148:1=300;1|1080401:1=1061,1080402:1=471','{10000,10000}'),(1253003,1,0,1000,0,0,1,'1|1090100:10=10000;2|1090100:1=5000;1|1090200:2=10000;2|1090200:1=3333;1|13:1=10000;1|83:1=3050;1|14:1=1421;1|148:1=300;1|1090401:1=750,1090402:1=333','{10000,10000}'),(1253004,1,0,1000,0,0,1,'1|1090100:14=10000;2|1090100:1=5000;1|1090200:2=10000;2|1090200:1=3333;1|13:1=10000;1|83:1=3100;1|14:1=1368;1|148:1=300;1|1090401:1=825,1090402:1=367','{10000,10000}'),(1253005,1,0,1000,0,0,1,'1|1100100:10=10000;2|1100100:1=5000;1|1100200:2=10000;2|1100200:1=3333;1|13:1=10000;1|83:1=3150;1|14:1=1315;1|148:1=300;1|1100401:1=675,1100402:1=300','{10000,10000}'),(1254001,1,0,1000,0,0,1,'1|1090100:10=10000;2|1090100:1=5000;1|1090200:2=10000;2|1090200:1=3333;1|13:1=10000;1|83:1=3200;1|14:1=1263;1|149:1=300;1|1090401:1=750,1090402:1=333','{10000,10000}'),(1254002,1,0,1000,0,0,1,'1|1100100:10=10000;2|1100100:1=5000;1|1100200:2=10000;2|1100200:1=3333;1|13:1=10000;1|83:1=3250;1|14:1=1210;1|149:1=300;1|1100401:1=675,1100402:1=300','{10000,10000}'),(1254003,1,0,1000,0,0,1,'1|1100100:10=10000;2|1100100:1=5000;1|1100200:2=10000;2|1100200:1=3333;1|13:1=10000;1|83:1=3300;1|14:1=1157;1|149:1=300;1|1100401:1=675,1100402:1=300','{10000,10000}'),(1254004,1,0,1000,0,0,1,'1|1110100:10=10000;2|1110100:1=5000;1|1110200:2=10000;2|1110200:1=3333;1|13:1=10000;1|83:1=3350;1|14:1=1105;1|149:1=300;1|1110401:1=600,1110402:1=200','{10000,10000}'),(1254005,1,0,1000,0,0,1,'1|1120100:10=10000;2|1120100:1=5000;1|1120200:2=10000;2|1120200:1=3333;1|13:1=10000;1|83:1=3400;1|14:1=1052;1|149:1=300;1|1120401:1=360,1120402:1=120','{10000,10000}'),(1255001,1,0,1000,0,0,1,'1|1110100:10=10000;2|1110100:1=5000;1|1110200:2=10000;2|1110200:1=3333;1|13:1=10000;1|83:1=3450;1|14:1=1000;1|150:1=300;1|1110401:1=600,1110402:1=200','{10000,10000}'),(1255002,1,0,1000,0,0,1,'1|1110100:10=10000;2|1110100:1=5000;1|1110200:2=10000;2|1110200:1=3333;1|13:1=10000;1|83:1=3500;1|14:1=947;1|150:1=300;1|1110401:1=600,1110402:1=200','{10000,10000}'),(1255003,1,0,1000,0,0,1,'1|1120100:10=10000;2|1120100:1=5000;1|1120200:2=10000;2|1120200:1=3333;1|13:1=10000;1|83:1=3550;1|14:1=894;1|150:1=300;1|1120401:1=360,1120402:1=120','{10000,10000}'),(1255004,1,0,1000,0,0,1,'1|1130100:10=10000;2|1130100:1=5000;1|1130200:2=10000;2|1130200:1=3333;1|13:1=10000;1|83:1=3600;1|14:1=842;1|150:1=300;1|1130401:1=257,1130402:1=171','{10000,10000}'),(1255005,1,0,1000,0,0,1,'1|1140100:10=10000;2|1140100:1=5000;1|1140200:2=10000;2|1140200:1=3333;1|13:1=10000;1|83:1=3650;1|14:1=789;1|150:1=300;1|1140401:1=333,1140402:1=222','{10000,10000}'),(1256001,1,0,1000,0,0,1,'1|1120100:10=10000;2|1120100:1=5000;1|1120200:2=10000;2|1120200:1=3333;1|13:1=10000;1|83:1=3700;1|14:1=736;1|151:1=300;1|1120401:1=360,1120402:1=120','{10000,10000}'),(1256002,1,0,1000,0,0,1,'1|1130100:10=10000;2|1130100:1=5000;1|1130200:2=10000;2|1130200:1=3333;1|13:1=10000;1|83:1=3750;1|14:1=684;1|151:1=300;1|1130401:1=257,1130402:1=171','{10000,10000}'),(1256003,1,0,1000,0,0,1,'1|1130100:10=10000;2|1130100:1=5000;1|1130200:2=10000;2|1130200:1=3333;1|13:1=10000;1|83:1=3800;1|14:1=631;1|151:1=300;1|1130401:1=257,1130402:1=171','{10000,10000}'),(1256004,1,0,1000,0,0,1,'1|1140100:10=10000;2|1140100:1=5000;1|1140200:2=10000;2|1140200:1=3333;1|13:1=10000;1|83:1=3850;1|14:1=578;1|151:1=300;1|1140401:1=333,1140402:1=222','{10000,10000}'),(1256005,1,0,1000,0,0,1,'1|1140100:10=10000;2|1140100:1=5000;1|1140200:2=10000;2|1140200:1=3333;1|13:1=10000;1|83:1=3900;1|14:1=526;1|151:1=300;1|1140401:1=333,1140402:1=222','{10000,10000}'),(1257001,1,0,1000,0,0,1,'1|1130100:10=10000;2|1130100:1=5000;1|1130200:2=10000;2|1130200:1=3333;1|13:1=10000;1|83:1=3950;1|14:1=473;1|152:1=300;1|1130401:1=257,1130402:1=171','{10000,10000}'),(1257002,1,0,1000,0,0,1,'1|1140100:10=10000;2|1140100:1=5000;1|1140200:2=10000;2|1140200:1=3333;1|13:1=10000;1|83:1=4000;1|14:1=421;1|152:1=300;1|1140401:1=333,1140402:1=222','{10000,10000}'),(1257003,1,0,1000,0,0,1,'1|1140100:10=10000;2|1140100:1=5000;1|1140200:2=10000;2|1140200:1=3333;1|13:1=10000;1|83:1=4050;1|14:1=368;1|152:1=300;1|1140401:1=333,1140402:1=222','{10000,10000}'),(1257004,1,0,1000,0,0,1,'1|1150100:10=10000;2|1150100:1=5000;1|1150200:2=10000;2|1150200:1=3333;1|13:1=10000;1|83:1=4100;1|14:1=315;1|152:1=300;1|1150401:1=300,1150402:1=200','{10000,10000}'),(1257005,1,0,1000,0,0,1,'1|1160100:10=10000;2|1160100:1=5000;1|1160200:2=10000;2|1160200:1=3333;1|13:1=10000;1|83:1=4150;1|14:1=263;1|152:1=300;1|1160401:1=250,1160402:1=167','{10000,10000}'),(1301001,1,0,1000,0,0,1,'1|1060100:10=10000;2|1060100:1=5000;1|1060200:2=10000;2|1060200:1=3333;7|13:1=10000;1|13:4=4925;2|14:1=10000;1|14:2=1050;1|1060601:1=1406,1060602:1=469','{10000,10000}'),(1301002,1,0,1000,0,0,1,'1|1070100:10=10000;2|1070100:1=5000;1|1070200:2=10000;2|1070200:1=3333;7|13:1=10000;1|13:4=5081;2|14:1=10000;1|14:2=1277;1|1070601:1=1205,1070602:1=402','{10000,10000}'),(1301003,1,0,1000,0,0,1,'1|1070100:14=10000;2|1070100:1=5000;1|1070200:2=10000;2|1070200:1=3333;7|13:1=10000;1|13:4=5236;2|14:1=10000;1|14:2=1505;1|1070601:1=1326,1070602:1=442','{10000,10000}'),(1301004,1,0,1000,0,0,1,'1|1070100:18=10000;2|1070100:1=5000;1|1070200:2=10000;2|1070200:1=3333;7|13:1=10000;1|13:4=5392;2|14:1=10000;1|14:2=1732;1|1070601:1=1446,1070602:1=482','{10000,10000}'),(1301005,1,0,1000,0,0,1,'1|1080100:10=10000;2|1080100:1=5000;1|1080200:2=10000;2|1080200:1=3333;7|13:1=10000;1|13:4=5548;2|14:1=10000;1|14:2=1960;1|1080601:1=964,1080602:1=321','{10000,10000}'),(1301006,1,0,1000,0,0,1,'1|1080100:14=10000;2|1080100:1=5000;1|1080200:2=10000;2|1080200:1=3333;7|13:1=10000;1|13:4=5703;2|14:1=10000;1|14:2=2187;1|1080601:1=1061,1080602:1=354','{10000,10000}'),(1301007,1,0,1000,0,0,1,'1|1090100:10=10000;2|1090100:1=5000;1|1090200:2=10000;2|1090200:1=3333;7|13:1=10000;1|13:4=5859;2|14:1=10000;1|14:2=2415;1|1090601:1=750,1090602:1=250','{10000,10000}'),(1301008,1,0,1000,0,0,1,'1|1090100:14=10000;2|1090100:1=5000;1|1090200:2=10000;2|1090200:1=3333;7|13:1=10000;1|13:4=6015;2|14:1=10000;1|14:2=2642;1|1090601:1=825,1090602:1=275','{10000,10000}'),(1301901,1,0,1000,0,0,1,'1|6:1=5000','{10000,10000}'),(1301902,1,0,1000,0,0,1,'1|6:1=5032','{10000,10000}'),(1301903,1,0,1000,0,0,1,'1|6:1=5064','{10000,10000}'),(1301904,1,0,1000,0,0,1,'1|6:1=5096','{10000,10000}'),(1301905,1,0,1000,0,0,1,'1|6:1=5129','{10000,10000}'),(1301906,1,0,1000,0,0,1,'1|6:1=5161','{10000,10000}'),(1301907,1,0,1000,0,0,1,'1|6:1=5193','{10000,10000}'),(1301908,1,0,1000,0,0,1,'1|6:1=5225','{10000,10000}'),(1302001,1,0,1000,0,0,1,'1|1100100:10=10000;2|1100100:1=5000;1|1100200:2=10000;2|1100200:1=3333;7|13:1=10000;1|13:4=6170;2|14:1=10000;1|14:2=2869;1|1100601:1=675,1100602:1=225','{10000,10000}'),(1302002,1,0,1000,0,0,1,'1|1100100:10=10000;2|1100100:1=5000;1|1100200:2=10000;2|1100200:1=3333;7|13:1=10000;1|13:4=6326;2|14:1=10000;1|14:2=3097;1|1100601:1=675,1100602:1=225','{10000,10000}'),(1302003,1,0,1000,0,0,1,'1|1110100:14=10000;2|1110100:1=5000;1|1110200:2=10000;2|1110200:1=3333;7|13:1=10000;1|13:4=6481;2|14:1=10000;1|14:2=3324;1|1110601:1=660,1110602:1=165','{10000,10000}'),(1302004,1,0,1000,0,0,1,'1|1110100:18=10000;2|1110100:1=5000;1|1110200:2=10000;2|1110200:1=3333;7|13:1=10000;1|13:4=6637;2|14:1=10000;1|14:2=3552;1|1110601:1=720,1110602:1=180','{10000,10000}'),(1302005,1,0,1000,0,0,1,'1|1110100:10=10000;2|1110100:1=5000;1|1110200:2=10000;2|1110200:1=3333;7|13:1=10000;1|13:4=6793;2|14:1=10000;1|14:2=3779;1|1110601:1=600,1110602:1=150','{10000,10000}'),(1302006,1,0,1000,0,0,1,'1|1120100:14=10000;2|1120100:1=5000;1|1120200:2=10000;2|1120200:1=3333;7|13:1=10000;1|13:4=6948;2|14:1=10000;1|14:2=4006;1|1120601:1=396,1120602:1=99','{10000,10000}'),(1302007,1,0,1000,0,0,1,'1|1120100:10=10000;2|1120100:1=5000;1|1120200:2=10000;2|1120200:1=3333;7|13:1=10000;1|13:4=7104;2|14:1=10000;1|14:2=4234;1|1120601:1=360,1120602:1=90','{10000,10000}'),(1302008,1,0,1000,0,0,1,'1|1120100:14=10000;2|1120100:1=5000;1|1120200:2=10000;2|1120200:1=3333;7|13:1=10000;1|13:4=7260;2|14:1=10000;1|14:2=4461;1|1120601:1=396,1120602:1=99','{10000,10000}'),(1302901,1,0,1000,0,0,1,'1|6:1=5258','{10000,10000}'),(1302902,1,0,1000,0,0,1,'1|6:1=5290','{10000,10000}'),(1302903,1,0,1000,0,0,1,'1|6:1=5322','{10000,10000}'),(1302904,1,0,1000,0,0,1,'1|6:1=5354','{10000,10000}'),(1302905,1,0,1000,0,0,1,'1|6:1=5387','{10000,10000}'),(1302906,1,0,1000,0,0,1,'1|6:1=5419','{10000,10000}'),(1302907,1,0,1000,0,0,1,'1|6:1=5451','{10000,10000}'),(1302908,1,0,1000,0,0,1,'1|6:1=5483','{10000,10000}'),(1303001,1,0,1000,0,0,1,'1|1120100:10=10000;2|1120100:1=5000;1|1120200:2=10000;2|1120200:1=3333;7|13:1=10000;1|13:4=7415;2|14:1=10000;1|14:2=4689;1|1120601:1=360,1120602:1=90','{10000,10000}'),(1303002,1,0,1000,0,0,1,'1|1120100:10=10000;2|1120100:1=5000;1|1120200:2=10000;2|1120200:1=3333;7|13:1=10000;1|13:4=7571;2|14:1=10000;1|14:2=4916;1|1120601:1=360,1120602:1=90','{10000,10000}'),(1303003,1,0,1000,0,0,1,'1|1120100:14=10000;2|1120100:1=5000;1|1120200:2=10000;2|1120200:1=3333;7|13:1=10000;1|13:4=7727;2|14:1=10000;1|14:2=5144;1|1120601:1=396,1120602:1=99','{10000,10000}'),(1303004,1,0,1000,0,0,1,'1|1130100:18=10000;2|1130100:1=5000;1|1130200:2=10000;2|1130200:1=3333;7|13:1=10000;1|13:4=7882;2|14:1=10000;1|14:2=5371;1|1130601:1=309,1130602:1=154','{10000,10000}'),(1303005,1,0,1000,0,0,1,'1|1130100:10=10000;2|1130100:1=5000;1|1130200:2=10000;2|1130200:1=3333;7|13:1=10000;1|13:4=8038;2|14:1=10000;1|14:2=5598;1|1130601:1=257,1130602:1=129','{10000,10000}'),(1303006,1,0,1000,0,0,1,'1|1130100:14=10000;2|1130100:1=5000;1|1130200:2=10000;2|1130200:1=3333;7|13:1=10000;1|13:4=8194;2|14:1=10000;1|14:2=5826;1|1130601:1=283,1130602:1=141','{10000,10000}'),(1303007,1,0,1000,0,0,1,'1|1140100:10=10000;2|1140100:1=5000;1|1140200:2=10000;2|1140200:1=3333;7|13:1=10000;1|13:4=8349;2|14:1=10000;1|14:2=6053;1|1140601:1=333,1140602:1=167','{10000,10000}'),(1303008,1,0,1000,0,0,1,'1|1140100:14=10000;2|1140100:1=5000;1|1140200:2=10000;2|1140200:1=3333;7|13:1=10000;1|13:4=8505;2|14:1=10000;1|14:2=6281;1|1140601:1=367,1140602:1=183','{10000,10000}'),(1303901,1,0,1000,0,0,1,'1|6:1=5516','{10000,10000}'),(1303902,1,0,1000,0,0,1,'1|6:1=5548','{10000,10000}'),(1303903,1,0,1000,0,0,1,'1|6:1=5580','{10000,10000}'),(1303904,1,0,1000,0,0,1,'1|6:1=5612','{10000,10000}'),(1303905,1,0,1000,0,0,1,'1|6:1=5645','{10000,10000}'),(1303906,1,0,1000,0,0,1,'1|6:1=5677','{10000,10000}'),(1303907,1,0,1000,0,0,1,'1|6:1=5709','{10000,10000}'),(1303908,1,0,1000,0,0,1,'1|6:1=5741','{10000,10000}'),(1304001,1,0,1000,0,0,1,'1|1140100:10=10000;2|1140100:1=5000;1|1140200:2=10000;2|1140200:1=3333;7|13:1=10000;1|13:4=8660;2|14:1=10000;1|14:2=6508;1|1140601:1=333,1140602:1=167','{10000,10000}'),(1304002,1,0,1000,0,0,1,'1|1140100:14=10000;2|1140100:1=5000;1|1140200:2=10000;2|1140200:1=3333;7|13:1=10000;1|13:4=8816;2|14:1=10000;1|14:2=6735;1|1140601:1=367,1140602:1=183','{10000,10000}'),(1304003,1,0,1000,0,0,1,'1|1140100:18=10000;2|1140100:1=5000;1|1140200:2=10000;2|1140200:1=3333;7|13:1=10000;1|13:4=8972;2|14:1=10000;1|14:2=6963;1|1140601:1=400,1140602:1=200','{10000,10000}'),(1304004,1,0,1000,0,0,1,'1|1150100:10=10000;2|1150100:1=5000;1|1150200:2=10000;2|1150200:1=3333;7|13:1=10000;1|13:4=9127;2|14:1=10000;1|14:2=7190;1|1150601:1=300,1150602:1=150','{10000,10000}'),(1304005,1,0,1000,0,0,1,'1|1150100:14=10000;2|1150100:1=5000;1|1150200:2=10000;2|1150200:1=3333;7|13:1=10000;1|13:4=9283;2|14:1=10000;1|14:2=7418;1|1150601:1=330,1150602:1=165','{10000,10000}'),(1304006,1,0,1000,0,0,1,'1|1150100:18=10000;2|1150100:1=5000;1|1150200:2=10000;2|1150200:1=3333;7|13:1=10000;1|13:4=9439;2|14:1=10000;1|14:2=7645;1|1150601:1=360,1150602:1=180','{10000,10000}'),(1304007,1,0,1000,0,0,1,'1|1160100:10=10000;2|1160100:1=5000;1|1160200:2=10000;2|1160200:1=3333;7|13:1=10000;1|13:4=9594;2|14:1=10000;1|14:2=7873;1|1160601:1=250,1160602:1=125','{10000,10000}'),(1304008,1,0,1000,0,0,1,'1|1160100:14=10000;2|1160100:1=5000;1|1160200:2=10000;2|1160200:1=3333;7|13:1=10000;1|13:4=9750;2|14:1=10000;1|14:2=8100;1|1160601:1=275,1160602:1=138','{10000,10000}'),(1304901,1,0,1000,0,0,1,'1|6:1=5774','{10000,10000}'),(1304902,1,0,1000,0,0,1,'1|6:1=5806','{10000,10000}'),(1304903,1,0,1000,0,0,1,'1|6:1=5838','{10000,10000}'),(1304904,1,0,1000,0,0,1,'1|6:1=5870','{10000,10000}'),(1304905,1,0,1000,0,0,1,'1|6:1=5903','{10000,10000}'),(1304906,1,0,1000,0,0,1,'1|6:1=5935','{10000,10000}'),(1304907,1,0,1000,0,0,1,'1|6:1=5967','{10000,10000}'),(1304908,1,0,1000,0,0,1,'1|6:1=6000','{10000,10000}'),(1341002,1,0,1000,0,0,1,'1|1040100:8=10000;2|1040100:1=5000;1|1040200:3=10000;2|1040200:2=5000;1|17:3=10000;1|18:1=10000;1|93:1=158;1|1040501:1=5800,1040502:1=2900','{10000,10000}'),(1341003,1,0,1000,0,0,1,'1|1050100:8=10000;2|1050100:1=5000;1|1050200:3=10000;2|1050200:2=5000;1|17:3=10000;1|18:1=10000;1|93:1=158;1|1050501:1=4320,1050502:1=2160','{10000,10000}'),(1341004,1,0,1000,0,0,1,'1|1050100:8=10000;2|1050100:1=5000;1|1060100:6=10000;1|1050200:2=10000;2|1050200:1=5000;1|1060200:1=10000;1|17:3=10000;1|18:1=10000;1|93:1=158;1|1050501:1=2160,1050502:1=1081,1060501:1=2703,1060502:1=883','{10000,10000}'),(1341005,1,0,1000,0,0,1,'1|1060100:8=10000;2|1060100:1=5000;1|1070100:6=10000;1|1060200:2=10000;2|1060200:1=5000;1|1070200:1=10000;5|83:1=7716;2|14:1=4786;1|17:3=10000;1|18:1=10000;1|94:1=80;1|176:1=2000;1|1060501:1=2703,1060502:1=883,1070501:1=2314,1070502:1=756','{10000,10000}'),(1341006,1,0,1000,0,0,1,'1|1070100:8=10000;2|1070100:1=5000;1|1080100:6=10000;1|1070200:2=10000;2|1070200:1=5000;1|1080200:1=10000;5|83:1=7820;2|14:1=4977;1|17:3=10000;1|18:1=10000;1|94:1=80;1|176:1=2000;1|1070501:1=2314,1070502:1=756,1080501:1=1830,1080502:1=594','{10000,10000}'),(1341007,1,0,1000,0,0,1,'1|1080100:8=10000;2|1080100:1=5000;1|1090100:6=10000;1|1080200:2=10000;2|1080200:1=5000;1|1090200:1=10000;5|83:1=7923;2|14:1=5169;1|17:4=10000;1|18:1=10000;1|95:1=2;1|178:1=2000;1|1080501:1=1830,1080502:1=594,1090501:1=1400,1090502:1=451','{10000,10000}'),(1341008,1,0,1000,0,0,1,'1|1090100:8=10000;2|1090100:1=5000;1|1100100:6=10000;1|1090200:2=10000;2|1090200:1=5000;1|1100200:1=10000;5|83:1=8027;2|14:1=5360;1|17:4=10000;1|18:1=10000;1|95:1=2;1|178:1=2000;1|1090501:1=1400,1090502:1=451,1100501:1=1250,1100502:1=400','{10000,10000}'),(1341009,1,0,1000,0,0,1,'1|1100100:8=10000;2|1100100:1=5000;1|1110100:6=10000;1|1100200:2=10000;2|1100200:1=5000;1|1110200:1=10000;5|83:1=8130;2|14:1=5551;1|17:4=10000;1|18:1=10000;1|96:1=1;1|178:1=2000;1|1100501:1=1250,1100502:1=400,1110501:1=1125,1110502:1=262','{10000,10000}'),(1341010,1,0,1000,0,0,1,'1|1110100:8=10000;2|1110100:1=5000;1|1120100:6=10000;1|1110200:2=10000;2|1110200:1=5000;1|1120200:1=10000;5|83:1=8233;2|14:1=5743;1|17:4=10000;1|18:1=10000;1|96:1=1;1|177:1=2000;1|1110501:1=1125,1110502:1=262,1120501:1=670,1120502:1=155','{10000,10000}'),(1341011,1,0,1000,0,0,1,'1|1120100:8=10000;2|1120100:1=5000;1|1130100:6=10000;1|1120200:2=10000;2|1120200:1=5000;1|1130200:1=10000;5|83:1=8337;2|14:1=5934;1|17:5=10000;1|18:1=10000;1|97:1=1;1|177:1=2000;1|1120501:1=670,1120502:1=155,1130501:1=489,1130502:1=244','{10000,10000}'),(1341012,1,0,1000,0,0,1,'1|1130100:8=10000;2|1130100:1=5000;1|1140100:6=10000;1|1130200:2=10000;2|1130200:1=5000;1|1140200:1=10000;5|83:1=8440;2|14:1=6126;1|17:5=10000;1|18:1=10000;1|97:1=1;1|177:1=2000;1|1130501:1=489,1130502:1=244,1140501:1=622,1140502:1=311','{10000,10000}'),(1341013,1,0,1000,0,0,1,'1|1140100:8=10000;2|1140100:1=5000;1|1150100:6=10000;1|1140200:2=10000;2|1140200:1=5000;1|1150200:1=10000;5|83:1=8543;2|14:1=6317;1|17:5=10000;1|18:1=10000;1|97:1=1;1|177:1=2000;1|1140501:1=622,1140502:1=311,1150501:1=555,1150502:1=278','{10000,10000}'),(1341014,1,0,1000,0,0,1,'1|1140100:8=10000;2|1140100:1=5000;1|1150100:6=10000;1|1140200:2=10000;2|1140200:1=5000;1|1150200:1=10000;5|83:1=8647;2|14:1=6509;1|17:5=10000;1|18:1=10000;1|97:1=1;1|177:1=2000;1|1140501:1=622,1140502:1=311,1150501:1=555,1150502:1=278','{10000,10000}'),(1341015,1,0,1000,0,0,1,'1|1150100:8=10000;2|1150100:1=5000;1|1160100:6=10000;1|1150200:2=10000;2|1150200:1=5000;1|1160200:1=10000;5|83:1=8750;2|14:1=6700;1|17:5=10000;1|18:1=10000;1|97:1=1;1|177:1=2000;1|1150501:1=555,1150502:1=278,1160501:1=455,1160502:1=228','{10000,10000}'),(1341016,1,0,1000,0,0,1,'1|1150100:8=10000;2|1150100:1=5000;1|1160100:6=10000;1|1150200:2=10000;2|1150200:1=5000;1|1160200:1=10000;5|83:1=8750;2|14:1=6700;1|17:5=10000;1|18:1=10000;1|97:1=1;1|177:1=2000;1|1150501:1=555,1150502:1=278,1160501:1=455,1160502:1=228','{10000,10000}'),(3110007,3,0,1000,0,0,0,'1|1040100:4=10000;1|2040100:4=10000;1|1040200:1=10000;1|2040200:1=10000;1|1040200:1=5000;1|2040200:1=5000;1|1040801:1=6500,1040802:1=3250','{10000,10000}'),(3111007,3,0,1000,0,0,0,'1|1050100:8=10000;1|1050200:1=10000;1|1050200:1=5000;1|1050801:1=5500,1050802:1=2750','{10000,10000}'),(3112007,3,0,1000,0,0,0,'1|1050100:4=10000;1|1060100:4=10000;1|1050200:1=10000;1|1060200:1=10000;1|1050200:1=5000;1|1060200:1=5000;1|1050801:1=5500,1050802:1=2750','{10000,10000}'),(3113007,3,0,1000,0,0,0,'1|1060100:4=10000;1|1070100:4=10000;1|1060200:1=10000;1|1070200:1=10000;1|1060200:1=5000;1|1070200:1=5000;1|1060801:1=4500,1060802:1=2250','{10000,10000}'),(3114007,3,0,1000,0,0,0,'1|1070100:4=10000;1|1080100:4=10000;1|1070200:1=10000;1|1080200:1=10000;1|1070200:1=5000;1|1080200:1=5000;1|1070801:1=3500,1070802:1=1750','{10000,10000}'),(3115007,3,0,1000,0,0,0,'1|1080100:4=10000;1|1090100:4=10000;1|1080200:1=10000;1|1090200:1=10000;1|1080200:1=5000;1|1090200:1=5000;1|1080801:1=2500,1080802:1=1250','{10000,10000}'),(3116007,3,0,1000,0,0,0,'1|1090100:4=10000;1|1100100:4=10000;1|1090200:1=10000;1|1100200:1=10000;1|1090200:1=5000;1|1100200:1=5000;1|1090801:1=1500,1090802:1=750','{10000,10000}'),(3117007,3,0,1000,0,0,0,'1|1100100:4=10000;1|1110100:4=10000;1|1100200:1=10000;1|1110200:1=10000;1|1100200:1=5000;1|1110200:1=5000;1|1100801:1=1350,1100802:1=675','{10000,10000}'),(3118007,3,0,1000,0,0,0,'1|1110100:4=10000;1|1120100:4=10000;1|1110200:1=10000;1|1120200:1=10000;1|1110200:1=5000;1|1120200:1=5000;1|1110801:1=1200,1110802:1=600','{10000,10000}'),(3119007,3,0,1000,0,0,0,'1|1120100:4=10000;1|1130100:4=10000;1|1120200:1=10000;1|1130200:1=10000;1|1120200:1=5000;1|1130200:1=5000;1|1120801:1=720,1120802:1=360','{10000,10000}'),(3120007,3,0,1000,0,0,0,'1|1130100:4=10000;1|1140100:4=10000;1|1130200:1=10000;1|1140200:1=10000;1|1130200:1=5000;1|1140200:1=5000;1|1130801:1=514,1130802:1=257','{10000,10000}'),(3121007,3,0,1000,0,0,0,'1|1140100:4=10000;1|1150100:4=10000;1|1140200:1=10000;1|1150200:1=10000;1|1140200:1=5000;1|1150200:1=5000;1|1140801:1=667,1140802:1=333','{10000,10000}'),(3122007,3,0,1000,0,0,0,'1|1150100:4=10000;1|1160100:4=10000;1|1150200:1=10000;1|1160200:1=10000;1|1150200:1=5000;1|1160200:1=5000;1|1150801:1=600,1150802:1=300','{10000,10000}'),(3300105,3,0,1000,0,0,0,'1|2:1=10000;1|2:1=5000','{10000,10000}'),(3300106,3,0,1000,0,0,0,'3|2:1=10000','{10000,10000}'),(3300107,3,0,1000,0,0,0,'4|2:1=10000;1|2:1=5000','{10000,10000}'),(3300108,3,0,1000,0,0,0,'6|2:1=10000','{10000,10000}'),(3300205,3,0,1000,0,0,0,'1|2:1=10000;1|2:1=5000','{10000,10000}'),(3300206,3,0,1000,0,0,0,'3|2:1=10000','{10000,10000}'),(3300207,3,0,1000,0,0,0,'4|2:1=10000;1|2:1=5000','{10000,10000}'),(3300208,3,0,1000,0,0,0,'6|2:1=10000','{10000,10000}'),(3300305,3,0,1000,0,0,0,'1|2:1=10000;1|2:1=5000','{10000,10000}'),(3300306,3,0,1000,0,0,0,'3|2:1=10000','{10000,10000}'),(3300307,3,0,1000,0,0,0,'4|2:1=10000;1|2:1=5000','{10000,10000}'),(3300308,3,0,1000,0,0,0,'6|2:1=10000','{10000,10000}'),(3300405,3,0,1000,0,0,0,'1|2:1=10000;1|2:1=5000','{10000,10000}'),(3300406,3,0,1000,0,0,0,'3|2:1=10000','{10000,10000}'),(3300407,3,0,1000,0,0,0,'4|2:1=10000;1|2:1=5000','{10000,10000}'),(3300408,3,0,1000,0,0,0,'6|2:1=10000','{10000,10000}'),(3301105,3,0,1000,0,0,0,'2|2:1=10000;1|2:1=2500','{10000,10000}'),(3301106,3,0,1000,0,0,0,'4|2:1=10000;1|2:1=5000','{10000,10000}'),(3301107,3,0,1000,0,0,0,'6|2:1=10000;1|2:1=7500','{10000,10000}'),(3301108,3,0,1000,0,0,0,'9|2:1=10000','{10000,10000}'),(3301205,3,0,1000,0,0,0,'2|2:1=10000;1|2:1=2500','{10000,10000}'),(3301206,3,0,1000,0,0,0,'4|2:1=10000;1|2:1=5000','{10000,10000}'),(3301207,3,0,1000,0,0,0,'6|2:1=10000;1|2:1=7500','{10000,10000}'),(3301208,3,0,1000,0,0,0,'9|2:1=10000','{10000,10000}'),(3301305,3,0,1000,0,0,0,'2|2:1=10000;1|2:1=2500','{10000,10000}'),(3301306,3,0,1000,0,0,0,'4|2:1=10000;1|2:1=5000','{10000,10000}'),(3301307,3,0,1000,0,0,0,'6|2:1=10000;1|2:1=7500','{10000,10000}'),(3301308,3,0,1000,0,0,0,'9|2:1=10000','{10000,10000}'),(3301405,3,0,1000,0,0,0,'2|2:1=10000;1|2:1=2500','{10000,10000}'),(3301406,3,0,1000,0,0,0,'4|2:1=10000;1|2:1=5000','{10000,10000}'),(3301407,3,0,1000,0,0,0,'6|2:1=10000;1|2:1=7500','{10000,10000}'),(3301408,3,0,1000,0,0,0,'9|2:1=10000','{10000,10000}'),(3302105,3,0,1000,0,0,0,'3|2:1=10000','{10000,10000}'),(3302106,3,0,1000,0,0,0,'6|2:1=10000','{10000,10000}'),(3302107,3,0,1000,0,0,0,'9|2:1=10000','{10000,10000}'),(3302108,3,0,1000,0,0,0,'12|2:1=10000','{10000,10000}'),(3302205,3,0,1000,0,0,0,'3|2:1=10000','{10000,10000}'),(3302206,3,0,1000,0,0,0,'6|2:1=10000','{10000,10000}'),(3302207,3,0,1000,0,0,0,'9|2:1=10000','{10000,10000}'),(3302208,3,0,1000,0,0,0,'12|2:1=10000','{10000,10000}'),(3302305,3,0,1000,0,0,0,'3|2:1=10000','{10000,10000}'),(3302306,3,0,1000,0,0,0,'6|2:1=10000','{10000,10000}'),(3302307,3,0,1000,0,0,0,'9|2:1=10000','{10000,10000}'),(3302308,3,0,1000,0,0,0,'12|2:1=10000','{10000,10000}'),(3302405,3,0,1000,0,0,0,'3|2:1=10000','{10000,10000}'),(3302406,3,0,1000,0,0,0,'6|2:1=10000','{10000,10000}'),(3302407,3,0,1000,0,0,0,'9|2:1=10000','{10000,10000}'),(3302408,3,0,1000,0,0,0,'12|2:1=10000','{10000,10000}'),(3303105,3,0,1000,0,0,0,'3|2:1=10000;1|2:1=7500','{10000,10000}'),(3303106,3,0,1000,0,0,0,'7|2:1=10000;1|2:1=5000','{10000,10000}'),(3303107,3,0,1000,0,0,0,'11|2:1=10000;1|2:1=2500','{10000,10000}'),(3303108,3,0,1000,0,0,0,'15|2:1=10000','{10000,10000}'),(3303205,3,0,1000,0,0,0,'3|2:1=10000;1|2:1=7500','{10000,10000}'),(3303206,3,0,1000,0,0,0,'7|2:1=10000;1|2:1=5000','{10000,10000}'),(3303207,3,0,1000,0,0,0,'11|2:1=10000;1|2:1=2500','{10000,10000}'),(3303208,3,0,1000,0,0,0,'15|2:1=10000','{10000,10000}'),(3303305,3,0,1000,0,0,0,'3|2:1=10000;1|2:1=7500','{10000,10000}'),(3303306,3,0,1000,0,0,0,'7|2:1=10000;1|2:1=5000','{10000,10000}'),(3303307,3,0,1000,0,0,0,'11|2:1=10000;1|2:1=2500','{10000,10000}'),(3303308,3,0,1000,0,0,0,'15|2:1=10000','{10000,10000}'),(3303405,3,0,1000,0,0,0,'3|2:1=10000;1|2:1=7500','{10000,10000}'),(3303406,3,0,1000,0,0,0,'7|2:1=10000;1|2:1=5000','{10000,10000}'),(3303407,3,0,1000,0,0,0,'11|2:1=10000;1|2:1=2500','{10000,10000}'),(3303408,3,0,1000,0,0,0,'15|2:1=10000','{10000,10000}'),(3304105,3,0,1000,0,0,0,'4|2:1=10000;1|2:1=5000','{10000,10000}'),(3304106,3,0,1000,0,0,0,'9|2:1=10000','{10000,10000}'),(3304107,3,0,1000,0,0,0,'13|2:1=10000;1|2:1=5000','{10000,10000}'),(3304108,3,0,1000,0,0,0,'18|2:1=10000','{10000,10000}'),(3304205,3,0,1000,0,0,0,'4|2:1=10000;1|2:1=5000','{10000,10000}'),(3304206,3,0,1000,0,0,0,'9|2:1=10000','{10000,10000}'),(3304207,3,0,1000,0,0,0,'13|2:1=10000;1|2:1=5000','{10000,10000}'),(3304208,3,0,1000,0,0,0,'18|2:1=10000','{10000,10000}'),(3304305,3,0,1000,0,0,0,'4|2:1=10000;1|2:1=5000','{10000,10000}'),(3304306,3,0,1000,0,0,0,'9|2:1=10000','{10000,10000}'),(3304307,3,0,1000,0,0,0,'13|2:1=10000;1|2:1=5000','{10000,10000}'),(3304308,3,0,1000,0,0,0,'18|2:1=10000','{10000,10000}'),(3304405,3,0,1000,0,0,0,'4|2:1=10000;1|2:1=5000','{10000,10000}'),(3304406,3,0,1000,0,0,0,'9|2:1=10000','{10000,10000}'),(3304407,3,0,1000,0,0,0,'13|2:1=10000;1|2:1=5000','{10000,10000}'),(3304408,3,0,1000,0,0,0,'18|2:1=10000','{10000,10000}'),(5800005,1,0,1000,2,0,0,'1|116:1=10000','{10000,10000}'),(5800006,1,0,1000,2,0,0,'1|117:1=10000','{10000,10000}'),(5800007,1,0,1000,2,0,0,'1|118:1=10000','{10000,10000}'),(5800008,1,0,1000,2,0,0,'1|119:1=10000','{10000,10000}'),(5800009,1,0,1000,2,0,0,'1|120:1=10000','{10000,10000}'),(5800010,1,0,1000,2,0,0,'1|121:1=10000','{10000,10000}'),(5800011,1,0,1000,2,0,0,'1|122:1=10000','{10000,10000}'),(5800012,1,0,1000,2,0,0,'1|123:1=10000','{10000,10000}'),(5800013,1,0,1000,2,0,0,'1|124:1=10000','{10000,10000}'),(5800014,1,0,1000,2,0,0,'1|125:1=10000','{10000,10000}'),(5800015,1,0,1000,2,0,0,'1|126:1=10000','{10000,10000}'),(5800016,1,0,1000,2,0,0,'1|127:1=10000','{10000,10000}'),(6200000,1,0,599,0,0,1,'1|137:1=10000;1|137:1=1667;1|3000010:1=5833;1|3000020:1=350;1|3000030:1=292;1|3000040:1=175;1|3000050:1=58;1|3000110:1=0;1|3000120:1=0;1|3000130:1=0;1|3000140:1=0;1|3000150:1=0;1|3000210:1=0;1|3000220:1=0;1|3000230:1=0;1|3000240:1=0;1|3000250:1=0;1|3000310:1=0;1|3000320:1=0;1|3000330:1=0;1|3000340:1=0;1|3000350:1=0;1|3000410:1=0','{10000,10000}'),(6200000,1,600,649,0,0,1,'1|137:1=10000;1|137:1=7500;1|3000010:1=7250;1|3000020:1=524;1|3000030:1=524;1|3000040:1=242;1|3000050:1=81;1|3000110:1=525;1|3000120:1=38;1|3000130:1=53;1|3000140:1=35;1|3000150:1=6;1|3000210:1=127;1|3000220:1=8;1|3000230:1=9;1|3000240:1=5;1|3000250:1=1;1|3000310:1=0;1|3000320:1=0;1|3000330:1=0;1|3000340:1=0;1|3000350:1=0;1|3000410:1=0','{10000,10000}'),(6200000,1,650,699,0,0,1,'2|137:1=10000;1|137:1=3333;1|3000010:1=7778;1|3000020:1=778;1|3000030:1=889;1|3000040:1=333;1|3000050:1=222;1|3000110:1=778;1|3000120:1=68;1|3000130:1=126;1|3000140:1=88;1|3000150:1=19;1|3000210:1=175;1|3000220:1=13;1|3000230:1=16;1|3000240:1=10;1|3000250:1=2;1|3000310:1=0;1|3000320:1=0;1|3000330:1=0;1|3000340:1=0;1|3000350:1=0;1|3000410:1=0','{10000,10000}'),(6200000,1,700,749,0,0,1,'2|137:1=10000;1|137:1=9167;1|3000010:1=6667;1|3000020:1=1000;1|3000030:1=1267;1|3000040:1=400;1|3000050:1=267;1|3000110:1=817;1|3000120:1=88;1|3000130:1=198;1|3000140:1=140;1|3000150:1=23;1|3000210:1=215;1|3000220:1=17;1|3000230:1=24;1|3000240:1=15;1|3000250:1=3;1|3000310:1=0;1|3000320:1=0;1|3000330:1=0;1|3000340:1=0;1|3000350:1=0;1|3000410:1=0','{10000,10000}'),(6200000,1,750,799,0,0,1,'3|137:1=10000;1|137:1=2083;1|3000010:1=0;1|3000020:1=2022;1|3000030:1=2333;1|3000040:1=467;1|3000050:1=467;1|3000110:1=826;1|3000120:1=132;1|3000130:1=314;1|3000140:1=248;1|3000150:1=35;1|3000210:1=249;1|3000220:1=22;1|3000230:1=34;1|3000240:1=22;1|3000250:1=3;1|3000310:1=67;1|3000320:1=1;1|3000330:1=1;1|3000340:1=0;1|3000350:1=0;1|3000410:1=17','{10000,10000}'),(6200000,1,800,849,0,0,1,'3|137:1=10000;1|137:1=5000;1|3000010:1=0;1|3000020:1=0;1|3000030:1=2667;1|3000040:1=1422;1|3000050:1=889;1|3000110:1=0;1|3000120:1=193;1|3000130:1=535;1|3000140:1=385;1|3000150:1=62;1|3000210:1=292;1|3000220:1=29;1|3000230:1=49;1|3000240:1=31;1|3000250:1=4;1|3000310:1=100;1|3000320:1=1;1|3000330:1=1;1|3000340:1=0;1|3000350:1=0;1|3000410:1=25','{10000,10000}'),(6200000,1,850,899,0,0,1,'3|137:1=10000;1|137:1=7917;1|3000010:1=0;1|3000020:1=0;1|3000030:1=0;1|3000040:1=2000;1|3000050:1=1600;1|3000110:1=0;1|3000120:1=0;1|3000130:1=681;1|3000140:1=572;1|3000150:1=109;1|3000210:1=313;1|3000220:1=35;1|3000230:1=63;1|3000240:1=40;1|3000250:1=4;1|3000310:1=133;1|3000320:1=1;1|3000330:1=1;1|3000340:1=0;1|3000350:1=0;1|3000410:1=33','{10000,10000}'),(6200000,1,900,1000,0,0,1,'4|137:1=10000;1|137:1=833;1|3000010:1=0;1|3000020:1=0;1|3000030:1=0;1|3000040:1=0;1|3000050:1=2222;1|3000110:1=0;1|3000120:1=0;1|3000130:1=0;1|3000140:1=875;1|3000150:1=160;1|3000210:1=329;1|3000220:1=41;1|3000230:1=78;1|3000240:1=51;1|3000250:1=5;1|3000310:1=200;1|3000320:1=2;1|3000330:1=2;1|3000340:1=0;1|3000350:1=0;1|3000410:1=42','{10000,10000}'),(6200001,1,0,599,0,0,1,'1|137:1=10000;1|137:1=7500;1|3000010:1=7250;1|3000020:1=524;1|3000030:1=524;1|3000040:1=242;1|3000050:1=81;1|3000110:1=525;1|3000120:1=38;1|3000130:1=53;1|3000140:1=35;1|3000150:1=6;1|3000210:1=127;1|3000220:1=8;1|3000230:1=9;1|3000240:1=5;1|3000250:1=1;1|3000310:1=0;1|3000320:1=0;1|3000330:1=0;1|3000340:1=0;1|3000350:1=0;1|3000410:1=0','{10000,10000}'),(6200001,1,600,649,0,0,1,'1|137:1=10000;1|137:1=3333;1|3000010:1=7778;1|3000020:1=778;1|3000030:1=889;1|3000040:1=333;1|3000050:1=222;1|3000110:1=778;1|3000120:1=68;1|3000130:1=126;1|3000140:1=88;1|3000150:1=19;1|3000210:1=175;1|3000220:1=13;1|3000230:1=16;1|3000240:1=10;1|3000250:1=2;1|3000310:1=0;1|3000320:1=0;1|3000330:1=0;1|3000340:1=0;1|3000350:1=0;1|3000410:1=0','{10000,10000}'),(6200001,1,650,699,0,0,1,'2|137:1=10000;1|137:1=9167;1|3000010:1=6667;1|3000020:1=1000;1|3000030:1=1267;1|3000040:1=400;1|3000050:1=267;1|3000110:1=817;1|3000120:1=88;1|3000130:1=198;1|3000140:1=140;1|3000150:1=23;1|3000210:1=215;1|3000220:1=17;1|3000230:1=24;1|3000240:1=15;1|3000250:1=3;1|3000310:1=0;1|3000320:1=0;1|3000330:1=0;1|3000340:1=0;1|3000350:1=0;1|3000410:1=0','{10000,10000}'),(6200001,1,700,749,0,0,1,'2|137:1=10000;1|137:1=2083;1|3000010:1=0;1|3000020:1=2022;1|3000030:1=2333;1|3000040:1=467;1|3000050:1=467;1|3000110:1=826;1|3000120:1=132;1|3000130:1=314;1|3000140:1=248;1|3000150:1=35;1|3000210:1=249;1|3000220:1=22;1|3000230:1=34;1|3000240:1=22;1|3000250:1=3;1|3000310:1=67;1|3000320:1=1;1|3000330:1=1;1|3000340:1=0;1|3000350:1=0;1|3000410:1=17','{10000,10000}'),(6200001,1,750,799,0,0,1,'3|137:1=10000;1|137:1=5000;1|3000010:1=0;1|3000020:1=0;1|3000030:1=2667;1|3000040:1=1422;1|3000050:1=889;1|3000110:1=0;1|3000120:1=193;1|3000130:1=535;1|3000140:1=385;1|3000150:1=62;1|3000210:1=292;1|3000220:1=29;1|3000230:1=49;1|3000240:1=31;1|3000250:1=4;1|3000310:1=100;1|3000320:1=1;1|3000330:1=1;1|3000340:1=0;1|3000350:1=0;1|3000410:1=25','{10000,10000}'),(6200001,1,800,849,0,0,1,'3|137:1=10000;1|137:1=7917;1|3000010:1=0;1|3000020:1=0;1|3000030:1=0;1|3000040:1=2000;1|3000050:1=1600;1|3000110:1=0;1|3000120:1=0;1|3000130:1=681;1|3000140:1=572;1|3000150:1=109;1|3000210:1=313;1|3000220:1=35;1|3000230:1=63;1|3000240:1=40;1|3000250:1=4;1|3000310:1=133;1|3000320:1=1;1|3000330:1=1;1|3000340:1=0;1|3000350:1=0;1|3000410:1=33','{10000,10000}'),(6200001,1,850,899,0,0,1,'3|137:1=10000;1|137:1=833;1|3000010:1=0;1|3000020:1=0;1|3000030:1=0;1|3000040:1=0;1|3000050:1=2222;1|3000110:1=0;1|3000120:1=0;1|3000130:1=0;1|3000140:1=875;1|3000150:1=160;1|3000210:1=329;1|3000220:1=41;1|3000230:1=78;1|3000240:1=51;1|3000250:1=5;1|3000310:1=200;1|3000320:1=2;1|3000330:1=2;1|3000340:1=0;1|3000350:1=0;1|3000410:1=42','{10000,10000}'),(6200001,1,900,1000,0,0,1,'4|137:1=10000;1|137:1=7500;1|3000010:1=7250;1|3000020:1=524;1|3000030:1=524;1|3000040:1=242;1|3000050:1=81;1|3000110:1=525;1|3000120:1=38;1|3000130:1=53;1|3000140:1=35;1|3000150:1=6;1|3000210:1=127;1|3000220:1=8;1|3000230:1=9;1|3000240:1=5;1|3000250:1=1;1|3000310:1=0;1|3000320:1=0;1|3000330:1=0;1|3000340:1=0;1|3000350:1=0;1|3000410:1=0','{10000,10000}'),(6200002,1,0,599,0,0,1,'1|137:1=10000;1|137:1=3333;1|3000010:1=7778;1|3000020:1=778;1|3000030:1=889;1|3000040:1=333;1|3000050:1=222;1|3000110:1=778;1|3000120:1=68;1|3000130:1=126;1|3000140:1=88;1|3000150:1=19;1|3000210:1=175;1|3000220:1=13;1|3000230:1=16;1|3000240:1=10;1|3000250:1=2;1|3000310:1=0;1|3000320:1=0;1|3000330:1=0;1|3000340:1=0;1|3000350:1=0;1|3000410:1=0','{10000,10000}'),(6200002,1,600,649,0,0,1,'1|137:1=10000;1|137:1=9167;1|3000010:1=6667;1|3000020:1=1000;1|3000030:1=1267;1|3000040:1=400;1|3000050:1=267;1|3000110:1=817;1|3000120:1=88;1|3000130:1=198;1|3000140:1=140;1|3000150:1=23;1|3000210:1=215;1|3000220:1=17;1|3000230:1=24;1|3000240:1=15;1|3000250:1=3;1|3000310:1=0;1|3000320:1=0;1|3000330:1=0;1|3000340:1=0;1|3000350:1=0;1|3000410:1=0','{10000,10000}'),(6200002,1,650,699,0,0,1,'2|137:1=10000;1|137:1=2083;1|3000010:1=0;1|3000020:1=2022;1|3000030:1=2333;1|3000040:1=467;1|3000050:1=467;1|3000110:1=826;1|3000120:1=132;1|3000130:1=314;1|3000140:1=248;1|3000150:1=35;1|3000210:1=249;1|3000220:1=22;1|3000230:1=34;1|3000240:1=22;1|3000250:1=3;1|3000310:1=67;1|3000320:1=1;1|3000330:1=1;1|3000340:1=0;1|3000350:1=0;1|3000410:1=17','{10000,10000}'),(6200002,1,700,749,0,0,1,'2|137:1=10000;1|137:1=5000;1|3000010:1=0;1|3000020:1=0;1|3000030:1=2667;1|3000040:1=1422;1|3000050:1=889;1|3000110:1=0;1|3000120:1=193;1|3000130:1=535;1|3000140:1=385;1|3000150:1=62;1|3000210:1=292;1|3000220:1=29;1|3000230:1=49;1|3000240:1=31;1|3000250:1=4;1|3000310:1=100;1|3000320:1=1;1|3000330:1=1;1|3000340:1=0;1|3000350:1=0;1|3000410:1=25','{10000,10000}'),(6200002,1,750,799,0,0,1,'3|137:1=10000;1|137:1=7917;1|3000010:1=0;1|3000020:1=0;1|3000030:1=0;1|3000040:1=2000;1|3000050:1=1600;1|3000110:1=0;1|3000120:1=0;1|3000130:1=681;1|3000140:1=572;1|3000150:1=109;1|3000210:1=313;1|3000220:1=35;1|3000230:1=63;1|3000240:1=40;1|3000250:1=4;1|3000310:1=133;1|3000320:1=1;1|3000330:1=1;1|3000340:1=0;1|3000350:1=0;1|3000410:1=33','{10000,10000}'),(6200002,1,800,849,0,0,1,'3|137:1=10000;1|137:1=833;1|3000010:1=0;1|3000020:1=0;1|3000030:1=0;1|3000040:1=0;1|3000050:1=2222;1|3000110:1=0;1|3000120:1=0;1|3000130:1=0;1|3000140:1=875;1|3000150:1=160;1|3000210:1=329;1|3000220:1=41;1|3000230:1=78;1|3000240:1=51;1|3000250:1=5;1|3000310:1=200;1|3000320:1=2;1|3000330:1=2;1|3000340:1=0;1|3000350:1=0;1|3000410:1=42','{10000,10000}'),(6200002,1,850,899,0,0,1,'3|137:1=10000;1|137:1=7500;1|3000010:1=7250;1|3000020:1=524;1|3000030:1=524;1|3000040:1=242;1|3000050:1=81;1|3000110:1=525;1|3000120:1=38;1|3000130:1=53;1|3000140:1=35;1|3000150:1=6;1|3000210:1=127;1|3000220:1=8;1|3000230:1=9;1|3000240:1=5;1|3000250:1=1;1|3000310:1=0;1|3000320:1=0;1|3000330:1=0;1|3000340:1=0;1|3000350:1=0;1|3000410:1=0','{10000,10000}'),(6200002,1,900,1000,0,0,1,'4|137:1=10000;1|137:1=3333;1|3000010:1=7778;1|3000020:1=778;1|3000030:1=889;1|3000040:1=333;1|3000050:1=222;1|3000110:1=778;1|3000120:1=68;1|3000130:1=126;1|3000140:1=88;1|3000150:1=19;1|3000210:1=175;1|3000220:1=13;1|3000230:1=16;1|3000240:1=10;1|3000250:1=2;1|3000310:1=0;1|3000320:1=0;1|3000330:1=0;1|3000340:1=0;1|3000350:1=0;1|3000410:1=0','{10000,10000}'),(6200003,1,0,599,0,0,1,'1|137:1=10000;1|137:1=9167;1|3000010:1=6667;1|3000020:1=1000;1|3000030:1=1267;1|3000040:1=400;1|3000050:1=267;1|3000110:1=817;1|3000120:1=88;1|3000130:1=198;1|3000140:1=140;1|3000150:1=23;1|3000210:1=215;1|3000220:1=17;1|3000230:1=24;1|3000240:1=15;1|3000250:1=3;1|3000310:1=0;1|3000320:1=0;1|3000330:1=0;1|3000340:1=0;1|3000350:1=0;1|3000410:1=0','{10000,10000}'),(6200003,1,600,649,0,0,1,'1|137:1=10000;1|137:1=2083;1|3000010:1=0;1|3000020:1=2022;1|3000030:1=2333;1|3000040:1=467;1|3000050:1=467;1|3000110:1=826;1|3000120:1=132;1|3000130:1=314;1|3000140:1=248;1|3000150:1=35;1|3000210:1=249;1|3000220:1=22;1|3000230:1=34;1|3000240:1=22;1|3000250:1=3;1|3000310:1=67;1|3000320:1=1;1|3000330:1=1;1|3000340:1=0;1|3000350:1=0;1|3000410:1=17','{10000,10000}'),(6200003,1,650,699,0,0,1,'2|137:1=10000;1|137:1=5000;1|3000010:1=0;1|3000020:1=0;1|3000030:1=2667;1|3000040:1=1422;1|3000050:1=889;1|3000110:1=0;1|3000120:1=193;1|3000130:1=535;1|3000140:1=385;1|3000150:1=62;1|3000210:1=292;1|3000220:1=29;1|3000230:1=49;1|3000240:1=31;1|3000250:1=4;1|3000310:1=100;1|3000320:1=1;1|3000330:1=1;1|3000340:1=0;1|3000350:1=0;1|3000410:1=25','{10000,10000}'),(6200003,1,700,749,0,0,1,'2|137:1=10000;1|137:1=7917;1|3000010:1=0;1|3000020:1=0;1|3000030:1=0;1|3000040:1=2000;1|3000050:1=1600;1|3000110:1=0;1|3000120:1=0;1|3000130:1=681;1|3000140:1=572;1|3000150:1=109;1|3000210:1=313;1|3000220:1=35;1|3000230:1=63;1|3000240:1=40;1|3000250:1=4;1|3000310:1=133;1|3000320:1=1;1|3000330:1=1;1|3000340:1=0;1|3000350:1=0;1|3000410:1=33','{10000,10000}'),(6200003,1,750,799,0,0,1,'3|137:1=10000;1|137:1=833;1|3000010:1=0;1|3000020:1=0;1|3000030:1=0;1|3000040:1=0;1|3000050:1=2222;1|3000110:1=0;1|3000120:1=0;1|3000130:1=0;1|3000140:1=875;1|3000150:1=160;1|3000210:1=329;1|3000220:1=41;1|3000230:1=78;1|3000240:1=51;1|3000250:1=5;1|3000310:1=200;1|3000320:1=2;1|3000330:1=2;1|3000340:1=0;1|3000350:1=0;1|3000410:1=42','{10000,10000}'),(6200003,1,800,849,0,0,1,'3|137:1=10000;1|137:1=7500;1|3000010:1=7250;1|3000020:1=524;1|3000030:1=524;1|3000040:1=242;1|3000050:1=81;1|3000110:1=525;1|3000120:1=38;1|3000130:1=53;1|3000140:1=35;1|3000150:1=6;1|3000210:1=127;1|3000220:1=8;1|3000230:1=9;1|3000240:1=5;1|3000250:1=1;1|3000310:1=0;1|3000320:1=0;1|3000330:1=0;1|3000340:1=0;1|3000350:1=0;1|3000410:1=0','{10000,10000}'),(6200003,1,850,899,0,0,1,'3|137:1=10000;1|137:1=3333;1|3000010:1=7778;1|3000020:1=778;1|3000030:1=889;1|3000040:1=333;1|3000050:1=222;1|3000110:1=778;1|3000120:1=68;1|3000130:1=126;1|3000140:1=88;1|3000150:1=19;1|3000210:1=175;1|3000220:1=13;1|3000230:1=16;1|3000240:1=10;1|3000250:1=2;1|3000310:1=0;1|3000320:1=0;1|3000330:1=0;1|3000340:1=0;1|3000350:1=0;1|3000410:1=0','{10000,10000}'),(6200003,1,900,1000,0,0,1,'4|137:1=10000;1|137:1=9167;1|3000010:1=6667;1|3000020:1=1000;1|3000030:1=1267;1|3000040:1=400;1|3000050:1=267;1|3000110:1=817;1|3000120:1=88;1|3000130:1=198;1|3000140:1=140;1|3000150:1=23;1|3000210:1=215;1|3000220:1=17;1|3000230:1=24;1|3000240:1=15;1|3000250:1=3;1|3000310:1=0;1|3000320:1=0;1|3000330:1=0;1|3000340:1=0;1|3000350:1=0;1|3000410:1=0','{10000,10000}'),(6200004,1,0,599,0,0,1,'1|137:1=10000;1|137:1=2083;1|3000010:1=0;1|3000020:1=2022;1|3000030:1=2333;1|3000040:1=467;1|3000050:1=467;1|3000110:1=826;1|3000120:1=132;1|3000130:1=314;1|3000140:1=248;1|3000150:1=35;1|3000210:1=249;1|3000220:1=22;1|3000230:1=34;1|3000240:1=22;1|3000250:1=3;1|3000310:1=67;1|3000320:1=1;1|3000330:1=1;1|3000340:1=0;1|3000350:1=0;1|3000410:1=17','{10000,10000}'),(6200004,1,600,649,0,0,1,'1|137:1=10000;1|137:1=5000;1|3000010:1=0;1|3000020:1=0;1|3000030:1=2667;1|3000040:1=1422;1|3000050:1=889;1|3000110:1=0;1|3000120:1=193;1|3000130:1=535;1|3000140:1=385;1|3000150:1=62;1|3000210:1=292;1|3000220:1=29;1|3000230:1=49;1|3000240:1=31;1|3000250:1=4;1|3000310:1=100;1|3000320:1=1;1|3000330:1=1;1|3000340:1=0;1|3000350:1=0;1|3000410:1=25','{10000,10000}'),(6200004,1,650,699,0,0,1,'2|137:1=10000;1|137:1=7917;1|3000010:1=0;1|3000020:1=0;1|3000030:1=0;1|3000040:1=2000;1|3000050:1=1600;1|3000110:1=0;1|3000120:1=0;1|3000130:1=681;1|3000140:1=572;1|3000150:1=109;1|3000210:1=313;1|3000220:1=35;1|3000230:1=63;1|3000240:1=40;1|3000250:1=4;1|3000310:1=133;1|3000320:1=1;1|3000330:1=1;1|3000340:1=0;1|3000350:1=0;1|3000410:1=33','{10000,10000}'),(6200004,1,700,749,0,0,1,'2|137:1=10000;1|137:1=833;1|3000010:1=0;1|3000020:1=0;1|3000030:1=0;1|3000040:1=0;1|3000050:1=2222;1|3000110:1=0;1|3000120:1=0;1|3000130:1=0;1|3000140:1=875;1|3000150:1=160;1|3000210:1=329;1|3000220:1=41;1|3000230:1=78;1|3000240:1=51;1|3000250:1=5;1|3000310:1=200;1|3000320:1=2;1|3000330:1=2;1|3000340:1=0;1|3000350:1=0;1|3000410:1=42','{10000,10000}'),(6200004,1,750,799,0,0,1,'3|137:1=10000;1|137:1=7500;1|3000010:1=7250;1|3000020:1=524;1|3000030:1=524;1|3000040:1=242;1|3000050:1=81;1|3000110:1=525;1|3000120:1=38;1|3000130:1=53;1|3000140:1=35;1|3000150:1=6;1|3000210:1=127;1|3000220:1=8;1|3000230:1=9;1|3000240:1=5;1|3000250:1=1;1|3000310:1=0;1|3000320:1=0;1|3000330:1=0;1|3000340:1=0;1|3000350:1=0;1|3000410:1=0','{10000,10000}'),(6200004,1,800,849,0,0,1,'3|137:1=10000;1|137:1=3333;1|3000010:1=7778;1|3000020:1=778;1|3000030:1=889;1|3000040:1=333;1|3000050:1=222;1|3000110:1=778;1|3000120:1=68;1|3000130:1=126;1|3000140:1=88;1|3000150:1=19;1|3000210:1=175;1|3000220:1=13;1|3000230:1=16;1|3000240:1=10;1|3000250:1=2;1|3000310:1=0;1|3000320:1=0;1|3000330:1=0;1|3000340:1=0;1|3000350:1=0;1|3000410:1=0','{10000,10000}'),(6200004,1,850,899,0,0,1,'3|137:1=10000;1|137:1=9167;1|3000010:1=6667;1|3000020:1=1000;1|3000030:1=1267;1|3000040:1=400;1|3000050:1=267;1|3000110:1=817;1|3000120:1=88;1|3000130:1=198;1|3000140:1=140;1|3000150:1=23;1|3000210:1=215;1|3000220:1=17;1|3000230:1=24;1|3000240:1=15;1|3000250:1=3;1|3000310:1=0;1|3000320:1=0;1|3000330:1=0;1|3000340:1=0;1|3000350:1=0;1|3000410:1=0','{10000,10000}'),(6200004,1,900,1000,0,0,1,'4|137:1=10000;1|137:1=2083;1|3000010:1=0;1|3000020:1=2022;1|3000030:1=2333;1|3000040:1=467;1|3000050:1=467;1|3000110:1=826;1|3000120:1=132;1|3000130:1=314;1|3000140:1=248;1|3000150:1=35;1|3000210:1=249;1|3000220:1=22;1|3000230:1=34;1|3000240:1=22;1|3000250:1=3;1|3000310:1=67;1|3000320:1=1;1|3000330:1=1;1|3000340:1=0;1|3000350:1=0;1|3000410:1=17','{10000,10000}'),(6200005,1,0,599,0,0,1,'1|137:1=10000;1|137:1=5000;1|3000010:1=0;1|3000020:1=0;1|3000030:1=2667;1|3000040:1=1422;1|3000050:1=889;1|3000110:1=0;1|3000120:1=193;1|3000130:1=535;1|3000140:1=385;1|3000150:1=62;1|3000210:1=292;1|3000220:1=29;1|3000230:1=49;1|3000240:1=31;1|3000250:1=4;1|3000310:1=100;1|3000320:1=1;1|3000330:1=1;1|3000340:1=0;1|3000350:1=0;1|3000410:1=25','{10000,10000}'),(6200005,1,600,649,0,0,1,'1|137:1=10000;1|137:1=7917;1|3000010:1=0;1|3000020:1=0;1|3000030:1=0;1|3000040:1=2000;1|3000050:1=1600;1|3000110:1=0;1|3000120:1=0;1|3000130:1=681;1|3000140:1=572;1|3000150:1=109;1|3000210:1=313;1|3000220:1=35;1|3000230:1=63;1|3000240:1=40;1|3000250:1=4;1|3000310:1=133;1|3000320:1=1;1|3000330:1=1;1|3000340:1=0;1|3000350:1=0;1|3000410:1=33','{10000,10000}'),(6200005,1,650,699,0,0,1,'2|137:1=10000;1|137:1=833;1|3000010:1=0;1|3000020:1=0;1|3000030:1=0;1|3000040:1=0;1|3000050:1=2222;1|3000110:1=0;1|3000120:1=0;1|3000130:1=0;1|3000140:1=875;1|3000150:1=160;1|3000210:1=329;1|3000220:1=41;1|3000230:1=78;1|3000240:1=51;1|3000250:1=5;1|3000310:1=200;1|3000320:1=2;1|3000330:1=2;1|3000340:1=0;1|3000350:1=0;1|3000410:1=42','{10000,10000}'),(6200005,1,700,749,0,0,1,'2|137:1=10000;1|137:1=7500;1|3000010:1=7250;1|3000020:1=524;1|3000030:1=524;1|3000040:1=242;1|3000050:1=81;1|3000110:1=525;1|3000120:1=38;1|3000130:1=53;1|3000140:1=35;1|3000150:1=6;1|3000210:1=127;1|3000220:1=8;1|3000230:1=9;1|3000240:1=5;1|3000250:1=1;1|3000310:1=0;1|3000320:1=0;1|3000330:1=0;1|3000340:1=0;1|3000350:1=0;1|3000410:1=0','{10000,10000}'),(6200005,1,750,799,0,0,1,'3|137:1=10000;1|137:1=3333;1|3000010:1=7778;1|3000020:1=778;1|3000030:1=889;1|3000040:1=333;1|3000050:1=222;1|3000110:1=778;1|3000120:1=68;1|3000130:1=126;1|3000140:1=88;1|3000150:1=19;1|3000210:1=175;1|3000220:1=13;1|3000230:1=16;1|3000240:1=10;1|3000250:1=2;1|3000310:1=0;1|3000320:1=0;1|3000330:1=0;1|3000340:1=0;1|3000350:1=0;1|3000410:1=0','{10000,10000}'),(6200005,1,800,849,0,0,1,'3|137:1=10000;1|137:1=9167;1|3000010:1=6667;1|3000020:1=1000;1|3000030:1=1267;1|3000040:1=400;1|3000050:1=267;1|3000110:1=817;1|3000120:1=88;1|3000130:1=198;1|3000140:1=140;1|3000150:1=23;1|3000210:1=215;1|3000220:1=17;1|3000230:1=24;1|3000240:1=15;1|3000250:1=3;1|3000310:1=0;1|3000320:1=0;1|3000330:1=0;1|3000340:1=0;1|3000350:1=0;1|3000410:1=0','{10000,10000}'),(6200005,1,850,899,0,0,1,'3|137:1=10000;1|137:1=2083;1|3000010:1=0;1|3000020:1=2022;1|3000030:1=2333;1|3000040:1=467;1|3000050:1=467;1|3000110:1=826;1|3000120:1=132;1|3000130:1=314;1|3000140:1=248;1|3000150:1=35;1|3000210:1=249;1|3000220:1=22;1|3000230:1=34;1|3000240:1=22;1|3000250:1=3;1|3000310:1=67;1|3000320:1=1;1|3000330:1=1;1|3000340:1=0;1|3000350:1=0;1|3000410:1=17','{10000,10000}'),(6200005,1,900,1000,0,0,1,'4|137:1=10000;1|137:1=5000;1|3000010:1=0;1|3000020:1=0;1|3000030:1=2667;1|3000040:1=1422;1|3000050:1=889;1|3000110:1=0;1|3000120:1=193;1|3000130:1=535;1|3000140:1=385;1|3000150:1=62;1|3000210:1=292;1|3000220:1=29;1|3000230:1=49;1|3000240:1=31;1|3000250:1=4;1|3000310:1=100;1|3000320:1=1;1|3000330:1=1;1|3000340:1=0;1|3000350:1=0;1|3000410:1=25','{10000,10000}'),(6200020,1,0,599,0,0,1,'2|137:1=10000;1|137:1=3333;1|3000010:2=10000;1|3000010:2=7500;1|3000020:1=1750;1|3000030:1=1750;1|3000040:1=1050;1|3000050:1=350;1|3000110:1=0;1|3000120:1=0;1|3000130:1=0;1|3000140:1=0;1|3000150:1=0;1|3000210:1=0;1|3000220:1=0;1|3000230:1=0;1|3000240:1=0;1|3000250:1=0;1|3000310:1=0;1|3000320:1=0;1|3000330:1=0;1|3000340:1=0;1|3000350:1=0;1|3000410:1=0','{10000,10000}'),(6200020,1,600,649,0,0,1,'3|137:1=10000;1|137:1=5000;1|3000010:2=10000;1|3000010:4=6000;1|3000020:1=3142;1|3000030:1=3142;1|3000040:1=1450;1|3000050:1=483;1|3000110:1=3150;1|3000120:1=228;1|3000130:1=315;1|3000140:1=210;1|3000150:1=35;1|3000210:1=760;1|3000220:1=50;1|3000230:1=52;1|3000240:1=32;1|3000250:1=8;1|3000310:1=0;1|3000320:1=0;1|3000330:1=0;1|3000340:1=0;1|3000350:1=0;1|3000410:1=0','{10000,10000}'),(6200020,1,650,699,0,0,1,'4|137:1=10000;1|137:1=6667;1|3000010:3=10000;1|3000010:5=5000;1|3000020:1=5333;1|3000030:1=5333;1|3000040:1=2000;1|3000050:1=1333;1|3000110:1=4667;1|3000120:1=408;1|3000130:1=758;1|3000140:1=525;1|3000150:1=117;1|3000210:1=1050;1|3000220:1=77;1|3000230:1=93;1|3000240:1=58;1|3000250:1=12;1|3000310:1=0;1|3000320:1=0;1|3000330:1=0;1|3000340:1=0;1|3000350:1=0;1|3000410:1=0','{10000,10000}'),(6200020,1,700,749,0,0,1,'5|137:1=10000;1|137:1=8334;1|3000010:3=10000;1|3000010:2=5000;1|3000020:1=7600;1|3000030:1=7600;1|3000040:1=2400;1|3000050:1=1600;1|3000110:1=4900;1|3000120:1=525;1|3000130:1=1190;1|3000140:1=840;1|3000150:1=140;1|3000210:1=1289;1|3000220:1=105;1|3000230:1=144;1|3000240:1=91;1|3000250:1=15;1|3000310:1=0;1|3000320:1=0;1|3000330:1=0;1|3000340:1=0;1|3000350:1=0;1|3000410:1=0','{10000,10000}'),(6200020,1,750,799,0,0,1,'6|137:1=10000;1|137:1=4611;1|3000020:1=10000;1|3000010:1=0;1|3000020:1=4000;1|3000030:2=7000;1|3000040:1=2800;1|3000050:1=2800;1|3000110:1=4958;1|3000120:1=793;1|3000130:1=1884;1|3000140:1=1488;1|3000150:1=208;1|3000210:1=1493;1|3000220:1=131;1|3000230:1=205;1|3000240:1=131;1|3000250:1=19;1|3000310:1=400;1|3000320:1=4;1|3000330:1=4;1|3000340:1=0;1|3000350:1=0;1|3000410:1=100','{10000,10000}'),(6200020,1,800,849,0,0,1,'7|137:1=10000;1|137:1=20;1|3000030:1=10000;1|3000010:1=0;1|3000020:2=6000;1|3000030:1=6000;1|3000040:1=8583;1|3000050:1=5333;1|3000110:1=0;1|3000120:1=1155;1|3000130:1=3208;1|3000140:1=2310;1|3000150:1=372;1|3000210:1=1750;1|3000220:1=175;1|3000230:1=292;1|3000240:1=187;1|3000250:1=23;1|3000310:1=600;1|3000320:1=6;1|3000330:1=6;1|3000340:1=0;1|3000350:1=0;1|3000410:1=150','{10000,10000}'),(6200020,1,850,899,0,0,1,'7|137:1=10000;1|137:1=5833;1|3000040:1=10000;1|3000010:1=0;1|3000020:1=0;1|3000030:1=0;1|3000040:1=2000;1|3000050:1=9600;1|3000110:1=0;1|3000120:1=0;1|3000130:1=4083;1|3000140:1=3430;1|3000150:1=653;1|3000210:1=1878;1|3000220:1=209;1|3000230:1=376;1|3000240:1=242;1|3000250:1=27;1|3000310:1=800;1|3000320:1=8;1|3000330:1=8;1|3000340:1=0;1|3000350:1=0;1|3000410:1=200','{10000,10000}'),(6200020,1,900,1000,0,0,1,'8|137:1=10000;1|137:1=1667;1|3000050:1=10000;1|3000010:1=0;1|3000020:1=0;1|3000030:1=0;1|3000040:1=0;1|3000050:1=3333;1|3000110:1=0;1|3000120:1=0;1|3000130:1=0;1|3000140:1=5250;1|3000150:1=963;1|3000210:1=1972;1|3000220:1=246;1|3000230:1=470;1|3000240:1=303;1|3000250:1=30;1|3000310:1=1200;1|3000320:1=12;1|3000330:1=12;1|3000340:1=0;1|3000350:1=0;1|3000410:1=250','{10000,10000}'),(6301001,1,0,1000,0,0,1,'3|4000001:1=10000;1|4000003:1=2000;1|29:1=10000;1|47:3=10000;1|179:1=2500;1|180:1=300;1|181:1=300;1|182:1=50;1|1080200:1=10000;2|1080200:1=3333','{10000,10000}'),(6301002,1,0,1000,0,0,1,'3|4000001:1=10000;1|4000003:1=2000;1|29:1=10000;1|47:3=10000;1|179:1=2500;1|180:1=300;1|181:1=300;1|182:1=50;1|1080200:1=10000;2|1080200:1=3333','{10000,10000}'),(6301003,1,0,1000,0,0,1,'3|4000001:1=10000;1|4000003:1=2000;1|29:1=10000;1|47:3=10000;1|179:1=2500;1|180:1=300;1|181:1=300;1|182:1=50;1|1090200:1=10000;2|1090200:1=3333','{10000,10000}'),(6301004,1,0,1000,0,0,1,'3|4000002:1=10000;1|4000004:1=2000;1|29:1=10000;1|47:5=10000;1|179:1=2500;1|180:1=300;1|181:1=300;1|182:1=50;1|1090200:1=10000;2|1090200:1=3333','{10000,10000}'),(6301005,1,0,1000,0,0,1,'3|4000002:1=10000;1|4000005:1=2000;1|29:1=10000;1|47:7=10000;1|179:1=2500;1|180:1=300;1|181:1=300;1|182:1=50;1|1090200:1=10000;2|1090200:1=3333','{10000,10000}'),(6301006,1,0,1000,0,0,1,'3|4000002:1=10000;1|4000006:1=2000;1|29:1=10000;1|48:4=10000;1|179:1=2500;1|180:1=300;1|181:1=300;1|182:1=50;1|1100200:1=10000;2|1100200:1=3333','{10000,10000}'),(6301101,1,0,1000,2,0,0,'1|129:1=10000','{10000,10000}'),(6301102,1,0,1000,2,0,0,'1|130:1=10000','{10000,10000}'),(6302001,1,0,1000,0,0,1,'3|4000002:1=10000;1|4000005:1=3000;1|4000019:1=1000;1|29:1=10000;1|48:4=10000;1|179:1=2500;1|180:1=300;1|181:1=300;1|182:1=50;1|1100200:1=10000;2|1100200:1=3333','{10000,10000}'),(6302002,1,0,1000,0,0,1,'3|4000002:1=10000;1|4000007:1=3000;1|4000019:1=1000;1|29:1=10000;1|48:5=10000;1|179:1=2500;1|180:1=300;1|181:1=300;1|182:1=50;1|1100200:1=10000;2|1100200:1=3333','{10000,10000}'),(6302003,1,0,1000,0,0,1,'3|4000002:1=10000;1|4000008:1=3000;1|4000020:1=1000;1|29:1=10000;1|48:6=10000;1|179:1=2500;1|180:1=300;1|181:1=300;1|182:1=50;1|1100200:1=10000;2|1100200:1=3333','{10000,10000}'),(6302004,1,0,1000,0,0,1,'3|4000002:1=10000;1|4000009:1=3000;1|4000021:1=1000;1|29:1=10000;1|48:7=10000;1|179:1=2500;1|180:1=300;1|181:1=300;1|182:1=50;1|1100200:1=10000;2|1100200:1=3333','{10000,10000}'),(6302005,1,0,1000,0,0,1,'3|4000002:1=10000;1|4000010:1=3000;1|4000022:1=1000;1|29:1=10000;1|49:4=10000;1|179:1=2500;1|180:1=300;1|181:1=300;1|182:1=50;1|1110200:1=10000;2|1110200:1=3333','{10000,10000}'),(6302006,1,0,1000,0,0,1,'3|4000002:1=10000;1|4000011:1=3000;1|4000023:1=1000;1|29:1=10000;1|48:5=10000;1|179:1=2500;1|180:1=300;1|181:1=300;1|182:1=50;1|1120200:1=10000;2|1120200:1=3333','{10000,10000}'),(6302101,1,0,1000,2,0,0,'1|131:1=10000','{10000,10000}'),(6302102,1,0,1000,2,0,0,'1|132:1=10000','{10000,10000}'),(6303001,1,0,1000,0,0,1,'3|4000002:1=10000;1|4000012:1=6000;1|4000024:1=1500;1|4000035:1=300;1|29:1=10000;1|48:6=10000;1|179:1=2500;1|180:1=300;1|181:1=300;1|182:1=50;1|1120200:1=10000;2|1120200:1=3333','{10000,10000}'),(6303002,1,0,1000,0,0,1,'3|4000002:1=10000;1|4000013:1=6000;1|4000025:1=1500;1|4000036:1=300;1|29:1=10000;1|48:7=10000;1|179:1=2500;1|180:1=300;1|181:1=300;1|182:1=50;1|1120200:1=10000;2|1120200:1=3333','{10000,10000}'),(6303003,1,0,1000,0,0,1,'3|4000002:1=10000;1|4000014:1=6000;1|4000026:1=1500;1|4000037:1=300;1|29:1=10000;1|48:8=10000;1|179:1=2500;1|180:1=300;1|181:1=300;1|182:1=50;1|1120200:1=10000;2|1120200:1=3333','{10000,10000}'),(6303004,1,0,1000,0,0,1,'3|4000002:1=10000;1|4000015:1=6000;1|4000027:1=1500;1|4000038:1=300;1|29:1=10000;1|48:9=10000;1|179:1=2500;1|180:1=300;1|181:1=300;1|182:1=50;1|1120200:1=10000;2|1120200:1=3333','{10000,10000}'),(6303005,1,0,1000,0,0,1,'3|4000002:1=10000;1|4000016:1=6000;1|4000028:1=1500;1|4000039:1=300;1|29:1=10000;1|48:9=10000;1|179:1=2500;1|180:1=300;1|181:1=300;1|182:1=50;1|1130200:1=10000;2|1130200:1=3333','{10000,10000}'),(6303006,1,0,1000,0,0,1,'3|4000002:1=10000;1|4000016:1=6000;1|4000029:1=1500;1|4000040:1=300;1|29:1=10000;1|50:4=10000;1|179:1=2500;1|180:1=300;1|181:1=300;1|182:1=50;1|1140200:1=10000;2|1140200:1=3333','{10000,10000}'),(6303101,1,0,1000,2,0,0,'1|133:1=10000','{10000,10000}'),(6303102,1,0,1000,2,0,0,'1|134:1=10000','{10000,10000}'),(6304001,1,0,1000,0,0,1,'3|4000002:1=10000;1|4000017:1=10000;1|4000030:1=2000;1|4000041:1=500;1|183:1=100;1|29:1=10000;1|50:4=10000;1|179:1=2500;1|180:1=300;1|181:1=300;1|182:1=50;1|1140200:1=10000;2|1140200:1=3333','{10000,10000}'),(6304002,1,0,1000,0,0,1,'3|4000002:1=10000;1|4000018:1=10000;1|4000031:1=2000;1|4000042:1=500;1|183:1=100;1|29:1=10000;1|50:4=10000;1|179:1=2500;1|180:1=300;1|181:1=300;1|182:1=50;1|1140200:1=10000;2|1140200:1=3333','{10000,10000}'),(6304003,1,0,1000,0,0,1,'3|4000002:1=10000;1|4000017:1=10000;1|4000032:1=2000;1|4000043:1=500;1|183:1=100;1|29:1=10000;1|50:5=10000;1|179:1=2500;1|180:1=300;1|181:1=300;1|182:1=50;1|1150200:1=10000;2|1150200:1=3333','{10000,10000}'),(6304004,1,0,1000,0,0,1,'3|4000002:1=10000;1|4000018:1=10000;1|4000033:1=2000;1|4000044:1=500;1|183:1=100;1|29:1=10000;1|50:5=10000;1|179:1=2500;1|180:1=300;1|181:1=300;1|182:1=50;1|1150200:1=10000;2|1150200:1=3333','{10000,10000}'),(6304005,1,0,1000,0,0,1,'3|4000002:1=10000;1|4000017:1=10000;1|4000034:1=2000;1|4000045:1=500;1|183:1=100;1|29:1=10000;1|50:5=10000;1|179:1=2500;1|180:1=300;1|181:1=300;1|182:1=50;1|1150200:1=10000;2|1150200:1=3333','{10000,10000}'),(6304006,1,0,1000,0,0,1,'3|4000002:1=10000;1|4000018:1=10000;1|4000034:1=2000;1|4000046:1=500;1|183:1=100;1|29:1=10000;1|50:6=10000;1|179:1=2500;1|180:1=300;1|181:1=300;1|182:1=50;1|1150200:1=10000;2|1150200:1=3333','{10000,10000}'),(6304101,1,0,1000,2,0,0,'1|135:1=10000','{10000,10000}'),(6304102,1,0,1000,2,0,0,'1|136:1=10000','{10000,10000}'),(10000001,1,0,1000,2,0,0,'1|28:1=10','{10000,10000}'),(10000002,1,0,1000,2,0,0,'1|28:1=10','{10000,10000}'),(10000003,1,0,1000,2,0,0,'1|28:1=10','{10000,10000}'),(10000004,1,0,1000,2,0,0,'1|28:1=10','{10000,10000}'),(10000005,1,0,1000,2,0,0,'1|28:1=10','{10000,10000}'),(10000006,1,0,1000,2,0,0,'1|28:1=10','{10000,10000}'),(10000007,1,0,1000,2,0,0,'1|28:1=10','{10000,10000}'),(10020001,1,0,1000,2,0,0,'1|31:1=19;1|28:1=10','{10000,10000}'),(10020003,1,0,1000,2,0,0,'1|31:1=19;1|28:1=10','{10000,10000}'),(10020004,1,0,1000,2,0,0,'1|31:1=19;1|28:1=10','{10000,10000}'),(10020005,1,0,1000,2,0,0,'1|31:1=19;1|28:1=10','{10000,10000}'),(10020006,1,0,1000,2,0,0,'1|31:1=19;1|28:1=10','{10000,10000}'),(10020007,1,0,1000,2,0,0,'1|31:1=19;1|28:1=10','{10000,10000}'),(10030001,1,0,1000,2,0,0,'1|31:1=19;1|28:1=10','{10000,10000}'),(10030002,1,0,1000,2,0,0,'1|31:1=19;1|28:1=10','{10000,10000}'),(10030004,1,0,1000,2,0,0,'1|31:1=19;1|28:1=10','{10000,10000}'),(10030005,1,0,1000,2,0,0,'1|31:1=19;1|28:1=10','{10000,10000}'),(10030006,1,0,1000,2,0,0,'1|31:1=19;1|28:1=10','{10000,10000}'),(10030007,1,0,1000,2,0,0,'1|31:1=19;1|28:1=10','{10000,10000}'),(10050001,1,0,1000,2,0,0,'1|31:1=19;1|28:1=10','{10000,10000}'),(10050002,1,0,1000,2,0,0,'1|32:1=29;1|28:1=10','{10000,10000}'),(10050003,1,0,1000,2,0,0,'1|32:1=29;1|28:1=10','{10000,10000}'),(10050004,1,0,1000,2,0,0,'1|28:1=10','{10000,10000}'),(10050005,1,0,1000,2,0,0,'1|32:1=29;1|28:1=10;1|38:1=700','{10000,10000}'),(10050006,1,0,1000,2,0,0,'1|32:1=29;1|28:1=10;1|38:1=700','{10000,10000}'),(10060001,1,0,1000,2,0,0,'1|32:1=29;1|28:1=10;1|38:1=700;1|85:1=588','{10000,10000}'),(10060002,1,0,1000,2,0,0,'1|32:1=29;1|28:1=10;1|38:1=700;1|85:1=588','{10000,10000}'),(10060003,1,0,1000,2,0,0,'1|33:1=33;1|28:1=10;1|38:1=700;1|85:1=588','{10000,10000}'),(10060004,1,0,1000,2,0,0,'1|34:1=34;1|28:1=10;1|38:1=700;1|85:1=588','{10000,10000}'),(10060005,1,0,1000,2,0,0,'1|34:1=34;1|28:1=10;1|38:1=700;1|85:1=588','{10000,10000}'),(10060006,1,0,1000,2,0,0,'1|34:1=34;1|28:1=10;1|38:1=700;1|85:1=588','{10000,10000}'),(10060007,1,0,1000,2,0,0,'1|34:1=34;1|28:1=10;1|38:1=700;1|85:1=588','{10000,10000}'),(10060008,1,0,1000,2,0,0,'1|35:1=34;1|28:1=10;1|38:1=700;1|85:1=588','{10000,10000}'),(10070001,1,0,1000,2,0,0,'1|35:1=34;1|28:1=10;1|38:1=700;1|85:1=588','{10000,10000}'),(10070002,1,0,1000,2,0,0,'1|35:1=34;1|28:1=10;1|38:1=700;1|85:1=588','{10000,10000}'),(10070003,1,0,1000,2,0,0,'1|35:1=34;1|28:1=10;1|38:1=700;1|85:1=588','{10000,10000}'),(10070004,1,0,1000,2,0,0,'1|35:1=34;1|28:1=10;1|86:1=208','{10000,10000}'),(10070005,1,0,1000,2,0,0,'1|35:1=34;1|28:1=10;1|38:1=700;1|86:1=208','{10000,10000}'),(10070006,1,0,1000,2,0,0,'1|35:1=34;1|28:1=10;1|38:1=700;1|86:1=208','{10000,10000}'),(10070007,1,0,1000,2,0,0,'1|35:1=34;1|28:1=10;1|38:1=700;1|86:1=208','{10000,10000}'),(10080001,1,0,1000,2,0,0,'1|35:1=34;1|28:1=10;1|86:1=208','{10000,10000}'),(10080002,1,0,1000,2,0,0,'1|35:1=34;1|28:1=10;1|86:1=208','{10000,10000}'),(10080003,1,0,1000,2,0,0,'1|35:1=34;1|28:1=10;1|86:1=208','{10000,10000}'),(10080004,1,0,1000,2,0,0,'1|35:1=34;1|28:1=10;1|86:1=208','{10000,10000}'),(10080005,1,0,1000,2,0,0,'1|35:1=34;1|28:1=10;1|87:1=60','{10000,10000}'),(10080006,1,0,1000,2,0,0,'1|35:1=34;1|28:1=10;1|87:1=60','{10000,10000}'),(10080007,1,0,1000,2,0,0,'1|35:1=34;1|28:1=10;1|87:1=60','{10000,10000}'),(10080008,1,0,1000,2,0,0,'1|35:1=34;1|28:1=10;1|87:1=60','{10000,10000}'),(10090001,1,0,1000,2,0,0,'1|35:1=34;1|28:1=10;1|87:1=60','{10000,10000}'),(10090002,1,0,1000,2,0,0,'1|35:1=34;1|28:1=10;1|87:1=60','{10000,10000}'),(10090003,1,0,1000,2,0,0,'1|35:1=34;1|28:1=10;1|87:1=60','{10000,10000}'),(10090004,1,0,1000,2,0,0,'1|35:1=34;1|28:1=10;1|87:1=60','{10000,10000}'),(10090005,1,0,1000,2,0,0,'1|35:1=34;1|28:1=10;1|87:1=60','{10000,10000}'),(10090006,1,0,1000,2,0,0,'1|35:1=34;1|28:1=10;1|87:1=60','{10000,10000}'),(10090007,1,0,1000,2,0,0,'1|35:1=34;1|28:1=10;1|87:1=60','{10000,10000}'),(10090008,1,0,1000,2,0,0,'1|35:1=34;1|28:1=10;1|87:1=60','{10000,10000}'),(10100001,1,0,1000,2,0,0,'1|35:1=34;1|28:1=10;1|88:1=1','{10000,10000}'),(10100002,1,0,1000,2,0,0,'1|35:1=34;1|28:1=10;1|88:1=1','{10000,10000}'),(10100003,1,0,1000,2,0,0,'1|35:1=34;1|28:1=10;1|88:1=1','{10000,10000}'),(10100004,1,0,1000,2,0,0,'1|35:1=34;1|28:1=10;1|88:1=1','{10000,10000}'),(10100005,1,0,1000,2,0,0,'1|35:1=34;1|28:1=10;1|88:1=1','{10000,10000}'),(10100006,1,0,1000,2,0,0,'1|35:1=34;1|28:1=10;1|88:1=1','{10000,10000}'),(10100007,1,0,1000,2,0,0,'1|35:1=34;1|28:1=10;1|88:1=1','{10000,10000}'),(10110001,1,0,1000,2,0,0,'1|36:1=35;1|28:1=10;1|88:1=1','{10000,10000}'),(10110002,1,0,1000,2,0,0,'1|36:1=35;1|28:1=10;1|89:1=1','{10000,10000}'),(10110003,1,0,1000,2,0,0,'1|36:1=35;1|28:1=10;1|89:1=1','{10000,10000}'),(10110004,1,0,1000,2,0,0,'1|36:1=35;1|28:1=10;1|89:1=1','{10000,10000}'),(10110005,1,0,1000,2,0,0,'1|36:1=35;1|28:1=10;1|89:1=1','{10000,10000}'),(10110006,1,0,1000,2,0,0,'1|36:1=35;1|28:1=10;1|89:1=1','{10000,10000}'),(10110007,1,0,1000,2,0,0,'1|36:1=35;1|28:1=10;1|89:1=1','{10000,10000}'),(10110008,1,0,1000,2,0,0,'1|36:1=35;1|28:1=10;1|89:1=1','{10000,10000}'),(10120001,1,0,1000,2,0,0,'1|35:1=34;1|28:1=10;1|88:1=1','{10000,10000}'),(10120002,1,0,1000,2,0,0,'1|36:1=35;1|28:1=10;1|88:1=1','{10000,10000}'),(10120003,1,0,1000,2,0,0,'1|36:1=35;1|28:1=10;1|88:1=1','{10000,10000}'),(10120004,1,0,1000,2,0,0,'1|36:1=35;1|28:1=10;1|88:1=1','{10000,10000}'),(10120005,1,0,1000,2,0,0,'1|36:1=35;1|28:1=10;1|88:1=1','{10000,10000}'),(10120006,1,0,1000,2,0,0,'1|36:1=35;1|28:1=10;1|88:1=1','{10000,10000}'),(10120007,1,0,1000,2,0,0,'1|36:1=35;1|28:1=10;1|88:1=1','{10000,10000}'),(10120008,1,0,1000,2,0,0,'1|36:1=35;1|28:1=10;1|88:1=1','{10000,10000}'),(10130001,1,0,1000,2,0,0,'1|36:1=35;1|28:1=10;1|89:1=1','{10000,10000}'),(10130002,1,0,1000,2,0,0,'1|36:1=35;1|28:1=10;1|89:1=1','{10000,10000}'),(10130003,1,0,1000,2,0,0,'1|36:1=35;1|28:1=10;1|89:1=1','{10000,10000}'),(10130004,1,0,1000,2,0,0,'1|36:1=35;1|28:1=10;1|89:1=1','{10000,10000}'),(10130005,1,0,1000,2,0,0,'1|36:1=35;1|28:1=10;1|89:1=1','{10000,10000}'),(10130006,1,0,1000,2,0,0,'1|36:1=35;1|28:1=10;1|89:1=1','{10000,10000}'),(10130007,1,0,1000,2,0,0,'1|36:1=35;1|28:1=10;1|89:1=1','{10000,10000}'),(10130008,1,0,1000,2,0,0,'1|36:1=35;1|28:1=10','{10000,10000}'),(10130009,1,0,1000,2,0,0,'1|36:1=35;1|28:1=10','{10000,10000}'),(10140001,1,0,1000,2,0,0,'1|36:1=35;1|28:1=10','{10000,10000}'),(10140002,1,0,1000,2,0,0,'1|37:1=36;1|28:1=10','{10000,10000}'),(10140003,1,0,1000,2,0,0,'1|37:1=36;1|28:1=10','{10000,10000}'),(10140004,1,0,1000,2,0,0,'1|37:1=36;1|28:1=10','{10000,10000}'),(10140005,1,0,1000,2,0,0,'1|37:1=36;1|28:1=10','{10000,10000}'),(10140006,1,0,1000,2,0,0,'1|37:1=36;1|28:1=10','{10000,10000}'),(10140007,1,0,1000,2,0,0,'1|37:1=36;1|28:1=10','{10000,10000}'),(10140008,1,0,1000,2,0,0,'1|37:1=36;1|28:1=10','{10000,10000}'),(10140009,1,0,1000,2,0,0,'1|37:1=36;1|28:1=10','{10000,10000}'),(51550008,1,0,1000,0,0,0,'1|84:1=10000','{10000,10000}'),(620020001,1,0,1000,2,0,1,'2|137:1=10000;8|137:1=5000;1|138:1=10000','{10000,10000}'),(620020002,1,0,1000,2,0,1,'2|137:1=10000;8|137:1=5000;1|139:1=10000','{10000,10000}'),(620020003,1,0,1000,2,0,1,'2|137:1=10000;8|137:1=5000;1|140:1=10000','{10000,10000}'),(620020004,1,0,1000,2,0,1,'2|137:1=10000;8|137:1=5000;1|141:1=10000','{10000,10000}'),(620020005,1,0,1000,2,0,1,'2|137:1=10000;8|137:1=5000;1|142:1=10000','{10000,10000}'),(620020006,1,0,1000,2,0,1,'2|137:1=10000;8|137:1=5000;1|143:1=10000','{10000,10000}'),(620020007,1,0,1000,2,0,1,'2|137:1=10000;8|137:1=5000;1|144:1=10000','{10000,10000}'),(620020008,1,0,1000,2,0,1,'2|137:1=10000;8|137:1=5000;1|145:1=10000','{10000,10000}'),(620030001,1,0,599,2,0,1,'7|137:1=10000;2|137:1=7917;1|3000010:1=5000;1|3000020:1=300;1|3000030:1=250;1|3000040:1=150;1|3000050:1=50;1|3000110:1=0;1|3000120:1=0;1|3000130:1=0;1|3000140:1=0;1|3000150:1=0;1|3000210:1=0;1|3000220:1=0;1|3000230:1=0;1|3000240:1=0;1|3000250:1=0;1|3000310:1=0;1|3000320:1=0;1|3000330:1=0;1|3000340:1=0;1|3000350:1=0;1|3000410:1=0','{10000,10000}'),(620030001,1,600,649,2,0,1,'10|137:1=10000;4|137:1=833;1|3000010:1=6214;1|3000020:1=449;1|3000030:1=449;1|3000040:1=207;1|3000050:1=69;1|3000110:1=450;1|3000120:1=33;1|3000130:1=45;1|3000140:1=0;1|3000150:1=0;1|3000210:1=109;1|3000220:1=0;1|3000230:1=0;1|3000240:1=0;1|3000250:1=0;1|3000310:1=0;1|3000320:1=0;1|3000330:1=0;1|3000340:1=0;1|3000350:1=0;1|3000410:1=0','{10000,10000}'),(620030001,1,650,699,2,0,1,'14|137:1=10000;4|137:1=7500;1|3000010:1=6667;1|3000020:1=667;1|3000030:1=762;1|3000040:1=286;1|3000050:1=190;1|3000110:1=667;1|3000120:1=58;1|3000130:1=108;1|3000140:1=75;1|3000150:1=0;1|3000210:1=150;1|3000220:1=11;1|3000230:1=0;1|3000240:1=0;1|3000250:1=0;1|3000310:1=0;1|3000320:1=0;1|3000330:1=0;1|3000340:1=0;1|3000350:1=0;1|3000410:1=0','{10000,10000}'),(620030001,1,700,749,2,0,1,'18|137:1=10000;4|137:1=3333;1|3000010:1=5714;1|3000020:1=857;1|3000030:1=1086;1|3000040:1=343;1|3000050:1=229;1|3000110:1=700;1|3000120:1=75;1|3000130:1=170;1|3000140:1=120;1|3000150:1=20;1|3000210:1=184;1|3000220:1=15;1|3000230:1=21;1|3000240:1=0;1|3000250:1=0;1|3000310:1=0;1|3000320:1=0;1|3000330:1=0;1|3000340:1=0;1|3000350:1=0;1|3000410:1=0','{10000,10000}'),(620030001,1,750,799,2,0,1,'20|137:1=10000;4|137:1=9167;1|3000010:1=0;1|3000020:1=1733;1|3000030:1=2000;1|3000040:1=400;1|3000050:1=400;1|3000110:1=708;1|3000120:1=113;1|3000130:1=269;1|3000140:1=213;1|3000150:1=30;1|3000210:1=213;1|3000220:1=19;1|3000230:1=29;1|3000240:1=19;1|3000250:1=0;1|3000310:1=57;1|3000320:1=0;1|3000330:1=0;1|3000340:1=0;1|3000350:1=0;1|3000410:1=0','{10000,10000}'),(620030001,1,800,849,2,0,1,'21|137:1=10000;6|137:1=2083;1|3000010:1=0;1|3000020:1=0;1|3000030:1=2286;1|3000040:1=1219;1|3000050:1=762;1|3000110:1=0;1|3000120:1=165;1|3000130:1=458;1|3000140:1=330;1|3000150:1=53;1|3000210:1=250;1|3000220:1=25;1|3000230:1=42;1|3000240:1=27;1|3000250:1=0;1|3000310:1=86;1|3000320:1=1;1|3000330:1=0;1|3000340:1=0;1|3000350:1=0;1|3000410:1=0','{10000,10000}'),(620030001,1,850,899,2,0,1,'23|137:1=10000;6|137:1=5000;1|3000010:1=0;1|3000020:1=0;1|3000030:1=0;1|3000040:1=1714;1|3000050:1=1371;1|3000110:1=0;1|3000120:1=0;1|3000130:1=583;1|3000140:1=490;1|3000150:1=93;1|3000210:1=268;1|3000220:1=30;1|3000230:1=54;1|3000240:1=35;1|3000250:1=0;1|3000310:1=114;1|3000320:1=1;1|3000330:1=0;1|3000340:1=0;1|3000350:1=0;1|3000410:1=0','{10000,10000}'),(620030001,1,900,1000,2,0,1,'25|137:1=10000;6|137:1=7917;1|3000010:1=0;1|3000020:1=0;1|3000030:1=0;1|3000040:1=0;1|3000050:1=1905;1|3000110:1=0;1|3000120:1=0;1|3000130:1=0;1|3000140:1=750;1|3000150:1=138;1|3000210:1=282;1|3000220:1=35;1|3000230:1=67;1|3000240:1=43;1|3000250:1=0;1|3000310:1=171;1|3000320:1=2;1|3000330:1=0;1|3000340:1=0;1|3000350:1=0;1|3000410:1=0','{10000,10000}');
/*!40000 ALTER TABLE `base_drop_rule` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_drumwar_cfg`
--

DROP TABLE IF EXISTS `base_drumwar_cfg`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_drumwar_cfg` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `open_day` varchar(512) NOT NULL DEFAULT '[]' COMMENT '开启日期',
  `sign_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '报名持续时间',
  `sea_ready` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '准备期持续时间',
  `sea_prepare` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '海选赛准备时间',
  `sea_enter` int(11) NOT NULL DEFAULT '0' COMMENT '海选赛拉人进战场时间',
  `sea_war` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '海选赛每场战斗时间',
  `rank_ready` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '夺王赛备战时间(转场时间)',
  `rank_prepare` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '夺王赛准备时间',
  `rank_enter` int(11) NOT NULL DEFAULT '0' COMMENT '夺王赛拉人进场时间',
  `rank_war` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '夺王赛时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_drumwar_cfg`
--

LOCK TABLES `base_drumwar_cfg` WRITE;
/*!40000 ALTER TABLE `base_drumwar_cfg` DISABLE KEYS */;
INSERT INTO `base_drumwar_cfg` VALUES (2,'[{6,0,0,0}]',75600,120,20,10,60,10,30,10,90);
/*!40000 ALTER TABLE `base_drumwar_cfg` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_drumwar_choose`
--

DROP TABLE IF EXISTS `base_drumwar_choose`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_drumwar_choose` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '场次',
  `type` int(11) NOT NULL DEFAULT '0' COMMENT '类型',
  `input` varchar(512) NOT NULL DEFAULT '[]' COMMENT '投入金额',
  `output` varchar(512) NOT NULL DEFAULT '[]' COMMENT '成功奖励',
  PRIMARY KEY (`id`,`type`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_drumwar_choose`
--

LOCK TABLES `base_drumwar_choose` WRITE;
/*!40000 ALTER TABLE `base_drumwar_choose` DISABLE KEYS */;
INSERT INTO `base_drumwar_choose` VALUES (9,1,'[{2,36020001,15}]','[{2,36020001,30}]'),(9,2,'[{2,36020001,30}]','[{2,36020001,60}]'),(9,3,'[{2,36020001,50}]','[{2,36020001,100}]'),(10,1,'[{2,36020001,30}]','[{2,36020001,60}]'),(10,2,'[{2,36020001,50}]','[{2,36020001,100}]'),(10,3,'[{2,36020001,80}]','[{2,36020001,160}]'),(11,1,'[{2,36020001,50}]','[{2,36020001,100}]'),(11,2,'[{2,36020001,80}]','[{2,36020001,160}]'),(11,3,'[{2,36020001,100}]','[{2,36020001,200}]'),(12,1,'[{2,36020001,80}]','[{2,36020001,160}]'),(12,2,'[{2,36020001,100}]','[{2,36020001,200}]'),(12,3,'[{2,36020001,150}]','[{2,36020001,300}]');
/*!40000 ALTER TABLE `base_drumwar_choose` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_drumwar_kv`
--

DROP TABLE IF EXISTS `base_drumwar_kv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_drumwar_kv` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '键',
  `val` varchar(255) NOT NULL DEFAULT '0' COMMENT '值',
  `description` varchar(50) NOT NULL DEFAULT '[]' COMMENT '描述@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_drumwar_kv`
--

LOCK TABLES `base_drumwar_kv` WRITE;
/*!40000 ALTER TABLE `base_drumwar_kv` DISABLE KEYS */;
INSERT INTO `base_drumwar_kv` VALUES (1,'340','参加比赛等级'),(2,'340','参加竞猜等级'),(3,'38220003','钻石大战门票物品id'),(4,'[7005,7006,7007,7008,7009,7010,7011,7012]','[准备场景id]'),(5,'[7001,7002,7003,7004]','[战斗场景id]'),(6,'[{2815,5991,300},{3685,6568,300},{4254,5876,300},{2569,3363,300},{4006,3341,300},{1801,2178,300},{4368,1388,300},{5114,3188,300}]','准备场景出生点,格式:[{圆心坐标X,圆心坐标Y,圆半径}]'),(7,'[{3557,5723},{3409,3153},{6059,3174},{6133,5811}]','复活坐标点:格式:[{X,Y}]'),(8,'[21007001,21007002,21007003]','[技能id]'),(9,'10','幸运奖人数'),(10,'{3805,4511}','战场左边出生点:格式:{X,Y}'),(11,'{5747,4460}','战场右边出生点:格式:{X,Y}'),(12,'[{2,0,20}]','技能使用消耗:[{类型,物品id,数量}]'),(13,'10','技能cd时间'),(14,'[{3,21,00}]','钻石大战开启时间'),(15,'[{1,36010001,25}]','钻石大战买命消耗（先消耗门票））'),(16,'8','开服多少天后开启'),(17,'[{1,3754,4614},{2,3747,4355},{3,3629,4461}]','左边星灵出战坐标:[{位置,X,Y}]'),(18,'[{1,5832,4575},{2,5829,4312},{3,5932,4423}]','右边星灵出战坐标:[{位置,X,Y}]'),(19,'1','单个赛区活动开启的最低人数');
/*!40000 ALTER TABLE `base_drumwar_kv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_drumwar_lv_to_zone`
--

DROP TABLE IF EXISTS `base_drumwar_lv_to_zone`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_drumwar_lv_to_zone` (
  `zid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战区',
  `turn` int(11) NOT NULL DEFAULT '0' COMMENT '传奇等级',
  `min_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小等级',
  `max_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大等级',
  `lucky_reward` varchar(50) NOT NULL DEFAULT '[]' COMMENT '幸运奖',
  PRIMARY KEY (`zid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_drumwar_lv_to_zone`
--

LOCK TABLES `base_drumwar_lv_to_zone` WRITE;
/*!40000 ALTER TABLE `base_drumwar_lv_to_zone` DISABLE KEYS */;
INSERT INTO `base_drumwar_lv_to_zone` VALUES (1,0,340,1000,'[{0,38220003,1},{0,32030401,1}]');
/*!40000 ALTER TABLE `base_drumwar_lv_to_zone` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_drumwar_mon`
--

DROP TABLE IF EXISTS `base_drumwar_mon`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_drumwar_mon` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '序号',
  `zone` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战区',
  `act` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '轮次',
  `min_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级下限',
  `max_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级上限',
  `stage` varchar(50) NOT NULL DEFAULT '{0,0}' COMMENT '假星灵阶数{stage, star}',
  `star_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT '假星灵id',
  `mon_lv` int(11) NOT NULL DEFAULT '0' COMMENT '假人等级',
  `ratio` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '系数',
  `power` varchar(50) NOT NULL DEFAULT '[]' COMMENT '假人战力区间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_drumwar_mon`
--

LOCK TABLES `base_drumwar_mon` WRITE;
/*!40000 ALTER TABLE `base_drumwar_mon` DISABLE KEYS */;
INSERT INTO `base_drumwar_mon` VALUES (1,1,1,340,1000,'{4,3}','[1001,1004,2001]',340,90,'{3424942,3534211}'),(2,1,2,340,1000,'{5,1}','[1001,1004,2001]',345,95,'{3561529,3670798}'),(3,1,3,340,1000,'{5,2}','[1001,1004,2001]',350,100,'{3698115,3858542}'),(4,1,4,340,1000,'{5,3}','[1001,1004,2001]',355,105,'{3898649,4059077}'),(5,1,5,340,1000,'{6,1}','[1001,1004,2001]',360,110,'{4099183,4259611}'),(6,1,6,340,1000,'{6,2}','[1001,1004,2001]',365,115,'{4299718,4460145}'),(7,1,7,340,1000,'{6,3}','[1001,1004,2001]',370,120,'{4500252,4660679}'),(8,1,8,340,1000,'{7,1}','[1001,1004,2001]',375,125,'{4700786,4861213}'),(9,1,9,340,1000,'{7,2}','[1001,1004,2001]',380,130,'{4901320,5061748}'),(10,1,10,340,1000,'{7,3}','[1001,1004,2001]',385,135,'{5101854,5262282}'),(11,1,11,340,1000,'{8,1}','[1001,1004,2001]',390,140,'{5302389,5462816}'),(12,1,12,340,1000,'{8,2}','[1001,1004,2001]',395,145,'{5502923,5663350}');
/*!40000 ALTER TABLE `base_drumwar_mon` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_drumwar_rank_reward`
--

DROP TABLE IF EXISTS `base_drumwar_rank_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_drumwar_rank_reward` (
  `zid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战区id',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排行',
  `reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`zid`,`rank`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_drumwar_rank_reward`
--

LOCK TABLES `base_drumwar_rank_reward` WRITE;
/*!40000 ALTER TABLE `base_drumwar_rank_reward` DISABLE KEYS */;
INSERT INTO `base_drumwar_rank_reward` VALUES (1,1,'[{2,36020001,600},{0,4915003,1}]'),(1,2,'[{2,36020001,450},{0,4915002,1}]'),(1,3,'[{2,36020001,350},{0,4915001,1}]'),(1,4,'[{2,36020001,350},{0,4915001,1}]'),(1,5,'[{2,36020001,270}]'),(1,6,'[{2,36020001,270}]'),(1,7,'[{2,36020001,270}]'),(1,8,'[{2,36020001,270}]'),(1,9,'[{2,36020001,200}]'),(1,10,'[{2,36020001,200}]'),(1,11,'[{2,36020001,200}]'),(1,12,'[{2,36020001,200}]'),(1,13,'[{2,36020001,200}]'),(1,14,'[{2,36020001,200}]'),(1,15,'[{2,36020001,200}]'),(1,16,'[{2,36020001,200}]');
/*!40000 ALTER TABLE `base_drumwar_rank_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_drumwar_robot`
--

DROP TABLE IF EXISTS `base_drumwar_robot`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_drumwar_robot` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '机器人id',
  `name` varchar(100) NOT NULL COMMENT '机器人名字@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_drumwar_robot`
--

LOCK TABLES `base_drumwar_robot` WRITE;
/*!40000 ALTER TABLE `base_drumwar_robot` DISABLE KEYS */;
INSERT INTO `base_drumwar_robot` VALUES (1,'阿博特'),(2,'艾比盖'),(3,'埃达'),(4,'黑骑'),(5,'萌小乖'),(6,'小乖'),(7,'小强'),(8,'阿贝'),(9,'爱得莱德'),(10,'爱得拉'),(11,'旗木'),(12,'冷峰'),(13,'香远'),(14,'头领'),(15,'男名'),(16,'亚伯拉罕'),(17,'爱尔柏塔'),(18,'阿芙拉'),(19,'漩涡'),(20,'皇族'),(21,'丽影'),(22,'王子'),(23,'埃利诺吉榭尔'),(24,'艾奇逊'),(25,'贝齐'),(26,'阿加莎'),(27,'纳尔'),(28,'古墓'),(29,'莎伦纳'),(30,'骑士'),(31,'阿克曼'),(32,'贝蒂'),(33,'爱葛妮丝'),(34,'专属'),(35,'艾尔莎'),(36,'丫头'),(37,'帅帅'),(38,'萌萌爱'),(39,'亚当'),(40,'比尤莱'),(41,'亚莉克希亚'),(42,'非主流唯爱'),(43,'洛菲达'),(44,'阿木'),(45,'小帅'),(46,'亚当斯'),(47,'布莱兹'),(48,'艾丽斯'),(49,'宇智波'),(50,'银铃'),(51,'绅士'),(52,'艾迪生'),(53,'布伦达'),(54,'爱玛'),(55,'完美'),(56,'非主流'),(57,'小芳'),(58,'佐助'),(59,'阿狄森'),(60,'布里奇特'),(61,'奥尔瑟雅'),(62,'经典'),(63,'芳芳'),(64,'鸣人'),(65,'艾狄生'),(66,'布鲁克诺娃'),(67,'阿尔娃夏诺'),(68,'巅峰'),(69,'冰激凌'),(70,'巴扎克'),(71,'卡卡西'),(72,'阿德拉'),(73,'西莱斯特'),(74,'阿蜜莉雅'),(75,'回忆'),(76,'经典回忆'),(77,'倾城之恋'),(78,'一户'),(79,'阿德莱德'),(80,'夏洛特诺玛'),(81,'艾咪酱'),(82,'独恋红尘'),(83,'红尘'),(84,'喵喵酱'),(85,'小墨'),(86,'阿道夫'),(87,'谢里尔法'),(88,'阿娜丝塔西夏'),(89,'银月传说'),(90,'永恒经典'),(91,'小笨蛋酱'),(92,'墨尘'),(93,'阿格尼丝'),(94,'克里斯丁'),(95,'安德烈亚'),(96,'单身孤独'),(97,'回忆至爱'),(98,'喵咪酱'),(99,'小林'),(100,'艾伯特'),(101,'克莱娜'),(102,'安妮儿'),(103,'恋孤独'),(104,'独恋'),(105,'燕尾蝶蜂'),(106,'爱情相信眼泪'),(107,'奥尔科特'),(108,'克莱拉那'),(109,'安娜贝利'),(110,'午夜传说'),(111,'传说'),(112,'姑娘不哭'),(113,'小傻瓜'),(114,'奥尔丁顿'),(115,'潼恩斯克'),(116,'安纳贝尔'),(117,'大和'),(118,'可爱'),(119,'小妞酱'),(120,'小雨'),(121,'奥尔德里奇'),(122,'德博拉娜'),(123,'安东妮儿'),(124,'慕容铅华'),(125,'单身'),(126,'幕小小'),(127,'小宇'),(128,'亚历克'),(129,'多洛雷斯'),(130,'艾谱莉娜'),(131,'欧阳闪耀'),(132,'醉恋'),(133,'夏洛特玲玲'),(134,'小羽'),(135,'亚历山大'),(136,'多明尼卡'),(137,'爱勒贝拉'),(138,'西门'),(139,'千语'),(140,'阿绫'),(141,'小渔'),(142,'阿尔弗列德'),(143,'多拉蕾娜'),(144,'爱琳'),(145,'爱琳娜'),(146,'午夜'),(147,'麦当娜'),(148,'小煜'),(149,'艾尔弗雷德'),(150,'桃乐斯丽'),(151,'艾丝翠得'),(152,'夏日倾城'),(153,'倾城'),(154,'妖精恋'),(155,'幕潇雨'),(156,'艾丽丝'),(157,'伊甸苹果'),(158,'亚特兰特'),(159,'诸葛'),(160,'慕容'),(161,'戴安娜'),(162,'小瑜'),(163,'阿丽丝'),(164,'伊迪丝'),(165,'阿西娜'),(166,'哈利'),(167,'欧阳'),(168,'小娜'),(169,'晓宇'),(170,'阿利克'),(171,'伊莲恩'),(172,'奥德丽'),(173,'演绎'),(174,'南宫'),(175,'莎'),(176,'小禹'),(177,'艾尔索普'),(178,'艾琳诺'),(179,'奥劳拉'),(180,'司马'),(181,'夏侯'),(182,'小鱼'),(183,'豆包'),(184,'阿利'),(185,'艾伦'),(186,'芭芭拉'),(187,'纳兰'),(188,'春野'),(189,'潇雨'),(190,'包子'),(191,'阿米利亚'),(192,'艾尔玛'),(193,'碧翠丝'),(194,'自由'),(195,'猫猫'),(196,'豆浆'),(197,'安德森'),(198,'艾西'),(199,'贝琳达'),(200,'浪漫'),(201,'卑弥呼'),(202,'玄子'),(203,'志伟'),(204,'安德鲁'),(205,'埃尔韦拉'),(206,'贝拉'),(207,'守护'),(208,'彩虹'),(209,'国宝'),(210,'小辉'),(211,'安'),(212,'费滋'),(213,'柏妮丝'),(214,'华丽'),(215,'熊猫'),(216,'小二'),(217,'安娜'),(218,'弗朗西斯'),(219,'柏莎'),(220,'王者'),(221,'蕊蕊'),(222,'瑞萌萌'),(223,'安妮伦纳'),(224,'弗莉达'),(225,'百丽儿'),(226,'龙之'),(227,'小蕊'),(228,'小瑞'),(229,'安东尼'),(230,'菲蕾德翠卡贝丝'),(231,'左岸'),(232,'七夜'),(233,'墨墨'),(234,'安托瓦妮特'),(235,'盖尔'),(236,'贝芙'),(237,'阿尔'),(238,'笑笑'),(239,'阿修罗'),(240,'安东尼娅'),(241,'乔治亚'),(242,'布兰琪'),(243,'挚爱'),(244,'泪眼'),(245,'匪徒'),(246,'阿拉贝拉'),(247,'杰拉尔丁'),(248,'卡米拉'),(249,'天道'),(250,'星星'),(251,'汏少爺'),(252,'阿奇博尔德'),(253,'吉榭尔'),(254,'坎蒂丝'),(255,'红人'),(256,'淑女'),(257,'花满楼'),(258,'阿姆斯特朗'),(259,'葛罗瑞亚'),(260,'卡拉'),(261,'star'),(262,'梦醒'),(263,'榮耀'),(264,'阿诺德'),(265,'格拉迪斯'),(266,'卡萝'),(267,'笑傲'),(268,'小梦'),(269,'誑磝'),(270,'阿瑟'),(271,'达卡罗琳'),(272,'神圣'),(273,'晓梦'),(274,'輝煌'),(275,'阿特利'),(276,'凯瑟琳'),(277,'大爱'),(278,'妖娆'),(279,'茉莉'),(280,'神气'),(281,'奥古斯丁'),(282,'汉纳'),(283,'凯丝'),(284,'天使'),(285,'牡丹'),(286,'先生'),(287,'奥古斯塔斯'),(288,'海柔尔'),(289,'塞西莉亚'),(290,'温柔'),(291,'姗姗'),(292,'浪子'),(293,'奥斯汀'),(294,'赫瑟尔'),(295,'夏洛特'),(296,'灵魂'),(297,'小珊'),(298,'空空'),(299,'赫达'),(300,'绮莉'),(301,'无情'),(302,'卡卡'),(303,'白壁德'),(304,'海伦'),(305,'克洛怡'),(306,'潇洒'),(307,'咪咪'),(308,'清景'),(309,'巴比'),(310,'海洛伊丝'),(311,'克莱儿'),(312,'无忧'),(313,'蜜蜜'),(314,'晓林'),(315,'巴比特'),(316,'胡尔达'),(317,'克莱拉'),(318,'繁华'),(319,'小蜜'),(320,'庆'),(321,'巴赫'),(322,'克莱曼婷'),(323,'柔情'),(324,'小秘'),(325,'阿信'),(326,'培根'),(327,'康斯坦丝'),(328,'绝版'),(329,'莫莫'),(330,'波特'),(331,'鲍德温'),(332,'伊莎蓓尔'),(333,'科拉'),(334,'寂寞'),(335,'沫沫'),(336,'草雉'),(337,'巴纳德'),(338,'杰奎琳'),(339,'卡洛儿'),(340,'幻想'),(341,'么么'),(342,'巴神'),(343,'巴尼'),(344,'乔'),(345,'可妮莉雅'),(346,'旋律'),(347,'笨笨'),(348,'巴雷特'),(349,'琼酱'),(350,'黛西'),(351,'优雅'),(352,'美子'),(353,'飞飞'),(354,'希伯来'),(355,'黛儿'),(356,'精彩'),(357,'雯雯'),(358,'浮云'),(359,'巴里'),(360,'乔伊'),(361,'黛娜'),(362,'辉煌'),(363,'小雯'),(364,'仙人'),(365,'巴特'),(366,'乔伊斯');
/*!40000 ALTER TABLE `base_drumwar_robot` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_drumwar_zone_reward`
--

DROP TABLE IF EXISTS `base_drumwar_zone_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_drumwar_zone_reward` (
  `zid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战区',
  `act` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '轮次',
  `win_reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '胜奖励',
  `lose_reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '败奖励',
  PRIMARY KEY (`zid`,`act`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_drumwar_zone_reward`
--

LOCK TABLES `base_drumwar_zone_reward` WRITE;
/*!40000 ALTER TABLE `base_drumwar_zone_reward` DISABLE KEYS */;
INSERT INTO `base_drumwar_zone_reward` VALUES (1,1,'[{2,36020001,80}]','[{2,36020001,60}]'),(1,2,'[{2,36020001,100}]','[{2,36020001,75}]'),(1,3,'[{2,36020001,120}]','[{2,36020001,90}]'),(1,4,'[{2,36020001,140}]','[{2,36020001,105}]'),(1,5,'[{2,36020001,160}]','[{2,36020001,120}]'),(1,6,'[{2,36020001,180}]','[{2,36020001,135}]'),(1,7,'[{2,36020001,200}]','[{2,36020001,150}]'),(1,8,'[{2,36020001,220}]','[{2,36020001,165}]'),(1,9,'[{2,36020001,240}]','[{2,36020001,180}]'),(1,10,'[{2,36020001,260}]','[{2,36020001,195}]'),(1,11,'[{2,36020001,280}]','[{2,36020001,210}]'),(1,12,'[{2,36020001,300}]','[{2,36020001,225}]');
/*!40000 ALTER TABLE `base_drumwar_zone_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_dsgt`
--

DROP TABLE IF EXISTS `base_dsgt`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_dsgt` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '称号id',
  `main_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '称号大类',
  `name` varchar(50) NOT NULL COMMENT '称号名称@lang@',
  `description` varchar(1024) NOT NULL COMMENT '称号描述@lang@',
  `type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '称号类型',
  `expire_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时效',
  `is_overlay` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '时效叠加',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '称号对应的物品ID',
  `attr_list` varchar(1024) NOT NULL COMMENT '属性奖励',
  `resource_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '资源id',
  `is_global` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '全局称号数量',
  `color` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '称号颜色',
  `return_money` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '返还物品',
  `refresh_time` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '刷新间隔',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='称号配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_dsgt`
--

LOCK TABLES `base_dsgt` WRITE;
/*!40000 ALTER TABLE `base_dsgt` DISABLE KEYS */;
INSERT INTO `base_dsgt` VALUES (4901001,1,'新贵一族','贵族VIP1玩家的专属称号',3,0,0,4901001,'[{2,1200},{1,60},{3,30},{4,30}]',4901001,0,1,'[]',0),(4901002,1,'华丽贵族','贵族VIP4玩家的专属称号',3,0,0,4901002,'[{2,2400},{1,120},{3,60},{4,60}]',4901002,0,2,'[]',0),(4901003,1,'典雅贵族','贵族VIP6玩家的专属称号',3,0,0,4901003,'[{2,10400},{1,520},{3,260},{4,260}]',4901003,0,3,'[]',0),(4901004,1,'荣耀贵族','贵族VIP8玩家的专属称号',3,0,0,4901004,'[{2,15400},{1,770},{3,385},{4,385}]',4901004,0,3,'[]',0),(4901005,1,'星曜贵族','贵族VIP10玩家的专属称号',3,0,0,4901005,'[{2,40000},{1,2000},{3,1000},{4,1000}]',4901005,0,3,'[]',0),(4901006,1,'世袭贵族','贵族VIP12玩家的专属称号',3,0,0,4901006,'[{2,46000},{1,2300},{3,1150},{4,1150}]',4901006,0,4,'[]',0),(4901007,1,'永恒贵族','贵族VIP14玩家的专属称号',3,0,0,4901007,'[{2,52200},{1,2610},{3,1305},{4,1305}]',4901007,0,4,'[]',0),(4901008,1,'至尊贵族','贵族VIP15玩家的专属称号',3,0,0,4901008,'[{2,58400},{1,2920},{3,1460},{4,1460}]',4901008,0,5,'[]',0),(4901009,1,'发家致富','投资传奇计划中投资1880档获得',3,0,0,4901009,'[{2,2000},{1,100},{5,25},{6,25}]',4901009,0,1,'[]',0),(4901010,1,'富可敌国','投资巅峰计划中投资1880档获得',3,0,0,4901010,'[{2,3200},{1,160},{5,45},{6,45}]',4901010,0,3,'[]',0),(4901011,1,'富甲天下','投资巅峰计划中投资2880档获得',3,0,0,4901011,'[{2,5400},{1,270},{5,65},{6,65}]',4901011,0,3,'[]',0),(4901012,1,'荣耀至尊','至尊贵族商店兑换',3,86400,0,4901012,'[{19,200},{20,200},{50,400},{51,400}]',4901012,0,5,'[]',0),(4902001,2,'十方新星','实时刷新，竞技前4-10名获得',3,0,0,4902001,'[{2,2400},{1,120},{3,60},{4,60}]',4902001,1,2,'[]',0),(4902002,2,'决斗之光','实时刷新，竞技排名第3名获得',3,0,0,4902002,'[{2,3600},{1,180},{3,90},{4,90}]',4902002,1,2,'[]',0),(4902003,2,'决斗大师','实时刷新，竞技排名第2名获得',3,0,0,4902003,'[{2,4200},{1,210},{3,105},{4,105}]',4902003,1,2,'[]',0),(4902004,2,'决斗之王','实时刷新，竞技排名第1名获得',3,0,0,4902004,'[{2,5000},{1,250},{3,125},{4,125}]',4902004,1,3,'[]',0),(4902005,2,'战神无双','实时刷新称号归属，战力榜第1名专属称号',3,0,0,4902005,'[{2,4000},{1,200},{3,100},{4,100}]',4902005,1,3,'[]',0),(4902006,2,'登峰造极','实时刷新称号归属，等级榜第1名专属称号',3,0,0,4902006,'[{2,4000},{1,200},{5,50},{6,50}]',4902006,1,3,'[]',0),(4902007,2,'神行千里','每日0点刷新称号归属，坐骑榜第1名专属称号',3,0,0,4902007,'[{2,4000},{1,200},{7,50},{8,50}]',4902007,1,3,'[]',0),(4902008,2,'逐风之翼','每日0点刷新称号归属，翅膀榜第1名专属称号',3,0,0,4902008,'[{2,4000},{1,200},{3,100},{4,100}]',4902008,1,3,'[]',0),(4902009,2,'神兵天降','每日0点刷新称号归属，宝具榜第1名专属称号',3,0,0,4902009,'[{2,4000},{1,200},{5,50},{6,50}]',4902009,1,3,'[]',0),(4902010,2,'神域领主','每日0点刷新称号归属，降神榜第1名专属称号',3,0,0,4902010,'[{2,4000},{1,200},{7,50},{8,50}]',4902010,1,3,'[]',0),(4902011,2,'圣灵统领','每日0点刷新称号归属，圣灵榜第1名专属称号',3,0,0,4902011,'[{2,4000},{1,200},{3,100},{4,100}]',4902011,1,3,'[]',0),(4902012,2,'星辰之怒','每日0点刷新称号归属，星灵榜第1名专属称号',3,0,0,4902012,'[{2,4000},{1,200},{5,50},{6,50}]',4902012,1,3,'[]',0),(4902013,2,'时尚达人','每日0点刷新称号归属，时装榜第1名专属称号',3,0,0,4902013,'[{2,4000},{1,200},{7,50},{8,50}]',4902013,1,3,'[]',0),(4902014,2,'绝对魔王','每日0点刷新称号归属，魔剑士职业榜第1名专属称号',3,0,0,4902014,'[{2,4000},{1,200},{3,100},{4,100}]',4902014,1,3,'[]',0),(4902015,2,'驭龙统帅','每日0点刷新称号归属，龙骑士职业榜第1名专属称号',3,0,0,4902015,'[{2,4000},{1,200},{3,100},{4,100}]',4902015,1,3,'[]',0),(4902016,2,'枪炮玫瑰','每日0点刷新称号归属，重炮手职业榜第1名专属称号',3,0,0,4902016,'[{2,4000},{1,200},{3,100},{4,100}]',4902016,1,3,'[]',0),(4902017,2,'冲级狂人','等级礼包称号',3,0,0,4902017,'[{2,4000},{1,200},{5,60},{6,60}]',4902017,0,3,'[]',0),(4902018,2,'战力狂人','战力礼包称号',3,0,0,4902018,'[{2,4000},{1,200},{7,60},{8,60}]',4902018,0,3,'[]',0),(4902019,2,'最强装备','每日0点刷新称号归属，本服装备第1名专属称号',3,0,0,4902019,'[{2,3500},{1,175},{7,70},{8,70}]',4902019,1,3,'[]',0),(4902020,2,'绝对巅峰','每日0点刷新称号归属，跨服等级榜第1名专属称号',3,0,0,4902020,'[{2,5000},{1,250},{5,100},{6,100}]',4902020,1,3,'[]',0),(4902021,2,'跨服战神','每日0点刷新称号归属，跨服战力榜第1名专属称号',3,0,0,4902021,'[{2,5000},{1,250},{3,200},{4,200}]',4902021,1,3,'[]',0),(4902022,2,'装备之王','每日0点刷新称号归属，跨服装备榜第1名专属称号',3,0,0,4902022,'[{2,5000},{1,250},{7,100},{8,100}]',4902022,1,3,'[]',0),(4903001,3,'星界游侠','成就称号Ⅰ',3,0,0,4903001,'[{2,2320},{1,116},{5,29},{6,29}]',4903001,0,1,'[]',0),(4903002,3,'星界守护','成就称号Ⅱ',3,0,0,4903002,'[{2,4320},{1,216},{5,54},{6,54}]',4903002,0,2,'[]',0),(4903003,3,'星界英杰','成就称号Ⅲ',3,0,0,4903003,'[{2,6400},{1,320},{5,80},{6,80}]',4903003,0,3,'[]',0),(4903004,3,'星界领主','成就称号Ⅳ',3,0,0,4903004,'[{2,1000},{1,50},{7,12},{8,12}]',4903004,0,3,'[]',0),(4904001,4,'小行星','任务称号Ⅰ',3,0,0,4904001,'[{2,500},{1,25}]',4904001,0,1,'[]',0),(4904002,4,'暗星云','任务称号Ⅱ',3,0,0,4904002,'[{2,800},{1,40},{7,10},{8,10}]',4904002,0,1,'[]',0),(4904003,4,'原恒星','任务称号Ⅲ',3,0,0,4904003,'[{2,1500},{1,75},{7,20},{8,20}]',4904003,0,2,'[]',0),(4904004,4,'主序星','任务称号Ⅳ',3,0,0,4904004,'[{2,2000},{1,100},{7,40},{8,40}]',4904004,0,2,'[]',0),(4904005,4,'超巨星','任务称号Ⅴ',3,0,0,4904005,'[{2,3000},{1,150},{5,60},{6,60}]',4904005,0,2,'[]',0),(4904006,4,'辉曜星','任务称号Ⅵ',3,0,0,4904006,'[{2,5000},{1,250},{5,80},{6,80}]',4904006,0,3,'[]',0),(4904007,4,'超新星','任务称号Ⅶ',3,0,0,4904007,'[{2,6000},{1,300},{3,200},{4,200}]',4904007,0,3,'[]',0),(4905001,5,'智多星','智慧达人中获得第1名获得',3,86400,0,4905001,'[{2,2800},{1,140},{5,35},{6,35}]',4905001,0,2,'[]',0),(4905002,5,'魅力新人王','魅力海滩中魅力值第1名获得',3,86400,0,4905002,'[{2,2800},{1,140},{7,35},{8,35}]',4905002,0,2,'[]',0),(4905003,5,'冲上云霄','护送最高等级飞艇10次获得',3,0,0,4905003,'[{2,2800},{1,140},{3,70},{4,70}]',4905003,0,2,'[]',0),(4905004,5,'蝴蝶捕手','捕蝶活动中取得第1名',3,86400,0,4905004,'[{2,3600},{1,180},{3,90},{4,90}]',4905004,0,2,'[]',0),(4906001,6,'无畏勇士','公会争霸第3名成员',3,604800,0,4906001,'[{2,2000},{1,100},{3,50},{4,50}]',4906001,0,1,'[]',0),(4906002,6,'荣耀勇士','公会争霸第2名成员',3,604800,0,4906002,'[{2,3400},{1,170},{3,85},{4,85}]',4906002,0,2,'[]',0),(4906003,6,'地表最强','公会争霸第1名成员',3,604800,0,4906003,'[{2,4800},{1,240},{3,120},{4,120}]',4906003,0,3,'[]',0),(4906004,6,'天生霸王','公会争霸第1名会长',3,0,0,4906004,'[{2,6400},{1,320},{3,160},{4,160}]',4906004,1,3,'[]',0),(4907001,7,'气宇轩昂','获得魅力周榜男榜第1名',3,604800,0,4907001,'[{2,2000},{1,100},{5,25},{6,25}]',4907001,0,1,'[]',0),(4907002,7,'国色天香','获得魅力周榜女榜第1名',3,604800,0,4907002,'[{2,2000},{1,100},{5,25},{6,25}]',4907002,0,1,'[]',0),(4907003,7,'风流倜傥','获得魅力榜男榜第1名',3,86400,0,4907003,'[{2,3600},{1,180},{7,45},{8,45}]',4907003,0,3,'[]',0),(4907004,7,'倾国倾城','获得魅力榜女榜第1名',3,86400,0,4907004,'[{2,3600},{1,180},{7,45},{8,45}]',4907004,0,3,'[]',0),(4907005,7,'名门君子','获得跨服魅力榜男榜第1名',3,2592000,0,4907005,'[{2,5400},{1,270},{3,135},{4,135}]',4907005,0,2,'[]',0),(4907006,7,'绝世佳人','获得跨服魅力榜女榜第1名',3,2592000,0,4907006,'[{2,5400},{1,270},{3,135},{4,135}]',4907006,0,2,'[]',0),(4907007,7,'玫瑰之恋','举行简约婚礼获得',3,0,0,4907007,'[{2,2000},{1,100},{3,50},{4,50}]',4907007,0,1,'[]',0),(4907008,7,'永恒之恋','举行豪华婚礼获得',3,0,0,4907008,'[{2,3600},{1,180},{3,90},{4,90}]',4907008,0,2,'[]',0),(4907009,7,'世纪之恋','举行世纪婚礼获得',3,0,0,4907009,'[{2,5000},{1,250},{3,125},{4,125}]',4907009,0,3,'[]',0),(4907010,7,'恋爱大作战','举行简约巡游获得',3,0,0,4907010,'[{2,2000},{1,100},{3,50},{4,50}]',4907010,0,1,'[]',0),(4907011,7,'蜜月大冒险','举行豪华巡游获得',3,0,0,4907011,'[{2,3600},{1,180},{3,90},{4,90}]',4907011,0,2,'[]',0),(4907012,7,'甜蜜恋旅人','举行世纪巡游获得',3,0,0,4907012,'[{2,5000},{1,250},{3,125},{4,125}]',4907012,0,3,'[]',0),(4908001,8,'冲级高手','获得开服冲榜【等级榜】第4~10名',3,0,0,4908001,'[{2,4160},{1,208},{3,104},{4,104}]',4908001,0,2,'[]',0),(4908002,8,'冲级达人','获得开服冲榜【等级榜】第2~3名',3,0,0,4908002,'[{2,6400},{1,320},{3,160},{4,160}]',4908002,0,3,'[]',0),(4908003,8,'俯瞰众生','获得开服冲榜【等级榜】第1名',3,0,0,4908003,'[{2,10000},{1,500},{3,250},{4,250}]',4908003,0,4,'[]',0),(4908013,8,'宝石达人','获得开服冲榜【装备榜】第4~10名',3,0,0,4908013,'[{2,4200},{1,210},{5,52},{6,52}]',4908013,0,2,'[]',0),(4908014,8,'宝石之心','获得开服冲榜【装备榜】第2~3名',3,0,0,4908014,'[{2,6400},{1,320},{5,80},{6,80}]',4908014,0,3,'[]',0),(4908015,8,'宝石大亨','获得开服冲榜【宝石榜】第1名',3,0,0,4908015,'[{2,10000},{1,500},{5,125},{6,125}]',4908015,0,4,'[]',0),(4908016,8,'战力达人','获得开服冲榜【战力榜】第4~10名',3,0,0,4908016,'[{2,4200},{1,210},{7,52},{8,52}]',4908016,0,2,'[]',0),(4908017,8,'战力强者','获得开服冲榜【战力榜】第2~3名',3,0,0,4908017,'[{2,6400},{1,320},{7,80},{8,80}]',4908017,0,3,'[]',0),(4908018,8,'战力无双','获得开服冲榜【战力榜】第1名',3,0,0,4908018,'[{2,10000},{1,500},{7,125},{8,125}]',4908018,0,4,'[]',0),(4908019,8,'三世恋人','完成开服活动【三世恋人】后获得',3,0,0,4908019,'[{2,11000},{1,550},{3,275},{4,275}]',4908019,0,4,'[]',0),(4908020,8,'创世筑梦者','开服奖励',3,0,0,4908020,'[{2,2000},{1,100}]',4908020,0,2,'[]',0),(4908021,8,'创世勇士','开服奖励',3,0,0,4908021,'[{2,2000},{1,100}]',4908021,0,2,'[]',0),(4908022,8,'星之守护者','七天送礼第3天获得',3,0,0,4908022,'[{2,2400},{1,120},{3,55},{4,55}]',4908022,0,2,'[]',0),(4908023,8,'星界旅行者','七天送礼第10天获得',3,0,0,4908023,'[{2,4000},{1,200},{3,90},{4,90}]',4908023,0,3,'[]',0),(4908024,8,'大旅行家','七天送礼第20天获得',3,0,0,4908024,'[{2,6800},{1,340},{5,85},{6,85}]',4908024,0,3,'[]',0),(4908025,8,'时间守护者','七天送礼第28天获得',3,0,0,4908025,'[{2,5800},{1,290},{3,240},{4,240},{7,90},{8,90}]',4908025,0,4,'[]',0),(4908026,8,'人生赢家','0元礼包购买可获得',3,0,0,4908026,'[{1,70},{3,40},{5,24},{7,24}]',4908026,0,3,'[]',0),(4908027,8,'先锋骑士','内测玩家专属称号',3,0,0,4908027,'[{2,2400},{1,120},{3,55},{4,55}]',4908027,0,2,'[]',0),(4909001,10,'荆棘修罗','丛林突围排名2等奖',3,172800,0,4909001,'[{2,3600},{1,180},{7,45},{8,45}]',4909001,0,2,'[]',0),(4909002,10,'荆棘主宰','丛林突围排名1等奖',3,172800,0,4909002,'[{2,5400},{1,270},{7,65},{8,65}]',4909002,0,3,'[]',0),(4909003,10,'荆棘使者','丛林突围排名3等奖',3,172800,0,4909003,'[{2,2400},{1,120},{7,30},{8,30}]',4909003,0,2,'[]',0),(4910001,11,'屠魔战神','取得荣耀战神伤害排名第1',3,86400,0,4910001,'[{2,3600},{1,180},{5,45},{6,45}]',4910001,0,2,'[]',0),(4910002,11,'致命一击','取得荣耀战神活动中夺得最后一击',3,86400,0,4910002,'[{2,3600},{1,180},{7,45},{8,45}]',4910002,0,2,'[]',0),(4911001,12,'不屈青铜','跨服3V3商店积分兑换',3,2419200,0,4911001,'[{2,720},{1,36},{3,18},{4,18}]',4911001,0,1,'[]',0),(4911002,12,'倔强白银','跨服3V3商店积分兑换',3,2419200,0,4911002,'[{2,1480},{1,74},{3,37},{4,37}]',4911002,0,1,'[]',0),(4911003,12,'英勇黄金','跨服3V3商店积分兑换',3,2419200,0,4911003,'[{2,2320},{1,116},{3,58},{4,58}]',4911003,0,2,'[]',0),(4911004,12,'华贵铂金','跨服3V3商店积分兑换',3,2419200,0,4911004,'[{2,3200},{1,160},{3,80},{4,80}]',4911004,0,2,'[]',0),(4911005,12,'永恒钻石','跨服3V3商店积分兑换',3,2419200,0,4911005,'[{2,4200},{1,210},{3,105},{4,105}]',4911005,0,2,'[]',0),(4911006,12,'荣耀王者','跨服3V3商店积分兑换',3,2419200,0,4911006,'[{2,5400},{1,270},{3,135},{4,135}]',4911006,0,3,'[]',0),(4911007,12,'无双传说','跨服3V3商店积分兑换',3,2419200,0,4911007,'[{2,6400},{1,320},{3,160},{4,160}]',4911007,0,3,'[]',0),(4911008,12,'战斗大师','跨服3V3商店积分兑换',3,2419200,0,4911008,'[{2,7600},{1,380},{3,190},{4,190}]',4911008,0,3,'[]',0),(4911009,12,'传说战神','跨服3V3中总排名第3名赛季奖励',3,2419200,0,4911009,'[{2,8600},{1,430},{3,215},{4,215}]',4911009,0,3,'[]',0),(4911010,12,'无冕之王','跨服3V3中总排名第2名赛季奖励',3,2419200,0,4911010,'[{2,10800},{1,540},{3,270},{4,270}]',4911010,0,3,'[]',0),(4911011,12,'战争之王','跨服3V3中总排名第1名赛季奖励',3,2419200,0,4911011,'[{2,13000},{1,650},{3,325},{4,325}]',4911011,0,4,'[]',0),(4912001,13,'以一当十','获得跨服1VN第3名',3,604800,0,4912001,'[{2,4600},{1,230},{3,115},{4,115}]',4912001,0,2,'[]',0),(4912002,13,'一骑当千','获得跨服1VN第2名',3,604800,0,4912002,'[{2,8600},{1,430},{3,215},{4,215}]',4912002,0,3,'[]',0),(4912003,13,'浴血屠戮','获得跨服1VN第1名',3,604800,0,4912003,'[{2,12000},{1,600},{3,300},{4,300}]',4912003,0,4,'[]',0),(4912004,13,'无人之境','获得跨服1VN七轮守擂全胜',3,604800,0,4912004,'[{2,5400},{1,270},{3,135},{4,135}]',4912004,0,3,'[]',0),(4913001,14,'巅峰荣耀','获得巅峰竞技3等奖',3,1209600,0,4913001,'[{2,3600},{1,180},{3,90},{4,90}]',4913001,0,2,'[]',0),(4913002,14,'巅峰战神','获得巅峰竞技2等奖',3,1209600,0,4913002,'[{2,5400},{1,270},{3,135},{4,135}]',4913002,0,3,'[]',0),(4913003,14,'世界之巅','获得巅峰竞技1等奖',3,1209600,0,4913003,'[{2,7000},{1,350},{3,175},{4,175}]',4913003,0,4,'[]',0),(4914001,15,'人间兵器','获得跨服争霸击杀排名第3名',3,86400,0,4914001,'[{2,2800},{1,140},{5,35},{6,35}]',4914001,0,2,'[]',0),(4914002,15,'征服者','获得跨服争霸击杀排名第2名',3,86400,0,4914002,'[{2,4300},{1,215},{5,55},{6,55}]',4914002,0,3,'[]',0),(4914003,15,'君王','获得跨服争霸击杀排名第1名',3,86400,0,4914003,'[{2,6400},{1,320},{5,80},{6,80}]',4914003,0,3,'[]',0),(4915001,16,'钻石爱好者','获得钻石大战第3~4名',3,604800,0,4915001,'[{2,3200},{1,160},{5,32},{6,32}]',4915001,0,1,'[]',0),(4915002,16,'钻石收藏家','获得钻石大战第2名',3,604800,0,4915002,'[{2,4800},{1,240},{5,52},{6,52}]',4915002,0,2,'[]',0),(4915003,16,'钻石收割者','钻石大战中获得第1名',3,604800,0,4915003,'[{2,6400},{1,320},{5,80},{6,80}]',4915003,0,3,'[]',0),(4916001,17,'乘风破浪','无尽海域击杀排名第3名',3,604800,0,4916001,'[{2,2800},{1,140},{5,35},{6,35}]',4916001,0,2,'[]',0),(4916002,17,'海域传说','无尽海域击杀排名第2名',3,604800,0,4916002,'[{2,4300},{1,215},{5,55},{6,55}]',4916002,0,3,'[]',0),(4916003,17,'海域霸主','无尽海域击杀排名第1名',3,604800,0,4916003,'[{2,6400},{1,320},{5,80},{6,80}]',4916003,0,4,'[]',0),(4916004,17,'打我是小狗','无尽海域被击败次数最多者',3,604800,0,4916004,'[{2,2000},{1,100},{5,15},{6,15}]',4916004,0,2,'[]',0),(4917001,9,'？？？？','运营活动称号',3,0,0,4917001,'[{2,8000},{1,400},{3,320},{4,320}]',4917001,0,4,'[]',0),(4917002,9,'自带BGM','运营活动称号',3,0,0,4917002,'[{2,6000},{1,300},{7,120},{8,120}]',4917002,0,4,'[]',0),(4917003,9,'幸运之星','运营活动称号',3,0,0,4917003,'[{2,8000},{1,400},{5,160},{6,160}]',4917003,0,4,'[]',0),(4917004,9,'至尊裁决者','运营活动称号',3,0,0,4917004,'[{2,7500},{1,375},{5,150},{6,150}]',4917004,0,4,'[]',0),(4917005,9,'海洋之王','运营活动称号',3,0,0,4917005,'[{2,7500},{1,375},{3,300},{4,300}]',4917005,0,4,'[]',0),(4917006,9,'圣月之光','运营活动称号',3,0,0,4917006,'[{2,7500},{1,375},{7,150},{8,150}]',4917006,0,4,'[]',0),(4917007,9,'萌兔守护者','运营活动称号',3,0,0,4917007,'[{2,7500},{1,375},{3,300},{4,300}]',4917007,0,4,'[]',0),(4917008,9,'黑猫守护者','运营活动称号',3,0,0,4917008,'[{2,7500},{1,375},{5,150},{6,150}]',4917008,0,4,'[]',0),(4917009,9,'小熊守护者','运营活动称号',3,0,0,4917009,'[{2,7500},{1,375},{7,150},{8,150}]',4917009,0,4,'[{2,0,100}]',0),(4917010,9,'蛋蛋的忧伤','运营活动称号',3,0,0,4917010,'[{2,4700},{1,235},{3,188},{4,188}]',4917010,0,3,'[]',0),(4917011,9,'过于优秀','运营活动称号',3,0,0,4917011,'[{2,4700},{1,235},{5,94},{6,94}]',4917011,0,3,'[]',0),(4917012,9,'浪起来','运营活动称号',3,0,0,4917012,'[{2,4700},{1,235},{7,94},{8,94}]',4917012,0,3,'[]',0),(4917013,9,'清凉一夏','运营活动称号',3,0,0,4917013,'[{3,188},{4,188},{5,94},{6,94}]',4917013,0,3,'[]',0),(4918001,18,'战场审判者','三英会战',3,172800,0,4918001,'[{2,2400},{1,120},{7,30},{8,30}]',4918001,0,2,'[]',0),(4918002,18,'战场裁决者','三英会战',3,172800,0,4918002,'[{2,3600},{1,180},{7,45},{8,45}]',4918002,0,2,'[]',0),(4918003,18,'战场掌控者','三英会战',3,172800,0,4918003,'[{2,5700},{1,285},{7,60},{8,60}]',4918003,0,3,'[]',0);
/*!40000 ALTER TABLE `base_dsgt` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_dungeon`
--

DROP TABLE IF EXISTS `base_dungeon`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_dungeon` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本id',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '副本名字@lang@',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本类型##0:普通副本、1:诛仙塔、2:铜钱副本、3:宠物副本、4:经验副本、5：装备副本、6：五行副本、7、塔防副本（预留）',
  `npc_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '入口NPC##NPCID',
  `enter_type` tinyint(1) NOT NULL DEFAULT '0' COMMENT '进入副本模式',
  `cost` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '消耗门票##[{道具ID，数量}]',
  `sweep_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '可扫荡等级##0：不可以扫荡，>0的等级就可以扫荡',
  `sweep_cost` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '扫荡券##[{道具ID,数量}]',
  `level_change_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '关卡切换类型',
  `diff_lv` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '副本难度##0:无,1:普通,2:困难,3:地狱',
  `scene_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '场景id',
  `scene_list` varchar(200) NOT NULL DEFAULT '[]' COMMENT '场景列表## 关联的所有场景',
  `scene_out` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '退出副本##[场景ID，X，Y]',
  `count_deduct` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '次数扣除',
  `revive_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '复活类型(0:不允许复活;1:复活时间叠加;2:复活时间不叠加)',
  `revive_count` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '复活次数',
  `revive_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '复活秒数',
  `wave_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本波数',
  `auto_mon_lv` tinyint(1) NOT NULL DEFAULT '0' COMMENT '怪物等级',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本时间',
  `wait_time` int(11) NOT NULL DEFAULT '0' COMMENT '开始倒计时时间',
  `count_cond` text NOT NULL COMMENT '次数条件##[{类型(1:日次数;2:周次数;3:终身次数;4:每日助战次数), 次数上限}]',
  `condition` text NOT NULL COMMENT '条件##等级，组队，职业，互为异性，任务',
  `open_begin` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开服时段开始天数',
  `open_end` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开服时段结束天数',
  `start_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动开始时间',
  `end_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动结束时间',
  `week_list` varchar(50) NOT NULL DEFAULT '[]' COMMENT '星期开放列表',
  `mon_event` text NOT NULL COMMENT '刷怪事件',
  `story_event` text NOT NULL COMMENT '剧情事件',
  `zone_event` text NOT NULL COMMENT '区域事件',
  `scene_event` text NOT NULL COMMENT '场景事件',
  `success_event` text NOT NULL COMMENT '通关事件',
  `fail_event` text NOT NULL COMMENT '失败事件',
  `dynamic_attr` text NOT NULL COMMENT '动态属性',
  `recommend_power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '推荐战力',
  `recommend_attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '推荐攻击力',
  `is_use_power_crush` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否使用战力碾压',
  `is_use_attr_crush` varchar(512) NOT NULL DEFAULT '[]' COMMENT '碾压属性',
  `buy_count_cost` varchar(2048) NOT NULL DEFAULT '[]' COMMENT '次数购买消耗',
  `reward_show` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励展示',
  `free_sweep` int(11) NOT NULL DEFAULT '0' COMMENT '免费扫荡次数',
  `buy_sweep_cost` varchar(2048) NOT NULL DEFAULT '[]' COMMENT '扫荡次数购买',
  `flop_cost` varchar(512) NOT NULL DEFAULT '[]' COMMENT '翻牌消耗',
  `flop_reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '翻牌奖池',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='副本配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_dungeon`
--

LOCK TABLES `base_dungeon` WRITE;
/*!40000 ALTER TABLE `base_dungeon` DISABLE KEYS */;
INSERT INTO `base_dungeon` VALUES (1002,'梦魇深处',0,0,0,'[]',0,'[]',0,0,7500,'[]','[]',1,2,0,10,1,0,600,1,'[]','[{num,1,1},{lv,10},{safe_scene}]',0,0,0,0,'[]','[{7500,[{1,1,[],[{dungeon_time,0}]},{2,2,[],[{dungeon_time,0}]}]}]','[]','[]','[{7500,[{1,[{revive,3982,3578}],[]}]}]','[{7500,[{0,[{quit_time,8}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7500,[{0,[],[{dungeon_timeout}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(1003,'女王魔林',0,0,0,'[]',0,'[]',0,0,10009,'[]','[]',2,2,0,5,2,0,600,1,'[{3,1}]','[{num,1,1},{lv,10},{safe_scene}]',0,0,0,0,'[]','[{10009,[{1,1,[],[{dungeon_time,0}]}]}]','[]','[]','[{10009,[{1,[{revive,11625,10075}],[]}]}]','[{10009,[{0,[{quit_time,8}],[{mon_event_id_kill_all_mon,1}]}]}]','[{10009,[{0,[],[{dungeon_timeout}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(2101,'日常副本',0,0,0,'[]',0,'[]',0,0,5303,'[]','[]',2,2,0,5,2,1,600,4,'[]','[{num,1,1},{lv,10},{safe_scene}]',0,0,0,0,'[]','[{5303,[{1,1,[],[{dungeon_time,3}]},{2,2,[],[{mon_event_id_kill_all_mon,1}]}]}]','[]','[]','[{5303,[{1,[{revive,3982,3578}],[]}]}]','[{5303,[{0,[{quit_time,5}],[{mon_event_id_kill_all_mon,2}]}]}]','[{5303,[{0,[],[{dungeon_timeout}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(2102,'日常副本',0,0,0,'[]',0,'[]',0,0,5303,'[]','[]',2,2,0,5,2,1,600,4,'[]','[{num,1,1},{lv,15},{safe_scene}]',0,0,0,0,'[]','[{5303,[{1,1,[],[{dungeon_time,3}]},{2,2,[],[{mon_event_id_kill_all_mon,1}]}]}]','[]','[]','[{5303,[{1,[{revive,3982,3578}],[]}]}]','[{5303,[{0,[{quit_time,5}],[{mon_event_id_kill_all_mon,2}]}]}]','[{5303,[{0,[],[{dungeon_timeout}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(2103,'日常副本',0,0,0,'[]',0,'[]',0,0,2102,'[]','[]',2,2,0,5,2,0,600,0,'[]','[{num,1,1},{lv,20},{safe_scene}]',0,0,0,0,'[]','[{2102,[{1,1,[],[]},{2,2,[],[{mon_event_id_kill_all_mon,1}]}]}]','[]','[]','[{2102,[{1,[{revive,4804,3630}],[]}]}]','[{2102,[{0,[{quit_time,5}],[{mon_event_id_kill_all_mon,2}]}]}]','[{2102,[{0,[],[{dungeon_timeout}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(2104,'日常副本',0,0,0,'[]',0,'[]',0,0,2107,'[]','[]',2,2,0,5,2,0,600,0,'[]','[{num,1,1},{lv,25},{safe_scene}]',0,0,0,0,'[]','[{2107,[{1,1,[],[]},{2,2,[],[{mon_event_id_kill_all_mon,1}]}]}]','[]','[]','[{2107,[{1,[{revive,2570,2902}],[]}]}]','[{2107,[{0,[{quit_time,5}],[{mon_event_id_kill_all_mon,2}]}]}]','[{2107,[{0,[],[{dungeon_timeout}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(2105,'日常副本',0,0,0,'[]',0,'[]',0,0,2102,'[]','[]',2,2,0,5,2,0,600,0,'[]','[{num,1,1},{lv,30},{safe_scene}]',0,0,0,0,'[]','[{2102,[{1,1,[],[]},{2,2,[],[{mon_event_id_kill_all_mon,1}]}]}]','[]','[]','[{2102,[{1,[{revive,921,553}],[]}]}]','[{2102,[{0,[{quit_time,5}],[{mon_event_id_kill_all_mon,2}]}]}]','[{2102,[{0,[],[{dungeon_timeout}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(2106,'公会副本',0,0,0,'[]',0,'[]',0,0,2105,'[]','[]',2,2,0,5,2,0,600,0,'[]','[{num,1,1},{lv,35},{safe_scene}]',0,0,0,0,'[]','[{2105,[{1,1,[],[]},{2,2,[],[{mon_event_id_kill_all_mon,1}]}]}]','[]','[]','[{2105,[{1,[{revive,2978,701}],[]}]}]','[{2105,[{0,[{quit_time,2}],[{mon_event_id_kill_all_mon,2}]}]}]','[{2105,[{0,[],[{dungeon_timeout}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(2107,'公会副本',0,0,0,'[]',0,'[]',0,0,2104,'[]','[]',2,2,0,5,2,0,600,0,'[]','[{num,1,1},{lv,40},{safe_scene}]',0,0,0,0,'[]','[{2104,[{1,1,[],[]},{2,2,[],[{mon_event_id_kill_all_mon,1}]}]}]','[]','[]','[{2104,[{1,[{revive,973,713}],[]}]}]','[{2104,[{0,[{quit_time,2}],[{mon_event_id_kill_all_mon,2}]}]}]','[{2104,[{0,[],[{dungeon_timeout}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(2108,'公会副本',0,0,0,'[]',0,'[]',0,0,2108,'[]','[]',2,2,0,5,2,0,600,0,'[]','[{num,1,1},{lv,45},{safe_scene}]',0,0,0,0,'[]','[{2108,[{1,1,[],[]},{2,2,[],[{mon_event_id_kill_all_mon,1}]}]}]','[]','[]','[{2108,[{1,[{revive,1868,2814}],[]}]}]','[{2108,[{0,[{quit_time,2}],[{mon_event_id_kill_all_mon,2}]}]}]','[{2108,[{0,[],[{dungeon_timeout}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(2109,'公会副本',0,0,0,'[]',0,'[]',0,0,2101,'[]','[]',2,2,0,5,2,0,600,0,'[]','[{num,1,1},{lv,10},{safe_scene}]',0,0,0,0,'[]','[{2101,[{1,1,[],[]},{2,2,[],[{mon_event_id_kill_all_mon,1}]}]}]','[]','[]','[{2101,[{1,[{revive,893,725}],[]}]}]','[{2101,[{0,[{quit_time,2}],[{mon_event_id_kill_all_mon,2}]}]}]','[{2101,[{0,[],[{dungeon_timeout}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(2110,'公会副本',0,0,0,'[]',0,'[]',0,0,2106,'[]','[]',2,2,0,5,2,0,600,0,'[]','[{num,1,1},{lv,15},{safe_scene}]',0,0,0,0,'[]','[{2106,[{1,1,[],[]},{2,2,[],[{mon_event_id_kill_all_mon,1}]}]}]','[]','[]','[{2106,[{1,[{revive,1204,1513}],[]}]}]','[{2106,[{0,[{quit_time,2}],[{mon_event_id_kill_all_mon,2}]}]}]','[{2106,[{0,[],[{dungeon_timeout}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(2201,'勇者试炼Ⅰ',15,0,0,'[]',0,'[]',0,0,7501,'[]','[]',2,0,0,0,1,0,90,4,'[]','[{num,1,1},{lv,45},{safe_scene}]',0,0,0,0,'[]','[{7501,[{1,1,[],[{dungeon_time,7}]}]}]','[{7501,[{1,[7501,2,[]],[{dungeon_time,0}]}]}]','[]','[{7501,[{1,[{revive,3982,3578}],[]}]}]','[{7501,[{0,[{quit_time,8}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7501,[{0,[],[{dungeon_timeout}]},{0,[],[{role_hp_rate,0}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(2202,'勇者试炼Ⅱ',15,0,0,'[]',0,'[]',0,0,7501,'[]','[]',2,0,0,0,1,0,90,3,'[]','[{num,1,1},{lv,10},{safe_scene}]',0,0,0,0,'[]','[{7501,[{1,1,[],[{dungeon_time,7}]}]}]','[{7501,[{1,[7501,3,[]],[{dungeon_time,0}]}]}]','[]','[{7501,[{1,[{revive,3982,3578}],[]}]}]','[{7501,[{0,[{quit_time,8}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7501,[{0,[],[{dungeon_timeout}]},{0,[],[{role_hp_rate,0}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(2203,'勇者试炼Ⅲ',15,0,0,'[]',0,'[]',0,0,7100,'[]','[]',2,0,0,0,1,0,90,3,'[]','[{num,1,1},{lv,11},{safe_scene}]',0,0,0,0,'[]','[{7100,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7100,[{1,[{revive,3982,3578}],[]}]}]','[{7100,[{0,[{quit_time,8}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7100,[{0,[],[{dungeon_timeout}]},{0,[],[{role_hp_rate,0}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(2204,'勇者试炼Ⅳ',15,0,0,'[]',0,'[]',0,0,7100,'[]','[]',2,0,0,0,1,0,90,3,'[]','[{num,1,1},{lv,12},{safe_scene}]',0,0,0,0,'[]','[{7100,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7100,[{1,[{revive,3982,3578}],[]}]}]','[{7100,[{0,[{quit_time,8}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7100,[{0,[],[{dungeon_timeout}]},{0,[],[{role_hp_rate,0}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(2205,'勇者试炼Ⅴ',15,0,0,'[]',0,'[]',0,0,7100,'[]','[]',2,0,0,0,1,0,90,0,'[]','[{num,1,1},{lv,245},{safe_scene}]',0,0,0,0,'[]','[{7100,[{1,1,[],[{dungeon_time,12}]}]}]','[]','[]','[{7100,[{1,[{revive,3982,3578}],[]}]}]','[{7100,[{0,[{quit_time,8}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7100,[{0,[],[{dungeon_timeout}]},{0,[],[{role_hp_rate,0}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(2301,'转生试炼Ⅰ',16,0,0,'[]',0,'[]',0,0,10006,'[]','[]',2,0,0,0,1,0,180,4,'[]','[{num,1,1},{lv,150},{safe_scene}]',0,0,0,0,'[]','[{10006,[{1,1,[],[{dungeon_time,4}]}]}]','[]','[]','[{10006,[{1,[{revive,2996,16494}],[]}]}]','[{10006,[{0,[{quit_time,8}],[{mon_event_id_kill_all_mon,1}]}]}]','[{10006,[{0,[],[{dungeon_timeout}]},{0,[],[{role_hp_rate,0}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(2302,'转生试炼Ⅱ',16,0,0,'[]',0,'[]',0,0,10008,'[]','[]',2,0,0,0,1,0,180,4,'[]','[{num,1,1},{lv,220},{safe_scene}]',0,0,0,0,'[]','[{10008,[{1,1,[],[{dungeon_time,4}]}]}]','[]','[]','[{10008,[{1,[{revive,12200,12100}],[]}]}]','[{10008,[{0,[{quit_time,8}],[{mon_event_id_kill_all_mon,1}]}]}]','[{10008,[{0,[],[{dungeon_timeout}]},{0,[],[{role_hp_rate,0}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(2303,'转生试炼Ⅲ',16,0,0,'[]',0,'[]',0,0,10009,'[]','[]',2,0,0,0,1,0,180,4,'[]','[{num,1,1},{lv,280},{safe_scene}]',0,0,0,0,'[]','[{10009,[{1,1,[],[{dungeon_time,4}]}]}]','[]','[]','[{10009,[{1,[{revive,11300,10100}],[]}]}]','[{10009,[{0,[{quit_time,8}],[{mon_event_id_kill_all_mon,1}]}]}]','[{10009,[{0,[],[{dungeon_timeout}]},{0,[],[{role_hp_rate,0}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(2304,'转生试炼Ⅳ',16,0,0,'[]',0,'[]',0,0,7100,'[]','[]',2,0,0,0,1,0,180,4,'[]','[{num,1,1},{lv,280},{safe_scene}]',0,0,0,0,'[]','[{7100,[{1,1,[],[{dungeon_time,4}]}]}]','[]','[]','[{7100,[{1,[{revive,3982,3578}],[]}]}]','[{7100,[{0,[{quit_time,8}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7100,[{0,[],[{dungeon_timeout}]},{0,[],[{role_hp_rate,0}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(2305,'转生试炼Ⅴ',16,0,0,'[]',0,'[]',0,0,7100,'[]','[]',2,0,0,0,1,0,180,4,'[]','[{num,1,1},{lv,280},{safe_scene}]',0,0,0,0,'[]','[{7100,[{1,1,[],[{dungeon_time,4}]}]}]','[]','[]','[{7100,[{1,[{revive,3982,3578}],[]}]}]','[{7100,[{0,[{quit_time,8}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7100,[{0,[],[{dungeon_timeout}]},{0,[],[{role_hp_rate,0}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(3000,'经验宝库（旧）',4,0,0,'[{38030001,1}]',0,'[]',0,0,3000,'[3000]','[]',1,2,0,5,1,1,312,0,'[{1,2}]','[{num,1,3},{lv,70},{safe_scene}]',0,0,0,0,'[]','[{3000,[{1,1,[],[{dungeon_time,12}]}]},{3000,[{2,2,[],[{dungeon_time,12}]}]},{3000,[{3,3,[],[{dungeon_time,12}]}]},{3000,[{4,4,[],[{dungeon_time,12}]}]},{3000,[{5,5,[],[{dungeon_time,12}]}]},{3000,[{6,6,[],[{dungeon_time,12}]}]},{3000,[{7,7,[],[{dungeon_time,12}]}]}]','[]','[]','[{3000,[{1,[{revive,4934,4299}],[]}]}]','[{3000,[{0,[],[{dungeon_timeout}]}]}]','[]','[]',0,'[]',0,'[]','[{1,50},{2,60},{3,70},{4,80},{5,90}]','[]',0,'[]','[]','[]'),(3001,'经验副本',4,0,0,'[{38030001,1}]',0,'[]',0,0,3000,'[3000]','[]',1,2,0,5,5,1,312,0,'[{1,2}]','[{num,1,1},{lv,70},{safe_scene}]',0,0,0,0,'[]','[{3000,[{1,1,[{wave_no,1,5}],[{dungeon_time,10}]}]},{3000,[{2,2,[{wave_no,1,5}],[{dungeon_time,10}]}]},{3000,[{3,3,[{wave_no,1,5}],[{dungeon_time,10}]}]},{3000,[{4,4,[{wave_no,1,5}],[{dungeon_time,10}]}]},{3000,[{5,5,[{wave_no,1,5}],[{dungeon_time,10}]}]},{3000,[{6,6,[{wave_no,1,5}],[{dungeon_time,10}]}]},{3000,[{7,7,[{wave_no,1,5}],[{dungeon_time,10}]}]},{3000,[{8,8,[{wave_no,1,5}],[{dungeon_time,10}]}]},{3000,[{9,9,[{wave_no,1,5}],[{dungeon_time,10}]}]},{3000,[{10,10,[{wave_no,2,5}],[{kill_mon_num,30010101,32}]}]},{3000,[{11,11,[{wave_no,2,5}],[{kill_mon_num,30010102,32}]}]},{3000,[{12,12,[{wave_no,2,5}],[{kill_mon_num,30010103,32}]}]},{3000,[{13,13,[{wave_no,2,5}],[{kill_mon_num,30010104,32}]}]},{3000,[{14,14,[{wave_no,2,5}],[{kill_mon_num,30010105,32}]}]},{3000,[{15,15,[{wave_no,2,5}],[{kill_mon_num,30010106,32}]}]},{3000,[{16,16,[{wave_no,2,5}],[{kill_mon_num,30010107,32}]}]},{3000,[{17,17,[{wave_no,2,5}],[{kill_mon_num,30010108,32}]}]},{3000,[{18,18,[{wave_no,2,5}],[{kill_mon_num,30010109,32}]}]},{3000,[{19,19,[{wave_no,3,5}],[{kill_mon_num,30010201,11}]}]},{3000,[{20,20,[{wave_no,3,5}],[{kill_mon_num,30010202,11}]}]},{3000,[{21,21,[{wave_no,3,5}],[{kill_mon_num,30010203,11}]}]},{3000,[{22,22,[{wave_no,3,5}],[{kill_mon_num,30010204,11}]}]},{3000,[{23,23,[{wave_no,3,5}],[{kill_mon_num,30010205,11}]}]},{3000,[{24,24,[{wave_no,3,5}],[{kill_mon_num,30010206,11}]}]},{3000,[{25,25,[{wave_no,3,5}],[{kill_mon_num,30010207,11}]}]},{3000,[{26,26,[{wave_no,3,5}],[{kill_mon_num,30010208,11}]}]},{3000,[{27,27,[{wave_no,3,5}],[{kill_mon_num,30010209,11}]}]},{3000,[{28,28,[{wave_no,4,5}],[{kill_mon_num,30010301,5}]}]},{3000,[{29,29,[{wave_no,4,5}],[{kill_mon_num,30010302,5}]}]},{3000,[{30,30,[{wave_no,4,5}],[{kill_mon_num,30010303,5}]}]},{3000,[{31,31,[{wave_no,4,5}],[{kill_mon_num,30010304,5}]}]},{3000,[{32,32,[{wave_no,4,5}],[{kill_mon_num,30010305,5}]}]},{3000,[{33,33,[{wave_no,4,5}],[{kill_mon_num,30010306,5}]}]},{3000,[{34,34,[{wave_no,4,5}],[{kill_mon_num,30010307,5}]}]},{3000,[{35,35,[{wave_no,4,5}],[{kill_mon_num,30010308,5}]}]},{3000,[{36,36,[{wave_no,4,5}],[{kill_mon_num,30010309,5}]}]},{3000,[{37,37,[{wave_no,5,5}],[{kill_mon_num,30010401,5}]}]},{3000,[{38,38,[{wave_no,5,5}],[{kill_mon_num,30010402,5}]}]},{3000,[{39,39,[{wave_no,5,5}],[{kill_mon_num,30010403,5}]}]},{3000,[{40,40,[{wave_no,5,5}],[{kill_mon_num,30010404,5}]}]},{3000,[{41,41,[{wave_no,5,5}],[{kill_mon_num,30010405,5}]}]},{3000,[{42,42,[{wave_no,5,5}],[{kill_mon_num,30010406,5}]}]},{3000,[{43,43,[{wave_no,5,5}],[{kill_mon_num,30010407,5}]}]},{3000,[{44,44,[{wave_no,5,5}],[{kill_mon_num,30010408,5}]}]},{3000,[{45,45,[{wave_no,5,5}],[{kill_mon_num,30010409,5}]}]}]','[]','[]','[{3000,[{1,[{revive,4934,4300}],[]}]}]','[{3000,[{0,[],[{dungeon_timeout}]}]}]','[]','[]',5000,'[]',0,'[]','[{1,50},{2,60},{3,70},{4,80},{5,90}]','[]',0,'[]','[]','[]'),(3002,'经验副本',23,0,0,'[]',0,'[]',0,0,3000,'[3000]','[]',2,2,0,5,1,1,312,5,'[{3,1}]','[{num,1,1},{lv,60},{safe_scene}]',0,0,0,0,'[]','[{3000,[{1,1,[{wave_no,1,5}],[{dungeon_time,3}]}]},{3000,[{2,2,[{wave_no,1,5}],[{dungeon_time,3}]}]},{3000,[{3,3,[{wave_no,1,5}],[{dungeon_time,3}]}]},{3000,[{4,4,[{wave_no,1,5}],[{dungeon_time,3}]}]},{3000,[{5,5,[{wave_no,1,5}],[{dungeon_time,3}]}]}]','[]','[]','[{3000,[{1,[{revive,4934,4301}],[]}]}]','[{3000,[{0,[{quit_time,2}],[{kill_mon_num,3002001,200}]}]}]','[{3000,[{0,[{quit_time,2}],[{dungeon_timeout}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(3003,'经验副本（旧）',4,0,0,'[{38030008,1}]',0,'[]',0,0,3000,'[3000]','[]',1,2,0,5,1,1,312,0,'[]','[{num,1,1},{lv,70},{safe_scene}]',0,0,0,0,'[]','[{3000,[{1,1,[{wave_no,1,9}],[{dungeon_time,10}]}]},{3000,[{2,2,[{wave_no,1,9}],[{dungeon_time,10}]}]},{3000,[{3,3,[{wave_no,1,9}],[{dungeon_time,10}]}]},{3000,[{4,4,[{wave_no,1,9}],[{dungeon_time,10}]}]},{3000,[{5,5,[{wave_no,1,9}],[{dungeon_time,10}]}]},{3000,[{6,6,[{wave_no,1,9}],[{dungeon_time,10}]}]},{3000,[{7,7,[{wave_no,1,9}],[{dungeon_time,10}]}]},{3000,[{8,8,[{wave_no,1,9}],[{dungeon_time,10}]}]},{3000,[{9,9,[{wave_no,1,9}],[{dungeon_time,10}]}]},{3000,[{10,10,[{wave_no,2,9}],[{kill_mon_num,30010101,32}]}]},{3000,[{11,11,[{wave_no,2,9}],[{kill_mon_num,30010102,32}]}]},{3000,[{12,12,[{wave_no,2,9}],[{kill_mon_num,30010103,32}]}]},{3000,[{13,13,[{wave_no,2,9}],[{kill_mon_num,30010104,32}]}]},{3000,[{14,14,[{wave_no,2,9}],[{kill_mon_num,30010105,32}]}]},{3000,[{15,15,[{wave_no,2,9}],[{kill_mon_num,30010106,32}]}]},{3000,[{16,16,[{wave_no,2,9}],[{kill_mon_num,30010107,32}]}]},{3000,[{17,17,[{wave_no,2,9}],[{kill_mon_num,30010108,32}]}]},{3000,[{18,18,[{wave_no,2,9}],[{kill_mon_num,30010109,32}]}]},{3000,[{19,19,[{wave_no,3,9}],[{kill_mon_num,30010201,11}]}]},{3000,[{20,20,[{wave_no,3,9}],[{kill_mon_num,30010202,11}]}]},{3000,[{21,21,[{wave_no,3,9}],[{kill_mon_num,30010203,11}]}]},{3000,[{22,22,[{wave_no,3,9}],[{kill_mon_num,30010204,11}]}]},{3000,[{23,23,[{wave_no,3,9}],[{kill_mon_num,30010205,11}]}]},{3000,[{24,24,[{wave_no,3,9}],[{kill_mon_num,30010206,11}]}]},{3000,[{25,25,[{wave_no,3,9}],[{kill_mon_num,30010207,11}]}]},{3000,[{26,26,[{wave_no,3,9}],[{kill_mon_num,30010208,11}]}]},{3000,[{27,27,[{wave_no,3,9}],[{kill_mon_num,30010209,11}]}]},{3000,[{28,28,[{wave_no,4,9}],[{kill_mon_num,30010301,5}]}]},{3000,[{29,29,[{wave_no,4,9}],[{kill_mon_num,30010302,5}]}]},{3000,[{30,30,[{wave_no,4,9}],[{kill_mon_num,30010303,5}]}]},{3000,[{31,31,[{wave_no,4,9}],[{kill_mon_num,30010304,5}]}]},{3000,[{32,32,[{wave_no,4,9}],[{kill_mon_num,30010305,5}]}]},{3000,[{33,33,[{wave_no,4,9}],[{kill_mon_num,30010306,5}]}]},{3000,[{34,34,[{wave_no,4,9}],[{kill_mon_num,30010307,5}]}]},{3000,[{35,35,[{wave_no,4,9}],[{kill_mon_num,30010308,5}]}]},{3000,[{36,36,[{wave_no,4,9}],[{kill_mon_num,30010309,5}]}]},{3000,[{37,37,[{wave_no,5,9}],[{kill_mon_num,30010401,5}]}]},{3000,[{38,38,[{wave_no,5,9}],[{kill_mon_num,30010402,5}]}]},{3000,[{39,39,[{wave_no,5,9}],[{kill_mon_num,30010403,5}]}]},{3000,[{40,40,[{wave_no,5,9}],[{kill_mon_num,30010404,5}]}]},{3000,[{41,41,[{wave_no,5,9}],[{kill_mon_num,30010405,5}]}]},{3000,[{42,42,[{wave_no,5,9}],[{kill_mon_num,30010406,5}]}]},{3000,[{43,43,[{wave_no,5,9}],[{kill_mon_num,30010407,5}]}]},{3000,[{44,44,[{wave_no,5,9}],[{kill_mon_num,30010408,5}]}]},{3000,[{45,45,[{wave_no,5,9}],[{kill_mon_num,30010409,5}]}]}]','[]','[]','[{3000,[{1,[{revive,4934,4302}],[]}]}]','[{3000,[{0,[],[{dungeon_timeout}]}]}]','[]','[]',5000,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(3110,'装备副本',5,0,0,'[]',0,'[]',0,0,3115,'[3115]','[]',1,2,0,9,4,0,600,5,'[{1,2},{4,10}]','[{num,1,3},{lv,105},{safe_scene}]',0,0,0,0,'[]','[{3115,[{1,1,[],[{dungeon_time,5}]},{2,2,[],[{mon_event_id_kill_all_mon,1}]},{3,3,[],[{mon_event_id_kill_all_mon,2},{story_finish,2,1}]},{4,4,[],[{mon_event_id_kill_all_mon,3},{story_finish,3,1}]}]}]','[{3115,[{1,[2,1,[{mon,1003001,2752,4919,1}]],[{mon_event_id_kill_all_mon,2}]},{2,[3,1,[{mon,1003001,7382,7639,1}]],[{mon_event_id_kill_all_mon,3}]}]}]','[{3115,[{1,{[{1,0}],[{3,0}]},[{mon_event_id_kill_all_mon,1}]},{2,{[{2,0}],[{2,0}]},[{story_finish,2,1}]},{3,{[{3,0}],[{1,0}]},[{story_finish,3,1}]}]}]','[]','[{3115,[{0,[],[{mon_event_id_kill_all_mon,4}]}]}]','[{3115,[{0,[{quit_time,10}],[{score_grade,0}]},{0,[{quit_time,10}],[{dungeon_timeout}]}]}]','[]',166751,'[]',0,'[]','[]','[{0,1001011132,1},{0,1002010232,1},{0,1004010920,1},{0,1010010941,1}]',0,'[]','[]','[]'),(3111,'装备副本',5,0,0,'[]',0,'[]',0,0,3115,'[3115]','[]',1,2,0,9,4,0,600,5,'[{1,2},{4,10}]','[{num,1,3},{lv,140},{safe_scene}]',0,0,0,0,'[]','[{3115,[{1,1,[],[{dungeon_time,5}]},{2,2,[],[{mon_event_id_kill_all_mon,1}]},{3,3,[],[{mon_event_id_kill_all_mon,2},{story_finish,2,1}]},{4,4,[],[{mon_event_id_kill_all_mon,3},{story_finish,3,1}]}]}]','[{3115,[{1,[2,1,[{mon,1003001,2752,4919,1}]],[{mon_event_id_kill_all_mon,2}]},{2,[3,1,[{mon,1003001,7382,7639,1}]],[{mon_event_id_kill_all_mon,3}]}]}]','[{3115,[{1,{[{1,0}],[{3,0}]},[{mon_event_id_kill_all_mon,1}]},{2,{[{2,0}],[{2,0}]},[{story_finish,2,1}]},{3,{[{3,0}],[{1,0}]},[{story_finish,3,1}]}]}]','[]','[{3115,[{0,[],[{mon_event_id_kill_all_mon,4}]}]}]','[{3115,[{0,[{quit_time,10}],[{score_grade,0}]},{0,[{quit_time,10}],[{dungeon_timeout}]}]}]','[]',204486,'[]',0,'[]','[]','[{0,1001011132,1},{0,1002010232,1},{0,1004010920,1},{0,1010010941,1}]',0,'[]','[]','[]'),(3112,'装备副本',5,0,0,'[]',0,'[]',0,0,3115,'[3115]','[]',1,2,0,9,4,0,600,5,'[{1,2},{4,10}]','[{num,1,3},{lv,200},{safe_scene}]',0,0,0,0,'[]','[{3115,[{1,1,[],[{dungeon_time,5}]},{2,2,[],[{mon_event_id_kill_all_mon,1}]},{3,3,[],[{mon_event_id_kill_all_mon,2},{story_finish,2,1}]},{4,4,[],[{mon_event_id_kill_all_mon,3},{story_finish,3,1}]}]}]','[{3115,[{1,[2,1,[{mon,1003001,2752,4919,1}]],[{mon_event_id_kill_all_mon,2}]},{2,[3,1,[{mon,1003001,7382,7639,1}]],[{mon_event_id_kill_all_mon,3}]}]}]','[{3115,[{1,{[{1,0}],[{3,0}]},[{mon_event_id_kill_all_mon,1}]},{2,{[{2,0}],[{2,0}]},[{story_finish,2,1}]},{3,{[{3,0}],[{1,0}]},[{story_finish,3,1}]}]}]','[]','[{3115,[{0,[],[{mon_event_id_kill_all_mon,4}]}]}]','[{3115,[{0,[{quit_time,10}],[{score_grade,0}]},{0,[{quit_time,10}],[{dungeon_timeout}]}]}]','[]',529521,'[]',0,'[]','[]','[{0,1001011132,1},{0,1002010232,1},{0,1004010920,1},{0,1010010941,1}]',0,'[]','[]','[]'),(3113,'装备副本',5,0,0,'[]',0,'[]',0,0,3115,'[3115]','[]',1,2,0,9,4,0,600,5,'[{1,2},{4,10}]','[{num,1,3},{lv,240},{safe_scene}]',0,0,0,0,'[]','[{3115,[{1,1,[],[{dungeon_time,5}]},{2,2,[],[{mon_event_id_kill_all_mon,1}]},{3,3,[],[{mon_event_id_kill_all_mon,2},{story_finish,2,1}]},{4,4,[],[{mon_event_id_kill_all_mon,3},{story_finish,3,1}]}]}]','[{3115,[{1,[2,1,[{mon,1003001,2752,4919,1}]],[{mon_event_id_kill_all_mon,2}]},{2,[3,1,[{mon,1003001,7382,7639,1}]],[{mon_event_id_kill_all_mon,3}]}]}]','[{3115,[{1,{[{1,0}],[{3,0}]},[{mon_event_id_kill_all_mon,1}]},{2,{[{2,0}],[{2,0}]},[{story_finish,2,1}]},{3,{[{3,0}],[{1,0}]},[{story_finish,3,1}]}]}]','[]','[{3115,[{0,[],[{mon_event_id_kill_all_mon,4}]}]}]','[{3115,[{0,[{quit_time,10}],[{score_grade,0}]},{0,[{quit_time,10}],[{dungeon_timeout}]}]}]','[]',1046145,'[]',0,'[]','[]','[{0,1001011132,1},{0,1002010232,1},{0,1004010920,1},{0,1010010941,1}]',0,'[]','[]','[]'),(3114,'装备副本',5,0,0,'[]',0,'[]',0,0,3115,'[3115]','[]',1,2,0,9,4,0,600,5,'[{1,2},{4,10}]','[{num,1,3},{lv,300},{safe_scene}]',0,0,0,0,'[]','[{3115,[{1,1,[],[{dungeon_time,5}]},{2,2,[],[{mon_event_id_kill_all_mon,1}]},{3,3,[],[{mon_event_id_kill_all_mon,2},{story_finish,2,1}]},{4,4,[],[{mon_event_id_kill_all_mon,3},{story_finish,3,1}]}]}]','[{3115,[{1,[2,1,[{mon,1003001,2752,4919,1}]],[{mon_event_id_kill_all_mon,2}]},{2,[3,1,[{mon,1003001,7382,7639,1}]],[{mon_event_id_kill_all_mon,3}]}]}]','[{3115,[{1,{[{1,0}],[{3,0}]},[{mon_event_id_kill_all_mon,1}]},{2,{[{2,0}],[{2,0}]},[{story_finish,2,1}]},{3,{[{3,0}],[{1,0}]},[{story_finish,3,1}]}]}]','[]','[{3115,[{0,[],[{mon_event_id_kill_all_mon,4}]}]}]','[{3115,[{0,[{quit_time,10}],[{score_grade,0}]},{0,[{quit_time,10}],[{dungeon_timeout}]}]}]','[]',2332252,'[]',0,'[]','[]','[{0,1001011132,1},{0,1002010232,1},{0,1004010920,1},{0,1010010941,1}]',0,'[]','[]','[]'),(3115,'装备副本',5,0,0,'[]',0,'[]',0,0,3115,'[3115]','[]',1,2,0,9,4,0,600,5,'[{1,2},{4,10}]','[{num,1,3},{lv,350},{safe_scene}]',0,0,0,0,'[]','[{3115,[{1,1,[],[{dungeon_time,5}]},{2,2,[],[{mon_event_id_kill_all_mon,1}]},{3,3,[],[{mon_event_id_kill_all_mon,2},{story_finish,2,1}]},{4,4,[],[{mon_event_id_kill_all_mon,3},{story_finish,3,1}]}]}]','[{3115,[{1,[2,1,[{mon,1003001,2752,4919,1}]],[{mon_event_id_kill_all_mon,2}]},{2,[3,1,[{mon,1003001,7382,7639,1}]],[{mon_event_id_kill_all_mon,3}]}]}]','[{3115,[{1,{[{1,0}],[{3,0}]},[{mon_event_id_kill_all_mon,1}]},{2,{[{2,0}],[{2,0}]},[{story_finish,2,1}]},{3,{[{3,0}],[{1,0}]},[{story_finish,3,1}]}]}]','[]','[{3115,[{0,[],[{mon_event_id_kill_all_mon,4}]}]}]','[{3115,[{0,[{quit_time,10}],[{score_grade,0}]},{0,[{quit_time,10}],[{dungeon_timeout}]}]}]','[]',3698115,'[]',0,'[]','[]','[{0,1001011132,1},{0,1002010232,1},{0,1004010920,1},{0,1010010941,1}]',0,'[]','[]','[]'),(3116,'装备副本',5,0,0,'[]',0,'[]',0,0,3115,'[3115]','[]',1,2,0,9,4,0,600,5,'[{1,2},{4,10}]','[{num,1,3},{lv,400},{safe_scene}]',0,0,0,0,'[]','[{3115,[{1,1,[],[{dungeon_time,5}]},{2,2,[],[{mon_event_id_kill_all_mon,1}]},{3,3,[],[{mon_event_id_kill_all_mon,2},{story_finish,2,1}]},{4,4,[],[{mon_event_id_kill_all_mon,3},{story_finish,3,1}]}]}]','[{3115,[{1,[2,1,[{mon,1003001,2752,4919,1}]],[{mon_event_id_kill_all_mon,2}]},{2,[3,1,[{mon,1003001,7382,7639,1}]],[{mon_event_id_kill_all_mon,3}]}]}]','[{3115,[{1,{[{1,0}],[{3,0}]},[{mon_event_id_kill_all_mon,1}]},{2,{[{2,0}],[{2,0}]},[{story_finish,2,1}]},{3,{[{3,0}],[{1,0}]},[{story_finish,3,1}]}]}]','[]','[{3115,[{0,[],[{mon_event_id_kill_all_mon,4}]}]}]','[{3115,[{0,[{quit_time,10}],[{score_grade,0}]},{0,[{quit_time,10}],[{dungeon_timeout}]}]}]','[]',5703457,'[]',0,'[]','[]','[{0,1001011132,1},{0,1002010232,1},{0,1004010920,1},{0,1010010941,1}]',0,'[]','[]','[]'),(3117,'装备副本',5,0,0,'[]',0,'[]',0,0,3115,'[3115]','[]',1,2,0,9,4,0,600,5,'[{1,2},{4,10}]','[{num,1,3},{lv,450},{safe_scene}]',0,0,0,0,'[]','[{3115,[{1,1,[],[{dungeon_time,5}]},{2,2,[],[{mon_event_id_kill_all_mon,1}]},{3,3,[],[{mon_event_id_kill_all_mon,2},{story_finish,2,1}]},{4,4,[],[{mon_event_id_kill_all_mon,3},{story_finish,3,1}]}]}]','[{3115,[{1,[2,1,[{mon,1003001,2752,4919,1}]],[{mon_event_id_kill_all_mon,2}]},{2,[3,1,[{mon,1003001,7382,7639,1}]],[{mon_event_id_kill_all_mon,3}]}]}]','[{3115,[{1,{[{1,0}],[{3,0}]},[{mon_event_id_kill_all_mon,1}]},{2,{[{2,0}],[{2,0}]},[{story_finish,2,1}]},{3,{[{3,0}],[{1,0}]},[{story_finish,3,1}]}]}]','[]','[{3115,[{0,[],[{mon_event_id_kill_all_mon,4}]}]}]','[{3115,[{0,[{quit_time,10}],[{score_grade,0}]},{0,[{quit_time,10}],[{dungeon_timeout}]}]}]','[]',7435890,'[]',0,'[]','[]','[{0,1001011132,1},{0,1002010232,1},{0,1004010920,1},{0,1010010941,1}]',0,'[]','[]','[]'),(3118,'装备副本',5,0,0,'[]',0,'[]',0,0,3115,'[3115]','[]',1,2,0,9,4,0,600,5,'[{1,2},{4,10}]','[{num,1,3},{lv,500},{safe_scene}]',0,0,0,0,'[]','[{3115,[{1,1,[],[{dungeon_time,5}]},{2,2,[],[{mon_event_id_kill_all_mon,1}]},{3,3,[],[{mon_event_id_kill_all_mon,2},{story_finish,2,1}]},{4,4,[],[{mon_event_id_kill_all_mon,3},{story_finish,3,1}]}]}]','[{3115,[{1,[2,1,[{mon,1003001,2752,4919,1}]],[{mon_event_id_kill_all_mon,2}]},{2,[3,1,[{mon,1003001,7382,7639,1}]],[{mon_event_id_kill_all_mon,3}]}]}]','[{3115,[{1,{[{1,0}],[{3,0}]},[{mon_event_id_kill_all_mon,1}]},{2,{[{2,0}],[{2,0}]},[{story_finish,2,1}]},{3,{[{3,0}],[{1,0}]},[{story_finish,3,1}]}]}]','[]','[{3115,[{0,[],[{mon_event_id_kill_all_mon,4}]}]}]','[{3115,[{0,[{quit_time,10}],[{score_grade,0}]},{0,[{quit_time,10}],[{dungeon_timeout}]}]}]','[]',10075953,'[]',0,'[]','[]','[{0,1001011132,1},{0,1002010232,1},{0,1004010920,1},{0,1010010941,1}]',0,'[]','[]','[]'),(3119,'装备副本',5,0,0,'[]',0,'[]',0,0,3115,'[3115]','[]',1,2,0,9,4,0,600,5,'[{1,2},{4,10}]','[{num,1,3},{lv,580},{safe_scene}]',0,0,0,0,'[]','[{3115,[{1,1,[],[{dungeon_time,5}]},{2,2,[],[{mon_event_id_kill_all_mon,1}]},{3,3,[],[{mon_event_id_kill_all_mon,2},{story_finish,2,1}]},{4,4,[],[{mon_event_id_kill_all_mon,3},{story_finish,3,1}]}]}]','[{3115,[{1,[2,1,[{mon,1003001,2752,4919,1}]],[{mon_event_id_kill_all_mon,2}]},{2,[3,1,[{mon,1003001,7382,7639,1}]],[{mon_event_id_kill_all_mon,3}]}]}]','[{3115,[{1,{[{1,0}],[{3,0}]},[{mon_event_id_kill_all_mon,1}]},{2,{[{2,0}],[{2,0}]},[{story_finish,2,1}]},{3,{[{3,0}],[{1,0}]},[{story_finish,3,1}]}]}]','[]','[{3115,[{0,[],[{mon_event_id_kill_all_mon,4}]}]}]','[{3115,[{0,[{quit_time,10}],[{score_grade,0}]},{0,[{quit_time,10}],[{dungeon_timeout}]}]}]','[]',15337989,'[]',0,'[]','[]','[{0,1001011132,1},{0,1002010232,1},{0,1004010920,1},{0,1010010941,1}]',0,'[]','[]','[]'),(3120,'装备副本',5,0,0,'[]',0,'[]',0,0,3115,'[3115]','[]',1,2,0,9,4,0,600,5,'[{1,2},{4,10}]','[{num,1,3},{lv,620},{safe_scene}]',0,0,0,0,'[]','[{3115,[{1,1,[],[{dungeon_time,5}]},{2,2,[],[{mon_event_id_kill_all_mon,1}]},{3,3,[],[{mon_event_id_kill_all_mon,2},{story_finish,2,1}]},{4,4,[],[{mon_event_id_kill_all_mon,3},{story_finish,3,1}]}]}]','[{3115,[{1,[2,1,[{mon,1003001,2752,4919,1}]],[{mon_event_id_kill_all_mon,2}]},{2,[3,1,[{mon,1003001,7382,7639,1}]],[{mon_event_id_kill_all_mon,3}]}]}]','[{3115,[{1,{[{1,0}],[{3,0}]},[{mon_event_id_kill_all_mon,1}]},{2,{[{2,0}],[{2,0}]},[{story_finish,2,1}]},{3,{[{3,0}],[{1,0}]},[{story_finish,3,1}]}]}]','[]','[{3115,[{0,[],[{mon_event_id_kill_all_mon,4}]}]}]','[{3115,[{0,[{quit_time,10}],[{score_grade,0}]},{0,[{quit_time,10}],[{dungeon_timeout}]}]}]','[]',18140004,'[]',0,'[]','[]','[{0,1001011132,1},{0,1002010232,1},{0,1004010920,1},{0,1010010941,1}]',0,'[]','[]','[]'),(3121,'装备副本',5,0,0,'[]',0,'[]',0,0,3115,'[3115]','[]',1,2,0,9,4,0,600,5,'[{1,2},{4,10}]','[{num,1,3},{lv,680},{safe_scene}]',0,0,0,0,'[]','[{3115,[{1,1,[],[{dungeon_time,5}]},{2,2,[],[{mon_event_id_kill_all_mon,1}]},{3,3,[],[{mon_event_id_kill_all_mon,2},{story_finish,2,1}]},{4,4,[],[{mon_event_id_kill_all_mon,3},{story_finish,3,1}]}]}]','[{3115,[{1,[2,1,[{mon,1003001,2752,4919,1}]],[{mon_event_id_kill_all_mon,2}]},{2,[3,1,[{mon,1003001,7382,7639,1}]],[{mon_event_id_kill_all_mon,3}]}]}]','[{3115,[{1,{[{1,0}],[{3,0}]},[{mon_event_id_kill_all_mon,1}]},{2,{[{2,0}],[{2,0}]},[{story_finish,2,1}]},{3,{[{3,0}],[{1,0}]},[{story_finish,3,1}]}]}]','[]','[{3115,[{0,[],[{mon_event_id_kill_all_mon,4}]}]}]','[{3115,[{0,[{quit_time,10}],[{score_grade,0}]},{0,[{quit_time,10}],[{dungeon_timeout}]}]}]','[]',22956945,'[]',0,'[]','[]','[{0,1001011132,1},{0,1002010232,1},{0,1004010920,1},{0,1010010941,1}]',0,'[]','[]','[]'),(3122,'装备副本',5,0,0,'[]',0,'[]',0,0,3115,'[3115]','[]',1,2,0,9,4,0,600,5,'[{1,2},{4,10}]','[{num,1,3},{lv,750},{safe_scene}]',0,0,0,0,'[]','[{3115,[{1,1,[],[{dungeon_time,5}]},{2,2,[],[{mon_event_id_kill_all_mon,1}]},{3,3,[],[{mon_event_id_kill_all_mon,2},{story_finish,2,1}]},{4,4,[],[{mon_event_id_kill_all_mon,3},{story_finish,3,1}]}]}]','[{3115,[{1,[2,1,[{mon,1003001,2752,4919,1}]],[{mon_event_id_kill_all_mon,2}]},{2,[3,1,[{mon,1003001,7382,7639,1}]],[{mon_event_id_kill_all_mon,3}]}]}]','[{3115,[{1,{[{1,0}],[{3,0}]},[{mon_event_id_kill_all_mon,1}]},{2,{[{2,0}],[{2,0}]},[{story_finish,2,1}]},{3,{[{3,0}],[{1,0}]},[{story_finish,3,1}]}]}]','[]','[{3115,[{0,[],[{mon_event_id_kill_all_mon,4}]}]}]','[{3115,[{0,[{quit_time,10}],[{score_grade,0}]},{0,[{quit_time,10}],[{dungeon_timeout}]}]}]','[]',28494553,'[]',0,'[]','[]','[{0,1001011132,1},{0,1002010232,1},{0,1004010920,1},{0,1010010941,1}]',0,'[]','[]','[]'),(3300,'洗练副本',22,0,0,'[]',0,'[]',0,0,3300,'[3300]','[]',1,2,0,5,4,0,600,5,'[{1,2},{4,10}]','[{num,1,3},{lv,260},{safe_scene}]',0,0,0,0,'[]','[]','[]','[]','[]','[]','[{3300,[{0,[{quit_time,10}],[{score_grade,0}]},{0,[{quit_time,10}],[{dungeon_timeout}]}]}]','[]',1286052,'[]',0,'[]','[]','[{0,38040002,1},{0,37010004,1}]',0,'[]','[{1,0,[]},{2,0,[{2,0,20}]},{3,0,[{2,0,30}]},{4,1,[{2,0,40}]},{5,4,[{2,0,60}]}]','[{1,[{50,[{0,38260001,9}]},{10,[{0,38250001,1}]},{20,[{0,38260001,11}]},{15,[{0,38260001,16}]},{5,[{0,38260001,13}]}]},{2,[{50,[{0,38260001,10}]},{10,[{0,38250001,1}]},{20,[{0,38260001,11}]},{15,[{0,38260001,17}]},{5,[{0,38260002,1}]}]},{3,[{50,[{0,38260001,10}]},{10,[{0,38250001,1}]},{20,[{0,38260001,12}]},{15,[{0,38260001,18}]},{5,[{0,38260002,1}]}]},{4,[{50,[{0,38260001,11}]},{10,[{0,38250001,1}]},{20,[{0,38260001,13}]},{15,[{0,38260001,19}]},{5,[{0,38260002,1}]}]},{5,[{50,[{0,38260001,11}]},{10,[{0,38250001,1}]},{20,[{0,38260001,14}]},{15,[{0,38260001,20}]},{5,[{0,38260002,1}]}]}]'),(3301,'洗练副本',22,0,0,'[]',0,'[]',0,0,3301,'[3301]','[]',1,2,0,5,4,0,600,5,'[{1,2},{4,10}]','[{num,1,3},{lv,310},{safe_scene}]',0,0,0,0,'[]','[]','[]','[]','[]','[]','[{3301,[{0,[{quit_time,10}],[{score_grade,0}]},{0,[{quit_time,10}],[{dungeon_timeout}]}]}]','[]',2605425,'[]',0,'[]','[]','[{0,38040002,1},{0,37010004,1}]',0,'[]','[{1,0,[]},{2,0,[{2,0,20}]},{3,0,[{2,0,30}]},{4,1,[{2,0,40}]},{5,4,[{2,0,60}]}]','[{1,[{50,[{0,38260001,10}]},{10,[{0,38250001,1}]},{20,[{0,38260001,12}]},{15,[{0,38260001,18}]},{5,[{0,38260001,14}]}]},{2,[{50,[{0,38260001,10}]},{10,[{0,38250001,1}]},{20,[{0,38260001,12}]},{15,[{0,38260001,18}]},{5,[{0,38260002,1}]}]},{3,[{50,[{0,38260001,11}]},{10,[{0,38250001,1}]},{20,[{0,38260001,13}]},{15,[{0,38260001,20}]},{5,[{0,38260002,1}]}]},{4,[{50,[{0,38260001,12}]},{10,[{0,38250001,1}]},{20,[{0,38260001,14}]},{15,[{0,38260001,22}]},{5,[{0,38260002,1}]}]},{5,[{50,[{0,38260001,13}]},{10,[{0,38250001,1}]},{20,[{0,38260001,16}]},{15,[{0,38260001,24}]},{5,[{0,38260002,1}]}]}]'),(3302,'洗练副本',22,0,0,'[]',0,'[]',0,0,3302,'[3302]','[]',1,2,0,5,4,0,600,5,'[{1,2},{4,10}]','[{num,1,3},{lv,350},{safe_scene}]',0,0,0,0,'[]','[]','[]','[]','[]','[]','[{3302,[{0,[{quit_time,10}],[{score_grade,0}]},{0,[{quit_time,10}],[{dungeon_timeout}]}]}]','[]',3698115,'[]',0,'[]','[]','[{0,38040002,1},{0,37010004,1}]',0,'[]','[{1,0,[]},{2,0,[{2,0,20}]},{3,0,[{2,0,30}]},{4,1,[{2,0,40}]},{5,4,[{2,0,60}]}]','[{1,[{50,[{0,38260001,11}]},{10,[{0,38250001,1}]},{20,[{0,38260001,13}]},{15,[{0,38260001,19}]},{5,[{0,38260001,15}]}]},{2,[{50,[{0,38260001,11}]},{10,[{0,38250001,1}]},{20,[{0,38260001,14}]},{15,[{0,38260001,20}]},{5,[{0,38260002,1}]}]},{3,[{50,[{0,38260001,12}]},{10,[{0,38250001,1}]},{20,[{0,38260001,14}]},{15,[{0,38260001,22}]},{5,[{0,38260002,1}]}]},{4,[{50,[{0,38260001,14}]},{10,[{0,38250001,1}]},{20,[{0,38260001,16}]},{15,[{0,38260001,24}]},{5,[{0,38260002,1}]}]},{5,[{50,[{0,38260001,15}]},{10,[{0,38250001,1}]},{20,[{0,38260001,18}]},{15,[{0,38260001,27}]},{5,[{0,38260002,1}]}]}]'),(3303,'洗练副本',22,0,0,'[]',0,'[]',0,0,3303,'[3303]','[]',1,2,0,5,4,0,600,5,'[{1,2},{4,10}]','[{num,1,3},{lv,400},{safe_scene}]',0,0,0,0,'[]','[]','[]','[]','[]','[]','[{3303,[{0,[{quit_time,10}],[{score_grade,0}]},{0,[{quit_time,10}],[{dungeon_timeout}]}]}]','[]',5703457,'[]',0,'[]','[]','[{0,38040002,1},{0,37010004,1}]',0,'[]','[{1,0,[]},{2,0,[{2,0,20}]},{3,0,[{2,0,30}]},{4,1,[{2,0,40}]},{5,4,[{2,0,60}]}]','[{1,[{50,[{0,38260001,11}]},{10,[{0,38250001,1}]},{20,[{0,38260001,14}]},{15,[{0,38260001,20}]},{5,[{0,38260001,16}]}]},{2,[{50,[{0,38260001,12}]},{10,[{0,38250001,1}]},{20,[{0,38260001,15}]},{15,[{0,38260001,22}]},{5,[{0,38260002,1}]}]},{3,[{50,[{0,38260001,13}]},{10,[{0,38250001,1}]},{20,[{0,38260001,16}]},{15,[{0,38260001,24}]},{5,[{0,38260002,1}]}]},{4,[{50,[{0,38260001,15}]},{10,[{0,38250001,1}]},{20,[{0,38260001,18}]},{15,[{0,38260001,27}]},{5,[{0,38260002,1}]}]},{5,[{50,[{0,38260001,17}]},{10,[{0,38250001,1}]},{20,[{0,38260001,20}]},{15,[{0,38260001,31}]},{5,[{0,38260002,1}]}]}]'),(3304,'洗练副本',22,0,0,'[]',0,'[]',0,0,3304,'[3304]','[]',1,2,0,5,4,0,600,5,'[{1,2},{4,10}]','[{num,1,3},{lv,520},{safe_scene}]',0,0,0,0,'[]','[]','[]','[]','[]','[]','[{3304,[{0,[{quit_time,10}],[{score_grade,0}]},{0,[{quit_time,10}],[{dungeon_timeout}]}]}]','[]',11407305,'[]',0,'[]','[]','[{0,38040002,1},{0,37010004,1}]',0,'[]','[{1,0,[]},{2,0,[{2,0,20}]},{3,0,[{2,0,30}]},{4,1,[{2,0,40}]},{5,4,[{2,0,60}]}]','[{1,[{50,[{0,38260001,12}]},{10,[{0,38250001,1}]},{20,[{0,38260001,14}]},{15,[{0,38260001,22}]},{5,[{0,38260001,17}]}]},{2,[{50,[{0,38260001,13}]},{10,[{0,38250001,1}]},{20,[{0,38260001,16}]},{15,[{0,38260001,24}]},{5,[{0,38260002,1}]}]},{3,[{50,[{0,38260001,14}]},{10,[{0,38250001,1}]},{20,[{0,38260001,17}]},{15,[{0,38260001,26}]},{5,[{0,38260002,1}]}]},{4,[{50,[{0,38260001,17}]},{10,[{0,38250001,1}]},{20,[{0,38260001,20}]},{15,[{0,38260001,30}]},{5,[{0,38260002,1}]}]},{5,[{50,[{0,38260001,19}]},{10,[{0,38250001,1}]},{20,[{0,38260001,23}]},{15,[{0,38260001,34}]},{5,[{0,38260002,1}]}]}]'),(4201,'守卫公会',11,0,0,'[]',0,'[]',0,0,42011,'[]','[]',2,2,0,5,8,0,1200,0,'[]','[{lv,115},{safe_scene}]',0,0,0,0,'[]','[{42011,[{1,10,[{is_calc_wave_num,0}],[]},\n    {2,1,[],[{dungeon_time,5}]},\n    {3,2,[],[{mon_event_id_kill_all_mon,2}]},\n    {4,3,[],[{mon_event_id_kill_all_mon,3}]},\n    {5,4,[],[{mon_event_id_kill_all_mon,4}]},\n    {6,5,[],[{mon_event_id_kill_all_mon,5}]},\n    {7,6,[],[{mon_event_id_kill_all_mon,6}]},\n    {8,7,[],[{mon_event_id_kill_all_mon,7}]},\n    {9,8,[],[{mon_event_id_kill_all_mon,8}]},\n    {10,0,[{is_calc_wave_num,0},{summon_boss,2,60}],[{mon_event_id_kill_all_mon,9}]}\n    ]}]','[]','[]','[{42011,[{1,[{revive,4915,2205}],[]}]}]','[{42011,[{0,[{quit_time,3}],[{dungeon_timeout}]}]}]','[]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(5200,'情侣副本',13,0,0,'[]',0,'[]',0,0,5200,'[5200]','[]',1,2,0,9,3,0,600,5,'[{1,1},{4,10}]','[{num,1,2},{lv,180},{safe_scene},{relationship,couple},{couple_intimacy,99}]',0,0,0,0,'[]','[{5200,[{1,1,[],[{dungeon_time,5}]},{2,2,[{is_calc_wave_num,0}],[{dungeon_time,5}]},{3,3,[],[{mon_event_id_kill_all_mon,1}]},{4,4,[{is_calc_wave_num,0}],[{mon_event_id_kill_all_mon,1}]},{5,5,[],[{mon_event_id_kill_all_mon,3}]}]}]','[]','[]','[]','[{5200,[{0,[{quit_time,2}],[{mon_event_id_kill_all_mon,5}]}]}]','[{5200,[{0,[{quit_time,2}],[{dungeon_timeout}]}]}]','[]',713998,'[]',0,'[]','[]','[{0,38100008,1},{0,38100009,1},{0,38100010,1},{0,37010002,1}]',0,'[]','[]','[]'),(5201,'情侣副本',13,0,0,'[]',0,'[]',0,0,5201,'[5201]','[]',1,2,0,9,3,0,600,5,'[{1,1},{4,10}]','[{num,1,2},{lv,280},{safe_scene},{relationship,couple},{couple_intimacy,520}]',0,0,0,0,'[]','[{5201,[{1,1,[],[{dungeon_time,5}]},{2,2,[{is_calc_wave_num,0}],[{dungeon_time,5}]},{3,3,[],[{mon_event_id_kill_all_mon,1}]},{4,4,[{is_calc_wave_num,0}],[{mon_event_id_kill_all_mon,1}]},{5,5,[],[{mon_event_id_kill_all_mon,3}]}]}]','[]','[]','[]','[{5201,[{0,[{quit_time,2}],[{mon_event_id_kill_all_mon,5}]}]}]','[{5201,[{0,[{quit_time,2}],[{dungeon_timeout}]}]}]','[]',4500252,'[]',0,'[]','[]','[{0,38100008,1},{0,38100009,1},{0,38100010,1},{0,37010002,1}]',0,'[]','[]','[]'),(5202,'情侣副本',13,0,0,'[]',0,'[]',0,0,5202,'[5202]','[]',1,2,0,9,3,0,600,5,'[{1,1},{4,10}]','[{num,1,2},{lv,390},{safe_scene},{relationship,couple},{couple_intimacy,1000}]',0,0,0,0,'[]','[{5202,[{1,1,[],[{dungeon_time,5}]},{2,2,[{is_calc_wave_num,0}],[{dungeon_time,5}]},{3,3,[],[{mon_event_id_kill_all_mon,1}]},{4,4,[{is_calc_wave_num,0}],[{mon_event_id_kill_all_mon,1}]},{5,5,[],[{mon_event_id_kill_all_mon,3}]}]}]','[]','[]','[]','[{5202,[{0,[{quit_time,2}],[{mon_event_id_kill_all_mon,5}]}]}]','[{5202,[{0,[{quit_time,2}],[{dungeon_timeout}]}]}]','[]',11407305,'[]',0,'[]','[]','[{0,38100008,1},{0,38100009,1},{0,38100010,1},{0,37010002,1}]',0,'[]','[]','[]'),(5300,'星灵副本',18,0,0,'[]',1,'[{38040010,1}]',0,0,5502,'[]','[]',1,2,0,5,2,0,300,5,'[{1,2}]','[{num,1,1},{lv,85},{star_battle},{safe_scene}]',0,0,0,0,'[]','[{5502,[{1,4,[{is_calc_wave_num,0}],[]},{2,1,[],[{dungeon_time,5}]},{3,2,[],[{mon_event_id_kill_all_mon,2}]}]}]','[]','[]','[{5502,[{1,[{revive,2738,2320}],[]}]}]','[{5502,[{0,[{quit_time,8}],[{mon_event_id_kill_all_mon,3}]},{0,[{quit_time,8}],[{dungeon_timeout}]},{0,[{quit_time,8}],[{kill_mon_num,5300400,1}]}]}]','[]','[]',10000,'[]',0,'[]','[{1,70},{2,80},{3,90},{4,100},{5,100},{6,100},{7,100},{8,100},{9,100},{10,100}]','[]',0,'[]','[]','[]'),(5301,'星灵副本',18,0,0,'[]',1,'[{38040010,1}]',0,0,5502,'[]','[]',1,2,0,5,3,0,300,0,'[{1,2}]','[{num,1,1},{lv,230},{finish_dun_id,5300},{star_battle},{safe_scene}]',0,0,0,0,'[]','[{5502,[{1,4,[{is_calc_wave_num,0}],[]},{2,1,[],[{dungeon_time,5}]},{3,2,[],[{mon_event_id_kill_all_mon,2}]},{4,3,[],[{mon_event_id_kill_all_mon,3}]}]}]','[]','[]','[{5502,[{1,[{revive,2738,2320}],[]}]}]','[{5502,[{0,[{quit_time,8}],[{mon_event_id_kill_all_mon,4}]},{0,[{quit_time,8}],[{dungeon_timeout}]},{0,[{quit_time,8}],[{kill_mon_num,5401400,1}]}]}]','[]','[]',4000,'[]',0,'[]','[{1,70},{2,80},{3,90},{4,100},{5,100},{6,100},{7,100},{8,100},{9,100},{10,100}]','[]',0,'[]','[]','[]'),(5302,'星灵副本',18,0,0,'[]',1,'[{38040010,1}]',0,0,5502,'[]','[]',1,2,0,5,3,0,300,0,'[{1,2}]','[{num,1,1},{lv,320},{finish_dun_id,5301},{star_battle},{safe_scene}]',0,0,0,0,'[]','[{5502,[{1,4,[{is_calc_wave_num,0}],[]},{2,1,[],[{dungeon_time,5}]},{3,2,[],[{mon_event_id_kill_all_mon,2}]},{4,3,[],[{mon_event_id_kill_all_mon,3}]}]}]','[]','[]','[{5502,[{1,[{revive,2738,2320}],[]}]}]','[{5502,[{0,[{quit_time,8}],[{mon_event_id_kill_all_mon,4}]},{0,[{quit_time,8}],[{dungeon_timeout}]},{0,[{quit_time,8}],[{kill_mon_num,5402400,1}]}]}]','[]','[]',4000,'[]',0,'[]','[{1,70},{2,80},{3,90},{4,100},{5,100},{6,100},{7,100},{8,100},{9,100},{10,100}]','[]',0,'[]','[]','[]'),(5303,'星灵副本',18,0,0,'[]',1,'[{38040010,1}]',0,0,5502,'[]','[]',1,2,0,5,3,0,300,0,'[{1,2}]','[{num,1,1},{lv,380},{finish_dun_id,5302},{star_battle},{safe_scene}]',0,0,0,0,'[]','[{5502,[{1,4,[{is_calc_wave_num,0}],[]},{2,1,[],[{dungeon_time,5}]},{3,2,[],[{mon_event_id_kill_all_mon,2}]},{4,3,[],[{mon_event_id_kill_all_mon,3}]}]}]','[]','[]','[{5502,[{1,[{revive,2738,2320}],[]}]}]','[{5502,[{0,[{quit_time,8}],[{mon_event_id_kill_all_mon,4}]},{0,[{quit_time,8}],[{dungeon_timeout}]},{0,[{quit_time,8}],[{kill_mon_num,5403400,1}]}]}]','[]','[]',6000,'[]',0,'[]','[{1,70},{2,80},{3,90},{4,100},{5,100},{6,100},{7,100},{8,100},{9,100},{10,100}]','[]',0,'[]','[]','[]'),(5304,'星灵副本',18,0,0,'[]',1,'[{38040010,1}]',0,0,5502,'[]','[]',1,2,0,5,3,0,300,0,'[{1,2}]','[{num,1,1},{lv,510},{finish_dun_id,5303},{star_battle},{safe_scene}]',0,0,0,0,'[]','[{5502,[{1,4,[{is_calc_wave_num,0}],[]},{2,1,[],[{dungeon_time,5}]},{3,2,[],[{mon_event_id_kill_all_mon,2}]},{4,3,[],[{mon_event_id_kill_all_mon,3}]}]}]','[]','[]','[{5502,[{1,[{revive,2738,2320}],[]}]}]','[{5502,[{0,[{quit_time,8}],[{mon_event_id_kill_all_mon,4}]},{0,[{quit_time,8}],[{dungeon_timeout}]},{0,[{quit_time,8}],[{kill_mon_num,5404400,1}]}]}]','[]','[]',10000,'[]',0,'[]','[{1,70},{2,80},{3,90},{4,100},{5,100},{6,100},{7,100},{8,100},{9,100},{10,100}]','[]',0,'[]','[]','[]'),(5400,'降神副本',19,0,0,'[]',1,'[{38040010,1}]',0,0,5400,'[]','[]',1,2,0,5,1,0,300,8,'[{1,2}]','[{num,1,1},{lv,115},{safe_scene}]',0,0,0,0,'[]','[{5400,[{1,1,[],[{dungeon_time,4}]}]}]','[]','[]','[{5400,[{1,[{revive,4561,4585}],[]}]}]','[{5400,[{0,[{quit_time,8}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5400,[{0,[],[{dungeon_timeout}]}]}]','[]',166751,'[]',0,'[]','[{1,50},{2,60},{3,70},{4,80},{5,100},{6,100},{7,100},{8,100},{9,100},{10,100}]','[]',0,'[]','[]','[]'),(5401,'降神副本',19,0,0,'[]',1,'[{38040010,1}]',0,0,5400,'[]','[]',1,2,0,5,1,0,300,8,'[{1,2}]','[{num,1,1},{lv,200},{finish_dun_id,5400},{safe_scene}]',0,0,0,0,'[]','[{5400,[{1,1,[],[{dungeon_time,4}]}]}]','[]','[]','[{5400,[{1,[{revive,4561,4585}],[]}]}]','[{5400,[{0,[{quit_time,8}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5400,[{0,[],[{dungeon_timeout}]}]}]','[]',529521,'[]',0,'[]','[{1,50},{2,60},{3,70},{4,80},{5,100},{6,100},{7,100},{8,100},{9,100},{10,100}]','[]',0,'[]','[]','[]'),(5402,'降神副本',19,0,0,'[]',1,'[{38040010,1}]',0,0,5400,'[]','[]',1,2,0,5,1,0,300,8,'[{1,2}]','[{num,1,1},{lv,300},{finish_dun_id,5401},{safe_scene}]',0,0,0,0,'[]','[{5400,[{1,1,[],[{dungeon_time,4}]}]}]','[]','[]','[{5400,[{1,[{revive,4561,4585}],[]}]}]','[{5400,[{0,[{quit_time,8}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5400,[{0,[],[{dungeon_timeout}]}]}]','[]',2332252,'[]',0,'[]','[{1,50},{2,60},{3,70},{4,80},{5,100},{6,100},{7,100},{8,100},{9,100},{10,100}]','[]',0,'[]','[]','[]'),(5403,'降神副本',19,0,0,'[]',1,'[{38040010,1}]',0,0,5400,'[]','[]',1,2,0,5,1,0,300,8,'[{1,2}]','[{num,1,1},{lv,370},{finish_dun_id,5402},{safe_scene}]',0,0,0,0,'[]','[{5400,[{1,1,[],[{dungeon_time,4}]}]}]','[]','[]','[{5400,[{1,[{revive,4561,4585}],[]}]}]','[{5400,[{0,[{quit_time,8}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5400,[{0,[],[{dungeon_timeout}]}]}]','[]',4500252,'[]',0,'[]','[{1,50},{2,60},{3,70},{4,80},{5,100},{6,100},{7,100},{8,100},{9,100},{10,100}]','[]',0,'[]','[]','[]'),(5404,'降神副本',19,0,0,'[]',1,'[{38040010,1}]',0,0,5400,'[]','[]',1,2,0,5,1,0,300,8,'[{1,2}]','[{num,1,1},{lv,500},{finish_dun_id,5403},{safe_scene}]',0,0,0,0,'[]','[{5400,[{1,1,[],[{dungeon_time,4}]}]}]','[]','[]','[{5400,[{1,[{revive,4561,4585}],[]}]}]','[{5400,[{0,[{quit_time,8}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5400,[{0,[],[{dungeon_timeout}]}]}]','[]',10075953,'[]',0,'[]','[{1,50},{2,60},{3,70},{4,80},{5,100},{6,100},{7,100},{8,100},{9,100},{10,100}]','[]',0,'[]','[]','[]'),(5405,'降神副本',25,0,0,'[]',1,'[{38040010,1}]',0,0,5400,'[]','[]',2,2,0,5,1,0,600,8,'[{3,1}]','[{num,1,1},{lv,10},{safe_scene}]',0,0,0,0,'[]','[{5400,[{1,1,[],[{dungeon_time,4}]}]}]','[]','[]','[{5400,[{1,[{revive,4561,4585}],[]}]}]','[{5400,[{0,[{quit_time,8}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5400,[{0,[],[{dungeon_timeout}]}]}]','[]',0,'[]',0,'[]','[{1,50},{2,60},{3,70},{4,80},{5,100},{6,100},{7,100},{8,100},{9,100},{10,100}]','[]',0,'[]','[]','[]'),(5900,'魂珠副本(1)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',101740,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5901,'魂珠副本(2)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5900},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',186751,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5902,'魂珠副本(3)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5901},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',227211,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5903,'魂珠副本(4)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5902},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',262499,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5904,'魂珠副本(5)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5903},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',280153,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5905,'魂珠副本(6)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5904},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',298202,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5906,'魂珠副本(7)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5905},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',366984,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5907,'魂珠副本(8)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5906},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',435767,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5908,'魂珠副本(9)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5907},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',505726,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5909,'魂珠副本(10)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5908},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',579503,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5910,'魂珠副本(11)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5909},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',671724,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5911,'魂珠副本(12)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5910},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',763945,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5912,'魂珠副本(13)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5911},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',856166,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5913,'魂珠副本(14)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5912},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',1096034,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5914,'魂珠副本(15)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5913},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',1335901,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5915,'魂珠副本(16)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5914},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',1545122,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5916,'魂珠副本(17)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5915},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',1754343,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5917,'魂珠副本(18)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5916},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',1963565,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5918,'魂珠副本(19)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5917},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',2172786,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5919,'魂珠副本(20)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5918},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',2382007,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5920,'魂珠副本(21)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5919},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',2518574,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5921,'魂珠副本(22)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5920},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',2655140,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5922,'魂珠副本(23)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5921},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',2791707,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5923,'魂珠副本(24)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5922},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',2928274,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5924,'魂珠副本(25)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5923},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',3064841,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5925,'魂珠副本(26)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5924},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',3201407,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5926,'魂珠副本(27)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5925},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',3337974,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5927,'魂珠副本(28)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5926},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',3474541,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5928,'魂珠副本(29)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5927},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',3611107,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5929,'魂珠副本(30)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5928},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',3747674,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5930,'魂珠副本(31)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5929},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',3948159,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5931,'魂珠副本(32)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5930},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',4148644,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5932,'魂珠副本(33)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5931},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',4349130,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5933,'魂珠副本(34)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5932},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',4549615,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5934,'魂珠副本(35)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5933},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',4750100,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5935,'魂珠副本(36)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5934},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',4950585,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5936,'魂珠副本(37)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5935},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',5151070,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5937,'魂珠副本(38)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5936},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',5351556,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5938,'魂珠副本(39)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5937},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',5552041,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5939,'魂珠副本(40)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5938},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',5752526,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5940,'魂珠副本(41)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5939},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',5925694,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5941,'魂珠副本(42)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5940},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',6098862,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5942,'魂珠副本(43)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5941},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',6272029,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5943,'魂珠副本(44)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5942},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',6445197,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5944,'魂珠副本(45)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5943},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',6618365,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5945,'魂珠副本(46)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5944},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',6791533,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5946,'魂珠副本(47)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5945},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',6964701,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5947,'魂珠副本(48)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5946},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',7137868,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5948,'魂珠副本(49)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5947},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',7311036,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5949,'魂珠副本(50)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5948},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',7484204,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5950,'魂珠副本(51)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5949},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',8012006,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5951,'魂珠副本(52)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5950},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',8539809,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5952,'魂珠副本(53)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5951},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',9067611,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5953,'魂珠副本(54)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5952},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',9595414,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5954,'魂珠副本(55)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5953},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',10123216,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5955,'魂珠副本(56)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5954},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',10788604,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5956,'魂珠副本(57)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5955},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',11453992,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5957,'魂珠副本(58)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5956},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',12119381,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5958,'魂珠副本(59)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5957},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',12784769,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5959,'魂珠副本(60)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5958},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',13450157,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5960,'魂珠副本(61)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5959},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',14094359,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5961,'魂珠副本(62)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5960},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',14738561,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5962,'魂珠副本(63)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5961},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',15382762,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5963,'魂珠副本(64)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5962},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',16026964,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5964,'魂珠副本(65)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5963},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',16671166,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5965,'魂珠副本(66)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5964},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',17427196,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5966,'魂珠副本(67)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5965},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',18183227,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5967,'魂珠副本(68)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5966},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',18939257,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5968,'魂珠副本(69)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5967},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',19695288,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5969,'魂珠副本(70)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5968},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',20451318,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5970,'魂珠副本(71)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5969},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',21300120,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5971,'魂珠副本(72)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5970},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',22148922,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5972,'魂珠副本(73)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5971},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',22997725,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5973,'魂珠副本(74)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5972},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',23846527,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5974,'魂珠副本(75)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5973},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',24695329,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5975,'魂珠副本(76)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5974},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',25462810,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5976,'魂珠副本(77)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5975},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',26230290,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5977,'魂珠副本(78)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5976},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',26997771,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5978,'魂珠副本(79)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5977},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',27765251,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5979,'魂珠副本(80)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5978},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',28532732,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5980,'魂珠副本(81)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5979},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',29414667,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5981,'魂珠副本(82)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5980},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',30296603,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5982,'魂珠副本(83)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5981},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',31178538,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5983,'魂珠副本(84)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5982},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',32060474,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5984,'魂珠副本(85)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5983},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',32942409,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5985,'魂珠副本(86)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5984},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',33929203,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5986,'魂珠副本(87)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5985},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',34945540,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5987,'魂珠副本(88)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5986},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',35992335,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5988,'魂珠副本(89)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5987},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',37070620,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5989,'魂珠副本(90)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5988},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',38181302,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5990,'魂珠副本(91)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5989},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',39325259,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5991,'魂珠副本(92)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5990},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',40503463,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5992,'魂珠副本(93)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5991},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',41717075,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5993,'魂珠副本(94)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5992},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',42967014,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5994,'魂珠副本(95)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5993},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',44254524,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5995,'魂珠副本(96)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5994},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',45580644,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5996,'魂珠副本(97)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5995},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',46946611,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5997,'魂珠副本(98)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5996},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',48353498,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5998,'魂珠副本(99)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5997},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',49802553,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(5999,'魂珠副本(100)',20,0,0,'[]',1,'[]',0,0,5900,'[]','[]',2,0,0,0,1,0,29,3,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,5998},{safe_scene}]',1,9999,0,0,'[]','[{5900,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5900,[{1,[{revive,3982,3578}],[]}]}]','[{5900,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5900,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',51295124,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(10000,'暗裔BOSS',0,0,1,'[]',0,'[]',0,0,10000,'[]','[1000,4514,12894]',2,2,0,10,1,0,600,1,'[{3,1}]','[{num,1,1},{lv,10},{safe_scene}]',0,0,0,0,'[]','[{10000,[{1,1,[],[{dungeon_time,0}]}]}]','[]','[]','[{10000,[{1,[{revive,3758,13729}],[]}]}]','[{10000,[{0,[{quit_time,8}],[{mon_event_id_kill_all_mon,1}]}]}]','[{10000,[{0,[],[{dungeon_timeout}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(10002,'暗裔BOSS',0,0,1,'[]',0,'[]',0,0,10002,'[]','[]',2,2,0,10,1,0,600,3,'[]','[{num,1,1},{lv,10},{safe_scene}]',0,0,0,0,'[]','[{10002,[{1,1,[],[{dungeon_time,3}]}]}]','[{10002,[{1,[10002,2,[]],[{dungeon_time,0}]}]}]','[]','[{10002,[{1,[{revive,12298,12384}],[]}]}]','[{10002,[{0,[{quit_time,8}],[{mon_event_id_kill_all_mon,1}]}]}]','[{10002,[{0,[],[{dungeon_timeout}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(10003,'暗裔BOSS',0,0,1,'[]',0,'[]',0,0,10003,'[]','[]',2,2,0,10,1,0,600,1,'[{3,1}]','[{num,1,1},{lv,10},{safe_scene}]',0,0,0,0,'[]','[{10003,[{1,1,[],[{dungeon_time,0}]}]}]','[]','[]','[{10003,[{1,[{revive,1818,1701}],[]}]}]','[{10003,[{0,[{quit_time,6}],[{mon_event_id_kill_all_mon,1}]}]}]','[{10003,[{0,[],[{dungeon_timeout}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(10006,'神殿试炼',0,0,1,'[]',0,'[]',0,0,10006,'[]','[]',2,2,0,5,1,0,600,3,'[]','[{num,1,1},{lv,10},{safe_scene}]',0,0,0,0,'[]','[{10006,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{10006,[{1,[{revive,2996,16494}],[]}]}]','[{10006,[{0,[{quit_time,8}],[{mon_event_id_kill_all_mon,1}]}]}]','[{10006,[{0,[],[{dungeon_timeout}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(10007,'暗裔BOSS',0,0,1,'[]',0,'[]',0,0,10007,'[]','[]',2,2,0,10,1,0,600,3,'[]','[{num,1,1},{lv,10},{safe_scene}]',0,0,0,0,'[]','[{10007,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{10007,[{1,[{revive,13873,10612}],[]}]}]','[{10007,[{0,[{quit_time,8}],[{mon_event_id_kill_all_mon,1}]}]}]','[{10007,[{0,[],[{dungeon_timeout}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(10008,'死神试炼',0,0,1,'[]',0,'[]',0,0,10008,'[]','[]',2,2,0,10,1,0,600,3,'[]','[{num,1,1},{lv,10},{safe_scene}]',0,0,0,0,'[]','[{10008,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{10008,[{1,[{revive,11247,12750}],[]}]}]','[{10008,[{0,[{quit_time,8}],[{mon_event_id_kill_all_mon,1}]}]}]','[{10008,[{0,[],[{dungeon_timeout}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(10009,'骑士试炼',0,0,1,'[]',0,'[]',0,0,7504,'[]','[]',2,2,0,10,1,0,600,3,'[]','[{num,1,1},{lv,10},{safe_scene}]',0,0,0,0,'[]','[{7504,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7504,[{1,[{revive,12450,9150}],[]}]}]','[{7504,[{0,[{quit_time,8}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7504,[{0,[],[{dungeon_timeout}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(10030,'解救白羊',15,0,0,'[]',0,'[]',0,0,10030,'[10030]','[]',2,2,0,5,1,0,600,1,'[{3,1}]','[{num,1,1},{safe_scene}]',0,0,0,0,'[]','[{10030,[{1,1,[],[{dungeon_time,0}]},{2,2,[],[{mon_event_id_kill_all_mon,1}]}]}]','[]','[]','[{10030,[{1,[{revive,15999,8092}],[]}]}]','[{10030,[{0,[{quit_time,8}],[{mon_event_id_kill_all_mon,2}]}]}]','[{10030,[{0,[],[{dungeon_timeout}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(30000,'D-1试炼',26,0,0,'[]',0,'[]',0,0,2501,'[2501]','[]',2,2,0,5,1,0,180,5,'[{2,100}]','[{lv,55},{num,1,1},{safe_scene}]',0,0,0,0,'[]','[{2501,[{1,1,[],[{dungeon_time,5}]}]}]','[]','[]','[]','[{2501,[{0,[{quit_time,10}],[{mon_event_id_kill_all_mon,1}]}]}]','[{2501,[{0,[{quit_time,2}],[{dungeon_timeout}]},{0,[{quit_time,2}],[{role_hp_rate,0}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(30001,'D-2试炼',26,0,0,'[]',0,'[]',0,0,2502,'[2502]','[]',2,2,0,5,1,0,180,5,'[{2,100}]','[{lv,55},{num,1,1},{safe_scene}]',0,0,0,0,'[]','[{2502,[{1,1,[],[{dungeon_time,5}]}]}]','[]','[]','[]','[{2502,[{0,[{quit_time,10}],[{mon_event_id_kill_all_mon,1}]}]}]','[{2502,[{0,[{quit_time,2}],[{dungeon_timeout}]},{0,[{quit_time,2}],[{role_hp_rate,0}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(30002,'D-3试炼',26,0,0,'[]',0,'[]',0,0,2503,'[2503]','[]',2,2,0,5,1,0,180,5,'[{2,100}]','[{lv,55},{num,1,1},{safe_scene}]',0,0,0,0,'[]','[{2503,[{1,1,[],[{dungeon_time,5}]}]}]','[]','[]','[]','[{2503,[{0,[{quit_time,10}],[{mon_event_id_kill_all_mon,1}]}]}]','[{2503,[{0,[{quit_time,2}],[{dungeon_timeout}]},{0,[{quit_time,2}],[{role_hp_rate,0}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(30003,'D-4试炼',26,0,0,'[]',0,'[]',0,0,2504,'[2504]','[]',2,2,0,5,1,0,180,5,'[{2,100}]','[{lv,55},{num,1,1},{safe_scene}]',0,0,0,0,'[]','[{2504,[{1,1,[],[{dungeon_time,5}]}]}]','[]','[]','[]','[{2504,[{0,[{quit_time,10}],[{mon_event_id_kill_all_mon,1}]}]}]','[{2504,[{0,[{quit_time,2}],[{dungeon_timeout}]},{0,[{quit_time,2}],[{role_hp_rate,0}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(30004,'D-5试炼',26,0,0,'[]',0,'[]',0,0,2505,'[2505]','[]',2,2,0,5,1,0,180,5,'[{2,100}]','[{lv,55},{num,1,1},{safe_scene}]',0,0,0,0,'[]','[{2505,[{1,1,[],[{dungeon_time,5}]}]}]','[]','[]','[]','[{2505,[{0,[{quit_time,10}],[{mon_event_id_kill_all_mon,1}]}]}]','[{2505,[{0,[{quit_time,2}],[{dungeon_timeout}]},{0,[{quit_time,2}],[{role_hp_rate,0}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(30005,'C-1试炼',26,0,0,'[]',0,'[]',0,0,2501,'[2501]','[]',2,2,0,5,1,0,180,5,'[{2,100}]','[{lv,55},{num,1,1},{safe_scene}]',0,0,0,0,'[]','[{2501,[{1,1,[],[{dungeon_time,5}]}]}]','[]','[]','[]','[{2501,[{0,[{quit_time,10}],[{mon_event_id_kill_all_mon,1}]}]}]','[{2501,[{0,[{quit_time,2}],[{dungeon_timeout}]},{0,[{quit_time,2}],[{role_hp_rate,0}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(30006,'C-2试炼',26,0,0,'[]',0,'[]',0,0,2502,'[2502]','[]',2,2,0,5,1,0,180,5,'[{2,100}]','[{lv,55},{num,1,1},{safe_scene}]',0,0,0,0,'[]','[{2502,[{1,1,[],[{dungeon_time,5}]}]}]','[]','[]','[]','[{2502,[{0,[{quit_time,10}],[{mon_event_id_kill_all_mon,1}]}]}]','[{2502,[{0,[{quit_time,2}],[{dungeon_timeout}]},{0,[{quit_time,2}],[{role_hp_rate,0}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(30007,'C-3试炼',26,0,0,'[]',0,'[]',0,0,2503,'[2503]','[]',2,2,0,5,1,0,180,5,'[{2,100}]','[{lv,55},{num,1,1},{safe_scene}]',0,0,0,0,'[]','[{2503,[{1,1,[],[{dungeon_time,5}]}]}]','[]','[]','[]','[{2503,[{0,[{quit_time,10}],[{mon_event_id_kill_all_mon,1}]}]}]','[{2503,[{0,[{quit_time,2}],[{dungeon_timeout}]},{0,[{quit_time,2}],[{role_hp_rate,0}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(30008,'C-4试炼',26,0,0,'[]',0,'[]',0,0,2504,'[2504]','[]',2,2,0,5,1,0,180,5,'[{2,100}]','[{lv,55},{num,1,1},{safe_scene}]',0,0,0,0,'[]','[{2504,[{1,1,[],[{dungeon_time,5}]}]}]','[]','[]','[]','[{2504,[{0,[{quit_time,10}],[{mon_event_id_kill_all_mon,1}]}]}]','[{2504,[{0,[{quit_time,2}],[{dungeon_timeout}]},{0,[{quit_time,2}],[{role_hp_rate,0}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(30009,'C-5试炼',26,0,0,'[]',0,'[]',0,0,2505,'[2505]','[]',2,2,0,5,1,0,180,5,'[{2,100}]','[{lv,55},{num,1,1},{safe_scene}]',0,0,0,0,'[]','[{2505,[{1,1,[],[{dungeon_time,5}]}]}]','[]','[]','[]','[{2505,[{0,[{quit_time,10}],[{mon_event_id_kill_all_mon,1}]}]}]','[{2505,[{0,[{quit_time,2}],[{dungeon_timeout}]},{0,[{quit_time,2}],[{role_hp_rate,0}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(30010,'B-1试炼',26,0,0,'[]',0,'[]',0,0,2501,'[2501]','[]',2,2,0,5,1,0,180,5,'[{2,100}]','[{lv,55},{num,1,1},{safe_scene}]',0,0,0,0,'[]','[{2501,[{1,1,[],[{dungeon_time,5}]}]}]','[]','[]','[]','[{2501,[{0,[{quit_time,10}],[{mon_event_id_kill_all_mon,1}]}]}]','[{2501,[{0,[{quit_time,2}],[{dungeon_timeout}]},{0,[{quit_time,2}],[{role_hp_rate,0}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(30011,'B-2试炼',26,0,0,'[]',0,'[]',0,0,2502,'[2502]','[]',2,2,0,5,1,0,180,5,'[{2,100}]','[{lv,55},{num,1,1},{safe_scene}]',0,0,0,0,'[]','[{2502,[{1,1,[],[{dungeon_time,5}]}]}]','[]','[]','[]','[{2502,[{0,[{quit_time,10}],[{mon_event_id_kill_all_mon,1}]}]}]','[{2502,[{0,[{quit_time,2}],[{dungeon_timeout}]},{0,[{quit_time,2}],[{role_hp_rate,0}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(30012,'B-3试炼',26,0,0,'[]',0,'[]',0,0,2503,'[2503]','[]',2,2,0,5,1,0,180,5,'[{2,100}]','[{lv,55},{num,1,1},{safe_scene}]',0,0,0,0,'[]','[{2503,[{1,1,[],[{dungeon_time,5}]}]}]','[]','[]','[]','[{2503,[{0,[{quit_time,10}],[{mon_event_id_kill_all_mon,1}]}]}]','[{2503,[{0,[{quit_time,2}],[{dungeon_timeout}]},{0,[{quit_time,2}],[{role_hp_rate,0}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(30013,'B-4试炼',26,0,0,'[]',0,'[]',0,0,2504,'[2504]','[]',2,2,0,5,1,0,180,5,'[{2,100}]','[{lv,55},{num,1,1},{safe_scene}]',0,0,0,0,'[]','[{2504,[{1,1,[],[{dungeon_time,5}]}]}]','[]','[]','[]','[{2504,[{0,[{quit_time,10}],[{mon_event_id_kill_all_mon,1}]}]}]','[{2504,[{0,[{quit_time,2}],[{dungeon_timeout}]},{0,[{quit_time,2}],[{role_hp_rate,0}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(30014,'B-5试炼',26,0,0,'[]',0,'[]',0,0,2505,'[2505]','[]',2,2,0,5,1,0,180,5,'[{2,100}]','[{lv,55},{num,1,1},{safe_scene}]',0,0,0,0,'[]','[{2505,[{1,1,[],[{dungeon_time,5}]}]}]','[]','[]','[]','[{2505,[{0,[{quit_time,10}],[{mon_event_id_kill_all_mon,1}]}]}]','[{2505,[{0,[{quit_time,2}],[{dungeon_timeout}]},{0,[{quit_time,2}],[{role_hp_rate,0}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(30015,'A-1试炼',26,0,0,'[]',0,'[]',0,0,2501,'[2501]','[]',2,2,0,5,1,0,180,5,'[{2,100}]','[{lv,55},{num,1,1},{safe_scene}]',0,0,0,0,'[]','[{2501,[{1,1,[],[{dungeon_time,5}]}]}]','[]','[]','[]','[{2501,[{0,[{quit_time,10}],[{mon_event_id_kill_all_mon,1}]}]}]','[{2501,[{0,[{quit_time,2}],[{dungeon_timeout}]},{0,[{quit_time,2}],[{role_hp_rate,0}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(30016,'A-2试炼',26,0,0,'[]',0,'[]',0,0,2502,'[2502]','[]',2,2,0,5,1,0,180,5,'[{2,100}]','[{lv,55},{num,1,1},{safe_scene}]',0,0,0,0,'[]','[{2502,[{1,1,[],[{dungeon_time,5}]}]}]','[]','[]','[]','[{2502,[{0,[{quit_time,10}],[{mon_event_id_kill_all_mon,1}]}]}]','[{2502,[{0,[{quit_time,2}],[{dungeon_timeout}]},{0,[{quit_time,2}],[{role_hp_rate,0}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(30017,'A-3试炼',26,0,0,'[]',0,'[]',0,0,2503,'[2503]','[]',2,2,0,5,1,0,180,5,'[{2,100}]','[{lv,55},{num,1,1},{safe_scene}]',0,0,0,0,'[]','[{2503,[{1,1,[],[{dungeon_time,5}]}]}]','[]','[]','[]','[{2503,[{0,[{quit_time,10}],[{mon_event_id_kill_all_mon,1}]}]}]','[{2503,[{0,[{quit_time,2}],[{dungeon_timeout}]},{0,[{quit_time,2}],[{role_hp_rate,0}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(30018,'A-4试炼',26,0,0,'[]',0,'[]',0,0,2504,'[2504]','[]',2,2,0,5,1,0,180,5,'[{2,100}]','[{lv,55},{num,1,1},{safe_scene}]',0,0,0,0,'[]','[{2504,[{1,1,[],[{dungeon_time,5}]}]}]','[]','[]','[]','[{2504,[{0,[{quit_time,10}],[{mon_event_id_kill_all_mon,1}]}]}]','[{2504,[{0,[{quit_time,2}],[{dungeon_timeout}]},{0,[{quit_time,2}],[{role_hp_rate,0}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(30019,'A-5试炼',26,0,0,'[]',0,'[]',0,0,2505,'[2505]','[]',2,2,0,5,1,0,180,5,'[{2,100}]','[{lv,55},{num,1,1},{safe_scene}]',0,0,0,0,'[]','[{2505,[{1,1,[],[{dungeon_time,5}]}]}]','[]','[]','[]','[{2505,[{0,[{quit_time,10}],[{mon_event_id_kill_all_mon,1}]}]}]','[{2505,[{0,[{quit_time,2}],[{dungeon_timeout}]},{0,[{quit_time,2}],[{role_hp_rate,0}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(30020,'S-1试炼',26,0,0,'[]',0,'[]',0,0,2501,'[2501]','[]',2,2,0,5,1,0,180,5,'[{2,100}]','[{lv,55},{num,1,1},{safe_scene}]',0,0,0,0,'[]','[{2501,[{1,1,[],[{dungeon_time,5}]}]}]','[]','[]','[]','[{2501,[{0,[{quit_time,10}],[{mon_event_id_kill_all_mon,1}]}]}]','[{2501,[{0,[{quit_time,2}],[{dungeon_timeout}]},{0,[{quit_time,2}],[{role_hp_rate,0}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(30021,'S-2试炼',26,0,0,'[]',0,'[]',0,0,2502,'[2502]','[]',2,2,0,5,1,0,180,5,'[{2,100}]','[{lv,55},{num,1,1},{safe_scene}]',0,0,0,0,'[]','[{2502,[{1,1,[],[{dungeon_time,5}]}]}]','[]','[]','[]','[{2502,[{0,[{quit_time,10}],[{mon_event_id_kill_all_mon,1}]}]}]','[{2502,[{0,[{quit_time,2}],[{dungeon_timeout}]},{0,[{quit_time,2}],[{role_hp_rate,0}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(30022,'S-3试炼',26,0,0,'[]',0,'[]',0,0,2503,'[2503]','[]',2,2,0,5,1,0,180,5,'[{2,100}]','[{lv,55},{num,1,1},{safe_scene}]',0,0,0,0,'[]','[{2503,[{1,1,[],[{dungeon_time,5}]}]}]','[]','[]','[]','[{2503,[{0,[{quit_time,10}],[{mon_event_id_kill_all_mon,1}]}]}]','[{2503,[{0,[{quit_time,2}],[{dungeon_timeout}]},{0,[{quit_time,2}],[{role_hp_rate,0}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(30023,'S-4试炼',26,0,0,'[]',0,'[]',0,0,2504,'[2504]','[]',2,2,0,5,1,0,180,5,'[{2,100}]','[{lv,55},{num,1,1},{safe_scene}]',0,0,0,0,'[]','[{2504,[{1,1,[],[{dungeon_time,5}]}]}]','[]','[]','[]','[{2504,[{0,[{quit_time,10}],[{mon_event_id_kill_all_mon,1}]}]}]','[{2504,[{0,[{quit_time,2}],[{dungeon_timeout}]},{0,[{quit_time,2}],[{role_hp_rate,0}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(30024,'S-5试炼',26,0,0,'[]',0,'[]',0,0,2505,'[2505]','[]',2,2,0,5,1,0,180,5,'[{2,100}]','[{lv,55},{num,1,1},{safe_scene}]',0,0,0,0,'[]','[{2505,[{1,1,[],[{dungeon_time,5}]}]}]','[]','[]','[]','[{2505,[{0,[{quit_time,10}],[{mon_event_id_kill_all_mon,1}]}]}]','[{2505,[{0,[{quit_time,2}],[{dungeon_timeout}]},{0,[{quit_time,2}],[{role_hp_rate,0}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(30025,'D-5试炼',26,0,0,'[]',0,'[]',0,0,2501,'[2501]','[]',2,2,0,5,1,0,180,5,'[{2,100}]','[{lv,55},{num,1,1},{safe_scene}]',0,0,0,0,'[]','[{2501,[{1,1,[],[{dungeon_time,5}]}]}]','[]','[]','[]','[{2501,[{0,[{quit_time,10}],[{mon_event_id_kill_all_mon,1}]}]}]','[{2501,[{0,[{quit_time,2}],[{dungeon_timeout}]},{0,[{quit_time,2}],[{role_hp_rate,0}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(30026,'C-5试炼',26,0,0,'[]',0,'[]',0,0,2502,'[2502]','[]',2,2,0,5,1,0,180,5,'[{2,100}]','[{lv,55},{num,1,1},{safe_scene}]',0,0,0,0,'[]','[{2502,[{1,1,[],[{dungeon_time,5}]}]}]','[]','[]','[]','[{2502,[{0,[{quit_time,10}],[{mon_event_id_kill_all_mon,1}]}]}]','[{2502,[{0,[{quit_time,2}],[{dungeon_timeout}]},{0,[{quit_time,2}],[{role_hp_rate,0}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(30027,'B-5试炼',26,0,0,'[]',0,'[]',0,0,2503,'[2503]','[]',2,2,0,5,1,0,180,5,'[{2,100}]','[{lv,55},{num,1,1},{safe_scene}]',0,0,0,0,'[]','[{2503,[{1,1,[],[{dungeon_time,5}]}]}]','[]','[]','[]','[{2503,[{0,[{quit_time,10}],[{mon_event_id_kill_all_mon,1}]}]}]','[{2503,[{0,[{quit_time,2}],[{dungeon_timeout}]},{0,[{quit_time,2}],[{role_hp_rate,0}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(30028,'A-5试炼',26,0,0,'[]',0,'[]',0,0,2504,'[2504]','[]',2,2,0,5,1,0,180,5,'[{2,100}]','[{lv,55},{num,1,1},{safe_scene}]',0,0,0,0,'[]','[{2504,[{1,1,[],[{dungeon_time,5}]}]}]','[]','[]','[]','[{2504,[{0,[{quit_time,10}],[{mon_event_id_kill_all_mon,1}]}]}]','[{2504,[{0,[{quit_time,2}],[{dungeon_timeout}]},{0,[{quit_time,2}],[{role_hp_rate,0}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(30030,'S-5试炼',26,0,0,'[]',0,'[]',0,0,2501,'[2501]','[]',2,2,0,5,1,0,180,5,'[{2,100}]','[{lv,55},{num,1,1},{safe_scene}]',0,0,0,0,'[]','[{2501,[{1,1,[],[{dungeon_time,5}]}]}]','[]','[]','[]','[{2501,[{0,[{quit_time,10}],[{mon_event_id_kill_all_mon,1}]}]}]','[{2501,[{0,[{quit_time,2}],[{dungeon_timeout}]},{0,[{quit_time,2}],[{role_hp_rate,0}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(40001,'宝宝副本',17,0,0,'[]',1,'[]',0,0,40001,'[40001]','[]',1,3,0,10,100,0,600,3,'[]','[{num,1,1},{lv,315},{safe_scene}]',2,0,0,0,'[]','[{40001,[{1,1,[],[{dungeon_time,3}]},{2,2,[],[{mon_event_id_kill_all_mon,1}]},{3,3,[],[{mon_event_id_kill_all_mon,2}]},{4,4,[],[{mon_event_id_kill_all_mon,3}]},{5,5,[],[{mon_event_id_kill_all_mon,4}]},{6,6,[],[{mon_event_id_kill_all_mon,5}]},{7,7,[],[{mon_event_id_kill_all_mon,6}]},{8,8,[],[{mon_event_id_kill_all_mon,7}]},{9,9,[],[{mon_event_id_kill_all_mon,8}]},{10,10,[],[{mon_event_id_kill_all_mon,9}]},{11,11,[],[{mon_event_id_kill_all_mon,10}]},{12,12,[],[{mon_event_id_kill_all_mon,11}]},{13,13,[],[{mon_event_id_kill_all_mon,12}]},{14,14,[],[{mon_event_id_kill_all_mon,13}]},{15,15,[],[{mon_event_id_kill_all_mon,14}]},{16,16,[],[{mon_event_id_kill_all_mon,15}]},{17,17,[],[{mon_event_id_kill_all_mon,16}]},{18,18,[],[{mon_event_id_kill_all_mon,17}]},{19,19,[],[{mon_event_id_kill_all_mon,18}]},{20,20,[],[{mon_event_id_kill_all_mon,19}]},{21,21,[],[{mon_event_id_kill_all_mon,20}]},{22,22,[],[{mon_event_id_kill_all_mon,21}]},{23,23,[],[{mon_event_id_kill_all_mon,22}]},{24,24,[],[{mon_event_id_kill_all_mon,23}]},{25,25,[],[{mon_event_id_kill_all_mon,24}]},{26,26,[],[{mon_event_id_kill_all_mon,25}]},{27,27,[],[{mon_event_id_kill_all_mon,26}]},{28,28,[],[{mon_event_id_kill_all_mon,27}]},{29,29,[],[{mon_event_id_kill_all_mon,28}]},{30,30,[],[{mon_event_id_kill_all_mon,29}]},{31,31,[],[{mon_event_id_kill_all_mon,30}]},{32,32,[],[{mon_event_id_kill_all_mon,31}]},{33,33,[],[{mon_event_id_kill_all_mon,32}]},{34,34,[],[{mon_event_id_kill_all_mon,33}]},{35,35,[],[{mon_event_id_kill_all_mon,34}]},{36,36,[],[{mon_event_id_kill_all_mon,35}]},{37,37,[],[{mon_event_id_kill_all_mon,36}]},{38,38,[],[{mon_event_id_kill_all_mon,37}]},{39,39,[],[{mon_event_id_kill_all_mon,38}]},{40,40,[],[{mon_event_id_kill_all_mon,39}]},{41,41,[],[{mon_event_id_kill_all_mon,40}]},{42,42,[],[{mon_event_id_kill_all_mon,41}]},{43,43,[],[{mon_event_id_kill_all_mon,42}]},{44,44,[],[{mon_event_id_kill_all_mon,43}]},{45,45,[],[{mon_event_id_kill_all_mon,44}]},{46,46,[],[{mon_event_id_kill_all_mon,45}]},{47,47,[],[{mon_event_id_kill_all_mon,46}]},{48,48,[],[{mon_event_id_kill_all_mon,47}]},{49,49,[],[{mon_event_id_kill_all_mon,48}]},{50,50,[],[{mon_event_id_kill_all_mon,49}]},{51,51,[],[{mon_event_id_kill_all_mon,50}]},{52,52,[],[{mon_event_id_kill_all_mon,51}]},{53,53,[],[{mon_event_id_kill_all_mon,52}]},{54,54,[],[{mon_event_id_kill_all_mon,53}]},{55,55,[],[{mon_event_id_kill_all_mon,54}]},{56,56,[],[{mon_event_id_kill_all_mon,55}]},{57,57,[],[{mon_event_id_kill_all_mon,56}]},{58,58,[],[{mon_event_id_kill_all_mon,57}]},{59,59,[],[{mon_event_id_kill_all_mon,58}]},{60,60,[],[{mon_event_id_kill_all_mon,59}]},{61,61,[],[{mon_event_id_kill_all_mon,60}]},{62,62,[],[{mon_event_id_kill_all_mon,61}]},{63,63,[],[{mon_event_id_kill_all_mon,62}]},{64,64,[],[{mon_event_id_kill_all_mon,63}]},{65,65,[],[{mon_event_id_kill_all_mon,64}]},{66,66,[],[{mon_event_id_kill_all_mon,65}]},{67,67,[],[{mon_event_id_kill_all_mon,66}]},{68,68,[],[{mon_event_id_kill_all_mon,67}]},{69,69,[],[{mon_event_id_kill_all_mon,68}]},{70,70,[],[{mon_event_id_kill_all_mon,69}]},{71,71,[],[{mon_event_id_kill_all_mon,70}]},{72,72,[],[{mon_event_id_kill_all_mon,71}]},{73,73,[],[{mon_event_id_kill_all_mon,72}]},{74,74,[],[{mon_event_id_kill_all_mon,73}]},{75,75,[],[{mon_event_id_kill_all_mon,74}]},{76,76,[],[{mon_event_id_kill_all_mon,75}]},{77,77,[],[{mon_event_id_kill_all_mon,76}]},{78,78,[],[{mon_event_id_kill_all_mon,77}]},{79,79,[],[{mon_event_id_kill_all_mon,78}]},{80,80,[],[{mon_event_id_kill_all_mon,79}]},{81,81,[],[{mon_event_id_kill_all_mon,80}]},{82,82,[],[{mon_event_id_kill_all_mon,81}]},{83,83,[],[{mon_event_id_kill_all_mon,82}]},{84,84,[],[{mon_event_id_kill_all_mon,83}]},{85,85,[],[{mon_event_id_kill_all_mon,84}]},{86,86,[],[{mon_event_id_kill_all_mon,85}]},{87,87,[],[{mon_event_id_kill_all_mon,86}]},{88,88,[],[{mon_event_id_kill_all_mon,87}]},{89,89,[],[{mon_event_id_kill_all_mon,88}]},{90,90,[],[{mon_event_id_kill_all_mon,89}]},{91,91,[],[{mon_event_id_kill_all_mon,90}]},{92,92,[],[{mon_event_id_kill_all_mon,91}]},{93,93,[],[{mon_event_id_kill_all_mon,92}]},{94,94,[],[{mon_event_id_kill_all_mon,93}]},{95,95,[],[{mon_event_id_kill_all_mon,94}]},{96,96,[],[{mon_event_id_kill_all_mon,95}]},{97,97,[],[{mon_event_id_kill_all_mon,96}]},{98,98,[],[{mon_event_id_kill_all_mon,97}]},{99,99,[],[{mon_event_id_kill_all_mon,98}]},{100,100,[],[{mon_event_id_kill_all_mon,99}]}]}]','[]','[]','[{40001,[{1,[{revive,4934,4299}],[]}]}]','[{40001,[{0,[],[{dungeon_timeout}]},{0,[],[{mon_event_id_kill_all_mon,100}]}]}]','[{40001,[{0,[{quit_time,3}],[{score_grade,0}]}]}]','[]',0,'[]',1,'[]','[]','[]',1,'[]','[]','[]'),(56000,'神格副本(1)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,3,1,0,40,6,'[{3,1}]','[{num,1,1},{lv,70},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,4}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',192211,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56001,'神格副本(2)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56000},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',220480,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56002,'神格副本(3)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56001},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',242499,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56003,'神格副本(4)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56002},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',270833,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56004,'神格副本(5)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56003},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',401338,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56005,'神格副本(6)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56004},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',533393,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56006,'神格副本(7)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56005},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',671724,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56007,'神格副本(8)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56006},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',763945,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56008,'神格副本(9)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56007},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',856166,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56009,'神格副本(10)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56008},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',1096034,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56010,'神格副本(11)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56009},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',1335901,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56011,'神格副本(12)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56010},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',1545122,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56012,'神格副本(13)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56011},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',1754343,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56013,'神格副本(14)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56012},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',1963565,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56014,'神格副本(15)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56013},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',2172786,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56015,'神格副本(16)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56014},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',2382007,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56016,'神格副本(17)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56015},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',2655140,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56017,'神格副本(18)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56016},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',2928274,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56018,'神格副本(19)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56017},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',3201407,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56019,'神格副本(20)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56018},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',3474541,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56020,'神格副本(21)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56019},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',3747674,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56021,'神格副本(22)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56020},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',4148644,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56022,'神格副本(23)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56021},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',4549615,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56023,'神格副本(24)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56022},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',4950585,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56024,'神格副本(25)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56023},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',5351556,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56025,'神格副本(26)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56024},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',5752526,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56026,'神格副本(27)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56025},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',6098862,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56027,'神格副本(28)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56026},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',6445197,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56028,'神格副本(29)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56027},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',6791533,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56029,'神格副本(30)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56028},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',7137868,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56030,'神格副本(31)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56029},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',7484204,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56031,'神格副本(32)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56030},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',8012006,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56032,'神格副本(33)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56031},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',8539809,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56033,'神格副本(34)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56032},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',9067611,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56034,'神格副本(35)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56033},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',9595414,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56035,'神格副本(36)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56034},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',10123216,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56036,'神格副本(37)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56035},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',10788604,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56037,'神格副本(38)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56036},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',11453992,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56038,'神格副本(39)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56037},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',12119381,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56039,'神格副本(40)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56038},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',12784769,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56040,'神格副本(41)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56039},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',13450157,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56041,'神格副本(42)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56040},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',14094359,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56042,'神格副本(43)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56041},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',14738561,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56043,'神格副本(44)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56042},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',15382762,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56044,'神格副本(45)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56043},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',16026964,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56045,'神格副本(46)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56044},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',16671166,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56046,'神格副本(47)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56045},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',17427196,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56047,'神格副本(48)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56046},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',18183227,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56048,'神格副本(49)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56047},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',18939257,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56049,'神格副本(50)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56048},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',19695288,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56050,'神格副本(51)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56049},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',20451318,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56051,'神格副本(52)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56050},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',21300120,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56052,'神格副本(53)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56051},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',22148922,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56053,'神格副本(54)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56052},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',22997725,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56054,'神格副本(55)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56053},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',23846527,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56055,'神格副本(56)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56054},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',24695329,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56056,'神格副本(57)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56055},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',25079069,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56057,'神格副本(58)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56056},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',25462810,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56058,'神格副本(59)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56057},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',25846550,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56059,'神格副本(60)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56058},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',26230290,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56060,'神格副本(61)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56059},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',26614031,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56061,'神格副本(62)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56060},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',26997771,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56062,'神格副本(63)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56061},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',27381511,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56063,'神格副本(64)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56062},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',27765251,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56064,'神格副本(65)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56063},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',28148992,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56065,'神格副本(66)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56064},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',28532732,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56066,'神格副本(67)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56065},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',28973700,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56067,'神格副本(68)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56066},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',29414667,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56068,'神格副本(69)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56067},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',29855635,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56069,'神格副本(70)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56068},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',30296603,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56070,'神格副本(71)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56069},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',30737571,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56071,'神格副本(72)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56070},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',31178538,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56072,'神格副本(73)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56071},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',31619506,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56073,'神格副本(74)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56072},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',32060474,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56074,'神格副本(75)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56073},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',32501441,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56075,'神格副本(76)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56074},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',32942409,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56076,'神格副本(77)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56075},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',33929203,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56077,'神格副本(78)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56076},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',34945540,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56078,'神格副本(79)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56077},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',35992335,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56079,'神格副本(80)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56078},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',37070620,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56080,'神格副本(81)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56079},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',38181302,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56081,'神格副本(82)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56080},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',39325259,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56082,'神格副本(83)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56081},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',40503463,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56083,'神格副本(84)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56082},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',41717075,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56084,'神格副本(85)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56083},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',42967014,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56085,'神格副本(86)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56084},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',44254524,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56086,'神格副本(87)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56085},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',45580644,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56087,'神格副本(88)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56086},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',46946611,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56088,'神格副本(89)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56087},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',48353498,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56089,'神格副本(90)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56088},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',49802553,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56090,'神格副本(91)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56089},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',51295124,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56091,'神格副本(92)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56090},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',52832552,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56092,'神格副本(93)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56091},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',54416022,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56093,'神格副本(94)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56092},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',56047052,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56094,'神格副本(95)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56093},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',57726991,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56095,'神格副本(96)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56094},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',59457240,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56096,'神格副本(97)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56095},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',61239449,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56097,'神格副本(98)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56096},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',63075200,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56098,'神格副本(99)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56097},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',64965959,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(56099,'神格副本(100)',21,0,0,'[]',0,'[]',0,0,5600,'[]','[]',2,0,0,0,1,0,38,5,'[{3,1}]','[{num,1,1},{lv,70},{finish_dun_id,56098},{safe_scene}]',0,0,0,0,'[]','[{5600,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{5600,[{1,[{revive,3421,5703}],[]}]}]','[{5600,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{5600,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',66913430,'[]',1,'[]','[]','[]',0,'[]','[]','[]'),(60000,'重铸副本【简单】',12,0,0,'[]',0,'[]',0,0,60000,'[60000]','[]',1,2,0,10,6,0,600,10,'[{1,2},{4,10}]','[{num,1,3},{lv,330}]',0,0,0,0,'[]','[{60000,[{1,1,[{is_calc_wave_num,0}],[]},{2,2,[],[{dungeon_time,7}]},{3,3,[],[{mon_event_id_kill_all_mon,2}]},{4,4,[],[{mon_event_id_kill_all_mon,3}]},{5,5,[],[{mon_event_id_kill_all_mon,4}]},{6,6,[],[{mon_event_id_kill_all_mon,5}]},{7,7,[],[{mon_event_id_kill_all_mon,6}]}]}]','[]','[]','[{60000,[{1,[{revive,4915,2205}],[]}]}]','[{60000,[{0,[{quit_time,10}],[{mon_event_id_kill_all_mon,7}]}]}]','[{60000,[{0,[{quit_time,5}],[{dungeon_timeout}]},{0,[{quit_time,5}],[{kill_mon_num,600019,1}]}]}]','[]',3209112,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(60001,'重铸副本【普通】',12,0,0,'[]',0,'[]',0,0,60000,'[60000]','[]',1,2,0,10,6,0,600,10,'[{1,2},{4,10}]','[{num,1,3},{lv,375}]',0,0,0,0,'[]','[{60000,[{1,1,[{is_calc_wave_num,0}],[]},{2,2,[],[{dungeon_time,7}]},{3,3,[],[{mon_event_id_kill_all_mon,2}]},{4,4,[],[{mon_event_id_kill_all_mon,3}]},{5,5,[],[{mon_event_id_kill_all_mon,4}]},{6,6,[],[{mon_event_id_kill_all_mon,5}]},{7,7,[],[{mon_event_id_kill_all_mon,6}]}]}]','[]','[]','[{60000,[{1,[{revive,4915,2205}],[]}]}]','[{60000,[{0,[{quit_time,10}],[{mon_event_id_kill_all_mon,7}]}]}]','[{60000,[{0,[{quit_time,5}],[{dungeon_timeout}]},{0,[{quit_time,5}],[{kill_mon_num,600039,1}]}]}]','[]',4927239,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(60002,'重铸副本【困难】',12,0,0,'[]',0,'[]',0,0,60000,'[60000]','[]',1,2,0,10,6,0,600,10,'[{1,2},{4,10}]','[{num,1,3},{lv,420}]',0,0,0,0,'[]','[{60000,[{1,1,[{is_calc_wave_num,0}],[]},{2,2,[],[{dungeon_time,7}]},{3,3,[],[{mon_event_id_kill_all_mon,2}]},{4,4,[],[{mon_event_id_kill_all_mon,3}]},{5,5,[],[{mon_event_id_kill_all_mon,4}]},{6,6,[],[{mon_event_id_kill_all_mon,5}]},{7,7,[],[{mon_event_id_kill_all_mon,6}]}]}]','[]','[]','[{60000,[{1,[{revive,4915,2205}],[]}]}]','[{60000,[{0,[{quit_time,10}],[{mon_event_id_kill_all_mon,7}]}]}]','[{60000,[{0,[{quit_time,5}],[{dungeon_timeout}]},{0,[{quit_time,5}],[{kill_mon_num,600059,1}]}]}]','[]',6805165,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(60003,'重铸副本【噩梦】',12,0,0,'[]',0,'[]',0,0,60000,'[60000]','[]',1,2,0,10,6,0,600,10,'[{1,2},{4,10}]','[{num,1,3},{lv,540}]',0,0,0,0,'[]','[{60000,[{1,1,[{is_calc_wave_num,0}],[]},{2,2,[],[{dungeon_time,7}]},{3,3,[],[{mon_event_id_kill_all_mon,2}]},{4,4,[],[{mon_event_id_kill_all_mon,3}]},{5,5,[],[{mon_event_id_kill_all_mon,4}]},{6,6,[],[{mon_event_id_kill_all_mon,5}]},{7,7,[],[{mon_event_id_kill_all_mon,6}]}]}]','[]','[]','[{60000,[{1,[{revive,4915,2205}],[]}]}]','[{60000,[{0,[{quit_time,10}],[{mon_event_id_kill_all_mon,7}]}]}]','[{60000,[{0,[{quit_time,5}],[{dungeon_timeout}]},{0,[{quit_time,5}],[{kill_mon_num,600079,1}]}]}]','[]',13721805,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(60004,'重铸副本【炼狱】',12,0,0,'[]',0,'[]',0,0,60000,'[60000]','[]',1,2,0,10,6,0,600,10,'[{1,2},{4,10}]','[{num,1,3},{lv,630}]',0,0,0,0,'[]','[{60000,[{1,1,[{is_calc_wave_num,0}],[]},{2,2,[],[{dungeon_time,7}]},{3,3,[],[{mon_event_id_kill_all_mon,2}]},{4,4,[],[{mon_event_id_kill_all_mon,3}]},{5,5,[],[{mon_event_id_kill_all_mon,4}]},{6,6,[],[{mon_event_id_kill_all_mon,5}]},{7,7,[],[{mon_event_id_kill_all_mon,6}]}]}]','[]','[]','[{60000,[{1,[{revive,4915,2205}],[]}]}]','[{60000,[{0,[{quit_time,10}],[{mon_event_id_kill_all_mon,7}]}]}]','[{60000,[{0,[{quit_time,5}],[{dungeon_timeout}]},{0,[{quit_time,5}],[{kill_mon_num,600099,1}]}]}]','[]',20539426,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(70001,'降神塔I',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',3051590,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70002,'降神塔I',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70001},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',3173675,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70003,'降神塔I',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70002},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',3295765,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70004,'降神塔I',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70003},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',3417750,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70005,'降神塔I',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70004},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',3723020,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70006,'降神塔I',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70005},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',3845005,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70007,'降神塔I',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70006},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',3967095,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70008,'降神塔I',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70007},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',4089080,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70009,'降神塔I',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70008},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',4211270,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70010,'降神塔I',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70009},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',4668893,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70011,'降神塔II',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70010},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',4516340,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70012,'降神塔II',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70011},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',4760515,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70013,'降神塔II',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70012},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',5004590,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70014,'降神塔II',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70013},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',5248765,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70015,'降神塔II',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70014},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',5706488,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70016,'降神塔II',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70015},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',5950563,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70017,'降神塔II',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70016},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',6194738,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70018,'降神塔II',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70017},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',6438813,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70019,'降神塔II',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70018},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',6682988,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70020,'降神塔II',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70019},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',7445840,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70021,'降神塔III',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70020},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',7171238,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70022,'降神塔III',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70021},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',7537383,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70023,'降神塔III',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70022},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',7903563,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70024,'降神塔III',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70023},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',8269808,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70025,'降神塔III',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70024},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',8880063,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70026,'降神塔III',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70025},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',9246308,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70027,'降神塔III',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70026},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',9612488,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70028,'降神塔III',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70027},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',9978633,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70029,'降神塔III',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70028},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',10344813,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70030,'降神塔III',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70029},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',11412830,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70031,'降神塔IV',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70030},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',11016143,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70032,'降神塔IV',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70031},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',11504393,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70033,'降神塔IV',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70032},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',11992643,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70034,'降神塔IV',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70033},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',12480893,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70035,'降神塔IV',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70034},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',13243845,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70036,'降神塔IV',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70035},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',13732095,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70037,'降神塔IV',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70036},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',14220345,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70038,'降神塔IV',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70037},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',14708595,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70039,'降神塔IV',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70038},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',15196845,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70040,'降神塔IV',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70039},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',16570058,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70041,'降神塔V',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70040},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',16051255,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70042,'降神塔V',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70041},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',16661595,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70043,'降神塔V',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70042},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',17271830,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70044,'降神塔V',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70043},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',17882270,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70045,'降神塔V',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70044},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',18797675,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70046,'降神塔V',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70045},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',19408015,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70047,'降神塔V',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70046},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',20018250,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70048,'降神塔V',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70047},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',20628590,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70049,'降神塔V',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70048},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',21238925,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70050,'降神塔V',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70049},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',22917308,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70051,'降神塔VI',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70050},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',22276520,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70052,'降神塔VI',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70051},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',23008845,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70053,'降神塔VI',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70052},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',23741270,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70054,'降神塔VI',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70053},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',24473595,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70055,'降神塔VI',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70054},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',25541538,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70056,'降神塔VI',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70055},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',26273963,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70057,'降神塔VI',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70056},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',27006288,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70058,'降神塔VI',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70057},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',27738713,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70059,'降神塔VI',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70058},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',28471038,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70060,'降神塔VI',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70059},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',30454580,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70061,'降神塔VII',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70060},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',29691713,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70062,'降神塔VII',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70061},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',30546143,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70063,'降神塔VII',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70062},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',31400538,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70064,'降神塔VII',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70063},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',32254968,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70065,'降神塔VII',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70064},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',33475643,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70066,'降神塔VII',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70065},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',34330038,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70067,'降神塔VII',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70066},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',35184468,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70068,'降神塔VII',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70067},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',36038963,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70069,'降神塔VII',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70068},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',36893393,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70070,'降神塔VII',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70069},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',39182090,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70071,'降神塔VIII',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70070},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',38297133,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70072,'降神塔VIII',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70071},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',39273633,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70073,'降神塔VIII',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70072},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',40250133,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70074,'降神塔VIII',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70073},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',41226633,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70075,'降神塔VIII',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70074},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',42599840,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70076,'降神塔VIII',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70075},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',43576340,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70077,'降神塔VIII',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70076},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',44552840,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70078,'降神塔VIII',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70077},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',45529340,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70079,'降神塔VIII',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70078},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',46505840,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70080,'降神塔VIII',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70079},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',49099643,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70081,'降神塔IX',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70080},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',48092675,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70082,'降神塔IX',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70081},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',49191265,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70083,'降神塔IX',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70082},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',50289750,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70084,'降神塔IX',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70083},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',51388340,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70085,'降神塔IX',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70084},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',52914080,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70086,'降神塔IX',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70085},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',54012770,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70087,'降神塔IX',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70086},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',55111255,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70088,'降神塔IX',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70087},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',56209845,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70089,'降神塔IX',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70088},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',57308330,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70090,'降神塔IX',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70089},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',60207288,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70091,'降神塔X',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70090},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',59078250,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70092,'降神塔X',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70091},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',60298925,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70093,'降神塔X',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70092},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',61519500,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70094,'降神塔X',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70093},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',62740175,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70095,'降神塔X',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70094},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',64418558,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70096,'降神塔X',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70095},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',65639133,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70097,'降神塔X',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70096},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',66859808,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70098,'降神塔X',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70097},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',68080383,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70099,'降神塔X',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70098},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',69301058,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70100,'降神塔X',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70099},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',72505175,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70101,'降神塔XI',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70100},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',71254058,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70102,'降神塔XI',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70101},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',72596738,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70103,'降神塔XI',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70102},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',73939383,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70104,'降神塔XI',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70103},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',75282063,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70105,'降神塔XI',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70104},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',77113058,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70106,'降神塔XI',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70105},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',78455738,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70107,'降神塔XI',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70106},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',79798383,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70108,'降神塔XI',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70107},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',81141063,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70109,'降神塔XI',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70108},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',82483808,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70110,'降神塔XI',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70109},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',85993095,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70111,'降神塔XII',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70110},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',84619788,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70112,'降神塔XII',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70111},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',86084538,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70113,'降神塔XII',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70112},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',87549288,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70114,'降神塔XII',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70113},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',89014038,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70115,'降神塔XII',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70114},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',90997580,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70116,'降神塔XII',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70115},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',92462330,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70117,'降神塔XII',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70116},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',93927080,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70118,'降神塔XII',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70117},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',95391830,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70119,'降神塔XII',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70118},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',96856580,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(70120,'降神塔XII',9,0,0,'[]',1,'[]',0,0,7700,'[]','[]',2,0,0,0,1,0,59,3,'[{3,1}]','[{num,1,1},{lv,345},{finish_dun_id,70119},{safe_scene}]',1,9999,0,0,'[]','[{7700,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{7700,[{1,[{revive,3982,3578}],[]}]}]','[{7700,[{0,[{quit_time,12}],[{mon_event_id_kill_all_mon,1}]}]}]','[{7700,[{0,[{quit_time,12}],[{dungeon_timeout}]},{0,[{quit_time,12}],[{role_hp_rate,0}]}]}]','[]',100671063,'[]',1,'[]','[]','[]',1,'[{1,[{2,36020001,50}]},{2,[{2,36020001,60}]},{3,[{2,36020001,75}]},{4,[{2,36020001,90}]},{5,[{2,36020001,100}]},{6,[{2,36020001,120}]},{7,[{2,36020001,120}]},{8,[{2,36020001,120}]},{9,[{2,36020001,120}]},{10,[{2,36020001,120}]}]','[]','[]'),(134102,'个人BOSS',10,0,0,'[{38030002,1}]',0,'[]',0,0,1341,'[]','[]',1,2,0,10,1,0,1200,5,'[{1,2}]','[{num,1,1},{lv,120},{safe_scene}]',0,0,0,0,'[]','[{1341,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{1341,[{1,[{revive,2006,2852}],[]}]}]','[{1341,[{0,[{quit_time,20}],[{mon_event_id_kill_all_mon,1}]}]}]','[{1341,[{0,[],[{dungeon_timeout}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(134103,'个人BOSS',10,0,0,'[{38030002,1}]',0,'[]',0,0,1341,'[]','[]',1,2,0,10,1,0,1200,5,'[{1,2}]','[{num,1,1},{lv,150},{safe_scene}]',0,0,0,0,'[]','[{1341,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{1341,[{1,[{revive,2006,2852}],[]}]}]','[{1341,[{0,[{quit_time,20}],[{mon_event_id_kill_all_mon,1}]}]}]','[{1341,[{0,[],[{dungeon_timeout}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(134104,'个人BOSS',10,0,0,'[{38030002,1}]',0,'[]',0,0,1341,'[]','[]',1,2,0,10,1,0,1200,5,'[{1,2}]','[{num,1,1},{lv,200},{safe_scene}]',0,0,0,0,'[]','[{1341,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{1341,[{1,[{revive,2006,2852}],[]}]}]','[{1341,[{0,[{quit_time,20}],[{mon_event_id_kill_all_mon,1}]}]}]','[{1341,[{0,[],[{dungeon_timeout}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(134105,'个人BOSS',10,0,0,'[{38030002,1}]',0,'[]',0,0,1341,'[]','[]',1,2,0,10,1,0,1200,5,'[{1,2}]','[{num,1,1},{lv,250},{safe_scene}]',0,0,0,0,'[]','[{1341,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{1341,[{1,[{revive,2006,2852}],[]}]}]','[{1341,[{0,[{quit_time,20}],[{mon_event_id_kill_all_mon,1}]}]}]','[{1341,[{0,[],[{dungeon_timeout}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(134106,'个人BOSS',10,0,0,'[{38030002,1}]',0,'[]',0,0,1341,'[]','[]',1,2,0,10,1,0,1200,5,'[{1,2}]','[{num,1,1},{lv,300},{safe_scene}]',0,0,0,0,'[]','[{1341,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{1341,[{1,[{revive,2006,2852}],[]}]}]','[{1341,[{0,[{quit_time,20}],[{mon_event_id_kill_all_mon,1}]}]}]','[{1341,[{0,[],[{dungeon_timeout}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(134107,'个人BOSS',10,0,0,'[{38030002,1}]',0,'[]',0,0,1341,'[]','[]',1,2,0,10,1,0,1200,5,'[{1,2}]','[{num,1,1},{lv,350},{safe_scene}]',0,0,0,0,'[]','[{1341,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{1341,[{1,[{revive,2006,2852}],[]}]}]','[{1341,[{0,[{quit_time,20}],[{mon_event_id_kill_all_mon,1}]}]}]','[{1341,[{0,[],[{dungeon_timeout}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(134108,'个人BOSS',10,0,0,'[{38030002,1}]',0,'[]',0,0,1341,'[]','[]',1,2,0,10,1,0,1200,5,'[{1,2}]','[{num,1,1},{lv,400},{safe_scene}]',0,0,0,0,'[]','[{1341,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{1341,[{1,[{revive,2006,2852}],[]}]}]','[{1341,[{0,[{quit_time,20}],[{mon_event_id_kill_all_mon,1}]}]}]','[{1341,[{0,[],[{dungeon_timeout}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(134109,'个人BOSS',10,0,0,'[{38030002,1}]',0,'[]',0,0,1341,'[]','[]',1,2,0,10,1,0,1200,5,'[{1,2}]','[{num,1,1},{lv,450},{safe_scene}]',0,0,0,0,'[]','[{1341,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{1341,[{1,[{revive,2006,2852}],[]}]}]','[{1341,[{0,[{quit_time,20}],[{mon_event_id_kill_all_mon,1}]}]}]','[{1341,[{0,[],[{dungeon_timeout}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(134110,'个人BOSS',10,0,0,'[{38030002,1}]',0,'[]',0,0,1341,'[]','[]',1,2,0,10,1,0,1200,5,'[{1,2}]','[{num,1,1},{lv,500},{safe_scene}]',0,0,0,0,'[]','[{1341,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{1341,[{1,[{revive,2006,2852}],[]}]}]','[{1341,[{0,[{quit_time,20}],[{mon_event_id_kill_all_mon,1}]}]}]','[{1341,[{0,[],[{dungeon_timeout}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(134111,'个人BOSS',10,0,0,'[{38030002,1}]',0,'[]',0,0,1341,'[]','[]',1,2,0,10,1,0,1200,5,'[{1,2}]','[{num,1,1},{lv,550},{safe_scene}]',0,0,0,0,'[]','[{1341,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{1341,[{1,[{revive,2006,2852}],[]}]}]','[{1341,[{0,[{quit_time,20}],[{mon_event_id_kill_all_mon,1}]}]}]','[{1341,[{0,[],[{dungeon_timeout}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(134112,'个人BOSS',10,0,0,'[{38030002,1}]',0,'[]',0,0,1341,'[]','[]',1,2,0,10,1,0,1200,5,'[{1,2}]','[{num,1,1},{lv,600},{safe_scene}]',0,0,0,0,'[]','[{1341,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{1341,[{1,[{revive,2006,2852}],[]}]}]','[{1341,[{0,[{quit_time,20}],[{mon_event_id_kill_all_mon,1}]}]}]','[{1341,[{0,[],[{dungeon_timeout}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(134113,'个人BOSS',10,0,0,'[{38030002,1}]',0,'[]',0,0,1341,'[]','[]',1,2,0,10,1,0,1200,5,'[{1,2}]','[{num,1,1},{lv,650},{safe_scene}]',0,0,0,0,'[]','[{1341,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{1341,[{1,[{revive,2006,2852}],[]}]}]','[{1341,[{0,[{quit_time,20}],[{mon_event_id_kill_all_mon,1}]}]}]','[{1341,[{0,[],[{dungeon_timeout}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(134114,'个人BOSS',10,0,0,'[{38030002,1}]',0,'[]',0,0,1341,'[]','[]',1,2,0,10,1,0,1200,5,'[{1,2}]','[{num,1,1},{lv,700},{safe_scene}]',0,0,0,0,'[]','[{1341,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{1341,[{1,[{revive,2006,2852}],[]}]}]','[{1341,[{0,[{quit_time,20}],[{mon_event_id_kill_all_mon,1}]}]}]','[{1341,[{0,[],[{dungeon_timeout}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(134115,'个人BOSS',10,0,0,'[{38030002,1}]',0,'[]',0,0,1341,'[]','[]',1,2,0,10,1,0,1200,5,'[{1,2}]','[{num,1,1},{lv,750},{safe_scene}]',0,0,0,0,'[]','[{1341,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{1341,[{1,[{revive,2006,2852}],[]}]}]','[{1341,[{0,[{quit_time,20}],[{mon_event_id_kill_all_mon,1}]}]}]','[{1341,[{0,[],[{dungeon_timeout}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(134116,'新手boss副本',24,0,0,'[]',0,'[]',0,0,10010,'[10010]','[]',2,2,0,5,1,0,300,1,'[{3,1}]','[{num,1,1},{lv,10},{safe_scene}]',0,0,0,0,'[]','[{10010,[{1,2,[],[{dungeon_time,1}]},{2,1,[],[{dungeon_time,1}]}]}]','[]','[]','[{10010,[{1,[{revive,12388,3988}],[]}]}]','[{10010,[{0,[],[{dungeon_timeout}]},{0,[{quit_time,8}],[{mon_event_id_kill_all_mon,2}]}]}]','[]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]'),(134117,'个人BOSS',10,0,0,'[{38030002,1}]',0,'[]',0,0,1341,'[]','[]',1,2,0,10,1,0,1200,5,'[{1,2}]','[{num,1,1},{lv,800},{safe_scene}]',0,0,0,0,'[]','[{1341,[{1,1,[],[{dungeon_time,3}]}]}]','[]','[]','[{1341,[{1,[{revive,2006,2852}],[]}]}]','[{1341,[{0,[{quit_time,20}],[{mon_event_id_kill_all_mon,1}]}]}]','[{1341,[{0,[],[{dungeon_timeout}]}]}]','[]',0,'[]',0,'[]','[]','[]',0,'[]','[]','[]');
/*!40000 ALTER TABLE `base_dungeon` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_dungeon_attr_crush`
--

DROP TABLE IF EXISTS `base_dungeon_attr_crush`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_dungeon_attr_crush` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '属性',
  `attr_r` double unsigned NOT NULL DEFAULT '0' COMMENT '属性比',
  `crush_r` double unsigned NOT NULL DEFAULT '0' COMMENT '碾压参数',
  PRIMARY KEY (`id`,`attr_r`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_dungeon_attr_crush`
--

LOCK TABLES `base_dungeon_attr_crush` WRITE;
/*!40000 ALTER TABLE `base_dungeon_attr_crush` DISABLE KEYS */;
INSERT INTO `base_dungeon_attr_crush` VALUES (1,0.02,0.05),(1,0.05,0.1),(1,0.08,0.15),(1,0.11,0.25),(1,0.14,0.45),(1,0.17,0.65),(1,0.2,0.85),(1,0.23,1.05),(1,0.26,1.35),(1,0.29,1.5),(1,0.32,1.6),(1,0.35,1.7),(1,0.38,1.8),(1,0.41,1.9),(1,0.44,2),(1,0.47,2.1),(1,0.5,2.2),(1,1,2.5),(2,0.02,0.05),(2,0.05,0.1),(2,0.08,0.15),(2,0.11,0.25),(2,0.14,0.45),(2,0.17,0.65),(2,0.2,0.85),(2,0.23,1.05),(2,0.26,1.35),(2,0.29,1.5),(2,0.32,1.6),(2,0.35,1.7),(2,0.38,1.8),(2,0.41,1.9),(2,0.44,2),(2,0.47,2.1),(2,0.5,2.2),(2,1,2.5),(3,0.02,0.05),(3,0.05,0.1),(3,0.08,0.15),(3,0.11,0.25),(3,0.14,0.45),(3,0.17,0.65),(3,0.2,0.85),(3,0.23,1.05),(3,0.26,1.35),(3,0.29,1.5),(3,0.32,1.6),(3,0.35,1.7),(3,0.38,1.8),(3,0.41,1.9),(3,0.44,2),(3,0.47,2.1),(3,0.5,2.2),(3,1,2.5),(4,0.02,0.05),(4,0.05,0.1),(4,0.08,0.15),(4,0.11,0.25),(4,0.14,0.45),(4,0.17,0.65),(4,0.2,0.85),(4,0.23,1.05),(4,0.26,1.35),(4,0.29,1.5),(4,0.32,1.6),(4,0.35,1.7),(4,0.38,1.8),(4,0.41,1.9),(4,0.44,2),(4,0.47,2.1),(4,0.5,2.2),(4,1,2.5),(5,0.02,0.05),(5,0.05,0.1),(5,0.08,0.15),(5,0.11,0.25),(5,0.14,0.45),(5,0.17,0.65),(5,0.2,0.85),(5,0.23,1.05),(5,0.26,1.35),(5,0.29,1.5),(5,0.32,1.6),(5,0.35,1.7),(5,0.38,1.8),(5,0.41,1.9),(5,0.44,2),(5,0.47,2.1),(5,0.5,2.2),(5,1,2.5),(6,0.02,0.05),(6,0.05,0.1),(6,0.08,0.15),(6,0.11,0.25),(6,0.14,0.45),(6,0.17,0.65),(6,0.2,0.85),(6,0.23,1.05),(6,0.26,1.35),(6,0.29,1.5),(6,0.32,1.6),(6,0.35,1.7),(6,0.38,1.8),(6,0.41,1.9),(6,0.44,2),(6,0.47,2.1),(6,0.5,2.2),(6,1,2.5),(7,0.02,0.05),(7,0.05,0.1),(7,0.08,0.15),(7,0.11,0.25),(7,0.14,0.45),(7,0.17,0.65),(7,0.2,0.85),(7,0.23,1.05),(7,0.26,1.35),(7,0.29,1.5),(7,0.32,1.6),(7,0.35,1.7),(7,0.38,1.8),(7,0.41,1.9),(7,0.44,2),(7,0.47,2.1),(7,0.5,2.2),(7,1,2.5),(8,0.02,0.05),(8,0.05,0.1),(8,0.08,0.15),(8,0.11,0.25),(8,0.14,0.45),(8,0.17,0.65),(8,0.2,0.85),(8,0.23,1.05),(8,0.26,1.35),(8,0.29,1.5),(8,0.32,1.6),(8,0.35,1.7),(8,0.38,1.8),(8,0.41,1.9),(8,0.44,2),(8,0.47,2.1),(8,0.5,2.2),(8,1,2.5);
/*!40000 ALTER TABLE `base_dungeon_attr_crush` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_dungeon_clear`
--

DROP TABLE IF EXISTS `base_dungeon_clear`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_dungeon_clear` (
  `dun_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '副本id',
  `scene_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '场景id',
  `wave_list` text NOT NULL COMMENT '对应的波数##[{波数类型, 波数子类型}]',
  `clear_mon_list` text NOT NULL COMMENT '清理的怪物列表##[MonId,...]',
  PRIMARY KEY (`dun_id`,`scene_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='副本清理配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_dungeon_clear`
--

LOCK TABLES `base_dungeon_clear` WRITE;
/*!40000 ALTER TABLE `base_dungeon_clear` DISABLE KEYS */;
INSERT INTO `base_dungeon_clear` VALUES (2100,2100,'[{11,1},{12,1},{13,1},{14,1}]','[2100016,2100017,2100018,2100019,2100020,2100021,2100022,2100023,2100024,2100025]');
/*!40000 ALTER TABLE `base_dungeon_clear` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_dungeon_dynamic_event`
--

DROP TABLE IF EXISTS `base_dungeon_dynamic_event`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_dungeon_dynamic_event` (
  `dun_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本id',
  `wave_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '波数',
  `wave_list` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '波数概率事件',
  PRIMARY KEY (`dun_id`,`wave_type`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_dungeon_dynamic_event`
--

LOCK TABLES `base_dungeon_dynamic_event` WRITE;
/*!40000 ALTER TABLE `base_dungeon_dynamic_event` DISABLE KEYS */;
INSERT INTO `base_dungeon_dynamic_event` VALUES (3300,1,'[{500,[{1,[{1,[],[{dungeon_time,5}]},{5,[{is_calc_wave_num,0}],[]}],1}]},{500,[{1,[{17,[],[{dungeon_time,5}]},{21,[{is_calc_wave_num,0}],[]}],1}]}]'),(3300,2,'[{200,[{1,[{2,[],[]},{6,[{is_calc_wave_num,0}],[]}],2}]},{200,[{1,[{10,[],[]},{14,[{is_calc_wave_num,0}],[]}],5}]},{200,[{1,[{18,[],[]},{22,[{is_calc_wave_num,0}],[]}],2}]},{200,[{1,[{26,[],[]},{30,[{is_calc_wave_num,0}],[]}],5}]},{200,[{1,[{34,[],[]},{7,[{is_calc_wave_num,0}],[]}],3}]}]'),(3300,3,'[{200,[{1,[{3,[],[]},{7,[{is_calc_wave_num,0}],[]}],3}]},{200,[{1,[{11,[],[]},{15,[{is_calc_wave_num,0}],[]}],6}]},{200,[{1,[{19,[],[]},{23,[{is_calc_wave_num,0}],[]}],3}]},{200,[{1,[{27,[],[]},{31,[{is_calc_wave_num,0}],[]}],6}]},{200,[{1,[{33,[],[]},{15,[{is_calc_wave_num,0}],[]}],6}]}]'),(3300,4,'[{250,[{1,[{4,[],[]},{8,[{is_calc_wave_num,0}],[]}],4}]},{250,[{1,[{12,[],[]},{16,[{is_calc_wave_num,0}],[]}],6}]},{250,[{3,[{[4,1,[{mon,1003001,7138,17240,1}]],[]},[{20,[{is_calc_wave_num,0}],[]},{24,[{is_calc_wave_num,0}],[]}]],4}]},{250,[{3,[{[4,2,[{mon,1003001,17112,18086,1}]],[]},[{28,[{is_calc_wave_num,0}],[]},{32,[{is_calc_wave_num,0}],[]}]],6}]}]'),(3301,1,'[{500,[{1,[{1,[],[{dungeon_time,5}]},{5,[{is_calc_wave_num,0}],[]}],1}]},{500,[{1,[{17,[],[{dungeon_time,5}]},{21,[{is_calc_wave_num,0}],[]}],1}]}]'),(3301,2,'[{200,[{1,[{2,[],[]},{6,[{is_calc_wave_num,0}],[]}],2}]},{200,[{1,[{10,[],[]},{14,[{is_calc_wave_num,0}],[]}],5}]},{200,[{1,[{18,[],[]},{22,[{is_calc_wave_num,0}],[]}],2}]},{200,[{1,[{26,[],[]},{30,[{is_calc_wave_num,0}],[]}],5}]},{200,[{1,[{34,[],[]},{7,[{is_calc_wave_num,0}],[]}],3}]}]'),(3301,3,'[{200,[{1,[{3,[],[]},{7,[{is_calc_wave_num,0}],[]}],3}]},{200,[{1,[{11,[],[]},{15,[{is_calc_wave_num,0}],[]}],6}]},{200,[{1,[{19,[],[]},{23,[{is_calc_wave_num,0}],[]}],3}]},{200,[{1,[{27,[],[]},{31,[{is_calc_wave_num,0}],[]}],6}]},{200,[{1,[{33,[],[]},{15,[{is_calc_wave_num,0}],[]}],6}]}]'),(3301,4,'[{250,[{1,[{4,[],[]},{8,[{is_calc_wave_num,0}],[]}],4}]},{250,[{1,[{12,[],[]},{16,[{is_calc_wave_num,0}],[]}],6}]},{250,[{3,[{[4,1,[{mon,1003001,7138,17240,1}]],[]},[{20,[{is_calc_wave_num,0}],[]},{24,[{is_calc_wave_num,0}],[]}]],4}]},{250,[{3,[{[4,2,[{mon,1003001,17112,18086,1}]],[]},[{28,[{is_calc_wave_num,0}],[]},{32,[{is_calc_wave_num,0}],[]}]],6}]}]'),(3302,1,'[{500,[{1,[{1,[],[{dungeon_time,5}]},{5,[{is_calc_wave_num,0}],[]}],1}]},{500,[{1,[{17,[],[{dungeon_time,5}]},{21,[{is_calc_wave_num,0}],[]}],1}]}]'),(3302,2,'[{200,[{1,[{2,[],[]},{6,[{is_calc_wave_num,0}],[]}],2}]},{200,[{1,[{10,[],[]},{14,[{is_calc_wave_num,0}],[]}],5}]},{200,[{1,[{18,[],[]},{22,[{is_calc_wave_num,0}],[]}],2}]},{200,[{1,[{26,[],[]},{30,[{is_calc_wave_num,0}],[]}],5}]},{200,[{1,[{34,[],[]},{7,[{is_calc_wave_num,0}],[]}],3}]}]'),(3302,3,'[{200,[{1,[{3,[],[]},{7,[{is_calc_wave_num,0}],[]}],3}]},{200,[{1,[{11,[],[]},{15,[{is_calc_wave_num,0}],[]}],6}]},{200,[{1,[{19,[],[]},{23,[{is_calc_wave_num,0}],[]}],3}]},{200,[{1,[{27,[],[]},{31,[{is_calc_wave_num,0}],[]}],6}]},{200,[{1,[{33,[],[]},{15,[{is_calc_wave_num,0}],[]}],6}]}]'),(3302,4,'[{250,[{1,[{4,[],[]},{8,[{is_calc_wave_num,0}],[]}],4}]},{250,[{1,[{12,[],[]},{16,[{is_calc_wave_num,0}],[]}],6}]},{250,[{3,[{[4,1,[{mon,1003001,7138,17240,1}]],[]},[{20,[{is_calc_wave_num,0}],[]},{24,[{is_calc_wave_num,0}],[]}]],4}]},{250,[{3,[{[4,2,[{mon,1003001,17112,18086,1}]],[]},[{28,[{is_calc_wave_num,0}],[]},{32,[{is_calc_wave_num,0}],[]}]],6}]}]'),(3303,1,'[{500,[{1,[{1,[],[{dungeon_time,5}]},{5,[{is_calc_wave_num,0}],[]}],1}]},{500,[{1,[{17,[],[{dungeon_time,5}]},{21,[{is_calc_wave_num,0}],[]}],1}]}]'),(3303,2,'[{200,[{1,[{2,[],[]},{6,[{is_calc_wave_num,0}],[]}],2}]},{200,[{1,[{10,[],[]},{14,[{is_calc_wave_num,0}],[]}],5}]},{200,[{1,[{18,[],[]},{22,[{is_calc_wave_num,0}],[]}],2}]},{200,[{1,[{26,[],[]},{30,[{is_calc_wave_num,0}],[]}],5}]},{200,[{1,[{34,[],[]},{7,[{is_calc_wave_num,0}],[]}],3}]}]'),(3303,3,'[{200,[{1,[{3,[],[]},{7,[{is_calc_wave_num,0}],[]}],3}]},{200,[{1,[{11,[],[]},{15,[{is_calc_wave_num,0}],[]}],6}]},{200,[{1,[{19,[],[]},{23,[{is_calc_wave_num,0}],[]}],3}]},{200,[{1,[{27,[],[]},{31,[{is_calc_wave_num,0}],[]}],6}]},{200,[{1,[{33,[],[]},{15,[{is_calc_wave_num,0}],[]}],6}]}]'),(3303,4,'[{250,[{1,[{4,[],[]},{8,[{is_calc_wave_num,0}],[]}],4}]},{250,[{1,[{12,[],[]},{16,[{is_calc_wave_num,0}],[]}],6}]},{250,[{3,[{[4,1,[{mon,1003001,7138,17240,1}]],[]},[{20,[{is_calc_wave_num,0}],[]},{24,[{is_calc_wave_num,0}],[]}]],4}]},{250,[{3,[{[4,2,[{mon,1003001,17112,18086,1}]],[]},[{28,[{is_calc_wave_num,0}],[]},{32,[{is_calc_wave_num,0}],[]}]],6}]}]'),(3304,1,'[{500,[{1,[{1,[],[{dungeon_time,5}]},{5,[{is_calc_wave_num,0}],[]}],1}]},{500,[{1,[{17,[],[{dungeon_time,5}]},{21,[{is_calc_wave_num,0}],[]}],1}]}]'),(3304,2,'[{200,[{1,[{2,[],[]},{6,[{is_calc_wave_num,0}],[]}],2}]},{200,[{1,[{10,[],[]},{14,[{is_calc_wave_num,0}],[]}],5}]},{200,[{1,[{18,[],[]},{22,[{is_calc_wave_num,0}],[]}],2}]},{200,[{1,[{26,[],[]},{30,[{is_calc_wave_num,0}],[]}],5}]},{200,[{1,[{34,[],[]},{7,[{is_calc_wave_num,0}],[]}],3}]}]'),(3304,3,'[{200,[{1,[{3,[],[]},{7,[{is_calc_wave_num,0}],[]}],3}]},{200,[{1,[{11,[],[]},{15,[{is_calc_wave_num,0}],[]}],6}]},{200,[{1,[{19,[],[]},{23,[{is_calc_wave_num,0}],[]}],3}]},{200,[{1,[{27,[],[]},{31,[{is_calc_wave_num,0}],[]}],6}]},{200,[{1,[{33,[],[]},{15,[{is_calc_wave_num,0}],[]}],6}]}]'),(3304,4,'[{250,[{1,[{4,[],[]},{8,[{is_calc_wave_num,0}],[]}],4}]},{250,[{1,[{12,[],[]},{16,[{is_calc_wave_num,0}],[]}],6}]},{250,[{3,[{[4,1,[{mon,1003001,7138,17240,1}]],[]},[{20,[{is_calc_wave_num,0}],[]},{24,[{is_calc_wave_num,0}],[]}]],4}]},{250,[{3,[{[4,2,[{mon,1003001,17112,18086,1}]],[]},[{28,[{is_calc_wave_num,0}],[]},{32,[{is_calc_wave_num,0}],[]}]],6}]}]');
/*!40000 ALTER TABLE `base_dungeon_dynamic_event` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_dungeon_fake_role`
--

DROP TABLE IF EXISTS `base_dungeon_fake_role`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_dungeon_fake_role` (
  `lv` smallint(5) unsigned NOT NULL COMMENT '假人等级',
  `attr_list` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '属性列表',
  `combat` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战力',
  PRIMARY KEY (`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='副本假人属性配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_dungeon_fake_role`
--

LOCK TABLES `base_dungeon_fake_role` WRITE;
/*!40000 ALTER TABLE `base_dungeon_fake_role` DISABLE KEYS */;
INSERT INTO `base_dungeon_fake_role` VALUES (1,'[{1,33},{2,660},{3,15},{4,15},{5,0},{6,0},{7,0},{8,0},{48,0},{49,0}]',2070),(2,'[{1,33},{2,740},{3,15},{4,15},{5,0},{6,0},{7,0},{8,0},{48,0},{49,0}]',2150),(3,'[{1,37},{2,820},{3,17},{4,17},{5,0},{6,0},{7,0},{8,0},{48,0},{49,0}]',2410),(4,'[{1,86},{2,900},{3,41},{4,19},{5,0},{6,0},{7,0},{8,0},{48,0},{49,0}]',4120),(5,'[{1,94},{2,1467},{3,45},{4,23},{5,0},{6,0},{7,0},{8,0},{48,0},{49,0}]',5047),(6,'[{1,94},{2,1547},{3,45},{4,35},{5,0},{6,0},{7,0},{8,0},{48,0},{49,0}]',5427),(7,'[{1,98},{2,1627},{3,47},{4,37},{5,0},{6,0},{7,0},{8,0},{48,0},{49,0}]',5687),(8,'[{1,102},{2,1707},{3,49},{4,39},{5,0},{6,0},{7,0},{8,0},{48,0},{49,0}]',5947),(9,'[{1,106},{2,1787},{3,51},{4,41},{5,0},{6,0},{7,0},{8,0},{48,0},{49,0}]',6207),(10,'[{1,114},{2,2354},{3,55},{4,45},{5,0},{6,0},{7,0},{8,0},{48,0},{49,0}]',7134),(11,'[{1,114},{2,2434},{3,55},{4,57},{5,0},{6,0},{7,0},{8,0},{48,0},{49,0}]',7514),(12,'[{1,118},{2,2514},{3,57},{4,59},{5,0},{6,0},{7,0},{8,0},{48,0},{49,0}]',7774),(13,'[{1,122},{2,2594},{3,59},{4,61},{5,0},{6,0},{7,0},{8,0},{48,0},{49,0}]',8034),(14,'[{1,130},{2,3161},{3,63},{4,65},{5,0},{6,0},{7,0},{8,0},{48,0},{49,0}]',8961),(15,'[{1,130},{2,3241},{3,63},{4,77},{5,0},{6,0},{7,0},{8,0},{48,0},{49,0}]',9341),(16,'[{1,138},{2,4052},{3,67},{4,81},{5,0},{6,0},{7,0},{8,0},{48,0},{49,0}]',10512),(17,'[{1,138},{2,4132},{3,67},{4,99},{5,0},{6,0},{7,0},{8,0},{48,0},{49,0}]',11042),(18,'[{1,142},{2,4212},{3,69},{4,101},{5,0},{6,0},{7,0},{8,0},{48,0},{49,0}]',11302),(19,'[{1,176},{2,4292},{3,86},{4,103},{5,0},{6,0},{7,0},{8,0},{48,0},{49,0}]',12537),(20,'[{1,180},{2,4372},{3,88},{4,105},{5,0},{6,0},{7,0},{8,0},{48,0},{49,0}]',12797),(21,'[{1,184},{2,4452},{3,90},{4,107},{5,0},{6,0},{7,0},{8,0},{48,0},{49,0}]',13057),(22,'[{1,218},{2,4532},{3,107},{4,109},{5,0},{6,0},{7,0},{8,0},{48,0},{49,0}]',14292),(23,'[{1,222},{2,4612},{3,109},{4,111},{5,0},{6,0},{7,0},{8,0},{48,0},{49,0}]',14552),(24,'[{1,411},{2,9658},{3,113},{4,115},{5,90},{6,90},{7,0},{8,0},{48,0},{49,0}]',32578),(25,'[{1,415},{2,10029},{3,115},{4,150},{5,90},{6,90},{7,0},{8,0},{48,0},{49,0}]',33954),(26,'[{1,434},{2,10873},{3,117},{4,152},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',36078),(27,'[{1,434},{2,10953},{3,117},{4,171},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',36633),(28,'[{1,438},{2,11033},{3,119},{4,173},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',36893),(29,'[{1,442},{2,11113},{3,121},{4,175},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',37153),(30,'[{1,450},{2,11593},{3,125},{4,179},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',37993),(31,'[{1,474},{2,12818},{3,127},{4,181},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',39798),(32,'[{1,474},{2,12898},{3,127},{4,210},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',40603),(33,'[{1,478},{2,12978},{3,129},{4,212},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',40863),(34,'[{1,528},{2,13058},{3,154},{4,214},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',42618),(35,'[{1,532},{2,13138},{3,156},{4,216},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',42878),(36,'[{1,606},{2,13218},{3,193},{4,218},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',45413),(37,'[{1,614},{2,13758},{3,197},{4,222},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',46313),(38,'[{1,637},{2,13838},{3,197},{4,222},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',46853),(39,'[{1,641},{2,13918},{3,199},{4,224},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',47113),(40,'[{1,645},{2,13998},{3,201},{4,226},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',47373),(41,'[{1,653},{2,14196},{3,205},{4,230},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',47931),(42,'[{1,653},{2,14276},{3,205},{4,233},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',48086),(43,'[{1,657},{2,14356},{3,207},{4,235},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',48346),(44,'[{1,665},{2,16436},{3,211},{4,239},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',50786),(45,'[{1,665},{2,16516},{3,211},{4,239},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',50866),(46,'[{1,673},{2,17360},{3,215},{4,243},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',52070),(47,'[{1,673},{2,17440},{3,215},{4,262},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',52625),(48,'[{1,677},{2,17520},{3,217},{4,264},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',52885),(49,'[{1,681},{2,17600},{3,219},{4,266},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',53145),(50,'[{1,685},{2,17680},{3,221},{4,268},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',53405),(51,'[{1,809},{2,27952},{3,275},{4,436},{5,128},{6,123},{7,26},{8,27},{48,0},{49,0}]',77107),(52,'[{1,823},{2,28034},{3,281},{4,443},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',78444),(53,'[{1,827},{2,28116},{3,283},{4,445},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',78706),(54,'[{1,831},{2,28198},{3,285},{4,447},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',78968),(55,'[{1,835},{2,28280},{3,287},{4,449},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',79230),(56,'[{1,1095},{2,28362},{3,437},{4,451},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',88312),(57,'[{1,1099},{2,28444},{3,439},{4,453},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',88574),(58,'[{1,1103},{2,28526},{3,441},{4,455},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',88836),(59,'[{1,1107},{2,28607},{3,443},{4,457},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',89097),(60,'[{1,1498},{2,32966},{3,649},{4,461},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',106526),(61,'[{1,1498},{2,33048},{3,649},{4,566},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',109233),(62,'[{1,1502},{2,33129},{3,651},{4,568},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',109494),(63,'[{1,1808},{2,33211},{3,811},{4,570},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',119746),(64,'[{1,1812},{2,33293},{3,813},{4,572},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',120008),(65,'[{1,1816},{2,33375},{3,815},{4,574},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',120270),(66,'[{1,1926},{2,37652},{3,873},{4,578},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',128297),(67,'[{1,1926},{2,37734},{3,873},{4,681},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',130954),(68,'[{1,1930},{2,37816},{3,875},{4,683},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',131216),(69,'[{1,1934},{2,37898},{3,877},{4,685},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',131478),(70,'[{1,1938},{2,37980},{3,879},{4,687},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',131740),(71,'[{1,1942},{2,38062},{3,881},{4,689},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',132002),(72,'[{1,1946},{2,38144},{3,883},{4,691},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',132264),(73,'[{1,1950},{2,38226},{3,886},{4,693},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',132551),(74,'[{1,1954},{2,38308},{3,888},{4,695},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',132813),(75,'[{1,1958},{2,38390},{3,890},{4,697},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',133075),(76,'[{1,1962},{2,38472},{3,892},{4,699},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',133337),(77,'[{1,1966},{2,38554},{3,894},{4,701},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',133599),(78,'[{1,1970},{2,38636},{3,896},{4,703},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',133861),(79,'[{1,1974},{2,38717},{3,898},{4,705},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',134122),(80,'[{1,1982},{2,39057},{3,902},{4,709},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',134822),(81,'[{1,1995},{2,39139},{3,902},{4,709},{5,132},{6,126},{7,35},{8,30},{48,0},{49,0}]',135464),(82,'[{1,1999},{2,39221},{3,904},{4,711},{5,132},{6,126},{7,35},{8,30},{48,0},{49,0}]',135726),(83,'[{1,2003},{2,39303},{3,907},{4,713},{5,132},{6,126},{7,35},{8,30},{48,0},{49,0}]',136013),(84,'[{1,2007},{2,39385},{3,909},{4,715},{5,132},{6,126},{7,35},{8,30},{48,0},{49,0}]',136275),(85,'[{1,2015},{2,39725},{3,913},{4,719},{5,132},{6,126},{7,35},{8,30},{48,0},{49,0}]',136975),(86,'[{1,2028},{2,39807},{3,913},{4,719},{5,132},{6,126},{7,35},{8,36},{48,0},{49,0}]',137617),(87,'[{1,2032},{2,39889},{3,915},{4,721},{5,132},{6,126},{7,35},{8,36},{48,0},{49,0}]',137879),(88,'[{1,2036},{2,39971},{3,917},{4,723},{5,132},{6,126},{7,35},{8,36},{48,0},{49,0}]',138141),(89,'[{1,2040},{2,40053},{3,919},{4,725},{5,132},{6,126},{7,35},{8,36},{48,0},{49,0}]',138403),(90,'[{1,2048},{2,40392},{3,923},{4,729},{5,132},{6,126},{7,35},{8,36},{48,0},{49,0}]',139102),(91,'[{1,2061},{2,40474},{3,923},{4,729},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',140644),(92,'[{1,2065},{2,40556},{3,925},{4,731},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',140906),(93,'[{1,2069},{2,40637},{3,927},{4,733},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',141167),(94,'[{1,2073},{2,40719},{3,930},{4,735},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',141454),(95,'[{1,2081},{2,41108},{3,934},{4,739},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',142203),(96,'[{1,2096},{2,41190},{3,934},{4,739},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',142585),(97,'[{1,2100},{2,41272},{3,936},{4,741},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',142847),(98,'[{1,2104},{2,41354},{3,938},{4,743},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',143109),(99,'[{1,2108},{2,41436},{3,940},{4,745},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',143371),(100,'[{1,2116},{2,64456},{3,944},{4,749},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',166751),(101,'[{1,3236},{2,64538},{3,944},{4,749},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',189233),(102,'[{1,3240},{2,64620},{3,946},{4,751},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',189495),(103,'[{1,3244},{2,64701},{3,948},{4,753},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',189756),(104,'[{1,3248},{2,64783},{3,951},{4,755},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',190043),(105,'[{1,3252},{2,64865},{3,953},{4,757},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',190305),(106,'[{1,3256},{2,64947},{3,955},{4,759},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',190567),(107,'[{1,3260},{2,65029},{3,957},{4,761},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',190829),(108,'[{1,3264},{2,65111},{3,959},{4,763},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',191091),(109,'[{1,3268},{2,65193},{3,961},{4,765},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',191353),(110,'[{1,3272},{2,65275},{3,963},{4,767},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',191615),(111,'[{1,3276},{2,65357},{3,965},{4,769},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',191877),(112,'[{1,3280},{2,65439},{3,967},{4,771},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',192139),(113,'[{1,3284},{2,65521},{3,969},{4,773},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',192401),(114,'[{1,3292},{2,63555},{3,974},{4,777},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',190820),(115,'[{1,3292},{2,63636},{3,974},{4,777},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',190901),(116,'[{1,3296},{2,63718},{3,976},{4,779},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',191163),(117,'[{1,3300},{2,63800},{3,978},{4,781},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',191425),(118,'[{1,3304},{2,63882},{3,980},{4,783},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',191687),(119,'[{1,3308},{2,63964},{3,982},{4,785},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',191949),(120,'[{1,3312},{2,64046},{3,984},{4,787},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',192211),(121,'[{1,3316},{2,64128},{3,986},{4,789},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',192473),(122,'[{1,3320},{2,64210},{3,988},{4,791},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',192735),(123,'[{1,3324},{2,64292},{3,990},{4,793},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',192997),(124,'[{1,3328},{2,64374},{3,992},{4,795},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',193259),(125,'[{1,3332},{2,64456},{3,995},{4,797},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',193546),(126,'[{1,3336},{2,64538},{3,997},{4,799},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',193808),(127,'[{1,3340},{2,64620},{3,999},{4,801},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',194070),(128,'[{1,3345},{2,64628},{3,1025},{4,814},{5,134},{6,127},{7,41},{8,42},{48,0},{49,0}]',194871),(129,'[{1,3350},{2,64637},{3,1052},{4,828},{5,131},{6,124},{7,41},{8,41},{48,0},{49,0}]',195673),(130,'[{1,3356},{2,64646},{3,1078},{4,841},{5,129},{6,121},{7,41},{8,41},{48,0},{49,0}]',196474),(131,'[{1,3361},{2,64655},{3,1105},{4,855},{5,126},{6,118},{7,40},{8,40},{48,0},{49,0}]',197275),(132,'[{1,3367},{2,64664},{3,1131},{4,868},{5,124},{6,115},{7,40},{8,40},{48,0},{49,0}]',198076),(133,'[{1,3372},{2,64673},{3,1158},{4,882},{5,121},{6,112},{7,40},{8,39},{48,0},{49,0}]',198878),(134,'[{1,3378},{2,64682},{3,1184},{4,895},{5,119},{6,109},{7,39},{8,39},{48,0},{49,0}]',199679),(135,'[{1,3383},{2,64690},{3,1211},{4,909},{5,116},{6,106},{7,39},{8,38},{48,0},{49,0}]',200480),(136,'[{1,3388},{2,64699},{3,1238},{4,923},{5,114},{6,103},{7,39},{8,38},{48,0},{49,0}]',201281),(137,'[{1,3394},{2,64708},{3,1264},{4,936},{5,111},{6,100},{7,38},{8,37},{48,0},{49,0}]',202083),(138,'[{1,3399},{2,64717},{3,1291},{4,950},{5,109},{6,97},{7,38},{8,37},{48,0},{49,0}]',202884),(139,'[{1,3405},{2,64726},{3,1317},{4,963},{5,106},{6,94},{7,38},{8,36},{48,0},{49,0}]',203685),(140,'[{1,3410},{2,64735},{3,1344},{4,977},{5,104},{6,91},{7,38},{8,36},{48,0},{49,0}]',204486),(141,'[{1,3416},{2,64744},{3,1370},{4,990},{5,101},{6,88},{7,37},{8,35},{48,0},{49,0}]',205288),(142,'[{1,3421},{2,64753},{3,1397},{4,1004},{5,99},{6,85},{7,37},{8,35},{48,0},{49,0}]',206089),(143,'[{1,3426},{2,64761},{3,1424},{4,1018},{5,96},{6,82},{7,37},{8,34},{48,0},{49,0}]',206890),(144,'[{1,3432},{2,64770},{3,1450},{4,1031},{5,94},{6,79},{7,36},{8,34},{48,0},{49,0}]',207691),(145,'[{1,3437},{2,64779},{3,1477},{4,1045},{5,91},{6,76},{7,36},{8,33},{48,0},{49,0}]',208493),(146,'[{1,3443},{2,64788},{3,1503},{4,1058},{5,89},{6,73},{7,36},{8,33},{48,0},{49,0}]',209294),(147,'[{1,3448},{2,64797},{3,1530},{4,1072},{5,86},{6,70},{7,35},{8,32},{48,0},{49,0}]',210095),(148,'[{1,3454},{2,64806},{3,1556},{4,1085},{5,84},{6,67},{7,35},{8,32},{48,0},{49,0}]',210896),(149,'[{1,3459},{2,64815},{3,1583},{4,1099},{5,81},{6,64},{7,35},{8,31},{48,0},{49,0}]',211698),(150,'[{1,3465},{2,64824},{3,1610},{4,1113},{5,79},{6,61},{7,35},{8,31},{48,0},{49,0}]',212499),(151,'[{1,3825},{2,64866},{3,1798},{4,1293},{5,79},{6,61},{7,35},{8,31},{48,0},{49,0}]',228941),(152,'[{1,3827},{2,64908},{3,1799},{4,1294},{5,79},{6,61},{7,35},{8,31},{48,0},{49,0}]',229073),(153,'[{1,3829},{2,64950},{3,1800},{4,1295},{5,79},{6,61},{7,35},{8,31},{48,0},{49,0}]',229205),(154,'[{1,3831},{2,64992},{3,1802},{4,1296},{5,79},{6,61},{7,35},{8,31},{48,0},{49,0}]',229362),(155,'[{1,3833},{2,65034},{3,1803},{4,1297},{5,79},{6,61},{7,35},{8,31},{48,0},{49,0}]',229494),(156,'[{1,3835},{2,65076},{3,1804},{4,1298},{5,79},{6,61},{7,35},{8,31},{48,0},{49,0}]',229626),(157,'[{1,3837},{2,65117},{3,1805},{4,1299},{5,79},{6,61},{7,35},{8,31},{48,0},{49,0}]',229757),(158,'[{1,3839},{2,65159},{3,1806},{4,1300},{5,79},{6,61},{7,35},{8,31},{48,0},{49,0}]',229889),(159,'[{1,3841},{2,65201},{3,1807},{4,1301},{5,79},{6,61},{7,35},{8,31},{48,0},{49,0}]',230021),(160,'[{1,3843},{2,65243},{3,1808},{4,1302},{5,79},{6,61},{7,35},{8,31},{48,0},{49,0}]',230153),(161,'[{1,3845},{2,65285},{3,1809},{4,1303},{5,79},{6,61},{7,35},{8,31},{48,0},{49,0}]',230285),(162,'[{1,3847},{2,65327},{3,1810},{4,1304},{5,79},{6,61},{7,35},{8,31},{48,0},{49,0}]',230417),(163,'[{1,3850},{2,65369},{3,1811},{4,1305},{5,79},{6,61},{7,35},{8,31},{48,0},{49,0}]',230569),(164,'[{1,3852},{2,65411},{3,1812},{4,1306},{5,79},{6,61},{7,35},{8,31},{48,0},{49,0}]',230701),(165,'[{1,3854},{2,65453},{3,1813},{4,1307},{5,79},{6,61},{7,35},{8,31},{48,0},{49,0}]',230833),(166,'[{1,3856},{2,65495},{3,1814},{4,1308},{5,79},{6,61},{7,35},{8,31},{48,0},{49,0}]',230965),(167,'[{1,3899},{2,69666},{3,1828},{4,1414},{5,80},{6,63},{7,37},{8,32},{48,2},{49,6}]',239536),(168,'[{1,3943},{2,73837},{3,1843},{4,1520},{5,82},{6,65},{7,38},{8,34},{48,4},{49,12}]',248202),(169,'[{1,3986},{2,78008},{3,1857},{4,1625},{5,83},{6,67},{7,40},{8,35},{48,6},{49,18}]',256748),(170,'[{1,4029},{2,82179},{3,1872},{4,1731},{5,85},{6,70},{7,41},{8,36},{48,8},{49,25}]',265424),(171,'[{1,4072},{2,86350},{3,1886},{4,1837},{5,86},{6,72},{7,43},{8,37},{48,9},{49,31}]',273965),(172,'[{1,4116},{2,90521},{3,1900},{4,1943},{5,87},{6,74},{7,45},{8,39},{48,11},{49,37}]',282606),(173,'[{1,4159},{2,94691},{3,1915},{4,2048},{5,89},{6,76},{7,46},{8,40},{48,13},{49,43}]',291176),(174,'[{1,4202},{2,98862},{3,1929},{4,2154},{5,90},{6,78},{7,48},{8,41},{48,15},{49,49}]',299747),(175,'[{1,4246},{2,103033},{3,1943},{4,2260},{5,91},{6,80},{7,49},{8,42},{48,17},{49,55}]',308288),(176,'[{1,4289},{2,107204},{3,1958},{4,2366},{5,93},{6,82},{7,51},{8,44},{48,19},{49,61}]',316984),(177,'[{1,4332},{2,111375},{3,1972},{4,2471},{5,94},{6,84},{7,52},{8,45},{48,21},{49,67}]',325480),(178,'[{1,4376},{2,115546},{3,1987},{4,2577},{5,96},{6,87},{7,54},{8,46},{48,23},{49,74}]',334226),(179,'[{1,4419},{2,119717},{3,2001},{4,2683},{5,97},{6,89},{7,56},{8,47},{48,24},{49,80}]',342767),(180,'[{1,4462},{2,123888},{3,2015},{4,2789},{5,98},{6,91},{7,57},{8,49},{48,26},{49,86}]',351338),(181,'[{1,4505},{2,128059},{3,2030},{4,2894},{5,100},{6,93},{7,59},{8,50},{48,28},{49,92}]',359959),(182,'[{1,4549},{2,132230},{3,2044},{4,3000},{5,101},{6,95},{7,60},{8,51},{48,30},{49,98}]',368500),(183,'[{1,4592},{2,136401},{3,2058},{4,3106},{5,102},{6,97},{7,62},{8,52},{48,32},{49,104}]',377071),(184,'[{1,4635},{2,140572},{3,2073},{4,3212},{5,104},{6,99},{7,64},{8,54},{48,34},{49,110}]',385767),(185,'[{1,4679},{2,144742},{3,2087},{4,3317},{5,105},{6,101},{7,65},{8,55},{48,36},{49,116}]',394282),(186,'[{1,4722},{2,148913},{3,2102},{4,3423},{5,107},{6,104},{7,67},{8,56},{48,38},{49,123}]',403008),(187,'[{1,4765},{2,153084},{3,2116},{4,3529},{5,108},{6,106},{7,68},{8,57},{48,39},{49,129}]',411499),(188,'[{1,4808},{2,157255},{3,2130},{4,3635},{5,109},{6,108},{7,70},{8,59},{48,41},{49,135}]',420120),(189,'[{1,4852},{2,161426},{3,2145},{4,3740},{5,111},{6,110},{7,71},{8,60},{48,43},{49,141}]',428711),(190,'[{1,4895},{2,165597},{3,2159},{4,3846},{5,112},{6,112},{7,73},{8,61},{48,45},{49,147}]',437282),(191,'[{1,5006},{2,168756},{3,2200},{4,3911},{5,113},{6,113},{7,77},{8,65},{48,60},{49,150}]',446506),(192,'[{1,5117},{2,171915},{3,2242},{4,3976},{5,114},{6,114},{7,81},{8,69},{48,76},{49,154}]',455730),(193,'[{1,5228},{2,175075},{3,2284},{4,4041},{5,116},{6,116},{7,85},{8,73},{48,92},{49,158}]',464954),(194,'[{1,5339},{2,178234},{3,2326},{4,4107},{5,117},{6,117},{7,90},{8,77},{48,108},{49,162}]',474178),(195,'[{1,5450},{2,181393},{3,2368},{4,4172},{5,119},{6,119},{7,94},{8,82},{48,123},{49,166}]',483401),(196,'[{1,5561},{2,184553},{3,2410},{4,4237},{5,120},{6,120},{7,98},{8,86},{48,139},{49,170}]',492625),(197,'[{1,5672},{2,187712},{3,2452},{4,4303},{5,122},{6,122},{7,103},{8,90},{48,155},{49,174}]',501849),(198,'[{1,5783},{2,190872},{3,2494},{4,4368},{5,123},{6,123},{7,107},{8,94},{48,171},{49,178}]',511073),(199,'[{1,5894},{2,194031},{3,2535},{4,4433},{5,125},{6,125},{7,111},{8,99},{48,186},{49,182}]',520297),(200,'[{1,6005},{2,197190},{3,2577},{4,4499},{5,126},{6,126},{7,116},{8,103},{48,202},{49,186}]',529521),(201,'[{1,6116},{2,200350},{3,2619},{4,4564},{5,127},{6,127},{7,120},{8,107},{48,218},{49,190}]',538745),(202,'[{1,6227},{2,203509},{3,2661},{4,4629},{5,129},{6,129},{7,124},{8,111},{48,234},{49,194}]',547969),(203,'[{1,6338},{2,206668},{3,2703},{4,4695},{5,130},{6,130},{7,129},{8,115},{48,249},{49,198}]',557192),(204,'[{1,6449},{2,209828},{3,2745},{4,4760},{5,132},{6,132},{7,133},{8,120},{48,265},{49,202}]',566416),(205,'[{1,6560},{2,212987},{3,2787},{4,4825},{5,133},{6,133},{7,137},{8,124},{48,281},{49,206}]',575640),(206,'[{1,6671},{2,216147},{3,2829},{4,4891},{5,135},{6,135},{7,142},{8,128},{48,297},{49,210}]',584864),(207,'[{1,6782},{2,219306},{3,2870},{4,4956},{5,136},{6,136},{7,146},{8,132},{48,312},{49,214}]',594088),(208,'[{1,6893},{2,222465},{3,2912},{4,5021},{5,138},{6,138},{7,150},{8,137},{48,328},{49,218}]',603312),(209,'[{1,7004},{2,225625},{3,2954},{4,5087},{5,139},{6,139},{7,155},{8,141},{48,344},{49,222}]',612536),(210,'[{1,7116},{2,228784},{3,2996},{4,5152},{5,141},{6,141},{7,159},{8,145},{48,360},{49,226}]',621760),(211,'[{1,7227},{2,231943},{3,3038},{4,5217},{5,142},{6,142},{7,163},{8,149},{48,375},{49,229}]',630983),(212,'[{1,7338},{2,235103},{3,3080},{4,5283},{5,143},{6,143},{7,168},{8,153},{48,391},{49,233}]',640207),(213,'[{1,7449},{2,238262},{3,3122},{4,5348},{5,145},{6,145},{7,172},{8,158},{48,407},{49,237}]',649431),(214,'[{1,7560},{2,241422},{3,3164},{4,5413},{5,146},{6,146},{7,176},{8,162},{48,423},{49,241}]',658655),(215,'[{1,7671},{2,244581},{3,3205},{4,5479},{5,148},{6,148},{7,181},{8,166},{48,438},{49,245}]',667879),(216,'[{1,7782},{2,247740},{3,3247},{4,5544},{5,149},{6,149},{7,185},{8,170},{48,454},{49,249}]',677103),(217,'[{1,7893},{2,250900},{3,3289},{4,5609},{5,151},{6,151},{7,189},{8,175},{48,470},{49,253}]',686327),(218,'[{1,8004},{2,254059},{3,3331},{4,5675},{5,152},{6,152},{7,194},{8,179},{48,486},{49,257}]',695551),(219,'[{1,8115},{2,257218},{3,3373},{4,5740},{5,154},{6,154},{7,198},{8,183},{48,501},{49,261}]',704774),(220,'[{1,8226},{2,260378},{3,3415},{4,5805},{5,155},{6,155},{7,202},{8,187},{48,517},{49,265}]',713998),(221,'[{1,8337},{2,263537},{3,3457},{4,5871},{5,156},{6,156},{7,207},{8,191},{48,533},{49,269}]',723222),(222,'[{1,8448},{2,266697},{3,3499},{4,5936},{5,158},{6,158},{7,211},{8,196},{48,549},{49,273}]',732446),(223,'[{1,8559},{2,269856},{3,3540},{4,6001},{5,159},{6,159},{7,215},{8,200},{48,564},{49,277}]',741670),(224,'[{1,8670},{2,273015},{3,3582},{4,6067},{5,161},{6,161},{7,220},{8,204},{48,580},{49,281}]',750894),(225,'[{1,8781},{2,276175},{3,3624},{4,6132},{5,162},{6,162},{7,224},{8,208},{48,596},{49,285}]',760118),(226,'[{1,8892},{2,279334},{3,3666},{4,6197},{5,164},{6,164},{7,228},{8,213},{48,612},{49,289}]',769341),(227,'[{1,9003},{2,282493},{3,3708},{4,6263},{5,165},{6,165},{7,233},{8,217},{48,627},{49,293}]',778565),(228,'[{1,9114},{2,285653},{3,3750},{4,6328},{5,167},{6,167},{7,237},{8,221},{48,643},{49,297}]',787789),(229,'[{1,9225},{2,288812},{3,3792},{4,6393},{5,168},{6,168},{7,241},{8,225},{48,659},{49,301}]',797013),(230,'[{1,9337},{2,291972},{3,3834},{4,6459},{5,170},{6,170},{7,246},{8,230},{48,675},{49,305}]',806237),(231,'[{1,9616},{2,299805},{3,3966},{4,6647},{5,180},{6,180},{7,258},{8,241},{48,675},{49,313}]',830228),(232,'[{1,9896},{2,307638},{3,4099},{4,6835},{5,191},{6,191},{7,271},{8,253},{48,675},{49,322}]',854219),(233,'[{1,10176},{2,315471},{3,4231},{4,7023},{5,201},{6,201},{7,283},{8,265},{48,675},{49,331}]',878209),(234,'[{1,10456},{2,323304},{3,4364},{4,7211},{5,212},{6,212},{7,296},{8,277},{48,675},{49,340}]',902200),(235,'[{1,10735},{2,331137},{3,4496},{4,7399},{5,223},{6,223},{7,308},{8,289},{48,675},{49,349}]',926191),(236,'[{1,11015},{2,338970},{3,4629},{4,7587},{5,233},{6,233},{7,321},{8,301},{48,675},{49,357}]',950182),(237,'[{1,11295},{2,346803},{3,4761},{4,7775},{5,244},{6,244},{7,333},{8,313},{48,675},{49,366}]',974172),(238,'[{1,11575},{2,354636},{3,4894},{4,7963},{5,254},{6,254},{7,346},{8,325},{48,675},{49,375}]',998163),(239,'[{1,11854},{2,362469},{3,5026},{4,8151},{5,265},{6,265},{7,358},{8,337},{48,675},{49,384}]',1022154),(240,'[{1,12134},{2,370302},{3,5159},{4,8340},{5,276},{6,276},{7,371},{8,349},{48,675},{49,393}]',1046145),(241,'[{1,12414},{2,378135},{3,5292},{4,8528},{5,286},{6,286},{7,384},{8,360},{48,675},{49,401}]',1070135),(242,'[{1,12694},{2,385968},{3,5424},{4,8716},{5,297},{6,297},{7,396},{8,372},{48,675},{49,410}]',1094126),(243,'[{1,12973},{2,393801},{3,5557},{4,8904},{5,307},{6,307},{7,409},{8,384},{48,675},{49,419}]',1118117),(244,'[{1,13253},{2,401634},{3,5689},{4,9092},{5,318},{6,318},{7,421},{8,396},{48,675},{49,428}]',1142108),(245,'[{1,13533},{2,409467},{3,5822},{4,9280},{5,329},{6,329},{7,434},{8,408},{48,675},{49,437}]',1166098),(246,'[{1,13813},{2,417300},{3,5954},{4,9468},{5,339},{6,339},{7,446},{8,420},{48,675},{49,445}]',1190089),(247,'[{1,14092},{2,425133},{3,6087},{4,9656},{5,350},{6,350},{7,459},{8,432},{48,675},{49,454}]',1214080),(248,'[{1,14372},{2,432966},{3,6219},{4,9844},{5,360},{6,360},{7,471},{8,444},{48,675},{49,463}]',1238071),(249,'[{1,14652},{2,440799},{3,6352},{4,10032},{5,371},{6,371},{7,484},{8,456},{48,675},{49,472}]',1262061),(250,'[{1,14932},{2,448632},{3,6485},{4,10221},{5,382},{6,382},{7,497},{8,468},{48,675},{49,481}]',1286052),(251,'[{1,15139},{2,456245},{3,6568},{4,10390},{5,391},{6,391},{7,508},{8,479},{48,693},{49,486}]',1306976),(252,'[{1,15346},{2,463858},{3,6652},{4,10559},{5,401},{6,401},{7,520},{8,491},{48,712},{49,491}]',1327900),(253,'[{1,15553},{2,471471},{3,6735},{4,10729},{5,410},{6,410},{7,531},{8,503},{48,731},{49,496}]',1348824),(254,'[{1,15760},{2,479084},{3,6819},{4,10898},{5,420},{6,420},{7,543},{8,515},{48,750},{49,501}]',1369748),(255,'[{1,15967},{2,486697},{3,6903},{4,11067},{5,430},{6,430},{7,554},{8,526},{48,769},{49,506}]',1390672),(256,'[{1,16174},{2,494310},{3,6986},{4,11237},{5,439},{6,439},{7,566},{8,538},{48,788},{49,511}]',1411596),(257,'[{1,16381},{2,501923},{3,7070},{4,11406},{5,449},{6,449},{7,577},{8,550},{48,807},{49,517}]',1432520),(258,'[{1,16588},{2,509536},{3,7153},{4,11575},{5,458},{6,458},{7,589},{8,562},{48,826},{49,522}]',1453444),(259,'[{1,16795},{2,517149},{3,7237},{4,11745},{5,468},{6,468},{7,600},{8,574},{48,845},{49,527}]',1474368),(260,'[{1,17002},{2,524762},{3,7321},{4,11914},{5,478},{6,478},{7,612},{8,585},{48,864},{49,532}]',1495292),(261,'[{1,17209},{2,532375},{3,7404},{4,12083},{5,487},{6,487},{7,623},{8,597},{48,882},{49,537}]',1516216),(262,'[{1,17416},{2,539988},{3,7488},{4,12253},{5,497},{6,497},{7,635},{8,609},{48,901},{49,542}]',1537140),(263,'[{1,17623},{2,547601},{3,7572},{4,12422},{5,506},{6,506},{7,646},{8,621},{48,920},{49,548}]',1558064),(264,'[{1,17830},{2,555214},{3,7655},{4,12591},{5,516},{6,516},{7,658},{8,632},{48,939},{49,553}]',1578988),(265,'[{1,18037},{2,562827},{3,7739},{4,12761},{5,526},{6,526},{7,669},{8,644},{48,958},{49,558}]',1599912),(266,'[{1,18244},{2,570440},{3,7822},{4,12930},{5,535},{6,535},{7,681},{8,656},{48,977},{49,563}]',1620836),(267,'[{1,18452},{2,578053},{3,7906},{4,13099},{5,545},{6,545},{7,692},{8,668},{48,996},{49,568}]',1641760),(268,'[{1,18659},{2,585666},{3,7990},{4,13269},{5,554},{6,554},{7,704},{8,680},{48,1015},{49,573}]',1662684),(269,'[{1,18866},{2,593279},{3,8073},{4,13438},{5,564},{6,564},{7,715},{8,691},{48,1034},{49,579}]',1683608),(270,'[{1,19073},{2,600892},{3,8157},{4,13607},{5,574},{6,574},{7,727},{8,703},{48,1053},{49,584}]',1704532),(271,'[{1,19280},{2,608505},{3,8241},{4,13777},{5,583},{6,583},{7,738},{8,715},{48,1071},{49,589}]',1725456),(272,'[{1,19487},{2,616118},{3,8324},{4,13946},{5,593},{6,593},{7,750},{8,727},{48,1090},{49,594}]',1746380),(273,'[{1,19694},{2,623731},{3,8408},{4,14115},{5,602},{6,602},{7,761},{8,738},{48,1109},{49,599}]',1767304),(274,'[{1,19901},{2,631344},{3,8491},{4,14285},{5,612},{6,612},{7,773},{8,750},{48,1128},{49,604}]',1788228),(275,'[{1,20108},{2,638957},{3,8575},{4,14454},{5,622},{6,622},{7,784},{8,762},{48,1147},{49,610}]',1809152),(276,'[{1,20315},{2,646570},{3,8659},{4,14623},{5,631},{6,631},{7,796},{8,774},{48,1166},{49,615}]',1830076),(277,'[{1,20522},{2,654183},{3,8742},{4,14793},{5,641},{6,641},{7,807},{8,786},{48,1185},{49,620}]',1851000),(278,'[{1,20729},{2,661796},{3,8826},{4,14962},{5,650},{6,650},{7,819},{8,797},{48,1204},{49,625}]',1871924),(279,'[{1,20936},{2,669409},{3,8909},{4,15131},{5,660},{6,660},{7,830},{8,809},{48,1223},{49,630}]',1892848),(280,'[{1,21143},{2,677022},{3,8993},{4,15301},{5,670},{6,670},{7,842},{8,821},{48,1242},{49,635}]',1913772),(281,'[{1,21350},{2,684635},{3,9077},{4,15470},{5,679},{6,679},{7,853},{8,833},{48,1260},{49,640}]',1934696),(282,'[{1,21557},{2,692248},{3,9160},{4,15639},{5,689},{6,689},{7,865},{8,844},{48,1279},{49,646}]',1955620),(283,'[{1,21764},{2,699861},{3,9244},{4,15809},{5,698},{6,698},{7,876},{8,856},{48,1298},{49,651}]',1976544),(284,'[{1,21972},{2,707474},{3,9328},{4,15978},{5,708},{6,708},{7,888},{8,868},{48,1317},{49,656}]',1997468),(285,'[{1,22179},{2,715087},{3,9411},{4,16147},{5,718},{6,718},{7,899},{8,880},{48,1336},{49,661}]',2018392),(286,'[{1,22386},{2,722700},{3,9495},{4,16317},{5,727},{6,727},{7,911},{8,892},{48,1355},{49,666}]',2039316),(287,'[{1,22593},{2,730313},{3,9578},{4,16486},{5,737},{6,737},{7,922},{8,903},{48,1374},{49,671}]',2060240),(288,'[{1,22800},{2,737926},{3,9662},{4,16655},{5,746},{6,746},{7,934},{8,915},{48,1393},{49,677}]',2081164),(289,'[{1,23007},{2,745539},{3,9746},{4,16825},{5,756},{6,756},{7,945},{8,927},{48,1412},{49,682}]',2102088),(290,'[{1,23214},{2,753152},{3,9829},{4,16994},{5,766},{6,766},{7,957},{8,939},{48,1431},{49,687}]',2123012),(291,'[{1,23421},{2,760765},{3,9913},{4,17163},{5,775},{6,775},{7,968},{8,950},{48,1449},{49,692}]',2143936),(292,'[{1,23628},{2,768378},{3,9997},{4,17333},{5,785},{6,785},{7,980},{8,962},{48,1468},{49,697}]',2164860),(293,'[{1,23835},{2,775991},{3,10080},{4,17502},{5,794},{6,794},{7,991},{8,974},{48,1487},{49,702}]',2185784),(294,'[{1,24042},{2,783604},{3,10164},{4,17671},{5,804},{6,804},{7,1003},{8,986},{48,1506},{49,708}]',2206708),(295,'[{1,24249},{2,791217},{3,10247},{4,17841},{5,814},{6,814},{7,1014},{8,998},{48,1525},{49,713}]',2227632),(296,'[{1,24456},{2,798830},{3,10331},{4,18010},{5,823},{6,823},{7,1026},{8,1009},{48,1544},{49,718}]',2248556),(297,'[{1,24663},{2,806443},{3,10415},{4,18179},{5,833},{6,833},{7,1037},{8,1021},{48,1563},{49,723}]',2269480),(298,'[{1,24870},{2,814056},{3,10498},{4,18349},{5,842},{6,842},{7,1049},{8,1033},{48,1582},{49,728}]',2290404),(299,'[{1,25077},{2,821669},{3,10582},{4,18518},{5,852},{6,852},{7,1060},{8,1045},{48,1601},{49,733}]',2311328),(300,'[{1,25285},{2,829282},{3,10666},{4,18688},{5,862},{6,862},{7,1072},{8,1057},{48,1620},{49,739}]',2332252),(301,'[{1,25643},{2,838045},{3,10840},{4,18870},{5,877},{6,877},{7,1078},{8,1063},{48,1620},{49,747}]',2359569),(302,'[{1,26002},{2,846809},{3,11014},{4,19052},{5,893},{6,893},{7,1085},{8,1069},{48,1620},{49,755}]',2386887),(303,'[{1,26361},{2,855572},{3,11188},{4,19234},{5,908},{6,908},{7,1091},{8,1076},{48,1620},{49,763}]',2414204),(304,'[{1,26720},{2,864336},{3,11362},{4,19416},{5,924},{6,924},{7,1098},{8,1082},{48,1620},{49,772}]',2441521),(305,'[{1,27079},{2,873100},{3,11536},{4,19598},{5,940},{6,940},{7,1105},{8,1089},{48,1620},{49,780}]',2468838),(306,'[{1,27438},{2,881863},{3,11711},{4,19780},{5,955},{6,955},{7,1111},{8,1095},{48,1620},{49,788}]',2496156),(307,'[{1,27797},{2,890627},{3,11885},{4,19962},{5,971},{6,971},{7,1118},{8,1102},{48,1620},{49,796}]',2523473),(308,'[{1,28156},{2,899391},{3,12059},{4,20144},{5,987},{6,987},{7,1125},{8,1108},{48,1620},{49,805}]',2550790),(309,'[{1,28515},{2,908154},{3,12233},{4,20326},{5,1002},{6,1002},{7,1131},{8,1115},{48,1620},{49,813}]',2578107),(310,'[{1,28874},{2,916918},{3,12407},{4,20508},{5,1018},{6,1018},{7,1138},{8,1121},{48,1620},{49,821}]',2605425),(311,'[{1,29233},{2,925682},{3,12581},{4,20690},{5,1034},{6,1034},{7,1145},{8,1128},{48,1620},{49,830}]',2632742),(312,'[{1,29592},{2,934445},{3,12756},{4,20872},{5,1049},{6,1049},{7,1151},{8,1134},{48,1620},{49,838}]',2660059),(313,'[{1,29951},{2,943209},{3,12930},{4,21054},{5,1065},{6,1065},{7,1158},{8,1140},{48,1620},{49,846}]',2687376),(314,'[{1,30310},{2,951973},{3,13104},{4,21236},{5,1080},{6,1080},{7,1165},{8,1147},{48,1620},{49,854}]',2714694),(315,'[{1,30669},{2,960736},{3,13278},{4,21418},{5,1096},{6,1096},{7,1171},{8,1153},{48,1620},{49,863}]',2742011),(316,'[{1,31028},{2,969500},{3,13452},{4,21600},{5,1112},{6,1112},{7,1178},{8,1160},{48,1620},{49,871}]',2769328),(317,'[{1,31387},{2,978264},{3,13627},{4,21783},{5,1127},{6,1127},{7,1185},{8,1166},{48,1620},{49,879}]',2796645),(318,'[{1,31746},{2,987027},{3,13801},{4,21965},{5,1143},{6,1143},{7,1191},{8,1173},{48,1620},{49,888}]',2823963),(319,'[{1,32105},{2,995791},{3,13975},{4,22147},{5,1159},{6,1159},{7,1198},{8,1179},{48,1620},{49,896}]',2851280),(320,'[{1,32464},{2,1004555},{3,14149},{4,22329},{5,1174},{6,1174},{7,1205},{8,1186},{48,1620},{49,904}]',2878597),(321,'[{1,32823},{2,1013318},{3,14323},{4,22511},{5,1190},{6,1190},{7,1211},{8,1192},{48,1620},{49,912}]',2905914),(322,'[{1,33182},{2,1022082},{3,14497},{4,22693},{5,1206},{6,1206},{7,1218},{8,1199},{48,1620},{49,921}]',2933232),(323,'[{1,33541},{2,1030846},{3,14672},{4,22875},{5,1221},{6,1221},{7,1225},{8,1205},{48,1620},{49,929}]',2960549),(324,'[{1,33900},{2,1039609},{3,14846},{4,23057},{5,1237},{6,1237},{7,1231},{8,1212},{48,1620},{49,937}]',2987866),(325,'[{1,34259},{2,1048373},{3,15020},{4,23239},{5,1253},{6,1253},{7,1238},{8,1218},{48,1620},{49,945}]',3015184),(326,'[{1,34617},{2,1057137},{3,15194},{4,23421},{5,1268},{6,1268},{7,1245},{8,1224},{48,1620},{49,954}]',3042501),(327,'[{1,34976},{2,1065900},{3,15368},{4,23603},{5,1284},{6,1284},{7,1251},{8,1231},{48,1620},{49,962}]',3069818),(328,'[{1,35335},{2,1074664},{3,15543},{4,23785},{5,1299},{6,1299},{7,1258},{8,1237},{48,1620},{49,970}]',3097135),(329,'[{1,35694},{2,1083428},{3,15717},{4,23967},{5,1315},{6,1315},{7,1265},{8,1244},{48,1620},{49,979}]',3124453),(330,'[{1,36053},{2,1092191},{3,15891},{4,24149},{5,1331},{6,1331},{7,1271},{8,1250},{48,1620},{49,987}]',3151770),(331,'[{1,36412},{2,1100955},{3,16065},{4,24331},{5,1346},{6,1346},{7,1278},{8,1257},{48,1620},{49,995}]',3179087),(332,'[{1,36771},{2,1109719},{3,16239},{4,24513},{5,1362},{6,1362},{7,1285},{8,1263},{48,1620},{49,1003}]',3206404),(333,'[{1,37130},{2,1118482},{3,16413},{4,24695},{5,1378},{6,1378},{7,1291},{8,1270},{48,1620},{49,1012}]',3233722),(334,'[{1,37489},{2,1127246},{3,16588},{4,24878},{5,1393},{6,1393},{7,1298},{8,1276},{48,1620},{49,1020}]',3261039),(335,'[{1,37848},{2,1136010},{3,16762},{4,25060},{5,1409},{6,1409},{7,1305},{8,1283},{48,1620},{49,1028}]',3288356),(336,'[{1,38207},{2,1144773},{3,16936},{4,25242},{5,1425},{6,1425},{7,1311},{8,1289},{48,1620},{49,1037}]',3315673),(337,'[{1,38566},{2,1153537},{3,17110},{4,25424},{5,1440},{6,1440},{7,1318},{8,1296},{48,1620},{49,1045}]',3342991),(338,'[{1,38925},{2,1162301},{3,17284},{4,25606},{5,1456},{6,1456},{7,1325},{8,1302},{48,1620},{49,1053}]',3370308),(339,'[{1,39284},{2,1171064},{3,17459},{4,25788},{5,1471},{6,1471},{7,1331},{8,1308},{48,1620},{49,1061}]',3397625),(340,'[{1,39643},{2,1179828},{3,17633},{4,25970},{5,1487},{6,1487},{7,1338},{8,1315},{48,1620},{49,1070}]',3424942),(341,'[{1,40002},{2,1188592},{3,17807},{4,26152},{5,1503},{6,1503},{7,1345},{8,1321},{48,1620},{49,1078}]',3452260),(342,'[{1,40361},{2,1197355},{3,17981},{4,26334},{5,1518},{6,1518},{7,1351},{8,1328},{48,1620},{49,1086}]',3479577),(343,'[{1,40720},{2,1206119},{3,18155},{4,26516},{5,1534},{6,1534},{7,1358},{8,1334},{48,1620},{49,1095}]',3506894),(344,'[{1,41079},{2,1214883},{3,18329},{4,26698},{5,1550},{6,1550},{7,1365},{8,1341},{48,1620},{49,1103}]',3534211),(345,'[{1,41438},{2,1223646},{3,18504},{4,26880},{5,1565},{6,1565},{7,1371},{8,1347},{48,1620},{49,1111}]',3561529),(346,'[{1,41797},{2,1232410},{3,18678},{4,27062},{5,1581},{6,1581},{7,1378},{8,1354},{48,1620},{49,1119}]',3588846),(347,'[{1,42156},{2,1241174},{3,18852},{4,27244},{5,1597},{6,1597},{7,1385},{8,1360},{48,1620},{49,1128}]',3616163),(348,'[{1,42515},{2,1249937},{3,19026},{4,27426},{5,1612},{6,1612},{7,1391},{8,1367},{48,1620},{49,1136}]',3643480),(349,'[{1,42874},{2,1258701},{3,19200},{4,27608},{5,1628},{6,1628},{7,1398},{8,1373},{48,1620},{49,1144}]',3670798),(350,'[{1,43233},{2,1267465},{3,19375},{4,27791},{5,1644},{6,1644},{7,1405},{8,1380},{48,1620},{49,1153}]',3698115),(351,'[{1,43787},{2,1278089},{3,19615},{4,28000},{5,1682},{6,1682},{7,1434},{8,1409},{48,1620},{49,1164}]',3738222),(352,'[{1,44341},{2,1288713},{3,19855},{4,28209},{5,1721},{6,1721},{7,1464},{8,1438},{48,1620},{49,1176}]',3778329),(353,'[{1,44896},{2,1299337},{3,20096},{4,28419},{5,1759},{6,1759},{7,1493},{8,1467},{48,1620},{49,1188}]',3818436),(354,'[{1,45450},{2,1309961},{3,20336},{4,28628},{5,1798},{6,1798},{7,1523},{8,1496},{48,1620},{49,1200}]',3858542),(355,'[{1,46005},{2,1320586},{3,20577},{4,28837},{5,1837},{6,1837},{7,1552},{8,1525},{48,1620},{49,1212}]',3898649),(356,'[{1,46559},{2,1331210},{3,20817},{4,29047},{5,1875},{6,1875},{7,1582},{8,1554},{48,1620},{49,1224}]',3938756),(357,'[{1,47113},{2,1341834},{3,21058},{4,29256},{5,1914},{6,1914},{7,1611},{8,1583},{48,1620},{49,1236}]',3978863),(358,'[{1,47668},{2,1352458},{3,21298},{4,29465},{5,1952},{6,1952},{7,1641},{8,1612},{48,1620},{49,1248}]',4018970),(359,'[{1,48222},{2,1363083},{3,21539},{4,29675},{5,1991},{6,1991},{7,1670},{8,1641},{48,1620},{49,1260}]',4059077),(360,'[{1,48777},{2,1373707},{3,21779},{4,29884},{5,2030},{6,2030},{7,1700},{8,1670},{48,1620},{49,1272}]',4099183),(361,'[{1,49331},{2,1384331},{3,22020},{4,30093},{5,2068},{6,2068},{7,1729},{8,1699},{48,1620},{49,1284}]',4139290),(362,'[{1,49886},{2,1394955},{3,22260},{4,30303},{5,2107},{6,2107},{7,1759},{8,1728},{48,1620},{49,1296}]',4179397),(363,'[{1,50440},{2,1405580},{3,22501},{4,30512},{5,2145},{6,2145},{7,1788},{8,1758},{48,1620},{49,1308}]',4219504),(364,'[{1,50994},{2,1416204},{3,22741},{4,30722},{5,2184},{6,2184},{7,1818},{8,1787},{48,1620},{49,1320}]',4259611),(365,'[{1,51549},{2,1426828},{3,22982},{4,30931},{5,2223},{6,2223},{7,1847},{8,1816},{48,1620},{49,1332}]',4299718),(366,'[{1,52103},{2,1437452},{3,23222},{4,31140},{5,2261},{6,2261},{7,1877},{8,1845},{48,1620},{49,1344}]',4339824),(367,'[{1,52658},{2,1448077},{3,23463},{4,31350},{5,2300},{6,2300},{7,1906},{8,1874},{48,1620},{49,1355}]',4379931),(368,'[{1,53212},{2,1458701},{3,23703},{4,31559},{5,2338},{6,2338},{7,1936},{8,1903},{48,1620},{49,1367}]',4420038),(369,'[{1,53766},{2,1469325},{3,23944},{4,31768},{5,2377},{6,2377},{7,1965},{8,1932},{48,1620},{49,1379}]',4460145),(370,'[{1,54321},{2,1479949},{3,24184},{4,31978},{5,2416},{6,2416},{7,1995},{8,1961},{48,1620},{49,1391}]',4500252),(371,'[{1,54875},{2,1490574},{3,24425},{4,32187},{5,2454},{6,2454},{7,2024},{8,1990},{48,1620},{49,1403}]',4540359),(372,'[{1,55430},{2,1501198},{3,24665},{4,32396},{5,2493},{6,2493},{7,2054},{8,2019},{48,1620},{49,1415}]',4580465),(373,'[{1,55984},{2,1511822},{3,24906},{4,32606},{5,2531},{6,2531},{7,2083},{8,2048},{48,1620},{49,1427}]',4620572),(374,'[{1,56539},{2,1522446},{3,25146},{4,32815},{5,2570},{6,2570},{7,2113},{8,2077},{48,1620},{49,1439}]',4660679),(375,'[{1,57093},{2,1533071},{3,25387},{4,33025},{5,2609},{6,2609},{7,2143},{8,2107},{48,1620},{49,1451}]',4700786),(376,'[{1,57647},{2,1543695},{3,25627},{4,33234},{5,2647},{6,2647},{7,2172},{8,2136},{48,1620},{49,1463}]',4740893),(377,'[{1,58202},{2,1554319},{3,25867},{4,33443},{5,2686},{6,2686},{7,2202},{8,2165},{48,1620},{49,1475}]',4781000),(378,'[{1,58756},{2,1564943},{3,26108},{4,33653},{5,2724},{6,2724},{7,2231},{8,2194},{48,1620},{49,1487}]',4821107),(379,'[{1,59311},{2,1575567},{3,26348},{4,33862},{5,2763},{6,2763},{7,2261},{8,2223},{48,1620},{49,1499}]',4861213),(380,'[{1,59865},{2,1586192},{3,26589},{4,34071},{5,2802},{6,2802},{7,2290},{8,2252},{48,1620},{49,1511}]',4901320),(381,'[{1,60420},{2,1596816},{3,26829},{4,34281},{5,2840},{6,2840},{7,2320},{8,2281},{48,1620},{49,1523}]',4941427),(382,'[{1,60974},{2,1607440},{3,27070},{4,34490},{5,2879},{6,2879},{7,2349},{8,2310},{48,1620},{49,1535}]',4981534),(383,'[{1,61528},{2,1618064},{3,27310},{4,34699},{5,2917},{6,2917},{7,2379},{8,2339},{48,1620},{49,1547}]',5021641),(384,'[{1,62083},{2,1628689},{3,27551},{4,34909},{5,2956},{6,2956},{7,2408},{8,2368},{48,1620},{49,1558}]',5061748),(385,'[{1,62637},{2,1639313},{3,27791},{4,35118},{5,2995},{6,2995},{7,2438},{8,2397},{48,1620},{49,1570}]',5101854),(386,'[{1,63192},{2,1649937},{3,28032},{4,35327},{5,3033},{6,3033},{7,2467},{8,2426},{48,1620},{49,1582}]',5141961),(387,'[{1,63746},{2,1660561},{3,28272},{4,35537},{5,3072},{6,3072},{7,2497},{8,2455},{48,1620},{49,1594}]',5182068),(388,'[{1,64300},{2,1671186},{3,28513},{4,35746},{5,3110},{6,3110},{7,2526},{8,2485},{48,1620},{49,1606}]',5222175),(389,'[{1,64855},{2,1681810},{3,28753},{4,35956},{5,3149},{6,3149},{7,2556},{8,2514},{48,1620},{49,1618}]',5262282),(390,'[{1,65409},{2,1692434},{3,28994},{4,36165},{5,3188},{6,3188},{7,2585},{8,2543},{48,1620},{49,1630}]',5302389),(391,'[{1,65964},{2,1703058},{3,29234},{4,36374},{5,3226},{6,3226},{7,2615},{8,2572},{48,1620},{49,1642}]',5342495),(392,'[{1,66518},{2,1713683},{3,29475},{4,36584},{5,3265},{6,3265},{7,2644},{8,2601},{48,1620},{49,1654}]',5382602),(393,'[{1,67073},{2,1724307},{3,29715},{4,36793},{5,3303},{6,3303},{7,2674},{8,2630},{48,1620},{49,1666}]',5422709),(394,'[{1,67627},{2,1734931},{3,29956},{4,37002},{5,3342},{6,3342},{7,2703},{8,2659},{48,1620},{49,1678}]',5462816),(395,'[{1,68181},{2,1745555},{3,30196},{4,37212},{5,3381},{6,3381},{7,2733},{8,2688},{48,1620},{49,1690}]',5502923),(396,'[{1,68736},{2,1756180},{3,30437},{4,37421},{5,3419},{6,3419},{7,2762},{8,2717},{48,1620},{49,1702}]',5543030),(397,'[{1,69290},{2,1766804},{3,30677},{4,37630},{5,3458},{6,3458},{7,2792},{8,2746},{48,1620},{49,1714}]',5583136),(398,'[{1,69845},{2,1777428},{3,30918},{4,37840},{5,3496},{6,3496},{7,2821},{8,2775},{48,1620},{49,1726}]',5623243),(399,'[{1,70399},{2,1788052},{3,31158},{4,38049},{5,3535},{6,3535},{7,2851},{8,2804},{48,1620},{49,1738}]',5663350),(400,'[{1,70954},{2,1798677},{3,31399},{4,38259},{5,3574},{6,3574},{7,2881},{8,2834},{48,1620},{49,1750}]',5703457),(401,'[{1,71395},{2,1809071},{3,31577},{4,38452},{5,3610},{6,3610},{7,2901},{8,2852},{48,1620},{49,1766}]',5738106),(402,'[{1,71837},{2,1819465},{3,31755},{4,38646},{5,3647},{6,3647},{7,2921},{8,2871},{48,1620},{49,1783}]',5772754),(403,'[{1,72278},{2,1829859},{3,31934},{4,38839},{5,3684},{6,3684},{7,2941},{8,2889},{48,1620},{49,1800}]',5807403),(404,'[{1,72720},{2,1840253},{3,32112},{4,39033},{5,3721},{6,3721},{7,2961},{8,2908},{48,1620},{49,1817}]',5842052),(405,'[{1,73162},{2,1850647},{3,32291},{4,39226},{5,3757},{6,3757},{7,2981},{8,2926},{48,1620},{49,1834}]',5876700),(406,'[{1,73603},{2,1861041},{3,32469},{4,39420},{5,3794},{6,3794},{7,3001},{8,2945},{48,1620},{49,1851}]',5911349),(407,'[{1,74045},{2,1871436},{3,32648},{4,39614},{5,3831},{6,3831},{7,3022},{8,2963},{48,1620},{49,1868}]',5945998),(408,'[{1,74486},{2,1881830},{3,32826},{4,39807},{5,3868},{6,3868},{7,3042},{8,2982},{48,1620},{49,1885}]',5980646),(409,'[{1,74928},{2,1892224},{3,33005},{4,40001},{5,3905},{6,3905},{7,3062},{8,3000},{48,1620},{49,1902}]',6015295),(410,'[{1,75370},{2,1902618},{3,33183},{4,40194},{5,3941},{6,3941},{7,3082},{8,3019},{48,1620},{49,1919}]',6049944),(411,'[{1,75811},{2,1913012},{3,33362},{4,40388},{5,3978},{6,3978},{7,3102},{8,3037},{48,1620},{49,1936}]',6084592),(412,'[{1,76253},{2,1923406},{3,33540},{4,40581},{5,4015},{6,4015},{7,3122},{8,3056},{48,1620},{49,1953}]',6119241),(413,'[{1,76695},{2,1933801},{3,33719},{4,40775},{5,4052},{6,4052},{7,3143},{8,3075},{48,1620},{49,1969}]',6153890),(414,'[{1,77136},{2,1944195},{3,33897},{4,40969},{5,4088},{6,4088},{7,3163},{8,3093},{48,1620},{49,1986}]',6188538),(415,'[{1,77578},{2,1954589},{3,34076},{4,41162},{5,4125},{6,4125},{7,3183},{8,3112},{48,1620},{49,2003}]',6223187),(416,'[{1,78019},{2,1964983},{3,34254},{4,41356},{5,4162},{6,4162},{7,3203},{8,3130},{48,1620},{49,2020}]',6257836),(417,'[{1,78461},{2,1975377},{3,34433},{4,41549},{5,4199},{6,4199},{7,3223},{8,3149},{48,1620},{49,2037}]',6292484),(418,'[{1,78903},{2,1985771},{3,34611},{4,41743},{5,4236},{6,4236},{7,3243},{8,3167},{48,1620},{49,2054}]',6327133),(419,'[{1,79344},{2,1996166},{3,34790},{4,41937},{5,4272},{6,4272},{7,3264},{8,3186},{48,1620},{49,2071}]',6361782),(420,'[{1,79786},{2,2006560},{3,34968},{4,42130},{5,4309},{6,4309},{7,3284},{8,3204},{48,1620},{49,2088}]',6396430),(421,'[{1,80228},{2,2016954},{3,35147},{4,42324},{5,4346},{6,4346},{7,3304},{8,3223},{48,1620},{49,2105}]',6431079),(422,'[{1,80669},{2,2027348},{3,35325},{4,42517},{5,4383},{6,4383},{7,3324},{8,3241},{48,1620},{49,2122}]',6465728),(423,'[{1,81111},{2,2037742},{3,35504},{4,42711},{5,4419},{6,4419},{7,3344},{8,3260},{48,1620},{49,2139}]',6500376),(424,'[{1,81552},{2,2048136},{3,35682},{4,42904},{5,4456},{6,4456},{7,3364},{8,3278},{48,1620},{49,2156}]',6535025),(425,'[{1,81994},{2,2058531},{3,35861},{4,43098},{5,4493},{6,4493},{7,3385},{8,3297},{48,1620},{49,2173}]',6569673),(426,'[{1,82436},{2,2068925},{3,36039},{4,43292},{5,4530},{6,4530},{7,3405},{8,3316},{48,1620},{49,2189}]',6604322),(427,'[{1,82877},{2,2079319},{3,36217},{4,43485},{5,4567},{6,4567},{7,3425},{8,3334},{48,1620},{49,2206}]',6638971),(428,'[{1,83319},{2,2089713},{3,36396},{4,43679},{5,4603},{6,4603},{7,3445},{8,3353},{48,1620},{49,2223}]',6673619),(429,'[{1,83760},{2,2100107},{3,36574},{4,43872},{5,4640},{6,4640},{7,3465},{8,3371},{48,1620},{49,2240}]',6708268),(430,'[{1,84202},{2,2110501},{3,36753},{4,44066},{5,4677},{6,4677},{7,3485},{8,3390},{48,1620},{49,2257}]',6742917),(431,'[{1,84644},{2,2120895},{3,36931},{4,44259},{5,4714},{6,4714},{7,3505},{8,3408},{48,1620},{49,2274}]',6777565),(432,'[{1,85085},{2,2131290},{3,37110},{4,44453},{5,4750},{6,4750},{7,3526},{8,3427},{48,1620},{49,2291}]',6812214),(433,'[{1,85527},{2,2141684},{3,37288},{4,44647},{5,4787},{6,4787},{7,3546},{8,3445},{48,1620},{49,2308}]',6846863),(434,'[{1,85969},{2,2152078},{3,37467},{4,44840},{5,4824},{6,4824},{7,3566},{8,3464},{48,1620},{49,2325}]',6881511),(435,'[{1,86410},{2,2162472},{3,37645},{4,45034},{5,4861},{6,4861},{7,3586},{8,3482},{48,1620},{49,2342}]',6916160),(436,'[{1,86852},{2,2172866},{3,37824},{4,45227},{5,4898},{6,4898},{7,3606},{8,3501},{48,1620},{49,2359}]',6950809),(437,'[{1,87293},{2,2183260},{3,38002},{4,45421},{5,4934},{6,4934},{7,3626},{8,3519},{48,1620},{49,2376}]',6985457),(438,'[{1,87735},{2,2193655},{3,38181},{4,45615},{5,4971},{6,4971},{7,3647},{8,3538},{48,1620},{49,2392}]',7020106),(439,'[{1,88177},{2,2204049},{3,38359},{4,45808},{5,5008},{6,5008},{7,3667},{8,3557},{48,1620},{49,2409}]',7054755),(440,'[{1,88618},{2,2214443},{3,38538},{4,46002},{5,5045},{6,5045},{7,3687},{8,3575},{48,1620},{49,2426}]',7089403),(441,'[{1,89060},{2,2224837},{3,38716},{4,46195},{5,5081},{6,5081},{7,3707},{8,3594},{48,1620},{49,2443}]',7124052),(442,'[{1,89502},{2,2235231},{3,38895},{4,46389},{5,5118},{6,5118},{7,3727},{8,3612},{48,1620},{49,2460}]',7158701),(443,'[{1,89943},{2,2245625},{3,39073},{4,46582},{5,5155},{6,5155},{7,3747},{8,3631},{48,1620},{49,2477}]',7193349),(444,'[{1,90385},{2,2256020},{3,39252},{4,46776},{5,5192},{6,5192},{7,3768},{8,3649},{48,1620},{49,2494}]',7227998),(445,'[{1,90826},{2,2266414},{3,39430},{4,46970},{5,5229},{6,5229},{7,3788},{8,3668},{48,1620},{49,2511}]',7262647),(446,'[{1,91268},{2,2276808},{3,39609},{4,47163},{5,5265},{6,5265},{7,3808},{8,3686},{48,1620},{49,2528}]',7297295),(447,'[{1,91710},{2,2287202},{3,39787},{4,47357},{5,5302},{6,5302},{7,3828},{8,3705},{48,1620},{49,2545}]',7331944),(448,'[{1,92151},{2,2297596},{3,39966},{4,47550},{5,5339},{6,5339},{7,3848},{8,3723},{48,1620},{49,2562}]',7366593),(449,'[{1,92593},{2,2307990},{3,40144},{4,47744},{5,5376},{6,5376},{7,3868},{8,3742},{48,1620},{49,2579}]',7401241),(450,'[{1,93035},{2,2318385},{3,40323},{4,47938},{5,5413},{6,5413},{7,3889},{8,3761},{48,1620},{49,2596}]',7435890),(451,'[{1,93692},{2,2333301},{3,40595},{4,48226},{5,5466},{6,5466},{7,3931},{8,3801},{48,1645},{49,2609}]',7488691),(452,'[{1,94349},{2,2348217},{3,40868},{4,48515},{5,5520},{6,5520},{7,3974},{8,3841},{48,1670},{49,2623}]',7541493),(453,'[{1,95007},{2,2363133},{3,41141},{4,48804},{5,5574},{6,5574},{7,4016},{8,3881},{48,1695},{49,2637}]',7594294),(454,'[{1,95664},{2,2378049},{3,41414},{4,49093},{5,5628},{6,5628},{7,4059},{8,3921},{48,1720},{49,2651}]',7647095),(455,'[{1,96321},{2,2392965},{3,41687},{4,49382},{5,5682},{6,5682},{7,4102},{8,3962},{48,1746},{49,2665}]',7699896),(456,'[{1,96979},{2,2407881},{3,41959},{4,49670},{5,5736},{6,5736},{7,4144},{8,4002},{48,1771},{49,2678}]',7752698),(457,'[{1,97636},{2,2422798},{3,42232},{4,49959},{5,5789},{6,5789},{7,4187},{8,4042},{48,1796},{49,2692}]',7805499),(458,'[{1,98294},{2,2437714},{3,42505},{4,50248},{5,5843},{6,5843},{7,4230},{8,4082},{48,1821},{49,2706}]',7858300),(459,'[{1,98951},{2,2452630},{3,42778},{4,50537},{5,5897},{6,5897},{7,4272},{8,4122},{48,1846},{49,2720}]',7911101),(460,'[{1,99608},{2,2467546},{3,43051},{4,50826},{5,5951},{6,5951},{7,4315},{8,4163},{48,1872},{49,2734}]',7963903),(461,'[{1,100266},{2,2482462},{3,43323},{4,51115},{5,6005},{6,6005},{7,4358},{8,4203},{48,1897},{49,2747}]',8016704),(462,'[{1,100923},{2,2497378},{3,43596},{4,51403},{5,6059},{6,6059},{7,4400},{8,4243},{48,1922},{49,2761}]',8069505),(463,'[{1,101580},{2,2512295},{3,43869},{4,51692},{5,6112},{6,6112},{7,4443},{8,4283},{48,1947},{49,2775}]',8122306),(464,'[{1,102238},{2,2527211},{3,44142},{4,51981},{5,6166},{6,6166},{7,4485},{8,4324},{48,1972},{49,2789}]',8175108),(465,'[{1,102895},{2,2542127},{3,44415},{4,52270},{5,6220},{6,6220},{7,4528},{8,4364},{48,1998},{49,2803}]',8227909),(466,'[{1,103553},{2,2557043},{3,44687},{4,52559},{5,6274},{6,6274},{7,4571},{8,4404},{48,2023},{49,2816}]',8280710),(467,'[{1,104210},{2,2571959},{3,44960},{4,52847},{5,6328},{6,6328},{7,4613},{8,4444},{48,2048},{49,2830}]',8333511),(468,'[{1,104867},{2,2586875},{3,45233},{4,53136},{5,6382},{6,6382},{7,4656},{8,4484},{48,2073},{49,2844}]',8386313),(469,'[{1,105525},{2,2601792},{3,45506},{4,53425},{5,6435},{6,6435},{7,4699},{8,4525},{48,2098},{49,2858}]',8439114),(470,'[{1,106182},{2,2616708},{3,45779},{4,53714},{5,6489},{6,6489},{7,4741},{8,4565},{48,2124},{49,2872}]',8491915),(471,'[{1,106839},{2,2631624},{3,46051},{4,54003},{5,6543},{6,6543},{7,4784},{8,4605},{48,2149},{49,2885}]',8544716),(472,'[{1,107497},{2,2646540},{3,46324},{4,54292},{5,6597},{6,6597},{7,4827},{8,4645},{48,2174},{49,2899}]',8597518),(473,'[{1,108154},{2,2661456},{3,46597},{4,54580},{5,6651},{6,6651},{7,4869},{8,4686},{48,2199},{49,2913}]',8650319),(474,'[{1,108812},{2,2676372},{3,46870},{4,54869},{5,6705},{6,6705},{7,4912},{8,4726},{48,2224},{49,2927}]',8703120),(475,'[{1,109469},{2,2691289},{3,47143},{4,55158},{5,6759},{6,6759},{7,4955},{8,4766},{48,2250},{49,2941}]',8755922),(476,'[{1,110126},{2,2706205},{3,47415},{4,55447},{5,6812},{6,6812},{7,4997},{8,4806},{48,2275},{49,2954}]',8808723),(477,'[{1,110784},{2,2721121},{3,47688},{4,55736},{5,6866},{6,6866},{7,5040},{8,4846},{48,2300},{49,2968}]',8861524),(478,'[{1,111441},{2,2736037},{3,47961},{4,56024},{5,6920},{6,6920},{7,5082},{8,4887},{48,2325},{49,2982}]',8914325),(479,'[{1,112099},{2,2750953},{3,48234},{4,56313},{5,6974},{6,6974},{7,5125},{8,4927},{48,2350},{49,2996}]',8967127),(480,'[{1,112756},{2,2765869},{3,48507},{4,56602},{5,7028},{6,7028},{7,5168},{8,4967},{48,2376},{49,3010}]',9019928),(481,'[{1,113413},{2,2780785},{3,48779},{4,56891},{5,7082},{6,7082},{7,5210},{8,5007},{48,2401},{49,3023}]',9072729),(482,'[{1,114071},{2,2795702},{3,49052},{4,57180},{5,7135},{6,7135},{7,5253},{8,5048},{48,2426},{49,3037}]',9125530),(483,'[{1,114728},{2,2810618},{3,49325},{4,57469},{5,7189},{6,7189},{7,5296},{8,5088},{48,2451},{49,3051}]',9178332),(484,'[{1,115385},{2,2825534},{3,49598},{4,57757},{5,7243},{6,7243},{7,5338},{8,5128},{48,2476},{49,3065}]',9231133),(485,'[{1,116043},{2,2840450},{3,49871},{4,58046},{5,7297},{6,7297},{7,5381},{8,5168},{48,2502},{49,3079}]',9283934),(486,'[{1,116700},{2,2855366},{3,50143},{4,58335},{5,7351},{6,7351},{7,5424},{8,5208},{48,2527},{49,3092}]',9336735),(487,'[{1,117358},{2,2870282},{3,50416},{4,58624},{5,7405},{6,7405},{7,5466},{8,5249},{48,2552},{49,3106}]',9389537),(488,'[{1,118015},{2,2885199},{3,50689},{4,58913},{5,7458},{6,7458},{7,5509},{8,5289},{48,2577},{49,3120}]',9442338),(489,'[{1,118672},{2,2900115},{3,50962},{4,59201},{5,7512},{6,7512},{7,5551},{8,5329},{48,2602},{49,3134}]',9495139),(490,'[{1,119330},{2,2915031},{3,51235},{4,59490},{5,7566},{6,7566},{7,5594},{8,5369},{48,2628},{49,3148}]',9547940),(491,'[{1,119987},{2,2929947},{3,51507},{4,59779},{5,7620},{6,7620},{7,5637},{8,5410},{48,2653},{49,3161}]',9600742),(492,'[{1,120644},{2,2944863},{3,51780},{4,60068},{5,7674},{6,7674},{7,5679},{8,5450},{48,2678},{49,3175}]',9653543),(493,'[{1,121302},{2,2959779},{3,52053},{4,60357},{5,7728},{6,7728},{7,5722},{8,5490},{48,2703},{49,3189}]',9706344),(494,'[{1,121959},{2,2974696},{3,52326},{4,60646},{5,7781},{6,7781},{7,5765},{8,5530},{48,2728},{49,3203}]',9759145),(495,'[{1,122617},{2,2989612},{3,52599},{4,60934},{5,7835},{6,7835},{7,5807},{8,5570},{48,2754},{49,3217}]',9811947),(496,'[{1,123274},{2,3004528},{3,52871},{4,61223},{5,7889},{6,7889},{7,5850},{8,5611},{48,2779},{49,3230}]',9864748),(497,'[{1,123931},{2,3019444},{3,53144},{4,61512},{5,7943},{6,7943},{7,5893},{8,5651},{48,2804},{49,3244}]',9917549),(498,'[{1,124589},{2,3034360},{3,53417},{4,61801},{5,7997},{6,7997},{7,5935},{8,5691},{48,2829},{49,3258}]',9970350),(499,'[{1,125246},{2,3049276},{3,53690},{4,62090},{5,8051},{6,8051},{7,5978},{8,5731},{48,2854},{49,3272}]',10023152),(500,'[{1,125904},{2,3064193},{3,53963},{4,62379},{5,8105},{6,8105},{7,6021},{8,5772},{48,2880},{49,3286}]',10075953),(501,'[{1,126664},{2,3081484},{3,54274},{4,62707},{5,8214},{6,8214},{7,6089},{8,5838},{48,2880},{49,3298}]',10142521),(502,'[{1,127425},{2,3098776},{3,54586},{4,63035},{5,8323},{6,8323},{7,6157},{8,5905},{48,2880},{49,3310}]',10209088),(503,'[{1,128186},{2,3116068},{3,54898},{4,63363},{5,8433},{6,8433},{7,6225},{8,5972},{48,2880},{49,3322}]',10275656),(504,'[{1,128947},{2,3133360},{3,55210},{4,63692},{5,8542},{6,8542},{7,6293},{8,6039},{48,2880},{49,3334}]',10342223),(505,'[{1,129707},{2,3150652},{3,55522},{4,64020},{5,8652},{6,8652},{7,6361},{8,6106},{48,2880},{49,3347}]',10408791),(506,'[{1,130468},{2,3167944},{3,55834},{4,64348},{5,8761},{6,8761},{7,6429},{8,6173},{48,2880},{49,3359}]',10475359),(507,'[{1,131229},{2,3185236},{3,56146},{4,64676},{5,8870},{6,8870},{7,6497},{8,6239},{48,2880},{49,3371}]',10541926),(508,'[{1,131990},{2,3202528},{3,56458},{4,65005},{5,8980},{6,8980},{7,6565},{8,6306},{48,2880},{49,3383}]',10608494),(509,'[{1,132751},{2,3219820},{3,56770},{4,65333},{5,9089},{6,9089},{7,6633},{8,6373},{48,2880},{49,3395}]',10675062),(510,'[{1,133511},{2,3237112},{3,57082},{4,65661},{5,9199},{6,9199},{7,6702},{8,6440},{48,2880},{49,3408}]',10741629),(511,'[{1,134272},{2,3254404},{3,57394},{4,65990},{5,9308},{6,9308},{7,6770},{8,6507},{48,2880},{49,3420}]',10808197),(512,'[{1,135033},{2,3271696},{3,57706},{4,66318},{5,9417},{6,9417},{7,6838},{8,6574},{48,2880},{49,3432}]',10874764),(513,'[{1,135794},{2,3288987},{3,58018},{4,66646},{5,9527},{6,9527},{7,6906},{8,6640},{48,2880},{49,3444}]',10941332),(514,'[{1,136554},{2,3306279},{3,58330},{4,66974},{5,9636},{6,9636},{7,6974},{8,6707},{48,2880},{49,3457}]',11007900),(515,'[{1,137315},{2,3323571},{3,58642},{4,67303},{5,9745},{6,9745},{7,7042},{8,6774},{48,2880},{49,3469}]',11074467),(516,'[{1,138076},{2,3340863},{3,58954},{4,67631},{5,9855},{6,9855},{7,7110},{8,6841},{48,2880},{49,3481}]',11141035),(517,'[{1,138837},{2,3358155},{3,59266},{4,67959},{5,9964},{6,9964},{7,7178},{8,6908},{48,2880},{49,3493}]',11207603),(518,'[{1,139598},{2,3375447},{3,59578},{4,68288},{5,10074},{6,10074},{7,7246},{8,6975},{48,2880},{49,3505}]',11274170),(519,'[{1,140358},{2,3392739},{3,59890},{4,68616},{5,10183},{6,10183},{7,7314},{8,7041},{48,2880},{49,3518}]',11340738),(520,'[{1,141119},{2,3410031},{3,60202},{4,68944},{5,10293},{6,10293},{7,7383},{8,7108},{48,2880},{49,3530}]',11407305),(521,'[{1,141880},{2,3427323},{3,60514},{4,69272},{5,10402},{6,10402},{7,7451},{8,7175},{48,2880},{49,3542}]',11473873),(522,'[{1,142641},{2,3444615},{3,60826},{4,69601},{5,10511},{6,10511},{7,7519},{8,7242},{48,2880},{49,3554}]',11540441),(523,'[{1,143401},{2,3461907},{3,61138},{4,69929},{5,10621},{6,10621},{7,7587},{8,7309},{48,2880},{49,3567}]',11607008),(524,'[{1,144162},{2,3479199},{3,61450},{4,70257},{5,10730},{6,10730},{7,7655},{8,7376},{48,2880},{49,3579}]',11673576),(525,'[{1,144923},{2,3496491},{3,61762},{4,70586},{5,10840},{6,10840},{7,7723},{8,7443},{48,2880},{49,3591}]',11740144),(526,'[{1,145684},{2,3513782},{3,62074},{4,70914},{5,10949},{6,10949},{7,7791},{8,7509},{48,2880},{49,3603}]',11806711),(527,'[{1,146445},{2,3531074},{3,62386},{4,71242},{5,11058},{6,11058},{7,7859},{8,7576},{48,2880},{49,3615}]',11873279),(528,'[{1,147205},{2,3548366},{3,62698},{4,71570},{5,11168},{6,11168},{7,7927},{8,7643},{48,2880},{49,3628}]',11939846),(529,'[{1,147966},{2,3565658},{3,63010},{4,71899},{5,11277},{6,11277},{7,7995},{8,7710},{48,2880},{49,3640}]',12006414),(530,'[{1,148727},{2,3582950},{3,63322},{4,72227},{5,11387},{6,11387},{7,8064},{8,7777},{48,2880},{49,3652}]',12072982),(531,'[{1,149488},{2,3600242},{3,63634},{4,72555},{5,11496},{6,11496},{7,8132},{8,7844},{48,2880},{49,3664}]',12139549),(532,'[{1,150248},{2,3617534},{3,63946},{4,72883},{5,11605},{6,11605},{7,8200},{8,7910},{48,2880},{49,3677}]',12206117),(533,'[{1,151009},{2,3634826},{3,64258},{4,73212},{5,11715},{6,11715},{7,8268},{8,7977},{48,2880},{49,3689}]',12272684),(534,'[{1,151770},{2,3652118},{3,64570},{4,73540},{5,11824},{6,11824},{7,8336},{8,8044},{48,2880},{49,3701}]',12339252),(535,'[{1,152531},{2,3669410},{3,64882},{4,73868},{5,11934},{6,11934},{7,8404},{8,8111},{48,2880},{49,3713}]',12405820),(536,'[{1,153292},{2,3686702},{3,65194},{4,74197},{5,12043},{6,12043},{7,8472},{8,8178},{48,2880},{49,3725}]',12472387),(537,'[{1,154052},{2,3703994},{3,65506},{4,74525},{5,12152},{6,12152},{7,8540},{8,8245},{48,2880},{49,3738}]',12538955),(538,'[{1,154813},{2,3721285},{3,65818},{4,74853},{5,12262},{6,12262},{7,8608},{8,8311},{48,2880},{49,3750}]',12605523),(539,'[{1,155574},{2,3738577},{3,66130},{4,75181},{5,12371},{6,12371},{7,8676},{8,8378},{48,2880},{49,3762}]',12672090),(540,'[{1,156335},{2,3755869},{3,66442},{4,75510},{5,12481},{6,12481},{7,8745},{8,8445},{48,2880},{49,3774}]',12738658),(541,'[{1,157095},{2,3773161},{3,66754},{4,75838},{5,12590},{6,12590},{7,8813},{8,8512},{48,2880},{49,3787}]',12805225),(542,'[{1,157856},{2,3790453},{3,67066},{4,76166},{5,12699},{6,12699},{7,8881},{8,8579},{48,2880},{49,3799}]',12871793),(543,'[{1,158617},{2,3807745},{3,67378},{4,76495},{5,12809},{6,12809},{7,8949},{8,8646},{48,2880},{49,3811}]',12938361),(544,'[{1,159378},{2,3825037},{3,67690},{4,76823},{5,12918},{6,12918},{7,9017},{8,8712},{48,2880},{49,3823}]',13004928),(545,'[{1,160139},{2,3842329},{3,68002},{4,77151},{5,13028},{6,13028},{7,9085},{8,8779},{48,2880},{49,3835}]',13071496),(546,'[{1,160899},{2,3859621},{3,68314},{4,77479},{5,13137},{6,13137},{7,9153},{8,8846},{48,2880},{49,3848}]',13138064),(547,'[{1,161660},{2,3876913},{3,68626},{4,77808},{5,13246},{6,13246},{7,9221},{8,8913},{48,2880},{49,3860}]',13204631),(548,'[{1,162421},{2,3894205},{3,68938},{4,78136},{5,13356},{6,13356},{7,9289},{8,8980},{48,2880},{49,3872}]',13271199),(549,'[{1,163182},{2,3911497},{3,69250},{4,78464},{5,13465},{6,13465},{7,9357},{8,9047},{48,2880},{49,3884}]',13337766),(550,'[{1,163943},{2,3928789},{3,69562},{4,78793},{5,13575},{6,13575},{7,9426},{8,9114},{48,2880},{49,3897}]',13404334),(551,'[{1,164753},{2,3947242},{3,69898},{4,79145},{5,13654},{6,13654},{7,9467},{8,9156},{48,2880},{49,3912}]',13468789),(552,'[{1,165563},{2,3965695},{3,70235},{4,79497},{5,13734},{6,13734},{7,9508},{8,9198},{48,2880},{49,3927}]',13533244),(553,'[{1,166373},{2,3984149},{3,70572},{4,79849},{5,13813},{6,13813},{7,9549},{8,9240},{48,2880},{49,3942}]',13597700),(554,'[{1,167183},{2,4002602},{3,70909},{4,80201},{5,13893},{6,13893},{7,9590},{8,9282},{48,2880},{49,3957}]',13662155),(555,'[{1,167993},{2,4021055},{3,71246},{4,80554},{5,13973},{6,13973},{7,9631},{8,9324},{48,2880},{49,3972}]',13726610),(556,'[{1,168803},{2,4039509},{3,71583},{4,80906},{5,14052},{6,14052},{7,9672},{8,9366},{48,2880},{49,3987}]',13791065),(557,'[{1,169614},{2,4057962},{3,71919},{4,81258},{5,14132},{6,14132},{7,9713},{8,9408},{48,2880},{49,4002}]',13855520),(558,'[{1,170424},{2,4076416},{3,72256},{4,81610},{5,14211},{6,14211},{7,9754},{8,9451},{48,2880},{49,4017}]',13919975),(559,'[{1,171234},{2,4094869},{3,72593},{4,81962},{5,14291},{6,14291},{7,9795},{8,9493},{48,2880},{49,4033}]',13984431),(560,'[{1,172044},{2,4113322},{3,72930},{4,82315},{5,14371},{6,14371},{7,9836},{8,9535},{48,2880},{49,4048}]',14048886),(561,'[{1,172854},{2,4131776},{3,73267},{4,82667},{5,14450},{6,14450},{7,9877},{8,9577},{48,2880},{49,4063}]',14113341),(562,'[{1,173664},{2,4150229},{3,73604},{4,83019},{5,14530},{6,14530},{7,9918},{8,9619},{48,2880},{49,4078}]',14177796),(563,'[{1,174475},{2,4168682},{3,73940},{4,83371},{5,14610},{6,14610},{7,9959},{8,9661},{48,2880},{49,4093}]',14242251),(564,'[{1,175285},{2,4187136},{3,74277},{4,83723},{5,14689},{6,14689},{7,10000},{8,9703},{48,2880},{49,4108}]',14306707),(565,'[{1,176095},{2,4205589},{3,74614},{4,84076},{5,14769},{6,14769},{7,10041},{8,9746},{48,2880},{49,4123}]',14371162),(566,'[{1,176905},{2,4224043},{3,74951},{4,84428},{5,14848},{6,14848},{7,10082},{8,9788},{48,2880},{49,4138}]',14435617),(567,'[{1,177715},{2,4242496},{3,75288},{4,84780},{5,14928},{6,14928},{7,10123},{8,9830},{48,2880},{49,4154}]',14500072),(568,'[{1,178525},{2,4260949},{3,75625},{4,85132},{5,15008},{6,15008},{7,10164},{8,9872},{48,2880},{49,4169}]',14564527),(569,'[{1,179336},{2,4279403},{3,75961},{4,85484},{5,15087},{6,15087},{7,10205},{8,9914},{48,2880},{49,4184}]',14628982),(570,'[{1,180146},{2,4297856},{3,76298},{4,85836},{5,15167},{6,15167},{7,10246},{8,9956},{48,2880},{49,4199}]',14693438),(571,'[{1,180956},{2,4316309},{3,76635},{4,86189},{5,15247},{6,15247},{7,10287},{8,9998},{48,2880},{49,4214}]',14757893),(572,'[{1,181766},{2,4334763},{3,76972},{4,86541},{5,15326},{6,15326},{7,10328},{8,10041},{48,2880},{49,4229}]',14822348),(573,'[{1,182576},{2,4353216},{3,77309},{4,86893},{5,15406},{6,15406},{7,10369},{8,10083},{48,2880},{49,4244}]',14886803),(574,'[{1,183386},{2,4371670},{3,77646},{4,87245},{5,15485},{6,15485},{7,10410},{8,10125},{48,2880},{49,4259}]',14951258),(575,'[{1,184197},{2,4390123},{3,77982},{4,87597},{5,15565},{6,15565},{7,10451},{8,10167},{48,2880},{49,4275}]',15015714),(576,'[{1,185007},{2,4408576},{3,78319},{4,87950},{5,15645},{6,15645},{7,10492},{8,10209},{48,2880},{49,4290}]',15080169),(577,'[{1,185817},{2,4427030},{3,78656},{4,88302},{5,15724},{6,15724},{7,10533},{8,10251},{48,2880},{49,4305}]',15144624),(578,'[{1,186627},{2,4445483},{3,78993},{4,88654},{5,15804},{6,15804},{7,10574},{8,10293},{48,2880},{49,4320}]',15209079),(579,'[{1,187437},{2,4463937},{3,79330},{4,89006},{5,15883},{6,15883},{7,10615},{8,10336},{48,2880},{49,4335}]',15273534),(580,'[{1,188247},{2,4482390},{3,79667},{4,89358},{5,15963},{6,15963},{7,10656},{8,10378},{48,2880},{49,4350}]',15337989),(581,'[{1,189057},{2,4500843},{3,80004},{4,89711},{5,16043},{6,16043},{7,10697},{8,10420},{48,2880},{49,4365}]',15402445),(582,'[{1,189868},{2,4519297},{3,80340},{4,90063},{5,16122},{6,16122},{7,10738},{8,10462},{48,2880},{49,4380}]',15466900),(583,'[{1,190678},{2,4537750},{3,80677},{4,90415},{5,16202},{6,16202},{7,10779},{8,10504},{48,2880},{49,4395}]',15531355),(584,'[{1,191488},{2,4556203},{3,81014},{4,90767},{5,16282},{6,16282},{7,10820},{8,10546},{48,2880},{49,4411}]',15595810),(585,'[{1,192298},{2,4574657},{3,81351},{4,91119},{5,16361},{6,16361},{7,10861},{8,10588},{48,2880},{49,4426}]',15660265),(586,'[{1,193108},{2,4593110},{3,81688},{4,91472},{5,16441},{6,16441},{7,10902},{8,10631},{48,2880},{49,4441}]',15724720),(587,'[{1,193918},{2,4611564},{3,82025},{4,91824},{5,16520},{6,16520},{7,10943},{8,10673},{48,2880},{49,4456}]',15789176),(588,'[{1,194729},{2,4630017},{3,82361},{4,92176},{5,16600},{6,16600},{7,10984},{8,10715},{48,2880},{49,4471}]',15853631),(589,'[{1,195539},{2,4648470},{3,82698},{4,92528},{5,16680},{6,16680},{7,11025},{8,10757},{48,2880},{49,4486}]',15918086),(590,'[{1,196349},{2,4666924},{3,83035},{4,92880},{5,16759},{6,16759},{7,11066},{8,10799},{48,2880},{49,4501}]',15982541),(591,'[{1,197159},{2,4685377},{3,83372},{4,93233},{5,16839},{6,16839},{7,11107},{8,10841},{48,2880},{49,4516}]',16046996),(592,'[{1,197969},{2,4703830},{3,83709},{4,93585},{5,16919},{6,16919},{7,11148},{8,10883},{48,2880},{49,4532}]',16111452),(593,'[{1,198779},{2,4722284},{3,84046},{4,93937},{5,16998},{6,16998},{7,11189},{8,10926},{48,2880},{49,4547}]',16175907),(594,'[{1,199590},{2,4740737},{3,84382},{4,94289},{5,17078},{6,17078},{7,11230},{8,10968},{48,2880},{49,4562}]',16240362),(595,'[{1,200400},{2,4759191},{3,84719},{4,94641},{5,17157},{6,17157},{7,11271},{8,11010},{48,2880},{49,4577}]',16304817),(596,'[{1,201210},{2,4777644},{3,85056},{4,94994},{5,17237},{6,17237},{7,11312},{8,11052},{48,2880},{49,4592}]',16369272),(597,'[{1,202020},{2,4796097},{3,85393},{4,95346},{5,17317},{6,17317},{7,11353},{8,11094},{48,2880},{49,4607}]',16433727),(598,'[{1,202830},{2,4814551},{3,85730},{4,95698},{5,17396},{6,17396},{7,11394},{8,11136},{48,2880},{49,4622}]',16498183),(599,'[{1,203640},{2,4833004},{3,86067},{4,96050},{5,17476},{6,17476},{7,11435},{8,11178},{48,2880},{49,4637}]',16562638),(600,'[{1,204451},{2,4851458},{3,86404},{4,96403},{5,17556},{6,17556},{7,11476},{8,11221},{48,2880},{49,4653}]',16627093),(601,'[{1,205338},{2,4871676},{3,86804},{4,96819},{5,17652},{6,17652},{7,11546},{8,11293},{48,2880},{49,4669}]',16702739),(602,'[{1,206225},{2,4891894},{3,87205},{4,97235},{5,17748},{6,17748},{7,11616},{8,11366},{48,2880},{49,4685}]',16778384),(603,'[{1,207113},{2,4912112},{3,87606},{4,97651},{5,17844},{6,17844},{7,11687},{8,11438},{48,2880},{49,4701}]',16854030),(604,'[{1,208000},{2,4932330},{3,88007},{4,98068},{5,17940},{6,17940},{7,11757},{8,11511},{48,2880},{49,4717}]',16929675),(605,'[{1,208888},{2,4952548},{3,88407},{4,98484},{5,18037},{6,18037},{7,11828},{8,11583},{48,2880},{49,4733}]',17005321),(606,'[{1,209775},{2,4972766},{3,88808},{4,98900},{5,18133},{6,18133},{7,11898},{8,11656},{48,2880},{49,4749}]',17080966),(607,'[{1,210662},{2,4992985},{3,89209},{4,99317},{5,18229},{6,18229},{7,11968},{8,11728},{48,2880},{49,4765}]',17156612),(608,'[{1,211550},{2,5013203},{3,89610},{4,99733},{5,18325},{6,18325},{7,12039},{8,11801},{48,2880},{49,4781}]',17232257),(609,'[{1,212437},{2,5033421},{3,90011},{4,100149},{5,18421},{6,18421},{7,12109},{8,11873},{48,2880},{49,4797}]',17307903),(610,'[{1,213325},{2,5053639},{3,90411},{4,100566},{5,18518},{6,18518},{7,12180},{8,11946},{48,2880},{49,4814}]',17383549),(611,'[{1,214212},{2,5073857},{3,90812},{4,100982},{5,18614},{6,18614},{7,12250},{8,12018},{48,2880},{49,4830}]',17459194),(612,'[{1,215100},{2,5094075},{3,91213},{4,101398},{5,18710},{6,18710},{7,12320},{8,12091},{48,2880},{49,4846}]',17534840),(613,'[{1,215987},{2,5114294},{3,91614},{4,101814},{5,18806},{6,18806},{7,12391},{8,12164},{48,2880},{49,4862}]',17610485),(614,'[{1,216874},{2,5134512},{3,92014},{4,102231},{5,18903},{6,18903},{7,12461},{8,12236},{48,2880},{49,4878}]',17686131),(615,'[{1,217762},{2,5154730},{3,92415},{4,102647},{5,18999},{6,18999},{7,12532},{8,12309},{48,2880},{49,4894}]',17761776),(616,'[{1,218649},{2,5174948},{3,92816},{4,103063},{5,19095},{6,19095},{7,12602},{8,12381},{48,2880},{49,4910}]',17837422),(617,'[{1,219537},{2,5195166},{3,93217},{4,103480},{5,19191},{6,19191},{7,12672},{8,12454},{48,2880},{49,4926}]',17913068),(618,'[{1,220424},{2,5215384},{3,93618},{4,103896},{5,19287},{6,19287},{7,12743},{8,12526},{48,2880},{49,4942}]',17988713),(619,'[{1,221311},{2,5235603},{3,94018},{4,104312},{5,19384},{6,19384},{7,12813},{8,12599},{48,2880},{49,4958}]',18064359),(620,'[{1,222199},{2,5255821},{3,94419},{4,104729},{5,19480},{6,19480},{7,12884},{8,12671},{48,2880},{49,4975}]',18140004),(621,'[{1,223086},{2,5276039},{3,94820},{4,105145},{5,19576},{6,19576},{7,12954},{8,12744},{48,2880},{49,4991}]',18215650),(622,'[{1,223974},{2,5296257},{3,95221},{4,105561},{5,19672},{6,19672},{7,13024},{8,12816},{48,2880},{49,5007}]',18291295),(623,'[{1,224861},{2,5316475},{3,95621},{4,105977},{5,19769},{6,19769},{7,13095},{8,12889},{48,2880},{49,5023}]',18366941),(624,'[{1,225749},{2,5336693},{3,96022},{4,106394},{5,19865},{6,19865},{7,13165},{8,12961},{48,2880},{49,5039}]',18442586),(625,'[{1,226636},{2,5356912},{3,96423},{4,106810},{5,19961},{6,19961},{7,13236},{8,13034},{48,2880},{49,5055}]',18518232),(626,'[{1,227523},{2,5377130},{3,96824},{4,107226},{5,20057},{6,20057},{7,13306},{8,13107},{48,2880},{49,5071}]',18593878),(627,'[{1,228411},{2,5397348},{3,97225},{4,107643},{5,20153},{6,20153},{7,13376},{8,13179},{48,2880},{49,5087}]',18669523),(628,'[{1,229298},{2,5417566},{3,97625},{4,108059},{5,20250},{6,20250},{7,13447},{8,13252},{48,2880},{49,5103}]',18745169),(629,'[{1,230186},{2,5437784},{3,98026},{4,108475},{5,20346},{6,20346},{7,13517},{8,13324},{48,2880},{49,5119}]',18820814),(630,'[{1,231073},{2,5458002},{3,98427},{4,108892},{5,20442},{6,20442},{7,13588},{8,13397},{48,2880},{49,5136}]',18896460),(631,'[{1,231961},{2,5478220},{3,98828},{4,109308},{5,20538},{6,20538},{7,13658},{8,13469},{48,2880},{49,5152}]',18972105),(632,'[{1,232848},{2,5498439},{3,99228},{4,109724},{5,20635},{6,20635},{7,13728},{8,13542},{48,2880},{49,5168}]',19047751),(633,'[{1,233735},{2,5518657},{3,99629},{4,110140},{5,20731},{6,20731},{7,13799},{8,13614},{48,2880},{49,5184}]',19123396),(634,'[{1,234623},{2,5538875},{3,100030},{4,110557},{5,20827},{6,20827},{7,13869},{8,13687},{48,2880},{49,5200}]',19199042),(635,'[{1,235510},{2,5559093},{3,100431},{4,110973},{5,20923},{6,20923},{7,13940},{8,13759},{48,2880},{49,5216}]',19274688),(636,'[{1,236398},{2,5579311},{3,100832},{4,111389},{5,21019},{6,21019},{7,14010},{8,13832},{48,2880},{49,5232}]',19350333),(637,'[{1,237285},{2,5599529},{3,101232},{4,111806},{5,21116},{6,21116},{7,14080},{8,13904},{48,2880},{49,5248}]',19425979),(638,'[{1,238172},{2,5619748},{3,101633},{4,112222},{5,21212},{6,21212},{7,14151},{8,13977},{48,2880},{49,5264}]',19501624),(639,'[{1,239060},{2,5639966},{3,102034},{4,112638},{5,21308},{6,21308},{7,14221},{8,14050},{48,2880},{49,5280}]',19577270),(640,'[{1,239947},{2,5660184},{3,102435},{4,113055},{5,21404},{6,21404},{7,14292},{8,14122},{48,2880},{49,5297}]',19652915),(641,'[{1,240835},{2,5680402},{3,102835},{4,113471},{5,21501},{6,21501},{7,14362},{8,14195},{48,2880},{49,5313}]',19728561),(642,'[{1,241722},{2,5700620},{3,103236},{4,113887},{5,21597},{6,21597},{7,14432},{8,14267},{48,2880},{49,5329}]',19804207),(643,'[{1,242610},{2,5720838},{3,103637},{4,114303},{5,21693},{6,21693},{7,14503},{8,14340},{48,2880},{49,5345}]',19879852),(644,'[{1,243497},{2,5741057},{3,104038},{4,114720},{5,21789},{6,21789},{7,14573},{8,14412},{48,2880},{49,5361}]',19955498),(645,'[{1,244384},{2,5761275},{3,104439},{4,115136},{5,21885},{6,21885},{7,14644},{8,14485},{48,2880},{49,5377}]',20031143),(646,'[{1,245272},{2,5781493},{3,104839},{4,115552},{5,21982},{6,21982},{7,14714},{8,14557},{48,2880},{49,5393}]',20106789),(647,'[{1,246159},{2,5801711},{3,105240},{4,115969},{5,22078},{6,22078},{7,14784},{8,14630},{48,2880},{49,5409}]',20182434),(648,'[{1,247047},{2,5821929},{3,105641},{4,116385},{5,22174},{6,22174},{7,14855},{8,14702},{48,2880},{49,5425}]',20258080),(649,'[{1,247934},{2,5842147},{3,106042},{4,116801},{5,22270},{6,22270},{7,14925},{8,14775},{48,2880},{49,5441}]',20333725),(650,'[{1,248822},{2,5862366},{3,106443},{4,117218},{5,22367},{6,22367},{7,14996},{8,14848},{48,2880},{49,5458}]',20409371),(651,'[{1,249933},{2,5887256},{3,106860},{4,117649},{5,22454},{6,22454},{7,15038},{8,14889},{48,2984},{49,5475}]',20494290),(652,'[{1,251044},{2,5912147},{3,107277},{4,118081},{5,22542},{6,22542},{7,15080},{8,14931},{48,3088},{49,5492}]',20579209),(653,'[{1,252155},{2,5937038},{3,107694},{4,118512},{5,22629},{6,22629},{7,15122},{8,14972},{48,3193},{49,5509}]',20664128),(654,'[{1,253266},{2,5961929},{3,108112},{4,118944},{5,22717},{6,22717},{7,15164},{8,15014},{48,3297},{49,5526}]',20749047),(655,'[{1,254377},{2,5986820},{3,108529},{4,119375},{5,22804},{6,22804},{7,15206},{8,15056},{48,3402},{49,5543}]',20833967),(656,'[{1,255488},{2,6011710},{3,108946},{4,119807},{5,22892},{6,22892},{7,15248},{8,15097},{48,3506},{49,5560}]',20918886),(657,'[{1,256599},{2,6036601},{3,109364},{4,120238},{5,22980},{6,22980},{7,15290},{8,15139},{48,3610},{49,5577}]',21003805),(658,'[{1,257710},{2,6061492},{3,109781},{4,120670},{5,23067},{6,23067},{7,15332},{8,15181},{48,3715},{49,5594}]',21088724),(659,'[{1,258821},{2,6086383},{3,110198},{4,121101},{5,23155},{6,23155},{7,15374},{8,15222},{48,3819},{49,5611}]',21173643),(660,'[{1,259933},{2,6111274},{3,110616},{4,121533},{5,23242},{6,23242},{7,15416},{8,15264},{48,3924},{49,5628}]',21258562),(661,'[{1,261044},{2,6136165},{3,111033},{4,121964},{5,23330},{6,23330},{7,15458},{8,15306},{48,4028},{49,5645}]',21343481),(662,'[{1,262155},{2,6161055},{3,111450},{4,122396},{5,23417},{6,23417},{7,15500},{8,15347},{48,4132},{49,5662}]',21428400),(663,'[{1,263266},{2,6185946},{3,111867},{4,122827},{5,23505},{6,23505},{7,15542},{8,15389},{48,4237},{49,5679}]',21513320),(664,'[{1,264377},{2,6210837},{3,112285},{4,123259},{5,23593},{6,23593},{7,15584},{8,15431},{48,4341},{49,5696}]',21598239),(665,'[{1,265488},{2,6235728},{3,112702},{4,123690},{5,23680},{6,23680},{7,15626},{8,15472},{48,4446},{49,5713}]',21683158),(666,'[{1,266599},{2,6260619},{3,113119},{4,124122},{5,23768},{6,23768},{7,15668},{8,15514},{48,4550},{49,5730}]',21768077),(667,'[{1,267710},{2,6285509},{3,113537},{4,124553},{5,23855},{6,23855},{7,15710},{8,15556},{48,4654},{49,5748}]',21852996),(668,'[{1,268821},{2,6310400},{3,113954},{4,124985},{5,23943},{6,23943},{7,15752},{8,15597},{48,4759},{49,5765}]',21937915),(669,'[{1,269932},{2,6335291},{3,114371},{4,125416},{5,24031},{6,24031},{7,15794},{8,15639},{48,4863},{49,5782}]',22022834),(670,'[{1,271044},{2,6360182},{3,114789},{4,125848},{5,24118},{6,24118},{7,15836},{8,15681},{48,4968},{49,5799}]',22107753),(671,'[{1,272155},{2,6385073},{3,115206},{4,126279},{5,24206},{6,24206},{7,15878},{8,15722},{48,5072},{49,5816}]',22192673),(672,'[{1,273266},{2,6409964},{3,115623},{4,126711},{5,24293},{6,24293},{7,15920},{8,15764},{48,5176},{49,5833}]',22277592),(673,'[{1,274377},{2,6434854},{3,116040},{4,127142},{5,24381},{6,24381},{7,15962},{8,15806},{48,5281},{49,5850}]',22362511),(674,'[{1,275488},{2,6459745},{3,116458},{4,127574},{5,24468},{6,24468},{7,16004},{8,15847},{48,5385},{49,5867}]',22447430),(675,'[{1,276599},{2,6484636},{3,116875},{4,128006},{5,24556},{6,24556},{7,16046},{8,15889},{48,5490},{49,5884}]',22532349),(676,'[{1,277710},{2,6509527},{3,117292},{4,128437},{5,24644},{6,24644},{7,16088},{8,15931},{48,5594},{49,5901}]',22617268),(677,'[{1,278821},{2,6534418},{3,117710},{4,128869},{5,24731},{6,24731},{7,16130},{8,15972},{48,5698},{49,5918}]',22702187),(678,'[{1,279932},{2,6559308},{3,118127},{4,129300},{5,24819},{6,24819},{7,16172},{8,16014},{48,5803},{49,5935}]',22787106),(679,'[{1,281043},{2,6584199},{3,118544},{4,129732},{5,24906},{6,24906},{7,16214},{8,16056},{48,5907},{49,5952}]',22872025),(680,'[{1,282155},{2,6609090},{3,118962},{4,130163},{5,24994},{6,24994},{7,16256},{8,16097},{48,6011},{49,5969}]',22956945),(681,'[{1,283266},{2,6633981},{3,119379},{4,130595},{5,25081},{6,25081},{7,16298},{8,16139},{48,6116},{49,5986}]',23041864),(682,'[{1,284377},{2,6658872},{3,119796},{4,131026},{5,25169},{6,25169},{7,16340},{8,16181},{48,6220},{49,6003}]',23126783),(683,'[{1,285488},{2,6683763},{3,120213},{4,131458},{5,25257},{6,25257},{7,16382},{8,16222},{48,6325},{49,6020}]',23211702),(684,'[{1,286599},{2,6708653},{3,120631},{4,131889},{5,25344},{6,25344},{7,16424},{8,16264},{48,6429},{49,6038}]',23296621),(685,'[{1,287710},{2,6733544},{3,121048},{4,132321},{5,25432},{6,25432},{7,16466},{8,16306},{48,6533},{49,6055}]',23381540),(686,'[{1,288821},{2,6758435},{3,121465},{4,132752},{5,25519},{6,25519},{7,16508},{8,16347},{48,6638},{49,6072}]',23466459),(687,'[{1,289932},{2,6783326},{3,121883},{4,133184},{5,25607},{6,25607},{7,16550},{8,16389},{48,6742},{49,6089}]',23551378),(688,'[{1,291043},{2,6808217},{3,122300},{4,133615},{5,25695},{6,25695},{7,16592},{8,16431},{48,6847},{49,6106}]',23636298),(689,'[{1,292154},{2,6833107},{3,122717},{4,134047},{5,25782},{6,25782},{7,16634},{8,16472},{48,6951},{49,6123}]',23721217),(690,'[{1,293265},{2,6857998},{3,123135},{4,134478},{5,25870},{6,25870},{7,16676},{8,16514},{48,7055},{49,6140}]',23806136),(691,'[{1,294377},{2,6882889},{3,123552},{4,134910},{5,25957},{6,25957},{7,16718},{8,16556},{48,7160},{49,6157}]',23891055),(692,'[{1,295488},{2,6907780},{3,123969},{4,135341},{5,26045},{6,26045},{7,16760},{8,16597},{48,7264},{49,6174}]',23975974),(693,'[{1,296599},{2,6932671},{3,124386},{4,135773},{5,26132},{6,26132},{7,16802},{8,16639},{48,7369},{49,6191}]',24060893),(694,'[{1,297710},{2,6957562},{3,124804},{4,136204},{5,26220},{6,26220},{7,16844},{8,16681},{48,7473},{49,6208}]',24145812),(695,'[{1,298821},{2,6982452},{3,125221},{4,136636},{5,26308},{6,26308},{7,16886},{8,16722},{48,7577},{49,6225}]',24230731),(696,'[{1,299932},{2,7007343},{3,125638},{4,137067},{5,26395},{6,26395},{7,16928},{8,16764},{48,7682},{49,6242}]',24315651),(697,'[{1,301043},{2,7032234},{3,126056},{4,137499},{5,26483},{6,26483},{7,16970},{8,16806},{48,7786},{49,6259}]',24400570),(698,'[{1,302154},{2,7057125},{3,126473},{4,137930},{5,26570},{6,26570},{7,17012},{8,16847},{48,7891},{49,6276}]',24485489),(699,'[{1,303265},{2,7082016},{3,126890},{4,138362},{5,26658},{6,26658},{7,17054},{8,16889},{48,7995},{49,6293}]',24570408),(700,'[{1,304377},{2,7106907},{3,127308},{4,138794},{5,26746},{6,26746},{7,17097},{8,16931},{48,8100},{49,6311}]',24655327),(701,'[{1,305358},{2,7129439},{3,127752},{4,139253},{5,26821},{6,26821},{7,17135},{8,16972},{48,8100},{49,6325}]',24732112),(702,'[{1,306339},{2,7151971},{3,128196},{4,139713},{5,26897},{6,26897},{7,17173},{8,17014},{48,8100},{49,6340}]',24808896),(703,'[{1,307320},{2,7174503},{3,128641},{4,140172},{5,26973},{6,26973},{7,17212},{8,17056},{48,8100},{49,6354}]',24885681),(704,'[{1,308301},{2,7197035},{3,129085},{4,140632},{5,27049},{6,27049},{7,17250},{8,17097},{48,8100},{49,6369}]',24962465),(705,'[{1,309282},{2,7219567},{3,129529},{4,141091},{5,27125},{6,27125},{7,17289},{8,17139},{48,8100},{49,6384}]',25039250),(706,'[{1,310263},{2,7242099},{3,129974},{4,141551},{5,27201},{6,27201},{7,17327},{8,17181},{48,8100},{49,6398}]',25116034),(707,'[{1,311244},{2,7264631},{3,130418},{4,142010},{5,27277},{6,27277},{7,17365},{8,17223},{48,8100},{49,6413}]',25192819),(708,'[{1,312225},{2,7287163},{3,130862},{4,142470},{5,27353},{6,27353},{7,17404},{8,17264},{48,8100},{49,6427}]',25269603),(709,'[{1,313206},{2,7309696},{3,131307},{4,142929},{5,27428},{6,27428},{7,17442},{8,17306},{48,8100},{49,6442}]',25346388),(710,'[{1,314187},{2,7332228},{3,131751},{4,143389},{5,27504},{6,27504},{7,17481},{8,17348},{48,8100},{49,6457}]',25423172),(711,'[{1,315168},{2,7354760},{3,132195},{4,143848},{5,27580},{6,27580},{7,17519},{8,17390},{48,8100},{49,6471}]',25499957),(712,'[{1,316149},{2,7377292},{3,132640},{4,144308},{5,27656},{6,27656},{7,17558},{8,17431},{48,8100},{49,6486}]',25576741),(713,'[{1,317130},{2,7399824},{3,133084},{4,144767},{5,27732},{6,27732},{7,17596},{8,17473},{48,8100},{49,6501}]',25653526),(714,'[{1,318111},{2,7422356},{3,133529},{4,145227},{5,27808},{6,27808},{7,17634},{8,17515},{48,8100},{49,6515}]',25730310),(715,'[{1,319092},{2,7444888},{3,133973},{4,145686},{5,27884},{6,27884},{7,17673},{8,17557},{48,8100},{49,6530}]',25807095),(716,'[{1,320073},{2,7467420},{3,134417},{4,146146},{5,27960},{6,27960},{7,17711},{8,17598},{48,8100},{49,6544}]',25883879),(717,'[{1,321054},{2,7489953},{3,134862},{4,146605},{5,28035},{6,28035},{7,17750},{8,17640},{48,8100},{49,6559}]',25960664),(718,'[{1,322035},{2,7512485},{3,135306},{4,147065},{5,28111},{6,28111},{7,17788},{8,17682},{48,8100},{49,6574}]',26037448),(719,'[{1,323016},{2,7535017},{3,135750},{4,147524},{5,28187},{6,28187},{7,17826},{8,17724},{48,8100},{49,6588}]',26114233),(720,'[{1,323997},{2,7557549},{3,136195},{4,147984},{5,28263},{6,28263},{7,17865},{8,17765},{48,8100},{49,6603}]',26191017),(721,'[{1,324978},{2,7580081},{3,136639},{4,148443},{5,28339},{6,28339},{7,17903},{8,17807},{48,8100},{49,6618}]',26267802),(722,'[{1,325959},{2,7602613},{3,137083},{4,148903},{5,28415},{6,28415},{7,17942},{8,17849},{48,8100},{49,6632}]',26344586),(723,'[{1,326940},{2,7625145},{3,137528},{4,149362},{5,28491},{6,28491},{7,17980},{8,17891},{48,8100},{49,6647}]',26421371),(724,'[{1,327921},{2,7647677},{3,137972},{4,149822},{5,28567},{6,28567},{7,18019},{8,17932},{48,8100},{49,6661}]',26498155),(725,'[{1,328902},{2,7670210},{3,138417},{4,150282},{5,28643},{6,28643},{7,18057},{8,17974},{48,8100},{49,6676}]',26574940),(726,'[{1,329884},{2,7692742},{3,138861},{4,150741},{5,28718},{6,28718},{7,18095},{8,18016},{48,8100},{49,6691}]',26651725),(727,'[{1,330865},{2,7715274},{3,139305},{4,151201},{5,28794},{6,28794},{7,18134},{8,18057},{48,8100},{49,6705}]',26728509),(728,'[{1,331846},{2,7737806},{3,139750},{4,151660},{5,28870},{6,28870},{7,18172},{8,18099},{48,8100},{49,6720}]',26805294),(729,'[{1,332827},{2,7760338},{3,140194},{4,152120},{5,28946},{6,28946},{7,18211},{8,18141},{48,8100},{49,6734}]',26882078),(730,'[{1,333808},{2,7782870},{3,140638},{4,152579},{5,29022},{6,29022},{7,18249},{8,18183},{48,8100},{49,6749}]',26958863),(731,'[{1,334789},{2,7805402},{3,141083},{4,153039},{5,29098},{6,29098},{7,18288},{8,18224},{48,8100},{49,6764}]',27035647),(732,'[{1,335770},{2,7827934},{3,141527},{4,153498},{5,29174},{6,29174},{7,18326},{8,18266},{48,8100},{49,6778}]',27112432),(733,'[{1,336751},{2,7850466},{3,141971},{4,153958},{5,29250},{6,29250},{7,18364},{8,18308},{48,8100},{49,6793}]',27189216),(734,'[{1,337732},{2,7872999},{3,142416},{4,154417},{5,29325},{6,29325},{7,18403},{8,18350},{48,8100},{49,6808}]',27266001),(735,'[{1,338713},{2,7895531},{3,142860},{4,154877},{5,29401},{6,29401},{7,18441},{8,18391},{48,8100},{49,6822}]',27342785),(736,'[{1,339694},{2,7918063},{3,143304},{4,155336},{5,29477},{6,29477},{7,18480},{8,18433},{48,8100},{49,6837}]',27419570),(737,'[{1,340675},{2,7940595},{3,143749},{4,155796},{5,29553},{6,29553},{7,18518},{8,18475},{48,8100},{49,6851}]',27496354),(738,'[{1,341656},{2,7963127},{3,144193},{4,156255},{5,29629},{6,29629},{7,18556},{8,18517},{48,8100},{49,6866}]',27573139),(739,'[{1,342637},{2,7985659},{3,144638},{4,156715},{5,29705},{6,29705},{7,18595},{8,18558},{48,8100},{49,6881}]',27649923),(740,'[{1,343618},{2,8008191},{3,145082},{4,157174},{5,29781},{6,29781},{7,18633},{8,18600},{48,8100},{49,6895}]',27726708),(741,'[{1,344599},{2,8030723},{3,145526},{4,157634},{5,29857},{6,29857},{7,18672},{8,18642},{48,8100},{49,6910}]',27803492),(742,'[{1,345580},{2,8053256},{3,145971},{4,158093},{5,29932},{6,29932},{7,18710},{8,18684},{48,8100},{49,6925}]',27880277),(743,'[{1,346561},{2,8075788},{3,146415},{4,158553},{5,30008},{6,30008},{7,18749},{8,18725},{48,8100},{49,6939}]',27957061),(744,'[{1,347542},{2,8098320},{3,146859},{4,159012},{5,30084},{6,30084},{7,18787},{8,18767},{48,8100},{49,6954}]',28033846),(745,'[{1,348523},{2,8120852},{3,147304},{4,159472},{5,30160},{6,30160},{7,18825},{8,18809},{48,8100},{49,6968}]',28110630),(746,'[{1,349504},{2,8143384},{3,147748},{4,159931},{5,30236},{6,30236},{7,18864},{8,18851},{48,8100},{49,6983}]',28187415),(747,'[{1,350485},{2,8165916},{3,148192},{4,160391},{5,30312},{6,30312},{7,18902},{8,18892},{48,8100},{49,6998}]',28264199),(748,'[{1,351466},{2,8188448},{3,148637},{4,160850},{5,30388},{6,30388},{7,18941},{8,18934},{48,8100},{49,7012}]',28340984),(749,'[{1,352447},{2,8210980},{3,149081},{4,161310},{5,30464},{6,30464},{7,18979},{8,18976},{48,8100},{49,7027}]',28417768),(750,'[{1,353429},{2,8233513},{3,149526},{4,161770},{5,30540},{6,30540},{7,19018},{8,19018},{48,8100},{49,7042}]',28494553),(751,'[{1,354489},{2,8257863},{3,150042},{4,162301},{5,30616},{6,30616},{7,19096},{8,19096},{48,8100},{49,7072}]',28582784),(752,'[{1,355549},{2,8282214},{3,150559},{4,162832},{5,30693},{6,30693},{7,19175},{8,19175},{48,8100},{49,7103}]',28671015),(753,'[{1,356609},{2,8306565},{3,151076},{4,163364},{5,30770},{6,30770},{7,19253},{8,19253},{48,8100},{49,7134}]',28759246),(754,'[{1,357669},{2,8330916},{3,151593},{4,163895},{5,30846},{6,30846},{7,19332},{8,19332},{48,8100},{49,7165}]',28847477),(755,'[{1,358729},{2,8355267},{3,152110},{4,164427},{5,30923},{6,30923},{7,19411},{8,19411},{48,8100},{49,7196}]',28935707),(756,'[{1,359790},{2,8379618},{3,152627},{4,164958},{5,31000},{6,31000},{7,19489},{8,19489},{48,8100},{49,7227}]',29023938),(757,'[{1,360850},{2,8403969},{3,153144},{4,165489},{5,31077},{6,31077},{7,19568},{8,19568},{48,8100},{49,7258}]',29112169),(758,'[{1,361910},{2,8428320},{3,153661},{4,166021},{5,31153},{6,31153},{7,19647},{8,19647},{48,8100},{49,7289}]',29200400),(759,'[{1,362970},{2,8452671},{3,154178},{4,166552},{5,31230},{6,31230},{7,19725},{8,19725},{48,8100},{49,7320}]',29288631),(760,'[{1,364030},{2,8477022},{3,154695},{4,167084},{5,31307},{6,31307},{7,19804},{8,19804},{48,8100},{49,7351}]',29376862),(761,'[{1,365090},{2,8501373},{3,155212},{4,167615},{5,31384},{6,31384},{7,19883},{8,19883},{48,8100},{49,7382}]',29465093),(762,'[{1,366151},{2,8525724},{3,155729},{4,168147},{5,31460},{6,31460},{7,19961},{8,19961},{48,8100},{49,7413}]',29553324),(763,'[{1,367211},{2,8550075},{3,156246},{4,168678},{5,31537},{6,31537},{7,20040},{8,20040},{48,8100},{49,7444}]',29641554),(764,'[{1,368271},{2,8574426},{3,156763},{4,169209},{5,31614},{6,31614},{7,20118},{8,20118},{48,8100},{49,7475}]',29729785),(765,'[{1,369331},{2,8598777},{3,157280},{4,169741},{5,31691},{6,31691},{7,20197},{8,20197},{48,8100},{49,7506}]',29818016),(766,'[{1,370391},{2,8623128},{3,157797},{4,170272},{5,31767},{6,31767},{7,20276},{8,20276},{48,8100},{49,7537}]',29906247),(767,'[{1,371452},{2,8647479},{3,158314},{4,170804},{5,31844},{6,31844},{7,20354},{8,20354},{48,8100},{49,7568}]',29994478),(768,'[{1,372512},{2,8671830},{3,158831},{4,171335},{5,31921},{6,31921},{7,20433},{8,20433},{48,8100},{49,7599}]',30082709),(769,'[{1,373572},{2,8696181},{3,159348},{4,171866},{5,31998},{6,31998},{7,20512},{8,20512},{48,8100},{49,7630}]',30170940),(770,'[{1,374632},{2,8720532},{3,159865},{4,172398},{5,32074},{6,32074},{7,20590},{8,20590},{48,8100},{49,7661}]',30259171),(771,'[{1,375692},{2,8744883},{3,160382},{4,172929},{5,32151},{6,32151},{7,20669},{8,20669},{48,8100},{49,7692}]',30347401),(772,'[{1,376752},{2,8769234},{3,160899},{4,173461},{5,32228},{6,32228},{7,20748},{8,20748},{48,8100},{49,7723}]',30435632),(773,'[{1,377813},{2,8793585},{3,161416},{4,173992},{5,32305},{6,32305},{7,20826},{8,20826},{48,8100},{49,7754}]',30523863),(774,'[{1,378873},{2,8817936},{3,161933},{4,174524},{5,32381},{6,32381},{7,20905},{8,20905},{48,8100},{49,7785}]',30612094),(775,'[{1,379933},{2,8842287},{3,162450},{4,175055},{5,32458},{6,32458},{7,20984},{8,20984},{48,8100},{49,7816}]',30700325),(776,'[{1,380993},{2,8866638},{3,162966},{4,175586},{5,32535},{6,32535},{7,21062},{8,21062},{48,8100},{49,7846}]',30788556),(777,'[{1,382053},{2,8890989},{3,163483},{4,176118},{5,32611},{6,32611},{7,21141},{8,21141},{48,8100},{49,7877}]',30876787),(778,'[{1,383114},{2,8915340},{3,164000},{4,176649},{5,32688},{6,32688},{7,21219},{8,21219},{48,8100},{49,7908}]',30965018),(779,'[{1,384174},{2,8939691},{3,164517},{4,177181},{5,32765},{6,32765},{7,21298},{8,21298},{48,8100},{49,7939}]',31053249),(780,'[{1,385234},{2,8964042},{3,165034},{4,177712},{5,32842},{6,32842},{7,21377},{8,21377},{48,8100},{49,7970}]',31141479),(781,'[{1,386294},{2,8988393},{3,165551},{4,178244},{5,32918},{6,32918},{7,21455},{8,21455},{48,8100},{49,8001}]',31229710),(782,'[{1,387354},{2,9012744},{3,166068},{4,178775},{5,32995},{6,32995},{7,21534},{8,21534},{48,8100},{49,8032}]',31317941),(783,'[{1,388414},{2,9037095},{3,166585},{4,179306},{5,33072},{6,33072},{7,21613},{8,21613},{48,8100},{49,8063}]',31406172),(784,'[{1,389475},{2,9061446},{3,167102},{4,179838},{5,33149},{6,33149},{7,21691},{8,21691},{48,8100},{49,8094}]',31494403),(785,'[{1,390535},{2,9085797},{3,167619},{4,180369},{5,33225},{6,33225},{7,21770},{8,21770},{48,8100},{49,8125}]',31582634),(786,'[{1,391595},{2,9110148},{3,168136},{4,180901},{5,33302},{6,33302},{7,21849},{8,21849},{48,8100},{49,8156}]',31670865),(787,'[{1,392655},{2,9134499},{3,168653},{4,181432},{5,33379},{6,33379},{7,21927},{8,21927},{48,8100},{49,8187}]',31759096),(788,'[{1,393715},{2,9158850},{3,169170},{4,181963},{5,33456},{6,33456},{7,22006},{8,22006},{48,8100},{49,8218}]',31847326),(789,'[{1,394776},{2,9183201},{3,169687},{4,182495},{5,33532},{6,33532},{7,22084},{8,22084},{48,8100},{49,8249}]',31935557),(790,'[{1,395836},{2,9207552},{3,170204},{4,183026},{5,33609},{6,33609},{7,22163},{8,22163},{48,8100},{49,8280}]',32023788),(791,'[{1,396896},{2,9231903},{3,170721},{4,183558},{5,33686},{6,33686},{7,22242},{8,22242},{48,8100},{49,8311}]',32112019),(792,'[{1,397956},{2,9256254},{3,171238},{4,184089},{5,33763},{6,33763},{7,22320},{8,22320},{48,8100},{49,8342}]',32200250),(793,'[{1,399016},{2,9280605},{3,171755},{4,184621},{5,33839},{6,33839},{7,22399},{8,22399},{48,8100},{49,8373}]',32288481),(794,'[{1,400076},{2,9304956},{3,172272},{4,185152},{5,33916},{6,33916},{7,22478},{8,22478},{48,8100},{49,8404}]',32376712),(795,'[{1,401137},{2,9329307},{3,172789},{4,185683},{5,33993},{6,33993},{7,22556},{8,22556},{48,8100},{49,8435}]',32464943),(796,'[{1,402197},{2,9353658},{3,173306},{4,186215},{5,34070},{6,34070},{7,22635},{8,22635},{48,8100},{49,8466}]',32553173),(797,'[{1,403257},{2,9378009},{3,173823},{4,186746},{5,34146},{6,34146},{7,22714},{8,22714},{48,8100},{49,8497}]',32641404),(798,'[{1,404317},{2,9402360},{3,174340},{4,187278},{5,34223},{6,34223},{7,22792},{8,22792},{48,8100},{49,8528}]',32729635),(799,'[{1,405377},{2,9426711},{3,174857},{4,187809},{5,34300},{6,34300},{7,22871},{8,22871},{48,8100},{49,8559}]',32817866),(800,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(801,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(802,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(803,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(804,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(805,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(806,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(807,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(808,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(809,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(810,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(811,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(812,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(813,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(814,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(815,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(816,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(817,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(818,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(819,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(820,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(821,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(822,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(823,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(824,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(825,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(826,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(827,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(828,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(829,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(830,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(831,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(832,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(833,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(834,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(835,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(836,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(837,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(838,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(839,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(840,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(841,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(842,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(843,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(844,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(845,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(846,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(847,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(848,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(849,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(850,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(851,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(852,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(853,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(854,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(855,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(856,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(857,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(858,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(859,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(860,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(861,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(862,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(863,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(864,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(865,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(866,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(867,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(868,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(869,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(870,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(871,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(872,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(873,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(874,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(875,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(876,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(877,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(878,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(879,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(880,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(881,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(882,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(883,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(884,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(885,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(886,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(887,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(888,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(889,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(890,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(891,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(892,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(893,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(894,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(895,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(896,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(897,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(898,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(899,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(900,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(901,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(902,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(903,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(904,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(905,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(906,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(907,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(908,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(909,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(910,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(911,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(912,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(913,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(914,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(915,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(916,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(917,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(918,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(919,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(920,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(921,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(922,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(923,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(924,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(925,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(926,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(927,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(928,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(929,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(930,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(931,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(932,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(933,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(934,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(935,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(936,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(937,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(938,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(939,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(940,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(941,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(942,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(943,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(944,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(945,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(946,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(947,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(948,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(949,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(950,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(951,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(952,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(953,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(954,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(955,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(956,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(957,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(958,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(959,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(960,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(961,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(962,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(963,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(964,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(965,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(966,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(967,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(968,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(969,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(970,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(971,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(972,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(973,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(974,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(975,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(976,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(977,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(978,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(979,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(980,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(981,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(982,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(983,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(984,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(985,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(986,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(987,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(988,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(989,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(990,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(991,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(992,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(993,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(994,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(995,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(996,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(997,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(998,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(999,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(1000,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097);
/*!40000 ALTER TABLE `base_dungeon_fake_role` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_dungeon_good_times`
--

DROP TABLE IF EXISTS `base_dungeon_good_times`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_dungeon_good_times` (
  `good_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '道具id',
  `dun_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本类型',
  `times` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '增加次数',
  `limit` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '每日上限',
  PRIMARY KEY (`good_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_dungeon_good_times`
--

LOCK TABLES `base_dungeon_good_times` WRITE;
/*!40000 ALTER TABLE `base_dungeon_good_times` DISABLE KEYS */;
INSERT INTO `base_dungeon_good_times` VALUES (38340001,4,1,0),(38340002,18,1,0),(38340003,19,1,0),(38340004,22,1,0),(38340005,13,1,0),(38340006,5,1,0);
/*!40000 ALTER TABLE `base_dungeon_good_times` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_dungeon_grade`
--

DROP TABLE IF EXISTS `base_dungeon_grade`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_dungeon_grade` (
  `dun_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本id',
  `grade` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `min_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小分数',
  `max_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大分数',
  `reward` text NOT NULL COMMENT '奖励列表',
  `must_rewards_show` varchar(255) NOT NULL DEFAULT '[]' COMMENT '必得奖励（展示）',
  `rand_rewards_show` varchar(255) NOT NULL DEFAULT '[]' COMMENT '随机奖励（展示）',
  PRIMARY KEY (`dun_id`,`min_score`,`max_score`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='副本评分配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_dungeon_grade`
--

LOCK TABLES `base_dungeon_grade` WRITE;
/*!40000 ALTER TABLE `base_dungeon_grade` DISABLE KEYS */;
INSERT INTO `base_dungeon_grade` VALUES (1002,0,0,0,'[{2,36020001,5}]','[]','[]'),(1003,0,1,1,'[{2,36020001,10},{0,1003000320,1}]','[]','[]'),(2201,0,0,0,'[{0,15010001,1}]','[]','[]'),(2202,0,0,0,'[{0,15010005,1},{2,36020001,20}]','[]','[]'),(2203,0,0,0,'[{0,15010002,1}]','[]','[]'),(2204,0,0,0,'[{0,15010007,1}]','[]','[]'),(2301,0,0,0,'[{3,36030001,20000}]','[]','[]'),(2302,0,0,0,'[{3,36030001,30000}]','[]','[]'),(2303,0,0,0,'[{3,36030001,40000}]','[]','[]'),(3000,1,0,1,'[]','[]','[]'),(3000,2,2,3,'[]','[]','[]'),(3000,3,4,5,'[]','[]','[]'),(3000,3,4,99999,'[]','[]','[]'),(3001,1,0,1,'[]','[]','[]'),(3001,2,2,3,'[]','[]','[]'),(3001,3,4,5,'[]','[]','[]'),(3001,3,4,99999,'[]','[]','[]'),(3110,105,1,1,'[{0,37010508,7}]','[]','[]'),(3110,105,2,2,'[{0,37010508,9}]','[]','[]'),(3110,105,3,3,'[{0,37010509,4}]','[]','[]'),(3110,105,4,4,'[{0,37010510,2}]','[]','[]'),(3110,105,5,5,'[{0,37010510,3}]','[]','[]'),(3111,140,1,1,'[{0,37010508,8}]','[]','[]'),(3111,140,2,2,'[{0,37010508,10}]','[]','[]'),(3111,140,3,3,'[{0,37010509,5}]','[]','[]'),(3111,140,4,4,'[{0,37010510,2},{0,37010509,1}]','[]','[]'),(3111,140,5,5,'[{0,37010510,3},{0,37010509,1}]','[]','[]'),(3112,200,1,1,'[{0,37010508,14}]','[]','[]'),(3112,200,2,2,'[{0,37010508,17}]','[]','[]'),(3112,200,3,3,'[{0,37010509,8}]','[]','[]'),(3112,200,4,4,'[{0,37010510,4}]','[]','[]'),(3112,200,5,5,'[{0,37010510,5}]','[]','[]'),(3113,240,1,1,'[{0,37010510,4}]','[]','[]'),(3113,240,2,2,'[{0,37010510,5}]','[]','[]'),(3113,240,3,3,'[{0,37010510,6}]','[]','[]'),(3113,240,4,4,'[{0,37010510,7}]','[]','[]'),(3113,240,5,5,'[{0,37010510,8}]','[]','[]'),(3114,300,1,1,'[{0,37010510,5}]','[]','[]'),(3114,300,2,2,'[{0,37010510,6}]','[]','[]'),(3114,300,3,3,'[{0,37010510,7}]','[]','[]'),(3114,300,4,4,'[{0,37010510,9}]','[]','[]'),(3114,300,5,5,'[{0,37010510,10}]','[]','[]'),(3115,350,1,1,'[{0,37010510,6}]','[]','[]'),(3115,350,2,2,'[{0,37010510,7}]','[]','[]'),(3115,350,3,3,'[{0,37010510,8}]','[]','[]'),(3115,350,4,4,'[{0,37010510,10}]','[]','[]'),(3115,350,5,5,'[{0,37010510,12}]','[]','[]'),(3116,400,1,1,'[{0,37010511,7}]','[]','[]'),(3116,400,2,2,'[{0,37010511,9}]','[]','[]'),(3116,400,3,3,'[{0,37010511,11}]','[]','[]'),(3116,400,4,4,'[{0,37010511,13}]','[]','[]'),(3116,400,5,5,'[{0,37010511,15}]','[]','[]'),(3117,450,1,1,'[{0,37010511,12}]','[]','[]'),(3117,450,2,2,'[{0,37010511,15}]','[]','[]'),(3117,450,3,3,'[{0,37010511,17}]','[]','[]'),(3117,450,4,4,'[{0,37010511,21}]','[]','[]'),(3117,450,5,5,'[{0,37010511,25}]','[]','[]'),(3118,500,1,1,'[{0,37010511,16}]','[]','[]'),(3118,500,2,2,'[{0,37010511,19}]','[]','[]'),(3118,500,3,3,'[{0,37010511,23}]','[]','[]'),(3118,500,4,4,'[{0,37010511,28}]','[]','[]'),(3118,500,5,5,'[{0,37010511,33}]','[]','[]'),(3119,580,1,1,'[{0,37010512,13}]','[]','[]'),(3119,580,2,2,'[{0,37010512,15}]','[]','[]'),(3119,580,3,3,'[{0,37010512,18}]','[]','[]'),(3119,580,4,4,'[{0,37010512,22}]','[]','[]'),(3119,580,5,5,'[{0,37010512,26}]','[]','[]'),(3120,620,1,1,'[{0,37010512,15}]','[]','[]'),(3120,620,2,2,'[{0,37010512,18}]','[]','[]'),(3120,620,3,3,'[{0,37010512,21}]','[]','[]'),(3120,620,4,4,'[{0,37010512,26}]','[]','[]'),(3120,620,5,5,'[{0,37010512,31}]','[]','[]'),(3121,680,1,1,'[{0,37010512,19}]','[]','[]'),(3121,680,2,2,'[{0,37010512,22}]','[]','[]'),(3121,680,3,3,'[{0,37010512,26}]','[]','[]'),(3121,680,4,4,'[{0,37010512,32}]','[]','[]'),(3121,680,5,5,'[{0,37010512,38}]','[]','[]'),(3122,750,1,1,'[{0,37010512,23}]','[]','[]'),(3122,750,2,2,'[{0,37010512,27}]','[]','[]'),(3122,750,3,3,'[{0,37010512,32}]','[]','[]'),(3122,750,4,4,'[{0,37010512,39}]','[]','[]'),(3122,750,5,5,'[{0,37010512,46}]','[]','[]'),(5200,100,0,5000,'[{0,40010011,9},{255,40040001,127}]','[]','[]'),(5200,100,5001,9000,'[{0,40010011,12},{255,40040001,150}]','[]','[]'),(5200,100,9001,12000,'[{0,40010011,15},{255,40040001,187}]','[]','[]'),(5200,100,12001,13500,'[{0,40010011,18},{255,40040001,225}]','[]','[]'),(5200,100,13500,14800,'[{0,40010011,22},{255,40040001,270}]','[]','[]'),(5201,100,0,5000,'[{0,40010011,15},{255,40040001,195}]','[]','[]'),(5201,100,5001,9000,'[{0,40010011,18},{255,40040001,240}]','[]','[]'),(5201,100,9001,12000,'[{0,40010011,24},{255,40040001,300}]','[]','[]'),(5201,100,12001,13500,'[{0,40010011,30},{255,40040001,375}]','[]','[]'),(5201,100,13500,14800,'[{0,40010011,37},{255,40040001,450}]','[]','[]'),(5202,100,0,5000,'[{0,40010011,27},{255,40040001,300}]','[]','[]'),(5202,100,5001,9000,'[{0,40010011,30},{255,40040001,375}]','[]','[]'),(5202,100,9001,12000,'[{0,40010011,37},{255,40040001,450}]','[]','[]'),(5202,100,12001,13500,'[{0,40010011,45},{255,40040001,540}]','[]','[]'),(5202,100,13500,14800,'[{0,40010011,54},{255,40040001,675}]','[]','[]'),(5300,0,0,0,'[{0,18020001,15}]','[]','[]'),(5300,1,1,1,'[{0,18020001,15}]','[]','[]'),(5300,2,2,2,'[{0,18020001,15}]','[]','[]'),(5300,3,3,3,'[{0,18020001,15}]','[]','[]'),(5300,4,4,4,'[{0,18020001,15}]','[]','[]'),(5300,5,5,5,'[{0,18020001,15}]','[]','[]'),(5301,0,0,0,'[{0,18020001,25}]','[]','[]'),(5301,1,1,1,'[{0,18020001,25}]','[]','[]'),(5301,2,2,2,'[{0,18020001,25}]','[]','[]'),(5301,3,3,3,'[{0,18020001,25}]','[]','[]'),(5301,4,4,4,'[{0,18020001,25}]','[]','[]'),(5301,5,5,5,'[{0,18020001,25}]','[]','[]'),(5302,0,0,0,'[{0,18020001,15},{0,18020002,5}]','[]','[]'),(5302,1,1,1,'[{0,18020001,15},{0,18020002,5}]','[]','[]'),(5302,2,2,2,'[{0,18020001,15},{0,18020002,5}]','[]','[]'),(5302,3,3,3,'[{0,18020001,15},{0,18020002,5}]','[]','[]'),(5302,4,4,4,'[{0,18020001,15},{0,18020002,5}]','[]','[]'),(5302,5,5,5,'[{0,18020001,15},{0,18020002,5}]','[]','[]'),(5303,0,0,0,'[{0,18020002,15}]','[]','[]'),(5303,1,1,1,'[{0,18020002,15}]','[]','[]'),(5303,2,2,2,'[{0,18020002,15}]','[]','[]'),(5303,3,3,3,'[{0,18020002,15}]','[]','[]'),(5303,4,4,4,'[{0,18020002,15}]','[]','[]'),(5303,5,5,5,'[{0,18020002,15}]','[]','[]'),(5304,0,0,0,'[{0,18020002,9},{0,18020003,5}]','[]','[]'),(5304,1,1,1,'[{0,18020002,9},{0,18020003,5}]','[]','[]'),(5304,2,2,2,'[{0,18020002,9},{0,18020003,5}]','[]','[]'),(5304,3,3,3,'[{0,18020002,9},{0,18020003,5}]','[]','[]'),(5304,4,4,4,'[{0,18020002,9},{0,18020003,5}]','[]','[]'),(5304,5,5,5,'[{0,18020002,9},{0,18020003,5}]','[]','[]'),(5400,1,1,1,'[{0,11020001,10}]','[]','[]'),(5400,2,2,2,'[{0,11020001,10}]','[]','[]'),(5400,3,3,3,'[{0,11020001,10}]','[]','[]'),(5400,4,4,4,'[{0,11020001,10}]','[]','[]'),(5400,5,5,5,'[{0,11020001,10}]','[]','[]'),(5401,1,1,1,'[{0,11020001,20}]','[]','[]'),(5401,2,2,2,'[{0,11020001,20}]','[]','[]'),(5401,3,3,3,'[{0,11020001,20}]','[]','[]'),(5401,4,4,4,'[{0,11020001,20}]','[]','[]'),(5401,5,5,5,'[{0,11020001,20}]','[]','[]'),(5402,1,1,1,'[{0,11020001,14},{0,11020002,5}]','[]','[]'),(5402,2,2,2,'[{0,11020001,14},{0,11020002,5}]','[]','[]'),(5402,3,3,3,'[{0,11020001,14},{0,11020002,5}]','[]','[]'),(5402,4,4,4,'[{0,11020001,14},{0,11020002,5}]','[]','[]'),(5402,5,5,5,'[{0,11020001,14},{0,11020002,5}]','[]','[]'),(5403,1,1,1,'[{0,11020002,15}]','[]','[]'),(5403,2,2,2,'[{0,11020002,15}]','[]','[]'),(5403,3,3,3,'[{0,11020002,15}]','[]','[]'),(5403,4,4,4,'[{0,11020002,15}]','[]','[]'),(5403,5,5,5,'[{0,11020002,15}]','[]','[]'),(5404,1,1,1,'[{0,11020002,10},{0,11020003,5}]','[]','[]'),(5404,2,2,2,'[{0,11020002,10},{0,11020003,5}]','[]','[]'),(5404,3,3,3,'[{0,11020002,10},{0,11020003,5}]','[]','[]'),(5404,4,4,4,'[{0,11020002,10},{0,11020003,5}]','[]','[]'),(5404,5,5,5,'[{0,11020002,10},{0,11020003,5}]','[]','[]'),(5405,0,0,0,'[{0,11020001,5},{2,36020001,5}]','[]','[]'),(5405,1,1,1,'[{0,11020001,5},{2,36020001,5}]','[]','[]'),(5405,2,2,2,'[{0,11020001,5},{2,36020001,5}]','[]','[]'),(5405,3,3,3,'[{0,11020001,5},{2,36020001,5}]','[]','[]'),(5405,4,4,4,'[{0,11020001,5},{2,36020001,5}]','[]','[]'),(5405,5,5,5,'[{0,11020001,5},{2,36020001,5}]','[]','[]'),(5900,0,0,0,'[{0,5201011,1},{255,36160007,2500}]','[{0,5201011,1},{255,36160007,2500}]','[]'),(5900,0,1,1,'[{0,5201011,1},{255,36160007,2500}]','[{0,5201011,1},{255,36160007,2500}]','[]'),(5900,0,2,2,'[{0,5201011,1},{255,36160007,2500}]','[{0,5201011,1},{255,36160007,2500}]','[]'),(5900,0,3,3,'[{0,5201011,1},{255,36160007,2500}]','[{0,5201011,1},{255,36160007,2500}]','[]'),(5900,0,4,4,'[{0,5201011,1},{255,36160007,2500}]','[{0,5201011,1},{255,36160007,2500}]','[]'),(5900,0,5,5,'[{0,5201011,1},{255,36160007,2500}]','[{0,5201011,1},{255,36160007,2500}]','[]'),(5901,0,0,0,'[{0,32150002,2},{255,36160007,800}]','[{0,32150002,2},{255,36160007,800}]','[]'),(5901,0,1,1,'[{0,32150002,2},{255,36160007,800}]','[{0,32150002,2},{255,36160007,800}]','[]'),(5901,0,2,2,'[{0,32150002,2},{255,36160007,800}]','[{0,32150002,2},{255,36160007,800}]','[]'),(5901,0,3,3,'[{0,32150002,2},{255,36160007,800}]','[{0,32150002,2},{255,36160007,800}]','[]'),(5901,0,4,4,'[{0,32150002,2},{255,36160007,800}]','[{0,32150002,2},{255,36160007,800}]','[]'),(5901,0,5,5,'[{0,32150002,2},{255,36160007,800}]','[{0,32150002,2},{255,36160007,800}]','[]'),(5902,0,0,0,'[{0,32150002,2},{255,36160007,1000}]','[{0,32150002,2},{255,36160007,1000}]','[]'),(5902,0,1,1,'[{0,32150002,2},{255,36160007,1000}]','[{0,32150002,2},{255,36160007,1000}]','[]'),(5902,0,2,2,'[{0,32150002,2},{255,36160007,1000}]','[{0,32150002,2},{255,36160007,1000}]','[]'),(5902,0,3,3,'[{0,32150002,2},{255,36160007,1000}]','[{0,32150002,2},{255,36160007,1000}]','[]'),(5902,0,4,4,'[{0,32150002,2},{255,36160007,1000}]','[{0,32150002,2},{255,36160007,1000}]','[]'),(5902,0,5,5,'[{0,32150002,2},{255,36160007,1000}]','[{0,32150002,2},{255,36160007,1000}]','[]'),(5903,0,0,0,'[{0,5201141,1},{255,36160007,1200}]','[{0,5201141,1},{255,36160007,1200}]','[]'),(5903,0,1,1,'[{0,5201141,1},{255,36160007,1200}]','[{0,5201141,1},{255,36160007,1200}]','[]'),(5903,0,2,2,'[{0,5201141,1},{255,36160007,1200}]','[{0,5201141,1},{255,36160007,1200}]','[]'),(5903,0,3,3,'[{0,5201141,1},{255,36160007,1200}]','[{0,5201141,1},{255,36160007,1200}]','[]'),(5903,0,4,4,'[{0,5201141,1},{255,36160007,1200}]','[{0,5201141,1},{255,36160007,1200}]','[]'),(5903,0,5,5,'[{0,5201141,1},{255,36160007,1200}]','[{0,5201141,1},{255,36160007,1200}]','[]'),(5904,0,0,0,'[{0,32150002,2},{255,36160007,1400}]','[{0,32150002,2},{255,36160007,1400}]','[]'),(5904,0,1,1,'[{0,32150002,2},{255,36160007,1400}]','[{0,32150002,2},{255,36160007,1400}]','[]'),(5904,0,2,2,'[{0,32150002,2},{255,36160007,1400}]','[{0,32150002,2},{255,36160007,1400}]','[]'),(5904,0,3,3,'[{0,32150002,2},{255,36160007,1400}]','[{0,32150002,2},{255,36160007,1400}]','[]'),(5904,0,4,4,'[{0,32150002,2},{255,36160007,1400}]','[{0,32150002,2},{255,36160007,1400}]','[]'),(5904,0,5,5,'[{0,32150002,2},{255,36160007,1400}]','[{0,32150002,2},{255,36160007,1400}]','[]'),(5905,0,0,0,'[{0,32150003,1},{255,36160007,1800}]','[{0,32150003,1},{255,36160007,1800}]','[]'),(5905,0,1,1,'[{0,32150003,1},{255,36160007,1800}]','[{0,32150003,1},{255,36160007,1800}]','[]'),(5905,0,2,2,'[{0,32150003,1},{255,36160007,1800}]','[{0,32150003,1},{255,36160007,1800}]','[]'),(5905,0,3,3,'[{0,32150003,1},{255,36160007,1800}]','[{0,32150003,1},{255,36160007,1800}]','[]'),(5905,0,4,4,'[{0,32150003,1},{255,36160007,1800}]','[{0,32150003,1},{255,36160007,1800}]','[]'),(5905,0,5,5,'[{0,32150003,1},{255,36160007,1800}]','[{0,32150003,1},{255,36160007,1800}]','[]'),(5906,0,0,0,'[{0,32150002,2},{255,36160007,2200}]','[{0,32150002,2},{255,36160007,2200}]','[]'),(5906,0,1,1,'[{0,32150002,2},{255,36160007,2200}]','[{0,32150002,2},{255,36160007,2200}]','[]'),(5906,0,2,2,'[{0,32150002,2},{255,36160007,2200}]','[{0,32150002,2},{255,36160007,2200}]','[]'),(5906,0,3,3,'[{0,32150002,2},{255,36160007,2200}]','[{0,32150002,2},{255,36160007,2200}]','[]'),(5906,0,4,4,'[{0,32150002,2},{255,36160007,2200}]','[{0,32150002,2},{255,36160007,2200}]','[]'),(5906,0,5,5,'[{0,32150002,2},{255,36160007,2200}]','[{0,32150002,2},{255,36160007,2200}]','[]'),(5907,0,0,0,'[{0,5201051,1},{255,36160007,2500}]','[{0,5201051,1},{255,36160007,2500}]','[]'),(5907,0,1,1,'[{0,5201051,1},{255,36160007,2500}]','[{0,5201051,1},{255,36160007,2500}]','[]'),(5907,0,2,2,'[{0,5201051,1},{255,36160007,2500}]','[{0,5201051,1},{255,36160007,2500}]','[]'),(5907,0,3,3,'[{0,5201051,1},{255,36160007,2500}]','[{0,5201051,1},{255,36160007,2500}]','[]'),(5907,0,4,4,'[{0,5201051,1},{255,36160007,2500}]','[{0,5201051,1},{255,36160007,2500}]','[]'),(5907,0,5,5,'[{0,5201051,1},{255,36160007,2500}]','[{0,5201051,1},{255,36160007,2500}]','[]'),(5908,0,0,0,'[{0,32150002,2},{255,36160007,3000}]','[{0,32150002,2},{255,36160007,3000}]','[]'),(5908,0,1,1,'[{0,32150002,2},{255,36160007,3000}]','[{0,32150002,2},{255,36160007,3000}]','[]'),(5908,0,2,2,'[{0,32150002,2},{255,36160007,3000}]','[{0,32150002,2},{255,36160007,3000}]','[]'),(5908,0,3,3,'[{0,32150002,2},{255,36160007,3000}]','[{0,32150002,2},{255,36160007,3000}]','[]'),(5908,0,4,4,'[{0,32150002,2},{255,36160007,3000}]','[{0,32150002,2},{255,36160007,3000}]','[]'),(5908,0,5,5,'[{0,32150002,2},{255,36160007,3000}]','[{0,32150002,2},{255,36160007,3000}]','[]'),(5909,0,0,0,'[{0,32150002,2},{255,36160007,4200}]','[{0,32150002,2},{255,36160007,4200}]','[]'),(5909,0,1,1,'[{0,32150002,2},{255,36160007,4200}]','[{0,32150002,2},{255,36160007,4200}]','[]'),(5909,0,2,2,'[{0,32150002,2},{255,36160007,4200}]','[{0,32150002,2},{255,36160007,4200}]','[]'),(5909,0,3,3,'[{0,32150002,2},{255,36160007,4200}]','[{0,32150002,2},{255,36160007,4200}]','[]'),(5909,0,4,4,'[{0,32150002,2},{255,36160007,4200}]','[{0,32150002,2},{255,36160007,4200}]','[]'),(5909,0,5,5,'[{0,32150002,2},{255,36160007,4200}]','[{0,32150002,2},{255,36160007,4200}]','[]'),(5910,0,0,0,'[{0,38180010,2},{255,36160007,5300}]','[{0,38180010,2},{255,36160007,5300}]','[]'),(5910,0,1,1,'[{0,38180010,2},{255,36160007,5300}]','[{0,38180010,2},{255,36160007,5300}]','[]'),(5910,0,2,2,'[{0,38180010,2},{255,36160007,5300}]','[{0,38180010,2},{255,36160007,5300}]','[]'),(5910,0,3,3,'[{0,38180010,2},{255,36160007,5300}]','[{0,38180010,2},{255,36160007,5300}]','[]'),(5910,0,4,4,'[{0,38180010,2},{255,36160007,5300}]','[{0,38180010,2},{255,36160007,5300}]','[]'),(5910,0,5,5,'[{0,38180010,2},{255,36160007,5300}]','[{0,38180010,2},{255,36160007,5300}]','[]'),(5911,0,0,0,'[{0,5201061,1},{255,36160007,6300}]','[{0,5201061,1},{255,36160007,6300}]','[]'),(5911,0,1,1,'[{0,5201061,1},{255,36160007,6300}]','[{0,5201061,1},{255,36160007,6300}]','[]'),(5911,0,2,2,'[{0,5201061,1},{255,36160007,6300}]','[{0,5201061,1},{255,36160007,6300}]','[]'),(5911,0,3,3,'[{0,5201061,1},{255,36160007,6300}]','[{0,5201061,1},{255,36160007,6300}]','[]'),(5911,0,4,4,'[{0,5201061,1},{255,36160007,6300}]','[{0,5201061,1},{255,36160007,6300}]','[]'),(5911,0,5,5,'[{0,5201061,1},{255,36160007,6300}]','[{0,5201061,1},{255,36160007,6300}]','[]'),(5912,0,0,0,'[{0,32150002,2},{255,36160007,7400}]','[{0,32150002,2},{255,36160007,7400}]','[]'),(5912,0,1,1,'[{0,32150002,2},{255,36160007,7400}]','[{0,32150002,2},{255,36160007,7400}]','[]'),(5912,0,2,2,'[{0,32150002,2},{255,36160007,7400}]','[{0,32150002,2},{255,36160007,7400}]','[]'),(5912,0,3,3,'[{0,32150002,2},{255,36160007,7400}]','[{0,32150002,2},{255,36160007,7400}]','[]'),(5912,0,4,4,'[{0,32150002,2},{255,36160007,7400}]','[{0,32150002,2},{255,36160007,7400}]','[]'),(5912,0,5,5,'[{0,32150002,2},{255,36160007,7400}]','[{0,32150002,2},{255,36160007,7400}]','[]'),(5913,0,0,0,'[{0,32150002,2},{255,36160007,7800}]','[{0,32150002,2},{255,36160007,7800}]','[]'),(5913,0,1,1,'[{0,32150002,2},{255,36160007,7800}]','[{0,32150002,2},{255,36160007,7800}]','[]'),(5913,0,2,2,'[{0,32150002,2},{255,36160007,7800}]','[{0,32150002,2},{255,36160007,7800}]','[]'),(5913,0,3,3,'[{0,32150002,2},{255,36160007,7800}]','[{0,32150002,2},{255,36160007,7800}]','[]'),(5913,0,4,4,'[{0,32150002,2},{255,36160007,7800}]','[{0,32150002,2},{255,36160007,7800}]','[]'),(5913,0,5,5,'[{0,32150002,2},{255,36160007,7800}]','[{0,32150002,2},{255,36160007,7800}]','[]'),(5914,0,0,0,'[{0,32150002,2},{255,36160007,8300}]','[{0,32150002,2},{255,36160007,8300}]','[]'),(5914,0,1,1,'[{0,32150002,2},{255,36160007,8300}]','[{0,32150002,2},{255,36160007,8300}]','[]'),(5914,0,2,2,'[{0,32150002,2},{255,36160007,8300}]','[{0,32150002,2},{255,36160007,8300}]','[]'),(5914,0,3,3,'[{0,32150002,2},{255,36160007,8300}]','[{0,32150002,2},{255,36160007,8300}]','[]'),(5914,0,4,4,'[{0,32150002,2},{255,36160007,8300}]','[{0,32150002,2},{255,36160007,8300}]','[]'),(5914,0,5,5,'[{0,32150002,2},{255,36160007,8300}]','[{0,32150002,2},{255,36160007,8300}]','[]'),(5915,0,0,0,'[{0,5201081,1},{255,36160007,8700}]','[{0,5201081,1},{255,36160007,8700}]','[]'),(5915,0,1,1,'[{0,5201081,1},{255,36160007,8700}]','[{0,5201081,1},{255,36160007,8700}]','[]'),(5915,0,2,2,'[{0,5201081,1},{255,36160007,8700}]','[{0,5201081,1},{255,36160007,8700}]','[]'),(5915,0,3,3,'[{0,5201081,1},{255,36160007,8700}]','[{0,5201081,1},{255,36160007,8700}]','[]'),(5915,0,4,4,'[{0,5201081,1},{255,36160007,8700}]','[{0,5201081,1},{255,36160007,8700}]','[]'),(5915,0,5,5,'[{0,5201081,1},{255,36160007,8700}]','[{0,5201081,1},{255,36160007,8700}]','[]'),(5916,0,0,0,'[{0,32150002,3},{255,36160007,9200}]','[{0,32150002,3},{255,36160007,9200}]','[]'),(5916,0,1,1,'[{0,32150002,3},{255,36160007,9200}]','[{0,32150002,3},{255,36160007,9200}]','[]'),(5916,0,2,2,'[{0,32150002,3},{255,36160007,9200}]','[{0,32150002,3},{255,36160007,9200}]','[]'),(5916,0,3,3,'[{0,32150002,3},{255,36160007,9200}]','[{0,32150002,3},{255,36160007,9200}]','[]'),(5916,0,4,4,'[{0,32150002,3},{255,36160007,9200}]','[{0,32150002,3},{255,36160007,9200}]','[]'),(5916,0,5,5,'[{0,32150002,3},{255,36160007,9200}]','[{0,32150002,3},{255,36160007,9200}]','[]'),(5917,0,0,0,'[{0,32150002,3},{255,36160007,9600}]','[{0,32150002,3},{255,36160007,9600}]','[]'),(5917,0,1,1,'[{0,32150002,3},{255,36160007,9600}]','[{0,32150002,3},{255,36160007,9600}]','[]'),(5917,0,2,2,'[{0,32150002,3},{255,36160007,9600}]','[{0,32150002,3},{255,36160007,9600}]','[]'),(5917,0,3,3,'[{0,32150002,3},{255,36160007,9600}]','[{0,32150002,3},{255,36160007,9600}]','[]'),(5917,0,4,4,'[{0,32150002,3},{255,36160007,9600}]','[{0,32150002,3},{255,36160007,9600}]','[]'),(5917,0,5,5,'[{0,32150002,3},{255,36160007,9600}]','[{0,32150002,3},{255,36160007,9600}]','[]'),(5918,0,0,0,'[{0,32150002,3},{255,36160007,10100}]','[{0,32150002,3},{255,36160007,10100}]','[]'),(5918,0,1,1,'[{0,32150002,3},{255,36160007,10100}]','[{0,32150002,3},{255,36160007,10100}]','[]'),(5918,0,2,2,'[{0,32150002,3},{255,36160007,10100}]','[{0,32150002,3},{255,36160007,10100}]','[]'),(5918,0,3,3,'[{0,32150002,3},{255,36160007,10100}]','[{0,32150002,3},{255,36160007,10100}]','[]'),(5918,0,4,4,'[{0,32150002,3},{255,36160007,10100}]','[{0,32150002,3},{255,36160007,10100}]','[]'),(5918,0,5,5,'[{0,32150002,3},{255,36160007,10100}]','[{0,32150002,3},{255,36160007,10100}]','[]'),(5919,0,0,0,'[{0,5201101,1},{255,36160007,10500}]','[{0,5201101,1},{255,36160007,10500}]','[]'),(5919,0,1,1,'[{0,5201101,1},{255,36160007,10500}]','[{0,5201101,1},{255,36160007,10500}]','[]'),(5919,0,2,2,'[{0,5201101,1},{255,36160007,10500}]','[{0,5201101,1},{255,36160007,10500}]','[]'),(5919,0,3,3,'[{0,5201101,1},{255,36160007,10500}]','[{0,5201101,1},{255,36160007,10500}]','[]'),(5919,0,4,4,'[{0,5201101,1},{255,36160007,10500}]','[{0,5201101,1},{255,36160007,10500}]','[]'),(5919,0,5,5,'[{0,5201101,1},{255,36160007,10500}]','[{0,5201101,1},{255,36160007,10500}]','[]'),(5920,0,0,0,'[{0,38180010,3},{255,36160007,11000}]','[{0,38180010,3},{255,36160007,11000}]','[]'),(5920,0,1,1,'[{0,38180010,3},{255,36160007,11000}]','[{0,38180010,3},{255,36160007,11000}]','[]'),(5920,0,2,2,'[{0,38180010,3},{255,36160007,11000}]','[{0,38180010,3},{255,36160007,11000}]','[]'),(5920,0,3,3,'[{0,38180010,3},{255,36160007,11000}]','[{0,38180010,3},{255,36160007,11000}]','[]'),(5920,0,4,4,'[{0,38180010,3},{255,36160007,11000}]','[{0,38180010,3},{255,36160007,11000}]','[]'),(5920,0,5,5,'[{0,38180010,3},{255,36160007,11000}]','[{0,38180010,3},{255,36160007,11000}]','[]'),(5921,0,0,0,'[{0,32150002,3},{255,36160007,11400}]','[{0,32150002,3},{255,36160007,11400}]','[]'),(5921,0,1,1,'[{0,32150002,3},{255,36160007,11400}]','[{0,32150002,3},{255,36160007,11400}]','[]'),(5921,0,2,2,'[{0,32150002,3},{255,36160007,11400}]','[{0,32150002,3},{255,36160007,11400}]','[]'),(5921,0,3,3,'[{0,32150002,3},{255,36160007,11400}]','[{0,32150002,3},{255,36160007,11400}]','[]'),(5921,0,4,4,'[{0,32150002,3},{255,36160007,11400}]','[{0,32150002,3},{255,36160007,11400}]','[]'),(5921,0,5,5,'[{0,32150002,3},{255,36160007,11400}]','[{0,32150002,3},{255,36160007,11400}]','[]'),(5922,0,0,0,'[{0,32150002,3},{255,36160007,11700}]','[{0,32150002,3},{255,36160007,11700}]','[]'),(5922,0,1,1,'[{0,32150002,3},{255,36160007,11700}]','[{0,32150002,3},{255,36160007,11700}]','[]'),(5922,0,2,2,'[{0,32150002,3},{255,36160007,11700}]','[{0,32150002,3},{255,36160007,11700}]','[]'),(5922,0,3,3,'[{0,32150002,3},{255,36160007,11700}]','[{0,32150002,3},{255,36160007,11700}]','[]'),(5922,0,4,4,'[{0,32150002,3},{255,36160007,11700}]','[{0,32150002,3},{255,36160007,11700}]','[]'),(5922,0,5,5,'[{0,32150002,3},{255,36160007,11700}]','[{0,32150002,3},{255,36160007,11700}]','[]'),(5923,0,0,0,'[{0,5201091,1},{255,36160007,12200}]','[{0,5201091,1},{255,36160007,12200}]','[]'),(5923,0,1,1,'[{0,5201091,1},{255,36160007,12200}]','[{0,5201091,1},{255,36160007,12200}]','[]'),(5923,0,2,2,'[{0,5201091,1},{255,36160007,12200}]','[{0,5201091,1},{255,36160007,12200}]','[]'),(5923,0,3,3,'[{0,5201091,1},{255,36160007,12200}]','[{0,5201091,1},{255,36160007,12200}]','[]'),(5923,0,4,4,'[{0,5201091,1},{255,36160007,12200}]','[{0,5201091,1},{255,36160007,12200}]','[]'),(5923,0,5,5,'[{0,5201091,1},{255,36160007,12200}]','[{0,5201091,1},{255,36160007,12200}]','[]'),(5924,0,0,0,'[{0,32150002,3},{255,36160007,12600}]','[{0,32150002,3},{255,36160007,12600}]','[]'),(5924,0,1,1,'[{0,32150002,3},{255,36160007,12600}]','[{0,32150002,3},{255,36160007,12600}]','[]'),(5924,0,2,2,'[{0,32150002,3},{255,36160007,12600}]','[{0,32150002,3},{255,36160007,12600}]','[]'),(5924,0,3,3,'[{0,32150002,3},{255,36160007,12600}]','[{0,32150002,3},{255,36160007,12600}]','[]'),(5924,0,4,4,'[{0,32150002,3},{255,36160007,12600}]','[{0,32150002,3},{255,36160007,12600}]','[]'),(5924,0,5,5,'[{0,32150002,3},{255,36160007,12600}]','[{0,32150002,3},{255,36160007,12600}]','[]'),(5925,0,0,0,'[{0,32150003,2},{255,36160007,13100}]','[{0,32150003,2},{255,36160007,13100}]','[]'),(5925,0,1,1,'[{0,32150003,2},{255,36160007,13100}]','[{0,32150003,2},{255,36160007,13100}]','[]'),(5925,0,2,2,'[{0,32150003,2},{255,36160007,13100}]','[{0,32150003,2},{255,36160007,13100}]','[]'),(5925,0,3,3,'[{0,32150003,2},{255,36160007,13100}]','[{0,32150003,2},{255,36160007,13100}]','[]'),(5925,0,4,4,'[{0,32150003,2},{255,36160007,13100}]','[{0,32150003,2},{255,36160007,13100}]','[]'),(5925,0,5,5,'[{0,32150003,2},{255,36160007,13100}]','[{0,32150003,2},{255,36160007,13100}]','[]'),(5926,0,0,0,'[{0,32150002,3},{255,36160007,13500}]','[{0,32150002,3},{255,36160007,13500}]','[]'),(5926,0,1,1,'[{0,32150002,3},{255,36160007,13500}]','[{0,32150002,3},{255,36160007,13500}]','[]'),(5926,0,2,2,'[{0,32150002,3},{255,36160007,13500}]','[{0,32150002,3},{255,36160007,13500}]','[]'),(5926,0,3,3,'[{0,32150002,3},{255,36160007,13500}]','[{0,32150002,3},{255,36160007,13500}]','[]'),(5926,0,4,4,'[{0,32150002,3},{255,36160007,13500}]','[{0,32150002,3},{255,36160007,13500}]','[]'),(5926,0,5,5,'[{0,32150002,3},{255,36160007,13500}]','[{0,32150002,3},{255,36160007,13500}]','[]'),(5927,0,0,0,'[{0,32150002,3},{255,36160007,14000}]','[{0,32150002,3},{255,36160007,14000}]','[]'),(5927,0,1,1,'[{0,32150002,3},{255,36160007,14000}]','[{0,32150002,3},{255,36160007,14000}]','[]'),(5927,0,2,2,'[{0,32150002,3},{255,36160007,14000}]','[{0,32150002,3},{255,36160007,14000}]','[]'),(5927,0,3,3,'[{0,32150002,3},{255,36160007,14000}]','[{0,32150002,3},{255,36160007,14000}]','[]'),(5927,0,4,4,'[{0,32150002,3},{255,36160007,14000}]','[{0,32150002,3},{255,36160007,14000}]','[]'),(5927,0,5,5,'[{0,32150002,3},{255,36160007,14000}]','[{0,32150002,3},{255,36160007,14000}]','[]'),(5928,0,0,0,'[{0,32150002,3},{255,36160007,14400}]','[{0,32150002,3},{255,36160007,14400}]','[]'),(5928,0,1,1,'[{0,32150002,3},{255,36160007,14400}]','[{0,32150002,3},{255,36160007,14400}]','[]'),(5928,0,2,2,'[{0,32150002,3},{255,36160007,14400}]','[{0,32150002,3},{255,36160007,14400}]','[]'),(5928,0,3,3,'[{0,32150002,3},{255,36160007,14400}]','[{0,32150002,3},{255,36160007,14400}]','[]'),(5928,0,4,4,'[{0,32150002,3},{255,36160007,14400}]','[{0,32150002,3},{255,36160007,14400}]','[]'),(5928,0,5,5,'[{0,32150002,3},{255,36160007,14400}]','[{0,32150002,3},{255,36160007,14400}]','[]'),(5929,0,0,0,'[{0,32150002,3},{255,36160007,14900}]','[{0,32150002,3},{255,36160007,14900}]','[]'),(5929,0,1,1,'[{0,32150002,3},{255,36160007,14900}]','[{0,32150002,3},{255,36160007,14900}]','[]'),(5929,0,2,2,'[{0,32150002,3},{255,36160007,14900}]','[{0,32150002,3},{255,36160007,14900}]','[]'),(5929,0,3,3,'[{0,32150002,3},{255,36160007,14900}]','[{0,32150002,3},{255,36160007,14900}]','[]'),(5929,0,4,4,'[{0,32150002,3},{255,36160007,14900}]','[{0,32150002,3},{255,36160007,14900}]','[]'),(5929,0,5,5,'[{0,32150002,3},{255,36160007,14900}]','[{0,32150002,3},{255,36160007,14900}]','[]'),(5930,0,0,0,'[{0,38180010,4},{255,36160007,15200}]','[{0,38180010,4},{255,36160007,15200}]','[]'),(5930,0,1,1,'[{0,38180010,4},{255,36160007,15200}]','[{0,38180010,4},{255,36160007,15200}]','[]'),(5930,0,2,2,'[{0,38180010,4},{255,36160007,15200}]','[{0,38180010,4},{255,36160007,15200}]','[]'),(5930,0,3,3,'[{0,38180010,4},{255,36160007,15200}]','[{0,38180010,4},{255,36160007,15200}]','[]'),(5930,0,4,4,'[{0,38180010,4},{255,36160007,15200}]','[{0,38180010,4},{255,36160007,15200}]','[]'),(5930,0,5,5,'[{0,38180010,4},{255,36160007,15200}]','[{0,38180010,4},{255,36160007,15200}]','[]'),(5931,0,0,0,'[{0,5201071,1},{255,36160007,15600}]','[{0,5201071,1},{255,36160007,15600}]','[]'),(5931,0,1,1,'[{0,5201071,1},{255,36160007,15600}]','[{0,5201071,1},{255,36160007,15600}]','[]'),(5931,0,2,2,'[{0,5201071,1},{255,36160007,15600}]','[{0,5201071,1},{255,36160007,15600}]','[]'),(5931,0,3,3,'[{0,5201071,1},{255,36160007,15600}]','[{0,5201071,1},{255,36160007,15600}]','[]'),(5931,0,4,4,'[{0,5201071,1},{255,36160007,15600}]','[{0,5201071,1},{255,36160007,15600}]','[]'),(5931,0,5,5,'[{0,5201071,1},{255,36160007,15600}]','[{0,5201071,1},{255,36160007,15600}]','[]'),(5932,0,0,0,'[{0,32150002,3},{255,36160007,16100}]','[{0,32150002,3},{255,36160007,16100}]','[]'),(5932,0,1,1,'[{0,32150002,3},{255,36160007,16100}]','[{0,32150002,3},{255,36160007,16100}]','[]'),(5932,0,2,2,'[{0,32150002,3},{255,36160007,16100}]','[{0,32150002,3},{255,36160007,16100}]','[]'),(5932,0,3,3,'[{0,32150002,3},{255,36160007,16100}]','[{0,32150002,3},{255,36160007,16100}]','[]'),(5932,0,4,4,'[{0,32150002,3},{255,36160007,16100}]','[{0,32150002,3},{255,36160007,16100}]','[]'),(5932,0,5,5,'[{0,32150002,3},{255,36160007,16100}]','[{0,32150002,3},{255,36160007,16100}]','[]'),(5933,0,0,0,'[{0,32150002,3},{255,36160007,16500}]','[{0,32150002,3},{255,36160007,16500}]','[]'),(5933,0,1,1,'[{0,32150002,3},{255,36160007,16500}]','[{0,32150002,3},{255,36160007,16500}]','[]'),(5933,0,2,2,'[{0,32150002,3},{255,36160007,16500}]','[{0,32150002,3},{255,36160007,16500}]','[]'),(5933,0,3,3,'[{0,32150002,3},{255,36160007,16500}]','[{0,32150002,3},{255,36160007,16500}]','[]'),(5933,0,4,4,'[{0,32150002,3},{255,36160007,16500}]','[{0,32150002,3},{255,36160007,16500}]','[]'),(5933,0,5,5,'[{0,32150002,3},{255,36160007,16500}]','[{0,32150002,3},{255,36160007,16500}]','[]'),(5934,0,0,0,'[{0,32150002,3},{255,36160007,17000}]','[{0,32150002,3},{255,36160007,17000}]','[]'),(5934,0,1,1,'[{0,32150002,3},{255,36160007,17000}]','[{0,32150002,3},{255,36160007,17000}]','[]'),(5934,0,2,2,'[{0,32150002,3},{255,36160007,17000}]','[{0,32150002,3},{255,36160007,17000}]','[]'),(5934,0,3,3,'[{0,32150002,3},{255,36160007,17000}]','[{0,32150002,3},{255,36160007,17000}]','[]'),(5934,0,4,4,'[{0,32150002,3},{255,36160007,17000}]','[{0,32150002,3},{255,36160007,17000}]','[]'),(5934,0,5,5,'[{0,32150002,3},{255,36160007,17000}]','[{0,32150002,3},{255,36160007,17000}]','[]'),(5935,0,0,0,'[{0,32150003,2},{255,36160007,17400}]','[{0,32150003,2},{255,36160007,17400}]','[]'),(5935,0,1,1,'[{0,32150003,2},{255,36160007,17400}]','[{0,32150003,2},{255,36160007,17400}]','[]'),(5935,0,2,2,'[{0,32150003,2},{255,36160007,17400}]','[{0,32150003,2},{255,36160007,17400}]','[]'),(5935,0,3,3,'[{0,32150003,2},{255,36160007,17400}]','[{0,32150003,2},{255,36160007,17400}]','[]'),(5935,0,4,4,'[{0,32150003,2},{255,36160007,17400}]','[{0,32150003,2},{255,36160007,17400}]','[]'),(5935,0,5,5,'[{0,32150003,2},{255,36160007,17400}]','[{0,32150003,2},{255,36160007,17400}]','[]'),(5936,0,0,0,'[{0,32150002,3},{255,36160007,17900}]','[{0,32150002,3},{255,36160007,17900}]','[]'),(5936,0,1,1,'[{0,32150002,3},{255,36160007,17900}]','[{0,32150002,3},{255,36160007,17900}]','[]'),(5936,0,2,2,'[{0,32150002,3},{255,36160007,17900}]','[{0,32150002,3},{255,36160007,17900}]','[]'),(5936,0,3,3,'[{0,32150002,3},{255,36160007,17900}]','[{0,32150002,3},{255,36160007,17900}]','[]'),(5936,0,4,4,'[{0,32150002,3},{255,36160007,17900}]','[{0,32150002,3},{255,36160007,17900}]','[]'),(5936,0,5,5,'[{0,32150002,3},{255,36160007,17900}]','[{0,32150002,3},{255,36160007,17900}]','[]'),(5937,0,0,0,'[{0,32150002,3},{255,36160007,18300}]','[{0,32150002,3},{255,36160007,18300}]','[]'),(5937,0,1,1,'[{0,32150002,3},{255,36160007,18300}]','[{0,32150002,3},{255,36160007,18300}]','[]'),(5937,0,2,2,'[{0,32150002,3},{255,36160007,18300}]','[{0,32150002,3},{255,36160007,18300}]','[]'),(5937,0,3,3,'[{0,32150002,3},{255,36160007,18300}]','[{0,32150002,3},{255,36160007,18300}]','[]'),(5937,0,4,4,'[{0,32150002,3},{255,36160007,18300}]','[{0,32150002,3},{255,36160007,18300}]','[]'),(5937,0,5,5,'[{0,32150002,3},{255,36160007,18300}]','[{0,32150002,3},{255,36160007,18300}]','[]'),(5938,0,0,0,'[{0,32150002,3},{255,36160007,18600}]','[{0,32150002,3},{255,36160007,18600}]','[]'),(5938,0,1,1,'[{0,32150002,3},{255,36160007,18600}]','[{0,32150002,3},{255,36160007,18600}]','[]'),(5938,0,2,2,'[{0,32150002,3},{255,36160007,18600}]','[{0,32150002,3},{255,36160007,18600}]','[]'),(5938,0,3,3,'[{0,32150002,3},{255,36160007,18600}]','[{0,32150002,3},{255,36160007,18600}]','[]'),(5938,0,4,4,'[{0,32150002,3},{255,36160007,18600}]','[{0,32150002,3},{255,36160007,18600}]','[]'),(5938,0,5,5,'[{0,32150002,3},{255,36160007,18600}]','[{0,32150002,3},{255,36160007,18600}]','[]'),(5939,0,0,0,'[{0,5201171,1},{255,36160007,19100}]','[{0,5201171,1},{255,36160007,19100}]','[]'),(5939,0,1,1,'[{0,5201171,1},{255,36160007,19100}]','[{0,5201171,1},{255,36160007,19100}]','[]'),(5939,0,2,2,'[{0,5201171,1},{255,36160007,19100}]','[{0,5201171,1},{255,36160007,19100}]','[]'),(5939,0,3,3,'[{0,5201171,1},{255,36160007,19100}]','[{0,5201171,1},{255,36160007,19100}]','[]'),(5939,0,4,4,'[{0,5201171,1},{255,36160007,19100}]','[{0,5201171,1},{255,36160007,19100}]','[]'),(5939,0,5,5,'[{0,5201171,1},{255,36160007,19100}]','[{0,5201171,1},{255,36160007,19100}]','[]'),(5940,0,0,0,'[{0,38180010,5},{255,36160007,19500}]','[{0,38180010,5},{255,36160007,19500}]','[]'),(5940,0,1,1,'[{0,38180010,5},{255,36160007,19500}]','[{0,38180010,5},{255,36160007,19500}]','[]'),(5940,0,2,2,'[{0,38180010,5},{255,36160007,19500}]','[{0,38180010,5},{255,36160007,19500}]','[]'),(5940,0,3,3,'[{0,38180010,5},{255,36160007,19500}]','[{0,38180010,5},{255,36160007,19500}]','[]'),(5940,0,4,4,'[{0,38180010,5},{255,36160007,19500}]','[{0,38180010,5},{255,36160007,19500}]','[]'),(5940,0,5,5,'[{0,38180010,5},{255,36160007,19500}]','[{0,38180010,5},{255,36160007,19500}]','[]'),(5941,0,0,0,'[{0,32150002,3},{255,36160007,20000}]','[{0,32150002,3},{255,36160007,20000}]','[]'),(5941,0,1,1,'[{0,32150002,3},{255,36160007,20000}]','[{0,32150002,3},{255,36160007,20000}]','[]'),(5941,0,2,2,'[{0,32150002,3},{255,36160007,20000}]','[{0,32150002,3},{255,36160007,20000}]','[]'),(5941,0,3,3,'[{0,32150002,3},{255,36160007,20000}]','[{0,32150002,3},{255,36160007,20000}]','[]'),(5941,0,4,4,'[{0,32150002,3},{255,36160007,20000}]','[{0,32150002,3},{255,36160007,20000}]','[]'),(5941,0,5,5,'[{0,32150002,3},{255,36160007,20000}]','[{0,32150002,3},{255,36160007,20000}]','[]'),(5942,0,0,0,'[{0,32150002,3},{255,36160007,20400}]','[{0,32150002,3},{255,36160007,20400}]','[]'),(5942,0,1,1,'[{0,32150002,3},{255,36160007,20400}]','[{0,32150002,3},{255,36160007,20400}]','[]'),(5942,0,2,2,'[{0,32150002,3},{255,36160007,20400}]','[{0,32150002,3},{255,36160007,20400}]','[]'),(5942,0,3,3,'[{0,32150002,3},{255,36160007,20400}]','[{0,32150002,3},{255,36160007,20400}]','[]'),(5942,0,4,4,'[{0,32150002,3},{255,36160007,20400}]','[{0,32150002,3},{255,36160007,20400}]','[]'),(5942,0,5,5,'[{0,32150002,3},{255,36160007,20400}]','[{0,32150002,3},{255,36160007,20400}]','[]'),(5943,0,0,0,'[{0,32150002,3},{255,36160007,20900}]','[{0,32150002,3},{255,36160007,20900}]','[]'),(5943,0,1,1,'[{0,32150002,3},{255,36160007,20900}]','[{0,32150002,3},{255,36160007,20900}]','[]'),(5943,0,2,2,'[{0,32150002,3},{255,36160007,20900}]','[{0,32150002,3},{255,36160007,20900}]','[]'),(5943,0,3,3,'[{0,32150002,3},{255,36160007,20900}]','[{0,32150002,3},{255,36160007,20900}]','[]'),(5943,0,4,4,'[{0,32150002,3},{255,36160007,20900}]','[{0,32150002,3},{255,36160007,20900}]','[]'),(5943,0,5,5,'[{0,32150002,3},{255,36160007,20900}]','[{0,32150002,3},{255,36160007,20900}]','[]'),(5944,0,0,0,'[{0,32150002,3},{255,36160007,21300}]','[{0,32150002,3},{255,36160007,21300}]','[]'),(5944,0,1,1,'[{0,32150002,3},{255,36160007,21300}]','[{0,32150002,3},{255,36160007,21300}]','[]'),(5944,0,2,2,'[{0,32150002,3},{255,36160007,21300}]','[{0,32150002,3},{255,36160007,21300}]','[]'),(5944,0,3,3,'[{0,32150002,3},{255,36160007,21300}]','[{0,32150002,3},{255,36160007,21300}]','[]'),(5944,0,4,4,'[{0,32150002,3},{255,36160007,21300}]','[{0,32150002,3},{255,36160007,21300}]','[]'),(5944,0,5,5,'[{0,32150002,3},{255,36160007,21300}]','[{0,32150002,3},{255,36160007,21300}]','[]'),(5945,0,0,0,'[{0,32150003,3},{255,36160007,21800}]','[{0,32150003,3},{255,36160007,21800}]','[]'),(5945,0,1,1,'[{0,32150003,3},{255,36160007,21800}]','[{0,32150003,3},{255,36160007,21800}]','[]'),(5945,0,2,2,'[{0,32150003,3},{255,36160007,21800}]','[{0,32150003,3},{255,36160007,21800}]','[]'),(5945,0,3,3,'[{0,32150003,3},{255,36160007,21800}]','[{0,32150003,3},{255,36160007,21800}]','[]'),(5945,0,4,4,'[{0,32150003,3},{255,36160007,21800}]','[{0,32150003,3},{255,36160007,21800}]','[]'),(5945,0,5,5,'[{0,32150003,3},{255,36160007,21800}]','[{0,32150003,3},{255,36160007,21800}]','[]'),(5946,0,0,0,'[{0,32150002,3},{255,36160007,22100}]','[{0,32150002,3},{255,36160007,22100}]','[]'),(5946,0,1,1,'[{0,32150002,3},{255,36160007,22100}]','[{0,32150002,3},{255,36160007,22100}]','[]'),(5946,0,2,2,'[{0,32150002,3},{255,36160007,22100}]','[{0,32150002,3},{255,36160007,22100}]','[]'),(5946,0,3,3,'[{0,32150002,3},{255,36160007,22100}]','[{0,32150002,3},{255,36160007,22100}]','[]'),(5946,0,4,4,'[{0,32150002,3},{255,36160007,22100}]','[{0,32150002,3},{255,36160007,22100}]','[]'),(5946,0,5,5,'[{0,32150002,3},{255,36160007,22100}]','[{0,32150002,3},{255,36160007,22100}]','[]'),(5947,0,0,0,'[{0,5201181,1},{255,36160007,22500}]','[{0,5201181,1},{255,36160007,22500}]','[]'),(5947,0,1,1,'[{0,5201181,1},{255,36160007,22500}]','[{0,5201181,1},{255,36160007,22500}]','[]'),(5947,0,2,2,'[{0,5201181,1},{255,36160007,22500}]','[{0,5201181,1},{255,36160007,22500}]','[]'),(5947,0,3,3,'[{0,5201181,1},{255,36160007,22500}]','[{0,5201181,1},{255,36160007,22500}]','[]'),(5947,0,4,4,'[{0,5201181,1},{255,36160007,22500}]','[{0,5201181,1},{255,36160007,22500}]','[]'),(5947,0,5,5,'[{0,5201181,1},{255,36160007,22500}]','[{0,5201181,1},{255,36160007,22500}]','[]'),(5948,0,0,0,'[{0,32150002,3},{255,36160007,23000}]','[{0,32150002,3},{255,36160007,23000}]','[]'),(5948,0,1,1,'[{0,32150002,3},{255,36160007,23000}]','[{0,32150002,3},{255,36160007,23000}]','[]'),(5948,0,2,2,'[{0,32150002,3},{255,36160007,23000}]','[{0,32150002,3},{255,36160007,23000}]','[]'),(5948,0,3,3,'[{0,32150002,3},{255,36160007,23000}]','[{0,32150002,3},{255,36160007,23000}]','[]'),(5948,0,4,4,'[{0,32150002,3},{255,36160007,23000}]','[{0,32150002,3},{255,36160007,23000}]','[]'),(5948,0,5,5,'[{0,32150002,3},{255,36160007,23000}]','[{0,32150002,3},{255,36160007,23000}]','[]'),(5949,0,0,0,'[{0,32150002,3},{255,36160007,23400}]','[{0,32150002,3},{255,36160007,23400}]','[]'),(5949,0,1,1,'[{0,32150002,3},{255,36160007,23400}]','[{0,32150002,3},{255,36160007,23400}]','[]'),(5949,0,2,2,'[{0,32150002,3},{255,36160007,23400}]','[{0,32150002,3},{255,36160007,23400}]','[]'),(5949,0,3,3,'[{0,32150002,3},{255,36160007,23400}]','[{0,32150002,3},{255,36160007,23400}]','[]'),(5949,0,4,4,'[{0,32150002,3},{255,36160007,23400}]','[{0,32150002,3},{255,36160007,23400}]','[]'),(5949,0,5,5,'[{0,32150002,3},{255,36160007,23400}]','[{0,32150002,3},{255,36160007,23400}]','[]'),(5950,0,0,0,'[{0,38180010,6},{255,36160007,23900}]','[{0,38180010,6},{255,36160007,23900}]','[]'),(5950,0,1,1,'[{0,38180010,6},{255,36160007,23900}]','[{0,38180010,6},{255,36160007,23900}]','[]'),(5950,0,2,2,'[{0,38180010,6},{255,36160007,23900}]','[{0,38180010,6},{255,36160007,23900}]','[]'),(5950,0,3,3,'[{0,38180010,6},{255,36160007,23900}]','[{0,38180010,6},{255,36160007,23900}]','[]'),(5950,0,4,4,'[{0,38180010,6},{255,36160007,23900}]','[{0,38180010,6},{255,36160007,23900}]','[]'),(5950,0,5,5,'[{0,38180010,6},{255,36160007,23900}]','[{0,38180010,6},{255,36160007,23900}]','[]'),(5951,0,0,0,'[{0,32150002,3},{255,36160007,24300}]','[{0,32150002,3},{255,36160007,24300}]','[]'),(5951,0,1,1,'[{0,32150002,3},{255,36160007,24300}]','[{0,32150002,3},{255,36160007,24300}]','[]'),(5951,0,2,2,'[{0,32150002,3},{255,36160007,24300}]','[{0,32150002,3},{255,36160007,24300}]','[]'),(5951,0,3,3,'[{0,32150002,3},{255,36160007,24300}]','[{0,32150002,3},{255,36160007,24300}]','[]'),(5951,0,4,4,'[{0,32150002,3},{255,36160007,24300}]','[{0,32150002,3},{255,36160007,24300}]','[]'),(5951,0,5,5,'[{0,32150002,3},{255,36160007,24300}]','[{0,32150002,3},{255,36160007,24300}]','[]'),(5952,0,0,0,'[{0,32150002,3},{255,36160007,24800}]','[{0,32150002,3},{255,36160007,24800}]','[]'),(5952,0,1,1,'[{0,32150002,3},{255,36160007,24800}]','[{0,32150002,3},{255,36160007,24800}]','[]'),(5952,0,2,2,'[{0,32150002,3},{255,36160007,24800}]','[{0,32150002,3},{255,36160007,24800}]','[]'),(5952,0,3,3,'[{0,32150002,3},{255,36160007,24800}]','[{0,32150002,3},{255,36160007,24800}]','[]'),(5952,0,4,4,'[{0,32150002,3},{255,36160007,24800}]','[{0,32150002,3},{255,36160007,24800}]','[]'),(5952,0,5,5,'[{0,32150002,3},{255,36160007,24800}]','[{0,32150002,3},{255,36160007,24800}]','[]'),(5953,0,0,0,'[{0,32150002,3},{255,36160007,25200}]','[{0,32150002,3},{255,36160007,25200}]','[]'),(5953,0,1,1,'[{0,32150002,3},{255,36160007,25200}]','[{0,32150002,3},{255,36160007,25200}]','[]'),(5953,0,2,2,'[{0,32150002,3},{255,36160007,25200}]','[{0,32150002,3},{255,36160007,25200}]','[]'),(5953,0,3,3,'[{0,32150002,3},{255,36160007,25200}]','[{0,32150002,3},{255,36160007,25200}]','[]'),(5953,0,4,4,'[{0,32150002,3},{255,36160007,25200}]','[{0,32150002,3},{255,36160007,25200}]','[]'),(5953,0,5,5,'[{0,32150002,3},{255,36160007,25200}]','[{0,32150002,3},{255,36160007,25200}]','[]'),(5954,0,0,0,'[{0,32150002,3},{255,36160007,25700}]','[{0,32150002,3},{255,36160007,25700}]','[]'),(5954,0,1,1,'[{0,32150002,3},{255,36160007,25700}]','[{0,32150002,3},{255,36160007,25700}]','[]'),(5954,0,2,2,'[{0,32150002,3},{255,36160007,25700}]','[{0,32150002,3},{255,36160007,25700}]','[]'),(5954,0,3,3,'[{0,32150002,3},{255,36160007,25700}]','[{0,32150002,3},{255,36160007,25700}]','[]'),(5954,0,4,4,'[{0,32150002,3},{255,36160007,25700}]','[{0,32150002,3},{255,36160007,25700}]','[]'),(5954,0,5,5,'[{0,32150002,3},{255,36160007,25700}]','[{0,32150002,3},{255,36160007,25700}]','[]'),(5955,0,0,0,'[{0,32150003,3},{255,36160007,26000}]','[{0,32150003,3},{255,36160007,26000}]','[]'),(5955,0,1,1,'[{0,32150003,3},{255,36160007,26000}]','[{0,32150003,3},{255,36160007,26000}]','[]'),(5955,0,2,2,'[{0,32150003,3},{255,36160007,26000}]','[{0,32150003,3},{255,36160007,26000}]','[]'),(5955,0,3,3,'[{0,32150003,3},{255,36160007,26000}]','[{0,32150003,3},{255,36160007,26000}]','[]'),(5955,0,4,4,'[{0,32150003,3},{255,36160007,26000}]','[{0,32150003,3},{255,36160007,26000}]','[]'),(5955,0,5,5,'[{0,32150003,3},{255,36160007,26000}]','[{0,32150003,3},{255,36160007,26000}]','[]'),(5956,0,0,0,'[{0,32150002,3},{255,36160007,26400}]','[{0,32150002,3},{255,36160007,26400}]','[]'),(5956,0,1,1,'[{0,32150002,3},{255,36160007,26400}]','[{0,32150002,3},{255,36160007,26400}]','[]'),(5956,0,2,2,'[{0,32150002,3},{255,36160007,26400}]','[{0,32150002,3},{255,36160007,26400}]','[]'),(5956,0,3,3,'[{0,32150002,3},{255,36160007,26400}]','[{0,32150002,3},{255,36160007,26400}]','[]'),(5956,0,4,4,'[{0,32150002,3},{255,36160007,26400}]','[{0,32150002,3},{255,36160007,26400}]','[]'),(5956,0,5,5,'[{0,32150002,3},{255,36160007,26400}]','[{0,32150002,3},{255,36160007,26400}]','[]'),(5957,0,0,0,'[{0,32150002,3},{255,36160007,26900}]','[{0,32150002,3},{255,36160007,26900}]','[]'),(5957,0,1,1,'[{0,32150002,3},{255,36160007,26900}]','[{0,32150002,3},{255,36160007,26900}]','[]'),(5957,0,2,2,'[{0,32150002,3},{255,36160007,26900}]','[{0,32150002,3},{255,36160007,26900}]','[]'),(5957,0,3,3,'[{0,32150002,3},{255,36160007,26900}]','[{0,32150002,3},{255,36160007,26900}]','[]'),(5957,0,4,4,'[{0,32150002,3},{255,36160007,26900}]','[{0,32150002,3},{255,36160007,26900}]','[]'),(5957,0,5,5,'[{0,32150002,3},{255,36160007,26900}]','[{0,32150002,3},{255,36160007,26900}]','[]'),(5958,0,0,0,'[{0,32150002,3},{255,36160007,27300}]','[{0,32150002,3},{255,36160007,27300}]','[]'),(5958,0,1,1,'[{0,32150002,3},{255,36160007,27300}]','[{0,32150002,3},{255,36160007,27300}]','[]'),(5958,0,2,2,'[{0,32150002,3},{255,36160007,27300}]','[{0,32150002,3},{255,36160007,27300}]','[]'),(5958,0,3,3,'[{0,32150002,3},{255,36160007,27300}]','[{0,32150002,3},{255,36160007,27300}]','[]'),(5958,0,4,4,'[{0,32150002,3},{255,36160007,27300}]','[{0,32150002,3},{255,36160007,27300}]','[]'),(5958,0,5,5,'[{0,32150002,3},{255,36160007,27300}]','[{0,32150002,3},{255,36160007,27300}]','[]'),(5959,0,0,0,'[{0,5201151,1},{255,36160007,27800}]','[{0,5201151,1},{255,36160007,27800}]','[]'),(5959,0,1,1,'[{0,5201151,1},{255,36160007,27800}]','[{0,5201151,1},{255,36160007,27800}]','[]'),(5959,0,2,2,'[{0,5201151,1},{255,36160007,27800}]','[{0,5201151,1},{255,36160007,27800}]','[]'),(5959,0,3,3,'[{0,5201151,1},{255,36160007,27800}]','[{0,5201151,1},{255,36160007,27800}]','[]'),(5959,0,4,4,'[{0,5201151,1},{255,36160007,27800}]','[{0,5201151,1},{255,36160007,27800}]','[]'),(5959,0,5,5,'[{0,5201151,1},{255,36160007,27800}]','[{0,5201151,1},{255,36160007,27800}]','[]'),(5960,0,0,0,'[{0,38180010,7},{255,36160007,28200}]','[{0,38180010,7},{255,36160007,28200}]','[]'),(5960,0,1,1,'[{0,38180010,7},{255,36160007,28200}]','[{0,38180010,7},{255,36160007,28200}]','[]'),(5960,0,2,2,'[{0,38180010,7},{255,36160007,28200}]','[{0,38180010,7},{255,36160007,28200}]','[]'),(5960,0,3,3,'[{0,38180010,7},{255,36160007,28200}]','[{0,38180010,7},{255,36160007,28200}]','[]'),(5960,0,4,4,'[{0,38180010,7},{255,36160007,28200}]','[{0,38180010,7},{255,36160007,28200}]','[]'),(5960,0,5,5,'[{0,38180010,7},{255,36160007,28200}]','[{0,38180010,7},{255,36160007,28200}]','[]'),(5961,0,0,0,'[{0,32150002,3},{255,36160007,28700}]','[{0,32150002,3},{255,36160007,28700}]','[]'),(5961,0,1,1,'[{0,32150002,3},{255,36160007,28700}]','[{0,32150002,3},{255,36160007,28700}]','[]'),(5961,0,2,2,'[{0,32150002,3},{255,36160007,28700}]','[{0,32150002,3},{255,36160007,28700}]','[]'),(5961,0,3,3,'[{0,32150002,3},{255,36160007,28700}]','[{0,32150002,3},{255,36160007,28700}]','[]'),(5961,0,4,4,'[{0,32150002,3},{255,36160007,28700}]','[{0,32150002,3},{255,36160007,28700}]','[]'),(5961,0,5,5,'[{0,32150002,3},{255,36160007,28700}]','[{0,32150002,3},{255,36160007,28700}]','[]'),(5962,0,0,0,'[{0,32150002,3},{255,36160007,29100}]','[{0,32150002,3},{255,36160007,29100}]','[]'),(5962,0,1,1,'[{0,32150002,3},{255,36160007,29100}]','[{0,32150002,3},{255,36160007,29100}]','[]'),(5962,0,2,2,'[{0,32150002,3},{255,36160007,29100}]','[{0,32150002,3},{255,36160007,29100}]','[]'),(5962,0,3,3,'[{0,32150002,3},{255,36160007,29100}]','[{0,32150002,3},{255,36160007,29100}]','[]'),(5962,0,4,4,'[{0,32150002,3},{255,36160007,29100}]','[{0,32150002,3},{255,36160007,29100}]','[]'),(5962,0,5,5,'[{0,32150002,3},{255,36160007,29100}]','[{0,32150002,3},{255,36160007,29100}]','[]'),(5963,0,0,0,'[{0,32150002,3},{255,36160007,29400}]','[{0,32150002,3},{255,36160007,29400}]','[]'),(5963,0,1,1,'[{0,32150002,3},{255,36160007,29400}]','[{0,32150002,3},{255,36160007,29400}]','[]'),(5963,0,2,2,'[{0,32150002,3},{255,36160007,29400}]','[{0,32150002,3},{255,36160007,29400}]','[]'),(5963,0,3,3,'[{0,32150002,3},{255,36160007,29400}]','[{0,32150002,3},{255,36160007,29400}]','[]'),(5963,0,4,4,'[{0,32150002,3},{255,36160007,29400}]','[{0,32150002,3},{255,36160007,29400}]','[]'),(5963,0,5,5,'[{0,32150002,3},{255,36160007,29400}]','[{0,32150002,3},{255,36160007,29400}]','[]'),(5964,0,0,0,'[{0,32150002,3},{255,36160007,29900}]','[{0,32150002,3},{255,36160007,29900}]','[]'),(5964,0,1,1,'[{0,32150002,3},{255,36160007,29900}]','[{0,32150002,3},{255,36160007,29900}]','[]'),(5964,0,2,2,'[{0,32150002,3},{255,36160007,29900}]','[{0,32150002,3},{255,36160007,29900}]','[]'),(5964,0,3,3,'[{0,32150002,3},{255,36160007,29900}]','[{0,32150002,3},{255,36160007,29900}]','[]'),(5964,0,4,4,'[{0,32150002,3},{255,36160007,29900}]','[{0,32150002,3},{255,36160007,29900}]','[]'),(5964,0,5,5,'[{0,32150002,3},{255,36160007,29900}]','[{0,32150002,3},{255,36160007,29900}]','[]'),(5965,0,0,0,'[{0,32150003,4},{255,36160007,30300}]','[{0,32150003,4},{255,36160007,30300}]','[]'),(5965,0,1,1,'[{0,32150003,4},{255,36160007,30300}]','[{0,32150003,4},{255,36160007,30300}]','[]'),(5965,0,2,2,'[{0,32150003,4},{255,36160007,30300}]','[{0,32150003,4},{255,36160007,30300}]','[]'),(5965,0,3,3,'[{0,32150003,4},{255,36160007,30300}]','[{0,32150003,4},{255,36160007,30300}]','[]'),(5965,0,4,4,'[{0,32150003,4},{255,36160007,30300}]','[{0,32150003,4},{255,36160007,30300}]','[]'),(5965,0,5,5,'[{0,32150003,4},{255,36160007,30300}]','[{0,32150003,4},{255,36160007,30300}]','[]'),(5966,0,0,0,'[{0,32150002,3},{255,36160007,30800}]','[{0,32150002,3},{255,36160007,30800}]','[]'),(5966,0,1,1,'[{0,32150002,3},{255,36160007,30800}]','[{0,32150002,3},{255,36160007,30800}]','[]'),(5966,0,2,2,'[{0,32150002,3},{255,36160007,30800}]','[{0,32150002,3},{255,36160007,30800}]','[]'),(5966,0,3,3,'[{0,32150002,3},{255,36160007,30800}]','[{0,32150002,3},{255,36160007,30800}]','[]'),(5966,0,4,4,'[{0,32150002,3},{255,36160007,30800}]','[{0,32150002,3},{255,36160007,30800}]','[]'),(5966,0,5,5,'[{0,32150002,3},{255,36160007,30800}]','[{0,32150002,3},{255,36160007,30800}]','[]'),(5967,0,0,0,'[{0,32150002,3},{255,36160007,31200}]','[{0,32150002,3},{255,36160007,31200}]','[]'),(5967,0,1,1,'[{0,32150002,3},{255,36160007,31200}]','[{0,32150002,3},{255,36160007,31200}]','[]'),(5967,0,2,2,'[{0,32150002,3},{255,36160007,31200}]','[{0,32150002,3},{255,36160007,31200}]','[]'),(5967,0,3,3,'[{0,32150002,3},{255,36160007,31200}]','[{0,32150002,3},{255,36160007,31200}]','[]'),(5967,0,4,4,'[{0,32150002,3},{255,36160007,31200}]','[{0,32150002,3},{255,36160007,31200}]','[]'),(5967,0,5,5,'[{0,32150002,3},{255,36160007,31200}]','[{0,32150002,3},{255,36160007,31200}]','[]'),(5968,0,0,0,'[{0,32150002,3},{255,36160007,31700}]','[{0,32150002,3},{255,36160007,31700}]','[]'),(5968,0,1,1,'[{0,32150002,3},{255,36160007,31700}]','[{0,32150002,3},{255,36160007,31700}]','[]'),(5968,0,2,2,'[{0,32150002,3},{255,36160007,31700}]','[{0,32150002,3},{255,36160007,31700}]','[]'),(5968,0,3,3,'[{0,32150002,3},{255,36160007,31700}]','[{0,32150002,3},{255,36160007,31700}]','[]'),(5968,0,4,4,'[{0,32150002,3},{255,36160007,31700}]','[{0,32150002,3},{255,36160007,31700}]','[]'),(5968,0,5,5,'[{0,32150002,3},{255,36160007,31700}]','[{0,32150002,3},{255,36160007,31700}]','[]'),(5969,0,0,0,'[{0,32150002,3},{255,36160007,32100}]','[{0,32150002,3},{255,36160007,32100}]','[]'),(5969,0,1,1,'[{0,32150002,3},{255,36160007,32100}]','[{0,32150002,3},{255,36160007,32100}]','[]'),(5969,0,2,2,'[{0,32150002,3},{255,36160007,32100}]','[{0,32150002,3},{255,36160007,32100}]','[]'),(5969,0,3,3,'[{0,32150002,3},{255,36160007,32100}]','[{0,32150002,3},{255,36160007,32100}]','[]'),(5969,0,4,4,'[{0,32150002,3},{255,36160007,32100}]','[{0,32150002,3},{255,36160007,32100}]','[]'),(5969,0,5,5,'[{0,32150002,3},{255,36160007,32100}]','[{0,32150002,3},{255,36160007,32100}]','[]'),(5970,0,0,0,'[{0,38180010,8},{255,36160007,32600}]','[{0,38180010,8},{255,36160007,32600}]','[]'),(5970,0,1,1,'[{0,38180010,8},{255,36160007,32600}]','[{0,38180010,8},{255,36160007,32600}]','[]'),(5970,0,2,2,'[{0,38180010,8},{255,36160007,32600}]','[{0,38180010,8},{255,36160007,32600}]','[]'),(5970,0,3,3,'[{0,38180010,8},{255,36160007,32600}]','[{0,38180010,8},{255,36160007,32600}]','[]'),(5970,0,4,4,'[{0,38180010,8},{255,36160007,32600}]','[{0,38180010,8},{255,36160007,32600}]','[]'),(5970,0,5,5,'[{0,38180010,8},{255,36160007,32600}]','[{0,38180010,8},{255,36160007,32600}]','[]'),(5971,0,0,0,'[{0,5201161,1},{255,36160007,32900}]','[{0,5201161,1},{255,36160007,32900}]','[]'),(5971,0,1,1,'[{0,5201161,1},{255,36160007,32900}]','[{0,5201161,1},{255,36160007,32900}]','[]'),(5971,0,2,2,'[{0,5201161,1},{255,36160007,32900}]','[{0,5201161,1},{255,36160007,32900}]','[]'),(5971,0,3,3,'[{0,5201161,1},{255,36160007,32900}]','[{0,5201161,1},{255,36160007,32900}]','[]'),(5971,0,4,4,'[{0,5201161,1},{255,36160007,32900}]','[{0,5201161,1},{255,36160007,32900}]','[]'),(5971,0,5,5,'[{0,5201161,1},{255,36160007,32900}]','[{0,5201161,1},{255,36160007,32900}]','[]'),(5972,0,0,0,'[{0,32150002,3},{255,36160007,33300}]','[{0,32150002,3},{255,36160007,33300}]','[]'),(5972,0,1,1,'[{0,32150002,3},{255,36160007,33300}]','[{0,32150002,3},{255,36160007,33300}]','[]'),(5972,0,2,2,'[{0,32150002,3},{255,36160007,33300}]','[{0,32150002,3},{255,36160007,33300}]','[]'),(5972,0,3,3,'[{0,32150002,3},{255,36160007,33300}]','[{0,32150002,3},{255,36160007,33300}]','[]'),(5972,0,4,4,'[{0,32150002,3},{255,36160007,33300}]','[{0,32150002,3},{255,36160007,33300}]','[]'),(5972,0,5,5,'[{0,32150002,3},{255,36160007,33300}]','[{0,32150002,3},{255,36160007,33300}]','[]'),(5973,0,0,0,'[{0,32150002,3},{255,36160007,33800}]','[{0,32150002,3},{255,36160007,33800}]','[]'),(5973,0,1,1,'[{0,32150002,3},{255,36160007,33800}]','[{0,32150002,3},{255,36160007,33800}]','[]'),(5973,0,2,2,'[{0,32150002,3},{255,36160007,33800}]','[{0,32150002,3},{255,36160007,33800}]','[]'),(5973,0,3,3,'[{0,32150002,3},{255,36160007,33800}]','[{0,32150002,3},{255,36160007,33800}]','[]'),(5973,0,4,4,'[{0,32150002,3},{255,36160007,33800}]','[{0,32150002,3},{255,36160007,33800}]','[]'),(5973,0,5,5,'[{0,32150002,3},{255,36160007,33800}]','[{0,32150002,3},{255,36160007,33800}]','[]'),(5974,0,0,0,'[{0,32150002,3},{255,36160007,34200}]','[{0,32150002,3},{255,36160007,34200}]','[]'),(5974,0,1,1,'[{0,32150002,3},{255,36160007,34200}]','[{0,32150002,3},{255,36160007,34200}]','[]'),(5974,0,2,2,'[{0,32150002,3},{255,36160007,34200}]','[{0,32150002,3},{255,36160007,34200}]','[]'),(5974,0,3,3,'[{0,32150002,3},{255,36160007,34200}]','[{0,32150002,3},{255,36160007,34200}]','[]'),(5974,0,4,4,'[{0,32150002,3},{255,36160007,34200}]','[{0,32150002,3},{255,36160007,34200}]','[]'),(5974,0,5,5,'[{0,32150002,3},{255,36160007,34200}]','[{0,32150002,3},{255,36160007,34200}]','[]'),(5975,0,0,0,'[{0,32150003,4},{255,36160007,34700}]','[{0,32150003,4},{255,36160007,34700}]','[]'),(5975,0,1,1,'[{0,32150003,4},{255,36160007,34700}]','[{0,32150003,4},{255,36160007,34700}]','[]'),(5975,0,2,2,'[{0,32150003,4},{255,36160007,34700}]','[{0,32150003,4},{255,36160007,34700}]','[]'),(5975,0,3,3,'[{0,32150003,4},{255,36160007,34700}]','[{0,32150003,4},{255,36160007,34700}]','[]'),(5975,0,4,4,'[{0,32150003,4},{255,36160007,34700}]','[{0,32150003,4},{255,36160007,34700}]','[]'),(5975,0,5,5,'[{0,32150003,4},{255,36160007,34700}]','[{0,32150003,4},{255,36160007,34700}]','[]'),(5976,0,0,0,'[{0,32150002,3},{255,36160007,35100}]','[{0,32150002,3},{255,36160007,35100}]','[]'),(5976,0,1,1,'[{0,32150002,3},{255,36160007,35100}]','[{0,32150002,3},{255,36160007,35100}]','[]'),(5976,0,2,2,'[{0,32150002,3},{255,36160007,35100}]','[{0,32150002,3},{255,36160007,35100}]','[]'),(5976,0,3,3,'[{0,32150002,3},{255,36160007,35100}]','[{0,32150002,3},{255,36160007,35100}]','[]'),(5976,0,4,4,'[{0,32150002,3},{255,36160007,35100}]','[{0,32150002,3},{255,36160007,35100}]','[]'),(5976,0,5,5,'[{0,32150002,3},{255,36160007,35100}]','[{0,32150002,3},{255,36160007,35100}]','[]'),(5977,0,0,0,'[{0,32150002,3},{255,36160007,35600}]','[{0,32150002,3},{255,36160007,35600}]','[]'),(5977,0,1,1,'[{0,32150002,3},{255,36160007,35600}]','[{0,32150002,3},{255,36160007,35600}]','[]'),(5977,0,2,2,'[{0,32150002,3},{255,36160007,35600}]','[{0,32150002,3},{255,36160007,35600}]','[]'),(5977,0,3,3,'[{0,32150002,3},{255,36160007,35600}]','[{0,32150002,3},{255,36160007,35600}]','[]'),(5977,0,4,4,'[{0,32150002,3},{255,36160007,35600}]','[{0,32150002,3},{255,36160007,35600}]','[]'),(5977,0,5,5,'[{0,32150002,3},{255,36160007,35600}]','[{0,32150002,3},{255,36160007,35600}]','[]'),(5978,0,0,0,'[{0,32150002,3},{255,36160007,36000}]','[{0,32150002,3},{255,36160007,36000}]','[]'),(5978,0,1,1,'[{0,32150002,3},{255,36160007,36000}]','[{0,32150002,3},{255,36160007,36000}]','[]'),(5978,0,2,2,'[{0,32150002,3},{255,36160007,36000}]','[{0,32150002,3},{255,36160007,36000}]','[]'),(5978,0,3,3,'[{0,32150002,3},{255,36160007,36000}]','[{0,32150002,3},{255,36160007,36000}]','[]'),(5978,0,4,4,'[{0,32150002,3},{255,36160007,36000}]','[{0,32150002,3},{255,36160007,36000}]','[]'),(5978,0,5,5,'[{0,32150002,3},{255,36160007,36000}]','[{0,32150002,3},{255,36160007,36000}]','[]'),(5979,0,0,0,'[{0,32150002,3},{255,36160007,36300}]','[{0,32150002,3},{255,36160007,36300}]','[]'),(5979,0,1,1,'[{0,32150002,3},{255,36160007,36300}]','[{0,32150002,3},{255,36160007,36300}]','[]'),(5979,0,2,2,'[{0,32150002,3},{255,36160007,36300}]','[{0,32150002,3},{255,36160007,36300}]','[]'),(5979,0,3,3,'[{0,32150002,3},{255,36160007,36300}]','[{0,32150002,3},{255,36160007,36300}]','[]'),(5979,0,4,4,'[{0,32150002,3},{255,36160007,36300}]','[{0,32150002,3},{255,36160007,36300}]','[]'),(5979,0,5,5,'[{0,32150002,3},{255,36160007,36300}]','[{0,32150002,3},{255,36160007,36300}]','[]'),(5980,0,0,0,'[{0,38180010,9},{255,36160007,36800}]','[{0,38180010,9},{255,36160007,36800}]','[]'),(5980,0,1,1,'[{0,38180010,9},{255,36160007,36800}]','[{0,38180010,9},{255,36160007,36800}]','[]'),(5980,0,2,2,'[{0,38180010,9},{255,36160007,36800}]','[{0,38180010,9},{255,36160007,36800}]','[]'),(5980,0,3,3,'[{0,38180010,9},{255,36160007,36800}]','[{0,38180010,9},{255,36160007,36800}]','[]'),(5980,0,4,4,'[{0,38180010,9},{255,36160007,36800}]','[{0,38180010,9},{255,36160007,36800}]','[]'),(5980,0,5,5,'[{0,38180010,9},{255,36160007,36800}]','[{0,38180010,9},{255,36160007,36800}]','[]'),(5981,0,0,0,'[{0,32150002,3},{255,36160007,37200}]','[{0,32150002,3},{255,36160007,37200}]','[]'),(5981,0,1,1,'[{0,32150002,3},{255,36160007,37200}]','[{0,32150002,3},{255,36160007,37200}]','[]'),(5981,0,2,2,'[{0,32150002,3},{255,36160007,37200}]','[{0,32150002,3},{255,36160007,37200}]','[]'),(5981,0,3,3,'[{0,32150002,3},{255,36160007,37200}]','[{0,32150002,3},{255,36160007,37200}]','[]'),(5981,0,4,4,'[{0,32150002,3},{255,36160007,37200}]','[{0,32150002,3},{255,36160007,37200}]','[]'),(5981,0,5,5,'[{0,32150002,3},{255,36160007,37200}]','[{0,32150002,3},{255,36160007,37200}]','[]'),(5982,0,0,0,'[{0,32150002,3},{255,36160007,37700}]','[{0,32150002,3},{255,36160007,37700}]','[]'),(5982,0,1,1,'[{0,32150002,3},{255,36160007,37700}]','[{0,32150002,3},{255,36160007,37700}]','[]'),(5982,0,2,2,'[{0,32150002,3},{255,36160007,37700}]','[{0,32150002,3},{255,36160007,37700}]','[]'),(5982,0,3,3,'[{0,32150002,3},{255,36160007,37700}]','[{0,32150002,3},{255,36160007,37700}]','[]'),(5982,0,4,4,'[{0,32150002,3},{255,36160007,37700}]','[{0,32150002,3},{255,36160007,37700}]','[]'),(5982,0,5,5,'[{0,32150002,3},{255,36160007,37700}]','[{0,32150002,3},{255,36160007,37700}]','[]'),(5983,0,0,0,'[{0,5201191,1},{255,36160007,38100}]','[{0,5201191,1},{255,36160007,38100}]','[]'),(5983,0,1,1,'[{0,5201191,1},{255,36160007,38100}]','[{0,5201191,1},{255,36160007,38100}]','[]'),(5983,0,2,2,'[{0,5201191,1},{255,36160007,38100}]','[{0,5201191,1},{255,36160007,38100}]','[]'),(5983,0,3,3,'[{0,5201191,1},{255,36160007,38100}]','[{0,5201191,1},{255,36160007,38100}]','[]'),(5983,0,4,4,'[{0,5201191,1},{255,36160007,38100}]','[{0,5201191,1},{255,36160007,38100}]','[]'),(5983,0,5,5,'[{0,5201191,1},{255,36160007,38100}]','[{0,5201191,1},{255,36160007,38100}]','[]'),(5984,0,0,0,'[{0,32150002,3},{255,36160007,38600}]','[{0,32150002,3},{255,36160007,38600}]','[]'),(5984,0,1,1,'[{0,32150002,3},{255,36160007,38600}]','[{0,32150002,3},{255,36160007,38600}]','[]'),(5984,0,2,2,'[{0,32150002,3},{255,36160007,38600}]','[{0,32150002,3},{255,36160007,38600}]','[]'),(5984,0,3,3,'[{0,32150002,3},{255,36160007,38600}]','[{0,32150002,3},{255,36160007,38600}]','[]'),(5984,0,4,4,'[{0,32150002,3},{255,36160007,38600}]','[{0,32150002,3},{255,36160007,38600}]','[]'),(5984,0,5,5,'[{0,32150002,3},{255,36160007,38600}]','[{0,32150002,3},{255,36160007,38600}]','[]'),(5985,0,0,0,'[{0,32150003,5},{255,36160007,39000}]','[{0,32150003,5},{255,36160007,39000}]','[]'),(5985,0,1,1,'[{0,32150003,5},{255,36160007,39000}]','[{0,32150003,5},{255,36160007,39000}]','[]'),(5985,0,2,2,'[{0,32150003,5},{255,36160007,39000}]','[{0,32150003,5},{255,36160007,39000}]','[]'),(5985,0,3,3,'[{0,32150003,5},{255,36160007,39000}]','[{0,32150003,5},{255,36160007,39000}]','[]'),(5985,0,4,4,'[{0,32150003,5},{255,36160007,39000}]','[{0,32150003,5},{255,36160007,39000}]','[]'),(5985,0,5,5,'[{0,32150003,5},{255,36160007,39000}]','[{0,32150003,5},{255,36160007,39000}]','[]'),(5986,0,0,0,'[{0,32150002,3},{255,36160007,39500}]','[{0,32150002,3},{255,36160007,39500}]','[]'),(5986,0,1,1,'[{0,32150002,3},{255,36160007,39500}]','[{0,32150002,3},{255,36160007,39500}]','[]'),(5986,0,2,2,'[{0,32150002,3},{255,36160007,39500}]','[{0,32150002,3},{255,36160007,39500}]','[]'),(5986,0,3,3,'[{0,32150002,3},{255,36160007,39500}]','[{0,32150002,3},{255,36160007,39500}]','[]'),(5986,0,4,4,'[{0,32150002,3},{255,36160007,39500}]','[{0,32150002,3},{255,36160007,39500}]','[]'),(5986,0,5,5,'[{0,32150002,3},{255,36160007,39500}]','[{0,32150002,3},{255,36160007,39500}]','[]'),(5987,0,0,0,'[{0,32150002,3},{255,36160007,39900}]','[{0,32150002,3},{255,36160007,39900}]','[]'),(5987,0,1,1,'[{0,32150002,3},{255,36160007,39900}]','[{0,32150002,3},{255,36160007,39900}]','[]'),(5987,0,2,2,'[{0,32150002,3},{255,36160007,39900}]','[{0,32150002,3},{255,36160007,39900}]','[]'),(5987,0,3,3,'[{0,32150002,3},{255,36160007,39900}]','[{0,32150002,3},{255,36160007,39900}]','[]'),(5987,0,4,4,'[{0,32150002,3},{255,36160007,39900}]','[{0,32150002,3},{255,36160007,39900}]','[]'),(5987,0,5,5,'[{0,32150002,3},{255,36160007,39900}]','[{0,32150002,3},{255,36160007,39900}]','[]'),(5988,0,0,0,'[{0,32150002,3},{255,36160007,40200}]','[{0,32150002,3},{255,36160007,40200}]','[]'),(5988,0,1,1,'[{0,32150002,3},{255,36160007,40200}]','[{0,32150002,3},{255,36160007,40200}]','[]'),(5988,0,2,2,'[{0,32150002,3},{255,36160007,40200}]','[{0,32150002,3},{255,36160007,40200}]','[]'),(5988,0,3,3,'[{0,32150002,3},{255,36160007,40200}]','[{0,32150002,3},{255,36160007,40200}]','[]'),(5988,0,4,4,'[{0,32150002,3},{255,36160007,40200}]','[{0,32150002,3},{255,36160007,40200}]','[]'),(5988,0,5,5,'[{0,32150002,3},{255,36160007,40200}]','[{0,32150002,3},{255,36160007,40200}]','[]'),(5989,0,0,0,'[{0,32150002,3},{255,36160007,40700}]','[{0,32150002,3},{255,36160007,40700}]','[]'),(5989,0,1,1,'[{0,32150002,3},{255,36160007,40700}]','[{0,32150002,3},{255,36160007,40700}]','[]'),(5989,0,2,2,'[{0,32150002,3},{255,36160007,40700}]','[{0,32150002,3},{255,36160007,40700}]','[]'),(5989,0,3,3,'[{0,32150002,3},{255,36160007,40700}]','[{0,32150002,3},{255,36160007,40700}]','[]'),(5989,0,4,4,'[{0,32150002,3},{255,36160007,40700}]','[{0,32150002,3},{255,36160007,40700}]','[]'),(5989,0,5,5,'[{0,32150002,3},{255,36160007,40700}]','[{0,32150002,3},{255,36160007,40700}]','[]'),(5990,0,0,0,'[{0,38180010,10},{255,36160007,41100}]','[{0,38180010,10},{255,36160007,41100}]','[]'),(5990,0,1,1,'[{0,38180010,10},{255,36160007,41100}]','[{0,38180010,10},{255,36160007,41100}]','[]'),(5990,0,2,2,'[{0,38180010,10},{255,36160007,41100}]','[{0,38180010,10},{255,36160007,41100}]','[]'),(5990,0,3,3,'[{0,38180010,10},{255,36160007,41100}]','[{0,38180010,10},{255,36160007,41100}]','[]'),(5990,0,4,4,'[{0,38180010,10},{255,36160007,41100}]','[{0,38180010,10},{255,36160007,41100}]','[]'),(5990,0,5,5,'[{0,38180010,10},{255,36160007,41100}]','[{0,38180010,10},{255,36160007,41100}]','[]'),(5991,0,0,0,'[{0,32150002,3},{255,36160007,41600}]','[{0,32150002,3},{255,36160007,41600}]','[]'),(5991,0,1,1,'[{0,32150002,3},{255,36160007,41600}]','[{0,32150002,3},{255,36160007,41600}]','[]'),(5991,0,2,2,'[{0,32150002,3},{255,36160007,41600}]','[{0,32150002,3},{255,36160007,41600}]','[]'),(5991,0,3,3,'[{0,32150002,3},{255,36160007,41600}]','[{0,32150002,3},{255,36160007,41600}]','[]'),(5991,0,4,4,'[{0,32150002,3},{255,36160007,41600}]','[{0,32150002,3},{255,36160007,41600}]','[]'),(5991,0,5,5,'[{0,32150002,3},{255,36160007,41600}]','[{0,32150002,3},{255,36160007,41600}]','[]'),(5992,0,0,0,'[{0,32150002,3},{255,36160007,42000}]','[{0,32150002,3},{255,36160007,42000}]','[]'),(5992,0,1,1,'[{0,32150002,3},{255,36160007,42000}]','[{0,32150002,3},{255,36160007,42000}]','[]'),(5992,0,2,2,'[{0,32150002,3},{255,36160007,42000}]','[{0,32150002,3},{255,36160007,42000}]','[]'),(5992,0,3,3,'[{0,32150002,3},{255,36160007,42000}]','[{0,32150002,3},{255,36160007,42000}]','[]'),(5992,0,4,4,'[{0,32150002,3},{255,36160007,42000}]','[{0,32150002,3},{255,36160007,42000}]','[]'),(5992,0,5,5,'[{0,32150002,3},{255,36160007,42000}]','[{0,32150002,3},{255,36160007,42000}]','[]'),(5993,0,0,0,'[{0,32150002,3},{255,36160007,42500}]','[{0,32150002,3},{255,36160007,42500}]','[]'),(5993,0,1,1,'[{0,32150002,3},{255,36160007,42500}]','[{0,32150002,3},{255,36160007,42500}]','[]'),(5993,0,2,2,'[{0,32150002,3},{255,36160007,42500}]','[{0,32150002,3},{255,36160007,42500}]','[]'),(5993,0,3,3,'[{0,32150002,3},{255,36160007,42500}]','[{0,32150002,3},{255,36160007,42500}]','[]'),(5993,0,4,4,'[{0,32150002,3},{255,36160007,42500}]','[{0,32150002,3},{255,36160007,42500}]','[]'),(5993,0,5,5,'[{0,32150002,3},{255,36160007,42500}]','[{0,32150002,3},{255,36160007,42500}]','[]'),(5994,0,0,0,'[{0,32150002,3},{255,36160007,42900}]','[{0,32150002,3},{255,36160007,42900}]','[]'),(5994,0,1,1,'[{0,32150002,3},{255,36160007,42900}]','[{0,32150002,3},{255,36160007,42900}]','[]'),(5994,0,2,2,'[{0,32150002,3},{255,36160007,42900}]','[{0,32150002,3},{255,36160007,42900}]','[]'),(5994,0,3,3,'[{0,32150002,3},{255,36160007,42900}]','[{0,32150002,3},{255,36160007,42900}]','[]'),(5994,0,4,4,'[{0,32150002,3},{255,36160007,42900}]','[{0,32150002,3},{255,36160007,42900}]','[]'),(5994,0,5,5,'[{0,32150002,3},{255,36160007,42900}]','[{0,32150002,3},{255,36160007,42900}]','[]'),(5995,0,0,0,'[{0,32150003,5},{255,36160007,43400}]','[{0,32150003,5},{255,36160007,43400}]','[]'),(5995,0,1,1,'[{0,32150003,5},{255,36160007,43400}]','[{0,32150003,5},{255,36160007,43400}]','[]'),(5995,0,2,2,'[{0,32150003,5},{255,36160007,43400}]','[{0,32150003,5},{255,36160007,43400}]','[]'),(5995,0,3,3,'[{0,32150003,5},{255,36160007,43400}]','[{0,32150003,5},{255,36160007,43400}]','[]'),(5995,0,4,4,'[{0,32150003,5},{255,36160007,43400}]','[{0,32150003,5},{255,36160007,43400}]','[]'),(5995,0,5,5,'[{0,32150003,5},{255,36160007,43400}]','[{0,32150003,5},{255,36160007,43400}]','[]'),(5996,0,0,0,'[{0,32150002,3},{255,36160007,43700}]','[{0,32150002,3},{255,36160007,43700}]','[]'),(5996,0,1,1,'[{0,32150002,3},{255,36160007,43700}]','[{0,32150002,3},{255,36160007,43700}]','[]'),(5996,0,2,2,'[{0,32150002,3},{255,36160007,43700}]','[{0,32150002,3},{255,36160007,43700}]','[]'),(5996,0,3,3,'[{0,32150002,3},{255,36160007,43700}]','[{0,32150002,3},{255,36160007,43700}]','[]'),(5996,0,4,4,'[{0,32150002,3},{255,36160007,43700}]','[{0,32150002,3},{255,36160007,43700}]','[]'),(5996,0,5,5,'[{0,32150002,3},{255,36160007,43700}]','[{0,32150002,3},{255,36160007,43700}]','[]'),(5997,0,0,0,'[{0,32150002,3},{255,36160007,44100}]','[{0,32150002,3},{255,36160007,44100}]','[]'),(5997,0,1,1,'[{0,32150002,3},{255,36160007,44100}]','[{0,32150002,3},{255,36160007,44100}]','[]'),(5997,0,2,2,'[{0,32150002,3},{255,36160007,44100}]','[{0,32150002,3},{255,36160007,44100}]','[]'),(5997,0,3,3,'[{0,32150002,3},{255,36160007,44100}]','[{0,32150002,3},{255,36160007,44100}]','[]'),(5997,0,4,4,'[{0,32150002,3},{255,36160007,44100}]','[{0,32150002,3},{255,36160007,44100}]','[]'),(5997,0,5,5,'[{0,32150002,3},{255,36160007,44100}]','[{0,32150002,3},{255,36160007,44100}]','[]'),(5998,0,0,0,'[{0,32150002,3},{255,36160007,44600}]','[{0,32150002,3},{255,36160007,44600}]','[]'),(5998,0,1,1,'[{0,32150002,3},{255,36160007,44600}]','[{0,32150002,3},{255,36160007,44600}]','[]'),(5998,0,2,2,'[{0,32150002,3},{255,36160007,44600}]','[{0,32150002,3},{255,36160007,44600}]','[]'),(5998,0,3,3,'[{0,32150002,3},{255,36160007,44600}]','[{0,32150002,3},{255,36160007,44600}]','[]'),(5998,0,4,4,'[{0,32150002,3},{255,36160007,44600}]','[{0,32150002,3},{255,36160007,44600}]','[]'),(5998,0,5,5,'[{0,32150002,3},{255,36160007,44600}]','[{0,32150002,3},{255,36160007,44600}]','[]'),(5999,0,0,0,'[{0,32150002,3},{255,36160007,45000}]','[{0,32150002,3},{255,36160007,45000}]','[]'),(5999,0,1,1,'[{0,32150002,3},{255,36160007,45000}]','[{0,32150002,3},{255,36160007,45000}]','[]'),(5999,0,2,2,'[{0,32150002,3},{255,36160007,45000}]','[{0,32150002,3},{255,36160007,45000}]','[]'),(5999,0,3,3,'[{0,32150002,3},{255,36160007,45000}]','[{0,32150002,3},{255,36160007,45000}]','[]'),(5999,0,4,4,'[{0,32150002,3},{255,36160007,45000}]','[{0,32150002,3},{255,36160007,45000}]','[]'),(5999,0,5,5,'[{0,32150002,3},{255,36160007,45000}]','[{0,32150002,3},{255,36160007,45000}]','[]'),(10000,0,1,1,'[{2,36020001,5},{3,36030001,500}]','[]','[]'),(10003,0,1,1,'[{2,36020001,10},{0,38130001,2}]','',''),(10030,0,0,0,'[{0,18040001,1},{2,36020001,5}]','[]','[]'),(10030,1,1,1,'[{0,18040001,1},{2,36020001,5}]','[]','[]'),(10030,2,2,2,'[{0,18040001,1},{2,36020001,5}]','[]','[]'),(10030,3,3,3,'[{0,18040001,1},{2,36020001,5}]','[]','[]'),(10030,4,4,4,'[{0,18040001,1},{2,36020001,5}]','[]','[]'),(10030,5,5,5,'[{0,18040001,1},{2,36020001,5}]','[]','[]'),(56000,0,0,0,'[{0,17010001,10}]','[]','[]'),(56000,0,1,1,'[{0,17010001,10}]','[]','[]'),(56000,0,2,2,'[{0,17010001,10}]','[]','[]'),(56000,0,3,3,'[{0,17010001,10}]','[]','[]'),(56000,0,4,4,'[{0,17010001,10}]','[]','[]'),(56000,0,5,5,'[{0,17010001,10}]','[]','[]'),(56001,0,0,0,'[{0,17010001,10}]','[]','[]'),(56001,0,1,1,'[{0,17010001,10}]','[]','[]'),(56001,0,2,2,'[{0,17010001,10}]','[]','[]'),(56001,0,3,3,'[{0,17010001,10}]','[]','[]'),(56001,0,4,4,'[{0,17010001,10}]','[]','[]'),(56001,0,5,5,'[{0,17010001,10}]','[]','[]'),(56002,0,0,0,'[{0,17010001,10}]','[]','[]'),(56002,0,1,1,'[{0,17010001,10}]','[]','[]'),(56002,0,2,2,'[{0,17010001,10}]','[]','[]'),(56002,0,3,3,'[{0,17010001,10}]','[]','[]'),(56002,0,4,4,'[{0,17010001,10}]','[]','[]'),(56002,0,5,5,'[{0,17010001,10}]','[]','[]'),(56003,0,0,0,'[{0,17010001,10}]','[]','[]'),(56003,0,1,1,'[{0,17010001,10}]','[]','[]'),(56003,0,2,2,'[{0,17010001,10}]','[]','[]'),(56003,0,3,3,'[{0,17010001,10}]','[]','[]'),(56003,0,4,4,'[{0,17010001,10}]','[]','[]'),(56003,0,5,5,'[{0,17010001,10}]','[]','[]'),(56004,0,0,0,'[{0,17010001,30}]','[]','[]'),(56004,0,1,1,'[{0,17010001,30}]','[]','[]'),(56004,0,2,2,'[{0,17010001,30}]','[]','[]'),(56004,0,3,3,'[{0,17010001,30}]','[]','[]'),(56004,0,4,4,'[{0,17010001,30}]','[]','[]'),(56004,0,5,5,'[{0,17010001,30}]','[]','[]'),(56005,0,0,0,'[{0,17010001,12}]','[]','[]'),(56005,0,1,1,'[{0,17010001,12}]','[]','[]'),(56005,0,2,2,'[{0,17010001,12}]','[]','[]'),(56005,0,3,3,'[{0,17010001,12}]','[]','[]'),(56005,0,4,4,'[{0,17010001,12}]','[]','[]'),(56005,0,5,5,'[{0,17010001,12}]','[]','[]'),(56006,0,0,0,'[{0,17010001,12}]','[]','[]'),(56006,0,1,1,'[{0,17010001,12}]','[]','[]'),(56006,0,2,2,'[{0,17010001,12}]','[]','[]'),(56006,0,3,3,'[{0,17010001,12}]','[]','[]'),(56006,0,4,4,'[{0,17010001,12}]','[]','[]'),(56006,0,5,5,'[{0,17010001,12}]','[]','[]'),(56007,0,0,0,'[{0,17010001,12}]','[]','[]'),(56007,0,1,1,'[{0,17010001,12}]','[]','[]'),(56007,0,2,2,'[{0,17010001,12}]','[]','[]'),(56007,0,3,3,'[{0,17010001,12}]','[]','[]'),(56007,0,4,4,'[{0,17010001,12}]','[]','[]'),(56007,0,5,5,'[{0,17010001,12}]','[]','[]'),(56008,0,0,0,'[{0,17010001,12}]','[]','[]'),(56008,0,1,1,'[{0,17010001,12}]','[]','[]'),(56008,0,2,2,'[{0,17010001,12}]','[]','[]'),(56008,0,3,3,'[{0,17010001,12}]','[]','[]'),(56008,0,4,4,'[{0,17010001,12}]','[]','[]'),(56008,0,5,5,'[{0,17010001,12}]','[]','[]'),(56009,0,0,0,'[{0,17010001,36}]','[]','[]'),(56009,0,1,1,'[{0,17010001,36}]','[]','[]'),(56009,0,2,2,'[{0,17010001,36}]','[]','[]'),(56009,0,3,3,'[{0,17010001,36}]','[]','[]'),(56009,0,4,4,'[{0,17010001,36}]','[]','[]'),(56009,0,5,5,'[{0,17010001,36}]','[]','[]'),(56010,0,0,0,'[{0,17010001,14}]','[]','[]'),(56010,0,1,1,'[{0,17010001,14}]','[]','[]'),(56010,0,2,2,'[{0,17010001,14}]','[]','[]'),(56010,0,3,3,'[{0,17010001,14}]','[]','[]'),(56010,0,4,4,'[{0,17010001,14}]','[]','[]'),(56010,0,5,5,'[{0,17010001,14}]','[]','[]'),(56011,0,0,0,'[{0,17010001,14}]','[]','[]'),(56011,0,1,1,'[{0,17010001,14}]','[]','[]'),(56011,0,2,2,'[{0,17010001,14}]','[]','[]'),(56011,0,3,3,'[{0,17010001,14}]','[]','[]'),(56011,0,4,4,'[{0,17010001,14}]','[]','[]'),(56011,0,5,5,'[{0,17010001,14}]','[]','[]'),(56012,0,0,0,'[{0,17010001,14}]','[]','[]'),(56012,0,1,1,'[{0,17010001,14}]','[]','[]'),(56012,0,2,2,'[{0,17010001,14}]','[]','[]'),(56012,0,3,3,'[{0,17010001,14}]','[]','[]'),(56012,0,4,4,'[{0,17010001,14}]','[]','[]'),(56012,0,5,5,'[{0,17010001,14}]','[]','[]'),(56013,0,0,0,'[{0,17010001,14}]','[]','[]'),(56013,0,1,1,'[{0,17010001,14}]','[]','[]'),(56013,0,2,2,'[{0,17010001,14}]','[]','[]'),(56013,0,3,3,'[{0,17010001,14}]','[]','[]'),(56013,0,4,4,'[{0,17010001,14}]','[]','[]'),(56013,0,5,5,'[{0,17010001,14}]','[]','[]'),(56014,0,0,0,'[{0,17010001,42}]','[]','[]'),(56014,0,1,1,'[{0,17010001,42}]','[]','[]'),(56014,0,2,2,'[{0,17010001,42}]','[]','[]'),(56014,0,3,3,'[{0,17010001,42}]','[]','[]'),(56014,0,4,4,'[{0,17010001,42}]','[]','[]'),(56014,0,5,5,'[{0,17010001,42}]','[]','[]'),(56015,0,0,0,'[{0,17010001,16}]','[]','[]'),(56015,0,1,1,'[{0,17010001,16}]','[]','[]'),(56015,0,2,2,'[{0,17010001,16}]','[]','[]'),(56015,0,3,3,'[{0,17010001,16}]','[]','[]'),(56015,0,4,4,'[{0,17010001,16}]','[]','[]'),(56015,0,5,5,'[{0,17010001,16}]','[]','[]'),(56016,0,0,0,'[{0,17010001,16}]','[]','[]'),(56016,0,1,1,'[{0,17010001,16}]','[]','[]'),(56016,0,2,2,'[{0,17010001,16}]','[]','[]'),(56016,0,3,3,'[{0,17010001,16}]','[]','[]'),(56016,0,4,4,'[{0,17010001,16}]','[]','[]'),(56016,0,5,5,'[{0,17010001,16}]','[]','[]'),(56017,0,0,0,'[{0,17010001,16}]','[]','[]'),(56017,0,1,1,'[{0,17010001,16}]','[]','[]'),(56017,0,2,2,'[{0,17010001,16}]','[]','[]'),(56017,0,3,3,'[{0,17010001,16}]','[]','[]'),(56017,0,4,4,'[{0,17010001,16}]','[]','[]'),(56017,0,5,5,'[{0,17010001,16}]','[]','[]'),(56018,0,0,0,'[{0,17010001,16}]','[]','[]'),(56018,0,1,1,'[{0,17010001,16}]','[]','[]'),(56018,0,2,2,'[{0,17010001,16}]','[]','[]'),(56018,0,3,3,'[{0,17010001,16}]','[]','[]'),(56018,0,4,4,'[{0,17010001,16}]','[]','[]'),(56018,0,5,5,'[{0,17010001,16}]','[]','[]'),(56019,0,0,0,'[{0,17010001,48}]','[]','[]'),(56019,0,1,1,'[{0,17010001,48}]','[]','[]'),(56019,0,2,2,'[{0,17010001,48}]','[]','[]'),(56019,0,3,3,'[{0,17010001,48}]','[]','[]'),(56019,0,4,4,'[{0,17010001,48}]','[]','[]'),(56019,0,5,5,'[{0,17010001,48}]','[]','[]'),(56020,0,0,0,'[{0,17010001,18}]','[]','[]'),(56020,0,1,1,'[{0,17010001,18}]','[]','[]'),(56020,0,2,2,'[{0,17010001,18}]','[]','[]'),(56020,0,3,3,'[{0,17010001,18}]','[]','[]'),(56020,0,4,4,'[{0,17010001,18}]','[]','[]'),(56020,0,5,5,'[{0,17010001,18}]','[]','[]'),(56021,0,0,0,'[{0,17010001,18}]','[]','[]'),(56021,0,1,1,'[{0,17010001,18}]','[]','[]'),(56021,0,2,2,'[{0,17010001,18}]','[]','[]'),(56021,0,3,3,'[{0,17010001,18}]','[]','[]'),(56021,0,4,4,'[{0,17010001,18}]','[]','[]'),(56021,0,5,5,'[{0,17010001,18}]','[]','[]'),(56022,0,0,0,'[{0,17010001,18}]','[]','[]'),(56022,0,1,1,'[{0,17010001,18}]','[]','[]'),(56022,0,2,2,'[{0,17010001,18}]','[]','[]'),(56022,0,3,3,'[{0,17010001,18}]','[]','[]'),(56022,0,4,4,'[{0,17010001,18}]','[]','[]'),(56022,0,5,5,'[{0,17010001,18}]','[]','[]'),(56023,0,0,0,'[{0,17010001,18}]','[]','[]'),(56023,0,1,1,'[{0,17010001,18}]','[]','[]'),(56023,0,2,2,'[{0,17010001,18}]','[]','[]'),(56023,0,3,3,'[{0,17010001,18}]','[]','[]'),(56023,0,4,4,'[{0,17010001,18}]','[]','[]'),(56023,0,5,5,'[{0,17010001,18}]','[]','[]'),(56024,0,0,0,'[{0,17010001,54}]','[]','[]'),(56024,0,1,1,'[{0,17010001,54}]','[]','[]'),(56024,0,2,2,'[{0,17010001,54}]','[]','[]'),(56024,0,3,3,'[{0,17010001,54}]','[]','[]'),(56024,0,4,4,'[{0,17010001,54}]','[]','[]'),(56024,0,5,5,'[{0,17010001,54}]','[]','[]'),(56025,0,0,0,'[{0,17010001,20}]','[]','[]'),(56025,0,1,1,'[{0,17010001,20}]','[]','[]'),(56025,0,2,2,'[{0,17010001,20}]','[]','[]'),(56025,0,3,3,'[{0,17010001,20}]','[]','[]'),(56025,0,4,4,'[{0,17010001,20}]','[]','[]'),(56025,0,5,5,'[{0,17010001,20}]','[]','[]'),(56026,0,0,0,'[{0,17010001,20}]','[]','[]'),(56026,0,1,1,'[{0,17010001,20}]','[]','[]'),(56026,0,2,2,'[{0,17010001,20}]','[]','[]'),(56026,0,3,3,'[{0,17010001,20}]','[]','[]'),(56026,0,4,4,'[{0,17010001,20}]','[]','[]'),(56026,0,5,5,'[{0,17010001,20}]','[]','[]'),(56027,0,0,0,'[{0,17010001,20}]','[]','[]'),(56027,0,1,1,'[{0,17010001,20}]','[]','[]'),(56027,0,2,2,'[{0,17010001,20}]','[]','[]'),(56027,0,3,3,'[{0,17010001,20}]','[]','[]'),(56027,0,4,4,'[{0,17010001,20}]','[]','[]'),(56027,0,5,5,'[{0,17010001,20}]','[]','[]'),(56028,0,0,0,'[{0,17010001,20}]','[]','[]'),(56028,0,1,1,'[{0,17010001,20}]','[]','[]'),(56028,0,2,2,'[{0,17010001,20}]','[]','[]'),(56028,0,3,3,'[{0,17010001,20}]','[]','[]'),(56028,0,4,4,'[{0,17010001,20}]','[]','[]'),(56028,0,5,5,'[{0,17010001,20}]','[]','[]'),(56029,0,0,0,'[{0,17010001,60}]','[]','[]'),(56029,0,1,1,'[{0,17010001,60}]','[]','[]'),(56029,0,2,2,'[{0,17010001,60}]','[]','[]'),(56029,0,3,3,'[{0,17010001,60}]','[]','[]'),(56029,0,4,4,'[{0,17010001,60}]','[]','[]'),(56029,0,5,5,'[{0,17010001,60}]','[]','[]'),(56030,0,0,0,'[{0,17010001,30}]','[]','[]'),(56030,0,1,1,'[{0,17010001,30}]','[]','[]'),(56030,0,2,2,'[{0,17010001,30}]','[]','[]'),(56030,0,3,3,'[{0,17010001,30}]','[]','[]'),(56030,0,4,4,'[{0,17010001,30}]','[]','[]'),(56030,0,5,5,'[{0,17010001,30}]','[]','[]'),(56031,0,0,0,'[{0,17010001,30}]','[]','[]'),(56031,0,1,1,'[{0,17010001,30}]','[]','[]'),(56031,0,2,2,'[{0,17010001,30}]','[]','[]'),(56031,0,3,3,'[{0,17010001,30}]','[]','[]'),(56031,0,4,4,'[{0,17010001,30}]','[]','[]'),(56031,0,5,5,'[{0,17010001,30}]','[]','[]'),(56032,0,0,0,'[{0,17010001,30}]','[]','[]'),(56032,0,1,1,'[{0,17010001,30}]','[]','[]'),(56032,0,2,2,'[{0,17010001,30}]','[]','[]'),(56032,0,3,3,'[{0,17010001,30}]','[]','[]'),(56032,0,4,4,'[{0,17010001,30}]','[]','[]'),(56032,0,5,5,'[{0,17010001,30}]','[]','[]'),(56033,0,0,0,'[{0,17010001,30}]','[]','[]'),(56033,0,1,1,'[{0,17010001,30}]','[]','[]'),(56033,0,2,2,'[{0,17010001,30}]','[]','[]'),(56033,0,3,3,'[{0,17010001,30}]','[]','[]'),(56033,0,4,4,'[{0,17010001,30}]','[]','[]'),(56033,0,5,5,'[{0,17010001,30}]','[]','[]'),(56034,0,0,0,'[{0,17010001,90}]','[]','[]'),(56034,0,1,1,'[{0,17010001,90}]','[]','[]'),(56034,0,2,2,'[{0,17010001,90}]','[]','[]'),(56034,0,3,3,'[{0,17010001,90}]','[]','[]'),(56034,0,4,4,'[{0,17010001,90}]','[]','[]'),(56034,0,5,5,'[{0,17010001,90}]','[]','[]'),(56035,0,0,0,'[{0,17010001,40}]','[]','[]'),(56035,0,1,1,'[{0,17010001,40}]','[]','[]'),(56035,0,2,2,'[{0,17010001,40}]','[]','[]'),(56035,0,3,3,'[{0,17010001,40}]','[]','[]'),(56035,0,4,4,'[{0,17010001,40}]','[]','[]'),(56035,0,5,5,'[{0,17010001,40}]','[]','[]'),(56036,0,0,0,'[{0,17010001,40}]','[]','[]'),(56036,0,1,1,'[{0,17010001,40}]','[]','[]'),(56036,0,2,2,'[{0,17010001,40}]','[]','[]'),(56036,0,3,3,'[{0,17010001,40}]','[]','[]'),(56036,0,4,4,'[{0,17010001,40}]','[]','[]'),(56036,0,5,5,'[{0,17010001,40}]','[]','[]'),(56037,0,0,0,'[{0,17010001,40}]','[]','[]'),(56037,0,1,1,'[{0,17010001,40}]','[]','[]'),(56037,0,2,2,'[{0,17010001,40}]','[]','[]'),(56037,0,3,3,'[{0,17010001,40}]','[]','[]'),(56037,0,4,4,'[{0,17010001,40}]','[]','[]'),(56037,0,5,5,'[{0,17010001,40}]','[]','[]'),(56038,0,0,0,'[{0,17010001,40}]','[]','[]'),(56038,0,1,1,'[{0,17010001,40}]','[]','[]'),(56038,0,2,2,'[{0,17010001,40}]','[]','[]'),(56038,0,3,3,'[{0,17010001,40}]','[]','[]'),(56038,0,4,4,'[{0,17010001,40}]','[]','[]'),(56038,0,5,5,'[{0,17010001,40}]','[]','[]'),(56039,0,0,0,'[{0,17010001,120}]','[]','[]'),(56039,0,1,1,'[{0,17010001,120}]','[]','[]'),(56039,0,2,2,'[{0,17010001,120}]','[]','[]'),(56039,0,3,3,'[{0,17010001,120}]','[]','[]'),(56039,0,4,4,'[{0,17010001,120}]','[]','[]'),(56039,0,5,5,'[{0,17010001,120}]','[]','[]'),(56040,0,0,0,'[{0,17010001,50}]','[]','[]'),(56040,0,1,1,'[{0,17010001,50}]','[]','[]'),(56040,0,2,2,'[{0,17010001,50}]','[]','[]'),(56040,0,3,3,'[{0,17010001,50}]','[]','[]'),(56040,0,4,4,'[{0,17010001,50}]','[]','[]'),(56040,0,5,5,'[{0,17010001,50}]','[]','[]'),(56041,0,0,0,'[{0,17010001,50}]','[]','[]'),(56041,0,1,1,'[{0,17010001,50}]','[]','[]'),(56041,0,2,2,'[{0,17010001,50}]','[]','[]'),(56041,0,3,3,'[{0,17010001,50}]','[]','[]'),(56041,0,4,4,'[{0,17010001,50}]','[]','[]'),(56041,0,5,5,'[{0,17010001,50}]','[]','[]'),(56042,0,0,0,'[{0,17010001,50}]','[]','[]'),(56042,0,1,1,'[{0,17010001,50}]','[]','[]'),(56042,0,2,2,'[{0,17010001,50}]','[]','[]'),(56042,0,3,3,'[{0,17010001,50}]','[]','[]'),(56042,0,4,4,'[{0,17010001,50}]','[]','[]'),(56042,0,5,5,'[{0,17010001,50}]','[]','[]'),(56043,0,0,0,'[{0,17010001,50}]','[]','[]'),(56043,0,1,1,'[{0,17010001,50}]','[]','[]'),(56043,0,2,2,'[{0,17010001,50}]','[]','[]'),(56043,0,3,3,'[{0,17010001,50}]','[]','[]'),(56043,0,4,4,'[{0,17010001,50}]','[]','[]'),(56043,0,5,5,'[{0,17010001,50}]','[]','[]'),(56044,0,0,0,'[{0,17010001,150}]','[]','[]'),(56044,0,1,1,'[{0,17010001,150}]','[]','[]'),(56044,0,2,2,'[{0,17010001,150}]','[]','[]'),(56044,0,3,3,'[{0,17010001,150}]','[]','[]'),(56044,0,4,4,'[{0,17010001,150}]','[]','[]'),(56044,0,5,5,'[{0,17010001,150}]','[]','[]'),(56045,0,0,0,'[{0,17010001,60}]','[]','[]'),(56045,0,1,1,'[{0,17010001,60}]','[]','[]'),(56045,0,2,2,'[{0,17010001,60}]','[]','[]'),(56045,0,3,3,'[{0,17010001,60}]','[]','[]'),(56045,0,4,4,'[{0,17010001,60}]','[]','[]'),(56045,0,5,5,'[{0,17010001,60}]','[]','[]'),(56046,0,0,0,'[{0,17010001,60}]','[]','[]'),(56046,0,1,1,'[{0,17010001,60}]','[]','[]'),(56046,0,2,2,'[{0,17010001,60}]','[]','[]'),(56046,0,3,3,'[{0,17010001,60}]','[]','[]'),(56046,0,4,4,'[{0,17010001,60}]','[]','[]'),(56046,0,5,5,'[{0,17010001,60}]','[]','[]'),(56047,0,0,0,'[{0,17010001,60}]','[]','[]'),(56047,0,1,1,'[{0,17010001,60}]','[]','[]'),(56047,0,2,2,'[{0,17010001,60}]','[]','[]'),(56047,0,3,3,'[{0,17010001,60}]','[]','[]'),(56047,0,4,4,'[{0,17010001,60}]','[]','[]'),(56047,0,5,5,'[{0,17010001,60}]','[]','[]'),(56048,0,0,0,'[{0,17010001,60}]','[]','[]'),(56048,0,1,1,'[{0,17010001,60}]','[]','[]'),(56048,0,2,2,'[{0,17010001,60}]','[]','[]'),(56048,0,3,3,'[{0,17010001,60}]','[]','[]'),(56048,0,4,4,'[{0,17010001,60}]','[]','[]'),(56048,0,5,5,'[{0,17010001,60}]','[]','[]'),(56049,0,0,0,'[{0,17010001,180}]','[]','[]'),(56049,0,1,1,'[{0,17010001,180}]','[]','[]'),(56049,0,2,2,'[{0,17010001,180}]','[]','[]'),(56049,0,3,3,'[{0,17010001,180}]','[]','[]'),(56049,0,4,4,'[{0,17010001,180}]','[]','[]'),(56049,0,5,5,'[{0,17010001,180}]','[]','[]'),(56050,0,0,0,'[{0,17010001,70}]','[]','[]'),(56050,0,1,1,'[{0,17010001,70}]','[]','[]'),(56050,0,2,2,'[{0,17010001,70}]','[]','[]'),(56050,0,3,3,'[{0,17010001,70}]','[]','[]'),(56050,0,4,4,'[{0,17010001,70}]','[]','[]'),(56050,0,5,5,'[{0,17010001,70}]','[]','[]'),(56051,0,0,0,'[{0,17010001,70}]','[]','[]'),(56051,0,1,1,'[{0,17010001,70}]','[]','[]'),(56051,0,2,2,'[{0,17010001,70}]','[]','[]'),(56051,0,3,3,'[{0,17010001,70}]','[]','[]'),(56051,0,4,4,'[{0,17010001,70}]','[]','[]'),(56051,0,5,5,'[{0,17010001,70}]','[]','[]'),(56052,0,0,0,'[{0,17010001,70}]','[]','[]'),(56052,0,1,1,'[{0,17010001,70}]','[]','[]'),(56052,0,2,2,'[{0,17010001,70}]','[]','[]'),(56052,0,3,3,'[{0,17010001,70}]','[]','[]'),(56052,0,4,4,'[{0,17010001,70}]','[]','[]'),(56052,0,5,5,'[{0,17010001,70}]','[]','[]'),(56053,0,0,0,'[{0,17010001,70}]','[]','[]'),(56053,0,1,1,'[{0,17010001,70}]','[]','[]'),(56053,0,2,2,'[{0,17010001,70}]','[]','[]'),(56053,0,3,3,'[{0,17010001,70}]','[]','[]'),(56053,0,4,4,'[{0,17010001,70}]','[]','[]'),(56053,0,5,5,'[{0,17010001,70}]','[]','[]'),(56054,0,0,0,'[{0,17010001,210}]','[]','[]'),(56054,0,1,1,'[{0,17010001,210}]','[]','[]'),(56054,0,2,2,'[{0,17010001,210}]','[]','[]'),(56054,0,3,3,'[{0,17010001,210}]','[]','[]'),(56054,0,4,4,'[{0,17010001,210}]','[]','[]'),(56054,0,5,5,'[{0,17010001,210}]','[]','[]'),(56055,0,0,0,'[{0,17010001,80}]','[]','[]'),(56055,0,1,1,'[{0,17010001,80}]','[]','[]'),(56055,0,2,2,'[{0,17010001,80}]','[]','[]'),(56055,0,3,3,'[{0,17010001,80}]','[]','[]'),(56055,0,4,4,'[{0,17010001,80}]','[]','[]'),(56055,0,5,5,'[{0,17010001,80}]','[]','[]'),(56056,0,0,0,'[{0,17010001,80}]','[]','[]'),(56056,0,1,1,'[{0,17010001,80}]','[]','[]'),(56056,0,2,2,'[{0,17010001,80}]','[]','[]'),(56056,0,3,3,'[{0,17010001,80}]','[]','[]'),(56056,0,4,4,'[{0,17010001,80}]','[]','[]'),(56056,0,5,5,'[{0,17010001,80}]','[]','[]'),(56057,0,0,0,'[{0,17010001,80}]','[]','[]'),(56057,0,1,1,'[{0,17010001,80}]','[]','[]'),(56057,0,2,2,'[{0,17010001,80}]','[]','[]'),(56057,0,3,3,'[{0,17010001,80}]','[]','[]'),(56057,0,4,4,'[{0,17010001,80}]','[]','[]'),(56057,0,5,5,'[{0,17010001,80}]','[]','[]'),(56058,0,0,0,'[{0,17010001,80}]','[]','[]'),(56058,0,1,1,'[{0,17010001,80}]','[]','[]'),(56058,0,2,2,'[{0,17010001,80}]','[]','[]'),(56058,0,3,3,'[{0,17010001,80}]','[]','[]'),(56058,0,4,4,'[{0,17010001,80}]','[]','[]'),(56058,0,5,5,'[{0,17010001,80}]','[]','[]'),(56059,0,0,0,'[{0,17010001,240}]','[]','[]'),(56059,0,1,1,'[{0,17010001,240}]','[]','[]'),(56059,0,2,2,'[{0,17010001,240}]','[]','[]'),(56059,0,3,3,'[{0,17010001,240}]','[]','[]'),(56059,0,4,4,'[{0,17010001,240}]','[]','[]'),(56059,0,5,5,'[{0,17010001,240}]','[]','[]'),(56060,0,0,0,'[{0,17010001,90}]','[]','[]'),(56060,0,1,1,'[{0,17010001,90}]','[]','[]'),(56060,0,2,2,'[{0,17010001,90}]','[]','[]'),(56060,0,3,3,'[{0,17010001,90}]','[]','[]'),(56060,0,4,4,'[{0,17010001,90}]','[]','[]'),(56060,0,5,5,'[{0,17010001,90}]','[]','[]'),(56061,0,0,0,'[{0,17010001,90}]','[]','[]'),(56061,0,1,1,'[{0,17010001,90}]','[]','[]'),(56061,0,2,2,'[{0,17010001,90}]','[]','[]'),(56061,0,3,3,'[{0,17010001,90}]','[]','[]'),(56061,0,4,4,'[{0,17010001,90}]','[]','[]'),(56061,0,5,5,'[{0,17010001,90}]','[]','[]'),(56062,0,0,0,'[{0,17010001,90}]','[]','[]'),(56062,0,1,1,'[{0,17010001,90}]','[]','[]'),(56062,0,2,2,'[{0,17010001,90}]','[]','[]'),(56062,0,3,3,'[{0,17010001,90}]','[]','[]'),(56062,0,4,4,'[{0,17010001,90}]','[]','[]'),(56062,0,5,5,'[{0,17010001,90}]','[]','[]'),(56063,0,0,0,'[{0,17010001,90}]','[]','[]'),(56063,0,1,1,'[{0,17010001,90}]','[]','[]'),(56063,0,2,2,'[{0,17010001,90}]','[]','[]'),(56063,0,3,3,'[{0,17010001,90}]','[]','[]'),(56063,0,4,4,'[{0,17010001,90}]','[]','[]'),(56063,0,5,5,'[{0,17010001,90}]','[]','[]'),(56064,0,0,0,'[{0,17010001,270}]','[]','[]'),(56064,0,1,1,'[{0,17010001,270}]','[]','[]'),(56064,0,2,2,'[{0,17010001,270}]','[]','[]'),(56064,0,3,3,'[{0,17010001,270}]','[]','[]'),(56064,0,4,4,'[{0,17010001,270}]','[]','[]'),(56064,0,5,5,'[{0,17010001,270}]','[]','[]'),(56065,0,0,0,'[{0,17010001,100}]','[]','[]'),(56065,0,1,1,'[{0,17010001,100}]','[]','[]'),(56065,0,2,2,'[{0,17010001,100}]','[]','[]'),(56065,0,3,3,'[{0,17010001,100}]','[]','[]'),(56065,0,4,4,'[{0,17010001,100}]','[]','[]'),(56065,0,5,5,'[{0,17010001,100}]','[]','[]'),(56066,0,0,0,'[{0,17010001,100}]','[]','[]'),(56066,0,1,1,'[{0,17010001,100}]','[]','[]'),(56066,0,2,2,'[{0,17010001,100}]','[]','[]'),(56066,0,3,3,'[{0,17010001,100}]','[]','[]'),(56066,0,4,4,'[{0,17010001,100}]','[]','[]'),(56066,0,5,5,'[{0,17010001,100}]','[]','[]'),(56067,0,0,0,'[{0,17010001,100}]','[]','[]'),(56067,0,1,1,'[{0,17010001,100}]','[]','[]'),(56067,0,2,2,'[{0,17010001,100}]','[]','[]'),(56067,0,3,3,'[{0,17010001,100}]','[]','[]'),(56067,0,4,4,'[{0,17010001,100}]','[]','[]'),(56067,0,5,5,'[{0,17010001,100}]','[]','[]'),(56068,0,0,0,'[{0,17010001,100}]','[]','[]'),(56068,0,1,1,'[{0,17010001,100}]','[]','[]'),(56068,0,2,2,'[{0,17010001,100}]','[]','[]'),(56068,0,3,3,'[{0,17010001,100}]','[]','[]'),(56068,0,4,4,'[{0,17010001,100}]','[]','[]'),(56068,0,5,5,'[{0,17010001,100}]','[]','[]'),(56069,0,0,0,'[{0,17010001,300}]','[]','[]'),(56069,0,1,1,'[{0,17010001,300}]','[]','[]'),(56069,0,2,2,'[{0,17010001,300}]','[]','[]'),(56069,0,3,3,'[{0,17010001,300}]','[]','[]'),(56069,0,4,4,'[{0,17010001,300}]','[]','[]'),(56069,0,5,5,'[{0,17010001,300}]','[]','[]'),(56070,0,0,0,'[{0,17010001,200}]','[]','[]'),(56070,0,1,1,'[{0,17010001,200}]','[]','[]'),(56070,0,2,2,'[{0,17010001,200}]','[]','[]'),(56070,0,3,3,'[{0,17010001,200}]','[]','[]'),(56070,0,4,4,'[{0,17010001,200}]','[]','[]'),(56070,0,5,5,'[{0,17010001,200}]','[]','[]'),(56071,0,0,0,'[{0,17010001,200}]','[]','[]'),(56071,0,1,1,'[{0,17010001,200}]','[]','[]'),(56071,0,2,2,'[{0,17010001,200}]','[]','[]'),(56071,0,3,3,'[{0,17010001,200}]','[]','[]'),(56071,0,4,4,'[{0,17010001,200}]','[]','[]'),(56071,0,5,5,'[{0,17010001,200}]','[]','[]'),(56072,0,0,0,'[{0,17010001,200}]','[]','[]'),(56072,0,1,1,'[{0,17010001,200}]','[]','[]'),(56072,0,2,2,'[{0,17010001,200}]','[]','[]'),(56072,0,3,3,'[{0,17010001,200}]','[]','[]'),(56072,0,4,4,'[{0,17010001,200}]','[]','[]'),(56072,0,5,5,'[{0,17010001,200}]','[]','[]'),(56073,0,0,0,'[{0,17010001,200}]','[]','[]'),(56073,0,1,1,'[{0,17010001,200}]','[]','[]'),(56073,0,2,2,'[{0,17010001,200}]','[]','[]'),(56073,0,3,3,'[{0,17010001,200}]','[]','[]'),(56073,0,4,4,'[{0,17010001,200}]','[]','[]'),(56073,0,5,5,'[{0,17010001,200}]','[]','[]'),(56074,0,0,0,'[{0,17010001,600}]','[]','[]'),(56074,0,1,1,'[{0,17010001,600}]','[]','[]'),(56074,0,2,2,'[{0,17010001,600}]','[]','[]'),(56074,0,3,3,'[{0,17010001,600}]','[]','[]'),(56074,0,4,4,'[{0,17010001,600}]','[]','[]'),(56074,0,5,5,'[{0,17010001,600}]','[]','[]'),(56075,0,0,0,'[{0,17010001,300}]','[]','[]'),(56075,0,1,1,'[{0,17010001,300}]','[]','[]'),(56075,0,2,2,'[{0,17010001,300}]','[]','[]'),(56075,0,3,3,'[{0,17010001,300}]','[]','[]'),(56075,0,4,4,'[{0,17010001,300}]','[]','[]'),(56075,0,5,5,'[{0,17010001,300}]','[]','[]'),(56076,0,0,0,'[{0,17010001,300}]','[]','[]'),(56076,0,1,1,'[{0,17010001,300}]','[]','[]'),(56076,0,2,2,'[{0,17010001,300}]','[]','[]'),(56076,0,3,3,'[{0,17010001,300}]','[]','[]'),(56076,0,4,4,'[{0,17010001,300}]','[]','[]'),(56076,0,5,5,'[{0,17010001,300}]','[]','[]'),(56077,0,0,0,'[{0,17010001,300}]','[]','[]'),(56077,0,1,1,'[{0,17010001,300}]','[]','[]'),(56077,0,2,2,'[{0,17010001,300}]','[]','[]'),(56077,0,3,3,'[{0,17010001,300}]','[]','[]'),(56077,0,4,4,'[{0,17010001,300}]','[]','[]'),(56077,0,5,5,'[{0,17010001,300}]','[]','[]'),(56078,0,0,0,'[{0,17010001,300}]','[]','[]'),(56078,0,1,1,'[{0,17010001,300}]','[]','[]'),(56078,0,2,2,'[{0,17010001,300}]','[]','[]'),(56078,0,3,3,'[{0,17010001,300}]','[]','[]'),(56078,0,4,4,'[{0,17010001,300}]','[]','[]'),(56078,0,5,5,'[{0,17010001,300}]','[]','[]'),(56079,0,0,0,'[{0,17010001,900}]','[]','[]'),(56079,0,1,1,'[{0,17010001,900}]','[]','[]'),(56079,0,2,2,'[{0,17010001,900}]','[]','[]'),(56079,0,3,3,'[{0,17010001,900}]','[]','[]'),(56079,0,4,4,'[{0,17010001,900}]','[]','[]'),(56079,0,5,5,'[{0,17010001,900}]','[]','[]'),(56080,0,0,0,'[{0,17010001,400}]','[]','[]'),(56080,0,1,1,'[{0,17010001,400}]','[]','[]'),(56080,0,2,2,'[{0,17010001,400}]','[]','[]'),(56080,0,3,3,'[{0,17010001,400}]','[]','[]'),(56080,0,4,4,'[{0,17010001,400}]','[]','[]'),(56080,0,5,5,'[{0,17010001,400}]','[]','[]'),(56081,0,0,0,'[{0,17010001,400}]','[]','[]'),(56081,0,1,1,'[{0,17010001,400}]','[]','[]'),(56081,0,2,2,'[{0,17010001,400}]','[]','[]'),(56081,0,3,3,'[{0,17010001,400}]','[]','[]'),(56081,0,4,4,'[{0,17010001,400}]','[]','[]'),(56081,0,5,5,'[{0,17010001,400}]','[]','[]'),(56082,0,0,0,'[{0,17010001,400}]','[]','[]'),(56082,0,1,1,'[{0,17010001,400}]','[]','[]'),(56082,0,2,2,'[{0,17010001,400}]','[]','[]'),(56082,0,3,3,'[{0,17010001,400}]','[]','[]'),(56082,0,4,4,'[{0,17010001,400}]','[]','[]'),(56082,0,5,5,'[{0,17010001,400}]','[]','[]'),(56083,0,0,0,'[{0,17010001,400}]','[]','[]'),(56083,0,1,1,'[{0,17010001,400}]','[]','[]'),(56083,0,2,2,'[{0,17010001,400}]','[]','[]'),(56083,0,3,3,'[{0,17010001,400}]','[]','[]'),(56083,0,4,4,'[{0,17010001,400}]','[]','[]'),(56083,0,5,5,'[{0,17010001,400}]','[]','[]'),(56084,0,0,0,'[{0,17010001,1200}]','[]','[]'),(56084,0,1,1,'[{0,17010001,1200}]','[]','[]'),(56084,0,2,2,'[{0,17010001,1200}]','[]','[]'),(56084,0,3,3,'[{0,17010001,1200}]','[]','[]'),(56084,0,4,4,'[{0,17010001,1200}]','[]','[]'),(56084,0,5,5,'[{0,17010001,1200}]','[]','[]'),(56085,0,0,0,'[{0,17010001,500}]','[]','[]'),(56085,0,1,1,'[{0,17010001,500}]','[]','[]'),(56085,0,2,2,'[{0,17010001,500}]','[]','[]'),(56085,0,3,3,'[{0,17010001,500}]','[]','[]'),(56085,0,4,4,'[{0,17010001,500}]','[]','[]'),(56085,0,5,5,'[{0,17010001,500}]','[]','[]'),(56086,0,0,0,'[{0,17010001,500}]','[]','[]'),(56086,0,1,1,'[{0,17010001,500}]','[]','[]'),(56086,0,2,2,'[{0,17010001,500}]','[]','[]'),(56086,0,3,3,'[{0,17010001,500}]','[]','[]'),(56086,0,4,4,'[{0,17010001,500}]','[]','[]'),(56086,0,5,5,'[{0,17010001,500}]','[]','[]'),(56087,0,0,0,'[{0,17010001,500}]','[]','[]'),(56087,0,1,1,'[{0,17010001,500}]','[]','[]'),(56087,0,2,2,'[{0,17010001,500}]','[]','[]'),(56087,0,3,3,'[{0,17010001,500}]','[]','[]'),(56087,0,4,4,'[{0,17010001,500}]','[]','[]'),(56087,0,5,5,'[{0,17010001,500}]','[]','[]'),(56088,0,0,0,'[{0,17010001,500}]','[]','[]'),(56088,0,1,1,'[{0,17010001,500}]','[]','[]'),(56088,0,2,2,'[{0,17010001,500}]','[]','[]'),(56088,0,3,3,'[{0,17010001,500}]','[]','[]'),(56088,0,4,4,'[{0,17010001,500}]','[]','[]'),(56088,0,5,5,'[{0,17010001,500}]','[]','[]'),(56089,0,0,0,'[{0,17010001,1500}]','[]','[]'),(56089,0,1,1,'[{0,17010001,1500}]','[]','[]'),(56089,0,2,2,'[{0,17010001,1500}]','[]','[]'),(56089,0,3,3,'[{0,17010001,1500}]','[]','[]'),(56089,0,4,4,'[{0,17010001,1500}]','[]','[]'),(56089,0,5,5,'[{0,17010001,1500}]','[]','[]'),(56090,0,0,0,'[{0,17010001,600}]','[]','[]'),(56090,0,1,1,'[{0,17010001,600}]','[]','[]'),(56090,0,2,2,'[{0,17010001,600}]','[]','[]'),(56090,0,3,3,'[{0,17010001,600}]','[]','[]'),(56090,0,4,4,'[{0,17010001,600}]','[]','[]'),(56090,0,5,5,'[{0,17010001,600}]','[]','[]'),(56091,0,0,0,'[{0,17010001,600}]','[]','[]'),(56091,0,1,1,'[{0,17010001,600}]','[]','[]'),(56091,0,2,2,'[{0,17010001,600}]','[]','[]'),(56091,0,3,3,'[{0,17010001,600}]','[]','[]'),(56091,0,4,4,'[{0,17010001,600}]','[]','[]'),(56091,0,5,5,'[{0,17010001,600}]','[]','[]'),(56092,0,0,0,'[{0,17010001,600}]','[]','[]'),(56092,0,1,1,'[{0,17010001,600}]','[]','[]'),(56092,0,2,2,'[{0,17010001,600}]','[]','[]'),(56092,0,3,3,'[{0,17010001,600}]','[]','[]'),(56092,0,4,4,'[{0,17010001,600}]','[]','[]'),(56092,0,5,5,'[{0,17010001,600}]','[]','[]'),(56093,0,0,0,'[{0,17010001,600}]','[]','[]'),(56093,0,1,1,'[{0,17010001,600}]','[]','[]'),(56093,0,2,2,'[{0,17010001,600}]','[]','[]'),(56093,0,3,3,'[{0,17010001,600}]','[]','[]'),(56093,0,4,4,'[{0,17010001,600}]','[]','[]'),(56093,0,5,5,'[{0,17010001,600}]','[]','[]'),(56094,0,0,0,'[{0,17010001,1800}]','[]','[]'),(56094,0,1,1,'[{0,17010001,1800}]','[]','[]'),(56094,0,2,2,'[{0,17010001,1800}]','[]','[]'),(56094,0,3,3,'[{0,17010001,1800}]','[]','[]'),(56094,0,4,4,'[{0,17010001,1800}]','[]','[]'),(56094,0,5,5,'[{0,17010001,1800}]','[]','[]'),(56095,0,0,0,'[{0,17010001,700}]','[]','[]'),(56095,0,1,1,'[{0,17010001,700}]','[]','[]'),(56095,0,2,2,'[{0,17010001,700}]','[]','[]'),(56095,0,3,3,'[{0,17010001,700}]','[]','[]'),(56095,0,4,4,'[{0,17010001,700}]','[]','[]'),(56095,0,5,5,'[{0,17010001,700}]','[]','[]'),(56096,0,0,0,'[{0,17010001,700}]','[]','[]'),(56096,0,1,1,'[{0,17010001,700}]','[]','[]'),(56096,0,2,2,'[{0,17010001,700}]','[]','[]'),(56096,0,3,3,'[{0,17010001,700}]','[]','[]'),(56096,0,4,4,'[{0,17010001,700}]','[]','[]'),(56096,0,5,5,'[{0,17010001,700}]','[]','[]'),(56097,0,0,0,'[{0,17010001,700}]','[]','[]'),(56097,0,1,1,'[{0,17010001,700}]','[]','[]'),(56097,0,2,2,'[{0,17010001,700}]','[]','[]'),(56097,0,3,3,'[{0,17010001,700}]','[]','[]'),(56097,0,4,4,'[{0,17010001,700}]','[]','[]'),(56097,0,5,5,'[{0,17010001,700}]','[]','[]'),(56098,0,0,0,'[{0,17010001,700}]','[]','[]'),(56098,0,1,1,'[{0,17010001,700}]','[]','[]'),(56098,0,2,2,'[{0,17010001,700}]','[]','[]'),(56098,0,3,3,'[{0,17010001,700}]','[]','[]'),(56098,0,4,4,'[{0,17010001,700}]','[]','[]'),(56098,0,5,5,'[{0,17010001,700}]','[]','[]'),(56099,0,0,0,'[{0,17010001,2100}]','[]','[]'),(56099,0,1,1,'[{0,17010001,2100}]','[]','[]'),(56099,0,2,2,'[{0,17010001,2100}]','[]','[]'),(56099,0,3,3,'[{0,17010001,2100}]','[]','[]'),(56099,0,4,4,'[{0,17010001,2100}]','[]','[]'),(56099,0,5,5,'[{0,17010001,2100}]','[]','[]'),(60000,0,1,1,'[{0,38040300,6}]','[]','[]'),(60000,0,2,2,'[{0,38040300,8}]','[]','[]'),(60000,0,3,3,'[{0,38040300,10}]','[]','[]'),(60000,0,4,4,'[{0,38040300,12}]','[]','[]'),(60000,0,5,5,'[{0,38040300,14}]','[]','[]'),(60001,0,1,1,'[{0,38040300,8}]','[]','[]'),(60001,0,2,2,'[{0,38040300,10}]','[]','[]'),(60001,0,3,3,'[{0,38040300,12},{0,38040301,2}]','[]','[]'),(60001,0,4,4,'[{0,38040300,14},{0,38040301,3}]','[]','[]'),(60001,0,5,5,'[{0,38040300,16},{0,38040301,5},{0,38040302,3}]','[]','[]'),(60002,0,1,1,'[{0,38040300,10}]','[]','[]'),(60002,0,2,2,'[{0,38040300,12}]','[]','[]'),(60002,0,3,3,'[{0,38040300,14},{0,38040301,3}]','[]','[]'),(60002,0,4,4,'[{0,38040300,16},{0,38040301,5}]','[]','[]'),(60002,0,5,5,'[{0,38040300,18},{0,38040301,7},{0,38040302,4}]','[]','[]'),(60003,0,1,1,'[{0,38040300,12}]','[]','[]'),(60003,0,2,2,'[{0,38040300,14}]','[]','[]'),(60003,0,3,3,'[{0,38040300,16},{0,38040303,2}]','[]','[]'),(60003,0,4,4,'[{0,38040300,18},{0,38040303,3}]','[]','[]'),(60003,0,5,5,'[{0,38040300,20},{0,38040303,5},{0,38040304,3}]','[]','[]'),(60004,0,1,1,'[{0,38040300,14}]','[]','[]'),(60004,0,2,2,'[{0,38040300,16}]','[]','[]'),(60004,0,3,3,'[{0,38040300,15},{0,38040305,2}]','[]','[]'),(60004,0,4,4,'[{0,38040300,20},{0,38040305,3}]','[]','[]'),(60004,0,5,5,'[{0,38040300,22},{0,38040305,5},{0,38040306,3}]','[]','[]');
/*!40000 ALTER TABLE `base_dungeon_grade` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_dungeon_grade_dynamic`
--

DROP TABLE IF EXISTS `base_dungeon_grade_dynamic`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_dungeon_grade_dynamic` (
  `dun_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本id',
  `grade` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '评分等级',
  `min_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级下限',
  `max_lv` int(11) unsigned NOT NULL COMMENT '等级上限',
  `reward` varchar(500) NOT NULL DEFAULT '[]' COMMENT '静态奖励列表',
  `reward2` varchar(500) NOT NULL DEFAULT '[]' COMMENT '动态奖励(有参数参与计算)',
  PRIMARY KEY (`dun_id`,`grade`,`min_lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='副本动态奖励配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_dungeon_grade_dynamic`
--

LOCK TABLES `base_dungeon_grade_dynamic` WRITE;
/*!40000 ALTER TABLE `base_dungeon_grade_dynamic` DISABLE KEYS */;
INSERT INTO `base_dungeon_grade_dynamic` VALUES (5152,0,170,219,'[]','[{0,40010011,[32,32]},{255,40040001,[4,4]}]'),(5152,0,220,269,'[]','[{0,40010011,[34,34]},{255,40040001,[4,4]}]'),(5152,0,270,319,'[]','[{0,40010011,[36,36]},{255,40040001,[5,5]}]'),(5152,0,320,369,'[]','[{0,40010011,[38,38]},{255,40040001,[5,5]}]'),(5152,0,370,419,'[]','[{0,40010011,[40,40]},{255,40040001,[6,6]}]'),(5152,0,420,469,'[]','[{0,40010011,[42,42]},{255,40040001,[6,6]}]'),(5152,0,470,519,'[]','[{0,40010011,[44,44]},{255,40040001,[7,7]}]'),(5152,0,520,569,'[]','[{0,40010011,[46,46]},{255,40040001,[7,7]}]'),(5152,0,570,619,'[]','[{0,40010011,[48,48]},{255,40040001,[8,8]}]'),(5152,0,620,669,'[]','[{0,40010011,[50,50]},{255,40040001,[8,8]}]'),(5152,0,670,9999,'[]','[{0,40010011,[52,52]},{255,40040001,[9,9]}]'),(5152,1,170,219,'[]','[{0,40010011,[48,48]},{0,40030001,[2,2]},{255,40040001,[6,6]}]'),(5152,1,220,269,'[]','[{0,40010011,[51,51]},{0,40030001,[2,2]},{255,40040001,[6,6]}]'),(5152,1,270,319,'[]','[{0,40010011,[54,54]},{0,40030001,[2,2]},{255,40040001,[7,7]}]'),(5152,1,320,369,'[]','[{0,40010011,[57,57]},{0,40030001,[3,3]},{255,40040001,[7,7]}]'),(5152,1,370,419,'[]','[{0,40010011,[60,60]},{0,40030001,[3,3]},{255,40040001,[8,8]}]'),(5152,1,420,469,'[]','[{0,40010011,[63,63]},{0,40030001,[3,3]},{255,40040001,[8,8]}]'),(5152,1,470,519,'[]','[{0,40010011,[66,66]},{0,40030001,[4,4]},{255,40040001,[9,9]}]'),(5152,1,520,569,'[]','[{0,40010011,[69,69]},{0,40030001,[4,4]},{255,40040001,[9,9]}]'),(5152,1,570,619,'[]','[{0,40010011,[72,72]},{0,40030001,[4,4]},{255,40040001,[10,10]}]'),(5152,1,620,669,'[]','[{0,40010011,[75,75]},{0,40030001,[5,5]},{255,40040001,[10,10]}]'),(5152,1,670,9999,'[]','[{0,40010011,[78,78]},{0,40030001,[5,5]},{255,40040001,[11,11]}]'),(5152,2,170,219,'[]','[{0,40010011,[64,64]},{0,40030001,[5,5]},{255,40040001,[8,8]}]'),(5152,2,220,269,'[]','[{0,40010011,[68,68]},{0,40030001,[5,5]},{255,40040001,[8,8]}]'),(5152,2,270,319,'[]','[{0,40010011,[72,72]},{0,40030001,[5,5]},{255,40040001,[9,9]}]'),(5152,2,320,369,'[]','[{0,40010011,[76,76]},{0,40030001,[6,6]},{255,40040001,[9,9]}]'),(5152,2,370,419,'[]','[{0,40010011,[80,80]},{0,40030001,[6,6]},{255,40040001,[10,10]}]'),(5152,2,420,469,'[]','[{0,40010011,[84,84]},{0,40030001,[6,6]},{255,40040001,[10,10]}]'),(5152,2,470,519,'[]','[{0,40010011,[88,88]},{0,40030001,[7,7]},{255,40040001,[11,11]}]'),(5152,2,520,569,'[]','[{0,40010011,[92,92]},{0,40030001,[7,7]},{255,40040001,[11,11]}]'),(5152,2,570,619,'[]','[{0,40010011,[96,96]},{0,40030001,[7,7]},{255,40040001,[12,12]}]'),(5152,2,620,669,'[]','[{0,40010011,[100,100]},{0,40030001,[8,8]},{255,40040001,[12,12]}]'),(5152,2,670,9999,'[]','[{0,40010011,[104,104]},{0,40030001,[8,8]},{255,40040001,[13,13]}]'),(5152,3,170,219,'[]','[{0,40010011,[80,80]},{0,40030001,[8,8]},{255,40040001,[10,10]}]'),(5152,3,220,269,'[]','[{0,40010011,[85,85]},{0,40030001,[8,8]},{255,40040001,[10,10]}]'),(5152,3,270,319,'[]','[{0,40010011,[90,90]},{0,40030001,[8,8]},{255,40040001,[11,11]}]'),(5152,3,320,369,'[]','[{0,40010011,[95,95]},{0,40030001,[9,9]},{255,40040001,[11,11]}]'),(5152,3,370,419,'[]','[{0,40010011,[100,100]},{0,40030001,[9,9]},{255,40040001,[12,12]}]'),(5152,3,420,469,'[]','[{0,40010011,[105,105]},{0,40030001,[9,9]},{255,40040001,[12,12]}]'),(5152,3,470,519,'[]','[{0,40010011,[110,110]},{0,40030001,[10,10]},{255,40040001,[13,13]}]'),(5152,3,520,569,'[]','[{0,40010011,[115,115]},{0,40030001,[10,10]},{255,40040001,[13,13]}]'),(5152,3,570,619,'[]','[{0,40010011,[120,120]},{0,40030001,[10,10]},{255,40040001,[14,14]}]'),(5152,3,620,669,'[]','[{0,40010011,[125,125]},{0,40030001,[11,11]},{255,40040001,[14,14]}]'),(5152,3,670,9999,'[]','[{0,40010011,[130,130]},{0,40030001,[11,11]},{255,40040001,[15,15]}]');
/*!40000 ALTER TABLE `base_dungeon_grade_dynamic` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_dungeon_kill_mon_eff`
--

DROP TABLE IF EXISTS `base_dungeon_kill_mon_eff`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_dungeon_kill_mon_eff` (
  `dun_type` tinyint(3) unsigned NOT NULL COMMENT '副本类型',
  `title_id` int(10) unsigned NOT NULL COMMENT '标记id',
  `kill_count` smallint(5) unsigned NOT NULL COMMENT '击杀次数',
  `is_serial` tinyint(3) unsigned NOT NULL COMMENT '是否连续##0否 1是',
  `skill_id` int(10) unsigned NOT NULL COMMENT '技能id',
  `skill_lv` smallint(5) unsigned NOT NULL COMMENT '技能等级',
  `skill_way` tinyint(3) unsigned NOT NULL COMMENT '技能方式##1辅助 2攻击',
  PRIMARY KEY (`dun_type`,`title_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='副本杀怪效果配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_dungeon_kill_mon_eff`
--

LOCK TABLES `base_dungeon_kill_mon_eff` WRITE;
/*!40000 ALTER TABLE `base_dungeon_kill_mon_eff` DISABLE KEYS */;
INSERT INTO `base_dungeon_kill_mon_eff` VALUES (3,1000000,3,1,1000001,1,1);
/*!40000 ALTER TABLE `base_dungeon_kill_mon_eff` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_dungeon_level`
--

DROP TABLE IF EXISTS `base_dungeon_level`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_dungeon_level` (
  `dun_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本id',
  `scene_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本场景id',
  `serial_no` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '序号##顺序关卡需要使用的，顺序关卡副本不能有相同的serial_no',
  `name` varchar(100) NOT NULL DEFAULT '' COMMENT '名字@lang@',
  `desc` varchar(1000) NOT NULL DEFAULT '' COMMENT '描述@lang@',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  `wave_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本波数',
  `mon_event` text NOT NULL COMMENT '刷怪事件##[ {事件编号ID1, 波数类型1, 参数列表, [{触发元素1},{触发元素2},...}]}, {事件编号ID2, 波数类型2, 参数列表, [{触发元素3},{触发元素4},...}]},...]',
  `story_event` text NOT NULL COMMENT '剧情事件##[ {事件编号ID1, [剧情配置ID1, 剧情子类型], [{触发元素1},{触发元素2},...}]}, {事件编号ID2, [剧情ID配置2, 剧情子类型], [{触发元素3},{触发元素4},...}]},...]',
  `zone_event` text NOT NULL COMMENT '区域事件##[ {事件编号ID1, 区域配置ID1, 切换状态, [{触发元素1},{触发元素2},...}]}, {事件编号ID2, 区域ID配置2, 切换状态, [{触发元素3},{触发元素4},...}]},...]',
  `scene_event` text NOT NULL COMMENT '场景事件##[ {事件编号ID1, 参数列表, [{触发元素1},{触发元素2},...}]}, {事件编号ID2, 场景id, 参数列表, [{触发元素3},{触发元素4},...}]} }] },...]',
  `success_event` text NOT NULL COMMENT '通关事件##[ {类型(0:直接结算,1:只推送结算信息), [{触发元素1},{触发元素2},...}]}, {类型, [{触发元素3},{触发元素4},...}]},...]',
  `fail_event` text NOT NULL COMMENT '失败事件##[ {类型(0:直接结算,1:只推送结算信息), [{触发元素1},{触发元素2},...}]}, {类型, [{触发元素3},{触发元素4},...}]},...]',
  PRIMARY KEY (`dun_id`,`scene_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='副本关卡配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_dungeon_level`
--

LOCK TABLES `base_dungeon_level` WRITE;
/*!40000 ALTER TABLE `base_dungeon_level` DISABLE KEYS */;
INSERT INTO `base_dungeon_level` VALUES (2151,2150,1,'神秘洞窟1层','探索洞窟',180,1,'[{1,1,[],[{level_time,5}]}]','[]','[]','[]','[{1,[],[{mon_event_id_kill_all_mon,1}]}]','[{1,[],[{level_timeout}]}]'),(2151,2151,2,'神秘洞窟2层','探索洞窟2层',180,1,'[{1,1,[],[{level_time,5}]}]','[]','[]','[]','[{1,[],[{mon_event_id_kill_all_mon,1}]}]','[{1,[],[{level_timeout}]}]');
/*!40000 ALTER TABLE `base_dungeon_level` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_dungeon_level_rewards`
--

DROP TABLE IF EXISTS `base_dungeon_level_rewards`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_dungeon_level_rewards` (
  `dun_id` int(10) unsigned NOT NULL COMMENT '副本id',
  `level` smallint(5) unsigned NOT NULL COMMENT '关卡',
  `score_min` int(10) unsigned NOT NULL COMMENT '评分下限',
  `score_max` int(10) unsigned NOT NULL COMMENT '评分上限',
  `grade` smallint(5) unsigned NOT NULL COMMENT '评价等级',
  `rewards` varchar(1000) NOT NULL COMMENT '奖励列表',
  PRIMARY KEY (`dun_id`,`level`,`score_min`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='副本关卡评分奖励';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_dungeon_level_rewards`
--

LOCK TABLES `base_dungeon_level_rewards` WRITE;
/*!40000 ALTER TABLE `base_dungeon_level_rewards` DISABLE KEYS */;
/*!40000 ALTER TABLE `base_dungeon_level_rewards` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_dungeon_level_score`
--

DROP TABLE IF EXISTS `base_dungeon_level_score`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_dungeon_level_score` (
  `dun_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本id',
  `min_time_ratio` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间比例上限##百分比',
  `max_time_ratio` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间比例下限##百分比',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分数',
  `base_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '基础值',
  PRIMARY KEY (`dun_id`,`min_time_ratio`,`max_time_ratio`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='副本关卡加分配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_dungeon_level_score`
--

LOCK TABLES `base_dungeon_level_score` WRITE;
/*!40000 ALTER TABLE `base_dungeon_level_score` DISABLE KEYS */;
/*!40000 ALTER TABLE `base_dungeon_level_score` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_dungeon_mon_dynamic`
--

DROP TABLE IF EXISTS `base_dungeon_mon_dynamic`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_dungeon_mon_dynamic` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '怪物id',
  `dun_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本id',
  `level` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '层数',
  `ratio` double unsigned NOT NULL DEFAULT '0' COMMENT '难度系数##小数',
  PRIMARY KEY (`id`,`dun_id`,`level`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='副本怪物动态属性配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_dungeon_mon_dynamic`
--

LOCK TABLES `base_dungeon_mon_dynamic` WRITE;
/*!40000 ALTER TABLE `base_dungeon_mon_dynamic` DISABLE KEYS */;
INSERT INTO `base_dungeon_mon_dynamic` VALUES (2300001,2300,1,1),(2300001,2300,2,1.84);
/*!40000 ALTER TABLE `base_dungeon_mon_dynamic` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_dungeon_power_crush`
--

DROP TABLE IF EXISTS `base_dungeon_power_crush`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_dungeon_power_crush` (
  `power_r` double NOT NULL DEFAULT '0' COMMENT '战力比',
  `crush_r` double unsigned NOT NULL DEFAULT '0' COMMENT '碾压参数',
  PRIMARY KEY (`power_r`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='副本战力碾压配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_dungeon_power_crush`
--

LOCK TABLES `base_dungeon_power_crush` WRITE;
/*!40000 ALTER TABLE `base_dungeon_power_crush` DISABLE KEYS */;
INSERT INTO `base_dungeon_power_crush` VALUES (-9999,0.3),(-1,0.3),(-0.9,0.3),(-0.8,0.3),(-0.75,0.3),(-0.7,0.3),(-0.65,0.3),(-0.6,0.3),(-0.55,0.3),(-0.5,0.3),(-0.45,0.31),(-0.4,0.32),(-0.35,0.33),(-0.3,0.34),(-0.25,0.35),(-0.2,0.36),(-0.15,0.37),(-0.1,0.38),(-0.05,0.39),(0,0.4),(0.05,0.95),(0.09,1.2),(0.13,1.3),(0.17,1.4),(0.2,1.5),(0.23,1.6),(0.26,1.7),(0.29,1.8),(0.31,1.9),(0.33,2),(0.35,2.1),(0.38,2.2),(0.39,2.3),(0.41,2.4),(0.43,2.5),(0.44,2.6),(0.46,2.7),(0.47,2.8),(0.49,2.9),(0.5,3),(1,3);
/*!40000 ALTER TABLE `base_dungeon_power_crush` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_dungeon_rune_lv_data`
--

DROP TABLE IF EXISTS `base_dungeon_rune_lv_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_dungeon_rune_lv_data` (
  `dun_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本id',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '通关关卡',
  `group` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '组id',
  `boss_type` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'boss标志',
  `daily_rewards` varchar(255) NOT NULL DEFAULT '[]' COMMENT '每日奖励',
  `unlock_rune` varchar(255) NOT NULL DEFAULT '[]' COMMENT '解锁',
  `resource` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '资源',
  PRIMARY KEY (`dun_id`,`lv`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_dungeon_rune_lv_data`
--

LOCK TABLES `base_dungeon_rune_lv_data` WRITE;
/*!40000 ALTER TABLE `base_dungeon_rune_lv_data` DISABLE KEYS */;
INSERT INTO `base_dungeon_rune_lv_data` VALUES (5900,1,1,0,'[{255,36160007,500}]','[1]',0),(5901,2,2,0,'[{255,36160007,700}]','[]',0),(5902,3,3,0,'[{255,36160007,900}]','[]',0),(5903,4,4,0,'[{255,36160007,1100}]','[2]',5201144),(5904,5,5,0,'[{255,36160007,1300}]','[]',0),(5905,6,6,0,'[{255,36160007,1500}]','[]',0),(5906,7,7,0,'[{255,36160007,1700}]','[]',0),(5907,8,8,0,'[{255,36160007,1900}]','[3]',5201054),(5908,9,9,0,'[{255,36160007,2100}]','[]',0),(5909,10,10,0,'[{255,36160007,2800}]','[]',0),(5910,11,11,0,'[{255,36160007,3500}]','[]',0),(5911,12,12,0,'[{255,36160007,4200}]','[4]',5201064),(5912,13,13,0,'[{255,36160007,4900}]','[]',0),(5913,14,14,0,'[{255,36160007,5200}]','[]',0),(5914,15,15,0,'[{255,36160007,5500}]','[]',0),(5915,16,16,0,'[{255,36160007,5800}]','[5]',5201074),(5916,17,17,0,'[{255,36160007,6100}]','[]',0),(5917,18,18,0,'[{255,36160007,6400}]','[]',0),(5918,19,19,0,'[{255,36160007,6700}]','[]',0),(5919,20,20,0,'[{255,36160007,7000}]','[6]',5201084),(5920,21,21,0,'[{255,36160007,7300}]','[]',0),(5921,22,22,0,'[{255,36160007,7600}]','[]',0),(5922,23,23,0,'[{255,36160007,7800}]','[]',0),(5923,24,24,0,'[{255,36160007,8100}]','[]',5201094),(5924,25,25,0,'[{255,36160007,8400}]','[7]',0),(5925,26,26,0,'[{255,36160007,8700}]','[]',0),(5926,27,27,0,'[{255,36160007,9000}]','[]',0),(5927,28,28,0,'[{255,36160007,9300}]','[]',5201104),(5928,29,29,0,'[{255,36160007,9600}]','[]',0),(5929,30,30,0,'[{255,36160007,9900}]','[8]',0),(5930,31,31,0,'[{255,36160007,10100}]','[]',0),(5931,32,32,0,'[{255,36160007,10400}]','[]',5201154),(5932,33,33,0,'[{255,36160007,10700}]','[]',0),(5933,34,34,0,'[{255,36160007,11000}]','[]',0),(5934,35,35,0,'[{255,36160007,11300}]','[]',0),(5935,36,36,0,'[{255,36160007,11600}]','[]',5201174),(5936,37,37,0,'[{255,36160007,11900}]','[]',0),(5937,38,38,0,'[{255,36160007,12200}]','[]',0),(5938,39,39,0,'[{255,36160007,12400}]','[]',0),(5939,40,40,0,'[{255,36160007,12700}]','[]',0),(5940,41,41,0,'[{255,36160007,13000}]','[]',0),(5941,42,42,0,'[{255,36160007,13300}]','[]',5201164),(5942,43,43,0,'[{255,36160007,13600}]','[]',0),(5943,44,44,0,'[{255,36160007,13900}]','[]',0),(5944,45,45,0,'[{255,36160007,14200}]','[]',0),(5945,46,46,0,'[{255,36160007,14500}]','[]',0),(5946,47,47,0,'[{255,36160007,14700}]','[]',0),(5947,48,48,0,'[{255,36160007,15000}]','[]',0),(5948,49,49,0,'[{255,36160007,15300}]','[]',0),(5949,50,50,0,'[{255,36160007,15600}]','[]',5201184),(5950,51,51,0,'[{255,36160007,15900}]','[]',0),(5951,52,52,0,'[{255,36160007,16200}]','[]',0),(5952,53,53,0,'[{255,36160007,16500}]','[]',0),(5953,54,54,0,'[{255,36160007,16800}]','[]',0),(5954,55,55,0,'[{255,36160007,17100}]','[]',0),(5955,56,56,0,'[{255,36160007,17300}]','[]',0),(5956,57,57,0,'[{255,36160007,17600}]','[]',0),(5957,58,58,0,'[{255,36160007,17900}]','[]',0),(5958,59,59,0,'[{255,36160007,18200}]','[]',0),(5959,60,60,0,'[{255,36160007,18500}]','[]',5201194),(5960,61,61,0,'[{255,36160007,18800}]','[]',0),(5961,62,62,0,'[{255,36160007,19100}]','[]',0),(5962,63,63,0,'[{255,36160007,19400}]','[]',0),(5963,64,64,0,'[{255,36160007,19600}]','[]',0),(5964,65,65,0,'[{255,36160007,19900}]','[]',0),(5965,66,66,0,'[{255,36160007,20200}]','[]',0),(5966,67,67,0,'[{255,36160007,20500}]','[]',0),(5967,68,68,0,'[{255,36160007,20800}]','[]',0),(5968,69,69,0,'[{255,36160007,21100}]','[]',0),(5969,70,70,0,'[{255,36160007,21400}]','[]',0),(5970,71,71,0,'[{255,36160007,21700}]','[]',0),(5971,72,72,0,'[{255,36160007,21900}]','[]',0),(5972,73,73,0,'[{255,36160007,22200}]','[]',0),(5973,74,74,0,'[{255,36160007,22500}]','[]',0),(5974,75,75,0,'[{255,36160007,22800}]','[]',0),(5975,76,76,0,'[{255,36160007,23100}]','[]',0),(5976,77,77,0,'[{255,36160007,23400}]','[]',0),(5977,78,78,0,'[{255,36160007,23700}]','[]',0),(5978,79,79,0,'[{255,36160007,24000}]','[]',0),(5979,80,80,0,'[{255,36160007,24200}]','[]',0),(5980,81,81,0,'[{255,36160007,24500}]','[]',0),(5981,82,82,0,'[{255,36160007,24800}]','[]',0),(5982,83,83,0,'[{255,36160007,25100}]','[]',0),(5983,84,84,0,'[{255,36160007,25400}]','[]',0),(5984,85,85,0,'[{255,36160007,25700}]','[]',0),(5985,86,86,0,'[{255,36160007,26000}]','[]',0),(5986,87,87,0,'[{255,36160007,26300}]','[]',0),(5987,88,88,0,'[{255,36160007,26600}]','[]',0),(5988,89,89,0,'[{255,36160007,26800}]','[]',0),(5989,90,90,0,'[{255,36160007,27100}]','[]',0),(5990,91,91,0,'[{255,36160007,27400}]','[]',0),(5991,92,92,0,'[{255,36160007,27700}]','[]',0),(5992,93,93,0,'[{255,36160007,28000}]','[]',0),(5993,94,94,0,'[{255,36160007,28300}]','[]',0),(5994,95,95,0,'[{255,36160007,28600}]','[]',0),(5995,96,96,0,'[{255,36160007,28900}]','[]',0),(5996,97,97,0,'[{255,36160007,29100}]','[]',0),(5997,98,98,0,'[{255,36160007,29400}]','[]',0),(5998,99,99,0,'[{255,36160007,29700}]','[]',0),(5999,100,100,0,'[{255,36160007,30000}]','[]',0),(40001,1,0,0,'[{255,36160007,60}]','[]',0),(40001,2,0,0,'[{255,36160007,132}]','[]',0),(40001,3,0,0,'[{255,36160007,215}]','[]',0),(40001,4,0,0,'[{255,36160007,304}]','[]',0),(40001,5,0,0,'[{255,36160007,399}]','[]',0),(40001,6,0,0,'[{255,36160007,498}]','[]',0),(40001,7,0,0,'[{255,36160007,601}]','[]',0),(40001,8,0,0,'[{255,36160007,707}]','[]',0),(40001,9,0,0,'[{255,36160007,816}]','[]',0),(40001,10,0,0,'[{255,36160007,928}]','[]',0),(40001,11,0,0,'[{255,36160007,1042}]','[]',0),(40001,12,0,0,'[{255,36160007,1158}]','[]',0),(40001,13,0,0,'[{255,36160007,1276}]','[]',0),(40001,14,0,0,'[{255,36160007,1397}]','[]',0),(40001,15,0,0,'[{255,36160007,1518}]','[]',0),(40001,16,0,0,'[{255,36160007,1642}]','[]',0),(40001,17,0,0,'[{255,36160007,1767}]','[]',0),(40001,18,0,0,'[{255,36160007,1894}]','[]',0),(40001,19,0,0,'[{255,36160007,2022}]','[]',0),(40001,20,0,0,'[{255,36160007,2152}]','[]',0),(40001,21,0,0,'[{255,36160007,2283}]','[]',0),(40001,22,0,0,'[{255,36160007,2415}]','[]',0),(40001,23,0,0,'[{255,36160007,2548}]','[]',0),(40001,24,0,0,'[{255,36160007,2683}]','[]',0),(40001,25,0,0,'[{255,36160007,2819}]','[]',0),(40001,26,0,0,'[{255,36160007,2956}]','[]',0),(40001,27,0,0,'[{255,36160007,3094}]','[]',0),(40001,28,0,0,'[{255,36160007,3233}]','[]',0),(40001,29,0,0,'[{255,36160007,3373}]','[]',0),(40001,30,0,0,'[{255,36160007,3514}]','[]',0),(40001,31,0,0,'[{255,36160007,3656}]','[]',0),(40001,32,0,0,'[{255,36160007,3799}]','[]',0),(40001,33,0,0,'[{255,36160007,3943}]','[]',0),(40001,34,0,0,'[{255,36160007,4088}]','[]',0),(40001,35,0,0,'[{255,36160007,4233}]','[]',0),(40001,36,0,0,'[{255,36160007,4380}]','[]',0),(40001,37,0,0,'[{255,36160007,4527}]','[]',0),(40001,38,0,0,'[{255,36160007,4675}]','[]',0),(40001,39,0,0,'[{255,36160007,4824}]','[]',0),(40001,40,0,0,'[{255,36160007,4973}]','[]',0),(40001,41,0,0,'[{255,36160007,5124}]','[]',0),(40001,42,0,0,'[{255,36160007,5275}]','[]',0),(40001,43,0,0,'[{255,36160007,5427}]','[]',0),(40001,44,0,0,'[{255,36160007,5580}]','[]',0),(40001,45,0,0,'[{255,36160007,5733}]','[]',0),(40001,46,0,0,'[{255,36160007,5887}]','[]',0),(40001,47,0,0,'[{255,36160007,6042}]','[]',0),(40001,48,0,0,'[{255,36160007,6197}]','[]',0),(40001,49,0,0,'[{255,36160007,6353}]','[]',0),(40001,50,0,0,'[{255,36160007,6510}]','[]',0),(40001,51,0,0,'[{255,36160007,6667}]','[]',0),(40001,52,0,0,'[{255,36160007,6825}]','[]',0),(40001,53,0,0,'[{255,36160007,6983}]','[]',0),(40001,54,0,0,'[{255,36160007,7142}]','[]',0),(40001,55,0,0,'[{255,36160007,7302}]','[]',0),(40001,56,0,0,'[{255,36160007,7462}]','[]',0),(40001,57,0,0,'[{255,36160007,7623}]','[]',0),(40001,58,0,0,'[{255,36160007,7785}]','[]',0),(40001,59,0,0,'[{255,36160007,7947}]','[]',0),(40001,60,0,0,'[{255,36160007,8109}]','[]',0),(40001,61,0,0,'[{255,36160007,8272}]','[]',0),(40001,62,0,0,'[{255,36160007,8436}]','[]',0),(40001,63,0,0,'[{255,36160007,8600}]','[]',0),(40001,64,0,0,'[{255,36160007,8765}]','[]',0),(40001,65,0,0,'[{255,36160007,8930}]','[]',0),(40001,66,0,0,'[{255,36160007,9096}]','[]',0),(40001,67,0,0,'[{255,36160007,9262}]','[]',0),(40001,68,0,0,'[{255,36160007,9429}]','[]',0),(40001,69,0,0,'[{255,36160007,9596}]','[]',0),(40001,70,0,0,'[{255,36160007,9764}]','[]',0),(40001,71,0,0,'[{255,36160007,9932}]','[]',0),(40001,72,0,0,'[{255,36160007,10101}]','[]',0),(40001,73,0,0,'[{255,36160007,10270}]','[]',0),(40001,74,0,0,'[{255,36160007,10440}]','[]',0),(40001,75,0,0,'[{255,36160007,10610}]','[]',0),(40001,76,0,0,'[{255,36160007,10780}]','[]',0),(40001,77,0,0,'[{255,36160007,10951}]','[]',0),(40001,78,0,0,'[{255,36160007,11123}]','[]',0),(40001,79,0,0,'[{255,36160007,11295}]','[]',0),(40001,80,0,0,'[{255,36160007,11467}]','[]',0),(40001,81,0,0,'[{255,36160007,11640}]','[]',0),(40001,82,0,0,'[{255,36160007,11813}]','[]',0),(40001,83,0,0,'[{255,36160007,11987}]','[]',0),(40001,84,0,0,'[{255,36160007,12161}]','[]',0),(40001,85,0,0,'[{255,36160007,12335}]','[]',0),(40001,86,0,0,'[{255,36160007,12510}]','[]',0),(40001,87,0,0,'[{255,36160007,12685}]','[]',0),(40001,88,0,0,'[{255,36160007,12861}]','[]',0),(40001,89,0,0,'[{255,36160007,13037}]','[]',0),(40001,90,0,0,'[{255,36160007,13214}]','[]',0),(40001,91,0,0,'[{255,36160007,13391}]','[]',0),(40001,92,0,0,'[{255,36160007,13568}]','[]',0),(40001,93,0,0,'[{255,36160007,13746}]','[]',0),(40001,94,0,0,'[{255,36160007,13924}]','[]',0),(40001,95,0,0,'[{255,36160007,14102}]','[]',0),(40001,96,0,0,'[{255,36160007,14281}]','[]',0),(40001,97,0,0,'[{255,36160007,14460}]','[]',0),(40001,98,0,0,'[{255,36160007,14640}]','[]',0),(40001,99,0,0,'[{255,36160007,14820}]','[]',0),(40001,100,0,0,'[{255,36160007,15000}]','[]',0),(56000,1,1,0,'[]','[]',0),(56001,2,1,0,'[]','[]',0),(56002,3,1,0,'[]','[]',0),(56003,4,1,0,'[]','[]',0),(56004,5,1,1,'[]','[]',0),(56005,6,2,0,'[]','[]',0),(56006,7,2,0,'[]','[]',0),(56007,8,2,0,'[]','[]',0),(56008,9,2,0,'[]','[]',0),(56009,10,2,1,'[]','[]',0),(56010,11,3,0,'[]','[]',0),(56011,12,3,0,'[]','[]',0),(56012,13,3,0,'[]','[]',0),(56013,14,3,0,'[]','[]',0),(56014,15,3,1,'[]','[]',0),(56015,16,4,0,'[]','[]',0),(56016,17,4,0,'[]','[]',0),(56017,18,4,0,'[]','[]',0),(56018,19,4,0,'[]','[]',0),(56019,20,4,1,'[]','[]',0),(56020,21,5,0,'[]','[]',0),(56021,22,5,0,'[]','[]',0),(56022,23,5,0,'[]','[]',0),(56023,24,5,0,'[]','[]',0),(56024,25,5,1,'[]','[]',0),(56025,26,6,0,'[]','[]',0),(56026,27,6,0,'[]','[]',0),(56027,28,6,0,'[]','[]',0),(56028,29,6,0,'[]','[]',0),(56029,30,6,1,'[]','[]',0),(56030,31,7,0,'[]','[]',0),(56031,32,7,0,'[]','[]',0),(56032,33,7,0,'[]','[]',0),(56033,34,7,0,'[]','[]',0),(56034,35,7,1,'[]','[]',0),(56035,36,8,0,'[]','[]',0),(56036,37,8,0,'[]','[]',0),(56037,38,8,0,'[]','[]',0),(56038,39,8,0,'[]','[]',0),(56039,40,8,1,'[]','[]',0),(56040,41,9,0,'[]','[]',0),(56041,42,9,0,'[]','[]',0),(56042,43,9,0,'[]','[]',0),(56043,44,9,0,'[]','[]',0),(56044,45,9,1,'[]','[]',0),(56045,46,10,0,'[]','[]',0),(56046,47,10,0,'[]','[]',0),(56047,48,10,0,'[]','[]',0),(56048,49,10,0,'[]','[]',0),(56049,50,10,1,'[]','[]',0),(56050,51,11,0,'[]','[]',0),(56051,52,11,0,'[]','[]',0),(56052,53,11,0,'[]','[]',0),(56053,54,11,0,'[]','[]',0),(56054,55,11,1,'[]','[]',0),(56055,56,12,0,'[]','[]',0),(56056,57,12,0,'[]','[]',0),(56057,58,12,0,'[]','[]',0),(56058,59,12,0,'[]','[]',0),(56059,60,12,1,'[]','[]',0),(56060,61,13,0,'[]','[]',0),(56061,62,13,0,'[]','[]',0),(56062,63,13,0,'[]','[]',0),(56063,64,13,0,'[]','[]',0),(56064,65,13,1,'[]','[]',0),(56065,66,14,0,'[]','[]',0),(56066,67,14,0,'[]','[]',0),(56067,68,14,0,'[]','[]',0),(56068,69,14,0,'[]','[]',0),(56069,70,14,1,'[]','[]',0),(56070,71,15,0,'[]','[]',0),(56071,72,15,0,'[]','[]',0),(56072,73,15,0,'[]','[]',0),(56073,74,15,0,'[]','[]',0),(56074,75,15,1,'[]','[]',0),(56075,76,16,0,'[]','[]',0),(56076,77,16,0,'[]','[]',0),(56077,78,16,0,'[]','[]',0),(56078,79,16,0,'[]','[]',0),(56079,80,16,1,'[]','[]',0),(56080,81,17,0,'[]','[]',0),(56081,82,17,0,'[]','[]',0),(56082,83,17,0,'[]','[]',0),(56083,84,17,0,'[]','[]',0),(56084,85,17,1,'[]','[]',0),(56085,86,18,0,'[]','[]',0),(56086,87,18,0,'[]','[]',0),(56087,88,18,0,'[]','[]',0),(56088,89,18,0,'[]','[]',0),(56089,90,18,1,'[]','[]',0),(56090,91,19,0,'[]','[]',0),(56091,92,19,0,'[]','[]',0),(56092,93,19,0,'[]','[]',0),(56093,94,19,0,'[]','[]',0),(56094,95,19,1,'[]','[]',0),(56095,96,20,0,'[]','[]',0),(56096,97,20,0,'[]','[]',0),(56097,98,20,0,'[]','[]',0),(56098,99,20,0,'[]','[]',0),(56099,100,20,1,'[]','[]',0);
/*!40000 ALTER TABLE `base_dungeon_rune_lv_data` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_dungeon_score`
--

DROP TABLE IF EXISTS `base_dungeon_score`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_dungeon_score` (
  `dun_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本id',
  `same_guild_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '同公会加分',
  `friend_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '好友加分',
  `intimacy_score_list` text NOT NULL COMMENT '亲密度等级加分##[{最小亲密度等级,最大亲密度等级,加分}]',
  `time_score_list` text NOT NULL COMMENT '时间加分##[{耗时开始时间,耗时结束时间,加分}]',
  `mon_score_list` text NOT NULL COMMENT '怪物加分##[{怪物id,加分}]',
  `other_list` varchar(512) NOT NULL DEFAULT '[]' COMMENT '其他加分',
  PRIMARY KEY (`dun_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='副本加分配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_dungeon_score`
--

LOCK TABLES `base_dungeon_score` WRITE;
/*!40000 ALTER TABLE `base_dungeon_score` DISABLE KEYS */;
INSERT INTO `base_dungeon_score` VALUES (1003,0,0,'[]','[]','[{1003000,1}]','[]'),(3000,0,0,'[]','[]','[{30010101,1},{30010102,1},{30010103,1},{30010104,1},{30010105,1},{30010106,1},{30010107,1},{30010108,1},{30010109,1},{30010201,1},{30010202,1},{30010203,1},{30010204,1},{30010205,1},{30010206,1},{30010207,1},{30010208,1},{30010209,1},{30010301,1},{30010302,1},{30010303,1},{30010304,1},{30010305,1},{30010306,1},{30010307,1},{30010308,1},{30010309,1},{30010401,1},{30010402,1},{30010403,1},{30010404,1},{30010405,1},{30010406,1},{30010407,1},{30010408,1},{30010409,1},{30010501,1},{30010502,1},{30010503,1},{30010504,1},{30010505,1},{30010506,1},{30010507,1},{30010508,1},{30010509,1}]','[]'),(3001,0,0,'[]','[]','[{30010101,1},{30010102,1},{30010103,1},{30010104,1},{30010105,1},{30010106,1},{30010107,1},{30010108,1},{30010109,1},{30010201,1},{30010202,1},{30010203,1},{30010204,1},{30010205,1},{30010206,1},{30010207,1},{30010208,1},{30010209,1},{30010301,1},{30010302,1},{30010303,1},{30010304,1},{30010305,1},{30010306,1},{30010307,1},{30010308,1},{30010309,1},{30010401,1},{30010402,1},{30010403,1},{30010404,1},{30010405,1},{30010406,1},{30010407,1},{30010408,1},{30010409,1},{30010501,1},{30010502,1},{30010503,1},{30010504,1},{30010505,1},{30010506,1},{30010507,1},{30010508,1},{30010509,1}]','[]'),(3002,0,0,'[]','[]','[{3002001,1}]','[]'),(3003,0,0,'[]','[]','[{30010101,1},{30010102,1},{30010103,1},{30010104,1},{30010105,1},{30010106,1},{30010107,1},{30010108,1},{30010109,1},{30010201,1},{30010202,1},{30010203,1},{30010204,1},{30010205,1},{30010206,1},{30010207,1},{30010208,1},{30010209,1},{30010301,1},{30010302,1},{30010303,1},{30010304,1},{30010305,1},{30010306,1},{30010307,1},{30010308,1},{30010309,1},{30010401,1},{30010402,1},{30010403,1},{30010404,1},{30010405,1},{30010406,1},{30010407,1},{30010408,1},{30010409,1},{30010501,1},{30010502,1},{30010503,1},{30010504,1},{30010505,1},{30010506,1},{30010507,1},{30010508,1},{30010509,1}]','[]'),(3110,0,0,'[]','[]','[{3110001,1},{3110002,1},{3110003,1},{3110004,1},{3110005,1},{3110006,1},{3110007,1}]','[\n{sp_time_score,\n[\n{1,[{0,45,5},{46,55,4},{56,70,3},{71,90,2},{91,590,1},{591,600,0}]},\n{2,[{0,60,5},{61,70,4},{71,85,3},{86,100,2},{101,590,1},{591,600,0}]},\n{3,[{0,40,5},{41,50,4},{51,65,3},{66,80,2},{81,590,1},{591,600,0}]},\n{4,[{0,65,5},{66,75,4},{76,90,3},{91,105,2},{106,590,1},{591,600,0}]}\n]\n}\n]'),(3111,0,0,'[]','[]','[{3111001,1},{3111002,1},{3111003,1},{3111004,1},{3111005,1},{3111006,1},{3111007,1}]','[\n{sp_time_score,\n[\n{1,[{0,50,5},{51,55,4},{56,70,3},{71,90,2},{91,590,1},{591,600,0}]},\n{2,[{0,55,5},{56,65,4},{66,80,3},{81,95,2},{96,590,1},{591,600,0}]},\n{3,[{0,30,5},{31,40,4},{41,55,3},{56,70,2},{71,590,1},{591,600,0}]},\n{4,[{0,90,5},{91,100,4},{101,110,3},{111,120,2},{121,590,1},{591,600,0}]}\n]\n}\n]'),(3112,0,0,'[]','[]','[{3112001,1},{3112002,1},{3112003,1},{3112004,1},{3112005,1},{3112006,1},{3112007,1}]','[\n{sp_time_score,\n[\n{1,[{0,50,5},{51,55,4},{56,70,3},{71,90,2},{91,590,1},{591,600,0}]},\n{2,[{0,55,5},{56,65,4},{66,80,3},{81,95,2},{96,590,1},{591,600,0}]},\n{3,[{0,30,5},{31,40,4},{41,55,3},{56,70,2},{71,590,1},{591,600,0}]},\n{4,[{0,90,5},{91,100,4},{101,110,3},{111,120,2},{121,590,1},{591,600,0}]}\n]\n}\n]'),(3113,0,0,'[]','[]','[{3113001,1},{3113002,1},{3113003,1},{3113004,1},{3113005,1},{3113006,1},{3113007,1}]','[\n{sp_time_score,\n[\n{1,[{0,50,5},{51,55,4},{56,70,3},{71,90,2},{91,590,1},{591,600,0}]},\n{2,[{0,55,5},{56,65,4},{66,80,3},{81,95,2},{96,590,1},{591,600,0}]},\n{3,[{0,30,5},{31,40,4},{41,55,3},{56,70,2},{71,590,1},{591,600,0}]},\n{4,[{0,90,5},{91,100,4},{101,110,3},{111,120,2},{121,590,1},{591,600,0}]}\n]\n}\n]'),(3114,0,0,'[]','[]','[{3114001,1},{3114002,1},{3114003,1},{3114004,1},{3114005,1},{3114006,1},{3114007,1}]','[\n{sp_time_score,\n[\n{1,[{0,50,5},{51,55,4},{56,70,3},{71,90,2},{91,590,1},{591,600,0}]},\n{2,[{0,55,5},{56,65,4},{66,80,3},{81,95,2},{96,590,1},{591,600,0}]},\n{3,[{0,30,5},{31,40,4},{41,55,3},{56,70,2},{71,590,1},{591,600,0}]},\n{4,[{0,90,5},{91,100,4},{101,110,3},{111,120,2},{121,590,1},{591,600,0}]}\n]\n}\n]'),(3115,0,0,'[]','[]','[{3115001,1},{3115002,1},{3115003,1},{3115004,1},{3115005,1},{3115006,1},{3115007,1}]','[\n{sp_time_score,\n[\n{1,[{0,50,5},{51,55,4},{56,70,3},{71,90,2},{91,590,1},{591,600,0}]},\n{2,[{0,55,5},{56,65,4},{66,80,3},{81,95,2},{96,590,1},{591,600,0}]},\n{3,[{0,30,5},{31,40,4},{41,55,3},{56,70,2},{71,590,1},{591,600,0}]},\n{4,[{0,90,5},{91,100,4},{101,110,3},{111,120,2},{121,590,1},{591,600,0}]}\n]\n}\n]'),(3116,0,0,'[]','[]','[{3116001,1},{3116002,1},{3116003,1},{3116004,1},{3116005,1},{3116006,1},{3116007,1}]','[\n{sp_time_score,\n[\n{1,[{0,50,5},{51,55,4},{56,70,3},{71,90,2},{91,590,1},{591,600,0}]},\n{2,[{0,55,5},{56,65,4},{66,80,3},{81,95,2},{96,590,1},{591,600,0}]},\n{3,[{0,30,5},{31,40,4},{41,55,3},{56,70,2},{71,590,1},{591,600,0}]},\n{4,[{0,90,5},{91,100,4},{101,110,3},{111,120,2},{121,590,1},{591,600,0}]}\n]\n}\n]'),(3117,0,0,'[]','[]','[{3117001,1},{3117002,1},{3117003,1},{3117004,1},{3117005,1},{3117006,1},{3117007,1}]','[\n{sp_time_score,\n[\n{1,[{0,50,5},{51,55,4},{56,70,3},{71,90,2},{91,590,1},{591,600,0}]},\n{2,[{0,55,5},{56,65,4},{66,80,3},{81,95,2},{96,590,1},{591,600,0}]},\n{3,[{0,30,5},{31,40,4},{41,55,3},{56,70,2},{71,590,1},{591,600,0}]},\n{4,[{0,90,5},{91,100,4},{101,110,3},{111,120,2},{121,590,1},{591,600,0}]}\n]\n}\n]'),(3118,0,0,'[]','[]','[{3118001,1},{3118002,1},{3118003,1},{3118004,1},{3118005,1},{3118006,1},{3118007,1}]','[\n{sp_time_score,\n[\n{1,[{0,50,5},{51,55,4},{56,70,3},{71,90,2},{91,590,1},{591,600,0}]},\n{2,[{0,55,5},{56,65,4},{66,80,3},{81,95,2},{96,590,1},{591,600,0}]},\n{3,[{0,30,5},{31,40,4},{41,55,3},{56,70,2},{71,590,1},{591,600,0}]},\n{4,[{0,90,5},{91,100,4},{101,110,3},{111,120,2},{121,590,1},{591,600,0}]}\n]\n}\n]'),(3119,0,0,'[]','[]','[{3119001,1},{3119002,1},{3119003,1},{3119004,1},{3119005,1},{3119006,1},{3119007,1}]','[\n{sp_time_score,\n[\n{1,[{0,50,5},{51,55,4},{56,70,3},{71,90,2},{91,590,1},{591,600,0}]},\n{2,[{0,55,5},{56,65,4},{66,80,3},{81,95,2},{96,590,1},{591,600,0}]},\n{3,[{0,30,5},{31,40,4},{41,55,3},{56,70,2},{71,590,1},{591,600,0}]},\n{4,[{0,90,5},{91,100,4},{101,110,3},{111,120,2},{121,590,1},{591,600,0}]}\n]\n}\n]'),(3120,0,0,'[]','[]','[{3120001,1},{3120002,1},{3120003,1},{3120004,1},{3120005,1},{3120006,1},{3120007,1}]','[\n{sp_time_score,\n[\n{1,[{0,50,5},{51,55,4},{56,70,3},{71,90,2},{91,590,1},{591,600,0}]},\n{2,[{0,55,5},{56,65,4},{66,80,3},{81,95,2},{96,590,1},{591,600,0}]},\n{3,[{0,30,5},{31,40,4},{41,55,3},{56,70,2},{71,590,1},{591,600,0}]},\n{4,[{0,90,5},{91,100,4},{101,110,3},{111,120,2},{121,590,1},{591,600,0}]}\n]\n}\n]'),(3121,0,0,'[]','[]','[{3121001,1},{3121002,1},{3121003,1},{3121004,1},{3121005,1},{3121006,1},{3121007,1}]','[\n{sp_time_score,\n[\n{1,[{0,50,5},{51,55,4},{56,70,3},{71,90,2},{91,590,1},{591,600,0}]},\n{2,[{0,55,5},{56,65,4},{66,80,3},{81,95,2},{96,590,1},{591,600,0}]},\n{3,[{0,30,5},{31,40,4},{41,55,3},{56,70,2},{71,590,1},{591,600,0}]},\n{4,[{0,90,5},{91,100,4},{101,110,3},{111,120,2},{121,590,1},{591,600,0}]}\n]\n}\n]'),(3122,0,0,'[]','[]','[{3122001,1},{3122002,1},{3122003,1},{3122004,1},{3122005,1},{3122006,1},{3122007,1}]','[\n{sp_time_score,\n[\n{1,[{0,50,5},{51,55,4},{56,70,3},{71,90,2},{91,590,1},{591,600,0}]},\n{2,[{0,55,5},{56,65,4},{66,80,3},{81,95,2},{96,590,1},{591,600,0}]},\n{3,[{0,30,5},{31,40,4},{41,55,3},{56,70,2},{71,590,1},{591,600,0}]},\n{4,[{0,90,5},{91,100,4},{101,110,3},{111,120,2},{121,590,1},{591,600,0}]}\n]\n}\n]'),(3300,0,0,'[]','[]','[{3110001,1},{3110002,1},{3110003,1},{3110004,1},{1003001,1}]','[{wave_score,[{1,2},{2,3},{3,4},{4,5}]}]'),(3301,0,0,'[]','[]','[{3110001,1},{3110002,1},{3110003,1},{3110004,1},{1003001,1}]','[{wave_score,[{1,2},{2,3},{3,4},{4,5}]}]'),(3302,0,0,'[]','[]','[{3110001,1},{3110002,1},{3110003,1},{3110004,1},{1003001,1}]','[{wave_score,[{1,2},{2,3},{3,4},{4,5}]}]'),(3303,0,0,'[]','[]','[{3110001,1},{3110002,1},{3110003,1},{3110004,1},{1003001,1}]','[{wave_score,[{1,2},{2,3},{3,4},{4,5}]}]'),(3304,0,0,'[]','[]','[{3110001,1},{3110002,1},{3110003,1},{3110004,1},{1003001,1}]','[{wave_score,[{1,2},{2,3},{3,4},{4,5}]}]'),(4201,0,0,'[]','[{0,60,4},{61,120,3},{121,180,2},{181,9999,1}]','[{4201111,1},{4201112,1},{4201121,1},{4201122,1},{4201131,1},{4201132,1},{4201141,1},{4201142,1},{4201151,1},{4201152,1},{4201161,1},{4201162,1},{4201171,1},{4201172,1},{4201181,1},{4201182,1},{4201211,1},{4201212,1},{4201221,1},{4201222,1},{4201231,1},{4201232,1},{4201241,1},{4201242,1},{4201251,1},{4201252,1},{4201261,1},{4201262,1},{4201271,1},{4201272,1},{4201281,1},{4201282,1},{4201311,1},{4201312,1},{4201321,1},{4201322,1},{4201331,1},{4201332,1},{4201341,1},{4201342,1},{4201351,1},{4201352,1},{4201361,1},{4201362,1},{4201371,1},{4201372,1},{4201381,1},{4201382,1}]','[]'),(5200,0,0,'[]','[]','[{5200001,1},{5200002,1},{5200003,1},{5200004,1},{5200005,1},{5200006,1}]','[{common_sp_score,[{0,5000,1},{5001,9000,2},{9001,12000,3},{12001,13500,4},{13501,14800,5}]},{couple_mon_wave_score,[{1,100,1},{2,200,0},{3,1500,2}]},{couple_skill_score,[{21005200,240,4,10},{21005201,360,6,15}]}]'),(5201,0,0,'[]','[]','[{5201001,1},{5201002,1},{5201003,1},{5201004,1},{5201005,1},{5201006,1}]','[{common_sp_score,[{0,5000,1},{5001,9000,2},{9001,12000,3},{12001,13500,4},{13501,14800,5}]},{couple_mon_wave_score,[{1,100,1},{2,200,0},{3,1500,2}]},{couple_skill_score,[{21005200,240,4,10},{21005201,360,6,15}]}]'),(5202,0,0,'[]','[]','[{5202001,1},{5202002,1},{5202003,1},{5202004,1},{5202005,1},{5202006,1}]','[{common_sp_score,[{0,5000,1},{5001,9000,2},{9001,12000,3},{12001,13500,4},{13501,14800,5}]},{couple_mon_wave_score,[{1,100,1},{2,200,0},{3,1500,2}]},{couple_skill_score,[{21005200,240,4,10},{21005201,360,6,15}]}]'),(5300,0,0,'[]','[]','[]','[{common_sp_score,[{70,100,5},{50,69,4},{30,49,3},{20,29,2},{10,19,1},{0,9,0}]}]'),(5301,0,0,'[]','[]','[]','[{common_sp_score,[{70,100,5},{50,69,4},{30,49,3},{20,29,2},{10,19,1},{0,9,0}]}]'),(5302,0,0,'[]','[]','[]','[{common_sp_score,[{70,100,5},{50,69,4},{30,49,3},{20,29,2},{10,19,1},{0,9,0}]}]'),(5303,0,0,'[]','[]','[]','[{common_sp_score,[{70,100,5},{50,69,4},{30,49,3},{20,29,2},{10,19,1},{0,9,0}]}]'),(5304,0,0,'[]','[]','[]','[{common_sp_score,[{70,100,5},{50,69,4},{30,49,3},{20,29,2},{10,19,1},{0,9,0}]}]'),(5400,0,0,'[]','[{0,60,5},{61,120,4},{121,180,3},{181,240,2},{241,300,1},{300,320,0}]','[{5400000,1}]','[]'),(5401,0,0,'[]','[{0,60,5},{61,120,4},{121,180,3},{181,240,2},{241,300,1},{300,320,0}]','[{5401000,1}]','[]'),(5402,0,0,'[]','[{0,60,5},{61,120,4},{121,180,3},{181,240,2},{241,300,1},{300,320,0}]','[{5402000,1}]','[]'),(5403,0,0,'[]','[{0,60,5},{61,120,4},{121,180,3},{181,240,2},{241,300,1},{300,320,0}]','[{5403000,1}]','[]'),(5404,0,0,'[]','[{0,60,5},{61,120,4},{121,180,3},{181,240,2},{241,300,1},{300,320,0}]','[{5404000,1}]','[]'),(5405,0,0,'[]','[]','[{5405000,1}]','[]'),(5900,0,0,'[]','[]','[{5900000,1}]','[]'),(5901,0,0,'[]','[]','[{5900001,1}]','[]'),(5902,0,0,'[]','[]','[{5900002,1}]','[]'),(5903,0,0,'[]','[]','[{5900003,1}]','[]'),(5904,0,0,'[]','[]','[{5900004,1}]','[]'),(5905,0,0,'[]','[]','[{5900005,1}]','[]'),(5906,0,0,'[]','[]','[{5900006,1}]','[]'),(5907,0,0,'[]','[]','[{5900007,1}]','[]'),(5908,0,0,'[]','[]','[{5900008,1}]','[]'),(5909,0,0,'[]','[]','[{5900009,1}]','[]'),(5910,0,0,'[]','[]','[{5900010,1}]','[]'),(5911,0,0,'[]','[]','[{5900011,1}]','[]'),(5912,0,0,'[]','[]','[{5900012,1}]','[]'),(5913,0,0,'[]','[]','[{5900013,1}]','[]'),(5914,0,0,'[]','[]','[{5900014,1}]','[]'),(5915,0,0,'[]','[]','[{5900015,1}]','[]'),(5916,0,0,'[]','[]','[{5900016,1}]','[]'),(5917,0,0,'[]','[]','[{5900017,1}]','[]'),(5918,0,0,'[]','[]','[{5900018,1}]','[]'),(5919,0,0,'[]','[]','[{5900019,1}]','[]'),(5920,0,0,'[]','[]','[{5900020,1}]','[]'),(5921,0,0,'[]','[]','[{5900021,1}]','[]'),(5922,0,0,'[]','[]','[{5900022,1}]','[]'),(5923,0,0,'[]','[]','[{5900023,1}]','[]'),(5924,0,0,'[]','[]','[{5900024,1}]','[]'),(5925,0,0,'[]','[]','[{5900025,1}]','[]'),(5926,0,0,'[]','[]','[{5900026,1}]','[]'),(5927,0,0,'[]','[]','[{5900027,1}]','[]'),(5928,0,0,'[]','[]','[{5900028,1}]','[]'),(5929,0,0,'[]','[]','[{5900029,1}]','[]'),(5930,0,0,'[]','[]','[{5900030,1}]','[]'),(5931,0,0,'[]','[]','[{5900031,1}]','[]'),(5932,0,0,'[]','[]','[{5900032,1}]','[]'),(5933,0,0,'[]','[]','[{5900033,1}]','[]'),(5934,0,0,'[]','[]','[{5900034,1}]','[]'),(5935,0,0,'[]','[]','[{5900035,1}]','[]'),(5936,0,0,'[]','[]','[{5900036,1}]','[]'),(5937,0,0,'[]','[]','[{5900037,1}]','[]'),(5938,0,0,'[]','[]','[{5900038,1}]','[]'),(5939,0,0,'[]','[]','[{5900039,1}]','[]'),(5940,0,0,'[]','[]','[{5900040,1}]','[]'),(5941,0,0,'[]','[]','[{5900041,1}]','[]'),(5942,0,0,'[]','[]','[{5900042,1}]','[]'),(5943,0,0,'[]','[]','[{5900043,1}]','[]'),(5944,0,0,'[]','[]','[{5900044,1}]','[]'),(5945,0,0,'[]','[]','[{5900045,1}]','[]'),(5946,0,0,'[]','[]','[{5900046,1}]','[]'),(5947,0,0,'[]','[]','[{5900047,1}]','[]'),(5948,0,0,'[]','[]','[{5900048,1}]','[]'),(5949,0,0,'[]','[]','[{5900049,1}]','[]'),(5950,0,0,'[]','[]','[{5900050,1}]','[]'),(5951,0,0,'[]','[]','[{5900051,1}]','[]'),(5952,0,0,'[]','[]','[{5900052,1}]','[]'),(5953,0,0,'[]','[]','[{5900053,1}]','[]'),(5954,0,0,'[]','[]','[{5900054,1}]','[]'),(5955,0,0,'[]','[]','[{5900055,1}]','[]'),(5956,0,0,'[]','[]','[{5900056,1}]','[]'),(5957,0,0,'[]','[]','[{5900057,1}]','[]'),(5958,0,0,'[]','[]','[{5900058,1}]','[]'),(5959,0,0,'[]','[]','[{5900059,1}]','[]'),(5960,0,0,'[]','[]','[{5900060,1}]','[]'),(5961,0,0,'[]','[]','[{5900061,1}]','[]'),(5962,0,0,'[]','[]','[{5900062,1}]','[]'),(5963,0,0,'[]','[]','[{5900063,1}]','[]'),(5964,0,0,'[]','[]','[{5900064,1}]','[]'),(5965,0,0,'[]','[]','[{5900065,1}]','[]'),(5966,0,0,'[]','[]','[{5900066,1}]','[]'),(5967,0,0,'[]','[]','[{5900067,1}]','[]'),(5968,0,0,'[]','[]','[{5900068,1}]','[]'),(5969,0,0,'[]','[]','[{5900069,1}]','[]'),(5970,0,0,'[]','[]','[{5900070,1}]','[]'),(5971,0,0,'[]','[]','[{5900071,1}]','[]'),(5972,0,0,'[]','[]','[{5900072,1}]','[]'),(5973,0,0,'[]','[]','[{5900073,1}]','[]'),(5974,0,0,'[]','[]','[{5900074,1}]','[]'),(5975,0,0,'[]','[]','[{5900075,1}]','[]'),(5976,0,0,'[]','[]','[{5900076,1}]','[]'),(5977,0,0,'[]','[]','[{5900077,1}]','[]'),(5978,0,0,'[]','[]','[{5900078,1}]','[]'),(5979,0,0,'[]','[]','[{5900079,1}]','[]'),(5980,0,0,'[]','[]','[{5900080,1}]','[]'),(5981,0,0,'[]','[]','[{5900081,1}]','[]'),(5982,0,0,'[]','[]','[{5900082,1}]','[]'),(5983,0,0,'[]','[]','[{5900083,1}]','[]'),(5984,0,0,'[]','[]','[{5900084,1}]','[]'),(5985,0,0,'[]','[]','[{5900085,1}]','[]'),(5986,0,0,'[]','[]','[{5900086,1}]','[]'),(5987,0,0,'[]','[]','[{5900087,1}]','[]'),(5988,0,0,'[]','[]','[{5900088,1}]','[]'),(5989,0,0,'[]','[]','[{5900089,1}]','[]'),(5990,0,0,'[]','[]','[{5900090,1}]','[]'),(5991,0,0,'[]','[]','[{5900091,1}]','[]'),(5992,0,0,'[]','[]','[{5900092,1}]','[]'),(5993,0,0,'[]','[]','[{5900093,1}]','[]'),(5994,0,0,'[]','[]','[{5900094,1}]','[]'),(5995,0,0,'[]','[]','[{5900095,1}]','[]'),(5996,0,0,'[]','[]','[{5900096,1}]','[]'),(5997,0,0,'[]','[]','[{5900097,1}]','[]'),(5998,0,0,'[]','[]','[{5900098,1}]','[]'),(5999,0,0,'[]','[]','[{5900099,1}]','[]'),(10000,0,0,'[]','[]','[{100000001,1}]','[]'),(10003,0,0,'[]','[]','[{100030001,1}]','[]'),(40001,0,0,'[]','[]','[]','[{mon_skip_num,[{0,2,5}]},{mon_skip_num,[{3,999,0}]}]'),(56000,0,0,'[]','[]','[{56000001,1}]','[]'),(56001,0,0,'[]','[]','[{56000002,1}]','[]'),(56002,0,0,'[]','[]','[{56000003,1}]','[]'),(56003,0,0,'[]','[]','[{56000004,1}]','[]'),(56004,0,0,'[]','[]','[{56000005,1}]','[]'),(56005,0,0,'[]','[]','[{56000006,1}]','[]'),(56006,0,0,'[]','[]','[{56000007,1}]','[]'),(56007,0,0,'[]','[]','[{56000008,1}]','[]'),(56008,0,0,'[]','[]','[{56000009,1}]','[]'),(56009,0,0,'[]','[]','[{56000010,1}]','[]'),(56010,0,0,'[]','[]','[{56000011,1}]','[]'),(56011,0,0,'[]','[]','[{56000012,1}]','[]'),(56012,0,0,'[]','[]','[{56000013,1}]','[]'),(56013,0,0,'[]','[]','[{56000014,1}]','[]'),(56014,0,0,'[]','[]','[{56000015,1}]','[]'),(56015,0,0,'[]','[]','[{56000016,1}]','[]'),(56016,0,0,'[]','[]','[{56000017,1}]','[]'),(56017,0,0,'[]','[]','[{56000018,1}]','[]'),(56018,0,0,'[]','[]','[{56000019,1}]','[]'),(56019,0,0,'[]','[]','[{56000020,1}]','[]'),(56020,0,0,'[]','[]','[{56000021,1}]','[]'),(56021,0,0,'[]','[]','[{56000022,1}]','[]'),(56022,0,0,'[]','[]','[{56000023,1}]','[]'),(56023,0,0,'[]','[]','[{56000024,1}]','[]'),(56024,0,0,'[]','[]','[{56000025,1}]','[]'),(56025,0,0,'[]','[]','[{56000026,1}]','[]'),(56026,0,0,'[]','[]','[{56000027,1}]','[]'),(56027,0,0,'[]','[]','[{56000028,1}]','[]'),(56028,0,0,'[]','[]','[{56000029,1}]','[]'),(56029,0,0,'[]','[]','[{56000030,1}]','[]'),(56030,0,0,'[]','[]','[{56000031,1}]','[]'),(56031,0,0,'[]','[]','[{56000032,1}]','[]'),(56032,0,0,'[]','[]','[{56000033,1}]','[]'),(56033,0,0,'[]','[]','[{56000034,1}]','[]'),(56034,0,0,'[]','[]','[{56000035,1}]','[]'),(56035,0,0,'[]','[]','[{56000036,1}]','[]'),(56036,0,0,'[]','[]','[{56000037,1}]','[]'),(56037,0,0,'[]','[]','[{56000038,1}]','[]'),(56038,0,0,'[]','[]','[{56000039,1}]','[]'),(56039,0,0,'[]','[]','[{56000040,1}]','[]'),(56040,0,0,'[]','[]','[{56000041,1}]','[]'),(56041,0,0,'[]','[]','[{56000042,1}]','[]'),(56042,0,0,'[]','[]','[{56000043,1}]','[]'),(56043,0,0,'[]','[]','[{56000044,1}]','[]'),(56044,0,0,'[]','[]','[{56000045,1}]','[]'),(56045,0,0,'[]','[]','[{56000046,1}]','[]'),(56046,0,0,'[]','[]','[{56000047,1}]','[]'),(56047,0,0,'[]','[]','[{56000048,1}]','[]'),(56048,0,0,'[]','[]','[{56000049,1}]','[]'),(56049,0,0,'[]','[]','[{56000050,1}]','[]'),(56050,0,0,'[]','[]','[{56000051,1}]','[]'),(56051,0,0,'[]','[]','[{56000052,1}]','[]'),(56052,0,0,'[]','[]','[{56000053,1}]','[]'),(56053,0,0,'[]','[]','[{56000054,1}]','[]'),(56054,0,0,'[]','[]','[{56000055,1}]','[]'),(56055,0,0,'[]','[]','[{56000056,1}]','[]'),(56056,0,0,'[]','[]','[{56000057,1}]','[]'),(56057,0,0,'[]','[]','[{56000058,1}]','[]'),(56058,0,0,'[]','[]','[{56000059,1}]','[]'),(56059,0,0,'[]','[]','[{56000060,1}]','[]'),(56060,0,0,'[]','[]','[{56000061,1}]','[]'),(56061,0,0,'[]','[]','[{56000062,1}]','[]'),(56062,0,0,'[]','[]','[{56000063,1}]','[]'),(56063,0,0,'[]','[]','[{56000064,1}]','[]'),(56064,0,0,'[]','[]','[{56000065,1}]','[]'),(56065,0,0,'[]','[]','[{56000066,1}]','[]'),(56066,0,0,'[]','[]','[{56000067,1}]','[]'),(56067,0,0,'[]','[]','[{56000068,1}]','[]'),(56068,0,0,'[]','[]','[{56000069,1}]','[]'),(56069,0,0,'[]','[]','[{56000070,1}]','[]'),(56070,0,0,'[]','[]','[{56000071,1}]','[]'),(56071,0,0,'[]','[]','[{56000072,1}]','[]'),(56072,0,0,'[]','[]','[{56000073,1}]','[]'),(56073,0,0,'[]','[]','[{56000074,1}]','[]'),(56074,0,0,'[]','[]','[{56000075,1}]','[]'),(56075,0,0,'[]','[]','[{56000076,1}]','[]'),(56076,0,0,'[]','[]','[{56000077,1}]','[]'),(56077,0,0,'[]','[]','[{56000078,1}]','[]'),(56078,0,0,'[]','[]','[{56000079,1}]','[]'),(56079,0,0,'[]','[]','[{56000080,1}]','[]'),(56080,0,0,'[]','[]','[{56000081,1}]','[]'),(56081,0,0,'[]','[]','[{56000082,1}]','[]'),(56082,0,0,'[]','[]','[{56000083,1}]','[]'),(56083,0,0,'[]','[]','[{56000084,1}]','[]'),(56084,0,0,'[]','[]','[{56000085,1}]','[]'),(56085,0,0,'[]','[]','[{56000086,1}]','[]'),(56086,0,0,'[]','[]','[{56000087,1}]','[]'),(56087,0,0,'[]','[]','[{56000088,1}]','[]'),(56088,0,0,'[]','[]','[{56000089,1}]','[]'),(56089,0,0,'[]','[]','[{56000090,1}]','[]'),(56090,0,0,'[]','[]','[{56000091,1}]','[]'),(56091,0,0,'[]','[]','[{56000092,1}]','[]'),(56092,0,0,'[]','[]','[{56000093,1}]','[]'),(56093,0,0,'[]','[]','[{56000094,1}]','[]'),(56094,0,0,'[]','[]','[{56000095,1}]','[]'),(56095,0,0,'[]','[]','[{56000096,1}]','[]'),(56096,0,0,'[]','[]','[{56000097,1}]','[]'),(56097,0,0,'[]','[]','[{56000098,1}]','[]'),(56098,0,0,'[]','[]','[{56000099,1}]','[]'),(56099,0,0,'[]','[]','[{56000100,1}]','[]'),(60000,0,0,'[]','[]','[{600001,1},{600002,1},{600003,1},{600004,1},{600005,1},{600006,1},{600007,1},{600008,1},{600009,1},{600010,1},{600011,1},{600012,1},{600013,1},{600014,1},{600015,1},{600016,1},{600017,1},{600018,1}]','[{common_sp_score,[{0,2,1},{3,3,2},{4,4,3},{5,5,4},{6,99,5}]}]'),(60001,0,0,'[]','[]','[{600021,1},{600022,1},{600023,1},{600024,1},{600025,1},{600026,1},{600027,1},{600028,1},{600029,1},{600030,1},{600031,1},{600032,1},{600033,1},{600034,1},{600035,1},{600036,1},{600037,1},{600038,1}]','[{common_sp_score,[{0,2,1},{3,3,2},{4,4,3},{5,5,4},{6,99,5}]}]'),(60002,0,0,'[]','[]','[{600041,1},{600042,1},{600043,1},{600044,1},{600045,1},{600046,1},{600047,1},{600048,1},{600049,1},{600050,1},{600051,1},{600052,1},{600053,1},{600054,1},{600055,1},{600056,1},{600057,1},{600058,1}]','[{common_sp_score,[{0,2,1},{3,3,2},{4,4,3},{5,5,4},{6,99,5}]}]'),(60003,0,0,'[]','[]','[{600061,1},{600062,1},{600063,1},{600064,1},{600065,1},{600066,1},{600067,1},{600068,1},{600069,1},{600070,1},{600071,1},{600072,1},{600073,1},{600074,1},{600075,1},{600076,1},{600077,1},{600078,1}]','[{common_sp_score,[{0,2,1},{3,3,2},{4,4,3},{5,5,4},{6,99,5}]}]'),(60004,0,0,'[]','[]','[{600081,1},{600082,1},{600083,1},{600084,1},{600085,1},{600086,1},{600087,1},{600088,1},{600089,1},{600090,1},{600091,1},{600092,1},{600093,1},{600094,1},{600095,1},{600096,1},{600097,1},{600098,1}]','[{common_sp_score,[{0,2,1},{3,3,2},{4,4,3},{5,5,4},{6,99,5}]}]');
/*!40000 ALTER TABLE `base_dungeon_score` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_dungeon_skill`
--

DROP TABLE IF EXISTS `base_dungeon_skill`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_dungeon_skill` (
  `mon_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '怪物id',
  `skill_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '技能id',
  PRIMARY KEY (`mon_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='副本技能配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_dungeon_skill`
--

LOCK TABLES `base_dungeon_skill` WRITE;
/*!40000 ALTER TABLE `base_dungeon_skill` DISABLE KEYS */;
INSERT INTO `base_dungeon_skill` VALUES (2,100000),(8010,910016),(1701001,211701001),(1701002,211701001),(2100016,910005),(2100017,910006),(2100018,910007),(2100019,910013),(2100020,910009),(2100021,910010),(2100022,910011),(2100023,910012),(2100024,910013),(2100025,910014);
/*!40000 ALTER TABLE `base_dungeon_skill` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_dungeon_special_cfg`
--

DROP TABLE IF EXISTS `base_dungeon_special_cfg`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_dungeon_special_cfg` (
  `dun_id` int(10) unsigned NOT NULL COMMENT '副本id',
  `key` varchar(255) NOT NULL COMMENT '键',
  `value` text NOT NULL COMMENT '值',
  `desc` text NOT NULL COMMENT '说明',
  PRIMARY KEY (`dun_id`,`key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='副本特殊配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_dungeon_special_cfg`
--

LOCK TABLES `base_dungeon_special_cfg` WRITE;
/*!40000 ALTER TABLE `base_dungeon_special_cfg` DISABLE KEYS */;
INSERT INTO `base_dungeon_special_cfg` VALUES (2201,'pyx_id','1','圣器id'),(2202,'pyx_id','2','圣器id'),(2203,'pyx_id','3','圣器ID'),(2204,'pyx_id','4','圣器ID'),(3000,'encourage_data','{21000001,21000001,10,5,{2,0,10},{3,0,10000}}','{钻石鼓舞的技能id,金币鼓舞的技能id,总次数,铜币次数,钻石消耗,金币消耗}\n玩家的鼓舞次数会当作技能等级使用'),(3001,'encourage_data','{21000002,21000001,10,5,{0,38040101,1},{0,38040102,1}}','{大号角鼓舞的技能id,小唢呐鼓舞的技能id,总次数,单个次数,大号角消耗,小唢呐消耗} 玩家的鼓舞次数会当作技能等级使用'),(3002,'encourage_data','{21000002,21000001,10,5,{0,38040101,1},{0,38040102,1}}','{钻石鼓舞的技能id,金币鼓舞的技能id,总次数,铜币次数,钻石消耗,金币消耗}玩家的鼓舞次数会当作技能等级使用'),(3003,'encourage_data','{21000002,21000001,10,5,{0,38040101,1},{0,38040102,1}}','{钻石鼓舞的技能id,金币鼓舞的技能id,总次数,铜币次数,钻石消耗,金币消耗}玩家的鼓舞次数会当作技能等级使用'),(3110,'drop_rule','[{5,300},{4,250},{3,200},{2,150},{1,100}]','掉落倍率,格式[{评分，倍率}](倍率用百分制，100%写成100)'),(3110,'encourage_data','{21000002,21000001,10,5,{0,38040101,1},{0,38040102,1}}','{大号角鼓舞的技能id,小唢呐鼓舞的技能id,总次数,单个次数,大号角消耗,小唢呐消耗} 玩家的鼓舞次数会当作技能等级使用'),(3110,'help_rewards','[{255,36160002,100}]','助战奖励:格式[{类型,物品id,数量}]'),(3111,'drop_rule','[{5,300},{4,250},{3,200},{2,150},{1,100}]','掉落倍率,格式[{评分，倍率}](倍率用百分制，100%写成100)'),(3111,'encourage_data','{21000002,21000001,10,5,{0,38040101,1},{0,38040102,1}}','{大号角鼓舞的技能id,小唢呐鼓舞的技能id,总次数,单个次数,大号角消耗,小唢呐消耗} 玩家的鼓舞次数会当作技能等级使用'),(3111,'help_rewards','[{255,36160002,100}]','助战奖励:格式[{类型,物品id,数量}]'),(3112,'drop_rule','[{5,300},{4,250},{3,200},{2,150},{1,100}]','掉落倍率,格式[{评分，倍率}](倍率用百分制，100%写成100)'),(3112,'encourage_data','{21000002,21000001,10,5,{0,38040101,1},{0,38040102,1}}','{大号角鼓舞的技能id,小唢呐鼓舞的技能id,总次数,单个次数,大号角消耗,小唢呐消耗} 玩家的鼓舞次数会当作技能等级使用'),(3112,'help_rewards','[{255,36160002,100}]','助战奖励:格式[{类型,物品id,数量}]'),(3113,'drop_rule','[{5,300},{4,250},{3,200},{2,150},{1,100}]','掉落倍率,格式[{评分，倍率}](倍率用百分制，100%写成100)'),(3113,'encourage_data','{21000002,21000001,10,5,{0,38040101,1},{0,38040102,1}}','{大号角鼓舞的技能id,小唢呐鼓舞的技能id,总次数,单个次数,大号角消耗,小唢呐消耗} 玩家的鼓舞次数会当作技能等级使用'),(3113,'help_rewards','[{255,36160002,100}]','助战奖励:格式[{类型,物品id,数量}]'),(3114,'drop_rule','[{5,300},{4,250},{3,200},{2,150},{1,100}]','掉落倍率,格式[{评分，倍率}](倍率用百分制，100%写成100)'),(3114,'encourage_data','{21000002,21000001,10,5,{0,38040101,1},{0,38040102,1}}','{大号角鼓舞的技能id,小唢呐鼓舞的技能id,总次数,单个次数,大号角消耗,小唢呐消耗} 玩家的鼓舞次数会当作技能等级使用'),(3114,'help_rewards','[{255,36160002,100}]','助战奖励:格式[{类型,物品id,数量}]'),(3115,'drop_rule','[{5,300},{4,250},{3,200},{2,150},{1,100}]','掉落倍率,格式[{评分，倍率}](倍率用百分制，100%写成100)'),(3115,'encourage_data','{21000002,21000001,10,5,{0,38040101,1},{0,38040102,1}}','{大号角鼓舞的技能id,小唢呐鼓舞的技能id,总次数,单个次数,大号角消耗,小唢呐消耗} 玩家的鼓舞次数会当作技能等级使用'),(3115,'help_rewards','[{255,36160002,100}]','助战奖励:格式[{类型,物品id,数量}]'),(3116,'drop_rule','[{5,300},{4,250},{3,200},{2,150},{1,100}]','掉落倍率,格式[{评分，倍率}](倍率用百分制，100%写成100)'),(3116,'encourage_data','{21000002,21000001,10,5,{0,38040101,1},{0,38040102,1}}','{大号角鼓舞的技能id,小唢呐鼓舞的技能id,总次数,单个次数,大号角消耗,小唢呐消耗} 玩家的鼓舞次数会当作技能等级使用'),(3116,'help_rewards','[{255,36160002,100}]','助战奖励:格式[{类型,物品id,数量}]'),(3117,'drop_rule','[{5,300},{4,250},{3,200},{2,150},{1,100}]','掉落倍率,格式[{评分，倍率}](倍率用百分制，100%写成100)'),(3117,'encourage_data','{21000002,21000001,10,5,{0,38040101,1},{0,38040102,1}}','{大号角鼓舞的技能id,小唢呐鼓舞的技能id,总次数,单个次数,大号角消耗,小唢呐消耗} 玩家的鼓舞次数会当作技能等级使用'),(3117,'help_rewards','[{255,36160002,100}]','助战奖励:格式[{类型,物品id,数量}]'),(3118,'drop_rule','[{5,300},{4,250},{3,200},{2,150},{1,100}]','掉落倍率,格式[{评分，倍率}](倍率用百分制，100%写成100)'),(3118,'encourage_data','{21000002,21000001,10,5,{0,38040101,1},{0,38040102,1}}','{大号角鼓舞的技能id,小唢呐鼓舞的技能id,总次数,单个次数,大号角消耗,小唢呐消耗} 玩家的鼓舞次数会当作技能等级使用'),(3118,'help_rewards','[{255,36160002,100}]','助战奖励:格式[{类型,物品id,数量}]'),(3119,'drop_rule','[{5,300},{4,250},{3,200},{2,150},{1,100}]','掉落倍率,格式[{评分，倍率}](倍率用百分制，100%写成100)'),(3119,'encourage_data','{21000002,21000001,10,5,{0,38040101,1},{0,38040102,1}}','{大号角鼓舞的技能id,小唢呐鼓舞的技能id,总次数,单个次数,大号角消耗,小唢呐消耗} 玩家的鼓舞次数会当作技能等级使用'),(3119,'help_rewards','[{255,36160002,100}]','助战奖励:格式[{类型,物品id,数量}]'),(3120,'drop_rule','[{5,300},{4,250},{3,200},{2,150},{1,100}]','掉落倍率,格式[{评分，倍率}](倍率用百分制，100%写成100)'),(3120,'encourage_data','{21000002,21000001,10,5,{0,38040101,1},{0,38040102,1}}','{大号角鼓舞的技能id,小唢呐鼓舞的技能id,总次数,单个次数,大号角消耗,小唢呐消耗} 玩家的鼓舞次数会当作技能等级使用'),(3120,'help_rewards','[{255,36160002,100}]','助战奖励:格式[{类型,物品id,数量}]'),(3121,'drop_rule','[{5,300},{4,250},{3,200},{2,150},{1,100}]','掉落倍率,格式[{评分，倍率}](倍率用百分制，100%写成100)'),(3121,'encourage_data','{21000002,21000001,10,5,{0,38040101,1},{0,38040102,1}}','{大号角鼓舞的技能id,小唢呐鼓舞的技能id,总次数,单个次数,大号角消耗,小唢呐消耗} 玩家的鼓舞次数会当作技能等级使用'),(3121,'help_rewards','[{255,36160002,100}]','助战奖励:格式[{类型,物品id,数量}]'),(3122,'drop_rule','[{5,300},{4,250},{3,200},{2,150},{1,100}]','掉落倍率,格式[{评分，倍率}](倍率用百分制，100%写成100)'),(3122,'encourage_data','{21000002,21000001,10,5,{0,38040101,1},{0,38040102,1}}','{大号角鼓舞的技能id,小唢呐鼓舞的技能id,总次数,单个次数,大号角消耗,小唢呐消耗} 玩家的鼓舞次数会当作技能等级使用'),(3122,'help_rewards','[{255,36160002,100}]','助战奖励:格式[{类型,物品id,数量}]'),(3300,'dynamic_event_info','{0,10}','格式：{0,退出时间}'),(3300,'encourage_data','{21000002,21000001,10,5,{0,38040101,1},{0,38040102,1}}','{大号角鼓舞的技能id,小唢呐鼓舞的技能id,总次数,单个次数,大号角消耗,小唢呐消耗} 玩家的鼓舞次数会当作技能等级使用'),(3300,'help_rewards','[{255,36160002,100}]','助战奖励:格式[{类型,物品id,数量}]'),(3300,'zone_list','[{1,10505,3176},{2,7567,5221},{3,3288,9808},{4,7138,17240},{5,10678,10198},{6,17112,18086}]','[{区域, {X, Y}}]'),(3301,'dynamic_event_info','{0,10}','格式：{0,退出时间}'),(3301,'encourage_data','{21000002,21000001,10,5,{0,38040101,1},{0,38040102,1}}','{大号角鼓舞的技能id,小唢呐鼓舞的技能id,总次数,单个次数,大号角消耗,小唢呐消耗} 玩家的鼓舞次数会当作技能等级使用'),(3301,'help_rewards','[{255,36160002,100}]','助战奖励:格式[{类型,物品id,数量}]'),(3301,'zone_list','[{1,10505,3176},{2,7567,5221},{3,3288,9808},{4,7138,17240},{5,10678,10198},{6,17112,18086}]','[{区域, {X, Y}}]'),(3302,'dynamic_event_info','{0,10}','格式：{0,退出时间}'),(3302,'encourage_data','{21000002,21000001,10,5,{0,38040101,1},{0,38040102,1}}','{大号角鼓舞的技能id,小唢呐鼓舞的技能id,总次数,单个次数,大号角消耗,小唢呐消耗} 玩家的鼓舞次数会当作技能等级使用'),(3302,'help_rewards','[{255,36160002,100}]','助战奖励:格式[{类型,物品id,数量}]'),(3302,'zone_list','[{1,10505,3176},{2,7567,5221},{3,3288,9808},{4,7138,17240},{5,10678,10198},{6,17112,18086}]','[{区域, {X, Y}}]'),(3303,'dynamic_event_info','{0,10}','格式：{0,退出时间}'),(3303,'encourage_data','{21000002,21000001,10,5,{0,38040101,1},{0,38040102,1}}','{大号角鼓舞的技能id,小唢呐鼓舞的技能id,总次数,单个次数,大号角消耗,小唢呐消耗} 玩家的鼓舞次数会当作技能等级使用'),(3303,'help_rewards','[{255,36160002,100}]','助战奖励:格式[{类型,物品id,数量}]'),(3303,'zone_list','[{1,10505,3176},{2,7567,5221},{3,3288,9808},{4,7138,17240},{5,10678,10198},{6,17112,18086}]','[{区域, {X, Y}}]'),(3304,'dynamic_event_info','{0,10}','格式：{0,退出时间}'),(3304,'encourage_data','{21000002,21000001,10,5,{0,38040101,1},{0,38040102,1}}','{大号角鼓舞的技能id,小唢呐鼓舞的技能id,总次数,单个次数,大号角消耗,小唢呐消耗} 玩家的鼓舞次数会当作技能等级使用'),(3304,'help_rewards','[{255,36160002,100}]','助战奖励:格式[{类型,物品id,数量}]'),(3304,'zone_list','[{1,10505,3176},{2,7567,5221},{3,3288,9808},{4,7138,17240},{5,10678,10198},{6,17112,18086}]','[{区域, {X, Y}}]'),(4201,'encourage_data','{21000002,21000001,10,5,{0,38040101,1},{0,38040102,1}}','{大号角鼓舞的技能id,小唢呐鼓舞的技能id,总次数,单个次数,大号角消耗,小唢呐消耗} 玩家的鼓舞次数会当作技能等级使用'),(4201,'encourage_mon','{10,[{2,0,100}],500}','{怪物加固上限, 消耗, 每次加伤害减免百分比(万分比500则加5%)}'),(4201,'filter_ai','[4201111,4201112,4201121,4201122,4201131,4201132,4201141,4201142,4201151,4201152,4201161,4201162,4201171,4201172,4201181,4201182,4201211,4201212,4201221,4201222,4201231,4201232,4201241,4201242,4201251,4201252,4201261,4201262,4201271,4201272,4201281,4201282,4201311,4201312,4201321,4201322,4201331,4201332,4201341,4201342,4201351,4201352,4201361,4201362,4201371,4201372,4201381,4201382]','不打人的怪物id列表'),(4201,'guild_guard_lister','[4201100,4201101,4201102,4201103]','加固的怪物（基地等）格式：[怪物id]'),(5200,'couple_reply','[1,2,3,4,5,6]','默契答题题目:[题目id](具体文字内容配lua配置)'),(5200,'couple_rotate','[{100,200}]','转盘奖励倍数，格式：[{权重,倍数(用百分制,1.5倍则填150)}]'),(5200,'couple_skill','[21005200,21005201]','情侣技能id，格式[技能id]'),(5200,'double_rewards','[{2,36020001,80}]','结算双倍领取消耗'),(5200,'encourage_data','{21000002,21000001,10,5,{0,38040101,1},{0,38040102,1}}','{大号角鼓舞的技能id,小唢呐鼓舞的技能id,总次数,单个次数,大号角消耗,小唢呐消耗} 玩家的鼓舞次数会当作技能等级使用'),(5200,'help_rewards','[{255,36160002,100}]','助战奖励:格式[{类型,物品id,数量}]'),(5200,'mon_group','{[5200001,5200002,5200005,5200006],[{5200003,1},{5200004,3}]}','怪物分类,{[普通怪物id],[{花朵怪物id,清怪的波数}]}'),(5200,'skill_cost_score','[{21005200,4},{21005201,6}]','[{技能id,消耗恩爱分}]'),(5201,'couple_reply','[1,2,3,4,5,6]','默契答题题目:[题目id](具体文字内容配lua配置)'),(5201,'couple_rotate','[{100,200}]','转盘奖励倍数，格式：[{权重,倍数(用百分制,1.5倍则填150)}]'),(5201,'couple_skill','[21005200,21005201]','情侣技能id，格式[技能id]'),(5201,'double_rewards','[{2,36020001,100}]','结算双倍领取消耗'),(5201,'encourage_data','{21000002,21000001,10,5,{0,38040101,1},{0,38040102,1}}','{大号角鼓舞的技能id,小唢呐鼓舞的技能id,总次数,单个次数,大号角消耗,小唢呐消耗} 玩家的鼓舞次数会当作技能等级使用'),(5201,'help_rewards','[{255,36160002,100}]','助战奖励:格式[{类型,物品id,数量}]'),(5201,'mon_group','{[5201001,5201002,5201005,5201006],[{5201003,1},{5201004,3}]}','怪物分类,{[普通怪物id],[花朵怪物id]}'),(5201,'skill_cost_score','[{21005200,4},{21005201,6}]','[{技能id,消耗恩爱分}]'),(5202,'couple_reply','[1,2,3,4,5,6]','默契答题题目:[题目id](具体文字内容配lua配置)'),(5202,'couple_rotate','[{100,200}]','转盘奖励倍数，格式：[{权重,倍数(用百分制,1.5倍则填150)}]'),(5202,'couple_skill','[21005200,21005201]','情侣技能id，格式[技能id]'),(5202,'double_rewards','[{2,36020001,120}]','结算双倍领取消耗'),(5202,'encourage_data','{21000002,21000001,10,5,{0,38040101,1},{0,38040102,1}}','{大号角鼓舞的技能id,小唢呐鼓舞的技能id,总次数,单个次数,大号角消耗,小唢呐消耗} 玩家的鼓舞次数会当作技能等级使用'),(5202,'help_rewards','[{255,36160002,100}]','助战奖励:格式[{类型,物品id,数量}]'),(5202,'mon_group','{[5202001,5202002,5202005,5202006],[{5202003,1},{5202004,3}]}','怪物分类,{[普通怪物id],[花朵怪物id]}'),(5202,'skill_cost_score','[{21005200,4},{21005201,6}]','[{技能id,消耗恩爱分}]'),(5300,'encourage_data','{21000002,21000001,10,5,{0,38040101,1},{0,38040102,1}}','{钻石鼓舞的技能id,金币鼓舞的技能id,总次数,铜币次数,钻石消耗,金币消耗} 玩家的鼓舞次数会当作技能等级使用'),(5300,'helper_list','[{1001,53001001,2204,2306},{1002,53001002,2266,2214},{1003,53001003,2302,2143},{1004,53001004,2349,2060},{1005,53001005,2407,1986},{1006,53001006,2438,1888},{1007,53001007,2476,1825},{2001,53002001,2137,2172},{2002,53002002,2195,2074},{2003,53002003,2137,2172},{2004,53002004,2242,1946},{2005,53002005,2387,1711}]',''),(5300,'mon_lister','[5300400]','监听血量的怪物id'),(5301,'encourage_data','{21000002,21000001,10,5,{0,38040101,1},{0,38040102,1}}','{钻石鼓舞的技能id,金币鼓舞的技能id,总次数,铜币次数,钻石消耗,金币消耗} 玩家的鼓舞次数会当作技能等级使用'),(5301,'helper_list','[{1001,53001001,2204,2306},{1002,53001002,2266,2214},{1003,53001003,2302,2143},{1004,53001004,2349,2060},{1005,53001005,2407,1986},{1006,53001006,2438,1888},{1007,53001007,2476,1825},{2001,53002001,2137,2172},{2002,53002002,2195,2074},{2003,53002003,2137,2172},{2004,53002004,2242,1946},{2005,53002005,2387,1711}]',''),(5301,'mon_lister','[5301400]','监听血量的怪物id'),(5302,'encourage_data','{21000002,21000001,10,5,{0,38040101,1},{0,38040102,1}}','{钻石鼓舞的技能id,金币鼓舞的技能id,总次数,铜币次数,钻石消耗,金币消耗} 玩家的鼓舞次数会当作技能等级使用'),(5302,'helper_list','[{1001,53001001,2204,2306},{1002,53001002,2266,2214},{1003,53001003,2302,2143},{1004,53001004,2349,2060},{1005,53001005,2407,1986},{1006,53001006,2438,1888},{1007,53001007,2476,1825},{2001,53002001,2137,2172},{2002,53002002,2195,2074},{2003,53002003,2137,2172},{2004,53002004,2242,1946},{2005,53002005,2387,1711}]',''),(5302,'mon_lister','[5302400]','监听血量的怪物id'),(5303,'encourage_data','{21000002,21000001,10,5,{0,38040101,1},{0,38040102,1}}','{钻石鼓舞的技能id,金币鼓舞的技能id,总次数,铜币次数,钻石消耗,金币消耗} 玩家的鼓舞次数会当作技能等级使用'),(5303,'helper_list','[{1001,53001001,2204,2306},{1002,53001002,2266,2214},{1003,53001003,2302,2143},{1004,53001004,2349,2060},{1005,53001005,2407,1986},{1006,53001006,2438,1888},{1007,53001007,2476,1825},{2001,53002001,2137,2172},{2002,53002002,2195,2074},{2003,53002003,2137,2172},{2004,53002004,2242,1946},{2005,53002005,2387,1711}]',''),(5303,'mon_lister','[5303400]','监听血量的怪物id'),(5304,'encourage_data','{21000002,21000001,10,5,{0,38040101,1},{0,38040102,1}}','{钻石鼓舞的技能id,金币鼓舞的技能id,总次数,铜币次数,钻石消耗,金币消耗} 玩家的鼓舞次数会当作技能等级使用'),(5304,'helper_list','[{1001,53001001,2204,2306},{1002,53001002,2266,2214},{1003,53001003,2302,2143},{1004,53001004,2349,2060},{1005,53001005,2407,1986},{1006,53001006,2438,1888},{1007,53001007,2476,1825},{2001,53002001,2137,2172},{2002,53002002,2195,2074},{2003,53002003,2137,2172},{2004,53002004,2242,1946},{2005,53002005,2387,1711}]',''),(5304,'mon_lister','[5304400]','监听血量的怪物id'),(60000,'encourage_data','{21000002,21000001,10,5,{0,38040101,1},{0,38040102,1}}','{大号角鼓舞的技能id,小唢呐鼓舞的技能id,总次数,单个次数,大号角消耗,小唢呐消耗} 玩家的鼓舞次数会当作技能等级使用'),(60000,'filter_ai','[600001,600002,600003,600004,600005,600006,600007,600008,600009,600010,600011,600012,600013,600014,600015,600016,600017,600018]','不打人的怪物id列表,格式:[怪物id]'),(60000,'mon_lister','[600019]','监听水晶血量：[水晶id]'),(60001,'encourage_data','{21000002,21000001,10,5,{0,38040101,1},{0,38040102,1}}','{大号角鼓舞的技能id,小唢呐鼓舞的技能id,总次数,单个次数,大号角消耗,小唢呐消耗} 玩家的鼓舞次数会当作技能等级使用'),(60001,'filter_ai','[600021,600022,600023,600024,600025,600026,600027,600028,600029,600030,600031,600032,600033,600034,600035,600036,600037,600038]','不打人的怪物id列表,格式:[怪物id]'),(60001,'mon_lister','[600039]','监听水晶血量：[水晶id]'),(60002,'encourage_data','{21000002,21000001,10,5,{0,38040101,1},{0,38040102,1}}','{大号角鼓舞的技能id,小唢呐鼓舞的技能id,总次数,单个次数,大号角消耗,小唢呐消耗} 玩家的鼓舞次数会当作技能等级使用'),(60002,'filter_ai','[600041,600042,600043,600044,600045,600046,600047,600048,600049,600050,600051,600052,600053,600054,600055,600056,600057,600058]','不打人的怪物id列表,格式:[怪物id]'),(60002,'mon_lister','[600059]','监听水晶血量：[水晶id]'),(60003,'encourage_data','{21000002,21000001,10,5,{0,38040101,1},{0,38040102,1}}','{大号角鼓舞的技能id,小唢呐鼓舞的技能id,总次数,单个次数,大号角消耗,小唢呐消耗} 玩家的鼓舞次数会当作技能等级使用'),(60003,'filter_ai','[600061,600062,600063,600064,600065,600066,600067,600068,600069,600070,600071,600072,600073,600074,600075,600076,600077,600078]','不打人的怪物id列表,格式:[怪物id]'),(60003,'mon_lister','[600079]','监听水晶血量：[水晶id]'),(60004,'encourage_data','{21000002,21000001,10,5,{0,38040101,1},{0,38040102,1}}','{大号角鼓舞的技能id,小唢呐鼓舞的技能id,总次数,单个次数,大号角消耗,小唢呐消耗} 玩家的鼓舞次数会当作技能等级使用'),(60004,'filter_ai','[600081,600082,600083,600084,600085,600086,600087,600088,600089,600090,600091,600092,600093,600094,600095,600096,600097,600098]','不打人的怪物id列表,格式:[怪物id]'),(60004,'mon_lister','[600099]','监听水晶血量：[水晶id]'),(134116,'dummy_list','[1201000,1201001]','[假人id],监听复活事件');
/*!40000 ALTER TABLE `base_dungeon_special_cfg` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_dungeon_stage_daily_reward`
--

DROP TABLE IF EXISTS `base_dungeon_stage_daily_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_dungeon_stage_daily_reward` (
  `dun_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本类型',
  `reward_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励id',
  `need_level_min` int(11) NOT NULL DEFAULT '0' COMMENT '最低关卡/波数',
  `need_level` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最高关卡/波数',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励内容',
  PRIMARY KEY (`dun_type`,`reward_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_dungeon_stage_daily_reward`
--

LOCK TABLES `base_dungeon_stage_daily_reward` WRITE;
/*!40000 ALTER TABLE `base_dungeon_stage_daily_reward` DISABLE KEYS */;
INSERT INTO `base_dungeon_stage_daily_reward` VALUES (17,1,1,5,'[{255,36160007,399}]'),(17,2,6,10,'[{255,36160007,529}]'),(17,3,11,15,'[{255,36160007,590}]'),(17,4,16,20,'[{255,36160007,634}]'),(17,5,21,25,'[{255,36160007,667}]'),(17,6,26,30,'[{255,36160007,695}]'),(17,7,31,35,'[{255,36160007,719}]'),(17,8,36,40,'[{255,36160007,740}]'),(17,9,41,45,'[{255,36160007,760}]'),(17,10,46,50,'[{255,36160007,777}]'),(17,11,51,55,'[{255,36160007,792}]'),(17,12,56,60,'[{255,36160007,807}]'),(17,13,61,65,'[{255,36160007,821}]'),(17,14,66,70,'[{255,36160007,834}]'),(17,15,71,75,'[{255,36160007,846}]'),(17,16,76,80,'[{255,36160007,857}]'),(17,17,81,85,'[{255,36160007,868}]'),(17,18,86,90,'[{255,36160007,879}]'),(17,19,91,95,'[{255,36160007,888}]'),(17,20,96,100,'[{255,36160007,898}]');
/*!40000 ALTER TABLE `base_dungeon_stage_daily_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_dungeon_stage_reward`
--

DROP TABLE IF EXISTS `base_dungeon_stage_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_dungeon_stage_reward` (
  `dun_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本类型',
  `level` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '关卡/波数',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励内容',
  `second_reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '非首次奖励',
  `stage_reward` varchar(512) NOT NULL DEFAULT '[]' COMMENT '阶段奖励',
  `recommend_power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '推荐战力',
  `other` text NOT NULL COMMENT '其它条件',
  PRIMARY KEY (`dun_type`,`level`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_dungeon_stage_reward`
--

LOCK TABLES `base_dungeon_stage_reward` WRITE;
/*!40000 ALTER TABLE `base_dungeon_stage_reward` DISABLE KEYS */;
INSERT INTO `base_dungeon_stage_reward` VALUES (9,70001,'[{0,11070001,10}]','[{0,11070001,4}]','[]',0,'[{belong_tower,0,1}]'),(9,70002,'[{0,11070001,10}]','[{0,11070001,4}]','[]',20000,'[{belong_tower,0,2}]'),(9,70003,'[{0,11070001,10}]','[{0,11070001,4}]','[]',40000,'[{belong_tower,0,3}]'),(9,70004,'[{0,11070001,10}]','[{0,11070001,4}]','[]',60000,'[{belong_tower,0,4}]'),(9,70005,'[{0,11070010,1}]','[{0,11070001,5}]','[{0,55010001,1}]',80000,'[{belong_tower,0,5}]'),(9,70006,'[{0,11070001,12}]','[{0,11070001,5}]','[]',100000,'[{belong_tower,0,6}]'),(9,70007,'[{0,11070001,12}]','[{0,11070001,5}]','[]',120000,'[{belong_tower,0,7}]'),(9,70008,'[{0,11070001,12}]','[{0,11070001,5}]','[]',150000,'[{belong_tower,0,8}]'),(9,70009,'[{0,11070001,12}]','[{0,11070001,5}]','[]',180000,'[{belong_tower,0,9}]'),(9,70010,'[{0,11070010,2}]','[{0,11070001,6}]','[{0,55010002,1}]',210000,'[{belong_tower,0,10}]'),(9,70011,'[{0,11070001,14}]','[{0,11070001,6}]','[]',240000,'[{belong_tower,1,1}]'),(9,70012,'[{0,11070001,14}]','[{0,11070001,6}]','[]',270000,'[{belong_tower,1,2}]'),(9,70013,'[{0,11070001,14}]','[{0,11070001,6}]','[]',300000,'[{belong_tower,1,3}]'),(9,70014,'[{0,11070001,14}]','[{0,11070001,6}]','[]',350000,'[{belong_tower,1,4}]'),(9,70015,'[{0,11070010,3}]','[{0,11070001,7}]','[{0,55010003,1}]',400000,'[{belong_tower,1,5}]'),(9,70016,'[{0,11070001,16}]','[{0,11070001,7}]','[]',450000,'[{belong_tower,1,6}]'),(9,70017,'[{0,11070001,16}]','[{0,11070001,7}]','[]',500000,'[{belong_tower,1,7}]'),(9,70018,'[{0,11070001,16}]','[{0,11070001,7}]','[]',550000,'[{belong_tower,1,8}]'),(9,70019,'[{0,11070001,16}]','[{0,11070001,7}]','[]',600000,'[{belong_tower,1,9}]'),(9,70020,'[{0,11070010,4}]','[{0,11070001,8}]','[{0,55010001,1}]',650000,'[{belong_tower,1,10}]'),(9,70021,'[{0,11070001,18}]','[{0,11070001,8}]','[]',700000,'[{belong_tower,2,1}]'),(9,70022,'[{0,11070001,18}]','[{0,11070001,8}]','[]',750000,'[{belong_tower,2,2}]'),(9,70023,'[{0,11070001,18}]','[{0,11070001,8}]','[]',800000,'[{belong_tower,2,3}]'),(9,70024,'[{0,11070001,18}]','[{0,11070001,8}]','[]',850000,'[{belong_tower,2,4}]'),(9,70025,'[{0,11070010,5}]','[{0,11070001,9}]','[{0,55010002,1}]',900000,'[{belong_tower,2,5}]'),(9,70026,'[{0,11070001,20}]','[{0,11070001,9}]','[]',950000,'[{belong_tower,2,6}]'),(9,70027,'[{0,11070001,20}]','[{0,11070001,9}]','[]',1000000,'[{belong_tower,2,7}]'),(9,70028,'[{0,11070001,20}]','[{0,11070001,9}]','[]',1050000,'[{belong_tower,2,8}]'),(9,70029,'[{0,11070001,20}]','[{0,11070001,9}]','[]',1100000,'[{belong_tower,2,9}]'),(9,70030,'[{0,11070010,6}]','[{0,11070001,10}]','[{0,55010003,1}]',1150000,'[{belong_tower,2,10}]'),(9,70031,'[{0,11070001,22}]','[{0,11070001,10}]','[]',1220000,'[{belong_tower,3,1}]'),(9,70032,'[{0,11070001,22}]','[{0,11070001,10}]','[]',1290000,'[{belong_tower,3,2}]'),(9,70033,'[{0,11070001,22}]','[{0,11070001,10}]','[]',1360000,'[{belong_tower,3,3}]'),(9,70034,'[{0,11070001,22}]','[{0,11070001,10}]','[]',1430000,'[{belong_tower,3,4}]'),(9,70035,'[{0,11070010,7}]','[{0,11070001,11}]','[{0,55010001,2}]',1500000,'[{belong_tower,3,5}]'),(9,70036,'[{0,11070001,24}]','[{0,11070001,11}]','[]',1600000,'[{belong_tower,3,6}]'),(9,70037,'[{0,11070001,24}]','[{0,11070001,11}]','[]',1700000,'[{belong_tower,3,7}]'),(9,70038,'[{0,11070001,24}]','[{0,11070001,11}]','[]',1800000,'[{belong_tower,3,8}]'),(9,70039,'[{0,11070001,24}]','[{0,11070001,11}]','[]',1900000,'[{belong_tower,3,9}]'),(9,70040,'[{0,11070010,8}]','[{0,11070001,12}]','[{0,55010002,2}]',2000000,'[{belong_tower,3,10}]'),(9,70041,'[{0,11070001,26}]','[{0,11070001,12}]','[]',2100000,'[{belong_tower,4,1}]'),(9,70042,'[{0,11070001,26}]','[{0,11070001,12}]','[]',2200000,'[{belong_tower,4,2}]'),(9,70043,'[{0,11070001,26}]','[{0,11070001,12}]','[]',2300000,'[{belong_tower,4,3}]'),(9,70044,'[{0,11070001,26}]','[{0,11070001,12}]','[]',2400000,'[{belong_tower,4,4}]'),(9,70045,'[{0,11070010,9}]','[{0,11070001,13}]','[{0,55010003,2}]',2500000,'[{belong_tower,4,5}]'),(9,70046,'[{0,11070001,28}]','[{0,11070001,13}]','[]',2600000,'[{belong_tower,4,6}]'),(9,70047,'[{0,11070001,28}]','[{0,11070001,13}]','[]',2700000,'[{belong_tower,4,7}]'),(9,70048,'[{0,11070001,28}]','[{0,11070001,13}]','[]',2800000,'[{belong_tower,4,8}]'),(9,70049,'[{0,11070001,28}]','[{0,11070001,13}]','[]',2900000,'[{belong_tower,4,9}]'),(9,70050,'[{0,11070010,10}]','[{0,11070001,14}]','[{0,55010001,3}]',3000000,'[{belong_tower,4,10}]'),(9,70051,'[{0,11070001,30}]','[{0,11070001,14}]','[]',3150000,'[{belong_tower,5,1}]'),(9,70052,'[{0,11070001,30}]','[{0,11070001,14}]','[]',3300000,'[{belong_tower,5,2}]'),(9,70053,'[{0,11070001,30}]','[{0,11070001,14}]','[]',3450000,'[{belong_tower,5,3}]'),(9,70054,'[{0,11070001,30}]','[{0,11070001,14}]','[]',3600000,'[{belong_tower,5,4}]'),(9,70055,'[{0,11070010,11}]','[{0,11070001,15}]','[{0,55010002,3}]',3750000,'[{belong_tower,5,5}]'),(9,70056,'[{0,11070001,32}]','[{0,11070001,15}]','[]',3900000,'[{belong_tower,5,6}]'),(9,70057,'[{0,11070001,32}]','[{0,11070001,15}]','[]',4050000,'[{belong_tower,5,7}]'),(9,70058,'[{0,11070001,32}]','[{0,11070001,15}]','[]',4200000,'[{belong_tower,5,8}]'),(9,70059,'[{0,11070001,32}]','[{0,11070001,15}]','[]',4350000,'[{belong_tower,5,9}]'),(9,70060,'[{0,11070010,12}]','[{0,11070001,16}]','[{0,55010003,3}]',4500000,'[{belong_tower,5,10}]'),(9,70061,'[{0,11070001,34}]','[{0,11070001,16}]','[]',4650000,'[{belong_tower,6,1}]'),(9,70062,'[{0,11070001,34}]','[{0,11070001,16}]','[]',4800000,'[{belong_tower,6,2}]'),(9,70063,'[{0,11070001,34}]','[{0,11070001,16}]','[]',4950000,'[{belong_tower,6,3}]'),(9,70064,'[{0,11070001,34}]','[{0,11070001,16}]','[]',5100000,'[{belong_tower,6,4}]'),(9,70065,'[{0,11070010,13}]','[{0,11070001,17}]','[{0,55010001,4}]',5250000,'[{belong_tower,6,5}]'),(9,70066,'[{0,11070001,36}]','[{0,11070001,17}]','[]',5400000,'[{belong_tower,6,6}]'),(9,70067,'[{0,11070001,36}]','[{0,11070001,17}]','[]',5550000,'[{belong_tower,6,7}]'),(9,70068,'[{0,11070001,36}]','[{0,11070001,17}]','[]',5700000,'[{belong_tower,6,8}]'),(9,70069,'[{0,11070001,36}]','[{0,11070001,17}]','[]',5850000,'[{belong_tower,6,9}]'),(9,70070,'[{0,11070010,14}]','[{0,11070001,18}]','[{0,55010002,4}]',6000000,'[{belong_tower,6,10}]'),(9,70071,'[{0,11070001,38}]','[{0,11070001,18}]','[]',6200000,'[{belong_tower,7,1}]'),(9,70072,'[{0,11070001,38}]','[{0,11070001,18}]','[]',6400000,'[{belong_tower,7,2}]'),(9,70073,'[{0,11070001,38}]','[{0,11070001,18}]','[]',6600000,'[{belong_tower,7,3}]'),(9,70074,'[{0,11070001,38}]','[{0,11070001,18}]','[]',6800000,'[{belong_tower,7,4}]'),(9,70075,'[{0,11070010,15}]','[{0,11070001,19}]','[{0,55010003,4}]',7000000,'[{belong_tower,7,5}]'),(9,70076,'[{0,11070001,40}]','[{0,11070001,19}]','[]',7200000,'[{belong_tower,7,6}]'),(9,70077,'[{0,11070001,40}]','[{0,11070001,19}]','[]',7400000,'[{belong_tower,7,7}]'),(9,70078,'[{0,11070001,40}]','[{0,11070001,19}]','[]',7600000,'[{belong_tower,7,8}]'),(9,70079,'[{0,11070001,40}]','[{0,11070001,19}]','[]',7800000,'[{belong_tower,7,9}]'),(9,70080,'[{0,11070010,16}]','[{0,11070001,20}]','[{0,55010001,6}]',8000000,'[{belong_tower,7,10}]'),(9,70081,'[{0,11070001,42}]','[{0,11070001,20}]','[]',8200000,'[{belong_tower,8,1}]'),(9,70082,'[{0,11070001,42}]','[{0,11070001,20}]','[]',8400000,'[{belong_tower,8,2}]'),(9,70083,'[{0,11070001,42}]','[{0,11070001,20}]','[]',8600000,'[{belong_tower,8,3}]'),(9,70084,'[{0,11070001,42}]','[{0,11070001,20}]','[]',8800000,'[{belong_tower,8,4}]'),(9,70085,'[{0,11070010,17}]','[{0,11070001,21}]','[{0,55010002,6}]',9000000,'[{belong_tower,8,5}]'),(9,70086,'[{0,11070001,44}]','[{0,11070001,21}]','[]',9200000,'[{belong_tower,8,6}]'),(9,70087,'[{0,11070001,44}]','[{0,11070001,21}]','[]',9400000,'[{belong_tower,8,7}]'),(9,70088,'[{0,11070001,44}]','[{0,11070001,21}]','[]',9600000,'[{belong_tower,8,8}]'),(9,70089,'[{0,11070001,44}]','[{0,11070001,21}]','[]',9800000,'[{belong_tower,8,9}]'),(9,70090,'[{0,11070010,18}]','[{0,11070001,22}]','[{0,55010003,6}]',10000000,'[{belong_tower,8,10}]'),(9,70091,'[{0,11070001,46}]','[{0,11070001,22}]','[]',10200000,'[{belong_tower,9,1}]'),(9,70092,'[{0,11070001,46}]','[{0,11070001,22}]','[]',10400000,'[{belong_tower,9,2}]'),(9,70093,'[{0,11070001,46}]','[{0,11070001,22}]','[]',10600000,'[{belong_tower,9,3}]'),(9,70094,'[{0,11070001,46}]','[{0,11070001,22}]','[]',10800000,'[{belong_tower,9,4}]'),(9,70095,'[{0,11070010,19}]','[{0,11070001,23}]','[{0,55010001,7}]',11000000,'[{belong_tower,9,5}]'),(9,70096,'[{0,11070001,48}]','[{0,11070001,23}]','[]',11200000,'[{belong_tower,9,6}]'),(9,70097,'[{0,11070001,48}]','[{0,11070001,23}]','[]',11400000,'[{belong_tower,9,7}]'),(9,70098,'[{0,11070001,48}]','[{0,11070001,23}]','[]',11600000,'[{belong_tower,9,8}]'),(9,70099,'[{0,11070001,48}]','[{0,11070001,23}]','[]',11800000,'[{belong_tower,9,9}]'),(9,70100,'[{0,11070010,20}]','[{0,11070001,24}]','[{0,55010002,7}]',12000000,'[{belong_tower,9,10}]'),(9,70101,'[{0,11070001,50}]','[{0,11070001,24}]','[]',12200000,'[{belong_tower,10,1}]'),(9,70102,'[{0,11070001,50}]','[{0,11070001,24}]','[]',12400000,'[{belong_tower,10,2}]'),(9,70103,'[{0,11070001,50}]','[{0,11070001,24}]','[]',12600000,'[{belong_tower,10,3}]'),(9,70104,'[{0,11070001,50}]','[{0,11070001,24}]','[]',12800000,'[{belong_tower,10,4}]'),(9,70105,'[{0,11070010,21}]','[{0,11070001,25}]','[{0,55010003,7}]',13000000,'[{belong_tower,10,5}]'),(9,70106,'[{0,11070001,52}]','[{0,11070001,25}]','[]',13200000,'[{belong_tower,10,6}]'),(9,70107,'[{0,11070001,52}]','[{0,11070001,25}]','[]',13400000,'[{belong_tower,10,7}]'),(9,70108,'[{0,11070001,52}]','[{0,11070001,25}]','[]',13600000,'[{belong_tower,10,8}]'),(9,70109,'[{0,11070001,52}]','[{0,11070001,25}]','[]',13800000,'[{belong_tower,10,9}]'),(9,70110,'[{0,11070010,22}]','[{0,11070001,26}]','[{0,55010001,8}]',14000000,'[{belong_tower,10,10}]'),(9,70111,'[{0,11070001,54}]','[{0,11070001,26}]','[]',14200000,'[{belong_tower,11,1}]'),(9,70112,'[{0,11070001,54}]','[{0,11070001,26}]','[]',14400000,'[{belong_tower,11,2}]'),(9,70113,'[{0,11070001,54}]','[{0,11070001,26}]','[]',14600000,'[{belong_tower,11,3}]'),(9,70114,'[{0,11070001,54}]','[{0,11070001,26}]','[]',14800000,'[{belong_tower,11,4}]'),(9,70115,'[{0,11070010,23}]','[{0,11070001,27}]','[{0,55010002,8}]',15000000,'[{belong_tower,11,5}]'),(9,70116,'[{0,11070001,56}]','[{0,11070001,27}]','[]',15200000,'[{belong_tower,11,6}]'),(9,70117,'[{0,11070001,56}]','[{0,11070001,27}]','[]',15400000,'[{belong_tower,11,7}]'),(9,70118,'[{0,11070001,56}]','[{0,11070001,27}]','[]',15600000,'[{belong_tower,11,8}]'),(9,70119,'[{0,11070001,56}]','[{0,11070001,27}]','[]',15800000,'[{belong_tower,11,9}]'),(9,70120,'[{0,11070010,24}]','[{0,11070001,28}]','[{0,55010003,8}]',16000000,'[{belong_tower,11,10}]'),(17,1,'[{0,54010001,1}]','[{0,54010001,1}]','[]',2625425,'[{back_wave,0},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,2,'[{0,54040001,1}]','[{0,54040001,1}]','[{0,54010001,3}]',2707376,'[{back_wave,0},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,3,'[{0,54010001,1}]','[{0,54010001,1}]','[]',2804328,'[{back_wave,0},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,4,'[{0,54040001,1}]','[{0,54040001,1}]','[{0,54040001,3}]',2901280,'[{back_wave,0},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,5,'[{0,54010001,1}]','[{0,54010001,1}]','[{0,54060101,5}]',2983232,'[{back_wave,5},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,6,'[{0,54040001,1}]','[{0,54040001,1}]','[{0,54010001,5}]',3065184,'[{back_wave,5},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,7,'[{0,54010001,1}]','[{0,54010001,1}]','[]',3147135,'[{back_wave,5},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,8,'[{0,54040001,1}]','[{0,54040001,1}]','[{0,54040001,5}]',3229087,'[{back_wave,5},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,9,'[{0,54010001,1}]','[{0,54010001,1}]','[]',3311039,'[{back_wave,5},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,10,'[{0,54040001,1}]','[{0,54040001,1}]','[{0,54060101,5}]',3392991,'[{back_wave,10},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,11,'[{0,54010001,1}]','[{0,54010001,1}]','[]',3474942,'[{back_wave,10},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,12,'[{0,54040001,1}]','[{0,54040001,1}]','[{0,54010001,8}]',3584211,'[{back_wave,10},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,13,'[{0,54010001,1}]','[{0,54010001,1}]','[]',3693480,'[{back_wave,10},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,14,'[{0,54040001,1}]','[{0,54040001,1}]','[{0,54040001,8}]',3828329,'[{back_wave,10},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,15,'[{0,54010001,1}]','[{0,54010001,1}]','[{0,54060101,5}]',3988756,'[{back_wave,15},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,16,'[{0,54040001,1}]','[{0,54040001,1}]','[{0,54010001,12}]',4149183,'[{back_wave,15},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,17,'[{0,54010001,1}]','[{0,54010001,1}]','[]',4309611,'[{back_wave,15},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,18,'[{0,54040001,1}]','[{0,54040001,1}]','[{0,54040001,12}]',4470038,'[{back_wave,15},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,19,'[{0,54010001,1}]','[{0,54010001,1}]','[]',4630465,'[{back_wave,15},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,20,'[{0,54040001,1}]','[{0,54040001,1}]','[{0,54060101,5}]',4790893,'[{back_wave,20},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,21,'[{0,54010001,1}]','[{0,54010001,1}]','[]',4951320,'[{back_wave,20},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,22,'[{0,54040001,1}]','[{0,54040001,1}]','[{0,54010001,16}]',5151854,'[{back_wave,20},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,23,'[{0,54010001,1}]','[{0,54010001,1}]','[]',5352389,'[{back_wave,20},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,24,'[{0,54040001,1}]','[{0,54040001,1}]','[{0,54040001,16}]',5552923,'[{back_wave,20},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,25,'[{0,54010001,1}]','[{0,54010001,1}]','[{0,54060101,5}]',5753457,'[{back_wave,25},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,26,'[{0,54040001,1}]','[{0,54040001,1}]','[{0,54010001,20}]',5926700,'[{back_wave,25},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,27,'[{0,54010001,1}]','[{0,54010001,1}]','[]',6099944,'[{back_wave,25},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,28,'[{0,54040001,1}]','[{0,54040001,1}]','[{0,54040001,20}]',6273187,'[{back_wave,25},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,29,'[{0,54010001,1}]','[{0,54010001,1}]','[]',6446430,'[{back_wave,25},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,30,'[{0,54040001,1}]','[{0,54040001,1}]','[{0,54060101,5}]',6619674,'[{back_wave,30},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,31,'[{0,54010001,1}]','[{0,54010001,1}]','[]',6792917,'[{back_wave,30},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,32,'[{0,54040001,1}]','[{0,54040001,1}]','[{0,54010001,24}]',6966160,'[{back_wave,30},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,33,'[{0,54010001,1}]','[{0,54010001,1}]','[]',7139403,'[{back_wave,30},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,34,'[{0,54040001,1}]','[{0,54040001,1}]','[{0,54040001,24}]',7312647,'[{back_wave,30},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,35,'[{0,54010001,1}]','[{0,54010001,1}]','[{0,54060101,5}]',7485890,'[{back_wave,35},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,36,'[{0,54040001,1}]','[{0,54040001,1}]','[{0,54010001,28}]',7749896,'[{back_wave,35},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,37,'[{0,54010001,1}]','[{0,54010001,1}]','[]',8013903,'[{back_wave,35},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,38,'[{0,54040001,1}]','[{0,54040001,1}]','[{0,54040001,28}]',8277909,'[{back_wave,35},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,39,'[{0,54010001,1}]','[{0,54010001,1}]','[]',8541915,'[{back_wave,35},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,40,'[{0,54040001,1}]','[{0,54040001,1}]','[{0,54060101,5}]',8805922,'[{back_wave,40},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,41,'[{0,54010001,1}]','[{0,54010001,1}]','[]',9069928,'[{back_wave,40},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,42,'[{0,54040001,1}]','[{0,54040001,1}]','[{0,54010001,32}]',9333934,'[{back_wave,40},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,43,'[{0,54010001,1}]','[{0,54010001,1}]','[]',9597940,'[{back_wave,40},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,44,'[{0,54040001,1}]','[{0,54040001,1}]','[{0,54040001,32}]',9861947,'[{back_wave,40},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,45,'[{0,54010001,1}]','[{0,54010001,1}]','[{0,54060101,5}]',10125953,'[{back_wave,45},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,46,'[{0,54040001,1}]','[{0,54040001,1}]','[{0,54010001,36}]',10525359,'[{back_wave,45},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,47,'[{0,54010001,1}]','[{0,54010001,1}]','[]',10924764,'[{back_wave,45},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,48,'[{0,54040001,1}]','[{0,54040001,1}]','[{0,54040001,36}]',11324170,'[{back_wave,45},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,49,'[{0,54010001,1}]','[{0,54010001,1}]','[]',11723576,'[{back_wave,45},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,50,'[{0,54040001,1}]','[{0,54040001,1}]','[{0,54060101,5}]',12122982,'[{back_wave,50},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,51,'[{0,54010001,2}]','[{0,54010001,2}]','[]',12522387,'[{back_wave,50},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,52,'[{0,54040001,2}]','[{0,54040001,2}]','[{0,54010002,15}]',12921793,'[{back_wave,50},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,53,'[{0,54010001,2}]','[{0,54010001,2}]','[]',13321199,'[{back_wave,50},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,54,'[{0,54040001,2}]','[{0,54040001,2}]','[{0,54040002,15}]',13712155,'[{back_wave,50},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,55,'[{0,54010001,2}]','[{0,54010001,2}]','[{0,54060101,5}]',14098886,'[{back_wave,55},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,56,'[{0,54040001,2}]','[{0,54040001,2}]','[{0,54010002,18}]',14485617,'[{back_wave,55},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,57,'[{0,54010001,2}]','[{0,54010001,2}]','[]',14872348,'[{back_wave,55},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,58,'[{0,54040001,2}]','[{0,54040001,2}]','[{0,54040002,18}]',15259079,'[{back_wave,55},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,59,'[{0,54010001,2}]','[{0,54010001,2}]','[]',15645810,'[{back_wave,55},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,60,'[{0,54040001,2}]','[{0,54040001,2}]','[{0,54060101,5}]',16032541,'[{back_wave,60},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,61,'[{0,54010001,2}]','[{0,54010001,2}]','[]',16548183,'[{back_wave,60},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,62,'[{0,54040001,2}]','[{0,54040001,2}]','[{0,54010002,21}]',17130966,'[{back_wave,60},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,63,'[{0,54010001,2}]','[{0,54010001,2}]','[]',17736131,'[{back_wave,60},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,64,'[{0,54040001,2}]','[{0,54040001,2}]','[{0,54040002,21}]',18341295,'[{back_wave,60},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,65,'[{0,54010001,2}]','[{0,54010001,2}]','[{0,54060101,5}]',18946460,'[{back_wave,65},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,66,'[{0,54040001,2}]','[{0,54040001,2}]','[{0,54010002,24}]',19551624,'[{back_wave,65},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,67,'[{0,54010001,2}]','[{0,54010001,2}]','[]',20156789,'[{back_wave,65},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,68,'[{0,54040001,2}]','[{0,54040001,2}]','[{0,54040002,24}]',20799047,'[{back_wave,65},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,69,'[{0,54010001,2}]','[{0,54010001,2}]','[]',21478400,'[{back_wave,65},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,70,'[{0,54040001,2}]','[{0,54040001,2}]','[{0,54060101,5}]',22157753,'[{back_wave,70},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,71,'[{0,54010001,2}]','[{0,54010001,2}]','[]',22837106,'[{back_wave,70},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,72,'[{0,54040001,2}]','[{0,54040001,2}]','[{0,54010002,27}]',23516459,'[{back_wave,70},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,73,'[{0,54010001,2}]','[{0,54010001,2}]','[]',24195812,'[{back_wave,70},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,74,'[{0,54040001,2}]','[{0,54040001,2}]','[{0,54040002,27}]',24858896,'[{back_wave,70},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,75,'[{0,54010001,2}]','[{0,54010001,2}]','[{0,54060101,5}]',25473172,'[{back_wave,75},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,76,'[{0,54040001,2}]','[{0,54040001,2}]','[{0,54010002,30}]',26087448,'[{back_wave,75},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,77,'[{0,54010001,2}]','[{0,54010001,2}]','[]',26701725,'[{back_wave,75},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,78,'[{0,54040001,2}]','[{0,54040001,2}]','[{0,54040002,30}]',27316001,'[{back_wave,75},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,79,'[{0,54010001,2}]','[{0,54010001,2}]','[]',27930277,'[{back_wave,75},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,80,'[{0,54040001,3}]','[{0,54040001,3}]','[{0,54060101,5}]',28544553,'[{back_wave,80},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,81,'[{0,54010001,3}]','[{0,54010001,3}]','[]',29250400,'[{back_wave,80},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,82,'[{0,54040001,3}]','[{0,54040001,3}]','[{0,54010003,12}]',29956247,'[{back_wave,80},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,83,'[{0,54010001,3}]','[{0,54010001,3}]','[]',30662094,'[{back_wave,80},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,84,'[{0,54040001,3}]','[{0,54040001,3}]','[{0,54040003,12}]',31367941,'[{back_wave,80},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,85,'[{0,54010001,3}]','[{0,54010001,3}]','[{0,54060101,5}]',32073788,'[{back_wave,85},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,86,'[{0,54040001,3}]','[{0,54040001,3}]','[{0,54010003,15}]',33034584,'[{back_wave,85},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,87,'[{0,54010001,3}]','[{0,54010001,3}]','[]',34024172,'[{back_wave,85},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,88,'[{0,54040001,3}]','[{0,54040001,3}]','[{0,54040003,15}]',35043391,'[{back_wave,85},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,89,'[{0,54010001,3}]','[{0,54010001,3}]','[]',36093261,'[{back_wave,85},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,90,'[{0,54040001,3}]','[{0,54040001,3}]','[{0,54060101,5}]',37174551,'[{back_wave,90},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,91,'[{0,54010001,3}]','[{0,54010001,3}]','[]',38288293,'[{back_wave,90},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,92,'[{0,54040001,3}]','[{0,54040001,3}]','[{0,54010003,18}]',39435437,'[{back_wave,90},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,93,'[{0,54010001,3}]','[{0,54010001,3}]','[]',40617036,'[{back_wave,90},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,94,'[{0,54040001,3}]','[{0,54040001,3}]','[{0,54040003,18}]',41834002,'[{back_wave,90},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,95,'[{0,54010001,3}]','[{0,54010001,3}]','[{0,54060101,5}]',43087575,'[{back_wave,95},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,96,'[{0,54040001,3}]','[{0,54040001,3}]','[{0,54010003,21}]',44378735,'[{back_wave,95},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,97,'[{0,54010001,3}]','[{0,54010001,3}]','[]',45708582,'[{back_wave,95},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,98,'[{0,54040001,3}]','[{0,54040001,3}]','[{0,54040003,21}]',47078390,'[{back_wave,95},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,99,'[{0,54010001,3}]','[{0,54010001,3}]','[]',48489228,'[{back_wave,95},{score_list,[{0,2,5},{3,9999,0}]}]'),(17,100,'[{0,54040001,3}]','[{0,54040001,3}]','[{0,54060101,5}]',49942405,'[{back_wave,100},{score_list,[{0,2,5},{3,9999,0}]}]');
/*!40000 ALTER TABLE `base_dungeon_stage_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_dungeon_sweep_rewards`
--

DROP TABLE IF EXISTS `base_dungeon_sweep_rewards`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_dungeon_sweep_rewards` (
  `dun_id` int(10) unsigned NOT NULL COMMENT '副本id',
  `score_min` int(10) unsigned NOT NULL COMMENT '记录范围下限',
  `score_max` int(10) unsigned NOT NULL COMMENT '记录范围上限',
  `rewards` text NOT NULL COMMENT '奖励内容 ',
  `must_rewards_show` varchar(255) NOT NULL DEFAULT '[]' COMMENT '必得奖励（展示）',
  `rand_rewards_show` varchar(255) NOT NULL DEFAULT '[]' COMMENT '随机奖励（展示）',
  PRIMARY KEY (`dun_id`,`score_min`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='扫荡奖励配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_dungeon_sweep_rewards`
--

LOCK TABLES `base_dungeon_sweep_rewards` WRITE;
/*!40000 ALTER TABLE `base_dungeon_sweep_rewards` DISABLE KEYS */;
INSERT INTO `base_dungeon_sweep_rewards` VALUES (5300,5,5,'[{0,18020001,15}]','[]','[]'),(5301,5,5,'[{0,18020001,25}]','[]','[]'),(5302,5,5,'[{0,18020001,15},{0,18020002,5}]','[]','[]'),(5303,5,5,'[{0,18020002,15}]','[]','[]'),(5304,5,5,'[{0,18020002,9},{0,18020003,5}]','[]','[]'),(5400,5,5,'[{0,11020001,10}]','[]','[]'),(5401,5,5,'[{0,11020001,20}]','[]','[]'),(5402,5,5,'[{0,11020001,14},{0,11020002,5}]','[]','[]'),(5403,5,5,'[{0,11020002,15}]','[]','[]'),(5404,5,5,'[{0,11020002,10},{0,11020003,5}]','[]','[]'),(5900,0,0,'[{255,36160007,500}]','[{255,36160007,500}]','[]'),(5901,0,0,'[{255,36160007,700}]','[{255,36160007,700}]','[]'),(5902,0,0,'[{255,36160007,900}]','[{255,36160007,900}]','[]'),(5903,0,0,'[{255,36160007,1100}]','[{255,36160007,1100}]','[]'),(5904,0,0,'[{255,36160007,1300}]','[{255,36160007,1300}]','[]'),(5905,0,0,'[{255,36160007,1500}]','[{255,36160007,1500}]','[]'),(5906,0,0,'[{255,36160007,1700}]','[{255,36160007,1700}]','[]'),(5907,0,0,'[{255,36160007,1900}]','[{255,36160007,1900}]','[]'),(5908,0,0,'[{255,36160007,2100}]','[{255,36160007,2100}]','[]'),(5909,0,0,'[{255,36160007,2800}]','[{255,36160007,2800}]','[]'),(5910,0,0,'[{255,36160007,3500}]','[{255,36160007,3500}]','[]'),(5911,0,0,'[{255,36160007,4200}]','[{255,36160007,4200}]','[]'),(5912,0,0,'[{255,36160007,4900}]','[{255,36160007,4900}]','[]'),(5913,0,0,'[{255,36160007,5200}]','[{255,36160007,5200}]','[]'),(5914,0,0,'[{255,36160007,5500}]','[{255,36160007,5500}]','[]'),(5915,0,0,'[{255,36160007,5800}]','[{255,36160007,5800}]','[]'),(5916,0,0,'[{255,36160007,6100}]','[{255,36160007,6100}]','[]'),(5917,0,0,'[{255,36160007,6400}]','[{255,36160007,6400}]','[]'),(5918,0,0,'[{255,36160007,6700}]','[{255,36160007,6700}]','[]'),(5919,0,0,'[{255,36160007,7000}]','[{255,36160007,7000}]','[]'),(5920,0,0,'[{255,36160007,7300}]','[{255,36160007,7300}]','[]'),(5921,0,0,'[{255,36160007,7600}]','[{255,36160007,7600}]','[]'),(5922,0,0,'[{255,36160007,7800}]','[{255,36160007,7800}]','[]'),(5923,0,0,'[{255,36160007,8100}]','[{255,36160007,8100}]','[]'),(5924,0,0,'[{255,36160007,8400}]','[{255,36160007,8400}]','[]'),(5925,0,0,'[{255,36160007,8700}]','[{255,36160007,8700}]','[]'),(5926,0,0,'[{255,36160007,9000}]','[{255,36160007,9000}]','[]'),(5927,0,0,'[{255,36160007,9300}]','[{255,36160007,9300}]','[]'),(5928,0,0,'[{255,36160007,9600}]','[{255,36160007,9600}]','[]'),(5929,0,0,'[{255,36160007,9900}]','[{255,36160007,9900}]','[]'),(5930,0,0,'[{255,36160007,10100}]','[{255,36160007,10100}]','[]'),(5931,0,0,'[{255,36160007,10400}]','[{255,36160007,10400}]','[]'),(5932,0,0,'[{255,36160007,10700}]','[{255,36160007,10700}]','[]'),(5933,0,0,'[{255,36160007,11000}]','[{255,36160007,11000}]','[]'),(5934,0,0,'[{255,36160007,11300}]','[{255,36160007,11300}]','[]'),(5935,0,0,'[{255,36160007,11600}]','[{255,36160007,11600}]','[]'),(5936,0,0,'[{255,36160007,11900}]','[{255,36160007,11900}]','[]'),(5937,0,0,'[{255,36160007,12200}]','[{255,36160007,12200}]','[]'),(5938,0,0,'[{255,36160007,12400}]','[{255,36160007,12400}]','[]'),(5939,0,0,'[{255,36160007,12700}]','[{255,36160007,12700}]','[]'),(5940,0,0,'[{255,36160007,13000}]','[{255,36160007,13000}]','[]'),(5941,0,0,'[{255,36160007,13300}]','[{255,36160007,13300}]','[]'),(5942,0,0,'[{255,36160007,13600}]','[{255,36160007,13600}]','[]'),(5943,0,0,'[{255,36160007,13900}]','[{255,36160007,13900}]','[]'),(5944,0,0,'[{255,36160007,14200}]','[{255,36160007,14200}]','[]'),(5945,0,0,'[{255,36160007,14500}]','[{255,36160007,14500}]','[]'),(5946,0,0,'[{255,36160007,14700}]','[{255,36160007,14700}]','[]'),(5947,0,0,'[{255,36160007,15000}]','[{255,36160007,15000}]','[]'),(5948,0,0,'[{255,36160007,15300}]','[{255,36160007,15300}]','[]'),(5949,0,0,'[{255,36160007,15600}]','[{255,36160007,15600}]','[]'),(5950,0,0,'[{255,36160007,15900}]','[{255,36160007,15900}]','[]'),(5951,0,0,'[{255,36160007,16200}]','[{255,36160007,16200}]','[]'),(5952,0,0,'[{255,36160007,16500}]','[{255,36160007,16500}]','[]'),(5953,0,0,'[{255,36160007,16800}]','[{255,36160007,16800}]','[]'),(5954,0,0,'[{255,36160007,17100}]','[{255,36160007,17100}]','[]'),(5955,0,0,'[{255,36160007,17300}]','[{255,36160007,17300}]','[]'),(5956,0,0,'[{255,36160007,17600}]','[{255,36160007,17600}]','[]'),(5957,0,0,'[{255,36160007,17900}]','[{255,36160007,17900}]','[]'),(5958,0,0,'[{255,36160007,18200}]','[{255,36160007,18200}]','[]'),(5959,0,0,'[{255,36160007,18500}]','[{255,36160007,18500}]','[]'),(5960,0,0,'[{255,36160007,18800}]','[{255,36160007,18800}]','[]'),(5961,0,0,'[{255,36160007,19100}]','[{255,36160007,19100}]','[]'),(5962,0,0,'[{255,36160007,19400}]','[{255,36160007,19400}]','[]'),(5963,0,0,'[{255,36160007,19600}]','[{255,36160007,19600}]','[]'),(5964,0,0,'[{255,36160007,19900}]','[{255,36160007,19900}]','[]'),(5965,0,0,'[{255,36160007,20200}]','[{255,36160007,20200}]','[]'),(5966,0,0,'[{255,36160007,20500}]','[{255,36160007,20500}]','[]'),(5967,0,0,'[{255,36160007,20800}]','[{255,36160007,20800}]','[]'),(5968,0,0,'[{255,36160007,21100}]','[{255,36160007,21100}]','[]'),(5969,0,0,'[{255,36160007,21400}]','[{255,36160007,21400}]','[]'),(5970,0,0,'[{255,36160007,21700}]','[{255,36160007,21700}]','[]'),(5971,0,0,'[{255,36160007,21900}]','[{255,36160007,21900}]','[]'),(5972,0,0,'[{255,36160007,22200}]','[{255,36160007,22200}]','[]'),(5973,0,0,'[{255,36160007,22500}]','[{255,36160007,22500}]','[]'),(5974,0,0,'[{255,36160007,22800}]','[{255,36160007,22800}]','[]'),(5975,0,0,'[{255,36160007,23100}]','[{255,36160007,23100}]','[]'),(5976,0,0,'[{255,36160007,23400}]','[{255,36160007,23400}]','[]'),(5977,0,0,'[{255,36160007,23700}]','[{255,36160007,23700}]','[]'),(5978,0,0,'[{255,36160007,24000}]','[{255,36160007,24000}]','[]'),(5979,0,0,'[{255,36160007,24200}]','[{255,36160007,24200}]','[]'),(5980,0,0,'[{255,36160007,24500}]','[{255,36160007,24500}]','[]'),(5981,0,0,'[{255,36160007,24800}]','[{255,36160007,24800}]','[]'),(5982,0,0,'[{255,36160007,25100}]','[{255,36160007,25100}]','[]'),(5983,0,0,'[{255,36160007,25400}]','[{255,36160007,25400}]','[]'),(5984,0,0,'[{255,36160007,25700}]','[{255,36160007,25700}]','[]'),(5985,0,0,'[{255,36160007,26000}]','[{255,36160007,26000}]','[]'),(5986,0,0,'[{255,36160007,26300}]','[{255,36160007,26300}]','[]'),(5987,0,0,'[{255,36160007,26600}]','[{255,36160007,26600}]','[]'),(5988,0,0,'[{255,36160007,26800}]','[{255,36160007,26800}]','[]'),(5989,0,0,'[{255,36160007,27100}]','[{255,36160007,27100}]','[]'),(5990,0,0,'[{255,36160007,27400}]','[{255,36160007,27400}]','[]'),(5991,0,0,'[{255,36160007,27700}]','[{255,36160007,27700}]','[]'),(5992,0,0,'[{255,36160007,28000}]','[{255,36160007,28000}]','[]'),(5993,0,0,'[{255,36160007,28300}]','[{255,36160007,28300}]','[]'),(5994,0,0,'[{255,36160007,28600}]','[{255,36160007,28600}]','[]'),(5995,0,0,'[{255,36160007,28900}]','[{255,36160007,28900}]','[]'),(5996,0,0,'[{255,36160007,29100}]','[{255,36160007,29100}]','[]'),(5997,0,0,'[{255,36160007,29400}]','[{255,36160007,29400}]','[]'),(5998,0,0,'[{255,36160007,29700}]','[{255,36160007,29700}]','[]'),(5999,0,0,'[{255,36160007,30000}]','[{255,36160007,30000}]','[]'),(40001,1,1,'[{255,36160007,60}]','',''),(40001,2,2,'[{255,36160007,132}]','',''),(40001,3,3,'[{255,36160007,215}]','',''),(40001,4,4,'[{255,36160007,304}]','',''),(40001,5,5,'[{255,36160007,399}]','',''),(40001,6,6,'[{255,36160007,498}]','',''),(40001,7,7,'[{255,36160007,601}]','',''),(40001,8,8,'[{255,36160007,707}]','',''),(40001,9,9,'[{255,36160007,816}]','',''),(40001,10,10,'[{255,36160007,928}]','',''),(40001,11,11,'[{255,36160007,1042}]','',''),(40001,12,12,'[{255,36160007,1158}]','',''),(40001,13,13,'[{255,36160007,1276}]','',''),(40001,14,14,'[{255,36160007,1397}]','',''),(40001,15,15,'[{255,36160007,1518}]','',''),(40001,16,16,'[{255,36160007,1642}]','',''),(40001,17,17,'[{255,36160007,1767}]','',''),(40001,18,18,'[{255,36160007,1894}]','',''),(40001,19,19,'[{255,36160007,2022}]','',''),(40001,20,20,'[{255,36160007,2152}]','',''),(40001,21,21,'[{255,36160007,2283}]','',''),(40001,22,22,'[{255,36160007,2415}]','',''),(40001,23,23,'[{255,36160007,2548}]','',''),(40001,24,24,'[{255,36160007,2683}]','',''),(40001,25,25,'[{255,36160007,2819}]','',''),(40001,26,26,'[{255,36160007,2956}]','',''),(40001,27,27,'[{255,36160007,3094}]','',''),(40001,28,28,'[{255,36160007,3233}]','',''),(40001,29,29,'[{255,36160007,3373}]','',''),(40001,30,30,'[{255,36160007,3514}]','',''),(40001,31,31,'[{255,36160007,3656}]','',''),(40001,32,32,'[{255,36160007,3799}]','',''),(40001,33,33,'[{255,36160007,3943}]','',''),(40001,34,34,'[{255,36160007,4088}]','',''),(40001,35,35,'[{255,36160007,4233}]','',''),(40001,36,36,'[{255,36160007,4380}]','',''),(40001,37,37,'[{255,36160007,4527}]','',''),(40001,38,38,'[{255,36160007,4675}]','',''),(40001,39,39,'[{255,36160007,4824}]','',''),(40001,40,40,'[{255,36160007,4973}]','',''),(40001,41,41,'[{255,36160007,5124}]','',''),(40001,42,42,'[{255,36160007,5275}]','',''),(40001,43,43,'[{255,36160007,5427}]','',''),(40001,44,44,'[{255,36160007,5580}]','',''),(40001,45,45,'[{255,36160007,5733}]','',''),(40001,46,46,'[{255,36160007,5887}]','',''),(40001,47,47,'[{255,36160007,6042}]','',''),(40001,48,48,'[{255,36160007,6197}]','',''),(40001,49,49,'[{255,36160007,6353}]','',''),(40001,50,50,'[{255,36160007,6510}]','',''),(40001,51,51,'[{255,36160007,6667}]','',''),(40001,52,52,'[{255,36160007,6825}]','',''),(40001,53,53,'[{255,36160007,6983}]','',''),(40001,54,54,'[{255,36160007,7142}]','',''),(40001,55,55,'[{255,36160007,7302}]','',''),(40001,56,56,'[{255,36160007,7462}]','',''),(40001,57,57,'[{255,36160007,7623}]','',''),(40001,58,58,'[{255,36160007,7785}]','',''),(40001,59,59,'[{255,36160007,7947}]','',''),(40001,60,60,'[{255,36160007,8109}]','',''),(40001,61,61,'[{255,36160007,8272}]','',''),(40001,62,62,'[{255,36160007,8436}]','',''),(40001,63,63,'[{255,36160007,8600}]','',''),(40001,64,64,'[{255,36160007,8765}]','',''),(40001,65,65,'[{255,36160007,8930}]','',''),(40001,66,66,'[{255,36160007,9096}]','',''),(40001,67,67,'[{255,36160007,9262}]','',''),(40001,68,68,'[{255,36160007,9429}]','',''),(40001,69,69,'[{255,36160007,9596}]','',''),(40001,70,70,'[{255,36160007,9764}]','',''),(40001,71,71,'[{255,36160007,9932}]','',''),(40001,72,72,'[{255,36160007,10101}]','',''),(40001,73,73,'[{255,36160007,10270}]','',''),(40001,74,74,'[{255,36160007,10440}]','',''),(40001,75,75,'[{255,36160007,10610}]','',''),(40001,76,76,'[{255,36160007,10780}]','',''),(40001,77,77,'[{255,36160007,10951}]','',''),(40001,78,78,'[{255,36160007,11123}]','',''),(40001,79,79,'[{255,36160007,11295}]','',''),(40001,80,80,'[{255,36160007,11467}]','',''),(40001,81,81,'[{255,36160007,11640}]','',''),(40001,82,82,'[{255,36160007,11813}]','',''),(40001,83,83,'[{255,36160007,11987}]','',''),(40001,84,84,'[{255,36160007,12161}]','',''),(40001,85,85,'[{255,36160007,12335}]','',''),(40001,86,86,'[{255,36160007,12510}]','',''),(40001,87,87,'[{255,36160007,12685}]','',''),(40001,88,88,'[{255,36160007,12861}]','',''),(40001,89,89,'[{255,36160007,13037}]','',''),(40001,90,90,'[{255,36160007,13214}]','',''),(40001,91,91,'[{255,36160007,13391}]','',''),(40001,92,92,'[{255,36160007,13568}]','',''),(40001,93,93,'[{255,36160007,13746}]','',''),(40001,94,94,'[{255,36160007,13924}]','',''),(40001,95,95,'[{255,36160007,14102}]','',''),(40001,96,96,'[{255,36160007,14281}]','',''),(40001,97,97,'[{255,36160007,14460}]','',''),(40001,98,98,'[{255,36160007,14640}]','',''),(40001,99,99,'[{255,36160007,14820}]','',''),(40001,100,100,'[{255,36160007,15000}]','','');
/*!40000 ALTER TABLE `base_dungeon_sweep_rewards` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_dungeon_ui_content`
--

DROP TABLE IF EXISTS `base_dungeon_ui_content`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_dungeon_ui_content` (
  `dun_id` int(11) unsigned NOT NULL COMMENT '副本id',
  `rewards` varchar(1000) NOT NULL COMMENT '显示奖励',
  `desc1` text NOT NULL COMMENT '说明1@lang@',
  `desc2` text NOT NULL COMMENT '说明2@lang@',
  `desc3` text NOT NULL COMMENT '说明3@lang@',
  `value1` int(11) NOT NULL COMMENT '值1',
  `value2` int(11) NOT NULL COMMENT '值2',
  `value3` int(11) NOT NULL COMMENT '值3',
  PRIMARY KEY (`dun_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='副本界面内容';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_dungeon_ui_content`
--

LOCK TABLES `base_dungeon_ui_content` WRITE;
/*!40000 ALTER TABLE `base_dungeon_ui_content` DISABLE KEYS */;
INSERT INTO `base_dungeon_ui_content` VALUES (3000,'[{5,36060001,1}]','经验爆表，组队最高可获得30%额外经验加成，伤害越高经验越多','','',0,0,0),(3001,'[{0,36060001,1}]','','','',0,0,0),(3110,'[{0,1001010441,1},{0,1004010441,1},{0,1001010432,1},{0,1004010432,1}]','通关时间越短，奖励越丰厚哦！(副本次数耗尽时，可以助战拿额外奖励)','','',0,0,0),(3111,'[{0,1001010541,1},{0,1004010541,1},{0,1001010532,1},{0,1004010532,1}]','通关时间越短，奖励越丰厚哦！(副本次数耗尽时，可以助战拿额外奖励)','','',0,0,0),(3112,'[{0,1001010641,1},{0,1001010541,1},{0,1001010632,1},{0,1001010532,1}]','通关时间越短，奖励越丰厚哦！(副本次数耗尽时，可以助战拿额外奖励)','','',0,0,0),(3113,'[{0,1001010741,1},{0,1001010641,1},{0,1001010732,1},{0,1001010632,1}]','通关时间越短，奖励越丰厚哦！(副本次数耗尽时，可以助战拿额外奖励)','','',0,0,0),(3114,'[{0,1001010841,1},{0,1001010741,1},{0,1001010832,1},{0,1001010732,1}]','通关时间越短，奖励越丰厚哦！(副本次数耗尽时，可以助战拿额外奖励)','','',0,0,0),(3115,'[{0,1001010941,1},{0,1001010841,1},{0,1001010932,1},{0,1001010832,1}]','通关时间越短，奖励越丰厚哦！(副本次数耗尽时，可以助战拿额外奖励)','','',0,0,0),(3116,'[{0,1001011041,1},{0,1001010941,1},{0,1001011032,1},{0,1001010932,1}]','通关时间越短，奖励越丰厚哦！(副本次数耗尽时，可以助战拿额外奖励)','','',0,0,0),(3117,'[{0,1001011141,1},{0,1001011041,1},{0,1001011132,1},{0,1001011032,1}]','通关时间越短，奖励越丰厚哦！(副本次数耗尽时，可以助战拿额外奖励)','','',0,0,0),(3118,'[{0,1001011241,1},{0,1001011141,1},{0,1001011232,1},{0,1001011132,1}]','通关时间越短，奖励越丰厚哦！(副本次数耗尽时，可以助战拿额外奖励)','','',0,0,0),(3119,'[{0,1001011341,1},{0,1001011241,1},{0,1001011332,1},{0,1001011232,1}]','通关时间越短，奖励越丰厚哦！(副本次数耗尽时，可以助战拿额外奖励)','','',0,0,0),(3120,'[{0,1001011441,1},{0,1001011341,1},{0,1001011432,1},{0,1001011332,1}]','通关时间越短，奖励越丰厚哦！(副本次数耗尽时，可以助战拿额外奖励)','','',0,0,0),(3121,'[{0,1001011541,1},{0,1001011441,1},{0,1001011532,1},{0,1001011432,1}]','通关时间越短，奖励越丰厚哦！(副本次数耗尽时，可以助战拿额外奖励)','','',0,0,0),(3122,'[{0,1001011541,1},{0,1001011541,1},{0,1001011532,1},{0,1001011532,1}]','通关时间越短，奖励越丰厚哦！(副本次数耗尽时，可以助战拿额外奖励)','','',0,0,0),(3300,'[{0,38260002,1},{0,38260001,1},{0,38250001,1}]','限定时间内，通关越多的波数，奖励越多哦！(副本次数耗尽时，可以助战拿额外奖励)','','',0,0,0),(3301,'[{0,38260002,1},{0,38260001,1},{0,38250001,1}]','限定时间内，通关越多的波数，奖励越多哦！(副本次数耗尽时，可以助战拿额外奖励)','','',0,0,0),(3302,'[{0,38260002,1},{0,38260001,1},{0,38250001,1}]','限定时间内，通关越多的波数，奖励越多哦！(副本次数耗尽时，可以助战拿额外奖励)','','',0,0,0),(3303,'[{0,38260002,1},{0,38260001,1},{0,38250001,1}]','限定时间内，通关越多的波数，奖励越多哦！(副本次数耗尽时，可以助战拿额外奖励)','','',0,0,0),(3304,'[{0,38260002,1},{0,38260001,1},{0,38250001,1}]','限定时间内，通关越多的波数，奖励越多哦！(副本次数耗尽时，可以助战拿额外奖励)','','',0,0,0),(5200,'[{0,40010011,1},{255,40040001,1}]','规定时间内获得更多的分数，获得更多奖励！(副本次数耗尽时，可以助战拿额外奖励)','','',0,0,0),(5201,'[{0,40010011,1},{255,40040001,1}]','规定时间内获得更多的分数，获得更多奖励！(副本次数耗尽时，可以助战拿额外奖励)','','',0,0,0),(5202,'[{0,40010011,1},{255,40040001,1}]','规定时间内获得更多的分数，获得更多奖励！(副本次数耗尽时，可以助战拿额外奖励)','','',0,0,0),(5300,'[{0,18020001,15}]','','','',0,0,0),(5301,'[{0,18020001,25}]','','','',0,0,0),(5302,'[{0,18020001,15},{0,18020002,5}]','','','',0,0,0),(5303,'[{0,18020002,15}]','','','',0,0,0),(5304,'[{0,18020002,9},{0,18020003,5}]','','','',0,0,0),(5400,'[{0,11020001,10}]','','','',0,0,0),(5401,'[{0,11020001,20}]','','','',0,0,0),(5402,'[{0,11020001,14},{0,11020002,5}]','','','',0,0,0),(5403,'[{0,11020002,15}]','','','',0,0,0),(5404,'[{0,11020002,10},{0,11020003,5}]','','','',0,0,0),(5405,'[{0,11020001,5}]','','','',0,0,0),(5900,'[{0,5201011,1},{255,36160007,2500}]','','','',0,0,0),(5901,'[{0,32150002,2},{255,36160007,800}]','','','',0,0,0),(5902,'[{0,32150002,2},{255,36160007,1000}]','','','',0,0,0),(5903,'[{0,5201141,1},{255,36160007,1200}]','','','',0,0,0),(5904,'[{0,32150002,2},{255,36160007,1400}]','','','',0,0,0),(5905,'[{0,32150003,1},{255,36160007,1800}]','','','',0,0,0),(5906,'[{0,32150002,2},{255,36160007,2200}]','','','',0,0,0),(5907,'[{0,5201051,1},{255,36160007,2500}]','','','',0,0,0),(5908,'[{0,32150002,2},{255,36160007,3000}]','','','',0,0,0),(5909,'[{0,32150002,2},{255,36160007,4200}]','','','',0,0,0),(5910,'[{0,38180010,2},{255,36160007,5300}]','','','',0,0,0),(5911,'[{0,5201061,1},{255,36160007,6300}]','','','',0,0,0),(5912,'[{0,32150002,2},{255,36160007,7400}]','','','',0,0,0),(5913,'[{0,32150002,2},{255,36160007,7800}]','','','',0,0,0),(5914,'[{0,32150002,2},{255,36160007,8300}]','','','',0,0,0),(5915,'[{0,5201081,1},{255,36160007,8700}]','','','',0,0,0),(5916,'[{0,32150002,3},{255,36160007,9200}]','','','',0,0,0),(5917,'[{0,32150002,3},{255,36160007,9600}]','','','',0,0,0),(5918,'[{0,32150002,3},{255,36160007,10100}]','','','',0,0,0),(5919,'[{0,5201101,1},{255,36160007,10500}]','','','',0,0,0),(5920,'[{0,38180010,3},{255,36160007,11000}]','','','',0,0,0),(5921,'[{0,32150002,3},{255,36160007,11400}]','','','',0,0,0),(5922,'[{0,32150002,3},{255,36160007,11700}]','','','',0,0,0),(5923,'[{0,5201091,1},{255,36160007,12200}]','','','',0,0,0),(5924,'[{0,32150002,3},{255,36160007,12600}]','','','',0,0,0),(5925,'[{0,32150003,2},{255,36160007,13100}]','','','',0,0,0),(5926,'[{0,32150002,3},{255,36160007,13500}]','','','',0,0,0),(5927,'[{0,32150002,3},{255,36160007,14000}]','','','',0,0,0),(5928,'[{0,32150002,3},{255,36160007,14400}]','','','',0,0,0),(5929,'[{0,32150002,3},{255,36160007,14900}]','','','',0,0,0),(5930,'[{0,38180010,4},{255,36160007,15200}]','','','',0,0,0),(5931,'[{0,5201071,1},{255,36160007,15600}]','','','',0,0,0),(5932,'[{0,32150002,3},{255,36160007,16100}]','','','',0,0,0),(5933,'[{0,32150002,3},{255,36160007,16500}]','','','',0,0,0),(5934,'[{0,32150002,3},{255,36160007,17000}]','','','',0,0,0),(5935,'[{0,32150003,2},{255,36160007,17400}]','','','',0,0,0),(5936,'[{0,32150002,3},{255,36160007,17900}]','','','',0,0,0),(5937,'[{0,32150002,3},{255,36160007,18300}]','','','',0,0,0),(5938,'[{0,32150002,3},{255,36160007,18600}]','','','',0,0,0),(5939,'[{0,5201171,1},{255,36160007,19100}]','','','',0,0,0),(5940,'[{0,38180010,5},{255,36160007,19500}]','','','',0,0,0),(5941,'[{0,32150002,3},{255,36160007,20000}]','','','',0,0,0),(5942,'[{0,32150002,3},{255,36160007,20400}]','','','',0,0,0),(5943,'[{0,32150002,3},{255,36160007,20900}]','','','',0,0,0),(5944,'[{0,32150002,3},{255,36160007,21300}]','','','',0,0,0),(5945,'[{0,32150003,3},{255,36160007,21800}]','','','',0,0,0),(5946,'[{0,32150002,3},{255,36160007,22100}]','','','',0,0,0),(5947,'[{0,5201181,1},{255,36160007,22500}]','','','',0,0,0),(5948,'[{0,32150002,3},{255,36160007,23000}]','','','',0,0,0),(5949,'[{0,32150002,3},{255,36160007,23400}]','','','',0,0,0),(5950,'[{0,38180010,6},{255,36160007,23900}]','','','',0,0,0),(5951,'[{0,32150002,3},{255,36160007,24300}]','','','',0,0,0),(5952,'[{0,32150002,3},{255,36160007,24800}]','','','',0,0,0),(5953,'[{0,32150002,3},{255,36160007,25200}]','','','',0,0,0),(5954,'[{0,32150002,3},{255,36160007,25700}]','','','',0,0,0),(5955,'[{0,32150003,3},{255,36160007,26000}]','','','',0,0,0),(5956,'[{0,32150002,3},{255,36160007,26400}]','','','',0,0,0),(5957,'[{0,32150002,3},{255,36160007,26900}]','','','',0,0,0),(5958,'[{0,32150002,3},{255,36160007,27300}]','','','',0,0,0),(5959,'[{0,5201151,1},{255,36160007,27800}]','','','',0,0,0),(5960,'[{0,38180010,7},{255,36160007,28200}]','','','',0,0,0),(5961,'[{0,32150002,3},{255,36160007,28700}]','','','',0,0,0),(5962,'[{0,32150002,3},{255,36160007,29100}]','','','',0,0,0),(5963,'[{0,32150002,3},{255,36160007,29400}]','','','',0,0,0),(5964,'[{0,32150002,3},{255,36160007,29900}]','','','',0,0,0),(5965,'[{0,32150003,4},{255,36160007,30300}]','','','',0,0,0),(5966,'[{0,32150002,3},{255,36160007,30800}]','','','',0,0,0),(5967,'[{0,32150002,3},{255,36160007,31200}]','','','',0,0,0),(5968,'[{0,32150002,3},{255,36160007,31700}]','','','',0,0,0),(5969,'[{0,32150002,3},{255,36160007,32100}]','','','',0,0,0),(5970,'[{0,38180010,8},{255,36160007,32600}]','','','',0,0,0),(5971,'[{0,5201161,1},{255,36160007,32900}]','','','',0,0,0),(5972,'[{0,32150002,3},{255,36160007,33300}]','','','',0,0,0),(5973,'[{0,32150002,3},{255,36160007,33800}]','','','',0,0,0),(5974,'[{0,32150002,3},{255,36160007,34200}]','','','',0,0,0),(5975,'[{0,32150003,4},{255,36160007,34700}]','','','',0,0,0),(5976,'[{0,32150002,3},{255,36160007,35100}]','','','',0,0,0),(5977,'[{0,32150002,3},{255,36160007,35600}]','','','',0,0,0),(5978,'[{0,32150002,3},{255,36160007,36000}]','','','',0,0,0),(5979,'[{0,32150002,3},{255,36160007,36300}]','','','',0,0,0),(5980,'[{0,38180010,9},{255,36160007,36800}]','','','',0,0,0),(5981,'[{0,32150002,3},{255,36160007,37200}]','','','',0,0,0),(5982,'[{0,32150002,3},{255,36160007,37700}]','','','',0,0,0),(5983,'[{0,5201191,1},{255,36160007,38100}]','','','',0,0,0),(5984,'[{0,32150002,3},{255,36160007,38600}]','','','',0,0,0),(5985,'[{0,32150003,5},{255,36160007,39000}]','','','',0,0,0),(5986,'[{0,32150002,3},{255,36160007,39500}]','','','',0,0,0),(5987,'[{0,32150002,3},{255,36160007,39900}]','','','',0,0,0),(5988,'[{0,32150002,3},{255,36160007,40200}]','','','',0,0,0),(5989,'[{0,32150002,3},{255,36160007,40700}]','','','',0,0,0),(5990,'[{0,38180010,10},{255,36160007,41100}]','','','',0,0,0),(5991,'[{0,32150002,3},{255,36160007,41600}]','','','',0,0,0),(5992,'[{0,32150002,3},{255,36160007,42000}]','','','',0,0,0),(5993,'[{0,32150002,3},{255,36160007,42500}]','','','',0,0,0),(5994,'[{0,32150002,3},{255,36160007,42900}]','','','',0,0,0),(5995,'[{0,32150003,5},{255,36160007,43400}]','','','',0,0,0),(5996,'[{0,32150002,3},{255,36160007,43700}]','','','',0,0,0),(5997,'[{0,32150002,3},{255,36160007,44100}]','','','',0,0,0),(5998,'[{0,32150002,3},{255,36160007,44600}]','','','',0,0,0),(5999,'[{0,32150002,3},{255,36160007,45000}]','','','',0,0,0),(40001,'[{0,18020001,27},{0,18030001,100}]','阻止怪物抵达终点','通过怪物超过3只任务失败','每天可扫荡昨日最高波数',0,0,0),(56000,'[{0,17010001,10}]','','','',0,0,0),(56001,'[{0,17010001,10}]','','','',0,0,0),(56002,'[{0,17010001,10}]','','','',0,0,0),(56003,'[{0,17010001,10}]','','','',0,0,0),(56004,'[{0,17010001,30}]','','','',0,0,0),(56005,'[{0,17010001,12}]','','','',0,0,0),(56006,'[{0,17010001,12}]','','','',0,0,0),(56007,'[{0,17010001,12}]','','','',0,0,0),(56008,'[{0,17010001,12}]','','','',0,0,0),(56009,'[{0,17010001,36}]','','','',0,0,0),(56010,'[{0,17010001,14}]','','','',0,0,0),(56011,'[{0,17010001,14}]','','','',0,0,0),(56012,'[{0,17010001,14}]','','','',0,0,0),(56013,'[{0,17010001,14}]','','','',0,0,0),(56014,'[{0,17010001,42}]','','','',0,0,0),(56015,'[{0,17010001,16}]','','','',0,0,0),(56016,'[{0,17010001,16}]','','','',0,0,0),(56017,'[{0,17010001,16}]','','','',0,0,0),(56018,'[{0,17010001,16}]','','','',0,0,0),(56019,'[{0,17010001,48}]','','','',0,0,0),(56020,'[{0,17010001,18}]','','','',0,0,0),(56021,'[{0,17010001,18}]','','','',0,0,0),(56022,'[{0,17010001,18}]','','','',0,0,0),(56023,'[{0,17010001,18}]','','','',0,0,0),(56024,'[{0,17010001,54}]','','','',0,0,0),(56025,'[{0,17010001,20}]','','','',0,0,0),(56026,'[{0,17010001,20}]','','','',0,0,0),(56027,'[{0,17010001,20}]','','','',0,0,0),(56028,'[{0,17010001,20}]','','','',0,0,0),(56029,'[{0,17010001,60}]','','','',0,0,0),(56030,'[{0,17010001,30}]','','','',0,0,0),(56031,'[{0,17010001,30}]','','','',0,0,0),(56032,'[{0,17010001,30}]','','','',0,0,0),(56033,'[{0,17010001,30}]','','','',0,0,0),(56034,'[{0,17010001,90}]','','','',0,0,0),(56035,'[{0,17010001,40}]','','','',0,0,0),(56036,'[{0,17010001,40}]','','','',0,0,0),(56037,'[{0,17010001,40}]','','','',0,0,0),(56038,'[{0,17010001,40}]','','','',0,0,0),(56039,'[{0,17010001,120}]','','','',0,0,0),(56040,'[{0,17010001,50}]','','','',0,0,0),(56041,'[{0,17010001,50}]','','','',0,0,0),(56042,'[{0,17010001,50}]','','','',0,0,0),(56043,'[{0,17010001,50}]','','','',0,0,0),(56044,'[{0,17010001,150}]','','','',0,0,0),(56045,'[{0,17010001,60}]','','','',0,0,0),(56046,'[{0,17010001,60}]','','','',0,0,0),(56047,'[{0,17010001,60}]','','','',0,0,0),(56048,'[{0,17010001,60}]','','','',0,0,0),(56049,'[{0,17010001,180}]','','','',0,0,0),(56050,'[{0,17010001,70}]','','','',0,0,0),(56051,'[{0,17010001,70}]','','','',0,0,0),(56052,'[{0,17010001,70}]','','','',0,0,0),(56053,'[{0,17010001,70}]','','','',0,0,0),(56054,'[{0,17010001,210}]','','','',0,0,0),(56055,'[{0,17010001,80}]','','','',0,0,0),(56056,'[{0,17010001,80}]','','','',0,0,0),(56057,'[{0,17010001,80}]','','','',0,0,0),(56058,'[{0,17010001,80}]','','','',0,0,0),(56059,'[{0,17010001,240}]','','','',0,0,0),(56060,'[{0,17010001,90}]','','','',0,0,0),(56061,'[{0,17010001,90}]','','','',0,0,0),(56062,'[{0,17010001,90}]','','','',0,0,0),(56063,'[{0,17010001,90}]','','','',0,0,0),(56064,'[{0,17010001,270}]','','','',0,0,0),(56065,'[{0,17010001,100}]','','','',0,0,0),(56066,'[{0,17010001,100}]','','','',0,0,0),(56067,'[{0,17010001,100}]','','','',0,0,0),(56068,'[{0,17010001,100}]','','','',0,0,0),(56069,'[{0,17010001,300}]','','','',0,0,0),(56070,'[{0,17010001,200}]','','','',0,0,0),(56071,'[{0,17010001,200}]','','','',0,0,0),(56072,'[{0,17010001,200}]','','','',0,0,0),(56073,'[{0,17010001,200}]','','','',0,0,0),(56074,'[{0,17010001,600}]','','','',0,0,0),(56075,'[{0,17010001,300}]','','','',0,0,0),(56076,'[{0,17010001,300}]','','','',0,0,0),(56077,'[{0,17010001,300}]','','','',0,0,0),(56078,'[{0,17010001,300}]','','','',0,0,0),(56079,'[{0,17010001,900}]','','','',0,0,0),(56080,'[{0,17010001,400}]','','','',0,0,0),(56081,'[{0,17010001,400}]','','','',0,0,0),(56082,'[{0,17010001,400}]','','','',0,0,0),(56083,'[{0,17010001,400}]','','','',0,0,0),(56084,'[{0,17010001,1200}]','','','',0,0,0),(56085,'[{0,17010001,500}]','','','',0,0,0),(56086,'[{0,17010001,500}]','','','',0,0,0),(56087,'[{0,17010001,500}]','','','',0,0,0),(56088,'[{0,17010001,500}]','','','',0,0,0),(56089,'[{0,17010001,1500}]','','','',0,0,0),(56090,'[{0,17010001,600}]','','','',0,0,0),(56091,'[{0,17010001,600}]','','','',0,0,0),(56092,'[{0,17010001,600}]','','','',0,0,0),(56093,'[{0,17010001,600}]','','','',0,0,0),(56094,'[{0,17010001,1800}]','','','',0,0,0),(56095,'[{0,17010001,700}]','','','',0,0,0),(56096,'[{0,17010001,700}]','','','',0,0,0),(56097,'[{0,17010001,700}]','','','',0,0,0),(56098,'[{0,17010001,700}]','','','',0,0,0),(56099,'[{0,17010001,2100}]','','','',0,0,0),(60000,'[{0,38040300,14}]','抵御入侵魔物，守卫雅典娜。守卫的波数越多，奖励越丰厚。雅典娜被击杀副本会失败！','','',0,0,0),(60001,'[{0,38040300,16},{0,38040301,5},{0,38040302,3}]','抵御入侵魔物，守卫雅典娜。守卫的波数越多，奖励越丰厚。雅典娜被击杀副本会失败！','','',0,0,0),(60002,'[{0,38040300,18},{0,38040301,7},{0,38040302,4}]','抵御入侵魔物，守卫雅典娜。守卫的波数越多，奖励越丰厚。雅典娜被击杀副本会失败！','','',0,0,0),(60003,'[{0,38040300,20},{0,38040303,5},{0,38040304,3}]','抵御入侵魔物，守卫雅典娜。守卫的波数越多，奖励越丰厚。雅典娜被击杀副本会失败！','','',0,0,0),(60004,'[{0,38040300,22},{0,38040305,5},{0,38040306,3}]','抵御入侵魔物，守卫雅典娜。守卫的波数越多，奖励越丰厚。雅典娜被击杀副本会失败！','','',0,0,0);
/*!40000 ALTER TABLE `base_dungeon_ui_content` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_dungeon_ui_tab`
--

DROP TABLE IF EXISTS `base_dungeon_ui_tab`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_dungeon_ui_tab` (
  `group` tinyint(3) unsigned NOT NULL COMMENT '组标签',
  `group_name` varchar(255) NOT NULL COMMENT '组名@lang@',
  `index` int(10) unsigned NOT NULL COMMENT '页标签',
  `tab_name` varchar(255) NOT NULL COMMENT '标签名@lang@',
  `dun_type` tinyint(3) unsigned NOT NULL COMMENT '副本类型',
  `desc` text NOT NULL COMMENT '说明',
  PRIMARY KEY (`group`,`index`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='副本标签配置（客户端用）';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_dungeon_ui_tab`
--

LOCK TABLES `base_dungeon_ui_tab` WRITE;
/*!40000 ALTER TABLE `base_dungeon_ui_tab` DISABLE KEYS */;
INSERT INTO `base_dungeon_ui_tab` VALUES (1,'单人',1,'精灵秘境',3,'设计目的：阶段性的提供新的单人副本玩法和主要的宠物成长资源产出点'),(1,'单人',2,'无尽挑战',8,'聚魂副本'),(1,'单人',3,'藏宝洞窟',2,'金币副本'),(1,'单人',4,'灵魂之塔',12,'灵魂之塔'),(1,'单人',5,'觉醒之门',17,'觉醒副本'),(2,'组队',1,'经验宝库',4,'在发条密室中击败怪物可获得大量经验'),(2,'组队',2,'装备副本',5,'装备副本'),(2,'组队',3,'诛邪战场',14,'诛邪战场');
/*!40000 ALTER TABLE `base_dungeon_ui_tab` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_dungeon_wave`
--

DROP TABLE IF EXISTS `base_dungeon_wave`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_dungeon_wave` (
  `dun_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本id',
  `scene_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '场景id',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '波数类型',
  `subtype` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '波数子类型',
  `rand_num` text NOT NULL COMMENT '随机数量',
  `mon_list` text NOT NULL COMMENT '怪物信息',
  `group_mon_list` text NOT NULL COMMENT '组怪物信息##[{GroupWeight(组权重), [{MonId, X, Y, MonWeight, AttrList},...]},...] MonWeight:权重,怪物MonId:怪物id,[X,Y]:坐标,AttrList:属性列表(默认填[])',
  `xy_range` varchar(100) NOT NULL DEFAULT '[]' COMMENT '坐标波动',
  `refresh_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '刷怪时间',
  `create_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '生成怪物类型##0:循环刷新,1:怪物死亡刷新,2:最大刷新是循环时间(死亡间隔和循环时间一起使用,最大的刷新时间是循环间隔)',
  `cycle_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '循环次数',
  `cycle_gap` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '循环间隔',
  `die_gap` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '死亡间隔',
  `msg_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消息推送时间',
  `msg_stay_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消息停留时间',
  `msg` varchar(200) NOT NULL DEFAULT '' COMMENT '消息@lang@',
  `desc` varchar(1000) NOT NULL DEFAULT '' COMMENT '描述@lang@',
  PRIMARY KEY (`dun_id`,`scene_id`,`type`,`subtype`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='副本波数配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_dungeon_wave`
--

LOCK TABLES `base_dungeon_wave` WRITE;
/*!40000 ALTER TABLE `base_dungeon_wave` DISABLE KEYS */;
INSERT INTO `base_dungeon_wave` VALUES (1002,3000,1,1,'[]','[{1003103,4892,5163,100,[]}]','[]','[]',0,0,1,0,0,0,0,'击败扰乱心智的梦魇恶魔，让护民官从梦魇中苏醒。','击败扰乱心智的梦魇恶魔，让护民官从梦魇中苏醒'),(1002,3000,51,1,'[]','[{1003103,4892,5163,100,[]}]','[]','[]',0,0,1,0,0,0,0,'击败扰乱心智的梦魇恶魔，让护民官从梦魇中苏醒。','击败扰乱心智的梦魇恶魔，让护民官从梦魇中苏醒。'),(1002,3003,1,1,'[]','[{1003103,4892,5163,100,[]}]','[]','[]',0,0,1,0,0,0,0,'击败扰乱心智的梦魇恶魔，让护民官从梦魇中苏醒。','击败扰乱心智的梦魇恶魔，让护民官从梦魇中苏醒'),(1002,7500,1,1,'[]','[{1002001,12686,10218,100,[]}]','[]','[]',0,0,1,0,0,0,0,'击败扰乱心智的梦魇恶魔，让护民官从梦魇中苏醒。','击败扰乱心智的梦魇恶魔，解救经验馆主'),(1002,7500,2,1,'[]','[{1002002,12279,9501,100,[]}]','[]','[]',0,0,1,0,0,0,0,'击败扰乱心智的梦魇恶魔，让护民官从梦魇中苏醒。','击败扰乱心智的梦魇恶魔，让护民官从梦魇中苏醒'),(1003,10009,1,1,'[]','[{1003000,12641,10184,100,[]}]','[]','[]',0,0,1,0,0,0,0,'','击败BOSS色欲，可获得<color=#ff00ff>强力紫色项链</color>'),(2101,3003,1,1,'[]','[{2101011,4824,4610,100,[]},{2101011,4912,4488,100,[]},{2101011,4877,4873,100,[]},{2101011,5174,4768,100,[]},{2101011,5314,4470,100,[]},{2101011,5279,5278,100,[]},{2101011,4894,4138,100,[]},{2101011,4632,4208,100,[]}]','[]','[]',0,0,1,0,0,0,0,'','击败所有怪物即可通关'),(2101,3003,2,1,'[]','[{2101001,4892,5163,100,[]}]','[]','[]',0,0,1,0,0,0,0,'','击败所有怪物即可通关'),(2101,5303,1,1,'[]','[{2101011,4824,4610,100,[]},{2101011,4912,4488,100,[]},{2101011,4877,4873,100,[]},{2101011,5174,4768,100,[]},{2101011,5314,4470,100,[]},{2101011,5279,5278,100,[]},{2101011,4894,4138,100,[]},{2101011,4632,4208,100,[]}]','[]','[]',0,0,1,0,0,0,0,'','击败所有怪物即可通关'),(2101,5303,2,1,'[]','[{2101001,4892,5163,100,[]}]','[]','[]',0,0,1,0,0,0,0,'','击败所有怪物即可通关'),(2102,2103,1,1,'[]','[{2101012,1570,1207,100,[]},{2101012,1765,1100,100,[]},{2101012,2025,1000,100,[]},{2101012,2322,990,100,[]},{2101012,1860,1337,100,[]},{2101012,2090,1255,100,[]},{2101012,2320,1202,100,[]},{2101012,2617,1175,100,[]}]','[]','[]',0,0,1,0,0,0,0,'','击败所有怪物即可通关'),(2102,2103,2,1,'[]','[{2101002,2167,1200,100,[]}]','[]','[]',0,0,1,0,0,0,0,'','击败所有怪物即可通关'),(2102,5303,1,1,'[]','[{2101012,4824,4610,100,[]},{2101012,4912,4488,100,[]},{2101012,4877,4873,100,[]},{2101012,5174,4768,100,[]},{2101012,5314,4470,100,[]},{2101012,5279,5278,100,[]},{2101012,4894,4138,100,[]},{2101012,4632,4208,100,[]}]','[]','[]',0,0,1,0,0,0,0,'','击败所有怪物即可通关'),(2102,5303,2,1,'[]','[{2101002,4877,4873,100,[]}]','[]','[]',0,0,1,0,0,0,0,'','击败所有怪物即可通关'),(2103,2102,1,1,'[]','[{2101013,1656,688,100,[]},{2101013,1438,796,100,[]},{2101013,1248,930,100,[]},{2101013,1519,1099,100,[]},{2101013,1735,937,100,[]},{2101013,1927,751,100,[]},{2101013,1837,1149,100,[]},{2101013,2071,943,100,[]}]','[]','[]',0,0,1,0,0,0,0,'','击败所有怪物即可通关'),(2103,2102,2,1,'[]','[{2101003,1787,960,100,[]}]','[]','[]',0,0,1,0,0,0,0,'','击败所有怪物即可通关'),(2104,2107,1,1,'[]','[{2101014,2518,2900,100,[]},{2101014,2724,2835,100,[]},{2101014,2944,2679,100,[]},{2101014,2680,3037,100,[]},{2101014,2938,3097,100,[]},{2101014,2980,2897,100,[]},{2101014,3194,2823,100,[]},{2101014,3143,2609,100,[]}]','[]','[]',0,0,1,0,0,0,0,'','击败所有怪物即可通关'),(2104,2107,2,1,'[]','[{2101004,3385,3080,100,[]}]','[]','[]',0,0,1,0,0,0,0,'','击败所有怪物即可通关'),(2105,2102,1,1,'[]','[{2101015,1656,688,100,[]},{2101015,1438,796,100,[]},{2101015,1248,930,100,[]},{2101015,1519,1099,100,[]},{2101015,1735,937,100,[]},{2101015,1927,751,100,[]},{2101015,1837,1149,100,[]},{2101015,2071,943,100,[]}]','[]','[]',0,0,1,0,0,0,0,'','击败所有怪物即可通关'),(2105,2102,2,1,'[]','[{2101005,1787,960,100,[]}]','[]','[]',0,0,1,0,0,0,0,'','击败所有怪物即可通关'),(2106,2105,1,1,'[]','[{2101016,2304,558,100,[]},{2101016,2092,565,100,[]},{2101016,2129,380,100,[]},{2101016,1917,664,100,[]},{2101016,1853,513,100,[]},{2101016,1934,291,100,[]},{2101016,1950,300,100,[]},{2101016,1934,465,100,[]}]','[]','[]',0,0,1,0,0,0,0,'','击败所有怪物即可通关'),(2106,2105,2,1,'[]','[{2101006,1705,486,100,[]}]','[]','[]',0,0,1,0,0,0,0,'','击败所有怪物即可通关'),(2107,2104,1,1,'[]','[{2101017,1144,822,100,[]},{2101017,1442,686,100,[]},{2101017,1090,1043,100,[]},{2101017,1369,1009,100,[]},{2101017,1601,889,100,[]},{2101017,1783,759,100,[]},{2101017,1094,992,100,[]},{2101017,1203,759,100,[]}]','[]','[]',0,0,1,0,0,0,0,'','击败所有怪物即可通关'),(2107,2104,2,1,'[]','[{2101007,1562,972,100,[]}]','[]','[]',0,0,1,0,0,0,0,'','击败所有怪物即可通关'),(2108,2108,1,1,'[]','[{2101018,1579,2942,100,[]},{2101018,1548,2700,100,[]},{2101018,1401,3023,100,[]},{2101018,1336,2651,100,[]},{2101018,1153,3072,100,[]},{2101018,1078,2645,100,[]},{2101018,1278,2845,100,[]},{2101018,1200,2645,100,[]}]','[]','[]',0,0,1,0,0,0,0,'','击败所有怪物即可通关'),(2108,2108,2,1,'[]','[{2101008,1088,2877,100,[]}]','[]','[]',0,0,1,0,0,0,0,'','击败所有怪物即可通关'),(2109,2101,1,1,'[]','[{2101019,1252,713,100,[]},{2101019,976,891,100,[]},{2101019,1051,1134,100,[]},{2101019,1387,1145,100,[]},{2101019,1673,1096,100,[]},{2101019,1740,821,100,[]},{2101019,840,671,100,[]},{2101019,1106,983,100,[]}]','[]','[]',0,0,1,0,0,0,0,'','击败所有怪物即可通关'),(2109,2101,2,1,'[]','[{2101009,1467,1005,100,[]}]','[]','[]',0,0,1,0,0,0,0,'','击败所有怪物即可通关'),(2110,2106,1,1,'[]','[{2101020,1812,1576,100,[]},{2101020,2005,1676,100,[]},{2101020,2299,1606,100,[]},{2101020,2533,1409,100,[]},{2101020,2448,1784,100,[]},{2101020,2706,1679,100,[]},{2101020,1782,1453,100,[]},{2101020,2066,1473,100,[]}]','[]','[]',0,0,1,0,0,0,0,'','击败所有怪物即可通关'),(2110,2106,2,1,'[]','[{2101010,2848,1740,100,[]}]','[]','[]',0,0,1,0,0,0,0,'','击败所有怪物即可通关'),(2201,7501,1,1,'[]','[{2201001,10574,2846,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(2202,7100,1,1,'[]','[{2201002,4892,5163,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(2202,7501,1,1,'[]','[{2201002,10574,2846,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(2203,7100,1,1,'[]','[{2201003,4789,4510,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(2204,7100,1,1,'[]','[{2201004,4789,4510,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(2205,7100,1,1,'[]','[{2201005,4789,4510,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(2301,10006,1,1,'[]','[{2301001,2211,17577,100,[]}]','[]','[]',0,0,1,0,0,0,0,'','佩戴<color=#00FF00>白羊天使</color>更容易通关哦！'),(2302,10008,1,1,'[]','[{2301002,11300,12900,100,[]}]','[]','[]',0,0,1,0,0,0,0,'','佩戴<color=#00FF00>白羊天使</color>更容易通关哦！'),(2303,10009,1,1,'[]','[{2301003,12600,10200,100,[]}]','[]','[]',0,0,1,0,0,0,0,'','佩戴<color=#00FF00>白羊天使</color>更容易通关哦！'),(2304,7100,1,1,'[]','[{2301004,4910,4584,100,[]}]','[]','[]',0,0,1,0,0,0,0,'','佩戴<color=#00FF00>白羊天使</color>更容易通关哦！'),(2305,7100,1,1,'[]','[{2301005,4910,4584,100,[]}]','[]','[]',0,0,1,0,0,0,0,'','佩戴<color=#00FF00>白羊天使</color>更容易通关哦！'),(3000,3000,1,1,'[]','[{3000002,1438,1300,100,[]},{3000002,1238,1232,100,[]}]','[]','[]',0,1,500,2000,0,0,0,'',''),(3000,3000,2,1,'[]','[{3000002,1065,1152,100,[]},{3000002,945,992,100,[]}]','[]','[]',0,1,500,2000,0,0,0,'',''),(3000,3000,3,1,'[]','[{3000002,1045,815,100,[]},{3000002,1230,697,100,[]}]','[]','[]',0,1,500,2000,0,0,0,'',''),(3000,3000,4,1,'[]','[{3000002,1385,645,100,[]},{3000002,1435,635,100,[]}]','[]','[]',0,1,500,2000,0,0,0,'',''),(3000,3000,5,1,'[]','[{3000002,1715,645,100,[]},{3000002,1888,700,100,[]}]','[]','[]',2000,1,500,2000,0,0,0,'',''),(3000,3000,6,1,'[]','[{3000002,2088,815,100,[]},{3000003,2168,977,100,[]},{3000007,2268,1077,100,[]}]','[]','[]',2000,1,500,2000,0,0,0,'',''),(3000,3000,7,1,'[]','[{3000002,2088,1122,100,[]},{3000002,1873,1255,100,[]},{3000002,1668,1290,100,[]}]','[]','[]',2000,1,500,2000,0,0,0,'',''),(3001,3000,1,1,'[]','[{30010101,4479,4515,100,[]}]','[]','[]',0,1,33,2000,1000,0,0,'',''),(3001,3000,2,1,'[]','[{30010102,4491,4654,100,[]}]','[]','[]',0,1,33,2000,1000,0,0,'',''),(3001,3000,3,1,'[]','[{30010103,5064,4713,100,[]}]','[]','[]',0,1,33,2000,1000,0,0,'',''),(3001,3000,4,1,'[]','[{30010104,5121,4603,100,[]}]','[]','[]',0,1,33,2000,1000,0,0,'',''),(3001,3000,5,1,'[]','[{30010105,5125,4490,100,[]}]','[]','[]',0,1,33,2000,1000,0,0,'',''),(3001,3000,6,1,'[]','[{30010106,5104,4345,100,[]}]','[]','[]',0,1,33,2000,1000,0,0,'',''),(3001,3000,7,1,'[]','[{30010107,5074,4254,100,[]}]','[]','[]',0,1,33,2000,1000,0,0,'',''),(3001,3000,8,1,'[]','[{30010108,4509,4263,100,[]}]','[]','[]',0,1,33,2000,1000,0,0,'',''),(3001,3000,9,1,'[]','[{30010109,4478,4371,100,[]}]','[]','[]',0,1,33,2000,1000,0,0,'',''),(3001,3000,10,1,'[]','[{30010201,4479,4515,100,[]}]','[]','[]',0,1,12,2000,1000,0,0,'',''),(3001,3000,11,1,'[]','[{30010202,4491,4654,100,[]}]','[]','[]',0,1,12,2000,1000,0,0,'',''),(3001,3000,12,1,'[]','[{30010203,5064,4713,100,[]}]','[]','[]',0,1,12,2000,1000,0,0,'',''),(3001,3000,13,1,'[]','[{30010204,5121,4603,100,[]}]','[]','[]',0,1,12,2000,1000,0,0,'',''),(3001,3000,14,1,'[]','[{30010205,5125,4490,100,[]}]','[]','[]',0,1,12,2000,1000,0,0,'',''),(3001,3000,15,1,'[]','[{30010206,5104,4345,100,[]}]','[]','[]',0,1,12,2000,1000,0,0,'',''),(3001,3000,16,1,'[]','[{30010207,5074,4254,100,[]}]','[]','[]',0,1,12,2000,1000,0,0,'',''),(3001,3000,17,1,'[]','[{30010208,4509,4263,100,[]}]','[]','[]',0,1,12,2000,1000,0,0,'',''),(3001,3000,18,1,'[]','[{30010209,4478,4371,100,[]}]','[]','[]',0,1,12,2000,1000,0,0,'',''),(3001,3000,19,1,'[]','[{30010301,4479,4515,100,[]}]','[]','[]',0,1,5,2000,1000,0,0,'',''),(3001,3000,20,1,'[]','[{30010302,4491,4654,100,[]}]','[]','[]',0,1,5,2000,1000,0,0,'',''),(3001,3000,21,1,'[]','[{30010303,5064,4713,100,[]}]','[]','[]',0,1,5,2000,1000,0,0,'',''),(3001,3000,22,1,'[]','[{30010304,5121,4603,100,[]}]','[]','[]',0,1,5,2000,1000,0,0,'',''),(3001,3000,23,1,'[]','[{30010305,5125,4490,100,[]}]','[]','[]',0,1,5,2000,1000,0,0,'',''),(3001,3000,24,1,'[]','[{30010306,5104,4345,100,[]}]','[]','[]',0,1,5,2000,1000,0,0,'',''),(3001,3000,25,1,'[]','[{30010307,5074,4254,100,[]}]','[]','[]',0,1,5,2000,1000,0,0,'',''),(3001,3000,26,1,'[]','[{30010308,4509,4263,100,[]}]','[]','[]',0,1,5,2000,1000,0,0,'',''),(3001,3000,27,1,'[]','[{30010309,4478,4371,100,[]}]','[]','[]',0,1,5,2000,1000,0,0,'',''),(3001,3000,28,1,'[]','[{30010401,4479,4515,100,[]}]','[]','[]',0,1,5,2000,1000,0,0,'',''),(3001,3000,29,1,'[]','[{30010402,4491,4654,100,[]}]','[]','[]',0,1,5,2000,1000,0,0,'',''),(3001,3000,30,1,'[]','[{30010403,5064,4713,100,[]}]','[]','[]',0,1,5,2000,1000,0,0,'',''),(3001,3000,31,1,'[]','[{30010404,5121,4603,100,[]}]','[]','[]',0,1,5,2000,1000,0,0,'',''),(3001,3000,32,1,'[]','[{30010405,5125,4490,100,[]}]','[]','[]',0,1,5,2000,1000,0,0,'',''),(3001,3000,33,1,'[]','[{30010406,5104,4345,100,[]}]','[]','[]',0,1,5,2000,1000,0,0,'',''),(3001,3000,34,1,'[]','[{30010407,5074,4254,100,[]}]','[]','[]',0,1,5,2000,1000,0,0,'',''),(3001,3000,35,1,'[]','[{30010408,4509,4263,100,[]}]','[]','[]',0,1,5,2000,1000,0,0,'',''),(3001,3000,36,1,'[]','[{30010409,4478,4371,100,[]}]','[]','[]',0,1,5,2000,1000,0,0,'',''),(3001,3000,37,1,'[]','[{30010501,4479,4515,100,[]}]','[]','[]',0,1,9999,3000,2000,0,0,'',''),(3001,3000,38,1,'[]','[{30010502,4491,4654,100,[]}]','[]','[]',0,1,9999,3000,2000,0,0,'',''),(3001,3000,39,1,'[]','[{30010503,5064,4713,100,[]}]','[]','[]',0,1,9999,3000,2000,0,0,'',''),(3001,3000,40,1,'[]','[{30010504,5121,4603,100,[]}]','[]','[]',0,1,9999,3000,2000,0,0,'',''),(3001,3000,41,1,'[]','[{30010505,5125,4490,100,[]}]','[]','[]',0,1,9999,3000,2000,0,0,'',''),(3001,3000,42,1,'[]','[{30010506,5104,4345,100,[]}]','[]','[]',0,1,9999,3000,2000,0,0,'',''),(3001,3000,43,1,'[]','[{30010507,5074,4254,100,[]}]','[]','[]',0,1,9999,3000,2000,0,0,'',''),(3001,3000,44,1,'[]','[{30010508,4509,4263,100,[]}]','[]','[]',0,1,9999,3000,2000,0,0,'',''),(3001,3000,45,1,'[]','[{30010509,4478,4371,100,[]}]','[]','[]',0,1,9999,3000,2000,0,0,'',''),(3002,3000,1,1,'[]','[{3002001,4824,4610,100,[]},{3002001,4912,4488,100,[]}]','[]','[]',0,1,40,1000,0,0,0,'',''),(3002,3000,2,1,'[]','[{3002001,4877,4873,100,[]},{3002001,5174,4768,100,[]}]','[]','[]',0,1,40,1000,0,0,0,'',''),(3002,3000,3,1,'[]','[{3002001,5314,4470,100,[]},{3002001,5279,5278,100,[]}]','[]','[]',0,1,40,1000,0,0,0,'',''),(3002,3000,4,1,'[]','[{3002001,4894,4138,100,[]},{3002001,4632,4208,100,[]}]','[]','[]',0,1,40,1000,0,0,0,'',''),(3002,3000,5,1,'[]','[{3002001,4527,4488,100,[]},{3002001,4650,4733,100,[]}]','[]','[]',0,1,40,1000,0,0,0,'',''),(3002,3000,6,1,'[]','[{3002001,4824,4610,100,[]},{3002001,4912,4488,100,[]}]','[]','[]',0,1,40,1000,0,0,0,'',''),(3002,3000,7,1,'[]','[{3002001,4877,4873,100,[]},{3002001,5174,4768,100,[]}]','[]','[]',0,1,20,1000,0,0,0,'',''),(3002,3000,8,1,'[]','[{3002001,5314,4470,100,[]},{3002001,5279,5278,100,[]}]','[]','[]',0,1,20,1000,0,0,0,'',''),(3002,3000,9,1,'[]','[{3002001,4894,4138,100,[]},{3002001,4632,4208,100,[]}]','[]','[]',0,1,20,1000,0,0,0,'',''),(3002,3000,10,1,'[]','[{3002001,4527,4488,100,[]},{3002001,4650,4733,100,[]}]','[]','[]',0,1,20,1000,0,0,0,'',''),(3003,3000,1,1,'[]','[{30010101,4479,4515,100,[]}]','[]','[]',0,1,33,2000,0,0,0,'',''),(3003,3000,2,1,'[]','[{30010102,4491,4654,100,[]}]','[]','[]',0,1,33,2000,0,0,0,'',''),(3003,3000,3,1,'[]','[{30010103,5064,4713,100,[]}]','[]','[]',0,1,33,2000,0,0,0,'',''),(3003,3000,4,1,'[]','[{30010104,5121,4603,100,[]}]','[]','[]',0,1,33,2000,0,0,0,'',''),(3003,3000,5,1,'[]','[{30010105,5125,4490,100,[]}]','[]','[]',0,1,33,2000,0,0,0,'',''),(3003,3000,6,1,'[]','[{30010106,5104,4345,100,[]}]','[]','[]',0,1,33,2000,0,0,0,'',''),(3003,3000,7,1,'[]','[{30010107,5074,4254,100,[]}]','[]','[]',0,1,33,2000,0,0,0,'',''),(3003,3000,8,1,'[]','[{30010108,4509,4263,100,[]}]','[]','[]',0,1,33,2000,0,0,0,'',''),(3003,3000,9,1,'[]','[{30010109,4478,4371,100,[]}]','[]','[]',0,1,33,2000,0,0,0,'',''),(3003,3000,10,1,'[]','[{30010201,4479,4515,100,[]}]','[]','[]',0,1,12,2000,0,0,0,'',''),(3003,3000,11,1,'[]','[{30010202,4491,4654,100,[]}]','[]','[]',0,1,12,2000,0,0,0,'',''),(3003,3000,12,1,'[]','[{30010203,5064,4713,100,[]}]','[]','[]',0,1,12,2000,0,0,0,'',''),(3003,3000,13,1,'[]','[{30010204,5121,4603,100,[]}]','[]','[]',0,1,12,2000,0,0,0,'',''),(3003,3000,14,1,'[]','[{30010205,5125,4490,100,[]}]','[]','[]',0,1,12,2000,0,0,0,'',''),(3003,3000,15,1,'[]','[{30010206,5104,4345,100,[]}]','[]','[]',0,1,12,2000,0,0,0,'',''),(3003,3000,16,1,'[]','[{30010207,5074,4254,100,[]}]','[]','[]',0,1,12,2000,0,0,0,'',''),(3003,3000,17,1,'[]','[{30010208,4509,4263,100,[]}]','[]','[]',0,1,12,2000,0,0,0,'',''),(3003,3000,18,1,'[]','[{30010209,4478,4371,100,[]}]','[]','[]',0,1,12,2000,0,0,0,'',''),(3003,3000,19,1,'[]','[{30010301,4479,4515,100,[]}]','[]','[]',0,1,5,2000,0,0,0,'',''),(3003,3000,20,1,'[]','[{30010302,4491,4654,100,[]}]','[]','[]',0,1,5,2000,0,0,0,'',''),(3003,3000,21,1,'[]','[{30010303,5064,4713,100,[]}]','[]','[]',0,1,5,2000,0,0,0,'',''),(3003,3000,22,1,'[]','[{30010304,5121,4603,100,[]}]','[]','[]',0,1,5,2000,0,0,0,'',''),(3003,3000,23,1,'[]','[{30010305,5125,4490,100,[]}]','[]','[]',0,1,5,2000,0,0,0,'',''),(3003,3000,24,1,'[]','[{30010306,5104,4345,100,[]}]','[]','[]',0,1,5,2000,0,0,0,'',''),(3003,3000,25,1,'[]','[{30010307,5074,4254,100,[]}]','[]','[]',0,1,5,2000,0,0,0,'',''),(3003,3000,26,1,'[]','[{30010308,4509,4263,100,[]}]','[]','[]',0,1,5,2000,0,0,0,'',''),(3003,3000,27,1,'[]','[{30010309,4478,4371,100,[]}]','[]','[]',0,1,5,2000,0,0,0,'',''),(3003,3000,28,1,'[]','[{30010401,4479,4515,100,[]}]','[]','[]',0,1,5,2000,0,0,0,'',''),(3003,3000,29,1,'[]','[{30010402,4491,4654,100,[]}]','[]','[]',0,1,5,2000,0,0,0,'',''),(3003,3000,30,1,'[]','[{30010403,5064,4713,100,[]}]','[]','[]',0,1,5,2000,0,0,0,'',''),(3003,3000,31,1,'[]','[{30010404,5121,4603,100,[]}]','[]','[]',0,1,5,2000,0,0,0,'',''),(3003,3000,32,1,'[]','[{30010405,5125,4490,100,[]}]','[]','[]',0,1,5,2000,0,0,0,'',''),(3003,3000,33,1,'[]','[{30010406,5104,4345,100,[]}]','[]','[]',0,1,5,2000,0,0,0,'',''),(3003,3000,34,1,'[]','[{30010407,5074,4254,100,[]}]','[]','[]',0,1,5,2000,0,0,0,'',''),(3003,3000,35,1,'[]','[{30010408,4509,4263,100,[]}]','[]','[]',0,1,5,2000,0,0,0,'',''),(3003,3000,36,1,'[]','[{30010409,4478,4371,100,[]}]','[]','[]',0,1,5,2000,0,0,0,'',''),(3003,3000,37,1,'[]','[{30010501,4479,4515,100,[]}]','[]','[]',0,1,9999,2000,0,0,0,'',''),(3003,3000,38,1,'[]','[{30010502,4491,4654,100,[]}]','[]','[]',0,1,9999,2000,0,0,0,'',''),(3003,3000,39,1,'[]','[{30010503,5064,4713,100,[]}]','[]','[]',0,1,9999,2000,0,0,0,'',''),(3003,3000,40,1,'[]','[{30010504,5121,4603,100,[]}]','[]','[]',0,1,9999,2000,0,0,0,'',''),(3003,3000,41,1,'[]','[{30010505,5125,4490,100,[]}]','[]','[]',0,1,9999,2000,0,0,0,'',''),(3003,3000,42,1,'[]','[{30010506,5104,4345,100,[]}]','[]','[]',0,1,9999,2000,0,0,0,'',''),(3003,3000,43,1,'[]','[{30010507,5074,4254,100,[]}]','[]','[]',0,1,9999,2000,0,0,0,'',''),(3003,3000,44,1,'[]','[{30010508,4509,4263,100,[]}]','[]','[]',0,1,9999,2000,0,0,0,'',''),(3003,3000,45,1,'[]','[{30010509,4478,4371,100,[]}]','[]','[]',0,1,9999,2000,0,0,0,'',''),(3110,3115,1,1,'[]','[{3110001,6617,2802,100,[]},{3110001,6700,2942,100,[]},{3110001,6814,3140,100,[]},{3110001,6989,3271,100,[]},{3110001,6581,2644,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3110,3115,1,2,'[]','[{3110001,6617,2802,100,[]},{3110001,6700,2942,100,[]},{3110001,6814,3140,100,[]},{3110001,6989,3271,100,[]},{3110001,6581,2644,100,[]}]','[]','[]',6000,0,1,2000,0,0,0,'',''),(3110,3115,2,1,'[]','[{3110002,1967,4417,100,[{die_info,drop}]},{3110002,2599,3999,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3110,3115,3,1,'[]','[{3110004,5830,8755,100,[{die_info,drop}]},{3110004,6531,8755,100,[{die_info,drop}]},{3110004,6582,8247,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3110,3115,4,1,'[]','[{3110007,11895,9272,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3111,3115,1,1,'[]','[{3111001,6617,2802,100,[]},{3111001,6700,2942,100,[]},{3111001,6814,3140,100,[]},{3111001,6989,3271,100,[]},{3111001,6581,2644,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3111,3115,1,2,'[]','[{3111001,6617,2802,100,[]},{3111001,6700,2942,100,[]},{3111001,6814,3140,100,[]},{3111001,6989,3271,100,[]},{3111001,6581,2644,100,[]}]','[]','[]',6000,0,1,2000,0,0,0,'',''),(3111,3115,2,1,'[]','[{3111002,1967,4417,100,[{die_info,drop}]},{3111002,2599,3999,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3111,3115,3,1,'[]','[{3111004,5830,8755,100,[{die_info,drop}]},{3111004,6531,8755,100,[{die_info,drop}]},{3111004,6582,8247,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3111,3115,4,1,'[]','[{3111007,11895,9272,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3112,3115,1,1,'[]','[{3112001,6617,2802,100,[]},{3112001,6700,2942,100,[]},{3112001,6814,3140,100,[]},{3112001,6989,3271,100,[]},{3112001,6581,2644,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3112,3115,1,2,'[]','[{3112001,6617,2802,100,[]},{3112001,6700,2942,100,[]},{3112001,6814,3140,100,[]},{3112001,6989,3271,100,[]},{3112001,6581,2644,100,[]}]','[]','[]',6000,0,1,2000,0,0,0,'',''),(3112,3115,2,1,'[]','[{3112002,1967,4417,100,[{die_info,drop}]},{3112002,2599,3999,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3112,3115,3,1,'[]','[{3112004,5830,8755,100,[{die_info,drop}]},{3112004,6531,8755,100,[{die_info,drop}]},{3112004,6582,8247,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3112,3115,4,1,'[]','[{3112007,11895,9272,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3113,3115,1,1,'[]','[{3113001,6617,2802,100,[]},{3113001,6700,2942,100,[]},{3113001,6814,3140,100,[]},{3113001,6989,3271,100,[]},{3113001,6581,2644,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3113,3115,1,2,'[]','[{3113001,6617,2802,100,[]},{3113001,6700,2942,100,[]},{3113001,6814,3140,100,[]},{3113001,6989,3271,100,[]},{3113001,6581,2644,100,[]}]','[]','[]',6000,0,1,2000,0,0,0,'',''),(3113,3115,2,1,'[]','[{3113002,1967,4417,100,[{die_info,drop}]},{3113002,2599,3999,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3113,3115,3,1,'[]','[{3113004,5830,8755,100,[{die_info,drop}]},{3113004,6531,8755,100,[{die_info,drop}]},{3113004,6582,8247,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3113,3115,4,1,'[]','[{3113007,11895,9272,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3114,3115,1,1,'[]','[{3114001,6617,2802,100,[]},{3114001,6700,2942,100,[]},{3114001,6814,3140,100,[]},{3114001,6989,3271,100,[]},{3114001,6581,2644,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3114,3115,1,2,'[]','[{3114001,6617,2802,100,[]},{3114001,6700,2942,100,[]},{3114001,6814,3140,100,[]},{3114001,6989,3271,100,[]},{3114001,6581,2644,100,[]}]','[]','[]',6000,0,1,2000,0,0,0,'',''),(3114,3115,2,1,'[]','[{3114002,1967,4417,100,[{die_info,drop}]},{3114002,2599,3999,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3114,3115,3,1,'[]','[{3114004,5830,8755,100,[{die_info,drop}]},{3114004,6531,8755,100,[{die_info,drop}]},{3114004,6582,8247,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3114,3115,4,1,'[]','[{3114007,11895,9272,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3115,3115,1,1,'[]','[{3115001,6617,2802,100,[]},{3115001,6700,2942,100,[]},{3115001,6814,3140,100,[]},{3115001,6989,3271,100,[]},{3115001,6581,2644,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3115,3115,1,2,'[]','[{3115001,6617,2802,100,[]},{3115001,6700,2942,100,[]},{3115001,6814,3140,100,[]},{3115001,6989,3271,100,[]},{3115001,6581,2644,100,[]}]','[]','[]',6000,0,1,2000,0,0,0,'',''),(3115,3115,2,1,'[]','[{3115002,1967,4417,100,[{die_info,drop}]},{3115002,2599,3999,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3115,3115,3,1,'[]','[{3115004,5830,8755,100,[{die_info,drop}]},{3115004,6531,8755,100,[{die_info,drop}]},{3115004,6582,8247,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3115,3115,4,1,'[]','[{3115007,11895,9272,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3116,3115,1,1,'[]','[{3116001,6617,2802,100,[]},{3116001,6700,2942,100,[]},{3116001,6814,3140,100,[]},{3116001,6989,3271,100,[]},{3116001,6581,2644,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3116,3115,1,2,'[]','[{3116001,6617,2802,100,[]},{3116001,6700,2942,100,[]},{3116001,6814,3140,100,[]},{3116001,6989,3271,100,[]},{3116001,6581,2644,100,[]}]','[]','[]',6000,0,1,2000,0,0,0,'',''),(3116,3115,2,1,'[]','[{3116002,1967,4417,100,[{die_info,drop}]},{3116002,2599,3999,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3116,3115,3,1,'[]','[{3116004,5830,8755,100,[{die_info,drop}]},{3116004,6531,8755,100,[{die_info,drop}]},{3116004,6582,8247,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3116,3115,4,1,'[]','[{3116007,11895,9272,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3117,3115,1,1,'[]','[{3117001,6617,2802,100,[]},{3117001,6700,2942,100,[]},{3117001,6814,3140,100,[]},{3117001,6989,3271,100,[]},{3117001,6581,2644,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3117,3115,1,2,'[]','[{3117001,6617,2802,100,[]},{3117001,6700,2942,100,[]},{3117001,6814,3140,100,[]},{3117001,6989,3271,100,[]},{3117001,6581,2644,100,[]}]','[]','[]',6000,0,1,2000,0,0,0,'',''),(3117,3115,2,1,'[]','[{3117002,1967,4417,100,[{die_info,drop}]},{3117002,2599,3999,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3117,3115,3,1,'[]','[{3117004,5830,8755,100,[{die_info,drop}]},{3117004,6531,8755,100,[{die_info,drop}]},{3117004,6582,8247,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3117,3115,4,1,'[]','[{3117007,11895,9272,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3118,3115,1,1,'[]','[{3118001,6617,2802,100,[]},{3118001,6700,2942,100,[]},{3118001,6814,3140,100,[]},{3118001,6989,3271,100,[]},{3118001,6581,2644,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3118,3115,1,2,'[]','[{3118001,6617,2802,100,[]},{3118001,6700,2942,100,[]},{3118001,6814,3140,100,[]},{3118001,6989,3271,100,[]},{3118001,6581,2644,100,[]}]','[]','[]',6000,0,1,2000,0,0,0,'',''),(3118,3115,2,1,'[]','[{3118002,1967,4417,100,[{die_info,drop}]},{3118002,2599,3999,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3118,3115,3,1,'[]','[{3118004,5830,8755,100,[{die_info,drop}]},{3118004,6531,8755,100,[{die_info,drop}]},{3118004,6582,8247,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3118,3115,4,1,'[]','[{3118007,11895,9272,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3119,3115,1,1,'[]','[{3119001,6617,2802,100,[]},{3119001,6700,2942,100,[]},{3119001,6814,3140,100,[]},{3119001,6989,3271,100,[]},{3119001,6581,2644,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3119,3115,1,2,'[]','[{3119001,6617,2802,100,[]},{3119001,6700,2942,100,[]},{3119001,6814,3140,100,[]},{3119001,6989,3271,100,[]},{3119001,6581,2644,100,[]}]','[]','[]',6000,0,1,2000,0,0,0,'',''),(3119,3115,2,1,'[]','[{3119002,1967,4417,100,[{die_info,drop}]},{3119002,2599,3999,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3119,3115,3,1,'[]','[{3119004,5830,8755,100,[{die_info,drop}]},{3119004,6531,8755,100,[{die_info,drop}]},{3119004,6582,8247,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3119,3115,4,1,'[]','[{3119007,11895,9272,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3120,3115,1,1,'[]','[{3120001,6617,2802,100,[]},{3120001,6700,2942,100,[]},{3120001,6814,3140,100,[]},{3120001,6989,3271,100,[]},{3120001,6581,2644,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3120,3115,1,2,'[]','[{3120001,6617,2802,100,[]},{3120001,6700,2942,100,[]},{3120001,6814,3140,100,[]},{3120001,6989,3271,100,[]},{3120001,6581,2644,100,[]}]','[]','[]',6000,0,1,2000,0,0,0,'',''),(3120,3115,2,1,'[]','[{3120002,1967,4417,100,[{die_info,drop}]},{3120002,2599,3999,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3120,3115,3,1,'[]','[{3120004,5830,8755,100,[{die_info,drop}]},{3120004,6531,8755,100,[{die_info,drop}]},{3120004,6582,8247,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3120,3115,4,1,'[]','[{3120007,11895,9272,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3121,3115,1,1,'[]','[{3121001,6617,2802,100,[]},{3121001,6700,2942,100,[]},{3121001,6814,3140,100,[]},{3121001,6989,3271,100,[]},{3121001,6581,2644,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3121,3115,1,2,'[]','[{3121001,6617,2802,100,[]},{3121001,6700,2942,100,[]},{3121001,6814,3140,100,[]},{3121001,6989,3271,100,[]},{3121001,6581,2644,100,[]}]','[]','[]',6000,0,1,2000,0,0,0,'',''),(3121,3115,2,1,'[]','[{3121002,1967,4417,100,[{die_info,drop}]},{3121002,2599,3999,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3121,3115,3,1,'[]','[{3121004,5830,8755,100,[{die_info,drop}]},{3121004,6531,8755,100,[{die_info,drop}]},{3121004,6582,8247,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3121,3115,4,1,'[]','[{3121007,11895,9272,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3122,3115,1,1,'[]','[{3122001,6617,2802,100,[]},{3122001,6700,2942,100,[]},{3122001,6814,3140,100,[]},{3122001,6989,3271,100,[]},{3122001,6581,2644,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3122,3115,1,2,'[]','[{3122001,6617,2802,100,[]},{3122001,6700,2942,100,[]},{3122001,6814,3140,100,[]},{3122001,6989,3271,100,[]},{3122001,6581,2644,100,[]}]','[]','[]',6000,0,1,2000,0,0,0,'',''),(3122,3115,2,1,'[]','[{3122002,1967,4417,100,[{die_info,drop}]},{3122002,2599,3999,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3122,3115,3,1,'[]','[{3122004,5830,8755,100,[{die_info,drop}]},{3122004,6531,8755,100,[{die_info,drop}]},{3122004,6582,8247,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3122,3115,4,1,'[]','[{3122007,11895,9272,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3300,3300,1,1,'[]','[{3300101,10505,3176,100,[]},{3300101,10579,3393,100,[]},{3300101,10895,3349,100,[]},{3300101,10783,3181,100,[]},{3300101,11021,3103,100,[]},{3300101,11172,3311,100,[]},{3300101,11129,3527,100,[]},{3300101,10804,3553,100,[]},{3300101,10947,3648,100,[]},{3300101,11315,3583,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3300101,10},{3,击杀周围的怪物，快速通关吧！,0}]'),(3300,3300,2,1,'[]','[{3300102,7567,5221,100,[]},{3300102,7369,4852,100,[]},{3300102,7171,4628,100,[]},{3300102,6690,4845,100,[]},{3300102,6842,5129,100,[]},{3300102,7231,5406,100,[]},{3300102,8029,5037,100,[]},{3300102,7937,4740,100,[]},{3300102,8075,4496,100,[]},{3300102,8504,4608,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3300102,10},{3,击杀周围的怪物，快速通关吧！,0}]'),(3300,3300,3,1,'[]','[{3300103,3288,9808,100,[]},{3300103,3378,10665,100,[]},{3300103,3743,9964,100,[]},{3300103,3847,9614,100,[]},{3300103,3459,9555,100,[]},{3300103,2901,9726,100,[]},{3300103,2931,10024,100,[]},{3300103,3586,10225,100,[]},{3300103,3169,10374,100,[]},{3300103,2625,10404,100,[]},{3300103,3080,9294,100,[]},{3300103,4011,9115,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3300103,12},{3,击杀周围的怪物，快速通关吧！,0}]'),(3300,3300,4,1,'[]','[{3300104,7138,17240,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3300104,1},{3,击杀最终的大魔王吧！}]'),(3300,3300,5,1,'[]','[{3300105,10505,3176,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3300,3300,6,1,'[]','[{3300106,7567,5221,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3300,3300,7,1,'[]','[{3300107,3288,9808,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3300,3300,8,1,'[]','[{3300108,7138,17240,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3300,3300,9,1,'[]','[{3300201,11091,4114,100,[]},{3300201,11348,3615,100,[]},{3300201,10927,3451,100,[]},{3300201,11442,3872,100,[]},{3300201,10981,3591,100,[]},{3300201,10482,3092,100,[]},{3300201,10232,3014,100,[]},{3300201,10490,2498,100,[]},{3300201,10997,2990,100,[]},{3300201,10646,3427,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3300201,10},{3,击杀周围的怪物，快速通关吧！,0}]'),(3300,3300,10,1,'[]','[{3300202,10678,10198,100,[]},{3300202,10936,10355,100,[]},{3300202,11067,10572,100,[]},{3300202,10334,10218,100,[]},{3300202,11057,10749,100,[]},{3300202,10870,10865,100,[]},{3300202,10582,10900,100,[]},{3300202,10284,10875,100,[]},{3300202,10132,10678,100,[]},{3300202,10183,10451,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3300202,10},{3,击杀周围的怪物，快速通关吧！,0}]'),(3300,3300,11,1,'[]','[{3300203,17112,18086,100,[]},{3300203,16368,18148,100,[]},{3300203,17126,18810,100,[]},{3300203,17581,18644,100,[]},{3300203,17801,18334,100,[]},{3300203,16450,17831,100,[]},{3300203,17346,17369,100,[]},{3300203,17863,17969,100,[]},{3300203,16616,17548,100,[]},{3300203,17718,17590,100,[]},{3300203,16919,17349,100,[]},{3300203,16512,18603,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3300203,12},{3,击杀周围的怪物，快速通关吧！,0}]'),(3300,3300,12,1,'[]','[{3300204,17112,18086,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3300204,1},{3,击杀最终的大魔王吧！}]'),(3300,3300,13,1,'[]','[{3300205,11442,3872,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3300,3300,14,1,'[]','[{3300206,10678,10198,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3300,3300,15,1,'[]','[{3300207,17112,18086,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3300,3300,16,1,'[]','[{3300208,17112,18086,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3300,3300,17,1,'[]','[{3300301,10505,3176,100,[]},{3300301,10579,3393,100,[]},{3300301,10895,3349,100,[]},{3300301,10783,3181,100,[]},{3300301,11021,3103,100,[]},{3300301,11172,3311,100,[]},{3300301,11129,3527,100,[]},{3300301,10804,3553,100,[]},{3300301,10947,3648,100,[]},{3300301,11315,3583,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3300301,10},{3,击杀周围的怪物，快速通关吧！,0}]'),(3300,3300,18,1,'[]','[{3300302,7567,5221,100,[]},{3300302,7369,4852,100,[]},{3300302,7171,4628,100,[]},{3300302,6690,4845,100,[]},{3300302,6842,5129,100,[]},{3300302,7231,5406,100,[]},{3300302,8029,5037,100,[]},{3300302,7937,4740,100,[]},{3300302,8075,4496,100,[]},{3300302,8504,4608,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3300302,10},{3,击杀周围的怪物，快速通关吧！,0}]'),(3300,3300,19,1,'[]','[{3300303,3288,9808,100,[]},{3300303,3378,10665,100,[]},{3300303,3743,9964,100,[]},{3300303,3847,9614,100,[]},{3300303,3459,9555,100,[]},{3300303,2901,9726,100,[]},{3300303,2931,10024,100,[]},{3300303,3586,10225,100,[]},{3300303,3169,10374,100,[]},{3300303,2625,10404,100,[]},{3300303,3080,9294,100,[]},{3300303,4011,9115,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3300303,12},{3,击杀周围的怪物，快速通关吧！,0}]'),(3300,3300,20,1,'[]','[{3300304,7138,17240,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3300304,1},{3,击杀最终的大魔王吧！}]'),(3300,3300,21,1,'[]','[{3300305,10505,3176,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3300,3300,22,1,'[]','[{3300306,7567,5221,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3300,3300,23,1,'[]','[{3300307,3288,9808,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3300,3300,24,1,'[]','[{3300308,7138,17240,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3300,3300,25,1,'[]','[{3300401,11091,4114,100,[]},{3300401,11348,3615,100,[]},{3300401,10927,3451,100,[]},{3300401,11442,3872,100,[]},{3300401,10981,3591,100,[]},{3300401,10482,3092,100,[]},{3300401,10232,3014,100,[]},{3300401,10490,2498,100,[]},{3300401,10997,2990,100,[]},{3300401,10646,3427,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3300401,10},{3,击杀周围的怪物，快速通关吧！,0}]'),(3300,3300,26,1,'[]','[{3300402,10678,10198,100,[]},{3300402,10936,10355,100,[]},{3300402,11067,10572,100,[]},{3300402,10334,10218,100,[]},{3300402,11057,10749,100,[]},{3300402,10870,10865,100,[]},{3300402,10582,10900,100,[]},{3300402,10284,10875,100,[]},{3300402,10132,10678,100,[]},{3300402,10183,10451,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3300402,10},{3,击杀周围的怪物，快速通关吧！,0}]'),(3300,3300,27,1,'[]','[{3300403,17112,18086,100,[]},{3300403,16368,18148,100,[]},{3300403,17126,18810,100,[]},{3300403,17581,18644,100,[]},{3300403,17801,18334,100,[]},{3300403,16450,17831,100,[]},{3300403,17346,17369,100,[]},{3300403,17863,17969,100,[]},{3300403,16616,17548,100,[]},{3300403,17718,17590,100,[]},{3300403,16919,17349,100,[]},{3300403,16512,18603,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3300403,12},{3,击杀周围的怪物，快速通关吧！,0}]'),(3300,3300,28,1,'[]','[{3300404,17112,18086,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3300404,1},{3,击杀最终的大魔王吧！}]'),(3300,3300,29,1,'[]','[{3300405,10981,3591,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3300,3300,30,1,'[]','[{3300406,10678,10198,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3300,3300,31,1,'[]','[{3300407,17112,18086,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3300,3300,32,1,'[]','[{3300408,17112,18086,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3300,3300,33,1,'[]','[{3300701,17112,18086,100,[]},{3300701,16368,18148,100,[]},{3300701,17126,18810,100,[]},{3300701,17581,18644,100,[]},{3300701,17801,18334,100,[]},{3300701,16450,17831,100,[]},{3300701,17346,17369,100,[]},{3300701,17863,17969,100,[]},{3300701,16616,17548,100,[]},{3300701,17718,17590,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{2,3300701,10},{3,地上有好多机械星呢，捡起来看看！,0}]'),(3300,3300,34,1,'[]','[{3300702,3288,9808,100,[]},{3300702,3378,10665,100,[]},{3300702,3743,9964,100,[]},{3300702,3847,9614,100,[]},{3300702,3459,9555,100,[]},{3300702,2901,9726,100,[]},{3300702,2931,10024,100,[]},{3300702,3586,10225,100,[]},{3300702,3169,10374,100,[]},{3300702,2625,10404,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{2,3300702,10},{3,地上有好多机械元呢，捡起来看看！,0}]'),(3301,3301,1,1,'[]','[{3301101,10505,3176,100,[]},{3301101,10579,3393,100,[]},{3301101,10895,3349,100,[]},{3301101,10783,3181,100,[]},{3301101,11021,3103,100,[]},{3301101,11172,3311,100,[]},{3301101,11129,3527,100,[]},{3301101,10804,3553,100,[]},{3301101,10947,3648,100,[]},{3301101,11315,3583,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3301101,10},{3,击杀周围的怪物，快速通关吧！,0}]'),(3301,3301,2,1,'[]','[{3301102,7567,5221,100,[]},{3301102,7369,4852,100,[]},{3301102,7171,4628,100,[]},{3301102,6690,4845,100,[]},{3301102,6842,5129,100,[]},{3301102,7231,5406,100,[]},{3301102,8029,5037,100,[]},{3301102,7937,4740,100,[]},{3301102,8075,4496,100,[]},{3301102,8504,4608,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3301102,10},{3,击杀周围的怪物，快速通关吧！,0}]'),(3301,3301,3,1,'[]','[{3301103,3288,9808,100,[]},{3301103,3378,10665,100,[]},{3301103,3743,9964,100,[]},{3301103,3847,9614,100,[]},{3301103,3459,9555,100,[]},{3301103,2901,9726,100,[]},{3301103,2931,10024,100,[]},{3301103,3586,10225,100,[]},{3301103,3169,10374,100,[]},{3301103,2625,10404,100,[]},{3301103,3080,9294,100,[]},{3301103,4011,9115,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3301103,12},{3,击杀周围的怪物，快速通关吧！,0}]'),(3301,3301,4,1,'[]','[{3301104,7138,17240,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3301104,1},{3,击杀最终的大魔王吧！}]'),(3301,3301,5,1,'[]','[{3301105,10505,3176,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3301,3301,6,1,'[]','[{3301106,7567,5221,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3301,3301,7,1,'[]','[{3301107,3288,9808,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3301,3301,8,1,'[]','[{3301108,7138,17240,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3301,3301,9,1,'[]','[{3301201,11091,4114,100,[]},{3301201,11348,3615,100,[]},{3301201,10927,3451,100,[]},{3301201,11442,3872,100,[]},{3301201,10981,3591,100,[]},{3301201,10482,3092,100,[]},{3301201,10232,3014,100,[]},{3301201,10490,2498,100,[]},{3301201,10997,2990,100,[]},{3301201,10646,3427,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3301201,10},{3,击杀周围的怪物，快速通关吧！,0}]'),(3301,3301,10,1,'[]','[{3301202,10678,10198,100,[]},{3301202,10936,10355,100,[]},{3301202,11067,10572,100,[]},{3301202,10334,10218,100,[]},{3301202,11057,10749,100,[]},{3301202,10870,10865,100,[]},{3301202,10582,10900,100,[]},{3301202,10284,10875,100,[]},{3301202,10132,10678,100,[]},{3301202,10183,10451,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3301202,10},{3,击杀周围的怪物，快速通关吧！,0}]'),(3301,3301,11,1,'[]','[{3301203,17112,18086,100,[]},{3301203,16368,18148,100,[]},{3301203,17126,18810,100,[]},{3301203,17581,18644,100,[]},{3301203,17801,18334,100,[]},{3301203,16450,17831,100,[]},{3301203,17346,17369,100,[]},{3301203,17863,17969,100,[]},{3301203,16616,17548,100,[]},{3301203,17718,17590,100,[]},{3301203,16919,17349,100,[]},{3301203,16512,18603,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3301203,12},{3,击杀周围的怪物，快速通关吧！,0}]'),(3301,3301,12,1,'[]','[{3301204,17112,18086,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3301204,1},{3,击杀最终的大魔王吧！}]'),(3301,3301,13,1,'[]','[{3301205,11442,3872,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3301,3301,14,1,'[]','[{3301206,10678,10198,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3301,3301,15,1,'[]','[{3301207,17112,18086,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3301,3301,16,1,'[]','[{3301208,17112,18086,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3301,3301,17,1,'[]','[{3301301,10505,3176,100,[]},{3301301,10579,3393,100,[]},{3301301,10895,3349,100,[]},{3301301,10783,3181,100,[]},{3301301,11021,3103,100,[]},{3301301,11172,3311,100,[]},{3301301,11129,3527,100,[]},{3301301,10804,3553,100,[]},{3301301,10947,3648,100,[]},{3301301,11315,3583,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3301301,10},{3,击杀周围的怪物，快速通关吧！,0}]'),(3301,3301,18,1,'[]','[{3301302,7567,5221,100,[]},{3301302,7369,4852,100,[]},{3301302,7171,4628,100,[]},{3301302,6690,4845,100,[]},{3301302,6842,5129,100,[]},{3301302,7231,5406,100,[]},{3301302,8029,5037,100,[]},{3301302,7937,4740,100,[]},{3301302,8075,4496,100,[]},{3301302,8504,4608,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3301302,10},{3,击杀周围的怪物，快速通关吧！,0}]'),(3301,3301,19,1,'[]','[{3301303,3288,9808,100,[]},{3301303,3378,10665,100,[]},{3301303,3743,9964,100,[]},{3301303,3847,9614,100,[]},{3301303,3459,9555,100,[]},{3301303,2901,9726,100,[]},{3301303,2931,10024,100,[]},{3301303,3586,10225,100,[]},{3301303,3169,10374,100,[]},{3301303,2625,10404,100,[]},{3301303,3080,9294,100,[]},{3301303,4011,9115,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3301303,12},{3,击杀周围的怪物，快速通关吧！,0}]'),(3301,3301,20,1,'[]','[{3301304,7138,17240,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3301304,1},{3,击杀最终的大魔王吧！}]'),(3301,3301,21,1,'[]','[{3301305,10505,3176,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3301,3301,22,1,'[]','[{3301306,7567,5221,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3301,3301,23,1,'[]','[{3301307,3288,9808,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3301,3301,24,1,'[]','[{3301308,7138,17240,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3301,3301,25,1,'[]','[{3301401,11091,4114,100,[]},{3301401,11348,3615,100,[]},{3301401,10927,3451,100,[]},{3301401,11442,3872,100,[]},{3301401,10981,3591,100,[]},{3301401,10482,3092,100,[]},{3301401,10232,3014,100,[]},{3301401,10490,2498,100,[]},{3301401,10997,2990,100,[]},{3301401,10646,3427,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3301401,10},{3,击杀周围的怪物，快速通关吧！,0}]'),(3301,3301,26,1,'[]','[{3301402,10678,10198,100,[]},{3301402,10936,10355,100,[]},{3301402,11067,10572,100,[]},{3301402,10334,10218,100,[]},{3301402,11057,10749,100,[]},{3301402,10870,10865,100,[]},{3301402,10582,10900,100,[]},{3301402,10284,10875,100,[]},{3301402,10132,10678,100,[]},{3301402,10183,10451,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3301402,10},{3,击杀周围的怪物，快速通关吧！,0}]'),(3301,3301,27,1,'[]','[{3301403,17112,18086,100,[]},{3301403,16368,18148,100,[]},{3301403,17126,18810,100,[]},{3301403,17581,18644,100,[]},{3301403,17801,18334,100,[]},{3301403,16450,17831,100,[]},{3301403,17346,17369,100,[]},{3301403,17863,17969,100,[]},{3301403,16616,17548,100,[]},{3301403,17718,17590,100,[]},{3301403,16919,17349,100,[]},{3301403,16512,18603,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3301403,12},{3,击杀周围的怪物，快速通关吧！,0}]'),(3301,3301,28,1,'[]','[{3301404,17112,18086,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3301404,1},{3,击杀最终的大魔王吧！}]'),(3301,3301,29,1,'[]','[{3301405,10981,3591,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3301,3301,30,1,'[]','[{3301406,10678,10198,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3301,3301,31,1,'[]','[{3301407,17112,18086,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3301,3301,32,1,'[]','[{3301408,17112,18086,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3301,3301,33,1,'[]','[{3301701,17112,18086,100,[]},{3301701,16368,18148,100,[]},{3301701,17126,18810,100,[]},{3301701,17581,18644,100,[]},{3301701,17801,18334,100,[]},{3301701,16450,17831,100,[]},{3301701,17346,17369,100,[]},{3301701,17863,17969,100,[]},{3301701,16616,17548,100,[]},{3301701,17718,17590,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{2,3301701,10},{3,地上有好多机械星呢，捡起来看看！,0}]'),(3301,3301,34,1,'[]','[{3301702,3288,9808,100,[]},{3301702,3378,10665,100,[]},{3301702,3743,9964,100,[]},{3301702,3847,9614,100,[]},{3301702,3459,9555,100,[]},{3301702,2901,9726,100,[]},{3301702,2931,10024,100,[]},{3301702,3586,10225,100,[]},{3301702,3169,10374,100,[]},{3301702,2625,10404,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{2,3301702,10},{3,地上有好多机械元呢，捡起来看看！,0}]'),(3302,3302,1,1,'[]','[{3302101,10505,3176,100,[]},{3302101,10579,3393,100,[]},{3302101,10895,3349,100,[]},{3302101,10783,3181,100,[]},{3302101,11021,3103,100,[]},{3302101,11172,3311,100,[]},{3302101,11129,3527,100,[]},{3302101,10804,3553,100,[]},{3302101,10947,3648,100,[]},{3302101,11315,3583,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3302101,10},{3,击杀周围的怪物，快速通关吧！,0}]'),(3302,3302,2,1,'[]','[{3302102,7567,5221,100,[]},{3302102,7369,4852,100,[]},{3302102,7171,4628,100,[]},{3302102,6690,4845,100,[]},{3302102,6842,5129,100,[]},{3302102,7231,5406,100,[]},{3302102,8029,5037,100,[]},{3302102,7937,4740,100,[]},{3302102,8075,4496,100,[]},{3302102,8504,4608,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3302102,10},{3,击杀周围的怪物，快速通关吧！,0}]'),(3302,3302,3,1,'[]','[{3302103,3288,9808,100,[]},{3302103,3378,10665,100,[]},{3302103,3743,9964,100,[]},{3302103,3847,9614,100,[]},{3302103,3459,9555,100,[]},{3302103,2901,9726,100,[]},{3302103,2931,10024,100,[]},{3302103,3586,10225,100,[]},{3302103,3169,10374,100,[]},{3302103,2625,10404,100,[]},{3302103,3080,9294,100,[]},{3302103,4011,9115,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3302103,12},{3,击杀周围的怪物，快速通关吧！,0}]'),(3302,3302,4,1,'[]','[{3302104,7138,17240,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3302104,1},{3,击杀最终的大魔王吧！}]'),(3302,3302,5,1,'[]','[{3302105,10505,3176,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3302,3302,6,1,'[]','[{3302106,7567,5221,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3302,3302,7,1,'[]','[{3302107,3288,9808,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3302,3302,8,1,'[]','[{3302108,7138,17240,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3302,3302,9,1,'[]','[{3302201,11091,4114,100,[]},{3302201,11348,3615,100,[]},{3302201,10927,3451,100,[]},{3302201,11442,3872,100,[]},{3302201,10981,3591,100,[]},{3302201,10482,3092,100,[]},{3302201,10232,3014,100,[]},{3302201,10490,2498,100,[]},{3302201,10997,2990,100,[]},{3302201,10646,3427,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3302201,10},{3,击杀周围的怪物，快速通关吧！,0}]'),(3302,3302,10,1,'[]','[{3302202,10678,10198,100,[]},{3302202,10936,10355,100,[]},{3302202,11067,10572,100,[]},{3302202,10334,10218,100,[]},{3302202,11057,10749,100,[]},{3302202,10870,10865,100,[]},{3302202,10582,10900,100,[]},{3302202,10284,10875,100,[]},{3302202,10132,10678,100,[]},{3302202,10183,10451,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3302202,10},{3,击杀周围的怪物，快速通关吧！,0}]'),(3302,3302,11,1,'[]','[{3302203,17112,18086,100,[]},{3302203,16368,18148,100,[]},{3302203,17126,18810,100,[]},{3302203,17581,18644,100,[]},{3302203,17801,18334,100,[]},{3302203,16450,17831,100,[]},{3302203,17346,17369,100,[]},{3302203,17863,17969,100,[]},{3302203,16616,17548,100,[]},{3302203,17718,17590,100,[]},{3302203,16919,17349,100,[]},{3302203,16512,18603,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3302203,12},{3,击杀周围的怪物，快速通关吧！,0}]'),(3302,3302,12,1,'[]','[{3302204,17112,18086,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3302204,1},{3,击杀最终的大魔王吧！}]'),(3302,3302,13,1,'[]','[{3302205,11442,3872,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3302,3302,14,1,'[]','[{3302206,10678,10198,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3302,3302,15,1,'[]','[{3302207,17112,18086,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3302,3302,16,1,'[]','[{3302208,17112,18086,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3302,3302,17,1,'[]','[{3302301,10505,3176,100,[]},{3302301,10579,3393,100,[]},{3302301,10895,3349,100,[]},{3302301,10783,3181,100,[]},{3302301,11021,3103,100,[]},{3302301,11172,3311,100,[]},{3302301,11129,3527,100,[]},{3302301,10804,3553,100,[]},{3302301,10947,3648,100,[]},{3302301,11315,3583,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3302301,10},{3,击杀周围的怪物，快速通关吧！,0}]'),(3302,3302,18,1,'[]','[{3302302,7567,5221,100,[]},{3302302,7369,4852,100,[]},{3302302,7171,4628,100,[]},{3302302,6690,4845,100,[]},{3302302,6842,5129,100,[]},{3302302,7231,5406,100,[]},{3302302,8029,5037,100,[]},{3302302,7937,4740,100,[]},{3302302,8075,4496,100,[]},{3302302,8504,4608,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3302302,10},{3,击杀周围的怪物，快速通关吧！,0}]'),(3302,3302,19,1,'[]','[{3302303,3288,9808,100,[]},{3302303,3378,10665,100,[]},{3302303,3743,9964,100,[]},{3302303,3847,9614,100,[]},{3302303,3459,9555,100,[]},{3302303,2901,9726,100,[]},{3302303,2931,10024,100,[]},{3302303,3586,10225,100,[]},{3302303,3169,10374,100,[]},{3302303,2625,10404,100,[]},{3302303,3080,9294,100,[]},{3302303,4011,9115,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3302303,12},{3,击杀周围的怪物，快速通关吧！,0}]'),(3302,3302,20,1,'[]','[{3302304,7138,17240,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3302304,1},{3,击杀最终的大魔王吧！}]'),(3302,3302,21,1,'[]','[{3302305,10505,3176,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3302,3302,22,1,'[]','[{3302306,7567,5221,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3302,3302,23,1,'[]','[{3302307,3288,9808,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3302,3302,24,1,'[]','[{3302308,7138,17240,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3302,3302,25,1,'[]','[{3302401,11091,4114,100,[]},{3302401,11348,3615,100,[]},{3302401,10927,3451,100,[]},{3302401,11442,3872,100,[]},{3302401,10981,3591,100,[]},{3302401,10482,3092,100,[]},{3302401,10232,3014,100,[]},{3302401,10490,2498,100,[]},{3302401,10997,2990,100,[]},{3302401,10646,3427,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3302401,10},{3,击杀周围的怪物，快速通关吧！,0}]'),(3302,3302,26,1,'[]','[{3302402,10678,10198,100,[]},{3302402,10936,10355,100,[]},{3302402,11067,10572,100,[]},{3302402,10334,10218,100,[]},{3302402,11057,10749,100,[]},{3302402,10870,10865,100,[]},{3302402,10582,10900,100,[]},{3302402,10284,10875,100,[]},{3302402,10132,10678,100,[]},{3302402,10183,10451,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3302402,10},{3,击杀周围的怪物，快速通关吧！,0}]'),(3302,3302,27,1,'[]','[{3302403,17112,18086,100,[]},{3302403,16368,18148,100,[]},{3302403,17126,18810,100,[]},{3302403,17581,18644,100,[]},{3302403,17801,18334,100,[]},{3302403,16450,17831,100,[]},{3302403,17346,17369,100,[]},{3302403,17863,17969,100,[]},{3302403,16616,17548,100,[]},{3302403,17718,17590,100,[]},{3302403,16919,17349,100,[]},{3302403,16512,18603,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3302403,12},{3,击杀周围的怪物，快速通关吧！,0}]'),(3302,3302,28,1,'[]','[{3302404,17112,18086,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3302404,1},{3,击杀最终的大魔王吧！}]'),(3302,3302,29,1,'[]','[{3302405,10981,3591,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3302,3302,30,1,'[]','[{3302406,10678,10198,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3302,3302,31,1,'[]','[{3302407,17112,18086,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3302,3302,32,1,'[]','[{3302408,17112,18086,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3302,3302,33,1,'[]','[{3302701,17112,18086,100,[]},{3302701,16368,18148,100,[]},{3302701,17126,18810,100,[]},{3302701,17581,18644,100,[]},{3302701,17801,18334,100,[]},{3302701,16450,17831,100,[]},{3302701,17346,17369,100,[]},{3302701,17863,17969,100,[]},{3302701,16616,17548,100,[]},{3302701,17718,17590,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{2,3302701,10},{3,地上有好多机械星呢，捡起来看看！,0}]'),(3302,3302,34,1,'[]','[{3302702,3288,9808,100,[]},{3302702,3378,10665,100,[]},{3302702,3743,9964,100,[]},{3302702,3847,9614,100,[]},{3302702,3459,9555,100,[]},{3302702,2901,9726,100,[]},{3302702,2931,10024,100,[]},{3302702,3586,10225,100,[]},{3302702,3169,10374,100,[]},{3302702,2625,10404,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{2,3302702,10},{3,地上有好多机械元呢，捡起来看看！,0}]'),(3303,3303,1,1,'[]','[{3303101,10505,3176,100,[]},{3303101,10579,3393,100,[]},{3303101,10895,3349,100,[]},{3303101,10783,3181,100,[]},{3303101,11021,3103,100,[]},{3303101,11172,3311,100,[]},{3303101,11129,3527,100,[]},{3303101,10804,3553,100,[]},{3303101,10947,3648,100,[]},{3303101,11315,3583,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3303101,10},{3,击杀周围的怪物，快速通关吧！,0}]'),(3303,3303,2,1,'[]','[{3303102,7567,5221,100,[]},{3303102,7369,4852,100,[]},{3303102,7171,4628,100,[]},{3303102,6690,4845,100,[]},{3303102,6842,5129,100,[]},{3303102,7231,5406,100,[]},{3303102,8029,5037,100,[]},{3303102,7937,4740,100,[]},{3303102,8075,4496,100,[]},{3303102,8504,4608,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3303102,10},{3,击杀周围的怪物，快速通关吧！,0}]'),(3303,3303,3,1,'[]','[{3303103,3288,9808,100,[]},{3303103,3378,10665,100,[]},{3303103,3743,9964,100,[]},{3303103,3847,9614,100,[]},{3303103,3459,9555,100,[]},{3303103,2901,9726,100,[]},{3303103,2931,10024,100,[]},{3303103,3586,10225,100,[]},{3303103,3169,10374,100,[]},{3303103,2625,10404,100,[]},{3303103,3080,9294,100,[]},{3303103,4011,9115,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3303103,12},{3,击杀周围的怪物，快速通关吧！,0}]'),(3303,3303,4,1,'[]','[{3303104,7138,17240,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3303104,1},{3,击杀最终的大魔王吧！}]'),(3303,3303,5,1,'[]','[{3303105,10505,3176,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3303,3303,6,1,'[]','[{3303106,7567,5221,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3303,3303,7,1,'[]','[{3303107,3288,9808,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3303,3303,8,1,'[]','[{3303108,7138,17240,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3303,3303,9,1,'[]','[{3303201,11091,4114,100,[]},{3303201,11348,3615,100,[]},{3303201,10927,3451,100,[]},{3303201,11442,3872,100,[]},{3303201,10981,3591,100,[]},{3303201,10482,3092,100,[]},{3303201,10232,3014,100,[]},{3303201,10490,2498,100,[]},{3303201,10997,2990,100,[]},{3303201,10646,3427,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3303201,10},{3,击杀周围的怪物，快速通关吧！,0}]'),(3303,3303,10,1,'[]','[{3303202,10678,10198,100,[]},{3303202,10936,10355,100,[]},{3303202,11067,10572,100,[]},{3303202,10334,10218,100,[]},{3303202,11057,10749,100,[]},{3303202,10870,10865,100,[]},{3303202,10582,10900,100,[]},{3303202,10284,10875,100,[]},{3303202,10132,10678,100,[]},{3303202,10183,10451,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3303202,10},{3,击杀周围的怪物，快速通关吧！,0}]'),(3303,3303,11,1,'[]','[{3303203,17112,18086,100,[]},{3303203,16368,18148,100,[]},{3303203,17126,18810,100,[]},{3303203,17581,18644,100,[]},{3303203,17801,18334,100,[]},{3303203,16450,17831,100,[]},{3303203,17346,17369,100,[]},{3303203,17863,17969,100,[]},{3303203,16616,17548,100,[]},{3303203,17718,17590,100,[]},{3303203,16919,17349,100,[]},{3303203,16512,18603,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3303203,12},{3,击杀周围的怪物，快速通关吧！,0}]'),(3303,3303,12,1,'[]','[{3303204,17112,18086,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3303204,1},{3,击杀最终的大魔王吧！}]'),(3303,3303,13,1,'[]','[{3303205,11442,3872,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3303,3303,14,1,'[]','[{3303206,10678,10198,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3303,3303,15,1,'[]','[{3303207,17112,18086,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3303,3303,16,1,'[]','[{3303208,17112,18086,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3303,3303,17,1,'[]','[{3303301,10505,3176,100,[]},{3303301,10579,3393,100,[]},{3303301,10895,3349,100,[]},{3303301,10783,3181,100,[]},{3303301,11021,3103,100,[]},{3303301,11172,3311,100,[]},{3303301,11129,3527,100,[]},{3303301,10804,3553,100,[]},{3303301,10947,3648,100,[]},{3303301,11315,3583,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3303301,10},{3,击杀周围的怪物，快速通关吧！,0}]'),(3303,3303,18,1,'[]','[{3303302,7567,5221,100,[]},{3303302,7369,4852,100,[]},{3303302,7171,4628,100,[]},{3303302,6690,4845,100,[]},{3303302,6842,5129,100,[]},{3303302,7231,5406,100,[]},{3303302,8029,5037,100,[]},{3303302,7937,4740,100,[]},{3303302,8075,4496,100,[]},{3303302,8504,4608,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3303302,10},{3,击杀周围的怪物，快速通关吧！,0}]'),(3303,3303,19,1,'[]','[{3303303,3288,9808,100,[]},{3303303,3378,10665,100,[]},{3303303,3743,9964,100,[]},{3303303,3847,9614,100,[]},{3303303,3459,9555,100,[]},{3303303,2901,9726,100,[]},{3303303,2931,10024,100,[]},{3303303,3586,10225,100,[]},{3303303,3169,10374,100,[]},{3303303,2625,10404,100,[]},{3303303,3080,9294,100,[]},{3303303,4011,9115,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3303303,12},{3,击杀周围的怪物，快速通关吧！,0}]'),(3303,3303,20,1,'[]','[{3303304,7138,17240,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3303304,1},{3,击杀最终的大魔王吧！}]'),(3303,3303,21,1,'[]','[{3303305,10505,3176,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3303,3303,22,1,'[]','[{3303306,7567,5221,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3303,3303,23,1,'[]','[{3303307,3288,9808,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3303,3303,24,1,'[]','[{3303308,7138,17240,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3303,3303,25,1,'[]','[{3303401,11091,4114,100,[]},{3303401,11348,3615,100,[]},{3303401,10927,3451,100,[]},{3303401,11442,3872,100,[]},{3303401,10981,3591,100,[]},{3303401,10482,3092,100,[]},{3303401,10232,3014,100,[]},{3303401,10490,2498,100,[]},{3303401,10997,2990,100,[]},{3303401,10646,3427,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3303401,10},{3,击杀周围的怪物，快速通关吧！,0}]'),(3303,3303,26,1,'[]','[{3303402,10678,10198,100,[]},{3303402,10936,10355,100,[]},{3303402,11067,10572,100,[]},{3303402,10334,10218,100,[]},{3303402,11057,10749,100,[]},{3303402,10870,10865,100,[]},{3303402,10582,10900,100,[]},{3303402,10284,10875,100,[]},{3303402,10132,10678,100,[]},{3303402,10183,10451,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3303402,10},{3,击杀周围的怪物，快速通关吧！,0}]'),(3303,3303,27,1,'[]','[{3303403,17112,18086,100,[]},{3303403,16368,18148,100,[]},{3303403,17126,18810,100,[]},{3303403,17581,18644,100,[]},{3303403,17801,18334,100,[]},{3303403,16450,17831,100,[]},{3303403,17346,17369,100,[]},{3303403,17863,17969,100,[]},{3303403,16616,17548,100,[]},{3303403,17718,17590,100,[]},{3303403,16919,17349,100,[]},{3303403,16512,18603,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3303403,12},{3,击杀周围的怪物，快速通关吧！,0}]'),(3303,3303,28,1,'[]','[{3303404,17112,18086,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3303404,1},{3,击杀最终的大魔王吧！}]'),(3303,3303,29,1,'[]','[{3303405,10981,3591,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3303,3303,30,1,'[]','[{3303406,10678,10198,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3303,3303,31,1,'[]','[{3303407,17112,18086,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3303,3303,32,1,'[]','[{3303408,17112,18086,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3303,3303,33,1,'[]','[{3303701,17112,18086,100,[]},{3303701,16368,18148,100,[]},{3303701,17126,18810,100,[]},{3303701,17581,18644,100,[]},{3303701,17801,18334,100,[]},{3303701,16450,17831,100,[]},{3303701,17346,17369,100,[]},{3303701,17863,17969,100,[]},{3303701,16616,17548,100,[]},{3303701,17718,17590,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{2,3303701,10},{3,地上有好多机械星呢，捡起来看看！,0}]'),(3303,3303,34,1,'[]','[{3303702,3288,9808,100,[]},{3303702,3378,10665,100,[]},{3303702,3743,9964,100,[]},{3303702,3847,9614,100,[]},{3303702,3459,9555,100,[]},{3303702,2901,9726,100,[]},{3303702,2931,10024,100,[]},{3303702,3586,10225,100,[]},{3303702,3169,10374,100,[]},{3303702,2625,10404,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{2,3303702,10},{3,地上有好多机械元呢，捡起来看看！,0}]'),(3304,3304,1,1,'[]','[{3304101,10505,3176,100,[]},{3304101,10579,3393,100,[]},{3304101,10895,3349,100,[]},{3304101,10783,3181,100,[]},{3304101,11021,3103,100,[]},{3304101,11172,3311,100,[]},{3304101,11129,3527,100,[]},{3304101,10804,3553,100,[]},{3304101,10947,3648,100,[]},{3304101,11315,3583,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3304101,10},{3,击杀周围的怪物，快速通关吧！,0}]'),(3304,3304,2,1,'[]','[{3304102,7567,5221,100,[]},{3304102,7369,4852,100,[]},{3304102,7171,4628,100,[]},{3304102,6690,4845,100,[]},{3304102,6842,5129,100,[]},{3304102,7231,5406,100,[]},{3304102,8029,5037,100,[]},{3304102,7937,4740,100,[]},{3304102,8075,4496,100,[]},{3304102,8504,4608,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3304102,10},{3,击杀周围的怪物，快速通关吧！,0}]'),(3304,3304,3,1,'[]','[{3304103,3288,9808,100,[]},{3304103,3378,10665,100,[]},{3304103,3743,9964,100,[]},{3304103,3847,9614,100,[]},{3304103,3459,9555,100,[]},{3304103,2901,9726,100,[]},{3304103,2931,10024,100,[]},{3304103,3586,10225,100,[]},{3304103,3169,10374,100,[]},{3304103,2625,10404,100,[]},{3304103,3080,9294,100,[]},{3304103,4011,9115,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3304103,12},{3,击杀周围的怪物，快速通关吧！,0}]'),(3304,3304,4,1,'[]','[{3304104,7138,17240,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3304104,1},{3,击杀最终的大魔王吧！}]'),(3304,3304,5,1,'[]','[{3304105,10505,3176,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3304,3304,6,1,'[]','[{3304106,7567,5221,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3304,3304,7,1,'[]','[{3304107,3288,9808,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3304,3304,8,1,'[]','[{3304108,7138,17240,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3304,3304,9,1,'[]','[{3304201,11091,4114,100,[]},{3304201,11348,3615,100,[]},{3304201,10927,3451,100,[]},{3304201,11442,3872,100,[]},{3304201,10981,3591,100,[]},{3304201,10482,3092,100,[]},{3304201,10232,3014,100,[]},{3304201,10490,2498,100,[]},{3304201,10997,2990,100,[]},{3304201,10646,3427,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3304201,10},{3,击杀周围的怪物，快速通关吧！,0}]'),(3304,3304,10,1,'[]','[{3304202,10678,10198,100,[]},{3304202,10936,10355,100,[]},{3304202,11067,10572,100,[]},{3304202,10334,10218,100,[]},{3304202,11057,10749,100,[]},{3304202,10870,10865,100,[]},{3304202,10582,10900,100,[]},{3304202,10284,10875,100,[]},{3304202,10132,10678,100,[]},{3304202,10183,10451,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3304202,10},{3,击杀周围的怪物，快速通关吧！,0}]'),(3304,3304,11,1,'[]','[{3304203,17112,18086,100,[]},{3304203,16368,18148,100,[]},{3304203,17126,18810,100,[]},{3304203,17581,18644,100,[]},{3304203,17801,18334,100,[]},{3304203,16450,17831,100,[]},{3304203,17346,17369,100,[]},{3304203,17863,17969,100,[]},{3304203,16616,17548,100,[]},{3304203,17718,17590,100,[]},{3304203,16919,17349,100,[]},{3304203,16512,18603,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3304203,12},{3,击杀周围的怪物，快速通关吧！,0}]'),(3304,3304,12,1,'[]','[{3304204,17112,18086,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3304204,1},{3,击杀最终的大魔王吧！}]'),(3304,3304,13,1,'[]','[{3304205,11442,3872,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3304,3304,14,1,'[]','[{3304206,10678,10198,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3304,3304,15,1,'[]','[{3304207,17112,18086,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3304,3304,16,1,'[]','[{3304208,17112,18086,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3304,3304,17,1,'[]','[{3304301,10505,3176,100,[]},{3304301,10579,3393,100,[]},{3304301,10895,3349,100,[]},{3304301,10783,3181,100,[]},{3304301,11021,3103,100,[]},{3304301,11172,3311,100,[]},{3304301,11129,3527,100,[]},{3304301,10804,3553,100,[]},{3304301,10947,3648,100,[]},{3304301,11315,3583,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3304301,10},{3,击杀周围的怪物，快速通关吧！,0}]'),(3304,3304,18,1,'[]','[{3304302,7567,5221,100,[]},{3304302,7369,4852,100,[]},{3304302,7171,4628,100,[]},{3304302,6690,4845,100,[]},{3304302,6842,5129,100,[]},{3304302,7231,5406,100,[]},{3304302,8029,5037,100,[]},{3304302,7937,4740,100,[]},{3304302,8075,4496,100,[]},{3304302,8504,4608,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3304302,10},{3,击杀周围的怪物，快速通关吧！,0}]'),(3304,3304,19,1,'[]','[{3304303,3288,9808,100,[]},{3304303,3378,10665,100,[]},{3304303,3743,9964,100,[]},{3304303,3847,9614,100,[]},{3304303,3459,9555,100,[]},{3304303,2901,9726,100,[]},{3304303,2931,10024,100,[]},{3304303,3586,10225,100,[]},{3304303,3169,10374,100,[]},{3304303,2625,10404,100,[]},{3304303,3080,9294,100,[]},{3304303,4011,9115,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3304303,12},{3,击杀周围的怪物，快速通关吧！,0}]'),(3304,3304,20,1,'[]','[{3304304,7138,17240,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3304304,1},{3,击杀最终的大魔王吧！}]'),(3304,3304,21,1,'[]','[{3304305,10505,3176,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3304,3304,22,1,'[]','[{3304306,7567,5221,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3304,3304,23,1,'[]','[{3304307,3288,9808,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3304,3304,24,1,'[]','[{3304308,7138,17240,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3304,3304,25,1,'[]','[{3304401,11091,4114,100,[]},{3304401,11348,3615,100,[]},{3304401,10927,3451,100,[]},{3304401,11442,3872,100,[]},{3304401,10981,3591,100,[]},{3304401,10482,3092,100,[]},{3304401,10232,3014,100,[]},{3304401,10490,2498,100,[]},{3304401,10997,2990,100,[]},{3304401,10646,3427,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3304401,10},{3,击杀周围的怪物，快速通关吧！,0}]'),(3304,3304,26,1,'[]','[{3304402,10678,10198,100,[]},{3304402,10936,10355,100,[]},{3304402,11067,10572,100,[]},{3304402,10334,10218,100,[]},{3304402,11057,10749,100,[]},{3304402,10870,10865,100,[]},{3304402,10582,10900,100,[]},{3304402,10284,10875,100,[]},{3304402,10132,10678,100,[]},{3304402,10183,10451,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3304402,10},{3,击杀周围的怪物，快速通关吧！,0}]'),(3304,3304,27,1,'[]','[{3304403,17112,18086,100,[]},{3304403,16368,18148,100,[]},{3304403,17126,18810,100,[]},{3304403,17581,18644,100,[]},{3304403,17801,18334,100,[]},{3304403,16450,17831,100,[]},{3304403,17346,17369,100,[]},{3304403,17863,17969,100,[]},{3304403,16616,17548,100,[]},{3304403,17718,17590,100,[]},{3304403,16919,17349,100,[]},{3304403,16512,18603,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3304403,12},{3,击杀周围的怪物，快速通关吧！,0}]'),(3304,3304,28,1,'[]','[{3304404,17112,18086,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,3304404,1},{3,击杀最终的大魔王吧！}]'),(3304,3304,29,1,'[]','[{3304405,10981,3591,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3304,3304,30,1,'[]','[{3304406,10678,10198,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3304,3304,31,1,'[]','[{3304407,17112,18086,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3304,3304,32,1,'[]','[{3304408,17112,18086,100,[{die_info,drop}]}]','[]','[]',0,0,1,2000,0,0,0,'',''),(3304,3304,33,1,'[]','[{3304701,17112,18086,100,[]},{3304701,16368,18148,100,[]},{3304701,17126,18810,100,[]},{3304701,17581,18644,100,[]},{3304701,17801,18334,100,[]},{3304701,16450,17831,100,[]},{3304701,17346,17369,100,[]},{3304701,17863,17969,100,[]},{3304701,16616,17548,100,[]},{3304701,17718,17590,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{2,3304701,10},{3,地上有好多机械星呢，捡起来看看！,0}]'),(3304,3304,34,1,'[]','[{3304702,3288,9808,100,[]},{3304702,3378,10665,100,[]},{3304702,3743,9964,100,[]},{3304702,3847,9614,100,[]},{3304702,3459,9555,100,[]},{3304702,2901,9726,100,[]},{3304702,2931,10024,100,[]},{3304702,3586,10225,100,[]},{3304702,3169,10374,100,[]},{3304702,2625,10404,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{2,3304702,10},{3,地上有好多机械元呢，捡起来看看！,0}]'),(4201,42011,1,1,'[]','[{4201111,5783,11557,100,[{group,1},{die_info,klist}]},{4201211,11667,9320,100,[{group,1},{die_info,klist}]},{4201311,13711,3467,100,[{group,1},{die_info,klist}]}]','[]','[]',10000,0,5,2500,0,0,5000,'新的怪物出现了，小心防守！','守卫公会，击败所有怪物可提前结束副本，获得海量经验！'),(4201,42011,1,2,'[]','[{4201112,5783,11557,100,[{group,1},{die_info,klist}]},{4201212,11667,9320,100,[{group,1},{die_info,klist}]},{4201312,13711,3467,100,[{group,1},{die_info,klist}]}]','[]','[]',5000,0,5,2500,0,0,5000,'','守卫公会，击败所有怪物可提前结束副本，获得海量经验！'),(4201,42011,2,1,'[]','[{4201121,5783,11557,100,[{group,1},{die_info,klist}]},{4201221,11667,9320,100,[{group,1},{die_info,klist}]},{4201321,13711,3467,100,[{group,1},{die_info,klist}]}]','[]','[]',10000,0,5,2500,0,0,5000,'新的怪物出现了，小心防守！','守卫公会，击败所有怪物可提前结束副本，获得海量经验！'),(4201,42011,2,2,'[]','[{4201122,5783,11557,100,[{group,1},{die_info,klist}]},{4201222,11667,9320,100,[{group,1},{die_info,klist}]},{4201322,13711,3467,100,[{group,1},{die_info,klist}]}]','[]','[]',5000,0,5,2500,0,0,5000,'','守卫公会，击败所有怪物可提前结束副本，获得海量经验！'),(4201,42011,3,1,'[]','[{4201131,5783,11557,100,[{group,1},{die_info,klist}]},{4201231,11667,9320,100,[{group,1},{die_info,klist}]},{4201331,13711,3467,100,[{group,1},{die_info,klist}]}]','[]','[]',10000,0,5,2500,0,0,5000,'新的怪物出现了，小心防守！','守卫公会，击败所有怪物可提前结束副本，获得海量经验！'),(4201,42011,3,2,'[]','[{4201132,5783,11557,100,[{group,1},{die_info,klist}]},{4201232,11667,9320,100,[{group,1},{die_info,klist}]},{4201332,13711,3467,100,[{group,1},{die_info,klist}]}]','[]','[]',5000,0,5,2500,0,0,5000,'','守卫公会，击败所有怪物可提前结束副本，获得海量经验！'),(4201,42011,4,1,'[]','[{4201141,5783,11557,100,[{group,1},{die_info,klist}]},{4201241,11667,9320,100,[{group,1},{die_info,klist}]},{4201341,13711,3467,100,[{group,1},{die_info,klist}]}]','[]','[]',10000,0,5,2500,0,0,5000,'新的怪物出现了，小心防守！','守卫公会，击败所有怪物可提前结束副本，获得海量经验！'),(4201,42011,4,2,'[]','[{4201142,5783,11557,100,[{group,1},{die_info,klist}]},{4201242,11667,9320,100,[{group,1},{die_info,klist}]},{4201342,13711,3467,100,[{group,1},{die_info,klist}]}]','[]','[]',5000,0,5,2500,0,0,5000,'','守卫公会，击败所有怪物可提前结束副本，获得海量经验！'),(4201,42011,5,1,'[]','[{4201151,5783,11557,100,[{group,1},{die_info,klist}]},{4201251,11667,9320,100,[{group,1},{die_info,klist}]},{4201351,13711,3467,100,[{group,1},{die_info,klist}]}]','[]','[]',10000,0,5,2500,0,0,5000,'新的怪物出现了，小心防守！','守卫公会，击败所有怪物可提前结束副本，获得海量经验！'),(4201,42011,5,2,'[]','[{4201152,5783,11557,100,[{group,1},{die_info,klist}]},{4201252,11667,9320,100,[{group,1},{die_info,klist}]},{4201352,13711,3467,100,[{group,1},{die_info,klist}]}]','[]','[]',5000,0,5,2500,0,0,5000,'','守卫公会，击败所有怪物可提前结束副本，获得海量经验！'),(4201,42011,6,1,'[]','[{4201161,5783,11557,100,[{group,1},{die_info,klist}]},{4201261,11667,9320,100,[{group,1},{die_info,klist}]},{4201361,13711,3467,100,[{group,1},{die_info,klist}]}]','[]','[]',10000,0,5,2500,0,0,5000,'新的怪物出现了，小心防守！','守卫公会，击败所有怪物可提前结束副本，获得海量经验！'),(4201,42011,6,2,'[]','[{4201162,5783,11557,100,[{group,1},{die_info,klist}]},{4201262,11667,9320,100,[{group,1},{die_info,klist}]},{4201362,13711,3467,100,[{group,1},{die_info,klist}]}]','[]','[]',5000,0,5,2500,0,0,5000,'','守卫公会，击败所有怪物可提前结束副本，获得海量经验！'),(4201,42011,7,1,'[]','[{4201171,5783,11557,100,[{group,1},{die_info,klist}]},{4201271,11667,9320,100,[{group,1},{die_info,klist}]},{4201371,13711,3467,100,[{group,1},{die_info,klist}]}]','[]','[]',10000,0,5,2500,0,0,5000,'新的怪物出现了，小心防守！','守卫公会，击败所有怪物可提前结束副本，获得海量经验！'),(4201,42011,7,2,'[]','[{4201172,5783,11557,100,[{group,1},{die_info,klist}]},{4201272,11667,9320,100,[{group,1},{die_info,klist}]},{4201372,13711,3467,100,[{group,1},{die_info,klist}]}]','[]','[]',5000,0,5,2500,0,0,5000,'','守卫公会，击败所有怪物可提前结束副本，获得海量经验！'),(4201,42011,8,1,'[]','[{4201181,5783,11557,100,[{group,1},{die_info,klist}]},{4201281,11667,9320,100,[{group,1},{die_info,klist}]},{4201381,13711,3467,100,[{group,1},{die_info,klist}]}]','[]','[]',10000,0,5,2500,0,0,5000,'新的怪物出现了，小心防守！','守卫公会，击败所有怪物可提前结束副本，获得海量经验！'),(4201,42011,8,2,'[]','[{4201182,5783,11557,100,[{group,1},{die_info,klist}]},{4201282,11667,9320,100,[{group,1},{die_info,klist}]},{4201382,13711,3467,100,[{group,1},{die_info,klist}]}]','[]','[]',5000,0,5,2500,0,0,5000,'','守卫公会，击败所有怪物可提前结束副本，获得海量经验！'),(4201,42011,9,1,'[]','[{4201090,6600,4500,100,[{group,1},{die_info,klist}]}]','[]','[]',1000,0,1,0,0,0,5000,'有怪物突袭公会水晶，速速回防！','守卫公会，击败所有怪物可提前结束副本，获得海量经验！'),(4201,42011,10,1,'[]','[{4201100,6250,4044,100,[{group,99},{die_info,klist}]},{4201101,5799,8267,100,[{group,99},{die_info,klist}]},{4201102,9348,7040,100,[{group,99},{die_info,klist}]},{4201103,10425,3454,100,[{group,99},{die_info,klist}]}]','[]','[]',0,0,1,0,0,0,5000,'基地已经刷新！~','守卫公会，击败所有怪物可提前结束副本，获得海量经验！'),(5200,5200,1,1,'[]','[{5200001,3275,4509,100,[]},{5200001,3703,4534,100,[]},{5200001,4046,4242,100,[]},{5200001,4197,3874,100,[]},{5200001,4157,3354,100,[]},{5200001,3739,2981,100,[]},{5200001,3235,3027,100,[]},{5200001,2861,3329,100,[]},{5200001,2766,3743,100,[]},{5200001,2947,4211,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,5200001,20},{1,5200003,10},{3,击杀场景周围的妒忌花妖可以获得恩爱分,0}]'),(5200,5200,1,2,'[]','[{5200001,3275,4509,100,[]},{5200001,3703,4534,100,[]},{5200001,4046,4242,100,[]},{5200001,4197,3874,100,[]},{5200001,4157,3354,100,[]},{5200001,3739,2981,100,[]},{5200001,3235,3027,100,[]},{5200001,2861,3329,100,[]},{5200001,2766,3743,100,[]},{5200001,2947,4211,100,[]}]','[]','[]',13000,0,1,2000,0,0,0,'','[{1,5200001,20},{1,5200003,10},{3,击杀场景周围的妒忌花妖可以获得恩爱分,0}]'),(5200,5200,2,1,'[]','[{5200003,1991,4920,100,[]},{5200003,2997,5695,100,[]},{5200003,4323,5705,100,[]},{5200003,5379,5077,100,[]},{5200003,5843,3595,100,[]},{5200003,5426,2423,100,[]},{5200003,4408,1773,100,[]},{5200003,3092,1743,100,[]},{5200003,2037,2403,100,[]},{5200003,1607,3804,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,5200003,10},{3,击杀场景周围的妒忌花妖可以获得恩爱分,0}]'),(5200,5200,3,1,'[]','[{5200002,3275,4509,100,[]},{5200002,3703,4534,100,[]},{5200002,4046,4242,100,[]},{5200002,4197,3874,100,[]},{5200002,4157,3354,100,[]},{5200002,3739,2981,100,[]},{5200002,3235,3027,100,[]},{5200002,2861,3329,100,[]},{5200002,2766,3743,100,[]},{5200002,2947,4211,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,5200002,20},{1,5200004,10},{3,击杀场景周围的愤怒花妖可以获得恩爱分,0}]'),(5200,5200,3,2,'[]','[{5200002,3275,4509,100,[]},{5200002,3703,4534,100,[]},{5200002,4046,4242,100,[]},{5200002,4197,3874,100,[]},{5200002,4157,3354,100,[]},{5200002,3739,2981,100,[]},{5200002,3235,3027,100,[]},{5200002,2861,3329,100,[]},{5200002,2766,3743,100,[]},{5200002,2947,4211,100,[]}]','[]','[]',13000,0,1,2000,0,0,0,'','[{1,5200002,20},{1,5200004,10},{3,击杀场景周围的愤怒花妖可以获得恩爱分,0}]'),(5200,5200,4,1,'[]','[{5200004,1991,4920,100,[]},{5200004,2997,5695,100,[]},{5200004,4323,5705,100,[]},{5200004,5379,5077,100,[]},{5200004,5843,3595,100,[]},{5200004,5426,2423,100,[]},{5200004,4408,1773,100,[]},{5200004,3092,1743,100,[]},{5200004,2037,2403,100,[]},{5200004,1607,3804,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,5200004,12},{3,击杀场景周围的愤怒花妖可以获得恩爱分！,0}]'),(5200,5200,5,1,'[]','[{5200005,3275,4509,100,[]},{5200006,4157,3354,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,5200005,1},{1,5200006,1},{3,击杀痴男怨女，获得最终胜利吧！,0}]'),(5201,5201,1,1,'[]','[{5201001,3275,4509,100,[]},{5201001,3703,4534,100,[]},{5201001,4046,4242,100,[]},{5201001,4197,3874,100,[]},{5201001,4157,3354,100,[]},{5201001,3739,2981,100,[]},{5201001,3235,3027,100,[]},{5201001,2861,3329,100,[]},{5201001,2766,3743,100,[]},{5201001,2947,4211,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,5201001,20},{1,5201003,10},{3,击杀场景周围的妒忌花妖可以获得恩爱分,0}]'),(5201,5201,1,2,'[]','[{5201001,3275,4509,100,[]},{5201001,3703,4534,100,[]},{5201001,4046,4242,100,[]},{5201001,4197,3874,100,[]},{5201001,4157,3354,100,[]},{5201001,3739,2981,100,[]},{5201001,3235,3027,100,[]},{5201001,2861,3329,100,[]},{5201001,2766,3743,100,[]},{5201001,2947,4211,100,[]}]','[]','[]',13000,0,1,2000,0,0,0,'','[{1,5201001,20},{1,5201003,10},{3,击杀场景周围的妒忌花妖可以获得恩爱分,0}]'),(5201,5201,2,1,'[]','[{5201003,1991,4920,100,[]},{5201003,2997,5695,100,[]},{5201003,4323,5705,100,[]},{5201003,5379,5077,100,[]},{5201003,5843,3595,100,[]},{5201003,5426,2423,100,[]},{5201003,4408,1773,100,[]},{5201003,3092,1743,100,[]},{5201003,2037,2403,100,[]},{5201003,1607,3804,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,5201003,10},{3,击杀场景周围的妒忌花妖可以获得恩爱分,0}]'),(5201,5201,3,1,'[]','[{5201002,3275,4509,100,[]},{5201002,3703,4534,100,[]},{5201002,4046,4242,100,[]},{5201002,4197,3874,100,[]},{5201002,4157,3354,100,[]},{5201002,3739,2981,100,[]},{5201002,3235,3027,100,[]},{5201002,2861,3329,100,[]},{5201002,2766,3743,100,[]},{5201002,2947,4211,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,5201002,20},{1,5201004,10},{3,击杀场景周围的愤怒花妖可以获得恩爱分,0}]'),(5201,5201,3,2,'[]','[{5201002,3275,4509,100,[]},{5201002,3703,4534,100,[]},{5201002,4046,4242,100,[]},{5201002,4197,3874,100,[]},{5201002,4157,3354,100,[]},{5201002,3739,2981,100,[]},{5201002,3235,3027,100,[]},{5201002,2861,3329,100,[]},{5201002,2766,3743,100,[]},{5201002,2947,4211,100,[]}]','[]','[]',13000,0,1,2000,0,0,0,'','[{1,5201002,20},{1,5201004,10},{3,击杀场景周围的愤怒花妖可以获得恩爱分,0}]'),(5201,5201,4,1,'[]','[{5201004,1991,4920,100,[]},{5201004,2997,5695,100,[]},{5201004,4323,5705,100,[]},{5201004,5379,5077,100,[]},{5201004,5843,3595,100,[]},{5201004,5426,2423,100,[]},{5201004,4408,1773,100,[]},{5201004,3092,1743,100,[]},{5201004,2037,2403,100,[]},{5201004,1607,3804,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,5201004,12},{3,击杀场景周围的愤怒花妖可以获得恩爱分！,0}]'),(5201,5201,5,1,'[]','[{5201005,3275,4509,100,[]},{5201006,4157,3354,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,5201005,1},{1,5201006,1},{3,击杀痴男怨女，获得最终胜利吧！,0}]'),(5202,5202,1,1,'[]','[{5202001,3275,4509,100,[]},{5202001,3703,4534,100,[]},{5202001,4046,4242,100,[]},{5202001,4197,3874,100,[]},{5202001,4157,3354,100,[]},{5202001,3739,2981,100,[]},{5202001,3235,3027,100,[]},{5202001,2861,3329,100,[]},{5202001,2766,3743,100,[]},{5202001,2947,4211,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,5202001,20},{1,5202003,10},{3,击杀场景周围的妒忌花妖可以获得恩爱分,0}]'),(5202,5202,1,2,'[]','[{5202001,3275,4509,100,[]},{5202001,3703,4534,100,[]},{5202001,4046,4242,100,[]},{5202001,4197,3874,100,[]},{5202001,4157,3354,100,[]},{5202001,3739,2981,100,[]},{5202001,3235,3027,100,[]},{5202001,2861,3329,100,[]},{5202001,2766,3743,100,[]},{5202001,2947,4211,100,[]}]','[]','[]',13000,0,1,2000,0,0,0,'','[{1,5202001,20},{1,5202003,10},{3,击杀场景周围的妒忌花妖可以获得恩爱分,0}]'),(5202,5202,2,1,'[]','[{5202003,1991,4920,100,[]},{5202003,2997,5695,100,[]},{5202003,4323,5705,100,[]},{5202003,5379,5077,100,[]},{5202003,5843,3595,100,[]},{5202003,5426,2423,100,[]},{5202003,4408,1773,100,[]},{5202003,3092,1743,100,[]},{5202003,2037,2403,100,[]},{5202003,1607,3804,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,5202003,10},{3,击杀场景周围的妒忌花妖可以获得恩爱分,0}]'),(5202,5202,3,1,'[]','[{5202002,3275,4509,100,[]},{5202002,3703,4534,100,[]},{5202002,4046,4242,100,[]},{5202002,4197,3874,100,[]},{5202002,4157,3354,100,[]},{5202002,3739,2981,100,[]},{5202002,3235,3027,100,[]},{5202002,2861,3329,100,[]},{5202002,2766,3743,100,[]},{5202002,2947,4211,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,5202002,20},{1,5202004,10},{3,击杀场景周围的愤怒花妖可以获得恩爱分,0}]'),(5202,5202,3,2,'[]','[{5202002,3275,4509,100,[]},{5202002,3703,4534,100,[]},{5202002,4046,4242,100,[]},{5202002,4197,3874,100,[]},{5202002,4157,3354,100,[]},{5202002,3739,2981,100,[]},{5202002,3235,3027,100,[]},{5202002,2861,3329,100,[]},{5202002,2766,3743,100,[]},{5202002,2947,4211,100,[]}]','[]','[]',13000,0,1,2000,0,0,0,'','[{1,5202002,20},{1,5202004,10},{3,击杀场景周围的愤怒花妖可以获得恩爱分,0}]'),(5202,5202,4,1,'[]','[{5202004,1991,4920,100,[]},{5202004,2997,5695,100,[]},{5202004,4323,5705,100,[]},{5202004,5379,5077,100,[]},{5202004,5843,3595,100,[]},{5202004,5426,2423,100,[]},{5202004,4408,1773,100,[]},{5202004,3092,1743,100,[]},{5202004,2037,2403,100,[]},{5202004,1607,3804,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,5202004,12},{3,击杀场景周围的愤怒花妖可以获得恩爱分！,0}]'),(5202,5202,5,1,'[]','[{5202005,3275,4509,100,[]},{5202006,4157,3354,100,[]}]','[]','[]',0,0,1,2000,0,0,0,'','[{1,5202005,1},{1,5202006,1},{3,击杀痴男怨女，获得最终胜利吧！,0}]'),(5300,5502,1,1,'[]','[{5300101,6201,4264,100,[{group,1}]}]','[]','[]',0,0,10,1500,0,0,0,'该种怪物移动缓慢，并且会被阻挡哦',''),(5300,5502,2,1,'[]','[{5300102,6201,4264,100,[{group,1}]}]','[]','[]',5000,0,10,1500,0,0,0,'该种怪物移动迅速，迅速击杀！',''),(5300,5502,4,1,'[]','[{5300400,1903,1781,100,[{group,99}]}]','[]','[]',0,0,1,1500,0,0,0,'',''),(5301,5502,1,1,'[]','[{5301101,6201,4264,100,[{group,1}]}]','[]','[]',0,0,10,1500,0,0,0,'',''),(5301,5502,2,1,'[]','[{5301102,6201,4264,100,[{group,1}]}]','[]','[]',5000,0,10,1500,0,0,0,'',''),(5301,5502,3,1,'[]','[{5301103,6201,4264,100,[{group,1}]}]','[]','[]',5000,0,10,1500,0,0,0,'',''),(5301,5502,4,1,'[]','[{5301400,1903,1781,100,[{group,99}]}]','[]','[]',0,0,1,1500,0,0,0,'',''),(5302,5502,1,1,'[]','[{5302101,6201,4264,100,[{group,1}]}]','[]','[]',0,0,10,1500,0,0,0,'',''),(5302,5502,2,1,'[]','[{5302102,6201,4264,100,[{group,1}]}]','[]','[]',5000,0,10,1500,0,0,0,'',''),(5302,5502,3,1,'[]','[{5302103,6201,4264,100,[{group,1}]}]','[]','[]',5000,0,10,1500,0,0,0,'',''),(5302,5502,4,1,'[]','[{5302400,1903,1781,100,[{group,99}]}]','[]','[]',0,0,1,1500,0,0,0,'',''),(5303,5502,1,1,'[]','[{5303101,6201,4264,100,[{group,1}]}]','[]','[]',0,0,10,1500,0,0,0,'',''),(5303,5502,2,1,'[]','[{5303102,6201,4264,100,[{group,1}]}]','[]','[]',5000,0,10,1500,0,0,0,'',''),(5303,5502,3,1,'[]','[{5303103,6201,4264,100,[{group,1}]}]','[]','[]',5000,0,10,1500,0,0,0,'',''),(5303,5502,4,1,'[]','[{5303400,1903,1781,100,[{group,99}]}]','[]','[]',0,0,1,1500,0,0,0,'',''),(5304,5502,1,1,'[]','[{5304101,6201,4264,100,[{group,1}]}]','[]','[]',0,0,10,1500,0,0,0,'',''),(5304,5502,2,1,'[]','[{5304102,6201,4264,100,[{group,1}]}]','[]','[]',5000,0,10,1500,0,0,0,'',''),(5304,5502,3,1,'[]','[{5304103,6201,4264,100,[{group,1}]}]','[]','[]',5000,0,10,1500,0,0,0,'',''),(5304,5502,4,1,'[]','[{5304400,1903,1781,100,[{group,99}]}]','[]','[]',0,0,1,1500,0,0,0,'',''),(5400,5400,1,1,'[]','[{5400000,5851,6835,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5401,5400,1,1,'[]','[{5401000,5851,6835,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5402,5400,1,1,'[]','[{5402000,5851,6835,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5403,5400,1,1,'[]','[{5403000,5851,6835,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5404,5400,1,1,'[]','[{5404000,5851,6835,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5405,5400,1,1,'[]','[{5405000,5851,6835,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5900,5900,1,1,'[]','[{5900000,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5901,5900,1,1,'[]','[{5900001,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5902,5900,1,1,'[]','[{5900002,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5903,5900,1,1,'[]','[{5900003,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5904,5900,1,1,'[]','[{5900004,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5905,5900,1,1,'[]','[{5900005,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5906,5900,1,1,'[]','[{5900006,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5907,5900,1,1,'[]','[{5900007,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5908,5900,1,1,'[]','[{5900008,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5909,5900,1,1,'[]','[{5900009,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5910,5900,1,1,'[]','[{5900010,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5911,5900,1,1,'[]','[{5900011,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5912,5900,1,1,'[]','[{5900012,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5913,5900,1,1,'[]','[{5900013,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5914,5900,1,1,'[]','[{5900014,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5915,5900,1,1,'[]','[{5900015,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5916,5900,1,1,'[]','[{5900016,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5917,5900,1,1,'[]','[{5900017,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5918,5900,1,1,'[]','[{5900018,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5919,5900,1,1,'[]','[{5900019,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5920,5900,1,1,'[]','[{5900020,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5921,5900,1,1,'[]','[{5900021,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5922,5900,1,1,'[]','[{5900022,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5923,5900,1,1,'[]','[{5900023,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5924,5900,1,1,'[]','[{5900024,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5925,5900,1,1,'[]','[{5900025,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5926,5900,1,1,'[]','[{5900026,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5927,5900,1,1,'[]','[{5900027,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5928,5900,1,1,'[]','[{5900028,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5929,5900,1,1,'[]','[{5900029,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5930,5900,1,1,'[]','[{5900030,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5931,5900,1,1,'[]','[{5900031,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5932,5900,1,1,'[]','[{5900032,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5933,5900,1,1,'[]','[{5900033,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5934,5900,1,1,'[]','[{5900034,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5935,5900,1,1,'[]','[{5900035,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5936,5900,1,1,'[]','[{5900036,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5937,5900,1,1,'[]','[{5900037,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5938,5900,1,1,'[]','[{5900038,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5939,5900,1,1,'[]','[{5900039,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5940,5900,1,1,'[]','[{5900040,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5941,5900,1,1,'[]','[{5900041,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5942,5900,1,1,'[]','[{5900042,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5943,5900,1,1,'[]','[{5900043,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5944,5900,1,1,'[]','[{5900044,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5945,5900,1,1,'[]','[{5900045,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5946,5900,1,1,'[]','[{5900046,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5947,5900,1,1,'[]','[{5900047,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5948,5900,1,1,'[]','[{5900048,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5949,5900,1,1,'[]','[{5900049,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5950,5900,1,1,'[]','[{5900050,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5951,5900,1,1,'[]','[{5900051,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5952,5900,1,1,'[]','[{5900052,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5953,5900,1,1,'[]','[{5900053,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5954,5900,1,1,'[]','[{5900054,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5955,5900,1,1,'[]','[{5900055,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5956,5900,1,1,'[]','[{5900056,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5957,5900,1,1,'[]','[{5900057,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5958,5900,1,1,'[]','[{5900058,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5959,5900,1,1,'[]','[{5900059,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5960,5900,1,1,'[]','[{5900060,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5961,5900,1,1,'[]','[{5900061,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5962,5900,1,1,'[]','[{5900062,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5963,5900,1,1,'[]','[{5900063,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5964,5900,1,1,'[]','[{5900064,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5965,5900,1,1,'[]','[{5900065,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5966,5900,1,1,'[]','[{5900066,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5967,5900,1,1,'[]','[{5900067,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5968,5900,1,1,'[]','[{5900068,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5969,5900,1,1,'[]','[{5900069,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5970,5900,1,1,'[]','[{5900070,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5971,5900,1,1,'[]','[{5900071,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5972,5900,1,1,'[]','[{5900072,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5973,5900,1,1,'[]','[{5900073,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5974,5900,1,1,'[]','[{5900074,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5975,5900,1,1,'[]','[{5900075,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5976,5900,1,1,'[]','[{5900076,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5977,5900,1,1,'[]','[{5900077,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5978,5900,1,1,'[]','[{5900078,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5979,5900,1,1,'[]','[{5900079,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5980,5900,1,1,'[]','[{5900080,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5981,5900,1,1,'[]','[{5900081,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5982,5900,1,1,'[]','[{5900082,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5983,5900,1,1,'[]','[{5900083,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5984,5900,1,1,'[]','[{5900084,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5985,5900,1,1,'[]','[{5900085,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5986,5900,1,1,'[]','[{5900086,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5987,5900,1,1,'[]','[{5900087,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5988,5900,1,1,'[]','[{5900088,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5989,5900,1,1,'[]','[{5900089,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5990,5900,1,1,'[]','[{5900090,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5991,5900,1,1,'[]','[{5900091,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5992,5900,1,1,'[]','[{5900092,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5993,5900,1,1,'[]','[{5900093,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5994,5900,1,1,'[]','[{5900094,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5995,5900,1,1,'[]','[{5900095,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5996,5900,1,1,'[]','[{5900096,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5997,5900,1,1,'[]','[{5900097,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5998,5900,1,1,'[]','[{5900098,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(5999,5900,1,1,'[]','[{5900099,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(10000,10000,1,1,'[]','[{100000001,3558,13529,100,[]}]','[]','[]',0,0,1,0,0,0,0,'击败暗裔死神','击败暗裔死神'),(10002,10002,1,1,'[]','[{100020001,11805,13024,100,[]}]','[]','[]',0,0,1,0,0,0,0,'在海岸边袭击村民的恶魔！快击败他！','帝国军制造的蜘蛛女皇！快击败她！'),(10003,10003,1,1,'[]','[{100030001,1891,1930,100,[]}]','[]','[]',0,0,1,0,0,0,0,'击败荆棘之花','击败荆棘之花'),(10006,10006,1,1,'[]','[{100060001,2211,17577,100,[]}]','[]','[]',0,0,1,0,0,0,0,'通过神殿守卫半人马的试炼吧！','通过神殿守卫半人马的试炼吧！'),(10007,10007,1,1,'[]','[{100070001,14021,10616,100,[]}]','[]','[]',0,0,1,0,0,0,0,'在海岸边袭击村民的恶魔！快击败他！','冰脉中沉睡的巨龙被惊醒了！快让它镇定下来！'),(10008,10008,1,1,'[]','[{100080001,11367,12967,100,[]}]','[]','[]',0,0,1,0,0,0,0,'生与死的掌管者阿努比斯，对冒险者发起考验','生与死的掌管者阿努比斯，对冒险者发起考验'),(10009,7504,1,1,'[]','[{100090001,12600,9295,100,[]}]','[]','[]',0,0,1,0,0,0,0,'恶魔骑士将亲自测试冒险者的能力','恶魔骑士将亲自测试冒险者的能力'),(10030,10030,1,1,'[]','[{100300001,18881,8983,100,[]},{100300001,18845,9112,100,[]},{100300001,18887,8888,100,[]},{100300001,18958,9110,100,[]},{100300001,19016,8979,100,[]}]','[]','[]',0,0,1,0,0,0,0,'','击败所有怪物即可解救白羊'),(10030,10030,2,1,'[]','[{100300002,21395,10594,100,[]}]','[]','[]',0,0,1,0,0,0,0,'','击败所有怪物即可解救白羊'),(10030,10030,3,1,'[]','[{100300003,21395,10594,100,[]}]','[]','[]',0,0,1,0,0,0,0,'','解救被封印的白羊吧'),(30000,2501,1,1,'[]','[{star_soul,2001,1,{1,0},4801,6005,100,[]},{star_soul,2002,5,{1,0},4289,6375,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(30001,2502,1,1,'[]','[{star_soul,2002,3,{1,1},4516,9027,100,[]},{star_soul,2003,4,{1,1},4809,9246,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(30002,2503,1,1,'[]','[{star_soul,2004,1,{1,1},19811,7178,100,[]},{star_soul,2001,3,{1,1},19795,7552,100,[]},{star_soul,2005,5,{1,1},19778,7938,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(30003,2504,1,1,'[]','[{star_soul,2004,1,{1,1},18388,8150,100,[]},{star_soul,2004,3,{1,1},18266,8455,100,[]},{star_soul,2004,5,{1,1},18098,8736,100,[]},{star_soul,2003,4,{1,1},18552,8646,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(30004,2505,1,1,'[]','[{star_soul,1001,1,{1,2},10776,8362,100,[]},{star_soul,1001,5,{1,2},10577,9091,100,[]},{star_soul,1005,3,{2,0},10671,8739,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(30005,2501,1,1,'[]','[{star_soul,2001,1,{2,0},4801,6005,100,[]},{star_soul,2002,4,{2,0},4783,6618,100,[]},{star_soul,2003,5,{2,0},4289,6375,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(30006,2502,1,1,'[]','[{star_soul,2004,1,{2,1},4726,8702,100,[]},{star_soul,2005,3,{2,1},4516,9027,100,[]},{star_soul,2002,6,{2,1},4537,9782,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(30007,2503,1,1,'[]','[{star_soul,2003,1,{2,0},19811,7178,100,[]},{star_soul,2001,3,{2,0},19795,7552,100,[]},{star_soul,2001,4,{2,0},20085,7609,100,[]},{star_soul,2003,5,{2,0},19778,7938,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(30008,2504,1,1,'[]','[{star_soul,2002,1,{2,1},18388,8150,100,[]},{star_soul,2002,2,{2,1},18681,8366,100,[]},{star_soul,2005,5,{2,1},18098,8736,100,[]},{star_soul,2005,6,{2,1},18384,8913,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(30009,2505,1,1,'[]','[{star_soul,2004,1,{2,2},10776,8362,100,[]},{star_soul,2004,5,{2,2},10577,9091,100,[]},{star_soul,1006,3,{3,0},10671,8739,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(30010,2501,1,1,'[]','[{star_soul,2002,1,{2,3},4801,6005,100,[]},{star_soul,1002,3,{2,3},4549,6230,100,[]},{star_soul,2002,5,{2,3},4289,6375,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(30011,2502,1,1,'[]','[{star_soul,1003,3,{2,3},4516,9027,100,[]},{star_soul,2001,4,{2,3},4809,9246,100,[]},{star_soul,1003,1,{2,3},4726,8702,100,[]},{star_soul,2001,6,{2,3},4537,9782,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(30012,2503,1,1,'[]','[{star_soul,1002,2,{3,0},20078,7239,100,[]},{star_soul,2004,3,{3,0},19795,7552,100,[]},{star_soul,1004,4,{3,0},20085,7609,100,[]},{star_soul,2003,5,{3,0},19778,7938,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(30013,2504,1,1,'[]','[{star_soul,2003,1,{3,0},18388,8150,100,[]},{star_soul,1002,5,{3,0},18098,8736,100,[]},{star_soul,2003,2,{3,0},18681,8366,100,[]},{star_soul,1007,4,{3,0},18552,8646,100,[]},{star_soul,1002,6,{3,0},18384,8913,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(30014,2505,1,1,'[]','[{star_soul,1003,1,{3,3},10776,8362,100,[]},{star_soul,1007,5,{3,1},10577,9091,100,[]},{star_soul,1005,3,{3,1},10671,8739,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(30015,2501,1,1,'[]','[{star_soul,2004,1,{3,1},4801,6005,100,[]},{star_soul,2001,2,{3,1},4980,6164,100,[]},{star_soul,1004,3,{3,1},4549,6230,100,[]},{star_soul,1003,4,{2,0},4783,6618,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(30016,2502,1,1,'[]','[{star_soul,2002,2,{3,2},5039,8942,100,[]},{star_soul,2005,3,{3,2},4516,9027,100,[]},{star_soul,1006,4,{3,2},4809,9246,100,[]},{star_soul,1002,6,{3,2},4537,9782,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(30017,2503,1,1,'[]','[{star_soul,2004,1,{3,2},19811,7178,100,[]},{star_soul,1001,2,{3,2},20078,7239,100,[]},{star_soul,1006,3,{3,2},19795,7552,100,[]},{star_soul,2005,4,{3,2},20085,7609,100,[]},{star_soul,1003,5,{3,2},19778,7938,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(30018,2504,1,1,'[]','[{star_soul,1002,1,{3,3},18388,8150,100,[]},{star_soul,2003,3,{3,3},18266,8455,100,[]},{star_soul,1005,4,{3,3},18552,8646,100,[]},{star_soul,2001,5,{3,3},18098,8736,100,[]},{star_soul,1002,6,{3,3},18384,8913,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(30019,2505,1,1,'[]','[{star_soul,1007,1,{3,3},10776,8362,100,[]},{star_soul,1006,3,{4,2},10671,8739,100,[]},{star_soul,1005,4,{3,3},10995,8870,100,[]},{star_soul,1007,5,{3,3},10577,9091,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(30020,2501,1,1,'[]','[{star_soul,1002,1,{3,3},4801,6005,100,[]},{star_soul,1003,3,{3,3},4549,6230,100,[]},{star_soul,1006,4,{3,3},4783,6618,100,[]},{star_soul,1001,6,{3,3},4508,6678,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(30021,2502,1,1,'[]','[{star_soul,1005,3,{4,0},4516,9027,100,[]},{star_soul,1004,4,{4,0},4809,9246,100,[]},{star_soul,1003,1,{4,0},4726,8702,100,[]},{star_soul,1007,6,{4,0},4537,9782,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(30022,2503,1,1,'[]','[{star_soul,1004,1,{4,0},19811,7178,100,[]},{star_soul,1003,2,{4,0},20078,7239,100,[]},{star_soul,1005,3,{4,0},19795,7552,100,[]},{star_soul,1004,4,{4,0},20085,7609,100,[]},{star_soul,1003,5,{4,0},19778,7938,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(30023,2504,1,1,'[]','[{star_soul,1007,1,{4,1},18388,8150,100,[]},{star_soul,1002,2,{4,1},18681,8366,100,[]},{star_soul,1007,3,{4,1},18266,8455,100,[]},{star_soul,1002,4,{4,1},18552,8646,100,[]},{star_soul,1007,5,{4,1},18098,8736,100,[]},{star_soul,1002,6,{2,2},18384,8913,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(30024,2505,1,1,'[]','[{star_soul,1003,1,{4,2},10776,8362,100,[]},{star_soul,1004,3,{5,0},10671,8739,100,[]},{star_soul,1005,4,{4,2},10995,8870,100,[]},{star_soul,1003,5,{4,2},10577,9091,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(30025,2501,1,1,'[]','[{25010120,4624,6287,100,[]},{25010121,4832,6126,100,[]},{25010122,4873,6408,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(30026,2502,1,1,'[]','[{25010123,5202,9033,100,[]},{25010124,4753,9339,100,[]},{25010125,4800,8825,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(30027,2503,1,1,'[]','[{25010126,19900,7898,100,[]},{25010127,19940,7386,100,[]},{25010128,19657,7609,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(30028,2504,1,1,'[]','[{25010129,18372,8847,100,[]},{25010130,18690,8374,100,[]},{25010131,18603,8944,100,[]},{25010132,18795,8633,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(30030,2501,1,1,'[]','[{25010133,4624,6287,100,[]},{25010134,4832,6126,100,[]},{25010135,4746,6511,100,[]},{25010136,4918,6367,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(40001,40001,1,1,'[]','[{400010001,6107,4246,100,[{group,1}]},{400020001,6579,4538,100,[{group,1}]},{400030001,5989,4171,100,[{group,1}]},{400040001,6225,4339,100,[{group,1}]},{400050001,6345,4386,100,[{group,1}]},{400060001,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,2,1,'[]','[{400010002,6107,4246,100,[{group,1}]},{400020002,6579,4538,100,[{group,1}]},{400030002,5989,4171,100,[{group,1}]},{400040002,6225,4339,100,[{group,1}]},{400050002,6345,4386,100,[{group,1}]},{400060002,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,3,1,'[]','[{400010003,6107,4246,100,[{group,1}]},{400020003,6579,4538,100,[{group,1}]},{400030003,5989,4171,100,[{group,1}]},{400040003,6225,4339,100,[{group,1}]},{400050003,6345,4386,100,[{group,1}]},{400060003,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,4,1,'[]','[{400010004,6107,4246,100,[{group,1}]},{400020004,6579,4538,100,[{group,1}]},{400030004,5989,4171,100,[{group,1}]},{400040004,6225,4339,100,[{group,1}]},{400050004,6345,4386,100,[{group,1}]},{400060004,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,5,1,'[]','[{400010005,6107,4246,100,[{group,1}]},{400020005,6579,4538,100,[{group,1}]},{400030005,5989,4171,100,[{group,1}]},{400040005,6225,4339,100,[{group,1}]},{400050005,6345,4386,100,[{group,1}]},{400060005,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,6,1,'[]','[{400010006,6107,4246,100,[{group,1}]},{400020006,6579,4538,100,[{group,1}]},{400030006,5989,4171,100,[{group,1}]},{400040006,6225,4339,100,[{group,1}]},{400050006,6345,4386,100,[{group,1}]},{400060006,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,7,1,'[]','[{400010007,6107,4246,100,[{group,1}]},{400020007,6579,4538,100,[{group,1}]},{400030007,5989,4171,100,[{group,1}]},{400040007,6225,4339,100,[{group,1}]},{400050007,6345,4386,100,[{group,1}]},{400060007,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,8,1,'[]','[{400010008,6107,4246,100,[{group,1}]},{400020008,6579,4538,100,[{group,1}]},{400030008,5989,4171,100,[{group,1}]},{400040008,6225,4339,100,[{group,1}]},{400050008,6345,4386,100,[{group,1}]},{400060008,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,9,1,'[]','[{400010009,6107,4246,100,[{group,1}]},{400020009,6579,4538,100,[{group,1}]},{400030009,5989,4171,100,[{group,1}]},{400040009,6225,4339,100,[{group,1}]},{400050009,6345,4386,100,[{group,1}]},{400060009,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,10,1,'[]','[{400010010,6107,4246,100,[{group,1}]},{400020010,6579,4538,100,[{group,1}]},{400030010,5989,4171,100,[{group,1}]},{400040010,6225,4339,100,[{group,1}]},{400050010,6345,4386,100,[{group,1}]},{400060010,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,11,1,'[]','[{400010011,6107,4246,100,[{group,1}]},{400020011,6579,4538,100,[{group,1}]},{400030011,5989,4171,100,[{group,1}]},{400040011,6225,4339,100,[{group,1}]},{400050011,6345,4386,100,[{group,1}]},{400060011,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,12,1,'[]','[{400010012,6107,4246,100,[{group,1}]},{400020012,6579,4538,100,[{group,1}]},{400030012,5989,4171,100,[{group,1}]},{400040012,6225,4339,100,[{group,1}]},{400050012,6345,4386,100,[{group,1}]},{400060012,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,13,1,'[]','[{400010013,6107,4246,100,[{group,1}]},{400020013,6579,4538,100,[{group,1}]},{400030013,5989,4171,100,[{group,1}]},{400040013,6225,4339,100,[{group,1}]},{400050013,6345,4386,100,[{group,1}]},{400060013,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,14,1,'[]','[{400010014,6107,4246,100,[{group,1}]},{400020014,6579,4538,100,[{group,1}]},{400030014,5989,4171,100,[{group,1}]},{400040014,6225,4339,100,[{group,1}]},{400050014,6345,4386,100,[{group,1}]},{400060014,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,15,1,'[]','[{400010015,6107,4246,100,[{group,1}]},{400020015,6579,4538,100,[{group,1}]},{400030015,5989,4171,100,[{group,1}]},{400040015,6225,4339,100,[{group,1}]},{400050015,6345,4386,100,[{group,1}]},{400060015,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,16,1,'[]','[{400010016,6107,4246,100,[{group,1}]},{400020016,6579,4538,100,[{group,1}]},{400030016,5989,4171,100,[{group,1}]},{400040016,6225,4339,100,[{group,1}]},{400050016,6345,4386,100,[{group,1}]},{400060016,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,17,1,'[]','[{400010017,6107,4246,100,[{group,1}]},{400020017,6579,4538,100,[{group,1}]},{400030017,5989,4171,100,[{group,1}]},{400040017,6225,4339,100,[{group,1}]},{400050017,6345,4386,100,[{group,1}]},{400060017,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,18,1,'[]','[{400010018,6107,4246,100,[{group,1}]},{400020018,6579,4538,100,[{group,1}]},{400030018,5989,4171,100,[{group,1}]},{400040018,6225,4339,100,[{group,1}]},{400050018,6345,4386,100,[{group,1}]},{400060018,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,19,1,'[]','[{400010019,6107,4246,100,[{group,1}]},{400020019,6579,4538,100,[{group,1}]},{400030019,5989,4171,100,[{group,1}]},{400040019,6225,4339,100,[{group,1}]},{400050019,6345,4386,100,[{group,1}]},{400060019,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,20,1,'[]','[{400010020,6107,4246,100,[{group,1}]},{400020020,6579,4538,100,[{group,1}]},{400030020,5989,4171,100,[{group,1}]},{400040020,6225,4339,100,[{group,1}]},{400050020,6345,4386,100,[{group,1}]},{400060020,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,21,1,'[]','[{400010021,6107,4246,100,[{group,1}]},{400020021,6579,4538,100,[{group,1}]},{400030021,5989,4171,100,[{group,1}]},{400040021,6225,4339,100,[{group,1}]},{400050021,6345,4386,100,[{group,1}]},{400060021,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,22,1,'[]','[{400010022,6107,4246,100,[{group,1}]},{400020022,6579,4538,100,[{group,1}]},{400030022,5989,4171,100,[{group,1}]},{400040022,6225,4339,100,[{group,1}]},{400050022,6345,4386,100,[{group,1}]},{400060022,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,23,1,'[]','[{400010023,6107,4246,100,[{group,1}]},{400020023,6579,4538,100,[{group,1}]},{400030023,5989,4171,100,[{group,1}]},{400040023,6225,4339,100,[{group,1}]},{400050023,6345,4386,100,[{group,1}]},{400060023,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,24,1,'[]','[{400010024,6107,4246,100,[{group,1}]},{400020024,6579,4538,100,[{group,1}]},{400030024,5989,4171,100,[{group,1}]},{400040024,6225,4339,100,[{group,1}]},{400050024,6345,4386,100,[{group,1}]},{400060024,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,25,1,'[]','[{400010025,6107,4246,100,[{group,1}]},{400020025,6579,4538,100,[{group,1}]},{400030025,5989,4171,100,[{group,1}]},{400040025,6225,4339,100,[{group,1}]},{400050025,6345,4386,100,[{group,1}]},{400060025,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,26,1,'[]','[{400010026,6107,4246,100,[{group,1}]},{400020026,6579,4538,100,[{group,1}]},{400030026,5989,4171,100,[{group,1}]},{400040026,6225,4339,100,[{group,1}]},{400050026,6345,4386,100,[{group,1}]},{400060026,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,27,1,'[]','[{400010027,6107,4246,100,[{group,1}]},{400020027,6579,4538,100,[{group,1}]},{400030027,5989,4171,100,[{group,1}]},{400040027,6225,4339,100,[{group,1}]},{400050027,6345,4386,100,[{group,1}]},{400060027,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,28,1,'[]','[{400010028,6107,4246,100,[{group,1}]},{400020028,6579,4538,100,[{group,1}]},{400030028,5989,4171,100,[{group,1}]},{400040028,6225,4339,100,[{group,1}]},{400050028,6345,4386,100,[{group,1}]},{400060028,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,29,1,'[]','[{400010029,6107,4246,100,[{group,1}]},{400020029,6579,4538,100,[{group,1}]},{400030029,5989,4171,100,[{group,1}]},{400040029,6225,4339,100,[{group,1}]},{400050029,6345,4386,100,[{group,1}]},{400060029,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,30,1,'[]','[{400010030,6107,4246,100,[{group,1}]},{400020030,6579,4538,100,[{group,1}]},{400030030,5989,4171,100,[{group,1}]},{400040030,6225,4339,100,[{group,1}]},{400050030,6345,4386,100,[{group,1}]},{400060030,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,31,1,'[]','[{400010031,6107,4246,100,[{group,1}]},{400020031,6579,4538,100,[{group,1}]},{400030031,5989,4171,100,[{group,1}]},{400040031,6225,4339,100,[{group,1}]},{400050031,6345,4386,100,[{group,1}]},{400060031,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,32,1,'[]','[{400010032,6107,4246,100,[{group,1}]},{400020032,6579,4538,100,[{group,1}]},{400030032,5989,4171,100,[{group,1}]},{400040032,6225,4339,100,[{group,1}]},{400050032,6345,4386,100,[{group,1}]},{400060032,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,33,1,'[]','[{400010033,6107,4246,100,[{group,1}]},{400020033,6579,4538,100,[{group,1}]},{400030033,5989,4171,100,[{group,1}]},{400040033,6225,4339,100,[{group,1}]},{400050033,6345,4386,100,[{group,1}]},{400060033,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,34,1,'[]','[{400010034,6107,4246,100,[{group,1}]},{400020034,6579,4538,100,[{group,1}]},{400030034,5989,4171,100,[{group,1}]},{400040034,6225,4339,100,[{group,1}]},{400050034,6345,4386,100,[{group,1}]},{400060034,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,35,1,'[]','[{400010035,6107,4246,100,[{group,1}]},{400020035,6579,4538,100,[{group,1}]},{400030035,5989,4171,100,[{group,1}]},{400040035,6225,4339,100,[{group,1}]},{400050035,6345,4386,100,[{group,1}]},{400060035,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,36,1,'[]','[{400010036,6107,4246,100,[{group,1}]},{400020036,6579,4538,100,[{group,1}]},{400030036,5989,4171,100,[{group,1}]},{400040036,6225,4339,100,[{group,1}]},{400050036,6345,4386,100,[{group,1}]},{400060036,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,37,1,'[]','[{400010037,6107,4246,100,[{group,1}]},{400020037,6579,4538,100,[{group,1}]},{400030037,5989,4171,100,[{group,1}]},{400040037,6225,4339,100,[{group,1}]},{400050037,6345,4386,100,[{group,1}]},{400060037,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,38,1,'[]','[{400010038,6107,4246,100,[{group,1}]},{400020038,6579,4538,100,[{group,1}]},{400030038,5989,4171,100,[{group,1}]},{400040038,6225,4339,100,[{group,1}]},{400050038,6345,4386,100,[{group,1}]},{400060038,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,39,1,'[]','[{400010039,6107,4246,100,[{group,1}]},{400020039,6579,4538,100,[{group,1}]},{400030039,5989,4171,100,[{group,1}]},{400040039,6225,4339,100,[{group,1}]},{400050039,6345,4386,100,[{group,1}]},{400060039,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,40,1,'[]','[{400010040,6107,4246,100,[{group,1}]},{400020040,6579,4538,100,[{group,1}]},{400030040,5989,4171,100,[{group,1}]},{400040040,6225,4339,100,[{group,1}]},{400050040,6345,4386,100,[{group,1}]},{400060040,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,41,1,'[]','[{400010041,6107,4246,100,[{group,1}]},{400020041,6579,4538,100,[{group,1}]},{400030041,5989,4171,100,[{group,1}]},{400040041,6225,4339,100,[{group,1}]},{400050041,6345,4386,100,[{group,1}]},{400060041,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,42,1,'[]','[{400010042,6107,4246,100,[{group,1}]},{400020042,6579,4538,100,[{group,1}]},{400030042,5989,4171,100,[{group,1}]},{400040042,6225,4339,100,[{group,1}]},{400050042,6345,4386,100,[{group,1}]},{400060042,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,43,1,'[]','[{400010043,6107,4246,100,[{group,1}]},{400020043,6579,4538,100,[{group,1}]},{400030043,5989,4171,100,[{group,1}]},{400040043,6225,4339,100,[{group,1}]},{400050043,6345,4386,100,[{group,1}]},{400060043,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,44,1,'[]','[{400010044,6107,4246,100,[{group,1}]},{400020044,6579,4538,100,[{group,1}]},{400030044,5989,4171,100,[{group,1}]},{400040044,6225,4339,100,[{group,1}]},{400050044,6345,4386,100,[{group,1}]},{400060044,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,45,1,'[]','[{400010045,6107,4246,100,[{group,1}]},{400020045,6579,4538,100,[{group,1}]},{400030045,5989,4171,100,[{group,1}]},{400040045,6225,4339,100,[{group,1}]},{400050045,6345,4386,100,[{group,1}]},{400060045,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,46,1,'[]','[{400010046,6107,4246,100,[{group,1}]},{400020046,6579,4538,100,[{group,1}]},{400030046,5989,4171,100,[{group,1}]},{400040046,6225,4339,100,[{group,1}]},{400050046,6345,4386,100,[{group,1}]},{400060046,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,47,1,'[]','[{400010047,6107,4246,100,[{group,1}]},{400020047,6579,4538,100,[{group,1}]},{400030047,5989,4171,100,[{group,1}]},{400040047,6225,4339,100,[{group,1}]},{400050047,6345,4386,100,[{group,1}]},{400060047,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,48,1,'[]','[{400010048,6107,4246,100,[{group,1}]},{400020048,6579,4538,100,[{group,1}]},{400030048,5989,4171,100,[{group,1}]},{400040048,6225,4339,100,[{group,1}]},{400050048,6345,4386,100,[{group,1}]},{400060048,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,49,1,'[]','[{400010049,6107,4246,100,[{group,1}]},{400020049,6579,4538,100,[{group,1}]},{400030049,5989,4171,100,[{group,1}]},{400040049,6225,4339,100,[{group,1}]},{400050049,6345,4386,100,[{group,1}]},{400060049,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,50,1,'[]','[{400010050,6107,4246,100,[{group,1}]},{400020050,6579,4538,100,[{group,1}]},{400030050,5989,4171,100,[{group,1}]},{400040050,6225,4339,100,[{group,1}]},{400050050,6345,4386,100,[{group,1}]},{400060050,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,51,1,'[]','[{400010051,6107,4246,100,[{group,1}]},{400020051,6579,4538,100,[{group,1}]},{400030051,5989,4171,100,[{group,1}]},{400040051,6225,4339,100,[{group,1}]},{400050051,6345,4386,100,[{group,1}]},{400060051,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,52,1,'[]','[{400010052,6107,4246,100,[{group,1}]},{400020052,6579,4538,100,[{group,1}]},{400030052,5989,4171,100,[{group,1}]},{400040052,6225,4339,100,[{group,1}]},{400050052,6345,4386,100,[{group,1}]},{400060052,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,53,1,'[]','[{400010053,6107,4246,100,[{group,1}]},{400020053,6579,4538,100,[{group,1}]},{400030053,5989,4171,100,[{group,1}]},{400040053,6225,4339,100,[{group,1}]},{400050053,6345,4386,100,[{group,1}]},{400060053,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,54,1,'[]','[{400010054,6107,4246,100,[{group,1}]},{400020054,6579,4538,100,[{group,1}]},{400030054,5989,4171,100,[{group,1}]},{400040054,6225,4339,100,[{group,1}]},{400050054,6345,4386,100,[{group,1}]},{400060054,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,55,1,'[]','[{400010055,6107,4246,100,[{group,1}]},{400020055,6579,4538,100,[{group,1}]},{400030055,5989,4171,100,[{group,1}]},{400040055,6225,4339,100,[{group,1}]},{400050055,6345,4386,100,[{group,1}]},{400060055,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,56,1,'[]','[{400010056,6107,4246,100,[{group,1}]},{400020056,6579,4538,100,[{group,1}]},{400030056,5989,4171,100,[{group,1}]},{400040056,6225,4339,100,[{group,1}]},{400050056,6345,4386,100,[{group,1}]},{400060056,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,57,1,'[]','[{400010057,6107,4246,100,[{group,1}]},{400020057,6579,4538,100,[{group,1}]},{400030057,5989,4171,100,[{group,1}]},{400040057,6225,4339,100,[{group,1}]},{400050057,6345,4386,100,[{group,1}]},{400060057,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,58,1,'[]','[{400010058,6107,4246,100,[{group,1}]},{400020058,6579,4538,100,[{group,1}]},{400030058,5989,4171,100,[{group,1}]},{400040058,6225,4339,100,[{group,1}]},{400050058,6345,4386,100,[{group,1}]},{400060058,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,59,1,'[]','[{400010059,6107,4246,100,[{group,1}]},{400020059,6579,4538,100,[{group,1}]},{400030059,5989,4171,100,[{group,1}]},{400040059,6225,4339,100,[{group,1}]},{400050059,6345,4386,100,[{group,1}]},{400060059,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,60,1,'[]','[{400010060,6107,4246,100,[{group,1}]},{400020060,6579,4538,100,[{group,1}]},{400030060,5989,4171,100,[{group,1}]},{400040060,6225,4339,100,[{group,1}]},{400050060,6345,4386,100,[{group,1}]},{400060060,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,61,1,'[]','[{400010061,6107,4246,100,[{group,1}]},{400020061,6579,4538,100,[{group,1}]},{400030061,5989,4171,100,[{group,1}]},{400040061,6225,4339,100,[{group,1}]},{400050061,6345,4386,100,[{group,1}]},{400060061,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,62,1,'[]','[{400010062,6107,4246,100,[{group,1}]},{400020062,6579,4538,100,[{group,1}]},{400030062,5989,4171,100,[{group,1}]},{400040062,6225,4339,100,[{group,1}]},{400050062,6345,4386,100,[{group,1}]},{400060062,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,63,1,'[]','[{400010063,6107,4246,100,[{group,1}]},{400020063,6579,4538,100,[{group,1}]},{400030063,5989,4171,100,[{group,1}]},{400040063,6225,4339,100,[{group,1}]},{400050063,6345,4386,100,[{group,1}]},{400060063,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,64,1,'[]','[{400010064,6107,4246,100,[{group,1}]},{400020064,6579,4538,100,[{group,1}]},{400030064,5989,4171,100,[{group,1}]},{400040064,6225,4339,100,[{group,1}]},{400050064,6345,4386,100,[{group,1}]},{400060064,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,65,1,'[]','[{400010065,6107,4246,100,[{group,1}]},{400020065,6579,4538,100,[{group,1}]},{400030065,5989,4171,100,[{group,1}]},{400040065,6225,4339,100,[{group,1}]},{400050065,6345,4386,100,[{group,1}]},{400060065,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,66,1,'[]','[{400010066,6107,4246,100,[{group,1}]},{400020066,6579,4538,100,[{group,1}]},{400030066,5989,4171,100,[{group,1}]},{400040066,6225,4339,100,[{group,1}]},{400050066,6345,4386,100,[{group,1}]},{400060066,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,67,1,'[]','[{400010067,6107,4246,100,[{group,1}]},{400020067,6579,4538,100,[{group,1}]},{400030067,5989,4171,100,[{group,1}]},{400040067,6225,4339,100,[{group,1}]},{400050067,6345,4386,100,[{group,1}]},{400060067,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,68,1,'[]','[{400010068,6107,4246,100,[{group,1}]},{400020068,6579,4538,100,[{group,1}]},{400030068,5989,4171,100,[{group,1}]},{400040068,6225,4339,100,[{group,1}]},{400050068,6345,4386,100,[{group,1}]},{400060068,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,69,1,'[]','[{400010069,6107,4246,100,[{group,1}]},{400020069,6579,4538,100,[{group,1}]},{400030069,5989,4171,100,[{group,1}]},{400040069,6225,4339,100,[{group,1}]},{400050069,6345,4386,100,[{group,1}]},{400060069,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,70,1,'[]','[{400010070,6107,4246,100,[{group,1}]},{400020070,6579,4538,100,[{group,1}]},{400030070,5989,4171,100,[{group,1}]},{400040070,6225,4339,100,[{group,1}]},{400050070,6345,4386,100,[{group,1}]},{400060070,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,71,1,'[]','[{400010071,6107,4246,100,[{group,1}]},{400020071,6579,4538,100,[{group,1}]},{400030071,5989,4171,100,[{group,1}]},{400040071,6225,4339,100,[{group,1}]},{400050071,6345,4386,100,[{group,1}]},{400060071,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,72,1,'[]','[{400010072,6107,4246,100,[{group,1}]},{400020072,6579,4538,100,[{group,1}]},{400030072,5989,4171,100,[{group,1}]},{400040072,6225,4339,100,[{group,1}]},{400050072,6345,4386,100,[{group,1}]},{400060072,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,73,1,'[]','[{400010073,6107,4246,100,[{group,1}]},{400020073,6579,4538,100,[{group,1}]},{400030073,5989,4171,100,[{group,1}]},{400040073,6225,4339,100,[{group,1}]},{400050073,6345,4386,100,[{group,1}]},{400060073,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,74,1,'[]','[{400010074,6107,4246,100,[{group,1}]},{400020074,6579,4538,100,[{group,1}]},{400030074,5989,4171,100,[{group,1}]},{400040074,6225,4339,100,[{group,1}]},{400050074,6345,4386,100,[{group,1}]},{400060074,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,75,1,'[]','[{400010075,6107,4246,100,[{group,1}]},{400020075,6579,4538,100,[{group,1}]},{400030075,5989,4171,100,[{group,1}]},{400040075,6225,4339,100,[{group,1}]},{400050075,6345,4386,100,[{group,1}]},{400060075,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,76,1,'[]','[{400010076,6107,4246,100,[{group,1}]},{400020076,6579,4538,100,[{group,1}]},{400030076,5989,4171,100,[{group,1}]},{400040076,6225,4339,100,[{group,1}]},{400050076,6345,4386,100,[{group,1}]},{400060076,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,77,1,'[]','[{400010077,6107,4246,100,[{group,1}]},{400020077,6579,4538,100,[{group,1}]},{400030077,5989,4171,100,[{group,1}]},{400040077,6225,4339,100,[{group,1}]},{400050077,6345,4386,100,[{group,1}]},{400060077,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,78,1,'[]','[{400010078,6107,4246,100,[{group,1}]},{400020078,6579,4538,100,[{group,1}]},{400030078,5989,4171,100,[{group,1}]},{400040078,6225,4339,100,[{group,1}]},{400050078,6345,4386,100,[{group,1}]},{400060078,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,79,1,'[]','[{400010079,6107,4246,100,[{group,1}]},{400020079,6579,4538,100,[{group,1}]},{400030079,5989,4171,100,[{group,1}]},{400040079,6225,4339,100,[{group,1}]},{400050079,6345,4386,100,[{group,1}]},{400060079,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,80,1,'[]','[{400010080,6107,4246,100,[{group,1}]},{400020080,6579,4538,100,[{group,1}]},{400030080,5989,4171,100,[{group,1}]},{400040080,6225,4339,100,[{group,1}]},{400050080,6345,4386,100,[{group,1}]},{400060080,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,81,1,'[]','[{400010081,6107,4246,100,[{group,1}]},{400020081,6579,4538,100,[{group,1}]},{400030081,5989,4171,100,[{group,1}]},{400040081,6225,4339,100,[{group,1}]},{400050081,6345,4386,100,[{group,1}]},{400060081,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,82,1,'[]','[{400010082,6107,4246,100,[{group,1}]},{400020082,6579,4538,100,[{group,1}]},{400030082,5989,4171,100,[{group,1}]},{400040082,6225,4339,100,[{group,1}]},{400050082,6345,4386,100,[{group,1}]},{400060082,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,83,1,'[]','[{400010083,6107,4246,100,[{group,1}]},{400020083,6579,4538,100,[{group,1}]},{400030083,5989,4171,100,[{group,1}]},{400040083,6225,4339,100,[{group,1}]},{400050083,6345,4386,100,[{group,1}]},{400060083,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,84,1,'[]','[{400010084,6107,4246,100,[{group,1}]},{400020084,6579,4538,100,[{group,1}]},{400030084,5989,4171,100,[{group,1}]},{400040084,6225,4339,100,[{group,1}]},{400050084,6345,4386,100,[{group,1}]},{400060084,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,85,1,'[]','[{400010085,6107,4246,100,[{group,1}]},{400020085,6579,4538,100,[{group,1}]},{400030085,5989,4171,100,[{group,1}]},{400040085,6225,4339,100,[{group,1}]},{400050085,6345,4386,100,[{group,1}]},{400060085,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,86,1,'[]','[{400010086,6107,4246,100,[{group,1}]},{400020086,6579,4538,100,[{group,1}]},{400030086,5989,4171,100,[{group,1}]},{400040086,6225,4339,100,[{group,1}]},{400050086,6345,4386,100,[{group,1}]},{400060086,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,87,1,'[]','[{400010087,6107,4246,100,[{group,1}]},{400020087,6579,4538,100,[{group,1}]},{400030087,5989,4171,100,[{group,1}]},{400040087,6225,4339,100,[{group,1}]},{400050087,6345,4386,100,[{group,1}]},{400060087,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,88,1,'[]','[{400010088,6107,4246,100,[{group,1}]},{400020088,6579,4538,100,[{group,1}]},{400030088,5989,4171,100,[{group,1}]},{400040088,6225,4339,100,[{group,1}]},{400050088,6345,4386,100,[{group,1}]},{400060088,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,89,1,'[]','[{400010089,6107,4246,100,[{group,1}]},{400020089,6579,4538,100,[{group,1}]},{400030089,5989,4171,100,[{group,1}]},{400040089,6225,4339,100,[{group,1}]},{400050089,6345,4386,100,[{group,1}]},{400060089,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,90,1,'[]','[{400010090,6107,4246,100,[{group,1}]},{400020090,6579,4538,100,[{group,1}]},{400030090,5989,4171,100,[{group,1}]},{400040090,6225,4339,100,[{group,1}]},{400050090,6345,4386,100,[{group,1}]},{400060090,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,91,1,'[]','[{400010091,6107,4246,100,[{group,1}]},{400020091,6579,4538,100,[{group,1}]},{400030091,5989,4171,100,[{group,1}]},{400040091,6225,4339,100,[{group,1}]},{400050091,6345,4386,100,[{group,1}]},{400060091,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,92,1,'[]','[{400010092,6107,4246,100,[{group,1}]},{400020092,6579,4538,100,[{group,1}]},{400030092,5989,4171,100,[{group,1}]},{400040092,6225,4339,100,[{group,1}]},{400050092,6345,4386,100,[{group,1}]},{400060092,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,93,1,'[]','[{400010093,6107,4246,100,[{group,1}]},{400020093,6579,4538,100,[{group,1}]},{400030093,5989,4171,100,[{group,1}]},{400040093,6225,4339,100,[{group,1}]},{400050093,6345,4386,100,[{group,1}]},{400060093,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,94,1,'[]','[{400010094,6107,4246,100,[{group,1}]},{400020094,6579,4538,100,[{group,1}]},{400030094,5989,4171,100,[{group,1}]},{400040094,6225,4339,100,[{group,1}]},{400050094,6345,4386,100,[{group,1}]},{400060094,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,95,1,'[]','[{400010095,6107,4246,100,[{group,1}]},{400020095,6579,4538,100,[{group,1}]},{400030095,5989,4171,100,[{group,1}]},{400040095,6225,4339,100,[{group,1}]},{400050095,6345,4386,100,[{group,1}]},{400060095,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,96,1,'[]','[{400010096,6107,4246,100,[{group,1}]},{400020096,6579,4538,100,[{group,1}]},{400030096,5989,4171,100,[{group,1}]},{400040096,6225,4339,100,[{group,1}]},{400050096,6345,4386,100,[{group,1}]},{400060096,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,97,1,'[]','[{400010097,6107,4246,100,[{group,1}]},{400020097,6579,4538,100,[{group,1}]},{400030097,5989,4171,100,[{group,1}]},{400040097,6225,4339,100,[{group,1}]},{400050097,6345,4386,100,[{group,1}]},{400060097,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,98,1,'[]','[{400010098,6107,4246,100,[{group,1}]},{400020098,6579,4538,100,[{group,1}]},{400030098,5989,4171,100,[{group,1}]},{400040098,6225,4339,100,[{group,1}]},{400050098,6345,4386,100,[{group,1}]},{400060098,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,99,1,'[]','[{400010099,6107,4246,100,[{group,1}]},{400020099,6579,4538,100,[{group,1}]},{400030099,5989,4171,100,[{group,1}]},{400040099,6225,4339,100,[{group,1}]},{400050099,6345,4386,100,[{group,1}]},{400060099,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(40001,40001,100,1,'[]','[{400010100,6107,4246,100,[{group,1}]},{400020100,6579,4538,100,[{group,1}]},{400030100,5989,4171,100,[{group,1}]},{400040100,6225,4339,100,[{group,1}]},{400050100,6345,4386,100,[{group,1}]},{400060100,6468,4457,100,[{group,1}]}]','[]','[]',5000,0,1,1500,0,0,0,'',''),(56000,5600,1,1,'[]','[{56000001,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56001,5600,1,1,'[]','[{56000002,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56002,5600,1,1,'[]','[{56000003,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56003,5600,1,1,'[]','[{56000004,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56004,5600,1,1,'[]','[{56000005,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56005,5600,1,1,'[]','[{56000006,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56006,5600,1,1,'[]','[{56000007,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56007,5600,1,1,'[]','[{56000008,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56008,5600,1,1,'[]','[{56000009,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56009,5600,1,1,'[]','[{56000010,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56010,5600,1,1,'[]','[{56000011,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56011,5600,1,1,'[]','[{56000012,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56012,5600,1,1,'[]','[{56000013,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56013,5600,1,1,'[]','[{56000014,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56014,5600,1,1,'[]','[{56000015,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56015,5600,1,1,'[]','[{56000016,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56016,5600,1,1,'[]','[{56000017,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56017,5600,1,1,'[]','[{56000018,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56018,5600,1,1,'[]','[{56000019,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56019,5600,1,1,'[]','[{56000020,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56020,5600,1,1,'[]','[{56000021,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56021,5600,1,1,'[]','[{56000022,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56022,5600,1,1,'[]','[{56000023,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56023,5600,1,1,'[]','[{56000024,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56024,5600,1,1,'[]','[{56000025,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56025,5600,1,1,'[]','[{56000026,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56026,5600,1,1,'[]','[{56000027,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56027,5600,1,1,'[]','[{56000028,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56028,5600,1,1,'[]','[{56000029,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56029,5600,1,1,'[]','[{56000030,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56030,5600,1,1,'[]','[{56000031,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56031,5600,1,1,'[]','[{56000032,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56032,5600,1,1,'[]','[{56000033,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56033,5600,1,1,'[]','[{56000034,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56034,5600,1,1,'[]','[{56000035,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56035,5600,1,1,'[]','[{56000036,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56036,5600,1,1,'[]','[{56000037,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56037,5600,1,1,'[]','[{56000038,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56038,5600,1,1,'[]','[{56000039,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56039,5600,1,1,'[]','[{56000040,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56040,5600,1,1,'[]','[{56000041,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56041,5600,1,1,'[]','[{56000042,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56042,5600,1,1,'[]','[{56000043,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56043,5600,1,1,'[]','[{56000044,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56044,5600,1,1,'[]','[{56000045,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56045,5600,1,1,'[]','[{56000046,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56046,5600,1,1,'[]','[{56000047,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56047,5600,1,1,'[]','[{56000048,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56048,5600,1,1,'[]','[{56000049,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56049,5600,1,1,'[]','[{56000050,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56050,5600,1,1,'[]','[{56000051,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56051,5600,1,1,'[]','[{56000052,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56052,5600,1,1,'[]','[{56000053,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56053,5600,1,1,'[]','[{56000054,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56054,5600,1,1,'[]','[{56000055,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56055,5600,1,1,'[]','[{56000056,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56056,5600,1,1,'[]','[{56000057,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56057,5600,1,1,'[]','[{56000058,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56058,5600,1,1,'[]','[{56000059,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56059,5600,1,1,'[]','[{56000060,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56060,5600,1,1,'[]','[{56000061,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56061,5600,1,1,'[]','[{56000062,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56062,5600,1,1,'[]','[{56000063,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56063,5600,1,1,'[]','[{56000064,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56064,5600,1,1,'[]','[{56000065,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56065,5600,1,1,'[]','[{56000066,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56066,5600,1,1,'[]','[{56000067,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56067,5600,1,1,'[]','[{56000068,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56068,5600,1,1,'[]','[{56000069,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56069,5600,1,1,'[]','[{56000070,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56070,5600,1,1,'[]','[{56000071,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56071,5600,1,1,'[]','[{56000072,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56072,5600,1,1,'[]','[{56000073,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56073,5600,1,1,'[]','[{56000074,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56074,5600,1,1,'[]','[{56000075,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56075,5600,1,1,'[]','[{56000076,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56076,5600,1,1,'[]','[{56000077,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56077,5600,1,1,'[]','[{56000078,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56078,5600,1,1,'[]','[{56000079,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56079,5600,1,1,'[]','[{56000080,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56080,5600,1,1,'[]','[{56000081,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56081,5600,1,1,'[]','[{56000082,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56082,5600,1,1,'[]','[{56000083,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56083,5600,1,1,'[]','[{56000084,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56084,5600,1,1,'[]','[{56000085,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56085,5600,1,1,'[]','[{56000086,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56086,5600,1,1,'[]','[{56000087,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56087,5600,1,1,'[]','[{56000088,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56088,5600,1,1,'[]','[{56000089,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56089,5600,1,1,'[]','[{56000090,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56090,5600,1,1,'[]','[{56000091,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56091,5600,1,1,'[]','[{56000092,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56092,5600,1,1,'[]','[{56000093,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56093,5600,1,1,'[]','[{56000094,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56094,5600,1,1,'[]','[{56000095,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56095,5600,1,1,'[]','[{56000096,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56096,5600,1,1,'[]','[{56000097,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56097,5600,1,1,'[]','[{56000098,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56098,5600,1,1,'[]','[{56000099,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(56099,5600,1,1,'[]','[{56000100,3237,2775,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(60000,60000,1,1,'[]','[{600019,6250,4044,100,[{group,99}]}]','[]','[]',0,0,1,0,0,0,0,'',''),(60000,60000,2,1,'[]','[{600001,5790,8285,100,[{group,1},{die_info,klist}]},{600002,9361,7051,100,[{group,1},{die_info,klist}]},{600003,10419,3459,100,[{group,1},{die_info,klist}]}]','[]','[]',3000,0,6,1000,0,0,0,'第1波怪物发起攻击，小心防守！',''),(60000,60000,3,1,'[]','[{600004,5790,8285,100,[{group,1},{die_info,klist}]},{600005,9361,7051,100,[{group,1},{die_info,klist}]},{600006,10419,3459,100,[{group,1},{die_info,klist}]}]','[]','[]',3000,0,6,1000,0,0,0,'第2波怪物发起攻击，小心防守！',''),(60000,60000,4,1,'[]','[{600007,5790,8285,100,[{group,1},{die_info,klist}]},{600008,9361,7051,100,[{group,1},{die_info,klist}]},{600009,10419,3459,100,[{group,1},{die_info,klist}]}]','[]','[]',3000,0,6,1000,0,0,0,'第3波怪物发起攻击，小心防守！',''),(60000,60000,5,1,'[]','[{600010,5790,8285,100,[{group,1},{die_info,klist}]},{600011,9361,7051,100,[{group,1},{die_info,klist}]},{600012,10419,3459,100,[{group,1},{die_info,klist}]}]','[]','[]',3000,0,6,1000,0,0,0,'第4波怪物发起攻击，小心防守！',''),(60000,60000,6,1,'[]','[{600013,5790,8285,100,[{group,1},{die_info,klist}]},{600014,9361,7051,100,[{group,1},{die_info,klist}]},{600015,10419,3459,100,[{group,1},{die_info,klist}]}]','[]','[]',3000,0,6,1000,0,0,0,'第5波怪物发起攻击，小心防守！',''),(60000,60000,7,1,'[]','[{600016,5790,8285,100,[{group,1},{die_info,klist}]},{600017,9361,7051,100,[{group,1},{die_info,klist}]},{600018,10419,3459,100,[{group,1},{die_info,klist}]}]','[]','[]',3000,0,1,1000,0,0,0,'第6波怪物发起攻击，小心防守！',''),(60001,60000,1,1,'[]','[{600039,6250,4044,100,[{group,99}]}]','[]','[]',0,0,1,0,0,0,0,'',''),(60001,60000,2,1,'[]','[{600021,5790,8285,100,[{group,1},{die_info,klist}]},{600022,9361,7051,100,[{group,1},{die_info,klist}]},{600023,10419,3459,100,[{group,1},{die_info,klist}]}]','[]','[]',3000,0,6,1000,0,0,0,'第1波怪物发起攻击，小心防守！',''),(60001,60000,3,1,'[]','[{600024,5790,8285,100,[{group,1},{die_info,klist}]},{600025,9361,7051,100,[{group,1},{die_info,klist}]},{600026,10419,3459,100,[{group,1},{die_info,klist}]}]','[]','[]',3000,0,6,1000,0,0,0,'第2波怪物发起攻击，小心防守！',''),(60001,60000,4,1,'[]','[{600027,5790,8285,100,[{group,1},{die_info,klist}]},{600028,9361,7051,100,[{group,1},{die_info,klist}]},{600029,10419,3459,100,[{group,1},{die_info,klist}]}]','[]','[]',3000,0,6,1000,0,0,0,'第3波怪物发起攻击，小心防守！',''),(60001,60000,5,1,'[]','[{600030,5790,8285,100,[{group,1},{die_info,klist}]},{600031,9361,7051,100,[{group,1},{die_info,klist}]},{600032,10419,3459,100,[{group,1},{die_info,klist}]}]','[]','[]',3000,0,6,1000,0,0,0,'第4波怪物发起攻击，小心防守！',''),(60001,60000,6,1,'[]','[{600033,5790,8285,100,[{group,1},{die_info,klist}]},{600034,9361,7051,100,[{group,1},{die_info,klist}]},{600035,10419,3459,100,[{group,1},{die_info,klist}]}]','[]','[]',3000,0,6,1000,0,0,0,'第5波怪物发起攻击，小心防守！',''),(60001,60000,7,1,'[]','[{600036,5790,8285,100,[{group,1},{die_info,klist}]},{600037,9361,7051,100,[{group,1},{die_info,klist}]},{600038,10419,3459,100,[{group,1},{die_info,klist}]}]','[]','[]',3000,0,1,1000,0,0,0,'第6波怪物发起攻击，小心防守！',''),(60002,60000,1,1,'[]','[{600059,6250,4044,100,[{group,99}]}]','[]','[]',0,0,1,0,0,0,0,'',''),(60002,60000,2,1,'[]','[{600041,5790,8285,100,[{group,1},{die_info,klist}]},{600042,9361,7051,100,[{group,1},{die_info,klist}]},{600043,10419,3459,100,[{group,1},{die_info,klist}]}]','[]','[]',3000,0,6,1000,0,0,0,'第1波怪物发起攻击，小心防守！',''),(60002,60000,3,1,'[]','[{600044,5790,8285,100,[{group,1},{die_info,klist}]},{600045,9361,7051,100,[{group,1},{die_info,klist}]},{600046,10419,3459,100,[{group,1},{die_info,klist}]}]','[]','[]',3000,0,6,1000,0,0,0,'第2波怪物发起攻击，小心防守！',''),(60002,60000,4,1,'[]','[{600047,5790,8285,100,[{group,1},{die_info,klist}]},{600048,9361,7051,100,[{group,1},{die_info,klist}]},{600049,10419,3459,100,[{group,1},{die_info,klist}]}]','[]','[]',3000,0,6,1000,0,0,0,'第3波怪物发起攻击，小心防守！',''),(60002,60000,5,1,'[]','[{600050,5790,8285,100,[{group,1},{die_info,klist}]},{600051,9361,7051,100,[{group,1},{die_info,klist}]},{600052,10419,3459,100,[{group,1},{die_info,klist}]}]','[]','[]',3000,0,6,1000,0,0,0,'第4波怪物发起攻击，小心防守！',''),(60002,60000,6,1,'[]','[{600053,5790,8285,100,[{group,1},{die_info,klist}]},{600054,9361,7051,100,[{group,1},{die_info,klist}]},{600055,10419,3459,100,[{group,1},{die_info,klist}]}]','[]','[]',3000,0,6,1000,0,0,0,'第5波怪物发起攻击，小心防守！',''),(60002,60000,7,1,'[]','[{600056,5790,8285,100,[{group,1},{die_info,klist}]},{600057,9361,7051,100,[{group,1},{die_info,klist}]},{600058,10419,3459,100,[{group,1},{die_info,klist}]}]','[]','[]',3000,0,1,1000,0,0,0,'第6波怪物发起攻击，小心防守！',''),(60003,60000,1,1,'[]','[{600079,6250,4044,100,[{group,99}]}]','[]','[]',0,0,1,0,0,0,0,'',''),(60003,60000,2,1,'[]','[{600061,5790,8285,100,[{group,1},{die_info,klist}]},{600062,9361,7051,100,[{group,1},{die_info,klist}]},{600063,10419,3459,100,[{group,1},{die_info,klist}]}]','[]','[]',3000,0,6,1000,0,0,0,'第1波怪物发起攻击，小心防守！',''),(60003,60000,3,1,'[]','[{600064,5790,8285,100,[{group,1},{die_info,klist}]},{600065,9361,7051,100,[{group,1},{die_info,klist}]},{600066,10419,3459,100,[{group,1},{die_info,klist}]}]','[]','[]',3000,0,6,1000,0,0,0,'第2波怪物发起攻击，小心防守！',''),(60003,60000,4,1,'[]','[{600067,5790,8285,100,[{group,1},{die_info,klist}]},{600068,9361,7051,100,[{group,1},{die_info,klist}]},{600069,10419,3459,100,[{group,1},{die_info,klist}]}]','[]','[]',3000,0,6,1000,0,0,0,'第3波怪物发起攻击，小心防守！',''),(60003,60000,5,1,'[]','[{600070,5790,8285,100,[{group,1},{die_info,klist}]},{600071,9361,7051,100,[{group,1},{die_info,klist}]},{600072,10419,3459,100,[{group,1},{die_info,klist}]}]','[]','[]',3000,0,6,1000,0,0,0,'第4波怪物发起攻击，小心防守！',''),(60003,60000,6,1,'[]','[{600073,5790,8285,100,[{group,1},{die_info,klist}]},{600074,9361,7051,100,[{group,1},{die_info,klist}]},{600055,10419,3459,100,[{group,1},{die_info,klist}]}]','[]','[]',3000,0,6,1000,0,0,0,'第5波怪物发起攻击，小心防守！',''),(60003,60000,7,1,'[]','[{600076,5790,8285,100,[{group,1},{die_info,klist}]},{600077,9361,7051,100,[{group,1},{die_info,klist}]},{600078,10419,3459,100,[{group,1},{die_info,klist}]}]','[]','[]',3000,0,1,1000,0,0,0,'第6波怪物发起攻击，小心防守！',''),(60004,60000,1,1,'[]','[{600099,6250,4044,100,[{group,99}]}]','[]','[]',0,0,1,0,0,0,0,'',''),(60004,60000,2,1,'[]','[{600081,5790,8285,100,[{group,1},{die_info,klist}]},{600082,9361,7051,100,[{group,1},{die_info,klist}]},{600083,10419,3459,100,[{group,1},{die_info,klist}]}]','[]','[]',3000,0,6,1000,0,0,0,'第1波怪物发起攻击，小心防守！',''),(60004,60000,3,1,'[]','[{600084,5790,8285,100,[{group,1},{die_info,klist}]},{600085,9361,7051,100,[{group,1},{die_info,klist}]},{600086,10419,3459,100,[{group,1},{die_info,klist}]}]','[]','[]',3000,0,6,1000,0,0,0,'第2波怪物发起攻击，小心防守！',''),(60004,60000,4,1,'[]','[{600087,5790,8285,100,[{group,1},{die_info,klist}]},{600088,9361,7051,100,[{group,1},{die_info,klist}]},{600089,10419,3459,100,[{group,1},{die_info,klist}]}]','[]','[]',3000,0,6,1000,0,0,0,'第3波怪物发起攻击，小心防守！',''),(60004,60000,5,1,'[]','[{600090,5790,8285,100,[{group,1},{die_info,klist}]},{600091,9361,7051,100,[{group,1},{die_info,klist}]},{600092,10419,3459,100,[{group,1},{die_info,klist}]}]','[]','[]',3000,0,6,1000,0,0,0,'第4波怪物发起攻击，小心防守！',''),(60004,60000,6,1,'[]','[{600093,5790,8285,100,[{group,1},{die_info,klist}]},{600094,9361,7051,100,[{group,1},{die_info,klist}]},{600095,10419,3459,100,[{group,1},{die_info,klist}]}]','[]','[]',3000,0,6,1000,0,0,0,'第5波怪物发起攻击，小心防守！',''),(60004,60000,7,1,'[]','[{600096,5790,8285,100,[{group,1},{die_info,klist}]},{600097,9361,7051,100,[{group,1},{die_info,klist}]},{600098,10419,3459,100,[{group,1},{die_info,klist}]}]','[]','[]',3000,0,1,1000,0,0,0,'第6波怪物发起攻击，小心防守！',''),(70001,7700,1,1,'[]','[{70101001,4896,4826,100,[]},{70101001,5079,4355,100,[]},{70101001,5148,4741,100,[]},{70101001,5230,4491,100,[]},{70101001,5029,4921,100,[]},{70101001,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70002,7700,1,1,'[]','[{70101002,4896,4826,100,[]},{70101002,5079,4355,100,[]},{70101002,5148,4741,100,[]},{70101002,5230,4491,100,[]},{70101002,5029,4921,100,[]},{70101002,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70003,7700,1,1,'[]','[{70101003,4896,4826,100,[]},{70101003,5079,4355,100,[]},{70101003,5148,4741,100,[]},{70101003,5230,4491,100,[]},{70101003,5029,4921,100,[]},{70101003,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70004,7700,1,1,'[]','[{70101004,4896,4826,100,[]},{70101004,5079,4355,100,[]},{70101004,5148,4741,100,[]},{70101004,5230,4491,100,[]},{70101004,5029,4921,100,[]},{70101004,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70005,7700,1,1,'[]','[{70101005,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70006,7700,1,1,'[]','[{70101006,4896,4826,100,[]},{70101006,5079,4355,100,[]},{70101006,5148,4741,100,[]},{70101006,5230,4491,100,[]},{70101006,5029,4921,100,[]},{70101006,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70007,7700,1,1,'[]','[{70101007,4896,4826,100,[]},{70101007,5079,4355,100,[]},{70101007,5148,4741,100,[]},{70101007,5230,4491,100,[]},{70101007,5029,4921,100,[]},{70101007,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70008,7700,1,1,'[]','[{70101008,4896,4826,100,[]},{70101008,5079,4355,100,[]},{70101008,5148,4741,100,[]},{70101008,5230,4491,100,[]},{70101008,5029,4921,100,[]},{70101008,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70009,7700,1,1,'[]','[{70101009,4896,4826,100,[]},{70101009,5079,4355,100,[]},{70101009,5148,4741,100,[]},{70101009,5230,4491,100,[]},{70101009,5029,4921,100,[]},{70101009,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70010,7700,1,1,'[]','[{70101010,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70011,7700,1,1,'[]','[{70201001,4896,4826,100,[]},{70201001,5079,4355,100,[]},{70201001,5148,4741,100,[]},{70201001,5230,4491,100,[]},{70201001,5029,4921,100,[]},{70201001,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70012,7700,1,1,'[]','[{70201002,4896,4826,100,[]},{70201002,5079,4355,100,[]},{70201002,5148,4741,100,[]},{70201002,5230,4491,100,[]},{70201002,5029,4921,100,[]},{70201002,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70013,7700,1,1,'[]','[{70201003,4896,4826,100,[]},{70201003,5079,4355,100,[]},{70201003,5148,4741,100,[]},{70201003,5230,4491,100,[]},{70201003,5029,4921,100,[]},{70201003,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70014,7700,1,1,'[]','[{70201004,4896,4826,100,[]},{70201004,5079,4355,100,[]},{70201004,5148,4741,100,[]},{70201004,5230,4491,100,[]},{70201004,5029,4921,100,[]},{70201004,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70015,7700,1,1,'[]','[{70201005,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70016,7700,1,1,'[]','[{70201006,4896,4826,100,[]},{70201006,5079,4355,100,[]},{70201006,5148,4741,100,[]},{70201006,5230,4491,100,[]},{70201006,5029,4921,100,[]},{70201006,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70017,7700,1,1,'[]','[{70201007,4896,4826,100,[]},{70201007,5079,4355,100,[]},{70201007,5148,4741,100,[]},{70201007,5230,4491,100,[]},{70201007,5029,4921,100,[]},{70201007,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70018,7700,1,1,'[]','[{70201008,4896,4826,100,[]},{70201008,5079,4355,100,[]},{70201008,5148,4741,100,[]},{70201008,5230,4491,100,[]},{70201008,5029,4921,100,[]},{70201008,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70019,7700,1,1,'[]','[{70201009,4896,4826,100,[]},{70201009,5079,4355,100,[]},{70201009,5148,4741,100,[]},{70201009,5230,4491,100,[]},{70201009,5029,4921,100,[]},{70201009,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70020,7700,1,1,'[]','[{70201010,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70021,7700,1,1,'[]','[{70301001,4896,4826,100,[]},{70301001,5079,4355,100,[]},{70301001,5148,4741,100,[]},{70301001,5230,4491,100,[]},{70301001,5029,4921,100,[]},{70301001,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70022,7700,1,1,'[]','[{70301002,4896,4826,100,[]},{70301002,5079,4355,100,[]},{70301002,5148,4741,100,[]},{70301002,5230,4491,100,[]},{70301002,5029,4921,100,[]},{70301002,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70023,7700,1,1,'[]','[{70301003,4896,4826,100,[]},{70301003,5079,4355,100,[]},{70301003,5148,4741,100,[]},{70301003,5230,4491,100,[]},{70301003,5029,4921,100,[]},{70301003,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70024,7700,1,1,'[]','[{70301004,4896,4826,100,[]},{70301004,5079,4355,100,[]},{70301004,5148,4741,100,[]},{70301004,5230,4491,100,[]},{70301004,5029,4921,100,[]},{70301004,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70025,7700,1,1,'[]','[{70301005,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70026,7700,1,1,'[]','[{70301006,4896,4826,100,[]},{70301006,5079,4355,100,[]},{70301006,5148,4741,100,[]},{70301006,5230,4491,100,[]},{70301006,5029,4921,100,[]},{70301006,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70027,7700,1,1,'[]','[{70301007,4896,4826,100,[]},{70301007,5079,4355,100,[]},{70301007,5148,4741,100,[]},{70301007,5230,4491,100,[]},{70301007,5029,4921,100,[]},{70301007,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70028,7700,1,1,'[]','[{70301008,4896,4826,100,[]},{70301008,5079,4355,100,[]},{70301008,5148,4741,100,[]},{70301008,5230,4491,100,[]},{70301008,5029,4921,100,[]},{70301008,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70029,7700,1,1,'[]','[{70301009,4896,4826,100,[]},{70301009,5079,4355,100,[]},{70301009,5148,4741,100,[]},{70301009,5230,4491,100,[]},{70301009,5029,4921,100,[]},{70301009,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70030,7700,1,1,'[]','[{70301010,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70031,7700,1,1,'[]','[{70401001,4896,4826,100,[]},{70401001,5079,4355,100,[]},{70401001,5148,4741,100,[]},{70401001,5230,4491,100,[]},{70401001,5029,4921,100,[]},{70401001,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70032,7700,1,1,'[]','[{70401002,4896,4826,100,[]},{70401002,5079,4355,100,[]},{70401002,5148,4741,100,[]},{70401002,5230,4491,100,[]},{70401002,5029,4921,100,[]},{70401002,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70033,7700,1,1,'[]','[{70401003,4896,4826,100,[]},{70401003,5079,4355,100,[]},{70401003,5148,4741,100,[]},{70401003,5230,4491,100,[]},{70401003,5029,4921,100,[]},{70401003,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70034,7700,1,1,'[]','[{70401004,4896,4826,100,[]},{70401004,5079,4355,100,[]},{70401004,5148,4741,100,[]},{70401004,5230,4491,100,[]},{70401004,5029,4921,100,[]},{70401004,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70035,7700,1,1,'[]','[{70401005,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70036,7700,1,1,'[]','[{70401006,4896,4826,100,[]},{70401006,5079,4355,100,[]},{70401006,5148,4741,100,[]},{70401006,5230,4491,100,[]},{70401006,5029,4921,100,[]},{70401006,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70037,7700,1,1,'[]','[{70401007,4896,4826,100,[]},{70401007,5079,4355,100,[]},{70401007,5148,4741,100,[]},{70401007,5230,4491,100,[]},{70401007,5029,4921,100,[]},{70401007,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70038,7700,1,1,'[]','[{70401008,4896,4826,100,[]},{70401008,5079,4355,100,[]},{70401008,5148,4741,100,[]},{70401008,5230,4491,100,[]},{70401008,5029,4921,100,[]},{70401008,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70039,7700,1,1,'[]','[{70401009,4896,4826,100,[]},{70401009,5079,4355,100,[]},{70401009,5148,4741,100,[]},{70401009,5230,4491,100,[]},{70401009,5029,4921,100,[]},{70401009,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70040,7700,1,1,'[]','[{70401010,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70041,7700,1,1,'[]','[{70501001,4896,4826,100,[]},{70501001,5079,4355,100,[]},{70501001,5148,4741,100,[]},{70501001,5230,4491,100,[]},{70501001,5029,4921,100,[]},{70501001,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70042,7700,1,1,'[]','[{70501002,4896,4826,100,[]},{70501002,5079,4355,100,[]},{70501002,5148,4741,100,[]},{70501002,5230,4491,100,[]},{70501002,5029,4921,100,[]},{70501002,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70043,7700,1,1,'[]','[{70501003,4896,4826,100,[]},{70501003,5079,4355,100,[]},{70501003,5148,4741,100,[]},{70501003,5230,4491,100,[]},{70501003,5029,4921,100,[]},{70501003,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70044,7700,1,1,'[]','[{70501004,4896,4826,100,[]},{70501004,5079,4355,100,[]},{70501004,5148,4741,100,[]},{70501004,5230,4491,100,[]},{70501004,5029,4921,100,[]},{70501004,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70045,7700,1,1,'[]','[{70501005,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70046,7700,1,1,'[]','[{70501006,4896,4826,100,[]},{70501006,5079,4355,100,[]},{70501006,5148,4741,100,[]},{70501006,5230,4491,100,[]},{70501006,5029,4921,100,[]},{70501006,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70047,7700,1,1,'[]','[{70501007,4896,4826,100,[]},{70501007,5079,4355,100,[]},{70501007,5148,4741,100,[]},{70501007,5230,4491,100,[]},{70501007,5029,4921,100,[]},{70501007,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70048,7700,1,1,'[]','[{70501008,4896,4826,100,[]},{70501008,5079,4355,100,[]},{70501008,5148,4741,100,[]},{70501008,5230,4491,100,[]},{70501008,5029,4921,100,[]},{70501008,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70049,7700,1,1,'[]','[{70501009,4896,4826,100,[]},{70501009,5079,4355,100,[]},{70501009,5148,4741,100,[]},{70501009,5230,4491,100,[]},{70501009,5029,4921,100,[]},{70501009,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70050,7700,1,1,'[]','[{70501010,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70051,7700,1,1,'[]','[{70601001,4896,4826,100,[]},{70601001,5079,4355,100,[]},{70601001,5148,4741,100,[]},{70601001,5230,4491,100,[]},{70601001,5029,4921,100,[]},{70601001,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70052,7700,1,1,'[]','[{70601002,4896,4826,100,[]},{70601002,5079,4355,100,[]},{70601002,5148,4741,100,[]},{70601002,5230,4491,100,[]},{70601002,5029,4921,100,[]},{70601002,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70053,7700,1,1,'[]','[{70601003,4896,4826,100,[]},{70601003,5079,4355,100,[]},{70601003,5148,4741,100,[]},{70601003,5230,4491,100,[]},{70601003,5029,4921,100,[]},{70601003,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70054,7700,1,1,'[]','[{70601004,4896,4826,100,[]},{70601004,5079,4355,100,[]},{70601004,5148,4741,100,[]},{70601004,5230,4491,100,[]},{70601004,5029,4921,100,[]},{70601004,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70055,7700,1,1,'[]','[{70601005,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70056,7700,1,1,'[]','[{70601006,4896,4826,100,[]},{70601006,5079,4355,100,[]},{70601006,5148,4741,100,[]},{70601006,5230,4491,100,[]},{70601006,5029,4921,100,[]},{70601006,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70057,7700,1,1,'[]','[{70601007,4896,4826,100,[]},{70601007,5079,4355,100,[]},{70601007,5148,4741,100,[]},{70601007,5230,4491,100,[]},{70601007,5029,4921,100,[]},{70601007,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70058,7700,1,1,'[]','[{70601008,4896,4826,100,[]},{70601008,5079,4355,100,[]},{70601008,5148,4741,100,[]},{70601008,5230,4491,100,[]},{70601008,5029,4921,100,[]},{70601008,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70059,7700,1,1,'[]','[{70601009,4896,4826,100,[]},{70601009,5079,4355,100,[]},{70601009,5148,4741,100,[]},{70601009,5230,4491,100,[]},{70601009,5029,4921,100,[]},{70601009,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70060,7700,1,1,'[]','[{70601010,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70061,7700,1,1,'[]','[{70701001,4896,4826,100,[]},{70701001,5079,4355,100,[]},{70701001,5148,4741,100,[]},{70701001,5230,4491,100,[]},{70701001,5029,4921,100,[]},{70701001,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70062,7700,1,1,'[]','[{70701002,4896,4826,100,[]},{70701002,5079,4355,100,[]},{70701002,5148,4741,100,[]},{70701002,5230,4491,100,[]},{70701002,5029,4921,100,[]},{70701002,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70063,7700,1,1,'[]','[{70701003,4896,4826,100,[]},{70701003,5079,4355,100,[]},{70701003,5148,4741,100,[]},{70701003,5230,4491,100,[]},{70701003,5029,4921,100,[]},{70701003,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70064,7700,1,1,'[]','[{70701004,4896,4826,100,[]},{70701004,5079,4355,100,[]},{70701004,5148,4741,100,[]},{70701004,5230,4491,100,[]},{70701004,5029,4921,100,[]},{70701004,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70065,7700,1,1,'[]','[{70701005,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70066,7700,1,1,'[]','[{70701006,4896,4826,100,[]},{70701006,5079,4355,100,[]},{70701006,5148,4741,100,[]},{70701006,5230,4491,100,[]},{70701006,5029,4921,100,[]},{70701006,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70067,7700,1,1,'[]','[{70701007,4896,4826,100,[]},{70701007,5079,4355,100,[]},{70701007,5148,4741,100,[]},{70701007,5230,4491,100,[]},{70701007,5029,4921,100,[]},{70701007,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70068,7700,1,1,'[]','[{70701008,4896,4826,100,[]},{70701008,5079,4355,100,[]},{70701008,5148,4741,100,[]},{70701008,5230,4491,100,[]},{70701008,5029,4921,100,[]},{70701008,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70069,7700,1,1,'[]','[{70701009,4896,4826,100,[]},{70701009,5079,4355,100,[]},{70701009,5148,4741,100,[]},{70701009,5230,4491,100,[]},{70701009,5029,4921,100,[]},{70701009,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70070,7700,1,1,'[]','[{70701010,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70071,7700,1,1,'[]','[{70801001,4896,4826,100,[]},{70801001,5079,4355,100,[]},{70801001,5148,4741,100,[]},{70801001,5230,4491,100,[]},{70801001,5029,4921,100,[]},{70801001,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70072,7700,1,1,'[]','[{70801002,4896,4826,100,[]},{70801002,5079,4355,100,[]},{70801002,5148,4741,100,[]},{70801002,5230,4491,100,[]},{70801002,5029,4921,100,[]},{70801002,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70073,7700,1,1,'[]','[{70801003,4896,4826,100,[]},{70801003,5079,4355,100,[]},{70801003,5148,4741,100,[]},{70801003,5230,4491,100,[]},{70801003,5029,4921,100,[]},{70801003,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70074,7700,1,1,'[]','[{70801004,4896,4826,100,[]},{70801004,5079,4355,100,[]},{70801004,5148,4741,100,[]},{70801004,5230,4491,100,[]},{70801004,5029,4921,100,[]},{70801004,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70075,7700,1,1,'[]','[{70801005,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70076,7700,1,1,'[]','[{70801006,4896,4826,100,[]},{70801006,5079,4355,100,[]},{70801006,5148,4741,100,[]},{70801006,5230,4491,100,[]},{70801006,5029,4921,100,[]},{70801006,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70077,7700,1,1,'[]','[{70801007,4896,4826,100,[]},{70801007,5079,4355,100,[]},{70801007,5148,4741,100,[]},{70801007,5230,4491,100,[]},{70801007,5029,4921,100,[]},{70801007,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70078,7700,1,1,'[]','[{70801008,4896,4826,100,[]},{70801008,5079,4355,100,[]},{70801008,5148,4741,100,[]},{70801008,5230,4491,100,[]},{70801008,5029,4921,100,[]},{70801008,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70079,7700,1,1,'[]','[{70801009,4896,4826,100,[]},{70801009,5079,4355,100,[]},{70801009,5148,4741,100,[]},{70801009,5230,4491,100,[]},{70801009,5029,4921,100,[]},{70801009,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70080,7700,1,1,'[]','[{70801010,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70081,7700,1,1,'[]','[{70901001,4896,4826,100,[]},{70901001,5079,4355,100,[]},{70901001,5148,4741,100,[]},{70901001,5230,4491,100,[]},{70901001,5029,4921,100,[]},{70901001,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70082,7700,1,1,'[]','[{70901002,4896,4826,100,[]},{70901002,5079,4355,100,[]},{70901002,5148,4741,100,[]},{70901002,5230,4491,100,[]},{70901002,5029,4921,100,[]},{70901002,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70083,7700,1,1,'[]','[{70901003,4896,4826,100,[]},{70901003,5079,4355,100,[]},{70901003,5148,4741,100,[]},{70901003,5230,4491,100,[]},{70901003,5029,4921,100,[]},{70901003,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70084,7700,1,1,'[]','[{70901004,4896,4826,100,[]},{70901004,5079,4355,100,[]},{70901004,5148,4741,100,[]},{70901004,5230,4491,100,[]},{70901004,5029,4921,100,[]},{70901004,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70085,7700,1,1,'[]','[{70901005,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70086,7700,1,1,'[]','[{70901006,4896,4826,100,[]},{70901006,5079,4355,100,[]},{70901006,5148,4741,100,[]},{70901006,5230,4491,100,[]},{70901006,5029,4921,100,[]},{70901006,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70087,7700,1,1,'[]','[{70901007,4896,4826,100,[]},{70901007,5079,4355,100,[]},{70901007,5148,4741,100,[]},{70901007,5230,4491,100,[]},{70901007,5029,4921,100,[]},{70901007,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70088,7700,1,1,'[]','[{70901008,4896,4826,100,[]},{70901008,5079,4355,100,[]},{70901008,5148,4741,100,[]},{70901008,5230,4491,100,[]},{70901008,5029,4921,100,[]},{70901008,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70089,7700,1,1,'[]','[{70901009,4896,4826,100,[]},{70901009,5079,4355,100,[]},{70901009,5148,4741,100,[]},{70901009,5230,4491,100,[]},{70901009,5029,4921,100,[]},{70901009,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70090,7700,1,1,'[]','[{70901010,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70091,7700,1,1,'[]','[{71001001,4896,4826,100,[]},{71001001,5079,4355,100,[]},{71001001,5148,4741,100,[]},{71001001,5230,4491,100,[]},{71001001,5029,4921,100,[]},{71001001,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70092,7700,1,1,'[]','[{71001002,4896,4826,100,[]},{71001002,5079,4355,100,[]},{71001002,5148,4741,100,[]},{71001002,5230,4491,100,[]},{71001002,5029,4921,100,[]},{71001002,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70093,7700,1,1,'[]','[{71001003,4896,4826,100,[]},{71001003,5079,4355,100,[]},{71001003,5148,4741,100,[]},{71001003,5230,4491,100,[]},{71001003,5029,4921,100,[]},{71001003,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70094,7700,1,1,'[]','[{71001004,4896,4826,100,[]},{71001004,5079,4355,100,[]},{71001004,5148,4741,100,[]},{71001004,5230,4491,100,[]},{71001004,5029,4921,100,[]},{71001004,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70095,7700,1,1,'[]','[{71001005,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70096,7700,1,1,'[]','[{71001006,4896,4826,100,[]},{71001006,5079,4355,100,[]},{71001006,5148,4741,100,[]},{71001006,5230,4491,100,[]},{71001006,5029,4921,100,[]},{71001006,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70097,7700,1,1,'[]','[{71001007,4896,4826,100,[]},{71001007,5079,4355,100,[]},{71001007,5148,4741,100,[]},{71001007,5230,4491,100,[]},{71001007,5029,4921,100,[]},{71001007,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70098,7700,1,1,'[]','[{71001008,4896,4826,100,[]},{71001008,5079,4355,100,[]},{71001008,5148,4741,100,[]},{71001008,5230,4491,100,[]},{71001008,5029,4921,100,[]},{71001008,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70099,7700,1,1,'[]','[{71001009,4896,4826,100,[]},{71001009,5079,4355,100,[]},{71001009,5148,4741,100,[]},{71001009,5230,4491,100,[]},{71001009,5029,4921,100,[]},{71001009,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70100,7700,1,1,'[]','[{71001010,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70101,7700,1,1,'[]','[{71101001,4896,4826,100,[]},{71101001,5079,4355,100,[]},{71101001,5148,4741,100,[]},{71101001,5230,4491,100,[]},{71101001,5029,4921,100,[]},{71101001,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70102,7700,1,1,'[]','[{71101002,4896,4826,100,[]},{71101002,5079,4355,100,[]},{71101002,5148,4741,100,[]},{71101002,5230,4491,100,[]},{71101002,5029,4921,100,[]},{71101002,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70103,7700,1,1,'[]','[{71101003,4896,4826,100,[]},{71101003,5079,4355,100,[]},{71101003,5148,4741,100,[]},{71101003,5230,4491,100,[]},{71101003,5029,4921,100,[]},{71101003,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70104,7700,1,1,'[]','[{71101004,4896,4826,100,[]},{71101004,5079,4355,100,[]},{71101004,5148,4741,100,[]},{71101004,5230,4491,100,[]},{71101004,5029,4921,100,[]},{71101004,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70105,7700,1,1,'[]','[{71101005,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70106,7700,1,1,'[]','[{71101006,4896,4826,100,[]},{71101006,5079,4355,100,[]},{71101006,5148,4741,100,[]},{71101006,5230,4491,100,[]},{71101006,5029,4921,100,[]},{71101006,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70107,7700,1,1,'[]','[{71101007,4896,4826,100,[]},{71101007,5079,4355,100,[]},{71101007,5148,4741,100,[]},{71101007,5230,4491,100,[]},{71101007,5029,4921,100,[]},{71101007,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70108,7700,1,1,'[]','[{71101008,4896,4826,100,[]},{71101008,5079,4355,100,[]},{71101008,5148,4741,100,[]},{71101008,5230,4491,100,[]},{71101008,5029,4921,100,[]},{71101008,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70109,7700,1,1,'[]','[{71101009,4896,4826,100,[]},{71101009,5079,4355,100,[]},{71101009,5148,4741,100,[]},{71101009,5230,4491,100,[]},{71101009,5029,4921,100,[]},{71101009,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70110,7700,1,1,'[]','[{71101010,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70111,7700,1,1,'[]','[{71201001,4896,4826,100,[]},{71201001,5079,4355,100,[]},{71201001,5148,4741,100,[]},{71201001,5230,4491,100,[]},{71201001,5029,4921,100,[]},{71201001,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70112,7700,1,1,'[]','[{71201002,4896,4826,100,[]},{71201002,5079,4355,100,[]},{71201002,5148,4741,100,[]},{71201002,5230,4491,100,[]},{71201002,5029,4921,100,[]},{71201002,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70113,7700,1,1,'[]','[{71201003,4896,4826,100,[]},{71201003,5079,4355,100,[]},{71201003,5148,4741,100,[]},{71201003,5230,4491,100,[]},{71201003,5029,4921,100,[]},{71201003,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70114,7700,1,1,'[]','[{71201004,4896,4826,100,[]},{71201004,5079,4355,100,[]},{71201004,5148,4741,100,[]},{71201004,5230,4491,100,[]},{71201004,5029,4921,100,[]},{71201004,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70115,7700,1,1,'[]','[{71201005,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70116,7700,1,1,'[]','[{71201006,4896,4826,100,[]},{71201006,5079,4355,100,[]},{71201006,5148,4741,100,[]},{71201006,5230,4491,100,[]},{71201006,5029,4921,100,[]},{71201006,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70117,7700,1,1,'[]','[{71201007,4896,4826,100,[]},{71201007,5079,4355,100,[]},{71201007,5148,4741,100,[]},{71201007,5230,4491,100,[]},{71201007,5029,4921,100,[]},{71201007,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70118,7700,1,1,'[]','[{71201008,4896,4826,100,[]},{71201008,5079,4355,100,[]},{71201008,5148,4741,100,[]},{71201008,5230,4491,100,[]},{71201008,5029,4921,100,[]},{71201008,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70119,7700,1,1,'[]','[{71201009,4896,4826,100,[]},{71201009,5079,4355,100,[]},{71201009,5148,4741,100,[]},{71201009,5230,4491,100,[]},{71201009,5029,4921,100,[]},{71201009,5038,4621,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(70120,7700,1,1,'[]','[{71201010,4824,4610,100,[]}]','[]','[]',0,0,1,0,0,0,0,'',''),(134102,1341,1,1,'[]','[{1341002,2913,2886,100,[]}]','[]','[]',0,0,1,0,0,0,0,'','击败首领即可通过副本,获得丰厚的奖励噢。'),(134103,1341,1,1,'[]','[{1341003,2913,2886,100,[]}]','[]','[]',0,0,1,0,0,0,0,'','击败首领即可通过副本,获得丰厚的奖励噢。'),(134104,1341,1,1,'[]','[{1341004,2913,2886,100,[]}]','[]','[]',0,0,1,0,0,0,0,'','击败首领即可通过副本,获得丰厚的奖励噢。'),(134105,1341,1,1,'[]','[{1341005,2913,2886,100,[]}]','[]','[]',0,0,1,0,0,0,0,'','击败首领即可通过副本,获得丰厚的奖励噢。'),(134106,1341,1,1,'[]','[{1341006,2913,2886,100,[]}]','[]','[]',0,0,1,0,0,0,0,'','击败首领即可通过副本,获得丰厚的奖励噢。'),(134107,1341,1,1,'[]','[{1341007,2913,2886,100,[]}]','[]','[]',0,0,1,0,0,0,0,'','击败首领即可通过副本,获得丰厚的奖励噢。'),(134108,1341,1,1,'[]','[{1341008,2913,2886,100,[]}]','[]','[]',0,0,1,0,0,0,0,'','击败首领即可通过副本,获得丰厚的奖励噢。'),(134109,1341,1,1,'[]','[{1341009,2913,2886,100,[]}]','[]','[]',0,0,1,0,0,0,0,'','击败首领即可通过副本,获得丰厚的奖励噢。'),(134110,1341,1,1,'[]','[{1341010,2913,2886,100,[]}]','[]','[]',0,0,1,0,0,0,0,'','击败首领即可通过副本,获得丰厚的奖励噢。'),(134111,1341,1,1,'[]','[{1341011,2913,2886,100,[]}]','[]','[]',0,0,1,0,0,0,0,'','击败首领即可通过副本,获得丰厚的奖励噢。'),(134112,1341,1,1,'[]','[{1341012,2913,2886,100,[]}]','[]','[]',0,0,1,0,0,0,0,'','击败首领即可通过副本,获得丰厚的奖励噢。'),(134113,1341,1,1,'[]','[{1341013,2913,2886,100,[]}]','[]','[]',0,0,1,0,0,0,0,'','击败首领即可通过副本,获得丰厚的奖励噢。'),(134114,1341,1,1,'[]','[{1341014,2913,2886,100,[]}]','[]','[]',0,0,1,0,0,0,0,'','击败首领即可通过副本,获得丰厚的奖励噢。'),(134115,1341,1,1,'[]','[{1341015,2913,2886,100,[]}]','[]','[]',0,0,1,0,0,0,0,'','击败首领即可通过副本,获得丰厚的奖励噢。'),(134116,10010,1,1,'[]','[{1202000,12381,4466 ,100,[{group,1},{mod_args,9999}]}]','[]','[]',0,0,1,0,0,0,0,'','击败扰乱心智的梦魇恶魔，让护民官从梦魇中苏醒。'),(134116,10010,2,1,'[]','[{1201000,12951,2910,100,[{group,99}]},{1201001,13716,3363,100,[{group,99}]}]','[]','[]',6000,0,1,0,0,0,0,'',''),(134117,1341,1,1,'[]','[{1341016,2913,2886,100,[]}]','[]','[]',0,0,1,0,0,0,0,'','击败首领即可通过副本,获得丰厚的奖励噢。');
/*!40000 ALTER TABLE `base_dungeon_wave` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_dungeon_wave_ex`
--

DROP TABLE IF EXISTS `base_dungeon_wave_ex`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_dungeon_wave_ex` (
  `dun_id` int(10) unsigned NOT NULL COMMENT '副本id',
  `rand_key` int(10) unsigned NOT NULL COMMENT '随机索引',
  `wave` int(10) unsigned NOT NULL COMMENT '随机序号',
  `mon_list` text NOT NULL COMMENT '怪物列表',
  PRIMARY KEY (`dun_id`,`rand_key`,`wave`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='副本随机波数拓展';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_dungeon_wave_ex`
--

LOCK TABLES `base_dungeon_wave_ex` WRITE;
/*!40000 ALTER TABLE `base_dungeon_wave_ex` DISABLE KEYS */;
/*!40000 ALTER TABLE `base_dungeon_wave_ex` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_equip_attr`
--

DROP TABLE IF EXISTS `base_equip_attr`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_equip_attr` (
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型id',
  `stage` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '装备阶数',
  `star` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '装备星级',
  `base_rating` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '基础装备评分(预览展示用)',
  `recommend_attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '推荐属性(预览展示用) ',
  `nattr_1` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '蓝属数量',
  `vattr_1` text NOT NULL COMMENT '蓝属',
  `nattr_2` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '紫属数量',
  `vattr_2` text NOT NULL COMMENT '紫属',
  `nattr_3` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '橙属数量',
  `vattr_3` text NOT NULL COMMENT '橙属',
  `nattr_4` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '红属数量',
  `vattr_4` text NOT NULL COMMENT '红属',
  `extra_attr` varchar(128) NOT NULL DEFAULT '[]' COMMENT '额外属性',
  PRIMARY KEY (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备属性';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_equip_attr`
--

LOCK TABLES `base_equip_attr` WRITE;
/*!40000 ALTER TABLE `base_equip_attr` DISABLE KEYS */;
INSERT INTO `base_equip_attr` VALUES (1001010100,1,0,1450,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001010110,1,0,2873,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001010120,1,0,6237,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001010131,1,1,9734,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001010132,1,2,12230,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001010141,1,1,20420,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001010142,1,2,26892,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001010143,1,3,33732,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001010153,1,3,46619,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001010163,1,3,61463,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001010200,2,0,2470,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001010210,2,0,4689,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001010220,2,0,10332,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001010231,2,1,15747,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001010232,2,2,20227,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001010241,2,1,34595,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001010242,2,2,47419,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001010243,2,3,64927,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001010253,2,3,108138,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001010263,2,3,169550,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001010300,3,0,5915,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001010310,3,0,10257,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001010320,3,0,20953,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001010331,3,1,30119,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001010332,3,2,36931,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001010341,3,1,61408,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001010342,3,2,81700,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001010343,3,3,108616,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001010353,3,3,170913,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001010363,3,3,261847,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001010400,4,0,11915,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001010410,4,0,19659,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001010420,4,0,39081,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001010431,4,1,54211,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001010432,4,2,63627,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001010441,4,1,104005,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001010442,4,2,132225,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001010443,4,3,169089,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001010453,4,3,268380,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001010463,4,3,402935,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001010500,5,0,20650,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001010510,5,0,33485,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001010520,5,0,65495,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001010531,5,1,88682,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001010532,5,2,101834,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001010541,5,1,164576,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001010542,5,2,204064,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001010543,5,3,256516,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001010553,5,3,407370,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001010563,5,3,603657,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001010600,6,0,32260,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001010610,6,0,51880,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001010620,6,0,100851,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001010631,6,1,135301,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001010632,6,2,153705,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001010641,6,1,247169,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001010642,6,2,302441,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,4247},{4,3,2123}]'),(1001010643,6,3,375857,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,10164},{4,3,5081}]'),(1001010653,6,3,597074,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,13550},{4,3,6775}]'),(1001010663,6,3,878595,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,16938},{4,3,8470}]'),(1001010700,7,0,46910,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001010710,7,0,75250,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001010720,7,0,145934,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001010731,7,1,195215,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001010732,7,2,220995,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001010741,7,1,354748,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001010742,7,2,432148,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,6604},{4,3,3302}]'),(1001010743,7,3,534928,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,14378},{4,3,7189}]'),(1001010753,7,3,849893,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,19172},{4,3,9586}]'),(1001010763,7,3,1221752,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,23964},{4,3,11982}]'),(1001010800,8,0,64740,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001010810,8,0,103990,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001010820,8,0,201824,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001010831,8,1,270261,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001010832,8,2,306345,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001010841,8,1,492093,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001010842,8,2,600449,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,6963},{4,3,3482}]'),(1001010843,8,3,744329,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,14547},{4,3,7274}]'),(1001010853,8,3,1166474,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,19396},{4,3,9699}]'),(1001010863,8,3,1656886,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,24246},{4,3,12123}]'),(1001010900,9,0,85930,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001010910,9,0,138495,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001010920,9,0,269669,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001010931,9,1,362675,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001010932,9,2,413199,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001010941,9,1,665363,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001010942,9,2,817067,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,7310},{4,3,3655}]'),(1001010943,9,3,1007423,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,14564},{4,3,7283}]'),(1001010953,9,3,1561513,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,19419},{4,3,9710}]'),(1001010963,9,3,2208629,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,24274},{4,3,12137}]'),(1001011000,10,0,110630,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001011010,10,0,179409,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001011020,10,0,351143,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001011031,10,1,475536,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001011032,10,2,546280,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001011041,10,1,883151,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001011042,10,2,1086999,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,7691},{4,3,3845}]'),(1001011043,10,3,1335279,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,14727},{4,3,7364}]'),(1001011053,10,3,2056182,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,19636},{4,3,9818}]'),(1001011063,10,3,2896674,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,24545},{4,3,12273}]'),(1001011100,11,0,139035,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001011110,11,0,227360,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001011120,11,0,448259,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001011131,11,1,612882,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001011132,11,2,711926,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001011141,11,1,1150346,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001011142,11,2,1419894,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,8106},{4,3,4053}]'),(1001011143,11,3,1745454,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,15017},{4,3,7508}]'),(1001011153,11,3,2670259,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,20022},{4,3,10011}]'),(1001011163,11,3,3747041,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,25027},{4,3,12514}]'),(1001011200,12,0,171255,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001011210,12,0,283232,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001011220,12,0,563696,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001011231,12,1,780149,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001011232,12,2,913781,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001011241,12,1,1475077,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001011242,12,2,1831429,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,8529},{4,3,4265}]'),(1001011243,12,3,2256697,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,15343},{4,3,7672}]'),(1001011253,12,3,3427184,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,20457},{4,3,10229}]'),(1001011263,12,3,4791313,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,25572},{4,3,12786}]'),(1001011300,13,0,207460,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001011310,13,0,348067,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001011320,13,0,701045,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001011331,13,1,980164,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001011332,13,2,1157908,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001011341,13,1,1870638,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001011342,13,2,2339606,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,8975},{4,3,4488}]'),(1001011343,13,3,2890694,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,15754},{4,3,7877}]'),(1001011353,13,3,4355421,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,21006},{4,3,10503}]'),(1001011363,13,3,6065824,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,26257},{4,3,13129}]'),(1001011400,14,0,247825,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001011410,14,0,423383,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001011420,14,0,861756,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001011431,14,1,1218244,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001011432,14,2,1454272,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001011441,14,1,2352751,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001011442,14,2,2965343,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,9412},{4,3,4706}]'),(1001011443,14,3,3673439,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,16177},{4,3,8089}]'),(1001011453,14,3,5488029,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,21570},{4,3,10785}]'),(1001011463,14,3,7612110,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,26962},{4,3,13481}]'),(1001011500,15,0,292500,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001011510,15,0,509478,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001011520,15,0,1049597,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001011531,15,1,1502965,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001011532,15,2,1814673,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001011541,15,1,2939636,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001011542,15,2,3733440,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,9882},{4,3,4941}]'),(1001011543,15,3,4635552,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,16986},{4,3,8493}]'),(1001011553,15,3,6863244,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,22648},{4,3,11324}]'),(1001011563,15,3,9477000,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,28310},{4,3,14155}]'),(1001011600,16,0,6893640,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001011610,16,0,7064460,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001011620,16,0,7484705,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001011631,16,1,7689695,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001011632,16,2,7689695,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001011641,16,1,8260265,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001011642,16,2,8260265,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,10377},{4,3,5188}]'),(1001011643,16,3,8260265,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,17836},{4,3,8918}]'),(1001011653,16,3,9285205,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,23781},{4,3,11890}]'),(1001011663,16,3,9968510,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,29726},{4,3,14863}]'),(1001020100,1,0,1450,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001020110,1,0,2873,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001020120,1,0,6237,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001020131,1,1,9734,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001020132,1,2,12230,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001020141,1,1,20420,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001020142,1,2,26892,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001020143,1,3,33732,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001020153,1,3,46619,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001020163,1,3,61463,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001020200,2,0,2470,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001020210,2,0,4689,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001020220,2,0,10332,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001020231,2,1,15747,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001020232,2,2,20227,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001020241,2,1,34595,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001020242,2,2,47419,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001020243,2,3,64927,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001020253,2,3,108138,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001020263,2,3,169550,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001020300,3,0,5915,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001020310,3,0,10257,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001020320,3,0,20953,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001020331,3,1,30119,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001020332,3,2,36931,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001020341,3,1,61408,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001020342,3,2,81700,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001020343,3,3,108616,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001020353,3,3,170913,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001020363,3,3,261847,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001020400,4,0,11915,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001020410,4,0,19659,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001020420,4,0,39081,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001020431,4,1,54211,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001020432,4,2,63627,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001020441,4,1,104005,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001020442,4,2,132225,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001020443,4,3,169089,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001020453,4,3,268380,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001020463,4,3,402935,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001020500,5,0,20650,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001020510,5,0,33485,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001020520,5,0,65495,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001020531,5,1,88682,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001020532,5,2,101834,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001020541,5,1,164576,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001020542,5,2,204064,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001020543,5,3,256516,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001020553,5,3,407370,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001020563,5,3,603657,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001020600,6,0,32260,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001020610,6,0,51880,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001020620,6,0,100851,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001020631,6,1,135301,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001020632,6,2,153705,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001020641,6,1,247169,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001020642,6,2,302441,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,4247},{4,3,2123}]'),(1001020643,6,3,375857,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,10164},{4,3,5081}]'),(1001020653,6,3,597074,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,13550},{4,3,6775}]'),(1001020663,6,3,878595,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,16938},{4,3,8470}]'),(1001020700,7,0,46910,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001020710,7,0,75250,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001020720,7,0,145934,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001020731,7,1,195215,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001020732,7,2,220995,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001020741,7,1,354748,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001020742,7,2,432148,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,6604},{4,3,3302}]'),(1001020743,7,3,534928,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,14378},{4,3,7189}]'),(1001020753,7,3,849893,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,19172},{4,3,9586}]'),(1001020763,7,3,1221752,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,23964},{4,3,11982}]'),(1001020800,8,0,64740,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001020810,8,0,103990,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001020820,8,0,201824,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001020831,8,1,270261,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001020832,8,2,306345,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001020841,8,1,492093,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001020842,8,2,600449,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,6963},{4,3,3482}]'),(1001020843,8,3,744329,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,14547},{4,3,7274}]'),(1001020853,8,3,1166474,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,19396},{4,3,9699}]'),(1001020863,8,3,1656886,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,24246},{4,3,12123}]'),(1001020900,9,0,85930,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001020910,9,0,138495,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001020920,9,0,269669,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001020931,9,1,362675,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001020932,9,2,413199,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001020941,9,1,665363,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001020942,9,2,817067,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,7310},{4,3,3655}]'),(1001020943,9,3,1007423,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,14564},{4,3,7283}]'),(1001020953,9,3,1561513,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,19419},{4,3,9710}]'),(1001020963,9,3,2208629,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,24274},{4,3,12137}]'),(1001021000,10,0,110630,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001021010,10,0,179409,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001021020,10,0,351143,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001021031,10,1,475536,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001021032,10,2,546280,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001021041,10,1,883151,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001021042,10,2,1086999,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,7691},{4,3,3845}]'),(1001021043,10,3,1335279,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,14727},{4,3,7364}]'),(1001021053,10,3,2056182,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,19636},{4,3,9818}]'),(1001021063,10,3,2896674,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,24545},{4,3,12273}]'),(1001021100,11,0,139035,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001021110,11,0,227360,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001021120,11,0,448259,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001021131,11,1,612882,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001021132,11,2,711926,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001021141,11,1,1150346,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001021142,11,2,1419894,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,8106},{4,3,4053}]'),(1001021143,11,3,1745454,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,15017},{4,3,7508}]'),(1001021153,11,3,2670259,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,20022},{4,3,10011}]'),(1001021163,11,3,3747041,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,25027},{4,3,12514}]'),(1001021200,12,0,171255,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001021210,12,0,283232,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001021220,12,0,563696,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001021231,12,1,780149,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001021232,12,2,913781,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001021241,12,1,1475077,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001021242,12,2,1831429,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,8529},{4,3,4265}]'),(1001021243,12,3,2256697,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,15343},{4,3,7672}]'),(1001021253,12,3,3427184,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,20457},{4,3,10229}]'),(1001021263,12,3,4791313,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,25572},{4,3,12786}]'),(1001021300,13,0,207460,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001021310,13,0,348067,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001021320,13,0,701045,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001021331,13,1,980164,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001021332,13,2,1157908,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001021341,13,1,1870638,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001021342,13,2,2339606,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,8975},{4,3,4488}]'),(1001021343,13,3,2890694,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,15754},{4,3,7877}]'),(1001021353,13,3,4355421,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,21006},{4,3,10503}]'),(1001021363,13,3,6065824,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,26257},{4,3,13129}]'),(1001021400,14,0,247825,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001021410,14,0,423383,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001021420,14,0,861756,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001021431,14,1,1218244,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001021432,14,2,1454272,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001021441,14,1,2352751,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001021442,14,2,2965343,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,9412},{4,3,4706}]'),(1001021443,14,3,3673439,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,16177},{4,3,8089}]'),(1001021453,14,3,5488029,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,21570},{4,3,10785}]'),(1001021463,14,3,7612110,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,26962},{4,3,13481}]'),(1001021500,15,0,292500,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001021510,15,0,509478,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001021520,15,0,1049597,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001021531,15,1,1502965,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001021532,15,2,1814673,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001021541,15,1,2939636,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001021542,15,2,3733440,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,9882},{4,3,4941}]'),(1001021543,15,3,4635552,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,16986},{4,3,8493}]'),(1001021553,15,3,6863244,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,22648},{4,3,11324}]'),(1001021563,15,3,9477000,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,28310},{4,3,14155}]'),(1001021600,16,0,6893640,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001021610,16,0,7064460,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001021620,16,0,7484705,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001021631,16,1,7689695,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001021632,16,2,7689695,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001021641,16,1,8260265,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001021642,16,2,8260265,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,10377},{4,3,5188}]'),(1001021643,16,3,8260265,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,17836},{4,3,8918}]'),(1001021653,16,3,9285205,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,23781},{4,3,11890}]'),(1001021663,16,3,9968510,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,29726},{4,3,14863}]'),(1001030100,1,0,1450,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001030110,1,0,2873,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001030120,1,0,6237,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001030131,1,1,9734,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001030132,1,2,12230,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001030141,1,1,20420,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001030142,1,2,26892,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001030143,1,3,33732,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001030153,1,3,46619,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001030163,1,3,61463,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001030200,2,0,2470,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001030210,2,0,4689,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001030220,2,0,10332,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001030231,2,1,15747,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001030232,2,2,20227,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001030241,2,1,34595,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001030242,2,2,47419,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001030243,2,3,64927,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001030253,2,3,108138,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001030263,2,3,169550,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001030300,3,0,5915,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001030310,3,0,10257,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001030320,3,0,20953,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001030331,3,1,30119,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001030332,3,2,36931,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001030341,3,1,61408,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001030342,3,2,81700,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001030343,3,3,108616,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001030353,3,3,170913,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001030363,3,3,261847,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001030400,4,0,11915,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001030410,4,0,19659,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001030420,4,0,39081,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001030431,4,1,54211,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001030432,4,2,63627,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001030441,4,1,104005,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001030442,4,2,132225,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001030443,4,3,169089,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001030453,4,3,268380,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001030463,4,3,402935,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001030500,5,0,20650,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001030510,5,0,33485,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001030520,5,0,65495,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001030531,5,1,88682,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001030532,5,2,101834,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001030541,5,1,164576,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001030542,5,2,204064,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001030543,5,3,256516,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001030553,5,3,407370,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001030563,5,3,603657,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001030600,6,0,32260,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001030610,6,0,51880,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001030620,6,0,100851,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001030631,6,1,135301,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001030632,6,2,153705,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001030641,6,1,247169,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001030642,6,2,302441,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,4247},{4,3,2123}]'),(1001030643,6,3,375857,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,10164},{4,3,5081}]'),(1001030653,6,3,597074,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,13550},{4,3,6775}]'),(1001030663,6,3,878595,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,16938},{4,3,8470}]'),(1001030700,7,0,46910,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001030710,7,0,75250,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001030720,7,0,145934,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001030731,7,1,195215,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001030732,7,2,220995,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001030741,7,1,354748,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001030742,7,2,432148,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,6604},{4,3,3302}]'),(1001030743,7,3,534928,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,14378},{4,3,7189}]'),(1001030753,7,3,849893,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,19172},{4,3,9586}]'),(1001030763,7,3,1221752,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,23964},{4,3,11982}]'),(1001030800,8,0,64740,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001030810,8,0,103990,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001030820,8,0,201824,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001030831,8,1,270261,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001030832,8,2,306345,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001030841,8,1,492093,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001030842,8,2,600449,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,6963},{4,3,3482}]'),(1001030843,8,3,744329,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,14547},{4,3,7274}]'),(1001030853,8,3,1166474,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,19396},{4,3,9699}]'),(1001030863,8,3,1656886,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,24246},{4,3,12123}]'),(1001030900,9,0,85930,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001030910,9,0,138495,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001030920,9,0,269669,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001030931,9,1,362675,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001030932,9,2,413199,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001030941,9,1,665363,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001030942,9,2,817067,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,7310},{4,3,3655}]'),(1001030943,9,3,1007423,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,14564},{4,3,7283}]'),(1001030953,9,3,1561513,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,19419},{4,3,9710}]'),(1001030963,9,3,2208629,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,24274},{4,3,12137}]'),(1001031000,10,0,110630,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001031010,10,0,179409,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001031020,10,0,351143,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001031031,10,1,475536,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001031032,10,2,546280,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001031041,10,1,883151,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001031042,10,2,1086999,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,7691},{4,3,3845}]'),(1001031043,10,3,1335279,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,14727},{4,3,7364}]'),(1001031053,10,3,2056182,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,19636},{4,3,9818}]'),(1001031063,10,3,2896674,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,24545},{4,3,12273}]'),(1001031100,11,0,139035,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001031110,11,0,227360,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001031120,11,0,448259,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001031131,11,1,612882,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001031132,11,2,711926,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001031141,11,1,1150346,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001031142,11,2,1419894,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,8106},{4,3,4053}]'),(1001031143,11,3,1745454,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,15017},{4,3,7508}]'),(1001031153,11,3,2670259,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,20022},{4,3,10011}]'),(1001031163,11,3,3747041,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,25027},{4,3,12514}]'),(1001031200,12,0,171255,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001031210,12,0,283232,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001031220,12,0,563696,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001031231,12,1,780149,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001031232,12,2,913781,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001031241,12,1,1475077,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001031242,12,2,1831429,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,8529},{4,3,4265}]'),(1001031243,12,3,2256697,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,15343},{4,3,7672}]'),(1001031253,12,3,3427184,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,20457},{4,3,10229}]'),(1001031263,12,3,4791313,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,25572},{4,3,12786}]'),(1001031300,13,0,207460,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001031310,13,0,348067,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001031320,13,0,701045,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001031331,13,1,980164,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001031332,13,2,1157908,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001031341,13,1,1870638,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001031342,13,2,2339606,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,8975},{4,3,4488}]'),(1001031343,13,3,2890694,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,15754},{4,3,7877}]'),(1001031353,13,3,4355421,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,21006},{4,3,10503}]'),(1001031363,13,3,6065824,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,26257},{4,3,13129}]'),(1001031400,14,0,247825,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001031410,14,0,423383,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001031420,14,0,861756,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001031431,14,1,1218244,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001031432,14,2,1454272,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001031441,14,1,2352751,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001031442,14,2,2965343,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,9412},{4,3,4706}]'),(1001031443,14,3,3673439,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,16177},{4,3,8089}]'),(1001031453,14,3,5488029,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,21570},{4,3,10785}]'),(1001031463,14,3,7612110,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,26962},{4,3,13481}]'),(1001031500,15,0,292500,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001031510,15,0,509478,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001031520,15,0,1049597,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001031531,15,1,1502965,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001031532,15,2,1814673,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001031541,15,1,2939636,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001031542,15,2,3733440,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,9882},{4,3,4941}]'),(1001031543,15,3,4635552,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,16986},{4,3,8493}]'),(1001031553,15,3,6863244,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,22648},{4,3,11324}]'),(1001031563,15,3,9477000,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,28310},{4,3,14155}]'),(1001031600,16,0,6893640,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001031610,16,0,7064460,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001031620,16,0,7484705,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001031631,16,1,7689695,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001031632,16,2,7689695,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001031641,16,1,8260265,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001031642,16,2,8260265,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,10377},{4,3,5188}]'),(1001031643,16,3,8260265,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,17836},{4,3,8918}]'),(1001031653,16,3,9285205,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,23781},{4,3,11890}]'),(1001031663,16,3,9968510,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,29726},{4,3,14863}]'),(1001040100,1,0,1450,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001040110,1,0,2873,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001040120,1,0,6237,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001040131,1,1,9734,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001040132,1,2,12230,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001040141,1,1,20420,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001040142,1,2,26892,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001040143,1,3,33732,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001040153,1,3,46619,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001040163,1,3,61463,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001040200,2,0,2470,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001040210,2,0,4689,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001040220,2,0,10332,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001040231,2,1,15747,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001040232,2,2,20227,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001040241,2,1,34595,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001040242,2,2,47419,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001040243,2,3,64927,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001040253,2,3,108138,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001040263,2,3,169550,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001040300,3,0,5915,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001040310,3,0,10257,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001040320,3,0,20953,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001040331,3,1,30119,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001040332,3,2,36931,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001040341,3,1,61408,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001040342,3,2,81700,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001040343,3,3,108616,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001040353,3,3,170913,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001040363,3,3,261847,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001040400,4,0,11915,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001040410,4,0,19659,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001040420,4,0,39081,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001040431,4,1,54211,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001040432,4,2,63627,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001040441,4,1,104005,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001040442,4,2,132225,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001040443,4,3,169089,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001040453,4,3,268380,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001040463,4,3,402935,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001040500,5,0,20650,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001040510,5,0,33485,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001040520,5,0,65495,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001040531,5,1,88682,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001040532,5,2,101834,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001040541,5,1,164576,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001040542,5,2,204064,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001040543,5,3,256516,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001040553,5,3,407370,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001040563,5,3,603657,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001040600,6,0,32260,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001040610,6,0,51880,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001040620,6,0,100851,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001040631,6,1,135301,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001040632,6,2,153705,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001040641,6,1,247169,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001040642,6,2,302441,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,4247},{4,3,2123}]'),(1001040643,6,3,375857,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,10164},{4,3,5081}]'),(1001040653,6,3,597074,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,13550},{4,3,6775}]'),(1001040663,6,3,878595,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,16938},{4,3,8470}]'),(1001040700,7,0,46910,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001040710,7,0,75250,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001040720,7,0,145934,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001040731,7,1,195215,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001040732,7,2,220995,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001040741,7,1,354748,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001040742,7,2,432148,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,6604},{4,3,3302}]'),(1001040743,7,3,534928,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,14378},{4,3,7189}]'),(1001040753,7,3,849893,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,19172},{4,3,9586}]'),(1001040763,7,3,1221752,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,23964},{4,3,11982}]'),(1001040800,8,0,64740,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001040810,8,0,103990,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001040820,8,0,201824,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001040831,8,1,270261,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001040832,8,2,306345,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001040841,8,1,492093,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001040842,8,2,600449,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,6963},{4,3,3482}]'),(1001040843,8,3,744329,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,14547},{4,3,7274}]'),(1001040853,8,3,1166474,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,19396},{4,3,9699}]'),(1001040863,8,3,1656886,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,24246},{4,3,12123}]'),(1001040900,9,0,85930,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001040910,9,0,138495,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001040920,9,0,269669,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001040931,9,1,362675,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001040932,9,2,413199,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001040941,9,1,665363,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001040942,9,2,817067,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,7310},{4,3,3655}]'),(1001040943,9,3,1007423,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,14564},{4,3,7283}]'),(1001040953,9,3,1561513,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,19419},{4,3,9710}]'),(1001040963,9,3,2208629,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,24274},{4,3,12137}]'),(1001041000,10,0,110630,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001041010,10,0,179409,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001041020,10,0,351143,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001041031,10,1,475536,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001041032,10,2,546280,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001041041,10,1,883151,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001041042,10,2,1086999,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,7691},{4,3,3845}]'),(1001041043,10,3,1335279,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,14727},{4,3,7364}]'),(1001041053,10,3,2056182,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,19636},{4,3,9818}]'),(1001041063,10,3,2896674,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,24545},{4,3,12273}]'),(1001041100,11,0,139035,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001041110,11,0,227360,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001041120,11,0,448259,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001041131,11,1,612882,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001041132,11,2,711926,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001041141,11,1,1150346,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001041142,11,2,1419894,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,8106},{4,3,4053}]'),(1001041143,11,3,1745454,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,15017},{4,3,7508}]'),(1001041153,11,3,2670259,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,20022},{4,3,10011}]'),(1001041163,11,3,3747041,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,25027},{4,3,12514}]'),(1001041200,12,0,171255,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001041210,12,0,283232,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001041220,12,0,563696,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001041231,12,1,780149,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001041232,12,2,913781,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001041241,12,1,1475077,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001041242,12,2,1831429,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,8529},{4,3,4265}]'),(1001041243,12,3,2256697,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,15343},{4,3,7672}]'),(1001041253,12,3,3427184,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,20457},{4,3,10229}]'),(1001041263,12,3,4791313,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,25572},{4,3,12786}]'),(1001041300,13,0,207460,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001041310,13,0,348067,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001041320,13,0,701045,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001041331,13,1,980164,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001041332,13,2,1157908,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001041341,13,1,1870638,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001041342,13,2,2339606,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,8975},{4,3,4488}]'),(1001041343,13,3,2890694,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,15754},{4,3,7877}]'),(1001041353,13,3,4355421,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,21006},{4,3,10503}]'),(1001041363,13,3,6065824,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,26257},{4,3,13129}]'),(1001041400,14,0,247825,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001041410,14,0,423383,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001041420,14,0,861756,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001041431,14,1,1218244,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001041432,14,2,1454272,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001041441,14,1,2352751,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001041442,14,2,2965343,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,9412},{4,3,4706}]'),(1001041443,14,3,3673439,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,16177},{4,3,8089}]'),(1001041453,14,3,5488029,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,21570},{4,3,10785}]'),(1001041463,14,3,7612110,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,26962},{4,3,13481}]'),(1001041500,15,0,292500,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001041510,15,0,509478,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001041520,15,0,1049597,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001041531,15,1,1502965,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001041532,15,2,1814673,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001041541,15,1,2939636,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001041542,15,2,3733440,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,9882},{4,3,4941}]'),(1001041543,15,3,4635552,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,16986},{4,3,8493}]'),(1001041553,15,3,6863244,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,22648},{4,3,11324}]'),(1001041563,15,3,9477000,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,28310},{4,3,14155}]'),(1001041600,16,0,6893640,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001041610,16,0,7064460,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1001041620,16,0,7484705,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1001041631,16,1,7689695,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001041632,16,2,7689695,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1001041641,16,1,8260265,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1001041642,16,2,8260265,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,10377},{4,3,5188}]'),(1001041643,16,3,8260265,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,17836},{4,3,8918}]'),(1001041653,16,3,9285205,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,23781},{4,3,11890}]'),(1001041663,16,3,9968510,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,29726},{4,3,14863}]'),(1002010100,1,0,787,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002010110,1,0,1889,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002010120,1,0,4427,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002010131,1,1,7551,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002010132,1,2,10047,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002010141,1,1,17120,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002010142,1,2,23592,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002010143,1,3,30432,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002010153,1,3,41325,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002010163,1,3,54888,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002010200,2,0,1359,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002010210,2,0,2990,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002010220,2,0,7254,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002010231,2,1,11974,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002010232,2,2,16454,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002010241,2,1,28950,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002010242,2,2,41774,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002010243,2,3,59282,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002010253,2,3,99094,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002010263,2,3,158259,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002010300,3,0,3238,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002010310,3,0,6229,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002010320,3,0,13595,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002010331,3,1,21174,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002010332,3,2,27986,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002010341,3,1,47953,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002010342,3,2,68245,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002010343,3,3,95161,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002010353,3,3,149382,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002010363,3,3,234938,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002010400,4,0,6503,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002010410,4,0,11538,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002010420,4,0,24269,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002010431,4,1,36150,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002010432,4,2,45566,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002010441,4,1,76894,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002010442,4,2,105114,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002010443,4,3,141978,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002010453,4,3,225027,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002010463,4,3,348733,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002010500,5,0,11257,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002010510,5,0,19397,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002010520,5,0,39868,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002010531,5,1,57419,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002010532,5,2,70571,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002010541,5,1,117644,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002010542,5,2,157132,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002010543,5,3,209584,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002010553,5,3,332262,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002010563,5,3,509792,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002010600,6,0,17603,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002010610,6,0,29891,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002010620,6,0,60810,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002010631,6,1,86457,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002010632,6,2,104861,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002010641,6,1,173847,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002010642,6,2,229119,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,46323},{4,4,1158}]'),(1002010643,6,3,302535,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,110868},{4,4,2771}]'),(1002010653,6,3,479794,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,147822},{4,4,3696}]'),(1002010663,6,3,731971,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,184780},{4,4,4620}]'),(1002010700,7,0,25594,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002010710,7,0,43266,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002010720,7,0,87741,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002010731,7,1,124224,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002010732,7,2,150004,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002010741,7,1,248150,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002010742,7,2,325550,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,72050},{4,4,1801}]'),(1002010743,7,3,428330,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,156857},{4,4,3921}]'),(1002010753,7,3,679328,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,209142},{4,4,5229}]'),(1002010763,7,3,1008555,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,261426},{4,4,6536}]'),(1002010800,8,0,35310,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002010810,8,0,59838,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002010820,8,0,121456,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002010831,8,1,172239,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002010832,8,2,208323,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002010841,8,1,344929,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002010842,8,2,453285,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,75963},{4,4,1899}]'),(1002010843,8,3,597165,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,158699},{4,4,3968}]'),(1002010853,8,3,931000,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,211598},{4,4,5290}]'),(1002010863,8,3,1362558,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,264498},{4,4,6613}]'),(1002010900,9,0,46872,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002010910,9,0,79920,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002010920,9,0,163041,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002010931,9,1,232585,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002010932,9,2,283109,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002010941,9,1,470052,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002010942,9,2,621756,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,79744},{4,4,1994}]'),(1002010943,9,3,812112,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,158887},{4,4,3972}]'),(1002010953,9,3,1249007,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,211848},{4,4,5296}]'),(1002010963,9,3,1818012,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,264811},{4,4,6621}]'),(1002011000,10,0,60339,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002011010,10,0,103978,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002011020,10,0,213853,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002011031,10,1,308070,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002011032,10,2,378814,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002011041,10,1,631682,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002011042,10,2,835530,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,83902},{4,4,2097}]'),(1002011043,10,3,1083810,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,160662},{4,4,4016}]'),(1002011053,10,3,1653846,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,214216},{4,4,5356}]'),(1002011063,10,3,2393761,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,267770},{4,4,6694}]'),(1002011100,11,0,75841,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002011110,11,0,132569,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002011120,11,0,275747,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002011131,11,1,402454,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002011132,11,2,501498,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002011141,11,1,834370,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002011142,11,2,1103918,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,88425},{4,4,2211}]'),(1002011143,11,3,1429478,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,163814},{4,4,4095}]'),(1002011153,11,3,2164696,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,218419},{4,4,5460}]'),(1002011163,11,3,3115085,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,273024},{4,4,6825}]'),(1002011200,12,0,93405,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002011210,12,0,166472,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002011220,12,0,351212,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002011231,12,1,520938,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002011232,12,2,654570,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002011241,12,1,1085877,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002011242,12,2,1442229,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,93044},{4,4,2326}]'),(1002011243,12,3,1867497,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,167378},{4,4,4184}]'),(1002011253,12,3,2804485,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,223172},{4,4,5579}]'),(1002011263,12,3,4012939,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,278965},{4,4,6974}]'),(1002011300,13,0,113160,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002011310,13,0,206620,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002011320,13,0,443629,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002011331,13,1,666154,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002011332,13,2,843898,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002011341,13,1,1399144,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002011342,13,2,1868112,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,97910},{4,4,2448}]'),(1002011343,13,3,2419200,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,171866},{4,4,4296}]'),(1002011353,13,3,3601033,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,229154},{4,4,5729}]'),(1002011363,13,3,5122861,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,286443},{4,4,7161}]'),(1002011400,14,0,135185,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002011410,14,0,254400,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002011420,14,0,554235,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002011431,14,1,843134,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002011432,14,2,1079162,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002011441,14,1,1789529,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002011442,14,2,2402121,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,102675},{4,4,2567}]'),(1002011443,14,3,3110217,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,176479},{4,4,4412}]'),(1002011453,14,3,4586867,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,235306},{4,4,5883}]'),(1002011463,14,3,6485647,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,294132},{4,4,7353}]'),(1002011500,15,0,159557,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002011510,15,0,310051,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002011520,15,0,686633,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002011531,15,1,1060235,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002011532,15,2,1371943,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002011541,15,1,2274870,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002011542,15,2,3068674,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,107809},{4,4,2695}]'),(1002011543,15,3,3970786,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,185304},{4,4,4633}]'),(1002011553,15,3,5799599,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,247073},{4,4,6177}]'),(1002011563,15,3,8147443,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,308841},{4,4,7721}]'),(1002011600,16,0,6738355,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002011610,16,0,6831520,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002011620,16,0,7060751,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002011631,16,1,7172559,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002011632,16,2,7172559,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002011641,16,1,7483775,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002011642,16,2,7483775,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,113199},{4,4,2830}]'),(1002011643,16,3,7483775,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,194569},{4,4,4864}]'),(1002011653,16,3,8042840,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,259426},{4,4,6486}]'),(1002011663,16,3,8415550,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,324282},{4,4,8107}]'),(1002020100,1,0,787,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002020110,1,0,1889,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002020120,1,0,4427,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002020131,1,1,7551,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002020132,1,2,10047,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002020141,1,1,17120,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002020142,1,2,23592,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002020143,1,3,30432,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002020153,1,3,41325,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002020163,1,3,54888,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002020200,2,0,1359,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002020210,2,0,2990,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002020220,2,0,7254,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002020231,2,1,11974,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002020232,2,2,16454,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002020241,2,1,28950,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002020242,2,2,41774,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002020243,2,3,59282,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002020253,2,3,99094,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002020263,2,3,158259,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002020300,3,0,3238,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002020310,3,0,6229,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002020320,3,0,13595,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002020331,3,1,21174,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002020332,3,2,27986,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002020341,3,1,47953,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002020342,3,2,68245,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002020343,3,3,95161,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002020353,3,3,149382,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002020363,3,3,234938,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002020400,4,0,6503,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002020410,4,0,11538,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002020420,4,0,24269,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002020431,4,1,36150,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002020432,4,2,45566,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002020441,4,1,76894,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002020442,4,2,105114,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002020443,4,3,141978,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002020453,4,3,225027,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002020463,4,3,348733,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002020500,5,0,11257,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002020510,5,0,19397,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002020520,5,0,39868,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002020531,5,1,57419,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002020532,5,2,70571,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002020541,5,1,117644,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002020542,5,2,157132,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002020543,5,3,209584,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002020553,5,3,332262,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002020563,5,3,509792,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002020600,6,0,17603,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002020610,6,0,29891,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002020620,6,0,60810,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002020631,6,1,86457,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002020632,6,2,104861,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002020641,6,1,173847,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002020642,6,2,229119,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,46323},{4,4,1158}]'),(1002020643,6,3,302535,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,110868},{4,4,2771}]'),(1002020653,6,3,479794,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,147822},{4,4,3696}]'),(1002020663,6,3,731971,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,184780},{4,4,4620}]'),(1002020700,7,0,25594,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002020710,7,0,43266,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002020720,7,0,87741,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002020731,7,1,124224,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002020732,7,2,150004,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002020741,7,1,248150,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002020742,7,2,325550,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,72050},{4,4,1801}]'),(1002020743,7,3,428330,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,156857},{4,4,3921}]'),(1002020753,7,3,679328,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,209142},{4,4,5229}]'),(1002020763,7,3,1008555,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,261426},{4,4,6536}]'),(1002020800,8,0,35310,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002020810,8,0,59838,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002020820,8,0,121456,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002020831,8,1,172239,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002020832,8,2,208323,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002020841,8,1,344929,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002020842,8,2,453285,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,75963},{4,4,1899}]'),(1002020843,8,3,597165,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,158699},{4,4,3968}]'),(1002020853,8,3,931000,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,211598},{4,4,5290}]'),(1002020863,8,3,1362558,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,264498},{4,4,6613}]'),(1002020900,9,0,46872,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002020910,9,0,79920,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002020920,9,0,163041,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002020931,9,1,232585,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002020932,9,2,283109,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002020941,9,1,470052,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002020942,9,2,621756,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,79744},{4,4,1994}]'),(1002020943,9,3,812112,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,158887},{4,4,3972}]'),(1002020953,9,3,1249007,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,211848},{4,4,5296}]'),(1002020963,9,3,1818012,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,264811},{4,4,6621}]'),(1002021000,10,0,60339,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002021010,10,0,103978,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002021020,10,0,213853,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002021031,10,1,308070,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002021032,10,2,378814,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002021041,10,1,631682,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002021042,10,2,835530,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,83902},{4,4,2097}]'),(1002021043,10,3,1083810,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,160662},{4,4,4016}]'),(1002021053,10,3,1653846,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,214216},{4,4,5356}]'),(1002021063,10,3,2393761,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,267770},{4,4,6694}]'),(1002021100,11,0,75841,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002021110,11,0,132569,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002021120,11,0,275747,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002021131,11,1,402454,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002021132,11,2,501498,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002021141,11,1,834370,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002021142,11,2,1103918,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,88425},{4,4,2211}]'),(1002021143,11,3,1429478,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,163814},{4,4,4095}]'),(1002021153,11,3,2164696,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,218419},{4,4,5460}]'),(1002021163,11,3,3115085,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,273024},{4,4,6825}]'),(1002021200,12,0,93405,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002021210,12,0,166472,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002021220,12,0,351212,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002021231,12,1,520938,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002021232,12,2,654570,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002021241,12,1,1085877,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002021242,12,2,1442229,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,93044},{4,4,2326}]'),(1002021243,12,3,1867497,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,167378},{4,4,4184}]'),(1002021253,12,3,2804485,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,223172},{4,4,5579}]'),(1002021263,12,3,4012939,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,278965},{4,4,6974}]'),(1002021300,13,0,113160,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002021310,13,0,206620,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002021320,13,0,443629,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002021331,13,1,666154,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002021332,13,2,843898,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002021341,13,1,1399144,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002021342,13,2,1868112,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,97910},{4,4,2448}]'),(1002021343,13,3,2419200,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,171866},{4,4,4296}]'),(1002021353,13,3,3601033,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,229154},{4,4,5729}]'),(1002021363,13,3,5122861,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,286443},{4,4,7161}]'),(1002021400,14,0,135185,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002021410,14,0,254400,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002021420,14,0,554235,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002021431,14,1,843134,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002021432,14,2,1079162,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002021441,14,1,1789529,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002021442,14,2,2402121,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,102675},{4,4,2567}]'),(1002021443,14,3,3110217,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,176479},{4,4,4412}]'),(1002021453,14,3,4586867,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,235306},{4,4,5883}]'),(1002021463,14,3,6485647,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,294132},{4,4,7353}]'),(1002021500,15,0,159557,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002021510,15,0,310051,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002021520,15,0,686633,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002021531,15,1,1060235,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002021532,15,2,1371943,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002021541,15,1,2274870,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002021542,15,2,3068674,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,107809},{4,4,2695}]'),(1002021543,15,3,3970786,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,185304},{4,4,4633}]'),(1002021553,15,3,5799599,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,247073},{4,4,6177}]'),(1002021563,15,3,8147443,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,308841},{4,4,7721}]'),(1002021600,16,0,6738355,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002021610,16,0,6831520,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002021620,16,0,7060751,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002021631,16,1,7172559,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002021632,16,2,7172559,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002021641,16,1,7483775,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002021642,16,2,7483775,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,113199},{4,4,2830}]'),(1002021643,16,3,7483775,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,194569},{4,4,4864}]'),(1002021653,16,3,8042840,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,259426},{4,4,6486}]'),(1002021663,16,3,8415550,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,324282},{4,4,8107}]'),(1002030100,1,0,787,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002030110,1,0,1889,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002030120,1,0,4427,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002030131,1,1,7551,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002030132,1,2,10047,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002030141,1,1,17120,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002030142,1,2,23592,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002030143,1,3,30432,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002030153,1,3,41325,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002030163,1,3,54888,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002030200,2,0,1359,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002030210,2,0,2990,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002030220,2,0,7254,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002030231,2,1,11974,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002030232,2,2,16454,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002030241,2,1,28950,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002030242,2,2,41774,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002030243,2,3,59282,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002030253,2,3,99094,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002030263,2,3,158259,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002030300,3,0,3238,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002030310,3,0,6229,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002030320,3,0,13595,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002030331,3,1,21174,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002030332,3,2,27986,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002030341,3,1,47953,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002030342,3,2,68245,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002030343,3,3,95161,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002030353,3,3,149382,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002030363,3,3,234938,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002030400,4,0,6503,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002030410,4,0,11538,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002030420,4,0,24269,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002030431,4,1,36150,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002030432,4,2,45566,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002030441,4,1,76894,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002030442,4,2,105114,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002030443,4,3,141978,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002030453,4,3,225027,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002030463,4,3,348733,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002030500,5,0,11257,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002030510,5,0,19397,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002030520,5,0,39868,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002030531,5,1,57419,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002030532,5,2,70571,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002030541,5,1,117644,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002030542,5,2,157132,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002030543,5,3,209584,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002030553,5,3,332262,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002030563,5,3,509792,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002030600,6,0,17603,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002030610,6,0,29891,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002030620,6,0,60810,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002030631,6,1,86457,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002030632,6,2,104861,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002030641,6,1,173847,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002030642,6,2,229119,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,46323},{4,4,1158}]'),(1002030643,6,3,302535,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,110868},{4,4,2771}]'),(1002030653,6,3,479794,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,147822},{4,4,3696}]'),(1002030663,6,3,731971,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,184780},{4,4,4620}]'),(1002030700,7,0,25594,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002030710,7,0,43266,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002030720,7,0,87741,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002030731,7,1,124224,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002030732,7,2,150004,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002030741,7,1,248150,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002030742,7,2,325550,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,72050},{4,4,1801}]'),(1002030743,7,3,428330,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,156857},{4,4,3921}]'),(1002030753,7,3,679328,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,209142},{4,4,5229}]'),(1002030763,7,3,1008555,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,261426},{4,4,6536}]'),(1002030800,8,0,35310,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002030810,8,0,59838,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002030820,8,0,121456,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002030831,8,1,172239,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002030832,8,2,208323,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002030841,8,1,344929,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002030842,8,2,453285,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,75963},{4,4,1899}]'),(1002030843,8,3,597165,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,158699},{4,4,3968}]'),(1002030853,8,3,931000,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,211598},{4,4,5290}]'),(1002030863,8,3,1362558,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,264498},{4,4,6613}]'),(1002030900,9,0,46872,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002030910,9,0,79920,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002030920,9,0,163041,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002030931,9,1,232585,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002030932,9,2,283109,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002030941,9,1,470052,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002030942,9,2,621756,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,79744},{4,4,1994}]'),(1002030943,9,3,812112,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,158887},{4,4,3972}]'),(1002030953,9,3,1249007,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,211848},{4,4,5296}]'),(1002030963,9,3,1818012,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,264811},{4,4,6621}]'),(1002031000,10,0,60339,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002031010,10,0,103978,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002031020,10,0,213853,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002031031,10,1,308070,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002031032,10,2,378814,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002031041,10,1,631682,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002031042,10,2,835530,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,83902},{4,4,2097}]'),(1002031043,10,3,1083810,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,160662},{4,4,4016}]'),(1002031053,10,3,1653846,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,214216},{4,4,5356}]'),(1002031063,10,3,2393761,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,267770},{4,4,6694}]'),(1002031100,11,0,75841,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002031110,11,0,132569,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002031120,11,0,275747,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002031131,11,1,402454,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002031132,11,2,501498,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002031141,11,1,834370,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002031142,11,2,1103918,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,88425},{4,4,2211}]'),(1002031143,11,3,1429478,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,163814},{4,4,4095}]'),(1002031153,11,3,2164696,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,218419},{4,4,5460}]'),(1002031163,11,3,3115085,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,273024},{4,4,6825}]'),(1002031200,12,0,93405,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002031210,12,0,166472,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002031220,12,0,351212,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002031231,12,1,520938,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002031232,12,2,654570,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002031241,12,1,1085877,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002031242,12,2,1442229,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,93044},{4,4,2326}]'),(1002031243,12,3,1867497,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,167378},{4,4,4184}]'),(1002031253,12,3,2804485,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,223172},{4,4,5579}]'),(1002031263,12,3,4012939,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,278965},{4,4,6974}]'),(1002031300,13,0,113160,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002031310,13,0,206620,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002031320,13,0,443629,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002031331,13,1,666154,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002031332,13,2,843898,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002031341,13,1,1399144,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002031342,13,2,1868112,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,97910},{4,4,2448}]'),(1002031343,13,3,2419200,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,171866},{4,4,4296}]'),(1002031353,13,3,3601033,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,229154},{4,4,5729}]'),(1002031363,13,3,5122861,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,286443},{4,4,7161}]'),(1002031400,14,0,135185,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002031410,14,0,254400,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002031420,14,0,554235,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002031431,14,1,843134,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002031432,14,2,1079162,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002031441,14,1,1789529,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002031442,14,2,2402121,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,102675},{4,4,2567}]'),(1002031443,14,3,3110217,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,176479},{4,4,4412}]'),(1002031453,14,3,4586867,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,235306},{4,4,5883}]'),(1002031463,14,3,6485647,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,294132},{4,4,7353}]'),(1002031500,15,0,159557,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002031510,15,0,310051,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002031520,15,0,686633,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002031531,15,1,1060235,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002031532,15,2,1371943,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002031541,15,1,2274870,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002031542,15,2,3068674,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,107809},{4,4,2695}]'),(1002031543,15,3,3970786,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,185304},{4,4,4633}]'),(1002031553,15,3,5799599,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,247073},{4,4,6177}]'),(1002031563,15,3,8147443,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,308841},{4,4,7721}]'),(1002031600,16,0,6738355,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002031610,16,0,6831520,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002031620,16,0,7060751,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002031631,16,1,7172559,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002031632,16,2,7172559,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002031641,16,1,7483775,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002031642,16,2,7483775,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,113199},{4,4,2830}]'),(1002031643,16,3,7483775,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,194569},{4,4,4864}]'),(1002031653,16,3,8042840,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,259426},{4,4,6486}]'),(1002031663,16,3,8415550,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,324282},{4,4,8107}]'),(1002040100,1,0,787,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002040110,1,0,1889,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002040120,1,0,4427,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002040131,1,1,7551,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002040132,1,2,10047,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002040141,1,1,17120,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002040142,1,2,23592,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002040143,1,3,30432,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002040153,1,3,41325,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002040163,1,3,54888,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002040200,2,0,1359,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002040210,2,0,2990,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002040220,2,0,7254,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002040231,2,1,11974,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002040232,2,2,16454,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002040241,2,1,28950,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002040242,2,2,41774,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002040243,2,3,59282,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002040253,2,3,99094,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002040263,2,3,158259,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002040300,3,0,3238,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002040310,3,0,6229,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002040320,3,0,13595,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002040331,3,1,21174,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002040332,3,2,27986,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002040341,3,1,47953,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002040342,3,2,68245,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002040343,3,3,95161,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002040353,3,3,149382,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002040363,3,3,234938,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002040400,4,0,6503,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002040410,4,0,11538,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002040420,4,0,24269,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002040431,4,1,36150,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002040432,4,2,45566,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002040441,4,1,76894,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002040442,4,2,105114,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002040443,4,3,141978,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002040453,4,3,225027,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002040463,4,3,348733,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002040500,5,0,11257,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002040510,5,0,19397,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002040520,5,0,39868,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002040531,5,1,57419,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002040532,5,2,70571,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002040541,5,1,117644,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002040542,5,2,157132,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002040543,5,3,209584,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002040553,5,3,332262,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002040563,5,3,509792,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002040600,6,0,17603,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002040610,6,0,29891,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002040620,6,0,60810,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002040631,6,1,86457,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002040632,6,2,104861,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002040641,6,1,173847,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002040642,6,2,229119,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,46323},{4,4,1158}]'),(1002040643,6,3,302535,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,110868},{4,4,2771}]'),(1002040653,6,3,479794,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,147822},{4,4,3696}]'),(1002040663,6,3,731971,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,184780},{4,4,4620}]'),(1002040700,7,0,25594,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002040710,7,0,43266,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002040720,7,0,87741,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002040731,7,1,124224,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002040732,7,2,150004,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002040741,7,1,248150,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002040742,7,2,325550,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,72050},{4,4,1801}]'),(1002040743,7,3,428330,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,156857},{4,4,3921}]'),(1002040753,7,3,679328,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,209142},{4,4,5229}]'),(1002040763,7,3,1008555,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,261426},{4,4,6536}]'),(1002040800,8,0,35310,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002040810,8,0,59838,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002040820,8,0,121456,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002040831,8,1,172239,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002040832,8,2,208323,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002040841,8,1,344929,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002040842,8,2,453285,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,75963},{4,4,1899}]'),(1002040843,8,3,597165,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,158699},{4,4,3968}]'),(1002040853,8,3,931000,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,211598},{4,4,5290}]'),(1002040863,8,3,1362558,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,264498},{4,4,6613}]'),(1002040900,9,0,46872,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002040910,9,0,79920,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002040920,9,0,163041,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002040931,9,1,232585,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002040932,9,2,283109,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002040941,9,1,470052,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002040942,9,2,621756,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,79744},{4,4,1994}]'),(1002040943,9,3,812112,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,158887},{4,4,3972}]'),(1002040953,9,3,1249007,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,211848},{4,4,5296}]'),(1002040963,9,3,1818012,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,264811},{4,4,6621}]'),(1002041000,10,0,60339,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002041010,10,0,103978,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002041020,10,0,213853,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002041031,10,1,308070,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002041032,10,2,378814,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002041041,10,1,631682,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002041042,10,2,835530,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,83902},{4,4,2097}]'),(1002041043,10,3,1083810,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,160662},{4,4,4016}]'),(1002041053,10,3,1653846,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,214216},{4,4,5356}]'),(1002041063,10,3,2393761,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,267770},{4,4,6694}]'),(1002041100,11,0,75841,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002041110,11,0,132569,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002041120,11,0,275747,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002041131,11,1,402454,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002041132,11,2,501498,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002041141,11,1,834370,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002041142,11,2,1103918,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,88425},{4,4,2211}]'),(1002041143,11,3,1429478,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,163814},{4,4,4095}]'),(1002041153,11,3,2164696,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,218419},{4,4,5460}]'),(1002041163,11,3,3115085,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,273024},{4,4,6825}]'),(1002041200,12,0,93405,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002041210,12,0,166472,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002041220,12,0,351212,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002041231,12,1,520938,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002041232,12,2,654570,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002041241,12,1,1085877,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002041242,12,2,1442229,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,93044},{4,4,2326}]'),(1002041243,12,3,1867497,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,167378},{4,4,4184}]'),(1002041253,12,3,2804485,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,223172},{4,4,5579}]'),(1002041263,12,3,4012939,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,278965},{4,4,6974}]'),(1002041300,13,0,113160,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002041310,13,0,206620,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002041320,13,0,443629,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002041331,13,1,666154,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002041332,13,2,843898,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002041341,13,1,1399144,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002041342,13,2,1868112,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,97910},{4,4,2448}]'),(1002041343,13,3,2419200,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,171866},{4,4,4296}]'),(1002041353,13,3,3601033,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,229154},{4,4,5729}]'),(1002041363,13,3,5122861,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,286443},{4,4,7161}]'),(1002041400,14,0,135185,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002041410,14,0,254400,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002041420,14,0,554235,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002041431,14,1,843134,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002041432,14,2,1079162,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002041441,14,1,1789529,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002041442,14,2,2402121,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,102675},{4,4,2567}]'),(1002041443,14,3,3110217,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,176479},{4,4,4412}]'),(1002041453,14,3,4586867,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,235306},{4,4,5883}]'),(1002041463,14,3,6485647,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,294132},{4,4,7353}]'),(1002041500,15,0,159557,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002041510,15,0,310051,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002041520,15,0,686633,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002041531,15,1,1060235,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002041532,15,2,1371943,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002041541,15,1,2274870,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002041542,15,2,3068674,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,107809},{4,4,2695}]'),(1002041543,15,3,3970786,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,185304},{4,4,4633}]'),(1002041553,15,3,5799599,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,247073},{4,4,6177}]'),(1002041563,15,3,8147443,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,308841},{4,4,7721}]'),(1002041600,16,0,6738355,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002041610,16,0,6831520,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1002041620,16,0,7060751,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1002041631,16,1,7172559,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002041632,16,2,7172559,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1002041641,16,1,7483775,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1002041642,16,2,7483775,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,113199},{4,4,2830}]'),(1002041643,16,3,7483775,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,194569},{4,4,4864}]'),(1002041653,16,3,8042840,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,259426},{4,4,6486}]'),(1002041663,16,3,8415550,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,324282},{4,4,8107}]'),(1003000100,1,0,975,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1003000110,1,0,2158,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1003000120,1,0,4917,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1003000131,1,1,8134,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1003000132,1,2,10630,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1003000141,1,1,17990,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1003000142,1,2,24462,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1003000143,1,3,31302,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1003000153,1,3,42739,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1003000163,1,3,56653,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1003000200,2,0,1645,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1003000210,2,0,3434,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1003000220,2,0,8082,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1003000231,2,1,12997,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1003000232,2,2,17477,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1003000241,2,1,30455,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1003000242,2,2,43279,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1003000243,2,3,60787,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1003000253,2,3,101508,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1003000263,2,3,161295,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1003000300,3,0,3945,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1003000310,3,0,7287,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1003000320,3,0,15558,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1003000331,3,1,23554,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1003000332,3,2,30366,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1003000341,3,1,51528,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1003000342,3,2,71820,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1003000343,3,3,98736,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1003000353,3,3,155118,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1003000363,3,3,242107,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1003000400,4,0,7950,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1003000410,4,0,13699,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1003000420,4,0,28226,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1003000431,4,1,40971,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1003000432,4,2,50387,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1003000441,4,1,84140,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1003000442,4,2,112360,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1003000443,4,3,149224,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1003000453,4,3,236570,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1003000463,4,3,363175,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1003000500,5,0,13780,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1003000510,5,0,23150,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1003000520,5,0,46690,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1003000531,5,1,65757,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1003000532,5,2,78909,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1003000541,5,1,130171,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1003000542,5,2,169659,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1003000543,5,3,222111,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1003000553,5,3,352290,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1003000563,5,3,534822,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1003000600,6,0,21515,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1003000610,6,0,35760,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1003000620,6,0,71471,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1003000631,6,1,99486,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1003000632,6,2,117890,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1003000641,6,1,193394,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1003000642,6,2,248666,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,2830},{4,3,1415}]'),(1003000643,6,3,322082,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,6774},{4,3,3387}]'),(1003000653,6,3,511059,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,9033},{4,3,4517}]'),(1003000663,6,3,771060,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,11292},{4,3,5645}]'),(1003000700,7,0,31265,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1003000710,7,0,51810,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1003000720,7,0,103249,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1003000731,7,1,143150,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1003000732,7,2,168930,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1003000741,7,1,276573,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1003000742,7,2,353973,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,4403},{4,3,2201}]'),(1003000743,7,3,456753,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,9586},{4,3,4792}]'),(1003000753,7,3,724813,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,12780},{4,3,6391}]'),(1003000763,7,3,1065427,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,15977},{4,3,7988}]'),(1003000800,8,0,43160,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1003000810,8,0,71600,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1003000820,8,0,142889,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1003000831,8,1,198396,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1003000832,8,2,234480,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1003000841,8,1,384173,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1003000842,8,2,492529,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,4642},{4,3,2321}]'),(1003000843,8,3,636409,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,9698},{4,3,4850}]'),(1003000853,8,3,993789,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,12931},{4,3,6465}]'),(1003000863,8,3,1441041,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,16164},{4,3,8082}]'),(1003000900,9,0,57285,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1003000910,9,0,95530,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1003000920,9,0,191474,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1003000931,9,1,267275,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1003000932,9,2,317799,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1003000941,9,1,522123,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1003000942,9,2,673827,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,4873},{4,3,2437}]'),(1003000943,9,3,864183,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,9709},{4,3,4855}]'),(1003000953,9,3,1332343,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,12946},{4,3,6473}]'),(1003000963,9,3,1922174,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,16183},{4,3,8091}]'),(1003001000,10,0,73775,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1003001010,10,0,124074,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1003001020,10,0,250458,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1003001031,10,1,352731,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1003001032,10,2,423475,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1003001041,10,1,698746,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1003001042,10,2,902594,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,5127},{4,3,2564}]'),(1003001043,10,3,1150874,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,9818},{4,3,4909}]'),(1003001053,10,3,1761122,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,13091},{4,3,6545}]'),(1003001063,10,3,2527864,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,16364},{4,3,8182}]'),(1003001100,11,0,92690,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1003001110,11,0,157855,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1003001120,11,0,321749,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1003001131,11,1,458572,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1003001132,11,2,557616,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1003001141,11,1,918646,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1003001142,11,2,1188194,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,5404},{4,3,2702}]'),(1003001143,11,3,1513754,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,10011},{4,3,5006}]'),(1003001153,11,3,2299499,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,13348},{4,3,6674}]'),(1003001163,11,3,3283611,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,16685},{4,3,8342}]'),(1003001200,12,0,114160,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1003001210,12,0,197607,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1003001220,12,0,407891,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1003001231,12,1,590069,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1003001232,12,2,723701,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1003001241,12,1,1189662,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1003001242,12,2,1546014,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,5686},{4,3,2843}]'),(1003001243,12,3,1971282,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,10228},{4,3,5115}]'),(1003001253,12,3,2970539,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,13638},{4,3,6819}]'),(1003001263,12,3,4220503,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,17048},{4,3,8524}]'),(1003001300,13,0,138300,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1003001310,13,0,244352,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1003001320,13,0,512265,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1003001331,13,1,749889,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1003001332,13,2,927633,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1003001341,13,1,1524883,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1003001342,13,2,1993851,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,5983},{4,3,2992}]'),(1003001343,13,3,2544939,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,10503},{4,3,5252}]'),(1003001353,13,3,3802206,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,14004},{4,3,7002}]'),(1003001363,13,3,5374309,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,17505},{4,3,8752}]'),(1003001400,14,0,165230,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1003001410,14,0,299473,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1003001420,14,0,636251,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1003001431,14,1,943164,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1003001432,14,2,1179192,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1003001441,14,1,1939741,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1003001442,14,2,2552333,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,6275},{4,3,3137}]'),(1003001443,14,3,3260429,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,10785},{4,3,5393}]'),(1003001453,14,3,4827174,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,14380},{4,3,7190}]'),(1003001463,14,3,6786050,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,17975},{4,3,8988}]'),(1003001500,15,0,195000,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1003001510,15,0,363228,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1003001520,15,0,783422,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1003001531,15,1,1178290,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1003001532,15,2,1489998,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1003001541,15,1,2452136,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1003001542,15,2,3245940,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,6588},{4,3,3294}]'),(1003001543,15,3,4148052,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,11324},{4,3,5662}]'),(1003001553,15,3,6083244,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,15099},{4,3,7549}]'),(1003001563,15,3,8502000,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,18874},{4,3,9437}]'),(1003001600,16,0,6779760,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1003001610,16,0,6893640,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1003001620,16,0,7173790,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,9,180}}]',0,'[]',0,'[]','[]'),(1003001631,16,1,7310465,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1003001632,16,2,7310465,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,9,240}}]',0,'[]','[]'),(1003001641,16,1,7690845,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1003001642,16,2,7690845,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,6918},{4,3,3459}]'),(1003001643,16,3,7690845,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,11890},{4,3,5945}]'),(1003001653,16,3,8374145,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,15854},{4,3,7927}]'),(1003001663,16,3,8829665,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,19817},{4,3,9909}]'),(1004010100,1,0,1181,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004010110,1,0,2479,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004010120,1,0,5516,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004010131,1,1,8862,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004010132,1,2,11358,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004010141,1,1,19088,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004010142,1,2,25560,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004010143,1,3,32400,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004010153,1,3,44498,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004010163,1,3,58848,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004010200,2,0,2026,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004010210,2,0,4015,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004010220,2,0,9092,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004010231,2,1,14237,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004010232,2,2,18717,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004010241,2,1,32334,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004010242,2,2,45158,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004010243,2,3,62666,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004010253,2,3,104505,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004010263,2,3,165054,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004010300,3,0,4857,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004010310,3,0,8645,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004010320,3,0,18009,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004010331,3,1,26534,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004010332,3,2,33346,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004010341,3,1,56023,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004010342,3,2,76315,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004010343,3,3,103231,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004010353,3,3,162285,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004010363,3,3,251103,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004010400,4,0,9754,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004010410,4,0,16415,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004010420,4,0,33157,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004010431,4,1,46990,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004010432,4,2,56406,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004010441,4,1,93176,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004010442,4,2,121396,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004010443,4,3,158260,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004010453,4,3,251039,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004010463,4,3,381247,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004010500,5,0,16897,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004010510,5,0,27846,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004010520,5,0,55254,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004010531,5,1,76185,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004010532,5,2,89337,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004010541,5,1,145822,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004010542,5,2,185310,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004010543,5,3,237762,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004010553,5,3,377313,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004010563,5,3,566100,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004010600,6,0,26391,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004010610,6,0,43087,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004010620,6,0,84815,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004010631,6,1,115760,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004010632,6,2,134164,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004010641,6,1,217841,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004010642,6,2,273113,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,69484},{4,4,1737}]'),(1004010643,6,3,346529,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,166302},{4,4,4157}]'),(1004010653,6,3,550155,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,221735},{4,4,5543}]'),(1004010663,6,3,819933,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,277168},{4,4,6929}]'),(1004010700,7,0,38366,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004010710,7,0,62475,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004010720,7,0,122657,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004010731,7,1,166813,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004010732,7,2,192593,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004010741,7,1,312110,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004010742,7,2,389510,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,108075},{4,4,2702}]'),(1004010743,7,3,492290,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,235283},{4,4,5882}]'),(1004010753,7,3,781655,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,313712},{4,4,7842}]'),(1004010763,7,3,1136477,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,392140},{4,4,9803}]'),(1004010800,8,0,52978,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004010810,8,0,86339,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004010820,8,0,169674,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004010831,8,1,231053,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004010832,8,2,267137,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004010841,8,1,433217,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004010842,8,2,541573,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,113944},{4,4,2848}]'),(1004010843,8,3,685453,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,238049},{4,4,5951}]'),(1004010853,8,3,1072291,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,317398},{4,4,7935}]'),(1004010863,8,3,1539158,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,396746},{4,4,9919}]'),(1004010900,9,0,70320,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004010910,9,0,115080,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004010920,9,0,227017,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004010931,9,1,310640,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004010932,9,2,361164,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004010941,9,1,587244,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004010942,9,2,738948,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,119615},{4,4,2991}]'),(1004010943,9,3,929304,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,238330},{4,4,5958}]'),(1004010953,9,3,1436519,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,317773},{4,4,7944}]'),(1004010963,9,3,2052396,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,397217},{4,4,9931}]'),(1004011000,10,0,90534,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004011010,10,0,149232,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004011020,10,0,296223,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004011031,10,1,408556,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004011032,10,2,479300,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004011041,10,1,782580,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004011042,10,2,986428,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,125853},{4,4,3146}]'),(1004011043,10,3,1234708,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,240993},{4,4,6025}]'),(1004011053,10,3,1895253,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,321324},{4,4,8033}]'),(1004011063,10,3,2695508,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,401655},{4,4,10041}]'),(1004011100,11,0,113749,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004011110,11,0,189443,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004011120,11,0,379246,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004011131,11,1,528703,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004011132,11,2,627747,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004011141,11,1,1023960,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004011142,11,2,1293508,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,132638},{4,4,3316}]'),(1004011143,11,3,1619068,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,245722},{4,4,6143}]'),(1004011153,11,3,2468035,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,327629},{4,4,8191}]'),(1004011163,11,3,3494264,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,409536},{4,4,10239}]'),(1004011200,12,0,140120,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004011210,12,0,236507,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004011220,12,0,478722,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004011231,12,1,676467,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004011232,12,2,810099,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004011241,12,1,1319403,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004011242,12,2,1675755,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,139567},{4,4,3489}]'),(1004011243,12,3,2101023,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,251068},{4,4,6277}]'),(1004011253,12,3,3178105,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,334757},{4,4,8369}]'),(1004011263,12,3,4479964,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,418447},{4,4,10461}]'),(1004011300,13,0,169728,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004011310,13,0,291496,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004011320,13,0,598081,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004011331,13,1,854572,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004011332,13,2,1032316,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004011341,13,1,1682057,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004011342,13,2,2151025,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,146865},{4,4,3672}]'),(1004011343,13,3,2702113,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,257798},{4,4,6445}]'),(1004011353,13,3,4053674,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,343732},{4,4,8593}]'),(1004011363,13,3,5688638,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,429665},{4,4,10742}]'),(1004011400,14,0,202752,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004011410,14,0,355789,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004011420,14,0,738757,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004011431,14,1,1068212,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004011432,14,2,1304240,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004011441,14,1,2127466,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004011442,14,2,2740058,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,154012},{4,4,3850}]'),(1004011443,14,3,3448154,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,264719},{4,4,6618}]'),(1004011453,14,3,5127555,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,352959},{4,4,8824}]'),(1004011463,14,3,7161520,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,441198},{4,4,11030}]'),(1004011500,15,0,239323,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004011510,15,0,429712,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004011520,15,0,904402,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004011531,15,1,1325858,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004011532,15,2,1637566,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004011541,15,1,2673725,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004011542,15,2,3467529,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,161713},{4,4,4043}]'),(1004011543,15,3,4369641,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,277957},{4,4,6949}]'),(1004011553,15,3,6437801,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,370609},{4,4,9265}]'),(1004011563,15,3,8945177,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,463261},{4,4,11581}]'),(1004011600,16,0,6831520,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004011610,16,0,6971305,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004011620,16,0,7315115,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004011631,16,1,7482852,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004011632,16,2,7482852,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004011641,16,1,7949650,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004011642,16,2,7949650,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,169798},{4,4,4245}]'),(1004011643,16,3,7949650,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,291854},{4,4,7296}]'),(1004011653,16,3,8788260,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,389139},{4,4,9728}]'),(1004011663,16,3,9347325,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,486424},{4,4,12161}]'),(1004020100,1,0,1181,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004020110,1,0,2479,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004020120,1,0,5516,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004020131,1,1,8862,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004020132,1,2,11358,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004020141,1,1,19088,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004020142,1,2,25560,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004020143,1,3,32400,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004020153,1,3,44498,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004020163,1,3,58848,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004020200,2,0,2026,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004020210,2,0,4015,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004020220,2,0,9092,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004020231,2,1,14237,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004020232,2,2,18717,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004020241,2,1,32334,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004020242,2,2,45158,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004020243,2,3,62666,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004020253,2,3,104505,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004020263,2,3,165054,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004020300,3,0,4857,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004020310,3,0,8645,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004020320,3,0,18009,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004020331,3,1,26534,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004020332,3,2,33346,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004020341,3,1,56023,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004020342,3,2,76315,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004020343,3,3,103231,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004020353,3,3,162285,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004020363,3,3,251103,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004020400,4,0,9754,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004020410,4,0,16415,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004020420,4,0,33157,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004020431,4,1,46990,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004020432,4,2,56406,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004020441,4,1,93176,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004020442,4,2,121396,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004020443,4,3,158260,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004020453,4,3,251039,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004020463,4,3,381247,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004020500,5,0,16897,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004020510,5,0,27846,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004020520,5,0,55254,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004020531,5,1,76185,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004020532,5,2,89337,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004020541,5,1,145822,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004020542,5,2,185310,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004020543,5,3,237762,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004020553,5,3,377313,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004020563,5,3,566100,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004020600,6,0,26391,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004020610,6,0,43087,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004020620,6,0,84815,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004020631,6,1,115760,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004020632,6,2,134164,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004020641,6,1,217841,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004020642,6,2,273113,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,69484},{4,4,1737}]'),(1004020643,6,3,346529,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,166302},{4,4,4157}]'),(1004020653,6,3,550155,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,221735},{4,4,5543}]'),(1004020663,6,3,819933,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,277168},{4,4,6929}]'),(1004020700,7,0,38366,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004020710,7,0,62475,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004020720,7,0,122657,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004020731,7,1,166813,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004020732,7,2,192593,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004020741,7,1,312110,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004020742,7,2,389510,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,108075},{4,4,2702}]'),(1004020743,7,3,492290,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,235283},{4,4,5882}]'),(1004020753,7,3,781655,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,313712},{4,4,7842}]'),(1004020763,7,3,1136477,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,392140},{4,4,9803}]'),(1004020800,8,0,52978,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004020810,8,0,86339,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004020820,8,0,169674,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004020831,8,1,231053,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004020832,8,2,267137,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004020841,8,1,433217,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004020842,8,2,541573,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,113944},{4,4,2848}]'),(1004020843,8,3,685453,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,238049},{4,4,5951}]'),(1004020853,8,3,1072291,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,317398},{4,4,7935}]'),(1004020863,8,3,1539158,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,396746},{4,4,9919}]'),(1004020900,9,0,70320,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004020910,9,0,115080,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004020920,9,0,227017,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004020931,9,1,310640,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004020932,9,2,361164,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004020941,9,1,587244,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004020942,9,2,738948,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,119615},{4,4,2991}]'),(1004020943,9,3,929304,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,238330},{4,4,5958}]'),(1004020953,9,3,1436519,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,317773},{4,4,7944}]'),(1004020963,9,3,2052396,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,397217},{4,4,9931}]'),(1004021000,10,0,90534,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004021010,10,0,149232,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004021020,10,0,296223,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004021031,10,1,408556,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004021032,10,2,479300,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004021041,10,1,782580,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004021042,10,2,986428,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,125853},{4,4,3146}]'),(1004021043,10,3,1234708,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,240993},{4,4,6025}]'),(1004021053,10,3,1895253,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,321324},{4,4,8033}]'),(1004021063,10,3,2695508,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,401655},{4,4,10041}]'),(1004021100,11,0,113749,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004021110,11,0,189443,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004021120,11,0,379246,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004021131,11,1,528703,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004021132,11,2,627747,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004021141,11,1,1023960,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004021142,11,2,1293508,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,132638},{4,4,3316}]'),(1004021143,11,3,1619068,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,245722},{4,4,6143}]'),(1004021153,11,3,2468035,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,327629},{4,4,8191}]'),(1004021163,11,3,3494264,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,409536},{4,4,10239}]'),(1004021200,12,0,140120,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004021210,12,0,236507,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004021220,12,0,478722,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004021231,12,1,676467,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004021232,12,2,810099,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004021241,12,1,1319403,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004021242,12,2,1675755,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,139567},{4,4,3489}]'),(1004021243,12,3,2101023,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,251068},{4,4,6277}]'),(1004021253,12,3,3178105,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,334757},{4,4,8369}]'),(1004021263,12,3,4479964,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,418447},{4,4,10461}]'),(1004021300,13,0,169728,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004021310,13,0,291496,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004021320,13,0,598081,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004021331,13,1,854572,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004021332,13,2,1032316,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004021341,13,1,1682057,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004021342,13,2,2151025,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,146865},{4,4,3672}]'),(1004021343,13,3,2702113,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,257798},{4,4,6445}]'),(1004021353,13,3,4053674,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,343732},{4,4,8593}]'),(1004021363,13,3,5688638,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,429665},{4,4,10742}]'),(1004021400,14,0,202752,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004021410,14,0,355789,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004021420,14,0,738757,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004021431,14,1,1068212,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004021432,14,2,1304240,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004021441,14,1,2127466,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004021442,14,2,2740058,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,154012},{4,4,3850}]'),(1004021443,14,3,3448154,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,264719},{4,4,6618}]'),(1004021453,14,3,5127555,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,352959},{4,4,8824}]'),(1004021463,14,3,7161520,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,441198},{4,4,11030}]'),(1004021500,15,0,239323,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004021510,15,0,429712,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004021520,15,0,904402,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004021531,15,1,1325858,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004021532,15,2,1637566,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004021541,15,1,2673725,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004021542,15,2,3467529,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,161713},{4,4,4043}]'),(1004021543,15,3,4369641,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,277957},{4,4,6949}]'),(1004021553,15,3,6437801,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,370609},{4,4,9265}]'),(1004021563,15,3,8945177,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,463261},{4,4,11581}]'),(1004021600,16,0,6831520,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004021610,16,0,6971305,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004021620,16,0,7315115,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004021631,16,1,7482852,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004021632,16,2,7482852,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004021641,16,1,7949650,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004021642,16,2,7949650,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,169798},{4,4,4245}]'),(1004021643,16,3,7949650,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,291854},{4,4,7296}]'),(1004021653,16,3,8788260,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,389139},{4,4,9728}]'),(1004021663,16,3,9347325,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,486424},{4,4,12161}]'),(1004030100,1,0,1181,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004030110,1,0,2479,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004030120,1,0,5516,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004030131,1,1,8862,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004030132,1,2,11358,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004030141,1,1,19088,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004030142,1,2,25560,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004030143,1,3,32400,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004030153,1,3,44498,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004030163,1,3,58848,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004030200,2,0,2026,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004030210,2,0,4015,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004030220,2,0,9092,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004030231,2,1,14237,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004030232,2,2,18717,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004030241,2,1,32334,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004030242,2,2,45158,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004030243,2,3,62666,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004030253,2,3,104505,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004030263,2,3,165054,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004030300,3,0,4857,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004030310,3,0,8645,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004030320,3,0,18009,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004030331,3,1,26534,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004030332,3,2,33346,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004030341,3,1,56023,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004030342,3,2,76315,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004030343,3,3,103231,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004030353,3,3,162285,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004030363,3,3,251103,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004030400,4,0,9754,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004030410,4,0,16415,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004030420,4,0,33157,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004030431,4,1,46990,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004030432,4,2,56406,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004030441,4,1,93176,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004030442,4,2,121396,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004030443,4,3,158260,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004030453,4,3,251039,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004030463,4,3,381247,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004030500,5,0,16897,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004030510,5,0,27846,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004030520,5,0,55254,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004030531,5,1,76185,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004030532,5,2,89337,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004030541,5,1,145822,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004030542,5,2,185310,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004030543,5,3,237762,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004030553,5,3,377313,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004030563,5,3,566100,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004030600,6,0,26391,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004030610,6,0,43087,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004030620,6,0,84815,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004030631,6,1,115760,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004030632,6,2,134164,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004030641,6,1,217841,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004030642,6,2,273113,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,69484},{4,4,1737}]'),(1004030643,6,3,346529,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,166302},{4,4,4157}]'),(1004030653,6,3,550155,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,221735},{4,4,5543}]'),(1004030663,6,3,819933,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,277168},{4,4,6929}]'),(1004030700,7,0,38366,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004030710,7,0,62475,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004030720,7,0,122657,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004030731,7,1,166813,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004030732,7,2,192593,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004030741,7,1,312110,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004030742,7,2,389510,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,108075},{4,4,2702}]'),(1004030743,7,3,492290,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,235283},{4,4,5882}]'),(1004030753,7,3,781655,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,313712},{4,4,7842}]'),(1004030763,7,3,1136477,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,392140},{4,4,9803}]'),(1004030800,8,0,52978,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004030810,8,0,86339,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004030820,8,0,169674,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004030831,8,1,231053,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004030832,8,2,267137,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004030841,8,1,433217,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004030842,8,2,541573,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,113944},{4,4,2848}]'),(1004030843,8,3,685453,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,238049},{4,4,5951}]'),(1004030853,8,3,1072291,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,317398},{4,4,7935}]'),(1004030863,8,3,1539158,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,396746},{4,4,9919}]'),(1004030900,9,0,70320,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004030910,9,0,115080,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004030920,9,0,227017,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004030931,9,1,310640,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004030932,9,2,361164,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004030941,9,1,587244,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004030942,9,2,738948,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,119615},{4,4,2991}]'),(1004030943,9,3,929304,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,238330},{4,4,5958}]'),(1004030953,9,3,1436519,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,317773},{4,4,7944}]'),(1004030963,9,3,2052396,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,397217},{4,4,9931}]'),(1004031000,10,0,90534,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004031010,10,0,149232,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004031020,10,0,296223,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004031031,10,1,408556,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004031032,10,2,479300,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004031041,10,1,782580,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004031042,10,2,986428,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,125853},{4,4,3146}]'),(1004031043,10,3,1234708,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,240993},{4,4,6025}]'),(1004031053,10,3,1895253,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,321324},{4,4,8033}]'),(1004031063,10,3,2695508,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,401655},{4,4,10041}]'),(1004031100,11,0,113749,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004031110,11,0,189443,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004031120,11,0,379246,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004031131,11,1,528703,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004031132,11,2,627747,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004031141,11,1,1023960,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004031142,11,2,1293508,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,132638},{4,4,3316}]'),(1004031143,11,3,1619068,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,245722},{4,4,6143}]'),(1004031153,11,3,2468035,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,327629},{4,4,8191}]'),(1004031163,11,3,3494264,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,409536},{4,4,10239}]'),(1004031200,12,0,140120,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004031210,12,0,236507,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004031220,12,0,478722,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004031231,12,1,676467,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004031232,12,2,810099,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004031241,12,1,1319403,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004031242,12,2,1675755,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,139567},{4,4,3489}]'),(1004031243,12,3,2101023,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,251068},{4,4,6277}]'),(1004031253,12,3,3178105,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,334757},{4,4,8369}]'),(1004031263,12,3,4479964,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,418447},{4,4,10461}]'),(1004031300,13,0,169728,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004031310,13,0,291496,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004031320,13,0,598081,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004031331,13,1,854572,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004031332,13,2,1032316,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004031341,13,1,1682057,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004031342,13,2,2151025,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,146865},{4,4,3672}]'),(1004031343,13,3,2702113,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,257798},{4,4,6445}]'),(1004031353,13,3,4053674,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,343732},{4,4,8593}]'),(1004031363,13,3,5688638,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,429665},{4,4,10742}]'),(1004031400,14,0,202752,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004031410,14,0,355789,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004031420,14,0,738757,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004031431,14,1,1068212,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004031432,14,2,1304240,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004031441,14,1,2127466,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004031442,14,2,2740058,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,154012},{4,4,3850}]'),(1004031443,14,3,3448154,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,264719},{4,4,6618}]'),(1004031453,14,3,5127555,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,352959},{4,4,8824}]'),(1004031463,14,3,7161520,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,441198},{4,4,11030}]'),(1004031500,15,0,239323,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004031510,15,0,429712,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004031520,15,0,904402,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004031531,15,1,1325858,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004031532,15,2,1637566,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004031541,15,1,2673725,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004031542,15,2,3467529,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,161713},{4,4,4043}]'),(1004031543,15,3,4369641,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,277957},{4,4,6949}]'),(1004031553,15,3,6437801,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,370609},{4,4,9265}]'),(1004031563,15,3,8945177,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,463261},{4,4,11581}]'),(1004031600,16,0,6831520,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004031610,16,0,6971305,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004031620,16,0,7315115,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004031631,16,1,7482852,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004031632,16,2,7482852,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004031641,16,1,7949650,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004031642,16,2,7949650,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,169798},{4,4,4245}]'),(1004031643,16,3,7949650,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,291854},{4,4,7296}]'),(1004031653,16,3,8788260,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,389139},{4,4,9728}]'),(1004031663,16,3,9347325,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,486424},{4,4,12161}]'),(1004040100,1,0,1181,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004040110,1,0,2479,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004040120,1,0,5516,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004040131,1,1,8862,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004040132,1,2,11358,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004040141,1,1,19088,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004040142,1,2,25560,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004040143,1,3,32400,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004040153,1,3,44498,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004040163,1,3,58848,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004040200,2,0,2026,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004040210,2,0,4015,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004040220,2,0,9092,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004040231,2,1,14237,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004040232,2,2,18717,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004040241,2,1,32334,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004040242,2,2,45158,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004040243,2,3,62666,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004040253,2,3,104505,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004040263,2,3,165054,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004040300,3,0,4857,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004040310,3,0,8645,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004040320,3,0,18009,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004040331,3,1,26534,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004040332,3,2,33346,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004040341,3,1,56023,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004040342,3,2,76315,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004040343,3,3,103231,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004040353,3,3,162285,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004040363,3,3,251103,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004040400,4,0,9754,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004040410,4,0,16415,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004040420,4,0,33157,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004040431,4,1,46990,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004040432,4,2,56406,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004040441,4,1,93176,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004040442,4,2,121396,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004040443,4,3,158260,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004040453,4,3,251039,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004040463,4,3,381247,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004040500,5,0,16897,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004040510,5,0,27846,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004040520,5,0,55254,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004040531,5,1,76185,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004040532,5,2,89337,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004040541,5,1,145822,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004040542,5,2,185310,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004040543,5,3,237762,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004040553,5,3,377313,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004040563,5,3,566100,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004040600,6,0,26391,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004040610,6,0,43087,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004040620,6,0,84815,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004040631,6,1,115760,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004040632,6,2,134164,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004040641,6,1,217841,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004040642,6,2,273113,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,69484},{4,4,1737}]'),(1004040643,6,3,346529,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,166302},{4,4,4157}]'),(1004040653,6,3,550155,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,221735},{4,4,5543}]'),(1004040663,6,3,819933,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,277168},{4,4,6929}]'),(1004040700,7,0,38366,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004040710,7,0,62475,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004040720,7,0,122657,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004040731,7,1,166813,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004040732,7,2,192593,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004040741,7,1,312110,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004040742,7,2,389510,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,108075},{4,4,2702}]'),(1004040743,7,3,492290,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,235283},{4,4,5882}]'),(1004040753,7,3,781655,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,313712},{4,4,7842}]'),(1004040763,7,3,1136477,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,392140},{4,4,9803}]'),(1004040800,8,0,52978,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004040810,8,0,86339,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004040820,8,0,169674,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004040831,8,1,231053,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004040832,8,2,267137,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004040841,8,1,433217,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004040842,8,2,541573,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,113944},{4,4,2848}]'),(1004040843,8,3,685453,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,238049},{4,4,5951}]'),(1004040853,8,3,1072291,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,317398},{4,4,7935}]'),(1004040863,8,3,1539158,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,396746},{4,4,9919}]'),(1004040900,9,0,70320,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004040910,9,0,115080,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004040920,9,0,227017,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004040931,9,1,310640,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004040932,9,2,361164,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004040941,9,1,587244,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004040942,9,2,738948,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,119615},{4,4,2991}]'),(1004040943,9,3,929304,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,238330},{4,4,5958}]'),(1004040953,9,3,1436519,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,317773},{4,4,7944}]'),(1004040963,9,3,2052396,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,397217},{4,4,9931}]'),(1004041000,10,0,90534,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004041010,10,0,149232,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004041020,10,0,296223,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004041031,10,1,408556,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004041032,10,2,479300,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004041041,10,1,782580,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004041042,10,2,986428,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,125853},{4,4,3146}]'),(1004041043,10,3,1234708,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,240993},{4,4,6025}]'),(1004041053,10,3,1895253,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,321324},{4,4,8033}]'),(1004041063,10,3,2695508,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,401655},{4,4,10041}]'),(1004041100,11,0,113749,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004041110,11,0,189443,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004041120,11,0,379246,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004041131,11,1,528703,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004041132,11,2,627747,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004041141,11,1,1023960,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004041142,11,2,1293508,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,132638},{4,4,3316}]'),(1004041143,11,3,1619068,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,245722},{4,4,6143}]'),(1004041153,11,3,2468035,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,327629},{4,4,8191}]'),(1004041163,11,3,3494264,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,409536},{4,4,10239}]'),(1004041200,12,0,140120,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004041210,12,0,236507,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004041220,12,0,478722,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004041231,12,1,676467,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004041232,12,2,810099,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004041241,12,1,1319403,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004041242,12,2,1675755,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,139567},{4,4,3489}]'),(1004041243,12,3,2101023,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,251068},{4,4,6277}]'),(1004041253,12,3,3178105,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,334757},{4,4,8369}]'),(1004041263,12,3,4479964,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,418447},{4,4,10461}]'),(1004041300,13,0,169728,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004041310,13,0,291496,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004041320,13,0,598081,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004041331,13,1,854572,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004041332,13,2,1032316,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004041341,13,1,1682057,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004041342,13,2,2151025,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,146865},{4,4,3672}]'),(1004041343,13,3,2702113,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,257798},{4,4,6445}]'),(1004041353,13,3,4053674,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,343732},{4,4,8593}]'),(1004041363,13,3,5688638,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,429665},{4,4,10742}]'),(1004041400,14,0,202752,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004041410,14,0,355789,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004041420,14,0,738757,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004041431,14,1,1068212,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004041432,14,2,1304240,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004041441,14,1,2127466,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004041442,14,2,2740058,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,154012},{4,4,3850}]'),(1004041443,14,3,3448154,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,264719},{4,4,6618}]'),(1004041453,14,3,5127555,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,352959},{4,4,8824}]'),(1004041463,14,3,7161520,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,441198},{4,4,11030}]'),(1004041500,15,0,239323,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004041510,15,0,429712,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004041520,15,0,904402,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004041531,15,1,1325858,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004041532,15,2,1637566,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004041541,15,1,2673725,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004041542,15,2,3467529,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,161713},{4,4,4043}]'),(1004041543,15,3,4369641,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,277957},{4,4,6949}]'),(1004041553,15,3,6437801,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,370609},{4,4,9265}]'),(1004041563,15,3,8945177,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,463261},{4,4,11581}]'),(1004041600,16,0,6831520,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004041610,16,0,6971305,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1004041620,16,0,7315115,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1004041631,16,1,7482852,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004041632,16,2,7482852,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1004041641,16,1,7949650,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1004041642,16,2,7949650,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,169798},{4,4,4245}]'),(1004041643,16,3,7949650,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,291854},{4,4,7296}]'),(1004041653,16,3,8788260,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,389139},{4,4,9728}]'),(1004041663,16,3,9347325,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,486424},{4,4,12161}]'),(1005000100,1,0,475,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1005000110,1,0,1423,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1005000120,1,0,3592,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1005000131,1,1,6529,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1005000132,1,2,9025,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1005000141,1,1,15565,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1005000142,1,2,22037,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1005000143,1,3,28877,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1005000153,1,3,38884,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1005000163,1,3,51798,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1005000200,2,0,825,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1005000210,2,0,2199,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1005000220,2,0,5827,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1005000231,2,1,10222,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1005000232,2,2,14702,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1005000241,2,1,26320,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1005000242,2,2,39144,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1005000243,2,3,56652,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1005000253,2,3,94878,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1005000263,2,3,152995,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1005000300,3,0,1970,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1005000310,3,0,4342,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1005000320,3,0,10163,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1005000331,3,1,16969,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1005000332,3,2,23781,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1005000341,3,1,41668,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1005000342,3,2,61960,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1005000343,3,3,88876,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1005000353,3,3,139323,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1005000363,3,3,222372,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1005000400,4,0,3965,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1005000410,4,0,7744,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1005000420,4,0,17371,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1005000431,4,1,27736,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1005000432,4,2,37152,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1005000441,4,1,64270,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1005000442,4,2,92490,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1005000443,4,3,129354,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1005000453,4,3,204765,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1005000463,4,3,323440,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1005000500,5,0,6890,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1005000510,5,0,12835,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1005000520,5,0,27905,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1005000531,5,1,42837,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1005000532,5,2,55989,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1005000541,5,1,95741,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1005000542,5,2,135229,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1005000543,5,3,187681,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1005000553,5,3,297215,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1005000563,5,3,465987,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1005000600,6,0,10745,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1005000610,6,0,19620,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1005000620,6,0,42136,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1005000631,6,1,63691,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1005000632,6,2,82095,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1005000641,6,1,139639,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1005000642,6,2,194911,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,1415},{4,3,708}]'),(1005000643,6,3,268327,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,3387},{4,3,1694}]'),(1005000653,6,3,425039,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,4517},{4,3,2258}]'),(1005000663,6,3,663530,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,5645},{4,3,2823}]'),(1005000700,7,0,15645,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1005000710,7,0,28365,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1005000720,7,0,60569,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1005000731,7,1,91085,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1005000732,7,2,116865,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1005000741,7,1,198403,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1005000742,7,2,275803,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,2201},{4,3,1101}]'),(1005000743,7,3,378583,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,4792},{4,3,2397}]'),(1005000753,7,3,599728,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,6391},{4,3,3195}]'),(1005000763,7,3,909057,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,7988},{4,3,3993}]'),(1005000800,8,0,21580,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1005000810,8,0,39230,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1005000820,8,0,83979,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1005000831,8,1,126526,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1005000832,8,2,162610,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1005000841,8,1,276248,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1005000842,8,2,384604,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,2321},{4,3,1160}]'),(1005000843,8,3,528484,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,4850},{4,3,2424}]'),(1005000853,8,3,821129,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,6465},{4,3,3233}]'),(1005000863,8,3,1225201,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,8082},{4,3,4041}]'),(1005000900,9,0,28645,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1005000910,9,0,52565,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1005000920,9,0,113259,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1005000931,9,1,171900,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1005000932,9,2,222424,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1005000941,9,1,378908,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1005000942,9,2,530612,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,2437},{4,3,1219}]'),(1005000943,9,3,720968,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,4855},{4,3,2428}]'),(1005000953,9,3,1103178,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,6473},{4,3,3237}]'),(1005000963,9,3,1635699,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,8091},{4,3,4046}]'),(1005001000,10,0,36875,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1005001010,10,0,68759,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1005001020,10,0,149773,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1005001031,10,1,229901,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1005001032,10,2,300645,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1005001041,10,1,514341,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1005001042,10,2,718189,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,2564},{4,3,1282}]'),(1005001043,10,3,966469,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,4909},{4,3,2455}]'),(1005001053,10,3,1466067,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,6545},{4,3,3273}]'),(1005001063,10,3,2159054,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,8182},{4,3,4091}]'),(1005001100,11,0,46345,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1005001110,11,0,88325,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1005001120,11,0,195234,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1005001131,11,1,304242,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1005001132,11,2,403286,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1005001141,11,1,686941,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1005001142,11,2,956489,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,2702},{4,3,1351}]'),(1005001143,11,3,1282049,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,5006},{4,3,2503}]'),(1005001153,11,3,1928784,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,6674},{4,3,3337}]'),(1005001163,11,3,2820206,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,8342},{4,3,4171}]'),(1005001200,12,0,57070,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1005001210,12,0,111977,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1005001220,12,0,252041,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1005001231,12,1,399984,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1005001232,12,2,533616,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1005001241,12,1,904267,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1005001242,12,2,1260619,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,2843},{4,3,1422}]'),(1005001243,12,3,1685887,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,5115},{4,3,2557}]'),(1005001253,12,3,2513889,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,6819},{4,3,3409}]'),(1005001263,12,3,3649698,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,8524},{4,3,4262}]'),(1005001300,13,0,69160,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1005001310,13,0,140632,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1005001320,13,0,323480,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1005001331,13,1,519619,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1005001332,13,2,697363,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1005001341,13,1,1179123,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1005001342,13,2,1648091,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,2992},{4,3,1496}]'),(1005001343,13,3,2199179,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,5252},{4,3,2626}]'),(1005001353,13,3,3248991,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,7002},{4,3,3501}]'),(1005001363,13,3,4682799,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,8752},{4,3,4376}]'),(1005001400,14,0,82615,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1005001410,14,0,175558,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1005001420,14,0,410721,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1005001431,14,1,668084,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1005001432,14,2,904112,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1005001441,14,1,1526686,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1005001442,14,2,2139278,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,3137},{4,3,1569}]'),(1005001443,14,3,2847374,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,5393},{4,3,2696}]'),(1005001453,14,3,4166319,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,7190},{4,3,3595}]'),(1005001463,14,3,5959985,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,8988},{4,3,4494}]'),(1005001500,15,0,97500,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1005001510,15,0,216978,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1005001520,15,0,517247,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1005001531,15,1,853615,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1005001532,15,2,1165323,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1005001541,15,1,1964636,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1005001542,15,2,2758440,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,3294},{4,3,1647}]'),(1005001543,15,3,3660552,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,5662},{4,3,2831}]'),(1005001553,15,3,5303244,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,7549},{4,3,3775}]'),(1005001563,15,3,7527000,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,9437},{4,3,4718}]'),(1005001600,16,0,6665880,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1005001610,16,0,6722820,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1005001620,16,0,6862895,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1005001631,16,1,6931230,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1005001632,16,2,6931230,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1005001641,16,1,7121420,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1005001642,16,2,7121420,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,3459},{4,3,1729}]'),(1005001643,16,3,7121420,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,5945},{4,3,2972}]'),(1005001653,16,3,7463060,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,7927},{4,3,3963}]'),(1005001663,16,3,7690845,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,9909},{4,3,4954}]'),(1006010100,1,0,787,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006010110,1,0,1889,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006010120,1,0,4427,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006010131,1,1,7551,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006010132,1,2,10047,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006010141,1,1,17120,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006010142,1,2,23592,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006010143,1,3,30432,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006010153,1,3,41325,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006010163,1,3,54888,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006010200,2,0,1359,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006010210,2,0,2990,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006010220,2,0,7254,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006010231,2,1,11974,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006010232,2,2,16454,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006010241,2,1,28950,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006010242,2,2,41774,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006010243,2,3,59282,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006010253,2,3,99094,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006010263,2,3,158259,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006010300,3,0,3238,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006010310,3,0,6229,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006010320,3,0,13595,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006010331,3,1,21174,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006010332,3,2,27986,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006010341,3,1,47953,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006010342,3,2,68245,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006010343,3,3,95161,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006010353,3,3,149382,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006010363,3,3,234938,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006010400,4,0,6503,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006010410,4,0,11538,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006010420,4,0,24269,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006010431,4,1,36150,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006010432,4,2,45566,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006010441,4,1,76894,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006010442,4,2,105114,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006010443,4,3,141978,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006010453,4,3,225027,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006010463,4,3,348733,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006010500,5,0,11257,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006010510,5,0,19397,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006010520,5,0,39868,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006010531,5,1,57419,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006010532,5,2,70571,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006010541,5,1,117644,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006010542,5,2,157132,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006010543,5,3,209584,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006010553,5,3,332262,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006010563,5,3,509792,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006010600,6,0,17603,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006010610,6,0,29891,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006010620,6,0,60810,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006010631,6,1,86457,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006010632,6,2,104861,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006010641,6,1,173847,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006010642,6,2,229119,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,46323},{4,4,1158}]'),(1006010643,6,3,302535,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,110868},{4,4,2771}]'),(1006010653,6,3,479794,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,147822},{4,4,3696}]'),(1006010663,6,3,731971,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,184780},{4,4,4620}]'),(1006010700,7,0,25594,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006010710,7,0,43266,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006010720,7,0,87741,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006010731,7,1,124224,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006010732,7,2,150004,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006010741,7,1,248150,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006010742,7,2,325550,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,72050},{4,4,1801}]'),(1006010743,7,3,428330,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,156857},{4,4,3921}]'),(1006010753,7,3,679328,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,209142},{4,4,5229}]'),(1006010763,7,3,1008555,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,261426},{4,4,6536}]'),(1006010800,8,0,35310,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006010810,8,0,59838,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006010820,8,0,121456,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006010831,8,1,172239,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006010832,8,2,208323,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006010841,8,1,344929,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006010842,8,2,453285,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,75963},{4,4,1899}]'),(1006010843,8,3,597165,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,158699},{4,4,3968}]'),(1006010853,8,3,931000,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,211598},{4,4,5290}]'),(1006010863,8,3,1362558,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,264498},{4,4,6613}]'),(1006010900,9,0,46872,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006010910,9,0,79920,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006010920,9,0,163041,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006010931,9,1,232585,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006010932,9,2,283109,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006010941,9,1,470052,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006010942,9,2,621756,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,79744},{4,4,1994}]'),(1006010943,9,3,812112,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,158887},{4,4,3972}]'),(1006010953,9,3,1249007,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,211848},{4,4,5296}]'),(1006010963,9,3,1818012,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,264811},{4,4,6621}]'),(1006011000,10,0,60339,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006011010,10,0,103978,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006011020,10,0,213853,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006011031,10,1,308070,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006011032,10,2,378814,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006011041,10,1,631682,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006011042,10,2,835530,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,83902},{4,4,2097}]'),(1006011043,10,3,1083810,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,160662},{4,4,4016}]'),(1006011053,10,3,1653846,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,214216},{4,4,5356}]'),(1006011063,10,3,2393761,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,267770},{4,4,6694}]'),(1006011100,11,0,75841,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006011110,11,0,132569,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006011120,11,0,275747,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006011131,11,1,402454,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006011132,11,2,501498,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006011141,11,1,834370,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006011142,11,2,1103918,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,88425},{4,4,2211}]'),(1006011143,11,3,1429478,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,163814},{4,4,4095}]'),(1006011153,11,3,2164696,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,218419},{4,4,5460}]'),(1006011163,11,3,3115085,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,273024},{4,4,6825}]'),(1006011200,12,0,93405,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006011210,12,0,166472,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006011220,12,0,351212,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006011231,12,1,520938,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006011232,12,2,654570,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006011241,12,1,1085877,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006011242,12,2,1442229,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,93044},{4,4,2326}]'),(1006011243,12,3,1867497,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,167378},{4,4,4184}]'),(1006011253,12,3,2804485,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,223172},{4,4,5579}]'),(1006011263,12,3,4012939,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,278965},{4,4,6974}]'),(1006011300,13,0,113160,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006011310,13,0,206620,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006011320,13,0,443629,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006011331,13,1,666154,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006011332,13,2,843898,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006011341,13,1,1399144,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006011342,13,2,1868112,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,97910},{4,4,2448}]'),(1006011343,13,3,2419200,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,171866},{4,4,4296}]'),(1006011353,13,3,3601033,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,229154},{4,4,5729}]'),(1006011363,13,3,5122861,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,286443},{4,4,7161}]'),(1006011400,14,0,135185,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006011410,14,0,254400,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006011420,14,0,554235,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006011431,14,1,843134,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006011432,14,2,1079162,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006011441,14,1,1789529,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006011442,14,2,2402121,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,102675},{4,4,2567}]'),(1006011443,14,3,3110217,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,176479},{4,4,4412}]'),(1006011453,14,3,4586867,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,235306},{4,4,5883}]'),(1006011463,14,3,6485647,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,294132},{4,4,7353}]'),(1006011500,15,0,159557,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006011510,15,0,310051,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006011520,15,0,686633,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006011531,15,1,1060235,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006011532,15,2,1371943,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006011541,15,1,2274870,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006011542,15,2,3068674,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,107809},{4,4,2695}]'),(1006011543,15,3,3970786,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,185304},{4,4,4633}]'),(1006011553,15,3,5799599,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,247073},{4,4,6177}]'),(1006011563,15,3,8147443,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,308841},{4,4,7721}]'),(1006011600,16,0,6738355,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006011610,16,0,6831520,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006011620,16,0,7060751,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006011631,16,1,7172559,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006011632,16,2,7172559,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006011641,16,1,7483775,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006011642,16,2,7483775,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,113199},{4,4,2830}]'),(1006011643,16,3,7483775,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,194569},{4,4,4864}]'),(1006011653,16,3,8042840,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,259426},{4,4,6486}]'),(1006011663,16,3,8415550,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,324282},{4,4,8107}]'),(1006020100,1,0,787,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006020110,1,0,1889,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006020120,1,0,4427,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006020131,1,1,7551,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006020132,1,2,10047,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006020141,1,1,17120,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006020142,1,2,23592,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006020143,1,3,30432,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006020153,1,3,41325,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006020163,1,3,54888,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006020200,2,0,1359,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006020210,2,0,2990,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006020220,2,0,7254,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006020231,2,1,11974,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006020232,2,2,16454,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006020241,2,1,28950,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006020242,2,2,41774,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006020243,2,3,59282,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006020253,2,3,99094,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006020263,2,3,158259,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006020300,3,0,3238,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006020310,3,0,6229,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006020320,3,0,13595,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006020331,3,1,21174,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006020332,3,2,27986,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006020341,3,1,47953,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006020342,3,2,68245,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006020343,3,3,95161,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006020353,3,3,149382,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006020363,3,3,234938,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006020400,4,0,6503,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006020410,4,0,11538,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006020420,4,0,24269,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006020431,4,1,36150,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006020432,4,2,45566,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006020441,4,1,76894,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006020442,4,2,105114,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006020443,4,3,141978,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006020453,4,3,225027,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006020463,4,3,348733,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006020500,5,0,11257,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006020510,5,0,19397,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006020520,5,0,39868,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006020531,5,1,57419,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006020532,5,2,70571,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006020541,5,1,117644,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006020542,5,2,157132,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006020543,5,3,209584,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006020553,5,3,332262,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006020563,5,3,509792,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006020600,6,0,17603,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006020610,6,0,29891,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006020620,6,0,60810,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006020631,6,1,86457,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006020632,6,2,104861,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006020641,6,1,173847,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006020642,6,2,229119,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,46323},{4,4,1158}]'),(1006020643,6,3,302535,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,110868},{4,4,2771}]'),(1006020653,6,3,479794,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,147822},{4,4,3696}]'),(1006020663,6,3,731971,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,184780},{4,4,4620}]'),(1006020700,7,0,25594,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006020710,7,0,43266,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006020720,7,0,87741,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006020731,7,1,124224,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006020732,7,2,150004,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006020741,7,1,248150,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006020742,7,2,325550,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,72050},{4,4,1801}]'),(1006020743,7,3,428330,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,156857},{4,4,3921}]'),(1006020753,7,3,679328,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,209142},{4,4,5229}]'),(1006020763,7,3,1008555,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,261426},{4,4,6536}]'),(1006020800,8,0,35310,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006020810,8,0,59838,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006020820,8,0,121456,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006020831,8,1,172239,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006020832,8,2,208323,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006020841,8,1,344929,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006020842,8,2,453285,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,75963},{4,4,1899}]'),(1006020843,8,3,597165,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,158699},{4,4,3968}]'),(1006020853,8,3,931000,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,211598},{4,4,5290}]'),(1006020863,8,3,1362558,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,264498},{4,4,6613}]'),(1006020900,9,0,46872,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006020910,9,0,79920,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006020920,9,0,163041,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006020931,9,1,232585,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006020932,9,2,283109,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006020941,9,1,470052,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006020942,9,2,621756,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,79744},{4,4,1994}]'),(1006020943,9,3,812112,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,158887},{4,4,3972}]'),(1006020953,9,3,1249007,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,211848},{4,4,5296}]'),(1006020963,9,3,1818012,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,264811},{4,4,6621}]'),(1006021000,10,0,60339,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006021010,10,0,103978,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006021020,10,0,213853,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006021031,10,1,308070,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006021032,10,2,378814,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006021041,10,1,631682,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006021042,10,2,835530,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,83902},{4,4,2097}]'),(1006021043,10,3,1083810,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,160662},{4,4,4016}]'),(1006021053,10,3,1653846,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,214216},{4,4,5356}]'),(1006021063,10,3,2393761,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,267770},{4,4,6694}]'),(1006021100,11,0,75841,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006021110,11,0,132569,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006021120,11,0,275747,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006021131,11,1,402454,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006021132,11,2,501498,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006021141,11,1,834370,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006021142,11,2,1103918,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,88425},{4,4,2211}]'),(1006021143,11,3,1429478,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,163814},{4,4,4095}]'),(1006021153,11,3,2164696,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,218419},{4,4,5460}]'),(1006021163,11,3,3115085,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,273024},{4,4,6825}]'),(1006021200,12,0,93405,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006021210,12,0,166472,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006021220,12,0,351212,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006021231,12,1,520938,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006021232,12,2,654570,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006021241,12,1,1085877,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006021242,12,2,1442229,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,93044},{4,4,2326}]'),(1006021243,12,3,1867497,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,167378},{4,4,4184}]'),(1006021253,12,3,2804485,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,223172},{4,4,5579}]'),(1006021263,12,3,4012939,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,278965},{4,4,6974}]'),(1006021300,13,0,113160,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006021310,13,0,206620,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006021320,13,0,443629,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006021331,13,1,666154,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006021332,13,2,843898,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006021341,13,1,1399144,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006021342,13,2,1868112,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,97910},{4,4,2448}]'),(1006021343,13,3,2419200,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,171866},{4,4,4296}]'),(1006021353,13,3,3601033,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,229154},{4,4,5729}]'),(1006021363,13,3,5122861,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,286443},{4,4,7161}]'),(1006021400,14,0,135185,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006021410,14,0,254400,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006021420,14,0,554235,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006021431,14,1,843134,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006021432,14,2,1079162,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006021441,14,1,1789529,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006021442,14,2,2402121,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,102675},{4,4,2567}]'),(1006021443,14,3,3110217,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,176479},{4,4,4412}]'),(1006021453,14,3,4586867,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,235306},{4,4,5883}]'),(1006021463,14,3,6485647,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,294132},{4,4,7353}]'),(1006021500,15,0,159557,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006021510,15,0,310051,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006021520,15,0,686633,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006021531,15,1,1060235,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006021532,15,2,1371943,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006021541,15,1,2274870,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006021542,15,2,3068674,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,107809},{4,4,2695}]'),(1006021543,15,3,3970786,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,185304},{4,4,4633}]'),(1006021553,15,3,5799599,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,247073},{4,4,6177}]'),(1006021563,15,3,8147443,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,308841},{4,4,7721}]'),(1006021600,16,0,6738355,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006021610,16,0,6831520,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006021620,16,0,7060751,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006021631,16,1,7172559,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006021632,16,2,7172559,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006021641,16,1,7483775,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006021642,16,2,7483775,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,113199},{4,4,2830}]'),(1006021643,16,3,7483775,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,194569},{4,4,4864}]'),(1006021653,16,3,8042840,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,259426},{4,4,6486}]'),(1006021663,16,3,8415550,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,324282},{4,4,8107}]'),(1006030100,1,0,787,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006030110,1,0,1889,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006030120,1,0,4427,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006030131,1,1,7551,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006030132,1,2,10047,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006030141,1,1,17120,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006030142,1,2,23592,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006030143,1,3,30432,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006030153,1,3,41325,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006030163,1,3,54888,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006030200,2,0,1359,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006030210,2,0,2990,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006030220,2,0,7254,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006030231,2,1,11974,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006030232,2,2,16454,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006030241,2,1,28950,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006030242,2,2,41774,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006030243,2,3,59282,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006030253,2,3,99094,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006030263,2,3,158259,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006030300,3,0,3238,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006030310,3,0,6229,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006030320,3,0,13595,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006030331,3,1,21174,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006030332,3,2,27986,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006030341,3,1,47953,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006030342,3,2,68245,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006030343,3,3,95161,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006030353,3,3,149382,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006030363,3,3,234938,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006030400,4,0,6503,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006030410,4,0,11538,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006030420,4,0,24269,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006030431,4,1,36150,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006030432,4,2,45566,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006030441,4,1,76894,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006030442,4,2,105114,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006030443,4,3,141978,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006030453,4,3,225027,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006030463,4,3,348733,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006030500,5,0,11257,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006030510,5,0,19397,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006030520,5,0,39868,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006030531,5,1,57419,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006030532,5,2,70571,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006030541,5,1,117644,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006030542,5,2,157132,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006030543,5,3,209584,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006030553,5,3,332262,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006030563,5,3,509792,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006030600,6,0,17603,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006030610,6,0,29891,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006030620,6,0,60810,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006030631,6,1,86457,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006030632,6,2,104861,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006030641,6,1,173847,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006030642,6,2,229119,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,46323},{4,4,1158}]'),(1006030643,6,3,302535,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,110868},{4,4,2771}]'),(1006030653,6,3,479794,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,147822},{4,4,3696}]'),(1006030663,6,3,731971,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,184780},{4,4,4620}]'),(1006030700,7,0,25594,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006030710,7,0,43266,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006030720,7,0,87741,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006030731,7,1,124224,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006030732,7,2,150004,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006030741,7,1,248150,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006030742,7,2,325550,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,72050},{4,4,1801}]'),(1006030743,7,3,428330,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,156857},{4,4,3921}]'),(1006030753,7,3,679328,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,209142},{4,4,5229}]'),(1006030763,7,3,1008555,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,261426},{4,4,6536}]'),(1006030800,8,0,35310,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006030810,8,0,59838,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006030820,8,0,121456,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006030831,8,1,172239,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006030832,8,2,208323,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006030841,8,1,344929,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006030842,8,2,453285,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,75963},{4,4,1899}]'),(1006030843,8,3,597165,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,158699},{4,4,3968}]'),(1006030853,8,3,931000,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,211598},{4,4,5290}]'),(1006030863,8,3,1362558,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,264498},{4,4,6613}]'),(1006030900,9,0,46872,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006030910,9,0,79920,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006030920,9,0,163041,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006030931,9,1,232585,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006030932,9,2,283109,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006030941,9,1,470052,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006030942,9,2,621756,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,79744},{4,4,1994}]'),(1006030943,9,3,812112,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,158887},{4,4,3972}]'),(1006030953,9,3,1249007,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,211848},{4,4,5296}]'),(1006030963,9,3,1818012,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,264811},{4,4,6621}]'),(1006031000,10,0,60339,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006031010,10,0,103978,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006031020,10,0,213853,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006031031,10,1,308070,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006031032,10,2,378814,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006031041,10,1,631682,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006031042,10,2,835530,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,83902},{4,4,2097}]'),(1006031043,10,3,1083810,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,160662},{4,4,4016}]'),(1006031053,10,3,1653846,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,214216},{4,4,5356}]'),(1006031063,10,3,2393761,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,267770},{4,4,6694}]'),(1006031100,11,0,75841,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006031110,11,0,132569,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006031120,11,0,275747,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006031131,11,1,402454,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006031132,11,2,501498,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006031141,11,1,834370,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006031142,11,2,1103918,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,88425},{4,4,2211}]'),(1006031143,11,3,1429478,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,163814},{4,4,4095}]'),(1006031153,11,3,2164696,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,218419},{4,4,5460}]'),(1006031163,11,3,3115085,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,273024},{4,4,6825}]'),(1006031200,12,0,93405,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006031210,12,0,166472,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006031220,12,0,351212,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006031231,12,1,520938,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006031232,12,2,654570,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006031241,12,1,1085877,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006031242,12,2,1442229,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,93044},{4,4,2326}]'),(1006031243,12,3,1867497,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,167378},{4,4,4184}]'),(1006031253,12,3,2804485,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,223172},{4,4,5579}]'),(1006031263,12,3,4012939,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,278965},{4,4,6974}]'),(1006031300,13,0,113160,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006031310,13,0,206620,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006031320,13,0,443629,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006031331,13,1,666154,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006031332,13,2,843898,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006031341,13,1,1399144,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006031342,13,2,1868112,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,97910},{4,4,2448}]'),(1006031343,13,3,2419200,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,171866},{4,4,4296}]'),(1006031353,13,3,3601033,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,229154},{4,4,5729}]'),(1006031363,13,3,5122861,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,286443},{4,4,7161}]'),(1006031400,14,0,135185,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006031410,14,0,254400,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006031420,14,0,554235,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006031431,14,1,843134,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006031432,14,2,1079162,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006031441,14,1,1789529,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006031442,14,2,2402121,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,102675},{4,4,2567}]'),(1006031443,14,3,3110217,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,176479},{4,4,4412}]'),(1006031453,14,3,4586867,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,235306},{4,4,5883}]'),(1006031463,14,3,6485647,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,294132},{4,4,7353}]'),(1006031500,15,0,159557,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006031510,15,0,310051,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006031520,15,0,686633,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006031531,15,1,1060235,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006031532,15,2,1371943,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006031541,15,1,2274870,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006031542,15,2,3068674,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,107809},{4,4,2695}]'),(1006031543,15,3,3970786,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,185304},{4,4,4633}]'),(1006031553,15,3,5799599,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,247073},{4,4,6177}]'),(1006031563,15,3,8147443,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,308841},{4,4,7721}]'),(1006031600,16,0,6738355,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006031610,16,0,6831520,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006031620,16,0,7060751,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006031631,16,1,7172559,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006031632,16,2,7172559,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006031641,16,1,7483775,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006031642,16,2,7483775,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,113199},{4,4,2830}]'),(1006031643,16,3,7483775,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,194569},{4,4,4864}]'),(1006031653,16,3,8042840,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,259426},{4,4,6486}]'),(1006031663,16,3,8415550,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,324282},{4,4,8107}]'),(1006040100,1,0,787,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006040110,1,0,1889,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006040120,1,0,4427,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006040131,1,1,7551,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006040132,1,2,10047,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006040141,1,1,17120,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006040142,1,2,23592,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006040143,1,3,30432,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006040153,1,3,41325,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006040163,1,3,54888,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006040200,2,0,1359,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006040210,2,0,2990,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006040220,2,0,7254,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006040231,2,1,11974,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006040232,2,2,16454,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006040241,2,1,28950,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006040242,2,2,41774,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006040243,2,3,59282,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006040253,2,3,99094,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006040263,2,3,158259,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006040300,3,0,3238,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006040310,3,0,6229,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006040320,3,0,13595,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006040331,3,1,21174,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006040332,3,2,27986,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006040341,3,1,47953,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006040342,3,2,68245,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006040343,3,3,95161,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006040353,3,3,149382,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006040363,3,3,234938,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006040400,4,0,6503,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006040410,4,0,11538,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006040420,4,0,24269,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006040431,4,1,36150,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006040432,4,2,45566,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006040441,4,1,76894,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006040442,4,2,105114,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006040443,4,3,141978,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006040453,4,3,225027,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006040463,4,3,348733,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006040500,5,0,11257,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006040510,5,0,19397,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006040520,5,0,39868,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006040531,5,1,57419,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006040532,5,2,70571,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006040541,5,1,117644,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006040542,5,2,157132,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006040543,5,3,209584,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006040553,5,3,332262,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006040563,5,3,509792,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006040600,6,0,17603,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006040610,6,0,29891,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006040620,6,0,60810,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006040631,6,1,86457,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006040632,6,2,104861,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006040641,6,1,173847,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006040642,6,2,229119,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,46323},{4,4,1158}]'),(1006040643,6,3,302535,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,110868},{4,4,2771}]'),(1006040653,6,3,479794,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,147822},{4,4,3696}]'),(1006040663,6,3,731971,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,184780},{4,4,4620}]'),(1006040700,7,0,25594,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006040710,7,0,43266,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006040720,7,0,87741,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006040731,7,1,124224,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006040732,7,2,150004,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006040741,7,1,248150,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006040742,7,2,325550,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,72050},{4,4,1801}]'),(1006040743,7,3,428330,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,156857},{4,4,3921}]'),(1006040753,7,3,679328,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,209142},{4,4,5229}]'),(1006040763,7,3,1008555,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,261426},{4,4,6536}]'),(1006040800,8,0,35310,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006040810,8,0,59838,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006040820,8,0,121456,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006040831,8,1,172239,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006040832,8,2,208323,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006040841,8,1,344929,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006040842,8,2,453285,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,75963},{4,4,1899}]'),(1006040843,8,3,597165,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,158699},{4,4,3968}]'),(1006040853,8,3,931000,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,211598},{4,4,5290}]'),(1006040863,8,3,1362558,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,264498},{4,4,6613}]'),(1006040900,9,0,46872,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006040910,9,0,79920,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006040920,9,0,163041,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006040931,9,1,232585,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006040932,9,2,283109,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006040941,9,1,470052,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006040942,9,2,621756,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,79744},{4,4,1994}]'),(1006040943,9,3,812112,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,158887},{4,4,3972}]'),(1006040953,9,3,1249007,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,211848},{4,4,5296}]'),(1006040963,9,3,1818012,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,264811},{4,4,6621}]'),(1006041000,10,0,60339,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006041010,10,0,103978,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006041020,10,0,213853,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006041031,10,1,308070,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006041032,10,2,378814,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006041041,10,1,631682,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006041042,10,2,835530,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,83902},{4,4,2097}]'),(1006041043,10,3,1083810,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,160662},{4,4,4016}]'),(1006041053,10,3,1653846,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,214216},{4,4,5356}]'),(1006041063,10,3,2393761,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,267770},{4,4,6694}]'),(1006041100,11,0,75841,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006041110,11,0,132569,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006041120,11,0,275747,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006041131,11,1,402454,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006041132,11,2,501498,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006041141,11,1,834370,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006041142,11,2,1103918,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,88425},{4,4,2211}]'),(1006041143,11,3,1429478,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,163814},{4,4,4095}]'),(1006041153,11,3,2164696,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,218419},{4,4,5460}]'),(1006041163,11,3,3115085,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,273024},{4,4,6825}]'),(1006041200,12,0,93405,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006041210,12,0,166472,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006041220,12,0,351212,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006041231,12,1,520938,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006041232,12,2,654570,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006041241,12,1,1085877,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006041242,12,2,1442229,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,93044},{4,4,2326}]'),(1006041243,12,3,1867497,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,167378},{4,4,4184}]'),(1006041253,12,3,2804485,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,223172},{4,4,5579}]'),(1006041263,12,3,4012939,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,278965},{4,4,6974}]'),(1006041300,13,0,113160,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006041310,13,0,206620,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006041320,13,0,443629,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006041331,13,1,666154,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006041332,13,2,843898,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006041341,13,1,1399144,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006041342,13,2,1868112,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,97910},{4,4,2448}]'),(1006041343,13,3,2419200,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,171866},{4,4,4296}]'),(1006041353,13,3,3601033,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,229154},{4,4,5729}]'),(1006041363,13,3,5122861,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,286443},{4,4,7161}]'),(1006041400,14,0,135185,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006041410,14,0,254400,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006041420,14,0,554235,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006041431,14,1,843134,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006041432,14,2,1079162,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006041441,14,1,1789529,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006041442,14,2,2402121,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,102675},{4,4,2567}]'),(1006041443,14,3,3110217,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,176479},{4,4,4412}]'),(1006041453,14,3,4586867,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,235306},{4,4,5883}]'),(1006041463,14,3,6485647,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,294132},{4,4,7353}]'),(1006041500,15,0,159557,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006041510,15,0,310051,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006041520,15,0,686633,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006041531,15,1,1060235,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006041532,15,2,1371943,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006041541,15,1,2274870,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006041542,15,2,3068674,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,107809},{4,4,2695}]'),(1006041543,15,3,3970786,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,185304},{4,4,4633}]'),(1006041553,15,3,5799599,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,247073},{4,4,6177}]'),(1006041563,15,3,8147443,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,308841},{4,4,7721}]'),(1006041600,16,0,6738355,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006041610,16,0,6831520,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1006041620,16,0,7060751,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1006041631,16,1,7172559,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006041632,16,2,7172559,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1006041641,16,1,7483775,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1006041642,16,2,7483775,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,113199},{4,4,2830}]'),(1006041643,16,3,7483775,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,194569},{4,4,4864}]'),(1006041653,16,3,8042840,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,259426},{4,4,6486}]'),(1006041663,16,3,8415550,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,324282},{4,4,8107}]'),(1007010100,1,0,975,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007010110,1,0,2158,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007010120,1,0,4917,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007010131,1,1,8134,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007010132,1,2,10630,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007010141,1,1,17990,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007010142,1,2,24462,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007010143,1,3,31302,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007010153,1,3,42739,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007010163,1,3,56653,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007010200,2,0,1645,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007010210,2,0,3434,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007010220,2,0,8082,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007010231,2,1,12997,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007010232,2,2,17477,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007010241,2,1,30455,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007010242,2,2,43279,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007010243,2,3,60787,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007010253,2,3,101508,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007010263,2,3,161295,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007010300,3,0,3945,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007010310,3,0,7287,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007010320,3,0,15558,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007010331,3,1,23554,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007010332,3,2,30366,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007010341,3,1,51528,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007010342,3,2,71820,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007010343,3,3,98736,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007010353,3,3,155118,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007010363,3,3,242107,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007010400,4,0,7950,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007010410,4,0,13699,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007010420,4,0,28226,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007010431,4,1,40971,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007010432,4,2,50387,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007010441,4,1,84140,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007010442,4,2,112360,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007010443,4,3,149224,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007010453,4,3,236570,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007010463,4,3,363175,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007010500,5,0,13780,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007010510,5,0,23150,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007010520,5,0,46690,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007010531,5,1,65757,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007010532,5,2,78909,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007010541,5,1,130171,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007010542,5,2,169659,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007010543,5,3,222111,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007010553,5,3,352290,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007010563,5,3,534822,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007010600,6,0,21515,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007010610,6,0,35760,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007010620,6,0,71471,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007010631,6,1,99486,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007010632,6,2,117890,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007010641,6,1,193394,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007010642,6,2,248666,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,2830},{4,3,1415}]'),(1007010643,6,3,322082,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,6774},{4,3,3387}]'),(1007010653,6,3,511059,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,9033},{4,3,4517}]'),(1007010663,6,3,771060,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,11292},{4,3,5645}]'),(1007010700,7,0,31265,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007010710,7,0,51810,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007010720,7,0,103249,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007010731,7,1,143150,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007010732,7,2,168930,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007010741,7,1,276573,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007010742,7,2,353973,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,4403},{4,3,2201}]'),(1007010743,7,3,456753,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,9586},{4,3,4792}]'),(1007010753,7,3,724813,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,12780},{4,3,6391}]'),(1007010763,7,3,1065427,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,15977},{4,3,7988}]'),(1007010800,8,0,43160,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007010810,8,0,71600,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007010820,8,0,142889,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007010831,8,1,198396,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007010832,8,2,234480,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007010841,8,1,384173,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007010842,8,2,492529,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,4642},{4,3,2321}]'),(1007010843,8,3,636409,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,9698},{4,3,4850}]'),(1007010853,8,3,993789,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,12931},{4,3,6465}]'),(1007010863,8,3,1441041,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,16164},{4,3,8082}]'),(1007010900,9,0,57285,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007010910,9,0,95530,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007010920,9,0,191474,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007010931,9,1,267275,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007010932,9,2,317799,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007010941,9,1,522123,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007010942,9,2,673827,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,4873},{4,3,2437}]'),(1007010943,9,3,864183,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,9709},{4,3,4855}]'),(1007010953,9,3,1332343,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,12946},{4,3,6473}]'),(1007010963,9,3,1922174,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,16183},{4,3,8091}]'),(1007011000,10,0,73775,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007011010,10,0,124074,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007011020,10,0,250458,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007011031,10,1,352731,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007011032,10,2,423475,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007011041,10,1,698746,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007011042,10,2,902594,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,5127},{4,3,2564}]'),(1007011043,10,3,1150874,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,9818},{4,3,4909}]'),(1007011053,10,3,1761122,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,13091},{4,3,6545}]'),(1007011063,10,3,2527864,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,16364},{4,3,8182}]'),(1007011100,11,0,92690,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007011110,11,0,157855,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007011120,11,0,321749,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007011131,11,1,458572,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007011132,11,2,557616,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007011141,11,1,918646,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007011142,11,2,1188194,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,5404},{4,3,2702}]'),(1007011143,11,3,1513754,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,10011},{4,3,5006}]'),(1007011153,11,3,2299499,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,13348},{4,3,6674}]'),(1007011163,11,3,3283611,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,16685},{4,3,8342}]'),(1007011200,12,0,114160,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007011210,12,0,197607,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007011220,12,0,407891,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007011231,12,1,590069,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007011232,12,2,723701,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007011241,12,1,1189662,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007011242,12,2,1546014,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,5686},{4,3,2843}]'),(1007011243,12,3,1971282,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,10228},{4,3,5115}]'),(1007011253,12,3,2970539,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,13638},{4,3,6819}]'),(1007011263,12,3,4220503,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,17048},{4,3,8524}]'),(1007011300,13,0,138300,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007011310,13,0,244352,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007011320,13,0,512265,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007011331,13,1,749889,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007011332,13,2,927633,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007011341,13,1,1524883,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007011342,13,2,1993851,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,5983},{4,3,2992}]'),(1007011343,13,3,2544939,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,10503},{4,3,5252}]'),(1007011353,13,3,3802206,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,14004},{4,3,7002}]'),(1007011363,13,3,5374309,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,17505},{4,3,8752}]'),(1007011400,14,0,165230,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007011410,14,0,299473,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007011420,14,0,636251,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007011431,14,1,943164,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007011432,14,2,1179192,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007011441,14,1,1939741,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007011442,14,2,2552333,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,6275},{4,3,3137}]'),(1007011443,14,3,3260429,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,10785},{4,3,5393}]'),(1007011453,14,3,4827174,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,14380},{4,3,7190}]'),(1007011463,14,3,6786050,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,17975},{4,3,8988}]'),(1007011500,15,0,195000,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007011510,15,0,363228,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007011520,15,0,783422,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007011531,15,1,1178290,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007011532,15,2,1489998,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007011541,15,1,2452136,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007011542,15,2,3245940,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,6588},{4,3,3294}]'),(1007011543,15,3,4148052,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,11324},{4,3,5662}]'),(1007011553,15,3,6083244,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,15099},{4,3,7549}]'),(1007011563,15,3,8502000,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,18874},{4,3,9437}]'),(1007011600,16,0,6779760,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007011610,16,0,6893640,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007011620,16,0,7173790,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007011631,16,1,7310465,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007011632,16,2,7310465,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007011641,16,1,7690845,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007011642,16,2,7690845,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,6918},{4,3,3459}]'),(1007011643,16,3,7690845,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,11890},{4,3,5945}]'),(1007011653,16,3,8374145,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,15854},{4,3,7927}]'),(1007011663,16,3,8829665,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,19817},{4,3,9909}]'),(1007020100,1,0,975,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007020110,1,0,2158,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007020120,1,0,4917,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007020131,1,1,8134,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007020132,1,2,10630,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007020141,1,1,17990,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007020142,1,2,24462,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007020143,1,3,31302,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007020153,1,3,42739,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007020163,1,3,56653,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007020200,2,0,1645,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007020210,2,0,3434,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007020220,2,0,8082,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007020231,2,1,12997,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007020232,2,2,17477,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007020241,2,1,30455,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007020242,2,2,43279,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007020243,2,3,60787,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007020253,2,3,101508,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007020263,2,3,161295,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007020300,3,0,3945,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007020310,3,0,7287,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007020320,3,0,15558,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007020331,3,1,23554,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007020332,3,2,30366,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007020341,3,1,51528,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007020342,3,2,71820,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007020343,3,3,98736,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007020353,3,3,155118,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007020363,3,3,242107,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007020400,4,0,7950,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007020410,4,0,13699,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007020420,4,0,28226,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007020431,4,1,40971,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007020432,4,2,50387,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007020441,4,1,84140,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007020442,4,2,112360,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007020443,4,3,149224,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007020453,4,3,236570,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007020463,4,3,363175,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007020500,5,0,13780,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007020510,5,0,23150,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007020520,5,0,46690,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007020531,5,1,65757,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007020532,5,2,78909,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007020541,5,1,130171,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007020542,5,2,169659,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007020543,5,3,222111,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007020553,5,3,352290,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007020563,5,3,534822,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007020600,6,0,21515,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007020610,6,0,35760,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007020620,6,0,71471,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007020631,6,1,99486,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007020632,6,2,117890,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007020641,6,1,193394,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007020642,6,2,248666,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,2830},{4,3,1415}]'),(1007020643,6,3,322082,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,6774},{4,3,3387}]'),(1007020653,6,3,511059,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,9033},{4,3,4517}]'),(1007020663,6,3,771060,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,11292},{4,3,5645}]'),(1007020700,7,0,31265,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007020710,7,0,51810,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007020720,7,0,103249,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007020731,7,1,143150,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007020732,7,2,168930,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007020741,7,1,276573,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007020742,7,2,353973,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,4403},{4,3,2201}]'),(1007020743,7,3,456753,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,9586},{4,3,4792}]'),(1007020753,7,3,724813,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,12780},{4,3,6391}]'),(1007020763,7,3,1065427,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,15977},{4,3,7988}]'),(1007020800,8,0,43160,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007020810,8,0,71600,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007020820,8,0,142889,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007020831,8,1,198396,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007020832,8,2,234480,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007020841,8,1,384173,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007020842,8,2,492529,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,4642},{4,3,2321}]'),(1007020843,8,3,636409,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,9698},{4,3,4850}]'),(1007020853,8,3,993789,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,12931},{4,3,6465}]'),(1007020863,8,3,1441041,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,16164},{4,3,8082}]'),(1007020900,9,0,57285,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007020910,9,0,95530,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007020920,9,0,191474,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007020931,9,1,267275,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007020932,9,2,317799,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007020941,9,1,522123,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007020942,9,2,673827,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,4873},{4,3,2437}]'),(1007020943,9,3,864183,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,9709},{4,3,4855}]'),(1007020953,9,3,1332343,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,12946},{4,3,6473}]'),(1007020963,9,3,1922174,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,16183},{4,3,8091}]'),(1007021000,10,0,73775,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007021010,10,0,124074,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007021020,10,0,250458,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007021031,10,1,352731,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007021032,10,2,423475,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007021041,10,1,698746,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007021042,10,2,902594,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,5127},{4,3,2564}]'),(1007021043,10,3,1150874,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,9818},{4,3,4909}]'),(1007021053,10,3,1761122,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,13091},{4,3,6545}]'),(1007021063,10,3,2527864,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,16364},{4,3,8182}]'),(1007021100,11,0,92690,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007021110,11,0,157855,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007021120,11,0,321749,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007021131,11,1,458572,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007021132,11,2,557616,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007021141,11,1,918646,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007021142,11,2,1188194,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,5404},{4,3,2702}]'),(1007021143,11,3,1513754,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,10011},{4,3,5006}]'),(1007021153,11,3,2299499,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,13348},{4,3,6674}]'),(1007021163,11,3,3283611,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,16685},{4,3,8342}]'),(1007021200,12,0,114160,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007021210,12,0,197607,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007021220,12,0,407891,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007021231,12,1,590069,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007021232,12,2,723701,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007021241,12,1,1189662,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007021242,12,2,1546014,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,5686},{4,3,2843}]'),(1007021243,12,3,1971282,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,10228},{4,3,5115}]'),(1007021253,12,3,2970539,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,13638},{4,3,6819}]'),(1007021263,12,3,4220503,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,17048},{4,3,8524}]'),(1007021300,13,0,138300,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007021310,13,0,244352,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007021320,13,0,512265,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007021331,13,1,749889,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007021332,13,2,927633,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007021341,13,1,1524883,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007021342,13,2,1993851,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,5983},{4,3,2992}]'),(1007021343,13,3,2544939,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,10503},{4,3,5252}]'),(1007021353,13,3,3802206,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,14004},{4,3,7002}]'),(1007021363,13,3,5374309,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,17505},{4,3,8752}]'),(1007021400,14,0,165230,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007021410,14,0,299473,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007021420,14,0,636251,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007021431,14,1,943164,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007021432,14,2,1179192,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007021441,14,1,1939741,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007021442,14,2,2552333,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,6275},{4,3,3137}]'),(1007021443,14,3,3260429,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,10785},{4,3,5393}]'),(1007021453,14,3,4827174,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,14380},{4,3,7190}]'),(1007021463,14,3,6786050,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,17975},{4,3,8988}]'),(1007021500,15,0,195000,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007021510,15,0,363228,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007021520,15,0,783422,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007021531,15,1,1178290,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007021532,15,2,1489998,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007021541,15,1,2452136,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007021542,15,2,3245940,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,6588},{4,3,3294}]'),(1007021543,15,3,4148052,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,11324},{4,3,5662}]'),(1007021553,15,3,6083244,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,15099},{4,3,7549}]'),(1007021563,15,3,8502000,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,18874},{4,3,9437}]'),(1007021600,16,0,6779760,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007021610,16,0,6893640,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007021620,16,0,7173790,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007021631,16,1,7310465,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007021632,16,2,7310465,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007021641,16,1,7690845,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007021642,16,2,7690845,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,6918},{4,3,3459}]'),(1007021643,16,3,7690845,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,11890},{4,3,5945}]'),(1007021653,16,3,8374145,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,15854},{4,3,7927}]'),(1007021663,16,3,8829665,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,19817},{4,3,9909}]'),(1007030100,1,0,975,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007030110,1,0,2158,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007030120,1,0,4917,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007030131,1,1,8134,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007030132,1,2,10630,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007030141,1,1,17990,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007030142,1,2,24462,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007030143,1,3,31302,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007030153,1,3,42739,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007030163,1,3,56653,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007030200,2,0,1645,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007030210,2,0,3434,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007030220,2,0,8082,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007030231,2,1,12997,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007030232,2,2,17477,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007030241,2,1,30455,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007030242,2,2,43279,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007030243,2,3,60787,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007030253,2,3,101508,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007030263,2,3,161295,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007030300,3,0,3945,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007030310,3,0,7287,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007030320,3,0,15558,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007030331,3,1,23554,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007030332,3,2,30366,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007030341,3,1,51528,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007030342,3,2,71820,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007030343,3,3,98736,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007030353,3,3,155118,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007030363,3,3,242107,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007030400,4,0,7950,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007030410,4,0,13699,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007030420,4,0,28226,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007030431,4,1,40971,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007030432,4,2,50387,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007030441,4,1,84140,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007030442,4,2,112360,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007030443,4,3,149224,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007030453,4,3,236570,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007030463,4,3,363175,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007030500,5,0,13780,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007030510,5,0,23150,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007030520,5,0,46690,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007030531,5,1,65757,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007030532,5,2,78909,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007030541,5,1,130171,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007030542,5,2,169659,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007030543,5,3,222111,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007030553,5,3,352290,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007030563,5,3,534822,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007030600,6,0,21515,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007030610,6,0,35760,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007030620,6,0,71471,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007030631,6,1,99486,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007030632,6,2,117890,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007030641,6,1,193394,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007030642,6,2,248666,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,2830},{4,3,1415}]'),(1007030643,6,3,322082,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,6774},{4,3,3387}]'),(1007030653,6,3,511059,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,9033},{4,3,4517}]'),(1007030663,6,3,771060,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,11292},{4,3,5645}]'),(1007030700,7,0,31265,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007030710,7,0,51810,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007030720,7,0,103249,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007030731,7,1,143150,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007030732,7,2,168930,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007030741,7,1,276573,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007030742,7,2,353973,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,4403},{4,3,2201}]'),(1007030743,7,3,456753,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,9586},{4,3,4792}]'),(1007030753,7,3,724813,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,12780},{4,3,6391}]'),(1007030763,7,3,1065427,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,15977},{4,3,7988}]'),(1007030800,8,0,43160,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007030810,8,0,71600,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007030820,8,0,142889,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007030831,8,1,198396,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007030832,8,2,234480,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007030841,8,1,384173,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007030842,8,2,492529,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,4642},{4,3,2321}]'),(1007030843,8,3,636409,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,9698},{4,3,4850}]'),(1007030853,8,3,993789,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,12931},{4,3,6465}]'),(1007030863,8,3,1441041,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,16164},{4,3,8082}]'),(1007030900,9,0,57285,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007030910,9,0,95530,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007030920,9,0,191474,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007030931,9,1,267275,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007030932,9,2,317799,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007030941,9,1,522123,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007030942,9,2,673827,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,4873},{4,3,2437}]'),(1007030943,9,3,864183,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,9709},{4,3,4855}]'),(1007030953,9,3,1332343,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,12946},{4,3,6473}]'),(1007030963,9,3,1922174,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,16183},{4,3,8091}]'),(1007031000,10,0,73775,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007031010,10,0,124074,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007031020,10,0,250458,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007031031,10,1,352731,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007031032,10,2,423475,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007031041,10,1,698746,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007031042,10,2,902594,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,5127},{4,3,2564}]'),(1007031043,10,3,1150874,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,9818},{4,3,4909}]'),(1007031053,10,3,1761122,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,13091},{4,3,6545}]'),(1007031063,10,3,2527864,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,16364},{4,3,8182}]'),(1007031100,11,0,92690,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007031110,11,0,157855,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007031120,11,0,321749,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007031131,11,1,458572,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007031132,11,2,557616,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007031141,11,1,918646,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007031142,11,2,1188194,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,5404},{4,3,2702}]'),(1007031143,11,3,1513754,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,10011},{4,3,5006}]'),(1007031153,11,3,2299499,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,13348},{4,3,6674}]'),(1007031163,11,3,3283611,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,16685},{4,3,8342}]'),(1007031200,12,0,114160,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007031210,12,0,197607,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007031220,12,0,407891,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007031231,12,1,590069,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007031232,12,2,723701,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007031241,12,1,1189662,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007031242,12,2,1546014,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,5686},{4,3,2843}]'),(1007031243,12,3,1971282,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,10228},{4,3,5115}]'),(1007031253,12,3,2970539,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,13638},{4,3,6819}]'),(1007031263,12,3,4220503,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,17048},{4,3,8524}]'),(1007031300,13,0,138300,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007031310,13,0,244352,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007031320,13,0,512265,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007031331,13,1,749889,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007031332,13,2,927633,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007031341,13,1,1524883,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007031342,13,2,1993851,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,5983},{4,3,2992}]'),(1007031343,13,3,2544939,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,10503},{4,3,5252}]'),(1007031353,13,3,3802206,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,14004},{4,3,7002}]'),(1007031363,13,3,5374309,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,17505},{4,3,8752}]'),(1007031400,14,0,165230,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007031410,14,0,299473,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007031420,14,0,636251,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007031431,14,1,943164,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007031432,14,2,1179192,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007031441,14,1,1939741,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007031442,14,2,2552333,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,6275},{4,3,3137}]'),(1007031443,14,3,3260429,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,10785},{4,3,5393}]'),(1007031453,14,3,4827174,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,14380},{4,3,7190}]'),(1007031463,14,3,6786050,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,17975},{4,3,8988}]'),(1007031500,15,0,195000,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007031510,15,0,363228,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007031520,15,0,783422,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007031531,15,1,1178290,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007031532,15,2,1489998,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007031541,15,1,2452136,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007031542,15,2,3245940,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,6588},{4,3,3294}]'),(1007031543,15,3,4148052,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,11324},{4,3,5662}]'),(1007031553,15,3,6083244,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,15099},{4,3,7549}]'),(1007031563,15,3,8502000,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,18874},{4,3,9437}]'),(1007031600,16,0,6779760,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007031610,16,0,6893640,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007031620,16,0,7173790,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007031631,16,1,7310465,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007031632,16,2,7310465,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007031641,16,1,7690845,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007031642,16,2,7690845,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,6918},{4,3,3459}]'),(1007031643,16,3,7690845,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,11890},{4,3,5945}]'),(1007031653,16,3,8374145,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,15854},{4,3,7927}]'),(1007031663,16,3,8829665,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,19817},{4,3,9909}]'),(1007040100,1,0,975,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007040110,1,0,2158,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007040120,1,0,4917,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007040131,1,1,8134,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007040132,1,2,10630,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007040141,1,1,17990,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007040142,1,2,24462,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007040143,1,3,31302,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007040153,1,3,42739,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007040163,1,3,56653,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007040200,2,0,1645,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007040210,2,0,3434,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007040220,2,0,8082,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007040231,2,1,12997,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007040232,2,2,17477,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007040241,2,1,30455,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007040242,2,2,43279,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007040243,2,3,60787,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007040253,2,3,101508,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007040263,2,3,161295,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007040300,3,0,3945,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007040310,3,0,7287,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007040320,3,0,15558,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007040331,3,1,23554,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007040332,3,2,30366,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007040341,3,1,51528,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007040342,3,2,71820,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007040343,3,3,98736,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007040353,3,3,155118,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007040363,3,3,242107,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007040400,4,0,7950,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007040410,4,0,13699,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007040420,4,0,28226,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007040431,4,1,40971,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007040432,4,2,50387,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007040441,4,1,84140,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007040442,4,2,112360,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007040443,4,3,149224,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007040453,4,3,236570,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007040463,4,3,363175,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007040500,5,0,13780,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007040510,5,0,23150,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007040520,5,0,46690,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007040531,5,1,65757,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007040532,5,2,78909,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007040541,5,1,130171,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007040542,5,2,169659,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007040543,5,3,222111,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007040553,5,3,352290,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007040563,5,3,534822,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007040600,6,0,21515,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007040610,6,0,35760,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007040620,6,0,71471,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007040631,6,1,99486,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007040632,6,2,117890,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007040641,6,1,193394,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007040642,6,2,248666,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,2830},{4,3,1415}]'),(1007040643,6,3,322082,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,6774},{4,3,3387}]'),(1007040653,6,3,511059,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,9033},{4,3,4517}]'),(1007040663,6,3,771060,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,11292},{4,3,5645}]'),(1007040700,7,0,31265,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007040710,7,0,51810,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007040720,7,0,103249,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007040731,7,1,143150,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007040732,7,2,168930,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007040741,7,1,276573,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007040742,7,2,353973,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,4403},{4,3,2201}]'),(1007040743,7,3,456753,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,9586},{4,3,4792}]'),(1007040753,7,3,724813,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,12780},{4,3,6391}]'),(1007040763,7,3,1065427,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,15977},{4,3,7988}]'),(1007040800,8,0,43160,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007040810,8,0,71600,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007040820,8,0,142889,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007040831,8,1,198396,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007040832,8,2,234480,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007040841,8,1,384173,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007040842,8,2,492529,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,4642},{4,3,2321}]'),(1007040843,8,3,636409,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,9698},{4,3,4850}]'),(1007040853,8,3,993789,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,12931},{4,3,6465}]'),(1007040863,8,3,1441041,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,16164},{4,3,8082}]'),(1007040900,9,0,57285,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007040910,9,0,95530,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007040920,9,0,191474,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007040931,9,1,267275,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007040932,9,2,317799,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007040941,9,1,522123,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007040942,9,2,673827,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,4873},{4,3,2437}]'),(1007040943,9,3,864183,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,9709},{4,3,4855}]'),(1007040953,9,3,1332343,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,12946},{4,3,6473}]'),(1007040963,9,3,1922174,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,16183},{4,3,8091}]'),(1007041000,10,0,73775,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007041010,10,0,124074,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007041020,10,0,250458,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007041031,10,1,352731,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007041032,10,2,423475,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007041041,10,1,698746,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007041042,10,2,902594,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,5127},{4,3,2564}]'),(1007041043,10,3,1150874,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,9818},{4,3,4909}]'),(1007041053,10,3,1761122,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,13091},{4,3,6545}]'),(1007041063,10,3,2527864,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,16364},{4,3,8182}]'),(1007041100,11,0,92690,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007041110,11,0,157855,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007041120,11,0,321749,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007041131,11,1,458572,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007041132,11,2,557616,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007041141,11,1,918646,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007041142,11,2,1188194,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,5404},{4,3,2702}]'),(1007041143,11,3,1513754,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,10011},{4,3,5006}]'),(1007041153,11,3,2299499,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,13348},{4,3,6674}]'),(1007041163,11,3,3283611,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,16685},{4,3,8342}]'),(1007041200,12,0,114160,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007041210,12,0,197607,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007041220,12,0,407891,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007041231,12,1,590069,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007041232,12,2,723701,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007041241,12,1,1189662,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007041242,12,2,1546014,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,5686},{4,3,2843}]'),(1007041243,12,3,1971282,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,10228},{4,3,5115}]'),(1007041253,12,3,2970539,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,13638},{4,3,6819}]'),(1007041263,12,3,4220503,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,17048},{4,3,8524}]'),(1007041300,13,0,138300,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007041310,13,0,244352,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007041320,13,0,512265,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007041331,13,1,749889,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007041332,13,2,927633,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007041341,13,1,1524883,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007041342,13,2,1993851,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,5983},{4,3,2992}]'),(1007041343,13,3,2544939,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,10503},{4,3,5252}]'),(1007041353,13,3,3802206,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,14004},{4,3,7002}]'),(1007041363,13,3,5374309,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,17505},{4,3,8752}]'),(1007041400,14,0,165230,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007041410,14,0,299473,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007041420,14,0,636251,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007041431,14,1,943164,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007041432,14,2,1179192,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007041441,14,1,1939741,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007041442,14,2,2552333,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,6275},{4,3,3137}]'),(1007041443,14,3,3260429,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,10785},{4,3,5393}]'),(1007041453,14,3,4827174,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,14380},{4,3,7190}]'),(1007041463,14,3,6786050,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,17975},{4,3,8988}]'),(1007041500,15,0,195000,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007041510,15,0,363228,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007041520,15,0,783422,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007041531,15,1,1178290,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007041532,15,2,1489998,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007041541,15,1,2452136,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007041542,15,2,3245940,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,6588},{4,3,3294}]'),(1007041543,15,3,4148052,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,11324},{4,3,5662}]'),(1007041553,15,3,6083244,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,15099},{4,3,7549}]'),(1007041563,15,3,8502000,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,18874},{4,3,9437}]'),(1007041600,16,0,6779760,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007041610,16,0,6893640,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1007041620,16,0,7173790,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1007041631,16,1,7310465,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007041632,16,2,7310465,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1007041641,16,1,7690845,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1007041642,16,2,7690845,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,6918},{4,3,3459}]'),(1007041643,16,3,7690845,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,11890},{4,3,5945}]'),(1007041653,16,3,8374145,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,15854},{4,3,7927}]'),(1007041663,16,3,8829665,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,19817},{4,3,9909}]'),(1008010100,1,0,787,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008010110,1,0,1889,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008010120,1,0,4427,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008010131,1,1,7551,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008010132,1,2,10047,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008010141,1,1,17120,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008010142,1,2,23592,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008010143,1,3,30432,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008010153,1,3,41325,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008010163,1,3,54888,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008010200,2,0,1359,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008010210,2,0,2990,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008010220,2,0,7254,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008010231,2,1,11974,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008010232,2,2,16454,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008010241,2,1,28950,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008010242,2,2,41774,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008010243,2,3,59282,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008010253,2,3,99094,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008010263,2,3,158259,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008010300,3,0,3238,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008010310,3,0,6229,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008010320,3,0,13595,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008010331,3,1,21174,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008010332,3,2,27986,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008010341,3,1,47953,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008010342,3,2,68245,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008010343,3,3,95161,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008010353,3,3,149382,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008010363,3,3,234938,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008010400,4,0,6503,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008010410,4,0,11538,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008010420,4,0,24269,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008010431,4,1,36150,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008010432,4,2,45566,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008010441,4,1,76894,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008010442,4,2,105114,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008010443,4,3,141978,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008010453,4,3,225027,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008010463,4,3,348733,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008010500,5,0,11257,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008010510,5,0,19397,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008010520,5,0,39868,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008010531,5,1,57419,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008010532,5,2,70571,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008010541,5,1,117644,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008010542,5,2,157132,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008010543,5,3,209584,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008010553,5,3,332262,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008010563,5,3,509792,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008010600,6,0,17603,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008010610,6,0,29891,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008010620,6,0,60810,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008010631,6,1,86457,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008010632,6,2,104861,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008010641,6,1,173847,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008010642,6,2,229119,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,46323},{4,4,1158}]'),(1008010643,6,3,302535,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,110868},{4,4,2771}]'),(1008010653,6,3,479794,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,147822},{4,4,3696}]'),(1008010663,6,3,731971,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,184780},{4,4,4620}]'),(1008010700,7,0,25594,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008010710,7,0,43266,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008010720,7,0,87741,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008010731,7,1,124224,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008010732,7,2,150004,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008010741,7,1,248150,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008010742,7,2,325550,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,72050},{4,4,1801}]'),(1008010743,7,3,428330,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,156857},{4,4,3921}]'),(1008010753,7,3,679328,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,209142},{4,4,5229}]'),(1008010763,7,3,1008555,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,261426},{4,4,6536}]'),(1008010800,8,0,35310,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008010810,8,0,59838,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008010820,8,0,121456,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008010831,8,1,172239,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008010832,8,2,208323,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008010841,8,1,344929,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008010842,8,2,453285,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,75963},{4,4,1899}]'),(1008010843,8,3,597165,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,158699},{4,4,3968}]'),(1008010853,8,3,931000,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,211598},{4,4,5290}]'),(1008010863,8,3,1362558,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,264498},{4,4,6613}]'),(1008010900,9,0,46872,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008010910,9,0,79920,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008010920,9,0,163041,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008010931,9,1,232585,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008010932,9,2,283109,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008010941,9,1,470052,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008010942,9,2,621756,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,79744},{4,4,1994}]'),(1008010943,9,3,812112,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,158887},{4,4,3972}]'),(1008010953,9,3,1249007,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,211848},{4,4,5296}]'),(1008010963,9,3,1818012,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,264811},{4,4,6621}]'),(1008011000,10,0,60339,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008011010,10,0,103978,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008011020,10,0,213853,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008011031,10,1,308070,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008011032,10,2,378814,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008011041,10,1,631682,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008011042,10,2,835530,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,83902},{4,4,2097}]'),(1008011043,10,3,1083810,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,160662},{4,4,4016}]'),(1008011053,10,3,1653846,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,214216},{4,4,5356}]'),(1008011063,10,3,2393761,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,267770},{4,4,6694}]'),(1008011100,11,0,75841,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008011110,11,0,132569,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008011120,11,0,275747,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008011131,11,1,402454,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008011132,11,2,501498,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008011141,11,1,834370,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008011142,11,2,1103918,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,88425},{4,4,2211}]'),(1008011143,11,3,1429478,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,163814},{4,4,4095}]'),(1008011153,11,3,2164696,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,218419},{4,4,5460}]'),(1008011163,11,3,3115085,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,273024},{4,4,6825}]'),(1008011200,12,0,93405,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008011210,12,0,166472,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008011220,12,0,351212,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008011231,12,1,520938,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008011232,12,2,654570,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008011241,12,1,1085877,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008011242,12,2,1442229,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,93044},{4,4,2326}]'),(1008011243,12,3,1867497,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,167378},{4,4,4184}]'),(1008011253,12,3,2804485,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,223172},{4,4,5579}]'),(1008011263,12,3,4012939,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,278965},{4,4,6974}]'),(1008011300,13,0,113160,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008011310,13,0,206620,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008011320,13,0,443629,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008011331,13,1,666154,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008011332,13,2,843898,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008011341,13,1,1399144,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008011342,13,2,1868112,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,97910},{4,4,2448}]'),(1008011343,13,3,2419200,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,171866},{4,4,4296}]'),(1008011353,13,3,3601033,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,229154},{4,4,5729}]'),(1008011363,13,3,5122861,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,286443},{4,4,7161}]'),(1008011400,14,0,135185,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008011410,14,0,254400,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008011420,14,0,554235,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008011431,14,1,843134,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008011432,14,2,1079162,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008011441,14,1,1789529,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008011442,14,2,2402121,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,102675},{4,4,2567}]'),(1008011443,14,3,3110217,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,176479},{4,4,4412}]'),(1008011453,14,3,4586867,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,235306},{4,4,5883}]'),(1008011463,14,3,6485647,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,294132},{4,4,7353}]'),(1008011500,15,0,159557,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008011510,15,0,310051,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008011520,15,0,686633,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008011531,15,1,1060235,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008011532,15,2,1371943,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008011541,15,1,2274870,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008011542,15,2,3068674,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,107809},{4,4,2695}]'),(1008011543,15,3,3970786,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,185304},{4,4,4633}]'),(1008011553,15,3,5799599,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,247073},{4,4,6177}]'),(1008011563,15,3,8147443,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,308841},{4,4,7721}]'),(1008011600,16,0,6738355,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008011610,16,0,6831520,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008011620,16,0,7060751,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008011631,16,1,7172559,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008011632,16,2,7172559,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008011641,16,1,7483775,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008011642,16,2,7483775,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,113199},{4,4,2830}]'),(1008011643,16,3,7483775,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,194569},{4,4,4864}]'),(1008011653,16,3,8042840,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,259426},{4,4,6486}]'),(1008011663,16,3,8415550,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,324282},{4,4,8107}]'),(1008020100,1,0,787,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008020110,1,0,1889,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008020120,1,0,4427,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008020131,1,1,7551,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008020132,1,2,10047,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008020141,1,1,17120,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008020142,1,2,23592,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008020143,1,3,30432,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008020153,1,3,41325,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008020163,1,3,54888,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008020200,2,0,1359,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008020210,2,0,2990,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008020220,2,0,7254,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008020231,2,1,11974,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008020232,2,2,16454,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008020241,2,1,28950,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008020242,2,2,41774,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008020243,2,3,59282,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008020253,2,3,99094,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008020263,2,3,158259,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008020300,3,0,3238,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008020310,3,0,6229,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008020320,3,0,13595,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008020331,3,1,21174,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008020332,3,2,27986,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008020341,3,1,47953,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008020342,3,2,68245,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008020343,3,3,95161,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008020353,3,3,149382,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008020363,3,3,234938,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008020400,4,0,6503,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008020410,4,0,11538,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008020420,4,0,24269,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008020431,4,1,36150,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008020432,4,2,45566,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008020441,4,1,76894,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008020442,4,2,105114,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008020443,4,3,141978,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008020453,4,3,225027,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008020463,4,3,348733,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008020500,5,0,11257,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008020510,5,0,19397,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008020520,5,0,39868,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008020531,5,1,57419,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008020532,5,2,70571,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008020541,5,1,117644,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008020542,5,2,157132,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008020543,5,3,209584,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008020553,5,3,332262,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008020563,5,3,509792,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008020600,6,0,17603,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008020610,6,0,29891,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008020620,6,0,60810,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008020631,6,1,86457,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008020632,6,2,104861,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008020641,6,1,173847,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008020642,6,2,229119,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,46323},{4,4,1158}]'),(1008020643,6,3,302535,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,110868},{4,4,2771}]'),(1008020653,6,3,479794,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,147822},{4,4,3696}]'),(1008020663,6,3,731971,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,184780},{4,4,4620}]'),(1008020700,7,0,25594,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008020710,7,0,43266,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008020720,7,0,87741,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008020731,7,1,124224,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008020732,7,2,150004,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008020741,7,1,248150,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008020742,7,2,325550,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,72050},{4,4,1801}]'),(1008020743,7,3,428330,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,156857},{4,4,3921}]'),(1008020753,7,3,679328,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,209142},{4,4,5229}]'),(1008020763,7,3,1008555,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,261426},{4,4,6536}]'),(1008020800,8,0,35310,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008020810,8,0,59838,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008020820,8,0,121456,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008020831,8,1,172239,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008020832,8,2,208323,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008020841,8,1,344929,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008020842,8,2,453285,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,75963},{4,4,1899}]'),(1008020843,8,3,597165,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,158699},{4,4,3968}]'),(1008020853,8,3,931000,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,211598},{4,4,5290}]'),(1008020863,8,3,1362558,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,264498},{4,4,6613}]'),(1008020900,9,0,46872,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008020910,9,0,79920,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008020920,9,0,163041,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008020931,9,1,232585,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008020932,9,2,283109,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008020941,9,1,470052,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008020942,9,2,621756,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,79744},{4,4,1994}]'),(1008020943,9,3,812112,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,158887},{4,4,3972}]'),(1008020953,9,3,1249007,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,211848},{4,4,5296}]'),(1008020963,9,3,1818012,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,264811},{4,4,6621}]'),(1008021000,10,0,60339,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008021010,10,0,103978,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008021020,10,0,213853,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008021031,10,1,308070,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008021032,10,2,378814,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008021041,10,1,631682,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008021042,10,2,835530,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,83902},{4,4,2097}]'),(1008021043,10,3,1083810,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,160662},{4,4,4016}]'),(1008021053,10,3,1653846,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,214216},{4,4,5356}]'),(1008021063,10,3,2393761,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,267770},{4,4,6694}]'),(1008021100,11,0,75841,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008021110,11,0,132569,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008021120,11,0,275747,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008021131,11,1,402454,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008021132,11,2,501498,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008021141,11,1,834370,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008021142,11,2,1103918,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,88425},{4,4,2211}]'),(1008021143,11,3,1429478,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,163814},{4,4,4095}]'),(1008021153,11,3,2164696,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,218419},{4,4,5460}]'),(1008021163,11,3,3115085,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,273024},{4,4,6825}]'),(1008021200,12,0,93405,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008021210,12,0,166472,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008021220,12,0,351212,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008021231,12,1,520938,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008021232,12,2,654570,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008021241,12,1,1085877,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008021242,12,2,1442229,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,93044},{4,4,2326}]'),(1008021243,12,3,1867497,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,167378},{4,4,4184}]'),(1008021253,12,3,2804485,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,223172},{4,4,5579}]'),(1008021263,12,3,4012939,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,278965},{4,4,6974}]'),(1008021300,13,0,113160,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008021310,13,0,206620,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008021320,13,0,443629,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008021331,13,1,666154,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008021332,13,2,843898,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008021341,13,1,1399144,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008021342,13,2,1868112,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,97910},{4,4,2448}]'),(1008021343,13,3,2419200,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,171866},{4,4,4296}]'),(1008021353,13,3,3601033,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,229154},{4,4,5729}]'),(1008021363,13,3,5122861,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,286443},{4,4,7161}]'),(1008021400,14,0,135185,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008021410,14,0,254400,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008021420,14,0,554235,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008021431,14,1,843134,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008021432,14,2,1079162,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008021441,14,1,1789529,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008021442,14,2,2402121,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,102675},{4,4,2567}]'),(1008021443,14,3,3110217,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,176479},{4,4,4412}]'),(1008021453,14,3,4586867,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,235306},{4,4,5883}]'),(1008021463,14,3,6485647,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,294132},{4,4,7353}]'),(1008021500,15,0,159557,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008021510,15,0,310051,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008021520,15,0,686633,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008021531,15,1,1060235,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008021532,15,2,1371943,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008021541,15,1,2274870,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008021542,15,2,3068674,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,107809},{4,4,2695}]'),(1008021543,15,3,3970786,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,185304},{4,4,4633}]'),(1008021553,15,3,5799599,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,247073},{4,4,6177}]'),(1008021563,15,3,8147443,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,308841},{4,4,7721}]'),(1008021600,16,0,6738355,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008021610,16,0,6831520,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008021620,16,0,7060751,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008021631,16,1,7172559,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008021632,16,2,7172559,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008021641,16,1,7483775,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008021642,16,2,7483775,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,113199},{4,4,2830}]'),(1008021643,16,3,7483775,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,194569},{4,4,4864}]'),(1008021653,16,3,8042840,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,259426},{4,4,6486}]'),(1008021663,16,3,8415550,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,324282},{4,4,8107}]'),(1008030100,1,0,787,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008030110,1,0,1889,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008030120,1,0,4427,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008030131,1,1,7551,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008030132,1,2,10047,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008030141,1,1,17120,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008030142,1,2,23592,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008030143,1,3,30432,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008030153,1,3,41325,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008030163,1,3,54888,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008030200,2,0,1359,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008030210,2,0,2990,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008030220,2,0,7254,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008030231,2,1,11974,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008030232,2,2,16454,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008030241,2,1,28950,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008030242,2,2,41774,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008030243,2,3,59282,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008030253,2,3,99094,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008030263,2,3,158259,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008030300,3,0,3238,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008030310,3,0,6229,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008030320,3,0,13595,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008030331,3,1,21174,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008030332,3,2,27986,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008030341,3,1,47953,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008030342,3,2,68245,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008030343,3,3,95161,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008030353,3,3,149382,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008030363,3,3,234938,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008030400,4,0,6503,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008030410,4,0,11538,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008030420,4,0,24269,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008030431,4,1,36150,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008030432,4,2,45566,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008030441,4,1,76894,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008030442,4,2,105114,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008030443,4,3,141978,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008030453,4,3,225027,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008030463,4,3,348733,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008030500,5,0,11257,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008030510,5,0,19397,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008030520,5,0,39868,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008030531,5,1,57419,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008030532,5,2,70571,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008030541,5,1,117644,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008030542,5,2,157132,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008030543,5,3,209584,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008030553,5,3,332262,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008030563,5,3,509792,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008030600,6,0,17603,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008030610,6,0,29891,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008030620,6,0,60810,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008030631,6,1,86457,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008030632,6,2,104861,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008030641,6,1,173847,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008030642,6,2,229119,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,46323},{4,4,1158}]'),(1008030643,6,3,302535,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,110868},{4,4,2771}]'),(1008030653,6,3,479794,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,147822},{4,4,3696}]'),(1008030663,6,3,731971,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,184780},{4,4,4620}]'),(1008030700,7,0,25594,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008030710,7,0,43266,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008030720,7,0,87741,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008030731,7,1,124224,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008030732,7,2,150004,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008030741,7,1,248150,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008030742,7,2,325550,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,72050},{4,4,1801}]'),(1008030743,7,3,428330,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,156857},{4,4,3921}]'),(1008030753,7,3,679328,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,209142},{4,4,5229}]'),(1008030763,7,3,1008555,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,261426},{4,4,6536}]'),(1008030800,8,0,35310,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008030810,8,0,59838,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008030820,8,0,121456,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008030831,8,1,172239,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008030832,8,2,208323,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008030841,8,1,344929,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008030842,8,2,453285,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,75963},{4,4,1899}]'),(1008030843,8,3,597165,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,158699},{4,4,3968}]'),(1008030853,8,3,931000,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,211598},{4,4,5290}]'),(1008030863,8,3,1362558,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,264498},{4,4,6613}]'),(1008030900,9,0,46872,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008030910,9,0,79920,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008030920,9,0,163041,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008030931,9,1,232585,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008030932,9,2,283109,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008030941,9,1,470052,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008030942,9,2,621756,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,79744},{4,4,1994}]'),(1008030943,9,3,812112,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,158887},{4,4,3972}]'),(1008030953,9,3,1249007,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,211848},{4,4,5296}]'),(1008030963,9,3,1818012,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,264811},{4,4,6621}]'),(1008031000,10,0,60339,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008031010,10,0,103978,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008031020,10,0,213853,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008031031,10,1,308070,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008031032,10,2,378814,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008031041,10,1,631682,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008031042,10,2,835530,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,83902},{4,4,2097}]'),(1008031043,10,3,1083810,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,160662},{4,4,4016}]'),(1008031053,10,3,1653846,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,214216},{4,4,5356}]'),(1008031063,10,3,2393761,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,267770},{4,4,6694}]'),(1008031100,11,0,75841,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008031110,11,0,132569,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008031120,11,0,275747,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008031131,11,1,402454,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008031132,11,2,501498,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008031141,11,1,834370,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008031142,11,2,1103918,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,88425},{4,4,2211}]'),(1008031143,11,3,1429478,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,163814},{4,4,4095}]'),(1008031153,11,3,2164696,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,218419},{4,4,5460}]'),(1008031163,11,3,3115085,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,273024},{4,4,6825}]'),(1008031200,12,0,93405,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008031210,12,0,166472,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008031220,12,0,351212,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008031231,12,1,520938,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008031232,12,2,654570,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008031241,12,1,1085877,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008031242,12,2,1442229,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,93044},{4,4,2326}]'),(1008031243,12,3,1867497,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,167378},{4,4,4184}]'),(1008031253,12,3,2804485,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,223172},{4,4,5579}]'),(1008031263,12,3,4012939,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,278965},{4,4,6974}]'),(1008031300,13,0,113160,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008031310,13,0,206620,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008031320,13,0,443629,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008031331,13,1,666154,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008031332,13,2,843898,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008031341,13,1,1399144,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008031342,13,2,1868112,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,97910},{4,4,2448}]'),(1008031343,13,3,2419200,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,171866},{4,4,4296}]'),(1008031353,13,3,3601033,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,229154},{4,4,5729}]'),(1008031363,13,3,5122861,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,286443},{4,4,7161}]'),(1008031400,14,0,135185,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008031410,14,0,254400,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008031420,14,0,554235,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008031431,14,1,843134,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008031432,14,2,1079162,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008031441,14,1,1789529,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008031442,14,2,2402121,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,102675},{4,4,2567}]'),(1008031443,14,3,3110217,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,176479},{4,4,4412}]'),(1008031453,14,3,4586867,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,235306},{4,4,5883}]'),(1008031463,14,3,6485647,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,294132},{4,4,7353}]'),(1008031500,15,0,159557,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008031510,15,0,310051,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008031520,15,0,686633,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008031531,15,1,1060235,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008031532,15,2,1371943,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008031541,15,1,2274870,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008031542,15,2,3068674,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,107809},{4,4,2695}]'),(1008031543,15,3,3970786,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,185304},{4,4,4633}]'),(1008031553,15,3,5799599,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,247073},{4,4,6177}]'),(1008031563,15,3,8147443,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,308841},{4,4,7721}]'),(1008031600,16,0,6738355,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008031610,16,0,6831520,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008031620,16,0,7060751,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008031631,16,1,7172559,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008031632,16,2,7172559,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008031641,16,1,7483775,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008031642,16,2,7483775,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,113199},{4,4,2830}]'),(1008031643,16,3,7483775,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,194569},{4,4,4864}]'),(1008031653,16,3,8042840,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,259426},{4,4,6486}]'),(1008031663,16,3,8415550,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,324282},{4,4,8107}]'),(1008040100,1,0,787,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008040110,1,0,1889,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008040120,1,0,4427,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008040131,1,1,7551,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008040132,1,2,10047,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008040141,1,1,17120,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008040142,1,2,23592,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008040143,1,3,30432,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008040153,1,3,41325,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008040163,1,3,54888,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008040200,2,0,1359,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008040210,2,0,2990,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008040220,2,0,7254,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008040231,2,1,11974,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008040232,2,2,16454,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008040241,2,1,28950,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008040242,2,2,41774,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008040243,2,3,59282,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008040253,2,3,99094,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008040263,2,3,158259,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008040300,3,0,3238,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008040310,3,0,6229,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008040320,3,0,13595,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008040331,3,1,21174,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008040332,3,2,27986,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008040341,3,1,47953,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008040342,3,2,68245,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008040343,3,3,95161,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008040353,3,3,149382,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008040363,3,3,234938,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008040400,4,0,6503,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008040410,4,0,11538,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008040420,4,0,24269,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008040431,4,1,36150,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008040432,4,2,45566,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008040441,4,1,76894,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008040442,4,2,105114,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008040443,4,3,141978,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008040453,4,3,225027,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008040463,4,3,348733,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008040500,5,0,11257,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008040510,5,0,19397,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008040520,5,0,39868,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008040531,5,1,57419,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008040532,5,2,70571,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008040541,5,1,117644,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008040542,5,2,157132,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008040543,5,3,209584,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008040553,5,3,332262,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008040563,5,3,509792,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008040600,6,0,17603,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008040610,6,0,29891,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008040620,6,0,60810,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008040631,6,1,86457,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008040632,6,2,104861,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008040641,6,1,173847,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008040642,6,2,229119,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,46323},{4,4,1158}]'),(1008040643,6,3,302535,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,110868},{4,4,2771}]'),(1008040653,6,3,479794,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,147822},{4,4,3696}]'),(1008040663,6,3,731971,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,184780},{4,4,4620}]'),(1008040700,7,0,25594,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008040710,7,0,43266,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008040720,7,0,87741,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008040731,7,1,124224,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008040732,7,2,150004,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008040741,7,1,248150,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008040742,7,2,325550,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,72050},{4,4,1801}]'),(1008040743,7,3,428330,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,156857},{4,4,3921}]'),(1008040753,7,3,679328,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,209142},{4,4,5229}]'),(1008040763,7,3,1008555,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,261426},{4,4,6536}]'),(1008040800,8,0,35310,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008040810,8,0,59838,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008040820,8,0,121456,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008040831,8,1,172239,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008040832,8,2,208323,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008040841,8,1,344929,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008040842,8,2,453285,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,75963},{4,4,1899}]'),(1008040843,8,3,597165,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,158699},{4,4,3968}]'),(1008040853,8,3,931000,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,211598},{4,4,5290}]'),(1008040863,8,3,1362558,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,264498},{4,4,6613}]'),(1008040900,9,0,46872,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008040910,9,0,79920,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008040920,9,0,163041,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008040931,9,1,232585,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008040932,9,2,283109,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008040941,9,1,470052,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008040942,9,2,621756,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,79744},{4,4,1994}]'),(1008040943,9,3,812112,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,158887},{4,4,3972}]'),(1008040953,9,3,1249007,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,211848},{4,4,5296}]'),(1008040963,9,3,1818012,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,264811},{4,4,6621}]'),(1008041000,10,0,60339,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008041010,10,0,103978,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008041020,10,0,213853,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008041031,10,1,308070,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008041032,10,2,378814,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008041041,10,1,631682,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008041042,10,2,835530,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,83902},{4,4,2097}]'),(1008041043,10,3,1083810,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,160662},{4,4,4016}]'),(1008041053,10,3,1653846,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,214216},{4,4,5356}]'),(1008041063,10,3,2393761,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,267770},{4,4,6694}]'),(1008041100,11,0,75841,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008041110,11,0,132569,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008041120,11,0,275747,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008041131,11,1,402454,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008041132,11,2,501498,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008041141,11,1,834370,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008041142,11,2,1103918,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,88425},{4,4,2211}]'),(1008041143,11,3,1429478,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,163814},{4,4,4095}]'),(1008041153,11,3,2164696,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,218419},{4,4,5460}]'),(1008041163,11,3,3115085,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,273024},{4,4,6825}]'),(1008041200,12,0,93405,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008041210,12,0,166472,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008041220,12,0,351212,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008041231,12,1,520938,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008041232,12,2,654570,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008041241,12,1,1085877,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008041242,12,2,1442229,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,93044},{4,4,2326}]'),(1008041243,12,3,1867497,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,167378},{4,4,4184}]'),(1008041253,12,3,2804485,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,223172},{4,4,5579}]'),(1008041263,12,3,4012939,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,278965},{4,4,6974}]'),(1008041300,13,0,113160,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008041310,13,0,206620,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008041320,13,0,443629,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008041331,13,1,666154,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008041332,13,2,843898,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008041341,13,1,1399144,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008041342,13,2,1868112,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,97910},{4,4,2448}]'),(1008041343,13,3,2419200,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,171866},{4,4,4296}]'),(1008041353,13,3,3601033,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,229154},{4,4,5729}]'),(1008041363,13,3,5122861,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,286443},{4,4,7161}]'),(1008041400,14,0,135185,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008041410,14,0,254400,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008041420,14,0,554235,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008041431,14,1,843134,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008041432,14,2,1079162,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008041441,14,1,1789529,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008041442,14,2,2402121,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,102675},{4,4,2567}]'),(1008041443,14,3,3110217,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,176479},{4,4,4412}]'),(1008041453,14,3,4586867,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,235306},{4,4,5883}]'),(1008041463,14,3,6485647,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,294132},{4,4,7353}]'),(1008041500,15,0,159557,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008041510,15,0,310051,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008041520,15,0,686633,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008041531,15,1,1060235,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008041532,15,2,1371943,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008041541,15,1,2274870,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008041542,15,2,3068674,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,107809},{4,4,2695}]'),(1008041543,15,3,3970786,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,185304},{4,4,4633}]'),(1008041553,15,3,5799599,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,247073},{4,4,6177}]'),(1008041563,15,3,8147443,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,308841},{4,4,7721}]'),(1008041600,16,0,6738355,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008041610,16,0,6831520,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1008041620,16,0,7060751,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1008041631,16,1,7172559,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008041632,16,2,7172559,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1008041641,16,1,7483775,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1008041642,16,2,7483775,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,113199},{4,4,2830}]'),(1008041643,16,3,7483775,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,194569},{4,4,4864}]'),(1008041653,16,3,8042840,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,259426},{4,4,6486}]'),(1008041663,16,3,8415550,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,324282},{4,4,8107}]'),(1009000100,1,0,475,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1009000110,1,0,1423,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1009000120,1,0,3592,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1009000131,1,1,6529,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1009000132,1,2,9025,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1009000141,1,1,15565,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1009000142,1,2,22037,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1009000143,1,3,28877,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1009000153,1,3,38884,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1009000163,1,3,51798,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1009000200,2,0,825,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1009000210,2,0,2199,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1009000220,2,0,5827,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1009000231,2,1,10222,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1009000232,2,2,14702,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1009000241,2,1,26320,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1009000242,2,2,39144,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1009000243,2,3,56652,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1009000253,2,3,94878,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1009000263,2,3,152995,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1009000300,3,0,1970,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1009000310,3,0,4342,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1009000320,3,0,10163,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1009000331,3,1,16969,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1009000332,3,2,23781,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1009000341,3,1,41668,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1009000342,3,2,61960,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1009000343,3,3,88876,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1009000353,3,3,139323,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1009000363,3,3,222372,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1009000400,4,0,3965,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1009000410,4,0,7744,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1009000420,4,0,17371,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1009000431,4,1,27736,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1009000432,4,2,37152,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1009000441,4,1,64270,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1009000442,4,2,92490,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1009000443,4,3,129354,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1009000453,4,3,204765,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1009000463,4,3,323440,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1009000500,5,0,6890,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1009000510,5,0,12835,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1009000520,5,0,27905,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1009000531,5,1,42837,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1009000532,5,2,55989,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1009000541,5,1,95741,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1009000542,5,2,135229,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1009000543,5,3,187681,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1009000553,5,3,297215,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1009000563,5,3,465987,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1009000600,6,0,10745,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1009000610,6,0,19620,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1009000620,6,0,42136,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1009000631,6,1,63691,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1009000632,6,2,82095,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1009000641,6,1,139639,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1009000642,6,2,194911,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,1415},{4,3,708}]'),(1009000643,6,3,268327,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,3387},{4,3,1694}]'),(1009000653,6,3,425039,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,4517},{4,3,2258}]'),(1009000663,6,3,663530,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,5645},{4,3,2823}]'),(1009000700,7,0,15645,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1009000710,7,0,28365,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1009000720,7,0,60569,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1009000731,7,1,91085,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1009000732,7,2,116865,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1009000741,7,1,198403,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1009000742,7,2,275803,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,2201},{4,3,1101}]'),(1009000743,7,3,378583,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,4792},{4,3,2397}]'),(1009000753,7,3,599728,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,6391},{4,3,3195}]'),(1009000763,7,3,909057,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,7988},{4,3,3993}]'),(1009000800,8,0,21580,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1009000810,8,0,39230,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1009000820,8,0,83979,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1009000831,8,1,126526,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1009000832,8,2,162610,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1009000841,8,1,276248,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1009000842,8,2,384604,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,2321},{4,3,1160}]'),(1009000843,8,3,528484,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,4850},{4,3,2424}]'),(1009000853,8,3,821129,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,6465},{4,3,3233}]'),(1009000863,8,3,1225201,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,8082},{4,3,4041}]'),(1009000900,9,0,28645,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1009000910,9,0,52565,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1009000920,9,0,113259,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1009000931,9,1,171900,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1009000932,9,2,222424,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1009000941,9,1,378908,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1009000942,9,2,530612,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,2437},{4,3,1219}]'),(1009000943,9,3,720968,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,4855},{4,3,2428}]'),(1009000953,9,3,1103178,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,6473},{4,3,3237}]'),(1009000963,9,3,1635699,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,8091},{4,3,4046}]'),(1009001000,10,0,36875,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1009001010,10,0,68759,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1009001020,10,0,149773,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1009001031,10,1,229901,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1009001032,10,2,300645,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1009001041,10,1,514341,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1009001042,10,2,718189,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,2564},{4,3,1282}]'),(1009001043,10,3,966469,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,4909},{4,3,2455}]'),(1009001053,10,3,1466067,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,6545},{4,3,3273}]'),(1009001063,10,3,2159054,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,8182},{4,3,4091}]'),(1009001100,11,0,46345,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1009001110,11,0,88325,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1009001120,11,0,195234,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1009001131,11,1,304242,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1009001132,11,2,403286,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1009001141,11,1,686941,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1009001142,11,2,956489,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,2702},{4,3,1351}]'),(1009001143,11,3,1282049,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,5006},{4,3,2503}]'),(1009001153,11,3,1928784,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,6674},{4,3,3337}]'),(1009001163,11,3,2820206,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,8342},{4,3,4171}]'),(1009001200,12,0,57070,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1009001210,12,0,111977,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1009001220,12,0,252041,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1009001231,12,1,399984,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1009001232,12,2,533616,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1009001241,12,1,904267,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1009001242,12,2,1260619,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,2843},{4,3,1422}]'),(1009001243,12,3,1685887,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,5115},{4,3,2557}]'),(1009001253,12,3,2513889,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,6819},{4,3,3409}]'),(1009001263,12,3,3649698,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,8524},{4,3,4262}]'),(1009001300,13,0,69160,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1009001310,13,0,140632,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1009001320,13,0,323480,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1009001331,13,1,519619,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1009001332,13,2,697363,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1009001341,13,1,1179123,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1009001342,13,2,1648091,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,2992},{4,3,1496}]'),(1009001343,13,3,2199179,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,5252},{4,3,2626}]'),(1009001353,13,3,3248991,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,7002},{4,3,3501}]'),(1009001363,13,3,4682799,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,8752},{4,3,4376}]'),(1009001400,14,0,82615,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1009001410,14,0,175558,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1009001420,14,0,410721,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1009001431,14,1,668084,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1009001432,14,2,904112,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1009001441,14,1,1526686,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1009001442,14,2,2139278,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,3137},{4,3,1569}]'),(1009001443,14,3,2847374,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,5393},{4,3,2696}]'),(1009001453,14,3,4166319,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,7190},{4,3,3595}]'),(1009001463,14,3,5959985,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,8988},{4,3,4494}]'),(1009001500,15,0,97500,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1009001510,15,0,216978,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1009001520,15,0,517247,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1009001531,15,1,853615,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1009001532,15,2,1165323,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1009001541,15,1,1964636,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1009001542,15,2,2758440,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,3294},{4,3,1647}]'),(1009001543,15,3,3660552,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,5662},{4,3,2831}]'),(1009001553,15,3,5303244,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,7549},{4,3,3775}]'),(1009001563,15,3,7527000,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,9437},{4,3,4718}]'),(1009001600,16,0,6665880,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1009001610,16,0,6722820,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1009001620,16,0,6862895,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}},{10,{2,21,480}},{10,{2,13,150}}]',0,'[]',0,'[]','[]'),(1009001631,16,1,6931230,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1009001632,16,2,6931230,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}},{10,{3,13,200}}]',0,'[]','[]'),(1009001641,16,1,7121420,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1009001642,16,2,7121420,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,3459},{4,3,1729}]'),(1009001643,16,3,7121420,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,5945},{4,3,2972}]'),(1009001653,16,3,7463060,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,7927},{4,3,3963}]'),(1009001663,16,3,7690845,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,9909},{4,3,4954}]'),(1010010100,1,0,787,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010010110,1,0,1889,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010010120,1,0,4427,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010010131,1,1,7551,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010010132,1,2,10047,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010010141,1,1,17120,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010010142,1,2,23592,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010010143,1,3,30432,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010010153,1,3,41325,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010010163,1,3,54888,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010010200,2,0,1359,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010010210,2,0,2990,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010010220,2,0,7254,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010010231,2,1,11974,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010010232,2,2,16454,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010010241,2,1,28950,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010010242,2,2,41774,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010010243,2,3,59282,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010010253,2,3,99094,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010010263,2,3,158259,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010010300,3,0,3238,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010010310,3,0,6229,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010010320,3,0,13595,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010010331,3,1,21174,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010010332,3,2,27986,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010010341,3,1,47953,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010010342,3,2,68245,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010010343,3,3,95161,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010010353,3,3,149382,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010010363,3,3,234938,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010010400,4,0,6503,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010010410,4,0,11538,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010010420,4,0,24269,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010010431,4,1,36150,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010010432,4,2,45566,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010010441,4,1,76894,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010010442,4,2,105114,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010010443,4,3,141978,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010010453,4,3,225027,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010010463,4,3,348733,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010010500,5,0,11257,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010010510,5,0,19397,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010010520,5,0,39868,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010010531,5,1,57419,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010010532,5,2,70571,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010010541,5,1,117644,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010010542,5,2,157132,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010010543,5,3,209584,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010010553,5,3,332262,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010010563,5,3,509792,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010010600,6,0,17603,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010010610,6,0,29891,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010010620,6,0,60810,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010010631,6,1,86457,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010010632,6,2,104861,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010010641,6,1,173847,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010010642,6,2,229119,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,46323},{4,4,1158}]'),(1010010643,6,3,302535,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,110868},{4,4,2771}]'),(1010010653,6,3,479794,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,147822},{4,4,3696}]'),(1010010663,6,3,731971,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,184780},{4,4,4620}]'),(1010010700,7,0,25594,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010010710,7,0,43266,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010010720,7,0,87741,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010010731,7,1,124224,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010010732,7,2,150004,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010010741,7,1,248150,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010010742,7,2,325550,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,72050},{4,4,1801}]'),(1010010743,7,3,428330,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,156857},{4,4,3921}]'),(1010010753,7,3,679328,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,209142},{4,4,5229}]'),(1010010763,7,3,1008555,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,261426},{4,4,6536}]'),(1010010800,8,0,35310,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010010810,8,0,59838,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010010820,8,0,121456,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010010831,8,1,172239,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010010832,8,2,208323,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010010841,8,1,344929,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010010842,8,2,453285,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,75963},{4,4,1899}]'),(1010010843,8,3,597165,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,158699},{4,4,3968}]'),(1010010853,8,3,931000,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,211598},{4,4,5290}]'),(1010010863,8,3,1362558,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,264498},{4,4,6613}]'),(1010010900,9,0,46872,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010010910,9,0,79920,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010010920,9,0,163041,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010010931,9,1,232585,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010010932,9,2,283109,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010010941,9,1,470052,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010010942,9,2,621756,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,79744},{4,4,1994}]'),(1010010943,9,3,812112,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,158887},{4,4,3972}]'),(1010010953,9,3,1249007,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,211848},{4,4,5296}]'),(1010010963,9,3,1818012,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,264811},{4,4,6621}]'),(1010011000,10,0,60339,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010011010,10,0,103978,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010011020,10,0,213853,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010011031,10,1,308070,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010011032,10,2,378814,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010011041,10,1,631682,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010011042,10,2,835530,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,83902},{4,4,2097}]'),(1010011043,10,3,1083810,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,160662},{4,4,4016}]'),(1010011053,10,3,1653846,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,214216},{4,4,5356}]'),(1010011063,10,3,2393761,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,267770},{4,4,6694}]'),(1010011100,11,0,75841,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010011110,11,0,132569,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010011120,11,0,275747,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010011131,11,1,402454,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010011132,11,2,501498,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010011141,11,1,834370,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010011142,11,2,1103918,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,88425},{4,4,2211}]'),(1010011143,11,3,1429478,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,163814},{4,4,4095}]'),(1010011153,11,3,2164696,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,218419},{4,4,5460}]'),(1010011163,11,3,3115085,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,273024},{4,4,6825}]'),(1010011200,12,0,93405,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010011210,12,0,166472,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010011220,12,0,351212,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010011231,12,1,520938,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010011232,12,2,654570,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010011241,12,1,1085877,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010011242,12,2,1442229,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,93044},{4,4,2326}]'),(1010011243,12,3,1867497,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,167378},{4,4,4184}]'),(1010011253,12,3,2804485,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,223172},{4,4,5579}]'),(1010011263,12,3,4012939,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,278965},{4,4,6974}]'),(1010011300,13,0,113160,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010011310,13,0,206620,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010011320,13,0,443629,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010011331,13,1,666154,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010011332,13,2,843898,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010011341,13,1,1399144,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010011342,13,2,1868112,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,97910},{4,4,2448}]'),(1010011343,13,3,2419200,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,171866},{4,4,4296}]'),(1010011353,13,3,3601033,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,229154},{4,4,5729}]'),(1010011363,13,3,5122861,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,286443},{4,4,7161}]'),(1010011400,14,0,135185,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010011410,14,0,254400,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010011420,14,0,554235,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010011431,14,1,843134,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010011432,14,2,1079162,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010011441,14,1,1789529,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010011442,14,2,2402121,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,102675},{4,4,2567}]'),(1010011443,14,3,3110217,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,176479},{4,4,4412}]'),(1010011453,14,3,4586867,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,235306},{4,4,5883}]'),(1010011463,14,3,6485647,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,294132},{4,4,7353}]'),(1010011500,15,0,159557,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010011510,15,0,310051,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010011520,15,0,686633,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010011531,15,1,1060235,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010011532,15,2,1371943,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010011541,15,1,2274870,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010011542,15,2,3068674,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,107809},{4,4,2695}]'),(1010011543,15,3,3970786,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,185304},{4,4,4633}]'),(1010011553,15,3,5799599,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,247073},{4,4,6177}]'),(1010011563,15,3,8147443,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,308841},{4,4,7721}]'),(1010011600,16,0,6738355,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010011610,16,0,6831520,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010011620,16,0,7060751,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010011631,16,1,7172559,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010011632,16,2,7172559,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010011641,16,1,7483775,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010011642,16,2,7483775,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,113199},{4,4,2830}]'),(1010011643,16,3,7483775,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,194569},{4,4,4864}]'),(1010011653,16,3,8042840,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,259426},{4,4,6486}]'),(1010011663,16,3,8415550,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,324282},{4,4,8107}]'),(1010020100,1,0,787,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010020110,1,0,1889,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010020120,1,0,4427,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010020131,1,1,7551,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010020132,1,2,10047,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010020141,1,1,17120,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010020142,1,2,23592,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010020143,1,3,30432,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010020153,1,3,41325,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010020163,1,3,54888,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010020200,2,0,1359,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010020210,2,0,2990,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010020220,2,0,7254,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010020231,2,1,11974,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010020232,2,2,16454,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010020241,2,1,28950,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010020242,2,2,41774,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010020243,2,3,59282,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010020253,2,3,99094,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010020263,2,3,158259,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010020300,3,0,3238,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010020310,3,0,6229,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010020320,3,0,13595,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010020331,3,1,21174,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010020332,3,2,27986,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010020341,3,1,47953,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010020342,3,2,68245,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010020343,3,3,95161,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010020353,3,3,149382,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010020363,3,3,234938,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010020400,4,0,6503,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010020410,4,0,11538,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010020420,4,0,24269,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010020431,4,1,36150,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010020432,4,2,45566,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010020441,4,1,76894,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010020442,4,2,105114,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010020443,4,3,141978,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010020453,4,3,225027,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010020463,4,3,348733,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010020500,5,0,11257,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010020510,5,0,19397,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010020520,5,0,39868,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010020531,5,1,57419,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010020532,5,2,70571,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010020541,5,1,117644,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010020542,5,2,157132,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010020543,5,3,209584,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010020553,5,3,332262,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010020563,5,3,509792,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010020600,6,0,17603,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010020610,6,0,29891,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010020620,6,0,60810,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010020631,6,1,86457,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010020632,6,2,104861,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010020641,6,1,173847,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010020642,6,2,229119,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,46323},{4,4,1158}]'),(1010020643,6,3,302535,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,110868},{4,4,2771}]'),(1010020653,6,3,479794,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,147822},{4,4,3696}]'),(1010020663,6,3,731971,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,184780},{4,4,4620}]'),(1010020700,7,0,25594,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010020710,7,0,43266,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010020720,7,0,87741,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010020731,7,1,124224,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010020732,7,2,150004,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010020741,7,1,248150,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010020742,7,2,325550,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,72050},{4,4,1801}]'),(1010020743,7,3,428330,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,156857},{4,4,3921}]'),(1010020753,7,3,679328,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,209142},{4,4,5229}]'),(1010020763,7,3,1008555,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,261426},{4,4,6536}]'),(1010020800,8,0,35310,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010020810,8,0,59838,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010020820,8,0,121456,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010020831,8,1,172239,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010020832,8,2,208323,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010020841,8,1,344929,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010020842,8,2,453285,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,75963},{4,4,1899}]'),(1010020843,8,3,597165,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,158699},{4,4,3968}]'),(1010020853,8,3,931000,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,211598},{4,4,5290}]'),(1010020863,8,3,1362558,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,264498},{4,4,6613}]'),(1010020900,9,0,46872,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010020910,9,0,79920,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010020920,9,0,163041,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010020931,9,1,232585,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010020932,9,2,283109,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010020941,9,1,470052,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010020942,9,2,621756,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,79744},{4,4,1994}]'),(1010020943,9,3,812112,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,158887},{4,4,3972}]'),(1010020953,9,3,1249007,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,211848},{4,4,5296}]'),(1010020963,9,3,1818012,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,264811},{4,4,6621}]'),(1010021000,10,0,60339,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010021010,10,0,103978,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010021020,10,0,213853,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010021031,10,1,308070,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010021032,10,2,378814,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010021041,10,1,631682,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010021042,10,2,835530,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,83902},{4,4,2097}]'),(1010021043,10,3,1083810,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,160662},{4,4,4016}]'),(1010021053,10,3,1653846,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,214216},{4,4,5356}]'),(1010021063,10,3,2393761,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,267770},{4,4,6694}]'),(1010021100,11,0,75841,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010021110,11,0,132569,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010021120,11,0,275747,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010021131,11,1,402454,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010021132,11,2,501498,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010021141,11,1,834370,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010021142,11,2,1103918,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,88425},{4,4,2211}]'),(1010021143,11,3,1429478,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,163814},{4,4,4095}]'),(1010021153,11,3,2164696,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,218419},{4,4,5460}]'),(1010021163,11,3,3115085,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,273024},{4,4,6825}]'),(1010021200,12,0,93405,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010021210,12,0,166472,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010021220,12,0,351212,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010021231,12,1,520938,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010021232,12,2,654570,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010021241,12,1,1085877,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010021242,12,2,1442229,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,93044},{4,4,2326}]'),(1010021243,12,3,1867497,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,167378},{4,4,4184}]'),(1010021253,12,3,2804485,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,223172},{4,4,5579}]'),(1010021263,12,3,4012939,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,278965},{4,4,6974}]'),(1010021300,13,0,113160,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010021310,13,0,206620,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010021320,13,0,443629,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010021331,13,1,666154,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010021332,13,2,843898,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010021341,13,1,1399144,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010021342,13,2,1868112,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,97910},{4,4,2448}]'),(1010021343,13,3,2419200,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,171866},{4,4,4296}]'),(1010021353,13,3,3601033,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,229154},{4,4,5729}]'),(1010021363,13,3,5122861,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,286443},{4,4,7161}]'),(1010021400,14,0,135185,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010021410,14,0,254400,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010021420,14,0,554235,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010021431,14,1,843134,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010021432,14,2,1079162,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010021441,14,1,1789529,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010021442,14,2,2402121,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,102675},{4,4,2567}]'),(1010021443,14,3,3110217,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,176479},{4,4,4412}]'),(1010021453,14,3,4586867,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,235306},{4,4,5883}]'),(1010021463,14,3,6485647,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,294132},{4,4,7353}]'),(1010021500,15,0,159557,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010021510,15,0,310051,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010021520,15,0,686633,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010021531,15,1,1060235,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010021532,15,2,1371943,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010021541,15,1,2274870,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010021542,15,2,3068674,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,107809},{4,4,2695}]'),(1010021543,15,3,3970786,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,185304},{4,4,4633}]'),(1010021553,15,3,5799599,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,247073},{4,4,6177}]'),(1010021563,15,3,8147443,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,308841},{4,4,7721}]'),(1010021600,16,0,6738355,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010021610,16,0,6831520,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010021620,16,0,7060751,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010021631,16,1,7172559,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010021632,16,2,7172559,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010021641,16,1,7483775,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010021642,16,2,7483775,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,113199},{4,4,2830}]'),(1010021643,16,3,7483775,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,194569},{4,4,4864}]'),(1010021653,16,3,8042840,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,259426},{4,4,6486}]'),(1010021663,16,3,8415550,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,324282},{4,4,8107}]'),(1010030100,1,0,787,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010030110,1,0,1889,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010030120,1,0,4427,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010030131,1,1,7551,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010030132,1,2,10047,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010030141,1,1,17120,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010030142,1,2,23592,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010030143,1,3,30432,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010030153,1,3,41325,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010030163,1,3,54888,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010030200,2,0,1359,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010030210,2,0,2990,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010030220,2,0,7254,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010030231,2,1,11974,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010030232,2,2,16454,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010030241,2,1,28950,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010030242,2,2,41774,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010030243,2,3,59282,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010030253,2,3,99094,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010030263,2,3,158259,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010030300,3,0,3238,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010030310,3,0,6229,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010030320,3,0,13595,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010030331,3,1,21174,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010030332,3,2,27986,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010030341,3,1,47953,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010030342,3,2,68245,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010030343,3,3,95161,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010030353,3,3,149382,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010030363,3,3,234938,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010030400,4,0,6503,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010030410,4,0,11538,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010030420,4,0,24269,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010030431,4,1,36150,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010030432,4,2,45566,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010030441,4,1,76894,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010030442,4,2,105114,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010030443,4,3,141978,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010030453,4,3,225027,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010030463,4,3,348733,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010030500,5,0,11257,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010030510,5,0,19397,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010030520,5,0,39868,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010030531,5,1,57419,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010030532,5,2,70571,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010030541,5,1,117644,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010030542,5,2,157132,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010030543,5,3,209584,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010030553,5,3,332262,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010030563,5,3,509792,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010030600,6,0,17603,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010030610,6,0,29891,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010030620,6,0,60810,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010030631,6,1,86457,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010030632,6,2,104861,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010030641,6,1,173847,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010030642,6,2,229119,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,46323},{4,4,1158}]'),(1010030643,6,3,302535,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,110868},{4,4,2771}]'),(1010030653,6,3,479794,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,147822},{4,4,3696}]'),(1010030663,6,3,731971,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,184780},{4,4,4620}]'),(1010030700,7,0,25594,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010030710,7,0,43266,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010030720,7,0,87741,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010030731,7,1,124224,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010030732,7,2,150004,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010030741,7,1,248150,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010030742,7,2,325550,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,72050},{4,4,1801}]'),(1010030743,7,3,428330,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,156857},{4,4,3921}]'),(1010030753,7,3,679328,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,209142},{4,4,5229}]'),(1010030763,7,3,1008555,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,261426},{4,4,6536}]'),(1010030800,8,0,35310,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010030810,8,0,59838,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010030820,8,0,121456,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010030831,8,1,172239,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010030832,8,2,208323,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010030841,8,1,344929,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010030842,8,2,453285,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,75963},{4,4,1899}]'),(1010030843,8,3,597165,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,158699},{4,4,3968}]'),(1010030853,8,3,931000,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,211598},{4,4,5290}]'),(1010030863,8,3,1362558,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,264498},{4,4,6613}]'),(1010030900,9,0,46872,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010030910,9,0,79920,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010030920,9,0,163041,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010030931,9,1,232585,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010030932,9,2,283109,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010030941,9,1,470052,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010030942,9,2,621756,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,79744},{4,4,1994}]'),(1010030943,9,3,812112,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,158887},{4,4,3972}]'),(1010030953,9,3,1249007,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,211848},{4,4,5296}]'),(1010030963,9,3,1818012,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,264811},{4,4,6621}]'),(1010031000,10,0,60339,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010031010,10,0,103978,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010031020,10,0,213853,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010031031,10,1,308070,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010031032,10,2,378814,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010031041,10,1,631682,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010031042,10,2,835530,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,83902},{4,4,2097}]'),(1010031043,10,3,1083810,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,160662},{4,4,4016}]'),(1010031053,10,3,1653846,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,214216},{4,4,5356}]'),(1010031063,10,3,2393761,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,267770},{4,4,6694}]'),(1010031100,11,0,75841,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010031110,11,0,132569,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010031120,11,0,275747,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010031131,11,1,402454,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010031132,11,2,501498,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010031141,11,1,834370,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010031142,11,2,1103918,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,88425},{4,4,2211}]'),(1010031143,11,3,1429478,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,163814},{4,4,4095}]'),(1010031153,11,3,2164696,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,218419},{4,4,5460}]'),(1010031163,11,3,3115085,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,273024},{4,4,6825}]'),(1010031200,12,0,93405,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010031210,12,0,166472,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010031220,12,0,351212,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010031231,12,1,520938,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010031232,12,2,654570,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010031241,12,1,1085877,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010031242,12,2,1442229,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,93044},{4,4,2326}]'),(1010031243,12,3,1867497,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,167378},{4,4,4184}]'),(1010031253,12,3,2804485,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,223172},{4,4,5579}]'),(1010031263,12,3,4012939,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,278965},{4,4,6974}]'),(1010031300,13,0,113160,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010031310,13,0,206620,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010031320,13,0,443629,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010031331,13,1,666154,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010031332,13,2,843898,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010031341,13,1,1399144,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010031342,13,2,1868112,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,97910},{4,4,2448}]'),(1010031343,13,3,2419200,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,171866},{4,4,4296}]'),(1010031353,13,3,3601033,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,229154},{4,4,5729}]'),(1010031363,13,3,5122861,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,286443},{4,4,7161}]'),(1010031400,14,0,135185,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010031410,14,0,254400,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010031420,14,0,554235,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010031431,14,1,843134,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010031432,14,2,1079162,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010031441,14,1,1789529,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010031442,14,2,2402121,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,102675},{4,4,2567}]'),(1010031443,14,3,3110217,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,176479},{4,4,4412}]'),(1010031453,14,3,4586867,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,235306},{4,4,5883}]'),(1010031463,14,3,6485647,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,294132},{4,4,7353}]'),(1010031500,15,0,159557,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010031510,15,0,310051,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010031520,15,0,686633,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010031531,15,1,1060235,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010031532,15,2,1371943,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010031541,15,1,2274870,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010031542,15,2,3068674,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,107809},{4,4,2695}]'),(1010031543,15,3,3970786,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,185304},{4,4,4633}]'),(1010031553,15,3,5799599,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,247073},{4,4,6177}]'),(1010031563,15,3,8147443,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,308841},{4,4,7721}]'),(1010031600,16,0,6738355,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010031610,16,0,6831520,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010031620,16,0,7060751,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010031631,16,1,7172559,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010031632,16,2,7172559,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010031641,16,1,7483775,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010031642,16,2,7483775,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,113199},{4,4,2830}]'),(1010031643,16,3,7483775,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,194569},{4,4,4864}]'),(1010031653,16,3,8042840,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,259426},{4,4,6486}]'),(1010031663,16,3,8415550,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,324282},{4,4,8107}]'),(1010040100,1,0,787,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010040110,1,0,1889,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010040120,1,0,4427,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010040131,1,1,7551,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010040132,1,2,10047,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010040141,1,1,17120,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010040142,1,2,23592,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010040143,1,3,30432,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010040153,1,3,41325,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010040163,1,3,54888,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010040200,2,0,1359,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010040210,2,0,2990,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010040220,2,0,7254,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010040231,2,1,11974,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010040232,2,2,16454,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010040241,2,1,28950,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010040242,2,2,41774,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010040243,2,3,59282,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010040253,2,3,99094,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010040263,2,3,158259,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010040300,3,0,3238,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010040310,3,0,6229,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010040320,3,0,13595,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010040331,3,1,21174,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010040332,3,2,27986,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010040341,3,1,47953,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010040342,3,2,68245,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010040343,3,3,95161,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010040353,3,3,149382,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010040363,3,3,234938,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010040400,4,0,6503,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010040410,4,0,11538,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010040420,4,0,24269,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010040431,4,1,36150,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010040432,4,2,45566,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010040441,4,1,76894,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010040442,4,2,105114,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010040443,4,3,141978,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010040453,4,3,225027,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010040463,4,3,348733,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010040500,5,0,11257,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010040510,5,0,19397,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010040520,5,0,39868,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010040531,5,1,57419,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010040532,5,2,70571,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010040541,5,1,117644,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010040542,5,2,157132,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010040543,5,3,209584,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010040553,5,3,332262,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010040563,5,3,509792,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010040600,6,0,17603,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010040610,6,0,29891,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010040620,6,0,60810,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010040631,6,1,86457,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010040632,6,2,104861,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010040641,6,1,173847,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010040642,6,2,229119,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,46323},{4,4,1158}]'),(1010040643,6,3,302535,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,110868},{4,4,2771}]'),(1010040653,6,3,479794,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,147822},{4,4,3696}]'),(1010040663,6,3,731971,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,184780},{4,4,4620}]'),(1010040700,7,0,25594,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010040710,7,0,43266,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010040720,7,0,87741,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010040731,7,1,124224,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010040732,7,2,150004,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010040741,7,1,248150,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010040742,7,2,325550,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,72050},{4,4,1801}]'),(1010040743,7,3,428330,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,156857},{4,4,3921}]'),(1010040753,7,3,679328,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,209142},{4,4,5229}]'),(1010040763,7,3,1008555,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,261426},{4,4,6536}]'),(1010040800,8,0,35310,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010040810,8,0,59838,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010040820,8,0,121456,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010040831,8,1,172239,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010040832,8,2,208323,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010040841,8,1,344929,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010040842,8,2,453285,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,75963},{4,4,1899}]'),(1010040843,8,3,597165,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,158699},{4,4,3968}]'),(1010040853,8,3,931000,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,211598},{4,4,5290}]'),(1010040863,8,3,1362558,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,264498},{4,4,6613}]'),(1010040900,9,0,46872,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010040910,9,0,79920,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010040920,9,0,163041,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010040931,9,1,232585,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010040932,9,2,283109,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010040941,9,1,470052,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010040942,9,2,621756,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,79744},{4,4,1994}]'),(1010040943,9,3,812112,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,158887},{4,4,3972}]'),(1010040953,9,3,1249007,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,211848},{4,4,5296}]'),(1010040963,9,3,1818012,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,264811},{4,4,6621}]'),(1010041000,10,0,60339,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010041010,10,0,103978,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010041020,10,0,213853,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010041031,10,1,308070,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010041032,10,2,378814,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010041041,10,1,631682,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010041042,10,2,835530,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,83902},{4,4,2097}]'),(1010041043,10,3,1083810,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,160662},{4,4,4016}]'),(1010041053,10,3,1653846,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,214216},{4,4,5356}]'),(1010041063,10,3,2393761,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,267770},{4,4,6694}]'),(1010041100,11,0,75841,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010041110,11,0,132569,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010041120,11,0,275747,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010041131,11,1,402454,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010041132,11,2,501498,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010041141,11,1,834370,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010041142,11,2,1103918,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,88425},{4,4,2211}]'),(1010041143,11,3,1429478,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,163814},{4,4,4095}]'),(1010041153,11,3,2164696,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,218419},{4,4,5460}]'),(1010041163,11,3,3115085,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,273024},{4,4,6825}]'),(1010041200,12,0,93405,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010041210,12,0,166472,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010041220,12,0,351212,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010041231,12,1,520938,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010041232,12,2,654570,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010041241,12,1,1085877,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010041242,12,2,1442229,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,93044},{4,4,2326}]'),(1010041243,12,3,1867497,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,167378},{4,4,4184}]'),(1010041253,12,3,2804485,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,223172},{4,4,5579}]'),(1010041263,12,3,4012939,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,278965},{4,4,6974}]'),(1010041300,13,0,113160,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010041310,13,0,206620,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010041320,13,0,443629,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010041331,13,1,666154,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010041332,13,2,843898,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010041341,13,1,1399144,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010041342,13,2,1868112,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,97910},{4,4,2448}]'),(1010041343,13,3,2419200,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,171866},{4,4,4296}]'),(1010041353,13,3,3601033,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,229154},{4,4,5729}]'),(1010041363,13,3,5122861,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,286443},{4,4,7161}]'),(1010041400,14,0,135185,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010041410,14,0,254400,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010041420,14,0,554235,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010041431,14,1,843134,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010041432,14,2,1079162,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010041441,14,1,1789529,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010041442,14,2,2402121,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,102675},{4,4,2567}]'),(1010041443,14,3,3110217,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,176479},{4,4,4412}]'),(1010041453,14,3,4586867,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,235306},{4,4,5883}]'),(1010041463,14,3,6485647,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,294132},{4,4,7353}]'),(1010041500,15,0,159557,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010041510,15,0,310051,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010041520,15,0,686633,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010041531,15,1,1060235,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010041532,15,2,1371943,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010041541,15,1,2274870,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010041542,15,2,3068674,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,107809},{4,4,2695}]'),(1010041543,15,3,3970786,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,185304},{4,4,4633}]'),(1010041553,15,3,5799599,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,247073},{4,4,6177}]'),(1010041563,15,3,8147443,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,308841},{4,4,7721}]'),(1010041600,16,0,6738355,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010041610,16,0,6831520,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1010041620,16,0,7060751,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}},{10,{2,22,480}},{10,{2,10,180}}]',0,'[]',0,'[]','[]'),(1010041631,16,1,7172559,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010041632,16,2,7172559,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}},{10,{3,10,240}}]',0,'[]','[]'),(1010041641,16,1,7483775,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1010041642,16,2,7483775,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,113199},{4,4,2830}]'),(1010041643,16,3,7483775,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,194569},{4,4,4864}]'),(1010041653,16,3,8042840,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,259426},{4,4,6486}]'),(1010041663,16,3,8415550,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,324282},{4,4,8107}]'),(1011000001,0,0,2000,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1011000002,0,0,5000,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1011000003,0,0,4000,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1011000004,0,0,10000,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1011000005,0,0,2000,'[]',0,'[]',0,'[]',0,'[]',0,'[]','[]'),(1101010320,3,0,20953,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}}]',0,'[]',0,'[]','[]'),(1101010442,4,2,132225,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}}]','[]'),(1101010531,5,1,88682,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}}]',0,'[]','[]'),(1101010532,5,2,101834,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]','[]'),(1101010542,5,2,204064,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}}]','[]'),(1101010543,5,3,256516,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1101010641,6,1,247169,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}}]','[]'),(1101010732,7,2,220995,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]','[]'),(1101010742,7,2,432148,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}}]','[{4,1,6604},{4,3,3302}]'),(1101010743,7,3,534928,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,14378},{4,3,7189}]'),(1101010753,7,3,849893,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,19172},{4,3,9586}]'),(1101010842,8,2,600449,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}}]','[{4,1,6963},{4,3,3482}]'),(1101020320,3,0,20953,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}}]',0,'[]',0,'[]','[]'),(1101020442,4,2,132225,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}}]','[]'),(1101020531,5,1,88682,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}}]',0,'[]','[]'),(1101020532,5,2,101834,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]','[]'),(1101020542,5,2,204064,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}}]','[]'),(1101020543,5,3,256516,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1101020641,6,1,247169,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}}]','[]'),(1101020732,7,2,220995,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]','[]'),(1101020742,7,2,432148,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}}]','[{4,1,6604},{4,3,3302}]'),(1101020743,7,3,534928,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,14378},{4,3,7189}]'),(1101020753,7,3,849893,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,19172},{4,3,9586}]'),(1101020842,8,2,600449,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}}]','[{4,1,6963},{4,3,3482}]'),(1101030320,3,0,20953,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}}]',0,'[]',0,'[]','[]'),(1101030442,4,2,132225,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}}]','[]'),(1101030531,5,1,88682,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}}]',0,'[]','[]'),(1101030532,5,2,101834,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]','[]'),(1101030542,5,2,204064,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}}]','[]'),(1101030543,5,3,256516,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1101030641,6,1,247169,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}}]','[]'),(1101030732,7,2,220995,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]','[]'),(1101030742,7,2,432148,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}}]','[{4,1,6604},{4,3,3302}]'),(1101030743,7,3,534928,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,14378},{4,3,7189}]'),(1101030753,7,3,849893,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,19172},{4,3,9586}]'),(1101030842,8,2,600449,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}}]','[{4,1,6963},{4,3,3482}]'),(1101040320,3,0,20953,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}}]',0,'[]',0,'[]','[]'),(1101040442,4,2,132225,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}}]','[]'),(1101040531,5,1,88682,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}}]',0,'[]','[]'),(1101040532,5,2,101834,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]','[]'),(1101040542,5,2,204064,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}}]','[]'),(1101040543,5,3,256516,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1101040641,6,1,247169,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}}]','[]'),(1101040732,7,2,220995,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]','[]'),(1101040742,7,2,432148,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}}]','[{4,1,6604},{4,3,3302}]'),(1101040743,7,3,534928,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,14378},{4,3,7189}]'),(1101040753,7,3,849893,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,19172},{4,3,9586}]'),(1101040842,8,2,600449,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}}]','[{4,1,6963},{4,3,3482}]'),(1102010320,3,0,13595,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}}]',0,'[]',0,'[]','[]'),(1102010442,4,2,105114,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[]'),(1102010531,5,1,57419,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}}]',0,'[]','[]'),(1102010532,5,2,70571,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]','[]'),(1102010542,5,2,157132,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[]'),(1102010543,5,3,209584,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1102010641,6,1,173847,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}}]','[]'),(1102010732,7,2,150004,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]','[]'),(1102010742,7,2,325550,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[{4,2,72050},{4,4,1801}]'),(1102010743,7,3,428330,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,156857},{4,4,3921}]'),(1102010753,7,3,679328,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,209142},{4,4,5229}]'),(1102010842,8,2,453285,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[{4,2,75963},{4,4,1899}]'),(1102020320,3,0,13595,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}}]',0,'[]',0,'[]','[]'),(1102020442,4,2,105114,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[]'),(1102020531,5,1,57419,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}}]',0,'[]','[]'),(1102020532,5,2,70571,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]','[]'),(1102020542,5,2,157132,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[]'),(1102020543,5,3,209584,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1102020641,6,1,173847,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}}]','[]'),(1102020732,7,2,150004,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]','[]'),(1102020742,7,2,325550,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[{4,2,72050},{4,4,1801}]'),(1102020743,7,3,428330,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,156857},{4,4,3921}]'),(1102020753,7,3,679328,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,209142},{4,4,5229}]'),(1102020842,8,2,453285,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[{4,2,75963},{4,4,1899}]'),(1102030320,3,0,13595,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}}]',0,'[]',0,'[]','[]'),(1102030442,4,2,105114,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[]'),(1102030531,5,1,57419,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}}]',0,'[]','[]'),(1102030532,5,2,70571,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]','[]'),(1102030542,5,2,157132,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[]'),(1102030543,5,3,209584,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1102030641,6,1,173847,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}}]','[]'),(1102030732,7,2,150004,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]','[]'),(1102030742,7,2,325550,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[{4,2,72050},{4,4,1801}]'),(1102030743,7,3,428330,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,156857},{4,4,3921}]'),(1102030753,7,3,679328,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,209142},{4,4,5229}]'),(1102030842,8,2,453285,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[{4,2,75963},{4,4,1899}]'),(1102040320,3,0,13595,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}}]',0,'[]',0,'[]','[]'),(1102040442,4,2,105114,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[]'),(1102040531,5,1,57419,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}}]',0,'[]','[]'),(1102040532,5,2,70571,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]','[]'),(1102040542,5,2,157132,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[]'),(1102040543,5,3,209584,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1102040641,6,1,173847,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}}]','[]'),(1102040732,7,2,150004,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]','[]'),(1102040742,7,2,325550,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[{4,2,72050},{4,4,1801}]'),(1102040743,7,3,428330,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,156857},{4,4,3921}]'),(1102040753,7,3,679328,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,209142},{4,4,5229}]'),(1102040842,8,2,453285,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[{4,2,75963},{4,4,1899}]'),(1103000320,3,0,15558,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}}]',0,'[]',0,'[]','[]'),(1103000442,4,2,112360,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}}]','[]'),(1103000531,5,1,65757,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}}]',0,'[]','[]'),(1103000532,5,2,78909,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]','[]'),(1103000542,5,2,169659,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}}]','[]'),(1103000543,5,3,222111,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[]'),(1103000641,6,1,193394,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}}]','[]'),(1103000732,7,2,168930,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]','[]'),(1103000742,7,2,353973,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}}]','[{4,1,4403},{4,3,2201}]'),(1103000743,7,3,456753,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,9586},{4,3,4792}]'),(1103000753,7,3,724813,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,9,300}}]','[{4,1,12780},{4,3,6391}]'),(1103000842,8,2,492529,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}}]','[{4,1,4642},{4,3,2321}]'),(1104010320,3,0,18009,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}}]',0,'[]',0,'[]','[]'),(1104010442,4,2,121396,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[]'),(1104010531,5,1,76185,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}}]',0,'[]','[]'),(1104010532,5,2,89337,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]','[]'),(1104010542,5,2,185310,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[]'),(1104010543,5,3,237762,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1104010641,6,1,217841,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}}]','[]'),(1104010732,7,2,192593,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]','[]'),(1104010742,7,2,389510,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[{4,2,108075},{4,4,2702}]'),(1104010743,7,3,492290,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,235283},{4,4,5882}]'),(1104010753,7,3,781655,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,313712},{4,4,7842}]'),(1104010842,8,2,541573,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[{4,2,113944},{4,4,2848}]'),(1104020320,3,0,18009,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}}]',0,'[]',0,'[]','[]'),(1104020442,4,2,121396,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[]'),(1104020531,5,1,76185,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}}]',0,'[]','[]'),(1104020532,5,2,89337,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]','[]'),(1104020542,5,2,185310,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[]'),(1104020543,5,3,237762,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1104020641,6,1,217841,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}}]','[]'),(1104020732,7,2,192593,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]','[]'),(1104020742,7,2,389510,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[{4,2,108075},{4,4,2702}]'),(1104020743,7,3,492290,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,235283},{4,4,5882}]'),(1104020753,7,3,781655,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,313712},{4,4,7842}]'),(1104020842,8,2,541573,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[{4,2,113944},{4,4,2848}]'),(1104030320,3,0,18009,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}}]',0,'[]',0,'[]','[]'),(1104030442,4,2,121396,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[]'),(1104030531,5,1,76185,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}}]',0,'[]','[]'),(1104030532,5,2,89337,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]','[]'),(1104030542,5,2,185310,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[]'),(1104030543,5,3,237762,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1104030641,6,1,217841,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}}]','[]'),(1104030732,7,2,192593,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]','[]'),(1104030742,7,2,389510,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[{4,2,108075},{4,4,2702}]'),(1104030743,7,3,492290,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,235283},{4,4,5882}]'),(1104030753,7,3,781655,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,313712},{4,4,7842}]'),(1104030842,8,2,541573,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[{4,2,113944},{4,4,2848}]'),(1104040320,3,0,18009,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}}]',0,'[]',0,'[]','[]'),(1104040442,4,2,121396,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[]'),(1104040531,5,1,76185,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}}]',0,'[]','[]'),(1104040532,5,2,89337,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]','[]'),(1104040542,5,2,185310,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[]'),(1104040543,5,3,237762,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1104040641,6,1,217841,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}}]','[]'),(1104040732,7,2,192593,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]','[]'),(1104040742,7,2,389510,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[{4,2,108075},{4,4,2702}]'),(1104040743,7,3,492290,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,235283},{4,4,5882}]'),(1104040753,7,3,781655,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,313712},{4,4,7842}]'),(1104040842,8,2,541573,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[{4,2,113944},{4,4,2848}]'),(1105000320,3,0,10163,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}}]',0,'[]',0,'[]','[]'),(1105000442,4,2,92490,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}}]','[]'),(1105000531,5,1,42837,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}}]',0,'[]','[]'),(1105000532,5,2,55989,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]','[]'),(1105000542,5,2,135229,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}}]','[]'),(1105000543,5,3,187681,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1105000641,6,1,139639,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}}]','[]'),(1105000732,7,2,116865,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]','[]'),(1105000742,7,2,275803,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}}]','[{4,1,2201},{4,3,1101}]'),(1105000743,7,3,378583,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,4792},{4,3,2397}]'),(1105000753,7,3,599728,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,6391},{4,3,3195}]'),(1105000842,8,2,384604,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}}]','[{4,1,2321},{4,3,1160}]'),(1106010320,3,0,13595,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}}]',0,'[]',0,'[]','[]'),(1106010442,4,2,105114,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[]'),(1106010531,5,1,57419,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}}]',0,'[]','[]'),(1106010532,5,2,70571,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]','[]'),(1106010542,5,2,157132,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[]'),(1106010543,5,3,209584,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1106010641,6,1,173847,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}}]','[]'),(1106010732,7,2,150004,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]','[]'),(1106010742,7,2,325550,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[{4,2,72050},{4,4,1801}]'),(1106010743,7,3,428330,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,156857},{4,4,3921}]'),(1106010753,7,3,679328,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,209142},{4,4,5229}]'),(1106010842,8,2,453285,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[{4,2,75963},{4,4,1899}]'),(1106020320,3,0,13595,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}}]',0,'[]',0,'[]','[]'),(1106020442,4,2,105114,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[]'),(1106020531,5,1,57419,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}}]',0,'[]','[]'),(1106020532,5,2,70571,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]','[]'),(1106020542,5,2,157132,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[]'),(1106020543,5,3,209584,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1106020641,6,1,173847,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}}]','[]'),(1106020732,7,2,150004,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]','[]'),(1106020742,7,2,325550,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[{4,2,72050},{4,4,1801}]'),(1106020743,7,3,428330,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,156857},{4,4,3921}]'),(1106020753,7,3,679328,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,209142},{4,4,5229}]'),(1106020842,8,2,453285,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[{4,2,75963},{4,4,1899}]'),(1106030320,3,0,13595,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}}]',0,'[]',0,'[]','[]'),(1106030442,4,2,105114,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[]'),(1106030531,5,1,57419,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}}]',0,'[]','[]'),(1106030532,5,2,70571,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]','[]'),(1106030542,5,2,157132,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[]'),(1106030543,5,3,209584,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1106030641,6,1,173847,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}}]','[]'),(1106030732,7,2,150004,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]','[]'),(1106030742,7,2,325550,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[{4,2,72050},{4,4,1801}]'),(1106030743,7,3,428330,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,156857},{4,4,3921}]'),(1106030753,7,3,679328,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,209142},{4,4,5229}]'),(1106030842,8,2,453285,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[{4,2,75963},{4,4,1899}]'),(1106040320,3,0,13595,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}}]',0,'[]',0,'[]','[]'),(1106040442,4,2,105114,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[]'),(1106040531,5,1,57419,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}}]',0,'[]','[]'),(1106040532,5,2,70571,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]','[]'),(1106040542,5,2,157132,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[]'),(1106040543,5,3,209584,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1106040641,6,1,173847,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}}]','[]'),(1106040732,7,2,150004,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]','[]'),(1106040742,7,2,325550,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[{4,2,72050},{4,4,1801}]'),(1106040743,7,3,428330,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,156857},{4,4,3921}]'),(1106040753,7,3,679328,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,209142},{4,4,5229}]'),(1106040842,8,2,453285,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[{4,2,75963},{4,4,1899}]'),(1107010320,3,0,15558,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}}]',0,'[]',0,'[]','[]'),(1107010442,4,2,112360,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}}]','[]'),(1107010531,5,1,65757,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}}]',0,'[]','[]'),(1107010532,5,2,78909,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]','[]'),(1107010542,5,2,169659,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}}]','[]'),(1107010543,5,3,222111,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1107010641,6,1,193394,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}}]','[]'),(1107010732,7,2,168930,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]','[]'),(1107010742,7,2,353973,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}}]','[{4,1,4403},{4,3,2201}]'),(1107010743,7,3,456753,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,9586},{4,3,4792}]'),(1107010753,7,3,724813,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,12780},{4,3,6391}]'),(1107010842,8,2,492529,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}}]','[{4,1,4642},{4,3,2321}]'),(1107020320,3,0,15558,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}}]',0,'[]',0,'[]','[]'),(1107020442,4,2,112360,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}}]','[]'),(1107020531,5,1,65757,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}}]',0,'[]','[]'),(1107020532,5,2,78909,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]','[]'),(1107020542,5,2,169659,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}}]','[]'),(1107020543,5,3,222111,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1107020641,6,1,193394,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}}]','[]'),(1107020732,7,2,168930,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]','[]'),(1107020742,7,2,353973,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}}]','[{4,1,4403},{4,3,2201}]'),(1107020743,7,3,456753,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,9586},{4,3,4792}]'),(1107020753,7,3,724813,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,12780},{4,3,6391}]'),(1107020842,8,2,492529,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}}]','[{4,1,4642},{4,3,2321}]'),(1107030320,3,0,15558,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}}]',0,'[]',0,'[]','[]'),(1107030442,4,2,112360,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}}]','[]'),(1107030531,5,1,65757,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}}]',0,'[]','[]'),(1107030532,5,2,78909,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]','[]'),(1107030542,5,2,169659,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}}]','[]'),(1107030543,5,3,222111,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1107030641,6,1,193394,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}}]','[]'),(1107030732,7,2,168930,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]','[]'),(1107030742,7,2,353973,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}}]','[{4,1,4403},{4,3,2201}]'),(1107030743,7,3,456753,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,9586},{4,3,4792}]'),(1107030753,7,3,724813,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,12780},{4,3,6391}]'),(1107030842,8,2,492529,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}}]','[{4,1,4642},{4,3,2321}]'),(1107040320,3,0,15558,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}}]',0,'[]',0,'[]','[]'),(1107040442,4,2,112360,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}}]','[]'),(1107040531,5,1,65757,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}}]',0,'[]','[]'),(1107040532,5,2,78909,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]','[]'),(1107040542,5,2,169659,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}}]','[]'),(1107040543,5,3,222111,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1107040641,6,1,193394,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}}]','[]'),(1107040732,7,2,168930,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]','[]'),(1107040742,7,2,353973,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}}]','[{4,1,4403},{4,3,2201}]'),(1107040743,7,3,456753,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,9586},{4,3,4792}]'),(1107040753,7,3,724813,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,12780},{4,3,6391}]'),(1107040842,8,2,492529,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}}]','[{4,1,4642},{4,3,2321}]'),(1108010320,3,0,13595,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}}]',0,'[]',0,'[]','[]'),(1108010442,4,2,105114,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[]'),(1108010531,5,1,57419,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}}]',0,'[]','[]'),(1108010532,5,2,70571,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]','[]'),(1108010542,5,2,157132,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[]'),(1108010543,5,3,209584,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1108010641,6,1,173847,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}}]','[]'),(1108010732,7,2,150004,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]','[]'),(1108010742,7,2,325550,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[{4,2,72050},{4,4,1801}]'),(1108010743,7,3,428330,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,156857},{4,4,3921}]'),(1108010753,7,3,679328,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,209142},{4,4,5229}]'),(1108010842,8,2,453285,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[{4,2,75963},{4,4,1899}]'),(1108020320,3,0,13595,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}}]',0,'[]',0,'[]','[]'),(1108020442,4,2,105114,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[]'),(1108020531,5,1,57419,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}}]',0,'[]','[]'),(1108020532,5,2,70571,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]','[]'),(1108020542,5,2,157132,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[]'),(1108020543,5,3,209584,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1108020641,6,1,173847,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}}]','[]'),(1108020732,7,2,150004,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]','[]'),(1108020742,7,2,325550,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[{4,2,72050},{4,4,1801}]'),(1108020743,7,3,428330,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,156857},{4,4,3921}]'),(1108020753,7,3,679328,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,209142},{4,4,5229}]'),(1108020842,8,2,453285,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[{4,2,75963},{4,4,1899}]'),(1108030320,3,0,13595,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}}]',0,'[]',0,'[]','[]'),(1108030442,4,2,105114,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[]'),(1108030531,5,1,57419,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}}]',0,'[]','[]'),(1108030532,5,2,70571,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]','[]'),(1108030542,5,2,157132,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[]'),(1108030543,5,3,209584,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1108030641,6,1,173847,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}}]','[]'),(1108030732,7,2,150004,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]','[]'),(1108030742,7,2,325550,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[{4,2,72050},{4,4,1801}]'),(1108030743,7,3,428330,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,156857},{4,4,3921}]'),(1108030753,7,3,679328,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,209142},{4,4,5229}]'),(1108030842,8,2,453285,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[{4,2,75963},{4,4,1899}]'),(1108040320,3,0,13595,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}}]',0,'[]',0,'[]','[]'),(1108040442,4,2,105114,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[]'),(1108040531,5,1,57419,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}}]',0,'[]','[]'),(1108040532,5,2,70571,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]','[]'),(1108040542,5,2,157132,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[]'),(1108040543,5,3,209584,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1108040641,6,1,173847,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}}]','[]'),(1108040732,7,2,150004,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]','[]'),(1108040742,7,2,325550,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[{4,2,72050},{4,4,1801}]'),(1108040743,7,3,428330,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,156857},{4,4,3921}]'),(1108040753,7,3,679328,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,209142},{4,4,5229}]'),(1108040842,8,2,453285,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[{4,2,75963},{4,4,1899}]'),(1109000320,3,0,10163,'[{10,{2,19,240}}]',0,'[]',1,'[{10,{2,19,240}}]',0,'[]',0,'[]','[]'),(1109000442,4,2,92490,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}}]','[]'),(1109000531,5,1,42837,'[{10,{3,19,320}}]',0,'[]',0,'[]',1,'[{10,{3,19,320}}]',0,'[]','[]'),(1109000532,5,2,55989,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]','[]'),(1109000542,5,2,135229,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}}]','[]'),(1109000543,5,3,187681,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[]'),(1109000641,6,1,139639,'[{10,{4,19,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,19,400}}]','[]'),(1109000732,7,2,116865,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]',0,'[]',2,'[{10,{3,19,320}},{10,{3,21,640}}]',0,'[]','[]'),(1109000742,7,2,275803,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}}]','[{4,1,2201},{4,3,1101}]'),(1109000743,7,3,378583,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,4792},{4,3,2397}]'),(1109000753,7,3,599728,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,19,400}},{10,{4,21,800}},{10,{4,13,250}}]','[{4,1,6391},{4,3,3195}]'),(1109000842,8,2,384604,'[{10,{4,19,400}},{10,{4,21,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,19,400}},{10,{4,21,800}}]','[{4,1,2321},{4,3,1160}]'),(1110010320,3,0,13595,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}}]',0,'[]',0,'[]','[]'),(1110010442,4,2,105114,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[]'),(1110010531,5,1,57419,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}}]',0,'[]','[]'),(1110010532,5,2,70571,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]','[]'),(1110010542,5,2,157132,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[]'),(1110010543,5,3,209584,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1110010641,6,1,173847,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}}]','[]'),(1110010732,7,2,150004,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]','[]'),(1110010742,7,2,325550,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[{4,2,72050},{4,4,1801}]'),(1110010743,7,3,428330,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,156857},{4,4,3921}]'),(1110010753,7,3,679328,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,209142},{4,4,5229}]'),(1110010842,8,2,453285,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[{4,2,75963},{4,4,1899}]'),(1110020320,3,0,13595,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}}]',0,'[]',0,'[]','[]'),(1110020442,4,2,105114,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[]'),(1110020531,5,1,57419,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}}]',0,'[]','[]'),(1110020532,5,2,70571,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]','[]'),(1110020542,5,2,157132,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[]'),(1110020543,5,3,209584,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1110020641,6,1,173847,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}}]','[]'),(1110020732,7,2,150004,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]','[]'),(1110020742,7,2,325550,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[{4,2,72050},{4,4,1801}]'),(1110020743,7,3,428330,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,156857},{4,4,3921}]'),(1110020753,7,3,679328,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,209142},{4,4,5229}]'),(1110020842,8,2,453285,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[{4,2,75963},{4,4,1899}]'),(1110030320,3,0,13595,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}}]',0,'[]',0,'[]','[]'),(1110030442,4,2,105114,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[]'),(1110030531,5,1,57419,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}}]',0,'[]','[]'),(1110030532,5,2,70571,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]','[]'),(1110030542,5,2,157132,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[]'),(1110030543,5,3,209584,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1110030641,6,1,173847,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}}]','[]'),(1110030732,7,2,150004,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]','[]'),(1110030742,7,2,325550,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[{4,2,72050},{4,4,1801}]'),(1110030743,7,3,428330,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,156857},{4,4,3921}]'),(1110030753,7,3,679328,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,209142},{4,4,5229}]'),(1110030842,8,2,453285,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[{4,2,75963},{4,4,1899}]'),(1110040320,3,0,13595,'[{10,{2,20,240}}]',0,'[]',1,'[{10,{2,20,240}}]',0,'[]',0,'[]','[]'),(1110040442,4,2,105114,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[]'),(1110040531,5,1,57419,'[{10,{3,20,320}}]',0,'[]',0,'[]',1,'[{10,{3,20,320}}]',0,'[]','[]'),(1110040532,5,2,70571,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]','[]'),(1110040542,5,2,157132,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[]'),(1110040543,5,3,209584,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[]'),(1110040641,6,1,173847,'[{10,{4,20,400}}]',0,'[]',0,'[]',0,'[]',1,'[{10,{4,20,400}}]','[]'),(1110040732,7,2,150004,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]',0,'[]',2,'[{10,{3,20,320}},{10,{3,22,640}}]',0,'[]','[]'),(1110040742,7,2,325550,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[{4,2,72050},{4,4,1801}]'),(1110040743,7,3,428330,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,156857},{4,4,3921}]'),(1110040753,7,3,679328,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]',0,'[]',0,'[]',0,'[]',3,'[{10,{4,20,400}},{10,{4,22,800}},{10,{4,10,300}}]','[{4,2,209142},{4,4,5229}]'),(1110040842,8,2,453285,'[{10,{4,20,400}},{10,{4,22,800}}]',0,'[]',0,'[]',0,'[]',2,'[{10,{4,20,400}},{10,{4,22,800}}]','[{4,2,75963},{4,4,1899}]');
/*!40000 ALTER TABLE `base_equip_attr` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_equip_attr_rating`
--

DROP TABLE IF EXISTS `base_equip_attr_rating`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_equip_attr_rating` (
  `attr_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '属性类型',
  `stage` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '装备阶数',
  `min_lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '人物等级下限',
  `max_lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '任务等级上限',
  `rating` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '评分',
  PRIMARY KEY (`attr_id`,`stage`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备属性评分配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_equip_attr_rating`
--

LOCK TABLES `base_equip_attr_rating` WRITE;
/*!40000 ALTER TABLE `base_equip_attr_rating` DISABLE KEYS */;
INSERT INTO `base_equip_attr_rating` VALUES (1,1,1,39,20),(1,2,40,59,20),(1,3,60,99,20),(1,4,100,149,20),(1,5,150,179,20),(1,6,180,219,20),(1,7,220,259,20),(1,8,260,299,20),(1,9,300,354,20),(1,10,355,399,20),(1,11,400,499,20),(1,12,500,519,20),(1,13,520,619,20),(1,14,620,649,20),(1,15,650,699,20),(1,16,700,1000,20),(2,1,1,39,1),(2,2,40,59,1),(2,3,60,99,1),(2,4,100,149,1),(2,5,150,179,1),(2,6,180,219,1),(2,7,220,259,1),(2,8,260,299,1),(2,9,300,354,1),(2,10,355,399,1),(2,11,400,499,1),(2,12,500,519,1),(2,13,520,619,1),(2,14,620,649,1),(2,15,650,699,1),(2,16,700,1000,1),(3,1,1,39,25),(3,2,40,59,25),(3,3,60,99,25),(3,4,100,149,25),(3,5,150,179,25),(3,6,180,219,25),(3,7,220,259,25),(3,8,260,299,25),(3,9,300,354,25),(3,10,355,399,25),(3,11,400,499,25),(3,12,500,519,25),(3,13,520,619,25),(3,14,620,649,25),(3,15,650,699,25),(3,16,700,1000,25),(4,1,1,39,25),(4,2,40,59,25),(4,3,60,99,25),(4,4,100,149,25),(4,5,150,179,25),(4,6,180,219,25),(4,7,220,259,25),(4,8,260,299,25),(4,9,300,354,25),(4,10,355,399,25),(4,11,400,499,25),(4,12,500,519,25),(4,13,520,619,25),(4,14,620,649,25),(4,15,650,699,25),(4,16,700,1000,25),(5,1,1,39,50),(5,2,40,59,50),(5,3,60,99,50),(5,4,100,149,50),(5,5,150,179,50),(5,6,180,219,50),(5,7,220,259,50),(5,8,260,299,50),(5,9,300,354,50),(5,10,355,399,50),(5,11,400,499,50),(5,12,500,519,50),(5,13,520,619,50),(5,14,620,649,50),(5,15,650,699,50),(5,16,700,1000,50),(6,1,1,39,50),(6,2,40,59,50),(6,3,60,99,50),(6,4,100,149,50),(6,5,150,179,50),(6,6,180,219,50),(6,7,220,259,50),(6,8,260,299,50),(6,9,300,354,50),(6,10,355,399,50),(6,11,400,499,50),(6,12,500,519,50),(6,13,520,619,50),(6,14,620,649,50),(6,15,650,699,50),(6,16,700,1000,50),(7,1,1,39,50),(7,2,40,59,50),(7,3,60,99,50),(7,4,100,149,50),(7,5,150,179,50),(7,6,180,219,50),(7,7,220,259,50),(7,8,260,299,50),(7,9,300,354,50),(7,10,355,399,50),(7,11,400,499,50),(7,12,500,519,50),(7,13,520,619,50),(7,14,620,649,50),(7,15,650,699,50),(7,16,700,1000,50),(8,1,1,39,50),(8,2,40,59,50),(8,3,60,99,50),(8,4,100,149,50),(8,5,150,179,50),(8,6,180,219,50),(8,7,220,259,50),(8,8,260,299,50),(8,9,300,354,50),(8,10,355,399,50),(8,11,400,499,50),(8,12,500,519,50),(8,13,520,619,50),(8,14,620,649,50),(8,15,650,699,50),(8,16,700,1000,50),(9,1,1,39,0),(9,2,40,59,8),(9,3,60,99,12),(9,4,100,149,20),(9,5,150,179,30),(9,6,180,219,36),(9,7,220,259,44),(9,8,260,299,52),(9,9,300,354,60),(9,10,355,399,71),(9,11,400,499,80),(9,12,500,519,100),(9,13,520,619,104),(9,14,620,649,124),(9,15,650,699,130),(9,16,700,1000,140),(10,1,1,39,0),(10,2,40,59,8),(10,3,60,99,12),(10,4,100,149,20),(10,5,150,179,30),(10,6,180,219,36),(10,7,220,259,44),(10,8,260,299,52),(10,9,300,354,60),(10,10,355,399,71),(10,11,400,499,80),(10,12,500,519,100),(10,13,520,619,104),(10,14,620,649,124),(10,15,650,699,130),(10,16,700,1000,140),(11,1,1,39,1),(11,2,40,59,20),(11,3,60,99,30),(11,4,100,149,50),(11,5,150,179,75),(11,6,180,219,90),(11,7,220,259,110),(11,8,260,299,130),(11,9,300,354,150),(11,10,355,399,178),(11,11,400,499,200),(11,12,500,519,250),(11,13,520,619,260),(11,14,620,649,310),(11,15,650,699,325),(11,16,700,1000,350),(12,1,1,39,1),(12,2,40,59,20),(12,3,60,99,30),(12,4,100,149,50),(12,5,150,179,75),(12,6,180,219,90),(12,7,220,259,110),(12,8,260,299,130),(12,9,300,354,150),(12,10,355,399,178),(12,11,400,499,200),(12,12,500,519,250),(12,13,520,619,260),(12,14,620,649,310),(12,15,650,699,325),(12,16,700,1000,350),(13,1,1,39,1),(13,2,40,59,20),(13,3,60,99,30),(13,4,100,149,50),(13,5,150,179,75),(13,6,180,219,90),(13,7,220,259,110),(13,8,260,299,130),(13,9,300,354,150),(13,10,355,399,178),(13,11,400,499,200),(13,12,500,519,250),(13,13,520,619,260),(13,14,620,649,310),(13,15,650,699,325),(13,16,700,1000,350),(14,1,1,39,1),(14,2,40,59,20),(14,3,60,99,30),(14,4,100,149,50),(14,5,150,179,75),(14,6,180,219,90),(14,7,220,259,110),(14,8,260,299,130),(14,9,300,354,150),(14,10,355,399,178),(14,11,400,499,200),(14,12,500,519,250),(14,13,520,619,260),(14,14,620,649,310),(14,15,650,699,325),(14,16,700,1000,350),(15,1,1,39,30),(15,2,40,59,30),(15,3,60,99,30),(15,4,100,149,30),(15,5,150,179,30),(15,6,180,219,30),(15,7,220,259,30),(15,8,260,299,30),(15,9,300,354,30),(15,10,355,399,30),(15,11,400,499,30),(15,12,500,519,30),(15,13,520,619,30),(15,14,620,649,30),(15,15,650,699,30),(15,16,700,1000,30),(16,1,1,39,30),(16,2,40,59,30),(16,3,60,99,30),(16,4,100,149,30),(16,5,150,179,30),(16,6,180,219,30),(16,7,220,259,30),(16,8,260,299,30),(16,9,300,354,30),(16,10,355,399,30),(16,11,400,499,30),(16,12,500,519,30),(16,13,520,619,30),(16,14,620,649,30),(16,15,650,699,30),(16,16,700,1000,30),(18,1,1,39,20),(18,2,40,59,20),(18,3,60,99,20),(18,4,100,149,20),(18,5,150,179,20),(18,6,180,219,20),(18,7,220,259,20),(18,8,260,299,20),(18,9,300,354,20),(18,10,355,399,20),(18,11,400,499,20),(18,12,500,519,20),(18,13,520,619,20),(18,14,620,649,20),(18,15,650,699,20),(18,16,700,1000,20),(19,1,1,39,0),(19,2,40,59,6),(19,3,60,99,9),(19,4,100,149,15),(19,5,150,179,23),(19,6,180,219,27),(19,7,220,259,33),(19,8,260,299,39),(19,9,300,354,45),(19,10,355,399,53),(19,11,400,499,60),(19,12,500,519,75),(19,13,520,619,78),(19,14,620,649,93),(19,15,650,699,98),(19,16,700,1000,105),(20,1,1,39,0),(20,2,40,59,6),(20,3,60,99,9),(20,4,100,149,15),(20,5,150,179,23),(20,6,180,219,27),(20,7,220,259,33),(20,8,260,299,39),(20,9,300,354,45),(20,10,355,399,53),(20,11,400,499,60),(20,12,500,519,75),(20,13,520,619,78),(20,14,620,649,93),(20,15,650,699,98),(20,16,700,1000,105),(21,1,1,39,0),(21,2,40,59,3),(21,3,60,99,5),(21,4,100,149,8),(21,5,150,179,11),(21,6,180,219,14),(21,7,220,259,17),(21,8,260,299,20),(21,9,300,354,23),(21,10,355,399,27),(21,11,400,499,30),(21,12,500,519,38),(21,13,520,619,39),(21,14,620,649,47),(21,15,650,699,49),(21,16,700,1000,53),(22,1,1,39,0),(22,2,40,59,3),(22,3,60,99,5),(22,4,100,149,8),(22,5,150,179,11),(22,6,180,219,14),(22,7,220,259,17),(22,8,260,299,20),(22,9,300,354,23),(22,10,355,399,27),(22,11,400,499,30),(22,12,500,519,38),(22,13,520,619,39),(22,14,620,649,47),(22,15,650,699,49),(22,16,700,1000,53),(23,1,1,39,0),(23,2,40,59,0),(23,3,60,99,1),(23,4,100,149,1),(23,5,150,179,0),(23,6,180,219,0),(23,7,220,259,1),(23,8,260,299,2),(23,9,300,354,4),(23,10,355,399,9),(23,11,400,499,18),(23,12,500,519,41),(23,13,520,619,51),(23,14,620,649,97),(23,15,650,699,112),(23,16,700,1000,134),(24,1,1,39,0),(24,2,40,59,0),(24,3,60,99,1),(24,4,100,149,1),(24,5,150,179,0),(24,6,180,219,0),(24,7,220,259,1),(24,8,260,299,2),(24,9,300,354,4),(24,10,355,399,9),(24,11,400,499,18),(24,12,500,519,41),(24,13,520,619,51),(24,14,620,649,97),(24,15,650,699,112),(24,16,700,1000,134),(25,1,1,39,0),(25,2,40,59,0),(25,3,60,99,0),(25,4,100,149,0),(25,5,150,179,0),(25,6,180,219,0),(25,7,220,259,1),(25,8,260,299,3),(25,9,300,354,5),(25,10,355,399,8),(25,11,400,499,14),(25,12,500,519,30),(25,13,520,619,37),(25,14,620,649,64),(25,15,650,699,75),(25,16,700,1000,85),(26,1,1,39,0),(26,2,40,59,0),(26,3,60,99,0),(26,4,100,149,0),(26,5,150,179,0),(26,6,180,219,0),(26,7,220,259,1),(26,8,260,299,3),(26,9,300,354,5),(26,10,355,399,8),(26,11,400,499,14),(26,12,500,519,29),(26,13,520,619,36),(26,14,620,649,63),(26,15,650,699,74),(26,16,700,1000,85),(27,1,1,39,0),(27,2,40,59,5),(27,3,60,99,7),(27,4,100,149,12),(27,5,150,179,18),(27,6,180,219,22),(27,7,220,259,26),(27,8,260,299,31),(27,9,300,354,36),(27,10,355,399,43),(27,11,400,499,48),(27,12,500,519,60),(27,13,520,619,62),(27,14,620,649,74),(27,15,650,699,78),(27,16,700,1000,84),(28,1,1,39,0),(28,2,40,59,5),(28,3,60,99,7),(28,4,100,149,12),(28,5,150,179,18),(28,6,180,219,22),(28,7,220,259,26),(28,8,260,299,31),(28,9,300,354,36),(28,10,355,399,43),(28,11,400,499,48),(28,12,500,519,60),(28,13,520,619,62),(28,14,620,649,74),(28,15,650,699,78),(28,16,700,1000,84),(29,1,1,39,0),(29,2,40,59,0),(29,3,60,99,0),(29,4,100,149,0),(29,5,150,179,0),(29,6,180,219,0),(29,7,220,259,0),(29,8,260,299,0),(29,9,300,354,0),(29,10,355,399,0),(29,11,400,499,0),(29,12,500,519,0),(29,13,520,619,0),(29,14,620,649,0),(29,15,650,699,0),(29,16,700,1000,0),(30,1,1,39,0),(30,2,40,59,0),(30,3,60,99,0),(30,4,100,149,0),(30,5,150,179,0),(30,6,180,219,0),(30,7,220,259,0),(30,8,260,299,0),(30,9,300,354,0),(30,10,355,399,0),(30,11,400,499,0),(30,12,500,519,0),(30,13,520,619,0),(30,14,620,649,0),(30,15,650,699,0),(30,16,700,1000,0),(48,1,1,39,30),(48,2,40,59,30),(48,3,60,99,30),(48,4,100,149,30),(48,5,150,179,30),(48,6,180,219,30),(48,7,220,259,30),(48,8,260,299,30),(48,9,300,354,30),(48,10,355,399,30),(48,11,400,499,30),(48,12,500,519,30),(48,13,520,619,30),(48,14,620,649,30),(48,15,650,699,30),(48,16,700,1000,30),(49,1,1,39,30),(49,2,40,59,30),(49,3,60,99,30),(49,4,100,149,30),(49,5,150,179,30),(49,6,180,219,30),(49,7,220,259,30),(49,8,260,299,30),(49,9,300,354,30),(49,10,355,399,30),(49,11,400,499,30),(49,12,500,519,30),(49,13,520,619,30),(49,14,620,649,30),(49,15,650,699,30),(49,16,700,1000,30),(50,1,1,39,0),(50,2,40,59,6),(50,3,60,99,9),(50,4,100,149,15),(50,5,150,179,23),(50,6,180,219,27),(50,7,220,259,33),(50,8,260,299,39),(50,9,300,354,45),(50,10,355,399,53),(50,11,400,499,60),(50,12,500,519,75),(50,13,520,619,78),(50,14,620,649,93),(50,15,650,699,98),(50,16,700,1000,105),(51,1,1,39,0),(51,2,40,59,6),(51,3,60,99,9),(51,4,100,149,15),(51,5,150,179,23),(51,6,180,219,27),(51,7,220,259,33),(51,8,260,299,39),(51,9,300,354,45),(51,10,355,399,53),(51,11,400,499,60),(51,12,500,519,75),(51,13,520,619,78),(51,14,620,649,93),(51,15,650,699,98),(51,16,700,1000,105),(52,1,1,39,0),(52,2,40,59,5),(52,3,60,99,7),(52,4,100,149,12),(52,5,150,179,18),(52,6,180,219,22),(52,7,220,259,26),(52,8,260,299,31),(52,9,300,354,36),(52,10,355,399,43),(52,11,400,499,48),(52,12,500,519,60),(52,13,520,619,62),(52,14,620,649,74),(52,15,650,699,78),(52,16,700,1000,84),(53,1,1,39,0),(53,2,40,59,5),(53,3,60,99,7),(53,4,100,149,12),(53,5,150,179,18),(53,6,180,219,22),(53,7,220,259,26),(53,8,260,299,31),(53,9,300,354,36),(53,10,355,399,43),(53,11,400,499,48),(53,12,500,519,60),(53,13,520,619,62),(53,14,620,649,74),(53,15,650,699,78),(53,16,700,1000,84),(54,1,1,39,0),(54,2,40,59,14),(54,3,60,99,21),(54,4,100,149,35),(54,5,150,179,53),(54,6,180,219,63),(54,7,220,259,77),(54,8,260,299,91),(54,9,300,354,105),(54,10,355,399,124),(54,11,400,499,140),(54,12,500,519,175),(54,13,520,619,182),(54,14,620,649,217),(54,15,650,699,228),(54,16,700,1000,245),(55,1,1,39,1),(55,2,40,59,20),(55,3,60,99,30),(55,4,100,149,50),(55,5,150,179,75),(55,6,180,219,90),(55,7,220,259,110),(55,8,260,299,130),(55,9,300,354,150),(55,10,355,399,178),(55,11,400,499,200),(55,12,500,519,250),(55,13,520,619,260),(55,14,620,649,310),(55,15,650,699,325),(55,16,700,1000,350),(56,1,1,39,0),(56,2,40,59,14),(56,3,60,99,21),(56,4,100,149,35),(56,5,150,179,53),(56,6,180,219,63),(56,7,220,259,77),(56,8,260,299,91),(56,9,300,354,105),(56,10,355,399,124),(56,11,400,499,140),(56,12,500,519,175),(56,13,520,619,182),(56,14,620,649,217),(56,15,650,699,228),(56,16,700,1000,245),(57,1,1,39,1),(57,2,40,59,20),(57,3,60,99,30),(57,4,100,149,50),(57,5,150,179,75),(57,6,180,219,90),(57,7,220,259,110),(57,8,260,299,130),(57,9,300,354,150),(57,10,355,399,178),(57,11,400,499,200),(57,12,500,519,250),(57,13,520,619,260),(57,14,620,649,310),(57,15,650,699,325),(57,16,700,1000,350),(58,1,1,39,0),(58,2,40,59,6),(58,3,60,99,9),(58,4,100,149,15),(58,5,150,179,23),(58,6,180,219,27),(58,7,220,259,33),(58,8,260,299,39),(58,9,300,354,45),(58,10,355,399,53),(58,11,400,499,60),(58,12,500,519,75),(58,13,520,619,78),(58,14,620,649,93),(58,15,650,699,98),(58,16,700,1000,105),(59,1,1,39,0),(59,2,40,59,6),(59,3,60,99,9),(59,4,100,149,15),(59,5,150,179,23),(59,6,180,219,27),(59,7,220,259,33),(59,8,260,299,39),(59,9,300,354,45),(59,10,355,399,53),(59,11,400,499,60),(59,12,500,519,75),(59,13,520,619,78),(59,14,620,649,93),(59,15,650,699,98),(59,16,700,1000,105),(60,1,1,39,0),(60,2,40,59,0),(60,3,60,99,0),(60,4,100,149,0),(60,5,150,179,0),(60,6,180,219,0),(60,7,220,259,0),(60,8,260,299,0),(60,9,300,354,0),(60,10,355,399,0),(60,11,400,499,0),(60,12,500,519,0),(60,13,520,619,0),(60,14,620,649,0),(60,15,650,699,0),(60,16,700,1000,0),(61,1,1,39,0),(61,2,40,59,0),(61,3,60,99,0),(61,4,100,149,0),(61,5,150,179,0),(61,6,180,219,0),(61,7,220,259,0),(61,8,260,299,0),(61,9,300,354,0),(61,10,355,399,0),(61,11,400,499,0),(61,12,500,519,0),(61,13,520,619,0),(61,14,620,649,0),(61,15,650,699,0),(61,16,700,1000,0),(62,1,1,39,0),(62,2,40,59,0),(62,3,60,99,0),(62,4,100,149,0),(62,5,150,179,0),(62,6,180,219,0),(62,7,220,259,0),(62,8,260,299,0),(62,9,300,354,0),(62,10,355,399,0),(62,11,400,499,0),(62,12,500,519,0),(62,13,520,619,0),(62,14,620,649,0),(62,15,650,699,0),(62,16,700,1000,0),(63,1,1,39,0),(63,2,40,59,0),(63,3,60,99,0),(63,4,100,149,0),(63,5,150,179,0),(63,6,180,219,0),(63,7,220,259,0),(63,8,260,299,0),(63,9,300,354,0),(63,10,355,399,0),(63,11,400,499,0),(63,12,500,519,0),(63,13,520,619,0),(63,14,620,649,0),(63,15,650,699,0),(63,16,700,1000,0),(64,1,1,39,0),(64,2,40,59,0),(64,3,60,99,0),(64,4,100,149,0),(64,5,150,179,0),(64,6,180,219,0),(64,7,220,259,0),(64,8,260,299,0),(64,9,300,354,0),(64,10,355,399,0),(64,11,400,499,0),(64,12,500,519,0),(64,13,520,619,0),(64,14,620,649,0),(64,15,650,699,0),(64,16,700,1000,0),(65,1,1,39,0),(65,2,40,59,0),(65,3,60,99,0),(65,4,100,149,0),(65,5,150,179,0),(65,6,180,219,0),(65,7,220,259,0),(65,8,260,299,0),(65,9,300,354,0),(65,10,355,399,0),(65,11,400,499,0),(65,12,500,519,0),(65,13,520,619,0),(65,14,620,649,0),(65,15,650,699,0),(65,16,700,1000,0),(66,1,1,39,0),(66,2,40,59,0),(66,3,60,99,0),(66,4,100,149,0),(66,5,150,179,0),(66,6,180,219,0),(66,7,220,259,0),(66,8,260,299,0),(66,9,300,354,0),(66,10,355,399,0),(66,11,400,499,0),(66,12,500,519,0),(66,13,520,619,0),(66,14,620,649,0),(66,15,650,699,0),(66,16,700,1000,0),(67,1,1,39,0),(67,2,40,59,0),(67,3,60,99,0),(67,4,100,149,0),(67,5,150,179,0),(67,6,180,219,0),(67,7,220,259,0),(67,8,260,299,0),(67,9,300,354,0),(67,10,355,399,0),(67,11,400,499,0),(67,12,500,519,0),(67,13,520,619,0),(67,14,620,649,0),(67,15,650,699,0),(67,16,700,1000,0),(68,1,1,39,0),(68,2,40,59,0),(68,3,60,99,0),(68,4,100,149,0),(68,5,150,179,0),(68,6,180,219,0),(68,7,220,259,0),(68,8,260,299,0),(68,9,300,354,0),(68,10,355,399,0),(68,11,400,499,0),(68,12,500,519,0),(68,13,520,619,0),(68,14,620,649,0),(68,15,650,699,0),(68,16,700,1000,0),(69,1,1,39,0),(69,2,40,59,0),(69,3,60,99,0),(69,4,100,149,0),(69,5,150,179,0),(69,6,180,219,0),(69,7,220,259,0),(69,8,260,299,0),(69,9,300,354,0),(69,10,355,399,0),(69,11,400,499,0),(69,12,500,519,0),(69,13,520,619,0),(69,14,620,649,0),(69,15,650,699,0),(69,16,700,1000,0),(70,1,1,39,0),(70,2,40,59,0),(70,3,60,99,0),(70,4,100,149,0),(70,5,150,179,0),(70,6,180,219,0),(70,7,220,259,0),(70,8,260,299,0),(70,9,300,354,0),(70,10,355,399,0),(70,11,400,499,0),(70,12,500,519,0),(70,13,520,619,0),(70,14,620,649,0),(70,15,650,699,0),(70,16,700,1000,0),(71,1,1,39,0),(71,2,40,59,0),(71,3,60,99,0),(71,4,100,149,0),(71,5,150,179,0),(71,6,180,219,0),(71,7,220,259,0),(71,8,260,299,0),(71,9,300,354,0),(71,10,355,399,0),(71,11,400,499,0),(71,12,500,519,0),(71,13,520,619,0),(71,14,620,649,0),(71,15,650,699,0),(71,16,700,1000,0),(72,1,1,39,0),(72,2,40,59,0),(72,3,60,99,0),(72,4,100,149,0),(72,5,150,179,0),(72,6,180,219,0),(72,7,220,259,0),(72,8,260,299,0),(72,9,300,354,0),(72,10,355,399,0),(72,11,400,499,0),(72,12,500,519,0),(72,13,520,619,0),(72,14,620,649,0),(72,15,650,699,0),(72,16,700,1000,0),(73,1,1,39,0),(73,2,40,59,0),(73,3,60,99,0),(73,4,100,149,0),(73,5,150,179,0),(73,6,180,219,0),(73,7,220,259,0),(73,8,260,299,0),(73,9,300,354,0),(73,10,355,399,0),(73,11,400,499,0),(73,12,500,519,0),(73,13,520,619,0),(73,14,620,649,0),(73,15,650,699,0),(73,16,700,1000,0),(74,1,1,39,0),(74,2,40,59,0),(74,3,60,99,0),(74,4,100,149,0),(74,5,150,179,0),(74,6,180,219,0),(74,7,220,259,0),(74,8,260,299,0),(74,9,300,354,0),(74,10,355,399,0),(74,11,400,499,0),(74,12,500,519,0),(74,13,520,619,0),(74,14,620,649,0),(74,15,650,699,0),(74,16,700,1000,0),(75,1,1,39,0),(75,2,40,59,0),(75,3,60,99,0),(75,4,100,149,0),(75,5,150,179,0),(75,6,180,219,0),(75,7,220,259,0),(75,8,260,299,0),(75,9,300,354,0),(75,10,355,399,0),(75,11,400,499,0),(75,12,500,519,0),(75,13,520,619,0),(75,14,620,649,0),(75,15,650,699,0),(75,16,700,1000,0),(76,1,1,39,0),(76,2,40,59,0),(76,3,60,99,0),(76,4,100,149,0),(76,5,150,179,0),(76,6,180,219,0),(76,7,220,259,0),(76,8,260,299,0),(76,9,300,354,0),(76,10,355,399,0),(76,11,400,499,0),(76,12,500,519,0),(76,13,520,619,0),(76,14,620,649,0),(76,15,650,699,0),(76,16,700,1000,0),(77,1,1,39,30),(77,2,40,59,30),(77,3,60,99,30),(77,4,100,149,30),(77,5,150,179,30),(77,6,180,219,30),(77,7,220,259,30),(77,8,260,299,30),(77,9,300,354,30),(77,10,355,399,30),(77,11,400,499,30),(77,12,500,519,30),(77,13,520,619,30),(77,14,620,649,30),(77,15,650,699,30),(77,16,700,1000,30),(78,1,1,39,30),(78,2,40,59,30),(78,3,60,99,30),(78,4,100,149,30),(78,5,150,179,30),(78,6,180,219,30),(78,7,220,259,30),(78,8,260,299,30),(78,9,300,354,30),(78,10,355,399,30),(78,11,400,499,30),(78,12,500,519,30),(78,13,520,619,30),(78,14,620,649,30),(78,15,650,699,30),(78,16,700,1000,30),(79,1,1,39,30),(79,2,40,59,30),(79,3,60,99,30),(79,4,100,149,30),(79,5,150,179,30),(79,6,180,219,30),(79,7,220,259,30),(79,8,260,299,30),(79,9,300,354,30),(79,10,355,399,30),(79,11,400,499,30),(79,12,500,519,30),(79,13,520,619,30),(79,14,620,649,30),(79,15,650,699,30),(79,16,700,1000,30),(80,1,1,39,30),(80,2,40,59,30),(80,3,60,99,30),(80,4,100,149,30),(80,5,150,179,30),(80,6,180,219,30),(80,7,220,259,30),(80,8,260,299,30),(80,9,300,354,30),(80,10,355,399,30),(80,11,400,499,30),(80,12,500,519,30),(80,13,520,619,30),(80,14,620,649,30),(80,15,650,699,30),(80,16,700,1000,30),(81,1,1,39,30),(81,2,40,59,30),(81,3,60,99,30),(81,4,100,149,30),(81,5,150,179,30),(81,6,180,219,30),(81,7,220,259,30),(81,8,260,299,30),(81,9,300,354,30),(81,10,355,399,30),(81,11,400,499,30),(81,12,500,519,30),(81,13,520,619,30),(81,14,620,649,30),(81,15,650,699,30),(81,16,700,1000,30),(82,1,1,39,30),(82,2,40,59,30),(82,3,60,99,30),(82,4,100,149,30),(82,5,150,179,30),(82,6,180,219,30),(82,7,220,259,30),(82,8,260,299,30),(82,9,300,354,30),(82,10,355,399,30),(82,11,400,499,30),(82,12,500,519,30),(82,13,520,619,30),(82,14,620,649,30),(82,15,650,699,30),(82,16,700,1000,30),(83,1,1,39,30),(83,2,40,59,30),(83,3,60,99,30),(83,4,100,149,30),(83,5,150,179,30),(83,6,180,219,30),(83,7,220,259,30),(83,8,260,299,30),(83,9,300,354,30),(83,10,355,399,30),(83,11,400,499,30),(83,12,500,519,30),(83,13,520,619,30),(83,14,620,649,30),(83,15,650,699,30),(83,16,700,1000,30),(84,1,1,39,30),(84,2,40,59,30),(84,3,60,99,30),(84,4,100,149,30),(84,5,150,179,30),(84,6,180,219,30),(84,7,220,259,30),(84,8,260,299,30),(84,9,300,354,30),(84,10,355,399,30),(84,11,400,499,30),(84,12,500,519,30),(84,13,520,619,30),(84,14,620,649,30),(84,15,650,699,30),(84,16,700,1000,30),(85,1,1,39,0),(85,2,40,59,0),(85,3,60,99,0),(85,4,100,149,0),(85,5,150,179,0),(85,6,180,219,0),(85,7,220,259,0),(85,8,260,299,0),(85,9,300,354,0),(85,10,355,399,0),(85,11,400,499,0),(85,12,500,519,0),(85,13,520,619,0),(85,14,620,649,0),(85,15,650,699,0),(85,16,700,1000,0),(86,1,1,39,0),(86,2,40,59,0),(86,3,60,99,0),(86,4,100,149,0),(86,5,150,179,0),(86,6,180,219,0),(86,7,220,259,0),(86,8,260,299,0),(86,9,300,354,0),(86,10,355,399,0),(86,11,400,499,0),(86,12,500,519,0),(86,13,520,619,0),(86,14,620,649,0),(86,15,650,699,0),(86,16,700,1000,0),(87,1,1,39,0),(87,2,40,59,0),(87,3,60,99,0),(87,4,100,149,0),(87,5,150,179,0),(87,6,180,219,0),(87,7,220,259,0),(87,8,260,299,0),(87,9,300,354,0),(87,10,355,399,0),(87,11,400,499,0),(87,12,500,519,0),(87,13,520,619,0),(87,14,620,649,0),(87,15,650,699,0),(87,16,700,1000,0),(88,1,1,39,0),(88,2,40,59,0),(88,3,60,99,0),(88,4,100,149,0),(88,5,150,179,0),(88,6,180,219,0),(88,7,220,259,0),(88,8,260,299,0),(88,9,300,354,0),(88,10,355,399,0),(88,11,400,499,0),(88,12,500,519,0),(88,13,520,619,0),(88,14,620,649,0),(88,15,650,699,0),(88,16,700,1000,0),(89,1,1,39,0),(89,2,40,59,0),(89,3,60,99,0),(89,4,100,149,0),(89,5,150,179,0),(89,6,180,219,0),(89,7,220,259,0),(89,8,260,299,0),(89,9,300,354,0),(89,10,355,399,0),(89,11,400,499,0),(89,12,500,519,0),(89,13,520,619,0),(89,14,620,649,0),(89,15,650,699,0),(89,16,700,1000,0),(90,1,1,39,0),(90,2,40,59,0),(90,3,60,99,0),(90,4,100,149,0),(90,5,150,179,0),(90,6,180,219,0),(90,7,220,259,0),(90,8,260,299,0),(90,9,300,354,0),(90,10,355,399,0),(90,11,400,499,0),(90,12,500,519,0),(90,13,520,619,0),(90,14,620,649,0),(90,15,650,699,0),(90,16,700,1000,0),(91,1,1,39,0),(91,2,40,59,0),(91,3,60,99,0),(91,4,100,149,0),(91,5,150,179,0),(91,6,180,219,0),(91,7,220,259,0),(91,8,260,299,0),(91,9,300,354,0),(91,10,355,399,0),(91,11,400,499,0),(91,12,500,519,0),(91,13,520,619,0),(91,14,620,649,0),(91,15,650,699,0),(91,16,700,1000,0),(92,1,1,39,0),(92,2,40,59,0),(92,3,60,99,0),(92,4,100,149,0),(92,5,150,179,0),(92,6,180,219,0),(92,7,220,259,0),(92,8,260,299,0),(92,9,300,354,0),(92,10,355,399,0),(92,11,400,499,0),(92,12,500,519,0),(92,13,520,619,0),(92,14,620,649,0),(92,15,650,699,0),(92,16,700,1000,0),(201,1,1,39,0),(201,2,40,59,16),(201,3,60,99,24),(201,4,100,149,40),(201,5,150,179,60),(201,6,180,219,72),(201,7,220,259,88),(201,8,260,299,104),(201,9,300,354,120),(201,10,355,399,142),(201,11,400,499,160),(201,12,500,519,200),(201,13,520,619,208),(201,14,620,649,248),(201,15,650,699,260),(201,16,700,1000,280),(202,1,1,39,0),(202,2,40,59,0),(202,3,60,99,0),(202,4,100,149,0),(202,5,150,179,0),(202,6,180,219,0),(202,7,220,259,0),(202,8,260,299,0),(202,9,300,354,0),(202,10,355,399,0),(202,11,400,499,0),(202,12,500,519,0),(202,13,520,619,0),(202,14,620,649,0),(202,15,650,699,0),(202,16,700,1000,0),(203,1,1,39,0),(203,2,40,59,6),(203,3,60,99,9),(203,4,100,149,15),(203,5,150,179,23),(203,6,180,219,27),(203,7,220,259,33),(203,8,260,299,39),(203,9,300,354,45),(203,10,355,399,53),(203,11,400,499,60),(203,12,500,519,75),(203,13,520,619,78),(203,14,620,649,93),(203,15,650,699,98),(203,16,700,1000,105),(210,1,1,39,0),(210,2,40,59,0),(210,3,60,99,0),(210,4,100,149,0),(210,5,150,179,0),(210,6,180,219,0),(210,7,220,259,0),(210,8,260,299,0),(210,9,300,354,0),(210,10,355,399,0),(210,11,400,499,0),(210,12,500,519,0),(210,13,520,619,0),(210,14,620,649,0),(210,15,650,699,0),(210,16,700,1000,0),(211,1,1,39,0),(211,2,40,59,0),(211,3,60,99,0),(211,4,100,149,0),(211,5,150,179,0),(211,6,180,219,0),(211,7,220,259,0),(211,8,260,299,0),(211,9,300,354,0),(211,10,355,399,0),(211,11,400,499,0),(211,12,500,519,0),(211,13,520,619,0),(211,14,620,649,0),(211,15,650,699,0),(211,16,700,1000,0),(221,1,1,39,0),(221,2,40,59,0),(221,3,60,99,0),(221,4,100,149,0),(221,5,150,179,0),(221,6,180,219,0),(221,7,220,259,0),(221,8,260,299,0),(221,9,300,354,0),(221,10,355,399,0),(221,11,400,499,0),(221,12,500,519,0),(221,13,520,619,0),(221,14,620,649,0),(221,15,650,699,0),(221,16,700,1000,0),(222,1,1,39,0),(222,2,40,59,0),(222,3,60,99,0),(222,4,100,149,0),(222,5,150,179,0),(222,6,180,219,0),(222,7,220,259,0),(222,8,260,299,0),(222,9,300,354,0),(222,10,355,399,0),(222,11,400,499,0),(222,12,500,519,0),(222,13,520,619,0),(222,14,620,649,0),(222,15,650,699,0),(222,16,700,1000,0),(223,1,1,39,0),(223,2,40,59,0),(223,3,60,99,0),(223,4,100,149,0),(223,5,150,179,0),(223,6,180,219,0),(223,7,220,259,0),(223,8,260,299,0),(223,9,300,354,0),(223,10,355,399,0),(223,11,400,499,0),(223,12,500,519,0),(223,13,520,619,0),(223,14,620,649,0),(223,15,650,699,0),(223,16,700,1000,0),(224,1,1,39,0),(224,2,40,59,0),(224,3,60,99,0),(224,4,100,149,0),(224,5,150,179,0),(224,6,180,219,0),(224,7,220,259,0),(224,8,260,299,0),(224,9,300,354,0),(224,10,355,399,0),(224,11,400,499,0),(224,12,500,519,0),(224,13,520,619,0),(224,14,620,649,0),(224,15,650,699,0),(224,16,700,1000,0),(225,1,1,39,0),(225,2,40,59,0),(225,3,60,99,0),(225,4,100,149,0),(225,5,150,179,0),(225,6,180,219,0),(225,7,220,259,0),(225,8,260,299,0),(225,9,300,354,0),(225,10,355,399,0),(225,11,400,499,0),(225,12,500,519,0),(225,13,520,619,0),(225,14,620,649,0),(225,15,650,699,0),(225,16,700,1000,0),(226,1,1,39,0),(226,2,40,59,0),(226,3,60,99,0),(226,4,100,149,0),(226,5,150,179,0),(226,6,180,219,0),(226,7,220,259,0),(226,8,260,299,0),(226,9,300,354,0),(226,10,355,399,0),(226,11,400,499,0),(226,12,500,519,0),(226,13,520,619,0),(226,14,620,649,0),(226,15,650,699,0),(226,16,700,1000,0),(230,1,1,39,0),(230,2,40,59,6),(230,3,60,99,9),(230,4,100,149,15),(230,5,150,179,23),(230,6,180,219,27),(230,7,220,259,33),(230,8,260,299,39),(230,9,300,354,45),(230,10,355,399,53),(230,11,400,499,60),(230,12,500,519,75),(230,13,520,619,78),(230,14,620,649,93),(230,15,650,699,98),(230,16,700,1000,105),(231,1,1,39,0),(231,2,40,59,6),(231,3,60,99,9),(231,4,100,149,15),(231,5,150,179,23),(231,6,180,219,27),(231,7,220,259,33),(231,8,260,299,39),(231,9,300,354,45),(231,10,355,399,53),(231,11,400,499,60),(231,12,500,519,75),(231,13,520,619,78),(231,14,620,649,93),(231,15,650,699,98),(231,16,700,1000,105),(232,1,1,39,0),(232,2,40,59,6),(232,3,60,99,9),(232,4,100,149,15),(232,5,150,179,23),(232,6,180,219,27),(232,7,220,259,33),(232,8,260,299,39),(232,9,300,354,45),(232,10,355,399,53),(232,11,400,499,60),(232,12,500,519,75),(232,13,520,619,78),(232,14,620,649,93),(232,15,650,699,98),(232,16,700,1000,105);
/*!40000 ALTER TABLE `base_equip_attr_rating` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_equip_devour_exp`
--

DROP TABLE IF EXISTS `base_equip_devour_exp`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_equip_devour_exp` (
  `stage` int(10) unsigned NOT NULL COMMENT '道具阶数',
  `quality` int(10) unsigned NOT NULL COMMENT '道具品质',
  `star` int(10) unsigned NOT NULL COMMENT '道具星数',
  `goods_id` int(10) unsigned NOT NULL COMMENT '物品ID',
  `exp` int(10) unsigned NOT NULL COMMENT '增加经验值',
  PRIMARY KEY (`stage`,`quality`,`star`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备吞噬-吞噬经验';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_equip_devour_exp`
--

LOCK TABLES `base_equip_devour_exp` WRITE;
/*!40000 ALTER TABLE `base_equip_devour_exp` DISABLE KEYS */;
INSERT INTO `base_equip_devour_exp` VALUES (0,0,0,38040201,1500),(1,0,0,0,20),(1,1,0,0,26),(1,2,0,0,34),(1,3,1,0,45),(1,3,2,0,60),(1,4,1,0,83),(1,4,2,0,118),(1,4,3,0,172),(1,5,3,0,259),(1,6,3,0,416),(2,0,0,0,30),(2,1,0,0,39),(2,2,0,0,50),(2,3,1,0,67),(2,3,2,0,89),(2,4,1,0,121),(2,4,2,0,171),(2,4,3,0,248),(2,5,3,0,371),(2,6,3,0,591),(3,0,0,0,45),(3,1,0,0,58),(3,2,0,0,74),(3,3,1,0,98),(3,3,2,0,130),(3,4,1,0,176),(3,4,2,0,246),(3,4,3,0,355),(3,5,3,0,528),(3,6,3,0,833),(4,0,0,0,66),(4,1,0,0,85),(4,2,0,0,108),(4,3,1,0,143),(4,3,2,0,188),(4,4,1,0,254),(4,4,2,0,353),(4,4,3,0,505),(4,5,3,0,746),(4,6,3,0,1165),(5,0,0,0,97),(5,1,0,0,124),(5,2,0,0,158),(5,3,1,0,207),(5,3,2,0,271),(5,4,1,0,364),(5,4,2,0,502),(5,4,3,0,714),(5,5,3,0,1045),(5,6,3,0,1620),(6,0,0,0,142),(6,1,0,0,180),(6,2,0,0,228),(6,3,1,0,298),(6,3,2,0,387),(6,4,1,0,518),(6,4,2,0,710),(6,4,3,0,1002),(6,5,3,0,1456),(6,6,3,0,2234),(7,0,0,0,206),(7,1,0,0,260),(7,2,0,0,328),(7,3,1,0,426),(7,3,2,0,550),(7,4,1,0,731),(7,4,2,0,997),(7,4,3,0,1396),(7,5,3,0,2012),(7,6,3,0,3061),(8,0,0,0,296),(8,1,0,0,373),(8,2,0,0,468),(8,3,1,0,604),(8,3,2,0,777),(8,4,1,0,1026),(8,4,2,0,1389),(8,4,3,0,1932),(8,5,3,0,2761),(8,6,3,0,4162),(9,0,0,0,424),(9,1,0,0,531),(9,2,0,0,662),(9,3,1,0,851),(9,3,2,0,1088),(9,4,1,0,1429),(9,4,2,0,1921),(9,4,3,0,2653),(9,5,3,0,3762),(9,6,3,0,5618),(10,0,0,0,602),(10,1,0,0,750),(10,2,0,0,932),(10,3,1,0,1190),(10,3,2,0,1514),(10,4,1,0,1976),(10,4,2,0,2639),(10,4,3,0,3617),(10,5,3,0,5088),(10,6,3,0,7527),(11,0,0,0,849),(11,1,0,0,1053),(11,2,0,0,1301),(11,3,1,0,1653),(11,3,2,0,2091),(11,4,1,0,2712),(11,4,2,0,3598),(11,4,3,0,4896),(11,5,3,0,6830),(11,6,3,0,10011),(12,0,0,0,1188),(12,1,0,0,1466),(12,2,0,0,1804),(12,3,1,0,2279),(12,3,2,0,2867),(12,4,1,0,3696),(12,4,2,0,4870),(12,4,3,0,6578),(12,5,3,0,9102),(12,6,3,0,13214),(13,0,0,0,1652),(13,1,0,0,2028),(13,2,0,0,2483),(13,3,1,0,3120),(13,3,2,0,3904),(13,4,1,0,5001),(13,4,2,0,6545),(13,4,3,0,8773),(13,5,3,0,12039),(13,6,3,0,17310),(14,0,0,0,2279),(14,1,0,0,2786),(14,2,0,0,3393),(14,3,1,0,4239),(14,3,2,0,5275),(14,4,1,0,6716),(14,4,2,0,8729),(14,4,3,0,11613),(14,5,3,0,15804),(14,6,3,0,22504),(15,0,0,0,3123),(15,1,0,0,3797),(15,2,0,0,4602),(15,3,1,0,5719),(15,3,2,0,7076),(15,4,1,0,8953),(15,4,2,0,11557),(15,4,3,0,15258),(15,5,3,0,20590),(15,6,3,0,29032),(16,0,0,0,3435),(16,1,0,0,4177),(16,2,0,0,5063),(16,3,1,0,6291),(16,3,2,0,7784),(16,4,1,0,9848),(16,4,2,0,12712),(16,4,3,0,16783),(16,5,3,0,22649),(16,6,3,0,31935);
/*!40000 ALTER TABLE `base_equip_devour_exp` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_equip_devour_lv`
--

DROP TABLE IF EXISTS `base_equip_devour_lv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_equip_devour_lv` (
  `lv` int(10) unsigned NOT NULL COMMENT '等级',
  `exp` int(10) unsigned NOT NULL COMMENT '升级经验',
  `attr` varchar(255) NOT NULL COMMENT '属性',
  `notice` int(10) unsigned NOT NULL COMMENT '是否需要传闻',
  PRIMARY KEY (`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备吞噬-吞噬等级';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_equip_devour_lv`
--

LOCK TABLES `base_equip_devour_lv` WRITE;
/*!40000 ALTER TABLE `base_equip_devour_lv` DISABLE KEYS */;
INSERT INTO `base_equip_devour_lv` VALUES (1,100,'[{1,15},{2,300}]',0),(2,150,'[{1,30},{2,600}]',0),(3,210,'[{1,45},{2,900}]',0),(4,280,'[{1,60},{2,1200}]',0),(5,360,'[{1,75},{2,1500}]',0),(6,450,'[{1,90},{2,1800}]',0),(7,550,'[{1,105},{2,2100}]',0),(8,660,'[{1,120},{2,2400}]',0),(9,780,'[{1,135},{2,2700}]',0),(10,910,'[{1,150},{2,3000}]',0),(11,1050,'[{1,165},{2,3300}]',0),(12,1200,'[{1,180},{2,3600}]',0),(13,1360,'[{1,195},{2,3900}]',0),(14,1530,'[{1,210},{2,4200}]',0),(15,1710,'[{1,225},{2,4500}]',0),(16,1900,'[{1,240},{2,4800}]',0),(17,2100,'[{1,255},{2,5100}]',0),(18,2310,'[{1,270},{2,5400}]',0),(19,2530,'[{1,285},{2,5700}]',0),(20,2760,'[{1,300},{2,6000}]',0),(21,3000,'[{1,315},{2,6300}]',0),(22,3250,'[{1,330},{2,6600}]',0),(23,3510,'[{1,345},{2,6900}]',0),(24,3780,'[{1,360},{2,7200}]',0),(25,4060,'[{1,375},{2,7500}]',0),(26,4350,'[{1,390},{2,7800}]',0),(27,4650,'[{1,405},{2,8100}]',0),(28,4960,'[{1,420},{2,8400}]',0),(29,5280,'[{1,435},{2,8700}]',0),(30,5610,'[{1,450},{2,9000}]',0),(31,5950,'[{1,465},{2,9300}]',0),(32,6300,'[{1,480},{2,9600}]',0),(33,6660,'[{1,495},{2,9900}]',0),(34,7030,'[{1,510},{2,10200}]',0),(35,7410,'[{1,525},{2,10500}]',0),(36,7800,'[{1,540},{2,10800}]',0),(37,8200,'[{1,555},{2,11100}]',0),(38,8610,'[{1,570},{2,11400}]',0),(39,9030,'[{1,585},{2,11700}]',0),(40,9460,'[{1,600},{2,12000}]',0),(41,9900,'[{1,615},{2,12300}]',0),(42,10350,'[{1,630},{2,12600}]',0),(43,10810,'[{1,645},{2,12900}]',0),(44,11280,'[{1,660},{2,13200}]',0),(45,11760,'[{1,675},{2,13500}]',0),(46,12250,'[{1,690},{2,13800}]',0),(47,12750,'[{1,705},{2,14100}]',0),(48,13260,'[{1,720},{2,14400}]',0),(49,13780,'[{1,735},{2,14700}]',0),(50,14310,'[{1,750},{2,15000}]',0),(51,14850,'[{1,765},{2,15300}]',0),(52,15400,'[{1,780},{2,15600}]',0),(53,15960,'[{1,795},{2,15900}]',0),(54,16530,'[{1,810},{2,16200}]',0),(55,17110,'[{1,825},{2,16500}]',0),(56,17700,'[{1,840},{2,16800}]',0),(57,18300,'[{1,855},{2,17100}]',0),(58,18910,'[{1,870},{2,17400}]',0),(59,19530,'[{1,885},{2,17700}]',0),(60,20160,'[{1,900},{2,18000}]',0),(61,20800,'[{1,915},{2,18300}]',0),(62,21450,'[{1,930},{2,18600}]',0),(63,22110,'[{1,945},{2,18900}]',0),(64,22780,'[{1,960},{2,19200}]',0),(65,23460,'[{1,975},{2,19500}]',0),(66,24150,'[{1,990},{2,19800}]',0),(67,24850,'[{1,1005},{2,20100}]',0),(68,25560,'[{1,1020},{2,20400}]',0),(69,26280,'[{1,1035},{2,20700}]',0),(70,27010,'[{1,1050},{2,21000}]',0),(71,27750,'[{1,1065},{2,21300}]',0),(72,28500,'[{1,1080},{2,21600}]',0),(73,29260,'[{1,1095},{2,21900}]',0),(74,30030,'[{1,1110},{2,22200}]',0),(75,30810,'[{1,1125},{2,22500}]',0),(76,31600,'[{1,1140},{2,22800}]',0),(77,32400,'[{1,1155},{2,23100}]',0),(78,33210,'[{1,1170},{2,23400}]',0),(79,34030,'[{1,1185},{2,23700}]',0),(80,34860,'[{1,1200},{2,24000}]',0),(81,35700,'[{1,1215},{2,24300}]',0),(82,36550,'[{1,1230},{2,24600}]',0),(83,37410,'[{1,1245},{2,24900}]',0),(84,38280,'[{1,1260},{2,25200}]',0),(85,39160,'[{1,1275},{2,25500}]',0),(86,40050,'[{1,1290},{2,25800}]',0),(87,40950,'[{1,1305},{2,26100}]',0),(88,41860,'[{1,1320},{2,26400}]',0),(89,42780,'[{1,1335},{2,26700}]',0),(90,43710,'[{1,1350},{2,27000}]',0),(91,44650,'[{1,1365},{2,27300}]',0),(92,45600,'[{1,1380},{2,27600}]',0),(93,46560,'[{1,1395},{2,27900}]',0),(94,47530,'[{1,1410},{2,28200}]',0),(95,48510,'[{1,1425},{2,28500}]',0),(96,49500,'[{1,1440},{2,28800}]',0),(97,50500,'[{1,1455},{2,29100}]',0),(98,51510,'[{1,1470},{2,29400}]',0),(99,52530,'[{1,1485},{2,29700}]',0),(100,53560,'[{1,1500},{2,30000}]',0),(101,54600,'[{1,1515},{2,30300}]',0),(102,55650,'[{1,1530},{2,30600}]',0),(103,56710,'[{1,1545},{2,30900}]',0),(104,57780,'[{1,1560},{2,31200}]',0),(105,58860,'[{1,1575},{2,31500}]',0),(106,59950,'[{1,1590},{2,31800}]',0),(107,61050,'[{1,1605},{2,32100}]',0),(108,62160,'[{1,1620},{2,32400}]',0),(109,63280,'[{1,1635},{2,32700}]',0),(110,64410,'[{1,1650},{2,33000}]',0),(111,65550,'[{1,1665},{2,33300}]',0),(112,66700,'[{1,1680},{2,33600}]',0),(113,67860,'[{1,1695},{2,33900}]',0),(114,69030,'[{1,1710},{2,34200}]',0),(115,70210,'[{1,1725},{2,34500}]',0),(116,71400,'[{1,1740},{2,34800}]',0),(117,72600,'[{1,1755},{2,35100}]',0),(118,73810,'[{1,1770},{2,35400}]',0),(119,75030,'[{1,1785},{2,35700}]',0),(120,76260,'[{1,1800},{2,36000}]',0),(121,77500,'[{1,1815},{2,36300}]',0),(122,78750,'[{1,1830},{2,36600}]',0),(123,80010,'[{1,1845},{2,36900}]',0),(124,81280,'[{1,1860},{2,37200}]',0),(125,82560,'[{1,1875},{2,37500}]',0),(126,83850,'[{1,1890},{2,37800}]',0),(127,85150,'[{1,1905},{2,38100}]',0),(128,86460,'[{1,1920},{2,38400}]',0),(129,87780,'[{1,1935},{2,38700}]',0),(130,89110,'[{1,1950},{2,39000}]',0),(131,90450,'[{1,1965},{2,39300}]',0),(132,91800,'[{1,1980},{2,39600}]',0),(133,93160,'[{1,1995},{2,39900}]',0),(134,94530,'[{1,2010},{2,40200}]',0),(135,95910,'[{1,2025},{2,40500}]',0),(136,97300,'[{1,2040},{2,40800}]',0),(137,98700,'[{1,2055},{2,41100}]',0),(138,100110,'[{1,2070},{2,41400}]',0),(139,101530,'[{1,2085},{2,41700}]',0),(140,102960,'[{1,2100},{2,42000}]',0),(141,104400,'[{1,2115},{2,42300}]',0),(142,105850,'[{1,2130},{2,42600}]',0),(143,107310,'[{1,2145},{2,42900}]',0),(144,108780,'[{1,2160},{2,43200}]',0),(145,110260,'[{1,2175},{2,43500}]',0),(146,111750,'[{1,2190},{2,43800}]',0),(147,113250,'[{1,2205},{2,44100}]',0),(148,114760,'[{1,2220},{2,44400}]',0),(149,116280,'[{1,2235},{2,44700}]',0),(150,117810,'[{1,2250},{2,45000}]',0),(151,119350,'[{1,2265},{2,45300}]',0),(152,120900,'[{1,2280},{2,45600}]',0),(153,122460,'[{1,2295},{2,45900}]',0),(154,124030,'[{1,2310},{2,46200}]',0),(155,125610,'[{1,2325},{2,46500}]',0),(156,127200,'[{1,2340},{2,46800}]',0),(157,128800,'[{1,2355},{2,47100}]',0),(158,130410,'[{1,2370},{2,47400}]',0),(159,132030,'[{1,2385},{2,47700}]',0),(160,133660,'[{1,2400},{2,48000}]',0),(161,135300,'[{1,2415},{2,48300}]',0),(162,136950,'[{1,2430},{2,48600}]',0),(163,138610,'[{1,2445},{2,48900}]',0),(164,140280,'[{1,2460},{2,49200}]',0),(165,141960,'[{1,2475},{2,49500}]',0),(166,143650,'[{1,2490},{2,49800}]',0),(167,145350,'[{1,2505},{2,50100}]',0),(168,147060,'[{1,2520},{2,50400}]',0),(169,148780,'[{1,2535},{2,50700}]',0),(170,150510,'[{1,2550},{2,51000}]',0),(171,152250,'[{1,2565},{2,51300}]',0),(172,154000,'[{1,2580},{2,51600}]',0),(173,155760,'[{1,2595},{2,51900}]',0),(174,157530,'[{1,2610},{2,52200}]',0),(175,159310,'[{1,2625},{2,52500}]',0),(176,161100,'[{1,2640},{2,52800}]',0),(177,162900,'[{1,2655},{2,53100}]',0),(178,164710,'[{1,2670},{2,53400}]',0),(179,166530,'[{1,2685},{2,53700}]',0),(180,168360,'[{1,2700},{2,54000}]',0),(181,170200,'[{1,2715},{2,54300}]',0),(182,172050,'[{1,2730},{2,54600}]',0),(183,173910,'[{1,2745},{2,54900}]',0),(184,175780,'[{1,2760},{2,55200}]',0),(185,177660,'[{1,2775},{2,55500}]',0),(186,179550,'[{1,2790},{2,55800}]',0),(187,181450,'[{1,2805},{2,56100}]',0),(188,183360,'[{1,2820},{2,56400}]',0),(189,185280,'[{1,2835},{2,56700}]',0),(190,187210,'[{1,2850},{2,57000}]',0),(191,189150,'[{1,2865},{2,57300}]',0),(192,191100,'[{1,2880},{2,57600}]',0),(193,193060,'[{1,2895},{2,57900}]',0),(194,195030,'[{1,2910},{2,58200}]',0),(195,197010,'[{1,2925},{2,58500}]',0),(196,199000,'[{1,2940},{2,58800}]',0),(197,201000,'[{1,2955},{2,59100}]',0),(198,203010,'[{1,2970},{2,59400}]',0),(199,205030,'[{1,2985},{2,59700}]',0),(200,207060,'[{1,3000},{2,60000}]',0),(201,209100,'[{1,3015},{2,60300}]',0),(202,211150,'[{1,3030},{2,60600}]',0),(203,213210,'[{1,3045},{2,60900}]',0),(204,215280,'[{1,3060},{2,61200}]',0),(205,217360,'[{1,3075},{2,61500}]',0),(206,219450,'[{1,3090},{2,61800}]',0),(207,221550,'[{1,3105},{2,62100}]',0),(208,223660,'[{1,3120},{2,62400}]',0),(209,225780,'[{1,3135},{2,62700}]',0),(210,227910,'[{1,3150},{2,63000}]',0),(211,230050,'[{1,3165},{2,63300}]',0),(212,232200,'[{1,3180},{2,63600}]',0),(213,234360,'[{1,3195},{2,63900}]',0),(214,236530,'[{1,3210},{2,64200}]',0),(215,238710,'[{1,3225},{2,64500}]',0),(216,240900,'[{1,3240},{2,64800}]',0),(217,243100,'[{1,3255},{2,65100}]',0),(218,245310,'[{1,3270},{2,65400}]',0),(219,247530,'[{1,3285},{2,65700}]',0),(220,249760,'[{1,3300},{2,66000}]',0),(221,252000,'[{1,3315},{2,66300}]',0),(222,254250,'[{1,3330},{2,66600}]',0),(223,256510,'[{1,3345},{2,66900}]',0),(224,258780,'[{1,3360},{2,67200}]',0),(225,261060,'[{1,3375},{2,67500}]',0),(226,263350,'[{1,3390},{2,67800}]',0),(227,265650,'[{1,3405},{2,68100}]',0),(228,267960,'[{1,3420},{2,68400}]',0),(229,270280,'[{1,3435},{2,68700}]',0),(230,272610,'[{1,3450},{2,69000}]',0),(231,274950,'[{1,3465},{2,69300}]',0),(232,277300,'[{1,3480},{2,69600}]',0),(233,279660,'[{1,3495},{2,69900}]',0),(234,282030,'[{1,3510},{2,70200}]',0),(235,284410,'[{1,3525},{2,70500}]',0),(236,286800,'[{1,3540},{2,70800}]',0),(237,289200,'[{1,3555},{2,71100}]',0),(238,291610,'[{1,3570},{2,71400}]',0),(239,294030,'[{1,3585},{2,71700}]',0),(240,296460,'[{1,3600},{2,72000}]',0),(241,298900,'[{1,3615},{2,72300}]',0),(242,301350,'[{1,3630},{2,72600}]',0),(243,303810,'[{1,3645},{2,72900}]',0),(244,306280,'[{1,3660},{2,73200}]',0),(245,308760,'[{1,3675},{2,73500}]',0),(246,311250,'[{1,3690},{2,73800}]',0),(247,313750,'[{1,3705},{2,74100}]',0),(248,316260,'[{1,3720},{2,74400}]',0),(249,318780,'[{1,3735},{2,74700}]',0),(250,321310,'[{1,3750},{2,75000}]',0),(251,323850,'[{1,3765},{2,75300}]',0),(252,326400,'[{1,3780},{2,75600}]',0),(253,328960,'[{1,3795},{2,75900}]',0),(254,331530,'[{1,3810},{2,76200}]',0),(255,334110,'[{1,3825},{2,76500}]',0),(256,336700,'[{1,3840},{2,76800}]',0),(257,339300,'[{1,3855},{2,77100}]',0),(258,341910,'[{1,3870},{2,77400}]',0),(259,344530,'[{1,3885},{2,77700}]',0),(260,347160,'[{1,3900},{2,78000}]',0),(261,349800,'[{1,3915},{2,78300}]',0),(262,352450,'[{1,3930},{2,78600}]',0),(263,355110,'[{1,3945},{2,78900}]',0),(264,357780,'[{1,3960},{2,79200}]',0),(265,360460,'[{1,3975},{2,79500}]',0),(266,363150,'[{1,3990},{2,79800}]',0),(267,365850,'[{1,4005},{2,80100}]',0),(268,368560,'[{1,4020},{2,80400}]',0),(269,371280,'[{1,4035},{2,80700}]',0),(270,374010,'[{1,4050},{2,81000}]',0),(271,376750,'[{1,4065},{2,81300}]',0),(272,379500,'[{1,4080},{2,81600}]',0),(273,382260,'[{1,4095},{2,81900}]',0),(274,385030,'[{1,4110},{2,82200}]',0),(275,387810,'[{1,4125},{2,82500}]',0),(276,390600,'[{1,4140},{2,82800}]',0),(277,393400,'[{1,4155},{2,83100}]',0),(278,396210,'[{1,4170},{2,83400}]',0),(279,399030,'[{1,4185},{2,83700}]',0),(280,401860,'[{1,4200},{2,84000}]',0),(281,404700,'[{1,4215},{2,84300}]',0),(282,407550,'[{1,4230},{2,84600}]',0),(283,410410,'[{1,4245},{2,84900}]',0),(284,413280,'[{1,4260},{2,85200}]',0),(285,416160,'[{1,4275},{2,85500}]',0),(286,419050,'[{1,4290},{2,85800}]',0),(287,421950,'[{1,4305},{2,86100}]',0),(288,424860,'[{1,4320},{2,86400}]',0),(289,427780,'[{1,4335},{2,86700}]',0),(290,430710,'[{1,4350},{2,87000}]',0),(291,433650,'[{1,4365},{2,87300}]',0),(292,436600,'[{1,4380},{2,87600}]',0),(293,439560,'[{1,4395},{2,87900}]',0),(294,442530,'[{1,4410},{2,88200}]',0),(295,445510,'[{1,4425},{2,88500}]',0),(296,448500,'[{1,4440},{2,88800}]',0),(297,451500,'[{1,4455},{2,89100}]',0),(298,454510,'[{1,4470},{2,89400}]',0),(299,457530,'[{1,4485},{2,89700}]',0),(300,460560,'[{1,4500},{2,90000}]',0),(301,463600,'[{1,4515},{2,90300}]',0),(302,466650,'[{1,4530},{2,90600}]',0),(303,469710,'[{1,4545},{2,90900}]',0),(304,472780,'[{1,4560},{2,91200}]',0),(305,475860,'[{1,4575},{2,91500}]',0),(306,478950,'[{1,4590},{2,91800}]',0),(307,482050,'[{1,4605},{2,92100}]',0),(308,485160,'[{1,4620},{2,92400}]',0),(309,488280,'[{1,4635},{2,92700}]',0),(310,491410,'[{1,4650},{2,93000}]',0),(311,494550,'[{1,4665},{2,93300}]',0),(312,497700,'[{1,4680},{2,93600}]',0),(313,500860,'[{1,4695},{2,93900}]',0),(314,504030,'[{1,4710},{2,94200}]',0),(315,507210,'[{1,4725},{2,94500}]',0),(316,510400,'[{1,4740},{2,94800}]',0),(317,513600,'[{1,4755},{2,95100}]',0),(318,516810,'[{1,4770},{2,95400}]',0),(319,520030,'[{1,4785},{2,95700}]',0),(320,523260,'[{1,4800},{2,96000}]',0),(321,526500,'[{1,4815},{2,96300}]',0),(322,529750,'[{1,4830},{2,96600}]',0),(323,533010,'[{1,4845},{2,96900}]',0),(324,536280,'[{1,4860},{2,97200}]',0),(325,539560,'[{1,4875},{2,97500}]',0),(326,542850,'[{1,4890},{2,97800}]',0),(327,546150,'[{1,4905},{2,98100}]',0),(328,549460,'[{1,4920},{2,98400}]',0),(329,552780,'[{1,4935},{2,98700}]',0),(330,556110,'[{1,4950},{2,99000}]',0),(331,559450,'[{1,4965},{2,99300}]',0),(332,562800,'[{1,4980},{2,99600}]',0),(333,566160,'[{1,4995},{2,99900}]',0),(334,569530,'[{1,5010},{2,100200}]',0),(335,572910,'[{1,5025},{2,100500}]',0),(336,576300,'[{1,5040},{2,100800}]',0),(337,579700,'[{1,5055},{2,101100}]',0),(338,583110,'[{1,5070},{2,101400}]',0),(339,586530,'[{1,5085},{2,101700}]',0),(340,589960,'[{1,5100},{2,102000}]',0),(341,593400,'[{1,5115},{2,102300}]',0),(342,596850,'[{1,5130},{2,102600}]',0),(343,600310,'[{1,5145},{2,102900}]',0),(344,603780,'[{1,5160},{2,103200}]',0),(345,607260,'[{1,5175},{2,103500}]',0),(346,610750,'[{1,5190},{2,103800}]',0),(347,614250,'[{1,5205},{2,104100}]',0),(348,617760,'[{1,5220},{2,104400}]',0),(349,621280,'[{1,5235},{2,104700}]',0),(350,624810,'[{1,5250},{2,105000}]',0),(351,628350,'[{1,5265},{2,105300}]',0),(352,631900,'[{1,5280},{2,105600}]',0),(353,635460,'[{1,5295},{2,105900}]',0),(354,639030,'[{1,5310},{2,106200}]',0),(355,642610,'[{1,5325},{2,106500}]',0),(356,646200,'[{1,5340},{2,106800}]',0),(357,649800,'[{1,5355},{2,107100}]',0),(358,653410,'[{1,5370},{2,107400}]',0),(359,657030,'[{1,5385},{2,107700}]',0),(360,660660,'[{1,5400},{2,108000}]',0),(361,664300,'[{1,5415},{2,108300}]',0),(362,667950,'[{1,5430},{2,108600}]',0),(363,671610,'[{1,5445},{2,108900}]',0),(364,675280,'[{1,5460},{2,109200}]',0),(365,678960,'[{1,5475},{2,109500}]',0),(366,682650,'[{1,5490},{2,109800}]',0),(367,686350,'[{1,5505},{2,110100}]',0),(368,690060,'[{1,5520},{2,110400}]',0),(369,693780,'[{1,5535},{2,110700}]',0),(370,697510,'[{1,5550},{2,111000}]',0),(371,701250,'[{1,5565},{2,111300}]',0),(372,705000,'[{1,5580},{2,111600}]',0),(373,708760,'[{1,5595},{2,111900}]',0),(374,712530,'[{1,5610},{2,112200}]',0),(375,716310,'[{1,5625},{2,112500}]',0),(376,720100,'[{1,5640},{2,112800}]',0),(377,723900,'[{1,5655},{2,113100}]',0),(378,727710,'[{1,5670},{2,113400}]',0),(379,731530,'[{1,5685},{2,113700}]',0),(380,735360,'[{1,5700},{2,114000}]',0),(381,739200,'[{1,5715},{2,114300}]',0),(382,743050,'[{1,5730},{2,114600}]',0),(383,746910,'[{1,5745},{2,114900}]',0),(384,750780,'[{1,5760},{2,115200}]',0),(385,754660,'[{1,5775},{2,115500}]',0),(386,758550,'[{1,5790},{2,115800}]',0),(387,762450,'[{1,5805},{2,116100}]',0),(388,766360,'[{1,5820},{2,116400}]',0),(389,770280,'[{1,5835},{2,116700}]',0),(390,774210,'[{1,5850},{2,117000}]',0),(391,778150,'[{1,5865},{2,117300}]',0),(392,782100,'[{1,5880},{2,117600}]',0),(393,786060,'[{1,5895},{2,117900}]',0),(394,790030,'[{1,5910},{2,118200}]',0),(395,794010,'[{1,5925},{2,118500}]',0),(396,798000,'[{1,5940},{2,118800}]',0),(397,802000,'[{1,5955},{2,119100}]',0),(398,806010,'[{1,5970},{2,119400}]',0),(399,810030,'[{1,5985},{2,119700}]',0),(400,814060,'[{1,6000},{2,120000}]',0),(401,818100,'[{1,6015},{2,120300}]',0),(402,822150,'[{1,6030},{2,120600}]',0),(403,826210,'[{1,6045},{2,120900}]',0),(404,830280,'[{1,6060},{2,121200}]',0),(405,834360,'[{1,6075},{2,121500}]',0),(406,838450,'[{1,6090},{2,121800}]',0),(407,842550,'[{1,6105},{2,122100}]',0),(408,846660,'[{1,6120},{2,122400}]',0),(409,850780,'[{1,6135},{2,122700}]',0),(410,854910,'[{1,6150},{2,123000}]',0),(411,859050,'[{1,6165},{2,123300}]',0),(412,863200,'[{1,6180},{2,123600}]',0),(413,867360,'[{1,6195},{2,123900}]',0),(414,871530,'[{1,6210},{2,124200}]',0),(415,875710,'[{1,6225},{2,124500}]',0),(416,879900,'[{1,6240},{2,124800}]',0),(417,884100,'[{1,6255},{2,125100}]',0),(418,888310,'[{1,6270},{2,125400}]',0),(419,892530,'[{1,6285},{2,125700}]',0),(420,896760,'[{1,6300},{2,126000}]',0),(421,901000,'[{1,6315},{2,126300}]',0),(422,905250,'[{1,6330},{2,126600}]',0),(423,909510,'[{1,6345},{2,126900}]',0),(424,913780,'[{1,6360},{2,127200}]',0),(425,918060,'[{1,6375},{2,127500}]',0),(426,922350,'[{1,6390},{2,127800}]',0),(427,926650,'[{1,6405},{2,128100}]',0),(428,930960,'[{1,6420},{2,128400}]',0),(429,935280,'[{1,6435},{2,128700}]',0),(430,939610,'[{1,6450},{2,129000}]',0),(431,943950,'[{1,6465},{2,129300}]',0),(432,948300,'[{1,6480},{2,129600}]',0),(433,952660,'[{1,6495},{2,129900}]',0),(434,957030,'[{1,6510},{2,130200}]',0),(435,961410,'[{1,6525},{2,130500}]',0),(436,965800,'[{1,6540},{2,130800}]',0),(437,970200,'[{1,6555},{2,131100}]',0),(438,974610,'[{1,6570},{2,131400}]',0),(439,979030,'[{1,6585},{2,131700}]',0),(440,983460,'[{1,6600},{2,132000}]',0),(441,987900,'[{1,6615},{2,132300}]',0),(442,992350,'[{1,6630},{2,132600}]',0),(443,996810,'[{1,6645},{2,132900}]',0),(444,1001280,'[{1,6660},{2,133200}]',0),(445,1005760,'[{1,6675},{2,133500}]',0),(446,1010250,'[{1,6690},{2,133800}]',0),(447,1014750,'[{1,6705},{2,134100}]',0),(448,1019260,'[{1,6720},{2,134400}]',0),(449,1023780,'[{1,6735},{2,134700}]',0),(450,1028310,'[{1,6750},{2,135000}]',0),(451,1032850,'[{1,6765},{2,135300}]',0),(452,1037400,'[{1,6780},{2,135600}]',0),(453,1041960,'[{1,6795},{2,135900}]',0),(454,1046530,'[{1,6810},{2,136200}]',0),(455,1051110,'[{1,6825},{2,136500}]',0),(456,1055700,'[{1,6840},{2,136800}]',0),(457,1060300,'[{1,6855},{2,137100}]',0),(458,1064910,'[{1,6870},{2,137400}]',0),(459,1069530,'[{1,6885},{2,137700}]',0),(460,1074160,'[{1,6900},{2,138000}]',0),(461,1078800,'[{1,6915},{2,138300}]',0),(462,1083450,'[{1,6930},{2,138600}]',0),(463,1088110,'[{1,6945},{2,138900}]',0),(464,1092780,'[{1,6960},{2,139200}]',0),(465,1097460,'[{1,6975},{2,139500}]',0),(466,1102150,'[{1,6990},{2,139800}]',0),(467,1106850,'[{1,7005},{2,140100}]',0),(468,1111560,'[{1,7020},{2,140400}]',0),(469,1116280,'[{1,7035},{2,140700}]',0),(470,1121010,'[{1,7050},{2,141000}]',0),(471,1125750,'[{1,7065},{2,141300}]',0),(472,1130500,'[{1,7080},{2,141600}]',0),(473,1135260,'[{1,7095},{2,141900}]',0),(474,1140030,'[{1,7110},{2,142200}]',0),(475,1144810,'[{1,7125},{2,142500}]',0),(476,1149600,'[{1,7140},{2,142800}]',0),(477,1154400,'[{1,7155},{2,143100}]',0),(478,1159210,'[{1,7170},{2,143400}]',0),(479,1164030,'[{1,7185},{2,143700}]',0),(480,1168860,'[{1,7200},{2,144000}]',0),(481,1173700,'[{1,7215},{2,144300}]',0),(482,1178550,'[{1,7230},{2,144600}]',0),(483,1183410,'[{1,7245},{2,144900}]',0),(484,1188280,'[{1,7260},{2,145200}]',0),(485,1193160,'[{1,7275},{2,145500}]',0),(486,1198050,'[{1,7290},{2,145800}]',0),(487,1202950,'[{1,7305},{2,146100}]',0),(488,1207860,'[{1,7320},{2,146400}]',0),(489,1212780,'[{1,7335},{2,146700}]',0),(490,1217710,'[{1,7350},{2,147000}]',0),(491,1222650,'[{1,7365},{2,147300}]',0),(492,1227600,'[{1,7380},{2,147600}]',0),(493,1232560,'[{1,7395},{2,147900}]',0),(494,1237530,'[{1,7410},{2,148200}]',0),(495,1242510,'[{1,7425},{2,148500}]',0),(496,1247500,'[{1,7440},{2,148800}]',0),(497,1252500,'[{1,7455},{2,149100}]',0),(498,1257510,'[{1,7470},{2,149400}]',0),(499,1262530,'[{1,7485},{2,149700}]',0),(500,0,'[{1,7500},{2,150000}]',0);
/*!40000 ALTER TABLE `base_equip_devour_lv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_equip_dstone_icon`
--

DROP TABLE IF EXISTS `base_equip_dstone_icon`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_equip_dstone_icon` (
  `goods_id` int(11) unsigned NOT NULL COMMENT '双属性宝石id',
  `lv` tinyint(3) unsigned NOT NULL COMMENT '双属性宝石等级',
  `icon_id` int(11) unsigned NOT NULL COMMENT '图标id',
  PRIMARY KEY (`goods_id`,`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='双属性宝石图标配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_equip_dstone_icon`
--

LOCK TABLES `base_equip_dstone_icon` WRITE;
/*!40000 ALTER TABLE `base_equip_dstone_icon` DISABLE KEYS */;
INSERT INTO `base_equip_dstone_icon` VALUES (14100013,1,14010001),(14100013,2,14010002),(14100013,3,14010003),(14100013,4,14010004),(14100013,5,14010005),(14100013,6,14010006),(14100013,7,14010007),(14100013,8,141000131),(14100013,9,141000132),(14100013,10,141000133),(14100013,11,141000134),(14100013,12,141000135),(14100013,13,141000136),(14100013,14,141000137),(14100013,15,141000138),(14100013,16,141000139),(14100013,17,141000140),(14100013,18,141000141),(14100015,1,141000151),(14100015,2,141000152),(14100015,3,14020003),(14100015,4,14020004),(14100015,5,14020005),(14100015,6,14020006),(14100015,7,14020007),(14100015,8,141000151),(14100015,9,141000152),(14100015,10,141000153),(14100015,11,141000154),(14100015,12,141000155),(14100015,13,141000156),(14100015,14,141000157),(14100015,15,141000158),(14100015,16,141000159),(14100015,17,141000160),(14100015,18,141000161),(14100024,1,141000241),(14100024,2,141000242),(14100024,3,14010003),(14100024,4,14010004),(14100024,5,14010005),(14100024,6,14010006),(14100024,7,14010007),(14100024,8,141000241),(14100024,9,141000242),(14100024,10,141000243),(14100024,11,141000244),(14100024,12,141000245),(14100024,13,141000246),(14100024,14,141000247),(14100024,15,141000248),(14100024,16,141000249),(14100024,17,141000250),(14100024,18,141000251),(14100026,1,14020001),(14100026,2,14020002),(14100026,3,14020003),(14100026,4,14020004),(14100026,5,14020005),(14100026,6,14020006),(14100026,7,14020007),(14100026,8,141000261),(14100026,9,141000262),(14100026,10,141000263),(14100026,11,141000264),(14100026,12,141000265),(14100026,13,141000266),(14100026,14,141000267),(14100026,15,141000268),(14100026,16,141000269),(14100026,17,141000270),(14100026,18,141000271),(14100035,1,14010001),(14100035,2,14010002),(14100035,3,14010003),(14100035,4,14010004),(14100035,5,14010005),(14100035,6,14010006),(14100035,7,14010007),(14100035,8,141000351),(14100035,9,141000352),(14100035,10,141000353),(14100035,11,141000354),(14100035,12,141000355),(14100035,13,141000356),(14100035,14,141000357),(14100035,15,141000358),(14100035,16,141000359),(14100035,17,141000360),(14100035,18,141000361),(14100037,1,14020001),(14100037,2,14020002),(14100037,3,14020003),(14100037,4,14020004),(14100037,5,14020005),(14100037,6,14020006),(14100037,7,14020007),(14100037,8,141000371),(14100037,9,141000372),(14100037,10,141000373),(14100037,11,141000374),(14100037,12,141000375),(14100037,13,141000376),(14100037,14,141000377),(14100037,15,141000378),(14100037,16,141000379),(14100037,17,141000380),(14100037,18,141000381),(14100046,1,14010001),(14100046,2,14010002),(14100046,3,14010003),(14100046,4,14010004),(14100046,5,14010005),(14100046,6,14010006),(14100046,7,14010007),(14100046,8,141000461),(14100046,9,141000462),(14100046,10,141000463),(14100046,11,141000464),(14100046,12,141000465),(14100046,13,141000466),(14100046,14,141000467),(14100046,15,141000468),(14100046,16,141000469),(14100046,17,141000470),(14100046,18,141000471),(14100048,1,14020001),(14100048,2,14020002),(14100048,3,14020003),(14100048,4,14020004),(14100048,5,14020005),(14100048,6,14020006),(14100048,7,14020007),(14100048,8,141000481),(14100048,9,141000482),(14100048,10,141000483),(14100048,11,141000484),(14100048,12,141000485),(14100048,13,141000486),(14100048,14,141000487),(14100048,15,141000488),(14100048,16,141000489),(14100048,17,141000490),(14100048,18,141000491),(14100057,1,14010001),(14100057,2,14010002),(14100057,3,14010003),(14100057,4,14010004),(14100057,5,14010005),(14100057,6,14010006),(14100057,7,14010007),(14100057,8,141000571),(14100057,9,141000572),(14100057,10,141000573),(14100057,11,141000574),(14100057,12,141000575),(14100057,13,141000576),(14100057,14,141000577),(14100057,15,141000578),(14100057,16,141000579),(14100057,17,141000580),(14100057,18,141000581),(14100068,1,14020001),(14100068,2,14020002),(14100068,3,14020003),(14100068,4,14020004),(14100068,5,14020005),(14100068,6,14020006),(14100068,7,14020007),(14100068,8,141000681),(14100068,9,141000682),(14100068,10,141000683),(14100068,11,141000684),(14100068,12,141000685),(14100068,13,141000686),(14100068,14,141000687),(14100068,15,141000688),(14100068,16,141000689),(14100068,17,141000690),(14100068,18,141000691),(14100071,1,14010001),(14100071,2,14010002),(14100071,3,14010003),(14100071,4,14010004),(14100071,5,14010005),(14100071,6,14010006),(14100071,7,14010007),(14100071,8,141000711),(14100071,9,141000712),(14100071,10,141000713),(14100071,11,141000714),(14100071,12,141000715),(14100071,13,141000716),(14100071,14,141000717),(14100071,15,141000718),(14100071,16,141000719),(14100071,17,141000720),(14100071,18,141000721),(14100082,1,14020001),(14100082,2,14020002),(14100082,3,14020003),(14100082,4,14020004),(14100082,5,14020005),(14100082,6,14020006),(14100082,7,14020007),(14100082,8,141000821),(14100082,9,141000822),(14100082,10,141000823),(14100082,11,141000824),(14100082,12,141000825),(14100082,13,141000826),(14100082,14,141000827),(14100082,15,141000828),(14100082,16,141000829),(14100082,17,141000830),(14100082,18,141000831);
/*!40000 ALTER TABLE `base_equip_dstone_icon` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_equip_pos2suittype`
--

DROP TABLE IF EXISTS `base_equip_pos2suittype`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_equip_pos2suittype` (
  `pos` mediumint(8) unsigned NOT NULL COMMENT '装备类型',
  `type` tinyint(4) NOT NULL COMMENT '套装类型',
  PRIMARY KEY (`pos`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备位置映射套装类型';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_equip_pos2suittype`
--

LOCK TABLES `base_equip_pos2suittype` WRITE;
/*!40000 ALTER TABLE `base_equip_pos2suittype` DISABLE KEYS */;
INSERT INTO `base_equip_pos2suittype` VALUES (1,1),(2,1),(3,2),(4,1),(5,2),(6,1),(7,2),(8,1),(9,2),(10,1);
/*!40000 ALTER TABLE `base_equip_pos2suittype` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_equip_prefix`
--

DROP TABLE IF EXISTS `base_equip_prefix`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_equip_prefix` (
  `pos` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '装备部位',
  `prefix` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '重铸次数',
  `prefix_name` varchar(50) NOT NULL COMMENT '前缀名称@lang@',
  `attr_ratio` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '属性加成',
  `cost_list` varchar(512) NOT NULL COMMENT '消耗列表',
  PRIMARY KEY (`pos`,`prefix`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备重铸配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_equip_prefix`
--

LOCK TABLES `base_equip_prefix` WRITE;
/*!40000 ALTER TABLE `base_equip_prefix` DISABLE KEYS */;
INSERT INTO `base_equip_prefix` VALUES (1,1,'普通',800,'[{0,38040300,12}]'),(1,2,'优秀',1600,'[{0,38040300,24}]'),(1,3,'精良',2400,'[{0,38040300,36}]'),(1,4,'稀有',3200,'[{0,38040300,48},{0,38040302,12}]'),(1,5,'卓越',4000,'[{0,38040300,60},{0,38040302,18}]'),(1,6,'完美',4800,'[{0,38040300,72},{0,38040302,24}]'),(1,7,'史诗',5600,'[{0,38040300,84},{0,38040304,18}]'),(1,8,'传说',6400,'[{0,38040300,96},{0,38040304,25}]'),(1,9,'远古',7200,'[{0,38040300,108},{0,38040304,32}]'),(1,10,'不朽',8000,'[{0,38040300,120},{0,38040306,18}]'),(1,11,'圣物',8800,'[{0,38040300,132},{0,38040306,25}]'),(1,12,'神赐',9600,'[{0,38040300,144},{0,38040306,32}]'),(2,1,'普通',800,'[{0,38040300,12}]'),(2,2,'优秀',1600,'[{0,38040300,24}]'),(2,3,'精良',2400,'[{0,38040300,36}]'),(2,4,'稀有',3200,'[{0,38040300,48},{0,38040301,12}]'),(2,5,'卓越',4000,'[{0,38040300,60},{0,38040301,18}]'),(2,6,'完美',4800,'[{0,38040300,72},{0,38040301,24}]'),(2,7,'史诗',5600,'[{0,38040300,84},{0,38040303,18}]'),(2,8,'传说',6400,'[{0,38040300,96},{0,38040303,25}]'),(2,9,'远古',7200,'[{0,38040300,108},{0,38040303,32}]'),(2,10,'不朽',8000,'[{0,38040300,120},{0,38040305,18}]'),(2,11,'圣物',8800,'[{0,38040300,132},{0,38040305,25}]'),(2,12,'神赐',9600,'[{0,38040300,144},{0,38040305,32}]'),(3,1,'普通',800,'[{0,38040300,12}]'),(3,2,'优秀',1600,'[{0,38040300,24}]'),(3,3,'精良',2400,'[{0,38040300,36}]'),(3,4,'稀有',3200,'[{0,38040300,48},{0,38040307,12}]'),(3,5,'卓越',4000,'[{0,38040300,60},{0,38040307,18}]'),(3,6,'完美',4800,'[{0,38040300,72},{0,38040307,24}]'),(3,7,'史诗',5600,'[{0,38040300,84},{0,38040308,18}]'),(3,8,'传说',6400,'[{0,38040300,96},{0,38040308,25}]'),(3,9,'远古',7200,'[{0,38040300,108},{0,38040308,32}]'),(3,10,'不朽',8000,'[{0,38040300,120},{0,38040309,18}]'),(3,11,'圣物',8800,'[{0,38040300,132},{0,38040309,25}]'),(3,12,'神赐',9600,'[{0,38040300,144},{0,38040309,32}]'),(4,1,'普通',800,'[{0,38040300,12}]'),(4,2,'优秀',1600,'[{0,38040300,24}]'),(4,3,'精良',2400,'[{0,38040300,36}]'),(4,4,'稀有',3200,'[{0,38040300,48},{0,38040301,12}]'),(4,5,'卓越',4000,'[{0,38040300,60},{0,38040301,18}]'),(4,6,'完美',4800,'[{0,38040300,72},{0,38040301,24}]'),(4,7,'史诗',5600,'[{0,38040300,84},{0,38040303,18}]'),(4,8,'传说',6400,'[{0,38040300,96},{0,38040303,25}]'),(4,9,'远古',7200,'[{0,38040300,108},{0,38040303,32}]'),(4,10,'不朽',8000,'[{0,38040300,120},{0,38040305,18}]'),(4,11,'圣物',8800,'[{0,38040300,132},{0,38040305,25}]'),(4,12,'神赐',9600,'[{0,38040300,144},{0,38040305,32}]'),(5,1,'普通',800,'[{0,38040300,12}]'),(5,2,'优秀',1600,'[{0,38040300,24}]'),(5,3,'精良',2400,'[{0,38040300,36}]'),(5,4,'稀有',3200,'[{0,38040300,48},{0,38040302,12}]'),(5,5,'卓越',4000,'[{0,38040300,60},{0,38040302,18}]'),(5,6,'完美',4800,'[{0,38040300,72},{0,38040302,24}]'),(5,7,'史诗',5600,'[{0,38040300,84},{0,38040304,18}]'),(5,8,'传说',6400,'[{0,38040300,96},{0,38040304,25}]'),(5,9,'远古',7200,'[{0,38040300,108},{0,38040304,32}]'),(5,10,'不朽',8000,'[{0,38040300,120},{0,38040306,18}]'),(5,11,'圣物',8800,'[{0,38040300,132},{0,38040306,25}]'),(5,12,'神赐',9600,'[{0,38040300,144},{0,38040306,32}]'),(6,1,'普通',800,'[{0,38040300,12}]'),(6,2,'优秀',1600,'[{0,38040300,24}]'),(6,3,'精良',2400,'[{0,38040300,36}]'),(6,4,'稀有',3200,'[{0,38040300,48},{0,38040301,12}]'),(6,5,'卓越',4000,'[{0,38040300,60},{0,38040301,18}]'),(6,6,'完美',4800,'[{0,38040300,72},{0,38040301,24}]'),(6,7,'史诗',5600,'[{0,38040300,84},{0,38040303,18}]'),(6,8,'传说',6400,'[{0,38040300,96},{0,38040303,25}]'),(6,9,'远古',7200,'[{0,38040300,108},{0,38040303,32}]'),(6,10,'不朽',8000,'[{0,38040300,120},{0,38040305,18}]'),(6,11,'圣物',8800,'[{0,38040300,132},{0,38040305,25}]'),(6,12,'神赐',9600,'[{0,38040300,144},{0,38040305,32}]'),(7,1,'普通',800,'[{0,38040300,12}]'),(7,2,'优秀',1600,'[{0,38040300,24}]'),(7,3,'精良',2400,'[{0,38040300,36}]'),(7,4,'稀有',3200,'[{0,38040300,48},{0,38040302,12}]'),(7,5,'卓越',4000,'[{0,38040300,60},{0,38040302,18}]'),(7,6,'完美',4800,'[{0,38040300,72},{0,38040302,24}]'),(7,7,'史诗',5600,'[{0,38040300,84},{0,38040304,18}]'),(7,8,'传说',6400,'[{0,38040300,96},{0,38040304,25}]'),(7,9,'远古',7200,'[{0,38040300,108},{0,38040304,32}]'),(7,10,'不朽',8000,'[{0,38040300,120},{0,38040306,18}]'),(7,11,'圣物',8800,'[{0,38040300,132},{0,38040306,25}]'),(7,12,'神赐',9600,'[{0,38040300,144},{0,38040306,32}]'),(8,1,'普通',800,'[{0,38040300,12}]'),(8,2,'优秀',1600,'[{0,38040300,24}]'),(8,3,'精良',2400,'[{0,38040300,36}]'),(8,4,'稀有',3200,'[{0,38040300,48},{0,38040301,12}]'),(8,5,'卓越',4000,'[{0,38040300,60},{0,38040301,18}]'),(8,6,'完美',4800,'[{0,38040300,72},{0,38040301,24}]'),(8,7,'史诗',5600,'[{0,38040300,84},{0,38040303,18}]'),(8,8,'传说',6400,'[{0,38040300,96},{0,38040303,25}]'),(8,9,'远古',7200,'[{0,38040300,108},{0,38040303,32}]'),(8,10,'不朽',8000,'[{0,38040300,120},{0,38040305,18}]'),(8,11,'圣物',8800,'[{0,38040300,132},{0,38040305,25}]'),(8,12,'神赐',9600,'[{0,38040300,144},{0,38040305,32}]'),(9,1,'普通',800,'[{0,38040300,12}]'),(9,2,'优秀',1600,'[{0,38040300,24}]'),(9,3,'精良',2400,'[{0,38040300,36}]'),(9,4,'稀有',3200,'[{0,38040300,48},{0,38040307,12}]'),(9,5,'卓越',4000,'[{0,38040300,60},{0,38040307,18}]'),(9,6,'完美',4800,'[{0,38040300,72},{0,38040307,24}]'),(9,7,'史诗',5600,'[{0,38040300,84},{0,38040308,18}]'),(9,8,'传说',6400,'[{0,38040300,96},{0,38040308,25}]'),(9,9,'远古',7200,'[{0,38040300,108},{0,38040308,32}]'),(9,10,'不朽',8000,'[{0,38040300,120},{0,38040309,18}]'),(9,11,'圣物',8800,'[{0,38040300,132},{0,38040309,25}]'),(9,12,'神赐',9600,'[{0,38040300,144},{0,38040309,32}]'),(10,1,'普通',800,'[{0,38040300,12}]'),(10,2,'优秀',1600,'[{0,38040300,24}]'),(10,3,'精良',2400,'[{0,38040300,36}]'),(10,4,'稀有',3200,'[{0,38040300,48},{0,38040301,12}]'),(10,5,'卓越',4000,'[{0,38040300,60},{0,38040301,18}]'),(10,6,'完美',4800,'[{0,38040300,72},{0,38040301,24}]'),(10,7,'史诗',5600,'[{0,38040300,84},{0,38040303,18}]'),(10,8,'传说',6400,'[{0,38040300,96},{0,38040303,25}]'),(10,9,'远古',7200,'[{0,38040300,108},{0,38040303,32}]'),(10,10,'不朽',8000,'[{0,38040300,120},{0,38040305,18}]'),(10,11,'圣物',8800,'[{0,38040300,132},{0,38040305,25}]'),(10,12,'神赐',9600,'[{0,38040300,144},{0,38040305,32}]');
/*!40000 ALTER TABLE `base_equip_prefix` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_equip_prefix_max`
--

DROP TABLE IF EXISTS `base_equip_prefix_max`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_equip_prefix_max` (
  `pos` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '装备部位',
  `stage` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '装备阶数',
  `prefix_max` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '重铸上限',
  PRIMARY KEY (`pos`,`stage`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备重铸上限配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_equip_prefix_max`
--

LOCK TABLES `base_equip_prefix_max` WRITE;
/*!40000 ALTER TABLE `base_equip_prefix_max` DISABLE KEYS */;
INSERT INTO `base_equip_prefix_max` VALUES (1,1,1),(1,2,1),(1,3,1),(1,4,2),(1,5,4),(1,6,6),(1,7,8),(1,8,10),(1,9,12),(1,10,12),(1,11,12),(1,12,12),(1,13,12),(1,14,12),(1,15,12),(1,16,12),(2,1,1),(2,2,1),(2,3,1),(2,4,2),(2,5,4),(2,6,6),(2,7,8),(2,8,10),(2,9,12),(2,10,12),(2,11,12),(2,12,12),(2,13,12),(2,14,12),(2,15,12),(2,16,12),(3,1,1),(3,2,1),(3,3,1),(3,4,2),(3,5,4),(3,6,6),(3,7,8),(3,8,10),(3,9,12),(3,10,12),(3,11,12),(3,12,12),(3,13,12),(3,14,12),(3,15,12),(3,16,12),(4,1,1),(4,2,1),(4,3,1),(4,4,2),(4,5,4),(4,6,6),(4,7,8),(4,8,10),(4,9,12),(4,10,12),(4,11,12),(4,12,12),(4,13,12),(4,14,12),(4,15,12),(4,16,12),(5,1,1),(5,2,1),(5,3,1),(5,4,2),(5,5,4),(5,6,6),(5,7,8),(5,8,10),(5,9,12),(5,10,12),(5,11,12),(5,12,12),(5,13,12),(5,14,12),(5,15,12),(5,16,12),(6,1,1),(6,2,1),(6,3,1),(6,4,2),(6,5,4),(6,6,6),(6,7,8),(6,8,10),(6,9,12),(6,10,12),(6,11,12),(6,12,12),(6,13,12),(6,14,12),(6,15,12),(6,16,12),(7,1,1),(7,2,1),(7,3,1),(7,4,2),(7,5,4),(7,6,6),(7,7,8),(7,8,10),(7,9,12),(7,10,12),(7,11,12),(7,12,12),(7,13,12),(7,14,12),(7,15,12),(7,16,12),(8,1,1),(8,2,1),(8,3,1),(8,4,2),(8,5,4),(8,6,6),(8,7,8),(8,8,10),(8,9,12),(8,10,12),(8,11,12),(8,12,12),(8,13,12),(8,14,12),(8,15,12),(8,16,12),(9,1,1),(9,2,1),(9,3,1),(9,4,2),(9,5,4),(9,6,6),(9,7,8),(9,8,10),(9,9,12),(9,10,12),(9,11,12),(9,12,12),(9,13,12),(9,14,12),(9,15,12),(9,16,12),(10,1,1),(10,2,1),(10,3,1),(10,4,2),(10,5,4),(10,6,6),(10,7,8),(10,8,10),(10,9,12),(10,10,12),(10,11,12),(10,12,12),(10,13,12),(10,14,12),(10,15,12),(10,16,12);
/*!40000 ALTER TABLE `base_equip_prefix_max` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_equip_prefix_suit_attr`
--

DROP TABLE IF EXISTS `base_equip_prefix_suit_attr`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_equip_prefix_suit_attr` (
  `suit_type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '套装类型',
  `prefix` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '重铸次数',
  `num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '部位数量',
  `attr_list` varchar(512) NOT NULL COMMENT '属性列表',
  PRIMARY KEY (`suit_type`,`prefix`,`num`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备重铸套装属性配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_equip_prefix_suit_attr`
--

LOCK TABLES `base_equip_prefix_suit_attr` WRITE;
/*!40000 ALTER TABLE `base_equip_prefix_suit_attr` DISABLE KEYS */;
INSERT INTO `base_equip_prefix_suit_attr` VALUES (1,1,2,'[{1,100},{2,1000}]'),(1,2,3,'[{1,200},{2,2000}]'),(2,1,2,'[{1,200},{2,2000}]'),(2,2,3,'[{1,200},{2,2000}]');
/*!40000 ALTER TABLE `base_equip_prefix_suit_attr` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_equip_prefix_suit_belong`
--

DROP TABLE IF EXISTS `base_equip_prefix_suit_belong`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_equip_prefix_suit_belong` (
  `pos` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '装备部位',
  `suit_type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '所属套装',
  PRIMARY KEY (`pos`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备重铸套装归属配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_equip_prefix_suit_belong`
--

LOCK TABLES `base_equip_prefix_suit_belong` WRITE;
/*!40000 ALTER TABLE `base_equip_prefix_suit_belong` DISABLE KEYS */;
INSERT INTO `base_equip_prefix_suit_belong` VALUES (1,1),(2,2),(3,1),(4,2),(5,1),(6,1),(7,1),(8,2),(9,1),(10,2);
/*!40000 ALTER TABLE `base_equip_prefix_suit_belong` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_equip_star_suit`
--

DROP TABLE IF EXISTS `base_equip_star_suit`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_equip_star_suit` (
  `suit_name` varchar(128) NOT NULL COMMENT '套装名',
  `stage` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '装备阶数',
  `star_cond` varchar(64) NOT NULL COMMENT '条件',
  `num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '数量',
  `attr_list` varchar(512) NOT NULL COMMENT '属性列表',
  PRIMARY KEY (`stage`,`star_cond`,`num`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备星阶套装配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_equip_star_suit`
--

LOCK TABLES `base_equip_star_suit` WRITE;
/*!40000 ALTER TABLE `base_equip_star_suit` DISABLE KEYS */;
INSERT INTO `base_equip_star_suit` VALUES ('6阶红2星套装',6,'{4,2}',2,'[{53,800}]'),('6阶红2星套装',6,'{4,2}',4,'[{13,400}]'),('6阶红2星套装',6,'{4,2}',6,'[{52,1200}]'),('6阶红3星套装',6,'{4,3}',2,'[{53,820}]'),('6阶红3星套装',6,'{4,3}',4,'[{13,410}]'),('6阶红3星套装',6,'{4,3}',6,'[{52,1230}]'),('6阶粉装套装',6,'{5,3}',2,'[{53,840}]'),('6阶粉装套装',6,'{5,3}',4,'[{13,420}]'),('6阶粉装套装',6,'{5,3}',6,'[{52,1260}]'),('7阶红2星套装',7,'{4,2}',2,'[{53,840}]'),('7阶红2星套装',7,'{4,2}',4,'[{13,420}]'),('7阶红2星套装',7,'{4,2}',6,'[{52,1260}]'),('7阶红3星套装',7,'{4,3}',2,'[{53,880}]'),('7阶红3星套装',7,'{4,3}',4,'[{13,440}]'),('7阶红3星套装',7,'{4,3}',6,'[{52,1320}]'),('7阶粉装套装',7,'{5,3}',2,'[{53,920}]'),('7阶粉装套装',7,'{5,3}',4,'[{13,460}]'),('7阶粉装套装',7,'{5,3}',6,'[{52,1380}]'),('8阶红2星套装',8,'{4,2}',2,'[{53,880}]'),('8阶红2星套装',8,'{4,2}',4,'[{13,440}]'),('8阶红2星套装',8,'{4,2}',6,'[{52,1320}]'),('8阶红3星套装',8,'{4,3}',2,'[{53,940}]'),('8阶红3星套装',8,'{4,3}',4,'[{13,470}]'),('8阶红3星套装',8,'{4,3}',6,'[{52,1410}]'),('8阶粉装套装',8,'{5,3}',2,'[{53,1000}]'),('8阶粉装套装',8,'{5,3}',4,'[{13,500}]'),('8阶粉装套装',8,'{5,3}',6,'[{52,1500}]'),('9阶红2星套装',9,'{4,2}',2,'[{53,920}]'),('9阶红2星套装',9,'{4,2}',4,'[{13,460}]'),('9阶红2星套装',9,'{4,2}',6,'[{52,1380}]'),('9阶红3星套装',9,'{4,3}',2,'[{53,1000}]'),('9阶红3星套装',9,'{4,3}',4,'[{13,500}]'),('9阶红3星套装',9,'{4,3}',6,'[{52,1500}]'),('9阶粉装套装',9,'{5,3}',2,'[{53,1080}]'),('9阶粉装套装',9,'{5,3}',4,'[{13,540}]'),('9阶粉装套装',9,'{5,3}',6,'[{52,1620}]'),('10阶红2星套装',10,'{4,2}',2,'[{53,960}]'),('10阶红2星套装',10,'{4,2}',4,'[{13,480}]'),('10阶红2星套装',10,'{4,2}',6,'[{52,1440}]'),('10阶红3星套装',10,'{4,3}',2,'[{53,1060}]'),('10阶红3星套装',10,'{4,3}',4,'[{13,530}]'),('10阶红3星套装',10,'{4,3}',6,'[{52,1590}]'),('10阶粉装套装',10,'{5,3}',2,'[{53,1160}]'),('10阶粉装套装',10,'{5,3}',4,'[{13,580}]'),('10阶粉装套装',10,'{5,3}',6,'[{52,1740}]'),('11阶红2星套装',11,'{4,2}',2,'[{53,1000}]'),('11阶红2星套装',11,'{4,2}',4,'[{13,500}]'),('11阶红2星套装',11,'{4,2}',6,'[{52,1500}]'),('11阶红3星套装',11,'{4,3}',2,'[{53,1120}]'),('11阶红3星套装',11,'{4,3}',4,'[{13,560}]'),('11阶红3星套装',11,'{4,3}',6,'[{52,1680}]'),('11阶粉装套装',11,'{5,3}',2,'[{53,1240}]'),('11阶粉装套装',11,'{5,3}',4,'[{13,620}]'),('11阶粉装套装',11,'{5,3}',6,'[{52,1860}]'),('12阶红2星套装',12,'{4,2}',2,'[{53,1040}]'),('12阶红2星套装',12,'{4,2}',4,'[{13,520}]'),('12阶红2星套装',12,'{4,2}',6,'[{52,1560}]'),('12阶红3星套装',12,'{4,3}',2,'[{53,1180}]'),('12阶红3星套装',12,'{4,3}',4,'[{13,590}]'),('12阶红3星套装',12,'{4,3}',6,'[{52,1770}]'),('12阶粉装套装',12,'{5,3}',2,'[{53,1320}]'),('12阶粉装套装',12,'{5,3}',4,'[{13,660}]'),('12阶粉装套装',12,'{5,3}',6,'[{52,1980}]'),('13阶红2星套装',13,'{4,2}',2,'[{53,1080}]'),('13阶红2星套装',13,'{4,2}',4,'[{13,540}]'),('13阶红2星套装',13,'{4,2}',6,'[{52,1620}]'),('13阶红3星套装',13,'{4,3}',2,'[{53,1240}]'),('13阶红3星套装',13,'{4,3}',4,'[{13,620}]'),('13阶红3星套装',13,'{4,3}',6,'[{52,1860}]'),('13阶粉装套装',13,'{5,3}',2,'[{53,1400}]'),('13阶粉装套装',13,'{5,3}',4,'[{13,700}]'),('13阶粉装套装',13,'{5,3}',6,'[{52,2100}]'),('14阶红2星套装',14,'{4,2}',2,'[{53,1120}]'),('14阶红2星套装',14,'{4,2}',4,'[{13,560}]'),('14阶红2星套装',14,'{4,2}',6,'[{52,1680}]'),('14阶红3星套装',14,'{4,3}',2,'[{53,1300}]'),('14阶红3星套装',14,'{4,3}',4,'[{13,650}]'),('14阶红3星套装',14,'{4,3}',6,'[{52,1950}]'),('14阶粉装套装',14,'{5,3}',2,'[{53,1480}]'),('14阶粉装套装',14,'{5,3}',4,'[{13,740}]'),('14阶粉装套装',14,'{5,3}',6,'[{52,2220}]'),('15阶红2星套装',15,'{4,2}',2,'[{53,1160}]'),('15阶红2星套装',15,'{4,2}',4,'[{13,580}]'),('15阶红2星套装',15,'{4,2}',6,'[{52,1740}]'),('15阶红3星套装',15,'{4,3}',2,'[{53,1360}]'),('15阶红3星套装',15,'{4,3}',4,'[{13,680}]'),('15阶红3星套装',15,'{4,3}',6,'[{52,2040}]'),('15阶粉装套装',15,'{5,3}',2,'[{53,1560}]'),('15阶粉装套装',15,'{5,3}',4,'[{13,780}]'),('15阶粉装套装',15,'{5,3}',6,'[{52,2340}]'),('16阶红2星套装',16,'{4,2}',2,'[{53,1200}]'),('16阶红2星套装',16,'{4,2}',4,'[{13,600}]'),('16阶红2星套装',16,'{4,2}',6,'[{52,1800}]'),('16阶红3星套装',16,'{4,3}',2,'[{53,1420}]'),('16阶红3星套装',16,'{4,3}',4,'[{13,710}]'),('16阶红3星套装',16,'{4,3}',6,'[{52,2130}]'),('16阶粉装套装',16,'{5,3}',2,'[{53,1640}]'),('16阶粉装套装',16,'{5,3}',4,'[{13,820}]'),('16阶粉装套装',16,'{5,3}',6,'[{52,2460}]');
/*!40000 ALTER TABLE `base_equip_star_suit` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_equip_stone_compose_cost`
--

DROP TABLE IF EXISTS `base_equip_stone_compose_cost`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_equip_stone_compose_cost` (
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品id',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '合成消耗',
  PRIMARY KEY (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='宝石合成消耗配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_equip_stone_compose_cost`
--

LOCK TABLES `base_equip_stone_compose_cost` WRITE;
/*!40000 ALTER TABLE `base_equip_stone_compose_cost` DISABLE KEYS */;
INSERT INTO `base_equip_stone_compose_cost` VALUES (14010101,'[{0,14120001,3}]'),(14010102,'[{0,14010101,3}]'),(14010103,'[{0,14010102,3}]'),(14010104,'[{0,14010103,3}]'),(14010105,'[{0,14010104,3}]'),(14010106,'[{0,14010105,3}]'),(14010107,'[{0,14010106,3}]'),(14010108,'[{0,14010107,3}]'),(14010109,'[{0,14010108,3}]'),(14010301,'[{0,14120001,3}]'),(14010302,'[{0,14010301,3}]'),(14010303,'[{0,14010302,3}]'),(14010304,'[{0,14010303,3}]'),(14010305,'[{0,14010304,3}]'),(14010306,'[{0,14010305,3}]'),(14010307,'[{0,14010306,3}]'),(14010308,'[{0,14010307,3}]'),(14010309,'[{0,14010308,3}]'),(14010501,'[{0,14120001,3}]'),(14010502,'[{0,14010501,3}]'),(14010503,'[{0,14010502,3}]'),(14010504,'[{0,14010503,3}]'),(14010505,'[{0,14010504,3}]'),(14010506,'[{0,14010505,3}]'),(14010507,'[{0,14010506,3}]'),(14010508,'[{0,14010507,3}]'),(14010509,'[{0,14010508,3}]'),(14010701,'[{0,14120001,3}]'),(14010702,'[{0,14010701,3}]'),(14010703,'[{0,14010702,3}]'),(14010704,'[{0,14010703,3}]'),(14010705,'[{0,14010704,3}]'),(14010706,'[{0,14010705,3}]'),(14010707,'[{0,14010706,3}]'),(14010708,'[{0,14010707,3}]'),(14010709,'[{0,14010708,3}]'),(14020201,'[{0,14120001,3}]'),(14020202,'[{0,14020201,3}]'),(14020203,'[{0,14020202,3}]'),(14020204,'[{0,14020203,3}]'),(14020205,'[{0,14020204,3}]'),(14020206,'[{0,14020205,3}]'),(14020207,'[{0,14020206,3}]'),(14020208,'[{0,14020207,3}]'),(14020209,'[{0,14020208,3}]'),(14020401,'[{0,14120001,3}]'),(14020402,'[{0,14020401,3}]'),(14020403,'[{0,14020402,3}]'),(14020404,'[{0,14020403,3}]'),(14020405,'[{0,14020404,3}]'),(14020406,'[{0,14020405,3}]'),(14020407,'[{0,14020406,3}]'),(14020408,'[{0,14020407,3}]'),(14020409,'[{0,14020408,3}]'),(14020601,'[{0,14120001,3}]'),(14020602,'[{0,14020601,3}]'),(14020603,'[{0,14020602,3}]'),(14020604,'[{0,14020603,3}]'),(14020605,'[{0,14020604,3}]'),(14020606,'[{0,14020605,3}]'),(14020607,'[{0,14020606,3}]'),(14020608,'[{0,14020607,3}]'),(14020609,'[{0,14020608,3}]'),(14020801,'[{0,14120001,3}]'),(14020802,'[{0,14020801,3}]'),(14020803,'[{0,14020802,3}]'),(14020804,'[{0,14020803,3}]'),(14020805,'[{0,14020804,3}]'),(14020806,'[{0,14020805,3}]'),(14020807,'[{0,14020806,3}]'),(14020808,'[{0,14020807,3}]'),(14020809,'[{0,14020808,3}]');
/*!40000 ALTER TABLE `base_equip_stone_compose_cost` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_equip_stone_inlay`
--

DROP TABLE IF EXISTS `base_equip_stone_inlay`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_equip_stone_inlay` (
  `equip_pos` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '装备位置',
  `stone_type` varchar(255) NOT NULL DEFAULT '[]' COMMENT '宝石子类型列表[宝石子类型]',
  PRIMARY KEY (`equip_pos`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备镶嵌类型配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_equip_stone_inlay`
--

LOCK TABLES `base_equip_stone_inlay` WRITE;
/*!40000 ALTER TABLE `base_equip_stone_inlay` DISABLE KEYS */;
INSERT INTO `base_equip_stone_inlay` VALUES (1,'[1,3,5,7,9,13]'),(2,'[2,4,6,8,10,14]'),(3,'[1,3,5,7,9,13]'),(4,'[2,4,6,8,10,14]'),(5,'[1,3,5,7,9,13]'),(6,'[2,4,6,8,10,14]'),(7,'[1,3,5,7,9,13]'),(8,'[2,4,6,8,10,14]'),(9,'[1,3,5,7,9,13]'),(10,'[2,4,6,8,10,14]');
/*!40000 ALTER TABLE `base_equip_stone_inlay` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_equip_stone_lv`
--

DROP TABLE IF EXISTS `base_equip_stone_lv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_equip_stone_lv` (
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品id',
  `lv` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '宝石等级',
  `rating` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '评分',
  `attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '属性',
  PRIMARY KEY (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='宝石等级配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_equip_stone_lv`
--

LOCK TABLES `base_equip_stone_lv` WRITE;
/*!40000 ALTER TABLE `base_equip_stone_lv` DISABLE KEYS */;
INSERT INTO `base_equip_stone_lv` VALUES (11,1,9999,'[{1,300},{2,6000},{3,150},{4,150}]'),(12,2,99999,'[{1,3000},{2,60000},{3,1500},{4,1500}]'),(13,3,999999,'[{1,30000},{2,600000},{3,15000},{4,15000}]'),(14,4,9999999,'[{1,300000},{2,6000000},{3,150000},{4,150000}]'),(14010101,1,900,'[{1,45}]'),(14010102,2,1800,'[{1,90}]'),(14010103,3,3600,'[{1,180}]'),(14010104,4,7300,'[{1,365}]'),(14010105,5,14700,'[{1,735}]'),(14010106,6,29400,'[{1,1470}]'),(14010107,7,50000,'[{1,2500}]'),(14010108,8,80000,'[{1,4000}]'),(14010109,9,120000,'[{1,6000}]'),(14010301,1,900,'[{3,36}]'),(14010302,2,1800,'[{3,72}]'),(14010303,3,3625,'[{3,145}]'),(14010304,4,7350,'[{3,294}]'),(14010305,5,14700,'[{3,588}]'),(14010306,6,29000,'[{3,1160}]'),(14010307,7,50000,'[{3,2000}]'),(14010308,8,80000,'[{3,3200}]'),(14010309,9,120000,'[{3,4800}]'),(14010501,1,900,'[{5,18}]'),(14010502,2,1800,'[{5,36}]'),(14010503,3,3600,'[{5,72}]'),(14010504,4,7200,'[{5,144}]'),(14010505,5,14700,'[{5,294}]'),(14010506,6,29400,'[{5,588}]'),(14010507,7,50000,'[{5,1000}]'),(14010508,8,80000,'[{5,1600}]'),(14010509,9,120000,'[{5,2400}]'),(14010701,1,900,'[{7,18}]'),(14010702,2,1800,'[{7,36}]'),(14010703,3,3600,'[{7,72}]'),(14010704,4,7200,'[{7,144}]'),(14010705,5,14700,'[{7,294}]'),(14010706,6,29400,'[{7,588}]'),(14010707,7,50000,'[{7,1000}]'),(14010708,8,80000,'[{7,1600}]'),(14010709,9,120000,'[{7,2400}]'),(14020201,1,900,'[{2,900}]'),(14020202,2,1800,'[{2,1800}]'),(14020203,3,3600,'[{2,3600}]'),(14020204,4,7200,'[{2,7200}]'),(14020205,5,14700,'[{2,14700}]'),(14020206,6,29400,'[{2,29400}]'),(14020207,7,50000,'[{2,50000}]'),(14020208,8,80000,'[{2,80000}]'),(14020209,9,120000,'[{2,120000}]'),(14020401,1,900,'[{4,36}]'),(14020402,2,1800,'[{4,72}]'),(14020403,3,3625,'[{4,145}]'),(14020404,4,7350,'[{4,294}]'),(14020405,5,14700,'[{4,588}]'),(14020406,6,29000,'[{4,1160}]'),(14020407,7,50000,'[{4,2000}]'),(14020408,8,80000,'[{4,3200}]'),(14020409,9,120000,'[{4,4800}]'),(14020601,1,900,'[{6,18}]'),(14020602,2,1800,'[{6,36}]'),(14020603,3,3600,'[{6,72}]'),(14020604,4,7200,'[{6,144}]'),(14020605,5,14700,'[{6,294}]'),(14020606,6,29400,'[{6,588}]'),(14020607,7,50000,'[{6,1000}]'),(14020608,8,80000,'[{6,1600}]'),(14020609,9,120000,'[{6,2400}]'),(14020801,1,900,'[{8,18}]'),(14020802,2,1800,'[{8,36}]'),(14020803,3,3600,'[{8,72}]'),(14020804,4,7200,'[{8,144}]'),(14020805,5,14700,'[{8,294}]'),(14020806,6,29400,'[{8,588}]'),(14020807,7,50000,'[{8,1000}]'),(14020808,8,80000,'[{8,1600}]'),(14020809,9,120000,'[{8,2400}]'),(14140110,1,50000,'[{9,900},{23,750}]'),(14140111,2,80000,'[{9,1600},{23,1350}]'),(14140112,3,120000,'[{9,2400},{23,2000}]'),(14140210,1,50000,'[{27,1130},{25,750}]'),(14140211,2,80000,'[{27,2025},{25,1350}]'),(14140212,3,120000,'[{27,3040},{25,2000}]'),(14140310,1,50000,'[{50,1500},{19,750}]'),(14140311,2,80000,'[{50,2700},{19,1350}]'),(14140312,3,120000,'[{50,4050},{19,2000}]'),(14140410,1,50000,'[{51,1500},{21,750}]'),(14140411,2,80000,'[{51,2700},{21,1350}]'),(14140412,3,120000,'[{51,4050},{21,2000}]'),(14140510,1,50000,'[{10,900},{24,750}]'),(14140511,2,80000,'[{10,1600},{24,1350}]'),(14140512,3,120000,'[{10,2400},{24,2000}]'),(14140610,1,50000,'[{28,1130},{26,750}]'),(14140611,2,80000,'[{28,2025},{26,1350}]'),(14140612,3,120000,'[{28,3040},{26,2000}]'),(14140710,1,50000,'[{230,1500},{20,750}]'),(14140711,2,80000,'[{230,2700},{20,1350}]'),(14140712,3,120000,'[{230,4050},{20,2000}]'),(14140810,1,50000,'[{231,1500},{22,750}]'),(14140811,2,80000,'[{231,2700},{22,1350}]'),(14140812,3,120000,'[{231,4050},{22,2000}]');
/*!40000 ALTER TABLE `base_equip_stone_lv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_equip_stone_pos_unlock`
--

DROP TABLE IF EXISTS `base_equip_stone_pos_unlock`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_equip_stone_pos_unlock` (
  `equip_pos` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '装备位置',
  `stone_pos` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '宝石孔位置',
  `condition` varchar(255) NOT NULL DEFAULT '[]' COMMENT '解锁条件',
  PRIMARY KEY (`equip_pos`,`stone_pos`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='宝石孔解锁配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_equip_stone_pos_unlock`
--

LOCK TABLES `base_equip_stone_pos_unlock` WRITE;
/*!40000 ALTER TABLE `base_equip_stone_pos_unlock` DISABLE KEYS */;
INSERT INTO `base_equip_stone_pos_unlock` VALUES (1,1,'[{stage,1}]'),(1,2,'[{stage,3}]'),(1,3,'[{stage,4}]'),(1,4,'[{stage,5}]'),(1,5,'[{stage,7}]'),(1,6,'[{vip,5}]'),(2,1,'[{stage,1}]'),(2,2,'[{stage,3}]'),(2,3,'[{stage,4}]'),(2,4,'[{stage,5}]'),(2,5,'[{stage,7}]'),(2,6,'[{vip,5}]'),(3,1,'[{stage,1}]'),(3,2,'[{stage,3}]'),(3,3,'[{stage,4}]'),(3,4,'[{stage,5}]'),(3,5,'[{stage,7}]'),(3,6,'[{vip,5}]'),(4,1,'[{stage,1}]'),(4,2,'[{stage,3}]'),(4,3,'[{stage,4}]'),(4,4,'[{stage,5}]'),(4,5,'[{stage,7}]'),(4,6,'[{vip,5}]'),(5,1,'[{stage,1}]'),(5,2,'[{stage,3}]'),(5,3,'[{stage,4}]'),(5,4,'[{stage,5}]'),(5,5,'[{stage,7}]'),(5,6,'[{vip,5}]'),(6,1,'[{stage,1}]'),(6,2,'[{stage,3}]'),(6,3,'[{stage,4}]'),(6,4,'[{stage,5}]'),(6,5,'[{stage,7}]'),(6,6,'[{vip,5}]'),(7,1,'[{stage,1}]'),(7,2,'[{stage,3}]'),(7,3,'[{stage,4}]'),(7,4,'[{stage,5}]'),(7,5,'[{stage,7}]'),(7,6,'[{vip,5}]'),(8,1,'[{stage,1}]'),(8,2,'[{stage,3}]'),(8,3,'[{stage,4}]'),(8,4,'[{stage,5}]'),(8,5,'[{stage,7}]'),(8,6,'[{vip,5}]'),(9,1,'[{stage,1}]'),(9,2,'[{stage,3}]'),(9,3,'[{stage,4}]'),(9,4,'[{stage,5}]'),(9,5,'[{stage,7}]'),(9,6,'[{vip,5}]'),(10,1,'[{stage,1}]'),(10,2,'[{stage,3}]'),(10,3,'[{stage,4}]'),(10,4,'[{stage,5}]'),(10,5,'[{stage,7}]'),(10,6,'[{vip,5}]');
/*!40000 ALTER TABLE `base_equip_stone_pos_unlock` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_equip_stone_refine`
--

DROP TABLE IF EXISTS `base_equip_stone_refine`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_equip_stone_refine` (
  `equip_pos` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '装备位置',
  `refine_lv` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '精炼等级',
  `attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '属性',
  `overall_plus` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '总提升',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '升级所需经验',
  `rating` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '评分',
  PRIMARY KEY (`equip_pos`,`refine_lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='宝石精炼配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_equip_stone_refine`
--

LOCK TABLES `base_equip_stone_refine` WRITE;
/*!40000 ALTER TABLE `base_equip_stone_refine` DISABLE KEYS */;
INSERT INTO `base_equip_stone_refine` VALUES (1,0,'[{1,0},{15,0}]',0,50,0),(1,1,'[{1,8},{15,8}]',3,58,160),(1,2,'[{1,16},{15,16}]',6,71,320),(1,3,'[{1,24},{15,24}]',9,90,480),(1,4,'[{1,32},{15,32}]',12,115,640),(1,5,'[{1,40},{15,40}]',15,146,800),(1,6,'[{1,48},{15,48}]',18,184,960),(1,7,'[{1,56},{15,56}]',21,228,1120),(1,8,'[{1,64},{15,64}]',24,280,1280),(1,9,'[{1,72},{15,72}]',27,339,1440),(1,10,'[{1,80},{15,80}]',30,406,1600),(1,11,'[{1,88},{15,88}]',33,482,1760),(1,12,'[{1,96},{15,96}]',36,567,1920),(1,13,'[{1,104},{15,104}]',39,661,2080),(1,14,'[{1,112},{15,112}]',42,765,2240),(1,15,'[{1,120},{15,120}]',45,879,2400),(1,16,'[{1,128},{15,128}]',48,1004,2560),(1,17,'[{1,136},{15,136}]',51,1141,2720),(1,18,'[{1,144},{15,144}]',54,1290,2880),(1,19,'[{1,152},{15,152}]',57,1451,3040),(1,20,'[{1,160},{15,160}]',60,1626,3200),(1,21,'[{1,168},{15,168}]',63,1815,3360),(1,22,'[{1,176},{15,176}]',66,2018,3520),(1,23,'[{1,184},{15,184}]',69,2237,3680),(1,24,'[{1,192},{15,192}]',72,2472,3840),(1,25,'[{1,200},{15,200}]',75,999999,4000),(2,0,'[{2,0},{16,0}]',0,50,0),(2,1,'[{2,160},{16,8}]',3,58,160),(2,2,'[{2,320},{16,16}]',6,71,320),(2,3,'[{2,480},{16,24}]',9,90,480),(2,4,'[{2,640},{16,32}]',12,115,640),(2,5,'[{2,800},{16,40}]',15,146,800),(2,6,'[{2,960},{16,48}]',18,184,960),(2,7,'[{2,1120},{16,56}]',21,228,1120),(2,8,'[{2,1280},{16,64}]',24,280,1280),(2,9,'[{2,1440},{16,72}]',27,339,1440),(2,10,'[{2,1600},{16,80}]',30,406,1600),(2,11,'[{2,1760},{16,88}]',33,482,1760),(2,12,'[{2,1920},{16,96}]',36,567,1920),(2,13,'[{2,2080},{16,104}]',39,661,2080),(2,14,'[{2,2240},{16,112}]',42,765,2240),(2,15,'[{2,2400},{16,120}]',45,879,2400),(2,16,'[{2,2560},{16,128}]',48,1004,2560),(2,17,'[{2,2720},{16,136}]',51,1141,2720),(2,18,'[{2,2880},{16,144}]',54,1290,2880),(2,19,'[{2,3040},{16,152}]',57,1451,3040),(2,20,'[{2,3200},{16,160}]',60,1626,3200),(2,21,'[{2,3360},{16,168}]',63,1815,3360),(2,22,'[{2,3520},{16,176}]',66,2018,3520),(2,23,'[{2,3680},{16,184}]',69,2237,3680),(2,24,'[{2,3840},{16,192}]',72,2472,3840),(2,25,'[{2,4000},{16,200}]',75,999999,4000),(3,0,'[{1,0},{15,0}]',0,50,0),(3,1,'[{1,8},{15,8}]',3,58,160),(3,2,'[{1,16},{15,16}]',6,71,320),(3,3,'[{1,24},{15,24}]',9,90,480),(3,4,'[{1,32},{15,32}]',12,115,640),(3,5,'[{1,40},{15,40}]',15,146,800),(3,6,'[{1,48},{15,48}]',18,184,960),(3,7,'[{1,56},{15,56}]',21,228,1120),(3,8,'[{1,64},{15,64}]',24,280,1280),(3,9,'[{1,72},{15,72}]',27,339,1440),(3,10,'[{1,80},{15,80}]',30,406,1600),(3,11,'[{1,88},{15,88}]',33,482,1760),(3,12,'[{1,96},{15,96}]',36,567,1920),(3,13,'[{1,104},{15,104}]',39,661,2080),(3,14,'[{1,112},{15,112}]',42,765,2240),(3,15,'[{1,120},{15,120}]',45,879,2400),(3,16,'[{1,128},{15,128}]',48,1004,2560),(3,17,'[{1,136},{15,136}]',51,1141,2720),(3,18,'[{1,144},{15,144}]',54,1290,2880),(3,19,'[{1,152},{15,152}]',57,1451,3040),(3,20,'[{1,160},{15,160}]',60,1626,3200),(3,21,'[{1,168},{15,168}]',63,1815,3360),(3,22,'[{1,176},{15,176}]',66,2018,3520),(3,23,'[{1,184},{15,184}]',69,2237,3680),(3,24,'[{1,192},{15,192}]',72,2472,3840),(3,25,'[{1,200},{15,200}]',75,999999,4000),(4,0,'[{2,0},{16,0}]',0,50,0),(4,1,'[{2,160},{16,8}]',3,58,160),(4,2,'[{2,320},{16,16}]',6,71,320),(4,3,'[{2,480},{16,24}]',9,90,480),(4,4,'[{2,640},{16,32}]',12,115,640),(4,5,'[{2,800},{16,40}]',15,146,800),(4,6,'[{2,960},{16,48}]',18,184,960),(4,7,'[{2,1120},{16,56}]',21,228,1120),(4,8,'[{2,1280},{16,64}]',24,280,1280),(4,9,'[{2,1440},{16,72}]',27,339,1440),(4,10,'[{2,1600},{16,80}]',30,406,1600),(4,11,'[{2,1760},{16,88}]',33,482,1760),(4,12,'[{2,1920},{16,96}]',36,567,1920),(4,13,'[{2,2080},{16,104}]',39,661,2080),(4,14,'[{2,2240},{16,112}]',42,765,2240),(4,15,'[{2,2400},{16,120}]',45,879,2400),(4,16,'[{2,2560},{16,128}]',48,1004,2560),(4,17,'[{2,2720},{16,136}]',51,1141,2720),(4,18,'[{2,2880},{16,144}]',54,1290,2880),(4,19,'[{2,3040},{16,152}]',57,1451,3040),(4,20,'[{2,3200},{16,160}]',60,1626,3200),(4,21,'[{2,3360},{16,168}]',63,1815,3360),(4,22,'[{2,3520},{16,176}]',66,2018,3520),(4,23,'[{2,3680},{16,184}]',69,2237,3680),(4,24,'[{2,3840},{16,192}]',72,2472,3840),(4,25,'[{2,4000},{16,200}]',75,999999,4000),(5,0,'[{1,0},{15,0}]',0,50,0),(5,1,'[{1,8},{15,8}]',3,58,160),(5,2,'[{1,16},{15,16}]',6,71,320),(5,3,'[{1,24},{15,24}]',9,90,480),(5,4,'[{1,32},{15,32}]',12,115,640),(5,5,'[{1,40},{15,40}]',15,146,800),(5,6,'[{1,48},{15,48}]',18,184,960),(5,7,'[{1,56},{15,56}]',21,228,1120),(5,8,'[{1,64},{15,64}]',24,280,1280),(5,9,'[{1,72},{15,72}]',27,339,1440),(5,10,'[{1,80},{15,80}]',30,406,1600),(5,11,'[{1,88},{15,88}]',33,482,1760),(5,12,'[{1,96},{15,96}]',36,567,1920),(5,13,'[{1,104},{15,104}]',39,661,2080),(5,14,'[{1,112},{15,112}]',42,765,2240),(5,15,'[{1,120},{15,120}]',45,879,2400),(5,16,'[{1,128},{15,128}]',48,1004,2560),(5,17,'[{1,136},{15,136}]',51,1141,2720),(5,18,'[{1,144},{15,144}]',54,1290,2880),(5,19,'[{1,152},{15,152}]',57,1451,3040),(5,20,'[{1,160},{15,160}]',60,1626,3200),(5,21,'[{1,168},{15,168}]',63,1815,3360),(5,22,'[{1,176},{15,176}]',66,2018,3520),(5,23,'[{1,184},{15,184}]',69,2237,3680),(5,24,'[{1,192},{15,192}]',72,2472,3840),(5,25,'[{1,200},{15,200}]',75,999999,4000),(6,0,'[{2,0},{16,0}]',0,50,0),(6,1,'[{2,160},{16,8}]',3,58,160),(6,2,'[{2,320},{16,16}]',6,71,320),(6,3,'[{2,480},{16,24}]',9,90,480),(6,4,'[{2,640},{16,32}]',12,115,640),(6,5,'[{2,800},{16,40}]',15,146,800),(6,6,'[{2,960},{16,48}]',18,184,960),(6,7,'[{2,1120},{16,56}]',21,228,1120),(6,8,'[{2,1280},{16,64}]',24,280,1280),(6,9,'[{2,1440},{16,72}]',27,339,1440),(6,10,'[{2,1600},{16,80}]',30,406,1600),(6,11,'[{2,1760},{16,88}]',33,482,1760),(6,12,'[{2,1920},{16,96}]',36,567,1920),(6,13,'[{2,2080},{16,104}]',39,661,2080),(6,14,'[{2,2240},{16,112}]',42,765,2240),(6,15,'[{2,2400},{16,120}]',45,879,2400),(6,16,'[{2,2560},{16,128}]',48,1004,2560),(6,17,'[{2,2720},{16,136}]',51,1141,2720),(6,18,'[{2,2880},{16,144}]',54,1290,2880),(6,19,'[{2,3040},{16,152}]',57,1451,3040),(6,20,'[{2,3200},{16,160}]',60,1626,3200),(6,21,'[{2,3360},{16,168}]',63,1815,3360),(6,22,'[{2,3520},{16,176}]',66,2018,3520),(6,23,'[{2,3680},{16,184}]',69,2237,3680),(6,24,'[{2,3840},{16,192}]',72,2472,3840),(6,25,'[{2,4000},{16,200}]',75,999999,4000),(7,0,'[{1,0},{15,0}]',0,50,0),(7,1,'[{1,8},{15,8}]',3,58,160),(7,2,'[{1,16},{15,16}]',6,71,320),(7,3,'[{1,24},{15,24}]',9,90,480),(7,4,'[{1,32},{15,32}]',12,115,640),(7,5,'[{1,40},{15,40}]',15,146,800),(7,6,'[{1,48},{15,48}]',18,184,960),(7,7,'[{1,56},{15,56}]',21,228,1120),(7,8,'[{1,64},{15,64}]',24,280,1280),(7,9,'[{1,72},{15,72}]',27,339,1440),(7,10,'[{1,80},{15,80}]',30,406,1600),(7,11,'[{1,88},{15,88}]',33,482,1760),(7,12,'[{1,96},{15,96}]',36,567,1920),(7,13,'[{1,104},{15,104}]',39,661,2080),(7,14,'[{1,112},{15,112}]',42,765,2240),(7,15,'[{1,120},{15,120}]',45,879,2400),(7,16,'[{1,128},{15,128}]',48,1004,2560),(7,17,'[{1,136},{15,136}]',51,1141,2720),(7,18,'[{1,144},{15,144}]',54,1290,2880),(7,19,'[{1,152},{15,152}]',57,1451,3040),(7,20,'[{1,160},{15,160}]',60,1626,3200),(7,21,'[{1,168},{15,168}]',63,1815,3360),(7,22,'[{1,176},{15,176}]',66,2018,3520),(7,23,'[{1,184},{15,184}]',69,2237,3680),(7,24,'[{1,192},{15,192}]',72,2472,3840),(7,25,'[{1,200},{15,200}]',75,999999,4000),(8,0,'[{2,0},{16,0}]',0,50,0),(8,1,'[{2,160},{16,8}]',3,58,160),(8,2,'[{2,320},{16,16}]',6,71,320),(8,3,'[{2,480},{16,24}]',9,90,480),(8,4,'[{2,640},{16,32}]',12,115,640),(8,5,'[{2,800},{16,40}]',15,146,800),(8,6,'[{2,960},{16,48}]',18,184,960),(8,7,'[{2,1120},{16,56}]',21,228,1120),(8,8,'[{2,1280},{16,64}]',24,280,1280),(8,9,'[{2,1440},{16,72}]',27,339,1440),(8,10,'[{2,1600},{16,80}]',30,406,1600),(8,11,'[{2,1760},{16,88}]',33,482,1760),(8,12,'[{2,1920},{16,96}]',36,567,1920),(8,13,'[{2,2080},{16,104}]',39,661,2080),(8,14,'[{2,2240},{16,112}]',42,765,2240),(8,15,'[{2,2400},{16,120}]',45,879,2400),(8,16,'[{2,2560},{16,128}]',48,1004,2560),(8,17,'[{2,2720},{16,136}]',51,1141,2720),(8,18,'[{2,2880},{16,144}]',54,1290,2880),(8,19,'[{2,3040},{16,152}]',57,1451,3040),(8,20,'[{2,3200},{16,160}]',60,1626,3200),(8,21,'[{2,3360},{16,168}]',63,1815,3360),(8,22,'[{2,3520},{16,176}]',66,2018,3520),(8,23,'[{2,3680},{16,184}]',69,2237,3680),(8,24,'[{2,3840},{16,192}]',72,2472,3840),(8,25,'[{2,4000},{16,200}]',75,999999,4000),(9,0,'[{1,0},{15,0}]',0,50,0),(9,1,'[{1,8},{15,8}]',3,58,160),(9,2,'[{1,16},{15,16}]',6,71,320),(9,3,'[{1,24},{15,24}]',9,90,480),(9,4,'[{1,32},{15,32}]',12,115,640),(9,5,'[{1,40},{15,40}]',15,146,800),(9,6,'[{1,48},{15,48}]',18,184,960),(9,7,'[{1,56},{15,56}]',21,228,1120),(9,8,'[{1,64},{15,64}]',24,280,1280),(9,9,'[{1,72},{15,72}]',27,339,1440),(9,10,'[{1,80},{15,80}]',30,406,1600),(9,11,'[{1,88},{15,88}]',33,482,1760),(9,12,'[{1,96},{15,96}]',36,567,1920),(9,13,'[{1,104},{15,104}]',39,661,2080),(9,14,'[{1,112},{15,112}]',42,765,2240),(9,15,'[{1,120},{15,120}]',45,879,2400),(9,16,'[{1,128},{15,128}]',48,1004,2560),(9,17,'[{1,136},{15,136}]',51,1141,2720),(9,18,'[{1,144},{15,144}]',54,1290,2880),(9,19,'[{1,152},{15,152}]',57,1451,3040),(9,20,'[{1,160},{15,160}]',60,1626,3200),(9,21,'[{1,168},{15,168}]',63,1815,3360),(9,22,'[{1,176},{15,176}]',66,2018,3520),(9,23,'[{1,184},{15,184}]',69,2237,3680),(9,24,'[{1,192},{15,192}]',72,2472,3840),(9,25,'[{1,200},{15,200}]',75,999999,4000),(10,0,'[{2,0},{16,0}]',0,50,0),(10,1,'[{2,160},{16,8}]',3,58,160),(10,2,'[{2,320},{16,16}]',6,71,320),(10,3,'[{2,480},{16,24}]',9,90,480),(10,4,'[{2,640},{16,32}]',12,115,640),(10,5,'[{2,800},{16,40}]',15,146,800),(10,6,'[{2,960},{16,48}]',18,184,960),(10,7,'[{2,1120},{16,56}]',21,228,1120),(10,8,'[{2,1280},{16,64}]',24,280,1280),(10,9,'[{2,1440},{16,72}]',27,339,1440),(10,10,'[{2,1600},{16,80}]',30,406,1600),(10,11,'[{2,1760},{16,88}]',33,482,1760),(10,12,'[{2,1920},{16,96}]',36,567,1920),(10,13,'[{2,2080},{16,104}]',39,661,2080),(10,14,'[{2,2240},{16,112}]',42,765,2240),(10,15,'[{2,2400},{16,120}]',45,879,2400),(10,16,'[{2,2560},{16,128}]',48,1004,2560),(10,17,'[{2,2720},{16,136}]',51,1141,2720),(10,18,'[{2,2880},{16,144}]',54,1290,2880),(10,19,'[{2,3040},{16,152}]',57,1451,3040),(10,20,'[{2,3200},{16,160}]',60,1626,3200),(10,21,'[{2,3360},{16,168}]',63,1815,3360),(10,22,'[{2,3520},{16,176}]',66,2018,3520),(10,23,'[{2,3680},{16,184}]',69,2237,3680),(10,24,'[{2,3840},{16,192}]',72,2472,3840),(10,25,'[{2,4000},{16,200}]',75,999999,4000);
/*!40000 ALTER TABLE `base_equip_stone_refine` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_equip_stone_refine_goods`
--

DROP TABLE IF EXISTS `base_equip_stone_refine_goods`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_equip_stone_refine_goods` (
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品id',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '经验',
  PRIMARY KEY (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='宝石精炼道具配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_equip_stone_refine_goods`
--

LOCK TABLES `base_equip_stone_refine_goods` WRITE;
/*!40000 ALTER TABLE `base_equip_stone_refine_goods` DISABLE KEYS */;
INSERT INTO `base_equip_stone_refine_goods` VALUES (14110001,100),(14110002,500),(14110003,1000);
/*!40000 ALTER TABLE `base_equip_stone_refine_goods` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_equip_stren_lv`
--

DROP TABLE IF EXISTS `base_equip_stren_lv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_equip_stren_lv` (
  `part` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '部位',
  `stren` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '强化等级',
  `object_list` varchar(255) NOT NULL COMMENT '消耗',
  `proficiency_plus` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '单次增加的熟练度',
  `ratio` varchar(255) NOT NULL DEFAULT '0' COMMENT '[{权重,倍率}]',
  `proficiency_limit` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '当前等级的最大熟练度',
  `combat_power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战斗力',
  `attr_list` varchar(1024) NOT NULL COMMENT '属性列表',
  PRIMARY KEY (`part`,`stren`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='强化等级配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_equip_stren_lv`
--

LOCK TABLES `base_equip_stren_lv` WRITE;
/*!40000 ALTER TABLE `base_equip_stren_lv` DISABLE KEYS */;
INSERT INTO `base_equip_stren_lv` VALUES (1,0,'[{3,0,668}]',15,'[{90,1},{7,2},{2,3},{1,5}]',58,0,'[{1,0},{3,0}]'),(1,1,'[{3,0,803}]',17,'[{90,1},{7,2},{2,3},{1,5}]',67,195,'[{1,6},{3,3}]'),(1,2,'[{3,0,937}]',19,'[{90,1},{7,2},{2,3},{1,5}]',76,390,'[{1,12},{3,6}]'),(1,3,'[{3,0,1071}]',22,'[{90,1},{7,2},{2,3},{1,5}]',86,585,'[{1,18},{3,9}]'),(1,4,'[{3,0,1205}]',24,'[{90,1},{7,2},{2,3},{1,5}]',96,780,'[{1,24},{3,12}]'),(1,5,'[{3,0,1340}]',27,'[{90,1},{7,2},{2,3},{1,5}]',106,975,'[{1,30},{3,15}]'),(1,6,'[{3,0,1474}]',29,'[{90,1},{7,2},{2,3},{1,5}]',116,1170,'[{1,36},{3,18}]'),(1,7,'[{3,0,1608}]',32,'[{90,1},{7,2},{2,3},{1,5}]',126,1365,'[{1,42},{3,21}]'),(1,8,'[{3,0,1742}]',35,'[{90,1},{7,2},{2,3},{1,5}]',137,1560,'[{1,48},{3,24}]'),(1,9,'[{3,0,1877}]',37,'[{90,1},{7,2},{2,3},{1,5}]',148,1755,'[{1,54},{3,27}]'),(1,10,'[{3,0,2011}]',40,'[{90,1},{7,2},{2,3},{1,5}]',158,1950,'[{1,60},{3,30}]'),(1,11,'[{3,0,2145}]',43,'[{90,1},{7,2},{2,3},{1,5}]',169,2145,'[{1,66},{3,33}]'),(1,12,'[{3,0,2279}]',45,'[{90,1},{7,2},{2,3},{1,5}]',180,2340,'[{1,72},{3,36}]'),(1,13,'[{3,0,2414}]',48,'[{90,1},{7,2},{2,3},{1,5}]',191,2535,'[{1,78},{3,39}]'),(1,14,'[{3,0,2548}]',51,'[{90,1},{7,2},{2,3},{1,5}]',202,2730,'[{1,84},{3,42}]'),(1,15,'[{3,0,2682}]',54,'[{90,1},{7,2},{2,3},{1,5}]',214,2925,'[{1,90},{3,45}]'),(1,16,'[{3,0,2816}]',57,'[{90,1},{7,2},{2,3},{1,5}]',225,3120,'[{1,96},{3,48}]'),(1,17,'[{3,0,2951}]',59,'[{90,1},{7,2},{2,3},{1,5}]',236,3315,'[{1,102},{3,51}]'),(1,18,'[{3,0,3085}]',62,'[{90,1},{7,2},{2,3},{1,5}]',248,3510,'[{1,108},{3,54}]'),(1,19,'[{3,0,3219}]',65,'[{90,1},{7,2},{2,3},{1,5}]',259,3705,'[{1,114},{3,57}]'),(1,20,'[{3,0,3353}]',68,'[{90,1},{7,2},{2,3},{1,5}]',271,3900,'[{1,120},{3,60}]'),(1,21,'[{3,0,3488}]',71,'[{90,1},{7,2},{2,3},{1,5}]',282,4095,'[{1,126},{3,63}]'),(1,22,'[{3,0,3622}]',74,'[{90,1},{7,2},{2,3},{1,5}]',294,4290,'[{1,132},{3,66}]'),(1,23,'[{3,0,3756}]',77,'[{90,1},{7,2},{2,3},{1,5}]',306,4485,'[{1,138},{3,69}]'),(1,24,'[{3,0,3891}]',80,'[{90,1},{7,2},{2,3},{1,5}]',318,4680,'[{1,144},{3,72}]'),(1,25,'[{3,0,4239}]',83,'[{90,1},{7,2},{2,3},{1,5}]',330,4875,'[{1,150},{3,75}]'),(1,26,'[{3,0,4587}]',86,'[{90,1},{7,2},{2,3},{1,5}]',342,5070,'[{1,156},{3,78}]'),(1,27,'[{3,0,4936}]',89,'[{90,1},{7,2},{2,3},{1,5}]',354,5265,'[{1,162},{3,81}]'),(1,28,'[{3,0,5284}]',92,'[{90,1},{7,2},{2,3},{1,5}]',366,5460,'[{1,168},{3,84}]'),(1,29,'[{3,0,5632}]',95,'[{90,1},{7,2},{2,3},{1,5}]',378,5655,'[{1,174},{3,87}]'),(1,30,'[{3,0,5980}]',98,'[{90,1},{7,2},{2,3},{1,5}]',390,5850,'[{1,180},{3,90}]'),(1,31,'[{3,0,6329}]',101,'[{90,1},{7,2},{2,3},{1,5}]',402,6045,'[{1,186},{3,93}]'),(1,32,'[{3,0,6677}]',104,'[{90,1},{7,2},{2,3},{1,5}]',414,6240,'[{1,192},{3,96}]'),(1,33,'[{3,0,7025}]',107,'[{90,1},{7,2},{2,3},{1,5}]',426,6435,'[{1,198},{3,99}]'),(1,34,'[{3,0,7373}]',110,'[{90,1},{7,2},{2,3},{1,5}]',439,6630,'[{1,204},{3,102}]'),(1,35,'[{3,0,7722}]',113,'[{90,1},{7,2},{2,3},{1,5}]',451,6825,'[{1,210},{3,105}]'),(1,36,'[{3,0,8070}]',116,'[{90,1},{7,2},{2,3},{1,5}]',464,7020,'[{1,216},{3,108}]'),(1,37,'[{3,0,8418}]',119,'[{90,1},{7,2},{2,3},{1,5}]',476,7215,'[{1,222},{3,111}]'),(1,38,'[{3,0,8766}]',122,'[{90,1},{7,2},{2,3},{1,5}]',488,7410,'[{1,228},{3,114}]'),(1,39,'[{3,0,9115}]',126,'[{90,1},{7,2},{2,3},{1,5}]',501,7605,'[{1,234},{3,117}]'),(1,40,'[{3,0,9463}]',129,'[{90,1},{7,2},{2,3},{1,5}]',514,7800,'[{1,240},{3,120}]'),(1,41,'[{3,0,9811}]',132,'[{90,1},{7,2},{2,3},{1,5}]',526,7995,'[{1,246},{3,123}]'),(1,42,'[{3,0,10159}]',135,'[{90,1},{7,2},{2,3},{1,5}]',539,8190,'[{1,252},{3,126}]'),(1,43,'[{3,0,10508}]',138,'[{90,1},{7,2},{2,3},{1,5}]',551,8385,'[{1,258},{3,129}]'),(1,44,'[{3,0,10856}]',141,'[{90,1},{7,2},{2,3},{1,5}]',564,8580,'[{1,264},{3,132}]'),(1,45,'[{3,0,11204}]',145,'[{90,1},{7,2},{2,3},{1,5}]',577,8775,'[{1,270},{3,135}]'),(1,46,'[{3,0,11552}]',148,'[{90,1},{7,2},{2,3},{1,5}]',590,8970,'[{1,276},{3,138}]'),(1,47,'[{3,0,11901}]',151,'[{90,1},{7,2},{2,3},{1,5}]',602,9165,'[{1,282},{3,141}]'),(1,48,'[{3,0,12249}]',154,'[{90,1},{7,2},{2,3},{1,5}]',615,9360,'[{1,288},{3,144}]'),(1,49,'[{3,0,12923}]',162,'[{90,1},{7,2},{2,3},{1,5}]',628,9555,'[{1,294},{3,147}]'),(1,50,'[{3,0,13425}]',165,'[{90,1},{7,2},{2,3},{1,5}]',641,9750,'[{1,300},{3,150}]'),(1,51,'[{3,0,13927}]',168,'[{90,1},{7,2},{2,3},{1,5}]',654,9945,'[{1,306},{3,153}]'),(1,52,'[{3,0,14429}]',172,'[{90,1},{7,2},{2,3},{1,5}]',667,10140,'[{1,312},{3,156}]'),(1,53,'[{3,0,14931}]',175,'[{90,1},{7,2},{2,3},{1,5}]',680,10335,'[{1,318},{3,159}]'),(1,54,'[{3,0,15433}]',178,'[{90,1},{7,2},{2,3},{1,5}]',693,10530,'[{1,324},{3,162}]'),(1,55,'[{3,0,15935}]',182,'[{90,1},{7,2},{2,3},{1,5}]',706,10725,'[{1,330},{3,165}]'),(1,56,'[{3,0,16437}]',185,'[{90,1},{7,2},{2,3},{1,5}]',719,10920,'[{1,336},{3,168}]'),(1,57,'[{3,0,16939}]',188,'[{90,1},{7,2},{2,3},{1,5}]',732,11115,'[{1,342},{3,171}]'),(1,58,'[{3,0,17442}]',192,'[{90,1},{7,2},{2,3},{1,5}]',745,11310,'[{1,348},{3,174}]'),(1,59,'[{3,0,17944}]',195,'[{90,1},{7,2},{2,3},{1,5}]',758,11505,'[{1,354},{3,177}]'),(1,60,'[{3,0,18446}]',198,'[{90,1},{7,2},{2,3},{1,5}]',771,11700,'[{1,360},{3,180}]'),(1,61,'[{3,0,18948}]',202,'[{90,1},{7,2},{2,3},{1,5}]',785,11895,'[{1,366},{3,183}]'),(1,62,'[{3,0,19450}]',205,'[{90,1},{7,2},{2,3},{1,5}]',798,12090,'[{1,372},{3,186}]'),(1,63,'[{3,0,19952}]',208,'[{90,1},{7,2},{2,3},{1,5}]',811,12285,'[{1,378},{3,189}]'),(1,64,'[{3,0,20454}]',212,'[{90,1},{7,2},{2,3},{1,5}]',824,12480,'[{1,384},{3,192}]'),(1,65,'[{3,0,20956}]',215,'[{90,1},{7,2},{2,3},{1,5}]',838,12675,'[{1,390},{3,195}]'),(1,66,'[{3,0,21458}]',219,'[{90,1},{7,2},{2,3},{1,5}]',851,12870,'[{1,396},{3,198}]'),(1,67,'[{3,0,21960}]',222,'[{90,1},{7,2},{2,3},{1,5}]',864,13065,'[{1,402},{3,201}]'),(1,68,'[{3,0,22462}]',226,'[{90,1},{7,2},{2,3},{1,5}]',878,13260,'[{1,408},{3,204}]'),(1,69,'[{3,0,22964}]',229,'[{90,1},{7,2},{2,3},{1,5}]',891,13455,'[{1,414},{3,207}]'),(1,70,'[{3,0,23466}]',233,'[{90,1},{7,2},{2,3},{1,5}]',905,13650,'[{1,420},{3,210}]'),(1,71,'[{3,0,23968}]',236,'[{90,1},{7,2},{2,3},{1,5}]',918,13845,'[{1,426},{3,213}]'),(1,72,'[{3,0,24470}]',239,'[{90,1},{7,2},{2,3},{1,5}]',932,14040,'[{1,432},{3,216}]'),(1,73,'[{3,0,24972}]',243,'[{90,1},{7,2},{2,3},{1,5}]',945,14235,'[{1,438},{3,219}]'),(1,74,'[{3,0,25472}]',246,'[{90,1},{7,2},{2,3},{1,5}]',959,14430,'[{1,444},{3,222}]'),(1,75,'[{3,0,25627}]',250,'[{90,1},{7,2},{2,3},{1,5}]',972,14625,'[{1,450},{3,225}]'),(1,76,'[{3,0,25783}]',253,'[{90,1},{7,2},{2,3},{1,5}]',986,14820,'[{1,456},{3,228}]'),(1,77,'[{3,0,25938}]',257,'[{90,1},{7,2},{2,3},{1,5}]',999,15015,'[{1,462},{3,231}]'),(1,78,'[{3,0,26094}]',260,'[{90,1},{7,2},{2,3},{1,5}]',1013,15210,'[{1,468},{3,234}]'),(1,79,'[{3,0,26249}]',264,'[{90,1},{7,2},{2,3},{1,5}]',1027,15405,'[{1,474},{3,237}]'),(1,80,'[{3,0,26404}]',267,'[{90,1},{7,2},{2,3},{1,5}]',1040,15600,'[{1,480},{3,240}]'),(1,81,'[{3,0,26560}]',271,'[{90,1},{7,2},{2,3},{1,5}]',1054,15795,'[{1,486},{3,243}]'),(1,82,'[{3,0,26715}]',274,'[{90,1},{7,2},{2,3},{1,5}]',1068,15990,'[{1,492},{3,246}]'),(1,83,'[{3,0,26870}]',278,'[{90,1},{7,2},{2,3},{1,5}]',1081,16185,'[{1,498},{3,249}]'),(1,84,'[{3,0,27026}]',281,'[{90,1},{7,2},{2,3},{1,5}]',1095,16380,'[{1,504},{3,252}]'),(1,85,'[{3,0,27181}]',285,'[{90,1},{7,2},{2,3},{1,5}]',1109,16575,'[{1,510},{3,255}]'),(1,86,'[{3,0,27337}]',288,'[{90,1},{7,2},{2,3},{1,5}]',1123,16770,'[{1,516},{3,258}]'),(1,87,'[{3,0,27492}]',292,'[{90,1},{7,2},{2,3},{1,5}]',1136,16965,'[{1,522},{3,261}]'),(1,88,'[{3,0,27647}]',295,'[{90,1},{7,2},{2,3},{1,5}]',1150,17160,'[{1,528},{3,264}]'),(1,89,'[{3,0,27803}]',299,'[{90,1},{7,2},{2,3},{1,5}]',1164,17355,'[{1,534},{3,267}]'),(1,90,'[{3,0,27958}]',303,'[{90,1},{7,2},{2,3},{1,5}]',1178,17550,'[{1,540},{3,270}]'),(1,91,'[{3,0,28114}]',306,'[{90,1},{7,2},{2,3},{1,5}]',1192,17745,'[{1,546},{3,273}]'),(1,92,'[{3,0,28269}]',310,'[{90,1},{7,2},{2,3},{1,5}]',1206,17940,'[{1,552},{3,276}]'),(1,93,'[{3,0,28424}]',313,'[{90,1},{7,2},{2,3},{1,5}]',1220,18135,'[{1,558},{3,279}]'),(1,94,'[{3,0,28580}]',317,'[{90,1},{7,2},{2,3},{1,5}]',1234,18330,'[{1,564},{3,282}]'),(1,95,'[{3,0,28735}]',320,'[{90,1},{7,2},{2,3},{1,5}]',1248,18525,'[{1,570},{3,285}]'),(1,96,'[{3,0,28890}]',324,'[{90,1},{7,2},{2,3},{1,5}]',1262,18720,'[{1,576},{3,288}]'),(1,97,'[{3,0,29046}]',328,'[{90,1},{7,2},{2,3},{1,5}]',1276,18915,'[{1,582},{3,291}]'),(1,98,'[{3,0,29201}]',331,'[{90,1},{7,2},{2,3},{1,5}]',1290,19110,'[{1,588},{3,294}]'),(1,99,'[{3,0,30126}]',344,'[{90,1},{7,2},{2,3},{1,5}]',1304,19305,'[{1,594},{3,297}]'),(1,100,'[{3,0,30194}]',347,'[{90,1},{7,2},{2,3},{1,5}]',1318,19500,'[{1,600},{3,300}]'),(1,101,'[{3,0,30263}]',351,'[{90,1},{7,2},{2,3},{1,5}]',1332,19825,'[{1,610},{3,305}]'),(1,102,'[{3,0,30331}]',355,'[{90,1},{7,2},{2,3},{1,5}]',1346,20150,'[{1,620},{3,310}]'),(1,103,'[{3,0,30400}]',358,'[{90,1},{7,2},{2,3},{1,5}]',1360,20475,'[{1,630},{3,315}]'),(1,104,'[{3,0,30468}]',362,'[{90,1},{7,2},{2,3},{1,5}]',1374,20800,'[{1,640},{3,320}]'),(1,105,'[{3,0,30537}]',366,'[{90,1},{7,2},{2,3},{1,5}]',1388,21125,'[{1,650},{3,325}]'),(1,106,'[{3,0,30605}]',369,'[{90,1},{7,2},{2,3},{1,5}]',1402,21450,'[{1,660},{3,330}]'),(1,107,'[{3,0,30673}]',373,'[{90,1},{7,2},{2,3},{1,5}]',1416,21775,'[{1,670},{3,335}]'),(1,108,'[{3,0,30742}]',377,'[{90,1},{7,2},{2,3},{1,5}]',1431,22100,'[{1,680},{3,340}]'),(1,109,'[{3,0,30810}]',381,'[{90,1},{7,2},{2,3},{1,5}]',1445,22425,'[{1,690},{3,345}]'),(1,110,'[{3,0,30879}]',384,'[{90,1},{7,2},{2,3},{1,5}]',1459,22750,'[{1,700},{3,350}]'),(1,111,'[{3,0,30947}]',388,'[{90,1},{7,2},{2,3},{1,5}]',1473,23075,'[{1,710},{3,355}]'),(1,112,'[{3,0,31015}]',392,'[{90,1},{7,2},{2,3},{1,5}]',1488,23400,'[{1,720},{3,360}]'),(1,113,'[{3,0,31084}]',396,'[{90,1},{7,2},{2,3},{1,5}]',1502,23725,'[{1,730},{3,365}]'),(1,114,'[{3,0,31152}]',399,'[{90,1},{7,2},{2,3},{1,5}]',1516,24050,'[{1,740},{3,370}]'),(1,115,'[{3,0,31221}]',403,'[{90,1},{7,2},{2,3},{1,5}]',1530,24375,'[{1,750},{3,375}]'),(1,116,'[{3,0,31289}]',407,'[{90,1},{7,2},{2,3},{1,5}]',1545,24700,'[{1,760},{3,380}]'),(1,117,'[{3,0,31358}]',411,'[{90,1},{7,2},{2,3},{1,5}]',1559,25025,'[{1,770},{3,385}]'),(1,118,'[{3,0,31426}]',414,'[{90,1},{7,2},{2,3},{1,5}]',1573,25350,'[{1,780},{3,390}]'),(1,119,'[{3,0,31494}]',418,'[{90,1},{7,2},{2,3},{1,5}]',1588,25675,'[{1,790},{3,395}]'),(1,120,'[{3,0,31563}]',422,'[{90,1},{7,2},{2,3},{1,5}]',1602,26000,'[{1,800},{3,400}]'),(1,121,'[{3,0,31631}]',426,'[{90,1},{7,2},{2,3},{1,5}]',1617,26325,'[{1,810},{3,405}]'),(1,122,'[{3,0,31700}]',430,'[{90,1},{7,2},{2,3},{1,5}]',1631,26650,'[{1,820},{3,410}]'),(1,123,'[{3,0,31768}]',434,'[{90,1},{7,2},{2,3},{1,5}]',1646,26975,'[{1,830},{3,415}]'),(1,124,'[{3,0,31837}]',437,'[{90,1},{7,2},{2,3},{1,5}]',1660,27300,'[{1,840},{3,420}]'),(1,125,'[{3,0,32159}]',441,'[{90,1},{7,2},{2,3},{1,5}]',1674,27625,'[{1,850},{3,425}]'),(1,126,'[{3,0,32481}]',445,'[{90,1},{7,2},{2,3},{1,5}]',1689,27950,'[{1,860},{3,430}]'),(1,127,'[{3,0,32803}]',449,'[{90,1},{7,2},{2,3},{1,5}]',1703,28275,'[{1,870},{3,435}]'),(1,128,'[{3,0,33125}]',453,'[{90,1},{7,2},{2,3},{1,5}]',1718,28600,'[{1,880},{3,440}]'),(1,129,'[{3,0,33447}]',456,'[{90,1},{7,2},{2,3},{1,5}]',1732,28925,'[{1,890},{3,445}]'),(1,130,'[{3,0,33769}]',460,'[{90,1},{7,2},{2,3},{1,5}]',1747,29250,'[{1,900},{3,450}]'),(1,131,'[{3,0,34091}]',464,'[{90,1},{7,2},{2,3},{1,5}]',1762,29575,'[{1,910},{3,455}]'),(1,132,'[{3,0,34413}]',468,'[{90,1},{7,2},{2,3},{1,5}]',1776,29900,'[{1,920},{3,460}]'),(1,133,'[{3,0,34735}]',472,'[{90,1},{7,2},{2,3},{1,5}]',1791,30225,'[{1,930},{3,465}]'),(1,134,'[{3,0,35058}]',475,'[{90,1},{7,2},{2,3},{1,5}]',1805,30550,'[{1,940},{3,470}]'),(1,135,'[{3,0,35380}]',479,'[{90,1},{7,2},{2,3},{1,5}]',1820,30875,'[{1,950},{3,475}]'),(1,136,'[{3,0,35702}]',483,'[{90,1},{7,2},{2,3},{1,5}]',1834,31200,'[{1,960},{3,480}]'),(1,137,'[{3,0,36024}]',487,'[{90,1},{7,2},{2,3},{1,5}]',1849,31525,'[{1,970},{3,485}]'),(1,138,'[{3,0,36346}]',491,'[{90,1},{7,2},{2,3},{1,5}]',1864,31850,'[{1,980},{3,490}]'),(1,139,'[{3,0,36668}]',495,'[{90,1},{7,2},{2,3},{1,5}]',1878,32175,'[{1,990},{3,495}]'),(1,140,'[{3,0,36990}]',499,'[{90,1},{7,2},{2,3},{1,5}]',1893,32500,'[{1,1000},{3,500}]'),(1,141,'[{3,0,37312}]',503,'[{90,1},{7,2},{2,3},{1,5}]',1908,32825,'[{1,1010},{3,505}]'),(1,142,'[{3,0,37634}]',507,'[{90,1},{7,2},{2,3},{1,5}]',1923,33150,'[{1,1020},{3,510}]'),(1,143,'[{3,0,37957}]',510,'[{90,1},{7,2},{2,3},{1,5}]',1937,33475,'[{1,1030},{3,515}]'),(1,144,'[{3,0,38279}]',514,'[{90,1},{7,2},{2,3},{1,5}]',1952,33800,'[{1,1040},{3,520}]'),(1,145,'[{3,0,38601}]',518,'[{90,1},{7,2},{2,3},{1,5}]',1967,34125,'[{1,1050},{3,525}]'),(1,146,'[{3,0,38923}]',522,'[{90,1},{7,2},{2,3},{1,5}]',1981,34450,'[{1,1060},{3,530}]'),(1,147,'[{3,0,39245}]',526,'[{90,1},{7,2},{2,3},{1,5}]',1996,34775,'[{1,1070},{3,535}]'),(1,148,'[{3,0,39567}]',530,'[{90,1},{7,2},{2,3},{1,5}]',2011,35100,'[{1,1080},{3,540}]'),(1,149,'[{3,0,40965}]',548,'[{90,1},{7,2},{2,3},{1,5}]',2026,35425,'[{1,1090},{3,545}]'),(1,150,'[{3,0,41443}]',552,'[{90,1},{7,2},{2,3},{1,5}]',2041,35750,'[{1,1100},{3,550}]'),(1,151,'[{3,0,41922}]',556,'[{90,1},{7,2},{2,3},{1,5}]',2055,36075,'[{1,1110},{3,555}]'),(1,152,'[{3,0,42401}]',560,'[{90,1},{7,2},{2,3},{1,5}]',2070,36400,'[{1,1120},{3,560}]'),(1,153,'[{3,0,42879}]',564,'[{90,1},{7,2},{2,3},{1,5}]',2085,36725,'[{1,1130},{3,565}]'),(1,154,'[{3,0,43358}]',568,'[{90,1},{7,2},{2,3},{1,5}]',2100,37050,'[{1,1140},{3,570}]'),(1,155,'[{3,0,43837}]',572,'[{90,1},{7,2},{2,3},{1,5}]',2115,37375,'[{1,1150},{3,575}]'),(1,156,'[{3,0,44315}]',576,'[{90,1},{7,2},{2,3},{1,5}]',2130,37700,'[{1,1160},{3,580}]'),(1,157,'[{3,0,44794}]',580,'[{90,1},{7,2},{2,3},{1,5}]',2145,38025,'[{1,1170},{3,585}]'),(1,158,'[{3,0,45273}]',584,'[{90,1},{7,2},{2,3},{1,5}]',2160,38350,'[{1,1180},{3,590}]'),(1,159,'[{3,0,45751}]',588,'[{90,1},{7,2},{2,3},{1,5}]',2175,38675,'[{1,1190},{3,595}]'),(1,160,'[{3,0,46230}]',592,'[{90,1},{7,2},{2,3},{1,5}]',2189,39000,'[{1,1200},{3,600}]'),(1,161,'[{3,0,46709}]',596,'[{90,1},{7,2},{2,3},{1,5}]',2204,39325,'[{1,1210},{3,605}]'),(1,162,'[{3,0,47187}]',600,'[{90,1},{7,2},{2,3},{1,5}]',2219,39650,'[{1,1220},{3,610}]'),(1,163,'[{3,0,47666}]',604,'[{90,1},{7,2},{2,3},{1,5}]',2234,39975,'[{1,1230},{3,615}]'),(1,164,'[{3,0,48145}]',608,'[{90,1},{7,2},{2,3},{1,5}]',2249,40300,'[{1,1240},{3,620}]'),(1,165,'[{3,0,48623}]',612,'[{90,1},{7,2},{2,3},{1,5}]',2264,40625,'[{1,1250},{3,625}]'),(1,166,'[{3,0,49102}]',616,'[{90,1},{7,2},{2,3},{1,5}]',2279,40950,'[{1,1260},{3,630}]'),(1,167,'[{3,0,49580}]',620,'[{90,1},{7,2},{2,3},{1,5}]',2294,41275,'[{1,1270},{3,635}]'),(1,168,'[{3,0,50059}]',625,'[{90,1},{7,2},{2,3},{1,5}]',2309,41600,'[{1,1280},{3,640}]'),(1,169,'[{3,0,50538}]',629,'[{90,1},{7,2},{2,3},{1,5}]',2324,41925,'[{1,1290},{3,645}]'),(1,170,'[{3,0,51016}]',633,'[{90,1},{7,2},{2,3},{1,5}]',2340,42250,'[{1,1300},{3,650}]'),(1,171,'[{3,0,51495}]',637,'[{90,1},{7,2},{2,3},{1,5}]',2355,42575,'[{1,1310},{3,655}]'),(1,172,'[{3,0,51974}]',641,'[{90,1},{7,2},{2,3},{1,5}]',2370,42900,'[{1,1320},{3,660}]'),(1,173,'[{3,0,52452}]',645,'[{90,1},{7,2},{2,3},{1,5}]',2385,43225,'[{1,1330},{3,665}]'),(1,174,'[{3,0,52931}]',649,'[{90,1},{7,2},{2,3},{1,5}]',2400,43550,'[{1,1340},{3,670}]'),(1,175,'[{3,0,53077}]',653,'[{90,1},{7,2},{2,3},{1,5}]',2415,43875,'[{1,1350},{3,675}]'),(1,176,'[{3,0,53222}]',657,'[{90,1},{7,2},{2,3},{1,5}]',2430,44200,'[{1,1360},{3,680}]'),(1,177,'[{3,0,53368}]',661,'[{90,1},{7,2},{2,3},{1,5}]',2445,44525,'[{1,1370},{3,685}]'),(1,178,'[{3,0,53514}]',665,'[{90,1},{7,2},{2,3},{1,5}]',2460,44850,'[{1,1380},{3,690}]'),(1,179,'[{3,0,53659}]',670,'[{90,1},{7,2},{2,3},{1,5}]',2476,45175,'[{1,1390},{3,695}]'),(1,180,'[{3,0,53805}]',674,'[{90,1},{7,2},{2,3},{1,5}]',2491,45500,'[{1,1400},{3,700}]'),(1,181,'[{3,0,53951}]',678,'[{90,1},{7,2},{2,3},{1,5}]',2506,45825,'[{1,1410},{3,705}]'),(1,182,'[{3,0,54096}]',682,'[{90,1},{7,2},{2,3},{1,5}]',2521,46150,'[{1,1420},{3,710}]'),(1,183,'[{3,0,54242}]',686,'[{90,1},{7,2},{2,3},{1,5}]',2536,46475,'[{1,1430},{3,715}]'),(1,184,'[{3,0,54388}]',690,'[{90,1},{7,2},{2,3},{1,5}]',2552,46800,'[{1,1440},{3,720}]'),(1,185,'[{3,0,54533}]',694,'[{90,1},{7,2},{2,3},{1,5}]',2567,47125,'[{1,1450},{3,725}]'),(1,186,'[{3,0,54679}]',698,'[{90,1},{7,2},{2,3},{1,5}]',2582,47450,'[{1,1460},{3,730}]'),(1,187,'[{3,0,54825}]',702,'[{90,1},{7,2},{2,3},{1,5}]',2597,47775,'[{1,1470},{3,735}]'),(1,188,'[{3,0,54970}]',707,'[{90,1},{7,2},{2,3},{1,5}]',2613,48100,'[{1,1480},{3,740}]'),(1,189,'[{3,0,55116}]',711,'[{90,1},{7,2},{2,3},{1,5}]',2628,48425,'[{1,1490},{3,745}]'),(1,190,'[{3,0,55262}]',715,'[{90,1},{7,2},{2,3},{1,5}]',2643,48750,'[{1,1500},{3,750}]'),(1,191,'[{3,0,55408}]',719,'[{90,1},{7,2},{2,3},{1,5}]',2658,49075,'[{1,1510},{3,755}]'),(1,192,'[{3,0,55553}]',723,'[{90,1},{7,2},{2,3},{1,5}]',2674,49400,'[{1,1520},{3,760}]'),(1,193,'[{3,0,55699}]',727,'[{90,1},{7,2},{2,3},{1,5}]',2689,49725,'[{1,1530},{3,765}]'),(1,194,'[{3,0,55845}]',731,'[{90,1},{7,2},{2,3},{1,5}]',2704,50050,'[{1,1540},{3,770}]'),(1,195,'[{3,0,55990}]',736,'[{90,1},{7,2},{2,3},{1,5}]',2720,50375,'[{1,1550},{3,775}]'),(1,196,'[{3,0,56136}]',740,'[{90,1},{7,2},{2,3},{1,5}]',2735,50700,'[{1,1560},{3,780}]'),(1,197,'[{3,0,56282}]',744,'[{90,1},{7,2},{2,3},{1,5}]',2750,51025,'[{1,1570},{3,785}]'),(1,198,'[{3,0,56427}]',748,'[{90,1},{7,2},{2,3},{1,5}]',2766,51350,'[{1,1580},{3,790}]'),(1,199,'[{3,0,58145}]',773,'[{90,1},{7,2},{2,3},{1,5}]',2781,51675,'[{1,1590},{3,795}]'),(1,200,'[{3,0,58298}]',777,'[{90,1},{7,2},{2,3},{1,5}]',2797,52000,'[{1,1600},{3,800}]'),(1,201,'[{3,0,58451}]',782,'[{90,1},{7,2},{2,3},{1,5}]',2812,52520,'[{1,1616},{3,808}]'),(1,202,'[{3,0,58604}]',786,'[{90,1},{7,2},{2,3},{1,5}]',2827,53040,'[{1,1632},{3,816}]'),(1,203,'[{3,0,58757}]',790,'[{90,1},{7,2},{2,3},{1,5}]',2843,53560,'[{1,1648},{3,824}]'),(1,204,'[{3,0,58910}]',794,'[{90,1},{7,2},{2,3},{1,5}]',2858,54080,'[{1,1664},{3,832}]'),(1,205,'[{3,0,59063}]',799,'[{90,1},{7,2},{2,3},{1,5}]',2874,54600,'[{1,1680},{3,840}]'),(1,206,'[{3,0,59216}]',803,'[{90,1},{7,2},{2,3},{1,5}]',2889,55120,'[{1,1696},{3,848}]'),(1,207,'[{3,0,59369}]',807,'[{90,1},{7,2},{2,3},{1,5}]',2905,55640,'[{1,1712},{3,856}]'),(1,208,'[{3,0,59522}]',812,'[{90,1},{7,2},{2,3},{1,5}]',2920,56160,'[{1,1728},{3,864}]'),(1,209,'[{3,0,59675}]',816,'[{90,1},{7,2},{2,3},{1,5}]',2936,56680,'[{1,1744},{3,872}]'),(1,210,'[{3,0,59828}]',820,'[{90,1},{7,2},{2,3},{1,5}]',2951,57200,'[{1,1760},{3,880}]'),(1,211,'[{3,0,59981}]',825,'[{90,1},{7,2},{2,3},{1,5}]',2967,57720,'[{1,1776},{3,888}]'),(1,212,'[{3,0,60134}]',829,'[{90,1},{7,2},{2,3},{1,5}]',2982,58240,'[{1,1792},{3,896}]'),(1,213,'[{3,0,60287}]',833,'[{90,1},{7,2},{2,3},{1,5}]',2998,58760,'[{1,1808},{3,904}]'),(1,214,'[{3,0,60440}]',837,'[{90,1},{7,2},{2,3},{1,5}]',3013,59280,'[{1,1824},{3,912}]'),(1,215,'[{3,0,60594}]',842,'[{90,1},{7,2},{2,3},{1,5}]',3029,59800,'[{1,1840},{3,920}]'),(1,216,'[{3,0,60747}]',846,'[{90,1},{7,2},{2,3},{1,5}]',3044,60320,'[{1,1856},{3,928}]'),(1,217,'[{3,0,60900}]',850,'[{90,1},{7,2},{2,3},{1,5}]',3060,60840,'[{1,1872},{3,936}]'),(1,218,'[{3,0,61053}]',855,'[{90,1},{7,2},{2,3},{1,5}]',3075,61360,'[{1,1888},{3,944}]'),(1,219,'[{3,0,61206}]',859,'[{90,1},{7,2},{2,3},{1,5}]',3091,61880,'[{1,1904},{3,952}]'),(1,220,'[{3,0,61359}]',864,'[{90,1},{7,2},{2,3},{1,5}]',3107,62400,'[{1,1920},{3,960}]'),(1,221,'[{3,0,61512}]',868,'[{90,1},{7,2},{2,3},{1,5}]',3122,62920,'[{1,1936},{3,968}]'),(1,222,'[{3,0,61665}]',872,'[{90,1},{7,2},{2,3},{1,5}]',3138,63440,'[{1,1952},{3,976}]'),(1,223,'[{3,0,61818}]',876,'[{90,1},{7,2},{2,3},{1,5}]',3153,63960,'[{1,1968},{3,984}]'),(1,224,'[{3,0,61974}]',881,'[{90,1},{7,2},{2,3},{1,5}]',3169,64480,'[{1,1984},{3,992}]'),(1,225,'[{3,0,68137}]',885,'[{90,1},{7,2},{2,3},{1,5}]',3185,65000,'[{1,2000},{3,1000}]'),(1,226,'[{3,0,74299}]',889,'[{90,1},{7,2},{2,3},{1,5}]',3200,65520,'[{1,2016},{3,1008}]'),(1,227,'[{3,0,80461}]',894,'[{90,1},{7,2},{2,3},{1,5}]',3216,66040,'[{1,2032},{3,1016}]'),(1,228,'[{3,0,86623}]',898,'[{90,1},{7,2},{2,3},{1,5}]',3232,66560,'[{1,2048},{3,1024}]'),(1,229,'[{3,0,92785}]',902,'[{90,1},{7,2},{2,3},{1,5}]',3247,67080,'[{1,2064},{3,1032}]'),(1,230,'[{3,0,98948}]',907,'[{90,1},{7,2},{2,3},{1,5}]',3263,67600,'[{1,2080},{3,1040}]'),(1,231,'[{3,0,105110}]',911,'[{90,1},{7,2},{2,3},{1,5}]',3279,68120,'[{1,2096},{3,1048}]'),(1,232,'[{3,0,111272}]',915,'[{90,1},{7,2},{2,3},{1,5}]',3294,68640,'[{1,2112},{3,1056}]'),(1,233,'[{3,0,117434}]',920,'[{90,1},{7,2},{2,3},{1,5}]',3310,69160,'[{1,2128},{3,1064}]'),(1,234,'[{3,0,123597}]',924,'[{90,1},{7,2},{2,3},{1,5}]',3326,69680,'[{1,2144},{3,1072}]'),(1,235,'[{3,0,129759}]',929,'[{90,1},{7,2},{2,3},{1,5}]',3342,70200,'[{1,2160},{3,1080}]'),(1,236,'[{3,0,135921}]',933,'[{90,1},{7,2},{2,3},{1,5}]',3357,70720,'[{1,2176},{3,1088}]'),(1,237,'[{3,0,142083}]',937,'[{90,1},{7,2},{2,3},{1,5}]',3373,71240,'[{1,2192},{3,1096}]'),(1,238,'[{3,0,148245}]',942,'[{90,1},{7,2},{2,3},{1,5}]',3389,71760,'[{1,2208},{3,1104}]'),(1,239,'[{3,0,154408}]',946,'[{90,1},{7,2},{2,3},{1,5}]',3405,72280,'[{1,2224},{3,1112}]'),(1,240,'[{3,0,160570}]',950,'[{90,1},{7,2},{2,3},{1,5}]',3420,72800,'[{1,2240},{3,1120}]'),(1,241,'[{3,0,166732}]',955,'[{90,1},{7,2},{2,3},{1,5}]',3436,73320,'[{1,2256},{3,1128}]'),(1,242,'[{3,0,172894}]',959,'[{90,1},{7,2},{2,3},{1,5}]',3452,73840,'[{1,2272},{3,1136}]'),(1,243,'[{3,0,179057}]',964,'[{90,1},{7,2},{2,3},{1,5}]',3468,74360,'[{1,2288},{3,1144}]'),(1,244,'[{3,0,185219}]',968,'[{90,1},{7,2},{2,3},{1,5}]',3484,74880,'[{1,2304},{3,1152}]'),(1,245,'[{3,0,191381}]',972,'[{90,1},{7,2},{2,3},{1,5}]',3499,75400,'[{1,2320},{3,1160}]'),(1,246,'[{3,0,197543}]',977,'[{90,1},{7,2},{2,3},{1,5}]',3515,75920,'[{1,2336},{3,1168}]'),(1,247,'[{3,0,203705}]',981,'[{90,1},{7,2},{2,3},{1,5}]',3531,76440,'[{1,2352},{3,1176}]'),(1,248,'[{3,0,209868}]',986,'[{90,1},{7,2},{2,3},{1,5}]',3547,76960,'[{1,2368},{3,1184}]'),(1,249,'[{3,0,222203}]',1018,'[{90,1},{7,2},{2,3},{1,5}]',3563,77480,'[{1,2384},{3,1192}]'),(1,250,'[{3,0,228297}]',1023,'[{90,1},{7,2},{2,3},{1,5}]',3579,78000,'[{1,2400},{3,1200}]'),(1,251,'[{3,0,234391}]',1028,'[{90,1},{7,2},{2,3},{1,5}]',3595,78520,'[{1,2416},{3,1208}]'),(1,252,'[{3,0,240485}]',1032,'[{90,1},{7,2},{2,3},{1,5}]',3610,79040,'[{1,2432},{3,1216}]'),(1,253,'[{3,0,246579}]',1036,'[{90,1},{7,2},{2,3},{1,5}]',3626,79560,'[{1,2448},{3,1224}]'),(1,254,'[{3,0,252673}]',1041,'[{90,1},{7,2},{2,3},{1,5}]',3642,80080,'[{1,2464},{3,1232}]'),(1,255,'[{3,0,258767}]',1046,'[{90,1},{7,2},{2,3},{1,5}]',3658,80600,'[{1,2480},{3,1240}]'),(1,256,'[{3,0,264861}]',1050,'[{90,1},{7,2},{2,3},{1,5}]',3674,81120,'[{1,2496},{3,1248}]'),(1,257,'[{3,0,270955}]',1055,'[{90,1},{7,2},{2,3},{1,5}]',3690,81640,'[{1,2512},{3,1256}]'),(1,258,'[{3,0,277049}]',1059,'[{90,1},{7,2},{2,3},{1,5}]',3706,82160,'[{1,2528},{3,1264}]'),(1,259,'[{3,0,283143}]',1064,'[{90,1},{7,2},{2,3},{1,5}]',3722,82680,'[{1,2544},{3,1272}]'),(1,260,'[{3,0,289237}]',1068,'[{90,1},{7,2},{2,3},{1,5}]',3738,83200,'[{1,2560},{3,1280}]'),(1,261,'[{3,0,295331}]',1073,'[{90,1},{7,2},{2,3},{1,5}]',3754,83720,'[{1,2576},{3,1288}]'),(1,262,'[{3,0,301425}]',1078,'[{90,1},{7,2},{2,3},{1,5}]',3770,84240,'[{1,2592},{3,1296}]'),(1,263,'[{3,0,307519}]',1082,'[{90,1},{7,2},{2,3},{1,5}]',3786,84760,'[{1,2608},{3,1304}]'),(1,264,'[{3,0,313613}]',1087,'[{90,1},{7,2},{2,3},{1,5}]',3802,85280,'[{1,2624},{3,1312}]'),(1,265,'[{3,0,319707}]',1091,'[{90,1},{7,2},{2,3},{1,5}]',3818,85800,'[{1,2640},{3,1320}]'),(1,266,'[{3,0,325801}]',1096,'[{90,1},{7,2},{2,3},{1,5}]',3834,86320,'[{1,2656},{3,1328}]'),(1,267,'[{3,0,331895}]',1100,'[{90,1},{7,2},{2,3},{1,5}]',3850,86840,'[{1,2672},{3,1336}]'),(1,268,'[{3,0,337989}]',1105,'[{90,1},{7,2},{2,3},{1,5}]',3866,87360,'[{1,2688},{3,1344}]'),(1,269,'[{3,0,344083}]',1110,'[{90,1},{7,2},{2,3},{1,5}]',3882,87880,'[{1,2704},{3,1352}]'),(1,270,'[{3,0,350177}]',1114,'[{90,1},{7,2},{2,3},{1,5}]',3898,88400,'[{1,2720},{3,1360}]'),(1,271,'[{3,0,356271}]',1119,'[{90,1},{7,2},{2,3},{1,5}]',3914,88920,'[{1,2736},{3,1368}]'),(1,272,'[{3,0,362365}]',1123,'[{90,1},{7,2},{2,3},{1,5}]',3930,89440,'[{1,2752},{3,1376}]'),(1,273,'[{3,0,368459}]',1128,'[{90,1},{7,2},{2,3},{1,5}]',3946,89960,'[{1,2768},{3,1384}]'),(1,274,'[{3,0,374550}]',1132,'[{90,1},{7,2},{2,3},{1,5}]',3962,90480,'[{1,2784},{3,1392}]'),(1,275,'[{3,0,381734}]',1137,'[{90,1},{7,2},{2,3},{1,5}]',3978,91000,'[{1,2800},{3,1400}]'),(1,276,'[{3,0,388919}]',1142,'[{90,1},{7,2},{2,3},{1,5}]',3994,91520,'[{1,2816},{3,1408}]'),(1,277,'[{3,0,396104}]',1146,'[{90,1},{7,2},{2,3},{1,5}]',4010,92040,'[{1,2832},{3,1416}]'),(1,278,'[{3,0,403288}]',1151,'[{90,1},{7,2},{2,3},{1,5}]',4026,92560,'[{1,2848},{3,1424}]'),(1,279,'[{3,0,410473}]',1155,'[{90,1},{7,2},{2,3},{1,5}]',4042,93080,'[{1,2864},{3,1432}]'),(1,280,'[{3,0,417657}]',1160,'[{90,1},{7,2},{2,3},{1,5}]',4059,93600,'[{1,2880},{3,1440}]'),(1,281,'[{3,0,424842}]',1165,'[{90,1},{7,2},{2,3},{1,5}]',4075,94120,'[{1,2896},{3,1448}]'),(1,282,'[{3,0,432026}]',1169,'[{90,1},{7,2},{2,3},{1,5}]',4091,94640,'[{1,2912},{3,1456}]'),(1,283,'[{3,0,439211}]',1174,'[{90,1},{7,2},{2,3},{1,5}]',4107,95160,'[{1,2928},{3,1464}]'),(1,284,'[{3,0,446396}]',1178,'[{90,1},{7,2},{2,3},{1,5}]',4123,95680,'[{1,2944},{3,1472}]'),(1,285,'[{3,0,453580}]',1183,'[{90,1},{7,2},{2,3},{1,5}]',4139,96200,'[{1,2960},{3,1480}]'),(1,286,'[{3,0,460765}]',1188,'[{90,1},{7,2},{2,3},{1,5}]',4155,96720,'[{1,2976},{3,1488}]'),(1,287,'[{3,0,467949}]',1192,'[{90,1},{7,2},{2,3},{1,5}]',4172,97240,'[{1,2992},{3,1496}]'),(1,288,'[{3,0,475134}]',1197,'[{90,1},{7,2},{2,3},{1,5}]',4188,97760,'[{1,3008},{3,1504}]'),(1,289,'[{3,0,482318}]',1202,'[{90,1},{7,2},{2,3},{1,5}]',4204,98280,'[{1,3024},{3,1512}]'),(1,290,'[{3,0,489503}]',1206,'[{90,1},{7,2},{2,3},{1,5}]',4220,98800,'[{1,3040},{3,1520}]'),(1,291,'[{3,0,496688}]',1211,'[{90,1},{7,2},{2,3},{1,5}]',4236,99320,'[{1,3056},{3,1528}]'),(1,292,'[{3,0,503872}]',1216,'[{90,1},{7,2},{2,3},{1,5}]',4253,99840,'[{1,3072},{3,1536}]'),(1,293,'[{3,0,511057}]',1220,'[{90,1},{7,2},{2,3},{1,5}]',4269,100360,'[{1,3088},{3,1544}]'),(1,294,'[{3,0,518241}]',1225,'[{90,1},{7,2},{2,3},{1,5}]',4285,100880,'[{1,3104},{3,1552}]'),(1,295,'[{3,0,525426}]',1229,'[{90,1},{7,2},{2,3},{1,5}]',4301,101400,'[{1,3120},{3,1560}]'),(1,296,'[{3,0,532610}]',1234,'[{90,1},{7,2},{2,3},{1,5}]',4317,101920,'[{1,3136},{3,1568}]'),(1,297,'[{3,0,539795}]',1239,'[{90,1},{7,2},{2,3},{1,5}]',4334,102440,'[{1,3152},{3,1576}]'),(1,298,'[{3,0,546980}]',1243,'[{90,1},{7,2},{2,3},{1,5}]',4350,102960,'[{1,3168},{3,1584}]'),(1,299,'[{3,0,570466}]',1285,'[{90,1},{7,2},{2,3},{1,5}]',4366,103480,'[{1,3184},{3,1592}]'),(1,300,'[{3,0,581815}]',1289,'[{90,1},{7,2},{2,3},{1,5}]',4382,104000,'[{1,3200},{3,1600}]'),(1,301,'[{3,0,593165}]',1294,'[{90,1},{7,2},{2,3},{1,5}]',4399,104780,'[{1,3224},{3,1612}]'),(1,302,'[{3,0,604515}]',1299,'[{90,1},{7,2},{2,3},{1,5}]',4415,105560,'[{1,3248},{3,1624}]'),(1,303,'[{3,0,615865}]',1304,'[{90,1},{7,2},{2,3},{1,5}]',4431,106340,'[{1,3272},{3,1636}]'),(1,304,'[{3,0,627214}]',1309,'[{90,1},{7,2},{2,3},{1,5}]',4448,107120,'[{1,3296},{3,1648}]'),(1,305,'[{3,0,638564}]',1313,'[{90,1},{7,2},{2,3},{1,5}]',4464,107900,'[{1,3320},{3,1660}]'),(1,306,'[{3,0,649914}]',1318,'[{90,1},{7,2},{2,3},{1,5}]',4480,108680,'[{1,3344},{3,1672}]'),(1,307,'[{3,0,661263}]',1323,'[{90,1},{7,2},{2,3},{1,5}]',4497,109460,'[{1,3368},{3,1684}]'),(1,308,'[{3,0,672613}]',1328,'[{90,1},{7,2},{2,3},{1,5}]',4513,110240,'[{1,3392},{3,1696}]'),(1,309,'[{3,0,683963}]',1333,'[{90,1},{7,2},{2,3},{1,5}]',4529,111020,'[{1,3416},{3,1708}]'),(1,310,'[{3,0,695313}]',1338,'[{90,1},{7,2},{2,3},{1,5}]',4546,111800,'[{1,3440},{3,1720}]'),(1,311,'[{3,0,706662}]',1342,'[{90,1},{7,2},{2,3},{1,5}]',4562,112580,'[{1,3464},{3,1732}]'),(1,312,'[{3,0,718012}]',1347,'[{90,1},{7,2},{2,3},{1,5}]',4578,113360,'[{1,3488},{3,1744}]'),(1,313,'[{3,0,729362}]',1352,'[{90,1},{7,2},{2,3},{1,5}]',4595,114140,'[{1,3512},{3,1756}]'),(1,314,'[{3,0,740711}]',1357,'[{90,1},{7,2},{2,3},{1,5}]',4611,114920,'[{1,3536},{3,1768}]'),(1,315,'[{3,0,752061}]',1361,'[{90,1},{7,2},{2,3},{1,5}]',4627,115700,'[{1,3560},{3,1780}]'),(1,316,'[{3,0,763411}]',1366,'[{90,1},{7,2},{2,3},{1,5}]',4644,116480,'[{1,3584},{3,1792}]'),(1,317,'[{3,0,774760}]',1371,'[{90,1},{7,2},{2,3},{1,5}]',4660,117260,'[{1,3608},{3,1804}]'),(1,318,'[{3,0,786110}]',1376,'[{90,1},{7,2},{2,3},{1,5}]',4677,118040,'[{1,3632},{3,1816}]'),(1,319,'[{3,0,797460}]',1381,'[{90,1},{7,2},{2,3},{1,5}]',4693,118820,'[{1,3656},{3,1828}]'),(1,320,'[{3,0,808810}]',1385,'[{90,1},{7,2},{2,3},{1,5}]',4709,119600,'[{1,3680},{3,1840}]'),(1,321,'[{3,0,820159}]',1390,'[{90,1},{7,2},{2,3},{1,5}]',4726,120380,'[{1,3704},{3,1852}]'),(1,322,'[{3,0,831509}]',1395,'[{90,1},{7,2},{2,3},{1,5}]',4742,121160,'[{1,3728},{3,1864}]'),(1,323,'[{3,0,842859}]',1400,'[{90,1},{7,2},{2,3},{1,5}]',4759,121940,'[{1,3752},{3,1876}]'),(1,324,'[{3,0,854205}]',1405,'[{90,1},{7,2},{2,3},{1,5}]',4775,122720,'[{1,3776},{3,1888}]'),(1,325,'[{3,0,869085}]',1410,'[{90,1},{7,2},{2,3},{1,5}]',4792,123500,'[{1,3800},{3,1900}]'),(1,326,'[{3,0,883965}]',1415,'[{90,1},{7,2},{2,3},{1,5}]',4808,124280,'[{1,3824},{3,1912}]'),(1,327,'[{3,0,898846}]',1420,'[{90,1},{7,2},{2,3},{1,5}]',4825,125060,'[{1,3848},{3,1924}]'),(1,328,'[{3,0,913726}]',1424,'[{90,1},{7,2},{2,3},{1,5}]',4841,125840,'[{1,3872},{3,1936}]'),(1,329,'[{3,0,928606}]',1429,'[{90,1},{7,2},{2,3},{1,5}]',4857,126620,'[{1,3896},{3,1948}]'),(1,330,'[{3,0,943487}]',1434,'[{90,1},{7,2},{2,3},{1,5}]',4874,127400,'[{1,3920},{3,1960}]'),(1,331,'[{3,0,958367}]',1439,'[{90,1},{7,2},{2,3},{1,5}]',4890,128180,'[{1,3944},{3,1972}]'),(1,332,'[{3,0,973247}]',1444,'[{90,1},{7,2},{2,3},{1,5}]',4907,128960,'[{1,3968},{3,1984}]'),(1,333,'[{3,0,988128}]',1448,'[{90,1},{7,2},{2,3},{1,5}]',4923,129740,'[{1,3992},{3,1996}]'),(1,334,'[{3,0,1003008}]',1453,'[{90,1},{7,2},{2,3},{1,5}]',4940,130520,'[{1,4016},{3,2008}]'),(1,335,'[{3,0,1017888}]',1458,'[{90,1},{7,2},{2,3},{1,5}]',4956,131300,'[{1,4040},{3,2020}]'),(1,336,'[{3,0,1032768}]',1463,'[{90,1},{7,2},{2,3},{1,5}]',4973,132080,'[{1,4064},{3,2032}]'),(1,337,'[{3,0,1047649}]',1468,'[{90,1},{7,2},{2,3},{1,5}]',4990,132860,'[{1,4088},{3,2044}]'),(1,338,'[{3,0,1062529}]',1473,'[{90,1},{7,2},{2,3},{1,5}]',5006,133640,'[{1,4112},{3,2056}]'),(1,339,'[{3,0,1077409}]',1478,'[{90,1},{7,2},{2,3},{1,5}]',5023,134420,'[{1,4136},{3,2068}]'),(1,340,'[{3,0,1092290}]',1483,'[{90,1},{7,2},{2,3},{1,5}]',5039,135200,'[{1,4160},{3,2080}]'),(1,341,'[{3,0,1107170}]',1488,'[{90,1},{7,2},{2,3},{1,5}]',5056,135980,'[{1,4184},{3,2092}]'),(1,342,'[{3,0,1122050}]',1492,'[{90,1},{7,2},{2,3},{1,5}]',5072,136760,'[{1,4208},{3,2104}]'),(1,343,'[{3,0,1136930}]',1497,'[{90,1},{7,2},{2,3},{1,5}]',5089,137540,'[{1,4232},{3,2116}]'),(1,344,'[{3,0,1151811}]',1502,'[{90,1},{7,2},{2,3},{1,5}]',5105,138320,'[{1,4256},{3,2128}]'),(1,345,'[{3,0,1166691}]',1507,'[{90,1},{7,2},{2,3},{1,5}]',5122,139100,'[{1,4280},{3,2140}]'),(1,346,'[{3,0,1181571}]',1512,'[{90,1},{7,2},{2,3},{1,5}]',5139,139880,'[{1,4304},{3,2152}]'),(1,347,'[{3,0,1196452}]',1517,'[{90,1},{7,2},{2,3},{1,5}]',5155,140660,'[{1,4328},{3,2164}]'),(1,348,'[{3,0,1211332}]',1522,'[{90,1},{7,2},{2,3},{1,5}]',5172,141440,'[{1,4352},{3,2176}]'),(1,349,'[{3,0,1263370}]',1573,'[{90,1},{7,2},{2,3},{1,5}]',5188,142220,'[{1,4376},{3,2188}]'),(1,350,'[{3,0,1279417}]',1578,'[{90,1},{7,2},{2,3},{1,5}]',5205,143000,'[{1,4400},{3,2200}]'),(1,351,'[{3,0,1295463}]',1583,'[{90,1},{7,2},{2,3},{1,5}]',5222,143780,'[{1,4424},{3,2212}]'),(1,352,'[{3,0,1311509}]',1588,'[{90,1},{7,2},{2,3},{1,5}]',5238,144560,'[{1,4448},{3,2224}]'),(1,353,'[{3,0,1327556}]',1593,'[{90,1},{7,2},{2,3},{1,5}]',5255,145340,'[{1,4472},{3,2236}]'),(1,354,'[{3,0,1343602}]',1598,'[{90,1},{7,2},{2,3},{1,5}]',5272,146120,'[{1,4496},{3,2248}]'),(1,355,'[{3,0,1359648}]',1603,'[{90,1},{7,2},{2,3},{1,5}]',5288,146900,'[{1,4520},{3,2260}]'),(1,356,'[{3,0,1375695}]',1608,'[{90,1},{7,2},{2,3},{1,5}]',5305,147680,'[{1,4544},{3,2272}]'),(1,357,'[{3,0,1391741}]',1613,'[{90,1},{7,2},{2,3},{1,5}]',5322,148460,'[{1,4568},{3,2284}]'),(1,358,'[{3,0,1407787}]',1618,'[{90,1},{7,2},{2,3},{1,5}]',5338,149240,'[{1,4592},{3,2296}]'),(1,359,'[{3,0,1423834}]',1623,'[{90,1},{7,2},{2,3},{1,5}]',5355,150020,'[{1,4616},{3,2308}]'),(1,360,'[{3,0,1439880}]',1628,'[{90,1},{7,2},{2,3},{1,5}]',5372,150800,'[{1,4640},{3,2320}]'),(1,361,'[{3,0,1455927}]',1633,'[{90,1},{7,2},{2,3},{1,5}]',5388,151580,'[{1,4664},{3,2332}]'),(1,362,'[{3,0,1471973}]',1638,'[{90,1},{7,2},{2,3},{1,5}]',5405,152360,'[{1,4688},{3,2344}]'),(1,363,'[{3,0,1488019}]',1644,'[{90,1},{7,2},{2,3},{1,5}]',5422,153140,'[{1,4712},{3,2356}]'),(1,364,'[{3,0,1504066}]',1648,'[{90,1},{7,2},{2,3},{1,5}]',5438,153920,'[{1,4736},{3,2368}]'),(1,365,'[{3,0,1520112}]',1654,'[{90,1},{7,2},{2,3},{1,5}]',5455,154700,'[{1,4760},{3,2380}]'),(1,366,'[{3,0,1536158}]',1659,'[{90,1},{7,2},{2,3},{1,5}]',5472,155480,'[{1,4784},{3,2392}]'),(1,367,'[{3,0,1552205}]',1664,'[{90,1},{7,2},{2,3},{1,5}]',5489,156260,'[{1,4808},{3,2404}]'),(1,368,'[{3,0,1568251}]',1669,'[{90,1},{7,2},{2,3},{1,5}]',5505,157040,'[{1,4832},{3,2416}]'),(1,369,'[{3,0,1584297}]',1674,'[{90,1},{7,2},{2,3},{1,5}]',5522,157820,'[{1,4856},{3,2428}]'),(1,370,'[{3,0,1600344}]',1679,'[{90,1},{7,2},{2,3},{1,5}]',5539,158600,'[{1,4880},{3,2440}]'),(1,371,'[{3,0,1616390}]',1684,'[{90,1},{7,2},{2,3},{1,5}]',5556,159380,'[{1,4904},{3,2452}]'),(1,372,'[{3,0,1632437}]',1689,'[{90,1},{7,2},{2,3},{1,5}]',5572,160160,'[{1,4928},{3,2464}]'),(1,373,'[{3,0,1648483}]',1694,'[{90,1},{7,2},{2,3},{1,5}]',5589,160940,'[{1,4952},{3,2476}]'),(1,374,'[{3,0,1664530}]',1699,'[{90,1},{7,2},{2,3},{1,5}]',5606,161720,'[{1,4976},{3,2488}]'),(1,375,'[{3,0,1679756}]',1704,'[{90,1},{7,2},{2,3},{1,5}]',5623,162500,'[{1,5000},{3,2500}]'),(1,376,'[{3,0,1694982}]',1710,'[{90,1},{7,2},{2,3},{1,5}]',5640,163280,'[{1,5024},{3,2512}]'),(1,377,'[{3,0,1710209}]',1714,'[{90,1},{7,2},{2,3},{1,5}]',5656,164060,'[{1,5048},{3,2524}]'),(1,378,'[{3,0,1725435}]',1720,'[{90,1},{7,2},{2,3},{1,5}]',5673,164840,'[{1,5072},{3,2536}]'),(1,379,'[{3,0,1740661}]',1725,'[{90,1},{7,2},{2,3},{1,5}]',5690,165620,'[{1,5096},{3,2548}]'),(1,380,'[{3,0,1755888}]',1730,'[{90,1},{7,2},{2,3},{1,5}]',5707,166400,'[{1,5120},{3,2560}]'),(1,381,'[{3,0,1771114}]',1735,'[{90,1},{7,2},{2,3},{1,5}]',5724,167180,'[{1,5144},{3,2572}]'),(1,382,'[{3,0,1786340}]',1740,'[{90,1},{7,2},{2,3},{1,5}]',5740,167960,'[{1,5168},{3,2584}]'),(1,383,'[{3,0,1801567}]',1745,'[{90,1},{7,2},{2,3},{1,5}]',5757,168740,'[{1,5192},{3,2596}]'),(1,384,'[{3,0,1816793}]',1750,'[{90,1},{7,2},{2,3},{1,5}]',5774,169520,'[{1,5216},{3,2608}]'),(1,385,'[{3,0,1832020}]',1755,'[{90,1},{7,2},{2,3},{1,5}]',5791,170300,'[{1,5240},{3,2620}]'),(1,386,'[{3,0,1847246}]',1760,'[{90,1},{7,2},{2,3},{1,5}]',5808,171080,'[{1,5264},{3,2632}]'),(1,387,'[{3,0,1862472}]',1766,'[{90,1},{7,2},{2,3},{1,5}]',5825,171860,'[{1,5288},{3,2644}]'),(1,388,'[{3,0,1877699}]',1770,'[{90,1},{7,2},{2,3},{1,5}]',5841,172640,'[{1,5312},{3,2656}]'),(1,389,'[{3,0,1892925}]',1776,'[{90,1},{7,2},{2,3},{1,5}]',5858,173420,'[{1,5336},{3,2668}]'),(1,390,'[{3,0,1908151}]',1781,'[{90,1},{7,2},{2,3},{1,5}]',5875,174200,'[{1,5360},{3,2680}]'),(1,391,'[{3,0,1923378}]',1786,'[{90,1},{7,2},{2,3},{1,5}]',5892,174980,'[{1,5384},{3,2692}]'),(1,392,'[{3,0,1938604}]',1791,'[{90,1},{7,2},{2,3},{1,5}]',5909,175760,'[{1,5408},{3,2704}]'),(1,393,'[{3,0,1953830}]',1796,'[{90,1},{7,2},{2,3},{1,5}]',5926,176540,'[{1,5432},{3,2716}]'),(1,394,'[{3,0,1969057}]',1801,'[{90,1},{7,2},{2,3},{1,5}]',5943,177320,'[{1,5456},{3,2728}]'),(1,395,'[{3,0,1984283}]',1807,'[{90,1},{7,2},{2,3},{1,5}]',5960,178100,'[{1,5480},{3,2740}]'),(1,396,'[{3,0,1999510}]',1812,'[{90,1},{7,2},{2,3},{1,5}]',5977,178880,'[{1,5504},{3,2752}]'),(1,397,'[{3,0,2014736}]',1817,'[{90,1},{7,2},{2,3},{1,5}]',5993,179660,'[{1,5528},{3,2764}]'),(1,398,'[{3,0,2029962}]',1822,'[{90,1},{7,2},{2,3},{1,5}]',6010,180440,'[{1,5552},{3,2776}]'),(1,399,'[{3,0,2109102}]',1884,'[{90,1},{7,2},{2,3},{1,5}]',6027,181220,'[{1,5576},{3,2788}]'),(1,400,'[{3,0,2133037}]',1889,'[{90,1},{7,2},{2,3},{1,5}]',6044,182000,'[{1,5600},{3,2800}]'),(1,401,'[{3,0,2156972}]',1895,'[{90,1},{7,2},{2,3},{1,5}]',6061,183040,'[{1,5632},{3,2816}]'),(1,402,'[{3,0,2180907}]',1900,'[{90,1},{7,2},{2,3},{1,5}]',6078,184080,'[{1,5664},{3,2832}]'),(1,403,'[{3,0,2204842}]',1905,'[{90,1},{7,2},{2,3},{1,5}]',6095,185120,'[{1,5696},{3,2848}]'),(1,404,'[{3,0,2228777}]',1910,'[{90,1},{7,2},{2,3},{1,5}]',6112,186160,'[{1,5728},{3,2864}]'),(1,405,'[{3,0,2252712}]',1916,'[{90,1},{7,2},{2,3},{1,5}]',6129,187200,'[{1,5760},{3,2880}]'),(1,406,'[{3,0,2276647}]',1921,'[{90,1},{7,2},{2,3},{1,5}]',6146,188240,'[{1,5792},{3,2896}]'),(1,407,'[{3,0,2300582}]',1926,'[{90,1},{7,2},{2,3},{1,5}]',6163,189280,'[{1,5824},{3,2912}]'),(1,408,'[{3,0,2324517}]',1932,'[{90,1},{7,2},{2,3},{1,5}]',6180,190320,'[{1,5856},{3,2928}]'),(1,409,'[{3,0,2348452}]',1937,'[{90,1},{7,2},{2,3},{1,5}]',6197,191360,'[{1,5888},{3,2944}]'),(1,410,'[{3,0,2372387}]',1942,'[{90,1},{7,2},{2,3},{1,5}]',6214,192400,'[{1,5920},{3,2960}]'),(1,411,'[{3,0,2396322}]',1948,'[{90,1},{7,2},{2,3},{1,5}]',6231,193440,'[{1,5952},{3,2976}]'),(1,412,'[{3,0,2420257}]',1953,'[{90,1},{7,2},{2,3},{1,5}]',6248,194480,'[{1,5984},{3,2992}]'),(1,413,'[{3,0,2444192}]',1958,'[{90,1},{7,2},{2,3},{1,5}]',6265,195520,'[{1,6016},{3,3008}]'),(1,414,'[{3,0,2468127}]',1964,'[{90,1},{7,2},{2,3},{1,5}]',6282,196560,'[{1,6048},{3,3024}]'),(1,415,'[{3,0,2492062}]',1969,'[{90,1},{7,2},{2,3},{1,5}]',6299,197600,'[{1,6080},{3,3040}]'),(1,416,'[{3,0,2515997}]',1974,'[{90,1},{7,2},{2,3},{1,5}]',6316,198640,'[{1,6112},{3,3056}]'),(1,417,'[{3,0,2539932}]',1980,'[{90,1},{7,2},{2,3},{1,5}]',6333,199680,'[{1,6144},{3,3072}]'),(1,418,'[{3,0,2563867}]',1985,'[{90,1},{7,2},{2,3},{1,5}]',6350,200720,'[{1,6176},{3,3088}]'),(1,419,'[{3,0,2587802}]',1990,'[{90,1},{7,2},{2,3},{1,5}]',6367,201760,'[{1,6208},{3,3104}]'),(1,420,'[{3,0,2611737}]',1995,'[{90,1},{7,2},{2,3},{1,5}]',6384,202800,'[{1,6240},{3,3120}]'),(1,421,'[{3,0,2635672}]',2001,'[{90,1},{7,2},{2,3},{1,5}]',6401,203840,'[{1,6272},{3,3136}]'),(1,422,'[{3,0,2659607}]',2006,'[{90,1},{7,2},{2,3},{1,5}]',6418,204880,'[{1,6304},{3,3152}]'),(1,423,'[{3,0,2683542}]',2011,'[{90,1},{7,2},{2,3},{1,5}]',6435,205920,'[{1,6336},{3,3168}]'),(1,424,'[{3,0,2707479}]',2017,'[{90,1},{7,2},{2,3},{1,5}]',6452,206960,'[{1,6368},{3,3184}]'),(1,425,'[{3,0,2730859}]',2022,'[{90,1},{7,2},{2,3},{1,5}]',6470,208000,'[{1,6400},{3,3200}]'),(1,426,'[{3,0,2754239}]',2028,'[{90,1},{7,2},{2,3},{1,5}]',6487,209040,'[{1,6432},{3,3216}]'),(1,427,'[{3,0,2777618}]',2033,'[{90,1},{7,2},{2,3},{1,5}]',6504,210080,'[{1,6464},{3,3232}]'),(1,428,'[{3,0,2800998}]',2038,'[{90,1},{7,2},{2,3},{1,5}]',6521,211120,'[{1,6496},{3,3248}]'),(1,429,'[{3,0,2824378}]',2044,'[{90,1},{7,2},{2,3},{1,5}]',6538,212160,'[{1,6528},{3,3264}]'),(1,430,'[{3,0,2847757}]',2049,'[{90,1},{7,2},{2,3},{1,5}]',6555,213200,'[{1,6560},{3,3280}]'),(1,431,'[{3,0,2871137}]',2054,'[{90,1},{7,2},{2,3},{1,5}]',6572,214240,'[{1,6592},{3,3296}]'),(1,432,'[{3,0,2894517}]',2060,'[{90,1},{7,2},{2,3},{1,5}]',6589,215280,'[{1,6624},{3,3312}]'),(1,433,'[{3,0,2917896}]',2065,'[{90,1},{7,2},{2,3},{1,5}]',6606,216320,'[{1,6656},{3,3328}]'),(1,434,'[{3,0,2941276}]',2070,'[{90,1},{7,2},{2,3},{1,5}]',6624,217360,'[{1,6688},{3,3344}]'),(1,435,'[{3,0,2964656}]',2076,'[{90,1},{7,2},{2,3},{1,5}]',6641,218400,'[{1,6720},{3,3360}]'),(1,436,'[{3,0,2988035}]',2081,'[{90,1},{7,2},{2,3},{1,5}]',6658,219440,'[{1,6752},{3,3376}]'),(1,437,'[{3,0,3011415}]',2086,'[{90,1},{7,2},{2,3},{1,5}]',6675,220480,'[{1,6784},{3,3392}]'),(1,438,'[{3,0,3034795}]',2092,'[{90,1},{7,2},{2,3},{1,5}]',6692,221520,'[{1,6816},{3,3408}]'),(1,439,'[{3,0,3058175}]',2097,'[{90,1},{7,2},{2,3},{1,5}]',6709,222560,'[{1,6848},{3,3424}]'),(1,440,'[{3,0,3081554}]',2102,'[{90,1},{7,2},{2,3},{1,5}]',6726,223600,'[{1,6880},{3,3440}]'),(1,441,'[{3,0,3104934}]',2108,'[{90,1},{7,2},{2,3},{1,5}]',6744,224640,'[{1,6912},{3,3456}]'),(1,442,'[{3,0,3128314}]',2113,'[{90,1},{7,2},{2,3},{1,5}]',6761,225680,'[{1,6944},{3,3472}]'),(1,443,'[{3,0,3151693}]',2119,'[{90,1},{7,2},{2,3},{1,5}]',6778,226720,'[{1,6976},{3,3488}]'),(1,444,'[{3,0,3175073}]',2124,'[{90,1},{7,2},{2,3},{1,5}]',6795,227760,'[{1,7008},{3,3504}]'),(1,445,'[{3,0,3198453}]',2129,'[{90,1},{7,2},{2,3},{1,5}]',6812,228800,'[{1,7040},{3,3520}]'),(1,446,'[{3,0,3221832}]',2135,'[{90,1},{7,2},{2,3},{1,5}]',6830,229840,'[{1,7072},{3,3536}]'),(1,447,'[{3,0,3245212}]',2140,'[{90,1},{7,2},{2,3},{1,5}]',6847,230880,'[{1,7104},{3,3552}]'),(1,448,'[{3,0,3268592}]',2145,'[{90,1},{7,2},{2,3},{1,5}]',6864,231920,'[{1,7136},{3,3568}]'),(1,449,'[{3,0,3398166}]',2220,'[{90,1},{7,2},{2,3},{1,5}]',6881,232960,'[{1,7168},{3,3584}]'),(1,450,'[{3,0,3413589}]',2226,'[{90,1},{7,2},{2,3},{1,5}]',6898,234000,'[{1,7200},{3,3600}]'),(1,451,'[{3,0,3429011}]',2231,'[{90,1},{7,2},{2,3},{1,5}]',6916,235040,'[{1,7232},{3,3616}]'),(1,452,'[{3,0,3444434}]',2237,'[{90,1},{7,2},{2,3},{1,5}]',6933,236080,'[{1,7264},{3,3632}]'),(1,453,'[{3,0,3459856}]',2242,'[{90,1},{7,2},{2,3},{1,5}]',6950,237120,'[{1,7296},{3,3648}]'),(1,454,'[{3,0,3475279}]',2248,'[{90,1},{7,2},{2,3},{1,5}]',6967,238160,'[{1,7328},{3,3664}]'),(1,455,'[{3,0,3490701}]',2254,'[{90,1},{7,2},{2,3},{1,5}]',6985,239200,'[{1,7360},{3,3680}]'),(1,456,'[{3,0,3506124}]',2259,'[{90,1},{7,2},{2,3},{1,5}]',7002,240240,'[{1,7392},{3,3696}]'),(1,457,'[{3,0,3521547}]',2265,'[{90,1},{7,2},{2,3},{1,5}]',7019,241280,'[{1,7424},{3,3712}]'),(1,458,'[{3,0,3536969}]',2270,'[{90,1},{7,2},{2,3},{1,5}]',7036,242320,'[{1,7456},{3,3728}]'),(1,459,'[{3,0,3552392}]',2276,'[{90,1},{7,2},{2,3},{1,5}]',7054,243360,'[{1,7488},{3,3744}]'),(1,460,'[{3,0,3567814}]',2281,'[{90,1},{7,2},{2,3},{1,5}]',7071,244400,'[{1,7520},{3,3760}]'),(1,461,'[{3,0,3583237}]',2287,'[{90,1},{7,2},{2,3},{1,5}]',7088,245440,'[{1,7552},{3,3776}]'),(1,462,'[{3,0,3598660}]',2292,'[{90,1},{7,2},{2,3},{1,5}]',7105,246480,'[{1,7584},{3,3792}]'),(1,463,'[{3,0,3614082}]',2298,'[{90,1},{7,2},{2,3},{1,5}]',7123,247520,'[{1,7616},{3,3808}]'),(1,464,'[{3,0,3629505}]',2304,'[{90,1},{7,2},{2,3},{1,5}]',7140,248560,'[{1,7648},{3,3824}]'),(1,465,'[{3,0,3644927}]',2309,'[{90,1},{7,2},{2,3},{1,5}]',7157,249600,'[{1,7680},{3,3840}]'),(1,466,'[{3,0,3660350}]',2315,'[{90,1},{7,2},{2,3},{1,5}]',7175,250640,'[{1,7712},{3,3856}]'),(1,467,'[{3,0,3675772}]',2320,'[{90,1},{7,2},{2,3},{1,5}]',7192,251680,'[{1,7744},{3,3872}]'),(1,468,'[{3,0,3691195}]',2326,'[{90,1},{7,2},{2,3},{1,5}]',7209,252720,'[{1,7776},{3,3888}]'),(1,469,'[{3,0,3706618}]',2332,'[{90,1},{7,2},{2,3},{1,5}]',7227,253760,'[{1,7808},{3,3904}]'),(1,470,'[{3,0,3722040}]',2337,'[{90,1},{7,2},{2,3},{1,5}]',7244,254800,'[{1,7840},{3,3920}]'),(1,471,'[{3,0,3737463}]',2343,'[{90,1},{7,2},{2,3},{1,5}]',7261,255840,'[{1,7872},{3,3936}]'),(1,472,'[{3,0,3752885}]',2349,'[{90,1},{7,2},{2,3},{1,5}]',7279,256880,'[{1,7904},{3,3952}]'),(1,473,'[{3,0,3768308}]',2354,'[{90,1},{7,2},{2,3},{1,5}]',7296,257920,'[{1,7936},{3,3968}]'),(1,474,'[{3,0,3783732}]',2360,'[{90,1},{7,2},{2,3},{1,5}]',7313,258960,'[{1,7968},{3,3984}]'),(1,475,'[{3,0,3797544}]',2365,'[{90,1},{7,2},{2,3},{1,5}]',7331,260000,'[{1,8000},{3,4000}]'),(1,476,'[{3,0,3811356}]',2371,'[{90,1},{7,2},{2,3},{1,5}]',7348,261040,'[{1,8032},{3,4016}]'),(1,477,'[{3,0,3825168}]',2376,'[{90,1},{7,2},{2,3},{1,5}]',7365,262080,'[{1,8064},{3,4032}]'),(1,478,'[{3,0,3838980}]',2382,'[{90,1},{7,2},{2,3},{1,5}]',7383,263120,'[{1,8096},{3,4048}]'),(1,479,'[{3,0,3852791}]',2388,'[{90,1},{7,2},{2,3},{1,5}]',7400,264160,'[{1,8128},{3,4064}]'),(1,480,'[{3,0,3866603}]',2393,'[{90,1},{7,2},{2,3},{1,5}]',7417,265200,'[{1,8160},{3,4080}]'),(1,481,'[{3,0,3880415}]',2399,'[{90,1},{7,2},{2,3},{1,5}]',7435,266240,'[{1,8192},{3,4096}]'),(1,482,'[{3,0,3894227}]',2404,'[{90,1},{7,2},{2,3},{1,5}]',7452,267280,'[{1,8224},{3,4112}]'),(1,483,'[{3,0,3908039}]',2410,'[{90,1},{7,2},{2,3},{1,5}]',7470,268320,'[{1,8256},{3,4128}]'),(1,484,'[{3,0,3921851}]',2416,'[{90,1},{7,2},{2,3},{1,5}]',7487,269360,'[{1,8288},{3,4144}]'),(1,485,'[{3,0,3935663}]',2421,'[{90,1},{7,2},{2,3},{1,5}]',7504,270400,'[{1,8320},{3,4160}]'),(1,486,'[{3,0,3949475}]',2427,'[{90,1},{7,2},{2,3},{1,5}]',7522,271440,'[{1,8352},{3,4176}]'),(1,487,'[{3,0,3963287}]',2432,'[{90,1},{7,2},{2,3},{1,5}]',7539,272480,'[{1,8384},{3,4192}]'),(1,488,'[{3,0,3977099}]',2438,'[{90,1},{7,2},{2,3},{1,5}]',7557,273520,'[{1,8416},{3,4208}]'),(1,489,'[{3,0,3990911}]',2444,'[{90,1},{7,2},{2,3},{1,5}]',7574,274560,'[{1,8448},{3,4224}]'),(1,490,'[{3,0,4004723}]',2449,'[{90,1},{7,2},{2,3},{1,5}]',7591,275600,'[{1,8480},{3,4240}]'),(1,491,'[{3,0,4018535}]',2455,'[{90,1},{7,2},{2,3},{1,5}]',7609,276640,'[{1,8512},{3,4256}]'),(1,492,'[{3,0,4032347}]',2460,'[{90,1},{7,2},{2,3},{1,5}]',7626,277680,'[{1,8544},{3,4272}]'),(1,493,'[{3,0,4046159}]',2466,'[{90,1},{7,2},{2,3},{1,5}]',7644,278720,'[{1,8576},{3,4288}]'),(1,494,'[{3,0,4059970}]',2472,'[{90,1},{7,2},{2,3},{1,5}]',7661,279760,'[{1,8608},{3,4304}]'),(1,495,'[{3,0,4073782}]',2478,'[{90,1},{7,2},{2,3},{1,5}]',7679,280800,'[{1,8640},{3,4320}]'),(1,496,'[{3,0,4087594}]',2483,'[{90,1},{7,2},{2,3},{1,5}]',7696,281840,'[{1,8672},{3,4336}]'),(1,497,'[{3,0,4101406}]',2489,'[{90,1},{7,2},{2,3},{1,5}]',7714,282880,'[{1,8704},{3,4352}]'),(1,498,'[{3,0,4115218}]',2494,'[{90,1},{7,2},{2,3},{1,5}]',7731,283920,'[{1,8736},{3,4368}]'),(1,499,'[{3,0,4266667}]',2583,'[{90,1},{7,2},{2,3},{1,5}]',7749,284960,'[{1,8768},{3,4384}]'),(1,500,'[{3,0,0}]',0,'[{90,1},{7,2},{2,3},{1,5}]',0,286000,'[{1,8800},{3,4400}]'),(2,0,'[{3,0,668}]',15,'[{90,1},{7,2},{2,3},{1,5}]',58,0,'[{2,0},{4,0}]'),(2,1,'[{3,0,803}]',17,'[{90,1},{7,2},{2,3},{1,5}]',67,195,'[{2,120},{4,3}]'),(2,2,'[{3,0,937}]',19,'[{90,1},{7,2},{2,3},{1,5}]',76,390,'[{2,240},{4,6}]'),(2,3,'[{3,0,1071}]',22,'[{90,1},{7,2},{2,3},{1,5}]',86,585,'[{2,360},{4,9}]'),(2,4,'[{3,0,1205}]',24,'[{90,1},{7,2},{2,3},{1,5}]',96,780,'[{2,480},{4,12}]'),(2,5,'[{3,0,1340}]',27,'[{90,1},{7,2},{2,3},{1,5}]',106,975,'[{2,600},{4,15}]'),(2,6,'[{3,0,1474}]',29,'[{90,1},{7,2},{2,3},{1,5}]',116,1170,'[{2,720},{4,18}]'),(2,7,'[{3,0,1608}]',32,'[{90,1},{7,2},{2,3},{1,5}]',126,1365,'[{2,840},{4,21}]'),(2,8,'[{3,0,1742}]',35,'[{90,1},{7,2},{2,3},{1,5}]',137,1560,'[{2,960},{4,24}]'),(2,9,'[{3,0,1877}]',37,'[{90,1},{7,2},{2,3},{1,5}]',148,1755,'[{2,1080},{4,27}]'),(2,10,'[{3,0,2011}]',40,'[{90,1},{7,2},{2,3},{1,5}]',158,1950,'[{2,1200},{4,30}]'),(2,11,'[{3,0,2145}]',43,'[{90,1},{7,2},{2,3},{1,5}]',169,2145,'[{2,1320},{4,33}]'),(2,12,'[{3,0,2279}]',45,'[{90,1},{7,2},{2,3},{1,5}]',180,2340,'[{2,1440},{4,36}]'),(2,13,'[{3,0,2414}]',48,'[{90,1},{7,2},{2,3},{1,5}]',191,2535,'[{2,1560},{4,39}]'),(2,14,'[{3,0,2548}]',51,'[{90,1},{7,2},{2,3},{1,5}]',202,2730,'[{2,1680},{4,42}]'),(2,15,'[{3,0,2682}]',54,'[{90,1},{7,2},{2,3},{1,5}]',214,2925,'[{2,1800},{4,45}]'),(2,16,'[{3,0,2816}]',57,'[{90,1},{7,2},{2,3},{1,5}]',225,3120,'[{2,1920},{4,48}]'),(2,17,'[{3,0,2951}]',59,'[{90,1},{7,2},{2,3},{1,5}]',236,3315,'[{2,2040},{4,51}]'),(2,18,'[{3,0,3085}]',62,'[{90,1},{7,2},{2,3},{1,5}]',248,3510,'[{2,2160},{4,54}]'),(2,19,'[{3,0,3219}]',65,'[{90,1},{7,2},{2,3},{1,5}]',259,3705,'[{2,2280},{4,57}]'),(2,20,'[{3,0,3353}]',68,'[{90,1},{7,2},{2,3},{1,5}]',271,3900,'[{2,2400},{4,60}]'),(2,21,'[{3,0,3488}]',71,'[{90,1},{7,2},{2,3},{1,5}]',282,4095,'[{2,2520},{4,63}]'),(2,22,'[{3,0,3622}]',74,'[{90,1},{7,2},{2,3},{1,5}]',294,4290,'[{2,2640},{4,66}]'),(2,23,'[{3,0,3756}]',77,'[{90,1},{7,2},{2,3},{1,5}]',306,4485,'[{2,2760},{4,69}]'),(2,24,'[{3,0,3891}]',80,'[{90,1},{7,2},{2,3},{1,5}]',318,4680,'[{2,2880},{4,72}]'),(2,25,'[{3,0,4239}]',83,'[{90,1},{7,2},{2,3},{1,5}]',330,4875,'[{2,3000},{4,75}]'),(2,26,'[{3,0,4587}]',86,'[{90,1},{7,2},{2,3},{1,5}]',342,5070,'[{2,3120},{4,78}]'),(2,27,'[{3,0,4936}]',89,'[{90,1},{7,2},{2,3},{1,5}]',354,5265,'[{2,3240},{4,81}]'),(2,28,'[{3,0,5284}]',92,'[{90,1},{7,2},{2,3},{1,5}]',366,5460,'[{2,3360},{4,84}]'),(2,29,'[{3,0,5632}]',95,'[{90,1},{7,2},{2,3},{1,5}]',378,5655,'[{2,3480},{4,87}]'),(2,30,'[{3,0,5980}]',98,'[{90,1},{7,2},{2,3},{1,5}]',390,5850,'[{2,3600},{4,90}]'),(2,31,'[{3,0,6329}]',101,'[{90,1},{7,2},{2,3},{1,5}]',402,6045,'[{2,3720},{4,93}]'),(2,32,'[{3,0,6677}]',104,'[{90,1},{7,2},{2,3},{1,5}]',414,6240,'[{2,3840},{4,96}]'),(2,33,'[{3,0,7025}]',107,'[{90,1},{7,2},{2,3},{1,5}]',426,6435,'[{2,3960},{4,99}]'),(2,34,'[{3,0,7373}]',110,'[{90,1},{7,2},{2,3},{1,5}]',439,6630,'[{2,4080},{4,102}]'),(2,35,'[{3,0,7722}]',113,'[{90,1},{7,2},{2,3},{1,5}]',451,6825,'[{2,4200},{4,105}]'),(2,36,'[{3,0,8070}]',116,'[{90,1},{7,2},{2,3},{1,5}]',464,7020,'[{2,4320},{4,108}]'),(2,37,'[{3,0,8418}]',119,'[{90,1},{7,2},{2,3},{1,5}]',476,7215,'[{2,4440},{4,111}]'),(2,38,'[{3,0,8766}]',122,'[{90,1},{7,2},{2,3},{1,5}]',488,7410,'[{2,4560},{4,114}]'),(2,39,'[{3,0,9115}]',126,'[{90,1},{7,2},{2,3},{1,5}]',501,7605,'[{2,4680},{4,117}]'),(2,40,'[{3,0,9463}]',129,'[{90,1},{7,2},{2,3},{1,5}]',514,7800,'[{2,4800},{4,120}]'),(2,41,'[{3,0,9811}]',132,'[{90,1},{7,2},{2,3},{1,5}]',526,7995,'[{2,4920},{4,123}]'),(2,42,'[{3,0,10159}]',135,'[{90,1},{7,2},{2,3},{1,5}]',539,8190,'[{2,5040},{4,126}]'),(2,43,'[{3,0,10508}]',138,'[{90,1},{7,2},{2,3},{1,5}]',551,8385,'[{2,5160},{4,129}]'),(2,44,'[{3,0,10856}]',141,'[{90,1},{7,2},{2,3},{1,5}]',564,8580,'[{2,5280},{4,132}]'),(2,45,'[{3,0,11204}]',145,'[{90,1},{7,2},{2,3},{1,5}]',577,8775,'[{2,5400},{4,135}]'),(2,46,'[{3,0,11552}]',148,'[{90,1},{7,2},{2,3},{1,5}]',590,8970,'[{2,5520},{4,138}]'),(2,47,'[{3,0,11901}]',151,'[{90,1},{7,2},{2,3},{1,5}]',602,9165,'[{2,5640},{4,141}]'),(2,48,'[{3,0,12249}]',154,'[{90,1},{7,2},{2,3},{1,5}]',615,9360,'[{2,5760},{4,144}]'),(2,49,'[{3,0,12923}]',162,'[{90,1},{7,2},{2,3},{1,5}]',628,9555,'[{2,5880},{4,147}]'),(2,50,'[{3,0,13425}]',165,'[{90,1},{7,2},{2,3},{1,5}]',641,9750,'[{2,6000},{4,150}]'),(2,51,'[{3,0,13927}]',168,'[{90,1},{7,2},{2,3},{1,5}]',654,9945,'[{2,6120},{4,153}]'),(2,52,'[{3,0,14429}]',172,'[{90,1},{7,2},{2,3},{1,5}]',667,10140,'[{2,6240},{4,156}]'),(2,53,'[{3,0,14931}]',175,'[{90,1},{7,2},{2,3},{1,5}]',680,10335,'[{2,6360},{4,159}]'),(2,54,'[{3,0,15433}]',178,'[{90,1},{7,2},{2,3},{1,5}]',693,10530,'[{2,6480},{4,162}]'),(2,55,'[{3,0,15935}]',182,'[{90,1},{7,2},{2,3},{1,5}]',706,10725,'[{2,6600},{4,165}]'),(2,56,'[{3,0,16437}]',185,'[{90,1},{7,2},{2,3},{1,5}]',719,10920,'[{2,6720},{4,168}]'),(2,57,'[{3,0,16939}]',188,'[{90,1},{7,2},{2,3},{1,5}]',732,11115,'[{2,6840},{4,171}]'),(2,58,'[{3,0,17442}]',192,'[{90,1},{7,2},{2,3},{1,5}]',745,11310,'[{2,6960},{4,174}]'),(2,59,'[{3,0,17944}]',195,'[{90,1},{7,2},{2,3},{1,5}]',758,11505,'[{2,7080},{4,177}]'),(2,60,'[{3,0,18446}]',198,'[{90,1},{7,2},{2,3},{1,5}]',771,11700,'[{2,7200},{4,180}]'),(2,61,'[{3,0,18948}]',202,'[{90,1},{7,2},{2,3},{1,5}]',785,11895,'[{2,7320},{4,183}]'),(2,62,'[{3,0,19450}]',205,'[{90,1},{7,2},{2,3},{1,5}]',798,12090,'[{2,7440},{4,186}]'),(2,63,'[{3,0,19952}]',208,'[{90,1},{7,2},{2,3},{1,5}]',811,12285,'[{2,7560},{4,189}]'),(2,64,'[{3,0,20454}]',212,'[{90,1},{7,2},{2,3},{1,5}]',824,12480,'[{2,7680},{4,192}]'),(2,65,'[{3,0,20956}]',215,'[{90,1},{7,2},{2,3},{1,5}]',838,12675,'[{2,7800},{4,195}]'),(2,66,'[{3,0,21458}]',219,'[{90,1},{7,2},{2,3},{1,5}]',851,12870,'[{2,7920},{4,198}]'),(2,67,'[{3,0,21960}]',222,'[{90,1},{7,2},{2,3},{1,5}]',864,13065,'[{2,8040},{4,201}]'),(2,68,'[{3,0,22462}]',226,'[{90,1},{7,2},{2,3},{1,5}]',878,13260,'[{2,8160},{4,204}]'),(2,69,'[{3,0,22964}]',229,'[{90,1},{7,2},{2,3},{1,5}]',891,13455,'[{2,8280},{4,207}]'),(2,70,'[{3,0,23466}]',233,'[{90,1},{7,2},{2,3},{1,5}]',905,13650,'[{2,8400},{4,210}]'),(2,71,'[{3,0,23968}]',236,'[{90,1},{7,2},{2,3},{1,5}]',918,13845,'[{2,8520},{4,213}]'),(2,72,'[{3,0,24470}]',239,'[{90,1},{7,2},{2,3},{1,5}]',932,14040,'[{2,8640},{4,216}]'),(2,73,'[{3,0,24972}]',243,'[{90,1},{7,2},{2,3},{1,5}]',945,14235,'[{2,8760},{4,219}]'),(2,74,'[{3,0,25472}]',246,'[{90,1},{7,2},{2,3},{1,5}]',959,14430,'[{2,8880},{4,222}]'),(2,75,'[{3,0,25627}]',250,'[{90,1},{7,2},{2,3},{1,5}]',972,14625,'[{2,9000},{4,225}]'),(2,76,'[{3,0,25783}]',253,'[{90,1},{7,2},{2,3},{1,5}]',986,14820,'[{2,9120},{4,228}]'),(2,77,'[{3,0,25938}]',257,'[{90,1},{7,2},{2,3},{1,5}]',999,15015,'[{2,9240},{4,231}]'),(2,78,'[{3,0,26094}]',260,'[{90,1},{7,2},{2,3},{1,5}]',1013,15210,'[{2,9360},{4,234}]'),(2,79,'[{3,0,26249}]',264,'[{90,1},{7,2},{2,3},{1,5}]',1027,15405,'[{2,9480},{4,237}]'),(2,80,'[{3,0,26404}]',267,'[{90,1},{7,2},{2,3},{1,5}]',1040,15600,'[{2,9600},{4,240}]'),(2,81,'[{3,0,26560}]',271,'[{90,1},{7,2},{2,3},{1,5}]',1054,15795,'[{2,9720},{4,243}]'),(2,82,'[{3,0,26715}]',274,'[{90,1},{7,2},{2,3},{1,5}]',1068,15990,'[{2,9840},{4,246}]'),(2,83,'[{3,0,26870}]',278,'[{90,1},{7,2},{2,3},{1,5}]',1081,16185,'[{2,9960},{4,249}]'),(2,84,'[{3,0,27026}]',281,'[{90,1},{7,2},{2,3},{1,5}]',1095,16380,'[{2,10080},{4,252}]'),(2,85,'[{3,0,27181}]',285,'[{90,1},{7,2},{2,3},{1,5}]',1109,16575,'[{2,10200},{4,255}]'),(2,86,'[{3,0,27337}]',288,'[{90,1},{7,2},{2,3},{1,5}]',1123,16770,'[{2,10320},{4,258}]'),(2,87,'[{3,0,27492}]',292,'[{90,1},{7,2},{2,3},{1,5}]',1136,16965,'[{2,10440},{4,261}]'),(2,88,'[{3,0,27647}]',295,'[{90,1},{7,2},{2,3},{1,5}]',1150,17160,'[{2,10560},{4,264}]'),(2,89,'[{3,0,27803}]',299,'[{90,1},{7,2},{2,3},{1,5}]',1164,17355,'[{2,10680},{4,267}]'),(2,90,'[{3,0,27958}]',303,'[{90,1},{7,2},{2,3},{1,5}]',1178,17550,'[{2,10800},{4,270}]'),(2,91,'[{3,0,28114}]',306,'[{90,1},{7,2},{2,3},{1,5}]',1192,17745,'[{2,10920},{4,273}]'),(2,92,'[{3,0,28269}]',310,'[{90,1},{7,2},{2,3},{1,5}]',1206,17940,'[{2,11040},{4,276}]'),(2,93,'[{3,0,28424}]',313,'[{90,1},{7,2},{2,3},{1,5}]',1220,18135,'[{2,11160},{4,279}]'),(2,94,'[{3,0,28580}]',317,'[{90,1},{7,2},{2,3},{1,5}]',1234,18330,'[{2,11280},{4,282}]'),(2,95,'[{3,0,28735}]',320,'[{90,1},{7,2},{2,3},{1,5}]',1248,18525,'[{2,11400},{4,285}]'),(2,96,'[{3,0,28890}]',324,'[{90,1},{7,2},{2,3},{1,5}]',1262,18720,'[{2,11520},{4,288}]'),(2,97,'[{3,0,29046}]',328,'[{90,1},{7,2},{2,3},{1,5}]',1276,18915,'[{2,11640},{4,291}]'),(2,98,'[{3,0,29201}]',331,'[{90,1},{7,2},{2,3},{1,5}]',1290,19110,'[{2,11760},{4,294}]'),(2,99,'[{3,0,30126}]',344,'[{90,1},{7,2},{2,3},{1,5}]',1304,19305,'[{2,11880},{4,297}]'),(2,100,'[{3,0,30194}]',347,'[{90,1},{7,2},{2,3},{1,5}]',1318,19500,'[{2,12000},{4,300}]'),(2,101,'[{3,0,30263}]',351,'[{90,1},{7,2},{2,3},{1,5}]',1332,19825,'[{2,12200},{4,305}]'),(2,102,'[{3,0,30331}]',355,'[{90,1},{7,2},{2,3},{1,5}]',1346,20150,'[{2,12400},{4,310}]'),(2,103,'[{3,0,30400}]',358,'[{90,1},{7,2},{2,3},{1,5}]',1360,20475,'[{2,12600},{4,315}]'),(2,104,'[{3,0,30468}]',362,'[{90,1},{7,2},{2,3},{1,5}]',1374,20800,'[{2,12800},{4,320}]'),(2,105,'[{3,0,30537}]',366,'[{90,1},{7,2},{2,3},{1,5}]',1388,21125,'[{2,13000},{4,325}]'),(2,106,'[{3,0,30605}]',369,'[{90,1},{7,2},{2,3},{1,5}]',1402,21450,'[{2,13200},{4,330}]'),(2,107,'[{3,0,30673}]',373,'[{90,1},{7,2},{2,3},{1,5}]',1416,21775,'[{2,13400},{4,335}]'),(2,108,'[{3,0,30742}]',377,'[{90,1},{7,2},{2,3},{1,5}]',1431,22100,'[{2,13600},{4,340}]'),(2,109,'[{3,0,30810}]',381,'[{90,1},{7,2},{2,3},{1,5}]',1445,22425,'[{2,13800},{4,345}]'),(2,110,'[{3,0,30879}]',384,'[{90,1},{7,2},{2,3},{1,5}]',1459,22750,'[{2,14000},{4,350}]'),(2,111,'[{3,0,30947}]',388,'[{90,1},{7,2},{2,3},{1,5}]',1473,23075,'[{2,14200},{4,355}]'),(2,112,'[{3,0,31015}]',392,'[{90,1},{7,2},{2,3},{1,5}]',1488,23400,'[{2,14400},{4,360}]'),(2,113,'[{3,0,31084}]',396,'[{90,1},{7,2},{2,3},{1,5}]',1502,23725,'[{2,14600},{4,365}]'),(2,114,'[{3,0,31152}]',399,'[{90,1},{7,2},{2,3},{1,5}]',1516,24050,'[{2,14800},{4,370}]'),(2,115,'[{3,0,31221}]',403,'[{90,1},{7,2},{2,3},{1,5}]',1530,24375,'[{2,15000},{4,375}]'),(2,116,'[{3,0,31289}]',407,'[{90,1},{7,2},{2,3},{1,5}]',1545,24700,'[{2,15200},{4,380}]'),(2,117,'[{3,0,31358}]',411,'[{90,1},{7,2},{2,3},{1,5}]',1559,25025,'[{2,15400},{4,385}]'),(2,118,'[{3,0,31426}]',414,'[{90,1},{7,2},{2,3},{1,5}]',1573,25350,'[{2,15600},{4,390}]'),(2,119,'[{3,0,31494}]',418,'[{90,1},{7,2},{2,3},{1,5}]',1588,25675,'[{2,15800},{4,395}]'),(2,120,'[{3,0,31563}]',422,'[{90,1},{7,2},{2,3},{1,5}]',1602,26000,'[{2,16000},{4,400}]'),(2,121,'[{3,0,31631}]',426,'[{90,1},{7,2},{2,3},{1,5}]',1617,26325,'[{2,16200},{4,405}]'),(2,122,'[{3,0,31700}]',430,'[{90,1},{7,2},{2,3},{1,5}]',1631,26650,'[{2,16400},{4,410}]'),(2,123,'[{3,0,31768}]',434,'[{90,1},{7,2},{2,3},{1,5}]',1646,26975,'[{2,16600},{4,415}]'),(2,124,'[{3,0,31837}]',437,'[{90,1},{7,2},{2,3},{1,5}]',1660,27300,'[{2,16800},{4,420}]'),(2,125,'[{3,0,32159}]',441,'[{90,1},{7,2},{2,3},{1,5}]',1674,27625,'[{2,17000},{4,425}]'),(2,126,'[{3,0,32481}]',445,'[{90,1},{7,2},{2,3},{1,5}]',1689,27950,'[{2,17200},{4,430}]'),(2,127,'[{3,0,32803}]',449,'[{90,1},{7,2},{2,3},{1,5}]',1703,28275,'[{2,17400},{4,435}]'),(2,128,'[{3,0,33125}]',453,'[{90,1},{7,2},{2,3},{1,5}]',1718,28600,'[{2,17600},{4,440}]'),(2,129,'[{3,0,33447}]',456,'[{90,1},{7,2},{2,3},{1,5}]',1732,28925,'[{2,17800},{4,445}]'),(2,130,'[{3,0,33769}]',460,'[{90,1},{7,2},{2,3},{1,5}]',1747,29250,'[{2,18000},{4,450}]'),(2,131,'[{3,0,34091}]',464,'[{90,1},{7,2},{2,3},{1,5}]',1762,29575,'[{2,18200},{4,455}]'),(2,132,'[{3,0,34413}]',468,'[{90,1},{7,2},{2,3},{1,5}]',1776,29900,'[{2,18400},{4,460}]'),(2,133,'[{3,0,34735}]',472,'[{90,1},{7,2},{2,3},{1,5}]',1791,30225,'[{2,18600},{4,465}]'),(2,134,'[{3,0,35058}]',475,'[{90,1},{7,2},{2,3},{1,5}]',1805,30550,'[{2,18800},{4,470}]'),(2,135,'[{3,0,35380}]',479,'[{90,1},{7,2},{2,3},{1,5}]',1820,30875,'[{2,19000},{4,475}]'),(2,136,'[{3,0,35702}]',483,'[{90,1},{7,2},{2,3},{1,5}]',1834,31200,'[{2,19200},{4,480}]'),(2,137,'[{3,0,36024}]',487,'[{90,1},{7,2},{2,3},{1,5}]',1849,31525,'[{2,19400},{4,485}]'),(2,138,'[{3,0,36346}]',491,'[{90,1},{7,2},{2,3},{1,5}]',1864,31850,'[{2,19600},{4,490}]'),(2,139,'[{3,0,36668}]',495,'[{90,1},{7,2},{2,3},{1,5}]',1878,32175,'[{2,19800},{4,495}]'),(2,140,'[{3,0,36990}]',499,'[{90,1},{7,2},{2,3},{1,5}]',1893,32500,'[{2,20000},{4,500}]'),(2,141,'[{3,0,37312}]',503,'[{90,1},{7,2},{2,3},{1,5}]',1908,32825,'[{2,20200},{4,505}]'),(2,142,'[{3,0,37634}]',507,'[{90,1},{7,2},{2,3},{1,5}]',1923,33150,'[{2,20400},{4,510}]'),(2,143,'[{3,0,37957}]',510,'[{90,1},{7,2},{2,3},{1,5}]',1937,33475,'[{2,20600},{4,515}]'),(2,144,'[{3,0,38279}]',514,'[{90,1},{7,2},{2,3},{1,5}]',1952,33800,'[{2,20800},{4,520}]'),(2,145,'[{3,0,38601}]',518,'[{90,1},{7,2},{2,3},{1,5}]',1967,34125,'[{2,21000},{4,525}]'),(2,146,'[{3,0,38923}]',522,'[{90,1},{7,2},{2,3},{1,5}]',1981,34450,'[{2,21200},{4,530}]'),(2,147,'[{3,0,39245}]',526,'[{90,1},{7,2},{2,3},{1,5}]',1996,34775,'[{2,21400},{4,535}]'),(2,148,'[{3,0,39567}]',530,'[{90,1},{7,2},{2,3},{1,5}]',2011,35100,'[{2,21600},{4,540}]'),(2,149,'[{3,0,40965}]',548,'[{90,1},{7,2},{2,3},{1,5}]',2026,35425,'[{2,21800},{4,545}]'),(2,150,'[{3,0,41443}]',552,'[{90,1},{7,2},{2,3},{1,5}]',2041,35750,'[{2,22000},{4,550}]'),(2,151,'[{3,0,41922}]',556,'[{90,1},{7,2},{2,3},{1,5}]',2055,36075,'[{2,22200},{4,555}]'),(2,152,'[{3,0,42401}]',560,'[{90,1},{7,2},{2,3},{1,5}]',2070,36400,'[{2,22400},{4,560}]'),(2,153,'[{3,0,42879}]',564,'[{90,1},{7,2},{2,3},{1,5}]',2085,36725,'[{2,22600},{4,565}]'),(2,154,'[{3,0,43358}]',568,'[{90,1},{7,2},{2,3},{1,5}]',2100,37050,'[{2,22800},{4,570}]'),(2,155,'[{3,0,43837}]',572,'[{90,1},{7,2},{2,3},{1,5}]',2115,37375,'[{2,23000},{4,575}]'),(2,156,'[{3,0,44315}]',576,'[{90,1},{7,2},{2,3},{1,5}]',2130,37700,'[{2,23200},{4,580}]'),(2,157,'[{3,0,44794}]',580,'[{90,1},{7,2},{2,3},{1,5}]',2145,38025,'[{2,23400},{4,585}]'),(2,158,'[{3,0,45273}]',584,'[{90,1},{7,2},{2,3},{1,5}]',2160,38350,'[{2,23600},{4,590}]'),(2,159,'[{3,0,45751}]',588,'[{90,1},{7,2},{2,3},{1,5}]',2175,38675,'[{2,23800},{4,595}]'),(2,160,'[{3,0,46230}]',592,'[{90,1},{7,2},{2,3},{1,5}]',2189,39000,'[{2,24000},{4,600}]'),(2,161,'[{3,0,46709}]',596,'[{90,1},{7,2},{2,3},{1,5}]',2204,39325,'[{2,24200},{4,605}]'),(2,162,'[{3,0,47187}]',600,'[{90,1},{7,2},{2,3},{1,5}]',2219,39650,'[{2,24400},{4,610}]'),(2,163,'[{3,0,47666}]',604,'[{90,1},{7,2},{2,3},{1,5}]',2234,39975,'[{2,24600},{4,615}]'),(2,164,'[{3,0,48145}]',608,'[{90,1},{7,2},{2,3},{1,5}]',2249,40300,'[{2,24800},{4,620}]'),(2,165,'[{3,0,48623}]',612,'[{90,1},{7,2},{2,3},{1,5}]',2264,40625,'[{2,25000},{4,625}]'),(2,166,'[{3,0,49102}]',616,'[{90,1},{7,2},{2,3},{1,5}]',2279,40950,'[{2,25200},{4,630}]'),(2,167,'[{3,0,49580}]',620,'[{90,1},{7,2},{2,3},{1,5}]',2294,41275,'[{2,25400},{4,635}]'),(2,168,'[{3,0,50059}]',625,'[{90,1},{7,2},{2,3},{1,5}]',2309,41600,'[{2,25600},{4,640}]'),(2,169,'[{3,0,50538}]',629,'[{90,1},{7,2},{2,3},{1,5}]',2324,41925,'[{2,25800},{4,645}]'),(2,170,'[{3,0,51016}]',633,'[{90,1},{7,2},{2,3},{1,5}]',2340,42250,'[{2,26000},{4,650}]'),(2,171,'[{3,0,51495}]',637,'[{90,1},{7,2},{2,3},{1,5}]',2355,42575,'[{2,26200},{4,655}]'),(2,172,'[{3,0,51974}]',641,'[{90,1},{7,2},{2,3},{1,5}]',2370,42900,'[{2,26400},{4,660}]'),(2,173,'[{3,0,52452}]',645,'[{90,1},{7,2},{2,3},{1,5}]',2385,43225,'[{2,26600},{4,665}]'),(2,174,'[{3,0,52931}]',649,'[{90,1},{7,2},{2,3},{1,5}]',2400,43550,'[{2,26800},{4,670}]'),(2,175,'[{3,0,53077}]',653,'[{90,1},{7,2},{2,3},{1,5}]',2415,43875,'[{2,27000},{4,675}]'),(2,176,'[{3,0,53222}]',657,'[{90,1},{7,2},{2,3},{1,5}]',2430,44200,'[{2,27200},{4,680}]'),(2,177,'[{3,0,53368}]',661,'[{90,1},{7,2},{2,3},{1,5}]',2445,44525,'[{2,27400},{4,685}]'),(2,178,'[{3,0,53514}]',665,'[{90,1},{7,2},{2,3},{1,5}]',2460,44850,'[{2,27600},{4,690}]'),(2,179,'[{3,0,53659}]',670,'[{90,1},{7,2},{2,3},{1,5}]',2476,45175,'[{2,27800},{4,695}]'),(2,180,'[{3,0,53805}]',674,'[{90,1},{7,2},{2,3},{1,5}]',2491,45500,'[{2,28000},{4,700}]'),(2,181,'[{3,0,53951}]',678,'[{90,1},{7,2},{2,3},{1,5}]',2506,45825,'[{2,28200},{4,705}]'),(2,182,'[{3,0,54096}]',682,'[{90,1},{7,2},{2,3},{1,5}]',2521,46150,'[{2,28400},{4,710}]'),(2,183,'[{3,0,54242}]',686,'[{90,1},{7,2},{2,3},{1,5}]',2536,46475,'[{2,28600},{4,715}]'),(2,184,'[{3,0,54388}]',690,'[{90,1},{7,2},{2,3},{1,5}]',2552,46800,'[{2,28800},{4,720}]'),(2,185,'[{3,0,54533}]',694,'[{90,1},{7,2},{2,3},{1,5}]',2567,47125,'[{2,29000},{4,725}]'),(2,186,'[{3,0,54679}]',698,'[{90,1},{7,2},{2,3},{1,5}]',2582,47450,'[{2,29200},{4,730}]'),(2,187,'[{3,0,54825}]',702,'[{90,1},{7,2},{2,3},{1,5}]',2597,47775,'[{2,29400},{4,735}]'),(2,188,'[{3,0,54970}]',707,'[{90,1},{7,2},{2,3},{1,5}]',2613,48100,'[{2,29600},{4,740}]'),(2,189,'[{3,0,55116}]',711,'[{90,1},{7,2},{2,3},{1,5}]',2628,48425,'[{2,29800},{4,745}]'),(2,190,'[{3,0,55262}]',715,'[{90,1},{7,2},{2,3},{1,5}]',2643,48750,'[{2,30000},{4,750}]'),(2,191,'[{3,0,55408}]',719,'[{90,1},{7,2},{2,3},{1,5}]',2658,49075,'[{2,30200},{4,755}]'),(2,192,'[{3,0,55553}]',723,'[{90,1},{7,2},{2,3},{1,5}]',2674,49400,'[{2,30400},{4,760}]'),(2,193,'[{3,0,55699}]',727,'[{90,1},{7,2},{2,3},{1,5}]',2689,49725,'[{2,30600},{4,765}]'),(2,194,'[{3,0,55845}]',731,'[{90,1},{7,2},{2,3},{1,5}]',2704,50050,'[{2,30800},{4,770}]'),(2,195,'[{3,0,55990}]',736,'[{90,1},{7,2},{2,3},{1,5}]',2720,50375,'[{2,31000},{4,775}]'),(2,196,'[{3,0,56136}]',740,'[{90,1},{7,2},{2,3},{1,5}]',2735,50700,'[{2,31200},{4,780}]'),(2,197,'[{3,0,56282}]',744,'[{90,1},{7,2},{2,3},{1,5}]',2750,51025,'[{2,31400},{4,785}]'),(2,198,'[{3,0,56427}]',748,'[{90,1},{7,2},{2,3},{1,5}]',2766,51350,'[{2,31600},{4,790}]'),(2,199,'[{3,0,58145}]',773,'[{90,1},{7,2},{2,3},{1,5}]',2781,51675,'[{2,31800},{4,795}]'),(2,200,'[{3,0,58298}]',777,'[{90,1},{7,2},{2,3},{1,5}]',2797,52000,'[{2,32000},{4,800}]'),(2,201,'[{3,0,58451}]',782,'[{90,1},{7,2},{2,3},{1,5}]',2812,52520,'[{2,32320},{4,808}]'),(2,202,'[{3,0,58604}]',786,'[{90,1},{7,2},{2,3},{1,5}]',2827,53040,'[{2,32640},{4,816}]'),(2,203,'[{3,0,58757}]',790,'[{90,1},{7,2},{2,3},{1,5}]',2843,53560,'[{2,32960},{4,824}]'),(2,204,'[{3,0,58910}]',794,'[{90,1},{7,2},{2,3},{1,5}]',2858,54080,'[{2,33280},{4,832}]'),(2,205,'[{3,0,59063}]',799,'[{90,1},{7,2},{2,3},{1,5}]',2874,54600,'[{2,33600},{4,840}]'),(2,206,'[{3,0,59216}]',803,'[{90,1},{7,2},{2,3},{1,5}]',2889,55120,'[{2,33920},{4,848}]'),(2,207,'[{3,0,59369}]',807,'[{90,1},{7,2},{2,3},{1,5}]',2905,55640,'[{2,34240},{4,856}]'),(2,208,'[{3,0,59522}]',812,'[{90,1},{7,2},{2,3},{1,5}]',2920,56160,'[{2,34560},{4,864}]'),(2,209,'[{3,0,59675}]',816,'[{90,1},{7,2},{2,3},{1,5}]',2936,56680,'[{2,34880},{4,872}]'),(2,210,'[{3,0,59828}]',820,'[{90,1},{7,2},{2,3},{1,5}]',2951,57200,'[{2,35200},{4,880}]'),(2,211,'[{3,0,59981}]',825,'[{90,1},{7,2},{2,3},{1,5}]',2967,57720,'[{2,35520},{4,888}]'),(2,212,'[{3,0,60134}]',829,'[{90,1},{7,2},{2,3},{1,5}]',2982,58240,'[{2,35840},{4,896}]'),(2,213,'[{3,0,60287}]',833,'[{90,1},{7,2},{2,3},{1,5}]',2998,58760,'[{2,36160},{4,904}]'),(2,214,'[{3,0,60440}]',837,'[{90,1},{7,2},{2,3},{1,5}]',3013,59280,'[{2,36480},{4,912}]'),(2,215,'[{3,0,60594}]',842,'[{90,1},{7,2},{2,3},{1,5}]',3029,59800,'[{2,36800},{4,920}]'),(2,216,'[{3,0,60747}]',846,'[{90,1},{7,2},{2,3},{1,5}]',3044,60320,'[{2,37120},{4,928}]'),(2,217,'[{3,0,60900}]',850,'[{90,1},{7,2},{2,3},{1,5}]',3060,60840,'[{2,37440},{4,936}]'),(2,218,'[{3,0,61053}]',855,'[{90,1},{7,2},{2,3},{1,5}]',3075,61360,'[{2,37760},{4,944}]'),(2,219,'[{3,0,61206}]',859,'[{90,1},{7,2},{2,3},{1,5}]',3091,61880,'[{2,38080},{4,952}]'),(2,220,'[{3,0,61359}]',864,'[{90,1},{7,2},{2,3},{1,5}]',3107,62400,'[{2,38400},{4,960}]'),(2,221,'[{3,0,61512}]',868,'[{90,1},{7,2},{2,3},{1,5}]',3122,62920,'[{2,38720},{4,968}]'),(2,222,'[{3,0,61665}]',872,'[{90,1},{7,2},{2,3},{1,5}]',3138,63440,'[{2,39040},{4,976}]'),(2,223,'[{3,0,61818}]',876,'[{90,1},{7,2},{2,3},{1,5}]',3153,63960,'[{2,39360},{4,984}]'),(2,224,'[{3,0,61974}]',881,'[{90,1},{7,2},{2,3},{1,5}]',3169,64480,'[{2,39680},{4,992}]'),(2,225,'[{3,0,68137}]',885,'[{90,1},{7,2},{2,3},{1,5}]',3185,65000,'[{2,40000},{4,1000}]'),(2,226,'[{3,0,74299}]',889,'[{90,1},{7,2},{2,3},{1,5}]',3200,65520,'[{2,40320},{4,1008}]'),(2,227,'[{3,0,80461}]',894,'[{90,1},{7,2},{2,3},{1,5}]',3216,66040,'[{2,40640},{4,1016}]'),(2,228,'[{3,0,86623}]',898,'[{90,1},{7,2},{2,3},{1,5}]',3232,66560,'[{2,40960},{4,1024}]'),(2,229,'[{3,0,92785}]',902,'[{90,1},{7,2},{2,3},{1,5}]',3247,67080,'[{2,41280},{4,1032}]'),(2,230,'[{3,0,98948}]',907,'[{90,1},{7,2},{2,3},{1,5}]',3263,67600,'[{2,41600},{4,1040}]'),(2,231,'[{3,0,105110}]',911,'[{90,1},{7,2},{2,3},{1,5}]',3279,68120,'[{2,41920},{4,1048}]'),(2,232,'[{3,0,111272}]',915,'[{90,1},{7,2},{2,3},{1,5}]',3294,68640,'[{2,42240},{4,1056}]'),(2,233,'[{3,0,117434}]',920,'[{90,1},{7,2},{2,3},{1,5}]',3310,69160,'[{2,42560},{4,1064}]'),(2,234,'[{3,0,123597}]',924,'[{90,1},{7,2},{2,3},{1,5}]',3326,69680,'[{2,42880},{4,1072}]'),(2,235,'[{3,0,129759}]',929,'[{90,1},{7,2},{2,3},{1,5}]',3342,70200,'[{2,43200},{4,1080}]'),(2,236,'[{3,0,135921}]',933,'[{90,1},{7,2},{2,3},{1,5}]',3357,70720,'[{2,43520},{4,1088}]'),(2,237,'[{3,0,142083}]',937,'[{90,1},{7,2},{2,3},{1,5}]',3373,71240,'[{2,43840},{4,1096}]'),(2,238,'[{3,0,148245}]',942,'[{90,1},{7,2},{2,3},{1,5}]',3389,71760,'[{2,44160},{4,1104}]'),(2,239,'[{3,0,154408}]',946,'[{90,1},{7,2},{2,3},{1,5}]',3405,72280,'[{2,44480},{4,1112}]'),(2,240,'[{3,0,160570}]',950,'[{90,1},{7,2},{2,3},{1,5}]',3420,72800,'[{2,44800},{4,1120}]'),(2,241,'[{3,0,166732}]',955,'[{90,1},{7,2},{2,3},{1,5}]',3436,73320,'[{2,45120},{4,1128}]'),(2,242,'[{3,0,172894}]',959,'[{90,1},{7,2},{2,3},{1,5}]',3452,73840,'[{2,45440},{4,1136}]'),(2,243,'[{3,0,179057}]',964,'[{90,1},{7,2},{2,3},{1,5}]',3468,74360,'[{2,45760},{4,1144}]'),(2,244,'[{3,0,185219}]',968,'[{90,1},{7,2},{2,3},{1,5}]',3484,74880,'[{2,46080},{4,1152}]'),(2,245,'[{3,0,191381}]',972,'[{90,1},{7,2},{2,3},{1,5}]',3499,75400,'[{2,46400},{4,1160}]'),(2,246,'[{3,0,197543}]',977,'[{90,1},{7,2},{2,3},{1,5}]',3515,75920,'[{2,46720},{4,1168}]'),(2,247,'[{3,0,203705}]',981,'[{90,1},{7,2},{2,3},{1,5}]',3531,76440,'[{2,47040},{4,1176}]'),(2,248,'[{3,0,209868}]',986,'[{90,1},{7,2},{2,3},{1,5}]',3547,76960,'[{2,47360},{4,1184}]'),(2,249,'[{3,0,222203}]',1018,'[{90,1},{7,2},{2,3},{1,5}]',3563,77480,'[{2,47680},{4,1192}]'),(2,250,'[{3,0,228297}]',1023,'[{90,1},{7,2},{2,3},{1,5}]',3579,78000,'[{2,48000},{4,1200}]'),(2,251,'[{3,0,234391}]',1028,'[{90,1},{7,2},{2,3},{1,5}]',3595,78520,'[{2,48320},{4,1208}]'),(2,252,'[{3,0,240485}]',1032,'[{90,1},{7,2},{2,3},{1,5}]',3610,79040,'[{2,48640},{4,1216}]'),(2,253,'[{3,0,246579}]',1036,'[{90,1},{7,2},{2,3},{1,5}]',3626,79560,'[{2,48960},{4,1224}]'),(2,254,'[{3,0,252673}]',1041,'[{90,1},{7,2},{2,3},{1,5}]',3642,80080,'[{2,49280},{4,1232}]'),(2,255,'[{3,0,258767}]',1046,'[{90,1},{7,2},{2,3},{1,5}]',3658,80600,'[{2,49600},{4,1240}]'),(2,256,'[{3,0,264861}]',1050,'[{90,1},{7,2},{2,3},{1,5}]',3674,81120,'[{2,49920},{4,1248}]'),(2,257,'[{3,0,270955}]',1055,'[{90,1},{7,2},{2,3},{1,5}]',3690,81640,'[{2,50240},{4,1256}]'),(2,258,'[{3,0,277049}]',1059,'[{90,1},{7,2},{2,3},{1,5}]',3706,82160,'[{2,50560},{4,1264}]'),(2,259,'[{3,0,283143}]',1064,'[{90,1},{7,2},{2,3},{1,5}]',3722,82680,'[{2,50880},{4,1272}]'),(2,260,'[{3,0,289237}]',1068,'[{90,1},{7,2},{2,3},{1,5}]',3738,83200,'[{2,51200},{4,1280}]'),(2,261,'[{3,0,295331}]',1073,'[{90,1},{7,2},{2,3},{1,5}]',3754,83720,'[{2,51520},{4,1288}]'),(2,262,'[{3,0,301425}]',1078,'[{90,1},{7,2},{2,3},{1,5}]',3770,84240,'[{2,51840},{4,1296}]'),(2,263,'[{3,0,307519}]',1082,'[{90,1},{7,2},{2,3},{1,5}]',3786,84760,'[{2,52160},{4,1304}]'),(2,264,'[{3,0,313613}]',1087,'[{90,1},{7,2},{2,3},{1,5}]',3802,85280,'[{2,52480},{4,1312}]'),(2,265,'[{3,0,319707}]',1091,'[{90,1},{7,2},{2,3},{1,5}]',3818,85800,'[{2,52800},{4,1320}]'),(2,266,'[{3,0,325801}]',1096,'[{90,1},{7,2},{2,3},{1,5}]',3834,86320,'[{2,53120},{4,1328}]'),(2,267,'[{3,0,331895}]',1100,'[{90,1},{7,2},{2,3},{1,5}]',3850,86840,'[{2,53440},{4,1336}]'),(2,268,'[{3,0,337989}]',1105,'[{90,1},{7,2},{2,3},{1,5}]',3866,87360,'[{2,53760},{4,1344}]'),(2,269,'[{3,0,344083}]',1110,'[{90,1},{7,2},{2,3},{1,5}]',3882,87880,'[{2,54080},{4,1352}]'),(2,270,'[{3,0,350177}]',1114,'[{90,1},{7,2},{2,3},{1,5}]',3898,88400,'[{2,54400},{4,1360}]'),(2,271,'[{3,0,356271}]',1119,'[{90,1},{7,2},{2,3},{1,5}]',3914,88920,'[{2,54720},{4,1368}]'),(2,272,'[{3,0,362365}]',1123,'[{90,1},{7,2},{2,3},{1,5}]',3930,89440,'[{2,55040},{4,1376}]'),(2,273,'[{3,0,368459}]',1128,'[{90,1},{7,2},{2,3},{1,5}]',3946,89960,'[{2,55360},{4,1384}]'),(2,274,'[{3,0,374550}]',1132,'[{90,1},{7,2},{2,3},{1,5}]',3962,90480,'[{2,55680},{4,1392}]'),(2,275,'[{3,0,381734}]',1137,'[{90,1},{7,2},{2,3},{1,5}]',3978,91000,'[{2,56000},{4,1400}]'),(2,276,'[{3,0,388919}]',1142,'[{90,1},{7,2},{2,3},{1,5}]',3994,91520,'[{2,56320},{4,1408}]'),(2,277,'[{3,0,396104}]',1146,'[{90,1},{7,2},{2,3},{1,5}]',4010,92040,'[{2,56640},{4,1416}]'),(2,278,'[{3,0,403288}]',1151,'[{90,1},{7,2},{2,3},{1,5}]',4026,92560,'[{2,56960},{4,1424}]'),(2,279,'[{3,0,410473}]',1155,'[{90,1},{7,2},{2,3},{1,5}]',4042,93080,'[{2,57280},{4,1432}]'),(2,280,'[{3,0,417657}]',1160,'[{90,1},{7,2},{2,3},{1,5}]',4059,93600,'[{2,57600},{4,1440}]'),(2,281,'[{3,0,424842}]',1165,'[{90,1},{7,2},{2,3},{1,5}]',4075,94120,'[{2,57920},{4,1448}]'),(2,282,'[{3,0,432026}]',1169,'[{90,1},{7,2},{2,3},{1,5}]',4091,94640,'[{2,58240},{4,1456}]'),(2,283,'[{3,0,439211}]',1174,'[{90,1},{7,2},{2,3},{1,5}]',4107,95160,'[{2,58560},{4,1464}]'),(2,284,'[{3,0,446396}]',1178,'[{90,1},{7,2},{2,3},{1,5}]',4123,95680,'[{2,58880},{4,1472}]'),(2,285,'[{3,0,453580}]',1183,'[{90,1},{7,2},{2,3},{1,5}]',4139,96200,'[{2,59200},{4,1480}]'),(2,286,'[{3,0,460765}]',1188,'[{90,1},{7,2},{2,3},{1,5}]',4155,96720,'[{2,59520},{4,1488}]'),(2,287,'[{3,0,467949}]',1192,'[{90,1},{7,2},{2,3},{1,5}]',4172,97240,'[{2,59840},{4,1496}]'),(2,288,'[{3,0,475134}]',1197,'[{90,1},{7,2},{2,3},{1,5}]',4188,97760,'[{2,60160},{4,1504}]'),(2,289,'[{3,0,482318}]',1202,'[{90,1},{7,2},{2,3},{1,5}]',4204,98280,'[{2,60480},{4,1512}]'),(2,290,'[{3,0,489503}]',1206,'[{90,1},{7,2},{2,3},{1,5}]',4220,98800,'[{2,60800},{4,1520}]'),(2,291,'[{3,0,496688}]',1211,'[{90,1},{7,2},{2,3},{1,5}]',4236,99320,'[{2,61120},{4,1528}]'),(2,292,'[{3,0,503872}]',1216,'[{90,1},{7,2},{2,3},{1,5}]',4253,99840,'[{2,61440},{4,1536}]'),(2,293,'[{3,0,511057}]',1220,'[{90,1},{7,2},{2,3},{1,5}]',4269,100360,'[{2,61760},{4,1544}]'),(2,294,'[{3,0,518241}]',1225,'[{90,1},{7,2},{2,3},{1,5}]',4285,100880,'[{2,62080},{4,1552}]'),(2,295,'[{3,0,525426}]',1229,'[{90,1},{7,2},{2,3},{1,5}]',4301,101400,'[{2,62400},{4,1560}]'),(2,296,'[{3,0,532610}]',1234,'[{90,1},{7,2},{2,3},{1,5}]',4317,101920,'[{2,62720},{4,1568}]'),(2,297,'[{3,0,539795}]',1239,'[{90,1},{7,2},{2,3},{1,5}]',4334,102440,'[{2,63040},{4,1576}]'),(2,298,'[{3,0,546980}]',1243,'[{90,1},{7,2},{2,3},{1,5}]',4350,102960,'[{2,63360},{4,1584}]'),(2,299,'[{3,0,570466}]',1285,'[{90,1},{7,2},{2,3},{1,5}]',4366,103480,'[{2,63680},{4,1592}]'),(2,300,'[{3,0,581815}]',1289,'[{90,1},{7,2},{2,3},{1,5}]',4382,104000,'[{2,64000},{4,1600}]'),(2,301,'[{3,0,593165}]',1294,'[{90,1},{7,2},{2,3},{1,5}]',4399,104780,'[{2,64480},{4,1612}]'),(2,302,'[{3,0,604515}]',1299,'[{90,1},{7,2},{2,3},{1,5}]',4415,105560,'[{2,64960},{4,1624}]'),(2,303,'[{3,0,615865}]',1304,'[{90,1},{7,2},{2,3},{1,5}]',4431,106340,'[{2,65440},{4,1636}]'),(2,304,'[{3,0,627214}]',1309,'[{90,1},{7,2},{2,3},{1,5}]',4448,107120,'[{2,65920},{4,1648}]'),(2,305,'[{3,0,638564}]',1313,'[{90,1},{7,2},{2,3},{1,5}]',4464,107900,'[{2,66400},{4,1660}]'),(2,306,'[{3,0,649914}]',1318,'[{90,1},{7,2},{2,3},{1,5}]',4480,108680,'[{2,66880},{4,1672}]'),(2,307,'[{3,0,661263}]',1323,'[{90,1},{7,2},{2,3},{1,5}]',4497,109460,'[{2,67360},{4,1684}]'),(2,308,'[{3,0,672613}]',1328,'[{90,1},{7,2},{2,3},{1,5}]',4513,110240,'[{2,67840},{4,1696}]'),(2,309,'[{3,0,683963}]',1333,'[{90,1},{7,2},{2,3},{1,5}]',4529,111020,'[{2,68320},{4,1708}]'),(2,310,'[{3,0,695313}]',1338,'[{90,1},{7,2},{2,3},{1,5}]',4546,111800,'[{2,68800},{4,1720}]'),(2,311,'[{3,0,706662}]',1342,'[{90,1},{7,2},{2,3},{1,5}]',4562,112580,'[{2,69280},{4,1732}]'),(2,312,'[{3,0,718012}]',1347,'[{90,1},{7,2},{2,3},{1,5}]',4578,113360,'[{2,69760},{4,1744}]'),(2,313,'[{3,0,729362}]',1352,'[{90,1},{7,2},{2,3},{1,5}]',4595,114140,'[{2,70240},{4,1756}]'),(2,314,'[{3,0,740711}]',1357,'[{90,1},{7,2},{2,3},{1,5}]',4611,114920,'[{2,70720},{4,1768}]'),(2,315,'[{3,0,752061}]',1361,'[{90,1},{7,2},{2,3},{1,5}]',4627,115700,'[{2,71200},{4,1780}]'),(2,316,'[{3,0,763411}]',1366,'[{90,1},{7,2},{2,3},{1,5}]',4644,116480,'[{2,71680},{4,1792}]'),(2,317,'[{3,0,774760}]',1371,'[{90,1},{7,2},{2,3},{1,5}]',4660,117260,'[{2,72160},{4,1804}]'),(2,318,'[{3,0,786110}]',1376,'[{90,1},{7,2},{2,3},{1,5}]',4677,118040,'[{2,72640},{4,1816}]'),(2,319,'[{3,0,797460}]',1381,'[{90,1},{7,2},{2,3},{1,5}]',4693,118820,'[{2,73120},{4,1828}]'),(2,320,'[{3,0,808810}]',1385,'[{90,1},{7,2},{2,3},{1,5}]',4709,119600,'[{2,73600},{4,1840}]'),(2,321,'[{3,0,820159}]',1390,'[{90,1},{7,2},{2,3},{1,5}]',4726,120380,'[{2,74080},{4,1852}]'),(2,322,'[{3,0,831509}]',1395,'[{90,1},{7,2},{2,3},{1,5}]',4742,121160,'[{2,74560},{4,1864}]'),(2,323,'[{3,0,842859}]',1400,'[{90,1},{7,2},{2,3},{1,5}]',4759,121940,'[{2,75040},{4,1876}]'),(2,324,'[{3,0,854205}]',1405,'[{90,1},{7,2},{2,3},{1,5}]',4775,122720,'[{2,75520},{4,1888}]'),(2,325,'[{3,0,869085}]',1410,'[{90,1},{7,2},{2,3},{1,5}]',4792,123500,'[{2,76000},{4,1900}]'),(2,326,'[{3,0,883965}]',1415,'[{90,1},{7,2},{2,3},{1,5}]',4808,124280,'[{2,76480},{4,1912}]'),(2,327,'[{3,0,898846}]',1420,'[{90,1},{7,2},{2,3},{1,5}]',4825,125060,'[{2,76960},{4,1924}]'),(2,328,'[{3,0,913726}]',1424,'[{90,1},{7,2},{2,3},{1,5}]',4841,125840,'[{2,77440},{4,1936}]'),(2,329,'[{3,0,928606}]',1429,'[{90,1},{7,2},{2,3},{1,5}]',4857,126620,'[{2,77920},{4,1948}]'),(2,330,'[{3,0,943487}]',1434,'[{90,1},{7,2},{2,3},{1,5}]',4874,127400,'[{2,78400},{4,1960}]'),(2,331,'[{3,0,958367}]',1439,'[{90,1},{7,2},{2,3},{1,5}]',4890,128180,'[{2,78880},{4,1972}]'),(2,332,'[{3,0,973247}]',1444,'[{90,1},{7,2},{2,3},{1,5}]',4907,128960,'[{2,79360},{4,1984}]'),(2,333,'[{3,0,988128}]',1448,'[{90,1},{7,2},{2,3},{1,5}]',4923,129740,'[{2,79840},{4,1996}]'),(2,334,'[{3,0,1003008}]',1453,'[{90,1},{7,2},{2,3},{1,5}]',4940,130520,'[{2,80320},{4,2008}]'),(2,335,'[{3,0,1017888}]',1458,'[{90,1},{7,2},{2,3},{1,5}]',4956,131300,'[{2,80800},{4,2020}]'),(2,336,'[{3,0,1032768}]',1463,'[{90,1},{7,2},{2,3},{1,5}]',4973,132080,'[{2,81280},{4,2032}]'),(2,337,'[{3,0,1047649}]',1468,'[{90,1},{7,2},{2,3},{1,5}]',4990,132860,'[{2,81760},{4,2044}]'),(2,338,'[{3,0,1062529}]',1473,'[{90,1},{7,2},{2,3},{1,5}]',5006,133640,'[{2,82240},{4,2056}]'),(2,339,'[{3,0,1077409}]',1478,'[{90,1},{7,2},{2,3},{1,5}]',5023,134420,'[{2,82720},{4,2068}]'),(2,340,'[{3,0,1092290}]',1483,'[{90,1},{7,2},{2,3},{1,5}]',5039,135200,'[{2,83200},{4,2080}]'),(2,341,'[{3,0,1107170}]',1488,'[{90,1},{7,2},{2,3},{1,5}]',5056,135980,'[{2,83680},{4,2092}]'),(2,342,'[{3,0,1122050}]',1492,'[{90,1},{7,2},{2,3},{1,5}]',5072,136760,'[{2,84160},{4,2104}]'),(2,343,'[{3,0,1136930}]',1497,'[{90,1},{7,2},{2,3},{1,5}]',5089,137540,'[{2,84640},{4,2116}]'),(2,344,'[{3,0,1151811}]',1502,'[{90,1},{7,2},{2,3},{1,5}]',5105,138320,'[{2,85120},{4,2128}]'),(2,345,'[{3,0,1166691}]',1507,'[{90,1},{7,2},{2,3},{1,5}]',5122,139100,'[{2,85600},{4,2140}]'),(2,346,'[{3,0,1181571}]',1512,'[{90,1},{7,2},{2,3},{1,5}]',5139,139880,'[{2,86080},{4,2152}]'),(2,347,'[{3,0,1196452}]',1517,'[{90,1},{7,2},{2,3},{1,5}]',5155,140660,'[{2,86560},{4,2164}]'),(2,348,'[{3,0,1211332}]',1522,'[{90,1},{7,2},{2,3},{1,5}]',5172,141440,'[{2,87040},{4,2176}]'),(2,349,'[{3,0,1263370}]',1573,'[{90,1},{7,2},{2,3},{1,5}]',5188,142220,'[{2,87520},{4,2188}]'),(2,350,'[{3,0,1279417}]',1578,'[{90,1},{7,2},{2,3},{1,5}]',5205,143000,'[{2,88000},{4,2200}]'),(2,351,'[{3,0,1295463}]',1583,'[{90,1},{7,2},{2,3},{1,5}]',5222,143780,'[{2,88480},{4,2212}]'),(2,352,'[{3,0,1311509}]',1588,'[{90,1},{7,2},{2,3},{1,5}]',5238,144560,'[{2,88960},{4,2224}]'),(2,353,'[{3,0,1327556}]',1593,'[{90,1},{7,2},{2,3},{1,5}]',5255,145340,'[{2,89440},{4,2236}]'),(2,354,'[{3,0,1343602}]',1598,'[{90,1},{7,2},{2,3},{1,5}]',5272,146120,'[{2,89920},{4,2248}]'),(2,355,'[{3,0,1359648}]',1603,'[{90,1},{7,2},{2,3},{1,5}]',5288,146900,'[{2,90400},{4,2260}]'),(2,356,'[{3,0,1375695}]',1608,'[{90,1},{7,2},{2,3},{1,5}]',5305,147680,'[{2,90880},{4,2272}]'),(2,357,'[{3,0,1391741}]',1613,'[{90,1},{7,2},{2,3},{1,5}]',5322,148460,'[{2,91360},{4,2284}]'),(2,358,'[{3,0,1407787}]',1618,'[{90,1},{7,2},{2,3},{1,5}]',5338,149240,'[{2,91840},{4,2296}]'),(2,359,'[{3,0,1423834}]',1623,'[{90,1},{7,2},{2,3},{1,5}]',5355,150020,'[{2,92320},{4,2308}]'),(2,360,'[{3,0,1439880}]',1628,'[{90,1},{7,2},{2,3},{1,5}]',5372,150800,'[{2,92800},{4,2320}]'),(2,361,'[{3,0,1455927}]',1633,'[{90,1},{7,2},{2,3},{1,5}]',5388,151580,'[{2,93280},{4,2332}]'),(2,362,'[{3,0,1471973}]',1638,'[{90,1},{7,2},{2,3},{1,5}]',5405,152360,'[{2,93760},{4,2344}]'),(2,363,'[{3,0,1488019}]',1644,'[{90,1},{7,2},{2,3},{1,5}]',5422,153140,'[{2,94240},{4,2356}]'),(2,364,'[{3,0,1504066}]',1648,'[{90,1},{7,2},{2,3},{1,5}]',5438,153920,'[{2,94720},{4,2368}]'),(2,365,'[{3,0,1520112}]',1654,'[{90,1},{7,2},{2,3},{1,5}]',5455,154700,'[{2,95200},{4,2380}]'),(2,366,'[{3,0,1536158}]',1659,'[{90,1},{7,2},{2,3},{1,5}]',5472,155480,'[{2,95680},{4,2392}]'),(2,367,'[{3,0,1552205}]',1664,'[{90,1},{7,2},{2,3},{1,5}]',5489,156260,'[{2,96160},{4,2404}]'),(2,368,'[{3,0,1568251}]',1669,'[{90,1},{7,2},{2,3},{1,5}]',5505,157040,'[{2,96640},{4,2416}]'),(2,369,'[{3,0,1584297}]',1674,'[{90,1},{7,2},{2,3},{1,5}]',5522,157820,'[{2,97120},{4,2428}]'),(2,370,'[{3,0,1600344}]',1679,'[{90,1},{7,2},{2,3},{1,5}]',5539,158600,'[{2,97600},{4,2440}]'),(2,371,'[{3,0,1616390}]',1684,'[{90,1},{7,2},{2,3},{1,5}]',5556,159380,'[{2,98080},{4,2452}]'),(2,372,'[{3,0,1632437}]',1689,'[{90,1},{7,2},{2,3},{1,5}]',5572,160160,'[{2,98560},{4,2464}]'),(2,373,'[{3,0,1648483}]',1694,'[{90,1},{7,2},{2,3},{1,5}]',5589,160940,'[{2,99040},{4,2476}]'),(2,374,'[{3,0,1664530}]',1699,'[{90,1},{7,2},{2,3},{1,5}]',5606,161720,'[{2,99520},{4,2488}]'),(2,375,'[{3,0,1679756}]',1704,'[{90,1},{7,2},{2,3},{1,5}]',5623,162500,'[{2,100000},{4,2500}]'),(2,376,'[{3,0,1694982}]',1710,'[{90,1},{7,2},{2,3},{1,5}]',5640,163280,'[{2,100480},{4,2512}]'),(2,377,'[{3,0,1710209}]',1714,'[{90,1},{7,2},{2,3},{1,5}]',5656,164060,'[{2,100960},{4,2524}]'),(2,378,'[{3,0,1725435}]',1720,'[{90,1},{7,2},{2,3},{1,5}]',5673,164840,'[{2,101440},{4,2536}]'),(2,379,'[{3,0,1740661}]',1725,'[{90,1},{7,2},{2,3},{1,5}]',5690,165620,'[{2,101920},{4,2548}]'),(2,380,'[{3,0,1755888}]',1730,'[{90,1},{7,2},{2,3},{1,5}]',5707,166400,'[{2,102400},{4,2560}]'),(2,381,'[{3,0,1771114}]',1735,'[{90,1},{7,2},{2,3},{1,5}]',5724,167180,'[{2,102880},{4,2572}]'),(2,382,'[{3,0,1786340}]',1740,'[{90,1},{7,2},{2,3},{1,5}]',5740,167960,'[{2,103360},{4,2584}]'),(2,383,'[{3,0,1801567}]',1745,'[{90,1},{7,2},{2,3},{1,5}]',5757,168740,'[{2,103840},{4,2596}]'),(2,384,'[{3,0,1816793}]',1750,'[{90,1},{7,2},{2,3},{1,5}]',5774,169520,'[{2,104320},{4,2608}]'),(2,385,'[{3,0,1832020}]',1755,'[{90,1},{7,2},{2,3},{1,5}]',5791,170300,'[{2,104800},{4,2620}]'),(2,386,'[{3,0,1847246}]',1760,'[{90,1},{7,2},{2,3},{1,5}]',5808,171080,'[{2,105280},{4,2632}]'),(2,387,'[{3,0,1862472}]',1766,'[{90,1},{7,2},{2,3},{1,5}]',5825,171860,'[{2,105760},{4,2644}]'),(2,388,'[{3,0,1877699}]',1770,'[{90,1},{7,2},{2,3},{1,5}]',5841,172640,'[{2,106240},{4,2656}]'),(2,389,'[{3,0,1892925}]',1776,'[{90,1},{7,2},{2,3},{1,5}]',5858,173420,'[{2,106720},{4,2668}]'),(2,390,'[{3,0,1908151}]',1781,'[{90,1},{7,2},{2,3},{1,5}]',5875,174200,'[{2,107200},{4,2680}]'),(2,391,'[{3,0,1923378}]',1786,'[{90,1},{7,2},{2,3},{1,5}]',5892,174980,'[{2,107680},{4,2692}]'),(2,392,'[{3,0,1938604}]',1791,'[{90,1},{7,2},{2,3},{1,5}]',5909,175760,'[{2,108160},{4,2704}]'),(2,393,'[{3,0,1953830}]',1796,'[{90,1},{7,2},{2,3},{1,5}]',5926,176540,'[{2,108640},{4,2716}]'),(2,394,'[{3,0,1969057}]',1801,'[{90,1},{7,2},{2,3},{1,5}]',5943,177320,'[{2,109120},{4,2728}]'),(2,395,'[{3,0,1984283}]',1807,'[{90,1},{7,2},{2,3},{1,5}]',5960,178100,'[{2,109600},{4,2740}]'),(2,396,'[{3,0,1999510}]',1812,'[{90,1},{7,2},{2,3},{1,5}]',5977,178880,'[{2,110080},{4,2752}]'),(2,397,'[{3,0,2014736}]',1817,'[{90,1},{7,2},{2,3},{1,5}]',5993,179660,'[{2,110560},{4,2764}]'),(2,398,'[{3,0,2029962}]',1822,'[{90,1},{7,2},{2,3},{1,5}]',6010,180440,'[{2,111040},{4,2776}]'),(2,399,'[{3,0,2109102}]',1884,'[{90,1},{7,2},{2,3},{1,5}]',6027,181220,'[{2,111520},{4,2788}]'),(2,400,'[{3,0,2133037}]',1889,'[{90,1},{7,2},{2,3},{1,5}]',6044,182000,'[{2,112000},{4,2800}]'),(2,401,'[{3,0,2156972}]',1895,'[{90,1},{7,2},{2,3},{1,5}]',6061,183040,'[{2,112640},{4,2816}]'),(2,402,'[{3,0,2180907}]',1900,'[{90,1},{7,2},{2,3},{1,5}]',6078,184080,'[{2,113280},{4,2832}]'),(2,403,'[{3,0,2204842}]',1905,'[{90,1},{7,2},{2,3},{1,5}]',6095,185120,'[{2,113920},{4,2848}]'),(2,404,'[{3,0,2228777}]',1910,'[{90,1},{7,2},{2,3},{1,5}]',6112,186160,'[{2,114560},{4,2864}]'),(2,405,'[{3,0,2252712}]',1916,'[{90,1},{7,2},{2,3},{1,5}]',6129,187200,'[{2,115200},{4,2880}]'),(2,406,'[{3,0,2276647}]',1921,'[{90,1},{7,2},{2,3},{1,5}]',6146,188240,'[{2,115840},{4,2896}]'),(2,407,'[{3,0,2300582}]',1926,'[{90,1},{7,2},{2,3},{1,5}]',6163,189280,'[{2,116480},{4,2912}]'),(2,408,'[{3,0,2324517}]',1932,'[{90,1},{7,2},{2,3},{1,5}]',6180,190320,'[{2,117120},{4,2928}]'),(2,409,'[{3,0,2348452}]',1937,'[{90,1},{7,2},{2,3},{1,5}]',6197,191360,'[{2,117760},{4,2944}]'),(2,410,'[{3,0,2372387}]',1942,'[{90,1},{7,2},{2,3},{1,5}]',6214,192400,'[{2,118400},{4,2960}]'),(2,411,'[{3,0,2396322}]',1948,'[{90,1},{7,2},{2,3},{1,5}]',6231,193440,'[{2,119040},{4,2976}]'),(2,412,'[{3,0,2420257}]',1953,'[{90,1},{7,2},{2,3},{1,5}]',6248,194480,'[{2,119680},{4,2992}]'),(2,413,'[{3,0,2444192}]',1958,'[{90,1},{7,2},{2,3},{1,5}]',6265,195520,'[{2,120320},{4,3008}]'),(2,414,'[{3,0,2468127}]',1964,'[{90,1},{7,2},{2,3},{1,5}]',6282,196560,'[{2,120960},{4,3024}]'),(2,415,'[{3,0,2492062}]',1969,'[{90,1},{7,2},{2,3},{1,5}]',6299,197600,'[{2,121600},{4,3040}]'),(2,416,'[{3,0,2515997}]',1974,'[{90,1},{7,2},{2,3},{1,5}]',6316,198640,'[{2,122240},{4,3056}]'),(2,417,'[{3,0,2539932}]',1980,'[{90,1},{7,2},{2,3},{1,5}]',6333,199680,'[{2,122880},{4,3072}]'),(2,418,'[{3,0,2563867}]',1985,'[{90,1},{7,2},{2,3},{1,5}]',6350,200720,'[{2,123520},{4,3088}]'),(2,419,'[{3,0,2587802}]',1990,'[{90,1},{7,2},{2,3},{1,5}]',6367,201760,'[{2,124160},{4,3104}]'),(2,420,'[{3,0,2611737}]',1995,'[{90,1},{7,2},{2,3},{1,5}]',6384,202800,'[{2,124800},{4,3120}]'),(2,421,'[{3,0,2635672}]',2001,'[{90,1},{7,2},{2,3},{1,5}]',6401,203840,'[{2,125440},{4,3136}]'),(2,422,'[{3,0,2659607}]',2006,'[{90,1},{7,2},{2,3},{1,5}]',6418,204880,'[{2,126080},{4,3152}]'),(2,423,'[{3,0,2683542}]',2011,'[{90,1},{7,2},{2,3},{1,5}]',6435,205920,'[{2,126720},{4,3168}]'),(2,424,'[{3,0,2707479}]',2017,'[{90,1},{7,2},{2,3},{1,5}]',6452,206960,'[{2,127360},{4,3184}]'),(2,425,'[{3,0,2730859}]',2022,'[{90,1},{7,2},{2,3},{1,5}]',6470,208000,'[{2,128000},{4,3200}]'),(2,426,'[{3,0,2754239}]',2028,'[{90,1},{7,2},{2,3},{1,5}]',6487,209040,'[{2,128640},{4,3216}]'),(2,427,'[{3,0,2777618}]',2033,'[{90,1},{7,2},{2,3},{1,5}]',6504,210080,'[{2,129280},{4,3232}]'),(2,428,'[{3,0,2800998}]',2038,'[{90,1},{7,2},{2,3},{1,5}]',6521,211120,'[{2,129920},{4,3248}]'),(2,429,'[{3,0,2824378}]',2044,'[{90,1},{7,2},{2,3},{1,5}]',6538,212160,'[{2,130560},{4,3264}]'),(2,430,'[{3,0,2847757}]',2049,'[{90,1},{7,2},{2,3},{1,5}]',6555,213200,'[{2,131200},{4,3280}]'),(2,431,'[{3,0,2871137}]',2054,'[{90,1},{7,2},{2,3},{1,5}]',6572,214240,'[{2,131840},{4,3296}]'),(2,432,'[{3,0,2894517}]',2060,'[{90,1},{7,2},{2,3},{1,5}]',6589,215280,'[{2,132480},{4,3312}]'),(2,433,'[{3,0,2917896}]',2065,'[{90,1},{7,2},{2,3},{1,5}]',6606,216320,'[{2,133120},{4,3328}]'),(2,434,'[{3,0,2941276}]',2070,'[{90,1},{7,2},{2,3},{1,5}]',6624,217360,'[{2,133760},{4,3344}]'),(2,435,'[{3,0,2964656}]',2076,'[{90,1},{7,2},{2,3},{1,5}]',6641,218400,'[{2,134400},{4,3360}]'),(2,436,'[{3,0,2988035}]',2081,'[{90,1},{7,2},{2,3},{1,5}]',6658,219440,'[{2,135040},{4,3376}]'),(2,437,'[{3,0,3011415}]',2086,'[{90,1},{7,2},{2,3},{1,5}]',6675,220480,'[{2,135680},{4,3392}]'),(2,438,'[{3,0,3034795}]',2092,'[{90,1},{7,2},{2,3},{1,5}]',6692,221520,'[{2,136320},{4,3408}]'),(2,439,'[{3,0,3058175}]',2097,'[{90,1},{7,2},{2,3},{1,5}]',6709,222560,'[{2,136960},{4,3424}]'),(2,440,'[{3,0,3081554}]',2102,'[{90,1},{7,2},{2,3},{1,5}]',6726,223600,'[{2,137600},{4,3440}]'),(2,441,'[{3,0,3104934}]',2108,'[{90,1},{7,2},{2,3},{1,5}]',6744,224640,'[{2,138240},{4,3456}]'),(2,442,'[{3,0,3128314}]',2113,'[{90,1},{7,2},{2,3},{1,5}]',6761,225680,'[{2,138880},{4,3472}]'),(2,443,'[{3,0,3151693}]',2119,'[{90,1},{7,2},{2,3},{1,5}]',6778,226720,'[{2,139520},{4,3488}]'),(2,444,'[{3,0,3175073}]',2124,'[{90,1},{7,2},{2,3},{1,5}]',6795,227760,'[{2,140160},{4,3504}]'),(2,445,'[{3,0,3198453}]',2129,'[{90,1},{7,2},{2,3},{1,5}]',6812,228800,'[{2,140800},{4,3520}]'),(2,446,'[{3,0,3221832}]',2135,'[{90,1},{7,2},{2,3},{1,5}]',6830,229840,'[{2,141440},{4,3536}]'),(2,447,'[{3,0,3245212}]',2140,'[{90,1},{7,2},{2,3},{1,5}]',6847,230880,'[{2,142080},{4,3552}]'),(2,448,'[{3,0,3268592}]',2145,'[{90,1},{7,2},{2,3},{1,5}]',6864,231920,'[{2,142720},{4,3568}]'),(2,449,'[{3,0,3398166}]',2220,'[{90,1},{7,2},{2,3},{1,5}]',6881,232960,'[{2,143360},{4,3584}]'),(2,450,'[{3,0,3413589}]',2226,'[{90,1},{7,2},{2,3},{1,5}]',6898,234000,'[{2,144000},{4,3600}]'),(2,451,'[{3,0,3429011}]',2231,'[{90,1},{7,2},{2,3},{1,5}]',6916,235040,'[{2,144640},{4,3616}]'),(2,452,'[{3,0,3444434}]',2237,'[{90,1},{7,2},{2,3},{1,5}]',6933,236080,'[{2,145280},{4,3632}]'),(2,453,'[{3,0,3459856}]',2242,'[{90,1},{7,2},{2,3},{1,5}]',6950,237120,'[{2,145920},{4,3648}]'),(2,454,'[{3,0,3475279}]',2248,'[{90,1},{7,2},{2,3},{1,5}]',6967,238160,'[{2,146560},{4,3664}]'),(2,455,'[{3,0,3490701}]',2254,'[{90,1},{7,2},{2,3},{1,5}]',6985,239200,'[{2,147200},{4,3680}]'),(2,456,'[{3,0,3506124}]',2259,'[{90,1},{7,2},{2,3},{1,5}]',7002,240240,'[{2,147840},{4,3696}]'),(2,457,'[{3,0,3521547}]',2265,'[{90,1},{7,2},{2,3},{1,5}]',7019,241280,'[{2,148480},{4,3712}]'),(2,458,'[{3,0,3536969}]',2270,'[{90,1},{7,2},{2,3},{1,5}]',7036,242320,'[{2,149120},{4,3728}]'),(2,459,'[{3,0,3552392}]',2276,'[{90,1},{7,2},{2,3},{1,5}]',7054,243360,'[{2,149760},{4,3744}]'),(2,460,'[{3,0,3567814}]',2281,'[{90,1},{7,2},{2,3},{1,5}]',7071,244400,'[{2,150400},{4,3760}]'),(2,461,'[{3,0,3583237}]',2287,'[{90,1},{7,2},{2,3},{1,5}]',7088,245440,'[{2,151040},{4,3776}]'),(2,462,'[{3,0,3598660}]',2292,'[{90,1},{7,2},{2,3},{1,5}]',7105,246480,'[{2,151680},{4,3792}]'),(2,463,'[{3,0,3614082}]',2298,'[{90,1},{7,2},{2,3},{1,5}]',7123,247520,'[{2,152320},{4,3808}]'),(2,464,'[{3,0,3629505}]',2304,'[{90,1},{7,2},{2,3},{1,5}]',7140,248560,'[{2,152960},{4,3824}]'),(2,465,'[{3,0,3644927}]',2309,'[{90,1},{7,2},{2,3},{1,5}]',7157,249600,'[{2,153600},{4,3840}]'),(2,466,'[{3,0,3660350}]',2315,'[{90,1},{7,2},{2,3},{1,5}]',7175,250640,'[{2,154240},{4,3856}]'),(2,467,'[{3,0,3675772}]',2320,'[{90,1},{7,2},{2,3},{1,5}]',7192,251680,'[{2,154880},{4,3872}]'),(2,468,'[{3,0,3691195}]',2326,'[{90,1},{7,2},{2,3},{1,5}]',7209,252720,'[{2,155520},{4,3888}]'),(2,469,'[{3,0,3706618}]',2332,'[{90,1},{7,2},{2,3},{1,5}]',7227,253760,'[{2,156160},{4,3904}]'),(2,470,'[{3,0,3722040}]',2337,'[{90,1},{7,2},{2,3},{1,5}]',7244,254800,'[{2,156800},{4,3920}]'),(2,471,'[{3,0,3737463}]',2343,'[{90,1},{7,2},{2,3},{1,5}]',7261,255840,'[{2,157440},{4,3936}]'),(2,472,'[{3,0,3752885}]',2349,'[{90,1},{7,2},{2,3},{1,5}]',7279,256880,'[{2,158080},{4,3952}]'),(2,473,'[{3,0,3768308}]',2354,'[{90,1},{7,2},{2,3},{1,5}]',7296,257920,'[{2,158720},{4,3968}]'),(2,474,'[{3,0,3783732}]',2360,'[{90,1},{7,2},{2,3},{1,5}]',7313,258960,'[{2,159360},{4,3984}]'),(2,475,'[{3,0,3797544}]',2365,'[{90,1},{7,2},{2,3},{1,5}]',7331,260000,'[{2,160000},{4,4000}]'),(2,476,'[{3,0,3811356}]',2371,'[{90,1},{7,2},{2,3},{1,5}]',7348,261040,'[{2,160640},{4,4016}]'),(2,477,'[{3,0,3825168}]',2376,'[{90,1},{7,2},{2,3},{1,5}]',7365,262080,'[{2,161280},{4,4032}]'),(2,478,'[{3,0,3838980}]',2382,'[{90,1},{7,2},{2,3},{1,5}]',7383,263120,'[{2,161920},{4,4048}]'),(2,479,'[{3,0,3852791}]',2388,'[{90,1},{7,2},{2,3},{1,5}]',7400,264160,'[{2,162560},{4,4064}]'),(2,480,'[{3,0,3866603}]',2393,'[{90,1},{7,2},{2,3},{1,5}]',7417,265200,'[{2,163200},{4,4080}]'),(2,481,'[{3,0,3880415}]',2399,'[{90,1},{7,2},{2,3},{1,5}]',7435,266240,'[{2,163840},{4,4096}]'),(2,482,'[{3,0,3894227}]',2404,'[{90,1},{7,2},{2,3},{1,5}]',7452,267280,'[{2,164480},{4,4112}]'),(2,483,'[{3,0,3908039}]',2410,'[{90,1},{7,2},{2,3},{1,5}]',7470,268320,'[{2,165120},{4,4128}]'),(2,484,'[{3,0,3921851}]',2416,'[{90,1},{7,2},{2,3},{1,5}]',7487,269360,'[{2,165760},{4,4144}]'),(2,485,'[{3,0,3935663}]',2421,'[{90,1},{7,2},{2,3},{1,5}]',7504,270400,'[{2,166400},{4,4160}]'),(2,486,'[{3,0,3949475}]',2427,'[{90,1},{7,2},{2,3},{1,5}]',7522,271440,'[{2,167040},{4,4176}]'),(2,487,'[{3,0,3963287}]',2432,'[{90,1},{7,2},{2,3},{1,5}]',7539,272480,'[{2,167680},{4,4192}]'),(2,488,'[{3,0,3977099}]',2438,'[{90,1},{7,2},{2,3},{1,5}]',7557,273520,'[{2,168320},{4,4208}]'),(2,489,'[{3,0,3990911}]',2444,'[{90,1},{7,2},{2,3},{1,5}]',7574,274560,'[{2,168960},{4,4224}]'),(2,490,'[{3,0,4004723}]',2449,'[{90,1},{7,2},{2,3},{1,5}]',7591,275600,'[{2,169600},{4,4240}]'),(2,491,'[{3,0,4018535}]',2455,'[{90,1},{7,2},{2,3},{1,5}]',7609,276640,'[{2,170240},{4,4256}]'),(2,492,'[{3,0,4032347}]',2460,'[{90,1},{7,2},{2,3},{1,5}]',7626,277680,'[{2,170880},{4,4272}]'),(2,493,'[{3,0,4046159}]',2466,'[{90,1},{7,2},{2,3},{1,5}]',7644,278720,'[{2,171520},{4,4288}]'),(2,494,'[{3,0,4059970}]',2472,'[{90,1},{7,2},{2,3},{1,5}]',7661,279760,'[{2,172160},{4,4304}]'),(2,495,'[{3,0,4073782}]',2478,'[{90,1},{7,2},{2,3},{1,5}]',7679,280800,'[{2,172800},{4,4320}]'),(2,496,'[{3,0,4087594}]',2483,'[{90,1},{7,2},{2,3},{1,5}]',7696,281840,'[{2,173440},{4,4336}]'),(2,497,'[{3,0,4101406}]',2489,'[{90,1},{7,2},{2,3},{1,5}]',7714,282880,'[{2,174080},{4,4352}]'),(2,498,'[{3,0,4115218}]',2494,'[{90,1},{7,2},{2,3},{1,5}]',7731,283920,'[{2,174720},{4,4368}]'),(2,499,'[{3,0,4266667}]',2583,'[{90,1},{7,2},{2,3},{1,5}]',7749,284960,'[{2,175360},{4,4384}]'),(2,500,'[{3,0,0}]',0,'[{90,1},{7,2},{2,3},{1,5}]',0,286000,'[{2,176000},{4,4400}]'),(3,0,'[{3,0,668}]',15,'[{90,1},{7,2},{2,3},{1,5}]',58,0,'[{1,0},{3,0}]'),(3,1,'[{3,0,803}]',17,'[{90,1},{7,2},{2,3},{1,5}]',67,195,'[{1,6},{3,3}]'),(3,2,'[{3,0,937}]',19,'[{90,1},{7,2},{2,3},{1,5}]',76,390,'[{1,12},{3,6}]'),(3,3,'[{3,0,1071}]',22,'[{90,1},{7,2},{2,3},{1,5}]',86,585,'[{1,18},{3,9}]'),(3,4,'[{3,0,1205}]',24,'[{90,1},{7,2},{2,3},{1,5}]',96,780,'[{1,24},{3,12}]'),(3,5,'[{3,0,1340}]',27,'[{90,1},{7,2},{2,3},{1,5}]',106,975,'[{1,30},{3,15}]'),(3,6,'[{3,0,1474}]',29,'[{90,1},{7,2},{2,3},{1,5}]',116,1170,'[{1,36},{3,18}]'),(3,7,'[{3,0,1608}]',32,'[{90,1},{7,2},{2,3},{1,5}]',126,1365,'[{1,42},{3,21}]'),(3,8,'[{3,0,1742}]',35,'[{90,1},{7,2},{2,3},{1,5}]',137,1560,'[{1,48},{3,24}]'),(3,9,'[{3,0,1877}]',37,'[{90,1},{7,2},{2,3},{1,5}]',148,1755,'[{1,54},{3,27}]'),(3,10,'[{3,0,2011}]',40,'[{90,1},{7,2},{2,3},{1,5}]',158,1950,'[{1,60},{3,30}]'),(3,11,'[{3,0,2145}]',43,'[{90,1},{7,2},{2,3},{1,5}]',169,2145,'[{1,66},{3,33}]'),(3,12,'[{3,0,2279}]',45,'[{90,1},{7,2},{2,3},{1,5}]',180,2340,'[{1,72},{3,36}]'),(3,13,'[{3,0,2414}]',48,'[{90,1},{7,2},{2,3},{1,5}]',191,2535,'[{1,78},{3,39}]'),(3,14,'[{3,0,2548}]',51,'[{90,1},{7,2},{2,3},{1,5}]',202,2730,'[{1,84},{3,42}]'),(3,15,'[{3,0,2682}]',54,'[{90,1},{7,2},{2,3},{1,5}]',214,2925,'[{1,90},{3,45}]'),(3,16,'[{3,0,2816}]',57,'[{90,1},{7,2},{2,3},{1,5}]',225,3120,'[{1,96},{3,48}]'),(3,17,'[{3,0,2951}]',59,'[{90,1},{7,2},{2,3},{1,5}]',236,3315,'[{1,102},{3,51}]'),(3,18,'[{3,0,3085}]',62,'[{90,1},{7,2},{2,3},{1,5}]',248,3510,'[{1,108},{3,54}]'),(3,19,'[{3,0,3219}]',65,'[{90,1},{7,2},{2,3},{1,5}]',259,3705,'[{1,114},{3,57}]'),(3,20,'[{3,0,3353}]',68,'[{90,1},{7,2},{2,3},{1,5}]',271,3900,'[{1,120},{3,60}]'),(3,21,'[{3,0,3488}]',71,'[{90,1},{7,2},{2,3},{1,5}]',282,4095,'[{1,126},{3,63}]'),(3,22,'[{3,0,3622}]',74,'[{90,1},{7,2},{2,3},{1,5}]',294,4290,'[{1,132},{3,66}]'),(3,23,'[{3,0,3756}]',77,'[{90,1},{7,2},{2,3},{1,5}]',306,4485,'[{1,138},{3,69}]'),(3,24,'[{3,0,3891}]',80,'[{90,1},{7,2},{2,3},{1,5}]',318,4680,'[{1,144},{3,72}]'),(3,25,'[{3,0,4239}]',83,'[{90,1},{7,2},{2,3},{1,5}]',330,4875,'[{1,150},{3,75}]'),(3,26,'[{3,0,4587}]',86,'[{90,1},{7,2},{2,3},{1,5}]',342,5070,'[{1,156},{3,78}]'),(3,27,'[{3,0,4936}]',89,'[{90,1},{7,2},{2,3},{1,5}]',354,5265,'[{1,162},{3,81}]'),(3,28,'[{3,0,5284}]',92,'[{90,1},{7,2},{2,3},{1,5}]',366,5460,'[{1,168},{3,84}]'),(3,29,'[{3,0,5632}]',95,'[{90,1},{7,2},{2,3},{1,5}]',378,5655,'[{1,174},{3,87}]'),(3,30,'[{3,0,5980}]',98,'[{90,1},{7,2},{2,3},{1,5}]',390,5850,'[{1,180},{3,90}]'),(3,31,'[{3,0,6329}]',101,'[{90,1},{7,2},{2,3},{1,5}]',402,6045,'[{1,186},{3,93}]'),(3,32,'[{3,0,6677}]',104,'[{90,1},{7,2},{2,3},{1,5}]',414,6240,'[{1,192},{3,96}]'),(3,33,'[{3,0,7025}]',107,'[{90,1},{7,2},{2,3},{1,5}]',426,6435,'[{1,198},{3,99}]'),(3,34,'[{3,0,7373}]',110,'[{90,1},{7,2},{2,3},{1,5}]',439,6630,'[{1,204},{3,102}]'),(3,35,'[{3,0,7722}]',113,'[{90,1},{7,2},{2,3},{1,5}]',451,6825,'[{1,210},{3,105}]'),(3,36,'[{3,0,8070}]',116,'[{90,1},{7,2},{2,3},{1,5}]',464,7020,'[{1,216},{3,108}]'),(3,37,'[{3,0,8418}]',119,'[{90,1},{7,2},{2,3},{1,5}]',476,7215,'[{1,222},{3,111}]'),(3,38,'[{3,0,8766}]',122,'[{90,1},{7,2},{2,3},{1,5}]',488,7410,'[{1,228},{3,114}]'),(3,39,'[{3,0,9115}]',126,'[{90,1},{7,2},{2,3},{1,5}]',501,7605,'[{1,234},{3,117}]'),(3,40,'[{3,0,9463}]',129,'[{90,1},{7,2},{2,3},{1,5}]',514,7800,'[{1,240},{3,120}]'),(3,41,'[{3,0,9811}]',132,'[{90,1},{7,2},{2,3},{1,5}]',526,7995,'[{1,246},{3,123}]'),(3,42,'[{3,0,10159}]',135,'[{90,1},{7,2},{2,3},{1,5}]',539,8190,'[{1,252},{3,126}]'),(3,43,'[{3,0,10508}]',138,'[{90,1},{7,2},{2,3},{1,5}]',551,8385,'[{1,258},{3,129}]'),(3,44,'[{3,0,10856}]',141,'[{90,1},{7,2},{2,3},{1,5}]',564,8580,'[{1,264},{3,132}]'),(3,45,'[{3,0,11204}]',145,'[{90,1},{7,2},{2,3},{1,5}]',577,8775,'[{1,270},{3,135}]'),(3,46,'[{3,0,11552}]',148,'[{90,1},{7,2},{2,3},{1,5}]',590,8970,'[{1,276},{3,138}]'),(3,47,'[{3,0,11901}]',151,'[{90,1},{7,2},{2,3},{1,5}]',602,9165,'[{1,282},{3,141}]'),(3,48,'[{3,0,12249}]',154,'[{90,1},{7,2},{2,3},{1,5}]',615,9360,'[{1,288},{3,144}]'),(3,49,'[{3,0,12923}]',162,'[{90,1},{7,2},{2,3},{1,5}]',628,9555,'[{1,294},{3,147}]'),(3,50,'[{3,0,13425}]',165,'[{90,1},{7,2},{2,3},{1,5}]',641,9750,'[{1,300},{3,150}]'),(3,51,'[{3,0,13927}]',168,'[{90,1},{7,2},{2,3},{1,5}]',654,9945,'[{1,306},{3,153}]'),(3,52,'[{3,0,14429}]',172,'[{90,1},{7,2},{2,3},{1,5}]',667,10140,'[{1,312},{3,156}]'),(3,53,'[{3,0,14931}]',175,'[{90,1},{7,2},{2,3},{1,5}]',680,10335,'[{1,318},{3,159}]'),(3,54,'[{3,0,15433}]',178,'[{90,1},{7,2},{2,3},{1,5}]',693,10530,'[{1,324},{3,162}]'),(3,55,'[{3,0,15935}]',182,'[{90,1},{7,2},{2,3},{1,5}]',706,10725,'[{1,330},{3,165}]'),(3,56,'[{3,0,16437}]',185,'[{90,1},{7,2},{2,3},{1,5}]',719,10920,'[{1,336},{3,168}]'),(3,57,'[{3,0,16939}]',188,'[{90,1},{7,2},{2,3},{1,5}]',732,11115,'[{1,342},{3,171}]'),(3,58,'[{3,0,17442}]',192,'[{90,1},{7,2},{2,3},{1,5}]',745,11310,'[{1,348},{3,174}]'),(3,59,'[{3,0,17944}]',195,'[{90,1},{7,2},{2,3},{1,5}]',758,11505,'[{1,354},{3,177}]'),(3,60,'[{3,0,18446}]',198,'[{90,1},{7,2},{2,3},{1,5}]',771,11700,'[{1,360},{3,180}]'),(3,61,'[{3,0,18948}]',202,'[{90,1},{7,2},{2,3},{1,5}]',785,11895,'[{1,366},{3,183}]'),(3,62,'[{3,0,19450}]',205,'[{90,1},{7,2},{2,3},{1,5}]',798,12090,'[{1,372},{3,186}]'),(3,63,'[{3,0,19952}]',208,'[{90,1},{7,2},{2,3},{1,5}]',811,12285,'[{1,378},{3,189}]'),(3,64,'[{3,0,20454}]',212,'[{90,1},{7,2},{2,3},{1,5}]',824,12480,'[{1,384},{3,192}]'),(3,65,'[{3,0,20956}]',215,'[{90,1},{7,2},{2,3},{1,5}]',838,12675,'[{1,390},{3,195}]'),(3,66,'[{3,0,21458}]',219,'[{90,1},{7,2},{2,3},{1,5}]',851,12870,'[{1,396},{3,198}]'),(3,67,'[{3,0,21960}]',222,'[{90,1},{7,2},{2,3},{1,5}]',864,13065,'[{1,402},{3,201}]'),(3,68,'[{3,0,22462}]',226,'[{90,1},{7,2},{2,3},{1,5}]',878,13260,'[{1,408},{3,204}]'),(3,69,'[{3,0,22964}]',229,'[{90,1},{7,2},{2,3},{1,5}]',891,13455,'[{1,414},{3,207}]'),(3,70,'[{3,0,23466}]',233,'[{90,1},{7,2},{2,3},{1,5}]',905,13650,'[{1,420},{3,210}]'),(3,71,'[{3,0,23968}]',236,'[{90,1},{7,2},{2,3},{1,5}]',918,13845,'[{1,426},{3,213}]'),(3,72,'[{3,0,24470}]',239,'[{90,1},{7,2},{2,3},{1,5}]',932,14040,'[{1,432},{3,216}]'),(3,73,'[{3,0,24972}]',243,'[{90,1},{7,2},{2,3},{1,5}]',945,14235,'[{1,438},{3,219}]'),(3,74,'[{3,0,25472}]',246,'[{90,1},{7,2},{2,3},{1,5}]',959,14430,'[{1,444},{3,222}]'),(3,75,'[{3,0,25627}]',250,'[{90,1},{7,2},{2,3},{1,5}]',972,14625,'[{1,450},{3,225}]'),(3,76,'[{3,0,25783}]',253,'[{90,1},{7,2},{2,3},{1,5}]',986,14820,'[{1,456},{3,228}]'),(3,77,'[{3,0,25938}]',257,'[{90,1},{7,2},{2,3},{1,5}]',999,15015,'[{1,462},{3,231}]'),(3,78,'[{3,0,26094}]',260,'[{90,1},{7,2},{2,3},{1,5}]',1013,15210,'[{1,468},{3,234}]'),(3,79,'[{3,0,26249}]',264,'[{90,1},{7,2},{2,3},{1,5}]',1027,15405,'[{1,474},{3,237}]'),(3,80,'[{3,0,26404}]',267,'[{90,1},{7,2},{2,3},{1,5}]',1040,15600,'[{1,480},{3,240}]'),(3,81,'[{3,0,26560}]',271,'[{90,1},{7,2},{2,3},{1,5}]',1054,15795,'[{1,486},{3,243}]'),(3,82,'[{3,0,26715}]',274,'[{90,1},{7,2},{2,3},{1,5}]',1068,15990,'[{1,492},{3,246}]'),(3,83,'[{3,0,26870}]',278,'[{90,1},{7,2},{2,3},{1,5}]',1081,16185,'[{1,498},{3,249}]'),(3,84,'[{3,0,27026}]',281,'[{90,1},{7,2},{2,3},{1,5}]',1095,16380,'[{1,504},{3,252}]'),(3,85,'[{3,0,27181}]',285,'[{90,1},{7,2},{2,3},{1,5}]',1109,16575,'[{1,510},{3,255}]'),(3,86,'[{3,0,27337}]',288,'[{90,1},{7,2},{2,3},{1,5}]',1123,16770,'[{1,516},{3,258}]'),(3,87,'[{3,0,27492}]',292,'[{90,1},{7,2},{2,3},{1,5}]',1136,16965,'[{1,522},{3,261}]'),(3,88,'[{3,0,27647}]',295,'[{90,1},{7,2},{2,3},{1,5}]',1150,17160,'[{1,528},{3,264}]'),(3,89,'[{3,0,27803}]',299,'[{90,1},{7,2},{2,3},{1,5}]',1164,17355,'[{1,534},{3,267}]'),(3,90,'[{3,0,27958}]',303,'[{90,1},{7,2},{2,3},{1,5}]',1178,17550,'[{1,540},{3,270}]'),(3,91,'[{3,0,28114}]',306,'[{90,1},{7,2},{2,3},{1,5}]',1192,17745,'[{1,546},{3,273}]'),(3,92,'[{3,0,28269}]',310,'[{90,1},{7,2},{2,3},{1,5}]',1206,17940,'[{1,552},{3,276}]'),(3,93,'[{3,0,28424}]',313,'[{90,1},{7,2},{2,3},{1,5}]',1220,18135,'[{1,558},{3,279}]'),(3,94,'[{3,0,28580}]',317,'[{90,1},{7,2},{2,3},{1,5}]',1234,18330,'[{1,564},{3,282}]'),(3,95,'[{3,0,28735}]',320,'[{90,1},{7,2},{2,3},{1,5}]',1248,18525,'[{1,570},{3,285}]'),(3,96,'[{3,0,28890}]',324,'[{90,1},{7,2},{2,3},{1,5}]',1262,18720,'[{1,576},{3,288}]'),(3,97,'[{3,0,29046}]',328,'[{90,1},{7,2},{2,3},{1,5}]',1276,18915,'[{1,582},{3,291}]'),(3,98,'[{3,0,29201}]',331,'[{90,1},{7,2},{2,3},{1,5}]',1290,19110,'[{1,588},{3,294}]'),(3,99,'[{3,0,30126}]',344,'[{90,1},{7,2},{2,3},{1,5}]',1304,19305,'[{1,594},{3,297}]'),(3,100,'[{3,0,30194}]',347,'[{90,1},{7,2},{2,3},{1,5}]',1318,19500,'[{1,600},{3,300}]'),(3,101,'[{3,0,30263}]',351,'[{90,1},{7,2},{2,3},{1,5}]',1332,19825,'[{1,610},{3,305}]'),(3,102,'[{3,0,30331}]',355,'[{90,1},{7,2},{2,3},{1,5}]',1346,20150,'[{1,620},{3,310}]'),(3,103,'[{3,0,30400}]',358,'[{90,1},{7,2},{2,3},{1,5}]',1360,20475,'[{1,630},{3,315}]'),(3,104,'[{3,0,30468}]',362,'[{90,1},{7,2},{2,3},{1,5}]',1374,20800,'[{1,640},{3,320}]'),(3,105,'[{3,0,30537}]',366,'[{90,1},{7,2},{2,3},{1,5}]',1388,21125,'[{1,650},{3,325}]'),(3,106,'[{3,0,30605}]',369,'[{90,1},{7,2},{2,3},{1,5}]',1402,21450,'[{1,660},{3,330}]'),(3,107,'[{3,0,30673}]',373,'[{90,1},{7,2},{2,3},{1,5}]',1416,21775,'[{1,670},{3,335}]'),(3,108,'[{3,0,30742}]',377,'[{90,1},{7,2},{2,3},{1,5}]',1431,22100,'[{1,680},{3,340}]'),(3,109,'[{3,0,30810}]',381,'[{90,1},{7,2},{2,3},{1,5}]',1445,22425,'[{1,690},{3,345}]'),(3,110,'[{3,0,30879}]',384,'[{90,1},{7,2},{2,3},{1,5}]',1459,22750,'[{1,700},{3,350}]'),(3,111,'[{3,0,30947}]',388,'[{90,1},{7,2},{2,3},{1,5}]',1473,23075,'[{1,710},{3,355}]'),(3,112,'[{3,0,31015}]',392,'[{90,1},{7,2},{2,3},{1,5}]',1488,23400,'[{1,720},{3,360}]'),(3,113,'[{3,0,31084}]',396,'[{90,1},{7,2},{2,3},{1,5}]',1502,23725,'[{1,730},{3,365}]'),(3,114,'[{3,0,31152}]',399,'[{90,1},{7,2},{2,3},{1,5}]',1516,24050,'[{1,740},{3,370}]'),(3,115,'[{3,0,31221}]',403,'[{90,1},{7,2},{2,3},{1,5}]',1530,24375,'[{1,750},{3,375}]'),(3,116,'[{3,0,31289}]',407,'[{90,1},{7,2},{2,3},{1,5}]',1545,24700,'[{1,760},{3,380}]'),(3,117,'[{3,0,31358}]',411,'[{90,1},{7,2},{2,3},{1,5}]',1559,25025,'[{1,770},{3,385}]'),(3,118,'[{3,0,31426}]',414,'[{90,1},{7,2},{2,3},{1,5}]',1573,25350,'[{1,780},{3,390}]'),(3,119,'[{3,0,31494}]',418,'[{90,1},{7,2},{2,3},{1,5}]',1588,25675,'[{1,790},{3,395}]'),(3,120,'[{3,0,31563}]',422,'[{90,1},{7,2},{2,3},{1,5}]',1602,26000,'[{1,800},{3,400}]'),(3,121,'[{3,0,31631}]',426,'[{90,1},{7,2},{2,3},{1,5}]',1617,26325,'[{1,810},{3,405}]'),(3,122,'[{3,0,31700}]',430,'[{90,1},{7,2},{2,3},{1,5}]',1631,26650,'[{1,820},{3,410}]'),(3,123,'[{3,0,31768}]',434,'[{90,1},{7,2},{2,3},{1,5}]',1646,26975,'[{1,830},{3,415}]'),(3,124,'[{3,0,31837}]',437,'[{90,1},{7,2},{2,3},{1,5}]',1660,27300,'[{1,840},{3,420}]'),(3,125,'[{3,0,32159}]',441,'[{90,1},{7,2},{2,3},{1,5}]',1674,27625,'[{1,850},{3,425}]'),(3,126,'[{3,0,32481}]',445,'[{90,1},{7,2},{2,3},{1,5}]',1689,27950,'[{1,860},{3,430}]'),(3,127,'[{3,0,32803}]',449,'[{90,1},{7,2},{2,3},{1,5}]',1703,28275,'[{1,870},{3,435}]'),(3,128,'[{3,0,33125}]',453,'[{90,1},{7,2},{2,3},{1,5}]',1718,28600,'[{1,880},{3,440}]'),(3,129,'[{3,0,33447}]',456,'[{90,1},{7,2},{2,3},{1,5}]',1732,28925,'[{1,890},{3,445}]'),(3,130,'[{3,0,33769}]',460,'[{90,1},{7,2},{2,3},{1,5}]',1747,29250,'[{1,900},{3,450}]'),(3,131,'[{3,0,34091}]',464,'[{90,1},{7,2},{2,3},{1,5}]',1762,29575,'[{1,910},{3,455}]'),(3,132,'[{3,0,34413}]',468,'[{90,1},{7,2},{2,3},{1,5}]',1776,29900,'[{1,920},{3,460}]'),(3,133,'[{3,0,34735}]',472,'[{90,1},{7,2},{2,3},{1,5}]',1791,30225,'[{1,930},{3,465}]'),(3,134,'[{3,0,35058}]',475,'[{90,1},{7,2},{2,3},{1,5}]',1805,30550,'[{1,940},{3,470}]'),(3,135,'[{3,0,35380}]',479,'[{90,1},{7,2},{2,3},{1,5}]',1820,30875,'[{1,950},{3,475}]'),(3,136,'[{3,0,35702}]',483,'[{90,1},{7,2},{2,3},{1,5}]',1834,31200,'[{1,960},{3,480}]'),(3,137,'[{3,0,36024}]',487,'[{90,1},{7,2},{2,3},{1,5}]',1849,31525,'[{1,970},{3,485}]'),(3,138,'[{3,0,36346}]',491,'[{90,1},{7,2},{2,3},{1,5}]',1864,31850,'[{1,980},{3,490}]'),(3,139,'[{3,0,36668}]',495,'[{90,1},{7,2},{2,3},{1,5}]',1878,32175,'[{1,990},{3,495}]'),(3,140,'[{3,0,36990}]',499,'[{90,1},{7,2},{2,3},{1,5}]',1893,32500,'[{1,1000},{3,500}]'),(3,141,'[{3,0,37312}]',503,'[{90,1},{7,2},{2,3},{1,5}]',1908,32825,'[{1,1010},{3,505}]'),(3,142,'[{3,0,37634}]',507,'[{90,1},{7,2},{2,3},{1,5}]',1923,33150,'[{1,1020},{3,510}]'),(3,143,'[{3,0,37957}]',510,'[{90,1},{7,2},{2,3},{1,5}]',1937,33475,'[{1,1030},{3,515}]'),(3,144,'[{3,0,38279}]',514,'[{90,1},{7,2},{2,3},{1,5}]',1952,33800,'[{1,1040},{3,520}]'),(3,145,'[{3,0,38601}]',518,'[{90,1},{7,2},{2,3},{1,5}]',1967,34125,'[{1,1050},{3,525}]'),(3,146,'[{3,0,38923}]',522,'[{90,1},{7,2},{2,3},{1,5}]',1981,34450,'[{1,1060},{3,530}]'),(3,147,'[{3,0,39245}]',526,'[{90,1},{7,2},{2,3},{1,5}]',1996,34775,'[{1,1070},{3,535}]'),(3,148,'[{3,0,39567}]',530,'[{90,1},{7,2},{2,3},{1,5}]',2011,35100,'[{1,1080},{3,540}]'),(3,149,'[{3,0,40965}]',548,'[{90,1},{7,2},{2,3},{1,5}]',2026,35425,'[{1,1090},{3,545}]'),(3,150,'[{3,0,41443}]',552,'[{90,1},{7,2},{2,3},{1,5}]',2041,35750,'[{1,1100},{3,550}]'),(3,151,'[{3,0,41922}]',556,'[{90,1},{7,2},{2,3},{1,5}]',2055,36075,'[{1,1110},{3,555}]'),(3,152,'[{3,0,42401}]',560,'[{90,1},{7,2},{2,3},{1,5}]',2070,36400,'[{1,1120},{3,560}]'),(3,153,'[{3,0,42879}]',564,'[{90,1},{7,2},{2,3},{1,5}]',2085,36725,'[{1,1130},{3,565}]'),(3,154,'[{3,0,43358}]',568,'[{90,1},{7,2},{2,3},{1,5}]',2100,37050,'[{1,1140},{3,570}]'),(3,155,'[{3,0,43837}]',572,'[{90,1},{7,2},{2,3},{1,5}]',2115,37375,'[{1,1150},{3,575}]'),(3,156,'[{3,0,44315}]',576,'[{90,1},{7,2},{2,3},{1,5}]',2130,37700,'[{1,1160},{3,580}]'),(3,157,'[{3,0,44794}]',580,'[{90,1},{7,2},{2,3},{1,5}]',2145,38025,'[{1,1170},{3,585}]'),(3,158,'[{3,0,45273}]',584,'[{90,1},{7,2},{2,3},{1,5}]',2160,38350,'[{1,1180},{3,590}]'),(3,159,'[{3,0,45751}]',588,'[{90,1},{7,2},{2,3},{1,5}]',2175,38675,'[{1,1190},{3,595}]'),(3,160,'[{3,0,46230}]',592,'[{90,1},{7,2},{2,3},{1,5}]',2189,39000,'[{1,1200},{3,600}]'),(3,161,'[{3,0,46709}]',596,'[{90,1},{7,2},{2,3},{1,5}]',2204,39325,'[{1,1210},{3,605}]'),(3,162,'[{3,0,47187}]',600,'[{90,1},{7,2},{2,3},{1,5}]',2219,39650,'[{1,1220},{3,610}]'),(3,163,'[{3,0,47666}]',604,'[{90,1},{7,2},{2,3},{1,5}]',2234,39975,'[{1,1230},{3,615}]'),(3,164,'[{3,0,48145}]',608,'[{90,1},{7,2},{2,3},{1,5}]',2249,40300,'[{1,1240},{3,620}]'),(3,165,'[{3,0,48623}]',612,'[{90,1},{7,2},{2,3},{1,5}]',2264,40625,'[{1,1250},{3,625}]'),(3,166,'[{3,0,49102}]',616,'[{90,1},{7,2},{2,3},{1,5}]',2279,40950,'[{1,1260},{3,630}]'),(3,167,'[{3,0,49580}]',620,'[{90,1},{7,2},{2,3},{1,5}]',2294,41275,'[{1,1270},{3,635}]'),(3,168,'[{3,0,50059}]',625,'[{90,1},{7,2},{2,3},{1,5}]',2309,41600,'[{1,1280},{3,640}]'),(3,169,'[{3,0,50538}]',629,'[{90,1},{7,2},{2,3},{1,5}]',2324,41925,'[{1,1290},{3,645}]'),(3,170,'[{3,0,51016}]',633,'[{90,1},{7,2},{2,3},{1,5}]',2340,42250,'[{1,1300},{3,650}]'),(3,171,'[{3,0,51495}]',637,'[{90,1},{7,2},{2,3},{1,5}]',2355,42575,'[{1,1310},{3,655}]'),(3,172,'[{3,0,51974}]',641,'[{90,1},{7,2},{2,3},{1,5}]',2370,42900,'[{1,1320},{3,660}]'),(3,173,'[{3,0,52452}]',645,'[{90,1},{7,2},{2,3},{1,5}]',2385,43225,'[{1,1330},{3,665}]'),(3,174,'[{3,0,52931}]',649,'[{90,1},{7,2},{2,3},{1,5}]',2400,43550,'[{1,1340},{3,670}]'),(3,175,'[{3,0,53077}]',653,'[{90,1},{7,2},{2,3},{1,5}]',2415,43875,'[{1,1350},{3,675}]'),(3,176,'[{3,0,53222}]',657,'[{90,1},{7,2},{2,3},{1,5}]',2430,44200,'[{1,1360},{3,680}]'),(3,177,'[{3,0,53368}]',661,'[{90,1},{7,2},{2,3},{1,5}]',2445,44525,'[{1,1370},{3,685}]'),(3,178,'[{3,0,53514}]',665,'[{90,1},{7,2},{2,3},{1,5}]',2460,44850,'[{1,1380},{3,690}]'),(3,179,'[{3,0,53659}]',670,'[{90,1},{7,2},{2,3},{1,5}]',2476,45175,'[{1,1390},{3,695}]'),(3,180,'[{3,0,53805}]',674,'[{90,1},{7,2},{2,3},{1,5}]',2491,45500,'[{1,1400},{3,700}]'),(3,181,'[{3,0,53951}]',678,'[{90,1},{7,2},{2,3},{1,5}]',2506,45825,'[{1,1410},{3,705}]'),(3,182,'[{3,0,54096}]',682,'[{90,1},{7,2},{2,3},{1,5}]',2521,46150,'[{1,1420},{3,710}]'),(3,183,'[{3,0,54242}]',686,'[{90,1},{7,2},{2,3},{1,5}]',2536,46475,'[{1,1430},{3,715}]'),(3,184,'[{3,0,54388}]',690,'[{90,1},{7,2},{2,3},{1,5}]',2552,46800,'[{1,1440},{3,720}]'),(3,185,'[{3,0,54533}]',694,'[{90,1},{7,2},{2,3},{1,5}]',2567,47125,'[{1,1450},{3,725}]'),(3,186,'[{3,0,54679}]',698,'[{90,1},{7,2},{2,3},{1,5}]',2582,47450,'[{1,1460},{3,730}]'),(3,187,'[{3,0,54825}]',702,'[{90,1},{7,2},{2,3},{1,5}]',2597,47775,'[{1,1470},{3,735}]'),(3,188,'[{3,0,54970}]',707,'[{90,1},{7,2},{2,3},{1,5}]',2613,48100,'[{1,1480},{3,740}]'),(3,189,'[{3,0,55116}]',711,'[{90,1},{7,2},{2,3},{1,5}]',2628,48425,'[{1,1490},{3,745}]'),(3,190,'[{3,0,55262}]',715,'[{90,1},{7,2},{2,3},{1,5}]',2643,48750,'[{1,1500},{3,750}]'),(3,191,'[{3,0,55408}]',719,'[{90,1},{7,2},{2,3},{1,5}]',2658,49075,'[{1,1510},{3,755}]'),(3,192,'[{3,0,55553}]',723,'[{90,1},{7,2},{2,3},{1,5}]',2674,49400,'[{1,1520},{3,760}]'),(3,193,'[{3,0,55699}]',727,'[{90,1},{7,2},{2,3},{1,5}]',2689,49725,'[{1,1530},{3,765}]'),(3,194,'[{3,0,55845}]',731,'[{90,1},{7,2},{2,3},{1,5}]',2704,50050,'[{1,1540},{3,770}]'),(3,195,'[{3,0,55990}]',736,'[{90,1},{7,2},{2,3},{1,5}]',2720,50375,'[{1,1550},{3,775}]'),(3,196,'[{3,0,56136}]',740,'[{90,1},{7,2},{2,3},{1,5}]',2735,50700,'[{1,1560},{3,780}]'),(3,197,'[{3,0,56282}]',744,'[{90,1},{7,2},{2,3},{1,5}]',2750,51025,'[{1,1570},{3,785}]'),(3,198,'[{3,0,56427}]',748,'[{90,1},{7,2},{2,3},{1,5}]',2766,51350,'[{1,1580},{3,790}]'),(3,199,'[{3,0,58145}]',773,'[{90,1},{7,2},{2,3},{1,5}]',2781,51675,'[{1,1590},{3,795}]'),(3,200,'[{3,0,58298}]',777,'[{90,1},{7,2},{2,3},{1,5}]',2797,52000,'[{1,1600},{3,800}]'),(3,201,'[{3,0,58451}]',782,'[{90,1},{7,2},{2,3},{1,5}]',2812,52520,'[{1,1616},{3,808}]'),(3,202,'[{3,0,58604}]',786,'[{90,1},{7,2},{2,3},{1,5}]',2827,53040,'[{1,1632},{3,816}]'),(3,203,'[{3,0,58757}]',790,'[{90,1},{7,2},{2,3},{1,5}]',2843,53560,'[{1,1648},{3,824}]'),(3,204,'[{3,0,58910}]',794,'[{90,1},{7,2},{2,3},{1,5}]',2858,54080,'[{1,1664},{3,832}]'),(3,205,'[{3,0,59063}]',799,'[{90,1},{7,2},{2,3},{1,5}]',2874,54600,'[{1,1680},{3,840}]'),(3,206,'[{3,0,59216}]',803,'[{90,1},{7,2},{2,3},{1,5}]',2889,55120,'[{1,1696},{3,848}]'),(3,207,'[{3,0,59369}]',807,'[{90,1},{7,2},{2,3},{1,5}]',2905,55640,'[{1,1712},{3,856}]'),(3,208,'[{3,0,59522}]',812,'[{90,1},{7,2},{2,3},{1,5}]',2920,56160,'[{1,1728},{3,864}]'),(3,209,'[{3,0,59675}]',816,'[{90,1},{7,2},{2,3},{1,5}]',2936,56680,'[{1,1744},{3,872}]'),(3,210,'[{3,0,59828}]',820,'[{90,1},{7,2},{2,3},{1,5}]',2951,57200,'[{1,1760},{3,880}]'),(3,211,'[{3,0,59981}]',825,'[{90,1},{7,2},{2,3},{1,5}]',2967,57720,'[{1,1776},{3,888}]'),(3,212,'[{3,0,60134}]',829,'[{90,1},{7,2},{2,3},{1,5}]',2982,58240,'[{1,1792},{3,896}]'),(3,213,'[{3,0,60287}]',833,'[{90,1},{7,2},{2,3},{1,5}]',2998,58760,'[{1,1808},{3,904}]'),(3,214,'[{3,0,60440}]',837,'[{90,1},{7,2},{2,3},{1,5}]',3013,59280,'[{1,1824},{3,912}]'),(3,215,'[{3,0,60594}]',842,'[{90,1},{7,2},{2,3},{1,5}]',3029,59800,'[{1,1840},{3,920}]'),(3,216,'[{3,0,60747}]',846,'[{90,1},{7,2},{2,3},{1,5}]',3044,60320,'[{1,1856},{3,928}]'),(3,217,'[{3,0,60900}]',850,'[{90,1},{7,2},{2,3},{1,5}]',3060,60840,'[{1,1872},{3,936}]'),(3,218,'[{3,0,61053}]',855,'[{90,1},{7,2},{2,3},{1,5}]',3075,61360,'[{1,1888},{3,944}]'),(3,219,'[{3,0,61206}]',859,'[{90,1},{7,2},{2,3},{1,5}]',3091,61880,'[{1,1904},{3,952}]'),(3,220,'[{3,0,61359}]',864,'[{90,1},{7,2},{2,3},{1,5}]',3107,62400,'[{1,1920},{3,960}]'),(3,221,'[{3,0,61512}]',868,'[{90,1},{7,2},{2,3},{1,5}]',3122,62920,'[{1,1936},{3,968}]'),(3,222,'[{3,0,61665}]',872,'[{90,1},{7,2},{2,3},{1,5}]',3138,63440,'[{1,1952},{3,976}]'),(3,223,'[{3,0,61818}]',876,'[{90,1},{7,2},{2,3},{1,5}]',3153,63960,'[{1,1968},{3,984}]'),(3,224,'[{3,0,61974}]',881,'[{90,1},{7,2},{2,3},{1,5}]',3169,64480,'[{1,1984},{3,992}]'),(3,225,'[{3,0,68137}]',885,'[{90,1},{7,2},{2,3},{1,5}]',3185,65000,'[{1,2000},{3,1000}]'),(3,226,'[{3,0,74299}]',889,'[{90,1},{7,2},{2,3},{1,5}]',3200,65520,'[{1,2016},{3,1008}]'),(3,227,'[{3,0,80461}]',894,'[{90,1},{7,2},{2,3},{1,5}]',3216,66040,'[{1,2032},{3,1016}]'),(3,228,'[{3,0,86623}]',898,'[{90,1},{7,2},{2,3},{1,5}]',3232,66560,'[{1,2048},{3,1024}]'),(3,229,'[{3,0,92785}]',902,'[{90,1},{7,2},{2,3},{1,5}]',3247,67080,'[{1,2064},{3,1032}]'),(3,230,'[{3,0,98948}]',907,'[{90,1},{7,2},{2,3},{1,5}]',3263,67600,'[{1,2080},{3,1040}]'),(3,231,'[{3,0,105110}]',911,'[{90,1},{7,2},{2,3},{1,5}]',3279,68120,'[{1,2096},{3,1048}]'),(3,232,'[{3,0,111272}]',915,'[{90,1},{7,2},{2,3},{1,5}]',3294,68640,'[{1,2112},{3,1056}]'),(3,233,'[{3,0,117434}]',920,'[{90,1},{7,2},{2,3},{1,5}]',3310,69160,'[{1,2128},{3,1064}]'),(3,234,'[{3,0,123597}]',924,'[{90,1},{7,2},{2,3},{1,5}]',3326,69680,'[{1,2144},{3,1072}]'),(3,235,'[{3,0,129759}]',929,'[{90,1},{7,2},{2,3},{1,5}]',3342,70200,'[{1,2160},{3,1080}]'),(3,236,'[{3,0,135921}]',933,'[{90,1},{7,2},{2,3},{1,5}]',3357,70720,'[{1,2176},{3,1088}]'),(3,237,'[{3,0,142083}]',937,'[{90,1},{7,2},{2,3},{1,5}]',3373,71240,'[{1,2192},{3,1096}]'),(3,238,'[{3,0,148245}]',942,'[{90,1},{7,2},{2,3},{1,5}]',3389,71760,'[{1,2208},{3,1104}]'),(3,239,'[{3,0,154408}]',946,'[{90,1},{7,2},{2,3},{1,5}]',3405,72280,'[{1,2224},{3,1112}]'),(3,240,'[{3,0,160570}]',950,'[{90,1},{7,2},{2,3},{1,5}]',3420,72800,'[{1,2240},{3,1120}]'),(3,241,'[{3,0,166732}]',955,'[{90,1},{7,2},{2,3},{1,5}]',3436,73320,'[{1,2256},{3,1128}]'),(3,242,'[{3,0,172894}]',959,'[{90,1},{7,2},{2,3},{1,5}]',3452,73840,'[{1,2272},{3,1136}]'),(3,243,'[{3,0,179057}]',964,'[{90,1},{7,2},{2,3},{1,5}]',3468,74360,'[{1,2288},{3,1144}]'),(3,244,'[{3,0,185219}]',968,'[{90,1},{7,2},{2,3},{1,5}]',3484,74880,'[{1,2304},{3,1152}]'),(3,245,'[{3,0,191381}]',972,'[{90,1},{7,2},{2,3},{1,5}]',3499,75400,'[{1,2320},{3,1160}]'),(3,246,'[{3,0,197543}]',977,'[{90,1},{7,2},{2,3},{1,5}]',3515,75920,'[{1,2336},{3,1168}]'),(3,247,'[{3,0,203705}]',981,'[{90,1},{7,2},{2,3},{1,5}]',3531,76440,'[{1,2352},{3,1176}]'),(3,248,'[{3,0,209868}]',986,'[{90,1},{7,2},{2,3},{1,5}]',3547,76960,'[{1,2368},{3,1184}]'),(3,249,'[{3,0,222203}]',1018,'[{90,1},{7,2},{2,3},{1,5}]',3563,77480,'[{1,2384},{3,1192}]'),(3,250,'[{3,0,228297}]',1023,'[{90,1},{7,2},{2,3},{1,5}]',3579,78000,'[{1,2400},{3,1200}]'),(3,251,'[{3,0,234391}]',1028,'[{90,1},{7,2},{2,3},{1,5}]',3595,78520,'[{1,2416},{3,1208}]'),(3,252,'[{3,0,240485}]',1032,'[{90,1},{7,2},{2,3},{1,5}]',3610,79040,'[{1,2432},{3,1216}]'),(3,253,'[{3,0,246579}]',1036,'[{90,1},{7,2},{2,3},{1,5}]',3626,79560,'[{1,2448},{3,1224}]'),(3,254,'[{3,0,252673}]',1041,'[{90,1},{7,2},{2,3},{1,5}]',3642,80080,'[{1,2464},{3,1232}]'),(3,255,'[{3,0,258767}]',1046,'[{90,1},{7,2},{2,3},{1,5}]',3658,80600,'[{1,2480},{3,1240}]'),(3,256,'[{3,0,264861}]',1050,'[{90,1},{7,2},{2,3},{1,5}]',3674,81120,'[{1,2496},{3,1248}]'),(3,257,'[{3,0,270955}]',1055,'[{90,1},{7,2},{2,3},{1,5}]',3690,81640,'[{1,2512},{3,1256}]'),(3,258,'[{3,0,277049}]',1059,'[{90,1},{7,2},{2,3},{1,5}]',3706,82160,'[{1,2528},{3,1264}]'),(3,259,'[{3,0,283143}]',1064,'[{90,1},{7,2},{2,3},{1,5}]',3722,82680,'[{1,2544},{3,1272}]'),(3,260,'[{3,0,289237}]',1068,'[{90,1},{7,2},{2,3},{1,5}]',3738,83200,'[{1,2560},{3,1280}]'),(3,261,'[{3,0,295331}]',1073,'[{90,1},{7,2},{2,3},{1,5}]',3754,83720,'[{1,2576},{3,1288}]'),(3,262,'[{3,0,301425}]',1078,'[{90,1},{7,2},{2,3},{1,5}]',3770,84240,'[{1,2592},{3,1296}]'),(3,263,'[{3,0,307519}]',1082,'[{90,1},{7,2},{2,3},{1,5}]',3786,84760,'[{1,2608},{3,1304}]'),(3,264,'[{3,0,313613}]',1087,'[{90,1},{7,2},{2,3},{1,5}]',3802,85280,'[{1,2624},{3,1312}]'),(3,265,'[{3,0,319707}]',1091,'[{90,1},{7,2},{2,3},{1,5}]',3818,85800,'[{1,2640},{3,1320}]'),(3,266,'[{3,0,325801}]',1096,'[{90,1},{7,2},{2,3},{1,5}]',3834,86320,'[{1,2656},{3,1328}]'),(3,267,'[{3,0,331895}]',1100,'[{90,1},{7,2},{2,3},{1,5}]',3850,86840,'[{1,2672},{3,1336}]'),(3,268,'[{3,0,337989}]',1105,'[{90,1},{7,2},{2,3},{1,5}]',3866,87360,'[{1,2688},{3,1344}]'),(3,269,'[{3,0,344083}]',1110,'[{90,1},{7,2},{2,3},{1,5}]',3882,87880,'[{1,2704},{3,1352}]'),(3,270,'[{3,0,350177}]',1114,'[{90,1},{7,2},{2,3},{1,5}]',3898,88400,'[{1,2720},{3,1360}]'),(3,271,'[{3,0,356271}]',1119,'[{90,1},{7,2},{2,3},{1,5}]',3914,88920,'[{1,2736},{3,1368}]'),(3,272,'[{3,0,362365}]',1123,'[{90,1},{7,2},{2,3},{1,5}]',3930,89440,'[{1,2752},{3,1376}]'),(3,273,'[{3,0,368459}]',1128,'[{90,1},{7,2},{2,3},{1,5}]',3946,89960,'[{1,2768},{3,1384}]'),(3,274,'[{3,0,374550}]',1132,'[{90,1},{7,2},{2,3},{1,5}]',3962,90480,'[{1,2784},{3,1392}]'),(3,275,'[{3,0,381734}]',1137,'[{90,1},{7,2},{2,3},{1,5}]',3978,91000,'[{1,2800},{3,1400}]'),(3,276,'[{3,0,388919}]',1142,'[{90,1},{7,2},{2,3},{1,5}]',3994,91520,'[{1,2816},{3,1408}]'),(3,277,'[{3,0,396104}]',1146,'[{90,1},{7,2},{2,3},{1,5}]',4010,92040,'[{1,2832},{3,1416}]'),(3,278,'[{3,0,403288}]',1151,'[{90,1},{7,2},{2,3},{1,5}]',4026,92560,'[{1,2848},{3,1424}]'),(3,279,'[{3,0,410473}]',1155,'[{90,1},{7,2},{2,3},{1,5}]',4042,93080,'[{1,2864},{3,1432}]'),(3,280,'[{3,0,417657}]',1160,'[{90,1},{7,2},{2,3},{1,5}]',4059,93600,'[{1,2880},{3,1440}]'),(3,281,'[{3,0,424842}]',1165,'[{90,1},{7,2},{2,3},{1,5}]',4075,94120,'[{1,2896},{3,1448}]'),(3,282,'[{3,0,432026}]',1169,'[{90,1},{7,2},{2,3},{1,5}]',4091,94640,'[{1,2912},{3,1456}]'),(3,283,'[{3,0,439211}]',1174,'[{90,1},{7,2},{2,3},{1,5}]',4107,95160,'[{1,2928},{3,1464}]'),(3,284,'[{3,0,446396}]',1178,'[{90,1},{7,2},{2,3},{1,5}]',4123,95680,'[{1,2944},{3,1472}]'),(3,285,'[{3,0,453580}]',1183,'[{90,1},{7,2},{2,3},{1,5}]',4139,96200,'[{1,2960},{3,1480}]'),(3,286,'[{3,0,460765}]',1188,'[{90,1},{7,2},{2,3},{1,5}]',4155,96720,'[{1,2976},{3,1488}]'),(3,287,'[{3,0,467949}]',1192,'[{90,1},{7,2},{2,3},{1,5}]',4172,97240,'[{1,2992},{3,1496}]'),(3,288,'[{3,0,475134}]',1197,'[{90,1},{7,2},{2,3},{1,5}]',4188,97760,'[{1,3008},{3,1504}]'),(3,289,'[{3,0,482318}]',1202,'[{90,1},{7,2},{2,3},{1,5}]',4204,98280,'[{1,3024},{3,1512}]'),(3,290,'[{3,0,489503}]',1206,'[{90,1},{7,2},{2,3},{1,5}]',4220,98800,'[{1,3040},{3,1520}]'),(3,291,'[{3,0,496688}]',1211,'[{90,1},{7,2},{2,3},{1,5}]',4236,99320,'[{1,3056},{3,1528}]'),(3,292,'[{3,0,503872}]',1216,'[{90,1},{7,2},{2,3},{1,5}]',4253,99840,'[{1,3072},{3,1536}]'),(3,293,'[{3,0,511057}]',1220,'[{90,1},{7,2},{2,3},{1,5}]',4269,100360,'[{1,3088},{3,1544}]'),(3,294,'[{3,0,518241}]',1225,'[{90,1},{7,2},{2,3},{1,5}]',4285,100880,'[{1,3104},{3,1552}]'),(3,295,'[{3,0,525426}]',1229,'[{90,1},{7,2},{2,3},{1,5}]',4301,101400,'[{1,3120},{3,1560}]'),(3,296,'[{3,0,532610}]',1234,'[{90,1},{7,2},{2,3},{1,5}]',4317,101920,'[{1,3136},{3,1568}]'),(3,297,'[{3,0,539795}]',1239,'[{90,1},{7,2},{2,3},{1,5}]',4334,102440,'[{1,3152},{3,1576}]'),(3,298,'[{3,0,546980}]',1243,'[{90,1},{7,2},{2,3},{1,5}]',4350,102960,'[{1,3168},{3,1584}]'),(3,299,'[{3,0,570466}]',1285,'[{90,1},{7,2},{2,3},{1,5}]',4366,103480,'[{1,3184},{3,1592}]'),(3,300,'[{3,0,581815}]',1289,'[{90,1},{7,2},{2,3},{1,5}]',4382,104000,'[{1,3200},{3,1600}]'),(3,301,'[{3,0,593165}]',1294,'[{90,1},{7,2},{2,3},{1,5}]',4399,104780,'[{1,3224},{3,1612}]'),(3,302,'[{3,0,604515}]',1299,'[{90,1},{7,2},{2,3},{1,5}]',4415,105560,'[{1,3248},{3,1624}]'),(3,303,'[{3,0,615865}]',1304,'[{90,1},{7,2},{2,3},{1,5}]',4431,106340,'[{1,3272},{3,1636}]'),(3,304,'[{3,0,627214}]',1309,'[{90,1},{7,2},{2,3},{1,5}]',4448,107120,'[{1,3296},{3,1648}]'),(3,305,'[{3,0,638564}]',1313,'[{90,1},{7,2},{2,3},{1,5}]',4464,107900,'[{1,3320},{3,1660}]'),(3,306,'[{3,0,649914}]',1318,'[{90,1},{7,2},{2,3},{1,5}]',4480,108680,'[{1,3344},{3,1672}]'),(3,307,'[{3,0,661263}]',1323,'[{90,1},{7,2},{2,3},{1,5}]',4497,109460,'[{1,3368},{3,1684}]'),(3,308,'[{3,0,672613}]',1328,'[{90,1},{7,2},{2,3},{1,5}]',4513,110240,'[{1,3392},{3,1696}]'),(3,309,'[{3,0,683963}]',1333,'[{90,1},{7,2},{2,3},{1,5}]',4529,111020,'[{1,3416},{3,1708}]'),(3,310,'[{3,0,695313}]',1338,'[{90,1},{7,2},{2,3},{1,5}]',4546,111800,'[{1,3440},{3,1720}]'),(3,311,'[{3,0,706662}]',1342,'[{90,1},{7,2},{2,3},{1,5}]',4562,112580,'[{1,3464},{3,1732}]'),(3,312,'[{3,0,718012}]',1347,'[{90,1},{7,2},{2,3},{1,5}]',4578,113360,'[{1,3488},{3,1744}]'),(3,313,'[{3,0,729362}]',1352,'[{90,1},{7,2},{2,3},{1,5}]',4595,114140,'[{1,3512},{3,1756}]'),(3,314,'[{3,0,740711}]',1357,'[{90,1},{7,2},{2,3},{1,5}]',4611,114920,'[{1,3536},{3,1768}]'),(3,315,'[{3,0,752061}]',1361,'[{90,1},{7,2},{2,3},{1,5}]',4627,115700,'[{1,3560},{3,1780}]'),(3,316,'[{3,0,763411}]',1366,'[{90,1},{7,2},{2,3},{1,5}]',4644,116480,'[{1,3584},{3,1792}]'),(3,317,'[{3,0,774760}]',1371,'[{90,1},{7,2},{2,3},{1,5}]',4660,117260,'[{1,3608},{3,1804}]'),(3,318,'[{3,0,786110}]',1376,'[{90,1},{7,2},{2,3},{1,5}]',4677,118040,'[{1,3632},{3,1816}]'),(3,319,'[{3,0,797460}]',1381,'[{90,1},{7,2},{2,3},{1,5}]',4693,118820,'[{1,3656},{3,1828}]'),(3,320,'[{3,0,808810}]',1385,'[{90,1},{7,2},{2,3},{1,5}]',4709,119600,'[{1,3680},{3,1840}]'),(3,321,'[{3,0,820159}]',1390,'[{90,1},{7,2},{2,3},{1,5}]',4726,120380,'[{1,3704},{3,1852}]'),(3,322,'[{3,0,831509}]',1395,'[{90,1},{7,2},{2,3},{1,5}]',4742,121160,'[{1,3728},{3,1864}]'),(3,323,'[{3,0,842859}]',1400,'[{90,1},{7,2},{2,3},{1,5}]',4759,121940,'[{1,3752},{3,1876}]'),(3,324,'[{3,0,854205}]',1405,'[{90,1},{7,2},{2,3},{1,5}]',4775,122720,'[{1,3776},{3,1888}]'),(3,325,'[{3,0,869085}]',1410,'[{90,1},{7,2},{2,3},{1,5}]',4792,123500,'[{1,3800},{3,1900}]'),(3,326,'[{3,0,883965}]',1415,'[{90,1},{7,2},{2,3},{1,5}]',4808,124280,'[{1,3824},{3,1912}]'),(3,327,'[{3,0,898846}]',1420,'[{90,1},{7,2},{2,3},{1,5}]',4825,125060,'[{1,3848},{3,1924}]'),(3,328,'[{3,0,913726}]',1424,'[{90,1},{7,2},{2,3},{1,5}]',4841,125840,'[{1,3872},{3,1936}]'),(3,329,'[{3,0,928606}]',1429,'[{90,1},{7,2},{2,3},{1,5}]',4857,126620,'[{1,3896},{3,1948}]'),(3,330,'[{3,0,943487}]',1434,'[{90,1},{7,2},{2,3},{1,5}]',4874,127400,'[{1,3920},{3,1960}]'),(3,331,'[{3,0,958367}]',1439,'[{90,1},{7,2},{2,3},{1,5}]',4890,128180,'[{1,3944},{3,1972}]'),(3,332,'[{3,0,973247}]',1444,'[{90,1},{7,2},{2,3},{1,5}]',4907,128960,'[{1,3968},{3,1984}]'),(3,333,'[{3,0,988128}]',1448,'[{90,1},{7,2},{2,3},{1,5}]',4923,129740,'[{1,3992},{3,1996}]'),(3,334,'[{3,0,1003008}]',1453,'[{90,1},{7,2},{2,3},{1,5}]',4940,130520,'[{1,4016},{3,2008}]'),(3,335,'[{3,0,1017888}]',1458,'[{90,1},{7,2},{2,3},{1,5}]',4956,131300,'[{1,4040},{3,2020}]'),(3,336,'[{3,0,1032768}]',1463,'[{90,1},{7,2},{2,3},{1,5}]',4973,132080,'[{1,4064},{3,2032}]'),(3,337,'[{3,0,1047649}]',1468,'[{90,1},{7,2},{2,3},{1,5}]',4990,132860,'[{1,4088},{3,2044}]'),(3,338,'[{3,0,1062529}]',1473,'[{90,1},{7,2},{2,3},{1,5}]',5006,133640,'[{1,4112},{3,2056}]'),(3,339,'[{3,0,1077409}]',1478,'[{90,1},{7,2},{2,3},{1,5}]',5023,134420,'[{1,4136},{3,2068}]'),(3,340,'[{3,0,1092290}]',1483,'[{90,1},{7,2},{2,3},{1,5}]',5039,135200,'[{1,4160},{3,2080}]'),(3,341,'[{3,0,1107170}]',1488,'[{90,1},{7,2},{2,3},{1,5}]',5056,135980,'[{1,4184},{3,2092}]'),(3,342,'[{3,0,1122050}]',1492,'[{90,1},{7,2},{2,3},{1,5}]',5072,136760,'[{1,4208},{3,2104}]'),(3,343,'[{3,0,1136930}]',1497,'[{90,1},{7,2},{2,3},{1,5}]',5089,137540,'[{1,4232},{3,2116}]'),(3,344,'[{3,0,1151811}]',1502,'[{90,1},{7,2},{2,3},{1,5}]',5105,138320,'[{1,4256},{3,2128}]'),(3,345,'[{3,0,1166691}]',1507,'[{90,1},{7,2},{2,3},{1,5}]',5122,139100,'[{1,4280},{3,2140}]'),(3,346,'[{3,0,1181571}]',1512,'[{90,1},{7,2},{2,3},{1,5}]',5139,139880,'[{1,4304},{3,2152}]'),(3,347,'[{3,0,1196452}]',1517,'[{90,1},{7,2},{2,3},{1,5}]',5155,140660,'[{1,4328},{3,2164}]'),(3,348,'[{3,0,1211332}]',1522,'[{90,1},{7,2},{2,3},{1,5}]',5172,141440,'[{1,4352},{3,2176}]'),(3,349,'[{3,0,1263370}]',1573,'[{90,1},{7,2},{2,3},{1,5}]',5188,142220,'[{1,4376},{3,2188}]'),(3,350,'[{3,0,1279417}]',1578,'[{90,1},{7,2},{2,3},{1,5}]',5205,143000,'[{1,4400},{3,2200}]'),(3,351,'[{3,0,1295463}]',1583,'[{90,1},{7,2},{2,3},{1,5}]',5222,143780,'[{1,4424},{3,2212}]'),(3,352,'[{3,0,1311509}]',1588,'[{90,1},{7,2},{2,3},{1,5}]',5238,144560,'[{1,4448},{3,2224}]'),(3,353,'[{3,0,1327556}]',1593,'[{90,1},{7,2},{2,3},{1,5}]',5255,145340,'[{1,4472},{3,2236}]'),(3,354,'[{3,0,1343602}]',1598,'[{90,1},{7,2},{2,3},{1,5}]',5272,146120,'[{1,4496},{3,2248}]'),(3,355,'[{3,0,1359648}]',1603,'[{90,1},{7,2},{2,3},{1,5}]',5288,146900,'[{1,4520},{3,2260}]'),(3,356,'[{3,0,1375695}]',1608,'[{90,1},{7,2},{2,3},{1,5}]',5305,147680,'[{1,4544},{3,2272}]'),(3,357,'[{3,0,1391741}]',1613,'[{90,1},{7,2},{2,3},{1,5}]',5322,148460,'[{1,4568},{3,2284}]'),(3,358,'[{3,0,1407787}]',1618,'[{90,1},{7,2},{2,3},{1,5}]',5338,149240,'[{1,4592},{3,2296}]'),(3,359,'[{3,0,1423834}]',1623,'[{90,1},{7,2},{2,3},{1,5}]',5355,150020,'[{1,4616},{3,2308}]'),(3,360,'[{3,0,1439880}]',1628,'[{90,1},{7,2},{2,3},{1,5}]',5372,150800,'[{1,4640},{3,2320}]'),(3,361,'[{3,0,1455927}]',1633,'[{90,1},{7,2},{2,3},{1,5}]',5388,151580,'[{1,4664},{3,2332}]'),(3,362,'[{3,0,1471973}]',1638,'[{90,1},{7,2},{2,3},{1,5}]',5405,152360,'[{1,4688},{3,2344}]'),(3,363,'[{3,0,1488019}]',1644,'[{90,1},{7,2},{2,3},{1,5}]',5422,153140,'[{1,4712},{3,2356}]'),(3,364,'[{3,0,1504066}]',1648,'[{90,1},{7,2},{2,3},{1,5}]',5438,153920,'[{1,4736},{3,2368}]'),(3,365,'[{3,0,1520112}]',1654,'[{90,1},{7,2},{2,3},{1,5}]',5455,154700,'[{1,4760},{3,2380}]'),(3,366,'[{3,0,1536158}]',1659,'[{90,1},{7,2},{2,3},{1,5}]',5472,155480,'[{1,4784},{3,2392}]'),(3,367,'[{3,0,1552205}]',1664,'[{90,1},{7,2},{2,3},{1,5}]',5489,156260,'[{1,4808},{3,2404}]'),(3,368,'[{3,0,1568251}]',1669,'[{90,1},{7,2},{2,3},{1,5}]',5505,157040,'[{1,4832},{3,2416}]'),(3,369,'[{3,0,1584297}]',1674,'[{90,1},{7,2},{2,3},{1,5}]',5522,157820,'[{1,4856},{3,2428}]'),(3,370,'[{3,0,1600344}]',1679,'[{90,1},{7,2},{2,3},{1,5}]',5539,158600,'[{1,4880},{3,2440}]'),(3,371,'[{3,0,1616390}]',1684,'[{90,1},{7,2},{2,3},{1,5}]',5556,159380,'[{1,4904},{3,2452}]'),(3,372,'[{3,0,1632437}]',1689,'[{90,1},{7,2},{2,3},{1,5}]',5572,160160,'[{1,4928},{3,2464}]'),(3,373,'[{3,0,1648483}]',1694,'[{90,1},{7,2},{2,3},{1,5}]',5589,160940,'[{1,4952},{3,2476}]'),(3,374,'[{3,0,1664530}]',1699,'[{90,1},{7,2},{2,3},{1,5}]',5606,161720,'[{1,4976},{3,2488}]'),(3,375,'[{3,0,1679756}]',1704,'[{90,1},{7,2},{2,3},{1,5}]',5623,162500,'[{1,5000},{3,2500}]'),(3,376,'[{3,0,1694982}]',1710,'[{90,1},{7,2},{2,3},{1,5}]',5640,163280,'[{1,5024},{3,2512}]'),(3,377,'[{3,0,1710209}]',1714,'[{90,1},{7,2},{2,3},{1,5}]',5656,164060,'[{1,5048},{3,2524}]'),(3,378,'[{3,0,1725435}]',1720,'[{90,1},{7,2},{2,3},{1,5}]',5673,164840,'[{1,5072},{3,2536}]'),(3,379,'[{3,0,1740661}]',1725,'[{90,1},{7,2},{2,3},{1,5}]',5690,165620,'[{1,5096},{3,2548}]'),(3,380,'[{3,0,1755888}]',1730,'[{90,1},{7,2},{2,3},{1,5}]',5707,166400,'[{1,5120},{3,2560}]'),(3,381,'[{3,0,1771114}]',1735,'[{90,1},{7,2},{2,3},{1,5}]',5724,167180,'[{1,5144},{3,2572}]'),(3,382,'[{3,0,1786340}]',1740,'[{90,1},{7,2},{2,3},{1,5}]',5740,167960,'[{1,5168},{3,2584}]'),(3,383,'[{3,0,1801567}]',1745,'[{90,1},{7,2},{2,3},{1,5}]',5757,168740,'[{1,5192},{3,2596}]'),(3,384,'[{3,0,1816793}]',1750,'[{90,1},{7,2},{2,3},{1,5}]',5774,169520,'[{1,5216},{3,2608}]'),(3,385,'[{3,0,1832020}]',1755,'[{90,1},{7,2},{2,3},{1,5}]',5791,170300,'[{1,5240},{3,2620}]'),(3,386,'[{3,0,1847246}]',1760,'[{90,1},{7,2},{2,3},{1,5}]',5808,171080,'[{1,5264},{3,2632}]'),(3,387,'[{3,0,1862472}]',1766,'[{90,1},{7,2},{2,3},{1,5}]',5825,171860,'[{1,5288},{3,2644}]'),(3,388,'[{3,0,1877699}]',1770,'[{90,1},{7,2},{2,3},{1,5}]',5841,172640,'[{1,5312},{3,2656}]'),(3,389,'[{3,0,1892925}]',1776,'[{90,1},{7,2},{2,3},{1,5}]',5858,173420,'[{1,5336},{3,2668}]'),(3,390,'[{3,0,1908151}]',1781,'[{90,1},{7,2},{2,3},{1,5}]',5875,174200,'[{1,5360},{3,2680}]'),(3,391,'[{3,0,1923378}]',1786,'[{90,1},{7,2},{2,3},{1,5}]',5892,174980,'[{1,5384},{3,2692}]'),(3,392,'[{3,0,1938604}]',1791,'[{90,1},{7,2},{2,3},{1,5}]',5909,175760,'[{1,5408},{3,2704}]'),(3,393,'[{3,0,1953830}]',1796,'[{90,1},{7,2},{2,3},{1,5}]',5926,176540,'[{1,5432},{3,2716}]'),(3,394,'[{3,0,1969057}]',1801,'[{90,1},{7,2},{2,3},{1,5}]',5943,177320,'[{1,5456},{3,2728}]'),(3,395,'[{3,0,1984283}]',1807,'[{90,1},{7,2},{2,3},{1,5}]',5960,178100,'[{1,5480},{3,2740}]'),(3,396,'[{3,0,1999510}]',1812,'[{90,1},{7,2},{2,3},{1,5}]',5977,178880,'[{1,5504},{3,2752}]'),(3,397,'[{3,0,2014736}]',1817,'[{90,1},{7,2},{2,3},{1,5}]',5993,179660,'[{1,5528},{3,2764}]'),(3,398,'[{3,0,2029962}]',1822,'[{90,1},{7,2},{2,3},{1,5}]',6010,180440,'[{1,5552},{3,2776}]'),(3,399,'[{3,0,2109102}]',1884,'[{90,1},{7,2},{2,3},{1,5}]',6027,181220,'[{1,5576},{3,2788}]'),(3,400,'[{3,0,2133037}]',1889,'[{90,1},{7,2},{2,3},{1,5}]',6044,182000,'[{1,5600},{3,2800}]'),(3,401,'[{3,0,2156972}]',1895,'[{90,1},{7,2},{2,3},{1,5}]',6061,183040,'[{1,5632},{3,2816}]'),(3,402,'[{3,0,2180907}]',1900,'[{90,1},{7,2},{2,3},{1,5}]',6078,184080,'[{1,5664},{3,2832}]'),(3,403,'[{3,0,2204842}]',1905,'[{90,1},{7,2},{2,3},{1,5}]',6095,185120,'[{1,5696},{3,2848}]'),(3,404,'[{3,0,2228777}]',1910,'[{90,1},{7,2},{2,3},{1,5}]',6112,186160,'[{1,5728},{3,2864}]'),(3,405,'[{3,0,2252712}]',1916,'[{90,1},{7,2},{2,3},{1,5}]',6129,187200,'[{1,5760},{3,2880}]'),(3,406,'[{3,0,2276647}]',1921,'[{90,1},{7,2},{2,3},{1,5}]',6146,188240,'[{1,5792},{3,2896}]'),(3,407,'[{3,0,2300582}]',1926,'[{90,1},{7,2},{2,3},{1,5}]',6163,189280,'[{1,5824},{3,2912}]'),(3,408,'[{3,0,2324517}]',1932,'[{90,1},{7,2},{2,3},{1,5}]',6180,190320,'[{1,5856},{3,2928}]'),(3,409,'[{3,0,2348452}]',1937,'[{90,1},{7,2},{2,3},{1,5}]',6197,191360,'[{1,5888},{3,2944}]'),(3,410,'[{3,0,2372387}]',1942,'[{90,1},{7,2},{2,3},{1,5}]',6214,192400,'[{1,5920},{3,2960}]'),(3,411,'[{3,0,2396322}]',1948,'[{90,1},{7,2},{2,3},{1,5}]',6231,193440,'[{1,5952},{3,2976}]'),(3,412,'[{3,0,2420257}]',1953,'[{90,1},{7,2},{2,3},{1,5}]',6248,194480,'[{1,5984},{3,2992}]'),(3,413,'[{3,0,2444192}]',1958,'[{90,1},{7,2},{2,3},{1,5}]',6265,195520,'[{1,6016},{3,3008}]'),(3,414,'[{3,0,2468127}]',1964,'[{90,1},{7,2},{2,3},{1,5}]',6282,196560,'[{1,6048},{3,3024}]'),(3,415,'[{3,0,2492062}]',1969,'[{90,1},{7,2},{2,3},{1,5}]',6299,197600,'[{1,6080},{3,3040}]'),(3,416,'[{3,0,2515997}]',1974,'[{90,1},{7,2},{2,3},{1,5}]',6316,198640,'[{1,6112},{3,3056}]'),(3,417,'[{3,0,2539932}]',1980,'[{90,1},{7,2},{2,3},{1,5}]',6333,199680,'[{1,6144},{3,3072}]'),(3,418,'[{3,0,2563867}]',1985,'[{90,1},{7,2},{2,3},{1,5}]',6350,200720,'[{1,6176},{3,3088}]'),(3,419,'[{3,0,2587802}]',1990,'[{90,1},{7,2},{2,3},{1,5}]',6367,201760,'[{1,6208},{3,3104}]'),(3,420,'[{3,0,2611737}]',1995,'[{90,1},{7,2},{2,3},{1,5}]',6384,202800,'[{1,6240},{3,3120}]'),(3,421,'[{3,0,2635672}]',2001,'[{90,1},{7,2},{2,3},{1,5}]',6401,203840,'[{1,6272},{3,3136}]'),(3,422,'[{3,0,2659607}]',2006,'[{90,1},{7,2},{2,3},{1,5}]',6418,204880,'[{1,6304},{3,3152}]'),(3,423,'[{3,0,2683542}]',2011,'[{90,1},{7,2},{2,3},{1,5}]',6435,205920,'[{1,6336},{3,3168}]'),(3,424,'[{3,0,2707479}]',2017,'[{90,1},{7,2},{2,3},{1,5}]',6452,206960,'[{1,6368},{3,3184}]'),(3,425,'[{3,0,2730859}]',2022,'[{90,1},{7,2},{2,3},{1,5}]',6470,208000,'[{1,6400},{3,3200}]'),(3,426,'[{3,0,2754239}]',2028,'[{90,1},{7,2},{2,3},{1,5}]',6487,209040,'[{1,6432},{3,3216}]'),(3,427,'[{3,0,2777618}]',2033,'[{90,1},{7,2},{2,3},{1,5}]',6504,210080,'[{1,6464},{3,3232}]'),(3,428,'[{3,0,2800998}]',2038,'[{90,1},{7,2},{2,3},{1,5}]',6521,211120,'[{1,6496},{3,3248}]'),(3,429,'[{3,0,2824378}]',2044,'[{90,1},{7,2},{2,3},{1,5}]',6538,212160,'[{1,6528},{3,3264}]'),(3,430,'[{3,0,2847757}]',2049,'[{90,1},{7,2},{2,3},{1,5}]',6555,213200,'[{1,6560},{3,3280}]'),(3,431,'[{3,0,2871137}]',2054,'[{90,1},{7,2},{2,3},{1,5}]',6572,214240,'[{1,6592},{3,3296}]'),(3,432,'[{3,0,2894517}]',2060,'[{90,1},{7,2},{2,3},{1,5}]',6589,215280,'[{1,6624},{3,3312}]'),(3,433,'[{3,0,2917896}]',2065,'[{90,1},{7,2},{2,3},{1,5}]',6606,216320,'[{1,6656},{3,3328}]'),(3,434,'[{3,0,2941276}]',2070,'[{90,1},{7,2},{2,3},{1,5}]',6624,217360,'[{1,6688},{3,3344}]'),(3,435,'[{3,0,2964656}]',2076,'[{90,1},{7,2},{2,3},{1,5}]',6641,218400,'[{1,6720},{3,3360}]'),(3,436,'[{3,0,2988035}]',2081,'[{90,1},{7,2},{2,3},{1,5}]',6658,219440,'[{1,6752},{3,3376}]'),(3,437,'[{3,0,3011415}]',2086,'[{90,1},{7,2},{2,3},{1,5}]',6675,220480,'[{1,6784},{3,3392}]'),(3,438,'[{3,0,3034795}]',2092,'[{90,1},{7,2},{2,3},{1,5}]',6692,221520,'[{1,6816},{3,3408}]'),(3,439,'[{3,0,3058175}]',2097,'[{90,1},{7,2},{2,3},{1,5}]',6709,222560,'[{1,6848},{3,3424}]'),(3,440,'[{3,0,3081554}]',2102,'[{90,1},{7,2},{2,3},{1,5}]',6726,223600,'[{1,6880},{3,3440}]'),(3,441,'[{3,0,3104934}]',2108,'[{90,1},{7,2},{2,3},{1,5}]',6744,224640,'[{1,6912},{3,3456}]'),(3,442,'[{3,0,3128314}]',2113,'[{90,1},{7,2},{2,3},{1,5}]',6761,225680,'[{1,6944},{3,3472}]'),(3,443,'[{3,0,3151693}]',2119,'[{90,1},{7,2},{2,3},{1,5}]',6778,226720,'[{1,6976},{3,3488}]'),(3,444,'[{3,0,3175073}]',2124,'[{90,1},{7,2},{2,3},{1,5}]',6795,227760,'[{1,7008},{3,3504}]'),(3,445,'[{3,0,3198453}]',2129,'[{90,1},{7,2},{2,3},{1,5}]',6812,228800,'[{1,7040},{3,3520}]'),(3,446,'[{3,0,3221832}]',2135,'[{90,1},{7,2},{2,3},{1,5}]',6830,229840,'[{1,7072},{3,3536}]'),(3,447,'[{3,0,3245212}]',2140,'[{90,1},{7,2},{2,3},{1,5}]',6847,230880,'[{1,7104},{3,3552}]'),(3,448,'[{3,0,3268592}]',2145,'[{90,1},{7,2},{2,3},{1,5}]',6864,231920,'[{1,7136},{3,3568}]'),(3,449,'[{3,0,3398166}]',2220,'[{90,1},{7,2},{2,3},{1,5}]',6881,232960,'[{1,7168},{3,3584}]'),(3,450,'[{3,0,3413589}]',2226,'[{90,1},{7,2},{2,3},{1,5}]',6898,234000,'[{1,7200},{3,3600}]'),(3,451,'[{3,0,3429011}]',2231,'[{90,1},{7,2},{2,3},{1,5}]',6916,235040,'[{1,7232},{3,3616}]'),(3,452,'[{3,0,3444434}]',2237,'[{90,1},{7,2},{2,3},{1,5}]',6933,236080,'[{1,7264},{3,3632}]'),(3,453,'[{3,0,3459856}]',2242,'[{90,1},{7,2},{2,3},{1,5}]',6950,237120,'[{1,7296},{3,3648}]'),(3,454,'[{3,0,3475279}]',2248,'[{90,1},{7,2},{2,3},{1,5}]',6967,238160,'[{1,7328},{3,3664}]'),(3,455,'[{3,0,3490701}]',2254,'[{90,1},{7,2},{2,3},{1,5}]',6985,239200,'[{1,7360},{3,3680}]'),(3,456,'[{3,0,3506124}]',2259,'[{90,1},{7,2},{2,3},{1,5}]',7002,240240,'[{1,7392},{3,3696}]'),(3,457,'[{3,0,3521547}]',2265,'[{90,1},{7,2},{2,3},{1,5}]',7019,241280,'[{1,7424},{3,3712}]'),(3,458,'[{3,0,3536969}]',2270,'[{90,1},{7,2},{2,3},{1,5}]',7036,242320,'[{1,7456},{3,3728}]'),(3,459,'[{3,0,3552392}]',2276,'[{90,1},{7,2},{2,3},{1,5}]',7054,243360,'[{1,7488},{3,3744}]'),(3,460,'[{3,0,3567814}]',2281,'[{90,1},{7,2},{2,3},{1,5}]',7071,244400,'[{1,7520},{3,3760}]'),(3,461,'[{3,0,3583237}]',2287,'[{90,1},{7,2},{2,3},{1,5}]',7088,245440,'[{1,7552},{3,3776}]'),(3,462,'[{3,0,3598660}]',2292,'[{90,1},{7,2},{2,3},{1,5}]',7105,246480,'[{1,7584},{3,3792}]'),(3,463,'[{3,0,3614082}]',2298,'[{90,1},{7,2},{2,3},{1,5}]',7123,247520,'[{1,7616},{3,3808}]'),(3,464,'[{3,0,3629505}]',2304,'[{90,1},{7,2},{2,3},{1,5}]',7140,248560,'[{1,7648},{3,3824}]'),(3,465,'[{3,0,3644927}]',2309,'[{90,1},{7,2},{2,3},{1,5}]',7157,249600,'[{1,7680},{3,3840}]'),(3,466,'[{3,0,3660350}]',2315,'[{90,1},{7,2},{2,3},{1,5}]',7175,250640,'[{1,7712},{3,3856}]'),(3,467,'[{3,0,3675772}]',2320,'[{90,1},{7,2},{2,3},{1,5}]',7192,251680,'[{1,7744},{3,3872}]'),(3,468,'[{3,0,3691195}]',2326,'[{90,1},{7,2},{2,3},{1,5}]',7209,252720,'[{1,7776},{3,3888}]'),(3,469,'[{3,0,3706618}]',2332,'[{90,1},{7,2},{2,3},{1,5}]',7227,253760,'[{1,7808},{3,3904}]'),(3,470,'[{3,0,3722040}]',2337,'[{90,1},{7,2},{2,3},{1,5}]',7244,254800,'[{1,7840},{3,3920}]'),(3,471,'[{3,0,3737463}]',2343,'[{90,1},{7,2},{2,3},{1,5}]',7261,255840,'[{1,7872},{3,3936}]'),(3,472,'[{3,0,3752885}]',2349,'[{90,1},{7,2},{2,3},{1,5}]',7279,256880,'[{1,7904},{3,3952}]'),(3,473,'[{3,0,3768308}]',2354,'[{90,1},{7,2},{2,3},{1,5}]',7296,257920,'[{1,7936},{3,3968}]'),(3,474,'[{3,0,3783732}]',2360,'[{90,1},{7,2},{2,3},{1,5}]',7313,258960,'[{1,7968},{3,3984}]'),(3,475,'[{3,0,3797544}]',2365,'[{90,1},{7,2},{2,3},{1,5}]',7331,260000,'[{1,8000},{3,4000}]'),(3,476,'[{3,0,3811356}]',2371,'[{90,1},{7,2},{2,3},{1,5}]',7348,261040,'[{1,8032},{3,4016}]'),(3,477,'[{3,0,3825168}]',2376,'[{90,1},{7,2},{2,3},{1,5}]',7365,262080,'[{1,8064},{3,4032}]'),(3,478,'[{3,0,3838980}]',2382,'[{90,1},{7,2},{2,3},{1,5}]',7383,263120,'[{1,8096},{3,4048}]'),(3,479,'[{3,0,3852791}]',2388,'[{90,1},{7,2},{2,3},{1,5}]',7400,264160,'[{1,8128},{3,4064}]'),(3,480,'[{3,0,3866603}]',2393,'[{90,1},{7,2},{2,3},{1,5}]',7417,265200,'[{1,8160},{3,4080}]'),(3,481,'[{3,0,3880415}]',2399,'[{90,1},{7,2},{2,3},{1,5}]',7435,266240,'[{1,8192},{3,4096}]'),(3,482,'[{3,0,3894227}]',2404,'[{90,1},{7,2},{2,3},{1,5}]',7452,267280,'[{1,8224},{3,4112}]'),(3,483,'[{3,0,3908039}]',2410,'[{90,1},{7,2},{2,3},{1,5}]',7470,268320,'[{1,8256},{3,4128}]'),(3,484,'[{3,0,3921851}]',2416,'[{90,1},{7,2},{2,3},{1,5}]',7487,269360,'[{1,8288},{3,4144}]'),(3,485,'[{3,0,3935663}]',2421,'[{90,1},{7,2},{2,3},{1,5}]',7504,270400,'[{1,8320},{3,4160}]'),(3,486,'[{3,0,3949475}]',2427,'[{90,1},{7,2},{2,3},{1,5}]',7522,271440,'[{1,8352},{3,4176}]'),(3,487,'[{3,0,3963287}]',2432,'[{90,1},{7,2},{2,3},{1,5}]',7539,272480,'[{1,8384},{3,4192}]'),(3,488,'[{3,0,3977099}]',2438,'[{90,1},{7,2},{2,3},{1,5}]',7557,273520,'[{1,8416},{3,4208}]'),(3,489,'[{3,0,3990911}]',2444,'[{90,1},{7,2},{2,3},{1,5}]',7574,274560,'[{1,8448},{3,4224}]'),(3,490,'[{3,0,4004723}]',2449,'[{90,1},{7,2},{2,3},{1,5}]',7591,275600,'[{1,8480},{3,4240}]'),(3,491,'[{3,0,4018535}]',2455,'[{90,1},{7,2},{2,3},{1,5}]',7609,276640,'[{1,8512},{3,4256}]'),(3,492,'[{3,0,4032347}]',2460,'[{90,1},{7,2},{2,3},{1,5}]',7626,277680,'[{1,8544},{3,4272}]'),(3,493,'[{3,0,4046159}]',2466,'[{90,1},{7,2},{2,3},{1,5}]',7644,278720,'[{1,8576},{3,4288}]'),(3,494,'[{3,0,4059970}]',2472,'[{90,1},{7,2},{2,3},{1,5}]',7661,279760,'[{1,8608},{3,4304}]'),(3,495,'[{3,0,4073782}]',2478,'[{90,1},{7,2},{2,3},{1,5}]',7679,280800,'[{1,8640},{3,4320}]'),(3,496,'[{3,0,4087594}]',2483,'[{90,1},{7,2},{2,3},{1,5}]',7696,281840,'[{1,8672},{3,4336}]'),(3,497,'[{3,0,4101406}]',2489,'[{90,1},{7,2},{2,3},{1,5}]',7714,282880,'[{1,8704},{3,4352}]'),(3,498,'[{3,0,4115218}]',2494,'[{90,1},{7,2},{2,3},{1,5}]',7731,283920,'[{1,8736},{3,4368}]'),(3,499,'[{3,0,4266667}]',2583,'[{90,1},{7,2},{2,3},{1,5}]',7749,284960,'[{1,8768},{3,4384}]'),(3,500,'[{3,0,0}]',0,'[{90,1},{7,2},{2,3},{1,5}]',0,286000,'[{1,8800},{3,4400}]'),(4,0,'[{3,0,668}]',15,'[{90,1},{7,2},{2,3},{1,5}]',58,0,'[{2,0},{4,0}]'),(4,1,'[{3,0,803}]',17,'[{90,1},{7,2},{2,3},{1,5}]',67,195,'[{2,120},{4,3}]'),(4,2,'[{3,0,937}]',19,'[{90,1},{7,2},{2,3},{1,5}]',76,390,'[{2,240},{4,6}]'),(4,3,'[{3,0,1071}]',22,'[{90,1},{7,2},{2,3},{1,5}]',86,585,'[{2,360},{4,9}]'),(4,4,'[{3,0,1205}]',24,'[{90,1},{7,2},{2,3},{1,5}]',96,780,'[{2,480},{4,12}]'),(4,5,'[{3,0,1340}]',27,'[{90,1},{7,2},{2,3},{1,5}]',106,975,'[{2,600},{4,15}]'),(4,6,'[{3,0,1474}]',29,'[{90,1},{7,2},{2,3},{1,5}]',116,1170,'[{2,720},{4,18}]'),(4,7,'[{3,0,1608}]',32,'[{90,1},{7,2},{2,3},{1,5}]',126,1365,'[{2,840},{4,21}]'),(4,8,'[{3,0,1742}]',35,'[{90,1},{7,2},{2,3},{1,5}]',137,1560,'[{2,960},{4,24}]'),(4,9,'[{3,0,1877}]',37,'[{90,1},{7,2},{2,3},{1,5}]',148,1755,'[{2,1080},{4,27}]'),(4,10,'[{3,0,2011}]',40,'[{90,1},{7,2},{2,3},{1,5}]',158,1950,'[{2,1200},{4,30}]'),(4,11,'[{3,0,2145}]',43,'[{90,1},{7,2},{2,3},{1,5}]',169,2145,'[{2,1320},{4,33}]'),(4,12,'[{3,0,2279}]',45,'[{90,1},{7,2},{2,3},{1,5}]',180,2340,'[{2,1440},{4,36}]'),(4,13,'[{3,0,2414}]',48,'[{90,1},{7,2},{2,3},{1,5}]',191,2535,'[{2,1560},{4,39}]'),(4,14,'[{3,0,2548}]',51,'[{90,1},{7,2},{2,3},{1,5}]',202,2730,'[{2,1680},{4,42}]'),(4,15,'[{3,0,2682}]',54,'[{90,1},{7,2},{2,3},{1,5}]',214,2925,'[{2,1800},{4,45}]'),(4,16,'[{3,0,2816}]',57,'[{90,1},{7,2},{2,3},{1,5}]',225,3120,'[{2,1920},{4,48}]'),(4,17,'[{3,0,2951}]',59,'[{90,1},{7,2},{2,3},{1,5}]',236,3315,'[{2,2040},{4,51}]'),(4,18,'[{3,0,3085}]',62,'[{90,1},{7,2},{2,3},{1,5}]',248,3510,'[{2,2160},{4,54}]'),(4,19,'[{3,0,3219}]',65,'[{90,1},{7,2},{2,3},{1,5}]',259,3705,'[{2,2280},{4,57}]'),(4,20,'[{3,0,3353}]',68,'[{90,1},{7,2},{2,3},{1,5}]',271,3900,'[{2,2400},{4,60}]'),(4,21,'[{3,0,3488}]',71,'[{90,1},{7,2},{2,3},{1,5}]',282,4095,'[{2,2520},{4,63}]'),(4,22,'[{3,0,3622}]',74,'[{90,1},{7,2},{2,3},{1,5}]',294,4290,'[{2,2640},{4,66}]'),(4,23,'[{3,0,3756}]',77,'[{90,1},{7,2},{2,3},{1,5}]',306,4485,'[{2,2760},{4,69}]'),(4,24,'[{3,0,3891}]',80,'[{90,1},{7,2},{2,3},{1,5}]',318,4680,'[{2,2880},{4,72}]'),(4,25,'[{3,0,4239}]',83,'[{90,1},{7,2},{2,3},{1,5}]',330,4875,'[{2,3000},{4,75}]'),(4,26,'[{3,0,4587}]',86,'[{90,1},{7,2},{2,3},{1,5}]',342,5070,'[{2,3120},{4,78}]'),(4,27,'[{3,0,4936}]',89,'[{90,1},{7,2},{2,3},{1,5}]',354,5265,'[{2,3240},{4,81}]'),(4,28,'[{3,0,5284}]',92,'[{90,1},{7,2},{2,3},{1,5}]',366,5460,'[{2,3360},{4,84}]'),(4,29,'[{3,0,5632}]',95,'[{90,1},{7,2},{2,3},{1,5}]',378,5655,'[{2,3480},{4,87}]'),(4,30,'[{3,0,5980}]',98,'[{90,1},{7,2},{2,3},{1,5}]',390,5850,'[{2,3600},{4,90}]'),(4,31,'[{3,0,6329}]',101,'[{90,1},{7,2},{2,3},{1,5}]',402,6045,'[{2,3720},{4,93}]'),(4,32,'[{3,0,6677}]',104,'[{90,1},{7,2},{2,3},{1,5}]',414,6240,'[{2,3840},{4,96}]'),(4,33,'[{3,0,7025}]',107,'[{90,1},{7,2},{2,3},{1,5}]',426,6435,'[{2,3960},{4,99}]'),(4,34,'[{3,0,7373}]',110,'[{90,1},{7,2},{2,3},{1,5}]',439,6630,'[{2,4080},{4,102}]'),(4,35,'[{3,0,7722}]',113,'[{90,1},{7,2},{2,3},{1,5}]',451,6825,'[{2,4200},{4,105}]'),(4,36,'[{3,0,8070}]',116,'[{90,1},{7,2},{2,3},{1,5}]',464,7020,'[{2,4320},{4,108}]'),(4,37,'[{3,0,8418}]',119,'[{90,1},{7,2},{2,3},{1,5}]',476,7215,'[{2,4440},{4,111}]'),(4,38,'[{3,0,8766}]',122,'[{90,1},{7,2},{2,3},{1,5}]',488,7410,'[{2,4560},{4,114}]'),(4,39,'[{3,0,9115}]',126,'[{90,1},{7,2},{2,3},{1,5}]',501,7605,'[{2,4680},{4,117}]'),(4,40,'[{3,0,9463}]',129,'[{90,1},{7,2},{2,3},{1,5}]',514,7800,'[{2,4800},{4,120}]'),(4,41,'[{3,0,9811}]',132,'[{90,1},{7,2},{2,3},{1,5}]',526,7995,'[{2,4920},{4,123}]'),(4,42,'[{3,0,10159}]',135,'[{90,1},{7,2},{2,3},{1,5}]',539,8190,'[{2,5040},{4,126}]'),(4,43,'[{3,0,10508}]',138,'[{90,1},{7,2},{2,3},{1,5}]',551,8385,'[{2,5160},{4,129}]'),(4,44,'[{3,0,10856}]',141,'[{90,1},{7,2},{2,3},{1,5}]',564,8580,'[{2,5280},{4,132}]'),(4,45,'[{3,0,11204}]',145,'[{90,1},{7,2},{2,3},{1,5}]',577,8775,'[{2,5400},{4,135}]'),(4,46,'[{3,0,11552}]',148,'[{90,1},{7,2},{2,3},{1,5}]',590,8970,'[{2,5520},{4,138}]'),(4,47,'[{3,0,11901}]',151,'[{90,1},{7,2},{2,3},{1,5}]',602,9165,'[{2,5640},{4,141}]'),(4,48,'[{3,0,12249}]',154,'[{90,1},{7,2},{2,3},{1,5}]',615,9360,'[{2,5760},{4,144}]'),(4,49,'[{3,0,12923}]',162,'[{90,1},{7,2},{2,3},{1,5}]',628,9555,'[{2,5880},{4,147}]'),(4,50,'[{3,0,13425}]',165,'[{90,1},{7,2},{2,3},{1,5}]',641,9750,'[{2,6000},{4,150}]'),(4,51,'[{3,0,13927}]',168,'[{90,1},{7,2},{2,3},{1,5}]',654,9945,'[{2,6120},{4,153}]'),(4,52,'[{3,0,14429}]',172,'[{90,1},{7,2},{2,3},{1,5}]',667,10140,'[{2,6240},{4,156}]'),(4,53,'[{3,0,14931}]',175,'[{90,1},{7,2},{2,3},{1,5}]',680,10335,'[{2,6360},{4,159}]'),(4,54,'[{3,0,15433}]',178,'[{90,1},{7,2},{2,3},{1,5}]',693,10530,'[{2,6480},{4,162}]'),(4,55,'[{3,0,15935}]',182,'[{90,1},{7,2},{2,3},{1,5}]',706,10725,'[{2,6600},{4,165}]'),(4,56,'[{3,0,16437}]',185,'[{90,1},{7,2},{2,3},{1,5}]',719,10920,'[{2,6720},{4,168}]'),(4,57,'[{3,0,16939}]',188,'[{90,1},{7,2},{2,3},{1,5}]',732,11115,'[{2,6840},{4,171}]'),(4,58,'[{3,0,17442}]',192,'[{90,1},{7,2},{2,3},{1,5}]',745,11310,'[{2,6960},{4,174}]'),(4,59,'[{3,0,17944}]',195,'[{90,1},{7,2},{2,3},{1,5}]',758,11505,'[{2,7080},{4,177}]'),(4,60,'[{3,0,18446}]',198,'[{90,1},{7,2},{2,3},{1,5}]',771,11700,'[{2,7200},{4,180}]'),(4,61,'[{3,0,18948}]',202,'[{90,1},{7,2},{2,3},{1,5}]',785,11895,'[{2,7320},{4,183}]'),(4,62,'[{3,0,19450}]',205,'[{90,1},{7,2},{2,3},{1,5}]',798,12090,'[{2,7440},{4,186}]'),(4,63,'[{3,0,19952}]',208,'[{90,1},{7,2},{2,3},{1,5}]',811,12285,'[{2,7560},{4,189}]'),(4,64,'[{3,0,20454}]',212,'[{90,1},{7,2},{2,3},{1,5}]',824,12480,'[{2,7680},{4,192}]'),(4,65,'[{3,0,20956}]',215,'[{90,1},{7,2},{2,3},{1,5}]',838,12675,'[{2,7800},{4,195}]'),(4,66,'[{3,0,21458}]',219,'[{90,1},{7,2},{2,3},{1,5}]',851,12870,'[{2,7920},{4,198}]'),(4,67,'[{3,0,21960}]',222,'[{90,1},{7,2},{2,3},{1,5}]',864,13065,'[{2,8040},{4,201}]'),(4,68,'[{3,0,22462}]',226,'[{90,1},{7,2},{2,3},{1,5}]',878,13260,'[{2,8160},{4,204}]'),(4,69,'[{3,0,22964}]',229,'[{90,1},{7,2},{2,3},{1,5}]',891,13455,'[{2,8280},{4,207}]'),(4,70,'[{3,0,23466}]',233,'[{90,1},{7,2},{2,3},{1,5}]',905,13650,'[{2,8400},{4,210}]'),(4,71,'[{3,0,23968}]',236,'[{90,1},{7,2},{2,3},{1,5}]',918,13845,'[{2,8520},{4,213}]'),(4,72,'[{3,0,24470}]',239,'[{90,1},{7,2},{2,3},{1,5}]',932,14040,'[{2,8640},{4,216}]'),(4,73,'[{3,0,24972}]',243,'[{90,1},{7,2},{2,3},{1,5}]',945,14235,'[{2,8760},{4,219}]'),(4,74,'[{3,0,25472}]',246,'[{90,1},{7,2},{2,3},{1,5}]',959,14430,'[{2,8880},{4,222}]'),(4,75,'[{3,0,25627}]',250,'[{90,1},{7,2},{2,3},{1,5}]',972,14625,'[{2,9000},{4,225}]'),(4,76,'[{3,0,25783}]',253,'[{90,1},{7,2},{2,3},{1,5}]',986,14820,'[{2,9120},{4,228}]'),(4,77,'[{3,0,25938}]',257,'[{90,1},{7,2},{2,3},{1,5}]',999,15015,'[{2,9240},{4,231}]'),(4,78,'[{3,0,26094}]',260,'[{90,1},{7,2},{2,3},{1,5}]',1013,15210,'[{2,9360},{4,234}]'),(4,79,'[{3,0,26249}]',264,'[{90,1},{7,2},{2,3},{1,5}]',1027,15405,'[{2,9480},{4,237}]'),(4,80,'[{3,0,26404}]',267,'[{90,1},{7,2},{2,3},{1,5}]',1040,15600,'[{2,9600},{4,240}]'),(4,81,'[{3,0,26560}]',271,'[{90,1},{7,2},{2,3},{1,5}]',1054,15795,'[{2,9720},{4,243}]'),(4,82,'[{3,0,26715}]',274,'[{90,1},{7,2},{2,3},{1,5}]',1068,15990,'[{2,9840},{4,246}]'),(4,83,'[{3,0,26870}]',278,'[{90,1},{7,2},{2,3},{1,5}]',1081,16185,'[{2,9960},{4,249}]'),(4,84,'[{3,0,27026}]',281,'[{90,1},{7,2},{2,3},{1,5}]',1095,16380,'[{2,10080},{4,252}]'),(4,85,'[{3,0,27181}]',285,'[{90,1},{7,2},{2,3},{1,5}]',1109,16575,'[{2,10200},{4,255}]'),(4,86,'[{3,0,27337}]',288,'[{90,1},{7,2},{2,3},{1,5}]',1123,16770,'[{2,10320},{4,258}]'),(4,87,'[{3,0,27492}]',292,'[{90,1},{7,2},{2,3},{1,5}]',1136,16965,'[{2,10440},{4,261}]'),(4,88,'[{3,0,27647}]',295,'[{90,1},{7,2},{2,3},{1,5}]',1150,17160,'[{2,10560},{4,264}]'),(4,89,'[{3,0,27803}]',299,'[{90,1},{7,2},{2,3},{1,5}]',1164,17355,'[{2,10680},{4,267}]'),(4,90,'[{3,0,27958}]',303,'[{90,1},{7,2},{2,3},{1,5}]',1178,17550,'[{2,10800},{4,270}]'),(4,91,'[{3,0,28114}]',306,'[{90,1},{7,2},{2,3},{1,5}]',1192,17745,'[{2,10920},{4,273}]'),(4,92,'[{3,0,28269}]',310,'[{90,1},{7,2},{2,3},{1,5}]',1206,17940,'[{2,11040},{4,276}]'),(4,93,'[{3,0,28424}]',313,'[{90,1},{7,2},{2,3},{1,5}]',1220,18135,'[{2,11160},{4,279}]'),(4,94,'[{3,0,28580}]',317,'[{90,1},{7,2},{2,3},{1,5}]',1234,18330,'[{2,11280},{4,282}]'),(4,95,'[{3,0,28735}]',320,'[{90,1},{7,2},{2,3},{1,5}]',1248,18525,'[{2,11400},{4,285}]'),(4,96,'[{3,0,28890}]',324,'[{90,1},{7,2},{2,3},{1,5}]',1262,18720,'[{2,11520},{4,288}]'),(4,97,'[{3,0,29046}]',328,'[{90,1},{7,2},{2,3},{1,5}]',1276,18915,'[{2,11640},{4,291}]'),(4,98,'[{3,0,29201}]',331,'[{90,1},{7,2},{2,3},{1,5}]',1290,19110,'[{2,11760},{4,294}]'),(4,99,'[{3,0,30126}]',344,'[{90,1},{7,2},{2,3},{1,5}]',1304,19305,'[{2,11880},{4,297}]'),(4,100,'[{3,0,30194}]',347,'[{90,1},{7,2},{2,3},{1,5}]',1318,19500,'[{2,12000},{4,300}]'),(4,101,'[{3,0,30263}]',351,'[{90,1},{7,2},{2,3},{1,5}]',1332,19825,'[{2,12200},{4,305}]'),(4,102,'[{3,0,30331}]',355,'[{90,1},{7,2},{2,3},{1,5}]',1346,20150,'[{2,12400},{4,310}]'),(4,103,'[{3,0,30400}]',358,'[{90,1},{7,2},{2,3},{1,5}]',1360,20475,'[{2,12600},{4,315}]'),(4,104,'[{3,0,30468}]',362,'[{90,1},{7,2},{2,3},{1,5}]',1374,20800,'[{2,12800},{4,320}]'),(4,105,'[{3,0,30537}]',366,'[{90,1},{7,2},{2,3},{1,5}]',1388,21125,'[{2,13000},{4,325}]'),(4,106,'[{3,0,30605}]',369,'[{90,1},{7,2},{2,3},{1,5}]',1402,21450,'[{2,13200},{4,330}]'),(4,107,'[{3,0,30673}]',373,'[{90,1},{7,2},{2,3},{1,5}]',1416,21775,'[{2,13400},{4,335}]'),(4,108,'[{3,0,30742}]',377,'[{90,1},{7,2},{2,3},{1,5}]',1431,22100,'[{2,13600},{4,340}]'),(4,109,'[{3,0,30810}]',381,'[{90,1},{7,2},{2,3},{1,5}]',1445,22425,'[{2,13800},{4,345}]'),(4,110,'[{3,0,30879}]',384,'[{90,1},{7,2},{2,3},{1,5}]',1459,22750,'[{2,14000},{4,350}]'),(4,111,'[{3,0,30947}]',388,'[{90,1},{7,2},{2,3},{1,5}]',1473,23075,'[{2,14200},{4,355}]'),(4,112,'[{3,0,31015}]',392,'[{90,1},{7,2},{2,3},{1,5}]',1488,23400,'[{2,14400},{4,360}]'),(4,113,'[{3,0,31084}]',396,'[{90,1},{7,2},{2,3},{1,5}]',1502,23725,'[{2,14600},{4,365}]'),(4,114,'[{3,0,31152}]',399,'[{90,1},{7,2},{2,3},{1,5}]',1516,24050,'[{2,14800},{4,370}]'),(4,115,'[{3,0,31221}]',403,'[{90,1},{7,2},{2,3},{1,5}]',1530,24375,'[{2,15000},{4,375}]'),(4,116,'[{3,0,31289}]',407,'[{90,1},{7,2},{2,3},{1,5}]',1545,24700,'[{2,15200},{4,380}]'),(4,117,'[{3,0,31358}]',411,'[{90,1},{7,2},{2,3},{1,5}]',1559,25025,'[{2,15400},{4,385}]'),(4,118,'[{3,0,31426}]',414,'[{90,1},{7,2},{2,3},{1,5}]',1573,25350,'[{2,15600},{4,390}]'),(4,119,'[{3,0,31494}]',418,'[{90,1},{7,2},{2,3},{1,5}]',1588,25675,'[{2,15800},{4,395}]'),(4,120,'[{3,0,31563}]',422,'[{90,1},{7,2},{2,3},{1,5}]',1602,26000,'[{2,16000},{4,400}]'),(4,121,'[{3,0,31631}]',426,'[{90,1},{7,2},{2,3},{1,5}]',1617,26325,'[{2,16200},{4,405}]'),(4,122,'[{3,0,31700}]',430,'[{90,1},{7,2},{2,3},{1,5}]',1631,26650,'[{2,16400},{4,410}]'),(4,123,'[{3,0,31768}]',434,'[{90,1},{7,2},{2,3},{1,5}]',1646,26975,'[{2,16600},{4,415}]'),(4,124,'[{3,0,31837}]',437,'[{90,1},{7,2},{2,3},{1,5}]',1660,27300,'[{2,16800},{4,420}]'),(4,125,'[{3,0,32159}]',441,'[{90,1},{7,2},{2,3},{1,5}]',1674,27625,'[{2,17000},{4,425}]'),(4,126,'[{3,0,32481}]',445,'[{90,1},{7,2},{2,3},{1,5}]',1689,27950,'[{2,17200},{4,430}]'),(4,127,'[{3,0,32803}]',449,'[{90,1},{7,2},{2,3},{1,5}]',1703,28275,'[{2,17400},{4,435}]'),(4,128,'[{3,0,33125}]',453,'[{90,1},{7,2},{2,3},{1,5}]',1718,28600,'[{2,17600},{4,440}]'),(4,129,'[{3,0,33447}]',456,'[{90,1},{7,2},{2,3},{1,5}]',1732,28925,'[{2,17800},{4,445}]'),(4,130,'[{3,0,33769}]',460,'[{90,1},{7,2},{2,3},{1,5}]',1747,29250,'[{2,18000},{4,450}]'),(4,131,'[{3,0,34091}]',464,'[{90,1},{7,2},{2,3},{1,5}]',1762,29575,'[{2,18200},{4,455}]'),(4,132,'[{3,0,34413}]',468,'[{90,1},{7,2},{2,3},{1,5}]',1776,29900,'[{2,18400},{4,460}]'),(4,133,'[{3,0,34735}]',472,'[{90,1},{7,2},{2,3},{1,5}]',1791,30225,'[{2,18600},{4,465}]'),(4,134,'[{3,0,35058}]',475,'[{90,1},{7,2},{2,3},{1,5}]',1805,30550,'[{2,18800},{4,470}]'),(4,135,'[{3,0,35380}]',479,'[{90,1},{7,2},{2,3},{1,5}]',1820,30875,'[{2,19000},{4,475}]'),(4,136,'[{3,0,35702}]',483,'[{90,1},{7,2},{2,3},{1,5}]',1834,31200,'[{2,19200},{4,480}]'),(4,137,'[{3,0,36024}]',487,'[{90,1},{7,2},{2,3},{1,5}]',1849,31525,'[{2,19400},{4,485}]'),(4,138,'[{3,0,36346}]',491,'[{90,1},{7,2},{2,3},{1,5}]',1864,31850,'[{2,19600},{4,490}]'),(4,139,'[{3,0,36668}]',495,'[{90,1},{7,2},{2,3},{1,5}]',1878,32175,'[{2,19800},{4,495}]'),(4,140,'[{3,0,36990}]',499,'[{90,1},{7,2},{2,3},{1,5}]',1893,32500,'[{2,20000},{4,500}]'),(4,141,'[{3,0,37312}]',503,'[{90,1},{7,2},{2,3},{1,5}]',1908,32825,'[{2,20200},{4,505}]'),(4,142,'[{3,0,37634}]',507,'[{90,1},{7,2},{2,3},{1,5}]',1923,33150,'[{2,20400},{4,510}]'),(4,143,'[{3,0,37957}]',510,'[{90,1},{7,2},{2,3},{1,5}]',1937,33475,'[{2,20600},{4,515}]'),(4,144,'[{3,0,38279}]',514,'[{90,1},{7,2},{2,3},{1,5}]',1952,33800,'[{2,20800},{4,520}]'),(4,145,'[{3,0,38601}]',518,'[{90,1},{7,2},{2,3},{1,5}]',1967,34125,'[{2,21000},{4,525}]'),(4,146,'[{3,0,38923}]',522,'[{90,1},{7,2},{2,3},{1,5}]',1981,34450,'[{2,21200},{4,530}]'),(4,147,'[{3,0,39245}]',526,'[{90,1},{7,2},{2,3},{1,5}]',1996,34775,'[{2,21400},{4,535}]'),(4,148,'[{3,0,39567}]',530,'[{90,1},{7,2},{2,3},{1,5}]',2011,35100,'[{2,21600},{4,540}]'),(4,149,'[{3,0,40965}]',548,'[{90,1},{7,2},{2,3},{1,5}]',2026,35425,'[{2,21800},{4,545}]'),(4,150,'[{3,0,41443}]',552,'[{90,1},{7,2},{2,3},{1,5}]',2041,35750,'[{2,22000},{4,550}]'),(4,151,'[{3,0,41922}]',556,'[{90,1},{7,2},{2,3},{1,5}]',2055,36075,'[{2,22200},{4,555}]'),(4,152,'[{3,0,42401}]',560,'[{90,1},{7,2},{2,3},{1,5}]',2070,36400,'[{2,22400},{4,560}]'),(4,153,'[{3,0,42879}]',564,'[{90,1},{7,2},{2,3},{1,5}]',2085,36725,'[{2,22600},{4,565}]'),(4,154,'[{3,0,43358}]',568,'[{90,1},{7,2},{2,3},{1,5}]',2100,37050,'[{2,22800},{4,570}]'),(4,155,'[{3,0,43837}]',572,'[{90,1},{7,2},{2,3},{1,5}]',2115,37375,'[{2,23000},{4,575}]'),(4,156,'[{3,0,44315}]',576,'[{90,1},{7,2},{2,3},{1,5}]',2130,37700,'[{2,23200},{4,580}]'),(4,157,'[{3,0,44794}]',580,'[{90,1},{7,2},{2,3},{1,5}]',2145,38025,'[{2,23400},{4,585}]'),(4,158,'[{3,0,45273}]',584,'[{90,1},{7,2},{2,3},{1,5}]',2160,38350,'[{2,23600},{4,590}]'),(4,159,'[{3,0,45751}]',588,'[{90,1},{7,2},{2,3},{1,5}]',2175,38675,'[{2,23800},{4,595}]'),(4,160,'[{3,0,46230}]',592,'[{90,1},{7,2},{2,3},{1,5}]',2189,39000,'[{2,24000},{4,600}]'),(4,161,'[{3,0,46709}]',596,'[{90,1},{7,2},{2,3},{1,5}]',2204,39325,'[{2,24200},{4,605}]'),(4,162,'[{3,0,47187}]',600,'[{90,1},{7,2},{2,3},{1,5}]',2219,39650,'[{2,24400},{4,610}]'),(4,163,'[{3,0,47666}]',604,'[{90,1},{7,2},{2,3},{1,5}]',2234,39975,'[{2,24600},{4,615}]'),(4,164,'[{3,0,48145}]',608,'[{90,1},{7,2},{2,3},{1,5}]',2249,40300,'[{2,24800},{4,620}]'),(4,165,'[{3,0,48623}]',612,'[{90,1},{7,2},{2,3},{1,5}]',2264,40625,'[{2,25000},{4,625}]'),(4,166,'[{3,0,49102}]',616,'[{90,1},{7,2},{2,3},{1,5}]',2279,40950,'[{2,25200},{4,630}]'),(4,167,'[{3,0,49580}]',620,'[{90,1},{7,2},{2,3},{1,5}]',2294,41275,'[{2,25400},{4,635}]'),(4,168,'[{3,0,50059}]',625,'[{90,1},{7,2},{2,3},{1,5}]',2309,41600,'[{2,25600},{4,640}]'),(4,169,'[{3,0,50538}]',629,'[{90,1},{7,2},{2,3},{1,5}]',2324,41925,'[{2,25800},{4,645}]'),(4,170,'[{3,0,51016}]',633,'[{90,1},{7,2},{2,3},{1,5}]',2340,42250,'[{2,26000},{4,650}]'),(4,171,'[{3,0,51495}]',637,'[{90,1},{7,2},{2,3},{1,5}]',2355,42575,'[{2,26200},{4,655}]'),(4,172,'[{3,0,51974}]',641,'[{90,1},{7,2},{2,3},{1,5}]',2370,42900,'[{2,26400},{4,660}]'),(4,173,'[{3,0,52452}]',645,'[{90,1},{7,2},{2,3},{1,5}]',2385,43225,'[{2,26600},{4,665}]'),(4,174,'[{3,0,52931}]',649,'[{90,1},{7,2},{2,3},{1,5}]',2400,43550,'[{2,26800},{4,670}]'),(4,175,'[{3,0,53077}]',653,'[{90,1},{7,2},{2,3},{1,5}]',2415,43875,'[{2,27000},{4,675}]'),(4,176,'[{3,0,53222}]',657,'[{90,1},{7,2},{2,3},{1,5}]',2430,44200,'[{2,27200},{4,680}]'),(4,177,'[{3,0,53368}]',661,'[{90,1},{7,2},{2,3},{1,5}]',2445,44525,'[{2,27400},{4,685}]'),(4,178,'[{3,0,53514}]',665,'[{90,1},{7,2},{2,3},{1,5}]',2460,44850,'[{2,27600},{4,690}]'),(4,179,'[{3,0,53659}]',670,'[{90,1},{7,2},{2,3},{1,5}]',2476,45175,'[{2,27800},{4,695}]'),(4,180,'[{3,0,53805}]',674,'[{90,1},{7,2},{2,3},{1,5}]',2491,45500,'[{2,28000},{4,700}]'),(4,181,'[{3,0,53951}]',678,'[{90,1},{7,2},{2,3},{1,5}]',2506,45825,'[{2,28200},{4,705}]'),(4,182,'[{3,0,54096}]',682,'[{90,1},{7,2},{2,3},{1,5}]',2521,46150,'[{2,28400},{4,710}]'),(4,183,'[{3,0,54242}]',686,'[{90,1},{7,2},{2,3},{1,5}]',2536,46475,'[{2,28600},{4,715}]'),(4,184,'[{3,0,54388}]',690,'[{90,1},{7,2},{2,3},{1,5}]',2552,46800,'[{2,28800},{4,720}]'),(4,185,'[{3,0,54533}]',694,'[{90,1},{7,2},{2,3},{1,5}]',2567,47125,'[{2,29000},{4,725}]'),(4,186,'[{3,0,54679}]',698,'[{90,1},{7,2},{2,3},{1,5}]',2582,47450,'[{2,29200},{4,730}]'),(4,187,'[{3,0,54825}]',702,'[{90,1},{7,2},{2,3},{1,5}]',2597,47775,'[{2,29400},{4,735}]'),(4,188,'[{3,0,54970}]',707,'[{90,1},{7,2},{2,3},{1,5}]',2613,48100,'[{2,29600},{4,740}]'),(4,189,'[{3,0,55116}]',711,'[{90,1},{7,2},{2,3},{1,5}]',2628,48425,'[{2,29800},{4,745}]'),(4,190,'[{3,0,55262}]',715,'[{90,1},{7,2},{2,3},{1,5}]',2643,48750,'[{2,30000},{4,750}]'),(4,191,'[{3,0,55408}]',719,'[{90,1},{7,2},{2,3},{1,5}]',2658,49075,'[{2,30200},{4,755}]'),(4,192,'[{3,0,55553}]',723,'[{90,1},{7,2},{2,3},{1,5}]',2674,49400,'[{2,30400},{4,760}]'),(4,193,'[{3,0,55699}]',727,'[{90,1},{7,2},{2,3},{1,5}]',2689,49725,'[{2,30600},{4,765}]'),(4,194,'[{3,0,55845}]',731,'[{90,1},{7,2},{2,3},{1,5}]',2704,50050,'[{2,30800},{4,770}]'),(4,195,'[{3,0,55990}]',736,'[{90,1},{7,2},{2,3},{1,5}]',2720,50375,'[{2,31000},{4,775}]'),(4,196,'[{3,0,56136}]',740,'[{90,1},{7,2},{2,3},{1,5}]',2735,50700,'[{2,31200},{4,780}]'),(4,197,'[{3,0,56282}]',744,'[{90,1},{7,2},{2,3},{1,5}]',2750,51025,'[{2,31400},{4,785}]'),(4,198,'[{3,0,56427}]',748,'[{90,1},{7,2},{2,3},{1,5}]',2766,51350,'[{2,31600},{4,790}]'),(4,199,'[{3,0,58145}]',773,'[{90,1},{7,2},{2,3},{1,5}]',2781,51675,'[{2,31800},{4,795}]'),(4,200,'[{3,0,58298}]',777,'[{90,1},{7,2},{2,3},{1,5}]',2797,52000,'[{2,32000},{4,800}]'),(4,201,'[{3,0,58451}]',782,'[{90,1},{7,2},{2,3},{1,5}]',2812,52520,'[{2,32320},{4,808}]'),(4,202,'[{3,0,58604}]',786,'[{90,1},{7,2},{2,3},{1,5}]',2827,53040,'[{2,32640},{4,816}]'),(4,203,'[{3,0,58757}]',790,'[{90,1},{7,2},{2,3},{1,5}]',2843,53560,'[{2,32960},{4,824}]'),(4,204,'[{3,0,58910}]',794,'[{90,1},{7,2},{2,3},{1,5}]',2858,54080,'[{2,33280},{4,832}]'),(4,205,'[{3,0,59063}]',799,'[{90,1},{7,2},{2,3},{1,5}]',2874,54600,'[{2,33600},{4,840}]'),(4,206,'[{3,0,59216}]',803,'[{90,1},{7,2},{2,3},{1,5}]',2889,55120,'[{2,33920},{4,848}]'),(4,207,'[{3,0,59369}]',807,'[{90,1},{7,2},{2,3},{1,5}]',2905,55640,'[{2,34240},{4,856}]'),(4,208,'[{3,0,59522}]',812,'[{90,1},{7,2},{2,3},{1,5}]',2920,56160,'[{2,34560},{4,864}]'),(4,209,'[{3,0,59675}]',816,'[{90,1},{7,2},{2,3},{1,5}]',2936,56680,'[{2,34880},{4,872}]'),(4,210,'[{3,0,59828}]',820,'[{90,1},{7,2},{2,3},{1,5}]',2951,57200,'[{2,35200},{4,880}]'),(4,211,'[{3,0,59981}]',825,'[{90,1},{7,2},{2,3},{1,5}]',2967,57720,'[{2,35520},{4,888}]'),(4,212,'[{3,0,60134}]',829,'[{90,1},{7,2},{2,3},{1,5}]',2982,58240,'[{2,35840},{4,896}]'),(4,213,'[{3,0,60287}]',833,'[{90,1},{7,2},{2,3},{1,5}]',2998,58760,'[{2,36160},{4,904}]'),(4,214,'[{3,0,60440}]',837,'[{90,1},{7,2},{2,3},{1,5}]',3013,59280,'[{2,36480},{4,912}]'),(4,215,'[{3,0,60594}]',842,'[{90,1},{7,2},{2,3},{1,5}]',3029,59800,'[{2,36800},{4,920}]'),(4,216,'[{3,0,60747}]',846,'[{90,1},{7,2},{2,3},{1,5}]',3044,60320,'[{2,37120},{4,928}]'),(4,217,'[{3,0,60900}]',850,'[{90,1},{7,2},{2,3},{1,5}]',3060,60840,'[{2,37440},{4,936}]'),(4,218,'[{3,0,61053}]',855,'[{90,1},{7,2},{2,3},{1,5}]',3075,61360,'[{2,37760},{4,944}]'),(4,219,'[{3,0,61206}]',859,'[{90,1},{7,2},{2,3},{1,5}]',3091,61880,'[{2,38080},{4,952}]'),(4,220,'[{3,0,61359}]',864,'[{90,1},{7,2},{2,3},{1,5}]',3107,62400,'[{2,38400},{4,960}]'),(4,221,'[{3,0,61512}]',868,'[{90,1},{7,2},{2,3},{1,5}]',3122,62920,'[{2,38720},{4,968}]'),(4,222,'[{3,0,61665}]',872,'[{90,1},{7,2},{2,3},{1,5}]',3138,63440,'[{2,39040},{4,976}]'),(4,223,'[{3,0,61818}]',876,'[{90,1},{7,2},{2,3},{1,5}]',3153,63960,'[{2,39360},{4,984}]'),(4,224,'[{3,0,61974}]',881,'[{90,1},{7,2},{2,3},{1,5}]',3169,64480,'[{2,39680},{4,992}]'),(4,225,'[{3,0,68137}]',885,'[{90,1},{7,2},{2,3},{1,5}]',3185,65000,'[{2,40000},{4,1000}]'),(4,226,'[{3,0,74299}]',889,'[{90,1},{7,2},{2,3},{1,5}]',3200,65520,'[{2,40320},{4,1008}]'),(4,227,'[{3,0,80461}]',894,'[{90,1},{7,2},{2,3},{1,5}]',3216,66040,'[{2,40640},{4,1016}]'),(4,228,'[{3,0,86623}]',898,'[{90,1},{7,2},{2,3},{1,5}]',3232,66560,'[{2,40960},{4,1024}]'),(4,229,'[{3,0,92785}]',902,'[{90,1},{7,2},{2,3},{1,5}]',3247,67080,'[{2,41280},{4,1032}]'),(4,230,'[{3,0,98948}]',907,'[{90,1},{7,2},{2,3},{1,5}]',3263,67600,'[{2,41600},{4,1040}]'),(4,231,'[{3,0,105110}]',911,'[{90,1},{7,2},{2,3},{1,5}]',3279,68120,'[{2,41920},{4,1048}]'),(4,232,'[{3,0,111272}]',915,'[{90,1},{7,2},{2,3},{1,5}]',3294,68640,'[{2,42240},{4,1056}]'),(4,233,'[{3,0,117434}]',920,'[{90,1},{7,2},{2,3},{1,5}]',3310,69160,'[{2,42560},{4,1064}]'),(4,234,'[{3,0,123597}]',924,'[{90,1},{7,2},{2,3},{1,5}]',3326,69680,'[{2,42880},{4,1072}]'),(4,235,'[{3,0,129759}]',929,'[{90,1},{7,2},{2,3},{1,5}]',3342,70200,'[{2,43200},{4,1080}]'),(4,236,'[{3,0,135921}]',933,'[{90,1},{7,2},{2,3},{1,5}]',3357,70720,'[{2,43520},{4,1088}]'),(4,237,'[{3,0,142083}]',937,'[{90,1},{7,2},{2,3},{1,5}]',3373,71240,'[{2,43840},{4,1096}]'),(4,238,'[{3,0,148245}]',942,'[{90,1},{7,2},{2,3},{1,5}]',3389,71760,'[{2,44160},{4,1104}]'),(4,239,'[{3,0,154408}]',946,'[{90,1},{7,2},{2,3},{1,5}]',3405,72280,'[{2,44480},{4,1112}]'),(4,240,'[{3,0,160570}]',950,'[{90,1},{7,2},{2,3},{1,5}]',3420,72800,'[{2,44800},{4,1120}]'),(4,241,'[{3,0,166732}]',955,'[{90,1},{7,2},{2,3},{1,5}]',3436,73320,'[{2,45120},{4,1128}]'),(4,242,'[{3,0,172894}]',959,'[{90,1},{7,2},{2,3},{1,5}]',3452,73840,'[{2,45440},{4,1136}]'),(4,243,'[{3,0,179057}]',964,'[{90,1},{7,2},{2,3},{1,5}]',3468,74360,'[{2,45760},{4,1144}]'),(4,244,'[{3,0,185219}]',968,'[{90,1},{7,2},{2,3},{1,5}]',3484,74880,'[{2,46080},{4,1152}]'),(4,245,'[{3,0,191381}]',972,'[{90,1},{7,2},{2,3},{1,5}]',3499,75400,'[{2,46400},{4,1160}]'),(4,246,'[{3,0,197543}]',977,'[{90,1},{7,2},{2,3},{1,5}]',3515,75920,'[{2,46720},{4,1168}]'),(4,247,'[{3,0,203705}]',981,'[{90,1},{7,2},{2,3},{1,5}]',3531,76440,'[{2,47040},{4,1176}]'),(4,248,'[{3,0,209868}]',986,'[{90,1},{7,2},{2,3},{1,5}]',3547,76960,'[{2,47360},{4,1184}]'),(4,249,'[{3,0,222203}]',1018,'[{90,1},{7,2},{2,3},{1,5}]',3563,77480,'[{2,47680},{4,1192}]'),(4,250,'[{3,0,228297}]',1023,'[{90,1},{7,2},{2,3},{1,5}]',3579,78000,'[{2,48000},{4,1200}]'),(4,251,'[{3,0,234391}]',1028,'[{90,1},{7,2},{2,3},{1,5}]',3595,78520,'[{2,48320},{4,1208}]'),(4,252,'[{3,0,240485}]',1032,'[{90,1},{7,2},{2,3},{1,5}]',3610,79040,'[{2,48640},{4,1216}]'),(4,253,'[{3,0,246579}]',1036,'[{90,1},{7,2},{2,3},{1,5}]',3626,79560,'[{2,48960},{4,1224}]'),(4,254,'[{3,0,252673}]',1041,'[{90,1},{7,2},{2,3},{1,5}]',3642,80080,'[{2,49280},{4,1232}]'),(4,255,'[{3,0,258767}]',1046,'[{90,1},{7,2},{2,3},{1,5}]',3658,80600,'[{2,49600},{4,1240}]'),(4,256,'[{3,0,264861}]',1050,'[{90,1},{7,2},{2,3},{1,5}]',3674,81120,'[{2,49920},{4,1248}]'),(4,257,'[{3,0,270955}]',1055,'[{90,1},{7,2},{2,3},{1,5}]',3690,81640,'[{2,50240},{4,1256}]'),(4,258,'[{3,0,277049}]',1059,'[{90,1},{7,2},{2,3},{1,5}]',3706,82160,'[{2,50560},{4,1264}]'),(4,259,'[{3,0,283143}]',1064,'[{90,1},{7,2},{2,3},{1,5}]',3722,82680,'[{2,50880},{4,1272}]'),(4,260,'[{3,0,289237}]',1068,'[{90,1},{7,2},{2,3},{1,5}]',3738,83200,'[{2,51200},{4,1280}]'),(4,261,'[{3,0,295331}]',1073,'[{90,1},{7,2},{2,3},{1,5}]',3754,83720,'[{2,51520},{4,1288}]'),(4,262,'[{3,0,301425}]',1078,'[{90,1},{7,2},{2,3},{1,5}]',3770,84240,'[{2,51840},{4,1296}]'),(4,263,'[{3,0,307519}]',1082,'[{90,1},{7,2},{2,3},{1,5}]',3786,84760,'[{2,52160},{4,1304}]'),(4,264,'[{3,0,313613}]',1087,'[{90,1},{7,2},{2,3},{1,5}]',3802,85280,'[{2,52480},{4,1312}]'),(4,265,'[{3,0,319707}]',1091,'[{90,1},{7,2},{2,3},{1,5}]',3818,85800,'[{2,52800},{4,1320}]'),(4,266,'[{3,0,325801}]',1096,'[{90,1},{7,2},{2,3},{1,5}]',3834,86320,'[{2,53120},{4,1328}]'),(4,267,'[{3,0,331895}]',1100,'[{90,1},{7,2},{2,3},{1,5}]',3850,86840,'[{2,53440},{4,1336}]'),(4,268,'[{3,0,337989}]',1105,'[{90,1},{7,2},{2,3},{1,5}]',3866,87360,'[{2,53760},{4,1344}]'),(4,269,'[{3,0,344083}]',1110,'[{90,1},{7,2},{2,3},{1,5}]',3882,87880,'[{2,54080},{4,1352}]'),(4,270,'[{3,0,350177}]',1114,'[{90,1},{7,2},{2,3},{1,5}]',3898,88400,'[{2,54400},{4,1360}]'),(4,271,'[{3,0,356271}]',1119,'[{90,1},{7,2},{2,3},{1,5}]',3914,88920,'[{2,54720},{4,1368}]'),(4,272,'[{3,0,362365}]',1123,'[{90,1},{7,2},{2,3},{1,5}]',3930,89440,'[{2,55040},{4,1376}]'),(4,273,'[{3,0,368459}]',1128,'[{90,1},{7,2},{2,3},{1,5}]',3946,89960,'[{2,55360},{4,1384}]'),(4,274,'[{3,0,374550}]',1132,'[{90,1},{7,2},{2,3},{1,5}]',3962,90480,'[{2,55680},{4,1392}]'),(4,275,'[{3,0,381734}]',1137,'[{90,1},{7,2},{2,3},{1,5}]',3978,91000,'[{2,56000},{4,1400}]'),(4,276,'[{3,0,388919}]',1142,'[{90,1},{7,2},{2,3},{1,5}]',3994,91520,'[{2,56320},{4,1408}]'),(4,277,'[{3,0,396104}]',1146,'[{90,1},{7,2},{2,3},{1,5}]',4010,92040,'[{2,56640},{4,1416}]'),(4,278,'[{3,0,403288}]',1151,'[{90,1},{7,2},{2,3},{1,5}]',4026,92560,'[{2,56960},{4,1424}]'),(4,279,'[{3,0,410473}]',1155,'[{90,1},{7,2},{2,3},{1,5}]',4042,93080,'[{2,57280},{4,1432}]'),(4,280,'[{3,0,417657}]',1160,'[{90,1},{7,2},{2,3},{1,5}]',4059,93600,'[{2,57600},{4,1440}]'),(4,281,'[{3,0,424842}]',1165,'[{90,1},{7,2},{2,3},{1,5}]',4075,94120,'[{2,57920},{4,1448}]'),(4,282,'[{3,0,432026}]',1169,'[{90,1},{7,2},{2,3},{1,5}]',4091,94640,'[{2,58240},{4,1456}]'),(4,283,'[{3,0,439211}]',1174,'[{90,1},{7,2},{2,3},{1,5}]',4107,95160,'[{2,58560},{4,1464}]'),(4,284,'[{3,0,446396}]',1178,'[{90,1},{7,2},{2,3},{1,5}]',4123,95680,'[{2,58880},{4,1472}]'),(4,285,'[{3,0,453580}]',1183,'[{90,1},{7,2},{2,3},{1,5}]',4139,96200,'[{2,59200},{4,1480}]'),(4,286,'[{3,0,460765}]',1188,'[{90,1},{7,2},{2,3},{1,5}]',4155,96720,'[{2,59520},{4,1488}]'),(4,287,'[{3,0,467949}]',1192,'[{90,1},{7,2},{2,3},{1,5}]',4172,97240,'[{2,59840},{4,1496}]'),(4,288,'[{3,0,475134}]',1197,'[{90,1},{7,2},{2,3},{1,5}]',4188,97760,'[{2,60160},{4,1504}]'),(4,289,'[{3,0,482318}]',1202,'[{90,1},{7,2},{2,3},{1,5}]',4204,98280,'[{2,60480},{4,1512}]'),(4,290,'[{3,0,489503}]',1206,'[{90,1},{7,2},{2,3},{1,5}]',4220,98800,'[{2,60800},{4,1520}]'),(4,291,'[{3,0,496688}]',1211,'[{90,1},{7,2},{2,3},{1,5}]',4236,99320,'[{2,61120},{4,1528}]'),(4,292,'[{3,0,503872}]',1216,'[{90,1},{7,2},{2,3},{1,5}]',4253,99840,'[{2,61440},{4,1536}]'),(4,293,'[{3,0,511057}]',1220,'[{90,1},{7,2},{2,3},{1,5}]',4269,100360,'[{2,61760},{4,1544}]'),(4,294,'[{3,0,518241}]',1225,'[{90,1},{7,2},{2,3},{1,5}]',4285,100880,'[{2,62080},{4,1552}]'),(4,295,'[{3,0,525426}]',1229,'[{90,1},{7,2},{2,3},{1,5}]',4301,101400,'[{2,62400},{4,1560}]'),(4,296,'[{3,0,532610}]',1234,'[{90,1},{7,2},{2,3},{1,5}]',4317,101920,'[{2,62720},{4,1568}]'),(4,297,'[{3,0,539795}]',1239,'[{90,1},{7,2},{2,3},{1,5}]',4334,102440,'[{2,63040},{4,1576}]'),(4,298,'[{3,0,546980}]',1243,'[{90,1},{7,2},{2,3},{1,5}]',4350,102960,'[{2,63360},{4,1584}]'),(4,299,'[{3,0,570466}]',1285,'[{90,1},{7,2},{2,3},{1,5}]',4366,103480,'[{2,63680},{4,1592}]'),(4,300,'[{3,0,581815}]',1289,'[{90,1},{7,2},{2,3},{1,5}]',4382,104000,'[{2,64000},{4,1600}]'),(4,301,'[{3,0,593165}]',1294,'[{90,1},{7,2},{2,3},{1,5}]',4399,104780,'[{2,64480},{4,1612}]'),(4,302,'[{3,0,604515}]',1299,'[{90,1},{7,2},{2,3},{1,5}]',4415,105560,'[{2,64960},{4,1624}]'),(4,303,'[{3,0,615865}]',1304,'[{90,1},{7,2},{2,3},{1,5}]',4431,106340,'[{2,65440},{4,1636}]'),(4,304,'[{3,0,627214}]',1309,'[{90,1},{7,2},{2,3},{1,5}]',4448,107120,'[{2,65920},{4,1648}]'),(4,305,'[{3,0,638564}]',1313,'[{90,1},{7,2},{2,3},{1,5}]',4464,107900,'[{2,66400},{4,1660}]'),(4,306,'[{3,0,649914}]',1318,'[{90,1},{7,2},{2,3},{1,5}]',4480,108680,'[{2,66880},{4,1672}]'),(4,307,'[{3,0,661263}]',1323,'[{90,1},{7,2},{2,3},{1,5}]',4497,109460,'[{2,67360},{4,1684}]'),(4,308,'[{3,0,672613}]',1328,'[{90,1},{7,2},{2,3},{1,5}]',4513,110240,'[{2,67840},{4,1696}]'),(4,309,'[{3,0,683963}]',1333,'[{90,1},{7,2},{2,3},{1,5}]',4529,111020,'[{2,68320},{4,1708}]'),(4,310,'[{3,0,695313}]',1338,'[{90,1},{7,2},{2,3},{1,5}]',4546,111800,'[{2,68800},{4,1720}]'),(4,311,'[{3,0,706662}]',1342,'[{90,1},{7,2},{2,3},{1,5}]',4562,112580,'[{2,69280},{4,1732}]'),(4,312,'[{3,0,718012}]',1347,'[{90,1},{7,2},{2,3},{1,5}]',4578,113360,'[{2,69760},{4,1744}]'),(4,313,'[{3,0,729362}]',1352,'[{90,1},{7,2},{2,3},{1,5}]',4595,114140,'[{2,70240},{4,1756}]'),(4,314,'[{3,0,740711}]',1357,'[{90,1},{7,2},{2,3},{1,5}]',4611,114920,'[{2,70720},{4,1768}]'),(4,315,'[{3,0,752061}]',1361,'[{90,1},{7,2},{2,3},{1,5}]',4627,115700,'[{2,71200},{4,1780}]'),(4,316,'[{3,0,763411}]',1366,'[{90,1},{7,2},{2,3},{1,5}]',4644,116480,'[{2,71680},{4,1792}]'),(4,317,'[{3,0,774760}]',1371,'[{90,1},{7,2},{2,3},{1,5}]',4660,117260,'[{2,72160},{4,1804}]'),(4,318,'[{3,0,786110}]',1376,'[{90,1},{7,2},{2,3},{1,5}]',4677,118040,'[{2,72640},{4,1816}]'),(4,319,'[{3,0,797460}]',1381,'[{90,1},{7,2},{2,3},{1,5}]',4693,118820,'[{2,73120},{4,1828}]'),(4,320,'[{3,0,808810}]',1385,'[{90,1},{7,2},{2,3},{1,5}]',4709,119600,'[{2,73600},{4,1840}]'),(4,321,'[{3,0,820159}]',1390,'[{90,1},{7,2},{2,3},{1,5}]',4726,120380,'[{2,74080},{4,1852}]'),(4,322,'[{3,0,831509}]',1395,'[{90,1},{7,2},{2,3},{1,5}]',4742,121160,'[{2,74560},{4,1864}]'),(4,323,'[{3,0,842859}]',1400,'[{90,1},{7,2},{2,3},{1,5}]',4759,121940,'[{2,75040},{4,1876}]'),(4,324,'[{3,0,854205}]',1405,'[{90,1},{7,2},{2,3},{1,5}]',4775,122720,'[{2,75520},{4,1888}]'),(4,325,'[{3,0,869085}]',1410,'[{90,1},{7,2},{2,3},{1,5}]',4792,123500,'[{2,76000},{4,1900}]'),(4,326,'[{3,0,883965}]',1415,'[{90,1},{7,2},{2,3},{1,5}]',4808,124280,'[{2,76480},{4,1912}]'),(4,327,'[{3,0,898846}]',1420,'[{90,1},{7,2},{2,3},{1,5}]',4825,125060,'[{2,76960},{4,1924}]'),(4,328,'[{3,0,913726}]',1424,'[{90,1},{7,2},{2,3},{1,5}]',4841,125840,'[{2,77440},{4,1936}]'),(4,329,'[{3,0,928606}]',1429,'[{90,1},{7,2},{2,3},{1,5}]',4857,126620,'[{2,77920},{4,1948}]'),(4,330,'[{3,0,943487}]',1434,'[{90,1},{7,2},{2,3},{1,5}]',4874,127400,'[{2,78400},{4,1960}]'),(4,331,'[{3,0,958367}]',1439,'[{90,1},{7,2},{2,3},{1,5}]',4890,128180,'[{2,78880},{4,1972}]'),(4,332,'[{3,0,973247}]',1444,'[{90,1},{7,2},{2,3},{1,5}]',4907,128960,'[{2,79360},{4,1984}]'),(4,333,'[{3,0,988128}]',1448,'[{90,1},{7,2},{2,3},{1,5}]',4923,129740,'[{2,79840},{4,1996}]'),(4,334,'[{3,0,1003008}]',1453,'[{90,1},{7,2},{2,3},{1,5}]',4940,130520,'[{2,80320},{4,2008}]'),(4,335,'[{3,0,1017888}]',1458,'[{90,1},{7,2},{2,3},{1,5}]',4956,131300,'[{2,80800},{4,2020}]'),(4,336,'[{3,0,1032768}]',1463,'[{90,1},{7,2},{2,3},{1,5}]',4973,132080,'[{2,81280},{4,2032}]'),(4,337,'[{3,0,1047649}]',1468,'[{90,1},{7,2},{2,3},{1,5}]',4990,132860,'[{2,81760},{4,2044}]'),(4,338,'[{3,0,1062529}]',1473,'[{90,1},{7,2},{2,3},{1,5}]',5006,133640,'[{2,82240},{4,2056}]'),(4,339,'[{3,0,1077409}]',1478,'[{90,1},{7,2},{2,3},{1,5}]',5023,134420,'[{2,82720},{4,2068}]'),(4,340,'[{3,0,1092290}]',1483,'[{90,1},{7,2},{2,3},{1,5}]',5039,135200,'[{2,83200},{4,2080}]'),(4,341,'[{3,0,1107170}]',1488,'[{90,1},{7,2},{2,3},{1,5}]',5056,135980,'[{2,83680},{4,2092}]'),(4,342,'[{3,0,1122050}]',1492,'[{90,1},{7,2},{2,3},{1,5}]',5072,136760,'[{2,84160},{4,2104}]'),(4,343,'[{3,0,1136930}]',1497,'[{90,1},{7,2},{2,3},{1,5}]',5089,137540,'[{2,84640},{4,2116}]'),(4,344,'[{3,0,1151811}]',1502,'[{90,1},{7,2},{2,3},{1,5}]',5105,138320,'[{2,85120},{4,2128}]'),(4,345,'[{3,0,1166691}]',1507,'[{90,1},{7,2},{2,3},{1,5}]',5122,139100,'[{2,85600},{4,2140}]'),(4,346,'[{3,0,1181571}]',1512,'[{90,1},{7,2},{2,3},{1,5}]',5139,139880,'[{2,86080},{4,2152}]'),(4,347,'[{3,0,1196452}]',1517,'[{90,1},{7,2},{2,3},{1,5}]',5155,140660,'[{2,86560},{4,2164}]'),(4,348,'[{3,0,1211332}]',1522,'[{90,1},{7,2},{2,3},{1,5}]',5172,141440,'[{2,87040},{4,2176}]'),(4,349,'[{3,0,1263370}]',1573,'[{90,1},{7,2},{2,3},{1,5}]',5188,142220,'[{2,87520},{4,2188}]'),(4,350,'[{3,0,1279417}]',1578,'[{90,1},{7,2},{2,3},{1,5}]',5205,143000,'[{2,88000},{4,2200}]'),(4,351,'[{3,0,1295463}]',1583,'[{90,1},{7,2},{2,3},{1,5}]',5222,143780,'[{2,88480},{4,2212}]'),(4,352,'[{3,0,1311509}]',1588,'[{90,1},{7,2},{2,3},{1,5}]',5238,144560,'[{2,88960},{4,2224}]'),(4,353,'[{3,0,1327556}]',1593,'[{90,1},{7,2},{2,3},{1,5}]',5255,145340,'[{2,89440},{4,2236}]'),(4,354,'[{3,0,1343602}]',1598,'[{90,1},{7,2},{2,3},{1,5}]',5272,146120,'[{2,89920},{4,2248}]'),(4,355,'[{3,0,1359648}]',1603,'[{90,1},{7,2},{2,3},{1,5}]',5288,146900,'[{2,90400},{4,2260}]'),(4,356,'[{3,0,1375695}]',1608,'[{90,1},{7,2},{2,3},{1,5}]',5305,147680,'[{2,90880},{4,2272}]'),(4,357,'[{3,0,1391741}]',1613,'[{90,1},{7,2},{2,3},{1,5}]',5322,148460,'[{2,91360},{4,2284}]'),(4,358,'[{3,0,1407787}]',1618,'[{90,1},{7,2},{2,3},{1,5}]',5338,149240,'[{2,91840},{4,2296}]'),(4,359,'[{3,0,1423834}]',1623,'[{90,1},{7,2},{2,3},{1,5}]',5355,150020,'[{2,92320},{4,2308}]'),(4,360,'[{3,0,1439880}]',1628,'[{90,1},{7,2},{2,3},{1,5}]',5372,150800,'[{2,92800},{4,2320}]'),(4,361,'[{3,0,1455927}]',1633,'[{90,1},{7,2},{2,3},{1,5}]',5388,151580,'[{2,93280},{4,2332}]'),(4,362,'[{3,0,1471973}]',1638,'[{90,1},{7,2},{2,3},{1,5}]',5405,152360,'[{2,93760},{4,2344}]'),(4,363,'[{3,0,1488019}]',1644,'[{90,1},{7,2},{2,3},{1,5}]',5422,153140,'[{2,94240},{4,2356}]'),(4,364,'[{3,0,1504066}]',1648,'[{90,1},{7,2},{2,3},{1,5}]',5438,153920,'[{2,94720},{4,2368}]'),(4,365,'[{3,0,1520112}]',1654,'[{90,1},{7,2},{2,3},{1,5}]',5455,154700,'[{2,95200},{4,2380}]'),(4,366,'[{3,0,1536158}]',1659,'[{90,1},{7,2},{2,3},{1,5}]',5472,155480,'[{2,95680},{4,2392}]'),(4,367,'[{3,0,1552205}]',1664,'[{90,1},{7,2},{2,3},{1,5}]',5489,156260,'[{2,96160},{4,2404}]'),(4,368,'[{3,0,1568251}]',1669,'[{90,1},{7,2},{2,3},{1,5}]',5505,157040,'[{2,96640},{4,2416}]'),(4,369,'[{3,0,1584297}]',1674,'[{90,1},{7,2},{2,3},{1,5}]',5522,157820,'[{2,97120},{4,2428}]'),(4,370,'[{3,0,1600344}]',1679,'[{90,1},{7,2},{2,3},{1,5}]',5539,158600,'[{2,97600},{4,2440}]'),(4,371,'[{3,0,1616390}]',1684,'[{90,1},{7,2},{2,3},{1,5}]',5556,159380,'[{2,98080},{4,2452}]'),(4,372,'[{3,0,1632437}]',1689,'[{90,1},{7,2},{2,3},{1,5}]',5572,160160,'[{2,98560},{4,2464}]'),(4,373,'[{3,0,1648483}]',1694,'[{90,1},{7,2},{2,3},{1,5}]',5589,160940,'[{2,99040},{4,2476}]'),(4,374,'[{3,0,1664530}]',1699,'[{90,1},{7,2},{2,3},{1,5}]',5606,161720,'[{2,99520},{4,2488}]'),(4,375,'[{3,0,1679756}]',1704,'[{90,1},{7,2},{2,3},{1,5}]',5623,162500,'[{2,100000},{4,2500}]'),(4,376,'[{3,0,1694982}]',1710,'[{90,1},{7,2},{2,3},{1,5}]',5640,163280,'[{2,100480},{4,2512}]'),(4,377,'[{3,0,1710209}]',1714,'[{90,1},{7,2},{2,3},{1,5}]',5656,164060,'[{2,100960},{4,2524}]'),(4,378,'[{3,0,1725435}]',1720,'[{90,1},{7,2},{2,3},{1,5}]',5673,164840,'[{2,101440},{4,2536}]'),(4,379,'[{3,0,1740661}]',1725,'[{90,1},{7,2},{2,3},{1,5}]',5690,165620,'[{2,101920},{4,2548}]'),(4,380,'[{3,0,1755888}]',1730,'[{90,1},{7,2},{2,3},{1,5}]',5707,166400,'[{2,102400},{4,2560}]'),(4,381,'[{3,0,1771114}]',1735,'[{90,1},{7,2},{2,3},{1,5}]',5724,167180,'[{2,102880},{4,2572}]'),(4,382,'[{3,0,1786340}]',1740,'[{90,1},{7,2},{2,3},{1,5}]',5740,167960,'[{2,103360},{4,2584}]'),(4,383,'[{3,0,1801567}]',1745,'[{90,1},{7,2},{2,3},{1,5}]',5757,168740,'[{2,103840},{4,2596}]'),(4,384,'[{3,0,1816793}]',1750,'[{90,1},{7,2},{2,3},{1,5}]',5774,169520,'[{2,104320},{4,2608}]'),(4,385,'[{3,0,1832020}]',1755,'[{90,1},{7,2},{2,3},{1,5}]',5791,170300,'[{2,104800},{4,2620}]'),(4,386,'[{3,0,1847246}]',1760,'[{90,1},{7,2},{2,3},{1,5}]',5808,171080,'[{2,105280},{4,2632}]'),(4,387,'[{3,0,1862472}]',1766,'[{90,1},{7,2},{2,3},{1,5}]',5825,171860,'[{2,105760},{4,2644}]'),(4,388,'[{3,0,1877699}]',1770,'[{90,1},{7,2},{2,3},{1,5}]',5841,172640,'[{2,106240},{4,2656}]'),(4,389,'[{3,0,1892925}]',1776,'[{90,1},{7,2},{2,3},{1,5}]',5858,173420,'[{2,106720},{4,2668}]'),(4,390,'[{3,0,1908151}]',1781,'[{90,1},{7,2},{2,3},{1,5}]',5875,174200,'[{2,107200},{4,2680}]'),(4,391,'[{3,0,1923378}]',1786,'[{90,1},{7,2},{2,3},{1,5}]',5892,174980,'[{2,107680},{4,2692}]'),(4,392,'[{3,0,1938604}]',1791,'[{90,1},{7,2},{2,3},{1,5}]',5909,175760,'[{2,108160},{4,2704}]'),(4,393,'[{3,0,1953830}]',1796,'[{90,1},{7,2},{2,3},{1,5}]',5926,176540,'[{2,108640},{4,2716}]'),(4,394,'[{3,0,1969057}]',1801,'[{90,1},{7,2},{2,3},{1,5}]',5943,177320,'[{2,109120},{4,2728}]'),(4,395,'[{3,0,1984283}]',1807,'[{90,1},{7,2},{2,3},{1,5}]',5960,178100,'[{2,109600},{4,2740}]'),(4,396,'[{3,0,1999510}]',1812,'[{90,1},{7,2},{2,3},{1,5}]',5977,178880,'[{2,110080},{4,2752}]'),(4,397,'[{3,0,2014736}]',1817,'[{90,1},{7,2},{2,3},{1,5}]',5993,179660,'[{2,110560},{4,2764}]'),(4,398,'[{3,0,2029962}]',1822,'[{90,1},{7,2},{2,3},{1,5}]',6010,180440,'[{2,111040},{4,2776}]'),(4,399,'[{3,0,2109102}]',1884,'[{90,1},{7,2},{2,3},{1,5}]',6027,181220,'[{2,111520},{4,2788}]'),(4,400,'[{3,0,2133037}]',1889,'[{90,1},{7,2},{2,3},{1,5}]',6044,182000,'[{2,112000},{4,2800}]'),(4,401,'[{3,0,2156972}]',1895,'[{90,1},{7,2},{2,3},{1,5}]',6061,183040,'[{2,112640},{4,2816}]'),(4,402,'[{3,0,2180907}]',1900,'[{90,1},{7,2},{2,3},{1,5}]',6078,184080,'[{2,113280},{4,2832}]'),(4,403,'[{3,0,2204842}]',1905,'[{90,1},{7,2},{2,3},{1,5}]',6095,185120,'[{2,113920},{4,2848}]'),(4,404,'[{3,0,2228777}]',1910,'[{90,1},{7,2},{2,3},{1,5}]',6112,186160,'[{2,114560},{4,2864}]'),(4,405,'[{3,0,2252712}]',1916,'[{90,1},{7,2},{2,3},{1,5}]',6129,187200,'[{2,115200},{4,2880}]'),(4,406,'[{3,0,2276647}]',1921,'[{90,1},{7,2},{2,3},{1,5}]',6146,188240,'[{2,115840},{4,2896}]'),(4,407,'[{3,0,2300582}]',1926,'[{90,1},{7,2},{2,3},{1,5}]',6163,189280,'[{2,116480},{4,2912}]'),(4,408,'[{3,0,2324517}]',1932,'[{90,1},{7,2},{2,3},{1,5}]',6180,190320,'[{2,117120},{4,2928}]'),(4,409,'[{3,0,2348452}]',1937,'[{90,1},{7,2},{2,3},{1,5}]',6197,191360,'[{2,117760},{4,2944}]'),(4,410,'[{3,0,2372387}]',1942,'[{90,1},{7,2},{2,3},{1,5}]',6214,192400,'[{2,118400},{4,2960}]'),(4,411,'[{3,0,2396322}]',1948,'[{90,1},{7,2},{2,3},{1,5}]',6231,193440,'[{2,119040},{4,2976}]'),(4,412,'[{3,0,2420257}]',1953,'[{90,1},{7,2},{2,3},{1,5}]',6248,194480,'[{2,119680},{4,2992}]'),(4,413,'[{3,0,2444192}]',1958,'[{90,1},{7,2},{2,3},{1,5}]',6265,195520,'[{2,120320},{4,3008}]'),(4,414,'[{3,0,2468127}]',1964,'[{90,1},{7,2},{2,3},{1,5}]',6282,196560,'[{2,120960},{4,3024}]'),(4,415,'[{3,0,2492062}]',1969,'[{90,1},{7,2},{2,3},{1,5}]',6299,197600,'[{2,121600},{4,3040}]'),(4,416,'[{3,0,2515997}]',1974,'[{90,1},{7,2},{2,3},{1,5}]',6316,198640,'[{2,122240},{4,3056}]'),(4,417,'[{3,0,2539932}]',1980,'[{90,1},{7,2},{2,3},{1,5}]',6333,199680,'[{2,122880},{4,3072}]'),(4,418,'[{3,0,2563867}]',1985,'[{90,1},{7,2},{2,3},{1,5}]',6350,200720,'[{2,123520},{4,3088}]'),(4,419,'[{3,0,2587802}]',1990,'[{90,1},{7,2},{2,3},{1,5}]',6367,201760,'[{2,124160},{4,3104}]'),(4,420,'[{3,0,2611737}]',1995,'[{90,1},{7,2},{2,3},{1,5}]',6384,202800,'[{2,124800},{4,3120}]'),(4,421,'[{3,0,2635672}]',2001,'[{90,1},{7,2},{2,3},{1,5}]',6401,203840,'[{2,125440},{4,3136}]'),(4,422,'[{3,0,2659607}]',2006,'[{90,1},{7,2},{2,3},{1,5}]',6418,204880,'[{2,126080},{4,3152}]'),(4,423,'[{3,0,2683542}]',2011,'[{90,1},{7,2},{2,3},{1,5}]',6435,205920,'[{2,126720},{4,3168}]'),(4,424,'[{3,0,2707479}]',2017,'[{90,1},{7,2},{2,3},{1,5}]',6452,206960,'[{2,127360},{4,3184}]'),(4,425,'[{3,0,2730859}]',2022,'[{90,1},{7,2},{2,3},{1,5}]',6470,208000,'[{2,128000},{4,3200}]'),(4,426,'[{3,0,2754239}]',2028,'[{90,1},{7,2},{2,3},{1,5}]',6487,209040,'[{2,128640},{4,3216}]'),(4,427,'[{3,0,2777618}]',2033,'[{90,1},{7,2},{2,3},{1,5}]',6504,210080,'[{2,129280},{4,3232}]'),(4,428,'[{3,0,2800998}]',2038,'[{90,1},{7,2},{2,3},{1,5}]',6521,211120,'[{2,129920},{4,3248}]'),(4,429,'[{3,0,2824378}]',2044,'[{90,1},{7,2},{2,3},{1,5}]',6538,212160,'[{2,130560},{4,3264}]'),(4,430,'[{3,0,2847757}]',2049,'[{90,1},{7,2},{2,3},{1,5}]',6555,213200,'[{2,131200},{4,3280}]'),(4,431,'[{3,0,2871137}]',2054,'[{90,1},{7,2},{2,3},{1,5}]',6572,214240,'[{2,131840},{4,3296}]'),(4,432,'[{3,0,2894517}]',2060,'[{90,1},{7,2},{2,3},{1,5}]',6589,215280,'[{2,132480},{4,3312}]'),(4,433,'[{3,0,2917896}]',2065,'[{90,1},{7,2},{2,3},{1,5}]',6606,216320,'[{2,133120},{4,3328}]'),(4,434,'[{3,0,2941276}]',2070,'[{90,1},{7,2},{2,3},{1,5}]',6624,217360,'[{2,133760},{4,3344}]'),(4,435,'[{3,0,2964656}]',2076,'[{90,1},{7,2},{2,3},{1,5}]',6641,218400,'[{2,134400},{4,3360}]'),(4,436,'[{3,0,2988035}]',2081,'[{90,1},{7,2},{2,3},{1,5}]',6658,219440,'[{2,135040},{4,3376}]'),(4,437,'[{3,0,3011415}]',2086,'[{90,1},{7,2},{2,3},{1,5}]',6675,220480,'[{2,135680},{4,3392}]'),(4,438,'[{3,0,3034795}]',2092,'[{90,1},{7,2},{2,3},{1,5}]',6692,221520,'[{2,136320},{4,3408}]'),(4,439,'[{3,0,3058175}]',2097,'[{90,1},{7,2},{2,3},{1,5}]',6709,222560,'[{2,136960},{4,3424}]'),(4,440,'[{3,0,3081554}]',2102,'[{90,1},{7,2},{2,3},{1,5}]',6726,223600,'[{2,137600},{4,3440}]'),(4,441,'[{3,0,3104934}]',2108,'[{90,1},{7,2},{2,3},{1,5}]',6744,224640,'[{2,138240},{4,3456}]'),(4,442,'[{3,0,3128314}]',2113,'[{90,1},{7,2},{2,3},{1,5}]',6761,225680,'[{2,138880},{4,3472}]'),(4,443,'[{3,0,3151693}]',2119,'[{90,1},{7,2},{2,3},{1,5}]',6778,226720,'[{2,139520},{4,3488}]'),(4,444,'[{3,0,3175073}]',2124,'[{90,1},{7,2},{2,3},{1,5}]',6795,227760,'[{2,140160},{4,3504}]'),(4,445,'[{3,0,3198453}]',2129,'[{90,1},{7,2},{2,3},{1,5}]',6812,228800,'[{2,140800},{4,3520}]'),(4,446,'[{3,0,3221832}]',2135,'[{90,1},{7,2},{2,3},{1,5}]',6830,229840,'[{2,141440},{4,3536}]'),(4,447,'[{3,0,3245212}]',2140,'[{90,1},{7,2},{2,3},{1,5}]',6847,230880,'[{2,142080},{4,3552}]'),(4,448,'[{3,0,3268592}]',2145,'[{90,1},{7,2},{2,3},{1,5}]',6864,231920,'[{2,142720},{4,3568}]'),(4,449,'[{3,0,3398166}]',2220,'[{90,1},{7,2},{2,3},{1,5}]',6881,232960,'[{2,143360},{4,3584}]'),(4,450,'[{3,0,3413589}]',2226,'[{90,1},{7,2},{2,3},{1,5}]',6898,234000,'[{2,144000},{4,3600}]'),(4,451,'[{3,0,3429011}]',2231,'[{90,1},{7,2},{2,3},{1,5}]',6916,235040,'[{2,144640},{4,3616}]'),(4,452,'[{3,0,3444434}]',2237,'[{90,1},{7,2},{2,3},{1,5}]',6933,236080,'[{2,145280},{4,3632}]'),(4,453,'[{3,0,3459856}]',2242,'[{90,1},{7,2},{2,3},{1,5}]',6950,237120,'[{2,145920},{4,3648}]'),(4,454,'[{3,0,3475279}]',2248,'[{90,1},{7,2},{2,3},{1,5}]',6967,238160,'[{2,146560},{4,3664}]'),(4,455,'[{3,0,3490701}]',2254,'[{90,1},{7,2},{2,3},{1,5}]',6985,239200,'[{2,147200},{4,3680}]'),(4,456,'[{3,0,3506124}]',2259,'[{90,1},{7,2},{2,3},{1,5}]',7002,240240,'[{2,147840},{4,3696}]'),(4,457,'[{3,0,3521547}]',2265,'[{90,1},{7,2},{2,3},{1,5}]',7019,241280,'[{2,148480},{4,3712}]'),(4,458,'[{3,0,3536969}]',2270,'[{90,1},{7,2},{2,3},{1,5}]',7036,242320,'[{2,149120},{4,3728}]'),(4,459,'[{3,0,3552392}]',2276,'[{90,1},{7,2},{2,3},{1,5}]',7054,243360,'[{2,149760},{4,3744}]'),(4,460,'[{3,0,3567814}]',2281,'[{90,1},{7,2},{2,3},{1,5}]',7071,244400,'[{2,150400},{4,3760}]'),(4,461,'[{3,0,3583237}]',2287,'[{90,1},{7,2},{2,3},{1,5}]',7088,245440,'[{2,151040},{4,3776}]'),(4,462,'[{3,0,3598660}]',2292,'[{90,1},{7,2},{2,3},{1,5}]',7105,246480,'[{2,151680},{4,3792}]'),(4,463,'[{3,0,3614082}]',2298,'[{90,1},{7,2},{2,3},{1,5}]',7123,247520,'[{2,152320},{4,3808}]'),(4,464,'[{3,0,3629505}]',2304,'[{90,1},{7,2},{2,3},{1,5}]',7140,248560,'[{2,152960},{4,3824}]'),(4,465,'[{3,0,3644927}]',2309,'[{90,1},{7,2},{2,3},{1,5}]',7157,249600,'[{2,153600},{4,3840}]'),(4,466,'[{3,0,3660350}]',2315,'[{90,1},{7,2},{2,3},{1,5}]',7175,250640,'[{2,154240},{4,3856}]'),(4,467,'[{3,0,3675772}]',2320,'[{90,1},{7,2},{2,3},{1,5}]',7192,251680,'[{2,154880},{4,3872}]'),(4,468,'[{3,0,3691195}]',2326,'[{90,1},{7,2},{2,3},{1,5}]',7209,252720,'[{2,155520},{4,3888}]'),(4,469,'[{3,0,3706618}]',2332,'[{90,1},{7,2},{2,3},{1,5}]',7227,253760,'[{2,156160},{4,3904}]'),(4,470,'[{3,0,3722040}]',2337,'[{90,1},{7,2},{2,3},{1,5}]',7244,254800,'[{2,156800},{4,3920}]'),(4,471,'[{3,0,3737463}]',2343,'[{90,1},{7,2},{2,3},{1,5}]',7261,255840,'[{2,157440},{4,3936}]'),(4,472,'[{3,0,3752885}]',2349,'[{90,1},{7,2},{2,3},{1,5}]',7279,256880,'[{2,158080},{4,3952}]'),(4,473,'[{3,0,3768308}]',2354,'[{90,1},{7,2},{2,3},{1,5}]',7296,257920,'[{2,158720},{4,3968}]'),(4,474,'[{3,0,3783732}]',2360,'[{90,1},{7,2},{2,3},{1,5}]',7313,258960,'[{2,159360},{4,3984}]'),(4,475,'[{3,0,3797544}]',2365,'[{90,1},{7,2},{2,3},{1,5}]',7331,260000,'[{2,160000},{4,4000}]'),(4,476,'[{3,0,3811356}]',2371,'[{90,1},{7,2},{2,3},{1,5}]',7348,261040,'[{2,160640},{4,4016}]'),(4,477,'[{3,0,3825168}]',2376,'[{90,1},{7,2},{2,3},{1,5}]',7365,262080,'[{2,161280},{4,4032}]'),(4,478,'[{3,0,3838980}]',2382,'[{90,1},{7,2},{2,3},{1,5}]',7383,263120,'[{2,161920},{4,4048}]'),(4,479,'[{3,0,3852791}]',2388,'[{90,1},{7,2},{2,3},{1,5}]',7400,264160,'[{2,162560},{4,4064}]'),(4,480,'[{3,0,3866603}]',2393,'[{90,1},{7,2},{2,3},{1,5}]',7417,265200,'[{2,163200},{4,4080}]'),(4,481,'[{3,0,3880415}]',2399,'[{90,1},{7,2},{2,3},{1,5}]',7435,266240,'[{2,163840},{4,4096}]'),(4,482,'[{3,0,3894227}]',2404,'[{90,1},{7,2},{2,3},{1,5}]',7452,267280,'[{2,164480},{4,4112}]'),(4,483,'[{3,0,3908039}]',2410,'[{90,1},{7,2},{2,3},{1,5}]',7470,268320,'[{2,165120},{4,4128}]'),(4,484,'[{3,0,3921851}]',2416,'[{90,1},{7,2},{2,3},{1,5}]',7487,269360,'[{2,165760},{4,4144}]'),(4,485,'[{3,0,3935663}]',2421,'[{90,1},{7,2},{2,3},{1,5}]',7504,270400,'[{2,166400},{4,4160}]'),(4,486,'[{3,0,3949475}]',2427,'[{90,1},{7,2},{2,3},{1,5}]',7522,271440,'[{2,167040},{4,4176}]'),(4,487,'[{3,0,3963287}]',2432,'[{90,1},{7,2},{2,3},{1,5}]',7539,272480,'[{2,167680},{4,4192}]'),(4,488,'[{3,0,3977099}]',2438,'[{90,1},{7,2},{2,3},{1,5}]',7557,273520,'[{2,168320},{4,4208}]'),(4,489,'[{3,0,3990911}]',2444,'[{90,1},{7,2},{2,3},{1,5}]',7574,274560,'[{2,168960},{4,4224}]'),(4,490,'[{3,0,4004723}]',2449,'[{90,1},{7,2},{2,3},{1,5}]',7591,275600,'[{2,169600},{4,4240}]'),(4,491,'[{3,0,4018535}]',2455,'[{90,1},{7,2},{2,3},{1,5}]',7609,276640,'[{2,170240},{4,4256}]'),(4,492,'[{3,0,4032347}]',2460,'[{90,1},{7,2},{2,3},{1,5}]',7626,277680,'[{2,170880},{4,4272}]'),(4,493,'[{3,0,4046159}]',2466,'[{90,1},{7,2},{2,3},{1,5}]',7644,278720,'[{2,171520},{4,4288}]'),(4,494,'[{3,0,4059970}]',2472,'[{90,1},{7,2},{2,3},{1,5}]',7661,279760,'[{2,172160},{4,4304}]'),(4,495,'[{3,0,4073782}]',2478,'[{90,1},{7,2},{2,3},{1,5}]',7679,280800,'[{2,172800},{4,4320}]'),(4,496,'[{3,0,4087594}]',2483,'[{90,1},{7,2},{2,3},{1,5}]',7696,281840,'[{2,173440},{4,4336}]'),(4,497,'[{3,0,4101406}]',2489,'[{90,1},{7,2},{2,3},{1,5}]',7714,282880,'[{2,174080},{4,4352}]'),(4,498,'[{3,0,4115218}]',2494,'[{90,1},{7,2},{2,3},{1,5}]',7731,283920,'[{2,174720},{4,4368}]'),(4,499,'[{3,0,4266667}]',2583,'[{90,1},{7,2},{2,3},{1,5}]',7749,284960,'[{2,175360},{4,4384}]'),(4,500,'[{3,0,0}]',0,'[{90,1},{7,2},{2,3},{1,5}]',0,286000,'[{2,176000},{4,4400}]'),(5,0,'[{3,0,668}]',15,'[{90,1},{7,2},{2,3},{1,5}]',58,0,'[{1,0},{3,0}]'),(5,1,'[{3,0,803}]',17,'[{90,1},{7,2},{2,3},{1,5}]',67,195,'[{1,6},{3,3}]'),(5,2,'[{3,0,937}]',19,'[{90,1},{7,2},{2,3},{1,5}]',76,390,'[{1,12},{3,6}]'),(5,3,'[{3,0,1071}]',22,'[{90,1},{7,2},{2,3},{1,5}]',86,585,'[{1,18},{3,9}]'),(5,4,'[{3,0,1205}]',24,'[{90,1},{7,2},{2,3},{1,5}]',96,780,'[{1,24},{3,12}]'),(5,5,'[{3,0,1340}]',27,'[{90,1},{7,2},{2,3},{1,5}]',106,975,'[{1,30},{3,15}]'),(5,6,'[{3,0,1474}]',29,'[{90,1},{7,2},{2,3},{1,5}]',116,1170,'[{1,36},{3,18}]'),(5,7,'[{3,0,1608}]',32,'[{90,1},{7,2},{2,3},{1,5}]',126,1365,'[{1,42},{3,21}]'),(5,8,'[{3,0,1742}]',35,'[{90,1},{7,2},{2,3},{1,5}]',137,1560,'[{1,48},{3,24}]'),(5,9,'[{3,0,1877}]',37,'[{90,1},{7,2},{2,3},{1,5}]',148,1755,'[{1,54},{3,27}]'),(5,10,'[{3,0,2011}]',40,'[{90,1},{7,2},{2,3},{1,5}]',158,1950,'[{1,60},{3,30}]'),(5,11,'[{3,0,2145}]',43,'[{90,1},{7,2},{2,3},{1,5}]',169,2145,'[{1,66},{3,33}]'),(5,12,'[{3,0,2279}]',45,'[{90,1},{7,2},{2,3},{1,5}]',180,2340,'[{1,72},{3,36}]'),(5,13,'[{3,0,2414}]',48,'[{90,1},{7,2},{2,3},{1,5}]',191,2535,'[{1,78},{3,39}]'),(5,14,'[{3,0,2548}]',51,'[{90,1},{7,2},{2,3},{1,5}]',202,2730,'[{1,84},{3,42}]'),(5,15,'[{3,0,2682}]',54,'[{90,1},{7,2},{2,3},{1,5}]',214,2925,'[{1,90},{3,45}]'),(5,16,'[{3,0,2816}]',57,'[{90,1},{7,2},{2,3},{1,5}]',225,3120,'[{1,96},{3,48}]'),(5,17,'[{3,0,2951}]',59,'[{90,1},{7,2},{2,3},{1,5}]',236,3315,'[{1,102},{3,51}]'),(5,18,'[{3,0,3085}]',62,'[{90,1},{7,2},{2,3},{1,5}]',248,3510,'[{1,108},{3,54}]'),(5,19,'[{3,0,3219}]',65,'[{90,1},{7,2},{2,3},{1,5}]',259,3705,'[{1,114},{3,57}]'),(5,20,'[{3,0,3353}]',68,'[{90,1},{7,2},{2,3},{1,5}]',271,3900,'[{1,120},{3,60}]'),(5,21,'[{3,0,3488}]',71,'[{90,1},{7,2},{2,3},{1,5}]',282,4095,'[{1,126},{3,63}]'),(5,22,'[{3,0,3622}]',74,'[{90,1},{7,2},{2,3},{1,5}]',294,4290,'[{1,132},{3,66}]'),(5,23,'[{3,0,3756}]',77,'[{90,1},{7,2},{2,3},{1,5}]',306,4485,'[{1,138},{3,69}]'),(5,24,'[{3,0,3891}]',80,'[{90,1},{7,2},{2,3},{1,5}]',318,4680,'[{1,144},{3,72}]'),(5,25,'[{3,0,4239}]',83,'[{90,1},{7,2},{2,3},{1,5}]',330,4875,'[{1,150},{3,75}]'),(5,26,'[{3,0,4587}]',86,'[{90,1},{7,2},{2,3},{1,5}]',342,5070,'[{1,156},{3,78}]'),(5,27,'[{3,0,4936}]',89,'[{90,1},{7,2},{2,3},{1,5}]',354,5265,'[{1,162},{3,81}]'),(5,28,'[{3,0,5284}]',92,'[{90,1},{7,2},{2,3},{1,5}]',366,5460,'[{1,168},{3,84}]'),(5,29,'[{3,0,5632}]',95,'[{90,1},{7,2},{2,3},{1,5}]',378,5655,'[{1,174},{3,87}]'),(5,30,'[{3,0,5980}]',98,'[{90,1},{7,2},{2,3},{1,5}]',390,5850,'[{1,180},{3,90}]'),(5,31,'[{3,0,6329}]',101,'[{90,1},{7,2},{2,3},{1,5}]',402,6045,'[{1,186},{3,93}]'),(5,32,'[{3,0,6677}]',104,'[{90,1},{7,2},{2,3},{1,5}]',414,6240,'[{1,192},{3,96}]'),(5,33,'[{3,0,7025}]',107,'[{90,1},{7,2},{2,3},{1,5}]',426,6435,'[{1,198},{3,99}]'),(5,34,'[{3,0,7373}]',110,'[{90,1},{7,2},{2,3},{1,5}]',439,6630,'[{1,204},{3,102}]'),(5,35,'[{3,0,7722}]',113,'[{90,1},{7,2},{2,3},{1,5}]',451,6825,'[{1,210},{3,105}]'),(5,36,'[{3,0,8070}]',116,'[{90,1},{7,2},{2,3},{1,5}]',464,7020,'[{1,216},{3,108}]'),(5,37,'[{3,0,8418}]',119,'[{90,1},{7,2},{2,3},{1,5}]',476,7215,'[{1,222},{3,111}]'),(5,38,'[{3,0,8766}]',122,'[{90,1},{7,2},{2,3},{1,5}]',488,7410,'[{1,228},{3,114}]'),(5,39,'[{3,0,9115}]',126,'[{90,1},{7,2},{2,3},{1,5}]',501,7605,'[{1,234},{3,117}]'),(5,40,'[{3,0,9463}]',129,'[{90,1},{7,2},{2,3},{1,5}]',514,7800,'[{1,240},{3,120}]'),(5,41,'[{3,0,9811}]',132,'[{90,1},{7,2},{2,3},{1,5}]',526,7995,'[{1,246},{3,123}]'),(5,42,'[{3,0,10159}]',135,'[{90,1},{7,2},{2,3},{1,5}]',539,8190,'[{1,252},{3,126}]'),(5,43,'[{3,0,10508}]',138,'[{90,1},{7,2},{2,3},{1,5}]',551,8385,'[{1,258},{3,129}]'),(5,44,'[{3,0,10856}]',141,'[{90,1},{7,2},{2,3},{1,5}]',564,8580,'[{1,264},{3,132}]'),(5,45,'[{3,0,11204}]',145,'[{90,1},{7,2},{2,3},{1,5}]',577,8775,'[{1,270},{3,135}]'),(5,46,'[{3,0,11552}]',148,'[{90,1},{7,2},{2,3},{1,5}]',590,8970,'[{1,276},{3,138}]'),(5,47,'[{3,0,11901}]',151,'[{90,1},{7,2},{2,3},{1,5}]',602,9165,'[{1,282},{3,141}]'),(5,48,'[{3,0,12249}]',154,'[{90,1},{7,2},{2,3},{1,5}]',615,9360,'[{1,288},{3,144}]'),(5,49,'[{3,0,12923}]',162,'[{90,1},{7,2},{2,3},{1,5}]',628,9555,'[{1,294},{3,147}]'),(5,50,'[{3,0,13425}]',165,'[{90,1},{7,2},{2,3},{1,5}]',641,9750,'[{1,300},{3,150}]'),(5,51,'[{3,0,13927}]',168,'[{90,1},{7,2},{2,3},{1,5}]',654,9945,'[{1,306},{3,153}]'),(5,52,'[{3,0,14429}]',172,'[{90,1},{7,2},{2,3},{1,5}]',667,10140,'[{1,312},{3,156}]'),(5,53,'[{3,0,14931}]',175,'[{90,1},{7,2},{2,3},{1,5}]',680,10335,'[{1,318},{3,159}]'),(5,54,'[{3,0,15433}]',178,'[{90,1},{7,2},{2,3},{1,5}]',693,10530,'[{1,324},{3,162}]'),(5,55,'[{3,0,15935}]',182,'[{90,1},{7,2},{2,3},{1,5}]',706,10725,'[{1,330},{3,165}]'),(5,56,'[{3,0,16437}]',185,'[{90,1},{7,2},{2,3},{1,5}]',719,10920,'[{1,336},{3,168}]'),(5,57,'[{3,0,16939}]',188,'[{90,1},{7,2},{2,3},{1,5}]',732,11115,'[{1,342},{3,171}]'),(5,58,'[{3,0,17442}]',192,'[{90,1},{7,2},{2,3},{1,5}]',745,11310,'[{1,348},{3,174}]'),(5,59,'[{3,0,17944}]',195,'[{90,1},{7,2},{2,3},{1,5}]',758,11505,'[{1,354},{3,177}]'),(5,60,'[{3,0,18446}]',198,'[{90,1},{7,2},{2,3},{1,5}]',771,11700,'[{1,360},{3,180}]'),(5,61,'[{3,0,18948}]',202,'[{90,1},{7,2},{2,3},{1,5}]',785,11895,'[{1,366},{3,183}]'),(5,62,'[{3,0,19450}]',205,'[{90,1},{7,2},{2,3},{1,5}]',798,12090,'[{1,372},{3,186}]'),(5,63,'[{3,0,19952}]',208,'[{90,1},{7,2},{2,3},{1,5}]',811,12285,'[{1,378},{3,189}]'),(5,64,'[{3,0,20454}]',212,'[{90,1},{7,2},{2,3},{1,5}]',824,12480,'[{1,384},{3,192}]'),(5,65,'[{3,0,20956}]',215,'[{90,1},{7,2},{2,3},{1,5}]',838,12675,'[{1,390},{3,195}]'),(5,66,'[{3,0,21458}]',219,'[{90,1},{7,2},{2,3},{1,5}]',851,12870,'[{1,396},{3,198}]'),(5,67,'[{3,0,21960}]',222,'[{90,1},{7,2},{2,3},{1,5}]',864,13065,'[{1,402},{3,201}]'),(5,68,'[{3,0,22462}]',226,'[{90,1},{7,2},{2,3},{1,5}]',878,13260,'[{1,408},{3,204}]'),(5,69,'[{3,0,22964}]',229,'[{90,1},{7,2},{2,3},{1,5}]',891,13455,'[{1,414},{3,207}]'),(5,70,'[{3,0,23466}]',233,'[{90,1},{7,2},{2,3},{1,5}]',905,13650,'[{1,420},{3,210}]'),(5,71,'[{3,0,23968}]',236,'[{90,1},{7,2},{2,3},{1,5}]',918,13845,'[{1,426},{3,213}]'),(5,72,'[{3,0,24470}]',239,'[{90,1},{7,2},{2,3},{1,5}]',932,14040,'[{1,432},{3,216}]'),(5,73,'[{3,0,24972}]',243,'[{90,1},{7,2},{2,3},{1,5}]',945,14235,'[{1,438},{3,219}]'),(5,74,'[{3,0,25472}]',246,'[{90,1},{7,2},{2,3},{1,5}]',959,14430,'[{1,444},{3,222}]'),(5,75,'[{3,0,25627}]',250,'[{90,1},{7,2},{2,3},{1,5}]',972,14625,'[{1,450},{3,225}]'),(5,76,'[{3,0,25783}]',253,'[{90,1},{7,2},{2,3},{1,5}]',986,14820,'[{1,456},{3,228}]'),(5,77,'[{3,0,25938}]',257,'[{90,1},{7,2},{2,3},{1,5}]',999,15015,'[{1,462},{3,231}]'),(5,78,'[{3,0,26094}]',260,'[{90,1},{7,2},{2,3},{1,5}]',1013,15210,'[{1,468},{3,234}]'),(5,79,'[{3,0,26249}]',264,'[{90,1},{7,2},{2,3},{1,5}]',1027,15405,'[{1,474},{3,237}]'),(5,80,'[{3,0,26404}]',267,'[{90,1},{7,2},{2,3},{1,5}]',1040,15600,'[{1,480},{3,240}]'),(5,81,'[{3,0,26560}]',271,'[{90,1},{7,2},{2,3},{1,5}]',1054,15795,'[{1,486},{3,243}]'),(5,82,'[{3,0,26715}]',274,'[{90,1},{7,2},{2,3},{1,5}]',1068,15990,'[{1,492},{3,246}]'),(5,83,'[{3,0,26870}]',278,'[{90,1},{7,2},{2,3},{1,5}]',1081,16185,'[{1,498},{3,249}]'),(5,84,'[{3,0,27026}]',281,'[{90,1},{7,2},{2,3},{1,5}]',1095,16380,'[{1,504},{3,252}]'),(5,85,'[{3,0,27181}]',285,'[{90,1},{7,2},{2,3},{1,5}]',1109,16575,'[{1,510},{3,255}]'),(5,86,'[{3,0,27337}]',288,'[{90,1},{7,2},{2,3},{1,5}]',1123,16770,'[{1,516},{3,258}]'),(5,87,'[{3,0,27492}]',292,'[{90,1},{7,2},{2,3},{1,5}]',1136,16965,'[{1,522},{3,261}]'),(5,88,'[{3,0,27647}]',295,'[{90,1},{7,2},{2,3},{1,5}]',1150,17160,'[{1,528},{3,264}]'),(5,89,'[{3,0,27803}]',299,'[{90,1},{7,2},{2,3},{1,5}]',1164,17355,'[{1,534},{3,267}]'),(5,90,'[{3,0,27958}]',303,'[{90,1},{7,2},{2,3},{1,5}]',1178,17550,'[{1,540},{3,270}]'),(5,91,'[{3,0,28114}]',306,'[{90,1},{7,2},{2,3},{1,5}]',1192,17745,'[{1,546},{3,273}]'),(5,92,'[{3,0,28269}]',310,'[{90,1},{7,2},{2,3},{1,5}]',1206,17940,'[{1,552},{3,276}]'),(5,93,'[{3,0,28424}]',313,'[{90,1},{7,2},{2,3},{1,5}]',1220,18135,'[{1,558},{3,279}]'),(5,94,'[{3,0,28580}]',317,'[{90,1},{7,2},{2,3},{1,5}]',1234,18330,'[{1,564},{3,282}]'),(5,95,'[{3,0,28735}]',320,'[{90,1},{7,2},{2,3},{1,5}]',1248,18525,'[{1,570},{3,285}]'),(5,96,'[{3,0,28890}]',324,'[{90,1},{7,2},{2,3},{1,5}]',1262,18720,'[{1,576},{3,288}]'),(5,97,'[{3,0,29046}]',328,'[{90,1},{7,2},{2,3},{1,5}]',1276,18915,'[{1,582},{3,291}]'),(5,98,'[{3,0,29201}]',331,'[{90,1},{7,2},{2,3},{1,5}]',1290,19110,'[{1,588},{3,294}]'),(5,99,'[{3,0,30126}]',344,'[{90,1},{7,2},{2,3},{1,5}]',1304,19305,'[{1,594},{3,297}]'),(5,100,'[{3,0,30194}]',347,'[{90,1},{7,2},{2,3},{1,5}]',1318,19500,'[{1,600},{3,300}]'),(5,101,'[{3,0,30263}]',351,'[{90,1},{7,2},{2,3},{1,5}]',1332,19825,'[{1,610},{3,305}]'),(5,102,'[{3,0,30331}]',355,'[{90,1},{7,2},{2,3},{1,5}]',1346,20150,'[{1,620},{3,310}]'),(5,103,'[{3,0,30400}]',358,'[{90,1},{7,2},{2,3},{1,5}]',1360,20475,'[{1,630},{3,315}]'),(5,104,'[{3,0,30468}]',362,'[{90,1},{7,2},{2,3},{1,5}]',1374,20800,'[{1,640},{3,320}]'),(5,105,'[{3,0,30537}]',366,'[{90,1},{7,2},{2,3},{1,5}]',1388,21125,'[{1,650},{3,325}]'),(5,106,'[{3,0,30605}]',369,'[{90,1},{7,2},{2,3},{1,5}]',1402,21450,'[{1,660},{3,330}]'),(5,107,'[{3,0,30673}]',373,'[{90,1},{7,2},{2,3},{1,5}]',1416,21775,'[{1,670},{3,335}]'),(5,108,'[{3,0,30742}]',377,'[{90,1},{7,2},{2,3},{1,5}]',1431,22100,'[{1,680},{3,340}]'),(5,109,'[{3,0,30810}]',381,'[{90,1},{7,2},{2,3},{1,5}]',1445,22425,'[{1,690},{3,345}]'),(5,110,'[{3,0,30879}]',384,'[{90,1},{7,2},{2,3},{1,5}]',1459,22750,'[{1,700},{3,350}]'),(5,111,'[{3,0,30947}]',388,'[{90,1},{7,2},{2,3},{1,5}]',1473,23075,'[{1,710},{3,355}]'),(5,112,'[{3,0,31015}]',392,'[{90,1},{7,2},{2,3},{1,5}]',1488,23400,'[{1,720},{3,360}]'),(5,113,'[{3,0,31084}]',396,'[{90,1},{7,2},{2,3},{1,5}]',1502,23725,'[{1,730},{3,365}]'),(5,114,'[{3,0,31152}]',399,'[{90,1},{7,2},{2,3},{1,5}]',1516,24050,'[{1,740},{3,370}]'),(5,115,'[{3,0,31221}]',403,'[{90,1},{7,2},{2,3},{1,5}]',1530,24375,'[{1,750},{3,375}]'),(5,116,'[{3,0,31289}]',407,'[{90,1},{7,2},{2,3},{1,5}]',1545,24700,'[{1,760},{3,380}]'),(5,117,'[{3,0,31358}]',411,'[{90,1},{7,2},{2,3},{1,5}]',1559,25025,'[{1,770},{3,385}]'),(5,118,'[{3,0,31426}]',414,'[{90,1},{7,2},{2,3},{1,5}]',1573,25350,'[{1,780},{3,390}]'),(5,119,'[{3,0,31494}]',418,'[{90,1},{7,2},{2,3},{1,5}]',1588,25675,'[{1,790},{3,395}]'),(5,120,'[{3,0,31563}]',422,'[{90,1},{7,2},{2,3},{1,5}]',1602,26000,'[{1,800},{3,400}]'),(5,121,'[{3,0,31631}]',426,'[{90,1},{7,2},{2,3},{1,5}]',1617,26325,'[{1,810},{3,405}]'),(5,122,'[{3,0,31700}]',430,'[{90,1},{7,2},{2,3},{1,5}]',1631,26650,'[{1,820},{3,410}]'),(5,123,'[{3,0,31768}]',434,'[{90,1},{7,2},{2,3},{1,5}]',1646,26975,'[{1,830},{3,415}]'),(5,124,'[{3,0,31837}]',437,'[{90,1},{7,2},{2,3},{1,5}]',1660,27300,'[{1,840},{3,420}]'),(5,125,'[{3,0,32159}]',441,'[{90,1},{7,2},{2,3},{1,5}]',1674,27625,'[{1,850},{3,425}]'),(5,126,'[{3,0,32481}]',445,'[{90,1},{7,2},{2,3},{1,5}]',1689,27950,'[{1,860},{3,430}]'),(5,127,'[{3,0,32803}]',449,'[{90,1},{7,2},{2,3},{1,5}]',1703,28275,'[{1,870},{3,435}]'),(5,128,'[{3,0,33125}]',453,'[{90,1},{7,2},{2,3},{1,5}]',1718,28600,'[{1,880},{3,440}]'),(5,129,'[{3,0,33447}]',456,'[{90,1},{7,2},{2,3},{1,5}]',1732,28925,'[{1,890},{3,445}]'),(5,130,'[{3,0,33769}]',460,'[{90,1},{7,2},{2,3},{1,5}]',1747,29250,'[{1,900},{3,450}]'),(5,131,'[{3,0,34091}]',464,'[{90,1},{7,2},{2,3},{1,5}]',1762,29575,'[{1,910},{3,455}]'),(5,132,'[{3,0,34413}]',468,'[{90,1},{7,2},{2,3},{1,5}]',1776,29900,'[{1,920},{3,460}]'),(5,133,'[{3,0,34735}]',472,'[{90,1},{7,2},{2,3},{1,5}]',1791,30225,'[{1,930},{3,465}]'),(5,134,'[{3,0,35058}]',475,'[{90,1},{7,2},{2,3},{1,5}]',1805,30550,'[{1,940},{3,470}]'),(5,135,'[{3,0,35380}]',479,'[{90,1},{7,2},{2,3},{1,5}]',1820,30875,'[{1,950},{3,475}]'),(5,136,'[{3,0,35702}]',483,'[{90,1},{7,2},{2,3},{1,5}]',1834,31200,'[{1,960},{3,480}]'),(5,137,'[{3,0,36024}]',487,'[{90,1},{7,2},{2,3},{1,5}]',1849,31525,'[{1,970},{3,485}]'),(5,138,'[{3,0,36346}]',491,'[{90,1},{7,2},{2,3},{1,5}]',1864,31850,'[{1,980},{3,490}]'),(5,139,'[{3,0,36668}]',495,'[{90,1},{7,2},{2,3},{1,5}]',1878,32175,'[{1,990},{3,495}]'),(5,140,'[{3,0,36990}]',499,'[{90,1},{7,2},{2,3},{1,5}]',1893,32500,'[{1,1000},{3,500}]'),(5,141,'[{3,0,37312}]',503,'[{90,1},{7,2},{2,3},{1,5}]',1908,32825,'[{1,1010},{3,505}]'),(5,142,'[{3,0,37634}]',507,'[{90,1},{7,2},{2,3},{1,5}]',1923,33150,'[{1,1020},{3,510}]'),(5,143,'[{3,0,37957}]',510,'[{90,1},{7,2},{2,3},{1,5}]',1937,33475,'[{1,1030},{3,515}]'),(5,144,'[{3,0,38279}]',514,'[{90,1},{7,2},{2,3},{1,5}]',1952,33800,'[{1,1040},{3,520}]'),(5,145,'[{3,0,38601}]',518,'[{90,1},{7,2},{2,3},{1,5}]',1967,34125,'[{1,1050},{3,525}]'),(5,146,'[{3,0,38923}]',522,'[{90,1},{7,2},{2,3},{1,5}]',1981,34450,'[{1,1060},{3,530}]'),(5,147,'[{3,0,39245}]',526,'[{90,1},{7,2},{2,3},{1,5}]',1996,34775,'[{1,1070},{3,535}]'),(5,148,'[{3,0,39567}]',530,'[{90,1},{7,2},{2,3},{1,5}]',2011,35100,'[{1,1080},{3,540}]'),(5,149,'[{3,0,40965}]',548,'[{90,1},{7,2},{2,3},{1,5}]',2026,35425,'[{1,1090},{3,545}]'),(5,150,'[{3,0,41443}]',552,'[{90,1},{7,2},{2,3},{1,5}]',2041,35750,'[{1,1100},{3,550}]'),(5,151,'[{3,0,41922}]',556,'[{90,1},{7,2},{2,3},{1,5}]',2055,36075,'[{1,1110},{3,555}]'),(5,152,'[{3,0,42401}]',560,'[{90,1},{7,2},{2,3},{1,5}]',2070,36400,'[{1,1120},{3,560}]'),(5,153,'[{3,0,42879}]',564,'[{90,1},{7,2},{2,3},{1,5}]',2085,36725,'[{1,1130},{3,565}]'),(5,154,'[{3,0,43358}]',568,'[{90,1},{7,2},{2,3},{1,5}]',2100,37050,'[{1,1140},{3,570}]'),(5,155,'[{3,0,43837}]',572,'[{90,1},{7,2},{2,3},{1,5}]',2115,37375,'[{1,1150},{3,575}]'),(5,156,'[{3,0,44315}]',576,'[{90,1},{7,2},{2,3},{1,5}]',2130,37700,'[{1,1160},{3,580}]'),(5,157,'[{3,0,44794}]',580,'[{90,1},{7,2},{2,3},{1,5}]',2145,38025,'[{1,1170},{3,585}]'),(5,158,'[{3,0,45273}]',584,'[{90,1},{7,2},{2,3},{1,5}]',2160,38350,'[{1,1180},{3,590}]'),(5,159,'[{3,0,45751}]',588,'[{90,1},{7,2},{2,3},{1,5}]',2175,38675,'[{1,1190},{3,595}]'),(5,160,'[{3,0,46230}]',592,'[{90,1},{7,2},{2,3},{1,5}]',2189,39000,'[{1,1200},{3,600}]'),(5,161,'[{3,0,46709}]',596,'[{90,1},{7,2},{2,3},{1,5}]',2204,39325,'[{1,1210},{3,605}]'),(5,162,'[{3,0,47187}]',600,'[{90,1},{7,2},{2,3},{1,5}]',2219,39650,'[{1,1220},{3,610}]'),(5,163,'[{3,0,47666}]',604,'[{90,1},{7,2},{2,3},{1,5}]',2234,39975,'[{1,1230},{3,615}]'),(5,164,'[{3,0,48145}]',608,'[{90,1},{7,2},{2,3},{1,5}]',2249,40300,'[{1,1240},{3,620}]'),(5,165,'[{3,0,48623}]',612,'[{90,1},{7,2},{2,3},{1,5}]',2264,40625,'[{1,1250},{3,625}]'),(5,166,'[{3,0,49102}]',616,'[{90,1},{7,2},{2,3},{1,5}]',2279,40950,'[{1,1260},{3,630}]'),(5,167,'[{3,0,49580}]',620,'[{90,1},{7,2},{2,3},{1,5}]',2294,41275,'[{1,1270},{3,635}]'),(5,168,'[{3,0,50059}]',625,'[{90,1},{7,2},{2,3},{1,5}]',2309,41600,'[{1,1280},{3,640}]'),(5,169,'[{3,0,50538}]',629,'[{90,1},{7,2},{2,3},{1,5}]',2324,41925,'[{1,1290},{3,645}]'),(5,170,'[{3,0,51016}]',633,'[{90,1},{7,2},{2,3},{1,5}]',2340,42250,'[{1,1300},{3,650}]'),(5,171,'[{3,0,51495}]',637,'[{90,1},{7,2},{2,3},{1,5}]',2355,42575,'[{1,1310},{3,655}]'),(5,172,'[{3,0,51974}]',641,'[{90,1},{7,2},{2,3},{1,5}]',2370,42900,'[{1,1320},{3,660}]'),(5,173,'[{3,0,52452}]',645,'[{90,1},{7,2},{2,3},{1,5}]',2385,43225,'[{1,1330},{3,665}]'),(5,174,'[{3,0,52931}]',649,'[{90,1},{7,2},{2,3},{1,5}]',2400,43550,'[{1,1340},{3,670}]'),(5,175,'[{3,0,53077}]',653,'[{90,1},{7,2},{2,3},{1,5}]',2415,43875,'[{1,1350},{3,675}]'),(5,176,'[{3,0,53222}]',657,'[{90,1},{7,2},{2,3},{1,5}]',2430,44200,'[{1,1360},{3,680}]'),(5,177,'[{3,0,53368}]',661,'[{90,1},{7,2},{2,3},{1,5}]',2445,44525,'[{1,1370},{3,685}]'),(5,178,'[{3,0,53514}]',665,'[{90,1},{7,2},{2,3},{1,5}]',2460,44850,'[{1,1380},{3,690}]'),(5,179,'[{3,0,53659}]',670,'[{90,1},{7,2},{2,3},{1,5}]',2476,45175,'[{1,1390},{3,695}]'),(5,180,'[{3,0,53805}]',674,'[{90,1},{7,2},{2,3},{1,5}]',2491,45500,'[{1,1400},{3,700}]'),(5,181,'[{3,0,53951}]',678,'[{90,1},{7,2},{2,3},{1,5}]',2506,45825,'[{1,1410},{3,705}]'),(5,182,'[{3,0,54096}]',682,'[{90,1},{7,2},{2,3},{1,5}]',2521,46150,'[{1,1420},{3,710}]'),(5,183,'[{3,0,54242}]',686,'[{90,1},{7,2},{2,3},{1,5}]',2536,46475,'[{1,1430},{3,715}]'),(5,184,'[{3,0,54388}]',690,'[{90,1},{7,2},{2,3},{1,5}]',2552,46800,'[{1,1440},{3,720}]'),(5,185,'[{3,0,54533}]',694,'[{90,1},{7,2},{2,3},{1,5}]',2567,47125,'[{1,1450},{3,725}]'),(5,186,'[{3,0,54679}]',698,'[{90,1},{7,2},{2,3},{1,5}]',2582,47450,'[{1,1460},{3,730}]'),(5,187,'[{3,0,54825}]',702,'[{90,1},{7,2},{2,3},{1,5}]',2597,47775,'[{1,1470},{3,735}]'),(5,188,'[{3,0,54970}]',707,'[{90,1},{7,2},{2,3},{1,5}]',2613,48100,'[{1,1480},{3,740}]'),(5,189,'[{3,0,55116}]',711,'[{90,1},{7,2},{2,3},{1,5}]',2628,48425,'[{1,1490},{3,745}]'),(5,190,'[{3,0,55262}]',715,'[{90,1},{7,2},{2,3},{1,5}]',2643,48750,'[{1,1500},{3,750}]'),(5,191,'[{3,0,55408}]',719,'[{90,1},{7,2},{2,3},{1,5}]',2658,49075,'[{1,1510},{3,755}]'),(5,192,'[{3,0,55553}]',723,'[{90,1},{7,2},{2,3},{1,5}]',2674,49400,'[{1,1520},{3,760}]'),(5,193,'[{3,0,55699}]',727,'[{90,1},{7,2},{2,3},{1,5}]',2689,49725,'[{1,1530},{3,765}]'),(5,194,'[{3,0,55845}]',731,'[{90,1},{7,2},{2,3},{1,5}]',2704,50050,'[{1,1540},{3,770}]'),(5,195,'[{3,0,55990}]',736,'[{90,1},{7,2},{2,3},{1,5}]',2720,50375,'[{1,1550},{3,775}]'),(5,196,'[{3,0,56136}]',740,'[{90,1},{7,2},{2,3},{1,5}]',2735,50700,'[{1,1560},{3,780}]'),(5,197,'[{3,0,56282}]',744,'[{90,1},{7,2},{2,3},{1,5}]',2750,51025,'[{1,1570},{3,785}]'),(5,198,'[{3,0,56427}]',748,'[{90,1},{7,2},{2,3},{1,5}]',2766,51350,'[{1,1580},{3,790}]'),(5,199,'[{3,0,58145}]',773,'[{90,1},{7,2},{2,3},{1,5}]',2781,51675,'[{1,1590},{3,795}]'),(5,200,'[{3,0,58298}]',777,'[{90,1},{7,2},{2,3},{1,5}]',2797,52000,'[{1,1600},{3,800}]'),(5,201,'[{3,0,58451}]',782,'[{90,1},{7,2},{2,3},{1,5}]',2812,52520,'[{1,1616},{3,808}]'),(5,202,'[{3,0,58604}]',786,'[{90,1},{7,2},{2,3},{1,5}]',2827,53040,'[{1,1632},{3,816}]'),(5,203,'[{3,0,58757}]',790,'[{90,1},{7,2},{2,3},{1,5}]',2843,53560,'[{1,1648},{3,824}]'),(5,204,'[{3,0,58910}]',794,'[{90,1},{7,2},{2,3},{1,5}]',2858,54080,'[{1,1664},{3,832}]'),(5,205,'[{3,0,59063}]',799,'[{90,1},{7,2},{2,3},{1,5}]',2874,54600,'[{1,1680},{3,840}]'),(5,206,'[{3,0,59216}]',803,'[{90,1},{7,2},{2,3},{1,5}]',2889,55120,'[{1,1696},{3,848}]'),(5,207,'[{3,0,59369}]',807,'[{90,1},{7,2},{2,3},{1,5}]',2905,55640,'[{1,1712},{3,856}]'),(5,208,'[{3,0,59522}]',812,'[{90,1},{7,2},{2,3},{1,5}]',2920,56160,'[{1,1728},{3,864}]'),(5,209,'[{3,0,59675}]',816,'[{90,1},{7,2},{2,3},{1,5}]',2936,56680,'[{1,1744},{3,872}]'),(5,210,'[{3,0,59828}]',820,'[{90,1},{7,2},{2,3},{1,5}]',2951,57200,'[{1,1760},{3,880}]'),(5,211,'[{3,0,59981}]',825,'[{90,1},{7,2},{2,3},{1,5}]',2967,57720,'[{1,1776},{3,888}]'),(5,212,'[{3,0,60134}]',829,'[{90,1},{7,2},{2,3},{1,5}]',2982,58240,'[{1,1792},{3,896}]'),(5,213,'[{3,0,60287}]',833,'[{90,1},{7,2},{2,3},{1,5}]',2998,58760,'[{1,1808},{3,904}]'),(5,214,'[{3,0,60440}]',837,'[{90,1},{7,2},{2,3},{1,5}]',3013,59280,'[{1,1824},{3,912}]'),(5,215,'[{3,0,60594}]',842,'[{90,1},{7,2},{2,3},{1,5}]',3029,59800,'[{1,1840},{3,920}]'),(5,216,'[{3,0,60747}]',846,'[{90,1},{7,2},{2,3},{1,5}]',3044,60320,'[{1,1856},{3,928}]'),(5,217,'[{3,0,60900}]',850,'[{90,1},{7,2},{2,3},{1,5}]',3060,60840,'[{1,1872},{3,936}]'),(5,218,'[{3,0,61053}]',855,'[{90,1},{7,2},{2,3},{1,5}]',3075,61360,'[{1,1888},{3,944}]'),(5,219,'[{3,0,61206}]',859,'[{90,1},{7,2},{2,3},{1,5}]',3091,61880,'[{1,1904},{3,952}]'),(5,220,'[{3,0,61359}]',864,'[{90,1},{7,2},{2,3},{1,5}]',3107,62400,'[{1,1920},{3,960}]'),(5,221,'[{3,0,61512}]',868,'[{90,1},{7,2},{2,3},{1,5}]',3122,62920,'[{1,1936},{3,968}]'),(5,222,'[{3,0,61665}]',872,'[{90,1},{7,2},{2,3},{1,5}]',3138,63440,'[{1,1952},{3,976}]'),(5,223,'[{3,0,61818}]',876,'[{90,1},{7,2},{2,3},{1,5}]',3153,63960,'[{1,1968},{3,984}]'),(5,224,'[{3,0,61974}]',881,'[{90,1},{7,2},{2,3},{1,5}]',3169,64480,'[{1,1984},{3,992}]'),(5,225,'[{3,0,68137}]',885,'[{90,1},{7,2},{2,3},{1,5}]',3185,65000,'[{1,2000},{3,1000}]'),(5,226,'[{3,0,74299}]',889,'[{90,1},{7,2},{2,3},{1,5}]',3200,65520,'[{1,2016},{3,1008}]'),(5,227,'[{3,0,80461}]',894,'[{90,1},{7,2},{2,3},{1,5}]',3216,66040,'[{1,2032},{3,1016}]'),(5,228,'[{3,0,86623}]',898,'[{90,1},{7,2},{2,3},{1,5}]',3232,66560,'[{1,2048},{3,1024}]'),(5,229,'[{3,0,92785}]',902,'[{90,1},{7,2},{2,3},{1,5}]',3247,67080,'[{1,2064},{3,1032}]'),(5,230,'[{3,0,98948}]',907,'[{90,1},{7,2},{2,3},{1,5}]',3263,67600,'[{1,2080},{3,1040}]'),(5,231,'[{3,0,105110}]',911,'[{90,1},{7,2},{2,3},{1,5}]',3279,68120,'[{1,2096},{3,1048}]'),(5,232,'[{3,0,111272}]',915,'[{90,1},{7,2},{2,3},{1,5}]',3294,68640,'[{1,2112},{3,1056}]'),(5,233,'[{3,0,117434}]',920,'[{90,1},{7,2},{2,3},{1,5}]',3310,69160,'[{1,2128},{3,1064}]'),(5,234,'[{3,0,123597}]',924,'[{90,1},{7,2},{2,3},{1,5}]',3326,69680,'[{1,2144},{3,1072}]'),(5,235,'[{3,0,129759}]',929,'[{90,1},{7,2},{2,3},{1,5}]',3342,70200,'[{1,2160},{3,1080}]'),(5,236,'[{3,0,135921}]',933,'[{90,1},{7,2},{2,3},{1,5}]',3357,70720,'[{1,2176},{3,1088}]'),(5,237,'[{3,0,142083}]',937,'[{90,1},{7,2},{2,3},{1,5}]',3373,71240,'[{1,2192},{3,1096}]'),(5,238,'[{3,0,148245}]',942,'[{90,1},{7,2},{2,3},{1,5}]',3389,71760,'[{1,2208},{3,1104}]'),(5,239,'[{3,0,154408}]',946,'[{90,1},{7,2},{2,3},{1,5}]',3405,72280,'[{1,2224},{3,1112}]'),(5,240,'[{3,0,160570}]',950,'[{90,1},{7,2},{2,3},{1,5}]',3420,72800,'[{1,2240},{3,1120}]'),(5,241,'[{3,0,166732}]',955,'[{90,1},{7,2},{2,3},{1,5}]',3436,73320,'[{1,2256},{3,1128}]'),(5,242,'[{3,0,172894}]',959,'[{90,1},{7,2},{2,3},{1,5}]',3452,73840,'[{1,2272},{3,1136}]'),(5,243,'[{3,0,179057}]',964,'[{90,1},{7,2},{2,3},{1,5}]',3468,74360,'[{1,2288},{3,1144}]'),(5,244,'[{3,0,185219}]',968,'[{90,1},{7,2},{2,3},{1,5}]',3484,74880,'[{1,2304},{3,1152}]'),(5,245,'[{3,0,191381}]',972,'[{90,1},{7,2},{2,3},{1,5}]',3499,75400,'[{1,2320},{3,1160}]'),(5,246,'[{3,0,197543}]',977,'[{90,1},{7,2},{2,3},{1,5}]',3515,75920,'[{1,2336},{3,1168}]'),(5,247,'[{3,0,203705}]',981,'[{90,1},{7,2},{2,3},{1,5}]',3531,76440,'[{1,2352},{3,1176}]'),(5,248,'[{3,0,209868}]',986,'[{90,1},{7,2},{2,3},{1,5}]',3547,76960,'[{1,2368},{3,1184}]'),(5,249,'[{3,0,222203}]',1018,'[{90,1},{7,2},{2,3},{1,5}]',3563,77480,'[{1,2384},{3,1192}]'),(5,250,'[{3,0,228297}]',1023,'[{90,1},{7,2},{2,3},{1,5}]',3579,78000,'[{1,2400},{3,1200}]'),(5,251,'[{3,0,234391}]',1028,'[{90,1},{7,2},{2,3},{1,5}]',3595,78520,'[{1,2416},{3,1208}]'),(5,252,'[{3,0,240485}]',1032,'[{90,1},{7,2},{2,3},{1,5}]',3610,79040,'[{1,2432},{3,1216}]'),(5,253,'[{3,0,246579}]',1036,'[{90,1},{7,2},{2,3},{1,5}]',3626,79560,'[{1,2448},{3,1224}]'),(5,254,'[{3,0,252673}]',1041,'[{90,1},{7,2},{2,3},{1,5}]',3642,80080,'[{1,2464},{3,1232}]'),(5,255,'[{3,0,258767}]',1046,'[{90,1},{7,2},{2,3},{1,5}]',3658,80600,'[{1,2480},{3,1240}]'),(5,256,'[{3,0,264861}]',1050,'[{90,1},{7,2},{2,3},{1,5}]',3674,81120,'[{1,2496},{3,1248}]'),(5,257,'[{3,0,270955}]',1055,'[{90,1},{7,2},{2,3},{1,5}]',3690,81640,'[{1,2512},{3,1256}]'),(5,258,'[{3,0,277049}]',1059,'[{90,1},{7,2},{2,3},{1,5}]',3706,82160,'[{1,2528},{3,1264}]'),(5,259,'[{3,0,283143}]',1064,'[{90,1},{7,2},{2,3},{1,5}]',3722,82680,'[{1,2544},{3,1272}]'),(5,260,'[{3,0,289237}]',1068,'[{90,1},{7,2},{2,3},{1,5}]',3738,83200,'[{1,2560},{3,1280}]'),(5,261,'[{3,0,295331}]',1073,'[{90,1},{7,2},{2,3},{1,5}]',3754,83720,'[{1,2576},{3,1288}]'),(5,262,'[{3,0,301425}]',1078,'[{90,1},{7,2},{2,3},{1,5}]',3770,84240,'[{1,2592},{3,1296}]'),(5,263,'[{3,0,307519}]',1082,'[{90,1},{7,2},{2,3},{1,5}]',3786,84760,'[{1,2608},{3,1304}]'),(5,264,'[{3,0,313613}]',1087,'[{90,1},{7,2},{2,3},{1,5}]',3802,85280,'[{1,2624},{3,1312}]'),(5,265,'[{3,0,319707}]',1091,'[{90,1},{7,2},{2,3},{1,5}]',3818,85800,'[{1,2640},{3,1320}]'),(5,266,'[{3,0,325801}]',1096,'[{90,1},{7,2},{2,3},{1,5}]',3834,86320,'[{1,2656},{3,1328}]'),(5,267,'[{3,0,331895}]',1100,'[{90,1},{7,2},{2,3},{1,5}]',3850,86840,'[{1,2672},{3,1336}]'),(5,268,'[{3,0,337989}]',1105,'[{90,1},{7,2},{2,3},{1,5}]',3866,87360,'[{1,2688},{3,1344}]'),(5,269,'[{3,0,344083}]',1110,'[{90,1},{7,2},{2,3},{1,5}]',3882,87880,'[{1,2704},{3,1352}]'),(5,270,'[{3,0,350177}]',1114,'[{90,1},{7,2},{2,3},{1,5}]',3898,88400,'[{1,2720},{3,1360}]'),(5,271,'[{3,0,356271}]',1119,'[{90,1},{7,2},{2,3},{1,5}]',3914,88920,'[{1,2736},{3,1368}]'),(5,272,'[{3,0,362365}]',1123,'[{90,1},{7,2},{2,3},{1,5}]',3930,89440,'[{1,2752},{3,1376}]'),(5,273,'[{3,0,368459}]',1128,'[{90,1},{7,2},{2,3},{1,5}]',3946,89960,'[{1,2768},{3,1384}]'),(5,274,'[{3,0,374550}]',1132,'[{90,1},{7,2},{2,3},{1,5}]',3962,90480,'[{1,2784},{3,1392}]'),(5,275,'[{3,0,381734}]',1137,'[{90,1},{7,2},{2,3},{1,5}]',3978,91000,'[{1,2800},{3,1400}]'),(5,276,'[{3,0,388919}]',1142,'[{90,1},{7,2},{2,3},{1,5}]',3994,91520,'[{1,2816},{3,1408}]'),(5,277,'[{3,0,396104}]',1146,'[{90,1},{7,2},{2,3},{1,5}]',4010,92040,'[{1,2832},{3,1416}]'),(5,278,'[{3,0,403288}]',1151,'[{90,1},{7,2},{2,3},{1,5}]',4026,92560,'[{1,2848},{3,1424}]'),(5,279,'[{3,0,410473}]',1155,'[{90,1},{7,2},{2,3},{1,5}]',4042,93080,'[{1,2864},{3,1432}]'),(5,280,'[{3,0,417657}]',1160,'[{90,1},{7,2},{2,3},{1,5}]',4059,93600,'[{1,2880},{3,1440}]'),(5,281,'[{3,0,424842}]',1165,'[{90,1},{7,2},{2,3},{1,5}]',4075,94120,'[{1,2896},{3,1448}]'),(5,282,'[{3,0,432026}]',1169,'[{90,1},{7,2},{2,3},{1,5}]',4091,94640,'[{1,2912},{3,1456}]'),(5,283,'[{3,0,439211}]',1174,'[{90,1},{7,2},{2,3},{1,5}]',4107,95160,'[{1,2928},{3,1464}]'),(5,284,'[{3,0,446396}]',1178,'[{90,1},{7,2},{2,3},{1,5}]',4123,95680,'[{1,2944},{3,1472}]'),(5,285,'[{3,0,453580}]',1183,'[{90,1},{7,2},{2,3},{1,5}]',4139,96200,'[{1,2960},{3,1480}]'),(5,286,'[{3,0,460765}]',1188,'[{90,1},{7,2},{2,3},{1,5}]',4155,96720,'[{1,2976},{3,1488}]'),(5,287,'[{3,0,467949}]',1192,'[{90,1},{7,2},{2,3},{1,5}]',4172,97240,'[{1,2992},{3,1496}]'),(5,288,'[{3,0,475134}]',1197,'[{90,1},{7,2},{2,3},{1,5}]',4188,97760,'[{1,3008},{3,1504}]'),(5,289,'[{3,0,482318}]',1202,'[{90,1},{7,2},{2,3},{1,5}]',4204,98280,'[{1,3024},{3,1512}]'),(5,290,'[{3,0,489503}]',1206,'[{90,1},{7,2},{2,3},{1,5}]',4220,98800,'[{1,3040},{3,1520}]'),(5,291,'[{3,0,496688}]',1211,'[{90,1},{7,2},{2,3},{1,5}]',4236,99320,'[{1,3056},{3,1528}]'),(5,292,'[{3,0,503872}]',1216,'[{90,1},{7,2},{2,3},{1,5}]',4253,99840,'[{1,3072},{3,1536}]'),(5,293,'[{3,0,511057}]',1220,'[{90,1},{7,2},{2,3},{1,5}]',4269,100360,'[{1,3088},{3,1544}]'),(5,294,'[{3,0,518241}]',1225,'[{90,1},{7,2},{2,3},{1,5}]',4285,100880,'[{1,3104},{3,1552}]'),(5,295,'[{3,0,525426}]',1229,'[{90,1},{7,2},{2,3},{1,5}]',4301,101400,'[{1,3120},{3,1560}]'),(5,296,'[{3,0,532610}]',1234,'[{90,1},{7,2},{2,3},{1,5}]',4317,101920,'[{1,3136},{3,1568}]'),(5,297,'[{3,0,539795}]',1239,'[{90,1},{7,2},{2,3},{1,5}]',4334,102440,'[{1,3152},{3,1576}]'),(5,298,'[{3,0,546980}]',1243,'[{90,1},{7,2},{2,3},{1,5}]',4350,102960,'[{1,3168},{3,1584}]'),(5,299,'[{3,0,570466}]',1285,'[{90,1},{7,2},{2,3},{1,5}]',4366,103480,'[{1,3184},{3,1592}]'),(5,300,'[{3,0,581815}]',1289,'[{90,1},{7,2},{2,3},{1,5}]',4382,104000,'[{1,3200},{3,1600}]'),(5,301,'[{3,0,593165}]',1294,'[{90,1},{7,2},{2,3},{1,5}]',4399,104780,'[{1,3224},{3,1612}]'),(5,302,'[{3,0,604515}]',1299,'[{90,1},{7,2},{2,3},{1,5}]',4415,105560,'[{1,3248},{3,1624}]'),(5,303,'[{3,0,615865}]',1304,'[{90,1},{7,2},{2,3},{1,5}]',4431,106340,'[{1,3272},{3,1636}]'),(5,304,'[{3,0,627214}]',1309,'[{90,1},{7,2},{2,3},{1,5}]',4448,107120,'[{1,3296},{3,1648}]'),(5,305,'[{3,0,638564}]',1313,'[{90,1},{7,2},{2,3},{1,5}]',4464,107900,'[{1,3320},{3,1660}]'),(5,306,'[{3,0,649914}]',1318,'[{90,1},{7,2},{2,3},{1,5}]',4480,108680,'[{1,3344},{3,1672}]'),(5,307,'[{3,0,661263}]',1323,'[{90,1},{7,2},{2,3},{1,5}]',4497,109460,'[{1,3368},{3,1684}]'),(5,308,'[{3,0,672613}]',1328,'[{90,1},{7,2},{2,3},{1,5}]',4513,110240,'[{1,3392},{3,1696}]'),(5,309,'[{3,0,683963}]',1333,'[{90,1},{7,2},{2,3},{1,5}]',4529,111020,'[{1,3416},{3,1708}]'),(5,310,'[{3,0,695313}]',1338,'[{90,1},{7,2},{2,3},{1,5}]',4546,111800,'[{1,3440},{3,1720}]'),(5,311,'[{3,0,706662}]',1342,'[{90,1},{7,2},{2,3},{1,5}]',4562,112580,'[{1,3464},{3,1732}]'),(5,312,'[{3,0,718012}]',1347,'[{90,1},{7,2},{2,3},{1,5}]',4578,113360,'[{1,3488},{3,1744}]'),(5,313,'[{3,0,729362}]',1352,'[{90,1},{7,2},{2,3},{1,5}]',4595,114140,'[{1,3512},{3,1756}]'),(5,314,'[{3,0,740711}]',1357,'[{90,1},{7,2},{2,3},{1,5}]',4611,114920,'[{1,3536},{3,1768}]'),(5,315,'[{3,0,752061}]',1361,'[{90,1},{7,2},{2,3},{1,5}]',4627,115700,'[{1,3560},{3,1780}]'),(5,316,'[{3,0,763411}]',1366,'[{90,1},{7,2},{2,3},{1,5}]',4644,116480,'[{1,3584},{3,1792}]'),(5,317,'[{3,0,774760}]',1371,'[{90,1},{7,2},{2,3},{1,5}]',4660,117260,'[{1,3608},{3,1804}]'),(5,318,'[{3,0,786110}]',1376,'[{90,1},{7,2},{2,3},{1,5}]',4677,118040,'[{1,3632},{3,1816}]'),(5,319,'[{3,0,797460}]',1381,'[{90,1},{7,2},{2,3},{1,5}]',4693,118820,'[{1,3656},{3,1828}]'),(5,320,'[{3,0,808810}]',1385,'[{90,1},{7,2},{2,3},{1,5}]',4709,119600,'[{1,3680},{3,1840}]'),(5,321,'[{3,0,820159}]',1390,'[{90,1},{7,2},{2,3},{1,5}]',4726,120380,'[{1,3704},{3,1852}]'),(5,322,'[{3,0,831509}]',1395,'[{90,1},{7,2},{2,3},{1,5}]',4742,121160,'[{1,3728},{3,1864}]'),(5,323,'[{3,0,842859}]',1400,'[{90,1},{7,2},{2,3},{1,5}]',4759,121940,'[{1,3752},{3,1876}]'),(5,324,'[{3,0,854205}]',1405,'[{90,1},{7,2},{2,3},{1,5}]',4775,122720,'[{1,3776},{3,1888}]'),(5,325,'[{3,0,869085}]',1410,'[{90,1},{7,2},{2,3},{1,5}]',4792,123500,'[{1,3800},{3,1900}]'),(5,326,'[{3,0,883965}]',1415,'[{90,1},{7,2},{2,3},{1,5}]',4808,124280,'[{1,3824},{3,1912}]'),(5,327,'[{3,0,898846}]',1420,'[{90,1},{7,2},{2,3},{1,5}]',4825,125060,'[{1,3848},{3,1924}]'),(5,328,'[{3,0,913726}]',1424,'[{90,1},{7,2},{2,3},{1,5}]',4841,125840,'[{1,3872},{3,1936}]'),(5,329,'[{3,0,928606}]',1429,'[{90,1},{7,2},{2,3},{1,5}]',4857,126620,'[{1,3896},{3,1948}]'),(5,330,'[{3,0,943487}]',1434,'[{90,1},{7,2},{2,3},{1,5}]',4874,127400,'[{1,3920},{3,1960}]'),(5,331,'[{3,0,958367}]',1439,'[{90,1},{7,2},{2,3},{1,5}]',4890,128180,'[{1,3944},{3,1972}]'),(5,332,'[{3,0,973247}]',1444,'[{90,1},{7,2},{2,3},{1,5}]',4907,128960,'[{1,3968},{3,1984}]'),(5,333,'[{3,0,988128}]',1448,'[{90,1},{7,2},{2,3},{1,5}]',4923,129740,'[{1,3992},{3,1996}]'),(5,334,'[{3,0,1003008}]',1453,'[{90,1},{7,2},{2,3},{1,5}]',4940,130520,'[{1,4016},{3,2008}]'),(5,335,'[{3,0,1017888}]',1458,'[{90,1},{7,2},{2,3},{1,5}]',4956,131300,'[{1,4040},{3,2020}]'),(5,336,'[{3,0,1032768}]',1463,'[{90,1},{7,2},{2,3},{1,5}]',4973,132080,'[{1,4064},{3,2032}]'),(5,337,'[{3,0,1047649}]',1468,'[{90,1},{7,2},{2,3},{1,5}]',4990,132860,'[{1,4088},{3,2044}]'),(5,338,'[{3,0,1062529}]',1473,'[{90,1},{7,2},{2,3},{1,5}]',5006,133640,'[{1,4112},{3,2056}]'),(5,339,'[{3,0,1077409}]',1478,'[{90,1},{7,2},{2,3},{1,5}]',5023,134420,'[{1,4136},{3,2068}]'),(5,340,'[{3,0,1092290}]',1483,'[{90,1},{7,2},{2,3},{1,5}]',5039,135200,'[{1,4160},{3,2080}]'),(5,341,'[{3,0,1107170}]',1488,'[{90,1},{7,2},{2,3},{1,5}]',5056,135980,'[{1,4184},{3,2092}]'),(5,342,'[{3,0,1122050}]',1492,'[{90,1},{7,2},{2,3},{1,5}]',5072,136760,'[{1,4208},{3,2104}]'),(5,343,'[{3,0,1136930}]',1497,'[{90,1},{7,2},{2,3},{1,5}]',5089,137540,'[{1,4232},{3,2116}]'),(5,344,'[{3,0,1151811}]',1502,'[{90,1},{7,2},{2,3},{1,5}]',5105,138320,'[{1,4256},{3,2128}]'),(5,345,'[{3,0,1166691}]',1507,'[{90,1},{7,2},{2,3},{1,5}]',5122,139100,'[{1,4280},{3,2140}]'),(5,346,'[{3,0,1181571}]',1512,'[{90,1},{7,2},{2,3},{1,5}]',5139,139880,'[{1,4304},{3,2152}]'),(5,347,'[{3,0,1196452}]',1517,'[{90,1},{7,2},{2,3},{1,5}]',5155,140660,'[{1,4328},{3,2164}]'),(5,348,'[{3,0,1211332}]',1522,'[{90,1},{7,2},{2,3},{1,5}]',5172,141440,'[{1,4352},{3,2176}]'),(5,349,'[{3,0,1263370}]',1573,'[{90,1},{7,2},{2,3},{1,5}]',5188,142220,'[{1,4376},{3,2188}]'),(5,350,'[{3,0,1279417}]',1578,'[{90,1},{7,2},{2,3},{1,5}]',5205,143000,'[{1,4400},{3,2200}]'),(5,351,'[{3,0,1295463}]',1583,'[{90,1},{7,2},{2,3},{1,5}]',5222,143780,'[{1,4424},{3,2212}]'),(5,352,'[{3,0,1311509}]',1588,'[{90,1},{7,2},{2,3},{1,5}]',5238,144560,'[{1,4448},{3,2224}]'),(5,353,'[{3,0,1327556}]',1593,'[{90,1},{7,2},{2,3},{1,5}]',5255,145340,'[{1,4472},{3,2236}]'),(5,354,'[{3,0,1343602}]',1598,'[{90,1},{7,2},{2,3},{1,5}]',5272,146120,'[{1,4496},{3,2248}]'),(5,355,'[{3,0,1359648}]',1603,'[{90,1},{7,2},{2,3},{1,5}]',5288,146900,'[{1,4520},{3,2260}]'),(5,356,'[{3,0,1375695}]',1608,'[{90,1},{7,2},{2,3},{1,5}]',5305,147680,'[{1,4544},{3,2272}]'),(5,357,'[{3,0,1391741}]',1613,'[{90,1},{7,2},{2,3},{1,5}]',5322,148460,'[{1,4568},{3,2284}]'),(5,358,'[{3,0,1407787}]',1618,'[{90,1},{7,2},{2,3},{1,5}]',5338,149240,'[{1,4592},{3,2296}]'),(5,359,'[{3,0,1423834}]',1623,'[{90,1},{7,2},{2,3},{1,5}]',5355,150020,'[{1,4616},{3,2308}]'),(5,360,'[{3,0,1439880}]',1628,'[{90,1},{7,2},{2,3},{1,5}]',5372,150800,'[{1,4640},{3,2320}]'),(5,361,'[{3,0,1455927}]',1633,'[{90,1},{7,2},{2,3},{1,5}]',5388,151580,'[{1,4664},{3,2332}]'),(5,362,'[{3,0,1471973}]',1638,'[{90,1},{7,2},{2,3},{1,5}]',5405,152360,'[{1,4688},{3,2344}]'),(5,363,'[{3,0,1488019}]',1644,'[{90,1},{7,2},{2,3},{1,5}]',5422,153140,'[{1,4712},{3,2356}]'),(5,364,'[{3,0,1504066}]',1648,'[{90,1},{7,2},{2,3},{1,5}]',5438,153920,'[{1,4736},{3,2368}]'),(5,365,'[{3,0,1520112}]',1654,'[{90,1},{7,2},{2,3},{1,5}]',5455,154700,'[{1,4760},{3,2380}]'),(5,366,'[{3,0,1536158}]',1659,'[{90,1},{7,2},{2,3},{1,5}]',5472,155480,'[{1,4784},{3,2392}]'),(5,367,'[{3,0,1552205}]',1664,'[{90,1},{7,2},{2,3},{1,5}]',5489,156260,'[{1,4808},{3,2404}]'),(5,368,'[{3,0,1568251}]',1669,'[{90,1},{7,2},{2,3},{1,5}]',5505,157040,'[{1,4832},{3,2416}]'),(5,369,'[{3,0,1584297}]',1674,'[{90,1},{7,2},{2,3},{1,5}]',5522,157820,'[{1,4856},{3,2428}]'),(5,370,'[{3,0,1600344}]',1679,'[{90,1},{7,2},{2,3},{1,5}]',5539,158600,'[{1,4880},{3,2440}]'),(5,371,'[{3,0,1616390}]',1684,'[{90,1},{7,2},{2,3},{1,5}]',5556,159380,'[{1,4904},{3,2452}]'),(5,372,'[{3,0,1632437}]',1689,'[{90,1},{7,2},{2,3},{1,5}]',5572,160160,'[{1,4928},{3,2464}]'),(5,373,'[{3,0,1648483}]',1694,'[{90,1},{7,2},{2,3},{1,5}]',5589,160940,'[{1,4952},{3,2476}]'),(5,374,'[{3,0,1664530}]',1699,'[{90,1},{7,2},{2,3},{1,5}]',5606,161720,'[{1,4976},{3,2488}]'),(5,375,'[{3,0,1679756}]',1704,'[{90,1},{7,2},{2,3},{1,5}]',5623,162500,'[{1,5000},{3,2500}]'),(5,376,'[{3,0,1694982}]',1710,'[{90,1},{7,2},{2,3},{1,5}]',5640,163280,'[{1,5024},{3,2512}]'),(5,377,'[{3,0,1710209}]',1714,'[{90,1},{7,2},{2,3},{1,5}]',5656,164060,'[{1,5048},{3,2524}]'),(5,378,'[{3,0,1725435}]',1720,'[{90,1},{7,2},{2,3},{1,5}]',5673,164840,'[{1,5072},{3,2536}]'),(5,379,'[{3,0,1740661}]',1725,'[{90,1},{7,2},{2,3},{1,5}]',5690,165620,'[{1,5096},{3,2548}]'),(5,380,'[{3,0,1755888}]',1730,'[{90,1},{7,2},{2,3},{1,5}]',5707,166400,'[{1,5120},{3,2560}]'),(5,381,'[{3,0,1771114}]',1735,'[{90,1},{7,2},{2,3},{1,5}]',5724,167180,'[{1,5144},{3,2572}]'),(5,382,'[{3,0,1786340}]',1740,'[{90,1},{7,2},{2,3},{1,5}]',5740,167960,'[{1,5168},{3,2584}]'),(5,383,'[{3,0,1801567}]',1745,'[{90,1},{7,2},{2,3},{1,5}]',5757,168740,'[{1,5192},{3,2596}]'),(5,384,'[{3,0,1816793}]',1750,'[{90,1},{7,2},{2,3},{1,5}]',5774,169520,'[{1,5216},{3,2608}]'),(5,385,'[{3,0,1832020}]',1755,'[{90,1},{7,2},{2,3},{1,5}]',5791,170300,'[{1,5240},{3,2620}]'),(5,386,'[{3,0,1847246}]',1760,'[{90,1},{7,2},{2,3},{1,5}]',5808,171080,'[{1,5264},{3,2632}]'),(5,387,'[{3,0,1862472}]',1766,'[{90,1},{7,2},{2,3},{1,5}]',5825,171860,'[{1,5288},{3,2644}]'),(5,388,'[{3,0,1877699}]',1770,'[{90,1},{7,2},{2,3},{1,5}]',5841,172640,'[{1,5312},{3,2656}]'),(5,389,'[{3,0,1892925}]',1776,'[{90,1},{7,2},{2,3},{1,5}]',5858,173420,'[{1,5336},{3,2668}]'),(5,390,'[{3,0,1908151}]',1781,'[{90,1},{7,2},{2,3},{1,5}]',5875,174200,'[{1,5360},{3,2680}]'),(5,391,'[{3,0,1923378}]',1786,'[{90,1},{7,2},{2,3},{1,5}]',5892,174980,'[{1,5384},{3,2692}]'),(5,392,'[{3,0,1938604}]',1791,'[{90,1},{7,2},{2,3},{1,5}]',5909,175760,'[{1,5408},{3,2704}]'),(5,393,'[{3,0,1953830}]',1796,'[{90,1},{7,2},{2,3},{1,5}]',5926,176540,'[{1,5432},{3,2716}]'),(5,394,'[{3,0,1969057}]',1801,'[{90,1},{7,2},{2,3},{1,5}]',5943,177320,'[{1,5456},{3,2728}]'),(5,395,'[{3,0,1984283}]',1807,'[{90,1},{7,2},{2,3},{1,5}]',5960,178100,'[{1,5480},{3,2740}]'),(5,396,'[{3,0,1999510}]',1812,'[{90,1},{7,2},{2,3},{1,5}]',5977,178880,'[{1,5504},{3,2752}]'),(5,397,'[{3,0,2014736}]',1817,'[{90,1},{7,2},{2,3},{1,5}]',5993,179660,'[{1,5528},{3,2764}]'),(5,398,'[{3,0,2029962}]',1822,'[{90,1},{7,2},{2,3},{1,5}]',6010,180440,'[{1,5552},{3,2776}]'),(5,399,'[{3,0,2109102}]',1884,'[{90,1},{7,2},{2,3},{1,5}]',6027,181220,'[{1,5576},{3,2788}]'),(5,400,'[{3,0,2133037}]',1889,'[{90,1},{7,2},{2,3},{1,5}]',6044,182000,'[{1,5600},{3,2800}]'),(5,401,'[{3,0,2156972}]',1895,'[{90,1},{7,2},{2,3},{1,5}]',6061,183040,'[{1,5632},{3,2816}]'),(5,402,'[{3,0,2180907}]',1900,'[{90,1},{7,2},{2,3},{1,5}]',6078,184080,'[{1,5664},{3,2832}]'),(5,403,'[{3,0,2204842}]',1905,'[{90,1},{7,2},{2,3},{1,5}]',6095,185120,'[{1,5696},{3,2848}]'),(5,404,'[{3,0,2228777}]',1910,'[{90,1},{7,2},{2,3},{1,5}]',6112,186160,'[{1,5728},{3,2864}]'),(5,405,'[{3,0,2252712}]',1916,'[{90,1},{7,2},{2,3},{1,5}]',6129,187200,'[{1,5760},{3,2880}]'),(5,406,'[{3,0,2276647}]',1921,'[{90,1},{7,2},{2,3},{1,5}]',6146,188240,'[{1,5792},{3,2896}]'),(5,407,'[{3,0,2300582}]',1926,'[{90,1},{7,2},{2,3},{1,5}]',6163,189280,'[{1,5824},{3,2912}]'),(5,408,'[{3,0,2324517}]',1932,'[{90,1},{7,2},{2,3},{1,5}]',6180,190320,'[{1,5856},{3,2928}]'),(5,409,'[{3,0,2348452}]',1937,'[{90,1},{7,2},{2,3},{1,5}]',6197,191360,'[{1,5888},{3,2944}]'),(5,410,'[{3,0,2372387}]',1942,'[{90,1},{7,2},{2,3},{1,5}]',6214,192400,'[{1,5920},{3,2960}]'),(5,411,'[{3,0,2396322}]',1948,'[{90,1},{7,2},{2,3},{1,5}]',6231,193440,'[{1,5952},{3,2976}]'),(5,412,'[{3,0,2420257}]',1953,'[{90,1},{7,2},{2,3},{1,5}]',6248,194480,'[{1,5984},{3,2992}]'),(5,413,'[{3,0,2444192}]',1958,'[{90,1},{7,2},{2,3},{1,5}]',6265,195520,'[{1,6016},{3,3008}]'),(5,414,'[{3,0,2468127}]',1964,'[{90,1},{7,2},{2,3},{1,5}]',6282,196560,'[{1,6048},{3,3024}]'),(5,415,'[{3,0,2492062}]',1969,'[{90,1},{7,2},{2,3},{1,5}]',6299,197600,'[{1,6080},{3,3040}]'),(5,416,'[{3,0,2515997}]',1974,'[{90,1},{7,2},{2,3},{1,5}]',6316,198640,'[{1,6112},{3,3056}]'),(5,417,'[{3,0,2539932}]',1980,'[{90,1},{7,2},{2,3},{1,5}]',6333,199680,'[{1,6144},{3,3072}]'),(5,418,'[{3,0,2563867}]',1985,'[{90,1},{7,2},{2,3},{1,5}]',6350,200720,'[{1,6176},{3,3088}]'),(5,419,'[{3,0,2587802}]',1990,'[{90,1},{7,2},{2,3},{1,5}]',6367,201760,'[{1,6208},{3,3104}]'),(5,420,'[{3,0,2611737}]',1995,'[{90,1},{7,2},{2,3},{1,5}]',6384,202800,'[{1,6240},{3,3120}]'),(5,421,'[{3,0,2635672}]',2001,'[{90,1},{7,2},{2,3},{1,5}]',6401,203840,'[{1,6272},{3,3136}]'),(5,422,'[{3,0,2659607}]',2006,'[{90,1},{7,2},{2,3},{1,5}]',6418,204880,'[{1,6304},{3,3152}]'),(5,423,'[{3,0,2683542}]',2011,'[{90,1},{7,2},{2,3},{1,5}]',6435,205920,'[{1,6336},{3,3168}]'),(5,424,'[{3,0,2707479}]',2017,'[{90,1},{7,2},{2,3},{1,5}]',6452,206960,'[{1,6368},{3,3184}]'),(5,425,'[{3,0,2730859}]',2022,'[{90,1},{7,2},{2,3},{1,5}]',6470,208000,'[{1,6400},{3,3200}]'),(5,426,'[{3,0,2754239}]',2028,'[{90,1},{7,2},{2,3},{1,5}]',6487,209040,'[{1,6432},{3,3216}]'),(5,427,'[{3,0,2777618}]',2033,'[{90,1},{7,2},{2,3},{1,5}]',6504,210080,'[{1,6464},{3,3232}]'),(5,428,'[{3,0,2800998}]',2038,'[{90,1},{7,2},{2,3},{1,5}]',6521,211120,'[{1,6496},{3,3248}]'),(5,429,'[{3,0,2824378}]',2044,'[{90,1},{7,2},{2,3},{1,5}]',6538,212160,'[{1,6528},{3,3264}]'),(5,430,'[{3,0,2847757}]',2049,'[{90,1},{7,2},{2,3},{1,5}]',6555,213200,'[{1,6560},{3,3280}]'),(5,431,'[{3,0,2871137}]',2054,'[{90,1},{7,2},{2,3},{1,5}]',6572,214240,'[{1,6592},{3,3296}]'),(5,432,'[{3,0,2894517}]',2060,'[{90,1},{7,2},{2,3},{1,5}]',6589,215280,'[{1,6624},{3,3312}]'),(5,433,'[{3,0,2917896}]',2065,'[{90,1},{7,2},{2,3},{1,5}]',6606,216320,'[{1,6656},{3,3328}]'),(5,434,'[{3,0,2941276}]',2070,'[{90,1},{7,2},{2,3},{1,5}]',6624,217360,'[{1,6688},{3,3344}]'),(5,435,'[{3,0,2964656}]',2076,'[{90,1},{7,2},{2,3},{1,5}]',6641,218400,'[{1,6720},{3,3360}]'),(5,436,'[{3,0,2988035}]',2081,'[{90,1},{7,2},{2,3},{1,5}]',6658,219440,'[{1,6752},{3,3376}]'),(5,437,'[{3,0,3011415}]',2086,'[{90,1},{7,2},{2,3},{1,5}]',6675,220480,'[{1,6784},{3,3392}]'),(5,438,'[{3,0,3034795}]',2092,'[{90,1},{7,2},{2,3},{1,5}]',6692,221520,'[{1,6816},{3,3408}]'),(5,439,'[{3,0,3058175}]',2097,'[{90,1},{7,2},{2,3},{1,5}]',6709,222560,'[{1,6848},{3,3424}]'),(5,440,'[{3,0,3081554}]',2102,'[{90,1},{7,2},{2,3},{1,5}]',6726,223600,'[{1,6880},{3,3440}]'),(5,441,'[{3,0,3104934}]',2108,'[{90,1},{7,2},{2,3},{1,5}]',6744,224640,'[{1,6912},{3,3456}]'),(5,442,'[{3,0,3128314}]',2113,'[{90,1},{7,2},{2,3},{1,5}]',6761,225680,'[{1,6944},{3,3472}]'),(5,443,'[{3,0,3151693}]',2119,'[{90,1},{7,2},{2,3},{1,5}]',6778,226720,'[{1,6976},{3,3488}]'),(5,444,'[{3,0,3175073}]',2124,'[{90,1},{7,2},{2,3},{1,5}]',6795,227760,'[{1,7008},{3,3504}]'),(5,445,'[{3,0,3198453}]',2129,'[{90,1},{7,2},{2,3},{1,5}]',6812,228800,'[{1,7040},{3,3520}]'),(5,446,'[{3,0,3221832}]',2135,'[{90,1},{7,2},{2,3},{1,5}]',6830,229840,'[{1,7072},{3,3536}]'),(5,447,'[{3,0,3245212}]',2140,'[{90,1},{7,2},{2,3},{1,5}]',6847,230880,'[{1,7104},{3,3552}]'),(5,448,'[{3,0,3268592}]',2145,'[{90,1},{7,2},{2,3},{1,5}]',6864,231920,'[{1,7136},{3,3568}]'),(5,449,'[{3,0,3398166}]',2220,'[{90,1},{7,2},{2,3},{1,5}]',6881,232960,'[{1,7168},{3,3584}]'),(5,450,'[{3,0,3413589}]',2226,'[{90,1},{7,2},{2,3},{1,5}]',6898,234000,'[{1,7200},{3,3600}]'),(5,451,'[{3,0,3429011}]',2231,'[{90,1},{7,2},{2,3},{1,5}]',6916,235040,'[{1,7232},{3,3616}]'),(5,452,'[{3,0,3444434}]',2237,'[{90,1},{7,2},{2,3},{1,5}]',6933,236080,'[{1,7264},{3,3632}]'),(5,453,'[{3,0,3459856}]',2242,'[{90,1},{7,2},{2,3},{1,5}]',6950,237120,'[{1,7296},{3,3648}]'),(5,454,'[{3,0,3475279}]',2248,'[{90,1},{7,2},{2,3},{1,5}]',6967,238160,'[{1,7328},{3,3664}]'),(5,455,'[{3,0,3490701}]',2254,'[{90,1},{7,2},{2,3},{1,5}]',6985,239200,'[{1,7360},{3,3680}]'),(5,456,'[{3,0,3506124}]',2259,'[{90,1},{7,2},{2,3},{1,5}]',7002,240240,'[{1,7392},{3,3696}]'),(5,457,'[{3,0,3521547}]',2265,'[{90,1},{7,2},{2,3},{1,5}]',7019,241280,'[{1,7424},{3,3712}]'),(5,458,'[{3,0,3536969}]',2270,'[{90,1},{7,2},{2,3},{1,5}]',7036,242320,'[{1,7456},{3,3728}]'),(5,459,'[{3,0,3552392}]',2276,'[{90,1},{7,2},{2,3},{1,5}]',7054,243360,'[{1,7488},{3,3744}]'),(5,460,'[{3,0,3567814}]',2281,'[{90,1},{7,2},{2,3},{1,5}]',7071,244400,'[{1,7520},{3,3760}]'),(5,461,'[{3,0,3583237}]',2287,'[{90,1},{7,2},{2,3},{1,5}]',7088,245440,'[{1,7552},{3,3776}]'),(5,462,'[{3,0,3598660}]',2292,'[{90,1},{7,2},{2,3},{1,5}]',7105,246480,'[{1,7584},{3,3792}]'),(5,463,'[{3,0,3614082}]',2298,'[{90,1},{7,2},{2,3},{1,5}]',7123,247520,'[{1,7616},{3,3808}]'),(5,464,'[{3,0,3629505}]',2304,'[{90,1},{7,2},{2,3},{1,5}]',7140,248560,'[{1,7648},{3,3824}]'),(5,465,'[{3,0,3644927}]',2309,'[{90,1},{7,2},{2,3},{1,5}]',7157,249600,'[{1,7680},{3,3840}]'),(5,466,'[{3,0,3660350}]',2315,'[{90,1},{7,2},{2,3},{1,5}]',7175,250640,'[{1,7712},{3,3856}]'),(5,467,'[{3,0,3675772}]',2320,'[{90,1},{7,2},{2,3},{1,5}]',7192,251680,'[{1,7744},{3,3872}]'),(5,468,'[{3,0,3691195}]',2326,'[{90,1},{7,2},{2,3},{1,5}]',7209,252720,'[{1,7776},{3,3888}]'),(5,469,'[{3,0,3706618}]',2332,'[{90,1},{7,2},{2,3},{1,5}]',7227,253760,'[{1,7808},{3,3904}]'),(5,470,'[{3,0,3722040}]',2337,'[{90,1},{7,2},{2,3},{1,5}]',7244,254800,'[{1,7840},{3,3920}]'),(5,471,'[{3,0,3737463}]',2343,'[{90,1},{7,2},{2,3},{1,5}]',7261,255840,'[{1,7872},{3,3936}]'),(5,472,'[{3,0,3752885}]',2349,'[{90,1},{7,2},{2,3},{1,5}]',7279,256880,'[{1,7904},{3,3952}]'),(5,473,'[{3,0,3768308}]',2354,'[{90,1},{7,2},{2,3},{1,5}]',7296,257920,'[{1,7936},{3,3968}]'),(5,474,'[{3,0,3783732}]',2360,'[{90,1},{7,2},{2,3},{1,5}]',7313,258960,'[{1,7968},{3,3984}]'),(5,475,'[{3,0,3797544}]',2365,'[{90,1},{7,2},{2,3},{1,5}]',7331,260000,'[{1,8000},{3,4000}]'),(5,476,'[{3,0,3811356}]',2371,'[{90,1},{7,2},{2,3},{1,5}]',7348,261040,'[{1,8032},{3,4016}]'),(5,477,'[{3,0,3825168}]',2376,'[{90,1},{7,2},{2,3},{1,5}]',7365,262080,'[{1,8064},{3,4032}]'),(5,478,'[{3,0,3838980}]',2382,'[{90,1},{7,2},{2,3},{1,5}]',7383,263120,'[{1,8096},{3,4048}]'),(5,479,'[{3,0,3852791}]',2388,'[{90,1},{7,2},{2,3},{1,5}]',7400,264160,'[{1,8128},{3,4064}]'),(5,480,'[{3,0,3866603}]',2393,'[{90,1},{7,2},{2,3},{1,5}]',7417,265200,'[{1,8160},{3,4080}]'),(5,481,'[{3,0,3880415}]',2399,'[{90,1},{7,2},{2,3},{1,5}]',7435,266240,'[{1,8192},{3,4096}]'),(5,482,'[{3,0,3894227}]',2404,'[{90,1},{7,2},{2,3},{1,5}]',7452,267280,'[{1,8224},{3,4112}]'),(5,483,'[{3,0,3908039}]',2410,'[{90,1},{7,2},{2,3},{1,5}]',7470,268320,'[{1,8256},{3,4128}]'),(5,484,'[{3,0,3921851}]',2416,'[{90,1},{7,2},{2,3},{1,5}]',7487,269360,'[{1,8288},{3,4144}]'),(5,485,'[{3,0,3935663}]',2421,'[{90,1},{7,2},{2,3},{1,5}]',7504,270400,'[{1,8320},{3,4160}]'),(5,486,'[{3,0,3949475}]',2427,'[{90,1},{7,2},{2,3},{1,5}]',7522,271440,'[{1,8352},{3,4176}]'),(5,487,'[{3,0,3963287}]',2432,'[{90,1},{7,2},{2,3},{1,5}]',7539,272480,'[{1,8384},{3,4192}]'),(5,488,'[{3,0,3977099}]',2438,'[{90,1},{7,2},{2,3},{1,5}]',7557,273520,'[{1,8416},{3,4208}]'),(5,489,'[{3,0,3990911}]',2444,'[{90,1},{7,2},{2,3},{1,5}]',7574,274560,'[{1,8448},{3,4224}]'),(5,490,'[{3,0,4004723}]',2449,'[{90,1},{7,2},{2,3},{1,5}]',7591,275600,'[{1,8480},{3,4240}]'),(5,491,'[{3,0,4018535}]',2455,'[{90,1},{7,2},{2,3},{1,5}]',7609,276640,'[{1,8512},{3,4256}]'),(5,492,'[{3,0,4032347}]',2460,'[{90,1},{7,2},{2,3},{1,5}]',7626,277680,'[{1,8544},{3,4272}]'),(5,493,'[{3,0,4046159}]',2466,'[{90,1},{7,2},{2,3},{1,5}]',7644,278720,'[{1,8576},{3,4288}]'),(5,494,'[{3,0,4059970}]',2472,'[{90,1},{7,2},{2,3},{1,5}]',7661,279760,'[{1,8608},{3,4304}]'),(5,495,'[{3,0,4073782}]',2478,'[{90,1},{7,2},{2,3},{1,5}]',7679,280800,'[{1,8640},{3,4320}]'),(5,496,'[{3,0,4087594}]',2483,'[{90,1},{7,2},{2,3},{1,5}]',7696,281840,'[{1,8672},{3,4336}]'),(5,497,'[{3,0,4101406}]',2489,'[{90,1},{7,2},{2,3},{1,5}]',7714,282880,'[{1,8704},{3,4352}]'),(5,498,'[{3,0,4115218}]',2494,'[{90,1},{7,2},{2,3},{1,5}]',7731,283920,'[{1,8736},{3,4368}]'),(5,499,'[{3,0,4266667}]',2583,'[{90,1},{7,2},{2,3},{1,5}]',7749,284960,'[{1,8768},{3,4384}]'),(5,500,'[{3,0,0}]',0,'[{90,1},{7,2},{2,3},{1,5}]',0,286000,'[{1,8800},{3,4400}]'),(6,0,'[{3,0,668}]',15,'[{90,1},{7,2},{2,3},{1,5}]',58,0,'[{2,0},{4,0}]'),(6,1,'[{3,0,803}]',17,'[{90,1},{7,2},{2,3},{1,5}]',67,195,'[{2,120},{4,3}]'),(6,2,'[{3,0,937}]',19,'[{90,1},{7,2},{2,3},{1,5}]',76,390,'[{2,240},{4,6}]'),(6,3,'[{3,0,1071}]',22,'[{90,1},{7,2},{2,3},{1,5}]',86,585,'[{2,360},{4,9}]'),(6,4,'[{3,0,1205}]',24,'[{90,1},{7,2},{2,3},{1,5}]',96,780,'[{2,480},{4,12}]'),(6,5,'[{3,0,1340}]',27,'[{90,1},{7,2},{2,3},{1,5}]',106,975,'[{2,600},{4,15}]'),(6,6,'[{3,0,1474}]',29,'[{90,1},{7,2},{2,3},{1,5}]',116,1170,'[{2,720},{4,18}]'),(6,7,'[{3,0,1608}]',32,'[{90,1},{7,2},{2,3},{1,5}]',126,1365,'[{2,840},{4,21}]'),(6,8,'[{3,0,1742}]',35,'[{90,1},{7,2},{2,3},{1,5}]',137,1560,'[{2,960},{4,24}]'),(6,9,'[{3,0,1877}]',37,'[{90,1},{7,2},{2,3},{1,5}]',148,1755,'[{2,1080},{4,27}]'),(6,10,'[{3,0,2011}]',40,'[{90,1},{7,2},{2,3},{1,5}]',158,1950,'[{2,1200},{4,30}]'),(6,11,'[{3,0,2145}]',43,'[{90,1},{7,2},{2,3},{1,5}]',169,2145,'[{2,1320},{4,33}]'),(6,12,'[{3,0,2279}]',45,'[{90,1},{7,2},{2,3},{1,5}]',180,2340,'[{2,1440},{4,36}]'),(6,13,'[{3,0,2414}]',48,'[{90,1},{7,2},{2,3},{1,5}]',191,2535,'[{2,1560},{4,39}]'),(6,14,'[{3,0,2548}]',51,'[{90,1},{7,2},{2,3},{1,5}]',202,2730,'[{2,1680},{4,42}]'),(6,15,'[{3,0,2682}]',54,'[{90,1},{7,2},{2,3},{1,5}]',214,2925,'[{2,1800},{4,45}]'),(6,16,'[{3,0,2816}]',57,'[{90,1},{7,2},{2,3},{1,5}]',225,3120,'[{2,1920},{4,48}]'),(6,17,'[{3,0,2951}]',59,'[{90,1},{7,2},{2,3},{1,5}]',236,3315,'[{2,2040},{4,51}]'),(6,18,'[{3,0,3085}]',62,'[{90,1},{7,2},{2,3},{1,5}]',248,3510,'[{2,2160},{4,54}]'),(6,19,'[{3,0,3219}]',65,'[{90,1},{7,2},{2,3},{1,5}]',259,3705,'[{2,2280},{4,57}]'),(6,20,'[{3,0,3353}]',68,'[{90,1},{7,2},{2,3},{1,5}]',271,3900,'[{2,2400},{4,60}]'),(6,21,'[{3,0,3488}]',71,'[{90,1},{7,2},{2,3},{1,5}]',282,4095,'[{2,2520},{4,63}]'),(6,22,'[{3,0,3622}]',74,'[{90,1},{7,2},{2,3},{1,5}]',294,4290,'[{2,2640},{4,66}]'),(6,23,'[{3,0,3756}]',77,'[{90,1},{7,2},{2,3},{1,5}]',306,4485,'[{2,2760},{4,69}]'),(6,24,'[{3,0,3891}]',80,'[{90,1},{7,2},{2,3},{1,5}]',318,4680,'[{2,2880},{4,72}]'),(6,25,'[{3,0,4239}]',83,'[{90,1},{7,2},{2,3},{1,5}]',330,4875,'[{2,3000},{4,75}]'),(6,26,'[{3,0,4587}]',86,'[{90,1},{7,2},{2,3},{1,5}]',342,5070,'[{2,3120},{4,78}]'),(6,27,'[{3,0,4936}]',89,'[{90,1},{7,2},{2,3},{1,5}]',354,5265,'[{2,3240},{4,81}]'),(6,28,'[{3,0,5284}]',92,'[{90,1},{7,2},{2,3},{1,5}]',366,5460,'[{2,3360},{4,84}]'),(6,29,'[{3,0,5632}]',95,'[{90,1},{7,2},{2,3},{1,5}]',378,5655,'[{2,3480},{4,87}]'),(6,30,'[{3,0,5980}]',98,'[{90,1},{7,2},{2,3},{1,5}]',390,5850,'[{2,3600},{4,90}]'),(6,31,'[{3,0,6329}]',101,'[{90,1},{7,2},{2,3},{1,5}]',402,6045,'[{2,3720},{4,93}]'),(6,32,'[{3,0,6677}]',104,'[{90,1},{7,2},{2,3},{1,5}]',414,6240,'[{2,3840},{4,96}]'),(6,33,'[{3,0,7025}]',107,'[{90,1},{7,2},{2,3},{1,5}]',426,6435,'[{2,3960},{4,99}]'),(6,34,'[{3,0,7373}]',110,'[{90,1},{7,2},{2,3},{1,5}]',439,6630,'[{2,4080},{4,102}]'),(6,35,'[{3,0,7722}]',113,'[{90,1},{7,2},{2,3},{1,5}]',451,6825,'[{2,4200},{4,105}]'),(6,36,'[{3,0,8070}]',116,'[{90,1},{7,2},{2,3},{1,5}]',464,7020,'[{2,4320},{4,108}]'),(6,37,'[{3,0,8418}]',119,'[{90,1},{7,2},{2,3},{1,5}]',476,7215,'[{2,4440},{4,111}]'),(6,38,'[{3,0,8766}]',122,'[{90,1},{7,2},{2,3},{1,5}]',488,7410,'[{2,4560},{4,114}]'),(6,39,'[{3,0,9115}]',126,'[{90,1},{7,2},{2,3},{1,5}]',501,7605,'[{2,4680},{4,117}]'),(6,40,'[{3,0,9463}]',129,'[{90,1},{7,2},{2,3},{1,5}]',514,7800,'[{2,4800},{4,120}]'),(6,41,'[{3,0,9811}]',132,'[{90,1},{7,2},{2,3},{1,5}]',526,7995,'[{2,4920},{4,123}]'),(6,42,'[{3,0,10159}]',135,'[{90,1},{7,2},{2,3},{1,5}]',539,8190,'[{2,5040},{4,126}]'),(6,43,'[{3,0,10508}]',138,'[{90,1},{7,2},{2,3},{1,5}]',551,8385,'[{2,5160},{4,129}]'),(6,44,'[{3,0,10856}]',141,'[{90,1},{7,2},{2,3},{1,5}]',564,8580,'[{2,5280},{4,132}]'),(6,45,'[{3,0,11204}]',145,'[{90,1},{7,2},{2,3},{1,5}]',577,8775,'[{2,5400},{4,135}]'),(6,46,'[{3,0,11552}]',148,'[{90,1},{7,2},{2,3},{1,5}]',590,8970,'[{2,5520},{4,138}]'),(6,47,'[{3,0,11901}]',151,'[{90,1},{7,2},{2,3},{1,5}]',602,9165,'[{2,5640},{4,141}]'),(6,48,'[{3,0,12249}]',154,'[{90,1},{7,2},{2,3},{1,5}]',615,9360,'[{2,5760},{4,144}]'),(6,49,'[{3,0,12923}]',162,'[{90,1},{7,2},{2,3},{1,5}]',628,9555,'[{2,5880},{4,147}]'),(6,50,'[{3,0,13425}]',165,'[{90,1},{7,2},{2,3},{1,5}]',641,9750,'[{2,6000},{4,150}]'),(6,51,'[{3,0,13927}]',168,'[{90,1},{7,2},{2,3},{1,5}]',654,9945,'[{2,6120},{4,153}]'),(6,52,'[{3,0,14429}]',172,'[{90,1},{7,2},{2,3},{1,5}]',667,10140,'[{2,6240},{4,156}]'),(6,53,'[{3,0,14931}]',175,'[{90,1},{7,2},{2,3},{1,5}]',680,10335,'[{2,6360},{4,159}]'),(6,54,'[{3,0,15433}]',178,'[{90,1},{7,2},{2,3},{1,5}]',693,10530,'[{2,6480},{4,162}]'),(6,55,'[{3,0,15935}]',182,'[{90,1},{7,2},{2,3},{1,5}]',706,10725,'[{2,6600},{4,165}]'),(6,56,'[{3,0,16437}]',185,'[{90,1},{7,2},{2,3},{1,5}]',719,10920,'[{2,6720},{4,168}]'),(6,57,'[{3,0,16939}]',188,'[{90,1},{7,2},{2,3},{1,5}]',732,11115,'[{2,6840},{4,171}]'),(6,58,'[{3,0,17442}]',192,'[{90,1},{7,2},{2,3},{1,5}]',745,11310,'[{2,6960},{4,174}]'),(6,59,'[{3,0,17944}]',195,'[{90,1},{7,2},{2,3},{1,5}]',758,11505,'[{2,7080},{4,177}]'),(6,60,'[{3,0,18446}]',198,'[{90,1},{7,2},{2,3},{1,5}]',771,11700,'[{2,7200},{4,180}]'),(6,61,'[{3,0,18948}]',202,'[{90,1},{7,2},{2,3},{1,5}]',785,11895,'[{2,7320},{4,183}]'),(6,62,'[{3,0,19450}]',205,'[{90,1},{7,2},{2,3},{1,5}]',798,12090,'[{2,7440},{4,186}]'),(6,63,'[{3,0,19952}]',208,'[{90,1},{7,2},{2,3},{1,5}]',811,12285,'[{2,7560},{4,189}]'),(6,64,'[{3,0,20454}]',212,'[{90,1},{7,2},{2,3},{1,5}]',824,12480,'[{2,7680},{4,192}]'),(6,65,'[{3,0,20956}]',215,'[{90,1},{7,2},{2,3},{1,5}]',838,12675,'[{2,7800},{4,195}]'),(6,66,'[{3,0,21458}]',219,'[{90,1},{7,2},{2,3},{1,5}]',851,12870,'[{2,7920},{4,198}]'),(6,67,'[{3,0,21960}]',222,'[{90,1},{7,2},{2,3},{1,5}]',864,13065,'[{2,8040},{4,201}]'),(6,68,'[{3,0,22462}]',226,'[{90,1},{7,2},{2,3},{1,5}]',878,13260,'[{2,8160},{4,204}]'),(6,69,'[{3,0,22964}]',229,'[{90,1},{7,2},{2,3},{1,5}]',891,13455,'[{2,8280},{4,207}]'),(6,70,'[{3,0,23466}]',233,'[{90,1},{7,2},{2,3},{1,5}]',905,13650,'[{2,8400},{4,210}]'),(6,71,'[{3,0,23968}]',236,'[{90,1},{7,2},{2,3},{1,5}]',918,13845,'[{2,8520},{4,213}]'),(6,72,'[{3,0,24470}]',239,'[{90,1},{7,2},{2,3},{1,5}]',932,14040,'[{2,8640},{4,216}]'),(6,73,'[{3,0,24972}]',243,'[{90,1},{7,2},{2,3},{1,5}]',945,14235,'[{2,8760},{4,219}]'),(6,74,'[{3,0,25472}]',246,'[{90,1},{7,2},{2,3},{1,5}]',959,14430,'[{2,8880},{4,222}]'),(6,75,'[{3,0,25627}]',250,'[{90,1},{7,2},{2,3},{1,5}]',972,14625,'[{2,9000},{4,225}]'),(6,76,'[{3,0,25783}]',253,'[{90,1},{7,2},{2,3},{1,5}]',986,14820,'[{2,9120},{4,228}]'),(6,77,'[{3,0,25938}]',257,'[{90,1},{7,2},{2,3},{1,5}]',999,15015,'[{2,9240},{4,231}]'),(6,78,'[{3,0,26094}]',260,'[{90,1},{7,2},{2,3},{1,5}]',1013,15210,'[{2,9360},{4,234}]'),(6,79,'[{3,0,26249}]',264,'[{90,1},{7,2},{2,3},{1,5}]',1027,15405,'[{2,9480},{4,237}]'),(6,80,'[{3,0,26404}]',267,'[{90,1},{7,2},{2,3},{1,5}]',1040,15600,'[{2,9600},{4,240}]'),(6,81,'[{3,0,26560}]',271,'[{90,1},{7,2},{2,3},{1,5}]',1054,15795,'[{2,9720},{4,243}]'),(6,82,'[{3,0,26715}]',274,'[{90,1},{7,2},{2,3},{1,5}]',1068,15990,'[{2,9840},{4,246}]'),(6,83,'[{3,0,26870}]',278,'[{90,1},{7,2},{2,3},{1,5}]',1081,16185,'[{2,9960},{4,249}]'),(6,84,'[{3,0,27026}]',281,'[{90,1},{7,2},{2,3},{1,5}]',1095,16380,'[{2,10080},{4,252}]'),(6,85,'[{3,0,27181}]',285,'[{90,1},{7,2},{2,3},{1,5}]',1109,16575,'[{2,10200},{4,255}]'),(6,86,'[{3,0,27337}]',288,'[{90,1},{7,2},{2,3},{1,5}]',1123,16770,'[{2,10320},{4,258}]'),(6,87,'[{3,0,27492}]',292,'[{90,1},{7,2},{2,3},{1,5}]',1136,16965,'[{2,10440},{4,261}]'),(6,88,'[{3,0,27647}]',295,'[{90,1},{7,2},{2,3},{1,5}]',1150,17160,'[{2,10560},{4,264}]'),(6,89,'[{3,0,27803}]',299,'[{90,1},{7,2},{2,3},{1,5}]',1164,17355,'[{2,10680},{4,267}]'),(6,90,'[{3,0,27958}]',303,'[{90,1},{7,2},{2,3},{1,5}]',1178,17550,'[{2,10800},{4,270}]'),(6,91,'[{3,0,28114}]',306,'[{90,1},{7,2},{2,3},{1,5}]',1192,17745,'[{2,10920},{4,273}]'),(6,92,'[{3,0,28269}]',310,'[{90,1},{7,2},{2,3},{1,5}]',1206,17940,'[{2,11040},{4,276}]'),(6,93,'[{3,0,28424}]',313,'[{90,1},{7,2},{2,3},{1,5}]',1220,18135,'[{2,11160},{4,279}]'),(6,94,'[{3,0,28580}]',317,'[{90,1},{7,2},{2,3},{1,5}]',1234,18330,'[{2,11280},{4,282}]'),(6,95,'[{3,0,28735}]',320,'[{90,1},{7,2},{2,3},{1,5}]',1248,18525,'[{2,11400},{4,285}]'),(6,96,'[{3,0,28890}]',324,'[{90,1},{7,2},{2,3},{1,5}]',1262,18720,'[{2,11520},{4,288}]'),(6,97,'[{3,0,29046}]',328,'[{90,1},{7,2},{2,3},{1,5}]',1276,18915,'[{2,11640},{4,291}]'),(6,98,'[{3,0,29201}]',331,'[{90,1},{7,2},{2,3},{1,5}]',1290,19110,'[{2,11760},{4,294}]'),(6,99,'[{3,0,30126}]',344,'[{90,1},{7,2},{2,3},{1,5}]',1304,19305,'[{2,11880},{4,297}]'),(6,100,'[{3,0,30194}]',347,'[{90,1},{7,2},{2,3},{1,5}]',1318,19500,'[{2,12000},{4,300}]'),(6,101,'[{3,0,30263}]',351,'[{90,1},{7,2},{2,3},{1,5}]',1332,19825,'[{2,12200},{4,305}]'),(6,102,'[{3,0,30331}]',355,'[{90,1},{7,2},{2,3},{1,5}]',1346,20150,'[{2,12400},{4,310}]'),(6,103,'[{3,0,30400}]',358,'[{90,1},{7,2},{2,3},{1,5}]',1360,20475,'[{2,12600},{4,315}]'),(6,104,'[{3,0,30468}]',362,'[{90,1},{7,2},{2,3},{1,5}]',1374,20800,'[{2,12800},{4,320}]'),(6,105,'[{3,0,30537}]',366,'[{90,1},{7,2},{2,3},{1,5}]',1388,21125,'[{2,13000},{4,325}]'),(6,106,'[{3,0,30605}]',369,'[{90,1},{7,2},{2,3},{1,5}]',1402,21450,'[{2,13200},{4,330}]'),(6,107,'[{3,0,30673}]',373,'[{90,1},{7,2},{2,3},{1,5}]',1416,21775,'[{2,13400},{4,335}]'),(6,108,'[{3,0,30742}]',377,'[{90,1},{7,2},{2,3},{1,5}]',1431,22100,'[{2,13600},{4,340}]'),(6,109,'[{3,0,30810}]',381,'[{90,1},{7,2},{2,3},{1,5}]',1445,22425,'[{2,13800},{4,345}]'),(6,110,'[{3,0,30879}]',384,'[{90,1},{7,2},{2,3},{1,5}]',1459,22750,'[{2,14000},{4,350}]'),(6,111,'[{3,0,30947}]',388,'[{90,1},{7,2},{2,3},{1,5}]',1473,23075,'[{2,14200},{4,355}]'),(6,112,'[{3,0,31015}]',392,'[{90,1},{7,2},{2,3},{1,5}]',1488,23400,'[{2,14400},{4,360}]'),(6,113,'[{3,0,31084}]',396,'[{90,1},{7,2},{2,3},{1,5}]',1502,23725,'[{2,14600},{4,365}]'),(6,114,'[{3,0,31152}]',399,'[{90,1},{7,2},{2,3},{1,5}]',1516,24050,'[{2,14800},{4,370}]'),(6,115,'[{3,0,31221}]',403,'[{90,1},{7,2},{2,3},{1,5}]',1530,24375,'[{2,15000},{4,375}]'),(6,116,'[{3,0,31289}]',407,'[{90,1},{7,2},{2,3},{1,5}]',1545,24700,'[{2,15200},{4,380}]'),(6,117,'[{3,0,31358}]',411,'[{90,1},{7,2},{2,3},{1,5}]',1559,25025,'[{2,15400},{4,385}]'),(6,118,'[{3,0,31426}]',414,'[{90,1},{7,2},{2,3},{1,5}]',1573,25350,'[{2,15600},{4,390}]'),(6,119,'[{3,0,31494}]',418,'[{90,1},{7,2},{2,3},{1,5}]',1588,25675,'[{2,15800},{4,395}]'),(6,120,'[{3,0,31563}]',422,'[{90,1},{7,2},{2,3},{1,5}]',1602,26000,'[{2,16000},{4,400}]'),(6,121,'[{3,0,31631}]',426,'[{90,1},{7,2},{2,3},{1,5}]',1617,26325,'[{2,16200},{4,405}]'),(6,122,'[{3,0,31700}]',430,'[{90,1},{7,2},{2,3},{1,5}]',1631,26650,'[{2,16400},{4,410}]'),(6,123,'[{3,0,31768}]',434,'[{90,1},{7,2},{2,3},{1,5}]',1646,26975,'[{2,16600},{4,415}]'),(6,124,'[{3,0,31837}]',437,'[{90,1},{7,2},{2,3},{1,5}]',1660,27300,'[{2,16800},{4,420}]'),(6,125,'[{3,0,32159}]',441,'[{90,1},{7,2},{2,3},{1,5}]',1674,27625,'[{2,17000},{4,425}]'),(6,126,'[{3,0,32481}]',445,'[{90,1},{7,2},{2,3},{1,5}]',1689,27950,'[{2,17200},{4,430}]'),(6,127,'[{3,0,32803}]',449,'[{90,1},{7,2},{2,3},{1,5}]',1703,28275,'[{2,17400},{4,435}]'),(6,128,'[{3,0,33125}]',453,'[{90,1},{7,2},{2,3},{1,5}]',1718,28600,'[{2,17600},{4,440}]'),(6,129,'[{3,0,33447}]',456,'[{90,1},{7,2},{2,3},{1,5}]',1732,28925,'[{2,17800},{4,445}]'),(6,130,'[{3,0,33769}]',460,'[{90,1},{7,2},{2,3},{1,5}]',1747,29250,'[{2,18000},{4,450}]'),(6,131,'[{3,0,34091}]',464,'[{90,1},{7,2},{2,3},{1,5}]',1762,29575,'[{2,18200},{4,455}]'),(6,132,'[{3,0,34413}]',468,'[{90,1},{7,2},{2,3},{1,5}]',1776,29900,'[{2,18400},{4,460}]'),(6,133,'[{3,0,34735}]',472,'[{90,1},{7,2},{2,3},{1,5}]',1791,30225,'[{2,18600},{4,465}]'),(6,134,'[{3,0,35058}]',475,'[{90,1},{7,2},{2,3},{1,5}]',1805,30550,'[{2,18800},{4,470}]'),(6,135,'[{3,0,35380}]',479,'[{90,1},{7,2},{2,3},{1,5}]',1820,30875,'[{2,19000},{4,475}]'),(6,136,'[{3,0,35702}]',483,'[{90,1},{7,2},{2,3},{1,5}]',1834,31200,'[{2,19200},{4,480}]'),(6,137,'[{3,0,36024}]',487,'[{90,1},{7,2},{2,3},{1,5}]',1849,31525,'[{2,19400},{4,485}]'),(6,138,'[{3,0,36346}]',491,'[{90,1},{7,2},{2,3},{1,5}]',1864,31850,'[{2,19600},{4,490}]'),(6,139,'[{3,0,36668}]',495,'[{90,1},{7,2},{2,3},{1,5}]',1878,32175,'[{2,19800},{4,495}]'),(6,140,'[{3,0,36990}]',499,'[{90,1},{7,2},{2,3},{1,5}]',1893,32500,'[{2,20000},{4,500}]'),(6,141,'[{3,0,37312}]',503,'[{90,1},{7,2},{2,3},{1,5}]',1908,32825,'[{2,20200},{4,505}]'),(6,142,'[{3,0,37634}]',507,'[{90,1},{7,2},{2,3},{1,5}]',1923,33150,'[{2,20400},{4,510}]'),(6,143,'[{3,0,37957}]',510,'[{90,1},{7,2},{2,3},{1,5}]',1937,33475,'[{2,20600},{4,515}]'),(6,144,'[{3,0,38279}]',514,'[{90,1},{7,2},{2,3},{1,5}]',1952,33800,'[{2,20800},{4,520}]'),(6,145,'[{3,0,38601}]',518,'[{90,1},{7,2},{2,3},{1,5}]',1967,34125,'[{2,21000},{4,525}]'),(6,146,'[{3,0,38923}]',522,'[{90,1},{7,2},{2,3},{1,5}]',1981,34450,'[{2,21200},{4,530}]'),(6,147,'[{3,0,39245}]',526,'[{90,1},{7,2},{2,3},{1,5}]',1996,34775,'[{2,21400},{4,535}]'),(6,148,'[{3,0,39567}]',530,'[{90,1},{7,2},{2,3},{1,5}]',2011,35100,'[{2,21600},{4,540}]'),(6,149,'[{3,0,40965}]',548,'[{90,1},{7,2},{2,3},{1,5}]',2026,35425,'[{2,21800},{4,545}]'),(6,150,'[{3,0,41443}]',552,'[{90,1},{7,2},{2,3},{1,5}]',2041,35750,'[{2,22000},{4,550}]'),(6,151,'[{3,0,41922}]',556,'[{90,1},{7,2},{2,3},{1,5}]',2055,36075,'[{2,22200},{4,555}]'),(6,152,'[{3,0,42401}]',560,'[{90,1},{7,2},{2,3},{1,5}]',2070,36400,'[{2,22400},{4,560}]'),(6,153,'[{3,0,42879}]',564,'[{90,1},{7,2},{2,3},{1,5}]',2085,36725,'[{2,22600},{4,565}]'),(6,154,'[{3,0,43358}]',568,'[{90,1},{7,2},{2,3},{1,5}]',2100,37050,'[{2,22800},{4,570}]'),(6,155,'[{3,0,43837}]',572,'[{90,1},{7,2},{2,3},{1,5}]',2115,37375,'[{2,23000},{4,575}]'),(6,156,'[{3,0,44315}]',576,'[{90,1},{7,2},{2,3},{1,5}]',2130,37700,'[{2,23200},{4,580}]'),(6,157,'[{3,0,44794}]',580,'[{90,1},{7,2},{2,3},{1,5}]',2145,38025,'[{2,23400},{4,585}]'),(6,158,'[{3,0,45273}]',584,'[{90,1},{7,2},{2,3},{1,5}]',2160,38350,'[{2,23600},{4,590}]'),(6,159,'[{3,0,45751}]',588,'[{90,1},{7,2},{2,3},{1,5}]',2175,38675,'[{2,23800},{4,595}]'),(6,160,'[{3,0,46230}]',592,'[{90,1},{7,2},{2,3},{1,5}]',2189,39000,'[{2,24000},{4,600}]'),(6,161,'[{3,0,46709}]',596,'[{90,1},{7,2},{2,3},{1,5}]',2204,39325,'[{2,24200},{4,605}]'),(6,162,'[{3,0,47187}]',600,'[{90,1},{7,2},{2,3},{1,5}]',2219,39650,'[{2,24400},{4,610}]'),(6,163,'[{3,0,47666}]',604,'[{90,1},{7,2},{2,3},{1,5}]',2234,39975,'[{2,24600},{4,615}]'),(6,164,'[{3,0,48145}]',608,'[{90,1},{7,2},{2,3},{1,5}]',2249,40300,'[{2,24800},{4,620}]'),(6,165,'[{3,0,48623}]',612,'[{90,1},{7,2},{2,3},{1,5}]',2264,40625,'[{2,25000},{4,625}]'),(6,166,'[{3,0,49102}]',616,'[{90,1},{7,2},{2,3},{1,5}]',2279,40950,'[{2,25200},{4,630}]'),(6,167,'[{3,0,49580}]',620,'[{90,1},{7,2},{2,3},{1,5}]',2294,41275,'[{2,25400},{4,635}]'),(6,168,'[{3,0,50059}]',625,'[{90,1},{7,2},{2,3},{1,5}]',2309,41600,'[{2,25600},{4,640}]'),(6,169,'[{3,0,50538}]',629,'[{90,1},{7,2},{2,3},{1,5}]',2324,41925,'[{2,25800},{4,645}]'),(6,170,'[{3,0,51016}]',633,'[{90,1},{7,2},{2,3},{1,5}]',2340,42250,'[{2,26000},{4,650}]'),(6,171,'[{3,0,51495}]',637,'[{90,1},{7,2},{2,3},{1,5}]',2355,42575,'[{2,26200},{4,655}]'),(6,172,'[{3,0,51974}]',641,'[{90,1},{7,2},{2,3},{1,5}]',2370,42900,'[{2,26400},{4,660}]'),(6,173,'[{3,0,52452}]',645,'[{90,1},{7,2},{2,3},{1,5}]',2385,43225,'[{2,26600},{4,665}]'),(6,174,'[{3,0,52931}]',649,'[{90,1},{7,2},{2,3},{1,5}]',2400,43550,'[{2,26800},{4,670}]'),(6,175,'[{3,0,53077}]',653,'[{90,1},{7,2},{2,3},{1,5}]',2415,43875,'[{2,27000},{4,675}]'),(6,176,'[{3,0,53222}]',657,'[{90,1},{7,2},{2,3},{1,5}]',2430,44200,'[{2,27200},{4,680}]'),(6,177,'[{3,0,53368}]',661,'[{90,1},{7,2},{2,3},{1,5}]',2445,44525,'[{2,27400},{4,685}]'),(6,178,'[{3,0,53514}]',665,'[{90,1},{7,2},{2,3},{1,5}]',2460,44850,'[{2,27600},{4,690}]'),(6,179,'[{3,0,53659}]',670,'[{90,1},{7,2},{2,3},{1,5}]',2476,45175,'[{2,27800},{4,695}]'),(6,180,'[{3,0,53805}]',674,'[{90,1},{7,2},{2,3},{1,5}]',2491,45500,'[{2,28000},{4,700}]'),(6,181,'[{3,0,53951}]',678,'[{90,1},{7,2},{2,3},{1,5}]',2506,45825,'[{2,28200},{4,705}]'),(6,182,'[{3,0,54096}]',682,'[{90,1},{7,2},{2,3},{1,5}]',2521,46150,'[{2,28400},{4,710}]'),(6,183,'[{3,0,54242}]',686,'[{90,1},{7,2},{2,3},{1,5}]',2536,46475,'[{2,28600},{4,715}]'),(6,184,'[{3,0,54388}]',690,'[{90,1},{7,2},{2,3},{1,5}]',2552,46800,'[{2,28800},{4,720}]'),(6,185,'[{3,0,54533}]',694,'[{90,1},{7,2},{2,3},{1,5}]',2567,47125,'[{2,29000},{4,725}]'),(6,186,'[{3,0,54679}]',698,'[{90,1},{7,2},{2,3},{1,5}]',2582,47450,'[{2,29200},{4,730}]'),(6,187,'[{3,0,54825}]',702,'[{90,1},{7,2},{2,3},{1,5}]',2597,47775,'[{2,29400},{4,735}]'),(6,188,'[{3,0,54970}]',707,'[{90,1},{7,2},{2,3},{1,5}]',2613,48100,'[{2,29600},{4,740}]'),(6,189,'[{3,0,55116}]',711,'[{90,1},{7,2},{2,3},{1,5}]',2628,48425,'[{2,29800},{4,745}]'),(6,190,'[{3,0,55262}]',715,'[{90,1},{7,2},{2,3},{1,5}]',2643,48750,'[{2,30000},{4,750}]'),(6,191,'[{3,0,55408}]',719,'[{90,1},{7,2},{2,3},{1,5}]',2658,49075,'[{2,30200},{4,755}]'),(6,192,'[{3,0,55553}]',723,'[{90,1},{7,2},{2,3},{1,5}]',2674,49400,'[{2,30400},{4,760}]'),(6,193,'[{3,0,55699}]',727,'[{90,1},{7,2},{2,3},{1,5}]',2689,49725,'[{2,30600},{4,765}]'),(6,194,'[{3,0,55845}]',731,'[{90,1},{7,2},{2,3},{1,5}]',2704,50050,'[{2,30800},{4,770}]'),(6,195,'[{3,0,55990}]',736,'[{90,1},{7,2},{2,3},{1,5}]',2720,50375,'[{2,31000},{4,775}]'),(6,196,'[{3,0,56136}]',740,'[{90,1},{7,2},{2,3},{1,5}]',2735,50700,'[{2,31200},{4,780}]'),(6,197,'[{3,0,56282}]',744,'[{90,1},{7,2},{2,3},{1,5}]',2750,51025,'[{2,31400},{4,785}]'),(6,198,'[{3,0,56427}]',748,'[{90,1},{7,2},{2,3},{1,5}]',2766,51350,'[{2,31600},{4,790}]'),(6,199,'[{3,0,58145}]',773,'[{90,1},{7,2},{2,3},{1,5}]',2781,51675,'[{2,31800},{4,795}]'),(6,200,'[{3,0,58298}]',777,'[{90,1},{7,2},{2,3},{1,5}]',2797,52000,'[{2,32000},{4,800}]'),(6,201,'[{3,0,58451}]',782,'[{90,1},{7,2},{2,3},{1,5}]',2812,52520,'[{2,32320},{4,808}]'),(6,202,'[{3,0,58604}]',786,'[{90,1},{7,2},{2,3},{1,5}]',2827,53040,'[{2,32640},{4,816}]'),(6,203,'[{3,0,58757}]',790,'[{90,1},{7,2},{2,3},{1,5}]',2843,53560,'[{2,32960},{4,824}]'),(6,204,'[{3,0,58910}]',794,'[{90,1},{7,2},{2,3},{1,5}]',2858,54080,'[{2,33280},{4,832}]'),(6,205,'[{3,0,59063}]',799,'[{90,1},{7,2},{2,3},{1,5}]',2874,54600,'[{2,33600},{4,840}]'),(6,206,'[{3,0,59216}]',803,'[{90,1},{7,2},{2,3},{1,5}]',2889,55120,'[{2,33920},{4,848}]'),(6,207,'[{3,0,59369}]',807,'[{90,1},{7,2},{2,3},{1,5}]',2905,55640,'[{2,34240},{4,856}]'),(6,208,'[{3,0,59522}]',812,'[{90,1},{7,2},{2,3},{1,5}]',2920,56160,'[{2,34560},{4,864}]'),(6,209,'[{3,0,59675}]',816,'[{90,1},{7,2},{2,3},{1,5}]',2936,56680,'[{2,34880},{4,872}]'),(6,210,'[{3,0,59828}]',820,'[{90,1},{7,2},{2,3},{1,5}]',2951,57200,'[{2,35200},{4,880}]'),(6,211,'[{3,0,59981}]',825,'[{90,1},{7,2},{2,3},{1,5}]',2967,57720,'[{2,35520},{4,888}]'),(6,212,'[{3,0,60134}]',829,'[{90,1},{7,2},{2,3},{1,5}]',2982,58240,'[{2,35840},{4,896}]'),(6,213,'[{3,0,60287}]',833,'[{90,1},{7,2},{2,3},{1,5}]',2998,58760,'[{2,36160},{4,904}]'),(6,214,'[{3,0,60440}]',837,'[{90,1},{7,2},{2,3},{1,5}]',3013,59280,'[{2,36480},{4,912}]'),(6,215,'[{3,0,60594}]',842,'[{90,1},{7,2},{2,3},{1,5}]',3029,59800,'[{2,36800},{4,920}]'),(6,216,'[{3,0,60747}]',846,'[{90,1},{7,2},{2,3},{1,5}]',3044,60320,'[{2,37120},{4,928}]'),(6,217,'[{3,0,60900}]',850,'[{90,1},{7,2},{2,3},{1,5}]',3060,60840,'[{2,37440},{4,936}]'),(6,218,'[{3,0,61053}]',855,'[{90,1},{7,2},{2,3},{1,5}]',3075,61360,'[{2,37760},{4,944}]'),(6,219,'[{3,0,61206}]',859,'[{90,1},{7,2},{2,3},{1,5}]',3091,61880,'[{2,38080},{4,952}]'),(6,220,'[{3,0,61359}]',864,'[{90,1},{7,2},{2,3},{1,5}]',3107,62400,'[{2,38400},{4,960}]'),(6,221,'[{3,0,61512}]',868,'[{90,1},{7,2},{2,3},{1,5}]',3122,62920,'[{2,38720},{4,968}]'),(6,222,'[{3,0,61665}]',872,'[{90,1},{7,2},{2,3},{1,5}]',3138,63440,'[{2,39040},{4,976}]'),(6,223,'[{3,0,61818}]',876,'[{90,1},{7,2},{2,3},{1,5}]',3153,63960,'[{2,39360},{4,984}]'),(6,224,'[{3,0,61974}]',881,'[{90,1},{7,2},{2,3},{1,5}]',3169,64480,'[{2,39680},{4,992}]'),(6,225,'[{3,0,68137}]',885,'[{90,1},{7,2},{2,3},{1,5}]',3185,65000,'[{2,40000},{4,1000}]'),(6,226,'[{3,0,74299}]',889,'[{90,1},{7,2},{2,3},{1,5}]',3200,65520,'[{2,40320},{4,1008}]'),(6,227,'[{3,0,80461}]',894,'[{90,1},{7,2},{2,3},{1,5}]',3216,66040,'[{2,40640},{4,1016}]'),(6,228,'[{3,0,86623}]',898,'[{90,1},{7,2},{2,3},{1,5}]',3232,66560,'[{2,40960},{4,1024}]'),(6,229,'[{3,0,92785}]',902,'[{90,1},{7,2},{2,3},{1,5}]',3247,67080,'[{2,41280},{4,1032}]'),(6,230,'[{3,0,98948}]',907,'[{90,1},{7,2},{2,3},{1,5}]',3263,67600,'[{2,41600},{4,1040}]'),(6,231,'[{3,0,105110}]',911,'[{90,1},{7,2},{2,3},{1,5}]',3279,68120,'[{2,41920},{4,1048}]'),(6,232,'[{3,0,111272}]',915,'[{90,1},{7,2},{2,3},{1,5}]',3294,68640,'[{2,42240},{4,1056}]'),(6,233,'[{3,0,117434}]',920,'[{90,1},{7,2},{2,3},{1,5}]',3310,69160,'[{2,42560},{4,1064}]'),(6,234,'[{3,0,123597}]',924,'[{90,1},{7,2},{2,3},{1,5}]',3326,69680,'[{2,42880},{4,1072}]'),(6,235,'[{3,0,129759}]',929,'[{90,1},{7,2},{2,3},{1,5}]',3342,70200,'[{2,43200},{4,1080}]'),(6,236,'[{3,0,135921}]',933,'[{90,1},{7,2},{2,3},{1,5}]',3357,70720,'[{2,43520},{4,1088}]'),(6,237,'[{3,0,142083}]',937,'[{90,1},{7,2},{2,3},{1,5}]',3373,71240,'[{2,43840},{4,1096}]'),(6,238,'[{3,0,148245}]',942,'[{90,1},{7,2},{2,3},{1,5}]',3389,71760,'[{2,44160},{4,1104}]'),(6,239,'[{3,0,154408}]',946,'[{90,1},{7,2},{2,3},{1,5}]',3405,72280,'[{2,44480},{4,1112}]'),(6,240,'[{3,0,160570}]',950,'[{90,1},{7,2},{2,3},{1,5}]',3420,72800,'[{2,44800},{4,1120}]'),(6,241,'[{3,0,166732}]',955,'[{90,1},{7,2},{2,3},{1,5}]',3436,73320,'[{2,45120},{4,1128}]'),(6,242,'[{3,0,172894}]',959,'[{90,1},{7,2},{2,3},{1,5}]',3452,73840,'[{2,45440},{4,1136}]'),(6,243,'[{3,0,179057}]',964,'[{90,1},{7,2},{2,3},{1,5}]',3468,74360,'[{2,45760},{4,1144}]'),(6,244,'[{3,0,185219}]',968,'[{90,1},{7,2},{2,3},{1,5}]',3484,74880,'[{2,46080},{4,1152}]'),(6,245,'[{3,0,191381}]',972,'[{90,1},{7,2},{2,3},{1,5}]',3499,75400,'[{2,46400},{4,1160}]'),(6,246,'[{3,0,197543}]',977,'[{90,1},{7,2},{2,3},{1,5}]',3515,75920,'[{2,46720},{4,1168}]'),(6,247,'[{3,0,203705}]',981,'[{90,1},{7,2},{2,3},{1,5}]',3531,76440,'[{2,47040},{4,1176}]'),(6,248,'[{3,0,209868}]',986,'[{90,1},{7,2},{2,3},{1,5}]',3547,76960,'[{2,47360},{4,1184}]'),(6,249,'[{3,0,222203}]',1018,'[{90,1},{7,2},{2,3},{1,5}]',3563,77480,'[{2,47680},{4,1192}]'),(6,250,'[{3,0,228297}]',1023,'[{90,1},{7,2},{2,3},{1,5}]',3579,78000,'[{2,48000},{4,1200}]'),(6,251,'[{3,0,234391}]',1028,'[{90,1},{7,2},{2,3},{1,5}]',3595,78520,'[{2,48320},{4,1208}]'),(6,252,'[{3,0,240485}]',1032,'[{90,1},{7,2},{2,3},{1,5}]',3610,79040,'[{2,48640},{4,1216}]'),(6,253,'[{3,0,246579}]',1036,'[{90,1},{7,2},{2,3},{1,5}]',3626,79560,'[{2,48960},{4,1224}]'),(6,254,'[{3,0,252673}]',1041,'[{90,1},{7,2},{2,3},{1,5}]',3642,80080,'[{2,49280},{4,1232}]'),(6,255,'[{3,0,258767}]',1046,'[{90,1},{7,2},{2,3},{1,5}]',3658,80600,'[{2,49600},{4,1240}]'),(6,256,'[{3,0,264861}]',1050,'[{90,1},{7,2},{2,3},{1,5}]',3674,81120,'[{2,49920},{4,1248}]'),(6,257,'[{3,0,270955}]',1055,'[{90,1},{7,2},{2,3},{1,5}]',3690,81640,'[{2,50240},{4,1256}]'),(6,258,'[{3,0,277049}]',1059,'[{90,1},{7,2},{2,3},{1,5}]',3706,82160,'[{2,50560},{4,1264}]'),(6,259,'[{3,0,283143}]',1064,'[{90,1},{7,2},{2,3},{1,5}]',3722,82680,'[{2,50880},{4,1272}]'),(6,260,'[{3,0,289237}]',1068,'[{90,1},{7,2},{2,3},{1,5}]',3738,83200,'[{2,51200},{4,1280}]'),(6,261,'[{3,0,295331}]',1073,'[{90,1},{7,2},{2,3},{1,5}]',3754,83720,'[{2,51520},{4,1288}]'),(6,262,'[{3,0,301425}]',1078,'[{90,1},{7,2},{2,3},{1,5}]',3770,84240,'[{2,51840},{4,1296}]'),(6,263,'[{3,0,307519}]',1082,'[{90,1},{7,2},{2,3},{1,5}]',3786,84760,'[{2,52160},{4,1304}]'),(6,264,'[{3,0,313613}]',1087,'[{90,1},{7,2},{2,3},{1,5}]',3802,85280,'[{2,52480},{4,1312}]'),(6,265,'[{3,0,319707}]',1091,'[{90,1},{7,2},{2,3},{1,5}]',3818,85800,'[{2,52800},{4,1320}]'),(6,266,'[{3,0,325801}]',1096,'[{90,1},{7,2},{2,3},{1,5}]',3834,86320,'[{2,53120},{4,1328}]'),(6,267,'[{3,0,331895}]',1100,'[{90,1},{7,2},{2,3},{1,5}]',3850,86840,'[{2,53440},{4,1336}]'),(6,268,'[{3,0,337989}]',1105,'[{90,1},{7,2},{2,3},{1,5}]',3866,87360,'[{2,53760},{4,1344}]'),(6,269,'[{3,0,344083}]',1110,'[{90,1},{7,2},{2,3},{1,5}]',3882,87880,'[{2,54080},{4,1352}]'),(6,270,'[{3,0,350177}]',1114,'[{90,1},{7,2},{2,3},{1,5}]',3898,88400,'[{2,54400},{4,1360}]'),(6,271,'[{3,0,356271}]',1119,'[{90,1},{7,2},{2,3},{1,5}]',3914,88920,'[{2,54720},{4,1368}]'),(6,272,'[{3,0,362365}]',1123,'[{90,1},{7,2},{2,3},{1,5}]',3930,89440,'[{2,55040},{4,1376}]'),(6,273,'[{3,0,368459}]',1128,'[{90,1},{7,2},{2,3},{1,5}]',3946,89960,'[{2,55360},{4,1384}]'),(6,274,'[{3,0,374550}]',1132,'[{90,1},{7,2},{2,3},{1,5}]',3962,90480,'[{2,55680},{4,1392}]'),(6,275,'[{3,0,381734}]',1137,'[{90,1},{7,2},{2,3},{1,5}]',3978,91000,'[{2,56000},{4,1400}]'),(6,276,'[{3,0,388919}]',1142,'[{90,1},{7,2},{2,3},{1,5}]',3994,91520,'[{2,56320},{4,1408}]'),(6,277,'[{3,0,396104}]',1146,'[{90,1},{7,2},{2,3},{1,5}]',4010,92040,'[{2,56640},{4,1416}]'),(6,278,'[{3,0,403288}]',1151,'[{90,1},{7,2},{2,3},{1,5}]',4026,92560,'[{2,56960},{4,1424}]'),(6,279,'[{3,0,410473}]',1155,'[{90,1},{7,2},{2,3},{1,5}]',4042,93080,'[{2,57280},{4,1432}]'),(6,280,'[{3,0,417657}]',1160,'[{90,1},{7,2},{2,3},{1,5}]',4059,93600,'[{2,57600},{4,1440}]'),(6,281,'[{3,0,424842}]',1165,'[{90,1},{7,2},{2,3},{1,5}]',4075,94120,'[{2,57920},{4,1448}]'),(6,282,'[{3,0,432026}]',1169,'[{90,1},{7,2},{2,3},{1,5}]',4091,94640,'[{2,58240},{4,1456}]'),(6,283,'[{3,0,439211}]',1174,'[{90,1},{7,2},{2,3},{1,5}]',4107,95160,'[{2,58560},{4,1464}]'),(6,284,'[{3,0,446396}]',1178,'[{90,1},{7,2},{2,3},{1,5}]',4123,95680,'[{2,58880},{4,1472}]'),(6,285,'[{3,0,453580}]',1183,'[{90,1},{7,2},{2,3},{1,5}]',4139,96200,'[{2,59200},{4,1480}]'),(6,286,'[{3,0,460765}]',1188,'[{90,1},{7,2},{2,3},{1,5}]',4155,96720,'[{2,59520},{4,1488}]'),(6,287,'[{3,0,467949}]',1192,'[{90,1},{7,2},{2,3},{1,5}]',4172,97240,'[{2,59840},{4,1496}]'),(6,288,'[{3,0,475134}]',1197,'[{90,1},{7,2},{2,3},{1,5}]',4188,97760,'[{2,60160},{4,1504}]'),(6,289,'[{3,0,482318}]',1202,'[{90,1},{7,2},{2,3},{1,5}]',4204,98280,'[{2,60480},{4,1512}]'),(6,290,'[{3,0,489503}]',1206,'[{90,1},{7,2},{2,3},{1,5}]',4220,98800,'[{2,60800},{4,1520}]'),(6,291,'[{3,0,496688}]',1211,'[{90,1},{7,2},{2,3},{1,5}]',4236,99320,'[{2,61120},{4,1528}]'),(6,292,'[{3,0,503872}]',1216,'[{90,1},{7,2},{2,3},{1,5}]',4253,99840,'[{2,61440},{4,1536}]'),(6,293,'[{3,0,511057}]',1220,'[{90,1},{7,2},{2,3},{1,5}]',4269,100360,'[{2,61760},{4,1544}]'),(6,294,'[{3,0,518241}]',1225,'[{90,1},{7,2},{2,3},{1,5}]',4285,100880,'[{2,62080},{4,1552}]'),(6,295,'[{3,0,525426}]',1229,'[{90,1},{7,2},{2,3},{1,5}]',4301,101400,'[{2,62400},{4,1560}]'),(6,296,'[{3,0,532610}]',1234,'[{90,1},{7,2},{2,3},{1,5}]',4317,101920,'[{2,62720},{4,1568}]'),(6,297,'[{3,0,539795}]',1239,'[{90,1},{7,2},{2,3},{1,5}]',4334,102440,'[{2,63040},{4,1576}]'),(6,298,'[{3,0,546980}]',1243,'[{90,1},{7,2},{2,3},{1,5}]',4350,102960,'[{2,63360},{4,1584}]'),(6,299,'[{3,0,570466}]',1285,'[{90,1},{7,2},{2,3},{1,5}]',4366,103480,'[{2,63680},{4,1592}]'),(6,300,'[{3,0,581815}]',1289,'[{90,1},{7,2},{2,3},{1,5}]',4382,104000,'[{2,64000},{4,1600}]'),(6,301,'[{3,0,593165}]',1294,'[{90,1},{7,2},{2,3},{1,5}]',4399,104780,'[{2,64480},{4,1612}]'),(6,302,'[{3,0,604515}]',1299,'[{90,1},{7,2},{2,3},{1,5}]',4415,105560,'[{2,64960},{4,1624}]'),(6,303,'[{3,0,615865}]',1304,'[{90,1},{7,2},{2,3},{1,5}]',4431,106340,'[{2,65440},{4,1636}]'),(6,304,'[{3,0,627214}]',1309,'[{90,1},{7,2},{2,3},{1,5}]',4448,107120,'[{2,65920},{4,1648}]'),(6,305,'[{3,0,638564}]',1313,'[{90,1},{7,2},{2,3},{1,5}]',4464,107900,'[{2,66400},{4,1660}]'),(6,306,'[{3,0,649914}]',1318,'[{90,1},{7,2},{2,3},{1,5}]',4480,108680,'[{2,66880},{4,1672}]'),(6,307,'[{3,0,661263}]',1323,'[{90,1},{7,2},{2,3},{1,5}]',4497,109460,'[{2,67360},{4,1684}]'),(6,308,'[{3,0,672613}]',1328,'[{90,1},{7,2},{2,3},{1,5}]',4513,110240,'[{2,67840},{4,1696}]'),(6,309,'[{3,0,683963}]',1333,'[{90,1},{7,2},{2,3},{1,5}]',4529,111020,'[{2,68320},{4,1708}]'),(6,310,'[{3,0,695313}]',1338,'[{90,1},{7,2},{2,3},{1,5}]',4546,111800,'[{2,68800},{4,1720}]'),(6,311,'[{3,0,706662}]',1342,'[{90,1},{7,2},{2,3},{1,5}]',4562,112580,'[{2,69280},{4,1732}]'),(6,312,'[{3,0,718012}]',1347,'[{90,1},{7,2},{2,3},{1,5}]',4578,113360,'[{2,69760},{4,1744}]'),(6,313,'[{3,0,729362}]',1352,'[{90,1},{7,2},{2,3},{1,5}]',4595,114140,'[{2,70240},{4,1756}]'),(6,314,'[{3,0,740711}]',1357,'[{90,1},{7,2},{2,3},{1,5}]',4611,114920,'[{2,70720},{4,1768}]'),(6,315,'[{3,0,752061}]',1361,'[{90,1},{7,2},{2,3},{1,5}]',4627,115700,'[{2,71200},{4,1780}]'),(6,316,'[{3,0,763411}]',1366,'[{90,1},{7,2},{2,3},{1,5}]',4644,116480,'[{2,71680},{4,1792}]'),(6,317,'[{3,0,774760}]',1371,'[{90,1},{7,2},{2,3},{1,5}]',4660,117260,'[{2,72160},{4,1804}]'),(6,318,'[{3,0,786110}]',1376,'[{90,1},{7,2},{2,3},{1,5}]',4677,118040,'[{2,72640},{4,1816}]'),(6,319,'[{3,0,797460}]',1381,'[{90,1},{7,2},{2,3},{1,5}]',4693,118820,'[{2,73120},{4,1828}]'),(6,320,'[{3,0,808810}]',1385,'[{90,1},{7,2},{2,3},{1,5}]',4709,119600,'[{2,73600},{4,1840}]'),(6,321,'[{3,0,820159}]',1390,'[{90,1},{7,2},{2,3},{1,5}]',4726,120380,'[{2,74080},{4,1852}]'),(6,322,'[{3,0,831509}]',1395,'[{90,1},{7,2},{2,3},{1,5}]',4742,121160,'[{2,74560},{4,1864}]'),(6,323,'[{3,0,842859}]',1400,'[{90,1},{7,2},{2,3},{1,5}]',4759,121940,'[{2,75040},{4,1876}]'),(6,324,'[{3,0,854205}]',1405,'[{90,1},{7,2},{2,3},{1,5}]',4775,122720,'[{2,75520},{4,1888}]'),(6,325,'[{3,0,869085}]',1410,'[{90,1},{7,2},{2,3},{1,5}]',4792,123500,'[{2,76000},{4,1900}]'),(6,326,'[{3,0,883965}]',1415,'[{90,1},{7,2},{2,3},{1,5}]',4808,124280,'[{2,76480},{4,1912}]'),(6,327,'[{3,0,898846}]',1420,'[{90,1},{7,2},{2,3},{1,5}]',4825,125060,'[{2,76960},{4,1924}]'),(6,328,'[{3,0,913726}]',1424,'[{90,1},{7,2},{2,3},{1,5}]',4841,125840,'[{2,77440},{4,1936}]'),(6,329,'[{3,0,928606}]',1429,'[{90,1},{7,2},{2,3},{1,5}]',4857,126620,'[{2,77920},{4,1948}]'),(6,330,'[{3,0,943487}]',1434,'[{90,1},{7,2},{2,3},{1,5}]',4874,127400,'[{2,78400},{4,1960}]'),(6,331,'[{3,0,958367}]',1439,'[{90,1},{7,2},{2,3},{1,5}]',4890,128180,'[{2,78880},{4,1972}]'),(6,332,'[{3,0,973247}]',1444,'[{90,1},{7,2},{2,3},{1,5}]',4907,128960,'[{2,79360},{4,1984}]'),(6,333,'[{3,0,988128}]',1448,'[{90,1},{7,2},{2,3},{1,5}]',4923,129740,'[{2,79840},{4,1996}]'),(6,334,'[{3,0,1003008}]',1453,'[{90,1},{7,2},{2,3},{1,5}]',4940,130520,'[{2,80320},{4,2008}]'),(6,335,'[{3,0,1017888}]',1458,'[{90,1},{7,2},{2,3},{1,5}]',4956,131300,'[{2,80800},{4,2020}]'),(6,336,'[{3,0,1032768}]',1463,'[{90,1},{7,2},{2,3},{1,5}]',4973,132080,'[{2,81280},{4,2032}]'),(6,337,'[{3,0,1047649}]',1468,'[{90,1},{7,2},{2,3},{1,5}]',4990,132860,'[{2,81760},{4,2044}]'),(6,338,'[{3,0,1062529}]',1473,'[{90,1},{7,2},{2,3},{1,5}]',5006,133640,'[{2,82240},{4,2056}]'),(6,339,'[{3,0,1077409}]',1478,'[{90,1},{7,2},{2,3},{1,5}]',5023,134420,'[{2,82720},{4,2068}]'),(6,340,'[{3,0,1092290}]',1483,'[{90,1},{7,2},{2,3},{1,5}]',5039,135200,'[{2,83200},{4,2080}]'),(6,341,'[{3,0,1107170}]',1488,'[{90,1},{7,2},{2,3},{1,5}]',5056,135980,'[{2,83680},{4,2092}]'),(6,342,'[{3,0,1122050}]',1492,'[{90,1},{7,2},{2,3},{1,5}]',5072,136760,'[{2,84160},{4,2104}]'),(6,343,'[{3,0,1136930}]',1497,'[{90,1},{7,2},{2,3},{1,5}]',5089,137540,'[{2,84640},{4,2116}]'),(6,344,'[{3,0,1151811}]',1502,'[{90,1},{7,2},{2,3},{1,5}]',5105,138320,'[{2,85120},{4,2128}]'),(6,345,'[{3,0,1166691}]',1507,'[{90,1},{7,2},{2,3},{1,5}]',5122,139100,'[{2,85600},{4,2140}]'),(6,346,'[{3,0,1181571}]',1512,'[{90,1},{7,2},{2,3},{1,5}]',5139,139880,'[{2,86080},{4,2152}]'),(6,347,'[{3,0,1196452}]',1517,'[{90,1},{7,2},{2,3},{1,5}]',5155,140660,'[{2,86560},{4,2164}]'),(6,348,'[{3,0,1211332}]',1522,'[{90,1},{7,2},{2,3},{1,5}]',5172,141440,'[{2,87040},{4,2176}]'),(6,349,'[{3,0,1263370}]',1573,'[{90,1},{7,2},{2,3},{1,5}]',5188,142220,'[{2,87520},{4,2188}]'),(6,350,'[{3,0,1279417}]',1578,'[{90,1},{7,2},{2,3},{1,5}]',5205,143000,'[{2,88000},{4,2200}]'),(6,351,'[{3,0,1295463}]',1583,'[{90,1},{7,2},{2,3},{1,5}]',5222,143780,'[{2,88480},{4,2212}]'),(6,352,'[{3,0,1311509}]',1588,'[{90,1},{7,2},{2,3},{1,5}]',5238,144560,'[{2,88960},{4,2224}]'),(6,353,'[{3,0,1327556}]',1593,'[{90,1},{7,2},{2,3},{1,5}]',5255,145340,'[{2,89440},{4,2236}]'),(6,354,'[{3,0,1343602}]',1598,'[{90,1},{7,2},{2,3},{1,5}]',5272,146120,'[{2,89920},{4,2248}]'),(6,355,'[{3,0,1359648}]',1603,'[{90,1},{7,2},{2,3},{1,5}]',5288,146900,'[{2,90400},{4,2260}]'),(6,356,'[{3,0,1375695}]',1608,'[{90,1},{7,2},{2,3},{1,5}]',5305,147680,'[{2,90880},{4,2272}]'),(6,357,'[{3,0,1391741}]',1613,'[{90,1},{7,2},{2,3},{1,5}]',5322,148460,'[{2,91360},{4,2284}]'),(6,358,'[{3,0,1407787}]',1618,'[{90,1},{7,2},{2,3},{1,5}]',5338,149240,'[{2,91840},{4,2296}]'),(6,359,'[{3,0,1423834}]',1623,'[{90,1},{7,2},{2,3},{1,5}]',5355,150020,'[{2,92320},{4,2308}]'),(6,360,'[{3,0,1439880}]',1628,'[{90,1},{7,2},{2,3},{1,5}]',5372,150800,'[{2,92800},{4,2320}]'),(6,361,'[{3,0,1455927}]',1633,'[{90,1},{7,2},{2,3},{1,5}]',5388,151580,'[{2,93280},{4,2332}]'),(6,362,'[{3,0,1471973}]',1638,'[{90,1},{7,2},{2,3},{1,5}]',5405,152360,'[{2,93760},{4,2344}]'),(6,363,'[{3,0,1488019}]',1644,'[{90,1},{7,2},{2,3},{1,5}]',5422,153140,'[{2,94240},{4,2356}]'),(6,364,'[{3,0,1504066}]',1648,'[{90,1},{7,2},{2,3},{1,5}]',5438,153920,'[{2,94720},{4,2368}]'),(6,365,'[{3,0,1520112}]',1654,'[{90,1},{7,2},{2,3},{1,5}]',5455,154700,'[{2,95200},{4,2380}]'),(6,366,'[{3,0,1536158}]',1659,'[{90,1},{7,2},{2,3},{1,5}]',5472,155480,'[{2,95680},{4,2392}]'),(6,367,'[{3,0,1552205}]',1664,'[{90,1},{7,2},{2,3},{1,5}]',5489,156260,'[{2,96160},{4,2404}]'),(6,368,'[{3,0,1568251}]',1669,'[{90,1},{7,2},{2,3},{1,5}]',5505,157040,'[{2,96640},{4,2416}]'),(6,369,'[{3,0,1584297}]',1674,'[{90,1},{7,2},{2,3},{1,5}]',5522,157820,'[{2,97120},{4,2428}]'),(6,370,'[{3,0,1600344}]',1679,'[{90,1},{7,2},{2,3},{1,5}]',5539,158600,'[{2,97600},{4,2440}]'),(6,371,'[{3,0,1616390}]',1684,'[{90,1},{7,2},{2,3},{1,5}]',5556,159380,'[{2,98080},{4,2452}]'),(6,372,'[{3,0,1632437}]',1689,'[{90,1},{7,2},{2,3},{1,5}]',5572,160160,'[{2,98560},{4,2464}]'),(6,373,'[{3,0,1648483}]',1694,'[{90,1},{7,2},{2,3},{1,5}]',5589,160940,'[{2,99040},{4,2476}]'),(6,374,'[{3,0,1664530}]',1699,'[{90,1},{7,2},{2,3},{1,5}]',5606,161720,'[{2,99520},{4,2488}]'),(6,375,'[{3,0,1679756}]',1704,'[{90,1},{7,2},{2,3},{1,5}]',5623,162500,'[{2,100000},{4,2500}]'),(6,376,'[{3,0,1694982}]',1710,'[{90,1},{7,2},{2,3},{1,5}]',5640,163280,'[{2,100480},{4,2512}]'),(6,377,'[{3,0,1710209}]',1714,'[{90,1},{7,2},{2,3},{1,5}]',5656,164060,'[{2,100960},{4,2524}]'),(6,378,'[{3,0,1725435}]',1720,'[{90,1},{7,2},{2,3},{1,5}]',5673,164840,'[{2,101440},{4,2536}]'),(6,379,'[{3,0,1740661}]',1725,'[{90,1},{7,2},{2,3},{1,5}]',5690,165620,'[{2,101920},{4,2548}]'),(6,380,'[{3,0,1755888}]',1730,'[{90,1},{7,2},{2,3},{1,5}]',5707,166400,'[{2,102400},{4,2560}]'),(6,381,'[{3,0,1771114}]',1735,'[{90,1},{7,2},{2,3},{1,5}]',5724,167180,'[{2,102880},{4,2572}]'),(6,382,'[{3,0,1786340}]',1740,'[{90,1},{7,2},{2,3},{1,5}]',5740,167960,'[{2,103360},{4,2584}]'),(6,383,'[{3,0,1801567}]',1745,'[{90,1},{7,2},{2,3},{1,5}]',5757,168740,'[{2,103840},{4,2596}]'),(6,384,'[{3,0,1816793}]',1750,'[{90,1},{7,2},{2,3},{1,5}]',5774,169520,'[{2,104320},{4,2608}]'),(6,385,'[{3,0,1832020}]',1755,'[{90,1},{7,2},{2,3},{1,5}]',5791,170300,'[{2,104800},{4,2620}]'),(6,386,'[{3,0,1847246}]',1760,'[{90,1},{7,2},{2,3},{1,5}]',5808,171080,'[{2,105280},{4,2632}]'),(6,387,'[{3,0,1862472}]',1766,'[{90,1},{7,2},{2,3},{1,5}]',5825,171860,'[{2,105760},{4,2644}]'),(6,388,'[{3,0,1877699}]',1770,'[{90,1},{7,2},{2,3},{1,5}]',5841,172640,'[{2,106240},{4,2656}]'),(6,389,'[{3,0,1892925}]',1776,'[{90,1},{7,2},{2,3},{1,5}]',5858,173420,'[{2,106720},{4,2668}]'),(6,390,'[{3,0,1908151}]',1781,'[{90,1},{7,2},{2,3},{1,5}]',5875,174200,'[{2,107200},{4,2680}]'),(6,391,'[{3,0,1923378}]',1786,'[{90,1},{7,2},{2,3},{1,5}]',5892,174980,'[{2,107680},{4,2692}]'),(6,392,'[{3,0,1938604}]',1791,'[{90,1},{7,2},{2,3},{1,5}]',5909,175760,'[{2,108160},{4,2704}]'),(6,393,'[{3,0,1953830}]',1796,'[{90,1},{7,2},{2,3},{1,5}]',5926,176540,'[{2,108640},{4,2716}]'),(6,394,'[{3,0,1969057}]',1801,'[{90,1},{7,2},{2,3},{1,5}]',5943,177320,'[{2,109120},{4,2728}]'),(6,395,'[{3,0,1984283}]',1807,'[{90,1},{7,2},{2,3},{1,5}]',5960,178100,'[{2,109600},{4,2740}]'),(6,396,'[{3,0,1999510}]',1812,'[{90,1},{7,2},{2,3},{1,5}]',5977,178880,'[{2,110080},{4,2752}]'),(6,397,'[{3,0,2014736}]',1817,'[{90,1},{7,2},{2,3},{1,5}]',5993,179660,'[{2,110560},{4,2764}]'),(6,398,'[{3,0,2029962}]',1822,'[{90,1},{7,2},{2,3},{1,5}]',6010,180440,'[{2,111040},{4,2776}]'),(6,399,'[{3,0,2109102}]',1884,'[{90,1},{7,2},{2,3},{1,5}]',6027,181220,'[{2,111520},{4,2788}]'),(6,400,'[{3,0,2133037}]',1889,'[{90,1},{7,2},{2,3},{1,5}]',6044,182000,'[{2,112000},{4,2800}]'),(6,401,'[{3,0,2156972}]',1895,'[{90,1},{7,2},{2,3},{1,5}]',6061,183040,'[{2,112640},{4,2816}]'),(6,402,'[{3,0,2180907}]',1900,'[{90,1},{7,2},{2,3},{1,5}]',6078,184080,'[{2,113280},{4,2832}]'),(6,403,'[{3,0,2204842}]',1905,'[{90,1},{7,2},{2,3},{1,5}]',6095,185120,'[{2,113920},{4,2848}]'),(6,404,'[{3,0,2228777}]',1910,'[{90,1},{7,2},{2,3},{1,5}]',6112,186160,'[{2,114560},{4,2864}]'),(6,405,'[{3,0,2252712}]',1916,'[{90,1},{7,2},{2,3},{1,5}]',6129,187200,'[{2,115200},{4,2880}]'),(6,406,'[{3,0,2276647}]',1921,'[{90,1},{7,2},{2,3},{1,5}]',6146,188240,'[{2,115840},{4,2896}]'),(6,407,'[{3,0,2300582}]',1926,'[{90,1},{7,2},{2,3},{1,5}]',6163,189280,'[{2,116480},{4,2912}]'),(6,408,'[{3,0,2324517}]',1932,'[{90,1},{7,2},{2,3},{1,5}]',6180,190320,'[{2,117120},{4,2928}]'),(6,409,'[{3,0,2348452}]',1937,'[{90,1},{7,2},{2,3},{1,5}]',6197,191360,'[{2,117760},{4,2944}]'),(6,410,'[{3,0,2372387}]',1942,'[{90,1},{7,2},{2,3},{1,5}]',6214,192400,'[{2,118400},{4,2960}]'),(6,411,'[{3,0,2396322}]',1948,'[{90,1},{7,2},{2,3},{1,5}]',6231,193440,'[{2,119040},{4,2976}]'),(6,412,'[{3,0,2420257}]',1953,'[{90,1},{7,2},{2,3},{1,5}]',6248,194480,'[{2,119680},{4,2992}]'),(6,413,'[{3,0,2444192}]',1958,'[{90,1},{7,2},{2,3},{1,5}]',6265,195520,'[{2,120320},{4,3008}]'),(6,414,'[{3,0,2468127}]',1964,'[{90,1},{7,2},{2,3},{1,5}]',6282,196560,'[{2,120960},{4,3024}]'),(6,415,'[{3,0,2492062}]',1969,'[{90,1},{7,2},{2,3},{1,5}]',6299,197600,'[{2,121600},{4,3040}]'),(6,416,'[{3,0,2515997}]',1974,'[{90,1},{7,2},{2,3},{1,5}]',6316,198640,'[{2,122240},{4,3056}]'),(6,417,'[{3,0,2539932}]',1980,'[{90,1},{7,2},{2,3},{1,5}]',6333,199680,'[{2,122880},{4,3072}]'),(6,418,'[{3,0,2563867}]',1985,'[{90,1},{7,2},{2,3},{1,5}]',6350,200720,'[{2,123520},{4,3088}]'),(6,419,'[{3,0,2587802}]',1990,'[{90,1},{7,2},{2,3},{1,5}]',6367,201760,'[{2,124160},{4,3104}]'),(6,420,'[{3,0,2611737}]',1995,'[{90,1},{7,2},{2,3},{1,5}]',6384,202800,'[{2,124800},{4,3120}]'),(6,421,'[{3,0,2635672}]',2001,'[{90,1},{7,2},{2,3},{1,5}]',6401,203840,'[{2,125440},{4,3136}]'),(6,422,'[{3,0,2659607}]',2006,'[{90,1},{7,2},{2,3},{1,5}]',6418,204880,'[{2,126080},{4,3152}]'),(6,423,'[{3,0,2683542}]',2011,'[{90,1},{7,2},{2,3},{1,5}]',6435,205920,'[{2,126720},{4,3168}]'),(6,424,'[{3,0,2707479}]',2017,'[{90,1},{7,2},{2,3},{1,5}]',6452,206960,'[{2,127360},{4,3184}]'),(6,425,'[{3,0,2730859}]',2022,'[{90,1},{7,2},{2,3},{1,5}]',6470,208000,'[{2,128000},{4,3200}]'),(6,426,'[{3,0,2754239}]',2028,'[{90,1},{7,2},{2,3},{1,5}]',6487,209040,'[{2,128640},{4,3216}]'),(6,427,'[{3,0,2777618}]',2033,'[{90,1},{7,2},{2,3},{1,5}]',6504,210080,'[{2,129280},{4,3232}]'),(6,428,'[{3,0,2800998}]',2038,'[{90,1},{7,2},{2,3},{1,5}]',6521,211120,'[{2,129920},{4,3248}]'),(6,429,'[{3,0,2824378}]',2044,'[{90,1},{7,2},{2,3},{1,5}]',6538,212160,'[{2,130560},{4,3264}]'),(6,430,'[{3,0,2847757}]',2049,'[{90,1},{7,2},{2,3},{1,5}]',6555,213200,'[{2,131200},{4,3280}]'),(6,431,'[{3,0,2871137}]',2054,'[{90,1},{7,2},{2,3},{1,5}]',6572,214240,'[{2,131840},{4,3296}]'),(6,432,'[{3,0,2894517}]',2060,'[{90,1},{7,2},{2,3},{1,5}]',6589,215280,'[{2,132480},{4,3312}]'),(6,433,'[{3,0,2917896}]',2065,'[{90,1},{7,2},{2,3},{1,5}]',6606,216320,'[{2,133120},{4,3328}]'),(6,434,'[{3,0,2941276}]',2070,'[{90,1},{7,2},{2,3},{1,5}]',6624,217360,'[{2,133760},{4,3344}]'),(6,435,'[{3,0,2964656}]',2076,'[{90,1},{7,2},{2,3},{1,5}]',6641,218400,'[{2,134400},{4,3360}]'),(6,436,'[{3,0,2988035}]',2081,'[{90,1},{7,2},{2,3},{1,5}]',6658,219440,'[{2,135040},{4,3376}]'),(6,437,'[{3,0,3011415}]',2086,'[{90,1},{7,2},{2,3},{1,5}]',6675,220480,'[{2,135680},{4,3392}]'),(6,438,'[{3,0,3034795}]',2092,'[{90,1},{7,2},{2,3},{1,5}]',6692,221520,'[{2,136320},{4,3408}]'),(6,439,'[{3,0,3058175}]',2097,'[{90,1},{7,2},{2,3},{1,5}]',6709,222560,'[{2,136960},{4,3424}]'),(6,440,'[{3,0,3081554}]',2102,'[{90,1},{7,2},{2,3},{1,5}]',6726,223600,'[{2,137600},{4,3440}]'),(6,441,'[{3,0,3104934}]',2108,'[{90,1},{7,2},{2,3},{1,5}]',6744,224640,'[{2,138240},{4,3456}]'),(6,442,'[{3,0,3128314}]',2113,'[{90,1},{7,2},{2,3},{1,5}]',6761,225680,'[{2,138880},{4,3472}]'),(6,443,'[{3,0,3151693}]',2119,'[{90,1},{7,2},{2,3},{1,5}]',6778,226720,'[{2,139520},{4,3488}]'),(6,444,'[{3,0,3175073}]',2124,'[{90,1},{7,2},{2,3},{1,5}]',6795,227760,'[{2,140160},{4,3504}]'),(6,445,'[{3,0,3198453}]',2129,'[{90,1},{7,2},{2,3},{1,5}]',6812,228800,'[{2,140800},{4,3520}]'),(6,446,'[{3,0,3221832}]',2135,'[{90,1},{7,2},{2,3},{1,5}]',6830,229840,'[{2,141440},{4,3536}]'),(6,447,'[{3,0,3245212}]',2140,'[{90,1},{7,2},{2,3},{1,5}]',6847,230880,'[{2,142080},{4,3552}]'),(6,448,'[{3,0,3268592}]',2145,'[{90,1},{7,2},{2,3},{1,5}]',6864,231920,'[{2,142720},{4,3568}]'),(6,449,'[{3,0,3398166}]',2220,'[{90,1},{7,2},{2,3},{1,5}]',6881,232960,'[{2,143360},{4,3584}]'),(6,450,'[{3,0,3413589}]',2226,'[{90,1},{7,2},{2,3},{1,5}]',6898,234000,'[{2,144000},{4,3600}]'),(6,451,'[{3,0,3429011}]',2231,'[{90,1},{7,2},{2,3},{1,5}]',6916,235040,'[{2,144640},{4,3616}]'),(6,452,'[{3,0,3444434}]',2237,'[{90,1},{7,2},{2,3},{1,5}]',6933,236080,'[{2,145280},{4,3632}]'),(6,453,'[{3,0,3459856}]',2242,'[{90,1},{7,2},{2,3},{1,5}]',6950,237120,'[{2,145920},{4,3648}]'),(6,454,'[{3,0,3475279}]',2248,'[{90,1},{7,2},{2,3},{1,5}]',6967,238160,'[{2,146560},{4,3664}]'),(6,455,'[{3,0,3490701}]',2254,'[{90,1},{7,2},{2,3},{1,5}]',6985,239200,'[{2,147200},{4,3680}]'),(6,456,'[{3,0,3506124}]',2259,'[{90,1},{7,2},{2,3},{1,5}]',7002,240240,'[{2,147840},{4,3696}]'),(6,457,'[{3,0,3521547}]',2265,'[{90,1},{7,2},{2,3},{1,5}]',7019,241280,'[{2,148480},{4,3712}]'),(6,458,'[{3,0,3536969}]',2270,'[{90,1},{7,2},{2,3},{1,5}]',7036,242320,'[{2,149120},{4,3728}]'),(6,459,'[{3,0,3552392}]',2276,'[{90,1},{7,2},{2,3},{1,5}]',7054,243360,'[{2,149760},{4,3744}]'),(6,460,'[{3,0,3567814}]',2281,'[{90,1},{7,2},{2,3},{1,5}]',7071,244400,'[{2,150400},{4,3760}]'),(6,461,'[{3,0,3583237}]',2287,'[{90,1},{7,2},{2,3},{1,5}]',7088,245440,'[{2,151040},{4,3776}]'),(6,462,'[{3,0,3598660}]',2292,'[{90,1},{7,2},{2,3},{1,5}]',7105,246480,'[{2,151680},{4,3792}]'),(6,463,'[{3,0,3614082}]',2298,'[{90,1},{7,2},{2,3},{1,5}]',7123,247520,'[{2,152320},{4,3808}]'),(6,464,'[{3,0,3629505}]',2304,'[{90,1},{7,2},{2,3},{1,5}]',7140,248560,'[{2,152960},{4,3824}]'),(6,465,'[{3,0,3644927}]',2309,'[{90,1},{7,2},{2,3},{1,5}]',7157,249600,'[{2,153600},{4,3840}]'),(6,466,'[{3,0,3660350}]',2315,'[{90,1},{7,2},{2,3},{1,5}]',7175,250640,'[{2,154240},{4,3856}]'),(6,467,'[{3,0,3675772}]',2320,'[{90,1},{7,2},{2,3},{1,5}]',7192,251680,'[{2,154880},{4,3872}]'),(6,468,'[{3,0,3691195}]',2326,'[{90,1},{7,2},{2,3},{1,5}]',7209,252720,'[{2,155520},{4,3888}]'),(6,469,'[{3,0,3706618}]',2332,'[{90,1},{7,2},{2,3},{1,5}]',7227,253760,'[{2,156160},{4,3904}]'),(6,470,'[{3,0,3722040}]',2337,'[{90,1},{7,2},{2,3},{1,5}]',7244,254800,'[{2,156800},{4,3920}]'),(6,471,'[{3,0,3737463}]',2343,'[{90,1},{7,2},{2,3},{1,5}]',7261,255840,'[{2,157440},{4,3936}]'),(6,472,'[{3,0,3752885}]',2349,'[{90,1},{7,2},{2,3},{1,5}]',7279,256880,'[{2,158080},{4,3952}]'),(6,473,'[{3,0,3768308}]',2354,'[{90,1},{7,2},{2,3},{1,5}]',7296,257920,'[{2,158720},{4,3968}]'),(6,474,'[{3,0,3783732}]',2360,'[{90,1},{7,2},{2,3},{1,5}]',7313,258960,'[{2,159360},{4,3984}]'),(6,475,'[{3,0,3797544}]',2365,'[{90,1},{7,2},{2,3},{1,5}]',7331,260000,'[{2,160000},{4,4000}]'),(6,476,'[{3,0,3811356}]',2371,'[{90,1},{7,2},{2,3},{1,5}]',7348,261040,'[{2,160640},{4,4016}]'),(6,477,'[{3,0,3825168}]',2376,'[{90,1},{7,2},{2,3},{1,5}]',7365,262080,'[{2,161280},{4,4032}]'),(6,478,'[{3,0,3838980}]',2382,'[{90,1},{7,2},{2,3},{1,5}]',7383,263120,'[{2,161920},{4,4048}]'),(6,479,'[{3,0,3852791}]',2388,'[{90,1},{7,2},{2,3},{1,5}]',7400,264160,'[{2,162560},{4,4064}]'),(6,480,'[{3,0,3866603}]',2393,'[{90,1},{7,2},{2,3},{1,5}]',7417,265200,'[{2,163200},{4,4080}]'),(6,481,'[{3,0,3880415}]',2399,'[{90,1},{7,2},{2,3},{1,5}]',7435,266240,'[{2,163840},{4,4096}]'),(6,482,'[{3,0,3894227}]',2404,'[{90,1},{7,2},{2,3},{1,5}]',7452,267280,'[{2,164480},{4,4112}]'),(6,483,'[{3,0,3908039}]',2410,'[{90,1},{7,2},{2,3},{1,5}]',7470,268320,'[{2,165120},{4,4128}]'),(6,484,'[{3,0,3921851}]',2416,'[{90,1},{7,2},{2,3},{1,5}]',7487,269360,'[{2,165760},{4,4144}]'),(6,485,'[{3,0,3935663}]',2421,'[{90,1},{7,2},{2,3},{1,5}]',7504,270400,'[{2,166400},{4,4160}]'),(6,486,'[{3,0,3949475}]',2427,'[{90,1},{7,2},{2,3},{1,5}]',7522,271440,'[{2,167040},{4,4176}]'),(6,487,'[{3,0,3963287}]',2432,'[{90,1},{7,2},{2,3},{1,5}]',7539,272480,'[{2,167680},{4,4192}]'),(6,488,'[{3,0,3977099}]',2438,'[{90,1},{7,2},{2,3},{1,5}]',7557,273520,'[{2,168320},{4,4208}]'),(6,489,'[{3,0,3990911}]',2444,'[{90,1},{7,2},{2,3},{1,5}]',7574,274560,'[{2,168960},{4,4224}]'),(6,490,'[{3,0,4004723}]',2449,'[{90,1},{7,2},{2,3},{1,5}]',7591,275600,'[{2,169600},{4,4240}]'),(6,491,'[{3,0,4018535}]',2455,'[{90,1},{7,2},{2,3},{1,5}]',7609,276640,'[{2,170240},{4,4256}]'),(6,492,'[{3,0,4032347}]',2460,'[{90,1},{7,2},{2,3},{1,5}]',7626,277680,'[{2,170880},{4,4272}]'),(6,493,'[{3,0,4046159}]',2466,'[{90,1},{7,2},{2,3},{1,5}]',7644,278720,'[{2,171520},{4,4288}]'),(6,494,'[{3,0,4059970}]',2472,'[{90,1},{7,2},{2,3},{1,5}]',7661,279760,'[{2,172160},{4,4304}]'),(6,495,'[{3,0,4073782}]',2478,'[{90,1},{7,2},{2,3},{1,5}]',7679,280800,'[{2,172800},{4,4320}]'),(6,496,'[{3,0,4087594}]',2483,'[{90,1},{7,2},{2,3},{1,5}]',7696,281840,'[{2,173440},{4,4336}]'),(6,497,'[{3,0,4101406}]',2489,'[{90,1},{7,2},{2,3},{1,5}]',7714,282880,'[{2,174080},{4,4352}]'),(6,498,'[{3,0,4115218}]',2494,'[{90,1},{7,2},{2,3},{1,5}]',7731,283920,'[{2,174720},{4,4368}]'),(6,499,'[{3,0,4266667}]',2583,'[{90,1},{7,2},{2,3},{1,5}]',7749,284960,'[{2,175360},{4,4384}]'),(6,500,'[{3,0,0}]',0,'[{90,1},{7,2},{2,3},{1,5}]',0,286000,'[{2,176000},{4,4400}]'),(7,0,'[{3,0,668}]',15,'[{90,1},{7,2},{2,3},{1,5}]',58,0,'[{1,0},{3,0}]'),(7,1,'[{3,0,803}]',17,'[{90,1},{7,2},{2,3},{1,5}]',67,195,'[{1,6},{3,3}]'),(7,2,'[{3,0,937}]',19,'[{90,1},{7,2},{2,3},{1,5}]',76,390,'[{1,12},{3,6}]'),(7,3,'[{3,0,1071}]',22,'[{90,1},{7,2},{2,3},{1,5}]',86,585,'[{1,18},{3,9}]'),(7,4,'[{3,0,1205}]',24,'[{90,1},{7,2},{2,3},{1,5}]',96,780,'[{1,24},{3,12}]'),(7,5,'[{3,0,1340}]',27,'[{90,1},{7,2},{2,3},{1,5}]',106,975,'[{1,30},{3,15}]'),(7,6,'[{3,0,1474}]',29,'[{90,1},{7,2},{2,3},{1,5}]',116,1170,'[{1,36},{3,18}]'),(7,7,'[{3,0,1608}]',32,'[{90,1},{7,2},{2,3},{1,5}]',126,1365,'[{1,42},{3,21}]'),(7,8,'[{3,0,1742}]',35,'[{90,1},{7,2},{2,3},{1,5}]',137,1560,'[{1,48},{3,24}]'),(7,9,'[{3,0,1877}]',37,'[{90,1},{7,2},{2,3},{1,5}]',148,1755,'[{1,54},{3,27}]'),(7,10,'[{3,0,2011}]',40,'[{90,1},{7,2},{2,3},{1,5}]',158,1950,'[{1,60},{3,30}]'),(7,11,'[{3,0,2145}]',43,'[{90,1},{7,2},{2,3},{1,5}]',169,2145,'[{1,66},{3,33}]'),(7,12,'[{3,0,2279}]',45,'[{90,1},{7,2},{2,3},{1,5}]',180,2340,'[{1,72},{3,36}]'),(7,13,'[{3,0,2414}]',48,'[{90,1},{7,2},{2,3},{1,5}]',191,2535,'[{1,78},{3,39}]'),(7,14,'[{3,0,2548}]',51,'[{90,1},{7,2},{2,3},{1,5}]',202,2730,'[{1,84},{3,42}]'),(7,15,'[{3,0,2682}]',54,'[{90,1},{7,2},{2,3},{1,5}]',214,2925,'[{1,90},{3,45}]'),(7,16,'[{3,0,2816}]',57,'[{90,1},{7,2},{2,3},{1,5}]',225,3120,'[{1,96},{3,48}]'),(7,17,'[{3,0,2951}]',59,'[{90,1},{7,2},{2,3},{1,5}]',236,3315,'[{1,102},{3,51}]'),(7,18,'[{3,0,3085}]',62,'[{90,1},{7,2},{2,3},{1,5}]',248,3510,'[{1,108},{3,54}]'),(7,19,'[{3,0,3219}]',65,'[{90,1},{7,2},{2,3},{1,5}]',259,3705,'[{1,114},{3,57}]'),(7,20,'[{3,0,3353}]',68,'[{90,1},{7,2},{2,3},{1,5}]',271,3900,'[{1,120},{3,60}]'),(7,21,'[{3,0,3488}]',71,'[{90,1},{7,2},{2,3},{1,5}]',282,4095,'[{1,126},{3,63}]'),(7,22,'[{3,0,3622}]',74,'[{90,1},{7,2},{2,3},{1,5}]',294,4290,'[{1,132},{3,66}]'),(7,23,'[{3,0,3756}]',77,'[{90,1},{7,2},{2,3},{1,5}]',306,4485,'[{1,138},{3,69}]'),(7,24,'[{3,0,3891}]',80,'[{90,1},{7,2},{2,3},{1,5}]',318,4680,'[{1,144},{3,72}]'),(7,25,'[{3,0,4239}]',83,'[{90,1},{7,2},{2,3},{1,5}]',330,4875,'[{1,150},{3,75}]'),(7,26,'[{3,0,4587}]',86,'[{90,1},{7,2},{2,3},{1,5}]',342,5070,'[{1,156},{3,78}]'),(7,27,'[{3,0,4936}]',89,'[{90,1},{7,2},{2,3},{1,5}]',354,5265,'[{1,162},{3,81}]'),(7,28,'[{3,0,5284}]',92,'[{90,1},{7,2},{2,3},{1,5}]',366,5460,'[{1,168},{3,84}]'),(7,29,'[{3,0,5632}]',95,'[{90,1},{7,2},{2,3},{1,5}]',378,5655,'[{1,174},{3,87}]'),(7,30,'[{3,0,5980}]',98,'[{90,1},{7,2},{2,3},{1,5}]',390,5850,'[{1,180},{3,90}]'),(7,31,'[{3,0,6329}]',101,'[{90,1},{7,2},{2,3},{1,5}]',402,6045,'[{1,186},{3,93}]'),(7,32,'[{3,0,6677}]',104,'[{90,1},{7,2},{2,3},{1,5}]',414,6240,'[{1,192},{3,96}]'),(7,33,'[{3,0,7025}]',107,'[{90,1},{7,2},{2,3},{1,5}]',426,6435,'[{1,198},{3,99}]'),(7,34,'[{3,0,7373}]',110,'[{90,1},{7,2},{2,3},{1,5}]',439,6630,'[{1,204},{3,102}]'),(7,35,'[{3,0,7722}]',113,'[{90,1},{7,2},{2,3},{1,5}]',451,6825,'[{1,210},{3,105}]'),(7,36,'[{3,0,8070}]',116,'[{90,1},{7,2},{2,3},{1,5}]',464,7020,'[{1,216},{3,108}]'),(7,37,'[{3,0,8418}]',119,'[{90,1},{7,2},{2,3},{1,5}]',476,7215,'[{1,222},{3,111}]'),(7,38,'[{3,0,8766}]',122,'[{90,1},{7,2},{2,3},{1,5}]',488,7410,'[{1,228},{3,114}]'),(7,39,'[{3,0,9115}]',126,'[{90,1},{7,2},{2,3},{1,5}]',501,7605,'[{1,234},{3,117}]'),(7,40,'[{3,0,9463}]',129,'[{90,1},{7,2},{2,3},{1,5}]',514,7800,'[{1,240},{3,120}]'),(7,41,'[{3,0,9811}]',132,'[{90,1},{7,2},{2,3},{1,5}]',526,7995,'[{1,246},{3,123}]'),(7,42,'[{3,0,10159}]',135,'[{90,1},{7,2},{2,3},{1,5}]',539,8190,'[{1,252},{3,126}]'),(7,43,'[{3,0,10508}]',138,'[{90,1},{7,2},{2,3},{1,5}]',551,8385,'[{1,258},{3,129}]'),(7,44,'[{3,0,10856}]',141,'[{90,1},{7,2},{2,3},{1,5}]',564,8580,'[{1,264},{3,132}]'),(7,45,'[{3,0,11204}]',145,'[{90,1},{7,2},{2,3},{1,5}]',577,8775,'[{1,270},{3,135}]'),(7,46,'[{3,0,11552}]',148,'[{90,1},{7,2},{2,3},{1,5}]',590,8970,'[{1,276},{3,138}]'),(7,47,'[{3,0,11901}]',151,'[{90,1},{7,2},{2,3},{1,5}]',602,9165,'[{1,282},{3,141}]'),(7,48,'[{3,0,12249}]',154,'[{90,1},{7,2},{2,3},{1,5}]',615,9360,'[{1,288},{3,144}]'),(7,49,'[{3,0,12923}]',162,'[{90,1},{7,2},{2,3},{1,5}]',628,9555,'[{1,294},{3,147}]'),(7,50,'[{3,0,13425}]',165,'[{90,1},{7,2},{2,3},{1,5}]',641,9750,'[{1,300},{3,150}]'),(7,51,'[{3,0,13927}]',168,'[{90,1},{7,2},{2,3},{1,5}]',654,9945,'[{1,306},{3,153}]'),(7,52,'[{3,0,14429}]',172,'[{90,1},{7,2},{2,3},{1,5}]',667,10140,'[{1,312},{3,156}]'),(7,53,'[{3,0,14931}]',175,'[{90,1},{7,2},{2,3},{1,5}]',680,10335,'[{1,318},{3,159}]'),(7,54,'[{3,0,15433}]',178,'[{90,1},{7,2},{2,3},{1,5}]',693,10530,'[{1,324},{3,162}]'),(7,55,'[{3,0,15935}]',182,'[{90,1},{7,2},{2,3},{1,5}]',706,10725,'[{1,330},{3,165}]'),(7,56,'[{3,0,16437}]',185,'[{90,1},{7,2},{2,3},{1,5}]',719,10920,'[{1,336},{3,168}]'),(7,57,'[{3,0,16939}]',188,'[{90,1},{7,2},{2,3},{1,5}]',732,11115,'[{1,342},{3,171}]'),(7,58,'[{3,0,17442}]',192,'[{90,1},{7,2},{2,3},{1,5}]',745,11310,'[{1,348},{3,174}]'),(7,59,'[{3,0,17944}]',195,'[{90,1},{7,2},{2,3},{1,5}]',758,11505,'[{1,354},{3,177}]'),(7,60,'[{3,0,18446}]',198,'[{90,1},{7,2},{2,3},{1,5}]',771,11700,'[{1,360},{3,180}]'),(7,61,'[{3,0,18948}]',202,'[{90,1},{7,2},{2,3},{1,5}]',785,11895,'[{1,366},{3,183}]'),(7,62,'[{3,0,19450}]',205,'[{90,1},{7,2},{2,3},{1,5}]',798,12090,'[{1,372},{3,186}]'),(7,63,'[{3,0,19952}]',208,'[{90,1},{7,2},{2,3},{1,5}]',811,12285,'[{1,378},{3,189}]'),(7,64,'[{3,0,20454}]',212,'[{90,1},{7,2},{2,3},{1,5}]',824,12480,'[{1,384},{3,192}]'),(7,65,'[{3,0,20956}]',215,'[{90,1},{7,2},{2,3},{1,5}]',838,12675,'[{1,390},{3,195}]'),(7,66,'[{3,0,21458}]',219,'[{90,1},{7,2},{2,3},{1,5}]',851,12870,'[{1,396},{3,198}]'),(7,67,'[{3,0,21960}]',222,'[{90,1},{7,2},{2,3},{1,5}]',864,13065,'[{1,402},{3,201}]'),(7,68,'[{3,0,22462}]',226,'[{90,1},{7,2},{2,3},{1,5}]',878,13260,'[{1,408},{3,204}]'),(7,69,'[{3,0,22964}]',229,'[{90,1},{7,2},{2,3},{1,5}]',891,13455,'[{1,414},{3,207}]'),(7,70,'[{3,0,23466}]',233,'[{90,1},{7,2},{2,3},{1,5}]',905,13650,'[{1,420},{3,210}]'),(7,71,'[{3,0,23968}]',236,'[{90,1},{7,2},{2,3},{1,5}]',918,13845,'[{1,426},{3,213}]'),(7,72,'[{3,0,24470}]',239,'[{90,1},{7,2},{2,3},{1,5}]',932,14040,'[{1,432},{3,216}]'),(7,73,'[{3,0,24972}]',243,'[{90,1},{7,2},{2,3},{1,5}]',945,14235,'[{1,438},{3,219}]'),(7,74,'[{3,0,25472}]',246,'[{90,1},{7,2},{2,3},{1,5}]',959,14430,'[{1,444},{3,222}]'),(7,75,'[{3,0,25627}]',250,'[{90,1},{7,2},{2,3},{1,5}]',972,14625,'[{1,450},{3,225}]'),(7,76,'[{3,0,25783}]',253,'[{90,1},{7,2},{2,3},{1,5}]',986,14820,'[{1,456},{3,228}]'),(7,77,'[{3,0,25938}]',257,'[{90,1},{7,2},{2,3},{1,5}]',999,15015,'[{1,462},{3,231}]'),(7,78,'[{3,0,26094}]',260,'[{90,1},{7,2},{2,3},{1,5}]',1013,15210,'[{1,468},{3,234}]'),(7,79,'[{3,0,26249}]',264,'[{90,1},{7,2},{2,3},{1,5}]',1027,15405,'[{1,474},{3,237}]'),(7,80,'[{3,0,26404}]',267,'[{90,1},{7,2},{2,3},{1,5}]',1040,15600,'[{1,480},{3,240}]'),(7,81,'[{3,0,26560}]',271,'[{90,1},{7,2},{2,3},{1,5}]',1054,15795,'[{1,486},{3,243}]'),(7,82,'[{3,0,26715}]',274,'[{90,1},{7,2},{2,3},{1,5}]',1068,15990,'[{1,492},{3,246}]'),(7,83,'[{3,0,26870}]',278,'[{90,1},{7,2},{2,3},{1,5}]',1081,16185,'[{1,498},{3,249}]'),(7,84,'[{3,0,27026}]',281,'[{90,1},{7,2},{2,3},{1,5}]',1095,16380,'[{1,504},{3,252}]'),(7,85,'[{3,0,27181}]',285,'[{90,1},{7,2},{2,3},{1,5}]',1109,16575,'[{1,510},{3,255}]'),(7,86,'[{3,0,27337}]',288,'[{90,1},{7,2},{2,3},{1,5}]',1123,16770,'[{1,516},{3,258}]'),(7,87,'[{3,0,27492}]',292,'[{90,1},{7,2},{2,3},{1,5}]',1136,16965,'[{1,522},{3,261}]'),(7,88,'[{3,0,27647}]',295,'[{90,1},{7,2},{2,3},{1,5}]',1150,17160,'[{1,528},{3,264}]'),(7,89,'[{3,0,27803}]',299,'[{90,1},{7,2},{2,3},{1,5}]',1164,17355,'[{1,534},{3,267}]'),(7,90,'[{3,0,27958}]',303,'[{90,1},{7,2},{2,3},{1,5}]',1178,17550,'[{1,540},{3,270}]'),(7,91,'[{3,0,28114}]',306,'[{90,1},{7,2},{2,3},{1,5}]',1192,17745,'[{1,546},{3,273}]'),(7,92,'[{3,0,28269}]',310,'[{90,1},{7,2},{2,3},{1,5}]',1206,17940,'[{1,552},{3,276}]'),(7,93,'[{3,0,28424}]',313,'[{90,1},{7,2},{2,3},{1,5}]',1220,18135,'[{1,558},{3,279}]'),(7,94,'[{3,0,28580}]',317,'[{90,1},{7,2},{2,3},{1,5}]',1234,18330,'[{1,564},{3,282}]'),(7,95,'[{3,0,28735}]',320,'[{90,1},{7,2},{2,3},{1,5}]',1248,18525,'[{1,570},{3,285}]'),(7,96,'[{3,0,28890}]',324,'[{90,1},{7,2},{2,3},{1,5}]',1262,18720,'[{1,576},{3,288}]'),(7,97,'[{3,0,29046}]',328,'[{90,1},{7,2},{2,3},{1,5}]',1276,18915,'[{1,582},{3,291}]'),(7,98,'[{3,0,29201}]',331,'[{90,1},{7,2},{2,3},{1,5}]',1290,19110,'[{1,588},{3,294}]'),(7,99,'[{3,0,30126}]',344,'[{90,1},{7,2},{2,3},{1,5}]',1304,19305,'[{1,594},{3,297}]'),(7,100,'[{3,0,30194}]',347,'[{90,1},{7,2},{2,3},{1,5}]',1318,19500,'[{1,600},{3,300}]'),(7,101,'[{3,0,30263}]',351,'[{90,1},{7,2},{2,3},{1,5}]',1332,19825,'[{1,610},{3,305}]'),(7,102,'[{3,0,30331}]',355,'[{90,1},{7,2},{2,3},{1,5}]',1346,20150,'[{1,620},{3,310}]'),(7,103,'[{3,0,30400}]',358,'[{90,1},{7,2},{2,3},{1,5}]',1360,20475,'[{1,630},{3,315}]'),(7,104,'[{3,0,30468}]',362,'[{90,1},{7,2},{2,3},{1,5}]',1374,20800,'[{1,640},{3,320}]'),(7,105,'[{3,0,30537}]',366,'[{90,1},{7,2},{2,3},{1,5}]',1388,21125,'[{1,650},{3,325}]'),(7,106,'[{3,0,30605}]',369,'[{90,1},{7,2},{2,3},{1,5}]',1402,21450,'[{1,660},{3,330}]'),(7,107,'[{3,0,30673}]',373,'[{90,1},{7,2},{2,3},{1,5}]',1416,21775,'[{1,670},{3,335}]'),(7,108,'[{3,0,30742}]',377,'[{90,1},{7,2},{2,3},{1,5}]',1431,22100,'[{1,680},{3,340}]'),(7,109,'[{3,0,30810}]',381,'[{90,1},{7,2},{2,3},{1,5}]',1445,22425,'[{1,690},{3,345}]'),(7,110,'[{3,0,30879}]',384,'[{90,1},{7,2},{2,3},{1,5}]',1459,22750,'[{1,700},{3,350}]'),(7,111,'[{3,0,30947}]',388,'[{90,1},{7,2},{2,3},{1,5}]',1473,23075,'[{1,710},{3,355}]'),(7,112,'[{3,0,31015}]',392,'[{90,1},{7,2},{2,3},{1,5}]',1488,23400,'[{1,720},{3,360}]'),(7,113,'[{3,0,31084}]',396,'[{90,1},{7,2},{2,3},{1,5}]',1502,23725,'[{1,730},{3,365}]'),(7,114,'[{3,0,31152}]',399,'[{90,1},{7,2},{2,3},{1,5}]',1516,24050,'[{1,740},{3,370}]'),(7,115,'[{3,0,31221}]',403,'[{90,1},{7,2},{2,3},{1,5}]',1530,24375,'[{1,750},{3,375}]'),(7,116,'[{3,0,31289}]',407,'[{90,1},{7,2},{2,3},{1,5}]',1545,24700,'[{1,760},{3,380}]'),(7,117,'[{3,0,31358}]',411,'[{90,1},{7,2},{2,3},{1,5}]',1559,25025,'[{1,770},{3,385}]'),(7,118,'[{3,0,31426}]',414,'[{90,1},{7,2},{2,3},{1,5}]',1573,25350,'[{1,780},{3,390}]'),(7,119,'[{3,0,31494}]',418,'[{90,1},{7,2},{2,3},{1,5}]',1588,25675,'[{1,790},{3,395}]'),(7,120,'[{3,0,31563}]',422,'[{90,1},{7,2},{2,3},{1,5}]',1602,26000,'[{1,800},{3,400}]'),(7,121,'[{3,0,31631}]',426,'[{90,1},{7,2},{2,3},{1,5}]',1617,26325,'[{1,810},{3,405}]'),(7,122,'[{3,0,31700}]',430,'[{90,1},{7,2},{2,3},{1,5}]',1631,26650,'[{1,820},{3,410}]'),(7,123,'[{3,0,31768}]',434,'[{90,1},{7,2},{2,3},{1,5}]',1646,26975,'[{1,830},{3,415}]'),(7,124,'[{3,0,31837}]',437,'[{90,1},{7,2},{2,3},{1,5}]',1660,27300,'[{1,840},{3,420}]'),(7,125,'[{3,0,32159}]',441,'[{90,1},{7,2},{2,3},{1,5}]',1674,27625,'[{1,850},{3,425}]'),(7,126,'[{3,0,32481}]',445,'[{90,1},{7,2},{2,3},{1,5}]',1689,27950,'[{1,860},{3,430}]'),(7,127,'[{3,0,32803}]',449,'[{90,1},{7,2},{2,3},{1,5}]',1703,28275,'[{1,870},{3,435}]'),(7,128,'[{3,0,33125}]',453,'[{90,1},{7,2},{2,3},{1,5}]',1718,28600,'[{1,880},{3,440}]'),(7,129,'[{3,0,33447}]',456,'[{90,1},{7,2},{2,3},{1,5}]',1732,28925,'[{1,890},{3,445}]'),(7,130,'[{3,0,33769}]',460,'[{90,1},{7,2},{2,3},{1,5}]',1747,29250,'[{1,900},{3,450}]'),(7,131,'[{3,0,34091}]',464,'[{90,1},{7,2},{2,3},{1,5}]',1762,29575,'[{1,910},{3,455}]'),(7,132,'[{3,0,34413}]',468,'[{90,1},{7,2},{2,3},{1,5}]',1776,29900,'[{1,920},{3,460}]'),(7,133,'[{3,0,34735}]',472,'[{90,1},{7,2},{2,3},{1,5}]',1791,30225,'[{1,930},{3,465}]'),(7,134,'[{3,0,35058}]',475,'[{90,1},{7,2},{2,3},{1,5}]',1805,30550,'[{1,940},{3,470}]'),(7,135,'[{3,0,35380}]',479,'[{90,1},{7,2},{2,3},{1,5}]',1820,30875,'[{1,950},{3,475}]'),(7,136,'[{3,0,35702}]',483,'[{90,1},{7,2},{2,3},{1,5}]',1834,31200,'[{1,960},{3,480}]'),(7,137,'[{3,0,36024}]',487,'[{90,1},{7,2},{2,3},{1,5}]',1849,31525,'[{1,970},{3,485}]'),(7,138,'[{3,0,36346}]',491,'[{90,1},{7,2},{2,3},{1,5}]',1864,31850,'[{1,980},{3,490}]'),(7,139,'[{3,0,36668}]',495,'[{90,1},{7,2},{2,3},{1,5}]',1878,32175,'[{1,990},{3,495}]'),(7,140,'[{3,0,36990}]',499,'[{90,1},{7,2},{2,3},{1,5}]',1893,32500,'[{1,1000},{3,500}]'),(7,141,'[{3,0,37312}]',503,'[{90,1},{7,2},{2,3},{1,5}]',1908,32825,'[{1,1010},{3,505}]'),(7,142,'[{3,0,37634}]',507,'[{90,1},{7,2},{2,3},{1,5}]',1923,33150,'[{1,1020},{3,510}]'),(7,143,'[{3,0,37957}]',510,'[{90,1},{7,2},{2,3},{1,5}]',1937,33475,'[{1,1030},{3,515}]'),(7,144,'[{3,0,38279}]',514,'[{90,1},{7,2},{2,3},{1,5}]',1952,33800,'[{1,1040},{3,520}]'),(7,145,'[{3,0,38601}]',518,'[{90,1},{7,2},{2,3},{1,5}]',1967,34125,'[{1,1050},{3,525}]'),(7,146,'[{3,0,38923}]',522,'[{90,1},{7,2},{2,3},{1,5}]',1981,34450,'[{1,1060},{3,530}]'),(7,147,'[{3,0,39245}]',526,'[{90,1},{7,2},{2,3},{1,5}]',1996,34775,'[{1,1070},{3,535}]'),(7,148,'[{3,0,39567}]',530,'[{90,1},{7,2},{2,3},{1,5}]',2011,35100,'[{1,1080},{3,540}]'),(7,149,'[{3,0,40965}]',548,'[{90,1},{7,2},{2,3},{1,5}]',2026,35425,'[{1,1090},{3,545}]'),(7,150,'[{3,0,41443}]',552,'[{90,1},{7,2},{2,3},{1,5}]',2041,35750,'[{1,1100},{3,550}]'),(7,151,'[{3,0,41922}]',556,'[{90,1},{7,2},{2,3},{1,5}]',2055,36075,'[{1,1110},{3,555}]'),(7,152,'[{3,0,42401}]',560,'[{90,1},{7,2},{2,3},{1,5}]',2070,36400,'[{1,1120},{3,560}]'),(7,153,'[{3,0,42879}]',564,'[{90,1},{7,2},{2,3},{1,5}]',2085,36725,'[{1,1130},{3,565}]'),(7,154,'[{3,0,43358}]',568,'[{90,1},{7,2},{2,3},{1,5}]',2100,37050,'[{1,1140},{3,570}]'),(7,155,'[{3,0,43837}]',572,'[{90,1},{7,2},{2,3},{1,5}]',2115,37375,'[{1,1150},{3,575}]'),(7,156,'[{3,0,44315}]',576,'[{90,1},{7,2},{2,3},{1,5}]',2130,37700,'[{1,1160},{3,580}]'),(7,157,'[{3,0,44794}]',580,'[{90,1},{7,2},{2,3},{1,5}]',2145,38025,'[{1,1170},{3,585}]'),(7,158,'[{3,0,45273}]',584,'[{90,1},{7,2},{2,3},{1,5}]',2160,38350,'[{1,1180},{3,590}]'),(7,159,'[{3,0,45751}]',588,'[{90,1},{7,2},{2,3},{1,5}]',2175,38675,'[{1,1190},{3,595}]'),(7,160,'[{3,0,46230}]',592,'[{90,1},{7,2},{2,3},{1,5}]',2189,39000,'[{1,1200},{3,600}]'),(7,161,'[{3,0,46709}]',596,'[{90,1},{7,2},{2,3},{1,5}]',2204,39325,'[{1,1210},{3,605}]'),(7,162,'[{3,0,47187}]',600,'[{90,1},{7,2},{2,3},{1,5}]',2219,39650,'[{1,1220},{3,610}]'),(7,163,'[{3,0,47666}]',604,'[{90,1},{7,2},{2,3},{1,5}]',2234,39975,'[{1,1230},{3,615}]'),(7,164,'[{3,0,48145}]',608,'[{90,1},{7,2},{2,3},{1,5}]',2249,40300,'[{1,1240},{3,620}]'),(7,165,'[{3,0,48623}]',612,'[{90,1},{7,2},{2,3},{1,5}]',2264,40625,'[{1,1250},{3,625}]'),(7,166,'[{3,0,49102}]',616,'[{90,1},{7,2},{2,3},{1,5}]',2279,40950,'[{1,1260},{3,630}]'),(7,167,'[{3,0,49580}]',620,'[{90,1},{7,2},{2,3},{1,5}]',2294,41275,'[{1,1270},{3,635}]'),(7,168,'[{3,0,50059}]',625,'[{90,1},{7,2},{2,3},{1,5}]',2309,41600,'[{1,1280},{3,640}]'),(7,169,'[{3,0,50538}]',629,'[{90,1},{7,2},{2,3},{1,5}]',2324,41925,'[{1,1290},{3,645}]'),(7,170,'[{3,0,51016}]',633,'[{90,1},{7,2},{2,3},{1,5}]',2340,42250,'[{1,1300},{3,650}]'),(7,171,'[{3,0,51495}]',637,'[{90,1},{7,2},{2,3},{1,5}]',2355,42575,'[{1,1310},{3,655}]'),(7,172,'[{3,0,51974}]',641,'[{90,1},{7,2},{2,3},{1,5}]',2370,42900,'[{1,1320},{3,660}]'),(7,173,'[{3,0,52452}]',645,'[{90,1},{7,2},{2,3},{1,5}]',2385,43225,'[{1,1330},{3,665}]'),(7,174,'[{3,0,52931}]',649,'[{90,1},{7,2},{2,3},{1,5}]',2400,43550,'[{1,1340},{3,670}]'),(7,175,'[{3,0,53077}]',653,'[{90,1},{7,2},{2,3},{1,5}]',2415,43875,'[{1,1350},{3,675}]'),(7,176,'[{3,0,53222}]',657,'[{90,1},{7,2},{2,3},{1,5}]',2430,44200,'[{1,1360},{3,680}]'),(7,177,'[{3,0,53368}]',661,'[{90,1},{7,2},{2,3},{1,5}]',2445,44525,'[{1,1370},{3,685}]'),(7,178,'[{3,0,53514}]',665,'[{90,1},{7,2},{2,3},{1,5}]',2460,44850,'[{1,1380},{3,690}]'),(7,179,'[{3,0,53659}]',670,'[{90,1},{7,2},{2,3},{1,5}]',2476,45175,'[{1,1390},{3,695}]'),(7,180,'[{3,0,53805}]',674,'[{90,1},{7,2},{2,3},{1,5}]',2491,45500,'[{1,1400},{3,700}]'),(7,181,'[{3,0,53951}]',678,'[{90,1},{7,2},{2,3},{1,5}]',2506,45825,'[{1,1410},{3,705}]'),(7,182,'[{3,0,54096}]',682,'[{90,1},{7,2},{2,3},{1,5}]',2521,46150,'[{1,1420},{3,710}]'),(7,183,'[{3,0,54242}]',686,'[{90,1},{7,2},{2,3},{1,5}]',2536,46475,'[{1,1430},{3,715}]'),(7,184,'[{3,0,54388}]',690,'[{90,1},{7,2},{2,3},{1,5}]',2552,46800,'[{1,1440},{3,720}]'),(7,185,'[{3,0,54533}]',694,'[{90,1},{7,2},{2,3},{1,5}]',2567,47125,'[{1,1450},{3,725}]'),(7,186,'[{3,0,54679}]',698,'[{90,1},{7,2},{2,3},{1,5}]',2582,47450,'[{1,1460},{3,730}]'),(7,187,'[{3,0,54825}]',702,'[{90,1},{7,2},{2,3},{1,5}]',2597,47775,'[{1,1470},{3,735}]'),(7,188,'[{3,0,54970}]',707,'[{90,1},{7,2},{2,3},{1,5}]',2613,48100,'[{1,1480},{3,740}]'),(7,189,'[{3,0,55116}]',711,'[{90,1},{7,2},{2,3},{1,5}]',2628,48425,'[{1,1490},{3,745}]'),(7,190,'[{3,0,55262}]',715,'[{90,1},{7,2},{2,3},{1,5}]',2643,48750,'[{1,1500},{3,750}]'),(7,191,'[{3,0,55408}]',719,'[{90,1},{7,2},{2,3},{1,5}]',2658,49075,'[{1,1510},{3,755}]'),(7,192,'[{3,0,55553}]',723,'[{90,1},{7,2},{2,3},{1,5}]',2674,49400,'[{1,1520},{3,760}]'),(7,193,'[{3,0,55699}]',727,'[{90,1},{7,2},{2,3},{1,5}]',2689,49725,'[{1,1530},{3,765}]'),(7,194,'[{3,0,55845}]',731,'[{90,1},{7,2},{2,3},{1,5}]',2704,50050,'[{1,1540},{3,770}]'),(7,195,'[{3,0,55990}]',736,'[{90,1},{7,2},{2,3},{1,5}]',2720,50375,'[{1,1550},{3,775}]'),(7,196,'[{3,0,56136}]',740,'[{90,1},{7,2},{2,3},{1,5}]',2735,50700,'[{1,1560},{3,780}]'),(7,197,'[{3,0,56282}]',744,'[{90,1},{7,2},{2,3},{1,5}]',2750,51025,'[{1,1570},{3,785}]'),(7,198,'[{3,0,56427}]',748,'[{90,1},{7,2},{2,3},{1,5}]',2766,51350,'[{1,1580},{3,790}]'),(7,199,'[{3,0,58145}]',773,'[{90,1},{7,2},{2,3},{1,5}]',2781,51675,'[{1,1590},{3,795}]'),(7,200,'[{3,0,58298}]',777,'[{90,1},{7,2},{2,3},{1,5}]',2797,52000,'[{1,1600},{3,800}]'),(7,201,'[{3,0,58451}]',782,'[{90,1},{7,2},{2,3},{1,5}]',2812,52520,'[{1,1616},{3,808}]'),(7,202,'[{3,0,58604}]',786,'[{90,1},{7,2},{2,3},{1,5}]',2827,53040,'[{1,1632},{3,816}]'),(7,203,'[{3,0,58757}]',790,'[{90,1},{7,2},{2,3},{1,5}]',2843,53560,'[{1,1648},{3,824}]'),(7,204,'[{3,0,58910}]',794,'[{90,1},{7,2},{2,3},{1,5}]',2858,54080,'[{1,1664},{3,832}]'),(7,205,'[{3,0,59063}]',799,'[{90,1},{7,2},{2,3},{1,5}]',2874,54600,'[{1,1680},{3,840}]'),(7,206,'[{3,0,59216}]',803,'[{90,1},{7,2},{2,3},{1,5}]',2889,55120,'[{1,1696},{3,848}]'),(7,207,'[{3,0,59369}]',807,'[{90,1},{7,2},{2,3},{1,5}]',2905,55640,'[{1,1712},{3,856}]'),(7,208,'[{3,0,59522}]',812,'[{90,1},{7,2},{2,3},{1,5}]',2920,56160,'[{1,1728},{3,864}]'),(7,209,'[{3,0,59675}]',816,'[{90,1},{7,2},{2,3},{1,5}]',2936,56680,'[{1,1744},{3,872}]'),(7,210,'[{3,0,59828}]',820,'[{90,1},{7,2},{2,3},{1,5}]',2951,57200,'[{1,1760},{3,880}]'),(7,211,'[{3,0,59981}]',825,'[{90,1},{7,2},{2,3},{1,5}]',2967,57720,'[{1,1776},{3,888}]'),(7,212,'[{3,0,60134}]',829,'[{90,1},{7,2},{2,3},{1,5}]',2982,58240,'[{1,1792},{3,896}]'),(7,213,'[{3,0,60287}]',833,'[{90,1},{7,2},{2,3},{1,5}]',2998,58760,'[{1,1808},{3,904}]'),(7,214,'[{3,0,60440}]',837,'[{90,1},{7,2},{2,3},{1,5}]',3013,59280,'[{1,1824},{3,912}]'),(7,215,'[{3,0,60594}]',842,'[{90,1},{7,2},{2,3},{1,5}]',3029,59800,'[{1,1840},{3,920}]'),(7,216,'[{3,0,60747}]',846,'[{90,1},{7,2},{2,3},{1,5}]',3044,60320,'[{1,1856},{3,928}]'),(7,217,'[{3,0,60900}]',850,'[{90,1},{7,2},{2,3},{1,5}]',3060,60840,'[{1,1872},{3,936}]'),(7,218,'[{3,0,61053}]',855,'[{90,1},{7,2},{2,3},{1,5}]',3075,61360,'[{1,1888},{3,944}]'),(7,219,'[{3,0,61206}]',859,'[{90,1},{7,2},{2,3},{1,5}]',3091,61880,'[{1,1904},{3,952}]'),(7,220,'[{3,0,61359}]',864,'[{90,1},{7,2},{2,3},{1,5}]',3107,62400,'[{1,1920},{3,960}]'),(7,221,'[{3,0,61512}]',868,'[{90,1},{7,2},{2,3},{1,5}]',3122,62920,'[{1,1936},{3,968}]'),(7,222,'[{3,0,61665}]',872,'[{90,1},{7,2},{2,3},{1,5}]',3138,63440,'[{1,1952},{3,976}]'),(7,223,'[{3,0,61818}]',876,'[{90,1},{7,2},{2,3},{1,5}]',3153,63960,'[{1,1968},{3,984}]'),(7,224,'[{3,0,61974}]',881,'[{90,1},{7,2},{2,3},{1,5}]',3169,64480,'[{1,1984},{3,992}]'),(7,225,'[{3,0,68137}]',885,'[{90,1},{7,2},{2,3},{1,5}]',3185,65000,'[{1,2000},{3,1000}]'),(7,226,'[{3,0,74299}]',889,'[{90,1},{7,2},{2,3},{1,5}]',3200,65520,'[{1,2016},{3,1008}]'),(7,227,'[{3,0,80461}]',894,'[{90,1},{7,2},{2,3},{1,5}]',3216,66040,'[{1,2032},{3,1016}]'),(7,228,'[{3,0,86623}]',898,'[{90,1},{7,2},{2,3},{1,5}]',3232,66560,'[{1,2048},{3,1024}]'),(7,229,'[{3,0,92785}]',902,'[{90,1},{7,2},{2,3},{1,5}]',3247,67080,'[{1,2064},{3,1032}]'),(7,230,'[{3,0,98948}]',907,'[{90,1},{7,2},{2,3},{1,5}]',3263,67600,'[{1,2080},{3,1040}]'),(7,231,'[{3,0,105110}]',911,'[{90,1},{7,2},{2,3},{1,5}]',3279,68120,'[{1,2096},{3,1048}]'),(7,232,'[{3,0,111272}]',915,'[{90,1},{7,2},{2,3},{1,5}]',3294,68640,'[{1,2112},{3,1056}]'),(7,233,'[{3,0,117434}]',920,'[{90,1},{7,2},{2,3},{1,5}]',3310,69160,'[{1,2128},{3,1064}]'),(7,234,'[{3,0,123597}]',924,'[{90,1},{7,2},{2,3},{1,5}]',3326,69680,'[{1,2144},{3,1072}]'),(7,235,'[{3,0,129759}]',929,'[{90,1},{7,2},{2,3},{1,5}]',3342,70200,'[{1,2160},{3,1080}]'),(7,236,'[{3,0,135921}]',933,'[{90,1},{7,2},{2,3},{1,5}]',3357,70720,'[{1,2176},{3,1088}]'),(7,237,'[{3,0,142083}]',937,'[{90,1},{7,2},{2,3},{1,5}]',3373,71240,'[{1,2192},{3,1096}]'),(7,238,'[{3,0,148245}]',942,'[{90,1},{7,2},{2,3},{1,5}]',3389,71760,'[{1,2208},{3,1104}]'),(7,239,'[{3,0,154408}]',946,'[{90,1},{7,2},{2,3},{1,5}]',3405,72280,'[{1,2224},{3,1112}]'),(7,240,'[{3,0,160570}]',950,'[{90,1},{7,2},{2,3},{1,5}]',3420,72800,'[{1,2240},{3,1120}]'),(7,241,'[{3,0,166732}]',955,'[{90,1},{7,2},{2,3},{1,5}]',3436,73320,'[{1,2256},{3,1128}]'),(7,242,'[{3,0,172894}]',959,'[{90,1},{7,2},{2,3},{1,5}]',3452,73840,'[{1,2272},{3,1136}]'),(7,243,'[{3,0,179057}]',964,'[{90,1},{7,2},{2,3},{1,5}]',3468,74360,'[{1,2288},{3,1144}]'),(7,244,'[{3,0,185219}]',968,'[{90,1},{7,2},{2,3},{1,5}]',3484,74880,'[{1,2304},{3,1152}]'),(7,245,'[{3,0,191381}]',972,'[{90,1},{7,2},{2,3},{1,5}]',3499,75400,'[{1,2320},{3,1160}]'),(7,246,'[{3,0,197543}]',977,'[{90,1},{7,2},{2,3},{1,5}]',3515,75920,'[{1,2336},{3,1168}]'),(7,247,'[{3,0,203705}]',981,'[{90,1},{7,2},{2,3},{1,5}]',3531,76440,'[{1,2352},{3,1176}]'),(7,248,'[{3,0,209868}]',986,'[{90,1},{7,2},{2,3},{1,5}]',3547,76960,'[{1,2368},{3,1184}]'),(7,249,'[{3,0,222203}]',1018,'[{90,1},{7,2},{2,3},{1,5}]',3563,77480,'[{1,2384},{3,1192}]'),(7,250,'[{3,0,228297}]',1023,'[{90,1},{7,2},{2,3},{1,5}]',3579,78000,'[{1,2400},{3,1200}]'),(7,251,'[{3,0,234391}]',1028,'[{90,1},{7,2},{2,3},{1,5}]',3595,78520,'[{1,2416},{3,1208}]'),(7,252,'[{3,0,240485}]',1032,'[{90,1},{7,2},{2,3},{1,5}]',3610,79040,'[{1,2432},{3,1216}]'),(7,253,'[{3,0,246579}]',1036,'[{90,1},{7,2},{2,3},{1,5}]',3626,79560,'[{1,2448},{3,1224}]'),(7,254,'[{3,0,252673}]',1041,'[{90,1},{7,2},{2,3},{1,5}]',3642,80080,'[{1,2464},{3,1232}]'),(7,255,'[{3,0,258767}]',1046,'[{90,1},{7,2},{2,3},{1,5}]',3658,80600,'[{1,2480},{3,1240}]'),(7,256,'[{3,0,264861}]',1050,'[{90,1},{7,2},{2,3},{1,5}]',3674,81120,'[{1,2496},{3,1248}]'),(7,257,'[{3,0,270955}]',1055,'[{90,1},{7,2},{2,3},{1,5}]',3690,81640,'[{1,2512},{3,1256}]'),(7,258,'[{3,0,277049}]',1059,'[{90,1},{7,2},{2,3},{1,5}]',3706,82160,'[{1,2528},{3,1264}]'),(7,259,'[{3,0,283143}]',1064,'[{90,1},{7,2},{2,3},{1,5}]',3722,82680,'[{1,2544},{3,1272}]'),(7,260,'[{3,0,289237}]',1068,'[{90,1},{7,2},{2,3},{1,5}]',3738,83200,'[{1,2560},{3,1280}]'),(7,261,'[{3,0,295331}]',1073,'[{90,1},{7,2},{2,3},{1,5}]',3754,83720,'[{1,2576},{3,1288}]'),(7,262,'[{3,0,301425}]',1078,'[{90,1},{7,2},{2,3},{1,5}]',3770,84240,'[{1,2592},{3,1296}]'),(7,263,'[{3,0,307519}]',1082,'[{90,1},{7,2},{2,3},{1,5}]',3786,84760,'[{1,2608},{3,1304}]'),(7,264,'[{3,0,313613}]',1087,'[{90,1},{7,2},{2,3},{1,5}]',3802,85280,'[{1,2624},{3,1312}]'),(7,265,'[{3,0,319707}]',1091,'[{90,1},{7,2},{2,3},{1,5}]',3818,85800,'[{1,2640},{3,1320}]'),(7,266,'[{3,0,325801}]',1096,'[{90,1},{7,2},{2,3},{1,5}]',3834,86320,'[{1,2656},{3,1328}]'),(7,267,'[{3,0,331895}]',1100,'[{90,1},{7,2},{2,3},{1,5}]',3850,86840,'[{1,2672},{3,1336}]'),(7,268,'[{3,0,337989}]',1105,'[{90,1},{7,2},{2,3},{1,5}]',3866,87360,'[{1,2688},{3,1344}]'),(7,269,'[{3,0,344083}]',1110,'[{90,1},{7,2},{2,3},{1,5}]',3882,87880,'[{1,2704},{3,1352}]'),(7,270,'[{3,0,350177}]',1114,'[{90,1},{7,2},{2,3},{1,5}]',3898,88400,'[{1,2720},{3,1360}]'),(7,271,'[{3,0,356271}]',1119,'[{90,1},{7,2},{2,3},{1,5}]',3914,88920,'[{1,2736},{3,1368}]'),(7,272,'[{3,0,362365}]',1123,'[{90,1},{7,2},{2,3},{1,5}]',3930,89440,'[{1,2752},{3,1376}]'),(7,273,'[{3,0,368459}]',1128,'[{90,1},{7,2},{2,3},{1,5}]',3946,89960,'[{1,2768},{3,1384}]'),(7,274,'[{3,0,374550}]',1132,'[{90,1},{7,2},{2,3},{1,5}]',3962,90480,'[{1,2784},{3,1392}]'),(7,275,'[{3,0,381734}]',1137,'[{90,1},{7,2},{2,3},{1,5}]',3978,91000,'[{1,2800},{3,1400}]'),(7,276,'[{3,0,388919}]',1142,'[{90,1},{7,2},{2,3},{1,5}]',3994,91520,'[{1,2816},{3,1408}]'),(7,277,'[{3,0,396104}]',1146,'[{90,1},{7,2},{2,3},{1,5}]',4010,92040,'[{1,2832},{3,1416}]'),(7,278,'[{3,0,403288}]',1151,'[{90,1},{7,2},{2,3},{1,5}]',4026,92560,'[{1,2848},{3,1424}]'),(7,279,'[{3,0,410473}]',1155,'[{90,1},{7,2},{2,3},{1,5}]',4042,93080,'[{1,2864},{3,1432}]'),(7,280,'[{3,0,417657}]',1160,'[{90,1},{7,2},{2,3},{1,5}]',4059,93600,'[{1,2880},{3,1440}]'),(7,281,'[{3,0,424842}]',1165,'[{90,1},{7,2},{2,3},{1,5}]',4075,94120,'[{1,2896},{3,1448}]'),(7,282,'[{3,0,432026}]',1169,'[{90,1},{7,2},{2,3},{1,5}]',4091,94640,'[{1,2912},{3,1456}]'),(7,283,'[{3,0,439211}]',1174,'[{90,1},{7,2},{2,3},{1,5}]',4107,95160,'[{1,2928},{3,1464}]'),(7,284,'[{3,0,446396}]',1178,'[{90,1},{7,2},{2,3},{1,5}]',4123,95680,'[{1,2944},{3,1472}]'),(7,285,'[{3,0,453580}]',1183,'[{90,1},{7,2},{2,3},{1,5}]',4139,96200,'[{1,2960},{3,1480}]'),(7,286,'[{3,0,460765}]',1188,'[{90,1},{7,2},{2,3},{1,5}]',4155,96720,'[{1,2976},{3,1488}]'),(7,287,'[{3,0,467949}]',1192,'[{90,1},{7,2},{2,3},{1,5}]',4172,97240,'[{1,2992},{3,1496}]'),(7,288,'[{3,0,475134}]',1197,'[{90,1},{7,2},{2,3},{1,5}]',4188,97760,'[{1,3008},{3,1504}]'),(7,289,'[{3,0,482318}]',1202,'[{90,1},{7,2},{2,3},{1,5}]',4204,98280,'[{1,3024},{3,1512}]'),(7,290,'[{3,0,489503}]',1206,'[{90,1},{7,2},{2,3},{1,5}]',4220,98800,'[{1,3040},{3,1520}]'),(7,291,'[{3,0,496688}]',1211,'[{90,1},{7,2},{2,3},{1,5}]',4236,99320,'[{1,3056},{3,1528}]'),(7,292,'[{3,0,503872}]',1216,'[{90,1},{7,2},{2,3},{1,5}]',4253,99840,'[{1,3072},{3,1536}]'),(7,293,'[{3,0,511057}]',1220,'[{90,1},{7,2},{2,3},{1,5}]',4269,100360,'[{1,3088},{3,1544}]'),(7,294,'[{3,0,518241}]',1225,'[{90,1},{7,2},{2,3},{1,5}]',4285,100880,'[{1,3104},{3,1552}]'),(7,295,'[{3,0,525426}]',1229,'[{90,1},{7,2},{2,3},{1,5}]',4301,101400,'[{1,3120},{3,1560}]'),(7,296,'[{3,0,532610}]',1234,'[{90,1},{7,2},{2,3},{1,5}]',4317,101920,'[{1,3136},{3,1568}]'),(7,297,'[{3,0,539795}]',1239,'[{90,1},{7,2},{2,3},{1,5}]',4334,102440,'[{1,3152},{3,1576}]'),(7,298,'[{3,0,546980}]',1243,'[{90,1},{7,2},{2,3},{1,5}]',4350,102960,'[{1,3168},{3,1584}]'),(7,299,'[{3,0,570466}]',1285,'[{90,1},{7,2},{2,3},{1,5}]',4366,103480,'[{1,3184},{3,1592}]'),(7,300,'[{3,0,581815}]',1289,'[{90,1},{7,2},{2,3},{1,5}]',4382,104000,'[{1,3200},{3,1600}]'),(7,301,'[{3,0,593165}]',1294,'[{90,1},{7,2},{2,3},{1,5}]',4399,104780,'[{1,3224},{3,1612}]'),(7,302,'[{3,0,604515}]',1299,'[{90,1},{7,2},{2,3},{1,5}]',4415,105560,'[{1,3248},{3,1624}]'),(7,303,'[{3,0,615865}]',1304,'[{90,1},{7,2},{2,3},{1,5}]',4431,106340,'[{1,3272},{3,1636}]'),(7,304,'[{3,0,627214}]',1309,'[{90,1},{7,2},{2,3},{1,5}]',4448,107120,'[{1,3296},{3,1648}]'),(7,305,'[{3,0,638564}]',1313,'[{90,1},{7,2},{2,3},{1,5}]',4464,107900,'[{1,3320},{3,1660}]'),(7,306,'[{3,0,649914}]',1318,'[{90,1},{7,2},{2,3},{1,5}]',4480,108680,'[{1,3344},{3,1672}]'),(7,307,'[{3,0,661263}]',1323,'[{90,1},{7,2},{2,3},{1,5}]',4497,109460,'[{1,3368},{3,1684}]'),(7,308,'[{3,0,672613}]',1328,'[{90,1},{7,2},{2,3},{1,5}]',4513,110240,'[{1,3392},{3,1696}]'),(7,309,'[{3,0,683963}]',1333,'[{90,1},{7,2},{2,3},{1,5}]',4529,111020,'[{1,3416},{3,1708}]'),(7,310,'[{3,0,695313}]',1338,'[{90,1},{7,2},{2,3},{1,5}]',4546,111800,'[{1,3440},{3,1720}]'),(7,311,'[{3,0,706662}]',1342,'[{90,1},{7,2},{2,3},{1,5}]',4562,112580,'[{1,3464},{3,1732}]'),(7,312,'[{3,0,718012}]',1347,'[{90,1},{7,2},{2,3},{1,5}]',4578,113360,'[{1,3488},{3,1744}]'),(7,313,'[{3,0,729362}]',1352,'[{90,1},{7,2},{2,3},{1,5}]',4595,114140,'[{1,3512},{3,1756}]'),(7,314,'[{3,0,740711}]',1357,'[{90,1},{7,2},{2,3},{1,5}]',4611,114920,'[{1,3536},{3,1768}]'),(7,315,'[{3,0,752061}]',1361,'[{90,1},{7,2},{2,3},{1,5}]',4627,115700,'[{1,3560},{3,1780}]'),(7,316,'[{3,0,763411}]',1366,'[{90,1},{7,2},{2,3},{1,5}]',4644,116480,'[{1,3584},{3,1792}]'),(7,317,'[{3,0,774760}]',1371,'[{90,1},{7,2},{2,3},{1,5}]',4660,117260,'[{1,3608},{3,1804}]'),(7,318,'[{3,0,786110}]',1376,'[{90,1},{7,2},{2,3},{1,5}]',4677,118040,'[{1,3632},{3,1816}]'),(7,319,'[{3,0,797460}]',1381,'[{90,1},{7,2},{2,3},{1,5}]',4693,118820,'[{1,3656},{3,1828}]'),(7,320,'[{3,0,808810}]',1385,'[{90,1},{7,2},{2,3},{1,5}]',4709,119600,'[{1,3680},{3,1840}]'),(7,321,'[{3,0,820159}]',1390,'[{90,1},{7,2},{2,3},{1,5}]',4726,120380,'[{1,3704},{3,1852}]'),(7,322,'[{3,0,831509}]',1395,'[{90,1},{7,2},{2,3},{1,5}]',4742,121160,'[{1,3728},{3,1864}]'),(7,323,'[{3,0,842859}]',1400,'[{90,1},{7,2},{2,3},{1,5}]',4759,121940,'[{1,3752},{3,1876}]'),(7,324,'[{3,0,854205}]',1405,'[{90,1},{7,2},{2,3},{1,5}]',4775,122720,'[{1,3776},{3,1888}]'),(7,325,'[{3,0,869085}]',1410,'[{90,1},{7,2},{2,3},{1,5}]',4792,123500,'[{1,3800},{3,1900}]'),(7,326,'[{3,0,883965}]',1415,'[{90,1},{7,2},{2,3},{1,5}]',4808,124280,'[{1,3824},{3,1912}]'),(7,327,'[{3,0,898846}]',1420,'[{90,1},{7,2},{2,3},{1,5}]',4825,125060,'[{1,3848},{3,1924}]'),(7,328,'[{3,0,913726}]',1424,'[{90,1},{7,2},{2,3},{1,5}]',4841,125840,'[{1,3872},{3,1936}]'),(7,329,'[{3,0,928606}]',1429,'[{90,1},{7,2},{2,3},{1,5}]',4857,126620,'[{1,3896},{3,1948}]'),(7,330,'[{3,0,943487}]',1434,'[{90,1},{7,2},{2,3},{1,5}]',4874,127400,'[{1,3920},{3,1960}]'),(7,331,'[{3,0,958367}]',1439,'[{90,1},{7,2},{2,3},{1,5}]',4890,128180,'[{1,3944},{3,1972}]'),(7,332,'[{3,0,973247}]',1444,'[{90,1},{7,2},{2,3},{1,5}]',4907,128960,'[{1,3968},{3,1984}]'),(7,333,'[{3,0,988128}]',1448,'[{90,1},{7,2},{2,3},{1,5}]',4923,129740,'[{1,3992},{3,1996}]'),(7,334,'[{3,0,1003008}]',1453,'[{90,1},{7,2},{2,3},{1,5}]',4940,130520,'[{1,4016},{3,2008}]'),(7,335,'[{3,0,1017888}]',1458,'[{90,1},{7,2},{2,3},{1,5}]',4956,131300,'[{1,4040},{3,2020}]'),(7,336,'[{3,0,1032768}]',1463,'[{90,1},{7,2},{2,3},{1,5}]',4973,132080,'[{1,4064},{3,2032}]'),(7,337,'[{3,0,1047649}]',1468,'[{90,1},{7,2},{2,3},{1,5}]',4990,132860,'[{1,4088},{3,2044}]'),(7,338,'[{3,0,1062529}]',1473,'[{90,1},{7,2},{2,3},{1,5}]',5006,133640,'[{1,4112},{3,2056}]'),(7,339,'[{3,0,1077409}]',1478,'[{90,1},{7,2},{2,3},{1,5}]',5023,134420,'[{1,4136},{3,2068}]'),(7,340,'[{3,0,1092290}]',1483,'[{90,1},{7,2},{2,3},{1,5}]',5039,135200,'[{1,4160},{3,2080}]'),(7,341,'[{3,0,1107170}]',1488,'[{90,1},{7,2},{2,3},{1,5}]',5056,135980,'[{1,4184},{3,2092}]'),(7,342,'[{3,0,1122050}]',1492,'[{90,1},{7,2},{2,3},{1,5}]',5072,136760,'[{1,4208},{3,2104}]'),(7,343,'[{3,0,1136930}]',1497,'[{90,1},{7,2},{2,3},{1,5}]',5089,137540,'[{1,4232},{3,2116}]'),(7,344,'[{3,0,1151811}]',1502,'[{90,1},{7,2},{2,3},{1,5}]',5105,138320,'[{1,4256},{3,2128}]'),(7,345,'[{3,0,1166691}]',1507,'[{90,1},{7,2},{2,3},{1,5}]',5122,139100,'[{1,4280},{3,2140}]'),(7,346,'[{3,0,1181571}]',1512,'[{90,1},{7,2},{2,3},{1,5}]',5139,139880,'[{1,4304},{3,2152}]'),(7,347,'[{3,0,1196452}]',1517,'[{90,1},{7,2},{2,3},{1,5}]',5155,140660,'[{1,4328},{3,2164}]'),(7,348,'[{3,0,1211332}]',1522,'[{90,1},{7,2},{2,3},{1,5}]',5172,141440,'[{1,4352},{3,2176}]'),(7,349,'[{3,0,1263370}]',1573,'[{90,1},{7,2},{2,3},{1,5}]',5188,142220,'[{1,4376},{3,2188}]'),(7,350,'[{3,0,1279417}]',1578,'[{90,1},{7,2},{2,3},{1,5}]',5205,143000,'[{1,4400},{3,2200}]'),(7,351,'[{3,0,1295463}]',1583,'[{90,1},{7,2},{2,3},{1,5}]',5222,143780,'[{1,4424},{3,2212}]'),(7,352,'[{3,0,1311509}]',1588,'[{90,1},{7,2},{2,3},{1,5}]',5238,144560,'[{1,4448},{3,2224}]'),(7,353,'[{3,0,1327556}]',1593,'[{90,1},{7,2},{2,3},{1,5}]',5255,145340,'[{1,4472},{3,2236}]'),(7,354,'[{3,0,1343602}]',1598,'[{90,1},{7,2},{2,3},{1,5}]',5272,146120,'[{1,4496},{3,2248}]'),(7,355,'[{3,0,1359648}]',1603,'[{90,1},{7,2},{2,3},{1,5}]',5288,146900,'[{1,4520},{3,2260}]'),(7,356,'[{3,0,1375695}]',1608,'[{90,1},{7,2},{2,3},{1,5}]',5305,147680,'[{1,4544},{3,2272}]'),(7,357,'[{3,0,1391741}]',1613,'[{90,1},{7,2},{2,3},{1,5}]',5322,148460,'[{1,4568},{3,2284}]'),(7,358,'[{3,0,1407787}]',1618,'[{90,1},{7,2},{2,3},{1,5}]',5338,149240,'[{1,4592},{3,2296}]'),(7,359,'[{3,0,1423834}]',1623,'[{90,1},{7,2},{2,3},{1,5}]',5355,150020,'[{1,4616},{3,2308}]'),(7,360,'[{3,0,1439880}]',1628,'[{90,1},{7,2},{2,3},{1,5}]',5372,150800,'[{1,4640},{3,2320}]'),(7,361,'[{3,0,1455927}]',1633,'[{90,1},{7,2},{2,3},{1,5}]',5388,151580,'[{1,4664},{3,2332}]'),(7,362,'[{3,0,1471973}]',1638,'[{90,1},{7,2},{2,3},{1,5}]',5405,152360,'[{1,4688},{3,2344}]'),(7,363,'[{3,0,1488019}]',1644,'[{90,1},{7,2},{2,3},{1,5}]',5422,153140,'[{1,4712},{3,2356}]'),(7,364,'[{3,0,1504066}]',1648,'[{90,1},{7,2},{2,3},{1,5}]',5438,153920,'[{1,4736},{3,2368}]'),(7,365,'[{3,0,1520112}]',1654,'[{90,1},{7,2},{2,3},{1,5}]',5455,154700,'[{1,4760},{3,2380}]'),(7,366,'[{3,0,1536158}]',1659,'[{90,1},{7,2},{2,3},{1,5}]',5472,155480,'[{1,4784},{3,2392}]'),(7,367,'[{3,0,1552205}]',1664,'[{90,1},{7,2},{2,3},{1,5}]',5489,156260,'[{1,4808},{3,2404}]'),(7,368,'[{3,0,1568251}]',1669,'[{90,1},{7,2},{2,3},{1,5}]',5505,157040,'[{1,4832},{3,2416}]'),(7,369,'[{3,0,1584297}]',1674,'[{90,1},{7,2},{2,3},{1,5}]',5522,157820,'[{1,4856},{3,2428}]'),(7,370,'[{3,0,1600344}]',1679,'[{90,1},{7,2},{2,3},{1,5}]',5539,158600,'[{1,4880},{3,2440}]'),(7,371,'[{3,0,1616390}]',1684,'[{90,1},{7,2},{2,3},{1,5}]',5556,159380,'[{1,4904},{3,2452}]'),(7,372,'[{3,0,1632437}]',1689,'[{90,1},{7,2},{2,3},{1,5}]',5572,160160,'[{1,4928},{3,2464}]'),(7,373,'[{3,0,1648483}]',1694,'[{90,1},{7,2},{2,3},{1,5}]',5589,160940,'[{1,4952},{3,2476}]'),(7,374,'[{3,0,1664530}]',1699,'[{90,1},{7,2},{2,3},{1,5}]',5606,161720,'[{1,4976},{3,2488}]'),(7,375,'[{3,0,1679756}]',1704,'[{90,1},{7,2},{2,3},{1,5}]',5623,162500,'[{1,5000},{3,2500}]'),(7,376,'[{3,0,1694982}]',1710,'[{90,1},{7,2},{2,3},{1,5}]',5640,163280,'[{1,5024},{3,2512}]'),(7,377,'[{3,0,1710209}]',1714,'[{90,1},{7,2},{2,3},{1,5}]',5656,164060,'[{1,5048},{3,2524}]'),(7,378,'[{3,0,1725435}]',1720,'[{90,1},{7,2},{2,3},{1,5}]',5673,164840,'[{1,5072},{3,2536}]'),(7,379,'[{3,0,1740661}]',1725,'[{90,1},{7,2},{2,3},{1,5}]',5690,165620,'[{1,5096},{3,2548}]'),(7,380,'[{3,0,1755888}]',1730,'[{90,1},{7,2},{2,3},{1,5}]',5707,166400,'[{1,5120},{3,2560}]'),(7,381,'[{3,0,1771114}]',1735,'[{90,1},{7,2},{2,3},{1,5}]',5724,167180,'[{1,5144},{3,2572}]'),(7,382,'[{3,0,1786340}]',1740,'[{90,1},{7,2},{2,3},{1,5}]',5740,167960,'[{1,5168},{3,2584}]'),(7,383,'[{3,0,1801567}]',1745,'[{90,1},{7,2},{2,3},{1,5}]',5757,168740,'[{1,5192},{3,2596}]'),(7,384,'[{3,0,1816793}]',1750,'[{90,1},{7,2},{2,3},{1,5}]',5774,169520,'[{1,5216},{3,2608}]'),(7,385,'[{3,0,1832020}]',1755,'[{90,1},{7,2},{2,3},{1,5}]',5791,170300,'[{1,5240},{3,2620}]'),(7,386,'[{3,0,1847246}]',1760,'[{90,1},{7,2},{2,3},{1,5}]',5808,171080,'[{1,5264},{3,2632}]'),(7,387,'[{3,0,1862472}]',1766,'[{90,1},{7,2},{2,3},{1,5}]',5825,171860,'[{1,5288},{3,2644}]'),(7,388,'[{3,0,1877699}]',1770,'[{90,1},{7,2},{2,3},{1,5}]',5841,172640,'[{1,5312},{3,2656}]'),(7,389,'[{3,0,1892925}]',1776,'[{90,1},{7,2},{2,3},{1,5}]',5858,173420,'[{1,5336},{3,2668}]'),(7,390,'[{3,0,1908151}]',1781,'[{90,1},{7,2},{2,3},{1,5}]',5875,174200,'[{1,5360},{3,2680}]'),(7,391,'[{3,0,1923378}]',1786,'[{90,1},{7,2},{2,3},{1,5}]',5892,174980,'[{1,5384},{3,2692}]'),(7,392,'[{3,0,1938604}]',1791,'[{90,1},{7,2},{2,3},{1,5}]',5909,175760,'[{1,5408},{3,2704}]'),(7,393,'[{3,0,1953830}]',1796,'[{90,1},{7,2},{2,3},{1,5}]',5926,176540,'[{1,5432},{3,2716}]'),(7,394,'[{3,0,1969057}]',1801,'[{90,1},{7,2},{2,3},{1,5}]',5943,177320,'[{1,5456},{3,2728}]'),(7,395,'[{3,0,1984283}]',1807,'[{90,1},{7,2},{2,3},{1,5}]',5960,178100,'[{1,5480},{3,2740}]'),(7,396,'[{3,0,1999510}]',1812,'[{90,1},{7,2},{2,3},{1,5}]',5977,178880,'[{1,5504},{3,2752}]'),(7,397,'[{3,0,2014736}]',1817,'[{90,1},{7,2},{2,3},{1,5}]',5993,179660,'[{1,5528},{3,2764}]'),(7,398,'[{3,0,2029962}]',1822,'[{90,1},{7,2},{2,3},{1,5}]',6010,180440,'[{1,5552},{3,2776}]'),(7,399,'[{3,0,2109102}]',1884,'[{90,1},{7,2},{2,3},{1,5}]',6027,181220,'[{1,5576},{3,2788}]'),(7,400,'[{3,0,2133037}]',1889,'[{90,1},{7,2},{2,3},{1,5}]',6044,182000,'[{1,5600},{3,2800}]'),(7,401,'[{3,0,2156972}]',1895,'[{90,1},{7,2},{2,3},{1,5}]',6061,183040,'[{1,5632},{3,2816}]'),(7,402,'[{3,0,2180907}]',1900,'[{90,1},{7,2},{2,3},{1,5}]',6078,184080,'[{1,5664},{3,2832}]'),(7,403,'[{3,0,2204842}]',1905,'[{90,1},{7,2},{2,3},{1,5}]',6095,185120,'[{1,5696},{3,2848}]'),(7,404,'[{3,0,2228777}]',1910,'[{90,1},{7,2},{2,3},{1,5}]',6112,186160,'[{1,5728},{3,2864}]'),(7,405,'[{3,0,2252712}]',1916,'[{90,1},{7,2},{2,3},{1,5}]',6129,187200,'[{1,5760},{3,2880}]'),(7,406,'[{3,0,2276647}]',1921,'[{90,1},{7,2},{2,3},{1,5}]',6146,188240,'[{1,5792},{3,2896}]'),(7,407,'[{3,0,2300582}]',1926,'[{90,1},{7,2},{2,3},{1,5}]',6163,189280,'[{1,5824},{3,2912}]'),(7,408,'[{3,0,2324517}]',1932,'[{90,1},{7,2},{2,3},{1,5}]',6180,190320,'[{1,5856},{3,2928}]'),(7,409,'[{3,0,2348452}]',1937,'[{90,1},{7,2},{2,3},{1,5}]',6197,191360,'[{1,5888},{3,2944}]'),(7,410,'[{3,0,2372387}]',1942,'[{90,1},{7,2},{2,3},{1,5}]',6214,192400,'[{1,5920},{3,2960}]'),(7,411,'[{3,0,2396322}]',1948,'[{90,1},{7,2},{2,3},{1,5}]',6231,193440,'[{1,5952},{3,2976}]'),(7,412,'[{3,0,2420257}]',1953,'[{90,1},{7,2},{2,3},{1,5}]',6248,194480,'[{1,5984},{3,2992}]'),(7,413,'[{3,0,2444192}]',1958,'[{90,1},{7,2},{2,3},{1,5}]',6265,195520,'[{1,6016},{3,3008}]'),(7,414,'[{3,0,2468127}]',1964,'[{90,1},{7,2},{2,3},{1,5}]',6282,196560,'[{1,6048},{3,3024}]'),(7,415,'[{3,0,2492062}]',1969,'[{90,1},{7,2},{2,3},{1,5}]',6299,197600,'[{1,6080},{3,3040}]'),(7,416,'[{3,0,2515997}]',1974,'[{90,1},{7,2},{2,3},{1,5}]',6316,198640,'[{1,6112},{3,3056}]'),(7,417,'[{3,0,2539932}]',1980,'[{90,1},{7,2},{2,3},{1,5}]',6333,199680,'[{1,6144},{3,3072}]'),(7,418,'[{3,0,2563867}]',1985,'[{90,1},{7,2},{2,3},{1,5}]',6350,200720,'[{1,6176},{3,3088}]'),(7,419,'[{3,0,2587802}]',1990,'[{90,1},{7,2},{2,3},{1,5}]',6367,201760,'[{1,6208},{3,3104}]'),(7,420,'[{3,0,2611737}]',1995,'[{90,1},{7,2},{2,3},{1,5}]',6384,202800,'[{1,6240},{3,3120}]'),(7,421,'[{3,0,2635672}]',2001,'[{90,1},{7,2},{2,3},{1,5}]',6401,203840,'[{1,6272},{3,3136}]'),(7,422,'[{3,0,2659607}]',2006,'[{90,1},{7,2},{2,3},{1,5}]',6418,204880,'[{1,6304},{3,3152}]'),(7,423,'[{3,0,2683542}]',2011,'[{90,1},{7,2},{2,3},{1,5}]',6435,205920,'[{1,6336},{3,3168}]'),(7,424,'[{3,0,2707479}]',2017,'[{90,1},{7,2},{2,3},{1,5}]',6452,206960,'[{1,6368},{3,3184}]'),(7,425,'[{3,0,2730859}]',2022,'[{90,1},{7,2},{2,3},{1,5}]',6470,208000,'[{1,6400},{3,3200}]'),(7,426,'[{3,0,2754239}]',2028,'[{90,1},{7,2},{2,3},{1,5}]',6487,209040,'[{1,6432},{3,3216}]'),(7,427,'[{3,0,2777618}]',2033,'[{90,1},{7,2},{2,3},{1,5}]',6504,210080,'[{1,6464},{3,3232}]'),(7,428,'[{3,0,2800998}]',2038,'[{90,1},{7,2},{2,3},{1,5}]',6521,211120,'[{1,6496},{3,3248}]'),(7,429,'[{3,0,2824378}]',2044,'[{90,1},{7,2},{2,3},{1,5}]',6538,212160,'[{1,6528},{3,3264}]'),(7,430,'[{3,0,2847757}]',2049,'[{90,1},{7,2},{2,3},{1,5}]',6555,213200,'[{1,6560},{3,3280}]'),(7,431,'[{3,0,2871137}]',2054,'[{90,1},{7,2},{2,3},{1,5}]',6572,214240,'[{1,6592},{3,3296}]'),(7,432,'[{3,0,2894517}]',2060,'[{90,1},{7,2},{2,3},{1,5}]',6589,215280,'[{1,6624},{3,3312}]'),(7,433,'[{3,0,2917896}]',2065,'[{90,1},{7,2},{2,3},{1,5}]',6606,216320,'[{1,6656},{3,3328}]'),(7,434,'[{3,0,2941276}]',2070,'[{90,1},{7,2},{2,3},{1,5}]',6624,217360,'[{1,6688},{3,3344}]'),(7,435,'[{3,0,2964656}]',2076,'[{90,1},{7,2},{2,3},{1,5}]',6641,218400,'[{1,6720},{3,3360}]'),(7,436,'[{3,0,2988035}]',2081,'[{90,1},{7,2},{2,3},{1,5}]',6658,219440,'[{1,6752},{3,3376}]'),(7,437,'[{3,0,3011415}]',2086,'[{90,1},{7,2},{2,3},{1,5}]',6675,220480,'[{1,6784},{3,3392}]'),(7,438,'[{3,0,3034795}]',2092,'[{90,1},{7,2},{2,3},{1,5}]',6692,221520,'[{1,6816},{3,3408}]'),(7,439,'[{3,0,3058175}]',2097,'[{90,1},{7,2},{2,3},{1,5}]',6709,222560,'[{1,6848},{3,3424}]'),(7,440,'[{3,0,3081554}]',2102,'[{90,1},{7,2},{2,3},{1,5}]',6726,223600,'[{1,6880},{3,3440}]'),(7,441,'[{3,0,3104934}]',2108,'[{90,1},{7,2},{2,3},{1,5}]',6744,224640,'[{1,6912},{3,3456}]'),(7,442,'[{3,0,3128314}]',2113,'[{90,1},{7,2},{2,3},{1,5}]',6761,225680,'[{1,6944},{3,3472}]'),(7,443,'[{3,0,3151693}]',2119,'[{90,1},{7,2},{2,3},{1,5}]',6778,226720,'[{1,6976},{3,3488}]'),(7,444,'[{3,0,3175073}]',2124,'[{90,1},{7,2},{2,3},{1,5}]',6795,227760,'[{1,7008},{3,3504}]'),(7,445,'[{3,0,3198453}]',2129,'[{90,1},{7,2},{2,3},{1,5}]',6812,228800,'[{1,7040},{3,3520}]'),(7,446,'[{3,0,3221832}]',2135,'[{90,1},{7,2},{2,3},{1,5}]',6830,229840,'[{1,7072},{3,3536}]'),(7,447,'[{3,0,3245212}]',2140,'[{90,1},{7,2},{2,3},{1,5}]',6847,230880,'[{1,7104},{3,3552}]'),(7,448,'[{3,0,3268592}]',2145,'[{90,1},{7,2},{2,3},{1,5}]',6864,231920,'[{1,7136},{3,3568}]'),(7,449,'[{3,0,3398166}]',2220,'[{90,1},{7,2},{2,3},{1,5}]',6881,232960,'[{1,7168},{3,3584}]'),(7,450,'[{3,0,3413589}]',2226,'[{90,1},{7,2},{2,3},{1,5}]',6898,234000,'[{1,7200},{3,3600}]'),(7,451,'[{3,0,3429011}]',2231,'[{90,1},{7,2},{2,3},{1,5}]',6916,235040,'[{1,7232},{3,3616}]'),(7,452,'[{3,0,3444434}]',2237,'[{90,1},{7,2},{2,3},{1,5}]',6933,236080,'[{1,7264},{3,3632}]'),(7,453,'[{3,0,3459856}]',2242,'[{90,1},{7,2},{2,3},{1,5}]',6950,237120,'[{1,7296},{3,3648}]'),(7,454,'[{3,0,3475279}]',2248,'[{90,1},{7,2},{2,3},{1,5}]',6967,238160,'[{1,7328},{3,3664}]'),(7,455,'[{3,0,3490701}]',2254,'[{90,1},{7,2},{2,3},{1,5}]',6985,239200,'[{1,7360},{3,3680}]'),(7,456,'[{3,0,3506124}]',2259,'[{90,1},{7,2},{2,3},{1,5}]',7002,240240,'[{1,7392},{3,3696}]'),(7,457,'[{3,0,3521547}]',2265,'[{90,1},{7,2},{2,3},{1,5}]',7019,241280,'[{1,7424},{3,3712}]'),(7,458,'[{3,0,3536969}]',2270,'[{90,1},{7,2},{2,3},{1,5}]',7036,242320,'[{1,7456},{3,3728}]'),(7,459,'[{3,0,3552392}]',2276,'[{90,1},{7,2},{2,3},{1,5}]',7054,243360,'[{1,7488},{3,3744}]'),(7,460,'[{3,0,3567814}]',2281,'[{90,1},{7,2},{2,3},{1,5}]',7071,244400,'[{1,7520},{3,3760}]'),(7,461,'[{3,0,3583237}]',2287,'[{90,1},{7,2},{2,3},{1,5}]',7088,245440,'[{1,7552},{3,3776}]'),(7,462,'[{3,0,3598660}]',2292,'[{90,1},{7,2},{2,3},{1,5}]',7105,246480,'[{1,7584},{3,3792}]'),(7,463,'[{3,0,3614082}]',2298,'[{90,1},{7,2},{2,3},{1,5}]',7123,247520,'[{1,7616},{3,3808}]'),(7,464,'[{3,0,3629505}]',2304,'[{90,1},{7,2},{2,3},{1,5}]',7140,248560,'[{1,7648},{3,3824}]'),(7,465,'[{3,0,3644927}]',2309,'[{90,1},{7,2},{2,3},{1,5}]',7157,249600,'[{1,7680},{3,3840}]'),(7,466,'[{3,0,3660350}]',2315,'[{90,1},{7,2},{2,3},{1,5}]',7175,250640,'[{1,7712},{3,3856}]'),(7,467,'[{3,0,3675772}]',2320,'[{90,1},{7,2},{2,3},{1,5}]',7192,251680,'[{1,7744},{3,3872}]'),(7,468,'[{3,0,3691195}]',2326,'[{90,1},{7,2},{2,3},{1,5}]',7209,252720,'[{1,7776},{3,3888}]'),(7,469,'[{3,0,3706618}]',2332,'[{90,1},{7,2},{2,3},{1,5}]',7227,253760,'[{1,7808},{3,3904}]'),(7,470,'[{3,0,3722040}]',2337,'[{90,1},{7,2},{2,3},{1,5}]',7244,254800,'[{1,7840},{3,3920}]'),(7,471,'[{3,0,3737463}]',2343,'[{90,1},{7,2},{2,3},{1,5}]',7261,255840,'[{1,7872},{3,3936}]'),(7,472,'[{3,0,3752885}]',2349,'[{90,1},{7,2},{2,3},{1,5}]',7279,256880,'[{1,7904},{3,3952}]'),(7,473,'[{3,0,3768308}]',2354,'[{90,1},{7,2},{2,3},{1,5}]',7296,257920,'[{1,7936},{3,3968}]'),(7,474,'[{3,0,3783732}]',2360,'[{90,1},{7,2},{2,3},{1,5}]',7313,258960,'[{1,7968},{3,3984}]'),(7,475,'[{3,0,3797544}]',2365,'[{90,1},{7,2},{2,3},{1,5}]',7331,260000,'[{1,8000},{3,4000}]'),(7,476,'[{3,0,3811356}]',2371,'[{90,1},{7,2},{2,3},{1,5}]',7348,261040,'[{1,8032},{3,4016}]'),(7,477,'[{3,0,3825168}]',2376,'[{90,1},{7,2},{2,3},{1,5}]',7365,262080,'[{1,8064},{3,4032}]'),(7,478,'[{3,0,3838980}]',2382,'[{90,1},{7,2},{2,3},{1,5}]',7383,263120,'[{1,8096},{3,4048}]'),(7,479,'[{3,0,3852791}]',2388,'[{90,1},{7,2},{2,3},{1,5}]',7400,264160,'[{1,8128},{3,4064}]'),(7,480,'[{3,0,3866603}]',2393,'[{90,1},{7,2},{2,3},{1,5}]',7417,265200,'[{1,8160},{3,4080}]'),(7,481,'[{3,0,3880415}]',2399,'[{90,1},{7,2},{2,3},{1,5}]',7435,266240,'[{1,8192},{3,4096}]'),(7,482,'[{3,0,3894227}]',2404,'[{90,1},{7,2},{2,3},{1,5}]',7452,267280,'[{1,8224},{3,4112}]'),(7,483,'[{3,0,3908039}]',2410,'[{90,1},{7,2},{2,3},{1,5}]',7470,268320,'[{1,8256},{3,4128}]'),(7,484,'[{3,0,3921851}]',2416,'[{90,1},{7,2},{2,3},{1,5}]',7487,269360,'[{1,8288},{3,4144}]'),(7,485,'[{3,0,3935663}]',2421,'[{90,1},{7,2},{2,3},{1,5}]',7504,270400,'[{1,8320},{3,4160}]'),(7,486,'[{3,0,3949475}]',2427,'[{90,1},{7,2},{2,3},{1,5}]',7522,271440,'[{1,8352},{3,4176}]'),(7,487,'[{3,0,3963287}]',2432,'[{90,1},{7,2},{2,3},{1,5}]',7539,272480,'[{1,8384},{3,4192}]'),(7,488,'[{3,0,3977099}]',2438,'[{90,1},{7,2},{2,3},{1,5}]',7557,273520,'[{1,8416},{3,4208}]'),(7,489,'[{3,0,3990911}]',2444,'[{90,1},{7,2},{2,3},{1,5}]',7574,274560,'[{1,8448},{3,4224}]'),(7,490,'[{3,0,4004723}]',2449,'[{90,1},{7,2},{2,3},{1,5}]',7591,275600,'[{1,8480},{3,4240}]'),(7,491,'[{3,0,4018535}]',2455,'[{90,1},{7,2},{2,3},{1,5}]',7609,276640,'[{1,8512},{3,4256}]'),(7,492,'[{3,0,4032347}]',2460,'[{90,1},{7,2},{2,3},{1,5}]',7626,277680,'[{1,8544},{3,4272}]'),(7,493,'[{3,0,4046159}]',2466,'[{90,1},{7,2},{2,3},{1,5}]',7644,278720,'[{1,8576},{3,4288}]'),(7,494,'[{3,0,4059970}]',2472,'[{90,1},{7,2},{2,3},{1,5}]',7661,279760,'[{1,8608},{3,4304}]'),(7,495,'[{3,0,4073782}]',2478,'[{90,1},{7,2},{2,3},{1,5}]',7679,280800,'[{1,8640},{3,4320}]'),(7,496,'[{3,0,4087594}]',2483,'[{90,1},{7,2},{2,3},{1,5}]',7696,281840,'[{1,8672},{3,4336}]'),(7,497,'[{3,0,4101406}]',2489,'[{90,1},{7,2},{2,3},{1,5}]',7714,282880,'[{1,8704},{3,4352}]'),(7,498,'[{3,0,4115218}]',2494,'[{90,1},{7,2},{2,3},{1,5}]',7731,283920,'[{1,8736},{3,4368}]'),(7,499,'[{3,0,4266667}]',2583,'[{90,1},{7,2},{2,3},{1,5}]',7749,284960,'[{1,8768},{3,4384}]'),(7,500,'[{3,0,0}]',0,'[{90,1},{7,2},{2,3},{1,5}]',0,286000,'[{1,8800},{3,4400}]'),(8,0,'[{3,0,668}]',15,'[{90,1},{7,2},{2,3},{1,5}]',58,0,'[{2,0},{4,0}]'),(8,1,'[{3,0,803}]',17,'[{90,1},{7,2},{2,3},{1,5}]',67,195,'[{2,120},{4,3}]'),(8,2,'[{3,0,937}]',19,'[{90,1},{7,2},{2,3},{1,5}]',76,390,'[{2,240},{4,6}]'),(8,3,'[{3,0,1071}]',22,'[{90,1},{7,2},{2,3},{1,5}]',86,585,'[{2,360},{4,9}]'),(8,4,'[{3,0,1205}]',24,'[{90,1},{7,2},{2,3},{1,5}]',96,780,'[{2,480},{4,12}]'),(8,5,'[{3,0,1340}]',27,'[{90,1},{7,2},{2,3},{1,5}]',106,975,'[{2,600},{4,15}]'),(8,6,'[{3,0,1474}]',29,'[{90,1},{7,2},{2,3},{1,5}]',116,1170,'[{2,720},{4,18}]'),(8,7,'[{3,0,1608}]',32,'[{90,1},{7,2},{2,3},{1,5}]',126,1365,'[{2,840},{4,21}]'),(8,8,'[{3,0,1742}]',35,'[{90,1},{7,2},{2,3},{1,5}]',137,1560,'[{2,960},{4,24}]'),(8,9,'[{3,0,1877}]',37,'[{90,1},{7,2},{2,3},{1,5}]',148,1755,'[{2,1080},{4,27}]'),(8,10,'[{3,0,2011}]',40,'[{90,1},{7,2},{2,3},{1,5}]',158,1950,'[{2,1200},{4,30}]'),(8,11,'[{3,0,2145}]',43,'[{90,1},{7,2},{2,3},{1,5}]',169,2145,'[{2,1320},{4,33}]'),(8,12,'[{3,0,2279}]',45,'[{90,1},{7,2},{2,3},{1,5}]',180,2340,'[{2,1440},{4,36}]'),(8,13,'[{3,0,2414}]',48,'[{90,1},{7,2},{2,3},{1,5}]',191,2535,'[{2,1560},{4,39}]'),(8,14,'[{3,0,2548}]',51,'[{90,1},{7,2},{2,3},{1,5}]',202,2730,'[{2,1680},{4,42}]'),(8,15,'[{3,0,2682}]',54,'[{90,1},{7,2},{2,3},{1,5}]',214,2925,'[{2,1800},{4,45}]'),(8,16,'[{3,0,2816}]',57,'[{90,1},{7,2},{2,3},{1,5}]',225,3120,'[{2,1920},{4,48}]'),(8,17,'[{3,0,2951}]',59,'[{90,1},{7,2},{2,3},{1,5}]',236,3315,'[{2,2040},{4,51}]'),(8,18,'[{3,0,3085}]',62,'[{90,1},{7,2},{2,3},{1,5}]',248,3510,'[{2,2160},{4,54}]'),(8,19,'[{3,0,3219}]',65,'[{90,1},{7,2},{2,3},{1,5}]',259,3705,'[{2,2280},{4,57}]'),(8,20,'[{3,0,3353}]',68,'[{90,1},{7,2},{2,3},{1,5}]',271,3900,'[{2,2400},{4,60}]'),(8,21,'[{3,0,3488}]',71,'[{90,1},{7,2},{2,3},{1,5}]',282,4095,'[{2,2520},{4,63}]'),(8,22,'[{3,0,3622}]',74,'[{90,1},{7,2},{2,3},{1,5}]',294,4290,'[{2,2640},{4,66}]'),(8,23,'[{3,0,3756}]',77,'[{90,1},{7,2},{2,3},{1,5}]',306,4485,'[{2,2760},{4,69}]'),(8,24,'[{3,0,3891}]',80,'[{90,1},{7,2},{2,3},{1,5}]',318,4680,'[{2,2880},{4,72}]'),(8,25,'[{3,0,4239}]',83,'[{90,1},{7,2},{2,3},{1,5}]',330,4875,'[{2,3000},{4,75}]'),(8,26,'[{3,0,4587}]',86,'[{90,1},{7,2},{2,3},{1,5}]',342,5070,'[{2,3120},{4,78}]'),(8,27,'[{3,0,4936}]',89,'[{90,1},{7,2},{2,3},{1,5}]',354,5265,'[{2,3240},{4,81}]'),(8,28,'[{3,0,5284}]',92,'[{90,1},{7,2},{2,3},{1,5}]',366,5460,'[{2,3360},{4,84}]'),(8,29,'[{3,0,5632}]',95,'[{90,1},{7,2},{2,3},{1,5}]',378,5655,'[{2,3480},{4,87}]'),(8,30,'[{3,0,5980}]',98,'[{90,1},{7,2},{2,3},{1,5}]',390,5850,'[{2,3600},{4,90}]'),(8,31,'[{3,0,6329}]',101,'[{90,1},{7,2},{2,3},{1,5}]',402,6045,'[{2,3720},{4,93}]'),(8,32,'[{3,0,6677}]',104,'[{90,1},{7,2},{2,3},{1,5}]',414,6240,'[{2,3840},{4,96}]'),(8,33,'[{3,0,7025}]',107,'[{90,1},{7,2},{2,3},{1,5}]',426,6435,'[{2,3960},{4,99}]'),(8,34,'[{3,0,7373}]',110,'[{90,1},{7,2},{2,3},{1,5}]',439,6630,'[{2,4080},{4,102}]'),(8,35,'[{3,0,7722}]',113,'[{90,1},{7,2},{2,3},{1,5}]',451,6825,'[{2,4200},{4,105}]'),(8,36,'[{3,0,8070}]',116,'[{90,1},{7,2},{2,3},{1,5}]',464,7020,'[{2,4320},{4,108}]'),(8,37,'[{3,0,8418}]',119,'[{90,1},{7,2},{2,3},{1,5}]',476,7215,'[{2,4440},{4,111}]'),(8,38,'[{3,0,8766}]',122,'[{90,1},{7,2},{2,3},{1,5}]',488,7410,'[{2,4560},{4,114}]'),(8,39,'[{3,0,9115}]',126,'[{90,1},{7,2},{2,3},{1,5}]',501,7605,'[{2,4680},{4,117}]'),(8,40,'[{3,0,9463}]',129,'[{90,1},{7,2},{2,3},{1,5}]',514,7800,'[{2,4800},{4,120}]'),(8,41,'[{3,0,9811}]',132,'[{90,1},{7,2},{2,3},{1,5}]',526,7995,'[{2,4920},{4,123}]'),(8,42,'[{3,0,10159}]',135,'[{90,1},{7,2},{2,3},{1,5}]',539,8190,'[{2,5040},{4,126}]'),(8,43,'[{3,0,10508}]',138,'[{90,1},{7,2},{2,3},{1,5}]',551,8385,'[{2,5160},{4,129}]'),(8,44,'[{3,0,10856}]',141,'[{90,1},{7,2},{2,3},{1,5}]',564,8580,'[{2,5280},{4,132}]'),(8,45,'[{3,0,11204}]',145,'[{90,1},{7,2},{2,3},{1,5}]',577,8775,'[{2,5400},{4,135}]'),(8,46,'[{3,0,11552}]',148,'[{90,1},{7,2},{2,3},{1,5}]',590,8970,'[{2,5520},{4,138}]'),(8,47,'[{3,0,11901}]',151,'[{90,1},{7,2},{2,3},{1,5}]',602,9165,'[{2,5640},{4,141}]'),(8,48,'[{3,0,12249}]',154,'[{90,1},{7,2},{2,3},{1,5}]',615,9360,'[{2,5760},{4,144}]'),(8,49,'[{3,0,12923}]',162,'[{90,1},{7,2},{2,3},{1,5}]',628,9555,'[{2,5880},{4,147}]'),(8,50,'[{3,0,13425}]',165,'[{90,1},{7,2},{2,3},{1,5}]',641,9750,'[{2,6000},{4,150}]'),(8,51,'[{3,0,13927}]',168,'[{90,1},{7,2},{2,3},{1,5}]',654,9945,'[{2,6120},{4,153}]'),(8,52,'[{3,0,14429}]',172,'[{90,1},{7,2},{2,3},{1,5}]',667,10140,'[{2,6240},{4,156}]'),(8,53,'[{3,0,14931}]',175,'[{90,1},{7,2},{2,3},{1,5}]',680,10335,'[{2,6360},{4,159}]'),(8,54,'[{3,0,15433}]',178,'[{90,1},{7,2},{2,3},{1,5}]',693,10530,'[{2,6480},{4,162}]'),(8,55,'[{3,0,15935}]',182,'[{90,1},{7,2},{2,3},{1,5}]',706,10725,'[{2,6600},{4,165}]'),(8,56,'[{3,0,16437}]',185,'[{90,1},{7,2},{2,3},{1,5}]',719,10920,'[{2,6720},{4,168}]'),(8,57,'[{3,0,16939}]',188,'[{90,1},{7,2},{2,3},{1,5}]',732,11115,'[{2,6840},{4,171}]'),(8,58,'[{3,0,17442}]',192,'[{90,1},{7,2},{2,3},{1,5}]',745,11310,'[{2,6960},{4,174}]'),(8,59,'[{3,0,17944}]',195,'[{90,1},{7,2},{2,3},{1,5}]',758,11505,'[{2,7080},{4,177}]'),(8,60,'[{3,0,18446}]',198,'[{90,1},{7,2},{2,3},{1,5}]',771,11700,'[{2,7200},{4,180}]'),(8,61,'[{3,0,18948}]',202,'[{90,1},{7,2},{2,3},{1,5}]',785,11895,'[{2,7320},{4,183}]'),(8,62,'[{3,0,19450}]',205,'[{90,1},{7,2},{2,3},{1,5}]',798,12090,'[{2,7440},{4,186}]'),(8,63,'[{3,0,19952}]',208,'[{90,1},{7,2},{2,3},{1,5}]',811,12285,'[{2,7560},{4,189}]'),(8,64,'[{3,0,20454}]',212,'[{90,1},{7,2},{2,3},{1,5}]',824,12480,'[{2,7680},{4,192}]'),(8,65,'[{3,0,20956}]',215,'[{90,1},{7,2},{2,3},{1,5}]',838,12675,'[{2,7800},{4,195}]'),(8,66,'[{3,0,21458}]',219,'[{90,1},{7,2},{2,3},{1,5}]',851,12870,'[{2,7920},{4,198}]'),(8,67,'[{3,0,21960}]',222,'[{90,1},{7,2},{2,3},{1,5}]',864,13065,'[{2,8040},{4,201}]'),(8,68,'[{3,0,22462}]',226,'[{90,1},{7,2},{2,3},{1,5}]',878,13260,'[{2,8160},{4,204}]'),(8,69,'[{3,0,22964}]',229,'[{90,1},{7,2},{2,3},{1,5}]',891,13455,'[{2,8280},{4,207}]'),(8,70,'[{3,0,23466}]',233,'[{90,1},{7,2},{2,3},{1,5}]',905,13650,'[{2,8400},{4,210}]'),(8,71,'[{3,0,23968}]',236,'[{90,1},{7,2},{2,3},{1,5}]',918,13845,'[{2,8520},{4,213}]'),(8,72,'[{3,0,24470}]',239,'[{90,1},{7,2},{2,3},{1,5}]',932,14040,'[{2,8640},{4,216}]'),(8,73,'[{3,0,24972}]',243,'[{90,1},{7,2},{2,3},{1,5}]',945,14235,'[{2,8760},{4,219}]'),(8,74,'[{3,0,25472}]',246,'[{90,1},{7,2},{2,3},{1,5}]',959,14430,'[{2,8880},{4,222}]'),(8,75,'[{3,0,25627}]',250,'[{90,1},{7,2},{2,3},{1,5}]',972,14625,'[{2,9000},{4,225}]'),(8,76,'[{3,0,25783}]',253,'[{90,1},{7,2},{2,3},{1,5}]',986,14820,'[{2,9120},{4,228}]'),(8,77,'[{3,0,25938}]',257,'[{90,1},{7,2},{2,3},{1,5}]',999,15015,'[{2,9240},{4,231}]'),(8,78,'[{3,0,26094}]',260,'[{90,1},{7,2},{2,3},{1,5}]',1013,15210,'[{2,9360},{4,234}]'),(8,79,'[{3,0,26249}]',264,'[{90,1},{7,2},{2,3},{1,5}]',1027,15405,'[{2,9480},{4,237}]'),(8,80,'[{3,0,26404}]',267,'[{90,1},{7,2},{2,3},{1,5}]',1040,15600,'[{2,9600},{4,240}]'),(8,81,'[{3,0,26560}]',271,'[{90,1},{7,2},{2,3},{1,5}]',1054,15795,'[{2,9720},{4,243}]'),(8,82,'[{3,0,26715}]',274,'[{90,1},{7,2},{2,3},{1,5}]',1068,15990,'[{2,9840},{4,246}]'),(8,83,'[{3,0,26870}]',278,'[{90,1},{7,2},{2,3},{1,5}]',1081,16185,'[{2,9960},{4,249}]'),(8,84,'[{3,0,27026}]',281,'[{90,1},{7,2},{2,3},{1,5}]',1095,16380,'[{2,10080},{4,252}]'),(8,85,'[{3,0,27181}]',285,'[{90,1},{7,2},{2,3},{1,5}]',1109,16575,'[{2,10200},{4,255}]'),(8,86,'[{3,0,27337}]',288,'[{90,1},{7,2},{2,3},{1,5}]',1123,16770,'[{2,10320},{4,258}]'),(8,87,'[{3,0,27492}]',292,'[{90,1},{7,2},{2,3},{1,5}]',1136,16965,'[{2,10440},{4,261}]'),(8,88,'[{3,0,27647}]',295,'[{90,1},{7,2},{2,3},{1,5}]',1150,17160,'[{2,10560},{4,264}]'),(8,89,'[{3,0,27803}]',299,'[{90,1},{7,2},{2,3},{1,5}]',1164,17355,'[{2,10680},{4,267}]'),(8,90,'[{3,0,27958}]',303,'[{90,1},{7,2},{2,3},{1,5}]',1178,17550,'[{2,10800},{4,270}]'),(8,91,'[{3,0,28114}]',306,'[{90,1},{7,2},{2,3},{1,5}]',1192,17745,'[{2,10920},{4,273}]'),(8,92,'[{3,0,28269}]',310,'[{90,1},{7,2},{2,3},{1,5}]',1206,17940,'[{2,11040},{4,276}]'),(8,93,'[{3,0,28424}]',313,'[{90,1},{7,2},{2,3},{1,5}]',1220,18135,'[{2,11160},{4,279}]'),(8,94,'[{3,0,28580}]',317,'[{90,1},{7,2},{2,3},{1,5}]',1234,18330,'[{2,11280},{4,282}]'),(8,95,'[{3,0,28735}]',320,'[{90,1},{7,2},{2,3},{1,5}]',1248,18525,'[{2,11400},{4,285}]'),(8,96,'[{3,0,28890}]',324,'[{90,1},{7,2},{2,3},{1,5}]',1262,18720,'[{2,11520},{4,288}]'),(8,97,'[{3,0,29046}]',328,'[{90,1},{7,2},{2,3},{1,5}]',1276,18915,'[{2,11640},{4,291}]'),(8,98,'[{3,0,29201}]',331,'[{90,1},{7,2},{2,3},{1,5}]',1290,19110,'[{2,11760},{4,294}]'),(8,99,'[{3,0,30126}]',344,'[{90,1},{7,2},{2,3},{1,5}]',1304,19305,'[{2,11880},{4,297}]'),(8,100,'[{3,0,30194}]',347,'[{90,1},{7,2},{2,3},{1,5}]',1318,19500,'[{2,12000},{4,300}]'),(8,101,'[{3,0,30263}]',351,'[{90,1},{7,2},{2,3},{1,5}]',1332,19825,'[{2,12200},{4,305}]'),(8,102,'[{3,0,30331}]',355,'[{90,1},{7,2},{2,3},{1,5}]',1346,20150,'[{2,12400},{4,310}]'),(8,103,'[{3,0,30400}]',358,'[{90,1},{7,2},{2,3},{1,5}]',1360,20475,'[{2,12600},{4,315}]'),(8,104,'[{3,0,30468}]',362,'[{90,1},{7,2},{2,3},{1,5}]',1374,20800,'[{2,12800},{4,320}]'),(8,105,'[{3,0,30537}]',366,'[{90,1},{7,2},{2,3},{1,5}]',1388,21125,'[{2,13000},{4,325}]'),(8,106,'[{3,0,30605}]',369,'[{90,1},{7,2},{2,3},{1,5}]',1402,21450,'[{2,13200},{4,330}]'),(8,107,'[{3,0,30673}]',373,'[{90,1},{7,2},{2,3},{1,5}]',1416,21775,'[{2,13400},{4,335}]'),(8,108,'[{3,0,30742}]',377,'[{90,1},{7,2},{2,3},{1,5}]',1431,22100,'[{2,13600},{4,340}]'),(8,109,'[{3,0,30810}]',381,'[{90,1},{7,2},{2,3},{1,5}]',1445,22425,'[{2,13800},{4,345}]'),(8,110,'[{3,0,30879}]',384,'[{90,1},{7,2},{2,3},{1,5}]',1459,22750,'[{2,14000},{4,350}]'),(8,111,'[{3,0,30947}]',388,'[{90,1},{7,2},{2,3},{1,5}]',1473,23075,'[{2,14200},{4,355}]'),(8,112,'[{3,0,31015}]',392,'[{90,1},{7,2},{2,3},{1,5}]',1488,23400,'[{2,14400},{4,360}]'),(8,113,'[{3,0,31084}]',396,'[{90,1},{7,2},{2,3},{1,5}]',1502,23725,'[{2,14600},{4,365}]'),(8,114,'[{3,0,31152}]',399,'[{90,1},{7,2},{2,3},{1,5}]',1516,24050,'[{2,14800},{4,370}]'),(8,115,'[{3,0,31221}]',403,'[{90,1},{7,2},{2,3},{1,5}]',1530,24375,'[{2,15000},{4,375}]'),(8,116,'[{3,0,31289}]',407,'[{90,1},{7,2},{2,3},{1,5}]',1545,24700,'[{2,15200},{4,380}]'),(8,117,'[{3,0,31358}]',411,'[{90,1},{7,2},{2,3},{1,5}]',1559,25025,'[{2,15400},{4,385}]'),(8,118,'[{3,0,31426}]',414,'[{90,1},{7,2},{2,3},{1,5}]',1573,25350,'[{2,15600},{4,390}]'),(8,119,'[{3,0,31494}]',418,'[{90,1},{7,2},{2,3},{1,5}]',1588,25675,'[{2,15800},{4,395}]'),(8,120,'[{3,0,31563}]',422,'[{90,1},{7,2},{2,3},{1,5}]',1602,26000,'[{2,16000},{4,400}]'),(8,121,'[{3,0,31631}]',426,'[{90,1},{7,2},{2,3},{1,5}]',1617,26325,'[{2,16200},{4,405}]'),(8,122,'[{3,0,31700}]',430,'[{90,1},{7,2},{2,3},{1,5}]',1631,26650,'[{2,16400},{4,410}]'),(8,123,'[{3,0,31768}]',434,'[{90,1},{7,2},{2,3},{1,5}]',1646,26975,'[{2,16600},{4,415}]'),(8,124,'[{3,0,31837}]',437,'[{90,1},{7,2},{2,3},{1,5}]',1660,27300,'[{2,16800},{4,420}]'),(8,125,'[{3,0,32159}]',441,'[{90,1},{7,2},{2,3},{1,5}]',1674,27625,'[{2,17000},{4,425}]'),(8,126,'[{3,0,32481}]',445,'[{90,1},{7,2},{2,3},{1,5}]',1689,27950,'[{2,17200},{4,430}]'),(8,127,'[{3,0,32803}]',449,'[{90,1},{7,2},{2,3},{1,5}]',1703,28275,'[{2,17400},{4,435}]'),(8,128,'[{3,0,33125}]',453,'[{90,1},{7,2},{2,3},{1,5}]',1718,28600,'[{2,17600},{4,440}]'),(8,129,'[{3,0,33447}]',456,'[{90,1},{7,2},{2,3},{1,5}]',1732,28925,'[{2,17800},{4,445}]'),(8,130,'[{3,0,33769}]',460,'[{90,1},{7,2},{2,3},{1,5}]',1747,29250,'[{2,18000},{4,450}]'),(8,131,'[{3,0,34091}]',464,'[{90,1},{7,2},{2,3},{1,5}]',1762,29575,'[{2,18200},{4,455}]'),(8,132,'[{3,0,34413}]',468,'[{90,1},{7,2},{2,3},{1,5}]',1776,29900,'[{2,18400},{4,460}]'),(8,133,'[{3,0,34735}]',472,'[{90,1},{7,2},{2,3},{1,5}]',1791,30225,'[{2,18600},{4,465}]'),(8,134,'[{3,0,35058}]',475,'[{90,1},{7,2},{2,3},{1,5}]',1805,30550,'[{2,18800},{4,470}]'),(8,135,'[{3,0,35380}]',479,'[{90,1},{7,2},{2,3},{1,5}]',1820,30875,'[{2,19000},{4,475}]'),(8,136,'[{3,0,35702}]',483,'[{90,1},{7,2},{2,3},{1,5}]',1834,31200,'[{2,19200},{4,480}]'),(8,137,'[{3,0,36024}]',487,'[{90,1},{7,2},{2,3},{1,5}]',1849,31525,'[{2,19400},{4,485}]'),(8,138,'[{3,0,36346}]',491,'[{90,1},{7,2},{2,3},{1,5}]',1864,31850,'[{2,19600},{4,490}]'),(8,139,'[{3,0,36668}]',495,'[{90,1},{7,2},{2,3},{1,5}]',1878,32175,'[{2,19800},{4,495}]'),(8,140,'[{3,0,36990}]',499,'[{90,1},{7,2},{2,3},{1,5}]',1893,32500,'[{2,20000},{4,500}]'),(8,141,'[{3,0,37312}]',503,'[{90,1},{7,2},{2,3},{1,5}]',1908,32825,'[{2,20200},{4,505}]'),(8,142,'[{3,0,37634}]',507,'[{90,1},{7,2},{2,3},{1,5}]',1923,33150,'[{2,20400},{4,510}]'),(8,143,'[{3,0,37957}]',510,'[{90,1},{7,2},{2,3},{1,5}]',1937,33475,'[{2,20600},{4,515}]'),(8,144,'[{3,0,38279}]',514,'[{90,1},{7,2},{2,3},{1,5}]',1952,33800,'[{2,20800},{4,520}]'),(8,145,'[{3,0,38601}]',518,'[{90,1},{7,2},{2,3},{1,5}]',1967,34125,'[{2,21000},{4,525}]'),(8,146,'[{3,0,38923}]',522,'[{90,1},{7,2},{2,3},{1,5}]',1981,34450,'[{2,21200},{4,530}]'),(8,147,'[{3,0,39245}]',526,'[{90,1},{7,2},{2,3},{1,5}]',1996,34775,'[{2,21400},{4,535}]'),(8,148,'[{3,0,39567}]',530,'[{90,1},{7,2},{2,3},{1,5}]',2011,35100,'[{2,21600},{4,540}]'),(8,149,'[{3,0,40965}]',548,'[{90,1},{7,2},{2,3},{1,5}]',2026,35425,'[{2,21800},{4,545}]'),(8,150,'[{3,0,41443}]',552,'[{90,1},{7,2},{2,3},{1,5}]',2041,35750,'[{2,22000},{4,550}]'),(8,151,'[{3,0,41922}]',556,'[{90,1},{7,2},{2,3},{1,5}]',2055,36075,'[{2,22200},{4,555}]'),(8,152,'[{3,0,42401}]',560,'[{90,1},{7,2},{2,3},{1,5}]',2070,36400,'[{2,22400},{4,560}]'),(8,153,'[{3,0,42879}]',564,'[{90,1},{7,2},{2,3},{1,5}]',2085,36725,'[{2,22600},{4,565}]'),(8,154,'[{3,0,43358}]',568,'[{90,1},{7,2},{2,3},{1,5}]',2100,37050,'[{2,22800},{4,570}]'),(8,155,'[{3,0,43837}]',572,'[{90,1},{7,2},{2,3},{1,5}]',2115,37375,'[{2,23000},{4,575}]'),(8,156,'[{3,0,44315}]',576,'[{90,1},{7,2},{2,3},{1,5}]',2130,37700,'[{2,23200},{4,580}]'),(8,157,'[{3,0,44794}]',580,'[{90,1},{7,2},{2,3},{1,5}]',2145,38025,'[{2,23400},{4,585}]'),(8,158,'[{3,0,45273}]',584,'[{90,1},{7,2},{2,3},{1,5}]',2160,38350,'[{2,23600},{4,590}]'),(8,159,'[{3,0,45751}]',588,'[{90,1},{7,2},{2,3},{1,5}]',2175,38675,'[{2,23800},{4,595}]'),(8,160,'[{3,0,46230}]',592,'[{90,1},{7,2},{2,3},{1,5}]',2189,39000,'[{2,24000},{4,600}]'),(8,161,'[{3,0,46709}]',596,'[{90,1},{7,2},{2,3},{1,5}]',2204,39325,'[{2,24200},{4,605}]'),(8,162,'[{3,0,47187}]',600,'[{90,1},{7,2},{2,3},{1,5}]',2219,39650,'[{2,24400},{4,610}]'),(8,163,'[{3,0,47666}]',604,'[{90,1},{7,2},{2,3},{1,5}]',2234,39975,'[{2,24600},{4,615}]'),(8,164,'[{3,0,48145}]',608,'[{90,1},{7,2},{2,3},{1,5}]',2249,40300,'[{2,24800},{4,620}]'),(8,165,'[{3,0,48623}]',612,'[{90,1},{7,2},{2,3},{1,5}]',2264,40625,'[{2,25000},{4,625}]'),(8,166,'[{3,0,49102}]',616,'[{90,1},{7,2},{2,3},{1,5}]',2279,40950,'[{2,25200},{4,630}]'),(8,167,'[{3,0,49580}]',620,'[{90,1},{7,2},{2,3},{1,5}]',2294,41275,'[{2,25400},{4,635}]'),(8,168,'[{3,0,50059}]',625,'[{90,1},{7,2},{2,3},{1,5}]',2309,41600,'[{2,25600},{4,640}]'),(8,169,'[{3,0,50538}]',629,'[{90,1},{7,2},{2,3},{1,5}]',2324,41925,'[{2,25800},{4,645}]'),(8,170,'[{3,0,51016}]',633,'[{90,1},{7,2},{2,3},{1,5}]',2340,42250,'[{2,26000},{4,650}]'),(8,171,'[{3,0,51495}]',637,'[{90,1},{7,2},{2,3},{1,5}]',2355,42575,'[{2,26200},{4,655}]'),(8,172,'[{3,0,51974}]',641,'[{90,1},{7,2},{2,3},{1,5}]',2370,42900,'[{2,26400},{4,660}]'),(8,173,'[{3,0,52452}]',645,'[{90,1},{7,2},{2,3},{1,5}]',2385,43225,'[{2,26600},{4,665}]'),(8,174,'[{3,0,52931}]',649,'[{90,1},{7,2},{2,3},{1,5}]',2400,43550,'[{2,26800},{4,670}]'),(8,175,'[{3,0,53077}]',653,'[{90,1},{7,2},{2,3},{1,5}]',2415,43875,'[{2,27000},{4,675}]'),(8,176,'[{3,0,53222}]',657,'[{90,1},{7,2},{2,3},{1,5}]',2430,44200,'[{2,27200},{4,680}]'),(8,177,'[{3,0,53368}]',661,'[{90,1},{7,2},{2,3},{1,5}]',2445,44525,'[{2,27400},{4,685}]'),(8,178,'[{3,0,53514}]',665,'[{90,1},{7,2},{2,3},{1,5}]',2460,44850,'[{2,27600},{4,690}]'),(8,179,'[{3,0,53659}]',670,'[{90,1},{7,2},{2,3},{1,5}]',2476,45175,'[{2,27800},{4,695}]'),(8,180,'[{3,0,53805}]',674,'[{90,1},{7,2},{2,3},{1,5}]',2491,45500,'[{2,28000},{4,700}]'),(8,181,'[{3,0,53951}]',678,'[{90,1},{7,2},{2,3},{1,5}]',2506,45825,'[{2,28200},{4,705}]'),(8,182,'[{3,0,54096}]',682,'[{90,1},{7,2},{2,3},{1,5}]',2521,46150,'[{2,28400},{4,710}]'),(8,183,'[{3,0,54242}]',686,'[{90,1},{7,2},{2,3},{1,5}]',2536,46475,'[{2,28600},{4,715}]'),(8,184,'[{3,0,54388}]',690,'[{90,1},{7,2},{2,3},{1,5}]',2552,46800,'[{2,28800},{4,720}]'),(8,185,'[{3,0,54533}]',694,'[{90,1},{7,2},{2,3},{1,5}]',2567,47125,'[{2,29000},{4,725}]'),(8,186,'[{3,0,54679}]',698,'[{90,1},{7,2},{2,3},{1,5}]',2582,47450,'[{2,29200},{4,730}]'),(8,187,'[{3,0,54825}]',702,'[{90,1},{7,2},{2,3},{1,5}]',2597,47775,'[{2,29400},{4,735}]'),(8,188,'[{3,0,54970}]',707,'[{90,1},{7,2},{2,3},{1,5}]',2613,48100,'[{2,29600},{4,740}]'),(8,189,'[{3,0,55116}]',711,'[{90,1},{7,2},{2,3},{1,5}]',2628,48425,'[{2,29800},{4,745}]'),(8,190,'[{3,0,55262}]',715,'[{90,1},{7,2},{2,3},{1,5}]',2643,48750,'[{2,30000},{4,750}]'),(8,191,'[{3,0,55408}]',719,'[{90,1},{7,2},{2,3},{1,5}]',2658,49075,'[{2,30200},{4,755}]'),(8,192,'[{3,0,55553}]',723,'[{90,1},{7,2},{2,3},{1,5}]',2674,49400,'[{2,30400},{4,760}]'),(8,193,'[{3,0,55699}]',727,'[{90,1},{7,2},{2,3},{1,5}]',2689,49725,'[{2,30600},{4,765}]'),(8,194,'[{3,0,55845}]',731,'[{90,1},{7,2},{2,3},{1,5}]',2704,50050,'[{2,30800},{4,770}]'),(8,195,'[{3,0,55990}]',736,'[{90,1},{7,2},{2,3},{1,5}]',2720,50375,'[{2,31000},{4,775}]'),(8,196,'[{3,0,56136}]',740,'[{90,1},{7,2},{2,3},{1,5}]',2735,50700,'[{2,31200},{4,780}]'),(8,197,'[{3,0,56282}]',744,'[{90,1},{7,2},{2,3},{1,5}]',2750,51025,'[{2,31400},{4,785}]'),(8,198,'[{3,0,56427}]',748,'[{90,1},{7,2},{2,3},{1,5}]',2766,51350,'[{2,31600},{4,790}]'),(8,199,'[{3,0,58145}]',773,'[{90,1},{7,2},{2,3},{1,5}]',2781,51675,'[{2,31800},{4,795}]'),(8,200,'[{3,0,58298}]',777,'[{90,1},{7,2},{2,3},{1,5}]',2797,52000,'[{2,32000},{4,800}]'),(8,201,'[{3,0,58451}]',782,'[{90,1},{7,2},{2,3},{1,5}]',2812,52520,'[{2,32320},{4,808}]'),(8,202,'[{3,0,58604}]',786,'[{90,1},{7,2},{2,3},{1,5}]',2827,53040,'[{2,32640},{4,816}]'),(8,203,'[{3,0,58757}]',790,'[{90,1},{7,2},{2,3},{1,5}]',2843,53560,'[{2,32960},{4,824}]'),(8,204,'[{3,0,58910}]',794,'[{90,1},{7,2},{2,3},{1,5}]',2858,54080,'[{2,33280},{4,832}]'),(8,205,'[{3,0,59063}]',799,'[{90,1},{7,2},{2,3},{1,5}]',2874,54600,'[{2,33600},{4,840}]'),(8,206,'[{3,0,59216}]',803,'[{90,1},{7,2},{2,3},{1,5}]',2889,55120,'[{2,33920},{4,848}]'),(8,207,'[{3,0,59369}]',807,'[{90,1},{7,2},{2,3},{1,5}]',2905,55640,'[{2,34240},{4,856}]'),(8,208,'[{3,0,59522}]',812,'[{90,1},{7,2},{2,3},{1,5}]',2920,56160,'[{2,34560},{4,864}]'),(8,209,'[{3,0,59675}]',816,'[{90,1},{7,2},{2,3},{1,5}]',2936,56680,'[{2,34880},{4,872}]'),(8,210,'[{3,0,59828}]',820,'[{90,1},{7,2},{2,3},{1,5}]',2951,57200,'[{2,35200},{4,880}]'),(8,211,'[{3,0,59981}]',825,'[{90,1},{7,2},{2,3},{1,5}]',2967,57720,'[{2,35520},{4,888}]'),(8,212,'[{3,0,60134}]',829,'[{90,1},{7,2},{2,3},{1,5}]',2982,58240,'[{2,35840},{4,896}]'),(8,213,'[{3,0,60287}]',833,'[{90,1},{7,2},{2,3},{1,5}]',2998,58760,'[{2,36160},{4,904}]'),(8,214,'[{3,0,60440}]',837,'[{90,1},{7,2},{2,3},{1,5}]',3013,59280,'[{2,36480},{4,912}]'),(8,215,'[{3,0,60594}]',842,'[{90,1},{7,2},{2,3},{1,5}]',3029,59800,'[{2,36800},{4,920}]'),(8,216,'[{3,0,60747}]',846,'[{90,1},{7,2},{2,3},{1,5}]',3044,60320,'[{2,37120},{4,928}]'),(8,217,'[{3,0,60900}]',850,'[{90,1},{7,2},{2,3},{1,5}]',3060,60840,'[{2,37440},{4,936}]'),(8,218,'[{3,0,61053}]',855,'[{90,1},{7,2},{2,3},{1,5}]',3075,61360,'[{2,37760},{4,944}]'),(8,219,'[{3,0,61206}]',859,'[{90,1},{7,2},{2,3},{1,5}]',3091,61880,'[{2,38080},{4,952}]'),(8,220,'[{3,0,61359}]',864,'[{90,1},{7,2},{2,3},{1,5}]',3107,62400,'[{2,38400},{4,960}]'),(8,221,'[{3,0,61512}]',868,'[{90,1},{7,2},{2,3},{1,5}]',3122,62920,'[{2,38720},{4,968}]'),(8,222,'[{3,0,61665}]',872,'[{90,1},{7,2},{2,3},{1,5}]',3138,63440,'[{2,39040},{4,976}]'),(8,223,'[{3,0,61818}]',876,'[{90,1},{7,2},{2,3},{1,5}]',3153,63960,'[{2,39360},{4,984}]'),(8,224,'[{3,0,61974}]',881,'[{90,1},{7,2},{2,3},{1,5}]',3169,64480,'[{2,39680},{4,992}]'),(8,225,'[{3,0,68137}]',885,'[{90,1},{7,2},{2,3},{1,5}]',3185,65000,'[{2,40000},{4,1000}]'),(8,226,'[{3,0,74299}]',889,'[{90,1},{7,2},{2,3},{1,5}]',3200,65520,'[{2,40320},{4,1008}]'),(8,227,'[{3,0,80461}]',894,'[{90,1},{7,2},{2,3},{1,5}]',3216,66040,'[{2,40640},{4,1016}]'),(8,228,'[{3,0,86623}]',898,'[{90,1},{7,2},{2,3},{1,5}]',3232,66560,'[{2,40960},{4,1024}]'),(8,229,'[{3,0,92785}]',902,'[{90,1},{7,2},{2,3},{1,5}]',3247,67080,'[{2,41280},{4,1032}]'),(8,230,'[{3,0,98948}]',907,'[{90,1},{7,2},{2,3},{1,5}]',3263,67600,'[{2,41600},{4,1040}]'),(8,231,'[{3,0,105110}]',911,'[{90,1},{7,2},{2,3},{1,5}]',3279,68120,'[{2,41920},{4,1048}]'),(8,232,'[{3,0,111272}]',915,'[{90,1},{7,2},{2,3},{1,5}]',3294,68640,'[{2,42240},{4,1056}]'),(8,233,'[{3,0,117434}]',920,'[{90,1},{7,2},{2,3},{1,5}]',3310,69160,'[{2,42560},{4,1064}]'),(8,234,'[{3,0,123597}]',924,'[{90,1},{7,2},{2,3},{1,5}]',3326,69680,'[{2,42880},{4,1072}]'),(8,235,'[{3,0,129759}]',929,'[{90,1},{7,2},{2,3},{1,5}]',3342,70200,'[{2,43200},{4,1080}]'),(8,236,'[{3,0,135921}]',933,'[{90,1},{7,2},{2,3},{1,5}]',3357,70720,'[{2,43520},{4,1088}]'),(8,237,'[{3,0,142083}]',937,'[{90,1},{7,2},{2,3},{1,5}]',3373,71240,'[{2,43840},{4,1096}]'),(8,238,'[{3,0,148245}]',942,'[{90,1},{7,2},{2,3},{1,5}]',3389,71760,'[{2,44160},{4,1104}]'),(8,239,'[{3,0,154408}]',946,'[{90,1},{7,2},{2,3},{1,5}]',3405,72280,'[{2,44480},{4,1112}]'),(8,240,'[{3,0,160570}]',950,'[{90,1},{7,2},{2,3},{1,5}]',3420,72800,'[{2,44800},{4,1120}]'),(8,241,'[{3,0,166732}]',955,'[{90,1},{7,2},{2,3},{1,5}]',3436,73320,'[{2,45120},{4,1128}]'),(8,242,'[{3,0,172894}]',959,'[{90,1},{7,2},{2,3},{1,5}]',3452,73840,'[{2,45440},{4,1136}]'),(8,243,'[{3,0,179057}]',964,'[{90,1},{7,2},{2,3},{1,5}]',3468,74360,'[{2,45760},{4,1144}]'),(8,244,'[{3,0,185219}]',968,'[{90,1},{7,2},{2,3},{1,5}]',3484,74880,'[{2,46080},{4,1152}]'),(8,245,'[{3,0,191381}]',972,'[{90,1},{7,2},{2,3},{1,5}]',3499,75400,'[{2,46400},{4,1160}]'),(8,246,'[{3,0,197543}]',977,'[{90,1},{7,2},{2,3},{1,5}]',3515,75920,'[{2,46720},{4,1168}]'),(8,247,'[{3,0,203705}]',981,'[{90,1},{7,2},{2,3},{1,5}]',3531,76440,'[{2,47040},{4,1176}]'),(8,248,'[{3,0,209868}]',986,'[{90,1},{7,2},{2,3},{1,5}]',3547,76960,'[{2,47360},{4,1184}]'),(8,249,'[{3,0,222203}]',1018,'[{90,1},{7,2},{2,3},{1,5}]',3563,77480,'[{2,47680},{4,1192}]'),(8,250,'[{3,0,228297}]',1023,'[{90,1},{7,2},{2,3},{1,5}]',3579,78000,'[{2,48000},{4,1200}]'),(8,251,'[{3,0,234391}]',1028,'[{90,1},{7,2},{2,3},{1,5}]',3595,78520,'[{2,48320},{4,1208}]'),(8,252,'[{3,0,240485}]',1032,'[{90,1},{7,2},{2,3},{1,5}]',3610,79040,'[{2,48640},{4,1216}]'),(8,253,'[{3,0,246579}]',1036,'[{90,1},{7,2},{2,3},{1,5}]',3626,79560,'[{2,48960},{4,1224}]'),(8,254,'[{3,0,252673}]',1041,'[{90,1},{7,2},{2,3},{1,5}]',3642,80080,'[{2,49280},{4,1232}]'),(8,255,'[{3,0,258767}]',1046,'[{90,1},{7,2},{2,3},{1,5}]',3658,80600,'[{2,49600},{4,1240}]'),(8,256,'[{3,0,264861}]',1050,'[{90,1},{7,2},{2,3},{1,5}]',3674,81120,'[{2,49920},{4,1248}]'),(8,257,'[{3,0,270955}]',1055,'[{90,1},{7,2},{2,3},{1,5}]',3690,81640,'[{2,50240},{4,1256}]'),(8,258,'[{3,0,277049}]',1059,'[{90,1},{7,2},{2,3},{1,5}]',3706,82160,'[{2,50560},{4,1264}]'),(8,259,'[{3,0,283143}]',1064,'[{90,1},{7,2},{2,3},{1,5}]',3722,82680,'[{2,50880},{4,1272}]'),(8,260,'[{3,0,289237}]',1068,'[{90,1},{7,2},{2,3},{1,5}]',3738,83200,'[{2,51200},{4,1280}]'),(8,261,'[{3,0,295331}]',1073,'[{90,1},{7,2},{2,3},{1,5}]',3754,83720,'[{2,51520},{4,1288}]'),(8,262,'[{3,0,301425}]',1078,'[{90,1},{7,2},{2,3},{1,5}]',3770,84240,'[{2,51840},{4,1296}]'),(8,263,'[{3,0,307519}]',1082,'[{90,1},{7,2},{2,3},{1,5}]',3786,84760,'[{2,52160},{4,1304}]'),(8,264,'[{3,0,313613}]',1087,'[{90,1},{7,2},{2,3},{1,5}]',3802,85280,'[{2,52480},{4,1312}]'),(8,265,'[{3,0,319707}]',1091,'[{90,1},{7,2},{2,3},{1,5}]',3818,85800,'[{2,52800},{4,1320}]'),(8,266,'[{3,0,325801}]',1096,'[{90,1},{7,2},{2,3},{1,5}]',3834,86320,'[{2,53120},{4,1328}]'),(8,267,'[{3,0,331895}]',1100,'[{90,1},{7,2},{2,3},{1,5}]',3850,86840,'[{2,53440},{4,1336}]'),(8,268,'[{3,0,337989}]',1105,'[{90,1},{7,2},{2,3},{1,5}]',3866,87360,'[{2,53760},{4,1344}]'),(8,269,'[{3,0,344083}]',1110,'[{90,1},{7,2},{2,3},{1,5}]',3882,87880,'[{2,54080},{4,1352}]'),(8,270,'[{3,0,350177}]',1114,'[{90,1},{7,2},{2,3},{1,5}]',3898,88400,'[{2,54400},{4,1360}]'),(8,271,'[{3,0,356271}]',1119,'[{90,1},{7,2},{2,3},{1,5}]',3914,88920,'[{2,54720},{4,1368}]'),(8,272,'[{3,0,362365}]',1123,'[{90,1},{7,2},{2,3},{1,5}]',3930,89440,'[{2,55040},{4,1376}]'),(8,273,'[{3,0,368459}]',1128,'[{90,1},{7,2},{2,3},{1,5}]',3946,89960,'[{2,55360},{4,1384}]'),(8,274,'[{3,0,374550}]',1132,'[{90,1},{7,2},{2,3},{1,5}]',3962,90480,'[{2,55680},{4,1392}]'),(8,275,'[{3,0,381734}]',1137,'[{90,1},{7,2},{2,3},{1,5}]',3978,91000,'[{2,56000},{4,1400}]'),(8,276,'[{3,0,388919}]',1142,'[{90,1},{7,2},{2,3},{1,5}]',3994,91520,'[{2,56320},{4,1408}]'),(8,277,'[{3,0,396104}]',1146,'[{90,1},{7,2},{2,3},{1,5}]',4010,92040,'[{2,56640},{4,1416}]'),(8,278,'[{3,0,403288}]',1151,'[{90,1},{7,2},{2,3},{1,5}]',4026,92560,'[{2,56960},{4,1424}]'),(8,279,'[{3,0,410473}]',1155,'[{90,1},{7,2},{2,3},{1,5}]',4042,93080,'[{2,57280},{4,1432}]'),(8,280,'[{3,0,417657}]',1160,'[{90,1},{7,2},{2,3},{1,5}]',4059,93600,'[{2,57600},{4,1440}]'),(8,281,'[{3,0,424842}]',1165,'[{90,1},{7,2},{2,3},{1,5}]',4075,94120,'[{2,57920},{4,1448}]'),(8,282,'[{3,0,432026}]',1169,'[{90,1},{7,2},{2,3},{1,5}]',4091,94640,'[{2,58240},{4,1456}]'),(8,283,'[{3,0,439211}]',1174,'[{90,1},{7,2},{2,3},{1,5}]',4107,95160,'[{2,58560},{4,1464}]'),(8,284,'[{3,0,446396}]',1178,'[{90,1},{7,2},{2,3},{1,5}]',4123,95680,'[{2,58880},{4,1472}]'),(8,285,'[{3,0,453580}]',1183,'[{90,1},{7,2},{2,3},{1,5}]',4139,96200,'[{2,59200},{4,1480}]'),(8,286,'[{3,0,460765}]',1188,'[{90,1},{7,2},{2,3},{1,5}]',4155,96720,'[{2,59520},{4,1488}]'),(8,287,'[{3,0,467949}]',1192,'[{90,1},{7,2},{2,3},{1,5}]',4172,97240,'[{2,59840},{4,1496}]'),(8,288,'[{3,0,475134}]',1197,'[{90,1},{7,2},{2,3},{1,5}]',4188,97760,'[{2,60160},{4,1504}]'),(8,289,'[{3,0,482318}]',1202,'[{90,1},{7,2},{2,3},{1,5}]',4204,98280,'[{2,60480},{4,1512}]'),(8,290,'[{3,0,489503}]',1206,'[{90,1},{7,2},{2,3},{1,5}]',4220,98800,'[{2,60800},{4,1520}]'),(8,291,'[{3,0,496688}]',1211,'[{90,1},{7,2},{2,3},{1,5}]',4236,99320,'[{2,61120},{4,1528}]'),(8,292,'[{3,0,503872}]',1216,'[{90,1},{7,2},{2,3},{1,5}]',4253,99840,'[{2,61440},{4,1536}]'),(8,293,'[{3,0,511057}]',1220,'[{90,1},{7,2},{2,3},{1,5}]',4269,100360,'[{2,61760},{4,1544}]'),(8,294,'[{3,0,518241}]',1225,'[{90,1},{7,2},{2,3},{1,5}]',4285,100880,'[{2,62080},{4,1552}]'),(8,295,'[{3,0,525426}]',1229,'[{90,1},{7,2},{2,3},{1,5}]',4301,101400,'[{2,62400},{4,1560}]'),(8,296,'[{3,0,532610}]',1234,'[{90,1},{7,2},{2,3},{1,5}]',4317,101920,'[{2,62720},{4,1568}]'),(8,297,'[{3,0,539795}]',1239,'[{90,1},{7,2},{2,3},{1,5}]',4334,102440,'[{2,63040},{4,1576}]'),(8,298,'[{3,0,546980}]',1243,'[{90,1},{7,2},{2,3},{1,5}]',4350,102960,'[{2,63360},{4,1584}]'),(8,299,'[{3,0,570466}]',1285,'[{90,1},{7,2},{2,3},{1,5}]',4366,103480,'[{2,63680},{4,1592}]'),(8,300,'[{3,0,581815}]',1289,'[{90,1},{7,2},{2,3},{1,5}]',4382,104000,'[{2,64000},{4,1600}]'),(8,301,'[{3,0,593165}]',1294,'[{90,1},{7,2},{2,3},{1,5}]',4399,104780,'[{2,64480},{4,1612}]'),(8,302,'[{3,0,604515}]',1299,'[{90,1},{7,2},{2,3},{1,5}]',4415,105560,'[{2,64960},{4,1624}]'),(8,303,'[{3,0,615865}]',1304,'[{90,1},{7,2},{2,3},{1,5}]',4431,106340,'[{2,65440},{4,1636}]'),(8,304,'[{3,0,627214}]',1309,'[{90,1},{7,2},{2,3},{1,5}]',4448,107120,'[{2,65920},{4,1648}]'),(8,305,'[{3,0,638564}]',1313,'[{90,1},{7,2},{2,3},{1,5}]',4464,107900,'[{2,66400},{4,1660}]'),(8,306,'[{3,0,649914}]',1318,'[{90,1},{7,2},{2,3},{1,5}]',4480,108680,'[{2,66880},{4,1672}]'),(8,307,'[{3,0,661263}]',1323,'[{90,1},{7,2},{2,3},{1,5}]',4497,109460,'[{2,67360},{4,1684}]'),(8,308,'[{3,0,672613}]',1328,'[{90,1},{7,2},{2,3},{1,5}]',4513,110240,'[{2,67840},{4,1696}]'),(8,309,'[{3,0,683963}]',1333,'[{90,1},{7,2},{2,3},{1,5}]',4529,111020,'[{2,68320},{4,1708}]'),(8,310,'[{3,0,695313}]',1338,'[{90,1},{7,2},{2,3},{1,5}]',4546,111800,'[{2,68800},{4,1720}]'),(8,311,'[{3,0,706662}]',1342,'[{90,1},{7,2},{2,3},{1,5}]',4562,112580,'[{2,69280},{4,1732}]'),(8,312,'[{3,0,718012}]',1347,'[{90,1},{7,2},{2,3},{1,5}]',4578,113360,'[{2,69760},{4,1744}]'),(8,313,'[{3,0,729362}]',1352,'[{90,1},{7,2},{2,3},{1,5}]',4595,114140,'[{2,70240},{4,1756}]'),(8,314,'[{3,0,740711}]',1357,'[{90,1},{7,2},{2,3},{1,5}]',4611,114920,'[{2,70720},{4,1768}]'),(8,315,'[{3,0,752061}]',1361,'[{90,1},{7,2},{2,3},{1,5}]',4627,115700,'[{2,71200},{4,1780}]'),(8,316,'[{3,0,763411}]',1366,'[{90,1},{7,2},{2,3},{1,5}]',4644,116480,'[{2,71680},{4,1792}]'),(8,317,'[{3,0,774760}]',1371,'[{90,1},{7,2},{2,3},{1,5}]',4660,117260,'[{2,72160},{4,1804}]'),(8,318,'[{3,0,786110}]',1376,'[{90,1},{7,2},{2,3},{1,5}]',4677,118040,'[{2,72640},{4,1816}]'),(8,319,'[{3,0,797460}]',1381,'[{90,1},{7,2},{2,3},{1,5}]',4693,118820,'[{2,73120},{4,1828}]'),(8,320,'[{3,0,808810}]',1385,'[{90,1},{7,2},{2,3},{1,5}]',4709,119600,'[{2,73600},{4,1840}]'),(8,321,'[{3,0,820159}]',1390,'[{90,1},{7,2},{2,3},{1,5}]',4726,120380,'[{2,74080},{4,1852}]'),(8,322,'[{3,0,831509}]',1395,'[{90,1},{7,2},{2,3},{1,5}]',4742,121160,'[{2,74560},{4,1864}]'),(8,323,'[{3,0,842859}]',1400,'[{90,1},{7,2},{2,3},{1,5}]',4759,121940,'[{2,75040},{4,1876}]'),(8,324,'[{3,0,854205}]',1405,'[{90,1},{7,2},{2,3},{1,5}]',4775,122720,'[{2,75520},{4,1888}]'),(8,325,'[{3,0,869085}]',1410,'[{90,1},{7,2},{2,3},{1,5}]',4792,123500,'[{2,76000},{4,1900}]'),(8,326,'[{3,0,883965}]',1415,'[{90,1},{7,2},{2,3},{1,5}]',4808,124280,'[{2,76480},{4,1912}]'),(8,327,'[{3,0,898846}]',1420,'[{90,1},{7,2},{2,3},{1,5}]',4825,125060,'[{2,76960},{4,1924}]'),(8,328,'[{3,0,913726}]',1424,'[{90,1},{7,2},{2,3},{1,5}]',4841,125840,'[{2,77440},{4,1936}]'),(8,329,'[{3,0,928606}]',1429,'[{90,1},{7,2},{2,3},{1,5}]',4857,126620,'[{2,77920},{4,1948}]'),(8,330,'[{3,0,943487}]',1434,'[{90,1},{7,2},{2,3},{1,5}]',4874,127400,'[{2,78400},{4,1960}]'),(8,331,'[{3,0,958367}]',1439,'[{90,1},{7,2},{2,3},{1,5}]',4890,128180,'[{2,78880},{4,1972}]'),(8,332,'[{3,0,973247}]',1444,'[{90,1},{7,2},{2,3},{1,5}]',4907,128960,'[{2,79360},{4,1984}]'),(8,333,'[{3,0,988128}]',1448,'[{90,1},{7,2},{2,3},{1,5}]',4923,129740,'[{2,79840},{4,1996}]'),(8,334,'[{3,0,1003008}]',1453,'[{90,1},{7,2},{2,3},{1,5}]',4940,130520,'[{2,80320},{4,2008}]'),(8,335,'[{3,0,1017888}]',1458,'[{90,1},{7,2},{2,3},{1,5}]',4956,131300,'[{2,80800},{4,2020}]'),(8,336,'[{3,0,1032768}]',1463,'[{90,1},{7,2},{2,3},{1,5}]',4973,132080,'[{2,81280},{4,2032}]'),(8,337,'[{3,0,1047649}]',1468,'[{90,1},{7,2},{2,3},{1,5}]',4990,132860,'[{2,81760},{4,2044}]'),(8,338,'[{3,0,1062529}]',1473,'[{90,1},{7,2},{2,3},{1,5}]',5006,133640,'[{2,82240},{4,2056}]'),(8,339,'[{3,0,1077409}]',1478,'[{90,1},{7,2},{2,3},{1,5}]',5023,134420,'[{2,82720},{4,2068}]'),(8,340,'[{3,0,1092290}]',1483,'[{90,1},{7,2},{2,3},{1,5}]',5039,135200,'[{2,83200},{4,2080}]'),(8,341,'[{3,0,1107170}]',1488,'[{90,1},{7,2},{2,3},{1,5}]',5056,135980,'[{2,83680},{4,2092}]'),(8,342,'[{3,0,1122050}]',1492,'[{90,1},{7,2},{2,3},{1,5}]',5072,136760,'[{2,84160},{4,2104}]'),(8,343,'[{3,0,1136930}]',1497,'[{90,1},{7,2},{2,3},{1,5}]',5089,137540,'[{2,84640},{4,2116}]'),(8,344,'[{3,0,1151811}]',1502,'[{90,1},{7,2},{2,3},{1,5}]',5105,138320,'[{2,85120},{4,2128}]'),(8,345,'[{3,0,1166691}]',1507,'[{90,1},{7,2},{2,3},{1,5}]',5122,139100,'[{2,85600},{4,2140}]'),(8,346,'[{3,0,1181571}]',1512,'[{90,1},{7,2},{2,3},{1,5}]',5139,139880,'[{2,86080},{4,2152}]'),(8,347,'[{3,0,1196452}]',1517,'[{90,1},{7,2},{2,3},{1,5}]',5155,140660,'[{2,86560},{4,2164}]'),(8,348,'[{3,0,1211332}]',1522,'[{90,1},{7,2},{2,3},{1,5}]',5172,141440,'[{2,87040},{4,2176}]'),(8,349,'[{3,0,1263370}]',1573,'[{90,1},{7,2},{2,3},{1,5}]',5188,142220,'[{2,87520},{4,2188}]'),(8,350,'[{3,0,1279417}]',1578,'[{90,1},{7,2},{2,3},{1,5}]',5205,143000,'[{2,88000},{4,2200}]'),(8,351,'[{3,0,1295463}]',1583,'[{90,1},{7,2},{2,3},{1,5}]',5222,143780,'[{2,88480},{4,2212}]'),(8,352,'[{3,0,1311509}]',1588,'[{90,1},{7,2},{2,3},{1,5}]',5238,144560,'[{2,88960},{4,2224}]'),(8,353,'[{3,0,1327556}]',1593,'[{90,1},{7,2},{2,3},{1,5}]',5255,145340,'[{2,89440},{4,2236}]'),(8,354,'[{3,0,1343602}]',1598,'[{90,1},{7,2},{2,3},{1,5}]',5272,146120,'[{2,89920},{4,2248}]'),(8,355,'[{3,0,1359648}]',1603,'[{90,1},{7,2},{2,3},{1,5}]',5288,146900,'[{2,90400},{4,2260}]'),(8,356,'[{3,0,1375695}]',1608,'[{90,1},{7,2},{2,3},{1,5}]',5305,147680,'[{2,90880},{4,2272}]'),(8,357,'[{3,0,1391741}]',1613,'[{90,1},{7,2},{2,3},{1,5}]',5322,148460,'[{2,91360},{4,2284}]'),(8,358,'[{3,0,1407787}]',1618,'[{90,1},{7,2},{2,3},{1,5}]',5338,149240,'[{2,91840},{4,2296}]'),(8,359,'[{3,0,1423834}]',1623,'[{90,1},{7,2},{2,3},{1,5}]',5355,150020,'[{2,92320},{4,2308}]'),(8,360,'[{3,0,1439880}]',1628,'[{90,1},{7,2},{2,3},{1,5}]',5372,150800,'[{2,92800},{4,2320}]'),(8,361,'[{3,0,1455927}]',1633,'[{90,1},{7,2},{2,3},{1,5}]',5388,151580,'[{2,93280},{4,2332}]'),(8,362,'[{3,0,1471973}]',1638,'[{90,1},{7,2},{2,3},{1,5}]',5405,152360,'[{2,93760},{4,2344}]'),(8,363,'[{3,0,1488019}]',1644,'[{90,1},{7,2},{2,3},{1,5}]',5422,153140,'[{2,94240},{4,2356}]'),(8,364,'[{3,0,1504066}]',1648,'[{90,1},{7,2},{2,3},{1,5}]',5438,153920,'[{2,94720},{4,2368}]'),(8,365,'[{3,0,1520112}]',1654,'[{90,1},{7,2},{2,3},{1,5}]',5455,154700,'[{2,95200},{4,2380}]'),(8,366,'[{3,0,1536158}]',1659,'[{90,1},{7,2},{2,3},{1,5}]',5472,155480,'[{2,95680},{4,2392}]'),(8,367,'[{3,0,1552205}]',1664,'[{90,1},{7,2},{2,3},{1,5}]',5489,156260,'[{2,96160},{4,2404}]'),(8,368,'[{3,0,1568251}]',1669,'[{90,1},{7,2},{2,3},{1,5}]',5505,157040,'[{2,96640},{4,2416}]'),(8,369,'[{3,0,1584297}]',1674,'[{90,1},{7,2},{2,3},{1,5}]',5522,157820,'[{2,97120},{4,2428}]'),(8,370,'[{3,0,1600344}]',1679,'[{90,1},{7,2},{2,3},{1,5}]',5539,158600,'[{2,97600},{4,2440}]'),(8,371,'[{3,0,1616390}]',1684,'[{90,1},{7,2},{2,3},{1,5}]',5556,159380,'[{2,98080},{4,2452}]'),(8,372,'[{3,0,1632437}]',1689,'[{90,1},{7,2},{2,3},{1,5}]',5572,160160,'[{2,98560},{4,2464}]'),(8,373,'[{3,0,1648483}]',1694,'[{90,1},{7,2},{2,3},{1,5}]',5589,160940,'[{2,99040},{4,2476}]'),(8,374,'[{3,0,1664530}]',1699,'[{90,1},{7,2},{2,3},{1,5}]',5606,161720,'[{2,99520},{4,2488}]'),(8,375,'[{3,0,1679756}]',1704,'[{90,1},{7,2},{2,3},{1,5}]',5623,162500,'[{2,100000},{4,2500}]'),(8,376,'[{3,0,1694982}]',1710,'[{90,1},{7,2},{2,3},{1,5}]',5640,163280,'[{2,100480},{4,2512}]'),(8,377,'[{3,0,1710209}]',1714,'[{90,1},{7,2},{2,3},{1,5}]',5656,164060,'[{2,100960},{4,2524}]'),(8,378,'[{3,0,1725435}]',1720,'[{90,1},{7,2},{2,3},{1,5}]',5673,164840,'[{2,101440},{4,2536}]'),(8,379,'[{3,0,1740661}]',1725,'[{90,1},{7,2},{2,3},{1,5}]',5690,165620,'[{2,101920},{4,2548}]'),(8,380,'[{3,0,1755888}]',1730,'[{90,1},{7,2},{2,3},{1,5}]',5707,166400,'[{2,102400},{4,2560}]'),(8,381,'[{3,0,1771114}]',1735,'[{90,1},{7,2},{2,3},{1,5}]',5724,167180,'[{2,102880},{4,2572}]'),(8,382,'[{3,0,1786340}]',1740,'[{90,1},{7,2},{2,3},{1,5}]',5740,167960,'[{2,103360},{4,2584}]'),(8,383,'[{3,0,1801567}]',1745,'[{90,1},{7,2},{2,3},{1,5}]',5757,168740,'[{2,103840},{4,2596}]'),(8,384,'[{3,0,1816793}]',1750,'[{90,1},{7,2},{2,3},{1,5}]',5774,169520,'[{2,104320},{4,2608}]'),(8,385,'[{3,0,1832020}]',1755,'[{90,1},{7,2},{2,3},{1,5}]',5791,170300,'[{2,104800},{4,2620}]'),(8,386,'[{3,0,1847246}]',1760,'[{90,1},{7,2},{2,3},{1,5}]',5808,171080,'[{2,105280},{4,2632}]'),(8,387,'[{3,0,1862472}]',1766,'[{90,1},{7,2},{2,3},{1,5}]',5825,171860,'[{2,105760},{4,2644}]'),(8,388,'[{3,0,1877699}]',1770,'[{90,1},{7,2},{2,3},{1,5}]',5841,172640,'[{2,106240},{4,2656}]'),(8,389,'[{3,0,1892925}]',1776,'[{90,1},{7,2},{2,3},{1,5}]',5858,173420,'[{2,106720},{4,2668}]'),(8,390,'[{3,0,1908151}]',1781,'[{90,1},{7,2},{2,3},{1,5}]',5875,174200,'[{2,107200},{4,2680}]'),(8,391,'[{3,0,1923378}]',1786,'[{90,1},{7,2},{2,3},{1,5}]',5892,174980,'[{2,107680},{4,2692}]'),(8,392,'[{3,0,1938604}]',1791,'[{90,1},{7,2},{2,3},{1,5}]',5909,175760,'[{2,108160},{4,2704}]'),(8,393,'[{3,0,1953830}]',1796,'[{90,1},{7,2},{2,3},{1,5}]',5926,176540,'[{2,108640},{4,2716}]'),(8,394,'[{3,0,1969057}]',1801,'[{90,1},{7,2},{2,3},{1,5}]',5943,177320,'[{2,109120},{4,2728}]'),(8,395,'[{3,0,1984283}]',1807,'[{90,1},{7,2},{2,3},{1,5}]',5960,178100,'[{2,109600},{4,2740}]'),(8,396,'[{3,0,1999510}]',1812,'[{90,1},{7,2},{2,3},{1,5}]',5977,178880,'[{2,110080},{4,2752}]'),(8,397,'[{3,0,2014736}]',1817,'[{90,1},{7,2},{2,3},{1,5}]',5993,179660,'[{2,110560},{4,2764}]'),(8,398,'[{3,0,2029962}]',1822,'[{90,1},{7,2},{2,3},{1,5}]',6010,180440,'[{2,111040},{4,2776}]'),(8,399,'[{3,0,2109102}]',1884,'[{90,1},{7,2},{2,3},{1,5}]',6027,181220,'[{2,111520},{4,2788}]'),(8,400,'[{3,0,2133037}]',1889,'[{90,1},{7,2},{2,3},{1,5}]',6044,182000,'[{2,112000},{4,2800}]'),(8,401,'[{3,0,2156972}]',1895,'[{90,1},{7,2},{2,3},{1,5}]',6061,183040,'[{2,112640},{4,2816}]'),(8,402,'[{3,0,2180907}]',1900,'[{90,1},{7,2},{2,3},{1,5}]',6078,184080,'[{2,113280},{4,2832}]'),(8,403,'[{3,0,2204842}]',1905,'[{90,1},{7,2},{2,3},{1,5}]',6095,185120,'[{2,113920},{4,2848}]'),(8,404,'[{3,0,2228777}]',1910,'[{90,1},{7,2},{2,3},{1,5}]',6112,186160,'[{2,114560},{4,2864}]'),(8,405,'[{3,0,2252712}]',1916,'[{90,1},{7,2},{2,3},{1,5}]',6129,187200,'[{2,115200},{4,2880}]'),(8,406,'[{3,0,2276647}]',1921,'[{90,1},{7,2},{2,3},{1,5}]',6146,188240,'[{2,115840},{4,2896}]'),(8,407,'[{3,0,2300582}]',1926,'[{90,1},{7,2},{2,3},{1,5}]',6163,189280,'[{2,116480},{4,2912}]'),(8,408,'[{3,0,2324517}]',1932,'[{90,1},{7,2},{2,3},{1,5}]',6180,190320,'[{2,117120},{4,2928}]'),(8,409,'[{3,0,2348452}]',1937,'[{90,1},{7,2},{2,3},{1,5}]',6197,191360,'[{2,117760},{4,2944}]'),(8,410,'[{3,0,2372387}]',1942,'[{90,1},{7,2},{2,3},{1,5}]',6214,192400,'[{2,118400},{4,2960}]'),(8,411,'[{3,0,2396322}]',1948,'[{90,1},{7,2},{2,3},{1,5}]',6231,193440,'[{2,119040},{4,2976}]'),(8,412,'[{3,0,2420257}]',1953,'[{90,1},{7,2},{2,3},{1,5}]',6248,194480,'[{2,119680},{4,2992}]'),(8,413,'[{3,0,2444192}]',1958,'[{90,1},{7,2},{2,3},{1,5}]',6265,195520,'[{2,120320},{4,3008}]'),(8,414,'[{3,0,2468127}]',1964,'[{90,1},{7,2},{2,3},{1,5}]',6282,196560,'[{2,120960},{4,3024}]'),(8,415,'[{3,0,2492062}]',1969,'[{90,1},{7,2},{2,3},{1,5}]',6299,197600,'[{2,121600},{4,3040}]'),(8,416,'[{3,0,2515997}]',1974,'[{90,1},{7,2},{2,3},{1,5}]',6316,198640,'[{2,122240},{4,3056}]'),(8,417,'[{3,0,2539932}]',1980,'[{90,1},{7,2},{2,3},{1,5}]',6333,199680,'[{2,122880},{4,3072}]'),(8,418,'[{3,0,2563867}]',1985,'[{90,1},{7,2},{2,3},{1,5}]',6350,200720,'[{2,123520},{4,3088}]'),(8,419,'[{3,0,2587802}]',1990,'[{90,1},{7,2},{2,3},{1,5}]',6367,201760,'[{2,124160},{4,3104}]'),(8,420,'[{3,0,2611737}]',1995,'[{90,1},{7,2},{2,3},{1,5}]',6384,202800,'[{2,124800},{4,3120}]'),(8,421,'[{3,0,2635672}]',2001,'[{90,1},{7,2},{2,3},{1,5}]',6401,203840,'[{2,125440},{4,3136}]'),(8,422,'[{3,0,2659607}]',2006,'[{90,1},{7,2},{2,3},{1,5}]',6418,204880,'[{2,126080},{4,3152}]'),(8,423,'[{3,0,2683542}]',2011,'[{90,1},{7,2},{2,3},{1,5}]',6435,205920,'[{2,126720},{4,3168}]'),(8,424,'[{3,0,2707479}]',2017,'[{90,1},{7,2},{2,3},{1,5}]',6452,206960,'[{2,127360},{4,3184}]'),(8,425,'[{3,0,2730859}]',2022,'[{90,1},{7,2},{2,3},{1,5}]',6470,208000,'[{2,128000},{4,3200}]'),(8,426,'[{3,0,2754239}]',2028,'[{90,1},{7,2},{2,3},{1,5}]',6487,209040,'[{2,128640},{4,3216}]'),(8,427,'[{3,0,2777618}]',2033,'[{90,1},{7,2},{2,3},{1,5}]',6504,210080,'[{2,129280},{4,3232}]'),(8,428,'[{3,0,2800998}]',2038,'[{90,1},{7,2},{2,3},{1,5}]',6521,211120,'[{2,129920},{4,3248}]'),(8,429,'[{3,0,2824378}]',2044,'[{90,1},{7,2},{2,3},{1,5}]',6538,212160,'[{2,130560},{4,3264}]'),(8,430,'[{3,0,2847757}]',2049,'[{90,1},{7,2},{2,3},{1,5}]',6555,213200,'[{2,131200},{4,3280}]'),(8,431,'[{3,0,2871137}]',2054,'[{90,1},{7,2},{2,3},{1,5}]',6572,214240,'[{2,131840},{4,3296}]'),(8,432,'[{3,0,2894517}]',2060,'[{90,1},{7,2},{2,3},{1,5}]',6589,215280,'[{2,132480},{4,3312}]'),(8,433,'[{3,0,2917896}]',2065,'[{90,1},{7,2},{2,3},{1,5}]',6606,216320,'[{2,133120},{4,3328}]'),(8,434,'[{3,0,2941276}]',2070,'[{90,1},{7,2},{2,3},{1,5}]',6624,217360,'[{2,133760},{4,3344}]'),(8,435,'[{3,0,2964656}]',2076,'[{90,1},{7,2},{2,3},{1,5}]',6641,218400,'[{2,134400},{4,3360}]'),(8,436,'[{3,0,2988035}]',2081,'[{90,1},{7,2},{2,3},{1,5}]',6658,219440,'[{2,135040},{4,3376}]'),(8,437,'[{3,0,3011415}]',2086,'[{90,1},{7,2},{2,3},{1,5}]',6675,220480,'[{2,135680},{4,3392}]'),(8,438,'[{3,0,3034795}]',2092,'[{90,1},{7,2},{2,3},{1,5}]',6692,221520,'[{2,136320},{4,3408}]'),(8,439,'[{3,0,3058175}]',2097,'[{90,1},{7,2},{2,3},{1,5}]',6709,222560,'[{2,136960},{4,3424}]'),(8,440,'[{3,0,3081554}]',2102,'[{90,1},{7,2},{2,3},{1,5}]',6726,223600,'[{2,137600},{4,3440}]'),(8,441,'[{3,0,3104934}]',2108,'[{90,1},{7,2},{2,3},{1,5}]',6744,224640,'[{2,138240},{4,3456}]'),(8,442,'[{3,0,3128314}]',2113,'[{90,1},{7,2},{2,3},{1,5}]',6761,225680,'[{2,138880},{4,3472}]'),(8,443,'[{3,0,3151693}]',2119,'[{90,1},{7,2},{2,3},{1,5}]',6778,226720,'[{2,139520},{4,3488}]'),(8,444,'[{3,0,3175073}]',2124,'[{90,1},{7,2},{2,3},{1,5}]',6795,227760,'[{2,140160},{4,3504}]'),(8,445,'[{3,0,3198453}]',2129,'[{90,1},{7,2},{2,3},{1,5}]',6812,228800,'[{2,140800},{4,3520}]'),(8,446,'[{3,0,3221832}]',2135,'[{90,1},{7,2},{2,3},{1,5}]',6830,229840,'[{2,141440},{4,3536}]'),(8,447,'[{3,0,3245212}]',2140,'[{90,1},{7,2},{2,3},{1,5}]',6847,230880,'[{2,142080},{4,3552}]'),(8,448,'[{3,0,3268592}]',2145,'[{90,1},{7,2},{2,3},{1,5}]',6864,231920,'[{2,142720},{4,3568}]'),(8,449,'[{3,0,3398166}]',2220,'[{90,1},{7,2},{2,3},{1,5}]',6881,232960,'[{2,143360},{4,3584}]'),(8,450,'[{3,0,3413589}]',2226,'[{90,1},{7,2},{2,3},{1,5}]',6898,234000,'[{2,144000},{4,3600}]'),(8,451,'[{3,0,3429011}]',2231,'[{90,1},{7,2},{2,3},{1,5}]',6916,235040,'[{2,144640},{4,3616}]'),(8,452,'[{3,0,3444434}]',2237,'[{90,1},{7,2},{2,3},{1,5}]',6933,236080,'[{2,145280},{4,3632}]'),(8,453,'[{3,0,3459856}]',2242,'[{90,1},{7,2},{2,3},{1,5}]',6950,237120,'[{2,145920},{4,3648}]'),(8,454,'[{3,0,3475279}]',2248,'[{90,1},{7,2},{2,3},{1,5}]',6967,238160,'[{2,146560},{4,3664}]'),(8,455,'[{3,0,3490701}]',2254,'[{90,1},{7,2},{2,3},{1,5}]',6985,239200,'[{2,147200},{4,3680}]'),(8,456,'[{3,0,3506124}]',2259,'[{90,1},{7,2},{2,3},{1,5}]',7002,240240,'[{2,147840},{4,3696}]'),(8,457,'[{3,0,3521547}]',2265,'[{90,1},{7,2},{2,3},{1,5}]',7019,241280,'[{2,148480},{4,3712}]'),(8,458,'[{3,0,3536969}]',2270,'[{90,1},{7,2},{2,3},{1,5}]',7036,242320,'[{2,149120},{4,3728}]'),(8,459,'[{3,0,3552392}]',2276,'[{90,1},{7,2},{2,3},{1,5}]',7054,243360,'[{2,149760},{4,3744}]'),(8,460,'[{3,0,3567814}]',2281,'[{90,1},{7,2},{2,3},{1,5}]',7071,244400,'[{2,150400},{4,3760}]'),(8,461,'[{3,0,3583237}]',2287,'[{90,1},{7,2},{2,3},{1,5}]',7088,245440,'[{2,151040},{4,3776}]'),(8,462,'[{3,0,3598660}]',2292,'[{90,1},{7,2},{2,3},{1,5}]',7105,246480,'[{2,151680},{4,3792}]'),(8,463,'[{3,0,3614082}]',2298,'[{90,1},{7,2},{2,3},{1,5}]',7123,247520,'[{2,152320},{4,3808}]'),(8,464,'[{3,0,3629505}]',2304,'[{90,1},{7,2},{2,3},{1,5}]',7140,248560,'[{2,152960},{4,3824}]'),(8,465,'[{3,0,3644927}]',2309,'[{90,1},{7,2},{2,3},{1,5}]',7157,249600,'[{2,153600},{4,3840}]'),(8,466,'[{3,0,3660350}]',2315,'[{90,1},{7,2},{2,3},{1,5}]',7175,250640,'[{2,154240},{4,3856}]'),(8,467,'[{3,0,3675772}]',2320,'[{90,1},{7,2},{2,3},{1,5}]',7192,251680,'[{2,154880},{4,3872}]'),(8,468,'[{3,0,3691195}]',2326,'[{90,1},{7,2},{2,3},{1,5}]',7209,252720,'[{2,155520},{4,3888}]'),(8,469,'[{3,0,3706618}]',2332,'[{90,1},{7,2},{2,3},{1,5}]',7227,253760,'[{2,156160},{4,3904}]'),(8,470,'[{3,0,3722040}]',2337,'[{90,1},{7,2},{2,3},{1,5}]',7244,254800,'[{2,156800},{4,3920}]'),(8,471,'[{3,0,3737463}]',2343,'[{90,1},{7,2},{2,3},{1,5}]',7261,255840,'[{2,157440},{4,3936}]'),(8,472,'[{3,0,3752885}]',2349,'[{90,1},{7,2},{2,3},{1,5}]',7279,256880,'[{2,158080},{4,3952}]'),(8,473,'[{3,0,3768308}]',2354,'[{90,1},{7,2},{2,3},{1,5}]',7296,257920,'[{2,158720},{4,3968}]'),(8,474,'[{3,0,3783732}]',2360,'[{90,1},{7,2},{2,3},{1,5}]',7313,258960,'[{2,159360},{4,3984}]'),(8,475,'[{3,0,3797544}]',2365,'[{90,1},{7,2},{2,3},{1,5}]',7331,260000,'[{2,160000},{4,4000}]'),(8,476,'[{3,0,3811356}]',2371,'[{90,1},{7,2},{2,3},{1,5}]',7348,261040,'[{2,160640},{4,4016}]'),(8,477,'[{3,0,3825168}]',2376,'[{90,1},{7,2},{2,3},{1,5}]',7365,262080,'[{2,161280},{4,4032}]'),(8,478,'[{3,0,3838980}]',2382,'[{90,1},{7,2},{2,3},{1,5}]',7383,263120,'[{2,161920},{4,4048}]'),(8,479,'[{3,0,3852791}]',2388,'[{90,1},{7,2},{2,3},{1,5}]',7400,264160,'[{2,162560},{4,4064}]'),(8,480,'[{3,0,3866603}]',2393,'[{90,1},{7,2},{2,3},{1,5}]',7417,265200,'[{2,163200},{4,4080}]'),(8,481,'[{3,0,3880415}]',2399,'[{90,1},{7,2},{2,3},{1,5}]',7435,266240,'[{2,163840},{4,4096}]'),(8,482,'[{3,0,3894227}]',2404,'[{90,1},{7,2},{2,3},{1,5}]',7452,267280,'[{2,164480},{4,4112}]'),(8,483,'[{3,0,3908039}]',2410,'[{90,1},{7,2},{2,3},{1,5}]',7470,268320,'[{2,165120},{4,4128}]'),(8,484,'[{3,0,3921851}]',2416,'[{90,1},{7,2},{2,3},{1,5}]',7487,269360,'[{2,165760},{4,4144}]'),(8,485,'[{3,0,3935663}]',2421,'[{90,1},{7,2},{2,3},{1,5}]',7504,270400,'[{2,166400},{4,4160}]'),(8,486,'[{3,0,3949475}]',2427,'[{90,1},{7,2},{2,3},{1,5}]',7522,271440,'[{2,167040},{4,4176}]'),(8,487,'[{3,0,3963287}]',2432,'[{90,1},{7,2},{2,3},{1,5}]',7539,272480,'[{2,167680},{4,4192}]'),(8,488,'[{3,0,3977099}]',2438,'[{90,1},{7,2},{2,3},{1,5}]',7557,273520,'[{2,168320},{4,4208}]'),(8,489,'[{3,0,3990911}]',2444,'[{90,1},{7,2},{2,3},{1,5}]',7574,274560,'[{2,168960},{4,4224}]'),(8,490,'[{3,0,4004723}]',2449,'[{90,1},{7,2},{2,3},{1,5}]',7591,275600,'[{2,169600},{4,4240}]'),(8,491,'[{3,0,4018535}]',2455,'[{90,1},{7,2},{2,3},{1,5}]',7609,276640,'[{2,170240},{4,4256}]'),(8,492,'[{3,0,4032347}]',2460,'[{90,1},{7,2},{2,3},{1,5}]',7626,277680,'[{2,170880},{4,4272}]'),(8,493,'[{3,0,4046159}]',2466,'[{90,1},{7,2},{2,3},{1,5}]',7644,278720,'[{2,171520},{4,4288}]'),(8,494,'[{3,0,4059970}]',2472,'[{90,1},{7,2},{2,3},{1,5}]',7661,279760,'[{2,172160},{4,4304}]'),(8,495,'[{3,0,4073782}]',2478,'[{90,1},{7,2},{2,3},{1,5}]',7679,280800,'[{2,172800},{4,4320}]'),(8,496,'[{3,0,4087594}]',2483,'[{90,1},{7,2},{2,3},{1,5}]',7696,281840,'[{2,173440},{4,4336}]'),(8,497,'[{3,0,4101406}]',2489,'[{90,1},{7,2},{2,3},{1,5}]',7714,282880,'[{2,174080},{4,4352}]'),(8,498,'[{3,0,4115218}]',2494,'[{90,1},{7,2},{2,3},{1,5}]',7731,283920,'[{2,174720},{4,4368}]'),(8,499,'[{3,0,4266667}]',2583,'[{90,1},{7,2},{2,3},{1,5}]',7749,284960,'[{2,175360},{4,4384}]'),(8,500,'[{3,0,0}]',0,'[{90,1},{7,2},{2,3},{1,5}]',0,286000,'[{2,176000},{4,4400}]'),(9,0,'[{3,0,668}]',15,'[{90,1},{7,2},{2,3},{1,5}]',58,0,'[{1,0},{3,0}]'),(9,1,'[{3,0,803}]',17,'[{90,1},{7,2},{2,3},{1,5}]',67,195,'[{1,6},{3,3}]'),(9,2,'[{3,0,937}]',19,'[{90,1},{7,2},{2,3},{1,5}]',76,390,'[{1,12},{3,6}]'),(9,3,'[{3,0,1071}]',22,'[{90,1},{7,2},{2,3},{1,5}]',86,585,'[{1,18},{3,9}]'),(9,4,'[{3,0,1205}]',24,'[{90,1},{7,2},{2,3},{1,5}]',96,780,'[{1,24},{3,12}]'),(9,5,'[{3,0,1340}]',27,'[{90,1},{7,2},{2,3},{1,5}]',106,975,'[{1,30},{3,15}]'),(9,6,'[{3,0,1474}]',29,'[{90,1},{7,2},{2,3},{1,5}]',116,1170,'[{1,36},{3,18}]'),(9,7,'[{3,0,1608}]',32,'[{90,1},{7,2},{2,3},{1,5}]',126,1365,'[{1,42},{3,21}]'),(9,8,'[{3,0,1742}]',35,'[{90,1},{7,2},{2,3},{1,5}]',137,1560,'[{1,48},{3,24}]'),(9,9,'[{3,0,1877}]',37,'[{90,1},{7,2},{2,3},{1,5}]',148,1755,'[{1,54},{3,27}]'),(9,10,'[{3,0,2011}]',40,'[{90,1},{7,2},{2,3},{1,5}]',158,1950,'[{1,60},{3,30}]'),(9,11,'[{3,0,2145}]',43,'[{90,1},{7,2},{2,3},{1,5}]',169,2145,'[{1,66},{3,33}]'),(9,12,'[{3,0,2279}]',45,'[{90,1},{7,2},{2,3},{1,5}]',180,2340,'[{1,72},{3,36}]'),(9,13,'[{3,0,2414}]',48,'[{90,1},{7,2},{2,3},{1,5}]',191,2535,'[{1,78},{3,39}]'),(9,14,'[{3,0,2548}]',51,'[{90,1},{7,2},{2,3},{1,5}]',202,2730,'[{1,84},{3,42}]'),(9,15,'[{3,0,2682}]',54,'[{90,1},{7,2},{2,3},{1,5}]',214,2925,'[{1,90},{3,45}]'),(9,16,'[{3,0,2816}]',57,'[{90,1},{7,2},{2,3},{1,5}]',225,3120,'[{1,96},{3,48}]'),(9,17,'[{3,0,2951}]',59,'[{90,1},{7,2},{2,3},{1,5}]',236,3315,'[{1,102},{3,51}]'),(9,18,'[{3,0,3085}]',62,'[{90,1},{7,2},{2,3},{1,5}]',248,3510,'[{1,108},{3,54}]'),(9,19,'[{3,0,3219}]',65,'[{90,1},{7,2},{2,3},{1,5}]',259,3705,'[{1,114},{3,57}]'),(9,20,'[{3,0,3353}]',68,'[{90,1},{7,2},{2,3},{1,5}]',271,3900,'[{1,120},{3,60}]'),(9,21,'[{3,0,3488}]',71,'[{90,1},{7,2},{2,3},{1,5}]',282,4095,'[{1,126},{3,63}]'),(9,22,'[{3,0,3622}]',74,'[{90,1},{7,2},{2,3},{1,5}]',294,4290,'[{1,132},{3,66}]'),(9,23,'[{3,0,3756}]',77,'[{90,1},{7,2},{2,3},{1,5}]',306,4485,'[{1,138},{3,69}]'),(9,24,'[{3,0,3891}]',80,'[{90,1},{7,2},{2,3},{1,5}]',318,4680,'[{1,144},{3,72}]'),(9,25,'[{3,0,4239}]',83,'[{90,1},{7,2},{2,3},{1,5}]',330,4875,'[{1,150},{3,75}]'),(9,26,'[{3,0,4587}]',86,'[{90,1},{7,2},{2,3},{1,5}]',342,5070,'[{1,156},{3,78}]'),(9,27,'[{3,0,4936}]',89,'[{90,1},{7,2},{2,3},{1,5}]',354,5265,'[{1,162},{3,81}]'),(9,28,'[{3,0,5284}]',92,'[{90,1},{7,2},{2,3},{1,5}]',366,5460,'[{1,168},{3,84}]'),(9,29,'[{3,0,5632}]',95,'[{90,1},{7,2},{2,3},{1,5}]',378,5655,'[{1,174},{3,87}]'),(9,30,'[{3,0,5980}]',98,'[{90,1},{7,2},{2,3},{1,5}]',390,5850,'[{1,180},{3,90}]'),(9,31,'[{3,0,6329}]',101,'[{90,1},{7,2},{2,3},{1,5}]',402,6045,'[{1,186},{3,93}]'),(9,32,'[{3,0,6677}]',104,'[{90,1},{7,2},{2,3},{1,5}]',414,6240,'[{1,192},{3,96}]'),(9,33,'[{3,0,7025}]',107,'[{90,1},{7,2},{2,3},{1,5}]',426,6435,'[{1,198},{3,99}]'),(9,34,'[{3,0,7373}]',110,'[{90,1},{7,2},{2,3},{1,5}]',439,6630,'[{1,204},{3,102}]'),(9,35,'[{3,0,7722}]',113,'[{90,1},{7,2},{2,3},{1,5}]',451,6825,'[{1,210},{3,105}]'),(9,36,'[{3,0,8070}]',116,'[{90,1},{7,2},{2,3},{1,5}]',464,7020,'[{1,216},{3,108}]'),(9,37,'[{3,0,8418}]',119,'[{90,1},{7,2},{2,3},{1,5}]',476,7215,'[{1,222},{3,111}]'),(9,38,'[{3,0,8766}]',122,'[{90,1},{7,2},{2,3},{1,5}]',488,7410,'[{1,228},{3,114}]'),(9,39,'[{3,0,9115}]',126,'[{90,1},{7,2},{2,3},{1,5}]',501,7605,'[{1,234},{3,117}]'),(9,40,'[{3,0,9463}]',129,'[{90,1},{7,2},{2,3},{1,5}]',514,7800,'[{1,240},{3,120}]'),(9,41,'[{3,0,9811}]',132,'[{90,1},{7,2},{2,3},{1,5}]',526,7995,'[{1,246},{3,123}]'),(9,42,'[{3,0,10159}]',135,'[{90,1},{7,2},{2,3},{1,5}]',539,8190,'[{1,252},{3,126}]'),(9,43,'[{3,0,10508}]',138,'[{90,1},{7,2},{2,3},{1,5}]',551,8385,'[{1,258},{3,129}]'),(9,44,'[{3,0,10856}]',141,'[{90,1},{7,2},{2,3},{1,5}]',564,8580,'[{1,264},{3,132}]'),(9,45,'[{3,0,11204}]',145,'[{90,1},{7,2},{2,3},{1,5}]',577,8775,'[{1,270},{3,135}]'),(9,46,'[{3,0,11552}]',148,'[{90,1},{7,2},{2,3},{1,5}]',590,8970,'[{1,276},{3,138}]'),(9,47,'[{3,0,11901}]',151,'[{90,1},{7,2},{2,3},{1,5}]',602,9165,'[{1,282},{3,141}]'),(9,48,'[{3,0,12249}]',154,'[{90,1},{7,2},{2,3},{1,5}]',615,9360,'[{1,288},{3,144}]'),(9,49,'[{3,0,12923}]',162,'[{90,1},{7,2},{2,3},{1,5}]',628,9555,'[{1,294},{3,147}]'),(9,50,'[{3,0,13425}]',165,'[{90,1},{7,2},{2,3},{1,5}]',641,9750,'[{1,300},{3,150}]'),(9,51,'[{3,0,13927}]',168,'[{90,1},{7,2},{2,3},{1,5}]',654,9945,'[{1,306},{3,153}]'),(9,52,'[{3,0,14429}]',172,'[{90,1},{7,2},{2,3},{1,5}]',667,10140,'[{1,312},{3,156}]'),(9,53,'[{3,0,14931}]',175,'[{90,1},{7,2},{2,3},{1,5}]',680,10335,'[{1,318},{3,159}]'),(9,54,'[{3,0,15433}]',178,'[{90,1},{7,2},{2,3},{1,5}]',693,10530,'[{1,324},{3,162}]'),(9,55,'[{3,0,15935}]',182,'[{90,1},{7,2},{2,3},{1,5}]',706,10725,'[{1,330},{3,165}]'),(9,56,'[{3,0,16437}]',185,'[{90,1},{7,2},{2,3},{1,5}]',719,10920,'[{1,336},{3,168}]'),(9,57,'[{3,0,16939}]',188,'[{90,1},{7,2},{2,3},{1,5}]',732,11115,'[{1,342},{3,171}]'),(9,58,'[{3,0,17442}]',192,'[{90,1},{7,2},{2,3},{1,5}]',745,11310,'[{1,348},{3,174}]'),(9,59,'[{3,0,17944}]',195,'[{90,1},{7,2},{2,3},{1,5}]',758,11505,'[{1,354},{3,177}]'),(9,60,'[{3,0,18446}]',198,'[{90,1},{7,2},{2,3},{1,5}]',771,11700,'[{1,360},{3,180}]'),(9,61,'[{3,0,18948}]',202,'[{90,1},{7,2},{2,3},{1,5}]',785,11895,'[{1,366},{3,183}]'),(9,62,'[{3,0,19450}]',205,'[{90,1},{7,2},{2,3},{1,5}]',798,12090,'[{1,372},{3,186}]'),(9,63,'[{3,0,19952}]',208,'[{90,1},{7,2},{2,3},{1,5}]',811,12285,'[{1,378},{3,189}]'),(9,64,'[{3,0,20454}]',212,'[{90,1},{7,2},{2,3},{1,5}]',824,12480,'[{1,384},{3,192}]'),(9,65,'[{3,0,20956}]',215,'[{90,1},{7,2},{2,3},{1,5}]',838,12675,'[{1,390},{3,195}]'),(9,66,'[{3,0,21458}]',219,'[{90,1},{7,2},{2,3},{1,5}]',851,12870,'[{1,396},{3,198}]'),(9,67,'[{3,0,21960}]',222,'[{90,1},{7,2},{2,3},{1,5}]',864,13065,'[{1,402},{3,201}]'),(9,68,'[{3,0,22462}]',226,'[{90,1},{7,2},{2,3},{1,5}]',878,13260,'[{1,408},{3,204}]'),(9,69,'[{3,0,22964}]',229,'[{90,1},{7,2},{2,3},{1,5}]',891,13455,'[{1,414},{3,207}]'),(9,70,'[{3,0,23466}]',233,'[{90,1},{7,2},{2,3},{1,5}]',905,13650,'[{1,420},{3,210}]'),(9,71,'[{3,0,23968}]',236,'[{90,1},{7,2},{2,3},{1,5}]',918,13845,'[{1,426},{3,213}]'),(9,72,'[{3,0,24470}]',239,'[{90,1},{7,2},{2,3},{1,5}]',932,14040,'[{1,432},{3,216}]'),(9,73,'[{3,0,24972}]',243,'[{90,1},{7,2},{2,3},{1,5}]',945,14235,'[{1,438},{3,219}]'),(9,74,'[{3,0,25472}]',246,'[{90,1},{7,2},{2,3},{1,5}]',959,14430,'[{1,444},{3,222}]'),(9,75,'[{3,0,25627}]',250,'[{90,1},{7,2},{2,3},{1,5}]',972,14625,'[{1,450},{3,225}]'),(9,76,'[{3,0,25783}]',253,'[{90,1},{7,2},{2,3},{1,5}]',986,14820,'[{1,456},{3,228}]'),(9,77,'[{3,0,25938}]',257,'[{90,1},{7,2},{2,3},{1,5}]',999,15015,'[{1,462},{3,231}]'),(9,78,'[{3,0,26094}]',260,'[{90,1},{7,2},{2,3},{1,5}]',1013,15210,'[{1,468},{3,234}]'),(9,79,'[{3,0,26249}]',264,'[{90,1},{7,2},{2,3},{1,5}]',1027,15405,'[{1,474},{3,237}]'),(9,80,'[{3,0,26404}]',267,'[{90,1},{7,2},{2,3},{1,5}]',1040,15600,'[{1,480},{3,240}]'),(9,81,'[{3,0,26560}]',271,'[{90,1},{7,2},{2,3},{1,5}]',1054,15795,'[{1,486},{3,243}]'),(9,82,'[{3,0,26715}]',274,'[{90,1},{7,2},{2,3},{1,5}]',1068,15990,'[{1,492},{3,246}]'),(9,83,'[{3,0,26870}]',278,'[{90,1},{7,2},{2,3},{1,5}]',1081,16185,'[{1,498},{3,249}]'),(9,84,'[{3,0,27026}]',281,'[{90,1},{7,2},{2,3},{1,5}]',1095,16380,'[{1,504},{3,252}]'),(9,85,'[{3,0,27181}]',285,'[{90,1},{7,2},{2,3},{1,5}]',1109,16575,'[{1,510},{3,255}]'),(9,86,'[{3,0,27337}]',288,'[{90,1},{7,2},{2,3},{1,5}]',1123,16770,'[{1,516},{3,258}]'),(9,87,'[{3,0,27492}]',292,'[{90,1},{7,2},{2,3},{1,5}]',1136,16965,'[{1,522},{3,261}]'),(9,88,'[{3,0,27647}]',295,'[{90,1},{7,2},{2,3},{1,5}]',1150,17160,'[{1,528},{3,264}]'),(9,89,'[{3,0,27803}]',299,'[{90,1},{7,2},{2,3},{1,5}]',1164,17355,'[{1,534},{3,267}]'),(9,90,'[{3,0,27958}]',303,'[{90,1},{7,2},{2,3},{1,5}]',1178,17550,'[{1,540},{3,270}]'),(9,91,'[{3,0,28114}]',306,'[{90,1},{7,2},{2,3},{1,5}]',1192,17745,'[{1,546},{3,273}]'),(9,92,'[{3,0,28269}]',310,'[{90,1},{7,2},{2,3},{1,5}]',1206,17940,'[{1,552},{3,276}]'),(9,93,'[{3,0,28424}]',313,'[{90,1},{7,2},{2,3},{1,5}]',1220,18135,'[{1,558},{3,279}]'),(9,94,'[{3,0,28580}]',317,'[{90,1},{7,2},{2,3},{1,5}]',1234,18330,'[{1,564},{3,282}]'),(9,95,'[{3,0,28735}]',320,'[{90,1},{7,2},{2,3},{1,5}]',1248,18525,'[{1,570},{3,285}]'),(9,96,'[{3,0,28890}]',324,'[{90,1},{7,2},{2,3},{1,5}]',1262,18720,'[{1,576},{3,288}]'),(9,97,'[{3,0,29046}]',328,'[{90,1},{7,2},{2,3},{1,5}]',1276,18915,'[{1,582},{3,291}]'),(9,98,'[{3,0,29201}]',331,'[{90,1},{7,2},{2,3},{1,5}]',1290,19110,'[{1,588},{3,294}]'),(9,99,'[{3,0,30126}]',344,'[{90,1},{7,2},{2,3},{1,5}]',1304,19305,'[{1,594},{3,297}]'),(9,100,'[{3,0,30194}]',347,'[{90,1},{7,2},{2,3},{1,5}]',1318,19500,'[{1,600},{3,300}]'),(9,101,'[{3,0,30263}]',351,'[{90,1},{7,2},{2,3},{1,5}]',1332,19825,'[{1,610},{3,305}]'),(9,102,'[{3,0,30331}]',355,'[{90,1},{7,2},{2,3},{1,5}]',1346,20150,'[{1,620},{3,310}]'),(9,103,'[{3,0,30400}]',358,'[{90,1},{7,2},{2,3},{1,5}]',1360,20475,'[{1,630},{3,315}]'),(9,104,'[{3,0,30468}]',362,'[{90,1},{7,2},{2,3},{1,5}]',1374,20800,'[{1,640},{3,320}]'),(9,105,'[{3,0,30537}]',366,'[{90,1},{7,2},{2,3},{1,5}]',1388,21125,'[{1,650},{3,325}]'),(9,106,'[{3,0,30605}]',369,'[{90,1},{7,2},{2,3},{1,5}]',1402,21450,'[{1,660},{3,330}]'),(9,107,'[{3,0,30673}]',373,'[{90,1},{7,2},{2,3},{1,5}]',1416,21775,'[{1,670},{3,335}]'),(9,108,'[{3,0,30742}]',377,'[{90,1},{7,2},{2,3},{1,5}]',1431,22100,'[{1,680},{3,340}]'),(9,109,'[{3,0,30810}]',381,'[{90,1},{7,2},{2,3},{1,5}]',1445,22425,'[{1,690},{3,345}]'),(9,110,'[{3,0,30879}]',384,'[{90,1},{7,2},{2,3},{1,5}]',1459,22750,'[{1,700},{3,350}]'),(9,111,'[{3,0,30947}]',388,'[{90,1},{7,2},{2,3},{1,5}]',1473,23075,'[{1,710},{3,355}]'),(9,112,'[{3,0,31015}]',392,'[{90,1},{7,2},{2,3},{1,5}]',1488,23400,'[{1,720},{3,360}]'),(9,113,'[{3,0,31084}]',396,'[{90,1},{7,2},{2,3},{1,5}]',1502,23725,'[{1,730},{3,365}]'),(9,114,'[{3,0,31152}]',399,'[{90,1},{7,2},{2,3},{1,5}]',1516,24050,'[{1,740},{3,370}]'),(9,115,'[{3,0,31221}]',403,'[{90,1},{7,2},{2,3},{1,5}]',1530,24375,'[{1,750},{3,375}]'),(9,116,'[{3,0,31289}]',407,'[{90,1},{7,2},{2,3},{1,5}]',1545,24700,'[{1,760},{3,380}]'),(9,117,'[{3,0,31358}]',411,'[{90,1},{7,2},{2,3},{1,5}]',1559,25025,'[{1,770},{3,385}]'),(9,118,'[{3,0,31426}]',414,'[{90,1},{7,2},{2,3},{1,5}]',1573,25350,'[{1,780},{3,390}]'),(9,119,'[{3,0,31494}]',418,'[{90,1},{7,2},{2,3},{1,5}]',1588,25675,'[{1,790},{3,395}]'),(9,120,'[{3,0,31563}]',422,'[{90,1},{7,2},{2,3},{1,5}]',1602,26000,'[{1,800},{3,400}]'),(9,121,'[{3,0,31631}]',426,'[{90,1},{7,2},{2,3},{1,5}]',1617,26325,'[{1,810},{3,405}]'),(9,122,'[{3,0,31700}]',430,'[{90,1},{7,2},{2,3},{1,5}]',1631,26650,'[{1,820},{3,410}]'),(9,123,'[{3,0,31768}]',434,'[{90,1},{7,2},{2,3},{1,5}]',1646,26975,'[{1,830},{3,415}]'),(9,124,'[{3,0,31837}]',437,'[{90,1},{7,2},{2,3},{1,5}]',1660,27300,'[{1,840},{3,420}]'),(9,125,'[{3,0,32159}]',441,'[{90,1},{7,2},{2,3},{1,5}]',1674,27625,'[{1,850},{3,425}]'),(9,126,'[{3,0,32481}]',445,'[{90,1},{7,2},{2,3},{1,5}]',1689,27950,'[{1,860},{3,430}]'),(9,127,'[{3,0,32803}]',449,'[{90,1},{7,2},{2,3},{1,5}]',1703,28275,'[{1,870},{3,435}]'),(9,128,'[{3,0,33125}]',453,'[{90,1},{7,2},{2,3},{1,5}]',1718,28600,'[{1,880},{3,440}]'),(9,129,'[{3,0,33447}]',456,'[{90,1},{7,2},{2,3},{1,5}]',1732,28925,'[{1,890},{3,445}]'),(9,130,'[{3,0,33769}]',460,'[{90,1},{7,2},{2,3},{1,5}]',1747,29250,'[{1,900},{3,450}]'),(9,131,'[{3,0,34091}]',464,'[{90,1},{7,2},{2,3},{1,5}]',1762,29575,'[{1,910},{3,455}]'),(9,132,'[{3,0,34413}]',468,'[{90,1},{7,2},{2,3},{1,5}]',1776,29900,'[{1,920},{3,460}]'),(9,133,'[{3,0,34735}]',472,'[{90,1},{7,2},{2,3},{1,5}]',1791,30225,'[{1,930},{3,465}]'),(9,134,'[{3,0,35058}]',475,'[{90,1},{7,2},{2,3},{1,5}]',1805,30550,'[{1,940},{3,470}]'),(9,135,'[{3,0,35380}]',479,'[{90,1},{7,2},{2,3},{1,5}]',1820,30875,'[{1,950},{3,475}]'),(9,136,'[{3,0,35702}]',483,'[{90,1},{7,2},{2,3},{1,5}]',1834,31200,'[{1,960},{3,480}]'),(9,137,'[{3,0,36024}]',487,'[{90,1},{7,2},{2,3},{1,5}]',1849,31525,'[{1,970},{3,485}]'),(9,138,'[{3,0,36346}]',491,'[{90,1},{7,2},{2,3},{1,5}]',1864,31850,'[{1,980},{3,490}]'),(9,139,'[{3,0,36668}]',495,'[{90,1},{7,2},{2,3},{1,5}]',1878,32175,'[{1,990},{3,495}]'),(9,140,'[{3,0,36990}]',499,'[{90,1},{7,2},{2,3},{1,5}]',1893,32500,'[{1,1000},{3,500}]'),(9,141,'[{3,0,37312}]',503,'[{90,1},{7,2},{2,3},{1,5}]',1908,32825,'[{1,1010},{3,505}]'),(9,142,'[{3,0,37634}]',507,'[{90,1},{7,2},{2,3},{1,5}]',1923,33150,'[{1,1020},{3,510}]'),(9,143,'[{3,0,37957}]',510,'[{90,1},{7,2},{2,3},{1,5}]',1937,33475,'[{1,1030},{3,515}]'),(9,144,'[{3,0,38279}]',514,'[{90,1},{7,2},{2,3},{1,5}]',1952,33800,'[{1,1040},{3,520}]'),(9,145,'[{3,0,38601}]',518,'[{90,1},{7,2},{2,3},{1,5}]',1967,34125,'[{1,1050},{3,525}]'),(9,146,'[{3,0,38923}]',522,'[{90,1},{7,2},{2,3},{1,5}]',1981,34450,'[{1,1060},{3,530}]'),(9,147,'[{3,0,39245}]',526,'[{90,1},{7,2},{2,3},{1,5}]',1996,34775,'[{1,1070},{3,535}]'),(9,148,'[{3,0,39567}]',530,'[{90,1},{7,2},{2,3},{1,5}]',2011,35100,'[{1,1080},{3,540}]'),(9,149,'[{3,0,40965}]',548,'[{90,1},{7,2},{2,3},{1,5}]',2026,35425,'[{1,1090},{3,545}]'),(9,150,'[{3,0,41443}]',552,'[{90,1},{7,2},{2,3},{1,5}]',2041,35750,'[{1,1100},{3,550}]'),(9,151,'[{3,0,41922}]',556,'[{90,1},{7,2},{2,3},{1,5}]',2055,36075,'[{1,1110},{3,555}]'),(9,152,'[{3,0,42401}]',560,'[{90,1},{7,2},{2,3},{1,5}]',2070,36400,'[{1,1120},{3,560}]'),(9,153,'[{3,0,42879}]',564,'[{90,1},{7,2},{2,3},{1,5}]',2085,36725,'[{1,1130},{3,565}]'),(9,154,'[{3,0,43358}]',568,'[{90,1},{7,2},{2,3},{1,5}]',2100,37050,'[{1,1140},{3,570}]'),(9,155,'[{3,0,43837}]',572,'[{90,1},{7,2},{2,3},{1,5}]',2115,37375,'[{1,1150},{3,575}]'),(9,156,'[{3,0,44315}]',576,'[{90,1},{7,2},{2,3},{1,5}]',2130,37700,'[{1,1160},{3,580}]'),(9,157,'[{3,0,44794}]',580,'[{90,1},{7,2},{2,3},{1,5}]',2145,38025,'[{1,1170},{3,585}]'),(9,158,'[{3,0,45273}]',584,'[{90,1},{7,2},{2,3},{1,5}]',2160,38350,'[{1,1180},{3,590}]'),(9,159,'[{3,0,45751}]',588,'[{90,1},{7,2},{2,3},{1,5}]',2175,38675,'[{1,1190},{3,595}]'),(9,160,'[{3,0,46230}]',592,'[{90,1},{7,2},{2,3},{1,5}]',2189,39000,'[{1,1200},{3,600}]'),(9,161,'[{3,0,46709}]',596,'[{90,1},{7,2},{2,3},{1,5}]',2204,39325,'[{1,1210},{3,605}]'),(9,162,'[{3,0,47187}]',600,'[{90,1},{7,2},{2,3},{1,5}]',2219,39650,'[{1,1220},{3,610}]'),(9,163,'[{3,0,47666}]',604,'[{90,1},{7,2},{2,3},{1,5}]',2234,39975,'[{1,1230},{3,615}]'),(9,164,'[{3,0,48145}]',608,'[{90,1},{7,2},{2,3},{1,5}]',2249,40300,'[{1,1240},{3,620}]'),(9,165,'[{3,0,48623}]',612,'[{90,1},{7,2},{2,3},{1,5}]',2264,40625,'[{1,1250},{3,625}]'),(9,166,'[{3,0,49102}]',616,'[{90,1},{7,2},{2,3},{1,5}]',2279,40950,'[{1,1260},{3,630}]'),(9,167,'[{3,0,49580}]',620,'[{90,1},{7,2},{2,3},{1,5}]',2294,41275,'[{1,1270},{3,635}]'),(9,168,'[{3,0,50059}]',625,'[{90,1},{7,2},{2,3},{1,5}]',2309,41600,'[{1,1280},{3,640}]'),(9,169,'[{3,0,50538}]',629,'[{90,1},{7,2},{2,3},{1,5}]',2324,41925,'[{1,1290},{3,645}]'),(9,170,'[{3,0,51016}]',633,'[{90,1},{7,2},{2,3},{1,5}]',2340,42250,'[{1,1300},{3,650}]'),(9,171,'[{3,0,51495}]',637,'[{90,1},{7,2},{2,3},{1,5}]',2355,42575,'[{1,1310},{3,655}]'),(9,172,'[{3,0,51974}]',641,'[{90,1},{7,2},{2,3},{1,5}]',2370,42900,'[{1,1320},{3,660}]'),(9,173,'[{3,0,52452}]',645,'[{90,1},{7,2},{2,3},{1,5}]',2385,43225,'[{1,1330},{3,665}]'),(9,174,'[{3,0,52931}]',649,'[{90,1},{7,2},{2,3},{1,5}]',2400,43550,'[{1,1340},{3,670}]'),(9,175,'[{3,0,53077}]',653,'[{90,1},{7,2},{2,3},{1,5}]',2415,43875,'[{1,1350},{3,675}]'),(9,176,'[{3,0,53222}]',657,'[{90,1},{7,2},{2,3},{1,5}]',2430,44200,'[{1,1360},{3,680}]'),(9,177,'[{3,0,53368}]',661,'[{90,1},{7,2},{2,3},{1,5}]',2445,44525,'[{1,1370},{3,685}]'),(9,178,'[{3,0,53514}]',665,'[{90,1},{7,2},{2,3},{1,5}]',2460,44850,'[{1,1380},{3,690}]'),(9,179,'[{3,0,53659}]',670,'[{90,1},{7,2},{2,3},{1,5}]',2476,45175,'[{1,1390},{3,695}]'),(9,180,'[{3,0,53805}]',674,'[{90,1},{7,2},{2,3},{1,5}]',2491,45500,'[{1,1400},{3,700}]'),(9,181,'[{3,0,53951}]',678,'[{90,1},{7,2},{2,3},{1,5}]',2506,45825,'[{1,1410},{3,705}]'),(9,182,'[{3,0,54096}]',682,'[{90,1},{7,2},{2,3},{1,5}]',2521,46150,'[{1,1420},{3,710}]'),(9,183,'[{3,0,54242}]',686,'[{90,1},{7,2},{2,3},{1,5}]',2536,46475,'[{1,1430},{3,715}]'),(9,184,'[{3,0,54388}]',690,'[{90,1},{7,2},{2,3},{1,5}]',2552,46800,'[{1,1440},{3,720}]'),(9,185,'[{3,0,54533}]',694,'[{90,1},{7,2},{2,3},{1,5}]',2567,47125,'[{1,1450},{3,725}]'),(9,186,'[{3,0,54679}]',698,'[{90,1},{7,2},{2,3},{1,5}]',2582,47450,'[{1,1460},{3,730}]'),(9,187,'[{3,0,54825}]',702,'[{90,1},{7,2},{2,3},{1,5}]',2597,47775,'[{1,1470},{3,735}]'),(9,188,'[{3,0,54970}]',707,'[{90,1},{7,2},{2,3},{1,5}]',2613,48100,'[{1,1480},{3,740}]'),(9,189,'[{3,0,55116}]',711,'[{90,1},{7,2},{2,3},{1,5}]',2628,48425,'[{1,1490},{3,745}]'),(9,190,'[{3,0,55262}]',715,'[{90,1},{7,2},{2,3},{1,5}]',2643,48750,'[{1,1500},{3,750}]'),(9,191,'[{3,0,55408}]',719,'[{90,1},{7,2},{2,3},{1,5}]',2658,49075,'[{1,1510},{3,755}]'),(9,192,'[{3,0,55553}]',723,'[{90,1},{7,2},{2,3},{1,5}]',2674,49400,'[{1,1520},{3,760}]'),(9,193,'[{3,0,55699}]',727,'[{90,1},{7,2},{2,3},{1,5}]',2689,49725,'[{1,1530},{3,765}]'),(9,194,'[{3,0,55845}]',731,'[{90,1},{7,2},{2,3},{1,5}]',2704,50050,'[{1,1540},{3,770}]'),(9,195,'[{3,0,55990}]',736,'[{90,1},{7,2},{2,3},{1,5}]',2720,50375,'[{1,1550},{3,775}]'),(9,196,'[{3,0,56136}]',740,'[{90,1},{7,2},{2,3},{1,5}]',2735,50700,'[{1,1560},{3,780}]'),(9,197,'[{3,0,56282}]',744,'[{90,1},{7,2},{2,3},{1,5}]',2750,51025,'[{1,1570},{3,785}]'),(9,198,'[{3,0,56427}]',748,'[{90,1},{7,2},{2,3},{1,5}]',2766,51350,'[{1,1580},{3,790}]'),(9,199,'[{3,0,58145}]',773,'[{90,1},{7,2},{2,3},{1,5}]',2781,51675,'[{1,1590},{3,795}]'),(9,200,'[{3,0,58298}]',777,'[{90,1},{7,2},{2,3},{1,5}]',2797,52000,'[{1,1600},{3,800}]'),(9,201,'[{3,0,58451}]',782,'[{90,1},{7,2},{2,3},{1,5}]',2812,52520,'[{1,1616},{3,808}]'),(9,202,'[{3,0,58604}]',786,'[{90,1},{7,2},{2,3},{1,5}]',2827,53040,'[{1,1632},{3,816}]'),(9,203,'[{3,0,58757}]',790,'[{90,1},{7,2},{2,3},{1,5}]',2843,53560,'[{1,1648},{3,824}]'),(9,204,'[{3,0,58910}]',794,'[{90,1},{7,2},{2,3},{1,5}]',2858,54080,'[{1,1664},{3,832}]'),(9,205,'[{3,0,59063}]',799,'[{90,1},{7,2},{2,3},{1,5}]',2874,54600,'[{1,1680},{3,840}]'),(9,206,'[{3,0,59216}]',803,'[{90,1},{7,2},{2,3},{1,5}]',2889,55120,'[{1,1696},{3,848}]'),(9,207,'[{3,0,59369}]',807,'[{90,1},{7,2},{2,3},{1,5}]',2905,55640,'[{1,1712},{3,856}]'),(9,208,'[{3,0,59522}]',812,'[{90,1},{7,2},{2,3},{1,5}]',2920,56160,'[{1,1728},{3,864}]'),(9,209,'[{3,0,59675}]',816,'[{90,1},{7,2},{2,3},{1,5}]',2936,56680,'[{1,1744},{3,872}]'),(9,210,'[{3,0,59828}]',820,'[{90,1},{7,2},{2,3},{1,5}]',2951,57200,'[{1,1760},{3,880}]'),(9,211,'[{3,0,59981}]',825,'[{90,1},{7,2},{2,3},{1,5}]',2967,57720,'[{1,1776},{3,888}]'),(9,212,'[{3,0,60134}]',829,'[{90,1},{7,2},{2,3},{1,5}]',2982,58240,'[{1,1792},{3,896}]'),(9,213,'[{3,0,60287}]',833,'[{90,1},{7,2},{2,3},{1,5}]',2998,58760,'[{1,1808},{3,904}]'),(9,214,'[{3,0,60440}]',837,'[{90,1},{7,2},{2,3},{1,5}]',3013,59280,'[{1,1824},{3,912}]'),(9,215,'[{3,0,60594}]',842,'[{90,1},{7,2},{2,3},{1,5}]',3029,59800,'[{1,1840},{3,920}]'),(9,216,'[{3,0,60747}]',846,'[{90,1},{7,2},{2,3},{1,5}]',3044,60320,'[{1,1856},{3,928}]'),(9,217,'[{3,0,60900}]',850,'[{90,1},{7,2},{2,3},{1,5}]',3060,60840,'[{1,1872},{3,936}]'),(9,218,'[{3,0,61053}]',855,'[{90,1},{7,2},{2,3},{1,5}]',3075,61360,'[{1,1888},{3,944}]'),(9,219,'[{3,0,61206}]',859,'[{90,1},{7,2},{2,3},{1,5}]',3091,61880,'[{1,1904},{3,952}]'),(9,220,'[{3,0,61359}]',864,'[{90,1},{7,2},{2,3},{1,5}]',3107,62400,'[{1,1920},{3,960}]'),(9,221,'[{3,0,61512}]',868,'[{90,1},{7,2},{2,3},{1,5}]',3122,62920,'[{1,1936},{3,968}]'),(9,222,'[{3,0,61665}]',872,'[{90,1},{7,2},{2,3},{1,5}]',3138,63440,'[{1,1952},{3,976}]'),(9,223,'[{3,0,61818}]',876,'[{90,1},{7,2},{2,3},{1,5}]',3153,63960,'[{1,1968},{3,984}]'),(9,224,'[{3,0,61974}]',881,'[{90,1},{7,2},{2,3},{1,5}]',3169,64480,'[{1,1984},{3,992}]'),(9,225,'[{3,0,68137}]',885,'[{90,1},{7,2},{2,3},{1,5}]',3185,65000,'[{1,2000},{3,1000}]'),(9,226,'[{3,0,74299}]',889,'[{90,1},{7,2},{2,3},{1,5}]',3200,65520,'[{1,2016},{3,1008}]'),(9,227,'[{3,0,80461}]',894,'[{90,1},{7,2},{2,3},{1,5}]',3216,66040,'[{1,2032},{3,1016}]'),(9,228,'[{3,0,86623}]',898,'[{90,1},{7,2},{2,3},{1,5}]',3232,66560,'[{1,2048},{3,1024}]'),(9,229,'[{3,0,92785}]',902,'[{90,1},{7,2},{2,3},{1,5}]',3247,67080,'[{1,2064},{3,1032}]'),(9,230,'[{3,0,98948}]',907,'[{90,1},{7,2},{2,3},{1,5}]',3263,67600,'[{1,2080},{3,1040}]'),(9,231,'[{3,0,105110}]',911,'[{90,1},{7,2},{2,3},{1,5}]',3279,68120,'[{1,2096},{3,1048}]'),(9,232,'[{3,0,111272}]',915,'[{90,1},{7,2},{2,3},{1,5}]',3294,68640,'[{1,2112},{3,1056}]'),(9,233,'[{3,0,117434}]',920,'[{90,1},{7,2},{2,3},{1,5}]',3310,69160,'[{1,2128},{3,1064}]'),(9,234,'[{3,0,123597}]',924,'[{90,1},{7,2},{2,3},{1,5}]',3326,69680,'[{1,2144},{3,1072}]'),(9,235,'[{3,0,129759}]',929,'[{90,1},{7,2},{2,3},{1,5}]',3342,70200,'[{1,2160},{3,1080}]'),(9,236,'[{3,0,135921}]',933,'[{90,1},{7,2},{2,3},{1,5}]',3357,70720,'[{1,2176},{3,1088}]'),(9,237,'[{3,0,142083}]',937,'[{90,1},{7,2},{2,3},{1,5}]',3373,71240,'[{1,2192},{3,1096}]'),(9,238,'[{3,0,148245}]',942,'[{90,1},{7,2},{2,3},{1,5}]',3389,71760,'[{1,2208},{3,1104}]'),(9,239,'[{3,0,154408}]',946,'[{90,1},{7,2},{2,3},{1,5}]',3405,72280,'[{1,2224},{3,1112}]'),(9,240,'[{3,0,160570}]',950,'[{90,1},{7,2},{2,3},{1,5}]',3420,72800,'[{1,2240},{3,1120}]'),(9,241,'[{3,0,166732}]',955,'[{90,1},{7,2},{2,3},{1,5}]',3436,73320,'[{1,2256},{3,1128}]'),(9,242,'[{3,0,172894}]',959,'[{90,1},{7,2},{2,3},{1,5}]',3452,73840,'[{1,2272},{3,1136}]'),(9,243,'[{3,0,179057}]',964,'[{90,1},{7,2},{2,3},{1,5}]',3468,74360,'[{1,2288},{3,1144}]'),(9,244,'[{3,0,185219}]',968,'[{90,1},{7,2},{2,3},{1,5}]',3484,74880,'[{1,2304},{3,1152}]'),(9,245,'[{3,0,191381}]',972,'[{90,1},{7,2},{2,3},{1,5}]',3499,75400,'[{1,2320},{3,1160}]'),(9,246,'[{3,0,197543}]',977,'[{90,1},{7,2},{2,3},{1,5}]',3515,75920,'[{1,2336},{3,1168}]'),(9,247,'[{3,0,203705}]',981,'[{90,1},{7,2},{2,3},{1,5}]',3531,76440,'[{1,2352},{3,1176}]'),(9,248,'[{3,0,209868}]',986,'[{90,1},{7,2},{2,3},{1,5}]',3547,76960,'[{1,2368},{3,1184}]'),(9,249,'[{3,0,222203}]',1018,'[{90,1},{7,2},{2,3},{1,5}]',3563,77480,'[{1,2384},{3,1192}]'),(9,250,'[{3,0,228297}]',1023,'[{90,1},{7,2},{2,3},{1,5}]',3579,78000,'[{1,2400},{3,1200}]'),(9,251,'[{3,0,234391}]',1028,'[{90,1},{7,2},{2,3},{1,5}]',3595,78520,'[{1,2416},{3,1208}]'),(9,252,'[{3,0,240485}]',1032,'[{90,1},{7,2},{2,3},{1,5}]',3610,79040,'[{1,2432},{3,1216}]'),(9,253,'[{3,0,246579}]',1036,'[{90,1},{7,2},{2,3},{1,5}]',3626,79560,'[{1,2448},{3,1224}]'),(9,254,'[{3,0,252673}]',1041,'[{90,1},{7,2},{2,3},{1,5}]',3642,80080,'[{1,2464},{3,1232}]'),(9,255,'[{3,0,258767}]',1046,'[{90,1},{7,2},{2,3},{1,5}]',3658,80600,'[{1,2480},{3,1240}]'),(9,256,'[{3,0,264861}]',1050,'[{90,1},{7,2},{2,3},{1,5}]',3674,81120,'[{1,2496},{3,1248}]'),(9,257,'[{3,0,270955}]',1055,'[{90,1},{7,2},{2,3},{1,5}]',3690,81640,'[{1,2512},{3,1256}]'),(9,258,'[{3,0,277049}]',1059,'[{90,1},{7,2},{2,3},{1,5}]',3706,82160,'[{1,2528},{3,1264}]'),(9,259,'[{3,0,283143}]',1064,'[{90,1},{7,2},{2,3},{1,5}]',3722,82680,'[{1,2544},{3,1272}]'),(9,260,'[{3,0,289237}]',1068,'[{90,1},{7,2},{2,3},{1,5}]',3738,83200,'[{1,2560},{3,1280}]'),(9,261,'[{3,0,295331}]',1073,'[{90,1},{7,2},{2,3},{1,5}]',3754,83720,'[{1,2576},{3,1288}]'),(9,262,'[{3,0,301425}]',1078,'[{90,1},{7,2},{2,3},{1,5}]',3770,84240,'[{1,2592},{3,1296}]'),(9,263,'[{3,0,307519}]',1082,'[{90,1},{7,2},{2,3},{1,5}]',3786,84760,'[{1,2608},{3,1304}]'),(9,264,'[{3,0,313613}]',1087,'[{90,1},{7,2},{2,3},{1,5}]',3802,85280,'[{1,2624},{3,1312}]'),(9,265,'[{3,0,319707}]',1091,'[{90,1},{7,2},{2,3},{1,5}]',3818,85800,'[{1,2640},{3,1320}]'),(9,266,'[{3,0,325801}]',1096,'[{90,1},{7,2},{2,3},{1,5}]',3834,86320,'[{1,2656},{3,1328}]'),(9,267,'[{3,0,331895}]',1100,'[{90,1},{7,2},{2,3},{1,5}]',3850,86840,'[{1,2672},{3,1336}]'),(9,268,'[{3,0,337989}]',1105,'[{90,1},{7,2},{2,3},{1,5}]',3866,87360,'[{1,2688},{3,1344}]'),(9,269,'[{3,0,344083}]',1110,'[{90,1},{7,2},{2,3},{1,5}]',3882,87880,'[{1,2704},{3,1352}]'),(9,270,'[{3,0,350177}]',1114,'[{90,1},{7,2},{2,3},{1,5}]',3898,88400,'[{1,2720},{3,1360}]'),(9,271,'[{3,0,356271}]',1119,'[{90,1},{7,2},{2,3},{1,5}]',3914,88920,'[{1,2736},{3,1368}]'),(9,272,'[{3,0,362365}]',1123,'[{90,1},{7,2},{2,3},{1,5}]',3930,89440,'[{1,2752},{3,1376}]'),(9,273,'[{3,0,368459}]',1128,'[{90,1},{7,2},{2,3},{1,5}]',3946,89960,'[{1,2768},{3,1384}]'),(9,274,'[{3,0,374550}]',1132,'[{90,1},{7,2},{2,3},{1,5}]',3962,90480,'[{1,2784},{3,1392}]'),(9,275,'[{3,0,381734}]',1137,'[{90,1},{7,2},{2,3},{1,5}]',3978,91000,'[{1,2800},{3,1400}]'),(9,276,'[{3,0,388919}]',1142,'[{90,1},{7,2},{2,3},{1,5}]',3994,91520,'[{1,2816},{3,1408}]'),(9,277,'[{3,0,396104}]',1146,'[{90,1},{7,2},{2,3},{1,5}]',4010,92040,'[{1,2832},{3,1416}]'),(9,278,'[{3,0,403288}]',1151,'[{90,1},{7,2},{2,3},{1,5}]',4026,92560,'[{1,2848},{3,1424}]'),(9,279,'[{3,0,410473}]',1155,'[{90,1},{7,2},{2,3},{1,5}]',4042,93080,'[{1,2864},{3,1432}]'),(9,280,'[{3,0,417657}]',1160,'[{90,1},{7,2},{2,3},{1,5}]',4059,93600,'[{1,2880},{3,1440}]'),(9,281,'[{3,0,424842}]',1165,'[{90,1},{7,2},{2,3},{1,5}]',4075,94120,'[{1,2896},{3,1448}]'),(9,282,'[{3,0,432026}]',1169,'[{90,1},{7,2},{2,3},{1,5}]',4091,94640,'[{1,2912},{3,1456}]'),(9,283,'[{3,0,439211}]',1174,'[{90,1},{7,2},{2,3},{1,5}]',4107,95160,'[{1,2928},{3,1464}]'),(9,284,'[{3,0,446396}]',1178,'[{90,1},{7,2},{2,3},{1,5}]',4123,95680,'[{1,2944},{3,1472}]'),(9,285,'[{3,0,453580}]',1183,'[{90,1},{7,2},{2,3},{1,5}]',4139,96200,'[{1,2960},{3,1480}]'),(9,286,'[{3,0,460765}]',1188,'[{90,1},{7,2},{2,3},{1,5}]',4155,96720,'[{1,2976},{3,1488}]'),(9,287,'[{3,0,467949}]',1192,'[{90,1},{7,2},{2,3},{1,5}]',4172,97240,'[{1,2992},{3,1496}]'),(9,288,'[{3,0,475134}]',1197,'[{90,1},{7,2},{2,3},{1,5}]',4188,97760,'[{1,3008},{3,1504}]'),(9,289,'[{3,0,482318}]',1202,'[{90,1},{7,2},{2,3},{1,5}]',4204,98280,'[{1,3024},{3,1512}]'),(9,290,'[{3,0,489503}]',1206,'[{90,1},{7,2},{2,3},{1,5}]',4220,98800,'[{1,3040},{3,1520}]'),(9,291,'[{3,0,496688}]',1211,'[{90,1},{7,2},{2,3},{1,5}]',4236,99320,'[{1,3056},{3,1528}]'),(9,292,'[{3,0,503872}]',1216,'[{90,1},{7,2},{2,3},{1,5}]',4253,99840,'[{1,3072},{3,1536}]'),(9,293,'[{3,0,511057}]',1220,'[{90,1},{7,2},{2,3},{1,5}]',4269,100360,'[{1,3088},{3,1544}]'),(9,294,'[{3,0,518241}]',1225,'[{90,1},{7,2},{2,3},{1,5}]',4285,100880,'[{1,3104},{3,1552}]'),(9,295,'[{3,0,525426}]',1229,'[{90,1},{7,2},{2,3},{1,5}]',4301,101400,'[{1,3120},{3,1560}]'),(9,296,'[{3,0,532610}]',1234,'[{90,1},{7,2},{2,3},{1,5}]',4317,101920,'[{1,3136},{3,1568}]'),(9,297,'[{3,0,539795}]',1239,'[{90,1},{7,2},{2,3},{1,5}]',4334,102440,'[{1,3152},{3,1576}]'),(9,298,'[{3,0,546980}]',1243,'[{90,1},{7,2},{2,3},{1,5}]',4350,102960,'[{1,3168},{3,1584}]'),(9,299,'[{3,0,570466}]',1285,'[{90,1},{7,2},{2,3},{1,5}]',4366,103480,'[{1,3184},{3,1592}]'),(9,300,'[{3,0,581815}]',1289,'[{90,1},{7,2},{2,3},{1,5}]',4382,104000,'[{1,3200},{3,1600}]'),(9,301,'[{3,0,593165}]',1294,'[{90,1},{7,2},{2,3},{1,5}]',4399,104780,'[{1,3224},{3,1612}]'),(9,302,'[{3,0,604515}]',1299,'[{90,1},{7,2},{2,3},{1,5}]',4415,105560,'[{1,3248},{3,1624}]'),(9,303,'[{3,0,615865}]',1304,'[{90,1},{7,2},{2,3},{1,5}]',4431,106340,'[{1,3272},{3,1636}]'),(9,304,'[{3,0,627214}]',1309,'[{90,1},{7,2},{2,3},{1,5}]',4448,107120,'[{1,3296},{3,1648}]'),(9,305,'[{3,0,638564}]',1313,'[{90,1},{7,2},{2,3},{1,5}]',4464,107900,'[{1,3320},{3,1660}]'),(9,306,'[{3,0,649914}]',1318,'[{90,1},{7,2},{2,3},{1,5}]',4480,108680,'[{1,3344},{3,1672}]'),(9,307,'[{3,0,661263}]',1323,'[{90,1},{7,2},{2,3},{1,5}]',4497,109460,'[{1,3368},{3,1684}]'),(9,308,'[{3,0,672613}]',1328,'[{90,1},{7,2},{2,3},{1,5}]',4513,110240,'[{1,3392},{3,1696}]'),(9,309,'[{3,0,683963}]',1333,'[{90,1},{7,2},{2,3},{1,5}]',4529,111020,'[{1,3416},{3,1708}]'),(9,310,'[{3,0,695313}]',1338,'[{90,1},{7,2},{2,3},{1,5}]',4546,111800,'[{1,3440},{3,1720}]'),(9,311,'[{3,0,706662}]',1342,'[{90,1},{7,2},{2,3},{1,5}]',4562,112580,'[{1,3464},{3,1732}]'),(9,312,'[{3,0,718012}]',1347,'[{90,1},{7,2},{2,3},{1,5}]',4578,113360,'[{1,3488},{3,1744}]'),(9,313,'[{3,0,729362}]',1352,'[{90,1},{7,2},{2,3},{1,5}]',4595,114140,'[{1,3512},{3,1756}]'),(9,314,'[{3,0,740711}]',1357,'[{90,1},{7,2},{2,3},{1,5}]',4611,114920,'[{1,3536},{3,1768}]'),(9,315,'[{3,0,752061}]',1361,'[{90,1},{7,2},{2,3},{1,5}]',4627,115700,'[{1,3560},{3,1780}]'),(9,316,'[{3,0,763411}]',1366,'[{90,1},{7,2},{2,3},{1,5}]',4644,116480,'[{1,3584},{3,1792}]'),(9,317,'[{3,0,774760}]',1371,'[{90,1},{7,2},{2,3},{1,5}]',4660,117260,'[{1,3608},{3,1804}]'),(9,318,'[{3,0,786110}]',1376,'[{90,1},{7,2},{2,3},{1,5}]',4677,118040,'[{1,3632},{3,1816}]'),(9,319,'[{3,0,797460}]',1381,'[{90,1},{7,2},{2,3},{1,5}]',4693,118820,'[{1,3656},{3,1828}]'),(9,320,'[{3,0,808810}]',1385,'[{90,1},{7,2},{2,3},{1,5}]',4709,119600,'[{1,3680},{3,1840}]'),(9,321,'[{3,0,820159}]',1390,'[{90,1},{7,2},{2,3},{1,5}]',4726,120380,'[{1,3704},{3,1852}]'),(9,322,'[{3,0,831509}]',1395,'[{90,1},{7,2},{2,3},{1,5}]',4742,121160,'[{1,3728},{3,1864}]'),(9,323,'[{3,0,842859}]',1400,'[{90,1},{7,2},{2,3},{1,5}]',4759,121940,'[{1,3752},{3,1876}]'),(9,324,'[{3,0,854205}]',1405,'[{90,1},{7,2},{2,3},{1,5}]',4775,122720,'[{1,3776},{3,1888}]'),(9,325,'[{3,0,869085}]',1410,'[{90,1},{7,2},{2,3},{1,5}]',4792,123500,'[{1,3800},{3,1900}]'),(9,326,'[{3,0,883965}]',1415,'[{90,1},{7,2},{2,3},{1,5}]',4808,124280,'[{1,3824},{3,1912}]'),(9,327,'[{3,0,898846}]',1420,'[{90,1},{7,2},{2,3},{1,5}]',4825,125060,'[{1,3848},{3,1924}]'),(9,328,'[{3,0,913726}]',1424,'[{90,1},{7,2},{2,3},{1,5}]',4841,125840,'[{1,3872},{3,1936}]'),(9,329,'[{3,0,928606}]',1429,'[{90,1},{7,2},{2,3},{1,5}]',4857,126620,'[{1,3896},{3,1948}]'),(9,330,'[{3,0,943487}]',1434,'[{90,1},{7,2},{2,3},{1,5}]',4874,127400,'[{1,3920},{3,1960}]'),(9,331,'[{3,0,958367}]',1439,'[{90,1},{7,2},{2,3},{1,5}]',4890,128180,'[{1,3944},{3,1972}]'),(9,332,'[{3,0,973247}]',1444,'[{90,1},{7,2},{2,3},{1,5}]',4907,128960,'[{1,3968},{3,1984}]'),(9,333,'[{3,0,988128}]',1448,'[{90,1},{7,2},{2,3},{1,5}]',4923,129740,'[{1,3992},{3,1996}]'),(9,334,'[{3,0,1003008}]',1453,'[{90,1},{7,2},{2,3},{1,5}]',4940,130520,'[{1,4016},{3,2008}]'),(9,335,'[{3,0,1017888}]',1458,'[{90,1},{7,2},{2,3},{1,5}]',4956,131300,'[{1,4040},{3,2020}]'),(9,336,'[{3,0,1032768}]',1463,'[{90,1},{7,2},{2,3},{1,5}]',4973,132080,'[{1,4064},{3,2032}]'),(9,337,'[{3,0,1047649}]',1468,'[{90,1},{7,2},{2,3},{1,5}]',4990,132860,'[{1,4088},{3,2044}]'),(9,338,'[{3,0,1062529}]',1473,'[{90,1},{7,2},{2,3},{1,5}]',5006,133640,'[{1,4112},{3,2056}]'),(9,339,'[{3,0,1077409}]',1478,'[{90,1},{7,2},{2,3},{1,5}]',5023,134420,'[{1,4136},{3,2068}]'),(9,340,'[{3,0,1092290}]',1483,'[{90,1},{7,2},{2,3},{1,5}]',5039,135200,'[{1,4160},{3,2080}]'),(9,341,'[{3,0,1107170}]',1488,'[{90,1},{7,2},{2,3},{1,5}]',5056,135980,'[{1,4184},{3,2092}]'),(9,342,'[{3,0,1122050}]',1492,'[{90,1},{7,2},{2,3},{1,5}]',5072,136760,'[{1,4208},{3,2104}]'),(9,343,'[{3,0,1136930}]',1497,'[{90,1},{7,2},{2,3},{1,5}]',5089,137540,'[{1,4232},{3,2116}]'),(9,344,'[{3,0,1151811}]',1502,'[{90,1},{7,2},{2,3},{1,5}]',5105,138320,'[{1,4256},{3,2128}]'),(9,345,'[{3,0,1166691}]',1507,'[{90,1},{7,2},{2,3},{1,5}]',5122,139100,'[{1,4280},{3,2140}]'),(9,346,'[{3,0,1181571}]',1512,'[{90,1},{7,2},{2,3},{1,5}]',5139,139880,'[{1,4304},{3,2152}]'),(9,347,'[{3,0,1196452}]',1517,'[{90,1},{7,2},{2,3},{1,5}]',5155,140660,'[{1,4328},{3,2164}]'),(9,348,'[{3,0,1211332}]',1522,'[{90,1},{7,2},{2,3},{1,5}]',5172,141440,'[{1,4352},{3,2176}]'),(9,349,'[{3,0,1263370}]',1573,'[{90,1},{7,2},{2,3},{1,5}]',5188,142220,'[{1,4376},{3,2188}]'),(9,350,'[{3,0,1279417}]',1578,'[{90,1},{7,2},{2,3},{1,5}]',5205,143000,'[{1,4400},{3,2200}]'),(9,351,'[{3,0,1295463}]',1583,'[{90,1},{7,2},{2,3},{1,5}]',5222,143780,'[{1,4424},{3,2212}]'),(9,352,'[{3,0,1311509}]',1588,'[{90,1},{7,2},{2,3},{1,5}]',5238,144560,'[{1,4448},{3,2224}]'),(9,353,'[{3,0,1327556}]',1593,'[{90,1},{7,2},{2,3},{1,5}]',5255,145340,'[{1,4472},{3,2236}]'),(9,354,'[{3,0,1343602}]',1598,'[{90,1},{7,2},{2,3},{1,5}]',5272,146120,'[{1,4496},{3,2248}]'),(9,355,'[{3,0,1359648}]',1603,'[{90,1},{7,2},{2,3},{1,5}]',5288,146900,'[{1,4520},{3,2260}]'),(9,356,'[{3,0,1375695}]',1608,'[{90,1},{7,2},{2,3},{1,5}]',5305,147680,'[{1,4544},{3,2272}]'),(9,357,'[{3,0,1391741}]',1613,'[{90,1},{7,2},{2,3},{1,5}]',5322,148460,'[{1,4568},{3,2284}]'),(9,358,'[{3,0,1407787}]',1618,'[{90,1},{7,2},{2,3},{1,5}]',5338,149240,'[{1,4592},{3,2296}]'),(9,359,'[{3,0,1423834}]',1623,'[{90,1},{7,2},{2,3},{1,5}]',5355,150020,'[{1,4616},{3,2308}]'),(9,360,'[{3,0,1439880}]',1628,'[{90,1},{7,2},{2,3},{1,5}]',5372,150800,'[{1,4640},{3,2320}]'),(9,361,'[{3,0,1455927}]',1633,'[{90,1},{7,2},{2,3},{1,5}]',5388,151580,'[{1,4664},{3,2332}]'),(9,362,'[{3,0,1471973}]',1638,'[{90,1},{7,2},{2,3},{1,5}]',5405,152360,'[{1,4688},{3,2344}]'),(9,363,'[{3,0,1488019}]',1644,'[{90,1},{7,2},{2,3},{1,5}]',5422,153140,'[{1,4712},{3,2356}]'),(9,364,'[{3,0,1504066}]',1648,'[{90,1},{7,2},{2,3},{1,5}]',5438,153920,'[{1,4736},{3,2368}]'),(9,365,'[{3,0,1520112}]',1654,'[{90,1},{7,2},{2,3},{1,5}]',5455,154700,'[{1,4760},{3,2380}]'),(9,366,'[{3,0,1536158}]',1659,'[{90,1},{7,2},{2,3},{1,5}]',5472,155480,'[{1,4784},{3,2392}]'),(9,367,'[{3,0,1552205}]',1664,'[{90,1},{7,2},{2,3},{1,5}]',5489,156260,'[{1,4808},{3,2404}]'),(9,368,'[{3,0,1568251}]',1669,'[{90,1},{7,2},{2,3},{1,5}]',5505,157040,'[{1,4832},{3,2416}]'),(9,369,'[{3,0,1584297}]',1674,'[{90,1},{7,2},{2,3},{1,5}]',5522,157820,'[{1,4856},{3,2428}]'),(9,370,'[{3,0,1600344}]',1679,'[{90,1},{7,2},{2,3},{1,5}]',5539,158600,'[{1,4880},{3,2440}]'),(9,371,'[{3,0,1616390}]',1684,'[{90,1},{7,2},{2,3},{1,5}]',5556,159380,'[{1,4904},{3,2452}]'),(9,372,'[{3,0,1632437}]',1689,'[{90,1},{7,2},{2,3},{1,5}]',5572,160160,'[{1,4928},{3,2464}]'),(9,373,'[{3,0,1648483}]',1694,'[{90,1},{7,2},{2,3},{1,5}]',5589,160940,'[{1,4952},{3,2476}]'),(9,374,'[{3,0,1664530}]',1699,'[{90,1},{7,2},{2,3},{1,5}]',5606,161720,'[{1,4976},{3,2488}]'),(9,375,'[{3,0,1679756}]',1704,'[{90,1},{7,2},{2,3},{1,5}]',5623,162500,'[{1,5000},{3,2500}]'),(9,376,'[{3,0,1694982}]',1710,'[{90,1},{7,2},{2,3},{1,5}]',5640,163280,'[{1,5024},{3,2512}]'),(9,377,'[{3,0,1710209}]',1714,'[{90,1},{7,2},{2,3},{1,5}]',5656,164060,'[{1,5048},{3,2524}]'),(9,378,'[{3,0,1725435}]',1720,'[{90,1},{7,2},{2,3},{1,5}]',5673,164840,'[{1,5072},{3,2536}]'),(9,379,'[{3,0,1740661}]',1725,'[{90,1},{7,2},{2,3},{1,5}]',5690,165620,'[{1,5096},{3,2548}]'),(9,380,'[{3,0,1755888}]',1730,'[{90,1},{7,2},{2,3},{1,5}]',5707,166400,'[{1,5120},{3,2560}]'),(9,381,'[{3,0,1771114}]',1735,'[{90,1},{7,2},{2,3},{1,5}]',5724,167180,'[{1,5144},{3,2572}]'),(9,382,'[{3,0,1786340}]',1740,'[{90,1},{7,2},{2,3},{1,5}]',5740,167960,'[{1,5168},{3,2584}]'),(9,383,'[{3,0,1801567}]',1745,'[{90,1},{7,2},{2,3},{1,5}]',5757,168740,'[{1,5192},{3,2596}]'),(9,384,'[{3,0,1816793}]',1750,'[{90,1},{7,2},{2,3},{1,5}]',5774,169520,'[{1,5216},{3,2608}]'),(9,385,'[{3,0,1832020}]',1755,'[{90,1},{7,2},{2,3},{1,5}]',5791,170300,'[{1,5240},{3,2620}]'),(9,386,'[{3,0,1847246}]',1760,'[{90,1},{7,2},{2,3},{1,5}]',5808,171080,'[{1,5264},{3,2632}]'),(9,387,'[{3,0,1862472}]',1766,'[{90,1},{7,2},{2,3},{1,5}]',5825,171860,'[{1,5288},{3,2644}]'),(9,388,'[{3,0,1877699}]',1770,'[{90,1},{7,2},{2,3},{1,5}]',5841,172640,'[{1,5312},{3,2656}]'),(9,389,'[{3,0,1892925}]',1776,'[{90,1},{7,2},{2,3},{1,5}]',5858,173420,'[{1,5336},{3,2668}]'),(9,390,'[{3,0,1908151}]',1781,'[{90,1},{7,2},{2,3},{1,5}]',5875,174200,'[{1,5360},{3,2680}]'),(9,391,'[{3,0,1923378}]',1786,'[{90,1},{7,2},{2,3},{1,5}]',5892,174980,'[{1,5384},{3,2692}]'),(9,392,'[{3,0,1938604}]',1791,'[{90,1},{7,2},{2,3},{1,5}]',5909,175760,'[{1,5408},{3,2704}]'),(9,393,'[{3,0,1953830}]',1796,'[{90,1},{7,2},{2,3},{1,5}]',5926,176540,'[{1,5432},{3,2716}]'),(9,394,'[{3,0,1969057}]',1801,'[{90,1},{7,2},{2,3},{1,5}]',5943,177320,'[{1,5456},{3,2728}]'),(9,395,'[{3,0,1984283}]',1807,'[{90,1},{7,2},{2,3},{1,5}]',5960,178100,'[{1,5480},{3,2740}]'),(9,396,'[{3,0,1999510}]',1812,'[{90,1},{7,2},{2,3},{1,5}]',5977,178880,'[{1,5504},{3,2752}]'),(9,397,'[{3,0,2014736}]',1817,'[{90,1},{7,2},{2,3},{1,5}]',5993,179660,'[{1,5528},{3,2764}]'),(9,398,'[{3,0,2029962}]',1822,'[{90,1},{7,2},{2,3},{1,5}]',6010,180440,'[{1,5552},{3,2776}]'),(9,399,'[{3,0,2109102}]',1884,'[{90,1},{7,2},{2,3},{1,5}]',6027,181220,'[{1,5576},{3,2788}]'),(9,400,'[{3,0,2133037}]',1889,'[{90,1},{7,2},{2,3},{1,5}]',6044,182000,'[{1,5600},{3,2800}]'),(9,401,'[{3,0,2156972}]',1895,'[{90,1},{7,2},{2,3},{1,5}]',6061,183040,'[{1,5632},{3,2816}]'),(9,402,'[{3,0,2180907}]',1900,'[{90,1},{7,2},{2,3},{1,5}]',6078,184080,'[{1,5664},{3,2832}]'),(9,403,'[{3,0,2204842}]',1905,'[{90,1},{7,2},{2,3},{1,5}]',6095,185120,'[{1,5696},{3,2848}]'),(9,404,'[{3,0,2228777}]',1910,'[{90,1},{7,2},{2,3},{1,5}]',6112,186160,'[{1,5728},{3,2864}]'),(9,405,'[{3,0,2252712}]',1916,'[{90,1},{7,2},{2,3},{1,5}]',6129,187200,'[{1,5760},{3,2880}]'),(9,406,'[{3,0,2276647}]',1921,'[{90,1},{7,2},{2,3},{1,5}]',6146,188240,'[{1,5792},{3,2896}]'),(9,407,'[{3,0,2300582}]',1926,'[{90,1},{7,2},{2,3},{1,5}]',6163,189280,'[{1,5824},{3,2912}]'),(9,408,'[{3,0,2324517}]',1932,'[{90,1},{7,2},{2,3},{1,5}]',6180,190320,'[{1,5856},{3,2928}]'),(9,409,'[{3,0,2348452}]',1937,'[{90,1},{7,2},{2,3},{1,5}]',6197,191360,'[{1,5888},{3,2944}]'),(9,410,'[{3,0,2372387}]',1942,'[{90,1},{7,2},{2,3},{1,5}]',6214,192400,'[{1,5920},{3,2960}]'),(9,411,'[{3,0,2396322}]',1948,'[{90,1},{7,2},{2,3},{1,5}]',6231,193440,'[{1,5952},{3,2976}]'),(9,412,'[{3,0,2420257}]',1953,'[{90,1},{7,2},{2,3},{1,5}]',6248,194480,'[{1,5984},{3,2992}]'),(9,413,'[{3,0,2444192}]',1958,'[{90,1},{7,2},{2,3},{1,5}]',6265,195520,'[{1,6016},{3,3008}]'),(9,414,'[{3,0,2468127}]',1964,'[{90,1},{7,2},{2,3},{1,5}]',6282,196560,'[{1,6048},{3,3024}]'),(9,415,'[{3,0,2492062}]',1969,'[{90,1},{7,2},{2,3},{1,5}]',6299,197600,'[{1,6080},{3,3040}]'),(9,416,'[{3,0,2515997}]',1974,'[{90,1},{7,2},{2,3},{1,5}]',6316,198640,'[{1,6112},{3,3056}]'),(9,417,'[{3,0,2539932}]',1980,'[{90,1},{7,2},{2,3},{1,5}]',6333,199680,'[{1,6144},{3,3072}]'),(9,418,'[{3,0,2563867}]',1985,'[{90,1},{7,2},{2,3},{1,5}]',6350,200720,'[{1,6176},{3,3088}]'),(9,419,'[{3,0,2587802}]',1990,'[{90,1},{7,2},{2,3},{1,5}]',6367,201760,'[{1,6208},{3,3104}]'),(9,420,'[{3,0,2611737}]',1995,'[{90,1},{7,2},{2,3},{1,5}]',6384,202800,'[{1,6240},{3,3120}]'),(9,421,'[{3,0,2635672}]',2001,'[{90,1},{7,2},{2,3},{1,5}]',6401,203840,'[{1,6272},{3,3136}]'),(9,422,'[{3,0,2659607}]',2006,'[{90,1},{7,2},{2,3},{1,5}]',6418,204880,'[{1,6304},{3,3152}]'),(9,423,'[{3,0,2683542}]',2011,'[{90,1},{7,2},{2,3},{1,5}]',6435,205920,'[{1,6336},{3,3168}]'),(9,424,'[{3,0,2707479}]',2017,'[{90,1},{7,2},{2,3},{1,5}]',6452,206960,'[{1,6368},{3,3184}]'),(9,425,'[{3,0,2730859}]',2022,'[{90,1},{7,2},{2,3},{1,5}]',6470,208000,'[{1,6400},{3,3200}]'),(9,426,'[{3,0,2754239}]',2028,'[{90,1},{7,2},{2,3},{1,5}]',6487,209040,'[{1,6432},{3,3216}]'),(9,427,'[{3,0,2777618}]',2033,'[{90,1},{7,2},{2,3},{1,5}]',6504,210080,'[{1,6464},{3,3232}]'),(9,428,'[{3,0,2800998}]',2038,'[{90,1},{7,2},{2,3},{1,5}]',6521,211120,'[{1,6496},{3,3248}]'),(9,429,'[{3,0,2824378}]',2044,'[{90,1},{7,2},{2,3},{1,5}]',6538,212160,'[{1,6528},{3,3264}]'),(9,430,'[{3,0,2847757}]',2049,'[{90,1},{7,2},{2,3},{1,5}]',6555,213200,'[{1,6560},{3,3280}]'),(9,431,'[{3,0,2871137}]',2054,'[{90,1},{7,2},{2,3},{1,5}]',6572,214240,'[{1,6592},{3,3296}]'),(9,432,'[{3,0,2894517}]',2060,'[{90,1},{7,2},{2,3},{1,5}]',6589,215280,'[{1,6624},{3,3312}]'),(9,433,'[{3,0,2917896}]',2065,'[{90,1},{7,2},{2,3},{1,5}]',6606,216320,'[{1,6656},{3,3328}]'),(9,434,'[{3,0,2941276}]',2070,'[{90,1},{7,2},{2,3},{1,5}]',6624,217360,'[{1,6688},{3,3344}]'),(9,435,'[{3,0,2964656}]',2076,'[{90,1},{7,2},{2,3},{1,5}]',6641,218400,'[{1,6720},{3,3360}]'),(9,436,'[{3,0,2988035}]',2081,'[{90,1},{7,2},{2,3},{1,5}]',6658,219440,'[{1,6752},{3,3376}]'),(9,437,'[{3,0,3011415}]',2086,'[{90,1},{7,2},{2,3},{1,5}]',6675,220480,'[{1,6784},{3,3392}]'),(9,438,'[{3,0,3034795}]',2092,'[{90,1},{7,2},{2,3},{1,5}]',6692,221520,'[{1,6816},{3,3408}]'),(9,439,'[{3,0,3058175}]',2097,'[{90,1},{7,2},{2,3},{1,5}]',6709,222560,'[{1,6848},{3,3424}]'),(9,440,'[{3,0,3081554}]',2102,'[{90,1},{7,2},{2,3},{1,5}]',6726,223600,'[{1,6880},{3,3440}]'),(9,441,'[{3,0,3104934}]',2108,'[{90,1},{7,2},{2,3},{1,5}]',6744,224640,'[{1,6912},{3,3456}]'),(9,442,'[{3,0,3128314}]',2113,'[{90,1},{7,2},{2,3},{1,5}]',6761,225680,'[{1,6944},{3,3472}]'),(9,443,'[{3,0,3151693}]',2119,'[{90,1},{7,2},{2,3},{1,5}]',6778,226720,'[{1,6976},{3,3488}]'),(9,444,'[{3,0,3175073}]',2124,'[{90,1},{7,2},{2,3},{1,5}]',6795,227760,'[{1,7008},{3,3504}]'),(9,445,'[{3,0,3198453}]',2129,'[{90,1},{7,2},{2,3},{1,5}]',6812,228800,'[{1,7040},{3,3520}]'),(9,446,'[{3,0,3221832}]',2135,'[{90,1},{7,2},{2,3},{1,5}]',6830,229840,'[{1,7072},{3,3536}]'),(9,447,'[{3,0,3245212}]',2140,'[{90,1},{7,2},{2,3},{1,5}]',6847,230880,'[{1,7104},{3,3552}]'),(9,448,'[{3,0,3268592}]',2145,'[{90,1},{7,2},{2,3},{1,5}]',6864,231920,'[{1,7136},{3,3568}]'),(9,449,'[{3,0,3398166}]',2220,'[{90,1},{7,2},{2,3},{1,5}]',6881,232960,'[{1,7168},{3,3584}]'),(9,450,'[{3,0,3413589}]',2226,'[{90,1},{7,2},{2,3},{1,5}]',6898,234000,'[{1,7200},{3,3600}]'),(9,451,'[{3,0,3429011}]',2231,'[{90,1},{7,2},{2,3},{1,5}]',6916,235040,'[{1,7232},{3,3616}]'),(9,452,'[{3,0,3444434}]',2237,'[{90,1},{7,2},{2,3},{1,5}]',6933,236080,'[{1,7264},{3,3632}]'),(9,453,'[{3,0,3459856}]',2242,'[{90,1},{7,2},{2,3},{1,5}]',6950,237120,'[{1,7296},{3,3648}]'),(9,454,'[{3,0,3475279}]',2248,'[{90,1},{7,2},{2,3},{1,5}]',6967,238160,'[{1,7328},{3,3664}]'),(9,455,'[{3,0,3490701}]',2254,'[{90,1},{7,2},{2,3},{1,5}]',6985,239200,'[{1,7360},{3,3680}]'),(9,456,'[{3,0,3506124}]',2259,'[{90,1},{7,2},{2,3},{1,5}]',7002,240240,'[{1,7392},{3,3696}]'),(9,457,'[{3,0,3521547}]',2265,'[{90,1},{7,2},{2,3},{1,5}]',7019,241280,'[{1,7424},{3,3712}]'),(9,458,'[{3,0,3536969}]',2270,'[{90,1},{7,2},{2,3},{1,5}]',7036,242320,'[{1,7456},{3,3728}]'),(9,459,'[{3,0,3552392}]',2276,'[{90,1},{7,2},{2,3},{1,5}]',7054,243360,'[{1,7488},{3,3744}]'),(9,460,'[{3,0,3567814}]',2281,'[{90,1},{7,2},{2,3},{1,5}]',7071,244400,'[{1,7520},{3,3760}]'),(9,461,'[{3,0,3583237}]',2287,'[{90,1},{7,2},{2,3},{1,5}]',7088,245440,'[{1,7552},{3,3776}]'),(9,462,'[{3,0,3598660}]',2292,'[{90,1},{7,2},{2,3},{1,5}]',7105,246480,'[{1,7584},{3,3792}]'),(9,463,'[{3,0,3614082}]',2298,'[{90,1},{7,2},{2,3},{1,5}]',7123,247520,'[{1,7616},{3,3808}]'),(9,464,'[{3,0,3629505}]',2304,'[{90,1},{7,2},{2,3},{1,5}]',7140,248560,'[{1,7648},{3,3824}]'),(9,465,'[{3,0,3644927}]',2309,'[{90,1},{7,2},{2,3},{1,5}]',7157,249600,'[{1,7680},{3,3840}]'),(9,466,'[{3,0,3660350}]',2315,'[{90,1},{7,2},{2,3},{1,5}]',7175,250640,'[{1,7712},{3,3856}]'),(9,467,'[{3,0,3675772}]',2320,'[{90,1},{7,2},{2,3},{1,5}]',7192,251680,'[{1,7744},{3,3872}]'),(9,468,'[{3,0,3691195}]',2326,'[{90,1},{7,2},{2,3},{1,5}]',7209,252720,'[{1,7776},{3,3888}]'),(9,469,'[{3,0,3706618}]',2332,'[{90,1},{7,2},{2,3},{1,5}]',7227,253760,'[{1,7808},{3,3904}]'),(9,470,'[{3,0,3722040}]',2337,'[{90,1},{7,2},{2,3},{1,5}]',7244,254800,'[{1,7840},{3,3920}]'),(9,471,'[{3,0,3737463}]',2343,'[{90,1},{7,2},{2,3},{1,5}]',7261,255840,'[{1,7872},{3,3936}]'),(9,472,'[{3,0,3752885}]',2349,'[{90,1},{7,2},{2,3},{1,5}]',7279,256880,'[{1,7904},{3,3952}]'),(9,473,'[{3,0,3768308}]',2354,'[{90,1},{7,2},{2,3},{1,5}]',7296,257920,'[{1,7936},{3,3968}]'),(9,474,'[{3,0,3783732}]',2360,'[{90,1},{7,2},{2,3},{1,5}]',7313,258960,'[{1,7968},{3,3984}]'),(9,475,'[{3,0,3797544}]',2365,'[{90,1},{7,2},{2,3},{1,5}]',7331,260000,'[{1,8000},{3,4000}]'),(9,476,'[{3,0,3811356}]',2371,'[{90,1},{7,2},{2,3},{1,5}]',7348,261040,'[{1,8032},{3,4016}]'),(9,477,'[{3,0,3825168}]',2376,'[{90,1},{7,2},{2,3},{1,5}]',7365,262080,'[{1,8064},{3,4032}]'),(9,478,'[{3,0,3838980}]',2382,'[{90,1},{7,2},{2,3},{1,5}]',7383,263120,'[{1,8096},{3,4048}]'),(9,479,'[{3,0,3852791}]',2388,'[{90,1},{7,2},{2,3},{1,5}]',7400,264160,'[{1,8128},{3,4064}]'),(9,480,'[{3,0,3866603}]',2393,'[{90,1},{7,2},{2,3},{1,5}]',7417,265200,'[{1,8160},{3,4080}]'),(9,481,'[{3,0,3880415}]',2399,'[{90,1},{7,2},{2,3},{1,5}]',7435,266240,'[{1,8192},{3,4096}]'),(9,482,'[{3,0,3894227}]',2404,'[{90,1},{7,2},{2,3},{1,5}]',7452,267280,'[{1,8224},{3,4112}]'),(9,483,'[{3,0,3908039}]',2410,'[{90,1},{7,2},{2,3},{1,5}]',7470,268320,'[{1,8256},{3,4128}]'),(9,484,'[{3,0,3921851}]',2416,'[{90,1},{7,2},{2,3},{1,5}]',7487,269360,'[{1,8288},{3,4144}]'),(9,485,'[{3,0,3935663}]',2421,'[{90,1},{7,2},{2,3},{1,5}]',7504,270400,'[{1,8320},{3,4160}]'),(9,486,'[{3,0,3949475}]',2427,'[{90,1},{7,2},{2,3},{1,5}]',7522,271440,'[{1,8352},{3,4176}]'),(9,487,'[{3,0,3963287}]',2432,'[{90,1},{7,2},{2,3},{1,5}]',7539,272480,'[{1,8384},{3,4192}]'),(9,488,'[{3,0,3977099}]',2438,'[{90,1},{7,2},{2,3},{1,5}]',7557,273520,'[{1,8416},{3,4208}]'),(9,489,'[{3,0,3990911}]',2444,'[{90,1},{7,2},{2,3},{1,5}]',7574,274560,'[{1,8448},{3,4224}]'),(9,490,'[{3,0,4004723}]',2449,'[{90,1},{7,2},{2,3},{1,5}]',7591,275600,'[{1,8480},{3,4240}]'),(9,491,'[{3,0,4018535}]',2455,'[{90,1},{7,2},{2,3},{1,5}]',7609,276640,'[{1,8512},{3,4256}]'),(9,492,'[{3,0,4032347}]',2460,'[{90,1},{7,2},{2,3},{1,5}]',7626,277680,'[{1,8544},{3,4272}]'),(9,493,'[{3,0,4046159}]',2466,'[{90,1},{7,2},{2,3},{1,5}]',7644,278720,'[{1,8576},{3,4288}]'),(9,494,'[{3,0,4059970}]',2472,'[{90,1},{7,2},{2,3},{1,5}]',7661,279760,'[{1,8608},{3,4304}]'),(9,495,'[{3,0,4073782}]',2478,'[{90,1},{7,2},{2,3},{1,5}]',7679,280800,'[{1,8640},{3,4320}]'),(9,496,'[{3,0,4087594}]',2483,'[{90,1},{7,2},{2,3},{1,5}]',7696,281840,'[{1,8672},{3,4336}]'),(9,497,'[{3,0,4101406}]',2489,'[{90,1},{7,2},{2,3},{1,5}]',7714,282880,'[{1,8704},{3,4352}]'),(9,498,'[{3,0,4115218}]',2494,'[{90,1},{7,2},{2,3},{1,5}]',7731,283920,'[{1,8736},{3,4368}]'),(9,499,'[{3,0,4266667}]',2583,'[{90,1},{7,2},{2,3},{1,5}]',7749,284960,'[{1,8768},{3,4384}]'),(9,500,'[{3,0,0}]',0,'[{90,1},{7,2},{2,3},{1,5}]',0,286000,'[{1,8800},{3,4400}]'),(10,0,'[{3,0,668}]',15,'[{90,1},{7,2},{2,3},{1,5}]',58,0,'[{2,0},{4,0}]'),(10,1,'[{3,0,803}]',17,'[{90,1},{7,2},{2,3},{1,5}]',67,195,'[{2,120},{4,3}]'),(10,2,'[{3,0,937}]',19,'[{90,1},{7,2},{2,3},{1,5}]',76,390,'[{2,240},{4,6}]'),(10,3,'[{3,0,1071}]',22,'[{90,1},{7,2},{2,3},{1,5}]',86,585,'[{2,360},{4,9}]'),(10,4,'[{3,0,1205}]',24,'[{90,1},{7,2},{2,3},{1,5}]',96,780,'[{2,480},{4,12}]'),(10,5,'[{3,0,1340}]',27,'[{90,1},{7,2},{2,3},{1,5}]',106,975,'[{2,600},{4,15}]'),(10,6,'[{3,0,1474}]',29,'[{90,1},{7,2},{2,3},{1,5}]',116,1170,'[{2,720},{4,18}]'),(10,7,'[{3,0,1608}]',32,'[{90,1},{7,2},{2,3},{1,5}]',126,1365,'[{2,840},{4,21}]'),(10,8,'[{3,0,1742}]',35,'[{90,1},{7,2},{2,3},{1,5}]',137,1560,'[{2,960},{4,24}]'),(10,9,'[{3,0,1877}]',37,'[{90,1},{7,2},{2,3},{1,5}]',148,1755,'[{2,1080},{4,27}]'),(10,10,'[{3,0,2011}]',40,'[{90,1},{7,2},{2,3},{1,5}]',158,1950,'[{2,1200},{4,30}]'),(10,11,'[{3,0,2145}]',43,'[{90,1},{7,2},{2,3},{1,5}]',169,2145,'[{2,1320},{4,33}]'),(10,12,'[{3,0,2279}]',45,'[{90,1},{7,2},{2,3},{1,5}]',180,2340,'[{2,1440},{4,36}]'),(10,13,'[{3,0,2414}]',48,'[{90,1},{7,2},{2,3},{1,5}]',191,2535,'[{2,1560},{4,39}]'),(10,14,'[{3,0,2548}]',51,'[{90,1},{7,2},{2,3},{1,5}]',202,2730,'[{2,1680},{4,42}]'),(10,15,'[{3,0,2682}]',54,'[{90,1},{7,2},{2,3},{1,5}]',214,2925,'[{2,1800},{4,45}]'),(10,16,'[{3,0,2816}]',57,'[{90,1},{7,2},{2,3},{1,5}]',225,3120,'[{2,1920},{4,48}]'),(10,17,'[{3,0,2951}]',59,'[{90,1},{7,2},{2,3},{1,5}]',236,3315,'[{2,2040},{4,51}]'),(10,18,'[{3,0,3085}]',62,'[{90,1},{7,2},{2,3},{1,5}]',248,3510,'[{2,2160},{4,54}]'),(10,19,'[{3,0,3219}]',65,'[{90,1},{7,2},{2,3},{1,5}]',259,3705,'[{2,2280},{4,57}]'),(10,20,'[{3,0,3353}]',68,'[{90,1},{7,2},{2,3},{1,5}]',271,3900,'[{2,2400},{4,60}]'),(10,21,'[{3,0,3488}]',71,'[{90,1},{7,2},{2,3},{1,5}]',282,4095,'[{2,2520},{4,63}]'),(10,22,'[{3,0,3622}]',74,'[{90,1},{7,2},{2,3},{1,5}]',294,4290,'[{2,2640},{4,66}]'),(10,23,'[{3,0,3756}]',77,'[{90,1},{7,2},{2,3},{1,5}]',306,4485,'[{2,2760},{4,69}]'),(10,24,'[{3,0,3891}]',80,'[{90,1},{7,2},{2,3},{1,5}]',318,4680,'[{2,2880},{4,72}]'),(10,25,'[{3,0,4239}]',83,'[{90,1},{7,2},{2,3},{1,5}]',330,4875,'[{2,3000},{4,75}]'),(10,26,'[{3,0,4587}]',86,'[{90,1},{7,2},{2,3},{1,5}]',342,5070,'[{2,3120},{4,78}]'),(10,27,'[{3,0,4936}]',89,'[{90,1},{7,2},{2,3},{1,5}]',354,5265,'[{2,3240},{4,81}]'),(10,28,'[{3,0,5284}]',92,'[{90,1},{7,2},{2,3},{1,5}]',366,5460,'[{2,3360},{4,84}]'),(10,29,'[{3,0,5632}]',95,'[{90,1},{7,2},{2,3},{1,5}]',378,5655,'[{2,3480},{4,87}]'),(10,30,'[{3,0,5980}]',98,'[{90,1},{7,2},{2,3},{1,5}]',390,5850,'[{2,3600},{4,90}]'),(10,31,'[{3,0,6329}]',101,'[{90,1},{7,2},{2,3},{1,5}]',402,6045,'[{2,3720},{4,93}]'),(10,32,'[{3,0,6677}]',104,'[{90,1},{7,2},{2,3},{1,5}]',414,6240,'[{2,3840},{4,96}]'),(10,33,'[{3,0,7025}]',107,'[{90,1},{7,2},{2,3},{1,5}]',426,6435,'[{2,3960},{4,99}]'),(10,34,'[{3,0,7373}]',110,'[{90,1},{7,2},{2,3},{1,5}]',439,6630,'[{2,4080},{4,102}]'),(10,35,'[{3,0,7722}]',113,'[{90,1},{7,2},{2,3},{1,5}]',451,6825,'[{2,4200},{4,105}]'),(10,36,'[{3,0,8070}]',116,'[{90,1},{7,2},{2,3},{1,5}]',464,7020,'[{2,4320},{4,108}]'),(10,37,'[{3,0,8418}]',119,'[{90,1},{7,2},{2,3},{1,5}]',476,7215,'[{2,4440},{4,111}]'),(10,38,'[{3,0,8766}]',122,'[{90,1},{7,2},{2,3},{1,5}]',488,7410,'[{2,4560},{4,114}]'),(10,39,'[{3,0,9115}]',126,'[{90,1},{7,2},{2,3},{1,5}]',501,7605,'[{2,4680},{4,117}]'),(10,40,'[{3,0,9463}]',129,'[{90,1},{7,2},{2,3},{1,5}]',514,7800,'[{2,4800},{4,120}]'),(10,41,'[{3,0,9811}]',132,'[{90,1},{7,2},{2,3},{1,5}]',526,7995,'[{2,4920},{4,123}]'),(10,42,'[{3,0,10159}]',135,'[{90,1},{7,2},{2,3},{1,5}]',539,8190,'[{2,5040},{4,126}]'),(10,43,'[{3,0,10508}]',138,'[{90,1},{7,2},{2,3},{1,5}]',551,8385,'[{2,5160},{4,129}]'),(10,44,'[{3,0,10856}]',141,'[{90,1},{7,2},{2,3},{1,5}]',564,8580,'[{2,5280},{4,132}]'),(10,45,'[{3,0,11204}]',145,'[{90,1},{7,2},{2,3},{1,5}]',577,8775,'[{2,5400},{4,135}]'),(10,46,'[{3,0,11552}]',148,'[{90,1},{7,2},{2,3},{1,5}]',590,8970,'[{2,5520},{4,138}]'),(10,47,'[{3,0,11901}]',151,'[{90,1},{7,2},{2,3},{1,5}]',602,9165,'[{2,5640},{4,141}]'),(10,48,'[{3,0,12249}]',154,'[{90,1},{7,2},{2,3},{1,5}]',615,9360,'[{2,5760},{4,144}]'),(10,49,'[{3,0,12923}]',162,'[{90,1},{7,2},{2,3},{1,5}]',628,9555,'[{2,5880},{4,147}]'),(10,50,'[{3,0,13425}]',165,'[{90,1},{7,2},{2,3},{1,5}]',641,9750,'[{2,6000},{4,150}]'),(10,51,'[{3,0,13927}]',168,'[{90,1},{7,2},{2,3},{1,5}]',654,9945,'[{2,6120},{4,153}]'),(10,52,'[{3,0,14429}]',172,'[{90,1},{7,2},{2,3},{1,5}]',667,10140,'[{2,6240},{4,156}]'),(10,53,'[{3,0,14931}]',175,'[{90,1},{7,2},{2,3},{1,5}]',680,10335,'[{2,6360},{4,159}]'),(10,54,'[{3,0,15433}]',178,'[{90,1},{7,2},{2,3},{1,5}]',693,10530,'[{2,6480},{4,162}]'),(10,55,'[{3,0,15935}]',182,'[{90,1},{7,2},{2,3},{1,5}]',706,10725,'[{2,6600},{4,165}]'),(10,56,'[{3,0,16437}]',185,'[{90,1},{7,2},{2,3},{1,5}]',719,10920,'[{2,6720},{4,168}]'),(10,57,'[{3,0,16939}]',188,'[{90,1},{7,2},{2,3},{1,5}]',732,11115,'[{2,6840},{4,171}]'),(10,58,'[{3,0,17442}]',192,'[{90,1},{7,2},{2,3},{1,5}]',745,11310,'[{2,6960},{4,174}]'),(10,59,'[{3,0,17944}]',195,'[{90,1},{7,2},{2,3},{1,5}]',758,11505,'[{2,7080},{4,177}]'),(10,60,'[{3,0,18446}]',198,'[{90,1},{7,2},{2,3},{1,5}]',771,11700,'[{2,7200},{4,180}]'),(10,61,'[{3,0,18948}]',202,'[{90,1},{7,2},{2,3},{1,5}]',785,11895,'[{2,7320},{4,183}]'),(10,62,'[{3,0,19450}]',205,'[{90,1},{7,2},{2,3},{1,5}]',798,12090,'[{2,7440},{4,186}]'),(10,63,'[{3,0,19952}]',208,'[{90,1},{7,2},{2,3},{1,5}]',811,12285,'[{2,7560},{4,189}]'),(10,64,'[{3,0,20454}]',212,'[{90,1},{7,2},{2,3},{1,5}]',824,12480,'[{2,7680},{4,192}]'),(10,65,'[{3,0,20956}]',215,'[{90,1},{7,2},{2,3},{1,5}]',838,12675,'[{2,7800},{4,195}]'),(10,66,'[{3,0,21458}]',219,'[{90,1},{7,2},{2,3},{1,5}]',851,12870,'[{2,7920},{4,198}]'),(10,67,'[{3,0,21960}]',222,'[{90,1},{7,2},{2,3},{1,5}]',864,13065,'[{2,8040},{4,201}]'),(10,68,'[{3,0,22462}]',226,'[{90,1},{7,2},{2,3},{1,5}]',878,13260,'[{2,8160},{4,204}]'),(10,69,'[{3,0,22964}]',229,'[{90,1},{7,2},{2,3},{1,5}]',891,13455,'[{2,8280},{4,207}]'),(10,70,'[{3,0,23466}]',233,'[{90,1},{7,2},{2,3},{1,5}]',905,13650,'[{2,8400},{4,210}]'),(10,71,'[{3,0,23968}]',236,'[{90,1},{7,2},{2,3},{1,5}]',918,13845,'[{2,8520},{4,213}]'),(10,72,'[{3,0,24470}]',239,'[{90,1},{7,2},{2,3},{1,5}]',932,14040,'[{2,8640},{4,216}]'),(10,73,'[{3,0,24972}]',243,'[{90,1},{7,2},{2,3},{1,5}]',945,14235,'[{2,8760},{4,219}]'),(10,74,'[{3,0,25472}]',246,'[{90,1},{7,2},{2,3},{1,5}]',959,14430,'[{2,8880},{4,222}]'),(10,75,'[{3,0,25627}]',250,'[{90,1},{7,2},{2,3},{1,5}]',972,14625,'[{2,9000},{4,225}]'),(10,76,'[{3,0,25783}]',253,'[{90,1},{7,2},{2,3},{1,5}]',986,14820,'[{2,9120},{4,228}]'),(10,77,'[{3,0,25938}]',257,'[{90,1},{7,2},{2,3},{1,5}]',999,15015,'[{2,9240},{4,231}]'),(10,78,'[{3,0,26094}]',260,'[{90,1},{7,2},{2,3},{1,5}]',1013,15210,'[{2,9360},{4,234}]'),(10,79,'[{3,0,26249}]',264,'[{90,1},{7,2},{2,3},{1,5}]',1027,15405,'[{2,9480},{4,237}]'),(10,80,'[{3,0,26404}]',267,'[{90,1},{7,2},{2,3},{1,5}]',1040,15600,'[{2,9600},{4,240}]'),(10,81,'[{3,0,26560}]',271,'[{90,1},{7,2},{2,3},{1,5}]',1054,15795,'[{2,9720},{4,243}]'),(10,82,'[{3,0,26715}]',274,'[{90,1},{7,2},{2,3},{1,5}]',1068,15990,'[{2,9840},{4,246}]'),(10,83,'[{3,0,26870}]',278,'[{90,1},{7,2},{2,3},{1,5}]',1081,16185,'[{2,9960},{4,249}]'),(10,84,'[{3,0,27026}]',281,'[{90,1},{7,2},{2,3},{1,5}]',1095,16380,'[{2,10080},{4,252}]'),(10,85,'[{3,0,27181}]',285,'[{90,1},{7,2},{2,3},{1,5}]',1109,16575,'[{2,10200},{4,255}]'),(10,86,'[{3,0,27337}]',288,'[{90,1},{7,2},{2,3},{1,5}]',1123,16770,'[{2,10320},{4,258}]'),(10,87,'[{3,0,27492}]',292,'[{90,1},{7,2},{2,3},{1,5}]',1136,16965,'[{2,10440},{4,261}]'),(10,88,'[{3,0,27647}]',295,'[{90,1},{7,2},{2,3},{1,5}]',1150,17160,'[{2,10560},{4,264}]'),(10,89,'[{3,0,27803}]',299,'[{90,1},{7,2},{2,3},{1,5}]',1164,17355,'[{2,10680},{4,267}]'),(10,90,'[{3,0,27958}]',303,'[{90,1},{7,2},{2,3},{1,5}]',1178,17550,'[{2,10800},{4,270}]'),(10,91,'[{3,0,28114}]',306,'[{90,1},{7,2},{2,3},{1,5}]',1192,17745,'[{2,10920},{4,273}]'),(10,92,'[{3,0,28269}]',310,'[{90,1},{7,2},{2,3},{1,5}]',1206,17940,'[{2,11040},{4,276}]'),(10,93,'[{3,0,28424}]',313,'[{90,1},{7,2},{2,3},{1,5}]',1220,18135,'[{2,11160},{4,279}]'),(10,94,'[{3,0,28580}]',317,'[{90,1},{7,2},{2,3},{1,5}]',1234,18330,'[{2,11280},{4,282}]'),(10,95,'[{3,0,28735}]',320,'[{90,1},{7,2},{2,3},{1,5}]',1248,18525,'[{2,11400},{4,285}]'),(10,96,'[{3,0,28890}]',324,'[{90,1},{7,2},{2,3},{1,5}]',1262,18720,'[{2,11520},{4,288}]'),(10,97,'[{3,0,29046}]',328,'[{90,1},{7,2},{2,3},{1,5}]',1276,18915,'[{2,11640},{4,291}]'),(10,98,'[{3,0,29201}]',331,'[{90,1},{7,2},{2,3},{1,5}]',1290,19110,'[{2,11760},{4,294}]'),(10,99,'[{3,0,30126}]',344,'[{90,1},{7,2},{2,3},{1,5}]',1304,19305,'[{2,11880},{4,297}]'),(10,100,'[{3,0,30194}]',347,'[{90,1},{7,2},{2,3},{1,5}]',1318,19500,'[{2,12000},{4,300}]'),(10,101,'[{3,0,30263}]',351,'[{90,1},{7,2},{2,3},{1,5}]',1332,19825,'[{2,12200},{4,305}]'),(10,102,'[{3,0,30331}]',355,'[{90,1},{7,2},{2,3},{1,5}]',1346,20150,'[{2,12400},{4,310}]'),(10,103,'[{3,0,30400}]',358,'[{90,1},{7,2},{2,3},{1,5}]',1360,20475,'[{2,12600},{4,315}]'),(10,104,'[{3,0,30468}]',362,'[{90,1},{7,2},{2,3},{1,5}]',1374,20800,'[{2,12800},{4,320}]'),(10,105,'[{3,0,30537}]',366,'[{90,1},{7,2},{2,3},{1,5}]',1388,21125,'[{2,13000},{4,325}]'),(10,106,'[{3,0,30605}]',369,'[{90,1},{7,2},{2,3},{1,5}]',1402,21450,'[{2,13200},{4,330}]'),(10,107,'[{3,0,30673}]',373,'[{90,1},{7,2},{2,3},{1,5}]',1416,21775,'[{2,13400},{4,335}]'),(10,108,'[{3,0,30742}]',377,'[{90,1},{7,2},{2,3},{1,5}]',1431,22100,'[{2,13600},{4,340}]'),(10,109,'[{3,0,30810}]',381,'[{90,1},{7,2},{2,3},{1,5}]',1445,22425,'[{2,13800},{4,345}]'),(10,110,'[{3,0,30879}]',384,'[{90,1},{7,2},{2,3},{1,5}]',1459,22750,'[{2,14000},{4,350}]'),(10,111,'[{3,0,30947}]',388,'[{90,1},{7,2},{2,3},{1,5}]',1473,23075,'[{2,14200},{4,355}]'),(10,112,'[{3,0,31015}]',392,'[{90,1},{7,2},{2,3},{1,5}]',1488,23400,'[{2,14400},{4,360}]'),(10,113,'[{3,0,31084}]',396,'[{90,1},{7,2},{2,3},{1,5}]',1502,23725,'[{2,14600},{4,365}]'),(10,114,'[{3,0,31152}]',399,'[{90,1},{7,2},{2,3},{1,5}]',1516,24050,'[{2,14800},{4,370}]'),(10,115,'[{3,0,31221}]',403,'[{90,1},{7,2},{2,3},{1,5}]',1530,24375,'[{2,15000},{4,375}]'),(10,116,'[{3,0,31289}]',407,'[{90,1},{7,2},{2,3},{1,5}]',1545,24700,'[{2,15200},{4,380}]'),(10,117,'[{3,0,31358}]',411,'[{90,1},{7,2},{2,3},{1,5}]',1559,25025,'[{2,15400},{4,385}]'),(10,118,'[{3,0,31426}]',414,'[{90,1},{7,2},{2,3},{1,5}]',1573,25350,'[{2,15600},{4,390}]'),(10,119,'[{3,0,31494}]',418,'[{90,1},{7,2},{2,3},{1,5}]',1588,25675,'[{2,15800},{4,395}]'),(10,120,'[{3,0,31563}]',422,'[{90,1},{7,2},{2,3},{1,5}]',1602,26000,'[{2,16000},{4,400}]'),(10,121,'[{3,0,31631}]',426,'[{90,1},{7,2},{2,3},{1,5}]',1617,26325,'[{2,16200},{4,405}]'),(10,122,'[{3,0,31700}]',430,'[{90,1},{7,2},{2,3},{1,5}]',1631,26650,'[{2,16400},{4,410}]'),(10,123,'[{3,0,31768}]',434,'[{90,1},{7,2},{2,3},{1,5}]',1646,26975,'[{2,16600},{4,415}]'),(10,124,'[{3,0,31837}]',437,'[{90,1},{7,2},{2,3},{1,5}]',1660,27300,'[{2,16800},{4,420}]'),(10,125,'[{3,0,32159}]',441,'[{90,1},{7,2},{2,3},{1,5}]',1674,27625,'[{2,17000},{4,425}]'),(10,126,'[{3,0,32481}]',445,'[{90,1},{7,2},{2,3},{1,5}]',1689,27950,'[{2,17200},{4,430}]'),(10,127,'[{3,0,32803}]',449,'[{90,1},{7,2},{2,3},{1,5}]',1703,28275,'[{2,17400},{4,435}]'),(10,128,'[{3,0,33125}]',453,'[{90,1},{7,2},{2,3},{1,5}]',1718,28600,'[{2,17600},{4,440}]'),(10,129,'[{3,0,33447}]',456,'[{90,1},{7,2},{2,3},{1,5}]',1732,28925,'[{2,17800},{4,445}]'),(10,130,'[{3,0,33769}]',460,'[{90,1},{7,2},{2,3},{1,5}]',1747,29250,'[{2,18000},{4,450}]'),(10,131,'[{3,0,34091}]',464,'[{90,1},{7,2},{2,3},{1,5}]',1762,29575,'[{2,18200},{4,455}]'),(10,132,'[{3,0,34413}]',468,'[{90,1},{7,2},{2,3},{1,5}]',1776,29900,'[{2,18400},{4,460}]'),(10,133,'[{3,0,34735}]',472,'[{90,1},{7,2},{2,3},{1,5}]',1791,30225,'[{2,18600},{4,465}]'),(10,134,'[{3,0,35058}]',475,'[{90,1},{7,2},{2,3},{1,5}]',1805,30550,'[{2,18800},{4,470}]'),(10,135,'[{3,0,35380}]',479,'[{90,1},{7,2},{2,3},{1,5}]',1820,30875,'[{2,19000},{4,475}]'),(10,136,'[{3,0,35702}]',483,'[{90,1},{7,2},{2,3},{1,5}]',1834,31200,'[{2,19200},{4,480}]'),(10,137,'[{3,0,36024}]',487,'[{90,1},{7,2},{2,3},{1,5}]',1849,31525,'[{2,19400},{4,485}]'),(10,138,'[{3,0,36346}]',491,'[{90,1},{7,2},{2,3},{1,5}]',1864,31850,'[{2,19600},{4,490}]'),(10,139,'[{3,0,36668}]',495,'[{90,1},{7,2},{2,3},{1,5}]',1878,32175,'[{2,19800},{4,495}]'),(10,140,'[{3,0,36990}]',499,'[{90,1},{7,2},{2,3},{1,5}]',1893,32500,'[{2,20000},{4,500}]'),(10,141,'[{3,0,37312}]',503,'[{90,1},{7,2},{2,3},{1,5}]',1908,32825,'[{2,20200},{4,505}]'),(10,142,'[{3,0,37634}]',507,'[{90,1},{7,2},{2,3},{1,5}]',1923,33150,'[{2,20400},{4,510}]'),(10,143,'[{3,0,37957}]',510,'[{90,1},{7,2},{2,3},{1,5}]',1937,33475,'[{2,20600},{4,515}]'),(10,144,'[{3,0,38279}]',514,'[{90,1},{7,2},{2,3},{1,5}]',1952,33800,'[{2,20800},{4,520}]'),(10,145,'[{3,0,38601}]',518,'[{90,1},{7,2},{2,3},{1,5}]',1967,34125,'[{2,21000},{4,525}]'),(10,146,'[{3,0,38923}]',522,'[{90,1},{7,2},{2,3},{1,5}]',1981,34450,'[{2,21200},{4,530}]'),(10,147,'[{3,0,39245}]',526,'[{90,1},{7,2},{2,3},{1,5}]',1996,34775,'[{2,21400},{4,535}]'),(10,148,'[{3,0,39567}]',530,'[{90,1},{7,2},{2,3},{1,5}]',2011,35100,'[{2,21600},{4,540}]'),(10,149,'[{3,0,40965}]',548,'[{90,1},{7,2},{2,3},{1,5}]',2026,35425,'[{2,21800},{4,545}]'),(10,150,'[{3,0,41443}]',552,'[{90,1},{7,2},{2,3},{1,5}]',2041,35750,'[{2,22000},{4,550}]'),(10,151,'[{3,0,41922}]',556,'[{90,1},{7,2},{2,3},{1,5}]',2055,36075,'[{2,22200},{4,555}]'),(10,152,'[{3,0,42401}]',560,'[{90,1},{7,2},{2,3},{1,5}]',2070,36400,'[{2,22400},{4,560}]'),(10,153,'[{3,0,42879}]',564,'[{90,1},{7,2},{2,3},{1,5}]',2085,36725,'[{2,22600},{4,565}]'),(10,154,'[{3,0,43358}]',568,'[{90,1},{7,2},{2,3},{1,5}]',2100,37050,'[{2,22800},{4,570}]'),(10,155,'[{3,0,43837}]',572,'[{90,1},{7,2},{2,3},{1,5}]',2115,37375,'[{2,23000},{4,575}]'),(10,156,'[{3,0,44315}]',576,'[{90,1},{7,2},{2,3},{1,5}]',2130,37700,'[{2,23200},{4,580}]'),(10,157,'[{3,0,44794}]',580,'[{90,1},{7,2},{2,3},{1,5}]',2145,38025,'[{2,23400},{4,585}]'),(10,158,'[{3,0,45273}]',584,'[{90,1},{7,2},{2,3},{1,5}]',2160,38350,'[{2,23600},{4,590}]'),(10,159,'[{3,0,45751}]',588,'[{90,1},{7,2},{2,3},{1,5}]',2175,38675,'[{2,23800},{4,595}]'),(10,160,'[{3,0,46230}]',592,'[{90,1},{7,2},{2,3},{1,5}]',2189,39000,'[{2,24000},{4,600}]'),(10,161,'[{3,0,46709}]',596,'[{90,1},{7,2},{2,3},{1,5}]',2204,39325,'[{2,24200},{4,605}]'),(10,162,'[{3,0,47187}]',600,'[{90,1},{7,2},{2,3},{1,5}]',2219,39650,'[{2,24400},{4,610}]'),(10,163,'[{3,0,47666}]',604,'[{90,1},{7,2},{2,3},{1,5}]',2234,39975,'[{2,24600},{4,615}]'),(10,164,'[{3,0,48145}]',608,'[{90,1},{7,2},{2,3},{1,5}]',2249,40300,'[{2,24800},{4,620}]'),(10,165,'[{3,0,48623}]',612,'[{90,1},{7,2},{2,3},{1,5}]',2264,40625,'[{2,25000},{4,625}]'),(10,166,'[{3,0,49102}]',616,'[{90,1},{7,2},{2,3},{1,5}]',2279,40950,'[{2,25200},{4,630}]'),(10,167,'[{3,0,49580}]',620,'[{90,1},{7,2},{2,3},{1,5}]',2294,41275,'[{2,25400},{4,635}]'),(10,168,'[{3,0,50059}]',625,'[{90,1},{7,2},{2,3},{1,5}]',2309,41600,'[{2,25600},{4,640}]'),(10,169,'[{3,0,50538}]',629,'[{90,1},{7,2},{2,3},{1,5}]',2324,41925,'[{2,25800},{4,645}]'),(10,170,'[{3,0,51016}]',633,'[{90,1},{7,2},{2,3},{1,5}]',2340,42250,'[{2,26000},{4,650}]'),(10,171,'[{3,0,51495}]',637,'[{90,1},{7,2},{2,3},{1,5}]',2355,42575,'[{2,26200},{4,655}]'),(10,172,'[{3,0,51974}]',641,'[{90,1},{7,2},{2,3},{1,5}]',2370,42900,'[{2,26400},{4,660}]'),(10,173,'[{3,0,52452}]',645,'[{90,1},{7,2},{2,3},{1,5}]',2385,43225,'[{2,26600},{4,665}]'),(10,174,'[{3,0,52931}]',649,'[{90,1},{7,2},{2,3},{1,5}]',2400,43550,'[{2,26800},{4,670}]'),(10,175,'[{3,0,53077}]',653,'[{90,1},{7,2},{2,3},{1,5}]',2415,43875,'[{2,27000},{4,675}]'),(10,176,'[{3,0,53222}]',657,'[{90,1},{7,2},{2,3},{1,5}]',2430,44200,'[{2,27200},{4,680}]'),(10,177,'[{3,0,53368}]',661,'[{90,1},{7,2},{2,3},{1,5}]',2445,44525,'[{2,27400},{4,685}]'),(10,178,'[{3,0,53514}]',665,'[{90,1},{7,2},{2,3},{1,5}]',2460,44850,'[{2,27600},{4,690}]'),(10,179,'[{3,0,53659}]',670,'[{90,1},{7,2},{2,3},{1,5}]',2476,45175,'[{2,27800},{4,695}]'),(10,180,'[{3,0,53805}]',674,'[{90,1},{7,2},{2,3},{1,5}]',2491,45500,'[{2,28000},{4,700}]'),(10,181,'[{3,0,53951}]',678,'[{90,1},{7,2},{2,3},{1,5}]',2506,45825,'[{2,28200},{4,705}]'),(10,182,'[{3,0,54096}]',682,'[{90,1},{7,2},{2,3},{1,5}]',2521,46150,'[{2,28400},{4,710}]'),(10,183,'[{3,0,54242}]',686,'[{90,1},{7,2},{2,3},{1,5}]',2536,46475,'[{2,28600},{4,715}]'),(10,184,'[{3,0,54388}]',690,'[{90,1},{7,2},{2,3},{1,5}]',2552,46800,'[{2,28800},{4,720}]'),(10,185,'[{3,0,54533}]',694,'[{90,1},{7,2},{2,3},{1,5}]',2567,47125,'[{2,29000},{4,725}]'),(10,186,'[{3,0,54679}]',698,'[{90,1},{7,2},{2,3},{1,5}]',2582,47450,'[{2,29200},{4,730}]'),(10,187,'[{3,0,54825}]',702,'[{90,1},{7,2},{2,3},{1,5}]',2597,47775,'[{2,29400},{4,735}]'),(10,188,'[{3,0,54970}]',707,'[{90,1},{7,2},{2,3},{1,5}]',2613,48100,'[{2,29600},{4,740}]'),(10,189,'[{3,0,55116}]',711,'[{90,1},{7,2},{2,3},{1,5}]',2628,48425,'[{2,29800},{4,745}]'),(10,190,'[{3,0,55262}]',715,'[{90,1},{7,2},{2,3},{1,5}]',2643,48750,'[{2,30000},{4,750}]'),(10,191,'[{3,0,55408}]',719,'[{90,1},{7,2},{2,3},{1,5}]',2658,49075,'[{2,30200},{4,755}]'),(10,192,'[{3,0,55553}]',723,'[{90,1},{7,2},{2,3},{1,5}]',2674,49400,'[{2,30400},{4,760}]'),(10,193,'[{3,0,55699}]',727,'[{90,1},{7,2},{2,3},{1,5}]',2689,49725,'[{2,30600},{4,765}]'),(10,194,'[{3,0,55845}]',731,'[{90,1},{7,2},{2,3},{1,5}]',2704,50050,'[{2,30800},{4,770}]'),(10,195,'[{3,0,55990}]',736,'[{90,1},{7,2},{2,3},{1,5}]',2720,50375,'[{2,31000},{4,775}]'),(10,196,'[{3,0,56136}]',740,'[{90,1},{7,2},{2,3},{1,5}]',2735,50700,'[{2,31200},{4,780}]'),(10,197,'[{3,0,56282}]',744,'[{90,1},{7,2},{2,3},{1,5}]',2750,51025,'[{2,31400},{4,785}]'),(10,198,'[{3,0,56427}]',748,'[{90,1},{7,2},{2,3},{1,5}]',2766,51350,'[{2,31600},{4,790}]'),(10,199,'[{3,0,58145}]',773,'[{90,1},{7,2},{2,3},{1,5}]',2781,51675,'[{2,31800},{4,795}]'),(10,200,'[{3,0,58298}]',777,'[{90,1},{7,2},{2,3},{1,5}]',2797,52000,'[{2,32000},{4,800}]'),(10,201,'[{3,0,58451}]',782,'[{90,1},{7,2},{2,3},{1,5}]',2812,52520,'[{2,32320},{4,808}]'),(10,202,'[{3,0,58604}]',786,'[{90,1},{7,2},{2,3},{1,5}]',2827,53040,'[{2,32640},{4,816}]'),(10,203,'[{3,0,58757}]',790,'[{90,1},{7,2},{2,3},{1,5}]',2843,53560,'[{2,32960},{4,824}]'),(10,204,'[{3,0,58910}]',794,'[{90,1},{7,2},{2,3},{1,5}]',2858,54080,'[{2,33280},{4,832}]'),(10,205,'[{3,0,59063}]',799,'[{90,1},{7,2},{2,3},{1,5}]',2874,54600,'[{2,33600},{4,840}]'),(10,206,'[{3,0,59216}]',803,'[{90,1},{7,2},{2,3},{1,5}]',2889,55120,'[{2,33920},{4,848}]'),(10,207,'[{3,0,59369}]',807,'[{90,1},{7,2},{2,3},{1,5}]',2905,55640,'[{2,34240},{4,856}]'),(10,208,'[{3,0,59522}]',812,'[{90,1},{7,2},{2,3},{1,5}]',2920,56160,'[{2,34560},{4,864}]'),(10,209,'[{3,0,59675}]',816,'[{90,1},{7,2},{2,3},{1,5}]',2936,56680,'[{2,34880},{4,872}]'),(10,210,'[{3,0,59828}]',820,'[{90,1},{7,2},{2,3},{1,5}]',2951,57200,'[{2,35200},{4,880}]'),(10,211,'[{3,0,59981}]',825,'[{90,1},{7,2},{2,3},{1,5}]',2967,57720,'[{2,35520},{4,888}]'),(10,212,'[{3,0,60134}]',829,'[{90,1},{7,2},{2,3},{1,5}]',2982,58240,'[{2,35840},{4,896}]'),(10,213,'[{3,0,60287}]',833,'[{90,1},{7,2},{2,3},{1,5}]',2998,58760,'[{2,36160},{4,904}]'),(10,214,'[{3,0,60440}]',837,'[{90,1},{7,2},{2,3},{1,5}]',3013,59280,'[{2,36480},{4,912}]'),(10,215,'[{3,0,60594}]',842,'[{90,1},{7,2},{2,3},{1,5}]',3029,59800,'[{2,36800},{4,920}]'),(10,216,'[{3,0,60747}]',846,'[{90,1},{7,2},{2,3},{1,5}]',3044,60320,'[{2,37120},{4,928}]'),(10,217,'[{3,0,60900}]',850,'[{90,1},{7,2},{2,3},{1,5}]',3060,60840,'[{2,37440},{4,936}]'),(10,218,'[{3,0,61053}]',855,'[{90,1},{7,2},{2,3},{1,5}]',3075,61360,'[{2,37760},{4,944}]'),(10,219,'[{3,0,61206}]',859,'[{90,1},{7,2},{2,3},{1,5}]',3091,61880,'[{2,38080},{4,952}]'),(10,220,'[{3,0,61359}]',864,'[{90,1},{7,2},{2,3},{1,5}]',3107,62400,'[{2,38400},{4,960}]'),(10,221,'[{3,0,61512}]',868,'[{90,1},{7,2},{2,3},{1,5}]',3122,62920,'[{2,38720},{4,968}]'),(10,222,'[{3,0,61665}]',872,'[{90,1},{7,2},{2,3},{1,5}]',3138,63440,'[{2,39040},{4,976}]'),(10,223,'[{3,0,61818}]',876,'[{90,1},{7,2},{2,3},{1,5}]',3153,63960,'[{2,39360},{4,984}]'),(10,224,'[{3,0,61974}]',881,'[{90,1},{7,2},{2,3},{1,5}]',3169,64480,'[{2,39680},{4,992}]'),(10,225,'[{3,0,68137}]',885,'[{90,1},{7,2},{2,3},{1,5}]',3185,65000,'[{2,40000},{4,1000}]'),(10,226,'[{3,0,74299}]',889,'[{90,1},{7,2},{2,3},{1,5}]',3200,65520,'[{2,40320},{4,1008}]'),(10,227,'[{3,0,80461}]',894,'[{90,1},{7,2},{2,3},{1,5}]',3216,66040,'[{2,40640},{4,1016}]'),(10,228,'[{3,0,86623}]',898,'[{90,1},{7,2},{2,3},{1,5}]',3232,66560,'[{2,40960},{4,1024}]'),(10,229,'[{3,0,92785}]',902,'[{90,1},{7,2},{2,3},{1,5}]',3247,67080,'[{2,41280},{4,1032}]'),(10,230,'[{3,0,98948}]',907,'[{90,1},{7,2},{2,3},{1,5}]',3263,67600,'[{2,41600},{4,1040}]'),(10,231,'[{3,0,105110}]',911,'[{90,1},{7,2},{2,3},{1,5}]',3279,68120,'[{2,41920},{4,1048}]'),(10,232,'[{3,0,111272}]',915,'[{90,1},{7,2},{2,3},{1,5}]',3294,68640,'[{2,42240},{4,1056}]'),(10,233,'[{3,0,117434}]',920,'[{90,1},{7,2},{2,3},{1,5}]',3310,69160,'[{2,42560},{4,1064}]'),(10,234,'[{3,0,123597}]',924,'[{90,1},{7,2},{2,3},{1,5}]',3326,69680,'[{2,42880},{4,1072}]'),(10,235,'[{3,0,129759}]',929,'[{90,1},{7,2},{2,3},{1,5}]',3342,70200,'[{2,43200},{4,1080}]'),(10,236,'[{3,0,135921}]',933,'[{90,1},{7,2},{2,3},{1,5}]',3357,70720,'[{2,43520},{4,1088}]'),(10,237,'[{3,0,142083}]',937,'[{90,1},{7,2},{2,3},{1,5}]',3373,71240,'[{2,43840},{4,1096}]'),(10,238,'[{3,0,148245}]',942,'[{90,1},{7,2},{2,3},{1,5}]',3389,71760,'[{2,44160},{4,1104}]'),(10,239,'[{3,0,154408}]',946,'[{90,1},{7,2},{2,3},{1,5}]',3405,72280,'[{2,44480},{4,1112}]'),(10,240,'[{3,0,160570}]',950,'[{90,1},{7,2},{2,3},{1,5}]',3420,72800,'[{2,44800},{4,1120}]'),(10,241,'[{3,0,166732}]',955,'[{90,1},{7,2},{2,3},{1,5}]',3436,73320,'[{2,45120},{4,1128}]'),(10,242,'[{3,0,172894}]',959,'[{90,1},{7,2},{2,3},{1,5}]',3452,73840,'[{2,45440},{4,1136}]'),(10,243,'[{3,0,179057}]',964,'[{90,1},{7,2},{2,3},{1,5}]',3468,74360,'[{2,45760},{4,1144}]'),(10,244,'[{3,0,185219}]',968,'[{90,1},{7,2},{2,3},{1,5}]',3484,74880,'[{2,46080},{4,1152}]'),(10,245,'[{3,0,191381}]',972,'[{90,1},{7,2},{2,3},{1,5}]',3499,75400,'[{2,46400},{4,1160}]'),(10,246,'[{3,0,197543}]',977,'[{90,1},{7,2},{2,3},{1,5}]',3515,75920,'[{2,46720},{4,1168}]'),(10,247,'[{3,0,203705}]',981,'[{90,1},{7,2},{2,3},{1,5}]',3531,76440,'[{2,47040},{4,1176}]'),(10,248,'[{3,0,209868}]',986,'[{90,1},{7,2},{2,3},{1,5}]',3547,76960,'[{2,47360},{4,1184}]'),(10,249,'[{3,0,222203}]',1018,'[{90,1},{7,2},{2,3},{1,5}]',3563,77480,'[{2,47680},{4,1192}]'),(10,250,'[{3,0,228297}]',1023,'[{90,1},{7,2},{2,3},{1,5}]',3579,78000,'[{2,48000},{4,1200}]'),(10,251,'[{3,0,234391}]',1028,'[{90,1},{7,2},{2,3},{1,5}]',3595,78520,'[{2,48320},{4,1208}]'),(10,252,'[{3,0,240485}]',1032,'[{90,1},{7,2},{2,3},{1,5}]',3610,79040,'[{2,48640},{4,1216}]'),(10,253,'[{3,0,246579}]',1036,'[{90,1},{7,2},{2,3},{1,5}]',3626,79560,'[{2,48960},{4,1224}]'),(10,254,'[{3,0,252673}]',1041,'[{90,1},{7,2},{2,3},{1,5}]',3642,80080,'[{2,49280},{4,1232}]'),(10,255,'[{3,0,258767}]',1046,'[{90,1},{7,2},{2,3},{1,5}]',3658,80600,'[{2,49600},{4,1240}]'),(10,256,'[{3,0,264861}]',1050,'[{90,1},{7,2},{2,3},{1,5}]',3674,81120,'[{2,49920},{4,1248}]'),(10,257,'[{3,0,270955}]',1055,'[{90,1},{7,2},{2,3},{1,5}]',3690,81640,'[{2,50240},{4,1256}]'),(10,258,'[{3,0,277049}]',1059,'[{90,1},{7,2},{2,3},{1,5}]',3706,82160,'[{2,50560},{4,1264}]'),(10,259,'[{3,0,283143}]',1064,'[{90,1},{7,2},{2,3},{1,5}]',3722,82680,'[{2,50880},{4,1272}]'),(10,260,'[{3,0,289237}]',1068,'[{90,1},{7,2},{2,3},{1,5}]',3738,83200,'[{2,51200},{4,1280}]'),(10,261,'[{3,0,295331}]',1073,'[{90,1},{7,2},{2,3},{1,5}]',3754,83720,'[{2,51520},{4,1288}]'),(10,262,'[{3,0,301425}]',1078,'[{90,1},{7,2},{2,3},{1,5}]',3770,84240,'[{2,51840},{4,1296}]'),(10,263,'[{3,0,307519}]',1082,'[{90,1},{7,2},{2,3},{1,5}]',3786,84760,'[{2,52160},{4,1304}]'),(10,264,'[{3,0,313613}]',1087,'[{90,1},{7,2},{2,3},{1,5}]',3802,85280,'[{2,52480},{4,1312}]'),(10,265,'[{3,0,319707}]',1091,'[{90,1},{7,2},{2,3},{1,5}]',3818,85800,'[{2,52800},{4,1320}]'),(10,266,'[{3,0,325801}]',1096,'[{90,1},{7,2},{2,3},{1,5}]',3834,86320,'[{2,53120},{4,1328}]'),(10,267,'[{3,0,331895}]',1100,'[{90,1},{7,2},{2,3},{1,5}]',3850,86840,'[{2,53440},{4,1336}]'),(10,268,'[{3,0,337989}]',1105,'[{90,1},{7,2},{2,3},{1,5}]',3866,87360,'[{2,53760},{4,1344}]'),(10,269,'[{3,0,344083}]',1110,'[{90,1},{7,2},{2,3},{1,5}]',3882,87880,'[{2,54080},{4,1352}]'),(10,270,'[{3,0,350177}]',1114,'[{90,1},{7,2},{2,3},{1,5}]',3898,88400,'[{2,54400},{4,1360}]'),(10,271,'[{3,0,356271}]',1119,'[{90,1},{7,2},{2,3},{1,5}]',3914,88920,'[{2,54720},{4,1368}]'),(10,272,'[{3,0,362365}]',1123,'[{90,1},{7,2},{2,3},{1,5}]',3930,89440,'[{2,55040},{4,1376}]'),(10,273,'[{3,0,368459}]',1128,'[{90,1},{7,2},{2,3},{1,5}]',3946,89960,'[{2,55360},{4,1384}]'),(10,274,'[{3,0,374550}]',1132,'[{90,1},{7,2},{2,3},{1,5}]',3962,90480,'[{2,55680},{4,1392}]'),(10,275,'[{3,0,381734}]',1137,'[{90,1},{7,2},{2,3},{1,5}]',3978,91000,'[{2,56000},{4,1400}]'),(10,276,'[{3,0,388919}]',1142,'[{90,1},{7,2},{2,3},{1,5}]',3994,91520,'[{2,56320},{4,1408}]'),(10,277,'[{3,0,396104}]',1146,'[{90,1},{7,2},{2,3},{1,5}]',4010,92040,'[{2,56640},{4,1416}]'),(10,278,'[{3,0,403288}]',1151,'[{90,1},{7,2},{2,3},{1,5}]',4026,92560,'[{2,56960},{4,1424}]'),(10,279,'[{3,0,410473}]',1155,'[{90,1},{7,2},{2,3},{1,5}]',4042,93080,'[{2,57280},{4,1432}]'),(10,280,'[{3,0,417657}]',1160,'[{90,1},{7,2},{2,3},{1,5}]',4059,93600,'[{2,57600},{4,1440}]'),(10,281,'[{3,0,424842}]',1165,'[{90,1},{7,2},{2,3},{1,5}]',4075,94120,'[{2,57920},{4,1448}]'),(10,282,'[{3,0,432026}]',1169,'[{90,1},{7,2},{2,3},{1,5}]',4091,94640,'[{2,58240},{4,1456}]'),(10,283,'[{3,0,439211}]',1174,'[{90,1},{7,2},{2,3},{1,5}]',4107,95160,'[{2,58560},{4,1464}]'),(10,284,'[{3,0,446396}]',1178,'[{90,1},{7,2},{2,3},{1,5}]',4123,95680,'[{2,58880},{4,1472}]'),(10,285,'[{3,0,453580}]',1183,'[{90,1},{7,2},{2,3},{1,5}]',4139,96200,'[{2,59200},{4,1480}]'),(10,286,'[{3,0,460765}]',1188,'[{90,1},{7,2},{2,3},{1,5}]',4155,96720,'[{2,59520},{4,1488}]'),(10,287,'[{3,0,467949}]',1192,'[{90,1},{7,2},{2,3},{1,5}]',4172,97240,'[{2,59840},{4,1496}]'),(10,288,'[{3,0,475134}]',1197,'[{90,1},{7,2},{2,3},{1,5}]',4188,97760,'[{2,60160},{4,1504}]'),(10,289,'[{3,0,482318}]',1202,'[{90,1},{7,2},{2,3},{1,5}]',4204,98280,'[{2,60480},{4,1512}]'),(10,290,'[{3,0,489503}]',1206,'[{90,1},{7,2},{2,3},{1,5}]',4220,98800,'[{2,60800},{4,1520}]'),(10,291,'[{3,0,496688}]',1211,'[{90,1},{7,2},{2,3},{1,5}]',4236,99320,'[{2,61120},{4,1528}]'),(10,292,'[{3,0,503872}]',1216,'[{90,1},{7,2},{2,3},{1,5}]',4253,99840,'[{2,61440},{4,1536}]'),(10,293,'[{3,0,511057}]',1220,'[{90,1},{7,2},{2,3},{1,5}]',4269,100360,'[{2,61760},{4,1544}]'),(10,294,'[{3,0,518241}]',1225,'[{90,1},{7,2},{2,3},{1,5}]',4285,100880,'[{2,62080},{4,1552}]'),(10,295,'[{3,0,525426}]',1229,'[{90,1},{7,2},{2,3},{1,5}]',4301,101400,'[{2,62400},{4,1560}]'),(10,296,'[{3,0,532610}]',1234,'[{90,1},{7,2},{2,3},{1,5}]',4317,101920,'[{2,62720},{4,1568}]'),(10,297,'[{3,0,539795}]',1239,'[{90,1},{7,2},{2,3},{1,5}]',4334,102440,'[{2,63040},{4,1576}]'),(10,298,'[{3,0,546980}]',1243,'[{90,1},{7,2},{2,3},{1,5}]',4350,102960,'[{2,63360},{4,1584}]'),(10,299,'[{3,0,570466}]',1285,'[{90,1},{7,2},{2,3},{1,5}]',4366,103480,'[{2,63680},{4,1592}]'),(10,300,'[{3,0,581815}]',1289,'[{90,1},{7,2},{2,3},{1,5}]',4382,104000,'[{2,64000},{4,1600}]'),(10,301,'[{3,0,593165}]',1294,'[{90,1},{7,2},{2,3},{1,5}]',4399,104780,'[{2,64480},{4,1612}]'),(10,302,'[{3,0,604515}]',1299,'[{90,1},{7,2},{2,3},{1,5}]',4415,105560,'[{2,64960},{4,1624}]'),(10,303,'[{3,0,615865}]',1304,'[{90,1},{7,2},{2,3},{1,5}]',4431,106340,'[{2,65440},{4,1636}]'),(10,304,'[{3,0,627214}]',1309,'[{90,1},{7,2},{2,3},{1,5}]',4448,107120,'[{2,65920},{4,1648}]'),(10,305,'[{3,0,638564}]',1313,'[{90,1},{7,2},{2,3},{1,5}]',4464,107900,'[{2,66400},{4,1660}]'),(10,306,'[{3,0,649914}]',1318,'[{90,1},{7,2},{2,3},{1,5}]',4480,108680,'[{2,66880},{4,1672}]'),(10,307,'[{3,0,661263}]',1323,'[{90,1},{7,2},{2,3},{1,5}]',4497,109460,'[{2,67360},{4,1684}]'),(10,308,'[{3,0,672613}]',1328,'[{90,1},{7,2},{2,3},{1,5}]',4513,110240,'[{2,67840},{4,1696}]'),(10,309,'[{3,0,683963}]',1333,'[{90,1},{7,2},{2,3},{1,5}]',4529,111020,'[{2,68320},{4,1708}]'),(10,310,'[{3,0,695313}]',1338,'[{90,1},{7,2},{2,3},{1,5}]',4546,111800,'[{2,68800},{4,1720}]'),(10,311,'[{3,0,706662}]',1342,'[{90,1},{7,2},{2,3},{1,5}]',4562,112580,'[{2,69280},{4,1732}]'),(10,312,'[{3,0,718012}]',1347,'[{90,1},{7,2},{2,3},{1,5}]',4578,113360,'[{2,69760},{4,1744}]'),(10,313,'[{3,0,729362}]',1352,'[{90,1},{7,2},{2,3},{1,5}]',4595,114140,'[{2,70240},{4,1756}]'),(10,314,'[{3,0,740711}]',1357,'[{90,1},{7,2},{2,3},{1,5}]',4611,114920,'[{2,70720},{4,1768}]'),(10,315,'[{3,0,752061}]',1361,'[{90,1},{7,2},{2,3},{1,5}]',4627,115700,'[{2,71200},{4,1780}]'),(10,316,'[{3,0,763411}]',1366,'[{90,1},{7,2},{2,3},{1,5}]',4644,116480,'[{2,71680},{4,1792}]'),(10,317,'[{3,0,774760}]',1371,'[{90,1},{7,2},{2,3},{1,5}]',4660,117260,'[{2,72160},{4,1804}]'),(10,318,'[{3,0,786110}]',1376,'[{90,1},{7,2},{2,3},{1,5}]',4677,118040,'[{2,72640},{4,1816}]'),(10,319,'[{3,0,797460}]',1381,'[{90,1},{7,2},{2,3},{1,5}]',4693,118820,'[{2,73120},{4,1828}]'),(10,320,'[{3,0,808810}]',1385,'[{90,1},{7,2},{2,3},{1,5}]',4709,119600,'[{2,73600},{4,1840}]'),(10,321,'[{3,0,820159}]',1390,'[{90,1},{7,2},{2,3},{1,5}]',4726,120380,'[{2,74080},{4,1852}]'),(10,322,'[{3,0,831509}]',1395,'[{90,1},{7,2},{2,3},{1,5}]',4742,121160,'[{2,74560},{4,1864}]'),(10,323,'[{3,0,842859}]',1400,'[{90,1},{7,2},{2,3},{1,5}]',4759,121940,'[{2,75040},{4,1876}]'),(10,324,'[{3,0,854205}]',1405,'[{90,1},{7,2},{2,3},{1,5}]',4775,122720,'[{2,75520},{4,1888}]'),(10,325,'[{3,0,869085}]',1410,'[{90,1},{7,2},{2,3},{1,5}]',4792,123500,'[{2,76000},{4,1900}]'),(10,326,'[{3,0,883965}]',1415,'[{90,1},{7,2},{2,3},{1,5}]',4808,124280,'[{2,76480},{4,1912}]'),(10,327,'[{3,0,898846}]',1420,'[{90,1},{7,2},{2,3},{1,5}]',4825,125060,'[{2,76960},{4,1924}]'),(10,328,'[{3,0,913726}]',1424,'[{90,1},{7,2},{2,3},{1,5}]',4841,125840,'[{2,77440},{4,1936}]'),(10,329,'[{3,0,928606}]',1429,'[{90,1},{7,2},{2,3},{1,5}]',4857,126620,'[{2,77920},{4,1948}]'),(10,330,'[{3,0,943487}]',1434,'[{90,1},{7,2},{2,3},{1,5}]',4874,127400,'[{2,78400},{4,1960}]'),(10,331,'[{3,0,958367}]',1439,'[{90,1},{7,2},{2,3},{1,5}]',4890,128180,'[{2,78880},{4,1972}]'),(10,332,'[{3,0,973247}]',1444,'[{90,1},{7,2},{2,3},{1,5}]',4907,128960,'[{2,79360},{4,1984}]'),(10,333,'[{3,0,988128}]',1448,'[{90,1},{7,2},{2,3},{1,5}]',4923,129740,'[{2,79840},{4,1996}]'),(10,334,'[{3,0,1003008}]',1453,'[{90,1},{7,2},{2,3},{1,5}]',4940,130520,'[{2,80320},{4,2008}]'),(10,335,'[{3,0,1017888}]',1458,'[{90,1},{7,2},{2,3},{1,5}]',4956,131300,'[{2,80800},{4,2020}]'),(10,336,'[{3,0,1032768}]',1463,'[{90,1},{7,2},{2,3},{1,5}]',4973,132080,'[{2,81280},{4,2032}]'),(10,337,'[{3,0,1047649}]',1468,'[{90,1},{7,2},{2,3},{1,5}]',4990,132860,'[{2,81760},{4,2044}]'),(10,338,'[{3,0,1062529}]',1473,'[{90,1},{7,2},{2,3},{1,5}]',5006,133640,'[{2,82240},{4,2056}]'),(10,339,'[{3,0,1077409}]',1478,'[{90,1},{7,2},{2,3},{1,5}]',5023,134420,'[{2,82720},{4,2068}]'),(10,340,'[{3,0,1092290}]',1483,'[{90,1},{7,2},{2,3},{1,5}]',5039,135200,'[{2,83200},{4,2080}]'),(10,341,'[{3,0,1107170}]',1488,'[{90,1},{7,2},{2,3},{1,5}]',5056,135980,'[{2,83680},{4,2092}]'),(10,342,'[{3,0,1122050}]',1492,'[{90,1},{7,2},{2,3},{1,5}]',5072,136760,'[{2,84160},{4,2104}]'),(10,343,'[{3,0,1136930}]',1497,'[{90,1},{7,2},{2,3},{1,5}]',5089,137540,'[{2,84640},{4,2116}]'),(10,344,'[{3,0,1151811}]',1502,'[{90,1},{7,2},{2,3},{1,5}]',5105,138320,'[{2,85120},{4,2128}]'),(10,345,'[{3,0,1166691}]',1507,'[{90,1},{7,2},{2,3},{1,5}]',5122,139100,'[{2,85600},{4,2140}]'),(10,346,'[{3,0,1181571}]',1512,'[{90,1},{7,2},{2,3},{1,5}]',5139,139880,'[{2,86080},{4,2152}]'),(10,347,'[{3,0,1196452}]',1517,'[{90,1},{7,2},{2,3},{1,5}]',5155,140660,'[{2,86560},{4,2164}]'),(10,348,'[{3,0,1211332}]',1522,'[{90,1},{7,2},{2,3},{1,5}]',5172,141440,'[{2,87040},{4,2176}]'),(10,349,'[{3,0,1263370}]',1573,'[{90,1},{7,2},{2,3},{1,5}]',5188,142220,'[{2,87520},{4,2188}]'),(10,350,'[{3,0,1279417}]',1578,'[{90,1},{7,2},{2,3},{1,5}]',5205,143000,'[{2,88000},{4,2200}]'),(10,351,'[{3,0,1295463}]',1583,'[{90,1},{7,2},{2,3},{1,5}]',5222,143780,'[{2,88480},{4,2212}]'),(10,352,'[{3,0,1311509}]',1588,'[{90,1},{7,2},{2,3},{1,5}]',5238,144560,'[{2,88960},{4,2224}]'),(10,353,'[{3,0,1327556}]',1593,'[{90,1},{7,2},{2,3},{1,5}]',5255,145340,'[{2,89440},{4,2236}]'),(10,354,'[{3,0,1343602}]',1598,'[{90,1},{7,2},{2,3},{1,5}]',5272,146120,'[{2,89920},{4,2248}]'),(10,355,'[{3,0,1359648}]',1603,'[{90,1},{7,2},{2,3},{1,5}]',5288,146900,'[{2,90400},{4,2260}]'),(10,356,'[{3,0,1375695}]',1608,'[{90,1},{7,2},{2,3},{1,5}]',5305,147680,'[{2,90880},{4,2272}]'),(10,357,'[{3,0,1391741}]',1613,'[{90,1},{7,2},{2,3},{1,5}]',5322,148460,'[{2,91360},{4,2284}]'),(10,358,'[{3,0,1407787}]',1618,'[{90,1},{7,2},{2,3},{1,5}]',5338,149240,'[{2,91840},{4,2296}]'),(10,359,'[{3,0,1423834}]',1623,'[{90,1},{7,2},{2,3},{1,5}]',5355,150020,'[{2,92320},{4,2308}]'),(10,360,'[{3,0,1439880}]',1628,'[{90,1},{7,2},{2,3},{1,5}]',5372,150800,'[{2,92800},{4,2320}]'),(10,361,'[{3,0,1455927}]',1633,'[{90,1},{7,2},{2,3},{1,5}]',5388,151580,'[{2,93280},{4,2332}]'),(10,362,'[{3,0,1471973}]',1638,'[{90,1},{7,2},{2,3},{1,5}]',5405,152360,'[{2,93760},{4,2344}]'),(10,363,'[{3,0,1488019}]',1644,'[{90,1},{7,2},{2,3},{1,5}]',5422,153140,'[{2,94240},{4,2356}]'),(10,364,'[{3,0,1504066}]',1648,'[{90,1},{7,2},{2,3},{1,5}]',5438,153920,'[{2,94720},{4,2368}]'),(10,365,'[{3,0,1520112}]',1654,'[{90,1},{7,2},{2,3},{1,5}]',5455,154700,'[{2,95200},{4,2380}]'),(10,366,'[{3,0,1536158}]',1659,'[{90,1},{7,2},{2,3},{1,5}]',5472,155480,'[{2,95680},{4,2392}]'),(10,367,'[{3,0,1552205}]',1664,'[{90,1},{7,2},{2,3},{1,5}]',5489,156260,'[{2,96160},{4,2404}]'),(10,368,'[{3,0,1568251}]',1669,'[{90,1},{7,2},{2,3},{1,5}]',5505,157040,'[{2,96640},{4,2416}]'),(10,369,'[{3,0,1584297}]',1674,'[{90,1},{7,2},{2,3},{1,5}]',5522,157820,'[{2,97120},{4,2428}]'),(10,370,'[{3,0,1600344}]',1679,'[{90,1},{7,2},{2,3},{1,5}]',5539,158600,'[{2,97600},{4,2440}]'),(10,371,'[{3,0,1616390}]',1684,'[{90,1},{7,2},{2,3},{1,5}]',5556,159380,'[{2,98080},{4,2452}]'),(10,372,'[{3,0,1632437}]',1689,'[{90,1},{7,2},{2,3},{1,5}]',5572,160160,'[{2,98560},{4,2464}]'),(10,373,'[{3,0,1648483}]',1694,'[{90,1},{7,2},{2,3},{1,5}]',5589,160940,'[{2,99040},{4,2476}]'),(10,374,'[{3,0,1664530}]',1699,'[{90,1},{7,2},{2,3},{1,5}]',5606,161720,'[{2,99520},{4,2488}]'),(10,375,'[{3,0,1679756}]',1704,'[{90,1},{7,2},{2,3},{1,5}]',5623,162500,'[{2,100000},{4,2500}]'),(10,376,'[{3,0,1694982}]',1710,'[{90,1},{7,2},{2,3},{1,5}]',5640,163280,'[{2,100480},{4,2512}]'),(10,377,'[{3,0,1710209}]',1714,'[{90,1},{7,2},{2,3},{1,5}]',5656,164060,'[{2,100960},{4,2524}]'),(10,378,'[{3,0,1725435}]',1720,'[{90,1},{7,2},{2,3},{1,5}]',5673,164840,'[{2,101440},{4,2536}]'),(10,379,'[{3,0,1740661}]',1725,'[{90,1},{7,2},{2,3},{1,5}]',5690,165620,'[{2,101920},{4,2548}]'),(10,380,'[{3,0,1755888}]',1730,'[{90,1},{7,2},{2,3},{1,5}]',5707,166400,'[{2,102400},{4,2560}]'),(10,381,'[{3,0,1771114}]',1735,'[{90,1},{7,2},{2,3},{1,5}]',5724,167180,'[{2,102880},{4,2572}]'),(10,382,'[{3,0,1786340}]',1740,'[{90,1},{7,2},{2,3},{1,5}]',5740,167960,'[{2,103360},{4,2584}]'),(10,383,'[{3,0,1801567}]',1745,'[{90,1},{7,2},{2,3},{1,5}]',5757,168740,'[{2,103840},{4,2596}]'),(10,384,'[{3,0,1816793}]',1750,'[{90,1},{7,2},{2,3},{1,5}]',5774,169520,'[{2,104320},{4,2608}]'),(10,385,'[{3,0,1832020}]',1755,'[{90,1},{7,2},{2,3},{1,5}]',5791,170300,'[{2,104800},{4,2620}]'),(10,386,'[{3,0,1847246}]',1760,'[{90,1},{7,2},{2,3},{1,5}]',5808,171080,'[{2,105280},{4,2632}]'),(10,387,'[{3,0,1862472}]',1766,'[{90,1},{7,2},{2,3},{1,5}]',5825,171860,'[{2,105760},{4,2644}]'),(10,388,'[{3,0,1877699}]',1770,'[{90,1},{7,2},{2,3},{1,5}]',5841,172640,'[{2,106240},{4,2656}]'),(10,389,'[{3,0,1892925}]',1776,'[{90,1},{7,2},{2,3},{1,5}]',5858,173420,'[{2,106720},{4,2668}]'),(10,390,'[{3,0,1908151}]',1781,'[{90,1},{7,2},{2,3},{1,5}]',5875,174200,'[{2,107200},{4,2680}]'),(10,391,'[{3,0,1923378}]',1786,'[{90,1},{7,2},{2,3},{1,5}]',5892,174980,'[{2,107680},{4,2692}]'),(10,392,'[{3,0,1938604}]',1791,'[{90,1},{7,2},{2,3},{1,5}]',5909,175760,'[{2,108160},{4,2704}]'),(10,393,'[{3,0,1953830}]',1796,'[{90,1},{7,2},{2,3},{1,5}]',5926,176540,'[{2,108640},{4,2716}]'),(10,394,'[{3,0,1969057}]',1801,'[{90,1},{7,2},{2,3},{1,5}]',5943,177320,'[{2,109120},{4,2728}]'),(10,395,'[{3,0,1984283}]',1807,'[{90,1},{7,2},{2,3},{1,5}]',5960,178100,'[{2,109600},{4,2740}]'),(10,396,'[{3,0,1999510}]',1812,'[{90,1},{7,2},{2,3},{1,5}]',5977,178880,'[{2,110080},{4,2752}]'),(10,397,'[{3,0,2014736}]',1817,'[{90,1},{7,2},{2,3},{1,5}]',5993,179660,'[{2,110560},{4,2764}]'),(10,398,'[{3,0,2029962}]',1822,'[{90,1},{7,2},{2,3},{1,5}]',6010,180440,'[{2,111040},{4,2776}]'),(10,399,'[{3,0,2109102}]',1884,'[{90,1},{7,2},{2,3},{1,5}]',6027,181220,'[{2,111520},{4,2788}]'),(10,400,'[{3,0,2133037}]',1889,'[{90,1},{7,2},{2,3},{1,5}]',6044,182000,'[{2,112000},{4,2800}]'),(10,401,'[{3,0,2156972}]',1895,'[{90,1},{7,2},{2,3},{1,5}]',6061,183040,'[{2,112640},{4,2816}]'),(10,402,'[{3,0,2180907}]',1900,'[{90,1},{7,2},{2,3},{1,5}]',6078,184080,'[{2,113280},{4,2832}]'),(10,403,'[{3,0,2204842}]',1905,'[{90,1},{7,2},{2,3},{1,5}]',6095,185120,'[{2,113920},{4,2848}]'),(10,404,'[{3,0,2228777}]',1910,'[{90,1},{7,2},{2,3},{1,5}]',6112,186160,'[{2,114560},{4,2864}]'),(10,405,'[{3,0,2252712}]',1916,'[{90,1},{7,2},{2,3},{1,5}]',6129,187200,'[{2,115200},{4,2880}]'),(10,406,'[{3,0,2276647}]',1921,'[{90,1},{7,2},{2,3},{1,5}]',6146,188240,'[{2,115840},{4,2896}]'),(10,407,'[{3,0,2300582}]',1926,'[{90,1},{7,2},{2,3},{1,5}]',6163,189280,'[{2,116480},{4,2912}]'),(10,408,'[{3,0,2324517}]',1932,'[{90,1},{7,2},{2,3},{1,5}]',6180,190320,'[{2,117120},{4,2928}]'),(10,409,'[{3,0,2348452}]',1937,'[{90,1},{7,2},{2,3},{1,5}]',6197,191360,'[{2,117760},{4,2944}]'),(10,410,'[{3,0,2372387}]',1942,'[{90,1},{7,2},{2,3},{1,5}]',6214,192400,'[{2,118400},{4,2960}]'),(10,411,'[{3,0,2396322}]',1948,'[{90,1},{7,2},{2,3},{1,5}]',6231,193440,'[{2,119040},{4,2976}]'),(10,412,'[{3,0,2420257}]',1953,'[{90,1},{7,2},{2,3},{1,5}]',6248,194480,'[{2,119680},{4,2992}]'),(10,413,'[{3,0,2444192}]',1958,'[{90,1},{7,2},{2,3},{1,5}]',6265,195520,'[{2,120320},{4,3008}]'),(10,414,'[{3,0,2468127}]',1964,'[{90,1},{7,2},{2,3},{1,5}]',6282,196560,'[{2,120960},{4,3024}]'),(10,415,'[{3,0,2492062}]',1969,'[{90,1},{7,2},{2,3},{1,5}]',6299,197600,'[{2,121600},{4,3040}]'),(10,416,'[{3,0,2515997}]',1974,'[{90,1},{7,2},{2,3},{1,5}]',6316,198640,'[{2,122240},{4,3056}]'),(10,417,'[{3,0,2539932}]',1980,'[{90,1},{7,2},{2,3},{1,5}]',6333,199680,'[{2,122880},{4,3072}]'),(10,418,'[{3,0,2563867}]',1985,'[{90,1},{7,2},{2,3},{1,5}]',6350,200720,'[{2,123520},{4,3088}]'),(10,419,'[{3,0,2587802}]',1990,'[{90,1},{7,2},{2,3},{1,5}]',6367,201760,'[{2,124160},{4,3104}]'),(10,420,'[{3,0,2611737}]',1995,'[{90,1},{7,2},{2,3},{1,5}]',6384,202800,'[{2,124800},{4,3120}]'),(10,421,'[{3,0,2635672}]',2001,'[{90,1},{7,2},{2,3},{1,5}]',6401,203840,'[{2,125440},{4,3136}]'),(10,422,'[{3,0,2659607}]',2006,'[{90,1},{7,2},{2,3},{1,5}]',6418,204880,'[{2,126080},{4,3152}]'),(10,423,'[{3,0,2683542}]',2011,'[{90,1},{7,2},{2,3},{1,5}]',6435,205920,'[{2,126720},{4,3168}]'),(10,424,'[{3,0,2707479}]',2017,'[{90,1},{7,2},{2,3},{1,5}]',6452,206960,'[{2,127360},{4,3184}]'),(10,425,'[{3,0,2730859}]',2022,'[{90,1},{7,2},{2,3},{1,5}]',6470,208000,'[{2,128000},{4,3200}]'),(10,426,'[{3,0,2754239}]',2028,'[{90,1},{7,2},{2,3},{1,5}]',6487,209040,'[{2,128640},{4,3216}]'),(10,427,'[{3,0,2777618}]',2033,'[{90,1},{7,2},{2,3},{1,5}]',6504,210080,'[{2,129280},{4,3232}]'),(10,428,'[{3,0,2800998}]',2038,'[{90,1},{7,2},{2,3},{1,5}]',6521,211120,'[{2,129920},{4,3248}]'),(10,429,'[{3,0,2824378}]',2044,'[{90,1},{7,2},{2,3},{1,5}]',6538,212160,'[{2,130560},{4,3264}]'),(10,430,'[{3,0,2847757}]',2049,'[{90,1},{7,2},{2,3},{1,5}]',6555,213200,'[{2,131200},{4,3280}]'),(10,431,'[{3,0,2871137}]',2054,'[{90,1},{7,2},{2,3},{1,5}]',6572,214240,'[{2,131840},{4,3296}]'),(10,432,'[{3,0,2894517}]',2060,'[{90,1},{7,2},{2,3},{1,5}]',6589,215280,'[{2,132480},{4,3312}]'),(10,433,'[{3,0,2917896}]',2065,'[{90,1},{7,2},{2,3},{1,5}]',6606,216320,'[{2,133120},{4,3328}]'),(10,434,'[{3,0,2941276}]',2070,'[{90,1},{7,2},{2,3},{1,5}]',6624,217360,'[{2,133760},{4,3344}]'),(10,435,'[{3,0,2964656}]',2076,'[{90,1},{7,2},{2,3},{1,5}]',6641,218400,'[{2,134400},{4,3360}]'),(10,436,'[{3,0,2988035}]',2081,'[{90,1},{7,2},{2,3},{1,5}]',6658,219440,'[{2,135040},{4,3376}]'),(10,437,'[{3,0,3011415}]',2086,'[{90,1},{7,2},{2,3},{1,5}]',6675,220480,'[{2,135680},{4,3392}]'),(10,438,'[{3,0,3034795}]',2092,'[{90,1},{7,2},{2,3},{1,5}]',6692,221520,'[{2,136320},{4,3408}]'),(10,439,'[{3,0,3058175}]',2097,'[{90,1},{7,2},{2,3},{1,5}]',6709,222560,'[{2,136960},{4,3424}]'),(10,440,'[{3,0,3081554}]',2102,'[{90,1},{7,2},{2,3},{1,5}]',6726,223600,'[{2,137600},{4,3440}]'),(10,441,'[{3,0,3104934}]',2108,'[{90,1},{7,2},{2,3},{1,5}]',6744,224640,'[{2,138240},{4,3456}]'),(10,442,'[{3,0,3128314}]',2113,'[{90,1},{7,2},{2,3},{1,5}]',6761,225680,'[{2,138880},{4,3472}]'),(10,443,'[{3,0,3151693}]',2119,'[{90,1},{7,2},{2,3},{1,5}]',6778,226720,'[{2,139520},{4,3488}]'),(10,444,'[{3,0,3175073}]',2124,'[{90,1},{7,2},{2,3},{1,5}]',6795,227760,'[{2,140160},{4,3504}]'),(10,445,'[{3,0,3198453}]',2129,'[{90,1},{7,2},{2,3},{1,5}]',6812,228800,'[{2,140800},{4,3520}]'),(10,446,'[{3,0,3221832}]',2135,'[{90,1},{7,2},{2,3},{1,5}]',6830,229840,'[{2,141440},{4,3536}]'),(10,447,'[{3,0,3245212}]',2140,'[{90,1},{7,2},{2,3},{1,5}]',6847,230880,'[{2,142080},{4,3552}]'),(10,448,'[{3,0,3268592}]',2145,'[{90,1},{7,2},{2,3},{1,5}]',6864,231920,'[{2,142720},{4,3568}]'),(10,449,'[{3,0,3398166}]',2220,'[{90,1},{7,2},{2,3},{1,5}]',6881,232960,'[{2,143360},{4,3584}]'),(10,450,'[{3,0,3413589}]',2226,'[{90,1},{7,2},{2,3},{1,5}]',6898,234000,'[{2,144000},{4,3600}]'),(10,451,'[{3,0,3429011}]',2231,'[{90,1},{7,2},{2,3},{1,5}]',6916,235040,'[{2,144640},{4,3616}]'),(10,452,'[{3,0,3444434}]',2237,'[{90,1},{7,2},{2,3},{1,5}]',6933,236080,'[{2,145280},{4,3632}]'),(10,453,'[{3,0,3459856}]',2242,'[{90,1},{7,2},{2,3},{1,5}]',6950,237120,'[{2,145920},{4,3648}]'),(10,454,'[{3,0,3475279}]',2248,'[{90,1},{7,2},{2,3},{1,5}]',6967,238160,'[{2,146560},{4,3664}]'),(10,455,'[{3,0,3490701}]',2254,'[{90,1},{7,2},{2,3},{1,5}]',6985,239200,'[{2,147200},{4,3680}]'),(10,456,'[{3,0,3506124}]',2259,'[{90,1},{7,2},{2,3},{1,5}]',7002,240240,'[{2,147840},{4,3696}]'),(10,457,'[{3,0,3521547}]',2265,'[{90,1},{7,2},{2,3},{1,5}]',7019,241280,'[{2,148480},{4,3712}]'),(10,458,'[{3,0,3536969}]',2270,'[{90,1},{7,2},{2,3},{1,5}]',7036,242320,'[{2,149120},{4,3728}]'),(10,459,'[{3,0,3552392}]',2276,'[{90,1},{7,2},{2,3},{1,5}]',7054,243360,'[{2,149760},{4,3744}]'),(10,460,'[{3,0,3567814}]',2281,'[{90,1},{7,2},{2,3},{1,5}]',7071,244400,'[{2,150400},{4,3760}]'),(10,461,'[{3,0,3583237}]',2287,'[{90,1},{7,2},{2,3},{1,5}]',7088,245440,'[{2,151040},{4,3776}]'),(10,462,'[{3,0,3598660}]',2292,'[{90,1},{7,2},{2,3},{1,5}]',7105,246480,'[{2,151680},{4,3792}]'),(10,463,'[{3,0,3614082}]',2298,'[{90,1},{7,2},{2,3},{1,5}]',7123,247520,'[{2,152320},{4,3808}]'),(10,464,'[{3,0,3629505}]',2304,'[{90,1},{7,2},{2,3},{1,5}]',7140,248560,'[{2,152960},{4,3824}]'),(10,465,'[{3,0,3644927}]',2309,'[{90,1},{7,2},{2,3},{1,5}]',7157,249600,'[{2,153600},{4,3840}]'),(10,466,'[{3,0,3660350}]',2315,'[{90,1},{7,2},{2,3},{1,5}]',7175,250640,'[{2,154240},{4,3856}]'),(10,467,'[{3,0,3675772}]',2320,'[{90,1},{7,2},{2,3},{1,5}]',7192,251680,'[{2,154880},{4,3872}]'),(10,468,'[{3,0,3691195}]',2326,'[{90,1},{7,2},{2,3},{1,5}]',7209,252720,'[{2,155520},{4,3888}]'),(10,469,'[{3,0,3706618}]',2332,'[{90,1},{7,2},{2,3},{1,5}]',7227,253760,'[{2,156160},{4,3904}]'),(10,470,'[{3,0,3722040}]',2337,'[{90,1},{7,2},{2,3},{1,5}]',7244,254800,'[{2,156800},{4,3920}]'),(10,471,'[{3,0,3737463}]',2343,'[{90,1},{7,2},{2,3},{1,5}]',7261,255840,'[{2,157440},{4,3936}]'),(10,472,'[{3,0,3752885}]',2349,'[{90,1},{7,2},{2,3},{1,5}]',7279,256880,'[{2,158080},{4,3952}]'),(10,473,'[{3,0,3768308}]',2354,'[{90,1},{7,2},{2,3},{1,5}]',7296,257920,'[{2,158720},{4,3968}]'),(10,474,'[{3,0,3783732}]',2360,'[{90,1},{7,2},{2,3},{1,5}]',7313,258960,'[{2,159360},{4,3984}]'),(10,475,'[{3,0,3797544}]',2365,'[{90,1},{7,2},{2,3},{1,5}]',7331,260000,'[{2,160000},{4,4000}]'),(10,476,'[{3,0,3811356}]',2371,'[{90,1},{7,2},{2,3},{1,5}]',7348,261040,'[{2,160640},{4,4016}]'),(10,477,'[{3,0,3825168}]',2376,'[{90,1},{7,2},{2,3},{1,5}]',7365,262080,'[{2,161280},{4,4032}]'),(10,478,'[{3,0,3838980}]',2382,'[{90,1},{7,2},{2,3},{1,5}]',7383,263120,'[{2,161920},{4,4048}]'),(10,479,'[{3,0,3852791}]',2388,'[{90,1},{7,2},{2,3},{1,5}]',7400,264160,'[{2,162560},{4,4064}]'),(10,480,'[{3,0,3866603}]',2393,'[{90,1},{7,2},{2,3},{1,5}]',7417,265200,'[{2,163200},{4,4080}]'),(10,481,'[{3,0,3880415}]',2399,'[{90,1},{7,2},{2,3},{1,5}]',7435,266240,'[{2,163840},{4,4096}]'),(10,482,'[{3,0,3894227}]',2404,'[{90,1},{7,2},{2,3},{1,5}]',7452,267280,'[{2,164480},{4,4112}]'),(10,483,'[{3,0,3908039}]',2410,'[{90,1},{7,2},{2,3},{1,5}]',7470,268320,'[{2,165120},{4,4128}]'),(10,484,'[{3,0,3921851}]',2416,'[{90,1},{7,2},{2,3},{1,5}]',7487,269360,'[{2,165760},{4,4144}]'),(10,485,'[{3,0,3935663}]',2421,'[{90,1},{7,2},{2,3},{1,5}]',7504,270400,'[{2,166400},{4,4160}]'),(10,486,'[{3,0,3949475}]',2427,'[{90,1},{7,2},{2,3},{1,5}]',7522,271440,'[{2,167040},{4,4176}]'),(10,487,'[{3,0,3963287}]',2432,'[{90,1},{7,2},{2,3},{1,5}]',7539,272480,'[{2,167680},{4,4192}]'),(10,488,'[{3,0,3977099}]',2438,'[{90,1},{7,2},{2,3},{1,5}]',7557,273520,'[{2,168320},{4,4208}]'),(10,489,'[{3,0,3990911}]',2444,'[{90,1},{7,2},{2,3},{1,5}]',7574,274560,'[{2,168960},{4,4224}]'),(10,490,'[{3,0,4004723}]',2449,'[{90,1},{7,2},{2,3},{1,5}]',7591,275600,'[{2,169600},{4,4240}]'),(10,491,'[{3,0,4018535}]',2455,'[{90,1},{7,2},{2,3},{1,5}]',7609,276640,'[{2,170240},{4,4256}]'),(10,492,'[{3,0,4032347}]',2460,'[{90,1},{7,2},{2,3},{1,5}]',7626,277680,'[{2,170880},{4,4272}]'),(10,493,'[{3,0,4046159}]',2466,'[{90,1},{7,2},{2,3},{1,5}]',7644,278720,'[{2,171520},{4,4288}]'),(10,494,'[{3,0,4059970}]',2472,'[{90,1},{7,2},{2,3},{1,5}]',7661,279760,'[{2,172160},{4,4304}]'),(10,495,'[{3,0,4073782}]',2478,'[{90,1},{7,2},{2,3},{1,5}]',7679,280800,'[{2,172800},{4,4320}]'),(10,496,'[{3,0,4087594}]',2483,'[{90,1},{7,2},{2,3},{1,5}]',7696,281840,'[{2,173440},{4,4336}]'),(10,497,'[{3,0,4101406}]',2489,'[{90,1},{7,2},{2,3},{1,5}]',7714,282880,'[{2,174080},{4,4352}]'),(10,498,'[{3,0,4115218}]',2494,'[{90,1},{7,2},{2,3},{1,5}]',7731,283920,'[{2,174720},{4,4368}]'),(10,499,'[{3,0,4266667}]',2583,'[{90,1},{7,2},{2,3},{1,5}]',7749,284960,'[{2,175360},{4,4384}]'),(10,500,'[{3,0,0}]',0,'[{90,1},{7,2},{2,3},{1,5}]',0,286000,'[{2,176000},{4,4400}]');
/*!40000 ALTER TABLE `base_equip_stren_lv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_equip_strengthen_max`
--

DROP TABLE IF EXISTS `base_equip_strengthen_max`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_equip_strengthen_max` (
  `stage` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '阶数',
  `color` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '颜色',
  `pos` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '部位',
  `stren_max` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '强化上限',
  PRIMARY KEY (`stage`,`color`,`pos`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='强化上限配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_equip_strengthen_max`
--

LOCK TABLES `base_equip_strengthen_max` WRITE;
/*!40000 ALTER TABLE `base_equip_strengthen_max` DISABLE KEYS */;
INSERT INTO `base_equip_strengthen_max` VALUES (1,0,1,10),(1,0,2,10),(1,0,3,10),(1,0,4,10),(1,0,5,10),(1,0,6,10),(1,0,7,10),(1,0,8,10),(1,0,9,10),(1,0,10,10),(1,1,1,10),(1,1,2,10),(1,1,3,10),(1,1,4,10),(1,1,5,10),(1,1,6,10),(1,1,7,10),(1,1,8,10),(1,1,9,10),(1,1,10,10),(1,2,1,10),(1,2,2,10),(1,2,3,10),(1,2,4,10),(1,2,5,10),(1,2,6,10),(1,2,7,10),(1,2,8,10),(1,2,9,10),(1,2,10,10),(1,3,1,10),(1,3,2,10),(1,3,3,10),(1,3,4,10),(1,3,5,10),(1,3,6,10),(1,3,7,10),(1,3,8,10),(1,3,9,10),(1,3,10,10),(1,4,1,10),(1,4,2,10),(1,4,3,10),(1,4,4,10),(1,4,5,10),(1,4,6,10),(1,4,7,10),(1,4,8,10),(1,4,9,10),(1,4,10,10),(1,5,1,10),(1,5,2,10),(1,5,3,10),(1,5,4,10),(1,5,5,10),(1,5,6,10),(1,5,7,10),(1,5,8,10),(1,5,9,10),(1,5,10,10),(1,6,1,10),(1,6,2,10),(1,6,3,10),(1,6,4,10),(1,6,5,10),(1,6,6,10),(1,6,7,10),(1,6,8,10),(1,6,9,10),(1,6,10,10),(2,0,1,10),(2,0,2,10),(2,0,3,10),(2,0,4,10),(2,0,5,10),(2,0,6,10),(2,0,7,10),(2,0,8,10),(2,0,9,10),(2,0,10,10),(2,1,1,10),(2,1,2,10),(2,1,3,10),(2,1,4,10),(2,1,5,10),(2,1,6,10),(2,1,7,10),(2,1,8,10),(2,1,9,10),(2,1,10,10),(2,2,1,10),(2,2,2,10),(2,2,3,10),(2,2,4,10),(2,2,5,10),(2,2,6,10),(2,2,7,10),(2,2,8,10),(2,2,9,10),(2,2,10,10),(2,3,1,10),(2,3,2,10),(2,3,3,10),(2,3,4,10),(2,3,5,10),(2,3,6,10),(2,3,7,10),(2,3,8,10),(2,3,9,10),(2,3,10,10),(2,4,1,10),(2,4,2,10),(2,4,3,10),(2,4,4,10),(2,4,5,10),(2,4,6,10),(2,4,7,10),(2,4,8,10),(2,4,9,10),(2,4,10,10),(2,5,1,10),(2,5,2,10),(2,5,3,10),(2,5,4,10),(2,5,5,10),(2,5,6,10),(2,5,7,10),(2,5,8,10),(2,5,9,10),(2,5,10,10),(2,6,1,10),(2,6,2,10),(2,6,3,10),(2,6,4,10),(2,6,5,10),(2,6,6,10),(2,6,7,10),(2,6,8,10),(2,6,9,10),(2,6,10,10),(3,0,1,10),(3,0,2,10),(3,0,3,10),(3,0,4,10),(3,0,5,10),(3,0,6,10),(3,0,7,10),(3,0,8,10),(3,0,9,10),(3,0,10,10),(3,1,1,10),(3,1,2,10),(3,1,3,10),(3,1,4,10),(3,1,5,10),(3,1,6,10),(3,1,7,10),(3,1,8,10),(3,1,9,10),(3,1,10,10),(3,2,1,10),(3,2,2,10),(3,2,3,10),(3,2,4,10),(3,2,5,10),(3,2,6,10),(3,2,7,10),(3,2,8,10),(3,2,9,10),(3,2,10,10),(3,3,1,15),(3,3,2,15),(3,3,3,15),(3,3,4,15),(3,3,5,15),(3,3,6,15),(3,3,7,15),(3,3,8,15),(3,3,9,15),(3,3,10,15),(3,4,1,15),(3,4,2,15),(3,4,3,15),(3,4,4,15),(3,4,5,15),(3,4,6,15),(3,4,7,15),(3,4,8,15),(3,4,9,15),(3,4,10,15),(3,5,1,15),(3,5,2,15),(3,5,3,15),(3,5,4,15),(3,5,5,15),(3,5,6,15),(3,5,7,15),(3,5,8,15),(3,5,9,15),(3,5,10,15),(3,6,1,15),(3,6,2,15),(3,6,3,15),(3,6,4,15),(3,6,5,15),(3,6,6,15),(3,6,7,15),(3,6,8,15),(3,6,9,15),(3,6,10,15),(4,0,1,20),(4,0,2,20),(4,0,3,20),(4,0,4,20),(4,0,5,20),(4,0,6,20),(4,0,7,20),(4,0,8,20),(4,0,9,20),(4,0,10,20),(4,1,1,20),(4,1,2,20),(4,1,3,20),(4,1,4,20),(4,1,5,20),(4,1,6,20),(4,1,7,20),(4,1,8,20),(4,1,9,20),(4,1,10,20),(4,2,1,25),(4,2,2,25),(4,2,3,25),(4,2,4,25),(4,2,5,25),(4,2,6,25),(4,2,7,25),(4,2,8,25),(4,2,9,25),(4,2,10,25),(4,3,1,30),(4,3,2,30),(4,3,3,30),(4,3,4,30),(4,3,5,30),(4,3,6,30),(4,3,7,30),(4,3,8,30),(4,3,9,30),(4,3,10,30),(4,4,1,30),(4,4,2,30),(4,4,3,30),(4,4,4,30),(4,4,5,30),(4,4,6,30),(4,4,7,30),(4,4,8,30),(4,4,9,30),(4,4,10,30),(4,5,1,30),(4,5,2,30),(4,5,3,30),(4,5,4,30),(4,5,5,30),(4,5,6,30),(4,5,7,30),(4,5,8,30),(4,5,9,30),(4,5,10,30),(4,6,1,30),(4,6,2,30),(4,6,3,30),(4,6,4,30),(4,6,5,30),(4,6,6,30),(4,6,7,30),(4,6,8,30),(4,6,9,30),(4,6,10,30),(5,0,1,40),(5,0,2,40),(5,0,3,40),(5,0,4,40),(5,0,5,40),(5,0,6,40),(5,0,7,40),(5,0,8,40),(5,0,9,40),(5,0,10,40),(5,1,1,40),(5,1,2,40),(5,1,3,40),(5,1,4,40),(5,1,5,40),(5,1,6,40),(5,1,7,40),(5,1,8,40),(5,1,9,40),(5,1,10,40),(5,2,1,45),(5,2,2,45),(5,2,3,45),(5,2,4,45),(5,2,5,45),(5,2,6,45),(5,2,7,45),(5,2,8,45),(5,2,9,45),(5,2,10,45),(5,3,1,50),(5,3,2,50),(5,3,3,50),(5,3,4,50),(5,3,5,50),(5,3,6,50),(5,3,7,50),(5,3,8,50),(5,3,9,50),(5,3,10,50),(5,4,1,50),(5,4,2,50),(5,4,3,50),(5,4,4,50),(5,4,5,50),(5,4,6,50),(5,4,7,50),(5,4,8,50),(5,4,9,50),(5,4,10,50),(5,5,1,50),(5,5,2,50),(5,5,3,50),(5,5,4,50),(5,5,5,50),(5,5,6,50),(5,5,7,50),(5,5,8,50),(5,5,9,50),(5,5,10,50),(5,6,1,50),(5,6,2,50),(5,6,3,50),(5,6,4,50),(5,6,5,50),(5,6,6,50),(5,6,7,50),(5,6,8,50),(5,6,9,50),(5,6,10,50),(6,0,1,60),(6,0,2,60),(6,0,3,60),(6,0,4,60),(6,0,5,60),(6,0,6,60),(6,0,7,60),(6,0,8,60),(6,0,9,60),(6,0,10,60),(6,1,1,65),(6,1,2,65),(6,1,3,65),(6,1,4,65),(6,1,5,65),(6,1,6,65),(6,1,7,65),(6,1,8,65),(6,1,9,65),(6,1,10,65),(6,2,1,75),(6,2,2,75),(6,2,3,75),(6,2,4,75),(6,2,5,75),(6,2,6,75),(6,2,7,75),(6,2,8,75),(6,2,9,75),(6,2,10,75),(6,3,1,80),(6,3,2,80),(6,3,3,80),(6,3,4,80),(6,3,5,80),(6,3,6,80),(6,3,7,80),(6,3,8,80),(6,3,9,80),(6,3,10,80),(6,4,1,80),(6,4,2,80),(6,4,3,80),(6,4,4,80),(6,4,5,80),(6,4,6,80),(6,4,7,80),(6,4,8,80),(6,4,9,80),(6,4,10,80),(6,5,1,80),(6,5,2,80),(6,5,3,80),(6,5,4,80),(6,5,5,80),(6,5,6,80),(6,5,7,80),(6,5,8,80),(6,5,9,80),(6,5,10,80),(6,6,1,80),(6,6,2,80),(6,6,3,80),(6,6,4,80),(6,6,5,80),(6,6,6,80),(6,6,7,80),(6,6,8,80),(6,6,9,80),(6,6,10,80),(7,0,1,95),(7,0,2,95),(7,0,3,95),(7,0,4,95),(7,0,5,95),(7,0,6,95),(7,0,7,95),(7,0,8,95),(7,0,9,95),(7,0,10,95),(7,1,1,105),(7,1,2,105),(7,1,3,105),(7,1,4,105),(7,1,5,105),(7,1,6,105),(7,1,7,105),(7,1,8,105),(7,1,9,105),(7,1,10,105),(7,2,1,120),(7,2,2,120),(7,2,3,120),(7,2,4,120),(7,2,5,120),(7,2,6,120),(7,2,7,120),(7,2,8,120),(7,2,9,120),(7,2,10,120),(7,3,1,125),(7,3,2,125),(7,3,3,125),(7,3,4,125),(7,3,5,125),(7,3,6,125),(7,3,7,125),(7,3,8,125),(7,3,9,125),(7,3,10,125),(7,4,1,130),(7,4,2,130),(7,4,3,130),(7,4,4,130),(7,4,5,130),(7,4,6,130),(7,4,7,130),(7,4,8,130),(7,4,9,130),(7,4,10,130),(7,5,1,130),(7,5,2,130),(7,5,3,130),(7,5,4,130),(7,5,5,130),(7,5,6,130),(7,5,7,130),(7,5,8,130),(7,5,9,130),(7,5,10,130),(7,6,1,130),(7,6,2,130),(7,6,3,130),(7,6,4,130),(7,6,5,130),(7,6,6,130),(7,6,7,130),(7,6,8,130),(7,6,9,130),(7,6,10,130),(8,0,1,155),(8,0,2,155),(8,0,3,155),(8,0,4,155),(8,0,5,155),(8,0,6,155),(8,0,7,155),(8,0,8,155),(8,0,9,155),(8,0,10,155),(8,1,1,165),(8,1,2,165),(8,1,3,165),(8,1,4,165),(8,1,5,165),(8,1,6,165),(8,1,7,165),(8,1,8,165),(8,1,9,165),(8,1,10,165),(8,2,1,185),(8,2,2,185),(8,2,3,185),(8,2,4,185),(8,2,5,185),(8,2,6,185),(8,2,7,185),(8,2,8,185),(8,2,9,185),(8,2,10,185),(8,3,1,195),(8,3,2,195),(8,3,3,195),(8,3,4,195),(8,3,5,195),(8,3,6,195),(8,3,7,195),(8,3,8,195),(8,3,9,195),(8,3,10,195),(8,4,1,200),(8,4,2,200),(8,4,3,200),(8,4,4,200),(8,4,5,200),(8,4,6,200),(8,4,7,200),(8,4,8,200),(8,4,9,200),(8,4,10,200),(8,5,1,200),(8,5,2,200),(8,5,3,200),(8,5,4,200),(8,5,5,200),(8,5,6,200),(8,5,7,200),(8,5,8,200),(8,5,9,200),(8,5,10,200),(8,6,1,200),(8,6,2,200),(8,6,3,200),(8,6,4,200),(8,6,5,200),(8,6,6,200),(8,6,7,200),(8,6,8,200),(8,6,9,200),(8,6,10,200),(9,0,1,215),(9,0,2,215),(9,0,3,215),(9,0,4,215),(9,0,5,215),(9,0,6,215),(9,0,7,215),(9,0,8,215),(9,0,9,215),(9,0,10,215),(9,1,1,220),(9,1,2,220),(9,1,3,220),(9,1,4,220),(9,1,5,220),(9,1,6,220),(9,1,7,220),(9,1,8,220),(9,1,9,220),(9,1,10,220),(9,2,1,230),(9,2,2,230),(9,2,3,230),(9,2,4,230),(9,2,5,230),(9,2,6,230),(9,2,7,230),(9,2,8,230),(9,2,9,230),(9,2,10,230),(9,3,1,240),(9,3,2,240),(9,3,3,240),(9,3,4,240),(9,3,5,240),(9,3,6,240),(9,3,7,240),(9,3,8,240),(9,3,9,240),(9,3,10,240),(9,4,1,240),(9,4,2,240),(9,4,3,240),(9,4,4,240),(9,4,5,240),(9,4,6,240),(9,4,7,240),(9,4,8,240),(9,4,9,240),(9,4,10,240),(9,5,1,240),(9,5,2,240),(9,5,3,240),(9,5,4,240),(9,5,5,240),(9,5,6,240),(9,5,7,240),(9,5,8,240),(9,5,9,240),(9,5,10,240),(9,6,1,240),(9,6,2,240),(9,6,3,240),(9,6,4,240),(9,6,5,240),(9,6,6,240),(9,6,7,240),(9,6,8,240),(9,6,9,240),(9,6,10,240),(10,0,1,255),(10,0,2,255),(10,0,3,255),(10,0,4,255),(10,0,5,255),(10,0,6,255),(10,0,7,255),(10,0,8,255),(10,0,9,255),(10,0,10,255),(10,1,1,265),(10,1,2,265),(10,1,3,265),(10,1,4,265),(10,1,5,265),(10,1,6,265),(10,1,7,265),(10,1,8,265),(10,1,9,265),(10,1,10,265),(10,2,1,280),(10,2,2,280),(10,2,3,280),(10,2,4,280),(10,2,5,280),(10,2,6,280),(10,2,7,280),(10,2,8,280),(10,2,9,280),(10,2,10,280),(10,3,1,285),(10,3,2,285),(10,3,3,285),(10,3,4,285),(10,3,5,285),(10,3,6,285),(10,3,7,285),(10,3,8,285),(10,3,9,285),(10,3,10,285),(10,4,1,290),(10,4,2,290),(10,4,3,290),(10,4,4,290),(10,4,5,290),(10,4,6,290),(10,4,7,290),(10,4,8,290),(10,4,9,290),(10,4,10,290),(10,5,1,290),(10,5,2,290),(10,5,3,290),(10,5,4,290),(10,5,5,290),(10,5,6,290),(10,5,7,290),(10,5,8,290),(10,5,9,290),(10,5,10,290),(10,6,1,290),(10,6,2,290),(10,6,3,290),(10,6,4,290),(10,6,5,290),(10,6,6,290),(10,6,7,290),(10,6,8,290),(10,6,9,290),(10,6,10,290),(11,0,1,305),(11,0,2,305),(11,0,3,305),(11,0,4,305),(11,0,5,305),(11,0,6,305),(11,0,7,305),(11,0,8,305),(11,0,9,305),(11,0,10,305),(11,1,1,315),(11,1,2,315),(11,1,3,315),(11,1,4,315),(11,1,5,315),(11,1,6,315),(11,1,7,315),(11,1,8,315),(11,1,9,315),(11,1,10,315),(11,2,1,330),(11,2,2,330),(11,2,3,330),(11,2,4,330),(11,2,5,330),(11,2,6,330),(11,2,7,330),(11,2,8,330),(11,2,9,330),(11,2,10,330),(11,3,1,335),(11,3,2,335),(11,3,3,335),(11,3,4,335),(11,3,5,335),(11,3,6,335),(11,3,7,335),(11,3,8,335),(11,3,9,335),(11,3,10,335),(11,4,1,340),(11,4,2,340),(11,4,3,340),(11,4,4,340),(11,4,5,340),(11,4,6,340),(11,4,7,340),(11,4,8,340),(11,4,9,340),(11,4,10,340),(11,5,1,340),(11,5,2,340),(11,5,3,340),(11,5,4,340),(11,5,5,340),(11,5,6,340),(11,5,7,340),(11,5,8,340),(11,5,9,340),(11,5,10,340),(11,6,1,340),(11,6,2,340),(11,6,3,340),(11,6,4,340),(11,6,5,340),(11,6,6,340),(11,6,7,340),(11,6,8,340),(11,6,9,340),(11,6,10,340),(12,0,1,355),(12,0,2,355),(12,0,3,355),(12,0,4,355),(12,0,5,355),(12,0,6,355),(12,0,7,355),(12,0,8,355),(12,0,9,355),(12,0,10,355),(12,1,1,360),(12,1,2,360),(12,1,3,360),(12,1,4,360),(12,1,5,360),(12,1,6,360),(12,1,7,360),(12,1,8,360),(12,1,9,360),(12,1,10,360),(12,2,1,370),(12,2,2,370),(12,2,3,370),(12,2,4,370),(12,2,5,370),(12,2,6,370),(12,2,7,370),(12,2,8,370),(12,2,9,370),(12,2,10,370),(12,3,1,380),(12,3,2,380),(12,3,3,380),(12,3,4,380),(12,3,5,380),(12,3,6,380),(12,3,7,380),(12,3,8,380),(12,3,9,380),(12,3,10,380),(12,4,1,380),(12,4,2,380),(12,4,3,380),(12,4,4,380),(12,4,5,380),(12,4,6,380),(12,4,7,380),(12,4,8,380),(12,4,9,380),(12,4,10,380),(12,5,1,380),(12,5,2,380),(12,5,3,380),(12,5,4,380),(12,5,5,380),(12,5,6,380),(12,5,7,380),(12,5,8,380),(12,5,9,380),(12,5,10,380),(12,6,1,380),(12,6,2,380),(12,6,3,380),(12,6,4,380),(12,6,5,380),(12,6,6,380),(12,6,7,380),(12,6,8,380),(12,6,9,380),(12,6,10,380),(13,0,1,400),(13,0,2,400),(13,0,3,400),(13,0,4,400),(13,0,5,400),(13,0,6,400),(13,0,7,400),(13,0,8,400),(13,0,9,400),(13,0,10,400),(13,1,1,410),(13,1,2,410),(13,1,3,410),(13,1,4,410),(13,1,5,410),(13,1,6,410),(13,1,7,410),(13,1,8,410),(13,1,9,410),(13,1,10,410),(13,2,1,425),(13,2,2,425),(13,2,3,425),(13,2,4,425),(13,2,5,425),(13,2,6,425),(13,2,7,425),(13,2,8,425),(13,2,9,425),(13,2,10,425),(13,3,1,435),(13,3,2,435),(13,3,3,435),(13,3,4,435),(13,3,5,435),(13,3,6,435),(13,3,7,435),(13,3,8,435),(13,3,9,435),(13,3,10,435),(13,4,1,440),(13,4,2,440),(13,4,3,440),(13,4,4,440),(13,4,5,440),(13,4,6,440),(13,4,7,440),(13,4,8,440),(13,4,9,440),(13,4,10,440),(13,5,1,440),(13,5,2,440),(13,5,3,440),(13,5,4,440),(13,5,5,440),(13,5,6,440),(13,5,7,440),(13,5,8,440),(13,5,9,440),(13,5,10,440),(13,6,1,440),(13,6,2,440),(13,6,3,440),(13,6,4,440),(13,6,5,440),(13,6,6,440),(13,6,7,440),(13,6,8,440),(13,6,9,440),(13,6,10,440),(14,0,1,450),(14,0,2,450),(14,0,3,450),(14,0,4,450),(14,0,5,450),(14,0,6,450),(14,0,7,450),(14,0,8,450),(14,0,9,450),(14,0,10,450),(14,1,1,450),(14,1,2,450),(14,1,3,450),(14,1,4,450),(14,1,5,450),(14,1,6,450),(14,1,7,450),(14,1,8,450),(14,1,9,450),(14,1,10,450),(14,2,1,455),(14,2,2,455),(14,2,3,455),(14,2,4,455),(14,2,5,455),(14,2,6,455),(14,2,7,455),(14,2,8,455),(14,2,9,455),(14,2,10,455),(14,3,1,460),(14,3,2,460),(14,3,3,460),(14,3,4,460),(14,3,5,460),(14,3,6,460),(14,3,7,460),(14,3,8,460),(14,3,9,460),(14,3,10,460),(14,4,1,460),(14,4,2,460),(14,4,3,460),(14,4,4,460),(14,4,5,460),(14,4,6,460),(14,4,7,460),(14,4,8,460),(14,4,9,460),(14,4,10,460),(14,5,1,460),(14,5,2,460),(14,5,3,460),(14,5,4,460),(14,5,5,460),(14,5,6,460),(14,5,7,460),(14,5,8,460),(14,5,9,460),(14,5,10,460),(14,6,1,460),(14,6,2,460),(14,6,3,460),(14,6,4,460),(14,6,5,460),(14,6,6,460),(14,6,7,460),(14,6,8,460),(14,6,9,460),(14,6,10,460),(15,0,1,470),(15,0,2,470),(15,0,3,470),(15,0,4,470),(15,0,5,470),(15,0,6,470),(15,0,7,470),(15,0,8,470),(15,0,9,470),(15,0,10,470),(15,1,1,470),(15,1,2,470),(15,1,3,470),(15,1,4,470),(15,1,5,470),(15,1,6,470),(15,1,7,470),(15,1,8,470),(15,1,9,470),(15,1,10,470),(15,2,1,475),(15,2,2,475),(15,2,3,475),(15,2,4,475),(15,2,5,475),(15,2,6,475),(15,2,7,475),(15,2,8,475),(15,2,9,475),(15,2,10,475),(15,3,1,480),(15,3,2,480),(15,3,3,480),(15,3,4,480),(15,3,5,480),(15,3,6,480),(15,3,7,480),(15,3,8,480),(15,3,9,480),(15,3,10,480),(15,4,1,480),(15,4,2,480),(15,4,3,480),(15,4,4,480),(15,4,5,480),(15,4,6,480),(15,4,7,480),(15,4,8,480),(15,4,9,480),(15,4,10,480),(15,5,1,480),(15,5,2,480),(15,5,3,480),(15,5,4,480),(15,5,5,480),(15,5,6,480),(15,5,7,480),(15,5,8,480),(15,5,9,480),(15,5,10,480),(15,6,1,480),(15,6,2,480),(15,6,3,480),(15,6,4,480),(15,6,5,480),(15,6,6,480),(15,6,7,480),(15,6,8,480),(15,6,9,480),(15,6,10,480);
/*!40000 ALTER TABLE `base_equip_strengthen_max` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_equip_suit_attr`
--

DROP TABLE IF EXISTS `base_equip_suit_attr`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_equip_suit_attr` (
  `type` tinyint(3) unsigned NOT NULL COMMENT '类型##1装备2仙器',
  `lv` tinyint(3) unsigned NOT NULL COMMENT '套装等级##1诛仙2诸神',
  `slv` smallint(5) unsigned NOT NULL COMMENT '套装阶级',
  `attr_list` text NOT NULL COMMENT '属性',
  PRIMARY KEY (`type`,`lv`,`slv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备套装属性';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_equip_suit_attr`
--

LOCK TABLES `base_equip_suit_attr` WRITE;
/*!40000 ALTER TABLE `base_equip_suit_attr` DISABLE KEYS */;
INSERT INTO `base_equip_suit_attr` VALUES (1,1,5,'[{2,[{1,10}]},{4,[{1,10}]},{6,[{1,10}]}]');
/*!40000 ALTER TABLE `base_equip_suit_attr` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_equip_suit_item`
--

DROP TABLE IF EXISTS `base_equip_suit_item`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_equip_suit_item` (
  `type` tinyint(3) unsigned NOT NULL COMMENT '类型##1装备2仙器',
  `lv` tinyint(3) unsigned NOT NULL COMMENT '套装等级##1诛仙2诸神',
  `slv` smallint(5) unsigned NOT NULL COMMENT '套装阶级',
  `name` varchar(63) NOT NULL DEFAULT '' COMMENT '名称@lang@',
  `attr_list` tinytext NOT NULL COMMENT '属性列表',
  `max_count` tinyint(3) unsigned NOT NULL COMMENT '套装最大件数',
  PRIMARY KEY (`type`,`lv`,`slv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备套装分类配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_equip_suit_item`
--

LOCK TABLES `base_equip_suit_item` WRITE;
/*!40000 ALTER TABLE `base_equip_suit_item` DISABLE KEYS */;
INSERT INTO `base_equip_suit_item` VALUES (1,1,5,'5阶霸者套装','[{2,[{1,369},{4,388},{9,75}]},{4,[{2,7766},{3,427},{28,130}]},{6,[{1,446},{2,8542},{10,50},{27,75}]}]',6),(1,1,6,'6阶霸者套装','[{2,[{1,639},{4,672},{9,150}]},{4,[{2,13447},{3,740},{28,250}]},{6,[{1,773},{2,14792},{10,100},{27,150}]}]',6),(1,1,7,'7阶霸者套装','[{2,[{1,998},{4,1050},{9,210}]},{4,[{2,21006},{3,1155},{28,325}]},{6,[{1,1208},{2,23106},{10,140},{27,210}]}]',6),(1,1,8,'8阶霸者套装','[{2,[{1,1451},{4,1527},{9,270}]},{4,[{2,30544},{3,1680},{28,400}]},{6,[{1,1756},{2,33599},{10,180},{27,270}]}]',6),(1,1,9,'9阶霸者套装','[{2,[{1,2003},{4,2108},{9,330}]},{4,[{2,42167},{3,2319},{28,475}]},{6,[{1,2424},{2,46384},{10,220},{27,330}]}]',6),(1,1,10,'10阶霸者套装','[{2,[{1,2659},{4,2798},{9,390}]},{4,[{2,55964},{3,3078},{28,550}]},{6,[{1,3217},{2,61560},{10,260},{27,390}]}]',6),(1,1,11,'11阶霸者套装','[{2,[{1,3423},{4,3603},{9,450}]},{4,[{2,72051},{3,3963},{28,625}]},{6,[{1,4142},{2,79256},{10,300},{27,450}]}]',6),(1,1,12,'12阶霸者套装','[{2,[{1,4301},{4,4527},{9,510}]},{4,[{2,90533},{3,4979},{28,700}]},{6,[{1,5205},{2,99587},{10,340},{27,510}]}]',6),(1,1,13,'13阶霸者套装','[{2,[{1,5298},{4,5576},{9,570}]},{4,[{2,111513},{3,6133},{28,775}]},{6,[{1,6411},{2,122665},{10,380},{27,570}]}]',6),(1,1,14,'14阶霸者套装','[{2,[{1,6418},{4,6755},{9,630}]},{4,[{2,135094},{3,7430},{28,850}]},{6,[{1,7766},{2,148604},{10,420},{27,630}]}]',6),(1,1,15,'15阶霸者套装','[{2,[{1,7667},{4,8069},{9,690}]},{4,[{2,161381},{3,8876},{28,925}]},{6,[{1,9277},{2,177519},{10,460},{27,690}]}]',6),(1,1,16,'16阶霸者套装','[{2,[{1,9050},{4,9524},{9,750}]},{4,[{2,190476},{3,10476},{28,1000}]},{6,[{1,10950},{2,209524},{10,500},{27,750}]}]',6),(1,2,5,'5阶泰坦套装','[{2,[{1,738},{4,777},{9,150}]},{4,[{2,15531},{3,854},{28,260}]},{6,[{1,893},{2,17084},{10,100},{27,150}]}]',6),(1,2,6,'6阶泰坦套装','[{2,[{1,1278},{4,1345},{9,300}]},{4,[{2,26895},{3,1479},{28,500}]},{6,[{1,1546},{2,29584},{10,200},{27,300}]}]',6),(1,2,7,'7阶泰坦套装','[{2,[{1,1996},{4,2101},{9,420}]},{4,[{2,42012},{3,2311},{28,650}]},{6,[{1,2415},{2,46213},{10,280},{27,420}]}]',6),(1,2,8,'8阶泰坦套装','[{2,[{1,2902},{4,3055},{9,540}]},{4,[{2,61089},{3,3360},{28,800}]},{6,[{1,3512},{2,67198},{10,360},{27,540}]}]',6),(1,2,9,'9阶泰坦套装','[{2,[{1,4007},{4,4217},{9,660}]},{4,[{2,84334},{3,4638},{28,950}]},{6,[{1,4848},{2,92767},{10,440},{27,660}]}]',6),(1,2,10,'10阶泰坦套装','[{2,[{1,5318},{4,5596},{9,780}]},{4,[{2,111927},{3,6156},{28,1100}]},{6,[{1,6434},{2,123120},{10,520},{27,780}]}]',6),(1,2,11,'11阶泰坦套装','[{2,[{1,6846},{4,7205},{9,900}]},{4,[{2,144102},{3,7926},{28,1250}]},{6,[{1,8284},{2,158513},{10,600},{27,900}]}]',6),(1,2,12,'12阶泰坦套装','[{2,[{1,8602},{4,9054},{9,1020}]},{4,[{2,181066},{3,9958},{28,1400}]},{6,[{1,10409},{2,199173},{10,680},{27,1020}]}]',6),(1,2,13,'13阶泰坦套装','[{2,[{1,10596},{4,11152},{9,1140}]},{4,[{2,223026},{3,12266},{28,1550}]},{6,[{1,12821},{2,245329},{10,760},{27,1140}]}]',6),(1,2,14,'14阶泰坦套装','[{2,[{1,12837},{4,13510},{9,1260}]},{4,[{2,270189},{3,14860},{28,1700}]},{6,[{1,15533},{2,297208},{10,840},{27,1260}]}]',6),(1,2,15,'15阶泰坦套装','[{2,[{1,15334},{4,16138},{9,1380}]},{4,[{2,322761},{3,17752},{28,1850}]},{6,[{1,18555},{2,355038},{10,920},{27,1380}]}]',6),(1,2,16,'16阶泰坦套装','[{2,[{1,18099},{4,19048},{9,1500}]},{4,[{2,380951},{3,20952},{28,2000}]},{6,[{1,21900},{2,419047},{10,1000},{27,1500}]}]',6),(2,1,5,'5阶修罗套装','[{2,[{2,11069},{3,582},{10,75}]},{3,[{1,582},{4,641},{27,130}]},{4,[{1,641},{2,13393},{9,50},{28,75}]}]',4),(2,1,6,'6阶修罗套装','[{2,[{2,19167},{3,1009},{10,150}]},{3,[{1,1009},{4,1109},{27,250}]},{4,[{1,1109},{2,23192},{9,100},{28,150}]}]',4),(2,1,7,'7阶修罗套装','[{2,[{2,29940},{3,1575},{10,210}]},{3,[{1,1575},{4,1733},{27,325}]},{4,[{1,1733},{2,36228},{9,140},{28,210}]}]',4),(2,1,8,'8阶修罗套装','[{2,[{2,43536},{3,2291},{10,270}]},{3,[{1,2291},{4,2520},{27,400}]},{4,[{1,2520},{2,52679},{9,180},{28,270}]}]',4),(2,1,9,'9阶修罗套装','[{2,[{2,60102},{3,3162},{10,330}]},{3,[{1,3162},{4,3479},{27,475}]},{4,[{1,3479},{2,72724},{9,220},{28,330}]}]',4),(2,1,10,'10阶修罗套装','[{2,[{2,79767},{3,4197},{10,390}]},{3,[{1,4197},{4,4617},{27,550}]},{4,[{1,4617},{2,96518},{9,260},{28,390}]}]',4),(2,1,11,'11阶修罗套装','[{2,[{2,102697},{3,5404},{10,450}]},{3,[{1,5404},{4,5944},{27,625}]},{4,[{1,5944},{2,124264},{9,300},{28,450}]}]',4),(2,1,12,'12阶修罗套装','[{2,[{2,129041},{3,6790},{10,510}]},{3,[{1,6790},{4,7469},{27,700}]},{4,[{1,7469},{2,156139},{9,340},{28,510}]}]',4),(2,1,13,'13阶修罗套装','[{2,[{2,158944},{3,8363},{10,570}]},{3,[{1,8363},{4,9200},{27,775}]},{4,[{1,9200},{2,192323},{9,380},{28,570}]}]',4),(2,1,14,'14阶修罗套装','[{2,[{2,192555},{3,10132},{10,630}]},{3,[{1,10132},{4,11145},{27,850}]},{4,[{1,11145},{2,232993},{9,420},{28,630}]}]',4),(2,1,15,'15阶修罗套装','[{2,[{2,230022},{3,12103},{10,690}]},{3,[{1,12103},{4,13314},{27,925}]},{4,[{1,13314},{2,278328},{9,460},{28,690}]}]',4),(2,1,16,'16阶修罗套装','[{2,[{2,271493},{3,14286},{10,750}]},{3,[{1,14285},{4,15715},{27,1000}]},{4,[{1,15714},{2,328507},{9,500},{28,750}]}]',4),(2,2,5,'5阶战神套装','[{2,[{2,22137},{3,1165},{10,150}]},{3,[{1,1165},{4,1281},{27,260}]},{4,[{1,1281},{2,26786},{9,100},{28,150}]}]',4),(2,2,6,'6阶战神套装','[{2,[{2,38334},{3,2017},{10,300}]},{3,[{1,2017},{4,2219},{27,500}]},{4,[{1,2219},{2,46384},{9,200},{28,300}]}]',4),(2,2,7,'7阶战神套装','[{2,[{2,59881},{3,3151},{10,420}]},{3,[{1,3151},{4,3466},{27,650}]},{4,[{1,3466},{2,72456},{9,280},{28,420}]}]',4),(2,2,8,'8阶战神套装','[{2,[{2,87072},{3,4582},{10,540}]},{3,[{1,4581},{4,5040},{27,800}]},{4,[{1,5040},{2,105358},{9,360},{28,540}]}]',4),(2,2,9,'9阶战神套装','[{2,[{2,120204},{3,6325},{10,660}]},{3,[{1,6325},{4,6958},{27,950}]},{4,[{1,6957},{2,145447},{9,440},{28,660}]}]',4),(2,2,10,'10阶战神套装','[{2,[{2,159534},{3,8394},{10,780}]},{3,[{1,8394},{4,9234},{27,1100}]},{4,[{1,9234},{2,193037},{9,520},{28,780}]}]',4),(2,2,11,'11阶战神套装','[{2,[{2,205395},{3,10808},{10,900}]},{3,[{1,10807},{4,11889},{27,1250}]},{4,[{1,11888},{2,248528},{9,600},{28,900}]}]',4),(2,2,12,'12阶战神套装','[{2,[{2,258081},{3,13580},{10,1020}]},{3,[{1,13579},{4,14938},{27,1400}]},{4,[{1,14938},{2,312279},{9,680},{28,1020}]}]',4),(2,2,13,'13阶战神套装','[{2,[{2,317888},{3,16727},{10,1140}]},{3,[{1,16726},{4,18400},{27,1550}]},{4,[{1,18399},{2,384645},{9,760},{28,1140}]}]',4),(2,2,14,'14阶战神套装','[{2,[{2,385111},{3,20264},{10,1260}]},{3,[{1,20263},{4,22291},{27,1700}]},{4,[{1,22290},{2,465985},{9,840},{28,1260}]}]',4),(2,2,15,'15阶战神套装','[{2,[{2,460045},{3,24207},{10,1380}]},{3,[{1,24206},{4,26628},{27,1850}]},{4,[{1,26627},{2,556655},{9,920},{28,1380}]}]',4),(2,2,16,'16阶战神套装','[{2,[{2,542985},{3,28571},{10,1500}]},{3,[{1,28570},{4,31429},{27,2000}]},{4,[{1,31428},{2,657013},{9,1000},{28,1500}]}]',4);
/*!40000 ALTER TABLE `base_equip_suit_item` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_equip_suit_make`
--

DROP TABLE IF EXISTS `base_equip_suit_make`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_equip_suit_make` (
  `pos` mediumint(8) unsigned NOT NULL COMMENT '装备类型',
  `lv` tinyint(3) unsigned NOT NULL COMMENT '套装等级',
  `slv` smallint(5) unsigned NOT NULL COMMENT '套装阶级',
  `cost` varchar(1000) NOT NULL DEFAULT '' COMMENT '消耗',
  `condition` varchar(1000) NOT NULL COMMENT '升级条件',
  PRIMARY KEY (`pos`,`lv`,`slv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备套装制作配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_equip_suit_make`
--

LOCK TABLES `base_equip_suit_make` WRITE;
/*!40000 ALTER TABLE `base_equip_suit_make` DISABLE KEYS */;
INSERT INTO `base_equip_suit_make` VALUES (1,1,5,'[{1,[{0,38230101,13}]},{2,[{0,38230201,13}]},{3,[{0,38230301,13}]},{4,[{0,38230401,13}]}]','[{stage,eq,5},{quality,4,1}]'),(1,1,6,'[{1,[{0,38230101,25}]},{2,[{0,38230201,25}]},{3,[{0,38230301,25}]},{4,[{0,38230401,25}]}]','[{stage,eq,6},{quality,4,1}]'),(1,1,7,'[{1,[{0,38230101,45}]},{2,[{0,38230201,45}]},{3,[{0,38230301,45}]},{4,[{0,38230401,45}]}]','[{stage,eq,7},{quality,4,1}]'),(1,1,8,'[{1,[{0,38230101,80}]},{2,[{0,38230201,80}]},{3,[{0,38230301,80}]},{4,[{0,38230401,80}]}]','[{stage,eq,8},{quality,4,1}]'),(1,1,9,'[{1,[{0,38230101,140}]},{2,[{0,38230201,140}]},{3,[{0,38230301,140}]},{4,[{0,38230401,140}]}]','[{stage,eq,9},{quality,4,1}]'),(1,1,10,'[{1,[{0,38230101,225}]},{2,[{0,38230201,225}]},{3,[{0,38230301,225}]},{4,[{0,38230401,225}]}]','[{stage,eq,10},{quality,4,1}]'),(1,1,11,'[{1,[{0,38230101,350}]},{2,[{0,38230201,350}]},{3,[{0,38230301,350}]},{4,[{0,38230401,350}]}]','[{stage,eq,11},{quality,4,1}]'),(1,1,12,'[{1,[{0,38230101,500}]},{2,[{0,38230201,500}]},{3,[{0,38230301,500}]},{4,[{0,38230401,500}]}]','[{stage,eq,12},{quality,4,1}]'),(1,1,13,'[{1,[{0,38230101,675}]},{2,[{0,38230201,675}]},{3,[{0,38230301,675}]},{4,[{0,38230401,675}]}]','[{stage,eq,13},{quality,4,1}]'),(1,1,14,'[{1,[{0,38230101,900}]},{2,[{0,38230201,900}]},{3,[{0,38230301,900}]},{4,[{0,38230401,900}]}]','[{stage,eq,14},{quality,4,1}]'),(1,1,15,'[{1,[{0,38230101,1175}]},{2,[{0,38230201,1175}]},{3,[{0,38230301,1175}]},{4,[{0,38230401,1175}]}]','[{stage,eq,15},{quality,4,1}]'),(1,1,16,'[{1,[{0,38230101,1500}]},{2,[{0,38230201,1500}]},{3,[{0,38230301,1500}]},{4,[{0,38230401,1500}]}]','[{stage,eq,16},{quality,4,1}]'),(1,2,5,'[{1,[{0,38230101,3},{0,38240001,5}]},{2,[{0,38230201,3},{0,38240001,5}]},{3,[{0,38230301,3},{0,38240001,5}]},{4,[{0,38230401,3},{0,38240001,5}]}]','[{stage,eq,5},{quality,4,2}]'),(1,2,6,'[{1,[{0,38230101,5},{0,38240001,9}]},{2,[{0,38230201,5},{0,38240001,9}]},{3,[{0,38230301,5},{0,38240001,9}]},{4,[{0,38230401,5},{0,38240001,9}]}]','[{stage,eq,6},{quality,4,2}]'),(1,2,7,'[{1,[{0,38230101,10},{0,38240001,18}]},{2,[{0,38230201,10},{0,38240001,18}]},{3,[{0,38230301,10},{0,38240001,18}]},{4,[{0,38230401,10},{0,38240001,18}]}]','[{stage,eq,7},{quality,4,2}]'),(1,2,8,'[{1,[{0,38230101,20},{0,38240001,35}]},{2,[{0,38230201,20},{0,38240001,35}]},{3,[{0,38230301,20},{0,38240001,35}]},{4,[{0,38230401,20},{0,38240001,35}]}]','[{stage,eq,8},{quality,4,2}]'),(1,2,9,'[{1,[{0,38230101,35},{0,38240001,60}]},{2,[{0,38230201,35},{0,38240001,60}]},{3,[{0,38230301,35},{0,38240001,60}]},{4,[{0,38230401,35},{0,38240001,60}]}]','[{stage,eq,9},{quality,4,2}]'),(1,2,10,'[{1,[{0,38230101,60},{0,38240001,105}]},{2,[{0,38230201,60},{0,38240001,105}]},{3,[{0,38230301,60},{0,38240001,105}]},{4,[{0,38230401,60},{0,38240001,105}]}]','[{stage,eq,10},{quality,4,2}]'),(1,2,11,'[{1,[{0,38230101,90},{0,38240001,160}]},{2,[{0,38230201,90},{0,38240001,160}]},{3,[{0,38230301,90},{0,38240001,160}]},{4,[{0,38230401,90},{0,38240001,160}]}]','[{stage,eq,11},{quality,4,2}]'),(1,2,12,'[{1,[{0,38230101,125},{0,38240001,225}]},{2,[{0,38230201,125},{0,38240001,225}]},{3,[{0,38230301,125},{0,38240001,225}]},{4,[{0,38230401,125},{0,38240001,225}]}]','[{stage,eq,12},{quality,4,2}]'),(1,2,13,'[{1,[{0,38230101,175},{0,38240001,315}]},{2,[{0,38230201,175},{0,38240001,315}]},{3,[{0,38230301,175},{0,38240001,315}]},{4,[{0,38230401,175},{0,38240001,315}]}]','[{stage,eq,13},{quality,4,2}]'),(1,2,14,'[{1,[{0,38230101,225},{0,38240001,405}]},{2,[{0,38230201,225},{0,38240001,405}]},{3,[{0,38230301,225},{0,38240001,405}]},{4,[{0,38230401,225},{0,38240001,405}]}]','[{stage,eq,14},{quality,4,2}]'),(1,2,15,'[{1,[{0,38230101,300},{0,38240001,540}]},{2,[{0,38230201,300},{0,38240001,540}]},{3,[{0,38230301,300},{0,38240001,540}]},{4,[{0,38230401,300},{0,38240001,540}]}]','[{stage,eq,15},{quality,4,2}]'),(1,2,16,'[{1,[{0,38230101,400},{0,38240001,725}]},{2,[{0,38230201,400},{0,38240001,725}]},{3,[{0,38230301,400},{0,38240001,725}]},{4,[{0,38230401,400},{0,38240001,725}]}]','[{stage,eq,16},{quality,4,2}]'),(2,1,5,'[{1,[{0,38230102,25}]},{2,[{0,38230202,25}]},{3,[{0,38230302,25}]},{4,[{0,38230402,25}]}]','[{stage,eq,5},{quality,4,1}]'),(2,1,6,'[{1,[{0,38230102,50}]},{2,[{0,38230202,50}]},{3,[{0,38230302,50}]},{4,[{0,38230402,50}]}]','[{stage,eq,6},{quality,4,1}]'),(2,1,7,'[{1,[{0,38230102,90}]},{2,[{0,38230202,90}]},{3,[{0,38230302,90}]},{4,[{0,38230402,90}]}]','[{stage,eq,7},{quality,4,1}]'),(2,1,8,'[{1,[{0,38230102,160}]},{2,[{0,38230202,160}]},{3,[{0,38230302,160}]},{4,[{0,38230402,160}]}]','[{stage,eq,8},{quality,4,1}]'),(2,1,9,'[{1,[{0,38230102,280}]},{2,[{0,38230202,280}]},{3,[{0,38230302,280}]},{4,[{0,38230402,280}]}]','[{stage,eq,9},{quality,4,1}]'),(2,1,10,'[{1,[{0,38230102,450}]},{2,[{0,38230202,450}]},{3,[{0,38230302,450}]},{4,[{0,38230402,450}]}]','[{stage,eq,10},{quality,4,1}]'),(2,1,11,'[{1,[{0,38230102,700}]},{2,[{0,38230202,700}]},{3,[{0,38230302,700}]},{4,[{0,38230402,700}]}]','[{stage,eq,11},{quality,4,1}]'),(2,1,12,'[{1,[{0,38230102,1000}]},{2,[{0,38230202,1000}]},{3,[{0,38230302,1000}]},{4,[{0,38230402,1000}]}]','[{stage,eq,12},{quality,4,1}]'),(2,1,13,'[{1,[{0,38230102,1350}]},{2,[{0,38230202,1350}]},{3,[{0,38230302,1350}]},{4,[{0,38230402,1350}]}]','[{stage,eq,13},{quality,4,1}]'),(2,1,14,'[{1,[{0,38230102,1800}]},{2,[{0,38230202,1800}]},{3,[{0,38230302,1800}]},{4,[{0,38230402,1800}]}]','[{stage,eq,14},{quality,4,1}]'),(2,1,15,'[{1,[{0,38230102,2350}]},{2,[{0,38230202,2350}]},{3,[{0,38230302,2350}]},{4,[{0,38230402,2350}]}]','[{stage,eq,15},{quality,4,1}]'),(2,1,16,'[{1,[{0,38230102,3000}]},{2,[{0,38230202,3000}]},{3,[{0,38230302,3000}]},{4,[{0,38230402,3000}]}]','[{stage,eq,16},{quality,4,1}]'),(2,2,5,'[{1,[{0,38230102,5},{0,38240002,9}]},{2,[{0,38230202,5},{0,38240002,9}]},{3,[{0,38230302,5},{0,38240002,9}]},{4,[{0,38230402,5},{0,38240002,9}]}]','[{stage,eq,5},{quality,4,2}]'),(2,2,6,'[{1,[{0,38230102,10},{0,38240002,18}]},{2,[{0,38230202,10},{0,38240002,18}]},{3,[{0,38230302,10},{0,38240002,18}]},{4,[{0,38230402,10},{0,38240002,18}]}]','[{stage,eq,6},{quality,4,2}]'),(2,2,7,'[{1,[{0,38230102,20},{0,38240002,36}]},{2,[{0,38230202,20},{0,38240002,36}]},{3,[{0,38230302,20},{0,38240002,36}]},{4,[{0,38230402,20},{0,38240002,36}]}]','[{stage,eq,7},{quality,4,2}]'),(2,2,8,'[{1,[{0,38230102,40},{0,38240002,70}]},{2,[{0,38230202,40},{0,38240002,70}]},{3,[{0,38230302,40},{0,38240002,70}]},{4,[{0,38230402,40},{0,38240002,70}]}]','[{stage,eq,8},{quality,4,2}]'),(2,2,9,'[{1,[{0,38230102,70},{0,38240002,120}]},{2,[{0,38230202,70},{0,38240002,120}]},{3,[{0,38230302,70},{0,38240002,120}]},{4,[{0,38230402,70},{0,38240002,120}]}]','[{stage,eq,9},{quality,4,2}]'),(2,2,10,'[{1,[{0,38230102,120},{0,38240002,210}]},{2,[{0,38230202,120},{0,38240002,210}]},{3,[{0,38230302,120},{0,38240002,210}]},{4,[{0,38230402,120},{0,38240002,210}]}]','[{stage,eq,10},{quality,4,2}]'),(2,2,11,'[{1,[{0,38230102,180},{0,38240002,320}]},{2,[{0,38230202,180},{0,38240002,320}]},{3,[{0,38230302,180},{0,38240002,320}]},{4,[{0,38230402,180},{0,38240002,320}]}]','[{stage,eq,11},{quality,4,2}]'),(2,2,12,'[{1,[{0,38230102,250},{0,38240002,450}]},{2,[{0,38230202,250},{0,38240002,450}]},{3,[{0,38230302,250},{0,38240002,450}]},{4,[{0,38230402,250},{0,38240002,450}]}]','[{stage,eq,12},{quality,4,2}]'),(2,2,13,'[{1,[{0,38230102,350},{0,38240002,630}]},{2,[{0,38230202,350},{0,38240002,630}]},{3,[{0,38230302,350},{0,38240002,630}]},{4,[{0,38230402,350},{0,38240002,630}]}]','[{stage,eq,13},{quality,4,2}]'),(2,2,14,'[{1,[{0,38230102,450},{0,38240002,810}]},{2,[{0,38230202,450},{0,38240002,810}]},{3,[{0,38230302,450},{0,38240002,810}]},{4,[{0,38230402,450},{0,38240002,810}]}]','[{stage,eq,14},{quality,4,2}]'),(2,2,15,'[{1,[{0,38230102,600},{0,38240002,1080}]},{2,[{0,38230202,600},{0,38240002,1080}]},{3,[{0,38230302,600},{0,38240002,1080}]},{4,[{0,38230402,600},{0,38240002,1080}]}]','[{stage,eq,15},{quality,4,2}]'),(2,2,16,'[{1,[{0,38230102,800},{0,38240002,1450}]},{2,[{0,38230202,800},{0,38240002,1450}]},{3,[{0,38230302,800},{0,38240002,1450}]},{4,[{0,38230402,800},{0,38240002,1450}]}]','[{stage,eq,16},{quality,4,2}]'),(3,1,5,'[{1,[{0,38230003,3}]},{2,[{0,38230003,3}]},{3,[{0,38230003,3}]},{4,[{0,38230003,3}]}]','[{stage,eq,5},{quality,4,1}]'),(3,1,6,'[{1,[{0,38230003,5}]},{2,[{0,38230003,5}]},{3,[{0,38230003,5}]},{4,[{0,38230003,5}]}]','[{stage,eq,6},{quality,4,1}]'),(3,1,7,'[{1,[{0,38230003,9}]},{2,[{0,38230003,9}]},{3,[{0,38230003,9}]},{4,[{0,38230003,9}]}]','[{stage,eq,7},{quality,4,1}]'),(3,1,8,'[{1,[{0,38230003,16}]},{2,[{0,38230003,16}]},{3,[{0,38230003,16}]},{4,[{0,38230003,16}]}]','[{stage,eq,8},{quality,4,1}]'),(3,1,9,'[{1,[{0,38230003,28}]},{2,[{0,38230003,28}]},{3,[{0,38230003,28}]},{4,[{0,38230003,28}]}]','[{stage,eq,9},{quality,4,1}]'),(3,1,10,'[{1,[{0,38230003,45}]},{2,[{0,38230003,45}]},{3,[{0,38230003,45}]},{4,[{0,38230003,45}]}]','[{stage,eq,10},{quality,4,1}]'),(3,1,11,'[{1,[{0,38230003,70}]},{2,[{0,38230003,70}]},{3,[{0,38230003,70}]},{4,[{0,38230003,70}]}]','[{stage,eq,11},{quality,4,1}]'),(3,1,12,'[{1,[{0,38230003,100}]},{2,[{0,38230003,100}]},{3,[{0,38230003,100}]},{4,[{0,38230003,100}]}]','[{stage,eq,12},{quality,4,1}]'),(3,1,13,'[{1,[{0,38230003,135}]},{2,[{0,38230003,135}]},{3,[{0,38230003,135}]},{4,[{0,38230003,135}]}]','[{stage,eq,13},{quality,4,1}]'),(3,1,14,'[{1,[{0,38230003,180}]},{2,[{0,38230003,180}]},{3,[{0,38230003,180}]},{4,[{0,38230003,180}]}]','[{stage,eq,14},{quality,4,1}]'),(3,1,15,'[{1,[{0,38230003,235}]},{2,[{0,38230003,235}]},{3,[{0,38230003,235}]},{4,[{0,38230003,235}]}]','[{stage,eq,15},{quality,4,1}]'),(3,1,16,'[{1,[{0,38230003,300}]},{2,[{0,38230003,300}]},{3,[{0,38230003,300}]},{4,[{0,38230003,300}]}]','[{stage,eq,16},{quality,4,1}]'),(3,2,5,'[{1,[{0,38230003,1},{0,38240003,1}]},{2,[{0,38230003,1},{0,38240003,1}]},{3,[{0,38230003,1},{0,38240003,1}]},{4,[{0,38230003,1},{0,38240003,1}]}]','[{stage,eq,5},{quality,4,2}]'),(3,2,6,'[{1,[{0,38230003,1},{0,38240003,2}]},{2,[{0,38230003,1},{0,38240003,2}]},{3,[{0,38230003,1},{0,38240003,2}]},{4,[{0,38230003,1},{0,38240003,2}]}]','[{stage,eq,6},{quality,4,2}]'),(3,2,7,'[{1,[{0,38230003,2},{0,38240003,4}]},{2,[{0,38230003,2},{0,38240003,4}]},{3,[{0,38230003,2},{0,38240003,4}]},{4,[{0,38230003,2},{0,38240003,4}]}]','[{stage,eq,7},{quality,4,2}]'),(3,2,8,'[{1,[{0,38230003,4},{0,38240003,7}]},{2,[{0,38230003,4},{0,38240003,7}]},{3,[{0,38230003,4},{0,38240003,7}]},{4,[{0,38230003,4},{0,38240003,7}]}]','[{stage,eq,8},{quality,4,2}]'),(3,2,9,'[{1,[{0,38230003,7},{0,38240003,12}]},{2,[{0,38230003,7},{0,38240003,12}]},{3,[{0,38230003,7},{0,38240003,12}]},{4,[{0,38230003,7},{0,38240003,12}]}]','[{stage,eq,9},{quality,4,2}]'),(3,2,10,'[{1,[{0,38230003,12},{0,38240003,21}]},{2,[{0,38230003,12},{0,38240003,21}]},{3,[{0,38230003,12},{0,38240003,21}]},{4,[{0,38230003,12},{0,38240003,21}]}]','[{stage,eq,10},{quality,4,2}]'),(3,2,11,'[{1,[{0,38230003,18},{0,38240003,32}]},{2,[{0,38230003,18},{0,38240003,32}]},{3,[{0,38230003,18},{0,38240003,32}]},{4,[{0,38230003,18},{0,38240003,32}]}]','[{stage,eq,11},{quality,4,2}]'),(3,2,12,'[{1,[{0,38230003,25},{0,38240003,45}]},{2,[{0,38230003,25},{0,38240003,45}]},{3,[{0,38230003,25},{0,38240003,45}]},{4,[{0,38230003,25},{0,38240003,45}]}]','[{stage,eq,12},{quality,4,2}]'),(3,2,13,'[{1,[{0,38230003,35},{0,38240003,63}]},{2,[{0,38230003,35},{0,38240003,63}]},{3,[{0,38230003,35},{0,38240003,63}]},{4,[{0,38230003,35},{0,38240003,63}]}]','[{stage,eq,13},{quality,4,2}]'),(3,2,14,'[{1,[{0,38230003,45},{0,38240003,81}]},{2,[{0,38230003,45},{0,38240003,81}]},{3,[{0,38230003,45},{0,38240003,81}]},{4,[{0,38230003,45},{0,38240003,81}]}]','[{stage,eq,14},{quality,4,2}]'),(3,2,15,'[{1,[{0,38230003,60},{0,38240003,108}]},{2,[{0,38230003,60},{0,38240003,108}]},{3,[{0,38230003,60},{0,38240003,108}]},{4,[{0,38230003,60},{0,38240003,108}]}]','[{stage,eq,15},{quality,4,2}]'),(3,2,16,'[{1,[{0,38230003,80},{0,38240003,145}]},{2,[{0,38230003,80},{0,38240003,145}]},{3,[{0,38230003,80},{0,38240003,145}]},{4,[{0,38230003,80},{0,38240003,145}]}]','[{stage,eq,16},{quality,4,2}]'),(4,1,5,'[{1,[{0,38230104,25}]},{2,[{0,38230204,25}]},{3,[{0,38230304,25}]},{4,[{0,38230404,25}]}]','[{stage,eq,5},{quality,4,1}]'),(4,1,6,'[{1,[{0,38230104,50}]},{2,[{0,38230204,50}]},{3,[{0,38230304,50}]},{4,[{0,38230404,50}]}]','[{stage,eq,6},{quality,4,1}]'),(4,1,7,'[{1,[{0,38230104,90}]},{2,[{0,38230204,90}]},{3,[{0,38230304,90}]},{4,[{0,38230404,90}]}]','[{stage,eq,7},{quality,4,1}]'),(4,1,8,'[{1,[{0,38230104,160}]},{2,[{0,38230204,160}]},{3,[{0,38230304,160}]},{4,[{0,38230404,160}]}]','[{stage,eq,8},{quality,4,1}]'),(4,1,9,'[{1,[{0,38230104,280}]},{2,[{0,38230204,280}]},{3,[{0,38230304,280}]},{4,[{0,38230404,280}]}]','[{stage,eq,9},{quality,4,1}]'),(4,1,10,'[{1,[{0,38230104,450}]},{2,[{0,38230204,450}]},{3,[{0,38230304,450}]},{4,[{0,38230404,450}]}]','[{stage,eq,10},{quality,4,1}]'),(4,1,11,'[{1,[{0,38230104,700}]},{2,[{0,38230204,700}]},{3,[{0,38230304,700}]},{4,[{0,38230404,700}]}]','[{stage,eq,11},{quality,4,1}]'),(4,1,12,'[{1,[{0,38230104,1000}]},{2,[{0,38230204,1000}]},{3,[{0,38230304,1000}]},{4,[{0,38230404,1000}]}]','[{stage,eq,12},{quality,4,1}]'),(4,1,13,'[{1,[{0,38230104,1350}]},{2,[{0,38230204,1350}]},{3,[{0,38230304,1350}]},{4,[{0,38230404,1350}]}]','[{stage,eq,13},{quality,4,1}]'),(4,1,14,'[{1,[{0,38230104,1800}]},{2,[{0,38230204,1800}]},{3,[{0,38230304,1800}]},{4,[{0,38230404,1800}]}]','[{stage,eq,14},{quality,4,1}]'),(4,1,15,'[{1,[{0,38230104,2350}]},{2,[{0,38230204,2350}]},{3,[{0,38230304,2350}]},{4,[{0,38230404,2350}]}]','[{stage,eq,15},{quality,4,1}]'),(4,1,16,'[{1,[{0,38230104,3000}]},{2,[{0,38230204,3000}]},{3,[{0,38230304,3000}]},{4,[{0,38230404,3000}]}]','[{stage,eq,16},{quality,4,1}]'),(4,2,5,'[{1,[{0,38230104,5},{0,38240004,9}]},{2,[{0,38230204,5},{0,38240004,9}]},{3,[{0,38230304,5},{0,38240004,9}]},{4,[{0,38230404,5},{0,38240004,9}]}]','[{stage,eq,5},{quality,4,2}]'),(4,2,6,'[{1,[{0,38230104,10},{0,38240004,18}]},{2,[{0,38230204,10},{0,38240004,18}]},{3,[{0,38230304,10},{0,38240004,18}]},{4,[{0,38230404,10},{0,38240004,18}]}]','[{stage,eq,6},{quality,4,2}]'),(4,2,7,'[{1,[{0,38230104,20},{0,38240004,36}]},{2,[{0,38230204,20},{0,38240004,36}]},{3,[{0,38230304,20},{0,38240004,36}]},{4,[{0,38230404,20},{0,38240004,36}]}]','[{stage,eq,7},{quality,4,2}]'),(4,2,8,'[{1,[{0,38230104,40},{0,38240004,70}]},{2,[{0,38230204,40},{0,38240004,70}]},{3,[{0,38230304,40},{0,38240004,70}]},{4,[{0,38230404,40},{0,38240004,70}]}]','[{stage,eq,8},{quality,4,2}]'),(4,2,9,'[{1,[{0,38230104,70},{0,38240004,120}]},{2,[{0,38230204,70},{0,38240004,120}]},{3,[{0,38230304,70},{0,38240004,120}]},{4,[{0,38230404,70},{0,38240004,120}]}]','[{stage,eq,9},{quality,4,2}]'),(4,2,10,'[{1,[{0,38230104,120},{0,38240004,210}]},{2,[{0,38230204,120},{0,38240004,210}]},{3,[{0,38230304,120},{0,38240004,210}]},{4,[{0,38230404,120},{0,38240004,210}]}]','[{stage,eq,10},{quality,4,2}]'),(4,2,11,'[{1,[{0,38230104,180},{0,38240004,320}]},{2,[{0,38230204,180},{0,38240004,320}]},{3,[{0,38230304,180},{0,38240004,320}]},{4,[{0,38230404,180},{0,38240004,320}]}]','[{stage,eq,11},{quality,4,2}]'),(4,2,12,'[{1,[{0,38230104,250},{0,38240004,450}]},{2,[{0,38230204,250},{0,38240004,450}]},{3,[{0,38230304,250},{0,38240004,450}]},{4,[{0,38230404,250},{0,38240004,450}]}]','[{stage,eq,12},{quality,4,2}]'),(4,2,13,'[{1,[{0,38230104,350},{0,38240004,630}]},{2,[{0,38230204,350},{0,38240004,630}]},{3,[{0,38230304,350},{0,38240004,630}]},{4,[{0,38230404,350},{0,38240004,630}]}]','[{stage,eq,13},{quality,4,2}]'),(4,2,14,'[{1,[{0,38230104,450},{0,38240004,810}]},{2,[{0,38230204,450},{0,38240004,810}]},{3,[{0,38230304,450},{0,38240004,810}]},{4,[{0,38230404,450},{0,38240004,810}]}]','[{stage,eq,14},{quality,4,2}]'),(4,2,15,'[{1,[{0,38230104,600},{0,38240004,1080}]},{2,[{0,38230204,600},{0,38240004,1080}]},{3,[{0,38230304,600},{0,38240004,1080}]},{4,[{0,38230404,600},{0,38240004,1080}]}]','[{stage,eq,15},{quality,4,2}]'),(4,2,16,'[{1,[{0,38230104,800},{0,38240004,1450}]},{2,[{0,38230204,800},{0,38240004,1450}]},{3,[{0,38230304,800},{0,38240004,1450}]},{4,[{0,38230404,800},{0,38240004,1450}]}]','[{stage,eq,16},{quality,4,2}]'),(5,1,5,'[{1,[{0,38230005,3}]},{2,[{0,38230005,3}]},{3,[{0,38230005,3}]},{4,[{0,38230005,3}]}]','[{stage,eq,5},{quality,4,1}]'),(5,1,6,'[{1,[{0,38230005,5}]},{2,[{0,38230005,5}]},{3,[{0,38230005,5}]},{4,[{0,38230005,5}]}]','[{stage,eq,6},{quality,4,1}]'),(5,1,7,'[{1,[{0,38230005,9}]},{2,[{0,38230005,9}]},{3,[{0,38230005,9}]},{4,[{0,38230005,9}]}]','[{stage,eq,7},{quality,4,1}]'),(5,1,8,'[{1,[{0,38230005,16}]},{2,[{0,38230005,16}]},{3,[{0,38230005,16}]},{4,[{0,38230005,16}]}]','[{stage,eq,8},{quality,4,1}]'),(5,1,9,'[{1,[{0,38230005,28}]},{2,[{0,38230005,28}]},{3,[{0,38230005,28}]},{4,[{0,38230005,28}]}]','[{stage,eq,9},{quality,4,1}]'),(5,1,10,'[{1,[{0,38230005,45}]},{2,[{0,38230005,45}]},{3,[{0,38230005,45}]},{4,[{0,38230005,45}]}]','[{stage,eq,10},{quality,4,1}]'),(5,1,11,'[{1,[{0,38230005,70}]},{2,[{0,38230005,70}]},{3,[{0,38230005,70}]},{4,[{0,38230005,70}]}]','[{stage,eq,11},{quality,4,1}]'),(5,1,12,'[{1,[{0,38230005,100}]},{2,[{0,38230005,100}]},{3,[{0,38230005,100}]},{4,[{0,38230005,100}]}]','[{stage,eq,12},{quality,4,1}]'),(5,1,13,'[{1,[{0,38230005,135}]},{2,[{0,38230005,135}]},{3,[{0,38230005,135}]},{4,[{0,38230005,135}]}]','[{stage,eq,13},{quality,4,1}]'),(5,1,14,'[{1,[{0,38230005,180}]},{2,[{0,38230005,180}]},{3,[{0,38230005,180}]},{4,[{0,38230005,180}]}]','[{stage,eq,14},{quality,4,1}]'),(5,1,15,'[{1,[{0,38230005,235}]},{2,[{0,38230005,235}]},{3,[{0,38230005,235}]},{4,[{0,38230005,235}]}]','[{stage,eq,15},{quality,4,1}]'),(5,1,16,'[{1,[{0,38230005,300}]},{2,[{0,38230005,300}]},{3,[{0,38230005,300}]},{4,[{0,38230005,300}]}]','[{stage,eq,16},{quality,4,1}]'),(5,2,5,'[{1,[{0,38230005,1},{0,38240005,1}]},{2,[{0,38230005,1},{0,38240005,1}]},{3,[{0,38230005,1},{0,38240005,1}]},{4,[{0,38230005,1},{0,38240005,1}]}]','[{stage,eq,5},{quality,4,2}]'),(5,2,6,'[{1,[{0,38230005,1},{0,38240005,2}]},{2,[{0,38230005,1},{0,38240005,2}]},{3,[{0,38230005,1},{0,38240005,2}]},{4,[{0,38230005,1},{0,38240005,2}]}]','[{stage,eq,6},{quality,4,2}]'),(5,2,7,'[{1,[{0,38230005,2},{0,38240005,4}]},{2,[{0,38230005,2},{0,38240005,4}]},{3,[{0,38230005,2},{0,38240005,4}]},{4,[{0,38230005,2},{0,38240005,4}]}]','[{stage,eq,7},{quality,4,2}]'),(5,2,8,'[{1,[{0,38230005,4},{0,38240005,7}]},{2,[{0,38230005,4},{0,38240005,7}]},{3,[{0,38230005,4},{0,38240005,7}]},{4,[{0,38230005,4},{0,38240005,7}]}]','[{stage,eq,8},{quality,4,2}]'),(5,2,9,'[{1,[{0,38230005,7},{0,38240005,12}]},{2,[{0,38230005,7},{0,38240005,12}]},{3,[{0,38230005,7},{0,38240005,12}]},{4,[{0,38230005,7},{0,38240005,12}]}]','[{stage,eq,9},{quality,4,2}]'),(5,2,10,'[{1,[{0,38230005,12},{0,38240005,21}]},{2,[{0,38230005,12},{0,38240005,21}]},{3,[{0,38230005,12},{0,38240005,21}]},{4,[{0,38230005,12},{0,38240005,21}]}]','[{stage,eq,10},{quality,4,2}]'),(5,2,11,'[{1,[{0,38230005,18},{0,38240005,32}]},{2,[{0,38230005,18},{0,38240005,32}]},{3,[{0,38230005,18},{0,38240005,32}]},{4,[{0,38230005,18},{0,38240005,32}]}]','[{stage,eq,11},{quality,4,2}]'),(5,2,12,'[{1,[{0,38230005,25},{0,38240005,45}]},{2,[{0,38230005,25},{0,38240005,45}]},{3,[{0,38230005,25},{0,38240005,45}]},{4,[{0,38230005,25},{0,38240005,45}]}]','[{stage,eq,12},{quality,4,2}]'),(5,2,13,'[{1,[{0,38230005,35},{0,38240005,63}]},{2,[{0,38230005,35},{0,38240005,63}]},{3,[{0,38230005,35},{0,38240005,63}]},{4,[{0,38230005,35},{0,38240005,63}]}]','[{stage,eq,13},{quality,4,2}]'),(5,2,14,'[{1,[{0,38230005,45},{0,38240005,81}]},{2,[{0,38230005,45},{0,38240005,81}]},{3,[{0,38230005,45},{0,38240005,81}]},{4,[{0,38230005,45},{0,38240005,81}]}]','[{stage,eq,14},{quality,4,2}]'),(5,2,15,'[{1,[{0,38230005,60},{0,38240005,108}]},{2,[{0,38230005,60},{0,38240005,108}]},{3,[{0,38230005,60},{0,38240005,108}]},{4,[{0,38230005,60},{0,38240005,108}]}]','[{stage,eq,15},{quality,4,2}]'),(5,2,16,'[{1,[{0,38230005,80},{0,38240005,145}]},{2,[{0,38230005,80},{0,38240005,145}]},{3,[{0,38230005,80},{0,38240005,145}]},{4,[{0,38230005,80},{0,38240005,145}]}]','[{stage,eq,16},{quality,4,2}]'),(6,1,5,'[{1,[{0,38230106,25}]},{2,[{0,38230206,25}]},{3,[{0,38230306,25}]},{4,[{0,38230406,25}]}]','[{stage,eq,5},{quality,4,1}]'),(6,1,6,'[{1,[{0,38230106,50}]},{2,[{0,38230206,50}]},{3,[{0,38230306,50}]},{4,[{0,38230406,50}]}]','[{stage,eq,6},{quality,4,1}]'),(6,1,7,'[{1,[{0,38230106,90}]},{2,[{0,38230206,90}]},{3,[{0,38230306,90}]},{4,[{0,38230406,90}]}]','[{stage,eq,7},{quality,4,1}]'),(6,1,8,'[{1,[{0,38230106,160}]},{2,[{0,38230206,160}]},{3,[{0,38230306,160}]},{4,[{0,38230406,160}]}]','[{stage,eq,8},{quality,4,1}]'),(6,1,9,'[{1,[{0,38230106,280}]},{2,[{0,38230206,280}]},{3,[{0,38230306,280}]},{4,[{0,38230406,280}]}]','[{stage,eq,9},{quality,4,1}]'),(6,1,10,'[{1,[{0,38230106,450}]},{2,[{0,38230206,450}]},{3,[{0,38230306,450}]},{4,[{0,38230406,450}]}]','[{stage,eq,10},{quality,4,1}]'),(6,1,11,'[{1,[{0,38230106,700}]},{2,[{0,38230206,700}]},{3,[{0,38230306,700}]},{4,[{0,38230406,700}]}]','[{stage,eq,11},{quality,4,1}]'),(6,1,12,'[{1,[{0,38230106,1000}]},{2,[{0,38230206,1000}]},{3,[{0,38230306,1000}]},{4,[{0,38230406,1000}]}]','[{stage,eq,12},{quality,4,1}]'),(6,1,13,'[{1,[{0,38230106,1350}]},{2,[{0,38230206,1350}]},{3,[{0,38230306,1350}]},{4,[{0,38230406,1350}]}]','[{stage,eq,13},{quality,4,1}]'),(6,1,14,'[{1,[{0,38230106,1800}]},{2,[{0,38230206,1800}]},{3,[{0,38230306,1800}]},{4,[{0,38230406,1800}]}]','[{stage,eq,14},{quality,4,1}]'),(6,1,15,'[{1,[{0,38230106,2350}]},{2,[{0,38230206,2350}]},{3,[{0,38230306,2350}]},{4,[{0,38230406,2350}]}]','[{stage,eq,15},{quality,4,1}]'),(6,1,16,'[{1,[{0,38230106,3000}]},{2,[{0,38230206,3000}]},{3,[{0,38230306,3000}]},{4,[{0,38230406,3000}]}]','[{stage,eq,16},{quality,4,1}]'),(6,2,5,'[{1,[{0,38230106,5},{0,38240006,9}]},{2,[{0,38230206,5},{0,38240006,9}]},{3,[{0,38230306,5},{0,38240006,9}]},{4,[{0,38230406,5},{0,38240006,9}]}]','[{stage,eq,5},{quality,4,2}]'),(6,2,6,'[{1,[{0,38230106,10},{0,38240006,18}]},{2,[{0,38230206,10},{0,38240006,18}]},{3,[{0,38230306,10},{0,38240006,18}]},{4,[{0,38230406,10},{0,38240006,18}]}]','[{stage,eq,6},{quality,4,2}]'),(6,2,7,'[{1,[{0,38230106,20},{0,38240006,36}]},{2,[{0,38230206,20},{0,38240006,36}]},{3,[{0,38230306,20},{0,38240006,36}]},{4,[{0,38230406,20},{0,38240006,36}]}]','[{stage,eq,7},{quality,4,2}]'),(6,2,8,'[{1,[{0,38230106,40},{0,38240006,70}]},{2,[{0,38230206,40},{0,38240006,70}]},{3,[{0,38230306,40},{0,38240006,70}]},{4,[{0,38230406,40},{0,38240006,70}]}]','[{stage,eq,8},{quality,4,2}]'),(6,2,9,'[{1,[{0,38230106,70},{0,38240006,120}]},{2,[{0,38230206,70},{0,38240006,120}]},{3,[{0,38230306,70},{0,38240006,120}]},{4,[{0,38230406,70},{0,38240006,120}]}]','[{stage,eq,9},{quality,4,2}]'),(6,2,10,'[{1,[{0,38230106,120},{0,38240006,210}]},{2,[{0,38230206,120},{0,38240006,210}]},{3,[{0,38230306,120},{0,38240006,210}]},{4,[{0,38230406,120},{0,38240006,210}]}]','[{stage,eq,10},{quality,4,2}]'),(6,2,11,'[{1,[{0,38230106,180},{0,38240006,320}]},{2,[{0,38230206,180},{0,38240006,320}]},{3,[{0,38230306,180},{0,38240006,320}]},{4,[{0,38230406,180},{0,38240006,320}]}]','[{stage,eq,11},{quality,4,2}]'),(6,2,12,'[{1,[{0,38230106,250},{0,38240006,450}]},{2,[{0,38230206,250},{0,38240006,450}]},{3,[{0,38230306,250},{0,38240006,450}]},{4,[{0,38230406,250},{0,38240006,450}]}]','[{stage,eq,12},{quality,4,2}]'),(6,2,13,'[{1,[{0,38230106,350},{0,38240006,630}]},{2,[{0,38230206,350},{0,38240006,630}]},{3,[{0,38230306,350},{0,38240006,630}]},{4,[{0,38230406,350},{0,38240006,630}]}]','[{stage,eq,13},{quality,4,2}]'),(6,2,14,'[{1,[{0,38230106,450},{0,38240006,810}]},{2,[{0,38230206,450},{0,38240006,810}]},{3,[{0,38230306,450},{0,38240006,810}]},{4,[{0,38230406,450},{0,38240006,810}]}]','[{stage,eq,14},{quality,4,2}]'),(6,2,15,'[{1,[{0,38230106,600},{0,38240006,1080}]},{2,[{0,38230206,600},{0,38240006,1080}]},{3,[{0,38230306,600},{0,38240006,1080}]},{4,[{0,38230406,600},{0,38240006,1080}]}]','[{stage,eq,15},{quality,4,2}]'),(6,2,16,'[{1,[{0,38230106,800},{0,38240006,1450}]},{2,[{0,38230206,800},{0,38240006,1450}]},{3,[{0,38230306,800},{0,38240006,1450}]},{4,[{0,38230406,800},{0,38240006,1450}]}]','[{stage,eq,16},{quality,4,2}]'),(7,1,5,'[{1,[{0,38230107,13}]},{2,[{0,38230207,13}]},{3,[{0,38230307,13}]},{4,[{0,38230407,13}]}]','[{stage,eq,5},{quality,4,1}]'),(7,1,6,'[{1,[{0,38230107,25}]},{2,[{0,38230207,25}]},{3,[{0,38230307,25}]},{4,[{0,38230407,25}]}]','[{stage,eq,6},{quality,4,1}]'),(7,1,7,'[{1,[{0,38230107,45}]},{2,[{0,38230207,45}]},{3,[{0,38230307,45}]},{4,[{0,38230407,45}]}]','[{stage,eq,7},{quality,4,1}]'),(7,1,8,'[{1,[{0,38230107,80}]},{2,[{0,38230207,80}]},{3,[{0,38230307,80}]},{4,[{0,38230407,80}]}]','[{stage,eq,8},{quality,4,1}]'),(7,1,9,'[{1,[{0,38230107,140}]},{2,[{0,38230207,140}]},{3,[{0,38230307,140}]},{4,[{0,38230407,140}]}]','[{stage,eq,9},{quality,4,1}]'),(7,1,10,'[{1,[{0,38230107,225}]},{2,[{0,38230207,225}]},{3,[{0,38230307,225}]},{4,[{0,38230407,225}]}]','[{stage,eq,10},{quality,4,1}]'),(7,1,11,'[{1,[{0,38230107,350}]},{2,[{0,38230207,350}]},{3,[{0,38230307,350}]},{4,[{0,38230407,350}]}]','[{stage,eq,11},{quality,4,1}]'),(7,1,12,'[{1,[{0,38230107,500}]},{2,[{0,38230207,500}]},{3,[{0,38230307,500}]},{4,[{0,38230407,500}]}]','[{stage,eq,12},{quality,4,1}]'),(7,1,13,'[{1,[{0,38230107,675}]},{2,[{0,38230207,675}]},{3,[{0,38230307,675}]},{4,[{0,38230407,675}]}]','[{stage,eq,13},{quality,4,1}]'),(7,1,14,'[{1,[{0,38230107,900}]},{2,[{0,38230207,900}]},{3,[{0,38230307,900}]},{4,[{0,38230407,900}]}]','[{stage,eq,14},{quality,4,1}]'),(7,1,15,'[{1,[{0,38230107,1175}]},{2,[{0,38230207,1175}]},{3,[{0,38230307,1175}]},{4,[{0,38230407,1175}]}]','[{stage,eq,15},{quality,4,1}]'),(7,1,16,'[{1,[{0,38230107,1500}]},{2,[{0,38230207,1500}]},{3,[{0,38230307,1500}]},{4,[{0,38230407,1500}]}]','[{stage,eq,16},{quality,4,1}]'),(7,2,5,'[{1,[{0,38230107,3},{0,38240007,5}]},{2,[{0,38230207,3},{0,38240007,5}]},{3,[{0,38230307,3},{0,38240007,5}]},{4,[{0,38230407,3},{0,38240007,5}]}]','[{stage,eq,5},{quality,4,2}]'),(7,2,6,'[{1,[{0,38230107,5},{0,38240007,9}]},{2,[{0,38230207,5},{0,38240007,9}]},{3,[{0,38230307,5},{0,38240007,9}]},{4,[{0,38230407,5},{0,38240007,9}]}]','[{stage,eq,6},{quality,4,2}]'),(7,2,7,'[{1,[{0,38230107,10},{0,38240007,18}]},{2,[{0,38230207,10},{0,38240007,18}]},{3,[{0,38230307,10},{0,38240007,18}]},{4,[{0,38230407,10},{0,38240007,18}]}]','[{stage,eq,7},{quality,4,2}]'),(7,2,8,'[{1,[{0,38230107,20},{0,38240007,35}]},{2,[{0,38230207,20},{0,38240007,35}]},{3,[{0,38230307,20},{0,38240007,35}]},{4,[{0,38230407,20},{0,38240007,35}]}]','[{stage,eq,8},{quality,4,2}]'),(7,2,9,'[{1,[{0,38230107,35},{0,38240007,60}]},{2,[{0,38230207,35},{0,38240007,60}]},{3,[{0,38230307,35},{0,38240007,60}]},{4,[{0,38230407,35},{0,38240007,60}]}]','[{stage,eq,9},{quality,4,2}]'),(7,2,10,'[{1,[{0,38230107,60},{0,38240007,105}]},{2,[{0,38230207,60},{0,38240007,105}]},{3,[{0,38230307,60},{0,38240007,105}]},{4,[{0,38230407,60},{0,38240007,105}]}]','[{stage,eq,10},{quality,4,2}]'),(7,2,11,'[{1,[{0,38230107,90},{0,38240007,160}]},{2,[{0,38230207,90},{0,38240007,160}]},{3,[{0,38230307,90},{0,38240007,160}]},{4,[{0,38230407,90},{0,38240007,160}]}]','[{stage,eq,11},{quality,4,2}]'),(7,2,12,'[{1,[{0,38230107,125},{0,38240007,225}]},{2,[{0,38230207,125},{0,38240007,225}]},{3,[{0,38230307,125},{0,38240007,225}]},{4,[{0,38230407,125},{0,38240007,225}]}]','[{stage,eq,12},{quality,4,2}]'),(7,2,13,'[{1,[{0,38230107,175},{0,38240007,315}]},{2,[{0,38230207,175},{0,38240007,315}]},{3,[{0,38230307,175},{0,38240007,315}]},{4,[{0,38230407,175},{0,38240007,315}]}]','[{stage,eq,13},{quality,4,2}]'),(7,2,14,'[{1,[{0,38230107,225},{0,38240007,405}]},{2,[{0,38230207,225},{0,38240007,405}]},{3,[{0,38230307,225},{0,38240007,405}]},{4,[{0,38230407,225},{0,38240007,405}]}]','[{stage,eq,14},{quality,4,2}]'),(7,2,15,'[{1,[{0,38230107,300},{0,38240007,540}]},{2,[{0,38230207,300},{0,38240007,540}]},{3,[{0,38230307,300},{0,38240007,540}]},{4,[{0,38230407,300},{0,38240007,540}]}]','[{stage,eq,15},{quality,4,2}]'),(7,2,16,'[{1,[{0,38230107,400},{0,38240007,725}]},{2,[{0,38230207,400},{0,38240007,725}]},{3,[{0,38230307,400},{0,38240007,725}]},{4,[{0,38230407,400},{0,38240007,725}]}]','[{stage,eq,16},{quality,4,2}]'),(8,1,5,'[{1,[{0,38230108,25}]},{2,[{0,38230208,25}]},{3,[{0,38230308,25}]},{4,[{0,38230408,25}]}]','[{stage,eq,5},{quality,4,1}]'),(8,1,6,'[{1,[{0,38230108,50}]},{2,[{0,38230208,50}]},{3,[{0,38230308,50}]},{4,[{0,38230408,50}]}]','[{stage,eq,6},{quality,4,1}]'),(8,1,7,'[{1,[{0,38230108,90}]},{2,[{0,38230208,90}]},{3,[{0,38230308,90}]},{4,[{0,38230408,90}]}]','[{stage,eq,7},{quality,4,1}]'),(8,1,8,'[{1,[{0,38230108,160}]},{2,[{0,38230208,160}]},{3,[{0,38230308,160}]},{4,[{0,38230408,160}]}]','[{stage,eq,8},{quality,4,1}]'),(8,1,9,'[{1,[{0,38230108,280}]},{2,[{0,38230208,280}]},{3,[{0,38230308,280}]},{4,[{0,38230408,280}]}]','[{stage,eq,9},{quality,4,1}]'),(8,1,10,'[{1,[{0,38230108,450}]},{2,[{0,38230208,450}]},{3,[{0,38230308,450}]},{4,[{0,38230408,450}]}]','[{stage,eq,10},{quality,4,1}]'),(8,1,11,'[{1,[{0,38230108,700}]},{2,[{0,38230208,700}]},{3,[{0,38230308,700}]},{4,[{0,38230408,700}]}]','[{stage,eq,11},{quality,4,1}]'),(8,1,12,'[{1,[{0,38230108,1000}]},{2,[{0,38230208,1000}]},{3,[{0,38230308,1000}]},{4,[{0,38230408,1000}]}]','[{stage,eq,12},{quality,4,1}]'),(8,1,13,'[{1,[{0,38230108,1350}]},{2,[{0,38230208,1350}]},{3,[{0,38230308,1350}]},{4,[{0,38230408,1350}]}]','[{stage,eq,13},{quality,4,1}]'),(8,1,14,'[{1,[{0,38230108,1800}]},{2,[{0,38230208,1800}]},{3,[{0,38230308,1800}]},{4,[{0,38230408,1800}]}]','[{stage,eq,14},{quality,4,1}]'),(8,1,15,'[{1,[{0,38230108,2350}]},{2,[{0,38230208,2350}]},{3,[{0,38230308,2350}]},{4,[{0,38230408,2350}]}]','[{stage,eq,15},{quality,4,1}]'),(8,1,16,'[{1,[{0,38230108,3000}]},{2,[{0,38230208,3000}]},{3,[{0,38230308,3000}]},{4,[{0,38230408,3000}]}]','[{stage,eq,16},{quality,4,1}]'),(8,2,5,'[{1,[{0,38230108,5},{0,38240008,9}]},{2,[{0,38230208,5},{0,38240008,9}]},{3,[{0,38230308,5},{0,38240008,9}]},{4,[{0,38230408,5},{0,38240008,9}]}]','[{stage,eq,5},{quality,4,2}]'),(8,2,6,'[{1,[{0,38230108,10},{0,38240008,18}]},{2,[{0,38230208,10},{0,38240008,18}]},{3,[{0,38230308,10},{0,38240008,18}]},{4,[{0,38230408,10},{0,38240008,18}]}]','[{stage,eq,6},{quality,4,2}]'),(8,2,7,'[{1,[{0,38230108,20},{0,38240008,36}]},{2,[{0,38230208,20},{0,38240008,36}]},{3,[{0,38230308,20},{0,38240008,36}]},{4,[{0,38230408,20},{0,38240008,36}]}]','[{stage,eq,7},{quality,4,2}]'),(8,2,8,'[{1,[{0,38230108,40},{0,38240008,70}]},{2,[{0,38230208,40},{0,38240008,70}]},{3,[{0,38230308,40},{0,38240008,70}]},{4,[{0,38230408,40},{0,38240008,70}]}]','[{stage,eq,8},{quality,4,2}]'),(8,2,9,'[{1,[{0,38230108,70},{0,38240008,120}]},{2,[{0,38230208,70},{0,38240008,120}]},{3,[{0,38230308,70},{0,38240008,120}]},{4,[{0,38230408,70},{0,38240008,120}]}]','[{stage,eq,9},{quality,4,2}]'),(8,2,10,'[{1,[{0,38230108,120},{0,38240008,210}]},{2,[{0,38230208,120},{0,38240008,210}]},{3,[{0,38230308,120},{0,38240008,210}]},{4,[{0,38230408,120},{0,38240008,210}]}]','[{stage,eq,10},{quality,4,2}]'),(8,2,11,'[{1,[{0,38230108,180},{0,38240008,320}]},{2,[{0,38230208,180},{0,38240008,320}]},{3,[{0,38230308,180},{0,38240008,320}]},{4,[{0,38230408,180},{0,38240008,320}]}]','[{stage,eq,11},{quality,4,2}]'),(8,2,12,'[{1,[{0,38230108,250},{0,38240008,450}]},{2,[{0,38230208,250},{0,38240008,450}]},{3,[{0,38230308,250},{0,38240008,450}]},{4,[{0,38230408,250},{0,38240008,450}]}]','[{stage,eq,12},{quality,4,2}]'),(8,2,13,'[{1,[{0,38230108,350},{0,38240008,630}]},{2,[{0,38230208,350},{0,38240008,630}]},{3,[{0,38230308,350},{0,38240008,630}]},{4,[{0,38230408,350},{0,38240008,630}]}]','[{stage,eq,13},{quality,4,2}]'),(8,2,14,'[{1,[{0,38230108,450},{0,38240008,810}]},{2,[{0,38230208,450},{0,38240008,810}]},{3,[{0,38230308,450},{0,38240008,810}]},{4,[{0,38230408,450},{0,38240008,810}]}]','[{stage,eq,14},{quality,4,2}]'),(8,2,15,'[{1,[{0,38230108,600},{0,38240008,1080}]},{2,[{0,38230208,600},{0,38240008,1080}]},{3,[{0,38230308,600},{0,38240008,1080}]},{4,[{0,38230408,600},{0,38240008,1080}]}]','[{stage,eq,15},{quality,4,2}]'),(8,2,16,'[{1,[{0,38230108,800},{0,38240008,1450}]},{2,[{0,38230208,800},{0,38240008,1450}]},{3,[{0,38230308,800},{0,38240008,1450}]},{4,[{0,38230408,800},{0,38240008,1450}]}]','[{stage,eq,16},{quality,4,2}]'),(9,1,5,'[{1,[{0,38230009,3}]},{2,[{0,38230009,3}]},{3,[{0,38230009,3}]},{4,[{0,38230009,3}]}]','[{stage,eq,5},{quality,4,1}]'),(9,1,6,'[{1,[{0,38230009,5}]},{2,[{0,38230009,5}]},{3,[{0,38230009,5}]},{4,[{0,38230009,5}]}]','[{stage,eq,6},{quality,4,1}]'),(9,1,7,'[{1,[{0,38230009,9}]},{2,[{0,38230009,9}]},{3,[{0,38230009,9}]},{4,[{0,38230009,9}]}]','[{stage,eq,7},{quality,4,1}]'),(9,1,8,'[{1,[{0,38230009,16}]},{2,[{0,38230009,16}]},{3,[{0,38230009,16}]},{4,[{0,38230009,16}]}]','[{stage,eq,8},{quality,4,1}]'),(9,1,9,'[{1,[{0,38230009,28}]},{2,[{0,38230009,28}]},{3,[{0,38230009,28}]},{4,[{0,38230009,28}]}]','[{stage,eq,9},{quality,4,1}]'),(9,1,10,'[{1,[{0,38230009,45}]},{2,[{0,38230009,45}]},{3,[{0,38230009,45}]},{4,[{0,38230009,45}]}]','[{stage,eq,10},{quality,4,1}]'),(9,1,11,'[{1,[{0,38230009,70}]},{2,[{0,38230009,70}]},{3,[{0,38230009,70}]},{4,[{0,38230009,70}]}]','[{stage,eq,11},{quality,4,1}]'),(9,1,12,'[{1,[{0,38230009,100}]},{2,[{0,38230009,100}]},{3,[{0,38230009,100}]},{4,[{0,38230009,100}]}]','[{stage,eq,12},{quality,4,1}]'),(9,1,13,'[{1,[{0,38230009,135}]},{2,[{0,38230009,135}]},{3,[{0,38230009,135}]},{4,[{0,38230009,135}]}]','[{stage,eq,13},{quality,4,1}]'),(9,1,14,'[{1,[{0,38230009,180}]},{2,[{0,38230009,180}]},{3,[{0,38230009,180}]},{4,[{0,38230009,180}]}]','[{stage,eq,14},{quality,4,1}]'),(9,1,15,'[{1,[{0,38230009,235}]},{2,[{0,38230009,235}]},{3,[{0,38230009,235}]},{4,[{0,38230009,235}]}]','[{stage,eq,15},{quality,4,1}]'),(9,1,16,'[{1,[{0,38230009,300}]},{2,[{0,38230009,300}]},{3,[{0,38230009,300}]},{4,[{0,38230009,300}]}]','[{stage,eq,16},{quality,4,1}]'),(9,2,5,'[{1,[{0,38230009,1},{0,38240009,1}]},{2,[{0,38230009,1},{0,38240009,1}]},{3,[{0,38230009,1},{0,38240009,1}]},{4,[{0,38230009,1},{0,38240009,1}]}]','[{stage,eq,5},{quality,4,2}]'),(9,2,6,'[{1,[{0,38230009,1},{0,38240009,2}]},{2,[{0,38230009,1},{0,38240009,2}]},{3,[{0,38230009,1},{0,38240009,2}]},{4,[{0,38230009,1},{0,38240009,2}]}]','[{stage,eq,6},{quality,4,2}]'),(9,2,7,'[{1,[{0,38230009,2},{0,38240009,4}]},{2,[{0,38230009,2},{0,38240009,4}]},{3,[{0,38230009,2},{0,38240009,4}]},{4,[{0,38230009,2},{0,38240009,4}]}]','[{stage,eq,7},{quality,4,2}]'),(9,2,8,'[{1,[{0,38230009,4},{0,38240009,7}]},{2,[{0,38230009,4},{0,38240009,7}]},{3,[{0,38230009,4},{0,38240009,7}]},{4,[{0,38230009,4},{0,38240009,7}]}]','[{stage,eq,8},{quality,4,2}]'),(9,2,9,'[{1,[{0,38230009,7},{0,38240009,12}]},{2,[{0,38230009,7},{0,38240009,12}]},{3,[{0,38230009,7},{0,38240009,12}]},{4,[{0,38230009,7},{0,38240009,12}]}]','[{stage,eq,9},{quality,4,2}]'),(9,2,10,'[{1,[{0,38230009,12},{0,38240009,21}]},{2,[{0,38230009,12},{0,38240009,21}]},{3,[{0,38230009,12},{0,38240009,21}]},{4,[{0,38230009,12},{0,38240009,21}]}]','[{stage,eq,10},{quality,4,2}]'),(9,2,11,'[{1,[{0,38230009,18},{0,38240009,32}]},{2,[{0,38230009,18},{0,38240009,32}]},{3,[{0,38230009,18},{0,38240009,32}]},{4,[{0,38230009,18},{0,38240009,32}]}]','[{stage,eq,11},{quality,4,2}]'),(9,2,12,'[{1,[{0,38230009,25},{0,38240009,45}]},{2,[{0,38230009,25},{0,38240009,45}]},{3,[{0,38230009,25},{0,38240009,45}]},{4,[{0,38230009,25},{0,38240009,45}]}]','[{stage,eq,12},{quality,4,2}]'),(9,2,13,'[{1,[{0,38230009,35},{0,38240009,63}]},{2,[{0,38230009,35},{0,38240009,63}]},{3,[{0,38230009,35},{0,38240009,63}]},{4,[{0,38230009,35},{0,38240009,63}]}]','[{stage,eq,13},{quality,4,2}]'),(9,2,14,'[{1,[{0,38230009,45},{0,38240009,81}]},{2,[{0,38230009,45},{0,38240009,81}]},{3,[{0,38230009,45},{0,38240009,81}]},{4,[{0,38230009,45},{0,38240009,81}]}]','[{stage,eq,14},{quality,4,2}]'),(9,2,15,'[{1,[{0,38230009,60},{0,38240009,108}]},{2,[{0,38230009,60},{0,38240009,108}]},{3,[{0,38230009,60},{0,38240009,108}]},{4,[{0,38230009,60},{0,38240009,108}]}]','[{stage,eq,15},{quality,4,2}]'),(9,2,16,'[{1,[{0,38230009,80},{0,38240009,145}]},{2,[{0,38230009,80},{0,38240009,145}]},{3,[{0,38230009,80},{0,38240009,145}]},{4,[{0,38230009,80},{0,38240009,145}]}]','[{stage,eq,16},{quality,4,2}]'),(10,1,5,'[{1,[{0,38230110,25}]},{2,[{0,38230210,25}]},{3,[{0,38230310,25}]},{4,[{0,38230410,25}]}]','[{stage,eq,5},{quality,4,1}]'),(10,1,6,'[{1,[{0,38230110,50}]},{2,[{0,38230210,50}]},{3,[{0,38230310,50}]},{4,[{0,38230410,50}]}]','[{stage,eq,6},{quality,4,1}]'),(10,1,7,'[{1,[{0,38230110,90}]},{2,[{0,38230210,90}]},{3,[{0,38230310,90}]},{4,[{0,38230410,90}]}]','[{stage,eq,7},{quality,4,1}]'),(10,1,8,'[{1,[{0,38230110,160}]},{2,[{0,38230210,160}]},{3,[{0,38230310,160}]},{4,[{0,38230410,160}]}]','[{stage,eq,8},{quality,4,1}]'),(10,1,9,'[{1,[{0,38230110,280}]},{2,[{0,38230210,280}]},{3,[{0,38230310,280}]},{4,[{0,38230410,280}]}]','[{stage,eq,9},{quality,4,1}]'),(10,1,10,'[{1,[{0,38230110,450}]},{2,[{0,38230210,450}]},{3,[{0,38230310,450}]},{4,[{0,38230410,450}]}]','[{stage,eq,10},{quality,4,1}]'),(10,1,11,'[{1,[{0,38230110,700}]},{2,[{0,38230210,700}]},{3,[{0,38230310,700}]},{4,[{0,38230410,700}]}]','[{stage,eq,11},{quality,4,1}]'),(10,1,12,'[{1,[{0,38230110,1000}]},{2,[{0,38230210,1000}]},{3,[{0,38230310,1000}]},{4,[{0,38230410,1000}]}]','[{stage,eq,12},{quality,4,1}]'),(10,1,13,'[{1,[{0,38230110,1350}]},{2,[{0,38230210,1350}]},{3,[{0,38230310,1350}]},{4,[{0,38230410,1350}]}]','[{stage,eq,13},{quality,4,1}]'),(10,1,14,'[{1,[{0,38230110,1800}]},{2,[{0,38230210,1800}]},{3,[{0,38230310,1800}]},{4,[{0,38230410,1800}]}]','[{stage,eq,14},{quality,4,1}]'),(10,1,15,'[{1,[{0,38230110,2350}]},{2,[{0,38230210,2350}]},{3,[{0,38230310,2350}]},{4,[{0,38230410,2350}]}]','[{stage,eq,15},{quality,4,1}]'),(10,1,16,'[{1,[{0,38230110,3000}]},{2,[{0,38230210,3000}]},{3,[{0,38230310,3000}]},{4,[{0,38230410,3000}]}]','[{stage,eq,16},{quality,4,1}]'),(10,2,5,'[{1,[{0,38230110,5},{0,38240010,9}]},{2,[{0,38230210,5},{0,38240010,9}]},{3,[{0,38230310,5},{0,38240010,9}]},{4,[{0,38230410,5},{0,38240010,9}]}]','[{stage,eq,5},{quality,4,2}]'),(10,2,6,'[{1,[{0,38230110,10},{0,38240010,18}]},{2,[{0,38230210,10},{0,38240010,18}]},{3,[{0,38230310,10},{0,38240010,18}]},{4,[{0,38230410,10},{0,38240010,18}]}]','[{stage,eq,6},{quality,4,2}]'),(10,2,7,'[{1,[{0,38230110,20},{0,38240010,36}]},{2,[{0,38230210,20},{0,38240010,36}]},{3,[{0,38230310,20},{0,38240010,36}]},{4,[{0,38230410,20},{0,38240010,36}]}]','[{stage,eq,7},{quality,4,2}]'),(10,2,8,'[{1,[{0,38230110,40},{0,38240010,70}]},{2,[{0,38230210,40},{0,38240010,70}]},{3,[{0,38230310,40},{0,38240010,70}]},{4,[{0,38230410,40},{0,38240010,70}]}]','[{stage,eq,8},{quality,4,2}]'),(10,2,9,'[{1,[{0,38230110,70},{0,38240010,120}]},{2,[{0,38230210,70},{0,38240010,120}]},{3,[{0,38230310,70},{0,38240010,120}]},{4,[{0,38230410,70},{0,38240010,120}]}]','[{stage,eq,9},{quality,4,2}]'),(10,2,10,'[{1,[{0,38230110,120},{0,38240010,210}]},{2,[{0,38230210,120},{0,38240010,210}]},{3,[{0,38230310,120},{0,38240010,210}]},{4,[{0,38230410,120},{0,38240010,210}]}]','[{stage,eq,10},{quality,4,2}]'),(10,2,11,'[{1,[{0,38230110,180},{0,38240010,320}]},{2,[{0,38230210,180},{0,38240010,320}]},{3,[{0,38230310,180},{0,38240010,320}]},{4,[{0,38230410,180},{0,38240010,320}]}]','[{stage,eq,11},{quality,4,2}]'),(10,2,12,'[{1,[{0,38230110,250},{0,38240010,450}]},{2,[{0,38230210,250},{0,38240010,450}]},{3,[{0,38230310,250},{0,38240010,450}]},{4,[{0,38230410,250},{0,38240010,450}]}]','[{stage,eq,12},{quality,4,2}]'),(10,2,13,'[{1,[{0,38230110,350},{0,38240010,630}]},{2,[{0,38230210,350},{0,38240010,630}]},{3,[{0,38230310,350},{0,38240010,630}]},{4,[{0,38230410,350},{0,38240010,630}]}]','[{stage,eq,13},{quality,4,2}]'),(10,2,14,'[{1,[{0,38230110,450},{0,38240010,810}]},{2,[{0,38230210,450},{0,38240010,810}]},{3,[{0,38230310,450},{0,38240010,810}]},{4,[{0,38230410,450},{0,38240010,810}]}]','[{stage,eq,14},{quality,4,2}]'),(10,2,15,'[{1,[{0,38230110,600},{0,38240010,1080}]},{2,[{0,38230210,600},{0,38240010,1080}]},{3,[{0,38230310,600},{0,38240010,1080}]},{4,[{0,38230410,600},{0,38240010,1080}]}]','[{stage,eq,15},{quality,4,2}]'),(10,2,16,'[{1,[{0,38230110,800},{0,38240010,1450}]},{2,[{0,38230210,800},{0,38240010,1450}]},{3,[{0,38230310,800},{0,38240010,1450}]},{4,[{0,38230410,800},{0,38240010,1450}]}]','[{stage,eq,16},{quality,4,2}]');
/*!40000 ALTER TABLE `base_equip_suit_make` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_equip_type`
--

DROP TABLE IF EXISTS `base_equip_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_equip_type` (
  `type` int(11) NOT NULL COMMENT '装备类型',
  `type_name` varchar(50) NOT NULL COMMENT '名称',
  PRIMARY KEY (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备类型配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_equip_type`
--

LOCK TABLES `base_equip_type` WRITE;
/*!40000 ALTER TABLE `base_equip_type` DISABLE KEYS */;
INSERT INTO `base_equip_type` VALUES (0,'无'),(1,'武器'),(2,'头盔'),(3,'项链'),(4,'护腕'),(5,'戒指'),(6,'衣服'),(7,'圣物'),(8,'腰带'),(9,'护符'),(10,'鞋子');
/*!40000 ALTER TABLE `base_equip_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_equip_upgrade_stage`
--

DROP TABLE IF EXISTS `base_equip_upgrade_stage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_equip_upgrade_stage` (
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '装备id',
  `type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `ngoods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '进阶后的装备id',
  PRIMARY KEY (`goods_id`,`type`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备进阶表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_equip_upgrade_stage`
--

LOCK TABLES `base_equip_upgrade_stage` WRITE;
/*!40000 ALTER TABLE `base_equip_upgrade_stage` DISABLE KEYS */;
INSERT INTO `base_equip_upgrade_stage` VALUES (1005000710,2,'[{0,1005000710,2}]',1005000720),(1005000731,1,'[{0,38040400,1}]',1005000941),(1005000731,2,'[{0,38040402,1},{0,1005000731,1}]',1005000732),(1005000732,1,'[{0,38040400,1}]',1005000942),(1005000910,2,'[{0,1005000910,2}]',1005000920),(1005000941,1,'[{0,38040400,1}]',1005001041),(1005000941,2,'[{0,38040402,1},{0,1005000731,1}]',1005000942),(1005000942,1,'[{0,38040400,1}]',1005001042),(1005000942,2,'[{0,38040402,2}]',1005000943),(1005000943,1,'[{0,38040400,1}]',1005001043),(1005000943,2,'[{0,38040402,3},{0,38280520,6}]',1005000953),(1005000953,1,'[{0,38040400,1},{0,38280520,3}]',1005001053),(1005001041,1,'[{0,38040400,1}]',1005001141),(1005001041,2,'[{0,38040402,1},{0,1005000731,1}]',1005001042),(1005001042,1,'[{0,38040400,1}]',1005001142),(1005001042,2,'[{0,38040402,2}]',1005001043),(1005001043,1,'[{0,38040400,1}]',1005001143),(1005001043,2,'[{0,38040402,3},{0,38280520,9}]',1005001053),(1005001053,1,'[{0,38040400,1},{0,38280520,3}]',1005001153),(1005001110,2,'[{0,1005001110,2}]',1005001120),(1005001141,1,'[{0,38040400,1}]',1005001241),(1005001141,2,'[{0,38040402,1},{0,1005000731,1}]',1005001142),(1005001142,1,'[{0,38040400,1}]',1005001242),(1005001142,2,'[{0,38040402,2}]',1005001143),(1005001143,1,'[{0,38040400,1}]',1005001243),(1005001143,2,'[{0,38040402,3},{0,38280520,12}]',1005001153),(1005001153,1,'[{0,38040400,1},{0,38280520,4}]',1005001253),(1005001241,1,'[{0,38040400,1}]',1005001341),(1005001241,2,'[{0,38040402,1},{0,1005000731,1}]',1005001242),(1005001242,1,'[{0,38040400,1}]',1005001342),(1005001242,2,'[{0,38040402,2}]',1005001243),(1005001243,1,'[{0,38040400,1}]',1005001343),(1005001243,2,'[{0,38040402,3},{0,38280520,16}]',1005001253),(1005001253,1,'[{0,38040400,1},{0,38280520,4}]',1005001353),(1005001341,1,'[{0,38040400,1}]',1005001441),(1005001341,2,'[{0,38040402,1},{0,1005000731,1}]',1005001342),(1005001342,1,'[{0,38040400,1}]',1005001442),(1005001342,2,'[{0,38040402,2}]',1005001343),(1005001343,1,'[{0,38040400,1}]',1005001443),(1005001343,2,'[{0,38040402,3},{0,38280520,20}]',1005001353),(1005001353,1,'[{0,38040400,1},{0,38280520,5}]',1005001453),(1005001441,1,'[{0,38040400,1}]',1005001541),(1005001441,2,'[{0,38040402,1},{0,1005000731,1}]',1005001442),(1005001442,1,'[{0,38040400,1}]',1005001542),(1005001442,2,'[{0,38040402,2}]',1005001443),(1005001443,1,'[{0,38040400,1}]',1005001543),(1005001443,2,'[{0,38040402,3},{0,38280520,25}]',1005001453),(1005001453,1,'[{0,38040400,1},{0,38280520,5}]',1005001553),(1005001541,1,'[{0,38040400,1}]',1005001641),(1005001541,2,'[{0,38040402,1},{0,1005000731,1}]',1005001542),(1005001542,1,'[{0,38040400,1}]',1005001642),(1005001542,2,'[{0,38040402,2}]',1005001543),(1005001543,1,'[{0,38040400,1}]',1005001643),(1005001543,2,'[{0,38040402,3},{0,38280520,30}]',1005001553),(1005001553,1,'[{0,38040400,1},{0,38280520,5}]',1005001653),(1005001641,2,'[{0,38040402,1},{0,1005000731,1}]',1005001642),(1005001642,2,'[{0,38040402,2}]',1005001643),(1005001643,2,'[{0,38040402,3},{0,38280520,35}]',1005001653),(1009000710,2,'[{0,1009000710,2}]',1009000720),(1009000731,1,'[{0,38040401,1}]',1009000941),(1009000731,2,'[{0,38040403,1},{0,1009000731,1}]',1009000732),(1009000732,1,'[{0,38040401,1}]',1009000942),(1009000910,2,'[{0,1009000910,2}]',1009000920),(1009000941,1,'[{0,38040401,1}]',1009001041),(1009000941,2,'[{0,38040403,1},{0,1009000731,1}]',1009000942),(1009000942,1,'[{0,38040401,1}]',1009001042),(1009000942,2,'[{0,38040403,2}]',1009000943),(1009000943,1,'[{0,38040401,1}]',1009001043),(1009000943,2,'[{0,38040402,3},{0,38280520,6}]',1009000953),(1009000953,1,'[{0,38040400,1},{0,38280520,3}]',1009001053),(1009001041,1,'[{0,38040401,1}]',1009001141),(1009001041,2,'[{0,38040403,1},{0,1009000731,1}]',1009001042),(1009001042,1,'[{0,38040401,1}]',1009001142),(1009001042,2,'[{0,38040403,2}]',1009001043),(1009001043,1,'[{0,38040401,1}]',1009001143),(1009001043,2,'[{0,38040402,3},{0,38280520,9}]',1009001053),(1009001053,1,'[{0,38040400,1},{0,38280520,3}]',1009001153),(1009001110,2,'[{0,1009001110,2}]',1009001120),(1009001141,1,'[{0,38040401,1}]',1009001241),(1009001141,2,'[{0,38040403,1},{0,1009000731,1}]',1009001142),(1009001142,1,'[{0,38040401,1}]',1009001242),(1009001142,2,'[{0,38040403,2}]',1009001143),(1009001143,1,'[{0,38040401,1}]',1009001243),(1009001143,2,'[{0,38040402,3},{0,38280520,12}]',1009001153),(1009001153,1,'[{0,38040400,1},{0,38280520,4}]',1009001253),(1009001241,1,'[{0,38040401,1}]',1009001341),(1009001241,2,'[{0,38040403,1},{0,1009000731,1}]',1009001242),(1009001242,1,'[{0,38040401,1}]',1009001342),(1009001242,2,'[{0,38040403,2}]',1009001243),(1009001243,1,'[{0,38040401,1}]',1009001343),(1009001243,2,'[{0,38040402,3},{0,38280520,16}]',1009001253),(1009001253,1,'[{0,38040400,1},{0,38280520,4}]',1009001353),(1009001341,1,'[{0,38040401,1}]',1009001441),(1009001341,2,'[{0,38040403,1},{0,1009000731,1}]',1009001342),(1009001342,1,'[{0,38040401,1}]',1009001442),(1009001342,2,'[{0,38040403,2}]',1009001343),(1009001343,1,'[{0,38040401,1}]',1009001443),(1009001343,2,'[{0,38040402,3},{0,38280520,20}]',1009001353),(1009001353,1,'[{0,38040400,1},{0,38280520,5}]',1009001453),(1009001441,1,'[{0,38040401,1}]',1009001541),(1009001441,2,'[{0,38040403,1},{0,1009000731,1}]',1009001442),(1009001442,1,'[{0,38040401,1}]',1009001542),(1009001442,2,'[{0,38040403,2}]',1009001443),(1009001443,1,'[{0,38040401,1}]',1009001543),(1009001443,2,'[{0,38040402,3},{0,38280520,25}]',1009001453),(1009001453,1,'[{0,38040400,1},{0,38280520,5}]',1009001553),(1009001541,1,'[{0,38040401,1}]',1009001641),(1009001541,2,'[{0,38040403,1},{0,1009000731,1}]',1009001542),(1009001542,1,'[{0,38040401,1}]',1009001642),(1009001542,2,'[{0,38040403,2}]',1009001543),(1009001543,1,'[{0,38040401,1}]',1009001643),(1009001543,2,'[{0,38040402,3},{0,38280520,30}]',1009001553),(1009001553,1,'[{0,38040400,1},{0,38280520,5}]',1009001653),(1009001641,2,'[{0,38040403,1},{0,1009000731,1}]',1009001642),(1009001642,2,'[{0,38040403,2}]',1009001643),(1009001643,2,'[{0,38040402,3},{0,38280520,35}]',1009001653);
/*!40000 ALTER TABLE `base_equip_upgrade_stage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_equip_wash`
--

DROP TABLE IF EXISTS `base_equip_wash`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_equip_wash` (
  `pos` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '部位',
  `division` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '段位',
  `upgrade_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '升段积分',
  `upgrade_cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '神锻消耗',
  `attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '属性权重',
  `wash_cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '洗炼消耗',
  `extra_cost2` varchar(255) NOT NULL DEFAULT '[]' COMMENT '必出紫属以上特殊消耗',
  `extra_cost3` varchar(255) NOT NULL DEFAULT '[]' COMMENT '必出橙属特殊消耗',
  `extra_cost4` varchar(255) NOT NULL DEFAULT '[]' COMMENT '必出红属特殊消耗',
  PRIMARY KEY (`pos`,`division`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备洗炼配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_equip_wash`
--

LOCK TABLES `base_equip_wash` WRITE;
/*!40000 ALTER TABLE `base_equip_wash` DISABLE KEYS */;
INSERT INTO `base_equip_wash` VALUES (1,1,12000,'[{0,38250001,1}]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,2}]},{1,[{0,38260001,4}]},{2,[{0,38260001,8}]},{3,[{0,38260001,16}]}]','[{0,[{1,36010001,60}]},{1,[{1,36010001,90}]},{2,[{1,36010001,120}]},{3,[{1,36010001,180}]}]','[{0,[{0,38260002,2}]},{1,[{0,38260002,4}]},{2,[{0,38260002,8}]},{3,[{0,38260002,16}]}]','[{0,[{0,38260003,2}]},{1,[{0,38260003,4}]},{2,[{0,38260003,8}]},{3,[{0,38260003,16}]}]'),(1,2,28004,'[{0,38250001,2}]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,3}]},{1,[{0,38260001,6}]},{2,[{0,38260001,12}]},{3,[{0,38260001,24}]}]','[{0,[{1,36010001,90}]},{1,[{1,36010001,135}]},{2,[{1,36010001,180}]},{3,[{1,36010001,270}]}]','[{0,[{0,38260002,3}]},{1,[{0,38260002,6}]},{2,[{0,38260002,12}]},{3,[{0,38260002,24}]}]','[{0,[{0,38260003,3}]},{1,[{0,38260003,6}]},{2,[{0,38260003,12}]},{3,[{0,38260003,24}]}]'),(1,3,48668,'[{0,38250001,4}]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,5}]},{1,[{0,38260001,10}]},{2,[{0,38260001,20}]},{3,[{0,38260001,40}]}]','[{0,[{1,36010001,120}]},{1,[{1,36010001,180}]},{2,[{1,36010001,240}]},{3,[{1,36010001,360}]}]','[{0,[{0,38260002,4}]},{1,[{0,38260002,8}]},{2,[{0,38260002,16}]},{3,[{0,38260002,32}]}]','[{0,[{0,38260003,4}]},{1,[{0,38260003,8}]},{2,[{0,38260003,16}]},{3,[{0,38260003,32}]}]'),(1,4,77272,'[{0,38250001,8}]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,7}]},{1,[{0,38260001,14}]},{2,[{0,38260001,28}]},{3,[{0,38260001,56}]}]','[{0,[{1,36010001,150}]},{1,[{1,36010001,225}]},{2,[{1,36010001,300}]},{3,[{1,36010001,450}]}]','[{0,[{0,38260002,5}]},{1,[{0,38260002,10}]},{2,[{0,38260002,20}]},{3,[{0,38260002,40}]}]','[{0,[{0,38260003,5}]},{1,[{0,38260003,10}]},{2,[{0,38260003,20}]},{3,[{0,38260003,40}]}]'),(1,5,113852,'[{0,38250001,12}]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,9}]},{1,[{0,38260001,18}]},{2,[{0,38260001,36}]},{3,[{0,38260001,72}]}]','[{0,[{1,36010001,180}]},{1,[{1,36010001,270}]},{2,[{1,36010001,360}]},{3,[{1,36010001,540}]}]','[{0,[{0,38260002,6}]},{1,[{0,38260002,12}]},{2,[{0,38260002,24}]},{3,[{0,38260002,48}]}]','[{0,[{0,38260003,6}]},{1,[{0,38260003,12}]},{2,[{0,38260003,24}]},{3,[{0,38260003,48}]}]'),(1,6,158428,'[{0,38250001,18}]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,11}]},{1,[{0,38260001,22}]},{2,[{0,38260001,44}]},{3,[{0,38260001,88}]}]','[{0,[{1,36010001,210}]},{1,[{1,36010001,315}]},{2,[{1,36010001,420}]},{3,[{1,36010001,630}]}]','[{0,[{0,38260002,7}]},{1,[{0,38260002,14}]},{2,[{0,38260002,28}]},{3,[{0,38260002,56}]}]','[{0,[{0,38260003,7}]},{1,[{0,38260003,14}]},{2,[{0,38260003,28}]},{3,[{0,38260003,56}]}]'),(1,7,211000,'[{0,38250001,24}]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,13}]},{1,[{0,38260001,26}]},{2,[{0,38260001,52}]},{3,[{0,38260001,104}]}]','[{0,[{1,36010001,240}]},{1,[{1,36010001,360}]},{2,[{1,36010001,480}]},{3,[{1,36010001,720}]}]','[{0,[{0,38260002,8}]},{1,[{0,38260002,16}]},{2,[{0,38260002,32}]},{3,[{0,38260002,64}]}]','[{0,[{0,38260003,8}]},{1,[{0,38260003,16}]},{2,[{0,38260003,32}]},{3,[{0,38260003,64}]}]'),(1,8,271572,'[{0,38250001,30}]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,15}]},{1,[{0,38260001,30}]},{2,[{0,38260001,60}]},{3,[{0,38260001,120}]}]','[{0,[{1,36010001,270}]},{1,[{1,36010001,405}]},{2,[{1,36010001,540}]},{3,[{1,36010001,810}]}]','[{0,[{0,38260002,9}]},{1,[{0,38260002,18}]},{2,[{0,38260002,36}]},{3,[{0,38260002,72}]}]','[{0,[{0,38260003,9}]},{1,[{0,38260003,18}]},{2,[{0,38260003,36}]},{3,[{0,38260003,72}]}]'),(1,9,340148,'[{0,38250001,40}]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,17}]},{1,[{0,38260001,34}]},{2,[{0,38260001,68}]},{3,[{0,38260001,136}]}]','[{0,[{1,36010001,300}]},{1,[{1,36010001,450}]},{2,[{1,36010001,600}]},{3,[{1,36010001,900}]}]','[{0,[{0,38260002,10}]},{1,[{0,38260002,20}]},{2,[{0,38260002,40}]},{3,[{0,38260002,80}]}]','[{0,[{0,38260003,10}]},{1,[{0,38260003,20}]},{2,[{0,38260003,40}]},{3,[{0,38260003,80}]}]'),(1,10,0,'[]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,20}]},{1,[{0,38260001,40}]},{2,[{0,38260001,80}]},{3,[{0,38260001,160}]}]','[{0,[{1,36010001,330}]},{1,[{1,36010001,495}]},{2,[{1,36010001,660}]},{3,[{1,36010001,990}]}]','[{0,[{0,38260002,11}]},{1,[{0,38260002,22}]},{2,[{0,38260002,44}]},{3,[{0,38260002,88}]}]','[{0,[{0,38260003,11}]},{1,[{0,38260003,22}]},{2,[{0,38260003,44}]},{3,[{0,38260003,88}]}]'),(2,1,12000,'[{0,38250001,1}]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,2}]},{1,[{0,38260001,4}]},{2,[{0,38260001,8}]},{3,[{0,38260001,16}]}]','[{0,[{1,36010001,60}]},{1,[{1,36010001,90}]},{2,[{1,36010001,120}]},{3,[{1,36010001,180}]}]','[{0,[{0,38260002,2}]},{1,[{0,38260002,4}]},{2,[{0,38260002,8}]},{3,[{0,38260002,16}]}]','[{0,[{0,38260003,2}]},{1,[{0,38260003,4}]},{2,[{0,38260003,8}]},{3,[{0,38260003,16}]}]'),(2,2,28004,'[{0,38250001,2}]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,3}]},{1,[{0,38260001,6}]},{2,[{0,38260001,12}]},{3,[{0,38260001,24}]}]','[{0,[{1,36010001,90}]},{1,[{1,36010001,135}]},{2,[{1,36010001,180}]},{3,[{1,36010001,270}]}]','[{0,[{0,38260002,3}]},{1,[{0,38260002,6}]},{2,[{0,38260002,12}]},{3,[{0,38260002,24}]}]','[{0,[{0,38260003,3}]},{1,[{0,38260003,6}]},{2,[{0,38260003,12}]},{3,[{0,38260003,24}]}]'),(2,3,48668,'[{0,38250001,4}]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,5}]},{1,[{0,38260001,10}]},{2,[{0,38260001,20}]},{3,[{0,38260001,40}]}]','[{0,[{1,36010001,120}]},{1,[{1,36010001,180}]},{2,[{1,36010001,240}]},{3,[{1,36010001,360}]}]','[{0,[{0,38260002,4}]},{1,[{0,38260002,8}]},{2,[{0,38260002,16}]},{3,[{0,38260002,32}]}]','[{0,[{0,38260003,4}]},{1,[{0,38260003,8}]},{2,[{0,38260003,16}]},{3,[{0,38260003,32}]}]'),(2,4,77272,'[{0,38250001,8}]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,7}]},{1,[{0,38260001,14}]},{2,[{0,38260001,28}]},{3,[{0,38260001,56}]}]','[{0,[{1,36010001,150}]},{1,[{1,36010001,225}]},{2,[{1,36010001,300}]},{3,[{1,36010001,450}]}]','[{0,[{0,38260002,5}]},{1,[{0,38260002,10}]},{2,[{0,38260002,20}]},{3,[{0,38260002,40}]}]','[{0,[{0,38260003,5}]},{1,[{0,38260003,10}]},{2,[{0,38260003,20}]},{3,[{0,38260003,40}]}]'),(2,5,113852,'[{0,38250001,12}]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,9}]},{1,[{0,38260001,18}]},{2,[{0,38260001,36}]},{3,[{0,38260001,72}]}]','[{0,[{1,36010001,180}]},{1,[{1,36010001,270}]},{2,[{1,36010001,360}]},{3,[{1,36010001,540}]}]','[{0,[{0,38260002,6}]},{1,[{0,38260002,12}]},{2,[{0,38260002,24}]},{3,[{0,38260002,48}]}]','[{0,[{0,38260003,6}]},{1,[{0,38260003,12}]},{2,[{0,38260003,24}]},{3,[{0,38260003,48}]}]'),(2,6,158428,'[{0,38250001,18}]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,11}]},{1,[{0,38260001,22}]},{2,[{0,38260001,44}]},{3,[{0,38260001,88}]}]','[{0,[{1,36010001,210}]},{1,[{1,36010001,315}]},{2,[{1,36010001,420}]},{3,[{1,36010001,630}]}]','[{0,[{0,38260002,7}]},{1,[{0,38260002,14}]},{2,[{0,38260002,28}]},{3,[{0,38260002,56}]}]','[{0,[{0,38260003,7}]},{1,[{0,38260003,14}]},{2,[{0,38260003,28}]},{3,[{0,38260003,56}]}]'),(2,7,211000,'[{0,38250001,24}]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,13}]},{1,[{0,38260001,26}]},{2,[{0,38260001,52}]},{3,[{0,38260001,104}]}]','[{0,[{1,36010001,240}]},{1,[{1,36010001,360}]},{2,[{1,36010001,480}]},{3,[{1,36010001,720}]}]','[{0,[{0,38260002,8}]},{1,[{0,38260002,16}]},{2,[{0,38260002,32}]},{3,[{0,38260002,64}]}]','[{0,[{0,38260003,8}]},{1,[{0,38260003,16}]},{2,[{0,38260003,32}]},{3,[{0,38260003,64}]}]'),(2,8,271572,'[{0,38250001,30}]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,15}]},{1,[{0,38260001,30}]},{2,[{0,38260001,60}]},{3,[{0,38260001,120}]}]','[{0,[{1,36010001,270}]},{1,[{1,36010001,405}]},{2,[{1,36010001,540}]},{3,[{1,36010001,810}]}]','[{0,[{0,38260002,9}]},{1,[{0,38260002,18}]},{2,[{0,38260002,36}]},{3,[{0,38260002,72}]}]','[{0,[{0,38260003,9}]},{1,[{0,38260003,18}]},{2,[{0,38260003,36}]},{3,[{0,38260003,72}]}]'),(2,9,340148,'[{0,38250001,40}]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,17}]},{1,[{0,38260001,34}]},{2,[{0,38260001,68}]},{3,[{0,38260001,136}]}]','[{0,[{1,36010001,300}]},{1,[{1,36010001,450}]},{2,[{1,36010001,600}]},{3,[{1,36010001,900}]}]','[{0,[{0,38260002,10}]},{1,[{0,38260002,20}]},{2,[{0,38260002,40}]},{3,[{0,38260002,80}]}]','[{0,[{0,38260003,10}]},{1,[{0,38260003,20}]},{2,[{0,38260003,40}]},{3,[{0,38260003,80}]}]'),(2,10,0,'[]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,20}]},{1,[{0,38260001,40}]},{2,[{0,38260001,80}]},{3,[{0,38260001,160}]}]','[{0,[{1,36010001,330}]},{1,[{1,36010001,495}]},{2,[{1,36010001,660}]},{3,[{1,36010001,990}]}]','[{0,[{0,38260002,11}]},{1,[{0,38260002,22}]},{2,[{0,38260002,44}]},{3,[{0,38260002,88}]}]','[{0,[{0,38260003,11}]},{1,[{0,38260003,22}]},{2,[{0,38260003,44}]},{3,[{0,38260003,88}]}]'),(3,1,12000,'[{0,38250001,1}]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,2}]},{1,[{0,38260001,4}]},{2,[{0,38260001,8}]},{3,[{0,38260001,16}]}]','[{0,[{1,36010001,60}]},{1,[{1,36010001,90}]},{2,[{1,36010001,120}]},{3,[{1,36010001,180}]}]','[{0,[{0,38260002,2}]},{1,[{0,38260002,4}]},{2,[{0,38260002,8}]},{3,[{0,38260002,16}]}]','[{0,[{0,38260003,2}]},{1,[{0,38260003,4}]},{2,[{0,38260003,8}]},{3,[{0,38260003,16}]}]'),(3,2,28004,'[{0,38250001,2}]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,3}]},{1,[{0,38260001,6}]},{2,[{0,38260001,12}]},{3,[{0,38260001,24}]}]','[{0,[{1,36010001,90}]},{1,[{1,36010001,135}]},{2,[{1,36010001,180}]},{3,[{1,36010001,270}]}]','[{0,[{0,38260002,3}]},{1,[{0,38260002,6}]},{2,[{0,38260002,12}]},{3,[{0,38260002,24}]}]','[{0,[{0,38260003,3}]},{1,[{0,38260003,6}]},{2,[{0,38260003,12}]},{3,[{0,38260003,24}]}]'),(3,3,48668,'[{0,38250001,4}]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,5}]},{1,[{0,38260001,10}]},{2,[{0,38260001,20}]},{3,[{0,38260001,40}]}]','[{0,[{1,36010001,120}]},{1,[{1,36010001,180}]},{2,[{1,36010001,240}]},{3,[{1,36010001,360}]}]','[{0,[{0,38260002,4}]},{1,[{0,38260002,8}]},{2,[{0,38260002,16}]},{3,[{0,38260002,32}]}]','[{0,[{0,38260003,4}]},{1,[{0,38260003,8}]},{2,[{0,38260003,16}]},{3,[{0,38260003,32}]}]'),(3,4,77272,'[{0,38250001,8}]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,7}]},{1,[{0,38260001,14}]},{2,[{0,38260001,28}]},{3,[{0,38260001,56}]}]','[{0,[{1,36010001,150}]},{1,[{1,36010001,225}]},{2,[{1,36010001,300}]},{3,[{1,36010001,450}]}]','[{0,[{0,38260002,5}]},{1,[{0,38260002,10}]},{2,[{0,38260002,20}]},{3,[{0,38260002,40}]}]','[{0,[{0,38260003,5}]},{1,[{0,38260003,10}]},{2,[{0,38260003,20}]},{3,[{0,38260003,40}]}]'),(3,5,113852,'[{0,38250001,12}]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,9}]},{1,[{0,38260001,18}]},{2,[{0,38260001,36}]},{3,[{0,38260001,72}]}]','[{0,[{1,36010001,180}]},{1,[{1,36010001,270}]},{2,[{1,36010001,360}]},{3,[{1,36010001,540}]}]','[{0,[{0,38260002,6}]},{1,[{0,38260002,12}]},{2,[{0,38260002,24}]},{3,[{0,38260002,48}]}]','[{0,[{0,38260003,6}]},{1,[{0,38260003,12}]},{2,[{0,38260003,24}]},{3,[{0,38260003,48}]}]'),(3,6,158428,'[{0,38250001,18}]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,11}]},{1,[{0,38260001,22}]},{2,[{0,38260001,44}]},{3,[{0,38260001,88}]}]','[{0,[{1,36010001,210}]},{1,[{1,36010001,315}]},{2,[{1,36010001,420}]},{3,[{1,36010001,630}]}]','[{0,[{0,38260002,7}]},{1,[{0,38260002,14}]},{2,[{0,38260002,28}]},{3,[{0,38260002,56}]}]','[{0,[{0,38260003,7}]},{1,[{0,38260003,14}]},{2,[{0,38260003,28}]},{3,[{0,38260003,56}]}]'),(3,7,211000,'[{0,38250001,24}]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,13}]},{1,[{0,38260001,26}]},{2,[{0,38260001,52}]},{3,[{0,38260001,104}]}]','[{0,[{1,36010001,240}]},{1,[{1,36010001,360}]},{2,[{1,36010001,480}]},{3,[{1,36010001,720}]}]','[{0,[{0,38260002,8}]},{1,[{0,38260002,16}]},{2,[{0,38260002,32}]},{3,[{0,38260002,64}]}]','[{0,[{0,38260003,8}]},{1,[{0,38260003,16}]},{2,[{0,38260003,32}]},{3,[{0,38260003,64}]}]'),(3,8,271572,'[{0,38250001,30}]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,15}]},{1,[{0,38260001,30}]},{2,[{0,38260001,60}]},{3,[{0,38260001,120}]}]','[{0,[{1,36010001,270}]},{1,[{1,36010001,405}]},{2,[{1,36010001,540}]},{3,[{1,36010001,810}]}]','[{0,[{0,38260002,9}]},{1,[{0,38260002,18}]},{2,[{0,38260002,36}]},{3,[{0,38260002,72}]}]','[{0,[{0,38260003,9}]},{1,[{0,38260003,18}]},{2,[{0,38260003,36}]},{3,[{0,38260003,72}]}]'),(3,9,340148,'[{0,38250001,40}]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,17}]},{1,[{0,38260001,34}]},{2,[{0,38260001,68}]},{3,[{0,38260001,136}]}]','[{0,[{1,36010001,300}]},{1,[{1,36010001,450}]},{2,[{1,36010001,600}]},{3,[{1,36010001,900}]}]','[{0,[{0,38260002,10}]},{1,[{0,38260002,20}]},{2,[{0,38260002,40}]},{3,[{0,38260002,80}]}]','[{0,[{0,38260003,10}]},{1,[{0,38260003,20}]},{2,[{0,38260003,40}]},{3,[{0,38260003,80}]}]'),(3,10,0,'[]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,20}]},{1,[{0,38260001,40}]},{2,[{0,38260001,80}]},{3,[{0,38260001,160}]}]','[{0,[{1,36010001,330}]},{1,[{1,36010001,495}]},{2,[{1,36010001,660}]},{3,[{1,36010001,990}]}]','[{0,[{0,38260002,11}]},{1,[{0,38260002,22}]},{2,[{0,38260002,44}]},{3,[{0,38260002,88}]}]','[{0,[{0,38260003,11}]},{1,[{0,38260003,22}]},{2,[{0,38260003,44}]},{3,[{0,38260003,88}]}]'),(4,1,12000,'[{0,38250001,1}]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,2}]},{1,[{0,38260001,4}]},{2,[{0,38260001,8}]},{3,[{0,38260001,16}]}]','[{0,[{1,36010001,60}]},{1,[{1,36010001,90}]},{2,[{1,36010001,120}]},{3,[{1,36010001,180}]}]','[{0,[{0,38260002,2}]},{1,[{0,38260002,4}]},{2,[{0,38260002,8}]},{3,[{0,38260002,16}]}]','[{0,[{0,38260003,2}]},{1,[{0,38260003,4}]},{2,[{0,38260003,8}]},{3,[{0,38260003,16}]}]'),(4,2,28004,'[{0,38250001,2}]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,3}]},{1,[{0,38260001,6}]},{2,[{0,38260001,12}]},{3,[{0,38260001,24}]}]','[{0,[{1,36010001,90}]},{1,[{1,36010001,135}]},{2,[{1,36010001,180}]},{3,[{1,36010001,270}]}]','[{0,[{0,38260002,3}]},{1,[{0,38260002,6}]},{2,[{0,38260002,12}]},{3,[{0,38260002,24}]}]','[{0,[{0,38260003,3}]},{1,[{0,38260003,6}]},{2,[{0,38260003,12}]},{3,[{0,38260003,24}]}]'),(4,3,48668,'[{0,38250001,4}]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,5}]},{1,[{0,38260001,10}]},{2,[{0,38260001,20}]},{3,[{0,38260001,40}]}]','[{0,[{1,36010001,120}]},{1,[{1,36010001,180}]},{2,[{1,36010001,240}]},{3,[{1,36010001,360}]}]','[{0,[{0,38260002,4}]},{1,[{0,38260002,8}]},{2,[{0,38260002,16}]},{3,[{0,38260002,32}]}]','[{0,[{0,38260003,4}]},{1,[{0,38260003,8}]},{2,[{0,38260003,16}]},{3,[{0,38260003,32}]}]'),(4,4,77272,'[{0,38250001,8}]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,7}]},{1,[{0,38260001,14}]},{2,[{0,38260001,28}]},{3,[{0,38260001,56}]}]','[{0,[{1,36010001,150}]},{1,[{1,36010001,225}]},{2,[{1,36010001,300}]},{3,[{1,36010001,450}]}]','[{0,[{0,38260002,5}]},{1,[{0,38260002,10}]},{2,[{0,38260002,20}]},{3,[{0,38260002,40}]}]','[{0,[{0,38260003,5}]},{1,[{0,38260003,10}]},{2,[{0,38260003,20}]},{3,[{0,38260003,40}]}]'),(4,5,113852,'[{0,38250001,12}]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,9}]},{1,[{0,38260001,18}]},{2,[{0,38260001,36}]},{3,[{0,38260001,72}]}]','[{0,[{1,36010001,180}]},{1,[{1,36010001,270}]},{2,[{1,36010001,360}]},{3,[{1,36010001,540}]}]','[{0,[{0,38260002,6}]},{1,[{0,38260002,12}]},{2,[{0,38260002,24}]},{3,[{0,38260002,48}]}]','[{0,[{0,38260003,6}]},{1,[{0,38260003,12}]},{2,[{0,38260003,24}]},{3,[{0,38260003,48}]}]'),(4,6,158428,'[{0,38250001,18}]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,11}]},{1,[{0,38260001,22}]},{2,[{0,38260001,44}]},{3,[{0,38260001,88}]}]','[{0,[{1,36010001,210}]},{1,[{1,36010001,315}]},{2,[{1,36010001,420}]},{3,[{1,36010001,630}]}]','[{0,[{0,38260002,7}]},{1,[{0,38260002,14}]},{2,[{0,38260002,28}]},{3,[{0,38260002,56}]}]','[{0,[{0,38260003,7}]},{1,[{0,38260003,14}]},{2,[{0,38260003,28}]},{3,[{0,38260003,56}]}]'),(4,7,211000,'[{0,38250001,24}]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,13}]},{1,[{0,38260001,26}]},{2,[{0,38260001,52}]},{3,[{0,38260001,104}]}]','[{0,[{1,36010001,240}]},{1,[{1,36010001,360}]},{2,[{1,36010001,480}]},{3,[{1,36010001,720}]}]','[{0,[{0,38260002,8}]},{1,[{0,38260002,16}]},{2,[{0,38260002,32}]},{3,[{0,38260002,64}]}]','[{0,[{0,38260003,8}]},{1,[{0,38260003,16}]},{2,[{0,38260003,32}]},{3,[{0,38260003,64}]}]'),(4,8,271572,'[{0,38250001,30}]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,15}]},{1,[{0,38260001,30}]},{2,[{0,38260001,60}]},{3,[{0,38260001,120}]}]','[{0,[{1,36010001,270}]},{1,[{1,36010001,405}]},{2,[{1,36010001,540}]},{3,[{1,36010001,810}]}]','[{0,[{0,38260002,9}]},{1,[{0,38260002,18}]},{2,[{0,38260002,36}]},{3,[{0,38260002,72}]}]','[{0,[{0,38260003,9}]},{1,[{0,38260003,18}]},{2,[{0,38260003,36}]},{3,[{0,38260003,72}]}]'),(4,9,340148,'[{0,38250001,40}]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,17}]},{1,[{0,38260001,34}]},{2,[{0,38260001,68}]},{3,[{0,38260001,136}]}]','[{0,[{1,36010001,300}]},{1,[{1,36010001,450}]},{2,[{1,36010001,600}]},{3,[{1,36010001,900}]}]','[{0,[{0,38260002,10}]},{1,[{0,38260002,20}]},{2,[{0,38260002,40}]},{3,[{0,38260002,80}]}]','[{0,[{0,38260003,10}]},{1,[{0,38260003,20}]},{2,[{0,38260003,40}]},{3,[{0,38260003,80}]}]'),(4,10,0,'[]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,20}]},{1,[{0,38260001,40}]},{2,[{0,38260001,80}]},{3,[{0,38260001,160}]}]','[{0,[{1,36010001,330}]},{1,[{1,36010001,495}]},{2,[{1,36010001,660}]},{3,[{1,36010001,990}]}]','[{0,[{0,38260002,11}]},{1,[{0,38260002,22}]},{2,[{0,38260002,44}]},{3,[{0,38260002,88}]}]','[{0,[{0,38260003,11}]},{1,[{0,38260003,22}]},{2,[{0,38260003,44}]},{3,[{0,38260003,88}]}]'),(5,1,12000,'[{0,38250001,1}]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,2}]},{1,[{0,38260001,4}]},{2,[{0,38260001,8}]},{3,[{0,38260001,16}]}]','[{0,[{1,36010001,60}]},{1,[{1,36010001,90}]},{2,[{1,36010001,120}]},{3,[{1,36010001,180}]}]','[{0,[{0,38260002,2}]},{1,[{0,38260002,4}]},{2,[{0,38260002,8}]},{3,[{0,38260002,16}]}]','[{0,[{0,38260003,2}]},{1,[{0,38260003,4}]},{2,[{0,38260003,8}]},{3,[{0,38260003,16}]}]'),(5,2,28004,'[{0,38250001,2}]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,3}]},{1,[{0,38260001,6}]},{2,[{0,38260001,12}]},{3,[{0,38260001,24}]}]','[{0,[{1,36010001,90}]},{1,[{1,36010001,135}]},{2,[{1,36010001,180}]},{3,[{1,36010001,270}]}]','[{0,[{0,38260002,3}]},{1,[{0,38260002,6}]},{2,[{0,38260002,12}]},{3,[{0,38260002,24}]}]','[{0,[{0,38260003,3}]},{1,[{0,38260003,6}]},{2,[{0,38260003,12}]},{3,[{0,38260003,24}]}]'),(5,3,48668,'[{0,38250001,4}]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,5}]},{1,[{0,38260001,10}]},{2,[{0,38260001,20}]},{3,[{0,38260001,40}]}]','[{0,[{1,36010001,120}]},{1,[{1,36010001,180}]},{2,[{1,36010001,240}]},{3,[{1,36010001,360}]}]','[{0,[{0,38260002,4}]},{1,[{0,38260002,8}]},{2,[{0,38260002,16}]},{3,[{0,38260002,32}]}]','[{0,[{0,38260003,4}]},{1,[{0,38260003,8}]},{2,[{0,38260003,16}]},{3,[{0,38260003,32}]}]'),(5,4,77272,'[{0,38250001,8}]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,7}]},{1,[{0,38260001,14}]},{2,[{0,38260001,28}]},{3,[{0,38260001,56}]}]','[{0,[{1,36010001,150}]},{1,[{1,36010001,225}]},{2,[{1,36010001,300}]},{3,[{1,36010001,450}]}]','[{0,[{0,38260002,5}]},{1,[{0,38260002,10}]},{2,[{0,38260002,20}]},{3,[{0,38260002,40}]}]','[{0,[{0,38260003,5}]},{1,[{0,38260003,10}]},{2,[{0,38260003,20}]},{3,[{0,38260003,40}]}]'),(5,5,113852,'[{0,38250001,12}]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,9}]},{1,[{0,38260001,18}]},{2,[{0,38260001,36}]},{3,[{0,38260001,72}]}]','[{0,[{1,36010001,180}]},{1,[{1,36010001,270}]},{2,[{1,36010001,360}]},{3,[{1,36010001,540}]}]','[{0,[{0,38260002,6}]},{1,[{0,38260002,12}]},{2,[{0,38260002,24}]},{3,[{0,38260002,48}]}]','[{0,[{0,38260003,6}]},{1,[{0,38260003,12}]},{2,[{0,38260003,24}]},{3,[{0,38260003,48}]}]'),(5,6,158428,'[{0,38250001,18}]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,11}]},{1,[{0,38260001,22}]},{2,[{0,38260001,44}]},{3,[{0,38260001,88}]}]','[{0,[{1,36010001,210}]},{1,[{1,36010001,315}]},{2,[{1,36010001,420}]},{3,[{1,36010001,630}]}]','[{0,[{0,38260002,7}]},{1,[{0,38260002,14}]},{2,[{0,38260002,28}]},{3,[{0,38260002,56}]}]','[{0,[{0,38260003,7}]},{1,[{0,38260003,14}]},{2,[{0,38260003,28}]},{3,[{0,38260003,56}]}]'),(5,7,211000,'[{0,38250001,24}]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,13}]},{1,[{0,38260001,26}]},{2,[{0,38260001,52}]},{3,[{0,38260001,104}]}]','[{0,[{1,36010001,240}]},{1,[{1,36010001,360}]},{2,[{1,36010001,480}]},{3,[{1,36010001,720}]}]','[{0,[{0,38260002,8}]},{1,[{0,38260002,16}]},{2,[{0,38260002,32}]},{3,[{0,38260002,64}]}]','[{0,[{0,38260003,8}]},{1,[{0,38260003,16}]},{2,[{0,38260003,32}]},{3,[{0,38260003,64}]}]'),(5,8,271572,'[{0,38250001,30}]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,15}]},{1,[{0,38260001,30}]},{2,[{0,38260001,60}]},{3,[{0,38260001,120}]}]','[{0,[{1,36010001,270}]},{1,[{1,36010001,405}]},{2,[{1,36010001,540}]},{3,[{1,36010001,810}]}]','[{0,[{0,38260002,9}]},{1,[{0,38260002,18}]},{2,[{0,38260002,36}]},{3,[{0,38260002,72}]}]','[{0,[{0,38260003,9}]},{1,[{0,38260003,18}]},{2,[{0,38260003,36}]},{3,[{0,38260003,72}]}]'),(5,9,340148,'[{0,38250001,40}]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,17}]},{1,[{0,38260001,34}]},{2,[{0,38260001,68}]},{3,[{0,38260001,136}]}]','[{0,[{1,36010001,300}]},{1,[{1,36010001,450}]},{2,[{1,36010001,600}]},{3,[{1,36010001,900}]}]','[{0,[{0,38260002,10}]},{1,[{0,38260002,20}]},{2,[{0,38260002,40}]},{3,[{0,38260002,80}]}]','[{0,[{0,38260003,10}]},{1,[{0,38260003,20}]},{2,[{0,38260003,40}]},{3,[{0,38260003,80}]}]'),(5,10,0,'[]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,20}]},{1,[{0,38260001,40}]},{2,[{0,38260001,80}]},{3,[{0,38260001,160}]}]','[{0,[{1,36010001,330}]},{1,[{1,36010001,495}]},{2,[{1,36010001,660}]},{3,[{1,36010001,990}]}]','[{0,[{0,38260002,11}]},{1,[{0,38260002,22}]},{2,[{0,38260002,44}]},{3,[{0,38260002,88}]}]','[{0,[{0,38260003,11}]},{1,[{0,38260003,22}]},{2,[{0,38260003,44}]},{3,[{0,38260003,88}]}]'),(6,1,12000,'[{0,38250001,1}]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,2}]},{1,[{0,38260001,4}]},{2,[{0,38260001,8}]},{3,[{0,38260001,16}]}]','[{0,[{1,36010001,60}]},{1,[{1,36010001,90}]},{2,[{1,36010001,120}]},{3,[{1,36010001,180}]}]','[{0,[{0,38260002,2}]},{1,[{0,38260002,4}]},{2,[{0,38260002,8}]},{3,[{0,38260002,16}]}]','[{0,[{0,38260003,2}]},{1,[{0,38260003,4}]},{2,[{0,38260003,8}]},{3,[{0,38260003,16}]}]'),(6,2,28004,'[{0,38250001,2}]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,3}]},{1,[{0,38260001,6}]},{2,[{0,38260001,12}]},{3,[{0,38260001,24}]}]','[{0,[{1,36010001,90}]},{1,[{1,36010001,135}]},{2,[{1,36010001,180}]},{3,[{1,36010001,270}]}]','[{0,[{0,38260002,3}]},{1,[{0,38260002,6}]},{2,[{0,38260002,12}]},{3,[{0,38260002,24}]}]','[{0,[{0,38260003,3}]},{1,[{0,38260003,6}]},{2,[{0,38260003,12}]},{3,[{0,38260003,24}]}]'),(6,3,48668,'[{0,38250001,4}]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,5}]},{1,[{0,38260001,10}]},{2,[{0,38260001,20}]},{3,[{0,38260001,40}]}]','[{0,[{1,36010001,120}]},{1,[{1,36010001,180}]},{2,[{1,36010001,240}]},{3,[{1,36010001,360}]}]','[{0,[{0,38260002,4}]},{1,[{0,38260002,8}]},{2,[{0,38260002,16}]},{3,[{0,38260002,32}]}]','[{0,[{0,38260003,4}]},{1,[{0,38260003,8}]},{2,[{0,38260003,16}]},{3,[{0,38260003,32}]}]'),(6,4,77272,'[{0,38250001,8}]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,7}]},{1,[{0,38260001,14}]},{2,[{0,38260001,28}]},{3,[{0,38260001,56}]}]','[{0,[{1,36010001,150}]},{1,[{1,36010001,225}]},{2,[{1,36010001,300}]},{3,[{1,36010001,450}]}]','[{0,[{0,38260002,5}]},{1,[{0,38260002,10}]},{2,[{0,38260002,20}]},{3,[{0,38260002,40}]}]','[{0,[{0,38260003,5}]},{1,[{0,38260003,10}]},{2,[{0,38260003,20}]},{3,[{0,38260003,40}]}]'),(6,5,113852,'[{0,38250001,12}]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,9}]},{1,[{0,38260001,18}]},{2,[{0,38260001,36}]},{3,[{0,38260001,72}]}]','[{0,[{1,36010001,180}]},{1,[{1,36010001,270}]},{2,[{1,36010001,360}]},{3,[{1,36010001,540}]}]','[{0,[{0,38260002,6}]},{1,[{0,38260002,12}]},{2,[{0,38260002,24}]},{3,[{0,38260002,48}]}]','[{0,[{0,38260003,6}]},{1,[{0,38260003,12}]},{2,[{0,38260003,24}]},{3,[{0,38260003,48}]}]'),(6,6,158428,'[{0,38250001,18}]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,11}]},{1,[{0,38260001,22}]},{2,[{0,38260001,44}]},{3,[{0,38260001,88}]}]','[{0,[{1,36010001,210}]},{1,[{1,36010001,315}]},{2,[{1,36010001,420}]},{3,[{1,36010001,630}]}]','[{0,[{0,38260002,7}]},{1,[{0,38260002,14}]},{2,[{0,38260002,28}]},{3,[{0,38260002,56}]}]','[{0,[{0,38260003,7}]},{1,[{0,38260003,14}]},{2,[{0,38260003,28}]},{3,[{0,38260003,56}]}]'),(6,7,211000,'[{0,38250001,24}]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,13}]},{1,[{0,38260001,26}]},{2,[{0,38260001,52}]},{3,[{0,38260001,104}]}]','[{0,[{1,36010001,240}]},{1,[{1,36010001,360}]},{2,[{1,36010001,480}]},{3,[{1,36010001,720}]}]','[{0,[{0,38260002,8}]},{1,[{0,38260002,16}]},{2,[{0,38260002,32}]},{3,[{0,38260002,64}]}]','[{0,[{0,38260003,8}]},{1,[{0,38260003,16}]},{2,[{0,38260003,32}]},{3,[{0,38260003,64}]}]'),(6,8,271572,'[{0,38250001,30}]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,15}]},{1,[{0,38260001,30}]},{2,[{0,38260001,60}]},{3,[{0,38260001,120}]}]','[{0,[{1,36010001,270}]},{1,[{1,36010001,405}]},{2,[{1,36010001,540}]},{3,[{1,36010001,810}]}]','[{0,[{0,38260002,9}]},{1,[{0,38260002,18}]},{2,[{0,38260002,36}]},{3,[{0,38260002,72}]}]','[{0,[{0,38260003,9}]},{1,[{0,38260003,18}]},{2,[{0,38260003,36}]},{3,[{0,38260003,72}]}]'),(6,9,340148,'[{0,38250001,40}]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,17}]},{1,[{0,38260001,34}]},{2,[{0,38260001,68}]},{3,[{0,38260001,136}]}]','[{0,[{1,36010001,300}]},{1,[{1,36010001,450}]},{2,[{1,36010001,600}]},{3,[{1,36010001,900}]}]','[{0,[{0,38260002,10}]},{1,[{0,38260002,20}]},{2,[{0,38260002,40}]},{3,[{0,38260002,80}]}]','[{0,[{0,38260003,10}]},{1,[{0,38260003,20}]},{2,[{0,38260003,40}]},{3,[{0,38260003,80}]}]'),(6,10,0,'[]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,20}]},{1,[{0,38260001,40}]},{2,[{0,38260001,80}]},{3,[{0,38260001,160}]}]','[{0,[{1,36010001,330}]},{1,[{1,36010001,495}]},{2,[{1,36010001,660}]},{3,[{1,36010001,990}]}]','[{0,[{0,38260002,11}]},{1,[{0,38260002,22}]},{2,[{0,38260002,44}]},{3,[{0,38260002,88}]}]','[{0,[{0,38260003,11}]},{1,[{0,38260003,22}]},{2,[{0,38260003,44}]},{3,[{0,38260003,88}]}]'),(7,1,12000,'[{0,38250001,1}]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,2}]},{1,[{0,38260001,4}]},{2,[{0,38260001,8}]},{3,[{0,38260001,16}]}]','[{0,[{1,36010001,60}]},{1,[{1,36010001,90}]},{2,[{1,36010001,120}]},{3,[{1,36010001,180}]}]','[{0,[{0,38260002,2}]},{1,[{0,38260002,4}]},{2,[{0,38260002,8}]},{3,[{0,38260002,16}]}]','[{0,[{0,38260003,2}]},{1,[{0,38260003,4}]},{2,[{0,38260003,8}]},{3,[{0,38260003,16}]}]'),(7,2,28004,'[{0,38250001,2}]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,3}]},{1,[{0,38260001,6}]},{2,[{0,38260001,12}]},{3,[{0,38260001,24}]}]','[{0,[{1,36010001,90}]},{1,[{1,36010001,135}]},{2,[{1,36010001,180}]},{3,[{1,36010001,270}]}]','[{0,[{0,38260002,3}]},{1,[{0,38260002,6}]},{2,[{0,38260002,12}]},{3,[{0,38260002,24}]}]','[{0,[{0,38260003,3}]},{1,[{0,38260003,6}]},{2,[{0,38260003,12}]},{3,[{0,38260003,24}]}]'),(7,3,48668,'[{0,38250001,4}]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,5}]},{1,[{0,38260001,10}]},{2,[{0,38260001,20}]},{3,[{0,38260001,40}]}]','[{0,[{1,36010001,120}]},{1,[{1,36010001,180}]},{2,[{1,36010001,240}]},{3,[{1,36010001,360}]}]','[{0,[{0,38260002,4}]},{1,[{0,38260002,8}]},{2,[{0,38260002,16}]},{3,[{0,38260002,32}]}]','[{0,[{0,38260003,4}]},{1,[{0,38260003,8}]},{2,[{0,38260003,16}]},{3,[{0,38260003,32}]}]'),(7,4,77272,'[{0,38250001,8}]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,7}]},{1,[{0,38260001,14}]},{2,[{0,38260001,28}]},{3,[{0,38260001,56}]}]','[{0,[{1,36010001,150}]},{1,[{1,36010001,225}]},{2,[{1,36010001,300}]},{3,[{1,36010001,450}]}]','[{0,[{0,38260002,5}]},{1,[{0,38260002,10}]},{2,[{0,38260002,20}]},{3,[{0,38260002,40}]}]','[{0,[{0,38260003,5}]},{1,[{0,38260003,10}]},{2,[{0,38260003,20}]},{3,[{0,38260003,40}]}]'),(7,5,113852,'[{0,38250001,12}]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,9}]},{1,[{0,38260001,18}]},{2,[{0,38260001,36}]},{3,[{0,38260001,72}]}]','[{0,[{1,36010001,180}]},{1,[{1,36010001,270}]},{2,[{1,36010001,360}]},{3,[{1,36010001,540}]}]','[{0,[{0,38260002,6}]},{1,[{0,38260002,12}]},{2,[{0,38260002,24}]},{3,[{0,38260002,48}]}]','[{0,[{0,38260003,6}]},{1,[{0,38260003,12}]},{2,[{0,38260003,24}]},{3,[{0,38260003,48}]}]'),(7,6,158428,'[{0,38250001,18}]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,11}]},{1,[{0,38260001,22}]},{2,[{0,38260001,44}]},{3,[{0,38260001,88}]}]','[{0,[{1,36010001,210}]},{1,[{1,36010001,315}]},{2,[{1,36010001,420}]},{3,[{1,36010001,630}]}]','[{0,[{0,38260002,7}]},{1,[{0,38260002,14}]},{2,[{0,38260002,28}]},{3,[{0,38260002,56}]}]','[{0,[{0,38260003,7}]},{1,[{0,38260003,14}]},{2,[{0,38260003,28}]},{3,[{0,38260003,56}]}]'),(7,7,211000,'[{0,38250001,24}]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,13}]},{1,[{0,38260001,26}]},{2,[{0,38260001,52}]},{3,[{0,38260001,104}]}]','[{0,[{1,36010001,240}]},{1,[{1,36010001,360}]},{2,[{1,36010001,480}]},{3,[{1,36010001,720}]}]','[{0,[{0,38260002,8}]},{1,[{0,38260002,16}]},{2,[{0,38260002,32}]},{3,[{0,38260002,64}]}]','[{0,[{0,38260003,8}]},{1,[{0,38260003,16}]},{2,[{0,38260003,32}]},{3,[{0,38260003,64}]}]'),(7,8,271572,'[{0,38250001,30}]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,15}]},{1,[{0,38260001,30}]},{2,[{0,38260001,60}]},{3,[{0,38260001,120}]}]','[{0,[{1,36010001,270}]},{1,[{1,36010001,405}]},{2,[{1,36010001,540}]},{3,[{1,36010001,810}]}]','[{0,[{0,38260002,9}]},{1,[{0,38260002,18}]},{2,[{0,38260002,36}]},{3,[{0,38260002,72}]}]','[{0,[{0,38260003,9}]},{1,[{0,38260003,18}]},{2,[{0,38260003,36}]},{3,[{0,38260003,72}]}]'),(7,9,340148,'[{0,38250001,40}]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,17}]},{1,[{0,38260001,34}]},{2,[{0,38260001,68}]},{3,[{0,38260001,136}]}]','[{0,[{1,36010001,300}]},{1,[{1,36010001,450}]},{2,[{1,36010001,600}]},{3,[{1,36010001,900}]}]','[{0,[{0,38260002,10}]},{1,[{0,38260002,20}]},{2,[{0,38260002,40}]},{3,[{0,38260002,80}]}]','[{0,[{0,38260003,10}]},{1,[{0,38260003,20}]},{2,[{0,38260003,40}]},{3,[{0,38260003,80}]}]'),(7,10,0,'[]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,20}]},{1,[{0,38260001,40}]},{2,[{0,38260001,80}]},{3,[{0,38260001,160}]}]','[{0,[{1,36010001,330}]},{1,[{1,36010001,495}]},{2,[{1,36010001,660}]},{3,[{1,36010001,990}]}]','[{0,[{0,38260002,11}]},{1,[{0,38260002,22}]},{2,[{0,38260002,44}]},{3,[{0,38260002,88}]}]','[{0,[{0,38260003,11}]},{1,[{0,38260003,22}]},{2,[{0,38260003,44}]},{3,[{0,38260003,88}]}]'),(8,1,12000,'[{0,38250001,1}]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,2}]},{1,[{0,38260001,4}]},{2,[{0,38260001,8}]},{3,[{0,38260001,16}]}]','[{0,[{1,36010001,60}]},{1,[{1,36010001,90}]},{2,[{1,36010001,120}]},{3,[{1,36010001,180}]}]','[{0,[{0,38260002,2}]},{1,[{0,38260002,4}]},{2,[{0,38260002,8}]},{3,[{0,38260002,16}]}]','[{0,[{0,38260003,2}]},{1,[{0,38260003,4}]},{2,[{0,38260003,8}]},{3,[{0,38260003,16}]}]'),(8,2,28004,'[{0,38250001,2}]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,3}]},{1,[{0,38260001,6}]},{2,[{0,38260001,12}]},{3,[{0,38260001,24}]}]','[{0,[{1,36010001,90}]},{1,[{1,36010001,135}]},{2,[{1,36010001,180}]},{3,[{1,36010001,270}]}]','[{0,[{0,38260002,3}]},{1,[{0,38260002,6}]},{2,[{0,38260002,12}]},{3,[{0,38260002,24}]}]','[{0,[{0,38260003,3}]},{1,[{0,38260003,6}]},{2,[{0,38260003,12}]},{3,[{0,38260003,24}]}]'),(8,3,48668,'[{0,38250001,4}]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,5}]},{1,[{0,38260001,10}]},{2,[{0,38260001,20}]},{3,[{0,38260001,40}]}]','[{0,[{1,36010001,120}]},{1,[{1,36010001,180}]},{2,[{1,36010001,240}]},{3,[{1,36010001,360}]}]','[{0,[{0,38260002,4}]},{1,[{0,38260002,8}]},{2,[{0,38260002,16}]},{3,[{0,38260002,32}]}]','[{0,[{0,38260003,4}]},{1,[{0,38260003,8}]},{2,[{0,38260003,16}]},{3,[{0,38260003,32}]}]'),(8,4,77272,'[{0,38250001,8}]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,7}]},{1,[{0,38260001,14}]},{2,[{0,38260001,28}]},{3,[{0,38260001,56}]}]','[{0,[{1,36010001,150}]},{1,[{1,36010001,225}]},{2,[{1,36010001,300}]},{3,[{1,36010001,450}]}]','[{0,[{0,38260002,5}]},{1,[{0,38260002,10}]},{2,[{0,38260002,20}]},{3,[{0,38260002,40}]}]','[{0,[{0,38260003,5}]},{1,[{0,38260003,10}]},{2,[{0,38260003,20}]},{3,[{0,38260003,40}]}]'),(8,5,113852,'[{0,38250001,12}]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,9}]},{1,[{0,38260001,18}]},{2,[{0,38260001,36}]},{3,[{0,38260001,72}]}]','[{0,[{1,36010001,180}]},{1,[{1,36010001,270}]},{2,[{1,36010001,360}]},{3,[{1,36010001,540}]}]','[{0,[{0,38260002,6}]},{1,[{0,38260002,12}]},{2,[{0,38260002,24}]},{3,[{0,38260002,48}]}]','[{0,[{0,38260003,6}]},{1,[{0,38260003,12}]},{2,[{0,38260003,24}]},{3,[{0,38260003,48}]}]'),(8,6,158428,'[{0,38250001,18}]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,11}]},{1,[{0,38260001,22}]},{2,[{0,38260001,44}]},{3,[{0,38260001,88}]}]','[{0,[{1,36010001,210}]},{1,[{1,36010001,315}]},{2,[{1,36010001,420}]},{3,[{1,36010001,630}]}]','[{0,[{0,38260002,7}]},{1,[{0,38260002,14}]},{2,[{0,38260002,28}]},{3,[{0,38260002,56}]}]','[{0,[{0,38260003,7}]},{1,[{0,38260003,14}]},{2,[{0,38260003,28}]},{3,[{0,38260003,56}]}]'),(8,7,211000,'[{0,38250001,24}]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,13}]},{1,[{0,38260001,26}]},{2,[{0,38260001,52}]},{3,[{0,38260001,104}]}]','[{0,[{1,36010001,240}]},{1,[{1,36010001,360}]},{2,[{1,36010001,480}]},{3,[{1,36010001,720}]}]','[{0,[{0,38260002,8}]},{1,[{0,38260002,16}]},{2,[{0,38260002,32}]},{3,[{0,38260002,64}]}]','[{0,[{0,38260003,8}]},{1,[{0,38260003,16}]},{2,[{0,38260003,32}]},{3,[{0,38260003,64}]}]'),(8,8,271572,'[{0,38250001,30}]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,15}]},{1,[{0,38260001,30}]},{2,[{0,38260001,60}]},{3,[{0,38260001,120}]}]','[{0,[{1,36010001,270}]},{1,[{1,36010001,405}]},{2,[{1,36010001,540}]},{3,[{1,36010001,810}]}]','[{0,[{0,38260002,9}]},{1,[{0,38260002,18}]},{2,[{0,38260002,36}]},{3,[{0,38260002,72}]}]','[{0,[{0,38260003,9}]},{1,[{0,38260003,18}]},{2,[{0,38260003,36}]},{3,[{0,38260003,72}]}]'),(8,9,340148,'[{0,38250001,40}]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,17}]},{1,[{0,38260001,34}]},{2,[{0,38260001,68}]},{3,[{0,38260001,136}]}]','[{0,[{1,36010001,300}]},{1,[{1,36010001,450}]},{2,[{1,36010001,600}]},{3,[{1,36010001,900}]}]','[{0,[{0,38260002,10}]},{1,[{0,38260002,20}]},{2,[{0,38260002,40}]},{3,[{0,38260002,80}]}]','[{0,[{0,38260003,10}]},{1,[{0,38260003,20}]},{2,[{0,38260003,40}]},{3,[{0,38260003,80}]}]'),(8,10,0,'[]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,20}]},{1,[{0,38260001,40}]},{2,[{0,38260001,80}]},{3,[{0,38260001,160}]}]','[{0,[{1,36010001,330}]},{1,[{1,36010001,495}]},{2,[{1,36010001,660}]},{3,[{1,36010001,990}]}]','[{0,[{0,38260002,11}]},{1,[{0,38260002,22}]},{2,[{0,38260002,44}]},{3,[{0,38260002,88}]}]','[{0,[{0,38260003,11}]},{1,[{0,38260003,22}]},{2,[{0,38260003,44}]},{3,[{0,38260003,88}]}]'),(9,1,12000,'[{0,38250001,1}]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,2}]},{1,[{0,38260001,4}]},{2,[{0,38260001,8}]},{3,[{0,38260001,16}]}]','[{0,[{1,36010001,60}]},{1,[{1,36010001,90}]},{2,[{1,36010001,120}]},{3,[{1,36010001,180}]}]','[{0,[{0,38260002,2}]},{1,[{0,38260002,4}]},{2,[{0,38260002,8}]},{3,[{0,38260002,16}]}]','[{0,[{0,38260003,2}]},{1,[{0,38260003,4}]},{2,[{0,38260003,8}]},{3,[{0,38260003,16}]}]'),(9,2,28004,'[{0,38250001,2}]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,3}]},{1,[{0,38260001,6}]},{2,[{0,38260001,12}]},{3,[{0,38260001,24}]}]','[{0,[{1,36010001,90}]},{1,[{1,36010001,135}]},{2,[{1,36010001,180}]},{3,[{1,36010001,270}]}]','[{0,[{0,38260002,3}]},{1,[{0,38260002,6}]},{2,[{0,38260002,12}]},{3,[{0,38260002,24}]}]','[{0,[{0,38260003,3}]},{1,[{0,38260003,6}]},{2,[{0,38260003,12}]},{3,[{0,38260003,24}]}]'),(9,3,48668,'[{0,38250001,4}]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,5}]},{1,[{0,38260001,10}]},{2,[{0,38260001,20}]},{3,[{0,38260001,40}]}]','[{0,[{1,36010001,120}]},{1,[{1,36010001,180}]},{2,[{1,36010001,240}]},{3,[{1,36010001,360}]}]','[{0,[{0,38260002,4}]},{1,[{0,38260002,8}]},{2,[{0,38260002,16}]},{3,[{0,38260002,32}]}]','[{0,[{0,38260003,4}]},{1,[{0,38260003,8}]},{2,[{0,38260003,16}]},{3,[{0,38260003,32}]}]'),(9,4,77272,'[{0,38250001,8}]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,7}]},{1,[{0,38260001,14}]},{2,[{0,38260001,28}]},{3,[{0,38260001,56}]}]','[{0,[{1,36010001,150}]},{1,[{1,36010001,225}]},{2,[{1,36010001,300}]},{3,[{1,36010001,450}]}]','[{0,[{0,38260002,5}]},{1,[{0,38260002,10}]},{2,[{0,38260002,20}]},{3,[{0,38260002,40}]}]','[{0,[{0,38260003,5}]},{1,[{0,38260003,10}]},{2,[{0,38260003,20}]},{3,[{0,38260003,40}]}]'),(9,5,113852,'[{0,38250001,12}]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,9}]},{1,[{0,38260001,18}]},{2,[{0,38260001,36}]},{3,[{0,38260001,72}]}]','[{0,[{1,36010001,180}]},{1,[{1,36010001,270}]},{2,[{1,36010001,360}]},{3,[{1,36010001,540}]}]','[{0,[{0,38260002,6}]},{1,[{0,38260002,12}]},{2,[{0,38260002,24}]},{3,[{0,38260002,48}]}]','[{0,[{0,38260003,6}]},{1,[{0,38260003,12}]},{2,[{0,38260003,24}]},{3,[{0,38260003,48}]}]'),(9,6,158428,'[{0,38250001,18}]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,11}]},{1,[{0,38260001,22}]},{2,[{0,38260001,44}]},{3,[{0,38260001,88}]}]','[{0,[{1,36010001,210}]},{1,[{1,36010001,315}]},{2,[{1,36010001,420}]},{3,[{1,36010001,630}]}]','[{0,[{0,38260002,7}]},{1,[{0,38260002,14}]},{2,[{0,38260002,28}]},{3,[{0,38260002,56}]}]','[{0,[{0,38260003,7}]},{1,[{0,38260003,14}]},{2,[{0,38260003,28}]},{3,[{0,38260003,56}]}]'),(9,7,211000,'[{0,38250001,24}]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,13}]},{1,[{0,38260001,26}]},{2,[{0,38260001,52}]},{3,[{0,38260001,104}]}]','[{0,[{1,36010001,240}]},{1,[{1,36010001,360}]},{2,[{1,36010001,480}]},{3,[{1,36010001,720}]}]','[{0,[{0,38260002,8}]},{1,[{0,38260002,16}]},{2,[{0,38260002,32}]},{3,[{0,38260002,64}]}]','[{0,[{0,38260003,8}]},{1,[{0,38260003,16}]},{2,[{0,38260003,32}]},{3,[{0,38260003,64}]}]'),(9,8,271572,'[{0,38250001,30}]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,15}]},{1,[{0,38260001,30}]},{2,[{0,38260001,60}]},{3,[{0,38260001,120}]}]','[{0,[{1,36010001,270}]},{1,[{1,36010001,405}]},{2,[{1,36010001,540}]},{3,[{1,36010001,810}]}]','[{0,[{0,38260002,9}]},{1,[{0,38260002,18}]},{2,[{0,38260002,36}]},{3,[{0,38260002,72}]}]','[{0,[{0,38260003,9}]},{1,[{0,38260003,18}]},{2,[{0,38260003,36}]},{3,[{0,38260003,72}]}]'),(9,9,340148,'[{0,38250001,40}]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,17}]},{1,[{0,38260001,34}]},{2,[{0,38260001,68}]},{3,[{0,38260001,136}]}]','[{0,[{1,36010001,300}]},{1,[{1,36010001,450}]},{2,[{1,36010001,600}]},{3,[{1,36010001,900}]}]','[{0,[{0,38260002,10}]},{1,[{0,38260002,20}]},{2,[{0,38260002,40}]},{3,[{0,38260002,80}]}]','[{0,[{0,38260003,10}]},{1,[{0,38260003,20}]},{2,[{0,38260003,40}]},{3,[{0,38260003,80}]}]'),(9,10,0,'[]','[{100,1},{100,3},{100,5},{100,7},{100,15}]','[{0,[{0,38260001,20}]},{1,[{0,38260001,40}]},{2,[{0,38260001,80}]},{3,[{0,38260001,160}]}]','[{0,[{1,36010001,330}]},{1,[{1,36010001,495}]},{2,[{1,36010001,660}]},{3,[{1,36010001,990}]}]','[{0,[{0,38260002,11}]},{1,[{0,38260002,22}]},{2,[{0,38260002,44}]},{3,[{0,38260002,88}]}]','[{0,[{0,38260003,11}]},{1,[{0,38260003,22}]},{2,[{0,38260003,44}]},{3,[{0,38260003,88}]}]'),(10,1,12000,'[{0,38250001,1}]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,2}]},{1,[{0,38260001,4}]},{2,[{0,38260001,8}]},{3,[{0,38260001,16}]}]','[{0,[{1,36010001,60}]},{1,[{1,36010001,90}]},{2,[{1,36010001,120}]},{3,[{1,36010001,180}]}]','[{0,[{0,38260002,2}]},{1,[{0,38260002,4}]},{2,[{0,38260002,8}]},{3,[{0,38260002,16}]}]','[{0,[{0,38260003,2}]},{1,[{0,38260003,4}]},{2,[{0,38260003,8}]},{3,[{0,38260003,16}]}]'),(10,2,28004,'[{0,38250001,2}]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,3}]},{1,[{0,38260001,6}]},{2,[{0,38260001,12}]},{3,[{0,38260001,24}]}]','[{0,[{1,36010001,90}]},{1,[{1,36010001,135}]},{2,[{1,36010001,180}]},{3,[{1,36010001,270}]}]','[{0,[{0,38260002,3}]},{1,[{0,38260002,6}]},{2,[{0,38260002,12}]},{3,[{0,38260002,24}]}]','[{0,[{0,38260003,3}]},{1,[{0,38260003,6}]},{2,[{0,38260003,12}]},{3,[{0,38260003,24}]}]'),(10,3,48668,'[{0,38250001,4}]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,5}]},{1,[{0,38260001,10}]},{2,[{0,38260001,20}]},{3,[{0,38260001,40}]}]','[{0,[{1,36010001,120}]},{1,[{1,36010001,180}]},{2,[{1,36010001,240}]},{3,[{1,36010001,360}]}]','[{0,[{0,38260002,4}]},{1,[{0,38260002,8}]},{2,[{0,38260002,16}]},{3,[{0,38260002,32}]}]','[{0,[{0,38260003,4}]},{1,[{0,38260003,8}]},{2,[{0,38260003,16}]},{3,[{0,38260003,32}]}]'),(10,4,77272,'[{0,38250001,8}]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,7}]},{1,[{0,38260001,14}]},{2,[{0,38260001,28}]},{3,[{0,38260001,56}]}]','[{0,[{1,36010001,150}]},{1,[{1,36010001,225}]},{2,[{1,36010001,300}]},{3,[{1,36010001,450}]}]','[{0,[{0,38260002,5}]},{1,[{0,38260002,10}]},{2,[{0,38260002,20}]},{3,[{0,38260002,40}]}]','[{0,[{0,38260003,5}]},{1,[{0,38260003,10}]},{2,[{0,38260003,20}]},{3,[{0,38260003,40}]}]'),(10,5,113852,'[{0,38250001,12}]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,9}]},{1,[{0,38260001,18}]},{2,[{0,38260001,36}]},{3,[{0,38260001,72}]}]','[{0,[{1,36010001,180}]},{1,[{1,36010001,270}]},{2,[{1,36010001,360}]},{3,[{1,36010001,540}]}]','[{0,[{0,38260002,6}]},{1,[{0,38260002,12}]},{2,[{0,38260002,24}]},{3,[{0,38260002,48}]}]','[{0,[{0,38260003,6}]},{1,[{0,38260003,12}]},{2,[{0,38260003,24}]},{3,[{0,38260003,48}]}]'),(10,6,158428,'[{0,38250001,18}]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,11}]},{1,[{0,38260001,22}]},{2,[{0,38260001,44}]},{3,[{0,38260001,88}]}]','[{0,[{1,36010001,210}]},{1,[{1,36010001,315}]},{2,[{1,36010001,420}]},{3,[{1,36010001,630}]}]','[{0,[{0,38260002,7}]},{1,[{0,38260002,14}]},{2,[{0,38260002,28}]},{3,[{0,38260002,56}]}]','[{0,[{0,38260003,7}]},{1,[{0,38260003,14}]},{2,[{0,38260003,28}]},{3,[{0,38260003,56}]}]'),(10,7,211000,'[{0,38250001,24}]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,13}]},{1,[{0,38260001,26}]},{2,[{0,38260001,52}]},{3,[{0,38260001,104}]}]','[{0,[{1,36010001,240}]},{1,[{1,36010001,360}]},{2,[{1,36010001,480}]},{3,[{1,36010001,720}]}]','[{0,[{0,38260002,8}]},{1,[{0,38260002,16}]},{2,[{0,38260002,32}]},{3,[{0,38260002,64}]}]','[{0,[{0,38260003,8}]},{1,[{0,38260003,16}]},{2,[{0,38260003,32}]},{3,[{0,38260003,64}]}]'),(10,8,271572,'[{0,38250001,30}]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,15}]},{1,[{0,38260001,30}]},{2,[{0,38260001,60}]},{3,[{0,38260001,120}]}]','[{0,[{1,36010001,270}]},{1,[{1,36010001,405}]},{2,[{1,36010001,540}]},{3,[{1,36010001,810}]}]','[{0,[{0,38260002,9}]},{1,[{0,38260002,18}]},{2,[{0,38260002,36}]},{3,[{0,38260002,72}]}]','[{0,[{0,38260003,9}]},{1,[{0,38260003,18}]},{2,[{0,38260003,36}]},{3,[{0,38260003,72}]}]'),(10,9,340148,'[{0,38250001,40}]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,17}]},{1,[{0,38260001,34}]},{2,[{0,38260001,68}]},{3,[{0,38260001,136}]}]','[{0,[{1,36010001,300}]},{1,[{1,36010001,450}]},{2,[{1,36010001,600}]},{3,[{1,36010001,900}]}]','[{0,[{0,38260002,10}]},{1,[{0,38260002,20}]},{2,[{0,38260002,40}]},{3,[{0,38260002,80}]}]','[{0,[{0,38260003,10}]},{1,[{0,38260003,20}]},{2,[{0,38260003,40}]},{3,[{0,38260003,80}]}]'),(10,10,0,'[]','[{100,2},{100,4},{100,6},{100,8},{100,16}]','[{0,[{0,38260001,20}]},{1,[{0,38260001,40}]},{2,[{0,38260001,80}]},{3,[{0,38260001,160}]}]','[{0,[{1,36010001,330}]},{1,[{1,36010001,495}]},{2,[{1,36010001,660}]},{3,[{1,36010001,990}]}]','[{0,[{0,38260002,11}]},{1,[{0,38260002,22}]},{2,[{0,38260002,44}]},{3,[{0,38260002,88}]}]','[{0,[{0,38260003,11}]},{1,[{0,38260003,22}]},{2,[{0,38260003,44}]},{3,[{0,38260003,88}]}]');
/*!40000 ALTER TABLE `base_equip_wash` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_equip_wash_active_condition`
--

DROP TABLE IF EXISTS `base_equip_wash_active_condition`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_equip_wash_active_condition` (
  `num` smallint(5) unsigned NOT NULL COMMENT '激活条数',
  `condition` varchar(255) NOT NULL COMMENT '条件',
  `description` varchar(255) NOT NULL COMMENT '描述',
  PRIMARY KEY (`num`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_equip_wash_active_condition`
--

LOCK TABLES `base_equip_wash_active_condition` WRITE;
/*!40000 ALTER TABLE `base_equip_wash_active_condition` DISABLE KEYS */;
INSERT INTO `base_equip_wash_active_condition` VALUES (1,' [{1,260}]','该条属性免费开启'),(2,' [{2,[{2,0,100}]}]','消耗100绑钻可开启 '),(3,' [{2,[{2,0,100}]}]','消耗100绑钻可开启'),(4,' [{2,[{2,0,100}]}]','消耗100绑钻可开启');
/*!40000 ALTER TABLE `base_equip_wash_active_condition` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_equip_wash_attr`
--

DROP TABLE IF EXISTS `base_equip_wash_attr`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_equip_wash_attr` (
  `division` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '段位',
  `attr_id` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '属性id',
  `attr_color` varchar(255) NOT NULL DEFAULT '[]' COMMENT '属性颜色权重',
  `attr0` varchar(255) NOT NULL DEFAULT '[]' COMMENT '绿属范围',
  `attr1` varchar(255) NOT NULL DEFAULT '[]' COMMENT '蓝属范围',
  `attr2` varchar(255) NOT NULL DEFAULT '[]' COMMENT '紫属范围',
  `attr3` varchar(255) NOT NULL DEFAULT '[]' COMMENT '橙属范围',
  `attr4` varchar(255) NOT NULL DEFAULT '[]' COMMENT '红属范围',
  PRIMARY KEY (`division`,`attr_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备洗炼属性配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_equip_wash_attr`
--

LOCK TABLES `base_equip_wash_attr` WRITE;
/*!40000 ALTER TABLE `base_equip_wash_attr` DISABLE KEYS */;
INSERT INTO `base_equip_wash_attr` VALUES (1,1,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[50,99]','[100,124]','[125,149]','[150,279]','[280,300]'),(1,2,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[1000,1999]','[2000,2499]','[2500,2999]','[3000,5599]','[5600,6000]'),(1,3,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[40,79]','[80,99]','[100,119]','[120,223]','[224,240]'),(1,4,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[40,79]','[80,99]','[100,119]','[120,223]','[224,240]'),(1,5,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[20,39]','[40,49]','[50,59]','[60,111]','[112,120]'),(1,6,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[20,39]','[40,49]','[50,59]','[60,111]','[112,120]'),(1,7,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[20,39]','[40,49]','[50,59]','[60,111]','[112,120]'),(1,8,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[20,39]','[40,49]','[50,59]','[60,111]','[112,120]'),(1,15,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[33,66]','[67,82]','[83,99]','[100,186]','[187,200]'),(1,16,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[33,66]','[67,82]','[83,99]','[100,186]','[187,200]'),(2,1,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[150,220]','[221,292]','[293,349]','[350,406]','[407,436]'),(2,2,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[3000,4428]','[4429,5857]','[5858,7000]','[7001,8143]','[8144,8715]'),(2,3,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[120,176]','[177,233]','[234,279]','[280,325]','[326,349]'),(2,4,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[120,176]','[177,233]','[234,279]','[280,325]','[326,349]'),(2,5,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[60,88]','[89,116]','[117,139]','[140,162]','[163,174]'),(2,6,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[60,88]','[89,116]','[117,139]','[140,162]','[163,174]'),(2,7,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[60,88]','[89,116]','[117,139]','[140,162]','[163,174]'),(2,8,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[60,88]','[89,116]','[117,139]','[140,162]','[163,174]'),(2,15,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[100,147]','[148,194]','[195,232]','[233,270]','[271,291]'),(2,16,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[100,147]','[148,194]','[195,232]','[233,270]','[271,291]'),(3,1,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[350,441]','[442,534]','[535,607]','[608,681]','[682,719]'),(3,2,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[7001,8845]','[8846,10690]','[10691,12166]','[12167,13642]','[13643,14381]'),(3,3,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[280,353]','[354,427]','[428,486]','[487,545]','[546,575]'),(3,4,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[280,353]','[354,427]','[428,486]','[487,545]','[546,575]'),(3,5,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[140,176]','[177,213]','[214,242]','[243,272]','[273,288]'),(3,6,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[140,176]','[177,213]','[214,242]','[243,272]','[273,288]'),(3,7,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[140,176]','[177,213]','[214,242]','[243,272]','[273,288]'),(3,8,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[140,176]','[177,213]','[214,242]','[243,272]','[273,288]'),(3,15,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[233,294]','[295,355]','[356,405]','[406,454]','[455,479]'),(3,16,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[233,294]','[295,355]','[356,405]','[406,454]','[455,479]'),(4,1,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[608,735]','[736,863]','[864,965]','[966,1067]','[1068,1119]'),(4,2,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[12167,14720]','[14721,17274]','[17275,19317]','[19318,21360]','[21361,22382]'),(4,3,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[487,588]','[589,690]','[691,772]','[773,853]','[854,895]'),(4,4,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[487,588]','[589,690]','[691,772]','[773,853]','[854,895]'),(4,5,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[243,293]','[294,345]','[346,385]','[386,426]','[427,448]'),(4,6,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[243,293]','[294,345]','[346,385]','[386,426]','[427,448]'),(4,7,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[243,293]','[294,345]','[346,385]','[386,426]','[427,448]'),(4,8,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[243,293]','[294,345]','[346,385]','[386,426]','[427,448]'),(4,15,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[406,490]','[491,575]','[576,643]','[644,711]','[712,746]'),(4,16,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[406,490]','[491,575]','[576,643]','[644,711]','[712,746]'),(5,1,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[966,1128]','[1129,1292]','[1293,1422]','[1423,1553]','[1554,1619]'),(5,2,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[19318,22583]','[22584,25849]','[25850,28462]','[28463,31075]','[31076,32382]'),(5,3,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[773,902]','[903,1033]','[1034,1138]','[1139,1242]','[1243,1295]'),(5,4,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[773,902]','[903,1033]','[1034,1138]','[1139,1242]','[1243,1295]'),(5,5,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[386,451]','[452,516]','[517,568]','[569,621]','[622,648]'),(5,6,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[386,451]','[452,516]','[517,568]','[569,621]','[622,648]'),(5,7,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[386,451]','[452,516]','[517,568]','[569,621]','[622,648]'),(5,8,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[386,451]','[452,516]','[517,568]','[569,621]','[622,648]'),(5,15,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[644,752]','[753,861]','[862,948]','[949,1035]','[1036,1079]'),(5,16,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[644,752]','[753,861]','[862,948]','[949,1035]','[1036,1079]'),(6,1,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[1423,1621]','[1622,1820]','[1821,1979]','[1980,2139]','[2140,2219]'),(6,2,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[28463,32442]','[32443,36422]','[36423,39606]','[39607,42790]','[42791,44383]'),(6,3,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[1139,1297]','[1298,1456]','[1457,1583]','[1584,1711]','[1712,1775]'),(6,4,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[1139,1297]','[1298,1456]','[1457,1583]','[1584,1711]','[1712,1775]'),(6,5,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[569,648]','[649,727]','[728,791]','[792,855]','[856,888]'),(6,6,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[569,648]','[649,727]','[728,791]','[792,855]','[856,888]'),(6,7,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[569,648]','[649,727]','[728,791]','[792,855]','[856,888]'),(6,8,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[569,648]','[649,727]','[728,791]','[792,855]','[856,888]'),(6,15,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[949,1080]','[1081,1213]','[1214,1319]','[1320,1425]','[1426,1479]'),(6,16,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[949,1080]','[1081,1213]','[1214,1319]','[1320,1425]','[1426,1479]'),(7,1,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[1980,2214]','[2215,2449]','[2450,2637]','[2638,2824]','[2825,2919]'),(7,2,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[39607,44300]','[44301,48994]','[48995,52749]','[52750,56504]','[56505,58383]'),(7,3,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[1584,1771]','[1772,1959]','[1960,2109]','[2110,2259]','[2260,2335]'),(7,4,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[1584,1771]','[1772,1959]','[1960,2109]','[2110,2259]','[2260,2335]'),(7,5,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[792,885]','[886,979]','[980,1054]','[1055,1129]','[1130,1168]'),(7,6,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[792,885]','[886,979]','[980,1054]','[1055,1129]','[1130,1168]'),(7,7,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[792,885]','[886,979]','[980,1054]','[1055,1129]','[1130,1168]'),(7,8,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[792,885]','[886,979]','[980,1054]','[1055,1129]','[1130,1168]'),(7,15,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[1320,1476]','[1477,1632]','[1633,1757]','[1758,1883]','[1884,1946]'),(7,16,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[1320,1476]','[1477,1632]','[1633,1757]','[1758,1883]','[1884,1946]'),(8,1,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[2638,2907]','[2908,3177]','[3178,3394]','[3395,3610]','[3611,3719]'),(8,2,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[52750,58157]','[58158,63565]','[63566,67892]','[67893,72219]','[72220,74383]'),(8,3,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[2110,2325]','[2326,2542]','[2543,2715]','[2716,2888]','[2889,2975]'),(8,4,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[2110,2325]','[2326,2542]','[2543,2715]','[2716,2888]','[2889,2975]'),(8,5,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[1055,1162]','[1163,1270]','[1271,1357]','[1358,1443]','[1444,1488]'),(8,6,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[1055,1162]','[1163,1270]','[1271,1357]','[1358,1443]','[1444,1488]'),(8,7,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[1055,1162]','[1163,1270]','[1271,1357]','[1358,1443]','[1444,1488]'),(8,8,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[1055,1162]','[1163,1270]','[1271,1357]','[1358,1443]','[1444,1488]'),(8,15,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[1758,1938]','[1939,2118]','[2119,2262]','[2263,2406]','[2407,2479]'),(8,16,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[1758,1938]','[1939,2118]','[2119,2262]','[2263,2406]','[2407,2479]'),(9,1,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[3395,3700]','[3701,4006]','[4007,4251]','[4252,4496]','[4497,4619]'),(9,2,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[67893,74015]','[74016,80138]','[80139,85036]','[85037,89934]','[89935,92384]'),(9,3,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[2716,2960]','[2961,3205]','[3206,3400]','[3401,3596]','[3597,3695]'),(9,4,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[2716,2960]','[2961,3205]','[3206,3400]','[3401,3596]','[3597,3695]'),(9,5,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[1358,1479]','[1480,1602]','[1603,1700]','[1701,1798]','[1799,1848]'),(9,6,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[1358,1479]','[1480,1602]','[1603,1700]','[1701,1798]','[1799,1848]'),(9,7,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[1358,1479]','[1480,1602]','[1603,1700]','[1701,1798]','[1799,1848]'),(9,8,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[1358,1479]','[1480,1602]','[1603,1700]','[1701,1798]','[1799,1848]'),(9,15,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[2263,2466]','[2467,2670]','[2671,2834]','[2835,2997]','[2998,3079]'),(9,16,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[2263,2466]','[2467,2670]','[2671,2834]','[2835,2997]','[2998,3079]'),(10,1,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[4252,4593]','[4594,4935]','[4936,5208]','[5209,5481]','[5482,5619]'),(10,2,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[85037,91873]','[91874,98710]','[98711,104179]','[104180,109648]','[109649,112384]'),(10,3,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[3401,3674]','[3675,3947]','[3948,4166]','[4167,4385]','[4386,4495]'),(10,4,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[3401,3674]','[3675,3947]','[3948,4166]','[4167,4385]','[4386,4495]'),(10,5,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[1701,1836]','[1837,1973]','[1974,2083]','[2084,2192]','[2193,2248]'),(10,6,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[1701,1836]','[1837,1973]','[1974,2083]','[2084,2192]','[2193,2248]'),(10,7,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[1701,1836]','[1837,1973]','[1974,2083]','[2084,2192]','[2193,2248]'),(10,8,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[1701,1836]','[1837,1973]','[1974,2083]','[2084,2192]','[2193,2248]'),(10,15,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[2835,3061]','[3062,3289]','[3290,3472]','[3473,3654]','[3655,3746]'),(10,16,'[{39,0},{50,1},{8,2},{2,3},{1,4}]','[2835,3061]','[3062,3289]','[3290,3472]','[3473,3654]','[3655,3746]');
/*!40000 ALTER TABLE `base_equip_wash_attr` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_equip_wash_attr_limit`
--

DROP TABLE IF EXISTS `base_equip_wash_attr_limit`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_equip_wash_attr_limit` (
  `min_lv` smallint(5) unsigned NOT NULL COMMENT '最低等级',
  `max_lv` smallint(5) unsigned NOT NULL COMMENT '最高等级',
  `type` smallint(5) unsigned NOT NULL COMMENT '属性类型',
  `color` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '品质',
  `limit` int(11) unsigned NOT NULL COMMENT '属性上限',
  PRIMARY KEY (`min_lv`,`max_lv`,`type`,`color`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_equip_wash_attr_limit`
--

LOCK TABLES `base_equip_wash_attr_limit` WRITE;
/*!40000 ALTER TABLE `base_equip_wash_attr_limit` DISABLE KEYS */;
/*!40000 ALTER TABLE `base_equip_wash_attr_limit` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_equip_wash_attr_new`
--

DROP TABLE IF EXISTS `base_equip_wash_attr_new`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_equip_wash_attr_new` (
  `pos` smallint(5) unsigned NOT NULL COMMENT '装备部位 ',
  `career` smallint(5) unsigned NOT NULL COMMENT '职业',
  `type_ratio` varchar(255) NOT NULL COMMENT '属性类型/权重',
  PRIMARY KEY (`pos`,`career`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_equip_wash_attr_new`
--

LOCK TABLES `base_equip_wash_attr_new` WRITE;
/*!40000 ALTER TABLE `base_equip_wash_attr_new` DISABLE KEYS */;
/*!40000 ALTER TABLE `base_equip_wash_attr_new` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_equip_wash_attr_val`
--

DROP TABLE IF EXISTS `base_equip_wash_attr_val`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_equip_wash_attr_val` (
  `type` smallint(5) unsigned NOT NULL COMMENT '属性类型',
  `quality` smallint(5) unsigned NOT NULL COMMENT '属性品质',
  `value` smallint(5) unsigned NOT NULL COMMENT '属性值',
  PRIMARY KEY (`type`,`quality`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_equip_wash_attr_val`
--

LOCK TABLES `base_equip_wash_attr_val` WRITE;
/*!40000 ALTER TABLE `base_equip_wash_attr_val` DISABLE KEYS */;
/*!40000 ALTER TABLE `base_equip_wash_attr_val` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_equip_wash_cal_base`
--

DROP TABLE IF EXISTS `base_equip_wash_cal_base`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_equip_wash_cal_base` (
  `lv_min` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小等级',
  `lv_max` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大等级',
  `type` smallint(5) unsigned NOT NULL COMMENT '属性类型',
  `base` int(11) unsigned NOT NULL COMMENT '基数',
  PRIMARY KEY (`lv_min`,`lv_max`,`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='精炼基数';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_equip_wash_cal_base`
--

LOCK TABLES `base_equip_wash_cal_base` WRITE;
/*!40000 ALTER TABLE `base_equip_wash_cal_base` DISABLE KEYS */;
/*!40000 ALTER TABLE `base_equip_wash_cal_base` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_equip_wash_cost`
--

DROP TABLE IF EXISTS `base_equip_wash_cost`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_equip_wash_cost` (
  `num` smallint(5) unsigned NOT NULL COMMENT '锁定条数',
  `cost` varchar(255) NOT NULL COMMENT '洗练消耗',
  PRIMARY KEY (`num`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_equip_wash_cost`
--

LOCK TABLES `base_equip_wash_cost` WRITE;
/*!40000 ALTER TABLE `base_equip_wash_cost` DISABLE KEYS */;
/*!40000 ALTER TABLE `base_equip_wash_cost` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_equip_wash_kv`
--

DROP TABLE IF EXISTS `base_equip_wash_kv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_equip_wash_kv` (
  `key` varchar(255) NOT NULL COMMENT '键',
  `val` varchar(255) NOT NULL COMMENT '值\r\n',
  `desc` varchar(255) NOT NULL COMMENT '描述',
  PRIMARY KEY (`key`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_equip_wash_kv`
--

LOCK TABLES `base_equip_wash_kv` WRITE;
/*!40000 ALTER TABLE `base_equip_wash_kv` DISABLE KEYS */;
INSERT INTO `base_equip_wash_kv` VALUES ('refine_weight','[{30,{1,{5,30}}},{20,{1,{40,60}}},{30,{2,{40,60}}},{20,{2,{5,25}}}]','精炼权重：[{权重, {精炼结果(1增加,2减少),{最小随机值, 最大随机值 }}}]');
/*!40000 ALTER TABLE `base_equip_wash_kv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_equip_wash_refine`
--

DROP TABLE IF EXISTS `base_equip_wash_refine`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_equip_wash_refine` (
  `progress_min` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小进度',
  `progress_max` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大进度',
  `result_list` varchar(1024) NOT NULL COMMENT '精炼结果列表',
  PRIMARY KEY (`progress_min`,`progress_max`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备精炼结果配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_equip_wash_refine`
--

LOCK TABLES `base_equip_wash_refine` WRITE;
/*!40000 ALTER TABLE `base_equip_wash_refine` DISABLE KEYS */;
/*!40000 ALTER TABLE `base_equip_wash_refine` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_equip_wash_refine_cost`
--

DROP TABLE IF EXISTS `base_equip_wash_refine_cost`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_equip_wash_refine_cost` (
  `lv_min` smallint(5) unsigned NOT NULL COMMENT '最小等级',
  `lv_max` smallint(5) unsigned NOT NULL COMMENT '最大等级',
  `cost` varchar(255) NOT NULL COMMENT '消耗',
  PRIMARY KEY (`lv_min`,`lv_max`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='精炼消耗';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_equip_wash_refine_cost`
--

LOCK TABLES `base_equip_wash_refine_cost` WRITE;
/*!40000 ALTER TABLE `base_equip_wash_refine_cost` DISABLE KEYS */;
/*!40000 ALTER TABLE `base_equip_wash_refine_cost` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_equip_wash_unlock_lv`
--

DROP TABLE IF EXISTS `base_equip_wash_unlock_lv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_equip_wash_unlock_lv` (
  `pos` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '部位',
  `unlock_lv` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '洗炼解锁等级',
  PRIMARY KEY (`pos`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备洗炼部位解锁配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_equip_wash_unlock_lv`
--

LOCK TABLES `base_equip_wash_unlock_lv` WRITE;
/*!40000 ALTER TABLE `base_equip_wash_unlock_lv` DISABLE KEYS */;
INSERT INTO `base_equip_wash_unlock_lv` VALUES (1,260),(2,270),(3,275),(4,280),(5,305),(6,285),(7,290),(8,295),(9,310),(10,300);
/*!40000 ALTER TABLE `base_equip_wash_unlock_lv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_equip_whole_reward`
--

DROP TABLE IF EXISTS `base_equip_whole_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_equip_whole_reward` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `need_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '类型对应的级别',
  `next_nlv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '下一阶段需要的类型总等级',
  `attr_list` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '属性列表',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备全身奖励';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_equip_whole_reward`
--

LOCK TABLES `base_equip_whole_reward` WRITE;
/*!40000 ALTER TABLE `base_equip_whole_reward` DISABLE KEYS */;
INSERT INTO `base_equip_whole_reward` VALUES (1,1,100,149,'[{1,100},{2,2000}]'),(2,1,150,199,'[{1,150},{2,3000}]'),(3,1,200,249,'[{1,200},{2,4000}]'),(4,1,250,299,'[{1,250},{2,5000}]'),(5,1,300,399,'[{1,300},{2,6000}]'),(6,1,400,499,'[{1,400},{2,8000}]'),(7,1,500,599,'[{1,500},{2,10000}]'),(8,1,600,699,'[{1,600},{2,12000}]'),(9,1,700,799,'[{1,700},{2,14000}]'),(10,1,800,999,'[{1,800},{2,16000}]'),(11,1,1000,1199,'[{1,1000},{2,20000}]'),(12,1,1200,1399,'[{1,1200},{2,24000}]'),(13,1,1400,1599,'[{1,1400},{2,28000}]'),(14,1,1600,1999,'[{1,1600},{2,32000}]'),(15,1,2000,2399,'[{1,2000},{2,40000}]'),(16,1,2400,2799,'[{1,2400},{2,48000}]'),(17,1,2800,3199,'[{1,2800},{2,56000}]'),(18,1,3200,3599,'[{1,3200},{2,64000}]'),(19,1,3600,3999,'[{1,3600},{2,72000}]'),(20,1,4000,4499,'[{1,4000},{2,80000}]'),(21,1,4500,4999,'[{1,4500},{2,90000}]'),(22,1,5000,5000,'[{1,5000},{2,100000}]'),(23,2,3,5,'[{3,40},{4,40}]'),(24,2,6,8,'[{3,80},{4,80}]'),(25,2,9,11,'[{3,120},{4,120}]'),(26,2,12,14,'[{3,160},{4,160}]'),(27,2,15,17,'[{3,200},{4,200}]'),(28,2,18,20,'[{3,250},{4,250}]'),(29,2,21,23,'[{3,300},{4,300}]'),(30,2,24,26,'[{3,350},{4,350}]'),(31,2,27,29,'[{3,450},{4,450}]'),(32,2,30,30,'[{3,550},{4,550}]'),(33,3,25,49,'[{15,50},{16,50}]'),(34,3,50,74,'[{15,100},{16,100}]'),(35,3,75,99,'[{15,150},{16,150}]'),(36,3,100,124,'[{15,200},{16,200}]'),(37,3,125,149,'[{15,300},{16,300}]'),(38,3,150,174,'[{15,400},{16,400}]'),(39,3,175,199,'[{15,500},{16,500}]'),(40,3,200,224,'[{15,600},{16,600}]'),(41,3,225,249,'[{15,800},{16,800}]'),(42,3,250,274,'[{15,1000},{16,1000}]'),(43,3,275,299,'[{15,1200},{16,1200}]'),(44,3,300,324,'[{15,1500},{16,1500}]'),(45,3,325,349,'[{15,1800},{16,1800}]'),(46,3,350,374,'[{15,2100},{16,2100}]'),(47,3,375,399,'[{15,2400},{16,2400}]'),(48,3,400,424,'[{15,2800},{16,2800}]'),(49,3,425,449,'[{15,3200},{16,3200}]'),(50,3,450,450,'[{15,3600},{16,3600}]'),(51,4,6,11,'[{223,150},{221,150}]'),(52,4,12,17,'[{223,300},{221,300}]'),(53,4,18,23,'[{223,450},{221,450}]'),(54,4,24,29,'[{223,600},{221,600}]'),(55,4,30,35,'[{223,750},{221,750}]'),(56,4,36,41,'[{223,900},{221,900}]'),(57,4,42,47,'[{223,1050},{221,1050}]'),(58,4,48,53,'[{223,1200},{221,1200}]'),(59,4,54,59,'[{223,1350},{221,1350}]'),(60,4,60,65,'[{223,1500},{221,1500}]'),(61,4,66,71,'[{223,1650},{221,1650}]'),(62,4,72,77,'[{223,1800},{221,1800}]'),(63,4,78,83,'[{223,1950},{221,1950}]'),(64,4,84,89,'[{223,2100},{221,2100}]'),(65,4,90,95,'[{223,2250},{221,2250}]'),(66,4,96,101,'[{223,2400},{221,2400}]'),(67,4,102,107,'[{223,2550},{221,2550}]'),(68,4,108,113,'[{223,2700},{221,2700}]'),(69,4,114,119,'[{223,2850},{221,2850}]'),(70,4,120,120,'[{223,3000},{221,3000}]');
/*!40000 ALTER TABLE `base_equip_whole_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_error_code`
--

DROP TABLE IF EXISTS `base_error_code`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_error_code` (
  `module` int(11) unsigned NOT NULL COMMENT '功能id',
  `type` varchar(100) NOT NULL COMMENT '错误类型',
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '错误码id',
  `about` varchar(255) NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='错误码配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_error_code`
--

LOCK TABLES `base_error_code` WRITE;
/*!40000 ALTER TABLE `base_error_code` DISABLE KEYS */;
INSERT INTO `base_error_code` VALUES (0,'fail',0,'操作失败'),(0,'success',1,'操作成功'),(0,'gold_not_enough',1001,'您的钻石余额不足'),(0,'coin_not_enough',1002,'您的金币余额不足'),(0,'goods_not_enough',1003,'物品不足'),(0,'money_not_enough',1004,'您的金额不足'),(0,'missing_config',1005,'缺失配置'),(0,'bgold_not_enough',1006,'您的绑钻余额不足'),(0,'player_add_exp',1007,'经验 +{1}'),(0,'not_enough_length',1008,'长度为2-6个单位'),(0,'name_exist',1009,'该名称已存在'),(0,'illegal_character',1010,'非法字符'),(0,'not_have_free_card',1011,'改名卡数量不足'),(0,'lv_limit',1012,'等级不足，功能暂未开放'),(0,'vip_limit',1013,'专属等级不够'),(0,'cannot_transferable_scene',1014,'当前场景不能进入！'),(0,'cannot_transferable_area',1015,'非安全区不能进入！'),(0,'err_config',1016,'配置出错'),(0,'figure_actived',1017,'形象已激活'),(0,'data_error',1018,'数据异常，请稍后再试！'),(0,'cell_beyond',1019,'格子超出上限！'),(0,'player_add_exp_extra',1020,'经验 +{1}（+{2}%）'),(0,'player_lv_less',1021,'您的等级小于{1}'),(0,'player_lv_large',1022,'您的等级大于{1}'),(0,'operation_too_quickly',1023,'您的操作过快'),(0,'system_busy',1024,'系统繁忙，请稍后再操作'),(0,'honour_not_enough',1025,'您的荣誉值不足'),(0,'in_forbid_pk_status',1026,'玩家当前状态不能释放技能'),(0,'player_die',1027,'人物已死亡'),(0,'reward_is_got',1028,'奖励已领取'),(0,'what_not_enough',1029,'{1}不足'),(0,'player_power_less',1030,'您的战力小于{1}'),(0,'exp_not_enough',1031,'经验值不足'),(0,'config_err',1032,'配置错误'),(0,'turn_not_enough',1033,'操作无效，转生次数不足'),(0,'not_connect_center',1034,'连接不上跨服中心'),(0,'args_error',1035,'参数错误'),(0,'fgold_not_enough',1036,'您的粉钻余额不足'),(102,'err102_setting_key_not_exist',1020001,'游戏设置类型不存在'),(102,'err102_too_frequent',1020002,'玩家当前操作太频繁，请{1}秒后再重新操作'),(110,'err110_voice_lose_efficacy',1100001,'语音已经失效'),(110,'err110_lv_limit',1100002,'您未达到此频道开放等级！'),(110,'err110_unknow_channel',1100003,'未知频道，不能发送信息！'),(110,'err110_in_cd',1100004,'聊天冷却冷却中！'),(110,'err110_content_repeat',1100005,'内容重复不能发送！'),(110,'err110_times_not_enough',1100006,'次数不足'),(112,'err112_dress_not_exist',1120001,'装扮不存在'),(112,'err112_dress_has_enabled',1120002,'装扮已激活'),(112,'err112_dress_not_enabled',1120003,'装扮未激活'),(112,'err112_dress_not_used',1120004,'未使用装扮不需要卸下'),(112,'err112_dress_max_level',1120005,'装扮已经达到最高等级'),(112,'err112_debrisnum_illegal',1120006,'碎片数量必须大于零！'),(112,'err112_dress_arg_empty',1120007,'没有提供升级的碎片'),(120,'err120_cannot_transfer_scene',1200001,'当前场景不能进入！'),(120,'err120_cannot_transfer_not_in_safe',1200002,'非安全区不能进入！'),(120,'err120_cannot_transfer_pre_scene_time',1200003,'切换场景时间不足，请再次切换场景！'),(120,'err120_cannot_transfer_change_scene_sign',1200004,'排队换线中，请稍后再切换场景！'),(120,'err120_cannot_transfer_scene_not_exist',1200005,'目标场景数据不存在！'),(120,'err120_cannot_transfer_lv_not_reach',1200006,'等级不足，不能切换到目标场景！'),(120,'err120_cannot_transfer_in_dungeon',1200007,'副本地图无法传送！'),(120,'err120_same_line',1200008,'已在当前线路'),(120,'err120_to_many_people',1200009,'此线路玩家太多，请选择另外的线路'),(120,'err120_is_on_battle',1200010,'正在寻路安全区，或者脱离战斗再参加'),(120,'err120_cannot_transfer_on_battle',1200011,'处于战斗状态无法传送'),(120,'err120_scene_loading',1200012,'当前场景还没有加载完，请稍后！'),(120,'err120_is_near',1200013,'您已经在附近，不需要飞行！'),(120,'err120_no_fly_shoes',1200014,'成为贵族，海阔天空自由飞！'),(120,'err120_cannot_battle_change_scene_sign',1200015,'正在切换场景，不能进行攻击'),(120,'err120_max_user',1200016,'场景人数已达上限，无法进入！'),(120,'err120_transtype',1200017,'暂时不能使用小飞鞋！'),(120,'err120_already_in_scene',1200018,'已经在当前场景，无须再次进入！'),(120,'err120_cannot_transfer_to_target_scene',1200019,'目标场景不可进入'),(130,'err130_change_pk_change_line',1300001,'换线中，不能切换战斗状态'),(130,'err130_change_pk_cd',1300002,'和平状态切换正在冷却中'),(130,'err130_user_cant_change_pk',1300003,'此场景不能手动切换战斗模式'),(130,'err130_change_pk_lv_lim',1300004,'低于20级不能切换pk状态'),(130,'err130_no_peace',1300005,'此场景不能切换和平模式'),(130,'err130_not_change',1300006,'当前不能切换战斗状态'),(130,'err130_no_peace_ultimate',1300007,'不能切换此模式'),(130,'err130_transfer_lv_limit',1300008,'{1}级后开启变性功能'),(130,'err130_transfer_sex_limit',1300009,'非单身的玩家需离婚或分手后才可转变为其他性别'),(130,'err130_transfer_career_same_limit',1300010,'已经是本职业，不需要进行转职'),(130,'err130_transfer_cd_limit',1300011,'处于冷却期内，无法变性'),(130,'err130_transfer_career_err',1300012,'职业数据错误'),(130,'err130_change_pk_not_cluster_scene',1300013,'非跨服场景不能切换服务器模式'),(131,'err131_reply_error',1310001,'回复参数错误'),(131,'err131_player_die',1310002,'人物死亡，无法回复'),(131,'err131_hp_max',1310003,'气血已满，无需回复'),(131,'err131_time_error',1310004,'回复时间未到'),(131,'err131_scene_limit',1310005,'场景限制'),(131,'err131_sit_down_first',1310006,'请先打坐，方可按打坐方式回复'),(137,'err137_not_sign_state',1370001,'非报名阶段'),(137,'err137_has_sign',1370002,'已报名'),(137,'err137_tool_not_enough',1370003,'道具不足'),(137,'err137_lv_not_enough',1370004,'未达到参赛等级'),(137,'err137_buy_limit',1370005,'已达购买上限'),(137,'err137_not_sign',1370006,'未报名'),(137,'err137_not_prepare_state',1370007,'非准备阶段'),(137,'err137_is_in_prepare',1370008,'已在准备区'),(137,'err137_not_allow_select_same',1370009,'不可重复选同个候选人'),(137,'err137_cfg_error',1370010,'参数错误'),(137,'err137_not_need_to_leave',1370011,'非擂台赛场景,不需退出'),(137,'err137_not_guess_state',1370012,'非竞猜阶段'),(137,'err137_not_guess_zone_role',1370013,'非可选战区候选人'),(137,'err137_not_guess_act_role',1370014,'非可选战场候选人'),(137,'err137_not_select_empty_role',1370015,'轮空玩家不可选'),(137,'err137_not_select_same_plat',1370016,'不可同时选同台候选人'),(137,'err137_skill_cd',1370017,'技能未冷却'),(137,'err137_fight_allow_use',1370018,'技能擂台中可使用'),(137,'err137_error_skill',1370019,'非法技能'),(137,'err137_not_in_prepare',1370020,'不在准备区中'),(137,'err137_be_kill_not_buy',1370021,'您已被淘汰，不可购买'),(137,'err137_power_out',1370022,'战力跌出4096名，失去比赛资格'),(137,'err137_not_enter_lose',1370023,'已被淘汰'),(137,'err137_not_enter_state',1370024,'当前阶段不能进入'),(137,'err137_not_enter_sub_state',1370025,'已过了进入时间，故被淘汰'),(137,'err137_can_not_change_scene_in_drumwar',1370026,'在钻石大战中'),(137,'err137_has_winner',1370027,'已获得冠军'),(140,'err140_1_myself_friend_num_limit',1400001,'本人好友人数达到上限'),(140,'err140_2_other_friend_num_limit',1400002,'对方好友人数达到上限'),(140,'err140_3_role_no_exist',1400003,'玩家不存在'),(140,'err140_4_is_friend',1400004,'对方已经是您的好友'),(140,'err140_5_not_reply_myself_ask',1400005,'不可添加自己为好友'),(140,'err140_6_not_friend',1400006,'对方不是好友'),(140,'err140_7_not_exist_by_type',1400007,'非对应关系'),(140,'err140_9_exist_rela',1400009,'已经添加过了~'),(140,'err140_10_not_enemy',1400010,'不是仇人~'),(140,'err140_12_present_max',1400012,'赠送礼物次数已达上限'),(140,'err140_13_intimacy_max',1400013,'亲密度已达上限'),(140,'err140_14_not_online',1400014,'该玩家不在线'),(140,'err140_19_no_ask_to_be_friend',1400019,'暂时没有好友申请'),(140,'err140_20_no_friend_ask',1400020,'无申请信息'),(140,'err140_21_name_is_wrongful',1400021,'名字不合法'),(140,'err140_22_not_scene',1400022,'在主城或安全区才能进行该操作'),(140,'err140_25_in_blacklist',1400025,'该玩家已被您拉黑，需要移除黑名单才能添加好友'),(140,'err140_26_recommended_too_often',1400026,'推荐太频繁了，休息下再来'),(140,'err140_27_myself_black_list_num_limit',1400027,'黑名单人数已达上限'),(140,'err140_28_in_another_blacklist',1400028,'您在对方的黑名单，无法添加好友'),(140,'err140_29_not_same_server_player',1400029,'不是同服玩家暂时不能查看'),(140,'err140_30_in_blacklist',1400030,'您或对方在黑名单中，不可聊天。'),(140,'err140_is_lover',1400031,'对不起，你们还存在着情侣/伴侣关系'),(145,'err145_1_role_no_exist',1450001,'玩家不存在'),(145,'err145_2_word_is_sensitive',1450002,'存在敏感词'),(150,'err150_fail',1500000,'物品操作失败'),(150,'err150_no_goods',1500001,'物品不存在'),(150,'err150_no_money',1500002,'金额不足'),(150,'err150_no_cell',1500003,'背包空间不足，请先清理背包'),(150,'err150_npc_far',1500004,'离npc太远'),(150,'err150_in_sell',1500005,'正在交易中'),(150,'err150_price_err',1500006,'物品价格错误'),(150,'err150_palyer_err',1500007,'物品所有者错误'),(150,'err150_location_err',1500008,'物品位置错误'),(150,'err150_not_sell',1500009,'物品不可出售'),(150,'err150_num_err',1500010,'物品数量错误'),(150,'err150_cell_max',1500011,'背包空间已达上限'),(150,'err150_type_err',1500012,'物品类型错误'),(150,'err150_require_err',1500013,'条件不符'),(150,'err150_attrition_full',1500014,'无磨损'),(150,'err150_no_goods_type',1500015,'物品类型不存在'),(150,'err150_in_cd',1500016,'冷却时间'),(150,'err150_lv_err',1500017,'物品等级限制'),(150,'err150_player_die',1500018,'人物已死亡'),(150,'err150_not_trhow',1500019,'物品不可销毁'),(150,'err150_no_drop',1500020,'该掉落已被拾取'),(150,'err150_no_drop_per',1500021,'不是您的掉落，请稍后在拾取'),(150,'err150_time_not_start',1500022,'时间还未到'),(150,'err150_time_end',1500023,'时间已经结束'),(150,'err150_gift_unactive',1500024,'礼包未生效'),(150,'err150_no_rule',1500025,'规则不存在'),(150,'err150_rule_unactive',1500026,'规则未生效'),(150,'err150_shop_time_limit',1500027,'限时物品一天只能购买一次'),(150,'err150_goods_num_zero',1500028,'物品已经卖完'),(150,'err150_gift_got',1500029,'礼包已领取'),(150,'err150_num_limit',1500030,'次数已达上限'),(150,'err150_storage_no_cell',1500031,'仓库空间不足'),(150,'err150_scene_wrong',1500032,'本场景无法使用'),(150,'err150_npc_type_err',1500033,'npc类型错误'),(150,'err150_hp_mp_full',1500034,'使用量超出上限，无法使用'),(150,'err150_num_over',1500035,'次数超出每天上限'),(150,'err150_skill_fail',1500036,'技能学习失败'),(150,'err150_fashion_expire',1500037,'装备已经过期，不可穿戴'),(150,'err150_scene_pos',1500038,'使用地图坐标不正确'),(150,'err150_not_event',1500039,'无触发事件'),(150,'err150_nothing',1500040,'物品使用后什么都没有'),(150,'err150_cannot_replace_mid',1500041,'当前增益状态不能替换中级增益状态'),(150,'err150_cannot_replace_big',1500042,'当前增益状态不能替换高级增益状态'),(150,'err150_no_guild',1500043,'没有帮派'),(150,'err150_num_single_limit',1500044,'单个物品次数已达上限'),(150,'err150_num_single_over',1500045,'单个物品兑换数量超过每天上限'),(150,'err150_distance',1500046,'距离掉落包过远'),(150,'err150_vip_coin',1500047,'贵族铜币道具小于等于该等级的贵族不能使用'),(150,'err150_lv_goods',1500048,'无法使用等级道具'),(150,'err150_num_notmatch',1500049,'自选物品数量异常'),(150,'err150_seqlist_notmatch',1500050,'找不到自选礼包奖励内容'),(150,'err150_no_gift_type',1500051,'打开宝箱配置不存在'),(150,'err150_goods_expired',1500052,'物品已过有效期'),(150,'err150_no_career_gift',1500053,'职业不符，无法打开'),(150,'err150_exper_error',1500054,'剩余历练次数不足'),(150,'err150_compose_goods_not_enough',1500055,'材料不足，无法合成'),(150,'err150_goods_id_err',1500056,'物品类型id有误'),(150,'err150_exper_time_more_than_7hour',1500057,'智慧药水最多累积7小时'),(150,'err150_gift_cfg_missing',1500058,'礼包数据不存在'),(150,'err150_gift_status_error',1500059,'礼包状态为无效'),(150,'err150_gift_nobegin',1500060,'未到领取礼包时间'),(150,'err150_gift_overtime',1500061,'已过了领取礼包时间'),(150,'err150_gift_data_error',1500062,'礼包数据错误'),(150,'err150_gift_fetch_error',1500063,'领取礼包失败'),(150,'err150_gift_card_err_len',1500064,'礼包卡长度错误'),(150,'err150_gift_card_not_exist',1500065,'卡号错误'),(150,'err150_gift_card_no_gift_type',1500066,'卡号没有绑定礼包'),(150,'err150_gift_card_platform_error',1500067,'平台不对'),(150,'err150_gift_card_has_trigger',1500068,'卡号已经被领取'),(150,'err150_gift_card_nobegin',1500069,'未到领取卡号时间'),(150,'err150_gift_card_overtime',1500070,'卡号过期'),(150,'err150_gift_card_has_use_same_card',1500071,'已经使用过同类卡号'),(150,'err150_gift_card_gift_not_exist',1500072,'礼包数据不存在'),(150,'err150_lv_gfit_cfg_err',1500073,'等级不足，暂时无法使用'),(150,'err150_good_in_expire',1500074,'物品还未过期'),(150,'err150_pk_value_0',1500075,'红名值值为0，不需要使用洗恶卡'),(150,'err150_not_compose_mat',1500076,'所选物品不属于合成材料'),(150,'err150_no_cell_to_compose',1500077,'背包已满，无法合成'),(150,'err150_no_money_to_compose',1500078,'货币不足，无法合成'),(150,'err150_not_satisfy_compose_lv',1500079,'角色等级不够，无法合成'),(150,'err150_compose_success',1500080,'合成成功'),(150,'err150_compose_fail',1500081,'合成失败'),(150,'err150_no_null_cell_decompose_fail',1500082,'背包空位不足，拆解失败'),(150,'err150_user_use_dsgt',1500083,'称号已经激活，返还{1}金币'),(150,'err150_renew_cf_miss',1500084,'物品续费配置缺失'),(150,'err150_bag_location_fail',1500085,'背包类型配置错误'),(150,'err150_compose_type_lock',1500086,'该合成方式未解锁'),(150,'err150_notin_drop_scene',1500087,'场景不同，不能拾取'),(150,'err150_not_drop_copyid',1500088,'房间不同，不能拾取'),(150,'err150_drop_no_hp',1500089,'您已经死亡，不能拾取'),(150,'err150_no_hurt_drop',1500090,'您没有对首领造成伤害，暂时不能拾取该掉落'),(150,'err150_drop_overlv',1500091,'您的等级超过首领等级100级，无法获得掉落'),(150,'err150_no_boss_tired',1500092,'您的首领疲劳值还未消耗，无须使用该物品'),(150,'err150_no_drop_boss_tired',1500093,'您的首领疲劳已满不能拾取掉落'),(150,'err150_gift_reward_miss',1500094,'礼包奖励内容不存在'),(150,'err150_lv_not_enough',1500095,'等级不足，玩法使用！'),(150,'err150_decompose_wear',1500096,'不能拆解已经穿戴的物品'),(150,'err150_currency_not_enough',1500097,'{1}数量不足'),(150,'err150_day_not_enough',1500098,'再登录{1}天可开启哦!{2}'),(150,'err150_soul_bag_full',1500099,'纹章背包已满'),(150,'err150_onhook_time_enough',1500100,'您的离线挂机时间已满，无需在使用离线时间卡！'),(150,'err150_not_in_bag',1500101,'物品不在背包'),(150,'err150_dstone_lv_max',1500102,'该属性等级已达上限'),(150,'err150_stone_dungeon_limit',1500103,'魂珠副本未达到要求的层数'),(150,'err150_card_ok_send',1500104,'已成功领取该礼包~'),(150,'err150_bag_no_null_cell',1500105,'背包已满，请先清理背包'),(150,'err150_target_bag_is_null',1500106,'当前物品列表为空'),(150,'err150_mount_no_cell',1500107,'坐骑背包空间不足'),(150,'err150_star_shadow_no_cell',1500108,'星痕背包空间不足'),(150,'err150_star_soul_no_cell',1500109,'星灵背包空间不足'),(150,'err150_seal_soul_no_cell',1500110,'魂珠背包空间不足'),(150,'err150_goods_not_timeout',1500111,'存在未过期的物品'),(150,'err150_compose_chose',1500112,'所选道具需要都是限时或者永久'),(150,'err150_compose_times',1500113,'合成次数不能为0'),(150,'err150_not_satisfy_compose_career',1500114,'职业限制，无法合成'),(150,'err150_god_rune_no_cell',1500115,'符文印记背包空间不足'),(151,'err151_not_sell_category',1510001,'该类型物品不允许出售'),(151,'err151_sell_times_limit',1510002,'您已达今日交易次数上限，无法再进行交易'),(151,'err151_specify_sell_times_limit',1510003,'您与该玩家交易太过频繁，无法再进行交易。'),(151,'err151_max_sell_up_num',1510004,'已达到商品上架上限'),(151,'err151_goods_info_err',1510005,'商品信息有误，请重新打开界面'),(151,'err151_goods_not_exist',1510006,'该商品已下架'),(151,'err151_not_seller',1510007,'该商品不属于你'),(151,'err151_no_null_cells',1510008,'背包已满，请先清理背包'),(151,'err151_specify_role_lv_not_enough',1510009,'对方未达到交易等级'),(151,'err151_can_not_buy_self_goods',1510010,'不能购买自己出售的商品'),(151,'err151_not_specify_role',1510011,'您不是改商品的指定购买者'),(151,'err151_bind_cannot_sell',1510012,'绑定物品不能出售'),(151,'err151_not_enough_gold',1510013,'钻石不足'),(151,'err151_goods_sell_down',1510014,'商品已经下架，请重新刷新界面'),(151,'err151_vip_lv_not_enough',1510015,'贵族4及以上才可以发起指定交易哦'),(151,'err151_unit_price_fail',1510016,'单价设置不在范围内'),(151,'err151_num_limit',1510017,'超过上架数量上限'),(152,'err152_expire_err',1520001,'装备已过有效期'),(152,'err152_lv_err',1520002,'未达到装备使用等级'),(152,'err152_location_err',1520003,'所在位置不符合'),(152,'err152_type_err',1520004,'物品类型不符'),(152,'err152_stren_limit',1520014,'强化等级达到上限'),(152,'err152_missing_cfg',1520017,'缺失配置'),(152,'err152_equip_pos_err',1520019,'装备位置参数错误'),(152,'err152_stone_part_err',1520020,'该宝石不能镶嵌在本部位'),(152,'err152_pos_no_stone',1520024,'未镶嵌宝石'),(152,'err152_pos_no_equip',1520025,'请先穿戴装备'),(152,'err152_career_error',1520026,'职业不合适,不能穿戴'),(152,'err152_equip_type_error',1520029,'未知装备类型'),(152,'err152_has_stren_cant_unequip',1520035,'已强化过的装备无法卸下'),(152,'err152_max_stage',1520036,'装备已达最高阶'),(152,'err152_not_upgrade_stage_quality',1520037,'穿戴装备的品质、阶数不足'),(152,'err152_not_upgrade_stage_pos',1520038,'该部位装备不能进阶'),(152,'err152_not_enough_upgrade_stage_cost',1520039,'材料不足，无法进阶'),(152,'err152_not_equip_cannot_upgrade_stage',1520040,'未穿戴装备，不能进阶'),(152,'err152_has_unlock_wash_pos',1520041,'属性槽已经开启，不能重复开启'),(152,'err152_no_equip_cannot_wash',1520042,'穿戴装备后才可洗练'),(152,'err152_wash_pos_locked',1520043,'属性槽未开启，不能进行洗炼'),(152,'err152_can_not_lock_all',1520044,'至少有一条属性未锁定时才可洗练'),(152,'err152_has_wash_cant_unequip',1520045,'已洗炼过的装备无法卸下'),(152,'err152_wash_normal_cost_not_enough',1520046,'洗炼石不足，无法洗炼'),(152,'err152_wash_extra_cost_not_enough',1520047,'钻石不足，无法洗炼'),(152,'err152_role_lv_not_satisfy_wash_lv',1520048,'该部位未解锁'),(152,'err152_attr_num_not_satisfy_division',1520049,'4条属性槽均开启后可升段，升段后洗练属性范围提高！'),(152,'err152_no_equip_can_not_upgrade_division',1520050,'穿戴装备后才可升段'),(152,'err152_rating_not_satisfy_division',1520051,'洗练评分低于升段评分，无法升段'),(152,'err152_max_division',1520052,'已达最高段位'),(152,'err152_stone_pos_lock',1520053,'宝石孔未解锁'),(152,'err152_max_refine_lv',1520054,'已达精炼最高等级'),(152,'err152_has_refine_cant_unequip',1520055,'已进行宝石精炼的装备无法卸下'),(152,'err152_make_suit_error',1520056,'套装打造条件不足'),(152,'err152_casting_spirit_pos_lock',1520057,'该部位未解锁'),(152,'err152_casting_spirit_lv_lim',1520059,'已达到本阶等级上限'),(152,'err152_casting_spirit_equip_stage_not_enough',1520060,'装备阶数不足，无法铸灵'),(152,'err152_casting_spirit_max_lv',1520061,'铸灵达到满级'),(152,'err152_casting_spirit_material_not_enough',1520062,'材料不足，铸灵失败'),(152,'err152_spirit_max_lv',1520063,'已达满级，不能继续培养'),(152,'err152_upgrade_spirit_material_not_enough',1520064,'材料不足，提升护灵等级失败'),(152,'err152_has_awakening_cant_unequip',1520065,'觉醒后的装备不能卸下'),(152,'err152_not_awakening_equip',1520066,'9阶2星橙装以上可觉醒'),(152,'err152_awakening_lv_lim',1520067,'已达当前觉醒上限'),(152,'err152_awakening_cost_not_enough',1520068,'材料不足，无法觉醒'),(152,'err152_sex_error',1520069,'性别不合适，不能穿戴'),(152,'err152_turn_error',1520070,'未达对应转生，不能穿戴'),(152,'err152_equip_skill_awakening_lim',1520071,'已觉醒装备才可附加唤魔技能'),(152,'err152_equip_skill_has_skill',1520072,'该装备已附加唤魔技能，请先拆解技能'),(152,'err152_equip_skill_cfg_err',1520073,'唤魔技能配置有误'),(152,'err152_equip_skill_skill_type_lim',1520074,'当前装备部位无法附加此类型技能'),(152,'err152_equip_skill_no_cost_to_add_skill',1520075,'材料不足，附加技能失败'),(152,'err152_equip_skill_no_skill_to_remove',1520076,'该装备未附加唤魔技能'),(152,'err152_equip_skill_no_cost_to_remove',1520077,'金币不足，拆解技能失败'),(152,'err152_equip_skill_no_cost_upgrade',1520078,'材料不足，提升失败'),(152,'err152_equip_skill_no_skill_to_upgrade',1520079,'该装备未附加唤魔技能'),(152,'err152_equip_skill_skill_lv_lim',1520080,'当前技能等级已达上限'),(152,'err152_wash_lv_error',1520081,'未达到洗练要求等级'),(152,'err152_vip_lv_error',1520082,'vip等级不足'),(152,'err152_not_equip_cannot_upgrade_stone',1520083,'没有装备可升级宝石'),(152,'err152_no_equip_can_refine',1520084,'没有装备可以精炼'),(152,'err152_no_equip_can_wash',1520085,'没有装备可以洗练'),(152,'err152_no_this_equip',1520086,'没有这件装备'),(152,'err152_no_this_goods',1520087,'没有这件物品'),(152,'err152_cost_num_error',1520088,'消耗数量错误'),(152,'err152_gold_not_enough',1520089,'钻石不足'),(152,'err152_goods_not_enough',1520090,'道具不足'),(152,'err152_no_attr_can_ensure',1520091,'可保留的属性列表为空'),(152,'err152_stage_max',1520092,'已是最高阶'),(152,'err152_build_goods_error',1520093,'打造装备材料类型错误'),(152,'err152_build_turn_error',1520094,'未达对应转生数，打造条件不符'),(152,'err152_refine_value_max',1520095,'您当前精炼值已满'),(152,'err152_vip_stone_limit',1520096,'该宝石只能镶嵌在vip孔哦~'),(152,'err152_max_prefix_error',1520097,'重铸次数已达上限'),(152,'err152_max_star',1520098,'装备已达最大星级'),(152,'err152_not_upgrade_star_pos',1520099,'该部位装备不能升星'),(152,'err152_not_equip_cannot_upgrade_star',1520100,'未穿戴装备，不能升星'),(152,'err152_not_upgrade_star_quality',1520101,'装备的品质、阶数不足，不能升星'),(152,'err152_wash_args_error',1520102,'洗炼参数错误'),(153,'err153_goods_not_on_sale',1530000,'商品不在架上'),(153,'err153_goods_sold_out',1530001,'该道具已售空，请耐心等待补货。'),(153,'err153_goods_not_equal',1530002,'数据错误'),(153,'err153_bag_not_enough',1530003,'您拥有的背包空间不足，请清理后再来。'),(153,'err153_give_goods_failure',1530004,'派送物品失败'),(153,'err153_not_enough_goods_to_buy',1530005,'购买数量超过上限'),(153,'err153_money_type_wrong',1530006,'不能用此金钱支付'),(153,'err153_send_error',1530007,'请求错误'),(153,'err153_not_enough_world_lv',1530008,'世界等级未到达购买要求！'),(153,'err153_not_enough_server_time',1530009,'开发天数未达到购买要求！'),(153,'err153_not_enough_lv',1530010,'您的等级未达到购买要求！'),(153,'err153_qb_not_right_money',1530011,'不能用这种货币购买'),(153,'err153_mount_bag_not_enough',1530012,'您的坐骑背包空间不足，请清理后再来。'),(154,'err154_error_pricetype',1540001,'非法竞价类型'),(154,'err154_missing_config',1540002,'缺失物品配置'),(154,'err154_goods_sellout',1540003,'物品已拍出'),(154,'err154_price_change',1540004,'竞价已发生变化'),(154,'err154_error_price',1540005,'价格参数错误'),(154,'err154_goods_closed',1540006,'该物品已结束拍卖~'),(154,'err154_player_top_price',1540007,'你当前已是最高竞价者'),(154,'err154_error_guild_id',1540008,'不是你所在公会物品'),(154,'err154_auction_not_start',1540009,'拍卖未开启，请稍加等待'),(154,'err154_only_pay_by_gold',1540010,'本商品只能使用钻石参与拍卖'),(155,'err155_cannot_takeoff_stren',1550001,'已强化过的圣印无法卸下'),(155,'err155_stren_stage_limit',1550002,'强化等级超过当前装备强化上限'),(155,'err155_stren_no_equip',1550003,'需要穿戴圣印才能强化'),(155,'err150_soul_count_limit',1550004,'当前使用次数已达上限'),(155,'err155_pos_not_open',1550005,'装备孔还未开放'),(157,'err157_1_live_not_enough',1570001,'活跃度不够'),(157,'err157_2_live_aready_get',1570002,'不能重复领取'),(157,'err157_3_bag_not_enough',1570003,'背包不足'),(157,'err157_4_lv_not_enough',1570004,'等级不足，无法打开活动日历'),(157,'err157_5_cfg_err',1570005,'配置错误'),(157,'err157_6_live_not_enough',1570006,'活跃度不够'),(157,'err157_7_max_lv',1570007,'活跃度等级已达最高'),(157,'err157_8_live_lv_limit',1570008,'活跃度等级不够'),(157,'err157_9_open_day_limit',1570009,'开服天数不足'),(157,'err157_act_not_open',1570010,'活动未开启'),(157,'err157_figure_already',1570011,'已幻化当前形象'),(157,'err157_power_live_limit',1570012,'活力已达上限'),(158,'err158_time_error',1580001,'该充值商品暂未开启'),(158,'err158_condition_error',1580002,'您不符合该充值商品使用条件'),(158,'err158_product_error',1580003,'该充值商品缺失基础配置'),(158,'err158_product_ctrl_error',1580004,'该充值商品缺失控制信息配置'),(158,'err158_recharge_return_error',1580005,'该充值商品缺失返利配置'),(158,'err158_product_type_error',1580006,'未知充值商品类型'),(158,'err158_already_buy',1580007,'已购买该充值商品'),(158,'err158_not_open',1580008,'该充值商品暂未开放，敬请期待！'),(158,'err158_not_enough_world_lv',1580009,'世界等级未到达购买要求！'),(158,'err158_not_enough_times',1580010,'购买次数不足'),(159,'err159_daily_type_err',1590001,'每日礼包类型错误!'),(159,'err159_daily_purchased',1590002,'今天礼包已经被购买~'),(159,'err159_daily_cfg_err',1590003,'礼包配置错误~'),(159,'err159_daily_not_purchase',1590004,'礼包未购买,领取失败~'),(159,'err159_daily_is_get',1590005,'礼包已经领取,无法再次领取~'),(159,'err159_1_not_welfare',1590006,'非福利卡'),(159,'err159_2_welfare_timeout',1590007,'福利卡已过期'),(159,'err159_3_not_buy',1590008,'未购买相关产品'),(159,'err159_4_already_get',1590009,'已领取'),(159,'err159_5_bag_not_enough',1590010,'背包已满'),(159,'err159_vip_not_enough',1590012,'贵族等级不足！'),(159,'err159_not_the_time',1590013,'领取时间未到'),(159,'err159_first_recharge_product_not_open',1590014,'首充商品未开放'),(159,'err159_first_recharge_error_index',1590015,'首充奖励参数错误'),(160,'err160_3_figure_inactive',1600003,'坐骑幻形未激活'),(160,'err160_8_mount_scene_limit',1600008,'当前场景不可骑乘坐骑'),(160,'err160_9_config_err',1600009,'配置错误'),(160,'err160_10_exp_max',1600010,'已满级'),(160,'err160_figure_has_sel',1600011,'幻化中，不能重复操作'),(160,'err160_max_goods_use_times',1600012,'已达提升上限'),(160,'err160_max_star',1600013,'已达满星级，无法继续升星'),(160,'err160_not_enough_cost',1600014,'材料不足，无法提升'),(160,'err160_figure_not_active',1600015,'坐骑形象未激活'),(160,'err160_figure_max_stage',1600016,'已达满阶，无法继续提升'),(160,'err160_no_equip_cfg',1600017,'没有装备配置'),(160,'err160_equip_bag_close',1600018,'装备格子未解锁'),(160,'err160_smelt_equipping',1600019,'不能熔炼穿戴着的装备'),(160,'err160_equip_smelt_cfg_miss',1600020,'熔炼配置错误'),(160,'err160_equip_max_lv',1600021,'提升装备品质可以升级更高等级'),(160,'err160_equip_lv_cfg',1600022,'装备等级配置错误'),(160,'err160_is_stren',1600023,'不可卸下已强化的装备'),(160,'err160_make_cfg',1600024,'打造配置错误'),(160,'err160_best_equip_make',1600025,'您的装备已是最高品质'),(160,'err160_bad_make_equip',1600026,'打造配方错误'),(160,'err160_already_activity_figure',1600027,'该幻形已永久激活'),(160,'err160_stage_lim',1600028,'基础坐骑阶数未达要求'),(160,'err160_err_activity_goods',1600029,'错误的激活道具'),(160,'err160_time_lim_figure_cannot_upstage',1600030,'限时幻形不能升阶'),(161,'err161_already_active',1610001,'已经激活！'),(161,'err161_not_enough_cost',1610002,'材料不足'),(161,'err161_max_goods_use_times',1610003,'达到次数上限'),(161,'err161_figure_not_active',1610004,'尚未激活，无法幻化'),(161,'err161_not_equip_wing',1610005,'没有穿戴翅膀'),(161,'err161_cfg_error',1610006,'配置不存在'),(161,'err161_compose_fail',1610007,'合成失败'),(161,'err161_career_not_match',1610008,'职业不匹配'),(161,'err161_compose_not_extra_ratio',1610009,'该合成不能使用幸运物品'),(161,'err161_not_extra_equip',1610010,'所选装备不属于幸运材料'),(161,'err161_lv_not_enough',1610011,'等级不足'),(161,'err161_not_to_cancel',1610012,'当前形象不能取消'),(161,'err161_not_same_huanhua',1610013,'没有幻化该形象'),(161,'err161_not_overlap',1610014,'该幻化不能叠加'),(161,'err161_not_exit_ratio_goods',1610015,'存在不能使用的幸运材料'),(161,'err161_not_use_this_good',1610016,'不能使用该物品'),(161,'err161_is_limit',1610017,'已达上限'),(161,'err161_not_active',1610018,'未激活'),(162,'err162_figure_unactive',1620001,'形象未激活'),(162,'err162_up_ride',1620002,'已佩戴'),(162,'err162_not_up_ride',1620003,'已卸下'),(162,'err162_already_active',1620004,'形象已激活'),(163,'err163_already_active',1630001,'已经激活~'),(163,'err163_cfg_err',1630002,'配置出错~'),(163,'err163_exp_not_enough',1630003,'经验不足'),(163,'err163_max_lv',1630004,'已达最大等级'),(163,'err163_not_active',1630005,'未激活！'),(163,'err163_career_not_match',1630006,'职业不匹配'),(164,'err164_cant_active_repeat',1640001,'不能重复点亮命格'),(164,'err164_consume_not_enough',1640002,'道具不足，觉醒失败'),(164,'err164_pre_not_active',1640003,'上一个命格未点亮'),(168,'err168_already_active',1680001,'已经激活！'),(168,'err168_figure_unactive',1680002,'法宝形象未激活'),(168,'err168_not_enough_cost',1680003,'材料不足'),(168,'err168_max_goods_use_times',1680004,'达到次数上限'),(168,'err168_max_lv',1680005,'已达满级'),(168,'err168_max_star',1680006,'幻化到达满星'),(168,'err168_not_turn',1680007,'未到达转生数'),(168,'err168_figure_not_active',1680008,'尚未激活，无法幻化'),(168,'err168_wrong_goods',1680009,'该道具不符合当前等级'),(172,'err172_ring_not_polish',1720001,'不是打磨的物品'),(172,'err172_marriage_max',1720002,'已达上限'),(172,'err172_marriage_not_pray',1720003,'不是祝福消耗品'),(172,'err172_personals_send_cd',1720004,'请求冷却中'),(172,'err172_couple_self_not_single',1720005,'自己非单身'),(172,'err172_couple_other_not_single',1720006,'对方非单身'),(172,'err172_couple_intimacy_not_enough',1720007,'亲密度不足'),(172,'err172_couple_not_same_sex',1720008,'性别一样'),(172,'err172_couple_not_biaobai_twice',1720009,'不能重复表白'),(172,'err172_fouple_have_not_biaobai',1720010,'对方没有向你表白'),(172,'err172_couple_not_self',1720011,'不能向自己求婚'),(172,'err172_couple_single',1720012,'单身中'),(172,'err172_couple_not_lover',1720013,'对方不是你的伴侣'),(172,'err172_couple_have_marry',1720014,'你们已经结婚'),(172,'err172_couple_not_propose_twice',1720015,'不能重复求婚'),(172,'err172_marriage_life_not_marry',1720016,'未结婚'),(172,'err172_love_num_not_enough',1720017,'恩爱值不足'),(172,'err172_personals_not_player',1720018,'没有这个玩家'),(172,'err172_personals_cant_follow',1720019,'不能关注这个玩家'),(172,'err172_personals_not_following',1720020,'没有在关注这个玩家'),(172,'err172_couple_other_biaobai',1720021,'对方已向你表白'),(172,'err172_couple_other_propose',1720022,'对方已向你求婚'),(172,'err172_wedding_have_order',1720023,'婚礼已预约'),(172,'err172_wedding_over_day',1720024,'预约天数太后'),(172,'err172_wedding_not_time',1720025,'没有这个婚礼时间段'),(172,'err172_wedding_time_have_order',1720026,'该时间已经被预约'),(172,'err172_wedding_start',1720027,'婚礼已经开始'),(172,'err172_wedding_not_order',1720028,'还没预约婚礼'),(172,'err172_wedding_have_invite',1720029,'已经邀请过'),(172,'err172_wedding_guest_num_max',1720030,'宾客数量达到上限'),(172,'err172_wedding_guest_have_answer',1720031,'已经回复过'),(172,'err172_wedding_order_time_pass',1720032,'预订的时间已过'),(172,'err172_wedding_invite_success',1720033,'伴侣成功邀请了宾客'),(172,'err172_wedding_order_success',1720034,'伴侣成功预约了婚礼'),(172,'err172_wedding_buy_max_num_max',1720035,'购买宾客上限超过上限'),(172,'err172_wedding_buy_max_num_success',1720036,'伴侣成功购买宾客上限'),(172,'err172_wedding_not_start',1720037,'婚礼还没有开始'),(172,'err172_wedding_is_guest',1720038,'已经被邀请'),(172,'err172_wedding_already_ask',1720039,'已经索要过请柬'),(172,'err172_wedding_not_ask_invite',1720040,'玩家未索要请柬'),(172,'err172_wedding_not_guest',1720041,'你不是婚礼的宾客'),(172,'err172_wedding_not_scene',1720042,'不在婚礼区域里'),(172,'err172_wedding_not_owner',1720043,'你不是婚礼主人'),(172,'err172_wedding_not_invite_self',1720044,'不能邀请自己'),(172,'err172_wedding_not_have_solve',1720045,'要用{1}才能哄好{2}喔'),(172,'err172_wedding_tm_solve_success',1720046,'成功哄好{1}，获得{2}'),(172,'err172_wedding_mon_not_exist',1720047,'怪物不存在'),(172,'err172_wedding_not_scene_mon',1720048,'目标不在场景里'),(172,'err172_wedding_not_anime',1720049,'不在婚礼仪式期间'),(172,'err172_baby_have_active',1720050,'宝宝已经被激活'),(172,'err172_baby_not_image',1720051,'没有这个幻形'),(172,'err172_baby_not_active',1720052,'宝宝未激活'),(172,'err172_baby_image_have_active',1720053,'幻形已激活'),(172,'err172_baby_image_not_active',1720054,'幻形未激活'),(172,'err172_baby_have_not_resource',1720055,'该形象未获得'),(172,'err172_baby_already_resource',1720056,'已经装备改形象'),(172,'err172_baby_not_resource',1720057,'未装备宝宝形象'),(172,'err172_wedding_can_not_open_order',1720058,'婚礼已预约'),(172,'err172_wedding_can_not_order_same',1720059,'不能预约同一个时间'),(172,'err172_wedding_already_eat',1720060,'已经吃过'),(172,'err172_wedding_ask_invite_agree',1720061,'伴侣操作了索要请柬'),(172,'err172_df_cant_get',1720062,'不能拿本人发的狗粮'),(172,'err172_df_get_success',1720063,'成功领取狗粮，获得{1}金币'),(172,'err_df_have_get',1720064,'已经拿过这份狗粮'),(172,'err172_df_max',1720065,'这份狗粮已被分完'),(172,'err172_personals_is_fans',1720066,'已经是粉丝'),(172,'err172_personals_cant_follow_self',1720067,'不能关注自己'),(172,'err172_marriage_partner_lv_limit',1720068,'对方等级不足'),(172,'err172_wedding_not_invite',1720069,'没有被邀请'),(172,'err172_marriage_ask_lv_limit',1720070,'等级达到100才能参加婚礼喔'),(172,'err172_wedding_fires_success',1720071,'成功点燃{1}，获得{2}'),(172,'err172_wedding_candies_success',1720072,'成功食用{1}，获得{2}'),(172,'err172_wedding_tm_limit',1720073,'本次安抚小捣蛋次数已满'),(172,'err172_wedding_nc_limit',1720074,'本次食用普通喜糖次数已满'),(172,'err172_wedding_sc_limit',1720075,'本次食用豪华喜糖次数已满'),(172,'err172_please_order_wedding',1720076,'请先举行婚礼'),(172,'err172_cant_wedding_twice',1720077,'请等待对方回应'),(172,'err172_use_card_error',1720078,'婚礼卡类型不正确'),(172,'err172_already_in_scene',1720079,'已经在婚礼场景'),(172,'err172_cant_collect',1720080,'观众无法参与活动'),(172,'err172_audience_quit',1720081,'观众进出婚礼区域特殊处理'),(172,'err172_already_answer',1720082,'已经答题'),(172,'err172_wrong_answer',1720083,'错误的选择'),(172,'err172_answer_error',1720084,'你们还不是好友，无法操作'),(172,'err172_in_wedding_activity',1720085,'婚礼活动中无法执行此操作'),(172,'err172_parade_not_order',1720086,'请预约巡游'),(172,'err172_cant_parade_twice',1720087,'不能重复发起巡游'),(172,'err172_parade_card_error',1720088,'巡游卡类型不正确'),(172,'err172_couple_other_parade',1720089,'对方已向你申请巡游'),(172,'err172_now_in_wedding',1720090,'正在参加婚礼活动'),(172,'err172_now_in_parade',1720091,'正在参加巡游活动'),(172,'err172_not_couple',1720092,'还没结婚'),(172,'err172_parade_have_order',1720093,'巡游已经预约'),(172,'err172_parade_start',1720094,'巡游已经开始'),(172,'err172_parade_order_success',1720095,'伴侣成功预约了巡游'),(172,'err172_in_same_scene',1720096,'处于同一场景'),(172,'err172_parade_not_start',1720097,'巡游还未开启'),(172,'err172_cant_start_parade',1720098,'等待伴侣开启巡游'),(172,'err172_parade_wrong_stage',1720099,'巡游阶段不正确'),(172,'err172_not_near_npc',1720100,'不在任务npc附近'),(172,'err172_parade_cant_change_scene',1720101,'巡游活动中无法切换场景'),(172,'err172_not_in_parade_scene',1720102,'不在巡游场景无法跟随'),(172,'err172_second_stage_end',1720103,'巡游第二阶段已结束'),(172,'err172_not_follwed_player',1720104,'不是跟随玩家无法放烟花'),(172,'err172_flower_times_max',1720105,'撒花次数已达上限'),(172,'err172_fires_times_max',1720106,'搞气氛次数已达上限'),(172,'err172_in_parade_activity',1720107,'巡游活动中无法执行此操作'),(172,'err172_wedding_fires_max',1720108,'放烟花次数已达上限'),(172,'err172_wedding_candies_max',1720109,'撒糖次数已达上限'),(172,'err172_forbid_battle',1720110,'巡游中无法进行战斗'),(172,'err172_not_follower',1720111,'没有跟随婚车'),(172,'err172_wrong_msg_format',1720112,'信息存在敏感词汇'),(172,'err172_wrong_msg_type',1720113,'错误的信息发布类型'),(172,'err172_wrong_answer_type',1720114,'错误的回应类型'),(172,'err172_error_open_type',1720115,'错误的打开类型'),(172,'err172_table_collect_max',1720116,'本宴桌采集次数本轮已达上限'),(172,'err172_cant_collect_box',1720117,'无法采集新人专属宝箱'),(172,'err172_lover_not_near_npc',1720118,'伴侣不在巡游npc附近'),(172,'err172_in_wedding',1720119,'参加婚礼中'),(172,'err172_collect_box_max',1720120,'新人宝箱采集数量已达上限'),(172,'err172_need_request',1720121,'请先回应对方请求'),(172,'err172_love_box_not_lover',1720122,'您还未拥有伴侣'),(172,'err172_love_box_not_buy',1720123,'为TA购买爱情宝盒后可领取'),(172,'err172_love_box_already_get',1720124,'奖励已领取'),(172,'err172_love_box_other_not_buy',1720125,'尚未激活爱情宝盒，请TA帮你买吧'),(172,'err172_love_box_timeout',1720126,'爱情宝箱已过期'),(172,'err172_not_your_lover',1720127,'对方已经不是你的伴侣了哦'),(172,'err172_already_send_buy_message',1720128,'不能重复发送购买请求'),(172,'err172_reward_already_get',1720129,'奖励已领取'),(172,'err172_guidance_unfinish',1720130,'引导未完成'),(172,'err172_cant_get_lv_reward',1720131,'未达到相应等级'),(172,'err172_guidance_stage_wrong',1720132,'引导阶段不正确'),(172,'err172_not_open_lv',1720133,'200级开放该功能'),(172,'err172_wedding_candies_over',1720134,'当前喜糖数量过多，请先采集后再继续'),(172,'err172_prarde_not_start',1720135,'巡游还未正式开启，请等待新人开启'),(174,'err174_act_not_open',1740001,'活动未开启'),(174,'err174_no_enough_lv_join',1740002,'等级不足'),(174,'err174_on_noon_quiz',1740003,'答题活动中'),(174,'err174_not_in_act',1740004,'不在活动中'),(174,'err174_not_scene',1740005,'不在答题场景中'),(174,'err174_not_answering',1740006,'不在答题阶段中'),(174,'err174_skill_cd',1740007,'技能cd中'),(174,'err174_cannot_attack_yourself',1740008,'不能攻击自己'),(174,'err174_not_in_same_scene',1740009,'对方和你不在同一个场景'),(174,'err174_in_jumping',1740010,'对方使出了反复横跳，你无法瞄准'),(175,'err175_login_reward_closed',1750001,'七天登录活动已关闭'),(175,'err175_today_already_get',1750002,'今日已经领取'),(175,'err175_not_enough_days',1750003,'登录天数不足'),(176,'err176_not_sell',1760001,'该商品没有在销售'),(176,'err176_out_time',1760002,'超过限时'),(176,'err176_out_num',1760003,'超过数量'),(176,'err176_out_num_all',1760004,'已卖完'),(177,'err177_short_of_energy_value',1770001,'活力值不足'),(177,'err177_short_of_fishing_rod',1770002,'选择的鱼竿数量不足'),(177,'err177_short_of_bait',1770003,'选择的鱼饵数量不足'),(177,'err177_please_select_fishing_gear',1770004,'请选择渔具'),(177,'err177_no_in_fishing_scene',1770005,'不在钓鱼区内'),(177,'err177_data_no_exist',1770006,'配置数据不存在'),(177,'err177_args_type_error',1770007,'参数类型错误'),(177,'err177_fish_do_not_bite',1770008,'鱼儿没有上钩'),(177,'err_177_no_select_tool',1770009,'没有选择渔具'),(177,'err_177_scene_change_failure',1770010,'场景切换失败'),(177,'err177_lv_not_reach_the_open_level',1770011,'等级未达到开放等级'),(177,'err177_fishing_lv_not_reach_the_open_level',1770012,'钓鱼等级未达到开放等级'),(177,'err177_rod_data_no_exist',1770013,'鱼竿配置不存在'),(177,'err177_bait_data_no_exist',1770014,'鱼饵配置不存在'),(177,'err_177_buy_num_error',1770015,'购买数量错误'),(177,'err177_fishing_gear_can_not_storage',1770016,'渔具类道具不能存入仓库'),(177,'err177_fishing_cant_change_scene',1770017,'钓鱼模式中不能切换场景'),(178,'err178_not_activate',1780001,'功能暂未开放'),(178,'err178_miss_lv_con',1780002,'缺失吞食等级配置'),(178,'err178_devour_lv_max',1780003,'吞食等级已达上限'),(178,'err178_not_cost_res',1780004,'存在无法吞食的道具'),(178,'err178_not_correct_goods',1780005,'存在无法吞食的物品'),(179,'err179_baby_not_activate',1790001,'宝宝功能尚未开启'),(179,'err179_baby_max_stage',1790002,'已达升阶上限'),(179,'err179_wrong_goods_type',1790003,'不正确的物品类型'),(179,'err179_mount_activate_forever',1790004,'宝宝坐骑已永久激活'),(179,'err179_baby_mount_timeout',1790005,'宝宝坐骑已过期'),(179,'err179_baby_mount_not_activate',1790006,'该宝宝坐骑尚未激活'),(179,'err179_baby_mount_not_forever',1790007,'宝宝坐骑未永久激活'),(179,'err179_already_figure',1790008,'已幻化'),(179,'err179_fashion_activate_forever',1790009,'宝宝时装已永久激活'),(179,'err179_baby_fashion_not_forever',1790010,'宝宝时装未永久激活'),(179,'err179_baby_fashion_not_activate',1790011,'该宝宝时装尚未激活'),(179,'err179_baby_fashion_timeout',1790012,'宝宝时装已过期'),(179,'err179_wing_activate_forever',1790013,'宝宝翅膀已永久激活'),(179,'err179_baby_wing_not_forever',1790014,'宝宝翅膀未永久激活'),(179,'err179_baby_wing_not_activate',1790015,'宝宝翅膀尚未激活'),(179,'err179_baby_wing_timeout',1790016,'宝宝翅膀已过期'),(180,'err180_unknow_player',1800001,'不存在该玩家'),(180,'err180_same_sex',1800002,'性别相同'),(180,'err180_havent_lover',1800003,'没有伴侣'),(180,'err180_not_lover',1800004,'对方不是你的伴侣'),(180,'err180_havent_marriage',1800005,'还没结婚'),(180,'err180_not_enough_intimacy',1800006,'亲密度不足'),(180,'err180_player_offline',1800007,'对方不在线'),(180,'err180_already_response',1800008,'已经回应过了'),(180,'err180_refuse_interact',1800009,'拒绝交互'),(180,'err180_havent_interact',1800010,'对方没有进行交互请求'),(180,'err180_havent_relation',1800011,'不存在关系'),(180,'err180_not_friends',1800012,'不是好友关系'),(180,'err180_already_interact',1800013,'已经发送请求'),(180,'err180_other_already_interact',1800014,'对方已向你发送请求'),(180,'err180_other_in_interact',1800015,'对方正在交互中'),(180,'err180_other_in_activity',1800016,'对方正在参加活动'),(181,'err181_award_received',1810001,'已领取奖励'),(181,'err181_condition_not_met',1810002,'未达到领取条件'),(181,'err181_args_type_error',1810003,'参数类型错误'),(181,'err181_not_inlay_pos',1810004,'不可镶嵌在该位置'),(181,'err181_pos_lock',1810005,'未解锁'),(181,'err181_pos_has_been_inlay',1810006,'已镶嵌'),(181,'err181_no_seal_soul_resolve',1810007,'请选择分解的魂珠'),(181,'err181_types_of_repetition',1810008,'已拥有该属性魂珠'),(181,'err181_seal_soul_bag_no_cell',1810009,'魂珠背包空间不够'),(182,'err182_condition_not_met',1820000,'未达到领取条件'),(190,'err190_no_mail',1900001,'没有邮件'),(190,'err190_read_mail_content_fail',1900002,'读取邮件失败'),(190,'err190_no_mail_attachment',1900003,'没有邮件附件'),(190,'err190_no_mail_to_delete',1900004,'没有邮件可以删除'),(190,'err190_have_attachment_not_to_delete',1900005,'无法删除带附件的邮件'),(190,'err190_bag_full',1900006,'背包已满,无法领取剩余附件'),(190,'err190_mail_timeout_to_delete',1900007,'邮件已经失效，无法删除'),(190,'err190_mail_timeout_to_extract_attachment',1900008,'邮件已经失效，无法领取'),(190,'err190_mail_title_len',1900009,'邮件标题过长'),(190,'err190_mail_title_sensitive',1900010,'邮件标题含有敏感字'),(190,'err190_mail_content_len',1900011,'邮件内容过长'),(190,'err190_mail_content_sensitive',1900012,'邮件内容含有敏感字'),(190,'err190_send_guild_mail_count_not_enough',1900013,'发送邮件次数不足'),(190,'err190_must_on_guild_to_send_guild_mail',1900014,'必须在公会才能发公会邮件'),(190,'err190_not_permisssion_to_send_guild_mail',1900015,'没有权限发公会邮件'),(190,'err190_on_feedback_cd',1900016,'处于反馈的冷却时间内'),(190,'err190_feedback_not_valid',1900017,'反馈内容过长或者存在敏感字'),(190,'err190_have_receive_attachment',1900018,'附件已领取'),(210,'err210_skill_max_lv',2100001,'该技能已经达到最大等级'),(210,'err210_skill_error',2100002,'技能配置错误'),(210,'err210_lv_not_enough',2100003,'人物等级不足，无法升级技能'),(210,'err210_coin_not_enough',2100004,'铜币不足'),(210,'err210_no_pre_skill',2100005,'前置技能未学习'),(210,'err210_no_pre_skill_lv',2100006,'前置技能等级不足，无法学习'),(210,'err210_point_not_enough',2100007,'技能点不足，无法升级技能'),(210,'err210_no_pre_skill_point',2100008,'技能投入点不足，无法学习或升级技能'),(210,'err210_no_learn_talent_skill',2100009,'未学习天赋技能，不能重置'),(210,'err210_not_mycarrer_talent_skill',2100010,'不能学习非本职业天赋技能'),(210,'err210_not_rune_upgrade',2100011,'不是铭文技能，无法升级'),(210,'err_not_talent_learn',2100012,'不是天赋技能，无法学习'),(215,'err215_not_in_team',2150001,'不在队伍中'),(215,'err215_not_dun_multi',2150002,'不是跨服组队'),(215,'err215_not_all_help_type',2150003,'所有成员都为助战'),(215,'err215_quick_handle',2150004,'操作太快'),(215,'err215_not_enough_lv_to_enter_dungeon',2150005,'有队员等级不足，无法进入'),(215,'err215_dungeon_count_daily',2150006,'有队员已无次数，无法进入'),(215,'err215_dungeon_count_daily_help',2150007,'有队员已无助战次数,无法进入'),(215,'err215_have_team',2150008,'已经有队伍'),(215,'err215_no_team',2150009,'不存在该队伍'),(215,'err215_is_on_dungeon',2150010,'队伍正在副本中'),(215,'err215_less_power',2150011,'战力不匹配'),(215,'err215_less_lv',2150012,'等级不匹配'),(215,'err215_is_change_now',2150013,'队伍正在切换状态中'),(215,'err215_on_multi_team',2150014,'正在跨服组队中'),(215,'err215_team_max_member',2150015,'已满员'),(215,'err215_not_all_ready',2150016,'有队员无准备,无法进入'),(215,'err215_not_leader',2150017,'不是队长'),(215,'err215_member_not_condition',2150018,'有队员条件不足，无法切换'),(215,'err215_not_change_self',2150019,'不能委任给自己'),(215,'err215_member_not_exit',2150020,'队员不存在'),(215,'err215_not_prompt_self',2150021,'不能催促自己'),(215,'err215_target_limit_num',2150022,'超过目标最大人数'),(215,'err215_not_to_dummy',2150023,'不能委任给假人'),(215,'err215_is_dummy_team',2150024,'不能加入系统假人队伍'),(215,'err215_not_daily_times',2150025,'每日次数已用完'),(215,'err215_not_help_times',2150026,'助战次数已用完'),(215,'err215_is_max_num',2150027,'已超过该副本的进入人数'),(215,'err215_not_connect_center',2150028,'连接不上跨服中心'),(215,'err215_time_out_request',2150029,'请求跨服中心超时'),(222,'err222_goods_not_enough',2220001,'物品不够'),(222,'err222_combat_not_enough',2220002,'战力不够'),(222,'err222_title_not_equel',2220003,'职称与服务器不对应'),(222,'err222_title_config_error',2220004,'配置出错'),(222,'err222_deduction_goods_error',2220005,'扣除物品失败'),(222,'err222_6_not_enough_server_day',2220006,'开服天数不够'),(222,'err222_title_lv_max',2220007,'头衔等级已达最高'),(223,'err223_num_not_enough',2230001,'砸蛋次数不足'),(223,'err223_lv_not_enough',2230002,'等级不足'),(223,'err223_vip_not_enough',2230003,'贵族等级不足'),(223,'err223_shop_not_provide',2230004,'商城没有出售该商品'),(223,'err223_reset_time',2230005,'当前为重置时间'),(223,'err223_dissatisfy_send_gift_condition',2230006,'未达到赠送条件'),(223,'err223_receiver_lv_not_enough',2230007,'未达到赠送条件'),(223,'err223_player_not_online',2230008,'对方玩家不在线'),(223,'err223_player_charm_is_zero',2230009,'对方魅力值为0，太可怜了，不要砸蛋了'),(223,'err223_egg_time_lim',2230010,'砸蛋次数不足'),(225,'err225_goal_reward_limit',2250001,'未达到奖励领取要求'),(240,'err240_in_team',2400001,'您已经有队伍'),(240,'err240_changing_scene',2400002,'您正在切换场景'),(240,'err240_no_team',2400003,'该玩家没有队伍'),(240,'err240_kick_himself',2400004,'您不能踢除您自己'),(240,'err240_max_member',2400005,'队伍人数已满'),(240,'err240_not_leader',2400006,'您不是队长'),(240,'err240_not_kick_leader',2400007,'不能踢队长'),(240,'err240_leader_reject',2400008,'对方拒绝您的加入'),(240,'err240_other_offline',2400009,'对方不在线'),(240,'err240_other_in_team',2400010,'对方已经有队伍'),(240,'err240_team_disappear',2400011,'该队伍已解散'),(240,'err240_offline',2400012,'对方已经下线'),(240,'err240_arbitrate_timeout',2400013,'入场投票超时'),(240,'err240_arbitrate_refuse',2400014,'{1}拒绝进入'),(240,'err240_not_current_aribirate_req',2400015,'投票已经过期'),(240,'err240_not_on_arbitrate_req_to_vote',2400017,'没有投票'),(240,'err240_not_leader_to_arbitrate_req',2400018,'只有队长可以发起入场投票'),(240,'err240_not_arbitrate_req_in_dungeon',2400019,'在副本中无法发起入场投票'),(240,'err240_not_again_arbitrate_req',2400020,'不能重复发起入场投票'),(240,'err240_not_team_dungeon',2400021,'不是队伍副本'),(240,'err240_join_team',2400022,'您加入了新的队伍'),(240,'err240_new_member',2400023,'{1}加入队伍'),(240,'err240_self_out_team',2400024,'您离开了队伍'),(240,'err240_out_team',2400025,'{1}离开了队伍'),(240,'err240_self_shot_of_team',2400026,'您被请出了队伍'),(240,'err240_shot_of_team',2400027,'{1}被请出了队伍'),(240,'err240_no_member_follow',2400028,'当前没有队员跟战'),(240,'err240_cancel_follow_success',2400029,'取消队员跟战成功'),(240,'err240_change_state_to_interrput_arbitrate',2400030,'队伍状态改变,投票中断'),(240,'err240_on_dungeon_not_to_do',2400031,'队伍处于副本中无法进行操作'),(240,'err240_not_on_team',2400032,'不在队伍中，无法操作'),(240,'err240_this_team_on_dungeon',2400033,'本队伍处于副本中，无法加入'),(240,'err240_34_no_invite_role',2400034,'无邀请对象'),(240,'err240_agree_to_enter_safety_scene',2400035,'{1}同意,正玩命赶回安全区.'),(240,'err240_not_enough_lv_to_create_team',2400036,'等级不足，无法创建队伍'),(240,'err240_not_enough_lv_to_join_team',2400037,'等级不足，无法加入队伍'),(240,'err240_not_enough_lv_to_enter_target',2400038,'没有达到进入该目标的等级'),(240,'err240_not_enough_lv_to_enter_target_with_name',2400039,'{1}没有达到进入该目标的等级'),(240,'err240_not_enough_lv_to_create_target',2400040,'您没有达到目标的最低等级，无法创建'),(240,'err240_not_on_safe_scene_to_outdoor_by_other',2400047,'{1}所在场景无法进入'),(240,'err240_choose_lv_error',2400048,'等级范围不合法'),(240,'err240_auto_pair_limit',2400049,'该目标不可匹配'),(240,'err240_change_when_matching',2400050,'正在自动匹配中，请先取消自动匹配'),(240,'err240_all_for_help_other',2400051,'全员均助战，无法进入副本'),(240,'err240_teammates_offline',2400052,'{1}不在线'),(240,'err240_cost_error',2400053,'{1}物品不足'),(240,'err240_help_type_setup_limit',2400054,'该副本类型不能设置助战'),(240,'err240_too_many_members',2400055,'队伍人数超过新目标限定人数'),(240,'err240_team_create_unfinished',2400056,'正在创建队伍中，请勿进行其它操作'),(240,'err240_cls_type_error',2400057,'请先把队伍目标改成{1}'),(240,'err240_in_arbitrate',2400058,'当前正在队伍投票中，无法操作'),(240,'err240_me_to_other',2400059,'{1}{2}'),(240,'err240_local_team_with_other_serv',2400061,'队伍里有跨服成员无法切换成本服队伍'),(240,'err240_this_team_matching',2400062,'该队伍正在匹配诛邪战场，无法加入'),(240,'err240_arbitrate_vote_repeat',2400063,'您已经投过票了'),(240,'err240_invite_diff_target_error',2400064,'队员无法邀请伴侣，请先退队'),(240,'err240_no_teams_for_match',2400065,'没有可匹配的队伍'),(240,'err240_choose_target_first',2400066,'请先选择组队目标'),(240,'err240_team_target_not_exist',2400067,'请选择正确队伍目标'),(240,'err240_cannot_choose_lv',2400068,'当前目标不可设置等级限制'),(240,'err240_cannot_choose_power',2400069,'当前目标不可设置战力限制'),(240,'err240_not_enough_power_to_enter_target_with_name',2400070,'{1}没有达到进入该目标的战力'),(240,'err240_couple_intimacy_not_enough',2400071,'亲密度不足{1}，无法进入该副本'),(240,'err240_cannot_quit_in_dun',2400072,'处于副本中，无法退出队伍'),(280,'err280_over_max_buy_num',2800001,'超出可购买次数'),(280,'err280_inspire_max',2800002,'已达最大鼓舞次数'),(280,'err280_jjc_num',2800003,'挑战次数错误'),(280,'err280_none_reward',2800004,'没有奖励'),(280,'err280_already_receive_reward',2800005,'已领取奖励'),(280,'err280_rival_rank_change',2800006,'对手排名已改变'),(280,'err280_self_rank_change',2800007,'自己排名已改变'),(280,'err280_jjc_num_not_enough',2800008,'挑战次数不足'),(280,'err280_lv_not_enough',2800009,'等级不足'),(280,'err280_on_battle_state',2800010,'该玩家正在战斗中，请稍后'),(280,'err280_page_not_vaild',2800011,'只能查看前100名玩家信息'),(280,'err280_history_rank_not_enough',2800012,'未达到要求的历史最高排名'),(280,'err280_role_on_battle_state',2800013,'您正在被挑战中，请稍后'),(281,'err281_award_is_got',2810001,'奖励已经领取'),(281,'err281_daily_enter_count_error',2810002,'参与次数不足'),(281,'err281_buy_count_limit',2810003,'您的可购买次数不足'),(281,'err281_match_repeat',2810004,'您已经在匹配中'),(281,'err281_on_matching_state',2810005,'当前正在巅峰竞技匹配中'),(281,'err281_not_on_match_state',2810006,'当前不在匹配状态中'),(281,'err281_on_battle_state',2810007,'当前正在参与巅峰竞技中'),(281,'err281_grade_limit',2810008,'您的段位不足'),(281,'err281_no_honor_reward',2810009,'没有可领取的荣誉值'),(281,'err281_enemy_is_late',2810010,'由于您的对手不能及时到场，您获得胜利'),(300,'err300_task_trigger',3000001,'此任务已接取'),(300,'err300_task_config_null',3000002,'任务配置错误（无此任务）'),(300,'err300_lv_not_enough',3000003,'等级不足，无法接取任务'),(300,'err300_not_guild',3000004,'请加入帮派后再接取此任务'),(300,'err300_realm_diff',3000005,'阵营不符，无法接取'),(300,'err300_career_diff',3000006,'职业不符，无法接取'),(300,'err300_prev_not_fin',3000007,'前置任务未完成'),(300,'err300_fin',3000008,'任务已完成'),(300,'err300_condition_err',3000009,'条件不满足，无法接取（暂定提示）'),(300,'err300_not_enough_cell',3000010,'背包空间不足，请清理后再完成'),(300,'err300_turn_diff',3000011,'转生次数不符，无法领取'),(300,'err300_daily_task_finished',3000012,'今日日常任务已全部完成'),(300,'err300_guild_task_finished',3000013,'公会任务已全部完成'),(300,'err300_no_task_trigger',3000014,'此任务未领取'),(300,'err300_task_no_finish',3000015,'任务没有完成'),(300,'err300_lv_no_task',3000016,'您的等级段没有相应的任务'),(300,'err300_not_double_reward',3000017,'该任务没有双倍奖励'),(331,'err331_act_closed',3310001,'活动未开启'),(331,'err331_no_act_reward_cfg',3310002,'没有活动奖励配置'),(331,'err331_act_can_not_get',3310003,'条件不足,不能领取'),(331,'err331_already_get_reward',3310004,'奖励已领取'),(331,'err331_fs_already_evaluate',3310005,'已经评价过'),(331,'err331_act_time_out',3310006,'奖励超时'),(331,'err331_smashed_egg_refresh_fail',3310007,'刷新失败，您今天的砸蛋次数已用完'),(331,'err331_smashed_egg_times_lim',3310008,'本日钻石砸蛋次数已达到上限'),(331,'err331_limit_buy_daily_num_max',3310009,'本日数量已卖完'),(331,'err331_egg_has_smashed',3310010,'这个金蛋已经被砸过了'),(331,'err331_cloud_buy_end',3310011,'购买时间已结束，下次请早'),(331,'err331_cloud_buy_order_unfinished',3310012,'上一订单尚未完成'),(331,'err331_cloud_buy_personal_limit',3310013,'当前个人限购次数已达上限'),(331,'err331_cloud_buy_not_enough',3310014,'剩余份数不足，购买失败'),(331,'err331_act_boss_scene_tips',3310015,'无法获悉首领的入侵地点，请小心搜索'),(331,'err331_act_boss_scene_people_lim',3310016,'该场景已满人，建议到别处剿灭首领'),(331,'err331_act_boss_scene_no_boss',3310017,'该场景内的首领已全部被击退，建议到别处继续剿灭'),(331,'err331_act_mission_complete',3310018,'本轮活动已完成'),(331,'err331_count_limit',3310019,'奖励已被领完'),(331,'err331_only_president_reward',3310020,'只有会长才能领取该奖励'),(331,'err331_ticket_limit',3310021,'抽奖券不足'),(331,'err331_limit_buy_daily_player_max',3310022,'该商品本日个人次数已买完'),(331,'err331_not_in_buy_day',3310023,'本次活动购买时间已截止~'),(331,'err331_login_return_reward_has_buy',3310024,'已购买该豪礼~'),(331,'err331_act_boss_scene_no_collect',3310025,'采集怪采完用，该场景内的采集物已全部被采完，建议到别处继续采集'),(331,'err331_flop_times_lim',3310026,'奖池已领完，请刷新奖池'),(331,'err331_receive_time_limit',3310027,'今日兑换次数已用尽'),(331,'err331_te_cant_choose_big',3310028,'无法选择大奖'),(331,'err331_te_big_id_wrong',3310029,'没有该类型大奖'),(331,'err331_te_not_choose_again',3310030,'当前无法再次选择大奖'),(331,'err331_te_not_choose_big',3310031,'请先选择大奖'),(331,'err331_wrong_reward_num',3310032,'奖励选择数量不正确'),(331,'err331_not_supplication_time',3310033,'祈愿时间只限:周一12:00-24:00'),(331,'err331_invest_repeat',3310034,'已投资该档位'),(331,'err331_turntable_no_times',3310035,'没有转盘次数啦'),(331,'err331_score_not_enough',3310036,'积分不足，无法兑换奖励'),(331,'err331_kf_cloud_buy_personal_buy_num_lim',3310037,'个人购买次数已达上限'),(331,'err331_kf_cloud_buy_total_buy_num_lim',3310038,'商品总购买次数已达上限'),(331,'err331_kf_cloud_buy_product_id_err',3310039,'商品id错误'),(331,'err331_pls_wait_for_next_act',3310040,'请等待下次活动开启'),(331,'err331_kf_cloud_buy_drawing',3310041,'已开奖'),(331,'err331_can_not_pick_up',3310042,'不可领取'),(331,'err331_lucky_flop_cant_select',3310043,'奖池已锁定'),(331,'err331_lucky_flop_reward_repeat',3310044,'选择奖励重复'),(331,'err331_lucky_flop_no_reward',3310045,'奖励不存在'),(331,'err331_lucky_flop_select_error',3310046,'选择奖励失败'),(331,'err331_lucky_flop_no_select',3310047,'奖励未选取'),(331,'err331_lucky_flop_need_reset',3310048,'奖励已抽完，请重置奖池'),(331,'err331_lucky_flop_cant_reset',3310049,'还有未领取的累计奖励哦'),(338,'err338_act_not_open',3380001,'活动还未开启'),(338,'err338_has_got',3380002,'已领取'),(338,'err338_lack_of_score',3380003,'积分不足'),(338,'err338_not_this_choice',3380004,'没有该抽奖次数'),(338,'err338_point_later',3380005,'当前重置时间，请稍后点击'),(339,'err339_split_max_num_err',3390000,'红包个数不能超过金额/公会人数上限'),(339,'err339_split_min_num_err',3390001,'红包个数不能小于最小数量限制'),(339,'err339_not_exist',3390002,'红包不存在'),(339,'err339_has_expired',3390003,'红包已过期'),(339,'err339_not_send',3390004,'红包为未发送状态，不能领取'),(339,'err339_daily_times_no_enough',3390005,'今天该红包的发送次数已用完'),(339,'err339_not_join_guild',3390006,'没有加入公会，不能发红包'),(339,'err339_not_owner',3390007,'该红包不属于你，不能发送'),(339,'err339_vip_lv_not_enough',3390008,'vip等级不足'),(339,'err339_cannot_send_again',3390009,'红包已被发出，不能重复发送'),(339,'err339_is_limit',3390010,'领取金额达上限'),(339,'err339_no_in_scene',3390011,'击杀当时不在场'),(339,'err339_length_not_match',3390012,'祝福语长度不匹配'),(339,'err339_has_over',3390013,'手慢了'),(400,'err400_guild_name_len',4000001,'公会名字长度不匹配'),(400,'err400_guild_name_sensitive',4000002,'公会名字含有敏感字'),(400,'err400_tenet_len',4000003,'公会公告长度不匹配'),(400,'err400_tenet_sensitive',4000004,'公会宣言含有敏感字'),(400,'err400_on_guild_not_to_create',4000005,'您已经有公会了~'),(400,'err400_create_guild_cfg',4000006,'创建公会出错'),(400,'err400_not_station_scene_to_leave',4000007,'无法退出公会驻地'),(400,'err400_announce_sensitive',4000008,'公告有敏感字'),(400,'err400_announce_len',4000009,'公告过长'),(400,'err400_not_on_guild_to_modify_announce',4000010,'没有公会无法修改公告'),(400,'err400_auto_approve_power_error',4000011,'输入自动加入战力错误'),(400,'err400_auto_approve_lv_error',4000012,'输入自动加入等级错误'),(400,'err400_approve_type_error',4000013,'设置审批类型出错'),(400,'err400_this_scene_not_to_enter_station',4000014,'本场景无法进入公会驻地'),(400,'err400_not_on_guild_to_station',4000015,'无公会无法进入公会驻地'),(400,'err400_on_guild_not_to_apply',4000016,'处于公会中无法申请加入公会'),(400,'err400_not_permission_to_clean_apply',4000017,'您没有权限~'),(400,'err400_not_on_guild_to_clean_apply',4000018,'不在公会无法清理公会申请'),(400,'err400_can_not_modify_other_permission',4000019,'不能修改对方的权限'),(400,'err400_not_on_guild_to_modify_permission',4000020,'不在公会无法修改权限'),(400,'err400_not_right_is_allow_on_modify_permission',4000021,'发送的权限修改参数出错'),(400,'err400_not_modifiable_permission',4000022,'该权限不能被修改'),(400,'err400_not_modified_permission_pos',4000023,'本职位不能被修改权限'),(400,'err400_not_guild_apply',4000024,'没有向该公会申请'),(400,'err400_not_permission_to_rename_position',4000025,'没有权限设置称谓'),(400,'err400_not_on_guild_to_rename_position',4000026,'不在公会无法设置称谓'),(400,'err400_not_modified_name_pos',4000027,'本职位名字不能被修改'),(400,'err400_position_name_sensitive',4000028,'输入称谓含有敏感字'),(400,'err400_position_name_len',4000029,'输入称谓过长'),(400,'err400_this_position_can_not_kick_member',4000030,'你的权限不足'),(400,'err400_not_permission_to_kick',4000031,'没有权限踢除玩家'),(400,'err400_not_same_guild_to_kick',4000032,'只能踢出本公会的玩家'),(400,'err400_not_on_guild_to_kicked',4000033,'对方不在公会无法被踢出'),(400,'err400_not_on_guild_to_kick',4000034,'不在公会无法踢除玩家'),(400,'err400_this_position_can_not_resign',4000035,'本职位无法辞退'),(400,'err400_not_on_guild_to_resign_position',4000036,'不在公会不能辞退'),(400,'err400_not_permission_to_modify_announce',4000037,'没有权限修改公告'),(400,'err400_not_on_guild_to_modify_tenet',4000038,'不在公会无法修改宣言'),(400,'err400_not_permission_to_modify_tenet',4000039,'没有权限修改宣言'),(400,'err400_not_permission_to_modify_approve_setting',4000040,'没有权限修改审批设置'),(400,'err400_not_on_guild_to_modify_approve_setting',4000041,'不在公会无法审批设置'),(400,'err400_chief_not_to_quit',4000042,'会长不能退出公会'),(400,'err400_not_on_guild_to_quit',4000043,'不在公会无法退出公会'),(400,'err400_guild_name_same_not_to_create',4000044,'公会名字相同无法创建'),(400,'err400_this_position_full',4000045,'本职位已经满人'),(400,'err400_chief_not_exist',4000046,'会长不存在'),(400,'err400_not_allow_appoint',4000048,'不允许任命'),(400,'err400_must_have_chief',4000049,'必须要有会长哦'),(400,'err400_same_target_position',4000051,'任命新职位相同'),(400,'err400_not_same_guild_to_appoint',4000052,'只能任命同公会'),(400,'err400_guild_not_exist',4000053,'公会不存在'),(400,'err400_not_on_guild_to_appointed',4000054,'对方不在公会不能被任命'),(400,'err400_not_on_guild_to_appoint',4000056,'不在公会无法任命'),(400,'err400_not_permission_to_approve',4000057,'没有权限审批'),(400,'err400_not_apply',4000058,'没有该公会申请'),(400,'err400_approver_not_on_guild',4000059,'申请人不在公会'),(400,'err400_can_not_join',4000061,'不能加入公会'),(400,'err400_guild_apply_len_limit',4000062,'公会申请列表已满'),(400,'err400_member_enough',4000063,'公会人数已满'),(400,'err400_apply_realm_not_same',4000064,'申请的公会阵营不同'),(400,'err400_this_guild_not_exist_to_apply',4000065,'无法申请不存在的公会'),(400,'err400_is_apply_this_guild',4000066,'已经申请过本公会'),(400,'err400_not_config',4000083,'缺失配置'),(400,'err400_not_on_guild_to_modify_approve',4000094,'不在公会无法处理请求'),(400,'err400_not_allow_appoint_again',4000095,'不能重复任命'),(400,'err400_appoint_position_to_leader_only',4000096,'只允许任命一个领袖'),(400,'err400_not_allow_appoint_to_chief_again',4000097,'不能重复任命哦~'),(400,'err400_appoint_position_to_chief_only',4000098,'只允许任命一个会长'),(400,'err400_other_have_guild_not_to_join',4000101,'对方已有公会，无法加入'),(400,'err400_invitee_having_on_guild',4000106,'被邀请者已经在公会'),(400,'err400_not_enough_lv_to_apply_join_guild',4000107,'等级不足，无法加入公会'),(400,'err400_not_enough_lv_to_create_guild',4000108,'等级不足，无法创建公会'),(400,'err400_not_find_guild',4000109,'未找到公会'),(400,'err400_refuse_apply',4000110,'对方拒绝了你的申请'),(400,'err400_guild_name_null',4000111,'公会名不能为空'),(400,'err400_no_permission',4000112,'您没有权限'),(400,'err400_guild_full_lv',4000113,'公会已满级'),(400,'err400_not_satisfy_upgrade_guild_condition',4000114,'不满足升级公会条件'),(400,'err400_has_receive_salary',4000115,'已经领取过本日工资，不能重复领取'),(400,'err400_not_join_guild',4000116,'没有加入公会'),(400,'err400_not_peimission_research',4000117,'您没有权限研究公会技能'),(400,'err400_gskill_locked',4000118,'公会技能未解锁'),(400,'err400_gfunds_not_enough',4000119,'公会资金不足'),(400,'err400_guild_lv_not_satisfy_research',4000120,'公会等级不满足技能研究要求'),(400,'err400_max_research_lv',4000121,'技能研究已满级'),(400,'err400_research_lv_limit',4000122,'已达公会研究上限，无法学习'),(400,'err400_role_lv_not_satisfy_learn',4000123,'玩家等级不满足技能学习要求'),(400,'err400_gdonate_not_satisfy_learn',4000124,'公会贡献值不足，无法学习'),(400,'err400_approve_success',4000125,'批准成功'),(400,'err400_apply_refuse',4000126,'拒绝成功'),(400,'err400_dominator_guild_can_not_disband',4000127,'王者公会不能解散'),(400,'err400_no_guild',4000128,'玩家未加入公会'),(400,'err400_guild_name_same',4000129,'和当前公会名相同，请重新输入'),(400,'err400_guild_name_repeat',4000130,'和其他公会名重复了哦，请重新输入'),(400,'err400_leave_again_apply',4000131,'距离上次退出公会不足1小时'),(400,'err400_position_not_allow',4000132,'所在职位不可领取'),(400,'err400_building_not_active',4000133,'建筑还未激活'),(400,'err400_has_limit',4000134,'已达上限'),(400,'err400_num_not_enough',4000135,'数量不足'),(400,'err400_building_has_limit',4000136,'建筑已达最高级'),(400,'err400_not_allow_upgrade_building',4000137,'没有权限升级建筑'),(400,'err400_not_allow_kickout_when_bonfire',4000138,'公会活动期间，无法进行该项操作'),(400,'err400_not_allow_when_war_god',4000139,'荣耀战神活动期间，无法进行该项操作'),(400,'err400_not_allow_when_guard',4000140,'公会活动期间，无法进行该项操作'),(400,'err400_time_not_enough',4000141,'创建公会不足24小时'),(400,'err400_member_num_enough',4000142,'人数大于最低人数限制'),(400,'err400_please_select',4000143,'请先选择'),(400,'err400_building_lv_not_enough',4000144,'建筑等级不足'),(400,'err400_point_quickly',4000145,'手速太快'),(400,'err400_liveness_not_enough',4000146,'个人活跃度不足100，无法领取'),(400,'err400_not_allow_when_guild_war',4000147,'公会争霸期间不允许改名'),(400,'err400_not_than_guild_lv',4000148,'不能超过公会大厅等级'),(400,'err400_modify_times_limit',4000149,'公告修改次数达每日上限'),(400,'err400_condition_not_enough',4000150,'条件不足'),(401,'err401_not_in_depot',4010000,'仓库已满，无法继续捐献'),(401,'err401_goods_not_in_depot',4010001,'该道具不在公会仓库里面'),(401,'err401_goods_can_not_add_to_depot',4010002,'该道具不能捐献'),(401,'err401_depot_score_not_enough',4010003,'仓库积分不足，无法兑换'),(401,'err401_bag_cell_not_enough',4010004,'背包空间不足，无法兑换'),(401,'err401_exchange_num_err',4010005,'兑换数量错误'),(401,'err401_no_permission_to_destory',4010006,'您没有权限销毁仓库的物品'),(401,'err401_has_limit',4010007,'已超过上限'),(401,'err401_num_error',4010008,'数量异常'),(401,'err401_handle_quickly',4010009,'操作太快'),(401,'err401_please_select',4010010,'请选择装备'),(402,'err402_no_in_act_scene',4020000,'不在活动场景'),(402,'err402_no_join_guild',4020001,'您未加入公会，不能进入活动场景'),(402,'err402_no_enough_lv_join',4020002,'等级不足，无法参与活动'),(402,'err402_act_close',4020003,'活动未开启'),(402,'err402_not_in_act_cfg_open_time',4021009,'不在活动时间，不能开启活动'),(402,'err402_no_challenge_times',4021013,'挑战次数不足'),(402,'err402_guild_guard_end',4021014,'您所在公会的守卫活动已结束'),(402,'err402_not_battle_stage',4021015,'战斗尚未开启'),(402,'err402_gwar_no_qualification',4021016,'所属公会没有参与资格'),(402,'err402_can_not_change_scene_in_gwar',4021017,'玩家正处于公会争霸活动，不能参加其他活动'),(402,'err402_gwar_battle_end',4021018,'该赛区战斗已结束'),(402,'err402_join_in_guild_not_enough_time',4021019,'加入公会超过1小时的成员才可参与'),(402,'err402_can_not_join_action_this_scene',4021020,'当前场景无法进入活动'),(402,'err402_not_dominator',4021021,'您的公会不是冠军公会'),(402,'err402_join_in_guild_not_enough_time_can_not_receive',4021022,'加入公会时间不足24小时，无法领取'),(402,'err402_has_receive_salary_paul',4021023,'今天已领取过俸禄'),(402,'err402_no_null_cell_receive_salary_paul',4021024,'背包已满，请整理后再来领取'),(402,'err402_not_in_guild',4021025,'该玩家和您不在同一个公会'),(402,'err402_unacommpolished_streak_times',4021026,'未达成连胜条件'),(402,'err402_reward_has_allot',4021027,'奖励已经分配过了'),(402,'err402_no_permission_allot',4021028,'职位权限不够，无法分配'),(402,'err402_unacommpolished',4021029,'未达成奖励条件'),(402,'err402_cant_quit_guild_when_gwar_open',4021030,'公会争霸期间不能退出公会/踢除公会成员'),(402,'err402_cant_appoint_chief_when_gwar_open',4021031,'公会争霸开启期间不能任命会长'),(402,'err402_cant_disband_when_gwar_open',4021032,'公会争霸开启期间不能解散公会'),(402,'err402_gwar_role_num_lim',4021033,'战场人数已满'),(402,'err402_guild_not_open',4021035,'本公会未开启该活动'),(402,'err402_not_summon_stage',4021036,'当前不是召唤阶段'),(402,'err402_has_summon',4021037,'已有人召唤'),(402,'err402_has_add_limit',4021038,'已达上限'),(402,'err402_no_inspire_times',4021039,'没有鼓舞次数了'),(402,'err402_equip_not_enouht',4021040,'后备攻城器械不足'),(402,'err402_donate_not_enough',4021041,'公会贡献不足'),(402,'err402_too_much_blunt',4021042,'只能同时存在两辆冲车'),(402,'err402_too_much_camion',4021043,'只能同时存在两辆炮车'),(402,'err402_gwar_direct_win',4021044,'所属赛区战斗轮空，本公会获得胜利'),(402,'err402_inspire_success',4021045,'鼓舞成功，当前伤害减免加成{1}%'),(402,'err402_guild_limit_times',4021046,'本公会达到召唤次数上限'),(402,'err402_role_limit_times',4021047,'个人召唤次数达到上限'),(402,'err402_guard_lv_limit',4021048,'150级可参与'),(403,'err403_not_in_time',4030001,'活动未开启'),(403,'err403_not_in_guild_war',4030002,'不在公会篝火中'),(403,'err403_not_has_guild',4030003,'请先加入公会'),(403,'err403_lv_not_enough',4030004,'150级可参与'),(403,'err403_in_guild_war',4030005,'已在公会篝火中'),(403,'err403_not_right_card',4030006,'请使用正确召唤卡'),(403,'err403_guild_not_open',4030007,'该公会未开启篝火'),(403,'err403_step_not_handle',4030008,'当前阶段不能操作'),(403,'err403_has_limit',4030009,'已达购买上限'),(403,'err403_summon_boss_alive',4030010,'当前召唤boss还存活'),(403,'err403_in_guild_bonfire',4030011,'正在公会篝火中'),(403,'err403_join_time_not_enough',4030012,'加入公会一小时不能参加'),(403,'err403_not_enter_again',4030013,'不能以不同公会再次进入'),(409,'err409_not_finish',4090001,'成就未达成，无法领取奖励'),(409,'err409_has_received',4090002,'已经领取过奖励'),(411,'err411_current_not_exist',4110001,'当前使用的称号不存在'),(411,'err411_not_need_change',4110002,'切换的是当前使用的称号，不需切换'),(411,'err411_hide_error',4110003,'隐藏称号错误'),(411,'err411_change_error',4110004,'称号未激活，切换称号失败'),(411,'err411_is_expired',4110005,'称号已过期'),(411,'err411_already_exist',4110006,'[称号已拥有，无需再次激活]'),(412,'err412_cfg_not_exist',4120001,'配置不存在'),(412,'err412_goods_not_exist',4120002,'物品不存在'),(412,'err412_learn_sk_err1',4120003,'没有可用技能位置'),(412,'err412_learn_sk_err2',4120004,'学习技能的位置超出范围'),(412,'err412_learn_sk_err3',4120005,'学习的技能已存在'),(412,'err412_replace_sk_err1',4120006,'被替换的位置不存在技能'),(412,'err412_no_sk_book',4120007,'没有合适的技能书'),(412,'err412_recruit_not_free',4120008,'非免费招募'),(412,'err412_partner_not_exist',4120009,'伙伴不存在'),(412,'err412_wash_goods_err1',4120010,'洗髓物品不足'),(412,'err412_partner_state_err',4120011,'伙伴状态不对'),(412,'err412_upgrade_lv_err',4120012,'升级错误,伙伴等级已大于等于玩家等级'),(412,'err412_wash_replace_err',4120013,'洗髓的伙伴内存中不存在'),(412,'err412_break_err',4120014,'突破等级有错'),(412,'err412_promote_err',4120015,'资质提升错误,已超出上限'),(412,'err412_battle_err1',4120016,'没有可上阵的位置'),(412,'err412_battle_err2',4120017,'上阵错误,玩家等级不足'),(412,'err412_embattle_err1',4120018,'布阵错误,原位置没有伙伴'),(412,'err412_embattle_err2',4120019,'布阵错误,目标位置超出范围'),(412,'err412_weapon_err1',4120020,'激活专属,已激活'),(412,'err412_weapon_err2',4120021,'专属激活,伙伴没招募过'),(412,'err412_disband_err',4120022,'伙伴遣散,伙伴上阵无法遣散'),(412,'err412_callback_err',4120023,'以前没招募过'),(412,'err412_battle_err3',4120024,'上阵位置错误'),(412,'err412_recruit_err1',4120025,'非保底招募,没找到候选伙伴'),(412,'err412_recruit_err2',4120026,'保底招募,没找到候选伙伴'),(412,'err412_partner_is_battle',4120027,'已经有相同伙伴出战'),(413,'err413_fashion_not_pos',4130001,'没有该时装部位'),(413,'err413_fashion_not_fashion',4130002,'该时装未激活'),(413,'err413_fashion_not_same_color',4130003,'不能重复染同一种颜色'),(413,'err413_fashion_color_not_active',4130004,'颜色未激活'),(413,'err413_fashion_not_color',4130005,'颜色不存在'),(413,'err413_fashion_wear',4130006,'当前时装正在穿着'),(413,'err413_fashion_not_wear',4130007,'身上穿着不是这件时装'),(413,'err413_fashion_active',4130008,'时装已激活'),(413,'err413_fashion_max_lv',4130009,'时装部位已满级'),(413,'err413_fashion_not_enough_point',4130010,'时装精华不足'),(413,'err413_fashion_not_resolve',4130011,'该道具不能分解'),(413,'err413_fashion_max_star',4130012,'星级已满级'),(413,'err413_fashion_not_max_star',4130013,'星级未满级'),(413,'err413_fashion_color_active',4130014,'颜色已激活'),(413,'err413_fashion_not_forever',4130015,'时装没永久激活'),(413,'err143_fashion_type_error',4130016,'限时时装无法分解'),(414,'err414_has_receive',4140001,'已经领取过奖励'),(415,'err415_no_enough_times',4150001,'祈愿次数不足'),(416,'err416_no_null_cell',4160000,'寻宝背包已满,无法继续寻宝'),(416,'err416_bag_no_null_cell',4160001,'背包已满，请先清理背包'),(416,'err401_score_not_enough',4160002,'积分不足，无法兑换'),(416,'err416_equip_htimes_lim',4160004,'您已达到本日免费寻宝次数上限'),(416,'err416_peak_htimes_lim',4160005,'您已达到本日装备寻宝次数上限'),(416,'err416_seal_soul_htimes_lim',4160006,'您已达到本日魂珠寻宝次数上限'),(416,'err416_free_time_limit',4160008,'免费时间尚未刷新'),(417,'err417_level_illegal',4170001,'未设置该等级对应签到类型！'),(417,'err417_not_set_match_rewards',4170002,'签到类型没有对应奖励配置！'),(417,'err417_total_level_illegal',4170003,'还没有累计签到类型配置！'),(417,'err417_total_typedays_not_match',4170004,'累计签到类型没有对应的奖励配置！'),(417,'err417_cannot_retro_fulture_day',4170005,'那是未来的日子哦~'),(417,'err417_checkin_day_not_current',4170006,'签到只能是当天操作~'),(417,'err417_checkin_today_has_checked',4170007,'您已经领取过这天的奖励了哦！'),(417,'err417_daily_illeagal_day',4170008,'您累计签到的天数还不够哦！'),(417,'err417_not_reach_open_lv',4170009,'您还没达到签到开放的等级！'),(417,'err417_total_rewards_empty',4170010,'奖励配置错误，请联系GM！'),(417,'err417_checkin_gift_has_received',4170011,'您已经领取过这个奖励咯~'),(417,'err417_no_guild',4170012,'还没加入公会，不能求助~'),(417,'err417_has_received',4170013,'已经领取'),(417,'err417_not_share',4170014,'未分享，不能领取奖励'),(417,'err417_has_receive_share_reward',4170015,'已经领取过奖励'),(417,'err417_night_welfare_not_reward',4170016,'领取时间未到，每天20点至24点可领取'),(417,'err417_night_welfare_already_reward',4170017,'奖励已领取，请明天再来'),(417,'err417_retrotimes_not_enough',4170018,'剩余补签机会不足！'),(417,'err417_value_not_valid',4170019,'未达到领取条件！'),(417,'err417_gift_send_out',4170020,'礼包已经派光了！'),(417,'err417_monday_welfare_not_reward',4170021,'领取时间未到，每周一可领取'),(417,'err417_monday_welfare_already_reward',4170022,'奖励已领取，请下周一再来'),(417,'err417_receive_success',4170023,'领取成功'),(417,'err417_online_time_not_enough',4170024,'在线累积时间不足，不可领取'),(418,'err418_not_in_scene',4180001,'您不在魅力海滩场景中！'),(418,'err418_not_open',4180002,'活动未开始！'),(418,'err418_basic_exp_not_set',4180003,'经验配置错误！'),(418,'err418_gift_props_not_exists',4180004,'不存在该道具！'),(418,'err418_getter_not_join',4180005,'对方没有参加魅力海滩活动，不能赠送给他（她）！'),(418,'err418_gift_times_not_enougth',4180006,'您的赠送次数已经用完，请购买赠送次数后继续赠送！'),(418,'err418_send_to_self',4180007,'不能给自己赠送礼物！'),(418,'err418_no_partner',4180008,'您还没有对象呢！'),(418,'err418_not_join_act',4180009,'您还未参加魅力海滩活动！'),(418,'err418_opp_has_engaged',4180010,'对方已经在约会状态中，请邀请其他玩家！'),(418,'err418_cfg_fault',4180011,'魅力海滩活动配置错误！'),(418,'err418_lv_invalid',4180012,'您未达到开放等级，不能参加活动'),(418,'err418_has_in_scene',4180013,'您已经在场景中了！'),(418,'err418_has_on_engaged',4180014,'您已经在约会中，不能再邀请其他人咯！'),(418,'err418_add_exp_cd',4180015,'增加经验频率不对哦！'),(418,'err418_invite_cd',4180016,'邀请玩家频率太高了，稍后继续邀请！'),(418,'err418_not_find_vote',4180017,'没找到这条拉票信息哦'),(418,'err418_not_your_vote',4180018,'不能置顶别人的拉票信息哦'),(418,'err418_stick_vote_too_ofent',4180019,'置顶太频繁了，给别人点机会吧'),(418,'err418_vote_max',4180020,'该拉票信息可投票数已满'),(418,'err418_not_vote_times',4180021,'剩余投票次数不足'),(418,'err418_already_voted',4180022,'已为该条拉票信息投票过了'),(418,'err418_self_vote',4180023,'不能给自己投票'),(418,'err418_stick_other_vote',4180024,'只能给自己置顶'),(418,'err418_too_much_vote',4180025,'您已经发布太多拉票了，给别人点机会吧'),(418,'err418_refuse_invite',4180026,'对方拒绝了你的约会邀请'),(418,'err418_someone_not_in_scene',4180027,'对方不在活动场景中'),(418,'err418_not_invate',4180028,'对方没有邀请你啦~'),(418,'err418_is_engaging',4180029,'正在约会中，请不要三心二意呀'),(418,'err418_already_on_chair',4180030,'已经在椅子上啦，给别人留点位置吧'),(418,'err418_chair_has_owner',4180031,'这把椅子已经有人坐了'),(418,'err418_not_on_chair',4180032,'不在椅子上'),(418,'err418_buy_times_max',4180033,'已达到购买次数上限'),(419,'err419_no_res_act',4190001,'奖励找回中没有此活动'),(419,'err419_no_more_times',4190002,'次数不足'),(419,'err419_no_dun_finish',4190003,'没有通关副本'),(419,'err419_lv_not_match',4190004,'已超过该奖励等级'),(420,'err420_need_buy_greater',4200001,'不能选择比原来低档次的投资'),(420,'err420_no_investment',4200002,'您没有投资该项目'),(420,'err420_need_more_day',4200003,'投资{1}天后可以领取该奖励'),(420,'err420_reward_is_got',4200004,'该投资回报已经领取'),(421,'err421_1_have_not_goods',4210001,'不存在该藏宝图'),(421,'err421_2_not_xy',4210002,'未到达藏宝地点'),(421,'err421_3_collec_wrong',4210003,'采集失败'),(421,'err421_4_team_num_err',4210004,'队伍人数不够2人'),(421,'err421_5_clue_not_enough',4210005,'线索不够'),(421,'err421_6_not_team',4210006,'需2人以上组队前往'),(421,'err421_7_not_num',4210007,'需2人以上组队前往'),(421,'err421_8_lv_not',4210008,'等级不够'),(421,'err421_9_not_scene',4210009,'当前位置没发现线索'),(421,'err421_10_not_same_time',4210010,'不在同一支队伍中'),(421,'err421_11_not_same_guild',4210011,'不在同一个帮会中'),(421,'err421_12_already_get',4210012,'该线索已被发掘，请寻找其他线索'),(421,'err421_13_not_guild',4210013,'请加入一个公会'),(421,'err421_14_not_clue',4210014,'当前位置没发现线索'),(421,'err421_16_max_help',4210016,'您今天的神秘宝图帮助奖励已到上限'),(421,'err421_17_not_same_guild',4210017,'您与宝藏发布者不在同一个公会'),(421,'err421_18_collecting',4210018,'{1}正在挖宝，眼睛变成卢币形状'),(421,'err421_19_not_xy_extra',4210019,'{1}不在附近，无法挖宝'),(421,'err421_20_lv_not_extra',4210020,'{1}等级不足'),(421,'err421_21_fine_max_help',4210021,'您今天的精致宝图帮助奖励已到上限'),(421,'err421_22_not_safe_scene',4210022,'非安全区域不能进入神秘洞穴'),(421,'err421_23_team_spill',4210023,'队伍已满'),(421,'err421_24_not_enter_again',4210024,'不能再次进入神秘洞穴'),(421,'err421_25_dun_num_limit',4210025,'洞窟帮助次数已达上限'),(421,'err421_26_dun_level',4210026,'当前副本阶段禁止进入'),(421,'err421_28_response_success',4210028,'回应成功'),(423,'err423_already_onhook',4230001,'正在远征中'),(423,'err423_lv_limit',4230002,'未达到开放等级'),(423,'err423_no_onhook_time',4230003,'没有挂机时间了'),(423,'err423_not_in_onhook',4230004,'并没有进行远征'),(423,'err423_have_not_guardian',4230005,'您尚未拥有该守护'),(423,'err423_not_enough_times',4230006,'没有领取次数咯'),(423,'err423_guardian_already_working',4230007,'该守护已经上阵了'),(423,'err423_devil_can_not_work',4230008,'小恶魔不想挖矿'),(423,'err423_guardian_can_not_work',4230009,'我不想去这里'),(423,'err423_mine_max_lv',4230010,'矿洞已达最高等级'),(423,'err423_conditions_error',4230011,'尚未满足升级条件'),(423,'err423_actived_miner',4230012,'矿工已雇佣'),(423,'err423_received_time_limit',4230013,'尚未达到可领取时间'),(424,'err424_chapter_lock',4240001,'该玩法尚未解锁'),(424,'err424_has_receive_reward',4240002,'奖励已经领取过了'),(424,'err424_progress_not_finish',4240003,'当前阶段目标未完成'),(425,'err425_not_finish',4250001,'未完成不能激活'),(425,'err425_last_book_not_active',4250002,'请先激活{1}'),(425,'err425_book_lock',4250003,'请先解锁'),(425,'err425_is_finished',4250004,'已经激活'),(427,'err427_error_config',4270001,'配置错误'),(427,'err427_floor_not_enough',4270002,'未达到副本层数'),(427,'err427_posid_error',4270003,'错误的穿戴位置'),(427,'err427_not_equip_principle',4270004,'未装备该法则'),(427,'err427_cfg_error',4270005,'不正确的物品类型'),(427,'err427_not_in_bag',4270006,'法则不在背包'),(427,'err427_not_activate',4270007,'还未激活神格'),(428,'err428_grow_up_fail',4280001,'培养失败'),(428,'err428_active_fail',4280002,'激活失败'),(428,'err428_spirit_not_active',4280003,'请先开启对应圣灵'),(428,'err428_pyx_actived',4280004,'圣器已激活'),(428,'err428_args_error',4280005,'操作参数错误'),(428,'err428_has_limit',4280006,'已达满级'),(429,'err429_not_in_butterfly',4290001,'不再蝴蝶活动中'),(429,'err429_lv_not_enough',4290002,'等级不足'),(429,'err429_in_butterfly',4290003,'处于捕蝶场景中'),(429,'err429_is_not_open',4290004,'活动未开启'),(429,'err429_no_this_reward',4290005,'没有这项奖励'),(429,'err429_condition_not_enough',4290006,'未达到条件'),(429,'err429_has_got',4290009,'奖励已领取'),(429,'err429_is_in_team',4290010,'处于队伍中'),(429,'err429_tired_max',4290011,'疲劳值满了'),(429,'err429_had_rotato',4290012,'已抽过奖'),(429,'err429_activity_times_max',4290013,'今日捕蝶活动次数已达上限'),(430,'err430_have_not_star_soul',4300001,'尚未拥有该星灵'),(430,'err430_star_soul_stage_already_max',4300002,'星灵已是最高阶了'),(430,'err430_star_soul_star_already_max',4300003,'星灵已是最高星级'),(430,'err430_star_soul_universe_already_max',4300004,'已经是最强小宇宙了！'),(430,'err430_too_often',4300005,'上来上去太累了，先歇一下吧'),(430,'err430_location_is_full',4300006,'当前阵位已满了哦，试试突破小宇宙吧'),(430,'err430_already_in_location',4300007,'已在该阵位上了哦'),(430,'err430_change_location_fail',4300008,'上阵位置错误'),(430,'err430_lucky_draw_fail',4300009,'奖励抽取失败啦'),(430,'err430_short_of_integral',4300010,'积分不足,无法兑换'),(430,'err430_draw_type_error',4300011,'抽奖类型错误'),(430,'err430_least_num_over_draw_times',4300012,'物品配置错误'),(430,'err430_lack_of_goods',4300013,'缺少抽奖物品'),(430,'err430_goods_id_not_exist',4300014,'物品不存在'),(430,'err430_key_no_exist',4300015,'配置不存在'),(430,'err430_not_main_worker',4300016,'请先上阵主战位星灵'),(430,'err430_star_soul_using_skill',4300017,'星灵羁绊技能使用中，不可更换星灵阵位'),(430,'err430_already_have_star_soul',4300018,'已经拥有该星灵了'),(430,'err430_args_type_error',4300019,'参数类型错误'),(430,'err430_key_value_data_error',4300020,'键值对配置错误'),(430,'err430_have_not_passive_skill',4300021,'尚未拥有该技能'),(430,'err430_already_have_passive_skill',4300022,'已拥有该技能'),(430,'err430_have_not_skill_loc',4300023,'技能栏位已满'),(430,'err430_skill_max_lv',4300024,'该技能已达最大等级'),(430,'err430_not_up_to_open_level',4300025,'未达到抽奖等级'),(430,'err430_loc_open_lv_limit',4300026,'尚未达到阵位开启等级'),(430,'err430_formation_err',4300027,'所选阵位错误'),(431,'err431_not_star_shadow',4310001,'该道具不是星痕'),(431,'err431_star_shadow_cfg_err',4310002,'星痕配置出错'),(431,'err431_not_in_star_shadow_bag',4310003,'物品不在星痕背包中'),(431,'err431_equip_lv_limit',4310004,'等级不够无法装备'),(431,'err431_no_equip',4310005,'未装备星痕'),(431,'err431_mold_soul_lv_limit',4310006,'铸魂所需强化等级不够'),(431,'err431_mold_soul_lv_max',4310007,'铸魂已到最大等级'),(431,'err431_stren_lv_max',4310008,'星痕强化已到最高等级'),(431,'err431_compose_cfg_fail',4310009,'无法合成改星痕'),(432,'err432_lv_not_enough',4320001,'等级不足'),(432,'err432_is_max_level',4320002,'已通关最高层'),(432,'err432_please_star_soul',4320003,'请选择上阵星灵'),(432,'err432_exits_not_active',4320004,'存在未激活星灵'),(432,'err432_sweep_need_pass',4320005,'需要通关才能扫荡'),(432,'err432_not_sweep_times',4320006,'已无扫荡次数'),(432,'err432_pos_not_zero',4320007,'出战位不能为0'),(432,'err432_not_pass_level',4320008,'没有通关该关卡'),(433,'err433_no_equip_cfg',4330000,'没有装备配置'),(433,'err433_equip_pos_type_error',4330001,'装备部位类型错误'),(433,'err433_no_stren_cfg',4330002,'缺少强化配置'),(433,'err433_error_equip_type',4330003,'错误的装备类型'),(433,'err433_already_max_lv',4330004,'已达到最高级'),(433,'err433_failed_to_reach_breakthrough_level',4330005,'未达到突破等级'),(433,'err433_star_soul_no_equip',4330006,'星灵未穿戴该装备'),(433,'err433_target_equip_no_exist',4330007,'目标装备不存在'),(433,'err433_can_not_resolve_equip',4330008,'没有可分解的装备'),(434,'err434_can_not_change_scene_in_home',4340001,'正在家园中'),(434,'err434_furniture_num_not_enough',4340002,'家具数量不足'),(434,'err434_home_not_build',4340003,'未激活家园'),(434,'err434_furniture_type_is_limit',4340004,'家具摆放达上限'),(434,'err434_furniture_not_decorated',4340005,'该家具没有摆放中'),(434,'err434_mate_in_decoratting',4340006,'伴侣正在摆放家具，请稍后'),(434,'err434_condition_not_enough',4340007,'条件不足'),(434,'err434_collect_time_err',4340008,'时间未到'),(434,'err434_wish_coin_not_enough',4340009,'许愿币不足,可前往购买'),(434,'err434_build_not_exist',4340010,'建筑未激活'),(434,'err434_is_top_home',4340011,'已是最高规格房屋'),(434,'err434_not_in_self_courdyard',4340012,'不在自己的庭院中'),(434,'err434_not_in_home',4340013,'不在家园中'),(434,'err434_build_in_upgrade',4340014,'建筑正在升级中'),(434,'err434_upgrade_list_full',4340015,'升级列表已满'),(434,'err434_resource_not_enough',4340016,'资源不足'),(434,'err434_collect_type_err',4340017,'该建筑不可采集'),(434,'err434_not_in_self_home',4340018,'不在自己或者伴侣家园中'),(434,'err434_funiture_owner_err',4340019,'不是你或者你伴侣的家具'),(434,'err434_not_in_decorate_state',4340020,'请先进入家具摆放状态'),(434,'err434_funiture_type_not_lock',4340021,'该家具类型未解锁，请提升房屋等级'),(434,'err434_wish_type_err',4340022,'不是许愿池，不能许愿'),(434,'err434_signal_not_buy',4340023,'需要伴侣关系方可购买哦'),(434,'err434_not_than_home_lv',4340024,'不能超过房屋等级'),(434,'err434_not_share_signal',4340025,'需要伴侣关系能共享房屋'),(434,'err434_has_share',4340026,'已经共享了'),(434,'err434_not_group_share',4340027,'没有组合可共享'),(434,'err434_not_share_type',4340028,'不是共享房屋状态'),(434,'err434_up_vip_lv',4340029,'请提升贵族等级，继续购买'),(434,'err434_not_furniture',4340030,'不是家具'),(434,'err434_home_coin_not_enough',4340031,'家园币不足'),(434,'err434_task_reward_get',4340032,'已领取奖励'),(434,'err434_task_not_finish',4340033,'任务未达成'),(434,'err434_task_not_exits',4340034,'任务不存在'),(434,'err434_task_can_get',4340035,'任务已经是可领取状态'),(434,'err434_max_lv',4340036,'已达最高等级'),(434,'err434_baby_not_exit',4340037,'存在未激活宝宝'),(434,'err434_baby_in_task',4340038,'宝宝在派遣任务中'),(434,'err434_dispatch_num_limit',4340039,'派遣个数已达上限'),(434,'err434_baby_num_limit',4340040,'宝宝上阵数量达上限'),(434,'err434_wall_not_decorate',4340041,'当前房屋不能使用该墙纸'),(434,'err434_build_is_not_up',4340042,'建筑不在升级中'),(434,'err434_card_not_match',4340043,'该建筑不能使用'),(434,'err434_temp_line_limit',4340044,'临时队列已达上限'),(434,'err434_furniture_not_enough',4340045,'家具不足'),(434,'err434_furniture_decorated_limit',4340046,'该家具摆放达上限'),(434,'er434_has_active',4340047,'已经激活'),(434,'err434_not_active',4340048,'未激活该图鉴'),(434,'err434_has_max_lv',4340049,'已达最高等级'),(434,'err434_no_use_wish',4340050,'未激活许愿池建筑，不可使用'),(434,'err434_please_top_home',4340051,'请选择更高级家园'),(435,'err435_cfg_error',4350001,'配置异常'),(435,'err435_not_can_cook',4350002,'没有可烹饪的'),(435,'err435_not_can_equip',4350003,'没有可打造的'),(435,'err435_build_lv_not_enough',4350004,'建筑所需等级不足'),(435,'err435_skill_lv_not_enough',4350005,'技能等级不足'),(435,'err435_power_live_not_enough',4350006,'活力不足'),(435,'err435_not_cook_book',4350007,'找不到对应食物'),(435,'err435_has_cook_book',4350008,'已激活该食谱'),(435,'err435_not_gain_food',4350009,'不是增益类食物'),(435,'err435_lv_not_enough',4350010,'人物等级不足'),(435,'err435_has_equip_paper',4350011,'已激活该图纸'),(435,'err435_not_equip_paper',4350012,'找不到对应图纸'),(435,'err435_not_active',4350013,'未激活该类型'),(436,'err436_tool_not_enough',4360001,'道具不足'),(436,'err436_can_not_change_scene_in_drumwar',4360002,'在星灵争霸中'),(436,'err436_not_guess_state',4360003,'不是竞猜阶段'),(436,'err436_not_guess_zone_role',4360004,'非可选战区候选人'),(436,'err436_not_select_empty_role',4360005,'轮空玩家不可选'),(436,'err436_not_guess_act_role',4360006,'非可选战场候选人'),(436,'err436_not_select_same_plat',4360007,'不可同时选同台候选人'),(436,'err436_not_allow_select_same',4360008,'不可重复选同个候选人'),(436,'err436_has_sign',4360009,'已报名'),(436,'err436_not_sign_state',4360010,'不是报名阶段'),(436,'err436_no_repeat_enter',4360011,'不能重复出战'),(436,'err436_star_not_exits',4360012,'星灵不存在'),(436,'err436_no_repeat_choose',4360013,'已确认了出战阵容'),(436,'err436_time_pass',4360014,'已过了选择时间'),(436,'err436_star_num_not_enough',4360015,'星灵激活数量不足'),(436,'err436_please_choose',4360016,'请选择星灵'),(436,'err436_is_reject_into',4360017,'当前阶段不可进入'),(436,'err436_not_sign',4360018,'没有报名'),(436,'err436_is_in_prepare',4360019,'已在活动场景内'),(436,'err436_cfg_error',4360020,'配置出错'),(436,'err436_lv_not_enough',4360021,'等级不足'),(436,'err436_power_out',4360022,'战力跌出4096名，失去比赛资格'),(436,'err436_quick_point',4360023,'手速太快了'),(436,'err436_pos_error',4360024,'出战位置错误'),(437,'err437_lv_not_enough',4370001,'等级不足'),(437,'err437_cfg_error',4370002,'配置错误'),(437,'err437_has_buy',4370003,'已购买'),(437,'err437_no_sell',4370004,'该物品没上架'),(437,'err437_coin_not_enough',4370005,'货币不足'),(440,'err440_lv_not_enough',4400001,'等级不足'),(440,'err440_has_active',4400002,'已激活'),(440,'err440_not_active',4400003,'降神还未激活'),(440,'err440_cfg_error',4400004,'配置不存在'),(440,'err440_empty_battle_god',4400005,'没有出战的降神'),(440,'err440_cd_not_end',4400006,'灵气未蓄满'),(440,'err440_cannot_switch_status',4400007,'当前状态不能降神'),(440,'err440_is_limit',4400008,'已达满级'),(440,'err440_feed_kind_fail',4400009,'喂养道具不匹配'),(440,'err440_in_pos',4400010,'已经在出战位'),(440,'err440_trans_not_handle',4400011,'变身中不能替换'),(440,'err440_feed_num_error',4400012,'喂养数量错误'),(440,'err440_not_active_pyx',4400013,'未激活圣器'),(440,'err440_not_active_seal',4400014,'未激活印记'),(440,'err440_not_active_rune',4400015,'未激活符文'),(440,'err440_pos_not_open',4400016,'该槽位未开启'),(440,'err440_is_not_goods',4400017,'该物品不属于印记'),(440,'err440_not_equip_same_type',4400018,'不能穿戴相同类型的印记'),(440,'err440_not_equip',4400019,'印记无穿戴在身上'),(440,'err440_not_compose_goods',4400020,'不是合成材料'),(440,'err440_compose_goods_not_lv',4400021,'合成材料阶数不足'),(440,'err440_not_equip_low',4400022,'不能穿戴同类型低阶印记'),(440,'err440_please_select_compose',4400023,'请正确选择消耗材料'),(441,'er441_has_active',4410001,'已激活'),(441,'err441_cfg_fail',4410002,'配置不存在'),(441,'err441_condition_not_enough',4410003,'条件不足'),(441,'err441_lv_not_enough',4410004,'等级不足'),(441,'err441_not_active',4410005,'未激活该图鉴'),(441,'err441_has_max_lv',4410006,'已达满级'),(450,'pt_450_bad_card_type',4500001,'不存在对应卡片类型'),(450,'pt_450_hasbeen_vip',4500002,'您已是贵族会员，无须再体验哦!'),(450,'pt_450_card_exists',4500003,'该道具不存在'),(450,'pt_450_money_notenougth',4500004,'您的钻石余额不足'),(450,'pt_450_notexists_card',4500005,'不存在该类型物品'),(450,'pt_450_vip_time_out',4500006,'您会员已经过期！'),(450,'pt_450_vip_lower',4500007,'达到贵族4才可进入首领之家哦'),(450,'err450_have_not_times',4500008,'您的礼包已经领取完毕了哦~'),(450,'err450_buy_limit',4500009,'领取条件未满足'),(450,'err450_clear_data_time',4500010,'清理数据中，请3秒后再尝试领取~'),(450,'err450_already_honor',4500011,'已经是荣耀贵族了'),(450,'err450_already_checkin',4500012,'今天已经签过了~'),(450,'err450_vip_type_wrong',4500013,'vip特权不足'),(450,'err450_diamond_vip_need_buy',4500014,'未满足前置购买条件'),(450,'err450_progress_not_enough',4500015,'目标尚未达成'),(450,'err450_already_received',4500016,'该奖励已经领取过了'),(450,'err450_task_lv_limit',4500017,'等级不足，无法参与此任务'),(450,'err450_honor_coin_not_enough',4500018,'至尊币不足'),(450,'err450_activited_trial_honor',4500019,'体验至尊卡只能激活一次'),(450,'err450_vip_immune_already_used',4500020,'今日已使用过无敌buff了哦'),(450,'err450_not_in_boss_scene',4500021,'不在boss场景'),(450,'err450_already_forever',4500022,'已有该等级的永久vip啦'),(450,'err450_cant_use_exp_card',4500023,'未激活黄金vip，无法使用vip经验卡哦'),(460,'err460_no_boss_cfg',4600001,'首领配置错误！'),(460,'err460_no_boss_type',4600002,'首领类型错误！'),(460,'err460_tried_max',4600003,'疲劳值已满！'),(460,'err460_count_max',4600004,'进入次数已用完！'),(460,'err460_no_lv',4600005,'您的等级不足！'),(460,'err460_no_remind',4600006,'您已经关注了，无需重复关注'),(460,'err460_no_unremind',4600007,'您还没有关注，无需取消关注'),(460,'err460_quit_team',4600008,'请先退出队伍'),(460,'err460_not_in_scene',4600009,'该场景不能使用'),(460,'err460_has_limit',4600010,'次数已达上限'),(460,'err460_room_num_limit',4600011,'进入人数已达上限'),(460,'err_460_error_scene_add_target',4600012,'非boss场景，不能添加反击目标'),(460,'err_460_target_len_error',4600013,'反击目标数量超出范围了'),(460,'err_460_vip_immune_error',4600014,'无敌状态无需添加反击目标'),(461,'err461_in_kf_boss',4610001,'正在跨服boss场景中'),(461,'err461_collect_time_limie',4610002,'采集次数不足'),(461,'err461_enter_lv_limit',4610003,'等级不足，无法进入'),(461,'err461_not_in_kf_boss',4610004,'不在跨服boss场景中'),(461,'err461_enter_attr_limit',4610005,'属性不足，无法进入'),(461,'err461_enter_star_shadow_limit',4610006,'星痕战力不足，无法挑战该首领'),(461,'err461_open_day_limit',4610007,'未达指定开服天数'),(500,'err500_husong_start',5000001,'正在护送中'),(500,'err500_husong_end',5000002,'今日护送次数已经用完'),(500,'err500_husong_unfinish_last_stage',5000003,'未完成上一个阶段'),(500,'err500_husong_quality_max',5000004,'品质已达上限'),(500,'err500_husong_cant_change_scene',5000005,'开始了护送无法切换场景'),(500,'err500_husong_not_start',5000006,'护送还没开始'),(500,'err500_husong_stage_wrong',5000007,'护送阶段不正确'),(500,'err500_husong_ask_cd',5000008,'求助冷却中'),(500,'err500_husong_help_offline',5000009,'求助玩家已下线'),(500,'err500_husong_help_end',5000010,'求助玩家护送已结束'),(500,'err500_husong_help_same_scene',5000011,'求助玩家和你在同一场景'),(500,'err500_husong_not_now_scene_packup',5000012,'不是当前场景接取护送任务'),(500,'err500_husong_not_right_target_id',5000013,'目标天使id错误'),(500,'err500_husong_take_num_max',5000014,'拦截奖励次数已达上限，无法继续获得奖励'),(500,'err500_husong_take_success',5000015,'拦截成功'),(500,'err500_husong_invincible_max',5000016,'庇护已用完'),(500,'err500_husong_reflesh_fail',5000017,'提升失败，天使品质不变'),(500,'err500_husong_reflesh_success',5000018,'提升成功，获得<color=\'{1}\'>{2}</color>天使'),(500,'err500_husong_cost',5000019,'共消耗{1}个天使令，{2}绑钻，{3}钻石'),(500,'err500_not_near_packup_npc',5000020,'不在任务NPC附近'),(500,'err500_husong_help_max',5000021,'协助玩家已达上限'),(500,'err500_husong_wrong_id',5000022,'非法的飞艇ID'),(500,'err500_in_husong_help',5000023,'正在协助中，无法协助其他玩家'),(500,'err500_in_husong_take',5000024,'正在拦截中'),(500,'err500_not_now_scene_packup',5000025,'不在护送npc场景'),(501,'err501_please_join_guild',5010001,'请先加入公会，再来参加活动！'),(501,'err501_cannot_attack_friend',5010002,'请勿抢夺好友积分！'),(501,'err501_act_close',5010003,'荣耀战神活动已结束！'),(501,'err501_in_attack_cd',5010004,'冷却未冷却！'),(501,'err501_player_not_exist',5010005,'缺失玩家数据'),(501,'err501_oppplayer_not_exist',5010006,'对方玩家数据异常'),(501,'err501_in_protect_cd',5010007,'对方处于抢夺保护时间'),(501,'err501_cannot_attack',5010008,'请勿抢夺比自己名次差距太大的玩家'),(501,'err501_not_in_attack_idel',5010009,'请等当前战斗结束后，再来操作！'),(501,'err501_cannot_attack_self',5010010,'请勿抢夺你自己'),(501,'err501_cannot_transferable',5010011,'在主城和安全区才能参加活动！'),(501,'err501_lv_not_enough',5010012,'等级不足20级，暂不能参加荣耀战神活动！'),(501,'err501_goal_lock',5010013,'该玩法尚未解锁'),(501,'err501_has_receive_reward',5010014,'奖励已领取'),(501,'err501_progress_not_finish',5010015,'进度未完成'),(502,'err502_already_activate',5020001,'已激活'),(502,'err502_career_wrong',5020002,'职业不符'),(502,'err502_goods_id_wrong',5020003,'物品id有误'),(502,'err502_not_activate',5020004,'未激活'),(502,'err502_max_lv',5020005,'等级已达上限'),(502,'err502_max_star',5020006,'星级已达上限'),(502,'err502_max_upgrade',5020007,'强化已达上限'),(502,'err502_already_figure',5020008,'已幻化'),(502,'err502_not_unlock_figure',5020009,'外观尚未解锁'),(503,'err503_cannot_transferable',5030001,'在主城和安全区才能参与活动！'),(503,'err503_lv_error',5030002,'您未达到活动开启等级！'),(503,'err503_rival_not_enough',5030003,'英雄战场对手不足，暂时无法开启！'),(503,'err503_init_rival_error',5030004,'对手数据初始化异常'),(503,'err503_client_init_rival_error',5030005,'请刷新，客户端获取的对手数据不是最新的！'),(503,'err503_finish_all_attack',5030006,'您已挑战完所有对手！'),(503,'err503_in_battle_status',5030007,'您当前处于挑战状态，请先挑战！'),(503,'err503_no_award',5030008,'无可领取的奖励！'),(503,'err503_not_enough_attack_count',5030009,'剩余挑战次数不足！'),(503,'err503_reset_status',5030010,'英雄战场正在重置，无法挑战'),(503,'err503_missing_award_cfg',5030011,'领取失败，缺失奖励配置'),(503,'err503_settlement_plase_wait',5030012,'结算中，请稍后退出！'),(503,'err503_not_in_hero_war',5030013,'退出失败，不在英雄战场中！'),(601,'err601_not_kf_hegemony_server',6010001,'玩家所在服务器不满足服战参与条件'),(601,'err601_be_appoint_ser_id_not_vaild',6010002,'对方服务器不存在，不能进行约战'),(601,'err601_has_appoint_server',6010003,'您所在的服务器已有约战在身，无法继续约战'),(601,'err601_appoint_server_cd',6010004,'该服处于约战冷却状态，请5分钟后再试'),(601,'err601_not_enough_score',6010005,'本服积分不足，无法约战'),(601,'err601_player_not_qualified',6010006,'您没有参赛资格，无法入场'),(601,'err601_battlefield_has_end',6010007,'该战场已分出胜负，快去别的战场杀敌吧'),(601,'err601_not_in_battle_stage',6010008,'战斗期内才可入场'),(601,'err601_reach_max_people_lim',6010009,'战场内本方人数已达上限'),(603,'err603_in_battle',6030001,'当前正在幻兽入侵活动中'),(605,'err605_no_enough_lv_join',6050001,'等级不足'),(605,'err605_no_in_act_scene',6050002,'不在活动中'),(605,'err605_act_close',6050003,'活动未开启'),(605,'err605_can_not_change_scene_in_war_god',6050004,'在荣耀战神活动中'),(605,'err605_has_limit',6050005,'已达上限'),(605,'err605_has_got',6050006,'已经领取'),(605,'err605_not_enough',6050007,'条件不足'),(605,'err605_no_guild_call',6050008,'没有公会不能召集'),(606,'err606_cant_change_scene_in_melee_pk',6060001,'正处于大乱斗活动，不能参加其它活动'),(606,'err606_not_in_act_scene',6060002,'当前不处于大乱斗场景'),(606,'err606_act_close',6060003,'活动未开启'),(606,'err606_error_area_id',6060004,'地图区域参数错误'),(606,'err606_error_not_reach_area',6060005,'请继续步入目标区域'),(606,'err606_error_score_not_reach_area',6060006,'积分不足，不能进入下一层'),(607,'err607_not_allow',6070001,'只有会长和副会长才可以宣战哦'),(607,'err607_liveness_not_enough',6070002,'公会活跃度不足'),(607,'err607_not_in_war',6070003,'不在活动内'),(607,'err607_has_got',6070004,'已经领取过'),(607,'err607_not_in_sell',6070005,'该物品没有上架'),(607,'err607_point_quickly',6070006,'手速太快了'),(607,'err607_is_limit',6070007,'已达上限'),(607,'err607_not_apply_stage',6070008,'不是宣战阶段'),(607,'err607_not_fight_stage',6070009,'不是活动时间'),(607,'err607_cfg_error',6070010,'异常情况'),(607,'err607_not_apply',6070011,'您所在公会没有参战资格哦'),(607,'err607_not_own',6070012,'未占领该领地'),(607,'err607_is_own',6070013,'已经占领领地，无法宣战新的领地'),(607,'err607_has_apply',6070014,'已经宣战过'),(607,'err607_apply_has_limit',6070015,'宣战公会已达上限'),(607,'err607_score_not_enough',6070016,'积分不足'),(607,'err607_can_not_change_scene_in_kf_town',6070017,'正在跨服城战中'),(607,'err607_not_allow_kickout_when_kftown',6070018,'跨服城战期间，不能进行此操作'),(607,'err607_not_apply_building',6070019,'只有要塞领地才可以宣战'),(607,'err607_is_max_limit',6070020,'公会参加人数已满'),(607,'err607_not_assist_building',6070021,'只有要塞领地才可以应援'),(607,'err607_not_apply_assist',6070022,'没有宣战该领地'),(607,'err607_not_got_in_fight',6070023,'跨服城战期间，不能领取'),(607,'err607_not_buy_in_fight',6070024,'跨服城战期间，不能购买'),(607,'ererr607_lv_not_buy',6070025,'购买等级不足'),(608,'err608_cant_change_scene_in_kf_city',6080001,'正处于世界主城，不能参加其它活动'),(609,'err609_cant_change_scene_in_kf_invade',6090001,'正处于跨服入侵活动，不能参加其它活动'),(609,'err609_act_close',6090002,'活动未开启，不能进去他服'),(609,'err609_target_server_not_open',6090003,'目标服务器条件不符'),(609,'err609_not_enough_server',6090004,'服务器条件不符，数量不足2个'),(609,'err609_role_num_limit',6090005,'目标服务器场景人数已达上限'),(609,'err609_enter_kf_city_first',6090006,'请先前往世界主城'),(609,'err609_server_not_open',6090007,'你所在的服务器未开启跨服入侵'),(609,'err609_back_kf_city_error',6090008,'状态异常，请直接退出进入世界主城'),(609,'err609_not_in_kf_invade_scene',6090009,'你未处于跨服入侵场景'),(609,'err609_target_server_close',6090010,'目标服务器场景已关闭'),(609,'err609_stage_reward_unreach',6090011,'积分条件不足'),(609,'err609_stage_reward_geted',6090012,'已领取积分奖励'),(610,'err610_dungeon_role_not_exist',6100001,'副本玩家不存在'),(610,'err610_dungeon_team_args_error',6100002,'副本的队伍参数错误'),(610,'err610_not_on_safe_scene_to_enter_dungeon',6100003,'你不在安全区域无法进去副本'),(610,'err610_not_on_safe_scene_to_enter_dungeon_by_other',6100004,'{1}所在场景无法进入副本'),(610,'err610_not_enough_lv_to_enter_dungeon_by_other',6100005,'{1}等级不足无法进入副本'),(610,'err610_dungeon_count_daily_help_by_other',6100006,'{1}助战次数不足'),(610,'err610_dungeon_count_permanent_by_other',6100007,'{1}副本次数不足，终生最多进去{2}次'),(610,'err610_dungeon_count_week_by_other',6100008,'{1}副本次数不足，每周最多进去{2}次'),(610,'err610_dungeon_count_daily_by_other',6100009,'{1}副本次数不足'),(610,'err610_dungeon_not_open',6100010,'副本没有开启'),(610,'err610_just_once_finish',6100011,'副本已经通关，不能重复挑战'),(610,'err610_need_finish_dun_id',6100012,'需要完成前置副本'),(610,'err610_not_enough_lv_to_enter_dungeon',6100013,'等级不足，无法进入副本'),(610,'err610_dungeon_num_not_satisfy',6100014,'人数不足，无法进入副本'),(610,'err610_dungeon_count_cfg_error',6100015,'副本配置出错'),(610,'err610_dungeon_count_daily_help',6100016,'你的副本次数不足，每天助战最多进去{1}次'),(610,'err610_dungeon_count_permanent',6100017,'副本已经通关，不能重复挑战'),(610,'err610_dungeon_count_week',6100018,'你的副本次数不足，每周最多进去{1}次'),(610,'err610_dungeon_count_daily',6100019,'你的副本次数不足，每天最多进去{1}次'),(610,'err610_cls_team_not_enter_dungeon',6100020,'跨服队伍无法进入本副本'),(610,'err610_on_dungeon',6100021,'玩家已经在副本中'),(610,'err610_dungeon_not_exist',6100022,'副本不存在'),(610,'err610_not_on_enter_scene',6100029,'你不在副本进入所需场景'),(610,'err610_not_on_enter_scene_by_other',6100030,'{1}不在副本进入所需场景'),(610,'err610_dungeon_error',6100031,'副本异常,请联系GM'),(610,'err610_dungeon_scene_not_exist',6100032,'副本场景不存在'),(610,'err610_had_on_dungeon',6100033,'已经在副本'),(610,'err610_cannot_join_act_on_battle',6100034,'脱离战斗状态才能进入副本'),(610,'err610_cannot_join_act_on_battle_with_name',6100035,'{1}同意，正在脱离战斗，前往安全位置'),(610,'err610_have_no_count_to_enter_target_with_name',6100038,'{1}的次数为0，无法进入目标'),(610,'err610_have_no_count_to_enter_target',6100039,'您的次数为0，无法进入目标'),(610,'err610_have_no_count_to_create_target',6100040,'您的次数为0，无法创建目标'),(610,'err610_enter_cost_error',6100041,'您的门票不足，无法进入副本'),(610,'err610_buy_cost_error',6100042,'您的钻石余额不足，无法购买次数'),(610,'err610_buy_vip_error',6100043,'您的贵族等级不足，无法购买次数'),(610,'err610_buy_limit_error',6100044,'今日购买次数已达上限'),(610,'err610_sweep_limit_error',6100045,'该副本不能扫荡'),(610,'err610_sweep_lv_limit',6100046,'扫荡该副本需要角色达到{1}级'),(610,'err610_sweep_never_finish',6100047,'需要通关副本才能扫荡'),(610,'err610_dungeon_count_daily_sweep',6100048,'剩余次数不足'),(610,'err610_dungeon_count_weekly_sweep',6100049,'周次数不足'),(610,'err610_dungeon_count_permanent_sweep',6100050,'终生次数不足'),(610,'err610_help_times_left',6100051,'助战奖励已发送到背包，今日还可获得{1}次助战奖励'),(610,'err610_encourage_count_limit',6100052,'鼓舞次数已达上限'),(610,'err610_encourage_coin_count_limit',6100053,'鼓舞次数已达上限'),(610,'err610_reset_count_limit',6100054,'重置次数不足'),(610,'err610_nothing_reset',6100055,'没有可重置的关卡'),(610,'err610_nothing_sweep',6100056,'当前无可扫荡的副本'),(610,'err610_help_reward_time_limit',6100057,'今日助战次数已用完，无法再获得助战奖励'),(610,'err610_too_many_members',6100058,'该副本进入人数不能超过{1}人'),(610,'err610_dungeon_is_end',6100059,'当前已经结算，无法进入'),(610,'err610_buy_count_error',6100060,'该副本不能购买次数'),(610,'err610_only_couple_enter',6100061,'该副本只能互为异性或者情侣夫妻才可进入'),(610,'err240_my_cost_error_exp',6100062,'宝库入场券不足，请到商城购买'),(610,'err610_is_final_dun',6100063,'当前已是最高关卡'),(610,'err610_slowdown_cd',6100064,'减速正在冷却中'),(610,'err610_not_sweep',6100065,'评分不足以扫荡'),(610,'err610_legend_lv_not_enough',6100066,'传奇等级不足'),(610,'err610_flop_time_out',6100067,'已过了翻牌时间'),(610,'err610_score_not_flop',6100068,'评分不足'),(610,'err610_vip_not_flop',6100069,'vip等级不足'),(610,'err610_not_flop_times',6100070,'无翻牌次数'),(610,'err610_has_got',6100071,'已经领取过'),(610,'err610_not_couple_can_use',6100072,'互为情侣才能使用技能'),(610,'err610_love_score_not_enough',6100073,'恩爱分不足，无法使用情侣技能'),(610,'err610_is_cd',6100074,'冷却中'),(610,'err610_has_answer',6100075,'已经回答过'),(610,'err610_quit_team',6100076,'请先退出队伍'),(610,'err610_battle_star',6100077,'没有主战的星灵'),(610,'err610_pass_reply_time',6100078,'过了答题时间'),(610,'err610_times_is_limit',6100079,'使用次数已达上限'),(610,'err610_not_dungeon_goods',6100080,'不存在该道具'),(610,'err610_conditon_not_enough',6100081,'条件不足'),(610,'err610_reset_time',6100082,'当前是重置时间,请稍后进入'),(610,'err610_is_max_wave',6100083,'已达今日最高波数，不可扫荡'),(610,'err610_is_max_point',6100084,'未达到记录点，不可扫荡'),(610,'err610_not_unlock',6100085,'塔未解锁'),(610,'err610_please_got_sweep_reward',6100086,'请先领取每日奖励'),(610,'err610_rune_power_not_enough',6100087,'符文印记战力不足'),(610,'err610_got_tomorrow',6100088,'跨天才能领取'),(610,'err610_not_unlock_condition',6100089,'未达到解锁的条件'),(610,'err610_has_unlock',6100090,'该塔已经解锁'),(610,'err610_please_got_stage_reward',6100091,'请先领取完阶段奖励'),(621,'err621_not_kf_1vn_challenger',6210001,'不是跨服1vn的挑战者'),(621,'err621_turn_not_enough',6210002,'参与过的比赛轮数不足'),(621,'err621_no_bet_self',6210003,'不能投注自己那场'),(621,'err621_no_sign',6210004,'您未报名，无法参与活动'),(621,'err621_has_betted',6210005,'您已押注过'),(621,'err621_no_enter',6210006,'不在活动中'),(621,'err621_not_battle',6210007,'未找到该场比赛'),(621,'err621_battle_is_end',6210008,'该场比赛已结束'),(621,'err621_not_match_yet',6210009,'暂未匹配到对手，请耐心等待'),(621,'err621_goods_not_enough',6210010,'道具不足'),(621,'err621_watch_max_num',6210011,'已达到最大观战人数'),(621,'err621_not_bet_stage',6210012,'当前阶段不可竞猜'),(621,'err621_is_signed',6210013,'您已报名'),(621,'err621_in_kf_1vn',6210014,'正在跨服1vn活动中'),(621,'err621_not_in_race_2',6210015,'不在守擂赛准备阶段，不可进入'),(621,'err621_not_kf_1vn_def',6210016,'不是跨服1vn的擂主'),(621,'err621_not_kf_1vn_area',6210017,'不在该赛区'),(621,'err621_shop_not_open',6210018,'跨服1vn商城未开启'),(621,'err621_min_auction_price',6210019,'本次竞拍的最小加价为{1}'),(621,'err621_not_in_pre_scene',6210020,'不在备战区'),(621,'err621_auction_close',6210021,'拍卖尚未开启'),(647,'err647_lv_not_enough',6470001,'公会等级不足'),(647,'err647_not_has_guild',6470002,'你没有参加任何公会'),(647,'err647_activity_not_open',6470003,'公会试炼活动还没开始'),(647,'err647_not_in_safe_area',6470004,'主城和安全区才可以前往活动'),(647,'err647_not_in_guild_war',6470005,'不在公会试炼中'),(647,'err647_in_guild_war',6470006,'已在活动中'),(647,'err647_forbid_enter_again',6470007,'活动期间不能以新公会再次进入'),(647,'err647_self_guild_is_over',6470008,'您公会的试炼活动已经结束'),(650,'err650_kf_3v3_in_kill_scene',6500001,'杀戮战场不能进入3v3'),(650,'err650_kf_3v3_not_conn',6500002,'连接不上跨服中心'),(650,'err650_kf_3v3_lack_wincount',6500003,'未达领取条件'),(650,'err650_kf_3v3_lack_reward',6500004,'无奖励可领取'),(650,'err650_kf_3v3_is_packed',6500005,'已领取奖励'),(650,'err650_kf_3v3_kick_self',6500006,'不能踢出自己'),(650,'err650_kf_3v3_long_pasm',6500007,'密码长度超长'),(650,'err650_kf_3v3_come_to_end',6500008,'活动即将结束不可进入战斗'),(650,'err650_kf_3v3_watting',6500009,'等待回复'),(650,'err650_kf_3v3_not_start',6500010,'活动还未开始'),(650,'err650_kf_3v3_delete_team',6500011,'删除单个队伍'),(650,'err650_kf_3v3_update_team',6500012,'刷新单个队伍'),(650,'err650_kf_3v3_update_teamlist',6500013,'刷新队列'),(650,'err650_kf_3v3_low_power',6500014,'战力不足'),(650,'err650_kf_3v3_low_lv',6500015,'等级不足'),(650,'err650_kf_3v3_wrong_pswd',6500016,'密码不对'),(650,'err650_kf_3v3_no_member',6500017,'该玩家不在队伍中'),(650,'err650_kf_3v3_war_end',6500018,'战争已结束'),(650,'err650_kf_3v3_not_joined',6500019,'未加入队伍'),(650,'err650_kf_3v3_cannot_reset_ready',6500020,'队长不能取消准备'),(650,'err650_kf_3v3_not_ready',6500021,'有玩家未准备好'),(650,'err650_kf_3v3_matching',6500022,'已在匹配队伍中'),(650,'err650_kf_3v3_lack_member',6500023,'人数不足，无法开始'),(650,'err650_kf_3v3_fighting',6500024,'战斗中，请稍后再操作'),(650,'err650_kf_3v3_not_captain',6500025,'不是队长，没有权限开始匹配'),(650,'err650_kf_3v3_no_team',6500026,'队伍已解散'),(650,'err650_kf_3v3_full_member',6500027,'队伍已满员'),(650,'err650_kf_3v3_in_team',6500028,'已有队伍'),(650,'err650_in_kf_3v3_act',6500029,'正在3v3队伍中'),(650,'err650_kf_3v3_lack_count',6500030,'参与次数不足'),(650,'err650_tier_not_enough',6500031,'3v3段位不足，无法兑换'),(650,'err650_hornor_limit',6500032,'声望不足，参加3V3可以获得更多声望哦'),(650,'err650_kf_3v3_call_member_full',6500033,'队伍已满员，无用招募了'),(132,'err132_no_redemption_exp',132000001,'没有离线经验可赎回');
/*!40000 ALTER TABLE `base_error_code` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_eternal_valley_chapter`
--

DROP TABLE IF EXISTS `base_eternal_valley_chapter`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_eternal_valley_chapter` (
  `id` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '章节id',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '章节名字@lang@',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '描述@lang@',
  `pyx_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '解锁圣器id',
  `skill_list` varchar(255) NOT NULL DEFAULT '' COMMENT '解锁技能列表',
  `skill_desc` varchar(255) NOT NULL DEFAULT '' COMMENT '技能效果描述',
  `condition` varchar(255) NOT NULL DEFAULT '[]' COMMENT '章节解锁条件',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='永恒碑谷章节配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_eternal_valley_chapter`
--

LOCK TABLES `base_eternal_valley_chapter` WRITE;
/*!40000 ALTER TABLE `base_eternal_valley_chapter` DISABLE KEYS */;
INSERT INTO `base_eternal_valley_chapter` VALUES (1,'恶魔契约','<color=\'#31ee4a\'>完成任务</color>，收集石碑碎片，领取所有奖励后激活<color=\'#31ee4a\'>荆棘石碑</color>，获得技能<color=\'#31ee4a\'>【勇者无畏】</color>',9,'[11000002]','增加30%人物经验获得','[]'),(2,'镇魂十字','<color=\'#31ee4a\'>提升防御</color>，收集石碑碎片，领取所有奖励后激活<color=\'#31ee4a\'>生命石碑</color>，获得技能<color=\'#31ee4a\'>【虔信誓语】</color>',6,'[14000001]','每10秒回复玩家5%的生命','[1]'),(3,'起源之火','<color=\'#31ee4a\'>收集装备</color>，收集石碑碎片，领取所有奖励后激活<color=\'#31ee4a\'>智者石碑</color>，获得技能<color=\'#31ee4a\'>【智者顿悟】</color>',3,'[11000013]','血量低于25%时，暴击提高20%，持续10秒','[2]'),(4,'死亡圣杯','<color=\'#31ee4a\'>击败boss</color>，收集石碑碎片，领取所有奖励后激活<color=\'#31ee4a\'>强者石碑</color>，获得技能<color=\'#31ee4a\'>【强者之殇】</color>',10,'[11000009]','攻击时有5%概率使敌人减速10%，持续3秒','[3]'),(5,'冥府之钥','<color=\'#31ee4a\'>锻造装备</color>，收集石碑碎片，领取所有奖励后激活<color=\'#31ee4a\'>固守石碑</color>，获得技能<color=\'#31ee4a\'>【不灭希望】</color>',11,'[11000012]','攻击时有5%的概率提高自己3%的破甲，持续5秒','[]');
/*!40000 ALTER TABLE `base_eternal_valley_chapter` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_eternal_valley_stage`
--

DROP TABLE IF EXISTS `base_eternal_valley_stage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_eternal_valley_stage` (
  `chapter` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '章节id',
  `stage` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '阶段',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '描述@lang@',
  `condition` varchar(255) NOT NULL DEFAULT '[]' COMMENT '条件',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `recommended_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT '推荐途径',
  PRIMARY KEY (`chapter`,`stage`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='永恒碑谷阶段配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_eternal_valley_stage`
--

LOCK TABLES `base_eternal_valley_stage` WRITE;
/*!40000 ALTER TABLE `base_eternal_valley_stage` DISABLE KEYS */;
INSERT INTO `base_eternal_valley_stage` VALUES (1,1,'全身装备总等级强化到<color=\'#4eae1a\'>10</color>级以上','[{equipment_sumstren_lv,10}]','[{3,36030001,20000}]','[152,1]'),(1,2,'全身装备总等级强化到<color=\'#4eae1a\'>30</color>级以上','[{equipment_sumstren_lv,30}]','[{3,36030001,25000}]','[152,1]'),(1,3,'全身装备总等级强化到<color=\'#4eae1a\'>45</color>级以上','[{equipment_sumstren_lv,45}]','[{3,36030001,30000}]','[152,1]'),(1,4,'全身装备总等级强化到<color=\'#4eae1a\'>60</color>级以上','[{equipment_sumstren_lv,60}]','[{3,36030001,35000}]','[152,1]'),(1,5,'全身装备总等级强化到<color=\'#4eae1a\'>75</color>级以上','[{equipment_sumstren_lv,75}]','[{3,36030001,40000}]','[152,1]'),(1,6,'全身装备总等级强化到<color=\'#4eae1a\'>90</color>级以上','[{equipment_sumstren_lv,90}]','[{3,36030001,45000}]','[152,1]'),(1,7,'全身装备总等级强化到<color=\'#4eae1a\'>105</color>级以上','[{equipment_sumstren_lv,105}]','[{3,36030001,50000}]','[152,1]'),(1,8,'全身装备总等级强化到<color=\'#4eae1a\'>120</color>级以上','[{equipment_sumstren_lv,120}]','[{3,36030001,55000}]','[152,1]'),(2,1,'穿戴<color=\'#4eae1a\'>4</color>阶<color=\'#d146ff\'>橙1星</color>以上护腕','[{equip,8,4,3}]','[{0,17010001,20}]','[460,1]'),(2,2,'穿戴<color=\'#4eae1a\'>5</color>阶<color=\'#d146ff\'>橙1星</color>以上鞋子','[{equip,10,5,3}]','[{0,11020001,5}]','[460,1]'),(2,3,'穿戴<color=\'#4eae1a\'>5</color>阶<color=\'#d146ff\'>橙1星</color>以上头盔','[{equip,2,5,3}]','[{0,24010001,5}]','[460,1]'),(2,4,'穿戴<color=\'#4eae1a\'>5</color>阶<color=\'#d146ff\'>橙1星</color>以上衣服','[{equip,4,5,3}]','[{0,15020101,5}]','[460,1]'),(2,5,'穿戴<color=\'#4eae1a\'>5</color>阶<color=\'#d146ff\'>橙1星</color>以上裤子','[{equip,6,5,3}]','[{0,18020001,5}]','[460,1]'),(2,6,'穿戴<color=\'#4eae1a\'>5</color>阶<color=\'#d146ff\'>红1星</color>以上武器','[{equip,1,5,4}]','[{0,16020001,5}]','[460,1]'),(3,1,'获得掉落归属：日落遗迹<color=\'#4eae1a\'>海龙王[非和平]</color>','[{boss,[1203001]}]','[{3,36030001,100000}]','[460,1,1203001,2]'),(3,2,'获得掉落归属：日落遗迹<color=\'#4eae1a\'>蜘蛛女皇[非和平]</color>','[{boss,[1203005]}]','[{3,36030001,130000}]','[460,1,1203005,2]'),(3,3,'获得掉落归属：日落遗迹<color=\'#4eae1a\'>愤怒[非和平]</color>','[{boss,[1203007]}]','[{3,36030001,150000}]','[460,1,1203007,2]'),(3,4,'获得掉落归属：日落遗迹<color=\'#4eae1a\'>怠惰[非和平]</color>','[{boss,[1203009]}]','[{2,36020001,40}]','[460,1,1203009,2]'),(3,5,'获得掉落归属：日落遗迹<color=\'#4eae1a\'>嫉妒[非和平]</color>','[{boss,[1203011]}]','[{2,36020001,40}]','[460,1,1203011,2]'),(3,6,'获得掉落归属：日落遗迹<color=\'#4eae1a\'>色欲</color>','[{boss,[1203014]}]','[{2,36020001,40}]','[460,1,1203014,2]'),(4,1,'<color=\'#4eae1a\'>护腕</color>锻造至<color=\'#4eae1a\'>史诗</color>套装','[{equip_suit,8,1}]','[{2,36020001,60}]','[152,7]'),(4,2,'<color=\'#4eae1a\'>鞋子</color>锻造至<color=\'#4eae1a\'>史诗</color>套装','[{equip_suit,10,1}]','[{2,36020001,60}]','[152,7]'),(4,3,'<color=\'#4eae1a\'>头盔</color>锻造至<color=\'#4eae1a\'>史诗</color>套装','[{equip_suit,2,1}]','[{2,36020001,60}]','[152,7]'),(4,4,'<color=\'#4eae1a\'>衣服</color>锻造至<color=\'#4eae1a\'>史诗</color>套装','[{equip_suit,4,1}]','[{2,36020001,60}]','[152,7]'),(4,5,'<color=\'#4eae1a\'>裤子</color>锻造至<color=\'#4eae1a\'>史诗</color>套装','[{equip_suit,6,1}]','[{2,36020001,60}]','[152,7]'),(4,6,'<color=\'#4eae1a\'>武器</color>锻造至<color=\'#4eae1a\'>史诗</color>套装','[{equip_suit,1,1}]','[{2,36020001,80}]','[152,7]'),(5,1,'完成<color=\'#4eae1a\'>首充</color>','[{first_recharge}]','[{2,36020001,50}]','[999,8]'),(5,2,'穿戴<color=\'#4eae1a\'>经验馆主</color>或<color=\'#4eae1a\'>白羊天使</color>','[{equip_ids,[1011000001,1011000002]}]','[{2,36020001,25}]','[153,2,1011000001]'),(5,3,'成为<color=\'#4eae1a\'>贵族2</color>','[{vip, 2}]','[{2,36020001,50}]','[159,2]'),(5,4,'成为<color=\'#4eae1a\'>贵族3</color>','[{vip,3}]','[{2,36020001,75}]','[159,2]'),(5,5,'成为<color=\'#4eae1a\'>贵族4</color>','[{vip,4}]','[{2,36020001,100}]','[159,2]'),(5,6,'购买1张<color=\'#4eae1a\'>月卡</color>','[{month_card}]','[{2,36020001,125}]','[159,5]'),(5,7,'购买任意一种<color=\'#4eae1a\'>投资计划</color>','[{diamond_investment}]','[{2,36020001,150}]','[159,6]');
/*!40000 ALTER TABLE `base_eternal_valley_stage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_exp`
--

DROP TABLE IF EXISTS `base_exp`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_exp` (
  `lv` int(11) NOT NULL COMMENT '等级',
  `exp` bigint(20) NOT NULL COMMENT '经验',
  PRIMARY KEY (`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='经验表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_exp`
--

LOCK TABLES `base_exp` WRITE;
/*!40000 ALTER TABLE `base_exp` DISABLE KEYS */;
INSERT INTO `base_exp` VALUES (1,800),(2,1000),(3,1500),(4,2500),(5,4000),(6,6000),(7,8500),(8,11500),(9,15000),(10,19000),(11,23500),(12,28500),(13,34000),(14,40000),(15,46500),(16,53500),(17,61000),(18,69000),(19,77500),(20,86500),(21,96000),(22,106000),(23,116500),(24,127500),(25,139000),(26,151000),(27,163500),(28,176500),(29,190000),(30,204000),(31,218500),(32,233500),(33,249000),(34,265000),(35,281500),(36,298500),(37,316000),(38,334000),(39,352500),(40,371500),(41,391000),(42,411000),(43,431500),(44,452500),(45,474000),(46,496000),(47,518500),(48,541500),(49,565000),(50,589000),(51,613500),(52,638500),(53,664000),(54,690000),(55,716500),(56,743500),(57,771000),(58,799000),(59,827500),(60,856500),(61,886000),(62,916000),(63,946500),(64,977500),(65,1009000),(66,1041000),(67,1073500),(68,1106500),(69,1140000),(70,1174000),(71,1208500),(72,1243500),(73,1279000),(74,1315000),(75,1351500),(76,1388500),(77,1426000),(78,1464000),(79,1502500),(80,1541500),(81,1581000),(82,1621000),(83,1661500),(84,1702500),(85,1744000),(86,1786000),(87,1828500),(88,1871500),(89,1915000),(90,1959000),(91,2003500),(92,2048500),(93,2094000),(94,2140000),(95,2186500),(96,2233500),(97,2281000),(98,2329000),(99,2377500),(100,2426500),(101,2476000),(102,2526000),(103,2576500),(104,2627500),(105,2679000),(106,2731000),(107,2783500),(108,2836500),(109,2890000),(110,2944000),(111,2998500),(112,3053500),(113,3109000),(114,3165000),(115,3221500),(116,3278500),(117,3336000),(118,3394000),(119,3452500),(120,3511500),(121,3571000),(122,3631000),(123,3691500),(124,3752500),(125,3814000),(126,3876000),(127,3938500),(128,4001500),(129,4065000),(130,4129000),(131,4193500),(132,4258500),(133,4324000),(134,4390000),(135,4456500),(136,4523500),(137,4591000),(138,4659000),(139,4727500),(140,4796500),(141,4866000),(142,4936000),(143,5006500),(144,5077500),(145,5149000),(146,5221000),(147,5293500),(148,5366500),(149,5440000),(150,5514000),(151,5588500),(152,5663500),(153,5739000),(154,5815000),(155,5891500),(156,5968500),(157,6046000),(158,6124000),(159,6202500),(160,6281500),(161,6361000),(162,6441000),(163,6521500),(164,6602500),(165,6684000),(166,6766000),(167,6848500),(168,6931500),(169,7015000),(170,7099000),(171,7183500),(172,7268500),(173,7354000),(174,7440000),(175,7526500),(176,7613500),(177,7701000),(178,7789000),(179,7877500),(180,7966500),(181,8056000),(182,8146000),(183,8236500),(184,8327500),(185,8419000),(186,8511000),(187,8603500),(188,8696500),(189,8790000),(190,8884000),(191,8978500),(192,9073500),(193,9169000),(194,9265000),(195,9361500),(196,9458500),(197,9556000),(198,9654000),(199,9752500),(200,9851500),(201,9951000),(202,10051000),(203,10151500),(204,10252500),(205,10354000),(206,10456000),(207,10558500),(208,10661500),(209,10765000),(210,10869000),(211,10973500),(212,11078500),(213,11184000),(214,11290000),(215,11396500),(216,11503500),(217,11611000),(218,11719000),(219,11827500),(220,11936500),(221,12046000),(222,12156000),(223,12266500),(224,12377500),(225,12489000),(226,12601000),(227,12713500),(228,12826500),(229,12940000),(230,15528000),(231,18633600),(232,22360320),(233,26832384),(234,29515622),(235,29632122),(236,29749122),(237,29866622),(238,29984622),(239,30103122),(240,30222122),(241,30341622),(242,30461622),(243,30582122),(244,30703122),(245,30824622),(246,30946622),(247,31069122),(248,31192122),(249,31315622),(250,31439622),(251,31564122),(252,31689122),(253,31814622),(254,31940622),(255,32067122),(256,32194122),(257,32321622),(258,32449622),(259,32578122),(260,32707122),(261,32836622),(262,32966622),(263,33097122),(264,33228122),(265,33359622),(266,33491622),(267,33624122),(268,33757122),(269,33890622),(270,45890622),(271,46025122),(272,46160122),(273,46295622),(274,46431622),(275,46568122),(276,46705122),(277,46842622),(278,46980622),(279,47119122),(280,57119122),(281,57258622),(282,57398622),(283,57539122),(284,57680122),(285,57821622),(286,57963622),(287,58106122),(288,58249122),(289,58392622),(290,72392622),(291,72537122),(292,72682122),(293,72827622),(294,72973622),(295,73120122),(296,73267122),(297,73414622),(298,73562622),(299,73711122),(300,73860122),(301,74009622),(302,74159622),(303,74310122),(304,74461122),(305,74612622),(306,74764622),(307,74917122),(308,75070122),(309,75223622),(310,110223622),(311,110378122),(312,110533122),(313,110688622),(314,110844622),(315,111001122),(316,111158122),(317,111315622),(318,111473622),(319,111632122),(320,156632122),(321,156791622),(322,156951622),(323,157112122),(324,157273122),(325,157434622),(326,157596622),(327,157759122),(328,157922122),(329,158085622),(330,166085622),(331,166250122),(332,166415122),(333,166580622),(334,166746622),(335,166913122),(336,167080122),(337,167247622),(338,167415622),(339,167584122),(340,222584122),(341,222753622),(342,222923622),(343,223094122),(344,223265122),(345,223436622),(346,223608622),(347,223781122),(348,223954122),(349,224127622),(350,299127622),(351,299302122),(352,299477122),(353,299652622),(354,299828622),(355,300005122),(356,300182122),(357,300359622),(358,300537622),(359,300716122),(360,350716122),(361,400716122),(362,450716122),(363,500716122),(364,550716122),(365,600716122),(366,650716122),(367,700716122),(368,750716122),(369,800716122),(370,850716122),(371,851716122),(372,852716122),(373,853716122),(374,854716122),(375,855716122),(376,856716122),(377,857716122),(378,858716122),(379,859716122),(380,869716122),(381,879716122),(382,889716122),(383,899716122),(384,909716122),(385,919716122),(386,929716122),(387,939716122),(388,949716122),(389,959716122),(390,969716122),(391,979716122),(392,989716122),(393,999716122),(394,1009716122),(395,1019716122),(396,1029716122),(397,1039716122),(398,1049716122),(399,1059716122),(400,1069716122),(401,1079716122),(402,1089716122),(403,1099716122),(404,1109716122),(405,1119716122),(406,1129716122),(407,1139716122),(408,1149716122),(409,1159716122),(410,1169716122),(411,1179716122),(412,1189716122),(413,1199716122),(414,1209716122),(415,1219716122),(416,1229716122),(417,1239716122),(418,1249716122),(419,1259716122),(420,1269716122),(421,1279716122),(422,1289716122),(423,1299716122),(424,1309716122),(425,1319716122),(426,1329716122),(427,1339716122),(428,1349716122),(429,1359716122),(430,1369716122),(431,1379716122),(432,1389716122),(433,1399716122),(434,1409716122),(435,1419716122),(436,1429716122),(437,1439716122),(438,1449716122),(439,1459716122),(440,1469716122),(441,1589716122),(442,1709716122),(443,1829716122),(444,1949716122),(445,2069716122),(446,2189716122),(447,2309716122),(448,2429716122),(449,2549716122),(450,2559716122),(451,2569716122),(452,2579716122),(453,2589716122),(454,2599716122),(455,2609716122),(456,2619716122),(457,2629716122),(458,2639716122),(459,2649716122),(460,2659716122),(461,2669716122),(462,2679716122),(463,2689716122),(464,2699716122),(465,2709716122),(466,2719716122),(467,2729716122),(468,2739716122),(469,2749716122),(470,2759716122),(471,2769716122),(472,2779716122),(473,2789716122),(474,2799716122),(475,2809716122),(476,2819716122),(477,2829716122),(478,2839716122),(479,2849716122),(480,2859716122),(481,2869716122),(482,2879716122),(483,2889716122),(484,2899716122),(485,2909716122),(486,2919716122),(487,2929716122),(488,2939716122),(489,2949716122),(490,2959716122),(491,2969716122),(492,2979716122),(493,2989716122),(494,2999716122),(495,3009716122),(496,3019716122),(497,3029716122),(498,3039716122),(499,3049716122),(500,3059716122),(501,3069716122),(502,3079716122),(503,3089716122),(504,3099716122),(505,3109716122),(506,3119716122),(507,3129716122),(508,3139716122),(509,3149716122),(510,3159716122),(511,3169716122),(512,3179716122),(513,3189716122),(514,3199716122),(515,3209716122),(516,3219716122),(517,3229716122),(518,3239716122),(519,3249716122),(520,3259716122),(521,3289716122),(522,3319716122),(523,3349716122),(524,3379716122),(525,3409716122),(526,3439716122),(527,3469716122),(528,3499716122),(529,3529716122),(530,3929716122),(531,4329716122),(532,4729716122),(533,5129716122),(534,5529716122),(535,5929716122),(536,6329716122),(537,6729716122),(538,7129716122),(539,7529716122),(540,7569716122),(541,7609716122),(542,7649716122),(543,7689716122),(544,7729716122),(545,7769716122),(546,7809716122),(547,7849716122),(548,7889716122),(549,7929716122),(550,7969716122),(551,8009716122),(552,8049716122),(553,8089716122),(554,8129716122),(555,8169716122),(556,8209716122),(557,8249716122),(558,8289716122),(559,8329716122),(560,8369716122),(561,8409716122),(562,8449716122),(563,8489716122),(564,8529716122),(565,8569716122),(566,8609716122),(567,8649716122),(568,8689716122),(569,8729716122),(570,8769716122),(571,8809716122),(572,8849716122),(573,8889716122),(574,8929716122),(575,8969716122),(576,9009716122),(577,9049716122),(578,9089716122),(579,9129716122),(580,9169716122),(581,9209716122),(582,9249716122),(583,9289716122),(584,9329716122),(585,9369716122),(586,9409716122),(587,9449716122),(588,9489716122),(589,9529716122),(590,9569716122),(591,9609716122),(592,9649716122),(593,9689716122),(594,9729716122),(595,9769716122),(596,9809716122),(597,9849716122),(598,9889716122),(599,9929716122),(600,9969716122),(601,10009716122),(602,10049716122),(603,10089716122),(604,10129716122),(605,10169716122),(606,10209716122),(607,10249716122),(608,10289716122),(609,10329716122),(610,10369716122),(611,10409716122),(612,10449716122),(613,10489716122),(614,10529716122),(615,10569716122),(616,10609716122),(617,10649716122),(618,10689716122),(619,10729716122),(620,10769716122),(621,10809716122),(622,10849716122),(623,10889716122),(624,10929716122),(625,10969716122),(626,11009716122),(627,11049716122),(628,11089716122),(629,11129716122),(630,11169716122),(631,11209716122),(632,11249716122),(633,11289716122),(634,11329716122),(635,11369716122),(636,11409716122),(637,11449716122),(638,11489716122),(639,11529716122),(640,11569716122),(641,11609716122),(642,11649716122),(643,11689716122),(644,11729716122),(645,11769716122),(646,11809716122),(647,11849716122),(648,11889716122),(649,11929716122),(650,11969716122),(651,12009716122),(652,12049716122),(653,12089716122),(654,12129716122),(655,12169716122),(656,12209716122),(657,12249716122),(658,12289716122),(659,12329716122),(660,12369716122),(661,12409716122),(662,12449716122),(663,12489716122),(664,12529716122),(665,12569716122),(666,12609716122),(667,12649716122),(668,12689716122),(669,12729716122),(670,12769716122),(671,12809716122),(672,12849716122),(673,12889716122),(674,12929716122),(675,12969716122),(676,13009716122),(677,13049716122),(678,13089716122),(679,13129716122),(680,13169716122),(681,13209716122),(682,13249716122),(683,13289716122),(684,13329716122),(685,13369716122),(686,13409716122),(687,13449716122),(688,13489716122),(689,13529716122),(690,13569716122),(691,13609716122),(692,13649716122),(693,13689716122),(694,13729716122),(695,13769716122),(696,13809716122),(697,13849716122),(698,13889716122),(699,13929716122),(700,13969716122),(701,14009716122),(702,14049716122),(703,14089716122),(704,14129716122),(705,14169716122),(706,14209716122),(707,14249716122),(708,14289716122),(709,14329716122),(710,14369716122),(711,14409716122),(712,14449716122),(713,14489716122),(714,14529716122),(715,14569716122),(716,14609716122),(717,14649716122),(718,14689716122),(719,14729716122),(720,14769716122),(721,14809716122),(722,14849716122),(723,14889716122),(724,14929716122),(725,14969716122),(726,15009716122),(727,15049716122),(728,15089716122),(729,15129716122),(730,15169716122),(731,15209716122),(732,15249716122),(733,15289716122),(734,15329716122),(735,15369716122),(736,15409716122),(737,15449716122),(738,15489716122),(739,15529716122),(740,15569716122),(741,15609716122),(742,15649716122),(743,15689716122),(744,15729716122),(745,15769716122),(746,15809716122),(747,15849716122),(748,15889716122),(749,15929716122),(750,15969716122),(751,16009716122),(752,16049716122),(753,16089716122),(754,16129716122),(755,16169716122),(756,16209716122),(757,16249716122),(758,16289716122),(759,16329716122),(760,16369716122),(761,16409716122),(762,16449716122),(763,16489716122),(764,16529716122),(765,16569716122),(766,16609716122),(767,16649716122),(768,16689716122),(769,16729716122),(770,16769716122),(771,16809716122),(772,16849716122),(773,16889716122),(774,16929716122),(775,16969716122),(776,17009716122),(777,17049716122),(778,17089716122),(779,17129716122),(780,17169716122),(781,17209716122),(782,17249716122),(783,17289716122),(784,17329716122),(785,17369716122),(786,17409716122),(787,17449716122),(788,17489716122),(789,17529716122),(790,17569716122),(791,17609716122),(792,17649716122),(793,17689716122),(794,17729716122),(795,17769716122),(796,17809716122),(797,17849716122),(798,17889716122),(799,17929716122),(800,17969716122),(801,18009716122),(802,18049716122),(803,18089716122),(804,18129716122),(805,18169716122),(806,18209716122),(807,18249716122),(808,18289716122),(809,18329716122),(810,18369716122),(811,18409716122),(812,18449716122),(813,18489716122),(814,18529716122),(815,18569716122),(816,18609716122),(817,18649716122),(818,18689716122),(819,18729716122),(820,18769716122),(821,18809716122),(822,18849716122),(823,18889716122),(824,18929716122),(825,18969716122),(826,19009716122),(827,19049716122),(828,19089716122),(829,19129716122),(830,19169716122),(831,19209716122),(832,19249716122),(833,19289716122),(834,19329716122),(835,19369716122),(836,19409716122),(837,19449716122),(838,19489716122),(839,19529716122),(840,19569716122),(841,19609716122),(842,19649716122),(843,19689716122),(844,19729716122),(845,19769716122),(846,19809716122),(847,19849716122),(848,19889716122),(849,19929716122),(850,19969716122),(851,20009716122),(852,20049716122),(853,20089716122),(854,20129716122),(855,20169716122),(856,20209716122),(857,20249716122),(858,20289716122),(859,20329716122),(860,20369716122),(861,20409716122),(862,20449716122),(863,20489716122),(864,20529716122),(865,20569716122),(866,20609716122),(867,20649716122),(868,20689716122),(869,20729716122),(870,20769716122),(871,20809716122),(872,20849716122),(873,20889716122),(874,20929716122),(875,20969716122),(876,21009716122),(877,21049716122),(878,21089716122),(879,21129716122),(880,21169716122),(881,21209716122),(882,21249716122),(883,21289716122),(884,21329716122),(885,21369716122),(886,21409716122),(887,21449716122),(888,21489716122),(889,21529716122),(890,21569716122),(891,21609716122),(892,21649716122),(893,21689716122),(894,21729716122),(895,21769716122),(896,21809716122),(897,21849716122),(898,21889716122),(899,21929716122),(900,21969716122),(901,22009716122),(902,22049716122),(903,22089716122),(904,22129716122),(905,22169716122),(906,22209716122),(907,22249716122),(908,22289716122),(909,22329716122),(910,22369716122),(911,22409716122),(912,22449716122),(913,22489716122),(914,22529716122),(915,22569716122),(916,22609716122),(917,22649716122),(918,22689716122),(919,22729716122),(920,22769716122),(921,22809716122),(922,22849716122),(923,22889716122),(924,22929716122),(925,22969716122),(926,23009716122),(927,23049716122),(928,23089716122),(929,23129716122),(930,23169716122),(931,23209716122),(932,23249716122),(933,23289716122),(934,23329716122),(935,23369716122),(936,23409716122),(937,23449716122),(938,23489716122),(939,23529716122),(940,23569716122),(941,23609716122),(942,23649716122),(943,23689716122),(944,23729716122),(945,23769716122),(946,23809716122),(947,23849716122),(948,23889716122),(949,23929716122),(950,23969716122),(951,24009716122),(952,24049716122),(953,24089716122),(954,24129716122),(955,24169716122),(956,24209716122),(957,24249716122),(958,24289716122),(959,24329716122),(960,24369716122),(961,24409716122),(962,24449716122),(963,24489716122),(964,24529716122),(965,24569716122),(966,24609716122),(967,24649716122),(968,24689716122),(969,24729716122),(970,24769716122),(971,24809716122),(972,24849716122),(973,24889716122),(974,24929716122),(975,24969716122),(976,25009716122),(977,25049716122),(978,25089716122),(979,25129716122),(980,25169716122),(981,25209716122),(982,25249716122),(983,25289716122),(984,25329716122),(985,25369716122),(986,25409716122),(987,25449716122),(988,25489716122),(989,25529716122),(990,25569716122),(991,25609716122),(992,25649716122),(993,25689716122),(994,25729716122),(995,25769716122),(996,25809716122),(997,25849716122),(998,25889716122),(999,25929716122),(1000,0);
/*!40000 ALTER TABLE `base_exp` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_exp_add`
--

DROP TABLE IF EXISTS `base_exp_add`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_exp_add` (
  `min_server_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小世界等级',
  `max_server_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大世界等级',
  `min_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小玩家等级',
  `max_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大玩家等级',
  `exp_add` int(11) NOT NULL DEFAULT '0' COMMENT '经验加成百分比',
  UNIQUE KEY `min_gap` (`min_server_lv`,`max_server_lv`,`min_lv`,`max_lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='经验加成配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_exp_add`
--

LOCK TABLES `base_exp_add` WRITE;
/*!40000 ALTER TABLE `base_exp_add` DISABLE KEYS */;
INSERT INTO `base_exp_add` VALUES (0,150,0,1000,0),(151,155,0,1000,0),(156,160,0,150,0),(156,160,151,1000,0),(161,165,0,150,0),(161,165,151,155,0),(161,165,156,1000,0),(166,170,0,150,0),(166,170,151,155,0),(166,170,156,160,0),(166,170,161,1000,0),(171,175,0,150,0),(171,175,151,155,30),(171,175,156,160,0),(171,175,161,165,0),(171,175,166,1000,0),(176,180,0,150,0),(176,180,151,155,38),(176,180,156,160,30),(176,180,161,165,0),(176,180,166,170,0),(176,180,171,1000,0),(181,185,0,150,0),(181,185,151,155,45),(181,185,156,160,38),(181,185,161,165,30),(181,185,166,170,0),(181,185,171,175,0),(181,185,176,1000,0),(186,190,0,150,0),(186,190,151,155,53),(186,190,156,160,45),(186,190,161,165,38),(186,190,166,170,30),(186,190,171,175,0),(186,190,176,180,0),(186,190,181,1000,0),(191,195,0,150,0),(191,195,151,155,60),(191,195,156,160,53),(191,195,161,165,45),(191,195,166,170,38),(191,195,171,175,30),(191,195,176,180,0),(191,195,181,185,0),(191,195,186,1000,0),(196,200,0,150,0),(196,200,151,155,68),(196,200,156,160,60),(196,200,161,165,53),(196,200,166,170,45),(196,200,171,175,38),(196,200,176,180,30),(196,200,181,185,0),(196,200,186,190,0),(196,200,191,1000,0),(201,205,0,150,0),(201,205,151,155,75),(201,205,156,160,68),(201,205,161,165,60),(201,205,166,170,53),(201,205,171,175,45),(201,205,176,180,38),(201,205,181,185,30),(201,205,186,190,0),(201,205,191,195,0),(201,205,196,1000,0),(206,210,0,150,0),(206,210,151,155,83),(206,210,156,160,75),(206,210,161,165,68),(206,210,166,170,60),(206,210,171,175,53),(206,210,176,180,45),(206,210,181,185,38),(206,210,186,190,30),(206,210,191,195,0),(206,210,196,200,0),(206,210,201,1000,0),(211,215,0,150,0),(211,215,151,155,90),(211,215,156,160,83),(211,215,161,165,75),(211,215,166,170,68),(211,215,171,175,60),(211,215,176,180,53),(211,215,181,185,45),(211,215,186,190,38),(211,215,191,195,30),(211,215,196,200,0),(211,215,201,205,0),(211,215,206,1000,0),(216,220,0,150,0),(216,220,151,155,98),(216,220,156,160,90),(216,220,161,165,83),(216,220,166,170,75),(216,220,171,175,68),(216,220,176,180,60),(216,220,181,185,53),(216,220,186,190,45),(216,220,191,195,38),(216,220,196,200,30),(216,220,201,205,0),(216,220,206,210,0),(216,220,211,1000,0),(221,225,0,150,0),(221,225,151,155,105),(221,225,156,160,98),(221,225,161,165,90),(221,225,166,170,83),(221,225,171,175,75),(221,225,176,180,68),(221,225,181,185,60),(221,225,186,190,53),(221,225,191,195,45),(221,225,196,200,38),(221,225,201,205,30),(221,225,206,210,0),(221,225,211,215,0),(221,225,216,1000,0),(226,230,0,150,0),(226,230,151,155,113),(226,230,156,160,105),(226,230,161,165,98),(226,230,166,170,90),(226,230,171,175,83),(226,230,176,180,75),(226,230,181,185,68),(226,230,186,190,60),(226,230,191,195,53),(226,230,196,200,45),(226,230,201,205,38),(226,230,206,210,30),(226,230,211,215,0),(226,230,216,220,0),(226,230,221,1000,0),(231,235,0,150,0),(231,235,151,155,120),(231,235,156,160,113),(231,235,161,165,105),(231,235,166,170,98),(231,235,171,175,90),(231,235,176,180,83),(231,235,181,185,75),(231,235,186,190,68),(231,235,191,195,60),(231,235,196,200,53),(231,235,201,205,45),(231,235,206,210,38),(231,235,211,215,30),(231,235,216,220,0),(231,235,221,225,0),(231,235,226,1000,0),(236,240,0,150,0),(236,240,151,155,128),(236,240,156,160,120),(236,240,161,165,113),(236,240,166,170,105),(236,240,171,175,98),(236,240,176,180,90),(236,240,181,185,83),(236,240,186,190,75),(236,240,191,195,68),(236,240,196,200,60),(236,240,201,205,53),(236,240,206,210,45),(236,240,211,215,38),(236,240,216,220,30),(236,240,221,225,0),(236,240,226,230,0),(236,240,231,1000,0),(241,245,0,150,0),(241,245,151,155,135),(241,245,156,160,128),(241,245,161,165,120),(241,245,166,170,113),(241,245,171,175,105),(241,245,176,180,98),(241,245,181,185,90),(241,245,186,190,83),(241,245,191,195,75),(241,245,196,200,68),(241,245,201,205,60),(241,245,206,210,53),(241,245,211,215,45),(241,245,216,220,38),(241,245,221,225,30),(241,245,226,230,0),(241,245,231,235,0),(241,245,236,1000,0),(246,250,0,150,0),(246,250,151,155,143),(246,250,156,160,135),(246,250,161,165,128),(246,250,166,170,120),(246,250,171,175,113),(246,250,176,180,105),(246,250,181,185,98),(246,250,186,190,90),(246,250,191,195,83),(246,250,196,200,75),(246,250,201,205,68),(246,250,206,210,60),(246,250,211,215,53),(246,250,216,220,45),(246,250,221,225,38),(246,250,226,230,30),(246,250,231,235,0),(246,250,236,240,0),(246,250,241,1000,0),(251,255,0,150,0),(251,255,151,155,150),(251,255,156,160,143),(251,255,161,165,135),(251,255,166,170,128),(251,255,171,175,120),(251,255,176,180,113),(251,255,181,185,105),(251,255,186,190,98),(251,255,191,195,90),(251,255,196,200,83),(251,255,201,205,75),(251,255,206,210,68),(251,255,211,215,60),(251,255,216,220,53),(251,255,221,225,45),(251,255,226,230,38),(251,255,231,235,30),(251,255,236,240,0),(251,255,241,245,0),(251,255,246,1000,0),(256,260,0,150,0),(256,260,151,155,158),(256,260,156,160,150),(256,260,161,165,143),(256,260,166,170,135),(256,260,171,175,128),(256,260,176,180,120),(256,260,181,185,113),(256,260,186,190,105),(256,260,191,195,98),(256,260,196,200,90),(256,260,201,205,83),(256,260,206,210,75),(256,260,211,215,68),(256,260,216,220,60),(256,260,221,225,53),(256,260,226,230,45),(256,260,231,235,38),(256,260,236,240,30),(256,260,241,245,0),(256,260,246,250,0),(256,260,251,1000,0),(261,265,0,150,0),(261,265,151,155,165),(261,265,156,160,158),(261,265,161,165,150),(261,265,166,170,143),(261,265,171,175,135),(261,265,176,180,128),(261,265,181,185,120),(261,265,186,190,113),(261,265,191,195,105),(261,265,196,200,98),(261,265,201,205,90),(261,265,206,210,83),(261,265,211,215,75),(261,265,216,220,68),(261,265,221,225,60),(261,265,226,230,53),(261,265,231,235,45),(261,265,236,240,38),(261,265,241,245,30),(261,265,246,250,0),(261,265,251,255,0),(261,265,256,1000,0),(266,270,0,150,0),(266,270,151,155,173),(266,270,156,160,165),(266,270,161,165,158),(266,270,166,170,150),(266,270,171,175,143),(266,270,176,180,135),(266,270,181,185,128),(266,270,186,190,120),(266,270,191,195,113),(266,270,196,200,105),(266,270,201,205,98),(266,270,206,210,90),(266,270,211,215,83),(266,270,216,220,75),(266,270,221,225,68),(266,270,226,230,60),(266,270,231,235,53),(266,270,236,240,45),(266,270,241,245,38),(266,270,246,250,30),(266,270,251,255,0),(266,270,256,260,0),(266,270,261,1000,0),(271,275,0,150,0),(271,275,151,155,180),(271,275,156,160,173),(271,275,161,165,165),(271,275,166,170,158),(271,275,171,175,150),(271,275,176,180,143),(271,275,181,185,135),(271,275,186,190,128),(271,275,191,195,120),(271,275,196,200,113),(271,275,201,205,105),(271,275,206,210,98),(271,275,211,215,90),(271,275,216,220,83),(271,275,221,225,75),(271,275,226,230,68),(271,275,231,235,60),(271,275,236,240,53),(271,275,241,245,45),(271,275,246,250,38),(271,275,251,255,30),(271,275,256,260,0),(271,275,261,265,0),(271,275,266,1000,0),(276,280,0,150,0),(276,280,151,155,188),(276,280,156,160,180),(276,280,161,165,173),(276,280,166,170,165),(276,280,171,175,158),(276,280,176,180,150),(276,280,181,185,143),(276,280,186,190,135),(276,280,191,195,128),(276,280,196,200,120),(276,280,201,205,113),(276,280,206,210,105),(276,280,211,215,98),(276,280,216,220,90),(276,280,221,225,83),(276,280,226,230,75),(276,280,231,235,68),(276,280,236,240,60),(276,280,241,245,53),(276,280,246,250,45),(276,280,251,255,38),(276,280,256,260,30),(276,280,261,265,0),(276,280,266,270,0),(276,280,271,1000,0),(281,285,0,150,0),(281,285,151,155,195),(281,285,156,160,188),(281,285,161,165,180),(281,285,166,170,173),(281,285,171,175,165),(281,285,176,180,158),(281,285,181,185,150),(281,285,186,190,143),(281,285,191,195,135),(281,285,196,200,128),(281,285,201,205,120),(281,285,206,210,113),(281,285,211,215,105),(281,285,216,220,98),(281,285,221,225,90),(281,285,226,230,83),(281,285,231,235,75),(281,285,236,240,68),(281,285,241,245,60),(281,285,246,250,53),(281,285,251,255,45),(281,285,256,260,38),(281,285,261,265,30),(281,285,266,270,0),(281,285,271,275,0),(281,285,276,1000,0),(286,290,0,150,0),(286,290,151,155,203),(286,290,156,160,195),(286,290,161,165,188),(286,290,166,170,180),(286,290,171,175,173),(286,290,176,180,165),(286,290,181,185,158),(286,290,186,190,150),(286,290,191,195,143),(286,290,196,200,135),(286,290,201,205,128),(286,290,206,210,120),(286,290,211,215,113),(286,290,216,220,105),(286,290,221,225,98),(286,290,226,230,90),(286,290,231,235,83),(286,290,236,240,75),(286,290,241,245,68),(286,290,246,250,60),(286,290,251,255,53),(286,290,256,260,45),(286,290,261,265,38),(286,290,266,270,30),(286,290,271,275,0),(286,290,276,280,0),(286,290,281,1000,0),(291,295,0,150,0),(291,295,151,155,210),(291,295,156,160,203),(291,295,161,165,195),(291,295,166,170,188),(291,295,171,175,180),(291,295,176,180,173),(291,295,181,185,165),(291,295,186,190,158),(291,295,191,195,150),(291,295,196,200,143),(291,295,201,205,135),(291,295,206,210,128),(291,295,211,215,120),(291,295,216,220,113),(291,295,221,225,105),(291,295,226,230,98),(291,295,231,235,90),(291,295,236,240,83),(291,295,241,245,75),(291,295,246,250,68),(291,295,251,255,60),(291,295,256,260,53),(291,295,261,265,45),(291,295,266,270,38),(291,295,271,275,30),(291,295,276,280,0),(291,295,281,285,0),(291,295,286,1000,0),(296,300,0,150,0),(296,300,151,155,218),(296,300,156,160,210),(296,300,161,165,203),(296,300,166,170,195),(296,300,171,175,188),(296,300,176,180,180),(296,300,181,185,173),(296,300,186,190,165),(296,300,191,195,158),(296,300,196,200,150),(296,300,201,205,143),(296,300,206,210,135),(296,300,211,215,128),(296,300,216,220,120),(296,300,221,225,113),(296,300,226,230,105),(296,300,231,235,98),(296,300,236,240,90),(296,300,241,245,83),(296,300,246,250,75),(296,300,251,255,68),(296,300,256,260,60),(296,300,261,265,53),(296,300,266,270,45),(296,300,271,275,38),(296,300,276,280,30),(296,300,281,285,0),(296,300,286,290,0),(296,300,291,1000,0),(301,305,0,150,0),(301,305,151,155,225),(301,305,156,160,218),(301,305,161,165,210),(301,305,166,170,203),(301,305,171,175,195),(301,305,176,180,188),(301,305,181,185,180),(301,305,186,190,173),(301,305,191,195,165),(301,305,196,200,158),(301,305,201,205,150),(301,305,206,210,143),(301,305,211,215,135),(301,305,216,220,128),(301,305,221,225,120),(301,305,226,230,113),(301,305,231,235,105),(301,305,236,240,98),(301,305,241,245,90),(301,305,246,250,83),(301,305,251,255,75),(301,305,256,260,68),(301,305,261,265,60),(301,305,266,270,53),(301,305,271,275,45),(301,305,276,280,38),(301,305,281,285,30),(301,305,286,290,0),(301,305,291,295,0),(301,305,296,1000,0),(306,310,0,150,0),(306,310,151,155,233),(306,310,156,160,225),(306,310,161,165,218),(306,310,166,170,210),(306,310,171,175,203),(306,310,176,180,195),(306,310,181,185,188),(306,310,186,190,180),(306,310,191,195,173),(306,310,196,200,165),(306,310,201,205,158),(306,310,206,210,150),(306,310,211,215,143),(306,310,216,220,135),(306,310,221,225,128),(306,310,226,230,120),(306,310,231,235,113),(306,310,236,240,105),(306,310,241,245,98),(306,310,246,250,90),(306,310,251,255,83),(306,310,256,260,75),(306,310,261,265,68),(306,310,266,270,60),(306,310,271,275,53),(306,310,276,280,45),(306,310,281,285,38),(306,310,286,290,30),(306,310,291,295,0),(306,310,296,300,0),(306,310,301,1000,0),(311,315,0,150,0),(311,315,151,155,240),(311,315,156,160,233),(311,315,161,165,225),(311,315,166,170,218),(311,315,171,175,210),(311,315,176,180,203),(311,315,181,185,195),(311,315,186,190,188),(311,315,191,195,180),(311,315,196,200,173),(311,315,201,205,165),(311,315,206,210,158),(311,315,211,215,150),(311,315,216,220,143),(311,315,221,225,135),(311,315,226,230,128),(311,315,231,235,120),(311,315,236,240,113),(311,315,241,245,105),(311,315,246,250,98),(311,315,251,255,90),(311,315,256,260,83),(311,315,261,265,75),(311,315,266,270,68),(311,315,271,275,60),(311,315,276,280,53),(311,315,281,285,45),(311,315,286,290,38),(311,315,291,295,30),(311,315,296,300,0),(311,315,301,305,0),(311,315,306,1000,0),(316,320,0,150,0),(316,320,151,155,248),(316,320,156,160,240),(316,320,161,165,233),(316,320,166,170,225),(316,320,171,175,218),(316,320,176,180,210),(316,320,181,185,203),(316,320,186,190,195),(316,320,191,195,188),(316,320,196,200,180),(316,320,201,205,173),(316,320,206,210,165),(316,320,211,215,158),(316,320,216,220,150),(316,320,221,225,143),(316,320,226,230,135),(316,320,231,235,128),(316,320,236,240,120),(316,320,241,245,113),(316,320,246,250,105),(316,320,251,255,98),(316,320,256,260,90),(316,320,261,265,83),(316,320,266,270,75),(316,320,271,275,68),(316,320,276,280,60),(316,320,281,285,53),(316,320,286,290,45),(316,320,291,295,38),(316,320,296,300,30),(316,320,301,305,0),(316,320,306,310,0),(316,320,311,1000,0),(321,325,0,150,0),(321,325,151,155,255),(321,325,156,160,248),(321,325,161,165,240),(321,325,166,170,233),(321,325,171,175,225),(321,325,176,180,218),(321,325,181,185,210),(321,325,186,190,203),(321,325,191,195,195),(321,325,196,200,188),(321,325,201,205,180),(321,325,206,210,173),(321,325,211,215,165),(321,325,216,220,158),(321,325,221,225,150),(321,325,226,230,143),(321,325,231,235,135),(321,325,236,240,128),(321,325,241,245,120),(321,325,246,250,113),(321,325,251,255,105),(321,325,256,260,98),(321,325,261,265,90),(321,325,266,270,83),(321,325,271,275,75),(321,325,276,280,68),(321,325,281,285,60),(321,325,286,290,53),(321,325,291,295,45),(321,325,296,300,38),(321,325,301,305,30),(321,325,306,310,0),(321,325,311,315,0),(321,325,316,1000,0),(326,330,0,150,0),(326,330,151,155,263),(326,330,156,160,255),(326,330,161,165,248),(326,330,166,170,240),(326,330,171,175,233),(326,330,176,180,225),(326,330,181,185,218),(326,330,186,190,210),(326,330,191,195,203),(326,330,196,200,195),(326,330,201,205,188),(326,330,206,210,180),(326,330,211,215,173),(326,330,216,220,165),(326,330,221,225,158),(326,330,226,230,150),(326,330,231,235,143),(326,330,236,240,135),(326,330,241,245,128),(326,330,246,250,120),(326,330,251,255,113),(326,330,256,260,105),(326,330,261,265,98),(326,330,266,270,90),(326,330,271,275,83),(326,330,276,280,75),(326,330,281,285,68),(326,330,286,290,60),(326,330,291,295,53),(326,330,296,300,45),(326,330,301,305,38),(326,330,306,310,30),(326,330,311,315,0),(326,330,316,320,0),(326,330,321,1000,0),(331,335,0,150,0),(331,335,151,155,270),(331,335,156,160,263),(331,335,161,165,255),(331,335,166,170,248),(331,335,171,175,240),(331,335,176,180,233),(331,335,181,185,225),(331,335,186,190,218),(331,335,191,195,210),(331,335,196,200,203),(331,335,201,205,195),(331,335,206,210,188),(331,335,211,215,180),(331,335,216,220,173),(331,335,221,225,165),(331,335,226,230,158),(331,335,231,235,150),(331,335,236,240,143),(331,335,241,245,135),(331,335,246,250,128),(331,335,251,255,120),(331,335,256,260,113),(331,335,261,265,105),(331,335,266,270,98),(331,335,271,275,90),(331,335,276,280,83),(331,335,281,285,75),(331,335,286,290,68),(331,335,291,295,60),(331,335,296,300,53),(331,335,301,305,45),(331,335,306,310,38),(331,335,311,315,30),(331,335,316,320,0),(331,335,321,325,0),(331,335,326,1000,0),(336,340,0,150,0),(336,340,151,155,278),(336,340,156,160,270),(336,340,161,165,263),(336,340,166,170,255),(336,340,171,175,248),(336,340,176,180,240),(336,340,181,185,233),(336,340,186,190,225),(336,340,191,195,218),(336,340,196,200,210),(336,340,201,205,203),(336,340,206,210,195),(336,340,211,215,188),(336,340,216,220,180),(336,340,221,225,173),(336,340,226,230,165),(336,340,231,235,158),(336,340,236,240,150),(336,340,241,245,143),(336,340,246,250,135),(336,340,251,255,128),(336,340,256,260,120),(336,340,261,265,113),(336,340,266,270,105),(336,340,271,275,98),(336,340,276,280,90),(336,340,281,285,83),(336,340,286,290,75),(336,340,291,295,68),(336,340,296,300,60),(336,340,301,305,53),(336,340,306,310,45),(336,340,311,315,38),(336,340,316,320,30),(336,340,321,325,0),(336,340,326,330,0),(336,340,331,1000,0),(341,345,0,150,0),(341,345,151,155,285),(341,345,156,160,278),(341,345,161,165,270),(341,345,166,170,263),(341,345,171,175,255),(341,345,176,180,248),(341,345,181,185,240),(341,345,186,190,233),(341,345,191,195,225),(341,345,196,200,218),(341,345,201,205,210),(341,345,206,210,203),(341,345,211,215,195),(341,345,216,220,188),(341,345,221,225,180),(341,345,226,230,173),(341,345,231,235,165),(341,345,236,240,158),(341,345,241,245,150),(341,345,246,250,143),(341,345,251,255,135),(341,345,256,260,128),(341,345,261,265,120),(341,345,266,270,113),(341,345,271,275,105),(341,345,276,280,98),(341,345,281,285,90),(341,345,286,290,83),(341,345,291,295,75),(341,345,296,300,68),(341,345,301,305,60),(341,345,306,310,53),(341,345,311,315,45),(341,345,316,320,38),(341,345,321,325,30),(341,345,326,330,0),(341,345,331,335,0),(341,345,336,1000,0),(346,350,0,150,0),(346,350,151,155,293),(346,350,156,160,285),(346,350,161,165,278),(346,350,166,170,270),(346,350,171,175,263),(346,350,176,180,255),(346,350,181,185,248),(346,350,186,190,240),(346,350,191,195,233),(346,350,196,200,225),(346,350,201,205,218),(346,350,206,210,210),(346,350,211,215,203),(346,350,216,220,195),(346,350,221,225,188),(346,350,226,230,180),(346,350,231,235,173),(346,350,236,240,165),(346,350,241,245,158),(346,350,246,250,150),(346,350,251,255,143),(346,350,256,260,135),(346,350,261,265,128),(346,350,266,270,120),(346,350,271,275,113),(346,350,276,280,105),(346,350,281,285,98),(346,350,286,290,90),(346,350,291,295,83),(346,350,296,300,75),(346,350,301,305,68),(346,350,306,310,60),(346,350,311,315,53),(346,350,316,320,45),(346,350,321,325,38),(346,350,326,330,30),(346,350,331,335,0),(346,350,336,340,0),(346,350,341,1000,0),(351,355,0,150,0),(351,355,151,155,300),(351,355,156,160,293),(351,355,161,165,285),(351,355,166,170,278),(351,355,171,175,270),(351,355,176,180,263),(351,355,181,185,255),(351,355,186,190,248),(351,355,191,195,240),(351,355,196,200,233),(351,355,201,205,225),(351,355,206,210,218),(351,355,211,215,210),(351,355,216,220,203),(351,355,221,225,195),(351,355,226,230,188),(351,355,231,235,180),(351,355,236,240,173),(351,355,241,245,165),(351,355,246,250,158),(351,355,251,255,150),(351,355,256,260,143),(351,355,261,265,135),(351,355,266,270,128),(351,355,271,275,120),(351,355,276,280,113),(351,355,281,285,105),(351,355,286,290,98),(351,355,291,295,90),(351,355,296,300,83),(351,355,301,305,75),(351,355,306,310,68),(351,355,311,315,60),(351,355,316,320,53),(351,355,321,325,45),(351,355,326,330,38),(351,355,331,335,30),(351,355,336,340,0),(351,355,341,345,0),(351,355,346,1000,0),(356,360,0,150,0),(356,360,151,155,308),(356,360,156,160,300),(356,360,161,165,293),(356,360,166,170,285),(356,360,171,175,278),(356,360,176,180,270),(356,360,181,185,263),(356,360,186,190,255),(356,360,191,195,248),(356,360,196,200,240),(356,360,201,205,233),(356,360,206,210,225),(356,360,211,215,218),(356,360,216,220,210),(356,360,221,225,203),(356,360,226,230,195),(356,360,231,235,188),(356,360,236,240,180),(356,360,241,245,173),(356,360,246,250,165),(356,360,251,255,158),(356,360,256,260,150),(356,360,261,265,143),(356,360,266,270,135),(356,360,271,275,128),(356,360,276,280,120),(356,360,281,285,113),(356,360,286,290,105),(356,360,291,295,98),(356,360,296,300,90),(356,360,301,305,83),(356,360,306,310,75),(356,360,311,315,68),(356,360,316,320,60),(356,360,321,325,53),(356,360,326,330,45),(356,360,331,335,38),(356,360,336,340,30),(356,360,341,345,0),(356,360,346,350,0),(356,360,351,1000,0),(361,365,0,150,0),(361,365,151,155,315),(361,365,156,160,308),(361,365,161,165,300),(361,365,166,170,293),(361,365,171,175,285),(361,365,176,180,278),(361,365,181,185,270),(361,365,186,190,263),(361,365,191,195,255),(361,365,196,200,248),(361,365,201,205,240),(361,365,206,210,233),(361,365,211,215,225),(361,365,216,220,218),(361,365,221,225,210),(361,365,226,230,203),(361,365,231,235,195),(361,365,236,240,188),(361,365,241,245,180),(361,365,246,250,173),(361,365,251,255,165),(361,365,256,260,158),(361,365,261,265,150),(361,365,266,270,143),(361,365,271,275,135),(361,365,276,280,128),(361,365,281,285,120),(361,365,286,290,113),(361,365,291,295,105),(361,365,296,300,98),(361,365,301,305,90),(361,365,306,310,83),(361,365,311,315,75),(361,365,316,320,68),(361,365,321,325,60),(361,365,326,330,53),(361,365,331,335,45),(361,365,336,340,38),(361,365,341,345,30),(361,365,346,350,0),(361,365,351,355,0),(361,365,356,1000,0),(366,370,0,150,0),(366,370,151,155,323),(366,370,156,160,315),(366,370,161,165,308),(366,370,166,170,300),(366,370,171,175,293),(366,370,176,180,285),(366,370,181,185,278),(366,370,186,190,270),(366,370,191,195,263),(366,370,196,200,255),(366,370,201,205,248),(366,370,206,210,240),(366,370,211,215,233),(366,370,216,220,225),(366,370,221,225,218),(366,370,226,230,210),(366,370,231,235,203),(366,370,236,240,195),(366,370,241,245,188),(366,370,246,250,180),(366,370,251,255,173),(366,370,256,260,165),(366,370,261,265,158),(366,370,266,270,150),(366,370,271,275,143),(366,370,276,280,135),(366,370,281,285,128),(366,370,286,290,120),(366,370,291,295,113),(366,370,296,300,105),(366,370,301,305,98),(366,370,306,310,90),(366,370,311,315,83),(366,370,316,320,75),(366,370,321,325,68),(366,370,326,330,60),(366,370,331,335,53),(366,370,336,340,45),(366,370,341,345,38),(366,370,346,350,30),(366,370,351,355,0),(366,370,356,360,0),(366,370,361,1000,0),(371,375,0,150,0),(371,375,151,155,330),(371,375,156,160,323),(371,375,161,165,315),(371,375,166,170,308),(371,375,171,175,300),(371,375,176,180,293),(371,375,181,185,285),(371,375,186,190,278),(371,375,191,195,270),(371,375,196,200,263),(371,375,201,205,255),(371,375,206,210,248),(371,375,211,215,240),(371,375,216,220,233),(371,375,221,225,225),(371,375,226,230,218),(371,375,231,235,210),(371,375,236,240,203),(371,375,241,245,195),(371,375,246,250,188),(371,375,251,255,180),(371,375,256,260,173),(371,375,261,265,165),(371,375,266,270,158),(371,375,271,275,150),(371,375,276,280,143),(371,375,281,285,135),(371,375,286,290,128),(371,375,291,295,120),(371,375,296,300,113),(371,375,301,305,105),(371,375,306,310,98),(371,375,311,315,90),(371,375,316,320,83),(371,375,321,325,75),(371,375,326,330,68),(371,375,331,335,60),(371,375,336,340,53),(371,375,341,345,45),(371,375,346,350,38),(371,375,351,355,30),(371,375,356,360,0),(371,375,361,365,0),(371,375,366,1000,0),(376,380,0,150,0),(376,380,151,155,338),(376,380,156,160,330),(376,380,161,165,323),(376,380,166,170,315),(376,380,171,175,308),(376,380,176,180,300),(376,380,181,185,293),(376,380,186,190,285),(376,380,191,195,278),(376,380,196,200,270),(376,380,201,205,263),(376,380,206,210,255),(376,380,211,215,248),(376,380,216,220,240),(376,380,221,225,233),(376,380,226,230,225),(376,380,231,235,218),(376,380,236,240,210),(376,380,241,245,203),(376,380,246,250,195),(376,380,251,255,188),(376,380,256,260,180),(376,380,261,265,173),(376,380,266,270,165),(376,380,271,275,158),(376,380,276,280,150),(376,380,281,285,143),(376,380,286,290,135),(376,380,291,295,128),(376,380,296,300,120),(376,380,301,305,113),(376,380,306,310,105),(376,380,311,315,98),(376,380,316,320,90),(376,380,321,325,83),(376,380,326,330,75),(376,380,331,335,68),(376,380,336,340,60),(376,380,341,345,53),(376,380,346,350,45),(376,380,351,355,38),(376,380,356,360,30),(376,380,361,365,0),(376,380,366,370,0),(376,380,371,1000,0),(381,385,0,150,0),(381,385,151,155,345),(381,385,156,160,338),(381,385,161,165,330),(381,385,166,170,323),(381,385,171,175,315),(381,385,176,180,308),(381,385,181,185,300),(381,385,186,190,293),(381,385,191,195,285),(381,385,196,200,278),(381,385,201,205,270),(381,385,206,210,263),(381,385,211,215,255),(381,385,216,220,248),(381,385,221,225,240),(381,385,226,230,233),(381,385,231,235,225),(381,385,236,240,218),(381,385,241,245,210),(381,385,246,250,203),(381,385,251,255,195),(381,385,256,260,188),(381,385,261,265,180),(381,385,266,270,173),(381,385,271,275,165),(381,385,276,280,158),(381,385,281,285,150),(381,385,286,290,143),(381,385,291,295,135),(381,385,296,300,128),(381,385,301,305,120),(381,385,306,310,113),(381,385,311,315,105),(381,385,316,320,98),(381,385,321,325,90),(381,385,326,330,83),(381,385,331,335,75),(381,385,336,340,68),(381,385,341,345,60),(381,385,346,350,53),(381,385,351,355,45),(381,385,356,360,38),(381,385,361,365,30),(381,385,366,370,0),(381,385,371,375,0),(381,385,376,1000,0),(386,390,0,150,0),(386,390,151,155,353),(386,390,156,160,345),(386,390,161,165,338),(386,390,166,170,330),(386,390,171,175,323),(386,390,176,180,315),(386,390,181,185,308),(386,390,186,190,300),(386,390,191,195,293),(386,390,196,200,285),(386,390,201,205,278),(386,390,206,210,270),(386,390,211,215,263),(386,390,216,220,255),(386,390,221,225,248),(386,390,226,230,240),(386,390,231,235,233),(386,390,236,240,225),(386,390,241,245,218),(386,390,246,250,210),(386,390,251,255,203),(386,390,256,260,195),(386,390,261,265,188),(386,390,266,270,180),(386,390,271,275,173),(386,390,276,280,165),(386,390,281,285,158),(386,390,286,290,150),(386,390,291,295,143),(386,390,296,300,135),(386,390,301,305,128),(386,390,306,310,120),(386,390,311,315,113),(386,390,316,320,105),(386,390,321,325,98),(386,390,326,330,90),(386,390,331,335,83),(386,390,336,340,75),(386,390,341,345,68),(386,390,346,350,60),(386,390,351,355,53),(386,390,356,360,45),(386,390,361,365,38),(386,390,366,370,30),(386,390,371,375,0),(386,390,376,380,0),(386,390,381,1000,0),(391,395,0,150,0),(391,395,151,155,360),(391,395,156,160,353),(391,395,161,165,345),(391,395,166,170,338),(391,395,171,175,330),(391,395,176,180,323),(391,395,181,185,315),(391,395,186,190,308),(391,395,191,195,300),(391,395,196,200,293),(391,395,201,205,285),(391,395,206,210,278),(391,395,211,215,270),(391,395,216,220,263),(391,395,221,225,255),(391,395,226,230,248),(391,395,231,235,240),(391,395,236,240,233),(391,395,241,245,225),(391,395,246,250,218),(391,395,251,255,210),(391,395,256,260,203),(391,395,261,265,195),(391,395,266,270,188),(391,395,271,275,180),(391,395,276,280,173),(391,395,281,285,165),(391,395,286,290,158),(391,395,291,295,150),(391,395,296,300,143),(391,395,301,305,135),(391,395,306,310,128),(391,395,311,315,120),(391,395,316,320,113),(391,395,321,325,105),(391,395,326,330,98),(391,395,331,335,90),(391,395,336,340,83),(391,395,341,345,75),(391,395,346,350,68),(391,395,351,355,60),(391,395,356,360,53),(391,395,361,365,45),(391,395,366,370,38),(391,395,371,375,30),(391,395,376,380,0),(391,395,381,385,0),(391,395,386,1000,0),(396,400,0,150,0),(396,400,151,155,368),(396,400,156,160,360),(396,400,161,165,353),(396,400,166,170,345),(396,400,171,175,338),(396,400,176,180,330),(396,400,181,185,323),(396,400,186,190,315),(396,400,191,195,308),(396,400,196,200,300),(396,400,201,205,293),(396,400,206,210,285),(396,400,211,215,278),(396,400,216,220,270),(396,400,221,225,263),(396,400,226,230,255),(396,400,231,235,248),(396,400,236,240,240),(396,400,241,245,233),(396,400,246,250,225),(396,400,251,255,218),(396,400,256,260,210),(396,400,261,265,203),(396,400,266,270,195),(396,400,271,275,188),(396,400,276,280,180),(396,400,281,285,173),(396,400,286,290,165),(396,400,291,295,158),(396,400,296,300,150),(396,400,301,305,143),(396,400,306,310,135),(396,400,311,315,128),(396,400,316,320,120),(396,400,321,325,113),(396,400,326,330,105),(396,400,331,335,98),(396,400,336,340,90),(396,400,341,345,83),(396,400,346,350,75),(396,400,351,355,68),(396,400,356,360,60),(396,400,361,365,53),(396,400,366,370,45),(396,400,371,375,38),(396,400,376,380,30),(396,400,381,385,0),(396,400,386,390,0),(396,400,391,1000,0),(401,405,0,150,0),(401,405,151,155,375),(401,405,156,160,368),(401,405,161,165,360),(401,405,166,170,353),(401,405,171,175,345),(401,405,176,180,338),(401,405,181,185,330),(401,405,186,190,323),(401,405,191,195,315),(401,405,196,200,308),(401,405,201,205,300),(401,405,206,210,293),(401,405,211,215,285),(401,405,216,220,278),(401,405,221,225,270),(401,405,226,230,263),(401,405,231,235,255),(401,405,236,240,248),(401,405,241,245,240),(401,405,246,250,233),(401,405,251,255,225),(401,405,256,260,218),(401,405,261,265,210),(401,405,266,270,203),(401,405,271,275,195),(401,405,276,280,188),(401,405,281,285,180),(401,405,286,290,173),(401,405,291,295,165),(401,405,296,300,158),(401,405,301,305,150),(401,405,306,310,143),(401,405,311,315,135),(401,405,316,320,128),(401,405,321,325,120),(401,405,326,330,113),(401,405,331,335,105),(401,405,336,340,98),(401,405,341,345,90),(401,405,346,350,83),(401,405,351,355,75),(401,405,356,360,68),(401,405,361,365,60),(401,405,366,370,53),(401,405,371,375,45),(401,405,376,380,38),(401,405,381,385,30),(401,405,386,390,0),(401,405,391,395,0),(401,405,396,1000,0),(406,410,0,150,0),(406,410,151,155,383),(406,410,156,160,375),(406,410,161,165,368),(406,410,166,170,360),(406,410,171,175,353),(406,410,176,180,345),(406,410,181,185,338),(406,410,186,190,330),(406,410,191,195,323),(406,410,196,200,315),(406,410,201,205,308),(406,410,206,210,300),(406,410,211,215,293),(406,410,216,220,285),(406,410,221,225,278),(406,410,226,230,270),(406,410,231,235,263),(406,410,236,240,255),(406,410,241,245,248),(406,410,246,250,240),(406,410,251,255,233),(406,410,256,260,225),(406,410,261,265,218),(406,410,266,270,210),(406,410,271,275,203),(406,410,276,280,195),(406,410,281,285,188),(406,410,286,290,180),(406,410,291,295,173),(406,410,296,300,165),(406,410,301,305,158),(406,410,306,310,150),(406,410,311,315,143),(406,410,316,320,135),(406,410,321,325,128),(406,410,326,330,120),(406,410,331,335,113),(406,410,336,340,105),(406,410,341,345,98),(406,410,346,350,90),(406,410,351,355,83),(406,410,356,360,75),(406,410,361,365,68),(406,410,366,370,60),(406,410,371,375,53),(406,410,376,380,45),(406,410,381,385,38),(406,410,386,390,30),(406,410,391,395,0),(406,410,396,400,0),(406,410,401,1000,0),(411,415,0,150,0),(411,415,151,155,390),(411,415,156,160,383),(411,415,161,165,375),(411,415,166,170,368),(411,415,171,175,360),(411,415,176,180,353),(411,415,181,185,345),(411,415,186,190,338),(411,415,191,195,330),(411,415,196,200,323),(411,415,201,205,315),(411,415,206,210,308),(411,415,211,215,300),(411,415,216,220,293),(411,415,221,225,285),(411,415,226,230,278),(411,415,231,235,270),(411,415,236,240,263),(411,415,241,245,255),(411,415,246,250,248),(411,415,251,255,240),(411,415,256,260,233),(411,415,261,265,225),(411,415,266,270,218),(411,415,271,275,210),(411,415,276,280,203),(411,415,281,285,195),(411,415,286,290,188),(411,415,291,295,180),(411,415,296,300,173),(411,415,301,305,165),(411,415,306,310,158),(411,415,311,315,150),(411,415,316,320,143),(411,415,321,325,135),(411,415,326,330,128),(411,415,331,335,120),(411,415,336,340,113),(411,415,341,345,105),(411,415,346,350,98),(411,415,351,355,90),(411,415,356,360,83),(411,415,361,365,75),(411,415,366,370,68),(411,415,371,375,60),(411,415,376,380,53),(411,415,381,385,45),(411,415,386,390,38),(411,415,391,395,30),(411,415,396,400,0),(411,415,401,405,0),(411,415,406,1000,0),(416,420,0,150,0),(416,420,151,155,398),(416,420,156,160,390),(416,420,161,165,383),(416,420,166,170,375),(416,420,171,175,368),(416,420,176,180,360),(416,420,181,185,353),(416,420,186,190,345),(416,420,191,195,338),(416,420,196,200,330),(416,420,201,205,323),(416,420,206,210,315),(416,420,211,215,308),(416,420,216,220,300),(416,420,221,225,293),(416,420,226,230,285),(416,420,231,235,278),(416,420,236,240,270),(416,420,241,245,263),(416,420,246,250,255),(416,420,251,255,248),(416,420,256,260,240),(416,420,261,265,233),(416,420,266,270,225),(416,420,271,275,218),(416,420,276,280,210),(416,420,281,285,203),(416,420,286,290,195),(416,420,291,295,188),(416,420,296,300,180),(416,420,301,305,173),(416,420,306,310,165),(416,420,311,315,158),(416,420,316,320,150),(416,420,321,325,143),(416,420,326,330,135),(416,420,331,335,128),(416,420,336,340,120),(416,420,341,345,113),(416,420,346,350,105),(416,420,351,355,98),(416,420,356,360,90),(416,420,361,365,83),(416,420,366,370,75),(416,420,371,375,68),(416,420,376,380,60),(416,420,381,385,53),(416,420,386,390,45),(416,420,391,395,38),(416,420,396,400,30),(416,420,401,405,0),(416,420,406,410,0),(416,420,411,1000,0),(421,425,0,150,0),(421,425,151,155,405),(421,425,156,160,398),(421,425,161,165,390),(421,425,166,170,383),(421,425,171,175,375),(421,425,176,180,368),(421,425,181,185,360),(421,425,186,190,353),(421,425,191,195,345),(421,425,196,200,338),(421,425,201,205,330),(421,425,206,210,323),(421,425,211,215,315),(421,425,216,220,308),(421,425,221,225,300),(421,425,226,230,293),(421,425,231,235,285),(421,425,236,240,278),(421,425,241,245,270),(421,425,246,250,263),(421,425,251,255,255),(421,425,256,260,248),(421,425,261,265,240),(421,425,266,270,233),(421,425,271,275,225),(421,425,276,280,218),(421,425,281,285,210),(421,425,286,290,203),(421,425,291,295,195),(421,425,296,300,188),(421,425,301,305,180),(421,425,306,310,173),(421,425,311,315,165),(421,425,316,320,158),(421,425,321,325,150),(421,425,326,330,143),(421,425,331,335,135),(421,425,336,340,128),(421,425,341,345,120),(421,425,346,350,113),(421,425,351,355,105),(421,425,356,360,98),(421,425,361,365,90),(421,425,366,370,83),(421,425,371,375,75),(421,425,376,380,68),(421,425,381,385,60),(421,425,386,390,53),(421,425,391,395,45),(421,425,396,400,38),(421,425,401,405,30),(421,425,406,410,0),(421,425,411,415,0),(421,425,416,1000,0),(426,430,0,150,0),(426,430,151,155,413),(426,430,156,160,405),(426,430,161,165,398),(426,430,166,170,390),(426,430,171,175,383),(426,430,176,180,375),(426,430,181,185,368),(426,430,186,190,360),(426,430,191,195,353),(426,430,196,200,345),(426,430,201,205,338),(426,430,206,210,330),(426,430,211,215,323),(426,430,216,220,315),(426,430,221,225,308),(426,430,226,230,300),(426,430,231,235,293),(426,430,236,240,285),(426,430,241,245,278),(426,430,246,250,270),(426,430,251,255,263),(426,430,256,260,255),(426,430,261,265,248),(426,430,266,270,240),(426,430,271,275,233),(426,430,276,280,225),(426,430,281,285,218),(426,430,286,290,210),(426,430,291,295,203),(426,430,296,300,195),(426,430,301,305,188),(426,430,306,310,180),(426,430,311,315,173),(426,430,316,320,165),(426,430,321,325,158),(426,430,326,330,150),(426,430,331,335,143),(426,430,336,340,135),(426,430,341,345,128),(426,430,346,350,120),(426,430,351,355,113),(426,430,356,360,105),(426,430,361,365,98),(426,430,366,370,90),(426,430,371,375,83),(426,430,376,380,75),(426,430,381,385,68),(426,430,386,390,60),(426,430,391,395,53),(426,430,396,400,45),(426,430,401,405,38),(426,430,406,410,30),(426,430,411,415,0),(426,430,416,420,0),(426,430,421,1000,0),(431,435,0,150,0),(431,435,151,155,420),(431,435,156,160,413),(431,435,161,165,405),(431,435,166,170,398),(431,435,171,175,390),(431,435,176,180,383),(431,435,181,185,375),(431,435,186,190,368),(431,435,191,195,360),(431,435,196,200,353),(431,435,201,205,345),(431,435,206,210,338),(431,435,211,215,330),(431,435,216,220,323),(431,435,221,225,315),(431,435,226,230,308),(431,435,231,235,300),(431,435,236,240,293),(431,435,241,245,285),(431,435,246,250,278),(431,435,251,255,270),(431,435,256,260,263),(431,435,261,265,255),(431,435,266,270,248),(431,435,271,275,240),(431,435,276,280,233),(431,435,281,285,225),(431,435,286,290,218),(431,435,291,295,210),(431,435,296,300,203),(431,435,301,305,195),(431,435,306,310,188),(431,435,311,315,180),(431,435,316,320,173),(431,435,321,325,165),(431,435,326,330,158),(431,435,331,335,150),(431,435,336,340,143),(431,435,341,345,135),(431,435,346,350,128),(431,435,351,355,120),(431,435,356,360,113),(431,435,361,365,105),(431,435,366,370,98),(431,435,371,375,90),(431,435,376,380,83),(431,435,381,385,75),(431,435,386,390,68),(431,435,391,395,60),(431,435,396,400,53),(431,435,401,405,45),(431,435,406,410,38),(431,435,411,415,30),(431,435,416,420,0),(431,435,421,425,0),(431,435,426,1000,0),(436,440,0,150,0),(436,440,151,155,428),(436,440,156,160,420),(436,440,161,165,413),(436,440,166,170,405),(436,440,171,175,398),(436,440,176,180,390),(436,440,181,185,383),(436,440,186,190,375),(436,440,191,195,368),(436,440,196,200,360),(436,440,201,205,353),(436,440,206,210,345),(436,440,211,215,338),(436,440,216,220,330),(436,440,221,225,323),(436,440,226,230,315),(436,440,231,235,308),(436,440,236,240,300),(436,440,241,245,293),(436,440,246,250,285),(436,440,251,255,278),(436,440,256,260,270),(436,440,261,265,263),(436,440,266,270,255),(436,440,271,275,248),(436,440,276,280,240),(436,440,281,285,233),(436,440,286,290,225),(436,440,291,295,218),(436,440,296,300,210),(436,440,301,305,203),(436,440,306,310,195),(436,440,311,315,188),(436,440,316,320,180),(436,440,321,325,173),(436,440,326,330,165),(436,440,331,335,158),(436,440,336,340,150),(436,440,341,345,143),(436,440,346,350,135),(436,440,351,355,128),(436,440,356,360,120),(436,440,361,365,113),(436,440,366,370,105),(436,440,371,375,98),(436,440,376,380,90),(436,440,381,385,83),(436,440,386,390,75),(436,440,391,395,68),(436,440,396,400,60),(436,440,401,405,53),(436,440,406,410,45),(436,440,411,415,38),(436,440,416,420,30),(436,440,421,425,0),(436,440,426,430,0),(436,440,431,1000,0),(441,445,0,150,0),(441,445,151,155,435),(441,445,156,160,428),(441,445,161,165,420),(441,445,166,170,413),(441,445,171,175,405),(441,445,176,180,398),(441,445,181,185,390),(441,445,186,190,383),(441,445,191,195,375),(441,445,196,200,368),(441,445,201,205,360),(441,445,206,210,353),(441,445,211,215,345),(441,445,216,220,338),(441,445,221,225,330),(441,445,226,230,323),(441,445,231,235,315),(441,445,236,240,308),(441,445,241,245,300),(441,445,246,250,293),(441,445,251,255,285),(441,445,256,260,278),(441,445,261,265,270),(441,445,266,270,263),(441,445,271,275,255),(441,445,276,280,248),(441,445,281,285,240),(441,445,286,290,233),(441,445,291,295,225),(441,445,296,300,218),(441,445,301,305,210),(441,445,306,310,203),(441,445,311,315,195),(441,445,316,320,188),(441,445,321,325,180),(441,445,326,330,173),(441,445,331,335,165),(441,445,336,340,158),(441,445,341,345,150),(441,445,346,350,143),(441,445,351,355,135),(441,445,356,360,128),(441,445,361,365,120),(441,445,366,370,113),(441,445,371,375,105),(441,445,376,380,98),(441,445,381,385,90),(441,445,386,390,83),(441,445,391,395,75),(441,445,396,400,68),(441,445,401,405,60),(441,445,406,410,53),(441,445,411,415,45),(441,445,416,420,38),(441,445,421,425,30),(441,445,426,430,0),(441,445,431,435,0),(441,445,436,1000,0),(446,450,0,150,0),(446,450,151,155,443),(446,450,156,160,435),(446,450,161,165,428),(446,450,166,170,420),(446,450,171,175,413),(446,450,176,180,405),(446,450,181,185,398),(446,450,186,190,390),(446,450,191,195,383),(446,450,196,200,375),(446,450,201,205,368),(446,450,206,210,360),(446,450,211,215,353),(446,450,216,220,345),(446,450,221,225,338),(446,450,226,230,330),(446,450,231,235,323),(446,450,236,240,315),(446,450,241,245,308),(446,450,246,250,300),(446,450,251,255,293),(446,450,256,260,285),(446,450,261,265,278),(446,450,266,270,270),(446,450,271,275,263),(446,450,276,280,255),(446,450,281,285,248),(446,450,286,290,240),(446,450,291,295,233),(446,450,296,300,225),(446,450,301,305,218),(446,450,306,310,210),(446,450,311,315,203),(446,450,316,320,195),(446,450,321,325,188),(446,450,326,330,180),(446,450,331,335,173),(446,450,336,340,165),(446,450,341,345,158),(446,450,346,350,150),(446,450,351,355,143),(446,450,356,360,135),(446,450,361,365,128),(446,450,366,370,120),(446,450,371,375,113),(446,450,376,380,105),(446,450,381,385,98),(446,450,386,390,90),(446,450,391,395,83),(446,450,396,400,75),(446,450,401,405,68),(446,450,406,410,60),(446,450,411,415,53),(446,450,416,420,45),(446,450,421,425,38),(446,450,426,430,30),(446,450,431,435,0),(446,450,436,440,0),(446,450,441,1000,0),(451,455,0,150,0),(451,455,151,155,450),(451,455,156,160,443),(451,455,161,165,435),(451,455,166,170,428),(451,455,171,175,420),(451,455,176,180,413),(451,455,181,185,405),(451,455,186,190,398),(451,455,191,195,390),(451,455,196,200,383),(451,455,201,205,375),(451,455,206,210,368),(451,455,211,215,360),(451,455,216,220,353),(451,455,221,225,345),(451,455,226,230,338),(451,455,231,235,330),(451,455,236,240,323),(451,455,241,245,315),(451,455,246,250,308),(451,455,251,255,300),(451,455,256,260,293),(451,455,261,265,285),(451,455,266,270,278),(451,455,271,275,270),(451,455,276,280,263),(451,455,281,285,255),(451,455,286,290,248),(451,455,291,295,240),(451,455,296,300,233),(451,455,301,305,225),(451,455,306,310,218),(451,455,311,315,210),(451,455,316,320,203),(451,455,321,325,195),(451,455,326,330,188),(451,455,331,335,180),(451,455,336,340,173),(451,455,341,345,165),(451,455,346,350,158),(451,455,351,355,150),(451,455,356,360,143),(451,455,361,365,135),(451,455,366,370,128),(451,455,371,375,120),(451,455,376,380,113),(451,455,381,385,105),(451,455,386,390,98),(451,455,391,395,90),(451,455,396,400,83),(451,455,401,405,75),(451,455,406,410,68),(451,455,411,415,60),(451,455,416,420,53),(451,455,421,425,45),(451,455,426,430,38),(451,455,431,435,30),(451,455,436,440,0),(451,455,441,445,0),(451,455,446,1000,0),(456,460,0,150,0),(456,460,151,155,458),(456,460,156,160,450),(456,460,161,165,443),(456,460,166,170,435),(456,460,171,175,428),(456,460,176,180,420),(456,460,181,185,413),(456,460,186,190,405),(456,460,191,195,398),(456,460,196,200,390),(456,460,201,205,383),(456,460,206,210,375),(456,460,211,215,368),(456,460,216,220,360),(456,460,221,225,353),(456,460,226,230,345),(456,460,231,235,338),(456,460,236,240,330),(456,460,241,245,323),(456,460,246,250,315),(456,460,251,255,308),(456,460,256,260,300),(456,460,261,265,293),(456,460,266,270,285),(456,460,271,275,278),(456,460,276,280,270),(456,460,281,285,263),(456,460,286,290,255),(456,460,291,295,248),(456,460,296,300,240),(456,460,301,305,233),(456,460,306,310,225),(456,460,311,315,218),(456,460,316,320,210),(456,460,321,325,203),(456,460,326,330,195),(456,460,331,335,188),(456,460,336,340,180),(456,460,341,345,173),(456,460,346,350,165),(456,460,351,355,158),(456,460,356,360,150),(456,460,361,365,143),(456,460,366,370,135),(456,460,371,375,128),(456,460,376,380,120),(456,460,381,385,113),(456,460,386,390,105),(456,460,391,395,98),(456,460,396,400,90),(456,460,401,405,83),(456,460,406,410,75),(456,460,411,415,68),(456,460,416,420,60),(456,460,421,425,53),(456,460,426,430,45),(456,460,431,435,38),(456,460,436,440,30),(456,460,441,445,0),(456,460,446,450,0),(456,460,451,1000,0),(461,465,0,150,0),(461,465,151,155,465),(461,465,156,160,458),(461,465,161,165,450),(461,465,166,170,443),(461,465,171,175,435),(461,465,176,180,428),(461,465,181,185,420),(461,465,186,190,413),(461,465,191,195,405),(461,465,196,200,398),(461,465,201,205,390),(461,465,206,210,383),(461,465,211,215,375),(461,465,216,220,368),(461,465,221,225,360),(461,465,226,230,353),(461,465,231,235,345),(461,465,236,240,338),(461,465,241,245,330),(461,465,246,250,323),(461,465,251,255,315),(461,465,256,260,308),(461,465,261,265,300),(461,465,266,270,293),(461,465,271,275,285),(461,465,276,280,278),(461,465,281,285,270),(461,465,286,290,263),(461,465,291,295,255),(461,465,296,300,248),(461,465,301,305,240),(461,465,306,310,233),(461,465,311,315,225),(461,465,316,320,218),(461,465,321,325,210),(461,465,326,330,203),(461,465,331,335,195),(461,465,336,340,188),(461,465,341,345,180),(461,465,346,350,173),(461,465,351,355,165),(461,465,356,360,158),(461,465,361,365,150),(461,465,366,370,143),(461,465,371,375,135),(461,465,376,380,128),(461,465,381,385,120),(461,465,386,390,113),(461,465,391,395,105),(461,465,396,400,98),(461,465,401,405,90),(461,465,406,410,83),(461,465,411,415,75),(461,465,416,420,68),(461,465,421,425,60),(461,465,426,430,53),(461,465,431,435,45),(461,465,436,440,38),(461,465,441,445,30),(461,465,446,450,0),(461,465,451,455,0),(461,465,456,1000,0),(466,470,0,150,0),(466,470,151,155,473),(466,470,156,160,465),(466,470,161,165,458),(466,470,166,170,450),(466,470,171,175,443),(466,470,176,180,435),(466,470,181,185,428),(466,470,186,190,420),(466,470,191,195,413),(466,470,196,200,405),(466,470,201,205,398),(466,470,206,210,390),(466,470,211,215,383),(466,470,216,220,375),(466,470,221,225,368),(466,470,226,230,360),(466,470,231,235,353),(466,470,236,240,345),(466,470,241,245,338),(466,470,246,250,330),(466,470,251,255,323),(466,470,256,260,315),(466,470,261,265,308),(466,470,266,270,300),(466,470,271,275,293),(466,470,276,280,285),(466,470,281,285,278),(466,470,286,290,270),(466,470,291,295,263),(466,470,296,300,255),(466,470,301,305,248),(466,470,306,310,240),(466,470,311,315,233),(466,470,316,320,225),(466,470,321,325,218),(466,470,326,330,210),(466,470,331,335,203),(466,470,336,340,195),(466,470,341,345,188),(466,470,346,350,180),(466,470,351,355,173),(466,470,356,360,165),(466,470,361,365,158),(466,470,366,370,150),(466,470,371,375,143),(466,470,376,380,135),(466,470,381,385,128),(466,470,386,390,120),(466,470,391,395,113),(466,470,396,400,105),(466,470,401,405,98),(466,470,406,410,90),(466,470,411,415,83),(466,470,416,420,75),(466,470,421,425,68),(466,470,426,430,60),(466,470,431,435,53),(466,470,436,440,45),(466,470,441,445,38),(466,470,446,450,30),(466,470,451,455,0),(466,470,456,460,0),(466,470,461,1000,0),(471,475,0,150,0),(471,475,151,155,480),(471,475,156,160,473),(471,475,161,165,465),(471,475,166,170,458),(471,475,171,175,450),(471,475,176,180,443),(471,475,181,185,435),(471,475,186,190,428),(471,475,191,195,420),(471,475,196,200,413),(471,475,201,205,405),(471,475,206,210,398),(471,475,211,215,390),(471,475,216,220,383),(471,475,221,225,375),(471,475,226,230,368),(471,475,231,235,360),(471,475,236,240,353),(471,475,241,245,345),(471,475,246,250,338),(471,475,251,255,330),(471,475,256,260,323),(471,475,261,265,315),(471,475,266,270,308),(471,475,271,275,300),(471,475,276,280,293),(471,475,281,285,285),(471,475,286,290,278),(471,475,291,295,270),(471,475,296,300,263),(471,475,301,305,255),(471,475,306,310,248),(471,475,311,315,240),(471,475,316,320,233),(471,475,321,325,225),(471,475,326,330,218),(471,475,331,335,210),(471,475,336,340,203),(471,475,341,345,195),(471,475,346,350,188),(471,475,351,355,180),(471,475,356,360,173),(471,475,361,365,165),(471,475,366,370,158),(471,475,371,375,150),(471,475,376,380,143),(471,475,381,385,135),(471,475,386,390,128),(471,475,391,395,120),(471,475,396,400,113),(471,475,401,405,105),(471,475,406,410,98),(471,475,411,415,90),(471,475,416,420,83),(471,475,421,425,75),(471,475,426,430,68),(471,475,431,435,60),(471,475,436,440,53),(471,475,441,445,45),(471,475,446,450,38),(471,475,451,455,30),(471,475,456,460,0),(471,475,461,465,0),(471,475,466,1000,0),(476,480,0,150,0),(476,480,151,155,488),(476,480,156,160,480),(476,480,161,165,473),(476,480,166,170,465),(476,480,171,175,458),(476,480,176,180,450),(476,480,181,185,443),(476,480,186,190,435),(476,480,191,195,428),(476,480,196,200,420),(476,480,201,205,413),(476,480,206,210,405),(476,480,211,215,398),(476,480,216,220,390),(476,480,221,225,383),(476,480,226,230,375),(476,480,231,235,368),(476,480,236,240,360),(476,480,241,245,353),(476,480,246,250,345),(476,480,251,255,338),(476,480,256,260,330),(476,480,261,265,323),(476,480,266,270,315),(476,480,271,275,308),(476,480,276,280,300),(476,480,281,285,293),(476,480,286,290,285),(476,480,291,295,278),(476,480,296,300,270),(476,480,301,305,263),(476,480,306,310,255),(476,480,311,315,248),(476,480,316,320,240),(476,480,321,325,233),(476,480,326,330,225),(476,480,331,335,218),(476,480,336,340,210),(476,480,341,345,203),(476,480,346,350,195),(476,480,351,355,188),(476,480,356,360,180),(476,480,361,365,173),(476,480,366,370,165),(476,480,371,375,158),(476,480,376,380,150),(476,480,381,385,143),(476,480,386,390,135),(476,480,391,395,128),(476,480,396,400,120),(476,480,401,405,113),(476,480,406,410,105),(476,480,411,415,98),(476,480,416,420,90),(476,480,421,425,83),(476,480,426,430,75),(476,480,431,435,68),(476,480,436,440,60),(476,480,441,445,53),(476,480,446,450,45),(476,480,451,455,38),(476,480,456,460,30),(476,480,461,465,0),(476,480,466,470,0),(476,480,471,1000,0),(481,485,0,150,0),(481,485,151,155,495),(481,485,156,160,488),(481,485,161,165,480),(481,485,166,170,473),(481,485,171,175,465),(481,485,176,180,458),(481,485,181,185,450),(481,485,186,190,443),(481,485,191,195,435),(481,485,196,200,428),(481,485,201,205,420),(481,485,206,210,413),(481,485,211,215,405),(481,485,216,220,398),(481,485,221,225,390),(481,485,226,230,383),(481,485,231,235,375),(481,485,236,240,368),(481,485,241,245,360),(481,485,246,250,353),(481,485,251,255,345),(481,485,256,260,338),(481,485,261,265,330),(481,485,266,270,323),(481,485,271,275,315),(481,485,276,280,308),(481,485,281,285,300),(481,485,286,290,293),(481,485,291,295,285),(481,485,296,300,278),(481,485,301,305,270),(481,485,306,310,263),(481,485,311,315,255),(481,485,316,320,248),(481,485,321,325,240),(481,485,326,330,233),(481,485,331,335,225),(481,485,336,340,218),(481,485,341,345,210),(481,485,346,350,203),(481,485,351,355,195),(481,485,356,360,188),(481,485,361,365,180),(481,485,366,370,173),(481,485,371,375,165),(481,485,376,380,158),(481,485,381,385,150),(481,485,386,390,143),(481,485,391,395,135),(481,485,396,400,128),(481,485,401,405,120),(481,485,406,410,113),(481,485,411,415,105),(481,485,416,420,98),(481,485,421,425,90),(481,485,426,430,83),(481,485,431,435,75),(481,485,436,440,68),(481,485,441,445,60),(481,485,446,450,53),(481,485,451,455,45),(481,485,456,460,38),(481,485,461,465,30),(481,485,466,470,0),(481,485,471,475,0),(481,485,476,1000,0),(486,490,0,150,0),(486,490,151,155,503),(486,490,156,160,495),(486,490,161,165,488),(486,490,166,170,480),(486,490,171,175,473),(486,490,176,180,465),(486,490,181,185,458),(486,490,186,190,450),(486,490,191,195,443),(486,490,196,200,435),(486,490,201,205,428),(486,490,206,210,420),(486,490,211,215,413),(486,490,216,220,405),(486,490,221,225,398),(486,490,226,230,390),(486,490,231,235,383),(486,490,236,240,375),(486,490,241,245,368),(486,490,246,250,360),(486,490,251,255,353),(486,490,256,260,345),(486,490,261,265,338),(486,490,266,270,330),(486,490,271,275,323),(486,490,276,280,315),(486,490,281,285,308),(486,490,286,290,300),(486,490,291,295,293),(486,490,296,300,285),(486,490,301,305,278),(486,490,306,310,270),(486,490,311,315,263),(486,490,316,320,255),(486,490,321,325,248),(486,490,326,330,240),(486,490,331,335,233),(486,490,336,340,225),(486,490,341,345,218),(486,490,346,350,210),(486,490,351,355,203),(486,490,356,360,195),(486,490,361,365,188),(486,490,366,370,180),(486,490,371,375,173),(486,490,376,380,165),(486,490,381,385,158),(486,490,386,390,150),(486,490,391,395,143),(486,490,396,400,135),(486,490,401,405,128),(486,490,406,410,120),(486,490,411,415,113),(486,490,416,420,105),(486,490,421,425,98),(486,490,426,430,90),(486,490,431,435,83),(486,490,436,440,75),(486,490,441,445,68),(486,490,446,450,60),(486,490,451,455,53),(486,490,456,460,45),(486,490,461,465,38),(486,490,466,470,30),(486,490,471,475,0),(486,490,476,480,0),(486,490,481,1000,0),(491,495,0,150,0),(491,495,151,155,510),(491,495,156,160,503),(491,495,161,165,495),(491,495,166,170,488),(491,495,171,175,480),(491,495,176,180,473),(491,495,181,185,465),(491,495,186,190,458),(491,495,191,195,450),(491,495,196,200,443),(491,495,201,205,435),(491,495,206,210,428),(491,495,211,215,420),(491,495,216,220,413),(491,495,221,225,405),(491,495,226,230,398),(491,495,231,235,390),(491,495,236,240,383),(491,495,241,245,375),(491,495,246,250,368),(491,495,251,255,360),(491,495,256,260,353),(491,495,261,265,345),(491,495,266,270,338),(491,495,271,275,330),(491,495,276,280,323),(491,495,281,285,315),(491,495,286,290,308),(491,495,291,295,300),(491,495,296,300,293),(491,495,301,305,285),(491,495,306,310,278),(491,495,311,315,270),(491,495,316,320,263),(491,495,321,325,255),(491,495,326,330,248),(491,495,331,335,240),(491,495,336,340,233),(491,495,341,345,225),(491,495,346,350,218),(491,495,351,355,210),(491,495,356,360,203),(491,495,361,365,195),(491,495,366,370,188),(491,495,371,375,180),(491,495,376,380,173),(491,495,381,385,165),(491,495,386,390,158),(491,495,391,395,150),(491,495,396,400,143),(491,495,401,405,135),(491,495,406,410,128),(491,495,411,415,120),(491,495,416,420,113),(491,495,421,425,105),(491,495,426,430,98),(491,495,431,435,90),(491,495,436,440,83),(491,495,441,445,75),(491,495,446,450,68),(491,495,451,455,60),(491,495,456,460,53),(491,495,461,465,45),(491,495,466,470,38),(491,495,471,475,30),(491,495,476,480,0),(491,495,481,485,0),(491,495,486,1000,0),(496,500,0,150,0),(496,500,151,155,518),(496,500,156,160,510),(496,500,161,165,503),(496,500,166,170,495),(496,500,171,175,488),(496,500,176,180,480),(496,500,181,185,473),(496,500,186,190,465),(496,500,191,195,458),(496,500,196,200,450),(496,500,201,205,443),(496,500,206,210,435),(496,500,211,215,428),(496,500,216,220,420),(496,500,221,225,413),(496,500,226,230,405),(496,500,231,235,398),(496,500,236,240,390),(496,500,241,245,383),(496,500,246,250,375),(496,500,251,255,368),(496,500,256,260,360),(496,500,261,265,353),(496,500,266,270,345),(496,500,271,275,338),(496,500,276,280,330),(496,500,281,285,323),(496,500,286,290,315),(496,500,291,295,308),(496,500,296,300,300),(496,500,301,305,293),(496,500,306,310,285),(496,500,311,315,278),(496,500,316,320,270),(496,500,321,325,263),(496,500,326,330,255),(496,500,331,335,248),(496,500,336,340,240),(496,500,341,345,233),(496,500,346,350,225),(496,500,351,355,218),(496,500,356,360,210),(496,500,361,365,203),(496,500,366,370,195),(496,500,371,375,188),(496,500,376,380,180),(496,500,381,385,173),(496,500,386,390,165),(496,500,391,395,158),(496,500,396,400,150),(496,500,401,405,143),(496,500,406,410,135),(496,500,411,415,128),(496,500,416,420,120),(496,500,421,425,113),(496,500,426,430,105),(496,500,431,435,98),(496,500,436,440,90),(496,500,441,445,83),(496,500,446,450,75),(496,500,451,455,68),(496,500,456,460,60),(496,500,461,465,53),(496,500,466,470,45),(496,500,471,475,38),(496,500,476,480,30),(496,500,481,485,0),(496,500,486,490,0),(496,500,491,1000,0),(501,505,0,150,0),(501,505,151,155,525),(501,505,156,160,518),(501,505,161,165,510),(501,505,166,170,503),(501,505,171,175,495),(501,505,176,180,488),(501,505,181,185,480),(501,505,186,190,473),(501,505,191,195,465),(501,505,196,200,458),(501,505,201,205,450),(501,505,206,210,443),(501,505,211,215,435),(501,505,216,220,428),(501,505,221,225,420),(501,505,226,230,413),(501,505,231,235,405),(501,505,236,240,398),(501,505,241,245,390),(501,505,246,250,383),(501,505,251,255,375),(501,505,256,260,368),(501,505,261,265,360),(501,505,266,270,353),(501,505,271,275,345),(501,505,276,280,338),(501,505,281,285,330),(501,505,286,290,323),(501,505,291,295,315),(501,505,296,300,308),(501,505,301,305,300),(501,505,306,310,293),(501,505,311,315,285),(501,505,316,320,278),(501,505,321,325,270),(501,505,326,330,263),(501,505,331,335,255),(501,505,336,340,248),(501,505,341,345,240),(501,505,346,350,233),(501,505,351,355,225),(501,505,356,360,218),(501,505,361,365,210),(501,505,366,370,203),(501,505,371,375,195),(501,505,376,380,188),(501,505,381,385,180),(501,505,386,390,173),(501,505,391,395,165),(501,505,396,400,158),(501,505,401,405,150),(501,505,406,410,143),(501,505,411,415,135),(501,505,416,420,128),(501,505,421,425,120),(501,505,426,430,113),(501,505,431,435,105),(501,505,436,440,98),(501,505,441,445,90),(501,505,446,450,83),(501,505,451,455,75),(501,505,456,460,68),(501,505,461,465,60),(501,505,466,470,53),(501,505,471,475,45),(501,505,476,480,38),(501,505,481,485,30),(501,505,486,490,0),(501,505,491,495,0),(501,505,496,1000,0),(506,510,0,150,0),(506,510,151,155,533),(506,510,156,160,525),(506,510,161,165,518),(506,510,166,170,510),(506,510,171,175,503),(506,510,176,180,495),(506,510,181,185,488),(506,510,186,190,480),(506,510,191,195,473),(506,510,196,200,465),(506,510,201,205,458),(506,510,206,210,450),(506,510,211,215,443),(506,510,216,220,435),(506,510,221,225,428),(506,510,226,230,420),(506,510,231,235,413),(506,510,236,240,405),(506,510,241,245,398),(506,510,246,250,390),(506,510,251,255,383),(506,510,256,260,375),(506,510,261,265,368),(506,510,266,270,360),(506,510,271,275,353),(506,510,276,280,345),(506,510,281,285,338),(506,510,286,290,330),(506,510,291,295,323),(506,510,296,300,315),(506,510,301,305,308),(506,510,306,310,300),(506,510,311,315,293),(506,510,316,320,285),(506,510,321,325,278),(506,510,326,330,270),(506,510,331,335,263),(506,510,336,340,255),(506,510,341,345,248),(506,510,346,350,240),(506,510,351,355,233),(506,510,356,360,225),(506,510,361,365,218),(506,510,366,370,210),(506,510,371,375,203),(506,510,376,380,195),(506,510,381,385,188),(506,510,386,390,180),(506,510,391,395,173),(506,510,396,400,165),(506,510,401,405,158),(506,510,406,410,150),(506,510,411,415,143),(506,510,416,420,135),(506,510,421,425,128),(506,510,426,430,120),(506,510,431,435,113),(506,510,436,440,105),(506,510,441,445,98),(506,510,446,450,90),(506,510,451,455,83),(506,510,456,460,75),(506,510,461,465,68),(506,510,466,470,60),(506,510,471,475,53),(506,510,476,480,45),(506,510,481,485,38),(506,510,486,490,30),(506,510,491,495,0),(506,510,496,500,0),(506,510,501,1000,0),(511,515,0,150,0),(511,515,151,155,540),(511,515,156,160,533),(511,515,161,165,525),(511,515,166,170,518),(511,515,171,175,510),(511,515,176,180,503),(511,515,181,185,495),(511,515,186,190,488),(511,515,191,195,480),(511,515,196,200,473),(511,515,201,205,465),(511,515,206,210,458),(511,515,211,215,450),(511,515,216,220,443),(511,515,221,225,435),(511,515,226,230,428),(511,515,231,235,420),(511,515,236,240,413),(511,515,241,245,405),(511,515,246,250,398),(511,515,251,255,390),(511,515,256,260,383),(511,515,261,265,375),(511,515,266,270,368),(511,515,271,275,360),(511,515,276,280,353),(511,515,281,285,345),(511,515,286,290,338),(511,515,291,295,330),(511,515,296,300,323),(511,515,301,305,315),(511,515,306,310,308),(511,515,311,315,300),(511,515,316,320,293),(511,515,321,325,285),(511,515,326,330,278),(511,515,331,335,270),(511,515,336,340,263),(511,515,341,345,255),(511,515,346,350,248),(511,515,351,355,240),(511,515,356,360,233),(511,515,361,365,225),(511,515,366,370,218),(511,515,371,375,210),(511,515,376,380,203),(511,515,381,385,195),(511,515,386,390,188),(511,515,391,395,180),(511,515,396,400,173),(511,515,401,405,165),(511,515,406,410,158),(511,515,411,415,150),(511,515,416,420,143),(511,515,421,425,135),(511,515,426,430,128),(511,515,431,435,120),(511,515,436,440,113),(511,515,441,445,105),(511,515,446,450,98),(511,515,451,455,90),(511,515,456,460,83),(511,515,461,465,75),(511,515,466,470,68),(511,515,471,475,60),(511,515,476,480,53),(511,515,481,485,45),(511,515,486,490,38),(511,515,491,495,30),(511,515,496,500,0),(511,515,501,505,0),(511,515,506,1000,0),(516,520,0,150,0),(516,520,151,155,548),(516,520,156,160,540),(516,520,161,165,533),(516,520,166,170,525),(516,520,171,175,518),(516,520,176,180,510),(516,520,181,185,503),(516,520,186,190,495),(516,520,191,195,488),(516,520,196,200,480),(516,520,201,205,473),(516,520,206,210,465),(516,520,211,215,458),(516,520,216,220,450),(516,520,221,225,443),(516,520,226,230,435),(516,520,231,235,428),(516,520,236,240,420),(516,520,241,245,413),(516,520,246,250,405),(516,520,251,255,398),(516,520,256,260,390),(516,520,261,265,383),(516,520,266,270,375),(516,520,271,275,368),(516,520,276,280,360),(516,520,281,285,353),(516,520,286,290,345),(516,520,291,295,338),(516,520,296,300,330),(516,520,301,305,323),(516,520,306,310,315),(516,520,311,315,308),(516,520,316,320,300),(516,520,321,325,293),(516,520,326,330,285),(516,520,331,335,278),(516,520,336,340,270),(516,520,341,345,263),(516,520,346,350,255),(516,520,351,355,248),(516,520,356,360,240),(516,520,361,365,233),(516,520,366,370,225),(516,520,371,375,218),(516,520,376,380,210),(516,520,381,385,203),(516,520,386,390,195),(516,520,391,395,188),(516,520,396,400,180),(516,520,401,405,173),(516,520,406,410,165),(516,520,411,415,158),(516,520,416,420,150),(516,520,421,425,143),(516,520,426,430,135),(516,520,431,435,128),(516,520,436,440,120),(516,520,441,445,113),(516,520,446,450,105),(516,520,451,455,98),(516,520,456,460,90),(516,520,461,465,83),(516,520,466,470,75),(516,520,471,475,68),(516,520,476,480,60),(516,520,481,485,53),(516,520,486,490,45),(516,520,491,495,38),(516,520,496,500,30),(516,520,501,505,0),(516,520,506,510,0),(516,520,511,1000,0),(521,525,0,150,0),(521,525,151,155,555),(521,525,156,160,548),(521,525,161,165,540),(521,525,166,170,533),(521,525,171,175,525),(521,525,176,180,518),(521,525,181,185,510),(521,525,186,190,503),(521,525,191,195,495),(521,525,196,200,488),(521,525,201,205,480),(521,525,206,210,473),(521,525,211,215,465),(521,525,216,220,458),(521,525,221,225,450),(521,525,226,230,443),(521,525,231,235,435),(521,525,236,240,428),(521,525,241,245,420),(521,525,246,250,413),(521,525,251,255,405),(521,525,256,260,398),(521,525,261,265,390),(521,525,266,270,383),(521,525,271,275,375),(521,525,276,280,368),(521,525,281,285,360),(521,525,286,290,353),(521,525,291,295,345),(521,525,296,300,338),(521,525,301,305,330),(521,525,306,310,323),(521,525,311,315,315),(521,525,316,320,308),(521,525,321,325,300),(521,525,326,330,293),(521,525,331,335,285),(521,525,336,340,278),(521,525,341,345,270),(521,525,346,350,263),(521,525,351,355,255),(521,525,356,360,248),(521,525,361,365,240),(521,525,366,370,233),(521,525,371,375,225),(521,525,376,380,218),(521,525,381,385,210),(521,525,386,390,203),(521,525,391,395,195),(521,525,396,400,188),(521,525,401,405,180),(521,525,406,410,173),(521,525,411,415,165),(521,525,416,420,158),(521,525,421,425,150),(521,525,426,430,143),(521,525,431,435,135),(521,525,436,440,128),(521,525,441,445,120),(521,525,446,450,113),(521,525,451,455,105),(521,525,456,460,98),(521,525,461,465,90),(521,525,466,470,83),(521,525,471,475,75),(521,525,476,480,68),(521,525,481,485,60),(521,525,486,490,53),(521,525,491,495,45),(521,525,496,500,38),(521,525,501,505,30),(521,525,506,510,0),(521,525,511,515,0),(521,525,516,1000,0),(526,530,0,150,0),(526,530,151,155,563),(526,530,156,160,555),(526,530,161,165,548),(526,530,166,170,540),(526,530,171,175,533),(526,530,176,180,525),(526,530,181,185,518),(526,530,186,190,510),(526,530,191,195,503),(526,530,196,200,495),(526,530,201,205,488),(526,530,206,210,480),(526,530,211,215,473),(526,530,216,220,465),(526,530,221,225,458),(526,530,226,230,450),(526,530,231,235,443),(526,530,236,240,435),(526,530,241,245,428),(526,530,246,250,420),(526,530,251,255,413),(526,530,256,260,405),(526,530,261,265,398),(526,530,266,270,390),(526,530,271,275,383),(526,530,276,280,375),(526,530,281,285,368),(526,530,286,290,360),(526,530,291,295,353),(526,530,296,300,345),(526,530,301,305,338),(526,530,306,310,330),(526,530,311,315,323),(526,530,316,320,315),(526,530,321,325,308),(526,530,326,330,300),(526,530,331,335,293),(526,530,336,340,285),(526,530,341,345,278),(526,530,346,350,270),(526,530,351,355,263),(526,530,356,360,255),(526,530,361,365,248),(526,530,366,370,240),(526,530,371,375,233),(526,530,376,380,225),(526,530,381,385,218),(526,530,386,390,210),(526,530,391,395,203),(526,530,396,400,195),(526,530,401,405,188),(526,530,406,410,180),(526,530,411,415,173),(526,530,416,420,165),(526,530,421,425,158),(526,530,426,430,150),(526,530,431,435,143),(526,530,436,440,135),(526,530,441,445,128),(526,530,446,450,120),(526,530,451,455,113),(526,530,456,460,105),(526,530,461,465,98),(526,530,466,470,90),(526,530,471,475,83),(526,530,476,480,75),(526,530,481,485,68),(526,530,486,490,60),(526,530,491,495,53),(526,530,496,500,45),(526,530,501,505,38),(526,530,506,510,30),(526,530,511,515,0),(526,530,516,520,0),(526,530,521,1000,0),(531,535,0,150,0),(531,535,151,155,570),(531,535,156,160,563),(531,535,161,165,555),(531,535,166,170,548),(531,535,171,175,540),(531,535,176,180,533),(531,535,181,185,525),(531,535,186,190,518),(531,535,191,195,510),(531,535,196,200,503),(531,535,201,205,495),(531,535,206,210,488),(531,535,211,215,480),(531,535,216,220,473),(531,535,221,225,465),(531,535,226,230,458),(531,535,231,235,450),(531,535,236,240,443),(531,535,241,245,435),(531,535,246,250,428),(531,535,251,255,420),(531,535,256,260,413),(531,535,261,265,405),(531,535,266,270,398),(531,535,271,275,390),(531,535,276,280,383),(531,535,281,285,375),(531,535,286,290,368),(531,535,291,295,360),(531,535,296,300,353),(531,535,301,305,345),(531,535,306,310,338),(531,535,311,315,330),(531,535,316,320,323),(531,535,321,325,315),(531,535,326,330,308),(531,535,331,335,300),(531,535,336,340,293),(531,535,341,345,285),(531,535,346,350,278),(531,535,351,355,270),(531,535,356,360,263),(531,535,361,365,255),(531,535,366,370,248),(531,535,371,375,240),(531,535,376,380,233),(531,535,381,385,225),(531,535,386,390,218),(531,535,391,395,210),(531,535,396,400,203),(531,535,401,405,195),(531,535,406,410,188),(531,535,411,415,180),(531,535,416,420,173),(531,535,421,425,165),(531,535,426,430,158),(531,535,431,435,150),(531,535,436,440,143),(531,535,441,445,135),(531,535,446,450,128),(531,535,451,455,120),(531,535,456,460,113),(531,535,461,465,105),(531,535,466,470,98),(531,535,471,475,90),(531,535,476,480,83),(531,535,481,485,75),(531,535,486,490,68),(531,535,491,495,60),(531,535,496,500,53),(531,535,501,505,45),(531,535,506,510,38),(531,535,511,515,30),(531,535,516,520,0),(531,535,521,525,0),(531,535,526,1000,0),(536,540,0,150,0),(536,540,151,155,578),(536,540,156,160,570),(536,540,161,165,563),(536,540,166,170,555),(536,540,171,175,548),(536,540,176,180,540),(536,540,181,185,533),(536,540,186,190,525),(536,540,191,195,518),(536,540,196,200,510),(536,540,201,205,503),(536,540,206,210,495),(536,540,211,215,488),(536,540,216,220,480),(536,540,221,225,473),(536,540,226,230,465),(536,540,231,235,458),(536,540,236,240,450),(536,540,241,245,443),(536,540,246,250,435),(536,540,251,255,428),(536,540,256,260,420),(536,540,261,265,413),(536,540,266,270,405),(536,540,271,275,398),(536,540,276,280,390),(536,540,281,285,383),(536,540,286,290,375),(536,540,291,295,368),(536,540,296,300,360),(536,540,301,305,353),(536,540,306,310,345),(536,540,311,315,338),(536,540,316,320,330),(536,540,321,325,323),(536,540,326,330,315),(536,540,331,335,308),(536,540,336,340,300),(536,540,341,345,293),(536,540,346,350,285),(536,540,351,355,278),(536,540,356,360,270),(536,540,361,365,263),(536,540,366,370,255),(536,540,371,375,248),(536,540,376,380,240),(536,540,381,385,233),(536,540,386,390,225),(536,540,391,395,218),(536,540,396,400,210),(536,540,401,405,203),(536,540,406,410,195),(536,540,411,415,188),(536,540,416,420,180),(536,540,421,425,173),(536,540,426,430,165),(536,540,431,435,158),(536,540,436,440,150),(536,540,441,445,143),(536,540,446,450,135),(536,540,451,455,128),(536,540,456,460,120),(536,540,461,465,113),(536,540,466,470,105),(536,540,471,475,98),(536,540,476,480,90),(536,540,481,485,83),(536,540,486,490,75),(536,540,491,495,68),(536,540,496,500,60),(536,540,501,505,53),(536,540,506,510,45),(536,540,511,515,38),(536,540,516,520,30),(536,540,521,525,0),(536,540,526,530,0),(536,540,531,1000,0),(541,545,0,150,0),(541,545,151,155,585),(541,545,156,160,578),(541,545,161,165,570),(541,545,166,170,563),(541,545,171,175,555),(541,545,176,180,548),(541,545,181,185,540),(541,545,186,190,533),(541,545,191,195,525),(541,545,196,200,518),(541,545,201,205,510),(541,545,206,210,503),(541,545,211,215,495),(541,545,216,220,488),(541,545,221,225,480),(541,545,226,230,473),(541,545,231,235,465),(541,545,236,240,458),(541,545,241,245,450),(541,545,246,250,443),(541,545,251,255,435),(541,545,256,260,428),(541,545,261,265,420),(541,545,266,270,413),(541,545,271,275,405),(541,545,276,280,398),(541,545,281,285,390),(541,545,286,290,383),(541,545,291,295,375),(541,545,296,300,368),(541,545,301,305,360),(541,545,306,310,353),(541,545,311,315,345),(541,545,316,320,338),(541,545,321,325,330),(541,545,326,330,323),(541,545,331,335,315),(541,545,336,340,308),(541,545,341,345,300),(541,545,346,350,293),(541,545,351,355,285),(541,545,356,360,278),(541,545,361,365,270),(541,545,366,370,263),(541,545,371,375,255),(541,545,376,380,248),(541,545,381,385,240),(541,545,386,390,233),(541,545,391,395,225),(541,545,396,400,218),(541,545,401,405,210),(541,545,406,410,203),(541,545,411,415,195),(541,545,416,420,188),(541,545,421,425,180),(541,545,426,430,173),(541,545,431,435,165),(541,545,436,440,158),(541,545,441,445,150),(541,545,446,450,143),(541,545,451,455,135),(541,545,456,460,128),(541,545,461,465,120),(541,545,466,470,113),(541,545,471,475,105),(541,545,476,480,98),(541,545,481,485,90),(541,545,486,490,83),(541,545,491,495,75),(541,545,496,500,68),(541,545,501,505,60),(541,545,506,510,53),(541,545,511,515,45),(541,545,516,520,38),(541,545,521,525,30),(541,545,526,530,0),(541,545,531,535,0),(541,545,536,1000,0),(546,550,0,150,0),(546,550,151,155,593),(546,550,156,160,585),(546,550,161,165,578),(546,550,166,170,570),(546,550,171,175,563),(546,550,176,180,555),(546,550,181,185,548),(546,550,186,190,540),(546,550,191,195,533),(546,550,196,200,525),(546,550,201,205,518),(546,550,206,210,510),(546,550,211,215,503),(546,550,216,220,495),(546,550,221,225,488),(546,550,226,230,480),(546,550,231,235,473),(546,550,236,240,465),(546,550,241,245,458),(546,550,246,250,450),(546,550,251,255,443),(546,550,256,260,435),(546,550,261,265,428),(546,550,266,270,420),(546,550,271,275,413),(546,550,276,280,405),(546,550,281,285,398),(546,550,286,290,390),(546,550,291,295,383),(546,550,296,300,375),(546,550,301,305,368),(546,550,306,310,360),(546,550,311,315,353),(546,550,316,320,345),(546,550,321,325,338),(546,550,326,330,330),(546,550,331,335,323),(546,550,336,340,315),(546,550,341,345,308),(546,550,346,350,300),(546,550,351,355,293),(546,550,356,360,285),(546,550,361,365,278),(546,550,366,370,270),(546,550,371,375,263),(546,550,376,380,255),(546,550,381,385,248),(546,550,386,390,240),(546,550,391,395,233),(546,550,396,400,225),(546,550,401,405,218),(546,550,406,410,210),(546,550,411,415,203),(546,550,416,420,195),(546,550,421,425,188),(546,550,426,430,180),(546,550,431,435,173),(546,550,436,440,165),(546,550,441,445,158),(546,550,446,450,150),(546,550,451,455,143),(546,550,456,460,135),(546,550,461,465,128),(546,550,466,470,120),(546,550,471,475,113),(546,550,476,480,105),(546,550,481,485,98),(546,550,486,490,90),(546,550,491,495,83),(546,550,496,500,75),(546,550,501,505,68),(546,550,506,510,60),(546,550,511,515,53),(546,550,516,520,45),(546,550,521,525,38),(546,550,526,530,30),(546,550,531,535,0),(546,550,536,540,0),(546,550,541,1000,0),(551,555,0,150,0),(551,555,151,155,600),(551,555,156,160,593),(551,555,161,165,585),(551,555,166,170,578),(551,555,171,175,570),(551,555,176,180,563),(551,555,181,185,555),(551,555,186,190,548),(551,555,191,195,540),(551,555,196,200,533),(551,555,201,205,525),(551,555,206,210,518),(551,555,211,215,510),(551,555,216,220,503),(551,555,221,225,495),(551,555,226,230,488),(551,555,231,235,480),(551,555,236,240,473),(551,555,241,245,465),(551,555,246,250,458),(551,555,251,255,450),(551,555,256,260,443),(551,555,261,265,435),(551,555,266,270,428),(551,555,271,275,420),(551,555,276,280,413),(551,555,281,285,405),(551,555,286,290,398),(551,555,291,295,390),(551,555,296,300,383),(551,555,301,305,375),(551,555,306,310,368),(551,555,311,315,360),(551,555,316,320,353),(551,555,321,325,345),(551,555,326,330,338),(551,555,331,335,330),(551,555,336,340,323),(551,555,341,345,315),(551,555,346,350,308),(551,555,351,355,300),(551,555,356,360,293),(551,555,361,365,285),(551,555,366,370,278),(551,555,371,375,270),(551,555,376,380,263),(551,555,381,385,255),(551,555,386,390,248),(551,555,391,395,240),(551,555,396,400,233),(551,555,401,405,225),(551,555,406,410,218),(551,555,411,415,210),(551,555,416,420,203),(551,555,421,425,195),(551,555,426,430,188),(551,555,431,435,180),(551,555,436,440,173),(551,555,441,445,165),(551,555,446,450,158),(551,555,451,455,150),(551,555,456,460,143),(551,555,461,465,135),(551,555,466,470,128),(551,555,471,475,120),(551,555,476,480,113),(551,555,481,485,105),(551,555,486,490,98),(551,555,491,495,90),(551,555,496,500,83),(551,555,501,505,75),(551,555,506,510,68),(551,555,511,515,60),(551,555,516,520,53),(551,555,521,525,45),(551,555,526,530,38),(551,555,531,535,30),(551,555,536,540,0),(551,555,541,545,0),(551,555,546,1000,0),(556,560,0,150,0),(556,560,151,155,608),(556,560,156,160,600),(556,560,161,165,593),(556,560,166,170,585),(556,560,171,175,578),(556,560,176,180,570),(556,560,181,185,563),(556,560,186,190,555),(556,560,191,195,548),(556,560,196,200,540),(556,560,201,205,533),(556,560,206,210,525),(556,560,211,215,518),(556,560,216,220,510),(556,560,221,225,503),(556,560,226,230,495),(556,560,231,235,488),(556,560,236,240,480),(556,560,241,245,473),(556,560,246,250,465),(556,560,251,255,458),(556,560,256,260,450),(556,560,261,265,443),(556,560,266,270,435),(556,560,271,275,428),(556,560,276,280,420),(556,560,281,285,413),(556,560,286,290,405),(556,560,291,295,398),(556,560,296,300,390),(556,560,301,305,383),(556,560,306,310,375),(556,560,311,315,368),(556,560,316,320,360),(556,560,321,325,353),(556,560,326,330,345),(556,560,331,335,338),(556,560,336,340,330),(556,560,341,345,323),(556,560,346,350,315),(556,560,351,355,308),(556,560,356,360,300),(556,560,361,365,293),(556,560,366,370,285),(556,560,371,375,278),(556,560,376,380,270),(556,560,381,385,263),(556,560,386,390,255),(556,560,391,395,248),(556,560,396,400,240),(556,560,401,405,233),(556,560,406,410,225),(556,560,411,415,218),(556,560,416,420,210),(556,560,421,425,203),(556,560,426,430,195),(556,560,431,435,188),(556,560,436,440,180),(556,560,441,445,173),(556,560,446,450,165),(556,560,451,455,158),(556,560,456,460,150),(556,560,461,465,143),(556,560,466,470,135),(556,560,471,475,128),(556,560,476,480,120),(556,560,481,485,113),(556,560,486,490,105),(556,560,491,495,98),(556,560,496,500,90),(556,560,501,505,83),(556,560,506,510,75),(556,560,511,515,68),(556,560,516,520,60),(556,560,521,525,53),(556,560,526,530,45),(556,560,531,535,38),(556,560,536,540,30),(556,560,541,545,0),(556,560,546,550,0),(556,560,551,1000,0),(561,565,0,150,0),(561,565,151,155,615),(561,565,156,160,608),(561,565,161,165,600),(561,565,166,170,593),(561,565,171,175,585),(561,565,176,180,578),(561,565,181,185,570),(561,565,186,190,563),(561,565,191,195,555),(561,565,196,200,548),(561,565,201,205,540),(561,565,206,210,533),(561,565,211,215,525),(561,565,216,220,518),(561,565,221,225,510),(561,565,226,230,503),(561,565,231,235,495),(561,565,236,240,488),(561,565,241,245,480),(561,565,246,250,473),(561,565,251,255,465),(561,565,256,260,458),(561,565,261,265,450),(561,565,266,270,443),(561,565,271,275,435),(561,565,276,280,428),(561,565,281,285,420),(561,565,286,290,413),(561,565,291,295,405),(561,565,296,300,398),(561,565,301,305,390),(561,565,306,310,383),(561,565,311,315,375),(561,565,316,320,368),(561,565,321,325,360),(561,565,326,330,353),(561,565,331,335,345),(561,565,336,340,338),(561,565,341,345,330),(561,565,346,350,323),(561,565,351,355,315),(561,565,356,360,308),(561,565,361,365,300),(561,565,366,370,293),(561,565,371,375,285),(561,565,376,380,278),(561,565,381,385,270),(561,565,386,390,263),(561,565,391,395,255),(561,565,396,400,248),(561,565,401,405,240),(561,565,406,410,233),(561,565,411,415,225),(561,565,416,420,218),(561,565,421,425,210),(561,565,426,430,203),(561,565,431,435,195),(561,565,436,440,188),(561,565,441,445,180),(561,565,446,450,173),(561,565,451,455,165),(561,565,456,460,158),(561,565,461,465,150),(561,565,466,470,143),(561,565,471,475,135),(561,565,476,480,128),(561,565,481,485,120),(561,565,486,490,113),(561,565,491,495,105),(561,565,496,500,98),(561,565,501,505,90),(561,565,506,510,83),(561,565,511,515,75),(561,565,516,520,68),(561,565,521,525,60),(561,565,526,530,53),(561,565,531,535,45),(561,565,536,540,38),(561,565,541,545,30),(561,565,546,550,0),(561,565,551,555,0),(561,565,556,1000,0),(566,570,0,150,0),(566,570,151,155,623),(566,570,156,160,615),(566,570,161,165,608),(566,570,166,170,600),(566,570,171,175,593),(566,570,176,180,585),(566,570,181,185,578),(566,570,186,190,570),(566,570,191,195,563),(566,570,196,200,555),(566,570,201,205,548),(566,570,206,210,540),(566,570,211,215,533),(566,570,216,220,525),(566,570,221,225,518),(566,570,226,230,510),(566,570,231,235,503),(566,570,236,240,495),(566,570,241,245,488),(566,570,246,250,480),(566,570,251,255,473),(566,570,256,260,465),(566,570,261,265,458),(566,570,266,270,450),(566,570,271,275,443),(566,570,276,280,435),(566,570,281,285,428),(566,570,286,290,420),(566,570,291,295,413),(566,570,296,300,405),(566,570,301,305,398),(566,570,306,310,390),(566,570,311,315,383),(566,570,316,320,375),(566,570,321,325,368),(566,570,326,330,360),(566,570,331,335,353),(566,570,336,340,345),(566,570,341,345,338),(566,570,346,350,330),(566,570,351,355,323),(566,570,356,360,315),(566,570,361,365,308),(566,570,366,370,300),(566,570,371,375,293),(566,570,376,380,285),(566,570,381,385,278),(566,570,386,390,270),(566,570,391,395,263),(566,570,396,400,255),(566,570,401,405,248),(566,570,406,410,240),(566,570,411,415,233),(566,570,416,420,225),(566,570,421,425,218),(566,570,426,430,210),(566,570,431,435,203),(566,570,436,440,195),(566,570,441,445,188),(566,570,446,450,180),(566,570,451,455,173),(566,570,456,460,165),(566,570,461,465,158),(566,570,466,470,150),(566,570,471,475,143),(566,570,476,480,135),(566,570,481,485,128),(566,570,486,490,120),(566,570,491,495,113),(566,570,496,500,105),(566,570,501,505,98),(566,570,506,510,90),(566,570,511,515,83),(566,570,516,520,75),(566,570,521,525,68),(566,570,526,530,60),(566,570,531,535,53),(566,570,536,540,45),(566,570,541,545,38),(566,570,546,550,30),(566,570,551,555,0),(566,570,556,560,0),(566,570,561,1000,0),(571,575,0,150,0),(571,575,151,155,630),(571,575,156,160,623),(571,575,161,165,615),(571,575,166,170,608),(571,575,171,175,600),(571,575,176,180,593),(571,575,181,185,585),(571,575,186,190,578),(571,575,191,195,570),(571,575,196,200,563),(571,575,201,205,555),(571,575,206,210,548),(571,575,211,215,540),(571,575,216,220,533),(571,575,221,225,525),(571,575,226,230,518),(571,575,231,235,510),(571,575,236,240,503),(571,575,241,245,495),(571,575,246,250,488),(571,575,251,255,480),(571,575,256,260,473),(571,575,261,265,465),(571,575,266,270,458),(571,575,271,275,450),(571,575,276,280,443),(571,575,281,285,435),(571,575,286,290,428),(571,575,291,295,420),(571,575,296,300,413),(571,575,301,305,405),(571,575,306,310,398),(571,575,311,315,390),(571,575,316,320,383),(571,575,321,325,375),(571,575,326,330,368),(571,575,331,335,360),(571,575,336,340,353),(571,575,341,345,345),(571,575,346,350,338),(571,575,351,355,330),(571,575,356,360,323),(571,575,361,365,315),(571,575,366,370,308),(571,575,371,375,300),(571,575,376,380,293),(571,575,381,385,285),(571,575,386,390,278),(571,575,391,395,270),(571,575,396,400,263),(571,575,401,405,255),(571,575,406,410,248),(571,575,411,415,240),(571,575,416,420,233),(571,575,421,425,225),(571,575,426,430,218),(571,575,431,435,210),(571,575,436,440,203),(571,575,441,445,195),(571,575,446,450,188),(571,575,451,455,180),(571,575,456,460,173),(571,575,461,465,165),(571,575,466,470,158),(571,575,471,475,150),(571,575,476,480,143),(571,575,481,485,135),(571,575,486,490,128),(571,575,491,495,120),(571,575,496,500,113),(571,575,501,505,105),(571,575,506,510,98),(571,575,511,515,90),(571,575,516,520,83),(571,575,521,525,75),(571,575,526,530,68),(571,575,531,535,60),(571,575,536,540,53),(571,575,541,545,45),(571,575,546,550,38),(571,575,551,555,30),(571,575,556,560,0),(571,575,561,565,0),(571,575,566,1000,0),(576,580,0,150,0),(576,580,151,155,638),(576,580,156,160,630),(576,580,161,165,623),(576,580,166,170,615),(576,580,171,175,608),(576,580,176,180,600),(576,580,181,185,593),(576,580,186,190,585),(576,580,191,195,578),(576,580,196,200,570),(576,580,201,205,563),(576,580,206,210,555),(576,580,211,215,548),(576,580,216,220,540),(576,580,221,225,533),(576,580,226,230,525),(576,580,231,235,518),(576,580,236,240,510),(576,580,241,245,503),(576,580,246,250,495),(576,580,251,255,488),(576,580,256,260,480),(576,580,261,265,473),(576,580,266,270,465),(576,580,271,275,458),(576,580,276,280,450),(576,580,281,285,443),(576,580,286,290,435),(576,580,291,295,428),(576,580,296,300,420),(576,580,301,305,413),(576,580,306,310,405),(576,580,311,315,398),(576,580,316,320,390),(576,580,321,325,383),(576,580,326,330,375),(576,580,331,335,368),(576,580,336,340,360),(576,580,341,345,353),(576,580,346,350,345),(576,580,351,355,338),(576,580,356,360,330),(576,580,361,365,323),(576,580,366,370,315),(576,580,371,375,308),(576,580,376,380,300),(576,580,381,385,293),(576,580,386,390,285),(576,580,391,395,278),(576,580,396,400,270),(576,580,401,405,263),(576,580,406,410,255),(576,580,411,415,248),(576,580,416,420,240),(576,580,421,425,233),(576,580,426,430,225),(576,580,431,435,218),(576,580,436,440,210),(576,580,441,445,203),(576,580,446,450,195),(576,580,451,455,188),(576,580,456,460,180),(576,580,461,465,173),(576,580,466,470,165),(576,580,471,475,158),(576,580,476,480,150),(576,580,481,485,143),(576,580,486,490,135),(576,580,491,495,128),(576,580,496,500,120),(576,580,501,505,113),(576,580,506,510,105),(576,580,511,515,98),(576,580,516,520,90),(576,580,521,525,83),(576,580,526,530,75),(576,580,531,535,68),(576,580,536,540,60),(576,580,541,545,53),(576,580,546,550,45),(576,580,551,555,38),(576,580,556,560,30),(576,580,561,565,0),(576,580,566,570,0),(576,580,571,1000,0),(581,585,0,150,0),(581,585,151,155,645),(581,585,156,160,638),(581,585,161,165,630),(581,585,166,170,623),(581,585,171,175,615),(581,585,176,180,608),(581,585,181,185,600),(581,585,186,190,593),(581,585,191,195,585),(581,585,196,200,578),(581,585,201,205,570),(581,585,206,210,563),(581,585,211,215,555),(581,585,216,220,548),(581,585,221,225,540),(581,585,226,230,533),(581,585,231,235,525),(581,585,236,240,518),(581,585,241,245,510),(581,585,246,250,503),(581,585,251,255,495),(581,585,256,260,488),(581,585,261,265,480),(581,585,266,270,473),(581,585,271,275,465),(581,585,276,280,458),(581,585,281,285,450),(581,585,286,290,443),(581,585,291,295,435),(581,585,296,300,428),(581,585,301,305,420),(581,585,306,310,413),(581,585,311,315,405),(581,585,316,320,398),(581,585,321,325,390),(581,585,326,330,383),(581,585,331,335,375),(581,585,336,340,368),(581,585,341,345,360),(581,585,346,350,353),(581,585,351,355,345),(581,585,356,360,338),(581,585,361,365,330),(581,585,366,370,323),(581,585,371,375,315),(581,585,376,380,308),(581,585,381,385,300),(581,585,386,390,293),(581,585,391,395,285),(581,585,396,400,278),(581,585,401,405,270),(581,585,406,410,263),(581,585,411,415,255),(581,585,416,420,248),(581,585,421,425,240),(581,585,426,430,233),(581,585,431,435,225),(581,585,436,440,218),(581,585,441,445,210),(581,585,446,450,203),(581,585,451,455,195),(581,585,456,460,188),(581,585,461,465,180),(581,585,466,470,173),(581,585,471,475,165),(581,585,476,480,158),(581,585,481,485,150),(581,585,486,490,143),(581,585,491,495,135),(581,585,496,500,128),(581,585,501,505,120),(581,585,506,510,113),(581,585,511,515,105),(581,585,516,520,98),(581,585,521,525,90),(581,585,526,530,83),(581,585,531,535,75),(581,585,536,540,68),(581,585,541,545,60),(581,585,546,550,53),(581,585,551,555,45),(581,585,556,560,38),(581,585,561,565,30),(581,585,566,570,0),(581,585,571,575,0),(581,585,576,1000,0),(586,590,0,150,0),(586,590,151,155,653),(586,590,156,160,645),(586,590,161,165,638),(586,590,166,170,630),(586,590,171,175,623),(586,590,176,180,615),(586,590,181,185,608),(586,590,186,190,600),(586,590,191,195,593),(586,590,196,200,585),(586,590,201,205,578),(586,590,206,210,570),(586,590,211,215,563),(586,590,216,220,555),(586,590,221,225,548),(586,590,226,230,540),(586,590,231,235,533),(586,590,236,240,525),(586,590,241,245,518),(586,590,246,250,510),(586,590,251,255,503),(586,590,256,260,495),(586,590,261,265,488),(586,590,266,270,480),(586,590,271,275,473),(586,590,276,280,465),(586,590,281,285,458),(586,590,286,290,450),(586,590,291,295,443),(586,590,296,300,435),(586,590,301,305,428),(586,590,306,310,420),(586,590,311,315,413),(586,590,316,320,405),(586,590,321,325,398),(586,590,326,330,390),(586,590,331,335,383),(586,590,336,340,375),(586,590,341,345,368),(586,590,346,350,360),(586,590,351,355,353),(586,590,356,360,345),(586,590,361,365,338),(586,590,366,370,330),(586,590,371,375,323),(586,590,376,380,315),(586,590,381,385,308),(586,590,386,390,300),(586,590,391,395,293),(586,590,396,400,285),(586,590,401,405,278),(586,590,406,410,270),(586,590,411,415,263),(586,590,416,420,255),(586,590,421,425,248),(586,590,426,430,240),(586,590,431,435,233),(586,590,436,440,225),(586,590,441,445,218),(586,590,446,450,210),(586,590,451,455,203),(586,590,456,460,195),(586,590,461,465,188),(586,590,466,470,180),(586,590,471,475,173),(586,590,476,480,165),(586,590,481,485,158),(586,590,486,490,150),(586,590,491,495,143),(586,590,496,500,135),(586,590,501,505,128),(586,590,506,510,120),(586,590,511,515,113),(586,590,516,520,105),(586,590,521,525,98),(586,590,526,530,90),(586,590,531,535,83),(586,590,536,540,75),(586,590,541,545,68),(586,590,546,550,60),(586,590,551,555,53),(586,590,556,560,45),(586,590,561,565,38),(586,590,566,570,30),(586,590,571,575,0),(586,590,576,580,0),(586,590,581,1000,0),(591,595,0,150,0),(591,595,151,155,660),(591,595,156,160,653),(591,595,161,165,645),(591,595,166,170,638),(591,595,171,175,630),(591,595,176,180,623),(591,595,181,185,615),(591,595,186,190,608),(591,595,191,195,600),(591,595,196,200,593),(591,595,201,205,585),(591,595,206,210,578),(591,595,211,215,570),(591,595,216,220,563),(591,595,221,225,555),(591,595,226,230,548),(591,595,231,235,540),(591,595,236,240,533),(591,595,241,245,525),(591,595,246,250,518),(591,595,251,255,510),(591,595,256,260,503),(591,595,261,265,495),(591,595,266,270,488),(591,595,271,275,480),(591,595,276,280,473),(591,595,281,285,465),(591,595,286,290,458),(591,595,291,295,450),(591,595,296,300,443),(591,595,301,305,435),(591,595,306,310,428),(591,595,311,315,420),(591,595,316,320,413),(591,595,321,325,405),(591,595,326,330,398),(591,595,331,335,390),(591,595,336,340,383),(591,595,341,345,375),(591,595,346,350,368),(591,595,351,355,360),(591,595,356,360,353),(591,595,361,365,345),(591,595,366,370,338),(591,595,371,375,330),(591,595,376,380,323),(591,595,381,385,315),(591,595,386,390,308),(591,595,391,395,300),(591,595,396,400,293),(591,595,401,405,285),(591,595,406,410,278),(591,595,411,415,270),(591,595,416,420,263),(591,595,421,425,255),(591,595,426,430,248),(591,595,431,435,240),(591,595,436,440,233),(591,595,441,445,225),(591,595,446,450,218),(591,595,451,455,210),(591,595,456,460,203),(591,595,461,465,195),(591,595,466,470,188),(591,595,471,475,180),(591,595,476,480,173),(591,595,481,485,165),(591,595,486,490,158),(591,595,491,495,150),(591,595,496,500,143),(591,595,501,505,135),(591,595,506,510,128),(591,595,511,515,120),(591,595,516,520,113),(591,595,521,525,105),(591,595,526,530,98),(591,595,531,535,90),(591,595,536,540,83),(591,595,541,545,75),(591,595,546,550,68),(591,595,551,555,60),(591,595,556,560,53),(591,595,561,565,45),(591,595,566,570,38),(591,595,571,575,30),(591,595,576,580,0),(591,595,581,585,0),(591,595,586,1000,0),(596,600,0,150,0),(596,600,151,155,668),(596,600,156,160,660),(596,600,161,165,653),(596,600,166,170,645),(596,600,171,175,638),(596,600,176,180,630),(596,600,181,185,623),(596,600,186,190,615),(596,600,191,195,608),(596,600,196,200,600),(596,600,201,205,593),(596,600,206,210,585),(596,600,211,215,578),(596,600,216,220,570),(596,600,221,225,563),(596,600,226,230,555),(596,600,231,235,548),(596,600,236,240,540),(596,600,241,245,533),(596,600,246,250,525),(596,600,251,255,518),(596,600,256,260,510),(596,600,261,265,503),(596,600,266,270,495),(596,600,271,275,488),(596,600,276,280,480),(596,600,281,285,473),(596,600,286,290,465),(596,600,291,295,458),(596,600,296,300,450),(596,600,301,305,443),(596,600,306,310,435),(596,600,311,315,428),(596,600,316,320,420),(596,600,321,325,413),(596,600,326,330,405),(596,600,331,335,398),(596,600,336,340,390),(596,600,341,345,383),(596,600,346,350,375),(596,600,351,355,368),(596,600,356,360,360),(596,600,361,365,353),(596,600,366,370,345),(596,600,371,375,338),(596,600,376,380,330),(596,600,381,385,323),(596,600,386,390,315),(596,600,391,395,308),(596,600,396,400,300),(596,600,401,405,293),(596,600,406,410,285),(596,600,411,415,278),(596,600,416,420,270),(596,600,421,425,263),(596,600,426,430,255),(596,600,431,435,248),(596,600,436,440,240),(596,600,441,445,233),(596,600,446,450,225),(596,600,451,455,218),(596,600,456,460,210),(596,600,461,465,203),(596,600,466,470,195),(596,600,471,475,188),(596,600,476,480,180),(596,600,481,485,173),(596,600,486,490,165),(596,600,491,495,158),(596,600,496,500,150),(596,600,501,505,143),(596,600,506,510,135),(596,600,511,515,128),(596,600,516,520,120),(596,600,521,525,113),(596,600,526,530,105),(596,600,531,535,98),(596,600,536,540,90),(596,600,541,545,83),(596,600,546,550,75),(596,600,551,555,68),(596,600,556,560,60),(596,600,561,565,53),(596,600,566,570,45),(596,600,571,575,38),(596,600,576,580,30),(596,600,581,585,0),(596,600,586,590,0),(596,600,591,1000,0),(601,605,0,150,0),(601,605,151,155,675),(601,605,156,160,668),(601,605,161,165,660),(601,605,166,170,653),(601,605,171,175,645),(601,605,176,180,638),(601,605,181,185,630),(601,605,186,190,623),(601,605,191,195,615),(601,605,196,200,608),(601,605,201,205,600),(601,605,206,210,593),(601,605,211,215,585),(601,605,216,220,578),(601,605,221,225,570),(601,605,226,230,563),(601,605,231,235,555),(601,605,236,240,548),(601,605,241,245,540),(601,605,246,250,533),(601,605,251,255,525),(601,605,256,260,518),(601,605,261,265,510),(601,605,266,270,503),(601,605,271,275,495),(601,605,276,280,488),(601,605,281,285,480),(601,605,286,290,473),(601,605,291,295,465),(601,605,296,300,458),(601,605,301,305,450),(601,605,306,310,443),(601,605,311,315,435),(601,605,316,320,428),(601,605,321,325,420),(601,605,326,330,413),(601,605,331,335,405),(601,605,336,340,398),(601,605,341,345,390),(601,605,346,350,383),(601,605,351,355,375),(601,605,356,360,368),(601,605,361,365,360),(601,605,366,370,353),(601,605,371,375,345),(601,605,376,380,338),(601,605,381,385,330),(601,605,386,390,323),(601,605,391,395,315),(601,605,396,400,308),(601,605,401,405,300),(601,605,406,410,293),(601,605,411,415,285),(601,605,416,420,278),(601,605,421,425,270),(601,605,426,430,263),(601,605,431,435,255),(601,605,436,440,248),(601,605,441,445,240),(601,605,446,450,233),(601,605,451,455,225),(601,605,456,460,218),(601,605,461,465,210),(601,605,466,470,203),(601,605,471,475,195),(601,605,476,480,188),(601,605,481,485,180),(601,605,486,490,173),(601,605,491,495,165),(601,605,496,500,158),(601,605,501,505,150),(601,605,506,510,143),(601,605,511,515,135),(601,605,516,520,128),(601,605,521,525,120),(601,605,526,530,113),(601,605,531,535,105),(601,605,536,540,98),(601,605,541,545,90),(601,605,546,550,83),(601,605,551,555,75),(601,605,556,560,68),(601,605,561,565,60),(601,605,566,570,53),(601,605,571,575,45),(601,605,576,580,38),(601,605,581,585,30),(601,605,586,590,0),(601,605,591,595,0),(601,605,596,1000,0),(606,610,0,150,0),(606,610,151,155,683),(606,610,156,160,675),(606,610,161,165,668),(606,610,166,170,660),(606,610,171,175,653),(606,610,176,180,645),(606,610,181,185,638),(606,610,186,190,630),(606,610,191,195,623),(606,610,196,200,615),(606,610,201,205,608),(606,610,206,210,600),(606,610,211,215,593),(606,610,216,220,585),(606,610,221,225,578),(606,610,226,230,570),(606,610,231,235,563),(606,610,236,240,555),(606,610,241,245,548),(606,610,246,250,540),(606,610,251,255,533),(606,610,256,260,525),(606,610,261,265,518),(606,610,266,270,510),(606,610,271,275,503),(606,610,276,280,495),(606,610,281,285,488),(606,610,286,290,480),(606,610,291,295,473),(606,610,296,300,465),(606,610,301,305,458),(606,610,306,310,450),(606,610,311,315,443),(606,610,316,320,435),(606,610,321,325,428),(606,610,326,330,420),(606,610,331,335,413),(606,610,336,340,405),(606,610,341,345,398),(606,610,346,350,390),(606,610,351,355,383),(606,610,356,360,375),(606,610,361,365,368),(606,610,366,370,360),(606,610,371,375,353),(606,610,376,380,345),(606,610,381,385,338),(606,610,386,390,330),(606,610,391,395,323),(606,610,396,400,315),(606,610,401,405,308),(606,610,406,410,300),(606,610,411,415,293),(606,610,416,420,285),(606,610,421,425,278),(606,610,426,430,270),(606,610,431,435,263),(606,610,436,440,255),(606,610,441,445,248),(606,610,446,450,240),(606,610,451,455,233),(606,610,456,460,225),(606,610,461,465,218),(606,610,466,470,210),(606,610,471,475,203),(606,610,476,480,195),(606,610,481,485,188),(606,610,486,490,180),(606,610,491,495,173),(606,610,496,500,165),(606,610,501,505,158),(606,610,506,510,150),(606,610,511,515,143),(606,610,516,520,135),(606,610,521,525,128),(606,610,526,530,120),(606,610,531,535,113),(606,610,536,540,105),(606,610,541,545,98),(606,610,546,550,90),(606,610,551,555,83),(606,610,556,560,75),(606,610,561,565,68),(606,610,566,570,60),(606,610,571,575,53),(606,610,576,580,45),(606,610,581,585,38),(606,610,586,590,30),(606,610,591,595,0),(606,610,596,600,0),(606,610,601,1000,0),(611,615,0,150,0),(611,615,151,155,690),(611,615,156,160,683),(611,615,161,165,675),(611,615,166,170,668),(611,615,171,175,660),(611,615,176,180,653),(611,615,181,185,645),(611,615,186,190,638),(611,615,191,195,630),(611,615,196,200,623),(611,615,201,205,615),(611,615,206,210,608),(611,615,211,215,600),(611,615,216,220,593),(611,615,221,225,585),(611,615,226,230,578),(611,615,231,235,570),(611,615,236,240,563),(611,615,241,245,555),(611,615,246,250,548),(611,615,251,255,540),(611,615,256,260,533),(611,615,261,265,525),(611,615,266,270,518),(611,615,271,275,510),(611,615,276,280,503),(611,615,281,285,495),(611,615,286,290,488),(611,615,291,295,480),(611,615,296,300,473),(611,615,301,305,465),(611,615,306,310,458),(611,615,311,315,450),(611,615,316,320,443),(611,615,321,325,435),(611,615,326,330,428),(611,615,331,335,420),(611,615,336,340,413),(611,615,341,345,405),(611,615,346,350,398),(611,615,351,355,390),(611,615,356,360,383),(611,615,361,365,375),(611,615,366,370,368),(611,615,371,375,360),(611,615,376,380,353),(611,615,381,385,345),(611,615,386,390,338),(611,615,391,395,330),(611,615,396,400,323),(611,615,401,405,315),(611,615,406,410,308),(611,615,411,415,300),(611,615,416,420,293),(611,615,421,425,285),(611,615,426,430,278),(611,615,431,435,270),(611,615,436,440,263),(611,615,441,445,255),(611,615,446,450,248),(611,615,451,455,240),(611,615,456,460,233),(611,615,461,465,225),(611,615,466,470,218),(611,615,471,475,210),(611,615,476,480,203),(611,615,481,485,195),(611,615,486,490,188),(611,615,491,495,180),(611,615,496,500,173),(611,615,501,505,165),(611,615,506,510,158),(611,615,511,515,150),(611,615,516,520,143),(611,615,521,525,135),(611,615,526,530,128),(611,615,531,535,120),(611,615,536,540,113),(611,615,541,545,105),(611,615,546,550,98),(611,615,551,555,90),(611,615,556,560,83),(611,615,561,565,75),(611,615,566,570,68),(611,615,571,575,60),(611,615,576,580,53),(611,615,581,585,45),(611,615,586,590,38),(611,615,591,595,30),(611,615,596,600,0),(611,615,601,605,0),(611,615,606,1000,0),(616,620,0,150,0),(616,620,151,155,698),(616,620,156,160,690),(616,620,161,165,683),(616,620,166,170,675),(616,620,171,175,668),(616,620,176,180,660),(616,620,181,185,653),(616,620,186,190,645),(616,620,191,195,638),(616,620,196,200,630),(616,620,201,205,623),(616,620,206,210,615),(616,620,211,215,608),(616,620,216,220,600),(616,620,221,225,593),(616,620,226,230,585),(616,620,231,235,578),(616,620,236,240,570),(616,620,241,245,563),(616,620,246,250,555),(616,620,251,255,548),(616,620,256,260,540),(616,620,261,265,533),(616,620,266,270,525),(616,620,271,275,518),(616,620,276,280,510),(616,620,281,285,503),(616,620,286,290,495),(616,620,291,295,488),(616,620,296,300,480),(616,620,301,305,473),(616,620,306,310,465),(616,620,311,315,458),(616,620,316,320,450),(616,620,321,325,443),(616,620,326,330,435),(616,620,331,335,428),(616,620,336,340,420),(616,620,341,345,413),(616,620,346,350,405),(616,620,351,355,398),(616,620,356,360,390),(616,620,361,365,383),(616,620,366,370,375),(616,620,371,375,368),(616,620,376,380,360),(616,620,381,385,353),(616,620,386,390,345),(616,620,391,395,338),(616,620,396,400,330),(616,620,401,405,323),(616,620,406,410,315),(616,620,411,415,308),(616,620,416,420,300),(616,620,421,425,293),(616,620,426,430,285),(616,620,431,435,278),(616,620,436,440,270),(616,620,441,445,263),(616,620,446,450,255),(616,620,451,455,248),(616,620,456,460,240),(616,620,461,465,233),(616,620,466,470,225),(616,620,471,475,218),(616,620,476,480,210),(616,620,481,485,203),(616,620,486,490,195),(616,620,491,495,188),(616,620,496,500,180),(616,620,501,505,173),(616,620,506,510,165),(616,620,511,515,158),(616,620,516,520,150),(616,620,521,525,143),(616,620,526,530,135),(616,620,531,535,128),(616,620,536,540,120),(616,620,541,545,113),(616,620,546,550,105),(616,620,551,555,98),(616,620,556,560,90),(616,620,561,565,83),(616,620,566,570,75),(616,620,571,575,68),(616,620,576,580,60),(616,620,581,585,53),(616,620,586,590,45),(616,620,591,595,38),(616,620,596,600,30),(616,620,601,605,0),(616,620,606,610,0),(616,620,611,1000,0),(621,625,0,150,0),(621,625,151,155,705),(621,625,156,160,698),(621,625,161,165,690),(621,625,166,170,683),(621,625,171,175,675),(621,625,176,180,668),(621,625,181,185,660),(621,625,186,190,653),(621,625,191,195,645),(621,625,196,200,638),(621,625,201,205,630),(621,625,206,210,623),(621,625,211,215,615),(621,625,216,220,608),(621,625,221,225,600),(621,625,226,230,593),(621,625,231,235,585),(621,625,236,240,578),(621,625,241,245,570),(621,625,246,250,563),(621,625,251,255,555),(621,625,256,260,548),(621,625,261,265,540),(621,625,266,270,533),(621,625,271,275,525),(621,625,276,280,518),(621,625,281,285,510),(621,625,286,290,503),(621,625,291,295,495),(621,625,296,300,488),(621,625,301,305,480),(621,625,306,310,473),(621,625,311,315,465),(621,625,316,320,458),(621,625,321,325,450),(621,625,326,330,443),(621,625,331,335,435),(621,625,336,340,428),(621,625,341,345,420),(621,625,346,350,413),(621,625,351,355,405),(621,625,356,360,398),(621,625,361,365,390),(621,625,366,370,383),(621,625,371,375,375),(621,625,376,380,368),(621,625,381,385,360),(621,625,386,390,353),(621,625,391,395,345),(621,625,396,400,338),(621,625,401,405,330),(621,625,406,410,323),(621,625,411,415,315),(621,625,416,420,308),(621,625,421,425,300),(621,625,426,430,293),(621,625,431,435,285),(621,625,436,440,278),(621,625,441,445,270),(621,625,446,450,263),(621,625,451,455,255),(621,625,456,460,248),(621,625,461,465,240),(621,625,466,470,233),(621,625,471,475,225),(621,625,476,480,218),(621,625,481,485,210),(621,625,486,490,203),(621,625,491,495,195),(621,625,496,500,188),(621,625,501,505,180),(621,625,506,510,173),(621,625,511,515,165),(621,625,516,520,158),(621,625,521,525,150),(621,625,526,530,143),(621,625,531,535,135),(621,625,536,540,128),(621,625,541,545,120),(621,625,546,550,113),(621,625,551,555,105),(621,625,556,560,98),(621,625,561,565,90),(621,625,566,570,83),(621,625,571,575,75),(621,625,576,580,68),(621,625,581,585,60),(621,625,586,590,53),(621,625,591,595,45),(621,625,596,600,38),(621,625,601,605,30),(621,625,606,610,0),(621,625,611,615,0),(621,625,616,1000,0),(626,630,0,150,0),(626,630,151,155,713),(626,630,156,160,705),(626,630,161,165,698),(626,630,166,170,690),(626,630,171,175,683),(626,630,176,180,675),(626,630,181,185,668),(626,630,186,190,660),(626,630,191,195,653),(626,630,196,200,645),(626,630,201,205,638),(626,630,206,210,630),(626,630,211,215,623),(626,630,216,220,615),(626,630,221,225,608),(626,630,226,230,600),(626,630,231,235,593),(626,630,236,240,585),(626,630,241,245,578),(626,630,246,250,570),(626,630,251,255,563),(626,630,256,260,555),(626,630,261,265,548),(626,630,266,270,540),(626,630,271,275,533),(626,630,276,280,525),(626,630,281,285,518),(626,630,286,290,510),(626,630,291,295,503),(626,630,296,300,495),(626,630,301,305,488),(626,630,306,310,480),(626,630,311,315,473),(626,630,316,320,465),(626,630,321,325,458),(626,630,326,330,450),(626,630,331,335,443),(626,630,336,340,435),(626,630,341,345,428),(626,630,346,350,420),(626,630,351,355,413),(626,630,356,360,405),(626,630,361,365,398),(626,630,366,370,390),(626,630,371,375,383),(626,630,376,380,375),(626,630,381,385,368),(626,630,386,390,360),(626,630,391,395,353),(626,630,396,400,345),(626,630,401,405,338),(626,630,406,410,330),(626,630,411,415,323),(626,630,416,420,315),(626,630,421,425,308),(626,630,426,430,300),(626,630,431,435,293),(626,630,436,440,285),(626,630,441,445,278),(626,630,446,450,270),(626,630,451,455,263),(626,630,456,460,255),(626,630,461,465,248),(626,630,466,470,240),(626,630,471,475,233),(626,630,476,480,225),(626,630,481,485,218),(626,630,486,490,210),(626,630,491,495,203),(626,630,496,500,195),(626,630,501,505,188),(626,630,506,510,180),(626,630,511,515,173),(626,630,516,520,165),(626,630,521,525,158),(626,630,526,530,150),(626,630,531,535,143),(626,630,536,540,135),(626,630,541,545,128),(626,630,546,550,120),(626,630,551,555,113),(626,630,556,560,105),(626,630,561,565,98),(626,630,566,570,90),(626,630,571,575,83),(626,630,576,580,75),(626,630,581,585,68),(626,630,586,590,60),(626,630,591,595,53),(626,630,596,600,45),(626,630,601,605,38),(626,630,606,610,30),(626,630,611,615,0),(626,630,616,620,0),(626,630,621,1000,0),(631,635,0,150,0),(631,635,151,155,720),(631,635,156,160,713),(631,635,161,165,705),(631,635,166,170,698),(631,635,171,175,690),(631,635,176,180,683),(631,635,181,185,675),(631,635,186,190,668),(631,635,191,195,660),(631,635,196,200,653),(631,635,201,205,645),(631,635,206,210,638),(631,635,211,215,630),(631,635,216,220,623),(631,635,221,225,615),(631,635,226,230,608),(631,635,231,235,600),(631,635,236,240,593),(631,635,241,245,585),(631,635,246,250,578),(631,635,251,255,570),(631,635,256,260,563),(631,635,261,265,555),(631,635,266,270,548),(631,635,271,275,540),(631,635,276,280,533),(631,635,281,285,525),(631,635,286,290,518),(631,635,291,295,510),(631,635,296,300,503),(631,635,301,305,495),(631,635,306,310,488),(631,635,311,315,480),(631,635,316,320,473),(631,635,321,325,465),(631,635,326,330,458),(631,635,331,335,450),(631,635,336,340,443),(631,635,341,345,435),(631,635,346,350,428),(631,635,351,355,420),(631,635,356,360,413),(631,635,361,365,405),(631,635,366,370,398),(631,635,371,375,390),(631,635,376,380,383),(631,635,381,385,375),(631,635,386,390,368),(631,635,391,395,360),(631,635,396,400,353),(631,635,401,405,345),(631,635,406,410,338),(631,635,411,415,330),(631,635,416,420,323),(631,635,421,425,315),(631,635,426,430,308),(631,635,431,435,300),(631,635,436,440,293),(631,635,441,445,285),(631,635,446,450,278),(631,635,451,455,270),(631,635,456,460,263),(631,635,461,465,255),(631,635,466,470,248),(631,635,471,475,240),(631,635,476,480,233),(631,635,481,485,225),(631,635,486,490,218),(631,635,491,495,210),(631,635,496,500,203),(631,635,501,505,195),(631,635,506,510,188),(631,635,511,515,180),(631,635,516,520,173),(631,635,521,525,165),(631,635,526,530,158),(631,635,531,535,150),(631,635,536,540,143),(631,635,541,545,135),(631,635,546,550,128),(631,635,551,555,120),(631,635,556,560,113),(631,635,561,565,105),(631,635,566,570,98),(631,635,571,575,90),(631,635,576,580,83),(631,635,581,585,75),(631,635,586,590,68),(631,635,591,595,60),(631,635,596,600,53),(631,635,601,605,45),(631,635,606,610,38),(631,635,611,615,30),(631,635,616,620,0),(631,635,621,625,0),(631,635,626,1000,0),(636,640,0,150,0),(636,640,151,155,728),(636,640,156,160,720),(636,640,161,165,713),(636,640,166,170,705),(636,640,171,175,698),(636,640,176,180,690),(636,640,181,185,683),(636,640,186,190,675),(636,640,191,195,668),(636,640,196,200,660),(636,640,201,205,653),(636,640,206,210,645),(636,640,211,215,638),(636,640,216,220,630),(636,640,221,225,623),(636,640,226,230,615),(636,640,231,235,608),(636,640,236,240,600),(636,640,241,245,593),(636,640,246,250,585),(636,640,251,255,578),(636,640,256,260,570),(636,640,261,265,563),(636,640,266,270,555),(636,640,271,275,548),(636,640,276,280,540),(636,640,281,285,533),(636,640,286,290,525),(636,640,291,295,518),(636,640,296,300,510),(636,640,301,305,503),(636,640,306,310,495),(636,640,311,315,488),(636,640,316,320,480),(636,640,321,325,473),(636,640,326,330,465),(636,640,331,335,458),(636,640,336,340,450),(636,640,341,345,443),(636,640,346,350,435),(636,640,351,355,428),(636,640,356,360,420),(636,640,361,365,413),(636,640,366,370,405),(636,640,371,375,398),(636,640,376,380,390),(636,640,381,385,383),(636,640,386,390,375),(636,640,391,395,368),(636,640,396,400,360),(636,640,401,405,353),(636,640,406,410,345),(636,640,411,415,338),(636,640,416,420,330),(636,640,421,425,323),(636,640,426,430,315),(636,640,431,435,308),(636,640,436,440,300),(636,640,441,445,293),(636,640,446,450,285),(636,640,451,455,278),(636,640,456,460,270),(636,640,461,465,263),(636,640,466,470,255),(636,640,471,475,248),(636,640,476,480,240),(636,640,481,485,233),(636,640,486,490,225),(636,640,491,495,218),(636,640,496,500,210),(636,640,501,505,203),(636,640,506,510,195),(636,640,511,515,188),(636,640,516,520,180),(636,640,521,525,173),(636,640,526,530,165),(636,640,531,535,158),(636,640,536,540,150),(636,640,541,545,143),(636,640,546,550,135),(636,640,551,555,128),(636,640,556,560,120),(636,640,561,565,113),(636,640,566,570,105),(636,640,571,575,98),(636,640,576,580,90),(636,640,581,585,83),(636,640,586,590,75),(636,640,591,595,68),(636,640,596,600,60),(636,640,601,605,53),(636,640,606,610,45),(636,640,611,615,38),(636,640,616,620,30),(636,640,621,625,0),(636,640,626,630,0),(636,640,631,1000,0),(641,645,0,150,0),(641,645,151,155,735),(641,645,156,160,728),(641,645,161,165,720),(641,645,166,170,713),(641,645,171,175,705),(641,645,176,180,698),(641,645,181,185,690),(641,645,186,190,683),(641,645,191,195,675),(641,645,196,200,668),(641,645,201,205,660),(641,645,206,210,653),(641,645,211,215,645),(641,645,216,220,638),(641,645,221,225,630),(641,645,226,230,623),(641,645,231,235,615),(641,645,236,240,608),(641,645,241,245,600),(641,645,246,250,593),(641,645,251,255,585),(641,645,256,260,578),(641,645,261,265,570),(641,645,266,270,563),(641,645,271,275,555),(641,645,276,280,548),(641,645,281,285,540),(641,645,286,290,533),(641,645,291,295,525),(641,645,296,300,518),(641,645,301,305,510),(641,645,306,310,503),(641,645,311,315,495),(641,645,316,320,488),(641,645,321,325,480),(641,645,326,330,473),(641,645,331,335,465),(641,645,336,340,458),(641,645,341,345,450),(641,645,346,350,443),(641,645,351,355,435),(641,645,356,360,428),(641,645,361,365,420),(641,645,366,370,413),(641,645,371,375,405),(641,645,376,380,398),(641,645,381,385,390),(641,645,386,390,383),(641,645,391,395,375),(641,645,396,400,368),(641,645,401,405,360),(641,645,406,410,353),(641,645,411,415,345),(641,645,416,420,338),(641,645,421,425,330),(641,645,426,430,323),(641,645,431,435,315),(641,645,436,440,308),(641,645,441,445,300),(641,645,446,450,293),(641,645,451,455,285),(641,645,456,460,278),(641,645,461,465,270),(641,645,466,470,263),(641,645,471,475,255),(641,645,476,480,248),(641,645,481,485,240),(641,645,486,490,233),(641,645,491,495,225),(641,645,496,500,218),(641,645,501,505,210),(641,645,506,510,203),(641,645,511,515,195),(641,645,516,520,188),(641,645,521,525,180),(641,645,526,530,173),(641,645,531,535,165),(641,645,536,540,158),(641,645,541,545,150),(641,645,546,550,143),(641,645,551,555,135),(641,645,556,560,128),(641,645,561,565,120),(641,645,566,570,113),(641,645,571,575,105),(641,645,576,580,98),(641,645,581,585,90),(641,645,586,590,83),(641,645,591,595,75),(641,645,596,600,68),(641,645,601,605,60),(641,645,606,610,53),(641,645,611,615,45),(641,645,616,620,38),(641,645,621,625,30),(641,645,626,630,0),(641,645,631,635,0),(641,645,636,1000,0),(646,650,0,150,0),(646,650,151,155,743),(646,650,156,160,735),(646,650,161,165,728),(646,650,166,170,720),(646,650,171,175,713),(646,650,176,180,705),(646,650,181,185,698),(646,650,186,190,690),(646,650,191,195,683),(646,650,196,200,675),(646,650,201,205,668),(646,650,206,210,660),(646,650,211,215,653),(646,650,216,220,645),(646,650,221,225,638),(646,650,226,230,630),(646,650,231,235,623),(646,650,236,240,615),(646,650,241,245,608),(646,650,246,250,600),(646,650,251,255,593),(646,650,256,260,585),(646,650,261,265,578),(646,650,266,270,570),(646,650,271,275,563),(646,650,276,280,555),(646,650,281,285,548),(646,650,286,290,540),(646,650,291,295,533),(646,650,296,300,525),(646,650,301,305,518),(646,650,306,310,510),(646,650,311,315,503),(646,650,316,320,495),(646,650,321,325,488),(646,650,326,330,480),(646,650,331,335,473),(646,650,336,340,465),(646,650,341,345,458),(646,650,346,350,450),(646,650,351,355,443),(646,650,356,360,435),(646,650,361,365,428),(646,650,366,370,420),(646,650,371,375,413),(646,650,376,380,405),(646,650,381,385,398),(646,650,386,390,390),(646,650,391,395,383),(646,650,396,400,375),(646,650,401,405,368),(646,650,406,410,360),(646,650,411,415,353),(646,650,416,420,345),(646,650,421,425,338),(646,650,426,430,330),(646,650,431,435,323),(646,650,436,440,315),(646,650,441,445,308),(646,650,446,450,300),(646,650,451,455,293),(646,650,456,460,285),(646,650,461,465,278),(646,650,466,470,270),(646,650,471,475,263),(646,650,476,480,255),(646,650,481,485,248),(646,650,486,490,240),(646,650,491,495,233),(646,650,496,500,225),(646,650,501,505,218),(646,650,506,510,210),(646,650,511,515,203),(646,650,516,520,195),(646,650,521,525,188),(646,650,526,530,180),(646,650,531,535,173),(646,650,536,540,165),(646,650,541,545,158),(646,650,546,550,150),(646,650,551,555,143),(646,650,556,560,135),(646,650,561,565,128),(646,650,566,570,120),(646,650,571,575,113),(646,650,576,580,105),(646,650,581,585,98),(646,650,586,590,90),(646,650,591,595,83),(646,650,596,600,75),(646,650,601,605,68),(646,650,606,610,60),(646,650,611,615,53),(646,650,616,620,45),(646,650,621,625,38),(646,650,626,630,30),(646,650,631,635,0),(646,650,636,640,0),(646,650,641,1000,0),(651,655,0,150,0),(651,655,151,155,750),(651,655,156,160,743),(651,655,161,165,735),(651,655,166,170,728),(651,655,171,175,720),(651,655,176,180,713),(651,655,181,185,705),(651,655,186,190,698),(651,655,191,195,690),(651,655,196,200,683),(651,655,201,205,675),(651,655,206,210,668),(651,655,211,215,660),(651,655,216,220,653),(651,655,221,225,645),(651,655,226,230,638),(651,655,231,235,630),(651,655,236,240,623),(651,655,241,245,615),(651,655,246,250,608),(651,655,251,255,600),(651,655,256,260,593),(651,655,261,265,585),(651,655,266,270,578),(651,655,271,275,570),(651,655,276,280,563),(651,655,281,285,555),(651,655,286,290,548),(651,655,291,295,540),(651,655,296,300,533),(651,655,301,305,525),(651,655,306,310,518),(651,655,311,315,510),(651,655,316,320,503),(651,655,321,325,495),(651,655,326,330,488),(651,655,331,335,480),(651,655,336,340,473),(651,655,341,345,465),(651,655,346,350,458),(651,655,351,355,450),(651,655,356,360,443),(651,655,361,365,435),(651,655,366,370,428),(651,655,371,375,420),(651,655,376,380,413),(651,655,381,385,405),(651,655,386,390,398),(651,655,391,395,390),(651,655,396,400,383),(651,655,401,405,375),(651,655,406,410,368),(651,655,411,415,360),(651,655,416,420,353),(651,655,421,425,345),(651,655,426,430,338),(651,655,431,435,330),(651,655,436,440,323),(651,655,441,445,315),(651,655,446,450,308),(651,655,451,455,300),(651,655,456,460,293),(651,655,461,465,285),(651,655,466,470,278),(651,655,471,475,270),(651,655,476,480,263),(651,655,481,485,255),(651,655,486,490,248),(651,655,491,495,240),(651,655,496,500,233),(651,655,501,505,225),(651,655,506,510,218),(651,655,511,515,210),(651,655,516,520,203),(651,655,521,525,195),(651,655,526,530,188),(651,655,531,535,180),(651,655,536,540,173),(651,655,541,545,165),(651,655,546,550,158),(651,655,551,555,150),(651,655,556,560,143),(651,655,561,565,135),(651,655,566,570,128),(651,655,571,575,120),(651,655,576,580,113),(651,655,581,585,105),(651,655,586,590,98),(651,655,591,595,90),(651,655,596,600,83),(651,655,601,605,75),(651,655,606,610,68),(651,655,611,615,60),(651,655,616,620,53),(651,655,621,625,45),(651,655,626,630,38),(651,655,631,635,30),(651,655,636,640,0),(651,655,641,645,0),(651,655,646,1000,0),(656,660,0,150,0),(656,660,151,155,758),(656,660,156,160,750),(656,660,161,165,743),(656,660,166,170,735),(656,660,171,175,728),(656,660,176,180,720),(656,660,181,185,713),(656,660,186,190,705),(656,660,191,195,698),(656,660,196,200,690),(656,660,201,205,683),(656,660,206,210,675),(656,660,211,215,668),(656,660,216,220,660),(656,660,221,225,653),(656,660,226,230,645),(656,660,231,235,638),(656,660,236,240,630),(656,660,241,245,623),(656,660,246,250,615),(656,660,251,255,608),(656,660,256,260,600),(656,660,261,265,593),(656,660,266,270,585),(656,660,271,275,578),(656,660,276,280,570),(656,660,281,285,563),(656,660,286,290,555),(656,660,291,295,548),(656,660,296,300,540),(656,660,301,305,533),(656,660,306,310,525),(656,660,311,315,518),(656,660,316,320,510),(656,660,321,325,503),(656,660,326,330,495),(656,660,331,335,488),(656,660,336,340,480),(656,660,341,345,473),(656,660,346,350,465),(656,660,351,355,458),(656,660,356,360,450),(656,660,361,365,443),(656,660,366,370,435),(656,660,371,375,428),(656,660,376,380,420),(656,660,381,385,413),(656,660,386,390,405),(656,660,391,395,398),(656,660,396,400,390),(656,660,401,405,383),(656,660,406,410,375),(656,660,411,415,368),(656,660,416,420,360),(656,660,421,425,353),(656,660,426,430,345),(656,660,431,435,338),(656,660,436,440,330),(656,660,441,445,323),(656,660,446,450,315),(656,660,451,455,308),(656,660,456,460,300),(656,660,461,465,293),(656,660,466,470,285),(656,660,471,475,278),(656,660,476,480,270),(656,660,481,485,263),(656,660,486,490,255),(656,660,491,495,248),(656,660,496,500,240),(656,660,501,505,233),(656,660,506,510,225),(656,660,511,515,218),(656,660,516,520,210),(656,660,521,525,203),(656,660,526,530,195),(656,660,531,535,188),(656,660,536,540,180),(656,660,541,545,173),(656,660,546,550,165),(656,660,551,555,158),(656,660,556,560,150),(656,660,561,565,143),(656,660,566,570,135),(656,660,571,575,128),(656,660,576,580,120),(656,660,581,585,113),(656,660,586,590,105),(656,660,591,595,98),(656,660,596,600,90),(656,660,601,605,83),(656,660,606,610,75),(656,660,611,615,68),(656,660,616,620,60),(656,660,621,625,53),(656,660,626,630,45),(656,660,631,635,38),(656,660,636,640,30),(656,660,641,645,0),(656,660,646,650,0),(656,660,651,1000,0),(661,665,0,150,0),(661,665,151,155,765),(661,665,156,160,758),(661,665,161,165,750),(661,665,166,170,743),(661,665,171,175,735),(661,665,176,180,728),(661,665,181,185,720),(661,665,186,190,713),(661,665,191,195,705),(661,665,196,200,698),(661,665,201,205,690),(661,665,206,210,683),(661,665,211,215,675),(661,665,216,220,668),(661,665,221,225,660),(661,665,226,230,653),(661,665,231,235,645),(661,665,236,240,638),(661,665,241,245,630),(661,665,246,250,623),(661,665,251,255,615),(661,665,256,260,608),(661,665,261,265,600),(661,665,266,270,593),(661,665,271,275,585),(661,665,276,280,578),(661,665,281,285,570),(661,665,286,290,563),(661,665,291,295,555),(661,665,296,300,548),(661,665,301,305,540),(661,665,306,310,533),(661,665,311,315,525),(661,665,316,320,518),(661,665,321,325,510),(661,665,326,330,503),(661,665,331,335,495),(661,665,336,340,488),(661,665,341,345,480),(661,665,346,350,473),(661,665,351,355,465),(661,665,356,360,458),(661,665,361,365,450),(661,665,366,370,443),(661,665,371,375,435),(661,665,376,380,428),(661,665,381,385,420),(661,665,386,390,413),(661,665,391,395,405),(661,665,396,400,398),(661,665,401,405,390),(661,665,406,410,383),(661,665,411,415,375),(661,665,416,420,368),(661,665,421,425,360),(661,665,426,430,353),(661,665,431,435,345),(661,665,436,440,338),(661,665,441,445,330),(661,665,446,450,323),(661,665,451,455,315),(661,665,456,460,308),(661,665,461,465,300),(661,665,466,470,293),(661,665,471,475,285),(661,665,476,480,278),(661,665,481,485,270),(661,665,486,490,263),(661,665,491,495,255),(661,665,496,500,248),(661,665,501,505,240),(661,665,506,510,233),(661,665,511,515,225),(661,665,516,520,218),(661,665,521,525,210),(661,665,526,530,203),(661,665,531,535,195),(661,665,536,540,188),(661,665,541,545,180),(661,665,546,550,173),(661,665,551,555,165),(661,665,556,560,158),(661,665,561,565,150),(661,665,566,570,143),(661,665,571,575,135),(661,665,576,580,128),(661,665,581,585,120),(661,665,586,590,113),(661,665,591,595,105),(661,665,596,600,98),(661,665,601,605,90),(661,665,606,610,83),(661,665,611,615,75),(661,665,616,620,68),(661,665,621,625,60),(661,665,626,630,53),(661,665,631,635,45),(661,665,636,640,38),(661,665,641,645,30),(661,665,646,650,0),(661,665,651,655,0),(661,665,656,1000,0),(666,670,0,150,0),(666,670,151,155,773),(666,670,156,160,765),(666,670,161,165,758),(666,670,166,170,750),(666,670,171,175,743),(666,670,176,180,735),(666,670,181,185,728),(666,670,186,190,720),(666,670,191,195,713),(666,670,196,200,705),(666,670,201,205,698),(666,670,206,210,690),(666,670,211,215,683),(666,670,216,220,675),(666,670,221,225,668),(666,670,226,230,660),(666,670,231,235,653),(666,670,236,240,645),(666,670,241,245,638),(666,670,246,250,630),(666,670,251,255,623),(666,670,256,260,615),(666,670,261,265,608),(666,670,266,270,600),(666,670,271,275,593),(666,670,276,280,585),(666,670,281,285,578),(666,670,286,290,570),(666,670,291,295,563),(666,670,296,300,555),(666,670,301,305,548),(666,670,306,310,540),(666,670,311,315,533),(666,670,316,320,525),(666,670,321,325,518),(666,670,326,330,510),(666,670,331,335,503),(666,670,336,340,495),(666,670,341,345,488),(666,670,346,350,480),(666,670,351,355,473),(666,670,356,360,465),(666,670,361,365,458),(666,670,366,370,450),(666,670,371,375,443),(666,670,376,380,435),(666,670,381,385,428),(666,670,386,390,420),(666,670,391,395,413),(666,670,396,400,405),(666,670,401,405,398),(666,670,406,410,390),(666,670,411,415,383),(666,670,416,420,375),(666,670,421,425,368),(666,670,426,430,360),(666,670,431,435,353),(666,670,436,440,345),(666,670,441,445,338),(666,670,446,450,330),(666,670,451,455,323),(666,670,456,460,315),(666,670,461,465,308),(666,670,466,470,300),(666,670,471,475,293),(666,670,476,480,285),(666,670,481,485,278),(666,670,486,490,270),(666,670,491,495,263),(666,670,496,500,255),(666,670,501,505,248),(666,670,506,510,240),(666,670,511,515,233),(666,670,516,520,225),(666,670,521,525,218),(666,670,526,530,210),(666,670,531,535,203),(666,670,536,540,195),(666,670,541,545,188),(666,670,546,550,180),(666,670,551,555,173),(666,670,556,560,165),(666,670,561,565,158),(666,670,566,570,150),(666,670,571,575,143),(666,670,576,580,135),(666,670,581,585,128),(666,670,586,590,120),(666,670,591,595,113),(666,670,596,600,105),(666,670,601,605,98),(666,670,606,610,90),(666,670,611,615,83),(666,670,616,620,75),(666,670,621,625,68),(666,670,626,630,60),(666,670,631,635,53),(666,670,636,640,45),(666,670,641,645,38),(666,670,646,650,30),(666,670,651,655,0),(666,670,656,660,0),(666,670,661,1000,0),(671,675,0,150,0),(671,675,151,155,780),(671,675,156,160,773),(671,675,161,165,765),(671,675,166,170,758),(671,675,171,175,750),(671,675,176,180,743),(671,675,181,185,735),(671,675,186,190,728),(671,675,191,195,720),(671,675,196,200,713),(671,675,201,205,705),(671,675,206,210,698),(671,675,211,215,690),(671,675,216,220,683),(671,675,221,225,675),(671,675,226,230,668),(671,675,231,235,660),(671,675,236,240,653),(671,675,241,245,645),(671,675,246,250,638),(671,675,251,255,630),(671,675,256,260,623),(671,675,261,265,615),(671,675,266,270,608),(671,675,271,275,600),(671,675,276,280,593),(671,675,281,285,585),(671,675,286,290,578),(671,675,291,295,570),(671,675,296,300,563),(671,675,301,305,555),(671,675,306,310,548),(671,675,311,315,540),(671,675,316,320,533),(671,675,321,325,525),(671,675,326,330,518),(671,675,331,335,510),(671,675,336,340,503),(671,675,341,345,495),(671,675,346,350,488),(671,675,351,355,480),(671,675,356,360,473),(671,675,361,365,465),(671,675,366,370,458),(671,675,371,375,450),(671,675,376,380,443),(671,675,381,385,435),(671,675,386,390,428),(671,675,391,395,420),(671,675,396,400,413),(671,675,401,405,405),(671,675,406,410,398),(671,675,411,415,390),(671,675,416,420,383),(671,675,421,425,375),(671,675,426,430,368),(671,675,431,435,360),(671,675,436,440,353),(671,675,441,445,345),(671,675,446,450,338),(671,675,451,455,330),(671,675,456,460,323),(671,675,461,465,315),(671,675,466,470,308),(671,675,471,475,300),(671,675,476,480,293),(671,675,481,485,285),(671,675,486,490,278),(671,675,491,495,270),(671,675,496,500,263),(671,675,501,505,255),(671,675,506,510,248),(671,675,511,515,240),(671,675,516,520,233),(671,675,521,525,225),(671,675,526,530,218),(671,675,531,535,210),(671,675,536,540,203),(671,675,541,545,195),(671,675,546,550,188),(671,675,551,555,180),(671,675,556,560,173),(671,675,561,565,165),(671,675,566,570,158),(671,675,571,575,150),(671,675,576,580,143),(671,675,581,585,135),(671,675,586,590,128),(671,675,591,595,120),(671,675,596,600,113),(671,675,601,605,105),(671,675,606,610,98),(671,675,611,615,90),(671,675,616,620,83),(671,675,621,625,75),(671,675,626,630,68),(671,675,631,635,60),(671,675,636,640,53),(671,675,641,645,45),(671,675,646,650,38),(671,675,651,655,30),(671,675,656,660,0),(671,675,661,665,0),(671,675,666,1000,0),(676,680,0,150,0),(676,680,151,155,788),(676,680,156,160,780),(676,680,161,165,773),(676,680,166,170,765),(676,680,171,175,758),(676,680,176,180,750),(676,680,181,185,743),(676,680,186,190,735),(676,680,191,195,728),(676,680,196,200,720),(676,680,201,205,713),(676,680,206,210,705),(676,680,211,215,698),(676,680,216,220,690),(676,680,221,225,683),(676,680,226,230,675),(676,680,231,235,668),(676,680,236,240,660),(676,680,241,245,653),(676,680,246,250,645),(676,680,251,255,638),(676,680,256,260,630),(676,680,261,265,623),(676,680,266,270,615),(676,680,271,275,608),(676,680,276,280,600),(676,680,281,285,593),(676,680,286,290,585),(676,680,291,295,578),(676,680,296,300,570),(676,680,301,305,563),(676,680,306,310,555),(676,680,311,315,548),(676,680,316,320,540),(676,680,321,325,533),(676,680,326,330,525),(676,680,331,335,518),(676,680,336,340,510),(676,680,341,345,503),(676,680,346,350,495),(676,680,351,355,488),(676,680,356,360,480),(676,680,361,365,473),(676,680,366,370,465),(676,680,371,375,458),(676,680,376,380,450),(676,680,381,385,443),(676,680,386,390,435),(676,680,391,395,428),(676,680,396,400,420),(676,680,401,405,413),(676,680,406,410,405),(676,680,411,415,398),(676,680,416,420,390),(676,680,421,425,383),(676,680,426,430,375),(676,680,431,435,368),(676,680,436,440,360),(676,680,441,445,353),(676,680,446,450,345),(676,680,451,455,338),(676,680,456,460,330),(676,680,461,465,323),(676,680,466,470,315),(676,680,471,475,308),(676,680,476,480,300),(676,680,481,485,293),(676,680,486,490,285),(676,680,491,495,278),(676,680,496,500,270),(676,680,501,505,263),(676,680,506,510,255),(676,680,511,515,248),(676,680,516,520,240),(676,680,521,525,233),(676,680,526,530,225),(676,680,531,535,218),(676,680,536,540,210),(676,680,541,545,203),(676,680,546,550,195),(676,680,551,555,188),(676,680,556,560,180),(676,680,561,565,173),(676,680,566,570,165),(676,680,571,575,158),(676,680,576,580,150),(676,680,581,585,143),(676,680,586,590,135),(676,680,591,595,128),(676,680,596,600,120),(676,680,601,605,113),(676,680,606,610,105),(676,680,611,615,98),(676,680,616,620,90),(676,680,621,625,83),(676,680,626,630,75),(676,680,631,635,68),(676,680,636,640,60),(676,680,641,645,53),(676,680,646,650,45),(676,680,651,655,38),(676,680,656,660,30),(676,680,661,665,0),(676,680,666,670,0),(676,680,671,1000,0),(681,685,0,150,0),(681,685,151,155,795),(681,685,156,160,788),(681,685,161,165,780),(681,685,166,170,773),(681,685,171,175,765),(681,685,176,180,758),(681,685,181,185,750),(681,685,186,190,743),(681,685,191,195,735),(681,685,196,200,728),(681,685,201,205,720),(681,685,206,210,713),(681,685,211,215,705),(681,685,216,220,698),(681,685,221,225,690),(681,685,226,230,683),(681,685,231,235,675),(681,685,236,240,668),(681,685,241,245,660),(681,685,246,250,653),(681,685,251,255,645),(681,685,256,260,638),(681,685,261,265,630),(681,685,266,270,623),(681,685,271,275,615),(681,685,276,280,608),(681,685,281,285,600),(681,685,286,290,593),(681,685,291,295,585),(681,685,296,300,578),(681,685,301,305,570),(681,685,306,310,563),(681,685,311,315,555),(681,685,316,320,548),(681,685,321,325,540),(681,685,326,330,533),(681,685,331,335,525),(681,685,336,340,518),(681,685,341,345,510),(681,685,346,350,503),(681,685,351,355,495),(681,685,356,360,488),(681,685,361,365,480),(681,685,366,370,473),(681,685,371,375,465),(681,685,376,380,458),(681,685,381,385,450),(681,685,386,390,443),(681,685,391,395,435),(681,685,396,400,428),(681,685,401,405,420),(681,685,406,410,413),(681,685,411,415,405),(681,685,416,420,398),(681,685,421,425,390),(681,685,426,430,383),(681,685,431,435,375),(681,685,436,440,368),(681,685,441,445,360),(681,685,446,450,353),(681,685,451,455,345),(681,685,456,460,338),(681,685,461,465,330),(681,685,466,470,323),(681,685,471,475,315),(681,685,476,480,308),(681,685,481,485,300),(681,685,486,490,293),(681,685,491,495,285),(681,685,496,500,278),(681,685,501,505,270),(681,685,506,510,263),(681,685,511,515,255),(681,685,516,520,248),(681,685,521,525,240),(681,685,526,530,233),(681,685,531,535,225),(681,685,536,540,218),(681,685,541,545,210),(681,685,546,550,203),(681,685,551,555,195),(681,685,556,560,188),(681,685,561,565,180),(681,685,566,570,173),(681,685,571,575,165),(681,685,576,580,158),(681,685,581,585,150),(681,685,586,590,143),(681,685,591,595,135),(681,685,596,600,128),(681,685,601,605,120),(681,685,606,610,113),(681,685,611,615,105),(681,685,616,620,98),(681,685,621,625,90),(681,685,626,630,83),(681,685,631,635,75),(681,685,636,640,68),(681,685,641,645,60),(681,685,646,650,53),(681,685,651,655,45),(681,685,656,660,38),(681,685,661,665,30),(681,685,666,670,0),(681,685,671,675,0),(681,685,676,1000,0),(686,690,0,150,0),(686,690,151,155,800),(686,690,156,160,795),(686,690,161,165,788),(686,690,166,170,780),(686,690,171,175,773),(686,690,176,180,765),(686,690,181,185,758),(686,690,186,190,750),(686,690,191,195,743),(686,690,196,200,735),(686,690,201,205,728),(686,690,206,210,720),(686,690,211,215,713),(686,690,216,220,705),(686,690,221,225,698),(686,690,226,230,690),(686,690,231,235,683),(686,690,236,240,675),(686,690,241,245,668),(686,690,246,250,660),(686,690,251,255,653),(686,690,256,260,645),(686,690,261,265,638),(686,690,266,270,630),(686,690,271,275,623),(686,690,276,280,615),(686,690,281,285,608),(686,690,286,290,600),(686,690,291,295,593),(686,690,296,300,585),(686,690,301,305,578),(686,690,306,310,570),(686,690,311,315,563),(686,690,316,320,555),(686,690,321,325,548),(686,690,326,330,540),(686,690,331,335,533),(686,690,336,340,525),(686,690,341,345,518),(686,690,346,350,510),(686,690,351,355,503),(686,690,356,360,495),(686,690,361,365,488),(686,690,366,370,480),(686,690,371,375,473),(686,690,376,380,465),(686,690,381,385,458),(686,690,386,390,450),(686,690,391,395,443),(686,690,396,400,435),(686,690,401,405,428),(686,690,406,410,420),(686,690,411,415,413),(686,690,416,420,405),(686,690,421,425,398),(686,690,426,430,390),(686,690,431,435,383),(686,690,436,440,375),(686,690,441,445,368),(686,690,446,450,360),(686,690,451,455,353),(686,690,456,460,345),(686,690,461,465,338),(686,690,466,470,330),(686,690,471,475,323),(686,690,476,480,315),(686,690,481,485,308),(686,690,486,490,300),(686,690,491,495,293),(686,690,496,500,285),(686,690,501,505,278),(686,690,506,510,270),(686,690,511,515,263),(686,690,516,520,255),(686,690,521,525,248),(686,690,526,530,240),(686,690,531,535,233),(686,690,536,540,225),(686,690,541,545,218),(686,690,546,550,210),(686,690,551,555,203),(686,690,556,560,195),(686,690,561,565,188),(686,690,566,570,180),(686,690,571,575,173),(686,690,576,580,165),(686,690,581,585,158),(686,690,586,590,150),(686,690,591,595,143),(686,690,596,600,135),(686,690,601,605,128),(686,690,606,610,120),(686,690,611,615,113),(686,690,616,620,105),(686,690,621,625,98),(686,690,626,630,90),(686,690,631,635,83),(686,690,636,640,75),(686,690,641,645,68),(686,690,646,650,60),(686,690,651,655,53),(686,690,656,660,45),(686,690,661,665,38),(686,690,666,670,30),(686,690,671,675,0),(686,690,676,680,0),(686,690,681,1000,0),(691,695,0,150,0),(691,695,151,155,800),(691,695,156,160,800),(691,695,161,165,795),(691,695,166,170,788),(691,695,171,175,780),(691,695,176,180,773),(691,695,181,185,765),(691,695,186,190,758),(691,695,191,195,750),(691,695,196,200,743),(691,695,201,205,735),(691,695,206,210,728),(691,695,211,215,720),(691,695,216,220,713),(691,695,221,225,705),(691,695,226,230,698),(691,695,231,235,690),(691,695,236,240,683),(691,695,241,245,675),(691,695,246,250,668),(691,695,251,255,660),(691,695,256,260,653),(691,695,261,265,645),(691,695,266,270,638),(691,695,271,275,630),(691,695,276,280,623),(691,695,281,285,615),(691,695,286,290,608),(691,695,291,295,600),(691,695,296,300,593),(691,695,301,305,585),(691,695,306,310,578),(691,695,311,315,570),(691,695,316,320,563),(691,695,321,325,555),(691,695,326,330,548),(691,695,331,335,540),(691,695,336,340,533),(691,695,341,345,525),(691,695,346,350,518),(691,695,351,355,510),(691,695,356,360,503),(691,695,361,365,495),(691,695,366,370,488),(691,695,371,375,480),(691,695,376,380,473),(691,695,381,385,465),(691,695,386,390,458),(691,695,391,395,450),(691,695,396,400,443),(691,695,401,405,435),(691,695,406,410,428),(691,695,411,415,420),(691,695,416,420,413),(691,695,421,425,405),(691,695,426,430,398),(691,695,431,435,390),(691,695,436,440,383),(691,695,441,445,375),(691,695,446,450,368),(691,695,451,455,360),(691,695,456,460,353),(691,695,461,465,345),(691,695,466,470,338),(691,695,471,475,330),(691,695,476,480,323),(691,695,481,485,315),(691,695,486,490,308),(691,695,491,495,300),(691,695,496,500,293),(691,695,501,505,285),(691,695,506,510,278),(691,695,511,515,270),(691,695,516,520,263),(691,695,521,525,255),(691,695,526,530,248),(691,695,531,535,240),(691,695,536,540,233),(691,695,541,545,225),(691,695,546,550,218),(691,695,551,555,210),(691,695,556,560,203),(691,695,561,565,195),(691,695,566,570,188),(691,695,571,575,180),(691,695,576,580,173),(691,695,581,585,165),(691,695,586,590,158),(691,695,591,595,150),(691,695,596,600,143),(691,695,601,605,135),(691,695,606,610,128),(691,695,611,615,120),(691,695,616,620,113),(691,695,621,625,105),(691,695,626,630,98),(691,695,631,635,90),(691,695,636,640,83),(691,695,641,645,75),(691,695,646,650,68),(691,695,651,655,60),(691,695,656,660,53),(691,695,661,665,45),(691,695,666,670,38),(691,695,671,675,30),(691,695,676,680,0),(691,695,681,685,0),(691,695,686,1000,0),(696,700,0,150,0),(696,700,151,155,800),(696,700,156,160,800),(696,700,161,165,800),(696,700,166,170,795),(696,700,171,175,788),(696,700,176,180,780),(696,700,181,185,773),(696,700,186,190,765),(696,700,191,195,758),(696,700,196,200,750),(696,700,201,205,743),(696,700,206,210,735),(696,700,211,215,728),(696,700,216,220,720),(696,700,221,225,713),(696,700,226,230,705),(696,700,231,235,698),(696,700,236,240,690),(696,700,241,245,683),(696,700,246,250,675),(696,700,251,255,668),(696,700,256,260,660),(696,700,261,265,653),(696,700,266,270,645),(696,700,271,275,638),(696,700,276,280,630),(696,700,281,285,623),(696,700,286,290,615),(696,700,291,295,608),(696,700,296,300,600),(696,700,301,305,593),(696,700,306,310,585),(696,700,311,315,578),(696,700,316,320,570),(696,700,321,325,563),(696,700,326,330,555),(696,700,331,335,548),(696,700,336,340,540),(696,700,341,345,533),(696,700,346,350,525),(696,700,351,355,518),(696,700,356,360,510),(696,700,361,365,503),(696,700,366,370,495),(696,700,371,375,488),(696,700,376,380,480),(696,700,381,385,473),(696,700,386,390,465),(696,700,391,395,458),(696,700,396,400,450),(696,700,401,405,443),(696,700,406,410,435),(696,700,411,415,428),(696,700,416,420,420),(696,700,421,425,413),(696,700,426,430,405),(696,700,431,435,398),(696,700,436,440,390),(696,700,441,445,383),(696,700,446,450,375),(696,700,451,455,368),(696,700,456,460,360),(696,700,461,465,353),(696,700,466,470,345),(696,700,471,475,338),(696,700,476,480,330),(696,700,481,485,323),(696,700,486,490,315),(696,700,491,495,308),(696,700,496,500,300),(696,700,501,505,293),(696,700,506,510,285),(696,700,511,515,278),(696,700,516,520,270),(696,700,521,525,263),(696,700,526,530,255),(696,700,531,535,248),(696,700,536,540,240),(696,700,541,545,233),(696,700,546,550,225),(696,700,551,555,218),(696,700,556,560,210),(696,700,561,565,203),(696,700,566,570,195),(696,700,571,575,188),(696,700,576,580,180),(696,700,581,585,173),(696,700,586,590,165),(696,700,591,595,158),(696,700,596,600,150),(696,700,601,605,143),(696,700,606,610,135),(696,700,611,615,128),(696,700,616,620,120),(696,700,621,625,113),(696,700,626,630,105),(696,700,631,635,98),(696,700,636,640,90),(696,700,641,645,83),(696,700,646,650,75),(696,700,651,655,68),(696,700,656,660,60),(696,700,661,665,53),(696,700,666,670,45),(696,700,671,675,38),(696,700,676,680,30),(696,700,681,685,0),(696,700,686,690,0),(696,700,691,1000,0),(701,705,0,150,0),(701,705,151,155,800),(701,705,156,160,800),(701,705,161,165,800),(701,705,166,170,800),(701,705,171,175,795),(701,705,176,180,788),(701,705,181,185,780),(701,705,186,190,773),(701,705,191,195,765),(701,705,196,200,758),(701,705,201,205,750),(701,705,206,210,743),(701,705,211,215,735),(701,705,216,220,728),(701,705,221,225,720),(701,705,226,230,713),(701,705,231,235,705),(701,705,236,240,698),(701,705,241,245,690),(701,705,246,250,683),(701,705,251,255,675),(701,705,256,260,668),(701,705,261,265,660),(701,705,266,270,653),(701,705,271,275,645),(701,705,276,280,638),(701,705,281,285,630),(701,705,286,290,623),(701,705,291,295,615),(701,705,296,300,608),(701,705,301,305,600),(701,705,306,310,593),(701,705,311,315,585),(701,705,316,320,578),(701,705,321,325,570),(701,705,326,330,563),(701,705,331,335,555),(701,705,336,340,548),(701,705,341,345,540),(701,705,346,350,533),(701,705,351,355,525),(701,705,356,360,518),(701,705,361,365,510),(701,705,366,370,503),(701,705,371,375,495),(701,705,376,380,488),(701,705,381,385,480),(701,705,386,390,473),(701,705,391,395,465),(701,705,396,400,458),(701,705,401,405,450),(701,705,406,410,443),(701,705,411,415,435),(701,705,416,420,428),(701,705,421,425,420),(701,705,426,430,413),(701,705,431,435,405),(701,705,436,440,398),(701,705,441,445,390),(701,705,446,450,383),(701,705,451,455,375),(701,705,456,460,368),(701,705,461,465,360),(701,705,466,470,353),(701,705,471,475,345),(701,705,476,480,338),(701,705,481,485,330),(701,705,486,490,323),(701,705,491,495,315),(701,705,496,500,308),(701,705,501,505,300),(701,705,506,510,293),(701,705,511,515,285),(701,705,516,520,278),(701,705,521,525,270),(701,705,526,530,263),(701,705,531,535,255),(701,705,536,540,248),(701,705,541,545,240),(701,705,546,550,233),(701,705,551,555,225),(701,705,556,560,218),(701,705,561,565,210),(701,705,566,570,203),(701,705,571,575,195),(701,705,576,580,188),(701,705,581,585,180),(701,705,586,590,173),(701,705,591,595,165),(701,705,596,600,158),(701,705,601,605,150),(701,705,606,610,143),(701,705,611,615,135),(701,705,616,620,128),(701,705,621,625,120),(701,705,626,630,113),(701,705,631,635,105),(701,705,636,640,98),(701,705,641,645,90),(701,705,646,650,83),(701,705,651,655,75),(701,705,656,660,68),(701,705,661,665,60),(701,705,666,670,53),(701,705,671,675,45),(701,705,676,680,38),(701,705,681,685,30),(701,705,686,690,0),(701,705,691,695,0),(701,705,696,1000,0),(706,710,0,150,0),(706,710,151,155,800),(706,710,156,160,800),(706,710,161,165,800),(706,710,166,170,800),(706,710,171,175,800),(706,710,176,180,795),(706,710,181,185,788),(706,710,186,190,780),(706,710,191,195,773),(706,710,196,200,765),(706,710,201,205,758),(706,710,206,210,750),(706,710,211,215,743),(706,710,216,220,735),(706,710,221,225,728),(706,710,226,230,720),(706,710,231,235,713),(706,710,236,240,705),(706,710,241,245,698),(706,710,246,250,690),(706,710,251,255,683),(706,710,256,260,675),(706,710,261,265,668),(706,710,266,270,660),(706,710,271,275,653),(706,710,276,280,645),(706,710,281,285,638),(706,710,286,290,630),(706,710,291,295,623),(706,710,296,300,615),(706,710,301,305,608),(706,710,306,310,600),(706,710,311,315,593),(706,710,316,320,585),(706,710,321,325,578),(706,710,326,330,570),(706,710,331,335,563),(706,710,336,340,555),(706,710,341,345,548),(706,710,346,350,540),(706,710,351,355,533),(706,710,356,360,525),(706,710,361,365,518),(706,710,366,370,510),(706,710,371,375,503),(706,710,376,380,495),(706,710,381,385,488),(706,710,386,390,480),(706,710,391,395,473),(706,710,396,400,465),(706,710,401,405,458),(706,710,406,410,450),(706,710,411,415,443),(706,710,416,420,435),(706,710,421,425,428),(706,710,426,430,420),(706,710,431,435,413),(706,710,436,440,405),(706,710,441,445,398),(706,710,446,450,390),(706,710,451,455,383),(706,710,456,460,375),(706,710,461,465,368),(706,710,466,470,360),(706,710,471,475,353),(706,710,476,480,345),(706,710,481,485,338),(706,710,486,490,330),(706,710,491,495,323),(706,710,496,500,315),(706,710,501,505,308),(706,710,506,510,300),(706,710,511,515,293),(706,710,516,520,285),(706,710,521,525,278),(706,710,526,530,270),(706,710,531,535,263),(706,710,536,540,255),(706,710,541,545,248),(706,710,546,550,240),(706,710,551,555,233),(706,710,556,560,225),(706,710,561,565,218),(706,710,566,570,210),(706,710,571,575,203),(706,710,576,580,195),(706,710,581,585,188),(706,710,586,590,180),(706,710,591,595,173),(706,710,596,600,165),(706,710,601,605,158),(706,710,606,610,150),(706,710,611,615,143),(706,710,616,620,135),(706,710,621,625,128),(706,710,626,630,120),(706,710,631,635,113),(706,710,636,640,105),(706,710,641,645,98),(706,710,646,650,90),(706,710,651,655,83),(706,710,656,660,75),(706,710,661,665,68),(706,710,666,670,60),(706,710,671,675,53),(706,710,676,680,45),(706,710,681,685,38),(706,710,686,690,30),(706,710,691,695,0),(706,710,696,700,0),(706,710,701,1000,0),(711,715,0,150,0),(711,715,151,155,800),(711,715,156,160,800),(711,715,161,165,800),(711,715,166,170,800),(711,715,171,175,800),(711,715,176,180,800),(711,715,181,185,795),(711,715,186,190,788),(711,715,191,195,780),(711,715,196,200,773),(711,715,201,205,765),(711,715,206,210,758),(711,715,211,215,750),(711,715,216,220,743),(711,715,221,225,735),(711,715,226,230,728),(711,715,231,235,720),(711,715,236,240,713),(711,715,241,245,705),(711,715,246,250,698),(711,715,251,255,690),(711,715,256,260,683),(711,715,261,265,675),(711,715,266,270,668),(711,715,271,275,660),(711,715,276,280,653),(711,715,281,285,645),(711,715,286,290,638),(711,715,291,295,630),(711,715,296,300,623),(711,715,301,305,615),(711,715,306,310,608),(711,715,311,315,600),(711,715,316,320,593),(711,715,321,325,585),(711,715,326,330,578),(711,715,331,335,570),(711,715,336,340,563),(711,715,341,345,555),(711,715,346,350,548),(711,715,351,355,540),(711,715,356,360,533),(711,715,361,365,525),(711,715,366,370,518),(711,715,371,375,510),(711,715,376,380,503),(711,715,381,385,495),(711,715,386,390,488),(711,715,391,395,480),(711,715,396,400,473),(711,715,401,405,465),(711,715,406,410,458),(711,715,411,415,450),(711,715,416,420,443),(711,715,421,425,435),(711,715,426,430,428),(711,715,431,435,420),(711,715,436,440,413),(711,715,441,445,405),(711,715,446,450,398),(711,715,451,455,390),(711,715,456,460,383),(711,715,461,465,375),(711,715,466,470,368),(711,715,471,475,360),(711,715,476,480,353),(711,715,481,485,345),(711,715,486,490,338),(711,715,491,495,330),(711,715,496,500,323),(711,715,501,505,315),(711,715,506,510,308),(711,715,511,515,300),(711,715,516,520,293),(711,715,521,525,285),(711,715,526,530,278),(711,715,531,535,270),(711,715,536,540,263),(711,715,541,545,255),(711,715,546,550,248),(711,715,551,555,240),(711,715,556,560,233),(711,715,561,565,225),(711,715,566,570,218),(711,715,571,575,210),(711,715,576,580,203),(711,715,581,585,195),(711,715,586,590,188),(711,715,591,595,180),(711,715,596,600,173),(711,715,601,605,165),(711,715,606,610,158),(711,715,611,615,150),(711,715,616,620,143),(711,715,621,625,135),(711,715,626,630,128),(711,715,631,635,120),(711,715,636,640,113),(711,715,641,645,105),(711,715,646,650,98),(711,715,651,655,90),(711,715,656,660,83),(711,715,661,665,75),(711,715,666,670,68),(711,715,671,675,60),(711,715,676,680,53),(711,715,681,685,45),(711,715,686,690,38),(711,715,691,695,30),(711,715,696,700,0),(711,715,701,705,0),(711,715,706,1000,0),(716,720,0,150,0),(716,720,151,155,800),(716,720,156,160,800),(716,720,161,165,800),(716,720,166,170,800),(716,720,171,175,800),(716,720,176,180,800),(716,720,181,185,800),(716,720,186,190,795),(716,720,191,195,788),(716,720,196,200,780),(716,720,201,205,773),(716,720,206,210,765),(716,720,211,215,758),(716,720,216,220,750),(716,720,221,225,743),(716,720,226,230,735),(716,720,231,235,728),(716,720,236,240,720),(716,720,241,245,713),(716,720,246,250,705),(716,720,251,255,698),(716,720,256,260,690),(716,720,261,265,683),(716,720,266,270,675),(716,720,271,275,668),(716,720,276,280,660),(716,720,281,285,653),(716,720,286,290,645),(716,720,291,295,638),(716,720,296,300,630),(716,720,301,305,623),(716,720,306,310,615),(716,720,311,315,608),(716,720,316,320,600),(716,720,321,325,593),(716,720,326,330,585),(716,720,331,335,578),(716,720,336,340,570),(716,720,341,345,563),(716,720,346,350,555),(716,720,351,355,548),(716,720,356,360,540),(716,720,361,365,533),(716,720,366,370,525),(716,720,371,375,518),(716,720,376,380,510),(716,720,381,385,503),(716,720,386,390,495),(716,720,391,395,488),(716,720,396,400,480),(716,720,401,405,473),(716,720,406,410,465),(716,720,411,415,458),(716,720,416,420,450),(716,720,421,425,443),(716,720,426,430,435),(716,720,431,435,428),(716,720,436,440,420),(716,720,441,445,413),(716,720,446,450,405),(716,720,451,455,398),(716,720,456,460,390),(716,720,461,465,383),(716,720,466,470,375),(716,720,471,475,368),(716,720,476,480,360),(716,720,481,485,353),(716,720,486,490,345),(716,720,491,495,338),(716,720,496,500,330),(716,720,501,505,323),(716,720,506,510,315),(716,720,511,515,308),(716,720,516,520,300),(716,720,521,525,293),(716,720,526,530,285),(716,720,531,535,278),(716,720,536,540,270),(716,720,541,545,263),(716,720,546,550,255),(716,720,551,555,248),(716,720,556,560,240),(716,720,561,565,233),(716,720,566,570,225),(716,720,571,575,218),(716,720,576,580,210),(716,720,581,585,203),(716,720,586,590,195),(716,720,591,595,188),(716,720,596,600,180),(716,720,601,605,173),(716,720,606,610,165),(716,720,611,615,158),(716,720,616,620,150),(716,720,621,625,143),(716,720,626,630,135),(716,720,631,635,128),(716,720,636,640,120),(716,720,641,645,113),(716,720,646,650,105),(716,720,651,655,98),(716,720,656,660,90),(716,720,661,665,83),(716,720,666,670,75),(716,720,671,675,68),(716,720,676,680,60),(716,720,681,685,53),(716,720,686,690,45),(716,720,691,695,38),(716,720,696,700,30),(716,720,701,705,0),(716,720,706,710,0),(716,720,711,1000,0),(721,725,0,150,0),(721,725,151,155,800),(721,725,156,160,800),(721,725,161,165,800),(721,725,166,170,800),(721,725,171,175,800),(721,725,176,180,800),(721,725,181,185,800),(721,725,186,190,800),(721,725,191,195,795),(721,725,196,200,788),(721,725,201,205,780),(721,725,206,210,773),(721,725,211,215,765),(721,725,216,220,758),(721,725,221,225,750),(721,725,226,230,743),(721,725,231,235,735),(721,725,236,240,728),(721,725,241,245,720),(721,725,246,250,713),(721,725,251,255,705),(721,725,256,260,698),(721,725,261,265,690),(721,725,266,270,683),(721,725,271,275,675),(721,725,276,280,668),(721,725,281,285,660),(721,725,286,290,653),(721,725,291,295,645),(721,725,296,300,638),(721,725,301,305,630),(721,725,306,310,623),(721,725,311,315,615),(721,725,316,320,608),(721,725,321,325,600),(721,725,326,330,593),(721,725,331,335,585),(721,725,336,340,578),(721,725,341,345,570),(721,725,346,350,563),(721,725,351,355,555),(721,725,356,360,548),(721,725,361,365,540),(721,725,366,370,533),(721,725,371,375,525),(721,725,376,380,518),(721,725,381,385,510),(721,725,386,390,503),(721,725,391,395,495),(721,725,396,400,488),(721,725,401,405,480),(721,725,406,410,473),(721,725,411,415,465),(721,725,416,420,458),(721,725,421,425,450),(721,725,426,430,443),(721,725,431,435,435),(721,725,436,440,428),(721,725,441,445,420),(721,725,446,450,413),(721,725,451,455,405),(721,725,456,460,398),(721,725,461,465,390),(721,725,466,470,383),(721,725,471,475,375),(721,725,476,480,368),(721,725,481,485,360),(721,725,486,490,353),(721,725,491,495,345),(721,725,496,500,338),(721,725,501,505,330),(721,725,506,510,323),(721,725,511,515,315),(721,725,516,520,308),(721,725,521,525,300),(721,725,526,530,293),(721,725,531,535,285),(721,725,536,540,278),(721,725,541,545,270),(721,725,546,550,263),(721,725,551,555,255),(721,725,556,560,248),(721,725,561,565,240),(721,725,566,570,233),(721,725,571,575,225),(721,725,576,580,218),(721,725,581,585,210),(721,725,586,590,203),(721,725,591,595,195),(721,725,596,600,188),(721,725,601,605,180),(721,725,606,610,173),(721,725,611,615,165),(721,725,616,620,158),(721,725,621,625,150),(721,725,626,630,143),(721,725,631,635,135),(721,725,636,640,128),(721,725,641,645,120),(721,725,646,650,113),(721,725,651,655,105),(721,725,656,660,98),(721,725,661,665,90),(721,725,666,670,83),(721,725,671,675,75),(721,725,676,680,68),(721,725,681,685,60),(721,725,686,690,53),(721,725,691,695,45),(721,725,696,700,38),(721,725,701,705,30),(721,725,706,710,0),(721,725,711,715,0),(721,725,716,1000,0),(726,730,0,150,0),(726,730,151,155,800),(726,730,156,160,800),(726,730,161,165,800),(726,730,166,170,800),(726,730,171,175,800),(726,730,176,180,800),(726,730,181,185,800),(726,730,186,190,800),(726,730,191,195,800),(726,730,196,200,795),(726,730,201,205,788),(726,730,206,210,780),(726,730,211,215,773),(726,730,216,220,765),(726,730,221,225,758),(726,730,226,230,750),(726,730,231,235,743),(726,730,236,240,735),(726,730,241,245,728),(726,730,246,250,720),(726,730,251,255,713),(726,730,256,260,705),(726,730,261,265,698),(726,730,266,270,690),(726,730,271,275,683),(726,730,276,280,675),(726,730,281,285,668),(726,730,286,290,660),(726,730,291,295,653),(726,730,296,300,645),(726,730,301,305,638),(726,730,306,310,630),(726,730,311,315,623),(726,730,316,320,615),(726,730,321,325,608),(726,730,326,330,600),(726,730,331,335,593),(726,730,336,340,585),(726,730,341,345,578),(726,730,346,350,570),(726,730,351,355,563),(726,730,356,360,555),(726,730,361,365,548),(726,730,366,370,540),(726,730,371,375,533),(726,730,376,380,525),(726,730,381,385,518),(726,730,386,390,510),(726,730,391,395,503),(726,730,396,400,495),(726,730,401,405,488),(726,730,406,410,480),(726,730,411,415,473),(726,730,416,420,465),(726,730,421,425,458),(726,730,426,430,450),(726,730,431,435,443),(726,730,436,440,435),(726,730,441,445,428),(726,730,446,450,420),(726,730,451,455,413),(726,730,456,460,405),(726,730,461,465,398),(726,730,466,470,390),(726,730,471,475,383),(726,730,476,480,375),(726,730,481,485,368),(726,730,486,490,360),(726,730,491,495,353),(726,730,496,500,345),(726,730,501,505,338),(726,730,506,510,330),(726,730,511,515,323),(726,730,516,520,315),(726,730,521,525,308),(726,730,526,530,300),(726,730,531,535,293),(726,730,536,540,285),(726,730,541,545,278),(726,730,546,550,270),(726,730,551,555,263),(726,730,556,560,255),(726,730,561,565,248),(726,730,566,570,240),(726,730,571,575,233),(726,730,576,580,225),(726,730,581,585,218),(726,730,586,590,210),(726,730,591,595,203),(726,730,596,600,195),(726,730,601,605,188),(726,730,606,610,180),(726,730,611,615,173),(726,730,616,620,165),(726,730,621,625,158),(726,730,626,630,150),(726,730,631,635,143),(726,730,636,640,135),(726,730,641,645,128),(726,730,646,650,120),(726,730,651,655,113),(726,730,656,660,105),(726,730,661,665,98),(726,730,666,670,90),(726,730,671,675,83),(726,730,676,680,75),(726,730,681,685,68),(726,730,686,690,60),(726,730,691,695,53),(726,730,696,700,45),(726,730,701,705,38),(726,730,706,710,30),(726,730,711,715,0),(726,730,716,720,0),(726,730,721,1000,0),(731,735,0,150,0),(731,735,151,155,800),(731,735,156,160,800),(731,735,161,165,800),(731,735,166,170,800),(731,735,171,175,800),(731,735,176,180,800),(731,735,181,185,800),(731,735,186,190,800),(731,735,191,195,800),(731,735,196,200,800),(731,735,201,205,795),(731,735,206,210,788),(731,735,211,215,780),(731,735,216,220,773),(731,735,221,225,765),(731,735,226,230,758),(731,735,231,235,750),(731,735,236,240,743),(731,735,241,245,735),(731,735,246,250,728),(731,735,251,255,720),(731,735,256,260,713),(731,735,261,265,705),(731,735,266,270,698),(731,735,271,275,690),(731,735,276,280,683),(731,735,281,285,675),(731,735,286,290,668),(731,735,291,295,660),(731,735,296,300,653),(731,735,301,305,645),(731,735,306,310,638),(731,735,311,315,630),(731,735,316,320,623),(731,735,321,325,615),(731,735,326,330,608),(731,735,331,335,600),(731,735,336,340,593),(731,735,341,345,585),(731,735,346,350,578),(731,735,351,355,570),(731,735,356,360,563),(731,735,361,365,555),(731,735,366,370,548),(731,735,371,375,540),(731,735,376,380,533),(731,735,381,385,525),(731,735,386,390,518),(731,735,391,395,510),(731,735,396,400,503),(731,735,401,405,495),(731,735,406,410,488),(731,735,411,415,480),(731,735,416,420,473),(731,735,421,425,465),(731,735,426,430,458),(731,735,431,435,450),(731,735,436,440,443),(731,735,441,445,435),(731,735,446,450,428),(731,735,451,455,420),(731,735,456,460,413),(731,735,461,465,405),(731,735,466,470,398),(731,735,471,475,390),(731,735,476,480,383),(731,735,481,485,375),(731,735,486,490,368),(731,735,491,495,360),(731,735,496,500,353),(731,735,501,505,345),(731,735,506,510,338),(731,735,511,515,330),(731,735,516,520,323),(731,735,521,525,315),(731,735,526,530,308),(731,735,531,535,300),(731,735,536,540,293),(731,735,541,545,285),(731,735,546,550,278),(731,735,551,555,270),(731,735,556,560,263),(731,735,561,565,255),(731,735,566,570,248),(731,735,571,575,240),(731,735,576,580,233),(731,735,581,585,225),(731,735,586,590,218),(731,735,591,595,210),(731,735,596,600,203),(731,735,601,605,195),(731,735,606,610,188),(731,735,611,615,180),(731,735,616,620,173),(731,735,621,625,165),(731,735,626,630,158),(731,735,631,635,150),(731,735,636,640,143),(731,735,641,645,135),(731,735,646,650,128),(731,735,651,655,120),(731,735,656,660,113),(731,735,661,665,105),(731,735,666,670,98),(731,735,671,675,90),(731,735,676,680,83),(731,735,681,685,75),(731,735,686,690,68),(731,735,691,695,60),(731,735,696,700,53),(731,735,701,705,45),(731,735,706,710,38),(731,735,711,715,30),(731,735,716,720,0),(731,735,721,725,0),(731,735,726,1000,0),(736,740,0,150,0),(736,740,151,155,800),(736,740,156,160,800),(736,740,161,165,800),(736,740,166,170,800),(736,740,171,175,800),(736,740,176,180,800),(736,740,181,185,800),(736,740,186,190,800),(736,740,191,195,800),(736,740,196,200,800),(736,740,201,205,800),(736,740,206,210,795),(736,740,211,215,788),(736,740,216,220,780),(736,740,221,225,773),(736,740,226,230,765),(736,740,231,235,758),(736,740,236,240,750),(736,740,241,245,743),(736,740,246,250,735),(736,740,251,255,728),(736,740,256,260,720),(736,740,261,265,713),(736,740,266,270,705),(736,740,271,275,698),(736,740,276,280,690),(736,740,281,285,683),(736,740,286,290,675),(736,740,291,295,668),(736,740,296,300,660),(736,740,301,305,653),(736,740,306,310,645),(736,740,311,315,638),(736,740,316,320,630),(736,740,321,325,623),(736,740,326,330,615),(736,740,331,335,608),(736,740,336,340,600),(736,740,341,345,593),(736,740,346,350,585),(736,740,351,355,578),(736,740,356,360,570),(736,740,361,365,563),(736,740,366,370,555),(736,740,371,375,548),(736,740,376,380,540),(736,740,381,385,533),(736,740,386,390,525),(736,740,391,395,518),(736,740,396,400,510),(736,740,401,405,503),(736,740,406,410,495),(736,740,411,415,488),(736,740,416,420,480),(736,740,421,425,473),(736,740,426,430,465),(736,740,431,435,458),(736,740,436,440,450),(736,740,441,445,443),(736,740,446,450,435),(736,740,451,455,428),(736,740,456,460,420),(736,740,461,465,413),(736,740,466,470,405),(736,740,471,475,398),(736,740,476,480,390),(736,740,481,485,383),(736,740,486,490,375),(736,740,491,495,368),(736,740,496,500,360),(736,740,501,505,353),(736,740,506,510,345),(736,740,511,515,338),(736,740,516,520,330),(736,740,521,525,323),(736,740,526,530,315),(736,740,531,535,308),(736,740,536,540,300),(736,740,541,545,293),(736,740,546,550,285),(736,740,551,555,278),(736,740,556,560,270),(736,740,561,565,263),(736,740,566,570,255),(736,740,571,575,248),(736,740,576,580,240),(736,740,581,585,233),(736,740,586,590,225),(736,740,591,595,218),(736,740,596,600,210),(736,740,601,605,203),(736,740,606,610,195),(736,740,611,615,188),(736,740,616,620,180),(736,740,621,625,173),(736,740,626,630,165),(736,740,631,635,158),(736,740,636,640,150),(736,740,641,645,143),(736,740,646,650,135),(736,740,651,655,128),(736,740,656,660,120),(736,740,661,665,113),(736,740,666,670,105),(736,740,671,675,98),(736,740,676,680,90),(736,740,681,685,83),(736,740,686,690,75),(736,740,691,695,68),(736,740,696,700,60),(736,740,701,705,53),(736,740,706,710,45),(736,740,711,715,38),(736,740,716,720,30),(736,740,721,725,0),(736,740,726,730,0),(736,740,731,1000,0),(741,745,0,150,0),(741,745,151,155,800),(741,745,156,160,800),(741,745,161,165,800),(741,745,166,170,800),(741,745,171,175,800),(741,745,176,180,800),(741,745,181,185,800),(741,745,186,190,800),(741,745,191,195,800),(741,745,196,200,800),(741,745,201,205,800),(741,745,206,210,800),(741,745,211,215,795),(741,745,216,220,788),(741,745,221,225,780),(741,745,226,230,773),(741,745,231,235,765),(741,745,236,240,758),(741,745,241,245,750),(741,745,246,250,743),(741,745,251,255,735),(741,745,256,260,728),(741,745,261,265,720),(741,745,266,270,713),(741,745,271,275,705),(741,745,276,280,698),(741,745,281,285,690),(741,745,286,290,683),(741,745,291,295,675),(741,745,296,300,668),(741,745,301,305,660),(741,745,306,310,653),(741,745,311,315,645),(741,745,316,320,638),(741,745,321,325,630),(741,745,326,330,623),(741,745,331,335,615),(741,745,336,340,608),(741,745,341,345,600),(741,745,346,350,593),(741,745,351,355,585),(741,745,356,360,578),(741,745,361,365,570),(741,745,366,370,563),(741,745,371,375,555),(741,745,376,380,548),(741,745,381,385,540),(741,745,386,390,533),(741,745,391,395,525),(741,745,396,400,518),(741,745,401,405,510),(741,745,406,410,503),(741,745,411,415,495),(741,745,416,420,488),(741,745,421,425,480),(741,745,426,430,473),(741,745,431,435,465),(741,745,436,440,458),(741,745,441,445,450),(741,745,446,450,443),(741,745,451,455,435),(741,745,456,460,428),(741,745,461,465,420),(741,745,466,470,413),(741,745,471,475,405),(741,745,476,480,398),(741,745,481,485,390),(741,745,486,490,383),(741,745,491,495,375),(741,745,496,500,368),(741,745,501,505,360),(741,745,506,510,353),(741,745,511,515,345),(741,745,516,520,338),(741,745,521,525,330),(741,745,526,530,323),(741,745,531,535,315),(741,745,536,540,308),(741,745,541,545,300),(741,745,546,550,293),(741,745,551,555,285),(741,745,556,560,278),(741,745,561,565,270),(741,745,566,570,263),(741,745,571,575,255),(741,745,576,580,248),(741,745,581,585,240),(741,745,586,590,233),(741,745,591,595,225),(741,745,596,600,218),(741,745,601,605,210),(741,745,606,610,203),(741,745,611,615,195),(741,745,616,620,188),(741,745,621,625,180),(741,745,626,630,173),(741,745,631,635,165),(741,745,636,640,158),(741,745,641,645,150),(741,745,646,650,143),(741,745,651,655,135),(741,745,656,660,128),(741,745,661,665,120),(741,745,666,670,113),(741,745,671,675,105),(741,745,676,680,98),(741,745,681,685,90),(741,745,686,690,83),(741,745,691,695,75),(741,745,696,700,68),(741,745,701,705,60),(741,745,706,710,53),(741,745,711,715,45),(741,745,716,720,38),(741,745,721,725,30),(741,745,726,730,0),(741,745,731,735,0),(741,745,736,1000,0),(746,750,0,150,0),(746,750,151,155,800),(746,750,156,160,800),(746,750,161,165,800),(746,750,166,170,800),(746,750,171,175,800),(746,750,176,180,800),(746,750,181,185,800),(746,750,186,190,800),(746,750,191,195,800),(746,750,196,200,800),(746,750,201,205,800),(746,750,206,210,800),(746,750,211,215,800),(746,750,216,220,795),(746,750,221,225,788),(746,750,226,230,780),(746,750,231,235,773),(746,750,236,240,765),(746,750,241,245,758),(746,750,246,250,750),(746,750,251,255,743),(746,750,256,260,735),(746,750,261,265,728),(746,750,266,270,720),(746,750,271,275,713),(746,750,276,280,705),(746,750,281,285,698),(746,750,286,290,690),(746,750,291,295,683),(746,750,296,300,675),(746,750,301,305,668),(746,750,306,310,660),(746,750,311,315,653),(746,750,316,320,645),(746,750,321,325,638),(746,750,326,330,630),(746,750,331,335,623),(746,750,336,340,615),(746,750,341,345,608),(746,750,346,350,600),(746,750,351,355,593),(746,750,356,360,585),(746,750,361,365,578),(746,750,366,370,570),(746,750,371,375,563),(746,750,376,380,555),(746,750,381,385,548),(746,750,386,390,540),(746,750,391,395,533),(746,750,396,400,525),(746,750,401,405,518),(746,750,406,410,510),(746,750,411,415,503),(746,750,416,420,495),(746,750,421,425,488),(746,750,426,430,480),(746,750,431,435,473),(746,750,436,440,465),(746,750,441,445,458),(746,750,446,450,450),(746,750,451,455,443),(746,750,456,460,435),(746,750,461,465,428),(746,750,466,470,420),(746,750,471,475,413),(746,750,476,480,405),(746,750,481,485,398),(746,750,486,490,390),(746,750,491,495,383),(746,750,496,500,375),(746,750,501,505,368),(746,750,506,510,360),(746,750,511,515,353),(746,750,516,520,345),(746,750,521,525,338),(746,750,526,530,330),(746,750,531,535,323),(746,750,536,540,315),(746,750,541,545,308),(746,750,546,550,300),(746,750,551,555,293),(746,750,556,560,285),(746,750,561,565,278),(746,750,566,570,270),(746,750,571,575,263),(746,750,576,580,255),(746,750,581,585,248),(746,750,586,590,240),(746,750,591,595,233),(746,750,596,600,225),(746,750,601,605,218),(746,750,606,610,210),(746,750,611,615,203),(746,750,616,620,195),(746,750,621,625,188),(746,750,626,630,180),(746,750,631,635,173),(746,750,636,640,165),(746,750,641,645,158),(746,750,646,650,150),(746,750,651,655,143),(746,750,656,660,135),(746,750,661,665,128),(746,750,666,670,120),(746,750,671,675,113),(746,750,676,680,105),(746,750,681,685,98),(746,750,686,690,90),(746,750,691,695,83),(746,750,696,700,75),(746,750,701,705,68),(746,750,706,710,60),(746,750,711,715,53),(746,750,716,720,45),(746,750,721,725,38),(746,750,726,730,30),(746,750,731,735,0),(746,750,736,740,0),(746,750,741,1000,0),(751,755,0,150,0),(751,755,151,155,800),(751,755,156,160,800),(751,755,161,165,800),(751,755,166,170,800),(751,755,171,175,800),(751,755,176,180,800),(751,755,181,185,800),(751,755,186,190,800),(751,755,191,195,800),(751,755,196,200,800),(751,755,201,205,800),(751,755,206,210,800),(751,755,211,215,800),(751,755,216,220,800),(751,755,221,225,795),(751,755,226,230,788),(751,755,231,235,780),(751,755,236,240,773),(751,755,241,245,765),(751,755,246,250,758),(751,755,251,255,750),(751,755,256,260,743),(751,755,261,265,735),(751,755,266,270,728),(751,755,271,275,720),(751,755,276,280,713),(751,755,281,285,705),(751,755,286,290,698),(751,755,291,295,690),(751,755,296,300,683),(751,755,301,305,675),(751,755,306,310,668),(751,755,311,315,660),(751,755,316,320,653),(751,755,321,325,645),(751,755,326,330,638),(751,755,331,335,630),(751,755,336,340,623),(751,755,341,345,615),(751,755,346,350,608),(751,755,351,355,600),(751,755,356,360,593),(751,755,361,365,585),(751,755,366,370,578),(751,755,371,375,570),(751,755,376,380,563),(751,755,381,385,555),(751,755,386,390,548),(751,755,391,395,540),(751,755,396,400,533),(751,755,401,405,525),(751,755,406,410,518),(751,755,411,415,510),(751,755,416,420,503),(751,755,421,425,495),(751,755,426,430,488),(751,755,431,435,480),(751,755,436,440,473),(751,755,441,445,465),(751,755,446,450,458),(751,755,451,455,450),(751,755,456,460,443),(751,755,461,465,435),(751,755,466,470,428),(751,755,471,475,420),(751,755,476,480,413),(751,755,481,485,405),(751,755,486,490,398),(751,755,491,495,390),(751,755,496,500,383),(751,755,501,505,375),(751,755,506,510,368),(751,755,511,515,360),(751,755,516,520,353),(751,755,521,525,345),(751,755,526,530,338),(751,755,531,535,330),(751,755,536,540,323),(751,755,541,545,315),(751,755,546,550,308),(751,755,551,555,300),(751,755,556,560,293),(751,755,561,565,285),(751,755,566,570,278),(751,755,571,575,270),(751,755,576,580,263),(751,755,581,585,255),(751,755,586,590,248),(751,755,591,595,240),(751,755,596,600,233),(751,755,601,605,225),(751,755,606,610,218),(751,755,611,615,210),(751,755,616,620,203),(751,755,621,625,195),(751,755,626,630,188),(751,755,631,635,180),(751,755,636,640,173),(751,755,641,645,165),(751,755,646,650,158),(751,755,651,655,150),(751,755,656,660,143),(751,755,661,665,135),(751,755,666,670,128),(751,755,671,675,120),(751,755,676,680,113),(751,755,681,685,105),(751,755,686,690,98),(751,755,691,695,90),(751,755,696,700,83),(751,755,701,705,75),(751,755,706,710,68),(751,755,711,715,60),(751,755,716,720,53),(751,755,721,725,45),(751,755,726,730,38),(751,755,731,735,30),(751,755,736,740,0),(751,755,741,745,0),(751,755,746,1000,0),(756,760,0,150,0),(756,760,151,155,800),(756,760,156,160,800),(756,760,161,165,800),(756,760,166,170,800),(756,760,171,175,800),(756,760,176,180,800),(756,760,181,185,800),(756,760,186,190,800),(756,760,191,195,800),(756,760,196,200,800),(756,760,201,205,800),(756,760,206,210,800),(756,760,211,215,800),(756,760,216,220,800),(756,760,221,225,800),(756,760,226,230,795),(756,760,231,235,788),(756,760,236,240,780),(756,760,241,245,773),(756,760,246,250,765),(756,760,251,255,758),(756,760,256,260,750),(756,760,261,265,743),(756,760,266,270,735),(756,760,271,275,728),(756,760,276,280,720),(756,760,281,285,713),(756,760,286,290,705),(756,760,291,295,698),(756,760,296,300,690),(756,760,301,305,683),(756,760,306,310,675),(756,760,311,315,668),(756,760,316,320,660),(756,760,321,325,653),(756,760,326,330,645),(756,760,331,335,638),(756,760,336,340,630),(756,760,341,345,623),(756,760,346,350,615),(756,760,351,355,608),(756,760,356,360,600),(756,760,361,365,593),(756,760,366,370,585),(756,760,371,375,578),(756,760,376,380,570),(756,760,381,385,563),(756,760,386,390,555),(756,760,391,395,548),(756,760,396,400,540),(756,760,401,405,533),(756,760,406,410,525),(756,760,411,415,518),(756,760,416,420,510),(756,760,421,425,503),(756,760,426,430,495),(756,760,431,435,488),(756,760,436,440,480),(756,760,441,445,473),(756,760,446,450,465),(756,760,451,455,458),(756,760,456,460,450),(756,760,461,465,443),(756,760,466,470,435),(756,760,471,475,428),(756,760,476,480,420),(756,760,481,485,413),(756,760,486,490,405),(756,760,491,495,398),(756,760,496,500,390),(756,760,501,505,383),(756,760,506,510,375),(756,760,511,515,368),(756,760,516,520,360),(756,760,521,525,353),(756,760,526,530,345),(756,760,531,535,338),(756,760,536,540,330),(756,760,541,545,323),(756,760,546,550,315),(756,760,551,555,308),(756,760,556,560,300),(756,760,561,565,293),(756,760,566,570,285),(756,760,571,575,278),(756,760,576,580,270),(756,760,581,585,263),(756,760,586,590,255),(756,760,591,595,248),(756,760,596,600,240),(756,760,601,605,233),(756,760,606,610,225),(756,760,611,615,218),(756,760,616,620,210),(756,760,621,625,203),(756,760,626,630,195),(756,760,631,635,188),(756,760,636,640,180),(756,760,641,645,173),(756,760,646,650,165),(756,760,651,655,158),(756,760,656,660,150),(756,760,661,665,143),(756,760,666,670,135),(756,760,671,675,128),(756,760,676,680,120),(756,760,681,685,113),(756,760,686,690,105),(756,760,691,695,98),(756,760,696,700,90),(756,760,701,705,83),(756,760,706,710,75),(756,760,711,715,68),(756,760,716,720,60),(756,760,721,725,53),(756,760,726,730,45),(756,760,731,735,38),(756,760,736,740,30),(756,760,741,745,0),(756,760,746,750,0),(756,760,751,1000,0),(761,765,0,150,0),(761,765,151,155,800),(761,765,156,160,800),(761,765,161,165,800),(761,765,166,170,800),(761,765,171,175,800),(761,765,176,180,800),(761,765,181,185,800),(761,765,186,190,800),(761,765,191,195,800),(761,765,196,200,800),(761,765,201,205,800),(761,765,206,210,800),(761,765,211,215,800),(761,765,216,220,800),(761,765,221,225,800),(761,765,226,230,800),(761,765,231,235,795),(761,765,236,240,788),(761,765,241,245,780),(761,765,246,250,773),(761,765,251,255,765),(761,765,256,260,758),(761,765,261,265,750),(761,765,266,270,743),(761,765,271,275,735),(761,765,276,280,728),(761,765,281,285,720),(761,765,286,290,713),(761,765,291,295,705),(761,765,296,300,698),(761,765,301,305,690),(761,765,306,310,683),(761,765,311,315,675),(761,765,316,320,668),(761,765,321,325,660),(761,765,326,330,653),(761,765,331,335,645),(761,765,336,340,638),(761,765,341,345,630),(761,765,346,350,623),(761,765,351,355,615),(761,765,356,360,608),(761,765,361,365,600),(761,765,366,370,593),(761,765,371,375,585),(761,765,376,380,578),(761,765,381,385,570),(761,765,386,390,563),(761,765,391,395,555),(761,765,396,400,548),(761,765,401,405,540),(761,765,406,410,533),(761,765,411,415,525),(761,765,416,420,518),(761,765,421,425,510),(761,765,426,430,503),(761,765,431,435,495),(761,765,436,440,488),(761,765,441,445,480),(761,765,446,450,473),(761,765,451,455,465),(761,765,456,460,458),(761,765,461,465,450),(761,765,466,470,443),(761,765,471,475,435),(761,765,476,480,428),(761,765,481,485,420),(761,765,486,490,413),(761,765,491,495,405),(761,765,496,500,398),(761,765,501,505,390),(761,765,506,510,383),(761,765,511,515,375),(761,765,516,520,368),(761,765,521,525,360),(761,765,526,530,353),(761,765,531,535,345),(761,765,536,540,338),(761,765,541,545,330),(761,765,546,550,323),(761,765,551,555,315),(761,765,556,560,308),(761,765,561,565,300),(761,765,566,570,293),(761,765,571,575,285),(761,765,576,580,278),(761,765,581,585,270),(761,765,586,590,263),(761,765,591,595,255),(761,765,596,600,248),(761,765,601,605,240),(761,765,606,610,233),(761,765,611,615,225),(761,765,616,620,218),(761,765,621,625,210),(761,765,626,630,203),(761,765,631,635,195),(761,765,636,640,188),(761,765,641,645,180),(761,765,646,650,173),(761,765,651,655,165),(761,765,656,660,158),(761,765,661,665,150),(761,765,666,670,143),(761,765,671,675,135),(761,765,676,680,128),(761,765,681,685,120),(761,765,686,690,113),(761,765,691,695,105),(761,765,696,700,98),(761,765,701,705,90),(761,765,706,710,83),(761,765,711,715,75),(761,765,716,720,68),(761,765,721,725,60),(761,765,726,730,53),(761,765,731,735,45),(761,765,736,740,38),(761,765,741,745,30),(761,765,746,750,0),(761,765,751,755,0),(761,765,756,1000,0),(766,770,0,150,0),(766,770,151,155,800),(766,770,156,160,800),(766,770,161,165,800),(766,770,166,170,800),(766,770,171,175,800),(766,770,176,180,800),(766,770,181,185,800),(766,770,186,190,800),(766,770,191,195,800),(766,770,196,200,800),(766,770,201,205,800),(766,770,206,210,800),(766,770,211,215,800),(766,770,216,220,800),(766,770,221,225,800),(766,770,226,230,800),(766,770,231,235,800),(766,770,236,240,795),(766,770,241,245,788),(766,770,246,250,780),(766,770,251,255,773),(766,770,256,260,765),(766,770,261,265,758),(766,770,266,270,750),(766,770,271,275,743),(766,770,276,280,735),(766,770,281,285,728),(766,770,286,290,720),(766,770,291,295,713),(766,770,296,300,705),(766,770,301,305,698),(766,770,306,310,690),(766,770,311,315,683),(766,770,316,320,675),(766,770,321,325,668),(766,770,326,330,660),(766,770,331,335,653),(766,770,336,340,645),(766,770,341,345,638),(766,770,346,350,630),(766,770,351,355,623),(766,770,356,360,615),(766,770,361,365,608),(766,770,366,370,600),(766,770,371,375,593),(766,770,376,380,585),(766,770,381,385,578),(766,770,386,390,570),(766,770,391,395,563),(766,770,396,400,555),(766,770,401,405,548),(766,770,406,410,540),(766,770,411,415,533),(766,770,416,420,525),(766,770,421,425,518),(766,770,426,430,510),(766,770,431,435,503),(766,770,436,440,495),(766,770,441,445,488),(766,770,446,450,480),(766,770,451,455,473),(766,770,456,460,465),(766,770,461,465,458),(766,770,466,470,450),(766,770,471,475,443),(766,770,476,480,435),(766,770,481,485,428),(766,770,486,490,420),(766,770,491,495,413),(766,770,496,500,405),(766,770,501,505,398),(766,770,506,510,390),(766,770,511,515,383),(766,770,516,520,375),(766,770,521,525,368),(766,770,526,530,360),(766,770,531,535,353),(766,770,536,540,345),(766,770,541,545,338),(766,770,546,550,330),(766,770,551,555,323),(766,770,556,560,315),(766,770,561,565,308),(766,770,566,570,300),(766,770,571,575,293),(766,770,576,580,285),(766,770,581,585,278),(766,770,586,590,270),(766,770,591,595,263),(766,770,596,600,255),(766,770,601,605,248),(766,770,606,610,240),(766,770,611,615,233),(766,770,616,620,225),(766,770,621,625,218),(766,770,626,630,210),(766,770,631,635,203),(766,770,636,640,195),(766,770,641,645,188),(766,770,646,650,180),(766,770,651,655,173),(766,770,656,660,165),(766,770,661,665,158),(766,770,666,670,150),(766,770,671,675,143),(766,770,676,680,135),(766,770,681,685,128),(766,770,686,690,120),(766,770,691,695,113),(766,770,696,700,105),(766,770,701,705,98),(766,770,706,710,90),(766,770,711,715,83),(766,770,716,720,75),(766,770,721,725,68),(766,770,726,730,60),(766,770,731,735,53),(766,770,736,740,45),(766,770,741,745,38),(766,770,746,750,30),(766,770,751,755,0),(766,770,756,760,0),(766,770,761,1000,0),(771,775,0,150,0),(771,775,151,155,800),(771,775,156,160,800),(771,775,161,165,800),(771,775,166,170,800),(771,775,171,175,800),(771,775,176,180,800),(771,775,181,185,800),(771,775,186,190,800),(771,775,191,195,800),(771,775,196,200,800),(771,775,201,205,800),(771,775,206,210,800),(771,775,211,215,800),(771,775,216,220,800),(771,775,221,225,800),(771,775,226,230,800),(771,775,231,235,800),(771,775,236,240,800),(771,775,241,245,795),(771,775,246,250,788),(771,775,251,255,780),(771,775,256,260,773),(771,775,261,265,765),(771,775,266,270,758),(771,775,271,275,750),(771,775,276,280,743),(771,775,281,285,735),(771,775,286,290,728),(771,775,291,295,720),(771,775,296,300,713),(771,775,301,305,705),(771,775,306,310,698),(771,775,311,315,690),(771,775,316,320,683),(771,775,321,325,675),(771,775,326,330,668),(771,775,331,335,660),(771,775,336,340,653),(771,775,341,345,645),(771,775,346,350,638),(771,775,351,355,630),(771,775,356,360,623),(771,775,361,365,615),(771,775,366,370,608),(771,775,371,375,600),(771,775,376,380,593),(771,775,381,385,585),(771,775,386,390,578),(771,775,391,395,570),(771,775,396,400,563),(771,775,401,405,555),(771,775,406,410,548),(771,775,411,415,540),(771,775,416,420,533),(771,775,421,425,525),(771,775,426,430,518),(771,775,431,435,510),(771,775,436,440,503),(771,775,441,445,495),(771,775,446,450,488),(771,775,451,455,480),(771,775,456,460,473),(771,775,461,465,465),(771,775,466,470,458),(771,775,471,475,450),(771,775,476,480,443),(771,775,481,485,435),(771,775,486,490,428),(771,775,491,495,420),(771,775,496,500,413),(771,775,501,505,405),(771,775,506,510,398),(771,775,511,515,390),(771,775,516,520,383),(771,775,521,525,375),(771,775,526,530,368),(771,775,531,535,360),(771,775,536,540,353),(771,775,541,545,345),(771,775,546,550,338),(771,775,551,555,330),(771,775,556,560,323),(771,775,561,565,315),(771,775,566,570,308),(771,775,571,575,300),(771,775,576,580,293),(771,775,581,585,285),(771,775,586,590,278),(771,775,591,595,270),(771,775,596,600,263),(771,775,601,605,255),(771,775,606,610,248),(771,775,611,615,240),(771,775,616,620,233),(771,775,621,625,225),(771,775,626,630,218),(771,775,631,635,210),(771,775,636,640,203),(771,775,641,645,195),(771,775,646,650,188),(771,775,651,655,180),(771,775,656,660,173),(771,775,661,665,165),(771,775,666,670,158),(771,775,671,675,150),(771,775,676,680,143),(771,775,681,685,135),(771,775,686,690,128),(771,775,691,695,120),(771,775,696,700,113),(771,775,701,705,105),(771,775,706,710,98),(771,775,711,715,90),(771,775,716,720,83),(771,775,721,725,75),(771,775,726,730,68),(771,775,731,735,60),(771,775,736,740,53),(771,775,741,745,45),(771,775,746,750,38),(771,775,751,755,30),(771,775,756,760,0),(771,775,761,765,0),(771,775,766,1000,0),(776,780,0,150,0),(776,780,151,155,800),(776,780,156,160,800),(776,780,161,165,800),(776,780,166,170,800),(776,780,171,175,800),(776,780,176,180,800),(776,780,181,185,800),(776,780,186,190,800),(776,780,191,195,800),(776,780,196,200,800),(776,780,201,205,800),(776,780,206,210,800),(776,780,211,215,800),(776,780,216,220,800),(776,780,221,225,800),(776,780,226,230,800),(776,780,231,235,800),(776,780,236,240,800),(776,780,241,245,800),(776,780,246,250,795),(776,780,251,255,788),(776,780,256,260,780),(776,780,261,265,773),(776,780,266,270,765),(776,780,271,275,758),(776,780,276,280,750),(776,780,281,285,743),(776,780,286,290,735),(776,780,291,295,728),(776,780,296,300,720),(776,780,301,305,713),(776,780,306,310,705),(776,780,311,315,698),(776,780,316,320,690),(776,780,321,325,683),(776,780,326,330,675),(776,780,331,335,668),(776,780,336,340,660),(776,780,341,345,653),(776,780,346,350,645),(776,780,351,355,638),(776,780,356,360,630),(776,780,361,365,623),(776,780,366,370,615),(776,780,371,375,608),(776,780,376,380,600),(776,780,381,385,593),(776,780,386,390,585),(776,780,391,395,578),(776,780,396,400,570),(776,780,401,405,563),(776,780,406,410,555),(776,780,411,415,548),(776,780,416,420,540),(776,780,421,425,533),(776,780,426,430,525),(776,780,431,435,518),(776,780,436,440,510),(776,780,441,445,503),(776,780,446,450,495),(776,780,451,455,488),(776,780,456,460,480),(776,780,461,465,473),(776,780,466,470,465),(776,780,471,475,458),(776,780,476,480,450),(776,780,481,485,443),(776,780,486,490,435),(776,780,491,495,428),(776,780,496,500,420),(776,780,501,505,413),(776,780,506,510,405),(776,780,511,515,398),(776,780,516,520,390),(776,780,521,525,383),(776,780,526,530,375),(776,780,531,535,368),(776,780,536,540,360),(776,780,541,545,353),(776,780,546,550,345),(776,780,551,555,338),(776,780,556,560,330),(776,780,561,565,323),(776,780,566,570,315),(776,780,571,575,308),(776,780,576,580,300),(776,780,581,585,293),(776,780,586,590,285),(776,780,591,595,278),(776,780,596,600,270),(776,780,601,605,263),(776,780,606,610,255),(776,780,611,615,248),(776,780,616,620,240),(776,780,621,625,233),(776,780,626,630,225),(776,780,631,635,218),(776,780,636,640,210),(776,780,641,645,203),(776,780,646,650,195),(776,780,651,655,188),(776,780,656,660,180),(776,780,661,665,173),(776,780,666,670,165),(776,780,671,675,158),(776,780,676,680,150),(776,780,681,685,143),(776,780,686,690,135),(776,780,691,695,128),(776,780,696,700,120),(776,780,701,705,113),(776,780,706,710,105),(776,780,711,715,98),(776,780,716,720,90),(776,780,721,725,83),(776,780,726,730,75),(776,780,731,735,68),(776,780,736,740,60),(776,780,741,745,53),(776,780,746,750,45),(776,780,751,755,38),(776,780,756,760,30),(776,780,761,765,0),(776,780,766,770,0),(776,780,771,1000,0),(781,785,0,150,0),(781,785,151,155,800),(781,785,156,160,800),(781,785,161,165,800),(781,785,166,170,800),(781,785,171,175,800),(781,785,176,180,800),(781,785,181,185,800),(781,785,186,190,800),(781,785,191,195,800),(781,785,196,200,800),(781,785,201,205,800),(781,785,206,210,800),(781,785,211,215,800),(781,785,216,220,800),(781,785,221,225,800),(781,785,226,230,800),(781,785,231,235,800),(781,785,236,240,800),(781,785,241,245,800),(781,785,246,250,800),(781,785,251,255,795),(781,785,256,260,788),(781,785,261,265,780),(781,785,266,270,773),(781,785,271,275,765),(781,785,276,280,758),(781,785,281,285,750),(781,785,286,290,743),(781,785,291,295,735),(781,785,296,300,728),(781,785,301,305,720),(781,785,306,310,713),(781,785,311,315,705),(781,785,316,320,698),(781,785,321,325,690),(781,785,326,330,683),(781,785,331,335,675),(781,785,336,340,668),(781,785,341,345,660),(781,785,346,350,653),(781,785,351,355,645),(781,785,356,360,638),(781,785,361,365,630),(781,785,366,370,623),(781,785,371,375,615),(781,785,376,380,608),(781,785,381,385,600),(781,785,386,390,593),(781,785,391,395,585),(781,785,396,400,578),(781,785,401,405,570),(781,785,406,410,563),(781,785,411,415,555),(781,785,416,420,548),(781,785,421,425,540),(781,785,426,430,533),(781,785,431,435,525),(781,785,436,440,518),(781,785,441,445,510),(781,785,446,450,503),(781,785,451,455,495),(781,785,456,460,488),(781,785,461,465,480),(781,785,466,470,473),(781,785,471,475,465),(781,785,476,480,458),(781,785,481,485,450),(781,785,486,490,443),(781,785,491,495,435),(781,785,496,500,428),(781,785,501,505,420),(781,785,506,510,413),(781,785,511,515,405),(781,785,516,520,398),(781,785,521,525,390),(781,785,526,530,383),(781,785,531,535,375),(781,785,536,540,368),(781,785,541,545,360),(781,785,546,550,353),(781,785,551,555,345),(781,785,556,560,338),(781,785,561,565,330),(781,785,566,570,323),(781,785,571,575,315),(781,785,576,580,308),(781,785,581,585,300),(781,785,586,590,293),(781,785,591,595,285),(781,785,596,600,278),(781,785,601,605,270),(781,785,606,610,263),(781,785,611,615,255),(781,785,616,620,248),(781,785,621,625,240),(781,785,626,630,233),(781,785,631,635,225),(781,785,636,640,218),(781,785,641,645,210),(781,785,646,650,203),(781,785,651,655,195),(781,785,656,660,188),(781,785,661,665,180),(781,785,666,670,173),(781,785,671,675,165),(781,785,676,680,158),(781,785,681,685,150),(781,785,686,690,143),(781,785,691,695,135),(781,785,696,700,128),(781,785,701,705,120),(781,785,706,710,113),(781,785,711,715,105),(781,785,716,720,98),(781,785,721,725,90),(781,785,726,730,83),(781,785,731,735,75),(781,785,736,740,68),(781,785,741,745,60),(781,785,746,750,53),(781,785,751,755,45),(781,785,756,760,38),(781,785,761,765,30),(781,785,766,770,0),(781,785,771,775,0),(781,785,776,1000,0),(786,790,0,150,0),(786,790,151,155,800),(786,790,156,160,800),(786,790,161,165,800),(786,790,166,170,800),(786,790,171,175,800),(786,790,176,180,800),(786,790,181,185,800),(786,790,186,190,800),(786,790,191,195,800),(786,790,196,200,800),(786,790,201,205,800),(786,790,206,210,800),(786,790,211,215,800),(786,790,216,220,800),(786,790,221,225,800),(786,790,226,230,800),(786,790,231,235,800),(786,790,236,240,800),(786,790,241,245,800),(786,790,246,250,800),(786,790,251,255,800),(786,790,256,260,795),(786,790,261,265,788),(786,790,266,270,780),(786,790,271,275,773),(786,790,276,280,765),(786,790,281,285,758),(786,790,286,290,750),(786,790,291,295,743),(786,790,296,300,735),(786,790,301,305,728),(786,790,306,310,720),(786,790,311,315,713),(786,790,316,320,705),(786,790,321,325,698),(786,790,326,330,690),(786,790,331,335,683),(786,790,336,340,675),(786,790,341,345,668),(786,790,346,350,660),(786,790,351,355,653),(786,790,356,360,645),(786,790,361,365,638),(786,790,366,370,630),(786,790,371,375,623),(786,790,376,380,615),(786,790,381,385,608),(786,790,386,390,600),(786,790,391,395,593),(786,790,396,400,585),(786,790,401,405,578),(786,790,406,410,570),(786,790,411,415,563),(786,790,416,420,555),(786,790,421,425,548),(786,790,426,430,540),(786,790,431,435,533),(786,790,436,440,525),(786,790,441,445,518),(786,790,446,450,510),(786,790,451,455,503),(786,790,456,460,495),(786,790,461,465,488),(786,790,466,470,480),(786,790,471,475,473),(786,790,476,480,465),(786,790,481,485,458),(786,790,486,490,450),(786,790,491,495,443),(786,790,496,500,435),(786,790,501,505,428),(786,790,506,510,420),(786,790,511,515,413),(786,790,516,520,405),(786,790,521,525,398),(786,790,526,530,390),(786,790,531,535,383),(786,790,536,540,375),(786,790,541,545,368),(786,790,546,550,360),(786,790,551,555,353),(786,790,556,560,345),(786,790,561,565,338),(786,790,566,570,330),(786,790,571,575,323),(786,790,576,580,315),(786,790,581,585,308),(786,790,586,590,300),(786,790,591,595,293),(786,790,596,600,285),(786,790,601,605,278),(786,790,606,610,270),(786,790,611,615,263),(786,790,616,620,255),(786,790,621,625,248),(786,790,626,630,240),(786,790,631,635,233),(786,790,636,640,225),(786,790,641,645,218),(786,790,646,650,210),(786,790,651,655,203),(786,790,656,660,195),(786,790,661,665,188),(786,790,666,670,180),(786,790,671,675,173),(786,790,676,680,165),(786,790,681,685,158),(786,790,686,690,150),(786,790,691,695,143),(786,790,696,700,135),(786,790,701,705,128),(786,790,706,710,120),(786,790,711,715,113),(786,790,716,720,105),(786,790,721,725,98),(786,790,726,730,90),(786,790,731,735,83),(786,790,736,740,75),(786,790,741,745,68),(786,790,746,750,60),(786,790,751,755,53),(786,790,756,760,45),(786,790,761,765,38),(786,790,766,770,30),(786,790,771,775,0),(786,790,776,780,0),(786,790,781,1000,0),(791,795,0,150,0),(791,795,151,155,800),(791,795,156,160,800),(791,795,161,165,800),(791,795,166,170,800),(791,795,171,175,800),(791,795,176,180,800),(791,795,181,185,800),(791,795,186,190,800),(791,795,191,195,800),(791,795,196,200,800),(791,795,201,205,800),(791,795,206,210,800),(791,795,211,215,800),(791,795,216,220,800),(791,795,221,225,800),(791,795,226,230,800),(791,795,231,235,800),(791,795,236,240,800),(791,795,241,245,800),(791,795,246,250,800),(791,795,251,255,800),(791,795,256,260,800),(791,795,261,265,795),(791,795,266,270,788),(791,795,271,275,780),(791,795,276,280,773),(791,795,281,285,765),(791,795,286,290,758),(791,795,291,295,750),(791,795,296,300,743),(791,795,301,305,735),(791,795,306,310,728),(791,795,311,315,720),(791,795,316,320,713),(791,795,321,325,705),(791,795,326,330,698),(791,795,331,335,690),(791,795,336,340,683),(791,795,341,345,675),(791,795,346,350,668),(791,795,351,355,660),(791,795,356,360,653),(791,795,361,365,645),(791,795,366,370,638),(791,795,371,375,630),(791,795,376,380,623),(791,795,381,385,615),(791,795,386,390,608),(791,795,391,395,600),(791,795,396,400,593),(791,795,401,405,585),(791,795,406,410,578),(791,795,411,415,570),(791,795,416,420,563),(791,795,421,425,555),(791,795,426,430,548),(791,795,431,435,540),(791,795,436,440,533),(791,795,441,445,525),(791,795,446,450,518),(791,795,451,455,510),(791,795,456,460,503),(791,795,461,465,495),(791,795,466,470,488),(791,795,471,475,480),(791,795,476,480,473),(791,795,481,485,465),(791,795,486,490,458),(791,795,491,495,450),(791,795,496,500,443),(791,795,501,505,435),(791,795,506,510,428),(791,795,511,515,420),(791,795,516,520,413),(791,795,521,525,405),(791,795,526,530,398),(791,795,531,535,390),(791,795,536,540,383),(791,795,541,545,375),(791,795,546,550,368),(791,795,551,555,360),(791,795,556,560,353),(791,795,561,565,345),(791,795,566,570,338),(791,795,571,575,330),(791,795,576,580,323),(791,795,581,585,315),(791,795,586,590,308),(791,795,591,595,300),(791,795,596,600,293),(791,795,601,605,285),(791,795,606,610,278),(791,795,611,615,270),(791,795,616,620,263),(791,795,621,625,255),(791,795,626,630,248),(791,795,631,635,240),(791,795,636,640,233),(791,795,641,645,225),(791,795,646,650,218),(791,795,651,655,210),(791,795,656,660,203),(791,795,661,665,195),(791,795,666,670,188),(791,795,671,675,180),(791,795,676,680,173),(791,795,681,685,165),(791,795,686,690,158),(791,795,691,695,150),(791,795,696,700,143),(791,795,701,705,135),(791,795,706,710,128),(791,795,711,715,120),(791,795,716,720,113),(791,795,721,725,105),(791,795,726,730,98),(791,795,731,735,90),(791,795,736,740,83),(791,795,741,745,75),(791,795,746,750,68),(791,795,751,755,60),(791,795,756,760,53),(791,795,761,765,45),(791,795,766,770,38),(791,795,771,775,30),(791,795,776,780,0),(791,795,781,785,0),(791,795,786,1000,0),(796,800,0,150,0),(796,800,151,155,800),(796,800,156,160,800),(796,800,161,165,800),(796,800,166,170,800),(796,800,171,175,800),(796,800,176,180,800),(796,800,181,185,800),(796,800,186,190,800),(796,800,191,195,800),(796,800,196,200,800),(796,800,201,205,800),(796,800,206,210,800),(796,800,211,215,800),(796,800,216,220,800),(796,800,221,225,800),(796,800,226,230,800),(796,800,231,235,800),(796,800,236,240,800),(796,800,241,245,800),(796,800,246,250,800),(796,800,251,255,800),(796,800,256,260,800),(796,800,261,265,800),(796,800,266,270,795),(796,800,271,275,788),(796,800,276,280,780),(796,800,281,285,773),(796,800,286,290,765),(796,800,291,295,758),(796,800,296,300,750),(796,800,301,305,743),(796,800,306,310,735),(796,800,311,315,728),(796,800,316,320,720),(796,800,321,325,713),(796,800,326,330,705),(796,800,331,335,698),(796,800,336,340,690),(796,800,341,345,683),(796,800,346,350,675),(796,800,351,355,668),(796,800,356,360,660),(796,800,361,365,653),(796,800,366,370,645),(796,800,371,375,638),(796,800,376,380,630),(796,800,381,385,623),(796,800,386,390,615),(796,800,391,395,608),(796,800,396,400,600),(796,800,401,405,593),(796,800,406,410,585),(796,800,411,415,578),(796,800,416,420,570),(796,800,421,425,563),(796,800,426,430,555),(796,800,431,435,548),(796,800,436,440,540),(796,800,441,445,533),(796,800,446,450,525),(796,800,451,455,518),(796,800,456,460,510),(796,800,461,465,503),(796,800,466,470,495),(796,800,471,475,488),(796,800,476,480,480),(796,800,481,485,473),(796,800,486,490,465),(796,800,491,495,458),(796,800,496,500,450),(796,800,501,505,443),(796,800,506,510,435),(796,800,511,515,428),(796,800,516,520,420),(796,800,521,525,413),(796,800,526,530,405),(796,800,531,535,398),(796,800,536,540,390),(796,800,541,545,383),(796,800,546,550,375),(796,800,551,555,368),(796,800,556,560,360),(796,800,561,565,353),(796,800,566,570,345),(796,800,571,575,338),(796,800,576,580,330),(796,800,581,585,323),(796,800,586,590,315),(796,800,591,595,308),(796,800,596,600,300),(796,800,601,605,293),(796,800,606,610,285),(796,800,611,615,278),(796,800,616,620,270),(796,800,621,625,263),(796,800,626,630,255),(796,800,631,635,248),(796,800,636,640,240),(796,800,641,645,233),(796,800,646,650,225),(796,800,651,655,218),(796,800,656,660,210),(796,800,661,665,203),(796,800,666,670,195),(796,800,671,675,188),(796,800,676,680,180),(796,800,681,685,173),(796,800,686,690,165),(796,800,691,695,158),(796,800,696,700,150),(796,800,701,705,143),(796,800,706,710,135),(796,800,711,715,128),(796,800,716,720,120),(796,800,721,725,113),(796,800,726,730,105),(796,800,731,735,98),(796,800,736,740,90),(796,800,741,745,83),(796,800,746,750,75),(796,800,751,755,68),(796,800,756,760,60),(796,800,761,765,53),(796,800,766,770,45),(796,800,771,775,38),(796,800,776,780,30),(796,800,781,785,0),(796,800,786,790,0),(796,800,791,1000,0),(801,805,0,150,0),(801,805,151,155,800),(801,805,156,160,800),(801,805,161,165,800),(801,805,166,170,800),(801,805,171,175,800),(801,805,176,180,800),(801,805,181,185,800),(801,805,186,190,800),(801,805,191,195,800),(801,805,196,200,800),(801,805,201,205,800),(801,805,206,210,800),(801,805,211,215,800),(801,805,216,220,800),(801,805,221,225,800),(801,805,226,230,800),(801,805,231,235,800),(801,805,236,240,800),(801,805,241,245,800),(801,805,246,250,800),(801,805,251,255,800),(801,805,256,260,800),(801,805,261,265,800),(801,805,266,270,800),(801,805,271,275,795),(801,805,276,280,788),(801,805,281,285,780),(801,805,286,290,773),(801,805,291,295,765),(801,805,296,300,758),(801,805,301,305,750),(801,805,306,310,743),(801,805,311,315,735),(801,805,316,320,728),(801,805,321,325,720),(801,805,326,330,713),(801,805,331,335,705),(801,805,336,340,698),(801,805,341,345,690),(801,805,346,350,683),(801,805,351,355,675),(801,805,356,360,668),(801,805,361,365,660),(801,805,366,370,653),(801,805,371,375,645),(801,805,376,380,638),(801,805,381,385,630),(801,805,386,390,623),(801,805,391,395,615),(801,805,396,400,608),(801,805,401,405,600),(801,805,406,410,593),(801,805,411,415,585),(801,805,416,420,578),(801,805,421,425,570),(801,805,426,430,563),(801,805,431,435,555),(801,805,436,440,548),(801,805,441,445,540),(801,805,446,450,533),(801,805,451,455,525),(801,805,456,460,518),(801,805,461,465,510),(801,805,466,470,503),(801,805,471,475,495),(801,805,476,480,488),(801,805,481,485,480),(801,805,486,490,473),(801,805,491,495,465),(801,805,496,500,458),(801,805,501,505,450),(801,805,506,510,443),(801,805,511,515,435),(801,805,516,520,428),(801,805,521,525,420),(801,805,526,530,413),(801,805,531,535,405),(801,805,536,540,398),(801,805,541,545,390),(801,805,546,550,383),(801,805,551,555,375),(801,805,556,560,368),(801,805,561,565,360),(801,805,566,570,353),(801,805,571,575,345),(801,805,576,580,338),(801,805,581,585,330),(801,805,586,590,323),(801,805,591,595,315),(801,805,596,600,308),(801,805,601,605,300),(801,805,606,610,293),(801,805,611,615,285),(801,805,616,620,278),(801,805,621,625,270),(801,805,626,630,263),(801,805,631,635,255),(801,805,636,640,248),(801,805,641,645,240),(801,805,646,650,233),(801,805,651,655,225),(801,805,656,660,218),(801,805,661,665,210),(801,805,666,670,203),(801,805,671,675,195),(801,805,676,680,188),(801,805,681,685,180),(801,805,686,690,173),(801,805,691,695,165),(801,805,696,700,158),(801,805,701,705,150),(801,805,706,710,143),(801,805,711,715,135),(801,805,716,720,128),(801,805,721,725,120),(801,805,726,730,113),(801,805,731,735,105),(801,805,736,740,98),(801,805,741,745,90),(801,805,746,750,83),(801,805,751,755,75),(801,805,756,760,68),(801,805,761,765,60),(801,805,766,770,53),(801,805,771,775,45),(801,805,776,780,38),(801,805,781,785,30),(801,805,786,790,0),(801,805,791,795,0),(801,805,796,1000,0),(806,810,0,150,0),(806,810,151,155,800),(806,810,156,160,800),(806,810,161,165,800),(806,810,166,170,800),(806,810,171,175,800),(806,810,176,180,800),(806,810,181,185,800),(806,810,186,190,800),(806,810,191,195,800),(806,810,196,200,800),(806,810,201,205,800),(806,810,206,210,800),(806,810,211,215,800),(806,810,216,220,800),(806,810,221,225,800),(806,810,226,230,800),(806,810,231,235,800),(806,810,236,240,800),(806,810,241,245,800),(806,810,246,250,800),(806,810,251,255,800),(806,810,256,260,800),(806,810,261,265,800),(806,810,266,270,800),(806,810,271,275,800),(806,810,276,280,795),(806,810,281,285,788),(806,810,286,290,780),(806,810,291,295,773),(806,810,296,300,765),(806,810,301,305,758),(806,810,306,310,750),(806,810,311,315,743),(806,810,316,320,735),(806,810,321,325,728),(806,810,326,330,720),(806,810,331,335,713),(806,810,336,340,705),(806,810,341,345,698),(806,810,346,350,690),(806,810,351,355,683),(806,810,356,360,675),(806,810,361,365,668),(806,810,366,370,660),(806,810,371,375,653),(806,810,376,380,645),(806,810,381,385,638),(806,810,386,390,630),(806,810,391,395,623),(806,810,396,400,615),(806,810,401,405,608),(806,810,406,410,600),(806,810,411,415,593),(806,810,416,420,585),(806,810,421,425,578),(806,810,426,430,570),(806,810,431,435,563),(806,810,436,440,555),(806,810,441,445,548),(806,810,446,450,540),(806,810,451,455,533),(806,810,456,460,525),(806,810,461,465,518),(806,810,466,470,510),(806,810,471,475,503),(806,810,476,480,495),(806,810,481,485,488),(806,810,486,490,480),(806,810,491,495,473),(806,810,496,500,465),(806,810,501,505,458),(806,810,506,510,450),(806,810,511,515,443),(806,810,516,520,435),(806,810,521,525,428),(806,810,526,530,420),(806,810,531,535,413),(806,810,536,540,405),(806,810,541,545,398),(806,810,546,550,390),(806,810,551,555,383),(806,810,556,560,375),(806,810,561,565,368),(806,810,566,570,360),(806,810,571,575,353),(806,810,576,580,345),(806,810,581,585,338),(806,810,586,590,330),(806,810,591,595,323),(806,810,596,600,315),(806,810,601,605,308),(806,810,606,610,300),(806,810,611,615,293),(806,810,616,620,285),(806,810,621,625,278),(806,810,626,630,270),(806,810,631,635,263),(806,810,636,640,255),(806,810,641,645,248),(806,810,646,650,240),(806,810,651,655,233),(806,810,656,660,225),(806,810,661,665,218),(806,810,666,670,210),(806,810,671,675,203),(806,810,676,680,195),(806,810,681,685,188),(806,810,686,690,180),(806,810,691,695,173),(806,810,696,700,165),(806,810,701,705,158),(806,810,706,710,150),(806,810,711,715,143),(806,810,716,720,135),(806,810,721,725,128),(806,810,726,730,120),(806,810,731,735,113),(806,810,736,740,105),(806,810,741,745,98),(806,810,746,750,90),(806,810,751,755,83),(806,810,756,760,75),(806,810,761,765,68),(806,810,766,770,60),(806,810,771,775,53),(806,810,776,780,45),(806,810,781,785,38),(806,810,786,790,30),(806,810,791,795,0),(806,810,796,800,0),(806,810,801,1000,0),(811,815,0,150,0),(811,815,151,155,800),(811,815,156,160,800),(811,815,161,165,800),(811,815,166,170,800),(811,815,171,175,800),(811,815,176,180,800),(811,815,181,185,800),(811,815,186,190,800),(811,815,191,195,800),(811,815,196,200,800),(811,815,201,205,800),(811,815,206,210,800),(811,815,211,215,800),(811,815,216,220,800),(811,815,221,225,800),(811,815,226,230,800),(811,815,231,235,800),(811,815,236,240,800),(811,815,241,245,800),(811,815,246,250,800),(811,815,251,255,800),(811,815,256,260,800),(811,815,261,265,800),(811,815,266,270,800),(811,815,271,275,800),(811,815,276,280,800),(811,815,281,285,795),(811,815,286,290,788),(811,815,291,295,780),(811,815,296,300,773),(811,815,301,305,765),(811,815,306,310,758),(811,815,311,315,750),(811,815,316,320,743),(811,815,321,325,735),(811,815,326,330,728),(811,815,331,335,720),(811,815,336,340,713),(811,815,341,345,705),(811,815,346,350,698),(811,815,351,355,690),(811,815,356,360,683),(811,815,361,365,675),(811,815,366,370,668),(811,815,371,375,660),(811,815,376,380,653),(811,815,381,385,645),(811,815,386,390,638),(811,815,391,395,630),(811,815,396,400,623),(811,815,401,405,615),(811,815,406,410,608),(811,815,411,415,600),(811,815,416,420,593),(811,815,421,425,585),(811,815,426,430,578),(811,815,431,435,570),(811,815,436,440,563),(811,815,441,445,555),(811,815,446,450,548),(811,815,451,455,540),(811,815,456,460,533),(811,815,461,465,525),(811,815,466,470,518),(811,815,471,475,510),(811,815,476,480,503),(811,815,481,485,495),(811,815,486,490,488),(811,815,491,495,480),(811,815,496,500,473),(811,815,501,505,465),(811,815,506,510,458),(811,815,511,515,450),(811,815,516,520,443),(811,815,521,525,435),(811,815,526,530,428),(811,815,531,535,420),(811,815,536,540,413),(811,815,541,545,405),(811,815,546,550,398),(811,815,551,555,390),(811,815,556,560,383),(811,815,561,565,375),(811,815,566,570,368),(811,815,571,575,360),(811,815,576,580,353),(811,815,581,585,345),(811,815,586,590,338),(811,815,591,595,330),(811,815,596,600,323),(811,815,601,605,315),(811,815,606,610,308),(811,815,611,615,300),(811,815,616,620,293),(811,815,621,625,285),(811,815,626,630,278),(811,815,631,635,270),(811,815,636,640,263),(811,815,641,645,255),(811,815,646,650,248),(811,815,651,655,240),(811,815,656,660,233),(811,815,661,665,225),(811,815,666,670,218),(811,815,671,675,210),(811,815,676,680,203),(811,815,681,685,195),(811,815,686,690,188),(811,815,691,695,180),(811,815,696,700,173),(811,815,701,705,165),(811,815,706,710,158),(811,815,711,715,150),(811,815,716,720,143),(811,815,721,725,135),(811,815,726,730,128),(811,815,731,735,120),(811,815,736,740,113),(811,815,741,745,105),(811,815,746,750,98),(811,815,751,755,90),(811,815,756,760,83),(811,815,761,765,75),(811,815,766,770,68),(811,815,771,775,60),(811,815,776,780,53),(811,815,781,785,45),(811,815,786,790,38),(811,815,791,795,30),(811,815,796,800,0),(811,815,801,805,0),(811,815,806,1000,0),(816,820,0,150,0),(816,820,151,155,800),(816,820,156,160,800),(816,820,161,165,800),(816,820,166,170,800),(816,820,171,175,800),(816,820,176,180,800),(816,820,181,185,800),(816,820,186,190,800),(816,820,191,195,800),(816,820,196,200,800),(816,820,201,205,800),(816,820,206,210,800),(816,820,211,215,800),(816,820,216,220,800),(816,820,221,225,800),(816,820,226,230,800),(816,820,231,235,800),(816,820,236,240,800),(816,820,241,245,800),(816,820,246,250,800),(816,820,251,255,800),(816,820,256,260,800),(816,820,261,265,800),(816,820,266,270,800),(816,820,271,275,800),(816,820,276,280,800),(816,820,281,285,800),(816,820,286,290,795),(816,820,291,295,788),(816,820,296,300,780),(816,820,301,305,773),(816,820,306,310,765),(816,820,311,315,758),(816,820,316,320,750),(816,820,321,325,743),(816,820,326,330,735),(816,820,331,335,728),(816,820,336,340,720),(816,820,341,345,713),(816,820,346,350,705),(816,820,351,355,698),(816,820,356,360,690),(816,820,361,365,683),(816,820,366,370,675),(816,820,371,375,668),(816,820,376,380,660),(816,820,381,385,653),(816,820,386,390,645),(816,820,391,395,638),(816,820,396,400,630),(816,820,401,405,623),(816,820,406,410,615),(816,820,411,415,608),(816,820,416,420,600),(816,820,421,425,593),(816,820,426,430,585),(816,820,431,435,578),(816,820,436,440,570),(816,820,441,445,563),(816,820,446,450,555),(816,820,451,455,548),(816,820,456,460,540),(816,820,461,465,533),(816,820,466,470,525),(816,820,471,475,518),(816,820,476,480,510),(816,820,481,485,503),(816,820,486,490,495),(816,820,491,495,488),(816,820,496,500,480),(816,820,501,505,473),(816,820,506,510,465),(816,820,511,515,458),(816,820,516,520,450),(816,820,521,525,443),(816,820,526,530,435),(816,820,531,535,428),(816,820,536,540,420),(816,820,541,545,413),(816,820,546,550,405),(816,820,551,555,398),(816,820,556,560,390),(816,820,561,565,383),(816,820,566,570,375),(816,820,571,575,368),(816,820,576,580,360),(816,820,581,585,353),(816,820,586,590,345),(816,820,591,595,338),(816,820,596,600,330),(816,820,601,605,323),(816,820,606,610,315),(816,820,611,615,308),(816,820,616,620,300),(816,820,621,625,293),(816,820,626,630,285),(816,820,631,635,278),(816,820,636,640,270),(816,820,641,645,263),(816,820,646,650,255),(816,820,651,655,248),(816,820,656,660,240),(816,820,661,665,233),(816,820,666,670,225),(816,820,671,675,218),(816,820,676,680,210),(816,820,681,685,203),(816,820,686,690,195),(816,820,691,695,188),(816,820,696,700,180),(816,820,701,705,173),(816,820,706,710,165),(816,820,711,715,158),(816,820,716,720,150),(816,820,721,725,143),(816,820,726,730,135),(816,820,731,735,128),(816,820,736,740,120),(816,820,741,745,113),(816,820,746,750,105),(816,820,751,755,98),(816,820,756,760,90),(816,820,761,765,83),(816,820,766,770,75),(816,820,771,775,68),(816,820,776,780,60),(816,820,781,785,53),(816,820,786,790,45),(816,820,791,795,38),(816,820,796,800,30),(816,820,801,805,0),(816,820,806,810,0),(816,820,811,1000,0),(821,825,0,150,0),(821,825,151,155,800),(821,825,156,160,800),(821,825,161,165,800),(821,825,166,170,800),(821,825,171,175,800),(821,825,176,180,800),(821,825,181,185,800),(821,825,186,190,800),(821,825,191,195,800),(821,825,196,200,800),(821,825,201,205,800),(821,825,206,210,800),(821,825,211,215,800),(821,825,216,220,800),(821,825,221,225,800),(821,825,226,230,800),(821,825,231,235,800),(821,825,236,240,800),(821,825,241,245,800),(821,825,246,250,800),(821,825,251,255,800),(821,825,256,260,800),(821,825,261,265,800),(821,825,266,270,800),(821,825,271,275,800),(821,825,276,280,800),(821,825,281,285,800),(821,825,286,290,800),(821,825,291,295,795),(821,825,296,300,788),(821,825,301,305,780),(821,825,306,310,773),(821,825,311,315,765),(821,825,316,320,758),(821,825,321,325,750),(821,825,326,330,743),(821,825,331,335,735),(821,825,336,340,728),(821,825,341,345,720),(821,825,346,350,713),(821,825,351,355,705),(821,825,356,360,698),(821,825,361,365,690),(821,825,366,370,683),(821,825,371,375,675),(821,825,376,380,668),(821,825,381,385,660),(821,825,386,390,653),(821,825,391,395,645),(821,825,396,400,638),(821,825,401,405,630),(821,825,406,410,623),(821,825,411,415,615),(821,825,416,420,608),(821,825,421,425,600),(821,825,426,430,593),(821,825,431,435,585),(821,825,436,440,578),(821,825,441,445,570),(821,825,446,450,563),(821,825,451,455,555),(821,825,456,460,548),(821,825,461,465,540),(821,825,466,470,533),(821,825,471,475,525),(821,825,476,480,518),(821,825,481,485,510),(821,825,486,490,503),(821,825,491,495,495),(821,825,496,500,488),(821,825,501,505,480),(821,825,506,510,473),(821,825,511,515,465),(821,825,516,520,458),(821,825,521,525,450),(821,825,526,530,443),(821,825,531,535,435),(821,825,536,540,428),(821,825,541,545,420),(821,825,546,550,413),(821,825,551,555,405),(821,825,556,560,398),(821,825,561,565,390),(821,825,566,570,383),(821,825,571,575,375),(821,825,576,580,368),(821,825,581,585,360),(821,825,586,590,353),(821,825,591,595,345),(821,825,596,600,338),(821,825,601,605,330),(821,825,606,610,323),(821,825,611,615,315),(821,825,616,620,308),(821,825,621,625,300),(821,825,626,630,293),(821,825,631,635,285),(821,825,636,640,278),(821,825,641,645,270),(821,825,646,650,263),(821,825,651,655,255),(821,825,656,660,248),(821,825,661,665,240),(821,825,666,670,233),(821,825,671,675,225),(821,825,676,680,218),(821,825,681,685,210),(821,825,686,690,203),(821,825,691,695,195),(821,825,696,700,188),(821,825,701,705,180),(821,825,706,710,173),(821,825,711,715,165),(821,825,716,720,158),(821,825,721,725,150),(821,825,726,730,143),(821,825,731,735,135),(821,825,736,740,128),(821,825,741,745,120),(821,825,746,750,113),(821,825,751,755,105),(821,825,756,760,98),(821,825,761,765,90),(821,825,766,770,83),(821,825,771,775,75),(821,825,776,780,68),(821,825,781,785,60),(821,825,786,790,53),(821,825,791,795,45),(821,825,796,800,38),(821,825,801,805,30),(821,825,806,810,0),(821,825,811,815,0),(821,825,816,1000,0),(826,830,0,150,0),(826,830,151,155,800),(826,830,156,160,800),(826,830,161,165,800),(826,830,166,170,800),(826,830,171,175,800),(826,830,176,180,800),(826,830,181,185,800),(826,830,186,190,800),(826,830,191,195,800),(826,830,196,200,800),(826,830,201,205,800),(826,830,206,210,800),(826,830,211,215,800),(826,830,216,220,800),(826,830,221,225,800),(826,830,226,230,800),(826,830,231,235,800),(826,830,236,240,800),(826,830,241,245,800),(826,830,246,250,800),(826,830,251,255,800),(826,830,256,260,800),(826,830,261,265,800),(826,830,266,270,800),(826,830,271,275,800),(826,830,276,280,800),(826,830,281,285,800),(826,830,286,290,800),(826,830,291,295,800),(826,830,296,300,795),(826,830,301,305,788),(826,830,306,310,780),(826,830,311,315,773),(826,830,316,320,765),(826,830,321,325,758),(826,830,326,330,750),(826,830,331,335,743),(826,830,336,340,735),(826,830,341,345,728),(826,830,346,350,720),(826,830,351,355,713),(826,830,356,360,705),(826,830,361,365,698),(826,830,366,370,690),(826,830,371,375,683),(826,830,376,380,675),(826,830,381,385,668),(826,830,386,390,660),(826,830,391,395,653),(826,830,396,400,645),(826,830,401,405,638),(826,830,406,410,630),(826,830,411,415,623),(826,830,416,420,615),(826,830,421,425,608),(826,830,426,430,600),(826,830,431,435,593),(826,830,436,440,585),(826,830,441,445,578),(826,830,446,450,570),(826,830,451,455,563),(826,830,456,460,555),(826,830,461,465,548),(826,830,466,470,540),(826,830,471,475,533),(826,830,476,480,525),(826,830,481,485,518),(826,830,486,490,510),(826,830,491,495,503),(826,830,496,500,495),(826,830,501,505,488),(826,830,506,510,480),(826,830,511,515,473),(826,830,516,520,465),(826,830,521,525,458),(826,830,526,530,450),(826,830,531,535,443),(826,830,536,540,435),(826,830,541,545,428),(826,830,546,550,420),(826,830,551,555,413),(826,830,556,560,405),(826,830,561,565,398),(826,830,566,570,390),(826,830,571,575,383),(826,830,576,580,375),(826,830,581,585,368),(826,830,586,590,360),(826,830,591,595,353),(826,830,596,600,345),(826,830,601,605,338),(826,830,606,610,330),(826,830,611,615,323),(826,830,616,620,315),(826,830,621,625,308),(826,830,626,630,300),(826,830,631,635,293),(826,830,636,640,285),(826,830,641,645,278),(826,830,646,650,270),(826,830,651,655,263),(826,830,656,660,255),(826,830,661,665,248),(826,830,666,670,240),(826,830,671,675,233),(826,830,676,680,225),(826,830,681,685,218),(826,830,686,690,210),(826,830,691,695,203),(826,830,696,700,195),(826,830,701,705,188),(826,830,706,710,180),(826,830,711,715,173),(826,830,716,720,165),(826,830,721,725,158),(826,830,726,730,150),(826,830,731,735,143),(826,830,736,740,135),(826,830,741,745,128),(826,830,746,750,120),(826,830,751,755,113),(826,830,756,760,105),(826,830,761,765,98),(826,830,766,770,90),(826,830,771,775,83),(826,830,776,780,75),(826,830,781,785,68),(826,830,786,790,60),(826,830,791,795,53),(826,830,796,800,45),(826,830,801,805,38),(826,830,806,810,30),(826,830,811,815,0),(826,830,816,820,0),(826,830,821,1000,0),(831,835,0,150,0),(831,835,151,155,800),(831,835,156,160,800),(831,835,161,165,800),(831,835,166,170,800),(831,835,171,175,800),(831,835,176,180,800),(831,835,181,185,800),(831,835,186,190,800),(831,835,191,195,800),(831,835,196,200,800),(831,835,201,205,800),(831,835,206,210,800),(831,835,211,215,800),(831,835,216,220,800),(831,835,221,225,800),(831,835,226,230,800),(831,835,231,235,800),(831,835,236,240,800),(831,835,241,245,800),(831,835,246,250,800),(831,835,251,255,800),(831,835,256,260,800),(831,835,261,265,800),(831,835,266,270,800),(831,835,271,275,800),(831,835,276,280,800),(831,835,281,285,800),(831,835,286,290,800),(831,835,291,295,800),(831,835,296,300,800),(831,835,301,305,795),(831,835,306,310,788),(831,835,311,315,780),(831,835,316,320,773),(831,835,321,325,765),(831,835,326,330,758),(831,835,331,335,750),(831,835,336,340,743),(831,835,341,345,735),(831,835,346,350,728),(831,835,351,355,720),(831,835,356,360,713),(831,835,361,365,705),(831,835,366,370,698),(831,835,371,375,690),(831,835,376,380,683),(831,835,381,385,675),(831,835,386,390,668),(831,835,391,395,660),(831,835,396,400,653),(831,835,401,405,645),(831,835,406,410,638),(831,835,411,415,630),(831,835,416,420,623),(831,835,421,425,615),(831,835,426,430,608),(831,835,431,435,600),(831,835,436,440,593),(831,835,441,445,585),(831,835,446,450,578),(831,835,451,455,570),(831,835,456,460,563),(831,835,461,465,555),(831,835,466,470,548),(831,835,471,475,540),(831,835,476,480,533),(831,835,481,485,525),(831,835,486,490,518),(831,835,491,495,510),(831,835,496,500,503),(831,835,501,505,495),(831,835,506,510,488),(831,835,511,515,480),(831,835,516,520,473),(831,835,521,525,465),(831,835,526,530,458),(831,835,531,535,450),(831,835,536,540,443),(831,835,541,545,435),(831,835,546,550,428),(831,835,551,555,420),(831,835,556,560,413),(831,835,561,565,405),(831,835,566,570,398),(831,835,571,575,390),(831,835,576,580,383),(831,835,581,585,375),(831,835,586,590,368),(831,835,591,595,360),(831,835,596,600,353),(831,835,601,605,345),(831,835,606,610,338),(831,835,611,615,330),(831,835,616,620,323),(831,835,621,625,315),(831,835,626,630,308),(831,835,631,635,300),(831,835,636,640,293),(831,835,641,645,285),(831,835,646,650,278),(831,835,651,655,270),(831,835,656,660,263),(831,835,661,665,255),(831,835,666,670,248),(831,835,671,675,240),(831,835,676,680,233),(831,835,681,685,225),(831,835,686,690,218),(831,835,691,695,210),(831,835,696,700,203),(831,835,701,705,195),(831,835,706,710,188),(831,835,711,715,180),(831,835,716,720,173),(831,835,721,725,165),(831,835,726,730,158),(831,835,731,735,150),(831,835,736,740,143),(831,835,741,745,135),(831,835,746,750,128),(831,835,751,755,120),(831,835,756,760,113),(831,835,761,765,105),(831,835,766,770,98),(831,835,771,775,90),(831,835,776,780,83),(831,835,781,785,75),(831,835,786,790,68),(831,835,791,795,60),(831,835,796,800,53),(831,835,801,805,45),(831,835,806,810,38),(831,835,811,815,30),(831,835,816,820,0),(831,835,821,825,0),(831,835,826,1000,0),(836,840,0,150,0),(836,840,151,155,800),(836,840,156,160,800),(836,840,161,165,800),(836,840,166,170,800),(836,840,171,175,800),(836,840,176,180,800),(836,840,181,185,800),(836,840,186,190,800),(836,840,191,195,800),(836,840,196,200,800),(836,840,201,205,800),(836,840,206,210,800),(836,840,211,215,800),(836,840,216,220,800),(836,840,221,225,800),(836,840,226,230,800),(836,840,231,235,800),(836,840,236,240,800),(836,840,241,245,800),(836,840,246,250,800),(836,840,251,255,800),(836,840,256,260,800),(836,840,261,265,800),(836,840,266,270,800),(836,840,271,275,800),(836,840,276,280,800),(836,840,281,285,800),(836,840,286,290,800),(836,840,291,295,800),(836,840,296,300,800),(836,840,301,305,800),(836,840,306,310,795),(836,840,311,315,788),(836,840,316,320,780),(836,840,321,325,773),(836,840,326,330,765),(836,840,331,335,758),(836,840,336,340,750),(836,840,341,345,743),(836,840,346,350,735),(836,840,351,355,728),(836,840,356,360,720),(836,840,361,365,713),(836,840,366,370,705),(836,840,371,375,698),(836,840,376,380,690),(836,840,381,385,683),(836,840,386,390,675),(836,840,391,395,668),(836,840,396,400,660),(836,840,401,405,653),(836,840,406,410,645),(836,840,411,415,638),(836,840,416,420,630),(836,840,421,425,623),(836,840,426,430,615),(836,840,431,435,608),(836,840,436,440,600),(836,840,441,445,593),(836,840,446,450,585),(836,840,451,455,578),(836,840,456,460,570),(836,840,461,465,563),(836,840,466,470,555),(836,840,471,475,548),(836,840,476,480,540),(836,840,481,485,533),(836,840,486,490,525),(836,840,491,495,518),(836,840,496,500,510),(836,840,501,505,503),(836,840,506,510,495),(836,840,511,515,488),(836,840,516,520,480),(836,840,521,525,473),(836,840,526,530,465),(836,840,531,535,458),(836,840,536,540,450),(836,840,541,545,443),(836,840,546,550,435),(836,840,551,555,428),(836,840,556,560,420),(836,840,561,565,413),(836,840,566,570,405),(836,840,571,575,398),(836,840,576,580,390),(836,840,581,585,383),(836,840,586,590,375),(836,840,591,595,368),(836,840,596,600,360),(836,840,601,605,353),(836,840,606,610,345),(836,840,611,615,338),(836,840,616,620,330),(836,840,621,625,323),(836,840,626,630,315),(836,840,631,635,308),(836,840,636,640,300),(836,840,641,645,293),(836,840,646,650,285),(836,840,651,655,278),(836,840,656,660,270),(836,840,661,665,263),(836,840,666,670,255),(836,840,671,675,248),(836,840,676,680,240),(836,840,681,685,233),(836,840,686,690,225),(836,840,691,695,218),(836,840,696,700,210),(836,840,701,705,203),(836,840,706,710,195),(836,840,711,715,188),(836,840,716,720,180),(836,840,721,725,173),(836,840,726,730,165),(836,840,731,735,158),(836,840,736,740,150),(836,840,741,745,143),(836,840,746,750,135),(836,840,751,755,128),(836,840,756,760,120),(836,840,761,765,113),(836,840,766,770,105),(836,840,771,775,98),(836,840,776,780,90),(836,840,781,785,83),(836,840,786,790,75),(836,840,791,795,68),(836,840,796,800,60),(836,840,801,805,53),(836,840,806,810,45),(836,840,811,815,38),(836,840,816,820,30),(836,840,821,825,0),(836,840,826,830,0),(836,840,831,1000,0),(841,845,0,150,0),(841,845,151,155,800),(841,845,156,160,800),(841,845,161,165,800),(841,845,166,170,800),(841,845,171,175,800),(841,845,176,180,800),(841,845,181,185,800),(841,845,186,190,800),(841,845,191,195,800),(841,845,196,200,800),(841,845,201,205,800),(841,845,206,210,800),(841,845,211,215,800),(841,845,216,220,800),(841,845,221,225,800),(841,845,226,230,800),(841,845,231,235,800),(841,845,236,240,800),(841,845,241,245,800),(841,845,246,250,800),(841,845,251,255,800),(841,845,256,260,800),(841,845,261,265,800),(841,845,266,270,800),(841,845,271,275,800),(841,845,276,280,800),(841,845,281,285,800),(841,845,286,290,800),(841,845,291,295,800),(841,845,296,300,800),(841,845,301,305,800),(841,845,306,310,800),(841,845,311,315,795),(841,845,316,320,788),(841,845,321,325,780),(841,845,326,330,773),(841,845,331,335,765),(841,845,336,340,758),(841,845,341,345,750),(841,845,346,350,743),(841,845,351,355,735),(841,845,356,360,728),(841,845,361,365,720),(841,845,366,370,713),(841,845,371,375,705),(841,845,376,380,698),(841,845,381,385,690),(841,845,386,390,683),(841,845,391,395,675),(841,845,396,400,668),(841,845,401,405,660),(841,845,406,410,653),(841,845,411,415,645),(841,845,416,420,638),(841,845,421,425,630),(841,845,426,430,623),(841,845,431,435,615),(841,845,436,440,608),(841,845,441,445,600),(841,845,446,450,593),(841,845,451,455,585),(841,845,456,460,578),(841,845,461,465,570),(841,845,466,470,563),(841,845,471,475,555),(841,845,476,480,548),(841,845,481,485,540),(841,845,486,490,533),(841,845,491,495,525),(841,845,496,500,518),(841,845,501,505,510),(841,845,506,510,503),(841,845,511,515,495),(841,845,516,520,488),(841,845,521,525,480),(841,845,526,530,473),(841,845,531,535,465),(841,845,536,540,458),(841,845,541,545,450),(841,845,546,550,443),(841,845,551,555,435),(841,845,556,560,428),(841,845,561,565,420),(841,845,566,570,413),(841,845,571,575,405),(841,845,576,580,398),(841,845,581,585,390),(841,845,586,590,383),(841,845,591,595,375),(841,845,596,600,368),(841,845,601,605,360),(841,845,606,610,353),(841,845,611,615,345),(841,845,616,620,338),(841,845,621,625,330),(841,845,626,630,323),(841,845,631,635,315),(841,845,636,640,308),(841,845,641,645,300),(841,845,646,650,293),(841,845,651,655,285),(841,845,656,660,278),(841,845,661,665,270),(841,845,666,670,263),(841,845,671,675,255),(841,845,676,680,248),(841,845,681,685,240),(841,845,686,690,233),(841,845,691,695,225),(841,845,696,700,218),(841,845,701,705,210),(841,845,706,710,203),(841,845,711,715,195),(841,845,716,720,188),(841,845,721,725,180),(841,845,726,730,173),(841,845,731,735,165),(841,845,736,740,158),(841,845,741,745,150),(841,845,746,750,143),(841,845,751,755,135),(841,845,756,760,128),(841,845,761,765,120),(841,845,766,770,113),(841,845,771,775,105),(841,845,776,780,98),(841,845,781,785,90),(841,845,786,790,83),(841,845,791,795,75),(841,845,796,800,68),(841,845,801,805,60),(841,845,806,810,53),(841,845,811,815,45),(841,845,816,820,38),(841,845,821,825,30),(841,845,826,830,0),(841,845,831,835,0),(841,845,836,1000,0),(846,850,0,150,0),(846,850,151,155,800),(846,850,156,160,800),(846,850,161,165,800),(846,850,166,170,800),(846,850,171,175,800),(846,850,176,180,800),(846,850,181,185,800),(846,850,186,190,800),(846,850,191,195,800),(846,850,196,200,800),(846,850,201,205,800),(846,850,206,210,800),(846,850,211,215,800),(846,850,216,220,800),(846,850,221,225,800),(846,850,226,230,800),(846,850,231,235,800),(846,850,236,240,800),(846,850,241,245,800),(846,850,246,250,800),(846,850,251,255,800),(846,850,256,260,800),(846,850,261,265,800),(846,850,266,270,800),(846,850,271,275,800),(846,850,276,280,800),(846,850,281,285,800),(846,850,286,290,800),(846,850,291,295,800),(846,850,296,300,800),(846,850,301,305,800),(846,850,306,310,800),(846,850,311,315,800),(846,850,316,320,795),(846,850,321,325,788),(846,850,326,330,780),(846,850,331,335,773),(846,850,336,340,765),(846,850,341,345,758),(846,850,346,350,750),(846,850,351,355,743),(846,850,356,360,735),(846,850,361,365,728),(846,850,366,370,720),(846,850,371,375,713),(846,850,376,380,705),(846,850,381,385,698),(846,850,386,390,690),(846,850,391,395,683),(846,850,396,400,675),(846,850,401,405,668),(846,850,406,410,660),(846,850,411,415,653),(846,850,416,420,645),(846,850,421,425,638),(846,850,426,430,630),(846,850,431,435,623),(846,850,436,440,615),(846,850,441,445,608),(846,850,446,450,600),(846,850,451,455,593),(846,850,456,460,585),(846,850,461,465,578),(846,850,466,470,570),(846,850,471,475,563),(846,850,476,480,555),(846,850,481,485,548),(846,850,486,490,540),(846,850,491,495,533),(846,850,496,500,525),(846,850,501,505,518),(846,850,506,510,510),(846,850,511,515,503),(846,850,516,520,495),(846,850,521,525,488),(846,850,526,530,480),(846,850,531,535,473),(846,850,536,540,465),(846,850,541,545,458),(846,850,546,550,450),(846,850,551,555,443),(846,850,556,560,435),(846,850,561,565,428),(846,850,566,570,420),(846,850,571,575,413),(846,850,576,580,405),(846,850,581,585,398),(846,850,586,590,390),(846,850,591,595,383),(846,850,596,600,375),(846,850,601,605,368),(846,850,606,610,360),(846,850,611,615,353),(846,850,616,620,345),(846,850,621,625,338),(846,850,626,630,330),(846,850,631,635,323),(846,850,636,640,315),(846,850,641,645,308),(846,850,646,650,300),(846,850,651,655,293),(846,850,656,660,285),(846,850,661,665,278),(846,850,666,670,270),(846,850,671,675,263),(846,850,676,680,255),(846,850,681,685,248),(846,850,686,690,240),(846,850,691,695,233),(846,850,696,700,225),(846,850,701,705,218),(846,850,706,710,210),(846,850,711,715,203),(846,850,716,720,195),(846,850,721,725,188),(846,850,726,730,180),(846,850,731,735,173),(846,850,736,740,165),(846,850,741,745,158),(846,850,746,750,150),(846,850,751,755,143),(846,850,756,760,135),(846,850,761,765,128),(846,850,766,770,120),(846,850,771,775,113),(846,850,776,780,105),(846,850,781,785,98),(846,850,786,790,90),(846,850,791,795,83),(846,850,796,800,75),(846,850,801,805,68),(846,850,806,810,60),(846,850,811,815,53),(846,850,816,820,45),(846,850,821,825,38),(846,850,826,830,30),(846,850,831,835,0),(846,850,836,840,0),(846,850,841,1000,0),(851,855,0,150,0),(851,855,151,155,800),(851,855,156,160,800),(851,855,161,165,800),(851,855,166,170,800),(851,855,171,175,800),(851,855,176,180,800),(851,855,181,185,800),(851,855,186,190,800),(851,855,191,195,800),(851,855,196,200,800),(851,855,201,205,800),(851,855,206,210,800),(851,855,211,215,800),(851,855,216,220,800),(851,855,221,225,800),(851,855,226,230,800),(851,855,231,235,800),(851,855,236,240,800),(851,855,241,245,800),(851,855,246,250,800),(851,855,251,255,800),(851,855,256,260,800),(851,855,261,265,800),(851,855,266,270,800),(851,855,271,275,800),(851,855,276,280,800),(851,855,281,285,800),(851,855,286,290,800),(851,855,291,295,800),(851,855,296,300,800),(851,855,301,305,800),(851,855,306,310,800),(851,855,311,315,800),(851,855,316,320,800),(851,855,321,325,795),(851,855,326,330,788),(851,855,331,335,780),(851,855,336,340,773),(851,855,341,345,765),(851,855,346,350,758),(851,855,351,355,750),(851,855,356,360,743),(851,855,361,365,735),(851,855,366,370,728),(851,855,371,375,720),(851,855,376,380,713),(851,855,381,385,705),(851,855,386,390,698),(851,855,391,395,690),(851,855,396,400,683),(851,855,401,405,675),(851,855,406,410,668),(851,855,411,415,660),(851,855,416,420,653),(851,855,421,425,645),(851,855,426,430,638),(851,855,431,435,630),(851,855,436,440,623),(851,855,441,445,615),(851,855,446,450,608),(851,855,451,455,600),(851,855,456,460,593),(851,855,461,465,585),(851,855,466,470,578),(851,855,471,475,570),(851,855,476,480,563),(851,855,481,485,555),(851,855,486,490,548),(851,855,491,495,540),(851,855,496,500,533),(851,855,501,505,525),(851,855,506,510,518),(851,855,511,515,510),(851,855,516,520,503),(851,855,521,525,495),(851,855,526,530,488),(851,855,531,535,480),(851,855,536,540,473),(851,855,541,545,465),(851,855,546,550,458),(851,855,551,555,450),(851,855,556,560,443),(851,855,561,565,435),(851,855,566,570,428),(851,855,571,575,420),(851,855,576,580,413),(851,855,581,585,405),(851,855,586,590,398),(851,855,591,595,390),(851,855,596,600,383),(851,855,601,605,375),(851,855,606,610,368),(851,855,611,615,360),(851,855,616,620,353),(851,855,621,625,345),(851,855,626,630,338),(851,855,631,635,330),(851,855,636,640,323),(851,855,641,645,315),(851,855,646,650,308),(851,855,651,655,300),(851,855,656,660,293),(851,855,661,665,285),(851,855,666,670,278),(851,855,671,675,270),(851,855,676,680,263),(851,855,681,685,255),(851,855,686,690,248),(851,855,691,695,240),(851,855,696,700,233),(851,855,701,705,225),(851,855,706,710,218),(851,855,711,715,210),(851,855,716,720,203),(851,855,721,725,195),(851,855,726,730,188),(851,855,731,735,180),(851,855,736,740,173),(851,855,741,745,165),(851,855,746,750,158),(851,855,751,755,150),(851,855,756,760,143),(851,855,761,765,135),(851,855,766,770,128),(851,855,771,775,120),(851,855,776,780,113),(851,855,781,785,105),(851,855,786,790,98),(851,855,791,795,90),(851,855,796,800,83),(851,855,801,805,75),(851,855,806,810,68),(851,855,811,815,60),(851,855,816,820,53),(851,855,821,825,45),(851,855,826,830,38),(851,855,831,835,30),(851,855,836,840,0),(851,855,841,845,0),(851,855,846,1000,0),(856,860,0,150,0),(856,860,151,155,800),(856,860,156,160,800),(856,860,161,165,800),(856,860,166,170,800),(856,860,171,175,800),(856,860,176,180,800),(856,860,181,185,800),(856,860,186,190,800),(856,860,191,195,800),(856,860,196,200,800),(856,860,201,205,800),(856,860,206,210,800),(856,860,211,215,800),(856,860,216,220,800),(856,860,221,225,800),(856,860,226,230,800),(856,860,231,235,800),(856,860,236,240,800),(856,860,241,245,800),(856,860,246,250,800),(856,860,251,255,800),(856,860,256,260,800),(856,860,261,265,800),(856,860,266,270,800),(856,860,271,275,800),(856,860,276,280,800),(856,860,281,285,800),(856,860,286,290,800),(856,860,291,295,800),(856,860,296,300,800),(856,860,301,305,800),(856,860,306,310,800),(856,860,311,315,800),(856,860,316,320,800),(856,860,321,325,800),(856,860,326,330,795),(856,860,331,335,788),(856,860,336,340,780),(856,860,341,345,773),(856,860,346,350,765),(856,860,351,355,758),(856,860,356,360,750),(856,860,361,365,743),(856,860,366,370,735),(856,860,371,375,728),(856,860,376,380,720),(856,860,381,385,713),(856,860,386,390,705),(856,860,391,395,698),(856,860,396,400,690),(856,860,401,405,683),(856,860,406,410,675),(856,860,411,415,668),(856,860,416,420,660),(856,860,421,425,653),(856,860,426,430,645),(856,860,431,435,638),(856,860,436,440,630),(856,860,441,445,623),(856,860,446,450,615),(856,860,451,455,608),(856,860,456,460,600),(856,860,461,465,593),(856,860,466,470,585),(856,860,471,475,578),(856,860,476,480,570),(856,860,481,485,563),(856,860,486,490,555),(856,860,491,495,548),(856,860,496,500,540),(856,860,501,505,533),(856,860,506,510,525),(856,860,511,515,518),(856,860,516,520,510),(856,860,521,525,503),(856,860,526,530,495),(856,860,531,535,488),(856,860,536,540,480),(856,860,541,545,473),(856,860,546,550,465),(856,860,551,555,458),(856,860,556,560,450),(856,860,561,565,443),(856,860,566,570,435),(856,860,571,575,428),(856,860,576,580,420),(856,860,581,585,413),(856,860,586,590,405),(856,860,591,595,398),(856,860,596,600,390),(856,860,601,605,383),(856,860,606,610,375),(856,860,611,615,368),(856,860,616,620,360),(856,860,621,625,353),(856,860,626,630,345),(856,860,631,635,338),(856,860,636,640,330),(856,860,641,645,323),(856,860,646,650,315),(856,860,651,655,308),(856,860,656,660,300),(856,860,661,665,293),(856,860,666,670,285),(856,860,671,675,278),(856,860,676,680,270),(856,860,681,685,263),(856,860,686,690,255),(856,860,691,695,248),(856,860,696,700,240),(856,860,701,705,233),(856,860,706,710,225),(856,860,711,715,218),(856,860,716,720,210),(856,860,721,725,203),(856,860,726,730,195),(856,860,731,735,188),(856,860,736,740,180),(856,860,741,745,173),(856,860,746,750,165),(856,860,751,755,158),(856,860,756,760,150),(856,860,761,765,143),(856,860,766,770,135),(856,860,771,775,128),(856,860,776,780,120),(856,860,781,785,113),(856,860,786,790,105),(856,860,791,795,98),(856,860,796,800,90),(856,860,801,805,83),(856,860,806,810,75),(856,860,811,815,68),(856,860,816,820,60),(856,860,821,825,53),(856,860,826,830,45),(856,860,831,835,38),(856,860,836,840,30),(856,860,841,845,0),(856,860,846,850,0),(856,860,851,1000,0),(861,865,0,150,0),(861,865,151,155,800),(861,865,156,160,800),(861,865,161,165,800),(861,865,166,170,800),(861,865,171,175,800),(861,865,176,180,800),(861,865,181,185,800),(861,865,186,190,800),(861,865,191,195,800),(861,865,196,200,800),(861,865,201,205,800),(861,865,206,210,800),(861,865,211,215,800),(861,865,216,220,800),(861,865,221,225,800),(861,865,226,230,800),(861,865,231,235,800),(861,865,236,240,800),(861,865,241,245,800),(861,865,246,250,800),(861,865,251,255,800),(861,865,256,260,800),(861,865,261,265,800),(861,865,266,270,800),(861,865,271,275,800),(861,865,276,280,800),(861,865,281,285,800),(861,865,286,290,800),(861,865,291,295,800),(861,865,296,300,800),(861,865,301,305,800),(861,865,306,310,800),(861,865,311,315,800),(861,865,316,320,800),(861,865,321,325,800),(861,865,326,330,800),(861,865,331,335,795),(861,865,336,340,788),(861,865,341,345,780),(861,865,346,350,773),(861,865,351,355,765),(861,865,356,360,758),(861,865,361,365,750),(861,865,366,370,743),(861,865,371,375,735),(861,865,376,380,728),(861,865,381,385,720),(861,865,386,390,713),(861,865,391,395,705),(861,865,396,400,698),(861,865,401,405,690),(861,865,406,410,683),(861,865,411,415,675),(861,865,416,420,668),(861,865,421,425,660),(861,865,426,430,653),(861,865,431,435,645),(861,865,436,440,638),(861,865,441,445,630),(861,865,446,450,623),(861,865,451,455,615),(861,865,456,460,608),(861,865,461,465,600),(861,865,466,470,593),(861,865,471,475,585),(861,865,476,480,578),(861,865,481,485,570),(861,865,486,490,563),(861,865,491,495,555),(861,865,496,500,548),(861,865,501,505,540),(861,865,506,510,533),(861,865,511,515,525),(861,865,516,520,518),(861,865,521,525,510),(861,865,526,530,503),(861,865,531,535,495),(861,865,536,540,488),(861,865,541,545,480),(861,865,546,550,473),(861,865,551,555,465),(861,865,556,560,458),(861,865,561,565,450),(861,865,566,570,443),(861,865,571,575,435),(861,865,576,580,428),(861,865,581,585,420),(861,865,586,590,413),(861,865,591,595,405),(861,865,596,600,398),(861,865,601,605,390),(861,865,606,610,383),(861,865,611,615,375),(861,865,616,620,368),(861,865,621,625,360),(861,865,626,630,353),(861,865,631,635,345),(861,865,636,640,338),(861,865,641,645,330),(861,865,646,650,323),(861,865,651,655,315),(861,865,656,660,308),(861,865,661,665,300),(861,865,666,670,293),(861,865,671,675,285),(861,865,676,680,278),(861,865,681,685,270),(861,865,686,690,263),(861,865,691,695,255),(861,865,696,700,248),(861,865,701,705,240),(861,865,706,710,233),(861,865,711,715,225),(861,865,716,720,218),(861,865,721,725,210),(861,865,726,730,203),(861,865,731,735,195),(861,865,736,740,188),(861,865,741,745,180),(861,865,746,750,173),(861,865,751,755,165),(861,865,756,760,158),(861,865,761,765,150),(861,865,766,770,143),(861,865,771,775,135),(861,865,776,780,128),(861,865,781,785,120),(861,865,786,790,113),(861,865,791,795,105),(861,865,796,800,98),(861,865,801,805,90),(861,865,806,810,83),(861,865,811,815,75),(861,865,816,820,68),(861,865,821,825,60),(861,865,826,830,53),(861,865,831,835,45),(861,865,836,840,38),(861,865,841,845,30),(861,865,846,850,0),(861,865,851,855,0),(861,865,856,1000,0),(866,870,0,150,0),(866,870,151,155,800),(866,870,156,160,800),(866,870,161,165,800),(866,870,166,170,800),(866,870,171,175,800),(866,870,176,180,800),(866,870,181,185,800),(866,870,186,190,800),(866,870,191,195,800),(866,870,196,200,800),(866,870,201,205,800),(866,870,206,210,800),(866,870,211,215,800),(866,870,216,220,800),(866,870,221,225,800),(866,870,226,230,800),(866,870,231,235,800),(866,870,236,240,800),(866,870,241,245,800),(866,870,246,250,800),(866,870,251,255,800),(866,870,256,260,800),(866,870,261,265,800),(866,870,266,270,800),(866,870,271,275,800),(866,870,276,280,800),(866,870,281,285,800),(866,870,286,290,800),(866,870,291,295,800),(866,870,296,300,800),(866,870,301,305,800),(866,870,306,310,800),(866,870,311,315,800),(866,870,316,320,800),(866,870,321,325,800),(866,870,326,330,800),(866,870,331,335,800),(866,870,336,340,795),(866,870,341,345,788),(866,870,346,350,780),(866,870,351,355,773),(866,870,356,360,765),(866,870,361,365,758),(866,870,366,370,750),(866,870,371,375,743),(866,870,376,380,735),(866,870,381,385,728),(866,870,386,390,720),(866,870,391,395,713),(866,870,396,400,705),(866,870,401,405,698),(866,870,406,410,690),(866,870,411,415,683),(866,870,416,420,675),(866,870,421,425,668),(866,870,426,430,660),(866,870,431,435,653),(866,870,436,440,645),(866,870,441,445,638),(866,870,446,450,630),(866,870,451,455,623),(866,870,456,460,615),(866,870,461,465,608),(866,870,466,470,600),(866,870,471,475,593),(866,870,476,480,585),(866,870,481,485,578),(866,870,486,490,570),(866,870,491,495,563),(866,870,496,500,555),(866,870,501,505,548),(866,870,506,510,540),(866,870,511,515,533),(866,870,516,520,525),(866,870,521,525,518),(866,870,526,530,510),(866,870,531,535,503),(866,870,536,540,495),(866,870,541,545,488),(866,870,546,550,480),(866,870,551,555,473),(866,870,556,560,465),(866,870,561,565,458),(866,870,566,570,450),(866,870,571,575,443),(866,870,576,580,435),(866,870,581,585,428),(866,870,586,590,420),(866,870,591,595,413),(866,870,596,600,405),(866,870,601,605,398),(866,870,606,610,390),(866,870,611,615,383),(866,870,616,620,375),(866,870,621,625,368),(866,870,626,630,360),(866,870,631,635,353),(866,870,636,640,345),(866,870,641,645,338),(866,870,646,650,330),(866,870,651,655,323),(866,870,656,660,315),(866,870,661,665,308),(866,870,666,670,300),(866,870,671,675,293),(866,870,676,680,285),(866,870,681,685,278),(866,870,686,690,270),(866,870,691,695,263),(866,870,696,700,255),(866,870,701,705,248),(866,870,706,710,240),(866,870,711,715,233),(866,870,716,720,225),(866,870,721,725,218),(866,870,726,730,210),(866,870,731,735,203),(866,870,736,740,195),(866,870,741,745,188),(866,870,746,750,180),(866,870,751,755,173),(866,870,756,760,165),(866,870,761,765,158),(866,870,766,770,150),(866,870,771,775,143),(866,870,776,780,135),(866,870,781,785,128),(866,870,786,790,120),(866,870,791,795,113),(866,870,796,800,105),(866,870,801,805,98),(866,870,806,810,90),(866,870,811,815,83),(866,870,816,820,75),(866,870,821,825,68),(866,870,826,830,60),(866,870,831,835,53),(866,870,836,840,45),(866,870,841,845,38),(866,870,846,850,30),(866,870,851,855,0),(866,870,856,860,0),(866,870,861,1000,0),(871,875,0,150,0),(871,875,151,155,800),(871,875,156,160,800),(871,875,161,165,800),(871,875,166,170,800),(871,875,171,175,800),(871,875,176,180,800),(871,875,181,185,800),(871,875,186,190,800),(871,875,191,195,800),(871,875,196,200,800),(871,875,201,205,800),(871,875,206,210,800),(871,875,211,215,800),(871,875,216,220,800),(871,875,221,225,800),(871,875,226,230,800),(871,875,231,235,800),(871,875,236,240,800),(871,875,241,245,800),(871,875,246,250,800),(871,875,251,255,800),(871,875,256,260,800),(871,875,261,265,800),(871,875,266,270,800),(871,875,271,275,800),(871,875,276,280,800),(871,875,281,285,800),(871,875,286,290,800),(871,875,291,295,800),(871,875,296,300,800),(871,875,301,305,800),(871,875,306,310,800),(871,875,311,315,800),(871,875,316,320,800),(871,875,321,325,800),(871,875,326,330,800),(871,875,331,335,800),(871,875,336,340,800),(871,875,341,345,795),(871,875,346,350,788),(871,875,351,355,780),(871,875,356,360,773),(871,875,361,365,765),(871,875,366,370,758),(871,875,371,375,750),(871,875,376,380,743),(871,875,381,385,735),(871,875,386,390,728),(871,875,391,395,720),(871,875,396,400,713),(871,875,401,405,705),(871,875,406,410,698),(871,875,411,415,690),(871,875,416,420,683),(871,875,421,425,675),(871,875,426,430,668),(871,875,431,435,660),(871,875,436,440,653),(871,875,441,445,645),(871,875,446,450,638),(871,875,451,455,630),(871,875,456,460,623),(871,875,461,465,615),(871,875,466,470,608),(871,875,471,475,600),(871,875,476,480,593),(871,875,481,485,585),(871,875,486,490,578),(871,875,491,495,570),(871,875,496,500,563),(871,875,501,505,555),(871,875,506,510,548),(871,875,511,515,540),(871,875,516,520,533),(871,875,521,525,525),(871,875,526,530,518),(871,875,531,535,510),(871,875,536,540,503),(871,875,541,545,495),(871,875,546,550,488),(871,875,551,555,480),(871,875,556,560,473),(871,875,561,565,465),(871,875,566,570,458),(871,875,571,575,450),(871,875,576,580,443),(871,875,581,585,435),(871,875,586,590,428),(871,875,591,595,420),(871,875,596,600,413),(871,875,601,605,405),(871,875,606,610,398),(871,875,611,615,390),(871,875,616,620,383),(871,875,621,625,375),(871,875,626,630,368),(871,875,631,635,360),(871,875,636,640,353),(871,875,641,645,345),(871,875,646,650,338),(871,875,651,655,330),(871,875,656,660,323),(871,875,661,665,315),(871,875,666,670,308),(871,875,671,675,300),(871,875,676,680,293),(871,875,681,685,285),(871,875,686,690,278),(871,875,691,695,270),(871,875,696,700,263),(871,875,701,705,255),(871,875,706,710,248),(871,875,711,715,240),(871,875,716,720,233),(871,875,721,725,225),(871,875,726,730,218),(871,875,731,735,210),(871,875,736,740,203),(871,875,741,745,195),(871,875,746,750,188),(871,875,751,755,180),(871,875,756,760,173),(871,875,761,765,165),(871,875,766,770,158),(871,875,771,775,150),(871,875,776,780,143),(871,875,781,785,135),(871,875,786,790,128),(871,875,791,795,120),(871,875,796,800,113),(871,875,801,805,105),(871,875,806,810,98),(871,875,811,815,90),(871,875,816,820,83),(871,875,821,825,75),(871,875,826,830,68),(871,875,831,835,60),(871,875,836,840,53),(871,875,841,845,45),(871,875,846,850,38),(871,875,851,855,30),(871,875,856,860,0),(871,875,861,865,0),(871,875,866,1000,0),(876,880,0,150,0),(876,880,151,155,800),(876,880,156,160,800),(876,880,161,165,800),(876,880,166,170,800),(876,880,171,175,800),(876,880,176,180,800),(876,880,181,185,800),(876,880,186,190,800),(876,880,191,195,800),(876,880,196,200,800),(876,880,201,205,800),(876,880,206,210,800),(876,880,211,215,800),(876,880,216,220,800),(876,880,221,225,800),(876,880,226,230,800),(876,880,231,235,800),(876,880,236,240,800),(876,880,241,245,800),(876,880,246,250,800),(876,880,251,255,800),(876,880,256,260,800),(876,880,261,265,800),(876,880,266,270,800),(876,880,271,275,800),(876,880,276,280,800),(876,880,281,285,800),(876,880,286,290,800),(876,880,291,295,800),(876,880,296,300,800),(876,880,301,305,800),(876,880,306,310,800),(876,880,311,315,800),(876,880,316,320,800),(876,880,321,325,800),(876,880,326,330,800),(876,880,331,335,800),(876,880,336,340,800),(876,880,341,345,800),(876,880,346,350,795),(876,880,351,355,788),(876,880,356,360,780),(876,880,361,365,773),(876,880,366,370,765),(876,880,371,375,758),(876,880,376,380,750),(876,880,381,385,743),(876,880,386,390,735),(876,880,391,395,728),(876,880,396,400,720),(876,880,401,405,713),(876,880,406,410,705),(876,880,411,415,698),(876,880,416,420,690),(876,880,421,425,683),(876,880,426,430,675),(876,880,431,435,668),(876,880,436,440,660),(876,880,441,445,653),(876,880,446,450,645),(876,880,451,455,638),(876,880,456,460,630),(876,880,461,465,623),(876,880,466,470,615),(876,880,471,475,608),(876,880,476,480,600),(876,880,481,485,593),(876,880,486,490,585),(876,880,491,495,578),(876,880,496,500,570),(876,880,501,505,563),(876,880,506,510,555),(876,880,511,515,548),(876,880,516,520,540),(876,880,521,525,533),(876,880,526,530,525),(876,880,531,535,518),(876,880,536,540,510),(876,880,541,545,503),(876,880,546,550,495),(876,880,551,555,488),(876,880,556,560,480),(876,880,561,565,473),(876,880,566,570,465),(876,880,571,575,458),(876,880,576,580,450),(876,880,581,585,443),(876,880,586,590,435),(876,880,591,595,428),(876,880,596,600,420),(876,880,601,605,413),(876,880,606,610,405),(876,880,611,615,398),(876,880,616,620,390),(876,880,621,625,383),(876,880,626,630,375),(876,880,631,635,368),(876,880,636,640,360),(876,880,641,645,353),(876,880,646,650,345),(876,880,651,655,338),(876,880,656,660,330),(876,880,661,665,323),(876,880,666,670,315),(876,880,671,675,308),(876,880,676,680,300),(876,880,681,685,293),(876,880,686,690,285),(876,880,691,695,278),(876,880,696,700,270),(876,880,701,705,263),(876,880,706,710,255),(876,880,711,715,248),(876,880,716,720,240),(876,880,721,725,233),(876,880,726,730,225),(876,880,731,735,218),(876,880,736,740,210),(876,880,741,745,203),(876,880,746,750,195),(876,880,751,755,188),(876,880,756,760,180),(876,880,761,765,173),(876,880,766,770,165),(876,880,771,775,158),(876,880,776,780,150),(876,880,781,785,143),(876,880,786,790,135),(876,880,791,795,128),(876,880,796,800,120),(876,880,801,805,113),(876,880,806,810,105),(876,880,811,815,98),(876,880,816,820,90),(876,880,821,825,83),(876,880,826,830,75),(876,880,831,835,68),(876,880,836,840,60),(876,880,841,845,53),(876,880,846,850,45),(876,880,851,855,38),(876,880,856,860,30),(876,880,861,865,0),(876,880,866,870,0),(876,880,871,1000,0),(881,885,0,150,0),(881,885,151,155,800),(881,885,156,160,800),(881,885,161,165,800),(881,885,166,170,800),(881,885,171,175,800),(881,885,176,180,800),(881,885,181,185,800),(881,885,186,190,800),(881,885,191,195,800),(881,885,196,200,800),(881,885,201,205,800),(881,885,206,210,800),(881,885,211,215,800),(881,885,216,220,800),(881,885,221,225,800),(881,885,226,230,800),(881,885,231,235,800),(881,885,236,240,800),(881,885,241,245,800),(881,885,246,250,800),(881,885,251,255,800),(881,885,256,260,800),(881,885,261,265,800),(881,885,266,270,800),(881,885,271,275,800),(881,885,276,280,800),(881,885,281,285,800),(881,885,286,290,800),(881,885,291,295,800),(881,885,296,300,800),(881,885,301,305,800),(881,885,306,310,800),(881,885,311,315,800),(881,885,316,320,800),(881,885,321,325,800),(881,885,326,330,800),(881,885,331,335,800),(881,885,336,340,800),(881,885,341,345,800),(881,885,346,350,800),(881,885,351,355,795),(881,885,356,360,788),(881,885,361,365,780),(881,885,366,370,773),(881,885,371,375,765),(881,885,376,380,758),(881,885,381,385,750),(881,885,386,390,743),(881,885,391,395,735),(881,885,396,400,728),(881,885,401,405,720),(881,885,406,410,713),(881,885,411,415,705),(881,885,416,420,698),(881,885,421,425,690),(881,885,426,430,683),(881,885,431,435,675),(881,885,436,440,668),(881,885,441,445,660),(881,885,446,450,653),(881,885,451,455,645),(881,885,456,460,638),(881,885,461,465,630),(881,885,466,470,623),(881,885,471,475,615),(881,885,476,480,608),(881,885,481,485,600),(881,885,486,490,593),(881,885,491,495,585),(881,885,496,500,578),(881,885,501,505,570),(881,885,506,510,563),(881,885,511,515,555),(881,885,516,520,548),(881,885,521,525,540),(881,885,526,530,533),(881,885,531,535,525),(881,885,536,540,518),(881,885,541,545,510),(881,885,546,550,503),(881,885,551,555,495),(881,885,556,560,488),(881,885,561,565,480),(881,885,566,570,473),(881,885,571,575,465),(881,885,576,580,458),(881,885,581,585,450),(881,885,586,590,443),(881,885,591,595,435),(881,885,596,600,428),(881,885,601,605,420),(881,885,606,610,413),(881,885,611,615,405),(881,885,616,620,398),(881,885,621,625,390),(881,885,626,630,383),(881,885,631,635,375),(881,885,636,640,368),(881,885,641,645,360),(881,885,646,650,353),(881,885,651,655,345),(881,885,656,660,338),(881,885,661,665,330),(881,885,666,670,323),(881,885,671,675,315),(881,885,676,680,308),(881,885,681,685,300),(881,885,686,690,293),(881,885,691,695,285),(881,885,696,700,278),(881,885,701,705,270),(881,885,706,710,263),(881,885,711,715,255),(881,885,716,720,248),(881,885,721,725,240),(881,885,726,730,233),(881,885,731,735,225),(881,885,736,740,218),(881,885,741,745,210),(881,885,746,750,203),(881,885,751,755,195),(881,885,756,760,188),(881,885,761,765,180),(881,885,766,770,173),(881,885,771,775,165),(881,885,776,780,158),(881,885,781,785,150),(881,885,786,790,143),(881,885,791,795,135),(881,885,796,800,128),(881,885,801,805,120),(881,885,806,810,113),(881,885,811,815,105),(881,885,816,820,98),(881,885,821,825,90),(881,885,826,830,83),(881,885,831,835,75),(881,885,836,840,68),(881,885,841,845,60),(881,885,846,850,53),(881,885,851,855,45),(881,885,856,860,38),(881,885,861,865,30),(881,885,866,870,0),(881,885,871,875,0),(881,885,876,1000,0),(886,890,0,150,0),(886,890,151,155,800),(886,890,156,160,800),(886,890,161,165,800),(886,890,166,170,800),(886,890,171,175,800),(886,890,176,180,800),(886,890,181,185,800),(886,890,186,190,800),(886,890,191,195,800),(886,890,196,200,800),(886,890,201,205,800),(886,890,206,210,800),(886,890,211,215,800),(886,890,216,220,800),(886,890,221,225,800),(886,890,226,230,800),(886,890,231,235,800),(886,890,236,240,800),(886,890,241,245,800),(886,890,246,250,800),(886,890,251,255,800),(886,890,256,260,800),(886,890,261,265,800),(886,890,266,270,800),(886,890,271,275,800),(886,890,276,280,800),(886,890,281,285,800),(886,890,286,290,800),(886,890,291,295,800),(886,890,296,300,800),(886,890,301,305,800),(886,890,306,310,800),(886,890,311,315,800),(886,890,316,320,800),(886,890,321,325,800),(886,890,326,330,800),(886,890,331,335,800),(886,890,336,340,800),(886,890,341,345,800),(886,890,346,350,800),(886,890,351,355,800),(886,890,356,360,795),(886,890,361,365,788),(886,890,366,370,780),(886,890,371,375,773),(886,890,376,380,765),(886,890,381,385,758),(886,890,386,390,750),(886,890,391,395,743),(886,890,396,400,735),(886,890,401,405,728),(886,890,406,410,720),(886,890,411,415,713),(886,890,416,420,705),(886,890,421,425,698),(886,890,426,430,690),(886,890,431,435,683),(886,890,436,440,675),(886,890,441,445,668),(886,890,446,450,660),(886,890,451,455,653),(886,890,456,460,645),(886,890,461,465,638),(886,890,466,470,630),(886,890,471,475,623),(886,890,476,480,615),(886,890,481,485,608),(886,890,486,490,600),(886,890,491,495,593),(886,890,496,500,585),(886,890,501,505,578),(886,890,506,510,570),(886,890,511,515,563),(886,890,516,520,555),(886,890,521,525,548),(886,890,526,530,540),(886,890,531,535,533),(886,890,536,540,525),(886,890,541,545,518),(886,890,546,550,510),(886,890,551,555,503),(886,890,556,560,495),(886,890,561,565,488),(886,890,566,570,480),(886,890,571,575,473),(886,890,576,580,465),(886,890,581,585,458),(886,890,586,590,450),(886,890,591,595,443),(886,890,596,600,435),(886,890,601,605,428),(886,890,606,610,420),(886,890,611,615,413),(886,890,616,620,405),(886,890,621,625,398),(886,890,626,630,390),(886,890,631,635,383),(886,890,636,640,375),(886,890,641,645,368),(886,890,646,650,360),(886,890,651,655,353),(886,890,656,660,345),(886,890,661,665,338),(886,890,666,670,330),(886,890,671,675,323),(886,890,676,680,315),(886,890,681,685,308),(886,890,686,690,300),(886,890,691,695,293),(886,890,696,700,285),(886,890,701,705,278),(886,890,706,710,270),(886,890,711,715,263),(886,890,716,720,255),(886,890,721,725,248),(886,890,726,730,240),(886,890,731,735,233),(886,890,736,740,225),(886,890,741,745,218),(886,890,746,750,210),(886,890,751,755,203),(886,890,756,760,195),(886,890,761,765,188),(886,890,766,770,180),(886,890,771,775,173),(886,890,776,780,165),(886,890,781,785,158),(886,890,786,790,150),(886,890,791,795,143),(886,890,796,800,135),(886,890,801,805,128),(886,890,806,810,120),(886,890,811,815,113),(886,890,816,820,105),(886,890,821,825,98),(886,890,826,830,90),(886,890,831,835,83),(886,890,836,840,75),(886,890,841,845,68),(886,890,846,850,60),(886,890,851,855,53),(886,890,856,860,45),(886,890,861,865,38),(886,890,866,870,30),(886,890,871,875,0),(886,890,876,880,0),(886,890,881,1000,0),(891,895,0,150,0),(891,895,151,155,800),(891,895,156,160,800),(891,895,161,165,800),(891,895,166,170,800),(891,895,171,175,800),(891,895,176,180,800),(891,895,181,185,800),(891,895,186,190,800),(891,895,191,195,800),(891,895,196,200,800),(891,895,201,205,800),(891,895,206,210,800),(891,895,211,215,800),(891,895,216,220,800),(891,895,221,225,800),(891,895,226,230,800),(891,895,231,235,800),(891,895,236,240,800),(891,895,241,245,800),(891,895,246,250,800),(891,895,251,255,800),(891,895,256,260,800),(891,895,261,265,800),(891,895,266,270,800),(891,895,271,275,800),(891,895,276,280,800),(891,895,281,285,800),(891,895,286,290,800),(891,895,291,295,800),(891,895,296,300,800),(891,895,301,305,800),(891,895,306,310,800),(891,895,311,315,800),(891,895,316,320,800),(891,895,321,325,800),(891,895,326,330,800),(891,895,331,335,800),(891,895,336,340,800),(891,895,341,345,800),(891,895,346,350,800),(891,895,351,355,800),(891,895,356,360,800),(891,895,361,365,795),(891,895,366,370,788),(891,895,371,375,780),(891,895,376,380,773),(891,895,381,385,765),(891,895,386,390,758),(891,895,391,395,750),(891,895,396,400,743),(891,895,401,405,735),(891,895,406,410,728),(891,895,411,415,720),(891,895,416,420,713),(891,895,421,425,705),(891,895,426,430,698),(891,895,431,435,690),(891,895,436,440,683),(891,895,441,445,675),(891,895,446,450,668),(891,895,451,455,660),(891,895,456,460,653),(891,895,461,465,645),(891,895,466,470,638),(891,895,471,475,630),(891,895,476,480,623),(891,895,481,485,615),(891,895,486,490,608),(891,895,491,495,600),(891,895,496,500,593),(891,895,501,505,585),(891,895,506,510,578),(891,895,511,515,570),(891,895,516,520,563),(891,895,521,525,555),(891,895,526,530,548),(891,895,531,535,540),(891,895,536,540,533),(891,895,541,545,525),(891,895,546,550,518),(891,895,551,555,510),(891,895,556,560,503),(891,895,561,565,495),(891,895,566,570,488),(891,895,571,575,480),(891,895,576,580,473),(891,895,581,585,465),(891,895,586,590,458),(891,895,591,595,450),(891,895,596,600,443),(891,895,601,605,435),(891,895,606,610,428),(891,895,611,615,420),(891,895,616,620,413),(891,895,621,625,405),(891,895,626,630,398),(891,895,631,635,390),(891,895,636,640,383),(891,895,641,645,375),(891,895,646,650,368),(891,895,651,655,360),(891,895,656,660,353),(891,895,661,665,345),(891,895,666,670,338),(891,895,671,675,330),(891,895,676,680,323),(891,895,681,685,315),(891,895,686,690,308),(891,895,691,695,300),(891,895,696,700,293),(891,895,701,705,285),(891,895,706,710,278),(891,895,711,715,270),(891,895,716,720,263),(891,895,721,725,255),(891,895,726,730,248),(891,895,731,735,240),(891,895,736,740,233),(891,895,741,745,225),(891,895,746,750,218),(891,895,751,755,210),(891,895,756,760,203),(891,895,761,765,195),(891,895,766,770,188),(891,895,771,775,180),(891,895,776,780,173),(891,895,781,785,165),(891,895,786,790,158),(891,895,791,795,150),(891,895,796,800,143),(891,895,801,805,135),(891,895,806,810,128),(891,895,811,815,120),(891,895,816,820,113),(891,895,821,825,105),(891,895,826,830,98),(891,895,831,835,90),(891,895,836,840,83),(891,895,841,845,75),(891,895,846,850,68),(891,895,851,855,60),(891,895,856,860,53),(891,895,861,865,45),(891,895,866,870,38),(891,895,871,875,30),(891,895,876,880,0),(891,895,881,885,0),(891,895,886,1000,0),(896,900,0,150,0),(896,900,151,155,800),(896,900,156,160,800),(896,900,161,165,800),(896,900,166,170,800),(896,900,171,175,800),(896,900,176,180,800),(896,900,181,185,800),(896,900,186,190,800),(896,900,191,195,800),(896,900,196,200,800),(896,900,201,205,800),(896,900,206,210,800),(896,900,211,215,800),(896,900,216,220,800),(896,900,221,225,800),(896,900,226,230,800),(896,900,231,235,800),(896,900,236,240,800),(896,900,241,245,800),(896,900,246,250,800),(896,900,251,255,800),(896,900,256,260,800),(896,900,261,265,800),(896,900,266,270,800),(896,900,271,275,800),(896,900,276,280,800),(896,900,281,285,800),(896,900,286,290,800),(896,900,291,295,800),(896,900,296,300,800),(896,900,301,305,800),(896,900,306,310,800),(896,900,311,315,800),(896,900,316,320,800),(896,900,321,325,800),(896,900,326,330,800),(896,900,331,335,800),(896,900,336,340,800),(896,900,341,345,800),(896,900,346,350,800),(896,900,351,355,800),(896,900,356,360,800),(896,900,361,365,800),(896,900,366,370,795),(896,900,371,375,788),(896,900,376,380,780),(896,900,381,385,773),(896,900,386,390,765),(896,900,391,395,758),(896,900,396,400,750),(896,900,401,405,743),(896,900,406,410,735),(896,900,411,415,728),(896,900,416,420,720),(896,900,421,425,713),(896,900,426,430,705),(896,900,431,435,698),(896,900,436,440,690),(896,900,441,445,683),(896,900,446,450,675),(896,900,451,455,668),(896,900,456,460,660),(896,900,461,465,653),(896,900,466,470,645),(896,900,471,475,638),(896,900,476,480,630),(896,900,481,485,623),(896,900,486,490,615),(896,900,491,495,608),(896,900,496,500,600),(896,900,501,505,593),(896,900,506,510,585),(896,900,511,515,578),(896,900,516,520,570),(896,900,521,525,563),(896,900,526,530,555),(896,900,531,535,548),(896,900,536,540,540),(896,900,541,545,533),(896,900,546,550,525),(896,900,551,555,518),(896,900,556,560,510),(896,900,561,565,503),(896,900,566,570,495),(896,900,571,575,488),(896,900,576,580,480),(896,900,581,585,473),(896,900,586,590,465),(896,900,591,595,458),(896,900,596,600,450),(896,900,601,605,443),(896,900,606,610,435),(896,900,611,615,428),(896,900,616,620,420),(896,900,621,625,413),(896,900,626,630,405),(896,900,631,635,398),(896,900,636,640,390),(896,900,641,645,383),(896,900,646,650,375),(896,900,651,655,368),(896,900,656,660,360),(896,900,661,665,353),(896,900,666,670,345),(896,900,671,675,338),(896,900,676,680,330),(896,900,681,685,323),(896,900,686,690,315),(896,900,691,695,308),(896,900,696,700,300),(896,900,701,705,293),(896,900,706,710,285),(896,900,711,715,278),(896,900,716,720,270),(896,900,721,725,263),(896,900,726,730,255),(896,900,731,735,248),(896,900,736,740,240),(896,900,741,745,233),(896,900,746,750,225),(896,900,751,755,218),(896,900,756,760,210),(896,900,761,765,203),(896,900,766,770,195),(896,900,771,775,188),(896,900,776,780,180),(896,900,781,785,173),(896,900,786,790,165),(896,900,791,795,158),(896,900,796,800,150),(896,900,801,805,143),(896,900,806,810,135),(896,900,811,815,128),(896,900,816,820,120),(896,900,821,825,113),(896,900,826,830,105),(896,900,831,835,98),(896,900,836,840,90),(896,900,841,845,83),(896,900,846,850,75),(896,900,851,855,68),(896,900,856,860,60),(896,900,861,865,53),(896,900,866,870,45),(896,900,871,875,38),(896,900,876,880,30),(896,900,881,885,0),(896,900,886,890,0),(896,900,891,1000,0),(901,905,0,150,0),(901,905,151,155,800),(901,905,156,160,800),(901,905,161,165,800),(901,905,166,170,800),(901,905,171,175,800),(901,905,176,180,800),(901,905,181,185,800),(901,905,186,190,800),(901,905,191,195,800),(901,905,196,200,800),(901,905,201,205,800),(901,905,206,210,800),(901,905,211,215,800),(901,905,216,220,800),(901,905,221,225,800),(901,905,226,230,800),(901,905,231,235,800),(901,905,236,240,800),(901,905,241,245,800),(901,905,246,250,800),(901,905,251,255,800),(901,905,256,260,800),(901,905,261,265,800),(901,905,266,270,800),(901,905,271,275,800),(901,905,276,280,800),(901,905,281,285,800),(901,905,286,290,800),(901,905,291,295,800),(901,905,296,300,800),(901,905,301,305,800),(901,905,306,310,800),(901,905,311,315,800),(901,905,316,320,800),(901,905,321,325,800),(901,905,326,330,800),(901,905,331,335,800),(901,905,336,340,800),(901,905,341,345,800),(901,905,346,350,800),(901,905,351,355,800),(901,905,356,360,800),(901,905,361,365,800),(901,905,366,370,800),(901,905,371,375,795),(901,905,376,380,788),(901,905,381,385,780),(901,905,386,390,773),(901,905,391,395,765),(901,905,396,400,758),(901,905,401,405,750),(901,905,406,410,743),(901,905,411,415,735),(901,905,416,420,728),(901,905,421,425,720),(901,905,426,430,713),(901,905,431,435,705),(901,905,436,440,698),(901,905,441,445,690),(901,905,446,450,683),(901,905,451,455,675),(901,905,456,460,668),(901,905,461,465,660),(901,905,466,470,653),(901,905,471,475,645),(901,905,476,480,638),(901,905,481,485,630),(901,905,486,490,623),(901,905,491,495,615),(901,905,496,500,608),(901,905,501,505,600),(901,905,506,510,593),(901,905,511,515,585),(901,905,516,520,578),(901,905,521,525,570),(901,905,526,530,563),(901,905,531,535,555),(901,905,536,540,548),(901,905,541,545,540),(901,905,546,550,533),(901,905,551,555,525),(901,905,556,560,518),(901,905,561,565,510),(901,905,566,570,503),(901,905,571,575,495),(901,905,576,580,488),(901,905,581,585,480),(901,905,586,590,473),(901,905,591,595,465),(901,905,596,600,458),(901,905,601,605,450),(901,905,606,610,443),(901,905,611,615,435),(901,905,616,620,428),(901,905,621,625,420),(901,905,626,630,413),(901,905,631,635,405),(901,905,636,640,398),(901,905,641,645,390),(901,905,646,650,383),(901,905,651,655,375),(901,905,656,660,368),(901,905,661,665,360),(901,905,666,670,353),(901,905,671,675,345),(901,905,676,680,338),(901,905,681,685,330),(901,905,686,690,323),(901,905,691,695,315),(901,905,696,700,308),(901,905,701,705,300),(901,905,706,710,293),(901,905,711,715,285),(901,905,716,720,278),(901,905,721,725,270),(901,905,726,730,263),(901,905,731,735,255),(901,905,736,740,248),(901,905,741,745,240),(901,905,746,750,233),(901,905,751,755,225),(901,905,756,760,218),(901,905,761,765,210),(901,905,766,770,203),(901,905,771,775,195),(901,905,776,780,188),(901,905,781,785,180),(901,905,786,790,173),(901,905,791,795,165),(901,905,796,800,158),(901,905,801,805,150),(901,905,806,810,143),(901,905,811,815,135),(901,905,816,820,128),(901,905,821,825,120),(901,905,826,830,113),(901,905,831,835,105),(901,905,836,840,98),(901,905,841,845,90),(901,905,846,850,83),(901,905,851,855,75),(901,905,856,860,68),(901,905,861,865,60),(901,905,866,870,53),(901,905,871,875,45),(901,905,876,880,38),(901,905,881,885,30),(901,905,886,890,0),(901,905,891,895,0),(901,905,896,1000,0),(906,910,0,150,0),(906,910,151,155,800),(906,910,156,160,800),(906,910,161,165,800),(906,910,166,170,800),(906,910,171,175,800),(906,910,176,180,800),(906,910,181,185,800),(906,910,186,190,800),(906,910,191,195,800),(906,910,196,200,800),(906,910,201,205,800),(906,910,206,210,800),(906,910,211,215,800),(906,910,216,220,800),(906,910,221,225,800),(906,910,226,230,800),(906,910,231,235,800),(906,910,236,240,800),(906,910,241,245,800),(906,910,246,250,800),(906,910,251,255,800),(906,910,256,260,800),(906,910,261,265,800),(906,910,266,270,800),(906,910,271,275,800),(906,910,276,280,800),(906,910,281,285,800),(906,910,286,290,800),(906,910,291,295,800),(906,910,296,300,800),(906,910,301,305,800),(906,910,306,310,800),(906,910,311,315,800),(906,910,316,320,800),(906,910,321,325,800),(906,910,326,330,800),(906,910,331,335,800),(906,910,336,340,800),(906,910,341,345,800),(906,910,346,350,800),(906,910,351,355,800),(906,910,356,360,800),(906,910,361,365,800),(906,910,366,370,800),(906,910,371,375,800),(906,910,376,380,795),(906,910,381,385,788),(906,910,386,390,780),(906,910,391,395,773),(906,910,396,400,765),(906,910,401,405,758),(906,910,406,410,750),(906,910,411,415,743),(906,910,416,420,735),(906,910,421,425,728),(906,910,426,430,720),(906,910,431,435,713),(906,910,436,440,705),(906,910,441,445,698),(906,910,446,450,690),(906,910,451,455,683),(906,910,456,460,675),(906,910,461,465,668),(906,910,466,470,660),(906,910,471,475,653),(906,910,476,480,645),(906,910,481,485,638),(906,910,486,490,630),(906,910,491,495,623),(906,910,496,500,615),(906,910,501,505,608),(906,910,506,510,600),(906,910,511,515,593),(906,910,516,520,585),(906,910,521,525,578),(906,910,526,530,570),(906,910,531,535,563),(906,910,536,540,555),(906,910,541,545,548),(906,910,546,550,540),(906,910,551,555,533),(906,910,556,560,525),(906,910,561,565,518),(906,910,566,570,510),(906,910,571,575,503),(906,910,576,580,495),(906,910,581,585,488),(906,910,586,590,480),(906,910,591,595,473),(906,910,596,600,465),(906,910,601,605,458),(906,910,606,610,450),(906,910,611,615,443),(906,910,616,620,435),(906,910,621,625,428),(906,910,626,630,420),(906,910,631,635,413),(906,910,636,640,405),(906,910,641,645,398),(906,910,646,650,390),(906,910,651,655,383),(906,910,656,660,375),(906,910,661,665,368),(906,910,666,670,360),(906,910,671,675,353),(906,910,676,680,345),(906,910,681,685,338),(906,910,686,690,330),(906,910,691,695,323),(906,910,696,700,315),(906,910,701,705,308),(906,910,706,710,300),(906,910,711,715,293),(906,910,716,720,285),(906,910,721,725,278),(906,910,726,730,270),(906,910,731,735,263),(906,910,736,740,255),(906,910,741,745,248),(906,910,746,750,240),(906,910,751,755,233),(906,910,756,760,225),(906,910,761,765,218),(906,910,766,770,210),(906,910,771,775,203),(906,910,776,780,195),(906,910,781,785,188),(906,910,786,790,180),(906,910,791,795,173),(906,910,796,800,165),(906,910,801,805,158),(906,910,806,810,150),(906,910,811,815,143),(906,910,816,820,135),(906,910,821,825,128),(906,910,826,830,120),(906,910,831,835,113),(906,910,836,840,105),(906,910,841,845,98),(906,910,846,850,90),(906,910,851,855,83),(906,910,856,860,75),(906,910,861,865,68),(906,910,866,870,60),(906,910,871,875,53),(906,910,876,880,45),(906,910,881,885,38),(906,910,886,890,30),(906,910,891,895,0),(906,910,896,900,0),(906,910,901,1000,0),(911,915,0,150,0),(911,915,151,155,800),(911,915,156,160,800),(911,915,161,165,800),(911,915,166,170,800),(911,915,171,175,800),(911,915,176,180,800),(911,915,181,185,800),(911,915,186,190,800),(911,915,191,195,800),(911,915,196,200,800),(911,915,201,205,800),(911,915,206,210,800),(911,915,211,215,800),(911,915,216,220,800),(911,915,221,225,800),(911,915,226,230,800),(911,915,231,235,800),(911,915,236,240,800),(911,915,241,245,800),(911,915,246,250,800),(911,915,251,255,800),(911,915,256,260,800),(911,915,261,265,800),(911,915,266,270,800),(911,915,271,275,800),(911,915,276,280,800),(911,915,281,285,800),(911,915,286,290,800),(911,915,291,295,800),(911,915,296,300,800),(911,915,301,305,800),(911,915,306,310,800),(911,915,311,315,800),(911,915,316,320,800),(911,915,321,325,800),(911,915,326,330,800),(911,915,331,335,800),(911,915,336,340,800),(911,915,341,345,800),(911,915,346,350,800),(911,915,351,355,800),(911,915,356,360,800),(911,915,361,365,800),(911,915,366,370,800),(911,915,371,375,800),(911,915,376,380,800),(911,915,381,385,795),(911,915,386,390,788),(911,915,391,395,780),(911,915,396,400,773),(911,915,401,405,765),(911,915,406,410,758),(911,915,411,415,750),(911,915,416,420,743),(911,915,421,425,735),(911,915,426,430,728),(911,915,431,435,720),(911,915,436,440,713),(911,915,441,445,705),(911,915,446,450,698),(911,915,451,455,690),(911,915,456,460,683),(911,915,461,465,675),(911,915,466,470,668),(911,915,471,475,660),(911,915,476,480,653),(911,915,481,485,645),(911,915,486,490,638),(911,915,491,495,630),(911,915,496,500,623),(911,915,501,505,615),(911,915,506,510,608),(911,915,511,515,600),(911,915,516,520,593),(911,915,521,525,585),(911,915,526,530,578),(911,915,531,535,570),(911,915,536,540,563),(911,915,541,545,555),(911,915,546,550,548),(911,915,551,555,540),(911,915,556,560,533),(911,915,561,565,525),(911,915,566,570,518),(911,915,571,575,510),(911,915,576,580,503),(911,915,581,585,495),(911,915,586,590,488),(911,915,591,595,480),(911,915,596,600,473),(911,915,601,605,465),(911,915,606,610,458),(911,915,611,615,450),(911,915,616,620,443),(911,915,621,625,435),(911,915,626,630,428),(911,915,631,635,420),(911,915,636,640,413),(911,915,641,645,405),(911,915,646,650,398),(911,915,651,655,390),(911,915,656,660,383),(911,915,661,665,375),(911,915,666,670,368),(911,915,671,675,360),(911,915,676,680,353),(911,915,681,685,345),(911,915,686,690,338),(911,915,691,695,330),(911,915,696,700,323),(911,915,701,705,315),(911,915,706,710,308),(911,915,711,715,300),(911,915,716,720,293),(911,915,721,725,285),(911,915,726,730,278),(911,915,731,735,270),(911,915,736,740,263),(911,915,741,745,255),(911,915,746,750,248),(911,915,751,755,240),(911,915,756,760,233),(911,915,761,765,225),(911,915,766,770,218),(911,915,771,775,210),(911,915,776,780,203),(911,915,781,785,195),(911,915,786,790,188),(911,915,791,795,180),(911,915,796,800,173),(911,915,801,805,165),(911,915,806,810,158),(911,915,811,815,150),(911,915,816,820,143),(911,915,821,825,135),(911,915,826,830,128),(911,915,831,835,120),(911,915,836,840,113),(911,915,841,845,105),(911,915,846,850,98),(911,915,851,855,90),(911,915,856,860,83),(911,915,861,865,75),(911,915,866,870,68),(911,915,871,875,60),(911,915,876,880,53),(911,915,881,885,45),(911,915,886,890,38),(911,915,891,895,30),(911,915,896,900,0),(911,915,901,905,0),(911,915,906,1000,0),(916,920,0,150,0),(916,920,151,155,800),(916,920,156,160,800),(916,920,161,165,800),(916,920,166,170,800),(916,920,171,175,800),(916,920,176,180,800),(916,920,181,185,800),(916,920,186,190,800),(916,920,191,195,800),(916,920,196,200,800),(916,920,201,205,800),(916,920,206,210,800),(916,920,211,215,800),(916,920,216,220,800),(916,920,221,225,800),(916,920,226,230,800),(916,920,231,235,800),(916,920,236,240,800),(916,920,241,245,800),(916,920,246,250,800),(916,920,251,255,800),(916,920,256,260,800),(916,920,261,265,800),(916,920,266,270,800),(916,920,271,275,800),(916,920,276,280,800),(916,920,281,285,800),(916,920,286,290,800),(916,920,291,295,800),(916,920,296,300,800),(916,920,301,305,800),(916,920,306,310,800),(916,920,311,315,800),(916,920,316,320,800),(916,920,321,325,800),(916,920,326,330,800),(916,920,331,335,800),(916,920,336,340,800),(916,920,341,345,800),(916,920,346,350,800),(916,920,351,355,800),(916,920,356,360,800),(916,920,361,365,800),(916,920,366,370,800),(916,920,371,375,800),(916,920,376,380,800),(916,920,381,385,800),(916,920,386,390,795),(916,920,391,395,788),(916,920,396,400,780),(916,920,401,405,773),(916,920,406,410,765),(916,920,411,415,758),(916,920,416,420,750),(916,920,421,425,743),(916,920,426,430,735),(916,920,431,435,728),(916,920,436,440,720),(916,920,441,445,713),(916,920,446,450,705),(916,920,451,455,698),(916,920,456,460,690),(916,920,461,465,683),(916,920,466,470,675),(916,920,471,475,668),(916,920,476,480,660),(916,920,481,485,653),(916,920,486,490,645),(916,920,491,495,638),(916,920,496,500,630),(916,920,501,505,623),(916,920,506,510,615),(916,920,511,515,608),(916,920,516,520,600),(916,920,521,525,593),(916,920,526,530,585),(916,920,531,535,578),(916,920,536,540,570),(916,920,541,545,563),(916,920,546,550,555),(916,920,551,555,548),(916,920,556,560,540),(916,920,561,565,533),(916,920,566,570,525),(916,920,571,575,518),(916,920,576,580,510),(916,920,581,585,503),(916,920,586,590,495),(916,920,591,595,488),(916,920,596,600,480),(916,920,601,605,473),(916,920,606,610,465),(916,920,611,615,458),(916,920,616,620,450),(916,920,621,625,443),(916,920,626,630,435),(916,920,631,635,428),(916,920,636,640,420),(916,920,641,645,413),(916,920,646,650,405),(916,920,651,655,398),(916,920,656,660,390),(916,920,661,665,383),(916,920,666,670,375),(916,920,671,675,368),(916,920,676,680,360),(916,920,681,685,353),(916,920,686,690,345),(916,920,691,695,338),(916,920,696,700,330),(916,920,701,705,323),(916,920,706,710,315),(916,920,711,715,308),(916,920,716,720,300),(916,920,721,725,293),(916,920,726,730,285),(916,920,731,735,278),(916,920,736,740,270),(916,920,741,745,263),(916,920,746,750,255),(916,920,751,755,248),(916,920,756,760,240),(916,920,761,765,233),(916,920,766,770,225),(916,920,771,775,218),(916,920,776,780,210),(916,920,781,785,203),(916,920,786,790,195),(916,920,791,795,188),(916,920,796,800,180),(916,920,801,805,173),(916,920,806,810,165),(916,920,811,815,158),(916,920,816,820,150),(916,920,821,825,143),(916,920,826,830,135),(916,920,831,835,128),(916,920,836,840,120),(916,920,841,845,113),(916,920,846,850,105),(916,920,851,855,98),(916,920,856,860,90),(916,920,861,865,83),(916,920,866,870,75),(916,920,871,875,68),(916,920,876,880,60),(916,920,881,885,53),(916,920,886,890,45),(916,920,891,895,38),(916,920,896,900,30),(916,920,901,905,0),(916,920,906,910,0),(916,920,911,1000,0),(921,925,0,150,0),(921,925,151,155,800),(921,925,156,160,800),(921,925,161,165,800),(921,925,166,170,800),(921,925,171,175,800),(921,925,176,180,800),(921,925,181,185,800),(921,925,186,190,800),(921,925,191,195,800),(921,925,196,200,800),(921,925,201,205,800),(921,925,206,210,800),(921,925,211,215,800),(921,925,216,220,800),(921,925,221,225,800),(921,925,226,230,800),(921,925,231,235,800),(921,925,236,240,800),(921,925,241,245,800),(921,925,246,250,800),(921,925,251,255,800),(921,925,256,260,800),(921,925,261,265,800),(921,925,266,270,800),(921,925,271,275,800),(921,925,276,280,800),(921,925,281,285,800),(921,925,286,290,800),(921,925,291,295,800),(921,925,296,300,800),(921,925,301,305,800),(921,925,306,310,800),(921,925,311,315,800),(921,925,316,320,800),(921,925,321,325,800),(921,925,326,330,800),(921,925,331,335,800),(921,925,336,340,800),(921,925,341,345,800),(921,925,346,350,800),(921,925,351,355,800),(921,925,356,360,800),(921,925,361,365,800),(921,925,366,370,800),(921,925,371,375,800),(921,925,376,380,800),(921,925,381,385,800),(921,925,386,390,800),(921,925,391,395,795),(921,925,396,400,788),(921,925,401,405,780),(921,925,406,410,773),(921,925,411,415,765),(921,925,416,420,758),(921,925,421,425,750),(921,925,426,430,743),(921,925,431,435,735),(921,925,436,440,728),(921,925,441,445,720),(921,925,446,450,713),(921,925,451,455,705),(921,925,456,460,698),(921,925,461,465,690),(921,925,466,470,683),(921,925,471,475,675),(921,925,476,480,668),(921,925,481,485,660),(921,925,486,490,653),(921,925,491,495,645),(921,925,496,500,638),(921,925,501,505,630),(921,925,506,510,623),(921,925,511,515,615),(921,925,516,520,608),(921,925,521,525,600),(921,925,526,530,593),(921,925,531,535,585),(921,925,536,540,578),(921,925,541,545,570),(921,925,546,550,563),(921,925,551,555,555),(921,925,556,560,548),(921,925,561,565,540),(921,925,566,570,533),(921,925,571,575,525),(921,925,576,580,518),(921,925,581,585,510),(921,925,586,590,503),(921,925,591,595,495),(921,925,596,600,488),(921,925,601,605,480),(921,925,606,610,473),(921,925,611,615,465),(921,925,616,620,458),(921,925,621,625,450),(921,925,626,630,443),(921,925,631,635,435),(921,925,636,640,428),(921,925,641,645,420),(921,925,646,650,413),(921,925,651,655,405),(921,925,656,660,398),(921,925,661,665,390),(921,925,666,670,383),(921,925,671,675,375),(921,925,676,680,368),(921,925,681,685,360),(921,925,686,690,353),(921,925,691,695,345),(921,925,696,700,338),(921,925,701,705,330),(921,925,706,710,323),(921,925,711,715,315),(921,925,716,720,308),(921,925,721,725,300),(921,925,726,730,293),(921,925,731,735,285),(921,925,736,740,278),(921,925,741,745,270),(921,925,746,750,263),(921,925,751,755,255),(921,925,756,760,248),(921,925,761,765,240),(921,925,766,770,233),(921,925,771,775,225),(921,925,776,780,218),(921,925,781,785,210),(921,925,786,790,203),(921,925,791,795,195),(921,925,796,800,188),(921,925,801,805,180),(921,925,806,810,173),(921,925,811,815,165),(921,925,816,820,158),(921,925,821,825,150),(921,925,826,830,143),(921,925,831,835,135),(921,925,836,840,128),(921,925,841,845,120),(921,925,846,850,113),(921,925,851,855,105),(921,925,856,860,98),(921,925,861,865,90),(921,925,866,870,83),(921,925,871,875,75),(921,925,876,880,68),(921,925,881,885,60),(921,925,886,890,53),(921,925,891,895,45),(921,925,896,900,38),(921,925,901,905,30),(921,925,906,910,0),(921,925,911,915,0),(921,925,916,1000,0),(926,930,0,150,0),(926,930,151,155,800),(926,930,156,160,800),(926,930,161,165,800),(926,930,166,170,800),(926,930,171,175,800),(926,930,176,180,800),(926,930,181,185,800),(926,930,186,190,800),(926,930,191,195,800),(926,930,196,200,800),(926,930,201,205,800),(926,930,206,210,800),(926,930,211,215,800),(926,930,216,220,800),(926,930,221,225,800),(926,930,226,230,800),(926,930,231,235,800),(926,930,236,240,800),(926,930,241,245,800),(926,930,246,250,800),(926,930,251,255,800),(926,930,256,260,800),(926,930,261,265,800),(926,930,266,270,800),(926,930,271,275,800),(926,930,276,280,800),(926,930,281,285,800),(926,930,286,290,800),(926,930,291,295,800),(926,930,296,300,800),(926,930,301,305,800),(926,930,306,310,800),(926,930,311,315,800),(926,930,316,320,800),(926,930,321,325,800),(926,930,326,330,800),(926,930,331,335,800),(926,930,336,340,800),(926,930,341,345,800),(926,930,346,350,800),(926,930,351,355,800),(926,930,356,360,800),(926,930,361,365,800),(926,930,366,370,800),(926,930,371,375,800),(926,930,376,380,800),(926,930,381,385,800),(926,930,386,390,800),(926,930,391,395,800),(926,930,396,400,795),(926,930,401,405,788),(926,930,406,410,780),(926,930,411,415,773),(926,930,416,420,765),(926,930,421,425,758),(926,930,426,430,750),(926,930,431,435,743),(926,930,436,440,735),(926,930,441,445,728),(926,930,446,450,720),(926,930,451,455,713),(926,930,456,460,705),(926,930,461,465,698),(926,930,466,470,690),(926,930,471,475,683),(926,930,476,480,675),(926,930,481,485,668),(926,930,486,490,660),(926,930,491,495,653),(926,930,496,500,645),(926,930,501,505,638),(926,930,506,510,630),(926,930,511,515,623),(926,930,516,520,615),(926,930,521,525,608),(926,930,526,530,600),(926,930,531,535,593),(926,930,536,540,585),(926,930,541,545,578),(926,930,546,550,570),(926,930,551,555,563),(926,930,556,560,555),(926,930,561,565,548),(926,930,566,570,540),(926,930,571,575,533),(926,930,576,580,525),(926,930,581,585,518),(926,930,586,590,510),(926,930,591,595,503),(926,930,596,600,495),(926,930,601,605,488),(926,930,606,610,480),(926,930,611,615,473),(926,930,616,620,465),(926,930,621,625,458),(926,930,626,630,450),(926,930,631,635,443),(926,930,636,640,435),(926,930,641,645,428),(926,930,646,650,420),(926,930,651,655,413),(926,930,656,660,405),(926,930,661,665,398),(926,930,666,670,390),(926,930,671,675,383),(926,930,676,680,375),(926,930,681,685,368),(926,930,686,690,360),(926,930,691,695,353),(926,930,696,700,345),(926,930,701,705,338),(926,930,706,710,330),(926,930,711,715,323),(926,930,716,720,315),(926,930,721,725,308),(926,930,726,730,300),(926,930,731,735,293),(926,930,736,740,285),(926,930,741,745,278),(926,930,746,750,270),(926,930,751,755,263),(926,930,756,760,255),(926,930,761,765,248),(926,930,766,770,240),(926,930,771,775,233),(926,930,776,780,225),(926,930,781,785,218),(926,930,786,790,210),(926,930,791,795,203),(926,930,796,800,195),(926,930,801,805,188),(926,930,806,810,180),(926,930,811,815,173),(926,930,816,820,165),(926,930,821,825,158),(926,930,826,830,150),(926,930,831,835,143),(926,930,836,840,135),(926,930,841,845,128),(926,930,846,850,120),(926,930,851,855,113),(926,930,856,860,105),(926,930,861,865,98),(926,930,866,870,90),(926,930,871,875,83),(926,930,876,880,75),(926,930,881,885,68),(926,930,886,890,60),(926,930,891,895,53),(926,930,896,900,45),(926,930,901,905,38),(926,930,906,910,30),(926,930,911,915,0),(926,930,916,920,0),(926,930,921,1000,0),(931,935,0,150,0),(931,935,151,155,800),(931,935,156,160,800),(931,935,161,165,800),(931,935,166,170,800),(931,935,171,175,800),(931,935,176,180,800),(931,935,181,185,800),(931,935,186,190,800),(931,935,191,195,800),(931,935,196,200,800),(931,935,201,205,800),(931,935,206,210,800),(931,935,211,215,800),(931,935,216,220,800),(931,935,221,225,800),(931,935,226,230,800),(931,935,231,235,800),(931,935,236,240,800),(931,935,241,245,800),(931,935,246,250,800),(931,935,251,255,800),(931,935,256,260,800),(931,935,261,265,800),(931,935,266,270,800),(931,935,271,275,800),(931,935,276,280,800),(931,935,281,285,800),(931,935,286,290,800),(931,935,291,295,800),(931,935,296,300,800),(931,935,301,305,800),(931,935,306,310,800),(931,935,311,315,800),(931,935,316,320,800),(931,935,321,325,800),(931,935,326,330,800),(931,935,331,335,800),(931,935,336,340,800),(931,935,341,345,800),(931,935,346,350,800),(931,935,351,355,800),(931,935,356,360,800),(931,935,361,365,800),(931,935,366,370,800),(931,935,371,375,800),(931,935,376,380,800),(931,935,381,385,800),(931,935,386,390,800),(931,935,391,395,800),(931,935,396,400,800),(931,935,401,405,795),(931,935,406,410,788),(931,935,411,415,780),(931,935,416,420,773),(931,935,421,425,765),(931,935,426,430,758),(931,935,431,435,750),(931,935,436,440,743),(931,935,441,445,735),(931,935,446,450,728),(931,935,451,455,720),(931,935,456,460,713),(931,935,461,465,705),(931,935,466,470,698),(931,935,471,475,690),(931,935,476,480,683),(931,935,481,485,675),(931,935,486,490,668),(931,935,491,495,660),(931,935,496,500,653),(931,935,501,505,645),(931,935,506,510,638),(931,935,511,515,630),(931,935,516,520,623),(931,935,521,525,615),(931,935,526,530,608),(931,935,531,535,600),(931,935,536,540,593),(931,935,541,545,585),(931,935,546,550,578),(931,935,551,555,570),(931,935,556,560,563),(931,935,561,565,555),(931,935,566,570,548),(931,935,571,575,540),(931,935,576,580,533),(931,935,581,585,525),(931,935,586,590,518),(931,935,591,595,510),(931,935,596,600,503),(931,935,601,605,495),(931,935,606,610,488),(931,935,611,615,480),(931,935,616,620,473),(931,935,621,625,465),(931,935,626,630,458),(931,935,631,635,450),(931,935,636,640,443),(931,935,641,645,435),(931,935,646,650,428),(931,935,651,655,420),(931,935,656,660,413),(931,935,661,665,405),(931,935,666,670,398),(931,935,671,675,390),(931,935,676,680,383),(931,935,681,685,375),(931,935,686,690,368),(931,935,691,695,360),(931,935,696,700,353),(931,935,701,705,345),(931,935,706,710,338),(931,935,711,715,330),(931,935,716,720,323),(931,935,721,725,315),(931,935,726,730,308),(931,935,731,735,300),(931,935,736,740,293),(931,935,741,745,285),(931,935,746,750,278),(931,935,751,755,270),(931,935,756,760,263),(931,935,761,765,255),(931,935,766,770,248),(931,935,771,775,240),(931,935,776,780,233),(931,935,781,785,225),(931,935,786,790,218),(931,935,791,795,210),(931,935,796,800,203),(931,935,801,805,195),(931,935,806,810,188),(931,935,811,815,180),(931,935,816,820,173),(931,935,821,825,165),(931,935,826,830,158),(931,935,831,835,150),(931,935,836,840,143),(931,935,841,845,135),(931,935,846,850,128),(931,935,851,855,120),(931,935,856,860,113),(931,935,861,865,105),(931,935,866,870,98),(931,935,871,875,90),(931,935,876,880,83),(931,935,881,885,75),(931,935,886,890,68),(931,935,891,895,60),(931,935,896,900,53),(931,935,901,905,45),(931,935,906,910,38),(931,935,911,915,30),(931,935,916,920,0),(931,935,921,925,0),(931,935,926,1000,0),(936,940,0,150,0),(936,940,151,155,800),(936,940,156,160,800),(936,940,161,165,800),(936,940,166,170,800),(936,940,171,175,800),(936,940,176,180,800),(936,940,181,185,800),(936,940,186,190,800),(936,940,191,195,800),(936,940,196,200,800),(936,940,201,205,800),(936,940,206,210,800),(936,940,211,215,800),(936,940,216,220,800),(936,940,221,225,800),(936,940,226,230,800),(936,940,231,235,800),(936,940,236,240,800),(936,940,241,245,800),(936,940,246,250,800),(936,940,251,255,800),(936,940,256,260,800),(936,940,261,265,800),(936,940,266,270,800),(936,940,271,275,800),(936,940,276,280,800),(936,940,281,285,800),(936,940,286,290,800),(936,940,291,295,800),(936,940,296,300,800),(936,940,301,305,800),(936,940,306,310,800),(936,940,311,315,800),(936,940,316,320,800),(936,940,321,325,800),(936,940,326,330,800),(936,940,331,335,800),(936,940,336,340,800),(936,940,341,345,800),(936,940,346,350,800),(936,940,351,355,800),(936,940,356,360,800),(936,940,361,365,800),(936,940,366,370,800),(936,940,371,375,800),(936,940,376,380,800),(936,940,381,385,800),(936,940,386,390,800),(936,940,391,395,800),(936,940,396,400,800),(936,940,401,405,800),(936,940,406,410,795),(936,940,411,415,788),(936,940,416,420,780),(936,940,421,425,773),(936,940,426,430,765),(936,940,431,435,758),(936,940,436,440,750),(936,940,441,445,743),(936,940,446,450,735),(936,940,451,455,728),(936,940,456,460,720),(936,940,461,465,713),(936,940,466,470,705),(936,940,471,475,698),(936,940,476,480,690),(936,940,481,485,683),(936,940,486,490,675),(936,940,491,495,668),(936,940,496,500,660),(936,940,501,505,653),(936,940,506,510,645),(936,940,511,515,638),(936,940,516,520,630),(936,940,521,525,623),(936,940,526,530,615),(936,940,531,535,608),(936,940,536,540,600),(936,940,541,545,593),(936,940,546,550,585),(936,940,551,555,578),(936,940,556,560,570),(936,940,561,565,563),(936,940,566,570,555),(936,940,571,575,548),(936,940,576,580,540),(936,940,581,585,533),(936,940,586,590,525),(936,940,591,595,518),(936,940,596,600,510),(936,940,601,605,503),(936,940,606,610,495),(936,940,611,615,488),(936,940,616,620,480),(936,940,621,625,473),(936,940,626,630,465),(936,940,631,635,458),(936,940,636,640,450),(936,940,641,645,443),(936,940,646,650,435),(936,940,651,655,428),(936,940,656,660,420),(936,940,661,665,413),(936,940,666,670,405),(936,940,671,675,398),(936,940,676,680,390),(936,940,681,685,383),(936,940,686,690,375),(936,940,691,695,368),(936,940,696,700,360),(936,940,701,705,353),(936,940,706,710,345),(936,940,711,715,338),(936,940,716,720,330),(936,940,721,725,323),(936,940,726,730,315),(936,940,731,735,308),(936,940,736,740,300),(936,940,741,745,293),(936,940,746,750,285),(936,940,751,755,278),(936,940,756,760,270),(936,940,761,765,263),(936,940,766,770,255),(936,940,771,775,248),(936,940,776,780,240),(936,940,781,785,233),(936,940,786,790,225),(936,940,791,795,218),(936,940,796,800,210),(936,940,801,805,203),(936,940,806,810,195),(936,940,811,815,188),(936,940,816,820,180),(936,940,821,825,173),(936,940,826,830,165),(936,940,831,835,158),(936,940,836,840,150),(936,940,841,845,143),(936,940,846,850,135),(936,940,851,855,128),(936,940,856,860,120),(936,940,861,865,113),(936,940,866,870,105),(936,940,871,875,98),(936,940,876,880,90),(936,940,881,885,83),(936,940,886,890,75),(936,940,891,895,68),(936,940,896,900,60),(936,940,901,905,53),(936,940,906,910,45),(936,940,911,915,38),(936,940,916,920,30),(936,940,921,925,0),(936,940,926,930,0),(936,940,931,1000,0),(941,945,0,150,0),(941,945,151,155,800),(941,945,156,160,800),(941,945,161,165,800),(941,945,166,170,800),(941,945,171,175,800),(941,945,176,180,800),(941,945,181,185,800),(941,945,186,190,800),(941,945,191,195,800),(941,945,196,200,800),(941,945,201,205,800),(941,945,206,210,800),(941,945,211,215,800),(941,945,216,220,800),(941,945,221,225,800),(941,945,226,230,800),(941,945,231,235,800),(941,945,236,240,800),(941,945,241,245,800),(941,945,246,250,800),(941,945,251,255,800),(941,945,256,260,800),(941,945,261,265,800),(941,945,266,270,800),(941,945,271,275,800),(941,945,276,280,800),(941,945,281,285,800),(941,945,286,290,800),(941,945,291,295,800),(941,945,296,300,800),(941,945,301,305,800),(941,945,306,310,800),(941,945,311,315,800),(941,945,316,320,800),(941,945,321,325,800),(941,945,326,330,800),(941,945,331,335,800),(941,945,336,340,800),(941,945,341,345,800),(941,945,346,350,800),(941,945,351,355,800),(941,945,356,360,800),(941,945,361,365,800),(941,945,366,370,800),(941,945,371,375,800),(941,945,376,380,800),(941,945,381,385,800),(941,945,386,390,800),(941,945,391,395,800),(941,945,396,400,800),(941,945,401,405,800),(941,945,406,410,800),(941,945,411,415,795),(941,945,416,420,788),(941,945,421,425,780),(941,945,426,430,773),(941,945,431,435,765),(941,945,436,440,758),(941,945,441,445,750),(941,945,446,450,743),(941,945,451,455,735),(941,945,456,460,728),(941,945,461,465,720),(941,945,466,470,713),(941,945,471,475,705),(941,945,476,480,698),(941,945,481,485,690),(941,945,486,490,683),(941,945,491,495,675),(941,945,496,500,668),(941,945,501,505,660),(941,945,506,510,653),(941,945,511,515,645),(941,945,516,520,638),(941,945,521,525,630),(941,945,526,530,623),(941,945,531,535,615),(941,945,536,540,608),(941,945,541,545,600),(941,945,546,550,593),(941,945,551,555,585),(941,945,556,560,578),(941,945,561,565,570),(941,945,566,570,563),(941,945,571,575,555),(941,945,576,580,548),(941,945,581,585,540),(941,945,586,590,533),(941,945,591,595,525),(941,945,596,600,518),(941,945,601,605,510),(941,945,606,610,503),(941,945,611,615,495),(941,945,616,620,488),(941,945,621,625,480),(941,945,626,630,473),(941,945,631,635,465),(941,945,636,640,458),(941,945,641,645,450),(941,945,646,650,443),(941,945,651,655,435),(941,945,656,660,428),(941,945,661,665,420),(941,945,666,670,413),(941,945,671,675,405),(941,945,676,680,398),(941,945,681,685,390),(941,945,686,690,383),(941,945,691,695,375),(941,945,696,700,368),(941,945,701,705,360),(941,945,706,710,353),(941,945,711,715,345),(941,945,716,720,338),(941,945,721,725,330),(941,945,726,730,323),(941,945,731,735,315),(941,945,736,740,308),(941,945,741,745,300),(941,945,746,750,293),(941,945,751,755,285),(941,945,756,760,278),(941,945,761,765,270),(941,945,766,770,263),(941,945,771,775,255),(941,945,776,780,248),(941,945,781,785,240),(941,945,786,790,233),(941,945,791,795,225),(941,945,796,800,218),(941,945,801,805,210),(941,945,806,810,203),(941,945,811,815,195),(941,945,816,820,188),(941,945,821,825,180),(941,945,826,830,173),(941,945,831,835,165),(941,945,836,840,158),(941,945,841,845,150),(941,945,846,850,143),(941,945,851,855,135),(941,945,856,860,128),(941,945,861,865,120),(941,945,866,870,113),(941,945,871,875,105),(941,945,876,880,98),(941,945,881,885,90),(941,945,886,890,83),(941,945,891,895,75),(941,945,896,900,68),(941,945,901,905,60),(941,945,906,910,53),(941,945,911,915,45),(941,945,916,920,38),(941,945,921,925,30),(941,945,926,930,0),(941,945,931,935,0),(941,945,936,1000,0),(946,950,0,150,0),(946,950,151,155,800),(946,950,156,160,800),(946,950,161,165,800),(946,950,166,170,800),(946,950,171,175,800),(946,950,176,180,800),(946,950,181,185,800),(946,950,186,190,800),(946,950,191,195,800),(946,950,196,200,800),(946,950,201,205,800),(946,950,206,210,800),(946,950,211,215,800),(946,950,216,220,800),(946,950,221,225,800),(946,950,226,230,800),(946,950,231,235,800),(946,950,236,240,800),(946,950,241,245,800),(946,950,246,250,800),(946,950,251,255,800),(946,950,256,260,800),(946,950,261,265,800),(946,950,266,270,800),(946,950,271,275,800),(946,950,276,280,800),(946,950,281,285,800),(946,950,286,290,800),(946,950,291,295,800),(946,950,296,300,800),(946,950,301,305,800),(946,950,306,310,800),(946,950,311,315,800),(946,950,316,320,800),(946,950,321,325,800),(946,950,326,330,800),(946,950,331,335,800),(946,950,336,340,800),(946,950,341,345,800),(946,950,346,350,800),(946,950,351,355,800),(946,950,356,360,800),(946,950,361,365,800),(946,950,366,370,800),(946,950,371,375,800),(946,950,376,380,800),(946,950,381,385,800),(946,950,386,390,800),(946,950,391,395,800),(946,950,396,400,800),(946,950,401,405,800),(946,950,406,410,800),(946,950,411,415,800),(946,950,416,420,795),(946,950,421,425,788),(946,950,426,430,780),(946,950,431,435,773),(946,950,436,440,765),(946,950,441,445,758),(946,950,446,450,750),(946,950,451,455,743),(946,950,456,460,735),(946,950,461,465,728),(946,950,466,470,720),(946,950,471,475,713),(946,950,476,480,705),(946,950,481,485,698),(946,950,486,490,690),(946,950,491,495,683),(946,950,496,500,675),(946,950,501,505,668),(946,950,506,510,660),(946,950,511,515,653),(946,950,516,520,645),(946,950,521,525,638),(946,950,526,530,630),(946,950,531,535,623),(946,950,536,540,615),(946,950,541,545,608),(946,950,546,550,600),(946,950,551,555,593),(946,950,556,560,585),(946,950,561,565,578),(946,950,566,570,570),(946,950,571,575,563),(946,950,576,580,555),(946,950,581,585,548),(946,950,586,590,540),(946,950,591,595,533),(946,950,596,600,525),(946,950,601,605,518),(946,950,606,610,510),(946,950,611,615,503),(946,950,616,620,495),(946,950,621,625,488),(946,950,626,630,480),(946,950,631,635,473),(946,950,636,640,465),(946,950,641,645,458),(946,950,646,650,450),(946,950,651,655,443),(946,950,656,660,435),(946,950,661,665,428),(946,950,666,670,420),(946,950,671,675,413),(946,950,676,680,405),(946,950,681,685,398),(946,950,686,690,390),(946,950,691,695,383),(946,950,696,700,375),(946,950,701,705,368),(946,950,706,710,360),(946,950,711,715,353),(946,950,716,720,345),(946,950,721,725,338),(946,950,726,730,330),(946,950,731,735,323),(946,950,736,740,315),(946,950,741,745,308),(946,950,746,750,300),(946,950,751,755,293),(946,950,756,760,285),(946,950,761,765,278),(946,950,766,770,270),(946,950,771,775,263),(946,950,776,780,255),(946,950,781,785,248),(946,950,786,790,240),(946,950,791,795,233),(946,950,796,800,225),(946,950,801,805,218),(946,950,806,810,210),(946,950,811,815,203),(946,950,816,820,195),(946,950,821,825,188),(946,950,826,830,180),(946,950,831,835,173),(946,950,836,840,165),(946,950,841,845,158),(946,950,846,850,150),(946,950,851,855,143),(946,950,856,860,135),(946,950,861,865,128),(946,950,866,870,120),(946,950,871,875,113),(946,950,876,880,105),(946,950,881,885,98),(946,950,886,890,90),(946,950,891,895,83),(946,950,896,900,75),(946,950,901,905,68),(946,950,906,910,60),(946,950,911,915,53),(946,950,916,920,45),(946,950,921,925,38),(946,950,926,930,30),(946,950,931,935,0),(946,950,936,940,0),(946,950,941,1000,0),(951,955,0,150,0),(951,955,151,155,800),(951,955,156,160,800),(951,955,161,165,800),(951,955,166,170,800),(951,955,171,175,800),(951,955,176,180,800),(951,955,181,185,800),(951,955,186,190,800),(951,955,191,195,800),(951,955,196,200,800),(951,955,201,205,800),(951,955,206,210,800),(951,955,211,215,800),(951,955,216,220,800),(951,955,221,225,800),(951,955,226,230,800),(951,955,231,235,800),(951,955,236,240,800),(951,955,241,245,800),(951,955,246,250,800),(951,955,251,255,800),(951,955,256,260,800),(951,955,261,265,800),(951,955,266,270,800),(951,955,271,275,800),(951,955,276,280,800),(951,955,281,285,800),(951,955,286,290,800),(951,955,291,295,800),(951,955,296,300,800),(951,955,301,305,800),(951,955,306,310,800),(951,955,311,315,800),(951,955,316,320,800),(951,955,321,325,800),(951,955,326,330,800),(951,955,331,335,800),(951,955,336,340,800),(951,955,341,345,800),(951,955,346,350,800),(951,955,351,355,800),(951,955,356,360,800),(951,955,361,365,800),(951,955,366,370,800),(951,955,371,375,800),(951,955,376,380,800),(951,955,381,385,800),(951,955,386,390,800),(951,955,391,395,800),(951,955,396,400,800),(951,955,401,405,800),(951,955,406,410,800),(951,955,411,415,800),(951,955,416,420,800),(951,955,421,425,795),(951,955,426,430,788),(951,955,431,435,780),(951,955,436,440,773),(951,955,441,445,765),(951,955,446,450,758),(951,955,451,455,750),(951,955,456,460,743),(951,955,461,465,735),(951,955,466,470,728),(951,955,471,475,720),(951,955,476,480,713),(951,955,481,485,705),(951,955,486,490,698),(951,955,491,495,690),(951,955,496,500,683),(951,955,501,505,675),(951,955,506,510,668),(951,955,511,515,660),(951,955,516,520,653),(951,955,521,525,645),(951,955,526,530,638),(951,955,531,535,630),(951,955,536,540,623),(951,955,541,545,615),(951,955,546,550,608),(951,955,551,555,600),(951,955,556,560,593),(951,955,561,565,585),(951,955,566,570,578),(951,955,571,575,570),(951,955,576,580,563),(951,955,581,585,555),(951,955,586,590,548),(951,955,591,595,540),(951,955,596,600,533),(951,955,601,605,525),(951,955,606,610,518),(951,955,611,615,510),(951,955,616,620,503),(951,955,621,625,495),(951,955,626,630,488),(951,955,631,635,480),(951,955,636,640,473),(951,955,641,645,465),(951,955,646,650,458),(951,955,651,655,450),(951,955,656,660,443),(951,955,661,665,435),(951,955,666,670,428),(951,955,671,675,420),(951,955,676,680,413),(951,955,681,685,405),(951,955,686,690,398),(951,955,691,695,390),(951,955,696,700,383),(951,955,701,705,375),(951,955,706,710,368),(951,955,711,715,360),(951,955,716,720,353),(951,955,721,725,345),(951,955,726,730,338),(951,955,731,735,330),(951,955,736,740,323),(951,955,741,745,315),(951,955,746,750,308),(951,955,751,755,300),(951,955,756,760,293),(951,955,761,765,285),(951,955,766,770,278),(951,955,771,775,270),(951,955,776,780,263),(951,955,781,785,255),(951,955,786,790,248),(951,955,791,795,240),(951,955,796,800,233),(951,955,801,805,225),(951,955,806,810,218),(951,955,811,815,210),(951,955,816,820,203),(951,955,821,825,195),(951,955,826,830,188),(951,955,831,835,180),(951,955,836,840,173),(951,955,841,845,165),(951,955,846,850,158),(951,955,851,855,150),(951,955,856,860,143),(951,955,861,865,135),(951,955,866,870,128),(951,955,871,875,120),(951,955,876,880,113),(951,955,881,885,105),(951,955,886,890,98),(951,955,891,895,90),(951,955,896,900,83),(951,955,901,905,75),(951,955,906,910,68),(951,955,911,915,60),(951,955,916,920,53),(951,955,921,925,45),(951,955,926,930,38),(951,955,931,935,30),(951,955,936,940,0),(951,955,941,945,0),(951,955,946,1000,0),(956,960,0,150,0),(956,960,151,155,800),(956,960,156,160,800),(956,960,161,165,800),(956,960,166,170,800),(956,960,171,175,800),(956,960,176,180,800),(956,960,181,185,800),(956,960,186,190,800),(956,960,191,195,800),(956,960,196,200,800),(956,960,201,205,800),(956,960,206,210,800),(956,960,211,215,800),(956,960,216,220,800),(956,960,221,225,800),(956,960,226,230,800),(956,960,231,235,800),(956,960,236,240,800),(956,960,241,245,800),(956,960,246,250,800),(956,960,251,255,800),(956,960,256,260,800),(956,960,261,265,800),(956,960,266,270,800),(956,960,271,275,800),(956,960,276,280,800),(956,960,281,285,800),(956,960,286,290,800),(956,960,291,295,800),(956,960,296,300,800),(956,960,301,305,800),(956,960,306,310,800),(956,960,311,315,800),(956,960,316,320,800),(956,960,321,325,800),(956,960,326,330,800),(956,960,331,335,800),(956,960,336,340,800),(956,960,341,345,800),(956,960,346,350,800),(956,960,351,355,800),(956,960,356,360,800),(956,960,361,365,800),(956,960,366,370,800),(956,960,371,375,800),(956,960,376,380,800),(956,960,381,385,800),(956,960,386,390,800),(956,960,391,395,800),(956,960,396,400,800),(956,960,401,405,800),(956,960,406,410,800),(956,960,411,415,800),(956,960,416,420,800),(956,960,421,425,800),(956,960,426,430,795),(956,960,431,435,788),(956,960,436,440,780),(956,960,441,445,773),(956,960,446,450,765),(956,960,451,455,758),(956,960,456,460,750),(956,960,461,465,743),(956,960,466,470,735),(956,960,471,475,728),(956,960,476,480,720),(956,960,481,485,713),(956,960,486,490,705),(956,960,491,495,698),(956,960,496,500,690),(956,960,501,505,683),(956,960,506,510,675),(956,960,511,515,668),(956,960,516,520,660),(956,960,521,525,653),(956,960,526,530,645),(956,960,531,535,638),(956,960,536,540,630),(956,960,541,545,623),(956,960,546,550,615),(956,960,551,555,608),(956,960,556,560,600),(956,960,561,565,593),(956,960,566,570,585),(956,960,571,575,578),(956,960,576,580,570),(956,960,581,585,563),(956,960,586,590,555),(956,960,591,595,548),(956,960,596,600,540),(956,960,601,605,533),(956,960,606,610,525),(956,960,611,615,518),(956,960,616,620,510),(956,960,621,625,503),(956,960,626,630,495),(956,960,631,635,488),(956,960,636,640,480),(956,960,641,645,473),(956,960,646,650,465),(956,960,651,655,458),(956,960,656,660,450),(956,960,661,665,443),(956,960,666,670,435),(956,960,671,675,428),(956,960,676,680,420),(956,960,681,685,413),(956,960,686,690,405),(956,960,691,695,398),(956,960,696,700,390),(956,960,701,705,383),(956,960,706,710,375),(956,960,711,715,368),(956,960,716,720,360),(956,960,721,725,353),(956,960,726,730,345),(956,960,731,735,338),(956,960,736,740,330),(956,960,741,745,323),(956,960,746,750,315),(956,960,751,755,308),(956,960,756,760,300),(956,960,761,765,293),(956,960,766,770,285),(956,960,771,775,278),(956,960,776,780,270),(956,960,781,785,263),(956,960,786,790,255),(956,960,791,795,248),(956,960,796,800,240),(956,960,801,805,233),(956,960,806,810,225),(956,960,811,815,218),(956,960,816,820,210),(956,960,821,825,203),(956,960,826,830,195),(956,960,831,835,188),(956,960,836,840,180),(956,960,841,845,173),(956,960,846,850,165),(956,960,851,855,158),(956,960,856,860,150),(956,960,861,865,143),(956,960,866,870,135),(956,960,871,875,128),(956,960,876,880,120),(956,960,881,885,113),(956,960,886,890,105),(956,960,891,895,98),(956,960,896,900,90),(956,960,901,905,83),(956,960,906,910,75),(956,960,911,915,68),(956,960,916,920,60),(956,960,921,925,53),(956,960,926,930,45),(956,960,931,935,38),(956,960,936,940,30),(956,960,941,945,0),(956,960,946,950,0),(956,960,951,1000,0),(961,965,0,150,0),(961,965,151,155,800),(961,965,156,160,800),(961,965,161,165,800),(961,965,166,170,800),(961,965,171,175,800),(961,965,176,180,800),(961,965,181,185,800),(961,965,186,190,800),(961,965,191,195,800),(961,965,196,200,800),(961,965,201,205,800),(961,965,206,210,800),(961,965,211,215,800),(961,965,216,220,800),(961,965,221,225,800),(961,965,226,230,800),(961,965,231,235,800),(961,965,236,240,800),(961,965,241,245,800),(961,965,246,250,800),(961,965,251,255,800),(961,965,256,260,800),(961,965,261,265,800),(961,965,266,270,800),(961,965,271,275,800),(961,965,276,280,800),(961,965,281,285,800),(961,965,286,290,800),(961,965,291,295,800),(961,965,296,300,800),(961,965,301,305,800),(961,965,306,310,800),(961,965,311,315,800),(961,965,316,320,800),(961,965,321,325,800),(961,965,326,330,800),(961,965,331,335,800),(961,965,336,340,800),(961,965,341,345,800),(961,965,346,350,800),(961,965,351,355,800),(961,965,356,360,800),(961,965,361,365,800),(961,965,366,370,800),(961,965,371,375,800),(961,965,376,380,800),(961,965,381,385,800),(961,965,386,390,800),(961,965,391,395,800),(961,965,396,400,800),(961,965,401,405,800),(961,965,406,410,800),(961,965,411,415,800),(961,965,416,420,800),(961,965,421,425,800),(961,965,426,430,800),(961,965,431,435,795),(961,965,436,440,788),(961,965,441,445,780),(961,965,446,450,773),(961,965,451,455,765),(961,965,456,460,758),(961,965,461,465,750),(961,965,466,470,743),(961,965,471,475,735),(961,965,476,480,728),(961,965,481,485,720),(961,965,486,490,713),(961,965,491,495,705),(961,965,496,500,698),(961,965,501,505,690),(961,965,506,510,683),(961,965,511,515,675),(961,965,516,520,668),(961,965,521,525,660),(961,965,526,530,653),(961,965,531,535,645),(961,965,536,540,638),(961,965,541,545,630),(961,965,546,550,623),(961,965,551,555,615),(961,965,556,560,608),(961,965,561,565,600),(961,965,566,570,593),(961,965,571,575,585),(961,965,576,580,578),(961,965,581,585,570),(961,965,586,590,563),(961,965,591,595,555),(961,965,596,600,548),(961,965,601,605,540),(961,965,606,610,533),(961,965,611,615,525),(961,965,616,620,518),(961,965,621,625,510),(961,965,626,630,503),(961,965,631,635,495),(961,965,636,640,488),(961,965,641,645,480),(961,965,646,650,473),(961,965,651,655,465),(961,965,656,660,458),(961,965,661,665,450),(961,965,666,670,443),(961,965,671,675,435),(961,965,676,680,428),(961,965,681,685,420),(961,965,686,690,413),(961,965,691,695,405),(961,965,696,700,398),(961,965,701,705,390),(961,965,706,710,383),(961,965,711,715,375),(961,965,716,720,368),(961,965,721,725,360),(961,965,726,730,353),(961,965,731,735,345),(961,965,736,740,338),(961,965,741,745,330),(961,965,746,750,323),(961,965,751,755,315),(961,965,756,760,308),(961,965,761,765,300),(961,965,766,770,293),(961,965,771,775,285),(961,965,776,780,278),(961,965,781,785,270),(961,965,786,790,263),(961,965,791,795,255),(961,965,796,800,248),(961,965,801,805,240),(961,965,806,810,233),(961,965,811,815,225),(961,965,816,820,218),(961,965,821,825,210),(961,965,826,830,203),(961,965,831,835,195),(961,965,836,840,188),(961,965,841,845,180),(961,965,846,850,173),(961,965,851,855,165),(961,965,856,860,158),(961,965,861,865,150),(961,965,866,870,143),(961,965,871,875,135),(961,965,876,880,128),(961,965,881,885,120),(961,965,886,890,113),(961,965,891,895,105),(961,965,896,900,98),(961,965,901,905,90),(961,965,906,910,83),(961,965,911,915,75),(961,965,916,920,68),(961,965,921,925,60),(961,965,926,930,53),(961,965,931,935,45),(961,965,936,940,38),(961,965,941,945,30),(961,965,946,950,0),(961,965,951,955,0),(961,965,956,1000,0),(966,970,0,150,0),(966,970,151,155,800),(966,970,156,160,800),(966,970,161,165,800),(966,970,166,170,800),(966,970,171,175,800),(966,970,176,180,800),(966,970,181,185,800),(966,970,186,190,800),(966,970,191,195,800),(966,970,196,200,800),(966,970,201,205,800),(966,970,206,210,800),(966,970,211,215,800),(966,970,216,220,800),(966,970,221,225,800),(966,970,226,230,800),(966,970,231,235,800),(966,970,236,240,800),(966,970,241,245,800),(966,970,246,250,800),(966,970,251,255,800),(966,970,256,260,800),(966,970,261,265,800),(966,970,266,270,800),(966,970,271,275,800),(966,970,276,280,800),(966,970,281,285,800),(966,970,286,290,800),(966,970,291,295,800),(966,970,296,300,800),(966,970,301,305,800),(966,970,306,310,800),(966,970,311,315,800),(966,970,316,320,800),(966,970,321,325,800),(966,970,326,330,800),(966,970,331,335,800),(966,970,336,340,800),(966,970,341,345,800),(966,970,346,350,800),(966,970,351,355,800),(966,970,356,360,800),(966,970,361,365,800),(966,970,366,370,800),(966,970,371,375,800),(966,970,376,380,800),(966,970,381,385,800),(966,970,386,390,800),(966,970,391,395,800),(966,970,396,400,800),(966,970,401,405,800),(966,970,406,410,800),(966,970,411,415,800),(966,970,416,420,800),(966,970,421,425,800),(966,970,426,430,800),(966,970,431,435,800),(966,970,436,440,795),(966,970,441,445,788),(966,970,446,450,780),(966,970,451,455,773),(966,970,456,460,765),(966,970,461,465,758),(966,970,466,470,750),(966,970,471,475,743),(966,970,476,480,735),(966,970,481,485,728),(966,970,486,490,720),(966,970,491,495,713),(966,970,496,500,705),(966,970,501,505,698),(966,970,506,510,690),(966,970,511,515,683),(966,970,516,520,675),(966,970,521,525,668),(966,970,526,530,660),(966,970,531,535,653),(966,970,536,540,645),(966,970,541,545,638),(966,970,546,550,630),(966,970,551,555,623),(966,970,556,560,615),(966,970,561,565,608),(966,970,566,570,600),(966,970,571,575,593),(966,970,576,580,585),(966,970,581,585,578),(966,970,586,590,570),(966,970,591,595,563),(966,970,596,600,555),(966,970,601,605,548),(966,970,606,610,540),(966,970,611,615,533),(966,970,616,620,525),(966,970,621,625,518),(966,970,626,630,510),(966,970,631,635,503),(966,970,636,640,495),(966,970,641,645,488),(966,970,646,650,480),(966,970,651,655,473),(966,970,656,660,465),(966,970,661,665,458),(966,970,666,670,450),(966,970,671,675,443),(966,970,676,680,435),(966,970,681,685,428),(966,970,686,690,420),(966,970,691,695,413),(966,970,696,700,405),(966,970,701,705,398),(966,970,706,710,390),(966,970,711,715,383),(966,970,716,720,375),(966,970,721,725,368),(966,970,726,730,360),(966,970,731,735,353),(966,970,736,740,345),(966,970,741,745,338),(966,970,746,750,330),(966,970,751,755,323),(966,970,756,760,315),(966,970,761,765,308),(966,970,766,770,300),(966,970,771,775,293),(966,970,776,780,285),(966,970,781,785,278),(966,970,786,790,270),(966,970,791,795,263),(966,970,796,800,255),(966,970,801,805,248),(966,970,806,810,240),(966,970,811,815,233),(966,970,816,820,225),(966,970,821,825,218),(966,970,826,830,210),(966,970,831,835,203),(966,970,836,840,195),(966,970,841,845,188),(966,970,846,850,180),(966,970,851,855,173),(966,970,856,860,165),(966,970,861,865,158),(966,970,866,870,150),(966,970,871,875,143),(966,970,876,880,135),(966,970,881,885,128),(966,970,886,890,120),(966,970,891,895,113),(966,970,896,900,105),(966,970,901,905,98),(966,970,906,910,90),(966,970,911,915,83),(966,970,916,920,75),(966,970,921,925,68),(966,970,926,930,60),(966,970,931,935,53),(966,970,936,940,45),(966,970,941,945,38),(966,970,946,950,30),(966,970,951,955,0),(966,970,956,960,0),(966,970,961,1000,0),(971,975,0,150,0),(971,975,151,155,800),(971,975,156,160,800),(971,975,161,165,800),(971,975,166,170,800),(971,975,171,175,800),(971,975,176,180,800),(971,975,181,185,800),(971,975,186,190,800),(971,975,191,195,800),(971,975,196,200,800),(971,975,201,205,800),(971,975,206,210,800),(971,975,211,215,800),(971,975,216,220,800),(971,975,221,225,800),(971,975,226,230,800),(971,975,231,235,800),(971,975,236,240,800),(971,975,241,245,800),(971,975,246,250,800),(971,975,251,255,800),(971,975,256,260,800),(971,975,261,265,800),(971,975,266,270,800),(971,975,271,275,800),(971,975,276,280,800),(971,975,281,285,800),(971,975,286,290,800),(971,975,291,295,800),(971,975,296,300,800),(971,975,301,305,800),(971,975,306,310,800),(971,975,311,315,800),(971,975,316,320,800),(971,975,321,325,800),(971,975,326,330,800),(971,975,331,335,800),(971,975,336,340,800),(971,975,341,345,800),(971,975,346,350,800),(971,975,351,355,800),(971,975,356,360,800),(971,975,361,365,800),(971,975,366,370,800),(971,975,371,375,800),(971,975,376,380,800),(971,975,381,385,800),(971,975,386,390,800),(971,975,391,395,800),(971,975,396,400,800),(971,975,401,405,800),(971,975,406,410,800),(971,975,411,415,800),(971,975,416,420,800),(971,975,421,425,800),(971,975,426,430,800),(971,975,431,435,800),(971,975,436,440,800),(971,975,441,445,795),(971,975,446,450,788),(971,975,451,455,780),(971,975,456,460,773),(971,975,461,465,765),(971,975,466,470,758),(971,975,471,475,750),(971,975,476,480,743),(971,975,481,485,735),(971,975,486,490,728),(971,975,491,495,720),(971,975,496,500,713),(971,975,501,505,705),(971,975,506,510,698),(971,975,511,515,690),(971,975,516,520,683),(971,975,521,525,675),(971,975,526,530,668),(971,975,531,535,660),(971,975,536,540,653),(971,975,541,545,645),(971,975,546,550,638),(971,975,551,555,630),(971,975,556,560,623),(971,975,561,565,615),(971,975,566,570,608),(971,975,571,575,600),(971,975,576,580,593),(971,975,581,585,585),(971,975,586,590,578),(971,975,591,595,570),(971,975,596,600,563),(971,975,601,605,555),(971,975,606,610,548),(971,975,611,615,540),(971,975,616,620,533),(971,975,621,625,525),(971,975,626,630,518),(971,975,631,635,510),(971,975,636,640,503),(971,975,641,645,495),(971,975,646,650,488),(971,975,651,655,480),(971,975,656,660,473),(971,975,661,665,465),(971,975,666,670,458),(971,975,671,675,450),(971,975,676,680,443),(971,975,681,685,435),(971,975,686,690,428),(971,975,691,695,420),(971,975,696,700,413),(971,975,701,705,405),(971,975,706,710,398),(971,975,711,715,390),(971,975,716,720,383),(971,975,721,725,375),(971,975,726,730,368),(971,975,731,735,360),(971,975,736,740,353),(971,975,741,745,345),(971,975,746,750,338),(971,975,751,755,330),(971,975,756,760,323),(971,975,761,765,315),(971,975,766,770,308),(971,975,771,775,300),(971,975,776,780,293),(971,975,781,785,285),(971,975,786,790,278),(971,975,791,795,270),(971,975,796,800,263),(971,975,801,805,255),(971,975,806,810,248),(971,975,811,815,240),(971,975,816,820,233),(971,975,821,825,225),(971,975,826,830,218),(971,975,831,835,210),(971,975,836,840,203),(971,975,841,845,195),(971,975,846,850,188),(971,975,851,855,180),(971,975,856,860,173),(971,975,861,865,165),(971,975,866,870,158),(971,975,871,875,150),(971,975,876,880,143),(971,975,881,885,135),(971,975,886,890,128),(971,975,891,895,120),(971,975,896,900,113),(971,975,901,905,105),(971,975,906,910,98),(971,975,911,915,90),(971,975,916,920,83),(971,975,921,925,75),(971,975,926,930,68),(971,975,931,935,60),(971,975,936,940,53),(971,975,941,945,45),(971,975,946,950,38),(971,975,951,955,30),(971,975,956,960,0),(971,975,961,965,0),(971,975,966,1000,0),(976,980,0,150,0),(976,980,151,155,800),(976,980,156,160,800),(976,980,161,165,800),(976,980,166,170,800),(976,980,171,175,800),(976,980,176,180,800),(976,980,181,185,800),(976,980,186,190,800),(976,980,191,195,800),(976,980,196,200,800),(976,980,201,205,800),(976,980,206,210,800),(976,980,211,215,800),(976,980,216,220,800),(976,980,221,225,800),(976,980,226,230,800),(976,980,231,235,800),(976,980,236,240,800),(976,980,241,245,800),(976,980,246,250,800),(976,980,251,255,800),(976,980,256,260,800),(976,980,261,265,800),(976,980,266,270,800),(976,980,271,275,800),(976,980,276,280,800),(976,980,281,285,800),(976,980,286,290,800),(976,980,291,295,800),(976,980,296,300,800),(976,980,301,305,800),(976,980,306,310,800),(976,980,311,315,800),(976,980,316,320,800),(976,980,321,325,800),(976,980,326,330,800),(976,980,331,335,800),(976,980,336,340,800),(976,980,341,345,800),(976,980,346,350,800),(976,980,351,355,800),(976,980,356,360,800),(976,980,361,365,800),(976,980,366,370,800),(976,980,371,375,800),(976,980,376,380,800),(976,980,381,385,800),(976,980,386,390,800),(976,980,391,395,800),(976,980,396,400,800),(976,980,401,405,800),(976,980,406,410,800),(976,980,411,415,800),(976,980,416,420,800),(976,980,421,425,800),(976,980,426,430,800),(976,980,431,435,800),(976,980,436,440,800),(976,980,441,445,800),(976,980,446,450,795),(976,980,451,455,788),(976,980,456,460,780),(976,980,461,465,773),(976,980,466,470,765),(976,980,471,475,758),(976,980,476,480,750),(976,980,481,485,743),(976,980,486,490,735),(976,980,491,495,728),(976,980,496,500,720),(976,980,501,505,713),(976,980,506,510,705),(976,980,511,515,698),(976,980,516,520,690),(976,980,521,525,683),(976,980,526,530,675),(976,980,531,535,668),(976,980,536,540,660),(976,980,541,545,653),(976,980,546,550,645),(976,980,551,555,638),(976,980,556,560,630),(976,980,561,565,623),(976,980,566,570,615),(976,980,571,575,608),(976,980,576,580,600),(976,980,581,585,593),(976,980,586,590,585),(976,980,591,595,578),(976,980,596,600,570),(976,980,601,605,563),(976,980,606,610,555),(976,980,611,615,548),(976,980,616,620,540),(976,980,621,625,533),(976,980,626,630,525),(976,980,631,635,518),(976,980,636,640,510),(976,980,641,645,503),(976,980,646,650,495),(976,980,651,655,488),(976,980,656,660,480),(976,980,661,665,473),(976,980,666,670,465),(976,980,671,675,458),(976,980,676,680,450),(976,980,681,685,443),(976,980,686,690,435),(976,980,691,695,428),(976,980,696,700,420),(976,980,701,705,413),(976,980,706,710,405),(976,980,711,715,398),(976,980,716,720,390),(976,980,721,725,383),(976,980,726,730,375),(976,980,731,735,368),(976,980,736,740,360),(976,980,741,745,353),(976,980,746,750,345),(976,980,751,755,338),(976,980,756,760,330),(976,980,761,765,323),(976,980,766,770,315),(976,980,771,775,308),(976,980,776,780,300),(976,980,781,785,293),(976,980,786,790,285),(976,980,791,795,278),(976,980,796,800,270),(976,980,801,805,263),(976,980,806,810,255),(976,980,811,815,248),(976,980,816,820,240),(976,980,821,825,233),(976,980,826,830,225),(976,980,831,835,218),(976,980,836,840,210),(976,980,841,845,203),(976,980,846,850,195),(976,980,851,855,188),(976,980,856,860,180),(976,980,861,865,173),(976,980,866,870,165),(976,980,871,875,158),(976,980,876,880,150),(976,980,881,885,143),(976,980,886,890,135),(976,980,891,895,128),(976,980,896,900,120),(976,980,901,905,113),(976,980,906,910,105),(976,980,911,915,98),(976,980,916,920,90),(976,980,921,925,83),(976,980,926,930,75),(976,980,931,935,68),(976,980,936,940,60),(976,980,941,945,53),(976,980,946,950,45),(976,980,951,955,38),(976,980,956,960,30),(976,980,961,965,0),(976,980,966,970,0),(976,980,971,1000,0),(981,985,0,150,0),(981,985,151,155,800),(981,985,156,160,800),(981,985,161,165,800),(981,985,166,170,800),(981,985,171,175,800),(981,985,176,180,800),(981,985,181,185,800),(981,985,186,190,800),(981,985,191,195,800),(981,985,196,200,800),(981,985,201,205,800),(981,985,206,210,800),(981,985,211,215,800),(981,985,216,220,800),(981,985,221,225,800),(981,985,226,230,800),(981,985,231,235,800),(981,985,236,240,800),(981,985,241,245,800),(981,985,246,250,800),(981,985,251,255,800),(981,985,256,260,800),(981,985,261,265,800),(981,985,266,270,800),(981,985,271,275,800),(981,985,276,280,800),(981,985,281,285,800),(981,985,286,290,800),(981,985,291,295,800),(981,985,296,300,800),(981,985,301,305,800),(981,985,306,310,800),(981,985,311,315,800),(981,985,316,320,800),(981,985,321,325,800),(981,985,326,330,800),(981,985,331,335,800),(981,985,336,340,800),(981,985,341,345,800),(981,985,346,350,800),(981,985,351,355,800),(981,985,356,360,800),(981,985,361,365,800),(981,985,366,370,800),(981,985,371,375,800),(981,985,376,380,800),(981,985,381,385,800),(981,985,386,390,800),(981,985,391,395,800),(981,985,396,400,800),(981,985,401,405,800),(981,985,406,410,800),(981,985,411,415,800),(981,985,416,420,800),(981,985,421,425,800),(981,985,426,430,800),(981,985,431,435,800),(981,985,436,440,800),(981,985,441,445,800),(981,985,446,450,800),(981,985,451,455,795),(981,985,456,460,788),(981,985,461,465,780),(981,985,466,470,773),(981,985,471,475,765),(981,985,476,480,758),(981,985,481,485,750),(981,985,486,490,743),(981,985,491,495,735),(981,985,496,500,728),(981,985,501,505,720),(981,985,506,510,713),(981,985,511,515,705),(981,985,516,520,698),(981,985,521,525,690),(981,985,526,530,683),(981,985,531,535,675),(981,985,536,540,668),(981,985,541,545,660),(981,985,546,550,653),(981,985,551,555,645),(981,985,556,560,638),(981,985,561,565,630),(981,985,566,570,623),(981,985,571,575,615),(981,985,576,580,608),(981,985,581,585,600),(981,985,586,590,593),(981,985,591,595,585),(981,985,596,600,578),(981,985,601,605,570),(981,985,606,610,563),(981,985,611,615,555),(981,985,616,620,548),(981,985,621,625,540),(981,985,626,630,533),(981,985,631,635,525),(981,985,636,640,518),(981,985,641,645,510),(981,985,646,650,503),(981,985,651,655,495),(981,985,656,660,488),(981,985,661,665,480),(981,985,666,670,473),(981,985,671,675,465),(981,985,676,680,458),(981,985,681,685,450),(981,985,686,690,443),(981,985,691,695,435),(981,985,696,700,428),(981,985,701,705,420),(981,985,706,710,413),(981,985,711,715,405),(981,985,716,720,398),(981,985,721,725,390),(981,985,726,730,383),(981,985,731,735,375),(981,985,736,740,368),(981,985,741,745,360),(981,985,746,750,353),(981,985,751,755,345),(981,985,756,760,338),(981,985,761,765,330),(981,985,766,770,323),(981,985,771,775,315),(981,985,776,780,308),(981,985,781,785,300),(981,985,786,790,293),(981,985,791,795,285),(981,985,796,800,278),(981,985,801,805,270),(981,985,806,810,263),(981,985,811,815,255),(981,985,816,820,248),(981,985,821,825,240),(981,985,826,830,233),(981,985,831,835,225),(981,985,836,840,218),(981,985,841,845,210),(981,985,846,850,203),(981,985,851,855,195),(981,985,856,860,188),(981,985,861,865,180),(981,985,866,870,173),(981,985,871,875,165),(981,985,876,880,158),(981,985,881,885,150),(981,985,886,890,143),(981,985,891,895,135),(981,985,896,900,128),(981,985,901,905,120),(981,985,906,910,113),(981,985,911,915,105),(981,985,916,920,98),(981,985,921,925,90),(981,985,926,930,83),(981,985,931,935,75),(981,985,936,940,68),(981,985,941,945,60),(981,985,946,950,53),(981,985,951,955,45),(981,985,956,960,38),(981,985,961,965,30),(981,985,966,970,0),(981,985,971,975,0),(981,985,976,1000,0),(986,990,0,150,0),(986,990,151,155,800),(986,990,156,160,800),(986,990,161,165,800),(986,990,166,170,800),(986,990,171,175,800),(986,990,176,180,800),(986,990,181,185,800),(986,990,186,190,800),(986,990,191,195,800),(986,990,196,200,800),(986,990,201,205,800),(986,990,206,210,800),(986,990,211,215,800),(986,990,216,220,800),(986,990,221,225,800),(986,990,226,230,800),(986,990,231,235,800),(986,990,236,240,800),(986,990,241,245,800),(986,990,246,250,800),(986,990,251,255,800),(986,990,256,260,800),(986,990,261,265,800),(986,990,266,270,800),(986,990,271,275,800),(986,990,276,280,800),(986,990,281,285,800),(986,990,286,290,800),(986,990,291,295,800),(986,990,296,300,800),(986,990,301,305,800),(986,990,306,310,800),(986,990,311,315,800),(986,990,316,320,800),(986,990,321,325,800),(986,990,326,330,800),(986,990,331,335,800),(986,990,336,340,800),(986,990,341,345,800),(986,990,346,350,800),(986,990,351,355,800),(986,990,356,360,800),(986,990,361,365,800),(986,990,366,370,800),(986,990,371,375,800),(986,990,376,380,800),(986,990,381,385,800),(986,990,386,390,800),(986,990,391,395,800),(986,990,396,400,800),(986,990,401,405,800),(986,990,406,410,800),(986,990,411,415,800),(986,990,416,420,800),(986,990,421,425,800),(986,990,426,430,800),(986,990,431,435,800),(986,990,436,440,800),(986,990,441,445,800),(986,990,446,450,800),(986,990,451,455,800),(986,990,456,460,795),(986,990,461,465,788),(986,990,466,470,780),(986,990,471,475,773),(986,990,476,480,765),(986,990,481,485,758),(986,990,486,490,750),(986,990,491,495,743),(986,990,496,500,735),(986,990,501,505,728),(986,990,506,510,720),(986,990,511,515,713),(986,990,516,520,705),(986,990,521,525,698),(986,990,526,530,690),(986,990,531,535,683),(986,990,536,540,675),(986,990,541,545,668),(986,990,546,550,660),(986,990,551,555,653),(986,990,556,560,645),(986,990,561,565,638),(986,990,566,570,630),(986,990,571,575,623),(986,990,576,580,615),(986,990,581,585,608),(986,990,586,590,600),(986,990,591,595,593),(986,990,596,600,585),(986,990,601,605,578),(986,990,606,610,570),(986,990,611,615,563),(986,990,616,620,555),(986,990,621,625,548),(986,990,626,630,540),(986,990,631,635,533),(986,990,636,640,525),(986,990,641,645,518),(986,990,646,650,510),(986,990,651,655,503),(986,990,656,660,495),(986,990,661,665,488),(986,990,666,670,480),(986,990,671,675,473),(986,990,676,680,465),(986,990,681,685,458),(986,990,686,690,450),(986,990,691,695,443),(986,990,696,700,435),(986,990,701,705,428),(986,990,706,710,420),(986,990,711,715,413),(986,990,716,720,405),(986,990,721,725,398),(986,990,726,730,390),(986,990,731,735,383),(986,990,736,740,375),(986,990,741,745,368),(986,990,746,750,360),(986,990,751,755,353),(986,990,756,760,345),(986,990,761,765,338),(986,990,766,770,330),(986,990,771,775,323),(986,990,776,780,315),(986,990,781,785,308),(986,990,786,790,300),(986,990,791,795,293),(986,990,796,800,285),(986,990,801,805,278),(986,990,806,810,270),(986,990,811,815,263),(986,990,816,820,255),(986,990,821,825,248),(986,990,826,830,240),(986,990,831,835,233),(986,990,836,840,225),(986,990,841,845,218),(986,990,846,850,210),(986,990,851,855,203),(986,990,856,860,195),(986,990,861,865,188),(986,990,866,870,180),(986,990,871,875,173),(986,990,876,880,165),(986,990,881,885,158),(986,990,886,890,150),(986,990,891,895,143),(986,990,896,900,135),(986,990,901,905,128),(986,990,906,910,120),(986,990,911,915,113),(986,990,916,920,105),(986,990,921,925,98),(986,990,926,930,90),(986,990,931,935,83),(986,990,936,940,75),(986,990,941,945,68),(986,990,946,950,60),(986,990,951,955,53),(986,990,956,960,45),(986,990,961,965,38),(986,990,966,970,30),(986,990,971,975,0),(986,990,976,980,0),(986,990,981,1000,0),(991,995,0,150,0),(991,995,151,155,800),(991,995,156,160,800),(991,995,161,165,800),(991,995,166,170,800),(991,995,171,175,800),(991,995,176,180,800),(991,995,181,185,800),(991,995,186,190,800),(991,995,191,195,800),(991,995,196,200,800),(991,995,201,205,800),(991,995,206,210,800),(991,995,211,215,800),(991,995,216,220,800),(991,995,221,225,800),(991,995,226,230,800),(991,995,231,235,800),(991,995,236,240,800),(991,995,241,245,800),(991,995,246,250,800),(991,995,251,255,800),(991,995,256,260,800),(991,995,261,265,800),(991,995,266,270,800),(991,995,271,275,800),(991,995,276,280,800),(991,995,281,285,800),(991,995,286,290,800),(991,995,291,295,800),(991,995,296,300,800),(991,995,301,305,800),(991,995,306,310,800),(991,995,311,315,800),(991,995,316,320,800),(991,995,321,325,800),(991,995,326,330,800),(991,995,331,335,800),(991,995,336,340,800),(991,995,341,345,800),(991,995,346,350,800),(991,995,351,355,800),(991,995,356,360,800),(991,995,361,365,800),(991,995,366,370,800),(991,995,371,375,800),(991,995,376,380,800),(991,995,381,385,800),(991,995,386,390,800),(991,995,391,395,800),(991,995,396,400,800),(991,995,401,405,800),(991,995,406,410,800),(991,995,411,415,800),(991,995,416,420,800),(991,995,421,425,800),(991,995,426,430,800),(991,995,431,435,800),(991,995,436,440,800),(991,995,441,445,800),(991,995,446,450,800),(991,995,451,455,800),(991,995,456,460,800),(991,995,461,465,795),(991,995,466,470,788),(991,995,471,475,780),(991,995,476,480,773),(991,995,481,485,765),(991,995,486,490,758),(991,995,491,495,750),(991,995,496,500,743),(991,995,501,505,735),(991,995,506,510,728),(991,995,511,515,720),(991,995,516,520,713),(991,995,521,525,705),(991,995,526,530,698),(991,995,531,535,690),(991,995,536,540,683),(991,995,541,545,675),(991,995,546,550,668),(991,995,551,555,660),(991,995,556,560,653),(991,995,561,565,645),(991,995,566,570,638),(991,995,571,575,630),(991,995,576,580,623),(991,995,581,585,615),(991,995,586,590,608),(991,995,591,595,600),(991,995,596,600,593),(991,995,601,605,585),(991,995,606,610,578),(991,995,611,615,570),(991,995,616,620,563),(991,995,621,625,555),(991,995,626,630,548),(991,995,631,635,540),(991,995,636,640,533),(991,995,641,645,525),(991,995,646,650,518),(991,995,651,655,510),(991,995,656,660,503),(991,995,661,665,495),(991,995,666,670,488),(991,995,671,675,480),(991,995,676,680,473),(991,995,681,685,465),(991,995,686,690,458),(991,995,691,695,450),(991,995,696,700,443),(991,995,701,705,435),(991,995,706,710,428),(991,995,711,715,420),(991,995,716,720,413),(991,995,721,725,405),(991,995,726,730,398),(991,995,731,735,390),(991,995,736,740,383),(991,995,741,745,375),(991,995,746,750,368),(991,995,751,755,360),(991,995,756,760,353),(991,995,761,765,345),(991,995,766,770,338),(991,995,771,775,330),(991,995,776,780,323),(991,995,781,785,315),(991,995,786,790,308),(991,995,791,795,300),(991,995,796,800,293),(991,995,801,805,285),(991,995,806,810,278),(991,995,811,815,270),(991,995,816,820,263),(991,995,821,825,255),(991,995,826,830,248),(991,995,831,835,240),(991,995,836,840,233),(991,995,841,845,225),(991,995,846,850,218),(991,995,851,855,210),(991,995,856,860,203),(991,995,861,865,195),(991,995,866,870,188),(991,995,871,875,180),(991,995,876,880,173),(991,995,881,885,165),(991,995,886,890,158),(991,995,891,895,150),(991,995,896,900,143),(991,995,901,905,135),(991,995,906,910,128),(991,995,911,915,120),(991,995,916,920,113),(991,995,921,925,105),(991,995,926,930,98),(991,995,931,935,90),(991,995,936,940,83),(991,995,941,945,75),(991,995,946,950,68),(991,995,951,955,60),(991,995,956,960,53),(991,995,961,965,45),(991,995,966,970,38),(991,995,971,975,30),(991,995,976,980,0),(991,995,981,985,0),(991,995,986,1000,0),(996,1000,0,150,0),(996,1000,151,155,800),(996,1000,156,160,800),(996,1000,161,165,800),(996,1000,166,170,800),(996,1000,171,175,800),(996,1000,176,180,800),(996,1000,181,185,800),(996,1000,186,190,800),(996,1000,191,195,800),(996,1000,196,200,800),(996,1000,201,205,800),(996,1000,206,210,800),(996,1000,211,215,800),(996,1000,216,220,800),(996,1000,221,225,800),(996,1000,226,230,800),(996,1000,231,235,800),(996,1000,236,240,800),(996,1000,241,245,800),(996,1000,246,250,800),(996,1000,251,255,800),(996,1000,256,260,800),(996,1000,261,265,800),(996,1000,266,270,800),(996,1000,271,275,800),(996,1000,276,280,800),(996,1000,281,285,800),(996,1000,286,290,800),(996,1000,291,295,800),(996,1000,296,300,800),(996,1000,301,305,800),(996,1000,306,310,800),(996,1000,311,315,800),(996,1000,316,320,800),(996,1000,321,325,800),(996,1000,326,330,800),(996,1000,331,335,800),(996,1000,336,340,800),(996,1000,341,345,800),(996,1000,346,350,800),(996,1000,351,355,800),(996,1000,356,360,800),(996,1000,361,365,800),(996,1000,366,370,800),(996,1000,371,375,800),(996,1000,376,380,800),(996,1000,381,385,800),(996,1000,386,390,800),(996,1000,391,395,800),(996,1000,396,400,800),(996,1000,401,405,800),(996,1000,406,410,800),(996,1000,411,415,800),(996,1000,416,420,800),(996,1000,421,425,800),(996,1000,426,430,800),(996,1000,431,435,800),(996,1000,436,440,800),(996,1000,441,445,800),(996,1000,446,450,800),(996,1000,451,455,800),(996,1000,456,460,800),(996,1000,461,465,800),(996,1000,466,470,795),(996,1000,471,475,788),(996,1000,476,480,780),(996,1000,481,485,773),(996,1000,486,490,765),(996,1000,491,495,758),(996,1000,496,500,750),(996,1000,501,505,743),(996,1000,506,510,735),(996,1000,511,515,728),(996,1000,516,520,720),(996,1000,521,525,713),(996,1000,526,530,705),(996,1000,531,535,698),(996,1000,536,540,690),(996,1000,541,545,683),(996,1000,546,550,675),(996,1000,551,555,668),(996,1000,556,560,660),(996,1000,561,565,653),(996,1000,566,570,645),(996,1000,571,575,638),(996,1000,576,580,630),(996,1000,581,585,623),(996,1000,586,590,615),(996,1000,591,595,608),(996,1000,596,600,600),(996,1000,601,605,593),(996,1000,606,610,585),(996,1000,611,615,578),(996,1000,616,620,570),(996,1000,621,625,563),(996,1000,626,630,555),(996,1000,631,635,548),(996,1000,636,640,540),(996,1000,641,645,533),(996,1000,646,650,525),(996,1000,651,655,518),(996,1000,656,660,510),(996,1000,661,665,503),(996,1000,666,670,495),(996,1000,671,675,488),(996,1000,676,680,480),(996,1000,681,685,473),(996,1000,686,690,465),(996,1000,691,695,458),(996,1000,696,700,450),(996,1000,701,705,443),(996,1000,706,710,435),(996,1000,711,715,428),(996,1000,716,720,420),(996,1000,721,725,413),(996,1000,726,730,405),(996,1000,731,735,398),(996,1000,736,740,390),(996,1000,741,745,383),(996,1000,746,750,375),(996,1000,751,755,368),(996,1000,756,760,360),(996,1000,761,765,353),(996,1000,766,770,345),(996,1000,771,775,338),(996,1000,776,780,330),(996,1000,781,785,323),(996,1000,786,790,315),(996,1000,791,795,308),(996,1000,796,800,300),(996,1000,801,805,293),(996,1000,806,810,285),(996,1000,811,815,278),(996,1000,816,820,270),(996,1000,821,825,263),(996,1000,826,830,255),(996,1000,831,835,248),(996,1000,836,840,240),(996,1000,841,845,233),(996,1000,846,850,225),(996,1000,851,855,218),(996,1000,856,860,210),(996,1000,861,865,203),(996,1000,866,870,195),(996,1000,871,875,188),(996,1000,876,880,180),(996,1000,881,885,173),(996,1000,886,890,165),(996,1000,891,895,158),(996,1000,896,900,150),(996,1000,901,905,143),(996,1000,906,910,135),(996,1000,911,915,128),(996,1000,916,920,120),(996,1000,921,925,113),(996,1000,926,930,105),(996,1000,931,935,98),(996,1000,936,940,90),(996,1000,941,945,83),(996,1000,946,950,75),(996,1000,951,955,68),(996,1000,956,960,60),(996,1000,961,965,53),(996,1000,966,970,45),(996,1000,971,975,38),(996,1000,976,980,30),(996,1000,981,985,0),(996,1000,986,990,0),(996,1000,991,1000,0);
/*!40000 ALTER TABLE `base_exp_add` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_exp_book`
--

DROP TABLE IF EXISTS `base_exp_book`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_exp_book` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品id',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '经验',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='经验书配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_exp_book`
--

LOCK TABLES `base_exp_book` WRITE;
/*!40000 ALTER TABLE `base_exp_book` DISABLE KEYS */;
INSERT INTO `base_exp_book` VALUES (212201,10000),(212202,100000),(212203,1000000);
/*!40000 ALTER TABLE `base_exp_book` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_expand_bag_costs`
--

DROP TABLE IF EXISTS `base_expand_bag_costs`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_expand_bag_costs` (
  `bag_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '背包类型',
  `min_cell` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小开启格子数',
  `max_cell` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大开启格子数',
  `cost_goods_list` varchar(128) NOT NULL COMMENT '道具消耗列表',
  `cost_money_list` varchar(128) NOT NULL COMMENT '货币消耗列表',
  PRIMARY KEY (`bag_type`,`min_cell`,`max_cell`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='扩展背包空间消耗配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_expand_bag_costs`
--

LOCK TABLES `base_expand_bag_costs` WRITE;
/*!40000 ALTER TABLE `base_expand_bag_costs` DISABLE KEYS */;
INSERT INTO `base_expand_bag_costs` VALUES (4,1,10,'[{0,38040001,1}]','[{2,0,10}]'),(4,11,20,'[{0,38040001,2}]','[{2,0,20}]'),(4,21,30,'[{0,38040001,3}]','[{2,0,30}]'),(4,31,40,'[{0,38040001,4}]','[{2,0,40}]'),(4,41,50,'[{0,38040001,5}]','[{2,0,50}]'),(4,51,60,'[{0,38040001,6}]','[{2,0,60}]'),(4,61,70,'[{0,38040001,7}]','[{2,0,70}]'),(4,71,110,'[{0,38040001,8}]','[{2,0,80}]'),(5,1,10,'[{0,38040001,2}]','[{2,0,20}]'),(5,11,20,'[{0,38040001,3}]','[{2,0,30}]'),(5,21,30,'[{0,38040001,4}]','[{2,0,40}]'),(5,31,40,'[{0,38040001,5}]','[{2,0,50}]'),(5,41,90,'[{0,38040001,6}]','[{2,0,60}]');
/*!40000 ALTER TABLE `base_expand_bag_costs` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_fake_attr_ratio`
--

DROP TABLE IF EXISTS `base_fake_attr_ratio`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_fake_attr_ratio` (
  `module_id` smallint(5) unsigned NOT NULL COMMENT '功能id',
  `sub_id` smallint(5) unsigned NOT NULL COMMENT '子id',
  `ratio` tinyint(3) unsigned NOT NULL COMMENT '属性系数',
  PRIMARY KEY (`module_id`,`sub_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='假属性系数';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_fake_attr_ratio`
--

LOCK TABLES `base_fake_attr_ratio` WRITE;
/*!40000 ALTER TABLE `base_fake_attr_ratio` DISABLE KEYS */;
INSERT INTO `base_fake_attr_ratio` VALUES (280,1,100),(281,1,100),(606,0,75),(606,1,75);
/*!40000 ALTER TABLE `base_fake_attr_ratio` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_fake_role`
--

DROP TABLE IF EXISTS `base_fake_role`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_fake_role` (
  `lv` smallint(5) unsigned NOT NULL COMMENT '假人等级',
  `attr_list` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '属性列表',
  `combat` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战力',
  PRIMARY KEY (`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='假人属性配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_fake_role`
--

LOCK TABLES `base_fake_role` WRITE;
/*!40000 ALTER TABLE `base_fake_role` DISABLE KEYS */;
INSERT INTO `base_fake_role` VALUES (1,'[{1,33},{2,660},{3,15},{4,15},{5,0},{6,0},{7,0},{8,0},{48,0},{49,0}]',2070),(2,'[{1,33},{2,740},{3,15},{4,15},{5,0},{6,0},{7,0},{8,0},{48,0},{49,0}]',2150),(3,'[{1,37},{2,820},{3,17},{4,17},{5,0},{6,0},{7,0},{8,0},{48,0},{49,0}]',2410),(4,'[{1,86},{2,900},{3,41},{4,19},{5,0},{6,0},{7,0},{8,0},{48,0},{49,0}]',4120),(5,'[{1,94},{2,1467},{3,45},{4,23},{5,0},{6,0},{7,0},{8,0},{48,0},{49,0}]',5047),(6,'[{1,94},{2,1547},{3,45},{4,35},{5,0},{6,0},{7,0},{8,0},{48,0},{49,0}]',5427),(7,'[{1,98},{2,1627},{3,47},{4,37},{5,0},{6,0},{7,0},{8,0},{48,0},{49,0}]',5687),(8,'[{1,102},{2,1707},{3,49},{4,39},{5,0},{6,0},{7,0},{8,0},{48,0},{49,0}]',5947),(9,'[{1,106},{2,1787},{3,51},{4,41},{5,0},{6,0},{7,0},{8,0},{48,0},{49,0}]',6207),(10,'[{1,114},{2,2354},{3,55},{4,45},{5,0},{6,0},{7,0},{8,0},{48,0},{49,0}]',7134),(11,'[{1,114},{2,2434},{3,55},{4,57},{5,0},{6,0},{7,0},{8,0},{48,0},{49,0}]',7514),(12,'[{1,118},{2,2514},{3,57},{4,59},{5,0},{6,0},{7,0},{8,0},{48,0},{49,0}]',7774),(13,'[{1,122},{2,2594},{3,59},{4,61},{5,0},{6,0},{7,0},{8,0},{48,0},{49,0}]',8034),(14,'[{1,130},{2,3161},{3,63},{4,65},{5,0},{6,0},{7,0},{8,0},{48,0},{49,0}]',8961),(15,'[{1,130},{2,3241},{3,63},{4,77},{5,0},{6,0},{7,0},{8,0},{48,0},{49,0}]',9341),(16,'[{1,138},{2,4052},{3,67},{4,81},{5,0},{6,0},{7,0},{8,0},{48,0},{49,0}]',10512),(17,'[{1,138},{2,4132},{3,67},{4,99},{5,0},{6,0},{7,0},{8,0},{48,0},{49,0}]',11042),(18,'[{1,142},{2,4212},{3,69},{4,101},{5,0},{6,0},{7,0},{8,0},{48,0},{49,0}]',11302),(19,'[{1,176},{2,4292},{3,86},{4,103},{5,0},{6,0},{7,0},{8,0},{48,0},{49,0}]',12537),(20,'[{1,180},{2,4372},{3,88},{4,105},{5,0},{6,0},{7,0},{8,0},{48,0},{49,0}]',12797),(21,'[{1,184},{2,4452},{3,90},{4,107},{5,0},{6,0},{7,0},{8,0},{48,0},{49,0}]',13057),(22,'[{1,218},{2,4532},{3,107},{4,109},{5,0},{6,0},{7,0},{8,0},{48,0},{49,0}]',14292),(23,'[{1,222},{2,4612},{3,109},{4,111},{5,0},{6,0},{7,0},{8,0},{48,0},{49,0}]',14552),(24,'[{1,411},{2,9658},{3,113},{4,115},{5,90},{6,90},{7,0},{8,0},{48,0},{49,0}]',32578),(25,'[{1,415},{2,10029},{3,115},{4,150},{5,90},{6,90},{7,0},{8,0},{48,0},{49,0}]',33954),(26,'[{1,434},{2,10873},{3,117},{4,152},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',36078),(27,'[{1,434},{2,10953},{3,117},{4,171},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',36633),(28,'[{1,438},{2,11033},{3,119},{4,173},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',36893),(29,'[{1,442},{2,11113},{3,121},{4,175},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',37153),(30,'[{1,450},{2,11593},{3,125},{4,179},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',37993),(31,'[{1,474},{2,12818},{3,127},{4,181},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',39798),(32,'[{1,474},{2,12898},{3,127},{4,210},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',40603),(33,'[{1,478},{2,12978},{3,129},{4,212},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',40863),(34,'[{1,528},{2,13058},{3,154},{4,214},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',42618),(35,'[{1,532},{2,13138},{3,156},{4,216},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',42878),(36,'[{1,606},{2,13218},{3,193},{4,218},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',45413),(37,'[{1,614},{2,13758},{3,197},{4,222},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',46313),(38,'[{1,637},{2,13838},{3,197},{4,222},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',46853),(39,'[{1,641},{2,13918},{3,199},{4,224},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',47113),(40,'[{1,645},{2,13998},{3,201},{4,226},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',47373),(41,'[{1,653},{2,14196},{3,205},{4,230},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',47931),(42,'[{1,653},{2,14276},{3,205},{4,233},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',48086),(43,'[{1,657},{2,14356},{3,207},{4,235},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',48346),(44,'[{1,665},{2,16436},{3,211},{4,239},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',50786),(45,'[{1,665},{2,16516},{3,211},{4,239},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',50866),(46,'[{1,673},{2,17360},{3,215},{4,243},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',52070),(47,'[{1,673},{2,17440},{3,215},{4,262},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',52625),(48,'[{1,677},{2,17520},{3,217},{4,264},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',52885),(49,'[{1,681},{2,17600},{3,219},{4,266},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',53145),(50,'[{1,685},{2,17680},{3,221},{4,268},{5,98},{6,98},{7,0},{8,0},{48,0},{49,0}]',53405),(51,'[{1,809},{2,27952},{3,275},{4,436},{5,128},{6,123},{7,26},{8,27},{48,0},{49,0}]',77107),(52,'[{1,823},{2,28034},{3,281},{4,443},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',78444),(53,'[{1,827},{2,28116},{3,283},{4,445},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',78706),(54,'[{1,831},{2,28198},{3,285},{4,447},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',78968),(55,'[{1,835},{2,28280},{3,287},{4,449},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',79230),(56,'[{1,1095},{2,28362},{3,437},{4,451},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',88312),(57,'[{1,1099},{2,28444},{3,439},{4,453},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',88574),(58,'[{1,1103},{2,28526},{3,441},{4,455},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',88836),(59,'[{1,1107},{2,28607},{3,443},{4,457},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',89097),(60,'[{1,1498},{2,32966},{3,649},{4,461},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',106526),(61,'[{1,1498},{2,33048},{3,649},{4,566},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',109233),(62,'[{1,1502},{2,33129},{3,651},{4,568},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',109494),(63,'[{1,1808},{2,33211},{3,811},{4,570},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',119746),(64,'[{1,1812},{2,33293},{3,813},{4,572},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',120008),(65,'[{1,1816},{2,33375},{3,815},{4,574},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',120270),(66,'[{1,1926},{2,37652},{3,873},{4,578},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',128297),(67,'[{1,1926},{2,37734},{3,873},{4,681},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',130954),(68,'[{1,1930},{2,37816},{3,875},{4,683},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',131216),(69,'[{1,1934},{2,37898},{3,877},{4,685},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',131478),(70,'[{1,1938},{2,37980},{3,879},{4,687},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',131740),(71,'[{1,1942},{2,38062},{3,881},{4,689},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',132002),(72,'[{1,1946},{2,38144},{3,883},{4,691},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',132264),(73,'[{1,1950},{2,38226},{3,886},{4,693},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',132551),(74,'[{1,1954},{2,38308},{3,888},{4,695},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',132813),(75,'[{1,1958},{2,38390},{3,890},{4,697},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',133075),(76,'[{1,1962},{2,38472},{3,892},{4,699},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',133337),(77,'[{1,1966},{2,38554},{3,894},{4,701},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',133599),(78,'[{1,1970},{2,38636},{3,896},{4,703},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',133861),(79,'[{1,1974},{2,38717},{3,898},{4,705},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',134122),(80,'[{1,1982},{2,39057},{3,902},{4,709},{5,132},{6,126},{7,29},{8,30},{48,0},{49,0}]',134822),(81,'[{1,1995},{2,39139},{3,902},{4,709},{5,132},{6,126},{7,35},{8,30},{48,0},{49,0}]',135464),(82,'[{1,1999},{2,39221},{3,904},{4,711},{5,132},{6,126},{7,35},{8,30},{48,0},{49,0}]',135726),(83,'[{1,2003},{2,39303},{3,907},{4,713},{5,132},{6,126},{7,35},{8,30},{48,0},{49,0}]',136013),(84,'[{1,2007},{2,39385},{3,909},{4,715},{5,132},{6,126},{7,35},{8,30},{48,0},{49,0}]',136275),(85,'[{1,2015},{2,39725},{3,913},{4,719},{5,132},{6,126},{7,35},{8,30},{48,0},{49,0}]',136975),(86,'[{1,2028},{2,39807},{3,913},{4,719},{5,132},{6,126},{7,35},{8,36},{48,0},{49,0}]',137617),(87,'[{1,2032},{2,39889},{3,915},{4,721},{5,132},{6,126},{7,35},{8,36},{48,0},{49,0}]',137879),(88,'[{1,2036},{2,39971},{3,917},{4,723},{5,132},{6,126},{7,35},{8,36},{48,0},{49,0}]',138141),(89,'[{1,2040},{2,40053},{3,919},{4,725},{5,132},{6,126},{7,35},{8,36},{48,0},{49,0}]',138403),(90,'[{1,2048},{2,40392},{3,923},{4,729},{5,132},{6,126},{7,35},{8,36},{48,0},{49,0}]',139102),(91,'[{1,2061},{2,40474},{3,923},{4,729},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',140644),(92,'[{1,2065},{2,40556},{3,925},{4,731},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',140906),(93,'[{1,2069},{2,40637},{3,927},{4,733},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',141167),(94,'[{1,2073},{2,40719},{3,930},{4,735},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',141454),(95,'[{1,2081},{2,41108},{3,934},{4,739},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',142203),(96,'[{1,2096},{2,41190},{3,934},{4,739},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',142585),(97,'[{1,2100},{2,41272},{3,936},{4,741},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',142847),(98,'[{1,2104},{2,41354},{3,938},{4,743},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',143109),(99,'[{1,2108},{2,41436},{3,940},{4,745},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',143371),(100,'[{1,2116},{2,64456},{3,944},{4,749},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',166751),(101,'[{1,3236},{2,64538},{3,944},{4,749},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',189233),(102,'[{1,3240},{2,64620},{3,946},{4,751},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',189495),(103,'[{1,3244},{2,64701},{3,948},{4,753},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',189756),(104,'[{1,3248},{2,64783},{3,951},{4,755},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',190043),(105,'[{1,3252},{2,64865},{3,953},{4,757},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',190305),(106,'[{1,3256},{2,64947},{3,955},{4,759},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',190567),(107,'[{1,3260},{2,65029},{3,957},{4,761},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',190829),(108,'[{1,3264},{2,65111},{3,959},{4,763},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',191091),(109,'[{1,3268},{2,65193},{3,961},{4,765},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',191353),(110,'[{1,3272},{2,65275},{3,963},{4,767},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',191615),(111,'[{1,3276},{2,65357},{3,965},{4,769},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',191877),(112,'[{1,3280},{2,65439},{3,967},{4,771},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',192139),(113,'[{1,3284},{2,65521},{3,969},{4,773},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',192401),(114,'[{1,3292},{2,63555},{3,974},{4,777},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',190820),(115,'[{1,3292},{2,63636},{3,974},{4,777},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',190901),(116,'[{1,3296},{2,63718},{3,976},{4,779},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',191163),(117,'[{1,3300},{2,63800},{3,978},{4,781},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',191425),(118,'[{1,3304},{2,63882},{3,980},{4,783},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',191687),(119,'[{1,3308},{2,63964},{3,982},{4,785},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',191949),(120,'[{1,3312},{2,64046},{3,984},{4,787},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',192211),(121,'[{1,3316},{2,64128},{3,986},{4,789},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',192473),(122,'[{1,3320},{2,64210},{3,988},{4,791},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',192735),(123,'[{1,3324},{2,64292},{3,990},{4,793},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',192997),(124,'[{1,3328},{2,64374},{3,992},{4,795},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',193259),(125,'[{1,3332},{2,64456},{3,995},{4,797},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',193546),(126,'[{1,3336},{2,64538},{3,997},{4,799},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',193808),(127,'[{1,3340},{2,64620},{3,999},{4,801},{5,137},{6,131},{7,42},{8,43},{48,0},{49,0}]',194070),(128,'[{1,3345},{2,64628},{3,1025},{4,814},{5,134},{6,127},{7,41},{8,42},{48,0},{49,0}]',194871),(129,'[{1,3350},{2,64637},{3,1052},{4,828},{5,131},{6,124},{7,41},{8,41},{48,0},{49,0}]',195673),(130,'[{1,3356},{2,64646},{3,1078},{4,841},{5,129},{6,121},{7,41},{8,41},{48,0},{49,0}]',196474),(131,'[{1,3361},{2,64655},{3,1105},{4,855},{5,126},{6,118},{7,40},{8,40},{48,0},{49,0}]',197275),(132,'[{1,3367},{2,64664},{3,1131},{4,868},{5,124},{6,115},{7,40},{8,40},{48,0},{49,0}]',198076),(133,'[{1,3372},{2,64673},{3,1158},{4,882},{5,121},{6,112},{7,40},{8,39},{48,0},{49,0}]',198878),(134,'[{1,3378},{2,64682},{3,1184},{4,895},{5,119},{6,109},{7,39},{8,39},{48,0},{49,0}]',199679),(135,'[{1,3383},{2,64690},{3,1211},{4,909},{5,116},{6,106},{7,39},{8,38},{48,0},{49,0}]',200480),(136,'[{1,3388},{2,64699},{3,1238},{4,923},{5,114},{6,103},{7,39},{8,38},{48,0},{49,0}]',201281),(137,'[{1,3394},{2,64708},{3,1264},{4,936},{5,111},{6,100},{7,38},{8,37},{48,0},{49,0}]',202083),(138,'[{1,3399},{2,64717},{3,1291},{4,950},{5,109},{6,97},{7,38},{8,37},{48,0},{49,0}]',202884),(139,'[{1,3405},{2,64726},{3,1317},{4,963},{5,106},{6,94},{7,38},{8,36},{48,0},{49,0}]',203685),(140,'[{1,3410},{2,64735},{3,1344},{4,977},{5,104},{6,91},{7,38},{8,36},{48,0},{49,0}]',204486),(141,'[{1,3416},{2,64744},{3,1370},{4,990},{5,101},{6,88},{7,37},{8,35},{48,0},{49,0}]',205288),(142,'[{1,3421},{2,64753},{3,1397},{4,1004},{5,99},{6,85},{7,37},{8,35},{48,0},{49,0}]',206089),(143,'[{1,3426},{2,64761},{3,1424},{4,1018},{5,96},{6,82},{7,37},{8,34},{48,0},{49,0}]',206890),(144,'[{1,3432},{2,64770},{3,1450},{4,1031},{5,94},{6,79},{7,36},{8,34},{48,0},{49,0}]',207691),(145,'[{1,3437},{2,64779},{3,1477},{4,1045},{5,91},{6,76},{7,36},{8,33},{48,0},{49,0}]',208493),(146,'[{1,3443},{2,64788},{3,1503},{4,1058},{5,89},{6,73},{7,36},{8,33},{48,0},{49,0}]',209294),(147,'[{1,3448},{2,64797},{3,1530},{4,1072},{5,86},{6,70},{7,35},{8,32},{48,0},{49,0}]',210095),(148,'[{1,3454},{2,64806},{3,1556},{4,1085},{5,84},{6,67},{7,35},{8,32},{48,0},{49,0}]',210896),(149,'[{1,3459},{2,64815},{3,1583},{4,1099},{5,81},{6,64},{7,35},{8,31},{48,0},{49,0}]',211698),(150,'[{1,3465},{2,64824},{3,1610},{4,1113},{5,79},{6,61},{7,35},{8,31},{48,0},{49,0}]',212499),(151,'[{1,3825},{2,64866},{3,1798},{4,1293},{5,79},{6,61},{7,35},{8,31},{48,0},{49,0}]',228941),(152,'[{1,3827},{2,64908},{3,1799},{4,1294},{5,79},{6,61},{7,35},{8,31},{48,0},{49,0}]',229073),(153,'[{1,3829},{2,64950},{3,1800},{4,1295},{5,79},{6,61},{7,35},{8,31},{48,0},{49,0}]',229205),(154,'[{1,3831},{2,64992},{3,1802},{4,1296},{5,79},{6,61},{7,35},{8,31},{48,0},{49,0}]',229362),(155,'[{1,3833},{2,65034},{3,1803},{4,1297},{5,79},{6,61},{7,35},{8,31},{48,0},{49,0}]',229494),(156,'[{1,3835},{2,65076},{3,1804},{4,1298},{5,79},{6,61},{7,35},{8,31},{48,0},{49,0}]',229626),(157,'[{1,3837},{2,65117},{3,1805},{4,1299},{5,79},{6,61},{7,35},{8,31},{48,0},{49,0}]',229757),(158,'[{1,3839},{2,65159},{3,1806},{4,1300},{5,79},{6,61},{7,35},{8,31},{48,0},{49,0}]',229889),(159,'[{1,3841},{2,65201},{3,1807},{4,1301},{5,79},{6,61},{7,35},{8,31},{48,0},{49,0}]',230021),(160,'[{1,3843},{2,65243},{3,1808},{4,1302},{5,79},{6,61},{7,35},{8,31},{48,0},{49,0}]',230153),(161,'[{1,3845},{2,65285},{3,1809},{4,1303},{5,79},{6,61},{7,35},{8,31},{48,0},{49,0}]',230285),(162,'[{1,3847},{2,65327},{3,1810},{4,1304},{5,79},{6,61},{7,35},{8,31},{48,0},{49,0}]',230417),(163,'[{1,3850},{2,65369},{3,1811},{4,1305},{5,79},{6,61},{7,35},{8,31},{48,0},{49,0}]',230569),(164,'[{1,3852},{2,65411},{3,1812},{4,1306},{5,79},{6,61},{7,35},{8,31},{48,0},{49,0}]',230701),(165,'[{1,3854},{2,65453},{3,1813},{4,1307},{5,79},{6,61},{7,35},{8,31},{48,0},{49,0}]',230833),(166,'[{1,3856},{2,65495},{3,1814},{4,1308},{5,79},{6,61},{7,35},{8,31},{48,0},{49,0}]',230965),(167,'[{1,3899},{2,69666},{3,1828},{4,1414},{5,80},{6,63},{7,37},{8,32},{48,2},{49,6}]',239536),(168,'[{1,3943},{2,73837},{3,1843},{4,1520},{5,82},{6,65},{7,38},{8,34},{48,4},{49,12}]',248202),(169,'[{1,3986},{2,78008},{3,1857},{4,1625},{5,83},{6,67},{7,40},{8,35},{48,6},{49,18}]',256748),(170,'[{1,4029},{2,82179},{3,1872},{4,1731},{5,85},{6,70},{7,41},{8,36},{48,8},{49,25}]',265424),(171,'[{1,4072},{2,86350},{3,1886},{4,1837},{5,86},{6,72},{7,43},{8,37},{48,9},{49,31}]',273965),(172,'[{1,4116},{2,90521},{3,1900},{4,1943},{5,87},{6,74},{7,45},{8,39},{48,11},{49,37}]',282606),(173,'[{1,4159},{2,94691},{3,1915},{4,2048},{5,89},{6,76},{7,46},{8,40},{48,13},{49,43}]',291176),(174,'[{1,4202},{2,98862},{3,1929},{4,2154},{5,90},{6,78},{7,48},{8,41},{48,15},{49,49}]',299747),(175,'[{1,4246},{2,103033},{3,1943},{4,2260},{5,91},{6,80},{7,49},{8,42},{48,17},{49,55}]',308288),(176,'[{1,4289},{2,107204},{3,1958},{4,2366},{5,93},{6,82},{7,51},{8,44},{48,19},{49,61}]',316984),(177,'[{1,4332},{2,111375},{3,1972},{4,2471},{5,94},{6,84},{7,52},{8,45},{48,21},{49,67}]',325480),(178,'[{1,4376},{2,115546},{3,1987},{4,2577},{5,96},{6,87},{7,54},{8,46},{48,23},{49,74}]',334226),(179,'[{1,4419},{2,119717},{3,2001},{4,2683},{5,97},{6,89},{7,56},{8,47},{48,24},{49,80}]',342767),(180,'[{1,4462},{2,123888},{3,2015},{4,2789},{5,98},{6,91},{7,57},{8,49},{48,26},{49,86}]',351338),(181,'[{1,4505},{2,128059},{3,2030},{4,2894},{5,100},{6,93},{7,59},{8,50},{48,28},{49,92}]',359959),(182,'[{1,4549},{2,132230},{3,2044},{4,3000},{5,101},{6,95},{7,60},{8,51},{48,30},{49,98}]',368500),(183,'[{1,4592},{2,136401},{3,2058},{4,3106},{5,102},{6,97},{7,62},{8,52},{48,32},{49,104}]',377071),(184,'[{1,4635},{2,140572},{3,2073},{4,3212},{5,104},{6,99},{7,64},{8,54},{48,34},{49,110}]',385767),(185,'[{1,4679},{2,144742},{3,2087},{4,3317},{5,105},{6,101},{7,65},{8,55},{48,36},{49,116}]',394282),(186,'[{1,4722},{2,148913},{3,2102},{4,3423},{5,107},{6,104},{7,67},{8,56},{48,38},{49,123}]',403008),(187,'[{1,4765},{2,153084},{3,2116},{4,3529},{5,108},{6,106},{7,68},{8,57},{48,39},{49,129}]',411499),(188,'[{1,4808},{2,157255},{3,2130},{4,3635},{5,109},{6,108},{7,70},{8,59},{48,41},{49,135}]',420120),(189,'[{1,4852},{2,161426},{3,2145},{4,3740},{5,111},{6,110},{7,71},{8,60},{48,43},{49,141}]',428711),(190,'[{1,4895},{2,165597},{3,2159},{4,3846},{5,112},{6,112},{7,73},{8,61},{48,45},{49,147}]',437282),(191,'[{1,5006},{2,168756},{3,2200},{4,3911},{5,113},{6,113},{7,77},{8,65},{48,60},{49,150}]',446506),(192,'[{1,5117},{2,171915},{3,2242},{4,3976},{5,114},{6,114},{7,81},{8,69},{48,76},{49,154}]',455730),(193,'[{1,5228},{2,175075},{3,2284},{4,4041},{5,116},{6,116},{7,85},{8,73},{48,92},{49,158}]',464954),(194,'[{1,5339},{2,178234},{3,2326},{4,4107},{5,117},{6,117},{7,90},{8,77},{48,108},{49,162}]',474178),(195,'[{1,5450},{2,181393},{3,2368},{4,4172},{5,119},{6,119},{7,94},{8,82},{48,123},{49,166}]',483401),(196,'[{1,5561},{2,184553},{3,2410},{4,4237},{5,120},{6,120},{7,98},{8,86},{48,139},{49,170}]',492625),(197,'[{1,5672},{2,187712},{3,2452},{4,4303},{5,122},{6,122},{7,103},{8,90},{48,155},{49,174}]',501849),(198,'[{1,5783},{2,190872},{3,2494},{4,4368},{5,123},{6,123},{7,107},{8,94},{48,171},{49,178}]',511073),(199,'[{1,5894},{2,194031},{3,2535},{4,4433},{5,125},{6,125},{7,111},{8,99},{48,186},{49,182}]',520297),(200,'[{1,6005},{2,197190},{3,2577},{4,4499},{5,126},{6,126},{7,116},{8,103},{48,202},{49,186}]',529521),(201,'[{1,6116},{2,200350},{3,2619},{4,4564},{5,127},{6,127},{7,120},{8,107},{48,218},{49,190}]',538745),(202,'[{1,6227},{2,203509},{3,2661},{4,4629},{5,129},{6,129},{7,124},{8,111},{48,234},{49,194}]',547969),(203,'[{1,6338},{2,206668},{3,2703},{4,4695},{5,130},{6,130},{7,129},{8,115},{48,249},{49,198}]',557192),(204,'[{1,6449},{2,209828},{3,2745},{4,4760},{5,132},{6,132},{7,133},{8,120},{48,265},{49,202}]',566416),(205,'[{1,6560},{2,212987},{3,2787},{4,4825},{5,133},{6,133},{7,137},{8,124},{48,281},{49,206}]',575640),(206,'[{1,6671},{2,216147},{3,2829},{4,4891},{5,135},{6,135},{7,142},{8,128},{48,297},{49,210}]',584864),(207,'[{1,6782},{2,219306},{3,2870},{4,4956},{5,136},{6,136},{7,146},{8,132},{48,312},{49,214}]',594088),(208,'[{1,6893},{2,222465},{3,2912},{4,5021},{5,138},{6,138},{7,150},{8,137},{48,328},{49,218}]',603312),(209,'[{1,7004},{2,225625},{3,2954},{4,5087},{5,139},{6,139},{7,155},{8,141},{48,344},{49,222}]',612536),(210,'[{1,7116},{2,228784},{3,2996},{4,5152},{5,141},{6,141},{7,159},{8,145},{48,360},{49,226}]',621760),(211,'[{1,7227},{2,231943},{3,3038},{4,5217},{5,142},{6,142},{7,163},{8,149},{48,375},{49,229}]',630983),(212,'[{1,7338},{2,235103},{3,3080},{4,5283},{5,143},{6,143},{7,168},{8,153},{48,391},{49,233}]',640207),(213,'[{1,7449},{2,238262},{3,3122},{4,5348},{5,145},{6,145},{7,172},{8,158},{48,407},{49,237}]',649431),(214,'[{1,7560},{2,241422},{3,3164},{4,5413},{5,146},{6,146},{7,176},{8,162},{48,423},{49,241}]',658655),(215,'[{1,7671},{2,244581},{3,3205},{4,5479},{5,148},{6,148},{7,181},{8,166},{48,438},{49,245}]',667879),(216,'[{1,7782},{2,247740},{3,3247},{4,5544},{5,149},{6,149},{7,185},{8,170},{48,454},{49,249}]',677103),(217,'[{1,7893},{2,250900},{3,3289},{4,5609},{5,151},{6,151},{7,189},{8,175},{48,470},{49,253}]',686327),(218,'[{1,8004},{2,254059},{3,3331},{4,5675},{5,152},{6,152},{7,194},{8,179},{48,486},{49,257}]',695551),(219,'[{1,8115},{2,257218},{3,3373},{4,5740},{5,154},{6,154},{7,198},{8,183},{48,501},{49,261}]',704774),(220,'[{1,8226},{2,260378},{3,3415},{4,5805},{5,155},{6,155},{7,202},{8,187},{48,517},{49,265}]',713998),(221,'[{1,8337},{2,263537},{3,3457},{4,5871},{5,156},{6,156},{7,207},{8,191},{48,533},{49,269}]',723222),(222,'[{1,8448},{2,266697},{3,3499},{4,5936},{5,158},{6,158},{7,211},{8,196},{48,549},{49,273}]',732446),(223,'[{1,8559},{2,269856},{3,3540},{4,6001},{5,159},{6,159},{7,215},{8,200},{48,564},{49,277}]',741670),(224,'[{1,8670},{2,273015},{3,3582},{4,6067},{5,161},{6,161},{7,220},{8,204},{48,580},{49,281}]',750894),(225,'[{1,8781},{2,276175},{3,3624},{4,6132},{5,162},{6,162},{7,224},{8,208},{48,596},{49,285}]',760118),(226,'[{1,8892},{2,279334},{3,3666},{4,6197},{5,164},{6,164},{7,228},{8,213},{48,612},{49,289}]',769341),(227,'[{1,9003},{2,282493},{3,3708},{4,6263},{5,165},{6,165},{7,233},{8,217},{48,627},{49,293}]',778565),(228,'[{1,9114},{2,285653},{3,3750},{4,6328},{5,167},{6,167},{7,237},{8,221},{48,643},{49,297}]',787789),(229,'[{1,9225},{2,288812},{3,3792},{4,6393},{5,168},{6,168},{7,241},{8,225},{48,659},{49,301}]',797013),(230,'[{1,9337},{2,291972},{3,3834},{4,6459},{5,170},{6,170},{7,246},{8,230},{48,675},{49,305}]',806237),(231,'[{1,9616},{2,299805},{3,3966},{4,6647},{5,180},{6,180},{7,258},{8,241},{48,675},{49,313}]',830228),(232,'[{1,9896},{2,307638},{3,4099},{4,6835},{5,191},{6,191},{7,271},{8,253},{48,675},{49,322}]',854219),(233,'[{1,10176},{2,315471},{3,4231},{4,7023},{5,201},{6,201},{7,283},{8,265},{48,675},{49,331}]',878209),(234,'[{1,10456},{2,323304},{3,4364},{4,7211},{5,212},{6,212},{7,296},{8,277},{48,675},{49,340}]',902200),(235,'[{1,10735},{2,331137},{3,4496},{4,7399},{5,223},{6,223},{7,308},{8,289},{48,675},{49,349}]',926191),(236,'[{1,11015},{2,338970},{3,4629},{4,7587},{5,233},{6,233},{7,321},{8,301},{48,675},{49,357}]',950182),(237,'[{1,11295},{2,346803},{3,4761},{4,7775},{5,244},{6,244},{7,333},{8,313},{48,675},{49,366}]',974172),(238,'[{1,11575},{2,354636},{3,4894},{4,7963},{5,254},{6,254},{7,346},{8,325},{48,675},{49,375}]',998163),(239,'[{1,11854},{2,362469},{3,5026},{4,8151},{5,265},{6,265},{7,358},{8,337},{48,675},{49,384}]',1022154),(240,'[{1,12134},{2,370302},{3,5159},{4,8340},{5,276},{6,276},{7,371},{8,349},{48,675},{49,393}]',1046145),(241,'[{1,12414},{2,378135},{3,5292},{4,8528},{5,286},{6,286},{7,384},{8,360},{48,675},{49,401}]',1070135),(242,'[{1,12694},{2,385968},{3,5424},{4,8716},{5,297},{6,297},{7,396},{8,372},{48,675},{49,410}]',1094126),(243,'[{1,12973},{2,393801},{3,5557},{4,8904},{5,307},{6,307},{7,409},{8,384},{48,675},{49,419}]',1118117),(244,'[{1,13253},{2,401634},{3,5689},{4,9092},{5,318},{6,318},{7,421},{8,396},{48,675},{49,428}]',1142108),(245,'[{1,13533},{2,409467},{3,5822},{4,9280},{5,329},{6,329},{7,434},{8,408},{48,675},{49,437}]',1166098),(246,'[{1,13813},{2,417300},{3,5954},{4,9468},{5,339},{6,339},{7,446},{8,420},{48,675},{49,445}]',1190089),(247,'[{1,14092},{2,425133},{3,6087},{4,9656},{5,350},{6,350},{7,459},{8,432},{48,675},{49,454}]',1214080),(248,'[{1,14372},{2,432966},{3,6219},{4,9844},{5,360},{6,360},{7,471},{8,444},{48,675},{49,463}]',1238071),(249,'[{1,14652},{2,440799},{3,6352},{4,10032},{5,371},{6,371},{7,484},{8,456},{48,675},{49,472}]',1262061),(250,'[{1,14932},{2,448632},{3,6485},{4,10221},{5,382},{6,382},{7,497},{8,468},{48,675},{49,481}]',1286052),(251,'[{1,15139},{2,456245},{3,6568},{4,10390},{5,391},{6,391},{7,508},{8,479},{48,693},{49,486}]',1306976),(252,'[{1,15346},{2,463858},{3,6652},{4,10559},{5,401},{6,401},{7,520},{8,491},{48,712},{49,491}]',1327900),(253,'[{1,15553},{2,471471},{3,6735},{4,10729},{5,410},{6,410},{7,531},{8,503},{48,731},{49,496}]',1348824),(254,'[{1,15760},{2,479084},{3,6819},{4,10898},{5,420},{6,420},{7,543},{8,515},{48,750},{49,501}]',1369748),(255,'[{1,15967},{2,486697},{3,6903},{4,11067},{5,430},{6,430},{7,554},{8,526},{48,769},{49,506}]',1390672),(256,'[{1,16174},{2,494310},{3,6986},{4,11237},{5,439},{6,439},{7,566},{8,538},{48,788},{49,511}]',1411596),(257,'[{1,16381},{2,501923},{3,7070},{4,11406},{5,449},{6,449},{7,577},{8,550},{48,807},{49,517}]',1432520),(258,'[{1,16588},{2,509536},{3,7153},{4,11575},{5,458},{6,458},{7,589},{8,562},{48,826},{49,522}]',1453444),(259,'[{1,16795},{2,517149},{3,7237},{4,11745},{5,468},{6,468},{7,600},{8,574},{48,845},{49,527}]',1474368),(260,'[{1,17002},{2,524762},{3,7321},{4,11914},{5,478},{6,478},{7,612},{8,585},{48,864},{49,532}]',1495292),(261,'[{1,17209},{2,532375},{3,7404},{4,12083},{5,487},{6,487},{7,623},{8,597},{48,882},{49,537}]',1516216),(262,'[{1,17416},{2,539988},{3,7488},{4,12253},{5,497},{6,497},{7,635},{8,609},{48,901},{49,542}]',1537140),(263,'[{1,17623},{2,547601},{3,7572},{4,12422},{5,506},{6,506},{7,646},{8,621},{48,920},{49,548}]',1558064),(264,'[{1,17830},{2,555214},{3,7655},{4,12591},{5,516},{6,516},{7,658},{8,632},{48,939},{49,553}]',1578988),(265,'[{1,18037},{2,562827},{3,7739},{4,12761},{5,526},{6,526},{7,669},{8,644},{48,958},{49,558}]',1599912),(266,'[{1,18244},{2,570440},{3,7822},{4,12930},{5,535},{6,535},{7,681},{8,656},{48,977},{49,563}]',1620836),(267,'[{1,18452},{2,578053},{3,7906},{4,13099},{5,545},{6,545},{7,692},{8,668},{48,996},{49,568}]',1641760),(268,'[{1,18659},{2,585666},{3,7990},{4,13269},{5,554},{6,554},{7,704},{8,680},{48,1015},{49,573}]',1662684),(269,'[{1,18866},{2,593279},{3,8073},{4,13438},{5,564},{6,564},{7,715},{8,691},{48,1034},{49,579}]',1683608),(270,'[{1,19073},{2,600892},{3,8157},{4,13607},{5,574},{6,574},{7,727},{8,703},{48,1053},{49,584}]',1704532),(271,'[{1,19280},{2,608505},{3,8241},{4,13777},{5,583},{6,583},{7,738},{8,715},{48,1071},{49,589}]',1725456),(272,'[{1,19487},{2,616118},{3,8324},{4,13946},{5,593},{6,593},{7,750},{8,727},{48,1090},{49,594}]',1746380),(273,'[{1,19694},{2,623731},{3,8408},{4,14115},{5,602},{6,602},{7,761},{8,738},{48,1109},{49,599}]',1767304),(274,'[{1,19901},{2,631344},{3,8491},{4,14285},{5,612},{6,612},{7,773},{8,750},{48,1128},{49,604}]',1788228),(275,'[{1,20108},{2,638957},{3,8575},{4,14454},{5,622},{6,622},{7,784},{8,762},{48,1147},{49,610}]',1809152),(276,'[{1,20315},{2,646570},{3,8659},{4,14623},{5,631},{6,631},{7,796},{8,774},{48,1166},{49,615}]',1830076),(277,'[{1,20522},{2,654183},{3,8742},{4,14793},{5,641},{6,641},{7,807},{8,786},{48,1185},{49,620}]',1851000),(278,'[{1,20729},{2,661796},{3,8826},{4,14962},{5,650},{6,650},{7,819},{8,797},{48,1204},{49,625}]',1871924),(279,'[{1,20936},{2,669409},{3,8909},{4,15131},{5,660},{6,660},{7,830},{8,809},{48,1223},{49,630}]',1892848),(280,'[{1,21143},{2,677022},{3,8993},{4,15301},{5,670},{6,670},{7,842},{8,821},{48,1242},{49,635}]',1913772),(281,'[{1,21350},{2,684635},{3,9077},{4,15470},{5,679},{6,679},{7,853},{8,833},{48,1260},{49,640}]',1934696),(282,'[{1,21557},{2,692248},{3,9160},{4,15639},{5,689},{6,689},{7,865},{8,844},{48,1279},{49,646}]',1955620),(283,'[{1,21764},{2,699861},{3,9244},{4,15809},{5,698},{6,698},{7,876},{8,856},{48,1298},{49,651}]',1976544),(284,'[{1,21972},{2,707474},{3,9328},{4,15978},{5,708},{6,708},{7,888},{8,868},{48,1317},{49,656}]',1997468),(285,'[{1,22179},{2,715087},{3,9411},{4,16147},{5,718},{6,718},{7,899},{8,880},{48,1336},{49,661}]',2018392),(286,'[{1,22386},{2,722700},{3,9495},{4,16317},{5,727},{6,727},{7,911},{8,892},{48,1355},{49,666}]',2039316),(287,'[{1,22593},{2,730313},{3,9578},{4,16486},{5,737},{6,737},{7,922},{8,903},{48,1374},{49,671}]',2060240),(288,'[{1,22800},{2,737926},{3,9662},{4,16655},{5,746},{6,746},{7,934},{8,915},{48,1393},{49,677}]',2081164),(289,'[{1,23007},{2,745539},{3,9746},{4,16825},{5,756},{6,756},{7,945},{8,927},{48,1412},{49,682}]',2102088),(290,'[{1,23214},{2,753152},{3,9829},{4,16994},{5,766},{6,766},{7,957},{8,939},{48,1431},{49,687}]',2123012),(291,'[{1,23421},{2,760765},{3,9913},{4,17163},{5,775},{6,775},{7,968},{8,950},{48,1449},{49,692}]',2143936),(292,'[{1,23628},{2,768378},{3,9997},{4,17333},{5,785},{6,785},{7,980},{8,962},{48,1468},{49,697}]',2164860),(293,'[{1,23835},{2,775991},{3,10080},{4,17502},{5,794},{6,794},{7,991},{8,974},{48,1487},{49,702}]',2185784),(294,'[{1,24042},{2,783604},{3,10164},{4,17671},{5,804},{6,804},{7,1003},{8,986},{48,1506},{49,708}]',2206708),(295,'[{1,24249},{2,791217},{3,10247},{4,17841},{5,814},{6,814},{7,1014},{8,998},{48,1525},{49,713}]',2227632),(296,'[{1,24456},{2,798830},{3,10331},{4,18010},{5,823},{6,823},{7,1026},{8,1009},{48,1544},{49,718}]',2248556),(297,'[{1,24663},{2,806443},{3,10415},{4,18179},{5,833},{6,833},{7,1037},{8,1021},{48,1563},{49,723}]',2269480),(298,'[{1,24870},{2,814056},{3,10498},{4,18349},{5,842},{6,842},{7,1049},{8,1033},{48,1582},{49,728}]',2290404),(299,'[{1,25077},{2,821669},{3,10582},{4,18518},{5,852},{6,852},{7,1060},{8,1045},{48,1601},{49,733}]',2311328),(300,'[{1,25285},{2,829282},{3,10666},{4,18688},{5,862},{6,862},{7,1072},{8,1057},{48,1620},{49,739}]',2332252),(301,'[{1,25643},{2,838045},{3,10840},{4,18870},{5,877},{6,877},{7,1078},{8,1063},{48,1620},{49,747}]',2359569),(302,'[{1,26002},{2,846809},{3,11014},{4,19052},{5,893},{6,893},{7,1085},{8,1069},{48,1620},{49,755}]',2386887),(303,'[{1,26361},{2,855572},{3,11188},{4,19234},{5,908},{6,908},{7,1091},{8,1076},{48,1620},{49,763}]',2414204),(304,'[{1,26720},{2,864336},{3,11362},{4,19416},{5,924},{6,924},{7,1098},{8,1082},{48,1620},{49,772}]',2441521),(305,'[{1,27079},{2,873100},{3,11536},{4,19598},{5,940},{6,940},{7,1105},{8,1089},{48,1620},{49,780}]',2468838),(306,'[{1,27438},{2,881863},{3,11711},{4,19780},{5,955},{6,955},{7,1111},{8,1095},{48,1620},{49,788}]',2496156),(307,'[{1,27797},{2,890627},{3,11885},{4,19962},{5,971},{6,971},{7,1118},{8,1102},{48,1620},{49,796}]',2523473),(308,'[{1,28156},{2,899391},{3,12059},{4,20144},{5,987},{6,987},{7,1125},{8,1108},{48,1620},{49,805}]',2550790),(309,'[{1,28515},{2,908154},{3,12233},{4,20326},{5,1002},{6,1002},{7,1131},{8,1115},{48,1620},{49,813}]',2578107),(310,'[{1,28874},{2,916918},{3,12407},{4,20508},{5,1018},{6,1018},{7,1138},{8,1121},{48,1620},{49,821}]',2605425),(311,'[{1,29233},{2,925682},{3,12581},{4,20690},{5,1034},{6,1034},{7,1145},{8,1128},{48,1620},{49,830}]',2632742),(312,'[{1,29592},{2,934445},{3,12756},{4,20872},{5,1049},{6,1049},{7,1151},{8,1134},{48,1620},{49,838}]',2660059),(313,'[{1,29951},{2,943209},{3,12930},{4,21054},{5,1065},{6,1065},{7,1158},{8,1140},{48,1620},{49,846}]',2687376),(314,'[{1,30310},{2,951973},{3,13104},{4,21236},{5,1080},{6,1080},{7,1165},{8,1147},{48,1620},{49,854}]',2714694),(315,'[{1,30669},{2,960736},{3,13278},{4,21418},{5,1096},{6,1096},{7,1171},{8,1153},{48,1620},{49,863}]',2742011),(316,'[{1,31028},{2,969500},{3,13452},{4,21600},{5,1112},{6,1112},{7,1178},{8,1160},{48,1620},{49,871}]',2769328),(317,'[{1,31387},{2,978264},{3,13627},{4,21783},{5,1127},{6,1127},{7,1185},{8,1166},{48,1620},{49,879}]',2796645),(318,'[{1,31746},{2,987027},{3,13801},{4,21965},{5,1143},{6,1143},{7,1191},{8,1173},{48,1620},{49,888}]',2823963),(319,'[{1,32105},{2,995791},{3,13975},{4,22147},{5,1159},{6,1159},{7,1198},{8,1179},{48,1620},{49,896}]',2851280),(320,'[{1,32464},{2,1004555},{3,14149},{4,22329},{5,1174},{6,1174},{7,1205},{8,1186},{48,1620},{49,904}]',2878597),(321,'[{1,32823},{2,1013318},{3,14323},{4,22511},{5,1190},{6,1190},{7,1211},{8,1192},{48,1620},{49,912}]',2905914),(322,'[{1,33182},{2,1022082},{3,14497},{4,22693},{5,1206},{6,1206},{7,1218},{8,1199},{48,1620},{49,921}]',2933232),(323,'[{1,33541},{2,1030846},{3,14672},{4,22875},{5,1221},{6,1221},{7,1225},{8,1205},{48,1620},{49,929}]',2960549),(324,'[{1,33900},{2,1039609},{3,14846},{4,23057},{5,1237},{6,1237},{7,1231},{8,1212},{48,1620},{49,937}]',2987866),(325,'[{1,34259},{2,1048373},{3,15020},{4,23239},{5,1253},{6,1253},{7,1238},{8,1218},{48,1620},{49,945}]',3015184),(326,'[{1,34617},{2,1057137},{3,15194},{4,23421},{5,1268},{6,1268},{7,1245},{8,1224},{48,1620},{49,954}]',3042501),(327,'[{1,34976},{2,1065900},{3,15368},{4,23603},{5,1284},{6,1284},{7,1251},{8,1231},{48,1620},{49,962}]',3069818),(328,'[{1,35335},{2,1074664},{3,15543},{4,23785},{5,1299},{6,1299},{7,1258},{8,1237},{48,1620},{49,970}]',3097135),(329,'[{1,35694},{2,1083428},{3,15717},{4,23967},{5,1315},{6,1315},{7,1265},{8,1244},{48,1620},{49,979}]',3124453),(330,'[{1,36053},{2,1092191},{3,15891},{4,24149},{5,1331},{6,1331},{7,1271},{8,1250},{48,1620},{49,987}]',3151770),(331,'[{1,36412},{2,1100955},{3,16065},{4,24331},{5,1346},{6,1346},{7,1278},{8,1257},{48,1620},{49,995}]',3179087),(332,'[{1,36771},{2,1109719},{3,16239},{4,24513},{5,1362},{6,1362},{7,1285},{8,1263},{48,1620},{49,1003}]',3206404),(333,'[{1,37130},{2,1118482},{3,16413},{4,24695},{5,1378},{6,1378},{7,1291},{8,1270},{48,1620},{49,1012}]',3233722),(334,'[{1,37489},{2,1127246},{3,16588},{4,24878},{5,1393},{6,1393},{7,1298},{8,1276},{48,1620},{49,1020}]',3261039),(335,'[{1,37848},{2,1136010},{3,16762},{4,25060},{5,1409},{6,1409},{7,1305},{8,1283},{48,1620},{49,1028}]',3288356),(336,'[{1,38207},{2,1144773},{3,16936},{4,25242},{5,1425},{6,1425},{7,1311},{8,1289},{48,1620},{49,1037}]',3315673),(337,'[{1,38566},{2,1153537},{3,17110},{4,25424},{5,1440},{6,1440},{7,1318},{8,1296},{48,1620},{49,1045}]',3342991),(338,'[{1,38925},{2,1162301},{3,17284},{4,25606},{5,1456},{6,1456},{7,1325},{8,1302},{48,1620},{49,1053}]',3370308),(339,'[{1,39284},{2,1171064},{3,17459},{4,25788},{5,1471},{6,1471},{7,1331},{8,1308},{48,1620},{49,1061}]',3397625),(340,'[{1,39643},{2,1179828},{3,17633},{4,25970},{5,1487},{6,1487},{7,1338},{8,1315},{48,1620},{49,1070}]',3424942),(341,'[{1,40002},{2,1188592},{3,17807},{4,26152},{5,1503},{6,1503},{7,1345},{8,1321},{48,1620},{49,1078}]',3452260),(342,'[{1,40361},{2,1197355},{3,17981},{4,26334},{5,1518},{6,1518},{7,1351},{8,1328},{48,1620},{49,1086}]',3479577),(343,'[{1,40720},{2,1206119},{3,18155},{4,26516},{5,1534},{6,1534},{7,1358},{8,1334},{48,1620},{49,1095}]',3506894),(344,'[{1,41079},{2,1214883},{3,18329},{4,26698},{5,1550},{6,1550},{7,1365},{8,1341},{48,1620},{49,1103}]',3534211),(345,'[{1,41438},{2,1223646},{3,18504},{4,26880},{5,1565},{6,1565},{7,1371},{8,1347},{48,1620},{49,1111}]',3561529),(346,'[{1,41797},{2,1232410},{3,18678},{4,27062},{5,1581},{6,1581},{7,1378},{8,1354},{48,1620},{49,1119}]',3588846),(347,'[{1,42156},{2,1241174},{3,18852},{4,27244},{5,1597},{6,1597},{7,1385},{8,1360},{48,1620},{49,1128}]',3616163),(348,'[{1,42515},{2,1249937},{3,19026},{4,27426},{5,1612},{6,1612},{7,1391},{8,1367},{48,1620},{49,1136}]',3643480),(349,'[{1,42874},{2,1258701},{3,19200},{4,27608},{5,1628},{6,1628},{7,1398},{8,1373},{48,1620},{49,1144}]',3670798),(350,'[{1,43233},{2,1267465},{3,19375},{4,27791},{5,1644},{6,1644},{7,1405},{8,1380},{48,1620},{49,1153}]',3698115),(351,'[{1,43787},{2,1278089},{3,19615},{4,28000},{5,1682},{6,1682},{7,1434},{8,1409},{48,1620},{49,1164}]',3738222),(352,'[{1,44341},{2,1288713},{3,19855},{4,28209},{5,1721},{6,1721},{7,1464},{8,1438},{48,1620},{49,1176}]',3778329),(353,'[{1,44896},{2,1299337},{3,20096},{4,28419},{5,1759},{6,1759},{7,1493},{8,1467},{48,1620},{49,1188}]',3818436),(354,'[{1,45450},{2,1309961},{3,20336},{4,28628},{5,1798},{6,1798},{7,1523},{8,1496},{48,1620},{49,1200}]',3858542),(355,'[{1,46005},{2,1320586},{3,20577},{4,28837},{5,1837},{6,1837},{7,1552},{8,1525},{48,1620},{49,1212}]',3898649),(356,'[{1,46559},{2,1331210},{3,20817},{4,29047},{5,1875},{6,1875},{7,1582},{8,1554},{48,1620},{49,1224}]',3938756),(357,'[{1,47113},{2,1341834},{3,21058},{4,29256},{5,1914},{6,1914},{7,1611},{8,1583},{48,1620},{49,1236}]',3978863),(358,'[{1,47668},{2,1352458},{3,21298},{4,29465},{5,1952},{6,1952},{7,1641},{8,1612},{48,1620},{49,1248}]',4018970),(359,'[{1,48222},{2,1363083},{3,21539},{4,29675},{5,1991},{6,1991},{7,1670},{8,1641},{48,1620},{49,1260}]',4059077),(360,'[{1,48777},{2,1373707},{3,21779},{4,29884},{5,2030},{6,2030},{7,1700},{8,1670},{48,1620},{49,1272}]',4099183),(361,'[{1,49331},{2,1384331},{3,22020},{4,30093},{5,2068},{6,2068},{7,1729},{8,1699},{48,1620},{49,1284}]',4139290),(362,'[{1,49886},{2,1394955},{3,22260},{4,30303},{5,2107},{6,2107},{7,1759},{8,1728},{48,1620},{49,1296}]',4179397),(363,'[{1,50440},{2,1405580},{3,22501},{4,30512},{5,2145},{6,2145},{7,1788},{8,1758},{48,1620},{49,1308}]',4219504),(364,'[{1,50994},{2,1416204},{3,22741},{4,30722},{5,2184},{6,2184},{7,1818},{8,1787},{48,1620},{49,1320}]',4259611),(365,'[{1,51549},{2,1426828},{3,22982},{4,30931},{5,2223},{6,2223},{7,1847},{8,1816},{48,1620},{49,1332}]',4299718),(366,'[{1,52103},{2,1437452},{3,23222},{4,31140},{5,2261},{6,2261},{7,1877},{8,1845},{48,1620},{49,1344}]',4339824),(367,'[{1,52658},{2,1448077},{3,23463},{4,31350},{5,2300},{6,2300},{7,1906},{8,1874},{48,1620},{49,1355}]',4379931),(368,'[{1,53212},{2,1458701},{3,23703},{4,31559},{5,2338},{6,2338},{7,1936},{8,1903},{48,1620},{49,1367}]',4420038),(369,'[{1,53766},{2,1469325},{3,23944},{4,31768},{5,2377},{6,2377},{7,1965},{8,1932},{48,1620},{49,1379}]',4460145),(370,'[{1,54321},{2,1479949},{3,24184},{4,31978},{5,2416},{6,2416},{7,1995},{8,1961},{48,1620},{49,1391}]',4500252),(371,'[{1,54875},{2,1490574},{3,24425},{4,32187},{5,2454},{6,2454},{7,2024},{8,1990},{48,1620},{49,1403}]',4540359),(372,'[{1,55430},{2,1501198},{3,24665},{4,32396},{5,2493},{6,2493},{7,2054},{8,2019},{48,1620},{49,1415}]',4580465),(373,'[{1,55984},{2,1511822},{3,24906},{4,32606},{5,2531},{6,2531},{7,2083},{8,2048},{48,1620},{49,1427}]',4620572),(374,'[{1,56539},{2,1522446},{3,25146},{4,32815},{5,2570},{6,2570},{7,2113},{8,2077},{48,1620},{49,1439}]',4660679),(375,'[{1,57093},{2,1533071},{3,25387},{4,33025},{5,2609},{6,2609},{7,2143},{8,2107},{48,1620},{49,1451}]',4700786),(376,'[{1,57647},{2,1543695},{3,25627},{4,33234},{5,2647},{6,2647},{7,2172},{8,2136},{48,1620},{49,1463}]',4740893),(377,'[{1,58202},{2,1554319},{3,25867},{4,33443},{5,2686},{6,2686},{7,2202},{8,2165},{48,1620},{49,1475}]',4781000),(378,'[{1,58756},{2,1564943},{3,26108},{4,33653},{5,2724},{6,2724},{7,2231},{8,2194},{48,1620},{49,1487}]',4821107),(379,'[{1,59311},{2,1575567},{3,26348},{4,33862},{5,2763},{6,2763},{7,2261},{8,2223},{48,1620},{49,1499}]',4861213),(380,'[{1,59865},{2,1586192},{3,26589},{4,34071},{5,2802},{6,2802},{7,2290},{8,2252},{48,1620},{49,1511}]',4901320),(381,'[{1,60420},{2,1596816},{3,26829},{4,34281},{5,2840},{6,2840},{7,2320},{8,2281},{48,1620},{49,1523}]',4941427),(382,'[{1,60974},{2,1607440},{3,27070},{4,34490},{5,2879},{6,2879},{7,2349},{8,2310},{48,1620},{49,1535}]',4981534),(383,'[{1,61528},{2,1618064},{3,27310},{4,34699},{5,2917},{6,2917},{7,2379},{8,2339},{48,1620},{49,1547}]',5021641),(384,'[{1,62083},{2,1628689},{3,27551},{4,34909},{5,2956},{6,2956},{7,2408},{8,2368},{48,1620},{49,1558}]',5061748),(385,'[{1,62637},{2,1639313},{3,27791},{4,35118},{5,2995},{6,2995},{7,2438},{8,2397},{48,1620},{49,1570}]',5101854),(386,'[{1,63192},{2,1649937},{3,28032},{4,35327},{5,3033},{6,3033},{7,2467},{8,2426},{48,1620},{49,1582}]',5141961),(387,'[{1,63746},{2,1660561},{3,28272},{4,35537},{5,3072},{6,3072},{7,2497},{8,2455},{48,1620},{49,1594}]',5182068),(388,'[{1,64300},{2,1671186},{3,28513},{4,35746},{5,3110},{6,3110},{7,2526},{8,2485},{48,1620},{49,1606}]',5222175),(389,'[{1,64855},{2,1681810},{3,28753},{4,35956},{5,3149},{6,3149},{7,2556},{8,2514},{48,1620},{49,1618}]',5262282),(390,'[{1,65409},{2,1692434},{3,28994},{4,36165},{5,3188},{6,3188},{7,2585},{8,2543},{48,1620},{49,1630}]',5302389),(391,'[{1,65964},{2,1703058},{3,29234},{4,36374},{5,3226},{6,3226},{7,2615},{8,2572},{48,1620},{49,1642}]',5342495),(392,'[{1,66518},{2,1713683},{3,29475},{4,36584},{5,3265},{6,3265},{7,2644},{8,2601},{48,1620},{49,1654}]',5382602),(393,'[{1,67073},{2,1724307},{3,29715},{4,36793},{5,3303},{6,3303},{7,2674},{8,2630},{48,1620},{49,1666}]',5422709),(394,'[{1,67627},{2,1734931},{3,29956},{4,37002},{5,3342},{6,3342},{7,2703},{8,2659},{48,1620},{49,1678}]',5462816),(395,'[{1,68181},{2,1745555},{3,30196},{4,37212},{5,3381},{6,3381},{7,2733},{8,2688},{48,1620},{49,1690}]',5502923),(396,'[{1,68736},{2,1756180},{3,30437},{4,37421},{5,3419},{6,3419},{7,2762},{8,2717},{48,1620},{49,1702}]',5543030),(397,'[{1,69290},{2,1766804},{3,30677},{4,37630},{5,3458},{6,3458},{7,2792},{8,2746},{48,1620},{49,1714}]',5583136),(398,'[{1,69845},{2,1777428},{3,30918},{4,37840},{5,3496},{6,3496},{7,2821},{8,2775},{48,1620},{49,1726}]',5623243),(399,'[{1,70399},{2,1788052},{3,31158},{4,38049},{5,3535},{6,3535},{7,2851},{8,2804},{48,1620},{49,1738}]',5663350),(400,'[{1,70954},{2,1798677},{3,31399},{4,38259},{5,3574},{6,3574},{7,2881},{8,2834},{48,1620},{49,1750}]',5703457),(401,'[{1,71395},{2,1809071},{3,31577},{4,38452},{5,3610},{6,3610},{7,2901},{8,2852},{48,1620},{49,1766}]',5738106),(402,'[{1,71837},{2,1819465},{3,31755},{4,38646},{5,3647},{6,3647},{7,2921},{8,2871},{48,1620},{49,1783}]',5772754),(403,'[{1,72278},{2,1829859},{3,31934},{4,38839},{5,3684},{6,3684},{7,2941},{8,2889},{48,1620},{49,1800}]',5807403),(404,'[{1,72720},{2,1840253},{3,32112},{4,39033},{5,3721},{6,3721},{7,2961},{8,2908},{48,1620},{49,1817}]',5842052),(405,'[{1,73162},{2,1850647},{3,32291},{4,39226},{5,3757},{6,3757},{7,2981},{8,2926},{48,1620},{49,1834}]',5876700),(406,'[{1,73603},{2,1861041},{3,32469},{4,39420},{5,3794},{6,3794},{7,3001},{8,2945},{48,1620},{49,1851}]',5911349),(407,'[{1,74045},{2,1871436},{3,32648},{4,39614},{5,3831},{6,3831},{7,3022},{8,2963},{48,1620},{49,1868}]',5945998),(408,'[{1,74486},{2,1881830},{3,32826},{4,39807},{5,3868},{6,3868},{7,3042},{8,2982},{48,1620},{49,1885}]',5980646),(409,'[{1,74928},{2,1892224},{3,33005},{4,40001},{5,3905},{6,3905},{7,3062},{8,3000},{48,1620},{49,1902}]',6015295),(410,'[{1,75370},{2,1902618},{3,33183},{4,40194},{5,3941},{6,3941},{7,3082},{8,3019},{48,1620},{49,1919}]',6049944),(411,'[{1,75811},{2,1913012},{3,33362},{4,40388},{5,3978},{6,3978},{7,3102},{8,3037},{48,1620},{49,1936}]',6084592),(412,'[{1,76253},{2,1923406},{3,33540},{4,40581},{5,4015},{6,4015},{7,3122},{8,3056},{48,1620},{49,1953}]',6119241),(413,'[{1,76695},{2,1933801},{3,33719},{4,40775},{5,4052},{6,4052},{7,3143},{8,3075},{48,1620},{49,1969}]',6153890),(414,'[{1,77136},{2,1944195},{3,33897},{4,40969},{5,4088},{6,4088},{7,3163},{8,3093},{48,1620},{49,1986}]',6188538),(415,'[{1,77578},{2,1954589},{3,34076},{4,41162},{5,4125},{6,4125},{7,3183},{8,3112},{48,1620},{49,2003}]',6223187),(416,'[{1,78019},{2,1964983},{3,34254},{4,41356},{5,4162},{6,4162},{7,3203},{8,3130},{48,1620},{49,2020}]',6257836),(417,'[{1,78461},{2,1975377},{3,34433},{4,41549},{5,4199},{6,4199},{7,3223},{8,3149},{48,1620},{49,2037}]',6292484),(418,'[{1,78903},{2,1985771},{3,34611},{4,41743},{5,4236},{6,4236},{7,3243},{8,3167},{48,1620},{49,2054}]',6327133),(419,'[{1,79344},{2,1996166},{3,34790},{4,41937},{5,4272},{6,4272},{7,3264},{8,3186},{48,1620},{49,2071}]',6361782),(420,'[{1,79786},{2,2006560},{3,34968},{4,42130},{5,4309},{6,4309},{7,3284},{8,3204},{48,1620},{49,2088}]',6396430),(421,'[{1,80228},{2,2016954},{3,35147},{4,42324},{5,4346},{6,4346},{7,3304},{8,3223},{48,1620},{49,2105}]',6431079),(422,'[{1,80669},{2,2027348},{3,35325},{4,42517},{5,4383},{6,4383},{7,3324},{8,3241},{48,1620},{49,2122}]',6465728),(423,'[{1,81111},{2,2037742},{3,35504},{4,42711},{5,4419},{6,4419},{7,3344},{8,3260},{48,1620},{49,2139}]',6500376),(424,'[{1,81552},{2,2048136},{3,35682},{4,42904},{5,4456},{6,4456},{7,3364},{8,3278},{48,1620},{49,2156}]',6535025),(425,'[{1,81994},{2,2058531},{3,35861},{4,43098},{5,4493},{6,4493},{7,3385},{8,3297},{48,1620},{49,2173}]',6569673),(426,'[{1,82436},{2,2068925},{3,36039},{4,43292},{5,4530},{6,4530},{7,3405},{8,3316},{48,1620},{49,2189}]',6604322),(427,'[{1,82877},{2,2079319},{3,36217},{4,43485},{5,4567},{6,4567},{7,3425},{8,3334},{48,1620},{49,2206}]',6638971),(428,'[{1,83319},{2,2089713},{3,36396},{4,43679},{5,4603},{6,4603},{7,3445},{8,3353},{48,1620},{49,2223}]',6673619),(429,'[{1,83760},{2,2100107},{3,36574},{4,43872},{5,4640},{6,4640},{7,3465},{8,3371},{48,1620},{49,2240}]',6708268),(430,'[{1,84202},{2,2110501},{3,36753},{4,44066},{5,4677},{6,4677},{7,3485},{8,3390},{48,1620},{49,2257}]',6742917),(431,'[{1,84644},{2,2120895},{3,36931},{4,44259},{5,4714},{6,4714},{7,3505},{8,3408},{48,1620},{49,2274}]',6777565),(432,'[{1,85085},{2,2131290},{3,37110},{4,44453},{5,4750},{6,4750},{7,3526},{8,3427},{48,1620},{49,2291}]',6812214),(433,'[{1,85527},{2,2141684},{3,37288},{4,44647},{5,4787},{6,4787},{7,3546},{8,3445},{48,1620},{49,2308}]',6846863),(434,'[{1,85969},{2,2152078},{3,37467},{4,44840},{5,4824},{6,4824},{7,3566},{8,3464},{48,1620},{49,2325}]',6881511),(435,'[{1,86410},{2,2162472},{3,37645},{4,45034},{5,4861},{6,4861},{7,3586},{8,3482},{48,1620},{49,2342}]',6916160),(436,'[{1,86852},{2,2172866},{3,37824},{4,45227},{5,4898},{6,4898},{7,3606},{8,3501},{48,1620},{49,2359}]',6950809),(437,'[{1,87293},{2,2183260},{3,38002},{4,45421},{5,4934},{6,4934},{7,3626},{8,3519},{48,1620},{49,2376}]',6985457),(438,'[{1,87735},{2,2193655},{3,38181},{4,45615},{5,4971},{6,4971},{7,3647},{8,3538},{48,1620},{49,2392}]',7020106),(439,'[{1,88177},{2,2204049},{3,38359},{4,45808},{5,5008},{6,5008},{7,3667},{8,3557},{48,1620},{49,2409}]',7054755),(440,'[{1,88618},{2,2214443},{3,38538},{4,46002},{5,5045},{6,5045},{7,3687},{8,3575},{48,1620},{49,2426}]',7089403),(441,'[{1,89060},{2,2224837},{3,38716},{4,46195},{5,5081},{6,5081},{7,3707},{8,3594},{48,1620},{49,2443}]',7124052),(442,'[{1,89502},{2,2235231},{3,38895},{4,46389},{5,5118},{6,5118},{7,3727},{8,3612},{48,1620},{49,2460}]',7158701),(443,'[{1,89943},{2,2245625},{3,39073},{4,46582},{5,5155},{6,5155},{7,3747},{8,3631},{48,1620},{49,2477}]',7193349),(444,'[{1,90385},{2,2256020},{3,39252},{4,46776},{5,5192},{6,5192},{7,3768},{8,3649},{48,1620},{49,2494}]',7227998),(445,'[{1,90826},{2,2266414},{3,39430},{4,46970},{5,5229},{6,5229},{7,3788},{8,3668},{48,1620},{49,2511}]',7262647),(446,'[{1,91268},{2,2276808},{3,39609},{4,47163},{5,5265},{6,5265},{7,3808},{8,3686},{48,1620},{49,2528}]',7297295),(447,'[{1,91710},{2,2287202},{3,39787},{4,47357},{5,5302},{6,5302},{7,3828},{8,3705},{48,1620},{49,2545}]',7331944),(448,'[{1,92151},{2,2297596},{3,39966},{4,47550},{5,5339},{6,5339},{7,3848},{8,3723},{48,1620},{49,2562}]',7366593),(449,'[{1,92593},{2,2307990},{3,40144},{4,47744},{5,5376},{6,5376},{7,3868},{8,3742},{48,1620},{49,2579}]',7401241),(450,'[{1,93035},{2,2318385},{3,40323},{4,47938},{5,5413},{6,5413},{7,3889},{8,3761},{48,1620},{49,2596}]',7435890),(451,'[{1,93692},{2,2333301},{3,40595},{4,48226},{5,5466},{6,5466},{7,3931},{8,3801},{48,1645},{49,2609}]',7488691),(452,'[{1,94349},{2,2348217},{3,40868},{4,48515},{5,5520},{6,5520},{7,3974},{8,3841},{48,1670},{49,2623}]',7541493),(453,'[{1,95007},{2,2363133},{3,41141},{4,48804},{5,5574},{6,5574},{7,4016},{8,3881},{48,1695},{49,2637}]',7594294),(454,'[{1,95664},{2,2378049},{3,41414},{4,49093},{5,5628},{6,5628},{7,4059},{8,3921},{48,1720},{49,2651}]',7647095),(455,'[{1,96321},{2,2392965},{3,41687},{4,49382},{5,5682},{6,5682},{7,4102},{8,3962},{48,1746},{49,2665}]',7699896),(456,'[{1,96979},{2,2407881},{3,41959},{4,49670},{5,5736},{6,5736},{7,4144},{8,4002},{48,1771},{49,2678}]',7752698),(457,'[{1,97636},{2,2422798},{3,42232},{4,49959},{5,5789},{6,5789},{7,4187},{8,4042},{48,1796},{49,2692}]',7805499),(458,'[{1,98294},{2,2437714},{3,42505},{4,50248},{5,5843},{6,5843},{7,4230},{8,4082},{48,1821},{49,2706}]',7858300),(459,'[{1,98951},{2,2452630},{3,42778},{4,50537},{5,5897},{6,5897},{7,4272},{8,4122},{48,1846},{49,2720}]',7911101),(460,'[{1,99608},{2,2467546},{3,43051},{4,50826},{5,5951},{6,5951},{7,4315},{8,4163},{48,1872},{49,2734}]',7963903),(461,'[{1,100266},{2,2482462},{3,43323},{4,51115},{5,6005},{6,6005},{7,4358},{8,4203},{48,1897},{49,2747}]',8016704),(462,'[{1,100923},{2,2497378},{3,43596},{4,51403},{5,6059},{6,6059},{7,4400},{8,4243},{48,1922},{49,2761}]',8069505),(463,'[{1,101580},{2,2512295},{3,43869},{4,51692},{5,6112},{6,6112},{7,4443},{8,4283},{48,1947},{49,2775}]',8122306),(464,'[{1,102238},{2,2527211},{3,44142},{4,51981},{5,6166},{6,6166},{7,4485},{8,4324},{48,1972},{49,2789}]',8175108),(465,'[{1,102895},{2,2542127},{3,44415},{4,52270},{5,6220},{6,6220},{7,4528},{8,4364},{48,1998},{49,2803}]',8227909),(466,'[{1,103553},{2,2557043},{3,44687},{4,52559},{5,6274},{6,6274},{7,4571},{8,4404},{48,2023},{49,2816}]',8280710),(467,'[{1,104210},{2,2571959},{3,44960},{4,52847},{5,6328},{6,6328},{7,4613},{8,4444},{48,2048},{49,2830}]',8333511),(468,'[{1,104867},{2,2586875},{3,45233},{4,53136},{5,6382},{6,6382},{7,4656},{8,4484},{48,2073},{49,2844}]',8386313),(469,'[{1,105525},{2,2601792},{3,45506},{4,53425},{5,6435},{6,6435},{7,4699},{8,4525},{48,2098},{49,2858}]',8439114),(470,'[{1,106182},{2,2616708},{3,45779},{4,53714},{5,6489},{6,6489},{7,4741},{8,4565},{48,2124},{49,2872}]',8491915),(471,'[{1,106839},{2,2631624},{3,46051},{4,54003},{5,6543},{6,6543},{7,4784},{8,4605},{48,2149},{49,2885}]',8544716),(472,'[{1,107497},{2,2646540},{3,46324},{4,54292},{5,6597},{6,6597},{7,4827},{8,4645},{48,2174},{49,2899}]',8597518),(473,'[{1,108154},{2,2661456},{3,46597},{4,54580},{5,6651},{6,6651},{7,4869},{8,4686},{48,2199},{49,2913}]',8650319),(474,'[{1,108812},{2,2676372},{3,46870},{4,54869},{5,6705},{6,6705},{7,4912},{8,4726},{48,2224},{49,2927}]',8703120),(475,'[{1,109469},{2,2691289},{3,47143},{4,55158},{5,6759},{6,6759},{7,4955},{8,4766},{48,2250},{49,2941}]',8755922),(476,'[{1,110126},{2,2706205},{3,47415},{4,55447},{5,6812},{6,6812},{7,4997},{8,4806},{48,2275},{49,2954}]',8808723),(477,'[{1,110784},{2,2721121},{3,47688},{4,55736},{5,6866},{6,6866},{7,5040},{8,4846},{48,2300},{49,2968}]',8861524),(478,'[{1,111441},{2,2736037},{3,47961},{4,56024},{5,6920},{6,6920},{7,5082},{8,4887},{48,2325},{49,2982}]',8914325),(479,'[{1,112099},{2,2750953},{3,48234},{4,56313},{5,6974},{6,6974},{7,5125},{8,4927},{48,2350},{49,2996}]',8967127),(480,'[{1,112756},{2,2765869},{3,48507},{4,56602},{5,7028},{6,7028},{7,5168},{8,4967},{48,2376},{49,3010}]',9019928),(481,'[{1,113413},{2,2780785},{3,48779},{4,56891},{5,7082},{6,7082},{7,5210},{8,5007},{48,2401},{49,3023}]',9072729),(482,'[{1,114071},{2,2795702},{3,49052},{4,57180},{5,7135},{6,7135},{7,5253},{8,5048},{48,2426},{49,3037}]',9125530),(483,'[{1,114728},{2,2810618},{3,49325},{4,57469},{5,7189},{6,7189},{7,5296},{8,5088},{48,2451},{49,3051}]',9178332),(484,'[{1,115385},{2,2825534},{3,49598},{4,57757},{5,7243},{6,7243},{7,5338},{8,5128},{48,2476},{49,3065}]',9231133),(485,'[{1,116043},{2,2840450},{3,49871},{4,58046},{5,7297},{6,7297},{7,5381},{8,5168},{48,2502},{49,3079}]',9283934),(486,'[{1,116700},{2,2855366},{3,50143},{4,58335},{5,7351},{6,7351},{7,5424},{8,5208},{48,2527},{49,3092}]',9336735),(487,'[{1,117358},{2,2870282},{3,50416},{4,58624},{5,7405},{6,7405},{7,5466},{8,5249},{48,2552},{49,3106}]',9389537),(488,'[{1,118015},{2,2885199},{3,50689},{4,58913},{5,7458},{6,7458},{7,5509},{8,5289},{48,2577},{49,3120}]',9442338),(489,'[{1,118672},{2,2900115},{3,50962},{4,59201},{5,7512},{6,7512},{7,5551},{8,5329},{48,2602},{49,3134}]',9495139),(490,'[{1,119330},{2,2915031},{3,51235},{4,59490},{5,7566},{6,7566},{7,5594},{8,5369},{48,2628},{49,3148}]',9547940),(491,'[{1,119987},{2,2929947},{3,51507},{4,59779},{5,7620},{6,7620},{7,5637},{8,5410},{48,2653},{49,3161}]',9600742),(492,'[{1,120644},{2,2944863},{3,51780},{4,60068},{5,7674},{6,7674},{7,5679},{8,5450},{48,2678},{49,3175}]',9653543),(493,'[{1,121302},{2,2959779},{3,52053},{4,60357},{5,7728},{6,7728},{7,5722},{8,5490},{48,2703},{49,3189}]',9706344),(494,'[{1,121959},{2,2974696},{3,52326},{4,60646},{5,7781},{6,7781},{7,5765},{8,5530},{48,2728},{49,3203}]',9759145),(495,'[{1,122617},{2,2989612},{3,52599},{4,60934},{5,7835},{6,7835},{7,5807},{8,5570},{48,2754},{49,3217}]',9811947),(496,'[{1,123274},{2,3004528},{3,52871},{4,61223},{5,7889},{6,7889},{7,5850},{8,5611},{48,2779},{49,3230}]',9864748),(497,'[{1,123931},{2,3019444},{3,53144},{4,61512},{5,7943},{6,7943},{7,5893},{8,5651},{48,2804},{49,3244}]',9917549),(498,'[{1,124589},{2,3034360},{3,53417},{4,61801},{5,7997},{6,7997},{7,5935},{8,5691},{48,2829},{49,3258}]',9970350),(499,'[{1,125246},{2,3049276},{3,53690},{4,62090},{5,8051},{6,8051},{7,5978},{8,5731},{48,2854},{49,3272}]',10023152),(500,'[{1,125904},{2,3064193},{3,53963},{4,62379},{5,8105},{6,8105},{7,6021},{8,5772},{48,2880},{49,3286}]',10075953),(501,'[{1,126664},{2,3081484},{3,54274},{4,62707},{5,8214},{6,8214},{7,6089},{8,5838},{48,2880},{49,3298}]',10142521),(502,'[{1,127425},{2,3098776},{3,54586},{4,63035},{5,8323},{6,8323},{7,6157},{8,5905},{48,2880},{49,3310}]',10209088),(503,'[{1,128186},{2,3116068},{3,54898},{4,63363},{5,8433},{6,8433},{7,6225},{8,5972},{48,2880},{49,3322}]',10275656),(504,'[{1,128947},{2,3133360},{3,55210},{4,63692},{5,8542},{6,8542},{7,6293},{8,6039},{48,2880},{49,3334}]',10342223),(505,'[{1,129707},{2,3150652},{3,55522},{4,64020},{5,8652},{6,8652},{7,6361},{8,6106},{48,2880},{49,3347}]',10408791),(506,'[{1,130468},{2,3167944},{3,55834},{4,64348},{5,8761},{6,8761},{7,6429},{8,6173},{48,2880},{49,3359}]',10475359),(507,'[{1,131229},{2,3185236},{3,56146},{4,64676},{5,8870},{6,8870},{7,6497},{8,6239},{48,2880},{49,3371}]',10541926),(508,'[{1,131990},{2,3202528},{3,56458},{4,65005},{5,8980},{6,8980},{7,6565},{8,6306},{48,2880},{49,3383}]',10608494),(509,'[{1,132751},{2,3219820},{3,56770},{4,65333},{5,9089},{6,9089},{7,6633},{8,6373},{48,2880},{49,3395}]',10675062),(510,'[{1,133511},{2,3237112},{3,57082},{4,65661},{5,9199},{6,9199},{7,6702},{8,6440},{48,2880},{49,3408}]',10741629),(511,'[{1,134272},{2,3254404},{3,57394},{4,65990},{5,9308},{6,9308},{7,6770},{8,6507},{48,2880},{49,3420}]',10808197),(512,'[{1,135033},{2,3271696},{3,57706},{4,66318},{5,9417},{6,9417},{7,6838},{8,6574},{48,2880},{49,3432}]',10874764),(513,'[{1,135794},{2,3288987},{3,58018},{4,66646},{5,9527},{6,9527},{7,6906},{8,6640},{48,2880},{49,3444}]',10941332),(514,'[{1,136554},{2,3306279},{3,58330},{4,66974},{5,9636},{6,9636},{7,6974},{8,6707},{48,2880},{49,3457}]',11007900),(515,'[{1,137315},{2,3323571},{3,58642},{4,67303},{5,9745},{6,9745},{7,7042},{8,6774},{48,2880},{49,3469}]',11074467),(516,'[{1,138076},{2,3340863},{3,58954},{4,67631},{5,9855},{6,9855},{7,7110},{8,6841},{48,2880},{49,3481}]',11141035),(517,'[{1,138837},{2,3358155},{3,59266},{4,67959},{5,9964},{6,9964},{7,7178},{8,6908},{48,2880},{49,3493}]',11207603),(518,'[{1,139598},{2,3375447},{3,59578},{4,68288},{5,10074},{6,10074},{7,7246},{8,6975},{48,2880},{49,3505}]',11274170),(519,'[{1,140358},{2,3392739},{3,59890},{4,68616},{5,10183},{6,10183},{7,7314},{8,7041},{48,2880},{49,3518}]',11340738),(520,'[{1,141119},{2,3410031},{3,60202},{4,68944},{5,10293},{6,10293},{7,7383},{8,7108},{48,2880},{49,3530}]',11407305),(521,'[{1,141880},{2,3427323},{3,60514},{4,69272},{5,10402},{6,10402},{7,7451},{8,7175},{48,2880},{49,3542}]',11473873),(522,'[{1,142641},{2,3444615},{3,60826},{4,69601},{5,10511},{6,10511},{7,7519},{8,7242},{48,2880},{49,3554}]',11540441),(523,'[{1,143401},{2,3461907},{3,61138},{4,69929},{5,10621},{6,10621},{7,7587},{8,7309},{48,2880},{49,3567}]',11607008),(524,'[{1,144162},{2,3479199},{3,61450},{4,70257},{5,10730},{6,10730},{7,7655},{8,7376},{48,2880},{49,3579}]',11673576),(525,'[{1,144923},{2,3496491},{3,61762},{4,70586},{5,10840},{6,10840},{7,7723},{8,7443},{48,2880},{49,3591}]',11740144),(526,'[{1,145684},{2,3513782},{3,62074},{4,70914},{5,10949},{6,10949},{7,7791},{8,7509},{48,2880},{49,3603}]',11806711),(527,'[{1,146445},{2,3531074},{3,62386},{4,71242},{5,11058},{6,11058},{7,7859},{8,7576},{48,2880},{49,3615}]',11873279),(528,'[{1,147205},{2,3548366},{3,62698},{4,71570},{5,11168},{6,11168},{7,7927},{8,7643},{48,2880},{49,3628}]',11939846),(529,'[{1,147966},{2,3565658},{3,63010},{4,71899},{5,11277},{6,11277},{7,7995},{8,7710},{48,2880},{49,3640}]',12006414),(530,'[{1,148727},{2,3582950},{3,63322},{4,72227},{5,11387},{6,11387},{7,8064},{8,7777},{48,2880},{49,3652}]',12072982),(531,'[{1,149488},{2,3600242},{3,63634},{4,72555},{5,11496},{6,11496},{7,8132},{8,7844},{48,2880},{49,3664}]',12139549),(532,'[{1,150248},{2,3617534},{3,63946},{4,72883},{5,11605},{6,11605},{7,8200},{8,7910},{48,2880},{49,3677}]',12206117),(533,'[{1,151009},{2,3634826},{3,64258},{4,73212},{5,11715},{6,11715},{7,8268},{8,7977},{48,2880},{49,3689}]',12272684),(534,'[{1,151770},{2,3652118},{3,64570},{4,73540},{5,11824},{6,11824},{7,8336},{8,8044},{48,2880},{49,3701}]',12339252),(535,'[{1,152531},{2,3669410},{3,64882},{4,73868},{5,11934},{6,11934},{7,8404},{8,8111},{48,2880},{49,3713}]',12405820),(536,'[{1,153292},{2,3686702},{3,65194},{4,74197},{5,12043},{6,12043},{7,8472},{8,8178},{48,2880},{49,3725}]',12472387),(537,'[{1,154052},{2,3703994},{3,65506},{4,74525},{5,12152},{6,12152},{7,8540},{8,8245},{48,2880},{49,3738}]',12538955),(538,'[{1,154813},{2,3721285},{3,65818},{4,74853},{5,12262},{6,12262},{7,8608},{8,8311},{48,2880},{49,3750}]',12605523),(539,'[{1,155574},{2,3738577},{3,66130},{4,75181},{5,12371},{6,12371},{7,8676},{8,8378},{48,2880},{49,3762}]',12672090),(540,'[{1,156335},{2,3755869},{3,66442},{4,75510},{5,12481},{6,12481},{7,8745},{8,8445},{48,2880},{49,3774}]',12738658),(541,'[{1,157095},{2,3773161},{3,66754},{4,75838},{5,12590},{6,12590},{7,8813},{8,8512},{48,2880},{49,3787}]',12805225),(542,'[{1,157856},{2,3790453},{3,67066},{4,76166},{5,12699},{6,12699},{7,8881},{8,8579},{48,2880},{49,3799}]',12871793),(543,'[{1,158617},{2,3807745},{3,67378},{4,76495},{5,12809},{6,12809},{7,8949},{8,8646},{48,2880},{49,3811}]',12938361),(544,'[{1,159378},{2,3825037},{3,67690},{4,76823},{5,12918},{6,12918},{7,9017},{8,8712},{48,2880},{49,3823}]',13004928),(545,'[{1,160139},{2,3842329},{3,68002},{4,77151},{5,13028},{6,13028},{7,9085},{8,8779},{48,2880},{49,3835}]',13071496),(546,'[{1,160899},{2,3859621},{3,68314},{4,77479},{5,13137},{6,13137},{7,9153},{8,8846},{48,2880},{49,3848}]',13138064),(547,'[{1,161660},{2,3876913},{3,68626},{4,77808},{5,13246},{6,13246},{7,9221},{8,8913},{48,2880},{49,3860}]',13204631),(548,'[{1,162421},{2,3894205},{3,68938},{4,78136},{5,13356},{6,13356},{7,9289},{8,8980},{48,2880},{49,3872}]',13271199),(549,'[{1,163182},{2,3911497},{3,69250},{4,78464},{5,13465},{6,13465},{7,9357},{8,9047},{48,2880},{49,3884}]',13337766),(550,'[{1,163943},{2,3928789},{3,69562},{4,78793},{5,13575},{6,13575},{7,9426},{8,9114},{48,2880},{49,3897}]',13404334),(551,'[{1,164753},{2,3947242},{3,69898},{4,79145},{5,13654},{6,13654},{7,9467},{8,9156},{48,2880},{49,3912}]',13468789),(552,'[{1,165563},{2,3965695},{3,70235},{4,79497},{5,13734},{6,13734},{7,9508},{8,9198},{48,2880},{49,3927}]',13533244),(553,'[{1,166373},{2,3984149},{3,70572},{4,79849},{5,13813},{6,13813},{7,9549},{8,9240},{48,2880},{49,3942}]',13597700),(554,'[{1,167183},{2,4002602},{3,70909},{4,80201},{5,13893},{6,13893},{7,9590},{8,9282},{48,2880},{49,3957}]',13662155),(555,'[{1,167993},{2,4021055},{3,71246},{4,80554},{5,13973},{6,13973},{7,9631},{8,9324},{48,2880},{49,3972}]',13726610),(556,'[{1,168803},{2,4039509},{3,71583},{4,80906},{5,14052},{6,14052},{7,9672},{8,9366},{48,2880},{49,3987}]',13791065),(557,'[{1,169614},{2,4057962},{3,71919},{4,81258},{5,14132},{6,14132},{7,9713},{8,9408},{48,2880},{49,4002}]',13855520),(558,'[{1,170424},{2,4076416},{3,72256},{4,81610},{5,14211},{6,14211},{7,9754},{8,9451},{48,2880},{49,4017}]',13919975),(559,'[{1,171234},{2,4094869},{3,72593},{4,81962},{5,14291},{6,14291},{7,9795},{8,9493},{48,2880},{49,4033}]',13984431),(560,'[{1,172044},{2,4113322},{3,72930},{4,82315},{5,14371},{6,14371},{7,9836},{8,9535},{48,2880},{49,4048}]',14048886),(561,'[{1,172854},{2,4131776},{3,73267},{4,82667},{5,14450},{6,14450},{7,9877},{8,9577},{48,2880},{49,4063}]',14113341),(562,'[{1,173664},{2,4150229},{3,73604},{4,83019},{5,14530},{6,14530},{7,9918},{8,9619},{48,2880},{49,4078}]',14177796),(563,'[{1,174475},{2,4168682},{3,73940},{4,83371},{5,14610},{6,14610},{7,9959},{8,9661},{48,2880},{49,4093}]',14242251),(564,'[{1,175285},{2,4187136},{3,74277},{4,83723},{5,14689},{6,14689},{7,10000},{8,9703},{48,2880},{49,4108}]',14306707),(565,'[{1,176095},{2,4205589},{3,74614},{4,84076},{5,14769},{6,14769},{7,10041},{8,9746},{48,2880},{49,4123}]',14371162),(566,'[{1,176905},{2,4224043},{3,74951},{4,84428},{5,14848},{6,14848},{7,10082},{8,9788},{48,2880},{49,4138}]',14435617),(567,'[{1,177715},{2,4242496},{3,75288},{4,84780},{5,14928},{6,14928},{7,10123},{8,9830},{48,2880},{49,4154}]',14500072),(568,'[{1,178525},{2,4260949},{3,75625},{4,85132},{5,15008},{6,15008},{7,10164},{8,9872},{48,2880},{49,4169}]',14564527),(569,'[{1,179336},{2,4279403},{3,75961},{4,85484},{5,15087},{6,15087},{7,10205},{8,9914},{48,2880},{49,4184}]',14628982),(570,'[{1,180146},{2,4297856},{3,76298},{4,85836},{5,15167},{6,15167},{7,10246},{8,9956},{48,2880},{49,4199}]',14693438),(571,'[{1,180956},{2,4316309},{3,76635},{4,86189},{5,15247},{6,15247},{7,10287},{8,9998},{48,2880},{49,4214}]',14757893),(572,'[{1,181766},{2,4334763},{3,76972},{4,86541},{5,15326},{6,15326},{7,10328},{8,10041},{48,2880},{49,4229}]',14822348),(573,'[{1,182576},{2,4353216},{3,77309},{4,86893},{5,15406},{6,15406},{7,10369},{8,10083},{48,2880},{49,4244}]',14886803),(574,'[{1,183386},{2,4371670},{3,77646},{4,87245},{5,15485},{6,15485},{7,10410},{8,10125},{48,2880},{49,4259}]',14951258),(575,'[{1,184197},{2,4390123},{3,77982},{4,87597},{5,15565},{6,15565},{7,10451},{8,10167},{48,2880},{49,4275}]',15015714),(576,'[{1,185007},{2,4408576},{3,78319},{4,87950},{5,15645},{6,15645},{7,10492},{8,10209},{48,2880},{49,4290}]',15080169),(577,'[{1,185817},{2,4427030},{3,78656},{4,88302},{5,15724},{6,15724},{7,10533},{8,10251},{48,2880},{49,4305}]',15144624),(578,'[{1,186627},{2,4445483},{3,78993},{4,88654},{5,15804},{6,15804},{7,10574},{8,10293},{48,2880},{49,4320}]',15209079),(579,'[{1,187437},{2,4463937},{3,79330},{4,89006},{5,15883},{6,15883},{7,10615},{8,10336},{48,2880},{49,4335}]',15273534),(580,'[{1,188247},{2,4482390},{3,79667},{4,89358},{5,15963},{6,15963},{7,10656},{8,10378},{48,2880},{49,4350}]',15337989),(581,'[{1,189057},{2,4500843},{3,80004},{4,89711},{5,16043},{6,16043},{7,10697},{8,10420},{48,2880},{49,4365}]',15402445),(582,'[{1,189868},{2,4519297},{3,80340},{4,90063},{5,16122},{6,16122},{7,10738},{8,10462},{48,2880},{49,4380}]',15466900),(583,'[{1,190678},{2,4537750},{3,80677},{4,90415},{5,16202},{6,16202},{7,10779},{8,10504},{48,2880},{49,4395}]',15531355),(584,'[{1,191488},{2,4556203},{3,81014},{4,90767},{5,16282},{6,16282},{7,10820},{8,10546},{48,2880},{49,4411}]',15595810),(585,'[{1,192298},{2,4574657},{3,81351},{4,91119},{5,16361},{6,16361},{7,10861},{8,10588},{48,2880},{49,4426}]',15660265),(586,'[{1,193108},{2,4593110},{3,81688},{4,91472},{5,16441},{6,16441},{7,10902},{8,10631},{48,2880},{49,4441}]',15724720),(587,'[{1,193918},{2,4611564},{3,82025},{4,91824},{5,16520},{6,16520},{7,10943},{8,10673},{48,2880},{49,4456}]',15789176),(588,'[{1,194729},{2,4630017},{3,82361},{4,92176},{5,16600},{6,16600},{7,10984},{8,10715},{48,2880},{49,4471}]',15853631),(589,'[{1,195539},{2,4648470},{3,82698},{4,92528},{5,16680},{6,16680},{7,11025},{8,10757},{48,2880},{49,4486}]',15918086),(590,'[{1,196349},{2,4666924},{3,83035},{4,92880},{5,16759},{6,16759},{7,11066},{8,10799},{48,2880},{49,4501}]',15982541),(591,'[{1,197159},{2,4685377},{3,83372},{4,93233},{5,16839},{6,16839},{7,11107},{8,10841},{48,2880},{49,4516}]',16046996),(592,'[{1,197969},{2,4703830},{3,83709},{4,93585},{5,16919},{6,16919},{7,11148},{8,10883},{48,2880},{49,4532}]',16111452),(593,'[{1,198779},{2,4722284},{3,84046},{4,93937},{5,16998},{6,16998},{7,11189},{8,10926},{48,2880},{49,4547}]',16175907),(594,'[{1,199590},{2,4740737},{3,84382},{4,94289},{5,17078},{6,17078},{7,11230},{8,10968},{48,2880},{49,4562}]',16240362),(595,'[{1,200400},{2,4759191},{3,84719},{4,94641},{5,17157},{6,17157},{7,11271},{8,11010},{48,2880},{49,4577}]',16304817),(596,'[{1,201210},{2,4777644},{3,85056},{4,94994},{5,17237},{6,17237},{7,11312},{8,11052},{48,2880},{49,4592}]',16369272),(597,'[{1,202020},{2,4796097},{3,85393},{4,95346},{5,17317},{6,17317},{7,11353},{8,11094},{48,2880},{49,4607}]',16433727),(598,'[{1,202830},{2,4814551},{3,85730},{4,95698},{5,17396},{6,17396},{7,11394},{8,11136},{48,2880},{49,4622}]',16498183),(599,'[{1,203640},{2,4833004},{3,86067},{4,96050},{5,17476},{6,17476},{7,11435},{8,11178},{48,2880},{49,4637}]',16562638),(600,'[{1,204451},{2,4851458},{3,86404},{4,96403},{5,17556},{6,17556},{7,11476},{8,11221},{48,2880},{49,4653}]',16627093),(601,'[{1,205338},{2,4871676},{3,86804},{4,96819},{5,17652},{6,17652},{7,11546},{8,11293},{48,2880},{49,4669}]',16702739),(602,'[{1,206225},{2,4891894},{3,87205},{4,97235},{5,17748},{6,17748},{7,11616},{8,11366},{48,2880},{49,4685}]',16778384),(603,'[{1,207113},{2,4912112},{3,87606},{4,97651},{5,17844},{6,17844},{7,11687},{8,11438},{48,2880},{49,4701}]',16854030),(604,'[{1,208000},{2,4932330},{3,88007},{4,98068},{5,17940},{6,17940},{7,11757},{8,11511},{48,2880},{49,4717}]',16929675),(605,'[{1,208888},{2,4952548},{3,88407},{4,98484},{5,18037},{6,18037},{7,11828},{8,11583},{48,2880},{49,4733}]',17005321),(606,'[{1,209775},{2,4972766},{3,88808},{4,98900},{5,18133},{6,18133},{7,11898},{8,11656},{48,2880},{49,4749}]',17080966),(607,'[{1,210662},{2,4992985},{3,89209},{4,99317},{5,18229},{6,18229},{7,11968},{8,11728},{48,2880},{49,4765}]',17156612),(608,'[{1,211550},{2,5013203},{3,89610},{4,99733},{5,18325},{6,18325},{7,12039},{8,11801},{48,2880},{49,4781}]',17232257),(609,'[{1,212437},{2,5033421},{3,90011},{4,100149},{5,18421},{6,18421},{7,12109},{8,11873},{48,2880},{49,4797}]',17307903),(610,'[{1,213325},{2,5053639},{3,90411},{4,100566},{5,18518},{6,18518},{7,12180},{8,11946},{48,2880},{49,4814}]',17383549),(611,'[{1,214212},{2,5073857},{3,90812},{4,100982},{5,18614},{6,18614},{7,12250},{8,12018},{48,2880},{49,4830}]',17459194),(612,'[{1,215100},{2,5094075},{3,91213},{4,101398},{5,18710},{6,18710},{7,12320},{8,12091},{48,2880},{49,4846}]',17534840),(613,'[{1,215987},{2,5114294},{3,91614},{4,101814},{5,18806},{6,18806},{7,12391},{8,12164},{48,2880},{49,4862}]',17610485),(614,'[{1,216874},{2,5134512},{3,92014},{4,102231},{5,18903},{6,18903},{7,12461},{8,12236},{48,2880},{49,4878}]',17686131),(615,'[{1,217762},{2,5154730},{3,92415},{4,102647},{5,18999},{6,18999},{7,12532},{8,12309},{48,2880},{49,4894}]',17761776),(616,'[{1,218649},{2,5174948},{3,92816},{4,103063},{5,19095},{6,19095},{7,12602},{8,12381},{48,2880},{49,4910}]',17837422),(617,'[{1,219537},{2,5195166},{3,93217},{4,103480},{5,19191},{6,19191},{7,12672},{8,12454},{48,2880},{49,4926}]',17913068),(618,'[{1,220424},{2,5215384},{3,93618},{4,103896},{5,19287},{6,19287},{7,12743},{8,12526},{48,2880},{49,4942}]',17988713),(619,'[{1,221311},{2,5235603},{3,94018},{4,104312},{5,19384},{6,19384},{7,12813},{8,12599},{48,2880},{49,4958}]',18064359),(620,'[{1,222199},{2,5255821},{3,94419},{4,104729},{5,19480},{6,19480},{7,12884},{8,12671},{48,2880},{49,4975}]',18140004),(621,'[{1,223086},{2,5276039},{3,94820},{4,105145},{5,19576},{6,19576},{7,12954},{8,12744},{48,2880},{49,4991}]',18215650),(622,'[{1,223974},{2,5296257},{3,95221},{4,105561},{5,19672},{6,19672},{7,13024},{8,12816},{48,2880},{49,5007}]',18291295),(623,'[{1,224861},{2,5316475},{3,95621},{4,105977},{5,19769},{6,19769},{7,13095},{8,12889},{48,2880},{49,5023}]',18366941),(624,'[{1,225749},{2,5336693},{3,96022},{4,106394},{5,19865},{6,19865},{7,13165},{8,12961},{48,2880},{49,5039}]',18442586),(625,'[{1,226636},{2,5356912},{3,96423},{4,106810},{5,19961},{6,19961},{7,13236},{8,13034},{48,2880},{49,5055}]',18518232),(626,'[{1,227523},{2,5377130},{3,96824},{4,107226},{5,20057},{6,20057},{7,13306},{8,13107},{48,2880},{49,5071}]',18593878),(627,'[{1,228411},{2,5397348},{3,97225},{4,107643},{5,20153},{6,20153},{7,13376},{8,13179},{48,2880},{49,5087}]',18669523),(628,'[{1,229298},{2,5417566},{3,97625},{4,108059},{5,20250},{6,20250},{7,13447},{8,13252},{48,2880},{49,5103}]',18745169),(629,'[{1,230186},{2,5437784},{3,98026},{4,108475},{5,20346},{6,20346},{7,13517},{8,13324},{48,2880},{49,5119}]',18820814),(630,'[{1,231073},{2,5458002},{3,98427},{4,108892},{5,20442},{6,20442},{7,13588},{8,13397},{48,2880},{49,5136}]',18896460),(631,'[{1,231961},{2,5478220},{3,98828},{4,109308},{5,20538},{6,20538},{7,13658},{8,13469},{48,2880},{49,5152}]',18972105),(632,'[{1,232848},{2,5498439},{3,99228},{4,109724},{5,20635},{6,20635},{7,13728},{8,13542},{48,2880},{49,5168}]',19047751),(633,'[{1,233735},{2,5518657},{3,99629},{4,110140},{5,20731},{6,20731},{7,13799},{8,13614},{48,2880},{49,5184}]',19123396),(634,'[{1,234623},{2,5538875},{3,100030},{4,110557},{5,20827},{6,20827},{7,13869},{8,13687},{48,2880},{49,5200}]',19199042),(635,'[{1,235510},{2,5559093},{3,100431},{4,110973},{5,20923},{6,20923},{7,13940},{8,13759},{48,2880},{49,5216}]',19274688),(636,'[{1,236398},{2,5579311},{3,100832},{4,111389},{5,21019},{6,21019},{7,14010},{8,13832},{48,2880},{49,5232}]',19350333),(637,'[{1,237285},{2,5599529},{3,101232},{4,111806},{5,21116},{6,21116},{7,14080},{8,13904},{48,2880},{49,5248}]',19425979),(638,'[{1,238172},{2,5619748},{3,101633},{4,112222},{5,21212},{6,21212},{7,14151},{8,13977},{48,2880},{49,5264}]',19501624),(639,'[{1,239060},{2,5639966},{3,102034},{4,112638},{5,21308},{6,21308},{7,14221},{8,14050},{48,2880},{49,5280}]',19577270),(640,'[{1,239947},{2,5660184},{3,102435},{4,113055},{5,21404},{6,21404},{7,14292},{8,14122},{48,2880},{49,5297}]',19652915),(641,'[{1,240835},{2,5680402},{3,102835},{4,113471},{5,21501},{6,21501},{7,14362},{8,14195},{48,2880},{49,5313}]',19728561),(642,'[{1,241722},{2,5700620},{3,103236},{4,113887},{5,21597},{6,21597},{7,14432},{8,14267},{48,2880},{49,5329}]',19804207),(643,'[{1,242610},{2,5720838},{3,103637},{4,114303},{5,21693},{6,21693},{7,14503},{8,14340},{48,2880},{49,5345}]',19879852),(644,'[{1,243497},{2,5741057},{3,104038},{4,114720},{5,21789},{6,21789},{7,14573},{8,14412},{48,2880},{49,5361}]',19955498),(645,'[{1,244384},{2,5761275},{3,104439},{4,115136},{5,21885},{6,21885},{7,14644},{8,14485},{48,2880},{49,5377}]',20031143),(646,'[{1,245272},{2,5781493},{3,104839},{4,115552},{5,21982},{6,21982},{7,14714},{8,14557},{48,2880},{49,5393}]',20106789),(647,'[{1,246159},{2,5801711},{3,105240},{4,115969},{5,22078},{6,22078},{7,14784},{8,14630},{48,2880},{49,5409}]',20182434),(648,'[{1,247047},{2,5821929},{3,105641},{4,116385},{5,22174},{6,22174},{7,14855},{8,14702},{48,2880},{49,5425}]',20258080),(649,'[{1,247934},{2,5842147},{3,106042},{4,116801},{5,22270},{6,22270},{7,14925},{8,14775},{48,2880},{49,5441}]',20333725),(650,'[{1,248822},{2,5862366},{3,106443},{4,117218},{5,22367},{6,22367},{7,14996},{8,14848},{48,2880},{49,5458}]',20409371),(651,'[{1,249933},{2,5887256},{3,106860},{4,117649},{5,22454},{6,22454},{7,15038},{8,14889},{48,2984},{49,5475}]',20494290),(652,'[{1,251044},{2,5912147},{3,107277},{4,118081},{5,22542},{6,22542},{7,15080},{8,14931},{48,3088},{49,5492}]',20579209),(653,'[{1,252155},{2,5937038},{3,107694},{4,118512},{5,22629},{6,22629},{7,15122},{8,14972},{48,3193},{49,5509}]',20664128),(654,'[{1,253266},{2,5961929},{3,108112},{4,118944},{5,22717},{6,22717},{7,15164},{8,15014},{48,3297},{49,5526}]',20749047),(655,'[{1,254377},{2,5986820},{3,108529},{4,119375},{5,22804},{6,22804},{7,15206},{8,15056},{48,3402},{49,5543}]',20833967),(656,'[{1,255488},{2,6011710},{3,108946},{4,119807},{5,22892},{6,22892},{7,15248},{8,15097},{48,3506},{49,5560}]',20918886),(657,'[{1,256599},{2,6036601},{3,109364},{4,120238},{5,22980},{6,22980},{7,15290},{8,15139},{48,3610},{49,5577}]',21003805),(658,'[{1,257710},{2,6061492},{3,109781},{4,120670},{5,23067},{6,23067},{7,15332},{8,15181},{48,3715},{49,5594}]',21088724),(659,'[{1,258821},{2,6086383},{3,110198},{4,121101},{5,23155},{6,23155},{7,15374},{8,15222},{48,3819},{49,5611}]',21173643),(660,'[{1,259933},{2,6111274},{3,110616},{4,121533},{5,23242},{6,23242},{7,15416},{8,15264},{48,3924},{49,5628}]',21258562),(661,'[{1,261044},{2,6136165},{3,111033},{4,121964},{5,23330},{6,23330},{7,15458},{8,15306},{48,4028},{49,5645}]',21343481),(662,'[{1,262155},{2,6161055},{3,111450},{4,122396},{5,23417},{6,23417},{7,15500},{8,15347},{48,4132},{49,5662}]',21428400),(663,'[{1,263266},{2,6185946},{3,111867},{4,122827},{5,23505},{6,23505},{7,15542},{8,15389},{48,4237},{49,5679}]',21513320),(664,'[{1,264377},{2,6210837},{3,112285},{4,123259},{5,23593},{6,23593},{7,15584},{8,15431},{48,4341},{49,5696}]',21598239),(665,'[{1,265488},{2,6235728},{3,112702},{4,123690},{5,23680},{6,23680},{7,15626},{8,15472},{48,4446},{49,5713}]',21683158),(666,'[{1,266599},{2,6260619},{3,113119},{4,124122},{5,23768},{6,23768},{7,15668},{8,15514},{48,4550},{49,5730}]',21768077),(667,'[{1,267710},{2,6285509},{3,113537},{4,124553},{5,23855},{6,23855},{7,15710},{8,15556},{48,4654},{49,5748}]',21852996),(668,'[{1,268821},{2,6310400},{3,113954},{4,124985},{5,23943},{6,23943},{7,15752},{8,15597},{48,4759},{49,5765}]',21937915),(669,'[{1,269932},{2,6335291},{3,114371},{4,125416},{5,24031},{6,24031},{7,15794},{8,15639},{48,4863},{49,5782}]',22022834),(670,'[{1,271044},{2,6360182},{3,114789},{4,125848},{5,24118},{6,24118},{7,15836},{8,15681},{48,4968},{49,5799}]',22107753),(671,'[{1,272155},{2,6385073},{3,115206},{4,126279},{5,24206},{6,24206},{7,15878},{8,15722},{48,5072},{49,5816}]',22192673),(672,'[{1,273266},{2,6409964},{3,115623},{4,126711},{5,24293},{6,24293},{7,15920},{8,15764},{48,5176},{49,5833}]',22277592),(673,'[{1,274377},{2,6434854},{3,116040},{4,127142},{5,24381},{6,24381},{7,15962},{8,15806},{48,5281},{49,5850}]',22362511),(674,'[{1,275488},{2,6459745},{3,116458},{4,127574},{5,24468},{6,24468},{7,16004},{8,15847},{48,5385},{49,5867}]',22447430),(675,'[{1,276599},{2,6484636},{3,116875},{4,128006},{5,24556},{6,24556},{7,16046},{8,15889},{48,5490},{49,5884}]',22532349),(676,'[{1,277710},{2,6509527},{3,117292},{4,128437},{5,24644},{6,24644},{7,16088},{8,15931},{48,5594},{49,5901}]',22617268),(677,'[{1,278821},{2,6534418},{3,117710},{4,128869},{5,24731},{6,24731},{7,16130},{8,15972},{48,5698},{49,5918}]',22702187),(678,'[{1,279932},{2,6559308},{3,118127},{4,129300},{5,24819},{6,24819},{7,16172},{8,16014},{48,5803},{49,5935}]',22787106),(679,'[{1,281043},{2,6584199},{3,118544},{4,129732},{5,24906},{6,24906},{7,16214},{8,16056},{48,5907},{49,5952}]',22872025),(680,'[{1,282155},{2,6609090},{3,118962},{4,130163},{5,24994},{6,24994},{7,16256},{8,16097},{48,6011},{49,5969}]',22956945),(681,'[{1,283266},{2,6633981},{3,119379},{4,130595},{5,25081},{6,25081},{7,16298},{8,16139},{48,6116},{49,5986}]',23041864),(682,'[{1,284377},{2,6658872},{3,119796},{4,131026},{5,25169},{6,25169},{7,16340},{8,16181},{48,6220},{49,6003}]',23126783),(683,'[{1,285488},{2,6683763},{3,120213},{4,131458},{5,25257},{6,25257},{7,16382},{8,16222},{48,6325},{49,6020}]',23211702),(684,'[{1,286599},{2,6708653},{3,120631},{4,131889},{5,25344},{6,25344},{7,16424},{8,16264},{48,6429},{49,6038}]',23296621),(685,'[{1,287710},{2,6733544},{3,121048},{4,132321},{5,25432},{6,25432},{7,16466},{8,16306},{48,6533},{49,6055}]',23381540),(686,'[{1,288821},{2,6758435},{3,121465},{4,132752},{5,25519},{6,25519},{7,16508},{8,16347},{48,6638},{49,6072}]',23466459),(687,'[{1,289932},{2,6783326},{3,121883},{4,133184},{5,25607},{6,25607},{7,16550},{8,16389},{48,6742},{49,6089}]',23551378),(688,'[{1,291043},{2,6808217},{3,122300},{4,133615},{5,25695},{6,25695},{7,16592},{8,16431},{48,6847},{49,6106}]',23636298),(689,'[{1,292154},{2,6833107},{3,122717},{4,134047},{5,25782},{6,25782},{7,16634},{8,16472},{48,6951},{49,6123}]',23721217),(690,'[{1,293265},{2,6857998},{3,123135},{4,134478},{5,25870},{6,25870},{7,16676},{8,16514},{48,7055},{49,6140}]',23806136),(691,'[{1,294377},{2,6882889},{3,123552},{4,134910},{5,25957},{6,25957},{7,16718},{8,16556},{48,7160},{49,6157}]',23891055),(692,'[{1,295488},{2,6907780},{3,123969},{4,135341},{5,26045},{6,26045},{7,16760},{8,16597},{48,7264},{49,6174}]',23975974),(693,'[{1,296599},{2,6932671},{3,124386},{4,135773},{5,26132},{6,26132},{7,16802},{8,16639},{48,7369},{49,6191}]',24060893),(694,'[{1,297710},{2,6957562},{3,124804},{4,136204},{5,26220},{6,26220},{7,16844},{8,16681},{48,7473},{49,6208}]',24145812),(695,'[{1,298821},{2,6982452},{3,125221},{4,136636},{5,26308},{6,26308},{7,16886},{8,16722},{48,7577},{49,6225}]',24230731),(696,'[{1,299932},{2,7007343},{3,125638},{4,137067},{5,26395},{6,26395},{7,16928},{8,16764},{48,7682},{49,6242}]',24315651),(697,'[{1,301043},{2,7032234},{3,126056},{4,137499},{5,26483},{6,26483},{7,16970},{8,16806},{48,7786},{49,6259}]',24400570),(698,'[{1,302154},{2,7057125},{3,126473},{4,137930},{5,26570},{6,26570},{7,17012},{8,16847},{48,7891},{49,6276}]',24485489),(699,'[{1,303265},{2,7082016},{3,126890},{4,138362},{5,26658},{6,26658},{7,17054},{8,16889},{48,7995},{49,6293}]',24570408),(700,'[{1,304377},{2,7106907},{3,127308},{4,138794},{5,26746},{6,26746},{7,17097},{8,16931},{48,8100},{49,6311}]',24655327),(701,'[{1,305358},{2,7129439},{3,127752},{4,139253},{5,26821},{6,26821},{7,17135},{8,16972},{48,8100},{49,6325}]',24732112),(702,'[{1,306339},{2,7151971},{3,128196},{4,139713},{5,26897},{6,26897},{7,17173},{8,17014},{48,8100},{49,6340}]',24808896),(703,'[{1,307320},{2,7174503},{3,128641},{4,140172},{5,26973},{6,26973},{7,17212},{8,17056},{48,8100},{49,6354}]',24885681),(704,'[{1,308301},{2,7197035},{3,129085},{4,140632},{5,27049},{6,27049},{7,17250},{8,17097},{48,8100},{49,6369}]',24962465),(705,'[{1,309282},{2,7219567},{3,129529},{4,141091},{5,27125},{6,27125},{7,17289},{8,17139},{48,8100},{49,6384}]',25039250),(706,'[{1,310263},{2,7242099},{3,129974},{4,141551},{5,27201},{6,27201},{7,17327},{8,17181},{48,8100},{49,6398}]',25116034),(707,'[{1,311244},{2,7264631},{3,130418},{4,142010},{5,27277},{6,27277},{7,17365},{8,17223},{48,8100},{49,6413}]',25192819),(708,'[{1,312225},{2,7287163},{3,130862},{4,142470},{5,27353},{6,27353},{7,17404},{8,17264},{48,8100},{49,6427}]',25269603),(709,'[{1,313206},{2,7309696},{3,131307},{4,142929},{5,27428},{6,27428},{7,17442},{8,17306},{48,8100},{49,6442}]',25346388),(710,'[{1,314187},{2,7332228},{3,131751},{4,143389},{5,27504},{6,27504},{7,17481},{8,17348},{48,8100},{49,6457}]',25423172),(711,'[{1,315168},{2,7354760},{3,132195},{4,143848},{5,27580},{6,27580},{7,17519},{8,17390},{48,8100},{49,6471}]',25499957),(712,'[{1,316149},{2,7377292},{3,132640},{4,144308},{5,27656},{6,27656},{7,17558},{8,17431},{48,8100},{49,6486}]',25576741),(713,'[{1,317130},{2,7399824},{3,133084},{4,144767},{5,27732},{6,27732},{7,17596},{8,17473},{48,8100},{49,6501}]',25653526),(714,'[{1,318111},{2,7422356},{3,133529},{4,145227},{5,27808},{6,27808},{7,17634},{8,17515},{48,8100},{49,6515}]',25730310),(715,'[{1,319092},{2,7444888},{3,133973},{4,145686},{5,27884},{6,27884},{7,17673},{8,17557},{48,8100},{49,6530}]',25807095),(716,'[{1,320073},{2,7467420},{3,134417},{4,146146},{5,27960},{6,27960},{7,17711},{8,17598},{48,8100},{49,6544}]',25883879),(717,'[{1,321054},{2,7489953},{3,134862},{4,146605},{5,28035},{6,28035},{7,17750},{8,17640},{48,8100},{49,6559}]',25960664),(718,'[{1,322035},{2,7512485},{3,135306},{4,147065},{5,28111},{6,28111},{7,17788},{8,17682},{48,8100},{49,6574}]',26037448),(719,'[{1,323016},{2,7535017},{3,135750},{4,147524},{5,28187},{6,28187},{7,17826},{8,17724},{48,8100},{49,6588}]',26114233),(720,'[{1,323997},{2,7557549},{3,136195},{4,147984},{5,28263},{6,28263},{7,17865},{8,17765},{48,8100},{49,6603}]',26191017),(721,'[{1,324978},{2,7580081},{3,136639},{4,148443},{5,28339},{6,28339},{7,17903},{8,17807},{48,8100},{49,6618}]',26267802),(722,'[{1,325959},{2,7602613},{3,137083},{4,148903},{5,28415},{6,28415},{7,17942},{8,17849},{48,8100},{49,6632}]',26344586),(723,'[{1,326940},{2,7625145},{3,137528},{4,149362},{5,28491},{6,28491},{7,17980},{8,17891},{48,8100},{49,6647}]',26421371),(724,'[{1,327921},{2,7647677},{3,137972},{4,149822},{5,28567},{6,28567},{7,18019},{8,17932},{48,8100},{49,6661}]',26498155),(725,'[{1,328902},{2,7670210},{3,138417},{4,150282},{5,28643},{6,28643},{7,18057},{8,17974},{48,8100},{49,6676}]',26574940),(726,'[{1,329884},{2,7692742},{3,138861},{4,150741},{5,28718},{6,28718},{7,18095},{8,18016},{48,8100},{49,6691}]',26651725),(727,'[{1,330865},{2,7715274},{3,139305},{4,151201},{5,28794},{6,28794},{7,18134},{8,18057},{48,8100},{49,6705}]',26728509),(728,'[{1,331846},{2,7737806},{3,139750},{4,151660},{5,28870},{6,28870},{7,18172},{8,18099},{48,8100},{49,6720}]',26805294),(729,'[{1,332827},{2,7760338},{3,140194},{4,152120},{5,28946},{6,28946},{7,18211},{8,18141},{48,8100},{49,6734}]',26882078),(730,'[{1,333808},{2,7782870},{3,140638},{4,152579},{5,29022},{6,29022},{7,18249},{8,18183},{48,8100},{49,6749}]',26958863),(731,'[{1,334789},{2,7805402},{3,141083},{4,153039},{5,29098},{6,29098},{7,18288},{8,18224},{48,8100},{49,6764}]',27035647),(732,'[{1,335770},{2,7827934},{3,141527},{4,153498},{5,29174},{6,29174},{7,18326},{8,18266},{48,8100},{49,6778}]',27112432),(733,'[{1,336751},{2,7850466},{3,141971},{4,153958},{5,29250},{6,29250},{7,18364},{8,18308},{48,8100},{49,6793}]',27189216),(734,'[{1,337732},{2,7872999},{3,142416},{4,154417},{5,29325},{6,29325},{7,18403},{8,18350},{48,8100},{49,6808}]',27266001),(735,'[{1,338713},{2,7895531},{3,142860},{4,154877},{5,29401},{6,29401},{7,18441},{8,18391},{48,8100},{49,6822}]',27342785),(736,'[{1,339694},{2,7918063},{3,143304},{4,155336},{5,29477},{6,29477},{7,18480},{8,18433},{48,8100},{49,6837}]',27419570),(737,'[{1,340675},{2,7940595},{3,143749},{4,155796},{5,29553},{6,29553},{7,18518},{8,18475},{48,8100},{49,6851}]',27496354),(738,'[{1,341656},{2,7963127},{3,144193},{4,156255},{5,29629},{6,29629},{7,18556},{8,18517},{48,8100},{49,6866}]',27573139),(739,'[{1,342637},{2,7985659},{3,144638},{4,156715},{5,29705},{6,29705},{7,18595},{8,18558},{48,8100},{49,6881}]',27649923),(740,'[{1,343618},{2,8008191},{3,145082},{4,157174},{5,29781},{6,29781},{7,18633},{8,18600},{48,8100},{49,6895}]',27726708),(741,'[{1,344599},{2,8030723},{3,145526},{4,157634},{5,29857},{6,29857},{7,18672},{8,18642},{48,8100},{49,6910}]',27803492),(742,'[{1,345580},{2,8053256},{3,145971},{4,158093},{5,29932},{6,29932},{7,18710},{8,18684},{48,8100},{49,6925}]',27880277),(743,'[{1,346561},{2,8075788},{3,146415},{4,158553},{5,30008},{6,30008},{7,18749},{8,18725},{48,8100},{49,6939}]',27957061),(744,'[{1,347542},{2,8098320},{3,146859},{4,159012},{5,30084},{6,30084},{7,18787},{8,18767},{48,8100},{49,6954}]',28033846),(745,'[{1,348523},{2,8120852},{3,147304},{4,159472},{5,30160},{6,30160},{7,18825},{8,18809},{48,8100},{49,6968}]',28110630),(746,'[{1,349504},{2,8143384},{3,147748},{4,159931},{5,30236},{6,30236},{7,18864},{8,18851},{48,8100},{49,6983}]',28187415),(747,'[{1,350485},{2,8165916},{3,148192},{4,160391},{5,30312},{6,30312},{7,18902},{8,18892},{48,8100},{49,6998}]',28264199),(748,'[{1,351466},{2,8188448},{3,148637},{4,160850},{5,30388},{6,30388},{7,18941},{8,18934},{48,8100},{49,7012}]',28340984),(749,'[{1,352447},{2,8210980},{3,149081},{4,161310},{5,30464},{6,30464},{7,18979},{8,18976},{48,8100},{49,7027}]',28417768),(750,'[{1,353429},{2,8233513},{3,149526},{4,161770},{5,30540},{6,30540},{7,19018},{8,19018},{48,8100},{49,7042}]',28494553),(751,'[{1,354489},{2,8257863},{3,150042},{4,162301},{5,30616},{6,30616},{7,19096},{8,19096},{48,8100},{49,7072}]',28582784),(752,'[{1,355549},{2,8282214},{3,150559},{4,162832},{5,30693},{6,30693},{7,19175},{8,19175},{48,8100},{49,7103}]',28671015),(753,'[{1,356609},{2,8306565},{3,151076},{4,163364},{5,30770},{6,30770},{7,19253},{8,19253},{48,8100},{49,7134}]',28759246),(754,'[{1,357669},{2,8330916},{3,151593},{4,163895},{5,30846},{6,30846},{7,19332},{8,19332},{48,8100},{49,7165}]',28847477),(755,'[{1,358729},{2,8355267},{3,152110},{4,164427},{5,30923},{6,30923},{7,19411},{8,19411},{48,8100},{49,7196}]',28935707),(756,'[{1,359790},{2,8379618},{3,152627},{4,164958},{5,31000},{6,31000},{7,19489},{8,19489},{48,8100},{49,7227}]',29023938),(757,'[{1,360850},{2,8403969},{3,153144},{4,165489},{5,31077},{6,31077},{7,19568},{8,19568},{48,8100},{49,7258}]',29112169),(758,'[{1,361910},{2,8428320},{3,153661},{4,166021},{5,31153},{6,31153},{7,19647},{8,19647},{48,8100},{49,7289}]',29200400),(759,'[{1,362970},{2,8452671},{3,154178},{4,166552},{5,31230},{6,31230},{7,19725},{8,19725},{48,8100},{49,7320}]',29288631),(760,'[{1,364030},{2,8477022},{3,154695},{4,167084},{5,31307},{6,31307},{7,19804},{8,19804},{48,8100},{49,7351}]',29376862),(761,'[{1,365090},{2,8501373},{3,155212},{4,167615},{5,31384},{6,31384},{7,19883},{8,19883},{48,8100},{49,7382}]',29465093),(762,'[{1,366151},{2,8525724},{3,155729},{4,168147},{5,31460},{6,31460},{7,19961},{8,19961},{48,8100},{49,7413}]',29553324),(763,'[{1,367211},{2,8550075},{3,156246},{4,168678},{5,31537},{6,31537},{7,20040},{8,20040},{48,8100},{49,7444}]',29641554),(764,'[{1,368271},{2,8574426},{3,156763},{4,169209},{5,31614},{6,31614},{7,20118},{8,20118},{48,8100},{49,7475}]',29729785),(765,'[{1,369331},{2,8598777},{3,157280},{4,169741},{5,31691},{6,31691},{7,20197},{8,20197},{48,8100},{49,7506}]',29818016),(766,'[{1,370391},{2,8623128},{3,157797},{4,170272},{5,31767},{6,31767},{7,20276},{8,20276},{48,8100},{49,7537}]',29906247),(767,'[{1,371452},{2,8647479},{3,158314},{4,170804},{5,31844},{6,31844},{7,20354},{8,20354},{48,8100},{49,7568}]',29994478),(768,'[{1,372512},{2,8671830},{3,158831},{4,171335},{5,31921},{6,31921},{7,20433},{8,20433},{48,8100},{49,7599}]',30082709),(769,'[{1,373572},{2,8696181},{3,159348},{4,171866},{5,31998},{6,31998},{7,20512},{8,20512},{48,8100},{49,7630}]',30170940),(770,'[{1,374632},{2,8720532},{3,159865},{4,172398},{5,32074},{6,32074},{7,20590},{8,20590},{48,8100},{49,7661}]',30259171),(771,'[{1,375692},{2,8744883},{3,160382},{4,172929},{5,32151},{6,32151},{7,20669},{8,20669},{48,8100},{49,7692}]',30347401),(772,'[{1,376752},{2,8769234},{3,160899},{4,173461},{5,32228},{6,32228},{7,20748},{8,20748},{48,8100},{49,7723}]',30435632),(773,'[{1,377813},{2,8793585},{3,161416},{4,173992},{5,32305},{6,32305},{7,20826},{8,20826},{48,8100},{49,7754}]',30523863),(774,'[{1,378873},{2,8817936},{3,161933},{4,174524},{5,32381},{6,32381},{7,20905},{8,20905},{48,8100},{49,7785}]',30612094),(775,'[{1,379933},{2,8842287},{3,162450},{4,175055},{5,32458},{6,32458},{7,20984},{8,20984},{48,8100},{49,7816}]',30700325),(776,'[{1,380993},{2,8866638},{3,162966},{4,175586},{5,32535},{6,32535},{7,21062},{8,21062},{48,8100},{49,7846}]',30788556),(777,'[{1,382053},{2,8890989},{3,163483},{4,176118},{5,32611},{6,32611},{7,21141},{8,21141},{48,8100},{49,7877}]',30876787),(778,'[{1,383114},{2,8915340},{3,164000},{4,176649},{5,32688},{6,32688},{7,21219},{8,21219},{48,8100},{49,7908}]',30965018),(779,'[{1,384174},{2,8939691},{3,164517},{4,177181},{5,32765},{6,32765},{7,21298},{8,21298},{48,8100},{49,7939}]',31053249),(780,'[{1,385234},{2,8964042},{3,165034},{4,177712},{5,32842},{6,32842},{7,21377},{8,21377},{48,8100},{49,7970}]',31141479),(781,'[{1,386294},{2,8988393},{3,165551},{4,178244},{5,32918},{6,32918},{7,21455},{8,21455},{48,8100},{49,8001}]',31229710),(782,'[{1,387354},{2,9012744},{3,166068},{4,178775},{5,32995},{6,32995},{7,21534},{8,21534},{48,8100},{49,8032}]',31317941),(783,'[{1,388414},{2,9037095},{3,166585},{4,179306},{5,33072},{6,33072},{7,21613},{8,21613},{48,8100},{49,8063}]',31406172),(784,'[{1,389475},{2,9061446},{3,167102},{4,179838},{5,33149},{6,33149},{7,21691},{8,21691},{48,8100},{49,8094}]',31494403),(785,'[{1,390535},{2,9085797},{3,167619},{4,180369},{5,33225},{6,33225},{7,21770},{8,21770},{48,8100},{49,8125}]',31582634),(786,'[{1,391595},{2,9110148},{3,168136},{4,180901},{5,33302},{6,33302},{7,21849},{8,21849},{48,8100},{49,8156}]',31670865),(787,'[{1,392655},{2,9134499},{3,168653},{4,181432},{5,33379},{6,33379},{7,21927},{8,21927},{48,8100},{49,8187}]',31759096),(788,'[{1,393715},{2,9158850},{3,169170},{4,181963},{5,33456},{6,33456},{7,22006},{8,22006},{48,8100},{49,8218}]',31847326),(789,'[{1,394776},{2,9183201},{3,169687},{4,182495},{5,33532},{6,33532},{7,22084},{8,22084},{48,8100},{49,8249}]',31935557),(790,'[{1,395836},{2,9207552},{3,170204},{4,183026},{5,33609},{6,33609},{7,22163},{8,22163},{48,8100},{49,8280}]',32023788),(791,'[{1,396896},{2,9231903},{3,170721},{4,183558},{5,33686},{6,33686},{7,22242},{8,22242},{48,8100},{49,8311}]',32112019),(792,'[{1,397956},{2,9256254},{3,171238},{4,184089},{5,33763},{6,33763},{7,22320},{8,22320},{48,8100},{49,8342}]',32200250),(793,'[{1,399016},{2,9280605},{3,171755},{4,184621},{5,33839},{6,33839},{7,22399},{8,22399},{48,8100},{49,8373}]',32288481),(794,'[{1,400076},{2,9304956},{3,172272},{4,185152},{5,33916},{6,33916},{7,22478},{8,22478},{48,8100},{49,8404}]',32376712),(795,'[{1,401137},{2,9329307},{3,172789},{4,185683},{5,33993},{6,33993},{7,22556},{8,22556},{48,8100},{49,8435}]',32464943),(796,'[{1,402197},{2,9353658},{3,173306},{4,186215},{5,34070},{6,34070},{7,22635},{8,22635},{48,8100},{49,8466}]',32553173),(797,'[{1,403257},{2,9378009},{3,173823},{4,186746},{5,34146},{6,34146},{7,22714},{8,22714},{48,8100},{49,8497}]',32641404),(798,'[{1,404317},{2,9402360},{3,174340},{4,187278},{5,34223},{6,34223},{7,22792},{8,22792},{48,8100},{49,8528}]',32729635),(799,'[{1,405377},{2,9426711},{3,174857},{4,187809},{5,34300},{6,34300},{7,22871},{8,22871},{48,8100},{49,8559}]',32817866),(800,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(801,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(802,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(803,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(804,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(805,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(806,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(807,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(808,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(809,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(810,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(811,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(812,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(813,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(814,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(815,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(816,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(817,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(818,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(819,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(820,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(821,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(822,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(823,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(824,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(825,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(826,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(827,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(828,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(829,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(830,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(831,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(832,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(833,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(834,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(835,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(836,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(837,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(838,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(839,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(840,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(841,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(842,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(843,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(844,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(845,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(846,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(847,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(848,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(849,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(850,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(851,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(852,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(853,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(854,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(855,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(856,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(857,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(858,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(859,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(860,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(861,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(862,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(863,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(864,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(865,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(866,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(867,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(868,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(869,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(870,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(871,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(872,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(873,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(874,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(875,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(876,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(877,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(878,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(879,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(880,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(881,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(882,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(883,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(884,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(885,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(886,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(887,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(888,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(889,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(890,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(891,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(892,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(893,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(894,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(895,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(896,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(897,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(898,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(899,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(900,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(901,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(902,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(903,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(904,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(905,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(906,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(907,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(908,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(909,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(910,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(911,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(912,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(913,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(914,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(915,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(916,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(917,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(918,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(919,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(920,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(921,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(922,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(923,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(924,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(925,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(926,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(927,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(928,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(929,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(930,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(931,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(932,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(933,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(934,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(935,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(936,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(937,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(938,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(939,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(940,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(941,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(942,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(943,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(944,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(945,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(946,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(947,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(948,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(949,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(950,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(951,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(952,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(953,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(954,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(955,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(956,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(957,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(958,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(959,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(960,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(961,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(962,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(963,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(964,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(965,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(966,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(967,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(968,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(969,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(970,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(971,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(972,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(973,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(974,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(975,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(976,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(977,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(978,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(979,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(980,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(981,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(982,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(983,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(984,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(985,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(986,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(987,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(988,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(989,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(990,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(991,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(992,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(993,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(994,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(995,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(996,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(997,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(998,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(999,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097),(1000,'[{1,406438},{2,9451062},{3,175374},{4,188341},{5,34377},{6,34377},{7,22950},{8,22950},{48,8100},{49,8590}]',32906097);
/*!40000 ALTER TABLE `base_fake_role` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_fake_star_soul`
--

DROP TABLE IF EXISTS `base_fake_star_soul`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_fake_star_soul` (
  `stage` smallint(5) unsigned NOT NULL COMMENT '阶数',
  `star` smallint(5) unsigned NOT NULL COMMENT '星阶',
  `attr_list` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '属性列表',
  `combat` int(11) unsigned NOT NULL COMMENT '战力',
  PRIMARY KEY (`stage`,`star`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星灵假人属性配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_fake_star_soul`
--

LOCK TABLES `base_fake_star_soul` WRITE;
/*!40000 ALTER TABLE `base_fake_star_soul` DISABLE KEYS */;
INSERT INTO `base_fake_star_soul` VALUES (1,0,'[{1,112},{2,2240},{3,56},{4,56},{5,28},{6,28},{7,28},{8,28}]',12880),(1,1,'[{1,139},{2,2778},{3,69},{4,69},{5,35},{6,35},{7,35},{8,35}]',15971),(1,2,'[{1,167},{2,3334},{3,83},{4,83},{5,42},{6,42},{7,42},{8,42}]',19165),(1,3,'[{1,196},{2,3907},{3,97},{4,97},{5,49},{6,49},{7,49},{8,49}]',22462),(2,0,'[{1,227},{2,4534},{3,113},{4,113},{5,57},{6,57},{7,57},{8,57}]',26068),(2,1,'[{1,259},{2,5179},{3,129},{4,129},{5,65},{6,65},{7,65},{8,65}]',29777),(2,2,'[{1,292},{2,5842},{3,146},{4,146},{5,73},{6,73},{7,73},{8,73}]',33589),(2,3,'[{1,326},{2,6523},{3,163},{4,163},{5,82},{6,82},{7,82},{8,82}]',37505),(3,0,'[{1,363},{2,7262},{3,181},{4,181},{5,91},{6,91},{7,91},{8,91}]',41755),(3,1,'[{1,401},{2,8019},{3,200},{4,200},{5,100},{6,100},{7,100},{8,100}]',46108),(3,2,'[{1,440},{2,8794},{3,219},{4,219},{5,110},{6,110},{7,110},{8,110}]',50564),(3,3,'[{1,480},{2,9587},{3,239},{4,239},{5,120},{6,120},{7,120},{8,120}]',55124),(4,0,'[{1,523},{2,10443},{3,260},{4,260},{5,131},{6,131},{7,131},{8,131}]',60044),(4,1,'[{1,567},{2,11321},{3,282},{4,282},{5,142},{6,142},{7,142},{8,142}]',65093),(4,2,'[{1,612},{2,12221},{3,305},{4,305},{5,153},{6,153},{7,153},{8,153}]',70271),(4,3,'[{1,658},{2,13144},{3,328},{4,328},{5,165},{6,165},{7,165},{8,165}]',75578),(5,0,'[{1,708},{2,14139},{3,353},{4,353},{5,177},{6,177},{7,177},{8,177}]',81297),(5,1,'[{1,759},{2,15156},{3,378},{4,378},{5,190},{6,190},{7,190},{8,190}]',87145),(5,2,'[{1,811},{2,16195},{3,404},{4,404},{5,203},{6,203},{7,203},{8,203}]',93121),(5,3,'[{1,864},{2,17257},{3,431},{4,431},{5,216},{6,216},{7,216},{8,216}]',99226),(6,0,'[{1,921},{2,18399},{3,460},{4,460},{5,230},{6,230},{7,230},{8,230}]',105795),(6,1,'[{1,979},{2,19564},{3,489},{4,489},{5,245},{6,245},{7,245},{8,245}]',112493),(6,2,'[{1,1038},{2,20751},{3,519},{4,519},{5,260},{6,260},{7,260},{8,260}]',119319),(6,3,'[{1,1098},{2,21961},{3,549},{4,549},{5,275},{6,275},{7,275},{8,275}]',126274),(7,0,'[{1,1163},{2,23260},{3,581},{4,581},{5,291},{6,291},{7,291},{8,291}]',133744),(7,1,'[{1,1229},{2,24582},{3,614},{4,614},{5,308},{6,308},{7,308},{8,308}]',141343),(7,2,'[{1,1296},{2,25926},{3,648},{4,648},{5,325},{6,325},{7,325},{8,325}]',149071),(7,3,'[{1,1364},{2,27292},{3,682},{4,682},{5,342},{6,342},{7,342},{8,342}]',156928),(8,0,'[{1,1437},{2,28757},{3,719},{4,719},{5,360},{6,360},{7,360},{8,360}]',165352),(8,1,'[{1,1512},{2,30249},{3,756},{4,756},{5,379},{6,379},{7,379},{8,379}]',173930),(8,2,'[{1,1588},{2,31768},{3,794},{4,794},{5,398},{6,398},{7,398},{8,398}]',182663),(8,3,'[{1,1665},{2,33314},{3,833},{4,833},{5,417},{6,417},{7,417},{8,417}]',191550),(9,0,'[{1,1748},{2,34967},{3,874},{4,874},{5,438},{6,438},{7,438},{8,438}]',201055),(9,1,'[{1,1832},{2,36647},{3,916},{4,916},{5,459},{6,459},{7,459},{8,459}]',210715),(9,2,'[{1,1917},{2,38354},{3,959},{4,959},{5,480},{6,480},{7,480},{8,480}]',220530),(9,3,'[{1,2004},{2,40088},{3,1002},{4,1002},{5,502},{6,502},{7,502},{8,502}]',230499),(10,0,'[{1,2097},{2,41938},{3,1048},{4,1048},{5,525},{6,525},{7,525},{8,525}]',241138),(10,1,'[{1,2191},{2,43815},{3,1095},{4,1095},{5,548},{6,548},{7,548},{8,548}]',251931),(10,2,'[{1,2286},{2,45719},{3,1143},{4,1143},{5,572},{6,572},{7,572},{8,572}]',262879),(10,3,'[{1,2383},{2,47650},{3,1191},{4,1191},{5,596},{6,596},{7,596},{8,596}]',273982),(11,0,'[{1,2486},{2,49706},{3,1242},{4,1242},{5,622},{6,622},{7,622},{8,622}]',285806),(11,1,'[{1,2590},{2,51789},{3,1294},{4,1294},{5,648},{6,648},{7,648},{8,648}]',297784),(11,2,'[{1,2696},{2,53899},{3,1347},{4,1347},{5,674},{6,674},{7,674},{8,674}]',309917),(11,3,'[{1,2803},{2,56036},{3,1400},{4,1400},{5,701},{6,701},{7,701},{8,701}]',322205),(12,0,'[{1,2917},{2,58307},{3,1457},{4,1457},{5,729},{6,729},{7,729},{8,729}]',335265),(12,1,'[{1,3032},{2,60610},{3,1515},{4,1515},{5,758},{6,758},{7,758},{8,758}]',348506),(12,2,'[{1,3149},{2,62944},{3,1573},{4,1573},{5,787},{6,787},{7,787},{8,787}]',361927),(12,3,'[{1,3267},{2,65309},{3,1632},{4,1632},{5,817},{6,817},{7,817},{8,817}]',375528),(13,0,'[{1,3392},{2,67818},{3,1695},{4,1695},{5,848},{6,848},{7,848},{8,848}]',389954),(13,1,'[{1,3519},{2,70358},{3,1759},{4,1759},{5,880},{6,880},{7,880},{8,880}]',404560),(13,2,'[{1,3648},{2,72930},{3,1823},{4,1823},{5,912},{6,912},{7,912},{8,912}]',419346),(13,3,'[{1,3778},{2,75533},{3,1888},{4,1888},{5,945},{6,945},{7,945},{8,945}]',434313),(14,0,'[{1,3916},{2,78288},{3,1957},{4,1957},{5,979},{6,979},{7,979},{8,979}]',450155),(14,1,'[{1,4055},{2,81075},{3,2027},{4,2027},{5,1014},{6,1014},{7,1014},{8,1014}]',466178),(14,2,'[{1,4196},{2,83893},{3,2097},{4,2097},{5,1049},{6,1049},{7,1049},{8,1049}]',482381),(14,3,'[{1,4338},{2,86742},{3,2168},{4,2168},{5,1085},{6,1085},{7,1085},{8,1085}]',498764),(15,0,'[{1,4489},{2,89753},{3,2243},{4,2243},{5,1123},{6,1123},{7,1123},{8,1123}]',516075),(15,1,'[{1,4641},{2,92795},{3,2319},{4,2319},{5,1161},{6,1161},{7,1161},{8,1161}]',533566),(15,2,'[{1,4795},{2,95868},{3,2396},{4,2396},{5,1199},{6,1199},{7,1199},{8,1199}]',551237),(15,3,'[{1,4950},{2,98973},{3,2474},{4,2474},{5,1238},{6,1238},{7,1238},{8,1238}]',569089),(16,0,'[{1,5114},{2,102248},{3,2556},{4,2556},{5,1279},{6,1279},{7,1279},{8,1279}]',587920),(16,1,'[{1,5279},{2,105554},{3,2639},{4,2639},{5,1320},{6,1320},{7,1320},{8,1320}]',606931),(16,2,'[{1,5446},{2,108892},{3,2722},{4,2722},{5,1362},{6,1362},{7,1362},{8,1362}]',626122),(16,3,'[{1,5614},{2,112261},{3,2806},{4,2806},{5,1404},{6,1404},{7,1404},{8,1404}]',645494),(17,0,'[{1,5791},{2,115809},{3,2895},{4,2895},{5,1448},{6,1448},{7,1448},{8,1448}]',665896),(17,1,'[{1,5970},{2,119389},{3,2984},{4,2984},{5,1493},{6,1493},{7,1493},{8,1493}]',686478),(17,2,'[{1,6151},{2,123000},{3,3074},{4,3074},{5,1538},{6,1538},{7,1538},{8,1538}]',707241),(17,3,'[{1,6333},{2,126642},{3,3165},{4,3165},{5,1584},{6,1584},{7,1584},{8,1584}]',728184),(18,0,'[{1,6525},{2,130472},{3,3261},{4,3261},{5,1632},{6,1632},{7,1632},{8,1632}]',750209),(18,1,'[{1,6718},{2,134338},{3,3358},{4,3358},{5,1680},{6,1680},{7,1680},{8,1680}]',772440),(18,2,'[{1,6913},{2,138240},{3,3456},{4,3456},{5,1729},{6,1729},{7,1729},{8,1729}]',794877),(18,3,'[{1,7110},{2,142178},{3,3554},{4,3554},{5,1778},{6,1778},{7,1778},{8,1778}]',817520),(19,0,'[{1,7317},{2,146313},{3,3657},{4,3657},{5,1830},{6,1830},{7,1830},{8,1830}]',841296),(19,1,'[{1,7526},{2,150484},{3,3761},{4,3761},{5,1882},{6,1882},{7,1882},{8,1882}]',865279),(19,2,'[{1,7736},{2,154691},{3,3866},{4,3866},{5,1935},{6,1935},{7,1935},{8,1935}]',889468),(19,3,'[{1,7948},{2,158934},{3,3972},{4,3972},{5,1988},{6,1988},{7,1988},{8,1988}]',913863),(20,0,'[{1,8170},{2,163383},{3,4083},{4,4083},{5,2044},{6,2044},{7,2044},{8,2044}]',939443),(20,1,'[{1,8394},{2,167867},{3,4195},{4,4195},{5,2100},{6,2100},{7,2100},{8,2100}]',965229),(20,2,'[{1,8620},{2,172387},{3,4308},{4,4308},{5,2157},{6,2157},{7,2157},{8,2157}]',991221),(20,3,'[{1,8848},{2,176943},{3,4422},{4,4422},{5,2214},{6,2214},{7,2214},{8,2214}]',1017419),(21,0,'[{1,9087},{2,181714},{3,4541},{4,4541},{5,2274},{6,2274},{7,2274},{8,2274}]',1044853),(21,1,'[{1,9328},{2,186526},{3,4661},{4,4661},{5,2334},{6,2334},{7,2334},{8,2334}]',1072519),(21,2,'[{1,9571},{2,191378},{3,4782},{4,4782},{5,2395},{6,2395},{7,2395},{8,2395}]',1100417),(21,3,'[{1,9816},{2,196270},{3,4904},{4,4904},{5,2456},{6,2456},{7,2456},{8,2456}]',1128547),(22,0,'[{1,10072},{2,201386},{3,5032},{4,5032},{5,2520},{6,2520},{7,2520},{8,2520}]',1157965),(22,1,'[{1,10330},{2,206542},{3,5161},{4,5161},{5,2584},{6,2584},{7,2584},{8,2584}]',1187615),(22,2,'[{1,10590},{2,211739},{3,5291},{4,5291},{5,2649},{6,2649},{7,2649},{8,2649}]',1217497),(22,3,'[{1,10852},{2,216976},{3,5422},{4,5422},{5,2714},{6,2714},{7,2714},{8,2714}]',1247610),(23,0,'[{1,11126},{2,222446},{3,5559},{4,5559},{5,2782},{6,2782},{7,2782},{8,2782}]',1279063),(23,1,'[{1,11402},{2,227961},{3,5697},{4,5697},{5,2851},{6,2851},{7,2851},{8,2851}]',1310774),(23,2,'[{1,11680},{2,233521},{3,5836},{4,5836},{5,2920},{6,2920},{7,2920},{8,2920}]',1342742),(23,3,'[{1,11960},{2,239125},{3,5976},{4,5976},{5,2990},{6,2990},{7,2990},{8,2990}]',1374968),(24,0,'[{1,12252},{2,244971},{3,6122},{4,6122},{5,3063},{6,3063},{7,3063},{8,3063}]',1408585),(24,1,'[{1,12547},{2,250867},{3,6269},{4,6269},{5,3137},{6,3137},{7,3137},{8,3137}]',1442485),(24,2,'[{1,12844},{2,256812},{3,6418},{4,6418},{5,3211},{6,3211},{7,3211},{8,3211}]',1476669),(24,3,'[{1,13144},{2,262806},{3,6568},{4,6568},{5,3286},{6,3286},{7,3286},{8,3286}]',1511136),(25,0,'[{1,13456},{2,269051},{3,6724},{4,6724},{5,3364},{6,3364},{7,3364},{8,3364}]',1547045),(25,1,'[{1,13771},{2,275350},{3,6881},{4,6881},{5,3443},{6,3443},{7,3443},{8,3443}]',1583264),(25,2,'[{1,14089},{2,281703},{3,7040},{4,7040},{5,3522},{6,3522},{7,3522},{8,3522}]',1619792),(25,3,'[{1,14409},{2,288109},{3,7200},{4,7200},{5,3602},{6,3602},{7,3602},{8,3602}]',1656629),(26,0,'[{1,14742},{2,294775},{3,7367},{4,7367},{5,3685},{6,3685},{7,3685},{8,3685}]',1694960),(26,1,'[{1,15078},{2,301499},{3,7535},{4,7535},{5,3769},{6,3769},{7,3769},{8,3769}]',1733626),(26,2,'[{1,15417},{2,308282},{3,7705},{4,7705},{5,3854},{6,3854},{7,3854},{8,3854}]',1772627),(26,3,'[{1,15759},{2,315123},{3,7876},{4,7876},{5,3940},{6,3940},{7,3940},{8,3940}]',1811963),(27,0,'[{1,16114},{2,322233},{3,8054},{4,8054},{5,4029},{6,4029},{7,4029},{8,4029}]',1852844),(27,1,'[{1,16473},{2,329405},{3,8233},{4,8233},{5,4119},{6,4119},{7,4119},{8,4119}]',1894086),(27,2,'[{1,16835},{2,336640},{3,8414},{4,8414},{5,4209},{6,4209},{7,4209},{8,4209}]',1935688),(27,3,'[{1,17200},{2,343938},{3,8596},{4,8596},{5,4300},{6,4300},{7,4300},{8,4300}]',1977651),(28,0,'[{1,17579},{2,351514},{3,8785},{4,8785},{5,4395},{6,4395},{7,4395},{8,4395}]',2021211),(28,1,'[{1,17961},{2,359157},{3,8976},{4,8976},{5,4491},{6,4491},{7,4491},{8,4491}]',2065158),(28,2,'[{1,18347},{2,366867},{3,9169},{4,9169},{5,4587},{6,4587},{7,4587},{8,4587}]',2109491),(28,3,'[{1,18736},{2,374644},{3,9363},{4,9363},{5,4684},{6,4684},{7,4684},{8,4684}]',2154210),(29,0,'[{1,19139},{2,382708},{3,9565},{4,9565},{5,4785},{6,4785},{7,4785},{8,4785}]',2200578),(29,1,'[{1,19546},{2,390844},{3,9768},{4,9768},{5,4887},{6,4887},{7,4887},{8,4887}]',2247358),(29,2,'[{1,19956},{2,399051},{3,9973},{4,9973},{5,4990},{6,4990},{7,4990},{8,4990}]',2294550),(29,3,'[{1,20370},{2,407330},{3,10180},{4,10180},{5,5093},{6,5093},{7,5093},{8,5093}]',2342154),(30,0,'[{1,20799},{2,415905},{3,10394},{4,10394},{5,5200},{6,5200},{7,5200},{8,5200}]',2391459),(30,1,'[{1,21232},{2,424556},{3,10610},{4,10610},{5,5308},{6,5308},{7,5308},{8,5308}]',2441202),(30,2,'[{1,21668},{2,433283},{3,10828},{4,10828},{5,5417},{6,5417},{7,5417},{8,5417}]',2491382),(30,3,'[{1,22108},{2,442086},{3,11048},{4,11048},{5,5527},{6,5527},{7,5527},{8,5527}]',2542000);
/*!40000 ALTER TABLE `base_fake_star_soul` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_fame_lv`
--

DROP TABLE IF EXISTS `base_fame_lv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_fame_lv` (
  `lv` int(11) unsigned NOT NULL COMMENT '名誉等级',
  `color` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '颜色',
  `name` varchar(255) NOT NULL COMMENT '名誉名字@lang@',
  `fame` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '所需名誉',
  `attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '属性加成',
  PRIMARY KEY (`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='名誉等级配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_fame_lv`
--

LOCK TABLES `base_fame_lv` WRITE;
/*!40000 ALTER TABLE `base_fame_lv` DISABLE KEYS */;
INSERT INTO `base_fame_lv` VALUES (1,1,'默默无闻',0,'[{1,0},{2,0}]'),(2,1,'人情练达',699,'[{3,120},{4,120}]'),(3,1,'左右逢源',1399,'[{3,240},{4,240}]'),(4,1,'屈尊敬贤',2499,'[{3,400},{4,400}]'),(5,1,'八面玲珑',3699,'[{3,600},{4,600}]'),(6,1,'高朋满座',6999,'[{3,800},{4,800}]'),(7,1,'宾客盈门',11620,'[{3,1080},{4,1080}]'),(8,1,'家喻户晓',20520,'[{3,1440},{4,1440}]'),(9,1,'声名显赫',34999,'[{3,2000},{4,2000}]'),(10,1,'大名鼎鼎',69999,'[{3,2800},{4,2800}]'),(11,1,'名动四方',139999,'[{3,4000},{4,4000}]');
/*!40000 ALTER TABLE `base_fame_lv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_fashion`
--

DROP TABLE IF EXISTS `base_fashion`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_fashion` (
  `pos_id` int(11) unsigned NOT NULL COMMENT '位置id',
  `fashion_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时装id',
  `star_lv` int(10) unsigned NOT NULL COMMENT '星级',
  `star_cost` varchar(500) NOT NULL COMMENT '升星消耗',
  `attr_list` varchar(500) NOT NULL COMMENT '基础属性列表',
  `power` varchar(255) NOT NULL COMMENT '战力（显示用）',
  PRIMARY KEY (`pos_id`,`fashion_id`,`star_lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='时装配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_fashion`
--

LOCK TABLES `base_fashion` WRITE;
/*!40000 ALTER TABLE `base_fashion` DISABLE KEYS */;
INSERT INTO `base_fashion` VALUES (1,12010001,0,'[{0,12010001,1}]','[{2,3360},{4,84},{8,28}]','6860'),(1,12010001,1,'[{0,12010001,1}]','[{2,6000},{4,150},{8,50}]','12250'),(1,12010001,2,'[{0,12010001,2}]','[{2,9360},{4,234},{8,78}]','19110'),(1,12010001,3,'[{0,12010001,4}]','[{2,13200},{4,330},{8,110}]','26950'),(1,12010001,4,'[{0,12010001,6}]','[{2,17520},{4,438},{8,146}]','35770'),(1,12010001,5,'[{0,12010001,8}]','[{2,22560},{4,564},{8,188}]','46060'),(1,12010002,0,'[{0,12010002,1}]','[{2,4320},{4,108},{8,36}]','8820'),(1,12010002,1,'[{0,12010002,1}]','[{2,7780},{4,195},{8,65}]','15905'),(1,12010002,2,'[{0,12010002,2}]','[{2,12100},{4,303},{8,101}]','24725'),(1,12010002,3,'[{0,12010002,4}]','[{2,17280},{4,433},{8,144}]','35305'),(1,12010002,4,'[{0,12010002,6}]','[{2,23320},{4,584},{8,194}]','47620'),(1,12010002,5,'[{0,12010002,8}]','[{2,30240},{4,757},{8,252}]','61765'),(1,12010003,0,'[{0,12010003,1}]','[{2,2400},{4,60},{8,20}]','4900'),(1,12010003,1,'[{0,12010003,1}]','[{2,4320},{4,108},{8,36}]','8820'),(1,12010003,2,'[{0,12010003,2}]','[{2,6720},{4,168},{8,56}]','13720'),(1,12010003,3,'[{0,12010003,4}]','[{2,9620},{4,241},{8,80}]','19645'),(1,12010003,4,'[{0,12010003,6}]','[{2,13000},{4,326},{8,108}]','26550'),(1,12010003,5,'[{0,12010003,8}]','[{2,16860},{4,423},{8,140}]','34435'),(1,12010004,0,'[{0,12010004,1}]','[{2,3580},{4,90},{8,30}]','7330'),(1,12010004,1,'[{0,12010004,1}]','[{2,6440},{4,162},{8,54}]','13190'),(1,12010004,2,'[{0,12010004,2}]','[{2,10020},{4,252},{8,84}]','20520'),(1,12010004,3,'[{0,12010004,4}]','[{2,14320},{4,360},{8,120}]','29320'),(1,12010004,4,'[{0,12010004,6}]','[{2,19340},{4,486},{8,162}]','39590'),(1,12010004,5,'[{0,12010004,8}]','[{2,25080},{4,630},{8,210}]','51330'),(1,12010005,0,'[{0,12010005,1}]','[{2,1820},{4,46},{8,15}]','3720'),(1,12010005,1,'[{0,12010005,1}]','[{2,3280},{4,83},{8,27}]','6705'),(1,12010005,2,'[{0,12010005,2}]','[{2,5100},{4,129},{8,42}]','10425'),(1,12010005,3,'[{0,12010005,4}]','[{2,7280},{4,184},{8,60}]','14880'),(1,12010005,4,'[{0,12010005,6}]','[{2,9840},{4,248},{8,81}]','20090'),(1,12010005,5,'[{0,12010005,8}]','[{2,12760},{4,321},{8,105}]','26035'),(1,12010006,0,'[{0,12010006,1}]','[{2,2860},{4,72},{8,24}]','5860'),(1,12010006,1,'[{0,12010006,1}]','[{2,5140},{4,129},{8,43}]','10515'),(1,12010006,2,'[{0,12010006,2}]','[{2,8000},{4,201},{8,67}]','16375'),(1,12010006,3,'[{0,12010006,4}]','[{2,11420},{4,287},{8,96}]','23395'),(1,12010006,4,'[{0,12010006,6}]','[{2,15420},{4,387},{8,129}]','31545'),(1,12010006,5,'[{0,12010006,8}]','[{2,19980},{4,501},{8,167}]','40855'),(1,12010007,0,'[{0,12010007,1}]','[{2,5060},{4,127},{8,42}]','10335'),(1,12010007,1,'[{0,12010007,1}]','[{2,9100},{4,228},{8,76}]','18600'),(1,12010007,2,'[{0,12010007,2}]','[{2,14160},{4,355},{8,118}]','28935'),(1,12010007,3,'[{0,12010007,4}]','[{2,20220},{4,507},{8,169}]','41345'),(1,12010007,4,'[{0,12010007,6}]','[{2,27300},{4,684},{8,228}]','55800'),(1,12010007,5,'[{0,12010007,8}]','[{2,35380},{4,886},{8,295}]','72280'),(1,12010008,0,'[{0,12010008,1}]','[{2,4320},{4,108},{8,36}]','8820'),(1,12010008,1,'[{0,12010008,1}]','[{2,7780},{4,195},{8,65}]','15905'),(1,12010008,2,'[{0,12010008,2}]','[{2,12100},{4,303},{8,101}]','24725'),(1,12010008,3,'[{0,12010008,4}]','[{2,17280},{4,433},{8,144}]','35305'),(1,12010008,4,'[{0,12010008,6}]','[{2,23320},{4,584},{8,194}]','47620'),(1,12010008,5,'[{0,12010008,8}]','[{2,30240},{4,757},{8,252}]','61765'),(1,12010009,0,'[{0,12010009,1}]','[{2,3740},{4,94},{8,31}]','7640'),(1,12010009,1,'[{0,12010009,1}]','[{2,6740},{4,169},{8,56}]','13765'),(1,12010009,2,'[{0,12010009,2}]','[{2,10480},{4,263},{8,87}]','21405'),(1,12010009,3,'[{0,12010009,4}]','[{2,14980},{4,376},{8,125}]','30630'),(1,12010009,4,'[{0,12010009,6}]','[{2,20220},{4,507},{8,169}]','41345'),(1,12010009,5,'[{0,12010009,8}]','[{2,26220},{4,657},{8,219}]','53595'),(1,12010010,0,'[{0,12010010,1}]','[{2,3740},{4,94},{8,31}]','7640'),(1,12010010,1,'[{0,12010010,1}]','[{2,6740},{4,169},{8,56}]','13765'),(1,12010010,2,'[{0,12010010,2}]','[{2,10480},{4,263},{8,87}]','21405'),(1,12010010,3,'[{0,12010010,4}]','[{2,14980},{4,376},{8,125}]','30630'),(1,12010010,4,'[{0,12010010,6}]','[{2,20220},{4,507},{8,169}]','41345'),(1,12010010,5,'[{0,12010010,8}]','[{2,26220},{4,657},{8,219}]','53595'),(1,12010011,0,'[{0,12010011,1}]','[{2,3740},{4,94},{8,31}]','7640'),(1,12010011,1,'[{0,12010011,1}]','[{2,6740},{4,169},{8,56}]','13765'),(1,12010011,2,'[{0,12010011,2}]','[{2,10480},{4,263},{8,87}]','21405'),(1,12010011,3,'[{0,12010011,4}]','[{2,14980},{4,376},{8,125}]','30630'),(1,12010011,4,'[{0,12010011,6}]','[{2,20220},{4,507},{8,169}]','41345'),(1,12010011,5,'[{0,12010011,8}]','[{2,26220},{4,657},{8,219}]','53595'),(1,12010012,0,'[{0,12010012,1}]','[{2,3300},{4,83},{8,28}]','6775'),(1,12010012,1,'[{0,12010012,1}]','[{2,5940},{4,149},{8,50}]','12165'),(1,12010012,2,'[{0,12010012,2}]','[{2,9240},{4,232},{8,78}]','18940'),(1,12010012,3,'[{0,12010012,4}]','[{2,13200},{4,331},{8,111}]','27025'),(1,12010012,4,'[{0,12010012,6}]','[{2,17820},{4,447},{8,150}]','36495'),(1,12010012,5,'[{0,12010012,8}]','[{2,23100},{4,579},{8,194}]','47275'),(2,12020001,0,'[{0,12020001,1}]','[{1,205},{3,84},{48,21}]','6830'),(2,12020001,1,'[{0,12020001,1}]','[{1,365},{3,150},{48,37}]','12160'),(2,12020001,2,'[{0,12020001,2}]','[{1,570},{3,234},{48,58}]','18990'),(2,12020001,3,'[{0,12020001,4}]','[{1,805},{3,330},{48,82}]','26810'),(2,12020001,4,'[{0,12020001,6}]','[{1,1070},{3,438},{48,109}]','35620'),(2,12020001,5,'[{0,12020001,8}]','[{1,1380},{3,564},{48,140}]','45900'),(2,12020002,0,'[{0,12020002,1}]','[{1,265},{3,108},{48,27}]','8810'),(2,12020002,1,'[{0,12020002,1}]','[{1,477},{3,195},{48,48}]','15855'),(2,12020002,2,'[{0,12020002,2}]','[{1,742},{3,303},{48,75}]','24665'),(2,12020002,3,'[{0,12020002,4}]','[{1,1060},{3,433},{48,107}]','35235'),(2,12020002,4,'[{0,12020002,6}]','[{1,1431},{3,584},{48,144}]','47540'),(2,12020002,5,'[{0,12020002,8}]','[{1,1857},{3,757},{48,187}]','61675'),(2,12020003,0,'[{0,12020003,1}]','[{1,148},{3,60},{48,15}]','4910'),(2,12020003,1,'[{0,12020003,1}]','[{1,266},{3,108},{48,27}]','8830'),(2,12020003,2,'[{0,12020003,2}]','[{1,414},{3,168},{48,42}]','13740'),(2,12020003,3,'[{0,12020003,4}]','[{1,591},{3,241},{48,60}]','19645'),(2,12020003,4,'[{0,12020003,6}]','[{1,798},{3,326},{48,81}]','26540'),(2,12020003,5,'[{0,12020003,8}]','[{1,1035},{3,423},{48,105}]','34425'),(2,12020004,0,'[{0,12020004,1}]','[{1,220},{3,90},{48,22}]','7310'),(2,12020004,1,'[{0,12020004,1}]','[{1,396},{3,162},{48,40}]','13170'),(2,12020004,2,'[{0,12020004,2}]','[{1,616},{3,252},{48,62}]','20480'),(2,12020004,3,'[{0,12020004,4}]','[{1,880},{3,360},{48,88}]','29240'),(2,12020004,4,'[{0,12020004,6}]','[{1,1188},{3,486},{48,119}]','39480'),(2,12020004,5,'[{0,12020004,8}]','[{1,1541},{3,630},{48,154}]','51190'),(2,12020005,0,'[{0,12020005,1}]','[{1,112},{3,46},{48,11}]','3720'),(2,12020005,1,'[{0,12020005,1}]','[{1,201},{3,83},{48,20}]','6695'),(2,12020005,2,'[{0,12020005,2}]','[{1,313},{3,129},{48,31}]','10415'),(2,12020005,3,'[{0,12020005,4}]','[{1,447},{3,184},{48,44}]','14860'),(2,12020005,4,'[{0,12020005,6}]','[{1,604},{3,248},{48,60}]','20080'),(2,12020005,5,'[{0,12020005,8}]','[{1,783},{3,321},{48,78}]','26025'),(2,12020006,0,'[{0,12020006,1}]','[{1,175},{3,72},{48,18}]','5840'),(2,12020006,1,'[{0,12020006,1}]','[{1,315},{3,129},{48,32}]','10485'),(2,12020006,2,'[{0,12020006,2}]','[{1,490},{3,201},{48,50}]','16325'),(2,12020006,3,'[{0,12020006,4}]','[{1,700},{3,287},{48,71}]','23305'),(2,12020006,4,'[{0,12020006,6}]','[{1,945},{3,387},{48,96}]','31455'),(2,12020006,5,'[{0,12020006,8}]','[{1,1226},{3,501},{48,124}]','40765'),(2,12020007,0,'[{0,12020007,1}]','[{1,310},{3,127},{48,31}]','10305'),(2,12020007,1,'[{0,12020007,1}]','[{1,558},{3,228},{48,56}]','18540'),(2,12020007,2,'[{0,12020007,2}]','[{1,868},{3,355},{48,87}]','28845'),(2,12020007,3,'[{0,12020007,4}]','[{1,1240},{3,507},{48,124}]','41195'),(2,12020007,4,'[{0,12020007,6}]','[{1,1675},{3,684},{48,168}]','55640'),(2,12020007,5,'[{0,12020007,8}]','[{1,2173},{3,886},{48,218}]','72150'),(2,12020008,0,'[{0,12020008,1}]','[{1,265},{3,108},{48,27}]','8810'),(2,12020008,1,'[{0,12020008,1}]','[{1,477},{3,195},{48,48}]','15855'),(2,12020008,2,'[{0,12020008,2}]','[{1,742},{3,303},{48,75}]','24665'),(2,12020008,3,'[{0,12020008,4}]','[{1,1060},{3,433},{48,107}]','35235'),(2,12020008,4,'[{0,12020008,6}]','[{1,1431},{3,584},{48,144}]','47540'),(2,12020008,5,'[{0,12020008,8}]','[{1,1857},{3,757},{48,187}]','61675'),(2,12020009,0,'[{0,12020009,1}]','[{1,230},{3,94},{48,23}]','7640'),(2,12020009,1,'[{0,12020009,1}]','[{1,414},{3,169},{48,41}]','13735'),(2,12020009,2,'[{0,12020009,2}]','[{1,644},{3,263},{48,64}]','21375'),(2,12020009,3,'[{0,12020009,4}]','[{1,920},{3,376},{48,92}]','30560'),(2,12020009,4,'[{0,12020009,6}]','[{1,1242},{3,507},{48,124}]','41235'),(2,12020009,5,'[{0,12020009,8}]','[{1,1611},{3,657},{48,161}]','53475'),(2,12020010,0,'[{0,12020010,1}]','[{1,230},{3,94},{48,23}]','7640'),(2,12020010,1,'[{0,12020010,1}]','[{1,414},{3,169},{48,41}]','13735'),(2,12020010,2,'[{0,12020010,2}]','[{1,644},{3,263},{48,64}]','21375'),(2,12020010,3,'[{0,12020010,4}]','[{1,920},{3,376},{48,92}]','30560'),(2,12020010,4,'[{0,12020010,6}]','[{1,1242},{3,507},{48,124}]','41235'),(2,12020010,5,'[{0,12020010,8}]','[{1,1611},{3,657},{48,161}]','53475'),(2,12020011,0,'[{0,12020011,1}]','[{1,230},{3,94},{48,23}]','7640'),(2,12020011,1,'[{0,12020011,1}]','[{1,414},{3,169},{48,41}]','13735'),(2,12020011,2,'[{0,12020011,2}]','[{1,644},{3,263},{48,64}]','21375'),(2,12020011,3,'[{0,12020011,4}]','[{1,920},{3,376},{48,92}]','30560'),(2,12020011,4,'[{0,12020011,6}]','[{1,1242},{3,507},{48,124}]','41235'),(2,12020011,5,'[{0,12020011,8}]','[{1,1611},{3,657},{48,161}]','53475'),(2,12020012,0,'[{0,12020012,1}]','[{1,203},{3,83},{48,20}]','6735'),(2,12020012,1,'[{0,12020012,1}]','[{1,365},{3,149},{48,36}]','12105'),(2,12020012,2,'[{0,12020012,2}]','[{1,568},{3,232},{48,56}]','18840'),(2,12020012,3,'[{0,12020012,4}]','[{1,811},{3,331},{48,80}]','26895'),(2,12020012,4,'[{0,12020012,6}]','[{1,1095},{3,447},{48,108}]','36315'),(2,12020012,5,'[{0,12020012,8}]','[{1,1421},{3,579},{48,141}]','47125'),(3,12030001,0,'[{0,12030001,1}]','[{1,168},{5,42},{7,28}]','6860'),(3,12030001,1,'[{0,12030001,1}]','[{1,300},{5,75},{7,50}]','12250'),(3,12030001,2,'[{0,12030001,2}]','[{1,468},{5,117},{7,78}]','19110'),(3,12030001,3,'[{0,12030001,4}]','[{1,660},{5,165},{7,110}]','26950'),(3,12030001,4,'[{0,12030001,6}]','[{1,876},{5,219},{7,146}]','35770'),(3,12030001,5,'[{0,12030001,8}]','[{1,1128},{5,282},{7,188}]','46060'),(3,12030002,0,'[{0,12030002,1}]','[{1,216},{5,54},{7,36}]','8820'),(3,12030002,1,'[{0,12030002,1}]','[{1,389},{5,97},{7,65}]','15880'),(3,12030002,2,'[{0,12030002,2}]','[{1,605},{5,151},{7,101}]','24700'),(3,12030002,3,'[{0,12030002,4}]','[{1,864},{5,216},{7,144}]','35280'),(3,12030002,4,'[{0,12030002,6}]','[{1,1166},{5,292},{7,194}]','47620'),(3,12030002,5,'[{0,12030002,8}]','[{1,1512},{5,379},{7,252}]','61790'),(3,12030003,0,'[{0,12030003,1}]','[{1,120},{5,30},{7,20}]','4900'),(3,12030003,1,'[{0,12030003,1}]','[{1,216},{5,54},{7,36}]','8820'),(3,12030003,2,'[{0,12030003,2}]','[{1,336},{5,84},{7,56}]','13720'),(3,12030003,3,'[{0,12030003,4}]','[{1,481},{5,120},{7,80}]','19620'),(3,12030003,4,'[{0,12030003,6}]','[{1,650},{5,162},{7,108}]','26500'),(3,12030003,5,'[{0,12030003,8}]','[{1,843},{5,210},{7,140}]','34360'),(3,12030004,0,'[{0,12030004,1}]','[{1,179},{5,45},{7,30}]','7330'),(3,12030004,1,'[{0,12030004,1}]','[{1,322},{5,81},{7,54}]','13190'),(3,12030004,2,'[{0,12030004,2}]','[{1,501},{5,126},{7,84}]','20520'),(3,12030004,3,'[{0,12030004,4}]','[{1,716},{5,180},{7,120}]','29320'),(3,12030004,4,'[{0,12030004,6}]','[{1,967},{5,243},{7,162}]','39590'),(3,12030004,5,'[{0,12030004,8}]','[{1,1254},{5,315},{7,210}]','51330'),(3,12030005,0,'[{0,12030005,1}]','[{1,91},{5,23},{7,15}]','3720'),(3,12030005,1,'[{0,12030005,1}]','[{1,164},{5,41},{7,27}]','6680'),(3,12030005,2,'[{0,12030005,2}]','[{1,255},{5,64},{7,42}]','10400'),(3,12030005,3,'[{0,12030005,4}]','[{1,364},{5,91},{7,60}]','14830'),(3,12030005,4,'[{0,12030005,6}]','[{1,492},{5,123},{7,81}]','20040'),(3,12030005,5,'[{0,12030005,8}]','[{1,638},{5,160},{7,105}]','26010'),(3,12030006,0,'[{0,12030006,1}]','[{1,143},{5,36},{7,24}]','5860'),(3,12030006,1,'[{0,12030006,1}]','[{1,257},{5,65},{7,43}]','10540'),(3,12030006,2,'[{0,12030006,2}]','[{1,400},{5,101},{7,67}]','16400'),(3,12030006,3,'[{0,12030006,4}]','[{1,571},{5,144},{7,96}]','23420'),(3,12030006,4,'[{0,12030006,6}]','[{1,771},{5,194},{7,129}]','31570'),(3,12030006,5,'[{0,12030006,8}]','[{1,999},{5,251},{7,167}]','40880'),(3,12030007,0,'[{0,12030007,1}]','[{1,253},{5,63},{7,42}]','10310'),(3,12030007,1,'[{0,12030007,1}]','[{1,455},{5,114},{7,76}]','18600'),(3,12030007,2,'[{0,12030007,2}]','[{1,708},{5,177},{7,118}]','28910'),(3,12030007,3,'[{0,12030007,4}]','[{1,1011},{5,253},{7,169}]','41320'),(3,12030007,4,'[{0,12030007,6}]','[{1,1365},{5,342},{7,228}]','55800'),(3,12030007,5,'[{0,12030007,8}]','[{1,1769},{5,443},{7,295}]','72280'),(3,12030008,0,'[{0,12030008,1}]','[{1,216},{5,54},{7,36}]','8820'),(3,12030008,1,'[{0,12030008,1}]','[{1,389},{5,97},{7,65}]','15880'),(3,12030008,2,'[{0,12030008,2}]','[{1,605},{5,151},{7,101}]','24700'),(3,12030008,3,'[{0,12030008,4}]','[{1,864},{5,216},{7,144}]','35280'),(3,12030008,4,'[{0,12030008,6}]','[{1,1166},{5,292},{7,194}]','47620'),(3,12030008,5,'[{0,12030008,8}]','[{1,1512},{5,379},{7,252}]','61790'),(3,12030009,0,'[{0,12030009,1}]','[{1,187},{5,47},{7,31}]','7640'),(3,12030009,1,'[{0,12030009,1}]','[{1,337},{5,85},{7,56}]','13790'),(3,12030009,2,'[{0,12030009,2}]','[{1,524},{5,132},{7,87}]','21430'),(3,12030009,3,'[{0,12030009,4}]','[{1,749},{5,188},{7,125}]','30630'),(3,12030009,4,'[{0,12030009,6}]','[{1,1011},{5,254},{7,169}]','41370'),(3,12030009,5,'[{0,12030009,8}]','[{1,1311},{5,329},{7,219}]','53620'),(3,12030010,0,'[{0,12030010,1}]','[{1,187},{5,47},{7,31}]','7640'),(3,12030010,1,'[{0,12030010,1}]','[{1,337},{5,85},{7,56}]','13790'),(3,12030010,2,'[{0,12030010,2}]','[{1,524},{5,132},{7,87}]','21430'),(3,12030010,3,'[{0,12030010,4}]','[{1,749},{5,188},{7,125}]','30630'),(3,12030010,4,'[{0,12030010,6}]','[{1,1011},{5,254},{7,169}]','41370'),(3,12030010,5,'[{0,12030010,8}]','[{1,1311},{5,329},{7,219}]','53620'),(3,12030011,0,'[{0,12030011,1}]','[{1,187},{5,47},{7,31}]','7640'),(3,12030011,1,'[{0,12030011,1}]','[{1,337},{5,85},{7,56}]','13790'),(3,12030011,2,'[{0,12030011,2}]','[{1,524},{5,132},{7,87}]','21430'),(3,12030011,3,'[{0,12030011,4}]','[{1,749},{5,188},{7,125}]','30630'),(3,12030011,4,'[{0,12030011,6}]','[{1,1011},{5,254},{7,169}]','41370'),(3,12030011,5,'[{0,12030011,8}]','[{1,1311},{5,329},{7,219}]','53620'),(3,12030012,0,'[{0,12030012,1}]','[{1,165},{5,41},{7,28}]','6750'),(3,12030012,1,'[{0,12030012,1}]','[{1,297},{5,74},{7,50}]','12140'),(3,12030012,2,'[{0,12030012,2}]','[{1,462},{5,115},{7,78}]','18890'),(3,12030012,3,'[{0,12030012,4}]','[{1,660},{5,165},{7,111}]','27000'),(3,12030012,4,'[{0,12030012,6}]','[{1,891},{5,223},{7,150}]','36470'),(3,12030012,5,'[{0,12030012,8}]','[{1,1155},{5,289},{7,194}]','47250'),(4,12040001,0,'[{0,12040001,1}]','[{2,4100},{6,42},{49,21}]','6830'),(4,12040001,1,'[{0,12040001,1}]','[{2,7300},{6,75},{49,37}]','12160'),(4,12040001,2,'[{0,12040001,2}]','[{2,11400},{6,117},{49,58}]','18990'),(4,12040001,3,'[{0,12040001,4}]','[{2,16100},{6,165},{49,82}]','26810'),(4,12040001,4,'[{0,12040001,6}]','[{2,21400},{6,219},{49,109}]','35620'),(4,12040001,5,'[{0,12040001,8}]','[{2,27600},{6,282},{49,140}]','45900'),(4,12040002,0,'[{0,12040002,1}]','[{2,5300},{6,54},{49,27}]','8810'),(4,12040002,1,'[{0,12040002,1}]','[{2,9540},{6,97},{49,48}]','15830'),(4,12040002,2,'[{0,12040002,2}]','[{2,14840},{6,151},{49,75}]','24640'),(4,12040002,3,'[{0,12040002,4}]','[{2,21200},{6,216},{49,107}]','35210'),(4,12040002,4,'[{0,12040002,6}]','[{2,28620},{6,292},{49,144}]','47540'),(4,12040002,5,'[{0,12040002,8}]','[{2,37140},{6,379},{49,187}]','61700'),(4,12040003,0,'[{0,12040003,1}]','[{2,2960},{6,30},{49,15}]','4910'),(4,12040003,1,'[{0,12040003,1}]','[{2,5320},{6,54},{49,27}]','8830'),(4,12040003,2,'[{0,12040003,2}]','[{2,8280},{6,84},{49,42}]','13740'),(4,12040003,3,'[{0,12040003,4}]','[{2,11820},{6,120},{49,60}]','19620'),(4,12040003,4,'[{0,12040003,6}]','[{2,15960},{6,162},{49,81}]','26490'),(4,12040003,5,'[{0,12040003,8}]','[{2,20700},{6,210},{49,105}]','34350'),(4,12040004,0,'[{0,12040004,1}]','[{2,4400},{6,45},{49,22}]','7310'),(4,12040004,1,'[{0,12040004,1}]','[{2,7920},{6,81},{49,40}]','13170'),(4,12040004,2,'[{0,12040004,2}]','[{2,12320},{6,126},{49,62}]','20480'),(4,12040004,3,'[{0,12040004,4}]','[{2,17600},{6,180},{49,88}]','29240'),(4,12040004,4,'[{0,12040004,6}]','[{2,23760},{6,243},{49,119}]','39480'),(4,12040004,5,'[{0,12040004,8}]','[{2,30820},{6,315},{49,154}]','51190'),(4,12040005,0,'[{0,12040005,1}]','[{2,2240},{6,23},{49,11}]','3720'),(4,12040005,1,'[{0,12040005,1}]','[{2,4020},{6,41},{49,20}]','6670'),(4,12040005,2,'[{0,12040005,2}]','[{2,6260},{6,64},{49,31}]','10390'),(4,12040005,3,'[{0,12040005,4}]','[{2,8940},{6,91},{49,44}]','14810'),(4,12040005,4,'[{0,12040005,6}]','[{2,12080},{6,123},{49,60}]','20030'),(4,12040005,5,'[{0,12040005,8}]','[{2,15660},{6,160},{49,78}]','26000'),(4,12040006,0,'[{0,12040006,1}]','[{2,3500},{6,36},{49,18}]','5840'),(4,12040006,1,'[{0,12040006,1}]','[{2,6300},{6,65},{49,32}]','10510'),(4,12040006,2,'[{0,12040006,2}]','[{2,9800},{6,101},{49,50}]','16350'),(4,12040006,3,'[{0,12040006,4}]','[{2,14000},{6,144},{49,71}]','23330'),(4,12040006,4,'[{0,12040006,6}]','[{2,18900},{6,194},{49,96}]','31480'),(4,12040006,5,'[{0,12040006,8}]','[{2,24520},{6,251},{49,124}]','40790'),(4,12040007,0,'[{0,12040007,1}]','[{2,6200},{6,63},{49,31}]','10280'),(4,12040007,1,'[{0,12040007,1}]','[{2,11160},{6,114},{49,56}]','18540'),(4,12040007,2,'[{0,12040007,2}]','[{2,17360},{6,177},{49,87}]','28820'),(4,12040007,3,'[{0,12040007,4}]','[{2,24800},{6,253},{49,124}]','41170'),(4,12040007,4,'[{0,12040007,6}]','[{2,33500},{6,342},{49,168}]','55640'),(4,12040007,5,'[{0,12040007,8}]','[{2,43460},{6,443},{49,218}]','72150'),(4,12040008,0,'[{0,12040008,1}]','[{2,5300},{6,54},{49,27}]','8810'),(4,12040008,1,'[{0,12040008,1}]','[{2,9540},{6,97},{49,48}]','15830'),(4,12040008,2,'[{0,12040008,2}]','[{2,14840},{6,151},{49,75}]','24640'),(4,12040008,3,'[{0,12040008,4}]','[{2,21200},{6,216},{49,107}]','35210'),(4,12040008,4,'[{0,12040008,6}]','[{2,28620},{6,292},{49,144}]','47540'),(4,12040008,5,'[{0,12040008,8}]','[{2,37140},{6,379},{49,187}]','61700');
/*!40000 ALTER TABLE `base_fashion` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_fashion_activate`
--

DROP TABLE IF EXISTS `base_fashion_activate`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_fashion_activate` (
  `id` int(10) unsigned NOT NULL COMMENT '编号',
  `fashion_id` int(10) unsigned NOT NULL COMMENT '时装id',
  `cost` varchar(255) NOT NULL COMMENT '激活消耗',
  `time` int(10) unsigned NOT NULL COMMENT '激活时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='时装激活表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_fashion_activate`
--

LOCK TABLES `base_fashion_activate` WRITE;
/*!40000 ALTER TABLE `base_fashion_activate` DISABLE KEYS */;
INSERT INTO `base_fashion_activate` VALUES (1,12010001,'[{0,12010001,1}]',0),(2,12010001,'[{0,12011001,1}]',1296000),(3,12010001,'[{0,12012001,1}]',604800),(4,12010001,'[{0,12013001,1}]',259200),(5,12020001,'[{0,12020001,1}]',0),(6,12020001,'[{0,12021001,1}]',1296000),(7,12020001,'[{0,12022001,1}]',604800),(8,12020001,'[{0,12023001,1}]',259200),(9,12030001,'[{0,12030001,1}]',0),(10,12030001,'[{0,12031001,1}]',1296000),(11,12030001,'[{0,12032001,1}]',604800),(12,12030001,'[{0,12033001,1}]',259200),(13,12040001,'[{0,12040001,1}]',0),(14,12040001,'[{0,12041001,1}]',1296000),(15,12040001,'[{0,12042001,1}]',604800),(16,12040001,'[{0,12043001,1}]',259200),(17,12010002,'[{0,12010002,1}]',0),(18,12020002,'[{0,12020002,1}]',0),(19,12030002,'[{0,12030002,1}]',0),(20,12040002,'[{0,12040002,1}]',0),(21,12010003,'[{0,12010003,1}]',0),(22,12020003,'[{0,12020003,1}]',0),(23,12030003,'[{0,12030003,1}]',0),(24,12040003,'[{0,12040003,1}]',0),(25,12010004,'[{0,12010004,1}]',0),(26,12020004,'[{0,12020004,1}]',0),(27,12030004,'[{0,12030004,1}]',0),(28,12040004,'[{0,12040004,1}]',0),(29,12010005,'[{0,12010005,1}]',0),(30,12020005,'[{0,12020005,1}]',0),(31,12030005,'[{0,12030005,1}]',0),(32,12040005,'[{0,12040005,1}]',0),(33,12010006,'[{0,12010006,1}]',0),(34,12020006,'[{0,12020006,1}]',0),(35,12030006,'[{0,12030006,1}]',0),(36,12040006,'[{0,12040006,1}]',0),(37,12010007,'[{0,12010007,1}]',0),(38,12020007,'[{0,12020007,1}]',0),(39,12030007,'[{0,12030007,1}]',0),(40,12040007,'[{0,12040007,1}]',0),(41,12010008,'[{0,12010008,1}]',0),(42,12020008,'[{0,12020008,1}]',0),(43,12030008,'[{0,12030008,1}]',0),(44,12040008,'[{0,12040008,1}]',0),(45,12010009,'[{0,12010009,1}]',0),(46,12020009,'[{0,12020009,1}]',0),(47,12030009,'[{0,12030009,1}]',0),(48,12010010,'[{0,12010010,1}]',0),(49,12020010,'[{0,12020010,1}]',0),(50,12030010,'[{0,12030010,1}]',0),(51,12010011,'[{0,12010011,1}]',0),(52,12020011,'[{0,12020011,1}]',0),(53,12030011,'[{0,12030011,1}]',0),(54,12010012,'[{0,12010012,1}]',0),(55,12020012,'[{0,12020012,1}]',0),(56,12030012,'[{0,12030012,1}]',0);
/*!40000 ALTER TABLE `base_fashion_activate` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_fashion_color`
--

DROP TABLE IF EXISTS `base_fashion_color`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_fashion_color` (
  `pos_id` int(10) unsigned NOT NULL COMMENT '位置id',
  `fashion_id` int(10) unsigned NOT NULL COMMENT '时装id',
  `career` int(10) unsigned NOT NULL COMMENT '职业',
  `color_id` int(10) unsigned NOT NULL COMMENT '颜色id',
  `color_logo` int(10) unsigned NOT NULL COMMENT '颜色logo',
  `color_name` varchar(500) NOT NULL COMMENT '颜色名字@lang@',
  `color_cost` varchar(500) NOT NULL COMMENT '染色消耗',
  PRIMARY KEY (`pos_id`,`fashion_id`,`career`,`color_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='时装颜色配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_fashion_color`
--

LOCK TABLES `base_fashion_color` WRITE;
/*!40000 ALTER TABLE `base_fashion_color` DISABLE KEYS */;
INSERT INTO `base_fashion_color` VALUES (1,12010001,1,0,0,'默认色','[]'),(1,12010001,1,1,2,'红色','[{0,12120002,5}]'),(1,12010001,1,2,5,'黑色','[{0,12120005,5}]'),(1,12010001,1,3,4,'紫色','[{0,12120004,5}]'),(1,12010001,2,0,0,'默认色','[]'),(1,12010001,2,1,2,'红色','[{0,12120002,5}]'),(1,12010001,2,2,5,'黑色','[{0,12120005,5}]'),(1,12010001,2,3,4,'紫色','[{0,12120004,5}]'),(1,12010001,4,0,0,'默认色','[]'),(1,12010001,4,1,2,'红色','[{0,12120002,5}]'),(1,12010001,4,2,5,'黑色','[{0,12120005,5}]'),(1,12010001,4,3,4,'紫色','[{0,12120004,5}]'),(1,12010002,1,0,0,'默认色','[]'),(1,12010002,1,1,5,'黑色','[{0,12120005,5}]'),(1,12010002,1,2,7,'蓝色','[{0,12120007,5}]'),(1,12010002,1,3,6,'金色','[{0,12120006,5}]'),(1,12010002,2,0,0,'默认色','[]'),(1,12010002,2,1,7,'蓝色','[{0,12120007,5}]'),(1,12010002,2,2,6,'金色','[{0,12120006,5}]'),(1,12010002,2,3,5,'黑色','[{0,12120005,5}]'),(1,12010002,4,0,0,'默认色','[]'),(1,12010002,4,1,6,'金色','[{0,12120006,5}]'),(1,12010002,4,2,7,'蓝色','[{0,12120007,5}]'),(1,12010002,4,3,5,'黑色','[{0,12120005,5}]'),(1,12010003,1,0,0,'默认色','[]'),(1,12010003,1,1,5,'黑色','[{0,12120005,5}]'),(1,12010003,1,2,1,'绿色','[{0,12120001,5}]'),(1,12010003,1,3,7,'蓝色','[{0,12120007,5}]'),(1,12010003,2,0,0,'默认色','[]'),(1,12010003,2,1,5,'黑色','[{0,12120005,5}]'),(1,12010003,2,2,4,'紫色','[{0,12120004,5}]'),(1,12010003,2,3,7,'蓝色','[{0,12120007,5}]'),(1,12010003,4,0,0,'默认色','[]'),(1,12010003,4,1,3,'白色','[{0,12120003,5}]'),(1,12010003,4,2,2,'红色','[{0,12120002,5}]'),(1,12010003,4,3,5,'黑色','[{0,12120005,5}]'),(1,12010004,1,0,0,'默认色','[]'),(1,12010004,1,1,5,'黑色','[{0,12120005,5}]'),(1,12010004,1,2,7,'蓝色','[{0,12120007,5}]'),(1,12010004,1,3,6,'金色','[{0,12120006,5}]'),(1,12010004,2,0,0,'默认色','[]'),(1,12010004,2,1,2,'红色','[{0,12120002,5}]'),(1,12010004,2,2,1,'绿色','[{0,12120001,5}]'),(1,12010004,2,3,8,'橙色','[{0,12120008,5}]'),(1,12010004,4,0,0,'默认色','[]'),(1,12010004,4,1,7,'蓝色','[{0,12120007,5}]'),(1,12010004,4,2,1,'绿色','[{0,12120001,5}]'),(1,12010004,4,3,6,'金色','[{0,12120006,5}]'),(1,12010005,1,0,0,'默认色','[]'),(1,12010005,1,1,5,'黑色','[{0,12120005,5}]'),(1,12010005,1,2,7,'蓝色','[{0,12120007,5}]'),(1,12010005,1,3,9,'粉色','[{0,12120009,5}]'),(1,12010005,2,0,0,'默认色','[]'),(1,12010005,2,1,5,'黑色','[{0,12120005,5}]'),(1,12010005,2,2,7,'蓝色','[{0,12120007,5}]'),(1,12010005,2,3,9,'粉色','[{0,12120009,5}]'),(1,12010005,4,0,0,'默认色','[]'),(1,12010005,4,1,5,'黑色','[{0,12120005,5}]'),(1,12010005,4,2,7,'蓝色','[{0,12120007,5}]'),(1,12010005,4,3,9,'粉色','[{0,12120009,5}]'),(1,12010006,1,0,0,'默认色','[]'),(1,12010006,1,1,7,'蓝色','[{0,12120007,5}]'),(1,12010006,1,2,4,'紫色','[{0,12120004,5}]'),(1,12010006,1,3,3,'白色','[{0,12120003,5}]'),(1,12010006,2,0,0,'默认色','[]'),(1,12010006,2,1,2,'红色','[{0,12120002,5}]'),(1,12010006,2,2,7,'蓝色','[{0,12120007,5}]'),(1,12010006,2,3,3,'白色','[{0,12120003,5}]'),(1,12010006,4,0,0,'默认色','[]'),(1,12010006,4,1,2,'红色','[{0,12120002,5}]'),(1,12010006,4,2,3,'白色','[{0,12120003,5}]'),(1,12010006,4,3,4,'紫色','[{0,12120004,5}]'),(1,12010007,1,0,0,'默认色','[]'),(1,12010007,1,1,3,'白色','[{0,12120003,5}]'),(1,12010007,1,2,9,'粉色','[{0,12120009,5}]'),(1,12010007,1,3,6,'金色','[{0,12120006,5}]'),(1,12010007,2,0,0,'默认色','[]'),(1,12010007,2,1,3,'白色','[{0,12120003,5}]'),(1,12010007,2,2,9,'粉色','[{0,12120009,5}]'),(1,12010007,2,3,6,'金色','[{0,12120006,5}]'),(1,12010007,4,0,0,'默认色','[]'),(1,12010007,4,1,3,'白色','[{0,12120003,5}]'),(1,12010007,4,2,9,'粉色','[{0,12120009,5}]'),(1,12010007,4,3,6,'金色','[{0,12120006,5}]'),(1,12010008,1,0,0,'默认色','[]'),(1,12010008,2,0,0,'默认色','[]'),(1,12010008,4,0,0,'默认色','[]'),(1,12010009,1,0,0,'默认色','[]'),(1,12010009,1,1,2,'红色','[{0,12120002,5}]'),(1,12010009,1,2,8,'橙色','[{0,12120008,5}]'),(1,12010009,1,3,5,'黑色','[{0,12120005,5}]'),(1,12010009,2,0,0,'默认色','[]'),(1,12010009,2,1,7,'蓝色','[{0,12120007,5}]'),(1,12010009,2,2,8,'橙色','[{0,12120008,5}]'),(1,12010009,2,3,5,'黑色','[{0,12120005,5}]'),(1,12010009,4,0,0,'默认色','[]'),(1,12010009,4,1,7,'蓝色','[{0,12120007,5}]'),(1,12010009,4,2,2,'红色','[{0,12120002,5}]'),(1,12010009,4,3,5,'黑色','[{0,12120005,5}]'),(1,12010010,1,0,0,'默认色','[]'),(1,12010010,1,1,2,'红色','[{0,12120002,5}]'),(1,12010010,1,2,6,'金色','[{0,12120006,5}]'),(1,12010010,1,3,7,'蓝色','[{0,12120007,5}]'),(1,12010010,2,0,0,'默认色','[]'),(1,12010010,2,1,4,'紫色','[{0,12120004,5}]'),(1,12010010,2,2,9,'粉色','[{0,12120009,5}]'),(1,12010010,2,3,6,'金色','[{0,12120006,5}]'),(1,12010010,4,0,0,'默认色','[]'),(1,12010010,4,1,4,'紫色','[{0,12120004,5}]'),(1,12010010,4,2,7,'蓝色','[{0,12120007,5}]'),(1,12010010,4,3,1,'绿色','[{0,12120001,5}]'),(1,12010011,1,0,0,'默认色','[]'),(1,12010011,2,0,0,'默认色','[]'),(1,12010011,4,0,0,'默认色','[]'),(1,12010012,1,0,0,'默认色','[]'),(1,12010012,2,0,0,'默认色','[]'),(1,12010012,4,0,0,'默认色','[]'),(2,12020001,1,0,0,'默认色','[]'),(2,12020001,1,1,5,'黑色','[{0,12120005,5}]'),(2,12020001,1,2,2,'红色','[{0,12120002,5}]'),(2,12020001,1,3,4,'紫色','[{0,12120004,5}]'),(2,12020001,2,0,0,'默认色','[]'),(2,12020001,2,1,5,'黑色','[{0,12120005,5}]'),(2,12020001,2,2,2,'红色','[{0,12120002,5}]'),(2,12020001,2,3,4,'紫色','[{0,12120004,5}]'),(2,12020001,4,0,0,'默认色','[]'),(2,12020001,4,1,5,'黑色','[{0,12120005,5}]'),(2,12020001,4,2,2,'红色','[{0,12120002,5}]'),(2,12020001,4,3,4,'紫色','[{0,12120004,5}]'),(2,12020002,1,0,0,'默认色','[]'),(2,12020002,1,1,5,'黑色','[{0,12120005,5}]'),(2,12020002,1,2,7,'蓝色','[{0,12120007,5}]'),(2,12020002,1,3,6,'金色','[{0,12120006,5}]'),(2,12020002,2,0,0,'默认色','[]'),(2,12020002,2,1,7,'蓝色','[{0,12120007,5}]'),(2,12020002,2,2,8,'橙色','[{0,12120008,5}]'),(2,12020002,2,3,5,'黑色','[{0,12120005,5}]'),(2,12020002,4,0,0,'默认色','[]'),(2,12020002,4,1,5,'黑色','[{0,12120005,5}]'),(2,12020002,4,2,7,'蓝色','[{0,12120007,5}]'),(2,12020002,4,3,4,'紫色','[{0,12120004,5}]'),(2,12020003,1,0,0,'默认色','[]'),(2,12020003,1,1,7,'蓝色','[{0,12120007,5}]'),(2,12020003,1,2,4,'紫色','[{0,12120004,5}]'),(2,12020003,1,3,3,'白色','[{0,12120003,5}]'),(2,12020003,2,0,0,'默认色','[]'),(2,12020003,2,1,2,'红色','[{0,12120002,5}]'),(2,12020003,2,2,4,'紫色','[{0,12120004,5}]'),(2,12020003,2,3,7,'蓝色','[{0,12120007,5}]'),(2,12020003,4,0,0,'默认色','[]'),(2,12020003,4,1,7,'蓝色','[{0,12120007,5}]'),(2,12020003,4,2,2,'红色','[{0,12120002,5}]'),(2,12020003,4,3,5,'黑色','[{0,12120005,5}]'),(2,12020004,1,0,0,'默认色','[]'),(2,12020004,1,1,5,'黑色','[{0,12120005,5}]'),(2,12020004,1,2,7,'蓝色','[{0,12120007,5}]'),(2,12020004,1,3,6,'金色','[{0,12120006,5}]'),(2,12020004,2,0,0,'默认色','[]'),(2,12020004,2,1,2,'红色','[{0,12120002,5}]'),(2,12020004,2,2,1,'绿色','[{0,12120001,5}]'),(2,12020004,2,3,8,'橙色','[{0,12120008,5}]'),(2,12020004,4,0,0,'默认色','[]'),(2,12020004,4,1,7,'蓝色','[{0,12120007,5}]'),(2,12020004,4,2,1,'绿色','[{0,12120001,5}]'),(2,12020004,4,3,6,'金色','[{0,12120006,5}]'),(2,12020005,1,0,0,'默认色','[]'),(2,12020005,2,0,0,'默认色','[]'),(2,12020005,4,0,0,'默认色','[]'),(2,12020006,1,0,0,'默认色','[]'),(2,12020006,1,1,7,'蓝色','[{0,12120007,5}]'),(2,12020006,1,2,4,'紫色','[{0,12120004,5}]'),(2,12020006,1,3,6,'金色','[{0,12120006,5}]'),(2,12020006,2,0,0,'默认色','[]'),(2,12020006,2,1,5,'红色','[{0,12120002,5}]'),(2,12020006,2,2,7,'蓝色','[{0,12120007,5}]'),(2,12020006,2,3,6,'金色','[{0,12120006,5}]'),(2,12020006,4,0,0,'默认色','[]'),(2,12020006,4,1,2,'红色','[{0,12120002,5}]'),(2,12020006,4,2,6,'金色','[{0,12120006,5}]'),(2,12020006,4,3,4,'紫色','[{0,12120004,5}]'),(2,12020007,1,0,0,'默认色','[]'),(2,12020007,1,1,3,'白色','[{0,12120003,5}]'),(2,12020007,1,2,9,'粉色','[{0,12120009,5}]'),(2,12020007,1,3,6,'金色','[{0,12120006,5}]'),(2,12020007,2,0,0,'默认色','[]'),(2,12020007,2,1,7,'蓝色','[{0,12120007,5}]'),(2,12020007,2,2,9,'粉色','[{0,12120009,5}]'),(2,12020007,2,3,6,'金色','[{0,12120006,5}]'),(2,12020007,4,0,0,'默认色','[]'),(2,12020007,4,1,7,'蓝色','[{0,12120007,5}]'),(2,12020007,4,2,9,'粉色','[{0,12120009,5}]'),(2,12020007,4,3,6,'金色','[{0,12120006,5}]'),(2,12020008,1,0,0,'默认色','[]'),(2,12020008,2,0,0,'默认色','[]'),(2,12020008,4,0,0,'默认色','[]'),(2,12020009,1,0,0,'默认色','[]'),(2,12020009,1,1,2,'红色','[{0,12120002,5}]'),(2,12020009,1,2,8,'橙色','[{0,12120008,5}]'),(2,12020009,1,3,5,'黑色','[{0,12120005,5}]'),(2,12020009,2,0,0,'默认色','[]'),(2,12020009,2,1,7,'蓝色','[{0,12120007,5}]'),(2,12020009,2,2,8,'橙色','[{0,12120008,5}]'),(2,12020009,2,3,5,'黑色','[{0,12120005,5}]'),(2,12020009,4,0,0,'默认色','[]'),(2,12020009,4,1,7,'蓝色','[{0,12120007,5}]'),(2,12020009,4,2,2,'红色','[{0,12120002,5}]'),(2,12020009,4,3,5,'黑色','[{0,12120005,5}]'),(2,12020010,1,0,0,'默认色','[]'),(2,12020010,1,1,2,'红色','[{0,12120002,5}]'),(2,12020010,1,2,6,'金色','[{0,12120006,5}]'),(2,12020010,1,3,7,'蓝色','[{0,12120007,5}]'),(2,12020010,2,0,0,'默认色','[]'),(2,12020010,2,1,4,'紫色','[{0,12120004,5}]'),(2,12020010,2,2,9,'粉色','[{0,12120009,5}]'),(2,12020010,2,3,6,'金色','[{0,12120006,5}]'),(2,12020010,4,0,0,'默认色','[]'),(2,12020010,4,1,4,'紫色','[{0,12120004,5}]'),(2,12020010,4,2,7,'蓝色','[{0,12120007,5}]'),(2,12020010,4,3,1,'绿色','[{0,12120001,5}]'),(2,12020011,1,0,0,'默认色','[]'),(2,12020011,2,0,0,'默认色','[]'),(2,12020011,4,0,0,'默认色','[]'),(2,12020012,1,0,0,'默认色','[]'),(2,12020012,2,0,0,'默认色','[]'),(2,12020012,4,0,0,'默认色','[]'),(3,12030001,1,0,0,'默认色','[]'),(3,12030001,1,2,6,'金色','[{0,12120006,5}]'),(3,12030001,2,0,0,'默认色','[]'),(3,12030001,4,0,0,'默认色','[]'),(3,12030001,4,1,2,'红色','[{0,12120002,5}]'),(3,12030001,4,2,5,'黑色','[{0,12120005,5}]'),(3,12030001,4,3,4,'紫色','[{0,12120004,5}]'),(3,12030002,1,0,0,'默认色','[]'),(3,12030002,1,1,1,'绿色','[{0,12120001,5}]'),(3,12030002,1,2,3,'白色','[{0,12120003,5}]'),(3,12030002,1,3,6,'金色','[{0,12120006,5}]'),(3,12030002,2,0,0,'默认色','[]'),(3,12030002,4,0,0,'默认色','[]'),(3,12030003,1,0,0,'默认色','[]'),(3,12030003,1,1,6,'金色','[{0,12120006,5}]'),(3,12030003,1,2,3,'白色','[{0,12120003,5}]'),(3,12030003,1,3,7,'蓝色','[{0,12120007,5}]'),(3,12030003,2,0,0,'默认色','[]'),(3,12030003,2,1,2,'红色','[{0,12120002,5}]'),(3,12030003,2,2,1,'绿色','[{0,12120001,5}]'),(3,12030003,2,3,7,'蓝色','[{0,12120007,5}]'),(3,12030003,4,0,0,'默认色','[]'),(3,12030003,4,1,7,'蓝色','[{0,12120007,5}]'),(3,12030003,4,2,2,'红色','[{0,12120002,5}]'),(3,12030003,4,3,5,'黑色','[{0,12120005,5}]'),(3,12030004,1,0,0,'默认色','[]'),(3,12030004,1,1,3,'白色','[{0,12120003,5}]'),(3,12030004,1,2,7,'蓝色','[{0,12120007,5}]'),(3,12030004,1,3,4,'紫色','[{0,12120004,5}]'),(3,12030004,2,0,0,'默认色','[]'),(3,12030004,2,1,1,'绿色','[{0,12120001,5}]'),(3,12030004,2,2,2,'红色','[{0,12120002,5}]'),(3,12030004,2,3,7,'蓝色','[{0,12120007,5}]'),(3,12030004,4,0,0,'默认色','[]'),(3,12030004,4,1,3,'白色','[{0,12120003,5}]'),(3,12030004,4,2,1,'绿色','[{0,12120001,5}]'),(3,12030004,4,3,6,'金色','[{0,12120006,5}]'),(3,12030005,1,0,0,'默认色','[]'),(3,12030005,1,1,5,'黑色','[{0,12120005,5}]'),(3,12030005,1,2,7,'蓝色','[{0,12120007,5}]'),(3,12030005,1,3,9,'粉色','[{0,12120009,5}]'),(3,12030005,2,0,0,'默认色','[]'),(3,12030005,2,1,5,'黑色','[{0,12120005,5}]'),(3,12030005,2,2,7,'蓝色','[{0,12120007,5}]'),(3,12030005,2,3,9,'粉色','[{0,12120009,5}]'),(3,12030005,4,0,0,'默认色','[]'),(3,12030005,4,1,5,'黑色','[{0,12120005,5}]'),(3,12030005,4,2,7,'蓝色','[{0,12120007,5}]'),(3,12030005,4,3,9,'粉色','[{0,12120009,5}]'),(3,12030006,1,0,0,'默认色','[]'),(3,12030006,1,1,7,'蓝色','[{0,12120007,5}]'),(3,12030006,1,2,4,'紫色','[{0,12120004,5}]'),(3,12030006,1,3,3,'白色','[{0,12120003,5}]'),(3,12030006,2,0,0,'默认色','[]'),(3,12030006,2,1,2,'红色','[{0,12120002,5}]'),(3,12030006,2,2,7,'蓝色','[{0,12120007,5}]'),(3,12030006,2,3,3,'白色','[{0,12120003,5}]'),(3,12030006,4,0,0,'默认色','[]'),(3,12030006,4,1,2,'红色','[{0,12120002,5}]'),(3,12030006,4,2,3,'白色','[{0,12120003,5}]'),(3,12030006,4,3,4,'紫色','[{0,12120004,5}]'),(3,12030007,1,0,0,'默认色','[]'),(3,12030007,1,1,5,'黑色','[{0,12120005,5}]'),(3,12030007,1,2,9,'粉色','[{0,12120009,5}]'),(3,12030007,1,3,8,'橙色','[{0,12120008,5}]'),(3,12030007,2,0,0,'默认色','[]'),(3,12030007,2,1,3,'白色','[{0,12120003,5}]'),(3,12030007,2,2,9,'粉色','[{0,12120009,5}]'),(3,12030007,2,3,8,'橙色','[{0,12120008,5}]'),(3,12030007,4,0,0,'默认色','[]'),(3,12030007,4,1,5,'黑色','[{0,12120005,5}]'),(3,12030007,4,2,9,'粉色','[{0,12120009,5}]'),(3,12030007,4,3,8,'橙色','[{0,12120008,5}]'),(3,12030008,1,0,0,'默认色','[]'),(3,12030008,2,0,0,'默认色','[]'),(3,12030008,4,0,0,'默认色','[]'),(3,12030009,1,0,0,'默认色','[]'),(3,12030009,1,1,2,'红色','[{0,12120002,5}]'),(3,12030009,1,2,8,'橙色','[{0,12120008,5}]'),(3,12030009,1,3,5,'黑色','[{0,12120005,5}]'),(3,12030009,2,0,0,'默认色','[]'),(3,12030009,2,1,7,'蓝色','[{0,12120007,5}]'),(3,12030009,2,2,8,'橙色','[{0,12120008,5}]'),(3,12030009,2,3,5,'黑色','[{0,12120005,5}]'),(3,12030009,4,0,0,'默认色','[]'),(3,12030009,4,1,7,'蓝色','[{0,12120007,5}]'),(3,12030009,4,2,2,'红色','[{0,12120002,5}]'),(3,12030009,4,3,5,'黑色','[{0,12120005,5}]'),(3,12030010,1,0,0,'默认色','[]'),(3,12030010,1,1,2,'红色','[{0,12120002,5}]'),(3,12030010,1,2,6,'金色','[{0,12120006,5}]'),(3,12030010,1,3,7,'蓝色','[{0,12120007,5}]'),(3,12030010,2,0,0,'默认色','[]'),(3,12030010,2,1,4,'紫色','[{0,12120004,5}]'),(3,12030010,2,2,9,'粉色','[{0,12120009,5}]'),(3,12030010,2,3,6,'金色','[{0,12120006,5}]'),(3,12030010,4,0,0,'默认色','[]'),(3,12030010,4,1,4,'紫色','[{0,12120004,5}]'),(3,12030010,4,2,7,'蓝色','[{0,12120007,5}]'),(3,12030010,4,3,1,'绿色','[{0,12120001,5}]'),(3,12030011,1,0,0,'默认色','[]'),(3,12030011,2,0,0,'默认色','[]'),(3,12030011,4,0,0,'默认色','[]'),(3,12030012,1,0,0,'默认色','[]'),(3,12030012,2,0,0,'默认色','[]'),(3,12030012,4,0,0,'默认色','[]');
/*!40000 ALTER TABLE `base_fashion_color` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_fashion_color_logo`
--

DROP TABLE IF EXISTS `base_fashion_color_logo`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_fashion_color_logo` (
  `pos_id` int(10) unsigned NOT NULL COMMENT '部位id',
  `fashion_id` int(10) unsigned NOT NULL COMMENT '时装id',
  `career` int(10) unsigned NOT NULL COMMENT '职业',
  `fashion_name` varchar(1000) NOT NULL COMMENT '时装名字@lang@',
  `color_list` varchar(1000) NOT NULL COMMENT '颜色列表',
  PRIMARY KEY (`pos_id`,`fashion_id`,`career`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='时装颜色图标配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_fashion_color_logo`
--

LOCK TABLES `base_fashion_color_logo` WRITE;
/*!40000 ALTER TABLE `base_fashion_color_logo` DISABLE KEYS */;
INSERT INTO `base_fashion_color_logo` VALUES (1,12010001,1,'新婚礼服','[]'),(1,12010001,2,'新婚礼服','[]'),(1,12010001,3,'新婚礼服','[]'),(1,12010001,4,'新婚礼服','[]'),(1,12010002,1,'战国甲胄','[]'),(1,12010002,2,'战国甲胄','[]'),(1,12010002,3,'战国甲胄','[]'),(1,12010002,4,'战国甲胄','[]'),(1,12010003,1,'西域风情','[]'),(1,12010003,2,'西域风情','[]'),(1,12010003,3,'西域风情','[]'),(1,12010003,4,'西域风情','[]'),(1,12010004,1,'偶像礼服','[]'),(1,12010004,2,'偶像礼服','[]'),(1,12010004,3,'偶像礼服','[]'),(1,12010004,4,'偶像礼服','[]'),(1,12010005,1,'海军水手','[]'),(1,12010005,2,'海军水手','[]'),(1,12010005,3,'海军水手','[]'),(1,12010005,4,'海军水手','[]'),(1,12010006,1,'海盗船长','[]'),(1,12010006,2,'海盗船长','[]'),(1,12010006,3,'海盗船长','[]'),(1,12010006,4,'海盗船长','[]'),(1,12010007,1,'叛逆青春','[]'),(1,12010007,2,'叛逆青春','[]'),(1,12010007,3,'叛逆青春','[]'),(1,12010007,4,'叛逆青春','[]'),(1,12010008,1,'变身熊猫','[]'),(1,12010008,2,'变身熊猫','[]'),(1,12010008,3,'变身熊猫','[]'),(1,12010008,4,'变身熊猫','[]'),(1,12010009,1,'传奇海怪','[]'),(1,12010009,2,'传奇海怪','[]'),(1,12010009,3,'传奇海怪','[]'),(1,12010009,4,'传奇海怪','[]'),(1,12010010,1,'劳动光荣','[]'),(1,12010010,2,'劳动光荣','[]'),(1,12010010,3,'劳动光荣','[]'),(1,12010010,4,'劳动光荣','[]'),(1,12010011,1,'童心未泯','[]'),(1,12010011,2,'童心未泯','[]'),(1,12010011,3,'童心未泯','[]'),(1,12010011,4,'童心未泯','[]'),(1,12010012,1,'管弦乐手','[]'),(1,12010012,2,'管弦乐手','[]'),(1,12010012,3,'管弦乐手','[]'),(1,12010012,4,'管弦乐手','[]'),(2,12020001,1,'甜蜜花束','[]'),(2,12020001,2,'甜蜜花束','[]'),(2,12020001,3,'甜蜜花束','[]'),(2,12020001,4,'甜蜜花束','[]'),(2,12020002,1,'战国寒芒','[]'),(2,12020002,2,'战国寒芒','[]'),(2,12020002,3,'战国寒芒','[]'),(2,12020002,4,'战国寒芒','[]'),(2,12020003,1,'西域武器','[]'),(2,12020003,2,'西域武器','[]'),(2,12020003,3,'西域武器','[]'),(2,12020003,4,'西域武器','[]'),(2,12020004,1,'偶像乐器','[]'),(2,12020004,2,'偶像乐器','[]'),(2,12020004,3,'偶像乐器','[]'),(2,12020004,4,'偶像乐器','[]'),(2,12020005,1,'水手武器','[]'),(2,12020005,2,'水手武器','[]'),(2,12020005,3,'水手武器','[]'),(2,12020005,4,'水手武器','[]'),(2,12020006,1,'海盗之力','[]'),(2,12020006,2,'海盗之力','[]'),(2,12020006,3,'海盗之力','[]'),(2,12020006,4,'海盗之力','[]'),(2,12020007,1,'街头武器','[]'),(2,12020007,2,'街头武器','[]'),(2,12020007,3,'街头武器','[]'),(2,12020007,4,'街头武器','[]'),(2,12020008,1,'熊猫口粮','[]'),(2,12020008,2,'熊猫口粮','[]'),(2,12020008,3,'熊猫口粮','[]'),(2,12020008,4,'熊猫口粮','[]'),(2,12020009,1,'传奇海怪','[]'),(2,12020009,2,'传奇海怪','[]'),(2,12020009,3,'传奇海怪','[]'),(2,12020009,4,'传奇海怪','[]'),(2,12020010,1,'劳动工具','[]'),(2,12020010,2,'劳动工具','[]'),(2,12020010,3,'劳动工具','[]'),(2,12020010,4,'劳动工具','[]'),(2,12020011,1,'童心玩具','[]'),(2,12020011,2,'童心玩具','[]'),(2,12020011,3,'童心玩具','[]'),(2,12020011,4,'童心玩具','[]'),(2,12020012,1,'管弦乐器','[]'),(2,12020012,2,'管弦乐器','[]'),(2,12020012,3,'管弦乐器','[]'),(2,12020012,4,'管弦乐器','[]'),(3,12030001,1,'新婚发饰','[]'),(3,12030001,2,'新婚发饰','[]'),(3,12030001,3,'新婚发饰','[]'),(3,12030001,4,'新婚发饰','[]'),(3,12030002,1,'战国头盔','[]'),(3,12030002,2,'战国头盔','[]'),(3,12030002,3,'战国头盔','[]'),(3,12030002,4,'战国头盔','[]'),(3,12030003,1,'西域面纱','[]'),(3,12030003,2,'西域面纱','[]'),(3,12030003,3,'西域面纱','[]'),(3,12030003,4,'西域面纱','[]'),(3,12030004,1,'偶像造型','[]'),(3,12030004,2,'偶像造型','[]'),(3,12030004,3,'偶像造型','[]'),(3,12030004,4,'偶像造型','[]'),(3,12030005,1,'水手之帽','[]'),(3,12030005,2,'水手之帽','[]'),(3,12030005,3,'水手之帽','[]'),(3,12030005,4,'水手之帽','[]'),(3,12030006,1,'船长之帽','[]'),(3,12030006,2,'船长之帽','[]'),(3,12030006,3,'船长之帽','[]'),(3,12030006,4,'船长之帽','[]'),(3,12030007,1,'叛逆头饰','[]'),(3,12030007,2,'叛逆头饰','[]'),(3,12030007,3,'叛逆头饰','[]'),(3,12030007,4,'叛逆头饰','[]'),(3,12030008,1,'熊猫头饰','[]'),(3,12030008,2,'熊猫头饰','[]'),(3,12030008,3,'熊猫头饰','[]'),(3,12030008,4,'熊猫头饰','[]'),(3,12030009,1,'传奇海怪','[]'),(3,12030009,2,'传奇海怪','[]'),(3,12030009,3,'传奇海怪','[]'),(3,12030009,4,'传奇海怪','[]'),(3,12030010,1,'劳动头饰','[]'),(3,12030010,2,'劳动头饰','[]'),(3,12030010,3,'劳动头饰','[]'),(3,12030010,4,'劳动头饰','[]'),(3,12030011,1,'童心发饰','[]'),(3,12030011,2,'童心发饰','[]'),(3,12030011,3,'童心发饰','[]'),(3,12030011,4,'童心发饰','[]'),(3,12030012,1,'乐队发饰','[]'),(3,12030012,2,'乐队发饰','[]'),(3,12030012,3,'乐队发饰','[]'),(3,12030012,4,'乐队发饰','[]'),(4,12040001,1,'玫瑰之恋','[]'),(4,12040001,2,'玫瑰之恋','[]'),(4,12040001,3,'玫瑰之恋','[]'),(4,12040001,4,'玫瑰之恋','[]'),(4,12040002,1,'战争之炎','[]'),(4,12040002,2,'战争之炎','[]'),(4,12040002,3,'战争之炎','[]'),(4,12040002,4,'战争之炎','[]'),(4,12040003,1,'黄金之沙','[]'),(4,12040003,2,'黄金之沙','[]'),(4,12040003,3,'黄金之沙','[]'),(4,12040003,4,'黄金之沙','[]'),(4,12040004,1,'律动音符','[]'),(4,12040004,2,'律动音符','[]'),(4,12040004,3,'律动音符','[]'),(4,12040004,4,'律动音符','[]'),(4,12040005,1,'海洋之友','[]'),(4,12040005,2,'海洋之友','[]'),(4,12040005,3,'海洋之友','[]'),(4,12040005,4,'海洋之友','[]'),(4,12040006,1,'伟大航线','[]'),(4,12040006,2,'伟大航线','[]'),(4,12040006,3,'伟大航线','[]'),(4,12040006,4,'伟大航线','[]'),(4,12040007,1,'青春之焰','[]'),(4,12040007,2,'青春之焰','[]'),(4,12040007,3,'青春之焰','[]'),(4,12040007,4,'青春之焰','[]'),(4,12040008,1,'黑白萌印','[]'),(4,12040008,2,'黑白萌印','[]'),(4,12040008,3,'黑白萌印','[]'),(4,12040008,4,'黑白萌印','[]');
/*!40000 ALTER TABLE `base_fashion_color_logo` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_fashion_decompose`
--

DROP TABLE IF EXISTS `base_fashion_decompose`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_fashion_decompose` (
  `goods_id` int(11) unsigned NOT NULL COMMENT '物品id',
  `pos_id` int(10) unsigned NOT NULL COMMENT '部位id',
  PRIMARY KEY (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='时装-物品分解表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_fashion_decompose`
--

LOCK TABLES `base_fashion_decompose` WRITE;
/*!40000 ALTER TABLE `base_fashion_decompose` DISABLE KEYS */;
INSERT INTO `base_fashion_decompose` VALUES (12060001,1),(12060002,2),(12060003,3),(12060004,4);
/*!40000 ALTER TABLE `base_fashion_decompose` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_fashion_model`
--

DROP TABLE IF EXISTS `base_fashion_model`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_fashion_model` (
  `pos_id` int(10) unsigned NOT NULL COMMENT '部位id',
  `fashion_id` int(10) unsigned NOT NULL COMMENT '时装id',
  `career` int(10) unsigned NOT NULL COMMENT '职业',
  `color_id` int(10) unsigned NOT NULL COMMENT '默认颜色id',
  `model_id` int(10) unsigned NOT NULL COMMENT '模型id',
  PRIMARY KEY (`pos_id`,`fashion_id`,`career`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='时装模型贴图配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_fashion_model`
--

LOCK TABLES `base_fashion_model` WRITE;
/*!40000 ALTER TABLE `base_fashion_model` DISABLE KEYS */;
INSERT INTO `base_fashion_model` VALUES (1,12010001,1,0,10105001),(1,12010001,2,0,10205001),(1,12010001,3,0,10305001),(1,12010001,4,0,10405001),(1,12010002,1,0,10102001),(1,12010002,2,0,10202001),(1,12010002,3,0,10302001),(1,12010002,4,0,10402001),(1,12010003,1,0,10103001),(1,12010003,2,0,10203001),(1,12010003,3,0,10303001),(1,12010003,4,0,10403001),(1,12010004,1,0,10104001),(1,12010004,2,0,10204001),(1,12010004,3,0,10304001),(1,12010004,4,0,10404001),(1,12010005,1,0,10108001),(1,12010005,2,0,10208001),(1,12010005,3,0,10308001),(1,12010005,4,0,10408001),(1,12010006,1,0,10107001),(1,12010006,2,0,10207001),(1,12010006,3,0,10307001),(1,12010006,4,0,10407001),(1,12010007,1,0,10106001),(1,12010007,2,0,10206001),(1,12010007,3,0,10306001),(1,12010007,4,0,10406001),(1,12010008,1,0,10109001),(1,12010008,2,0,10209001),(1,12010008,3,0,10309001),(1,12010008,4,0,10409001),(1,12010009,1,0,10110001),(1,12010009,2,0,10210001),(1,12010009,3,0,10310001),(1,12010009,4,0,10410001),(1,12010010,1,0,10111001),(1,12010010,2,0,10211001),(1,12010010,3,0,10311001),(1,12010010,4,0,10411001),(1,12010011,1,0,10112001),(1,12010011,2,0,10212001),(1,12010011,3,0,10312001),(1,12010011,4,0,10412001),(1,12010012,1,0,10119001),(1,12010012,2,0,10219001),(1,12010012,3,0,10319001),(1,12010012,4,0,10419001),(2,12020001,1,0,10105001),(2,12020001,2,0,10205001),(2,12020001,3,0,10305001),(2,12020001,4,0,10405001),(2,12020002,1,0,10102001),(2,12020002,2,0,10202001),(2,12020002,3,0,10302001),(2,12020002,4,0,10402001),(2,12020003,1,0,10103001),(2,12020003,2,0,10203001),(2,12020003,3,0,10303001),(2,12020003,4,0,10403001),(2,12020004,1,0,10104001),(2,12020004,2,0,10204001),(2,12020004,3,0,10304001),(2,12020004,4,0,10404001),(2,12020005,1,0,10108001),(2,12020005,2,0,10208001),(2,12020005,3,0,10308001),(2,12020005,4,0,10408001),(2,12020006,1,0,10107001),(2,12020006,2,0,10207001),(2,12020006,3,0,10307001),(2,12020006,4,0,10407001),(2,12020007,1,0,10106001),(2,12020007,2,0,10206001),(2,12020007,3,0,10306001),(2,12020007,4,0,10406001),(2,12020008,1,0,10109001),(2,12020008,2,0,10209001),(2,12020008,3,0,10309001),(2,12020008,4,0,10409001),(2,12020009,1,0,10110001),(2,12020009,2,0,10210001),(2,12020009,3,0,10310001),(2,12020009,4,0,10410001),(2,12020010,1,0,10111001),(2,12020010,2,0,10211001),(2,12020010,3,0,10311001),(2,12020010,4,0,10411001),(2,12020011,1,0,10112001),(2,12020011,2,0,10212001),(2,12020011,3,0,10312001),(2,12020011,4,0,10412001),(2,12020012,1,0,10119001),(2,12020012,2,0,10219001),(2,12020012,3,0,10319001),(2,12020012,4,0,10419001),(3,12030001,1,0,10105001),(3,12030001,2,0,10205001),(3,12030001,3,0,10305001),(3,12030001,4,0,10405001),(3,12030002,1,0,10102001),(3,12030002,2,0,10202001),(3,12030002,3,0,10302001),(3,12030002,4,0,10402001),(3,12030003,1,0,10103001),(3,12030003,2,0,10203001),(3,12030003,3,0,10303001),(3,12030003,4,0,10403001),(3,12030004,1,0,10104001),(3,12030004,2,0,10204001),(3,12030004,3,0,10304001),(3,12030004,4,0,10404001),(3,12030005,1,0,10108001),(3,12030005,2,0,10208001),(3,12030005,3,0,10308001),(3,12030005,4,0,10408001),(3,12030006,1,0,10107001),(3,12030006,2,0,10207001),(3,12030006,3,0,10307001),(3,12030006,4,0,10407001),(3,12030007,1,0,10106001),(3,12030007,2,0,10206001),(3,12030007,3,0,10306001),(3,12030007,4,0,10406001),(3,12030008,1,0,10109001),(3,12030008,2,0,10209001),(3,12030008,3,0,10309001),(3,12030008,4,0,10409001),(3,12030009,1,0,10110001),(3,12030009,2,0,10210001),(3,12030009,3,0,10310001),(3,12030009,4,0,10410001),(3,12030010,1,0,10111001),(3,12030010,2,0,10211001),(3,12030010,3,0,10311001),(3,12030010,4,0,10411001),(3,12030011,1,0,10112001),(3,12030011,2,0,10212001),(3,12030011,3,0,10312001),(3,12030011,4,0,10412001),(3,12030012,1,0,10119001),(3,12030012,2,0,10219001),(3,12030012,3,0,10319001),(3,12030012,4,0,10419001),(4,12040001,1,0,10005001),(4,12040001,2,0,10005001),(4,12040001,3,0,10005001),(4,12040001,4,0,10005001),(4,12040002,1,0,10002001),(4,12040002,2,0,10002001),(4,12040002,3,0,10002001),(4,12040002,4,0,10002001),(4,12040003,1,0,10003001),(4,12040003,2,0,10003001),(4,12040003,3,0,10003001),(4,12040003,4,0,10003001),(4,12040004,1,0,10004001),(4,12040004,2,0,10004001),(4,12040004,3,0,10004001),(4,12040004,4,0,10004001),(4,12040005,1,0,10008001),(4,12040005,2,0,10008001),(4,12040005,3,0,10008001),(4,12040005,4,0,10008001),(4,12040006,1,0,10007001),(4,12040006,2,0,10007001),(4,12040006,3,0,10007001),(4,12040006,4,0,10007001),(4,12040007,1,0,10006001),(4,12040007,2,0,10006001),(4,12040007,3,0,10006001),(4,12040007,4,0,10006001),(4,12040008,1,0,10009001),(4,12040008,2,0,10009001),(4,12040008,3,0,10009001),(4,12040008,4,0,10009001);
/*!40000 ALTER TABLE `base_fashion_model` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_fashion_pos`
--

DROP TABLE IF EXISTS `base_fashion_pos`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_fashion_pos` (
  `pos_id` int(10) unsigned NOT NULL COMMENT '位置id',
  `pos_lv` int(11) NOT NULL COMMENT '部位等级',
  `cost` int(10) unsigned NOT NULL COMMENT '消耗积分',
  `attr_add_list` varchar(500) NOT NULL COMMENT '属性加成百分比列表',
  PRIMARY KEY (`pos_id`,`pos_lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='时装部位配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_fashion_pos`
--

LOCK TABLES `base_fashion_pos` WRITE;
/*!40000 ALTER TABLE `base_fashion_pos` DISABLE KEYS */;
INSERT INTO `base_fashion_pos` VALUES (1,0,1351,'[{68,0}]'),(1,1,1377,'[{68,100}]'),(1,2,1404,'[{68,200}]'),(1,3,1430,'[{68,300}]'),(1,4,1457,'[{68,400}]'),(1,5,1483,'[{68,500}]'),(1,6,1510,'[{68,600}]'),(1,7,1536,'[{68,700}]'),(1,8,1563,'[{68,800}]'),(1,9,1589,'[{68,900}]'),(1,10,1616,'[{68,1000}]'),(1,11,1642,'[{68,1100}]'),(1,12,1669,'[{68,1200}]'),(1,13,1695,'[{68,1300}]'),(1,14,1722,'[{68,1400}]'),(1,15,1748,'[{68,1500}]'),(1,16,1775,'[{68,1600}]'),(1,17,1801,'[{68,1700}]'),(1,18,1828,'[{68,1800}]'),(1,19,1854,'[{68,1900}]'),(1,20,1881,'[{68,2000}]'),(1,21,1907,'[{68,2100}]'),(1,22,1934,'[{68,2200}]'),(1,23,1960,'[{68,2300}]'),(1,24,1987,'[{68,2400}]'),(1,25,2013,'[{68,2500}]'),(1,26,2040,'[{68,2600}]'),(1,27,2066,'[{68,2700}]'),(1,28,2093,'[{68,2800}]'),(1,29,2119,'[{68,2900}]'),(1,30,2146,'[{68,3000}]'),(1,31,2172,'[{68,3100}]'),(1,32,2199,'[{68,3200}]'),(1,33,2225,'[{68,3300}]'),(1,34,2252,'[{68,3400}]'),(1,35,2278,'[{68,3500}]'),(1,36,2305,'[{68,3600}]'),(1,37,2331,'[{68,3700}]'),(1,38,2358,'[{68,3800}]'),(1,39,2384,'[{68,3900}]'),(1,40,2411,'[{68,4000}]'),(1,41,2437,'[{68,4100}]'),(1,42,2464,'[{68,4200}]'),(1,43,2490,'[{68,4300}]'),(1,44,2517,'[{68,4400}]'),(1,45,2543,'[{68,4500}]'),(1,46,2570,'[{68,4600}]'),(1,47,2596,'[{68,4700}]'),(1,48,2623,'[{68,4800}]'),(1,49,2649,'[{68,4900}]'),(1,50,0,'[{68,5000}]'),(2,0,1351,'[{68,0}]'),(2,1,1377,'[{68,100}]'),(2,2,1404,'[{68,200}]'),(2,3,1430,'[{68,300}]'),(2,4,1457,'[{68,400}]'),(2,5,1483,'[{68,500}]'),(2,6,1510,'[{68,600}]'),(2,7,1536,'[{68,700}]'),(2,8,1563,'[{68,800}]'),(2,9,1589,'[{68,900}]'),(2,10,1616,'[{68,1000}]'),(2,11,1642,'[{68,1100}]'),(2,12,1669,'[{68,1200}]'),(2,13,1695,'[{68,1300}]'),(2,14,1722,'[{68,1400}]'),(2,15,1748,'[{68,1500}]'),(2,16,1775,'[{68,1600}]'),(2,17,1801,'[{68,1700}]'),(2,18,1828,'[{68,1800}]'),(2,19,1854,'[{68,1900}]'),(2,20,1881,'[{68,2000}]'),(2,21,1907,'[{68,2100}]'),(2,22,1934,'[{68,2200}]'),(2,23,1960,'[{68,2300}]'),(2,24,1987,'[{68,2400}]'),(2,25,2013,'[{68,2500}]'),(2,26,2040,'[{68,2600}]'),(2,27,2066,'[{68,2700}]'),(2,28,2093,'[{68,2800}]'),(2,29,2119,'[{68,2900}]'),(2,30,2146,'[{68,3000}]'),(2,31,2172,'[{68,3100}]'),(2,32,2199,'[{68,3200}]'),(2,33,2225,'[{68,3300}]'),(2,34,2252,'[{68,3400}]'),(2,35,2278,'[{68,3500}]'),(2,36,2305,'[{68,3600}]'),(2,37,2331,'[{68,3700}]'),(2,38,2358,'[{68,3800}]'),(2,39,2384,'[{68,3900}]'),(2,40,2411,'[{68,4000}]'),(2,41,2437,'[{68,4100}]'),(2,42,2464,'[{68,4200}]'),(2,43,2490,'[{68,4300}]'),(2,44,2517,'[{68,4400}]'),(2,45,2543,'[{68,4500}]'),(2,46,2570,'[{68,4600}]'),(2,47,2596,'[{68,4700}]'),(2,48,2623,'[{68,4800}]'),(2,49,2649,'[{68,4900}]'),(2,50,0,'[{68,5000}]'),(3,0,1351,'[{68,0}]'),(3,1,1377,'[{68,100}]'),(3,2,1404,'[{68,200}]'),(3,3,1430,'[{68,300}]'),(3,4,1457,'[{68,400}]'),(3,5,1483,'[{68,500}]'),(3,6,1510,'[{68,600}]'),(3,7,1536,'[{68,700}]'),(3,8,1563,'[{68,800}]'),(3,9,1589,'[{68,900}]'),(3,10,1616,'[{68,1000}]'),(3,11,1642,'[{68,1100}]'),(3,12,1669,'[{68,1200}]'),(3,13,1695,'[{68,1300}]'),(3,14,1722,'[{68,1400}]'),(3,15,1748,'[{68,1500}]'),(3,16,1775,'[{68,1600}]'),(3,17,1801,'[{68,1700}]'),(3,18,1828,'[{68,1800}]'),(3,19,1854,'[{68,1900}]'),(3,20,1881,'[{68,2000}]'),(3,21,1907,'[{68,2100}]'),(3,22,1934,'[{68,2200}]'),(3,23,1960,'[{68,2300}]'),(3,24,1987,'[{68,2400}]'),(3,25,2013,'[{68,2500}]'),(3,26,2040,'[{68,2600}]'),(3,27,2066,'[{68,2700}]'),(3,28,2093,'[{68,2800}]'),(3,29,2119,'[{68,2900}]'),(3,30,2146,'[{68,3000}]'),(3,31,2172,'[{68,3100}]'),(3,32,2199,'[{68,3200}]'),(3,33,2225,'[{68,3300}]'),(3,34,2252,'[{68,3400}]'),(3,35,2278,'[{68,3500}]'),(3,36,2305,'[{68,3600}]'),(3,37,2331,'[{68,3700}]'),(3,38,2358,'[{68,3800}]'),(3,39,2384,'[{68,3900}]'),(3,40,2411,'[{68,4000}]'),(3,41,2437,'[{68,4100}]'),(3,42,2464,'[{68,4200}]'),(3,43,2490,'[{68,4300}]'),(3,44,2517,'[{68,4400}]'),(3,45,2543,'[{68,4500}]'),(3,46,2570,'[{68,4600}]'),(3,47,2596,'[{68,4700}]'),(3,48,2623,'[{68,4800}]'),(3,49,2649,'[{68,4900}]'),(3,50,0,'[{68,5000}]'),(4,0,1351,'[{68,0}]'),(4,1,1377,'[{68,100}]'),(4,2,1404,'[{68,200}]'),(4,3,1430,'[{68,300}]'),(4,4,1457,'[{68,400}]'),(4,5,1483,'[{68,500}]'),(4,6,1510,'[{68,600}]'),(4,7,1536,'[{68,700}]'),(4,8,1563,'[{68,800}]'),(4,9,1589,'[{68,900}]'),(4,10,1616,'[{68,1000}]'),(4,11,1642,'[{68,1100}]'),(4,12,1669,'[{68,1200}]'),(4,13,1695,'[{68,1300}]'),(4,14,1722,'[{68,1400}]'),(4,15,1748,'[{68,1500}]'),(4,16,1775,'[{68,1600}]'),(4,17,1801,'[{68,1700}]'),(4,18,1828,'[{68,1800}]'),(4,19,1854,'[{68,1900}]'),(4,20,1881,'[{68,2000}]'),(4,21,1907,'[{68,2100}]'),(4,22,1934,'[{68,2200}]'),(4,23,1960,'[{68,2300}]'),(4,24,1987,'[{68,2400}]'),(4,25,2013,'[{68,2500}]'),(4,26,2040,'[{68,2600}]'),(4,27,2066,'[{68,2700}]'),(4,28,2093,'[{68,2800}]'),(4,29,2119,'[{68,2900}]'),(4,30,2146,'[{68,3000}]'),(4,31,2172,'[{68,3100}]'),(4,32,2199,'[{68,3200}]'),(4,33,2225,'[{68,3300}]'),(4,34,2252,'[{68,3400}]'),(4,35,2278,'[{68,3500}]'),(4,36,2305,'[{68,3600}]'),(4,37,2331,'[{68,3700}]'),(4,38,2358,'[{68,3800}]'),(4,39,2384,'[{68,3900}]'),(4,40,2411,'[{68,4000}]'),(4,41,2437,'[{68,4100}]'),(4,42,2464,'[{68,4200}]'),(4,43,2490,'[{68,4300}]'),(4,44,2517,'[{68,4400}]'),(4,45,2543,'[{68,4500}]'),(4,46,2570,'[{68,4600}]'),(4,47,2596,'[{68,4700}]'),(4,48,2623,'[{68,4800}]'),(4,49,2649,'[{68,4900}]'),(4,50,0,'[{68,5000}]');
/*!40000 ALTER TABLE `base_fashion_pos` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_fashion_upgrade`
--

DROP TABLE IF EXISTS `base_fashion_upgrade`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_fashion_upgrade` (
  `id` int(10) unsigned NOT NULL COMMENT '部位id',
  `goods_id` bigint(10) unsigned NOT NULL COMMENT '物品id',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='时装部位信息配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_fashion_upgrade`
--

LOCK TABLES `base_fashion_upgrade` WRITE;
/*!40000 ALTER TABLE `base_fashion_upgrade` DISABLE KEYS */;
INSERT INTO `base_fashion_upgrade` VALUES (1,12070001),(2,12070002),(3,12070003),(4,12070004);
/*!40000 ALTER TABLE `base_fashion_upgrade` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_fireworks_act`
--

DROP TABLE IF EXISTS `base_fireworks_act`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_fireworks_act` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `wlv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '世界等级',
  `goods` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `weight` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '权重',
  `limit_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '获取上限',
  `all_server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '全服次数上限',
  `is_tv` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否发通告',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='烟花活动奖励配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_fireworks_act`
--

LOCK TABLES `base_fireworks_act` WRITE;
/*!40000 ALTER TABLE `base_fireworks_act` DISABLE KEYS */;
INSERT INTO `base_fireworks_act` VALUES (1,0,'[{0,20030001,1}]',10,1,2,1),(2,0,'[{0,24030001,1}]',10,1,2,1),(3,0,'[{0,20020003,1}]',10,1,2,1),(4,0,'[{0,24020003,1}]',10,1,2,1),(5,0,'[{0,14010003,1}]',75,0,0,0),(6,0,'[{0,14020003,1}]',75,0,0,0),(7,0,'[{0,32010045,1}]',80,0,0,0),(8,0,'[{0,37020002,1}]',100,0,0,0),(9,0,'[{0,20020001,1}]',20,0,0,0),(10,0,'[{0,20020002,1}]',20,0,0,0),(11,0,'[{0,24020001,1}]',20,0,0,0),(12,0,'[{0,24020002,1}]',20,0,0,0),(13,0,'[{0,20010002,1}]',150,0,0,0),(14,0,'[{0,24010002,1}]',150,0,0,0),(15,0,'[{0,14010002,1}]',100,0,0,0),(16,0,'[{0,14020002,1}]',100,0,0,0),(17,0,'[{0,32010044,1}]',50,0,0,0),(18,201,'[{0,20030002,1}]',5,1,1,1),(19,201,'[{0,24030002,1}]',5,1,1,1),(20,201,'[{0,20030001,1}]',10,1,2,1),(21,201,'[{0,24030001,1}]',10,1,2,1),(22,201,'[{0,20020003,1}]',10,1,2,1),(23,201,'[{0,24020003,1}]',10,1,2,1),(24,201,'[{0,32010058,1}]',150,0,0,0),(25,201,'[{0,32010045,1}]',70,0,0,0),(26,201,'[{0,14010003,1}]',75,0,0,0),(27,201,'[{0,14020003,1}]',75,0,0,0),(28,201,'[{0,37020002,1}]',50,0,0,0),(29,201,'[{0,32010044,1}]',50,0,0,0),(30,201,'[{0,20020001,1}]',20,0,0,0),(31,201,'[{0,20020002,1}]',20,0,0,0),(32,201,'[{0,24020001,1}]',20,0,0,0),(33,201,'[{0,24020002,1}]',20,0,0,0),(34,201,'[{0,20010002,1}]',100,0,0,0),(35,201,'[{0,24010002,1}]',100,0,0,0),(36,201,'[{0,14010002,1}]',100,0,0,0),(37,201,'[{0,14020002,1}]',100,0,0,0),(38,251,'[{0,20030002,1}]',5,1,1,1),(39,251,'[{0,24030002,1}]',5,1,1,1),(40,251,'[{0,20030001,1}]',10,1,2,1),(41,251,'[{0,24030001,1}]',10,1,2,1),(42,251,'[{0,32010059,1}]',50,0,0,0),(43,251,'[{0,32010058,1}]',150,0,0,0),(44,251,'[{0,14010004,1}]',50,0,0,0),(45,251,'[{0,14020004,1}]',50,0,0,0),(46,251,'[{0,38040011,1}]',50,0,0,0),(47,251,'[{0,38040002,50}]',50,0,0,0),(48,251,'[{0,20020003,1}]',10,1,2,1),(49,251,'[{0,24020003,1}]',10,1,2,1),(50,251,'[{0,20020001,1}]',20,0,0,0),(51,251,'[{0,20020002,1}]',20,0,0,0),(52,251,'[{0,24020001,1}]',20,0,0,0),(53,251,'[{0,24020002,1}]',20,0,0,0),(54,251,'[{0,20010002,1}]',80,0,0,0),(55,251,'[{0,24010002,1}]',80,0,0,0),(56,251,'[{0,14010003,1}]',75,0,0,0),(57,251,'[{0,14020003,1}]',75,0,0,0),(58,251,'[{0,37020002,1}]',50,0,0,0),(59,251,'[{0,32010044,1}]',50,0,0,0),(60,251,'[{0,32010045,1}]',60,0,0,0),(61,301,'[{0,24030003,1}]',5,1,1,1),(62,301,'[{0,20030004,1}]',5,1,1,1),(63,301,'[{0,24030002,1}]',5,1,1,1),(64,301,'[{0,20030002,1}]',5,1,1,1),(65,301,'[{0,38041018,1}]',20,0,0,0),(66,301,'[{0,38040005,1}]',5,1,1,1),(67,301,'[{0,32010059,1}]',50,0,0,0),(68,301,'[{0,32010058,1}]',145,0,0,0),(69,301,'[{0,20030001,1}]',5,1,2,1),(70,301,'[{0,24030001,1}]',5,1,2,1),(71,301,'[{0,14010004,1}]',50,0,0,0),(72,301,'[{0,14020004,1}]',50,0,0,0),(73,301,'[{0,38040011,1}]',50,0,0,0),(74,301,'[{0,38040002,50}]',50,0,0,0),(75,301,'[{0,20020003,1}]',10,1,2,1),(76,301,'[{0,24020003,1}]',10,1,2,1),(77,301,'[{0,20020001,1}]',20,0,0,0),(78,301,'[{0,20020002,1}]',20,0,0,0),(79,301,'[{0,24020001,1}]',20,0,0,0),(80,301,'[{0,24020002,1}]',20,0,0,0),(81,301,'[{0,20010002,1}]',80,0,0,0),(82,301,'[{0,24010002,1}]',80,0,0,0),(83,301,'[{0,14010003,1}]',70,0,0,0),(84,301,'[{0,14020003,1}]',70,0,0,0),(85,301,'[{0,37020002,1}]',50,0,0,0),(86,301,'[{0,32010044,1}]',50,0,0,0),(87,301,'[{0,32010045,1}]',50,0,0,0),(88,401,'[{0,24030004,1}]',5,1,1,1),(89,401,'[{0,20030005,1}]',5,1,1,1),(90,401,'[{0,24030003,1}]',5,1,1,1),(91,401,'[{0,20030004,1}]',5,1,1,1),(92,401,'[{0,38040019,1}]',5,1,1,1),(93,401,'[{0,38040005,1}]',5,1,1,1),(94,401,'[{0,38041018,1}]',20,0,0,0),(95,401,'[{0,32010059,1}]',50,0,0,0),(96,401,'[{0,24030002,1}]',5,1,1,1),(97,401,'[{0,20030002,1}]',5,1,1,1),(98,401,'[{0,24030001,1}]',5,1,2,1),(99,401,'[{0,20030001,1}]',5,1,2,1),(100,401,'[{0,14010004,1}]',50,0,0,0),(101,401,'[{0,14020004,1}]',50,0,0,0),(102,401,'[{0,20020003,1}]',10,1,2,1),(103,401,'[{0,24020003,1}]',10,1,2,1),(104,401,'[{0,20020001,1}]',20,0,0,0),(105,401,'[{0,20020002,1}]',20,0,0,0),(106,401,'[{0,24020001,1}]',20,0,0,0),(107,401,'[{0,24020002,1}]',20,0,0,0),(108,401,'[{0,20010002,1}]',80,0,0,0),(109,401,'[{0,24010002,1}]',80,0,0,0),(110,401,'[{0,14010003,1}]',65,0,0,0),(111,401,'[{0,14020003,1}]',65,0,0,0),(112,401,'[{0,37020002,1}]',50,0,0,0),(113,401,'[{0,32010044,1}]',50,0,0,0),(114,401,'[{0,32010045,1}]',50,0,0,0),(115,401,'[{0,32010058,1}]',140,0,0,0),(116,401,'[{0,38040002,50}]',50,0,0,0),(117,401,'[{0,38040011,1}]',50,0,0,0);
/*!40000 ALTER TABLE `base_fireworks_act` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_fireworks_act_cfg`
--

DROP TABLE IF EXISTS `base_fireworks_act_cfg`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_fireworks_act_cfg` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `key` varchar(255) NOT NULL DEFAULT '' COMMENT 'key',
  `val` varchar(255) NOT NULL DEFAULT '0' COMMENT '值',
  `desc` varchar(1024) NOT NULL DEFAULT '' COMMENT '描述',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='烟花活动常量配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_fireworks_act_cfg`
--

LOCK TABLES `base_fireworks_act_cfg` WRITE;
/*!40000 ALTER TABLE `base_fireworks_act_cfg` DISABLE KEYS */;
INSERT INTO `base_fireworks_act_cfg` VALUES (1,'num_period','100','个人次数限制周期'),(2,'fireworks_id','38220002','烟花物品id'),(4,'global_num_period','200','全服次数限制周期'),(5,'fireworks_effect','effect_xunbaoyanhua_001','烟花特效');
/*!40000 ALTER TABLE `base_fireworks_act_cfg` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_fireworks_plus_weight`
--

DROP TABLE IF EXISTS `base_fireworks_plus_weight`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_fireworks_plus_weight` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '唯一id',
  `times` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '全服次数',
  `plus_weight` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '增加权重',
  PRIMARY KEY (`id`,`times`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='烟花动态概率配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_fireworks_plus_weight`
--

LOCK TABLES `base_fireworks_plus_weight` WRITE;
/*!40000 ALTER TABLE `base_fireworks_plus_weight` DISABLE KEYS */;
/*!40000 ALTER TABLE `base_fireworks_plus_weight` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_fish_illustrated`
--

DROP TABLE IF EXISTS `base_fish_illustrated`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_fish_illustrated` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '图鉴id',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '图鉴类型',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '图鉴名称',
  `quality` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '图鉴品质',
  `active_condition` varchar(128) NOT NULL DEFAULT '[]' COMMENT '激活条件',
  `photo_id` varchar(50) NOT NULL DEFAULT '' COMMENT '图片资源id',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='鱼类图鉴激活表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_fish_illustrated`
--

LOCK TABLES `base_fish_illustrated` WRITE;
/*!40000 ALTER TABLE `base_fish_illustrated` DISABLE KEYS */;
INSERT INTO `base_fish_illustrated` VALUES (50020101,1,'鳕鱼',0,'[]','50020101'),(50020102,1,'三文鱼',0,'[]','50020102'),(50020103,1,'九纹龙',0,'[]','50020103'),(50020104,1,'黄金尖尾鲈',1,'[]','50020104'),(50020105,1,'珊瑚美人',1,'[]','50020105'),(50020106,1,'龙鱼',2,'[]','50020106'),(50020107,1,'破浪剑鱼',2,'[]','50020107'),(50020108,1,'黄金鲶鱼',3,'[]','50020108'),(50020109,1,'彩斑河豚',3,'[]','50020109'),(50020110,1,'小丑鱼',4,'[]','50020110'),(50020111,1,'彩虹鱼',4,'[]','50020111'),(50030101,2,'章鱼',0,'[]','50030101'),(50030102,2,'龙尾虾',0,'[]','50030102'),(50030103,2,'鲍鱼',1,'[]','50030103'),(50030104,2,'珍宝蟹',1,'[]','50030104'),(50030105,2,'黄金海星',2,'[]','50030105'),(50030106,2,'红玉珊瑚',2,'[]','50030106'),(50030107,2,'寄居蟹',3,'[]','50030107'),(50030108,2,'幼生海草',4,'[]','50030108'),(50040101,3,'珍珠贝',0,'[]','50040101'),(50040102,3,'黄金螺',1,'[]','50040102'),(50040103,3,'火焰贝壳',2,'[]','50040103'),(50040104,3,'石斑螺',3,'[]','50040104');
/*!40000 ALTER TABLE `base_fish_illustrated` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_fish_illustrated_lv`
--

DROP TABLE IF EXISTS `base_fish_illustrated_lv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_fish_illustrated_lv` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '图鉴id',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '图鉴等级',
  `attr` varchar(128) NOT NULL DEFAULT '[]' COMMENT '图鉴属性',
  `cost` varchar(128) NOT NULL DEFAULT '[]' COMMENT '消耗道具',
  PRIMARY KEY (`id`,`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='鱼类图鉴升级表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_fish_illustrated_lv`
--

LOCK TABLES `base_fish_illustrated_lv` WRITE;
/*!40000 ALTER TABLE `base_fish_illustrated_lv` DISABLE KEYS */;
INSERT INTO `base_fish_illustrated_lv` VALUES (50020101,1,'[{2,160},{1,8},{5,5},{6,5}]','[{50020101,1}]'),(50020101,2,'[{2,294},{1,15},{5,9},{6,9}]','[{50020101,2}]'),(50020101,3,'[{2,446},{1,23},{5,14},{6,14}]','[{50020101,3}]'),(50020101,4,'[{2,616},{1,32},{5,19},{6,19}]','[{50020101,4}]'),(50020101,5,'[{2,804},{1,41},{5,25},{6,25}]','[{50020101,5}]'),(50020101,6,'[{2,1010},{1,51},{5,31},{6,31}]','[{50020101,6}]'),(50020101,7,'[{2,1234},{1,62},{5,38},{6,38}]','[{50020101,7}]'),(50020101,8,'[{2,1476},{1,74},{5,46},{6,46}]','[{50020101,8}]'),(50020101,9,'[{2,1736},{1,87},{5,54},{6,54}]','[{50020101,9}]'),(50020101,10,'[{2,2014},{1,101},{5,63},{6,63}]','[{50020101,10}]'),(50020101,11,'[{2,2310},{1,116},{5,72},{6,72}]','[{50020101,11}]'),(50020101,12,'[{2,2624},{1,132},{5,82},{6,82}]','[{50020101,12}]'),(50020101,13,'[{2,2956},{1,149},{5,92},{6,92}]','[{50020101,13}]'),(50020101,14,'[{2,3306},{1,167},{5,103},{6,103}]','[{50020101,14}]'),(50020101,15,'[{2,3674},{1,185},{5,115},{6,115}]','[{50020101,15}]'),(50020101,16,'[{2,4060},{1,204},{5,127},{6,127}]','[{50020101,16}]'),(50020101,17,'[{2,4464},{1,224},{5,140},{6,140}]','[{50020101,17}]'),(50020101,18,'[{2,4886},{1,245},{5,153},{6,153}]','[{50020101,18}]'),(50020101,19,'[{2,5326},{1,267},{5,167},{6,167}]','[{50020101,19}]'),(50020101,20,'[{2,5784},{1,290},{5,181},{6,181}]','[{50020101,20}]'),(50020101,21,'[{2,6266},{1,314},{5,196},{6,196}]','[{50020101,22}]'),(50020101,22,'[{2,6772},{1,339},{5,212},{6,212}]','[{50020101,24}]'),(50020101,23,'[{2,7302},{1,366},{5,229},{6,229}]','[{50020101,26}]'),(50020101,24,'[{2,7856},{1,394},{5,246},{6,246}]','[{50020101,28}]'),(50020101,25,'[{2,8434},{1,423},{5,264},{6,264}]','[{50020101,30}]'),(50020101,26,'[{2,9036},{1,453},{5,283},{6,283}]','[{50020101,32}]'),(50020101,27,'[{2,9662},{1,484},{5,303},{6,303}]','[{50020101,34}]'),(50020101,28,'[{2,10312},{1,517},{5,323},{6,323}]','[{50020101,36}]'),(50020101,29,'[{2,10986},{1,551},{5,344},{6,344}]','[{50020101,38}]'),(50020101,30,'[{2,11684},{1,586},{5,366},{6,366}]','[{50020101,40}]'),(50020101,31,'[{2,12406},{1,622},{5,389},{6,389}]','[{50020101,42}]'),(50020101,32,'[{2,13152},{1,659},{5,412},{6,412}]','[{50020101,44}]'),(50020101,33,'[{2,13922},{1,698},{5,436},{6,436}]','[{50020101,46}]'),(50020101,34,'[{2,14716},{1,738},{5,461},{6,461}]','[{50020101,48}]'),(50020101,35,'[{2,15534},{1,779},{5,487},{6,487}]','[{50020101,50}]'),(50020101,36,'[{2,16376},{1,821},{5,513},{6,513}]','[{50020101,52}]'),(50020101,37,'[{2,17242},{1,864},{5,540},{6,540}]','[{50020101,54}]'),(50020101,38,'[{2,18132},{1,909},{5,568},{6,568}]','[{50020101,56}]'),(50020101,39,'[{2,19046},{1,955},{5,597},{6,597}]','[{50020101,58}]'),(50020101,40,'[{2,19984},{1,1002},{5,626},{6,626}]','[{50020101,60}]'),(50020102,1,'[{2,160},{1,8},{5,5},{6,5}]','[{50020102,1}]'),(50020102,2,'[{2,294},{1,15},{5,9},{6,9}]','[{50020102,2}]'),(50020102,3,'[{2,446},{1,23},{5,14},{6,14}]','[{50020102,3}]'),(50020102,4,'[{2,616},{1,32},{5,19},{6,19}]','[{50020102,4}]'),(50020102,5,'[{2,804},{1,41},{5,25},{6,25}]','[{50020102,5}]'),(50020102,6,'[{2,1010},{1,51},{5,31},{6,31}]','[{50020102,6}]'),(50020102,7,'[{2,1234},{1,62},{5,38},{6,38}]','[{50020102,7}]'),(50020102,8,'[{2,1476},{1,74},{5,46},{6,46}]','[{50020102,8}]'),(50020102,9,'[{2,1736},{1,87},{5,54},{6,54}]','[{50020102,9}]'),(50020102,10,'[{2,2014},{1,101},{5,63},{6,63}]','[{50020102,10}]'),(50020102,11,'[{2,2310},{1,116},{5,72},{6,72}]','[{50020102,11}]'),(50020102,12,'[{2,2624},{1,132},{5,82},{6,82}]','[{50020102,12}]'),(50020102,13,'[{2,2956},{1,149},{5,92},{6,92}]','[{50020102,13}]'),(50020102,14,'[{2,3306},{1,167},{5,103},{6,103}]','[{50020102,14}]'),(50020102,15,'[{2,3674},{1,185},{5,115},{6,115}]','[{50020102,15}]'),(50020102,16,'[{2,4060},{1,204},{5,127},{6,127}]','[{50020102,16}]'),(50020102,17,'[{2,4464},{1,224},{5,140},{6,140}]','[{50020102,17}]'),(50020102,18,'[{2,4886},{1,245},{5,153},{6,153}]','[{50020102,18}]'),(50020102,19,'[{2,5326},{1,267},{5,167},{6,167}]','[{50020102,19}]'),(50020102,20,'[{2,5784},{1,290},{5,181},{6,181}]','[{50020102,20}]'),(50020102,21,'[{2,6266},{1,314},{5,196},{6,196}]','[{50020102,22}]'),(50020102,22,'[{2,6772},{1,339},{5,212},{6,212}]','[{50020102,24}]'),(50020102,23,'[{2,7302},{1,366},{5,229},{6,229}]','[{50020102,26}]'),(50020102,24,'[{2,7856},{1,394},{5,246},{6,246}]','[{50020102,28}]'),(50020102,25,'[{2,8434},{1,423},{5,264},{6,264}]','[{50020102,30}]'),(50020102,26,'[{2,9036},{1,453},{5,283},{6,283}]','[{50020102,32}]'),(50020102,27,'[{2,9662},{1,484},{5,303},{6,303}]','[{50020102,34}]'),(50020102,28,'[{2,10312},{1,517},{5,323},{6,323}]','[{50020102,36}]'),(50020102,29,'[{2,10986},{1,551},{5,344},{6,344}]','[{50020102,38}]'),(50020102,30,'[{2,11684},{1,586},{5,366},{6,366}]','[{50020102,40}]'),(50020102,31,'[{2,12406},{1,622},{5,389},{6,389}]','[{50020102,42}]'),(50020102,32,'[{2,13152},{1,659},{5,412},{6,412}]','[{50020102,44}]'),(50020102,33,'[{2,13922},{1,698},{5,436},{6,436}]','[{50020102,46}]'),(50020102,34,'[{2,14716},{1,738},{5,461},{6,461}]','[{50020102,48}]'),(50020102,35,'[{2,15534},{1,779},{5,487},{6,487}]','[{50020102,50}]'),(50020102,36,'[{2,16376},{1,821},{5,513},{6,513}]','[{50020102,52}]'),(50020102,37,'[{2,17242},{1,864},{5,540},{6,540}]','[{50020102,54}]'),(50020102,38,'[{2,18132},{1,909},{5,568},{6,568}]','[{50020102,56}]'),(50020102,39,'[{2,19046},{1,955},{5,597},{6,597}]','[{50020102,58}]'),(50020102,40,'[{2,19984},{1,1002},{5,626},{6,626}]','[{50020102,60}]'),(50020103,1,'[{2,160},{1,8},{5,5},{6,5}]','[{50020103,1}]'),(50020103,2,'[{2,294},{1,15},{5,9},{6,9}]','[{50020103,2}]'),(50020103,3,'[{2,446},{1,23},{5,14},{6,14}]','[{50020103,3}]'),(50020103,4,'[{2,616},{1,32},{5,19},{6,19}]','[{50020103,4}]'),(50020103,5,'[{2,804},{1,41},{5,25},{6,25}]','[{50020103,5}]'),(50020103,6,'[{2,1010},{1,51},{5,31},{6,31}]','[{50020103,6}]'),(50020103,7,'[{2,1234},{1,62},{5,38},{6,38}]','[{50020103,7}]'),(50020103,8,'[{2,1476},{1,74},{5,46},{6,46}]','[{50020103,8}]'),(50020103,9,'[{2,1736},{1,87},{5,54},{6,54}]','[{50020103,9}]'),(50020103,10,'[{2,2014},{1,101},{5,63},{6,63}]','[{50020103,10}]'),(50020103,11,'[{2,2310},{1,116},{5,72},{6,72}]','[{50020103,11}]'),(50020103,12,'[{2,2624},{1,132},{5,82},{6,82}]','[{50020103,12}]'),(50020103,13,'[{2,2956},{1,149},{5,92},{6,92}]','[{50020103,13}]'),(50020103,14,'[{2,3306},{1,167},{5,103},{6,103}]','[{50020103,14}]'),(50020103,15,'[{2,3674},{1,185},{5,115},{6,115}]','[{50020103,15}]'),(50020103,16,'[{2,4060},{1,204},{5,127},{6,127}]','[{50020103,16}]'),(50020103,17,'[{2,4464},{1,224},{5,140},{6,140}]','[{50020103,17}]'),(50020103,18,'[{2,4886},{1,245},{5,153},{6,153}]','[{50020103,18}]'),(50020103,19,'[{2,5326},{1,267},{5,167},{6,167}]','[{50020103,19}]'),(50020103,20,'[{2,5784},{1,290},{5,181},{6,181}]','[{50020103,20}]'),(50020103,21,'[{2,6266},{1,314},{5,196},{6,196}]','[{50020103,22}]'),(50020103,22,'[{2,6772},{1,339},{5,212},{6,212}]','[{50020103,24}]'),(50020103,23,'[{2,7302},{1,366},{5,229},{6,229}]','[{50020103,26}]'),(50020103,24,'[{2,7856},{1,394},{5,246},{6,246}]','[{50020103,28}]'),(50020103,25,'[{2,8434},{1,423},{5,264},{6,264}]','[{50020103,30}]'),(50020103,26,'[{2,9036},{1,453},{5,283},{6,283}]','[{50020103,32}]'),(50020103,27,'[{2,9662},{1,484},{5,303},{6,303}]','[{50020103,34}]'),(50020103,28,'[{2,10312},{1,517},{5,323},{6,323}]','[{50020103,36}]'),(50020103,29,'[{2,10986},{1,551},{5,344},{6,344}]','[{50020103,38}]'),(50020103,30,'[{2,11684},{1,586},{5,366},{6,366}]','[{50020103,40}]'),(50020103,31,'[{2,12406},{1,622},{5,389},{6,389}]','[{50020103,42}]'),(50020103,32,'[{2,13152},{1,659},{5,412},{6,412}]','[{50020103,44}]'),(50020103,33,'[{2,13922},{1,698},{5,436},{6,436}]','[{50020103,46}]'),(50020103,34,'[{2,14716},{1,738},{5,461},{6,461}]','[{50020103,48}]'),(50020103,35,'[{2,15534},{1,779},{5,487},{6,487}]','[{50020103,50}]'),(50020103,36,'[{2,16376},{1,821},{5,513},{6,513}]','[{50020103,52}]'),(50020103,37,'[{2,17242},{1,864},{5,540},{6,540}]','[{50020103,54}]'),(50020103,38,'[{2,18132},{1,909},{5,568},{6,568}]','[{50020103,56}]'),(50020103,39,'[{2,19046},{1,955},{5,597},{6,597}]','[{50020103,58}]'),(50020103,40,'[{2,19984},{1,1002},{5,626},{6,626}]','[{50020103,60}]'),(50020104,1,'[{2,300},{1,15},{5,9},{6,9}]','[{50020104,1}]'),(50020104,2,'[{2,498},{1,25},{5,15},{6,15}]','[{50020104,2}]'),(50020104,3,'[{2,723},{1,36},{5,22},{6,22}]','[{50020104,3}]'),(50020104,4,'[{2,975},{1,49},{5,30},{6,30}]','[{50020104,4}]'),(50020104,5,'[{2,1254},{1,63},{5,38},{6,38}]','[{50020104,5}]'),(50020104,6,'[{2,1560},{1,78},{5,47},{6,47}]','[{50020104,6}]'),(50020104,7,'[{2,1893},{1,95},{5,57},{6,57}]','[{50020104,7}]'),(50020104,8,'[{2,2253},{1,113},{5,68},{6,68}]','[{50020104,8}]'),(50020104,9,'[{2,2640},{1,132},{5,80},{6,80}]','[{50020104,9}]'),(50020104,10,'[{2,3054},{1,153},{5,92},{6,92}]','[{50020104,10}]'),(50020104,11,'[{2,3495},{1,175},{5,105},{6,105}]','[{50020104,11}]'),(50020104,12,'[{2,3963},{1,198},{5,119},{6,119}]','[{50020104,12}]'),(50020104,13,'[{2,4458},{1,223},{5,134},{6,134}]','[{50020104,13}]'),(50020104,14,'[{2,4980},{1,249},{5,150},{6,150}]','[{50020104,14}]'),(50020104,15,'[{2,5529},{1,276},{5,166},{6,166}]','[{50020104,15}]'),(50020104,16,'[{2,6105},{1,305},{5,183},{6,183}]','[{50020104,16}]'),(50020104,17,'[{2,6708},{1,335},{5,201},{6,201}]','[{50020104,17}]'),(50020104,18,'[{2,7338},{1,367},{5,220},{6,220}]','[{50020104,18}]'),(50020104,19,'[{2,7995},{1,400},{5,240},{6,240}]','[{50020104,19}]'),(50020104,20,'[{2,8679},{1,434},{5,261},{6,261}]','[{50020104,20}]'),(50020104,21,'[{2,9399},{1,470},{5,283},{6,283}]','[{50020104,22}]'),(50020104,22,'[{2,10155},{1,508},{5,306},{6,306}]','[{50020104,24}]'),(50020104,23,'[{2,10947},{1,548},{5,330},{6,330}]','[{50020104,26}]'),(50020104,24,'[{2,11775},{1,589},{5,355},{6,355}]','[{50020104,28}]'),(50020104,25,'[{2,12639},{1,632},{5,381},{6,381}]','[{50020104,30}]'),(50020104,26,'[{2,13539},{1,677},{5,408},{6,408}]','[{50020104,32}]'),(50020104,27,'[{2,14475},{1,724},{5,436},{6,436}]','[{50020104,34}]'),(50020104,28,'[{2,15447},{1,773},{5,465},{6,465}]','[{50020104,36}]'),(50020104,29,'[{2,16455},{1,823},{5,495},{6,495}]','[{50020104,38}]'),(50020104,30,'[{2,17499},{1,875},{5,526},{6,526}]','[{50020104,40}]'),(50020104,31,'[{2,18579},{1,929},{5,558},{6,558}]','[{50020104,42}]'),(50020104,32,'[{2,19695},{1,985},{5,591},{6,591}]','[{50020104,44}]'),(50020104,33,'[{2,20847},{1,1043},{5,626},{6,626}]','[{50020104,46}]'),(50020104,34,'[{2,22035},{1,1102},{5,662},{6,662}]','[{50020104,48}]'),(50020104,35,'[{2,23259},{1,1163},{5,699},{6,699}]','[{50020104,50}]'),(50020104,36,'[{2,24519},{1,1226},{5,737},{6,737}]','[{50020104,52}]'),(50020104,37,'[{2,25815},{1,1291},{5,776},{6,776}]','[{50020104,54}]'),(50020104,38,'[{2,27147},{1,1358},{5,816},{6,816}]','[{50020104,56}]'),(50020104,39,'[{2,28515},{1,1426},{5,857},{6,857}]','[{50020104,58}]'),(50020104,40,'[{2,29919},{1,1496},{5,899},{6,899}]','[{50020104,60}]'),(50020105,1,'[{2,300},{1,15},{5,9},{6,9}]','[{50020105,1}]'),(50020105,2,'[{2,498},{1,25},{5,15},{6,15}]','[{50020105,2}]'),(50020105,3,'[{2,723},{1,36},{5,22},{6,22}]','[{50020105,3}]'),(50020105,4,'[{2,975},{1,49},{5,30},{6,30}]','[{50020105,4}]'),(50020105,5,'[{2,1254},{1,63},{5,38},{6,38}]','[{50020105,5}]'),(50020105,6,'[{2,1560},{1,78},{5,47},{6,47}]','[{50020105,6}]'),(50020105,7,'[{2,1893},{1,95},{5,57},{6,57}]','[{50020105,7}]'),(50020105,8,'[{2,2253},{1,113},{5,68},{6,68}]','[{50020105,8}]'),(50020105,9,'[{2,2640},{1,132},{5,80},{6,80}]','[{50020105,9}]'),(50020105,10,'[{2,3054},{1,153},{5,92},{6,92}]','[{50020105,10}]'),(50020105,11,'[{2,3495},{1,175},{5,105},{6,105}]','[{50020105,11}]'),(50020105,12,'[{2,3963},{1,198},{5,119},{6,119}]','[{50020105,12}]'),(50020105,13,'[{2,4458},{1,223},{5,134},{6,134}]','[{50020105,13}]'),(50020105,14,'[{2,4980},{1,249},{5,150},{6,150}]','[{50020105,14}]'),(50020105,15,'[{2,5529},{1,276},{5,166},{6,166}]','[{50020105,15}]'),(50020105,16,'[{2,6105},{1,305},{5,183},{6,183}]','[{50020105,16}]'),(50020105,17,'[{2,6708},{1,335},{5,201},{6,201}]','[{50020105,17}]'),(50020105,18,'[{2,7338},{1,367},{5,220},{6,220}]','[{50020105,18}]'),(50020105,19,'[{2,7995},{1,400},{5,240},{6,240}]','[{50020105,19}]'),(50020105,20,'[{2,8679},{1,434},{5,261},{6,261}]','[{50020105,20}]'),(50020105,21,'[{2,9399},{1,470},{5,283},{6,283}]','[{50020105,22}]'),(50020105,22,'[{2,10155},{1,508},{5,306},{6,306}]','[{50020105,24}]'),(50020105,23,'[{2,10947},{1,548},{5,330},{6,330}]','[{50020105,26}]'),(50020105,24,'[{2,11775},{1,589},{5,355},{6,355}]','[{50020105,28}]'),(50020105,25,'[{2,12639},{1,632},{5,381},{6,381}]','[{50020105,30}]'),(50020105,26,'[{2,13539},{1,677},{5,408},{6,408}]','[{50020105,32}]'),(50020105,27,'[{2,14475},{1,724},{5,436},{6,436}]','[{50020105,34}]'),(50020105,28,'[{2,15447},{1,773},{5,465},{6,465}]','[{50020105,36}]'),(50020105,29,'[{2,16455},{1,823},{5,495},{6,495}]','[{50020105,38}]'),(50020105,30,'[{2,17499},{1,875},{5,526},{6,526}]','[{50020105,40}]'),(50020105,31,'[{2,18579},{1,929},{5,558},{6,558}]','[{50020105,42}]'),(50020105,32,'[{2,19695},{1,985},{5,591},{6,591}]','[{50020105,44}]'),(50020105,33,'[{2,20847},{1,1043},{5,626},{6,626}]','[{50020105,46}]'),(50020105,34,'[{2,22035},{1,1102},{5,662},{6,662}]','[{50020105,48}]'),(50020105,35,'[{2,23259},{1,1163},{5,699},{6,699}]','[{50020105,50}]'),(50020105,36,'[{2,24519},{1,1226},{5,737},{6,737}]','[{50020105,52}]'),(50020105,37,'[{2,25815},{1,1291},{5,776},{6,776}]','[{50020105,54}]'),(50020105,38,'[{2,27147},{1,1358},{5,816},{6,816}]','[{50020105,56}]'),(50020105,39,'[{2,28515},{1,1426},{5,857},{6,857}]','[{50020105,58}]'),(50020105,40,'[{2,29919},{1,1496},{5,899},{6,899}]','[{50020105,60}]'),(50020106,1,'[{2,600},{1,30},{5,14},{6,14}]','[{50020106,1}]'),(50020106,2,'[{2,1098},{1,55},{5,26},{6,26}]','[{50020106,2}]'),(50020106,3,'[{2,1666},{1,83},{5,39},{6,39}]','[{50020106,3}]'),(50020106,4,'[{2,2303},{1,115},{5,54},{6,54}]','[{50020106,4}]'),(50020106,5,'[{2,3009},{1,150},{5,70},{6,70}]','[{50020106,5}]'),(50020106,6,'[{2,3784},{1,189},{5,88},{6,88}]','[{50020106,6}]'),(50020106,7,'[{2,4629},{1,231},{5,108},{6,108}]','[{50020106,7}]'),(50020106,8,'[{2,5543},{1,277},{5,129},{6,129}]','[{50020106,8}]'),(50020106,9,'[{2,6526},{1,326},{5,152},{6,152}]','[{50020106,9}]'),(50020106,10,'[{2,7578},{1,379},{5,177},{6,177}]','[{50020106,10}]'),(50020106,11,'[{2,8700},{1,435},{5,203},{6,203}]','[{50020106,12}]'),(50020106,12,'[{2,9891},{1,495},{5,231},{6,231}]','[{50020106,14}]'),(50020106,13,'[{2,11151},{1,558},{5,260},{6,260}]','[{50020106,16}]'),(50020106,14,'[{2,12480},{1,624},{5,291},{6,291}]','[{50020106,18}]'),(50020106,15,'[{2,13878},{1,694},{5,324},{6,324}]','[{50020106,20}]'),(50020106,16,'[{2,15369},{1,769},{5,359},{6,359}]','[{50020106,22}]'),(50020106,17,'[{2,16952},{1,848},{5,396},{6,396}]','[{50020106,24}]'),(50020106,18,'[{2,18627},{1,932},{5,435},{6,435}]','[{50020106,26}]'),(50020106,19,'[{2,20395},{1,1020},{5,476},{6,476}]','[{50020106,28}]'),(50020106,20,'[{2,22255},{1,1113},{5,519},{6,519}]','[{50020106,30}]'),(50020106,21,'[{2,24207},{1,1211},{5,565},{6,565}]','[{50020106,33}]'),(50020106,22,'[{2,26252},{1,1313},{5,613},{6,613}]','[{50020106,36}]'),(50020106,23,'[{2,28389},{1,1420},{5,663},{6,663}]','[{50020106,39}]'),(50020106,24,'[{2,30618},{1,1531},{5,715},{6,715}]','[{50020106,42}]'),(50020106,25,'[{2,32940},{1,1647},{5,769},{6,769}]','[{50020106,45}]'),(50020106,26,'[{2,35354},{1,1768},{5,825},{6,825}]','[{50020106,48}]'),(50020106,27,'[{2,37883},{1,1894},{5,884},{6,884}]','[{50020106,51}]'),(50020106,28,'[{2,40528},{1,2026},{5,946},{6,946}]','[{50020106,54}]'),(50020106,29,'[{2,43288},{1,2164},{5,1010},{6,1010}]','[{50020106,57}]'),(50020106,30,'[{2,46163},{1,2308},{5,1077},{6,1077}]','[{50020106,60}]'),(50020107,1,'[{2,600},{1,30},{5,14},{6,14}]','[{50020107,1}]'),(50020107,2,'[{2,1098},{1,55},{5,26},{6,26}]','[{50020107,2}]'),(50020107,3,'[{2,1666},{1,83},{5,39},{6,39}]','[{50020107,3}]'),(50020107,4,'[{2,2303},{1,115},{5,54},{6,54}]','[{50020107,4}]'),(50020107,5,'[{2,3009},{1,150},{5,70},{6,70}]','[{50020107,5}]'),(50020107,6,'[{2,3784},{1,189},{5,88},{6,88}]','[{50020107,6}]'),(50020107,7,'[{2,4629},{1,231},{5,108},{6,108}]','[{50020107,7}]'),(50020107,8,'[{2,5543},{1,277},{5,129},{6,129}]','[{50020107,8}]'),(50020107,9,'[{2,6526},{1,326},{5,152},{6,152}]','[{50020107,9}]'),(50020107,10,'[{2,7578},{1,379},{5,177},{6,177}]','[{50020107,10}]'),(50020107,11,'[{2,8700},{1,435},{5,203},{6,203}]','[{50020107,12}]'),(50020107,12,'[{2,9891},{1,495},{5,231},{6,231}]','[{50020107,14}]'),(50020107,13,'[{2,11151},{1,558},{5,260},{6,260}]','[{50020107,16}]'),(50020107,14,'[{2,12480},{1,624},{5,291},{6,291}]','[{50020107,18}]'),(50020107,15,'[{2,13878},{1,694},{5,324},{6,324}]','[{50020107,20}]'),(50020107,16,'[{2,15369},{1,769},{5,359},{6,359}]','[{50020107,22}]'),(50020107,17,'[{2,16952},{1,848},{5,396},{6,396}]','[{50020107,24}]'),(50020107,18,'[{2,18627},{1,932},{5,435},{6,435}]','[{50020107,26}]'),(50020107,19,'[{2,20395},{1,1020},{5,476},{6,476}]','[{50020107,28}]'),(50020107,20,'[{2,22255},{1,1113},{5,519},{6,519}]','[{50020107,30}]'),(50020107,21,'[{2,24207},{1,1211},{5,565},{6,565}]','[{50020107,33}]'),(50020107,22,'[{2,26252},{1,1313},{5,613},{6,613}]','[{50020107,36}]'),(50020107,23,'[{2,28389},{1,1420},{5,663},{6,663}]','[{50020107,39}]'),(50020107,24,'[{2,30618},{1,1531},{5,715},{6,715}]','[{50020107,42}]'),(50020107,25,'[{2,32940},{1,1647},{5,769},{6,769}]','[{50020107,45}]'),(50020107,26,'[{2,35354},{1,1768},{5,825},{6,825}]','[{50020107,48}]'),(50020107,27,'[{2,37883},{1,1894},{5,884},{6,884}]','[{50020107,51}]'),(50020107,28,'[{2,40528},{1,2026},{5,946},{6,946}]','[{50020107,54}]'),(50020107,29,'[{2,43288},{1,2164},{5,1010},{6,1010}]','[{50020107,57}]'),(50020107,30,'[{2,46163},{1,2308},{5,1077},{6,1077}]','[{50020107,60}]'),(50020108,1,'[{2,1000},{1,50},{5,25},{6,25}]','[{50020108,1}]'),(50020108,2,'[{2,1778},{1,89},{5,44},{6,44}]','[{50020108,2}]'),(50020108,3,'[{2,2722},{1,136},{5,68},{6,68}]','[{50020108,3}]'),(50020108,4,'[{2,3833},{1,192},{5,96},{6,96}]','[{50020108,4}]'),(50020108,5,'[{2,5111},{1,256},{5,128},{6,128}]','[{50020108,5}]'),(50020108,6,'[{2,6611},{1,331},{5,166},{6,166}]','[{50020108,7}]'),(50020108,7,'[{2,8333},{1,417},{5,209},{6,209}]','[{50020108,9}]'),(50020108,8,'[{2,10277},{1,514},{5,258},{6,258}]','[{50020108,11}]'),(50020108,9,'[{2,12444},{1,622},{5,312},{6,312}]','[{50020108,13}]'),(50020108,10,'[{2,14888},{1,744},{5,373},{6,373}]','[{50020108,15}]'),(50020108,11,'[{2,17610},{1,880},{5,441},{6,441}]','[{50020108,18}]'),(50020108,12,'[{2,20610},{1,1030},{5,516},{6,516}]','[{50020108,21}]'),(50020108,13,'[{2,23888},{1,1194},{5,598},{6,598}]','[{50020108,24}]'),(50020108,14,'[{2,27444},{1,1372},{5,687},{6,687}]','[{50020108,27}]'),(50020108,15,'[{2,31277},{1,1564},{5,783},{6,783}]','[{50020108,30}]'),(50020108,16,'[{2,35444},{1,1772},{5,887},{6,887}]','[{50020108,34}]'),(50020108,17,'[{2,39944},{1,1997},{5,1000},{6,1000}]','[{50020108,38}]'),(50020108,18,'[{2,44777},{1,2239},{5,1121},{6,1121}]','[{50020108,42}]'),(50020108,19,'[{2,49944},{1,2497},{5,1250},{6,1250}]','[{50020108,46}]'),(50020108,20,'[{2,55444},{1,2772},{5,1388},{6,1388}]','[{50020108,50}]'),(50020109,1,'[{2,1000},{1,50},{5,25},{6,25}]','[{50020109,1}]'),(50020109,2,'[{2,1778},{1,89},{5,44},{6,44}]','[{50020109,2}]'),(50020109,3,'[{2,2722},{1,136},{5,68},{6,68}]','[{50020109,3}]'),(50020109,4,'[{2,3833},{1,192},{5,96},{6,96}]','[{50020109,4}]'),(50020109,5,'[{2,5111},{1,256},{5,128},{6,128}]','[{50020109,5}]'),(50020109,6,'[{2,6611},{1,331},{5,166},{6,166}]','[{50020109,7}]'),(50020109,7,'[{2,8333},{1,417},{5,209},{6,209}]','[{50020109,9}]'),(50020109,8,'[{2,10277},{1,514},{5,258},{6,258}]','[{50020109,11}]'),(50020109,9,'[{2,12444},{1,622},{5,312},{6,312}]','[{50020109,13}]'),(50020109,10,'[{2,14888},{1,744},{5,373},{6,373}]','[{50020109,15}]'),(50020109,11,'[{2,17610},{1,880},{5,441},{6,441}]','[{50020109,18}]'),(50020109,12,'[{2,20610},{1,1030},{5,516},{6,516}]','[{50020109,21}]'),(50020109,13,'[{2,23888},{1,1194},{5,598},{6,598}]','[{50020109,24}]'),(50020109,14,'[{2,27444},{1,1372},{5,687},{6,687}]','[{50020109,27}]'),(50020109,15,'[{2,31277},{1,1564},{5,783},{6,783}]','[{50020109,30}]'),(50020109,16,'[{2,35444},{1,1772},{5,887},{6,887}]','[{50020109,34}]'),(50020109,17,'[{2,39944},{1,1997},{5,1000},{6,1000}]','[{50020109,38}]'),(50020109,18,'[{2,44777},{1,2239},{5,1121},{6,1121}]','[{50020109,42}]'),(50020109,19,'[{2,49944},{1,2497},{5,1250},{6,1250}]','[{50020109,46}]'),(50020109,20,'[{2,55444},{1,2772},{5,1388},{6,1388}]','[{50020109,50}]'),(50020110,1,'[{2,2400},{1,120},{5,42},{6,42}]','[{50020110,1}]'),(50020110,2,'[{2,4160},{1,208},{5,73},{6,73}]','[{50020110,2}]'),(50020110,3,'[{2,6320},{1,316},{5,111},{6,111}]','[{50020110,3}]'),(50020110,4,'[{2,8880},{1,444},{5,156},{6,156}]','[{50020110,4}]'),(50020110,5,'[{2,11840},{1,592},{5,208},{6,208}]','[{50020110,5}]'),(50020110,6,'[{2,15400},{1,770},{5,270},{6,270}]','[{50020110,7}]'),(50020110,7,'[{2,19560},{1,978},{5,343},{6,343}]','[{50020110,9}]'),(50020110,8,'[{2,24320},{1,1216},{5,426},{6,426}]','[{50020110,11}]'),(50020110,9,'[{2,29680},{1,1484},{5,520},{6,520}]','[{50020110,13}]'),(50020110,10,'[{2,35840},{1,1792},{5,628},{6,628}]','[{50020110,15}]'),(50020110,11,'[{2,42800},{1,2140},{5,750},{6,750}]','[{50020110,18}]'),(50020110,12,'[{2,50560},{1,2528},{5,886},{6,886}]','[{50020110,21}]'),(50020110,13,'[{2,59120},{1,2956},{5,1036},{6,1036}]','[{50020110,24}]'),(50020110,14,'[{2,68680},{1,3434},{5,1203},{6,1203}]','[{50020110,27}]'),(50020110,15,'[{2,79240},{1,3962},{5,1388},{6,1388}]','[{50020110,30}]'),(50020111,1,'[{2,2400},{1,120},{5,42},{6,42}]','[{50020111,1}]'),(50020111,2,'[{2,4160},{1,208},{5,73},{6,73}]','[{50020111,2}]'),(50020111,3,'[{2,6320},{1,316},{5,111},{6,111}]','[{50020111,3}]'),(50020111,4,'[{2,8880},{1,444},{5,156},{6,156}]','[{50020111,4}]'),(50020111,5,'[{2,11840},{1,592},{5,208},{6,208}]','[{50020111,5}]'),(50020111,6,'[{2,15400},{1,770},{5,270},{6,270}]','[{50020111,7}]'),(50020111,7,'[{2,19560},{1,978},{5,343},{6,343}]','[{50020111,9}]'),(50020111,8,'[{2,24320},{1,1216},{5,426},{6,426}]','[{50020111,11}]'),(50020111,9,'[{2,29680},{1,1484},{5,520},{6,520}]','[{50020111,13}]'),(50020111,10,'[{2,35840},{1,1792},{5,628},{6,628}]','[{50020111,15}]'),(50020111,11,'[{2,42800},{1,2140},{5,750},{6,750}]','[{50020111,18}]'),(50020111,12,'[{2,50560},{1,2528},{5,886},{6,886}]','[{50020111,21}]'),(50020111,13,'[{2,59120},{1,2956},{5,1036},{6,1036}]','[{50020111,24}]'),(50020111,14,'[{2,68680},{1,3434},{5,1203},{6,1203}]','[{50020111,27}]'),(50020111,15,'[{2,79240},{1,3962},{5,1388},{6,1388}]','[{50020111,30}]'),(50030101,1,'[{2,160},{1,8},{5,5},{6,5}]','[{50030101,1}]'),(50030101,2,'[{2,294},{1,15},{5,9},{6,9}]','[{50030101,2}]'),(50030101,3,'[{2,446},{1,23},{5,14},{6,14}]','[{50030101,3}]'),(50030101,4,'[{2,616},{1,32},{5,19},{6,19}]','[{50030101,4}]'),(50030101,5,'[{2,804},{1,41},{5,25},{6,25}]','[{50030101,5}]'),(50030101,6,'[{2,1010},{1,51},{5,31},{6,31}]','[{50030101,6}]'),(50030101,7,'[{2,1234},{1,62},{5,38},{6,38}]','[{50030101,7}]'),(50030101,8,'[{2,1476},{1,74},{5,46},{6,46}]','[{50030101,8}]'),(50030101,9,'[{2,1736},{1,87},{5,54},{6,54}]','[{50030101,9}]'),(50030101,10,'[{2,2014},{1,101},{5,63},{6,63}]','[{50030101,10}]'),(50030101,11,'[{2,2310},{1,116},{5,72},{6,72}]','[{50030101,11}]'),(50030101,12,'[{2,2624},{1,132},{5,82},{6,82}]','[{50030101,12}]'),(50030101,13,'[{2,2956},{1,149},{5,92},{6,92}]','[{50030101,13}]'),(50030101,14,'[{2,3306},{1,167},{5,103},{6,103}]','[{50030101,14}]'),(50030101,15,'[{2,3674},{1,185},{5,115},{6,115}]','[{50030101,15}]'),(50030101,16,'[{2,4060},{1,204},{5,127},{6,127}]','[{50030101,16}]'),(50030101,17,'[{2,4464},{1,224},{5,140},{6,140}]','[{50030101,17}]'),(50030101,18,'[{2,4886},{1,245},{5,153},{6,153}]','[{50030101,18}]'),(50030101,19,'[{2,5326},{1,267},{5,167},{6,167}]','[{50030101,19}]'),(50030101,20,'[{2,5784},{1,290},{5,181},{6,181}]','[{50030101,20}]'),(50030101,21,'[{2,6266},{1,314},{5,196},{6,196}]','[{50030101,22}]'),(50030101,22,'[{2,6772},{1,339},{5,212},{6,212}]','[{50030101,24}]'),(50030101,23,'[{2,7302},{1,366},{5,229},{6,229}]','[{50030101,26}]'),(50030101,24,'[{2,7856},{1,394},{5,246},{6,246}]','[{50030101,28}]'),(50030101,25,'[{2,8434},{1,423},{5,264},{6,264}]','[{50030101,30}]'),(50030101,26,'[{2,9036},{1,453},{5,283},{6,283}]','[{50030101,32}]'),(50030101,27,'[{2,9662},{1,484},{5,303},{6,303}]','[{50030101,34}]'),(50030101,28,'[{2,10312},{1,517},{5,323},{6,323}]','[{50030101,36}]'),(50030101,29,'[{2,10986},{1,551},{5,344},{6,344}]','[{50030101,38}]'),(50030101,30,'[{2,11684},{1,586},{5,366},{6,366}]','[{50030101,40}]'),(50030101,31,'[{2,12406},{1,622},{5,389},{6,389}]','[{50030101,42}]'),(50030101,32,'[{2,13152},{1,659},{5,412},{6,412}]','[{50030101,44}]'),(50030101,33,'[{2,13922},{1,698},{5,436},{6,436}]','[{50030101,46}]'),(50030101,34,'[{2,14716},{1,738},{5,461},{6,461}]','[{50030101,48}]'),(50030101,35,'[{2,15534},{1,779},{5,487},{6,487}]','[{50030101,50}]'),(50030101,36,'[{2,16376},{1,821},{5,513},{6,513}]','[{50030101,52}]'),(50030101,37,'[{2,17242},{1,864},{5,540},{6,540}]','[{50030101,54}]'),(50030101,38,'[{2,18132},{1,909},{5,568},{6,568}]','[{50030101,56}]'),(50030101,39,'[{2,19046},{1,955},{5,597},{6,597}]','[{50030101,58}]'),(50030101,40,'[{2,19984},{1,1002},{5,626},{6,626}]','[{50030101,60}]'),(50030102,1,'[{2,160},{1,8},{5,5},{6,5}]','[{50030102,1}]'),(50030102,2,'[{2,294},{1,15},{5,9},{6,9}]','[{50030102,2}]'),(50030102,3,'[{2,446},{1,23},{5,14},{6,14}]','[{50030102,3}]'),(50030102,4,'[{2,616},{1,32},{5,19},{6,19}]','[{50030102,4}]'),(50030102,5,'[{2,804},{1,41},{5,25},{6,25}]','[{50030102,5}]'),(50030102,6,'[{2,1010},{1,51},{5,31},{6,31}]','[{50030102,6}]'),(50030102,7,'[{2,1234},{1,62},{5,38},{6,38}]','[{50030102,7}]'),(50030102,8,'[{2,1476},{1,74},{5,46},{6,46}]','[{50030102,8}]'),(50030102,9,'[{2,1736},{1,87},{5,54},{6,54}]','[{50030102,9}]'),(50030102,10,'[{2,2014},{1,101},{5,63},{6,63}]','[{50030102,10}]'),(50030102,11,'[{2,2310},{1,116},{5,72},{6,72}]','[{50030102,11}]'),(50030102,12,'[{2,2624},{1,132},{5,82},{6,82}]','[{50030102,12}]'),(50030102,13,'[{2,2956},{1,149},{5,92},{6,92}]','[{50030102,13}]'),(50030102,14,'[{2,3306},{1,167},{5,103},{6,103}]','[{50030102,14}]'),(50030102,15,'[{2,3674},{1,185},{5,115},{6,115}]','[{50030102,15}]'),(50030102,16,'[{2,4060},{1,204},{5,127},{6,127}]','[{50030102,16}]'),(50030102,17,'[{2,4464},{1,224},{5,140},{6,140}]','[{50030102,17}]'),(50030102,18,'[{2,4886},{1,245},{5,153},{6,153}]','[{50030102,18}]'),(50030102,19,'[{2,5326},{1,267},{5,167},{6,167}]','[{50030102,19}]'),(50030102,20,'[{2,5784},{1,290},{5,181},{6,181}]','[{50030102,20}]'),(50030102,21,'[{2,6266},{1,314},{5,196},{6,196}]','[{50030102,22}]'),(50030102,22,'[{2,6772},{1,339},{5,212},{6,212}]','[{50030102,24}]'),(50030102,23,'[{2,7302},{1,366},{5,229},{6,229}]','[{50030102,26}]'),(50030102,24,'[{2,7856},{1,394},{5,246},{6,246}]','[{50030102,28}]'),(50030102,25,'[{2,8434},{1,423},{5,264},{6,264}]','[{50030102,30}]'),(50030102,26,'[{2,9036},{1,453},{5,283},{6,283}]','[{50030102,32}]'),(50030102,27,'[{2,9662},{1,484},{5,303},{6,303}]','[{50030102,34}]'),(50030102,28,'[{2,10312},{1,517},{5,323},{6,323}]','[{50030102,36}]'),(50030102,29,'[{2,10986},{1,551},{5,344},{6,344}]','[{50030102,38}]'),(50030102,30,'[{2,11684},{1,586},{5,366},{6,366}]','[{50030102,40}]'),(50030102,31,'[{2,12406},{1,622},{5,389},{6,389}]','[{50030102,42}]'),(50030102,32,'[{2,13152},{1,659},{5,412},{6,412}]','[{50030102,44}]'),(50030102,33,'[{2,13922},{1,698},{5,436},{6,436}]','[{50030102,46}]'),(50030102,34,'[{2,14716},{1,738},{5,461},{6,461}]','[{50030102,48}]'),(50030102,35,'[{2,15534},{1,779},{5,487},{6,487}]','[{50030102,50}]'),(50030102,36,'[{2,16376},{1,821},{5,513},{6,513}]','[{50030102,52}]'),(50030102,37,'[{2,17242},{1,864},{5,540},{6,540}]','[{50030102,54}]'),(50030102,38,'[{2,18132},{1,909},{5,568},{6,568}]','[{50030102,56}]'),(50030102,39,'[{2,19046},{1,955},{5,597},{6,597}]','[{50030102,58}]'),(50030102,40,'[{2,19984},{1,1002},{5,626},{6,626}]','[{50030102,60}]'),(50030103,1,'[{2,300},{1,15},{5,9},{6,9}]','[{50030103,1}]'),(50030103,2,'[{2,498},{1,25},{5,15},{6,15}]','[{50030103,2}]'),(50030103,3,'[{2,723},{1,36},{5,22},{6,22}]','[{50030103,3}]'),(50030103,4,'[{2,975},{1,49},{5,30},{6,30}]','[{50030103,4}]'),(50030103,5,'[{2,1254},{1,63},{5,38},{6,38}]','[{50030103,5}]'),(50030103,6,'[{2,1560},{1,78},{5,47},{6,47}]','[{50030103,6}]'),(50030103,7,'[{2,1893},{1,95},{5,57},{6,57}]','[{50030103,7}]'),(50030103,8,'[{2,2253},{1,113},{5,68},{6,68}]','[{50030103,8}]'),(50030103,9,'[{2,2640},{1,132},{5,80},{6,80}]','[{50030103,9}]'),(50030103,10,'[{2,3054},{1,153},{5,92},{6,92}]','[{50030103,10}]'),(50030103,11,'[{2,3495},{1,175},{5,105},{6,105}]','[{50030103,11}]'),(50030103,12,'[{2,3963},{1,198},{5,119},{6,119}]','[{50030103,12}]'),(50030103,13,'[{2,4458},{1,223},{5,134},{6,134}]','[{50030103,13}]'),(50030103,14,'[{2,4980},{1,249},{5,150},{6,150}]','[{50030103,14}]'),(50030103,15,'[{2,5529},{1,276},{5,166},{6,166}]','[{50030103,15}]'),(50030103,16,'[{2,6105},{1,305},{5,183},{6,183}]','[{50030103,16}]'),(50030103,17,'[{2,6708},{1,335},{5,201},{6,201}]','[{50030103,17}]'),(50030103,18,'[{2,7338},{1,367},{5,220},{6,220}]','[{50030103,18}]'),(50030103,19,'[{2,7995},{1,400},{5,240},{6,240}]','[{50030103,19}]'),(50030103,20,'[{2,8679},{1,434},{5,261},{6,261}]','[{50030103,20}]'),(50030103,21,'[{2,9399},{1,470},{5,283},{6,283}]','[{50030103,22}]'),(50030103,22,'[{2,10155},{1,508},{5,306},{6,306}]','[{50030103,24}]'),(50030103,23,'[{2,10947},{1,548},{5,330},{6,330}]','[{50030103,26}]'),(50030103,24,'[{2,11775},{1,589},{5,355},{6,355}]','[{50030103,28}]'),(50030103,25,'[{2,12639},{1,632},{5,381},{6,381}]','[{50030103,30}]'),(50030103,26,'[{2,13539},{1,677},{5,408},{6,408}]','[{50030103,32}]'),(50030103,27,'[{2,14475},{1,724},{5,436},{6,436}]','[{50030103,34}]'),(50030103,28,'[{2,15447},{1,773},{5,465},{6,465}]','[{50030103,36}]'),(50030103,29,'[{2,16455},{1,823},{5,495},{6,495}]','[{50030103,38}]'),(50030103,30,'[{2,17499},{1,875},{5,526},{6,526}]','[{50030103,40}]'),(50030103,31,'[{2,18579},{1,929},{5,558},{6,558}]','[{50030103,42}]'),(50030103,32,'[{2,19695},{1,985},{5,591},{6,591}]','[{50030103,44}]'),(50030103,33,'[{2,20847},{1,1043},{5,626},{6,626}]','[{50030103,46}]'),(50030103,34,'[{2,22035},{1,1102},{5,662},{6,662}]','[{50030103,48}]'),(50030103,35,'[{2,23259},{1,1163},{5,699},{6,699}]','[{50030103,50}]'),(50030103,36,'[{2,24519},{1,1226},{5,737},{6,737}]','[{50030103,52}]'),(50030103,37,'[{2,25815},{1,1291},{5,776},{6,776}]','[{50030103,54}]'),(50030103,38,'[{2,27147},{1,1358},{5,816},{6,816}]','[{50030103,56}]'),(50030103,39,'[{2,28515},{1,1426},{5,857},{6,857}]','[{50030103,58}]'),(50030103,40,'[{2,29919},{1,1496},{5,899},{6,899}]','[{50030103,60}]'),(50030104,1,'[{2,300},{1,15},{5,9},{6,9}]','[{50030104,1}]'),(50030104,2,'[{2,498},{1,25},{5,15},{6,15}]','[{50030104,2}]'),(50030104,3,'[{2,723},{1,36},{5,22},{6,22}]','[{50030104,3}]'),(50030104,4,'[{2,975},{1,49},{5,30},{6,30}]','[{50030104,4}]'),(50030104,5,'[{2,1254},{1,63},{5,38},{6,38}]','[{50030104,5}]'),(50030104,6,'[{2,1560},{1,78},{5,47},{6,47}]','[{50030104,6}]'),(50030104,7,'[{2,1893},{1,95},{5,57},{6,57}]','[{50030104,7}]'),(50030104,8,'[{2,2253},{1,113},{5,68},{6,68}]','[{50030104,8}]'),(50030104,9,'[{2,2640},{1,132},{5,80},{6,80}]','[{50030104,9}]'),(50030104,10,'[{2,3054},{1,153},{5,92},{6,92}]','[{50030104,10}]'),(50030104,11,'[{2,3495},{1,175},{5,105},{6,105}]','[{50030104,11}]'),(50030104,12,'[{2,3963},{1,198},{5,119},{6,119}]','[{50030104,12}]'),(50030104,13,'[{2,4458},{1,223},{5,134},{6,134}]','[{50030104,13}]'),(50030104,14,'[{2,4980},{1,249},{5,150},{6,150}]','[{50030104,14}]'),(50030104,15,'[{2,5529},{1,276},{5,166},{6,166}]','[{50030104,15}]'),(50030104,16,'[{2,6105},{1,305},{5,183},{6,183}]','[{50030104,16}]'),(50030104,17,'[{2,6708},{1,335},{5,201},{6,201}]','[{50030104,17}]'),(50030104,18,'[{2,7338},{1,367},{5,220},{6,220}]','[{50030104,18}]'),(50030104,19,'[{2,7995},{1,400},{5,240},{6,240}]','[{50030104,19}]'),(50030104,20,'[{2,8679},{1,434},{5,261},{6,261}]','[{50030104,20}]'),(50030104,21,'[{2,9399},{1,470},{5,283},{6,283}]','[{50030104,22}]'),(50030104,22,'[{2,10155},{1,508},{5,306},{6,306}]','[{50030104,24}]'),(50030104,23,'[{2,10947},{1,548},{5,330},{6,330}]','[{50030104,26}]'),(50030104,24,'[{2,11775},{1,589},{5,355},{6,355}]','[{50030104,28}]'),(50030104,25,'[{2,12639},{1,632},{5,381},{6,381}]','[{50030104,30}]'),(50030104,26,'[{2,13539},{1,677},{5,408},{6,408}]','[{50030104,32}]'),(50030104,27,'[{2,14475},{1,724},{5,436},{6,436}]','[{50030104,34}]'),(50030104,28,'[{2,15447},{1,773},{5,465},{6,465}]','[{50030104,36}]'),(50030104,29,'[{2,16455},{1,823},{5,495},{6,495}]','[{50030104,38}]'),(50030104,30,'[{2,17499},{1,875},{5,526},{6,526}]','[{50030104,40}]'),(50030104,31,'[{2,18579},{1,929},{5,558},{6,558}]','[{50030104,42}]'),(50030104,32,'[{2,19695},{1,985},{5,591},{6,591}]','[{50030104,44}]'),(50030104,33,'[{2,20847},{1,1043},{5,626},{6,626}]','[{50030104,46}]'),(50030104,34,'[{2,22035},{1,1102},{5,662},{6,662}]','[{50030104,48}]'),(50030104,35,'[{2,23259},{1,1163},{5,699},{6,699}]','[{50030104,50}]'),(50030104,36,'[{2,24519},{1,1226},{5,737},{6,737}]','[{50030104,52}]'),(50030104,37,'[{2,25815},{1,1291},{5,776},{6,776}]','[{50030104,54}]'),(50030104,38,'[{2,27147},{1,1358},{5,816},{6,816}]','[{50030104,56}]'),(50030104,39,'[{2,28515},{1,1426},{5,857},{6,857}]','[{50030104,58}]'),(50030104,40,'[{2,29919},{1,1496},{5,899},{6,899}]','[{50030104,60}]'),(50030105,1,'[{2,600},{1,30},{5,14},{6,14}]','[{50030105,1}]'),(50030105,2,'[{2,1098},{1,55},{5,26},{6,26}]','[{50030105,2}]'),(50030105,3,'[{2,1666},{1,83},{5,39},{6,39}]','[{50030105,3}]'),(50030105,4,'[{2,2303},{1,115},{5,54},{6,54}]','[{50030105,4}]'),(50030105,5,'[{2,3009},{1,150},{5,70},{6,70}]','[{50030105,5}]'),(50030105,6,'[{2,3784},{1,189},{5,88},{6,88}]','[{50030105,6}]'),(50030105,7,'[{2,4629},{1,231},{5,108},{6,108}]','[{50030105,7}]'),(50030105,8,'[{2,5543},{1,277},{5,129},{6,129}]','[{50030105,8}]'),(50030105,9,'[{2,6526},{1,326},{5,152},{6,152}]','[{50030105,9}]'),(50030105,10,'[{2,7578},{1,379},{5,177},{6,177}]','[{50030105,10}]'),(50030105,11,'[{2,8700},{1,435},{5,203},{6,203}]','[{50030105,12}]'),(50030105,12,'[{2,9891},{1,495},{5,231},{6,231}]','[{50030105,14}]'),(50030105,13,'[{2,11151},{1,558},{5,260},{6,260}]','[{50030105,16}]'),(50030105,14,'[{2,12480},{1,624},{5,291},{6,291}]','[{50030105,18}]'),(50030105,15,'[{2,13878},{1,694},{5,324},{6,324}]','[{50030105,20}]'),(50030105,16,'[{2,15369},{1,769},{5,359},{6,359}]','[{50030105,22}]'),(50030105,17,'[{2,16952},{1,848},{5,396},{6,396}]','[{50030105,24}]'),(50030105,18,'[{2,18627},{1,932},{5,435},{6,435}]','[{50030105,26}]'),(50030105,19,'[{2,20395},{1,1020},{5,476},{6,476}]','[{50030105,28}]'),(50030105,20,'[{2,22255},{1,1113},{5,519},{6,519}]','[{50030105,30}]'),(50030105,21,'[{2,24207},{1,1211},{5,565},{6,565}]','[{50030105,33}]'),(50030105,22,'[{2,26252},{1,1313},{5,613},{6,613}]','[{50030105,36}]'),(50030105,23,'[{2,28389},{1,1420},{5,663},{6,663}]','[{50030105,39}]'),(50030105,24,'[{2,30618},{1,1531},{5,715},{6,715}]','[{50030105,42}]'),(50030105,25,'[{2,32940},{1,1647},{5,769},{6,769}]','[{50030105,45}]'),(50030105,26,'[{2,35354},{1,1768},{5,825},{6,825}]','[{50030105,48}]'),(50030105,27,'[{2,37883},{1,1894},{5,884},{6,884}]','[{50030105,51}]'),(50030105,28,'[{2,40528},{1,2026},{5,946},{6,946}]','[{50030105,54}]'),(50030105,29,'[{2,43288},{1,2164},{5,1010},{6,1010}]','[{50030105,57}]'),(50030105,30,'[{2,46163},{1,2308},{5,1077},{6,1077}]','[{50030105,60}]'),(50030106,1,'[{2,600},{1,30},{5,14},{6,14}]','[{50030106,1}]'),(50030106,2,'[{2,1098},{1,55},{5,26},{6,26}]','[{50030106,2}]'),(50030106,3,'[{2,1666},{1,83},{5,39},{6,39}]','[{50030106,3}]'),(50030106,4,'[{2,2303},{1,115},{5,54},{6,54}]','[{50030106,4}]'),(50030106,5,'[{2,3009},{1,150},{5,70},{6,70}]','[{50030106,5}]'),(50030106,6,'[{2,3784},{1,189},{5,88},{6,88}]','[{50030106,6}]'),(50030106,7,'[{2,4629},{1,231},{5,108},{6,108}]','[{50030106,7}]'),(50030106,8,'[{2,5543},{1,277},{5,129},{6,129}]','[{50030106,8}]'),(50030106,9,'[{2,6526},{1,326},{5,152},{6,152}]','[{50030106,9}]'),(50030106,10,'[{2,7578},{1,379},{5,177},{6,177}]','[{50030106,10}]'),(50030106,11,'[{2,8700},{1,435},{5,203},{6,203}]','[{50030106,12}]'),(50030106,12,'[{2,9891},{1,495},{5,231},{6,231}]','[{50030106,14}]'),(50030106,13,'[{2,11151},{1,558},{5,260},{6,260}]','[{50030106,16}]'),(50030106,14,'[{2,12480},{1,624},{5,291},{6,291}]','[{50030106,18}]'),(50030106,15,'[{2,13878},{1,694},{5,324},{6,324}]','[{50030106,20}]'),(50030106,16,'[{2,15369},{1,769},{5,359},{6,359}]','[{50030106,22}]'),(50030106,17,'[{2,16952},{1,848},{5,396},{6,396}]','[{50030106,24}]'),(50030106,18,'[{2,18627},{1,932},{5,435},{6,435}]','[{50030106,26}]'),(50030106,19,'[{2,20395},{1,1020},{5,476},{6,476}]','[{50030106,28}]'),(50030106,20,'[{2,22255},{1,1113},{5,519},{6,519}]','[{50030106,30}]'),(50030106,21,'[{2,24207},{1,1211},{5,565},{6,565}]','[{50030106,33}]'),(50030106,22,'[{2,26252},{1,1313},{5,613},{6,613}]','[{50030106,36}]'),(50030106,23,'[{2,28389},{1,1420},{5,663},{6,663}]','[{50030106,39}]'),(50030106,24,'[{2,30618},{1,1531},{5,715},{6,715}]','[{50030106,42}]'),(50030106,25,'[{2,32940},{1,1647},{5,769},{6,769}]','[{50030106,45}]'),(50030106,26,'[{2,35354},{1,1768},{5,825},{6,825}]','[{50030106,48}]'),(50030106,27,'[{2,37883},{1,1894},{5,884},{6,884}]','[{50030106,51}]'),(50030106,28,'[{2,40528},{1,2026},{5,946},{6,946}]','[{50030106,54}]'),(50030106,29,'[{2,43288},{1,2164},{5,1010},{6,1010}]','[{50030106,57}]'),(50030106,30,'[{2,46163},{1,2308},{5,1077},{6,1077}]','[{50030106,60}]'),(50030107,1,'[{2,1000},{1,50},{5,25},{6,25}]','[{50030107,1}]'),(50030107,2,'[{2,1778},{1,89},{5,44},{6,44}]','[{50030107,2}]'),(50030107,3,'[{2,2722},{1,136},{5,68},{6,68}]','[{50030107,3}]'),(50030107,4,'[{2,3833},{1,192},{5,96},{6,96}]','[{50030107,4}]'),(50030107,5,'[{2,5111},{1,256},{5,128},{6,128}]','[{50030107,5}]'),(50030107,6,'[{2,6611},{1,331},{5,166},{6,166}]','[{50030107,7}]'),(50030107,7,'[{2,8333},{1,417},{5,209},{6,209}]','[{50030107,9}]'),(50030107,8,'[{2,10277},{1,514},{5,258},{6,258}]','[{50030107,11}]'),(50030107,9,'[{2,12444},{1,622},{5,312},{6,312}]','[{50030107,13}]'),(50030107,10,'[{2,14888},{1,744},{5,373},{6,373}]','[{50030107,15}]'),(50030107,11,'[{2,17610},{1,880},{5,441},{6,441}]','[{50030107,18}]'),(50030107,12,'[{2,20610},{1,1030},{5,516},{6,516}]','[{50030107,21}]'),(50030107,13,'[{2,23888},{1,1194},{5,598},{6,598}]','[{50030107,24}]'),(50030107,14,'[{2,27444},{1,1372},{5,687},{6,687}]','[{50030107,27}]'),(50030107,15,'[{2,31277},{1,1564},{5,783},{6,783}]','[{50030107,30}]'),(50030107,16,'[{2,35444},{1,1772},{5,887},{6,887}]','[{50030107,34}]'),(50030107,17,'[{2,39944},{1,1997},{5,1000},{6,1000}]','[{50030107,38}]'),(50030107,18,'[{2,44777},{1,2239},{5,1121},{6,1121}]','[{50030107,42}]'),(50030107,19,'[{2,49944},{1,2497},{5,1250},{6,1250}]','[{50030107,46}]'),(50030107,20,'[{2,55444},{1,2772},{5,1388},{6,1388}]','[{50030107,50}]'),(50030108,1,'[{2,2400},{1,120},{5,42},{6,42}]','[{50030108,1}]'),(50030108,2,'[{2,4160},{1,208},{5,73},{6,73}]','[{50030108,2}]'),(50030108,3,'[{2,6320},{1,316},{5,111},{6,111}]','[{50030108,3}]'),(50030108,4,'[{2,8880},{1,444},{5,156},{6,156}]','[{50030108,4}]'),(50030108,5,'[{2,11840},{1,592},{5,208},{6,208}]','[{50030108,5}]'),(50030108,6,'[{2,15400},{1,770},{5,270},{6,270}]','[{50030108,7}]'),(50030108,7,'[{2,19560},{1,978},{5,343},{6,343}]','[{50030108,9}]'),(50030108,8,'[{2,24320},{1,1216},{5,426},{6,426}]','[{50030108,11}]'),(50030108,9,'[{2,29680},{1,1484},{5,520},{6,520}]','[{50030108,13}]'),(50030108,10,'[{2,35840},{1,1792},{5,628},{6,628}]','[{50030108,15}]'),(50030108,11,'[{2,42800},{1,2140},{5,750},{6,750}]','[{50030108,18}]'),(50030108,12,'[{2,50560},{1,2528},{5,886},{6,886}]','[{50030108,21}]'),(50030108,13,'[{2,59120},{1,2956},{5,1036},{6,1036}]','[{50030108,24}]'),(50030108,14,'[{2,68680},{1,3434},{5,1203},{6,1203}]','[{50030108,27}]'),(50030108,15,'[{2,79240},{1,3962},{5,1388},{6,1388}]','[{50030108,30}]'),(50040101,1,'[{2,160},{1,8},{5,5},{6,5}]','[{50040101,1}]'),(50040101,2,'[{2,294},{1,15},{5,9},{6,9}]','[{50040101,2}]'),(50040101,3,'[{2,446},{1,23},{5,14},{6,14}]','[{50040101,3}]'),(50040101,4,'[{2,616},{1,32},{5,19},{6,19}]','[{50040101,4}]'),(50040101,5,'[{2,804},{1,41},{5,25},{6,25}]','[{50040101,5}]'),(50040101,6,'[{2,1010},{1,51},{5,31},{6,31}]','[{50040101,6}]'),(50040101,7,'[{2,1234},{1,62},{5,38},{6,38}]','[{50040101,7}]'),(50040101,8,'[{2,1476},{1,74},{5,46},{6,46}]','[{50040101,8}]'),(50040101,9,'[{2,1736},{1,87},{5,54},{6,54}]','[{50040101,9}]'),(50040101,10,'[{2,2014},{1,101},{5,63},{6,63}]','[{50040101,10}]'),(50040101,11,'[{2,2310},{1,116},{5,72},{6,72}]','[{50040101,11}]'),(50040101,12,'[{2,2624},{1,132},{5,82},{6,82}]','[{50040101,12}]'),(50040101,13,'[{2,2956},{1,149},{5,92},{6,92}]','[{50040101,13}]'),(50040101,14,'[{2,3306},{1,167},{5,103},{6,103}]','[{50040101,14}]'),(50040101,15,'[{2,3674},{1,185},{5,115},{6,115}]','[{50040101,15}]'),(50040101,16,'[{2,4060},{1,204},{5,127},{6,127}]','[{50040101,16}]'),(50040101,17,'[{2,4464},{1,224},{5,140},{6,140}]','[{50040101,17}]'),(50040101,18,'[{2,4886},{1,245},{5,153},{6,153}]','[{50040101,18}]'),(50040101,19,'[{2,5326},{1,267},{5,167},{6,167}]','[{50040101,19}]'),(50040101,20,'[{2,5784},{1,290},{5,181},{6,181}]','[{50040101,20}]'),(50040101,21,'[{2,6266},{1,314},{5,196},{6,196}]','[{50040101,22}]'),(50040101,22,'[{2,6772},{1,339},{5,212},{6,212}]','[{50040101,24}]'),(50040101,23,'[{2,7302},{1,366},{5,229},{6,229}]','[{50040101,26}]'),(50040101,24,'[{2,7856},{1,394},{5,246},{6,246}]','[{50040101,28}]'),(50040101,25,'[{2,8434},{1,423},{5,264},{6,264}]','[{50040101,30}]'),(50040101,26,'[{2,9036},{1,453},{5,283},{6,283}]','[{50040101,32}]'),(50040101,27,'[{2,9662},{1,484},{5,303},{6,303}]','[{50040101,34}]'),(50040101,28,'[{2,10312},{1,517},{5,323},{6,323}]','[{50040101,36}]'),(50040101,29,'[{2,10986},{1,551},{5,344},{6,344}]','[{50040101,38}]'),(50040101,30,'[{2,11684},{1,586},{5,366},{6,366}]','[{50040101,40}]'),(50040101,31,'[{2,12406},{1,622},{5,389},{6,389}]','[{50040101,42}]'),(50040101,32,'[{2,13152},{1,659},{5,412},{6,412}]','[{50040101,44}]'),(50040101,33,'[{2,13922},{1,698},{5,436},{6,436}]','[{50040101,46}]'),(50040101,34,'[{2,14716},{1,738},{5,461},{6,461}]','[{50040101,48}]'),(50040101,35,'[{2,15534},{1,779},{5,487},{6,487}]','[{50040101,50}]'),(50040101,36,'[{2,16376},{1,821},{5,513},{6,513}]','[{50040101,52}]'),(50040101,37,'[{2,17242},{1,864},{5,540},{6,540}]','[{50040101,54}]'),(50040101,38,'[{2,18132},{1,909},{5,568},{6,568}]','[{50040101,56}]'),(50040101,39,'[{2,19046},{1,955},{5,597},{6,597}]','[{50040101,58}]'),(50040101,40,'[{2,19984},{1,1002},{5,626},{6,626}]','[{50040101,60}]'),(50040102,1,'[{2,300},{1,15},{5,9},{6,9}]','[{50040102,1}]'),(50040102,2,'[{2,498},{1,25},{5,15},{6,15}]','[{50040102,2}]'),(50040102,3,'[{2,723},{1,36},{5,22},{6,22}]','[{50040102,3}]'),(50040102,4,'[{2,975},{1,49},{5,30},{6,30}]','[{50040102,4}]'),(50040102,5,'[{2,1254},{1,63},{5,38},{6,38}]','[{50040102,5}]'),(50040102,6,'[{2,1560},{1,78},{5,47},{6,47}]','[{50040102,6}]'),(50040102,7,'[{2,1893},{1,95},{5,57},{6,57}]','[{50040102,7}]'),(50040102,8,'[{2,2253},{1,113},{5,68},{6,68}]','[{50040102,8}]'),(50040102,9,'[{2,2640},{1,132},{5,80},{6,80}]','[{50040102,9}]'),(50040102,10,'[{2,3054},{1,153},{5,92},{6,92}]','[{50040102,10}]'),(50040102,11,'[{2,3495},{1,175},{5,105},{6,105}]','[{50040102,11}]'),(50040102,12,'[{2,3963},{1,198},{5,119},{6,119}]','[{50040102,12}]'),(50040102,13,'[{2,4458},{1,223},{5,134},{6,134}]','[{50040102,13}]'),(50040102,14,'[{2,4980},{1,249},{5,150},{6,150}]','[{50040102,14}]'),(50040102,15,'[{2,5529},{1,276},{5,166},{6,166}]','[{50040102,15}]'),(50040102,16,'[{2,6105},{1,305},{5,183},{6,183}]','[{50040102,16}]'),(50040102,17,'[{2,6708},{1,335},{5,201},{6,201}]','[{50040102,17}]'),(50040102,18,'[{2,7338},{1,367},{5,220},{6,220}]','[{50040102,18}]'),(50040102,19,'[{2,7995},{1,400},{5,240},{6,240}]','[{50040102,19}]'),(50040102,20,'[{2,8679},{1,434},{5,261},{6,261}]','[{50040102,20}]'),(50040102,21,'[{2,9399},{1,470},{5,283},{6,283}]','[{50040102,22}]'),(50040102,22,'[{2,10155},{1,508},{5,306},{6,306}]','[{50040102,24}]'),(50040102,23,'[{2,10947},{1,548},{5,330},{6,330}]','[{50040102,26}]'),(50040102,24,'[{2,11775},{1,589},{5,355},{6,355}]','[{50040102,28}]'),(50040102,25,'[{2,12639},{1,632},{5,381},{6,381}]','[{50040102,30}]'),(50040102,26,'[{2,13539},{1,677},{5,408},{6,408}]','[{50040102,32}]'),(50040102,27,'[{2,14475},{1,724},{5,436},{6,436}]','[{50040102,34}]'),(50040102,28,'[{2,15447},{1,773},{5,465},{6,465}]','[{50040102,36}]'),(50040102,29,'[{2,16455},{1,823},{5,495},{6,495}]','[{50040102,38}]'),(50040102,30,'[{2,17499},{1,875},{5,526},{6,526}]','[{50040102,40}]'),(50040102,31,'[{2,18579},{1,929},{5,558},{6,558}]','[{50040102,42}]'),(50040102,32,'[{2,19695},{1,985},{5,591},{6,591}]','[{50040102,44}]'),(50040102,33,'[{2,20847},{1,1043},{5,626},{6,626}]','[{50040102,46}]'),(50040102,34,'[{2,22035},{1,1102},{5,662},{6,662}]','[{50040102,48}]'),(50040102,35,'[{2,23259},{1,1163},{5,699},{6,699}]','[{50040102,50}]'),(50040102,36,'[{2,24519},{1,1226},{5,737},{6,737}]','[{50040102,52}]'),(50040102,37,'[{2,25815},{1,1291},{5,776},{6,776}]','[{50040102,54}]'),(50040102,38,'[{2,27147},{1,1358},{5,816},{6,816}]','[{50040102,56}]'),(50040102,39,'[{2,28515},{1,1426},{5,857},{6,857}]','[{50040102,58}]'),(50040102,40,'[{2,29919},{1,1496},{5,899},{6,899}]','[{50040102,60}]'),(50040103,1,'[{2,600},{1,30},{5,14},{6,14}]','[{50040103,1}]'),(50040103,2,'[{2,1098},{1,55},{5,26},{6,26}]','[{50040103,2}]'),(50040103,3,'[{2,1666},{1,83},{5,39},{6,39}]','[{50040103,3}]'),(50040103,4,'[{2,2303},{1,115},{5,54},{6,54}]','[{50040103,4}]'),(50040103,5,'[{2,3009},{1,150},{5,70},{6,70}]','[{50040103,5}]'),(50040103,6,'[{2,3784},{1,189},{5,88},{6,88}]','[{50040103,6}]'),(50040103,7,'[{2,4629},{1,231},{5,108},{6,108}]','[{50040103,7}]'),(50040103,8,'[{2,5543},{1,277},{5,129},{6,129}]','[{50040103,8}]'),(50040103,9,'[{2,6526},{1,326},{5,152},{6,152}]','[{50040103,9}]'),(50040103,10,'[{2,7578},{1,379},{5,177},{6,177}]','[{50040103,10}]'),(50040103,11,'[{2,8700},{1,435},{5,203},{6,203}]','[{50040103,12}]'),(50040103,12,'[{2,9891},{1,495},{5,231},{6,231}]','[{50040103,14}]'),(50040103,13,'[{2,11151},{1,558},{5,260},{6,260}]','[{50040103,16}]'),(50040103,14,'[{2,12480},{1,624},{5,291},{6,291}]','[{50040103,18}]'),(50040103,15,'[{2,13878},{1,694},{5,324},{6,324}]','[{50040103,20}]'),(50040103,16,'[{2,15369},{1,769},{5,359},{6,359}]','[{50040103,22}]'),(50040103,17,'[{2,16952},{1,848},{5,396},{6,396}]','[{50040103,24}]'),(50040103,18,'[{2,18627},{1,932},{5,435},{6,435}]','[{50040103,26}]'),(50040103,19,'[{2,20395},{1,1020},{5,476},{6,476}]','[{50040103,28}]'),(50040103,20,'[{2,22255},{1,1113},{5,519},{6,519}]','[{50040103,30}]'),(50040103,21,'[{2,24207},{1,1211},{5,565},{6,565}]','[{50040103,33}]'),(50040103,22,'[{2,26252},{1,1313},{5,613},{6,613}]','[{50040103,36}]'),(50040103,23,'[{2,28389},{1,1420},{5,663},{6,663}]','[{50040103,39}]'),(50040103,24,'[{2,30618},{1,1531},{5,715},{6,715}]','[{50040103,42}]'),(50040103,25,'[{2,32940},{1,1647},{5,769},{6,769}]','[{50040103,45}]'),(50040103,26,'[{2,35354},{1,1768},{5,825},{6,825}]','[{50040103,48}]'),(50040103,27,'[{2,37883},{1,1894},{5,884},{6,884}]','[{50040103,51}]'),(50040103,28,'[{2,40528},{1,2026},{5,946},{6,946}]','[{50040103,54}]'),(50040103,29,'[{2,43288},{1,2164},{5,1010},{6,1010}]','[{50040103,57}]'),(50040103,30,'[{2,46163},{1,2308},{5,1077},{6,1077}]','[{50040103,60}]'),(50040104,1,'[{2,1000},{1,50},{5,25},{6,25}]','[{50040104,1}]'),(50040104,2,'[{2,1778},{1,89},{5,44},{6,44}]','[{50040104,2}]'),(50040104,3,'[{2,2722},{1,136},{5,68},{6,68}]','[{50040104,3}]'),(50040104,4,'[{2,3833},{1,192},{5,96},{6,96}]','[{50040104,4}]'),(50040104,5,'[{2,5111},{1,256},{5,128},{6,128}]','[{50040104,5}]'),(50040104,6,'[{2,6611},{1,331},{5,166},{6,166}]','[{50040104,7}]'),(50040104,7,'[{2,8333},{1,417},{5,209},{6,209}]','[{50040104,9}]'),(50040104,8,'[{2,10277},{1,514},{5,258},{6,258}]','[{50040104,11}]'),(50040104,9,'[{2,12444},{1,622},{5,312},{6,312}]','[{50040104,13}]'),(50040104,10,'[{2,14888},{1,744},{5,373},{6,373}]','[{50040104,15}]'),(50040104,11,'[{2,17610},{1,880},{5,441},{6,441}]','[{50040104,18}]'),(50040104,12,'[{2,20610},{1,1030},{5,516},{6,516}]','[{50040104,21}]'),(50040104,13,'[{2,23888},{1,1194},{5,598},{6,598}]','[{50040104,24}]'),(50040104,14,'[{2,27444},{1,1372},{5,687},{6,687}]','[{50040104,27}]'),(50040104,15,'[{2,31277},{1,1564},{5,783},{6,783}]','[{50040104,30}]'),(50040104,16,'[{2,35444},{1,1772},{5,887},{6,887}]','[{50040104,34}]'),(50040104,17,'[{2,39944},{1,1997},{5,1000},{6,1000}]','[{50040104,38}]'),(50040104,18,'[{2,44777},{1,2239},{5,1121},{6,1121}]','[{50040104,42}]'),(50040104,19,'[{2,49944},{1,2497},{5,1250},{6,1250}]','[{50040104,46}]'),(50040104,20,'[{2,55444},{1,2772},{5,1388},{6,1388}]','[{50040104,50}]');
/*!40000 ALTER TABLE `base_fish_illustrated_lv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_fish_illustrated_type`
--

DROP TABLE IF EXISTS `base_fish_illustrated_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_fish_illustrated_type` (
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '类型名称',
  `comment` varchar(128) NOT NULL DEFAULT '' COMMENT '备注',
  PRIMARY KEY (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='鱼类图鉴类型表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_fish_illustrated_type`
--

LOCK TABLES `base_fish_illustrated_type` WRITE;
/*!40000 ALTER TABLE `base_fish_illustrated_type` DISABLE KEYS */;
INSERT INTO `base_fish_illustrated_type` VALUES (1,'无敌鱼类',''),(2,'无敌奇珍',''),(3,'无敌贝壳','');
/*!40000 ALTER TABLE `base_fish_illustrated_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_fish_type`
--

DROP TABLE IF EXISTS `base_fish_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_fish_type` (
  `id` int(32) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增ID',
  `fish_id` int(32) unsigned NOT NULL COMMENT '物品ID',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '名称',
  `quality_type` int(16) unsigned NOT NULL DEFAULT '0' COMMENT '品质类型',
  `hook_probability` int(32) unsigned NOT NULL COMMENT '上钩概率',
  `distri_water_area` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '分布水域',
  `range_of_balance` int(32) unsigned NOT NULL DEFAULT '0' COMMENT '平衡范围',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=24 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_fish_type`
--

LOCK TABLES `base_fish_type` WRITE;
/*!40000 ALTER TABLE `base_fish_type` DISABLE KEYS */;
INSERT INTO `base_fish_type` VALUES (1,50020101,'鳕鱼',0,740,'[{1,2,3}]',500),(2,50020102,'三文鱼',0,740,'[{1,2,3}]',500),(3,50020103,'九纹龙',0,740,'[{1,2,3}]',500),(4,50020104,'黄金尖尾鲈',1,740,'[{1,2,3}]',375),(5,50020105,'珊瑚美人',1,740,'[{1,2,3}]',375),(6,50020106,'龙鱼',2,520,'[{1,2,3}]',250),(7,50020107,'破浪剑鱼',2,520,'[{1,2,3}]',250),(8,50020108,'黄金鲶鱼',3,290,'[{1,2,3}]',125),(9,50020109,'彩斑河豚',3,290,'[{1,2,3}]',125),(10,50020110,'小丑鱼',4,140,'[{1,2,3}]',75),(11,50020111,'彩虹鱼',4,140,'[{1,2,3}]',75),(12,50030101,'章鱼',0,740,'[{1,2,3}]',500),(13,50030102,'龙尾虾',0,740,'[{1,2,3}]',500),(14,50030103,'鲍鱼',1,740,'[{1,2,3}]',375),(15,50030104,'珍宝蟹',1,740,'[{1,2,3}]',375),(16,50030105,'黄金海星',2,520,'[{1,2,3}]',250),(17,50030106,'红玉珊瑚',2,520,'[{1,2,3}]',250),(18,50030107,'寄居蟹',3,290,'[{1,2,3}]',125),(19,50030108,'幼生海草',4,140,'[{1,2,3}]',75),(20,50040101,'珍珠贝',0,3230,'[{1,2,3}]',500),(21,50040102,'黄金螺',1,3230,'[{1,2,3}]',375),(22,50040103,'火焰贝壳',2,2290,'[{1,2,3}]',250),(23,50040104,'石斑螺',3,1250,'[{1,2,3}]',125);
/*!40000 ALTER TABLE `base_fish_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_fishing_gear_type`
--

DROP TABLE IF EXISTS `base_fishing_gear_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_fishing_gear_type` (
  `id` int(32) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增ID',
  `fishing_gear_id` int(32) unsigned NOT NULL COMMENT '渔具ID',
  `fishing_gear_type` int(16) unsigned NOT NULL DEFAULT '0' COMMENT '渔具类型',
  `quality_type` int(16) unsigned NOT NULL DEFAULT '0' COMMENT '品质类型',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名称',
  `price` varchar(500) NOT NULL DEFAULT '[]' COMMENT '价格',
  `usage_count` int(32) unsigned NOT NULL DEFAULT '0' COMMENT '使用次数',
  `probability` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '概率加成',
  `incr_mastery` int(16) unsigned NOT NULL DEFAULT '0' COMMENT '熟练度',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_fishing_gear_type`
--

LOCK TABLES `base_fishing_gear_type` WRITE;
/*!40000 ALTER TABLE `base_fishing_gear_type` DISABLE KEYS */;
INSERT INTO `base_fishing_gear_type` VALUES (1,50010101,1,0,'普通鱼竿','[]',50,'[{2,500}]',1),(2,50010102,1,1,'中级鱼竿','[{1,36010001,20}]',50,'[{3,1000}]',3),(3,50010103,1,2,'顶级鱼竿','[{1,36010001,100}]',50,'[{4,1000}]',5),(4,50010201,2,0,'普通鱼饵','[]',1,'[{3,100}]',0),(5,50010202,2,1,'顶级鱼饵','[{2,36020001,5}]',1,'[{4,500}]',0);
/*!40000 ALTER TABLE `base_fishing_gear_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_fishing_key_value`
--

DROP TABLE IF EXISTS `base_fishing_key_value`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_fishing_key_value` (
  `id` int(32) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增ID',
  `key` varchar(500) NOT NULL DEFAULT '' COMMENT '键',
  `value` varchar(1024) NOT NULL DEFAULT '' COMMENT '值',
  `describe` varchar(5000) NOT NULL DEFAULT '' COMMENT '描述@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_fishing_key_value`
--

LOCK TABLES `base_fishing_key_value` WRITE;
/*!40000 ALTER TABLE `base_fishing_key_value` DISABLE KEYS */;
INSERT INTO `base_fishing_key_value` VALUES (1,'consume','30','每次钓鱼消耗的精力值'),(2,'rate','80','自动钓鱼成功率（百分比）'),(3,'limit','100','每日购买活力次数上限'),(4,'free_rods','50010101','免费鱼竿'),(5,'free_bait','50010201','免费鱼饵');
/*!40000 ALTER TABLE `base_fishing_key_value` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_fishing_lv`
--

DROP TABLE IF EXISTS `base_fishing_lv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_fishing_lv` (
  `id` int(32) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增ID',
  `lv` int(32) unsigned NOT NULL COMMENT '钓鱼等级',
  `mastery` int(32) unsigned NOT NULL DEFAULT '0' COMMENT '熟练度',
  `no_comsume_rod_pro` int(32) unsigned NOT NULL COMMENT '不消耗鱼竿次数的概率',
  `no_comsume_energy_pro` int(32) unsigned NOT NULL COMMENT '不消耗精力概率',
  `fish_quality_pro` varchar(128) NOT NULL DEFAULT '[]' COMMENT '鱼类品质加成',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=51 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_fishing_lv`
--

LOCK TABLES `base_fishing_lv` WRITE;
/*!40000 ALTER TABLE `base_fishing_lv` DISABLE KEYS */;
INSERT INTO `base_fishing_lv` VALUES (1,1,10,0,0,'[{1,100}]'),(2,2,30,100,100,'[{1,200}]'),(3,3,50,200,150,'[{1,300}]'),(4,4,70,300,200,'[{1,400}]'),(5,5,90,400,250,'[{1,500}]'),(6,6,110,500,300,'[{1,600}]'),(7,7,130,600,350,'[{1,700}]'),(8,8,150,700,400,'[{1,800}]'),(9,9,170,800,450,'[{1,900}]'),(10,10,190,900,500,'[{1,1000}]'),(11,11,210,1000,550,'[{1,1100},{2,100}]'),(12,12,230,1100,600,'[{1,1200},{2,200}]'),(13,13,250,1200,650,'[{1,1300},{2,301}]'),(14,14,270,1300,700,'[{1,1400},{2,402}]'),(15,15,290,1400,750,'[{1,1500},{2,503}]'),(16,16,310,1500,800,'[{1,1600},{2,604}]'),(17,17,330,1600,850,'[{1,1700},{2,705}]'),(18,18,350,1700,900,'[{1,1800},{2,806}]'),(19,19,370,1800,950,'[{1,1900},{2,907}]'),(20,20,390,1900,1000,'[{1,2000},{2,1000}]'),(21,21,410,2000,1050,'[{1,2100},{2,1100},{3,100}]'),(22,22,430,2100,1100,'[{1,2200},{2,1200},{3,200}]'),(23,23,450,2200,1150,'[{1,2300},{2,1300},{3,300}]'),(24,24,470,2300,1200,'[{1,2400},{2,1400},{3,400}]'),(25,25,490,2400,1250,'[{1,2500},{2,1500},{3,500}]'),(26,26,510,2500,1300,'[{1,2600},{2,1600},{3,600}]'),(27,27,530,2600,1350,'[{1,2700},{2,1700},{3,700}]'),(28,28,550,2700,1400,'[{1,2800},{2,1800},{3,800}]'),(29,29,570,2800,1450,'[{1,2900},{2,1900},{3,900}]'),(30,30,590,2900,1500,'[{1,3000},{2,2000},{3,1000}]'),(31,31,610,3000,1550,'[{1,3100},{2,2050},{3,1050},{4,50}]'),(32,32,630,3100,1600,'[{1,3200},{2,2100},{3,1100},{4,100}]'),(33,33,650,3200,1650,'[{1,3300},{2,2150},{3,1150},{4,150}]'),(34,34,670,3300,1700,'[{1,3400},{2,2200},{3,1200},{4,200}]'),(35,35,690,3400,1750,'[{1,3500},{2,2250},{3,1250},{4,250}]'),(36,36,710,3500,1800,'[{1,3600},{2,2300},{3,1300},{4,300}]'),(37,37,730,3600,1850,'[{1,3700},{2,2350},{3,1350},{4,350}]'),(38,38,750,3700,1900,'[{1,3800},{2,2400},{3,1400},{4,400}]'),(39,39,770,3800,1950,'[{1,3900},{2,2450},{3,1450},{4,450}]'),(40,40,790,3900,2000,'[{1,4000},{2,2500},{3,1500},{4,500}]'),(41,41,810,4000,2050,'[{1,4100},{2,2550},{3,1550},{4,550}]'),(42,42,830,4100,2100,'[{1,4200},{2,2600},{3,1600},{4,600}]'),(43,43,850,4200,2150,'[{1,4300},{2,2650},{3,1650},{4,650}]'),(44,44,870,4300,2200,'[{1,4400},{2,2700},{3,1700},{4,700}]'),(45,45,890,4400,2250,'[{1,4500},{2,2750},{3,1750},{4,750}]'),(46,46,910,4500,2300,'[{1,4600},{2,2800},{3,1800},{4,800}]'),(47,47,930,4600,2350,'[{1,4700},{2,2850},{3,1850},{4,850}]'),(48,48,950,4700,2400,'[{1,4800},{2,2900},{3,1900},{4,900}]'),(49,49,970,4800,2450,'[{1,4900},{2,2950},{3,1950},{4,950}]'),(50,50,0,4900,2500,'[{1,5000},{2,3000},{3,2000},{4,1000}]');
/*!40000 ALTER TABLE `base_fishing_lv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_flower_egg`
--

DROP TABLE IF EXISTS `base_flower_egg`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_flower_egg` (
  `egg_id` int(11) unsigned NOT NULL COMMENT '物品id',
  `egg_name` varchar(255) NOT NULL COMMENT '道具名称',
  `min_lv` smallint(5) unsigned NOT NULL COMMENT '等级下限',
  `vip_lv` tinyint(3) unsigned NOT NULL COMMENT '贵族等级限制',
  `limit_time` tinyint(3) unsigned NOT NULL COMMENT '限制次数',
  `cost` varchar(255) NOT NULL COMMENT '花费',
  `charm_value` int(11) NOT NULL DEFAULT '0' COMMENT '减少的魅力值',
  `effect` varchar(255) NOT NULL COMMENT '特效名',
  PRIMARY KEY (`egg_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='砸蛋配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_flower_egg`
--

LOCK TABLES `base_flower_egg` WRITE;
/*!40000 ALTER TABLE `base_flower_egg` DISABLE KEYS */;
INSERT INTO `base_flower_egg` VALUES (15,'一个鸡蛋',100,0,0,'[{1,36010001,1}]',1,''),(16,'一筐鸡蛋',150,4,30,'[{1,36010001,99}]',100,'');
/*!40000 ALTER TABLE `base_flower_egg` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_flower_tools`
--

DROP TABLE IF EXISTS `base_flower_tools`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_flower_tools` (
  `goods_id` int(11) unsigned NOT NULL COMMENT '鲜花道具类型id',
  `intimacy` int(11) unsigned NOT NULL COMMENT '增加亲密度',
  `charm` int(11) unsigned NOT NULL COMMENT '增加魅力值',
  `fame` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '名誉',
  `need_lv` smallint(6) unsigned NOT NULL COMMENT '需要等级',
  `need_vip` tinyint(4) unsigned NOT NULL COMMENT '需要VIP等级',
  `is_sell` tinyint(4) unsigned NOT NULL DEFAULT '0' COMMENT '是否可购买',
  `is_tv` tinyint(4) unsigned NOT NULL DEFAULT '0' COMMENT '传闻',
  `effect_type` tinyint(4) unsigned NOT NULL DEFAULT '0' COMMENT '特效类型',
  `effect` varchar(100) NOT NULL DEFAULT '' COMMENT '鲜花特效',
  PRIMARY KEY (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='鲜花配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_flower_tools`
--

LOCK TABLES `base_flower_tools` WRITE;
/*!40000 ALTER TABLE `base_flower_tools` DISABLE KEYS */;
INSERT INTO `base_flower_tools` VALUES (38100001,1,1,1,0,0,1,0,1,''),(38100002,75,75,75,0,0,1,1,3,'ui_zayh'),(38100003,560,560,560,0,0,1,1,3,'ui_xxxy'),(38100004,120,120,120,0,0,1,1,3,'ui_friendgift_xinxinxiangyin'),(38100005,240,240,240,0,0,1,1,3,'ui_zqgb'),(38100006,180,180,180,0,0,1,1,3,'ui_friendgift_happybirthday'),(38100007,40,40,40,0,0,1,0,2,'ui_effect_songli_1'),(38100008,6,6,6,0,0,1,0,2,'ui_effect_songli_2'),(38100009,10,10,10,0,0,1,0,1,''),(38100010,120,120,120,0,0,1,1,3,'uifx_giftlv8'),(38100012,15,15,15,0,0,1,0,2,'ui_effect_songli_3');
/*!40000 ALTER TABLE `base_flower_tools` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_game`
--

DROP TABLE IF EXISTS `base_game`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_game` (
  `cf_name` varchar(50) NOT NULL DEFAULT '' COMMENT '名称',
  `cf_value` text NOT NULL COMMENT '值',
  PRIMARY KEY (`cf_name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='游戏配置参数表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_game`
--

LOCK TABLES `base_game` WRITE;
/*!40000 ALTER TABLE `base_game` DISABLE KEYS */;
/*!40000 ALTER TABLE `base_game` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_gang_act`
--

DROP TABLE IF EXISTS `base_gang_act`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_gang_act` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `name` varchar(50) NOT NULL COMMENT '活动名称',
  `time_describe` varchar(255) NOT NULL DEFAULT '',
  `describe` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_gang_act`
--

LOCK TABLES `base_gang_act` WRITE;
/*!40000 ALTER TABLE `base_gang_act` DISABLE KEYS */;
INSERT INTO `base_gang_act` VALUES (2,'公会篝火','晚上20:30-20:50','参与公会篝火，可以获得大量经验奖励；期间还有答题活动可获得额外奖励哦！'),(3,'公会守卫','晚20:30-20:50','怪物来袭，保卫公会，与伙伴们并肩作战，保卫公会水晶！'),(4,'公会争霸','晚上20:30-20:50','三方争霸勇者胜，参与活动还能获得海量奖励哦！');
/*!40000 ALTER TABLE `base_gang_act` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_gang_building`
--

DROP TABLE IF EXISTS `base_gang_building`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_gang_building` (
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '建筑类型',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `cost` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消耗资金',
  `descriptoin` varchar(255) NOT NULL COMMENT '效果描述',
  PRIMARY KEY (`type`,`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_gang_building`
--

LOCK TABLES `base_gang_building` WRITE;
/*!40000 ALTER TABLE `base_gang_building` DISABLE KEYS */;
INSERT INTO `base_gang_building` VALUES (1,1,1000000,'<color=\'#4eae1aff\'>30</color>名成员,可任命副会长<color=\'#4eae1aff\'>1</color>名,长老<color=\'#4eae1aff\'>3</color>名,精英成员<color=\'#4eae1aff\'>5</color>名'),(1,2,3000000,'<color=\'#4eae1aff\'>33</color>名成员,可任命副会长<color=\'#4eae1aff\'>1</color>名,长老<color=\'#4eae1aff\'>3</color>名,精英成员<color=\'#4eae1aff\'>5</color>名'),(1,3,8000000,'<color=\'#4eae1aff\'>36</color>名成员,可任命副会长<color=\'#4eae1aff\'>1</color>名,长老<color=\'#4eae1aff\'>3</color>名,精英成员<color=\'#4eae1aff\'>5</color>名'),(1,4,15000000,'<color=\'#4eae1aff\'>38</color>名成员,可任命副会长<color=\'#4eae1aff\'>2</color>名,长老<color=\'#4eae1aff\'>4</color>名,精英成员<color=\'#4eae1aff\'>5</color>名'),(1,5,25000000,'<color=\'#4eae1aff\'>40</color>名成员,可任命副会长<color=\'#4eae1aff\'>2</color>名,长老<color=\'#4eae1aff\'>4</color>名,精英成员<color=\'#4eae1aff\'>5</color>名'),(1,6,40000000,'<color=\'#4eae1aff\'>42</color>名成员,可任命副会长<color=\'#4eae1aff\'>2</color>名,长老<color=\'#4eae1aff\'>4</color>名,精英成员<color=\'#4eae1aff\'>5</color>名'),(1,7,60000000,'<color=\'#4eae1aff\'>44</color>名成员,可任命副会长<color=\'#4eae1aff\'>2</color>名,长老<color=\'#4eae1aff\'>4</color>名,精英成员<color=\'#4eae1aff\'>5</color>名'),(1,8,90000000,'<color=\'#4eae1aff\'>46</color>名成员,可任命副会长<color=\'#4eae1aff\'>2</color>名,长老<color=\'#4eae1aff\'>4</color>名,精英成员<color=\'#4eae1aff\'>5</color>名'),(1,9,120000000,'<color=\'#4eae1aff\'>48</color>名成员,可任命副会长<color=\'#4eae1aff\'>2</color>名,长老<color=\'#4eae1aff\'>4</color>名,精英成员<color=\'#4eae1aff\'>5</color>名'),(1,10,0,'<color=\'#4eae1aff\'>50</color>名成员,可任命副会长<color=\'#4eae1aff\'>2</color>名,长老<color=\'#4eae1aff\'>4</color>名,精英成员<color=\'#4eae1aff\'>5</color>名'),(2,1,325000,'每日可捐献徽章<color=\'#4eae1aff\'>10</color>次,每日可捐献钻石<color=\'#4eae1aff\'>10</color>次'),(2,2,975000,'每日可捐献徽章<color=\'#4eae1aff\'>11</color>次,每日可捐献钻石<color=\'#4eae1aff\'>11</color>次'),(2,3,2600000,'每日可捐献徽章<color=\'#4eae1aff\'>12</color>次,每日可捐献钻石<color=\'#4eae1aff\'>12</color>次'),(2,4,4875000,'每日可捐献徽章<color=\'#4eae1aff\'>13</color>次,每日可捐献钻石<color=\'#4eae1aff\'>13</color>次'),(2,5,8125000,'每日可捐献徽章<color=\'#4eae1aff\'>14</color>次,每日可捐献钻石<color=\'#4eae1aff\'>14</color>次'),(2,6,13000000,'每日可捐献徽章<color=\'#4eae1aff\'>15</color>次,每日可捐献钻石<color=\'#4eae1aff\'>15</color>次'),(2,7,19500000,'每日可捐献徽章<color=\'#4eae1aff\'>16</color>次,每日可捐献钻石<color=\'#4eae1aff\'>16</color>次'),(2,8,29250000,'每日可捐献徽章<color=\'#4eae1aff\'>17</color>次,每日可捐献钻石<color=\'#4eae1aff\'>17</color>次'),(2,9,39000000,'每日可捐献徽章<color=\'#4eae1aff\'>18</color>次,每日可捐献钻石<color=\'#4eae1aff\'>18</color>次'),(2,10,0,'每日可捐献徽章<color=\'#4eae1aff\'>19</color>次,每日可捐献钻石<color=\'#4eae1aff\'>19</color>次'),(3,1,175000,'仓库容量上限<color=\'#4eae1aff\'>100</color>格'),(3,2,525000,'仓库容量上限<color=\'#4eae1aff\'>110</color>格'),(3,3,1400000,'仓库容量上限<color=\'#4eae1aff\'>120</color>格'),(3,4,2625000,'仓库容量上限<color=\'#4eae1aff\'>130</color>格'),(3,5,4375000,'仓库容量上限<color=\'#4eae1aff\'>140</color>格'),(3,6,7000000,'仓库容量上限<color=\'#4eae1aff\'>150</color>格'),(3,7,10500000,'仓库容量上限<color=\'#4eae1aff\'>160</color>格'),(3,8,15750000,'仓库容量上限<color=\'#4eae1aff\'>170</color>格'),(3,9,21000000,'仓库容量上限<color=\'#4eae1aff\'>180</color>格'),(3,10,0,'仓库容量上限<color=\'#4eae1aff\'>190</color>格'),(4,1,400000,'公会技能属性加成<color=\'#4eae1aff\'>+0%</color>'),(4,2,1200000,'公会技能属性加成<color=\'#4eae1aff\'>+5%</color>'),(4,3,3200000,'公会技能属性加成<color=\'#4eae1aff\'>+10%</color>'),(4,4,6000000,'公会技能属性加成<color=\'#4eae1aff\'>+16%</color>'),(4,5,10000000,'公会技能属性加成<color=\'#4eae1aff\'>+24%</color>'),(4,6,16000000,'公会技能属性加成<color=\'#4eae1aff\'>+32%</color>'),(4,7,24000000,'公会技能属性加成<color=\'#4eae1aff\'>+40%</color>'),(4,8,36000000,'公会技能属性加成<color=\'#4eae1aff\'>+50%</color>'),(4,9,48000000,'公会技能属性加成<color=\'#4eae1aff\'>+60%</color>'),(4,10,0,'公会技能属性加成<color=\'#4eae1aff\'>+75%</color>'),(5,1,300000,'每日商店交易上限<color=\'#4eae1aff\'>15</color>次'),(5,2,900000,'每日商店交易上限<color=\'#4eae1aff\'>20</color>次'),(5,3,2400000,'每日商店交易上限<color=\'#4eae1aff\'>25</color>次'),(5,4,4500000,'每日商店交易上限<color=\'#4eae1aff\'>30</color>次'),(5,5,7500000,'每日商店交易上限<color=\'#4eae1aff\'>35</color>次'),(5,6,12000000,'每日商店交易上限<color=\'#4eae1aff\'>40</color>次'),(5,7,18000000,'每日商店交易上限<color=\'#4eae1aff\'>45</color>次'),(5,8,27000000,'每日商店交易上限<color=\'#4eae1aff\'>50</color>次'),(5,9,36000000,'每日商店交易上限<color=\'#4eae1aff\'>55</color>次'),(5,10,0,'每日商店交易上限<color=\'#4eae1aff\'>60</color>次'),(6,1,300000,'公会任务经验加成<color=\'#4eae1aff\'>0%</color>'),(6,2,900000,'公会任务经验加成<color=\'#4eae1aff\'>10%</color>'),(6,3,2400000,'公会任务经验加成<color=\'#4eae1aff\'>20%</color>'),(6,4,4500000,'公会任务经验加成<color=\'#4eae1aff\'>30%</color>'),(6,5,7500000,'公会任务经验加成<color=\'#4eae1aff\'>40%</color>'),(6,6,12000000,'公会任务经验加成<color=\'#4eae1aff\'>50%</color>'),(6,7,18000000,'公会任务经验加成<color=\'#4eae1aff\'>60%</color>'),(6,8,27000000,'公会任务经验加成<color=\'#4eae1aff\'>70%</color>'),(6,9,36000000,'公会任务经验加成<color=\'#4eae1aff\'>80%</color>'),(6,10,0,'公会任务经验加成<color=\'#4eae1aff\'>90%</color>');
/*!40000 ALTER TABLE `base_gang_building` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_gang_create`
--

DROP TABLE IF EXISTS `base_gang_create`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_gang_create` (
  `cfg_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '配置id',
  `cost` varchar(50) NOT NULL DEFAULT '[]' COMMENT '消耗内容',
  `guild_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '初始公会大厅等级',
  `condition` varchar(255) NOT NULL DEFAULT '[]' COMMENT '创建条件',
  PRIMARY KEY (`cfg_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_gang_create`
--

LOCK TABLES `base_gang_create` WRITE;
/*!40000 ALTER TABLE `base_gang_create` DISABLE KEYS */;
INSERT INTO `base_gang_create` VALUES (1,'[{3,36030001,3000000}]',1,'[{lv,150}]'),(2,'[{2,36020001,100}]',1,'[{lv,120}]'),(3,'[{1,36010001,200}]',2,'[]');
/*!40000 ALTER TABLE `base_gang_create` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_gang_donate`
--

DROP TABLE IF EXISTS `base_gang_donate`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_gang_donate` (
  `cfg_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '配置id',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗内容',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励内容',
  PRIMARY KEY (`cfg_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_gang_donate`
--

LOCK TABLES `base_gang_donate` WRITE;
/*!40000 ALTER TABLE `base_gang_donate` DISABLE KEYS */;
INSERT INTO `base_gang_donate` VALUES (1,'[{0,38190001,1}]','[{4,0,5000},{8,0,5000}]'),(2,'[{2,0,10}]','[{4,0,13000},{8,0,13000}]');
/*!40000 ALTER TABLE `base_gang_donate` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_gang_extra_live_reward`
--

DROP TABLE IF EXISTS `base_gang_extra_live_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_gang_extra_live_reward` (
  `reward_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励id',
  `live` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '个人累积活跃度',
  `extra_add` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '额外增加公会活跃度',
  PRIMARY KEY (`reward_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_gang_extra_live_reward`
--

LOCK TABLES `base_gang_extra_live_reward` WRITE;
/*!40000 ALTER TABLE `base_gang_extra_live_reward` DISABLE KEYS */;
INSERT INTO `base_gang_extra_live_reward` VALUES (1,50,1),(2,100,8),(3,150,10),(4,170,11),(5,180,12),(6,190,13),(7,200,14);
/*!40000 ALTER TABLE `base_gang_extra_live_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_gang_king_building`
--

DROP TABLE IF EXISTS `base_gang_king_building`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_gang_king_building` (
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '金库等级',
  `cfg_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '配置id',
  `limit` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '每日上限',
  PRIMARY KEY (`lv`,`cfg_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_gang_king_building`
--

LOCK TABLES `base_gang_king_building` WRITE;
/*!40000 ALTER TABLE `base_gang_king_building` DISABLE KEYS */;
INSERT INTO `base_gang_king_building` VALUES (1,1,10),(1,2,10),(2,1,11),(2,2,11),(3,1,12),(3,2,12),(4,1,13),(4,2,13),(5,1,14),(5,2,14),(6,1,15),(6,2,15),(7,1,16),(7,2,16),(8,1,17),(8,2,17),(9,1,18),(9,2,18),(10,1,19),(10,2,19);
/*!40000 ALTER TABLE `base_gang_king_building` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_gang_kv`
--

DROP TABLE IF EXISTS `base_gang_kv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_gang_kv` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `key` varchar(50) NOT NULL DEFAULT '0' COMMENT '键',
  `val` varchar(256) NOT NULL DEFAULT '0' COMMENT '值',
  `description` varchar(50) NOT NULL DEFAULT '' COMMENT '描述',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=30 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_gang_kv`
--

LOCK TABLES `base_gang_kv` WRITE;
/*!40000 ALTER TABLE `base_gang_kv` DISABLE KEYS */;
INSERT INTO `base_gang_kv` VALUES (1,'guild_name_len','{4,12}','最小字数限制和最大字数限制(字符 注:1个汉字需要两个字符,一个英文字母需要一个字)'),(2,'announce_len','{2,100}','公告最小字数限制和最大字数限制(字符 注:1个汉字需要两个字符,一个英文字母需要一个字)'),(3,'create_role_lv','100','创建公会人物等级限制'),(4,'create_vip_lv','4','创建公会vip等级限制'),(5,'leave_again_apply','0','退出公会cd（秒）'),(6,'guild_apply_len_limit','20','公会申请上限人数'),(7,'auto_to_chief_af_chief_leave_time','86400','会长离线上限时间自动任命'),(8,'appoint_leave_time','86400','离线时间上限不自动任命'),(9,'red_packet_limit','200','红包绑钻领取上限'),(10,'consume_item','[{1,[{2,36020001,100}]},{2,[{3,36030001,3000000}]}]','第一种创建公会消耗,格式[{消耗类型,[{类型,物品id,数量}]}]'),(11,'salary_refresh','72000','刷新工资时间（0点开始到刷新点的时间(秒)）'),(12,'red_packet_len','{1,20}','发送红包输入最大字符（一个中文字代表两个字符）'),(13,'red_gold_packet_limit','100','红包钻石领取上限'),(14,'rename_cost','[{0,38210002,1}]','公会改名消耗道具,格式[{类型,物品id,数量}]'),(15,'disband_time','0','公会解散最小时间限制(秒/s)'),(16,'disband_num','1','公会解散需要最少人数'),(17,'apply_join_guild_lv','60','申请公会玩家等级'),(18,'auto_to_elite','50000','普通成员自动转为精英的贡献'),(19,'liveness_trans','30','活跃度转换，百分比，30%则填30'),(20,'live_limit','100','每日领取奖励个人活跃度'),(21,'donate_limit','[{1,3,0}]','公会仓库装备捐献最低限制[{阶数，品质颜色id，星星数}]'),(22,'consume_item2','[{1,36010001,200}]','第二种创建公会的消耗,消耗格式[{类型,物品id,数量}]'),(23,'reward_liveness','490','创建第一天赠送的公会活跃度'),(24,'cost_liveness','[{2,70},{3,70},{4,70},{5,70},{6,70},{7,70}]','扣除的活跃度[{天数,活跃度值}]'),(25,'skill_limit','[{1000,1},{2000,1},{3000,240},{4000,240},{5000,420},{6000,420},{7000,540},{8000,540}]','[{技能id,人物等级}]'),(26,'exchange_goods','[{38040201,10,1,10000,400,3}]','公会仓库额外兑换道具:[{物品id,每日数量,每次获得个数,需要积分,模块id,模块子id}]'),(27,'notice_limit','3','公会公告每天可修改发布的次数'),(28,'depot_auto_del_num','3','公会仓库自动销毁个数'),(29,'guild_default_lv2','2','第二种创建公会消耗类型默认等级');
/*!40000 ALTER TABLE `base_gang_kv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_gang_lv`
--

DROP TABLE IF EXISTS `base_gang_lv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_gang_lv` (
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `member_capacity` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '成员数量',
  `pos_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT '职位数量',
  `building` varchar(50) NOT NULL DEFAULT '[]' COMMENT '开启建筑列表',
  `upgrade_desc` varchar(255) NOT NULL,
  `ratio` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级比例',
  `base_ratio` int(11) NOT NULL DEFAULT '0' COMMENT '基础比例',
  PRIMARY KEY (`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_gang_lv`
--

LOCK TABLES `base_gang_lv` WRITE;
/*!40000 ALTER TABLE `base_gang_lv` DISABLE KEYS */;
INSERT INTO `base_gang_lv` VALUES (1,30,'[{1,1},{2,1},{3,3},{4,5}]','[2,3,4,5,6]','可喜可贺！在公会所有成员的努力下，公会已经达到1级！公会成员上限达到30个!',0,10000),(2,33,'[{1,1},{2,1},{3,3},{4,5}]','[2,3,4,5,6]','可喜可贺！在公会所有成员的努力下，公会已经达到2级！公会成员上限达到33个!',0,10000),(3,36,'[{1,1},{2,1},{3,3},{4,5}]','[2,3,4,5,6]','可喜可贺！在公会所有成员的努力下，公会已经达到3级！公会成员上限达到36个!',0,10000),(4,38,'[{1,1},{2,2},{3,4},{4,5}]','[2,3,4,5,6]','可喜可贺！在公会所有成员的努力下，公会已经达到4级！公会成员上限达到38个!',0,10000),(5,40,'[{1,1},{2,2},{3,4},{4,5}]','[2,3,4,5,6]','可喜可贺！在公会所有成员的努力下，公会已经达到5级！公会成员上限达到40个!',0,10000),(6,42,'[{1,1},{2,2},{3,4},{4,5}]','[2,3,4,5,6]','可喜可贺！在公会所有成员的努力下，公会已经达到6级！公会成员上限达到42个!',0,10000),(7,44,'[{1,1},{2,2},{3,4},{4,5}]','[2,3,4,5,6]','可喜可贺！在公会所有成员的努力下，公会已经达到7级！公会成员上限达到44个!',0,10000),(8,46,'[{1,1},{2,2},{3,4},{4,5}]','[2,3,4,5,6]','可喜可贺！在公会所有成员的努力下，公会已经达到8级！公会成员上限达到46个!',0,10000),(9,48,'[{1,1},{2,2},{3,4},{4,5}]','[2,3,4,5,6]','可喜可贺！在公会所有成员的努力下，公会已经达到9级！公会成员上限达到48个!',0,10000),(10,50,'[{1,1},{2,2},{3,4},{4,5}]','[2,3,4,5,6]','可喜可贺！在公会所有成员的努力下，公会已经达到10级！公会成员上限达到50个!',0,10000);
/*!40000 ALTER TABLE `base_gang_lv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_gang_pos`
--

DROP TABLE IF EXISTS `base_gang_pos`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_gang_pos` (
  `position` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '职位',
  `name` varchar(50) NOT NULL DEFAULT '0' COMMENT '职位名称',
  `permission_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT '权限列表',
  PRIMARY KEY (`position`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_gang_pos`
--

LOCK TABLES `base_gang_pos` WRITE;
/*!40000 ALTER TABLE `base_gang_pos` DISABLE KEYS */;
INSERT INTO `base_gang_pos` VALUES (1,'会长','[1,2,3,4,5,6,7,8,9,10,11]'),(2,'副会长','[1,2,3,4,5,7,8,9]'),(3,'长老','[1,9]'),(4,'精英','[9]'),(5,'普通成员','[9]');
/*!40000 ALTER TABLE `base_gang_pos` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_gang_reply_boss`
--

DROP TABLE IF EXISTS `base_gang_reply_boss`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_gang_reply_boss` (
  `good_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品id',
  `boss_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'bossid',
  `ratio` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '单人系数',
  PRIMARY KEY (`good_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_gang_reply_boss`
--

LOCK TABLES `base_gang_reply_boss` WRITE;
/*!40000 ALTER TABLE `base_gang_reply_boss` DISABLE KEYS */;
INSERT INTO `base_gang_reply_boss` VALUES (38220011,4101001,50),(38220012,4101002,20),(38220013,4101003,10);
/*!40000 ALTER TABLE `base_gang_reply_boss` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_gang_reply_dinner`
--

DROP TABLE IF EXISTS `base_gang_reply_dinner`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_gang_reply_dinner` (
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '晚宴类型',
  `ratio` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '加成比例',
  `limit` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '购买数量',
  `cost` varchar(50) NOT NULL DEFAULT '[]' COMMENT '消耗',
  PRIMARY KEY (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_gang_reply_dinner`
--

LOCK TABLES `base_gang_reply_dinner` WRITE;
/*!40000 ALTER TABLE `base_gang_reply_dinner` DISABLE KEYS */;
INSERT INTO `base_gang_reply_dinner` VALUES (1,10,10,'[{2,36020001,20}]'),(2,20,5,'[{1,36010001,30}]'),(3,80,1,'[{1,36010001,150}]');
/*!40000 ALTER TABLE `base_gang_reply_dinner` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_gang_reply_exp`
--

DROP TABLE IF EXISTS `base_gang_reply_exp`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_gang_reply_exp` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '序号',
  `min_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小世界等级',
  `max_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大世界等级',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '经验',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_gang_reply_exp`
--

LOCK TABLES `base_gang_reply_exp` WRITE;
/*!40000 ALTER TABLE `base_gang_reply_exp` DISABLE KEYS */;
INSERT INTO `base_gang_reply_exp` VALUES (1,1,200,75308),(2,201,250,116945),(3,251,300,136177),(4,301,350,164379),(5,351,400,407300),(6,401,450,642413),(7,451,500,850812),(8,501,520,976797),(9,521,540,1274232),(10,541,560,1561967),(11,561,580,1708121),(12,581,600,1854275),(13,601,620,2000429),(14,621,640,2146583),(15,641,660,2292737),(16,661,680,2438890),(17,681,700,2585044),(18,701,720,2731198),(19,721,740,2877352),(20,741,760,3023506),(21,761,780,3169660),(22,781,800,3169660),(23,801,820,3169660),(24,821,840,3169660),(25,841,860,3169660),(26,861,880,3169660),(27,881,900,3169660),(28,901,920,3169660),(29,921,940,3169660),(30,941,960,3169660),(31,961,980,3169660),(32,981,1000,3169660);
/*!40000 ALTER TABLE `base_gang_reply_exp` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_gang_reply_kv`
--

DROP TABLE IF EXISTS `base_gang_reply_kv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_gang_reply_kv` (
  `key` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '键名',
  `val` varchar(255) NOT NULL DEFAULT '0' COMMENT '键值',
  `description` varchar(255) NOT NULL DEFAULT '' COMMENT '描述',
  PRIMARY KEY (`key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会答题键值配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_gang_reply_kv`
--

LOCK TABLES `base_gang_reply_kv` WRITE;
/*!40000 ALTER TABLE `base_gang_reply_kv` DISABLE KEYS */;
INSERT INTO `base_gang_reply_kv` VALUES (1,'1210','总时间（秒/s）'),(2,'10','倒计时出场景（秒/s）'),(3,'180','篝火开始后Xs开启答题'),(4,'5','经验间隔（秒/s）'),(5,'10','每道题答题时间（秒/s）'),(6,'5','每道题间隔时间（秒/s）'),(7,'20','总题目数量'),(8,'4101','场景id'),(9,'[{0,18020001,2}]','答对奖励:[{类型,物品id,数量}]'),(10,'[{0,18020001,1}]','答错奖励:[{类型,物品id,数量}]'),(11,'[{4000,1400}]','召唤boss位置'),(12,'150','玩家等级'),(13,'25','答题排行奖励数量'),(14,'5','公会活跃度开启下限'),(15,'780','加经验总时间(秒/s)'),(16,'[{3300, 1900, 600}]','出生点坐标:[{圆心X,圆心Y,半径}]');
/*!40000 ALTER TABLE `base_gang_reply_kv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_gang_reply_reward`
--

DROP TABLE IF EXISTS `base_gang_reply_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_gang_reply_reward` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `rank_min` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小排名',
  `rank_max` int(11) NOT NULL DEFAULT '0' COMMENT '最大排名',
  `min_lv` int(11) NOT NULL DEFAULT '0' COMMENT '世界最小等级',
  `max_lv` int(11) NOT NULL DEFAULT '0' COMMENT '最大世界等级',
  `reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '奖励内容',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=79 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_gang_reply_reward`
--

LOCK TABLES `base_gang_reply_reward` WRITE;
/*!40000 ALTER TABLE `base_gang_reply_reward` DISABLE KEYS */;
INSERT INTO `base_gang_reply_reward` VALUES (1,1,1,1,200,'[{0,24010001,15},{0,38220011,1}]'),(2,1,1,201,260,'[{0,24010001,15},{0,38220011,1}]'),(3,1,1,261,320,'[{0,24010001,15},{0,38220011,1}]'),(4,1,1,321,350,'[{0,24010001,18},{0,38220011,1}]'),(5,1,1,351,370,'[{0,24010001,18},{0,38220011,1}]'),(6,1,1,371,390,'[{0,24010001,18},{0,38220011,1}]'),(7,1,1,391,430,'[{0,24010001,20},{0,38220011,1}]'),(8,1,1,431,500,'[{0,24010001,20},{0,38220011,1}]'),(9,1,1,501,560,'[{0,24010001,24},{0,38220011,1}]'),(10,1,1,561,610,'[{0,24010001,24},{0,38220011,1}]'),(11,1,1,611,660,'[{0,24010001,24},{0,38220011,1}]'),(12,1,1,661,750,'[{0,24010001,24},{0,38220011,1}]'),(13,1,1,751,1000,'[{0,24010001,24},{0,38220011,1}]'),(14,2,2,1,200,'[{0,24010001,12},{0,38220011,1}]'),(15,2,2,201,260,'[{0,24010001,12},{0,38220011,1}]'),(16,2,2,261,320,'[{0,24010001,12},{0,38220011,1}]'),(17,2,2,321,350,'[{0,24010001,15},{0,38220011,1}]'),(18,2,2,351,370,'[{0,24010001,15},{0,38220011,1}]'),(19,2,2,371,390,'[{0,24010001,15},{0,38220011,1}]'),(20,2,2,391,430,'[{0,24010001,18},{0,38220011,1}]'),(21,2,2,431,500,'[{0,24010001,18},{0,38220011,1}]'),(22,2,2,501,560,'[{0,24010001,21},{0,38220011,1}]'),(23,2,2,561,610,'[{0,24010001,21},{0,38220011,1}]'),(24,2,2,611,660,'[{0,24010001,21},{0,38220011,1}]'),(25,2,2,661,750,'[{0,24010001,21},{0,38220011,1}]'),(26,2,2,751,1000,'[{0,24010001,21},{0,38220011,1}]'),(27,3,3,1,200,'[{0,24010001,10},{0,38220011,1}]'),(28,3,3,201,260,'[{0,24010001,10},{0,38220011,1}]'),(29,3,3,261,320,'[{0,24010001,10},{0,38220011,1}]'),(30,3,3,321,350,'[{0,24010001,12},{0,38220011,1}]'),(31,3,3,351,370,'[{0,24010001,12},{0,38220011,1}]'),(32,3,3,371,390,'[{0,24010001,12},{0,38220011,1}]'),(33,3,3,391,430,'[{0,24010001,15},{0,38220011,1}]'),(34,3,3,431,500,'[{0,24010001,15},{0,38220011,1}]'),(35,3,3,501,560,'[{0,24010001,18},{0,38220011,1}]'),(36,3,3,561,610,'[{0,24010001,18},{0,38220011,1}]'),(37,3,3,611,660,'[{0,24010001,18},{0,38220011,1}]'),(38,3,3,661,750,'[{0,24010001,18},{0,38220011,1}]'),(39,3,3,751,1000,'[{0,24010001,18},{0,38220011,1}]'),(40,4,5,1,200,'[{0,24010001,8},{0,38220012,1}]'),(41,4,5,201,260,'[{0,24010001,8},{0,38220012,1}]'),(42,4,5,261,320,'[{0,24010001,8},{0,38220012,1}]'),(43,4,5,321,350,'[{0,24010001,10},{0,38220012,1}]'),(44,4,5,351,370,'[{0,24010001,10},{0,38220012,1}]'),(45,4,5,371,390,'[{0,24010001,10},{0,38220012,1}]'),(46,4,5,391,430,'[{0,24010001,12},{0,38220012,1}]'),(47,4,5,431,500,'[{0,24010001,12},{0,38220012,1}]'),(48,4,5,501,560,'[{0,24010001,16},{0,38220012,1}]'),(49,4,5,561,610,'[{0,24010001,16},{0,38220012,1}]'),(50,4,5,611,660,'[{0,24010001,16},{0,38220012,1}]'),(51,4,5,661,750,'[{0,24010001,16},{0,38220012,1}]'),(52,4,5,751,1000,'[{0,24010001,16},{0,38220012,1}]'),(53,6,10,1,200,'[{0,24010001,5},{0,38220012,1}]'),(54,6,10,201,260,'[{0,24010001,5},{0,38220012,1}]'),(55,6,10,261,320,'[{0,24010001,5},{0,38220012,1}]'),(56,6,10,321,350,'[{0,24010001,8},{0,38220012,1}]'),(57,6,10,351,370,'[{0,24010001,8},{0,38220012,1}]'),(58,6,10,371,390,'[{0,24010001,8},{0,38220012,1}]'),(59,6,10,391,430,'[{0,24010001,10},{0,38220012,1}]'),(60,6,10,431,500,'[{0,24010001,10},{0,38220012,1}]'),(61,6,10,501,560,'[{0,24010001,14},{0,38220012,1}]'),(62,6,10,561,610,'[{0,24010001,14},{0,38220012,1}]'),(63,6,10,611,660,'[{0,24010001,14},{0,38220012,1}]'),(64,6,10,661,750,'[{0,24010001,14},{0,38220012,1}]'),(65,6,10,751,1000,'[{0,24010001,14},{0,38220012,1}]'),(66,11,25,1,200,'[{0,24010001,4},{0,38220013,1}]'),(67,11,25,201,260,'[{0,24010001,4},{0,38220013,1}]'),(68,11,25,261,320,'[{0,24010001,4},{0,38220013,1}]'),(69,11,25,321,350,'[{0,24010001,6},{0,38220013,1}]'),(70,11,25,351,370,'[{0,24010001,6},{0,38220013,1}]'),(71,11,25,371,390,'[{0,24010001,6},{0,38220013,1}]'),(72,11,25,391,430,'[{0,24010001,8},{0,38220013,1}]'),(73,11,25,431,500,'[{0,24010001,8},{0,38220013,1}]'),(74,11,25,501,560,'[{0,24010001,12},{0,38220013,1}]'),(75,11,25,561,610,'[{0,24010001,12},{0,38220013,1}]'),(76,11,25,611,660,'[{0,24010001,12},{0,38220013,1}]'),(77,11,25,661,750,'[{0,24010001,12},{0,38220013,1}]'),(78,11,25,751,1000,'[{0,24010001,12},{0,38220013,1}]');
/*!40000 ALTER TABLE `base_gang_reply_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_gang_reply_speed_rank`
--

DROP TABLE IF EXISTS `base_gang_reply_speed_rank`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_gang_reply_speed_rank` (
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '速度排行',
  `rank_max` int(11) NOT NULL COMMENT '最大速度',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '可得积分',
  PRIMARY KEY (`rank`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_gang_reply_speed_rank`
--

LOCK TABLES `base_gang_reply_speed_rank` WRITE;
/*!40000 ALTER TABLE `base_gang_reply_speed_rank` DISABLE KEYS */;
INSERT INTO `base_gang_reply_speed_rank` VALUES (1,1,100),(2,2,90),(3,3,80),(4,4,70),(5,5,60),(6,6,50),(7,7,40),(8,8,30),(9,9,20),(10,999,10);
/*!40000 ALTER TABLE `base_gang_reply_speed_rank` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_gang_reply_title`
--

DROP TABLE IF EXISTS `base_gang_reply_title`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_gang_reply_title` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '题目编号',
  `question` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '题目',
  `right` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '正确答案',
  `right_answer` varchar(50) NOT NULL COMMENT '正确答案',
  `answer1` varchar(512) NOT NULL DEFAULT '[]' COMMENT '选项1',
  `answer2` varchar(512) NOT NULL DEFAULT '[]' COMMENT '选型2',
  `answer3` varchar(512) NOT NULL DEFAULT '[]' COMMENT '选项3',
  `answer4` varchar(512) NOT NULL DEFAULT '[]' COMMENT '选项4',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_gang_reply_title`
--

LOCK TABLES `base_gang_reply_title` WRITE;
/*!40000 ALTER TABLE `base_gang_reply_title` DISABLE KEYS */;
INSERT INTO `base_gang_reply_title` VALUES (1,'哪种食物人吃了没事，可狗狗吃多了会危及生命？',3,'巧克力','小白菜','大白菜','巧克力','冰激凌'),(2,'中国工商银行的英文缩写是什么？',4,'ICBC','CCB','ABC','BOC','ICBC'),(3,'“沉鱼落雁，闭月羞花”中的“闭月”是指？',2,'貂蝉','王昭君','貂蝉','杨贵妃','西施'),(4,'“豆蔻年华”是指几岁？',1,'13岁','13岁','14岁','16岁','18岁'),(5,'世界上最大的鲸是？',1,'蓝鲸','蓝鲸','抹香鲸','虎鲸','角鲸'),(6,'下列哪个城市不是以人名为命名的？',2,'莫斯科','圣地亚哥','莫斯科','巴黎','科伦坡'),(7,'“三十年河东”中的“河”最初指的是？',1,'黄河','黄河','淮河','长江','汾河'),(8,'鱼翅是由哪种动物制成的？',3,'鲨鱼','鲸鱼','鲤鱼','鲨鱼','粉丝'),(9,'西楚霸王项羽是在哪条河自刎的？',4,'乌江','黄河','长江','珠江','乌江'),(10,'迪士尼卡通形象米老鼠有多少根手指？',2,'4根','5根','4根','3根','不知道'),(11,'人们通常用来送花的“蓝色妖姬”其实是什么花？',3,'玫瑰','月季','百合','玫瑰','海棠'),(12,'龙井茶的产地是下列哪个城市？',4,'杭州','贵州','重庆','苏州','杭州'),(13,'动漫《名侦探柯南》中，柯南常用的变声器藏在哪？',2,'领结','眼镜','领结','裤子','鞋子'),(14,'中国四大发明中的造纸术是谁发明的？',4,'蔡伦','蔡琴','蔡少芬','菜头','蔡伦'),(15,'多吃海带能够预防甲状腺肿大是因为其富含下列哪种元素？',4,'碘','钙','铁','锌','碘'),(16,'从电视机中爬出来的著名恐怖电影角色名叫？',3,'贞子','纯子','明子','贞子','爱子'),(17,'目前我国内地的小型民用汽车牌照的底色是？',2,'蓝色','白色','蓝色','绿色','黑色'),(18,'火车连续发出两声长鸣，这表示？',4,'火车倒退','火车前进','火车变轨','火车到站','火车倒退'),(19,'人体具有解毒作用的内脏是？',1,'肝','肝','肾','脾','肺'),(20,'以下哪种瓜不能吃？',4,'傻瓜','西瓜','南瓜','冬瓜','傻瓜'),(21,'哪一个月有28天？',4,'每个月','2月','4月','11月','每个月'),(22,'电影《功夫》中，火云邪神最后被什么武功打败？',3,'如来神掌','龟派气功','一阳指','如来神掌','排山倒海'),(23,'坏血症是缺乏什么引起的？',1,'维生素C','维生素C','维生素A','维生素B','维生素D'),(24,'唐太宗叫什么名字？',1,'李世民','李世民','李荣浩','李建成','李连杰'),(25,'《爱拼才会赢》使用的什么方言演唱的？',2,'闽南语','粤语','闽南语','泰语','英语'),(26,'电影《小时代》的导演是谁？',1,'郭敬明','郭敬明','韩寒','赵薇','张艺谋'),(27,'奥运会每几年举办一次？',4,'4年','1年','2年','3年','4年'),(28,'计算机的中央处理器英文缩写是？',2,'CPU','GPU','CPU','ABC','TCP'),(29,'哪种动物最没有方向感？',1,'麋鹿','麋鹿','狗熊','蝙蝠','鳄鱼'),(30,'哪种动物最容易被贴到墙壁上？',3,'海豹','壁虎','蜘蛛','海豹','企鹅'),(31,'开瓶器、剪刀、千斤顶等工具使用的是什么科学原理？',4,'杠杆原理','量子力学','勾股定理','电磁效应','杠杆原理'),(32,'“光年”是什么计量单位？',2,'长度','时间','长度','速度','质量'),(33,'下列哪首歌曲不是周杰伦所唱？',1,'《江南》','《江南》','《发如雪》','《青花瓷》','《龙卷风》'),(34,'六弦琴是什么乐器的别称？',1,'吉他','吉他','大提琴','小提琴','手风琴'),(35,'什么鸟可以倒着飞？',4,'蜂鸟','老鹰','大雁','信鸽','蜂鸟'),(36,'“金婚”是纪念结婚多少周年？',3,'50','30','40','50','60'),(37,'目前“麦当劳”又被人们称为？',2,'金拱门','麦当当','金拱门','银拱门','开封菜'),(38,'格力手机的开机画面是谁？',4,'董明珠','雷军','乔布斯','王大锤','董明珠'),(39,'“哈根达斯”是什么品牌？',1,'冰激凌','冰激凌','巧克力','洗发水','沐浴露'),(40,'根据我国农历，一年当中有多少个节气？',3,'24','23','25','24','26'),(41,'一次性筷子是由哪国人发明的？',2,'岛国','中国','岛国','韩国','新加坡'),(42,'人体最坚硬的部分是？',1,'牙齿','牙齿','指甲','头盖骨','膝盖'),(43,'离婚的最关键因素是什么？',4,'结婚','性格不合','理念不合','生活压力','结婚'),(44,'东北人过节最爱吃的食物是？',4,'饺子','烤鸭','火锅','汤圆','饺子'),(45,'“see you tomorrow”是指火锅中的哪种菜品？',4,'金针菇','平菇','香菇','木耳','金针菇'),(46,'电视剧《花千骨》中，赵丽颖饰演的角色名叫？',3,'花千骨','花十骨','花骨千','花千骨','花万骨'),(47,'电视剧《还珠格格》中紫薇的扮演者是？',4,'林心如','赵薇','尔康','林肺如','林心如'),(48,'电视剧《还珠格格》中小燕子的亲哥哥是谁？',2,'萧剑','尔康','萧剑','五阿哥','容嬷嬷'),(49,'电视剧《还珠格格》中，紫薇的母亲是？',4,'夏雨荷','尔康','夏雷荷','容嬷嬷','夏雨荷'),(50,'“排队上厕所”，打一地名？',3,'伦敦','洛杉矶','广州','伦敦','澳门'),(51,'“一点一横长，一撇到南洋，南洋有个人，只有一寸长”。打一字',1,'府','府','付','夜','光'),(52,'“夕阳下面两颗瓜”，猜一字',2,'冬','动','冬','苳','笗'),(53,'七百减一',2,'皂','旨','皂','白','百'),(54,'《暴走漫画》的女主角叫什么？',3,'尼美','尼玛','你妹','尼美','羊驼'),(55,'1颗绿豆从十楼跳了下去，变成了什么？',1,'红豆','红豆','死绿豆','豆芽','豆腐'),(56,'下列哪种动物的牙齿最黑？',2,'蚂蚁','黑熊','蚂蚁','杜鹃','乌鸦'),(57,'“五个兄弟住一起，名字不同，高低不齐”，猜一物',2,'手指','蛋糕','手指','笔筒','粉笔'),(58,'什么茶不能喝？',3,'警察','红茶','绿茶','警察','冰红茶'),(59,'世界上最大的壁画群坐落在哪里？',3,'敦煌','陕西','广州','敦煌','山东'),(60,'黄石国家公园位于哪个洲',1,'北美洲','北美洲','非洲','亚洲','贵州'),(61,'有一天，螃蟹和蝎子在玩剪刀石头布，请问最后谁会赢？',2,'平局','螃蟹','平局','不知道','蝎子'),(62,'一只狗在非洲走着走着就变成了什么狗？',4,'热狗','非洲狗','黑喂狗','丧家狗','热狗'),(63,'如果1=11,2=22,3=33，……10=1010，那么11=？',2,'1','111','1','11','1111'),(64,'为什么女鬼的眼睛里会有红血丝',4,'经常熬夜','导演安排','故意吓人','天生如此','经常熬夜'),(65,'世界上最大的宫殿是？',2,'故宫','罗浮宫','故宫','白宫','克里姆林宫'),(66,'电影《国产凌凌漆》中，男主角在晚会上唱了张学友的哪首歌？',4,'李香兰','兰花草','兰花香','李兰香','李香兰'),(67,'电影《美人鱼》的男主角是谁扮演的？',2,'邓超','邓超人','邓超','凳超','周星驰'),(68,'动漫《火影忍者》中，谁教给了佐助“千鸟”？',3,'卡卡西','大蛇丸','自来也','卡卡西','宇智波鼬'),(69,'“秽土转生”的最初开创者是谁？',4,'千手扉间','大蛇丸','长门','鸣人','千手扉间'),(70,'宫崎骏哪一部的动画票房最高？',1,'千与千寻','千与千寻','龙猫','风之谷','幽灵公主'),(71,'白开水超过几天后不能喝？',2,'3天','1天','3天','5天','7天'),(72,'元宵节又名？',1,'上元节','上元节','中元节','下元节','除夕'),(73,'下列哪项活动是重阳节的？',3,'登高','划龙舟','吃月饼','登高','发红包'),(74,'什么东西洗不干净',2,'水','脸','水','石头','衣服'),(75,'燃面是哪里的著名小吃？',1,'宜宾','宜宾','湖南','北京','福建'),(76,'贴春联的习俗，大约始于什么朝代',3,'宋朝','清朝','唐朝','宋朝','元朝'),(77,'建党节是几月几号？',1,'7月1号','7月1号','8月1号','9月1号','10月1号'),(78,'护士节是什么时候',2,'5月12','5月13','5月12','7月13','6月12'),(79,'啤酒瓶盖上的锯齿有多少个？',1,'21','21','23','19','不知道'),(80,'海星属于什么动物？',4,'棘皮动物','哺乳动物','腔肠动物','软体动物','棘皮动物'),(81,'被称为“印度硅谷”的地方是？',4,'班加罗尔','中关村','华强北','孟买','班加罗尔'),(82,'被称为“玫瑰之国”的是哪个国家？',1,'保加利亚','保加利亚','巴基斯坦','俄罗斯','英国'),(83,'有一头牛，它的头朝南，那么它的尾巴朝哪里？',2,'下','上','下','南','北'),(84,'刚起床时要做的第一件事是什么？',2,'睁眼','开灯','睁眼','开手机','上厕所'),(85,'别人在什么时候敲门，你绝对不会说“请进”？',4,'在厕所里','在房间里','在教室里','在同学家','在厕所里'),(86,'小明有两个哥哥，大哥叫大毛，二哥叫二毛，那么三弟叫？',3,'小明','三毛','四毛','小明','小毛'),(87,'“旭日东升”，打一字',3,'九','冕','昊','九','尬'),(88,'“一点一横长，一撇到南阳，南阳两棵树，长到鬼身上”，打一字',1,'魔','魔','磨','墨','莫'),(89,'“左一下，右一下，只管早晚，不问春夏”，打一物？',4,'钟摆','秋千','跷跷板','木鱼','钟摆'),(90,'被人们戏称为“死神小学生”的是？',2,'柯南','柯震东','柯南','柯北','柯西'),(91,'哪位明星不能称之为“小鲜肉”？',4,'郭德纲','吴亦凡','杨洋','鹿晗','郭德纲'),(92,'诗人李白被后人誉为？',1,'诗仙','诗仙','高手','才子','诗鬼'),(93,'下面哪一道美食是陕西的？',4,'羊肉泡馍','云吞面','过桥米线','椰子','羊肉泡馍'),(94,'QQ上1个太阳代表用户多少级？',2,'16','14','16','18','20'),(95,'中国南方航空的标志是？',2,'木棉花','牡丹花','木棉花','玫瑰花','紫荆花'),(96,'人体总共有多少块骨头？',3,'206','200','205','206','209'),(97,'人身上面积最大的器官是？',1,'皮肤','皮肤','胃','大脑','大肠'),(98,'以下哪种行为不仅容易导致发胖还危害身体健康？',4,'吃宵夜','吃饭','跳舞','游泳','吃宵夜'),(99,'在国外，一年有多少个情人节？',4,'12','1','2','6','12'),(100,'1+2+3+4+5+6+7+8+9=？',1,'45','45','59','100','999'),(101,'哪个手指的指甲长得最快？',1,'中指','中指','无名指','大拇指','食指'),(102,'什么水一个月才能见到一次？',4,'薪水','自来水','热水','海水','薪水'),(103,'日常交流中，人们所说的“修仙”是指？',1,'熬夜通宵','熬夜通宵','修炼内功','突击复习','睡觉'),(104,'现在流行的“小黄车”具体是指',1,'共享单车','共享单车','租赁单车','公交车','地铁'),(105,'《新闻联播》的播出时间是？',2,'晚上7点','凌晨2点','晚上7点','晚上6点','中午2点'),(106,'以下哪个不是国内的三大通讯运营商',3,'长城','电信','移动','长城','联通'),(107,'《桃花源记》的作者是？',2,'陶渊明','李白','陶渊明','金庸','杜甫'),(108,'动漫《海贼王》中，吃了恶魔果实的人会有什么副作用？',3,'不能游泳','不能睡觉','不能吃饭','不能游泳','不能喝水'),(109,'国内的汽车驾驶座位一般都是在？',1,'左边','左边','右边','车顶','后座'),(110,'什么人一年只工作一次？',3,'圣诞老人','警察','司机','圣诞老人','医生'),(111,'什么水果“外面是绿色的，吃进去是红色的，吐出来是黑色的”？',4,'西瓜','荔枝','石榴','龙眼','西瓜'),(112,'“大家都笑话你”，打一城市？',2,'齐齐哈尔','哈尔滨','齐齐哈尔','武汉','济南'),(113,'什么帽子不能戴？',3,'螺丝帽','小红帽','鸭舌帽','螺丝帽','太阳帽'),(114,'“一口咬掉牛尾巴”，打一字？',1,'告','告','击','咬','古'),(115,'孔子是我国著名的什么家？',2,'老人家','化学家','老人家','数学家','天文学家'),(116,'中秋节的农历是？',2,'八月十五','五月初五','八月十五','正月十五','大年初一'),(117,'牛有几个胃？',2,'4','1','4','2','3'),(118,'下列不是低碳能源的是？',2,'石油','风能','石油','核能','太阳能'),(119,'我国的国球是？',1,'乒乓球','乒乓球','羽毛球','篮球','足球'),(120,'霸王洗头水的代言人是？',1,'成龙','成龙','成凤','周迅','章子怡'),(121,'“不惑之年”是指多少岁？',4,'40','30','60','50','40'),(122,'著名高校剑桥大学位于哪个国家？',2,'英国','澳大利亚','英国','荷兰','中国'),(123,'左轮手枪一共可以装多少颗子弹？',2,'6','5','6','8','9'),(124,'下列哪个不属于联合国机构？',3,'国际奥委会','国际法院','安理会','国际奥委会','世界卫生组织'),(125,'“狗吠深巷中，鸡鸣桑树颠”出自？',1,'归园田居','归园田居','桃花源记','滕王阁序','塞下曲'),(126,'印度尼西亚的首都是？',4,'雅加达','马来西亚','圣地亚哥','吉隆坡','雅加达'),(127,'什么车子，寸步难行？',4,'风车','马车','三轮车','汽车','风车'),(128,'一个人上了手术台，会是什么样的状态？',3,'任人宰割','小鹿乱撞','面红耳赤','任人宰割','视死如归'),(129,'有5根蜡烛，吹灭了3根，还剩几根蜡烛',2,'5','2','5','3','1'),(130,'青春痘长在哪里不会让你心烦？',4,'别人脸上','自己脸上','屁股上','手上','别人脸上'),(131,'车在行驶过程中，最先离开地面的轮胎是？',3,'备胎','左前轮','右后轮','备胎','右后轮'),(132,'1+1+1+1+1+1+1+11+1=？',3,'19','9','10','19','11'),(133,'LOL中的雷恩加尔，外号是？',2,'狮子狗','猎人','狮子狗','托儿索','布老虎'),(134,'粤语中的“硬颈”是指？',3,'倔强','强壮','霸气','倔强','墨守成规'),(135,'只对一半。打一字？',2,'叹','分','叹','错','职'),(136,'有火能烧，有水能浇，若是猜尧，智商不高。打一字？',4,'林','尧','妖','烧','林'),(137,'什么线剪不断？',3,'光线','电线','毛线','光线','米线'),(138,'下雪天，小明打开了暖气并且关上门窗，为什么他还是觉得冷？',2,'他在室外','他感冒了','他在室外','暖气坏了','门窗没关好'),(139,'旺仔QQ糖的保质期是？',2,'12个月','9个月','12个月','3个月','6个月'),(140,'两个人在河中溺水，死了的叫死人，活着的叫什么？',2,'救命','活人','救命','苟且偷生','快被淹死的人'),(141,'“太平洋”中间是什么',4,'平','海水','海岛','陆地','平'),(142,'什么车可以免费坐，但是没人愿意坐？',3,'警车','地铁','公交车','警车','出租车'),(143,'“再见了，妈妈！”打一数学名词',4,'分母','分子','坐标','小数点','分母'),(144,'什么水果视力最不好？',3,'芒果','龙眼','荔枝','芒果','西瓜'),(145,'飞机在天上飞的时候，为什么撞不到星星？',2,'星星会闪','飞机有导航','星星会闪','飞机有飞行路线','不知道'),(146,'什么药可以当饭吃？',4,'山药','感冒药','西药','中药','山药'),(147,'小鸟最怕得什么病？',2,'恐高','发烧','恐高','抑郁','失眠'),(148,'一个多次离婚的女人，应该怎么形容她呢？',1,'前功尽弃','前功尽弃','不守妇道','泼辣','好吃懒做'),(149,'什么东西胖的快，瘦的更快？',2,'气球','人','气球','铅笔','盒子'),(150,'世界上使用人数最多的语言是？',1,'汉语','汉语','英语','西班牙语','法语'),(151,'奔驰汽车原产于哪一个国家？',4,'德国','比利时','西班牙','英国','德国'),(152,'美国航天部门简称是？',2,'NASA','FASA','NASA','VISA','ANNA'),(153,'哪座城市的别称为“鹭岛”？',4,'厦门','福建','宁波','上海','厦门'),(154,'我国的卫星发射基地“西昌”位于？',1,'四川','四川','西安','青藏高原','秦皇岛'),(155,'十二生肖中，排行第七的是？',3,'马','龙','兔','马','蛇'),(156,'香港回归祖国的时间是？',1,'1997.7','1997.7','1998.12','1999.1','2000.5'),(157,'“鞠躬尽瘁”的下一句是？',3,'死而后已','无力回天','三顾茅庐','死而后已','视死如归'),(158,'我国有多少个民族自治区？',3,'5','3','4','5','6'),(159,'下列哪个不是“花中四君子”？',4,'荷花','竹','梅花','兰花','荷花'),(160,'“不怕细菌小，有它能看到，化验需要它，科研不可少”打一物品？',3,'显微镜','望远镜','老花镜','显微镜','放大镜'),(161,'联合国常任理事国有几个？',4,'5','1','2','4','5'),(162,'山东六国中，最后被秦灭国的是？',4,'齐国','燕国','赵国','楚国','齐国'),(163,'世界上第一枚邮票“黑便士”是哪个国家发行的',3,'英国','法国','中国','英国','德国'),(164,'我国的“京杭大运河”是什么时期开凿的？',1,'春秋','春秋','隋朝','宋朝','明朝'),(165,'下列项目不是奥运会“五项全能”之一的是？',4,'跳高','跳远','200米','1500米','跳高'),(166,'德州扑克中，“葫芦”是什么意思？',2,'三带二','顺子','三带二','三条','四条'),(167,'“白嫩小宝宝，洗澡吹泡泡，越洗身越小，再洗不见了”打一生活用品？',3,'香皂','洗发水','洗手液','香皂','牙膏'),(168,'“多一半不少，多一横不好”',3,'夕','天','王','夕','灭'),(169,'“小小诸葛亮，稳坐军中帐，摆开八卦阵，单捉飞来将”打一动物？',4,'蜘蛛','贝壳','章鱼','苍蝇','蜘蛛'),(170,'“羊没了呼吸”打一成语？',2,'扬眉吐气','回天乏术','扬眉吐气','亡羊补牢','三羊开泰'),(171,'“正月缺初一”打一字？',1,'肯','肯','芷','止','啃'),(172,'08年北京奥运会的吉祥物是？',3,'福娃','皮卡丘','熊本熊','福娃','伏地魔'),(173,'“铁人三项”是哪一年成为奥运会项目的？',4,'2000','2012','2004','2008','2000'),(174,'裁判最多的的球类竞赛项目是？',1,'羽毛球','羽毛球','兵乓球','篮球','足球'),(175,'有“体操王子”美誉的是？',2,'李宁','李小鹏','李宁','李小龙','李易峰'),(176,'2004年的夏季奥运会是在哪里举行的？',2,'雅典','巴黎','雅典','北京','慕尼黑'),(177,'世界土地面积排行第一的国家是？',2,'俄罗斯','中国','俄罗斯','澳大利亚','加拿大'),(178,'被称为“天下第一关”的是？',1,'山海关','山海关','玉门关','娘子关','潼门关'),(179,'球速最快的球类运动项目是？',1,'羽毛球','羽毛球','棒球','网球','乒乓球'),(180,'咖啡原产地位于？',3,'非洲','欧洲','北美','非洲','亚洲'),(181,'“颜”字有几笔？',3,'15','13','14','15','16'),(182,'联合国总部设立在？',1,'纽约','纽约','北京','伦敦','巴黎'),(183,'悲剧《窦娥冤》的作者是？',3,'关汉卿','李白','陶渊明','关汉卿','鲁迅'),(184,'素有“瓷都”之称的景德镇位于哪个省份？',3,'江西','河北','湖南','江西','广西'),(185,'“桑拿”起源于？',1,'芬兰','芬兰','德国','法国','中国'),(186,'著名喜剧电影艺术家卓别林是哪国人？',3,'英国','墨西哥','加拿大','英国','瑞典'),(187,'我国科举制中，在殿试考取第二名被称为？',4,'榜眼','状元','探花','女婿','榜眼'),(188,'比喻变被动为主动，是“三十六计”中的哪一计？',3,'反客为主','李代桃僵','欲擒故纵','反客为主','声东击西'),(189,'“大白兔奶糖”的产地是？',1,'上海','上海','北京','深圳','广州'),(190,'世界上最大的花卉出口国是？',1,'荷兰','荷兰','哥伦比亚','澳大利亚','墨西哥'),(191,'鱼刺卡住喉咙可以通过喝什么来急救？',4,'白醋','盐水','牛奶','酱油','白醋'),(192,'“鲁”是我国哪个省份的简称？',2,'山东','吉林','山东','河北','四川'),(193,'电脑的粘贴快捷键是？',4,'ctrl+v','ctrl+c','ctrl+d','ctrl+a','ctrl+v'),(194,'目前市面上常见的方便面面饼形状是？',4,'圆形','方形','三角形','椭圆形','圆形'),(195,'什么门关不上？',3,'球门','铁门','车门','球门','木门'),(196,'英文字母A-Z中，第20个字母是？',2,'T','R','T','U','I'),(197,'国家提倡的夏季空调温度是？',3,'26度','24度','25度','26度','27度'),(198,'“低碳经济”是指低能耗，低污染和什么？',4,'低排放','低效率','低标准','低消费','低排放'),(199,'哪个季节的夜晚能看到的星星最多？',2,'夏','春','夏','秋','冬'),(200,'《三国演义》中，诸葛亮的妻子是？',4,'黄月英','貂蝉','关羽','大乔','黄月英'),(201,'《三国演义》的作者是？',4,'罗贯中','施耐庵','金庸','郭沫若','罗贯中');
/*!40000 ALTER TABLE `base_gang_reply_title` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_gang_salary`
--

DROP TABLE IF EXISTS `base_gang_salary`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_gang_salary` (
  `pos` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '职位',
  `ac_min` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活跃度最小值',
  `ac_max` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活跃度最大值',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励内容',
  PRIMARY KEY (`pos`,`ac_min`,`ac_max`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_gang_salary`
--

LOCK TABLES `base_gang_salary` WRITE;
/*!40000 ALTER TABLE `base_gang_salary` DISABLE KEYS */;
INSERT INTO `base_gang_salary` VALUES (1,60,119,'[{2,36020001,15}]'),(1,120,179,'[{2,36020001,20}]'),(1,180,239,'[{2,36020001,25}]'),(1,240,299,'[{2,36020001,30}]'),(1,300,999999,'[{2,36020001,35}]'),(2,60,119,'[{2,36020001,10}]'),(2,120,179,'[{2,36020001,15}]'),(2,180,239,'[{2,36020001,20}]'),(2,240,299,'[{2,36020001,25}]'),(2,300,999999,'[{2,36020001,30}]'),(3,60,119,'[{2,36020001,10}]'),(3,120,179,'[{2,36020001,15}]'),(3,180,239,'[{2,36020001,20}]'),(3,240,299,'[{2,36020001,25}]'),(3,300,999999,'[{2,36020001,30}]'),(4,60,119,'[{2,36020001,5}]'),(4,120,179,'[{2,36020001,10}]'),(4,180,239,'[{2,36020001,15}]'),(4,240,299,'[{2,36020001,20}]'),(4,300,999999,'[{2,36020001,25}]'),(5,60,119,'[{2,36020001,5}]'),(5,120,179,'[{2,36020001,10}]'),(5,180,239,'[{2,36020001,15}]'),(5,240,299,'[{2,36020001,20}]'),(5,300,999999,'[{2,36020001,25}]');
/*!40000 ALTER TABLE `base_gang_salary` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_gang_shop`
--

DROP TABLE IF EXISTS `base_gang_shop`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_gang_shop` (
  `auto_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商品唯一id',
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商品id',
  `cost` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消耗贡献',
  `limit` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '购买上限',
  `building_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商店等级',
  PRIMARY KEY (`auto_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_gang_shop`
--

LOCK TABLES `base_gang_shop` WRITE;
/*!40000 ALTER TABLE `base_gang_shop` DISABLE KEYS */;
INSERT INTO `base_gang_shop` VALUES (1,11020001,6000,15,1),(2,18020001,6000,15,1),(3,14120001,4500,15,1),(4,11020001,6000,20,2),(5,18020001,6000,20,2),(6,14120001,4500,20,2),(7,11020001,6000,25,3),(8,18020001,6000,25,3),(9,14120001,4500,25,3),(10,11020001,6000,30,4),(11,18020001,6000,30,4),(12,14120001,4500,30,4),(13,11020001,6000,35,5),(14,18020001,6000,35,5),(15,14120001,4500,35,5),(16,11020001,6000,40,6),(17,18020001,6000,40,6),(18,14120001,4500,40,6),(19,11020001,6000,45,7),(20,18020001,6000,45,7),(21,14120001,4500,45,7),(22,11020001,6000,50,8),(23,18020001,6000,50,8),(24,14120001,4500,50,8),(25,11020001,6000,55,9),(26,18020001,6000,55,9),(27,14120001,4500,55,9),(28,11020001,6000,60,10),(29,18020001,6000,60,10),(30,14120001,4500,60,10);
/*!40000 ALTER TABLE `base_gang_shop` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_gang_skill`
--

DROP TABLE IF EXISTS `base_gang_skill`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_gang_skill` (
  `skill_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能等级',
  `skill_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能等级',
  `skill_name` varchar(50) NOT NULL DEFAULT '0' COMMENT '技能名字',
  `building_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '建筑等级下限',
  `building_lv_max` int(11) NOT NULL DEFAULT '0' COMMENT '建筑等级上限',
  `guild_lv` int(11) NOT NULL DEFAULT '0' COMMENT '公会等级',
  `role_min_lv` int(11) NOT NULL DEFAULT '0' COMMENT '人物等级下限',
  `role_max_lv` int(11) NOT NULL DEFAULT '0' COMMENT '人物等级上限',
  `attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '属性',
  `cost` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '升级消耗',
  `resource_id` int(11) NOT NULL DEFAULT '0' COMMENT '技能图标',
  `description` varchar(50) NOT NULL COMMENT '技能效果描述',
  PRIMARY KEY (`skill_id`,`skill_lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_gang_skill`
--

LOCK TABLES `base_gang_skill` WRITE;
/*!40000 ALTER TABLE `base_gang_skill` DISABLE KEYS */;
INSERT INTO `base_gang_skill` VALUES (1000,1,'活力',1,10,1,0,1000,'[{2,250}]',1000,11000001,'生命<color=#4eae1aff>+250</color>'),(1000,2,'活力',1,10,1,0,1000,'[{2,500}]',1150,11000001,'生命<color=#4eae1aff>+500</color>'),(1000,3,'活力',1,10,1,0,1000,'[{2,750}]',1300,11000001,'生命<color=#4eae1aff>+750</color>'),(1000,4,'活力',1,10,1,0,1000,'[{2,1000}]',1450,11000001,'生命<color=#4eae1aff>+1000</color>'),(1000,5,'活力',1,10,1,0,1000,'[{2,1250}]',1600,11000001,'生命<color=#4eae1aff>+1250</color>'),(1000,6,'活力',1,10,1,0,1000,'[{2,1500}]',1750,11000001,'生命<color=#4eae1aff>+1500</color>'),(1000,7,'活力',1,10,1,0,1000,'[{2,1750}]',1900,11000001,'生命<color=#4eae1aff>+1750</color>'),(1000,8,'活力',1,10,1,0,1000,'[{2,2000}]',2050,11000001,'生命<color=#4eae1aff>+2000</color>'),(1000,9,'活力',1,10,1,0,1000,'[{2,2250}]',2200,11000001,'生命<color=#4eae1aff>+2250</color>'),(1000,10,'活力',1,10,1,0,1000,'[{2,2500}]',2350,11000001,'生命<color=#4eae1aff>+2500</color>'),(1000,11,'活力',1,10,1,0,1000,'[{2,2750}]',2500,11000001,'生命<color=#4eae1aff>+2750</color>'),(1000,12,'活力',1,10,1,0,1000,'[{2,3000}]',2650,11000001,'生命<color=#4eae1aff>+3000</color>'),(1000,13,'活力',1,10,1,0,1000,'[{2,3250}]',2800,11000001,'生命<color=#4eae1aff>+3250</color>'),(1000,14,'活力',1,10,1,0,1000,'[{2,3500}]',2950,11000001,'生命<color=#4eae1aff>+3500</color>'),(1000,15,'活力',1,10,1,0,1000,'[{2,3750}]',3100,11000001,'生命<color=#4eae1aff>+3750</color>'),(1000,16,'活力',1,10,1,0,1000,'[{2,4000}]',3250,11000001,'生命<color=#4eae1aff>+4000</color>'),(1000,17,'活力',1,10,1,0,1000,'[{2,4250}]',3400,11000001,'生命<color=#4eae1aff>+4250</color>'),(1000,18,'活力',1,10,1,0,1000,'[{2,4500}]',3550,11000001,'生命<color=#4eae1aff>+4500</color>'),(1000,19,'活力',1,10,1,0,1000,'[{2,4750}]',3700,11000001,'生命<color=#4eae1aff>+4750</color>'),(1000,20,'活力',1,10,1,0,1000,'[{2,5000}]',3850,11000001,'生命<color=#4eae1aff>+5000</color>'),(1000,21,'活力',1,10,1,0,1000,'[{2,5250}]',4000,11000001,'生命<color=#4eae1aff>+5250</color>'),(1000,22,'活力',1,10,1,0,1000,'[{2,5500}]',4150,11000001,'生命<color=#4eae1aff>+5500</color>'),(1000,23,'活力',1,10,1,0,1000,'[{2,5750}]',4300,11000001,'生命<color=#4eae1aff>+5750</color>'),(1000,24,'活力',1,10,1,0,1000,'[{2,6000}]',4450,11000001,'生命<color=#4eae1aff>+6000</color>'),(1000,25,'活力',1,10,1,0,1000,'[{2,6250}]',4600,11000001,'生命<color=#4eae1aff>+6250</color>'),(1000,26,'活力',1,10,1,0,1000,'[{2,6500}]',4750,11000001,'生命<color=#4eae1aff>+6500</color>'),(1000,27,'活力',1,10,1,0,1000,'[{2,6750}]',4900,11000001,'生命<color=#4eae1aff>+6750</color>'),(1000,28,'活力',1,10,1,0,1000,'[{2,7000}]',5050,11000001,'生命<color=#4eae1aff>+7000</color>'),(1000,29,'活力',1,10,1,0,1000,'[{2,7250}]',5200,11000001,'生命<color=#4eae1aff>+7250</color>'),(1000,30,'活力',1,10,1,0,1000,'[{2,7500}]',5350,11000001,'生命<color=#4eae1aff>+7500</color>'),(1000,31,'活力',1,10,1,0,1000,'[{2,7750}]',5500,11000001,'生命<color=#4eae1aff>+7750</color>'),(1000,32,'活力',1,10,1,0,1000,'[{2,8000}]',5650,11000001,'生命<color=#4eae1aff>+8000</color>'),(1000,33,'活力',1,10,1,0,1000,'[{2,8250}]',5800,11000001,'生命<color=#4eae1aff>+8250</color>'),(1000,34,'活力',1,10,1,0,1000,'[{2,8500}]',5950,11000001,'生命<color=#4eae1aff>+8500</color>'),(1000,35,'活力',1,10,1,0,1000,'[{2,8750}]',6100,11000001,'生命<color=#4eae1aff>+8750</color>'),(1000,36,'活力',1,10,1,0,1000,'[{2,9000}]',6250,11000001,'生命<color=#4eae1aff>+9000</color>'),(1000,37,'活力',1,10,1,0,1000,'[{2,9250}]',6400,11000001,'生命<color=#4eae1aff>+9250</color>'),(1000,38,'活力',1,10,1,0,1000,'[{2,9500}]',6550,11000001,'生命<color=#4eae1aff>+9500</color>'),(1000,39,'活力',1,10,1,0,1000,'[{2,9750}]',6700,11000001,'生命<color=#4eae1aff>+9750</color>'),(1000,40,'活力',1,10,1,0,1000,'[{2,10000}]',6850,11000001,'生命<color=#4eae1aff>+10000</color>'),(1000,41,'活力',1,10,1,0,1000,'[{2,10250}]',7000,11000001,'生命<color=#4eae1aff>+10250</color>'),(1000,42,'活力',1,10,1,0,1000,'[{2,10500}]',7150,11000001,'生命<color=#4eae1aff>+10500</color>'),(1000,43,'活力',1,10,1,0,1000,'[{2,10750}]',7300,11000001,'生命<color=#4eae1aff>+10750</color>'),(1000,44,'活力',1,10,1,0,1000,'[{2,11000}]',7450,11000001,'生命<color=#4eae1aff>+11000</color>'),(1000,45,'活力',1,10,1,0,1000,'[{2,11250}]',7600,11000001,'生命<color=#4eae1aff>+11250</color>'),(1000,46,'活力',1,10,1,0,1000,'[{2,11500}]',7750,11000001,'生命<color=#4eae1aff>+11500</color>'),(1000,47,'活力',1,10,1,0,1000,'[{2,11750}]',7900,11000001,'生命<color=#4eae1aff>+11750</color>'),(1000,48,'活力',1,10,1,0,1000,'[{2,12000}]',8050,11000001,'生命<color=#4eae1aff>+12000</color>'),(1000,49,'活力',1,10,1,0,1000,'[{2,12250}]',8200,11000001,'生命<color=#4eae1aff>+12250</color>'),(1000,50,'活力',1,10,1,0,1000,'[{2,12500}]',8350,11000001,'生命<color=#4eae1aff>+12500</color>'),(1000,51,'活力',1,10,2,0,1000,'[{2,12750}]',8500,11000001,'生命<color=#4eae1aff>+12750</color>'),(1000,52,'活力',1,10,2,0,1000,'[{2,13000}]',8650,11000001,'生命<color=#4eae1aff>+13000</color>'),(1000,53,'活力',1,10,2,0,1000,'[{2,13250}]',8800,11000001,'生命<color=#4eae1aff>+13250</color>'),(1000,54,'活力',1,10,2,0,1000,'[{2,13500}]',8950,11000001,'生命<color=#4eae1aff>+13500</color>'),(1000,55,'活力',1,10,2,0,1000,'[{2,13750}]',9100,11000001,'生命<color=#4eae1aff>+13750</color>'),(1000,56,'活力',1,10,2,0,1000,'[{2,14000}]',9250,11000001,'生命<color=#4eae1aff>+14000</color>'),(1000,57,'活力',1,10,2,0,1000,'[{2,14250}]',9400,11000001,'生命<color=#4eae1aff>+14250</color>'),(1000,58,'活力',1,10,2,0,1000,'[{2,14500}]',9550,11000001,'生命<color=#4eae1aff>+14500</color>'),(1000,59,'活力',1,10,2,0,1000,'[{2,14750}]',9700,11000001,'生命<color=#4eae1aff>+14750</color>'),(1000,60,'活力',1,10,2,0,1000,'[{2,15000}]',9850,11000001,'生命<color=#4eae1aff>+15000</color>'),(1000,61,'活力',1,10,2,0,1000,'[{2,15250}]',10000,11000001,'生命<color=#4eae1aff>+15250</color>'),(1000,62,'活力',1,10,2,0,1000,'[{2,15500}]',10150,11000001,'生命<color=#4eae1aff>+15500</color>'),(1000,63,'活力',1,10,2,0,1000,'[{2,15750}]',10300,11000001,'生命<color=#4eae1aff>+15750</color>'),(1000,64,'活力',1,10,2,0,1000,'[{2,16000}]',10450,11000001,'生命<color=#4eae1aff>+16000</color>'),(1000,65,'活力',1,10,2,0,1000,'[{2,16250}]',10600,11000001,'生命<color=#4eae1aff>+16250</color>'),(1000,66,'活力',1,10,2,0,1000,'[{2,16500}]',10750,11000001,'生命<color=#4eae1aff>+16500</color>'),(1000,67,'活力',1,10,2,0,1000,'[{2,16750}]',10900,11000001,'生命<color=#4eae1aff>+16750</color>'),(1000,68,'活力',1,10,2,0,1000,'[{2,17000}]',11050,11000001,'生命<color=#4eae1aff>+17000</color>'),(1000,69,'活力',1,10,2,0,1000,'[{2,17250}]',11200,11000001,'生命<color=#4eae1aff>+17250</color>'),(1000,70,'活力',1,10,2,0,1000,'[{2,17500}]',11350,11000001,'生命<color=#4eae1aff>+17500</color>'),(1000,71,'活力',1,10,2,0,1000,'[{2,17750}]',11500,11000001,'生命<color=#4eae1aff>+17750</color>'),(1000,72,'活力',1,10,2,0,1000,'[{2,18000}]',11650,11000001,'生命<color=#4eae1aff>+18000</color>'),(1000,73,'活力',1,10,2,0,1000,'[{2,18250}]',11800,11000001,'生命<color=#4eae1aff>+18250</color>'),(1000,74,'活力',1,10,2,0,1000,'[{2,18500}]',11950,11000001,'生命<color=#4eae1aff>+18500</color>'),(1000,75,'活力',1,10,2,0,1000,'[{2,18750}]',12100,11000001,'生命<color=#4eae1aff>+18750</color>'),(1000,76,'活力',1,10,2,0,1000,'[{2,19000}]',12250,11000001,'生命<color=#4eae1aff>+19000</color>'),(1000,77,'活力',1,10,2,0,1000,'[{2,19250}]',12400,11000001,'生命<color=#4eae1aff>+19250</color>'),(1000,78,'活力',1,10,2,0,1000,'[{2,19500}]',12550,11000001,'生命<color=#4eae1aff>+19500</color>'),(1000,79,'活力',1,10,2,0,1000,'[{2,19750}]',12700,11000001,'生命<color=#4eae1aff>+19750</color>'),(1000,80,'活力',1,10,2,0,1000,'[{2,20000}]',12850,11000001,'生命<color=#4eae1aff>+20000</color>'),(1000,81,'活力',1,10,2,0,1000,'[{2,20250}]',13000,11000001,'生命<color=#4eae1aff>+20250</color>'),(1000,82,'活力',1,10,2,0,1000,'[{2,20500}]',13150,11000001,'生命<color=#4eae1aff>+20500</color>'),(1000,83,'活力',1,10,2,0,1000,'[{2,20750}]',13300,11000001,'生命<color=#4eae1aff>+20750</color>'),(1000,84,'活力',1,10,2,0,1000,'[{2,21000}]',13450,11000001,'生命<color=#4eae1aff>+21000</color>'),(1000,85,'活力',1,10,2,0,1000,'[{2,21250}]',13600,11000001,'生命<color=#4eae1aff>+21250</color>'),(1000,86,'活力',1,10,2,0,1000,'[{2,21500}]',13750,11000001,'生命<color=#4eae1aff>+21500</color>'),(1000,87,'活力',1,10,2,0,1000,'[{2,21750}]',13900,11000001,'生命<color=#4eae1aff>+21750</color>'),(1000,88,'活力',1,10,2,0,1000,'[{2,22000}]',14050,11000001,'生命<color=#4eae1aff>+22000</color>'),(1000,89,'活力',1,10,2,0,1000,'[{2,22250}]',14200,11000001,'生命<color=#4eae1aff>+22250</color>'),(1000,90,'活力',1,10,2,0,1000,'[{2,22500}]',14350,11000001,'生命<color=#4eae1aff>+22500</color>'),(1000,91,'活力',1,10,2,0,1000,'[{2,22750}]',14500,11000001,'生命<color=#4eae1aff>+22750</color>'),(1000,92,'活力',1,10,2,0,1000,'[{2,23000}]',14650,11000001,'生命<color=#4eae1aff>+23000</color>'),(1000,93,'活力',1,10,2,0,1000,'[{2,23250}]',14800,11000001,'生命<color=#4eae1aff>+23250</color>'),(1000,94,'活力',1,10,2,0,1000,'[{2,23500}]',14950,11000001,'生命<color=#4eae1aff>+23500</color>'),(1000,95,'活力',1,10,2,0,1000,'[{2,23750}]',15100,11000001,'生命<color=#4eae1aff>+23750</color>'),(1000,96,'活力',1,10,2,0,1000,'[{2,24000}]',15250,11000001,'生命<color=#4eae1aff>+24000</color>'),(1000,97,'活力',1,10,2,0,1000,'[{2,24250}]',15400,11000001,'生命<color=#4eae1aff>+24250</color>'),(1000,98,'活力',1,10,2,0,1000,'[{2,24500}]',15550,11000001,'生命<color=#4eae1aff>+24500</color>'),(1000,99,'活力',1,10,2,0,1000,'[{2,24750}]',15700,11000001,'生命<color=#4eae1aff>+24750</color>'),(1000,100,'活力',1,10,2,0,1000,'[{2,25000}]',15850,11000001,'生命<color=#4eae1aff>+25000</color>'),(1000,101,'活力',1,10,3,0,1000,'[{2,25250}]',16000,11000001,'生命<color=#4eae1aff>+25250</color>'),(1000,102,'活力',1,10,3,0,1000,'[{2,25500}]',16150,11000001,'生命<color=#4eae1aff>+25500</color>'),(1000,103,'活力',1,10,3,0,1000,'[{2,25750}]',16300,11000001,'生命<color=#4eae1aff>+25750</color>'),(1000,104,'活力',1,10,3,0,1000,'[{2,26000}]',16450,11000001,'生命<color=#4eae1aff>+26000</color>'),(1000,105,'活力',1,10,3,0,1000,'[{2,26250}]',16600,11000001,'生命<color=#4eae1aff>+26250</color>'),(1000,106,'活力',1,10,3,0,1000,'[{2,26500}]',16750,11000001,'生命<color=#4eae1aff>+26500</color>'),(1000,107,'活力',1,10,3,0,1000,'[{2,26750}]',16900,11000001,'生命<color=#4eae1aff>+26750</color>'),(1000,108,'活力',1,10,3,0,1000,'[{2,27000}]',17050,11000001,'生命<color=#4eae1aff>+27000</color>'),(1000,109,'活力',1,10,3,0,1000,'[{2,27250}]',17200,11000001,'生命<color=#4eae1aff>+27250</color>'),(1000,110,'活力',1,10,3,0,1000,'[{2,27500}]',17350,11000001,'生命<color=#4eae1aff>+27500</color>'),(1000,111,'活力',1,10,3,0,1000,'[{2,27750}]',17500,11000001,'生命<color=#4eae1aff>+27750</color>'),(1000,112,'活力',1,10,3,0,1000,'[{2,28000}]',17650,11000001,'生命<color=#4eae1aff>+28000</color>'),(1000,113,'活力',1,10,3,0,1000,'[{2,28250}]',17800,11000001,'生命<color=#4eae1aff>+28250</color>'),(1000,114,'活力',1,10,3,0,1000,'[{2,28500}]',17950,11000001,'生命<color=#4eae1aff>+28500</color>'),(1000,115,'活力',1,10,3,0,1000,'[{2,28750}]',18100,11000001,'生命<color=#4eae1aff>+28750</color>'),(1000,116,'活力',1,10,3,0,1000,'[{2,29000}]',18250,11000001,'生命<color=#4eae1aff>+29000</color>'),(1000,117,'活力',1,10,3,0,1000,'[{2,29250}]',18400,11000001,'生命<color=#4eae1aff>+29250</color>'),(1000,118,'活力',1,10,3,0,1000,'[{2,29500}]',18550,11000001,'生命<color=#4eae1aff>+29500</color>'),(1000,119,'活力',1,10,3,0,1000,'[{2,29750}]',18700,11000001,'生命<color=#4eae1aff>+29750</color>'),(1000,120,'活力',1,10,3,0,1000,'[{2,30000}]',18850,11000001,'生命<color=#4eae1aff>+30000</color>'),(1000,121,'活力',1,10,3,0,1000,'[{2,30250}]',19000,11000001,'生命<color=#4eae1aff>+30250</color>'),(1000,122,'活力',1,10,3,0,1000,'[{2,30500}]',19150,11000001,'生命<color=#4eae1aff>+30500</color>'),(1000,123,'活力',1,10,3,0,1000,'[{2,30750}]',19300,11000001,'生命<color=#4eae1aff>+30750</color>'),(1000,124,'活力',1,10,3,0,1000,'[{2,31000}]',19450,11000001,'生命<color=#4eae1aff>+31000</color>'),(1000,125,'活力',1,10,3,0,1000,'[{2,31250}]',19600,11000001,'生命<color=#4eae1aff>+31250</color>'),(1000,126,'活力',1,10,3,0,1000,'[{2,31500}]',19750,11000001,'生命<color=#4eae1aff>+31500</color>'),(1000,127,'活力',1,10,3,0,1000,'[{2,31750}]',19900,11000001,'生命<color=#4eae1aff>+31750</color>'),(1000,128,'活力',1,10,3,0,1000,'[{2,32000}]',20050,11000001,'生命<color=#4eae1aff>+32000</color>'),(1000,129,'活力',1,10,3,0,1000,'[{2,32250}]',20200,11000001,'生命<color=#4eae1aff>+32250</color>'),(1000,130,'活力',1,10,3,0,1000,'[{2,32500}]',20350,11000001,'生命<color=#4eae1aff>+32500</color>'),(1000,131,'活力',1,10,3,0,1000,'[{2,32750}]',20500,11000001,'生命<color=#4eae1aff>+32750</color>'),(1000,132,'活力',1,10,3,0,1000,'[{2,33000}]',20650,11000001,'生命<color=#4eae1aff>+33000</color>'),(1000,133,'活力',1,10,3,0,1000,'[{2,33250}]',20800,11000001,'生命<color=#4eae1aff>+33250</color>'),(1000,134,'活力',1,10,3,0,1000,'[{2,33500}]',20950,11000001,'生命<color=#4eae1aff>+33500</color>'),(1000,135,'活力',1,10,3,0,1000,'[{2,33750}]',21100,11000001,'生命<color=#4eae1aff>+33750</color>'),(1000,136,'活力',1,10,3,0,1000,'[{2,34000}]',21250,11000001,'生命<color=#4eae1aff>+34000</color>'),(1000,137,'活力',1,10,3,0,1000,'[{2,34250}]',21400,11000001,'生命<color=#4eae1aff>+34250</color>'),(1000,138,'活力',1,10,3,0,1000,'[{2,34500}]',21550,11000001,'生命<color=#4eae1aff>+34500</color>'),(1000,139,'活力',1,10,3,0,1000,'[{2,34750}]',21700,11000001,'生命<color=#4eae1aff>+34750</color>'),(1000,140,'活力',1,10,3,0,1000,'[{2,35000}]',21850,11000001,'生命<color=#4eae1aff>+35000</color>'),(1000,141,'活力',1,10,3,0,1000,'[{2,35250}]',22000,11000001,'生命<color=#4eae1aff>+35250</color>'),(1000,142,'活力',1,10,3,0,1000,'[{2,35500}]',22150,11000001,'生命<color=#4eae1aff>+35500</color>'),(1000,143,'活力',1,10,3,0,1000,'[{2,35750}]',22300,11000001,'生命<color=#4eae1aff>+35750</color>'),(1000,144,'活力',1,10,3,0,1000,'[{2,36000}]',22450,11000001,'生命<color=#4eae1aff>+36000</color>'),(1000,145,'活力',1,10,3,0,1000,'[{2,36250}]',22600,11000001,'生命<color=#4eae1aff>+36250</color>'),(1000,146,'活力',1,10,3,0,1000,'[{2,36500}]',22750,11000001,'生命<color=#4eae1aff>+36500</color>'),(1000,147,'活力',1,10,3,0,1000,'[{2,36750}]',22900,11000001,'生命<color=#4eae1aff>+36750</color>'),(1000,148,'活力',1,10,3,0,1000,'[{2,37000}]',23050,11000001,'生命<color=#4eae1aff>+37000</color>'),(1000,149,'活力',1,10,3,0,1000,'[{2,37250}]',23200,11000001,'生命<color=#4eae1aff>+37250</color>'),(1000,150,'活力',1,10,3,0,1000,'[{2,37500}]',23350,11000001,'生命<color=#4eae1aff>+37500</color>'),(1000,151,'活力',1,10,4,0,1000,'[{2,37750}]',23500,11000001,'生命<color=#4eae1aff>+37750</color>'),(1000,152,'活力',1,10,4,0,1000,'[{2,38000}]',23650,11000001,'生命<color=#4eae1aff>+38000</color>'),(1000,153,'活力',1,10,4,0,1000,'[{2,38250}]',23800,11000001,'生命<color=#4eae1aff>+38250</color>'),(1000,154,'活力',1,10,4,0,1000,'[{2,38500}]',23950,11000001,'生命<color=#4eae1aff>+38500</color>'),(1000,155,'活力',1,10,4,0,1000,'[{2,38750}]',24100,11000001,'生命<color=#4eae1aff>+38750</color>'),(1000,156,'活力',1,10,4,0,1000,'[{2,39000}]',24250,11000001,'生命<color=#4eae1aff>+39000</color>'),(1000,157,'活力',1,10,4,0,1000,'[{2,39250}]',24400,11000001,'生命<color=#4eae1aff>+39250</color>'),(1000,158,'活力',1,10,4,0,1000,'[{2,39500}]',24550,11000001,'生命<color=#4eae1aff>+39500</color>'),(1000,159,'活力',1,10,4,0,1000,'[{2,39750}]',24700,11000001,'生命<color=#4eae1aff>+39750</color>'),(1000,160,'活力',1,10,4,0,1000,'[{2,40000}]',24850,11000001,'生命<color=#4eae1aff>+40000</color>'),(1000,161,'活力',1,10,4,0,1000,'[{2,40250}]',25000,11000001,'生命<color=#4eae1aff>+40250</color>'),(1000,162,'活力',1,10,4,0,1000,'[{2,40500}]',25150,11000001,'生命<color=#4eae1aff>+40500</color>'),(1000,163,'活力',1,10,4,0,1000,'[{2,40750}]',25300,11000001,'生命<color=#4eae1aff>+40750</color>'),(1000,164,'活力',1,10,4,0,1000,'[{2,41000}]',25450,11000001,'生命<color=#4eae1aff>+41000</color>'),(1000,165,'活力',1,10,4,0,1000,'[{2,41250}]',25600,11000001,'生命<color=#4eae1aff>+41250</color>'),(1000,166,'活力',1,10,4,0,1000,'[{2,41500}]',25750,11000001,'生命<color=#4eae1aff>+41500</color>'),(1000,167,'活力',1,10,4,0,1000,'[{2,41750}]',25900,11000001,'生命<color=#4eae1aff>+41750</color>'),(1000,168,'活力',1,10,4,0,1000,'[{2,42000}]',26050,11000001,'生命<color=#4eae1aff>+42000</color>'),(1000,169,'活力',1,10,4,0,1000,'[{2,42250}]',26200,11000001,'生命<color=#4eae1aff>+42250</color>'),(1000,170,'活力',1,10,4,0,1000,'[{2,42500}]',26350,11000001,'生命<color=#4eae1aff>+42500</color>'),(1000,171,'活力',1,10,4,0,1000,'[{2,42750}]',26500,11000001,'生命<color=#4eae1aff>+42750</color>'),(1000,172,'活力',1,10,4,0,1000,'[{2,43000}]',26650,11000001,'生命<color=#4eae1aff>+43000</color>'),(1000,173,'活力',1,10,4,0,1000,'[{2,43250}]',26800,11000001,'生命<color=#4eae1aff>+43250</color>'),(1000,174,'活力',1,10,4,0,1000,'[{2,43500}]',26950,11000001,'生命<color=#4eae1aff>+43500</color>'),(1000,175,'活力',1,10,4,0,1000,'[{2,43750}]',27100,11000001,'生命<color=#4eae1aff>+43750</color>'),(1000,176,'活力',1,10,4,0,1000,'[{2,44000}]',27250,11000001,'生命<color=#4eae1aff>+44000</color>'),(1000,177,'活力',1,10,4,0,1000,'[{2,44250}]',27400,11000001,'生命<color=#4eae1aff>+44250</color>'),(1000,178,'活力',1,10,4,0,1000,'[{2,44500}]',27550,11000001,'生命<color=#4eae1aff>+44500</color>'),(1000,179,'活力',1,10,4,0,1000,'[{2,44750}]',27700,11000001,'生命<color=#4eae1aff>+44750</color>'),(1000,180,'活力',1,10,4,0,1000,'[{2,45000}]',27850,11000001,'生命<color=#4eae1aff>+45000</color>'),(1000,181,'活力',1,10,4,0,1000,'[{2,45250}]',28000,11000001,'生命<color=#4eae1aff>+45250</color>'),(1000,182,'活力',1,10,4,0,1000,'[{2,45500}]',28150,11000001,'生命<color=#4eae1aff>+45500</color>'),(1000,183,'活力',1,10,4,0,1000,'[{2,45750}]',28300,11000001,'生命<color=#4eae1aff>+45750</color>'),(1000,184,'活力',1,10,4,0,1000,'[{2,46000}]',28450,11000001,'生命<color=#4eae1aff>+46000</color>'),(1000,185,'活力',1,10,4,0,1000,'[{2,46250}]',28600,11000001,'生命<color=#4eae1aff>+46250</color>'),(1000,186,'活力',1,10,4,0,1000,'[{2,46500}]',28750,11000001,'生命<color=#4eae1aff>+46500</color>'),(1000,187,'活力',1,10,4,0,1000,'[{2,46750}]',28900,11000001,'生命<color=#4eae1aff>+46750</color>'),(1000,188,'活力',1,10,4,0,1000,'[{2,47000}]',29050,11000001,'生命<color=#4eae1aff>+47000</color>'),(1000,189,'活力',1,10,4,0,1000,'[{2,47250}]',29200,11000001,'生命<color=#4eae1aff>+47250</color>'),(1000,190,'活力',1,10,4,0,1000,'[{2,47500}]',29350,11000001,'生命<color=#4eae1aff>+47500</color>'),(1000,191,'活力',1,10,4,0,1000,'[{2,47750}]',29500,11000001,'生命<color=#4eae1aff>+47750</color>'),(1000,192,'活力',1,10,4,0,1000,'[{2,48000}]',29650,11000001,'生命<color=#4eae1aff>+48000</color>'),(1000,193,'活力',1,10,4,0,1000,'[{2,48250}]',29800,11000001,'生命<color=#4eae1aff>+48250</color>'),(1000,194,'活力',1,10,4,0,1000,'[{2,48500}]',29950,11000001,'生命<color=#4eae1aff>+48500</color>'),(1000,195,'活力',1,10,4,0,1000,'[{2,48750}]',30100,11000001,'生命<color=#4eae1aff>+48750</color>'),(1000,196,'活力',1,10,4,0,1000,'[{2,49000}]',30250,11000001,'生命<color=#4eae1aff>+49000</color>'),(1000,197,'活力',1,10,4,0,1000,'[{2,49250}]',30400,11000001,'生命<color=#4eae1aff>+49250</color>'),(1000,198,'活力',1,10,4,0,1000,'[{2,49500}]',30550,11000001,'生命<color=#4eae1aff>+49500</color>'),(1000,199,'活力',1,10,4,0,1000,'[{2,49750}]',30700,11000001,'生命<color=#4eae1aff>+49750</color>'),(1000,200,'活力',1,10,4,0,1000,'[{2,50000}]',30850,11000001,'生命<color=#4eae1aff>+50000</color>'),(1000,201,'活力',1,10,5,0,1000,'[{2,50250}]',31000,11000001,'生命<color=#4eae1aff>+50250</color>'),(1000,202,'活力',1,10,5,0,1000,'[{2,50500}]',31150,11000001,'生命<color=#4eae1aff>+50500</color>'),(1000,203,'活力',1,10,5,0,1000,'[{2,50750}]',31300,11000001,'生命<color=#4eae1aff>+50750</color>'),(1000,204,'活力',1,10,5,0,1000,'[{2,51000}]',31450,11000001,'生命<color=#4eae1aff>+51000</color>'),(1000,205,'活力',1,10,5,0,1000,'[{2,51250}]',31600,11000001,'生命<color=#4eae1aff>+51250</color>'),(1000,206,'活力',1,10,5,0,1000,'[{2,51500}]',31750,11000001,'生命<color=#4eae1aff>+51500</color>'),(1000,207,'活力',1,10,5,0,1000,'[{2,51750}]',31900,11000001,'生命<color=#4eae1aff>+51750</color>'),(1000,208,'活力',1,10,5,0,1000,'[{2,52000}]',32050,11000001,'生命<color=#4eae1aff>+52000</color>'),(1000,209,'活力',1,10,5,0,1000,'[{2,52250}]',32200,11000001,'生命<color=#4eae1aff>+52250</color>'),(1000,210,'活力',1,10,5,0,1000,'[{2,52500}]',32350,11000001,'生命<color=#4eae1aff>+52500</color>'),(1000,211,'活力',1,10,5,0,1000,'[{2,52750}]',32500,11000001,'生命<color=#4eae1aff>+52750</color>'),(1000,212,'活力',1,10,5,0,1000,'[{2,53000}]',32650,11000001,'生命<color=#4eae1aff>+53000</color>'),(1000,213,'活力',1,10,5,0,1000,'[{2,53250}]',32800,11000001,'生命<color=#4eae1aff>+53250</color>'),(1000,214,'活力',1,10,5,0,1000,'[{2,53500}]',32950,11000001,'生命<color=#4eae1aff>+53500</color>'),(1000,215,'活力',1,10,5,0,1000,'[{2,53750}]',33100,11000001,'生命<color=#4eae1aff>+53750</color>'),(1000,216,'活力',1,10,5,0,1000,'[{2,54000}]',33250,11000001,'生命<color=#4eae1aff>+54000</color>'),(1000,217,'活力',1,10,5,0,1000,'[{2,54250}]',33400,11000001,'生命<color=#4eae1aff>+54250</color>'),(1000,218,'活力',1,10,5,0,1000,'[{2,54500}]',33550,11000001,'生命<color=#4eae1aff>+54500</color>'),(1000,219,'活力',1,10,5,0,1000,'[{2,54750}]',33700,11000001,'生命<color=#4eae1aff>+54750</color>'),(1000,220,'活力',1,10,5,0,1000,'[{2,55000}]',33850,11000001,'生命<color=#4eae1aff>+55000</color>'),(1000,221,'活力',1,10,5,0,1000,'[{2,55250}]',34000,11000001,'生命<color=#4eae1aff>+55250</color>'),(1000,222,'活力',1,10,5,0,1000,'[{2,55500}]',34150,11000001,'生命<color=#4eae1aff>+55500</color>'),(1000,223,'活力',1,10,5,0,1000,'[{2,55750}]',34300,11000001,'生命<color=#4eae1aff>+55750</color>'),(1000,224,'活力',1,10,5,0,1000,'[{2,56000}]',34450,11000001,'生命<color=#4eae1aff>+56000</color>'),(1000,225,'活力',1,10,5,0,1000,'[{2,56250}]',34600,11000001,'生命<color=#4eae1aff>+56250</color>'),(1000,226,'活力',1,10,5,0,1000,'[{2,56500}]',34750,11000001,'生命<color=#4eae1aff>+56500</color>'),(1000,227,'活力',1,10,5,0,1000,'[{2,56750}]',34900,11000001,'生命<color=#4eae1aff>+56750</color>'),(1000,228,'活力',1,10,5,0,1000,'[{2,57000}]',35050,11000001,'生命<color=#4eae1aff>+57000</color>'),(1000,229,'活力',1,10,5,0,1000,'[{2,57250}]',35200,11000001,'生命<color=#4eae1aff>+57250</color>'),(1000,230,'活力',1,10,5,0,1000,'[{2,57500}]',35350,11000001,'生命<color=#4eae1aff>+57500</color>'),(1000,231,'活力',1,10,5,0,1000,'[{2,57750}]',35500,11000001,'生命<color=#4eae1aff>+57750</color>'),(1000,232,'活力',1,10,5,0,1000,'[{2,58000}]',35650,11000001,'生命<color=#4eae1aff>+58000</color>'),(1000,233,'活力',1,10,5,0,1000,'[{2,58250}]',35800,11000001,'生命<color=#4eae1aff>+58250</color>'),(1000,234,'活力',1,10,5,0,1000,'[{2,58500}]',35950,11000001,'生命<color=#4eae1aff>+58500</color>'),(1000,235,'活力',1,10,5,0,1000,'[{2,58750}]',36100,11000001,'生命<color=#4eae1aff>+58750</color>'),(1000,236,'活力',1,10,5,0,1000,'[{2,59000}]',36250,11000001,'生命<color=#4eae1aff>+59000</color>'),(1000,237,'活力',1,10,5,0,1000,'[{2,59250}]',36400,11000001,'生命<color=#4eae1aff>+59250</color>'),(1000,238,'活力',1,10,5,0,1000,'[{2,59500}]',36550,11000001,'生命<color=#4eae1aff>+59500</color>'),(1000,239,'活力',1,10,5,0,1000,'[{2,59750}]',36700,11000001,'生命<color=#4eae1aff>+59750</color>'),(1000,240,'活力',1,10,5,0,1000,'[{2,60000}]',36850,11000001,'生命<color=#4eae1aff>+60000</color>'),(1000,241,'活力',1,10,5,0,1000,'[{2,60250}]',37000,11000001,'生命<color=#4eae1aff>+60250</color>'),(1000,242,'活力',1,10,5,0,1000,'[{2,60500}]',37150,11000001,'生命<color=#4eae1aff>+60500</color>'),(1000,243,'活力',1,10,5,0,1000,'[{2,60750}]',37300,11000001,'生命<color=#4eae1aff>+60750</color>'),(1000,244,'活力',1,10,5,0,1000,'[{2,61000}]',37450,11000001,'生命<color=#4eae1aff>+61000</color>'),(1000,245,'活力',1,10,5,0,1000,'[{2,61250}]',37600,11000001,'生命<color=#4eae1aff>+61250</color>'),(1000,246,'活力',1,10,5,0,1000,'[{2,61500}]',37750,11000001,'生命<color=#4eae1aff>+61500</color>'),(1000,247,'活力',1,10,5,0,1000,'[{2,61750}]',37900,11000001,'生命<color=#4eae1aff>+61750</color>'),(1000,248,'活力',1,10,5,0,1000,'[{2,62000}]',38050,11000001,'生命<color=#4eae1aff>+62000</color>'),(1000,249,'活力',1,10,5,0,1000,'[{2,62250}]',38200,11000001,'生命<color=#4eae1aff>+62250</color>'),(1000,250,'活力',1,10,5,0,1000,'[{2,62500}]',38350,11000001,'生命<color=#4eae1aff>+62500</color>'),(1000,251,'活力',1,10,6,0,1000,'[{2,62750}]',38500,11000001,'生命<color=#4eae1aff>+62750</color>'),(1000,252,'活力',1,10,6,0,1000,'[{2,63000}]',38650,11000001,'生命<color=#4eae1aff>+63000</color>'),(1000,253,'活力',1,10,6,0,1000,'[{2,63250}]',38800,11000001,'生命<color=#4eae1aff>+63250</color>'),(1000,254,'活力',1,10,6,0,1000,'[{2,63500}]',38950,11000001,'生命<color=#4eae1aff>+63500</color>'),(1000,255,'活力',1,10,6,0,1000,'[{2,63750}]',39100,11000001,'生命<color=#4eae1aff>+63750</color>'),(1000,256,'活力',1,10,6,0,1000,'[{2,64000}]',39250,11000001,'生命<color=#4eae1aff>+64000</color>'),(1000,257,'活力',1,10,6,0,1000,'[{2,64250}]',39400,11000001,'生命<color=#4eae1aff>+64250</color>'),(1000,258,'活力',1,10,6,0,1000,'[{2,64500}]',39550,11000001,'生命<color=#4eae1aff>+64500</color>'),(1000,259,'活力',1,10,6,0,1000,'[{2,64750}]',39700,11000001,'生命<color=#4eae1aff>+64750</color>'),(1000,260,'活力',1,10,6,0,1000,'[{2,65000}]',39850,11000001,'生命<color=#4eae1aff>+65000</color>'),(1000,261,'活力',1,10,6,0,1000,'[{2,65250}]',40000,11000001,'生命<color=#4eae1aff>+65250</color>'),(1000,262,'活力',1,10,6,0,1000,'[{2,65500}]',40150,11000001,'生命<color=#4eae1aff>+65500</color>'),(1000,263,'活力',1,10,6,0,1000,'[{2,65750}]',40300,11000001,'生命<color=#4eae1aff>+65750</color>'),(1000,264,'活力',1,10,6,0,1000,'[{2,66000}]',40450,11000001,'生命<color=#4eae1aff>+66000</color>'),(1000,265,'活力',1,10,6,0,1000,'[{2,66250}]',40600,11000001,'生命<color=#4eae1aff>+66250</color>'),(1000,266,'活力',1,10,6,0,1000,'[{2,66500}]',40750,11000001,'生命<color=#4eae1aff>+66500</color>'),(1000,267,'活力',1,10,6,0,1000,'[{2,66750}]',40900,11000001,'生命<color=#4eae1aff>+66750</color>'),(1000,268,'活力',1,10,6,0,1000,'[{2,67000}]',41050,11000001,'生命<color=#4eae1aff>+67000</color>'),(1000,269,'活力',1,10,6,0,1000,'[{2,67250}]',41200,11000001,'生命<color=#4eae1aff>+67250</color>'),(1000,270,'活力',1,10,6,0,1000,'[{2,67500}]',41350,11000001,'生命<color=#4eae1aff>+67500</color>'),(1000,271,'活力',1,10,6,0,1000,'[{2,67750}]',41500,11000001,'生命<color=#4eae1aff>+67750</color>'),(1000,272,'活力',1,10,6,0,1000,'[{2,68000}]',41650,11000001,'生命<color=#4eae1aff>+68000</color>'),(1000,273,'活力',1,10,6,0,1000,'[{2,68250}]',41800,11000001,'生命<color=#4eae1aff>+68250</color>'),(1000,274,'活力',1,10,6,0,1000,'[{2,68500}]',41950,11000001,'生命<color=#4eae1aff>+68500</color>'),(1000,275,'活力',1,10,6,0,1000,'[{2,68750}]',42100,11000001,'生命<color=#4eae1aff>+68750</color>'),(1000,276,'活力',1,10,6,0,1000,'[{2,69000}]',42250,11000001,'生命<color=#4eae1aff>+69000</color>'),(1000,277,'活力',1,10,6,0,1000,'[{2,69250}]',42400,11000001,'生命<color=#4eae1aff>+69250</color>'),(1000,278,'活力',1,10,6,0,1000,'[{2,69500}]',42550,11000001,'生命<color=#4eae1aff>+69500</color>'),(1000,279,'活力',1,10,6,0,1000,'[{2,69750}]',42700,11000001,'生命<color=#4eae1aff>+69750</color>'),(1000,280,'活力',1,10,6,0,1000,'[{2,70000}]',42850,11000001,'生命<color=#4eae1aff>+70000</color>'),(1000,281,'活力',1,10,6,0,1000,'[{2,70250}]',43000,11000001,'生命<color=#4eae1aff>+70250</color>'),(1000,282,'活力',1,10,6,0,1000,'[{2,70500}]',43150,11000001,'生命<color=#4eae1aff>+70500</color>'),(1000,283,'活力',1,10,6,0,1000,'[{2,70750}]',43300,11000001,'生命<color=#4eae1aff>+70750</color>'),(1000,284,'活力',1,10,6,0,1000,'[{2,71000}]',43450,11000001,'生命<color=#4eae1aff>+71000</color>'),(1000,285,'活力',1,10,6,0,1000,'[{2,71250}]',43600,11000001,'生命<color=#4eae1aff>+71250</color>'),(1000,286,'活力',1,10,6,0,1000,'[{2,71500}]',43750,11000001,'生命<color=#4eae1aff>+71500</color>'),(1000,287,'活力',1,10,6,0,1000,'[{2,71750}]',43900,11000001,'生命<color=#4eae1aff>+71750</color>'),(1000,288,'活力',1,10,6,0,1000,'[{2,72000}]',44050,11000001,'生命<color=#4eae1aff>+72000</color>'),(1000,289,'活力',1,10,6,0,1000,'[{2,72250}]',44200,11000001,'生命<color=#4eae1aff>+72250</color>'),(1000,290,'活力',1,10,6,0,1000,'[{2,72500}]',44350,11000001,'生命<color=#4eae1aff>+72500</color>'),(1000,291,'活力',1,10,6,0,1000,'[{2,72750}]',44500,11000001,'生命<color=#4eae1aff>+72750</color>'),(1000,292,'活力',1,10,6,0,1000,'[{2,73000}]',44650,11000001,'生命<color=#4eae1aff>+73000</color>'),(1000,293,'活力',1,10,6,0,1000,'[{2,73250}]',44800,11000001,'生命<color=#4eae1aff>+73250</color>'),(1000,294,'活力',1,10,6,0,1000,'[{2,73500}]',44950,11000001,'生命<color=#4eae1aff>+73500</color>'),(1000,295,'活力',1,10,6,0,1000,'[{2,73750}]',45100,11000001,'生命<color=#4eae1aff>+73750</color>'),(1000,296,'活力',1,10,6,0,1000,'[{2,74000}]',45250,11000001,'生命<color=#4eae1aff>+74000</color>'),(1000,297,'活力',1,10,6,0,1000,'[{2,74250}]',45400,11000001,'生命<color=#4eae1aff>+74250</color>'),(1000,298,'活力',1,10,6,0,1000,'[{2,74500}]',45550,11000001,'生命<color=#4eae1aff>+74500</color>'),(1000,299,'活力',1,10,6,0,1000,'[{2,74750}]',45700,11000001,'生命<color=#4eae1aff>+74750</color>'),(1000,300,'活力',1,10,6,0,1000,'[{2,75000}]',45850,11000001,'生命<color=#4eae1aff>+75000</color>'),(1000,301,'活力',1,10,7,0,1000,'[{2,75250}]',46000,11000001,'生命<color=#4eae1aff>+75250</color>'),(1000,302,'活力',1,10,7,0,1000,'[{2,75500}]',46150,11000001,'生命<color=#4eae1aff>+75500</color>'),(1000,303,'活力',1,10,7,0,1000,'[{2,75750}]',46300,11000001,'生命<color=#4eae1aff>+75750</color>'),(1000,304,'活力',1,10,7,0,1000,'[{2,76000}]',46450,11000001,'生命<color=#4eae1aff>+76000</color>'),(1000,305,'活力',1,10,7,0,1000,'[{2,76250}]',46600,11000001,'生命<color=#4eae1aff>+76250</color>'),(1000,306,'活力',1,10,7,0,1000,'[{2,76500}]',46750,11000001,'生命<color=#4eae1aff>+76500</color>'),(1000,307,'活力',1,10,7,0,1000,'[{2,76750}]',46900,11000001,'生命<color=#4eae1aff>+76750</color>'),(1000,308,'活力',1,10,7,0,1000,'[{2,77000}]',47050,11000001,'生命<color=#4eae1aff>+77000</color>'),(1000,309,'活力',1,10,7,0,1000,'[{2,77250}]',47200,11000001,'生命<color=#4eae1aff>+77250</color>'),(1000,310,'活力',1,10,7,0,1000,'[{2,77500}]',47350,11000001,'生命<color=#4eae1aff>+77500</color>'),(1000,311,'活力',1,10,7,0,1000,'[{2,77750}]',47500,11000001,'生命<color=#4eae1aff>+77750</color>'),(1000,312,'活力',1,10,7,0,1000,'[{2,78000}]',47650,11000001,'生命<color=#4eae1aff>+78000</color>'),(1000,313,'活力',1,10,7,0,1000,'[{2,78250}]',47800,11000001,'生命<color=#4eae1aff>+78250</color>'),(1000,314,'活力',1,10,7,0,1000,'[{2,78500}]',47950,11000001,'生命<color=#4eae1aff>+78500</color>'),(1000,315,'活力',1,10,7,0,1000,'[{2,78750}]',48100,11000001,'生命<color=#4eae1aff>+78750</color>'),(1000,316,'活力',1,10,7,0,1000,'[{2,79000}]',48250,11000001,'生命<color=#4eae1aff>+79000</color>'),(1000,317,'活力',1,10,7,0,1000,'[{2,79250}]',48400,11000001,'生命<color=#4eae1aff>+79250</color>'),(1000,318,'活力',1,10,7,0,1000,'[{2,79500}]',48550,11000001,'生命<color=#4eae1aff>+79500</color>'),(1000,319,'活力',1,10,7,0,1000,'[{2,79750}]',48700,11000001,'生命<color=#4eae1aff>+79750</color>'),(1000,320,'活力',1,10,7,0,1000,'[{2,80000}]',48850,11000001,'生命<color=#4eae1aff>+80000</color>'),(1000,321,'活力',1,10,7,0,1000,'[{2,80250}]',49000,11000001,'生命<color=#4eae1aff>+80250</color>'),(1000,322,'活力',1,10,7,0,1000,'[{2,80500}]',49150,11000001,'生命<color=#4eae1aff>+80500</color>'),(1000,323,'活力',1,10,7,0,1000,'[{2,80750}]',49300,11000001,'生命<color=#4eae1aff>+80750</color>'),(1000,324,'活力',1,10,7,0,1000,'[{2,81000}]',49450,11000001,'生命<color=#4eae1aff>+81000</color>'),(1000,325,'活力',1,10,7,0,1000,'[{2,81250}]',49600,11000001,'生命<color=#4eae1aff>+81250</color>'),(1000,326,'活力',1,10,7,0,1000,'[{2,81500}]',49750,11000001,'生命<color=#4eae1aff>+81500</color>'),(1000,327,'活力',1,10,7,0,1000,'[{2,81750}]',49900,11000001,'生命<color=#4eae1aff>+81750</color>'),(1000,328,'活力',1,10,7,0,1000,'[{2,82000}]',50050,11000001,'生命<color=#4eae1aff>+82000</color>'),(1000,329,'活力',1,10,7,0,1000,'[{2,82250}]',50200,11000001,'生命<color=#4eae1aff>+82250</color>'),(1000,330,'活力',1,10,7,0,1000,'[{2,82500}]',50350,11000001,'生命<color=#4eae1aff>+82500</color>'),(1000,331,'活力',1,10,7,0,1000,'[{2,82750}]',50500,11000001,'生命<color=#4eae1aff>+82750</color>'),(1000,332,'活力',1,10,7,0,1000,'[{2,83000}]',50650,11000001,'生命<color=#4eae1aff>+83000</color>'),(1000,333,'活力',1,10,7,0,1000,'[{2,83250}]',50800,11000001,'生命<color=#4eae1aff>+83250</color>'),(1000,334,'活力',1,10,7,0,1000,'[{2,83500}]',50950,11000001,'生命<color=#4eae1aff>+83500</color>'),(1000,335,'活力',1,10,7,0,1000,'[{2,83750}]',51100,11000001,'生命<color=#4eae1aff>+83750</color>'),(1000,336,'活力',1,10,7,0,1000,'[{2,84000}]',51250,11000001,'生命<color=#4eae1aff>+84000</color>'),(1000,337,'活力',1,10,7,0,1000,'[{2,84250}]',51400,11000001,'生命<color=#4eae1aff>+84250</color>'),(1000,338,'活力',1,10,7,0,1000,'[{2,84500}]',51550,11000001,'生命<color=#4eae1aff>+84500</color>'),(1000,339,'活力',1,10,7,0,1000,'[{2,84750}]',51700,11000001,'生命<color=#4eae1aff>+84750</color>'),(1000,340,'活力',1,10,7,0,1000,'[{2,85000}]',51850,11000001,'生命<color=#4eae1aff>+85000</color>'),(1000,341,'活力',1,10,7,0,1000,'[{2,85250}]',52000,11000001,'生命<color=#4eae1aff>+85250</color>'),(1000,342,'活力',1,10,7,0,1000,'[{2,85500}]',52150,11000001,'生命<color=#4eae1aff>+85500</color>'),(1000,343,'活力',1,10,7,0,1000,'[{2,85750}]',52300,11000001,'生命<color=#4eae1aff>+85750</color>'),(1000,344,'活力',1,10,7,0,1000,'[{2,86000}]',52450,11000001,'生命<color=#4eae1aff>+86000</color>'),(1000,345,'活力',1,10,7,0,1000,'[{2,86250}]',52600,11000001,'生命<color=#4eae1aff>+86250</color>'),(1000,346,'活力',1,10,7,0,1000,'[{2,86500}]',52750,11000001,'生命<color=#4eae1aff>+86500</color>'),(1000,347,'活力',1,10,7,0,1000,'[{2,86750}]',52900,11000001,'生命<color=#4eae1aff>+86750</color>'),(1000,348,'活力',1,10,7,0,1000,'[{2,87000}]',53050,11000001,'生命<color=#4eae1aff>+87000</color>'),(1000,349,'活力',1,10,7,0,1000,'[{2,87250}]',53200,11000001,'生命<color=#4eae1aff>+87250</color>'),(1000,350,'活力',1,10,7,0,1000,'[{2,87500}]',53350,11000001,'生命<color=#4eae1aff>+87500</color>'),(1000,351,'活力',1,10,8,0,1000,'[{2,87750}]',53500,11000001,'生命<color=#4eae1aff>+87750</color>'),(1000,352,'活力',1,10,8,0,1000,'[{2,88000}]',53650,11000001,'生命<color=#4eae1aff>+88000</color>'),(1000,353,'活力',1,10,8,0,1000,'[{2,88250}]',53800,11000001,'生命<color=#4eae1aff>+88250</color>'),(1000,354,'活力',1,10,8,0,1000,'[{2,88500}]',53950,11000001,'生命<color=#4eae1aff>+88500</color>'),(1000,355,'活力',1,10,8,0,1000,'[{2,88750}]',54100,11000001,'生命<color=#4eae1aff>+88750</color>'),(1000,356,'活力',1,10,8,0,1000,'[{2,89000}]',54250,11000001,'生命<color=#4eae1aff>+89000</color>'),(1000,357,'活力',1,10,8,0,1000,'[{2,89250}]',54400,11000001,'生命<color=#4eae1aff>+89250</color>'),(1000,358,'活力',1,10,8,0,1000,'[{2,89500}]',54550,11000001,'生命<color=#4eae1aff>+89500</color>'),(1000,359,'活力',1,10,8,0,1000,'[{2,89750}]',54700,11000001,'生命<color=#4eae1aff>+89750</color>'),(1000,360,'活力',1,10,8,0,1000,'[{2,90000}]',54850,11000001,'生命<color=#4eae1aff>+90000</color>'),(1000,361,'活力',1,10,8,0,1000,'[{2,90250}]',55000,11000001,'生命<color=#4eae1aff>+90250</color>'),(1000,362,'活力',1,10,8,0,1000,'[{2,90500}]',55150,11000001,'生命<color=#4eae1aff>+90500</color>'),(1000,363,'活力',1,10,8,0,1000,'[{2,90750}]',55300,11000001,'生命<color=#4eae1aff>+90750</color>'),(1000,364,'活力',1,10,8,0,1000,'[{2,91000}]',55450,11000001,'生命<color=#4eae1aff>+91000</color>'),(1000,365,'活力',1,10,8,0,1000,'[{2,91250}]',55600,11000001,'生命<color=#4eae1aff>+91250</color>'),(1000,366,'活力',1,10,8,0,1000,'[{2,91500}]',55750,11000001,'生命<color=#4eae1aff>+91500</color>'),(1000,367,'活力',1,10,8,0,1000,'[{2,91750}]',55900,11000001,'生命<color=#4eae1aff>+91750</color>'),(1000,368,'活力',1,10,8,0,1000,'[{2,92000}]',56050,11000001,'生命<color=#4eae1aff>+92000</color>'),(1000,369,'活力',1,10,8,0,1000,'[{2,92250}]',56200,11000001,'生命<color=#4eae1aff>+92250</color>'),(1000,370,'活力',1,10,8,0,1000,'[{2,92500}]',56350,11000001,'生命<color=#4eae1aff>+92500</color>'),(1000,371,'活力',1,10,8,0,1000,'[{2,92750}]',56500,11000001,'生命<color=#4eae1aff>+92750</color>'),(1000,372,'活力',1,10,8,0,1000,'[{2,93000}]',56650,11000001,'生命<color=#4eae1aff>+93000</color>'),(1000,373,'活力',1,10,8,0,1000,'[{2,93250}]',56800,11000001,'生命<color=#4eae1aff>+93250</color>'),(1000,374,'活力',1,10,8,0,1000,'[{2,93500}]',56950,11000001,'生命<color=#4eae1aff>+93500</color>'),(1000,375,'活力',1,10,8,0,1000,'[{2,93750}]',57100,11000001,'生命<color=#4eae1aff>+93750</color>'),(1000,376,'活力',1,10,8,0,1000,'[{2,94000}]',57250,11000001,'生命<color=#4eae1aff>+94000</color>'),(1000,377,'活力',1,10,8,0,1000,'[{2,94250}]',57400,11000001,'生命<color=#4eae1aff>+94250</color>'),(1000,378,'活力',1,10,8,0,1000,'[{2,94500}]',57550,11000001,'生命<color=#4eae1aff>+94500</color>'),(1000,379,'活力',1,10,8,0,1000,'[{2,94750}]',57700,11000001,'生命<color=#4eae1aff>+94750</color>'),(1000,380,'活力',1,10,8,0,1000,'[{2,95000}]',57850,11000001,'生命<color=#4eae1aff>+95000</color>'),(1000,381,'活力',1,10,8,0,1000,'[{2,95250}]',58000,11000001,'生命<color=#4eae1aff>+95250</color>'),(1000,382,'活力',1,10,8,0,1000,'[{2,95500}]',58150,11000001,'生命<color=#4eae1aff>+95500</color>'),(1000,383,'活力',1,10,8,0,1000,'[{2,95750}]',58300,11000001,'生命<color=#4eae1aff>+95750</color>'),(1000,384,'活力',1,10,8,0,1000,'[{2,96000}]',58450,11000001,'生命<color=#4eae1aff>+96000</color>'),(1000,385,'活力',1,10,8,0,1000,'[{2,96250}]',58600,11000001,'生命<color=#4eae1aff>+96250</color>'),(1000,386,'活力',1,10,8,0,1000,'[{2,96500}]',58750,11000001,'生命<color=#4eae1aff>+96500</color>'),(1000,387,'活力',1,10,8,0,1000,'[{2,96750}]',58900,11000001,'生命<color=#4eae1aff>+96750</color>'),(1000,388,'活力',1,10,8,0,1000,'[{2,97000}]',59050,11000001,'生命<color=#4eae1aff>+97000</color>'),(1000,389,'活力',1,10,8,0,1000,'[{2,97250}]',59200,11000001,'生命<color=#4eae1aff>+97250</color>'),(1000,390,'活力',1,10,8,0,1000,'[{2,97500}]',59350,11000001,'生命<color=#4eae1aff>+97500</color>'),(1000,391,'活力',1,10,8,0,1000,'[{2,97750}]',59500,11000001,'生命<color=#4eae1aff>+97750</color>'),(1000,392,'活力',1,10,8,0,1000,'[{2,98000}]',59650,11000001,'生命<color=#4eae1aff>+98000</color>'),(1000,393,'活力',1,10,8,0,1000,'[{2,98250}]',59800,11000001,'生命<color=#4eae1aff>+98250</color>'),(1000,394,'活力',1,10,8,0,1000,'[{2,98500}]',59950,11000001,'生命<color=#4eae1aff>+98500</color>'),(1000,395,'活力',1,10,8,0,1000,'[{2,98750}]',60100,11000001,'生命<color=#4eae1aff>+98750</color>'),(1000,396,'活力',1,10,8,0,1000,'[{2,99000}]',60250,11000001,'生命<color=#4eae1aff>+99000</color>'),(1000,397,'活力',1,10,8,0,1000,'[{2,99250}]',60400,11000001,'生命<color=#4eae1aff>+99250</color>'),(1000,398,'活力',1,10,8,0,1000,'[{2,99500}]',60550,11000001,'生命<color=#4eae1aff>+99500</color>'),(1000,399,'活力',1,10,8,0,1000,'[{2,99750}]',60700,11000001,'生命<color=#4eae1aff>+99750</color>'),(1000,400,'活力',1,10,8,0,1000,'[{2,100000}]',60850,11000001,'生命<color=#4eae1aff>+100000</color>'),(1000,401,'活力',1,10,9,0,1000,'[{2,100250}]',61000,11000001,'生命<color=#4eae1aff>+100250</color>'),(1000,402,'活力',1,10,9,0,1000,'[{2,100500}]',61150,11000001,'生命<color=#4eae1aff>+100500</color>'),(1000,403,'活力',1,10,9,0,1000,'[{2,100750}]',61300,11000001,'生命<color=#4eae1aff>+100750</color>'),(1000,404,'活力',1,10,9,0,1000,'[{2,101000}]',61450,11000001,'生命<color=#4eae1aff>+101000</color>'),(1000,405,'活力',1,10,9,0,1000,'[{2,101250}]',61600,11000001,'生命<color=#4eae1aff>+101250</color>'),(1000,406,'活力',1,10,9,0,1000,'[{2,101500}]',61750,11000001,'生命<color=#4eae1aff>+101500</color>'),(1000,407,'活力',1,10,9,0,1000,'[{2,101750}]',61900,11000001,'生命<color=#4eae1aff>+101750</color>'),(1000,408,'活力',1,10,9,0,1000,'[{2,102000}]',62050,11000001,'生命<color=#4eae1aff>+102000</color>'),(1000,409,'活力',1,10,9,0,1000,'[{2,102250}]',62200,11000001,'生命<color=#4eae1aff>+102250</color>'),(1000,410,'活力',1,10,9,0,1000,'[{2,102500}]',62350,11000001,'生命<color=#4eae1aff>+102500</color>'),(1000,411,'活力',1,10,9,0,1000,'[{2,102750}]',62500,11000001,'生命<color=#4eae1aff>+102750</color>'),(1000,412,'活力',1,10,9,0,1000,'[{2,103000}]',62650,11000001,'生命<color=#4eae1aff>+103000</color>'),(1000,413,'活力',1,10,9,0,1000,'[{2,103250}]',62800,11000001,'生命<color=#4eae1aff>+103250</color>'),(1000,414,'活力',1,10,9,0,1000,'[{2,103500}]',62950,11000001,'生命<color=#4eae1aff>+103500</color>'),(1000,415,'活力',1,10,9,0,1000,'[{2,103750}]',63100,11000001,'生命<color=#4eae1aff>+103750</color>'),(1000,416,'活力',1,10,9,0,1000,'[{2,104000}]',63250,11000001,'生命<color=#4eae1aff>+104000</color>'),(1000,417,'活力',1,10,9,0,1000,'[{2,104250}]',63400,11000001,'生命<color=#4eae1aff>+104250</color>'),(1000,418,'活力',1,10,9,0,1000,'[{2,104500}]',63550,11000001,'生命<color=#4eae1aff>+104500</color>'),(1000,419,'活力',1,10,9,0,1000,'[{2,104750}]',63700,11000001,'生命<color=#4eae1aff>+104750</color>'),(1000,420,'活力',1,10,9,0,1000,'[{2,105000}]',63850,11000001,'生命<color=#4eae1aff>+105000</color>'),(1000,421,'活力',1,10,9,0,1000,'[{2,105250}]',64000,11000001,'生命<color=#4eae1aff>+105250</color>'),(1000,422,'活力',1,10,9,0,1000,'[{2,105500}]',64150,11000001,'生命<color=#4eae1aff>+105500</color>'),(1000,423,'活力',1,10,9,0,1000,'[{2,105750}]',64300,11000001,'生命<color=#4eae1aff>+105750</color>'),(1000,424,'活力',1,10,9,0,1000,'[{2,106000}]',64450,11000001,'生命<color=#4eae1aff>+106000</color>'),(1000,425,'活力',1,10,9,0,1000,'[{2,106250}]',64600,11000001,'生命<color=#4eae1aff>+106250</color>'),(1000,426,'活力',1,10,9,0,1000,'[{2,106500}]',64750,11000001,'生命<color=#4eae1aff>+106500</color>'),(1000,427,'活力',1,10,9,0,1000,'[{2,106750}]',64900,11000001,'生命<color=#4eae1aff>+106750</color>'),(1000,428,'活力',1,10,9,0,1000,'[{2,107000}]',65050,11000001,'生命<color=#4eae1aff>+107000</color>'),(1000,429,'活力',1,10,9,0,1000,'[{2,107250}]',65200,11000001,'生命<color=#4eae1aff>+107250</color>'),(1000,430,'活力',1,10,9,0,1000,'[{2,107500}]',65350,11000001,'生命<color=#4eae1aff>+107500</color>'),(1000,431,'活力',1,10,9,0,1000,'[{2,107750}]',65500,11000001,'生命<color=#4eae1aff>+107750</color>'),(1000,432,'活力',1,10,9,0,1000,'[{2,108000}]',65650,11000001,'生命<color=#4eae1aff>+108000</color>'),(1000,433,'活力',1,10,9,0,1000,'[{2,108250}]',65800,11000001,'生命<color=#4eae1aff>+108250</color>'),(1000,434,'活力',1,10,9,0,1000,'[{2,108500}]',65950,11000001,'生命<color=#4eae1aff>+108500</color>'),(1000,435,'活力',1,10,9,0,1000,'[{2,108750}]',66100,11000001,'生命<color=#4eae1aff>+108750</color>'),(1000,436,'活力',1,10,9,0,1000,'[{2,109000}]',66250,11000001,'生命<color=#4eae1aff>+109000</color>'),(1000,437,'活力',1,10,9,0,1000,'[{2,109250}]',66400,11000001,'生命<color=#4eae1aff>+109250</color>'),(1000,438,'活力',1,10,9,0,1000,'[{2,109500}]',66550,11000001,'生命<color=#4eae1aff>+109500</color>'),(1000,439,'活力',1,10,9,0,1000,'[{2,109750}]',66700,11000001,'生命<color=#4eae1aff>+109750</color>'),(1000,440,'活力',1,10,9,0,1000,'[{2,110000}]',66850,11000001,'生命<color=#4eae1aff>+110000</color>'),(1000,441,'活力',1,10,9,0,1000,'[{2,110250}]',67000,11000001,'生命<color=#4eae1aff>+110250</color>'),(1000,442,'活力',1,10,9,0,1000,'[{2,110500}]',67150,11000001,'生命<color=#4eae1aff>+110500</color>'),(1000,443,'活力',1,10,9,0,1000,'[{2,110750}]',67300,11000001,'生命<color=#4eae1aff>+110750</color>'),(1000,444,'活力',1,10,9,0,1000,'[{2,111000}]',67450,11000001,'生命<color=#4eae1aff>+111000</color>'),(1000,445,'活力',1,10,9,0,1000,'[{2,111250}]',67600,11000001,'生命<color=#4eae1aff>+111250</color>'),(1000,446,'活力',1,10,9,0,1000,'[{2,111500}]',67750,11000001,'生命<color=#4eae1aff>+111500</color>'),(1000,447,'活力',1,10,9,0,1000,'[{2,111750}]',67900,11000001,'生命<color=#4eae1aff>+111750</color>'),(1000,448,'活力',1,10,9,0,1000,'[{2,112000}]',68050,11000001,'生命<color=#4eae1aff>+112000</color>'),(1000,449,'活力',1,10,9,0,1000,'[{2,112250}]',68200,11000001,'生命<color=#4eae1aff>+112250</color>'),(1000,450,'活力',1,10,9,0,1000,'[{2,112500}]',68350,11000001,'生命<color=#4eae1aff>+112500</color>'),(1000,451,'活力',1,10,10,0,1000,'[{2,112750}]',68500,11000001,'生命<color=#4eae1aff>+112750</color>'),(1000,452,'活力',1,10,10,0,1000,'[{2,113000}]',68650,11000001,'生命<color=#4eae1aff>+113000</color>'),(1000,453,'活力',1,10,10,0,1000,'[{2,113250}]',68800,11000001,'生命<color=#4eae1aff>+113250</color>'),(1000,454,'活力',1,10,10,0,1000,'[{2,113500}]',68950,11000001,'生命<color=#4eae1aff>+113500</color>'),(1000,455,'活力',1,10,10,0,1000,'[{2,113750}]',69100,11000001,'生命<color=#4eae1aff>+113750</color>'),(1000,456,'活力',1,10,10,0,1000,'[{2,114000}]',69250,11000001,'生命<color=#4eae1aff>+114000</color>'),(1000,457,'活力',1,10,10,0,1000,'[{2,114250}]',69400,11000001,'生命<color=#4eae1aff>+114250</color>'),(1000,458,'活力',1,10,10,0,1000,'[{2,114500}]',69550,11000001,'生命<color=#4eae1aff>+114500</color>'),(1000,459,'活力',1,10,10,0,1000,'[{2,114750}]',69700,11000001,'生命<color=#4eae1aff>+114750</color>'),(1000,460,'活力',1,10,10,0,1000,'[{2,115000}]',69850,11000001,'生命<color=#4eae1aff>+115000</color>'),(1000,461,'活力',1,10,10,0,1000,'[{2,115250}]',70000,11000001,'生命<color=#4eae1aff>+115250</color>'),(1000,462,'活力',1,10,10,0,1000,'[{2,115500}]',70150,11000001,'生命<color=#4eae1aff>+115500</color>'),(1000,463,'活力',1,10,10,0,1000,'[{2,115750}]',70300,11000001,'生命<color=#4eae1aff>+115750</color>'),(1000,464,'活力',1,10,10,0,1000,'[{2,116000}]',70450,11000001,'生命<color=#4eae1aff>+116000</color>'),(1000,465,'活力',1,10,10,0,1000,'[{2,116250}]',70600,11000001,'生命<color=#4eae1aff>+116250</color>'),(1000,466,'活力',1,10,10,0,1000,'[{2,116500}]',70750,11000001,'生命<color=#4eae1aff>+116500</color>'),(1000,467,'活力',1,10,10,0,1000,'[{2,116750}]',70900,11000001,'生命<color=#4eae1aff>+116750</color>'),(1000,468,'活力',1,10,10,0,1000,'[{2,117000}]',71050,11000001,'生命<color=#4eae1aff>+117000</color>'),(1000,469,'活力',1,10,10,0,1000,'[{2,117250}]',71200,11000001,'生命<color=#4eae1aff>+117250</color>'),(1000,470,'活力',1,10,10,0,1000,'[{2,117500}]',71350,11000001,'生命<color=#4eae1aff>+117500</color>'),(1000,471,'活力',1,10,10,0,1000,'[{2,117750}]',71500,11000001,'生命<color=#4eae1aff>+117750</color>'),(1000,472,'活力',1,10,10,0,1000,'[{2,118000}]',71650,11000001,'生命<color=#4eae1aff>+118000</color>'),(1000,473,'活力',1,10,10,0,1000,'[{2,118250}]',71800,11000001,'生命<color=#4eae1aff>+118250</color>'),(1000,474,'活力',1,10,10,0,1000,'[{2,118500}]',71950,11000001,'生命<color=#4eae1aff>+118500</color>'),(1000,475,'活力',1,10,10,0,1000,'[{2,118750}]',72100,11000001,'生命<color=#4eae1aff>+118750</color>'),(1000,476,'活力',1,10,10,0,1000,'[{2,119000}]',72250,11000001,'生命<color=#4eae1aff>+119000</color>'),(1000,477,'活力',1,10,10,0,1000,'[{2,119250}]',72400,11000001,'生命<color=#4eae1aff>+119250</color>'),(1000,478,'活力',1,10,10,0,1000,'[{2,119500}]',72550,11000001,'生命<color=#4eae1aff>+119500</color>'),(1000,479,'活力',1,10,10,0,1000,'[{2,119750}]',72700,11000001,'生命<color=#4eae1aff>+119750</color>'),(1000,480,'活力',1,10,10,0,1000,'[{2,120000}]',72850,11000001,'生命<color=#4eae1aff>+120000</color>'),(1000,481,'活力',1,10,10,0,1000,'[{2,120250}]',73000,11000001,'生命<color=#4eae1aff>+120250</color>'),(1000,482,'活力',1,10,10,0,1000,'[{2,120500}]',73150,11000001,'生命<color=#4eae1aff>+120500</color>'),(1000,483,'活力',1,10,10,0,1000,'[{2,120750}]',73300,11000001,'生命<color=#4eae1aff>+120750</color>'),(1000,484,'活力',1,10,10,0,1000,'[{2,121000}]',73450,11000001,'生命<color=#4eae1aff>+121000</color>'),(1000,485,'活力',1,10,10,0,1000,'[{2,121250}]',73600,11000001,'生命<color=#4eae1aff>+121250</color>'),(1000,486,'活力',1,10,10,0,1000,'[{2,121500}]',73750,11000001,'生命<color=#4eae1aff>+121500</color>'),(1000,487,'活力',1,10,10,0,1000,'[{2,121750}]',73900,11000001,'生命<color=#4eae1aff>+121750</color>'),(1000,488,'活力',1,10,10,0,1000,'[{2,122000}]',74050,11000001,'生命<color=#4eae1aff>+122000</color>'),(1000,489,'活力',1,10,10,0,1000,'[{2,122250}]',74200,11000001,'生命<color=#4eae1aff>+122250</color>'),(1000,490,'活力',1,10,10,0,1000,'[{2,122500}]',74350,11000001,'生命<color=#4eae1aff>+122500</color>'),(1000,491,'活力',1,10,10,0,1000,'[{2,122750}]',74500,11000001,'生命<color=#4eae1aff>+122750</color>'),(1000,492,'活力',1,10,10,0,1000,'[{2,123000}]',74650,11000001,'生命<color=#4eae1aff>+123000</color>'),(1000,493,'活力',1,10,10,0,1000,'[{2,123250}]',74800,11000001,'生命<color=#4eae1aff>+123250</color>'),(1000,494,'活力',1,10,10,0,1000,'[{2,123500}]',74950,11000001,'生命<color=#4eae1aff>+123500</color>'),(1000,495,'活力',1,10,10,0,1000,'[{2,123750}]',75100,11000001,'生命<color=#4eae1aff>+123750</color>'),(1000,496,'活力',1,10,10,0,1000,'[{2,124000}]',75250,11000001,'生命<color=#4eae1aff>+124000</color>'),(1000,497,'活力',1,10,10,0,1000,'[{2,124250}]',75400,11000001,'生命<color=#4eae1aff>+124250</color>'),(1000,498,'活力',1,10,10,0,1000,'[{2,124500}]',75550,11000001,'生命<color=#4eae1aff>+124500</color>'),(1000,499,'活力',1,10,10,0,1000,'[{2,124750}]',75700,11000001,'生命<color=#4eae1aff>+124750</color>'),(1000,500,'活力',1,10,10,0,1000,'[{2,125000}]',75850,11000001,'生命<color=#4eae1aff>+125000</color>'),(2000,1,'强攻',1,10,1,0,1000,'[{1,13}]',1000,11000002,'攻击<color=#4eae1aff>+13</color>'),(2000,2,'强攻',1,10,1,0,1000,'[{1,25}]',1150,11000002,'攻击<color=#4eae1aff>+25</color>'),(2000,3,'强攻',1,10,1,0,1000,'[{1,38}]',1300,11000002,'攻击<color=#4eae1aff>+38</color>'),(2000,4,'强攻',1,10,1,0,1000,'[{1,50}]',1450,11000002,'攻击<color=#4eae1aff>+50</color>'),(2000,5,'强攻',1,10,1,0,1000,'[{1,63}]',1600,11000002,'攻击<color=#4eae1aff>+63</color>'),(2000,6,'强攻',1,10,1,0,1000,'[{1,75}]',1750,11000002,'攻击<color=#4eae1aff>+75</color>'),(2000,7,'强攻',1,10,1,0,1000,'[{1,88}]',1900,11000002,'攻击<color=#4eae1aff>+88</color>'),(2000,8,'强攻',1,10,1,0,1000,'[{1,100}]',2050,11000002,'攻击<color=#4eae1aff>+100</color>'),(2000,9,'强攻',1,10,1,0,1000,'[{1,113}]',2200,11000002,'攻击<color=#4eae1aff>+113</color>'),(2000,10,'强攻',1,10,1,0,1000,'[{1,125}]',2350,11000002,'攻击<color=#4eae1aff>+125</color>'),(2000,11,'强攻',1,10,1,0,1000,'[{1,138}]',2500,11000002,'攻击<color=#4eae1aff>+138</color>'),(2000,12,'强攻',1,10,1,0,1000,'[{1,150}]',2650,11000002,'攻击<color=#4eae1aff>+150</color>'),(2000,13,'强攻',1,10,1,0,1000,'[{1,163}]',2800,11000002,'攻击<color=#4eae1aff>+163</color>'),(2000,14,'强攻',1,10,1,0,1000,'[{1,175}]',2950,11000002,'攻击<color=#4eae1aff>+175</color>'),(2000,15,'强攻',1,10,1,0,1000,'[{1,188}]',3100,11000002,'攻击<color=#4eae1aff>+188</color>'),(2000,16,'强攻',1,10,1,0,1000,'[{1,200}]',3250,11000002,'攻击<color=#4eae1aff>+200</color>'),(2000,17,'强攻',1,10,1,0,1000,'[{1,213}]',3400,11000002,'攻击<color=#4eae1aff>+213</color>'),(2000,18,'强攻',1,10,1,0,1000,'[{1,225}]',3550,11000002,'攻击<color=#4eae1aff>+225</color>'),(2000,19,'强攻',1,10,1,0,1000,'[{1,238}]',3700,11000002,'攻击<color=#4eae1aff>+238</color>'),(2000,20,'强攻',1,10,1,0,1000,'[{1,250}]',3850,11000002,'攻击<color=#4eae1aff>+250</color>'),(2000,21,'强攻',1,10,1,0,1000,'[{1,263}]',4000,11000002,'攻击<color=#4eae1aff>+263</color>'),(2000,22,'强攻',1,10,1,0,1000,'[{1,275}]',4150,11000002,'攻击<color=#4eae1aff>+275</color>'),(2000,23,'强攻',1,10,1,0,1000,'[{1,288}]',4300,11000002,'攻击<color=#4eae1aff>+288</color>'),(2000,24,'强攻',1,10,1,0,1000,'[{1,300}]',4450,11000002,'攻击<color=#4eae1aff>+300</color>'),(2000,25,'强攻',1,10,1,0,1000,'[{1,313}]',4600,11000002,'攻击<color=#4eae1aff>+313</color>'),(2000,26,'强攻',1,10,1,0,1000,'[{1,325}]',4750,11000002,'攻击<color=#4eae1aff>+325</color>'),(2000,27,'强攻',1,10,1,0,1000,'[{1,338}]',4900,11000002,'攻击<color=#4eae1aff>+338</color>'),(2000,28,'强攻',1,10,1,0,1000,'[{1,350}]',5050,11000002,'攻击<color=#4eae1aff>+350</color>'),(2000,29,'强攻',1,10,1,0,1000,'[{1,363}]',5200,11000002,'攻击<color=#4eae1aff>+363</color>'),(2000,30,'强攻',1,10,1,0,1000,'[{1,375}]',5350,11000002,'攻击<color=#4eae1aff>+375</color>'),(2000,31,'强攻',1,10,1,0,1000,'[{1,388}]',5500,11000002,'攻击<color=#4eae1aff>+388</color>'),(2000,32,'强攻',1,10,1,0,1000,'[{1,400}]',5650,11000002,'攻击<color=#4eae1aff>+400</color>'),(2000,33,'强攻',1,10,1,0,1000,'[{1,413}]',5800,11000002,'攻击<color=#4eae1aff>+413</color>'),(2000,34,'强攻',1,10,1,0,1000,'[{1,425}]',5950,11000002,'攻击<color=#4eae1aff>+425</color>'),(2000,35,'强攻',1,10,1,0,1000,'[{1,438}]',6100,11000002,'攻击<color=#4eae1aff>+438</color>'),(2000,36,'强攻',1,10,1,0,1000,'[{1,450}]',6250,11000002,'攻击<color=#4eae1aff>+450</color>'),(2000,37,'强攻',1,10,1,0,1000,'[{1,463}]',6400,11000002,'攻击<color=#4eae1aff>+463</color>'),(2000,38,'强攻',1,10,1,0,1000,'[{1,475}]',6550,11000002,'攻击<color=#4eae1aff>+475</color>'),(2000,39,'强攻',1,10,1,0,1000,'[{1,488}]',6700,11000002,'攻击<color=#4eae1aff>+488</color>'),(2000,40,'强攻',1,10,1,0,1000,'[{1,500}]',6850,11000002,'攻击<color=#4eae1aff>+500</color>'),(2000,41,'强攻',1,10,1,0,1000,'[{1,513}]',7000,11000002,'攻击<color=#4eae1aff>+513</color>'),(2000,42,'强攻',1,10,1,0,1000,'[{1,525}]',7150,11000002,'攻击<color=#4eae1aff>+525</color>'),(2000,43,'强攻',1,10,1,0,1000,'[{1,538}]',7300,11000002,'攻击<color=#4eae1aff>+538</color>'),(2000,44,'强攻',1,10,1,0,1000,'[{1,550}]',7450,11000002,'攻击<color=#4eae1aff>+550</color>'),(2000,45,'强攻',1,10,1,0,1000,'[{1,563}]',7600,11000002,'攻击<color=#4eae1aff>+563</color>'),(2000,46,'强攻',1,10,1,0,1000,'[{1,575}]',7750,11000002,'攻击<color=#4eae1aff>+575</color>'),(2000,47,'强攻',1,10,1,0,1000,'[{1,588}]',7900,11000002,'攻击<color=#4eae1aff>+588</color>'),(2000,48,'强攻',1,10,1,0,1000,'[{1,600}]',8050,11000002,'攻击<color=#4eae1aff>+600</color>'),(2000,49,'强攻',1,10,1,0,1000,'[{1,613}]',8200,11000002,'攻击<color=#4eae1aff>+613</color>'),(2000,50,'强攻',1,10,1,0,1000,'[{1,625}]',8350,11000002,'攻击<color=#4eae1aff>+625</color>'),(2000,51,'强攻',1,10,2,0,1000,'[{1,638}]',8500,11000002,'攻击<color=#4eae1aff>+638</color>'),(2000,52,'强攻',1,10,2,0,1000,'[{1,650}]',8650,11000002,'攻击<color=#4eae1aff>+650</color>'),(2000,53,'强攻',1,10,2,0,1000,'[{1,663}]',8800,11000002,'攻击<color=#4eae1aff>+663</color>'),(2000,54,'强攻',1,10,2,0,1000,'[{1,675}]',8950,11000002,'攻击<color=#4eae1aff>+675</color>'),(2000,55,'强攻',1,10,2,0,1000,'[{1,688}]',9100,11000002,'攻击<color=#4eae1aff>+688</color>'),(2000,56,'强攻',1,10,2,0,1000,'[{1,700}]',9250,11000002,'攻击<color=#4eae1aff>+700</color>'),(2000,57,'强攻',1,10,2,0,1000,'[{1,713}]',9400,11000002,'攻击<color=#4eae1aff>+713</color>'),(2000,58,'强攻',1,10,2,0,1000,'[{1,725}]',9550,11000002,'攻击<color=#4eae1aff>+725</color>'),(2000,59,'强攻',1,10,2,0,1000,'[{1,738}]',9700,11000002,'攻击<color=#4eae1aff>+738</color>'),(2000,60,'强攻',1,10,2,0,1000,'[{1,750}]',9850,11000002,'攻击<color=#4eae1aff>+750</color>'),(2000,61,'强攻',1,10,2,0,1000,'[{1,763}]',10000,11000002,'攻击<color=#4eae1aff>+763</color>'),(2000,62,'强攻',1,10,2,0,1000,'[{1,775}]',10150,11000002,'攻击<color=#4eae1aff>+775</color>'),(2000,63,'强攻',1,10,2,0,1000,'[{1,788}]',10300,11000002,'攻击<color=#4eae1aff>+788</color>'),(2000,64,'强攻',1,10,2,0,1000,'[{1,800}]',10450,11000002,'攻击<color=#4eae1aff>+800</color>'),(2000,65,'强攻',1,10,2,0,1000,'[{1,813}]',10600,11000002,'攻击<color=#4eae1aff>+813</color>'),(2000,66,'强攻',1,10,2,0,1000,'[{1,825}]',10750,11000002,'攻击<color=#4eae1aff>+825</color>'),(2000,67,'强攻',1,10,2,0,1000,'[{1,838}]',10900,11000002,'攻击<color=#4eae1aff>+838</color>'),(2000,68,'强攻',1,10,2,0,1000,'[{1,850}]',11050,11000002,'攻击<color=#4eae1aff>+850</color>'),(2000,69,'强攻',1,10,2,0,1000,'[{1,863}]',11200,11000002,'攻击<color=#4eae1aff>+863</color>'),(2000,70,'强攻',1,10,2,0,1000,'[{1,875}]',11350,11000002,'攻击<color=#4eae1aff>+875</color>'),(2000,71,'强攻',1,10,2,0,1000,'[{1,888}]',11500,11000002,'攻击<color=#4eae1aff>+888</color>'),(2000,72,'强攻',1,10,2,0,1000,'[{1,900}]',11650,11000002,'攻击<color=#4eae1aff>+900</color>'),(2000,73,'强攻',1,10,2,0,1000,'[{1,913}]',11800,11000002,'攻击<color=#4eae1aff>+913</color>'),(2000,74,'强攻',1,10,2,0,1000,'[{1,925}]',11950,11000002,'攻击<color=#4eae1aff>+925</color>'),(2000,75,'强攻',1,10,2,0,1000,'[{1,938}]',12100,11000002,'攻击<color=#4eae1aff>+938</color>'),(2000,76,'强攻',1,10,2,0,1000,'[{1,950}]',12250,11000002,'攻击<color=#4eae1aff>+950</color>'),(2000,77,'强攻',1,10,2,0,1000,'[{1,963}]',12400,11000002,'攻击<color=#4eae1aff>+963</color>'),(2000,78,'强攻',1,10,2,0,1000,'[{1,975}]',12550,11000002,'攻击<color=#4eae1aff>+975</color>'),(2000,79,'强攻',1,10,2,0,1000,'[{1,988}]',12700,11000002,'攻击<color=#4eae1aff>+988</color>'),(2000,80,'强攻',1,10,2,0,1000,'[{1,1000}]',12850,11000002,'攻击<color=#4eae1aff>+1000</color>'),(2000,81,'强攻',1,10,2,0,1000,'[{1,1013}]',13000,11000002,'攻击<color=#4eae1aff>+1013</color>'),(2000,82,'强攻',1,10,2,0,1000,'[{1,1025}]',13150,11000002,'攻击<color=#4eae1aff>+1025</color>'),(2000,83,'强攻',1,10,2,0,1000,'[{1,1038}]',13300,11000002,'攻击<color=#4eae1aff>+1038</color>'),(2000,84,'强攻',1,10,2,0,1000,'[{1,1050}]',13450,11000002,'攻击<color=#4eae1aff>+1050</color>'),(2000,85,'强攻',1,10,2,0,1000,'[{1,1063}]',13600,11000002,'攻击<color=#4eae1aff>+1063</color>'),(2000,86,'强攻',1,10,2,0,1000,'[{1,1075}]',13750,11000002,'攻击<color=#4eae1aff>+1075</color>'),(2000,87,'强攻',1,10,2,0,1000,'[{1,1088}]',13900,11000002,'攻击<color=#4eae1aff>+1088</color>'),(2000,88,'强攻',1,10,2,0,1000,'[{1,1100}]',14050,11000002,'攻击<color=#4eae1aff>+1100</color>'),(2000,89,'强攻',1,10,2,0,1000,'[{1,1113}]',14200,11000002,'攻击<color=#4eae1aff>+1113</color>'),(2000,90,'强攻',1,10,2,0,1000,'[{1,1125}]',14350,11000002,'攻击<color=#4eae1aff>+1125</color>'),(2000,91,'强攻',1,10,2,0,1000,'[{1,1138}]',14500,11000002,'攻击<color=#4eae1aff>+1138</color>'),(2000,92,'强攻',1,10,2,0,1000,'[{1,1150}]',14650,11000002,'攻击<color=#4eae1aff>+1150</color>'),(2000,93,'强攻',1,10,2,0,1000,'[{1,1163}]',14800,11000002,'攻击<color=#4eae1aff>+1163</color>'),(2000,94,'强攻',1,10,2,0,1000,'[{1,1175}]',14950,11000002,'攻击<color=#4eae1aff>+1175</color>'),(2000,95,'强攻',1,10,2,0,1000,'[{1,1188}]',15100,11000002,'攻击<color=#4eae1aff>+1188</color>'),(2000,96,'强攻',1,10,2,0,1000,'[{1,1200}]',15250,11000002,'攻击<color=#4eae1aff>+1200</color>'),(2000,97,'强攻',1,10,2,0,1000,'[{1,1213}]',15400,11000002,'攻击<color=#4eae1aff>+1213</color>'),(2000,98,'强攻',1,10,2,0,1000,'[{1,1225}]',15550,11000002,'攻击<color=#4eae1aff>+1225</color>'),(2000,99,'强攻',1,10,2,0,1000,'[{1,1238}]',15700,11000002,'攻击<color=#4eae1aff>+1238</color>'),(2000,100,'强攻',1,10,2,0,1000,'[{1,1250}]',15850,11000002,'攻击<color=#4eae1aff>+1250</color>'),(2000,101,'强攻',1,10,3,0,1000,'[{1,1263}]',16000,11000002,'攻击<color=#4eae1aff>+1263</color>'),(2000,102,'强攻',1,10,3,0,1000,'[{1,1275}]',16150,11000002,'攻击<color=#4eae1aff>+1275</color>'),(2000,103,'强攻',1,10,3,0,1000,'[{1,1288}]',16300,11000002,'攻击<color=#4eae1aff>+1288</color>'),(2000,104,'强攻',1,10,3,0,1000,'[{1,1300}]',16450,11000002,'攻击<color=#4eae1aff>+1300</color>'),(2000,105,'强攻',1,10,3,0,1000,'[{1,1313}]',16600,11000002,'攻击<color=#4eae1aff>+1313</color>'),(2000,106,'强攻',1,10,3,0,1000,'[{1,1325}]',16750,11000002,'攻击<color=#4eae1aff>+1325</color>'),(2000,107,'强攻',1,10,3,0,1000,'[{1,1338}]',16900,11000002,'攻击<color=#4eae1aff>+1338</color>'),(2000,108,'强攻',1,10,3,0,1000,'[{1,1350}]',17050,11000002,'攻击<color=#4eae1aff>+1350</color>'),(2000,109,'强攻',1,10,3,0,1000,'[{1,1363}]',17200,11000002,'攻击<color=#4eae1aff>+1363</color>'),(2000,110,'强攻',1,10,3,0,1000,'[{1,1375}]',17350,11000002,'攻击<color=#4eae1aff>+1375</color>'),(2000,111,'强攻',1,10,3,0,1000,'[{1,1388}]',17500,11000002,'攻击<color=#4eae1aff>+1388</color>'),(2000,112,'强攻',1,10,3,0,1000,'[{1,1400}]',17650,11000002,'攻击<color=#4eae1aff>+1400</color>'),(2000,113,'强攻',1,10,3,0,1000,'[{1,1413}]',17800,11000002,'攻击<color=#4eae1aff>+1413</color>'),(2000,114,'强攻',1,10,3,0,1000,'[{1,1425}]',17950,11000002,'攻击<color=#4eae1aff>+1425</color>'),(2000,115,'强攻',1,10,3,0,1000,'[{1,1438}]',18100,11000002,'攻击<color=#4eae1aff>+1438</color>'),(2000,116,'强攻',1,10,3,0,1000,'[{1,1450}]',18250,11000002,'攻击<color=#4eae1aff>+1450</color>'),(2000,117,'强攻',1,10,3,0,1000,'[{1,1463}]',18400,11000002,'攻击<color=#4eae1aff>+1463</color>'),(2000,118,'强攻',1,10,3,0,1000,'[{1,1475}]',18550,11000002,'攻击<color=#4eae1aff>+1475</color>'),(2000,119,'强攻',1,10,3,0,1000,'[{1,1488}]',18700,11000002,'攻击<color=#4eae1aff>+1488</color>'),(2000,120,'强攻',1,10,3,0,1000,'[{1,1500}]',18850,11000002,'攻击<color=#4eae1aff>+1500</color>'),(2000,121,'强攻',1,10,3,0,1000,'[{1,1513}]',19000,11000002,'攻击<color=#4eae1aff>+1513</color>'),(2000,122,'强攻',1,10,3,0,1000,'[{1,1525}]',19150,11000002,'攻击<color=#4eae1aff>+1525</color>'),(2000,123,'强攻',1,10,3,0,1000,'[{1,1538}]',19300,11000002,'攻击<color=#4eae1aff>+1538</color>'),(2000,124,'强攻',1,10,3,0,1000,'[{1,1550}]',19450,11000002,'攻击<color=#4eae1aff>+1550</color>'),(2000,125,'强攻',1,10,3,0,1000,'[{1,1563}]',19600,11000002,'攻击<color=#4eae1aff>+1563</color>'),(2000,126,'强攻',1,10,3,0,1000,'[{1,1575}]',19750,11000002,'攻击<color=#4eae1aff>+1575</color>'),(2000,127,'强攻',1,10,3,0,1000,'[{1,1588}]',19900,11000002,'攻击<color=#4eae1aff>+1588</color>'),(2000,128,'强攻',1,10,3,0,1000,'[{1,1600}]',20050,11000002,'攻击<color=#4eae1aff>+1600</color>'),(2000,129,'强攻',1,10,3,0,1000,'[{1,1613}]',20200,11000002,'攻击<color=#4eae1aff>+1613</color>'),(2000,130,'强攻',1,10,3,0,1000,'[{1,1625}]',20350,11000002,'攻击<color=#4eae1aff>+1625</color>'),(2000,131,'强攻',1,10,3,0,1000,'[{1,1638}]',20500,11000002,'攻击<color=#4eae1aff>+1638</color>'),(2000,132,'强攻',1,10,3,0,1000,'[{1,1650}]',20650,11000002,'攻击<color=#4eae1aff>+1650</color>'),(2000,133,'强攻',1,10,3,0,1000,'[{1,1663}]',20800,11000002,'攻击<color=#4eae1aff>+1663</color>'),(2000,134,'强攻',1,10,3,0,1000,'[{1,1675}]',20950,11000002,'攻击<color=#4eae1aff>+1675</color>'),(2000,135,'强攻',1,10,3,0,1000,'[{1,1688}]',21100,11000002,'攻击<color=#4eae1aff>+1688</color>'),(2000,136,'强攻',1,10,3,0,1000,'[{1,1700}]',21250,11000002,'攻击<color=#4eae1aff>+1700</color>'),(2000,137,'强攻',1,10,3,0,1000,'[{1,1713}]',21400,11000002,'攻击<color=#4eae1aff>+1713</color>'),(2000,138,'强攻',1,10,3,0,1000,'[{1,1725}]',21550,11000002,'攻击<color=#4eae1aff>+1725</color>'),(2000,139,'强攻',1,10,3,0,1000,'[{1,1738}]',21700,11000002,'攻击<color=#4eae1aff>+1738</color>'),(2000,140,'强攻',1,10,3,0,1000,'[{1,1750}]',21850,11000002,'攻击<color=#4eae1aff>+1750</color>'),(2000,141,'强攻',1,10,3,0,1000,'[{1,1763}]',22000,11000002,'攻击<color=#4eae1aff>+1763</color>'),(2000,142,'强攻',1,10,3,0,1000,'[{1,1775}]',22150,11000002,'攻击<color=#4eae1aff>+1775</color>'),(2000,143,'强攻',1,10,3,0,1000,'[{1,1788}]',22300,11000002,'攻击<color=#4eae1aff>+1788</color>'),(2000,144,'强攻',1,10,3,0,1000,'[{1,1800}]',22450,11000002,'攻击<color=#4eae1aff>+1800</color>'),(2000,145,'强攻',1,10,3,0,1000,'[{1,1813}]',22600,11000002,'攻击<color=#4eae1aff>+1813</color>'),(2000,146,'强攻',1,10,3,0,1000,'[{1,1825}]',22750,11000002,'攻击<color=#4eae1aff>+1825</color>'),(2000,147,'强攻',1,10,3,0,1000,'[{1,1838}]',22900,11000002,'攻击<color=#4eae1aff>+1838</color>'),(2000,148,'强攻',1,10,3,0,1000,'[{1,1850}]',23050,11000002,'攻击<color=#4eae1aff>+1850</color>'),(2000,149,'强攻',1,10,3,0,1000,'[{1,1863}]',23200,11000002,'攻击<color=#4eae1aff>+1863</color>'),(2000,150,'强攻',1,10,3,0,1000,'[{1,1875}]',23350,11000002,'攻击<color=#4eae1aff>+1875</color>'),(2000,151,'强攻',1,10,4,0,1000,'[{1,1888}]',23500,11000002,'攻击<color=#4eae1aff>+1888</color>'),(2000,152,'强攻',1,10,4,0,1000,'[{1,1900}]',23650,11000002,'攻击<color=#4eae1aff>+1900</color>'),(2000,153,'强攻',1,10,4,0,1000,'[{1,1913}]',23800,11000002,'攻击<color=#4eae1aff>+1913</color>'),(2000,154,'强攻',1,10,4,0,1000,'[{1,1925}]',23950,11000002,'攻击<color=#4eae1aff>+1925</color>'),(2000,155,'强攻',1,10,4,0,1000,'[{1,1938}]',24100,11000002,'攻击<color=#4eae1aff>+1938</color>'),(2000,156,'强攻',1,10,4,0,1000,'[{1,1950}]',24250,11000002,'攻击<color=#4eae1aff>+1950</color>'),(2000,157,'强攻',1,10,4,0,1000,'[{1,1963}]',24400,11000002,'攻击<color=#4eae1aff>+1963</color>'),(2000,158,'强攻',1,10,4,0,1000,'[{1,1975}]',24550,11000002,'攻击<color=#4eae1aff>+1975</color>'),(2000,159,'强攻',1,10,4,0,1000,'[{1,1988}]',24700,11000002,'攻击<color=#4eae1aff>+1988</color>'),(2000,160,'强攻',1,10,4,0,1000,'[{1,2000}]',24850,11000002,'攻击<color=#4eae1aff>+2000</color>'),(2000,161,'强攻',1,10,4,0,1000,'[{1,2013}]',25000,11000002,'攻击<color=#4eae1aff>+2013</color>'),(2000,162,'强攻',1,10,4,0,1000,'[{1,2025}]',25150,11000002,'攻击<color=#4eae1aff>+2025</color>'),(2000,163,'强攻',1,10,4,0,1000,'[{1,2038}]',25300,11000002,'攻击<color=#4eae1aff>+2038</color>'),(2000,164,'强攻',1,10,4,0,1000,'[{1,2050}]',25450,11000002,'攻击<color=#4eae1aff>+2050</color>'),(2000,165,'强攻',1,10,4,0,1000,'[{1,2063}]',25600,11000002,'攻击<color=#4eae1aff>+2063</color>'),(2000,166,'强攻',1,10,4,0,1000,'[{1,2075}]',25750,11000002,'攻击<color=#4eae1aff>+2075</color>'),(2000,167,'强攻',1,10,4,0,1000,'[{1,2088}]',25900,11000002,'攻击<color=#4eae1aff>+2088</color>'),(2000,168,'强攻',1,10,4,0,1000,'[{1,2100}]',26050,11000002,'攻击<color=#4eae1aff>+2100</color>'),(2000,169,'强攻',1,10,4,0,1000,'[{1,2113}]',26200,11000002,'攻击<color=#4eae1aff>+2113</color>'),(2000,170,'强攻',1,10,4,0,1000,'[{1,2125}]',26350,11000002,'攻击<color=#4eae1aff>+2125</color>'),(2000,171,'强攻',1,10,4,0,1000,'[{1,2138}]',26500,11000002,'攻击<color=#4eae1aff>+2138</color>'),(2000,172,'强攻',1,10,4,0,1000,'[{1,2150}]',26650,11000002,'攻击<color=#4eae1aff>+2150</color>'),(2000,173,'强攻',1,10,4,0,1000,'[{1,2163}]',26800,11000002,'攻击<color=#4eae1aff>+2163</color>'),(2000,174,'强攻',1,10,4,0,1000,'[{1,2175}]',26950,11000002,'攻击<color=#4eae1aff>+2175</color>'),(2000,175,'强攻',1,10,4,0,1000,'[{1,2188}]',27100,11000002,'攻击<color=#4eae1aff>+2188</color>'),(2000,176,'强攻',1,10,4,0,1000,'[{1,2200}]',27250,11000002,'攻击<color=#4eae1aff>+2200</color>'),(2000,177,'强攻',1,10,4,0,1000,'[{1,2213}]',27400,11000002,'攻击<color=#4eae1aff>+2213</color>'),(2000,178,'强攻',1,10,4,0,1000,'[{1,2225}]',27550,11000002,'攻击<color=#4eae1aff>+2225</color>'),(2000,179,'强攻',1,10,4,0,1000,'[{1,2238}]',27700,11000002,'攻击<color=#4eae1aff>+2238</color>'),(2000,180,'强攻',1,10,4,0,1000,'[{1,2250}]',27850,11000002,'攻击<color=#4eae1aff>+2250</color>'),(2000,181,'强攻',1,10,4,0,1000,'[{1,2263}]',28000,11000002,'攻击<color=#4eae1aff>+2263</color>'),(2000,182,'强攻',1,10,4,0,1000,'[{1,2275}]',28150,11000002,'攻击<color=#4eae1aff>+2275</color>'),(2000,183,'强攻',1,10,4,0,1000,'[{1,2288}]',28300,11000002,'攻击<color=#4eae1aff>+2288</color>'),(2000,184,'强攻',1,10,4,0,1000,'[{1,2300}]',28450,11000002,'攻击<color=#4eae1aff>+2300</color>'),(2000,185,'强攻',1,10,4,0,1000,'[{1,2313}]',28600,11000002,'攻击<color=#4eae1aff>+2313</color>'),(2000,186,'强攻',1,10,4,0,1000,'[{1,2325}]',28750,11000002,'攻击<color=#4eae1aff>+2325</color>'),(2000,187,'强攻',1,10,4,0,1000,'[{1,2338}]',28900,11000002,'攻击<color=#4eae1aff>+2338</color>'),(2000,188,'强攻',1,10,4,0,1000,'[{1,2350}]',29050,11000002,'攻击<color=#4eae1aff>+2350</color>'),(2000,189,'强攻',1,10,4,0,1000,'[{1,2363}]',29200,11000002,'攻击<color=#4eae1aff>+2363</color>'),(2000,190,'强攻',1,10,4,0,1000,'[{1,2375}]',29350,11000002,'攻击<color=#4eae1aff>+2375</color>'),(2000,191,'强攻',1,10,4,0,1000,'[{1,2388}]',29500,11000002,'攻击<color=#4eae1aff>+2388</color>'),(2000,192,'强攻',1,10,4,0,1000,'[{1,2400}]',29650,11000002,'攻击<color=#4eae1aff>+2400</color>'),(2000,193,'强攻',1,10,4,0,1000,'[{1,2413}]',29800,11000002,'攻击<color=#4eae1aff>+2413</color>'),(2000,194,'强攻',1,10,4,0,1000,'[{1,2425}]',29950,11000002,'攻击<color=#4eae1aff>+2425</color>'),(2000,195,'强攻',1,10,4,0,1000,'[{1,2438}]',30100,11000002,'攻击<color=#4eae1aff>+2438</color>'),(2000,196,'强攻',1,10,4,0,1000,'[{1,2450}]',30250,11000002,'攻击<color=#4eae1aff>+2450</color>'),(2000,197,'强攻',1,10,4,0,1000,'[{1,2463}]',30400,11000002,'攻击<color=#4eae1aff>+2463</color>'),(2000,198,'强攻',1,10,4,0,1000,'[{1,2475}]',30550,11000002,'攻击<color=#4eae1aff>+2475</color>'),(2000,199,'强攻',1,10,4,0,1000,'[{1,2488}]',30700,11000002,'攻击<color=#4eae1aff>+2488</color>'),(2000,200,'强攻',1,10,4,0,1000,'[{1,2500}]',30850,11000002,'攻击<color=#4eae1aff>+2500</color>'),(2000,201,'强攻',1,10,5,0,1000,'[{1,2513}]',31000,11000002,'攻击<color=#4eae1aff>+2513</color>'),(2000,202,'强攻',1,10,5,0,1000,'[{1,2525}]',31150,11000002,'攻击<color=#4eae1aff>+2525</color>'),(2000,203,'强攻',1,10,5,0,1000,'[{1,2538}]',31300,11000002,'攻击<color=#4eae1aff>+2538</color>'),(2000,204,'强攻',1,10,5,0,1000,'[{1,2550}]',31450,11000002,'攻击<color=#4eae1aff>+2550</color>'),(2000,205,'强攻',1,10,5,0,1000,'[{1,2563}]',31600,11000002,'攻击<color=#4eae1aff>+2563</color>'),(2000,206,'强攻',1,10,5,0,1000,'[{1,2575}]',31750,11000002,'攻击<color=#4eae1aff>+2575</color>'),(2000,207,'强攻',1,10,5,0,1000,'[{1,2588}]',31900,11000002,'攻击<color=#4eae1aff>+2588</color>'),(2000,208,'强攻',1,10,5,0,1000,'[{1,2600}]',32050,11000002,'攻击<color=#4eae1aff>+2600</color>'),(2000,209,'强攻',1,10,5,0,1000,'[{1,2613}]',32200,11000002,'攻击<color=#4eae1aff>+2613</color>'),(2000,210,'强攻',1,10,5,0,1000,'[{1,2625}]',32350,11000002,'攻击<color=#4eae1aff>+2625</color>'),(2000,211,'强攻',1,10,5,0,1000,'[{1,2638}]',32500,11000002,'攻击<color=#4eae1aff>+2638</color>'),(2000,212,'强攻',1,10,5,0,1000,'[{1,2650}]',32650,11000002,'攻击<color=#4eae1aff>+2650</color>'),(2000,213,'强攻',1,10,5,0,1000,'[{1,2663}]',32800,11000002,'攻击<color=#4eae1aff>+2663</color>'),(2000,214,'强攻',1,10,5,0,1000,'[{1,2675}]',32950,11000002,'攻击<color=#4eae1aff>+2675</color>'),(2000,215,'强攻',1,10,5,0,1000,'[{1,2688}]',33100,11000002,'攻击<color=#4eae1aff>+2688</color>'),(2000,216,'强攻',1,10,5,0,1000,'[{1,2700}]',33250,11000002,'攻击<color=#4eae1aff>+2700</color>'),(2000,217,'强攻',1,10,5,0,1000,'[{1,2713}]',33400,11000002,'攻击<color=#4eae1aff>+2713</color>'),(2000,218,'强攻',1,10,5,0,1000,'[{1,2725}]',33550,11000002,'攻击<color=#4eae1aff>+2725</color>'),(2000,219,'强攻',1,10,5,0,1000,'[{1,2738}]',33700,11000002,'攻击<color=#4eae1aff>+2738</color>'),(2000,220,'强攻',1,10,5,0,1000,'[{1,2750}]',33850,11000002,'攻击<color=#4eae1aff>+2750</color>'),(2000,221,'强攻',1,10,5,0,1000,'[{1,2763}]',34000,11000002,'攻击<color=#4eae1aff>+2763</color>'),(2000,222,'强攻',1,10,5,0,1000,'[{1,2775}]',34150,11000002,'攻击<color=#4eae1aff>+2775</color>'),(2000,223,'强攻',1,10,5,0,1000,'[{1,2788}]',34300,11000002,'攻击<color=#4eae1aff>+2788</color>'),(2000,224,'强攻',1,10,5,0,1000,'[{1,2800}]',34450,11000002,'攻击<color=#4eae1aff>+2800</color>'),(2000,225,'强攻',1,10,5,0,1000,'[{1,2813}]',34600,11000002,'攻击<color=#4eae1aff>+2813</color>'),(2000,226,'强攻',1,10,5,0,1000,'[{1,2825}]',34750,11000002,'攻击<color=#4eae1aff>+2825</color>'),(2000,227,'强攻',1,10,5,0,1000,'[{1,2838}]',34900,11000002,'攻击<color=#4eae1aff>+2838</color>'),(2000,228,'强攻',1,10,5,0,1000,'[{1,2850}]',35050,11000002,'攻击<color=#4eae1aff>+2850</color>'),(2000,229,'强攻',1,10,5,0,1000,'[{1,2863}]',35200,11000002,'攻击<color=#4eae1aff>+2863</color>'),(2000,230,'强攻',1,10,5,0,1000,'[{1,2875}]',35350,11000002,'攻击<color=#4eae1aff>+2875</color>'),(2000,231,'强攻',1,10,5,0,1000,'[{1,2888}]',35500,11000002,'攻击<color=#4eae1aff>+2888</color>'),(2000,232,'强攻',1,10,5,0,1000,'[{1,2900}]',35650,11000002,'攻击<color=#4eae1aff>+2900</color>'),(2000,233,'强攻',1,10,5,0,1000,'[{1,2913}]',35800,11000002,'攻击<color=#4eae1aff>+2913</color>'),(2000,234,'强攻',1,10,5,0,1000,'[{1,2925}]',35950,11000002,'攻击<color=#4eae1aff>+2925</color>'),(2000,235,'强攻',1,10,5,0,1000,'[{1,2938}]',36100,11000002,'攻击<color=#4eae1aff>+2938</color>'),(2000,236,'强攻',1,10,5,0,1000,'[{1,2950}]',36250,11000002,'攻击<color=#4eae1aff>+2950</color>'),(2000,237,'强攻',1,10,5,0,1000,'[{1,2963}]',36400,11000002,'攻击<color=#4eae1aff>+2963</color>'),(2000,238,'强攻',1,10,5,0,1000,'[{1,2975}]',36550,11000002,'攻击<color=#4eae1aff>+2975</color>'),(2000,239,'强攻',1,10,5,0,1000,'[{1,2988}]',36700,11000002,'攻击<color=#4eae1aff>+2988</color>'),(2000,240,'强攻',1,10,5,0,1000,'[{1,3000}]',36850,11000002,'攻击<color=#4eae1aff>+3000</color>'),(2000,241,'强攻',1,10,5,0,1000,'[{1,3013}]',37000,11000002,'攻击<color=#4eae1aff>+3013</color>'),(2000,242,'强攻',1,10,5,0,1000,'[{1,3025}]',37150,11000002,'攻击<color=#4eae1aff>+3025</color>'),(2000,243,'强攻',1,10,5,0,1000,'[{1,3038}]',37300,11000002,'攻击<color=#4eae1aff>+3038</color>'),(2000,244,'强攻',1,10,5,0,1000,'[{1,3050}]',37450,11000002,'攻击<color=#4eae1aff>+3050</color>'),(2000,245,'强攻',1,10,5,0,1000,'[{1,3063}]',37600,11000002,'攻击<color=#4eae1aff>+3063</color>'),(2000,246,'强攻',1,10,5,0,1000,'[{1,3075}]',37750,11000002,'攻击<color=#4eae1aff>+3075</color>'),(2000,247,'强攻',1,10,5,0,1000,'[{1,3088}]',37900,11000002,'攻击<color=#4eae1aff>+3088</color>'),(2000,248,'强攻',1,10,5,0,1000,'[{1,3100}]',38050,11000002,'攻击<color=#4eae1aff>+3100</color>'),(2000,249,'强攻',1,10,5,0,1000,'[{1,3113}]',38200,11000002,'攻击<color=#4eae1aff>+3113</color>'),(2000,250,'强攻',1,10,5,0,1000,'[{1,3125}]',38350,11000002,'攻击<color=#4eae1aff>+3125</color>'),(2000,251,'强攻',1,10,6,0,1000,'[{1,3138}]',38500,11000002,'攻击<color=#4eae1aff>+3138</color>'),(2000,252,'强攻',1,10,6,0,1000,'[{1,3150}]',38650,11000002,'攻击<color=#4eae1aff>+3150</color>'),(2000,253,'强攻',1,10,6,0,1000,'[{1,3163}]',38800,11000002,'攻击<color=#4eae1aff>+3163</color>'),(2000,254,'强攻',1,10,6,0,1000,'[{1,3175}]',38950,11000002,'攻击<color=#4eae1aff>+3175</color>'),(2000,255,'强攻',1,10,6,0,1000,'[{1,3188}]',39100,11000002,'攻击<color=#4eae1aff>+3188</color>'),(2000,256,'强攻',1,10,6,0,1000,'[{1,3200}]',39250,11000002,'攻击<color=#4eae1aff>+3200</color>'),(2000,257,'强攻',1,10,6,0,1000,'[{1,3213}]',39400,11000002,'攻击<color=#4eae1aff>+3213</color>'),(2000,258,'强攻',1,10,6,0,1000,'[{1,3225}]',39550,11000002,'攻击<color=#4eae1aff>+3225</color>'),(2000,259,'强攻',1,10,6,0,1000,'[{1,3238}]',39700,11000002,'攻击<color=#4eae1aff>+3238</color>'),(2000,260,'强攻',1,10,6,0,1000,'[{1,3250}]',39850,11000002,'攻击<color=#4eae1aff>+3250</color>'),(2000,261,'强攻',1,10,6,0,1000,'[{1,3263}]',40000,11000002,'攻击<color=#4eae1aff>+3263</color>'),(2000,262,'强攻',1,10,6,0,1000,'[{1,3275}]',40150,11000002,'攻击<color=#4eae1aff>+3275</color>'),(2000,263,'强攻',1,10,6,0,1000,'[{1,3288}]',40300,11000002,'攻击<color=#4eae1aff>+3288</color>'),(2000,264,'强攻',1,10,6,0,1000,'[{1,3300}]',40450,11000002,'攻击<color=#4eae1aff>+3300</color>'),(2000,265,'强攻',1,10,6,0,1000,'[{1,3313}]',40600,11000002,'攻击<color=#4eae1aff>+3313</color>'),(2000,266,'强攻',1,10,6,0,1000,'[{1,3325}]',40750,11000002,'攻击<color=#4eae1aff>+3325</color>'),(2000,267,'强攻',1,10,6,0,1000,'[{1,3338}]',40900,11000002,'攻击<color=#4eae1aff>+3338</color>'),(2000,268,'强攻',1,10,6,0,1000,'[{1,3350}]',41050,11000002,'攻击<color=#4eae1aff>+3350</color>'),(2000,269,'强攻',1,10,6,0,1000,'[{1,3363}]',41200,11000002,'攻击<color=#4eae1aff>+3363</color>'),(2000,270,'强攻',1,10,6,0,1000,'[{1,3375}]',41350,11000002,'攻击<color=#4eae1aff>+3375</color>'),(2000,271,'强攻',1,10,6,0,1000,'[{1,3388}]',41500,11000002,'攻击<color=#4eae1aff>+3388</color>'),(2000,272,'强攻',1,10,6,0,1000,'[{1,3400}]',41650,11000002,'攻击<color=#4eae1aff>+3400</color>'),(2000,273,'强攻',1,10,6,0,1000,'[{1,3413}]',41800,11000002,'攻击<color=#4eae1aff>+3413</color>'),(2000,274,'强攻',1,10,6,0,1000,'[{1,3425}]',41950,11000002,'攻击<color=#4eae1aff>+3425</color>'),(2000,275,'强攻',1,10,6,0,1000,'[{1,3438}]',42100,11000002,'攻击<color=#4eae1aff>+3438</color>'),(2000,276,'强攻',1,10,6,0,1000,'[{1,3450}]',42250,11000002,'攻击<color=#4eae1aff>+3450</color>'),(2000,277,'强攻',1,10,6,0,1000,'[{1,3463}]',42400,11000002,'攻击<color=#4eae1aff>+3463</color>'),(2000,278,'强攻',1,10,6,0,1000,'[{1,3475}]',42550,11000002,'攻击<color=#4eae1aff>+3475</color>'),(2000,279,'强攻',1,10,6,0,1000,'[{1,3488}]',42700,11000002,'攻击<color=#4eae1aff>+3488</color>'),(2000,280,'强攻',1,10,6,0,1000,'[{1,3500}]',42850,11000002,'攻击<color=#4eae1aff>+3500</color>'),(2000,281,'强攻',1,10,6,0,1000,'[{1,3513}]',43000,11000002,'攻击<color=#4eae1aff>+3513</color>'),(2000,282,'强攻',1,10,6,0,1000,'[{1,3525}]',43150,11000002,'攻击<color=#4eae1aff>+3525</color>'),(2000,283,'强攻',1,10,6,0,1000,'[{1,3538}]',43300,11000002,'攻击<color=#4eae1aff>+3538</color>'),(2000,284,'强攻',1,10,6,0,1000,'[{1,3550}]',43450,11000002,'攻击<color=#4eae1aff>+3550</color>'),(2000,285,'强攻',1,10,6,0,1000,'[{1,3563}]',43600,11000002,'攻击<color=#4eae1aff>+3563</color>'),(2000,286,'强攻',1,10,6,0,1000,'[{1,3575}]',43750,11000002,'攻击<color=#4eae1aff>+3575</color>'),(2000,287,'强攻',1,10,6,0,1000,'[{1,3588}]',43900,11000002,'攻击<color=#4eae1aff>+3588</color>'),(2000,288,'强攻',1,10,6,0,1000,'[{1,3600}]',44050,11000002,'攻击<color=#4eae1aff>+3600</color>'),(2000,289,'强攻',1,10,6,0,1000,'[{1,3613}]',44200,11000002,'攻击<color=#4eae1aff>+3613</color>'),(2000,290,'强攻',1,10,6,0,1000,'[{1,3625}]',44350,11000002,'攻击<color=#4eae1aff>+3625</color>'),(2000,291,'强攻',1,10,6,0,1000,'[{1,3638}]',44500,11000002,'攻击<color=#4eae1aff>+3638</color>'),(2000,292,'强攻',1,10,6,0,1000,'[{1,3650}]',44650,11000002,'攻击<color=#4eae1aff>+3650</color>'),(2000,293,'强攻',1,10,6,0,1000,'[{1,3663}]',44800,11000002,'攻击<color=#4eae1aff>+3663</color>'),(2000,294,'强攻',1,10,6,0,1000,'[{1,3675}]',44950,11000002,'攻击<color=#4eae1aff>+3675</color>'),(2000,295,'强攻',1,10,6,0,1000,'[{1,3688}]',45100,11000002,'攻击<color=#4eae1aff>+3688</color>'),(2000,296,'强攻',1,10,6,0,1000,'[{1,3700}]',45250,11000002,'攻击<color=#4eae1aff>+3700</color>'),(2000,297,'强攻',1,10,6,0,1000,'[{1,3713}]',45400,11000002,'攻击<color=#4eae1aff>+3713</color>'),(2000,298,'强攻',1,10,6,0,1000,'[{1,3725}]',45550,11000002,'攻击<color=#4eae1aff>+3725</color>'),(2000,299,'强攻',1,10,6,0,1000,'[{1,3738}]',45700,11000002,'攻击<color=#4eae1aff>+3738</color>'),(2000,300,'强攻',1,10,6,0,1000,'[{1,3750}]',45850,11000002,'攻击<color=#4eae1aff>+3750</color>'),(2000,301,'强攻',1,10,7,0,1000,'[{1,3763}]',46000,11000002,'攻击<color=#4eae1aff>+3763</color>'),(2000,302,'强攻',1,10,7,0,1000,'[{1,3775}]',46150,11000002,'攻击<color=#4eae1aff>+3775</color>'),(2000,303,'强攻',1,10,7,0,1000,'[{1,3788}]',46300,11000002,'攻击<color=#4eae1aff>+3788</color>'),(2000,304,'强攻',1,10,7,0,1000,'[{1,3800}]',46450,11000002,'攻击<color=#4eae1aff>+3800</color>'),(2000,305,'强攻',1,10,7,0,1000,'[{1,3813}]',46600,11000002,'攻击<color=#4eae1aff>+3813</color>'),(2000,306,'强攻',1,10,7,0,1000,'[{1,3825}]',46750,11000002,'攻击<color=#4eae1aff>+3825</color>'),(2000,307,'强攻',1,10,7,0,1000,'[{1,3838}]',46900,11000002,'攻击<color=#4eae1aff>+3838</color>'),(2000,308,'强攻',1,10,7,0,1000,'[{1,3850}]',47050,11000002,'攻击<color=#4eae1aff>+3850</color>'),(2000,309,'强攻',1,10,7,0,1000,'[{1,3863}]',47200,11000002,'攻击<color=#4eae1aff>+3863</color>'),(2000,310,'强攻',1,10,7,0,1000,'[{1,3875}]',47350,11000002,'攻击<color=#4eae1aff>+3875</color>'),(2000,311,'强攻',1,10,7,0,1000,'[{1,3888}]',47500,11000002,'攻击<color=#4eae1aff>+3888</color>'),(2000,312,'强攻',1,10,7,0,1000,'[{1,3900}]',47650,11000002,'攻击<color=#4eae1aff>+3900</color>'),(2000,313,'强攻',1,10,7,0,1000,'[{1,3913}]',47800,11000002,'攻击<color=#4eae1aff>+3913</color>'),(2000,314,'强攻',1,10,7,0,1000,'[{1,3925}]',47950,11000002,'攻击<color=#4eae1aff>+3925</color>'),(2000,315,'强攻',1,10,7,0,1000,'[{1,3938}]',48100,11000002,'攻击<color=#4eae1aff>+3938</color>'),(2000,316,'强攻',1,10,7,0,1000,'[{1,3950}]',48250,11000002,'攻击<color=#4eae1aff>+3950</color>'),(2000,317,'强攻',1,10,7,0,1000,'[{1,3963}]',48400,11000002,'攻击<color=#4eae1aff>+3963</color>'),(2000,318,'强攻',1,10,7,0,1000,'[{1,3975}]',48550,11000002,'攻击<color=#4eae1aff>+3975</color>'),(2000,319,'强攻',1,10,7,0,1000,'[{1,3988}]',48700,11000002,'攻击<color=#4eae1aff>+3988</color>'),(2000,320,'强攻',1,10,7,0,1000,'[{1,4000}]',48850,11000002,'攻击<color=#4eae1aff>+4000</color>'),(2000,321,'强攻',1,10,7,0,1000,'[{1,4013}]',49000,11000002,'攻击<color=#4eae1aff>+4013</color>'),(2000,322,'强攻',1,10,7,0,1000,'[{1,4025}]',49150,11000002,'攻击<color=#4eae1aff>+4025</color>'),(2000,323,'强攻',1,10,7,0,1000,'[{1,4038}]',49300,11000002,'攻击<color=#4eae1aff>+4038</color>'),(2000,324,'强攻',1,10,7,0,1000,'[{1,4050}]',49450,11000002,'攻击<color=#4eae1aff>+4050</color>'),(2000,325,'强攻',1,10,7,0,1000,'[{1,4063}]',49600,11000002,'攻击<color=#4eae1aff>+4063</color>'),(2000,326,'强攻',1,10,7,0,1000,'[{1,4075}]',49750,11000002,'攻击<color=#4eae1aff>+4075</color>'),(2000,327,'强攻',1,10,7,0,1000,'[{1,4088}]',49900,11000002,'攻击<color=#4eae1aff>+4088</color>'),(2000,328,'强攻',1,10,7,0,1000,'[{1,4100}]',50050,11000002,'攻击<color=#4eae1aff>+4100</color>'),(2000,329,'强攻',1,10,7,0,1000,'[{1,4113}]',50200,11000002,'攻击<color=#4eae1aff>+4113</color>'),(2000,330,'强攻',1,10,7,0,1000,'[{1,4125}]',50350,11000002,'攻击<color=#4eae1aff>+4125</color>'),(2000,331,'强攻',1,10,7,0,1000,'[{1,4138}]',50500,11000002,'攻击<color=#4eae1aff>+4138</color>'),(2000,332,'强攻',1,10,7,0,1000,'[{1,4150}]',50650,11000002,'攻击<color=#4eae1aff>+4150</color>'),(2000,333,'强攻',1,10,7,0,1000,'[{1,4163}]',50800,11000002,'攻击<color=#4eae1aff>+4163</color>'),(2000,334,'强攻',1,10,7,0,1000,'[{1,4175}]',50950,11000002,'攻击<color=#4eae1aff>+4175</color>'),(2000,335,'强攻',1,10,7,0,1000,'[{1,4188}]',51100,11000002,'攻击<color=#4eae1aff>+4188</color>'),(2000,336,'强攻',1,10,7,0,1000,'[{1,4200}]',51250,11000002,'攻击<color=#4eae1aff>+4200</color>'),(2000,337,'强攻',1,10,7,0,1000,'[{1,4213}]',51400,11000002,'攻击<color=#4eae1aff>+4213</color>'),(2000,338,'强攻',1,10,7,0,1000,'[{1,4225}]',51550,11000002,'攻击<color=#4eae1aff>+4225</color>'),(2000,339,'强攻',1,10,7,0,1000,'[{1,4238}]',51700,11000002,'攻击<color=#4eae1aff>+4238</color>'),(2000,340,'强攻',1,10,7,0,1000,'[{1,4250}]',51850,11000002,'攻击<color=#4eae1aff>+4250</color>'),(2000,341,'强攻',1,10,7,0,1000,'[{1,4263}]',52000,11000002,'攻击<color=#4eae1aff>+4263</color>'),(2000,342,'强攻',1,10,7,0,1000,'[{1,4275}]',52150,11000002,'攻击<color=#4eae1aff>+4275</color>'),(2000,343,'强攻',1,10,7,0,1000,'[{1,4288}]',52300,11000002,'攻击<color=#4eae1aff>+4288</color>'),(2000,344,'强攻',1,10,7,0,1000,'[{1,4300}]',52450,11000002,'攻击<color=#4eae1aff>+4300</color>'),(2000,345,'强攻',1,10,7,0,1000,'[{1,4313}]',52600,11000002,'攻击<color=#4eae1aff>+4313</color>'),(2000,346,'强攻',1,10,7,0,1000,'[{1,4325}]',52750,11000002,'攻击<color=#4eae1aff>+4325</color>'),(2000,347,'强攻',1,10,7,0,1000,'[{1,4338}]',52900,11000002,'攻击<color=#4eae1aff>+4338</color>'),(2000,348,'强攻',1,10,7,0,1000,'[{1,4350}]',53050,11000002,'攻击<color=#4eae1aff>+4350</color>'),(2000,349,'强攻',1,10,7,0,1000,'[{1,4363}]',53200,11000002,'攻击<color=#4eae1aff>+4363</color>'),(2000,350,'强攻',1,10,7,0,1000,'[{1,4375}]',53350,11000002,'攻击<color=#4eae1aff>+4375</color>'),(2000,351,'强攻',1,10,8,0,1000,'[{1,4388}]',53500,11000002,'攻击<color=#4eae1aff>+4388</color>'),(2000,352,'强攻',1,10,8,0,1000,'[{1,4400}]',53650,11000002,'攻击<color=#4eae1aff>+4400</color>'),(2000,353,'强攻',1,10,8,0,1000,'[{1,4413}]',53800,11000002,'攻击<color=#4eae1aff>+4413</color>'),(2000,354,'强攻',1,10,8,0,1000,'[{1,4425}]',53950,11000002,'攻击<color=#4eae1aff>+4425</color>'),(2000,355,'强攻',1,10,8,0,1000,'[{1,4438}]',54100,11000002,'攻击<color=#4eae1aff>+4438</color>'),(2000,356,'强攻',1,10,8,0,1000,'[{1,4450}]',54250,11000002,'攻击<color=#4eae1aff>+4450</color>'),(2000,357,'强攻',1,10,8,0,1000,'[{1,4463}]',54400,11000002,'攻击<color=#4eae1aff>+4463</color>'),(2000,358,'强攻',1,10,8,0,1000,'[{1,4475}]',54550,11000002,'攻击<color=#4eae1aff>+4475</color>'),(2000,359,'强攻',1,10,8,0,1000,'[{1,4488}]',54700,11000002,'攻击<color=#4eae1aff>+4488</color>'),(2000,360,'强攻',1,10,8,0,1000,'[{1,4500}]',54850,11000002,'攻击<color=#4eae1aff>+4500</color>'),(2000,361,'强攻',1,10,8,0,1000,'[{1,4513}]',55000,11000002,'攻击<color=#4eae1aff>+4513</color>'),(2000,362,'强攻',1,10,8,0,1000,'[{1,4525}]',55150,11000002,'攻击<color=#4eae1aff>+4525</color>'),(2000,363,'强攻',1,10,8,0,1000,'[{1,4538}]',55300,11000002,'攻击<color=#4eae1aff>+4538</color>'),(2000,364,'强攻',1,10,8,0,1000,'[{1,4550}]',55450,11000002,'攻击<color=#4eae1aff>+4550</color>'),(2000,365,'强攻',1,10,8,0,1000,'[{1,4563}]',55600,11000002,'攻击<color=#4eae1aff>+4563</color>'),(2000,366,'强攻',1,10,8,0,1000,'[{1,4575}]',55750,11000002,'攻击<color=#4eae1aff>+4575</color>'),(2000,367,'强攻',1,10,8,0,1000,'[{1,4588}]',55900,11000002,'攻击<color=#4eae1aff>+4588</color>'),(2000,368,'强攻',1,10,8,0,1000,'[{1,4600}]',56050,11000002,'攻击<color=#4eae1aff>+4600</color>'),(2000,369,'强攻',1,10,8,0,1000,'[{1,4613}]',56200,11000002,'攻击<color=#4eae1aff>+4613</color>'),(2000,370,'强攻',1,10,8,0,1000,'[{1,4625}]',56350,11000002,'攻击<color=#4eae1aff>+4625</color>'),(2000,371,'强攻',1,10,8,0,1000,'[{1,4638}]',56500,11000002,'攻击<color=#4eae1aff>+4638</color>'),(2000,372,'强攻',1,10,8,0,1000,'[{1,4650}]',56650,11000002,'攻击<color=#4eae1aff>+4650</color>'),(2000,373,'强攻',1,10,8,0,1000,'[{1,4663}]',56800,11000002,'攻击<color=#4eae1aff>+4663</color>'),(2000,374,'强攻',1,10,8,0,1000,'[{1,4675}]',56950,11000002,'攻击<color=#4eae1aff>+4675</color>'),(2000,375,'强攻',1,10,8,0,1000,'[{1,4688}]',57100,11000002,'攻击<color=#4eae1aff>+4688</color>'),(2000,376,'强攻',1,10,8,0,1000,'[{1,4700}]',57250,11000002,'攻击<color=#4eae1aff>+4700</color>'),(2000,377,'强攻',1,10,8,0,1000,'[{1,4713}]',57400,11000002,'攻击<color=#4eae1aff>+4713</color>'),(2000,378,'强攻',1,10,8,0,1000,'[{1,4725}]',57550,11000002,'攻击<color=#4eae1aff>+4725</color>'),(2000,379,'强攻',1,10,8,0,1000,'[{1,4738}]',57700,11000002,'攻击<color=#4eae1aff>+4738</color>'),(2000,380,'强攻',1,10,8,0,1000,'[{1,4750}]',57850,11000002,'攻击<color=#4eae1aff>+4750</color>'),(2000,381,'强攻',1,10,8,0,1000,'[{1,4763}]',58000,11000002,'攻击<color=#4eae1aff>+4763</color>'),(2000,382,'强攻',1,10,8,0,1000,'[{1,4775}]',58150,11000002,'攻击<color=#4eae1aff>+4775</color>'),(2000,383,'强攻',1,10,8,0,1000,'[{1,4788}]',58300,11000002,'攻击<color=#4eae1aff>+4788</color>'),(2000,384,'强攻',1,10,8,0,1000,'[{1,4800}]',58450,11000002,'攻击<color=#4eae1aff>+4800</color>'),(2000,385,'强攻',1,10,8,0,1000,'[{1,4813}]',58600,11000002,'攻击<color=#4eae1aff>+4813</color>'),(2000,386,'强攻',1,10,8,0,1000,'[{1,4825}]',58750,11000002,'攻击<color=#4eae1aff>+4825</color>'),(2000,387,'强攻',1,10,8,0,1000,'[{1,4838}]',58900,11000002,'攻击<color=#4eae1aff>+4838</color>'),(2000,388,'强攻',1,10,8,0,1000,'[{1,4850}]',59050,11000002,'攻击<color=#4eae1aff>+4850</color>'),(2000,389,'强攻',1,10,8,0,1000,'[{1,4863}]',59200,11000002,'攻击<color=#4eae1aff>+4863</color>'),(2000,390,'强攻',1,10,8,0,1000,'[{1,4875}]',59350,11000002,'攻击<color=#4eae1aff>+4875</color>'),(2000,391,'强攻',1,10,8,0,1000,'[{1,4888}]',59500,11000002,'攻击<color=#4eae1aff>+4888</color>'),(2000,392,'强攻',1,10,8,0,1000,'[{1,4900}]',59650,11000002,'攻击<color=#4eae1aff>+4900</color>'),(2000,393,'强攻',1,10,8,0,1000,'[{1,4913}]',59800,11000002,'攻击<color=#4eae1aff>+4913</color>'),(2000,394,'强攻',1,10,8,0,1000,'[{1,4925}]',59950,11000002,'攻击<color=#4eae1aff>+4925</color>'),(2000,395,'强攻',1,10,8,0,1000,'[{1,4938}]',60100,11000002,'攻击<color=#4eae1aff>+4938</color>'),(2000,396,'强攻',1,10,8,0,1000,'[{1,4950}]',60250,11000002,'攻击<color=#4eae1aff>+4950</color>'),(2000,397,'强攻',1,10,8,0,1000,'[{1,4963}]',60400,11000002,'攻击<color=#4eae1aff>+4963</color>'),(2000,398,'强攻',1,10,8,0,1000,'[{1,4975}]',60550,11000002,'攻击<color=#4eae1aff>+4975</color>'),(2000,399,'强攻',1,10,8,0,1000,'[{1,4988}]',60700,11000002,'攻击<color=#4eae1aff>+4988</color>'),(2000,400,'强攻',1,10,8,0,1000,'[{1,5000}]',60850,11000002,'攻击<color=#4eae1aff>+5000</color>'),(2000,401,'强攻',1,10,9,0,1000,'[{1,5013}]',61000,11000002,'攻击<color=#4eae1aff>+5013</color>'),(2000,402,'强攻',1,10,9,0,1000,'[{1,5025}]',61150,11000002,'攻击<color=#4eae1aff>+5025</color>'),(2000,403,'强攻',1,10,9,0,1000,'[{1,5038}]',61300,11000002,'攻击<color=#4eae1aff>+5038</color>'),(2000,404,'强攻',1,10,9,0,1000,'[{1,5050}]',61450,11000002,'攻击<color=#4eae1aff>+5050</color>'),(2000,405,'强攻',1,10,9,0,1000,'[{1,5063}]',61600,11000002,'攻击<color=#4eae1aff>+5063</color>'),(2000,406,'强攻',1,10,9,0,1000,'[{1,5075}]',61750,11000002,'攻击<color=#4eae1aff>+5075</color>'),(2000,407,'强攻',1,10,9,0,1000,'[{1,5088}]',61900,11000002,'攻击<color=#4eae1aff>+5088</color>'),(2000,408,'强攻',1,10,9,0,1000,'[{1,5100}]',62050,11000002,'攻击<color=#4eae1aff>+5100</color>'),(2000,409,'强攻',1,10,9,0,1000,'[{1,5113}]',62200,11000002,'攻击<color=#4eae1aff>+5113</color>'),(2000,410,'强攻',1,10,9,0,1000,'[{1,5125}]',62350,11000002,'攻击<color=#4eae1aff>+5125</color>'),(2000,411,'强攻',1,10,9,0,1000,'[{1,5138}]',62500,11000002,'攻击<color=#4eae1aff>+5138</color>'),(2000,412,'强攻',1,10,9,0,1000,'[{1,5150}]',62650,11000002,'攻击<color=#4eae1aff>+5150</color>'),(2000,413,'强攻',1,10,9,0,1000,'[{1,5163}]',62800,11000002,'攻击<color=#4eae1aff>+5163</color>'),(2000,414,'强攻',1,10,9,0,1000,'[{1,5175}]',62950,11000002,'攻击<color=#4eae1aff>+5175</color>'),(2000,415,'强攻',1,10,9,0,1000,'[{1,5188}]',63100,11000002,'攻击<color=#4eae1aff>+5188</color>'),(2000,416,'强攻',1,10,9,0,1000,'[{1,5200}]',63250,11000002,'攻击<color=#4eae1aff>+5200</color>'),(2000,417,'强攻',1,10,9,0,1000,'[{1,5213}]',63400,11000002,'攻击<color=#4eae1aff>+5213</color>'),(2000,418,'强攻',1,10,9,0,1000,'[{1,5225}]',63550,11000002,'攻击<color=#4eae1aff>+5225</color>'),(2000,419,'强攻',1,10,9,0,1000,'[{1,5238}]',63700,11000002,'攻击<color=#4eae1aff>+5238</color>'),(2000,420,'强攻',1,10,9,0,1000,'[{1,5250}]',63850,11000002,'攻击<color=#4eae1aff>+5250</color>'),(2000,421,'强攻',1,10,9,0,1000,'[{1,5263}]',64000,11000002,'攻击<color=#4eae1aff>+5263</color>'),(2000,422,'强攻',1,10,9,0,1000,'[{1,5275}]',64150,11000002,'攻击<color=#4eae1aff>+5275</color>'),(2000,423,'强攻',1,10,9,0,1000,'[{1,5288}]',64300,11000002,'攻击<color=#4eae1aff>+5288</color>'),(2000,424,'强攻',1,10,9,0,1000,'[{1,5300}]',64450,11000002,'攻击<color=#4eae1aff>+5300</color>'),(2000,425,'强攻',1,10,9,0,1000,'[{1,5313}]',64600,11000002,'攻击<color=#4eae1aff>+5313</color>'),(2000,426,'强攻',1,10,9,0,1000,'[{1,5325}]',64750,11000002,'攻击<color=#4eae1aff>+5325</color>'),(2000,427,'强攻',1,10,9,0,1000,'[{1,5338}]',64900,11000002,'攻击<color=#4eae1aff>+5338</color>'),(2000,428,'强攻',1,10,9,0,1000,'[{1,5350}]',65050,11000002,'攻击<color=#4eae1aff>+5350</color>'),(2000,429,'强攻',1,10,9,0,1000,'[{1,5363}]',65200,11000002,'攻击<color=#4eae1aff>+5363</color>'),(2000,430,'强攻',1,10,9,0,1000,'[{1,5375}]',65350,11000002,'攻击<color=#4eae1aff>+5375</color>'),(2000,431,'强攻',1,10,9,0,1000,'[{1,5388}]',65500,11000002,'攻击<color=#4eae1aff>+5388</color>'),(2000,432,'强攻',1,10,9,0,1000,'[{1,5400}]',65650,11000002,'攻击<color=#4eae1aff>+5400</color>'),(2000,433,'强攻',1,10,9,0,1000,'[{1,5413}]',65800,11000002,'攻击<color=#4eae1aff>+5413</color>'),(2000,434,'强攻',1,10,9,0,1000,'[{1,5425}]',65950,11000002,'攻击<color=#4eae1aff>+5425</color>'),(2000,435,'强攻',1,10,9,0,1000,'[{1,5438}]',66100,11000002,'攻击<color=#4eae1aff>+5438</color>'),(2000,436,'强攻',1,10,9,0,1000,'[{1,5450}]',66250,11000002,'攻击<color=#4eae1aff>+5450</color>'),(2000,437,'强攻',1,10,9,0,1000,'[{1,5463}]',66400,11000002,'攻击<color=#4eae1aff>+5463</color>'),(2000,438,'强攻',1,10,9,0,1000,'[{1,5475}]',66550,11000002,'攻击<color=#4eae1aff>+5475</color>'),(2000,439,'强攻',1,10,9,0,1000,'[{1,5488}]',66700,11000002,'攻击<color=#4eae1aff>+5488</color>'),(2000,440,'强攻',1,10,9,0,1000,'[{1,5500}]',66850,11000002,'攻击<color=#4eae1aff>+5500</color>'),(2000,441,'强攻',1,10,9,0,1000,'[{1,5513}]',67000,11000002,'攻击<color=#4eae1aff>+5513</color>'),(2000,442,'强攻',1,10,9,0,1000,'[{1,5525}]',67150,11000002,'攻击<color=#4eae1aff>+5525</color>'),(2000,443,'强攻',1,10,9,0,1000,'[{1,5538}]',67300,11000002,'攻击<color=#4eae1aff>+5538</color>'),(2000,444,'强攻',1,10,9,0,1000,'[{1,5550}]',67450,11000002,'攻击<color=#4eae1aff>+5550</color>'),(2000,445,'强攻',1,10,9,0,1000,'[{1,5563}]',67600,11000002,'攻击<color=#4eae1aff>+5563</color>'),(2000,446,'强攻',1,10,9,0,1000,'[{1,5575}]',67750,11000002,'攻击<color=#4eae1aff>+5575</color>'),(2000,447,'强攻',1,10,9,0,1000,'[{1,5588}]',67900,11000002,'攻击<color=#4eae1aff>+5588</color>'),(2000,448,'强攻',1,10,9,0,1000,'[{1,5600}]',68050,11000002,'攻击<color=#4eae1aff>+5600</color>'),(2000,449,'强攻',1,10,9,0,1000,'[{1,5613}]',68200,11000002,'攻击<color=#4eae1aff>+5613</color>'),(2000,450,'强攻',1,10,9,0,1000,'[{1,5625}]',68350,11000002,'攻击<color=#4eae1aff>+5625</color>'),(2000,451,'强攻',1,10,10,0,1000,'[{1,5638}]',68500,11000002,'攻击<color=#4eae1aff>+5638</color>'),(2000,452,'强攻',1,10,10,0,1000,'[{1,5650}]',68650,11000002,'攻击<color=#4eae1aff>+5650</color>'),(2000,453,'强攻',1,10,10,0,1000,'[{1,5663}]',68800,11000002,'攻击<color=#4eae1aff>+5663</color>'),(2000,454,'强攻',1,10,10,0,1000,'[{1,5675}]',68950,11000002,'攻击<color=#4eae1aff>+5675</color>'),(2000,455,'强攻',1,10,10,0,1000,'[{1,5688}]',69100,11000002,'攻击<color=#4eae1aff>+5688</color>'),(2000,456,'强攻',1,10,10,0,1000,'[{1,5700}]',69250,11000002,'攻击<color=#4eae1aff>+5700</color>'),(2000,457,'强攻',1,10,10,0,1000,'[{1,5713}]',69400,11000002,'攻击<color=#4eae1aff>+5713</color>'),(2000,458,'强攻',1,10,10,0,1000,'[{1,5725}]',69550,11000002,'攻击<color=#4eae1aff>+5725</color>'),(2000,459,'强攻',1,10,10,0,1000,'[{1,5738}]',69700,11000002,'攻击<color=#4eae1aff>+5738</color>'),(2000,460,'强攻',1,10,10,0,1000,'[{1,5750}]',69850,11000002,'攻击<color=#4eae1aff>+5750</color>'),(2000,461,'强攻',1,10,10,0,1000,'[{1,5763}]',70000,11000002,'攻击<color=#4eae1aff>+5763</color>'),(2000,462,'强攻',1,10,10,0,1000,'[{1,5775}]',70150,11000002,'攻击<color=#4eae1aff>+5775</color>'),(2000,463,'强攻',1,10,10,0,1000,'[{1,5788}]',70300,11000002,'攻击<color=#4eae1aff>+5788</color>'),(2000,464,'强攻',1,10,10,0,1000,'[{1,5800}]',70450,11000002,'攻击<color=#4eae1aff>+5800</color>'),(2000,465,'强攻',1,10,10,0,1000,'[{1,5813}]',70600,11000002,'攻击<color=#4eae1aff>+5813</color>'),(2000,466,'强攻',1,10,10,0,1000,'[{1,5825}]',70750,11000002,'攻击<color=#4eae1aff>+5825</color>'),(2000,467,'强攻',1,10,10,0,1000,'[{1,5838}]',70900,11000002,'攻击<color=#4eae1aff>+5838</color>'),(2000,468,'强攻',1,10,10,0,1000,'[{1,5850}]',71050,11000002,'攻击<color=#4eae1aff>+5850</color>'),(2000,469,'强攻',1,10,10,0,1000,'[{1,5863}]',71200,11000002,'攻击<color=#4eae1aff>+5863</color>'),(2000,470,'强攻',1,10,10,0,1000,'[{1,5875}]',71350,11000002,'攻击<color=#4eae1aff>+5875</color>'),(2000,471,'强攻',1,10,10,0,1000,'[{1,5888}]',71500,11000002,'攻击<color=#4eae1aff>+5888</color>'),(2000,472,'强攻',1,10,10,0,1000,'[{1,5900}]',71650,11000002,'攻击<color=#4eae1aff>+5900</color>'),(2000,473,'强攻',1,10,10,0,1000,'[{1,5913}]',71800,11000002,'攻击<color=#4eae1aff>+5913</color>'),(2000,474,'强攻',1,10,10,0,1000,'[{1,5925}]',71950,11000002,'攻击<color=#4eae1aff>+5925</color>'),(2000,475,'强攻',1,10,10,0,1000,'[{1,5938}]',72100,11000002,'攻击<color=#4eae1aff>+5938</color>'),(2000,476,'强攻',1,10,10,0,1000,'[{1,5950}]',72250,11000002,'攻击<color=#4eae1aff>+5950</color>'),(2000,477,'强攻',1,10,10,0,1000,'[{1,5963}]',72400,11000002,'攻击<color=#4eae1aff>+5963</color>'),(2000,478,'强攻',1,10,10,0,1000,'[{1,5975}]',72550,11000002,'攻击<color=#4eae1aff>+5975</color>'),(2000,479,'强攻',1,10,10,0,1000,'[{1,5988}]',72700,11000002,'攻击<color=#4eae1aff>+5988</color>'),(2000,480,'强攻',1,10,10,0,1000,'[{1,6000}]',72850,11000002,'攻击<color=#4eae1aff>+6000</color>'),(2000,481,'强攻',1,10,10,0,1000,'[{1,6013}]',73000,11000002,'攻击<color=#4eae1aff>+6013</color>'),(2000,482,'强攻',1,10,10,0,1000,'[{1,6025}]',73150,11000002,'攻击<color=#4eae1aff>+6025</color>'),(2000,483,'强攻',1,10,10,0,1000,'[{1,6038}]',73300,11000002,'攻击<color=#4eae1aff>+6038</color>'),(2000,484,'强攻',1,10,10,0,1000,'[{1,6050}]',73450,11000002,'攻击<color=#4eae1aff>+6050</color>'),(2000,485,'强攻',1,10,10,0,1000,'[{1,6063}]',73600,11000002,'攻击<color=#4eae1aff>+6063</color>'),(2000,486,'强攻',1,10,10,0,1000,'[{1,6075}]',73750,11000002,'攻击<color=#4eae1aff>+6075</color>'),(2000,487,'强攻',1,10,10,0,1000,'[{1,6088}]',73900,11000002,'攻击<color=#4eae1aff>+6088</color>'),(2000,488,'强攻',1,10,10,0,1000,'[{1,6100}]',74050,11000002,'攻击<color=#4eae1aff>+6100</color>'),(2000,489,'强攻',1,10,10,0,1000,'[{1,6113}]',74200,11000002,'攻击<color=#4eae1aff>+6113</color>'),(2000,490,'强攻',1,10,10,0,1000,'[{1,6125}]',74350,11000002,'攻击<color=#4eae1aff>+6125</color>'),(2000,491,'强攻',1,10,10,0,1000,'[{1,6138}]',74500,11000002,'攻击<color=#4eae1aff>+6138</color>'),(2000,492,'强攻',1,10,10,0,1000,'[{1,6150}]',74650,11000002,'攻击<color=#4eae1aff>+6150</color>'),(2000,493,'强攻',1,10,10,0,1000,'[{1,6163}]',74800,11000002,'攻击<color=#4eae1aff>+6163</color>'),(2000,494,'强攻',1,10,10,0,1000,'[{1,6175}]',74950,11000002,'攻击<color=#4eae1aff>+6175</color>'),(2000,495,'强攻',1,10,10,0,1000,'[{1,6188}]',75100,11000002,'攻击<color=#4eae1aff>+6188</color>'),(2000,496,'强攻',1,10,10,0,1000,'[{1,6200}]',75250,11000002,'攻击<color=#4eae1aff>+6200</color>'),(2000,497,'强攻',1,10,10,0,1000,'[{1,6213}]',75400,11000002,'攻击<color=#4eae1aff>+6213</color>'),(2000,498,'强攻',1,10,10,0,1000,'[{1,6225}]',75550,11000002,'攻击<color=#4eae1aff>+6225</color>'),(2000,499,'强攻',1,10,10,0,1000,'[{1,6238}]',75700,11000002,'攻击<color=#4eae1aff>+6238</color>'),(2000,500,'强攻',1,10,10,0,1000,'[{1,6250}]',75850,11000002,'攻击<color=#4eae1aff>+6250</color>'),(3000,1,'锐利',1,10,1,240,1000,'[{3,10}]',1000,11000003,'破甲<color=#4eae1aff>+10</color>'),(3000,2,'锐利',1,10,1,240,1000,'[{3,20}]',1150,11000003,'破甲<color=#4eae1aff>+20</color>'),(3000,3,'锐利',1,10,1,240,1000,'[{3,30}]',1300,11000003,'破甲<color=#4eae1aff>+30</color>'),(3000,4,'锐利',1,10,1,240,1000,'[{3,40}]',1450,11000003,'破甲<color=#4eae1aff>+40</color>'),(3000,5,'锐利',1,10,1,240,1000,'[{3,50}]',1600,11000003,'破甲<color=#4eae1aff>+50</color>'),(3000,6,'锐利',1,10,1,240,1000,'[{3,60}]',1750,11000003,'破甲<color=#4eae1aff>+60</color>'),(3000,7,'锐利',1,10,1,240,1000,'[{3,70}]',1900,11000003,'破甲<color=#4eae1aff>+70</color>'),(3000,8,'锐利',1,10,1,240,1000,'[{3,80}]',2050,11000003,'破甲<color=#4eae1aff>+80</color>'),(3000,9,'锐利',1,10,1,240,1000,'[{3,90}]',2200,11000003,'破甲<color=#4eae1aff>+90</color>'),(3000,10,'锐利',1,10,1,240,1000,'[{3,100}]',2350,11000003,'破甲<color=#4eae1aff>+100</color>'),(3000,11,'锐利',1,10,1,240,1000,'[{3,110}]',2500,11000003,'破甲<color=#4eae1aff>+110</color>'),(3000,12,'锐利',1,10,1,240,1000,'[{3,120}]',2650,11000003,'破甲<color=#4eae1aff>+120</color>'),(3000,13,'锐利',1,10,1,240,1000,'[{3,130}]',2800,11000003,'破甲<color=#4eae1aff>+130</color>'),(3000,14,'锐利',1,10,1,240,1000,'[{3,140}]',2950,11000003,'破甲<color=#4eae1aff>+140</color>'),(3000,15,'锐利',1,10,1,240,1000,'[{3,150}]',3100,11000003,'破甲<color=#4eae1aff>+150</color>'),(3000,16,'锐利',1,10,1,240,1000,'[{3,160}]',3250,11000003,'破甲<color=#4eae1aff>+160</color>'),(3000,17,'锐利',1,10,1,240,1000,'[{3,170}]',3400,11000003,'破甲<color=#4eae1aff>+170</color>'),(3000,18,'锐利',1,10,1,240,1000,'[{3,180}]',3550,11000003,'破甲<color=#4eae1aff>+180</color>'),(3000,19,'锐利',1,10,1,240,1000,'[{3,190}]',3700,11000003,'破甲<color=#4eae1aff>+190</color>'),(3000,20,'锐利',1,10,1,240,1000,'[{3,200}]',3850,11000003,'破甲<color=#4eae1aff>+200</color>'),(3000,21,'锐利',1,10,1,240,1000,'[{3,210}]',4000,11000003,'破甲<color=#4eae1aff>+210</color>'),(3000,22,'锐利',1,10,1,240,1000,'[{3,220}]',4150,11000003,'破甲<color=#4eae1aff>+220</color>'),(3000,23,'锐利',1,10,1,240,1000,'[{3,230}]',4300,11000003,'破甲<color=#4eae1aff>+230</color>'),(3000,24,'锐利',1,10,1,240,1000,'[{3,240}]',4450,11000003,'破甲<color=#4eae1aff>+240</color>'),(3000,25,'锐利',1,10,1,240,1000,'[{3,250}]',4600,11000003,'破甲<color=#4eae1aff>+250</color>'),(3000,26,'锐利',1,10,1,240,1000,'[{3,260}]',4750,11000003,'破甲<color=#4eae1aff>+260</color>'),(3000,27,'锐利',1,10,1,240,1000,'[{3,270}]',4900,11000003,'破甲<color=#4eae1aff>+270</color>'),(3000,28,'锐利',1,10,1,240,1000,'[{3,280}]',5050,11000003,'破甲<color=#4eae1aff>+280</color>'),(3000,29,'锐利',1,10,1,240,1000,'[{3,290}]',5200,11000003,'破甲<color=#4eae1aff>+290</color>'),(3000,30,'锐利',1,10,1,240,1000,'[{3,300}]',5350,11000003,'破甲<color=#4eae1aff>+300</color>'),(3000,31,'锐利',1,10,1,240,1000,'[{3,310}]',5500,11000003,'破甲<color=#4eae1aff>+310</color>'),(3000,32,'锐利',1,10,1,240,1000,'[{3,320}]',5650,11000003,'破甲<color=#4eae1aff>+320</color>'),(3000,33,'锐利',1,10,1,240,1000,'[{3,330}]',5800,11000003,'破甲<color=#4eae1aff>+330</color>'),(3000,34,'锐利',1,10,1,240,1000,'[{3,340}]',5950,11000003,'破甲<color=#4eae1aff>+340</color>'),(3000,35,'锐利',1,10,1,240,1000,'[{3,350}]',6100,11000003,'破甲<color=#4eae1aff>+350</color>'),(3000,36,'锐利',1,10,1,240,1000,'[{3,360}]',6250,11000003,'破甲<color=#4eae1aff>+360</color>'),(3000,37,'锐利',1,10,1,240,1000,'[{3,370}]',6400,11000003,'破甲<color=#4eae1aff>+370</color>'),(3000,38,'锐利',1,10,1,240,1000,'[{3,380}]',6550,11000003,'破甲<color=#4eae1aff>+380</color>'),(3000,39,'锐利',1,10,1,240,1000,'[{3,390}]',6700,11000003,'破甲<color=#4eae1aff>+390</color>'),(3000,40,'锐利',1,10,1,240,1000,'[{3,400}]',6850,11000003,'破甲<color=#4eae1aff>+400</color>'),(3000,41,'锐利',1,10,1,240,1000,'[{3,410}]',7000,11000003,'破甲<color=#4eae1aff>+410</color>'),(3000,42,'锐利',1,10,1,240,1000,'[{3,420}]',7150,11000003,'破甲<color=#4eae1aff>+420</color>'),(3000,43,'锐利',1,10,1,240,1000,'[{3,430}]',7300,11000003,'破甲<color=#4eae1aff>+430</color>'),(3000,44,'锐利',1,10,1,240,1000,'[{3,440}]',7450,11000003,'破甲<color=#4eae1aff>+440</color>'),(3000,45,'锐利',1,10,1,240,1000,'[{3,450}]',7600,11000003,'破甲<color=#4eae1aff>+450</color>'),(3000,46,'锐利',1,10,1,240,1000,'[{3,460}]',7750,11000003,'破甲<color=#4eae1aff>+460</color>'),(3000,47,'锐利',1,10,1,240,1000,'[{3,470}]',7900,11000003,'破甲<color=#4eae1aff>+470</color>'),(3000,48,'锐利',1,10,1,240,1000,'[{3,480}]',8050,11000003,'破甲<color=#4eae1aff>+480</color>'),(3000,49,'锐利',1,10,1,240,1000,'[{3,490}]',8200,11000003,'破甲<color=#4eae1aff>+490</color>'),(3000,50,'锐利',1,10,1,240,1000,'[{3,500}]',8350,11000003,'破甲<color=#4eae1aff>+500</color>'),(3000,51,'锐利',1,10,2,240,1000,'[{3,510}]',8500,11000003,'破甲<color=#4eae1aff>+510</color>'),(3000,52,'锐利',1,10,2,240,1000,'[{3,520}]',8650,11000003,'破甲<color=#4eae1aff>+520</color>'),(3000,53,'锐利',1,10,2,240,1000,'[{3,530}]',8800,11000003,'破甲<color=#4eae1aff>+530</color>'),(3000,54,'锐利',1,10,2,240,1000,'[{3,540}]',8950,11000003,'破甲<color=#4eae1aff>+540</color>'),(3000,55,'锐利',1,10,2,240,1000,'[{3,550}]',9100,11000003,'破甲<color=#4eae1aff>+550</color>'),(3000,56,'锐利',1,10,2,240,1000,'[{3,560}]',9250,11000003,'破甲<color=#4eae1aff>+560</color>'),(3000,57,'锐利',1,10,2,240,1000,'[{3,570}]',9400,11000003,'破甲<color=#4eae1aff>+570</color>'),(3000,58,'锐利',1,10,2,240,1000,'[{3,580}]',9550,11000003,'破甲<color=#4eae1aff>+580</color>'),(3000,59,'锐利',1,10,2,240,1000,'[{3,590}]',9700,11000003,'破甲<color=#4eae1aff>+590</color>'),(3000,60,'锐利',1,10,2,240,1000,'[{3,600}]',9850,11000003,'破甲<color=#4eae1aff>+600</color>'),(3000,61,'锐利',1,10,2,240,1000,'[{3,610}]',10000,11000003,'破甲<color=#4eae1aff>+610</color>'),(3000,62,'锐利',1,10,2,240,1000,'[{3,620}]',10150,11000003,'破甲<color=#4eae1aff>+620</color>'),(3000,63,'锐利',1,10,2,240,1000,'[{3,630}]',10300,11000003,'破甲<color=#4eae1aff>+630</color>'),(3000,64,'锐利',1,10,2,240,1000,'[{3,640}]',10450,11000003,'破甲<color=#4eae1aff>+640</color>'),(3000,65,'锐利',1,10,2,240,1000,'[{3,650}]',10600,11000003,'破甲<color=#4eae1aff>+650</color>'),(3000,66,'锐利',1,10,2,240,1000,'[{3,660}]',10750,11000003,'破甲<color=#4eae1aff>+660</color>'),(3000,67,'锐利',1,10,2,240,1000,'[{3,670}]',10900,11000003,'破甲<color=#4eae1aff>+670</color>'),(3000,68,'锐利',1,10,2,240,1000,'[{3,680}]',11050,11000003,'破甲<color=#4eae1aff>+680</color>'),(3000,69,'锐利',1,10,2,240,1000,'[{3,690}]',11200,11000003,'破甲<color=#4eae1aff>+690</color>'),(3000,70,'锐利',1,10,2,240,1000,'[{3,700}]',11350,11000003,'破甲<color=#4eae1aff>+700</color>'),(3000,71,'锐利',1,10,2,240,1000,'[{3,710}]',11500,11000003,'破甲<color=#4eae1aff>+710</color>'),(3000,72,'锐利',1,10,2,240,1000,'[{3,720}]',11650,11000003,'破甲<color=#4eae1aff>+720</color>'),(3000,73,'锐利',1,10,2,240,1000,'[{3,730}]',11800,11000003,'破甲<color=#4eae1aff>+730</color>'),(3000,74,'锐利',1,10,2,240,1000,'[{3,740}]',11950,11000003,'破甲<color=#4eae1aff>+740</color>'),(3000,75,'锐利',1,10,2,240,1000,'[{3,750}]',12100,11000003,'破甲<color=#4eae1aff>+750</color>'),(3000,76,'锐利',1,10,2,240,1000,'[{3,760}]',12250,11000003,'破甲<color=#4eae1aff>+760</color>'),(3000,77,'锐利',1,10,2,240,1000,'[{3,770}]',12400,11000003,'破甲<color=#4eae1aff>+770</color>'),(3000,78,'锐利',1,10,2,240,1000,'[{3,780}]',12550,11000003,'破甲<color=#4eae1aff>+780</color>'),(3000,79,'锐利',1,10,2,240,1000,'[{3,790}]',12700,11000003,'破甲<color=#4eae1aff>+790</color>'),(3000,80,'锐利',1,10,2,240,1000,'[{3,800}]',12850,11000003,'破甲<color=#4eae1aff>+800</color>'),(3000,81,'锐利',1,10,2,240,1000,'[{3,810}]',13000,11000003,'破甲<color=#4eae1aff>+810</color>'),(3000,82,'锐利',1,10,2,240,1000,'[{3,820}]',13150,11000003,'破甲<color=#4eae1aff>+820</color>'),(3000,83,'锐利',1,10,2,240,1000,'[{3,830}]',13300,11000003,'破甲<color=#4eae1aff>+830</color>'),(3000,84,'锐利',1,10,2,240,1000,'[{3,840}]',13450,11000003,'破甲<color=#4eae1aff>+840</color>'),(3000,85,'锐利',1,10,2,240,1000,'[{3,850}]',13600,11000003,'破甲<color=#4eae1aff>+850</color>'),(3000,86,'锐利',1,10,2,240,1000,'[{3,860}]',13750,11000003,'破甲<color=#4eae1aff>+860</color>'),(3000,87,'锐利',1,10,2,240,1000,'[{3,870}]',13900,11000003,'破甲<color=#4eae1aff>+870</color>'),(3000,88,'锐利',1,10,2,240,1000,'[{3,880}]',14050,11000003,'破甲<color=#4eae1aff>+880</color>'),(3000,89,'锐利',1,10,2,240,1000,'[{3,890}]',14200,11000003,'破甲<color=#4eae1aff>+890</color>'),(3000,90,'锐利',1,10,2,240,1000,'[{3,900}]',14350,11000003,'破甲<color=#4eae1aff>+900</color>'),(3000,91,'锐利',1,10,2,240,1000,'[{3,910}]',14500,11000003,'破甲<color=#4eae1aff>+910</color>'),(3000,92,'锐利',1,10,2,240,1000,'[{3,920}]',14650,11000003,'破甲<color=#4eae1aff>+920</color>'),(3000,93,'锐利',1,10,2,240,1000,'[{3,930}]',14800,11000003,'破甲<color=#4eae1aff>+930</color>'),(3000,94,'锐利',1,10,2,240,1000,'[{3,940}]',14950,11000003,'破甲<color=#4eae1aff>+940</color>'),(3000,95,'锐利',1,10,2,240,1000,'[{3,950}]',15100,11000003,'破甲<color=#4eae1aff>+950</color>'),(3000,96,'锐利',1,10,2,240,1000,'[{3,960}]',15250,11000003,'破甲<color=#4eae1aff>+960</color>'),(3000,97,'锐利',1,10,2,240,1000,'[{3,970}]',15400,11000003,'破甲<color=#4eae1aff>+970</color>'),(3000,98,'锐利',1,10,2,240,1000,'[{3,980}]',15550,11000003,'破甲<color=#4eae1aff>+980</color>'),(3000,99,'锐利',1,10,2,240,1000,'[{3,990}]',15700,11000003,'破甲<color=#4eae1aff>+990</color>'),(3000,100,'锐利',1,10,2,240,1000,'[{3,1000}]',15850,11000003,'破甲<color=#4eae1aff>+1000</color>'),(3000,101,'锐利',1,10,3,240,1000,'[{3,1010}]',16000,11000003,'破甲<color=#4eae1aff>+1010</color>'),(3000,102,'锐利',1,10,3,240,1000,'[{3,1020}]',16150,11000003,'破甲<color=#4eae1aff>+1020</color>'),(3000,103,'锐利',1,10,3,240,1000,'[{3,1030}]',16300,11000003,'破甲<color=#4eae1aff>+1030</color>'),(3000,104,'锐利',1,10,3,240,1000,'[{3,1040}]',16450,11000003,'破甲<color=#4eae1aff>+1040</color>'),(3000,105,'锐利',1,10,3,240,1000,'[{3,1050}]',16600,11000003,'破甲<color=#4eae1aff>+1050</color>'),(3000,106,'锐利',1,10,3,240,1000,'[{3,1060}]',16750,11000003,'破甲<color=#4eae1aff>+1060</color>'),(3000,107,'锐利',1,10,3,240,1000,'[{3,1070}]',16900,11000003,'破甲<color=#4eae1aff>+1070</color>'),(3000,108,'锐利',1,10,3,240,1000,'[{3,1080}]',17050,11000003,'破甲<color=#4eae1aff>+1080</color>'),(3000,109,'锐利',1,10,3,240,1000,'[{3,1090}]',17200,11000003,'破甲<color=#4eae1aff>+1090</color>'),(3000,110,'锐利',1,10,3,240,1000,'[{3,1100}]',17350,11000003,'破甲<color=#4eae1aff>+1100</color>'),(3000,111,'锐利',1,10,3,240,1000,'[{3,1110}]',17500,11000003,'破甲<color=#4eae1aff>+1110</color>'),(3000,112,'锐利',1,10,3,240,1000,'[{3,1120}]',17650,11000003,'破甲<color=#4eae1aff>+1120</color>'),(3000,113,'锐利',1,10,3,240,1000,'[{3,1130}]',17800,11000003,'破甲<color=#4eae1aff>+1130</color>'),(3000,114,'锐利',1,10,3,240,1000,'[{3,1140}]',17950,11000003,'破甲<color=#4eae1aff>+1140</color>'),(3000,115,'锐利',1,10,3,240,1000,'[{3,1150}]',18100,11000003,'破甲<color=#4eae1aff>+1150</color>'),(3000,116,'锐利',1,10,3,240,1000,'[{3,1160}]',18250,11000003,'破甲<color=#4eae1aff>+1160</color>'),(3000,117,'锐利',1,10,3,240,1000,'[{3,1170}]',18400,11000003,'破甲<color=#4eae1aff>+1170</color>'),(3000,118,'锐利',1,10,3,240,1000,'[{3,1180}]',18550,11000003,'破甲<color=#4eae1aff>+1180</color>'),(3000,119,'锐利',1,10,3,240,1000,'[{3,1190}]',18700,11000003,'破甲<color=#4eae1aff>+1190</color>'),(3000,120,'锐利',1,10,3,240,1000,'[{3,1200}]',18850,11000003,'破甲<color=#4eae1aff>+1200</color>'),(3000,121,'锐利',1,10,3,240,1000,'[{3,1210}]',19000,11000003,'破甲<color=#4eae1aff>+1210</color>'),(3000,122,'锐利',1,10,3,240,1000,'[{3,1220}]',19150,11000003,'破甲<color=#4eae1aff>+1220</color>'),(3000,123,'锐利',1,10,3,240,1000,'[{3,1230}]',19300,11000003,'破甲<color=#4eae1aff>+1230</color>'),(3000,124,'锐利',1,10,3,240,1000,'[{3,1240}]',19450,11000003,'破甲<color=#4eae1aff>+1240</color>'),(3000,125,'锐利',1,10,3,240,1000,'[{3,1250}]',19600,11000003,'破甲<color=#4eae1aff>+1250</color>'),(3000,126,'锐利',1,10,3,240,1000,'[{3,1260}]',19750,11000003,'破甲<color=#4eae1aff>+1260</color>'),(3000,127,'锐利',1,10,3,240,1000,'[{3,1270}]',19900,11000003,'破甲<color=#4eae1aff>+1270</color>'),(3000,128,'锐利',1,10,3,240,1000,'[{3,1280}]',20050,11000003,'破甲<color=#4eae1aff>+1280</color>'),(3000,129,'锐利',1,10,3,240,1000,'[{3,1290}]',20200,11000003,'破甲<color=#4eae1aff>+1290</color>'),(3000,130,'锐利',1,10,3,240,1000,'[{3,1300}]',20350,11000003,'破甲<color=#4eae1aff>+1300</color>'),(3000,131,'锐利',1,10,3,240,1000,'[{3,1310}]',20500,11000003,'破甲<color=#4eae1aff>+1310</color>'),(3000,132,'锐利',1,10,3,240,1000,'[{3,1320}]',20650,11000003,'破甲<color=#4eae1aff>+1320</color>'),(3000,133,'锐利',1,10,3,240,1000,'[{3,1330}]',20800,11000003,'破甲<color=#4eae1aff>+1330</color>'),(3000,134,'锐利',1,10,3,240,1000,'[{3,1340}]',20950,11000003,'破甲<color=#4eae1aff>+1340</color>'),(3000,135,'锐利',1,10,3,240,1000,'[{3,1350}]',21100,11000003,'破甲<color=#4eae1aff>+1350</color>'),(3000,136,'锐利',1,10,3,240,1000,'[{3,1360}]',21250,11000003,'破甲<color=#4eae1aff>+1360</color>'),(3000,137,'锐利',1,10,3,240,1000,'[{3,1370}]',21400,11000003,'破甲<color=#4eae1aff>+1370</color>'),(3000,138,'锐利',1,10,3,240,1000,'[{3,1380}]',21550,11000003,'破甲<color=#4eae1aff>+1380</color>'),(3000,139,'锐利',1,10,3,240,1000,'[{3,1390}]',21700,11000003,'破甲<color=#4eae1aff>+1390</color>'),(3000,140,'锐利',1,10,3,240,1000,'[{3,1400}]',21850,11000003,'破甲<color=#4eae1aff>+1400</color>'),(3000,141,'锐利',1,10,3,240,1000,'[{3,1410}]',22000,11000003,'破甲<color=#4eae1aff>+1410</color>'),(3000,142,'锐利',1,10,3,240,1000,'[{3,1420}]',22150,11000003,'破甲<color=#4eae1aff>+1420</color>'),(3000,143,'锐利',1,10,3,240,1000,'[{3,1430}]',22300,11000003,'破甲<color=#4eae1aff>+1430</color>'),(3000,144,'锐利',1,10,3,240,1000,'[{3,1440}]',22450,11000003,'破甲<color=#4eae1aff>+1440</color>'),(3000,145,'锐利',1,10,3,240,1000,'[{3,1450}]',22600,11000003,'破甲<color=#4eae1aff>+1450</color>'),(3000,146,'锐利',1,10,3,240,1000,'[{3,1460}]',22750,11000003,'破甲<color=#4eae1aff>+1460</color>'),(3000,147,'锐利',1,10,3,240,1000,'[{3,1470}]',22900,11000003,'破甲<color=#4eae1aff>+1470</color>'),(3000,148,'锐利',1,10,3,240,1000,'[{3,1480}]',23050,11000003,'破甲<color=#4eae1aff>+1480</color>'),(3000,149,'锐利',1,10,3,240,1000,'[{3,1490}]',23200,11000003,'破甲<color=#4eae1aff>+1490</color>'),(3000,150,'锐利',1,10,3,240,1000,'[{3,1500}]',23350,11000003,'破甲<color=#4eae1aff>+1500</color>'),(3000,151,'锐利',1,10,4,240,1000,'[{3,1510}]',23500,11000003,'破甲<color=#4eae1aff>+1510</color>'),(3000,152,'锐利',1,10,4,240,1000,'[{3,1520}]',23650,11000003,'破甲<color=#4eae1aff>+1520</color>'),(3000,153,'锐利',1,10,4,240,1000,'[{3,1530}]',23800,11000003,'破甲<color=#4eae1aff>+1530</color>'),(3000,154,'锐利',1,10,4,240,1000,'[{3,1540}]',23950,11000003,'破甲<color=#4eae1aff>+1540</color>'),(3000,155,'锐利',1,10,4,240,1000,'[{3,1550}]',24100,11000003,'破甲<color=#4eae1aff>+1550</color>'),(3000,156,'锐利',1,10,4,240,1000,'[{3,1560}]',24250,11000003,'破甲<color=#4eae1aff>+1560</color>'),(3000,157,'锐利',1,10,4,240,1000,'[{3,1570}]',24400,11000003,'破甲<color=#4eae1aff>+1570</color>'),(3000,158,'锐利',1,10,4,240,1000,'[{3,1580}]',24550,11000003,'破甲<color=#4eae1aff>+1580</color>'),(3000,159,'锐利',1,10,4,240,1000,'[{3,1590}]',24700,11000003,'破甲<color=#4eae1aff>+1590</color>'),(3000,160,'锐利',1,10,4,240,1000,'[{3,1600}]',24850,11000003,'破甲<color=#4eae1aff>+1600</color>'),(3000,161,'锐利',1,10,4,240,1000,'[{3,1610}]',25000,11000003,'破甲<color=#4eae1aff>+1610</color>'),(3000,162,'锐利',1,10,4,240,1000,'[{3,1620}]',25150,11000003,'破甲<color=#4eae1aff>+1620</color>'),(3000,163,'锐利',1,10,4,240,1000,'[{3,1630}]',25300,11000003,'破甲<color=#4eae1aff>+1630</color>'),(3000,164,'锐利',1,10,4,240,1000,'[{3,1640}]',25450,11000003,'破甲<color=#4eae1aff>+1640</color>'),(3000,165,'锐利',1,10,4,240,1000,'[{3,1650}]',25600,11000003,'破甲<color=#4eae1aff>+1650</color>'),(3000,166,'锐利',1,10,4,240,1000,'[{3,1660}]',25750,11000003,'破甲<color=#4eae1aff>+1660</color>'),(3000,167,'锐利',1,10,4,240,1000,'[{3,1670}]',25900,11000003,'破甲<color=#4eae1aff>+1670</color>'),(3000,168,'锐利',1,10,4,240,1000,'[{3,1680}]',26050,11000003,'破甲<color=#4eae1aff>+1680</color>'),(3000,169,'锐利',1,10,4,240,1000,'[{3,1690}]',26200,11000003,'破甲<color=#4eae1aff>+1690</color>'),(3000,170,'锐利',1,10,4,240,1000,'[{3,1700}]',26350,11000003,'破甲<color=#4eae1aff>+1700</color>'),(3000,171,'锐利',1,10,4,240,1000,'[{3,1710}]',26500,11000003,'破甲<color=#4eae1aff>+1710</color>'),(3000,172,'锐利',1,10,4,240,1000,'[{3,1720}]',26650,11000003,'破甲<color=#4eae1aff>+1720</color>'),(3000,173,'锐利',1,10,4,240,1000,'[{3,1730}]',26800,11000003,'破甲<color=#4eae1aff>+1730</color>'),(3000,174,'锐利',1,10,4,240,1000,'[{3,1740}]',26950,11000003,'破甲<color=#4eae1aff>+1740</color>'),(3000,175,'锐利',1,10,4,240,1000,'[{3,1750}]',27100,11000003,'破甲<color=#4eae1aff>+1750</color>'),(3000,176,'锐利',1,10,4,240,1000,'[{3,1760}]',27250,11000003,'破甲<color=#4eae1aff>+1760</color>'),(3000,177,'锐利',1,10,4,240,1000,'[{3,1770}]',27400,11000003,'破甲<color=#4eae1aff>+1770</color>'),(3000,178,'锐利',1,10,4,240,1000,'[{3,1780}]',27550,11000003,'破甲<color=#4eae1aff>+1780</color>'),(3000,179,'锐利',1,10,4,240,1000,'[{3,1790}]',27700,11000003,'破甲<color=#4eae1aff>+1790</color>'),(3000,180,'锐利',1,10,4,240,1000,'[{3,1800}]',27850,11000003,'破甲<color=#4eae1aff>+1800</color>'),(3000,181,'锐利',1,10,4,240,1000,'[{3,1810}]',28000,11000003,'破甲<color=#4eae1aff>+1810</color>'),(3000,182,'锐利',1,10,4,240,1000,'[{3,1820}]',28150,11000003,'破甲<color=#4eae1aff>+1820</color>'),(3000,183,'锐利',1,10,4,240,1000,'[{3,1830}]',28300,11000003,'破甲<color=#4eae1aff>+1830</color>'),(3000,184,'锐利',1,10,4,240,1000,'[{3,1840}]',28450,11000003,'破甲<color=#4eae1aff>+1840</color>'),(3000,185,'锐利',1,10,4,240,1000,'[{3,1850}]',28600,11000003,'破甲<color=#4eae1aff>+1850</color>'),(3000,186,'锐利',1,10,4,240,1000,'[{3,1860}]',28750,11000003,'破甲<color=#4eae1aff>+1860</color>'),(3000,187,'锐利',1,10,4,240,1000,'[{3,1870}]',28900,11000003,'破甲<color=#4eae1aff>+1870</color>'),(3000,188,'锐利',1,10,4,240,1000,'[{3,1880}]',29050,11000003,'破甲<color=#4eae1aff>+1880</color>'),(3000,189,'锐利',1,10,4,240,1000,'[{3,1890}]',29200,11000003,'破甲<color=#4eae1aff>+1890</color>'),(3000,190,'锐利',1,10,4,240,1000,'[{3,1900}]',29350,11000003,'破甲<color=#4eae1aff>+1900</color>'),(3000,191,'锐利',1,10,4,240,1000,'[{3,1910}]',29500,11000003,'破甲<color=#4eae1aff>+1910</color>'),(3000,192,'锐利',1,10,4,240,1000,'[{3,1920}]',29650,11000003,'破甲<color=#4eae1aff>+1920</color>'),(3000,193,'锐利',1,10,4,240,1000,'[{3,1930}]',29800,11000003,'破甲<color=#4eae1aff>+1930</color>'),(3000,194,'锐利',1,10,4,240,1000,'[{3,1940}]',29950,11000003,'破甲<color=#4eae1aff>+1940</color>'),(3000,195,'锐利',1,10,4,240,1000,'[{3,1950}]',30100,11000003,'破甲<color=#4eae1aff>+1950</color>'),(3000,196,'锐利',1,10,4,240,1000,'[{3,1960}]',30250,11000003,'破甲<color=#4eae1aff>+1960</color>'),(3000,197,'锐利',1,10,4,240,1000,'[{3,1970}]',30400,11000003,'破甲<color=#4eae1aff>+1970</color>'),(3000,198,'锐利',1,10,4,240,1000,'[{3,1980}]',30550,11000003,'破甲<color=#4eae1aff>+1980</color>'),(3000,199,'锐利',1,10,4,240,1000,'[{3,1990}]',30700,11000003,'破甲<color=#4eae1aff>+1990</color>'),(3000,200,'锐利',1,10,4,240,1000,'[{3,2000}]',30850,11000003,'破甲<color=#4eae1aff>+2000</color>'),(3000,201,'锐利',1,10,5,240,1000,'[{3,2010}]',31000,11000003,'破甲<color=#4eae1aff>+2010</color>'),(3000,202,'锐利',1,10,5,240,1000,'[{3,2020}]',31150,11000003,'破甲<color=#4eae1aff>+2020</color>'),(3000,203,'锐利',1,10,5,240,1000,'[{3,2030}]',31300,11000003,'破甲<color=#4eae1aff>+2030</color>'),(3000,204,'锐利',1,10,5,240,1000,'[{3,2040}]',31450,11000003,'破甲<color=#4eae1aff>+2040</color>'),(3000,205,'锐利',1,10,5,240,1000,'[{3,2050}]',31600,11000003,'破甲<color=#4eae1aff>+2050</color>'),(3000,206,'锐利',1,10,5,240,1000,'[{3,2060}]',31750,11000003,'破甲<color=#4eae1aff>+2060</color>'),(3000,207,'锐利',1,10,5,240,1000,'[{3,2070}]',31900,11000003,'破甲<color=#4eae1aff>+2070</color>'),(3000,208,'锐利',1,10,5,240,1000,'[{3,2080}]',32050,11000003,'破甲<color=#4eae1aff>+2080</color>'),(3000,209,'锐利',1,10,5,240,1000,'[{3,2090}]',32200,11000003,'破甲<color=#4eae1aff>+2090</color>'),(3000,210,'锐利',1,10,5,240,1000,'[{3,2100}]',32350,11000003,'破甲<color=#4eae1aff>+2100</color>'),(3000,211,'锐利',1,10,5,240,1000,'[{3,2110}]',32500,11000003,'破甲<color=#4eae1aff>+2110</color>'),(3000,212,'锐利',1,10,5,240,1000,'[{3,2120}]',32650,11000003,'破甲<color=#4eae1aff>+2120</color>'),(3000,213,'锐利',1,10,5,240,1000,'[{3,2130}]',32800,11000003,'破甲<color=#4eae1aff>+2130</color>'),(3000,214,'锐利',1,10,5,240,1000,'[{3,2140}]',32950,11000003,'破甲<color=#4eae1aff>+2140</color>'),(3000,215,'锐利',1,10,5,240,1000,'[{3,2150}]',33100,11000003,'破甲<color=#4eae1aff>+2150</color>'),(3000,216,'锐利',1,10,5,240,1000,'[{3,2160}]',33250,11000003,'破甲<color=#4eae1aff>+2160</color>'),(3000,217,'锐利',1,10,5,240,1000,'[{3,2170}]',33400,11000003,'破甲<color=#4eae1aff>+2170</color>'),(3000,218,'锐利',1,10,5,240,1000,'[{3,2180}]',33550,11000003,'破甲<color=#4eae1aff>+2180</color>'),(3000,219,'锐利',1,10,5,240,1000,'[{3,2190}]',33700,11000003,'破甲<color=#4eae1aff>+2190</color>'),(3000,220,'锐利',1,10,5,240,1000,'[{3,2200}]',33850,11000003,'破甲<color=#4eae1aff>+2200</color>'),(3000,221,'锐利',1,10,5,240,1000,'[{3,2210}]',34000,11000003,'破甲<color=#4eae1aff>+2210</color>'),(3000,222,'锐利',1,10,5,240,1000,'[{3,2220}]',34150,11000003,'破甲<color=#4eae1aff>+2220</color>'),(3000,223,'锐利',1,10,5,240,1000,'[{3,2230}]',34300,11000003,'破甲<color=#4eae1aff>+2230</color>'),(3000,224,'锐利',1,10,5,240,1000,'[{3,2240}]',34450,11000003,'破甲<color=#4eae1aff>+2240</color>'),(3000,225,'锐利',1,10,5,240,1000,'[{3,2250}]',34600,11000003,'破甲<color=#4eae1aff>+2250</color>'),(3000,226,'锐利',1,10,5,240,1000,'[{3,2260}]',34750,11000003,'破甲<color=#4eae1aff>+2260</color>'),(3000,227,'锐利',1,10,5,240,1000,'[{3,2270}]',34900,11000003,'破甲<color=#4eae1aff>+2270</color>'),(3000,228,'锐利',1,10,5,240,1000,'[{3,2280}]',35050,11000003,'破甲<color=#4eae1aff>+2280</color>'),(3000,229,'锐利',1,10,5,240,1000,'[{3,2290}]',35200,11000003,'破甲<color=#4eae1aff>+2290</color>'),(3000,230,'锐利',1,10,5,240,1000,'[{3,2300}]',35350,11000003,'破甲<color=#4eae1aff>+2300</color>'),(3000,231,'锐利',1,10,5,240,1000,'[{3,2310}]',35500,11000003,'破甲<color=#4eae1aff>+2310</color>'),(3000,232,'锐利',1,10,5,240,1000,'[{3,2320}]',35650,11000003,'破甲<color=#4eae1aff>+2320</color>'),(3000,233,'锐利',1,10,5,240,1000,'[{3,2330}]',35800,11000003,'破甲<color=#4eae1aff>+2330</color>'),(3000,234,'锐利',1,10,5,240,1000,'[{3,2340}]',35950,11000003,'破甲<color=#4eae1aff>+2340</color>'),(3000,235,'锐利',1,10,5,240,1000,'[{3,2350}]',36100,11000003,'破甲<color=#4eae1aff>+2350</color>'),(3000,236,'锐利',1,10,5,240,1000,'[{3,2360}]',36250,11000003,'破甲<color=#4eae1aff>+2360</color>'),(3000,237,'锐利',1,10,5,240,1000,'[{3,2370}]',36400,11000003,'破甲<color=#4eae1aff>+2370</color>'),(3000,238,'锐利',1,10,5,240,1000,'[{3,2380}]',36550,11000003,'破甲<color=#4eae1aff>+2380</color>'),(3000,239,'锐利',1,10,5,240,1000,'[{3,2390}]',36700,11000003,'破甲<color=#4eae1aff>+2390</color>'),(3000,240,'锐利',1,10,5,240,1000,'[{3,2400}]',36850,11000003,'破甲<color=#4eae1aff>+2400</color>'),(3000,241,'锐利',1,10,5,240,1000,'[{3,2410}]',37000,11000003,'破甲<color=#4eae1aff>+2410</color>'),(3000,242,'锐利',1,10,5,240,1000,'[{3,2420}]',37150,11000003,'破甲<color=#4eae1aff>+2420</color>'),(3000,243,'锐利',1,10,5,240,1000,'[{3,2430}]',37300,11000003,'破甲<color=#4eae1aff>+2430</color>'),(3000,244,'锐利',1,10,5,240,1000,'[{3,2440}]',37450,11000003,'破甲<color=#4eae1aff>+2440</color>'),(3000,245,'锐利',1,10,5,240,1000,'[{3,2450}]',37600,11000003,'破甲<color=#4eae1aff>+2450</color>'),(3000,246,'锐利',1,10,5,240,1000,'[{3,2460}]',37750,11000003,'破甲<color=#4eae1aff>+2460</color>'),(3000,247,'锐利',1,10,5,240,1000,'[{3,2470}]',37900,11000003,'破甲<color=#4eae1aff>+2470</color>'),(3000,248,'锐利',1,10,5,240,1000,'[{3,2480}]',38050,11000003,'破甲<color=#4eae1aff>+2480</color>'),(3000,249,'锐利',1,10,5,240,1000,'[{3,2490}]',38200,11000003,'破甲<color=#4eae1aff>+2490</color>'),(3000,250,'锐利',1,10,5,240,1000,'[{3,2500}]',38350,11000003,'破甲<color=#4eae1aff>+2500</color>'),(3000,251,'锐利',1,10,6,240,1000,'[{3,2510}]',38500,11000003,'破甲<color=#4eae1aff>+2510</color>'),(3000,252,'锐利',1,10,6,240,1000,'[{3,2520}]',38650,11000003,'破甲<color=#4eae1aff>+2520</color>'),(3000,253,'锐利',1,10,6,240,1000,'[{3,2530}]',38800,11000003,'破甲<color=#4eae1aff>+2530</color>'),(3000,254,'锐利',1,10,6,240,1000,'[{3,2540}]',38950,11000003,'破甲<color=#4eae1aff>+2540</color>'),(3000,255,'锐利',1,10,6,240,1000,'[{3,2550}]',39100,11000003,'破甲<color=#4eae1aff>+2550</color>'),(3000,256,'锐利',1,10,6,240,1000,'[{3,2560}]',39250,11000003,'破甲<color=#4eae1aff>+2560</color>'),(3000,257,'锐利',1,10,6,240,1000,'[{3,2570}]',39400,11000003,'破甲<color=#4eae1aff>+2570</color>'),(3000,258,'锐利',1,10,6,240,1000,'[{3,2580}]',39550,11000003,'破甲<color=#4eae1aff>+2580</color>'),(3000,259,'锐利',1,10,6,240,1000,'[{3,2590}]',39700,11000003,'破甲<color=#4eae1aff>+2590</color>'),(3000,260,'锐利',1,10,6,240,1000,'[{3,2600}]',39850,11000003,'破甲<color=#4eae1aff>+2600</color>'),(3000,261,'锐利',1,10,6,240,1000,'[{3,2610}]',40000,11000003,'破甲<color=#4eae1aff>+2610</color>'),(3000,262,'锐利',1,10,6,240,1000,'[{3,2620}]',40150,11000003,'破甲<color=#4eae1aff>+2620</color>'),(3000,263,'锐利',1,10,6,240,1000,'[{3,2630}]',40300,11000003,'破甲<color=#4eae1aff>+2630</color>'),(3000,264,'锐利',1,10,6,240,1000,'[{3,2640}]',40450,11000003,'破甲<color=#4eae1aff>+2640</color>'),(3000,265,'锐利',1,10,6,240,1000,'[{3,2650}]',40600,11000003,'破甲<color=#4eae1aff>+2650</color>'),(3000,266,'锐利',1,10,6,240,1000,'[{3,2660}]',40750,11000003,'破甲<color=#4eae1aff>+2660</color>'),(3000,267,'锐利',1,10,6,240,1000,'[{3,2670}]',40900,11000003,'破甲<color=#4eae1aff>+2670</color>'),(3000,268,'锐利',1,10,6,240,1000,'[{3,2680}]',41050,11000003,'破甲<color=#4eae1aff>+2680</color>'),(3000,269,'锐利',1,10,6,240,1000,'[{3,2690}]',41200,11000003,'破甲<color=#4eae1aff>+2690</color>'),(3000,270,'锐利',1,10,6,240,1000,'[{3,2700}]',41350,11000003,'破甲<color=#4eae1aff>+2700</color>'),(3000,271,'锐利',1,10,6,240,1000,'[{3,2710}]',41500,11000003,'破甲<color=#4eae1aff>+2710</color>'),(3000,272,'锐利',1,10,6,240,1000,'[{3,2720}]',41650,11000003,'破甲<color=#4eae1aff>+2720</color>'),(3000,273,'锐利',1,10,6,240,1000,'[{3,2730}]',41800,11000003,'破甲<color=#4eae1aff>+2730</color>'),(3000,274,'锐利',1,10,6,240,1000,'[{3,2740}]',41950,11000003,'破甲<color=#4eae1aff>+2740</color>'),(3000,275,'锐利',1,10,6,240,1000,'[{3,2750}]',42100,11000003,'破甲<color=#4eae1aff>+2750</color>'),(3000,276,'锐利',1,10,6,240,1000,'[{3,2760}]',42250,11000003,'破甲<color=#4eae1aff>+2760</color>'),(3000,277,'锐利',1,10,6,240,1000,'[{3,2770}]',42400,11000003,'破甲<color=#4eae1aff>+2770</color>'),(3000,278,'锐利',1,10,6,240,1000,'[{3,2780}]',42550,11000003,'破甲<color=#4eae1aff>+2780</color>'),(3000,279,'锐利',1,10,6,240,1000,'[{3,2790}]',42700,11000003,'破甲<color=#4eae1aff>+2790</color>'),(3000,280,'锐利',1,10,6,240,1000,'[{3,2800}]',42850,11000003,'破甲<color=#4eae1aff>+2800</color>'),(3000,281,'锐利',1,10,6,240,1000,'[{3,2810}]',43000,11000003,'破甲<color=#4eae1aff>+2810</color>'),(3000,282,'锐利',1,10,6,240,1000,'[{3,2820}]',43150,11000003,'破甲<color=#4eae1aff>+2820</color>'),(3000,283,'锐利',1,10,6,240,1000,'[{3,2830}]',43300,11000003,'破甲<color=#4eae1aff>+2830</color>'),(3000,284,'锐利',1,10,6,240,1000,'[{3,2840}]',43450,11000003,'破甲<color=#4eae1aff>+2840</color>'),(3000,285,'锐利',1,10,6,240,1000,'[{3,2850}]',43600,11000003,'破甲<color=#4eae1aff>+2850</color>'),(3000,286,'锐利',1,10,6,240,1000,'[{3,2860}]',43750,11000003,'破甲<color=#4eae1aff>+2860</color>'),(3000,287,'锐利',1,10,6,240,1000,'[{3,2870}]',43900,11000003,'破甲<color=#4eae1aff>+2870</color>'),(3000,288,'锐利',1,10,6,240,1000,'[{3,2880}]',44050,11000003,'破甲<color=#4eae1aff>+2880</color>'),(3000,289,'锐利',1,10,6,240,1000,'[{3,2890}]',44200,11000003,'破甲<color=#4eae1aff>+2890</color>'),(3000,290,'锐利',1,10,6,240,1000,'[{3,2900}]',44350,11000003,'破甲<color=#4eae1aff>+2900</color>'),(3000,291,'锐利',1,10,6,240,1000,'[{3,2910}]',44500,11000003,'破甲<color=#4eae1aff>+2910</color>'),(3000,292,'锐利',1,10,6,240,1000,'[{3,2920}]',44650,11000003,'破甲<color=#4eae1aff>+2920</color>'),(3000,293,'锐利',1,10,6,240,1000,'[{3,2930}]',44800,11000003,'破甲<color=#4eae1aff>+2930</color>'),(3000,294,'锐利',1,10,6,240,1000,'[{3,2940}]',44950,11000003,'破甲<color=#4eae1aff>+2940</color>'),(3000,295,'锐利',1,10,6,240,1000,'[{3,2950}]',45100,11000003,'破甲<color=#4eae1aff>+2950</color>'),(3000,296,'锐利',1,10,6,240,1000,'[{3,2960}]',45250,11000003,'破甲<color=#4eae1aff>+2960</color>'),(3000,297,'锐利',1,10,6,240,1000,'[{3,2970}]',45400,11000003,'破甲<color=#4eae1aff>+2970</color>'),(3000,298,'锐利',1,10,6,240,1000,'[{3,2980}]',45550,11000003,'破甲<color=#4eae1aff>+2980</color>'),(3000,299,'锐利',1,10,6,240,1000,'[{3,2990}]',45700,11000003,'破甲<color=#4eae1aff>+2990</color>'),(3000,300,'锐利',1,10,6,240,1000,'[{3,3000}]',45850,11000003,'破甲<color=#4eae1aff>+3000</color>'),(3000,301,'锐利',1,10,7,240,1000,'[{3,3010}]',46000,11000003,'破甲<color=#4eae1aff>+3010</color>'),(3000,302,'锐利',1,10,7,240,1000,'[{3,3020}]',46150,11000003,'破甲<color=#4eae1aff>+3020</color>'),(3000,303,'锐利',1,10,7,240,1000,'[{3,3030}]',46300,11000003,'破甲<color=#4eae1aff>+3030</color>'),(3000,304,'锐利',1,10,7,240,1000,'[{3,3040}]',46450,11000003,'破甲<color=#4eae1aff>+3040</color>'),(3000,305,'锐利',1,10,7,240,1000,'[{3,3050}]',46600,11000003,'破甲<color=#4eae1aff>+3050</color>'),(3000,306,'锐利',1,10,7,240,1000,'[{3,3060}]',46750,11000003,'破甲<color=#4eae1aff>+3060</color>'),(3000,307,'锐利',1,10,7,240,1000,'[{3,3070}]',46900,11000003,'破甲<color=#4eae1aff>+3070</color>'),(3000,308,'锐利',1,10,7,240,1000,'[{3,3080}]',47050,11000003,'破甲<color=#4eae1aff>+3080</color>'),(3000,309,'锐利',1,10,7,240,1000,'[{3,3090}]',47200,11000003,'破甲<color=#4eae1aff>+3090</color>'),(3000,310,'锐利',1,10,7,240,1000,'[{3,3100}]',47350,11000003,'破甲<color=#4eae1aff>+3100</color>'),(3000,311,'锐利',1,10,7,240,1000,'[{3,3110}]',47500,11000003,'破甲<color=#4eae1aff>+3110</color>'),(3000,312,'锐利',1,10,7,240,1000,'[{3,3120}]',47650,11000003,'破甲<color=#4eae1aff>+3120</color>'),(3000,313,'锐利',1,10,7,240,1000,'[{3,3130}]',47800,11000003,'破甲<color=#4eae1aff>+3130</color>'),(3000,314,'锐利',1,10,7,240,1000,'[{3,3140}]',47950,11000003,'破甲<color=#4eae1aff>+3140</color>'),(3000,315,'锐利',1,10,7,240,1000,'[{3,3150}]',48100,11000003,'破甲<color=#4eae1aff>+3150</color>'),(3000,316,'锐利',1,10,7,240,1000,'[{3,3160}]',48250,11000003,'破甲<color=#4eae1aff>+3160</color>'),(3000,317,'锐利',1,10,7,240,1000,'[{3,3170}]',48400,11000003,'破甲<color=#4eae1aff>+3170</color>'),(3000,318,'锐利',1,10,7,240,1000,'[{3,3180}]',48550,11000003,'破甲<color=#4eae1aff>+3180</color>'),(3000,319,'锐利',1,10,7,240,1000,'[{3,3190}]',48700,11000003,'破甲<color=#4eae1aff>+3190</color>'),(3000,320,'锐利',1,10,7,240,1000,'[{3,3200}]',48850,11000003,'破甲<color=#4eae1aff>+3200</color>'),(3000,321,'锐利',1,10,7,240,1000,'[{3,3210}]',49000,11000003,'破甲<color=#4eae1aff>+3210</color>'),(3000,322,'锐利',1,10,7,240,1000,'[{3,3220}]',49150,11000003,'破甲<color=#4eae1aff>+3220</color>'),(3000,323,'锐利',1,10,7,240,1000,'[{3,3230}]',49300,11000003,'破甲<color=#4eae1aff>+3230</color>'),(3000,324,'锐利',1,10,7,240,1000,'[{3,3240}]',49450,11000003,'破甲<color=#4eae1aff>+3240</color>'),(3000,325,'锐利',1,10,7,240,1000,'[{3,3250}]',49600,11000003,'破甲<color=#4eae1aff>+3250</color>'),(3000,326,'锐利',1,10,7,240,1000,'[{3,3260}]',49750,11000003,'破甲<color=#4eae1aff>+3260</color>'),(3000,327,'锐利',1,10,7,240,1000,'[{3,3270}]',49900,11000003,'破甲<color=#4eae1aff>+3270</color>'),(3000,328,'锐利',1,10,7,240,1000,'[{3,3280}]',50050,11000003,'破甲<color=#4eae1aff>+3280</color>'),(3000,329,'锐利',1,10,7,240,1000,'[{3,3290}]',50200,11000003,'破甲<color=#4eae1aff>+3290</color>'),(3000,330,'锐利',1,10,7,240,1000,'[{3,3300}]',50350,11000003,'破甲<color=#4eae1aff>+3300</color>'),(3000,331,'锐利',1,10,7,240,1000,'[{3,3310}]',50500,11000003,'破甲<color=#4eae1aff>+3310</color>'),(3000,332,'锐利',1,10,7,240,1000,'[{3,3320}]',50650,11000003,'破甲<color=#4eae1aff>+3320</color>'),(3000,333,'锐利',1,10,7,240,1000,'[{3,3330}]',50800,11000003,'破甲<color=#4eae1aff>+3330</color>'),(3000,334,'锐利',1,10,7,240,1000,'[{3,3340}]',50950,11000003,'破甲<color=#4eae1aff>+3340</color>'),(3000,335,'锐利',1,10,7,240,1000,'[{3,3350}]',51100,11000003,'破甲<color=#4eae1aff>+3350</color>'),(3000,336,'锐利',1,10,7,240,1000,'[{3,3360}]',51250,11000003,'破甲<color=#4eae1aff>+3360</color>'),(3000,337,'锐利',1,10,7,240,1000,'[{3,3370}]',51400,11000003,'破甲<color=#4eae1aff>+3370</color>'),(3000,338,'锐利',1,10,7,240,1000,'[{3,3380}]',51550,11000003,'破甲<color=#4eae1aff>+3380</color>'),(3000,339,'锐利',1,10,7,240,1000,'[{3,3390}]',51700,11000003,'破甲<color=#4eae1aff>+3390</color>'),(3000,340,'锐利',1,10,7,240,1000,'[{3,3400}]',51850,11000003,'破甲<color=#4eae1aff>+3400</color>'),(3000,341,'锐利',1,10,7,240,1000,'[{3,3410}]',52000,11000003,'破甲<color=#4eae1aff>+3410</color>'),(3000,342,'锐利',1,10,7,240,1000,'[{3,3420}]',52150,11000003,'破甲<color=#4eae1aff>+3420</color>'),(3000,343,'锐利',1,10,7,240,1000,'[{3,3430}]',52300,11000003,'破甲<color=#4eae1aff>+3430</color>'),(3000,344,'锐利',1,10,7,240,1000,'[{3,3440}]',52450,11000003,'破甲<color=#4eae1aff>+3440</color>'),(3000,345,'锐利',1,10,7,240,1000,'[{3,3450}]',52600,11000003,'破甲<color=#4eae1aff>+3450</color>'),(3000,346,'锐利',1,10,7,240,1000,'[{3,3460}]',52750,11000003,'破甲<color=#4eae1aff>+3460</color>'),(3000,347,'锐利',1,10,7,240,1000,'[{3,3470}]',52900,11000003,'破甲<color=#4eae1aff>+3470</color>'),(3000,348,'锐利',1,10,7,240,1000,'[{3,3480}]',53050,11000003,'破甲<color=#4eae1aff>+3480</color>'),(3000,349,'锐利',1,10,7,240,1000,'[{3,3490}]',53200,11000003,'破甲<color=#4eae1aff>+3490</color>'),(3000,350,'锐利',1,10,7,240,1000,'[{3,3500}]',53350,11000003,'破甲<color=#4eae1aff>+3500</color>'),(3000,351,'锐利',1,10,8,240,1000,'[{3,3510}]',53500,11000003,'破甲<color=#4eae1aff>+3510</color>'),(3000,352,'锐利',1,10,8,240,1000,'[{3,3520}]',53650,11000003,'破甲<color=#4eae1aff>+3520</color>'),(3000,353,'锐利',1,10,8,240,1000,'[{3,3530}]',53800,11000003,'破甲<color=#4eae1aff>+3530</color>'),(3000,354,'锐利',1,10,8,240,1000,'[{3,3540}]',53950,11000003,'破甲<color=#4eae1aff>+3540</color>'),(3000,355,'锐利',1,10,8,240,1000,'[{3,3550}]',54100,11000003,'破甲<color=#4eae1aff>+3550</color>'),(3000,356,'锐利',1,10,8,240,1000,'[{3,3560}]',54250,11000003,'破甲<color=#4eae1aff>+3560</color>'),(3000,357,'锐利',1,10,8,240,1000,'[{3,3570}]',54400,11000003,'破甲<color=#4eae1aff>+3570</color>'),(3000,358,'锐利',1,10,8,240,1000,'[{3,3580}]',54550,11000003,'破甲<color=#4eae1aff>+3580</color>'),(3000,359,'锐利',1,10,8,240,1000,'[{3,3590}]',54700,11000003,'破甲<color=#4eae1aff>+3590</color>'),(3000,360,'锐利',1,10,8,240,1000,'[{3,3600}]',54850,11000003,'破甲<color=#4eae1aff>+3600</color>'),(3000,361,'锐利',1,10,8,240,1000,'[{3,3610}]',55000,11000003,'破甲<color=#4eae1aff>+3610</color>'),(3000,362,'锐利',1,10,8,240,1000,'[{3,3620}]',55150,11000003,'破甲<color=#4eae1aff>+3620</color>'),(3000,363,'锐利',1,10,8,240,1000,'[{3,3630}]',55300,11000003,'破甲<color=#4eae1aff>+3630</color>'),(3000,364,'锐利',1,10,8,240,1000,'[{3,3640}]',55450,11000003,'破甲<color=#4eae1aff>+3640</color>'),(3000,365,'锐利',1,10,8,240,1000,'[{3,3650}]',55600,11000003,'破甲<color=#4eae1aff>+3650</color>'),(3000,366,'锐利',1,10,8,240,1000,'[{3,3660}]',55750,11000003,'破甲<color=#4eae1aff>+3660</color>'),(3000,367,'锐利',1,10,8,240,1000,'[{3,3670}]',55900,11000003,'破甲<color=#4eae1aff>+3670</color>'),(3000,368,'锐利',1,10,8,240,1000,'[{3,3680}]',56050,11000003,'破甲<color=#4eae1aff>+3680</color>'),(3000,369,'锐利',1,10,8,240,1000,'[{3,3690}]',56200,11000003,'破甲<color=#4eae1aff>+3690</color>'),(3000,370,'锐利',1,10,8,240,1000,'[{3,3700}]',56350,11000003,'破甲<color=#4eae1aff>+3700</color>'),(3000,371,'锐利',1,10,8,240,1000,'[{3,3710}]',56500,11000003,'破甲<color=#4eae1aff>+3710</color>'),(3000,372,'锐利',1,10,8,240,1000,'[{3,3720}]',56650,11000003,'破甲<color=#4eae1aff>+3720</color>'),(3000,373,'锐利',1,10,8,240,1000,'[{3,3730}]',56800,11000003,'破甲<color=#4eae1aff>+3730</color>'),(3000,374,'锐利',1,10,8,240,1000,'[{3,3740}]',56950,11000003,'破甲<color=#4eae1aff>+3740</color>'),(3000,375,'锐利',1,10,8,240,1000,'[{3,3750}]',57100,11000003,'破甲<color=#4eae1aff>+3750</color>'),(3000,376,'锐利',1,10,8,240,1000,'[{3,3760}]',57250,11000003,'破甲<color=#4eae1aff>+3760</color>'),(3000,377,'锐利',1,10,8,240,1000,'[{3,3770}]',57400,11000003,'破甲<color=#4eae1aff>+3770</color>'),(3000,378,'锐利',1,10,8,240,1000,'[{3,3780}]',57550,11000003,'破甲<color=#4eae1aff>+3780</color>'),(3000,379,'锐利',1,10,8,240,1000,'[{3,3790}]',57700,11000003,'破甲<color=#4eae1aff>+3790</color>'),(3000,380,'锐利',1,10,8,240,1000,'[{3,3800}]',57850,11000003,'破甲<color=#4eae1aff>+3800</color>'),(3000,381,'锐利',1,10,8,240,1000,'[{3,3810}]',58000,11000003,'破甲<color=#4eae1aff>+3810</color>'),(3000,382,'锐利',1,10,8,240,1000,'[{3,3820}]',58150,11000003,'破甲<color=#4eae1aff>+3820</color>'),(3000,383,'锐利',1,10,8,240,1000,'[{3,3830}]',58300,11000003,'破甲<color=#4eae1aff>+3830</color>'),(3000,384,'锐利',1,10,8,240,1000,'[{3,3840}]',58450,11000003,'破甲<color=#4eae1aff>+3840</color>'),(3000,385,'锐利',1,10,8,240,1000,'[{3,3850}]',58600,11000003,'破甲<color=#4eae1aff>+3850</color>'),(3000,386,'锐利',1,10,8,240,1000,'[{3,3860}]',58750,11000003,'破甲<color=#4eae1aff>+3860</color>'),(3000,387,'锐利',1,10,8,240,1000,'[{3,3870}]',58900,11000003,'破甲<color=#4eae1aff>+3870</color>'),(3000,388,'锐利',1,10,8,240,1000,'[{3,3880}]',59050,11000003,'破甲<color=#4eae1aff>+3880</color>'),(3000,389,'锐利',1,10,8,240,1000,'[{3,3890}]',59200,11000003,'破甲<color=#4eae1aff>+3890</color>'),(3000,390,'锐利',1,10,8,240,1000,'[{3,3900}]',59350,11000003,'破甲<color=#4eae1aff>+3900</color>'),(3000,391,'锐利',1,10,8,240,1000,'[{3,3910}]',59500,11000003,'破甲<color=#4eae1aff>+3910</color>'),(3000,392,'锐利',1,10,8,240,1000,'[{3,3920}]',59650,11000003,'破甲<color=#4eae1aff>+3920</color>'),(3000,393,'锐利',1,10,8,240,1000,'[{3,3930}]',59800,11000003,'破甲<color=#4eae1aff>+3930</color>'),(3000,394,'锐利',1,10,8,240,1000,'[{3,3940}]',59950,11000003,'破甲<color=#4eae1aff>+3940</color>'),(3000,395,'锐利',1,10,8,240,1000,'[{3,3950}]',60100,11000003,'破甲<color=#4eae1aff>+3950</color>'),(3000,396,'锐利',1,10,8,240,1000,'[{3,3960}]',60250,11000003,'破甲<color=#4eae1aff>+3960</color>'),(3000,397,'锐利',1,10,8,240,1000,'[{3,3970}]',60400,11000003,'破甲<color=#4eae1aff>+3970</color>'),(3000,398,'锐利',1,10,8,240,1000,'[{3,3980}]',60550,11000003,'破甲<color=#4eae1aff>+3980</color>'),(3000,399,'锐利',1,10,8,240,1000,'[{3,3990}]',60700,11000003,'破甲<color=#4eae1aff>+3990</color>'),(3000,400,'锐利',1,10,8,240,1000,'[{3,4000}]',60850,11000003,'破甲<color=#4eae1aff>+4000</color>'),(3000,401,'锐利',1,10,9,240,1000,'[{3,4010}]',61000,11000003,'破甲<color=#4eae1aff>+4010</color>'),(3000,402,'锐利',1,10,9,240,1000,'[{3,4020}]',61150,11000003,'破甲<color=#4eae1aff>+4020</color>'),(3000,403,'锐利',1,10,9,240,1000,'[{3,4030}]',61300,11000003,'破甲<color=#4eae1aff>+4030</color>'),(3000,404,'锐利',1,10,9,240,1000,'[{3,4040}]',61450,11000003,'破甲<color=#4eae1aff>+4040</color>'),(3000,405,'锐利',1,10,9,240,1000,'[{3,4050}]',61600,11000003,'破甲<color=#4eae1aff>+4050</color>'),(3000,406,'锐利',1,10,9,240,1000,'[{3,4060}]',61750,11000003,'破甲<color=#4eae1aff>+4060</color>'),(3000,407,'锐利',1,10,9,240,1000,'[{3,4070}]',61900,11000003,'破甲<color=#4eae1aff>+4070</color>'),(3000,408,'锐利',1,10,9,240,1000,'[{3,4080}]',62050,11000003,'破甲<color=#4eae1aff>+4080</color>'),(3000,409,'锐利',1,10,9,240,1000,'[{3,4090}]',62200,11000003,'破甲<color=#4eae1aff>+4090</color>'),(3000,410,'锐利',1,10,9,240,1000,'[{3,4100}]',62350,11000003,'破甲<color=#4eae1aff>+4100</color>'),(3000,411,'锐利',1,10,9,240,1000,'[{3,4110}]',62500,11000003,'破甲<color=#4eae1aff>+4110</color>'),(3000,412,'锐利',1,10,9,240,1000,'[{3,4120}]',62650,11000003,'破甲<color=#4eae1aff>+4120</color>'),(3000,413,'锐利',1,10,9,240,1000,'[{3,4130}]',62800,11000003,'破甲<color=#4eae1aff>+4130</color>'),(3000,414,'锐利',1,10,9,240,1000,'[{3,4140}]',62950,11000003,'破甲<color=#4eae1aff>+4140</color>'),(3000,415,'锐利',1,10,9,240,1000,'[{3,4150}]',63100,11000003,'破甲<color=#4eae1aff>+4150</color>'),(3000,416,'锐利',1,10,9,240,1000,'[{3,4160}]',63250,11000003,'破甲<color=#4eae1aff>+4160</color>'),(3000,417,'锐利',1,10,9,240,1000,'[{3,4170}]',63400,11000003,'破甲<color=#4eae1aff>+4170</color>'),(3000,418,'锐利',1,10,9,240,1000,'[{3,4180}]',63550,11000003,'破甲<color=#4eae1aff>+4180</color>'),(3000,419,'锐利',1,10,9,240,1000,'[{3,4190}]',63700,11000003,'破甲<color=#4eae1aff>+4190</color>'),(3000,420,'锐利',1,10,9,240,1000,'[{3,4200}]',63850,11000003,'破甲<color=#4eae1aff>+4200</color>'),(3000,421,'锐利',1,10,9,240,1000,'[{3,4210}]',64000,11000003,'破甲<color=#4eae1aff>+4210</color>'),(3000,422,'锐利',1,10,9,240,1000,'[{3,4220}]',64150,11000003,'破甲<color=#4eae1aff>+4220</color>'),(3000,423,'锐利',1,10,9,240,1000,'[{3,4230}]',64300,11000003,'破甲<color=#4eae1aff>+4230</color>'),(3000,424,'锐利',1,10,9,240,1000,'[{3,4240}]',64450,11000003,'破甲<color=#4eae1aff>+4240</color>'),(3000,425,'锐利',1,10,9,240,1000,'[{3,4250}]',64600,11000003,'破甲<color=#4eae1aff>+4250</color>'),(3000,426,'锐利',1,10,9,240,1000,'[{3,4260}]',64750,11000003,'破甲<color=#4eae1aff>+4260</color>'),(3000,427,'锐利',1,10,9,240,1000,'[{3,4270}]',64900,11000003,'破甲<color=#4eae1aff>+4270</color>'),(3000,428,'锐利',1,10,9,240,1000,'[{3,4280}]',65050,11000003,'破甲<color=#4eae1aff>+4280</color>'),(3000,429,'锐利',1,10,9,240,1000,'[{3,4290}]',65200,11000003,'破甲<color=#4eae1aff>+4290</color>'),(3000,430,'锐利',1,10,9,240,1000,'[{3,4300}]',65350,11000003,'破甲<color=#4eae1aff>+4300</color>'),(3000,431,'锐利',1,10,9,240,1000,'[{3,4310}]',65500,11000003,'破甲<color=#4eae1aff>+4310</color>'),(3000,432,'锐利',1,10,9,240,1000,'[{3,4320}]',65650,11000003,'破甲<color=#4eae1aff>+4320</color>'),(3000,433,'锐利',1,10,9,240,1000,'[{3,4330}]',65800,11000003,'破甲<color=#4eae1aff>+4330</color>'),(3000,434,'锐利',1,10,9,240,1000,'[{3,4340}]',65950,11000003,'破甲<color=#4eae1aff>+4340</color>'),(3000,435,'锐利',1,10,9,240,1000,'[{3,4350}]',66100,11000003,'破甲<color=#4eae1aff>+4350</color>'),(3000,436,'锐利',1,10,9,240,1000,'[{3,4360}]',66250,11000003,'破甲<color=#4eae1aff>+4360</color>'),(3000,437,'锐利',1,10,9,240,1000,'[{3,4370}]',66400,11000003,'破甲<color=#4eae1aff>+4370</color>'),(3000,438,'锐利',1,10,9,240,1000,'[{3,4380}]',66550,11000003,'破甲<color=#4eae1aff>+4380</color>'),(3000,439,'锐利',1,10,9,240,1000,'[{3,4390}]',66700,11000003,'破甲<color=#4eae1aff>+4390</color>'),(3000,440,'锐利',1,10,9,240,1000,'[{3,4400}]',66850,11000003,'破甲<color=#4eae1aff>+4400</color>'),(3000,441,'锐利',1,10,9,240,1000,'[{3,4410}]',67000,11000003,'破甲<color=#4eae1aff>+4410</color>'),(3000,442,'锐利',1,10,9,240,1000,'[{3,4420}]',67150,11000003,'破甲<color=#4eae1aff>+4420</color>'),(3000,443,'锐利',1,10,9,240,1000,'[{3,4430}]',67300,11000003,'破甲<color=#4eae1aff>+4430</color>'),(3000,444,'锐利',1,10,9,240,1000,'[{3,4440}]',67450,11000003,'破甲<color=#4eae1aff>+4440</color>'),(3000,445,'锐利',1,10,9,240,1000,'[{3,4450}]',67600,11000003,'破甲<color=#4eae1aff>+4450</color>'),(3000,446,'锐利',1,10,9,240,1000,'[{3,4460}]',67750,11000003,'破甲<color=#4eae1aff>+4460</color>'),(3000,447,'锐利',1,10,9,240,1000,'[{3,4470}]',67900,11000003,'破甲<color=#4eae1aff>+4470</color>'),(3000,448,'锐利',1,10,9,240,1000,'[{3,4480}]',68050,11000003,'破甲<color=#4eae1aff>+4480</color>'),(3000,449,'锐利',1,10,9,240,1000,'[{3,4490}]',68200,11000003,'破甲<color=#4eae1aff>+4490</color>'),(3000,450,'锐利',1,10,9,240,1000,'[{3,4500}]',68350,11000003,'破甲<color=#4eae1aff>+4500</color>'),(3000,451,'锐利',1,10,10,240,1000,'[{3,4510}]',68500,11000003,'破甲<color=#4eae1aff>+4510</color>'),(3000,452,'锐利',1,10,10,240,1000,'[{3,4520}]',68650,11000003,'破甲<color=#4eae1aff>+4520</color>'),(3000,453,'锐利',1,10,10,240,1000,'[{3,4530}]',68800,11000003,'破甲<color=#4eae1aff>+4530</color>'),(3000,454,'锐利',1,10,10,240,1000,'[{3,4540}]',68950,11000003,'破甲<color=#4eae1aff>+4540</color>'),(3000,455,'锐利',1,10,10,240,1000,'[{3,4550}]',69100,11000003,'破甲<color=#4eae1aff>+4550</color>'),(3000,456,'锐利',1,10,10,240,1000,'[{3,4560}]',69250,11000003,'破甲<color=#4eae1aff>+4560</color>'),(3000,457,'锐利',1,10,10,240,1000,'[{3,4570}]',69400,11000003,'破甲<color=#4eae1aff>+4570</color>'),(3000,458,'锐利',1,10,10,240,1000,'[{3,4580}]',69550,11000003,'破甲<color=#4eae1aff>+4580</color>'),(3000,459,'锐利',1,10,10,240,1000,'[{3,4590}]',69700,11000003,'破甲<color=#4eae1aff>+4590</color>'),(3000,460,'锐利',1,10,10,240,1000,'[{3,4600}]',69850,11000003,'破甲<color=#4eae1aff>+4600</color>'),(3000,461,'锐利',1,10,10,240,1000,'[{3,4610}]',70000,11000003,'破甲<color=#4eae1aff>+4610</color>'),(3000,462,'锐利',1,10,10,240,1000,'[{3,4620}]',70150,11000003,'破甲<color=#4eae1aff>+4620</color>'),(3000,463,'锐利',1,10,10,240,1000,'[{3,4630}]',70300,11000003,'破甲<color=#4eae1aff>+4630</color>'),(3000,464,'锐利',1,10,10,240,1000,'[{3,4640}]',70450,11000003,'破甲<color=#4eae1aff>+4640</color>'),(3000,465,'锐利',1,10,10,240,1000,'[{3,4650}]',70600,11000003,'破甲<color=#4eae1aff>+4650</color>'),(3000,466,'锐利',1,10,10,240,1000,'[{3,4660}]',70750,11000003,'破甲<color=#4eae1aff>+4660</color>'),(3000,467,'锐利',1,10,10,240,1000,'[{3,4670}]',70900,11000003,'破甲<color=#4eae1aff>+4670</color>'),(3000,468,'锐利',1,10,10,240,1000,'[{3,4680}]',71050,11000003,'破甲<color=#4eae1aff>+4680</color>'),(3000,469,'锐利',1,10,10,240,1000,'[{3,4690}]',71200,11000003,'破甲<color=#4eae1aff>+4690</color>'),(3000,470,'锐利',1,10,10,240,1000,'[{3,4700}]',71350,11000003,'破甲<color=#4eae1aff>+4700</color>'),(3000,471,'锐利',1,10,10,240,1000,'[{3,4710}]',71500,11000003,'破甲<color=#4eae1aff>+4710</color>'),(3000,472,'锐利',1,10,10,240,1000,'[{3,4720}]',71650,11000003,'破甲<color=#4eae1aff>+4720</color>'),(3000,473,'锐利',1,10,10,240,1000,'[{3,4730}]',71800,11000003,'破甲<color=#4eae1aff>+4730</color>'),(3000,474,'锐利',1,10,10,240,1000,'[{3,4740}]',71950,11000003,'破甲<color=#4eae1aff>+4740</color>'),(3000,475,'锐利',1,10,10,240,1000,'[{3,4750}]',72100,11000003,'破甲<color=#4eae1aff>+4750</color>'),(3000,476,'锐利',1,10,10,240,1000,'[{3,4760}]',72250,11000003,'破甲<color=#4eae1aff>+4760</color>'),(3000,477,'锐利',1,10,10,240,1000,'[{3,4770}]',72400,11000003,'破甲<color=#4eae1aff>+4770</color>'),(3000,478,'锐利',1,10,10,240,1000,'[{3,4780}]',72550,11000003,'破甲<color=#4eae1aff>+4780</color>'),(3000,479,'锐利',1,10,10,240,1000,'[{3,4790}]',72700,11000003,'破甲<color=#4eae1aff>+4790</color>'),(3000,480,'锐利',1,10,10,240,1000,'[{3,4800}]',72850,11000003,'破甲<color=#4eae1aff>+4800</color>'),(3000,481,'锐利',1,10,10,240,1000,'[{3,4810}]',73000,11000003,'破甲<color=#4eae1aff>+4810</color>'),(3000,482,'锐利',1,10,10,240,1000,'[{3,4820}]',73150,11000003,'破甲<color=#4eae1aff>+4820</color>'),(3000,483,'锐利',1,10,10,240,1000,'[{3,4830}]',73300,11000003,'破甲<color=#4eae1aff>+4830</color>'),(3000,484,'锐利',1,10,10,240,1000,'[{3,4840}]',73450,11000003,'破甲<color=#4eae1aff>+4840</color>'),(3000,485,'锐利',1,10,10,240,1000,'[{3,4850}]',73600,11000003,'破甲<color=#4eae1aff>+4850</color>'),(3000,486,'锐利',1,10,10,240,1000,'[{3,4860}]',73750,11000003,'破甲<color=#4eae1aff>+4860</color>'),(3000,487,'锐利',1,10,10,240,1000,'[{3,4870}]',73900,11000003,'破甲<color=#4eae1aff>+4870</color>'),(3000,488,'锐利',1,10,10,240,1000,'[{3,4880}]',74050,11000003,'破甲<color=#4eae1aff>+4880</color>'),(3000,489,'锐利',1,10,10,240,1000,'[{3,4890}]',74200,11000003,'破甲<color=#4eae1aff>+4890</color>'),(3000,490,'锐利',1,10,10,240,1000,'[{3,4900}]',74350,11000003,'破甲<color=#4eae1aff>+4900</color>'),(3000,491,'锐利',1,10,10,240,1000,'[{3,4910}]',74500,11000003,'破甲<color=#4eae1aff>+4910</color>'),(3000,492,'锐利',1,10,10,240,1000,'[{3,4920}]',74650,11000003,'破甲<color=#4eae1aff>+4920</color>'),(3000,493,'锐利',1,10,10,240,1000,'[{3,4930}]',74800,11000003,'破甲<color=#4eae1aff>+4930</color>'),(3000,494,'锐利',1,10,10,240,1000,'[{3,4940}]',74950,11000003,'破甲<color=#4eae1aff>+4940</color>'),(3000,495,'锐利',1,10,10,240,1000,'[{3,4950}]',75100,11000003,'破甲<color=#4eae1aff>+4950</color>'),(3000,496,'锐利',1,10,10,240,1000,'[{3,4960}]',75250,11000003,'破甲<color=#4eae1aff>+4960</color>'),(3000,497,'锐利',1,10,10,240,1000,'[{3,4970}]',75400,11000003,'破甲<color=#4eae1aff>+4970</color>'),(3000,498,'锐利',1,10,10,240,1000,'[{3,4980}]',75550,11000003,'破甲<color=#4eae1aff>+4980</color>'),(3000,499,'锐利',1,10,10,240,1000,'[{3,4990}]',75700,11000003,'破甲<color=#4eae1aff>+4990</color>'),(3000,500,'锐利',1,10,10,240,1000,'[{3,5000}]',75850,11000003,'破甲<color=#4eae1aff>+5000</color>'),(4000,1,'顽石',1,10,1,240,1000,'[{4,10}]',1000,11000004,'防御<color=#4eae1aff>+10</color>'),(4000,2,'顽石',1,10,1,240,1000,'[{4,20}]',1150,11000004,'防御<color=#4eae1aff>+20</color>'),(4000,3,'顽石',1,10,1,240,1000,'[{4,30}]',1300,11000004,'防御<color=#4eae1aff>+30</color>'),(4000,4,'顽石',1,10,1,240,1000,'[{4,40}]',1450,11000004,'防御<color=#4eae1aff>+40</color>'),(4000,5,'顽石',1,10,1,240,1000,'[{4,50}]',1600,11000004,'防御<color=#4eae1aff>+50</color>'),(4000,6,'顽石',1,10,1,240,1000,'[{4,60}]',1750,11000004,'防御<color=#4eae1aff>+60</color>'),(4000,7,'顽石',1,10,1,240,1000,'[{4,70}]',1900,11000004,'防御<color=#4eae1aff>+70</color>'),(4000,8,'顽石',1,10,1,240,1000,'[{4,80}]',2050,11000004,'防御<color=#4eae1aff>+80</color>'),(4000,9,'顽石',1,10,1,240,1000,'[{4,90}]',2200,11000004,'防御<color=#4eae1aff>+90</color>'),(4000,10,'顽石',1,10,1,240,1000,'[{4,100}]',2350,11000004,'防御<color=#4eae1aff>+100</color>'),(4000,11,'顽石',1,10,1,240,1000,'[{4,110}]',2500,11000004,'防御<color=#4eae1aff>+110</color>'),(4000,12,'顽石',1,10,1,240,1000,'[{4,120}]',2650,11000004,'防御<color=#4eae1aff>+120</color>'),(4000,13,'顽石',1,10,1,240,1000,'[{4,130}]',2800,11000004,'防御<color=#4eae1aff>+130</color>'),(4000,14,'顽石',1,10,1,240,1000,'[{4,140}]',2950,11000004,'防御<color=#4eae1aff>+140</color>'),(4000,15,'顽石',1,10,1,240,1000,'[{4,150}]',3100,11000004,'防御<color=#4eae1aff>+150</color>'),(4000,16,'顽石',1,10,1,240,1000,'[{4,160}]',3250,11000004,'防御<color=#4eae1aff>+160</color>'),(4000,17,'顽石',1,10,1,240,1000,'[{4,170}]',3400,11000004,'防御<color=#4eae1aff>+170</color>'),(4000,18,'顽石',1,10,1,240,1000,'[{4,180}]',3550,11000004,'防御<color=#4eae1aff>+180</color>'),(4000,19,'顽石',1,10,1,240,1000,'[{4,190}]',3700,11000004,'防御<color=#4eae1aff>+190</color>'),(4000,20,'顽石',1,10,1,240,1000,'[{4,200}]',3850,11000004,'防御<color=#4eae1aff>+200</color>'),(4000,21,'顽石',1,10,1,240,1000,'[{4,210}]',4000,11000004,'防御<color=#4eae1aff>+210</color>'),(4000,22,'顽石',1,10,1,240,1000,'[{4,220}]',4150,11000004,'防御<color=#4eae1aff>+220</color>'),(4000,23,'顽石',1,10,1,240,1000,'[{4,230}]',4300,11000004,'防御<color=#4eae1aff>+230</color>'),(4000,24,'顽石',1,10,1,240,1000,'[{4,240}]',4450,11000004,'防御<color=#4eae1aff>+240</color>'),(4000,25,'顽石',1,10,1,240,1000,'[{4,250}]',4600,11000004,'防御<color=#4eae1aff>+250</color>'),(4000,26,'顽石',1,10,1,240,1000,'[{4,260}]',4750,11000004,'防御<color=#4eae1aff>+260</color>'),(4000,27,'顽石',1,10,1,240,1000,'[{4,270}]',4900,11000004,'防御<color=#4eae1aff>+270</color>'),(4000,28,'顽石',1,10,1,240,1000,'[{4,280}]',5050,11000004,'防御<color=#4eae1aff>+280</color>'),(4000,29,'顽石',1,10,1,240,1000,'[{4,290}]',5200,11000004,'防御<color=#4eae1aff>+290</color>'),(4000,30,'顽石',1,10,1,240,1000,'[{4,300}]',5350,11000004,'防御<color=#4eae1aff>+300</color>'),(4000,31,'顽石',1,10,1,240,1000,'[{4,310}]',5500,11000004,'防御<color=#4eae1aff>+310</color>'),(4000,32,'顽石',1,10,1,240,1000,'[{4,320}]',5650,11000004,'防御<color=#4eae1aff>+320</color>'),(4000,33,'顽石',1,10,1,240,1000,'[{4,330}]',5800,11000004,'防御<color=#4eae1aff>+330</color>'),(4000,34,'顽石',1,10,1,240,1000,'[{4,340}]',5950,11000004,'防御<color=#4eae1aff>+340</color>'),(4000,35,'顽石',1,10,1,240,1000,'[{4,350}]',6100,11000004,'防御<color=#4eae1aff>+350</color>'),(4000,36,'顽石',1,10,1,240,1000,'[{4,360}]',6250,11000004,'防御<color=#4eae1aff>+360</color>'),(4000,37,'顽石',1,10,1,240,1000,'[{4,370}]',6400,11000004,'防御<color=#4eae1aff>+370</color>'),(4000,38,'顽石',1,10,1,240,1000,'[{4,380}]',6550,11000004,'防御<color=#4eae1aff>+380</color>'),(4000,39,'顽石',1,10,1,240,1000,'[{4,390}]',6700,11000004,'防御<color=#4eae1aff>+390</color>'),(4000,40,'顽石',1,10,1,240,1000,'[{4,400}]',6850,11000004,'防御<color=#4eae1aff>+400</color>'),(4000,41,'顽石',1,10,1,240,1000,'[{4,410}]',7000,11000004,'防御<color=#4eae1aff>+410</color>'),(4000,42,'顽石',1,10,1,240,1000,'[{4,420}]',7150,11000004,'防御<color=#4eae1aff>+420</color>'),(4000,43,'顽石',1,10,1,240,1000,'[{4,430}]',7300,11000004,'防御<color=#4eae1aff>+430</color>'),(4000,44,'顽石',1,10,1,240,1000,'[{4,440}]',7450,11000004,'防御<color=#4eae1aff>+440</color>'),(4000,45,'顽石',1,10,1,240,1000,'[{4,450}]',7600,11000004,'防御<color=#4eae1aff>+450</color>'),(4000,46,'顽石',1,10,1,240,1000,'[{4,460}]',7750,11000004,'防御<color=#4eae1aff>+460</color>'),(4000,47,'顽石',1,10,1,240,1000,'[{4,470}]',7900,11000004,'防御<color=#4eae1aff>+470</color>'),(4000,48,'顽石',1,10,1,240,1000,'[{4,480}]',8050,11000004,'防御<color=#4eae1aff>+480</color>'),(4000,49,'顽石',1,10,1,240,1000,'[{4,490}]',8200,11000004,'防御<color=#4eae1aff>+490</color>'),(4000,50,'顽石',1,10,1,240,1000,'[{4,500}]',8350,11000004,'防御<color=#4eae1aff>+500</color>'),(4000,51,'顽石',1,10,2,240,1000,'[{4,510}]',8500,11000004,'防御<color=#4eae1aff>+510</color>'),(4000,52,'顽石',1,10,2,240,1000,'[{4,520}]',8650,11000004,'防御<color=#4eae1aff>+520</color>'),(4000,53,'顽石',1,10,2,240,1000,'[{4,530}]',8800,11000004,'防御<color=#4eae1aff>+530</color>'),(4000,54,'顽石',1,10,2,240,1000,'[{4,540}]',8950,11000004,'防御<color=#4eae1aff>+540</color>'),(4000,55,'顽石',1,10,2,240,1000,'[{4,550}]',9100,11000004,'防御<color=#4eae1aff>+550</color>'),(4000,56,'顽石',1,10,2,240,1000,'[{4,560}]',9250,11000004,'防御<color=#4eae1aff>+560</color>'),(4000,57,'顽石',1,10,2,240,1000,'[{4,570}]',9400,11000004,'防御<color=#4eae1aff>+570</color>'),(4000,58,'顽石',1,10,2,240,1000,'[{4,580}]',9550,11000004,'防御<color=#4eae1aff>+580</color>'),(4000,59,'顽石',1,10,2,240,1000,'[{4,590}]',9700,11000004,'防御<color=#4eae1aff>+590</color>'),(4000,60,'顽石',1,10,2,240,1000,'[{4,600}]',9850,11000004,'防御<color=#4eae1aff>+600</color>'),(4000,61,'顽石',1,10,2,240,1000,'[{4,610}]',10000,11000004,'防御<color=#4eae1aff>+610</color>'),(4000,62,'顽石',1,10,2,240,1000,'[{4,620}]',10150,11000004,'防御<color=#4eae1aff>+620</color>'),(4000,63,'顽石',1,10,2,240,1000,'[{4,630}]',10300,11000004,'防御<color=#4eae1aff>+630</color>'),(4000,64,'顽石',1,10,2,240,1000,'[{4,640}]',10450,11000004,'防御<color=#4eae1aff>+640</color>'),(4000,65,'顽石',1,10,2,240,1000,'[{4,650}]',10600,11000004,'防御<color=#4eae1aff>+650</color>'),(4000,66,'顽石',1,10,2,240,1000,'[{4,660}]',10750,11000004,'防御<color=#4eae1aff>+660</color>'),(4000,67,'顽石',1,10,2,240,1000,'[{4,670}]',10900,11000004,'防御<color=#4eae1aff>+670</color>'),(4000,68,'顽石',1,10,2,240,1000,'[{4,680}]',11050,11000004,'防御<color=#4eae1aff>+680</color>'),(4000,69,'顽石',1,10,2,240,1000,'[{4,690}]',11200,11000004,'防御<color=#4eae1aff>+690</color>'),(4000,70,'顽石',1,10,2,240,1000,'[{4,700}]',11350,11000004,'防御<color=#4eae1aff>+700</color>'),(4000,71,'顽石',1,10,2,240,1000,'[{4,710}]',11500,11000004,'防御<color=#4eae1aff>+710</color>'),(4000,72,'顽石',1,10,2,240,1000,'[{4,720}]',11650,11000004,'防御<color=#4eae1aff>+720</color>'),(4000,73,'顽石',1,10,2,240,1000,'[{4,730}]',11800,11000004,'防御<color=#4eae1aff>+730</color>'),(4000,74,'顽石',1,10,2,240,1000,'[{4,740}]',11950,11000004,'防御<color=#4eae1aff>+740</color>'),(4000,75,'顽石',1,10,2,240,1000,'[{4,750}]',12100,11000004,'防御<color=#4eae1aff>+750</color>'),(4000,76,'顽石',1,10,2,240,1000,'[{4,760}]',12250,11000004,'防御<color=#4eae1aff>+760</color>'),(4000,77,'顽石',1,10,2,240,1000,'[{4,770}]',12400,11000004,'防御<color=#4eae1aff>+770</color>'),(4000,78,'顽石',1,10,2,240,1000,'[{4,780}]',12550,11000004,'防御<color=#4eae1aff>+780</color>'),(4000,79,'顽石',1,10,2,240,1000,'[{4,790}]',12700,11000004,'防御<color=#4eae1aff>+790</color>'),(4000,80,'顽石',1,10,2,240,1000,'[{4,800}]',12850,11000004,'防御<color=#4eae1aff>+800</color>'),(4000,81,'顽石',1,10,2,240,1000,'[{4,810}]',13000,11000004,'防御<color=#4eae1aff>+810</color>'),(4000,82,'顽石',1,10,2,240,1000,'[{4,820}]',13150,11000004,'防御<color=#4eae1aff>+820</color>'),(4000,83,'顽石',1,10,2,240,1000,'[{4,830}]',13300,11000004,'防御<color=#4eae1aff>+830</color>'),(4000,84,'顽石',1,10,2,240,1000,'[{4,840}]',13450,11000004,'防御<color=#4eae1aff>+840</color>'),(4000,85,'顽石',1,10,2,240,1000,'[{4,850}]',13600,11000004,'防御<color=#4eae1aff>+850</color>'),(4000,86,'顽石',1,10,2,240,1000,'[{4,860}]',13750,11000004,'防御<color=#4eae1aff>+860</color>'),(4000,87,'顽石',1,10,2,240,1000,'[{4,870}]',13900,11000004,'防御<color=#4eae1aff>+870</color>'),(4000,88,'顽石',1,10,2,240,1000,'[{4,880}]',14050,11000004,'防御<color=#4eae1aff>+880</color>'),(4000,89,'顽石',1,10,2,240,1000,'[{4,890}]',14200,11000004,'防御<color=#4eae1aff>+890</color>'),(4000,90,'顽石',1,10,2,240,1000,'[{4,900}]',14350,11000004,'防御<color=#4eae1aff>+900</color>'),(4000,91,'顽石',1,10,2,240,1000,'[{4,910}]',14500,11000004,'防御<color=#4eae1aff>+910</color>'),(4000,92,'顽石',1,10,2,240,1000,'[{4,920}]',14650,11000004,'防御<color=#4eae1aff>+920</color>'),(4000,93,'顽石',1,10,2,240,1000,'[{4,930}]',14800,11000004,'防御<color=#4eae1aff>+930</color>'),(4000,94,'顽石',1,10,2,240,1000,'[{4,940}]',14950,11000004,'防御<color=#4eae1aff>+940</color>'),(4000,95,'顽石',1,10,2,240,1000,'[{4,950}]',15100,11000004,'防御<color=#4eae1aff>+950</color>'),(4000,96,'顽石',1,10,2,240,1000,'[{4,960}]',15250,11000004,'防御<color=#4eae1aff>+960</color>'),(4000,97,'顽石',1,10,2,240,1000,'[{4,970}]',15400,11000004,'防御<color=#4eae1aff>+970</color>'),(4000,98,'顽石',1,10,2,240,1000,'[{4,980}]',15550,11000004,'防御<color=#4eae1aff>+980</color>'),(4000,99,'顽石',1,10,2,240,1000,'[{4,990}]',15700,11000004,'防御<color=#4eae1aff>+990</color>'),(4000,100,'顽石',1,10,2,240,1000,'[{4,1000}]',15850,11000004,'防御<color=#4eae1aff>+1000</color>'),(4000,101,'顽石',1,10,3,240,1000,'[{4,1010}]',16000,11000004,'防御<color=#4eae1aff>+1010</color>'),(4000,102,'顽石',1,10,3,240,1000,'[{4,1020}]',16150,11000004,'防御<color=#4eae1aff>+1020</color>'),(4000,103,'顽石',1,10,3,240,1000,'[{4,1030}]',16300,11000004,'防御<color=#4eae1aff>+1030</color>'),(4000,104,'顽石',1,10,3,240,1000,'[{4,1040}]',16450,11000004,'防御<color=#4eae1aff>+1040</color>'),(4000,105,'顽石',1,10,3,240,1000,'[{4,1050}]',16600,11000004,'防御<color=#4eae1aff>+1050</color>'),(4000,106,'顽石',1,10,3,240,1000,'[{4,1060}]',16750,11000004,'防御<color=#4eae1aff>+1060</color>'),(4000,107,'顽石',1,10,3,240,1000,'[{4,1070}]',16900,11000004,'防御<color=#4eae1aff>+1070</color>'),(4000,108,'顽石',1,10,3,240,1000,'[{4,1080}]',17050,11000004,'防御<color=#4eae1aff>+1080</color>'),(4000,109,'顽石',1,10,3,240,1000,'[{4,1090}]',17200,11000004,'防御<color=#4eae1aff>+1090</color>'),(4000,110,'顽石',1,10,3,240,1000,'[{4,1100}]',17350,11000004,'防御<color=#4eae1aff>+1100</color>'),(4000,111,'顽石',1,10,3,240,1000,'[{4,1110}]',17500,11000004,'防御<color=#4eae1aff>+1110</color>'),(4000,112,'顽石',1,10,3,240,1000,'[{4,1120}]',17650,11000004,'防御<color=#4eae1aff>+1120</color>'),(4000,113,'顽石',1,10,3,240,1000,'[{4,1130}]',17800,11000004,'防御<color=#4eae1aff>+1130</color>'),(4000,114,'顽石',1,10,3,240,1000,'[{4,1140}]',17950,11000004,'防御<color=#4eae1aff>+1140</color>'),(4000,115,'顽石',1,10,3,240,1000,'[{4,1150}]',18100,11000004,'防御<color=#4eae1aff>+1150</color>'),(4000,116,'顽石',1,10,3,240,1000,'[{4,1160}]',18250,11000004,'防御<color=#4eae1aff>+1160</color>'),(4000,117,'顽石',1,10,3,240,1000,'[{4,1170}]',18400,11000004,'防御<color=#4eae1aff>+1170</color>'),(4000,118,'顽石',1,10,3,240,1000,'[{4,1180}]',18550,11000004,'防御<color=#4eae1aff>+1180</color>'),(4000,119,'顽石',1,10,3,240,1000,'[{4,1190}]',18700,11000004,'防御<color=#4eae1aff>+1190</color>'),(4000,120,'顽石',1,10,3,240,1000,'[{4,1200}]',18850,11000004,'防御<color=#4eae1aff>+1200</color>'),(4000,121,'顽石',1,10,3,240,1000,'[{4,1210}]',19000,11000004,'防御<color=#4eae1aff>+1210</color>'),(4000,122,'顽石',1,10,3,240,1000,'[{4,1220}]',19150,11000004,'防御<color=#4eae1aff>+1220</color>'),(4000,123,'顽石',1,10,3,240,1000,'[{4,1230}]',19300,11000004,'防御<color=#4eae1aff>+1230</color>'),(4000,124,'顽石',1,10,3,240,1000,'[{4,1240}]',19450,11000004,'防御<color=#4eae1aff>+1240</color>'),(4000,125,'顽石',1,10,3,240,1000,'[{4,1250}]',19600,11000004,'防御<color=#4eae1aff>+1250</color>'),(4000,126,'顽石',1,10,3,240,1000,'[{4,1260}]',19750,11000004,'防御<color=#4eae1aff>+1260</color>'),(4000,127,'顽石',1,10,3,240,1000,'[{4,1270}]',19900,11000004,'防御<color=#4eae1aff>+1270</color>'),(4000,128,'顽石',1,10,3,240,1000,'[{4,1280}]',20050,11000004,'防御<color=#4eae1aff>+1280</color>'),(4000,129,'顽石',1,10,3,240,1000,'[{4,1290}]',20200,11000004,'防御<color=#4eae1aff>+1290</color>'),(4000,130,'顽石',1,10,3,240,1000,'[{4,1300}]',20350,11000004,'防御<color=#4eae1aff>+1300</color>'),(4000,131,'顽石',1,10,3,240,1000,'[{4,1310}]',20500,11000004,'防御<color=#4eae1aff>+1310</color>'),(4000,132,'顽石',1,10,3,240,1000,'[{4,1320}]',20650,11000004,'防御<color=#4eae1aff>+1320</color>'),(4000,133,'顽石',1,10,3,240,1000,'[{4,1330}]',20800,11000004,'防御<color=#4eae1aff>+1330</color>'),(4000,134,'顽石',1,10,3,240,1000,'[{4,1340}]',20950,11000004,'防御<color=#4eae1aff>+1340</color>'),(4000,135,'顽石',1,10,3,240,1000,'[{4,1350}]',21100,11000004,'防御<color=#4eae1aff>+1350</color>'),(4000,136,'顽石',1,10,3,240,1000,'[{4,1360}]',21250,11000004,'防御<color=#4eae1aff>+1360</color>'),(4000,137,'顽石',1,10,3,240,1000,'[{4,1370}]',21400,11000004,'防御<color=#4eae1aff>+1370</color>'),(4000,138,'顽石',1,10,3,240,1000,'[{4,1380}]',21550,11000004,'防御<color=#4eae1aff>+1380</color>'),(4000,139,'顽石',1,10,3,240,1000,'[{4,1390}]',21700,11000004,'防御<color=#4eae1aff>+1390</color>'),(4000,140,'顽石',1,10,3,240,1000,'[{4,1400}]',21850,11000004,'防御<color=#4eae1aff>+1400</color>'),(4000,141,'顽石',1,10,3,240,1000,'[{4,1410}]',22000,11000004,'防御<color=#4eae1aff>+1410</color>'),(4000,142,'顽石',1,10,3,240,1000,'[{4,1420}]',22150,11000004,'防御<color=#4eae1aff>+1420</color>'),(4000,143,'顽石',1,10,3,240,1000,'[{4,1430}]',22300,11000004,'防御<color=#4eae1aff>+1430</color>'),(4000,144,'顽石',1,10,3,240,1000,'[{4,1440}]',22450,11000004,'防御<color=#4eae1aff>+1440</color>'),(4000,145,'顽石',1,10,3,240,1000,'[{4,1450}]',22600,11000004,'防御<color=#4eae1aff>+1450</color>'),(4000,146,'顽石',1,10,3,240,1000,'[{4,1460}]',22750,11000004,'防御<color=#4eae1aff>+1460</color>'),(4000,147,'顽石',1,10,3,240,1000,'[{4,1470}]',22900,11000004,'防御<color=#4eae1aff>+1470</color>'),(4000,148,'顽石',1,10,3,240,1000,'[{4,1480}]',23050,11000004,'防御<color=#4eae1aff>+1480</color>'),(4000,149,'顽石',1,10,3,240,1000,'[{4,1490}]',23200,11000004,'防御<color=#4eae1aff>+1490</color>'),(4000,150,'顽石',1,10,3,240,1000,'[{4,1500}]',23350,11000004,'防御<color=#4eae1aff>+1500</color>'),(4000,151,'顽石',1,10,4,240,1000,'[{4,1510}]',23500,11000004,'防御<color=#4eae1aff>+1510</color>'),(4000,152,'顽石',1,10,4,240,1000,'[{4,1520}]',23650,11000004,'防御<color=#4eae1aff>+1520</color>'),(4000,153,'顽石',1,10,4,240,1000,'[{4,1530}]',23800,11000004,'防御<color=#4eae1aff>+1530</color>'),(4000,154,'顽石',1,10,4,240,1000,'[{4,1540}]',23950,11000004,'防御<color=#4eae1aff>+1540</color>'),(4000,155,'顽石',1,10,4,240,1000,'[{4,1550}]',24100,11000004,'防御<color=#4eae1aff>+1550</color>'),(4000,156,'顽石',1,10,4,240,1000,'[{4,1560}]',24250,11000004,'防御<color=#4eae1aff>+1560</color>'),(4000,157,'顽石',1,10,4,240,1000,'[{4,1570}]',24400,11000004,'防御<color=#4eae1aff>+1570</color>'),(4000,158,'顽石',1,10,4,240,1000,'[{4,1580}]',24550,11000004,'防御<color=#4eae1aff>+1580</color>'),(4000,159,'顽石',1,10,4,240,1000,'[{4,1590}]',24700,11000004,'防御<color=#4eae1aff>+1590</color>'),(4000,160,'顽石',1,10,4,240,1000,'[{4,1600}]',24850,11000004,'防御<color=#4eae1aff>+1600</color>'),(4000,161,'顽石',1,10,4,240,1000,'[{4,1610}]',25000,11000004,'防御<color=#4eae1aff>+1610</color>'),(4000,162,'顽石',1,10,4,240,1000,'[{4,1620}]',25150,11000004,'防御<color=#4eae1aff>+1620</color>'),(4000,163,'顽石',1,10,4,240,1000,'[{4,1630}]',25300,11000004,'防御<color=#4eae1aff>+1630</color>'),(4000,164,'顽石',1,10,4,240,1000,'[{4,1640}]',25450,11000004,'防御<color=#4eae1aff>+1640</color>'),(4000,165,'顽石',1,10,4,240,1000,'[{4,1650}]',25600,11000004,'防御<color=#4eae1aff>+1650</color>'),(4000,166,'顽石',1,10,4,240,1000,'[{4,1660}]',25750,11000004,'防御<color=#4eae1aff>+1660</color>'),(4000,167,'顽石',1,10,4,240,1000,'[{4,1670}]',25900,11000004,'防御<color=#4eae1aff>+1670</color>'),(4000,168,'顽石',1,10,4,240,1000,'[{4,1680}]',26050,11000004,'防御<color=#4eae1aff>+1680</color>'),(4000,169,'顽石',1,10,4,240,1000,'[{4,1690}]',26200,11000004,'防御<color=#4eae1aff>+1690</color>'),(4000,170,'顽石',1,10,4,240,1000,'[{4,1700}]',26350,11000004,'防御<color=#4eae1aff>+1700</color>'),(4000,171,'顽石',1,10,4,240,1000,'[{4,1710}]',26500,11000004,'防御<color=#4eae1aff>+1710</color>'),(4000,172,'顽石',1,10,4,240,1000,'[{4,1720}]',26650,11000004,'防御<color=#4eae1aff>+1720</color>'),(4000,173,'顽石',1,10,4,240,1000,'[{4,1730}]',26800,11000004,'防御<color=#4eae1aff>+1730</color>'),(4000,174,'顽石',1,10,4,240,1000,'[{4,1740}]',26950,11000004,'防御<color=#4eae1aff>+1740</color>'),(4000,175,'顽石',1,10,4,240,1000,'[{4,1750}]',27100,11000004,'防御<color=#4eae1aff>+1750</color>'),(4000,176,'顽石',1,10,4,240,1000,'[{4,1760}]',27250,11000004,'防御<color=#4eae1aff>+1760</color>'),(4000,177,'顽石',1,10,4,240,1000,'[{4,1770}]',27400,11000004,'防御<color=#4eae1aff>+1770</color>'),(4000,178,'顽石',1,10,4,240,1000,'[{4,1780}]',27550,11000004,'防御<color=#4eae1aff>+1780</color>'),(4000,179,'顽石',1,10,4,240,1000,'[{4,1790}]',27700,11000004,'防御<color=#4eae1aff>+1790</color>'),(4000,180,'顽石',1,10,4,240,1000,'[{4,1800}]',27850,11000004,'防御<color=#4eae1aff>+1800</color>'),(4000,181,'顽石',1,10,4,240,1000,'[{4,1810}]',28000,11000004,'防御<color=#4eae1aff>+1810</color>'),(4000,182,'顽石',1,10,4,240,1000,'[{4,1820}]',28150,11000004,'防御<color=#4eae1aff>+1820</color>'),(4000,183,'顽石',1,10,4,240,1000,'[{4,1830}]',28300,11000004,'防御<color=#4eae1aff>+1830</color>'),(4000,184,'顽石',1,10,4,240,1000,'[{4,1840}]',28450,11000004,'防御<color=#4eae1aff>+1840</color>'),(4000,185,'顽石',1,10,4,240,1000,'[{4,1850}]',28600,11000004,'防御<color=#4eae1aff>+1850</color>'),(4000,186,'顽石',1,10,4,240,1000,'[{4,1860}]',28750,11000004,'防御<color=#4eae1aff>+1860</color>'),(4000,187,'顽石',1,10,4,240,1000,'[{4,1870}]',28900,11000004,'防御<color=#4eae1aff>+1870</color>'),(4000,188,'顽石',1,10,4,240,1000,'[{4,1880}]',29050,11000004,'防御<color=#4eae1aff>+1880</color>'),(4000,189,'顽石',1,10,4,240,1000,'[{4,1890}]',29200,11000004,'防御<color=#4eae1aff>+1890</color>'),(4000,190,'顽石',1,10,4,240,1000,'[{4,1900}]',29350,11000004,'防御<color=#4eae1aff>+1900</color>'),(4000,191,'顽石',1,10,4,240,1000,'[{4,1910}]',29500,11000004,'防御<color=#4eae1aff>+1910</color>'),(4000,192,'顽石',1,10,4,240,1000,'[{4,1920}]',29650,11000004,'防御<color=#4eae1aff>+1920</color>'),(4000,193,'顽石',1,10,4,240,1000,'[{4,1930}]',29800,11000004,'防御<color=#4eae1aff>+1930</color>'),(4000,194,'顽石',1,10,4,240,1000,'[{4,1940}]',29950,11000004,'防御<color=#4eae1aff>+1940</color>'),(4000,195,'顽石',1,10,4,240,1000,'[{4,1950}]',30100,11000004,'防御<color=#4eae1aff>+1950</color>'),(4000,196,'顽石',1,10,4,240,1000,'[{4,1960}]',30250,11000004,'防御<color=#4eae1aff>+1960</color>'),(4000,197,'顽石',1,10,4,240,1000,'[{4,1970}]',30400,11000004,'防御<color=#4eae1aff>+1970</color>'),(4000,198,'顽石',1,10,4,240,1000,'[{4,1980}]',30550,11000004,'防御<color=#4eae1aff>+1980</color>'),(4000,199,'顽石',1,10,4,240,1000,'[{4,1990}]',30700,11000004,'防御<color=#4eae1aff>+1990</color>'),(4000,200,'顽石',1,10,4,240,1000,'[{4,2000}]',30850,11000004,'防御<color=#4eae1aff>+2000</color>'),(4000,201,'顽石',1,10,5,240,1000,'[{4,2010}]',31000,11000004,'防御<color=#4eae1aff>+2010</color>'),(4000,202,'顽石',1,10,5,240,1000,'[{4,2020}]',31150,11000004,'防御<color=#4eae1aff>+2020</color>'),(4000,203,'顽石',1,10,5,240,1000,'[{4,2030}]',31300,11000004,'防御<color=#4eae1aff>+2030</color>'),(4000,204,'顽石',1,10,5,240,1000,'[{4,2040}]',31450,11000004,'防御<color=#4eae1aff>+2040</color>'),(4000,205,'顽石',1,10,5,240,1000,'[{4,2050}]',31600,11000004,'防御<color=#4eae1aff>+2050</color>'),(4000,206,'顽石',1,10,5,240,1000,'[{4,2060}]',31750,11000004,'防御<color=#4eae1aff>+2060</color>'),(4000,207,'顽石',1,10,5,240,1000,'[{4,2070}]',31900,11000004,'防御<color=#4eae1aff>+2070</color>'),(4000,208,'顽石',1,10,5,240,1000,'[{4,2080}]',32050,11000004,'防御<color=#4eae1aff>+2080</color>'),(4000,209,'顽石',1,10,5,240,1000,'[{4,2090}]',32200,11000004,'防御<color=#4eae1aff>+2090</color>'),(4000,210,'顽石',1,10,5,240,1000,'[{4,2100}]',32350,11000004,'防御<color=#4eae1aff>+2100</color>'),(4000,211,'顽石',1,10,5,240,1000,'[{4,2110}]',32500,11000004,'防御<color=#4eae1aff>+2110</color>'),(4000,212,'顽石',1,10,5,240,1000,'[{4,2120}]',32650,11000004,'防御<color=#4eae1aff>+2120</color>'),(4000,213,'顽石',1,10,5,240,1000,'[{4,2130}]',32800,11000004,'防御<color=#4eae1aff>+2130</color>'),(4000,214,'顽石',1,10,5,240,1000,'[{4,2140}]',32950,11000004,'防御<color=#4eae1aff>+2140</color>'),(4000,215,'顽石',1,10,5,240,1000,'[{4,2150}]',33100,11000004,'防御<color=#4eae1aff>+2150</color>'),(4000,216,'顽石',1,10,5,240,1000,'[{4,2160}]',33250,11000004,'防御<color=#4eae1aff>+2160</color>'),(4000,217,'顽石',1,10,5,240,1000,'[{4,2170}]',33400,11000004,'防御<color=#4eae1aff>+2170</color>'),(4000,218,'顽石',1,10,5,240,1000,'[{4,2180}]',33550,11000004,'防御<color=#4eae1aff>+2180</color>'),(4000,219,'顽石',1,10,5,240,1000,'[{4,2190}]',33700,11000004,'防御<color=#4eae1aff>+2190</color>'),(4000,220,'顽石',1,10,5,240,1000,'[{4,2200}]',33850,11000004,'防御<color=#4eae1aff>+2200</color>'),(4000,221,'顽石',1,10,5,240,1000,'[{4,2210}]',34000,11000004,'防御<color=#4eae1aff>+2210</color>'),(4000,222,'顽石',1,10,5,240,1000,'[{4,2220}]',34150,11000004,'防御<color=#4eae1aff>+2220</color>'),(4000,223,'顽石',1,10,5,240,1000,'[{4,2230}]',34300,11000004,'防御<color=#4eae1aff>+2230</color>'),(4000,224,'顽石',1,10,5,240,1000,'[{4,2240}]',34450,11000004,'防御<color=#4eae1aff>+2240</color>'),(4000,225,'顽石',1,10,5,240,1000,'[{4,2250}]',34600,11000004,'防御<color=#4eae1aff>+2250</color>'),(4000,226,'顽石',1,10,5,240,1000,'[{4,2260}]',34750,11000004,'防御<color=#4eae1aff>+2260</color>'),(4000,227,'顽石',1,10,5,240,1000,'[{4,2270}]',34900,11000004,'防御<color=#4eae1aff>+2270</color>'),(4000,228,'顽石',1,10,5,240,1000,'[{4,2280}]',35050,11000004,'防御<color=#4eae1aff>+2280</color>'),(4000,229,'顽石',1,10,5,240,1000,'[{4,2290}]',35200,11000004,'防御<color=#4eae1aff>+2290</color>'),(4000,230,'顽石',1,10,5,240,1000,'[{4,2300}]',35350,11000004,'防御<color=#4eae1aff>+2300</color>'),(4000,231,'顽石',1,10,5,240,1000,'[{4,2310}]',35500,11000004,'防御<color=#4eae1aff>+2310</color>'),(4000,232,'顽石',1,10,5,240,1000,'[{4,2320}]',35650,11000004,'防御<color=#4eae1aff>+2320</color>'),(4000,233,'顽石',1,10,5,240,1000,'[{4,2330}]',35800,11000004,'防御<color=#4eae1aff>+2330</color>'),(4000,234,'顽石',1,10,5,240,1000,'[{4,2340}]',35950,11000004,'防御<color=#4eae1aff>+2340</color>'),(4000,235,'顽石',1,10,5,240,1000,'[{4,2350}]',36100,11000004,'防御<color=#4eae1aff>+2350</color>'),(4000,236,'顽石',1,10,5,240,1000,'[{4,2360}]',36250,11000004,'防御<color=#4eae1aff>+2360</color>'),(4000,237,'顽石',1,10,5,240,1000,'[{4,2370}]',36400,11000004,'防御<color=#4eae1aff>+2370</color>'),(4000,238,'顽石',1,10,5,240,1000,'[{4,2380}]',36550,11000004,'防御<color=#4eae1aff>+2380</color>'),(4000,239,'顽石',1,10,5,240,1000,'[{4,2390}]',36700,11000004,'防御<color=#4eae1aff>+2390</color>'),(4000,240,'顽石',1,10,5,240,1000,'[{4,2400}]',36850,11000004,'防御<color=#4eae1aff>+2400</color>'),(4000,241,'顽石',1,10,5,240,1000,'[{4,2410}]',37000,11000004,'防御<color=#4eae1aff>+2410</color>'),(4000,242,'顽石',1,10,5,240,1000,'[{4,2420}]',37150,11000004,'防御<color=#4eae1aff>+2420</color>'),(4000,243,'顽石',1,10,5,240,1000,'[{4,2430}]',37300,11000004,'防御<color=#4eae1aff>+2430</color>'),(4000,244,'顽石',1,10,5,240,1000,'[{4,2440}]',37450,11000004,'防御<color=#4eae1aff>+2440</color>'),(4000,245,'顽石',1,10,5,240,1000,'[{4,2450}]',37600,11000004,'防御<color=#4eae1aff>+2450</color>'),(4000,246,'顽石',1,10,5,240,1000,'[{4,2460}]',37750,11000004,'防御<color=#4eae1aff>+2460</color>'),(4000,247,'顽石',1,10,5,240,1000,'[{4,2470}]',37900,11000004,'防御<color=#4eae1aff>+2470</color>'),(4000,248,'顽石',1,10,5,240,1000,'[{4,2480}]',38050,11000004,'防御<color=#4eae1aff>+2480</color>'),(4000,249,'顽石',1,10,5,240,1000,'[{4,2490}]',38200,11000004,'防御<color=#4eae1aff>+2490</color>'),(4000,250,'顽石',1,10,5,240,1000,'[{4,2500}]',38350,11000004,'防御<color=#4eae1aff>+2500</color>'),(4000,251,'顽石',1,10,6,240,1000,'[{4,2510}]',38500,11000004,'防御<color=#4eae1aff>+2510</color>'),(4000,252,'顽石',1,10,6,240,1000,'[{4,2520}]',38650,11000004,'防御<color=#4eae1aff>+2520</color>'),(4000,253,'顽石',1,10,6,240,1000,'[{4,2530}]',38800,11000004,'防御<color=#4eae1aff>+2530</color>'),(4000,254,'顽石',1,10,6,240,1000,'[{4,2540}]',38950,11000004,'防御<color=#4eae1aff>+2540</color>'),(4000,255,'顽石',1,10,6,240,1000,'[{4,2550}]',39100,11000004,'防御<color=#4eae1aff>+2550</color>'),(4000,256,'顽石',1,10,6,240,1000,'[{4,2560}]',39250,11000004,'防御<color=#4eae1aff>+2560</color>'),(4000,257,'顽石',1,10,6,240,1000,'[{4,2570}]',39400,11000004,'防御<color=#4eae1aff>+2570</color>'),(4000,258,'顽石',1,10,6,240,1000,'[{4,2580}]',39550,11000004,'防御<color=#4eae1aff>+2580</color>'),(4000,259,'顽石',1,10,6,240,1000,'[{4,2590}]',39700,11000004,'防御<color=#4eae1aff>+2590</color>'),(4000,260,'顽石',1,10,6,240,1000,'[{4,2600}]',39850,11000004,'防御<color=#4eae1aff>+2600</color>'),(4000,261,'顽石',1,10,6,240,1000,'[{4,2610}]',40000,11000004,'防御<color=#4eae1aff>+2610</color>'),(4000,262,'顽石',1,10,6,240,1000,'[{4,2620}]',40150,11000004,'防御<color=#4eae1aff>+2620</color>'),(4000,263,'顽石',1,10,6,240,1000,'[{4,2630}]',40300,11000004,'防御<color=#4eae1aff>+2630</color>'),(4000,264,'顽石',1,10,6,240,1000,'[{4,2640}]',40450,11000004,'防御<color=#4eae1aff>+2640</color>'),(4000,265,'顽石',1,10,6,240,1000,'[{4,2650}]',40600,11000004,'防御<color=#4eae1aff>+2650</color>'),(4000,266,'顽石',1,10,6,240,1000,'[{4,2660}]',40750,11000004,'防御<color=#4eae1aff>+2660</color>'),(4000,267,'顽石',1,10,6,240,1000,'[{4,2670}]',40900,11000004,'防御<color=#4eae1aff>+2670</color>'),(4000,268,'顽石',1,10,6,240,1000,'[{4,2680}]',41050,11000004,'防御<color=#4eae1aff>+2680</color>'),(4000,269,'顽石',1,10,6,240,1000,'[{4,2690}]',41200,11000004,'防御<color=#4eae1aff>+2690</color>'),(4000,270,'顽石',1,10,6,240,1000,'[{4,2700}]',41350,11000004,'防御<color=#4eae1aff>+2700</color>'),(4000,271,'顽石',1,10,6,240,1000,'[{4,2710}]',41500,11000004,'防御<color=#4eae1aff>+2710</color>'),(4000,272,'顽石',1,10,6,240,1000,'[{4,2720}]',41650,11000004,'防御<color=#4eae1aff>+2720</color>'),(4000,273,'顽石',1,10,6,240,1000,'[{4,2730}]',41800,11000004,'防御<color=#4eae1aff>+2730</color>'),(4000,274,'顽石',1,10,6,240,1000,'[{4,2740}]',41950,11000004,'防御<color=#4eae1aff>+2740</color>'),(4000,275,'顽石',1,10,6,240,1000,'[{4,2750}]',42100,11000004,'防御<color=#4eae1aff>+2750</color>'),(4000,276,'顽石',1,10,6,240,1000,'[{4,2760}]',42250,11000004,'防御<color=#4eae1aff>+2760</color>'),(4000,277,'顽石',1,10,6,240,1000,'[{4,2770}]',42400,11000004,'防御<color=#4eae1aff>+2770</color>'),(4000,278,'顽石',1,10,6,240,1000,'[{4,2780}]',42550,11000004,'防御<color=#4eae1aff>+2780</color>'),(4000,279,'顽石',1,10,6,240,1000,'[{4,2790}]',42700,11000004,'防御<color=#4eae1aff>+2790</color>'),(4000,280,'顽石',1,10,6,240,1000,'[{4,2800}]',42850,11000004,'防御<color=#4eae1aff>+2800</color>'),(4000,281,'顽石',1,10,6,240,1000,'[{4,2810}]',43000,11000004,'防御<color=#4eae1aff>+2810</color>'),(4000,282,'顽石',1,10,6,240,1000,'[{4,2820}]',43150,11000004,'防御<color=#4eae1aff>+2820</color>'),(4000,283,'顽石',1,10,6,240,1000,'[{4,2830}]',43300,11000004,'防御<color=#4eae1aff>+2830</color>'),(4000,284,'顽石',1,10,6,240,1000,'[{4,2840}]',43450,11000004,'防御<color=#4eae1aff>+2840</color>'),(4000,285,'顽石',1,10,6,240,1000,'[{4,2850}]',43600,11000004,'防御<color=#4eae1aff>+2850</color>'),(4000,286,'顽石',1,10,6,240,1000,'[{4,2860}]',43750,11000004,'防御<color=#4eae1aff>+2860</color>'),(4000,287,'顽石',1,10,6,240,1000,'[{4,2870}]',43900,11000004,'防御<color=#4eae1aff>+2870</color>'),(4000,288,'顽石',1,10,6,240,1000,'[{4,2880}]',44050,11000004,'防御<color=#4eae1aff>+2880</color>'),(4000,289,'顽石',1,10,6,240,1000,'[{4,2890}]',44200,11000004,'防御<color=#4eae1aff>+2890</color>'),(4000,290,'顽石',1,10,6,240,1000,'[{4,2900}]',44350,11000004,'防御<color=#4eae1aff>+2900</color>'),(4000,291,'顽石',1,10,6,240,1000,'[{4,2910}]',44500,11000004,'防御<color=#4eae1aff>+2910</color>'),(4000,292,'顽石',1,10,6,240,1000,'[{4,2920}]',44650,11000004,'防御<color=#4eae1aff>+2920</color>'),(4000,293,'顽石',1,10,6,240,1000,'[{4,2930}]',44800,11000004,'防御<color=#4eae1aff>+2930</color>'),(4000,294,'顽石',1,10,6,240,1000,'[{4,2940}]',44950,11000004,'防御<color=#4eae1aff>+2940</color>'),(4000,295,'顽石',1,10,6,240,1000,'[{4,2950}]',45100,11000004,'防御<color=#4eae1aff>+2950</color>'),(4000,296,'顽石',1,10,6,240,1000,'[{4,2960}]',45250,11000004,'防御<color=#4eae1aff>+2960</color>'),(4000,297,'顽石',1,10,6,240,1000,'[{4,2970}]',45400,11000004,'防御<color=#4eae1aff>+2970</color>'),(4000,298,'顽石',1,10,6,240,1000,'[{4,2980}]',45550,11000004,'防御<color=#4eae1aff>+2980</color>'),(4000,299,'顽石',1,10,6,240,1000,'[{4,2990}]',45700,11000004,'防御<color=#4eae1aff>+2990</color>'),(4000,300,'顽石',1,10,6,240,1000,'[{4,3000}]',45850,11000004,'防御<color=#4eae1aff>+3000</color>'),(4000,301,'顽石',1,10,7,240,1000,'[{4,3010}]',46000,11000004,'防御<color=#4eae1aff>+3010</color>'),(4000,302,'顽石',1,10,7,240,1000,'[{4,3020}]',46150,11000004,'防御<color=#4eae1aff>+3020</color>'),(4000,303,'顽石',1,10,7,240,1000,'[{4,3030}]',46300,11000004,'防御<color=#4eae1aff>+3030</color>'),(4000,304,'顽石',1,10,7,240,1000,'[{4,3040}]',46450,11000004,'防御<color=#4eae1aff>+3040</color>'),(4000,305,'顽石',1,10,7,240,1000,'[{4,3050}]',46600,11000004,'防御<color=#4eae1aff>+3050</color>'),(4000,306,'顽石',1,10,7,240,1000,'[{4,3060}]',46750,11000004,'防御<color=#4eae1aff>+3060</color>'),(4000,307,'顽石',1,10,7,240,1000,'[{4,3070}]',46900,11000004,'防御<color=#4eae1aff>+3070</color>'),(4000,308,'顽石',1,10,7,240,1000,'[{4,3080}]',47050,11000004,'防御<color=#4eae1aff>+3080</color>'),(4000,309,'顽石',1,10,7,240,1000,'[{4,3090}]',47200,11000004,'防御<color=#4eae1aff>+3090</color>'),(4000,310,'顽石',1,10,7,240,1000,'[{4,3100}]',47350,11000004,'防御<color=#4eae1aff>+3100</color>'),(4000,311,'顽石',1,10,7,240,1000,'[{4,3110}]',47500,11000004,'防御<color=#4eae1aff>+3110</color>'),(4000,312,'顽石',1,10,7,240,1000,'[{4,3120}]',47650,11000004,'防御<color=#4eae1aff>+3120</color>'),(4000,313,'顽石',1,10,7,240,1000,'[{4,3130}]',47800,11000004,'防御<color=#4eae1aff>+3130</color>'),(4000,314,'顽石',1,10,7,240,1000,'[{4,3140}]',47950,11000004,'防御<color=#4eae1aff>+3140</color>'),(4000,315,'顽石',1,10,7,240,1000,'[{4,3150}]',48100,11000004,'防御<color=#4eae1aff>+3150</color>'),(4000,316,'顽石',1,10,7,240,1000,'[{4,3160}]',48250,11000004,'防御<color=#4eae1aff>+3160</color>'),(4000,317,'顽石',1,10,7,240,1000,'[{4,3170}]',48400,11000004,'防御<color=#4eae1aff>+3170</color>'),(4000,318,'顽石',1,10,7,240,1000,'[{4,3180}]',48550,11000004,'防御<color=#4eae1aff>+3180</color>'),(4000,319,'顽石',1,10,7,240,1000,'[{4,3190}]',48700,11000004,'防御<color=#4eae1aff>+3190</color>'),(4000,320,'顽石',1,10,7,240,1000,'[{4,3200}]',48850,11000004,'防御<color=#4eae1aff>+3200</color>'),(4000,321,'顽石',1,10,7,240,1000,'[{4,3210}]',49000,11000004,'防御<color=#4eae1aff>+3210</color>'),(4000,322,'顽石',1,10,7,240,1000,'[{4,3220}]',49150,11000004,'防御<color=#4eae1aff>+3220</color>'),(4000,323,'顽石',1,10,7,240,1000,'[{4,3230}]',49300,11000004,'防御<color=#4eae1aff>+3230</color>'),(4000,324,'顽石',1,10,7,240,1000,'[{4,3240}]',49450,11000004,'防御<color=#4eae1aff>+3240</color>'),(4000,325,'顽石',1,10,7,240,1000,'[{4,3250}]',49600,11000004,'防御<color=#4eae1aff>+3250</color>'),(4000,326,'顽石',1,10,7,240,1000,'[{4,3260}]',49750,11000004,'防御<color=#4eae1aff>+3260</color>'),(4000,327,'顽石',1,10,7,240,1000,'[{4,3270}]',49900,11000004,'防御<color=#4eae1aff>+3270</color>'),(4000,328,'顽石',1,10,7,240,1000,'[{4,3280}]',50050,11000004,'防御<color=#4eae1aff>+3280</color>'),(4000,329,'顽石',1,10,7,240,1000,'[{4,3290}]',50200,11000004,'防御<color=#4eae1aff>+3290</color>'),(4000,330,'顽石',1,10,7,240,1000,'[{4,3300}]',50350,11000004,'防御<color=#4eae1aff>+3300</color>'),(4000,331,'顽石',1,10,7,240,1000,'[{4,3310}]',50500,11000004,'防御<color=#4eae1aff>+3310</color>'),(4000,332,'顽石',1,10,7,240,1000,'[{4,3320}]',50650,11000004,'防御<color=#4eae1aff>+3320</color>'),(4000,333,'顽石',1,10,7,240,1000,'[{4,3330}]',50800,11000004,'防御<color=#4eae1aff>+3330</color>'),(4000,334,'顽石',1,10,7,240,1000,'[{4,3340}]',50950,11000004,'防御<color=#4eae1aff>+3340</color>'),(4000,335,'顽石',1,10,7,240,1000,'[{4,3350}]',51100,11000004,'防御<color=#4eae1aff>+3350</color>'),(4000,336,'顽石',1,10,7,240,1000,'[{4,3360}]',51250,11000004,'防御<color=#4eae1aff>+3360</color>'),(4000,337,'顽石',1,10,7,240,1000,'[{4,3370}]',51400,11000004,'防御<color=#4eae1aff>+3370</color>'),(4000,338,'顽石',1,10,7,240,1000,'[{4,3380}]',51550,11000004,'防御<color=#4eae1aff>+3380</color>'),(4000,339,'顽石',1,10,7,240,1000,'[{4,3390}]',51700,11000004,'防御<color=#4eae1aff>+3390</color>'),(4000,340,'顽石',1,10,7,240,1000,'[{4,3400}]',51850,11000004,'防御<color=#4eae1aff>+3400</color>'),(4000,341,'顽石',1,10,7,240,1000,'[{4,3410}]',52000,11000004,'防御<color=#4eae1aff>+3410</color>'),(4000,342,'顽石',1,10,7,240,1000,'[{4,3420}]',52150,11000004,'防御<color=#4eae1aff>+3420</color>'),(4000,343,'顽石',1,10,7,240,1000,'[{4,3430}]',52300,11000004,'防御<color=#4eae1aff>+3430</color>'),(4000,344,'顽石',1,10,7,240,1000,'[{4,3440}]',52450,11000004,'防御<color=#4eae1aff>+3440</color>'),(4000,345,'顽石',1,10,7,240,1000,'[{4,3450}]',52600,11000004,'防御<color=#4eae1aff>+3450</color>'),(4000,346,'顽石',1,10,7,240,1000,'[{4,3460}]',52750,11000004,'防御<color=#4eae1aff>+3460</color>'),(4000,347,'顽石',1,10,7,240,1000,'[{4,3470}]',52900,11000004,'防御<color=#4eae1aff>+3470</color>'),(4000,348,'顽石',1,10,7,240,1000,'[{4,3480}]',53050,11000004,'防御<color=#4eae1aff>+3480</color>'),(4000,349,'顽石',1,10,7,240,1000,'[{4,3490}]',53200,11000004,'防御<color=#4eae1aff>+3490</color>'),(4000,350,'顽石',1,10,7,240,1000,'[{4,3500}]',53350,11000004,'防御<color=#4eae1aff>+3500</color>'),(4000,351,'顽石',1,10,8,240,1000,'[{4,3510}]',53500,11000004,'防御<color=#4eae1aff>+3510</color>'),(4000,352,'顽石',1,10,8,240,1000,'[{4,3520}]',53650,11000004,'防御<color=#4eae1aff>+3520</color>'),(4000,353,'顽石',1,10,8,240,1000,'[{4,3530}]',53800,11000004,'防御<color=#4eae1aff>+3530</color>'),(4000,354,'顽石',1,10,8,240,1000,'[{4,3540}]',53950,11000004,'防御<color=#4eae1aff>+3540</color>'),(4000,355,'顽石',1,10,8,240,1000,'[{4,3550}]',54100,11000004,'防御<color=#4eae1aff>+3550</color>'),(4000,356,'顽石',1,10,8,240,1000,'[{4,3560}]',54250,11000004,'防御<color=#4eae1aff>+3560</color>'),(4000,357,'顽石',1,10,8,240,1000,'[{4,3570}]',54400,11000004,'防御<color=#4eae1aff>+3570</color>'),(4000,358,'顽石',1,10,8,240,1000,'[{4,3580}]',54550,11000004,'防御<color=#4eae1aff>+3580</color>'),(4000,359,'顽石',1,10,8,240,1000,'[{4,3590}]',54700,11000004,'防御<color=#4eae1aff>+3590</color>'),(4000,360,'顽石',1,10,8,240,1000,'[{4,3600}]',54850,11000004,'防御<color=#4eae1aff>+3600</color>'),(4000,361,'顽石',1,10,8,240,1000,'[{4,3610}]',55000,11000004,'防御<color=#4eae1aff>+3610</color>'),(4000,362,'顽石',1,10,8,240,1000,'[{4,3620}]',55150,11000004,'防御<color=#4eae1aff>+3620</color>'),(4000,363,'顽石',1,10,8,240,1000,'[{4,3630}]',55300,11000004,'防御<color=#4eae1aff>+3630</color>'),(4000,364,'顽石',1,10,8,240,1000,'[{4,3640}]',55450,11000004,'防御<color=#4eae1aff>+3640</color>'),(4000,365,'顽石',1,10,8,240,1000,'[{4,3650}]',55600,11000004,'防御<color=#4eae1aff>+3650</color>'),(4000,366,'顽石',1,10,8,240,1000,'[{4,3660}]',55750,11000004,'防御<color=#4eae1aff>+3660</color>'),(4000,367,'顽石',1,10,8,240,1000,'[{4,3670}]',55900,11000004,'防御<color=#4eae1aff>+3670</color>'),(4000,368,'顽石',1,10,8,240,1000,'[{4,3680}]',56050,11000004,'防御<color=#4eae1aff>+3680</color>'),(4000,369,'顽石',1,10,8,240,1000,'[{4,3690}]',56200,11000004,'防御<color=#4eae1aff>+3690</color>'),(4000,370,'顽石',1,10,8,240,1000,'[{4,3700}]',56350,11000004,'防御<color=#4eae1aff>+3700</color>'),(4000,371,'顽石',1,10,8,240,1000,'[{4,3710}]',56500,11000004,'防御<color=#4eae1aff>+3710</color>'),(4000,372,'顽石',1,10,8,240,1000,'[{4,3720}]',56650,11000004,'防御<color=#4eae1aff>+3720</color>'),(4000,373,'顽石',1,10,8,240,1000,'[{4,3730}]',56800,11000004,'防御<color=#4eae1aff>+3730</color>'),(4000,374,'顽石',1,10,8,240,1000,'[{4,3740}]',56950,11000004,'防御<color=#4eae1aff>+3740</color>'),(4000,375,'顽石',1,10,8,240,1000,'[{4,3750}]',57100,11000004,'防御<color=#4eae1aff>+3750</color>'),(4000,376,'顽石',1,10,8,240,1000,'[{4,3760}]',57250,11000004,'防御<color=#4eae1aff>+3760</color>'),(4000,377,'顽石',1,10,8,240,1000,'[{4,3770}]',57400,11000004,'防御<color=#4eae1aff>+3770</color>'),(4000,378,'顽石',1,10,8,240,1000,'[{4,3780}]',57550,11000004,'防御<color=#4eae1aff>+3780</color>'),(4000,379,'顽石',1,10,8,240,1000,'[{4,3790}]',57700,11000004,'防御<color=#4eae1aff>+3790</color>'),(4000,380,'顽石',1,10,8,240,1000,'[{4,3800}]',57850,11000004,'防御<color=#4eae1aff>+3800</color>'),(4000,381,'顽石',1,10,8,240,1000,'[{4,3810}]',58000,11000004,'防御<color=#4eae1aff>+3810</color>'),(4000,382,'顽石',1,10,8,240,1000,'[{4,3820}]',58150,11000004,'防御<color=#4eae1aff>+3820</color>'),(4000,383,'顽石',1,10,8,240,1000,'[{4,3830}]',58300,11000004,'防御<color=#4eae1aff>+3830</color>'),(4000,384,'顽石',1,10,8,240,1000,'[{4,3840}]',58450,11000004,'防御<color=#4eae1aff>+3840</color>'),(4000,385,'顽石',1,10,8,240,1000,'[{4,3850}]',58600,11000004,'防御<color=#4eae1aff>+3850</color>'),(4000,386,'顽石',1,10,8,240,1000,'[{4,3860}]',58750,11000004,'防御<color=#4eae1aff>+3860</color>'),(4000,387,'顽石',1,10,8,240,1000,'[{4,3870}]',58900,11000004,'防御<color=#4eae1aff>+3870</color>'),(4000,388,'顽石',1,10,8,240,1000,'[{4,3880}]',59050,11000004,'防御<color=#4eae1aff>+3880</color>'),(4000,389,'顽石',1,10,8,240,1000,'[{4,3890}]',59200,11000004,'防御<color=#4eae1aff>+3890</color>'),(4000,390,'顽石',1,10,8,240,1000,'[{4,3900}]',59350,11000004,'防御<color=#4eae1aff>+3900</color>'),(4000,391,'顽石',1,10,8,240,1000,'[{4,3910}]',59500,11000004,'防御<color=#4eae1aff>+3910</color>'),(4000,392,'顽石',1,10,8,240,1000,'[{4,3920}]',59650,11000004,'防御<color=#4eae1aff>+3920</color>'),(4000,393,'顽石',1,10,8,240,1000,'[{4,3930}]',59800,11000004,'防御<color=#4eae1aff>+3930</color>'),(4000,394,'顽石',1,10,8,240,1000,'[{4,3940}]',59950,11000004,'防御<color=#4eae1aff>+3940</color>'),(4000,395,'顽石',1,10,8,240,1000,'[{4,3950}]',60100,11000004,'防御<color=#4eae1aff>+3950</color>'),(4000,396,'顽石',1,10,8,240,1000,'[{4,3960}]',60250,11000004,'防御<color=#4eae1aff>+3960</color>'),(4000,397,'顽石',1,10,8,240,1000,'[{4,3970}]',60400,11000004,'防御<color=#4eae1aff>+3970</color>'),(4000,398,'顽石',1,10,8,240,1000,'[{4,3980}]',60550,11000004,'防御<color=#4eae1aff>+3980</color>'),(4000,399,'顽石',1,10,8,240,1000,'[{4,3990}]',60700,11000004,'防御<color=#4eae1aff>+3990</color>'),(4000,400,'顽石',1,10,8,240,1000,'[{4,4000}]',60850,11000004,'防御<color=#4eae1aff>+4000</color>'),(4000,401,'顽石',1,10,9,240,1000,'[{4,4010}]',61000,11000004,'防御<color=#4eae1aff>+4010</color>'),(4000,402,'顽石',1,10,9,240,1000,'[{4,4020}]',61150,11000004,'防御<color=#4eae1aff>+4020</color>'),(4000,403,'顽石',1,10,9,240,1000,'[{4,4030}]',61300,11000004,'防御<color=#4eae1aff>+4030</color>'),(4000,404,'顽石',1,10,9,240,1000,'[{4,4040}]',61450,11000004,'防御<color=#4eae1aff>+4040</color>'),(4000,405,'顽石',1,10,9,240,1000,'[{4,4050}]',61600,11000004,'防御<color=#4eae1aff>+4050</color>'),(4000,406,'顽石',1,10,9,240,1000,'[{4,4060}]',61750,11000004,'防御<color=#4eae1aff>+4060</color>'),(4000,407,'顽石',1,10,9,240,1000,'[{4,4070}]',61900,11000004,'防御<color=#4eae1aff>+4070</color>'),(4000,408,'顽石',1,10,9,240,1000,'[{4,4080}]',62050,11000004,'防御<color=#4eae1aff>+4080</color>'),(4000,409,'顽石',1,10,9,240,1000,'[{4,4090}]',62200,11000004,'防御<color=#4eae1aff>+4090</color>'),(4000,410,'顽石',1,10,9,240,1000,'[{4,4100}]',62350,11000004,'防御<color=#4eae1aff>+4100</color>'),(4000,411,'顽石',1,10,9,240,1000,'[{4,4110}]',62500,11000004,'防御<color=#4eae1aff>+4110</color>'),(4000,412,'顽石',1,10,9,240,1000,'[{4,4120}]',62650,11000004,'防御<color=#4eae1aff>+4120</color>'),(4000,413,'顽石',1,10,9,240,1000,'[{4,4130}]',62800,11000004,'防御<color=#4eae1aff>+4130</color>'),(4000,414,'顽石',1,10,9,240,1000,'[{4,4140}]',62950,11000004,'防御<color=#4eae1aff>+4140</color>'),(4000,415,'顽石',1,10,9,240,1000,'[{4,4150}]',63100,11000004,'防御<color=#4eae1aff>+4150</color>'),(4000,416,'顽石',1,10,9,240,1000,'[{4,4160}]',63250,11000004,'防御<color=#4eae1aff>+4160</color>'),(4000,417,'顽石',1,10,9,240,1000,'[{4,4170}]',63400,11000004,'防御<color=#4eae1aff>+4170</color>'),(4000,418,'顽石',1,10,9,240,1000,'[{4,4180}]',63550,11000004,'防御<color=#4eae1aff>+4180</color>'),(4000,419,'顽石',1,10,9,240,1000,'[{4,4190}]',63700,11000004,'防御<color=#4eae1aff>+4190</color>'),(4000,420,'顽石',1,10,9,240,1000,'[{4,4200}]',63850,11000004,'防御<color=#4eae1aff>+4200</color>'),(4000,421,'顽石',1,10,9,240,1000,'[{4,4210}]',64000,11000004,'防御<color=#4eae1aff>+4210</color>'),(4000,422,'顽石',1,10,9,240,1000,'[{4,4220}]',64150,11000004,'防御<color=#4eae1aff>+4220</color>'),(4000,423,'顽石',1,10,9,240,1000,'[{4,4230}]',64300,11000004,'防御<color=#4eae1aff>+4230</color>'),(4000,424,'顽石',1,10,9,240,1000,'[{4,4240}]',64450,11000004,'防御<color=#4eae1aff>+4240</color>'),(4000,425,'顽石',1,10,9,240,1000,'[{4,4250}]',64600,11000004,'防御<color=#4eae1aff>+4250</color>'),(4000,426,'顽石',1,10,9,240,1000,'[{4,4260}]',64750,11000004,'防御<color=#4eae1aff>+4260</color>'),(4000,427,'顽石',1,10,9,240,1000,'[{4,4270}]',64900,11000004,'防御<color=#4eae1aff>+4270</color>'),(4000,428,'顽石',1,10,9,240,1000,'[{4,4280}]',65050,11000004,'防御<color=#4eae1aff>+4280</color>'),(4000,429,'顽石',1,10,9,240,1000,'[{4,4290}]',65200,11000004,'防御<color=#4eae1aff>+4290</color>'),(4000,430,'顽石',1,10,9,240,1000,'[{4,4300}]',65350,11000004,'防御<color=#4eae1aff>+4300</color>'),(4000,431,'顽石',1,10,9,240,1000,'[{4,4310}]',65500,11000004,'防御<color=#4eae1aff>+4310</color>'),(4000,432,'顽石',1,10,9,240,1000,'[{4,4320}]',65650,11000004,'防御<color=#4eae1aff>+4320</color>'),(4000,433,'顽石',1,10,9,240,1000,'[{4,4330}]',65800,11000004,'防御<color=#4eae1aff>+4330</color>'),(4000,434,'顽石',1,10,9,240,1000,'[{4,4340}]',65950,11000004,'防御<color=#4eae1aff>+4340</color>'),(4000,435,'顽石',1,10,9,240,1000,'[{4,4350}]',66100,11000004,'防御<color=#4eae1aff>+4350</color>'),(4000,436,'顽石',1,10,9,240,1000,'[{4,4360}]',66250,11000004,'防御<color=#4eae1aff>+4360</color>'),(4000,437,'顽石',1,10,9,240,1000,'[{4,4370}]',66400,11000004,'防御<color=#4eae1aff>+4370</color>'),(4000,438,'顽石',1,10,9,240,1000,'[{4,4380}]',66550,11000004,'防御<color=#4eae1aff>+4380</color>'),(4000,439,'顽石',1,10,9,240,1000,'[{4,4390}]',66700,11000004,'防御<color=#4eae1aff>+4390</color>'),(4000,440,'顽石',1,10,9,240,1000,'[{4,4400}]',66850,11000004,'防御<color=#4eae1aff>+4400</color>'),(4000,441,'顽石',1,10,9,240,1000,'[{4,4410}]',67000,11000004,'防御<color=#4eae1aff>+4410</color>'),(4000,442,'顽石',1,10,9,240,1000,'[{4,4420}]',67150,11000004,'防御<color=#4eae1aff>+4420</color>'),(4000,443,'顽石',1,10,9,240,1000,'[{4,4430}]',67300,11000004,'防御<color=#4eae1aff>+4430</color>'),(4000,444,'顽石',1,10,9,240,1000,'[{4,4440}]',67450,11000004,'防御<color=#4eae1aff>+4440</color>'),(4000,445,'顽石',1,10,9,240,1000,'[{4,4450}]',67600,11000004,'防御<color=#4eae1aff>+4450</color>'),(4000,446,'顽石',1,10,9,240,1000,'[{4,4460}]',67750,11000004,'防御<color=#4eae1aff>+4460</color>'),(4000,447,'顽石',1,10,9,240,1000,'[{4,4470}]',67900,11000004,'防御<color=#4eae1aff>+4470</color>'),(4000,448,'顽石',1,10,9,240,1000,'[{4,4480}]',68050,11000004,'防御<color=#4eae1aff>+4480</color>'),(4000,449,'顽石',1,10,9,240,1000,'[{4,4490}]',68200,11000004,'防御<color=#4eae1aff>+4490</color>'),(4000,450,'顽石',1,10,9,240,1000,'[{4,4500}]',68350,11000004,'防御<color=#4eae1aff>+4500</color>'),(4000,451,'顽石',1,10,10,240,1000,'[{4,4510}]',68500,11000004,'防御<color=#4eae1aff>+4510</color>'),(4000,452,'顽石',1,10,10,240,1000,'[{4,4520}]',68650,11000004,'防御<color=#4eae1aff>+4520</color>'),(4000,453,'顽石',1,10,10,240,1000,'[{4,4530}]',68800,11000004,'防御<color=#4eae1aff>+4530</color>'),(4000,454,'顽石',1,10,10,240,1000,'[{4,4540}]',68950,11000004,'防御<color=#4eae1aff>+4540</color>'),(4000,455,'顽石',1,10,10,240,1000,'[{4,4550}]',69100,11000004,'防御<color=#4eae1aff>+4550</color>'),(4000,456,'顽石',1,10,10,240,1000,'[{4,4560}]',69250,11000004,'防御<color=#4eae1aff>+4560</color>'),(4000,457,'顽石',1,10,10,240,1000,'[{4,4570}]',69400,11000004,'防御<color=#4eae1aff>+4570</color>'),(4000,458,'顽石',1,10,10,240,1000,'[{4,4580}]',69550,11000004,'防御<color=#4eae1aff>+4580</color>'),(4000,459,'顽石',1,10,10,240,1000,'[{4,4590}]',69700,11000004,'防御<color=#4eae1aff>+4590</color>'),(4000,460,'顽石',1,10,10,240,1000,'[{4,4600}]',69850,11000004,'防御<color=#4eae1aff>+4600</color>'),(4000,461,'顽石',1,10,10,240,1000,'[{4,4610}]',70000,11000004,'防御<color=#4eae1aff>+4610</color>'),(4000,462,'顽石',1,10,10,240,1000,'[{4,4620}]',70150,11000004,'防御<color=#4eae1aff>+4620</color>'),(4000,463,'顽石',1,10,10,240,1000,'[{4,4630}]',70300,11000004,'防御<color=#4eae1aff>+4630</color>'),(4000,464,'顽石',1,10,10,240,1000,'[{4,4640}]',70450,11000004,'防御<color=#4eae1aff>+4640</color>'),(4000,465,'顽石',1,10,10,240,1000,'[{4,4650}]',70600,11000004,'防御<color=#4eae1aff>+4650</color>'),(4000,466,'顽石',1,10,10,240,1000,'[{4,4660}]',70750,11000004,'防御<color=#4eae1aff>+4660</color>'),(4000,467,'顽石',1,10,10,240,1000,'[{4,4670}]',70900,11000004,'防御<color=#4eae1aff>+4670</color>'),(4000,468,'顽石',1,10,10,240,1000,'[{4,4680}]',71050,11000004,'防御<color=#4eae1aff>+4680</color>'),(4000,469,'顽石',1,10,10,240,1000,'[{4,4690}]',71200,11000004,'防御<color=#4eae1aff>+4690</color>'),(4000,470,'顽石',1,10,10,240,1000,'[{4,4700}]',71350,11000004,'防御<color=#4eae1aff>+4700</color>'),(4000,471,'顽石',1,10,10,240,1000,'[{4,4710}]',71500,11000004,'防御<color=#4eae1aff>+4710</color>'),(4000,472,'顽石',1,10,10,240,1000,'[{4,4720}]',71650,11000004,'防御<color=#4eae1aff>+4720</color>'),(4000,473,'顽石',1,10,10,240,1000,'[{4,4730}]',71800,11000004,'防御<color=#4eae1aff>+4730</color>'),(4000,474,'顽石',1,10,10,240,1000,'[{4,4740}]',71950,11000004,'防御<color=#4eae1aff>+4740</color>'),(4000,475,'顽石',1,10,10,240,1000,'[{4,4750}]',72100,11000004,'防御<color=#4eae1aff>+4750</color>'),(4000,476,'顽石',1,10,10,240,1000,'[{4,4760}]',72250,11000004,'防御<color=#4eae1aff>+4760</color>'),(4000,477,'顽石',1,10,10,240,1000,'[{4,4770}]',72400,11000004,'防御<color=#4eae1aff>+4770</color>'),(4000,478,'顽石',1,10,10,240,1000,'[{4,4780}]',72550,11000004,'防御<color=#4eae1aff>+4780</color>'),(4000,479,'顽石',1,10,10,240,1000,'[{4,4790}]',72700,11000004,'防御<color=#4eae1aff>+4790</color>'),(4000,480,'顽石',1,10,10,240,1000,'[{4,4800}]',72850,11000004,'防御<color=#4eae1aff>+4800</color>'),(4000,481,'顽石',1,10,10,240,1000,'[{4,4810}]',73000,11000004,'防御<color=#4eae1aff>+4810</color>'),(4000,482,'顽石',1,10,10,240,1000,'[{4,4820}]',73150,11000004,'防御<color=#4eae1aff>+4820</color>'),(4000,483,'顽石',1,10,10,240,1000,'[{4,4830}]',73300,11000004,'防御<color=#4eae1aff>+4830</color>'),(4000,484,'顽石',1,10,10,240,1000,'[{4,4840}]',73450,11000004,'防御<color=#4eae1aff>+4840</color>'),(4000,485,'顽石',1,10,10,240,1000,'[{4,4850}]',73600,11000004,'防御<color=#4eae1aff>+4850</color>'),(4000,486,'顽石',1,10,10,240,1000,'[{4,4860}]',73750,11000004,'防御<color=#4eae1aff>+4860</color>'),(4000,487,'顽石',1,10,10,240,1000,'[{4,4870}]',73900,11000004,'防御<color=#4eae1aff>+4870</color>'),(4000,488,'顽石',1,10,10,240,1000,'[{4,4880}]',74050,11000004,'防御<color=#4eae1aff>+4880</color>'),(4000,489,'顽石',1,10,10,240,1000,'[{4,4890}]',74200,11000004,'防御<color=#4eae1aff>+4890</color>'),(4000,490,'顽石',1,10,10,240,1000,'[{4,4900}]',74350,11000004,'防御<color=#4eae1aff>+4900</color>'),(4000,491,'顽石',1,10,10,240,1000,'[{4,4910}]',74500,11000004,'防御<color=#4eae1aff>+4910</color>'),(4000,492,'顽石',1,10,10,240,1000,'[{4,4920}]',74650,11000004,'防御<color=#4eae1aff>+4920</color>'),(4000,493,'顽石',1,10,10,240,1000,'[{4,4930}]',74800,11000004,'防御<color=#4eae1aff>+4930</color>'),(4000,494,'顽石',1,10,10,240,1000,'[{4,4940}]',74950,11000004,'防御<color=#4eae1aff>+4940</color>'),(4000,495,'顽石',1,10,10,240,1000,'[{4,4950}]',75100,11000004,'防御<color=#4eae1aff>+4950</color>'),(4000,496,'顽石',1,10,10,240,1000,'[{4,4960}]',75250,11000004,'防御<color=#4eae1aff>+4960</color>'),(4000,497,'顽石',1,10,10,240,1000,'[{4,4970}]',75400,11000004,'防御<color=#4eae1aff>+4970</color>'),(4000,498,'顽石',1,10,10,240,1000,'[{4,4980}]',75550,11000004,'防御<color=#4eae1aff>+4980</color>'),(4000,499,'顽石',1,10,10,240,1000,'[{4,4990}]',75700,11000004,'防御<color=#4eae1aff>+4990</color>'),(4000,500,'顽石',1,10,10,240,1000,'[{4,5000}]',75850,11000004,'防御<color=#4eae1aff>+5000</color>'),(5000,1,'鹰眼',1,10,1,420,1000,'[{5,5}]',1000,11000005,'命中<color=#4eae1aff>+5</color>'),(5000,2,'鹰眼',1,10,1,420,1000,'[{5,10}]',1150,11000005,'命中<color=#4eae1aff>+10</color>'),(5000,3,'鹰眼',1,10,1,420,1000,'[{5,15}]',1300,11000005,'命中<color=#4eae1aff>+15</color>'),(5000,4,'鹰眼',1,10,1,420,1000,'[{5,20}]',1450,11000005,'命中<color=#4eae1aff>+20</color>'),(5000,5,'鹰眼',1,10,1,420,1000,'[{5,25}]',1600,11000005,'命中<color=#4eae1aff>+25</color>'),(5000,6,'鹰眼',1,10,1,420,1000,'[{5,30}]',1750,11000005,'命中<color=#4eae1aff>+30</color>'),(5000,7,'鹰眼',1,10,1,420,1000,'[{5,35}]',1900,11000005,'命中<color=#4eae1aff>+35</color>'),(5000,8,'鹰眼',1,10,1,420,1000,'[{5,40}]',2050,11000005,'命中<color=#4eae1aff>+40</color>'),(5000,9,'鹰眼',1,10,1,420,1000,'[{5,45}]',2200,11000005,'命中<color=#4eae1aff>+45</color>'),(5000,10,'鹰眼',1,10,1,420,1000,'[{5,50}]',2350,11000005,'命中<color=#4eae1aff>+50</color>'),(5000,11,'鹰眼',1,10,1,420,1000,'[{5,55}]',2500,11000005,'命中<color=#4eae1aff>+55</color>'),(5000,12,'鹰眼',1,10,1,420,1000,'[{5,60}]',2650,11000005,'命中<color=#4eae1aff>+60</color>'),(5000,13,'鹰眼',1,10,1,420,1000,'[{5,65}]',2800,11000005,'命中<color=#4eae1aff>+65</color>'),(5000,14,'鹰眼',1,10,1,420,1000,'[{5,70}]',2950,11000005,'命中<color=#4eae1aff>+70</color>'),(5000,15,'鹰眼',1,10,1,420,1000,'[{5,75}]',3100,11000005,'命中<color=#4eae1aff>+75</color>'),(5000,16,'鹰眼',1,10,1,420,1000,'[{5,80}]',3250,11000005,'命中<color=#4eae1aff>+80</color>'),(5000,17,'鹰眼',1,10,1,420,1000,'[{5,85}]',3400,11000005,'命中<color=#4eae1aff>+85</color>'),(5000,18,'鹰眼',1,10,1,420,1000,'[{5,90}]',3550,11000005,'命中<color=#4eae1aff>+90</color>'),(5000,19,'鹰眼',1,10,1,420,1000,'[{5,95}]',3700,11000005,'命中<color=#4eae1aff>+95</color>'),(5000,20,'鹰眼',1,10,1,420,1000,'[{5,100}]',3850,11000005,'命中<color=#4eae1aff>+100</color>'),(5000,21,'鹰眼',1,10,1,420,1000,'[{5,105}]',4000,11000005,'命中<color=#4eae1aff>+105</color>'),(5000,22,'鹰眼',1,10,1,420,1000,'[{5,110}]',4150,11000005,'命中<color=#4eae1aff>+110</color>'),(5000,23,'鹰眼',1,10,1,420,1000,'[{5,115}]',4300,11000005,'命中<color=#4eae1aff>+115</color>'),(5000,24,'鹰眼',1,10,1,420,1000,'[{5,120}]',4450,11000005,'命中<color=#4eae1aff>+120</color>'),(5000,25,'鹰眼',1,10,1,420,1000,'[{5,125}]',4600,11000005,'命中<color=#4eae1aff>+125</color>'),(5000,26,'鹰眼',1,10,1,420,1000,'[{5,130}]',4750,11000005,'命中<color=#4eae1aff>+130</color>'),(5000,27,'鹰眼',1,10,1,420,1000,'[{5,135}]',4900,11000005,'命中<color=#4eae1aff>+135</color>'),(5000,28,'鹰眼',1,10,1,420,1000,'[{5,140}]',5050,11000005,'命中<color=#4eae1aff>+140</color>'),(5000,29,'鹰眼',1,10,1,420,1000,'[{5,145}]',5200,11000005,'命中<color=#4eae1aff>+145</color>'),(5000,30,'鹰眼',1,10,1,420,1000,'[{5,150}]',5350,11000005,'命中<color=#4eae1aff>+150</color>'),(5000,31,'鹰眼',1,10,1,420,1000,'[{5,155}]',5500,11000005,'命中<color=#4eae1aff>+155</color>'),(5000,32,'鹰眼',1,10,1,420,1000,'[{5,160}]',5650,11000005,'命中<color=#4eae1aff>+160</color>'),(5000,33,'鹰眼',1,10,1,420,1000,'[{5,165}]',5800,11000005,'命中<color=#4eae1aff>+165</color>'),(5000,34,'鹰眼',1,10,1,420,1000,'[{5,170}]',5950,11000005,'命中<color=#4eae1aff>+170</color>'),(5000,35,'鹰眼',1,10,1,420,1000,'[{5,175}]',6100,11000005,'命中<color=#4eae1aff>+175</color>'),(5000,36,'鹰眼',1,10,1,420,1000,'[{5,180}]',6250,11000005,'命中<color=#4eae1aff>+180</color>'),(5000,37,'鹰眼',1,10,1,420,1000,'[{5,185}]',6400,11000005,'命中<color=#4eae1aff>+185</color>'),(5000,38,'鹰眼',1,10,1,420,1000,'[{5,190}]',6550,11000005,'命中<color=#4eae1aff>+190</color>'),(5000,39,'鹰眼',1,10,1,420,1000,'[{5,195}]',6700,11000005,'命中<color=#4eae1aff>+195</color>'),(5000,40,'鹰眼',1,10,1,420,1000,'[{5,200}]',6850,11000005,'命中<color=#4eae1aff>+200</color>'),(5000,41,'鹰眼',1,10,1,420,1000,'[{5,205}]',7000,11000005,'命中<color=#4eae1aff>+205</color>'),(5000,42,'鹰眼',1,10,1,420,1000,'[{5,210}]',7150,11000005,'命中<color=#4eae1aff>+210</color>'),(5000,43,'鹰眼',1,10,1,420,1000,'[{5,215}]',7300,11000005,'命中<color=#4eae1aff>+215</color>'),(5000,44,'鹰眼',1,10,1,420,1000,'[{5,220}]',7450,11000005,'命中<color=#4eae1aff>+220</color>'),(5000,45,'鹰眼',1,10,1,420,1000,'[{5,225}]',7600,11000005,'命中<color=#4eae1aff>+225</color>'),(5000,46,'鹰眼',1,10,1,420,1000,'[{5,230}]',7750,11000005,'命中<color=#4eae1aff>+230</color>'),(5000,47,'鹰眼',1,10,1,420,1000,'[{5,235}]',7900,11000005,'命中<color=#4eae1aff>+235</color>'),(5000,48,'鹰眼',1,10,1,420,1000,'[{5,240}]',8050,11000005,'命中<color=#4eae1aff>+240</color>'),(5000,49,'鹰眼',1,10,1,420,1000,'[{5,245}]',8200,11000005,'命中<color=#4eae1aff>+245</color>'),(5000,50,'鹰眼',1,10,1,420,1000,'[{5,250}]',8350,11000005,'命中<color=#4eae1aff>+250</color>'),(5000,51,'鹰眼',1,10,2,420,1000,'[{5,255}]',8500,11000005,'命中<color=#4eae1aff>+255</color>'),(5000,52,'鹰眼',1,10,2,420,1000,'[{5,260}]',8650,11000005,'命中<color=#4eae1aff>+260</color>'),(5000,53,'鹰眼',1,10,2,420,1000,'[{5,265}]',8800,11000005,'命中<color=#4eae1aff>+265</color>'),(5000,54,'鹰眼',1,10,2,420,1000,'[{5,270}]',8950,11000005,'命中<color=#4eae1aff>+270</color>'),(5000,55,'鹰眼',1,10,2,420,1000,'[{5,275}]',9100,11000005,'命中<color=#4eae1aff>+275</color>'),(5000,56,'鹰眼',1,10,2,420,1000,'[{5,280}]',9250,11000005,'命中<color=#4eae1aff>+280</color>'),(5000,57,'鹰眼',1,10,2,420,1000,'[{5,285}]',9400,11000005,'命中<color=#4eae1aff>+285</color>'),(5000,58,'鹰眼',1,10,2,420,1000,'[{5,290}]',9550,11000005,'命中<color=#4eae1aff>+290</color>'),(5000,59,'鹰眼',1,10,2,420,1000,'[{5,295}]',9700,11000005,'命中<color=#4eae1aff>+295</color>'),(5000,60,'鹰眼',1,10,2,420,1000,'[{5,300}]',9850,11000005,'命中<color=#4eae1aff>+300</color>'),(5000,61,'鹰眼',1,10,2,420,1000,'[{5,305}]',10000,11000005,'命中<color=#4eae1aff>+305</color>'),(5000,62,'鹰眼',1,10,2,420,1000,'[{5,310}]',10150,11000005,'命中<color=#4eae1aff>+310</color>'),(5000,63,'鹰眼',1,10,2,420,1000,'[{5,315}]',10300,11000005,'命中<color=#4eae1aff>+315</color>'),(5000,64,'鹰眼',1,10,2,420,1000,'[{5,320}]',10450,11000005,'命中<color=#4eae1aff>+320</color>'),(5000,65,'鹰眼',1,10,2,420,1000,'[{5,325}]',10600,11000005,'命中<color=#4eae1aff>+325</color>'),(5000,66,'鹰眼',1,10,2,420,1000,'[{5,330}]',10750,11000005,'命中<color=#4eae1aff>+330</color>'),(5000,67,'鹰眼',1,10,2,420,1000,'[{5,335}]',10900,11000005,'命中<color=#4eae1aff>+335</color>'),(5000,68,'鹰眼',1,10,2,420,1000,'[{5,340}]',11050,11000005,'命中<color=#4eae1aff>+340</color>'),(5000,69,'鹰眼',1,10,2,420,1000,'[{5,345}]',11200,11000005,'命中<color=#4eae1aff>+345</color>'),(5000,70,'鹰眼',1,10,2,420,1000,'[{5,350}]',11350,11000005,'命中<color=#4eae1aff>+350</color>'),(5000,71,'鹰眼',1,10,2,420,1000,'[{5,355}]',11500,11000005,'命中<color=#4eae1aff>+355</color>'),(5000,72,'鹰眼',1,10,2,420,1000,'[{5,360}]',11650,11000005,'命中<color=#4eae1aff>+360</color>'),(5000,73,'鹰眼',1,10,2,420,1000,'[{5,365}]',11800,11000005,'命中<color=#4eae1aff>+365</color>'),(5000,74,'鹰眼',1,10,2,420,1000,'[{5,370}]',11950,11000005,'命中<color=#4eae1aff>+370</color>'),(5000,75,'鹰眼',1,10,2,420,1000,'[{5,375}]',12100,11000005,'命中<color=#4eae1aff>+375</color>'),(5000,76,'鹰眼',1,10,2,420,1000,'[{5,380}]',12250,11000005,'命中<color=#4eae1aff>+380</color>'),(5000,77,'鹰眼',1,10,2,420,1000,'[{5,385}]',12400,11000005,'命中<color=#4eae1aff>+385</color>'),(5000,78,'鹰眼',1,10,2,420,1000,'[{5,390}]',12550,11000005,'命中<color=#4eae1aff>+390</color>'),(5000,79,'鹰眼',1,10,2,420,1000,'[{5,395}]',12700,11000005,'命中<color=#4eae1aff>+395</color>'),(5000,80,'鹰眼',1,10,2,420,1000,'[{5,400}]',12850,11000005,'命中<color=#4eae1aff>+400</color>'),(5000,81,'鹰眼',1,10,2,420,1000,'[{5,405}]',13000,11000005,'命中<color=#4eae1aff>+405</color>'),(5000,82,'鹰眼',1,10,2,420,1000,'[{5,410}]',13150,11000005,'命中<color=#4eae1aff>+410</color>'),(5000,83,'鹰眼',1,10,2,420,1000,'[{5,415}]',13300,11000005,'命中<color=#4eae1aff>+415</color>'),(5000,84,'鹰眼',1,10,2,420,1000,'[{5,420}]',13450,11000005,'命中<color=#4eae1aff>+420</color>'),(5000,85,'鹰眼',1,10,2,420,1000,'[{5,425}]',13600,11000005,'命中<color=#4eae1aff>+425</color>'),(5000,86,'鹰眼',1,10,2,420,1000,'[{5,430}]',13750,11000005,'命中<color=#4eae1aff>+430</color>'),(5000,87,'鹰眼',1,10,2,420,1000,'[{5,435}]',13900,11000005,'命中<color=#4eae1aff>+435</color>'),(5000,88,'鹰眼',1,10,2,420,1000,'[{5,440}]',14050,11000005,'命中<color=#4eae1aff>+440</color>'),(5000,89,'鹰眼',1,10,2,420,1000,'[{5,445}]',14200,11000005,'命中<color=#4eae1aff>+445</color>'),(5000,90,'鹰眼',1,10,2,420,1000,'[{5,450}]',14350,11000005,'命中<color=#4eae1aff>+450</color>'),(5000,91,'鹰眼',1,10,2,420,1000,'[{5,455}]',14500,11000005,'命中<color=#4eae1aff>+455</color>'),(5000,92,'鹰眼',1,10,2,420,1000,'[{5,460}]',14650,11000005,'命中<color=#4eae1aff>+460</color>'),(5000,93,'鹰眼',1,10,2,420,1000,'[{5,465}]',14800,11000005,'命中<color=#4eae1aff>+465</color>'),(5000,94,'鹰眼',1,10,2,420,1000,'[{5,470}]',14950,11000005,'命中<color=#4eae1aff>+470</color>'),(5000,95,'鹰眼',1,10,2,420,1000,'[{5,475}]',15100,11000005,'命中<color=#4eae1aff>+475</color>'),(5000,96,'鹰眼',1,10,2,420,1000,'[{5,480}]',15250,11000005,'命中<color=#4eae1aff>+480</color>'),(5000,97,'鹰眼',1,10,2,420,1000,'[{5,485}]',15400,11000005,'命中<color=#4eae1aff>+485</color>'),(5000,98,'鹰眼',1,10,2,420,1000,'[{5,490}]',15550,11000005,'命中<color=#4eae1aff>+490</color>'),(5000,99,'鹰眼',1,10,2,420,1000,'[{5,495}]',15700,11000005,'命中<color=#4eae1aff>+495</color>'),(5000,100,'鹰眼',1,10,2,420,1000,'[{5,500}]',15850,11000005,'命中<color=#4eae1aff>+500</color>'),(5000,101,'鹰眼',1,10,3,420,1000,'[{5,505}]',16000,11000005,'命中<color=#4eae1aff>+505</color>'),(5000,102,'鹰眼',1,10,3,420,1000,'[{5,510}]',16150,11000005,'命中<color=#4eae1aff>+510</color>'),(5000,103,'鹰眼',1,10,3,420,1000,'[{5,515}]',16300,11000005,'命中<color=#4eae1aff>+515</color>'),(5000,104,'鹰眼',1,10,3,420,1000,'[{5,520}]',16450,11000005,'命中<color=#4eae1aff>+520</color>'),(5000,105,'鹰眼',1,10,3,420,1000,'[{5,525}]',16600,11000005,'命中<color=#4eae1aff>+525</color>'),(5000,106,'鹰眼',1,10,3,420,1000,'[{5,530}]',16750,11000005,'命中<color=#4eae1aff>+530</color>'),(5000,107,'鹰眼',1,10,3,420,1000,'[{5,535}]',16900,11000005,'命中<color=#4eae1aff>+535</color>'),(5000,108,'鹰眼',1,10,3,420,1000,'[{5,540}]',17050,11000005,'命中<color=#4eae1aff>+540</color>'),(5000,109,'鹰眼',1,10,3,420,1000,'[{5,545}]',17200,11000005,'命中<color=#4eae1aff>+545</color>'),(5000,110,'鹰眼',1,10,3,420,1000,'[{5,550}]',17350,11000005,'命中<color=#4eae1aff>+550</color>'),(5000,111,'鹰眼',1,10,3,420,1000,'[{5,555}]',17500,11000005,'命中<color=#4eae1aff>+555</color>'),(5000,112,'鹰眼',1,10,3,420,1000,'[{5,560}]',17650,11000005,'命中<color=#4eae1aff>+560</color>'),(5000,113,'鹰眼',1,10,3,420,1000,'[{5,565}]',17800,11000005,'命中<color=#4eae1aff>+565</color>'),(5000,114,'鹰眼',1,10,3,420,1000,'[{5,570}]',17950,11000005,'命中<color=#4eae1aff>+570</color>'),(5000,115,'鹰眼',1,10,3,420,1000,'[{5,575}]',18100,11000005,'命中<color=#4eae1aff>+575</color>'),(5000,116,'鹰眼',1,10,3,420,1000,'[{5,580}]',18250,11000005,'命中<color=#4eae1aff>+580</color>'),(5000,117,'鹰眼',1,10,3,420,1000,'[{5,585}]',18400,11000005,'命中<color=#4eae1aff>+585</color>'),(5000,118,'鹰眼',1,10,3,420,1000,'[{5,590}]',18550,11000005,'命中<color=#4eae1aff>+590</color>'),(5000,119,'鹰眼',1,10,3,420,1000,'[{5,595}]',18700,11000005,'命中<color=#4eae1aff>+595</color>'),(5000,120,'鹰眼',1,10,3,420,1000,'[{5,600}]',18850,11000005,'命中<color=#4eae1aff>+600</color>'),(5000,121,'鹰眼',1,10,3,420,1000,'[{5,605}]',19000,11000005,'命中<color=#4eae1aff>+605</color>'),(5000,122,'鹰眼',1,10,3,420,1000,'[{5,610}]',19150,11000005,'命中<color=#4eae1aff>+610</color>'),(5000,123,'鹰眼',1,10,3,420,1000,'[{5,615}]',19300,11000005,'命中<color=#4eae1aff>+615</color>'),(5000,124,'鹰眼',1,10,3,420,1000,'[{5,620}]',19450,11000005,'命中<color=#4eae1aff>+620</color>'),(5000,125,'鹰眼',1,10,3,420,1000,'[{5,625}]',19600,11000005,'命中<color=#4eae1aff>+625</color>'),(5000,126,'鹰眼',1,10,3,420,1000,'[{5,630}]',19750,11000005,'命中<color=#4eae1aff>+630</color>'),(5000,127,'鹰眼',1,10,3,420,1000,'[{5,635}]',19900,11000005,'命中<color=#4eae1aff>+635</color>'),(5000,128,'鹰眼',1,10,3,420,1000,'[{5,640}]',20050,11000005,'命中<color=#4eae1aff>+640</color>'),(5000,129,'鹰眼',1,10,3,420,1000,'[{5,645}]',20200,11000005,'命中<color=#4eae1aff>+645</color>'),(5000,130,'鹰眼',1,10,3,420,1000,'[{5,650}]',20350,11000005,'命中<color=#4eae1aff>+650</color>'),(5000,131,'鹰眼',1,10,3,420,1000,'[{5,655}]',20500,11000005,'命中<color=#4eae1aff>+655</color>'),(5000,132,'鹰眼',1,10,3,420,1000,'[{5,660}]',20650,11000005,'命中<color=#4eae1aff>+660</color>'),(5000,133,'鹰眼',1,10,3,420,1000,'[{5,665}]',20800,11000005,'命中<color=#4eae1aff>+665</color>'),(5000,134,'鹰眼',1,10,3,420,1000,'[{5,670}]',20950,11000005,'命中<color=#4eae1aff>+670</color>'),(5000,135,'鹰眼',1,10,3,420,1000,'[{5,675}]',21100,11000005,'命中<color=#4eae1aff>+675</color>'),(5000,136,'鹰眼',1,10,3,420,1000,'[{5,680}]',21250,11000005,'命中<color=#4eae1aff>+680</color>'),(5000,137,'鹰眼',1,10,3,420,1000,'[{5,685}]',21400,11000005,'命中<color=#4eae1aff>+685</color>'),(5000,138,'鹰眼',1,10,3,420,1000,'[{5,690}]',21550,11000005,'命中<color=#4eae1aff>+690</color>'),(5000,139,'鹰眼',1,10,3,420,1000,'[{5,695}]',21700,11000005,'命中<color=#4eae1aff>+695</color>'),(5000,140,'鹰眼',1,10,3,420,1000,'[{5,700}]',21850,11000005,'命中<color=#4eae1aff>+700</color>'),(5000,141,'鹰眼',1,10,3,420,1000,'[{5,705}]',22000,11000005,'命中<color=#4eae1aff>+705</color>'),(5000,142,'鹰眼',1,10,3,420,1000,'[{5,710}]',22150,11000005,'命中<color=#4eae1aff>+710</color>'),(5000,143,'鹰眼',1,10,3,420,1000,'[{5,715}]',22300,11000005,'命中<color=#4eae1aff>+715</color>'),(5000,144,'鹰眼',1,10,3,420,1000,'[{5,720}]',22450,11000005,'命中<color=#4eae1aff>+720</color>'),(5000,145,'鹰眼',1,10,3,420,1000,'[{5,725}]',22600,11000005,'命中<color=#4eae1aff>+725</color>'),(5000,146,'鹰眼',1,10,3,420,1000,'[{5,730}]',22750,11000005,'命中<color=#4eae1aff>+730</color>'),(5000,147,'鹰眼',1,10,3,420,1000,'[{5,735}]',22900,11000005,'命中<color=#4eae1aff>+735</color>'),(5000,148,'鹰眼',1,10,3,420,1000,'[{5,740}]',23050,11000005,'命中<color=#4eae1aff>+740</color>'),(5000,149,'鹰眼',1,10,3,420,1000,'[{5,745}]',23200,11000005,'命中<color=#4eae1aff>+745</color>'),(5000,150,'鹰眼',1,10,3,420,1000,'[{5,750}]',23350,11000005,'命中<color=#4eae1aff>+750</color>'),(5000,151,'鹰眼',1,10,4,420,1000,'[{5,755}]',23500,11000005,'命中<color=#4eae1aff>+755</color>'),(5000,152,'鹰眼',1,10,4,420,1000,'[{5,760}]',23650,11000005,'命中<color=#4eae1aff>+760</color>'),(5000,153,'鹰眼',1,10,4,420,1000,'[{5,765}]',23800,11000005,'命中<color=#4eae1aff>+765</color>'),(5000,154,'鹰眼',1,10,4,420,1000,'[{5,770}]',23950,11000005,'命中<color=#4eae1aff>+770</color>'),(5000,155,'鹰眼',1,10,4,420,1000,'[{5,775}]',24100,11000005,'命中<color=#4eae1aff>+775</color>'),(5000,156,'鹰眼',1,10,4,420,1000,'[{5,780}]',24250,11000005,'命中<color=#4eae1aff>+780</color>'),(5000,157,'鹰眼',1,10,4,420,1000,'[{5,785}]',24400,11000005,'命中<color=#4eae1aff>+785</color>'),(5000,158,'鹰眼',1,10,4,420,1000,'[{5,790}]',24550,11000005,'命中<color=#4eae1aff>+790</color>'),(5000,159,'鹰眼',1,10,4,420,1000,'[{5,795}]',24700,11000005,'命中<color=#4eae1aff>+795</color>'),(5000,160,'鹰眼',1,10,4,420,1000,'[{5,800}]',24850,11000005,'命中<color=#4eae1aff>+800</color>'),(5000,161,'鹰眼',1,10,4,420,1000,'[{5,805}]',25000,11000005,'命中<color=#4eae1aff>+805</color>'),(5000,162,'鹰眼',1,10,4,420,1000,'[{5,810}]',25150,11000005,'命中<color=#4eae1aff>+810</color>'),(5000,163,'鹰眼',1,10,4,420,1000,'[{5,815}]',25300,11000005,'命中<color=#4eae1aff>+815</color>'),(5000,164,'鹰眼',1,10,4,420,1000,'[{5,820}]',25450,11000005,'命中<color=#4eae1aff>+820</color>'),(5000,165,'鹰眼',1,10,4,420,1000,'[{5,825}]',25600,11000005,'命中<color=#4eae1aff>+825</color>'),(5000,166,'鹰眼',1,10,4,420,1000,'[{5,830}]',25750,11000005,'命中<color=#4eae1aff>+830</color>'),(5000,167,'鹰眼',1,10,4,420,1000,'[{5,835}]',25900,11000005,'命中<color=#4eae1aff>+835</color>'),(5000,168,'鹰眼',1,10,4,420,1000,'[{5,840}]',26050,11000005,'命中<color=#4eae1aff>+840</color>'),(5000,169,'鹰眼',1,10,4,420,1000,'[{5,845}]',26200,11000005,'命中<color=#4eae1aff>+845</color>'),(5000,170,'鹰眼',1,10,4,420,1000,'[{5,850}]',26350,11000005,'命中<color=#4eae1aff>+850</color>'),(5000,171,'鹰眼',1,10,4,420,1000,'[{5,855}]',26500,11000005,'命中<color=#4eae1aff>+855</color>'),(5000,172,'鹰眼',1,10,4,420,1000,'[{5,860}]',26650,11000005,'命中<color=#4eae1aff>+860</color>'),(5000,173,'鹰眼',1,10,4,420,1000,'[{5,865}]',26800,11000005,'命中<color=#4eae1aff>+865</color>'),(5000,174,'鹰眼',1,10,4,420,1000,'[{5,870}]',26950,11000005,'命中<color=#4eae1aff>+870</color>'),(5000,175,'鹰眼',1,10,4,420,1000,'[{5,875}]',27100,11000005,'命中<color=#4eae1aff>+875</color>'),(5000,176,'鹰眼',1,10,4,420,1000,'[{5,880}]',27250,11000005,'命中<color=#4eae1aff>+880</color>'),(5000,177,'鹰眼',1,10,4,420,1000,'[{5,885}]',27400,11000005,'命中<color=#4eae1aff>+885</color>'),(5000,178,'鹰眼',1,10,4,420,1000,'[{5,890}]',27550,11000005,'命中<color=#4eae1aff>+890</color>'),(5000,179,'鹰眼',1,10,4,420,1000,'[{5,895}]',27700,11000005,'命中<color=#4eae1aff>+895</color>'),(5000,180,'鹰眼',1,10,4,420,1000,'[{5,900}]',27850,11000005,'命中<color=#4eae1aff>+900</color>'),(5000,181,'鹰眼',1,10,4,420,1000,'[{5,905}]',28000,11000005,'命中<color=#4eae1aff>+905</color>'),(5000,182,'鹰眼',1,10,4,420,1000,'[{5,910}]',28150,11000005,'命中<color=#4eae1aff>+910</color>'),(5000,183,'鹰眼',1,10,4,420,1000,'[{5,915}]',28300,11000005,'命中<color=#4eae1aff>+915</color>'),(5000,184,'鹰眼',1,10,4,420,1000,'[{5,920}]',28450,11000005,'命中<color=#4eae1aff>+920</color>'),(5000,185,'鹰眼',1,10,4,420,1000,'[{5,925}]',28600,11000005,'命中<color=#4eae1aff>+925</color>'),(5000,186,'鹰眼',1,10,4,420,1000,'[{5,930}]',28750,11000005,'命中<color=#4eae1aff>+930</color>'),(5000,187,'鹰眼',1,10,4,420,1000,'[{5,935}]',28900,11000005,'命中<color=#4eae1aff>+935</color>'),(5000,188,'鹰眼',1,10,4,420,1000,'[{5,940}]',29050,11000005,'命中<color=#4eae1aff>+940</color>'),(5000,189,'鹰眼',1,10,4,420,1000,'[{5,945}]',29200,11000005,'命中<color=#4eae1aff>+945</color>'),(5000,190,'鹰眼',1,10,4,420,1000,'[{5,950}]',29350,11000005,'命中<color=#4eae1aff>+950</color>'),(5000,191,'鹰眼',1,10,4,420,1000,'[{5,955}]',29500,11000005,'命中<color=#4eae1aff>+955</color>'),(5000,192,'鹰眼',1,10,4,420,1000,'[{5,960}]',29650,11000005,'命中<color=#4eae1aff>+960</color>'),(5000,193,'鹰眼',1,10,4,420,1000,'[{5,965}]',29800,11000005,'命中<color=#4eae1aff>+965</color>'),(5000,194,'鹰眼',1,10,4,420,1000,'[{5,970}]',29950,11000005,'命中<color=#4eae1aff>+970</color>'),(5000,195,'鹰眼',1,10,4,420,1000,'[{5,975}]',30100,11000005,'命中<color=#4eae1aff>+975</color>'),(5000,196,'鹰眼',1,10,4,420,1000,'[{5,980}]',30250,11000005,'命中<color=#4eae1aff>+980</color>'),(5000,197,'鹰眼',1,10,4,420,1000,'[{5,985}]',30400,11000005,'命中<color=#4eae1aff>+985</color>'),(5000,198,'鹰眼',1,10,4,420,1000,'[{5,990}]',30550,11000005,'命中<color=#4eae1aff>+990</color>'),(5000,199,'鹰眼',1,10,4,420,1000,'[{5,995}]',30700,11000005,'命中<color=#4eae1aff>+995</color>'),(5000,200,'鹰眼',1,10,4,420,1000,'[{5,1000}]',30850,11000005,'命中<color=#4eae1aff>+1000</color>'),(5000,201,'鹰眼',1,10,5,420,1000,'[{5,1005}]',31000,11000005,'命中<color=#4eae1aff>+1005</color>'),(5000,202,'鹰眼',1,10,5,420,1000,'[{5,1010}]',31150,11000005,'命中<color=#4eae1aff>+1010</color>'),(5000,203,'鹰眼',1,10,5,420,1000,'[{5,1015}]',31300,11000005,'命中<color=#4eae1aff>+1015</color>'),(5000,204,'鹰眼',1,10,5,420,1000,'[{5,1020}]',31450,11000005,'命中<color=#4eae1aff>+1020</color>'),(5000,205,'鹰眼',1,10,5,420,1000,'[{5,1025}]',31600,11000005,'命中<color=#4eae1aff>+1025</color>'),(5000,206,'鹰眼',1,10,5,420,1000,'[{5,1030}]',31750,11000005,'命中<color=#4eae1aff>+1030</color>'),(5000,207,'鹰眼',1,10,5,420,1000,'[{5,1035}]',31900,11000005,'命中<color=#4eae1aff>+1035</color>'),(5000,208,'鹰眼',1,10,5,420,1000,'[{5,1040}]',32050,11000005,'命中<color=#4eae1aff>+1040</color>'),(5000,209,'鹰眼',1,10,5,420,1000,'[{5,1045}]',32200,11000005,'命中<color=#4eae1aff>+1045</color>'),(5000,210,'鹰眼',1,10,5,420,1000,'[{5,1050}]',32350,11000005,'命中<color=#4eae1aff>+1050</color>'),(5000,211,'鹰眼',1,10,5,420,1000,'[{5,1055}]',32500,11000005,'命中<color=#4eae1aff>+1055</color>'),(5000,212,'鹰眼',1,10,5,420,1000,'[{5,1060}]',32650,11000005,'命中<color=#4eae1aff>+1060</color>'),(5000,213,'鹰眼',1,10,5,420,1000,'[{5,1065}]',32800,11000005,'命中<color=#4eae1aff>+1065</color>'),(5000,214,'鹰眼',1,10,5,420,1000,'[{5,1070}]',32950,11000005,'命中<color=#4eae1aff>+1070</color>'),(5000,215,'鹰眼',1,10,5,420,1000,'[{5,1075}]',33100,11000005,'命中<color=#4eae1aff>+1075</color>'),(5000,216,'鹰眼',1,10,5,420,1000,'[{5,1080}]',33250,11000005,'命中<color=#4eae1aff>+1080</color>'),(5000,217,'鹰眼',1,10,5,420,1000,'[{5,1085}]',33400,11000005,'命中<color=#4eae1aff>+1085</color>'),(5000,218,'鹰眼',1,10,5,420,1000,'[{5,1090}]',33550,11000005,'命中<color=#4eae1aff>+1090</color>'),(5000,219,'鹰眼',1,10,5,420,1000,'[{5,1095}]',33700,11000005,'命中<color=#4eae1aff>+1095</color>'),(5000,220,'鹰眼',1,10,5,420,1000,'[{5,1100}]',33850,11000005,'命中<color=#4eae1aff>+1100</color>'),(5000,221,'鹰眼',1,10,5,420,1000,'[{5,1105}]',34000,11000005,'命中<color=#4eae1aff>+1105</color>'),(5000,222,'鹰眼',1,10,5,420,1000,'[{5,1110}]',34150,11000005,'命中<color=#4eae1aff>+1110</color>'),(5000,223,'鹰眼',1,10,5,420,1000,'[{5,1115}]',34300,11000005,'命中<color=#4eae1aff>+1115</color>'),(5000,224,'鹰眼',1,10,5,420,1000,'[{5,1120}]',34450,11000005,'命中<color=#4eae1aff>+1120</color>'),(5000,225,'鹰眼',1,10,5,420,1000,'[{5,1125}]',34600,11000005,'命中<color=#4eae1aff>+1125</color>'),(5000,226,'鹰眼',1,10,5,420,1000,'[{5,1130}]',34750,11000005,'命中<color=#4eae1aff>+1130</color>'),(5000,227,'鹰眼',1,10,5,420,1000,'[{5,1135}]',34900,11000005,'命中<color=#4eae1aff>+1135</color>'),(5000,228,'鹰眼',1,10,5,420,1000,'[{5,1140}]',35050,11000005,'命中<color=#4eae1aff>+1140</color>'),(5000,229,'鹰眼',1,10,5,420,1000,'[{5,1145}]',35200,11000005,'命中<color=#4eae1aff>+1145</color>'),(5000,230,'鹰眼',1,10,5,420,1000,'[{5,1150}]',35350,11000005,'命中<color=#4eae1aff>+1150</color>'),(5000,231,'鹰眼',1,10,5,420,1000,'[{5,1155}]',35500,11000005,'命中<color=#4eae1aff>+1155</color>'),(5000,232,'鹰眼',1,10,5,420,1000,'[{5,1160}]',35650,11000005,'命中<color=#4eae1aff>+1160</color>'),(5000,233,'鹰眼',1,10,5,420,1000,'[{5,1165}]',35800,11000005,'命中<color=#4eae1aff>+1165</color>'),(5000,234,'鹰眼',1,10,5,420,1000,'[{5,1170}]',35950,11000005,'命中<color=#4eae1aff>+1170</color>'),(5000,235,'鹰眼',1,10,5,420,1000,'[{5,1175}]',36100,11000005,'命中<color=#4eae1aff>+1175</color>'),(5000,236,'鹰眼',1,10,5,420,1000,'[{5,1180}]',36250,11000005,'命中<color=#4eae1aff>+1180</color>'),(5000,237,'鹰眼',1,10,5,420,1000,'[{5,1185}]',36400,11000005,'命中<color=#4eae1aff>+1185</color>'),(5000,238,'鹰眼',1,10,5,420,1000,'[{5,1190}]',36550,11000005,'命中<color=#4eae1aff>+1190</color>'),(5000,239,'鹰眼',1,10,5,420,1000,'[{5,1195}]',36700,11000005,'命中<color=#4eae1aff>+1195</color>'),(5000,240,'鹰眼',1,10,5,420,1000,'[{5,1200}]',36850,11000005,'命中<color=#4eae1aff>+1200</color>'),(5000,241,'鹰眼',1,10,5,420,1000,'[{5,1205}]',37000,11000005,'命中<color=#4eae1aff>+1205</color>'),(5000,242,'鹰眼',1,10,5,420,1000,'[{5,1210}]',37150,11000005,'命中<color=#4eae1aff>+1210</color>'),(5000,243,'鹰眼',1,10,5,420,1000,'[{5,1215}]',37300,11000005,'命中<color=#4eae1aff>+1215</color>'),(5000,244,'鹰眼',1,10,5,420,1000,'[{5,1220}]',37450,11000005,'命中<color=#4eae1aff>+1220</color>'),(5000,245,'鹰眼',1,10,5,420,1000,'[{5,1225}]',37600,11000005,'命中<color=#4eae1aff>+1225</color>'),(5000,246,'鹰眼',1,10,5,420,1000,'[{5,1230}]',37750,11000005,'命中<color=#4eae1aff>+1230</color>'),(5000,247,'鹰眼',1,10,5,420,1000,'[{5,1235}]',37900,11000005,'命中<color=#4eae1aff>+1235</color>'),(5000,248,'鹰眼',1,10,5,420,1000,'[{5,1240}]',38050,11000005,'命中<color=#4eae1aff>+1240</color>'),(5000,249,'鹰眼',1,10,5,420,1000,'[{5,1245}]',38200,11000005,'命中<color=#4eae1aff>+1245</color>'),(5000,250,'鹰眼',1,10,5,420,1000,'[{5,1250}]',38350,11000005,'命中<color=#4eae1aff>+1250</color>'),(5000,251,'鹰眼',1,10,6,420,1000,'[{5,1255}]',38500,11000005,'命中<color=#4eae1aff>+1255</color>'),(5000,252,'鹰眼',1,10,6,420,1000,'[{5,1260}]',38650,11000005,'命中<color=#4eae1aff>+1260</color>'),(5000,253,'鹰眼',1,10,6,420,1000,'[{5,1265}]',38800,11000005,'命中<color=#4eae1aff>+1265</color>'),(5000,254,'鹰眼',1,10,6,420,1000,'[{5,1270}]',38950,11000005,'命中<color=#4eae1aff>+1270</color>'),(5000,255,'鹰眼',1,10,6,420,1000,'[{5,1275}]',39100,11000005,'命中<color=#4eae1aff>+1275</color>'),(5000,256,'鹰眼',1,10,6,420,1000,'[{5,1280}]',39250,11000005,'命中<color=#4eae1aff>+1280</color>'),(5000,257,'鹰眼',1,10,6,420,1000,'[{5,1285}]',39400,11000005,'命中<color=#4eae1aff>+1285</color>'),(5000,258,'鹰眼',1,10,6,420,1000,'[{5,1290}]',39550,11000005,'命中<color=#4eae1aff>+1290</color>'),(5000,259,'鹰眼',1,10,6,420,1000,'[{5,1295}]',39700,11000005,'命中<color=#4eae1aff>+1295</color>'),(5000,260,'鹰眼',1,10,6,420,1000,'[{5,1300}]',39850,11000005,'命中<color=#4eae1aff>+1300</color>'),(5000,261,'鹰眼',1,10,6,420,1000,'[{5,1305}]',40000,11000005,'命中<color=#4eae1aff>+1305</color>'),(5000,262,'鹰眼',1,10,6,420,1000,'[{5,1310}]',40150,11000005,'命中<color=#4eae1aff>+1310</color>'),(5000,263,'鹰眼',1,10,6,420,1000,'[{5,1315}]',40300,11000005,'命中<color=#4eae1aff>+1315</color>'),(5000,264,'鹰眼',1,10,6,420,1000,'[{5,1320}]',40450,11000005,'命中<color=#4eae1aff>+1320</color>'),(5000,265,'鹰眼',1,10,6,420,1000,'[{5,1325}]',40600,11000005,'命中<color=#4eae1aff>+1325</color>'),(5000,266,'鹰眼',1,10,6,420,1000,'[{5,1330}]',40750,11000005,'命中<color=#4eae1aff>+1330</color>'),(5000,267,'鹰眼',1,10,6,420,1000,'[{5,1335}]',40900,11000005,'命中<color=#4eae1aff>+1335</color>'),(5000,268,'鹰眼',1,10,6,420,1000,'[{5,1340}]',41050,11000005,'命中<color=#4eae1aff>+1340</color>'),(5000,269,'鹰眼',1,10,6,420,1000,'[{5,1345}]',41200,11000005,'命中<color=#4eae1aff>+1345</color>'),(5000,270,'鹰眼',1,10,6,420,1000,'[{5,1350}]',41350,11000005,'命中<color=#4eae1aff>+1350</color>'),(5000,271,'鹰眼',1,10,6,420,1000,'[{5,1355}]',41500,11000005,'命中<color=#4eae1aff>+1355</color>'),(5000,272,'鹰眼',1,10,6,420,1000,'[{5,1360}]',41650,11000005,'命中<color=#4eae1aff>+1360</color>'),(5000,273,'鹰眼',1,10,6,420,1000,'[{5,1365}]',41800,11000005,'命中<color=#4eae1aff>+1365</color>'),(5000,274,'鹰眼',1,10,6,420,1000,'[{5,1370}]',41950,11000005,'命中<color=#4eae1aff>+1370</color>'),(5000,275,'鹰眼',1,10,6,420,1000,'[{5,1375}]',42100,11000005,'命中<color=#4eae1aff>+1375</color>'),(5000,276,'鹰眼',1,10,6,420,1000,'[{5,1380}]',42250,11000005,'命中<color=#4eae1aff>+1380</color>'),(5000,277,'鹰眼',1,10,6,420,1000,'[{5,1385}]',42400,11000005,'命中<color=#4eae1aff>+1385</color>'),(5000,278,'鹰眼',1,10,6,420,1000,'[{5,1390}]',42550,11000005,'命中<color=#4eae1aff>+1390</color>'),(5000,279,'鹰眼',1,10,6,420,1000,'[{5,1395}]',42700,11000005,'命中<color=#4eae1aff>+1395</color>'),(5000,280,'鹰眼',1,10,6,420,1000,'[{5,1400}]',42850,11000005,'命中<color=#4eae1aff>+1400</color>'),(5000,281,'鹰眼',1,10,6,420,1000,'[{5,1405}]',43000,11000005,'命中<color=#4eae1aff>+1405</color>'),(5000,282,'鹰眼',1,10,6,420,1000,'[{5,1410}]',43150,11000005,'命中<color=#4eae1aff>+1410</color>'),(5000,283,'鹰眼',1,10,6,420,1000,'[{5,1415}]',43300,11000005,'命中<color=#4eae1aff>+1415</color>'),(5000,284,'鹰眼',1,10,6,420,1000,'[{5,1420}]',43450,11000005,'命中<color=#4eae1aff>+1420</color>'),(5000,285,'鹰眼',1,10,6,420,1000,'[{5,1425}]',43600,11000005,'命中<color=#4eae1aff>+1425</color>'),(5000,286,'鹰眼',1,10,6,420,1000,'[{5,1430}]',43750,11000005,'命中<color=#4eae1aff>+1430</color>'),(5000,287,'鹰眼',1,10,6,420,1000,'[{5,1435}]',43900,11000005,'命中<color=#4eae1aff>+1435</color>'),(5000,288,'鹰眼',1,10,6,420,1000,'[{5,1440}]',44050,11000005,'命中<color=#4eae1aff>+1440</color>'),(5000,289,'鹰眼',1,10,6,420,1000,'[{5,1445}]',44200,11000005,'命中<color=#4eae1aff>+1445</color>'),(5000,290,'鹰眼',1,10,6,420,1000,'[{5,1450}]',44350,11000005,'命中<color=#4eae1aff>+1450</color>'),(5000,291,'鹰眼',1,10,6,420,1000,'[{5,1455}]',44500,11000005,'命中<color=#4eae1aff>+1455</color>'),(5000,292,'鹰眼',1,10,6,420,1000,'[{5,1460}]',44650,11000005,'命中<color=#4eae1aff>+1460</color>'),(5000,293,'鹰眼',1,10,6,420,1000,'[{5,1465}]',44800,11000005,'命中<color=#4eae1aff>+1465</color>'),(5000,294,'鹰眼',1,10,6,420,1000,'[{5,1470}]',44950,11000005,'命中<color=#4eae1aff>+1470</color>'),(5000,295,'鹰眼',1,10,6,420,1000,'[{5,1475}]',45100,11000005,'命中<color=#4eae1aff>+1475</color>'),(5000,296,'鹰眼',1,10,6,420,1000,'[{5,1480}]',45250,11000005,'命中<color=#4eae1aff>+1480</color>'),(5000,297,'鹰眼',1,10,6,420,1000,'[{5,1485}]',45400,11000005,'命中<color=#4eae1aff>+1485</color>'),(5000,298,'鹰眼',1,10,6,420,1000,'[{5,1490}]',45550,11000005,'命中<color=#4eae1aff>+1490</color>'),(5000,299,'鹰眼',1,10,6,420,1000,'[{5,1495}]',45700,11000005,'命中<color=#4eae1aff>+1495</color>'),(5000,300,'鹰眼',1,10,6,420,1000,'[{5,1500}]',45850,11000005,'命中<color=#4eae1aff>+1500</color>'),(5000,301,'鹰眼',1,10,7,420,1000,'[{5,1505}]',46000,11000005,'命中<color=#4eae1aff>+1505</color>'),(5000,302,'鹰眼',1,10,7,420,1000,'[{5,1510}]',46150,11000005,'命中<color=#4eae1aff>+1510</color>'),(5000,303,'鹰眼',1,10,7,420,1000,'[{5,1515}]',46300,11000005,'命中<color=#4eae1aff>+1515</color>'),(5000,304,'鹰眼',1,10,7,420,1000,'[{5,1520}]',46450,11000005,'命中<color=#4eae1aff>+1520</color>'),(5000,305,'鹰眼',1,10,7,420,1000,'[{5,1525}]',46600,11000005,'命中<color=#4eae1aff>+1525</color>'),(5000,306,'鹰眼',1,10,7,420,1000,'[{5,1530}]',46750,11000005,'命中<color=#4eae1aff>+1530</color>'),(5000,307,'鹰眼',1,10,7,420,1000,'[{5,1535}]',46900,11000005,'命中<color=#4eae1aff>+1535</color>'),(5000,308,'鹰眼',1,10,7,420,1000,'[{5,1540}]',47050,11000005,'命中<color=#4eae1aff>+1540</color>'),(5000,309,'鹰眼',1,10,7,420,1000,'[{5,1545}]',47200,11000005,'命中<color=#4eae1aff>+1545</color>'),(5000,310,'鹰眼',1,10,7,420,1000,'[{5,1550}]',47350,11000005,'命中<color=#4eae1aff>+1550</color>'),(5000,311,'鹰眼',1,10,7,420,1000,'[{5,1555}]',47500,11000005,'命中<color=#4eae1aff>+1555</color>'),(5000,312,'鹰眼',1,10,7,420,1000,'[{5,1560}]',47650,11000005,'命中<color=#4eae1aff>+1560</color>'),(5000,313,'鹰眼',1,10,7,420,1000,'[{5,1565}]',47800,11000005,'命中<color=#4eae1aff>+1565</color>'),(5000,314,'鹰眼',1,10,7,420,1000,'[{5,1570}]',47950,11000005,'命中<color=#4eae1aff>+1570</color>'),(5000,315,'鹰眼',1,10,7,420,1000,'[{5,1575}]',48100,11000005,'命中<color=#4eae1aff>+1575</color>'),(5000,316,'鹰眼',1,10,7,420,1000,'[{5,1580}]',48250,11000005,'命中<color=#4eae1aff>+1580</color>'),(5000,317,'鹰眼',1,10,7,420,1000,'[{5,1585}]',48400,11000005,'命中<color=#4eae1aff>+1585</color>'),(5000,318,'鹰眼',1,10,7,420,1000,'[{5,1590}]',48550,11000005,'命中<color=#4eae1aff>+1590</color>'),(5000,319,'鹰眼',1,10,7,420,1000,'[{5,1595}]',48700,11000005,'命中<color=#4eae1aff>+1595</color>'),(5000,320,'鹰眼',1,10,7,420,1000,'[{5,1600}]',48850,11000005,'命中<color=#4eae1aff>+1600</color>'),(5000,321,'鹰眼',1,10,7,420,1000,'[{5,1605}]',49000,11000005,'命中<color=#4eae1aff>+1605</color>'),(5000,322,'鹰眼',1,10,7,420,1000,'[{5,1610}]',49150,11000005,'命中<color=#4eae1aff>+1610</color>'),(5000,323,'鹰眼',1,10,7,420,1000,'[{5,1615}]',49300,11000005,'命中<color=#4eae1aff>+1615</color>'),(5000,324,'鹰眼',1,10,7,420,1000,'[{5,1620}]',49450,11000005,'命中<color=#4eae1aff>+1620</color>'),(5000,325,'鹰眼',1,10,7,420,1000,'[{5,1625}]',49600,11000005,'命中<color=#4eae1aff>+1625</color>'),(5000,326,'鹰眼',1,10,7,420,1000,'[{5,1630}]',49750,11000005,'命中<color=#4eae1aff>+1630</color>'),(5000,327,'鹰眼',1,10,7,420,1000,'[{5,1635}]',49900,11000005,'命中<color=#4eae1aff>+1635</color>'),(5000,328,'鹰眼',1,10,7,420,1000,'[{5,1640}]',50050,11000005,'命中<color=#4eae1aff>+1640</color>'),(5000,329,'鹰眼',1,10,7,420,1000,'[{5,1645}]',50200,11000005,'命中<color=#4eae1aff>+1645</color>'),(5000,330,'鹰眼',1,10,7,420,1000,'[{5,1650}]',50350,11000005,'命中<color=#4eae1aff>+1650</color>'),(5000,331,'鹰眼',1,10,7,420,1000,'[{5,1655}]',50500,11000005,'命中<color=#4eae1aff>+1655</color>'),(5000,332,'鹰眼',1,10,7,420,1000,'[{5,1660}]',50650,11000005,'命中<color=#4eae1aff>+1660</color>'),(5000,333,'鹰眼',1,10,7,420,1000,'[{5,1665}]',50800,11000005,'命中<color=#4eae1aff>+1665</color>'),(5000,334,'鹰眼',1,10,7,420,1000,'[{5,1670}]',50950,11000005,'命中<color=#4eae1aff>+1670</color>'),(5000,335,'鹰眼',1,10,7,420,1000,'[{5,1675}]',51100,11000005,'命中<color=#4eae1aff>+1675</color>'),(5000,336,'鹰眼',1,10,7,420,1000,'[{5,1680}]',51250,11000005,'命中<color=#4eae1aff>+1680</color>'),(5000,337,'鹰眼',1,10,7,420,1000,'[{5,1685}]',51400,11000005,'命中<color=#4eae1aff>+1685</color>'),(5000,338,'鹰眼',1,10,7,420,1000,'[{5,1690}]',51550,11000005,'命中<color=#4eae1aff>+1690</color>'),(5000,339,'鹰眼',1,10,7,420,1000,'[{5,1695}]',51700,11000005,'命中<color=#4eae1aff>+1695</color>'),(5000,340,'鹰眼',1,10,7,420,1000,'[{5,1700}]',51850,11000005,'命中<color=#4eae1aff>+1700</color>'),(5000,341,'鹰眼',1,10,7,420,1000,'[{5,1705}]',52000,11000005,'命中<color=#4eae1aff>+1705</color>'),(5000,342,'鹰眼',1,10,7,420,1000,'[{5,1710}]',52150,11000005,'命中<color=#4eae1aff>+1710</color>'),(5000,343,'鹰眼',1,10,7,420,1000,'[{5,1715}]',52300,11000005,'命中<color=#4eae1aff>+1715</color>'),(5000,344,'鹰眼',1,10,7,420,1000,'[{5,1720}]',52450,11000005,'命中<color=#4eae1aff>+1720</color>'),(5000,345,'鹰眼',1,10,7,420,1000,'[{5,1725}]',52600,11000005,'命中<color=#4eae1aff>+1725</color>'),(5000,346,'鹰眼',1,10,7,420,1000,'[{5,1730}]',52750,11000005,'命中<color=#4eae1aff>+1730</color>'),(5000,347,'鹰眼',1,10,7,420,1000,'[{5,1735}]',52900,11000005,'命中<color=#4eae1aff>+1735</color>'),(5000,348,'鹰眼',1,10,7,420,1000,'[{5,1740}]',53050,11000005,'命中<color=#4eae1aff>+1740</color>'),(5000,349,'鹰眼',1,10,7,420,1000,'[{5,1745}]',53200,11000005,'命中<color=#4eae1aff>+1745</color>'),(5000,350,'鹰眼',1,10,7,420,1000,'[{5,1750}]',53350,11000005,'命中<color=#4eae1aff>+1750</color>'),(5000,351,'鹰眼',1,10,8,420,1000,'[{5,1755}]',53500,11000005,'命中<color=#4eae1aff>+1755</color>'),(5000,352,'鹰眼',1,10,8,420,1000,'[{5,1760}]',53650,11000005,'命中<color=#4eae1aff>+1760</color>'),(5000,353,'鹰眼',1,10,8,420,1000,'[{5,1765}]',53800,11000005,'命中<color=#4eae1aff>+1765</color>'),(5000,354,'鹰眼',1,10,8,420,1000,'[{5,1770}]',53950,11000005,'命中<color=#4eae1aff>+1770</color>'),(5000,355,'鹰眼',1,10,8,420,1000,'[{5,1775}]',54100,11000005,'命中<color=#4eae1aff>+1775</color>'),(5000,356,'鹰眼',1,10,8,420,1000,'[{5,1780}]',54250,11000005,'命中<color=#4eae1aff>+1780</color>'),(5000,357,'鹰眼',1,10,8,420,1000,'[{5,1785}]',54400,11000005,'命中<color=#4eae1aff>+1785</color>'),(5000,358,'鹰眼',1,10,8,420,1000,'[{5,1790}]',54550,11000005,'命中<color=#4eae1aff>+1790</color>'),(5000,359,'鹰眼',1,10,8,420,1000,'[{5,1795}]',54700,11000005,'命中<color=#4eae1aff>+1795</color>'),(5000,360,'鹰眼',1,10,8,420,1000,'[{5,1800}]',54850,11000005,'命中<color=#4eae1aff>+1800</color>'),(5000,361,'鹰眼',1,10,8,420,1000,'[{5,1805}]',55000,11000005,'命中<color=#4eae1aff>+1805</color>'),(5000,362,'鹰眼',1,10,8,420,1000,'[{5,1810}]',55150,11000005,'命中<color=#4eae1aff>+1810</color>'),(5000,363,'鹰眼',1,10,8,420,1000,'[{5,1815}]',55300,11000005,'命中<color=#4eae1aff>+1815</color>'),(5000,364,'鹰眼',1,10,8,420,1000,'[{5,1820}]',55450,11000005,'命中<color=#4eae1aff>+1820</color>'),(5000,365,'鹰眼',1,10,8,420,1000,'[{5,1825}]',55600,11000005,'命中<color=#4eae1aff>+1825</color>'),(5000,366,'鹰眼',1,10,8,420,1000,'[{5,1830}]',55750,11000005,'命中<color=#4eae1aff>+1830</color>'),(5000,367,'鹰眼',1,10,8,420,1000,'[{5,1835}]',55900,11000005,'命中<color=#4eae1aff>+1835</color>'),(5000,368,'鹰眼',1,10,8,420,1000,'[{5,1840}]',56050,11000005,'命中<color=#4eae1aff>+1840</color>'),(5000,369,'鹰眼',1,10,8,420,1000,'[{5,1845}]',56200,11000005,'命中<color=#4eae1aff>+1845</color>'),(5000,370,'鹰眼',1,10,8,420,1000,'[{5,1850}]',56350,11000005,'命中<color=#4eae1aff>+1850</color>'),(5000,371,'鹰眼',1,10,8,420,1000,'[{5,1855}]',56500,11000005,'命中<color=#4eae1aff>+1855</color>'),(5000,372,'鹰眼',1,10,8,420,1000,'[{5,1860}]',56650,11000005,'命中<color=#4eae1aff>+1860</color>'),(5000,373,'鹰眼',1,10,8,420,1000,'[{5,1865}]',56800,11000005,'命中<color=#4eae1aff>+1865</color>'),(5000,374,'鹰眼',1,10,8,420,1000,'[{5,1870}]',56950,11000005,'命中<color=#4eae1aff>+1870</color>'),(5000,375,'鹰眼',1,10,8,420,1000,'[{5,1875}]',57100,11000005,'命中<color=#4eae1aff>+1875</color>'),(5000,376,'鹰眼',1,10,8,420,1000,'[{5,1880}]',57250,11000005,'命中<color=#4eae1aff>+1880</color>'),(5000,377,'鹰眼',1,10,8,420,1000,'[{5,1885}]',57400,11000005,'命中<color=#4eae1aff>+1885</color>'),(5000,378,'鹰眼',1,10,8,420,1000,'[{5,1890}]',57550,11000005,'命中<color=#4eae1aff>+1890</color>'),(5000,379,'鹰眼',1,10,8,420,1000,'[{5,1895}]',57700,11000005,'命中<color=#4eae1aff>+1895</color>'),(5000,380,'鹰眼',1,10,8,420,1000,'[{5,1900}]',57850,11000005,'命中<color=#4eae1aff>+1900</color>'),(5000,381,'鹰眼',1,10,8,420,1000,'[{5,1905}]',58000,11000005,'命中<color=#4eae1aff>+1905</color>'),(5000,382,'鹰眼',1,10,8,420,1000,'[{5,1910}]',58150,11000005,'命中<color=#4eae1aff>+1910</color>'),(5000,383,'鹰眼',1,10,8,420,1000,'[{5,1915}]',58300,11000005,'命中<color=#4eae1aff>+1915</color>'),(5000,384,'鹰眼',1,10,8,420,1000,'[{5,1920}]',58450,11000005,'命中<color=#4eae1aff>+1920</color>'),(5000,385,'鹰眼',1,10,8,420,1000,'[{5,1925}]',58600,11000005,'命中<color=#4eae1aff>+1925</color>'),(5000,386,'鹰眼',1,10,8,420,1000,'[{5,1930}]',58750,11000005,'命中<color=#4eae1aff>+1930</color>'),(5000,387,'鹰眼',1,10,8,420,1000,'[{5,1935}]',58900,11000005,'命中<color=#4eae1aff>+1935</color>'),(5000,388,'鹰眼',1,10,8,420,1000,'[{5,1940}]',59050,11000005,'命中<color=#4eae1aff>+1940</color>'),(5000,389,'鹰眼',1,10,8,420,1000,'[{5,1945}]',59200,11000005,'命中<color=#4eae1aff>+1945</color>'),(5000,390,'鹰眼',1,10,8,420,1000,'[{5,1950}]',59350,11000005,'命中<color=#4eae1aff>+1950</color>'),(5000,391,'鹰眼',1,10,8,420,1000,'[{5,1955}]',59500,11000005,'命中<color=#4eae1aff>+1955</color>'),(5000,392,'鹰眼',1,10,8,420,1000,'[{5,1960}]',59650,11000005,'命中<color=#4eae1aff>+1960</color>'),(5000,393,'鹰眼',1,10,8,420,1000,'[{5,1965}]',59800,11000005,'命中<color=#4eae1aff>+1965</color>'),(5000,394,'鹰眼',1,10,8,420,1000,'[{5,1970}]',59950,11000005,'命中<color=#4eae1aff>+1970</color>'),(5000,395,'鹰眼',1,10,8,420,1000,'[{5,1975}]',60100,11000005,'命中<color=#4eae1aff>+1975</color>'),(5000,396,'鹰眼',1,10,8,420,1000,'[{5,1980}]',60250,11000005,'命中<color=#4eae1aff>+1980</color>'),(5000,397,'鹰眼',1,10,8,420,1000,'[{5,1985}]',60400,11000005,'命中<color=#4eae1aff>+1985</color>'),(5000,398,'鹰眼',1,10,8,420,1000,'[{5,1990}]',60550,11000005,'命中<color=#4eae1aff>+1990</color>'),(5000,399,'鹰眼',1,10,8,420,1000,'[{5,1995}]',60700,11000005,'命中<color=#4eae1aff>+1995</color>'),(5000,400,'鹰眼',1,10,8,420,1000,'[{5,2000}]',60850,11000005,'命中<color=#4eae1aff>+2000</color>'),(5000,401,'鹰眼',1,10,9,420,1000,'[{5,2005}]',61000,11000005,'命中<color=#4eae1aff>+2005</color>'),(5000,402,'鹰眼',1,10,9,420,1000,'[{5,2010}]',61150,11000005,'命中<color=#4eae1aff>+2010</color>'),(5000,403,'鹰眼',1,10,9,420,1000,'[{5,2015}]',61300,11000005,'命中<color=#4eae1aff>+2015</color>'),(5000,404,'鹰眼',1,10,9,420,1000,'[{5,2020}]',61450,11000005,'命中<color=#4eae1aff>+2020</color>'),(5000,405,'鹰眼',1,10,9,420,1000,'[{5,2025}]',61600,11000005,'命中<color=#4eae1aff>+2025</color>'),(5000,406,'鹰眼',1,10,9,420,1000,'[{5,2030}]',61750,11000005,'命中<color=#4eae1aff>+2030</color>'),(5000,407,'鹰眼',1,10,9,420,1000,'[{5,2035}]',61900,11000005,'命中<color=#4eae1aff>+2035</color>'),(5000,408,'鹰眼',1,10,9,420,1000,'[{5,2040}]',62050,11000005,'命中<color=#4eae1aff>+2040</color>'),(5000,409,'鹰眼',1,10,9,420,1000,'[{5,2045}]',62200,11000005,'命中<color=#4eae1aff>+2045</color>'),(5000,410,'鹰眼',1,10,9,420,1000,'[{5,2050}]',62350,11000005,'命中<color=#4eae1aff>+2050</color>'),(5000,411,'鹰眼',1,10,9,420,1000,'[{5,2055}]',62500,11000005,'命中<color=#4eae1aff>+2055</color>'),(5000,412,'鹰眼',1,10,9,420,1000,'[{5,2060}]',62650,11000005,'命中<color=#4eae1aff>+2060</color>'),(5000,413,'鹰眼',1,10,9,420,1000,'[{5,2065}]',62800,11000005,'命中<color=#4eae1aff>+2065</color>'),(5000,414,'鹰眼',1,10,9,420,1000,'[{5,2070}]',62950,11000005,'命中<color=#4eae1aff>+2070</color>'),(5000,415,'鹰眼',1,10,9,420,1000,'[{5,2075}]',63100,11000005,'命中<color=#4eae1aff>+2075</color>'),(5000,416,'鹰眼',1,10,9,420,1000,'[{5,2080}]',63250,11000005,'命中<color=#4eae1aff>+2080</color>'),(5000,417,'鹰眼',1,10,9,420,1000,'[{5,2085}]',63400,11000005,'命中<color=#4eae1aff>+2085</color>'),(5000,418,'鹰眼',1,10,9,420,1000,'[{5,2090}]',63550,11000005,'命中<color=#4eae1aff>+2090</color>'),(5000,419,'鹰眼',1,10,9,420,1000,'[{5,2095}]',63700,11000005,'命中<color=#4eae1aff>+2095</color>'),(5000,420,'鹰眼',1,10,9,420,1000,'[{5,2100}]',63850,11000005,'命中<color=#4eae1aff>+2100</color>'),(5000,421,'鹰眼',1,10,9,420,1000,'[{5,2105}]',64000,11000005,'命中<color=#4eae1aff>+2105</color>'),(5000,422,'鹰眼',1,10,9,420,1000,'[{5,2110}]',64150,11000005,'命中<color=#4eae1aff>+2110</color>'),(5000,423,'鹰眼',1,10,9,420,1000,'[{5,2115}]',64300,11000005,'命中<color=#4eae1aff>+2115</color>'),(5000,424,'鹰眼',1,10,9,420,1000,'[{5,2120}]',64450,11000005,'命中<color=#4eae1aff>+2120</color>'),(5000,425,'鹰眼',1,10,9,420,1000,'[{5,2125}]',64600,11000005,'命中<color=#4eae1aff>+2125</color>'),(5000,426,'鹰眼',1,10,9,420,1000,'[{5,2130}]',64750,11000005,'命中<color=#4eae1aff>+2130</color>'),(5000,427,'鹰眼',1,10,9,420,1000,'[{5,2135}]',64900,11000005,'命中<color=#4eae1aff>+2135</color>'),(5000,428,'鹰眼',1,10,9,420,1000,'[{5,2140}]',65050,11000005,'命中<color=#4eae1aff>+2140</color>'),(5000,429,'鹰眼',1,10,9,420,1000,'[{5,2145}]',65200,11000005,'命中<color=#4eae1aff>+2145</color>'),(5000,430,'鹰眼',1,10,9,420,1000,'[{5,2150}]',65350,11000005,'命中<color=#4eae1aff>+2150</color>'),(5000,431,'鹰眼',1,10,9,420,1000,'[{5,2155}]',65500,11000005,'命中<color=#4eae1aff>+2155</color>'),(5000,432,'鹰眼',1,10,9,420,1000,'[{5,2160}]',65650,11000005,'命中<color=#4eae1aff>+2160</color>'),(5000,433,'鹰眼',1,10,9,420,1000,'[{5,2165}]',65800,11000005,'命中<color=#4eae1aff>+2165</color>'),(5000,434,'鹰眼',1,10,9,420,1000,'[{5,2170}]',65950,11000005,'命中<color=#4eae1aff>+2170</color>'),(5000,435,'鹰眼',1,10,9,420,1000,'[{5,2175}]',66100,11000005,'命中<color=#4eae1aff>+2175</color>'),(5000,436,'鹰眼',1,10,9,420,1000,'[{5,2180}]',66250,11000005,'命中<color=#4eae1aff>+2180</color>'),(5000,437,'鹰眼',1,10,9,420,1000,'[{5,2185}]',66400,11000005,'命中<color=#4eae1aff>+2185</color>'),(5000,438,'鹰眼',1,10,9,420,1000,'[{5,2190}]',66550,11000005,'命中<color=#4eae1aff>+2190</color>'),(5000,439,'鹰眼',1,10,9,420,1000,'[{5,2195}]',66700,11000005,'命中<color=#4eae1aff>+2195</color>'),(5000,440,'鹰眼',1,10,9,420,1000,'[{5,2200}]',66850,11000005,'命中<color=#4eae1aff>+2200</color>'),(5000,441,'鹰眼',1,10,9,420,1000,'[{5,2205}]',67000,11000005,'命中<color=#4eae1aff>+2205</color>'),(5000,442,'鹰眼',1,10,9,420,1000,'[{5,2210}]',67150,11000005,'命中<color=#4eae1aff>+2210</color>'),(5000,443,'鹰眼',1,10,9,420,1000,'[{5,2215}]',67300,11000005,'命中<color=#4eae1aff>+2215</color>'),(5000,444,'鹰眼',1,10,9,420,1000,'[{5,2220}]',67450,11000005,'命中<color=#4eae1aff>+2220</color>'),(5000,445,'鹰眼',1,10,9,420,1000,'[{5,2225}]',67600,11000005,'命中<color=#4eae1aff>+2225</color>'),(5000,446,'鹰眼',1,10,9,420,1000,'[{5,2230}]',67750,11000005,'命中<color=#4eae1aff>+2230</color>'),(5000,447,'鹰眼',1,10,9,420,1000,'[{5,2235}]',67900,11000005,'命中<color=#4eae1aff>+2235</color>'),(5000,448,'鹰眼',1,10,9,420,1000,'[{5,2240}]',68050,11000005,'命中<color=#4eae1aff>+2240</color>'),(5000,449,'鹰眼',1,10,9,420,1000,'[{5,2245}]',68200,11000005,'命中<color=#4eae1aff>+2245</color>'),(5000,450,'鹰眼',1,10,9,420,1000,'[{5,2250}]',68350,11000005,'命中<color=#4eae1aff>+2250</color>'),(5000,451,'鹰眼',1,10,10,420,1000,'[{5,2255}]',68500,11000005,'命中<color=#4eae1aff>+2255</color>'),(5000,452,'鹰眼',1,10,10,420,1000,'[{5,2260}]',68650,11000005,'命中<color=#4eae1aff>+2260</color>'),(5000,453,'鹰眼',1,10,10,420,1000,'[{5,2265}]',68800,11000005,'命中<color=#4eae1aff>+2265</color>'),(5000,454,'鹰眼',1,10,10,420,1000,'[{5,2270}]',68950,11000005,'命中<color=#4eae1aff>+2270</color>'),(5000,455,'鹰眼',1,10,10,420,1000,'[{5,2275}]',69100,11000005,'命中<color=#4eae1aff>+2275</color>'),(5000,456,'鹰眼',1,10,10,420,1000,'[{5,2280}]',69250,11000005,'命中<color=#4eae1aff>+2280</color>'),(5000,457,'鹰眼',1,10,10,420,1000,'[{5,2285}]',69400,11000005,'命中<color=#4eae1aff>+2285</color>'),(5000,458,'鹰眼',1,10,10,420,1000,'[{5,2290}]',69550,11000005,'命中<color=#4eae1aff>+2290</color>'),(5000,459,'鹰眼',1,10,10,420,1000,'[{5,2295}]',69700,11000005,'命中<color=#4eae1aff>+2295</color>'),(5000,460,'鹰眼',1,10,10,420,1000,'[{5,2300}]',69850,11000005,'命中<color=#4eae1aff>+2300</color>'),(5000,461,'鹰眼',1,10,10,420,1000,'[{5,2305}]',70000,11000005,'命中<color=#4eae1aff>+2305</color>'),(5000,462,'鹰眼',1,10,10,420,1000,'[{5,2310}]',70150,11000005,'命中<color=#4eae1aff>+2310</color>'),(5000,463,'鹰眼',1,10,10,420,1000,'[{5,2315}]',70300,11000005,'命中<color=#4eae1aff>+2315</color>'),(5000,464,'鹰眼',1,10,10,420,1000,'[{5,2320}]',70450,11000005,'命中<color=#4eae1aff>+2320</color>'),(5000,465,'鹰眼',1,10,10,420,1000,'[{5,2325}]',70600,11000005,'命中<color=#4eae1aff>+2325</color>'),(5000,466,'鹰眼',1,10,10,420,1000,'[{5,2330}]',70750,11000005,'命中<color=#4eae1aff>+2330</color>'),(5000,467,'鹰眼',1,10,10,420,1000,'[{5,2335}]',70900,11000005,'命中<color=#4eae1aff>+2335</color>'),(5000,468,'鹰眼',1,10,10,420,1000,'[{5,2340}]',71050,11000005,'命中<color=#4eae1aff>+2340</color>'),(5000,469,'鹰眼',1,10,10,420,1000,'[{5,2345}]',71200,11000005,'命中<color=#4eae1aff>+2345</color>'),(5000,470,'鹰眼',1,10,10,420,1000,'[{5,2350}]',71350,11000005,'命中<color=#4eae1aff>+2350</color>'),(5000,471,'鹰眼',1,10,10,420,1000,'[{5,2355}]',71500,11000005,'命中<color=#4eae1aff>+2355</color>'),(5000,472,'鹰眼',1,10,10,420,1000,'[{5,2360}]',71650,11000005,'命中<color=#4eae1aff>+2360</color>'),(5000,473,'鹰眼',1,10,10,420,1000,'[{5,2365}]',71800,11000005,'命中<color=#4eae1aff>+2365</color>'),(5000,474,'鹰眼',1,10,10,420,1000,'[{5,2370}]',71950,11000005,'命中<color=#4eae1aff>+2370</color>'),(5000,475,'鹰眼',1,10,10,420,1000,'[{5,2375}]',72100,11000005,'命中<color=#4eae1aff>+2375</color>'),(5000,476,'鹰眼',1,10,10,420,1000,'[{5,2380}]',72250,11000005,'命中<color=#4eae1aff>+2380</color>'),(5000,477,'鹰眼',1,10,10,420,1000,'[{5,2385}]',72400,11000005,'命中<color=#4eae1aff>+2385</color>'),(5000,478,'鹰眼',1,10,10,420,1000,'[{5,2390}]',72550,11000005,'命中<color=#4eae1aff>+2390</color>'),(5000,479,'鹰眼',1,10,10,420,1000,'[{5,2395}]',72700,11000005,'命中<color=#4eae1aff>+2395</color>'),(5000,480,'鹰眼',1,10,10,420,1000,'[{5,2400}]',72850,11000005,'命中<color=#4eae1aff>+2400</color>'),(5000,481,'鹰眼',1,10,10,420,1000,'[{5,2405}]',73000,11000005,'命中<color=#4eae1aff>+2405</color>'),(5000,482,'鹰眼',1,10,10,420,1000,'[{5,2410}]',73150,11000005,'命中<color=#4eae1aff>+2410</color>'),(5000,483,'鹰眼',1,10,10,420,1000,'[{5,2415}]',73300,11000005,'命中<color=#4eae1aff>+2415</color>'),(5000,484,'鹰眼',1,10,10,420,1000,'[{5,2420}]',73450,11000005,'命中<color=#4eae1aff>+2420</color>'),(5000,485,'鹰眼',1,10,10,420,1000,'[{5,2425}]',73600,11000005,'命中<color=#4eae1aff>+2425</color>'),(5000,486,'鹰眼',1,10,10,420,1000,'[{5,2430}]',73750,11000005,'命中<color=#4eae1aff>+2430</color>'),(5000,487,'鹰眼',1,10,10,420,1000,'[{5,2435}]',73900,11000005,'命中<color=#4eae1aff>+2435</color>'),(5000,488,'鹰眼',1,10,10,420,1000,'[{5,2440}]',74050,11000005,'命中<color=#4eae1aff>+2440</color>'),(5000,489,'鹰眼',1,10,10,420,1000,'[{5,2445}]',74200,11000005,'命中<color=#4eae1aff>+2445</color>'),(5000,490,'鹰眼',1,10,10,420,1000,'[{5,2450}]',74350,11000005,'命中<color=#4eae1aff>+2450</color>'),(5000,491,'鹰眼',1,10,10,420,1000,'[{5,2455}]',74500,11000005,'命中<color=#4eae1aff>+2455</color>'),(5000,492,'鹰眼',1,10,10,420,1000,'[{5,2460}]',74650,11000005,'命中<color=#4eae1aff>+2460</color>'),(5000,493,'鹰眼',1,10,10,420,1000,'[{5,2465}]',74800,11000005,'命中<color=#4eae1aff>+2465</color>'),(5000,494,'鹰眼',1,10,10,420,1000,'[{5,2470}]',74950,11000005,'命中<color=#4eae1aff>+2470</color>'),(5000,495,'鹰眼',1,10,10,420,1000,'[{5,2475}]',75100,11000005,'命中<color=#4eae1aff>+2475</color>'),(5000,496,'鹰眼',1,10,10,420,1000,'[{5,2480}]',75250,11000005,'命中<color=#4eae1aff>+2480</color>'),(5000,497,'鹰眼',1,10,10,420,1000,'[{5,2485}]',75400,11000005,'命中<color=#4eae1aff>+2485</color>'),(5000,498,'鹰眼',1,10,10,420,1000,'[{5,2490}]',75550,11000005,'命中<color=#4eae1aff>+2490</color>'),(5000,499,'鹰眼',1,10,10,420,1000,'[{5,2495}]',75700,11000005,'命中<color=#4eae1aff>+2495</color>'),(5000,500,'鹰眼',1,10,10,420,1000,'[{5,2500}]',75850,11000005,'命中<color=#4eae1aff>+2500</color>'),(6000,1,'影遁',1,10,1,420,1000,'[{6,5}]',1000,11000006,'闪避<color=#4eae1aff>+5</color>'),(6000,2,'影遁',1,10,1,420,1000,'[{6,10}]',1150,11000006,'闪避<color=#4eae1aff>+10</color>'),(6000,3,'影遁',1,10,1,420,1000,'[{6,15}]',1300,11000006,'闪避<color=#4eae1aff>+15</color>'),(6000,4,'影遁',1,10,1,420,1000,'[{6,20}]',1450,11000006,'闪避<color=#4eae1aff>+20</color>'),(6000,5,'影遁',1,10,1,420,1000,'[{6,25}]',1600,11000006,'闪避<color=#4eae1aff>+25</color>'),(6000,6,'影遁',1,10,1,420,1000,'[{6,30}]',1750,11000006,'闪避<color=#4eae1aff>+30</color>'),(6000,7,'影遁',1,10,1,420,1000,'[{6,35}]',1900,11000006,'闪避<color=#4eae1aff>+35</color>'),(6000,8,'影遁',1,10,1,420,1000,'[{6,40}]',2050,11000006,'闪避<color=#4eae1aff>+40</color>'),(6000,9,'影遁',1,10,1,420,1000,'[{6,45}]',2200,11000006,'闪避<color=#4eae1aff>+45</color>'),(6000,10,'影遁',1,10,1,420,1000,'[{6,50}]',2350,11000006,'闪避<color=#4eae1aff>+50</color>'),(6000,11,'影遁',1,10,1,420,1000,'[{6,55}]',2500,11000006,'闪避<color=#4eae1aff>+55</color>'),(6000,12,'影遁',1,10,1,420,1000,'[{6,60}]',2650,11000006,'闪避<color=#4eae1aff>+60</color>'),(6000,13,'影遁',1,10,1,420,1000,'[{6,65}]',2800,11000006,'闪避<color=#4eae1aff>+65</color>'),(6000,14,'影遁',1,10,1,420,1000,'[{6,70}]',2950,11000006,'闪避<color=#4eae1aff>+70</color>'),(6000,15,'影遁',1,10,1,420,1000,'[{6,75}]',3100,11000006,'闪避<color=#4eae1aff>+75</color>'),(6000,16,'影遁',1,10,1,420,1000,'[{6,80}]',3250,11000006,'闪避<color=#4eae1aff>+80</color>'),(6000,17,'影遁',1,10,1,420,1000,'[{6,85}]',3400,11000006,'闪避<color=#4eae1aff>+85</color>'),(6000,18,'影遁',1,10,1,420,1000,'[{6,90}]',3550,11000006,'闪避<color=#4eae1aff>+90</color>'),(6000,19,'影遁',1,10,1,420,1000,'[{6,95}]',3700,11000006,'闪避<color=#4eae1aff>+95</color>'),(6000,20,'影遁',1,10,1,420,1000,'[{6,100}]',3850,11000006,'闪避<color=#4eae1aff>+100</color>'),(6000,21,'影遁',1,10,1,420,1000,'[{6,105}]',4000,11000006,'闪避<color=#4eae1aff>+105</color>'),(6000,22,'影遁',1,10,1,420,1000,'[{6,110}]',4150,11000006,'闪避<color=#4eae1aff>+110</color>'),(6000,23,'影遁',1,10,1,420,1000,'[{6,115}]',4300,11000006,'闪避<color=#4eae1aff>+115</color>'),(6000,24,'影遁',1,10,1,420,1000,'[{6,120}]',4450,11000006,'闪避<color=#4eae1aff>+120</color>'),(6000,25,'影遁',1,10,1,420,1000,'[{6,125}]',4600,11000006,'闪避<color=#4eae1aff>+125</color>'),(6000,26,'影遁',1,10,1,420,1000,'[{6,130}]',4750,11000006,'闪避<color=#4eae1aff>+130</color>'),(6000,27,'影遁',1,10,1,420,1000,'[{6,135}]',4900,11000006,'闪避<color=#4eae1aff>+135</color>'),(6000,28,'影遁',1,10,1,420,1000,'[{6,140}]',5050,11000006,'闪避<color=#4eae1aff>+140</color>'),(6000,29,'影遁',1,10,1,420,1000,'[{6,145}]',5200,11000006,'闪避<color=#4eae1aff>+145</color>'),(6000,30,'影遁',1,10,1,420,1000,'[{6,150}]',5350,11000006,'闪避<color=#4eae1aff>+150</color>'),(6000,31,'影遁',1,10,1,420,1000,'[{6,155}]',5500,11000006,'闪避<color=#4eae1aff>+155</color>'),(6000,32,'影遁',1,10,1,420,1000,'[{6,160}]',5650,11000006,'闪避<color=#4eae1aff>+160</color>'),(6000,33,'影遁',1,10,1,420,1000,'[{6,165}]',5800,11000006,'闪避<color=#4eae1aff>+165</color>'),(6000,34,'影遁',1,10,1,420,1000,'[{6,170}]',5950,11000006,'闪避<color=#4eae1aff>+170</color>'),(6000,35,'影遁',1,10,1,420,1000,'[{6,175}]',6100,11000006,'闪避<color=#4eae1aff>+175</color>'),(6000,36,'影遁',1,10,1,420,1000,'[{6,180}]',6250,11000006,'闪避<color=#4eae1aff>+180</color>'),(6000,37,'影遁',1,10,1,420,1000,'[{6,185}]',6400,11000006,'闪避<color=#4eae1aff>+185</color>'),(6000,38,'影遁',1,10,1,420,1000,'[{6,190}]',6550,11000006,'闪避<color=#4eae1aff>+190</color>'),(6000,39,'影遁',1,10,1,420,1000,'[{6,195}]',6700,11000006,'闪避<color=#4eae1aff>+195</color>'),(6000,40,'影遁',1,10,1,420,1000,'[{6,200}]',6850,11000006,'闪避<color=#4eae1aff>+200</color>'),(6000,41,'影遁',1,10,1,420,1000,'[{6,205}]',7000,11000006,'闪避<color=#4eae1aff>+205</color>'),(6000,42,'影遁',1,10,1,420,1000,'[{6,210}]',7150,11000006,'闪避<color=#4eae1aff>+210</color>'),(6000,43,'影遁',1,10,1,420,1000,'[{6,215}]',7300,11000006,'闪避<color=#4eae1aff>+215</color>'),(6000,44,'影遁',1,10,1,420,1000,'[{6,220}]',7450,11000006,'闪避<color=#4eae1aff>+220</color>'),(6000,45,'影遁',1,10,1,420,1000,'[{6,225}]',7600,11000006,'闪避<color=#4eae1aff>+225</color>'),(6000,46,'影遁',1,10,1,420,1000,'[{6,230}]',7750,11000006,'闪避<color=#4eae1aff>+230</color>'),(6000,47,'影遁',1,10,1,420,1000,'[{6,235}]',7900,11000006,'闪避<color=#4eae1aff>+235</color>'),(6000,48,'影遁',1,10,1,420,1000,'[{6,240}]',8050,11000006,'闪避<color=#4eae1aff>+240</color>'),(6000,49,'影遁',1,10,1,420,1000,'[{6,245}]',8200,11000006,'闪避<color=#4eae1aff>+245</color>'),(6000,50,'影遁',1,10,1,420,1000,'[{6,250}]',8350,11000006,'闪避<color=#4eae1aff>+250</color>'),(6000,51,'影遁',1,10,2,420,1000,'[{6,255}]',8500,11000006,'闪避<color=#4eae1aff>+255</color>'),(6000,52,'影遁',1,10,2,420,1000,'[{6,260}]',8650,11000006,'闪避<color=#4eae1aff>+260</color>'),(6000,53,'影遁',1,10,2,420,1000,'[{6,265}]',8800,11000006,'闪避<color=#4eae1aff>+265</color>'),(6000,54,'影遁',1,10,2,420,1000,'[{6,270}]',8950,11000006,'闪避<color=#4eae1aff>+270</color>'),(6000,55,'影遁',1,10,2,420,1000,'[{6,275}]',9100,11000006,'闪避<color=#4eae1aff>+275</color>'),(6000,56,'影遁',1,10,2,420,1000,'[{6,280}]',9250,11000006,'闪避<color=#4eae1aff>+280</color>'),(6000,57,'影遁',1,10,2,420,1000,'[{6,285}]',9400,11000006,'闪避<color=#4eae1aff>+285</color>'),(6000,58,'影遁',1,10,2,420,1000,'[{6,290}]',9550,11000006,'闪避<color=#4eae1aff>+290</color>'),(6000,59,'影遁',1,10,2,420,1000,'[{6,295}]',9700,11000006,'闪避<color=#4eae1aff>+295</color>'),(6000,60,'影遁',1,10,2,420,1000,'[{6,300}]',9850,11000006,'闪避<color=#4eae1aff>+300</color>'),(6000,61,'影遁',1,10,2,420,1000,'[{6,305}]',10000,11000006,'闪避<color=#4eae1aff>+305</color>'),(6000,62,'影遁',1,10,2,420,1000,'[{6,310}]',10150,11000006,'闪避<color=#4eae1aff>+310</color>'),(6000,63,'影遁',1,10,2,420,1000,'[{6,315}]',10300,11000006,'闪避<color=#4eae1aff>+315</color>'),(6000,64,'影遁',1,10,2,420,1000,'[{6,320}]',10450,11000006,'闪避<color=#4eae1aff>+320</color>'),(6000,65,'影遁',1,10,2,420,1000,'[{6,325}]',10600,11000006,'闪避<color=#4eae1aff>+325</color>'),(6000,66,'影遁',1,10,2,420,1000,'[{6,330}]',10750,11000006,'闪避<color=#4eae1aff>+330</color>'),(6000,67,'影遁',1,10,2,420,1000,'[{6,335}]',10900,11000006,'闪避<color=#4eae1aff>+335</color>'),(6000,68,'影遁',1,10,2,420,1000,'[{6,340}]',11050,11000006,'闪避<color=#4eae1aff>+340</color>'),(6000,69,'影遁',1,10,2,420,1000,'[{6,345}]',11200,11000006,'闪避<color=#4eae1aff>+345</color>'),(6000,70,'影遁',1,10,2,420,1000,'[{6,350}]',11350,11000006,'闪避<color=#4eae1aff>+350</color>'),(6000,71,'影遁',1,10,2,420,1000,'[{6,355}]',11500,11000006,'闪避<color=#4eae1aff>+355</color>'),(6000,72,'影遁',1,10,2,420,1000,'[{6,360}]',11650,11000006,'闪避<color=#4eae1aff>+360</color>'),(6000,73,'影遁',1,10,2,420,1000,'[{6,365}]',11800,11000006,'闪避<color=#4eae1aff>+365</color>'),(6000,74,'影遁',1,10,2,420,1000,'[{6,370}]',11950,11000006,'闪避<color=#4eae1aff>+370</color>'),(6000,75,'影遁',1,10,2,420,1000,'[{6,375}]',12100,11000006,'闪避<color=#4eae1aff>+375</color>'),(6000,76,'影遁',1,10,2,420,1000,'[{6,380}]',12250,11000006,'闪避<color=#4eae1aff>+380</color>'),(6000,77,'影遁',1,10,2,420,1000,'[{6,385}]',12400,11000006,'闪避<color=#4eae1aff>+385</color>'),(6000,78,'影遁',1,10,2,420,1000,'[{6,390}]',12550,11000006,'闪避<color=#4eae1aff>+390</color>'),(6000,79,'影遁',1,10,2,420,1000,'[{6,395}]',12700,11000006,'闪避<color=#4eae1aff>+395</color>'),(6000,80,'影遁',1,10,2,420,1000,'[{6,400}]',12850,11000006,'闪避<color=#4eae1aff>+400</color>'),(6000,81,'影遁',1,10,2,420,1000,'[{6,405}]',13000,11000006,'闪避<color=#4eae1aff>+405</color>'),(6000,82,'影遁',1,10,2,420,1000,'[{6,410}]',13150,11000006,'闪避<color=#4eae1aff>+410</color>'),(6000,83,'影遁',1,10,2,420,1000,'[{6,415}]',13300,11000006,'闪避<color=#4eae1aff>+415</color>'),(6000,84,'影遁',1,10,2,420,1000,'[{6,420}]',13450,11000006,'闪避<color=#4eae1aff>+420</color>'),(6000,85,'影遁',1,10,2,420,1000,'[{6,425}]',13600,11000006,'闪避<color=#4eae1aff>+425</color>'),(6000,86,'影遁',1,10,2,420,1000,'[{6,430}]',13750,11000006,'闪避<color=#4eae1aff>+430</color>'),(6000,87,'影遁',1,10,2,420,1000,'[{6,435}]',13900,11000006,'闪避<color=#4eae1aff>+435</color>'),(6000,88,'影遁',1,10,2,420,1000,'[{6,440}]',14050,11000006,'闪避<color=#4eae1aff>+440</color>'),(6000,89,'影遁',1,10,2,420,1000,'[{6,445}]',14200,11000006,'闪避<color=#4eae1aff>+445</color>'),(6000,90,'影遁',1,10,2,420,1000,'[{6,450}]',14350,11000006,'闪避<color=#4eae1aff>+450</color>'),(6000,91,'影遁',1,10,2,420,1000,'[{6,455}]',14500,11000006,'闪避<color=#4eae1aff>+455</color>'),(6000,92,'影遁',1,10,2,420,1000,'[{6,460}]',14650,11000006,'闪避<color=#4eae1aff>+460</color>'),(6000,93,'影遁',1,10,2,420,1000,'[{6,465}]',14800,11000006,'闪避<color=#4eae1aff>+465</color>'),(6000,94,'影遁',1,10,2,420,1000,'[{6,470}]',14950,11000006,'闪避<color=#4eae1aff>+470</color>'),(6000,95,'影遁',1,10,2,420,1000,'[{6,475}]',15100,11000006,'闪避<color=#4eae1aff>+475</color>'),(6000,96,'影遁',1,10,2,420,1000,'[{6,480}]',15250,11000006,'闪避<color=#4eae1aff>+480</color>'),(6000,97,'影遁',1,10,2,420,1000,'[{6,485}]',15400,11000006,'闪避<color=#4eae1aff>+485</color>'),(6000,98,'影遁',1,10,2,420,1000,'[{6,490}]',15550,11000006,'闪避<color=#4eae1aff>+490</color>'),(6000,99,'影遁',1,10,2,420,1000,'[{6,495}]',15700,11000006,'闪避<color=#4eae1aff>+495</color>'),(6000,100,'影遁',1,10,2,420,1000,'[{6,500}]',15850,11000006,'闪避<color=#4eae1aff>+500</color>'),(6000,101,'影遁',1,10,3,420,1000,'[{6,505}]',16000,11000006,'闪避<color=#4eae1aff>+505</color>'),(6000,102,'影遁',1,10,3,420,1000,'[{6,510}]',16150,11000006,'闪避<color=#4eae1aff>+510</color>'),(6000,103,'影遁',1,10,3,420,1000,'[{6,515}]',16300,11000006,'闪避<color=#4eae1aff>+515</color>'),(6000,104,'影遁',1,10,3,420,1000,'[{6,520}]',16450,11000006,'闪避<color=#4eae1aff>+520</color>'),(6000,105,'影遁',1,10,3,420,1000,'[{6,525}]',16600,11000006,'闪避<color=#4eae1aff>+525</color>'),(6000,106,'影遁',1,10,3,420,1000,'[{6,530}]',16750,11000006,'闪避<color=#4eae1aff>+530</color>'),(6000,107,'影遁',1,10,3,420,1000,'[{6,535}]',16900,11000006,'闪避<color=#4eae1aff>+535</color>'),(6000,108,'影遁',1,10,3,420,1000,'[{6,540}]',17050,11000006,'闪避<color=#4eae1aff>+540</color>'),(6000,109,'影遁',1,10,3,420,1000,'[{6,545}]',17200,11000006,'闪避<color=#4eae1aff>+545</color>'),(6000,110,'影遁',1,10,3,420,1000,'[{6,550}]',17350,11000006,'闪避<color=#4eae1aff>+550</color>'),(6000,111,'影遁',1,10,3,420,1000,'[{6,555}]',17500,11000006,'闪避<color=#4eae1aff>+555</color>'),(6000,112,'影遁',1,10,3,420,1000,'[{6,560}]',17650,11000006,'闪避<color=#4eae1aff>+560</color>'),(6000,113,'影遁',1,10,3,420,1000,'[{6,565}]',17800,11000006,'闪避<color=#4eae1aff>+565</color>'),(6000,114,'影遁',1,10,3,420,1000,'[{6,570}]',17950,11000006,'闪避<color=#4eae1aff>+570</color>'),(6000,115,'影遁',1,10,3,420,1000,'[{6,575}]',18100,11000006,'闪避<color=#4eae1aff>+575</color>'),(6000,116,'影遁',1,10,3,420,1000,'[{6,580}]',18250,11000006,'闪避<color=#4eae1aff>+580</color>'),(6000,117,'影遁',1,10,3,420,1000,'[{6,585}]',18400,11000006,'闪避<color=#4eae1aff>+585</color>'),(6000,118,'影遁',1,10,3,420,1000,'[{6,590}]',18550,11000006,'闪避<color=#4eae1aff>+590</color>'),(6000,119,'影遁',1,10,3,420,1000,'[{6,595}]',18700,11000006,'闪避<color=#4eae1aff>+595</color>'),(6000,120,'影遁',1,10,3,420,1000,'[{6,600}]',18850,11000006,'闪避<color=#4eae1aff>+600</color>'),(6000,121,'影遁',1,10,3,420,1000,'[{6,605}]',19000,11000006,'闪避<color=#4eae1aff>+605</color>'),(6000,122,'影遁',1,10,3,420,1000,'[{6,610}]',19150,11000006,'闪避<color=#4eae1aff>+610</color>'),(6000,123,'影遁',1,10,3,420,1000,'[{6,615}]',19300,11000006,'闪避<color=#4eae1aff>+615</color>'),(6000,124,'影遁',1,10,3,420,1000,'[{6,620}]',19450,11000006,'闪避<color=#4eae1aff>+620</color>'),(6000,125,'影遁',1,10,3,420,1000,'[{6,625}]',19600,11000006,'闪避<color=#4eae1aff>+625</color>'),(6000,126,'影遁',1,10,3,420,1000,'[{6,630}]',19750,11000006,'闪避<color=#4eae1aff>+630</color>'),(6000,127,'影遁',1,10,3,420,1000,'[{6,635}]',19900,11000006,'闪避<color=#4eae1aff>+635</color>'),(6000,128,'影遁',1,10,3,420,1000,'[{6,640}]',20050,11000006,'闪避<color=#4eae1aff>+640</color>'),(6000,129,'影遁',1,10,3,420,1000,'[{6,645}]',20200,11000006,'闪避<color=#4eae1aff>+645</color>'),(6000,130,'影遁',1,10,3,420,1000,'[{6,650}]',20350,11000006,'闪避<color=#4eae1aff>+650</color>'),(6000,131,'影遁',1,10,3,420,1000,'[{6,655}]',20500,11000006,'闪避<color=#4eae1aff>+655</color>'),(6000,132,'影遁',1,10,3,420,1000,'[{6,660}]',20650,11000006,'闪避<color=#4eae1aff>+660</color>'),(6000,133,'影遁',1,10,3,420,1000,'[{6,665}]',20800,11000006,'闪避<color=#4eae1aff>+665</color>'),(6000,134,'影遁',1,10,3,420,1000,'[{6,670}]',20950,11000006,'闪避<color=#4eae1aff>+670</color>'),(6000,135,'影遁',1,10,3,420,1000,'[{6,675}]',21100,11000006,'闪避<color=#4eae1aff>+675</color>'),(6000,136,'影遁',1,10,3,420,1000,'[{6,680}]',21250,11000006,'闪避<color=#4eae1aff>+680</color>'),(6000,137,'影遁',1,10,3,420,1000,'[{6,685}]',21400,11000006,'闪避<color=#4eae1aff>+685</color>'),(6000,138,'影遁',1,10,3,420,1000,'[{6,690}]',21550,11000006,'闪避<color=#4eae1aff>+690</color>'),(6000,139,'影遁',1,10,3,420,1000,'[{6,695}]',21700,11000006,'闪避<color=#4eae1aff>+695</color>'),(6000,140,'影遁',1,10,3,420,1000,'[{6,700}]',21850,11000006,'闪避<color=#4eae1aff>+700</color>'),(6000,141,'影遁',1,10,3,420,1000,'[{6,705}]',22000,11000006,'闪避<color=#4eae1aff>+705</color>'),(6000,142,'影遁',1,10,3,420,1000,'[{6,710}]',22150,11000006,'闪避<color=#4eae1aff>+710</color>'),(6000,143,'影遁',1,10,3,420,1000,'[{6,715}]',22300,11000006,'闪避<color=#4eae1aff>+715</color>'),(6000,144,'影遁',1,10,3,420,1000,'[{6,720}]',22450,11000006,'闪避<color=#4eae1aff>+720</color>'),(6000,145,'影遁',1,10,3,420,1000,'[{6,725}]',22600,11000006,'闪避<color=#4eae1aff>+725</color>'),(6000,146,'影遁',1,10,3,420,1000,'[{6,730}]',22750,11000006,'闪避<color=#4eae1aff>+730</color>'),(6000,147,'影遁',1,10,3,420,1000,'[{6,735}]',22900,11000006,'闪避<color=#4eae1aff>+735</color>'),(6000,148,'影遁',1,10,3,420,1000,'[{6,740}]',23050,11000006,'闪避<color=#4eae1aff>+740</color>'),(6000,149,'影遁',1,10,3,420,1000,'[{6,745}]',23200,11000006,'闪避<color=#4eae1aff>+745</color>'),(6000,150,'影遁',1,10,3,420,1000,'[{6,750}]',23350,11000006,'闪避<color=#4eae1aff>+750</color>'),(6000,151,'影遁',1,10,4,420,1000,'[{6,755}]',23500,11000006,'闪避<color=#4eae1aff>+755</color>'),(6000,152,'影遁',1,10,4,420,1000,'[{6,760}]',23650,11000006,'闪避<color=#4eae1aff>+760</color>'),(6000,153,'影遁',1,10,4,420,1000,'[{6,765}]',23800,11000006,'闪避<color=#4eae1aff>+765</color>'),(6000,154,'影遁',1,10,4,420,1000,'[{6,770}]',23950,11000006,'闪避<color=#4eae1aff>+770</color>'),(6000,155,'影遁',1,10,4,420,1000,'[{6,775}]',24100,11000006,'闪避<color=#4eae1aff>+775</color>'),(6000,156,'影遁',1,10,4,420,1000,'[{6,780}]',24250,11000006,'闪避<color=#4eae1aff>+780</color>'),(6000,157,'影遁',1,10,4,420,1000,'[{6,785}]',24400,11000006,'闪避<color=#4eae1aff>+785</color>'),(6000,158,'影遁',1,10,4,420,1000,'[{6,790}]',24550,11000006,'闪避<color=#4eae1aff>+790</color>'),(6000,159,'影遁',1,10,4,420,1000,'[{6,795}]',24700,11000006,'闪避<color=#4eae1aff>+795</color>'),(6000,160,'影遁',1,10,4,420,1000,'[{6,800}]',24850,11000006,'闪避<color=#4eae1aff>+800</color>'),(6000,161,'影遁',1,10,4,420,1000,'[{6,805}]',25000,11000006,'闪避<color=#4eae1aff>+805</color>'),(6000,162,'影遁',1,10,4,420,1000,'[{6,810}]',25150,11000006,'闪避<color=#4eae1aff>+810</color>'),(6000,163,'影遁',1,10,4,420,1000,'[{6,815}]',25300,11000006,'闪避<color=#4eae1aff>+815</color>'),(6000,164,'影遁',1,10,4,420,1000,'[{6,820}]',25450,11000006,'闪避<color=#4eae1aff>+820</color>'),(6000,165,'影遁',1,10,4,420,1000,'[{6,825}]',25600,11000006,'闪避<color=#4eae1aff>+825</color>'),(6000,166,'影遁',1,10,4,420,1000,'[{6,830}]',25750,11000006,'闪避<color=#4eae1aff>+830</color>'),(6000,167,'影遁',1,10,4,420,1000,'[{6,835}]',25900,11000006,'闪避<color=#4eae1aff>+835</color>'),(6000,168,'影遁',1,10,4,420,1000,'[{6,840}]',26050,11000006,'闪避<color=#4eae1aff>+840</color>'),(6000,169,'影遁',1,10,4,420,1000,'[{6,845}]',26200,11000006,'闪避<color=#4eae1aff>+845</color>'),(6000,170,'影遁',1,10,4,420,1000,'[{6,850}]',26350,11000006,'闪避<color=#4eae1aff>+850</color>'),(6000,171,'影遁',1,10,4,420,1000,'[{6,855}]',26500,11000006,'闪避<color=#4eae1aff>+855</color>'),(6000,172,'影遁',1,10,4,420,1000,'[{6,860}]',26650,11000006,'闪避<color=#4eae1aff>+860</color>'),(6000,173,'影遁',1,10,4,420,1000,'[{6,865}]',26800,11000006,'闪避<color=#4eae1aff>+865</color>'),(6000,174,'影遁',1,10,4,420,1000,'[{6,870}]',26950,11000006,'闪避<color=#4eae1aff>+870</color>'),(6000,175,'影遁',1,10,4,420,1000,'[{6,875}]',27100,11000006,'闪避<color=#4eae1aff>+875</color>'),(6000,176,'影遁',1,10,4,420,1000,'[{6,880}]',27250,11000006,'闪避<color=#4eae1aff>+880</color>'),(6000,177,'影遁',1,10,4,420,1000,'[{6,885}]',27400,11000006,'闪避<color=#4eae1aff>+885</color>'),(6000,178,'影遁',1,10,4,420,1000,'[{6,890}]',27550,11000006,'闪避<color=#4eae1aff>+890</color>'),(6000,179,'影遁',1,10,4,420,1000,'[{6,895}]',27700,11000006,'闪避<color=#4eae1aff>+895</color>'),(6000,180,'影遁',1,10,4,420,1000,'[{6,900}]',27850,11000006,'闪避<color=#4eae1aff>+900</color>'),(6000,181,'影遁',1,10,4,420,1000,'[{6,905}]',28000,11000006,'闪避<color=#4eae1aff>+905</color>'),(6000,182,'影遁',1,10,4,420,1000,'[{6,910}]',28150,11000006,'闪避<color=#4eae1aff>+910</color>'),(6000,183,'影遁',1,10,4,420,1000,'[{6,915}]',28300,11000006,'闪避<color=#4eae1aff>+915</color>'),(6000,184,'影遁',1,10,4,420,1000,'[{6,920}]',28450,11000006,'闪避<color=#4eae1aff>+920</color>'),(6000,185,'影遁',1,10,4,420,1000,'[{6,925}]',28600,11000006,'闪避<color=#4eae1aff>+925</color>'),(6000,186,'影遁',1,10,4,420,1000,'[{6,930}]',28750,11000006,'闪避<color=#4eae1aff>+930</color>'),(6000,187,'影遁',1,10,4,420,1000,'[{6,935}]',28900,11000006,'闪避<color=#4eae1aff>+935</color>'),(6000,188,'影遁',1,10,4,420,1000,'[{6,940}]',29050,11000006,'闪避<color=#4eae1aff>+940</color>'),(6000,189,'影遁',1,10,4,420,1000,'[{6,945}]',29200,11000006,'闪避<color=#4eae1aff>+945</color>'),(6000,190,'影遁',1,10,4,420,1000,'[{6,950}]',29350,11000006,'闪避<color=#4eae1aff>+950</color>'),(6000,191,'影遁',1,10,4,420,1000,'[{6,955}]',29500,11000006,'闪避<color=#4eae1aff>+955</color>'),(6000,192,'影遁',1,10,4,420,1000,'[{6,960}]',29650,11000006,'闪避<color=#4eae1aff>+960</color>'),(6000,193,'影遁',1,10,4,420,1000,'[{6,965}]',29800,11000006,'闪避<color=#4eae1aff>+965</color>'),(6000,194,'影遁',1,10,4,420,1000,'[{6,970}]',29950,11000006,'闪避<color=#4eae1aff>+970</color>'),(6000,195,'影遁',1,10,4,420,1000,'[{6,975}]',30100,11000006,'闪避<color=#4eae1aff>+975</color>'),(6000,196,'影遁',1,10,4,420,1000,'[{6,980}]',30250,11000006,'闪避<color=#4eae1aff>+980</color>'),(6000,197,'影遁',1,10,4,420,1000,'[{6,985}]',30400,11000006,'闪避<color=#4eae1aff>+985</color>'),(6000,198,'影遁',1,10,4,420,1000,'[{6,990}]',30550,11000006,'闪避<color=#4eae1aff>+990</color>'),(6000,199,'影遁',1,10,4,420,1000,'[{6,995}]',30700,11000006,'闪避<color=#4eae1aff>+995</color>'),(6000,200,'影遁',1,10,4,420,1000,'[{6,1000}]',30850,11000006,'闪避<color=#4eae1aff>+1000</color>'),(6000,201,'影遁',1,10,5,420,1000,'[{6,1005}]',31000,11000006,'闪避<color=#4eae1aff>+1005</color>'),(6000,202,'影遁',1,10,5,420,1000,'[{6,1010}]',31150,11000006,'闪避<color=#4eae1aff>+1010</color>'),(6000,203,'影遁',1,10,5,420,1000,'[{6,1015}]',31300,11000006,'闪避<color=#4eae1aff>+1015</color>'),(6000,204,'影遁',1,10,5,420,1000,'[{6,1020}]',31450,11000006,'闪避<color=#4eae1aff>+1020</color>'),(6000,205,'影遁',1,10,5,420,1000,'[{6,1025}]',31600,11000006,'闪避<color=#4eae1aff>+1025</color>'),(6000,206,'影遁',1,10,5,420,1000,'[{6,1030}]',31750,11000006,'闪避<color=#4eae1aff>+1030</color>'),(6000,207,'影遁',1,10,5,420,1000,'[{6,1035}]',31900,11000006,'闪避<color=#4eae1aff>+1035</color>'),(6000,208,'影遁',1,10,5,420,1000,'[{6,1040}]',32050,11000006,'闪避<color=#4eae1aff>+1040</color>'),(6000,209,'影遁',1,10,5,420,1000,'[{6,1045}]',32200,11000006,'闪避<color=#4eae1aff>+1045</color>'),(6000,210,'影遁',1,10,5,420,1000,'[{6,1050}]',32350,11000006,'闪避<color=#4eae1aff>+1050</color>'),(6000,211,'影遁',1,10,5,420,1000,'[{6,1055}]',32500,11000006,'闪避<color=#4eae1aff>+1055</color>'),(6000,212,'影遁',1,10,5,420,1000,'[{6,1060}]',32650,11000006,'闪避<color=#4eae1aff>+1060</color>'),(6000,213,'影遁',1,10,5,420,1000,'[{6,1065}]',32800,11000006,'闪避<color=#4eae1aff>+1065</color>'),(6000,214,'影遁',1,10,5,420,1000,'[{6,1070}]',32950,11000006,'闪避<color=#4eae1aff>+1070</color>'),(6000,215,'影遁',1,10,5,420,1000,'[{6,1075}]',33100,11000006,'闪避<color=#4eae1aff>+1075</color>'),(6000,216,'影遁',1,10,5,420,1000,'[{6,1080}]',33250,11000006,'闪避<color=#4eae1aff>+1080</color>'),(6000,217,'影遁',1,10,5,420,1000,'[{6,1085}]',33400,11000006,'闪避<color=#4eae1aff>+1085</color>'),(6000,218,'影遁',1,10,5,420,1000,'[{6,1090}]',33550,11000006,'闪避<color=#4eae1aff>+1090</color>'),(6000,219,'影遁',1,10,5,420,1000,'[{6,1095}]',33700,11000006,'闪避<color=#4eae1aff>+1095</color>'),(6000,220,'影遁',1,10,5,420,1000,'[{6,1100}]',33850,11000006,'闪避<color=#4eae1aff>+1100</color>'),(6000,221,'影遁',1,10,5,420,1000,'[{6,1105}]',34000,11000006,'闪避<color=#4eae1aff>+1105</color>'),(6000,222,'影遁',1,10,5,420,1000,'[{6,1110}]',34150,11000006,'闪避<color=#4eae1aff>+1110</color>'),(6000,223,'影遁',1,10,5,420,1000,'[{6,1115}]',34300,11000006,'闪避<color=#4eae1aff>+1115</color>'),(6000,224,'影遁',1,10,5,420,1000,'[{6,1120}]',34450,11000006,'闪避<color=#4eae1aff>+1120</color>'),(6000,225,'影遁',1,10,5,420,1000,'[{6,1125}]',34600,11000006,'闪避<color=#4eae1aff>+1125</color>'),(6000,226,'影遁',1,10,5,420,1000,'[{6,1130}]',34750,11000006,'闪避<color=#4eae1aff>+1130</color>'),(6000,227,'影遁',1,10,5,420,1000,'[{6,1135}]',34900,11000006,'闪避<color=#4eae1aff>+1135</color>'),(6000,228,'影遁',1,10,5,420,1000,'[{6,1140}]',35050,11000006,'闪避<color=#4eae1aff>+1140</color>'),(6000,229,'影遁',1,10,5,420,1000,'[{6,1145}]',35200,11000006,'闪避<color=#4eae1aff>+1145</color>'),(6000,230,'影遁',1,10,5,420,1000,'[{6,1150}]',35350,11000006,'闪避<color=#4eae1aff>+1150</color>'),(6000,231,'影遁',1,10,5,420,1000,'[{6,1155}]',35500,11000006,'闪避<color=#4eae1aff>+1155</color>'),(6000,232,'影遁',1,10,5,420,1000,'[{6,1160}]',35650,11000006,'闪避<color=#4eae1aff>+1160</color>'),(6000,233,'影遁',1,10,5,420,1000,'[{6,1165}]',35800,11000006,'闪避<color=#4eae1aff>+1165</color>'),(6000,234,'影遁',1,10,5,420,1000,'[{6,1170}]',35950,11000006,'闪避<color=#4eae1aff>+1170</color>'),(6000,235,'影遁',1,10,5,420,1000,'[{6,1175}]',36100,11000006,'闪避<color=#4eae1aff>+1175</color>'),(6000,236,'影遁',1,10,5,420,1000,'[{6,1180}]',36250,11000006,'闪避<color=#4eae1aff>+1180</color>'),(6000,237,'影遁',1,10,5,420,1000,'[{6,1185}]',36400,11000006,'闪避<color=#4eae1aff>+1185</color>'),(6000,238,'影遁',1,10,5,420,1000,'[{6,1190}]',36550,11000006,'闪避<color=#4eae1aff>+1190</color>'),(6000,239,'影遁',1,10,5,420,1000,'[{6,1195}]',36700,11000006,'闪避<color=#4eae1aff>+1195</color>'),(6000,240,'影遁',1,10,5,420,1000,'[{6,1200}]',36850,11000006,'闪避<color=#4eae1aff>+1200</color>'),(6000,241,'影遁',1,10,5,420,1000,'[{6,1205}]',37000,11000006,'闪避<color=#4eae1aff>+1205</color>'),(6000,242,'影遁',1,10,5,420,1000,'[{6,1210}]',37150,11000006,'闪避<color=#4eae1aff>+1210</color>'),(6000,243,'影遁',1,10,5,420,1000,'[{6,1215}]',37300,11000006,'闪避<color=#4eae1aff>+1215</color>'),(6000,244,'影遁',1,10,5,420,1000,'[{6,1220}]',37450,11000006,'闪避<color=#4eae1aff>+1220</color>'),(6000,245,'影遁',1,10,5,420,1000,'[{6,1225}]',37600,11000006,'闪避<color=#4eae1aff>+1225</color>'),(6000,246,'影遁',1,10,5,420,1000,'[{6,1230}]',37750,11000006,'闪避<color=#4eae1aff>+1230</color>'),(6000,247,'影遁',1,10,5,420,1000,'[{6,1235}]',37900,11000006,'闪避<color=#4eae1aff>+1235</color>'),(6000,248,'影遁',1,10,5,420,1000,'[{6,1240}]',38050,11000006,'闪避<color=#4eae1aff>+1240</color>'),(6000,249,'影遁',1,10,5,420,1000,'[{6,1245}]',38200,11000006,'闪避<color=#4eae1aff>+1245</color>'),(6000,250,'影遁',1,10,5,420,1000,'[{6,1250}]',38350,11000006,'闪避<color=#4eae1aff>+1250</color>'),(6000,251,'影遁',1,10,6,420,1000,'[{6,1255}]',38500,11000006,'闪避<color=#4eae1aff>+1255</color>'),(6000,252,'影遁',1,10,6,420,1000,'[{6,1260}]',38650,11000006,'闪避<color=#4eae1aff>+1260</color>'),(6000,253,'影遁',1,10,6,420,1000,'[{6,1265}]',38800,11000006,'闪避<color=#4eae1aff>+1265</color>'),(6000,254,'影遁',1,10,6,420,1000,'[{6,1270}]',38950,11000006,'闪避<color=#4eae1aff>+1270</color>'),(6000,255,'影遁',1,10,6,420,1000,'[{6,1275}]',39100,11000006,'闪避<color=#4eae1aff>+1275</color>'),(6000,256,'影遁',1,10,6,420,1000,'[{6,1280}]',39250,11000006,'闪避<color=#4eae1aff>+1280</color>'),(6000,257,'影遁',1,10,6,420,1000,'[{6,1285}]',39400,11000006,'闪避<color=#4eae1aff>+1285</color>'),(6000,258,'影遁',1,10,6,420,1000,'[{6,1290}]',39550,11000006,'闪避<color=#4eae1aff>+1290</color>'),(6000,259,'影遁',1,10,6,420,1000,'[{6,1295}]',39700,11000006,'闪避<color=#4eae1aff>+1295</color>'),(6000,260,'影遁',1,10,6,420,1000,'[{6,1300}]',39850,11000006,'闪避<color=#4eae1aff>+1300</color>'),(6000,261,'影遁',1,10,6,420,1000,'[{6,1305}]',40000,11000006,'闪避<color=#4eae1aff>+1305</color>'),(6000,262,'影遁',1,10,6,420,1000,'[{6,1310}]',40150,11000006,'闪避<color=#4eae1aff>+1310</color>'),(6000,263,'影遁',1,10,6,420,1000,'[{6,1315}]',40300,11000006,'闪避<color=#4eae1aff>+1315</color>'),(6000,264,'影遁',1,10,6,420,1000,'[{6,1320}]',40450,11000006,'闪避<color=#4eae1aff>+1320</color>'),(6000,265,'影遁',1,10,6,420,1000,'[{6,1325}]',40600,11000006,'闪避<color=#4eae1aff>+1325</color>'),(6000,266,'影遁',1,10,6,420,1000,'[{6,1330}]',40750,11000006,'闪避<color=#4eae1aff>+1330</color>'),(6000,267,'影遁',1,10,6,420,1000,'[{6,1335}]',40900,11000006,'闪避<color=#4eae1aff>+1335</color>'),(6000,268,'影遁',1,10,6,420,1000,'[{6,1340}]',41050,11000006,'闪避<color=#4eae1aff>+1340</color>'),(6000,269,'影遁',1,10,6,420,1000,'[{6,1345}]',41200,11000006,'闪避<color=#4eae1aff>+1345</color>'),(6000,270,'影遁',1,10,6,420,1000,'[{6,1350}]',41350,11000006,'闪避<color=#4eae1aff>+1350</color>'),(6000,271,'影遁',1,10,6,420,1000,'[{6,1355}]',41500,11000006,'闪避<color=#4eae1aff>+1355</color>'),(6000,272,'影遁',1,10,6,420,1000,'[{6,1360}]',41650,11000006,'闪避<color=#4eae1aff>+1360</color>'),(6000,273,'影遁',1,10,6,420,1000,'[{6,1365}]',41800,11000006,'闪避<color=#4eae1aff>+1365</color>'),(6000,274,'影遁',1,10,6,420,1000,'[{6,1370}]',41950,11000006,'闪避<color=#4eae1aff>+1370</color>'),(6000,275,'影遁',1,10,6,420,1000,'[{6,1375}]',42100,11000006,'闪避<color=#4eae1aff>+1375</color>'),(6000,276,'影遁',1,10,6,420,1000,'[{6,1380}]',42250,11000006,'闪避<color=#4eae1aff>+1380</color>'),(6000,277,'影遁',1,10,6,420,1000,'[{6,1385}]',42400,11000006,'闪避<color=#4eae1aff>+1385</color>'),(6000,278,'影遁',1,10,6,420,1000,'[{6,1390}]',42550,11000006,'闪避<color=#4eae1aff>+1390</color>'),(6000,279,'影遁',1,10,6,420,1000,'[{6,1395}]',42700,11000006,'闪避<color=#4eae1aff>+1395</color>'),(6000,280,'影遁',1,10,6,420,1000,'[{6,1400}]',42850,11000006,'闪避<color=#4eae1aff>+1400</color>'),(6000,281,'影遁',1,10,6,420,1000,'[{6,1405}]',43000,11000006,'闪避<color=#4eae1aff>+1405</color>'),(6000,282,'影遁',1,10,6,420,1000,'[{6,1410}]',43150,11000006,'闪避<color=#4eae1aff>+1410</color>'),(6000,283,'影遁',1,10,6,420,1000,'[{6,1415}]',43300,11000006,'闪避<color=#4eae1aff>+1415</color>'),(6000,284,'影遁',1,10,6,420,1000,'[{6,1420}]',43450,11000006,'闪避<color=#4eae1aff>+1420</color>'),(6000,285,'影遁',1,10,6,420,1000,'[{6,1425}]',43600,11000006,'闪避<color=#4eae1aff>+1425</color>'),(6000,286,'影遁',1,10,6,420,1000,'[{6,1430}]',43750,11000006,'闪避<color=#4eae1aff>+1430</color>'),(6000,287,'影遁',1,10,6,420,1000,'[{6,1435}]',43900,11000006,'闪避<color=#4eae1aff>+1435</color>'),(6000,288,'影遁',1,10,6,420,1000,'[{6,1440}]',44050,11000006,'闪避<color=#4eae1aff>+1440</color>'),(6000,289,'影遁',1,10,6,420,1000,'[{6,1445}]',44200,11000006,'闪避<color=#4eae1aff>+1445</color>'),(6000,290,'影遁',1,10,6,420,1000,'[{6,1450}]',44350,11000006,'闪避<color=#4eae1aff>+1450</color>'),(6000,291,'影遁',1,10,6,420,1000,'[{6,1455}]',44500,11000006,'闪避<color=#4eae1aff>+1455</color>'),(6000,292,'影遁',1,10,6,420,1000,'[{6,1460}]',44650,11000006,'闪避<color=#4eae1aff>+1460</color>'),(6000,293,'影遁',1,10,6,420,1000,'[{6,1465}]',44800,11000006,'闪避<color=#4eae1aff>+1465</color>'),(6000,294,'影遁',1,10,6,420,1000,'[{6,1470}]',44950,11000006,'闪避<color=#4eae1aff>+1470</color>'),(6000,295,'影遁',1,10,6,420,1000,'[{6,1475}]',45100,11000006,'闪避<color=#4eae1aff>+1475</color>'),(6000,296,'影遁',1,10,6,420,1000,'[{6,1480}]',45250,11000006,'闪避<color=#4eae1aff>+1480</color>'),(6000,297,'影遁',1,10,6,420,1000,'[{6,1485}]',45400,11000006,'闪避<color=#4eae1aff>+1485</color>'),(6000,298,'影遁',1,10,6,420,1000,'[{6,1490}]',45550,11000006,'闪避<color=#4eae1aff>+1490</color>'),(6000,299,'影遁',1,10,6,420,1000,'[{6,1495}]',45700,11000006,'闪避<color=#4eae1aff>+1495</color>'),(6000,300,'影遁',1,10,6,420,1000,'[{6,1500}]',45850,11000006,'闪避<color=#4eae1aff>+1500</color>'),(6000,301,'影遁',1,10,7,420,1000,'[{6,1505}]',46000,11000006,'闪避<color=#4eae1aff>+1505</color>'),(6000,302,'影遁',1,10,7,420,1000,'[{6,1510}]',46150,11000006,'闪避<color=#4eae1aff>+1510</color>'),(6000,303,'影遁',1,10,7,420,1000,'[{6,1515}]',46300,11000006,'闪避<color=#4eae1aff>+1515</color>'),(6000,304,'影遁',1,10,7,420,1000,'[{6,1520}]',46450,11000006,'闪避<color=#4eae1aff>+1520</color>'),(6000,305,'影遁',1,10,7,420,1000,'[{6,1525}]',46600,11000006,'闪避<color=#4eae1aff>+1525</color>'),(6000,306,'影遁',1,10,7,420,1000,'[{6,1530}]',46750,11000006,'闪避<color=#4eae1aff>+1530</color>'),(6000,307,'影遁',1,10,7,420,1000,'[{6,1535}]',46900,11000006,'闪避<color=#4eae1aff>+1535</color>'),(6000,308,'影遁',1,10,7,420,1000,'[{6,1540}]',47050,11000006,'闪避<color=#4eae1aff>+1540</color>'),(6000,309,'影遁',1,10,7,420,1000,'[{6,1545}]',47200,11000006,'闪避<color=#4eae1aff>+1545</color>'),(6000,310,'影遁',1,10,7,420,1000,'[{6,1550}]',47350,11000006,'闪避<color=#4eae1aff>+1550</color>'),(6000,311,'影遁',1,10,7,420,1000,'[{6,1555}]',47500,11000006,'闪避<color=#4eae1aff>+1555</color>'),(6000,312,'影遁',1,10,7,420,1000,'[{6,1560}]',47650,11000006,'闪避<color=#4eae1aff>+1560</color>'),(6000,313,'影遁',1,10,7,420,1000,'[{6,1565}]',47800,11000006,'闪避<color=#4eae1aff>+1565</color>'),(6000,314,'影遁',1,10,7,420,1000,'[{6,1570}]',47950,11000006,'闪避<color=#4eae1aff>+1570</color>'),(6000,315,'影遁',1,10,7,420,1000,'[{6,1575}]',48100,11000006,'闪避<color=#4eae1aff>+1575</color>'),(6000,316,'影遁',1,10,7,420,1000,'[{6,1580}]',48250,11000006,'闪避<color=#4eae1aff>+1580</color>'),(6000,317,'影遁',1,10,7,420,1000,'[{6,1585}]',48400,11000006,'闪避<color=#4eae1aff>+1585</color>'),(6000,318,'影遁',1,10,7,420,1000,'[{6,1590}]',48550,11000006,'闪避<color=#4eae1aff>+1590</color>'),(6000,319,'影遁',1,10,7,420,1000,'[{6,1595}]',48700,11000006,'闪避<color=#4eae1aff>+1595</color>'),(6000,320,'影遁',1,10,7,420,1000,'[{6,1600}]',48850,11000006,'闪避<color=#4eae1aff>+1600</color>'),(6000,321,'影遁',1,10,7,420,1000,'[{6,1605}]',49000,11000006,'闪避<color=#4eae1aff>+1605</color>'),(6000,322,'影遁',1,10,7,420,1000,'[{6,1610}]',49150,11000006,'闪避<color=#4eae1aff>+1610</color>'),(6000,323,'影遁',1,10,7,420,1000,'[{6,1615}]',49300,11000006,'闪避<color=#4eae1aff>+1615</color>'),(6000,324,'影遁',1,10,7,420,1000,'[{6,1620}]',49450,11000006,'闪避<color=#4eae1aff>+1620</color>'),(6000,325,'影遁',1,10,7,420,1000,'[{6,1625}]',49600,11000006,'闪避<color=#4eae1aff>+1625</color>'),(6000,326,'影遁',1,10,7,420,1000,'[{6,1630}]',49750,11000006,'闪避<color=#4eae1aff>+1630</color>'),(6000,327,'影遁',1,10,7,420,1000,'[{6,1635}]',49900,11000006,'闪避<color=#4eae1aff>+1635</color>'),(6000,328,'影遁',1,10,7,420,1000,'[{6,1640}]',50050,11000006,'闪避<color=#4eae1aff>+1640</color>'),(6000,329,'影遁',1,10,7,420,1000,'[{6,1645}]',50200,11000006,'闪避<color=#4eae1aff>+1645</color>'),(6000,330,'影遁',1,10,7,420,1000,'[{6,1650}]',50350,11000006,'闪避<color=#4eae1aff>+1650</color>'),(6000,331,'影遁',1,10,7,420,1000,'[{6,1655}]',50500,11000006,'闪避<color=#4eae1aff>+1655</color>'),(6000,332,'影遁',1,10,7,420,1000,'[{6,1660}]',50650,11000006,'闪避<color=#4eae1aff>+1660</color>'),(6000,333,'影遁',1,10,7,420,1000,'[{6,1665}]',50800,11000006,'闪避<color=#4eae1aff>+1665</color>'),(6000,334,'影遁',1,10,7,420,1000,'[{6,1670}]',50950,11000006,'闪避<color=#4eae1aff>+1670</color>'),(6000,335,'影遁',1,10,7,420,1000,'[{6,1675}]',51100,11000006,'闪避<color=#4eae1aff>+1675</color>'),(6000,336,'影遁',1,10,7,420,1000,'[{6,1680}]',51250,11000006,'闪避<color=#4eae1aff>+1680</color>'),(6000,337,'影遁',1,10,7,420,1000,'[{6,1685}]',51400,11000006,'闪避<color=#4eae1aff>+1685</color>'),(6000,338,'影遁',1,10,7,420,1000,'[{6,1690}]',51550,11000006,'闪避<color=#4eae1aff>+1690</color>'),(6000,339,'影遁',1,10,7,420,1000,'[{6,1695}]',51700,11000006,'闪避<color=#4eae1aff>+1695</color>'),(6000,340,'影遁',1,10,7,420,1000,'[{6,1700}]',51850,11000006,'闪避<color=#4eae1aff>+1700</color>'),(6000,341,'影遁',1,10,7,420,1000,'[{6,1705}]',52000,11000006,'闪避<color=#4eae1aff>+1705</color>'),(6000,342,'影遁',1,10,7,420,1000,'[{6,1710}]',52150,11000006,'闪避<color=#4eae1aff>+1710</color>'),(6000,343,'影遁',1,10,7,420,1000,'[{6,1715}]',52300,11000006,'闪避<color=#4eae1aff>+1715</color>'),(6000,344,'影遁',1,10,7,420,1000,'[{6,1720}]',52450,11000006,'闪避<color=#4eae1aff>+1720</color>'),(6000,345,'影遁',1,10,7,420,1000,'[{6,1725}]',52600,11000006,'闪避<color=#4eae1aff>+1725</color>'),(6000,346,'影遁',1,10,7,420,1000,'[{6,1730}]',52750,11000006,'闪避<color=#4eae1aff>+1730</color>'),(6000,347,'影遁',1,10,7,420,1000,'[{6,1735}]',52900,11000006,'闪避<color=#4eae1aff>+1735</color>'),(6000,348,'影遁',1,10,7,420,1000,'[{6,1740}]',53050,11000006,'闪避<color=#4eae1aff>+1740</color>'),(6000,349,'影遁',1,10,7,420,1000,'[{6,1745}]',53200,11000006,'闪避<color=#4eae1aff>+1745</color>'),(6000,350,'影遁',1,10,7,420,1000,'[{6,1750}]',53350,11000006,'闪避<color=#4eae1aff>+1750</color>'),(6000,351,'影遁',1,10,8,420,1000,'[{6,1755}]',53500,11000006,'闪避<color=#4eae1aff>+1755</color>'),(6000,352,'影遁',1,10,8,420,1000,'[{6,1760}]',53650,11000006,'闪避<color=#4eae1aff>+1760</color>'),(6000,353,'影遁',1,10,8,420,1000,'[{6,1765}]',53800,11000006,'闪避<color=#4eae1aff>+1765</color>'),(6000,354,'影遁',1,10,8,420,1000,'[{6,1770}]',53950,11000006,'闪避<color=#4eae1aff>+1770</color>'),(6000,355,'影遁',1,10,8,420,1000,'[{6,1775}]',54100,11000006,'闪避<color=#4eae1aff>+1775</color>'),(6000,356,'影遁',1,10,8,420,1000,'[{6,1780}]',54250,11000006,'闪避<color=#4eae1aff>+1780</color>'),(6000,357,'影遁',1,10,8,420,1000,'[{6,1785}]',54400,11000006,'闪避<color=#4eae1aff>+1785</color>'),(6000,358,'影遁',1,10,8,420,1000,'[{6,1790}]',54550,11000006,'闪避<color=#4eae1aff>+1790</color>'),(6000,359,'影遁',1,10,8,420,1000,'[{6,1795}]',54700,11000006,'闪避<color=#4eae1aff>+1795</color>'),(6000,360,'影遁',1,10,8,420,1000,'[{6,1800}]',54850,11000006,'闪避<color=#4eae1aff>+1800</color>'),(6000,361,'影遁',1,10,8,420,1000,'[{6,1805}]',55000,11000006,'闪避<color=#4eae1aff>+1805</color>'),(6000,362,'影遁',1,10,8,420,1000,'[{6,1810}]',55150,11000006,'闪避<color=#4eae1aff>+1810</color>'),(6000,363,'影遁',1,10,8,420,1000,'[{6,1815}]',55300,11000006,'闪避<color=#4eae1aff>+1815</color>'),(6000,364,'影遁',1,10,8,420,1000,'[{6,1820}]',55450,11000006,'闪避<color=#4eae1aff>+1820</color>'),(6000,365,'影遁',1,10,8,420,1000,'[{6,1825}]',55600,11000006,'闪避<color=#4eae1aff>+1825</color>'),(6000,366,'影遁',1,10,8,420,1000,'[{6,1830}]',55750,11000006,'闪避<color=#4eae1aff>+1830</color>'),(6000,367,'影遁',1,10,8,420,1000,'[{6,1835}]',55900,11000006,'闪避<color=#4eae1aff>+1835</color>'),(6000,368,'影遁',1,10,8,420,1000,'[{6,1840}]',56050,11000006,'闪避<color=#4eae1aff>+1840</color>'),(6000,369,'影遁',1,10,8,420,1000,'[{6,1845}]',56200,11000006,'闪避<color=#4eae1aff>+1845</color>'),(6000,370,'影遁',1,10,8,420,1000,'[{6,1850}]',56350,11000006,'闪避<color=#4eae1aff>+1850</color>'),(6000,371,'影遁',1,10,8,420,1000,'[{6,1855}]',56500,11000006,'闪避<color=#4eae1aff>+1855</color>'),(6000,372,'影遁',1,10,8,420,1000,'[{6,1860}]',56650,11000006,'闪避<color=#4eae1aff>+1860</color>'),(6000,373,'影遁',1,10,8,420,1000,'[{6,1865}]',56800,11000006,'闪避<color=#4eae1aff>+1865</color>'),(6000,374,'影遁',1,10,8,420,1000,'[{6,1870}]',56950,11000006,'闪避<color=#4eae1aff>+1870</color>'),(6000,375,'影遁',1,10,8,420,1000,'[{6,1875}]',57100,11000006,'闪避<color=#4eae1aff>+1875</color>'),(6000,376,'影遁',1,10,8,420,1000,'[{6,1880}]',57250,11000006,'闪避<color=#4eae1aff>+1880</color>'),(6000,377,'影遁',1,10,8,420,1000,'[{6,1885}]',57400,11000006,'闪避<color=#4eae1aff>+1885</color>'),(6000,378,'影遁',1,10,8,420,1000,'[{6,1890}]',57550,11000006,'闪避<color=#4eae1aff>+1890</color>'),(6000,379,'影遁',1,10,8,420,1000,'[{6,1895}]',57700,11000006,'闪避<color=#4eae1aff>+1895</color>'),(6000,380,'影遁',1,10,8,420,1000,'[{6,1900}]',57850,11000006,'闪避<color=#4eae1aff>+1900</color>'),(6000,381,'影遁',1,10,8,420,1000,'[{6,1905}]',58000,11000006,'闪避<color=#4eae1aff>+1905</color>'),(6000,382,'影遁',1,10,8,420,1000,'[{6,1910}]',58150,11000006,'闪避<color=#4eae1aff>+1910</color>'),(6000,383,'影遁',1,10,8,420,1000,'[{6,1915}]',58300,11000006,'闪避<color=#4eae1aff>+1915</color>'),(6000,384,'影遁',1,10,8,420,1000,'[{6,1920}]',58450,11000006,'闪避<color=#4eae1aff>+1920</color>'),(6000,385,'影遁',1,10,8,420,1000,'[{6,1925}]',58600,11000006,'闪避<color=#4eae1aff>+1925</color>'),(6000,386,'影遁',1,10,8,420,1000,'[{6,1930}]',58750,11000006,'闪避<color=#4eae1aff>+1930</color>'),(6000,387,'影遁',1,10,8,420,1000,'[{6,1935}]',58900,11000006,'闪避<color=#4eae1aff>+1935</color>'),(6000,388,'影遁',1,10,8,420,1000,'[{6,1940}]',59050,11000006,'闪避<color=#4eae1aff>+1940</color>'),(6000,389,'影遁',1,10,8,420,1000,'[{6,1945}]',59200,11000006,'闪避<color=#4eae1aff>+1945</color>'),(6000,390,'影遁',1,10,8,420,1000,'[{6,1950}]',59350,11000006,'闪避<color=#4eae1aff>+1950</color>'),(6000,391,'影遁',1,10,8,420,1000,'[{6,1955}]',59500,11000006,'闪避<color=#4eae1aff>+1955</color>'),(6000,392,'影遁',1,10,8,420,1000,'[{6,1960}]',59650,11000006,'闪避<color=#4eae1aff>+1960</color>'),(6000,393,'影遁',1,10,8,420,1000,'[{6,1965}]',59800,11000006,'闪避<color=#4eae1aff>+1965</color>'),(6000,394,'影遁',1,10,8,420,1000,'[{6,1970}]',59950,11000006,'闪避<color=#4eae1aff>+1970</color>'),(6000,395,'影遁',1,10,8,420,1000,'[{6,1975}]',60100,11000006,'闪避<color=#4eae1aff>+1975</color>'),(6000,396,'影遁',1,10,8,420,1000,'[{6,1980}]',60250,11000006,'闪避<color=#4eae1aff>+1980</color>'),(6000,397,'影遁',1,10,8,420,1000,'[{6,1985}]',60400,11000006,'闪避<color=#4eae1aff>+1985</color>'),(6000,398,'影遁',1,10,8,420,1000,'[{6,1990}]',60550,11000006,'闪避<color=#4eae1aff>+1990</color>'),(6000,399,'影遁',1,10,8,420,1000,'[{6,1995}]',60700,11000006,'闪避<color=#4eae1aff>+1995</color>'),(6000,400,'影遁',1,10,8,420,1000,'[{6,2000}]',60850,11000006,'闪避<color=#4eae1aff>+2000</color>'),(6000,401,'影遁',1,10,9,420,1000,'[{6,2005}]',61000,11000006,'闪避<color=#4eae1aff>+2005</color>'),(6000,402,'影遁',1,10,9,420,1000,'[{6,2010}]',61150,11000006,'闪避<color=#4eae1aff>+2010</color>'),(6000,403,'影遁',1,10,9,420,1000,'[{6,2015}]',61300,11000006,'闪避<color=#4eae1aff>+2015</color>'),(6000,404,'影遁',1,10,9,420,1000,'[{6,2020}]',61450,11000006,'闪避<color=#4eae1aff>+2020</color>'),(6000,405,'影遁',1,10,9,420,1000,'[{6,2025}]',61600,11000006,'闪避<color=#4eae1aff>+2025</color>'),(6000,406,'影遁',1,10,9,420,1000,'[{6,2030}]',61750,11000006,'闪避<color=#4eae1aff>+2030</color>'),(6000,407,'影遁',1,10,9,420,1000,'[{6,2035}]',61900,11000006,'闪避<color=#4eae1aff>+2035</color>'),(6000,408,'影遁',1,10,9,420,1000,'[{6,2040}]',62050,11000006,'闪避<color=#4eae1aff>+2040</color>'),(6000,409,'影遁',1,10,9,420,1000,'[{6,2045}]',62200,11000006,'闪避<color=#4eae1aff>+2045</color>'),(6000,410,'影遁',1,10,9,420,1000,'[{6,2050}]',62350,11000006,'闪避<color=#4eae1aff>+2050</color>'),(6000,411,'影遁',1,10,9,420,1000,'[{6,2055}]',62500,11000006,'闪避<color=#4eae1aff>+2055</color>'),(6000,412,'影遁',1,10,9,420,1000,'[{6,2060}]',62650,11000006,'闪避<color=#4eae1aff>+2060</color>'),(6000,413,'影遁',1,10,9,420,1000,'[{6,2065}]',62800,11000006,'闪避<color=#4eae1aff>+2065</color>'),(6000,414,'影遁',1,10,9,420,1000,'[{6,2070}]',62950,11000006,'闪避<color=#4eae1aff>+2070</color>'),(6000,415,'影遁',1,10,9,420,1000,'[{6,2075}]',63100,11000006,'闪避<color=#4eae1aff>+2075</color>'),(6000,416,'影遁',1,10,9,420,1000,'[{6,2080}]',63250,11000006,'闪避<color=#4eae1aff>+2080</color>'),(6000,417,'影遁',1,10,9,420,1000,'[{6,2085}]',63400,11000006,'闪避<color=#4eae1aff>+2085</color>'),(6000,418,'影遁',1,10,9,420,1000,'[{6,2090}]',63550,11000006,'闪避<color=#4eae1aff>+2090</color>'),(6000,419,'影遁',1,10,9,420,1000,'[{6,2095}]',63700,11000006,'闪避<color=#4eae1aff>+2095</color>'),(6000,420,'影遁',1,10,9,420,1000,'[{6,2100}]',63850,11000006,'闪避<color=#4eae1aff>+2100</color>'),(6000,421,'影遁',1,10,9,420,1000,'[{6,2105}]',64000,11000006,'闪避<color=#4eae1aff>+2105</color>'),(6000,422,'影遁',1,10,9,420,1000,'[{6,2110}]',64150,11000006,'闪避<color=#4eae1aff>+2110</color>'),(6000,423,'影遁',1,10,9,420,1000,'[{6,2115}]',64300,11000006,'闪避<color=#4eae1aff>+2115</color>'),(6000,424,'影遁',1,10,9,420,1000,'[{6,2120}]',64450,11000006,'闪避<color=#4eae1aff>+2120</color>'),(6000,425,'影遁',1,10,9,420,1000,'[{6,2125}]',64600,11000006,'闪避<color=#4eae1aff>+2125</color>'),(6000,426,'影遁',1,10,9,420,1000,'[{6,2130}]',64750,11000006,'闪避<color=#4eae1aff>+2130</color>'),(6000,427,'影遁',1,10,9,420,1000,'[{6,2135}]',64900,11000006,'闪避<color=#4eae1aff>+2135</color>'),(6000,428,'影遁',1,10,9,420,1000,'[{6,2140}]',65050,11000006,'闪避<color=#4eae1aff>+2140</color>'),(6000,429,'影遁',1,10,9,420,1000,'[{6,2145}]',65200,11000006,'闪避<color=#4eae1aff>+2145</color>'),(6000,430,'影遁',1,10,9,420,1000,'[{6,2150}]',65350,11000006,'闪避<color=#4eae1aff>+2150</color>'),(6000,431,'影遁',1,10,9,420,1000,'[{6,2155}]',65500,11000006,'闪避<color=#4eae1aff>+2155</color>'),(6000,432,'影遁',1,10,9,420,1000,'[{6,2160}]',65650,11000006,'闪避<color=#4eae1aff>+2160</color>'),(6000,433,'影遁',1,10,9,420,1000,'[{6,2165}]',65800,11000006,'闪避<color=#4eae1aff>+2165</color>'),(6000,434,'影遁',1,10,9,420,1000,'[{6,2170}]',65950,11000006,'闪避<color=#4eae1aff>+2170</color>'),(6000,435,'影遁',1,10,9,420,1000,'[{6,2175}]',66100,11000006,'闪避<color=#4eae1aff>+2175</color>'),(6000,436,'影遁',1,10,9,420,1000,'[{6,2180}]',66250,11000006,'闪避<color=#4eae1aff>+2180</color>'),(6000,437,'影遁',1,10,9,420,1000,'[{6,2185}]',66400,11000006,'闪避<color=#4eae1aff>+2185</color>'),(6000,438,'影遁',1,10,9,420,1000,'[{6,2190}]',66550,11000006,'闪避<color=#4eae1aff>+2190</color>'),(6000,439,'影遁',1,10,9,420,1000,'[{6,2195}]',66700,11000006,'闪避<color=#4eae1aff>+2195</color>'),(6000,440,'影遁',1,10,9,420,1000,'[{6,2200}]',66850,11000006,'闪避<color=#4eae1aff>+2200</color>'),(6000,441,'影遁',1,10,9,420,1000,'[{6,2205}]',67000,11000006,'闪避<color=#4eae1aff>+2205</color>'),(6000,442,'影遁',1,10,9,420,1000,'[{6,2210}]',67150,11000006,'闪避<color=#4eae1aff>+2210</color>'),(6000,443,'影遁',1,10,9,420,1000,'[{6,2215}]',67300,11000006,'闪避<color=#4eae1aff>+2215</color>'),(6000,444,'影遁',1,10,9,420,1000,'[{6,2220}]',67450,11000006,'闪避<color=#4eae1aff>+2220</color>'),(6000,445,'影遁',1,10,9,420,1000,'[{6,2225}]',67600,11000006,'闪避<color=#4eae1aff>+2225</color>'),(6000,446,'影遁',1,10,9,420,1000,'[{6,2230}]',67750,11000006,'闪避<color=#4eae1aff>+2230</color>'),(6000,447,'影遁',1,10,9,420,1000,'[{6,2235}]',67900,11000006,'闪避<color=#4eae1aff>+2235</color>'),(6000,448,'影遁',1,10,9,420,1000,'[{6,2240}]',68050,11000006,'闪避<color=#4eae1aff>+2240</color>'),(6000,449,'影遁',1,10,9,420,1000,'[{6,2245}]',68200,11000006,'闪避<color=#4eae1aff>+2245</color>'),(6000,450,'影遁',1,10,9,420,1000,'[{6,2250}]',68350,11000006,'闪避<color=#4eae1aff>+2250</color>'),(6000,451,'影遁',1,10,10,420,1000,'[{6,2255}]',68500,11000006,'闪避<color=#4eae1aff>+2255</color>'),(6000,452,'影遁',1,10,10,420,1000,'[{6,2260}]',68650,11000006,'闪避<color=#4eae1aff>+2260</color>'),(6000,453,'影遁',1,10,10,420,1000,'[{6,2265}]',68800,11000006,'闪避<color=#4eae1aff>+2265</color>'),(6000,454,'影遁',1,10,10,420,1000,'[{6,2270}]',68950,11000006,'闪避<color=#4eae1aff>+2270</color>'),(6000,455,'影遁',1,10,10,420,1000,'[{6,2275}]',69100,11000006,'闪避<color=#4eae1aff>+2275</color>'),(6000,456,'影遁',1,10,10,420,1000,'[{6,2280}]',69250,11000006,'闪避<color=#4eae1aff>+2280</color>'),(6000,457,'影遁',1,10,10,420,1000,'[{6,2285}]',69400,11000006,'闪避<color=#4eae1aff>+2285</color>'),(6000,458,'影遁',1,10,10,420,1000,'[{6,2290}]',69550,11000006,'闪避<color=#4eae1aff>+2290</color>'),(6000,459,'影遁',1,10,10,420,1000,'[{6,2295}]',69700,11000006,'闪避<color=#4eae1aff>+2295</color>'),(6000,460,'影遁',1,10,10,420,1000,'[{6,2300}]',69850,11000006,'闪避<color=#4eae1aff>+2300</color>'),(6000,461,'影遁',1,10,10,420,1000,'[{6,2305}]',70000,11000006,'闪避<color=#4eae1aff>+2305</color>'),(6000,462,'影遁',1,10,10,420,1000,'[{6,2310}]',70150,11000006,'闪避<color=#4eae1aff>+2310</color>'),(6000,463,'影遁',1,10,10,420,1000,'[{6,2315}]',70300,11000006,'闪避<color=#4eae1aff>+2315</color>'),(6000,464,'影遁',1,10,10,420,1000,'[{6,2320}]',70450,11000006,'闪避<color=#4eae1aff>+2320</color>'),(6000,465,'影遁',1,10,10,420,1000,'[{6,2325}]',70600,11000006,'闪避<color=#4eae1aff>+2325</color>'),(6000,466,'影遁',1,10,10,420,1000,'[{6,2330}]',70750,11000006,'闪避<color=#4eae1aff>+2330</color>'),(6000,467,'影遁',1,10,10,420,1000,'[{6,2335}]',70900,11000006,'闪避<color=#4eae1aff>+2335</color>'),(6000,468,'影遁',1,10,10,420,1000,'[{6,2340}]',71050,11000006,'闪避<color=#4eae1aff>+2340</color>'),(6000,469,'影遁',1,10,10,420,1000,'[{6,2345}]',71200,11000006,'闪避<color=#4eae1aff>+2345</color>'),(6000,470,'影遁',1,10,10,420,1000,'[{6,2350}]',71350,11000006,'闪避<color=#4eae1aff>+2350</color>'),(6000,471,'影遁',1,10,10,420,1000,'[{6,2355}]',71500,11000006,'闪避<color=#4eae1aff>+2355</color>'),(6000,472,'影遁',1,10,10,420,1000,'[{6,2360}]',71650,11000006,'闪避<color=#4eae1aff>+2360</color>'),(6000,473,'影遁',1,10,10,420,1000,'[{6,2365}]',71800,11000006,'闪避<color=#4eae1aff>+2365</color>'),(6000,474,'影遁',1,10,10,420,1000,'[{6,2370}]',71950,11000006,'闪避<color=#4eae1aff>+2370</color>'),(6000,475,'影遁',1,10,10,420,1000,'[{6,2375}]',72100,11000006,'闪避<color=#4eae1aff>+2375</color>'),(6000,476,'影遁',1,10,10,420,1000,'[{6,2380}]',72250,11000006,'闪避<color=#4eae1aff>+2380</color>'),(6000,477,'影遁',1,10,10,420,1000,'[{6,2385}]',72400,11000006,'闪避<color=#4eae1aff>+2385</color>'),(6000,478,'影遁',1,10,10,420,1000,'[{6,2390}]',72550,11000006,'闪避<color=#4eae1aff>+2390</color>'),(6000,479,'影遁',1,10,10,420,1000,'[{6,2395}]',72700,11000006,'闪避<color=#4eae1aff>+2395</color>'),(6000,480,'影遁',1,10,10,420,1000,'[{6,2400}]',72850,11000006,'闪避<color=#4eae1aff>+2400</color>'),(6000,481,'影遁',1,10,10,420,1000,'[{6,2405}]',73000,11000006,'闪避<color=#4eae1aff>+2405</color>'),(6000,482,'影遁',1,10,10,420,1000,'[{6,2410}]',73150,11000006,'闪避<color=#4eae1aff>+2410</color>'),(6000,483,'影遁',1,10,10,420,1000,'[{6,2415}]',73300,11000006,'闪避<color=#4eae1aff>+2415</color>'),(6000,484,'影遁',1,10,10,420,1000,'[{6,2420}]',73450,11000006,'闪避<color=#4eae1aff>+2420</color>'),(6000,485,'影遁',1,10,10,420,1000,'[{6,2425}]',73600,11000006,'闪避<color=#4eae1aff>+2425</color>'),(6000,486,'影遁',1,10,10,420,1000,'[{6,2430}]',73750,11000006,'闪避<color=#4eae1aff>+2430</color>'),(6000,487,'影遁',1,10,10,420,1000,'[{6,2435}]',73900,11000006,'闪避<color=#4eae1aff>+2435</color>'),(6000,488,'影遁',1,10,10,420,1000,'[{6,2440}]',74050,11000006,'闪避<color=#4eae1aff>+2440</color>'),(6000,489,'影遁',1,10,10,420,1000,'[{6,2445}]',74200,11000006,'闪避<color=#4eae1aff>+2445</color>'),(6000,490,'影遁',1,10,10,420,1000,'[{6,2450}]',74350,11000006,'闪避<color=#4eae1aff>+2450</color>'),(6000,491,'影遁',1,10,10,420,1000,'[{6,2455}]',74500,11000006,'闪避<color=#4eae1aff>+2455</color>'),(6000,492,'影遁',1,10,10,420,1000,'[{6,2460}]',74650,11000006,'闪避<color=#4eae1aff>+2460</color>'),(6000,493,'影遁',1,10,10,420,1000,'[{6,2465}]',74800,11000006,'闪避<color=#4eae1aff>+2465</color>'),(6000,494,'影遁',1,10,10,420,1000,'[{6,2470}]',74950,11000006,'闪避<color=#4eae1aff>+2470</color>'),(6000,495,'影遁',1,10,10,420,1000,'[{6,2475}]',75100,11000006,'闪避<color=#4eae1aff>+2475</color>'),(6000,496,'影遁',1,10,10,420,1000,'[{6,2480}]',75250,11000006,'闪避<color=#4eae1aff>+2480</color>'),(6000,497,'影遁',1,10,10,420,1000,'[{6,2485}]',75400,11000006,'闪避<color=#4eae1aff>+2485</color>'),(6000,498,'影遁',1,10,10,420,1000,'[{6,2490}]',75550,11000006,'闪避<color=#4eae1aff>+2490</color>'),(6000,499,'影遁',1,10,10,420,1000,'[{6,2495}]',75700,11000006,'闪避<color=#4eae1aff>+2495</color>'),(6000,500,'影遁',1,10,10,420,1000,'[{6,2500}]',75850,11000006,'闪避<color=#4eae1aff>+2500</color>'),(7000,1,'狂怒',1,10,1,540,1000,'[{7,5}]',1000,11000007,'暴击<color=#4eae1aff>+5</color>'),(7000,2,'狂怒',1,10,1,540,1000,'[{7,10}]',1150,11000007,'暴击<color=#4eae1aff>+10</color>'),(7000,3,'狂怒',1,10,1,540,1000,'[{7,15}]',1300,11000007,'暴击<color=#4eae1aff>+15</color>'),(7000,4,'狂怒',1,10,1,540,1000,'[{7,20}]',1450,11000007,'暴击<color=#4eae1aff>+20</color>'),(7000,5,'狂怒',1,10,1,540,1000,'[{7,25}]',1600,11000007,'暴击<color=#4eae1aff>+25</color>'),(7000,6,'狂怒',1,10,1,540,1000,'[{7,30}]',1750,11000007,'暴击<color=#4eae1aff>+30</color>'),(7000,7,'狂怒',1,10,1,540,1000,'[{7,35}]',1900,11000007,'暴击<color=#4eae1aff>+35</color>'),(7000,8,'狂怒',1,10,1,540,1000,'[{7,40}]',2050,11000007,'暴击<color=#4eae1aff>+40</color>'),(7000,9,'狂怒',1,10,1,540,1000,'[{7,45}]',2200,11000007,'暴击<color=#4eae1aff>+45</color>'),(7000,10,'狂怒',1,10,1,540,1000,'[{7,50}]',2350,11000007,'暴击<color=#4eae1aff>+50</color>'),(7000,11,'狂怒',1,10,1,540,1000,'[{7,55}]',2500,11000007,'暴击<color=#4eae1aff>+55</color>'),(7000,12,'狂怒',1,10,1,540,1000,'[{7,60}]',2650,11000007,'暴击<color=#4eae1aff>+60</color>'),(7000,13,'狂怒',1,10,1,540,1000,'[{7,65}]',2800,11000007,'暴击<color=#4eae1aff>+65</color>'),(7000,14,'狂怒',1,10,1,540,1000,'[{7,70}]',2950,11000007,'暴击<color=#4eae1aff>+70</color>'),(7000,15,'狂怒',1,10,1,540,1000,'[{7,75}]',3100,11000007,'暴击<color=#4eae1aff>+75</color>'),(7000,16,'狂怒',1,10,1,540,1000,'[{7,80}]',3250,11000007,'暴击<color=#4eae1aff>+80</color>'),(7000,17,'狂怒',1,10,1,540,1000,'[{7,85}]',3400,11000007,'暴击<color=#4eae1aff>+85</color>'),(7000,18,'狂怒',1,10,1,540,1000,'[{7,90}]',3550,11000007,'暴击<color=#4eae1aff>+90</color>'),(7000,19,'狂怒',1,10,1,540,1000,'[{7,95}]',3700,11000007,'暴击<color=#4eae1aff>+95</color>'),(7000,20,'狂怒',1,10,1,540,1000,'[{7,100}]',3850,11000007,'暴击<color=#4eae1aff>+100</color>'),(7000,21,'狂怒',1,10,1,540,1000,'[{7,105}]',4000,11000007,'暴击<color=#4eae1aff>+105</color>'),(7000,22,'狂怒',1,10,1,540,1000,'[{7,110}]',4150,11000007,'暴击<color=#4eae1aff>+110</color>'),(7000,23,'狂怒',1,10,1,540,1000,'[{7,115}]',4300,11000007,'暴击<color=#4eae1aff>+115</color>'),(7000,24,'狂怒',1,10,1,540,1000,'[{7,120}]',4450,11000007,'暴击<color=#4eae1aff>+120</color>'),(7000,25,'狂怒',1,10,1,540,1000,'[{7,125}]',4600,11000007,'暴击<color=#4eae1aff>+125</color>'),(7000,26,'狂怒',1,10,1,540,1000,'[{7,130}]',4750,11000007,'暴击<color=#4eae1aff>+130</color>'),(7000,27,'狂怒',1,10,1,540,1000,'[{7,135}]',4900,11000007,'暴击<color=#4eae1aff>+135</color>'),(7000,28,'狂怒',1,10,1,540,1000,'[{7,140}]',5050,11000007,'暴击<color=#4eae1aff>+140</color>'),(7000,29,'狂怒',1,10,1,540,1000,'[{7,145}]',5200,11000007,'暴击<color=#4eae1aff>+145</color>'),(7000,30,'狂怒',1,10,1,540,1000,'[{7,150}]',5350,11000007,'暴击<color=#4eae1aff>+150</color>'),(7000,31,'狂怒',1,10,1,540,1000,'[{7,155}]',5500,11000007,'暴击<color=#4eae1aff>+155</color>'),(7000,32,'狂怒',1,10,1,540,1000,'[{7,160}]',5650,11000007,'暴击<color=#4eae1aff>+160</color>'),(7000,33,'狂怒',1,10,1,540,1000,'[{7,165}]',5800,11000007,'暴击<color=#4eae1aff>+165</color>'),(7000,34,'狂怒',1,10,1,540,1000,'[{7,170}]',5950,11000007,'暴击<color=#4eae1aff>+170</color>'),(7000,35,'狂怒',1,10,1,540,1000,'[{7,175}]',6100,11000007,'暴击<color=#4eae1aff>+175</color>'),(7000,36,'狂怒',1,10,1,540,1000,'[{7,180}]',6250,11000007,'暴击<color=#4eae1aff>+180</color>'),(7000,37,'狂怒',1,10,1,540,1000,'[{7,185}]',6400,11000007,'暴击<color=#4eae1aff>+185</color>'),(7000,38,'狂怒',1,10,1,540,1000,'[{7,190}]',6550,11000007,'暴击<color=#4eae1aff>+190</color>'),(7000,39,'狂怒',1,10,1,540,1000,'[{7,195}]',6700,11000007,'暴击<color=#4eae1aff>+195</color>'),(7000,40,'狂怒',1,10,1,540,1000,'[{7,200}]',6850,11000007,'暴击<color=#4eae1aff>+200</color>'),(7000,41,'狂怒',1,10,1,540,1000,'[{7,205}]',7000,11000007,'暴击<color=#4eae1aff>+205</color>'),(7000,42,'狂怒',1,10,1,540,1000,'[{7,210}]',7150,11000007,'暴击<color=#4eae1aff>+210</color>'),(7000,43,'狂怒',1,10,1,540,1000,'[{7,215}]',7300,11000007,'暴击<color=#4eae1aff>+215</color>'),(7000,44,'狂怒',1,10,1,540,1000,'[{7,220}]',7450,11000007,'暴击<color=#4eae1aff>+220</color>'),(7000,45,'狂怒',1,10,1,540,1000,'[{7,225}]',7600,11000007,'暴击<color=#4eae1aff>+225</color>'),(7000,46,'狂怒',1,10,1,540,1000,'[{7,230}]',7750,11000007,'暴击<color=#4eae1aff>+230</color>'),(7000,47,'狂怒',1,10,1,540,1000,'[{7,235}]',7900,11000007,'暴击<color=#4eae1aff>+235</color>'),(7000,48,'狂怒',1,10,1,540,1000,'[{7,240}]',8050,11000007,'暴击<color=#4eae1aff>+240</color>'),(7000,49,'狂怒',1,10,1,540,1000,'[{7,245}]',8200,11000007,'暴击<color=#4eae1aff>+245</color>'),(7000,50,'狂怒',1,10,1,540,1000,'[{7,250}]',8350,11000007,'暴击<color=#4eae1aff>+250</color>'),(7000,51,'狂怒',1,10,2,540,1000,'[{7,255}]',8500,11000007,'暴击<color=#4eae1aff>+255</color>'),(7000,52,'狂怒',1,10,2,540,1000,'[{7,260}]',8650,11000007,'暴击<color=#4eae1aff>+260</color>'),(7000,53,'狂怒',1,10,2,540,1000,'[{7,265}]',8800,11000007,'暴击<color=#4eae1aff>+265</color>'),(7000,54,'狂怒',1,10,2,540,1000,'[{7,270}]',8950,11000007,'暴击<color=#4eae1aff>+270</color>'),(7000,55,'狂怒',1,10,2,540,1000,'[{7,275}]',9100,11000007,'暴击<color=#4eae1aff>+275</color>'),(7000,56,'狂怒',1,10,2,540,1000,'[{7,280}]',9250,11000007,'暴击<color=#4eae1aff>+280</color>'),(7000,57,'狂怒',1,10,2,540,1000,'[{7,285}]',9400,11000007,'暴击<color=#4eae1aff>+285</color>'),(7000,58,'狂怒',1,10,2,540,1000,'[{7,290}]',9550,11000007,'暴击<color=#4eae1aff>+290</color>'),(7000,59,'狂怒',1,10,2,540,1000,'[{7,295}]',9700,11000007,'暴击<color=#4eae1aff>+295</color>'),(7000,60,'狂怒',1,10,2,540,1000,'[{7,300}]',9850,11000007,'暴击<color=#4eae1aff>+300</color>'),(7000,61,'狂怒',1,10,2,540,1000,'[{7,305}]',10000,11000007,'暴击<color=#4eae1aff>+305</color>'),(7000,62,'狂怒',1,10,2,540,1000,'[{7,310}]',10150,11000007,'暴击<color=#4eae1aff>+310</color>'),(7000,63,'狂怒',1,10,2,540,1000,'[{7,315}]',10300,11000007,'暴击<color=#4eae1aff>+315</color>'),(7000,64,'狂怒',1,10,2,540,1000,'[{7,320}]',10450,11000007,'暴击<color=#4eae1aff>+320</color>'),(7000,65,'狂怒',1,10,2,540,1000,'[{7,325}]',10600,11000007,'暴击<color=#4eae1aff>+325</color>'),(7000,66,'狂怒',1,10,2,540,1000,'[{7,330}]',10750,11000007,'暴击<color=#4eae1aff>+330</color>'),(7000,67,'狂怒',1,10,2,540,1000,'[{7,335}]',10900,11000007,'暴击<color=#4eae1aff>+335</color>'),(7000,68,'狂怒',1,10,2,540,1000,'[{7,340}]',11050,11000007,'暴击<color=#4eae1aff>+340</color>'),(7000,69,'狂怒',1,10,2,540,1000,'[{7,345}]',11200,11000007,'暴击<color=#4eae1aff>+345</color>'),(7000,70,'狂怒',1,10,2,540,1000,'[{7,350}]',11350,11000007,'暴击<color=#4eae1aff>+350</color>'),(7000,71,'狂怒',1,10,2,540,1000,'[{7,355}]',11500,11000007,'暴击<color=#4eae1aff>+355</color>'),(7000,72,'狂怒',1,10,2,540,1000,'[{7,360}]',11650,11000007,'暴击<color=#4eae1aff>+360</color>'),(7000,73,'狂怒',1,10,2,540,1000,'[{7,365}]',11800,11000007,'暴击<color=#4eae1aff>+365</color>'),(7000,74,'狂怒',1,10,2,540,1000,'[{7,370}]',11950,11000007,'暴击<color=#4eae1aff>+370</color>'),(7000,75,'狂怒',1,10,2,540,1000,'[{7,375}]',12100,11000007,'暴击<color=#4eae1aff>+375</color>'),(7000,76,'狂怒',1,10,2,540,1000,'[{7,380}]',12250,11000007,'暴击<color=#4eae1aff>+380</color>'),(7000,77,'狂怒',1,10,2,540,1000,'[{7,385}]',12400,11000007,'暴击<color=#4eae1aff>+385</color>'),(7000,78,'狂怒',1,10,2,540,1000,'[{7,390}]',12550,11000007,'暴击<color=#4eae1aff>+390</color>'),(7000,79,'狂怒',1,10,2,540,1000,'[{7,395}]',12700,11000007,'暴击<color=#4eae1aff>+395</color>'),(7000,80,'狂怒',1,10,2,540,1000,'[{7,400}]',12850,11000007,'暴击<color=#4eae1aff>+400</color>'),(7000,81,'狂怒',1,10,2,540,1000,'[{7,405}]',13000,11000007,'暴击<color=#4eae1aff>+405</color>'),(7000,82,'狂怒',1,10,2,540,1000,'[{7,410}]',13150,11000007,'暴击<color=#4eae1aff>+410</color>'),(7000,83,'狂怒',1,10,2,540,1000,'[{7,415}]',13300,11000007,'暴击<color=#4eae1aff>+415</color>'),(7000,84,'狂怒',1,10,2,540,1000,'[{7,420}]',13450,11000007,'暴击<color=#4eae1aff>+420</color>'),(7000,85,'狂怒',1,10,2,540,1000,'[{7,425}]',13600,11000007,'暴击<color=#4eae1aff>+425</color>'),(7000,86,'狂怒',1,10,2,540,1000,'[{7,430}]',13750,11000007,'暴击<color=#4eae1aff>+430</color>'),(7000,87,'狂怒',1,10,2,540,1000,'[{7,435}]',13900,11000007,'暴击<color=#4eae1aff>+435</color>'),(7000,88,'狂怒',1,10,2,540,1000,'[{7,440}]',14050,11000007,'暴击<color=#4eae1aff>+440</color>'),(7000,89,'狂怒',1,10,2,540,1000,'[{7,445}]',14200,11000007,'暴击<color=#4eae1aff>+445</color>'),(7000,90,'狂怒',1,10,2,540,1000,'[{7,450}]',14350,11000007,'暴击<color=#4eae1aff>+450</color>'),(7000,91,'狂怒',1,10,2,540,1000,'[{7,455}]',14500,11000007,'暴击<color=#4eae1aff>+455</color>'),(7000,92,'狂怒',1,10,2,540,1000,'[{7,460}]',14650,11000007,'暴击<color=#4eae1aff>+460</color>'),(7000,93,'狂怒',1,10,2,540,1000,'[{7,465}]',14800,11000007,'暴击<color=#4eae1aff>+465</color>'),(7000,94,'狂怒',1,10,2,540,1000,'[{7,470}]',14950,11000007,'暴击<color=#4eae1aff>+470</color>'),(7000,95,'狂怒',1,10,2,540,1000,'[{7,475}]',15100,11000007,'暴击<color=#4eae1aff>+475</color>'),(7000,96,'狂怒',1,10,2,540,1000,'[{7,480}]',15250,11000007,'暴击<color=#4eae1aff>+480</color>'),(7000,97,'狂怒',1,10,2,540,1000,'[{7,485}]',15400,11000007,'暴击<color=#4eae1aff>+485</color>'),(7000,98,'狂怒',1,10,2,540,1000,'[{7,490}]',15550,11000007,'暴击<color=#4eae1aff>+490</color>'),(7000,99,'狂怒',1,10,2,540,1000,'[{7,495}]',15700,11000007,'暴击<color=#4eae1aff>+495</color>'),(7000,100,'狂怒',1,10,2,540,1000,'[{7,500}]',15850,11000007,'暴击<color=#4eae1aff>+500</color>'),(7000,101,'狂怒',1,10,3,540,1000,'[{7,505}]',16000,11000007,'暴击<color=#4eae1aff>+505</color>'),(7000,102,'狂怒',1,10,3,540,1000,'[{7,510}]',16150,11000007,'暴击<color=#4eae1aff>+510</color>'),(7000,103,'狂怒',1,10,3,540,1000,'[{7,515}]',16300,11000007,'暴击<color=#4eae1aff>+515</color>'),(7000,104,'狂怒',1,10,3,540,1000,'[{7,520}]',16450,11000007,'暴击<color=#4eae1aff>+520</color>'),(7000,105,'狂怒',1,10,3,540,1000,'[{7,525}]',16600,11000007,'暴击<color=#4eae1aff>+525</color>'),(7000,106,'狂怒',1,10,3,540,1000,'[{7,530}]',16750,11000007,'暴击<color=#4eae1aff>+530</color>'),(7000,107,'狂怒',1,10,3,540,1000,'[{7,535}]',16900,11000007,'暴击<color=#4eae1aff>+535</color>'),(7000,108,'狂怒',1,10,3,540,1000,'[{7,540}]',17050,11000007,'暴击<color=#4eae1aff>+540</color>'),(7000,109,'狂怒',1,10,3,540,1000,'[{7,545}]',17200,11000007,'暴击<color=#4eae1aff>+545</color>'),(7000,110,'狂怒',1,10,3,540,1000,'[{7,550}]',17350,11000007,'暴击<color=#4eae1aff>+550</color>'),(7000,111,'狂怒',1,10,3,540,1000,'[{7,555}]',17500,11000007,'暴击<color=#4eae1aff>+555</color>'),(7000,112,'狂怒',1,10,3,540,1000,'[{7,560}]',17650,11000007,'暴击<color=#4eae1aff>+560</color>'),(7000,113,'狂怒',1,10,3,540,1000,'[{7,565}]',17800,11000007,'暴击<color=#4eae1aff>+565</color>'),(7000,114,'狂怒',1,10,3,540,1000,'[{7,570}]',17950,11000007,'暴击<color=#4eae1aff>+570</color>'),(7000,115,'狂怒',1,10,3,540,1000,'[{7,575}]',18100,11000007,'暴击<color=#4eae1aff>+575</color>'),(7000,116,'狂怒',1,10,3,540,1000,'[{7,580}]',18250,11000007,'暴击<color=#4eae1aff>+580</color>'),(7000,117,'狂怒',1,10,3,540,1000,'[{7,585}]',18400,11000007,'暴击<color=#4eae1aff>+585</color>'),(7000,118,'狂怒',1,10,3,540,1000,'[{7,590}]',18550,11000007,'暴击<color=#4eae1aff>+590</color>'),(7000,119,'狂怒',1,10,3,540,1000,'[{7,595}]',18700,11000007,'暴击<color=#4eae1aff>+595</color>'),(7000,120,'狂怒',1,10,3,540,1000,'[{7,600}]',18850,11000007,'暴击<color=#4eae1aff>+600</color>'),(7000,121,'狂怒',1,10,3,540,1000,'[{7,605}]',19000,11000007,'暴击<color=#4eae1aff>+605</color>'),(7000,122,'狂怒',1,10,3,540,1000,'[{7,610}]',19150,11000007,'暴击<color=#4eae1aff>+610</color>'),(7000,123,'狂怒',1,10,3,540,1000,'[{7,615}]',19300,11000007,'暴击<color=#4eae1aff>+615</color>'),(7000,124,'狂怒',1,10,3,540,1000,'[{7,620}]',19450,11000007,'暴击<color=#4eae1aff>+620</color>'),(7000,125,'狂怒',1,10,3,540,1000,'[{7,625}]',19600,11000007,'暴击<color=#4eae1aff>+625</color>'),(7000,126,'狂怒',1,10,3,540,1000,'[{7,630}]',19750,11000007,'暴击<color=#4eae1aff>+630</color>'),(7000,127,'狂怒',1,10,3,540,1000,'[{7,635}]',19900,11000007,'暴击<color=#4eae1aff>+635</color>'),(7000,128,'狂怒',1,10,3,540,1000,'[{7,640}]',20050,11000007,'暴击<color=#4eae1aff>+640</color>'),(7000,129,'狂怒',1,10,3,540,1000,'[{7,645}]',20200,11000007,'暴击<color=#4eae1aff>+645</color>'),(7000,130,'狂怒',1,10,3,540,1000,'[{7,650}]',20350,11000007,'暴击<color=#4eae1aff>+650</color>'),(7000,131,'狂怒',1,10,3,540,1000,'[{7,655}]',20500,11000007,'暴击<color=#4eae1aff>+655</color>'),(7000,132,'狂怒',1,10,3,540,1000,'[{7,660}]',20650,11000007,'暴击<color=#4eae1aff>+660</color>'),(7000,133,'狂怒',1,10,3,540,1000,'[{7,665}]',20800,11000007,'暴击<color=#4eae1aff>+665</color>'),(7000,134,'狂怒',1,10,3,540,1000,'[{7,670}]',20950,11000007,'暴击<color=#4eae1aff>+670</color>'),(7000,135,'狂怒',1,10,3,540,1000,'[{7,675}]',21100,11000007,'暴击<color=#4eae1aff>+675</color>'),(7000,136,'狂怒',1,10,3,540,1000,'[{7,680}]',21250,11000007,'暴击<color=#4eae1aff>+680</color>'),(7000,137,'狂怒',1,10,3,540,1000,'[{7,685}]',21400,11000007,'暴击<color=#4eae1aff>+685</color>'),(7000,138,'狂怒',1,10,3,540,1000,'[{7,690}]',21550,11000007,'暴击<color=#4eae1aff>+690</color>'),(7000,139,'狂怒',1,10,3,540,1000,'[{7,695}]',21700,11000007,'暴击<color=#4eae1aff>+695</color>'),(7000,140,'狂怒',1,10,3,540,1000,'[{7,700}]',21850,11000007,'暴击<color=#4eae1aff>+700</color>'),(7000,141,'狂怒',1,10,3,540,1000,'[{7,705}]',22000,11000007,'暴击<color=#4eae1aff>+705</color>'),(7000,142,'狂怒',1,10,3,540,1000,'[{7,710}]',22150,11000007,'暴击<color=#4eae1aff>+710</color>'),(7000,143,'狂怒',1,10,3,540,1000,'[{7,715}]',22300,11000007,'暴击<color=#4eae1aff>+715</color>'),(7000,144,'狂怒',1,10,3,540,1000,'[{7,720}]',22450,11000007,'暴击<color=#4eae1aff>+720</color>'),(7000,145,'狂怒',1,10,3,540,1000,'[{7,725}]',22600,11000007,'暴击<color=#4eae1aff>+725</color>'),(7000,146,'狂怒',1,10,3,540,1000,'[{7,730}]',22750,11000007,'暴击<color=#4eae1aff>+730</color>'),(7000,147,'狂怒',1,10,3,540,1000,'[{7,735}]',22900,11000007,'暴击<color=#4eae1aff>+735</color>'),(7000,148,'狂怒',1,10,3,540,1000,'[{7,740}]',23050,11000007,'暴击<color=#4eae1aff>+740</color>'),(7000,149,'狂怒',1,10,3,540,1000,'[{7,745}]',23200,11000007,'暴击<color=#4eae1aff>+745</color>'),(7000,150,'狂怒',1,10,3,540,1000,'[{7,750}]',23350,11000007,'暴击<color=#4eae1aff>+750</color>'),(7000,151,'狂怒',1,10,4,540,1000,'[{7,755}]',23500,11000007,'暴击<color=#4eae1aff>+755</color>'),(7000,152,'狂怒',1,10,4,540,1000,'[{7,760}]',23650,11000007,'暴击<color=#4eae1aff>+760</color>'),(7000,153,'狂怒',1,10,4,540,1000,'[{7,765}]',23800,11000007,'暴击<color=#4eae1aff>+765</color>'),(7000,154,'狂怒',1,10,4,540,1000,'[{7,770}]',23950,11000007,'暴击<color=#4eae1aff>+770</color>'),(7000,155,'狂怒',1,10,4,540,1000,'[{7,775}]',24100,11000007,'暴击<color=#4eae1aff>+775</color>'),(7000,156,'狂怒',1,10,4,540,1000,'[{7,780}]',24250,11000007,'暴击<color=#4eae1aff>+780</color>'),(7000,157,'狂怒',1,10,4,540,1000,'[{7,785}]',24400,11000007,'暴击<color=#4eae1aff>+785</color>'),(7000,158,'狂怒',1,10,4,540,1000,'[{7,790}]',24550,11000007,'暴击<color=#4eae1aff>+790</color>'),(7000,159,'狂怒',1,10,4,540,1000,'[{7,795}]',24700,11000007,'暴击<color=#4eae1aff>+795</color>'),(7000,160,'狂怒',1,10,4,540,1000,'[{7,800}]',24850,11000007,'暴击<color=#4eae1aff>+800</color>'),(7000,161,'狂怒',1,10,4,540,1000,'[{7,805}]',25000,11000007,'暴击<color=#4eae1aff>+805</color>'),(7000,162,'狂怒',1,10,4,540,1000,'[{7,810}]',25150,11000007,'暴击<color=#4eae1aff>+810</color>'),(7000,163,'狂怒',1,10,4,540,1000,'[{7,815}]',25300,11000007,'暴击<color=#4eae1aff>+815</color>'),(7000,164,'狂怒',1,10,4,540,1000,'[{7,820}]',25450,11000007,'暴击<color=#4eae1aff>+820</color>'),(7000,165,'狂怒',1,10,4,540,1000,'[{7,825}]',25600,11000007,'暴击<color=#4eae1aff>+825</color>'),(7000,166,'狂怒',1,10,4,540,1000,'[{7,830}]',25750,11000007,'暴击<color=#4eae1aff>+830</color>'),(7000,167,'狂怒',1,10,4,540,1000,'[{7,835}]',25900,11000007,'暴击<color=#4eae1aff>+835</color>'),(7000,168,'狂怒',1,10,4,540,1000,'[{7,840}]',26050,11000007,'暴击<color=#4eae1aff>+840</color>'),(7000,169,'狂怒',1,10,4,540,1000,'[{7,845}]',26200,11000007,'暴击<color=#4eae1aff>+845</color>'),(7000,170,'狂怒',1,10,4,540,1000,'[{7,850}]',26350,11000007,'暴击<color=#4eae1aff>+850</color>'),(7000,171,'狂怒',1,10,4,540,1000,'[{7,855}]',26500,11000007,'暴击<color=#4eae1aff>+855</color>'),(7000,172,'狂怒',1,10,4,540,1000,'[{7,860}]',26650,11000007,'暴击<color=#4eae1aff>+860</color>'),(7000,173,'狂怒',1,10,4,540,1000,'[{7,865}]',26800,11000007,'暴击<color=#4eae1aff>+865</color>'),(7000,174,'狂怒',1,10,4,540,1000,'[{7,870}]',26950,11000007,'暴击<color=#4eae1aff>+870</color>'),(7000,175,'狂怒',1,10,4,540,1000,'[{7,875}]',27100,11000007,'暴击<color=#4eae1aff>+875</color>'),(7000,176,'狂怒',1,10,4,540,1000,'[{7,880}]',27250,11000007,'暴击<color=#4eae1aff>+880</color>'),(7000,177,'狂怒',1,10,4,540,1000,'[{7,885}]',27400,11000007,'暴击<color=#4eae1aff>+885</color>'),(7000,178,'狂怒',1,10,4,540,1000,'[{7,890}]',27550,11000007,'暴击<color=#4eae1aff>+890</color>'),(7000,179,'狂怒',1,10,4,540,1000,'[{7,895}]',27700,11000007,'暴击<color=#4eae1aff>+895</color>'),(7000,180,'狂怒',1,10,4,540,1000,'[{7,900}]',27850,11000007,'暴击<color=#4eae1aff>+900</color>'),(7000,181,'狂怒',1,10,4,540,1000,'[{7,905}]',28000,11000007,'暴击<color=#4eae1aff>+905</color>'),(7000,182,'狂怒',1,10,4,540,1000,'[{7,910}]',28150,11000007,'暴击<color=#4eae1aff>+910</color>'),(7000,183,'狂怒',1,10,4,540,1000,'[{7,915}]',28300,11000007,'暴击<color=#4eae1aff>+915</color>'),(7000,184,'狂怒',1,10,4,540,1000,'[{7,920}]',28450,11000007,'暴击<color=#4eae1aff>+920</color>'),(7000,185,'狂怒',1,10,4,540,1000,'[{7,925}]',28600,11000007,'暴击<color=#4eae1aff>+925</color>'),(7000,186,'狂怒',1,10,4,540,1000,'[{7,930}]',28750,11000007,'暴击<color=#4eae1aff>+930</color>'),(7000,187,'狂怒',1,10,4,540,1000,'[{7,935}]',28900,11000007,'暴击<color=#4eae1aff>+935</color>'),(7000,188,'狂怒',1,10,4,540,1000,'[{7,940}]',29050,11000007,'暴击<color=#4eae1aff>+940</color>'),(7000,189,'狂怒',1,10,4,540,1000,'[{7,945}]',29200,11000007,'暴击<color=#4eae1aff>+945</color>'),(7000,190,'狂怒',1,10,4,540,1000,'[{7,950}]',29350,11000007,'暴击<color=#4eae1aff>+950</color>'),(7000,191,'狂怒',1,10,4,540,1000,'[{7,955}]',29500,11000007,'暴击<color=#4eae1aff>+955</color>'),(7000,192,'狂怒',1,10,4,540,1000,'[{7,960}]',29650,11000007,'暴击<color=#4eae1aff>+960</color>'),(7000,193,'狂怒',1,10,4,540,1000,'[{7,965}]',29800,11000007,'暴击<color=#4eae1aff>+965</color>'),(7000,194,'狂怒',1,10,4,540,1000,'[{7,970}]',29950,11000007,'暴击<color=#4eae1aff>+970</color>'),(7000,195,'狂怒',1,10,4,540,1000,'[{7,975}]',30100,11000007,'暴击<color=#4eae1aff>+975</color>'),(7000,196,'狂怒',1,10,4,540,1000,'[{7,980}]',30250,11000007,'暴击<color=#4eae1aff>+980</color>'),(7000,197,'狂怒',1,10,4,540,1000,'[{7,985}]',30400,11000007,'暴击<color=#4eae1aff>+985</color>'),(7000,198,'狂怒',1,10,4,540,1000,'[{7,990}]',30550,11000007,'暴击<color=#4eae1aff>+990</color>'),(7000,199,'狂怒',1,10,4,540,1000,'[{7,995}]',30700,11000007,'暴击<color=#4eae1aff>+995</color>'),(7000,200,'狂怒',1,10,4,540,1000,'[{7,1000}]',30850,11000007,'暴击<color=#4eae1aff>+1000</color>'),(7000,201,'狂怒',1,10,5,540,1000,'[{7,1005}]',31000,11000007,'暴击<color=#4eae1aff>+1005</color>'),(7000,202,'狂怒',1,10,5,540,1000,'[{7,1010}]',31150,11000007,'暴击<color=#4eae1aff>+1010</color>'),(7000,203,'狂怒',1,10,5,540,1000,'[{7,1015}]',31300,11000007,'暴击<color=#4eae1aff>+1015</color>'),(7000,204,'狂怒',1,10,5,540,1000,'[{7,1020}]',31450,11000007,'暴击<color=#4eae1aff>+1020</color>'),(7000,205,'狂怒',1,10,5,540,1000,'[{7,1025}]',31600,11000007,'暴击<color=#4eae1aff>+1025</color>'),(7000,206,'狂怒',1,10,5,540,1000,'[{7,1030}]',31750,11000007,'暴击<color=#4eae1aff>+1030</color>'),(7000,207,'狂怒',1,10,5,540,1000,'[{7,1035}]',31900,11000007,'暴击<color=#4eae1aff>+1035</color>'),(7000,208,'狂怒',1,10,5,540,1000,'[{7,1040}]',32050,11000007,'暴击<color=#4eae1aff>+1040</color>'),(7000,209,'狂怒',1,10,5,540,1000,'[{7,1045}]',32200,11000007,'暴击<color=#4eae1aff>+1045</color>'),(7000,210,'狂怒',1,10,5,540,1000,'[{7,1050}]',32350,11000007,'暴击<color=#4eae1aff>+1050</color>'),(7000,211,'狂怒',1,10,5,540,1000,'[{7,1055}]',32500,11000007,'暴击<color=#4eae1aff>+1055</color>'),(7000,212,'狂怒',1,10,5,540,1000,'[{7,1060}]',32650,11000007,'暴击<color=#4eae1aff>+1060</color>'),(7000,213,'狂怒',1,10,5,540,1000,'[{7,1065}]',32800,11000007,'暴击<color=#4eae1aff>+1065</color>'),(7000,214,'狂怒',1,10,5,540,1000,'[{7,1070}]',32950,11000007,'暴击<color=#4eae1aff>+1070</color>'),(7000,215,'狂怒',1,10,5,540,1000,'[{7,1075}]',33100,11000007,'暴击<color=#4eae1aff>+1075</color>'),(7000,216,'狂怒',1,10,5,540,1000,'[{7,1080}]',33250,11000007,'暴击<color=#4eae1aff>+1080</color>'),(7000,217,'狂怒',1,10,5,540,1000,'[{7,1085}]',33400,11000007,'暴击<color=#4eae1aff>+1085</color>'),(7000,218,'狂怒',1,10,5,540,1000,'[{7,1090}]',33550,11000007,'暴击<color=#4eae1aff>+1090</color>'),(7000,219,'狂怒',1,10,5,540,1000,'[{7,1095}]',33700,11000007,'暴击<color=#4eae1aff>+1095</color>'),(7000,220,'狂怒',1,10,5,540,1000,'[{7,1100}]',33850,11000007,'暴击<color=#4eae1aff>+1100</color>'),(7000,221,'狂怒',1,10,5,540,1000,'[{7,1105}]',34000,11000007,'暴击<color=#4eae1aff>+1105</color>'),(7000,222,'狂怒',1,10,5,540,1000,'[{7,1110}]',34150,11000007,'暴击<color=#4eae1aff>+1110</color>'),(7000,223,'狂怒',1,10,5,540,1000,'[{7,1115}]',34300,11000007,'暴击<color=#4eae1aff>+1115</color>'),(7000,224,'狂怒',1,10,5,540,1000,'[{7,1120}]',34450,11000007,'暴击<color=#4eae1aff>+1120</color>'),(7000,225,'狂怒',1,10,5,540,1000,'[{7,1125}]',34600,11000007,'暴击<color=#4eae1aff>+1125</color>'),(7000,226,'狂怒',1,10,5,540,1000,'[{7,1130}]',34750,11000007,'暴击<color=#4eae1aff>+1130</color>'),(7000,227,'狂怒',1,10,5,540,1000,'[{7,1135}]',34900,11000007,'暴击<color=#4eae1aff>+1135</color>'),(7000,228,'狂怒',1,10,5,540,1000,'[{7,1140}]',35050,11000007,'暴击<color=#4eae1aff>+1140</color>'),(7000,229,'狂怒',1,10,5,540,1000,'[{7,1145}]',35200,11000007,'暴击<color=#4eae1aff>+1145</color>'),(7000,230,'狂怒',1,10,5,540,1000,'[{7,1150}]',35350,11000007,'暴击<color=#4eae1aff>+1150</color>'),(7000,231,'狂怒',1,10,5,540,1000,'[{7,1155}]',35500,11000007,'暴击<color=#4eae1aff>+1155</color>'),(7000,232,'狂怒',1,10,5,540,1000,'[{7,1160}]',35650,11000007,'暴击<color=#4eae1aff>+1160</color>'),(7000,233,'狂怒',1,10,5,540,1000,'[{7,1165}]',35800,11000007,'暴击<color=#4eae1aff>+1165</color>'),(7000,234,'狂怒',1,10,5,540,1000,'[{7,1170}]',35950,11000007,'暴击<color=#4eae1aff>+1170</color>'),(7000,235,'狂怒',1,10,5,540,1000,'[{7,1175}]',36100,11000007,'暴击<color=#4eae1aff>+1175</color>'),(7000,236,'狂怒',1,10,5,540,1000,'[{7,1180}]',36250,11000007,'暴击<color=#4eae1aff>+1180</color>'),(7000,237,'狂怒',1,10,5,540,1000,'[{7,1185}]',36400,11000007,'暴击<color=#4eae1aff>+1185</color>'),(7000,238,'狂怒',1,10,5,540,1000,'[{7,1190}]',36550,11000007,'暴击<color=#4eae1aff>+1190</color>'),(7000,239,'狂怒',1,10,5,540,1000,'[{7,1195}]',36700,11000007,'暴击<color=#4eae1aff>+1195</color>'),(7000,240,'狂怒',1,10,5,540,1000,'[{7,1200}]',36850,11000007,'暴击<color=#4eae1aff>+1200</color>'),(7000,241,'狂怒',1,10,5,540,1000,'[{7,1205}]',37000,11000007,'暴击<color=#4eae1aff>+1205</color>'),(7000,242,'狂怒',1,10,5,540,1000,'[{7,1210}]',37150,11000007,'暴击<color=#4eae1aff>+1210</color>'),(7000,243,'狂怒',1,10,5,540,1000,'[{7,1215}]',37300,11000007,'暴击<color=#4eae1aff>+1215</color>'),(7000,244,'狂怒',1,10,5,540,1000,'[{7,1220}]',37450,11000007,'暴击<color=#4eae1aff>+1220</color>'),(7000,245,'狂怒',1,10,5,540,1000,'[{7,1225}]',37600,11000007,'暴击<color=#4eae1aff>+1225</color>'),(7000,246,'狂怒',1,10,5,540,1000,'[{7,1230}]',37750,11000007,'暴击<color=#4eae1aff>+1230</color>'),(7000,247,'狂怒',1,10,5,540,1000,'[{7,1235}]',37900,11000007,'暴击<color=#4eae1aff>+1235</color>'),(7000,248,'狂怒',1,10,5,540,1000,'[{7,1240}]',38050,11000007,'暴击<color=#4eae1aff>+1240</color>'),(7000,249,'狂怒',1,10,5,540,1000,'[{7,1245}]',38200,11000007,'暴击<color=#4eae1aff>+1245</color>'),(7000,250,'狂怒',1,10,5,540,1000,'[{7,1250}]',38350,11000007,'暴击<color=#4eae1aff>+1250</color>'),(7000,251,'狂怒',1,10,6,540,1000,'[{7,1255}]',38500,11000007,'暴击<color=#4eae1aff>+1255</color>'),(7000,252,'狂怒',1,10,6,540,1000,'[{7,1260}]',38650,11000007,'暴击<color=#4eae1aff>+1260</color>'),(7000,253,'狂怒',1,10,6,540,1000,'[{7,1265}]',38800,11000007,'暴击<color=#4eae1aff>+1265</color>'),(7000,254,'狂怒',1,10,6,540,1000,'[{7,1270}]',38950,11000007,'暴击<color=#4eae1aff>+1270</color>'),(7000,255,'狂怒',1,10,6,540,1000,'[{7,1275}]',39100,11000007,'暴击<color=#4eae1aff>+1275</color>'),(7000,256,'狂怒',1,10,6,540,1000,'[{7,1280}]',39250,11000007,'暴击<color=#4eae1aff>+1280</color>'),(7000,257,'狂怒',1,10,6,540,1000,'[{7,1285}]',39400,11000007,'暴击<color=#4eae1aff>+1285</color>'),(7000,258,'狂怒',1,10,6,540,1000,'[{7,1290}]',39550,11000007,'暴击<color=#4eae1aff>+1290</color>'),(7000,259,'狂怒',1,10,6,540,1000,'[{7,1295}]',39700,11000007,'暴击<color=#4eae1aff>+1295</color>'),(7000,260,'狂怒',1,10,6,540,1000,'[{7,1300}]',39850,11000007,'暴击<color=#4eae1aff>+1300</color>'),(7000,261,'狂怒',1,10,6,540,1000,'[{7,1305}]',40000,11000007,'暴击<color=#4eae1aff>+1305</color>'),(7000,262,'狂怒',1,10,6,540,1000,'[{7,1310}]',40150,11000007,'暴击<color=#4eae1aff>+1310</color>'),(7000,263,'狂怒',1,10,6,540,1000,'[{7,1315}]',40300,11000007,'暴击<color=#4eae1aff>+1315</color>'),(7000,264,'狂怒',1,10,6,540,1000,'[{7,1320}]',40450,11000007,'暴击<color=#4eae1aff>+1320</color>'),(7000,265,'狂怒',1,10,6,540,1000,'[{7,1325}]',40600,11000007,'暴击<color=#4eae1aff>+1325</color>'),(7000,266,'狂怒',1,10,6,540,1000,'[{7,1330}]',40750,11000007,'暴击<color=#4eae1aff>+1330</color>'),(7000,267,'狂怒',1,10,6,540,1000,'[{7,1335}]',40900,11000007,'暴击<color=#4eae1aff>+1335</color>'),(7000,268,'狂怒',1,10,6,540,1000,'[{7,1340}]',41050,11000007,'暴击<color=#4eae1aff>+1340</color>'),(7000,269,'狂怒',1,10,6,540,1000,'[{7,1345}]',41200,11000007,'暴击<color=#4eae1aff>+1345</color>'),(7000,270,'狂怒',1,10,6,540,1000,'[{7,1350}]',41350,11000007,'暴击<color=#4eae1aff>+1350</color>'),(7000,271,'狂怒',1,10,6,540,1000,'[{7,1355}]',41500,11000007,'暴击<color=#4eae1aff>+1355</color>'),(7000,272,'狂怒',1,10,6,540,1000,'[{7,1360}]',41650,11000007,'暴击<color=#4eae1aff>+1360</color>'),(7000,273,'狂怒',1,10,6,540,1000,'[{7,1365}]',41800,11000007,'暴击<color=#4eae1aff>+1365</color>'),(7000,274,'狂怒',1,10,6,540,1000,'[{7,1370}]',41950,11000007,'暴击<color=#4eae1aff>+1370</color>'),(7000,275,'狂怒',1,10,6,540,1000,'[{7,1375}]',42100,11000007,'暴击<color=#4eae1aff>+1375</color>'),(7000,276,'狂怒',1,10,6,540,1000,'[{7,1380}]',42250,11000007,'暴击<color=#4eae1aff>+1380</color>'),(7000,277,'狂怒',1,10,6,540,1000,'[{7,1385}]',42400,11000007,'暴击<color=#4eae1aff>+1385</color>'),(7000,278,'狂怒',1,10,6,540,1000,'[{7,1390}]',42550,11000007,'暴击<color=#4eae1aff>+1390</color>'),(7000,279,'狂怒',1,10,6,540,1000,'[{7,1395}]',42700,11000007,'暴击<color=#4eae1aff>+1395</color>'),(7000,280,'狂怒',1,10,6,540,1000,'[{7,1400}]',42850,11000007,'暴击<color=#4eae1aff>+1400</color>'),(7000,281,'狂怒',1,10,6,540,1000,'[{7,1405}]',43000,11000007,'暴击<color=#4eae1aff>+1405</color>'),(7000,282,'狂怒',1,10,6,540,1000,'[{7,1410}]',43150,11000007,'暴击<color=#4eae1aff>+1410</color>'),(7000,283,'狂怒',1,10,6,540,1000,'[{7,1415}]',43300,11000007,'暴击<color=#4eae1aff>+1415</color>'),(7000,284,'狂怒',1,10,6,540,1000,'[{7,1420}]',43450,11000007,'暴击<color=#4eae1aff>+1420</color>'),(7000,285,'狂怒',1,10,6,540,1000,'[{7,1425}]',43600,11000007,'暴击<color=#4eae1aff>+1425</color>'),(7000,286,'狂怒',1,10,6,540,1000,'[{7,1430}]',43750,11000007,'暴击<color=#4eae1aff>+1430</color>'),(7000,287,'狂怒',1,10,6,540,1000,'[{7,1435}]',43900,11000007,'暴击<color=#4eae1aff>+1435</color>'),(7000,288,'狂怒',1,10,6,540,1000,'[{7,1440}]',44050,11000007,'暴击<color=#4eae1aff>+1440</color>'),(7000,289,'狂怒',1,10,6,540,1000,'[{7,1445}]',44200,11000007,'暴击<color=#4eae1aff>+1445</color>'),(7000,290,'狂怒',1,10,6,540,1000,'[{7,1450}]',44350,11000007,'暴击<color=#4eae1aff>+1450</color>'),(7000,291,'狂怒',1,10,6,540,1000,'[{7,1455}]',44500,11000007,'暴击<color=#4eae1aff>+1455</color>'),(7000,292,'狂怒',1,10,6,540,1000,'[{7,1460}]',44650,11000007,'暴击<color=#4eae1aff>+1460</color>'),(7000,293,'狂怒',1,10,6,540,1000,'[{7,1465}]',44800,11000007,'暴击<color=#4eae1aff>+1465</color>'),(7000,294,'狂怒',1,10,6,540,1000,'[{7,1470}]',44950,11000007,'暴击<color=#4eae1aff>+1470</color>'),(7000,295,'狂怒',1,10,6,540,1000,'[{7,1475}]',45100,11000007,'暴击<color=#4eae1aff>+1475</color>'),(7000,296,'狂怒',1,10,6,540,1000,'[{7,1480}]',45250,11000007,'暴击<color=#4eae1aff>+1480</color>'),(7000,297,'狂怒',1,10,6,540,1000,'[{7,1485}]',45400,11000007,'暴击<color=#4eae1aff>+1485</color>'),(7000,298,'狂怒',1,10,6,540,1000,'[{7,1490}]',45550,11000007,'暴击<color=#4eae1aff>+1490</color>'),(7000,299,'狂怒',1,10,6,540,1000,'[{7,1495}]',45700,11000007,'暴击<color=#4eae1aff>+1495</color>'),(7000,300,'狂怒',1,10,6,540,1000,'[{7,1500}]',45850,11000007,'暴击<color=#4eae1aff>+1500</color>'),(7000,301,'狂怒',1,10,7,540,1000,'[{7,1505}]',46000,11000007,'暴击<color=#4eae1aff>+1505</color>'),(7000,302,'狂怒',1,10,7,540,1000,'[{7,1510}]',46150,11000007,'暴击<color=#4eae1aff>+1510</color>'),(7000,303,'狂怒',1,10,7,540,1000,'[{7,1515}]',46300,11000007,'暴击<color=#4eae1aff>+1515</color>'),(7000,304,'狂怒',1,10,7,540,1000,'[{7,1520}]',46450,11000007,'暴击<color=#4eae1aff>+1520</color>'),(7000,305,'狂怒',1,10,7,540,1000,'[{7,1525}]',46600,11000007,'暴击<color=#4eae1aff>+1525</color>'),(7000,306,'狂怒',1,10,7,540,1000,'[{7,1530}]',46750,11000007,'暴击<color=#4eae1aff>+1530</color>'),(7000,307,'狂怒',1,10,7,540,1000,'[{7,1535}]',46900,11000007,'暴击<color=#4eae1aff>+1535</color>'),(7000,308,'狂怒',1,10,7,540,1000,'[{7,1540}]',47050,11000007,'暴击<color=#4eae1aff>+1540</color>'),(7000,309,'狂怒',1,10,7,540,1000,'[{7,1545}]',47200,11000007,'暴击<color=#4eae1aff>+1545</color>'),(7000,310,'狂怒',1,10,7,540,1000,'[{7,1550}]',47350,11000007,'暴击<color=#4eae1aff>+1550</color>'),(7000,311,'狂怒',1,10,7,540,1000,'[{7,1555}]',47500,11000007,'暴击<color=#4eae1aff>+1555</color>'),(7000,312,'狂怒',1,10,7,540,1000,'[{7,1560}]',47650,11000007,'暴击<color=#4eae1aff>+1560</color>'),(7000,313,'狂怒',1,10,7,540,1000,'[{7,1565}]',47800,11000007,'暴击<color=#4eae1aff>+1565</color>'),(7000,314,'狂怒',1,10,7,540,1000,'[{7,1570}]',47950,11000007,'暴击<color=#4eae1aff>+1570</color>'),(7000,315,'狂怒',1,10,7,540,1000,'[{7,1575}]',48100,11000007,'暴击<color=#4eae1aff>+1575</color>'),(7000,316,'狂怒',1,10,7,540,1000,'[{7,1580}]',48250,11000007,'暴击<color=#4eae1aff>+1580</color>'),(7000,317,'狂怒',1,10,7,540,1000,'[{7,1585}]',48400,11000007,'暴击<color=#4eae1aff>+1585</color>'),(7000,318,'狂怒',1,10,7,540,1000,'[{7,1590}]',48550,11000007,'暴击<color=#4eae1aff>+1590</color>'),(7000,319,'狂怒',1,10,7,540,1000,'[{7,1595}]',48700,11000007,'暴击<color=#4eae1aff>+1595</color>'),(7000,320,'狂怒',1,10,7,540,1000,'[{7,1600}]',48850,11000007,'暴击<color=#4eae1aff>+1600</color>'),(7000,321,'狂怒',1,10,7,540,1000,'[{7,1605}]',49000,11000007,'暴击<color=#4eae1aff>+1605</color>'),(7000,322,'狂怒',1,10,7,540,1000,'[{7,1610}]',49150,11000007,'暴击<color=#4eae1aff>+1610</color>'),(7000,323,'狂怒',1,10,7,540,1000,'[{7,1615}]',49300,11000007,'暴击<color=#4eae1aff>+1615</color>'),(7000,324,'狂怒',1,10,7,540,1000,'[{7,1620}]',49450,11000007,'暴击<color=#4eae1aff>+1620</color>'),(7000,325,'狂怒',1,10,7,540,1000,'[{7,1625}]',49600,11000007,'暴击<color=#4eae1aff>+1625</color>'),(7000,326,'狂怒',1,10,7,540,1000,'[{7,1630}]',49750,11000007,'暴击<color=#4eae1aff>+1630</color>'),(7000,327,'狂怒',1,10,7,540,1000,'[{7,1635}]',49900,11000007,'暴击<color=#4eae1aff>+1635</color>'),(7000,328,'狂怒',1,10,7,540,1000,'[{7,1640}]',50050,11000007,'暴击<color=#4eae1aff>+1640</color>'),(7000,329,'狂怒',1,10,7,540,1000,'[{7,1645}]',50200,11000007,'暴击<color=#4eae1aff>+1645</color>'),(7000,330,'狂怒',1,10,7,540,1000,'[{7,1650}]',50350,11000007,'暴击<color=#4eae1aff>+1650</color>'),(7000,331,'狂怒',1,10,7,540,1000,'[{7,1655}]',50500,11000007,'暴击<color=#4eae1aff>+1655</color>'),(7000,332,'狂怒',1,10,7,540,1000,'[{7,1660}]',50650,11000007,'暴击<color=#4eae1aff>+1660</color>'),(7000,333,'狂怒',1,10,7,540,1000,'[{7,1665}]',50800,11000007,'暴击<color=#4eae1aff>+1665</color>'),(7000,334,'狂怒',1,10,7,540,1000,'[{7,1670}]',50950,11000007,'暴击<color=#4eae1aff>+1670</color>'),(7000,335,'狂怒',1,10,7,540,1000,'[{7,1675}]',51100,11000007,'暴击<color=#4eae1aff>+1675</color>'),(7000,336,'狂怒',1,10,7,540,1000,'[{7,1680}]',51250,11000007,'暴击<color=#4eae1aff>+1680</color>'),(7000,337,'狂怒',1,10,7,540,1000,'[{7,1685}]',51400,11000007,'暴击<color=#4eae1aff>+1685</color>'),(7000,338,'狂怒',1,10,7,540,1000,'[{7,1690}]',51550,11000007,'暴击<color=#4eae1aff>+1690</color>'),(7000,339,'狂怒',1,10,7,540,1000,'[{7,1695}]',51700,11000007,'暴击<color=#4eae1aff>+1695</color>'),(7000,340,'狂怒',1,10,7,540,1000,'[{7,1700}]',51850,11000007,'暴击<color=#4eae1aff>+1700</color>'),(7000,341,'狂怒',1,10,7,540,1000,'[{7,1705}]',52000,11000007,'暴击<color=#4eae1aff>+1705</color>'),(7000,342,'狂怒',1,10,7,540,1000,'[{7,1710}]',52150,11000007,'暴击<color=#4eae1aff>+1710</color>'),(7000,343,'狂怒',1,10,7,540,1000,'[{7,1715}]',52300,11000007,'暴击<color=#4eae1aff>+1715</color>'),(7000,344,'狂怒',1,10,7,540,1000,'[{7,1720}]',52450,11000007,'暴击<color=#4eae1aff>+1720</color>'),(7000,345,'狂怒',1,10,7,540,1000,'[{7,1725}]',52600,11000007,'暴击<color=#4eae1aff>+1725</color>'),(7000,346,'狂怒',1,10,7,540,1000,'[{7,1730}]',52750,11000007,'暴击<color=#4eae1aff>+1730</color>'),(7000,347,'狂怒',1,10,7,540,1000,'[{7,1735}]',52900,11000007,'暴击<color=#4eae1aff>+1735</color>'),(7000,348,'狂怒',1,10,7,540,1000,'[{7,1740}]',53050,11000007,'暴击<color=#4eae1aff>+1740</color>'),(7000,349,'狂怒',1,10,7,540,1000,'[{7,1745}]',53200,11000007,'暴击<color=#4eae1aff>+1745</color>'),(7000,350,'狂怒',1,10,7,540,1000,'[{7,1750}]',53350,11000007,'暴击<color=#4eae1aff>+1750</color>'),(7000,351,'狂怒',1,10,8,540,1000,'[{7,1755}]',53500,11000007,'暴击<color=#4eae1aff>+1755</color>'),(7000,352,'狂怒',1,10,8,540,1000,'[{7,1760}]',53650,11000007,'暴击<color=#4eae1aff>+1760</color>'),(7000,353,'狂怒',1,10,8,540,1000,'[{7,1765}]',53800,11000007,'暴击<color=#4eae1aff>+1765</color>'),(7000,354,'狂怒',1,10,8,540,1000,'[{7,1770}]',53950,11000007,'暴击<color=#4eae1aff>+1770</color>'),(7000,355,'狂怒',1,10,8,540,1000,'[{7,1775}]',54100,11000007,'暴击<color=#4eae1aff>+1775</color>'),(7000,356,'狂怒',1,10,8,540,1000,'[{7,1780}]',54250,11000007,'暴击<color=#4eae1aff>+1780</color>'),(7000,357,'狂怒',1,10,8,540,1000,'[{7,1785}]',54400,11000007,'暴击<color=#4eae1aff>+1785</color>'),(7000,358,'狂怒',1,10,8,540,1000,'[{7,1790}]',54550,11000007,'暴击<color=#4eae1aff>+1790</color>'),(7000,359,'狂怒',1,10,8,540,1000,'[{7,1795}]',54700,11000007,'暴击<color=#4eae1aff>+1795</color>'),(7000,360,'狂怒',1,10,8,540,1000,'[{7,1800}]',54850,11000007,'暴击<color=#4eae1aff>+1800</color>'),(7000,361,'狂怒',1,10,8,540,1000,'[{7,1805}]',55000,11000007,'暴击<color=#4eae1aff>+1805</color>'),(7000,362,'狂怒',1,10,8,540,1000,'[{7,1810}]',55150,11000007,'暴击<color=#4eae1aff>+1810</color>'),(7000,363,'狂怒',1,10,8,540,1000,'[{7,1815}]',55300,11000007,'暴击<color=#4eae1aff>+1815</color>'),(7000,364,'狂怒',1,10,8,540,1000,'[{7,1820}]',55450,11000007,'暴击<color=#4eae1aff>+1820</color>'),(7000,365,'狂怒',1,10,8,540,1000,'[{7,1825}]',55600,11000007,'暴击<color=#4eae1aff>+1825</color>'),(7000,366,'狂怒',1,10,8,540,1000,'[{7,1830}]',55750,11000007,'暴击<color=#4eae1aff>+1830</color>'),(7000,367,'狂怒',1,10,8,540,1000,'[{7,1835}]',55900,11000007,'暴击<color=#4eae1aff>+1835</color>'),(7000,368,'狂怒',1,10,8,540,1000,'[{7,1840}]',56050,11000007,'暴击<color=#4eae1aff>+1840</color>'),(7000,369,'狂怒',1,10,8,540,1000,'[{7,1845}]',56200,11000007,'暴击<color=#4eae1aff>+1845</color>'),(7000,370,'狂怒',1,10,8,540,1000,'[{7,1850}]',56350,11000007,'暴击<color=#4eae1aff>+1850</color>'),(7000,371,'狂怒',1,10,8,540,1000,'[{7,1855}]',56500,11000007,'暴击<color=#4eae1aff>+1855</color>'),(7000,372,'狂怒',1,10,8,540,1000,'[{7,1860}]',56650,11000007,'暴击<color=#4eae1aff>+1860</color>'),(7000,373,'狂怒',1,10,8,540,1000,'[{7,1865}]',56800,11000007,'暴击<color=#4eae1aff>+1865</color>'),(7000,374,'狂怒',1,10,8,540,1000,'[{7,1870}]',56950,11000007,'暴击<color=#4eae1aff>+1870</color>'),(7000,375,'狂怒',1,10,8,540,1000,'[{7,1875}]',57100,11000007,'暴击<color=#4eae1aff>+1875</color>'),(7000,376,'狂怒',1,10,8,540,1000,'[{7,1880}]',57250,11000007,'暴击<color=#4eae1aff>+1880</color>'),(7000,377,'狂怒',1,10,8,540,1000,'[{7,1885}]',57400,11000007,'暴击<color=#4eae1aff>+1885</color>'),(7000,378,'狂怒',1,10,8,540,1000,'[{7,1890}]',57550,11000007,'暴击<color=#4eae1aff>+1890</color>'),(7000,379,'狂怒',1,10,8,540,1000,'[{7,1895}]',57700,11000007,'暴击<color=#4eae1aff>+1895</color>'),(7000,380,'狂怒',1,10,8,540,1000,'[{7,1900}]',57850,11000007,'暴击<color=#4eae1aff>+1900</color>'),(7000,381,'狂怒',1,10,8,540,1000,'[{7,1905}]',58000,11000007,'暴击<color=#4eae1aff>+1905</color>'),(7000,382,'狂怒',1,10,8,540,1000,'[{7,1910}]',58150,11000007,'暴击<color=#4eae1aff>+1910</color>'),(7000,383,'狂怒',1,10,8,540,1000,'[{7,1915}]',58300,11000007,'暴击<color=#4eae1aff>+1915</color>'),(7000,384,'狂怒',1,10,8,540,1000,'[{7,1920}]',58450,11000007,'暴击<color=#4eae1aff>+1920</color>'),(7000,385,'狂怒',1,10,8,540,1000,'[{7,1925}]',58600,11000007,'暴击<color=#4eae1aff>+1925</color>'),(7000,386,'狂怒',1,10,8,540,1000,'[{7,1930}]',58750,11000007,'暴击<color=#4eae1aff>+1930</color>'),(7000,387,'狂怒',1,10,8,540,1000,'[{7,1935}]',58900,11000007,'暴击<color=#4eae1aff>+1935</color>'),(7000,388,'狂怒',1,10,8,540,1000,'[{7,1940}]',59050,11000007,'暴击<color=#4eae1aff>+1940</color>'),(7000,389,'狂怒',1,10,8,540,1000,'[{7,1945}]',59200,11000007,'暴击<color=#4eae1aff>+1945</color>'),(7000,390,'狂怒',1,10,8,540,1000,'[{7,1950}]',59350,11000007,'暴击<color=#4eae1aff>+1950</color>'),(7000,391,'狂怒',1,10,8,540,1000,'[{7,1955}]',59500,11000007,'暴击<color=#4eae1aff>+1955</color>'),(7000,392,'狂怒',1,10,8,540,1000,'[{7,1960}]',59650,11000007,'暴击<color=#4eae1aff>+1960</color>'),(7000,393,'狂怒',1,10,8,540,1000,'[{7,1965}]',59800,11000007,'暴击<color=#4eae1aff>+1965</color>'),(7000,394,'狂怒',1,10,8,540,1000,'[{7,1970}]',59950,11000007,'暴击<color=#4eae1aff>+1970</color>'),(7000,395,'狂怒',1,10,8,540,1000,'[{7,1975}]',60100,11000007,'暴击<color=#4eae1aff>+1975</color>'),(7000,396,'狂怒',1,10,8,540,1000,'[{7,1980}]',60250,11000007,'暴击<color=#4eae1aff>+1980</color>'),(7000,397,'狂怒',1,10,8,540,1000,'[{7,1985}]',60400,11000007,'暴击<color=#4eae1aff>+1985</color>'),(7000,398,'狂怒',1,10,8,540,1000,'[{7,1990}]',60550,11000007,'暴击<color=#4eae1aff>+1990</color>'),(7000,399,'狂怒',1,10,8,540,1000,'[{7,1995}]',60700,11000007,'暴击<color=#4eae1aff>+1995</color>'),(7000,400,'狂怒',1,10,8,540,1000,'[{7,2000}]',60850,11000007,'暴击<color=#4eae1aff>+2000</color>'),(7000,401,'狂怒',1,10,9,540,1000,'[{7,2005}]',61000,11000007,'暴击<color=#4eae1aff>+2005</color>'),(7000,402,'狂怒',1,10,9,540,1000,'[{7,2010}]',61150,11000007,'暴击<color=#4eae1aff>+2010</color>'),(7000,403,'狂怒',1,10,9,540,1000,'[{7,2015}]',61300,11000007,'暴击<color=#4eae1aff>+2015</color>'),(7000,404,'狂怒',1,10,9,540,1000,'[{7,2020}]',61450,11000007,'暴击<color=#4eae1aff>+2020</color>'),(7000,405,'狂怒',1,10,9,540,1000,'[{7,2025}]',61600,11000007,'暴击<color=#4eae1aff>+2025</color>'),(7000,406,'狂怒',1,10,9,540,1000,'[{7,2030}]',61750,11000007,'暴击<color=#4eae1aff>+2030</color>'),(7000,407,'狂怒',1,10,9,540,1000,'[{7,2035}]',61900,11000007,'暴击<color=#4eae1aff>+2035</color>'),(7000,408,'狂怒',1,10,9,540,1000,'[{7,2040}]',62050,11000007,'暴击<color=#4eae1aff>+2040</color>'),(7000,409,'狂怒',1,10,9,540,1000,'[{7,2045}]',62200,11000007,'暴击<color=#4eae1aff>+2045</color>'),(7000,410,'狂怒',1,10,9,540,1000,'[{7,2050}]',62350,11000007,'暴击<color=#4eae1aff>+2050</color>'),(7000,411,'狂怒',1,10,9,540,1000,'[{7,2055}]',62500,11000007,'暴击<color=#4eae1aff>+2055</color>'),(7000,412,'狂怒',1,10,9,540,1000,'[{7,2060}]',62650,11000007,'暴击<color=#4eae1aff>+2060</color>'),(7000,413,'狂怒',1,10,9,540,1000,'[{7,2065}]',62800,11000007,'暴击<color=#4eae1aff>+2065</color>'),(7000,414,'狂怒',1,10,9,540,1000,'[{7,2070}]',62950,11000007,'暴击<color=#4eae1aff>+2070</color>'),(7000,415,'狂怒',1,10,9,540,1000,'[{7,2075}]',63100,11000007,'暴击<color=#4eae1aff>+2075</color>'),(7000,416,'狂怒',1,10,9,540,1000,'[{7,2080}]',63250,11000007,'暴击<color=#4eae1aff>+2080</color>'),(7000,417,'狂怒',1,10,9,540,1000,'[{7,2085}]',63400,11000007,'暴击<color=#4eae1aff>+2085</color>'),(7000,418,'狂怒',1,10,9,540,1000,'[{7,2090}]',63550,11000007,'暴击<color=#4eae1aff>+2090</color>'),(7000,419,'狂怒',1,10,9,540,1000,'[{7,2095}]',63700,11000007,'暴击<color=#4eae1aff>+2095</color>'),(7000,420,'狂怒',1,10,9,540,1000,'[{7,2100}]',63850,11000007,'暴击<color=#4eae1aff>+2100</color>'),(7000,421,'狂怒',1,10,9,540,1000,'[{7,2105}]',64000,11000007,'暴击<color=#4eae1aff>+2105</color>'),(7000,422,'狂怒',1,10,9,540,1000,'[{7,2110}]',64150,11000007,'暴击<color=#4eae1aff>+2110</color>'),(7000,423,'狂怒',1,10,9,540,1000,'[{7,2115}]',64300,11000007,'暴击<color=#4eae1aff>+2115</color>'),(7000,424,'狂怒',1,10,9,540,1000,'[{7,2120}]',64450,11000007,'暴击<color=#4eae1aff>+2120</color>'),(7000,425,'狂怒',1,10,9,540,1000,'[{7,2125}]',64600,11000007,'暴击<color=#4eae1aff>+2125</color>'),(7000,426,'狂怒',1,10,9,540,1000,'[{7,2130}]',64750,11000007,'暴击<color=#4eae1aff>+2130</color>'),(7000,427,'狂怒',1,10,9,540,1000,'[{7,2135}]',64900,11000007,'暴击<color=#4eae1aff>+2135</color>'),(7000,428,'狂怒',1,10,9,540,1000,'[{7,2140}]',65050,11000007,'暴击<color=#4eae1aff>+2140</color>'),(7000,429,'狂怒',1,10,9,540,1000,'[{7,2145}]',65200,11000007,'暴击<color=#4eae1aff>+2145</color>'),(7000,430,'狂怒',1,10,9,540,1000,'[{7,2150}]',65350,11000007,'暴击<color=#4eae1aff>+2150</color>'),(7000,431,'狂怒',1,10,9,540,1000,'[{7,2155}]',65500,11000007,'暴击<color=#4eae1aff>+2155</color>'),(7000,432,'狂怒',1,10,9,540,1000,'[{7,2160}]',65650,11000007,'暴击<color=#4eae1aff>+2160</color>'),(7000,433,'狂怒',1,10,9,540,1000,'[{7,2165}]',65800,11000007,'暴击<color=#4eae1aff>+2165</color>'),(7000,434,'狂怒',1,10,9,540,1000,'[{7,2170}]',65950,11000007,'暴击<color=#4eae1aff>+2170</color>'),(7000,435,'狂怒',1,10,9,540,1000,'[{7,2175}]',66100,11000007,'暴击<color=#4eae1aff>+2175</color>'),(7000,436,'狂怒',1,10,9,540,1000,'[{7,2180}]',66250,11000007,'暴击<color=#4eae1aff>+2180</color>'),(7000,437,'狂怒',1,10,9,540,1000,'[{7,2185}]',66400,11000007,'暴击<color=#4eae1aff>+2185</color>'),(7000,438,'狂怒',1,10,9,540,1000,'[{7,2190}]',66550,11000007,'暴击<color=#4eae1aff>+2190</color>'),(7000,439,'狂怒',1,10,9,540,1000,'[{7,2195}]',66700,11000007,'暴击<color=#4eae1aff>+2195</color>'),(7000,440,'狂怒',1,10,9,540,1000,'[{7,2200}]',66850,11000007,'暴击<color=#4eae1aff>+2200</color>'),(7000,441,'狂怒',1,10,9,540,1000,'[{7,2205}]',67000,11000007,'暴击<color=#4eae1aff>+2205</color>'),(7000,442,'狂怒',1,10,9,540,1000,'[{7,2210}]',67150,11000007,'暴击<color=#4eae1aff>+2210</color>'),(7000,443,'狂怒',1,10,9,540,1000,'[{7,2215}]',67300,11000007,'暴击<color=#4eae1aff>+2215</color>'),(7000,444,'狂怒',1,10,9,540,1000,'[{7,2220}]',67450,11000007,'暴击<color=#4eae1aff>+2220</color>'),(7000,445,'狂怒',1,10,9,540,1000,'[{7,2225}]',67600,11000007,'暴击<color=#4eae1aff>+2225</color>'),(7000,446,'狂怒',1,10,9,540,1000,'[{7,2230}]',67750,11000007,'暴击<color=#4eae1aff>+2230</color>'),(7000,447,'狂怒',1,10,9,540,1000,'[{7,2235}]',67900,11000007,'暴击<color=#4eae1aff>+2235</color>'),(7000,448,'狂怒',1,10,9,540,1000,'[{7,2240}]',68050,11000007,'暴击<color=#4eae1aff>+2240</color>'),(7000,449,'狂怒',1,10,9,540,1000,'[{7,2245}]',68200,11000007,'暴击<color=#4eae1aff>+2245</color>'),(7000,450,'狂怒',1,10,9,540,1000,'[{7,2250}]',68350,11000007,'暴击<color=#4eae1aff>+2250</color>'),(7000,451,'狂怒',1,10,10,540,1000,'[{7,2255}]',68500,11000007,'暴击<color=#4eae1aff>+2255</color>'),(7000,452,'狂怒',1,10,10,540,1000,'[{7,2260}]',68650,11000007,'暴击<color=#4eae1aff>+2260</color>'),(7000,453,'狂怒',1,10,10,540,1000,'[{7,2265}]',68800,11000007,'暴击<color=#4eae1aff>+2265</color>'),(7000,454,'狂怒',1,10,10,540,1000,'[{7,2270}]',68950,11000007,'暴击<color=#4eae1aff>+2270</color>'),(7000,455,'狂怒',1,10,10,540,1000,'[{7,2275}]',69100,11000007,'暴击<color=#4eae1aff>+2275</color>'),(7000,456,'狂怒',1,10,10,540,1000,'[{7,2280}]',69250,11000007,'暴击<color=#4eae1aff>+2280</color>'),(7000,457,'狂怒',1,10,10,540,1000,'[{7,2285}]',69400,11000007,'暴击<color=#4eae1aff>+2285</color>'),(7000,458,'狂怒',1,10,10,540,1000,'[{7,2290}]',69550,11000007,'暴击<color=#4eae1aff>+2290</color>'),(7000,459,'狂怒',1,10,10,540,1000,'[{7,2295}]',69700,11000007,'暴击<color=#4eae1aff>+2295</color>'),(7000,460,'狂怒',1,10,10,540,1000,'[{7,2300}]',69850,11000007,'暴击<color=#4eae1aff>+2300</color>'),(7000,461,'狂怒',1,10,10,540,1000,'[{7,2305}]',70000,11000007,'暴击<color=#4eae1aff>+2305</color>'),(7000,462,'狂怒',1,10,10,540,1000,'[{7,2310}]',70150,11000007,'暴击<color=#4eae1aff>+2310</color>'),(7000,463,'狂怒',1,10,10,540,1000,'[{7,2315}]',70300,11000007,'暴击<color=#4eae1aff>+2315</color>'),(7000,464,'狂怒',1,10,10,540,1000,'[{7,2320}]',70450,11000007,'暴击<color=#4eae1aff>+2320</color>'),(7000,465,'狂怒',1,10,10,540,1000,'[{7,2325}]',70600,11000007,'暴击<color=#4eae1aff>+2325</color>'),(7000,466,'狂怒',1,10,10,540,1000,'[{7,2330}]',70750,11000007,'暴击<color=#4eae1aff>+2330</color>'),(7000,467,'狂怒',1,10,10,540,1000,'[{7,2335}]',70900,11000007,'暴击<color=#4eae1aff>+2335</color>'),(7000,468,'狂怒',1,10,10,540,1000,'[{7,2340}]',71050,11000007,'暴击<color=#4eae1aff>+2340</color>'),(7000,469,'狂怒',1,10,10,540,1000,'[{7,2345}]',71200,11000007,'暴击<color=#4eae1aff>+2345</color>'),(7000,470,'狂怒',1,10,10,540,1000,'[{7,2350}]',71350,11000007,'暴击<color=#4eae1aff>+2350</color>'),(7000,471,'狂怒',1,10,10,540,1000,'[{7,2355}]',71500,11000007,'暴击<color=#4eae1aff>+2355</color>'),(7000,472,'狂怒',1,10,10,540,1000,'[{7,2360}]',71650,11000007,'暴击<color=#4eae1aff>+2360</color>'),(7000,473,'狂怒',1,10,10,540,1000,'[{7,2365}]',71800,11000007,'暴击<color=#4eae1aff>+2365</color>'),(7000,474,'狂怒',1,10,10,540,1000,'[{7,2370}]',71950,11000007,'暴击<color=#4eae1aff>+2370</color>'),(7000,475,'狂怒',1,10,10,540,1000,'[{7,2375}]',72100,11000007,'暴击<color=#4eae1aff>+2375</color>'),(7000,476,'狂怒',1,10,10,540,1000,'[{7,2380}]',72250,11000007,'暴击<color=#4eae1aff>+2380</color>'),(7000,477,'狂怒',1,10,10,540,1000,'[{7,2385}]',72400,11000007,'暴击<color=#4eae1aff>+2385</color>'),(7000,478,'狂怒',1,10,10,540,1000,'[{7,2390}]',72550,11000007,'暴击<color=#4eae1aff>+2390</color>'),(7000,479,'狂怒',1,10,10,540,1000,'[{7,2395}]',72700,11000007,'暴击<color=#4eae1aff>+2395</color>'),(7000,480,'狂怒',1,10,10,540,1000,'[{7,2400}]',72850,11000007,'暴击<color=#4eae1aff>+2400</color>'),(7000,481,'狂怒',1,10,10,540,1000,'[{7,2405}]',73000,11000007,'暴击<color=#4eae1aff>+2405</color>'),(7000,482,'狂怒',1,10,10,540,1000,'[{7,2410}]',73150,11000007,'暴击<color=#4eae1aff>+2410</color>'),(7000,483,'狂怒',1,10,10,540,1000,'[{7,2415}]',73300,11000007,'暴击<color=#4eae1aff>+2415</color>'),(7000,484,'狂怒',1,10,10,540,1000,'[{7,2420}]',73450,11000007,'暴击<color=#4eae1aff>+2420</color>'),(7000,485,'狂怒',1,10,10,540,1000,'[{7,2425}]',73600,11000007,'暴击<color=#4eae1aff>+2425</color>'),(7000,486,'狂怒',1,10,10,540,1000,'[{7,2430}]',73750,11000007,'暴击<color=#4eae1aff>+2430</color>'),(7000,487,'狂怒',1,10,10,540,1000,'[{7,2435}]',73900,11000007,'暴击<color=#4eae1aff>+2435</color>'),(7000,488,'狂怒',1,10,10,540,1000,'[{7,2440}]',74050,11000007,'暴击<color=#4eae1aff>+2440</color>'),(7000,489,'狂怒',1,10,10,540,1000,'[{7,2445}]',74200,11000007,'暴击<color=#4eae1aff>+2445</color>'),(7000,490,'狂怒',1,10,10,540,1000,'[{7,2450}]',74350,11000007,'暴击<color=#4eae1aff>+2450</color>'),(7000,491,'狂怒',1,10,10,540,1000,'[{7,2455}]',74500,11000007,'暴击<color=#4eae1aff>+2455</color>'),(7000,492,'狂怒',1,10,10,540,1000,'[{7,2460}]',74650,11000007,'暴击<color=#4eae1aff>+2460</color>'),(7000,493,'狂怒',1,10,10,540,1000,'[{7,2465}]',74800,11000007,'暴击<color=#4eae1aff>+2465</color>'),(7000,494,'狂怒',1,10,10,540,1000,'[{7,2470}]',74950,11000007,'暴击<color=#4eae1aff>+2470</color>'),(7000,495,'狂怒',1,10,10,540,1000,'[{7,2475}]',75100,11000007,'暴击<color=#4eae1aff>+2475</color>'),(7000,496,'狂怒',1,10,10,540,1000,'[{7,2480}]',75250,11000007,'暴击<color=#4eae1aff>+2480</color>'),(7000,497,'狂怒',1,10,10,540,1000,'[{7,2485}]',75400,11000007,'暴击<color=#4eae1aff>+2485</color>'),(7000,498,'狂怒',1,10,10,540,1000,'[{7,2490}]',75550,11000007,'暴击<color=#4eae1aff>+2490</color>'),(7000,499,'狂怒',1,10,10,540,1000,'[{7,2495}]',75700,11000007,'暴击<color=#4eae1aff>+2495</color>'),(7000,500,'狂怒',1,10,10,540,1000,'[{7,2500}]',75850,11000007,'暴击<color=#4eae1aff>+2500</color>'),(8000,1,'不屈',1,10,1,540,1000,'[{8,5}]',1000,11000008,'韧性<color=#4eae1aff>+5</color>'),(8000,2,'不屈',1,10,1,540,1000,'[{8,10}]',1150,11000008,'韧性<color=#4eae1aff>+10</color>'),(8000,3,'不屈',1,10,1,540,1000,'[{8,15}]',1300,11000008,'韧性<color=#4eae1aff>+15</color>'),(8000,4,'不屈',1,10,1,540,1000,'[{8,20}]',1450,11000008,'韧性<color=#4eae1aff>+20</color>'),(8000,5,'不屈',1,10,1,540,1000,'[{8,25}]',1600,11000008,'韧性<color=#4eae1aff>+25</color>'),(8000,6,'不屈',1,10,1,540,1000,'[{8,30}]',1750,11000008,'韧性<color=#4eae1aff>+30</color>'),(8000,7,'不屈',1,10,1,540,1000,'[{8,35}]',1900,11000008,'韧性<color=#4eae1aff>+35</color>'),(8000,8,'不屈',1,10,1,540,1000,'[{8,40}]',2050,11000008,'韧性<color=#4eae1aff>+40</color>'),(8000,9,'不屈',1,10,1,540,1000,'[{8,45}]',2200,11000008,'韧性<color=#4eae1aff>+45</color>'),(8000,10,'不屈',1,10,1,540,1000,'[{8,50}]',2350,11000008,'韧性<color=#4eae1aff>+50</color>'),(8000,11,'不屈',1,10,1,540,1000,'[{8,55}]',2500,11000008,'韧性<color=#4eae1aff>+55</color>'),(8000,12,'不屈',1,10,1,540,1000,'[{8,60}]',2650,11000008,'韧性<color=#4eae1aff>+60</color>'),(8000,13,'不屈',1,10,1,540,1000,'[{8,65}]',2800,11000008,'韧性<color=#4eae1aff>+65</color>'),(8000,14,'不屈',1,10,1,540,1000,'[{8,70}]',2950,11000008,'韧性<color=#4eae1aff>+70</color>'),(8000,15,'不屈',1,10,1,540,1000,'[{8,75}]',3100,11000008,'韧性<color=#4eae1aff>+75</color>'),(8000,16,'不屈',1,10,1,540,1000,'[{8,80}]',3250,11000008,'韧性<color=#4eae1aff>+80</color>'),(8000,17,'不屈',1,10,1,540,1000,'[{8,85}]',3400,11000008,'韧性<color=#4eae1aff>+85</color>'),(8000,18,'不屈',1,10,1,540,1000,'[{8,90}]',3550,11000008,'韧性<color=#4eae1aff>+90</color>'),(8000,19,'不屈',1,10,1,540,1000,'[{8,95}]',3700,11000008,'韧性<color=#4eae1aff>+95</color>'),(8000,20,'不屈',1,10,1,540,1000,'[{8,100}]',3850,11000008,'韧性<color=#4eae1aff>+100</color>'),(8000,21,'不屈',1,10,1,540,1000,'[{8,105}]',4000,11000008,'韧性<color=#4eae1aff>+105</color>'),(8000,22,'不屈',1,10,1,540,1000,'[{8,110}]',4150,11000008,'韧性<color=#4eae1aff>+110</color>'),(8000,23,'不屈',1,10,1,540,1000,'[{8,115}]',4300,11000008,'韧性<color=#4eae1aff>+115</color>'),(8000,24,'不屈',1,10,1,540,1000,'[{8,120}]',4450,11000008,'韧性<color=#4eae1aff>+120</color>'),(8000,25,'不屈',1,10,1,540,1000,'[{8,125}]',4600,11000008,'韧性<color=#4eae1aff>+125</color>'),(8000,26,'不屈',1,10,1,540,1000,'[{8,130}]',4750,11000008,'韧性<color=#4eae1aff>+130</color>'),(8000,27,'不屈',1,10,1,540,1000,'[{8,135}]',4900,11000008,'韧性<color=#4eae1aff>+135</color>'),(8000,28,'不屈',1,10,1,540,1000,'[{8,140}]',5050,11000008,'韧性<color=#4eae1aff>+140</color>'),(8000,29,'不屈',1,10,1,540,1000,'[{8,145}]',5200,11000008,'韧性<color=#4eae1aff>+145</color>'),(8000,30,'不屈',1,10,1,540,1000,'[{8,150}]',5350,11000008,'韧性<color=#4eae1aff>+150</color>'),(8000,31,'不屈',1,10,1,540,1000,'[{8,155}]',5500,11000008,'韧性<color=#4eae1aff>+155</color>'),(8000,32,'不屈',1,10,1,540,1000,'[{8,160}]',5650,11000008,'韧性<color=#4eae1aff>+160</color>'),(8000,33,'不屈',1,10,1,540,1000,'[{8,165}]',5800,11000008,'韧性<color=#4eae1aff>+165</color>'),(8000,34,'不屈',1,10,1,540,1000,'[{8,170}]',5950,11000008,'韧性<color=#4eae1aff>+170</color>'),(8000,35,'不屈',1,10,1,540,1000,'[{8,175}]',6100,11000008,'韧性<color=#4eae1aff>+175</color>'),(8000,36,'不屈',1,10,1,540,1000,'[{8,180}]',6250,11000008,'韧性<color=#4eae1aff>+180</color>'),(8000,37,'不屈',1,10,1,540,1000,'[{8,185}]',6400,11000008,'韧性<color=#4eae1aff>+185</color>'),(8000,38,'不屈',1,10,1,540,1000,'[{8,190}]',6550,11000008,'韧性<color=#4eae1aff>+190</color>'),(8000,39,'不屈',1,10,1,540,1000,'[{8,195}]',6700,11000008,'韧性<color=#4eae1aff>+195</color>'),(8000,40,'不屈',1,10,1,540,1000,'[{8,200}]',6850,11000008,'韧性<color=#4eae1aff>+200</color>'),(8000,41,'不屈',1,10,1,540,1000,'[{8,205}]',7000,11000008,'韧性<color=#4eae1aff>+205</color>'),(8000,42,'不屈',1,10,1,540,1000,'[{8,210}]',7150,11000008,'韧性<color=#4eae1aff>+210</color>'),(8000,43,'不屈',1,10,1,540,1000,'[{8,215}]',7300,11000008,'韧性<color=#4eae1aff>+215</color>'),(8000,44,'不屈',1,10,1,540,1000,'[{8,220}]',7450,11000008,'韧性<color=#4eae1aff>+220</color>'),(8000,45,'不屈',1,10,1,540,1000,'[{8,225}]',7600,11000008,'韧性<color=#4eae1aff>+225</color>'),(8000,46,'不屈',1,10,1,540,1000,'[{8,230}]',7750,11000008,'韧性<color=#4eae1aff>+230</color>'),(8000,47,'不屈',1,10,1,540,1000,'[{8,235}]',7900,11000008,'韧性<color=#4eae1aff>+235</color>'),(8000,48,'不屈',1,10,1,540,1000,'[{8,240}]',8050,11000008,'韧性<color=#4eae1aff>+240</color>'),(8000,49,'不屈',1,10,1,540,1000,'[{8,245}]',8200,11000008,'韧性<color=#4eae1aff>+245</color>'),(8000,50,'不屈',1,10,1,540,1000,'[{8,250}]',8350,11000008,'韧性<color=#4eae1aff>+250</color>'),(8000,51,'不屈',1,10,2,540,1000,'[{8,255}]',8500,11000008,'韧性<color=#4eae1aff>+255</color>'),(8000,52,'不屈',1,10,2,540,1000,'[{8,260}]',8650,11000008,'韧性<color=#4eae1aff>+260</color>'),(8000,53,'不屈',1,10,2,540,1000,'[{8,265}]',8800,11000008,'韧性<color=#4eae1aff>+265</color>'),(8000,54,'不屈',1,10,2,540,1000,'[{8,270}]',8950,11000008,'韧性<color=#4eae1aff>+270</color>'),(8000,55,'不屈',1,10,2,540,1000,'[{8,275}]',9100,11000008,'韧性<color=#4eae1aff>+275</color>'),(8000,56,'不屈',1,10,2,540,1000,'[{8,280}]',9250,11000008,'韧性<color=#4eae1aff>+280</color>'),(8000,57,'不屈',1,10,2,540,1000,'[{8,285}]',9400,11000008,'韧性<color=#4eae1aff>+285</color>'),(8000,58,'不屈',1,10,2,540,1000,'[{8,290}]',9550,11000008,'韧性<color=#4eae1aff>+290</color>'),(8000,59,'不屈',1,10,2,540,1000,'[{8,295}]',9700,11000008,'韧性<color=#4eae1aff>+295</color>'),(8000,60,'不屈',1,10,2,540,1000,'[{8,300}]',9850,11000008,'韧性<color=#4eae1aff>+300</color>'),(8000,61,'不屈',1,10,2,540,1000,'[{8,305}]',10000,11000008,'韧性<color=#4eae1aff>+305</color>'),(8000,62,'不屈',1,10,2,540,1000,'[{8,310}]',10150,11000008,'韧性<color=#4eae1aff>+310</color>'),(8000,63,'不屈',1,10,2,540,1000,'[{8,315}]',10300,11000008,'韧性<color=#4eae1aff>+315</color>'),(8000,64,'不屈',1,10,2,540,1000,'[{8,320}]',10450,11000008,'韧性<color=#4eae1aff>+320</color>'),(8000,65,'不屈',1,10,2,540,1000,'[{8,325}]',10600,11000008,'韧性<color=#4eae1aff>+325</color>'),(8000,66,'不屈',1,10,2,540,1000,'[{8,330}]',10750,11000008,'韧性<color=#4eae1aff>+330</color>'),(8000,67,'不屈',1,10,2,540,1000,'[{8,335}]',10900,11000008,'韧性<color=#4eae1aff>+335</color>'),(8000,68,'不屈',1,10,2,540,1000,'[{8,340}]',11050,11000008,'韧性<color=#4eae1aff>+340</color>'),(8000,69,'不屈',1,10,2,540,1000,'[{8,345}]',11200,11000008,'韧性<color=#4eae1aff>+345</color>'),(8000,70,'不屈',1,10,2,540,1000,'[{8,350}]',11350,11000008,'韧性<color=#4eae1aff>+350</color>'),(8000,71,'不屈',1,10,2,540,1000,'[{8,355}]',11500,11000008,'韧性<color=#4eae1aff>+355</color>'),(8000,72,'不屈',1,10,2,540,1000,'[{8,360}]',11650,11000008,'韧性<color=#4eae1aff>+360</color>'),(8000,73,'不屈',1,10,2,540,1000,'[{8,365}]',11800,11000008,'韧性<color=#4eae1aff>+365</color>'),(8000,74,'不屈',1,10,2,540,1000,'[{8,370}]',11950,11000008,'韧性<color=#4eae1aff>+370</color>'),(8000,75,'不屈',1,10,2,540,1000,'[{8,375}]',12100,11000008,'韧性<color=#4eae1aff>+375</color>'),(8000,76,'不屈',1,10,2,540,1000,'[{8,380}]',12250,11000008,'韧性<color=#4eae1aff>+380</color>'),(8000,77,'不屈',1,10,2,540,1000,'[{8,385}]',12400,11000008,'韧性<color=#4eae1aff>+385</color>'),(8000,78,'不屈',1,10,2,540,1000,'[{8,390}]',12550,11000008,'韧性<color=#4eae1aff>+390</color>'),(8000,79,'不屈',1,10,2,540,1000,'[{8,395}]',12700,11000008,'韧性<color=#4eae1aff>+395</color>'),(8000,80,'不屈',1,10,2,540,1000,'[{8,400}]',12850,11000008,'韧性<color=#4eae1aff>+400</color>'),(8000,81,'不屈',1,10,2,540,1000,'[{8,405}]',13000,11000008,'韧性<color=#4eae1aff>+405</color>'),(8000,82,'不屈',1,10,2,540,1000,'[{8,410}]',13150,11000008,'韧性<color=#4eae1aff>+410</color>'),(8000,83,'不屈',1,10,2,540,1000,'[{8,415}]',13300,11000008,'韧性<color=#4eae1aff>+415</color>'),(8000,84,'不屈',1,10,2,540,1000,'[{8,420}]',13450,11000008,'韧性<color=#4eae1aff>+420</color>'),(8000,85,'不屈',1,10,2,540,1000,'[{8,425}]',13600,11000008,'韧性<color=#4eae1aff>+425</color>'),(8000,86,'不屈',1,10,2,540,1000,'[{8,430}]',13750,11000008,'韧性<color=#4eae1aff>+430</color>'),(8000,87,'不屈',1,10,2,540,1000,'[{8,435}]',13900,11000008,'韧性<color=#4eae1aff>+435</color>'),(8000,88,'不屈',1,10,2,540,1000,'[{8,440}]',14050,11000008,'韧性<color=#4eae1aff>+440</color>'),(8000,89,'不屈',1,10,2,540,1000,'[{8,445}]',14200,11000008,'韧性<color=#4eae1aff>+445</color>'),(8000,90,'不屈',1,10,2,540,1000,'[{8,450}]',14350,11000008,'韧性<color=#4eae1aff>+450</color>'),(8000,91,'不屈',1,10,2,540,1000,'[{8,455}]',14500,11000008,'韧性<color=#4eae1aff>+455</color>'),(8000,92,'不屈',1,10,2,540,1000,'[{8,460}]',14650,11000008,'韧性<color=#4eae1aff>+460</color>'),(8000,93,'不屈',1,10,2,540,1000,'[{8,465}]',14800,11000008,'韧性<color=#4eae1aff>+465</color>'),(8000,94,'不屈',1,10,2,540,1000,'[{8,470}]',14950,11000008,'韧性<color=#4eae1aff>+470</color>'),(8000,95,'不屈',1,10,2,540,1000,'[{8,475}]',15100,11000008,'韧性<color=#4eae1aff>+475</color>'),(8000,96,'不屈',1,10,2,540,1000,'[{8,480}]',15250,11000008,'韧性<color=#4eae1aff>+480</color>'),(8000,97,'不屈',1,10,2,540,1000,'[{8,485}]',15400,11000008,'韧性<color=#4eae1aff>+485</color>'),(8000,98,'不屈',1,10,2,540,1000,'[{8,490}]',15550,11000008,'韧性<color=#4eae1aff>+490</color>'),(8000,99,'不屈',1,10,2,540,1000,'[{8,495}]',15700,11000008,'韧性<color=#4eae1aff>+495</color>'),(8000,100,'不屈',1,10,2,540,1000,'[{8,500}]',15850,11000008,'韧性<color=#4eae1aff>+500</color>'),(8000,101,'不屈',1,10,3,540,1000,'[{8,505}]',16000,11000008,'韧性<color=#4eae1aff>+505</color>'),(8000,102,'不屈',1,10,3,540,1000,'[{8,510}]',16150,11000008,'韧性<color=#4eae1aff>+510</color>'),(8000,103,'不屈',1,10,3,540,1000,'[{8,515}]',16300,11000008,'韧性<color=#4eae1aff>+515</color>'),(8000,104,'不屈',1,10,3,540,1000,'[{8,520}]',16450,11000008,'韧性<color=#4eae1aff>+520</color>'),(8000,105,'不屈',1,10,3,540,1000,'[{8,525}]',16600,11000008,'韧性<color=#4eae1aff>+525</color>'),(8000,106,'不屈',1,10,3,540,1000,'[{8,530}]',16750,11000008,'韧性<color=#4eae1aff>+530</color>'),(8000,107,'不屈',1,10,3,540,1000,'[{8,535}]',16900,11000008,'韧性<color=#4eae1aff>+535</color>'),(8000,108,'不屈',1,10,3,540,1000,'[{8,540}]',17050,11000008,'韧性<color=#4eae1aff>+540</color>'),(8000,109,'不屈',1,10,3,540,1000,'[{8,545}]',17200,11000008,'韧性<color=#4eae1aff>+545</color>'),(8000,110,'不屈',1,10,3,540,1000,'[{8,550}]',17350,11000008,'韧性<color=#4eae1aff>+550</color>'),(8000,111,'不屈',1,10,3,540,1000,'[{8,555}]',17500,11000008,'韧性<color=#4eae1aff>+555</color>'),(8000,112,'不屈',1,10,3,540,1000,'[{8,560}]',17650,11000008,'韧性<color=#4eae1aff>+560</color>'),(8000,113,'不屈',1,10,3,540,1000,'[{8,565}]',17800,11000008,'韧性<color=#4eae1aff>+565</color>'),(8000,114,'不屈',1,10,3,540,1000,'[{8,570}]',17950,11000008,'韧性<color=#4eae1aff>+570</color>'),(8000,115,'不屈',1,10,3,540,1000,'[{8,575}]',18100,11000008,'韧性<color=#4eae1aff>+575</color>'),(8000,116,'不屈',1,10,3,540,1000,'[{8,580}]',18250,11000008,'韧性<color=#4eae1aff>+580</color>'),(8000,117,'不屈',1,10,3,540,1000,'[{8,585}]',18400,11000008,'韧性<color=#4eae1aff>+585</color>'),(8000,118,'不屈',1,10,3,540,1000,'[{8,590}]',18550,11000008,'韧性<color=#4eae1aff>+590</color>'),(8000,119,'不屈',1,10,3,540,1000,'[{8,595}]',18700,11000008,'韧性<color=#4eae1aff>+595</color>'),(8000,120,'不屈',1,10,3,540,1000,'[{8,600}]',18850,11000008,'韧性<color=#4eae1aff>+600</color>'),(8000,121,'不屈',1,10,3,540,1000,'[{8,605}]',19000,11000008,'韧性<color=#4eae1aff>+605</color>'),(8000,122,'不屈',1,10,3,540,1000,'[{8,610}]',19150,11000008,'韧性<color=#4eae1aff>+610</color>'),(8000,123,'不屈',1,10,3,540,1000,'[{8,615}]',19300,11000008,'韧性<color=#4eae1aff>+615</color>'),(8000,124,'不屈',1,10,3,540,1000,'[{8,620}]',19450,11000008,'韧性<color=#4eae1aff>+620</color>'),(8000,125,'不屈',1,10,3,540,1000,'[{8,625}]',19600,11000008,'韧性<color=#4eae1aff>+625</color>'),(8000,126,'不屈',1,10,3,540,1000,'[{8,630}]',19750,11000008,'韧性<color=#4eae1aff>+630</color>'),(8000,127,'不屈',1,10,3,540,1000,'[{8,635}]',19900,11000008,'韧性<color=#4eae1aff>+635</color>'),(8000,128,'不屈',1,10,3,540,1000,'[{8,640}]',20050,11000008,'韧性<color=#4eae1aff>+640</color>'),(8000,129,'不屈',1,10,3,540,1000,'[{8,645}]',20200,11000008,'韧性<color=#4eae1aff>+645</color>'),(8000,130,'不屈',1,10,3,540,1000,'[{8,650}]',20350,11000008,'韧性<color=#4eae1aff>+650</color>'),(8000,131,'不屈',1,10,3,540,1000,'[{8,655}]',20500,11000008,'韧性<color=#4eae1aff>+655</color>'),(8000,132,'不屈',1,10,3,540,1000,'[{8,660}]',20650,11000008,'韧性<color=#4eae1aff>+660</color>'),(8000,133,'不屈',1,10,3,540,1000,'[{8,665}]',20800,11000008,'韧性<color=#4eae1aff>+665</color>'),(8000,134,'不屈',1,10,3,540,1000,'[{8,670}]',20950,11000008,'韧性<color=#4eae1aff>+670</color>'),(8000,135,'不屈',1,10,3,540,1000,'[{8,675}]',21100,11000008,'韧性<color=#4eae1aff>+675</color>'),(8000,136,'不屈',1,10,3,540,1000,'[{8,680}]',21250,11000008,'韧性<color=#4eae1aff>+680</color>'),(8000,137,'不屈',1,10,3,540,1000,'[{8,685}]',21400,11000008,'韧性<color=#4eae1aff>+685</color>'),(8000,138,'不屈',1,10,3,540,1000,'[{8,690}]',21550,11000008,'韧性<color=#4eae1aff>+690</color>'),(8000,139,'不屈',1,10,3,540,1000,'[{8,695}]',21700,11000008,'韧性<color=#4eae1aff>+695</color>'),(8000,140,'不屈',1,10,3,540,1000,'[{8,700}]',21850,11000008,'韧性<color=#4eae1aff>+700</color>'),(8000,141,'不屈',1,10,3,540,1000,'[{8,705}]',22000,11000008,'韧性<color=#4eae1aff>+705</color>'),(8000,142,'不屈',1,10,3,540,1000,'[{8,710}]',22150,11000008,'韧性<color=#4eae1aff>+710</color>'),(8000,143,'不屈',1,10,3,540,1000,'[{8,715}]',22300,11000008,'韧性<color=#4eae1aff>+715</color>'),(8000,144,'不屈',1,10,3,540,1000,'[{8,720}]',22450,11000008,'韧性<color=#4eae1aff>+720</color>'),(8000,145,'不屈',1,10,3,540,1000,'[{8,725}]',22600,11000008,'韧性<color=#4eae1aff>+725</color>'),(8000,146,'不屈',1,10,3,540,1000,'[{8,730}]',22750,11000008,'韧性<color=#4eae1aff>+730</color>'),(8000,147,'不屈',1,10,3,540,1000,'[{8,735}]',22900,11000008,'韧性<color=#4eae1aff>+735</color>'),(8000,148,'不屈',1,10,3,540,1000,'[{8,740}]',23050,11000008,'韧性<color=#4eae1aff>+740</color>'),(8000,149,'不屈',1,10,3,540,1000,'[{8,745}]',23200,11000008,'韧性<color=#4eae1aff>+745</color>'),(8000,150,'不屈',1,10,3,540,1000,'[{8,750}]',23350,11000008,'韧性<color=#4eae1aff>+750</color>'),(8000,151,'不屈',1,10,4,540,1000,'[{8,755}]',23500,11000008,'韧性<color=#4eae1aff>+755</color>'),(8000,152,'不屈',1,10,4,540,1000,'[{8,760}]',23650,11000008,'韧性<color=#4eae1aff>+760</color>'),(8000,153,'不屈',1,10,4,540,1000,'[{8,765}]',23800,11000008,'韧性<color=#4eae1aff>+765</color>'),(8000,154,'不屈',1,10,4,540,1000,'[{8,770}]',23950,11000008,'韧性<color=#4eae1aff>+770</color>'),(8000,155,'不屈',1,10,4,540,1000,'[{8,775}]',24100,11000008,'韧性<color=#4eae1aff>+775</color>'),(8000,156,'不屈',1,10,4,540,1000,'[{8,780}]',24250,11000008,'韧性<color=#4eae1aff>+780</color>'),(8000,157,'不屈',1,10,4,540,1000,'[{8,785}]',24400,11000008,'韧性<color=#4eae1aff>+785</color>'),(8000,158,'不屈',1,10,4,540,1000,'[{8,790}]',24550,11000008,'韧性<color=#4eae1aff>+790</color>'),(8000,159,'不屈',1,10,4,540,1000,'[{8,795}]',24700,11000008,'韧性<color=#4eae1aff>+795</color>'),(8000,160,'不屈',1,10,4,540,1000,'[{8,800}]',24850,11000008,'韧性<color=#4eae1aff>+800</color>'),(8000,161,'不屈',1,10,4,540,1000,'[{8,805}]',25000,11000008,'韧性<color=#4eae1aff>+805</color>'),(8000,162,'不屈',1,10,4,540,1000,'[{8,810}]',25150,11000008,'韧性<color=#4eae1aff>+810</color>'),(8000,163,'不屈',1,10,4,540,1000,'[{8,815}]',25300,11000008,'韧性<color=#4eae1aff>+815</color>'),(8000,164,'不屈',1,10,4,540,1000,'[{8,820}]',25450,11000008,'韧性<color=#4eae1aff>+820</color>'),(8000,165,'不屈',1,10,4,540,1000,'[{8,825}]',25600,11000008,'韧性<color=#4eae1aff>+825</color>'),(8000,166,'不屈',1,10,4,540,1000,'[{8,830}]',25750,11000008,'韧性<color=#4eae1aff>+830</color>'),(8000,167,'不屈',1,10,4,540,1000,'[{8,835}]',25900,11000008,'韧性<color=#4eae1aff>+835</color>'),(8000,168,'不屈',1,10,4,540,1000,'[{8,840}]',26050,11000008,'韧性<color=#4eae1aff>+840</color>'),(8000,169,'不屈',1,10,4,540,1000,'[{8,845}]',26200,11000008,'韧性<color=#4eae1aff>+845</color>'),(8000,170,'不屈',1,10,4,540,1000,'[{8,850}]',26350,11000008,'韧性<color=#4eae1aff>+850</color>'),(8000,171,'不屈',1,10,4,540,1000,'[{8,855}]',26500,11000008,'韧性<color=#4eae1aff>+855</color>'),(8000,172,'不屈',1,10,4,540,1000,'[{8,860}]',26650,11000008,'韧性<color=#4eae1aff>+860</color>'),(8000,173,'不屈',1,10,4,540,1000,'[{8,865}]',26800,11000008,'韧性<color=#4eae1aff>+865</color>'),(8000,174,'不屈',1,10,4,540,1000,'[{8,870}]',26950,11000008,'韧性<color=#4eae1aff>+870</color>'),(8000,175,'不屈',1,10,4,540,1000,'[{8,875}]',27100,11000008,'韧性<color=#4eae1aff>+875</color>'),(8000,176,'不屈',1,10,4,540,1000,'[{8,880}]',27250,11000008,'韧性<color=#4eae1aff>+880</color>'),(8000,177,'不屈',1,10,4,540,1000,'[{8,885}]',27400,11000008,'韧性<color=#4eae1aff>+885</color>'),(8000,178,'不屈',1,10,4,540,1000,'[{8,890}]',27550,11000008,'韧性<color=#4eae1aff>+890</color>'),(8000,179,'不屈',1,10,4,540,1000,'[{8,895}]',27700,11000008,'韧性<color=#4eae1aff>+895</color>'),(8000,180,'不屈',1,10,4,540,1000,'[{8,900}]',27850,11000008,'韧性<color=#4eae1aff>+900</color>'),(8000,181,'不屈',1,10,4,540,1000,'[{8,905}]',28000,11000008,'韧性<color=#4eae1aff>+905</color>'),(8000,182,'不屈',1,10,4,540,1000,'[{8,910}]',28150,11000008,'韧性<color=#4eae1aff>+910</color>'),(8000,183,'不屈',1,10,4,540,1000,'[{8,915}]',28300,11000008,'韧性<color=#4eae1aff>+915</color>'),(8000,184,'不屈',1,10,4,540,1000,'[{8,920}]',28450,11000008,'韧性<color=#4eae1aff>+920</color>'),(8000,185,'不屈',1,10,4,540,1000,'[{8,925}]',28600,11000008,'韧性<color=#4eae1aff>+925</color>'),(8000,186,'不屈',1,10,4,540,1000,'[{8,930}]',28750,11000008,'韧性<color=#4eae1aff>+930</color>'),(8000,187,'不屈',1,10,4,540,1000,'[{8,935}]',28900,11000008,'韧性<color=#4eae1aff>+935</color>'),(8000,188,'不屈',1,10,4,540,1000,'[{8,940}]',29050,11000008,'韧性<color=#4eae1aff>+940</color>'),(8000,189,'不屈',1,10,4,540,1000,'[{8,945}]',29200,11000008,'韧性<color=#4eae1aff>+945</color>'),(8000,190,'不屈',1,10,4,540,1000,'[{8,950}]',29350,11000008,'韧性<color=#4eae1aff>+950</color>'),(8000,191,'不屈',1,10,4,540,1000,'[{8,955}]',29500,11000008,'韧性<color=#4eae1aff>+955</color>'),(8000,192,'不屈',1,10,4,540,1000,'[{8,960}]',29650,11000008,'韧性<color=#4eae1aff>+960</color>'),(8000,193,'不屈',1,10,4,540,1000,'[{8,965}]',29800,11000008,'韧性<color=#4eae1aff>+965</color>'),(8000,194,'不屈',1,10,4,540,1000,'[{8,970}]',29950,11000008,'韧性<color=#4eae1aff>+970</color>'),(8000,195,'不屈',1,10,4,540,1000,'[{8,975}]',30100,11000008,'韧性<color=#4eae1aff>+975</color>'),(8000,196,'不屈',1,10,4,540,1000,'[{8,980}]',30250,11000008,'韧性<color=#4eae1aff>+980</color>'),(8000,197,'不屈',1,10,4,540,1000,'[{8,985}]',30400,11000008,'韧性<color=#4eae1aff>+985</color>'),(8000,198,'不屈',1,10,4,540,1000,'[{8,990}]',30550,11000008,'韧性<color=#4eae1aff>+990</color>'),(8000,199,'不屈',1,10,4,540,1000,'[{8,995}]',30700,11000008,'韧性<color=#4eae1aff>+995</color>'),(8000,200,'不屈',1,10,4,540,1000,'[{8,1000}]',30850,11000008,'韧性<color=#4eae1aff>+1000</color>'),(8000,201,'不屈',1,10,5,540,1000,'[{8,1005}]',31000,11000008,'韧性<color=#4eae1aff>+1005</color>'),(8000,202,'不屈',1,10,5,540,1000,'[{8,1010}]',31150,11000008,'韧性<color=#4eae1aff>+1010</color>'),(8000,203,'不屈',1,10,5,540,1000,'[{8,1015}]',31300,11000008,'韧性<color=#4eae1aff>+1015</color>'),(8000,204,'不屈',1,10,5,540,1000,'[{8,1020}]',31450,11000008,'韧性<color=#4eae1aff>+1020</color>'),(8000,205,'不屈',1,10,5,540,1000,'[{8,1025}]',31600,11000008,'韧性<color=#4eae1aff>+1025</color>'),(8000,206,'不屈',1,10,5,540,1000,'[{8,1030}]',31750,11000008,'韧性<color=#4eae1aff>+1030</color>'),(8000,207,'不屈',1,10,5,540,1000,'[{8,1035}]',31900,11000008,'韧性<color=#4eae1aff>+1035</color>'),(8000,208,'不屈',1,10,5,540,1000,'[{8,1040}]',32050,11000008,'韧性<color=#4eae1aff>+1040</color>'),(8000,209,'不屈',1,10,5,540,1000,'[{8,1045}]',32200,11000008,'韧性<color=#4eae1aff>+1045</color>'),(8000,210,'不屈',1,10,5,540,1000,'[{8,1050}]',32350,11000008,'韧性<color=#4eae1aff>+1050</color>'),(8000,211,'不屈',1,10,5,540,1000,'[{8,1055}]',32500,11000008,'韧性<color=#4eae1aff>+1055</color>'),(8000,212,'不屈',1,10,5,540,1000,'[{8,1060}]',32650,11000008,'韧性<color=#4eae1aff>+1060</color>'),(8000,213,'不屈',1,10,5,540,1000,'[{8,1065}]',32800,11000008,'韧性<color=#4eae1aff>+1065</color>'),(8000,214,'不屈',1,10,5,540,1000,'[{8,1070}]',32950,11000008,'韧性<color=#4eae1aff>+1070</color>'),(8000,215,'不屈',1,10,5,540,1000,'[{8,1075}]',33100,11000008,'韧性<color=#4eae1aff>+1075</color>'),(8000,216,'不屈',1,10,5,540,1000,'[{8,1080}]',33250,11000008,'韧性<color=#4eae1aff>+1080</color>'),(8000,217,'不屈',1,10,5,540,1000,'[{8,1085}]',33400,11000008,'韧性<color=#4eae1aff>+1085</color>'),(8000,218,'不屈',1,10,5,540,1000,'[{8,1090}]',33550,11000008,'韧性<color=#4eae1aff>+1090</color>'),(8000,219,'不屈',1,10,5,540,1000,'[{8,1095}]',33700,11000008,'韧性<color=#4eae1aff>+1095</color>'),(8000,220,'不屈',1,10,5,540,1000,'[{8,1100}]',33850,11000008,'韧性<color=#4eae1aff>+1100</color>'),(8000,221,'不屈',1,10,5,540,1000,'[{8,1105}]',34000,11000008,'韧性<color=#4eae1aff>+1105</color>'),(8000,222,'不屈',1,10,5,540,1000,'[{8,1110}]',34150,11000008,'韧性<color=#4eae1aff>+1110</color>'),(8000,223,'不屈',1,10,5,540,1000,'[{8,1115}]',34300,11000008,'韧性<color=#4eae1aff>+1115</color>'),(8000,224,'不屈',1,10,5,540,1000,'[{8,1120}]',34450,11000008,'韧性<color=#4eae1aff>+1120</color>'),(8000,225,'不屈',1,10,5,540,1000,'[{8,1125}]',34600,11000008,'韧性<color=#4eae1aff>+1125</color>'),(8000,226,'不屈',1,10,5,540,1000,'[{8,1130}]',34750,11000008,'韧性<color=#4eae1aff>+1130</color>'),(8000,227,'不屈',1,10,5,540,1000,'[{8,1135}]',34900,11000008,'韧性<color=#4eae1aff>+1135</color>'),(8000,228,'不屈',1,10,5,540,1000,'[{8,1140}]',35050,11000008,'韧性<color=#4eae1aff>+1140</color>'),(8000,229,'不屈',1,10,5,540,1000,'[{8,1145}]',35200,11000008,'韧性<color=#4eae1aff>+1145</color>'),(8000,230,'不屈',1,10,5,540,1000,'[{8,1150}]',35350,11000008,'韧性<color=#4eae1aff>+1150</color>'),(8000,231,'不屈',1,10,5,540,1000,'[{8,1155}]',35500,11000008,'韧性<color=#4eae1aff>+1155</color>'),(8000,232,'不屈',1,10,5,540,1000,'[{8,1160}]',35650,11000008,'韧性<color=#4eae1aff>+1160</color>'),(8000,233,'不屈',1,10,5,540,1000,'[{8,1165}]',35800,11000008,'韧性<color=#4eae1aff>+1165</color>'),(8000,234,'不屈',1,10,5,540,1000,'[{8,1170}]',35950,11000008,'韧性<color=#4eae1aff>+1170</color>'),(8000,235,'不屈',1,10,5,540,1000,'[{8,1175}]',36100,11000008,'韧性<color=#4eae1aff>+1175</color>'),(8000,236,'不屈',1,10,5,540,1000,'[{8,1180}]',36250,11000008,'韧性<color=#4eae1aff>+1180</color>'),(8000,237,'不屈',1,10,5,540,1000,'[{8,1185}]',36400,11000008,'韧性<color=#4eae1aff>+1185</color>'),(8000,238,'不屈',1,10,5,540,1000,'[{8,1190}]',36550,11000008,'韧性<color=#4eae1aff>+1190</color>'),(8000,239,'不屈',1,10,5,540,1000,'[{8,1195}]',36700,11000008,'韧性<color=#4eae1aff>+1195</color>'),(8000,240,'不屈',1,10,5,540,1000,'[{8,1200}]',36850,11000008,'韧性<color=#4eae1aff>+1200</color>'),(8000,241,'不屈',1,10,5,540,1000,'[{8,1205}]',37000,11000008,'韧性<color=#4eae1aff>+1205</color>'),(8000,242,'不屈',1,10,5,540,1000,'[{8,1210}]',37150,11000008,'韧性<color=#4eae1aff>+1210</color>'),(8000,243,'不屈',1,10,5,540,1000,'[{8,1215}]',37300,11000008,'韧性<color=#4eae1aff>+1215</color>'),(8000,244,'不屈',1,10,5,540,1000,'[{8,1220}]',37450,11000008,'韧性<color=#4eae1aff>+1220</color>'),(8000,245,'不屈',1,10,5,540,1000,'[{8,1225}]',37600,11000008,'韧性<color=#4eae1aff>+1225</color>'),(8000,246,'不屈',1,10,5,540,1000,'[{8,1230}]',37750,11000008,'韧性<color=#4eae1aff>+1230</color>'),(8000,247,'不屈',1,10,5,540,1000,'[{8,1235}]',37900,11000008,'韧性<color=#4eae1aff>+1235</color>'),(8000,248,'不屈',1,10,5,540,1000,'[{8,1240}]',38050,11000008,'韧性<color=#4eae1aff>+1240</color>'),(8000,249,'不屈',1,10,5,540,1000,'[{8,1245}]',38200,11000008,'韧性<color=#4eae1aff>+1245</color>'),(8000,250,'不屈',1,10,5,540,1000,'[{8,1250}]',38350,11000008,'韧性<color=#4eae1aff>+1250</color>'),(8000,251,'不屈',1,10,6,540,1000,'[{8,1255}]',38500,11000008,'韧性<color=#4eae1aff>+1255</color>'),(8000,252,'不屈',1,10,6,540,1000,'[{8,1260}]',38650,11000008,'韧性<color=#4eae1aff>+1260</color>'),(8000,253,'不屈',1,10,6,540,1000,'[{8,1265}]',38800,11000008,'韧性<color=#4eae1aff>+1265</color>'),(8000,254,'不屈',1,10,6,540,1000,'[{8,1270}]',38950,11000008,'韧性<color=#4eae1aff>+1270</color>'),(8000,255,'不屈',1,10,6,540,1000,'[{8,1275}]',39100,11000008,'韧性<color=#4eae1aff>+1275</color>'),(8000,256,'不屈',1,10,6,540,1000,'[{8,1280}]',39250,11000008,'韧性<color=#4eae1aff>+1280</color>'),(8000,257,'不屈',1,10,6,540,1000,'[{8,1285}]',39400,11000008,'韧性<color=#4eae1aff>+1285</color>'),(8000,258,'不屈',1,10,6,540,1000,'[{8,1290}]',39550,11000008,'韧性<color=#4eae1aff>+1290</color>'),(8000,259,'不屈',1,10,6,540,1000,'[{8,1295}]',39700,11000008,'韧性<color=#4eae1aff>+1295</color>'),(8000,260,'不屈',1,10,6,540,1000,'[{8,1300}]',39850,11000008,'韧性<color=#4eae1aff>+1300</color>'),(8000,261,'不屈',1,10,6,540,1000,'[{8,1305}]',40000,11000008,'韧性<color=#4eae1aff>+1305</color>'),(8000,262,'不屈',1,10,6,540,1000,'[{8,1310}]',40150,11000008,'韧性<color=#4eae1aff>+1310</color>'),(8000,263,'不屈',1,10,6,540,1000,'[{8,1315}]',40300,11000008,'韧性<color=#4eae1aff>+1315</color>'),(8000,264,'不屈',1,10,6,540,1000,'[{8,1320}]',40450,11000008,'韧性<color=#4eae1aff>+1320</color>'),(8000,265,'不屈',1,10,6,540,1000,'[{8,1325}]',40600,11000008,'韧性<color=#4eae1aff>+1325</color>'),(8000,266,'不屈',1,10,6,540,1000,'[{8,1330}]',40750,11000008,'韧性<color=#4eae1aff>+1330</color>'),(8000,267,'不屈',1,10,6,540,1000,'[{8,1335}]',40900,11000008,'韧性<color=#4eae1aff>+1335</color>'),(8000,268,'不屈',1,10,6,540,1000,'[{8,1340}]',41050,11000008,'韧性<color=#4eae1aff>+1340</color>'),(8000,269,'不屈',1,10,6,540,1000,'[{8,1345}]',41200,11000008,'韧性<color=#4eae1aff>+1345</color>'),(8000,270,'不屈',1,10,6,540,1000,'[{8,1350}]',41350,11000008,'韧性<color=#4eae1aff>+1350</color>'),(8000,271,'不屈',1,10,6,540,1000,'[{8,1355}]',41500,11000008,'韧性<color=#4eae1aff>+1355</color>'),(8000,272,'不屈',1,10,6,540,1000,'[{8,1360}]',41650,11000008,'韧性<color=#4eae1aff>+1360</color>'),(8000,273,'不屈',1,10,6,540,1000,'[{8,1365}]',41800,11000008,'韧性<color=#4eae1aff>+1365</color>'),(8000,274,'不屈',1,10,6,540,1000,'[{8,1370}]',41950,11000008,'韧性<color=#4eae1aff>+1370</color>'),(8000,275,'不屈',1,10,6,540,1000,'[{8,1375}]',42100,11000008,'韧性<color=#4eae1aff>+1375</color>'),(8000,276,'不屈',1,10,6,540,1000,'[{8,1380}]',42250,11000008,'韧性<color=#4eae1aff>+1380</color>'),(8000,277,'不屈',1,10,6,540,1000,'[{8,1385}]',42400,11000008,'韧性<color=#4eae1aff>+1385</color>'),(8000,278,'不屈',1,10,6,540,1000,'[{8,1390}]',42550,11000008,'韧性<color=#4eae1aff>+1390</color>'),(8000,279,'不屈',1,10,6,540,1000,'[{8,1395}]',42700,11000008,'韧性<color=#4eae1aff>+1395</color>'),(8000,280,'不屈',1,10,6,540,1000,'[{8,1400}]',42850,11000008,'韧性<color=#4eae1aff>+1400</color>'),(8000,281,'不屈',1,10,6,540,1000,'[{8,1405}]',43000,11000008,'韧性<color=#4eae1aff>+1405</color>'),(8000,282,'不屈',1,10,6,540,1000,'[{8,1410}]',43150,11000008,'韧性<color=#4eae1aff>+1410</color>'),(8000,283,'不屈',1,10,6,540,1000,'[{8,1415}]',43300,11000008,'韧性<color=#4eae1aff>+1415</color>'),(8000,284,'不屈',1,10,6,540,1000,'[{8,1420}]',43450,11000008,'韧性<color=#4eae1aff>+1420</color>'),(8000,285,'不屈',1,10,6,540,1000,'[{8,1425}]',43600,11000008,'韧性<color=#4eae1aff>+1425</color>'),(8000,286,'不屈',1,10,6,540,1000,'[{8,1430}]',43750,11000008,'韧性<color=#4eae1aff>+1430</color>'),(8000,287,'不屈',1,10,6,540,1000,'[{8,1435}]',43900,11000008,'韧性<color=#4eae1aff>+1435</color>'),(8000,288,'不屈',1,10,6,540,1000,'[{8,1440}]',44050,11000008,'韧性<color=#4eae1aff>+1440</color>'),(8000,289,'不屈',1,10,6,540,1000,'[{8,1445}]',44200,11000008,'韧性<color=#4eae1aff>+1445</color>'),(8000,290,'不屈',1,10,6,540,1000,'[{8,1450}]',44350,11000008,'韧性<color=#4eae1aff>+1450</color>'),(8000,291,'不屈',1,10,6,540,1000,'[{8,1455}]',44500,11000008,'韧性<color=#4eae1aff>+1455</color>'),(8000,292,'不屈',1,10,6,540,1000,'[{8,1460}]',44650,11000008,'韧性<color=#4eae1aff>+1460</color>'),(8000,293,'不屈',1,10,6,540,1000,'[{8,1465}]',44800,11000008,'韧性<color=#4eae1aff>+1465</color>'),(8000,294,'不屈',1,10,6,540,1000,'[{8,1470}]',44950,11000008,'韧性<color=#4eae1aff>+1470</color>'),(8000,295,'不屈',1,10,6,540,1000,'[{8,1475}]',45100,11000008,'韧性<color=#4eae1aff>+1475</color>'),(8000,296,'不屈',1,10,6,540,1000,'[{8,1480}]',45250,11000008,'韧性<color=#4eae1aff>+1480</color>'),(8000,297,'不屈',1,10,6,540,1000,'[{8,1485}]',45400,11000008,'韧性<color=#4eae1aff>+1485</color>'),(8000,298,'不屈',1,10,6,540,1000,'[{8,1490}]',45550,11000008,'韧性<color=#4eae1aff>+1490</color>'),(8000,299,'不屈',1,10,6,540,1000,'[{8,1495}]',45700,11000008,'韧性<color=#4eae1aff>+1495</color>'),(8000,300,'不屈',1,10,6,540,1000,'[{8,1500}]',45850,11000008,'韧性<color=#4eae1aff>+1500</color>'),(8000,301,'不屈',1,10,7,540,1000,'[{8,1505}]',46000,11000008,'韧性<color=#4eae1aff>+1505</color>'),(8000,302,'不屈',1,10,7,540,1000,'[{8,1510}]',46150,11000008,'韧性<color=#4eae1aff>+1510</color>'),(8000,303,'不屈',1,10,7,540,1000,'[{8,1515}]',46300,11000008,'韧性<color=#4eae1aff>+1515</color>'),(8000,304,'不屈',1,10,7,540,1000,'[{8,1520}]',46450,11000008,'韧性<color=#4eae1aff>+1520</color>'),(8000,305,'不屈',1,10,7,540,1000,'[{8,1525}]',46600,11000008,'韧性<color=#4eae1aff>+1525</color>'),(8000,306,'不屈',1,10,7,540,1000,'[{8,1530}]',46750,11000008,'韧性<color=#4eae1aff>+1530</color>'),(8000,307,'不屈',1,10,7,540,1000,'[{8,1535}]',46900,11000008,'韧性<color=#4eae1aff>+1535</color>'),(8000,308,'不屈',1,10,7,540,1000,'[{8,1540}]',47050,11000008,'韧性<color=#4eae1aff>+1540</color>'),(8000,309,'不屈',1,10,7,540,1000,'[{8,1545}]',47200,11000008,'韧性<color=#4eae1aff>+1545</color>'),(8000,310,'不屈',1,10,7,540,1000,'[{8,1550}]',47350,11000008,'韧性<color=#4eae1aff>+1550</color>'),(8000,311,'不屈',1,10,7,540,1000,'[{8,1555}]',47500,11000008,'韧性<color=#4eae1aff>+1555</color>'),(8000,312,'不屈',1,10,7,540,1000,'[{8,1560}]',47650,11000008,'韧性<color=#4eae1aff>+1560</color>'),(8000,313,'不屈',1,10,7,540,1000,'[{8,1565}]',47800,11000008,'韧性<color=#4eae1aff>+1565</color>'),(8000,314,'不屈',1,10,7,540,1000,'[{8,1570}]',47950,11000008,'韧性<color=#4eae1aff>+1570</color>'),(8000,315,'不屈',1,10,7,540,1000,'[{8,1575}]',48100,11000008,'韧性<color=#4eae1aff>+1575</color>'),(8000,316,'不屈',1,10,7,540,1000,'[{8,1580}]',48250,11000008,'韧性<color=#4eae1aff>+1580</color>'),(8000,317,'不屈',1,10,7,540,1000,'[{8,1585}]',48400,11000008,'韧性<color=#4eae1aff>+1585</color>'),(8000,318,'不屈',1,10,7,540,1000,'[{8,1590}]',48550,11000008,'韧性<color=#4eae1aff>+1590</color>'),(8000,319,'不屈',1,10,7,540,1000,'[{8,1595}]',48700,11000008,'韧性<color=#4eae1aff>+1595</color>'),(8000,320,'不屈',1,10,7,540,1000,'[{8,1600}]',48850,11000008,'韧性<color=#4eae1aff>+1600</color>'),(8000,321,'不屈',1,10,7,540,1000,'[{8,1605}]',49000,11000008,'韧性<color=#4eae1aff>+1605</color>'),(8000,322,'不屈',1,10,7,540,1000,'[{8,1610}]',49150,11000008,'韧性<color=#4eae1aff>+1610</color>'),(8000,323,'不屈',1,10,7,540,1000,'[{8,1615}]',49300,11000008,'韧性<color=#4eae1aff>+1615</color>'),(8000,324,'不屈',1,10,7,540,1000,'[{8,1620}]',49450,11000008,'韧性<color=#4eae1aff>+1620</color>'),(8000,325,'不屈',1,10,7,540,1000,'[{8,1625}]',49600,11000008,'韧性<color=#4eae1aff>+1625</color>'),(8000,326,'不屈',1,10,7,540,1000,'[{8,1630}]',49750,11000008,'韧性<color=#4eae1aff>+1630</color>'),(8000,327,'不屈',1,10,7,540,1000,'[{8,1635}]',49900,11000008,'韧性<color=#4eae1aff>+1635</color>'),(8000,328,'不屈',1,10,7,540,1000,'[{8,1640}]',50050,11000008,'韧性<color=#4eae1aff>+1640</color>'),(8000,329,'不屈',1,10,7,540,1000,'[{8,1645}]',50200,11000008,'韧性<color=#4eae1aff>+1645</color>'),(8000,330,'不屈',1,10,7,540,1000,'[{8,1650}]',50350,11000008,'韧性<color=#4eae1aff>+1650</color>'),(8000,331,'不屈',1,10,7,540,1000,'[{8,1655}]',50500,11000008,'韧性<color=#4eae1aff>+1655</color>'),(8000,332,'不屈',1,10,7,540,1000,'[{8,1660}]',50650,11000008,'韧性<color=#4eae1aff>+1660</color>'),(8000,333,'不屈',1,10,7,540,1000,'[{8,1665}]',50800,11000008,'韧性<color=#4eae1aff>+1665</color>'),(8000,334,'不屈',1,10,7,540,1000,'[{8,1670}]',50950,11000008,'韧性<color=#4eae1aff>+1670</color>'),(8000,335,'不屈',1,10,7,540,1000,'[{8,1675}]',51100,11000008,'韧性<color=#4eae1aff>+1675</color>'),(8000,336,'不屈',1,10,7,540,1000,'[{8,1680}]',51250,11000008,'韧性<color=#4eae1aff>+1680</color>'),(8000,337,'不屈',1,10,7,540,1000,'[{8,1685}]',51400,11000008,'韧性<color=#4eae1aff>+1685</color>'),(8000,338,'不屈',1,10,7,540,1000,'[{8,1690}]',51550,11000008,'韧性<color=#4eae1aff>+1690</color>'),(8000,339,'不屈',1,10,7,540,1000,'[{8,1695}]',51700,11000008,'韧性<color=#4eae1aff>+1695</color>'),(8000,340,'不屈',1,10,7,540,1000,'[{8,1700}]',51850,11000008,'韧性<color=#4eae1aff>+1700</color>'),(8000,341,'不屈',1,10,7,540,1000,'[{8,1705}]',52000,11000008,'韧性<color=#4eae1aff>+1705</color>'),(8000,342,'不屈',1,10,7,540,1000,'[{8,1710}]',52150,11000008,'韧性<color=#4eae1aff>+1710</color>'),(8000,343,'不屈',1,10,7,540,1000,'[{8,1715}]',52300,11000008,'韧性<color=#4eae1aff>+1715</color>'),(8000,344,'不屈',1,10,7,540,1000,'[{8,1720}]',52450,11000008,'韧性<color=#4eae1aff>+1720</color>'),(8000,345,'不屈',1,10,7,540,1000,'[{8,1725}]',52600,11000008,'韧性<color=#4eae1aff>+1725</color>'),(8000,346,'不屈',1,10,7,540,1000,'[{8,1730}]',52750,11000008,'韧性<color=#4eae1aff>+1730</color>'),(8000,347,'不屈',1,10,7,540,1000,'[{8,1735}]',52900,11000008,'韧性<color=#4eae1aff>+1735</color>'),(8000,348,'不屈',1,10,7,540,1000,'[{8,1740}]',53050,11000008,'韧性<color=#4eae1aff>+1740</color>'),(8000,349,'不屈',1,10,7,540,1000,'[{8,1745}]',53200,11000008,'韧性<color=#4eae1aff>+1745</color>'),(8000,350,'不屈',1,10,7,540,1000,'[{8,1750}]',53350,11000008,'韧性<color=#4eae1aff>+1750</color>'),(8000,351,'不屈',1,10,8,540,1000,'[{8,1755}]',53500,11000008,'韧性<color=#4eae1aff>+1755</color>'),(8000,352,'不屈',1,10,8,540,1000,'[{8,1760}]',53650,11000008,'韧性<color=#4eae1aff>+1760</color>'),(8000,353,'不屈',1,10,8,540,1000,'[{8,1765}]',53800,11000008,'韧性<color=#4eae1aff>+1765</color>'),(8000,354,'不屈',1,10,8,540,1000,'[{8,1770}]',53950,11000008,'韧性<color=#4eae1aff>+1770</color>'),(8000,355,'不屈',1,10,8,540,1000,'[{8,1775}]',54100,11000008,'韧性<color=#4eae1aff>+1775</color>'),(8000,356,'不屈',1,10,8,540,1000,'[{8,1780}]',54250,11000008,'韧性<color=#4eae1aff>+1780</color>'),(8000,357,'不屈',1,10,8,540,1000,'[{8,1785}]',54400,11000008,'韧性<color=#4eae1aff>+1785</color>'),(8000,358,'不屈',1,10,8,540,1000,'[{8,1790}]',54550,11000008,'韧性<color=#4eae1aff>+1790</color>'),(8000,359,'不屈',1,10,8,540,1000,'[{8,1795}]',54700,11000008,'韧性<color=#4eae1aff>+1795</color>'),(8000,360,'不屈',1,10,8,540,1000,'[{8,1800}]',54850,11000008,'韧性<color=#4eae1aff>+1800</color>'),(8000,361,'不屈',1,10,8,540,1000,'[{8,1805}]',55000,11000008,'韧性<color=#4eae1aff>+1805</color>'),(8000,362,'不屈',1,10,8,540,1000,'[{8,1810}]',55150,11000008,'韧性<color=#4eae1aff>+1810</color>'),(8000,363,'不屈',1,10,8,540,1000,'[{8,1815}]',55300,11000008,'韧性<color=#4eae1aff>+1815</color>'),(8000,364,'不屈',1,10,8,540,1000,'[{8,1820}]',55450,11000008,'韧性<color=#4eae1aff>+1820</color>'),(8000,365,'不屈',1,10,8,540,1000,'[{8,1825}]',55600,11000008,'韧性<color=#4eae1aff>+1825</color>'),(8000,366,'不屈',1,10,8,540,1000,'[{8,1830}]',55750,11000008,'韧性<color=#4eae1aff>+1830</color>'),(8000,367,'不屈',1,10,8,540,1000,'[{8,1835}]',55900,11000008,'韧性<color=#4eae1aff>+1835</color>'),(8000,368,'不屈',1,10,8,540,1000,'[{8,1840}]',56050,11000008,'韧性<color=#4eae1aff>+1840</color>'),(8000,369,'不屈',1,10,8,540,1000,'[{8,1845}]',56200,11000008,'韧性<color=#4eae1aff>+1845</color>'),(8000,370,'不屈',1,10,8,540,1000,'[{8,1850}]',56350,11000008,'韧性<color=#4eae1aff>+1850</color>'),(8000,371,'不屈',1,10,8,540,1000,'[{8,1855}]',56500,11000008,'韧性<color=#4eae1aff>+1855</color>'),(8000,372,'不屈',1,10,8,540,1000,'[{8,1860}]',56650,11000008,'韧性<color=#4eae1aff>+1860</color>'),(8000,373,'不屈',1,10,8,540,1000,'[{8,1865}]',56800,11000008,'韧性<color=#4eae1aff>+1865</color>'),(8000,374,'不屈',1,10,8,540,1000,'[{8,1870}]',56950,11000008,'韧性<color=#4eae1aff>+1870</color>'),(8000,375,'不屈',1,10,8,540,1000,'[{8,1875}]',57100,11000008,'韧性<color=#4eae1aff>+1875</color>'),(8000,376,'不屈',1,10,8,540,1000,'[{8,1880}]',57250,11000008,'韧性<color=#4eae1aff>+1880</color>'),(8000,377,'不屈',1,10,8,540,1000,'[{8,1885}]',57400,11000008,'韧性<color=#4eae1aff>+1885</color>'),(8000,378,'不屈',1,10,8,540,1000,'[{8,1890}]',57550,11000008,'韧性<color=#4eae1aff>+1890</color>'),(8000,379,'不屈',1,10,8,540,1000,'[{8,1895}]',57700,11000008,'韧性<color=#4eae1aff>+1895</color>'),(8000,380,'不屈',1,10,8,540,1000,'[{8,1900}]',57850,11000008,'韧性<color=#4eae1aff>+1900</color>'),(8000,381,'不屈',1,10,8,540,1000,'[{8,1905}]',58000,11000008,'韧性<color=#4eae1aff>+1905</color>'),(8000,382,'不屈',1,10,8,540,1000,'[{8,1910}]',58150,11000008,'韧性<color=#4eae1aff>+1910</color>'),(8000,383,'不屈',1,10,8,540,1000,'[{8,1915}]',58300,11000008,'韧性<color=#4eae1aff>+1915</color>'),(8000,384,'不屈',1,10,8,540,1000,'[{8,1920}]',58450,11000008,'韧性<color=#4eae1aff>+1920</color>'),(8000,385,'不屈',1,10,8,540,1000,'[{8,1925}]',58600,11000008,'韧性<color=#4eae1aff>+1925</color>'),(8000,386,'不屈',1,10,8,540,1000,'[{8,1930}]',58750,11000008,'韧性<color=#4eae1aff>+1930</color>'),(8000,387,'不屈',1,10,8,540,1000,'[{8,1935}]',58900,11000008,'韧性<color=#4eae1aff>+1935</color>'),(8000,388,'不屈',1,10,8,540,1000,'[{8,1940}]',59050,11000008,'韧性<color=#4eae1aff>+1940</color>'),(8000,389,'不屈',1,10,8,540,1000,'[{8,1945}]',59200,11000008,'韧性<color=#4eae1aff>+1945</color>'),(8000,390,'不屈',1,10,8,540,1000,'[{8,1950}]',59350,11000008,'韧性<color=#4eae1aff>+1950</color>'),(8000,391,'不屈',1,10,8,540,1000,'[{8,1955}]',59500,11000008,'韧性<color=#4eae1aff>+1955</color>'),(8000,392,'不屈',1,10,8,540,1000,'[{8,1960}]',59650,11000008,'韧性<color=#4eae1aff>+1960</color>'),(8000,393,'不屈',1,10,8,540,1000,'[{8,1965}]',59800,11000008,'韧性<color=#4eae1aff>+1965</color>'),(8000,394,'不屈',1,10,8,540,1000,'[{8,1970}]',59950,11000008,'韧性<color=#4eae1aff>+1970</color>'),(8000,395,'不屈',1,10,8,540,1000,'[{8,1975}]',60100,11000008,'韧性<color=#4eae1aff>+1975</color>'),(8000,396,'不屈',1,10,8,540,1000,'[{8,1980}]',60250,11000008,'韧性<color=#4eae1aff>+1980</color>'),(8000,397,'不屈',1,10,8,540,1000,'[{8,1985}]',60400,11000008,'韧性<color=#4eae1aff>+1985</color>'),(8000,398,'不屈',1,10,8,540,1000,'[{8,1990}]',60550,11000008,'韧性<color=#4eae1aff>+1990</color>'),(8000,399,'不屈',1,10,8,540,1000,'[{8,1995}]',60700,11000008,'韧性<color=#4eae1aff>+1995</color>'),(8000,400,'不屈',1,10,8,540,1000,'[{8,2000}]',60850,11000008,'韧性<color=#4eae1aff>+2000</color>'),(8000,401,'不屈',1,10,9,540,1000,'[{8,2005}]',61000,11000008,'韧性<color=#4eae1aff>+2005</color>'),(8000,402,'不屈',1,10,9,540,1000,'[{8,2010}]',61150,11000008,'韧性<color=#4eae1aff>+2010</color>'),(8000,403,'不屈',1,10,9,540,1000,'[{8,2015}]',61300,11000008,'韧性<color=#4eae1aff>+2015</color>'),(8000,404,'不屈',1,10,9,540,1000,'[{8,2020}]',61450,11000008,'韧性<color=#4eae1aff>+2020</color>'),(8000,405,'不屈',1,10,9,540,1000,'[{8,2025}]',61600,11000008,'韧性<color=#4eae1aff>+2025</color>'),(8000,406,'不屈',1,10,9,540,1000,'[{8,2030}]',61750,11000008,'韧性<color=#4eae1aff>+2030</color>'),(8000,407,'不屈',1,10,9,540,1000,'[{8,2035}]',61900,11000008,'韧性<color=#4eae1aff>+2035</color>'),(8000,408,'不屈',1,10,9,540,1000,'[{8,2040}]',62050,11000008,'韧性<color=#4eae1aff>+2040</color>'),(8000,409,'不屈',1,10,9,540,1000,'[{8,2045}]',62200,11000008,'韧性<color=#4eae1aff>+2045</color>'),(8000,410,'不屈',1,10,9,540,1000,'[{8,2050}]',62350,11000008,'韧性<color=#4eae1aff>+2050</color>'),(8000,411,'不屈',1,10,9,540,1000,'[{8,2055}]',62500,11000008,'韧性<color=#4eae1aff>+2055</color>'),(8000,412,'不屈',1,10,9,540,1000,'[{8,2060}]',62650,11000008,'韧性<color=#4eae1aff>+2060</color>'),(8000,413,'不屈',1,10,9,540,1000,'[{8,2065}]',62800,11000008,'韧性<color=#4eae1aff>+2065</color>'),(8000,414,'不屈',1,10,9,540,1000,'[{8,2070}]',62950,11000008,'韧性<color=#4eae1aff>+2070</color>'),(8000,415,'不屈',1,10,9,540,1000,'[{8,2075}]',63100,11000008,'韧性<color=#4eae1aff>+2075</color>'),(8000,416,'不屈',1,10,9,540,1000,'[{8,2080}]',63250,11000008,'韧性<color=#4eae1aff>+2080</color>'),(8000,417,'不屈',1,10,9,540,1000,'[{8,2085}]',63400,11000008,'韧性<color=#4eae1aff>+2085</color>'),(8000,418,'不屈',1,10,9,540,1000,'[{8,2090}]',63550,11000008,'韧性<color=#4eae1aff>+2090</color>'),(8000,419,'不屈',1,10,9,540,1000,'[{8,2095}]',63700,11000008,'韧性<color=#4eae1aff>+2095</color>'),(8000,420,'不屈',1,10,9,540,1000,'[{8,2100}]',63850,11000008,'韧性<color=#4eae1aff>+2100</color>'),(8000,421,'不屈',1,10,9,540,1000,'[{8,2105}]',64000,11000008,'韧性<color=#4eae1aff>+2105</color>'),(8000,422,'不屈',1,10,9,540,1000,'[{8,2110}]',64150,11000008,'韧性<color=#4eae1aff>+2110</color>'),(8000,423,'不屈',1,10,9,540,1000,'[{8,2115}]',64300,11000008,'韧性<color=#4eae1aff>+2115</color>'),(8000,424,'不屈',1,10,9,540,1000,'[{8,2120}]',64450,11000008,'韧性<color=#4eae1aff>+2120</color>'),(8000,425,'不屈',1,10,9,540,1000,'[{8,2125}]',64600,11000008,'韧性<color=#4eae1aff>+2125</color>'),(8000,426,'不屈',1,10,9,540,1000,'[{8,2130}]',64750,11000008,'韧性<color=#4eae1aff>+2130</color>'),(8000,427,'不屈',1,10,9,540,1000,'[{8,2135}]',64900,11000008,'韧性<color=#4eae1aff>+2135</color>'),(8000,428,'不屈',1,10,9,540,1000,'[{8,2140}]',65050,11000008,'韧性<color=#4eae1aff>+2140</color>'),(8000,429,'不屈',1,10,9,540,1000,'[{8,2145}]',65200,11000008,'韧性<color=#4eae1aff>+2145</color>'),(8000,430,'不屈',1,10,9,540,1000,'[{8,2150}]',65350,11000008,'韧性<color=#4eae1aff>+2150</color>'),(8000,431,'不屈',1,10,9,540,1000,'[{8,2155}]',65500,11000008,'韧性<color=#4eae1aff>+2155</color>'),(8000,432,'不屈',1,10,9,540,1000,'[{8,2160}]',65650,11000008,'韧性<color=#4eae1aff>+2160</color>'),(8000,433,'不屈',1,10,9,540,1000,'[{8,2165}]',65800,11000008,'韧性<color=#4eae1aff>+2165</color>'),(8000,434,'不屈',1,10,9,540,1000,'[{8,2170}]',65950,11000008,'韧性<color=#4eae1aff>+2170</color>'),(8000,435,'不屈',1,10,9,540,1000,'[{8,2175}]',66100,11000008,'韧性<color=#4eae1aff>+2175</color>'),(8000,436,'不屈',1,10,9,540,1000,'[{8,2180}]',66250,11000008,'韧性<color=#4eae1aff>+2180</color>'),(8000,437,'不屈',1,10,9,540,1000,'[{8,2185}]',66400,11000008,'韧性<color=#4eae1aff>+2185</color>'),(8000,438,'不屈',1,10,9,540,1000,'[{8,2190}]',66550,11000008,'韧性<color=#4eae1aff>+2190</color>'),(8000,439,'不屈',1,10,9,540,1000,'[{8,2195}]',66700,11000008,'韧性<color=#4eae1aff>+2195</color>'),(8000,440,'不屈',1,10,9,540,1000,'[{8,2200}]',66850,11000008,'韧性<color=#4eae1aff>+2200</color>'),(8000,441,'不屈',1,10,9,540,1000,'[{8,2205}]',67000,11000008,'韧性<color=#4eae1aff>+2205</color>'),(8000,442,'不屈',1,10,9,540,1000,'[{8,2210}]',67150,11000008,'韧性<color=#4eae1aff>+2210</color>'),(8000,443,'不屈',1,10,9,540,1000,'[{8,2215}]',67300,11000008,'韧性<color=#4eae1aff>+2215</color>'),(8000,444,'不屈',1,10,9,540,1000,'[{8,2220}]',67450,11000008,'韧性<color=#4eae1aff>+2220</color>'),(8000,445,'不屈',1,10,9,540,1000,'[{8,2225}]',67600,11000008,'韧性<color=#4eae1aff>+2225</color>'),(8000,446,'不屈',1,10,9,540,1000,'[{8,2230}]',67750,11000008,'韧性<color=#4eae1aff>+2230</color>'),(8000,447,'不屈',1,10,9,540,1000,'[{8,2235}]',67900,11000008,'韧性<color=#4eae1aff>+2235</color>'),(8000,448,'不屈',1,10,9,540,1000,'[{8,2240}]',68050,11000008,'韧性<color=#4eae1aff>+2240</color>'),(8000,449,'不屈',1,10,9,540,1000,'[{8,2245}]',68200,11000008,'韧性<color=#4eae1aff>+2245</color>'),(8000,450,'不屈',1,10,9,540,1000,'[{8,2250}]',68350,11000008,'韧性<color=#4eae1aff>+2250</color>'),(8000,451,'不屈',1,10,10,540,1000,'[{8,2255}]',68500,11000008,'韧性<color=#4eae1aff>+2255</color>'),(8000,452,'不屈',1,10,10,540,1000,'[{8,2260}]',68650,11000008,'韧性<color=#4eae1aff>+2260</color>'),(8000,453,'不屈',1,10,10,540,1000,'[{8,2265}]',68800,11000008,'韧性<color=#4eae1aff>+2265</color>'),(8000,454,'不屈',1,10,10,540,1000,'[{8,2270}]',68950,11000008,'韧性<color=#4eae1aff>+2270</color>'),(8000,455,'不屈',1,10,10,540,1000,'[{8,2275}]',69100,11000008,'韧性<color=#4eae1aff>+2275</color>'),(8000,456,'不屈',1,10,10,540,1000,'[{8,2280}]',69250,11000008,'韧性<color=#4eae1aff>+2280</color>'),(8000,457,'不屈',1,10,10,540,1000,'[{8,2285}]',69400,11000008,'韧性<color=#4eae1aff>+2285</color>'),(8000,458,'不屈',1,10,10,540,1000,'[{8,2290}]',69550,11000008,'韧性<color=#4eae1aff>+2290</color>'),(8000,459,'不屈',1,10,10,540,1000,'[{8,2295}]',69700,11000008,'韧性<color=#4eae1aff>+2295</color>'),(8000,460,'不屈',1,10,10,540,1000,'[{8,2300}]',69850,11000008,'韧性<color=#4eae1aff>+2300</color>'),(8000,461,'不屈',1,10,10,540,1000,'[{8,2305}]',70000,11000008,'韧性<color=#4eae1aff>+2305</color>'),(8000,462,'不屈',1,10,10,540,1000,'[{8,2310}]',70150,11000008,'韧性<color=#4eae1aff>+2310</color>'),(8000,463,'不屈',1,10,10,540,1000,'[{8,2315}]',70300,11000008,'韧性<color=#4eae1aff>+2315</color>'),(8000,464,'不屈',1,10,10,540,1000,'[{8,2320}]',70450,11000008,'韧性<color=#4eae1aff>+2320</color>'),(8000,465,'不屈',1,10,10,540,1000,'[{8,2325}]',70600,11000008,'韧性<color=#4eae1aff>+2325</color>'),(8000,466,'不屈',1,10,10,540,1000,'[{8,2330}]',70750,11000008,'韧性<color=#4eae1aff>+2330</color>'),(8000,467,'不屈',1,10,10,540,1000,'[{8,2335}]',70900,11000008,'韧性<color=#4eae1aff>+2335</color>'),(8000,468,'不屈',1,10,10,540,1000,'[{8,2340}]',71050,11000008,'韧性<color=#4eae1aff>+2340</color>'),(8000,469,'不屈',1,10,10,540,1000,'[{8,2345}]',71200,11000008,'韧性<color=#4eae1aff>+2345</color>'),(8000,470,'不屈',1,10,10,540,1000,'[{8,2350}]',71350,11000008,'韧性<color=#4eae1aff>+2350</color>'),(8000,471,'不屈',1,10,10,540,1000,'[{8,2355}]',71500,11000008,'韧性<color=#4eae1aff>+2355</color>'),(8000,472,'不屈',1,10,10,540,1000,'[{8,2360}]',71650,11000008,'韧性<color=#4eae1aff>+2360</color>'),(8000,473,'不屈',1,10,10,540,1000,'[{8,2365}]',71800,11000008,'韧性<color=#4eae1aff>+2365</color>'),(8000,474,'不屈',1,10,10,540,1000,'[{8,2370}]',71950,11000008,'韧性<color=#4eae1aff>+2370</color>'),(8000,475,'不屈',1,10,10,540,1000,'[{8,2375}]',72100,11000008,'韧性<color=#4eae1aff>+2375</color>'),(8000,476,'不屈',1,10,10,540,1000,'[{8,2380}]',72250,11000008,'韧性<color=#4eae1aff>+2380</color>'),(8000,477,'不屈',1,10,10,540,1000,'[{8,2385}]',72400,11000008,'韧性<color=#4eae1aff>+2385</color>'),(8000,478,'不屈',1,10,10,540,1000,'[{8,2390}]',72550,11000008,'韧性<color=#4eae1aff>+2390</color>'),(8000,479,'不屈',1,10,10,540,1000,'[{8,2395}]',72700,11000008,'韧性<color=#4eae1aff>+2395</color>'),(8000,480,'不屈',1,10,10,540,1000,'[{8,2400}]',72850,11000008,'韧性<color=#4eae1aff>+2400</color>'),(8000,481,'不屈',1,10,10,540,1000,'[{8,2405}]',73000,11000008,'韧性<color=#4eae1aff>+2405</color>'),(8000,482,'不屈',1,10,10,540,1000,'[{8,2410}]',73150,11000008,'韧性<color=#4eae1aff>+2410</color>'),(8000,483,'不屈',1,10,10,540,1000,'[{8,2415}]',73300,11000008,'韧性<color=#4eae1aff>+2415</color>'),(8000,484,'不屈',1,10,10,540,1000,'[{8,2420}]',73450,11000008,'韧性<color=#4eae1aff>+2420</color>'),(8000,485,'不屈',1,10,10,540,1000,'[{8,2425}]',73600,11000008,'韧性<color=#4eae1aff>+2425</color>'),(8000,486,'不屈',1,10,10,540,1000,'[{8,2430}]',73750,11000008,'韧性<color=#4eae1aff>+2430</color>'),(8000,487,'不屈',1,10,10,540,1000,'[{8,2435}]',73900,11000008,'韧性<color=#4eae1aff>+2435</color>'),(8000,488,'不屈',1,10,10,540,1000,'[{8,2440}]',74050,11000008,'韧性<color=#4eae1aff>+2440</color>'),(8000,489,'不屈',1,10,10,540,1000,'[{8,2445}]',74200,11000008,'韧性<color=#4eae1aff>+2445</color>'),(8000,490,'不屈',1,10,10,540,1000,'[{8,2450}]',74350,11000008,'韧性<color=#4eae1aff>+2450</color>'),(8000,491,'不屈',1,10,10,540,1000,'[{8,2455}]',74500,11000008,'韧性<color=#4eae1aff>+2455</color>'),(8000,492,'不屈',1,10,10,540,1000,'[{8,2460}]',74650,11000008,'韧性<color=#4eae1aff>+2460</color>'),(8000,493,'不屈',1,10,10,540,1000,'[{8,2465}]',74800,11000008,'韧性<color=#4eae1aff>+2465</color>'),(8000,494,'不屈',1,10,10,540,1000,'[{8,2470}]',74950,11000008,'韧性<color=#4eae1aff>+2470</color>'),(8000,495,'不屈',1,10,10,540,1000,'[{8,2475}]',75100,11000008,'韧性<color=#4eae1aff>+2475</color>'),(8000,496,'不屈',1,10,10,540,1000,'[{8,2480}]',75250,11000008,'韧性<color=#4eae1aff>+2480</color>'),(8000,497,'不屈',1,10,10,540,1000,'[{8,2485}]',75400,11000008,'韧性<color=#4eae1aff>+2485</color>'),(8000,498,'不屈',1,10,10,540,1000,'[{8,2490}]',75550,11000008,'韧性<color=#4eae1aff>+2490</color>'),(8000,499,'不屈',1,10,10,540,1000,'[{8,2495}]',75700,11000008,'韧性<color=#4eae1aff>+2495</color>'),(8000,500,'不屈',1,10,10,540,1000,'[{8,2500}]',75850,11000008,'韧性<color=#4eae1aff>+2500</color>');
/*!40000 ALTER TABLE `base_gang_skill` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_gang_skill_building`
--

DROP TABLE IF EXISTS `base_gang_skill_building`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_gang_skill_building` (
  `build_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能建筑等级',
  `attr_ratio` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '属性加成比例',
  PRIMARY KEY (`build_lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_gang_skill_building`
--

LOCK TABLES `base_gang_skill_building` WRITE;
/*!40000 ALTER TABLE `base_gang_skill_building` DISABLE KEYS */;
INSERT INTO `base_gang_skill_building` VALUES (1,0),(2,5),(3,10),(4,16),(5,24),(6,32),(7,40),(8,50),(9,60),(10,75);
/*!40000 ALTER TABLE `base_gang_skill_building` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_gang_store`
--

DROP TABLE IF EXISTS `base_gang_store`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_gang_store` (
  `grade` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '品阶',
  `star` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '星级',
  `color` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '品质',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  PRIMARY KEY (`grade`,`star`,`color`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_gang_store`
--

LOCK TABLES `base_gang_store` WRITE;
/*!40000 ALTER TABLE `base_gang_store` DISABLE KEYS */;
INSERT INTO `base_gang_store` VALUES (1,0,0,40),(1,0,1,53),(1,0,2,80),(1,1,3,118),(1,1,4,183),(1,2,3,146),(1,2,4,239),(1,3,4,300),(1,3,5,512),(1,3,6,760),(2,0,0,68),(2,0,1,90),(2,0,2,136),(2,1,3,200),(2,1,4,311),(2,2,3,249),(2,2,4,407),(2,3,4,510),(2,3,5,870),(2,3,6,1292),(3,0,0,160),(3,0,1,213),(3,0,2,320),(3,1,3,470),(3,1,4,733),(3,2,3,586),(3,2,4,957),(3,3,4,1200),(3,3,5,2048),(3,3,6,3040),(4,0,0,240),(4,0,1,319),(4,0,2,480),(4,1,3,706),(4,1,4,1099),(4,2,3,878),(4,2,4,1435),(4,3,4,1800),(4,3,5,3072),(4,3,6,4560),(5,0,0,400),(5,0,1,532),(5,0,2,800),(5,1,3,1176),(5,1,4,1832),(5,2,3,1464),(5,2,4,2392),(5,3,4,3000),(5,3,5,5120),(5,3,6,7600),(6,0,0,560),(6,0,1,745),(6,0,2,1120),(6,1,3,1646),(6,1,4,2565),(6,2,3,2050),(6,2,4,3349),(6,3,4,4200),(6,3,5,7168),(6,3,6,10640),(7,0,0,800),(7,0,1,1064),(7,0,2,1600),(7,1,3,2352),(7,1,4,3664),(7,2,3,2928),(7,2,4,4784),(7,3,4,6000),(7,3,5,10240),(7,3,6,15200),(8,0,0,1040),(8,0,1,1383),(8,0,2,2080),(8,1,3,3058),(8,1,4,4763),(8,2,3,3806),(8,2,4,6219),(8,3,4,7800),(8,3,5,13312),(8,3,6,19760),(9,0,0,1360),(9,0,1,1809),(9,0,2,2720),(9,1,3,3998),(9,1,4,6229),(9,2,3,4978),(9,2,4,8133),(9,3,4,10200),(9,3,5,17408),(9,3,6,25840),(10,0,0,1680),(10,0,1,2234),(10,0,2,3360),(10,1,3,4939),(10,1,4,7694),(10,2,3,6149),(10,2,4,10046),(10,3,4,12600),(10,3,5,21504),(10,3,6,31920),(11,0,0,2160),(11,0,1,2873),(11,0,2,4320),(11,1,3,6350),(11,1,4,9893),(11,2,3,7906),(11,2,4,12917),(11,3,4,16200),(11,3,5,27648),(11,3,6,41040),(12,0,0,2640),(12,0,1,3511),(12,0,2,5280),(12,1,3,7762),(12,1,4,12091),(12,2,3,9662),(12,2,4,15787),(12,3,4,19800),(12,3,5,33792),(12,3,6,50160),(13,0,0,3120),(13,0,1,4150),(13,0,2,6240),(13,1,3,9173),(13,1,4,14290),(13,2,3,11419),(13,2,4,18658),(13,3,4,23400),(13,3,5,39936),(13,3,6,59280),(14,0,0,3600),(14,0,1,4788),(14,0,2,7200),(14,1,3,10584),(14,1,4,16488),(14,2,3,13176),(14,2,4,21528),(14,3,4,27000),(14,3,5,46080),(14,3,6,68400),(15,0,0,4080),(15,0,1,5426),(15,0,2,8160),(15,1,3,11995),(15,1,4,18686),(15,2,3,14933),(15,2,4,24398),(15,3,4,30600),(15,3,5,52224),(15,3,6,77520),(16,0,0,4560),(16,0,1,6064),(16,0,2,9120),(16,1,3,13406),(16,1,4,20884),(16,2,3,16690),(16,2,4,27268),(16,3,4,34200),(16,3,5,58368),(16,3,6,86640);
/*!40000 ALTER TABLE `base_gang_store` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_gang_store_building`
--

DROP TABLE IF EXISTS `base_gang_store_building`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_gang_store_building` (
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '仓库等级',
  `cell` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '格子数',
  PRIMARY KEY (`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_gang_store_building`
--

LOCK TABLES `base_gang_store_building` WRITE;
/*!40000 ALTER TABLE `base_gang_store_building` DISABLE KEYS */;
INSERT INTO `base_gang_store_building` VALUES (1,90),(2,100),(3,110),(4,115),(5,120),(6,130),(7,135),(8,140),(9,145),(10,150);
/*!40000 ALTER TABLE `base_gang_store_building` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_gang_task_building`
--

DROP TABLE IF EXISTS `base_gang_task_building`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_gang_task_building` (
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `ratio` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '加成百分比',
  PRIMARY KEY (`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_gang_task_building`
--

LOCK TABLES `base_gang_task_building` WRITE;
/*!40000 ALTER TABLE `base_gang_task_building` DISABLE KEYS */;
INSERT INTO `base_gang_task_building` VALUES (1,0),(2,10),(3,20),(4,30),(5,40),(6,50),(7,60),(8,70),(9,80),(10,90);
/*!40000 ALTER TABLE `base_gang_task_building` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_gift_box`
--

DROP TABLE IF EXISTS `base_gift_box`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_gift_box` (
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '礼包物品ID',
  `get_way` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '领取方式，1礼包放在背包，2直接领取礼包内物品',
  `bind` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '绑定状态##0非绑定，1绑定',
  `condition` varchar(2000) NOT NULL DEFAULT '[]' COMMENT '条件',
  `start_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开始时间，0为不限',
  `end_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '结束时间，0为不限',
  `filter` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '筛选内容',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '状态，0为不生效，1为生效',
  `show` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否显示礼包领取界面',
  PRIMARY KEY (`goods_id`),
  KEY `status` (`status`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='礼包配置表(新)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_gift_box`
--

LOCK TABLES `base_gift_box` WRITE;
/*!40000 ALTER TABLE `base_gift_box` DISABLE KEYS */;
INSERT INTO `base_gift_box` VALUES (32000000,1,1,'[]',0,0,'[lv]',1,1),(32000011,1,1,'[]',0,0,'[lv]',1,1),(32000012,1,1,'[]',0,0,'[lv]',1,1),(32000013,1,1,'[]',0,0,'[lv]',1,1),(32000021,1,1,'[]',0,0,'[lv]',1,1),(32000022,1,1,'[]',0,0,'[lv]',1,1),(32000023,1,1,'[]',0,0,'[lv]',1,1),(32000024,1,1,'[]',0,0,'[lv]',1,1),(32000025,1,1,'[]',0,0,'[lv]',1,1),(32000026,1,1,'[]',0,0,'[lv]',1,1),(32000027,1,1,'[]',0,0,'[lv]',1,1),(32000028,1,1,'[]',0,0,'[lv]',1,1),(32000029,1,1,'[]',0,0,'[lv,career]',1,1),(32000030,1,1,'[]',0,0,'[lv,career]',1,1),(32000031,1,1,'[]',0,0,'[lv,career]',1,1),(32000032,1,1,'[]',0,0,'[lv,career]',1,1),(32000033,1,1,'[]',0,0,'[lv,career]',1,1),(32000034,1,1,'[]',0,0,'[lv,career]',1,1),(32000035,1,1,'[]',0,0,'[lv,career]',1,1),(32000036,1,1,'[]',0,0,'[lv,career]',1,1),(32000037,1,1,'[]',0,0,'[lv,career]',1,1),(32000038,1,1,'[]',0,0,'[lv,career]',1,1),(32000039,1,1,'[]',0,0,'[lv,career]',1,1),(32000040,1,1,'[]',0,0,'[lv,career]',1,1),(32000041,1,1,'[]',0,0,'[lv,career]',1,1),(32010001,1,1,'[]',0,0,'[lv]',1,1),(32010003,1,1,'[]',0,0,'[lv]',1,1),(32010004,1,0,'[]',0,0,'[lv]',1,1),(32010006,1,1,'[]',0,0,'[lv]',1,1),(32010015,1,1,'[]',0,0,'[lv]',1,1),(32010016,1,1,'[]',0,0,'[lv]',1,0),(32010031,1,1,'[]',0,0,'[lv]',1,0),(32010032,1,1,'[]',0,0,'[lv]',1,0),(32010033,1,1,'[]',0,0,'[lv]',1,0),(32010034,1,1,'[]',0,0,'[lv]',1,0),(32010035,1,1,'[]',0,0,'[lv]',1,0),(32010036,1,1,'[]',0,0,'[lv]',1,0),(32010037,1,1,'[]',0,0,'[lv]',1,0),(32010038,1,1,'[]',0,0,'[lv]',1,0),(32010041,1,1,'[]',0,0,'[lv]',1,0),(32010042,1,1,'[]',0,0,'[lv]',1,0),(32010043,1,1,'[]',0,0,'[lv]',1,0),(32010044,1,1,'[]',0,0,'[lv]',1,0),(32010045,1,1,'[]',0,0,'[lv]',1,0),(32010046,1,1,'[]',0,0,'[lv]',1,0),(32010047,1,1,'[]',0,0,'[lv]',1,0),(32010048,1,1,'[]',0,0,'[lv]',1,1),(32010052,1,1,'[]',0,0,'[lv]',1,1),(32010053,1,1,'[]',0,0,'[lv]',1,1),(32010054,1,1,'[]',0,0,'[lv]',1,1),(32010057,1,1,'[]',0,0,'[lv]',1,1),(32010067,1,1,'[]',0,0,'[lv]',1,1),(32020111,1,1,'[]',0,0,'[career]',1,1),(32020112,1,1,'[]',0,0,'[career]',1,1),(32020113,1,1,'[]',0,0,'[career]',1,1),(32020114,1,1,'[]',0,0,'[]',1,1),(32020121,1,1,'[]',0,0,'[career]',1,1),(32020122,1,1,'[]',0,0,'[career]',1,1),(32020123,1,1,'[]',0,0,'[career]',1,1),(32020124,1,1,'[]',0,0,'[]',1,1),(32030101,1,1,'[]',0,0,'[]',1,1),(32030102,1,1,'[]',0,0,'[]',1,1),(32030103,1,1,'[]',0,0,'[]',1,1),(32030201,1,1,'[]',0,0,'[]',1,1),(32030202,1,1,'[]',0,0,'[]',1,1),(32030203,1,1,'[]',0,0,'[]',1,1),(32030301,1,1,'[]',0,0,'[]',1,1),(32030302,1,1,'[]',0,0,'[]',1,1),(32030303,1,1,'[]',0,0,'[]',1,1),(32030401,1,1,'[]',0,0,'[]',1,1),(32030402,1,1,'[]',0,0,'[]',1,1),(32030403,1,1,'[]',0,0,'[]',1,1),(32030501,1,1,'[]',0,0,'[]',1,1),(32030502,1,1,'[]',0,0,'[]',1,1),(32030503,1,1,'[]',0,0,'[]',1,1),(32030601,1,1,'[]',0,0,'[]',1,1),(32030602,1,1,'[]',0,0,'[]',1,1),(32030603,1,1,'[]',0,0,'[]',1,1),(32030701,1,1,'[]',0,0,'[]',1,1),(32030702,1,1,'[]',0,0,'[]',1,1),(32030703,1,1,'[]',0,0,'[]',1,1),(32030801,1,1,'[]',0,0,'[]',1,1),(32030802,1,1,'[]',0,0,'[]',1,1),(32030803,1,1,'[]',0,0,'[]',1,1),(32030901,1,1,'[]',0,0,'[]',1,1),(32030902,1,1,'[]',0,0,'[]',1,1),(32030903,1,1,'[]',0,0,'[]',1,1),(32040001,1,1,'[]',0,0,'[lv]',1,1),(32040002,1,1,'[]',0,0,'[lv]',1,1),(32040003,1,1,'[]',0,0,'[lv]',1,1),(32040004,1,1,'[]',0,0,'[lv]',1,1),(32040005,1,1,'[]',0,0,'[lv]',1,1),(32040006,1,1,'[]',0,0,'[lv]',1,1),(32040007,1,1,'[]',0,0,'[lv]',1,1),(32040008,1,1,'[]',0,0,'[lv]',1,1),(32040009,1,1,'[]',0,0,'[lv]',1,1),(32040010,1,1,'[]',0,0,'[lv]',1,1),(32040011,1,1,'[]',0,0,'[lv]',1,1),(32040012,1,1,'[]',0,0,'[lv]',1,1),(32040013,1,1,'[]',0,0,'[lv]',1,1),(32040014,1,1,'[]',0,0,'[lv]',1,1),(32040015,1,1,'[]',0,0,'[lv]',1,1),(32040016,1,1,'[]',0,0,'[lv]',1,1),(32040017,1,1,'[]',0,0,'[lv]',1,1),(32040101,1,1,'[]',0,0,'[lv]',1,1),(32040102,1,1,'[]',0,0,'[lv]',1,1),(32040103,1,1,'[]',0,0,'[lv]',1,1),(32040104,1,1,'[]',0,0,'[lv]',1,1),(32040201,1,1,'[]',0,0,'[lv]',1,1),(32040202,1,1,'[]',0,0,'[lv]',1,1),(32040203,1,1,'[]',0,0,'[lv]',1,1),(32040204,1,1,'[]',0,0,'[lv]',1,1),(32040301,1,1,'[]',0,0,'[lv]',1,1),(32040302,1,1,'[]',0,0,'[lv]',1,1),(32040401,1,1,'[]',0,0,'[lv]',1,1),(32040402,1,1,'[]',0,0,'[lv]',1,1),(32040501,1,1,'[]',0,0,'[lv]',1,1),(32040502,1,1,'[]',0,0,'[lv]',1,1),(32040503,1,1,'[]',0,0,'[lv]',1,1),(32040601,1,1,'[]',0,0,'[lv]',1,1),(32040602,1,1,'[]',0,0,'[lv]',1,1),(32040701,1,1,'[]',0,0,'[lv]',1,1),(32040702,1,1,'[]',0,0,'[lv]',1,1),(32040801,1,1,'[]',0,0,'[lv]',1,1),(32040802,1,1,'[]',0,0,'[lv]',1,1),(32040901,1,1,'[]',0,0,'[lv]',1,1),(32040902,1,1,'[]',0,0,'[lv]',1,1),(32040903,1,1,'[]',0,0,'[lv]',1,1),(32041001,1,1,'[]',0,0,'[lv]',1,1),(32041002,1,1,'[]',0,0,'[lv]',1,1),(32041101,1,1,'[]',0,0,'[lv]',1,1),(32041102,1,1,'[]',0,0,'[lv]',1,1),(32041201,1,1,'[]',0,0,'[lv]',1,1),(32041202,1,1,'[]',0,0,'[lv]',1,1),(32041301,1,1,'[]',0,0,'[lv]',1,1),(32041401,1,1,'[]',0,0,'[lv]',1,1),(32041501,1,1,'[]',0,0,'[lv]',1,1),(32041601,1,1,'[]',0,0,'[lv]',1,1),(32041701,1,1,'[]',0,0,'[lv]',1,1),(32050004,1,1,'[]',0,0,'[lv]',1,1),(32050005,1,1,'[]',0,0,'[lv]',1,1),(32050006,1,1,'[]',0,0,'[lv]',1,1),(32060002,1,1,'[]',0,0,'[lv]',1,1),(32060003,1,1,'[]',0,0,'[lv]',1,1),(32060004,1,1,'[]',0,0,'[lv]',1,1),(32070001,1,1,'[]',0,0,'[lv]',1,1),(32070003,1,1,'[]',0,0,'[lv]',1,1),(32080001,1,1,'[]',0,0,'[lv,career]',1,1),(32080002,1,1,'[]',0,0,'[lv,career]',1,1),(32080003,1,1,'[]',0,0,'[lv,career]',1,1),(32080004,1,1,'[]',0,0,'[lv,career]',1,1),(32080005,1,1,'[]',0,0,'[lv,career]',1,1),(32080006,1,1,'[]',0,0,'[lv,career]',1,1),(32080007,1,1,'[]',0,0,'[lv,career]',1,1),(32080008,1,1,'[]',0,0,'[lv,career]',1,1),(32080111,1,1,'[]',0,0,'[career]',1,1),(32080112,1,1,'[]',0,0,'[career]',1,1),(32080113,1,1,'[]',0,0,'[career]',1,1),(32080114,1,1,'[]',0,0,'[]',1,1),(32080115,1,1,'[]',0,0,'[career]',1,1),(32080116,1,1,'[]',0,0,'[career]',1,1),(32080117,1,1,'[]',0,0,'[career]',1,1),(32080118,1,1,'[]',0,0,'[]',1,1),(32080121,1,1,'[]',0,0,'[career]',1,1),(32080122,1,1,'[]',0,0,'[career]',1,1),(32080123,1,1,'[]',0,0,'[career]',1,1),(32080124,1,1,'[]',0,0,'[]',1,1),(32080125,1,1,'[]',0,0,'[career]',1,1),(32080126,1,1,'[]',0,0,'[career]',1,1),(32080127,1,1,'[]',0,0,'[career]',1,1),(32080128,1,1,'[]',0,0,'[]',1,1),(32080131,1,1,'[]',0,0,'[career]',1,1),(32080132,1,1,'[]',0,0,'[career]',1,1),(32080133,1,1,'[]',0,0,'[career]',1,1),(32080134,1,1,'[]',0,0,'[]',1,1),(32080135,1,1,'[]',0,0,'[career]',1,1),(32080136,1,1,'[]',0,0,'[career]',1,1),(32080137,1,1,'[]',0,0,'[career]',1,1),(32080138,1,1,'[]',0,0,'[]',1,1),(32080141,1,1,'[]',0,0,'[career]',1,1),(32080142,1,1,'[]',0,0,'[career]',1,1),(32080143,1,1,'[]',0,0,'[career]',1,1),(32080144,1,1,'[]',0,0,'[]',1,1),(32080145,1,1,'[]',0,0,'[career]',1,1),(32080146,1,1,'[]',0,0,'[career]',1,1),(32080147,1,1,'[]',0,0,'[career]',1,1),(32080148,1,1,'[]',0,0,'[]',1,1),(32080151,1,1,'[]',0,0,'[career]',1,1),(32080152,1,1,'[]',0,0,'[career]',1,1),(32080153,1,1,'[]',0,0,'[career]',1,1),(32080154,1,1,'[]',0,0,'[]',1,1),(32080155,1,1,'[]',0,0,'[career]',1,1),(32080156,1,1,'[]',0,0,'[career]',1,1),(32080157,1,1,'[]',0,0,'[career]',1,1),(32080158,1,1,'[]',0,0,'[]',1,1),(32080161,1,1,'[]',0,0,'[career]',1,1),(32080162,1,1,'[]',0,0,'[career]',1,1),(32080163,1,1,'[]',0,0,'[career]',1,1),(32080164,1,1,'[]',0,0,'[]',1,1),(32080165,1,1,'[]',0,0,'[career]',1,1),(32080166,1,1,'[]',0,0,'[career]',1,1),(32080167,1,1,'[]',0,0,'[career]',1,1),(32080168,1,1,'[]',0,0,'[]',1,1),(32080171,1,1,'[]',0,0,'[career]',1,1),(32080172,1,1,'[]',0,0,'[career]',1,1),(32080173,1,1,'[]',0,0,'[career]',1,1),(32080174,1,1,'[]',0,0,'[]',1,1),(32080175,1,1,'[]',0,0,'[career]',1,1),(32080176,1,1,'[]',0,0,'[career]',1,1),(32080177,1,1,'[]',0,0,'[career]',1,1),(32080178,1,1,'[]',0,0,'[]',1,1),(32080181,1,1,'[]',0,0,'[career]',1,1),(32080182,1,1,'[]',0,0,'[career]',1,1),(32080183,1,1,'[]',0,0,'[career]',1,1),(32080184,1,1,'[]',0,0,'[]',1,1),(32080185,1,1,'[]',0,0,'[career]',1,1),(32080186,1,1,'[]',0,0,'[career]',1,1),(32080187,1,1,'[]',0,0,'[career]',1,1),(32080188,1,1,'[]',0,0,'[]',1,1),(32080191,1,1,'[]',0,0,'[career]',1,1),(32080192,1,1,'[]',0,0,'[career]',1,1),(32080193,1,1,'[]',0,0,'[career]',1,1),(32080194,1,1,'[]',0,0,'[]',1,1),(32080195,1,1,'[]',0,0,'[career]',1,1),(32080196,1,1,'[]',0,0,'[career]',1,1),(32080197,1,1,'[]',0,0,'[career]',1,1),(32080198,1,1,'[]',0,0,'[]',1,1),(32080201,1,1,'[]',0,0,'[career]',1,1),(32080202,1,1,'[]',0,0,'[career]',1,1),(32080203,1,1,'[]',0,0,'[career]',1,1),(32080204,1,1,'[]',0,0,'[]',1,1),(32080205,1,1,'[]',0,0,'[career]',1,1),(32080206,1,1,'[]',0,0,'[career]',1,1),(32080207,1,1,'[]',0,0,'[career]',1,1),(32080208,1,1,'[]',0,0,'[]',1,1),(32080211,1,1,'[]',0,0,'[career]',1,1),(32080212,1,1,'[]',0,0,'[career]',1,1),(32080213,1,1,'[]',0,0,'[career]',1,1),(32080214,1,1,'[]',0,0,'[]',1,1),(32080215,1,1,'[]',0,0,'[career]',1,1),(32080216,1,1,'[]',0,0,'[career]',1,1),(32080217,1,1,'[]',0,0,'[career]',1,1),(32080218,1,1,'[]',0,0,'[]',1,1),(32080221,1,1,'[]',0,0,'[career]',1,1),(32080222,1,1,'[]',0,0,'[career]',1,1),(32080223,1,1,'[]',0,0,'[career]',1,1),(32080224,1,1,'[]',0,0,'[]',1,1),(32080225,1,1,'[]',0,0,'[career]',1,1),(32080226,1,1,'[]',0,0,'[career]',1,1),(32080227,1,1,'[]',0,0,'[career]',1,1),(32080228,1,1,'[]',0,0,'[]',1,1),(32080231,1,1,'[]',0,0,'[career]',1,1),(32080232,1,1,'[]',0,0,'[career]',1,1),(32080233,1,1,'[]',0,0,'[career]',1,1),(32080234,1,1,'[]',0,0,'[]',1,1),(32080235,1,1,'[]',0,0,'[career]',1,1),(32080236,1,1,'[]',0,0,'[career]',1,1),(32080237,1,1,'[]',0,0,'[career]',1,1),(32080238,1,1,'[]',0,0,'[]',1,1),(32080241,1,1,'[]',0,0,'[career]',1,1),(32080242,1,1,'[]',0,0,'[career]',1,1),(32080243,1,1,'[]',0,0,'[career]',1,1),(32080244,1,1,'[]',0,0,'[]',1,1),(32080245,1,1,'[]',0,0,'[career]',1,1),(32080246,1,1,'[]',0,0,'[career]',1,1),(32080247,1,1,'[]',0,0,'[career]',1,1),(32080248,1,1,'[]',0,0,'[]',1,1),(32080251,1,1,'[]',0,0,'[career]',1,1),(32080252,1,1,'[]',0,0,'[career]',1,1),(32080253,1,1,'[]',0,0,'[career]',1,1),(32080254,1,1,'[]',0,0,'[]',1,1),(32080255,1,1,'[]',0,0,'[career]',1,1),(32080256,1,1,'[]',0,0,'[career]',1,1),(32080257,1,1,'[]',0,0,'[career]',1,1),(32080258,1,1,'[]',0,0,'[]',1,1),(32080261,1,1,'[]',0,0,'[career]',1,1),(32080262,1,1,'[]',0,0,'[career]',1,1),(32080263,1,1,'[]',0,0,'[career]',1,1),(32080264,1,1,'[]',0,0,'[]',1,1),(32080265,1,1,'[]',0,0,'[career]',1,1),(32080266,1,1,'[]',0,0,'[career]',1,1),(32080267,1,1,'[]',0,0,'[career]',1,1),(32080268,1,1,'[]',0,0,'[]',1,1),(32080271,1,1,'[]',0,0,'[career]',1,1),(32080272,1,1,'[]',0,0,'[career]',1,1),(32080273,1,1,'[]',0,0,'[career]',1,1),(32080274,1,1,'[]',0,0,'[]',1,1),(32080275,1,1,'[]',0,0,'[career]',1,1),(32080276,1,1,'[]',0,0,'[career]',1,1),(32080277,1,1,'[]',0,0,'[career]',1,1),(32080278,1,1,'[]',0,0,'[]',1,1),(32080281,1,1,'[]',0,0,'[career]',1,1),(32080282,1,1,'[]',0,0,'[career]',1,1),(32080283,1,1,'[]',0,0,'[career]',1,1),(32080284,1,1,'[]',0,0,'[]',1,1),(32080285,1,1,'[]',0,0,'[career]',1,1),(32080286,1,1,'[]',0,0,'[career]',1,1),(32080287,1,1,'[]',0,0,'[career]',1,1),(32080288,1,1,'[]',0,0,'[]',1,1),(32080291,1,1,'[]',0,0,'[career]',1,1),(32080292,1,1,'[]',0,0,'[career]',1,1),(32080293,1,1,'[]',0,0,'[career]',1,1),(32080294,1,1,'[]',0,0,'[]',1,1),(32080295,1,1,'[]',0,0,'[career]',1,1),(32080296,1,1,'[]',0,0,'[career]',1,1),(32080297,1,1,'[]',0,0,'[career]',1,1),(32080298,1,1,'[]',0,0,'[]',1,1),(32080301,1,1,'[]',0,0,'[career]',1,1),(32080302,1,1,'[]',0,0,'[career]',1,1),(32080303,1,1,'[]',0,0,'[career]',1,1),(32080304,1,1,'[]',0,0,'[]',1,1),(32080305,1,1,'[]',0,0,'[career]',1,1),(32080306,1,1,'[]',0,0,'[career]',1,1),(32080307,1,1,'[]',0,0,'[career]',1,1),(32080308,1,1,'[]',0,0,'[]',1,1),(32080311,1,1,'[]',0,0,'[career]',1,1),(32080312,1,1,'[]',0,0,'[career]',1,1),(32080313,1,1,'[]',0,0,'[career]',1,1),(32080314,1,1,'[]',0,0,'[]',1,1),(32080315,1,1,'[]',0,0,'[career]',1,1),(32080316,1,1,'[]',0,0,'[career]',1,1),(32080317,1,1,'[]',0,0,'[career]',1,1),(32080318,1,1,'[]',0,0,'[]',1,1),(32080321,1,1,'[]',0,0,'[career]',1,1),(32080322,1,1,'[]',0,0,'[career]',1,1),(32080323,1,1,'[]',0,0,'[career]',1,1),(32080324,1,1,'[]',0,0,'[]',1,1),(32080325,1,1,'[]',0,0,'[career]',1,1),(32080326,1,1,'[]',0,0,'[career]',1,1),(32080327,1,1,'[]',0,0,'[career]',1,1),(32080328,1,1,'[]',0,0,'[]',1,1),(32080331,1,1,'[]',0,0,'[career]',1,1),(32080332,1,1,'[]',0,0,'[career]',1,1),(32080333,1,1,'[]',0,0,'[career]',1,1),(32080334,1,1,'[]',0,0,'[]',1,1),(32080335,1,1,'[]',0,0,'[career]',1,1),(32080336,1,1,'[]',0,0,'[career]',1,1),(32080337,1,1,'[]',0,0,'[career]',1,1),(32080338,1,1,'[]',0,0,'[]',1,1),(32080341,1,1,'[]',0,0,'[career]',1,1),(32080342,1,1,'[]',0,0,'[career]',1,1),(32080343,1,1,'[]',0,0,'[career]',1,1),(32080344,1,1,'[]',0,0,'[]',1,1),(32080345,1,1,'[]',0,0,'[career]',1,1),(32080346,1,1,'[]',0,0,'[career]',1,1),(32080347,1,1,'[]',0,0,'[career]',1,1),(32080348,1,1,'[]',0,0,'[]',1,1),(32080351,1,1,'[]',0,0,'[career]',1,1),(32080352,1,1,'[]',0,0,'[career]',1,1),(32080353,1,1,'[]',0,0,'[career]',1,1),(32080354,1,1,'[]',0,0,'[]',1,1),(32080355,1,1,'[]',0,0,'[career]',1,1),(32080356,1,1,'[]',0,0,'[career]',1,1),(32080357,1,1,'[]',0,0,'[career]',1,1),(32080358,1,1,'[]',0,0,'[]',1,1),(32080361,1,1,'[]',0,0,'[career]',1,1),(32080362,1,1,'[]',0,0,'[career]',1,1),(32080363,1,1,'[]',0,0,'[career]',1,1),(32080364,1,1,'[]',0,0,'[]',1,1),(32080365,1,1,'[]',0,0,'[career]',1,1),(32080366,1,1,'[]',0,0,'[career]',1,1),(32080367,1,1,'[]',0,0,'[career]',1,1),(32080368,1,1,'[]',0,0,'[]',1,1),(32080371,1,1,'[]',0,0,'[career]',1,1),(32080372,1,1,'[]',0,0,'[career]',1,1),(32080373,1,1,'[]',0,0,'[career]',1,1),(32080374,1,1,'[]',0,0,'[]',1,1),(32080375,1,1,'[]',0,0,'[career]',1,1),(32080376,1,1,'[]',0,0,'[career]',1,1),(32080377,1,1,'[]',0,0,'[career]',1,1),(32080378,1,1,'[]',0,0,'[]',1,1),(32080381,1,1,'[]',0,0,'[career]',1,1),(32080382,1,1,'[]',0,0,'[career]',1,1),(32080383,1,1,'[]',0,0,'[career]',1,1),(32080384,1,1,'[]',0,0,'[]',1,1),(32080385,1,1,'[]',0,0,'[career]',1,1),(32080386,1,1,'[]',0,0,'[career]',1,1),(32080387,1,1,'[]',0,0,'[career]',1,1),(32080388,1,1,'[]',0,0,'[]',1,1),(32080391,1,1,'[]',0,0,'[career]',1,1),(32080392,1,1,'[]',0,0,'[career]',1,1),(32080393,1,1,'[]',0,0,'[career]',1,1),(32080394,1,1,'[]',0,0,'[]',1,1),(32080395,1,1,'[]',0,0,'[career]',1,1),(32080396,1,1,'[]',0,0,'[career]',1,1),(32080397,1,1,'[]',0,0,'[career]',1,1),(32080398,1,1,'[]',0,0,'[]',1,1),(32080401,1,1,'[]',0,0,'[career]',1,1),(32080402,1,1,'[]',0,0,'[career]',1,1),(32080403,1,1,'[]',0,0,'[career]',1,1),(32080404,1,1,'[]',0,0,'[]',1,1),(32080405,1,1,'[]',0,0,'[career]',1,1),(32080406,1,1,'[]',0,0,'[career]',1,1),(32080407,1,1,'[]',0,0,'[career]',1,1),(32080408,1,1,'[]',0,0,'[]',1,1),(32080411,1,1,'[]',0,0,'[career]',1,1),(32080412,1,1,'[]',0,0,'[career]',1,1),(32080413,1,1,'[]',0,0,'[career]',1,1),(32080414,1,1,'[]',0,0,'[]',1,1),(32080415,1,1,'[]',0,0,'[career]',1,1),(32080416,1,1,'[]',0,0,'[career]',1,1),(32080417,1,1,'[]',0,0,'[career]',1,1),(32080418,1,1,'[]',0,0,'[]',1,1),(32080421,1,1,'[]',0,0,'[career]',1,1),(32080422,1,1,'[]',0,0,'[career]',1,1),(32080423,1,1,'[]',0,0,'[career]',1,1),(32080424,1,1,'[]',0,0,'[]',1,1),(32080425,1,1,'[]',0,0,'[career]',1,1),(32080426,1,1,'[]',0,0,'[career]',1,1),(32080427,1,1,'[]',0,0,'[career]',1,1),(32080428,1,1,'[]',0,0,'[]',1,1),(32080431,1,1,'[]',0,0,'[career]',1,1),(32080432,1,1,'[]',0,0,'[career]',1,1),(32080433,1,1,'[]',0,0,'[career]',1,1),(32080434,1,1,'[]',0,0,'[]',1,1),(32080435,1,1,'[]',0,0,'[career]',1,1),(32080436,1,1,'[]',0,0,'[career]',1,1),(32080437,1,1,'[]',0,0,'[career]',1,1),(32080438,1,1,'[]',0,0,'[]',1,1),(32080441,1,1,'[]',0,0,'[career]',1,1),(32080442,1,1,'[]',0,0,'[career]',1,1),(32080443,1,1,'[]',0,0,'[career]',1,1),(32080444,1,1,'[]',0,0,'[]',1,1),(32080445,1,1,'[]',0,0,'[career]',1,1),(32080446,1,1,'[]',0,0,'[career]',1,1),(32080447,1,1,'[]',0,0,'[career]',1,1),(32080448,1,1,'[]',0,0,'[]',1,1),(32080451,1,1,'[]',0,0,'[career]',1,1),(32080452,1,1,'[]',0,0,'[career]',1,1),(32080453,1,1,'[]',0,0,'[career]',1,1),(32080454,1,1,'[]',0,0,'[]',1,1),(32080455,1,1,'[]',0,0,'[career]',1,1),(32080456,1,1,'[]',0,0,'[career]',1,1),(32080457,1,1,'[]',0,0,'[career]',1,1),(32080458,1,1,'[]',0,0,'[]',1,1),(32080461,1,1,'[]',0,0,'[career]',1,1),(32080462,1,1,'[]',0,0,'[career]',1,1),(32080463,1,1,'[]',0,0,'[career]',1,1),(32080464,1,1,'[]',0,0,'[]',1,1),(32080465,1,1,'[]',0,0,'[career]',1,1),(32080466,1,1,'[]',0,0,'[career]',1,1),(32080467,1,1,'[]',0,0,'[career]',1,1),(32080468,1,1,'[]',0,0,'[]',1,1),(32080471,1,1,'[]',0,0,'[career]',1,1),(32080472,1,1,'[]',0,0,'[career]',1,1),(32080473,1,1,'[]',0,0,'[career]',1,1),(32080474,1,1,'[]',0,0,'[]',1,1),(32080475,1,1,'[]',0,0,'[career]',1,1),(32080476,1,1,'[]',0,0,'[career]',1,1),(32080477,1,1,'[]',0,0,'[career]',1,1),(32080478,1,1,'[]',0,0,'[]',1,1),(32080481,1,1,'[]',0,0,'[career]',1,1),(32080482,1,1,'[]',0,0,'[career]',1,1),(32080483,1,1,'[]',0,0,'[career]',1,1),(32080484,1,1,'[]',0,0,'[]',1,1),(32080485,1,1,'[]',0,0,'[career]',1,1),(32080486,1,1,'[]',0,0,'[career]',1,1),(32080487,1,1,'[]',0,0,'[career]',1,1),(32080488,1,1,'[]',0,0,'[]',1,1),(32080491,1,1,'[]',0,0,'[career]',1,1),(32080492,1,1,'[]',0,0,'[career]',1,1),(32080493,1,1,'[]',0,0,'[career]',1,1),(32080494,1,1,'[]',0,0,'[]',1,1),(32080495,1,1,'[]',0,0,'[career]',1,1),(32080496,1,1,'[]',0,0,'[career]',1,1),(32080497,1,1,'[]',0,0,'[career]',1,1),(32080498,1,1,'[]',0,0,'[]',1,1),(32080501,1,1,'[]',0,0,'[career]',1,1),(32080502,1,1,'[]',0,0,'[career]',1,1),(32080503,1,1,'[]',0,0,'[career]',1,1),(32080504,1,1,'[]',0,0,'[]',1,1),(32080505,1,1,'[]',0,0,'[career]',1,1),(32080506,1,1,'[]',0,0,'[career]',1,1),(32080507,1,1,'[]',0,0,'[career]',1,1),(32080508,1,1,'[]',0,0,'[]',1,1),(32080511,1,1,'[]',0,0,'[career]',1,1),(32080512,1,1,'[]',0,0,'[career]',1,1),(32080513,1,1,'[]',0,0,'[career]',1,1),(32080514,1,1,'[]',0,0,'[]',1,1),(32080515,1,1,'[]',0,0,'[career]',1,1),(32080516,1,1,'[]',0,0,'[career]',1,1),(32080517,1,1,'[]',0,0,'[career]',1,1),(32080518,1,1,'[]',0,0,'[]',1,1),(32080521,1,1,'[]',0,0,'[career]',1,1),(32080522,1,1,'[]',0,0,'[career]',1,1),(32080523,1,1,'[]',0,0,'[career]',1,1),(32080524,1,1,'[]',0,0,'[]',1,1),(32080525,1,1,'[]',0,0,'[career]',1,1),(32080526,1,1,'[]',0,0,'[career]',1,1),(32080527,1,1,'[]',0,0,'[career]',1,1),(32080528,1,1,'[]',0,0,'[]',1,1),(32080531,1,1,'[]',0,0,'[career]',1,1),(32080532,1,1,'[]',0,0,'[career]',1,1),(32080533,1,1,'[]',0,0,'[career]',1,1),(32080534,1,1,'[]',0,0,'[]',1,1),(32080535,1,1,'[]',0,0,'[career]',1,1),(32080536,1,1,'[]',0,0,'[career]',1,1),(32080537,1,1,'[]',0,0,'[career]',1,1),(32080538,1,1,'[]',0,0,'[]',1,1),(32080541,1,1,'[]',0,0,'[career]',1,1),(32080542,1,1,'[]',0,0,'[career]',1,1),(32080543,1,1,'[]',0,0,'[career]',1,1),(32080544,1,1,'[]',0,0,'[]',1,1),(32080545,1,1,'[]',0,0,'[career]',1,1),(32080546,1,1,'[]',0,0,'[career]',1,1),(32080547,1,1,'[]',0,0,'[career]',1,1),(32080548,1,1,'[]',0,0,'[]',1,1),(32080551,1,1,'[]',0,0,'[career]',1,1),(32080552,1,1,'[]',0,0,'[career]',1,1),(32080553,1,1,'[]',0,0,'[career]',1,1),(32080554,1,1,'[]',0,0,'[]',1,1),(32080555,1,1,'[]',0,0,'[career]',1,1),(32080556,1,1,'[]',0,0,'[career]',1,1),(32080557,1,1,'[]',0,0,'[career]',1,1),(32080558,1,1,'[]',0,0,'[]',1,1),(32080561,1,1,'[]',0,0,'[career]',1,1),(32080562,1,1,'[]',0,0,'[career]',1,1),(32080563,1,1,'[]',0,0,'[career]',1,1),(32080564,1,1,'[]',0,0,'[]',1,1),(32080565,1,1,'[]',0,0,'[career]',1,1),(32080566,1,1,'[]',0,0,'[career]',1,1),(32080567,1,1,'[]',0,0,'[career]',1,1),(32080568,1,1,'[]',0,0,'[]',1,1),(32080571,1,1,'[]',0,0,'[career]',1,1),(32080572,1,1,'[]',0,0,'[career]',1,1),(32080573,1,1,'[]',0,0,'[career]',1,1),(32080574,1,1,'[]',0,0,'[]',1,1),(32080575,1,1,'[]',0,0,'[career]',1,1),(32080576,1,1,'[]',0,0,'[career]',1,1),(32080577,1,1,'[]',0,0,'[career]',1,1),(32080578,1,1,'[]',0,0,'[]',1,1),(32080581,1,1,'[]',0,0,'[career]',1,1),(32080582,1,1,'[]',0,0,'[career]',1,1),(32080583,1,1,'[]',0,0,'[career]',1,1),(32080584,1,1,'[]',0,0,'[]',1,1),(32080585,1,1,'[]',0,0,'[career]',1,1),(32080586,1,1,'[]',0,0,'[career]',1,1),(32080587,1,1,'[]',0,0,'[career]',1,1),(32080588,1,1,'[]',0,0,'[]',1,1),(32080591,1,1,'[]',0,0,'[career]',1,1),(32080592,1,1,'[]',0,0,'[career]',1,1),(32080593,1,1,'[]',0,0,'[career]',1,1),(32080594,1,1,'[]',0,0,'[]',1,1),(32080595,1,1,'[]',0,0,'[career]',1,1),(32080596,1,1,'[]',0,0,'[career]',1,1),(32080597,1,1,'[]',0,0,'[career]',1,1),(32080598,1,1,'[]',0,0,'[]',1,1),(32080601,1,1,'[]',0,0,'[career]',1,1),(32080602,1,1,'[]',0,0,'[career]',1,1),(32080603,1,1,'[]',0,0,'[career]',1,1),(32080604,1,1,'[]',0,0,'[]',1,1),(32080605,1,1,'[]',0,0,'[career]',1,1),(32080606,1,1,'[]',0,0,'[career]',1,1),(32080607,1,1,'[]',0,0,'[career]',1,1),(32080608,1,1,'[]',0,0,'[]',1,1),(32080611,1,1,'[]',0,0,'[career]',1,1),(32080612,1,1,'[]',0,0,'[career]',1,1),(32080613,1,1,'[]',0,0,'[career]',1,1),(32080614,1,1,'[]',0,0,'[]',1,1),(32080615,1,1,'[]',0,0,'[career]',1,1),(32080616,1,1,'[]',0,0,'[career]',1,1),(32080617,1,1,'[]',0,0,'[career]',1,1),(32080618,1,1,'[]',0,0,'[]',1,1),(32080621,1,1,'[]',0,0,'[career]',1,1),(32080622,1,1,'[]',0,0,'[career]',1,1),(32080623,1,1,'[]',0,0,'[career]',1,1),(32080624,1,1,'[]',0,0,'[]',1,1),(32080625,1,1,'[]',0,0,'[career]',1,1),(32080626,1,1,'[]',0,0,'[career]',1,1),(32080627,1,1,'[]',0,0,'[career]',1,1),(32080628,1,1,'[]',0,0,'[]',1,1),(32080631,1,1,'[]',0,0,'[career]',1,1),(32080632,1,1,'[]',0,0,'[career]',1,1),(32080633,1,1,'[]',0,0,'[career]',1,1),(32080634,1,1,'[]',0,0,'[]',1,1),(32080635,1,1,'[]',0,0,'[career]',1,1),(32080636,1,1,'[]',0,0,'[career]',1,1),(32080637,1,1,'[]',0,0,'[career]',1,1),(32080638,1,1,'[]',0,0,'[]',1,1),(32080641,1,1,'[]',0,0,'[career]',1,1),(32080642,1,1,'[]',0,0,'[career]',1,1),(32080643,1,1,'[]',0,0,'[career]',1,1),(32080644,1,1,'[]',0,0,'[]',1,1),(32080645,1,1,'[]',0,0,'[career]',1,1),(32080646,1,1,'[]',0,0,'[career]',1,1),(32080647,1,1,'[]',0,0,'[career]',1,1),(32080648,1,1,'[]',0,0,'[]',1,1),(32080651,1,1,'[]',0,0,'[career]',1,1),(32080652,1,1,'[]',0,0,'[career]',1,1),(32080653,1,1,'[]',0,0,'[career]',1,1),(32080654,1,1,'[]',0,0,'[]',1,1),(32080655,1,1,'[]',0,0,'[career]',1,1),(32080656,1,1,'[]',0,0,'[career]',1,1),(32080657,1,1,'[]',0,0,'[career]',1,1),(32080658,1,1,'[]',0,0,'[]',1,1),(32080661,1,1,'[]',0,0,'[career]',1,1),(32080662,1,1,'[]',0,0,'[career]',1,1),(32080663,1,1,'[]',0,0,'[career]',1,1),(32080664,1,1,'[]',0,0,'[]',1,1),(32080665,1,1,'[]',0,0,'[career]',1,1),(32080666,1,1,'[]',0,0,'[career]',1,1),(32080667,1,1,'[]',0,0,'[career]',1,1),(32080668,1,1,'[]',0,0,'[]',1,1),(32080671,1,1,'[]',0,0,'[career]',1,1),(32080672,1,1,'[]',0,0,'[career]',1,1),(32080673,1,1,'[]',0,0,'[career]',1,1),(32080674,1,1,'[]',0,0,'[]',1,1),(32080675,1,1,'[]',0,0,'[career]',1,1),(32080676,1,1,'[]',0,0,'[career]',1,1),(32080677,1,1,'[]',0,0,'[career]',1,1),(32080678,1,1,'[]',0,0,'[]',1,1),(32080681,1,1,'[]',0,0,'[career]',1,1),(32080682,1,1,'[]',0,0,'[career]',1,1),(32080683,1,1,'[]',0,0,'[career]',1,1),(32080684,1,1,'[]',0,0,'[]',1,1),(32080685,1,1,'[]',0,0,'[career]',1,1),(32080686,1,1,'[]',0,0,'[career]',1,1),(32080687,1,1,'[]',0,0,'[career]',1,1),(32080688,1,1,'[]',0,0,'[]',1,1),(32080691,1,1,'[]',0,0,'[career]',1,1),(32080692,1,1,'[]',0,0,'[career]',1,1),(32080693,1,1,'[]',0,0,'[career]',1,1),(32080694,1,1,'[]',0,0,'[]',1,1),(32080695,1,1,'[]',0,0,'[career]',1,1),(32080696,1,1,'[]',0,0,'[career]',1,1),(32080697,1,1,'[]',0,0,'[career]',1,1),(32080698,1,1,'[]',0,0,'[]',1,1),(32080701,1,1,'[]',0,0,'[career]',1,1),(32080702,1,1,'[]',0,0,'[career]',1,1),(32080703,1,1,'[]',0,0,'[career]',1,1),(32080704,1,1,'[]',0,0,'[]',1,1),(32080705,1,1,'[]',0,0,'[career]',1,1),(32080706,1,1,'[]',0,0,'[career]',1,1),(32080707,1,1,'[]',0,0,'[career]',1,1),(32080708,1,1,'[]',0,0,'[]',1,1),(32080711,1,1,'[]',0,0,'[career]',1,1),(32080712,1,1,'[]',0,0,'[career]',1,1),(32080713,1,1,'[]',0,0,'[career]',1,1),(32080714,1,1,'[]',0,0,'[]',1,1),(32080715,1,1,'[]',0,0,'[career]',1,1),(32080716,1,1,'[]',0,0,'[career]',1,1),(32080717,1,1,'[]',0,0,'[career]',1,1),(32080718,1,1,'[]',0,0,'[]',1,1),(32080721,1,1,'[]',0,0,'[career]',1,1),(32080722,1,1,'[]',0,0,'[career]',1,1),(32080723,1,1,'[]',0,0,'[career]',1,1),(32080724,1,1,'[]',0,0,'[]',1,1),(32080725,1,1,'[]',0,0,'[career]',1,1),(32080726,1,1,'[]',0,0,'[career]',1,1),(32080727,1,1,'[]',0,0,'[career]',1,1),(32080728,1,1,'[]',0,0,'[]',1,1),(32080731,1,1,'[]',0,0,'[career]',1,1),(32080732,1,1,'[]',0,0,'[career]',1,1),(32080733,1,1,'[]',0,0,'[career]',1,1),(32080734,1,1,'[]',0,0,'[]',1,1),(32080735,1,1,'[]',0,0,'[career]',1,1),(32080736,1,1,'[]',0,0,'[career]',1,1),(32080737,1,1,'[]',0,0,'[career]',1,1),(32080738,1,1,'[]',0,0,'[]',1,1),(32080741,1,1,'[]',0,0,'[career]',1,1),(32080742,1,1,'[]',0,0,'[career]',1,1),(32080743,1,1,'[]',0,0,'[career]',1,1),(32080744,1,1,'[]',0,0,'[]',1,1),(32080745,1,1,'[]',0,0,'[career]',1,1),(32080746,1,1,'[]',0,0,'[career]',1,1),(32080747,1,1,'[]',0,0,'[career]',1,1),(32080748,1,1,'[]',0,0,'[]',1,1),(32080751,1,1,'[]',0,0,'[career]',1,1),(32080752,1,1,'[]',0,0,'[career]',1,1),(32080753,1,1,'[]',0,0,'[career]',1,1),(32080754,1,1,'[]',0,0,'[]',1,1),(32080755,1,1,'[]',0,0,'[career]',1,1),(32080756,1,1,'[]',0,0,'[career]',1,1),(32080757,1,1,'[]',0,0,'[career]',1,1),(32080758,1,1,'[]',0,0,'[]',1,1),(32080761,1,1,'[]',0,0,'[career]',1,1),(32080762,1,1,'[]',0,0,'[career]',1,1),(32080763,1,1,'[]',0,0,'[career]',1,1),(32080764,1,1,'[]',0,0,'[]',1,1),(32080765,1,1,'[]',0,0,'[career]',1,1),(32080766,1,1,'[]',0,0,'[career]',1,1),(32080767,1,1,'[]',0,0,'[career]',1,1),(32080768,1,1,'[]',0,0,'[]',1,1),(32080771,1,1,'[]',0,0,'[career]',1,1),(32080772,1,1,'[]',0,0,'[career]',1,1),(32080773,1,1,'[]',0,0,'[career]',1,1),(32080774,1,1,'[]',0,0,'[]',1,1),(32080775,1,1,'[]',0,0,'[career]',1,1),(32080776,1,1,'[]',0,0,'[career]',1,1),(32080777,1,1,'[]',0,0,'[career]',1,1),(32080778,1,1,'[]',0,0,'[]',1,1),(32080781,1,1,'[]',0,0,'[career]',1,1),(32080782,1,1,'[]',0,0,'[career]',1,1),(32080783,1,1,'[]',0,0,'[career]',1,1),(32080784,1,1,'[]',0,0,'[]',1,1),(32080785,1,1,'[]',0,0,'[career]',1,1),(32080786,1,1,'[]',0,0,'[career]',1,1),(32080787,1,1,'[]',0,0,'[career]',1,1),(32080788,1,1,'[]',0,0,'[]',1,1),(32080791,1,1,'[]',0,0,'[career]',1,1),(32080792,1,1,'[]',0,0,'[career]',1,1),(32080793,1,1,'[]',0,0,'[career]',1,1),(32080794,1,1,'[]',0,0,'[]',1,1),(32080795,1,1,'[]',0,0,'[career]',1,1),(32080796,1,1,'[]',0,0,'[career]',1,1),(32080797,1,1,'[]',0,0,'[career]',1,1),(32080798,1,1,'[]',0,0,'[]',1,1),(32080801,1,1,'[]',0,0,'[career]',1,1),(32080802,1,1,'[]',0,0,'[career]',1,1),(32080803,1,1,'[]',0,0,'[career]',1,1),(32080804,1,1,'[]',0,0,'[]',1,1),(32080805,1,1,'[]',0,0,'[career]',1,1),(32080806,1,1,'[]',0,0,'[career]',1,1),(32080807,1,1,'[]',0,0,'[career]',1,1),(32080808,1,1,'[]',0,0,'[]',1,1),(32080811,1,1,'[]',0,0,'[career]',1,1),(32080812,1,1,'[]',0,0,'[career]',1,1),(32080813,1,1,'[]',0,0,'[career]',1,1),(32080814,1,1,'[]',0,0,'[]',1,1),(32080815,1,1,'[]',0,0,'[career]',1,1),(32080816,1,1,'[]',0,0,'[career]',1,1),(32080817,1,1,'[]',0,0,'[career]',1,1),(32080818,1,1,'[]',0,0,'[]',1,1),(32080821,1,1,'[]',0,0,'[career]',1,1),(32080822,1,1,'[]',0,0,'[career]',1,1),(32080823,1,1,'[]',0,0,'[career]',1,1),(32080824,1,1,'[]',0,0,'[]',1,1),(32080825,1,1,'[]',0,0,'[career]',1,1),(32080826,1,1,'[]',0,0,'[career]',1,1),(32080827,1,1,'[]',0,0,'[career]',1,1),(32080828,1,1,'[]',0,0,'[]',1,1),(32080831,1,1,'[]',0,0,'[career]',1,1),(32080832,1,1,'[]',0,0,'[career]',1,1),(32080833,1,1,'[]',0,0,'[career]',1,1),(32080834,1,1,'[]',0,0,'[]',1,1),(32080835,1,1,'[]',0,0,'[career]',1,1),(32080836,1,1,'[]',0,0,'[career]',1,1),(32080837,1,1,'[]',0,0,'[career]',1,1),(32080838,1,1,'[]',0,0,'[]',1,1),(32080841,1,1,'[]',0,0,'[career]',1,1),(32080842,1,1,'[]',0,0,'[career]',1,1),(32080843,1,1,'[]',0,0,'[career]',1,1),(32080844,1,1,'[]',0,0,'[]',1,1),(32080845,1,1,'[]',0,0,'[career]',1,1),(32080846,1,1,'[]',0,0,'[career]',1,1),(32080847,1,1,'[]',0,0,'[career]',1,1),(32080848,1,1,'[]',0,0,'[]',1,1),(32080851,1,1,'[]',0,0,'[career]',1,1),(32080852,1,1,'[]',0,0,'[career]',1,1),(32080853,1,1,'[]',0,0,'[career]',1,1),(32080854,1,1,'[]',0,0,'[]',1,1),(32080855,1,1,'[]',0,0,'[career]',1,1),(32080856,1,1,'[]',0,0,'[career]',1,1),(32080857,1,1,'[]',0,0,'[career]',1,1),(32080858,1,1,'[]',0,0,'[]',1,1),(32080861,1,1,'[]',0,0,'[career]',1,1),(32080862,1,1,'[]',0,0,'[career]',1,1),(32080863,1,1,'[]',0,0,'[career]',1,1),(32080864,1,1,'[]',0,0,'[]',1,1),(32080865,1,1,'[]',0,0,'[career]',1,1),(32080866,1,1,'[]',0,0,'[career]',1,1),(32080867,1,1,'[]',0,0,'[career]',1,1),(32080868,1,1,'[]',0,0,'[]',1,1),(32080871,1,1,'[]',0,0,'[career]',1,1),(32080872,1,1,'[]',0,0,'[career]',1,1),(32080873,1,1,'[]',0,0,'[career]',1,1),(32080874,1,1,'[]',0,0,'[]',1,1),(32080875,1,1,'[]',0,0,'[career]',1,1),(32080876,1,1,'[]',0,0,'[career]',1,1),(32080877,1,1,'[]',0,0,'[career]',1,1),(32080878,1,1,'[]',0,0,'[]',1,1),(32080881,1,1,'[]',0,0,'[career]',1,1),(32080882,1,1,'[]',0,0,'[career]',1,1),(32080883,1,1,'[]',0,0,'[career]',1,1),(32080884,1,1,'[]',0,0,'[]',1,1),(32080885,1,1,'[]',0,0,'[career]',1,1),(32080886,1,1,'[]',0,0,'[career]',1,1),(32080887,1,1,'[]',0,0,'[career]',1,1),(32080888,1,1,'[]',0,0,'[]',1,1),(32080891,1,1,'[]',0,0,'[career]',1,1),(32080892,1,1,'[]',0,0,'[career]',1,1),(32080893,1,1,'[]',0,0,'[career]',1,1),(32080894,1,1,'[]',0,0,'[]',1,1),(32080895,1,1,'[]',0,0,'[career]',1,1),(32080896,1,1,'[]',0,0,'[career]',1,1),(32080897,1,1,'[]',0,0,'[career]',1,1),(32080898,1,1,'[]',0,0,'[]',1,1),(32080901,1,1,'[]',0,0,'[career]',1,1),(32080902,1,1,'[]',0,0,'[career]',1,1),(32080903,1,1,'[]',0,0,'[career]',1,1),(32080904,1,1,'[]',0,0,'[]',1,1),(32080905,1,1,'[]',0,0,'[career]',1,1),(32080906,1,1,'[]',0,0,'[career]',1,1),(32080907,1,1,'[]',0,0,'[career]',1,1),(32080908,1,1,'[]',0,0,'[]',1,1),(32080911,1,1,'[]',0,0,'[career]',1,1),(32080912,1,1,'[]',0,0,'[career]',1,1),(32080913,1,1,'[]',0,0,'[career]',1,1),(32080914,1,1,'[]',0,0,'[]',1,1),(32080915,1,1,'[]',0,0,'[career]',1,1),(32080916,1,1,'[]',0,0,'[career]',1,1),(32080917,1,1,'[]',0,0,'[career]',1,1),(32080918,1,1,'[]',0,0,'[]',1,1),(32080921,1,1,'[]',0,0,'[career]',1,1),(32080922,1,1,'[]',0,0,'[career]',1,1),(32080923,1,1,'[]',0,0,'[career]',1,1),(32080924,1,1,'[]',0,0,'[]',1,1),(32080925,1,1,'[]',0,0,'[career]',1,1),(32080926,1,1,'[]',0,0,'[career]',1,1),(32080927,1,1,'[]',0,0,'[career]',1,1),(32080928,1,1,'[]',0,0,'[]',1,1),(32080931,1,1,'[]',0,0,'[career]',1,1),(32080932,1,1,'[]',0,0,'[career]',1,1),(32080933,1,1,'[]',0,0,'[career]',1,1),(32080934,1,1,'[]',0,0,'[]',1,1),(32080935,1,1,'[]',0,0,'[career]',1,1),(32080936,1,1,'[]',0,0,'[career]',1,1),(32080937,1,1,'[]',0,0,'[career]',1,1),(32080938,1,1,'[]',0,0,'[]',1,1),(32080941,1,1,'[]',0,0,'[career]',1,1),(32080942,1,1,'[]',0,0,'[career]',1,1),(32080943,1,1,'[]',0,0,'[career]',1,1),(32080944,1,1,'[]',0,0,'[]',1,1),(32080945,1,1,'[]',0,0,'[career]',1,1),(32080946,1,1,'[]',0,0,'[career]',1,1),(32080947,1,1,'[]',0,0,'[career]',1,1),(32080948,1,1,'[]',0,0,'[]',1,1),(32080951,1,1,'[]',0,0,'[career]',1,1),(32080952,1,1,'[]',0,0,'[career]',1,1),(32080953,1,1,'[]',0,0,'[career]',1,1),(32080954,1,1,'[]',0,0,'[]',1,1),(32080955,1,1,'[]',0,0,'[career]',1,1),(32080956,1,1,'[]',0,0,'[career]',1,1),(32080957,1,1,'[]',0,0,'[career]',1,1),(32080958,1,1,'[]',0,0,'[]',1,1),(32080961,1,1,'[]',0,0,'[career]',1,1),(32080962,1,1,'[]',0,0,'[career]',1,1),(32080963,1,1,'[]',0,0,'[career]',1,1),(32080964,1,1,'[]',0,0,'[]',1,1),(32080965,1,1,'[]',0,0,'[career]',1,1),(32080966,1,1,'[]',0,0,'[career]',1,1),(32080967,1,1,'[]',0,0,'[career]',1,1),(32080968,1,1,'[]',0,0,'[]',1,1),(32080971,1,1,'[]',0,0,'[career]',1,1),(32080972,1,1,'[]',0,0,'[career]',1,1),(32080973,1,1,'[]',0,0,'[career]',1,1),(32080974,1,1,'[]',0,0,'[]',1,1),(32080975,1,1,'[]',0,0,'[career]',1,1),(32080976,1,1,'[]',0,0,'[career]',1,1),(32080977,1,1,'[]',0,0,'[career]',1,1),(32080978,1,1,'[]',0,0,'[]',1,1),(32080981,1,1,'[]',0,0,'[career]',1,1),(32080982,1,1,'[]',0,0,'[career]',1,1),(32080983,1,1,'[]',0,0,'[career]',1,1),(32080984,1,1,'[]',0,0,'[]',1,1),(32080985,1,1,'[]',0,0,'[career]',1,1),(32080986,1,1,'[]',0,0,'[career]',1,1),(32080987,1,1,'[]',0,0,'[career]',1,1),(32080988,1,1,'[]',0,0,'[]',1,1),(32080991,1,1,'[]',0,0,'[career]',1,1),(32080992,1,1,'[]',0,0,'[career]',1,1),(32080993,1,1,'[]',0,0,'[career]',1,1),(32080994,1,1,'[]',0,0,'[]',1,1),(32080995,1,1,'[]',0,0,'[career]',1,1),(32080996,1,1,'[]',0,0,'[career]',1,1),(32080997,1,1,'[]',0,0,'[career]',1,1),(32080998,1,1,'[]',0,0,'[]',1,1),(32081001,1,1,'[]',0,0,'[career]',1,1),(32081002,1,1,'[]',0,0,'[career]',1,1),(32081003,1,1,'[]',0,0,'[career]',1,1),(32081004,1,1,'[]',0,0,'[]',1,1),(32081005,1,1,'[]',0,0,'[career]',1,1),(32081006,1,1,'[]',0,0,'[career]',1,1),(32081007,1,1,'[]',0,0,'[career]',1,1),(32081008,1,1,'[]',0,0,'[]',1,1),(32081011,1,1,'[]',0,0,'[career]',1,1),(32081012,1,1,'[]',0,0,'[career]',1,1),(32081013,1,1,'[]',0,0,'[career]',1,1),(32081014,1,1,'[]',0,0,'[]',1,1),(32081015,1,1,'[]',0,0,'[career]',1,1),(32081016,1,1,'[]',0,0,'[career]',1,1),(32081017,1,1,'[]',0,0,'[career]',1,1),(32081018,1,1,'[]',0,0,'[]',1,1),(32081021,1,1,'[]',0,0,'[career]',1,1),(32081022,1,1,'[]',0,0,'[career]',1,1),(32081023,1,1,'[]',0,0,'[career]',1,1),(32081024,1,1,'[]',0,0,'[]',1,1),(32081025,1,1,'[]',0,0,'[career]',1,1),(32081026,1,1,'[]',0,0,'[career]',1,1),(32081027,1,1,'[]',0,0,'[career]',1,1),(32081028,1,1,'[]',0,0,'[]',1,1),(32081031,1,1,'[]',0,0,'[career]',1,1),(32081032,1,1,'[]',0,0,'[career]',1,1),(32081033,1,1,'[]',0,0,'[career]',1,1),(32081034,1,1,'[]',0,0,'[]',1,1),(32081035,1,1,'[]',0,0,'[career]',1,1),(32081036,1,1,'[]',0,0,'[career]',1,1),(32081037,1,1,'[]',0,0,'[career]',1,1),(32081038,1,1,'[]',0,0,'[]',1,1),(32081041,1,1,'[]',0,0,'[career]',1,1),(32081042,1,1,'[]',0,0,'[career]',1,1),(32081043,1,1,'[]',0,0,'[career]',1,1),(32081044,1,1,'[]',0,0,'[]',1,1),(32081045,1,1,'[]',0,0,'[career]',1,1),(32081046,1,1,'[]',0,0,'[career]',1,1),(32081047,1,1,'[]',0,0,'[career]',1,1),(32081048,1,1,'[]',0,0,'[]',1,1),(32081051,1,1,'[]',0,0,'[career]',1,1),(32081052,1,1,'[]',0,0,'[career]',1,1),(32081053,1,1,'[]',0,0,'[career]',1,1),(32081054,1,1,'[]',0,0,'[]',1,1),(32081055,1,1,'[]',0,0,'[career]',1,1),(32081056,1,1,'[]',0,0,'[career]',1,1),(32081057,1,1,'[]',0,0,'[career]',1,1),(32081058,1,1,'[]',0,0,'[]',1,1),(32081061,1,1,'[]',0,0,'[career]',1,1),(32081062,1,1,'[]',0,0,'[career]',1,1),(32081063,1,1,'[]',0,0,'[career]',1,1),(32081064,1,1,'[]',0,0,'[]',1,1),(32081065,1,1,'[]',0,0,'[career]',1,1),(32081066,1,1,'[]',0,0,'[career]',1,1),(32081067,1,1,'[]',0,0,'[career]',1,1),(32081068,1,1,'[]',0,0,'[]',1,1),(32081071,1,1,'[]',0,0,'[career]',1,1),(32081072,1,1,'[]',0,0,'[career]',1,1),(32081073,1,1,'[]',0,0,'[career]',1,1),(32081074,1,1,'[]',0,0,'[]',1,1),(32081075,1,1,'[]',0,0,'[career]',1,1),(32081076,1,1,'[]',0,0,'[career]',1,1),(32081077,1,1,'[]',0,0,'[career]',1,1),(32081078,1,1,'[]',0,0,'[]',1,1),(32081081,1,1,'[]',0,0,'[career]',1,1),(32081082,1,1,'[]',0,0,'[career]',1,1),(32081083,1,1,'[]',0,0,'[career]',1,1),(32081084,1,1,'[]',0,0,'[]',1,1),(32081085,1,1,'[]',0,0,'[career]',1,1),(32081086,1,1,'[]',0,0,'[career]',1,1),(32081087,1,1,'[]',0,0,'[career]',1,1),(32081088,1,1,'[]',0,0,'[]',1,1),(32081091,1,1,'[]',0,0,'[career]',1,1),(32081092,1,1,'[]',0,0,'[career]',1,1),(32081093,1,1,'[]',0,0,'[career]',1,1),(32081094,1,1,'[]',0,0,'[]',1,1),(32081095,1,1,'[]',0,0,'[career]',1,1),(32081096,1,1,'[]',0,0,'[career]',1,1),(32081097,1,1,'[]',0,0,'[career]',1,1),(32081098,1,1,'[]',0,0,'[]',1,1),(32081101,1,1,'[]',0,0,'[career]',1,1),(32081102,1,1,'[]',0,0,'[career]',1,1),(32081103,1,1,'[]',0,0,'[career]',1,1),(32081104,1,1,'[]',0,0,'[]',1,1),(32081105,1,1,'[]',0,0,'[career]',1,1),(32081106,1,1,'[]',0,0,'[career]',1,1),(32081107,1,1,'[]',0,0,'[career]',1,1),(32081108,1,1,'[]',0,0,'[]',1,1),(32081111,1,1,'[]',0,0,'[career]',1,1),(32081112,1,1,'[]',0,0,'[career]',1,1),(32081113,1,1,'[]',0,0,'[career]',1,1),(32081114,1,1,'[]',0,0,'[]',1,1),(32081115,1,1,'[]',0,0,'[career]',1,1),(32081116,1,1,'[]',0,0,'[career]',1,1),(32081117,1,1,'[]',0,0,'[career]',1,1),(32081118,1,1,'[]',0,0,'[]',1,1),(32081121,1,1,'[]',0,0,'[career]',1,1),(32081122,1,1,'[]',0,0,'[career]',1,1),(32081123,1,1,'[]',0,0,'[career]',1,1),(32081124,1,1,'[]',0,0,'[]',1,1),(32081125,1,1,'[]',0,0,'[career]',1,1),(32081126,1,1,'[]',0,0,'[career]',1,1),(32081127,1,1,'[]',0,0,'[career]',1,1),(32081128,1,1,'[]',0,0,'[]',1,1),(32081131,1,1,'[]',0,0,'[career]',1,1),(32081132,1,1,'[]',0,0,'[career]',1,1),(32081133,1,1,'[]',0,0,'[career]',1,1),(32081134,1,1,'[]',0,0,'[]',1,1),(32081135,1,1,'[]',0,0,'[career]',1,1),(32081136,1,1,'[]',0,0,'[career]',1,1),(32081137,1,1,'[]',0,0,'[career]',1,1),(32081138,1,1,'[]',0,0,'[]',1,1),(32081141,1,1,'[]',0,0,'[career]',1,1),(32081142,1,1,'[]',0,0,'[career]',1,1),(32081143,1,1,'[]',0,0,'[career]',1,1),(32081144,1,1,'[]',0,0,'[]',1,1),(32081145,1,1,'[]',0,0,'[career]',1,1),(32081146,1,1,'[]',0,0,'[career]',1,1),(32081147,1,1,'[]',0,0,'[career]',1,1),(32081148,1,1,'[]',0,0,'[]',1,1),(32081151,1,1,'[]',0,0,'[career]',1,1),(32081152,1,1,'[]',0,0,'[career]',1,1),(32081153,1,1,'[]',0,0,'[career]',1,1),(32081154,1,1,'[]',0,0,'[]',1,1),(32081155,1,1,'[]',0,0,'[career]',1,1),(32081156,1,1,'[]',0,0,'[career]',1,1),(32081157,1,1,'[]',0,0,'[career]',1,1),(32081158,1,1,'[]',0,0,'[]',1,1),(32081161,1,1,'[]',0,0,'[career]',1,1),(32081162,1,1,'[]',0,0,'[career]',1,1),(32081163,1,1,'[]',0,0,'[career]',1,1),(32081164,1,1,'[]',0,0,'[]',1,1),(32081165,1,1,'[]',0,0,'[career]',1,1),(32081166,1,1,'[]',0,0,'[career]',1,1),(32081167,1,1,'[]',0,0,'[career]',1,1),(32081168,1,1,'[]',0,0,'[]',1,1),(32081171,1,1,'[]',0,0,'[career]',1,1),(32081172,1,1,'[]',0,0,'[career]',1,1),(32081173,1,1,'[]',0,0,'[career]',1,1),(32081174,1,1,'[]',0,0,'[]',1,1),(32081175,1,1,'[]',0,0,'[career]',1,1),(32081176,1,1,'[]',0,0,'[career]',1,1),(32081177,1,1,'[]',0,0,'[career]',1,1),(32081178,1,1,'[]',0,0,'[]',1,1),(32081181,1,1,'[]',0,0,'[career]',1,1),(32081182,1,1,'[]',0,0,'[career]',1,1),(32081183,1,1,'[]',0,0,'[career]',1,1),(32081184,1,1,'[]',0,0,'[]',1,1),(32081185,1,1,'[]',0,0,'[career]',1,1),(32081186,1,1,'[]',0,0,'[career]',1,1),(32081187,1,1,'[]',0,0,'[career]',1,1),(32081188,1,1,'[]',0,0,'[]',1,1),(32081191,1,1,'[]',0,0,'[career]',1,1),(32081192,1,1,'[]',0,0,'[career]',1,1),(32081193,1,1,'[]',0,0,'[career]',1,1),(32081194,1,1,'[]',0,0,'[]',1,1),(32081195,1,1,'[]',0,0,'[career]',1,1),(32081196,1,1,'[]',0,0,'[career]',1,1),(32081197,1,1,'[]',0,0,'[career]',1,1),(32081198,1,1,'[]',0,0,'[]',1,1),(32081201,1,1,'[]',0,0,'[career]',1,1),(32081202,1,1,'[]',0,0,'[career]',1,1),(32081203,1,1,'[]',0,0,'[career]',1,1),(32081204,1,1,'[]',0,0,'[]',1,1),(32081205,1,1,'[]',0,0,'[career]',1,1),(32081206,1,1,'[]',0,0,'[career]',1,1),(32081207,1,1,'[]',0,0,'[career]',1,1),(32081208,1,1,'[]',0,0,'[]',1,1),(32081211,1,1,'[]',0,0,'[career]',1,1),(32081212,1,1,'[]',0,0,'[career]',1,1),(32081213,1,1,'[]',0,0,'[career]',1,1),(32081214,1,1,'[]',0,0,'[]',1,1),(32081215,1,1,'[]',0,0,'[career]',1,1),(32081216,1,1,'[]',0,0,'[career]',1,1),(32081217,1,1,'[]',0,0,'[career]',1,1),(32081218,1,1,'[]',0,0,'[]',1,1),(32081221,1,1,'[]',0,0,'[career]',1,1),(32081222,1,1,'[]',0,0,'[career]',1,1),(32081223,1,1,'[]',0,0,'[career]',1,1),(32081224,1,1,'[]',0,0,'[]',1,1),(32081225,1,1,'[]',0,0,'[career]',1,1),(32081226,1,1,'[]',0,0,'[career]',1,1),(32081227,1,1,'[]',0,0,'[career]',1,1),(32081228,1,1,'[]',0,0,'[]',1,1),(32081231,1,1,'[]',0,0,'[career]',1,1),(32081232,1,1,'[]',0,0,'[career]',1,1),(32081233,1,1,'[]',0,0,'[career]',1,1),(32081234,1,1,'[]',0,0,'[]',1,1),(32081235,1,1,'[]',0,0,'[career]',1,1),(32081236,1,1,'[]',0,0,'[career]',1,1),(32081237,1,1,'[]',0,0,'[career]',1,1),(32081238,1,1,'[]',0,0,'[]',1,1),(32081241,1,1,'[]',0,0,'[career]',1,1),(32081242,1,1,'[]',0,0,'[career]',1,1),(32081243,1,1,'[]',0,0,'[career]',1,1),(32081244,1,1,'[]',0,0,'[]',1,1),(32081245,1,1,'[]',0,0,'[career]',1,1),(32081246,1,1,'[]',0,0,'[career]',1,1),(32081247,1,1,'[]',0,0,'[career]',1,1),(32081248,1,1,'[]',0,0,'[]',1,1),(32081251,1,1,'[]',0,0,'[career]',1,1),(32081252,1,1,'[]',0,0,'[career]',1,1),(32081253,1,1,'[]',0,0,'[career]',1,1),(32081254,1,1,'[]',0,0,'[]',1,1),(32081255,1,1,'[]',0,0,'[career]',1,1),(32081256,1,1,'[]',0,0,'[career]',1,1),(32081257,1,1,'[]',0,0,'[career]',1,1),(32081258,1,1,'[]',0,0,'[]',1,1),(32081261,1,1,'[]',0,0,'[career]',1,1),(32081262,1,1,'[]',0,0,'[career]',1,1),(32081263,1,1,'[]',0,0,'[career]',1,1),(32081264,1,1,'[]',0,0,'[]',1,1),(32081265,1,1,'[]',0,0,'[career]',1,1),(32081266,1,1,'[]',0,0,'[career]',1,1),(32081267,1,1,'[]',0,0,'[career]',1,1),(32081268,1,1,'[]',0,0,'[]',1,1),(32081271,1,1,'[]',0,0,'[career]',1,1),(32081272,1,1,'[]',0,0,'[career]',1,1),(32081273,1,1,'[]',0,0,'[career]',1,1),(32081274,1,1,'[]',0,0,'[]',1,1),(32081275,1,1,'[]',0,0,'[career]',1,1),(32081276,1,1,'[]',0,0,'[career]',1,1),(32081277,1,1,'[]',0,0,'[career]',1,1),(32081278,1,1,'[]',0,0,'[]',1,1),(32081281,1,1,'[]',0,0,'[career]',1,1),(32081282,1,1,'[]',0,0,'[career]',1,1),(32081283,1,1,'[]',0,0,'[career]',1,1),(32081284,1,1,'[]',0,0,'[]',1,1),(32081285,1,1,'[]',0,0,'[career]',1,1),(32081286,1,1,'[]',0,0,'[career]',1,1),(32081287,1,1,'[]',0,0,'[career]',1,1),(32081288,1,1,'[]',0,0,'[]',1,1),(32081291,1,1,'[]',0,0,'[career]',1,1),(32081292,1,1,'[]',0,0,'[career]',1,1),(32081293,1,1,'[]',0,0,'[career]',1,1),(32081294,1,1,'[]',0,0,'[]',1,1),(32081295,1,1,'[]',0,0,'[career]',1,1),(32081296,1,1,'[]',0,0,'[career]',1,1),(32081297,1,1,'[]',0,0,'[career]',1,1),(32081298,1,1,'[]',0,0,'[]',1,1),(32081301,1,1,'[]',0,0,'[career]',1,1),(32081302,1,1,'[]',0,0,'[career]',1,1),(32081303,1,1,'[]',0,0,'[career]',1,1),(32081304,1,1,'[]',0,0,'[]',1,1),(32081305,1,1,'[]',0,0,'[career]',1,1),(32081306,1,1,'[]',0,0,'[career]',1,1),(32081307,1,1,'[]',0,0,'[career]',1,1),(32081308,1,1,'[]',0,0,'[]',1,1),(32081311,1,1,'[]',0,0,'[career]',1,1),(32081312,1,1,'[]',0,0,'[career]',1,1),(32081313,1,1,'[]',0,0,'[career]',1,1),(32081314,1,1,'[]',0,0,'[]',1,1),(32081315,1,1,'[]',0,0,'[career]',1,1),(32081316,1,1,'[]',0,0,'[career]',1,1),(32081317,1,1,'[]',0,0,'[career]',1,1),(32081318,1,1,'[]',0,0,'[]',1,1),(32081321,1,1,'[]',0,0,'[career]',1,1),(32081322,1,1,'[]',0,0,'[career]',1,1),(32081323,1,1,'[]',0,0,'[career]',1,1),(32081324,1,1,'[]',0,0,'[]',1,1),(32081325,1,1,'[]',0,0,'[career]',1,1),(32081326,1,1,'[]',0,0,'[career]',1,1),(32081327,1,1,'[]',0,0,'[career]',1,1),(32081328,1,1,'[]',0,0,'[]',1,1),(32081331,1,1,'[]',0,0,'[career]',1,1),(32081332,1,1,'[]',0,0,'[career]',1,1),(32081333,1,1,'[]',0,0,'[career]',1,1),(32081334,1,1,'[]',0,0,'[]',1,1),(32081335,1,1,'[]',0,0,'[career]',1,1),(32081336,1,1,'[]',0,0,'[career]',1,1),(32081337,1,1,'[]',0,0,'[career]',1,1),(32081338,1,1,'[]',0,0,'[]',1,1),(32081341,1,1,'[]',0,0,'[career]',1,1),(32081342,1,1,'[]',0,0,'[career]',1,1),(32081343,1,1,'[]',0,0,'[career]',1,1),(32081344,1,1,'[]',0,0,'[]',1,1),(32081345,1,1,'[]',0,0,'[career]',1,1),(32081346,1,1,'[]',0,0,'[career]',1,1),(32081347,1,1,'[]',0,0,'[career]',1,1),(32081348,1,1,'[]',0,0,'[]',1,1),(32081351,1,1,'[]',0,0,'[career]',1,1),(32081352,1,1,'[]',0,0,'[career]',1,1),(32081353,1,1,'[]',0,0,'[career]',1,1),(32081354,1,1,'[]',0,0,'[]',1,1),(32081355,1,1,'[]',0,0,'[career]',1,1),(32081356,1,1,'[]',0,0,'[career]',1,1),(32081357,1,1,'[]',0,0,'[career]',1,1),(32081358,1,1,'[]',0,0,'[]',1,1),(32081361,1,1,'[]',0,0,'[career]',1,1),(32081362,1,1,'[]',0,0,'[career]',1,1),(32081363,1,1,'[]',0,0,'[career]',1,1),(32081364,1,1,'[]',0,0,'[]',1,1),(32081365,1,1,'[]',0,0,'[career]',1,1),(32081366,1,1,'[]',0,0,'[career]',1,1),(32081367,1,1,'[]',0,0,'[career]',1,1),(32081368,1,1,'[]',0,0,'[]',1,1),(32081371,1,1,'[]',0,0,'[career]',1,1),(32081372,1,1,'[]',0,0,'[career]',1,1),(32081373,1,1,'[]',0,0,'[career]',1,1),(32081374,1,1,'[]',0,0,'[]',1,1),(32081375,1,1,'[]',0,0,'[career]',1,1),(32081376,1,1,'[]',0,0,'[career]',1,1),(32081377,1,1,'[]',0,0,'[career]',1,1),(32081378,1,1,'[]',0,0,'[]',1,1),(32081381,1,1,'[]',0,0,'[career]',1,1),(32081382,1,1,'[]',0,0,'[career]',1,1),(32081383,1,1,'[]',0,0,'[career]',1,1),(32081384,1,1,'[]',0,0,'[]',1,1),(32081385,1,1,'[]',0,0,'[career]',1,1),(32081386,1,1,'[]',0,0,'[career]',1,1),(32081387,1,1,'[]',0,0,'[career]',1,1),(32081388,1,1,'[]',0,0,'[]',1,1),(32081391,1,1,'[]',0,0,'[career]',1,1),(32081392,1,1,'[]',0,0,'[career]',1,1),(32081393,1,1,'[]',0,0,'[career]',1,1),(32081394,1,1,'[]',0,0,'[]',1,1),(32081395,1,1,'[]',0,0,'[career]',1,1),(32081396,1,1,'[]',0,0,'[career]',1,1),(32081397,1,1,'[]',0,0,'[career]',1,1),(32081398,1,1,'[]',0,0,'[]',1,1),(32081401,1,1,'[]',0,0,'[career]',1,1),(32081402,1,1,'[]',0,0,'[career]',1,1),(32081403,1,1,'[]',0,0,'[career]',1,1),(32081404,1,1,'[]',0,0,'[]',1,1),(32081405,1,1,'[]',0,0,'[career]',1,1),(32081406,1,1,'[]',0,0,'[career]',1,1),(32081407,1,1,'[]',0,0,'[career]',1,1),(32081408,1,1,'[]',0,0,'[]',1,1),(32081411,1,1,'[]',0,0,'[career]',1,1),(32081412,1,1,'[]',0,0,'[career]',1,1),(32081413,1,1,'[]',0,0,'[career]',1,1),(32081414,1,1,'[]',0,0,'[]',1,1),(32081415,1,1,'[]',0,0,'[career]',1,1),(32081416,1,1,'[]',0,0,'[career]',1,1),(32081417,1,1,'[]',0,0,'[career]',1,1),(32081418,1,1,'[]',0,0,'[]',1,1),(32081421,1,1,'[]',0,0,'[career]',1,1),(32081422,1,1,'[]',0,0,'[career]',1,1),(32081423,1,1,'[]',0,0,'[career]',1,1),(32081424,1,1,'[]',0,0,'[]',1,1),(32081425,1,1,'[]',0,0,'[career]',1,1),(32081426,1,1,'[]',0,0,'[career]',1,1),(32081427,1,1,'[]',0,0,'[career]',1,1),(32081428,1,1,'[]',0,0,'[]',1,1),(32081431,1,1,'[]',0,0,'[career]',1,1),(32081432,1,1,'[]',0,0,'[career]',1,1),(32081433,1,1,'[]',0,0,'[career]',1,1),(32081434,1,1,'[]',0,0,'[]',1,1),(32081435,1,1,'[]',0,0,'[career]',1,1),(32081436,1,1,'[]',0,0,'[career]',1,1),(32081437,1,1,'[]',0,0,'[career]',1,1),(32081438,1,1,'[]',0,0,'[]',1,1),(32081441,1,1,'[]',0,0,'[career]',1,1),(32081442,1,1,'[]',0,0,'[career]',1,1),(32081443,1,1,'[]',0,0,'[career]',1,1),(32081444,1,1,'[]',0,0,'[]',1,1),(32081445,1,1,'[]',0,0,'[career]',1,1),(32081446,1,1,'[]',0,0,'[career]',1,1),(32081447,1,1,'[]',0,0,'[career]',1,1),(32081448,1,1,'[]',0,0,'[]',1,1),(32081451,1,1,'[]',0,0,'[career]',1,1),(32081452,1,1,'[]',0,0,'[career]',1,1),(32081453,1,1,'[]',0,0,'[career]',1,1),(32081454,1,1,'[]',0,0,'[]',1,1),(32081455,1,1,'[]',0,0,'[career]',1,1),(32081456,1,1,'[]',0,0,'[career]',1,1),(32081457,1,1,'[]',0,0,'[career]',1,1),(32081458,1,1,'[]',0,0,'[]',1,1),(32081461,1,1,'[]',0,0,'[career]',1,1),(32081462,1,1,'[]',0,0,'[career]',1,1),(32081463,1,1,'[]',0,0,'[career]',1,1),(32081464,1,1,'[]',0,0,'[]',1,1),(32081465,1,1,'[]',0,0,'[career]',1,1),(32081466,1,1,'[]',0,0,'[career]',1,1),(32081467,1,1,'[]',0,0,'[career]',1,1),(32081468,1,1,'[]',0,0,'[]',1,1),(32081471,1,1,'[]',0,0,'[career]',1,1),(32081472,1,1,'[]',0,0,'[career]',1,1),(32081473,1,1,'[]',0,0,'[career]',1,1),(32081474,1,1,'[]',0,0,'[]',1,1),(32081475,1,1,'[]',0,0,'[career]',1,1),(32081476,1,1,'[]',0,0,'[career]',1,1),(32081477,1,1,'[]',0,0,'[career]',1,1),(32081478,1,1,'[]',0,0,'[]',1,1),(32081481,1,1,'[]',0,0,'[career]',1,1),(32081482,1,1,'[]',0,0,'[career]',1,1),(32081483,1,1,'[]',0,0,'[career]',1,1),(32081484,1,1,'[]',0,0,'[]',1,1),(32081485,1,1,'[]',0,0,'[career]',1,1),(32081486,1,1,'[]',0,0,'[career]',1,1),(32081487,1,1,'[]',0,0,'[career]',1,1),(32081488,1,1,'[]',0,0,'[]',1,1),(32081491,1,1,'[]',0,0,'[career]',1,1),(32081492,1,1,'[]',0,0,'[career]',1,1),(32081493,1,1,'[]',0,0,'[career]',1,1),(32081494,1,1,'[]',0,0,'[]',1,1),(32081495,1,1,'[]',0,0,'[career]',1,1),(32081496,1,1,'[]',0,0,'[career]',1,1),(32081497,1,1,'[]',0,0,'[career]',1,1),(32081498,1,1,'[]',0,0,'[]',1,1),(32081501,1,1,'[]',0,0,'[career]',1,1),(32081502,1,1,'[]',0,0,'[career]',1,1),(32081503,1,1,'[]',0,0,'[career]',1,1),(32081504,1,1,'[]',0,0,'[]',1,1),(32081505,1,1,'[]',0,0,'[career]',1,1),(32081506,1,1,'[]',0,0,'[career]',1,1),(32081507,1,1,'[]',0,0,'[career]',1,1),(32081508,1,1,'[]',0,0,'[]',1,1),(32081511,1,1,'[]',0,0,'[career]',1,1),(32081512,1,1,'[]',0,0,'[career]',1,1),(32081513,1,1,'[]',0,0,'[career]',1,1),(32081514,1,1,'[]',0,0,'[]',1,1),(32081515,1,1,'[]',0,0,'[career]',1,1),(32081516,1,1,'[]',0,0,'[career]',1,1),(32081517,1,1,'[]',0,0,'[career]',1,1),(32081518,1,1,'[]',0,0,'[]',1,1),(32081521,1,1,'[]',0,0,'[career]',1,1),(32081522,1,1,'[]',0,0,'[career]',1,1),(32081523,1,1,'[]',0,0,'[career]',1,1),(32081524,1,1,'[]',0,0,'[]',1,1),(32081525,1,1,'[]',0,0,'[career]',1,1),(32081526,1,1,'[]',0,0,'[career]',1,1),(32081527,1,1,'[]',0,0,'[career]',1,1),(32081528,1,1,'[]',0,0,'[]',1,1),(32081531,1,1,'[]',0,0,'[career]',1,1),(32081532,1,1,'[]',0,0,'[career]',1,1),(32081533,1,1,'[]',0,0,'[career]',1,1),(32081534,1,1,'[]',0,0,'[]',1,1),(32081535,1,1,'[]',0,0,'[career]',1,1),(32081536,1,1,'[]',0,0,'[career]',1,1),(32081537,1,1,'[]',0,0,'[career]',1,1),(32081538,1,1,'[]',0,0,'[]',1,1),(32081541,1,1,'[]',0,0,'[career]',1,1),(32081542,1,1,'[]',0,0,'[career]',1,1),(32081543,1,1,'[]',0,0,'[career]',1,1),(32081544,1,1,'[]',0,0,'[]',1,1),(32081545,1,1,'[]',0,0,'[career]',1,1),(32081546,1,1,'[]',0,0,'[career]',1,1),(32081547,1,1,'[]',0,0,'[career]',1,1),(32081548,1,1,'[]',0,0,'[]',1,1),(32081551,1,1,'[]',0,0,'[career]',1,1),(32081552,1,1,'[]',0,0,'[career]',1,1),(32081553,1,1,'[]',0,0,'[career]',1,1),(32081554,1,1,'[]',0,0,'[]',1,1),(32081555,1,1,'[]',0,0,'[career]',1,1),(32081556,1,1,'[]',0,0,'[career]',1,1),(32081557,1,1,'[]',0,0,'[career]',1,1),(32081558,1,1,'[]',0,0,'[]',1,1),(32081561,1,1,'[]',0,0,'[career]',1,1),(32081562,1,1,'[]',0,0,'[career]',1,1),(32081563,1,1,'[]',0,0,'[career]',1,1),(32081564,1,1,'[]',0,0,'[]',1,1),(32081565,1,1,'[]',0,0,'[career]',1,1),(32081566,1,1,'[]',0,0,'[career]',1,1),(32081567,1,1,'[]',0,0,'[career]',1,1),(32081568,1,1,'[]',0,0,'[]',1,1),(32081571,1,1,'[]',0,0,'[career]',1,1),(32081572,1,1,'[]',0,0,'[career]',1,1),(32081573,1,1,'[]',0,0,'[career]',1,1),(32081574,1,1,'[]',0,0,'[]',1,1),(32081575,1,1,'[]',0,0,'[career]',1,1),(32081576,1,1,'[]',0,0,'[career]',1,1),(32081577,1,1,'[]',0,0,'[career]',1,1),(32081578,1,1,'[]',0,0,'[]',1,1),(32081581,1,1,'[]',0,0,'[career]',1,1),(32081582,1,1,'[]',0,0,'[career]',1,1),(32081583,1,1,'[]',0,0,'[career]',1,1),(32081584,1,1,'[]',0,0,'[]',1,1),(32081585,1,1,'[]',0,0,'[career]',1,1),(32081586,1,1,'[]',0,0,'[career]',1,1),(32081587,1,1,'[]',0,0,'[career]',1,1),(32081588,1,1,'[]',0,0,'[]',1,1),(32081591,1,1,'[]',0,0,'[career]',1,1),(32081592,1,1,'[]',0,0,'[career]',1,1),(32081593,1,1,'[]',0,0,'[career]',1,1),(32081594,1,1,'[]',0,0,'[]',1,1),(32081595,1,1,'[]',0,0,'[career]',1,1),(32081596,1,1,'[]',0,0,'[career]',1,1),(32081597,1,1,'[]',0,0,'[career]',1,1),(32081598,1,1,'[]',0,0,'[]',1,1),(32081601,1,1,'[]',0,0,'[career]',1,1),(32081602,1,1,'[]',0,0,'[career]',1,1),(32081603,1,1,'[]',0,0,'[career]',1,1),(32081604,1,1,'[]',0,0,'[]',1,1),(32081605,1,1,'[]',0,0,'[career]',1,1),(32081606,1,1,'[]',0,0,'[career]',1,1),(32081607,1,1,'[]',0,0,'[career]',1,1),(32081608,1,1,'[]',0,0,'[]',1,1),(32081611,1,1,'[]',0,0,'[career]',1,1),(32081612,1,1,'[]',0,0,'[career]',1,1),(32081613,1,1,'[]',0,0,'[career]',1,1),(32081614,1,1,'[]',0,0,'[]',1,1),(32081615,1,1,'[]',0,0,'[career]',1,1),(32081616,1,1,'[]',0,0,'[career]',1,1),(32081617,1,1,'[]',0,0,'[career]',1,1),(32081618,1,1,'[]',0,0,'[]',1,1),(32081621,1,1,'[]',0,0,'[career]',1,1),(32081622,1,1,'[]',0,0,'[career]',1,1),(32081623,1,1,'[]',0,0,'[career]',1,1),(32081624,1,1,'[]',0,0,'[]',1,1),(32081625,1,1,'[]',0,0,'[career]',1,1),(32081626,1,1,'[]',0,0,'[career]',1,1),(32081627,1,1,'[]',0,0,'[career]',1,1),(32081628,1,1,'[]',0,0,'[]',1,1),(32081631,1,1,'[]',0,0,'[career]',1,1),(32081632,1,1,'[]',0,0,'[career]',1,1),(32081633,1,1,'[]',0,0,'[career]',1,1),(32081634,1,1,'[]',0,0,'[]',1,1),(32081635,1,1,'[]',0,0,'[career]',1,1),(32081636,1,1,'[]',0,0,'[career]',1,1),(32081637,1,1,'[]',0,0,'[career]',1,1),(32081638,1,1,'[]',0,0,'[]',1,1),(32081641,1,1,'[]',0,0,'[career]',1,1),(32081642,1,1,'[]',0,0,'[career]',1,1),(32081643,1,1,'[]',0,0,'[career]',1,1),(32081644,1,1,'[]',0,0,'[]',1,1),(32081645,1,1,'[]',0,0,'[career]',1,1),(32081646,1,1,'[]',0,0,'[career]',1,1),(32081647,1,1,'[]',0,0,'[career]',1,1),(32081648,1,1,'[]',0,0,'[]',1,1),(32081651,1,1,'[]',0,0,'[career]',1,1),(32081652,1,1,'[]',0,0,'[career]',1,1),(32081653,1,1,'[]',0,0,'[career]',1,1),(32081654,1,1,'[]',0,0,'[]',1,1),(32081655,1,1,'[]',0,0,'[career]',1,1),(32081656,1,1,'[]',0,0,'[career]',1,1),(32081657,1,1,'[]',0,0,'[career]',1,1),(32081658,1,1,'[]',0,0,'[]',1,1),(32081661,1,1,'[]',0,0,'[career]',1,1),(32081662,1,1,'[]',0,0,'[career]',1,1),(32081663,1,1,'[]',0,0,'[career]',1,1),(32081664,1,1,'[]',0,0,'[]',1,1),(32081665,1,1,'[]',0,0,'[career]',1,1),(32081666,1,1,'[]',0,0,'[career]',1,1),(32081667,1,1,'[]',0,0,'[career]',1,1),(32081668,1,1,'[]',0,0,'[]',1,1),(32081671,1,1,'[]',0,0,'[career]',1,1),(32081672,1,1,'[]',0,0,'[career]',1,1),(32081673,1,1,'[]',0,0,'[career]',1,1),(32081674,1,1,'[]',0,0,'[]',1,1),(32081675,1,1,'[]',0,0,'[career]',1,1),(32081676,1,1,'[]',0,0,'[career]',1,1),(32081677,1,1,'[]',0,0,'[career]',1,1),(32081678,1,1,'[]',0,0,'[]',1,1),(32081681,1,1,'[]',0,0,'[career]',1,1),(32081682,1,1,'[]',0,0,'[career]',1,1),(32081683,1,1,'[]',0,0,'[career]',1,1),(32081684,1,1,'[]',0,0,'[]',1,1),(32081685,1,1,'[]',0,0,'[career]',1,1),(32081686,1,1,'[]',0,0,'[career]',1,1),(32081687,1,1,'[]',0,0,'[career]',1,1),(32081688,1,1,'[]',0,0,'[]',1,1),(32081691,1,1,'[]',0,0,'[career]',1,1),(32081692,1,1,'[]',0,0,'[career]',1,1),(32081693,1,1,'[]',0,0,'[career]',1,1),(32081694,1,1,'[]',0,0,'[]',1,1),(32081695,1,1,'[]',0,0,'[career]',1,1),(32081696,1,1,'[]',0,0,'[career]',1,1),(32081697,1,1,'[]',0,0,'[career]',1,1),(32081698,1,1,'[]',0,0,'[]',1,1),(32081701,1,1,'[]',0,0,'[career]',1,1),(32081702,1,1,'[]',0,0,'[career]',1,1),(32081703,1,1,'[]',0,0,'[career]',1,1),(32081704,1,1,'[]',0,0,'[]',1,1),(32081705,1,1,'[]',0,0,'[career]',1,1),(32081706,1,1,'[]',0,0,'[career]',1,1),(32081707,1,1,'[]',0,0,'[career]',1,1),(32081708,1,1,'[]',0,0,'[lv]',1,1),(32090001,1,1,'[]',0,0,'[lv]',1,1),(32090002,1,1,'[]',0,0,'[lv]',1,1),(32090003,1,1,'[]',0,0,'[lv]',1,1),(32100002,1,1,'[]',0,0,'[lv]',1,1),(32100003,1,1,'[]',0,0,'[lv]',1,1),(32100004,1,1,'[]',0,0,'[lv]',1,1),(32100005,1,1,'[]',0,0,'[lv]',1,1),(32100006,1,1,'[]',0,0,'[lv]',1,1),(32100007,1,1,'[]',0,0,'[lv]',1,1),(32100008,1,1,'[]',0,0,'[lv]',1,1),(32100009,1,1,'[]',0,0,'[lv]',1,1),(32100010,1,1,'[]',0,0,'[lv]',1,1),(32100011,1,1,'[]',0,0,'[lv]',1,1),(32100012,1,1,'[]',0,0,'[lv]',1,1),(32100013,1,1,'[]',0,0,'[lv]',1,1),(32100014,1,1,'[]',0,0,'[lv]',1,1),(32100015,1,1,'[]',0,0,'[lv]',1,1),(32100016,1,1,'[]',0,0,'[lv]',1,1),(32110011,1,1,'[]',0,0,'[lv]',1,1),(32110012,1,1,'[]',0,0,'[lv]',1,1),(32110013,1,1,'[]',0,0,'[lv]',1,1),(32110014,1,1,'[]',0,0,'[lv]',1,1),(32110021,1,1,'[]',0,0,'[lv]',1,1),(32110022,1,1,'[]',0,0,'[lv]',1,1),(32110023,1,1,'[]',0,0,'[lv]',1,1),(32110024,1,1,'[]',0,0,'[lv]',1,1),(32110031,1,1,'[]',0,0,'[lv]',1,1),(32110032,1,1,'[]',0,0,'[lv]',1,1),(32110033,1,1,'[]',0,0,'[lv]',1,1),(32110034,1,1,'[]',0,0,'[lv]',1,1),(32110041,1,1,'[]',0,0,'[lv]',1,1),(32110042,1,1,'[]',0,0,'[lv]',1,1),(32110043,1,1,'[]',0,0,'[lv]',1,1),(32110044,1,1,'[]',0,0,'[lv]',1,1),(32110051,1,1,'[]',0,0,'[lv]',1,1),(32110052,1,1,'[]',0,0,'[lv]',1,1),(32110053,1,1,'[]',0,0,'[lv]',1,1),(32110054,1,1,'[]',0,0,'[lv]',1,1),(32110061,1,1,'[]',0,0,'[lv]',1,1),(32110062,1,1,'[]',0,0,'[lv]',1,1),(32110063,1,1,'[]',0,0,'[lv]',1,1),(32110064,1,1,'[]',0,0,'[lv]',1,1),(32110071,1,1,'[]',0,0,'[lv]',1,1),(32110072,1,1,'[]',0,0,'[lv]',1,1),(32110073,1,1,'[]',0,0,'[lv]',1,1),(32110074,1,1,'[]',0,0,'[lv]',1,1),(32110081,1,1,'[]',0,0,'[lv]',1,1),(32110082,1,1,'[]',0,0,'[lv]',1,1),(32110083,1,1,'[]',0,0,'[lv]',1,1),(32110084,1,1,'[]',0,0,'[lv]',1,1),(32110091,1,1,'[]',0,0,'[lv]',1,1),(32110092,1,1,'[]',0,0,'[lv]',1,1),(32110093,1,1,'[]',0,0,'[lv]',1,1),(32110094,1,1,'[]',0,0,'[lv]',1,1),(32110101,1,1,'[]',0,0,'[lv]',1,1),(32110102,1,1,'[]',0,0,'[lv]',1,1),(32110103,1,1,'[]',0,0,'[lv]',1,1),(32110104,1,1,'[]',0,0,'[lv]',1,1),(32110201,1,1,'[]',0,0,'[lv]',1,1),(32110202,1,1,'[]',0,0,'[lv]',1,1),(32110203,1,1,'[]',0,0,'[lv]',1,1),(32110204,1,1,'[]',0,0,'[lv]',1,1),(32111001,1,1,'[]',0,0,'[lv]',1,1),(32111002,1,1,'[]',0,0,'[lv]',1,1),(32111003,1,1,'[]',0,0,'[lv]',1,1),(32111004,1,1,'[]',0,0,'[lv]',1,1),(32120101,1,1,'[]',0,0,'[lv]',1,1),(32120102,1,1,'[]',0,0,'[lv]',1,1),(32120201,1,1,'[]',0,0,'[lv]',1,1),(32120202,1,1,'[]',0,0,'[lv]',1,1),(32120301,1,1,'[]',0,0,'[lv]',1,1),(32120302,1,1,'[]',0,0,'[lv]',1,1),(32120401,1,1,'[]',0,0,'[lv]',1,1),(32120402,1,1,'[]',0,0,'[lv]',1,1),(32130001,1,1,'[]',0,0,'[lv]',1,1),(32130002,1,1,'[]',0,0,'[lv]',1,1),(32130003,1,1,'[]',0,0,'[lv]',1,1),(32130004,1,1,'[]',0,0,'[lv]',1,1),(32140001,1,1,'[]',0,0,'[lv]',1,1),(32140002,1,1,'[]',0,0,'[lv]',1,1),(32150001,1,1,'[]',0,0,'[lv]',1,1),(32150002,1,1,'[]',0,0,'[lv]',1,1),(32150003,1,1,'[]',0,0,'[lv]',1,1),(32150004,1,1,'[]',0,0,'[lv]',1,1),(32160001,1,1,'[]',0,0,'[lv]',1,1),(32160002,1,0,'[]',0,0,'[lv]',1,1),(32160003,1,1,'[]',0,0,'[lv]',1,1),(32160004,1,1,'[]',0,0,'[lv]',1,1),(32160005,1,1,'[]',0,0,'[lv]',1,1),(32160006,1,1,'[]',0,0,'[lv]',1,1),(32160007,1,1,'[]',0,0,'[lv]',1,1),(32160008,1,1,'[]',0,0,'[career]',1,1),(32160009,1,1,'[]',0,0,'[career]',1,1),(32160010,1,1,'[]',0,0,'[career]',1,1),(32160011,1,1,'[]',0,0,'[lv]',1,1),(32160012,1,1,'[]',0,0,'[lv]',1,1),(32160013,1,1,'[]',0,0,'[lv]',1,1),(32160014,1,1,'[]',0,0,'[lv]',1,1),(32160015,1,1,'[]',0,0,'[lv]',1,1),(32160016,1,1,'[]',0,0,'[lv]',1,1),(32160017,1,1,'[]',0,0,'[lv]',1,1),(32160018,1,1,'[]',0,0,'[lv]',1,1),(32160019,1,1,'[]',0,0,'[lv]',1,1),(32160020,1,1,'[]',0,0,'[lv]',1,1),(32160021,1,1,'[]',0,0,'[lv]',1,1),(32160022,1,1,'[]',0,0,'[lv]',1,1),(32160023,1,1,'[]',0,0,'[lv]',1,1),(32160024,1,1,'[]',0,0,'[lv]',1,1),(32170001,1,1,'[]',0,0,'[lv]',1,1),(32170002,1,1,'[]',0,0,'[lv]',1,1),(32170003,1,1,'[]',0,0,'[lv]',1,1),(32170004,1,1,'[]',0,0,'[lv]',1,1),(32170005,1,1,'[]',0,0,'[lv]',1,1),(32170101,1,1,'[]',0,0,'[lv]',1,1),(32170102,1,1,'[]',0,0,'[lv]',1,1),(32170103,1,1,'[]',0,0,'[lv]',1,1),(32170104,1,1,'[]',0,0,'[lv]',1,1),(32170105,1,1,'[]',0,0,'[lv]',1,1),(32170201,1,1,'[]',0,0,'[lv]',1,1),(32170202,1,1,'[]',0,0,'[lv]',1,1),(32170203,1,1,'[]',0,0,'[lv]',1,1),(32170204,1,1,'[]',0,0,'[lv]',1,1),(32170205,1,1,'[]',0,0,'[lv]',1,1),(32170301,1,1,'[]',0,0,'[lv]',1,1),(32170302,1,1,'[]',0,0,'[lv]',1,1),(32170303,1,1,'[]',0,0,'[lv]',1,1),(32170304,1,1,'[]',0,0,'[lv]',1,1),(32170305,1,1,'[]',0,0,'[lv]',1,1),(32170401,1,1,'[]',0,0,'[lv]',1,1),(32170402,1,1,'[]',0,0,'[lv]',1,1),(32170403,1,1,'[]',0,0,'[lv]',1,1),(32170404,1,1,'[]',0,0,'[lv]',1,1),(32170405,1,1,'[]',0,0,'[lv]',1,1),(32170501,1,1,'[]',0,0,'[lv]',1,1),(32170502,1,1,'[]',0,0,'[lv]',1,1),(32170503,1,1,'[]',0,0,'[lv]',1,1),(32170504,1,1,'[]',0,0,'[lv]',1,1),(32170505,1,1,'[]',0,0,'[lv]',1,1);
/*!40000 ALTER TABLE `base_gift_box` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_gift_list`
--

DROP TABLE IF EXISTS `base_gift_list`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_gift_list` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '序号',
  `gift_type` varchar(4) NOT NULL COMMENT '标识符，4位固定',
  `name` varchar(50) NOT NULL COMMENT '礼包名@lang@',
  `source` varchar(20) NOT NULL COMMENT '渠道',
  `list` varchar(1000) DEFAULT '[]' COMMENT '内容列表',
  `start_time` int(11) DEFAULT '0' COMMENT '有效开始，无0',
  `end_time` int(11) DEFAULT '0' COMMENT '有效结束，无0',
  `use_num` int(11) DEFAULT '1' COMMENT '同类型推广礼包最大叠加使用次数',
  PRIMARY KEY (`id`),
  UNIQUE KEY `type` (`gift_type`)
) ENGINE=InnoDB AUTO_INCREMENT=17 DEFAULT CHARSET=utf8 COMMENT='礼品卡列表配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_gift_list`
--

LOCK TABLES `base_gift_list` WRITE;
/*!40000 ALTER TABLE `base_gift_list` DISABLE KEYS */;
INSERT INTO `base_gift_list` VALUES (1,'u4ot','新手测试礼品卡','','[{3,0,1000},{2,0,500}]',1499840314,1501481918,1),(2,'w7sy','测试卡','JY','[{3,0,111},{5,0,222},{2,0,111}]',0,0,1),(3,'6jpm','激活码','','[{100,110101,10},{0,110101,10},{3,0,100}]',0,0,2),(4,'i507','封测加群礼包','','[{0,260201,5},{0,111010033,1},{0,228801,1},{1,0,1500}]',0,1500998400,1),(5,'3rab','封测新手礼包','','[{0,240502,1},{0,410120,5},{0,400003,1},{1,0,200}]',0,1500998400,1),(7,'canm','封测特权礼包','','[{0,240101,5},{0,240301,1},{3,0,8000},{2,0,200}]',0,1500998400,1),(15,'ny6g','123123','','[{100,110102,10}]',0,0,1),(16,'6etl','测试礼包','','[{0,32000000,1},{2,0,50}]',1512132257,1512218659,1);
/*!40000 ALTER TABLE `base_gift_list` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_gift_reward`
--

DROP TABLE IF EXISTS `base_gift_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_gift_reward` (
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '礼包ID',
  `slv` smallint(6) unsigned NOT NULL DEFAULT '0' COMMENT '开启等级',
  `elv` smallint(6) unsigned NOT NULL DEFAULT '0' COMMENT '结束等级',
  `sex` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '性别',
  `career` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '职业',
  `turn` smallint(6) unsigned NOT NULL DEFAULT '0' COMMENT '转生',
  `rand` int(11) unsigned DEFAULT '0' COMMENT '随机次数',
  `is_back` tinyint(1) unsigned DEFAULT '0' COMMENT '是否放回随机##0:否;1:是',
  `rand_gifts` varchar(5000) DEFAULT '[]' COMMENT '随机物品##[{{类型, 物品id, 数量}, R(权重)}]',
  `fixed_gifts` varchar(5000) DEFAULT '[]' COMMENT '固定物品##[{类型, 物品id, 数量}]',
  `tv_goods_id` varchar(1000) DEFAULT '[]' COMMENT '需要传闻的物品id##打开礼包时如果开到这些物品,会发传闻',
  PRIMARY KEY (`goods_id`,`slv`,`elv`,`sex`,`career`,`turn`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_gift_reward`
--

LOCK TABLES `base_gift_reward` WRITE;
/*!40000 ALTER TABLE `base_gift_reward` DISABLE KEYS */;
INSERT INTO `base_gift_reward` VALUES (32000000,0,1000,0,0,0,1,1,'[{{0,17020001,1},40},{{0,17020002,1},40},{{0,24020001,1},10},{{0,24020002,1},10}]','[]','[17020001,17020002,24020001,24020002]'),(32000011,0,1000,0,0,0,1,1,'[{{0,17020001,1},40},{{0,17020002,1},40},{{0,24020001,1},10},{{0,24020002,1},10}]','[]','[17020001,17020002,24020001,24020002]'),(32000012,0,1000,0,0,0,1,1,'[{{0,17020002,1},45},{{0,17020003,1},5},{{0,24020002,1},45},{{0,24020003,1},5}]','[]','[17020002,17020003,24020002,24020003]'),(32000013,0,1000,0,0,0,1,1,'[{{0,17020003,1},45},{{0,17020004,1},5},{{0,24020003,1},45},{{0,24020004,1},5}]','[]','[17020003,17020004,24020003,24020004]'),(32000021,0,1000,0,0,0,1,1,'[{{0,16010001,1},40},{{0,16010002,1},40},{{0,20020001,1},10},{{0,20020002,1},10}]','[]','[16010001,16010002,20020001,20020002]'),(32000022,0,1000,0,0,0,1,1,'[{{0,16010002,1},45},{{0,16010003,1},5},{{0,20020002,1},45},{{0,20020003,1},5}]','[]','[16010002,16010003,20020002,20020003]'),(32000023,0,1000,0,0,0,1,1,'[{{0,16010003,1},45},{{0,16010004,1},5},{{0,20020003,1},45},{{0,20020004,1},5}]','[]','[16010003,16010004,20020003,20020004]'),(32000024,0,1000,0,0,0,0,0,'[]','[{0,11020001,10},{0,32000025,1}]','[]'),(32000025,0,1000,0,0,0,0,0,'[]','[{0,24010001,10},{0,32000026,1}]','[]'),(32000026,0,1000,0,0,0,0,0,'[]','[{0,16020001,10},{0,32000027,1}]','[]'),(32000027,0,1000,0,0,0,0,0,'[]','[{0,14010103,1},{0,14020203,1}]','[]'),(32000028,0,1000,0,0,0,1,1,'[{{0,17020001,1},10},{{0,24020001,1},10}]','[]','[]'),(32000029,0,1000,0,1,0,0,0,'[]','[{0,20010011,1}]','[20010011]'),(32000029,0,1000,0,2,0,0,0,'[]','[{0,20010021,1}]','[20010021]'),(32000029,0,1000,0,3,0,0,0,'[]','[{0,20010031,1}]','[20010031]'),(32000029,0,1000,0,4,0,0,0,'[]','[{0,20010041,1}]','[20010041]'),(32000030,0,1000,0,1,0,0,0,'[]','[{0,20010012,1}]','[20010012]'),(32000030,0,1000,0,2,0,0,0,'[]','[{0,20010022,1}]','[20010022]'),(32000030,0,1000,0,3,0,0,0,'[]','[{0,20010032,1}]','[20010032]'),(32000030,0,1000,0,4,0,0,0,'[]','[{0,20010042,1}]','[20010042]'),(32000031,0,1000,0,1,0,0,0,'[]','[{0,20010013,1}]','[20010013]'),(32000031,0,1000,0,2,0,0,0,'[]','[{0,20010023,1}]','[20010023]'),(32000031,0,1000,0,3,0,0,0,'[]','[{0,20010033,1}]','[20010033]'),(32000031,0,1000,0,4,0,0,0,'[]','[{0,20010043,1}]','[20010043]'),(32000032,0,1000,0,1,0,0,0,'[]','[{0,20010014,1}]','[20010014]'),(32000032,0,1000,0,2,0,0,0,'[]','[{0,20010024,1}]','[20010024]'),(32000032,0,1000,0,3,0,0,0,'[]','[{0,20010034,1}]','[20010034]'),(32000032,0,1000,0,4,0,0,0,'[]','[{0,20010044,1}]','[20010044]'),(32000033,0,1000,0,1,0,0,0,'[]','[{0,20010015,1}]','[20010015]'),(32000033,0,1000,0,2,0,0,0,'[]','[{0,20010025,1}]','[20010025]'),(32000033,0,1000,0,3,0,0,0,'[]','[{0,20010035,1}]','[20010035]'),(32000033,0,1000,0,4,0,0,0,'[]','[{0,20010045,1}]','[20010045]'),(32000034,0,1000,0,1,0,0,0,'[]','[{0,20010016,1}]','[20010016]'),(32000034,0,1000,0,2,0,0,0,'[]','[{0,20010026,1}]','[20010026]'),(32000034,0,1000,0,3,0,0,0,'[]','[{0,20010036,1}]','[20010036]'),(32000034,0,1000,0,4,0,0,0,'[]','[{0,20010046,1}]','[20010046]'),(32000035,0,1000,0,1,0,0,0,'[]','[{0,1007010442,1}]','[1007010442]'),(32000035,0,1000,0,2,0,0,0,'[]','[{0,1007020442,1}]','[1007020442]'),(32000035,0,1000,0,3,0,0,0,'[]','[{0,1007030442,1}]','[1007030442]'),(32000035,0,1000,0,4,0,0,0,'[]','[{0,1007040442,1}]','[1007040442]'),(32000036,0,1000,0,1,0,0,0,'[]','[{0,1001010663,1}]','[1001010663]'),(32000036,0,1000,0,2,0,0,0,'[]','[{0,1001020663,1}]','[1001020663]'),(32000036,0,1000,0,3,0,0,0,'[]','[{0,1001030663,1}]','[1001030663]'),(32000036,0,1000,0,4,0,0,0,'[]','[{0,1001040663,1}]','[1001040663]'),(32000037,0,199,0,1,0,1,1,'[{{100,1004010241,1},24},{{100,1002010241,1},24},{{100,1008010241,1},24},{{100,1006010241,1},24},{{100,1010010241,1},24},{{100,1001010241,1},34},{{100,1007010241,1},34},{{100,1004010242,1},2},{{100,1002010242,1},2},{{100,1008010242,1},2},{{100,1006010242,1},2},{{100,1010010242,1},2},{{100,1001010242,1},1},{{100,1007010242,1},1}]','[]','[1004010241,1002010241,1008010241,1006010241,1010010241,1001010241,1007010241,1004010242,1002010242,1008010242,1006010242,1010010242,1001010242,1007010242]'),(32000037,0,199,0,2,0,1,1,'[{{100,1004020241,1},24},{{100,1002020241,1},24},{{100,1008020241,1},24},{{100,1006020241,1},24},{{100,1010020241,1},24},{{100,1001020241,1},34},{{100,1007020241,1},34},{{100,1004020242,1},2},{{100,1002020242,1},2},{{100,1008020242,1},2},{{100,1006020242,1},2},{{100,1010020242,1},2},{{100,1001020242,1},1},{{100,1007020242,1},1}]','[]','[1004020241,1002020241,1008020241,1006020241,1010020241,1001020241,1007020241,1004020242,1002020242,1008020242,1006020242,1010020242,1001020242,1007020242]'),(32000037,0,199,0,3,0,1,1,'[{{100,1004030241,1},24},{{100,1002030241,1},24},{{100,1008030241,1},24},{{100,1006030241,1},24},{{100,1010030241,1},24},{{100,1001030241,1},34},{{100,1007030241,1},34},{{100,1004030242,1},2},{{100,1002030242,1},2},{{100,1008030242,1},2},{{100,1006030242,1},2},{{100,1010030242,1},2},{{100,1001030242,1},1},{{100,1007030242,1},1}]','[]','[1004030241,1002030241,1008030241,1006030241,1010030241,1001030241,1007030241,1004030242,1002030242,1008030242,1006030242,1010030242,1001030242,1007030242]'),(32000037,0,199,0,4,0,1,1,'[{{100,1004040241,1},24},{{100,1002040241,1},24},{{100,1008040241,1},24},{{100,1006040241,1},24},{{100,1010040241,1},24},{{100,1001040241,1},34},{{100,1007040241,1},34},{{100,1004040242,1},2},{{100,1002040242,1},2},{{100,1008040242,1},2},{{100,1006040242,1},2},{{100,1010040242,1},2},{{100,1001040242,1},1},{{100,1007040242,1},1}]','[]','[1004040241,1002040241,1008040241,1006040241,1010040241,1001040241,1007040241,1004040242,1002040242,1008040242,1006040242,1010040242,1001040242,1007040242]'),(32000037,200,299,0,1,0,1,1,'[{{100,1004010341,1},24},{{100,1002010341,1},24},{{100,1008010341,1},24},{{100,1006010341,1},24},{{100,1010010341,1},24},{{100,1001010341,1},34},{{100,1007010341,1},34},{{100,1004010342,1},2},{{100,1002010342,1},2},{{100,1008010342,1},2},{{100,1006010342,1},2},{{100,1010010342,1},2},{{100,1001010342,1},1},{{100,1007010342,1},1}]','[]','[1004010341,1002010341,1008010341,1006010341,1010010341,1001010341,1007010341,1004010342,1002010342,1008010342,1006010342,1010010342,1001010342,1007010342]'),(32000037,200,299,0,2,0,1,1,'[{{100,1004020341,1},24},{{100,1002020341,1},24},{{100,1008020341,1},24},{{100,1006020341,1},24},{{100,1010020341,1},24},{{100,1001020341,1},34},{{100,1007020341,1},34},{{100,1004020342,1},2},{{100,1002020342,1},2},{{100,1008020342,1},2},{{100,1006020342,1},2},{{100,1010020342,1},2},{{100,1001020342,1},1},{{100,1007020342,1},1}]','[]','[1004020341,1002020341,1008020341,1006020341,1010020341,1001020341,1007020341,1004020342,1002020342,1008020342,1006020342,1010020342,1001020342,1007020342]'),(32000037,200,299,0,3,0,1,1,'[{{100,1004030341,1},24},{{100,1002030341,1},24},{{100,1008030341,1},24},{{100,1006030341,1},24},{{100,1010030341,1},24},{{100,1001030341,1},34},{{100,1007030341,1},34},{{100,1004030342,1},2},{{100,1002030342,1},2},{{100,1008030342,1},2},{{100,1006030342,1},2},{{100,1010030342,1},2},{{100,1001030342,1},1},{{100,1007030342,1},1}]','[]','[1004030341,1002030341,1008030341,1006030341,1010030341,1001030341,1007030341,1004030342,1002030342,1008030342,1006030342,1010030342,1001030342,1007030342]'),(32000037,200,299,0,4,0,1,1,'[{{100,1004040341,1},24},{{100,1002040341,1},24},{{100,1008040341,1},24},{{100,1006040341,1},24},{{100,1010040341,1},24},{{100,1001040341,1},34},{{100,1007040341,1},34},{{100,1004040342,1},2},{{100,1002040342,1},2},{{100,1008040342,1},2},{{100,1006040342,1},2},{{100,1010040342,1},2},{{100,1001040342,1},1},{{100,1007040342,1},1}]','[]','[1004040341,1002040341,1008040341,1006040341,1010040341,1001040341,1007040341,1004040342,1002040342,1008040342,1006040342,1010040342,1001040342,1007040342]'),(32000037,300,399,0,1,0,1,1,'[{{100,1004010441,1},24},{{100,1002010441,1},24},{{100,1008010441,1},24},{{100,1006010441,1},24},{{100,1010010441,1},24},{{100,1001010441,1},34},{{100,1007010441,1},34},{{100,1004010442,1},2},{{100,1002010442,1},2},{{100,1008010442,1},2},{{100,1006010442,1},2},{{100,1010010442,1},2},{{100,1001010442,1},1},{{100,1007010442,1},1}]','[]','[1004010441,1002010441,1008010441,1006010441,1010010441,1001010441,1007010441,1004010442,1002010442,1008010442,1006010442,1010010442,1001010442,1007010442]'),(32000037,300,399,0,2,0,1,1,'[{{100,1004020441,1},24},{{100,1002020441,1},24},{{100,1008020441,1},24},{{100,1006020441,1},24},{{100,1010020441,1},24},{{100,1001020441,1},34},{{100,1007020441,1},34},{{100,1004020442,1},2},{{100,1002020442,1},2},{{100,1008020442,1},2},{{100,1006020442,1},2},{{100,1010020442,1},2},{{100,1001020442,1},1},{{100,1007020442,1},1}]','[]','[1004020441,1002020441,1008020441,1006020441,1010020441,1001020441,1007020441,1004020442,1002020442,1008020442,1006020442,1010020442,1001020442,1007020442]'),(32000037,300,399,0,3,0,1,1,'[{{100,1004030441,1},24},{{100,1002030441,1},24},{{100,1008030441,1},24},{{100,1006030441,1},24},{{100,1010030441,1},24},{{100,1001030441,1},34},{{100,1007030441,1},34},{{100,1004030442,1},2},{{100,1002030442,1},2},{{100,1008030442,1},2},{{100,1006030442,1},2},{{100,1010030442,1},2},{{100,1001030442,1},1},{{100,1007030442,1},1}]','[]','[1004030441,1002030441,1008030441,1006030441,1010030441,1001030441,1007030441,1004030442,1002030442,1008030442,1006030442,1010030442,1001030442,1007030442]'),(32000037,300,399,0,4,0,1,1,'[{{100,1004040441,1},24},{{100,1002040441,1},24},{{100,1008040441,1},24},{{100,1006040441,1},24},{{100,1010040441,1},24},{{100,1001040441,1},34},{{100,1007040441,1},34},{{100,1004040442,1},2},{{100,1002040442,1},2},{{100,1008040442,1},2},{{100,1006040442,1},2},{{100,1010040442,1},2},{{100,1001040442,1},1},{{100,1007040442,1},1}]','[]','[1004040441,1002040441,1008040441,1006040441,1010040441,1001040441,1007040441,1004040442,1002040442,1008040442,1006040442,1010040442,1001040442,1007040442]'),(32000037,400,1000,0,1,0,1,1,'[{{100,1004010541,1},24},{{100,1002010541,1},24},{{100,1008010541,1},24},{{100,1006010541,1},24},{{100,1010010541,1},24},{{100,1001010541,1},34},{{100,1007010541,1},34},{{100,1004010542,1},2},{{100,1002010542,1},2},{{100,1008010542,1},2},{{100,1006010542,1},2},{{100,1010010542,1},2},{{100,1001010542,1},1},{{100,1007010542,1},1}]','[]','[1004010541,1002010541,1008010541,1006010541,1010010541,1001010541,1007010541,1004010542,1002010542,1008010542,1006010542,1010010542,1001010542,1007010542]'),(32000037,400,1000,0,2,0,1,1,'[{{100,1004020541,1},24},{{100,1002020541,1},24},{{100,1008020541,1},24},{{100,1006020541,1},24},{{100,1010020541,1},24},{{100,1001020541,1},34},{{100,1007020541,1},34},{{100,1004020542,1},2},{{100,1002020542,1},2},{{100,1008020542,1},2},{{100,1006020542,1},2},{{100,1010020542,1},2},{{100,1001020542,1},1},{{100,1007020542,1},1}]','[]','[1004020541,1002020541,1008020541,1006020541,1010020541,1001020541,1007020541,1004020542,1002020542,1008020542,1006020542,1010020542,1001020542,1007020542]'),(32000037,400,1000,0,3,0,1,1,'[{{100,1004030541,1},24},{{100,1002030541,1},24},{{100,1008030541,1},24},{{100,1006030541,1},24},{{100,1010030541,1},24},{{100,1001030541,1},34},{{100,1007030541,1},34},{{100,1004030542,1},2},{{100,1002030542,1},2},{{100,1008030542,1},2},{{100,1006030542,1},2},{{100,1010030542,1},2},{{100,1001030542,1},1},{{100,1007030542,1},1}]','[]','[1004030541,1002030541,1008030541,1006030541,1010030541,1001030541,1007030541,1004030542,1002030542,1008030542,1006030542,1010030542,1001030542,1007030542]'),(32000037,400,1000,0,4,0,1,1,'[{{100,1004040541,1},24},{{100,1002040541,1},24},{{100,1008040541,1},24},{{100,1006040541,1},24},{{100,1010040541,1},24},{{100,1001040541,1},34},{{100,1007040541,1},34},{{100,1004040542,1},2},{{100,1002040542,1},2},{{100,1008040542,1},2},{{100,1006040542,1},2},{{100,1010040542,1},2},{{100,1001040542,1},1},{{100,1007040542,1},1}]','[]','[1004040541,1002040541,1008040541,1006040541,1010040541,1001040541,1007040541,1004040542,1002040542,1008040542,1006040542,1010040542,1001040542,1007040542]'),(32000038,0,1000,0,1,0,0,0,'[]','[{0,1107010542,1}]','[1107010542]'),(32000038,0,1000,0,2,0,0,0,'[]','[{0,1107020542,1}]','[1107020542]'),(32000038,0,1000,0,3,0,0,0,'[]','[{0,1107030542,1}]','[1107030542]'),(32000038,0,1000,0,4,0,0,0,'[]','[{0,1107040542,1}]','[1107040542]'),(32000039,0,1000,0,1,0,0,0,'[]','[{0,1107010642,1}]','[1107010642]'),(32000039,0,1000,0,2,0,0,0,'[]','[{0,1107020642,1}]','[1107020642]'),(32000039,0,1000,0,3,0,0,0,'[]','[{0,1107030642,1}]','[1107030642]'),(32000039,0,1000,0,4,0,0,0,'[]','[{0,1107040642,1}]','[1107040642]'),(32000040,0,1000,0,1,0,0,0,'[]','[{0,1107010643,1}]','[1107010643]'),(32000040,0,1000,0,2,0,0,0,'[]','[{0,1107020643,1}]','[1107020643]'),(32000040,0,1000,0,3,0,0,0,'[]','[{0,1107030643,1}]','[1107030643]'),(32000040,0,1000,0,4,0,0,0,'[]','[{0,1107040643,1}]','[1107040643]'),(32000041,0,1000,0,1,0,0,0,'[]','[{0,1107010653,1}]','[1107010653]'),(32000041,0,1000,0,2,0,0,0,'[]','[{0,1107020653,1}]','[1107020653]'),(32000041,0,1000,0,3,0,0,0,'[]','[{0,1107030653,1}]','[1107030653]'),(32000041,0,1000,0,4,0,0,0,'[]','[{0,1107040653,1}]','[1107040653]'),(32010001,0,1000,0,0,0,0,0,'[]','[{3,36030001,1000000}]','[]'),(32010003,0,1000,0,0,0,0,0,'[]','[{2,36020001,30}]','[]'),(32010004,0,1000,0,0,0,0,0,'[]','[{3,36030001,100000}]','[]'),(32010006,0,1000,0,0,0,1,1,'[{{0,12120000,1},1},{{0,12120001,1},1},{{0,12120002,1},1},{{0,12120003,1},1},{{0,12120004,1},1},{{0,12120005,1},1},{{0,12120006,1},1},{{0,12120007,1},1},{{0,12120008,1},1},{{0,12120009,1},1}]','[]','[]'),(32010015,0,1000,0,0,0,0,0,'[]','[{0,12030002,1},{0,16020002,1},{0,37020002,3},{0,32010033,1},{0,32010016,1}]','[12030001]'),(32010016,0,1000,0,0,0,0,0,'[]','[{0,12020002,1},{0,16020002,1},{0,37020002,3},{0,32010033,1}]','[12020002]'),(32010031,0,1000,0,0,0,0,0,'[]','[{3,36030001,10000}]','[]'),(32010032,0,1000,0,0,0,0,0,'[]','[{3,36030001,50000}]','[]'),(32010033,0,1000,0,0,0,0,0,'[]','[{3,36030001,100000}]','[]'),(32010034,0,1000,0,0,0,0,0,'[]','[{3,36030001,1000000}]','[]'),(32010035,0,1000,0,0,0,0,0,'[]','[{3,36030001,150000}]','[]'),(32010036,0,1000,0,0,0,0,0,'[]','[{3,36030001,200000}]','[]'),(32010037,0,1000,0,0,0,0,0,'[]','[{3,36030001,1200000}]','[]'),(32010038,0,1000,0,0,0,0,0,'[]','[{3,36030001,1500000}]','[]'),(32010041,0,1000,0,0,0,0,0,'[]','[{2,36020001,5}]','[]'),(32010042,0,1000,0,0,0,0,0,'[]','[{2,36020001,10}]','[]'),(32010043,0,1000,0,0,0,0,0,'[]','[{2,36020001,20}]','[]'),(32010044,0,1000,0,0,0,0,0,'[]','[{2,36020001,50}]','[]'),(32010045,0,1000,0,0,0,0,0,'[]','[{2,36020001,100}]','[]'),(32010046,0,1000,0,0,0,0,0,'[]','[{2,36020001,15}]','[]'),(32010047,0,1000,0,0,0,0,0,'[]','[{2,36020001,30}]','[]'),(32010048,0,1000,0,0,0,0,0,'[]','[{2,36020001,1}]','[]'),(32010052,0,1000,0,0,0,0,0,'[]','[{0,12010004,1},{0,12020004,1},{0,12030004,1}]','[]'),(32010053,0,1000,0,0,0,0,0,'[]','[{0,12010001,1},{0,12020001,1},{0,12030001,1}]','[]'),(32010054,0,1000,0,0,0,0,0,'[]','[{0,12010002,1},{0,32010015,1}]','[12010002]'),(32010057,0,1000,0,0,0,0,0,'[]','[{0,37020001,2},{2,36020001,50},{255,36100001,3000}]','[]'),(32010067,0,1000,0,0,0,0,0,'[]','[{0,12010005,1},{0,12020005,1},{0,12030005,1}]','[]'),(32020111,0,1000,0,1,0,1,0,'[{{0,38230101,1},25},{{0,38230102,1},20},{{0,38230003,1},10},{{0,38230104,1},20},{{0,38230005,1},0},{{0,38230106,1},20},{{0,38230107,1},25},{{0,38230108,1},20},{{0,38230009,1},0},{{0,38230110,1},20}]','[]','[]'),(32020111,0,1000,0,2,0,1,0,'[{{0,38230201,1},25},{{0,38230202,1},20},{{0,38230003,1},10},{{0,38230204,1},20},{{0,38230005,1},0},{{0,38230206,1},20},{{0,38230207,1},25},{{0,38230208,1},20},{{0,38230009,1},0},{{0,38230210,1},20}]','[]','[]'),(32020111,0,1000,0,3,0,1,0,'[{{0,38230301,1},25},{{0,38230302,1},20},{{0,38230003,1},10},{{0,38230304,1},20},{{0,38230005,1},0},{{0,38230306,1},20},{{0,38230307,1},25},{{0,38230308,1},20},{{0,38230009,1},0},{{0,38230310,1},20}]','[]','[]'),(32020111,0,1000,0,4,0,1,0,'[{{0,38230401,1},25},{{0,38230402,1},20},{{0,38230003,1},10},{{0,38230404,1},20},{{0,38230005,1},0},{{0,38230406,1},20},{{0,38230407,1},25},{{0,38230408,1},20},{{0,38230009,1},0},{{0,38230410,1},20}]','[]','[]'),(32020112,0,1000,0,1,0,1,0,'[{{0,38230102,1},20},{{0,38230104,1},20},{{0,38230106,1},20},{{0,38230108,1},20},{{0,38230110,1},20}]','[]','[]'),(32020112,0,1000,0,2,0,1,0,'[{{0,38230202,1},20},{{0,38230204,1},20},{{0,38230206,1},20},{{0,38230208,1},20},{{0,38230210,1},20}]','[]','[]'),(32020112,0,1000,0,3,0,1,0,'[{{0,38230302,1},20},{{0,38230304,1},20},{{0,38230306,1},20},{{0,38230308,1},20},{{0,38230310,1},20}]','[]','[]'),(32020112,0,1000,0,4,0,1,0,'[{{0,38230402,1},20},{{0,38230404,1},20},{{0,38230406,1},20},{{0,38230408,1},20},{{0,38230410,1},20}]','[]','[]'),(32020113,0,1000,0,1,0,1,0,'[{{0,38230101,1},25},{{0,38230107,1},25}]','[]','[]'),(32020113,0,1000,0,2,0,1,0,'[{{0,38230201,1},25},{{0,38230207,1},25}]','[]','[]'),(32020113,0,1000,0,3,0,1,0,'[{{0,38230301,1},25},{{0,38230307,1},25}]','[]','[]'),(32020113,0,1000,0,4,0,1,0,'[{{0,38230401,1},25},{{0,38230407,1},25}]','[]','[]'),(32020114,0,1000,0,0,0,1,0,'[{{0,38230003,1},10},{{0,38230005,1},0},{{0,38230009,1},0}]','[]','[]'),(32020121,0,1000,0,1,0,1,0,'[{{0,38240001,1},25},{{0,38240002,1},20},{{0,38240003,1},10},{{0,38240004,1},20},{{0,38240005,1},0},{{0,38240006,1},20},{{0,38240007,1},25},{{0,38240008,1},20},{{0,38240009,1},0},{{0,38240010,1},20}]','[]','[38240001,38240002,38240003,38240004,38240005,38240006,38240007,38240008,38240009,38240010]'),(32020121,0,1000,0,2,0,1,0,'[{{0,38240001,1},25},{{0,38240002,1},20},{{0,38240003,1},10},{{0,38240004,1},20},{{0,38240005,1},0},{{0,38240006,1},20},{{0,38240007,1},25},{{0,38240008,1},20},{{0,38240009,1},0},{{0,38240010,1},20}]','[]','[38240001,38240002,38240003,38240004,38240005,38240006,38240007,38240008,38240009,38240010]'),(32020121,0,1000,0,3,0,1,0,'[{{0,38240001,1},25},{{0,38240002,1},20},{{0,38240003,1},10},{{0,38240004,1},20},{{0,38240005,1},0},{{0,38240006,1},20},{{0,38240007,1},25},{{0,38240008,1},20},{{0,38240009,1},0},{{0,38240010,1},20}]','[]','[38240001,38240002,38240003,38240004,38240005,38240006,38240007,38240008,38240009,38240010]'),(32020121,0,1000,0,4,0,1,0,'[{{0,38240001,1},25},{{0,38240002,1},20},{{0,38240003,1},10},{{0,38240004,1},20},{{0,38240005,1},0},{{0,38240006,1},20},{{0,38240007,1},25},{{0,38240008,1},20},{{0,38240009,1},0},{{0,38240010,1},20}]','[]','[38240001,38240002,38240003,38240004,38240005,38240006,38240007,38240008,38240009,38240010]'),(32020122,0,1000,0,1,0,1,0,'[{{0,38240002,1},20},{{0,38240004,1},20},{{0,38240006,1},20},{{0,38240008,1},20},{{0,38240010,1},20}]','[]','[38240002,38240004,38240006,38240008,38240010]'),(32020122,0,1000,0,2,0,1,0,'[{{0,38240002,1},20},{{0,38240004,1},20},{{0,38240006,1},20},{{0,38240008,1},20},{{0,38240010,1},20}]','[]','[38240002,38240004,38240006,38240008,38240010]'),(32020122,0,1000,0,3,0,1,0,'[{{0,38240002,1},20},{{0,38240004,1},20},{{0,38240006,1},20},{{0,38240008,1},20},{{0,38240010,1},20}]','[]','[38240002,38240004,38240006,38240008,38240010]'),(32020122,0,1000,0,4,0,1,0,'[{{0,38240002,1},20},{{0,38240004,1},20},{{0,38240006,1},20},{{0,38240008,1},20},{{0,38240010,1},20}]','[]','[38240002,38240004,38240006,38240008,38240010]'),(32020123,0,1000,0,1,0,1,0,'[{{0,38240001,1},25},{{0,38240007,1},25}]','[]','[38240001,38240007]'),(32020123,0,1000,0,2,0,1,0,'[{{0,38240001,1},25},{{0,38240007,1},25}]','[]','[38240001,38240007]'),(32020123,0,1000,0,3,0,1,0,'[{{0,38240001,1},25},{{0,38240007,1},25}]','[]','[38240001,38240007]'),(32020123,0,1000,0,4,0,1,0,'[{{0,38240001,1},25},{{0,38240007,1},25}]','[]','[38240001,38240007]'),(32020124,0,1000,0,0,0,1,0,'[{{0,38240003,1},10},{{0,38240005,1},0},{{0,38240009,1},0}]','[]','[38240003,38240005,38240009]'),(32030101,0,1000,0,0,0,1,0,'[{{0,14010101,1},1},{{0,14020201,1},1},{{0,14010301,1},1},{{0,14020401,1},1}]','[]','[]'),(32030102,0,1000,0,0,0,1,0,'[{{0,14010101,1},1},{{0,14010301,1},1}]','[]','[]'),(32030103,0,1000,0,0,0,1,0,'[{{0,14020201,1},1},{{0,14020401,1},1}]','[]','[]'),(32030201,0,1000,0,0,0,1,0,'[{{0,14010102,1},1},{{0,14020202,1},1},{{0,14010302,1},1},{{0,14020402,1},1}]','[]','[]'),(32030202,0,1000,0,0,0,1,0,'[{{0,14010102,1},1},{{0,14010302,1},1}]','[]','[]'),(32030203,0,1000,0,0,0,1,0,'[{{0,14020202,1},1},{{0,14020402,1},1}]','[]','[]'),(32030301,0,1000,0,0,0,1,0,'[{{0,14010103,1},1},{{0,14020203,1},1},{{0,14010303,1},1},{{0,14020403,1},1}]','[]','[]'),(32030302,0,1000,0,0,0,1,0,'[{{0,14010103,1},1},{{0,14010303,1},1}]','[]','[]'),(32030303,0,1000,0,0,0,1,0,'[{{0,14020203,1},1},{{0,14020403,1},1}]','[]','[]'),(32030401,0,1000,0,0,0,1,0,'[{{0,14010104,1},1},{{0,14020204,1},1},{{0,14010304,1},1},{{0,14020404,1},1}]','[]','[]'),(32030402,0,1000,0,0,0,1,0,'[{{0,14010104,1},1},{{0,14010304,1},1}]','[]','[]'),(32030403,0,1000,0,0,0,1,0,'[{{0,14020204,1},1},{{0,14020404,1},1}]','[]','[]'),(32030501,0,1000,0,0,0,1,0,'[{{0,14010105,1},1},{{0,14020205,1},1},{{0,14010305,1},1},{{0,14020405,1},1}]','[]','[]'),(32030502,0,1000,0,0,0,1,0,'[{{0,14010105,1},1},{{0,14010305,1},1}]','[]','[]'),(32030503,0,1000,0,0,0,1,0,'[{{0,14020205,1},1},{{0,14020405,1},1}]','[]','[]'),(32030601,0,1000,0,0,0,1,0,'[{{0,14010106,1},1},{{0,14020206,1},1},{{0,14010306,1},1},{{0,14020406,1},1}]','[]','[]'),(32030602,0,1000,0,0,0,1,0,'[{{0,14010106,1},1},{{0,14010306,1},1}]','[]','[]'),(32030603,0,1000,0,0,0,1,0,'[{{0,14020206,1},1},{{0,14020406,1},1}]','[]','[]'),(32030701,0,1000,0,0,0,1,0,'[{{0,14010107,1},1},{{0,14020207,1},1},{{0,14010307,1},1},{{0,14020407,1},1}]','[]','[14010107,14020207,14010307,14020407]'),(32030702,0,1000,0,0,0,1,0,'[{{0,14010107,1},1},{{0,14010307,1},1}]','[]','[14010107,14010307]'),(32030703,0,1000,0,0,0,1,0,'[{{0,14020207,1},1},{{0,14020407,1},1}]','[]','[14020207,14020407]'),(32030801,0,1000,0,0,0,1,0,'[{{0,14010108,1},1},{{0,14020208,1},1},{{0,14010308,1},1},{{0,14020408,1},1}]','[]','[14010108,14020208,14010308,14020408]'),(32030802,0,1000,0,0,0,1,0,'[{{0,14010108,1},1},{{0,14010308,1},1}]','[]','[14010108,14010308]'),(32030803,0,1000,0,0,0,1,0,'[{{0,14020208,1},1},{{0,14020408,1},1}]','[]','[14020208,14020408]'),(32030901,0,1000,0,0,0,1,0,'[{{0,14010109,1},1},{{0,14020209,1},1},{{0,14010309,1},1},{{0,14020409,1},1}]','[]','[14010109,14020209,14010309,14020409]'),(32030902,0,1000,0,0,0,1,0,'[{{0,14010109,1},1},{{0,14010309,1},1}]','[]','[14010109,14010309]'),(32030903,0,1000,0,0,0,1,0,'[{{0,14020209,1},1},{{0,14020409,1},1}]','[]','[14020209,14020409]'),(32040001,0,1000,0,0,0,0,0,'[]','[{0,21010101,1},{0,21010102,1},{0,21010103,1},{0,21010104,1},{0,21010105,1},{0,21010106,1},{0,21010107,1},{0,21010108,1},{0,21010109,1},{0,21010110,1}]','[]'),(32040002,0,1000,0,0,0,0,0,'[]','[{0,21010201,1},{0,21010202,1},{0,21010203,1},{0,21010204,1},{0,21010205,1},{0,21010206,1},{0,21010207,1},{0,21010208,1},{0,21010209,1},{0,21010210,1}]','[]'),(32040003,0,1000,0,0,0,0,0,'[]','[{0,21010301,1},{0,21010302,1},{0,21010303,1},{0,21010304,1},{0,21010305,1},{0,21010306,1},{0,21010307,1},{0,21010308,1},{0,21010309,1},{0,21010310,1}]','[]'),(32040004,0,1000,0,0,0,0,1,'[]','[{0,21010401,1},{0,21010402,1},{0,21010403,1},{0,21010404,1},{0,21010405,1},{0,21010406,1},{0,21010407,1},{0,21010408,1},{0,21010409,1},{0,21010410,1},{0,21010411,1},{0,21010412,1}]','[]'),(32040005,0,1000,0,0,0,0,0,'[]','[{0,21010501,1},{0,21010502,1},{0,21010503,1},{0,21010504,1},{0,21010505,1},{0,21010506,1},{0,21010507,1},{0,21010508,1},{0,21010509,1},{0,21010510,1},{0,21010511,1},{0,21010512,1}]','[]'),(32040006,0,1000,0,0,0,0,0,'[]','[{0,21010601,1},{0,21010602,1},{0,21010603,1},{0,21010604,1},{0,21010605,1},{0,21010606,1},{0,21010607,1},{0,21010608,1},{0,21010609,1},{0,21010610,1}]','[]'),(32040007,0,1000,0,0,0,0,0,'[]','[{0,21010701,1},{0,21010702,1},{0,21010703,1},{0,21010704,1},{0,21010705,1},{0,21010706,1},{0,21010707,1},{0,21010708,1},{0,21010709,1},{0,21010710,1}]','[]'),(32040008,0,1000,0,0,0,0,0,'[]','[{0,21010801,1},{0,21010802,1},{0,21010803,1},{0,21010804,1},{0,21010805,1},{0,21010806,1},{0,21010807,1},{0,21010808,1},{0,21010809,1},{0,21010810,1},{0,21010811,1},{0,21010812,1}]','[]'),(32040009,0,1000,0,0,0,0,0,'[]','[{0,21010901,1},{0,21010902,1},{0,21010903,1},{0,21010904,1},{0,21010905,1},{0,21010906,1},{0,21010907,1},{0,21010908,1},{0,21010909,1},{0,21010910,1},{0,21010911,1},{0,21010912,1}]','[]'),(32040010,0,1000,0,0,0,0,0,'[]','[{0,21011001,1},{0,21011002,1},{0,21011003,1},{0,21011004,1},{0,21011005,1},{0,21011006,1},{0,21011007,1},{0,21011008,1},{0,21011009,1},{0,21011010,1}]','[]'),(32040011,0,1000,0,0,0,0,0,'[]','[{0,21011101,1},{0,21011102,1},{0,21011103,1},{0,21011104,1},{0,21011105,1},{0,21011106,1},{0,21011107,1},{0,21011108,1},{0,21011109,1},{0,21011110,1}]','[]'),(32040012,0,1000,0,0,0,0,0,'[]','[{0,21011201,1},{0,21011202,1},{0,21011203,1},{0,21011204,1},{0,21011205,1},{0,21011206,1},{0,21011207,1},{0,21011208,1},{0,21011209,1},{0,21011210,1},{0,21011211,1},{0,21011212,1}]','[]'),(32040013,0,1000,0,0,0,0,0,'[]','[{0,21011301,1},{0,21011302,1},{0,21011303,1},{0,21011304,1},{0,21011305,1},{0,21011306,1},{0,21011307,1},{0,21011308,1},{0,21011309,1},{0,21011310,1},{0,21011311,1},{0,21011312,1}]','[]'),(32040014,0,1000,0,0,0,0,0,'[]','[{0,21011401,1},{0,21011402,1},{0,21011403,1},{0,21011404,1},{0,21011405,1},{0,21011406,1},{0,21011407,1},{0,21011408,1},{0,21011409,1},{0,21011410,1},{0,21011411,1},{0,21011412,1}]','[]'),(32040015,0,1000,0,0,0,0,0,'[]','[{0,21011501,1},{0,21011502,1},{0,21011503,1},{0,21011504,1},{0,21011505,1},{0,21011506,1},{0,21011507,1},{0,21011508,1},{0,21011509,1},{0,21011510,1},{0,21011511,1},{0,21011512,1}]','[]'),(32040016,0,1000,0,0,0,0,0,'[]','[{0,21011601,1},{0,21011602,1},{0,21011603,1},{0,21011604,1},{0,21011605,1},{0,21011606,1},{0,21011607,1},{0,21011608,1},{0,21011609,1},{0,21011610,1},{0,21011611,1},{0,21011612,1}]','[]'),(32040017,0,1000,0,0,0,0,0,'[]','[{0,21011701,1},{0,21011702,1},{0,21011703,1},{0,21011704,1},{0,21011705,1},{0,21011706,1},{0,21011707,1},{0,21011708,1},{0,21011709,1},{0,21011710,1},{0,21011711,1},{0,21011712,1}]','[]'),(32040101,1,1000,0,0,0,1,0,'[{{0,21010101,1},10},{{0,21010102,1},10}]','[]','[]'),(32040102,1,1000,0,0,0,1,0,'[{{0,21010103,1},10},{{0,21010104,1},10}]','[]','[]'),(32040103,1,1000,0,0,0,1,0,'[{{0,21010105,1},10},{{0,21010106,1},10},{{0,21010107,1},10}]','[]','[]'),(32040104,1,1000,0,0,0,1,0,'[{{0,21010108,1},10},{{0,21010109,1},10},{{0,21010110,1},10}]','[]','[]'),(32040201,1,1000,0,0,0,1,0,'[{{0,21010201,1},10},{{0,21010202,1},10}]','[]','[]'),(32040202,1,1000,0,0,0,1,0,'[{{0,21010203,1},10},{{0,21010204,1},10}]','[]','[]'),(32040203,1,1000,0,0,0,1,0,'[{{0,21010205,1},10},{{0,21010206,1},10},{{0,21010207,1},10}]','[]','[]'),(32040204,1,1000,0,0,0,1,0,'[{{0,21010208,1},10},{{0,21010209,1},10},{{0,21010210,1},10}]','[]','[]'),(32040301,1,1000,0,0,0,1,0,'[{{0,21010301,1},10},{{0,21010302,1},10},{{0,21010303,1},10},{{0,21010304,1},10}]','[]','[]'),(32040302,1,1000,0,0,0,1,0,'[{{0,21010305,1},10},{{0,21010306,1},10},{{0,21010307,1},10},{{0,21010308,1},10},{{0,21010309,1},10},{{0,21010310,1},10}]','[]','[]'),(32040401,1,1000,0,0,0,1,0,'[{{0,21010401,1},10},{{0,21010402,1},10},{{0,21010403,1},10},{{0,21010404,1},10},{{0,21010411,1},5},{{0,21010412,1},5}]','[]','[]'),(32040402,1,1000,0,0,0,1,0,'[{{0,21010405,1},10},{{0,21010406,1},10},{{0,21010407,1},10},{{0,21010408,1},10},{{0,21010409,1},10},{{0,21010410,1},10}]','[]','[]'),(32040501,1,1000,0,0,0,1,0,'[{{0,21010501,1},10},{{0,21010504,1},10},{{0,21010511,1},5},{{0,21010512,1},5}]','[]','[]'),(32040502,1,1000,0,0,0,1,0,'[{{0,21010502,1},10},{{0,21010505,1},10},{{0,21010506,1},10},{{0,21010507,1},10}]','[]','[]'),(32040503,1,1000,0,0,0,1,0,'[{{0,21010503,1},10},{{0,21010508,1},10},{{0,21010509,1},10},{{0,21010510,1},10}]','[]','[]'),(32040601,1,1000,0,0,0,1,0,'[{{0,21010601,1},10},{{0,21010602,1},10},{{0,21010603,1},10},{{0,21010604,1},10}]','[]','[]'),(32040602,1,1000,0,0,0,1,0,'[{{0,21010605,1},10},{{0,21010606,1},10},{{0,21010607,1},10},{{0,21010608,1},10},{{0,21010609,1},10},{{0,21010610,1},10}]','[]','[]'),(32040701,1,1000,0,0,0,1,0,'[{{0,21010701,1},10},{{0,21010702,1},10},{{0,21010705,1},10},{{0,21010706,1},10},{{0,21010707,1},10}]','[]','[]'),(32040702,1,1000,0,0,0,1,0,'[{{0,21010703,1},10},{{0,21010704,1},10},{{0,21010708,1},10},{{0,21010709,1},10},{{0,21010710,1},10}]','[]','[]'),(32040801,1,1000,0,0,0,1,0,'[{{0,21010801,1},10},{{0,21010802,1},10},{{0,21010803,1},10},{{0,21010804,1},10},{{0,21010811,1},5},{{0,21010812,1},5}]','[]','[]'),(32040802,1,1000,0,0,0,1,0,'[{{0,21010805,1},10},{{0,21010806,1},10},{{0,21010807,1},10},{{0,21010808,1},10},{{0,21010809,1},10},{{0,21010810,1},10}]','[]','[]'),(32040901,1,1000,0,0,0,1,0,'[{{0,21010901,1},10},{{0,21010904,1},10},{{0,21010911,1},5},{{0,21010912,1},5}]','[]','[21010901,21010904,21010911,21010912]'),(32040902,1,1000,0,0,0,1,0,'[{{0,21010902,1},10},{{0,21010905,1},10},{{0,21010906,1},10},{{0,21010907,1},10}]','[]','[21010902,21010905,21010906,21010907]'),(32040903,1,1000,0,0,0,1,0,'[{{0,21010903,1},10},{{0,21010908,1},10},{{0,21010909,1},10},{{0,21010910,1},10}]','[]','[21010903,21010908,21010909,21010910]'),(32041001,1,1000,0,0,0,1,0,'[{{0,21011001,1},10},{{0,21011002,1},10},{{0,21011003,1},10},{{0,21011004,1},10}]','[]','[21011001,21011002,21011003,21011004]'),(32041002,1,1000,0,0,0,1,0,'[{{0,21011005,1},10},{{0,21011006,1},10},{{0,21011007,1},10},{{0,21011008,1},10},{{0,21011009,1},10},{{0,21011010,1},10}]','[]','[21011005,21011006,21011007,21011008,21011009,21011010]'),(32041101,1,1000,0,0,0,1,0,'[{{0,21011101,1},10},{{0,21011102,1},10},{{0,21011105,1},10},{{0,21011106,1},10},{{0,21011107,1},10}]','[]','[21011101,21011102,21011105,21011106,21011107]'),(32041102,1,1000,0,0,0,1,0,'[{{0,21011103,1},10},{{0,21011104,1},10},{{0,21011108,1},10},{{0,21011109,1},10},{{0,21011110,1},10}]','[]','[21011103,21011104,21011108,21011109,21011110]'),(32041201,1,1000,0,0,0,1,0,'[{{0,21011201,1},10},{{0,21011202,1},10},{{0,21011203,1},10},{{0,21011204,1},10},{{0,21011211,1},5},{{0,21011212,1},5}]','[]','[21011201,21011202,21011203,21011204,21011211,21011212]'),(32041202,1,1000,0,0,0,1,0,'[{{0,21011205,1},10},{{0,21011206,1},10},{{0,21011207,1},10},{{0,21011208,1},10},{{0,21011209,1},10},{{0,21011210,1},10}]','[]','[21011205,21011206,21011207,21011208,21011209,21011210]'),(32041301,1,1000,0,0,0,1,0,'[{{0,21011301,1},10},{{0,21011302,1},10},{{0,21011303,1},10},{{0,21011304,1},10},{{0,21011305,1},10},{{0,21011306,1},10},{{0,21011307,1},10},{{0,21011308,1},10},{{0,21011309,1},10},{{0,21011310,1},10},{{0,21011311,1},5},{{0,21011312,1},5}]','[]','[21011301,21011302,21011303,21011304,21011305,21011306,21011307,21011308,21011309,21011310,21011311,21011312]'),(32041401,1,1000,0,0,0,1,0,'[{{0,21011401,1},10},{{0,21011402,1},10},{{0,21011403,1},10},{{0,21011404,1},10},{{0,21011405,1},10},{{0,21011406,1},10},{{0,21011407,1},10},{{0,21011408,1},10},{{0,21011409,1},10},{{0,21011410,1},10},{{0,21011411,1},5},{{0,21011412,1},5}]','[]','[21011401,21011402,21011403,21011404,21011405,21011406,21011407,21011408,21011409,21011410,21011411,21011412]'),(32041501,1,1000,0,0,0,1,0,'[{{0,21011501,1},10},{{0,21011502,1},10},{{0,21011503,1},10},{{0,21011504,1},10},{{0,21011505,1},10},{{0,21011506,1},10},{{0,21011507,1},10},{{0,21011508,1},10},{{0,21011509,1},10},{{0,21011510,1},10},{{0,21011511,1},5},{{0,21011512,1},5}]','[]','[21011501,21011502,21011503,21011504,21011505,21011506,21011507,21011508,21011509,21011510,21011511,21011512]'),(32041601,1,1000,0,0,0,1,0,'[{{0,21011601,1},10},{{0,21011602,1},10},{{0,21011603,1},10},{{0,21011604,1},10},{{0,21011605,1},10},{{0,21011606,1},10},{{0,21011607,1},10},{{0,21011608,1},10},{{0,21011609,1},10},{{0,21011610,1},10},{{0,21011611,1},5},{{0,21011612,1},5}]','[]','[21011601,21011602,21011603,21011604,21011605,21011606,21011607,21011608,21011609,21011610,21011611,21011612]'),(32041701,1,1000,0,0,0,1,0,'[{{0,21011701,1},10},{{0,21011702,1},10},{{0,21011703,1},10},{{0,21011704,1},10},{{0,21011705,1},10},{{0,21011706,1},10},{{0,21011707,1},10},{{0,21011708,1},10},{{0,21011709,1},10},{{0,21011710,1},10},{{0,21011711,1},5},{{0,21011712,1},5}]','[]','[21011701,21011702,21011703,21011704,21011705,21011706,21011707,21011708,21011709,21011710,21011711,21011712]'),(32050004,0,1000,0,0,0,0,0,'[]','[{255,40040001,50}]','[]'),(32050005,0,1000,0,0,0,0,0,'[]','[{255,40040001,210}]','[]'),(32050006,0,1000,0,0,0,0,0,'[]','[{255,40040001,450}]','[]'),(32060002,0,1000,0,0,0,1,1,'[{{0,18054701,1},10},{{0,18050101,1},10},{{0,18050201,1},10},{{0,18050301,1},10},{{0,18050401,1},10},{{0,18050501,1},10},{{0,18050601,1},10},{{0,18050701,1},10}]','[]','[18054701,18050101,18050201,18050301,18050401,18050501,18050601,18050701]'),(32060003,0,1000,0,0,0,1,1,'[{{0,18054801,1},10},{{0,18050801,1},10},{{0,18050901,1},10},{{0,18051001,1},10},{{0,18051101,1},10},{{0,18051201,1},10},{{0,18051301,1},10},{{0,18051401,1},10},{{0,18051501,1},10},{{0,18051601,1},10}]','[]','[18054801,18050801,18050901,18051001,18051101,18051201,18051301,18051401,18051501,18051601]'),(32060004,0,1000,0,0,0,1,1,'[{{0,18054301,1},10},{{0,18054401,1},10},{{0,18054501,1},10},{{0,18054601,1},10}]','[]','[18054301,18054401,18054501,18054601]'),(32070001,0,1000,0,0,0,1,1,'[{{100,18041002,1},10},{{100,18041003,1},10},{{100,18041004,1},10},{{100,18041005,1},10},{{100,18041006,1},10},{{100,18041007,1},10}]','[]','[18041002,18041003,18041004,18041005,18041006,18041007]'),(32070003,0,1000,0,0,0,1,1,'[{{100,18041002,1},10},{{100,18041003,1},10},{{100,18041004,1},10},{{100,18041005,1},10},{{100,18041006,1},10},{{100,18041007,1},10}]','[]','[18041101,18041102,18041103,18041104,18041105,18041007]'),(32080001,0,1000,0,1,0,1,1,'[{{0,19010001,1},10}]','[]','[19010001]'),(32080001,0,1000,0,2,0,1,1,'[{{0,19010011,1},10}]','[]','[19010011]'),(32080001,0,1000,0,3,0,1,1,'[{{0,19010021,1},10}]','[]','[19010021]'),(32080001,0,1000,0,4,0,1,1,'[{{0,19010031,1},10}]','[]','[19010031]'),(32080002,0,1000,0,1,0,1,1,'[{{0,19010002,1},10}]','[]','[19010002]'),(32080002,0,1000,0,2,0,1,1,'[{{0,19010012,1},10}]','[]','[19010012]'),(32080002,0,1000,0,3,0,1,1,'[{{0,19010022,1},10}]','[]','[19010022]'),(32080002,0,1000,0,4,0,1,1,'[{{0,19010032,1},10}]','[]','[19010032]'),(32080003,0,1000,0,1,0,1,1,'[{{0,19010001,1},10},{{0,19010003,1},20}]','[]','[19010003,19010003]'),(32080003,0,1000,0,2,0,1,1,'[{{0,19010011,1},10},{{0,19010013,1},20}]','[]','[19010013,19010013]'),(32080003,0,1000,0,3,0,1,1,'[{{0,19010021,1},10},{{0,19010023,1},20}]','[]','[19010023,19010023]'),(32080003,0,1000,0,4,0,1,1,'[{{0,19010031,1},10},{{0,19010033,1},20}]','[]','[19010033,19010033]'),(32080004,0,1000,0,1,0,1,1,'[{{0,19010002,1},10},{{0,19010004,1},20}]','[]','[19010004,19010004]'),(32080004,0,1000,0,2,0,1,1,'[{{0,19010012,1},10},{{0,19010014,1},20}]','[]','[19010014,19010014]'),(32080004,0,1000,0,3,0,1,1,'[{{0,19010022,1},10},{{0,19010024,1},20}]','[]','[19010024,19010024]'),(32080004,0,1000,0,4,0,1,1,'[{{0,19010032,1},10},{{0,19010034,1},20}]','[]','[19010034,19010034]'),(32080005,0,1000,0,1,0,1,1,'[{{0,19010001,1},10},{{0,19010003,1},20},{{0,19010005,1},60}]','[]','[19010005,19010005,19010005]'),(32080005,0,1000,0,2,0,1,1,'[{{0,19010011,1},10},{{0,19010013,1},20},{{0,19010015,1},60}]','[]','[19010015,19010015,19010015]'),(32080005,0,1000,0,3,0,1,1,'[{{0,19010021,1},10},{{0,19010023,1},20},{{0,19010025,1},60}]','[]','[19010025,19010025,19010025]'),(32080005,0,1000,0,4,0,1,1,'[{{0,19010031,1},10},{{0,19010033,1},20},{{0,19010035,1},60}]','[]','[19010035,19010035,19010035]'),(32080006,0,1000,0,1,0,1,1,'[{{0,19010002,1},10},{{0,19010004,1},20},{{0,19010006,1},60}]','[]','[19010006,19010006,19010006]'),(32080006,0,1000,0,2,0,1,1,'[{{0,19010012,1},10},{{0,19010014,1},20},{{0,19010016,1},60}]','[]','[19010016,19010016,19010016]'),(32080006,0,1000,0,3,0,1,1,'[{{0,19010022,1},10},{{0,19010024,1},20},{{0,19010026,1},60}]','[]','[19010026,19010026,19010026]'),(32080006,0,1000,0,4,0,1,1,'[{{0,19010032,1},10},{{0,19010034,1},20},{{0,19010036,1},60}]','[]','[19010036,19010036,19010036]'),(32080007,0,1000,0,1,0,1,1,'[{{0,19010001,1},10},{{0,19010003,1},20},{{0,19010005,1},60},{{0,19010007,1},120}]','[]','[19010007,19010007,19010007,19010007]'),(32080007,0,1000,0,2,0,1,1,'[{{0,19010011,1},10},{{0,19010013,1},20},{{0,19010015,1},60},{{0,19010017,1},120}]','[]','[19010017,19010017,19010017,19010017]'),(32080007,0,1000,0,3,0,1,1,'[{{0,19010021,1},10},{{0,19010023,1},20},{{0,19010025,1},60},{{0,19010027,1},120}]','[]','[19010027,19010027,19010027,19010027]'),(32080007,0,1000,0,4,0,1,1,'[{{0,19010031,1},10},{{0,19010033,1},20},{{0,19010035,1},60},{{0,19010037,1},120}]','[]','[19010037,19010037,19010037,19010037]'),(32080008,0,1000,0,1,0,1,1,'[{{0,19010002,1},10},{{0,19010004,1},20},{{0,19010006,1},60},{{0,19010008,1},120}]','[]','[19010008,19010008,19010008,19010008]'),(32080008,0,1000,0,2,0,1,1,'[{{0,19010012,1},10},{{0,19010014,1},20},{{0,19010016,1},60},{{0,19010018,1},120}]','[]','[19010018,19010018,19010018,19010018]'),(32080008,0,1000,0,3,0,1,1,'[{{0,19010022,1},10},{{0,19010024,1},20},{{0,19010026,1},60},{{0,19010028,1},120}]','[]','[19010028,19010028,19010028,19010028]'),(32080008,0,1000,0,4,0,1,1,'[{{0,19010032,1},10},{{0,19010034,1},20},{{0,19010036,1},60},{{0,19010038,1},120}]','[]','[19010038,19010038,19010038,19010038]'),(32080111,0,1000,0,1,0,1,0,'[{{0,1001010132,1},1},{{0,1002010132,1},1},{{0,1003000132,1},1},{{0,1004010132,1},1},{{0,1006010132,1},1},{{0,1007010132,1},1},{{0,1008010132,1},1},{{0,1010010132,1},1}]','[]','[1001010132,1002010132,1003000132,1004010132,1005000132,1006010132,1007010132,1008010132,1009000132,1010010132]'),(32080111,0,1000,0,2,0,1,0,'[{{0,1001020132,1},1},{{0,1002020132,1},1},{{0,1003000132,1},1},{{0,1004020132,1},1},{{0,1006020132,1},1},{{0,1007020132,1},1},{{0,1008020132,1},1},{{0,1010020132,1},1}]','[]','[1001020132,1002020132,1003000132,1004020132,1005000132,1006020132,1007020132,1008020132,1009000132,1010020132]'),(32080111,0,1000,0,3,0,1,0,'[{{0,1001030132,1},1},{{0,1002030132,1},1},{{0,1003000132,1},1},{{0,1004030132,1},1},{{0,1006030132,1},1},{{0,1007030132,1},1},{{0,1008030132,1},1},{{0,1010030132,1},1}]','[]','[1001030132,1002030132,1003000132,1004030132,1005000132,1006030132,1007030132,1008030132,1009000132,1010030132]'),(32080111,0,1000,0,4,0,1,0,'[{{0,1001040132,1},1},{{0,1002040132,1},1},{{0,1003000132,1},1},{{0,1004040132,1},1},{{0,1006040132,1},1},{{0,1007040132,1},1},{{0,1008040132,1},1},{{0,1010040132,1},1}]','[]','[1001040132,1002040132,1003000132,1004040132,1005000132,1006040132,1007040132,1008040132,1009000132,1010040132]'),(32080112,0,1000,0,1,0,1,0,'[{{0,1002010132,1},1},{{0,1004010132,1},1},{{0,1006010132,1},1},{{0,1008010132,1},1},{{0,1010010132,1},1}]','[]','[1002010132,1004010132,1006010132,1008010132,1010010132]'),(32080112,0,1000,0,2,0,1,0,'[{{0,1002020132,1},1},{{0,1004020132,1},1},{{0,1006020132,1},1},{{0,1008020132,1},1},{{0,1010020132,1},1}]','[]','[1002020132,1004020132,1006020132,1008020132,1010020132]'),(32080112,0,1000,0,3,0,1,0,'[{{0,1002030132,1},1},{{0,1004030132,1},1},{{0,1006030132,1},1},{{0,1008030132,1},1},{{0,1010030132,1},1}]','[]','[1002030132,1004030132,1006030132,1008030132,1010030132]'),(32080112,0,1000,0,4,0,1,0,'[{{0,1002040132,1},1},{{0,1004040132,1},1},{{0,1006040132,1},1},{{0,1008040132,1},1},{{0,1010040132,1},1}]','[]','[1002040132,1004040132,1006040132,1008040132,1010040132]'),(32080113,0,1000,0,1,0,1,0,'[{{0,1001010132,1},1},{{0,1007010132,1},1}]','[]','[1001010132,1007010132]'),(32080113,0,1000,0,2,0,1,0,'[{{0,1001020132,1},1},{{0,1007020132,1},1}]','[]','[1001020132,1007020132]'),(32080113,0,1000,0,3,0,1,0,'[{{0,1001030132,1},1},{{0,1007030132,1},1}]','[]','[1001030132,1007030132]'),(32080113,0,1000,0,4,0,1,0,'[{{0,1001040132,1},1},{{0,1007040132,1},1}]','[]','[1001040132,1007040132]'),(32080115,0,1000,0,1,0,1,0,'[{{0,1002010132,1},1},{{0,1004010132,1},1},{{0,1006010132,1},1},{{0,1008010132,1},1},{{0,1010010132,1},1},{{0,1001010132,1},1}]','[]','[1002010132,1004010132,1006010132,1008010132,1010010132,1001010132]'),(32080115,0,1000,0,2,0,1,0,'[{{0,1002020132,1},1},{{0,1004020132,1},1},{{0,1006020132,1},1},{{0,1008020132,1},1},{{0,1010020132,1},1},{{0,1001020132,1},1}]','[]','[1002020132,1004020132,1006020132,1008020132,1010020132,1001020132]'),(32080115,0,1000,0,3,0,1,0,'[{{0,1002030132,1},1},{{0,1004030132,1},1},{{0,1006030132,1},1},{{0,1008030132,1},1},{{0,1010030132,1},1},{{0,1001030132,1},1}]','[]','[1002030132,1004030132,1006030132,1008030132,1010030132,1001030132]'),(32080115,0,1000,0,4,0,1,0,'[{{0,1002040132,1},1},{{0,1004040132,1},1},{{0,1006040132,1},1},{{0,1008040132,1},1},{{0,1010040132,1},1},{{0,1001040132,1},1}]','[]','[1002040132,1004040132,1006040132,1008040132,1010040132,1001040132]'),(32080116,0,1000,0,1,0,1,0,'[{{0,1007010132,1},1},{{0,1003000132,1},1},{{0,1005000132,1},1},{{0,1009000132,1},1}]','[]','[1007010132,1003000132,1005000132,1009000132]'),(32080116,0,1000,0,2,0,1,0,'[{{0,1007020132,1},1},{{0,1003000132,1},1},{{0,1005000132,1},1},{{0,1009000132,1},1}]','[]','[1007020132,1003000132,1005000132,1009000132]'),(32080116,0,1000,0,3,0,1,0,'[{{0,1007030132,1},1},{{0,1003000132,1},1},{{0,1005000132,1},1},{{0,1009000132,1},1}]','[]','[1007030132,1003000132,1005000132,1009000132]'),(32080116,0,1000,0,4,0,1,0,'[{{0,1007040132,1},1},{{0,1003000132,1},1},{{0,1005000132,1},1},{{0,1009000132,1},1}]','[]','[1007040132,1003000132,1005000132,1009000132]'),(32080117,0,1000,0,1,0,1,0,'[{{0,1007010132,1},1},{{0,1003000132,1},1}]','[]','[1007010132,1003000132]'),(32080117,0,1000,0,2,0,1,0,'[{{0,1007020132,1},1},{{0,1003000132,1},1}]','[]','[1007020132,1003000132]'),(32080117,0,1000,0,3,0,1,0,'[{{0,1007030132,1},1},{{0,1003000132,1},1}]','[]','[1007030132,1003000132]'),(32080117,0,1000,0,4,0,1,0,'[{{0,1007040132,1},1},{{0,1003000132,1},1}]','[]','[1007040132,1003000132]'),(32080118,0,1000,0,0,0,1,0,'[{{0,1005000132,1},1},{{0,1009000132,1},1}]','[]','[1005000132,1009000132]'),(32080121,0,1000,0,1,0,1,0,'[{{0,1001010141,1},1},{{0,1002010141,1},1},{{0,1003000141,1},1},{{0,1004010141,1},1},{{0,1006010141,1},1},{{0,1007010141,1},1},{{0,1008010141,1},1},{{0,1010010141,1},1}]','[]','[]'),(32080121,0,1000,0,2,0,1,0,'[{{0,1001020141,1},1},{{0,1002020141,1},1},{{0,1003000141,1},1},{{0,1004020141,1},1},{{0,1006020141,1},1},{{0,1007020141,1},1},{{0,1008020141,1},1},{{0,1010020141,1},1}]','[]','[]'),(32080121,0,1000,0,3,0,1,0,'[{{0,1001030141,1},1},{{0,1002030141,1},1},{{0,1003000141,1},1},{{0,1004030141,1},1},{{0,1006030141,1},1},{{0,1007030141,1},1},{{0,1008030141,1},1},{{0,1010030141,1},1}]','[]','[]'),(32080121,0,1000,0,4,0,1,0,'[{{0,1001040141,1},1},{{0,1002040141,1},1},{{0,1003000141,1},1},{{0,1004040141,1},1},{{0,1006040141,1},1},{{0,1007040141,1},1},{{0,1008040141,1},1},{{0,1010040141,1},1}]','[]','[]'),(32080122,0,1000,0,1,0,1,0,'[{{0,1002010141,1},1},{{0,1004010141,1},1},{{0,1006010141,1},1},{{0,1008010141,1},1},{{0,1010010141,1},1}]','[]','[]'),(32080122,0,1000,0,2,0,1,0,'[{{0,1002020141,1},1},{{0,1004020141,1},1},{{0,1006020141,1},1},{{0,1008020141,1},1},{{0,1010020141,1},1}]','[]','[]'),(32080122,0,1000,0,3,0,1,0,'[{{0,1002030141,1},1},{{0,1004030141,1},1},{{0,1006030141,1},1},{{0,1008030141,1},1},{{0,1010030141,1},1}]','[]','[]'),(32080122,0,1000,0,4,0,1,0,'[{{0,1002040141,1},1},{{0,1004040141,1},1},{{0,1006040141,1},1},{{0,1008040141,1},1},{{0,1010040141,1},1}]','[]','[]'),(32080123,0,1000,0,1,0,1,0,'[{{0,1001010141,1},1},{{0,1007010141,1},1}]','[]','[]'),(32080123,0,1000,0,2,0,1,0,'[{{0,1001020141,1},1},{{0,1007020141,1},1}]','[]','[]'),(32080123,0,1000,0,3,0,1,0,'[{{0,1001030141,1},1},{{0,1007030141,1},1}]','[]','[]'),(32080123,0,1000,0,4,0,1,0,'[{{0,1001040141,1},1},{{0,1007040141,1},1}]','[]','[]'),(32080125,0,1000,0,1,0,1,0,'[{{0,1002010141,1},1},{{0,1004010141,1},1},{{0,1006010141,1},1},{{0,1008010141,1},1},{{0,1010010141,1},1},{{0,1001010141,1},1}]','[]','[]'),(32080125,0,1000,0,2,0,1,0,'[{{0,1002020141,1},1},{{0,1004020141,1},1},{{0,1006020141,1},1},{{0,1008020141,1},1},{{0,1010020141,1},1},{{0,1001020141,1},1}]','[]','[]'),(32080125,0,1000,0,3,0,1,0,'[{{0,1002030141,1},1},{{0,1004030141,1},1},{{0,1006030141,1},1},{{0,1008030141,1},1},{{0,1010030141,1},1},{{0,1001030141,1},1}]','[]','[]'),(32080125,0,1000,0,4,0,1,0,'[{{0,1002040141,1},1},{{0,1004040141,1},1},{{0,1006040141,1},1},{{0,1008040141,1},1},{{0,1010040141,1},1},{{0,1001040141,1},1}]','[]','[]'),(32080126,0,1000,0,1,0,1,0,'[{{0,1007010141,1},1},{{0,1003000141,1},1},{{0,1005000141,1},1},{{0,1009000141,1},1}]','[]','[]'),(32080126,0,1000,0,2,0,1,0,'[{{0,1007020141,1},1},{{0,1003000141,1},1},{{0,1005000141,1},1},{{0,1009000141,1},1}]','[]','[]'),(32080126,0,1000,0,3,0,1,0,'[{{0,1007030141,1},1},{{0,1003000141,1},1},{{0,1005000141,1},1},{{0,1009000141,1},1}]','[]','[]'),(32080126,0,1000,0,4,0,1,0,'[{{0,1007040141,1},1},{{0,1003000141,1},1},{{0,1005000141,1},1},{{0,1009000141,1},1}]','[]','[]'),(32080127,0,1000,0,1,0,1,0,'[{{0,1007010141,1},1},{{0,1003000141,1},1}]','[]','[]'),(32080127,0,1000,0,2,0,1,0,'[{{0,1007020141,1},1},{{0,1003000141,1},1}]','[]','[]'),(32080127,0,1000,0,3,0,1,0,'[{{0,1007030141,1},1},{{0,1003000141,1},1}]','[]','[]'),(32080127,0,1000,0,4,0,1,0,'[{{0,1007040141,1},1},{{0,1003000141,1},1}]','[]','[]'),(32080128,0,1000,0,0,0,1,0,'[{{0,1005000141,1},1},{{0,1009000141,1},1}]','[]','[]'),(32080131,0,1000,0,1,0,1,0,'[{{0,1001010142,1},1},{{0,1002010142,1},1},{{0,1003000142,1},1},{{0,1004010142,1},1},{{0,1006010142,1},1},{{0,1007010142,1},1},{{0,1008010142,1},1},{{0,1010010142,1},1}]','[]','[1001010142,1002010142,1003000142,1004010142,1005000142,1006010142,1007010142,1008010142,1009000142,1010010142]'),(32080131,0,1000,0,2,0,1,0,'[{{0,1001020142,1},1},{{0,1002020142,1},1},{{0,1003000142,1},1},{{0,1004020142,1},1},{{0,1006020142,1},1},{{0,1007020142,1},1},{{0,1008020142,1},1},{{0,1010020142,1},1}]','[]','[1001020142,1002020142,1003000142,1004020142,1005000142,1006020142,1007020142,1008020142,1009000142,1010020142]'),(32080131,0,1000,0,3,0,1,0,'[{{0,1001030142,1},1},{{0,1002030142,1},1},{{0,1003000142,1},1},{{0,1004030142,1},1},{{0,1006030142,1},1},{{0,1007030142,1},1},{{0,1008030142,1},1},{{0,1010030142,1},1}]','[]','[1001030142,1002030142,1003000142,1004030142,1005000142,1006030142,1007030142,1008030142,1009000142,1010030142]'),(32080131,0,1000,0,4,0,1,0,'[{{0,1001040142,1},1},{{0,1002040142,1},1},{{0,1003000142,1},1},{{0,1004040142,1},1},{{0,1006040142,1},1},{{0,1007040142,1},1},{{0,1008040142,1},1},{{0,1010040142,1},1}]','[]','[1001040142,1002040142,1003000142,1004040142,1005000142,1006040142,1007040142,1008040142,1009000142,1010040142]'),(32080132,0,1000,0,1,0,1,0,'[{{0,1002010142,1},1},{{0,1004010142,1},1},{{0,1006010142,1},1},{{0,1008010142,1},1},{{0,1010010142,1},1}]','[]','[1002010142,1004010142,1006010142,1008010142,1010010142]'),(32080132,0,1000,0,2,0,1,0,'[{{0,1002020142,1},1},{{0,1004020142,1},1},{{0,1006020142,1},1},{{0,1008020142,1},1},{{0,1010020142,1},1}]','[]','[1002020142,1004020142,1006020142,1008020142,1010020142]'),(32080132,0,1000,0,3,0,1,0,'[{{0,1002030142,1},1},{{0,1004030142,1},1},{{0,1006030142,1},1},{{0,1008030142,1},1},{{0,1010030142,1},1}]','[]','[1002030142,1004030142,1006030142,1008030142,1010030142]'),(32080132,0,1000,0,4,0,1,0,'[{{0,1002040142,1},1},{{0,1004040142,1},1},{{0,1006040142,1},1},{{0,1008040142,1},1},{{0,1010040142,1},1}]','[]','[1002040142,1004040142,1006040142,1008040142,1010040142]'),(32080133,0,1000,0,1,0,1,0,'[{{0,1001010142,1},1},{{0,1007010142,1},1}]','[]','[1001010142,1007010142]'),(32080133,0,1000,0,2,0,1,0,'[{{0,1001020142,1},1},{{0,1007020142,1},1}]','[]','[1001020142,1007020142]'),(32080133,0,1000,0,3,0,1,0,'[{{0,1001030142,1},1},{{0,1007030142,1},1}]','[]','[1001030142,1007030142]'),(32080133,0,1000,0,4,0,1,0,'[{{0,1001040142,1},1},{{0,1007040142,1},1}]','[]','[1001040142,1007040142]'),(32080135,0,1000,0,1,0,1,0,'[{{0,1002010142,1},1},{{0,1004010142,1},1},{{0,1006010142,1},1},{{0,1008010142,1},1},{{0,1010010142,1},1},{{0,1001010142,1},1}]','[]','[1002010142,1004010142,1006010142,1008010142,1010010142,1001010142]'),(32080135,0,1000,0,2,0,1,0,'[{{0,1002020142,1},1},{{0,1004020142,1},1},{{0,1006020142,1},1},{{0,1008020142,1},1},{{0,1010020142,1},1},{{0,1001020142,1},1}]','[]','[1002020142,1004020142,1006020142,1008020142,1010020142,1001020142]'),(32080135,0,1000,0,3,0,1,0,'[{{0,1002030142,1},1},{{0,1004030142,1},1},{{0,1006030142,1},1},{{0,1008030142,1},1},{{0,1010030142,1},1},{{0,1001030142,1},1}]','[]','[1002030142,1004030142,1006030142,1008030142,1010030142,1001030142]'),(32080135,0,1000,0,4,0,1,0,'[{{0,1002040142,1},1},{{0,1004040142,1},1},{{0,1006040142,1},1},{{0,1008040142,1},1},{{0,1010040142,1},1},{{0,1001040142,1},1}]','[]','[1002040142,1004040142,1006040142,1008040142,1010040142,1001040142]'),(32080136,0,1000,0,1,0,1,0,'[{{0,1007010142,1},1},{{0,1003000142,1},1},{{0,1005000142,1},1},{{0,1009000142,1},1}]','[]','[1007010142,1003000142,1005000142,1009000142]'),(32080136,0,1000,0,2,0,1,0,'[{{0,1007020142,1},1},{{0,1003000142,1},1},{{0,1005000142,1},1},{{0,1009000142,1},1}]','[]','[1007020142,1003000142,1005000142,1009000142]'),(32080136,0,1000,0,3,0,1,0,'[{{0,1007030142,1},1},{{0,1003000142,1},1},{{0,1005000142,1},1},{{0,1009000142,1},1}]','[]','[1007030142,1003000142,1005000142,1009000142]'),(32080136,0,1000,0,4,0,1,0,'[{{0,1007040142,1},1},{{0,1003000142,1},1},{{0,1005000142,1},1},{{0,1009000142,1},1}]','[]','[1007040142,1003000142,1005000142,1009000142]'),(32080137,0,1000,0,1,0,1,0,'[{{0,1007010142,1},1},{{0,1003000142,1},1}]','[]','[1007010142,1003000142]'),(32080137,0,1000,0,2,0,1,0,'[{{0,1007020142,1},1},{{0,1003000142,1},1}]','[]','[1007020142,1003000142]'),(32080137,0,1000,0,3,0,1,0,'[{{0,1007030142,1},1},{{0,1003000142,1},1}]','[]','[1007030142,1003000142]'),(32080137,0,1000,0,4,0,1,0,'[{{0,1007040142,1},1},{{0,1003000142,1},1}]','[]','[1007040142,1003000142]'),(32080138,0,1000,0,0,0,1,0,'[{{0,1005000142,1},1},{{0,1009000142,1},1}]','[]','[1005000142,1009000142]'),(32080141,0,1000,0,1,0,1,0,'[{{0,1001010143,1},1},{{0,1002010143,1},1},{{0,1003000143,1},1},{{0,1004010143,1},1},{{0,1006010143,1},1},{{0,1007010143,1},1},{{0,1008010143,1},1},{{0,1010010143,1},1}]','[]','[1001010143,1002010143,1003000143,1004010143,1005000143,1006010143,1007010143,1008010143,1009000143,1010010143]'),(32080141,0,1000,0,2,0,1,0,'[{{0,1001020143,1},1},{{0,1002020143,1},1},{{0,1003000143,1},1},{{0,1004020143,1},1},{{0,1006020143,1},1},{{0,1007020143,1},1},{{0,1008020143,1},1},{{0,1010020143,1},1}]','[]','[1001020143,1002020143,1003000143,1004020143,1005000143,1006020143,1007020143,1008020143,1009000143,1010020143]'),(32080141,0,1000,0,3,0,1,0,'[{{0,1001030143,1},1},{{0,1002030143,1},1},{{0,1003000143,1},1},{{0,1004030143,1},1},{{0,1006030143,1},1},{{0,1007030143,1},1},{{0,1008030143,1},1},{{0,1010030143,1},1}]','[]','[1001030143,1002030143,1003000143,1004030143,1005000143,1006030143,1007030143,1008030143,1009000143,1010030143]'),(32080141,0,1000,0,4,0,1,0,'[{{0,1001040143,1},1},{{0,1002040143,1},1},{{0,1003000143,1},1},{{0,1004040143,1},1},{{0,1006040143,1},1},{{0,1007040143,1},1},{{0,1008040143,1},1},{{0,1010040143,1},1}]','[]','[1001040143,1002040143,1003000143,1004040143,1005000143,1006040143,1007040143,1008040143,1009000143,1010040143]'),(32080142,0,1000,0,1,0,1,0,'[{{0,1002010143,1},1},{{0,1004010143,1},1},{{0,1006010143,1},1},{{0,1008010143,1},1},{{0,1010010143,1},1}]','[]','[1002010143,1004010143,1006010143,1008010143,1010010143]'),(32080142,0,1000,0,2,0,1,0,'[{{0,1002020143,1},1},{{0,1004020143,1},1},{{0,1006020143,1},1},{{0,1008020143,1},1},{{0,1010020143,1},1}]','[]','[1002020143,1004020143,1006020143,1008020143,1010020143]'),(32080142,0,1000,0,3,0,1,0,'[{{0,1002030143,1},1},{{0,1004030143,1},1},{{0,1006030143,1},1},{{0,1008030143,1},1},{{0,1010030143,1},1}]','[]','[1002030143,1004030143,1006030143,1008030143,1010030143]'),(32080142,0,1000,0,4,0,1,0,'[{{0,1002040143,1},1},{{0,1004040143,1},1},{{0,1006040143,1},1},{{0,1008040143,1},1},{{0,1010040143,1},1}]','[]','[1002040143,1004040143,1006040143,1008040143,1010040143]'),(32080143,0,1000,0,1,0,1,0,'[{{0,1001010143,1},1},{{0,1007010143,1},1}]','[]','[1001010143,1007010143]'),(32080143,0,1000,0,2,0,1,0,'[{{0,1001020143,1},1},{{0,1007020143,1},1}]','[]','[1001020143,1007020143]'),(32080143,0,1000,0,3,0,1,0,'[{{0,1001030143,1},1},{{0,1007030143,1},1}]','[]','[1001030143,1007030143]'),(32080143,0,1000,0,4,0,1,0,'[{{0,1001040143,1},1},{{0,1007040143,1},1}]','[]','[1001040143,1007040143]'),(32080145,0,1000,0,1,0,1,0,'[{{0,1002010143,1},1},{{0,1004010143,1},1},{{0,1006010143,1},1},{{0,1008010143,1},1},{{0,1010010143,1},1},{{0,1001010143,1},1}]','[]','[1002010143,1004010143,1006010143,1008010143,1010010143,1001010143]'),(32080145,0,1000,0,2,0,1,0,'[{{0,1002020143,1},1},{{0,1004020143,1},1},{{0,1006020143,1},1},{{0,1008020143,1},1},{{0,1010020143,1},1},{{0,1001020143,1},1}]','[]','[1002020143,1004020143,1006020143,1008020143,1010020143,1001020143]'),(32080145,0,1000,0,3,0,1,0,'[{{0,1002030143,1},1},{{0,1004030143,1},1},{{0,1006030143,1},1},{{0,1008030143,1},1},{{0,1010030143,1},1},{{0,1001030143,1},1}]','[]','[1002030143,1004030143,1006030143,1008030143,1010030143,1001030143]'),(32080145,0,1000,0,4,0,1,0,'[{{0,1002040143,1},1},{{0,1004040143,1},1},{{0,1006040143,1},1},{{0,1008040143,1},1},{{0,1010040143,1},1},{{0,1001040143,1},1}]','[]','[1002040143,1004040143,1006040143,1008040143,1010040143,1001040143]'),(32080146,0,1000,0,1,0,1,0,'[{{0,1007010143,1},1},{{0,1003000143,1},1},{{0,1005000143,1},1},{{0,1009000143,1},1}]','[]','[1007010143,1003000143,1005000143,1009000143]'),(32080146,0,1000,0,2,0,1,0,'[{{0,1007020143,1},1},{{0,1003000143,1},1},{{0,1005000143,1},1},{{0,1009000143,1},1}]','[]','[1007020143,1003000143,1005000143,1009000143]'),(32080146,0,1000,0,3,0,1,0,'[{{0,1007030143,1},1},{{0,1003000143,1},1},{{0,1005000143,1},1},{{0,1009000143,1},1}]','[]','[1007030143,1003000143,1005000143,1009000143]'),(32080146,0,1000,0,4,0,1,0,'[{{0,1007040143,1},1},{{0,1003000143,1},1},{{0,1005000143,1},1},{{0,1009000143,1},1}]','[]','[1007040143,1003000143,1005000143,1009000143]'),(32080147,0,1000,0,1,0,1,0,'[{{0,1007010143,1},1},{{0,1003000143,1},1}]','[]','[1007010143,1003000143]'),(32080147,0,1000,0,2,0,1,0,'[{{0,1007020143,1},1},{{0,1003000143,1},1}]','[]','[1007020143,1003000143]'),(32080147,0,1000,0,3,0,1,0,'[{{0,1007030143,1},1},{{0,1003000143,1},1}]','[]','[1007030143,1003000143]'),(32080147,0,1000,0,4,0,1,0,'[{{0,1007040143,1},1},{{0,1003000143,1},1}]','[]','[1007040143,1003000143]'),(32080148,0,1000,0,0,0,1,0,'[{{0,1005000143,1},1},{{0,1009000143,1},1}]','[]','[1005000143,1009000143]'),(32080151,0,1000,0,1,0,1,0,'[{{0,1001010153,1},1},{{0,1002010153,1},1},{{0,1003000153,1},1},{{0,1004010153,1},1},{{0,1006010153,1},1},{{0,1007010153,1},1},{{0,1008010153,1},1},{{0,1010010153,1},1}]','[]','[1001010153,1002010153,1003000153,1004010153,1005000153,1006010153,1007010153,1008010153,1009000153,1010010153]'),(32080151,0,1000,0,2,0,1,0,'[{{0,1001020153,1},1},{{0,1002020153,1},1},{{0,1003000153,1},1},{{0,1004020153,1},1},{{0,1006020153,1},1},{{0,1007020153,1},1},{{0,1008020153,1},1},{{0,1010020153,1},1}]','[]','[1001020153,1002020153,1003000153,1004020153,1005000153,1006020153,1007020153,1008020153,1009000153,1010020153]'),(32080151,0,1000,0,3,0,1,0,'[{{0,1001030153,1},1},{{0,1002030153,1},1},{{0,1003000153,1},1},{{0,1004030153,1},1},{{0,1006030153,1},1},{{0,1007030153,1},1},{{0,1008030153,1},1},{{0,1010030153,1},1}]','[]','[1001030153,1002030153,1003000153,1004030153,1005000153,1006030153,1007030153,1008030153,1009000153,1010030153]'),(32080151,0,1000,0,4,0,1,0,'[{{0,1001040153,1},1},{{0,1002040153,1},1},{{0,1003000153,1},1},{{0,1004040153,1},1},{{0,1006040153,1},1},{{0,1007040153,1},1},{{0,1008040153,1},1},{{0,1010040153,1},1}]','[]','[1001040153,1002040153,1003000153,1004040153,1005000153,1006040153,1007040153,1008040153,1009000153,1010040153]'),(32080152,0,1000,0,1,0,1,0,'[{{0,1002010153,1},1},{{0,1004010153,1},1},{{0,1006010153,1},1},{{0,1008010153,1},1},{{0,1010010153,1},1}]','[]','[1002010153,1004010153,1006010153,1008010153,1010010153]'),(32080152,0,1000,0,2,0,1,0,'[{{0,1002020153,1},1},{{0,1004020153,1},1},{{0,1006020153,1},1},{{0,1008020153,1},1},{{0,1010020153,1},1}]','[]','[1002020153,1004020153,1006020153,1008020153,1010020153]'),(32080152,0,1000,0,3,0,1,0,'[{{0,1002030153,1},1},{{0,1004030153,1},1},{{0,1006030153,1},1},{{0,1008030153,1},1},{{0,1010030153,1},1}]','[]','[1002030153,1004030153,1006030153,1008030153,1010030153]'),(32080152,0,1000,0,4,0,1,0,'[{{0,1002040153,1},1},{{0,1004040153,1},1},{{0,1006040153,1},1},{{0,1008040153,1},1},{{0,1010040153,1},1}]','[]','[1002040153,1004040153,1006040153,1008040153,1010040153]'),(32080153,0,1000,0,1,0,1,0,'[{{0,1001010153,1},1},{{0,1007010153,1},1}]','[]','[1001010153,1007010153]'),(32080153,0,1000,0,2,0,1,0,'[{{0,1001020153,1},1},{{0,1007020153,1},1}]','[]','[1001020153,1007020153]'),(32080153,0,1000,0,3,0,1,0,'[{{0,1001030153,1},1},{{0,1007030153,1},1}]','[]','[1001030153,1007030153]'),(32080153,0,1000,0,4,0,1,0,'[{{0,1001040153,1},1},{{0,1007040153,1},1}]','[]','[1001040153,1007040153]'),(32080155,0,1000,0,1,0,1,0,'[{{0,1002010153,1},1},{{0,1004010153,1},1},{{0,1006010153,1},1},{{0,1008010153,1},1},{{0,1010010153,1},1},{{0,1001010153,1},1}]','[]','[1002010153,1004010153,1006010153,1008010153,1010010153,1001010153]'),(32080155,0,1000,0,2,0,1,0,'[{{0,1002020153,1},1},{{0,1004020153,1},1},{{0,1006020153,1},1},{{0,1008020153,1},1},{{0,1010020153,1},1},{{0,1001020153,1},1}]','[]','[1002020153,1004020153,1006020153,1008020153,1010020153,1001020153]'),(32080155,0,1000,0,3,0,1,0,'[{{0,1002030153,1},1},{{0,1004030153,1},1},{{0,1006030153,1},1},{{0,1008030153,1},1},{{0,1010030153,1},1},{{0,1001030153,1},1}]','[]','[1002030153,1004030153,1006030153,1008030153,1010030153,1001030153]'),(32080155,0,1000,0,4,0,1,0,'[{{0,1002040153,1},1},{{0,1004040153,1},1},{{0,1006040153,1},1},{{0,1008040153,1},1},{{0,1010040153,1},1},{{0,1001040153,1},1}]','[]','[1002040153,1004040153,1006040153,1008040153,1010040153,1001040153]'),(32080156,0,1000,0,1,0,1,0,'[{{0,1007010153,1},1},{{0,1003000153,1},1},{{0,1005000153,1},1},{{0,1009000153,1},1}]','[]','[1007010153,1003000153,1005000153,1009000153]'),(32080156,0,1000,0,2,0,1,0,'[{{0,1007020153,1},1},{{0,1003000153,1},1},{{0,1005000153,1},1},{{0,1009000153,1},1}]','[]','[1007020153,1003000153,1005000153,1009000153]'),(32080156,0,1000,0,3,0,1,0,'[{{0,1007030153,1},1},{{0,1003000153,1},1},{{0,1005000153,1},1},{{0,1009000153,1},1}]','[]','[1007030153,1003000153,1005000153,1009000153]'),(32080156,0,1000,0,4,0,1,0,'[{{0,1007040153,1},1},{{0,1003000153,1},1},{{0,1005000153,1},1},{{0,1009000153,1},1}]','[]','[1007040153,1003000153,1005000153,1009000153]'),(32080157,0,1000,0,1,0,1,0,'[{{0,1007010153,1},1},{{0,1003000153,1},1}]','[]','[1007010153,1003000153]'),(32080157,0,1000,0,2,0,1,0,'[{{0,1007020153,1},1},{{0,1003000153,1},1}]','[]','[1007020153,1003000153]'),(32080157,0,1000,0,3,0,1,0,'[{{0,1007030153,1},1},{{0,1003000153,1},1}]','[]','[1007030153,1003000153]'),(32080157,0,1000,0,4,0,1,0,'[{{0,1007040153,1},1},{{0,1003000153,1},1}]','[]','[1007040153,1003000153]'),(32080158,0,1000,0,0,0,1,0,'[{{0,1005000153,1},1},{{0,1009000153,1},1}]','[]','[1005000153,1009000153]'),(32080161,0,1000,0,1,0,1,0,'[{{0,1001010163,1},1},{{0,1002010163,1},1},{{0,1003000163,1},1},{{0,1004010163,1},1},{{0,1006010163,1},1},{{0,1007010163,1},1},{{0,1008010163,1},1},{{0,1010010163,1},1}]','[]','[1001010163,1002010163,1003000163,1004010163,1005000163,1006010163,1007010163,1008010163,1009000163,1010010163]'),(32080161,0,1000,0,2,0,1,0,'[{{0,1001020163,1},1},{{0,1002020163,1},1},{{0,1003000163,1},1},{{0,1004020163,1},1},{{0,1006020163,1},1},{{0,1007020163,1},1},{{0,1008020163,1},1},{{0,1010020163,1},1}]','[]','[1001020163,1002020163,1003000163,1004020163,1005000163,1006020163,1007020163,1008020163,1009000163,1010020163]'),(32080161,0,1000,0,3,0,1,0,'[{{0,1001030163,1},1},{{0,1002030163,1},1},{{0,1003000163,1},1},{{0,1004030163,1},1},{{0,1006030163,1},1},{{0,1007030163,1},1},{{0,1008030163,1},1},{{0,1010030163,1},1}]','[]','[1001030163,1002030163,1003000163,1004030163,1005000163,1006030163,1007030163,1008030163,1009000163,1010030163]'),(32080161,0,1000,0,4,0,1,0,'[{{0,1001040163,1},1},{{0,1002040163,1},1},{{0,1003000163,1},1},{{0,1004040163,1},1},{{0,1006040163,1},1},{{0,1007040163,1},1},{{0,1008040163,1},1},{{0,1010040163,1},1}]','[]','[1001040163,1002040163,1003000163,1004040163,1005000163,1006040163,1007040163,1008040163,1009000163,1010040163]'),(32080162,0,1000,0,1,0,1,0,'[{{0,1002010163,1},1},{{0,1004010163,1},1},{{0,1006010163,1},1},{{0,1008010163,1},1},{{0,1010010163,1},1}]','[]','[1002010163,1004010163,1006010163,1008010163,1010010163]'),(32080162,0,1000,0,2,0,1,0,'[{{0,1002020163,1},1},{{0,1004020163,1},1},{{0,1006020163,1},1},{{0,1008020163,1},1},{{0,1010020163,1},1}]','[]','[1002020163,1004020163,1006020163,1008020163,1010020163]'),(32080162,0,1000,0,3,0,1,0,'[{{0,1002030163,1},1},{{0,1004030163,1},1},{{0,1006030163,1},1},{{0,1008030163,1},1},{{0,1010030163,1},1}]','[]','[1002030163,1004030163,1006030163,1008030163,1010030163]'),(32080162,0,1000,0,4,0,1,0,'[{{0,1002040163,1},1},{{0,1004040163,1},1},{{0,1006040163,1},1},{{0,1008040163,1},1},{{0,1010040163,1},1}]','[]','[1002040163,1004040163,1006040163,1008040163,1010040163]'),(32080163,0,1000,0,1,0,1,0,'[{{0,1001010163,1},1},{{0,1007010163,1},1}]','[]','[1001010163,1007010163]'),(32080163,0,1000,0,2,0,1,0,'[{{0,1001020163,1},1},{{0,1007020163,1},1}]','[]','[1001020163,1007020163]'),(32080163,0,1000,0,3,0,1,0,'[{{0,1001030163,1},1},{{0,1007030163,1},1}]','[]','[1001030163,1007030163]'),(32080163,0,1000,0,4,0,1,0,'[{{0,1001040163,1},1},{{0,1007040163,1},1}]','[]','[1001040163,1007040163]'),(32080165,0,1000,0,1,0,1,0,'[{{0,1002010163,1},1},{{0,1004010163,1},1},{{0,1006010163,1},1},{{0,1008010163,1},1},{{0,1010010163,1},1},{{0,1001010163,1},1}]','[]','[1002010163,1004010163,1006010163,1008010163,1010010163,1001010163]'),(32080165,0,1000,0,2,0,1,0,'[{{0,1002020163,1},1},{{0,1004020163,1},1},{{0,1006020163,1},1},{{0,1008020163,1},1},{{0,1010020163,1},1},{{0,1001020163,1},1}]','[]','[1002020163,1004020163,1006020163,1008020163,1010020163,1001020163]'),(32080165,0,1000,0,3,0,1,0,'[{{0,1002030163,1},1},{{0,1004030163,1},1},{{0,1006030163,1},1},{{0,1008030163,1},1},{{0,1010030163,1},1},{{0,1001030163,1},1}]','[]','[1002030163,1004030163,1006030163,1008030163,1010030163,1001030163]'),(32080165,0,1000,0,4,0,1,0,'[{{0,1002040163,1},1},{{0,1004040163,1},1},{{0,1006040163,1},1},{{0,1008040163,1},1},{{0,1010040163,1},1},{{0,1001040163,1},1}]','[]','[1002040163,1004040163,1006040163,1008040163,1010040163,1001040163]'),(32080166,0,1000,0,1,0,1,0,'[{{0,1007010163,1},1},{{0,1003000163,1},1},{{0,1005000163,1},1},{{0,1009000163,1},1}]','[]','[1007010163,1003000163,1005000163,1009000163]'),(32080166,0,1000,0,2,0,1,0,'[{{0,1007020163,1},1},{{0,1003000163,1},1},{{0,1005000163,1},1},{{0,1009000163,1},1}]','[]','[1007020163,1003000163,1005000163,1009000163]'),(32080166,0,1000,0,3,0,1,0,'[{{0,1007030163,1},1},{{0,1003000163,1},1},{{0,1005000163,1},1},{{0,1009000163,1},1}]','[]','[1007030163,1003000163,1005000163,1009000163]'),(32080166,0,1000,0,4,0,1,0,'[{{0,1007040163,1},1},{{0,1003000163,1},1},{{0,1005000163,1},1},{{0,1009000163,1},1}]','[]','[1007040163,1003000163,1005000163,1009000163]'),(32080167,0,1000,0,1,0,1,0,'[{{0,1007010163,1},1},{{0,1003000163,1},1}]','[]','[1007010163,1003000163]'),(32080167,0,1000,0,2,0,1,0,'[{{0,1007020163,1},1},{{0,1003000163,1},1}]','[]','[1007020163,1003000163]'),(32080167,0,1000,0,3,0,1,0,'[{{0,1007030163,1},1},{{0,1003000163,1},1}]','[]','[1007030163,1003000163]'),(32080167,0,1000,0,4,0,1,0,'[{{0,1007040163,1},1},{{0,1003000163,1},1}]','[]','[1007040163,1003000163]'),(32080168,0,1000,0,0,0,1,0,'[{{0,1005000163,1},1},{{0,1009000163,1},1}]','[]','[1005000163,1009000163]'),(32080171,0,1000,0,1,0,1,0,'[{{0,1001010100,1},1},{{0,1002010100,1},1},{{0,1003000100,1},1},{{0,1004010100,1},1},{{0,1006010100,1},1},{{0,1007010100,1},1},{{0,1008010100,1},1},{{0,1010010100,1},1}]','[]','[]'),(32080171,0,1000,0,2,0,1,0,'[{{0,1001020100,1},1},{{0,1002020100,1},1},{{0,1003000100,1},1},{{0,1004020100,1},1},{{0,1006020100,1},1},{{0,1007020100,1},1},{{0,1008020100,1},1},{{0,1010020100,1},1}]','[]','[]'),(32080171,0,1000,0,3,0,1,0,'[{{0,1001030100,1},1},{{0,1002030100,1},1},{{0,1003000100,1},1},{{0,1004030100,1},1},{{0,1006030100,1},1},{{0,1007030100,1},1},{{0,1008030100,1},1},{{0,1010030100,1},1}]','[]','[]'),(32080171,0,1000,0,4,0,1,0,'[{{0,1001040100,1},1},{{0,1002040100,1},1},{{0,1003000100,1},1},{{0,1004040100,1},1},{{0,1006040100,1},1},{{0,1007040100,1},1},{{0,1008040100,1},1},{{0,1010040100,1},1}]','[]','[]'),(32080172,0,1000,0,1,0,1,0,'[{{0,1002010100,1},1},{{0,1004010100,1},1},{{0,1006010100,1},1},{{0,1008010100,1},1},{{0,1010010100,1},1}]','[]','[]'),(32080172,0,1000,0,2,0,1,0,'[{{0,1002020100,1},1},{{0,1004020100,1},1},{{0,1006020100,1},1},{{0,1008020100,1},1},{{0,1010020100,1},1}]','[]','[]'),(32080172,0,1000,0,3,0,1,0,'[{{0,1002030100,1},1},{{0,1004030100,1},1},{{0,1006030100,1},1},{{0,1008030100,1},1},{{0,1010030100,1},1}]','[]','[]'),(32080172,0,1000,0,4,0,1,0,'[{{0,1002040100,1},1},{{0,1004040100,1},1},{{0,1006040100,1},1},{{0,1008040100,1},1},{{0,1010040100,1},1}]','[]','[]'),(32080173,0,1000,0,1,0,1,0,'[{{0,1001010100,1},1},{{0,1007010100,1},1}]','[]','[]'),(32080173,0,1000,0,2,0,1,0,'[{{0,1001020100,1},1},{{0,1007020100,1},1}]','[]','[]'),(32080173,0,1000,0,3,0,1,0,'[{{0,1001030100,1},1},{{0,1007030100,1},1}]','[]','[]'),(32080173,0,1000,0,4,0,1,0,'[{{0,1001040100,1},1},{{0,1007040100,1},1}]','[]','[]'),(32080175,0,1000,0,1,0,1,0,'[{{0,1002010100,1},1},{{0,1004010100,1},1},{{0,1006010100,1},1},{{0,1008010100,1},1},{{0,1010010100,1},1},{{0,1001010100,1},1}]','[]','[]'),(32080175,0,1000,0,2,0,1,0,'[{{0,1002020100,1},1},{{0,1004020100,1},1},{{0,1006020100,1},1},{{0,1008020100,1},1},{{0,1010020100,1},1},{{0,1001020100,1},1}]','[]','[]'),(32080175,0,1000,0,3,0,1,0,'[{{0,1002030100,1},1},{{0,1004030100,1},1},{{0,1006030100,1},1},{{0,1008030100,1},1},{{0,1010030100,1},1},{{0,1001030100,1},1}]','[]','[]'),(32080175,0,1000,0,4,0,1,0,'[{{0,1002040100,1},1},{{0,1004040100,1},1},{{0,1006040100,1},1},{{0,1008040100,1},1},{{0,1010040100,1},1},{{0,1001040100,1},1}]','[]','[]'),(32080176,0,1000,0,1,0,1,0,'[{{0,1007010100,1},1},{{0,1003000100,1},1},{{0,1005000100,1},1},{{0,1009000100,1},1}]','[]','[]'),(32080176,0,1000,0,2,0,1,0,'[{{0,1007020100,1},1},{{0,1003000100,1},1},{{0,1005000100,1},1},{{0,1009000100,1},1}]','[]','[]'),(32080176,0,1000,0,3,0,1,0,'[{{0,1007030100,1},1},{{0,1003000100,1},1},{{0,1005000100,1},1},{{0,1009000100,1},1}]','[]','[]'),(32080176,0,1000,0,4,0,1,0,'[{{0,1007040100,1},1},{{0,1003000100,1},1},{{0,1005000100,1},1},{{0,1009000100,1},1}]','[]','[]'),(32080177,0,1000,0,1,0,1,0,'[{{0,1007010100,1},1},{{0,1003000100,1},1}]','[]','[]'),(32080177,0,1000,0,2,0,1,0,'[{{0,1007020100,1},1},{{0,1003000100,1},1}]','[]','[]'),(32080177,0,1000,0,3,0,1,0,'[{{0,1007030100,1},1},{{0,1003000100,1},1}]','[]','[]'),(32080177,0,1000,0,4,0,1,0,'[{{0,1007040100,1},1},{{0,1003000100,1},1}]','[]','[]'),(32080178,0,1000,0,0,0,1,0,'[{{0,1005000100,1},1},{{0,1009000100,1},1}]','[]','[]'),(32080181,0,1000,0,1,0,1,0,'[{{0,1001010110,1},1},{{0,1002010110,1},1},{{0,1003000110,1},1},{{0,1004010110,1},1},{{0,1006010110,1},1},{{0,1007010110,1},1},{{0,1008010110,1},1},{{0,1010010110,1},1}]','[]','[]'),(32080181,0,1000,0,2,0,1,0,'[{{0,1001020110,1},1},{{0,1002020110,1},1},{{0,1003000110,1},1},{{0,1004020110,1},1},{{0,1006020110,1},1},{{0,1007020110,1},1},{{0,1008020110,1},1},{{0,1010020110,1},1}]','[]','[]'),(32080181,0,1000,0,3,0,1,0,'[{{0,1001030110,1},1},{{0,1002030110,1},1},{{0,1003000110,1},1},{{0,1004030110,1},1},{{0,1006030110,1},1},{{0,1007030110,1},1},{{0,1008030110,1},1},{{0,1010030110,1},1}]','[]','[]'),(32080181,0,1000,0,4,0,1,0,'[{{0,1001040110,1},1},{{0,1002040110,1},1},{{0,1003000110,1},1},{{0,1004040110,1},1},{{0,1006040110,1},1},{{0,1007040110,1},1},{{0,1008040110,1},1},{{0,1010040110,1},1}]','[]','[]'),(32080182,0,1000,0,1,0,1,0,'[{{0,1002010110,1},1},{{0,1004010110,1},1},{{0,1006010110,1},1},{{0,1008010110,1},1},{{0,1010010110,1},1}]','[]','[]'),(32080182,0,1000,0,2,0,1,0,'[{{0,1002020110,1},1},{{0,1004020110,1},1},{{0,1006020110,1},1},{{0,1008020110,1},1},{{0,1010020110,1},1}]','[]','[]'),(32080182,0,1000,0,3,0,1,0,'[{{0,1002030110,1},1},{{0,1004030110,1},1},{{0,1006030110,1},1},{{0,1008030110,1},1},{{0,1010030110,1},1}]','[]','[]'),(32080182,0,1000,0,4,0,1,0,'[{{0,1002040110,1},1},{{0,1004040110,1},1},{{0,1006040110,1},1},{{0,1008040110,1},1},{{0,1010040110,1},1}]','[]','[]'),(32080183,0,1000,0,1,0,1,0,'[{{0,1001010110,1},1},{{0,1007010110,1},1}]','[]','[]'),(32080183,0,1000,0,2,0,1,0,'[{{0,1001020110,1},1},{{0,1007020110,1},1}]','[]','[]'),(32080183,0,1000,0,3,0,1,0,'[{{0,1001030110,1},1},{{0,1007030110,1},1}]','[]','[]'),(32080183,0,1000,0,4,0,1,0,'[{{0,1001040110,1},1},{{0,1007040110,1},1}]','[]','[]'),(32080185,0,1000,0,1,0,1,0,'[{{0,1002010110,1},1},{{0,1004010110,1},1},{{0,1006010110,1},1},{{0,1008010110,1},1},{{0,1010010110,1},1},{{0,1001010110,1},1}]','[]','[]'),(32080185,0,1000,0,2,0,1,0,'[{{0,1002020110,1},1},{{0,1004020110,1},1},{{0,1006020110,1},1},{{0,1008020110,1},1},{{0,1010020110,1},1},{{0,1001020110,1},1}]','[]','[]'),(32080185,0,1000,0,3,0,1,0,'[{{0,1002030110,1},1},{{0,1004030110,1},1},{{0,1006030110,1},1},{{0,1008030110,1},1},{{0,1010030110,1},1},{{0,1001030110,1},1}]','[]','[]'),(32080185,0,1000,0,4,0,1,0,'[{{0,1002040110,1},1},{{0,1004040110,1},1},{{0,1006040110,1},1},{{0,1008040110,1},1},{{0,1010040110,1},1},{{0,1001040110,1},1}]','[]','[]'),(32080186,0,1000,0,1,0,1,0,'[{{0,1007010110,1},1},{{0,1003000110,1},1},{{0,1005000110,1},1},{{0,1009000110,1},1}]','[]','[]'),(32080186,0,1000,0,2,0,1,0,'[{{0,1007020110,1},1},{{0,1003000110,1},1},{{0,1005000110,1},1},{{0,1009000110,1},1}]','[]','[]'),(32080186,0,1000,0,3,0,1,0,'[{{0,1007030110,1},1},{{0,1003000110,1},1},{{0,1005000110,1},1},{{0,1009000110,1},1}]','[]','[]'),(32080186,0,1000,0,4,0,1,0,'[{{0,1007040110,1},1},{{0,1003000110,1},1},{{0,1005000110,1},1},{{0,1009000110,1},1}]','[]','[]'),(32080187,0,1000,0,1,0,1,0,'[{{0,1007010110,1},1},{{0,1003000110,1},1}]','[]','[]'),(32080187,0,1000,0,2,0,1,0,'[{{0,1007020110,1},1},{{0,1003000110,1},1}]','[]','[]'),(32080187,0,1000,0,3,0,1,0,'[{{0,1007030110,1},1},{{0,1003000110,1},1}]','[]','[]'),(32080187,0,1000,0,4,0,1,0,'[{{0,1007040110,1},1},{{0,1003000110,1},1}]','[]','[]'),(32080188,0,1000,0,0,0,1,0,'[{{0,1005000110,1},1},{{0,1009000110,1},1}]','[]','[]'),(32080191,0,1000,0,1,0,1,0,'[{{0,1001010120,1},1},{{0,1002010120,1},1},{{0,1003000120,1},1},{{0,1004010120,1},1},{{0,1006010120,1},1},{{0,1007010120,1},1},{{0,1008010120,1},1},{{0,1010010120,1},1}]','[]','[]'),(32080191,0,1000,0,2,0,1,0,'[{{0,1001020120,1},1},{{0,1002020120,1},1},{{0,1003000120,1},1},{{0,1004020120,1},1},{{0,1006020120,1},1},{{0,1007020120,1},1},{{0,1008020120,1},1},{{0,1010020120,1},1}]','[]','[]'),(32080191,0,1000,0,3,0,1,0,'[{{0,1001030120,1},1},{{0,1002030120,1},1},{{0,1003000120,1},1},{{0,1004030120,1},1},{{0,1006030120,1},1},{{0,1007030120,1},1},{{0,1008030120,1},1},{{0,1010030120,1},1}]','[]','[]'),(32080191,0,1000,0,4,0,1,0,'[{{0,1001040120,1},1},{{0,1002040120,1},1},{{0,1003000120,1},1},{{0,1004040120,1},1},{{0,1006040120,1},1},{{0,1007040120,1},1},{{0,1008040120,1},1},{{0,1010040120,1},1}]','[]','[]'),(32080192,0,1000,0,1,0,1,0,'[{{0,1002010120,1},1},{{0,1004010120,1},1},{{0,1006010120,1},1},{{0,1008010120,1},1},{{0,1010010120,1},1}]','[]','[]'),(32080192,0,1000,0,2,0,1,0,'[{{0,1002020120,1},1},{{0,1004020120,1},1},{{0,1006020120,1},1},{{0,1008020120,1},1},{{0,1010020120,1},1}]','[]','[]'),(32080192,0,1000,0,3,0,1,0,'[{{0,1002030120,1},1},{{0,1004030120,1},1},{{0,1006030120,1},1},{{0,1008030120,1},1},{{0,1010030120,1},1}]','[]','[]'),(32080192,0,1000,0,4,0,1,0,'[{{0,1002040120,1},1},{{0,1004040120,1},1},{{0,1006040120,1},1},{{0,1008040120,1},1},{{0,1010040120,1},1}]','[]','[]'),(32080193,0,1000,0,1,0,1,0,'[{{0,1001010120,1},1},{{0,1007010120,1},1}]','[]','[]'),(32080193,0,1000,0,2,0,1,0,'[{{0,1001020120,1},1},{{0,1007020120,1},1}]','[]','[]'),(32080193,0,1000,0,3,0,1,0,'[{{0,1001030120,1},1},{{0,1007030120,1},1}]','[]','[]'),(32080193,0,1000,0,4,0,1,0,'[{{0,1001040120,1},1},{{0,1007040120,1},1}]','[]','[]'),(32080195,0,1000,0,1,0,1,0,'[{{0,1002010120,1},1},{{0,1004010120,1},1},{{0,1006010120,1},1},{{0,1008010120,1},1},{{0,1010010120,1},1},{{0,1001010120,1},1}]','[]','[]'),(32080195,0,1000,0,2,0,1,0,'[{{0,1002020120,1},1},{{0,1004020120,1},1},{{0,1006020120,1},1},{{0,1008020120,1},1},{{0,1010020120,1},1},{{0,1001020120,1},1}]','[]','[]'),(32080195,0,1000,0,3,0,1,0,'[{{0,1002030120,1},1},{{0,1004030120,1},1},{{0,1006030120,1},1},{{0,1008030120,1},1},{{0,1010030120,1},1},{{0,1001030120,1},1}]','[]','[]'),(32080195,0,1000,0,4,0,1,0,'[{{0,1002040120,1},1},{{0,1004040120,1},1},{{0,1006040120,1},1},{{0,1008040120,1},1},{{0,1010040120,1},1},{{0,1001040120,1},1}]','[]','[]'),(32080196,0,1000,0,1,0,1,0,'[{{0,1007010120,1},1},{{0,1003000120,1},1},{{0,1005000120,1},1},{{0,1009000120,1},1}]','[]','[]'),(32080196,0,1000,0,2,0,1,0,'[{{0,1007020120,1},1},{{0,1003000120,1},1},{{0,1005000120,1},1},{{0,1009000120,1},1}]','[]','[]'),(32080196,0,1000,0,3,0,1,0,'[{{0,1007030120,1},1},{{0,1003000120,1},1},{{0,1005000120,1},1},{{0,1009000120,1},1}]','[]','[]'),(32080196,0,1000,0,4,0,1,0,'[{{0,1007040120,1},1},{{0,1003000120,1},1},{{0,1005000120,1},1},{{0,1009000120,1},1}]','[]','[]'),(32080197,0,1000,0,1,0,1,0,'[{{0,1007010120,1},1},{{0,1003000120,1},1}]','[]','[]'),(32080197,0,1000,0,2,0,1,0,'[{{0,1007020120,1},1},{{0,1003000120,1},1}]','[]','[]'),(32080197,0,1000,0,3,0,1,0,'[{{0,1007030120,1},1},{{0,1003000120,1},1}]','[]','[]'),(32080197,0,1000,0,4,0,1,0,'[{{0,1007040120,1},1},{{0,1003000120,1},1}]','[]','[]'),(32080198,0,1000,0,0,0,1,0,'[{{0,1005000120,1},1},{{0,1009000120,1},1}]','[]','[]'),(32080201,0,1000,0,1,0,1,0,'[{{0,1001010131,1},1},{{0,1002010131,1},1},{{0,1003000131,1},1},{{0,1004010131,1},1},{{0,1006010131,1},1},{{0,1007010131,1},1},{{0,1008010131,1},1},{{0,1010010131,1},1}]','[]','[]'),(32080201,0,1000,0,2,0,1,0,'[{{0,1001020131,1},1},{{0,1002020131,1},1},{{0,1003000131,1},1},{{0,1004020131,1},1},{{0,1006020131,1},1},{{0,1007020131,1},1},{{0,1008020131,1},1},{{0,1010020131,1},1}]','[]','[]'),(32080201,0,1000,0,3,0,1,0,'[{{0,1001030131,1},1},{{0,1002030131,1},1},{{0,1003000131,1},1},{{0,1004030131,1},1},{{0,1006030131,1},1},{{0,1007030131,1},1},{{0,1008030131,1},1},{{0,1010030131,1},1}]','[]','[]'),(32080201,0,1000,0,4,0,1,0,'[{{0,1001040131,1},1},{{0,1002040131,1},1},{{0,1003000131,1},1},{{0,1004040131,1},1},{{0,1006040131,1},1},{{0,1007040131,1},1},{{0,1008040131,1},1},{{0,1010040131,1},1}]','[]','[]'),(32080202,0,1000,0,1,0,1,0,'[{{0,1002010131,1},1},{{0,1004010131,1},1},{{0,1006010131,1},1},{{0,1008010131,1},1},{{0,1010010131,1},1}]','[]','[]'),(32080202,0,1000,0,2,0,1,0,'[{{0,1002020131,1},1},{{0,1004020131,1},1},{{0,1006020131,1},1},{{0,1008020131,1},1},{{0,1010020131,1},1}]','[]','[]'),(32080202,0,1000,0,3,0,1,0,'[{{0,1002030131,1},1},{{0,1004030131,1},1},{{0,1006030131,1},1},{{0,1008030131,1},1},{{0,1010030131,1},1}]','[]','[]'),(32080202,0,1000,0,4,0,1,0,'[{{0,1002040131,1},1},{{0,1004040131,1},1},{{0,1006040131,1},1},{{0,1008040131,1},1},{{0,1010040131,1},1}]','[]','[]'),(32080203,0,1000,0,1,0,1,0,'[{{0,1001010131,1},1},{{0,1007010131,1},1}]','[]','[]'),(32080203,0,1000,0,2,0,1,0,'[{{0,1001020131,1},1},{{0,1007020131,1},1}]','[]','[]'),(32080203,0,1000,0,3,0,1,0,'[{{0,1001030131,1},1},{{0,1007030131,1},1}]','[]','[]'),(32080203,0,1000,0,4,0,1,0,'[{{0,1001040131,1},1},{{0,1007040131,1},1}]','[]','[]'),(32080205,0,1000,0,1,0,1,0,'[{{0,1002010131,1},1},{{0,1004010131,1},1},{{0,1006010131,1},1},{{0,1008010131,1},1},{{0,1010010131,1},1},{{0,1001010131,1},1}]','[]','[]'),(32080205,0,1000,0,2,0,1,0,'[{{0,1002020131,1},1},{{0,1004020131,1},1},{{0,1006020131,1},1},{{0,1008020131,1},1},{{0,1010020131,1},1},{{0,1001020131,1},1}]','[]','[]'),(32080205,0,1000,0,3,0,1,0,'[{{0,1002030131,1},1},{{0,1004030131,1},1},{{0,1006030131,1},1},{{0,1008030131,1},1},{{0,1010030131,1},1},{{0,1001030131,1},1}]','[]','[]'),(32080205,0,1000,0,4,0,1,0,'[{{0,1002040131,1},1},{{0,1004040131,1},1},{{0,1006040131,1},1},{{0,1008040131,1},1},{{0,1010040131,1},1},{{0,1001040131,1},1}]','[]','[]'),(32080206,0,1000,0,1,0,1,0,'[{{0,1007010131,1},1},{{0,1003000131,1},1},{{0,1005000131,1},1},{{0,1009000131,1},1}]','[]','[]'),(32080206,0,1000,0,2,0,1,0,'[{{0,1007020131,1},1},{{0,1003000131,1},1},{{0,1005000131,1},1},{{0,1009000131,1},1}]','[]','[]'),(32080206,0,1000,0,3,0,1,0,'[{{0,1007030131,1},1},{{0,1003000131,1},1},{{0,1005000131,1},1},{{0,1009000131,1},1}]','[]','[]'),(32080206,0,1000,0,4,0,1,0,'[{{0,1007040131,1},1},{{0,1003000131,1},1},{{0,1005000131,1},1},{{0,1009000131,1},1}]','[]','[]'),(32080207,0,1000,0,1,0,1,0,'[{{0,1007010131,1},1},{{0,1003000131,1},1}]','[]','[]'),(32080207,0,1000,0,2,0,1,0,'[{{0,1007020131,1},1},{{0,1003000131,1},1}]','[]','[]'),(32080207,0,1000,0,3,0,1,0,'[{{0,1007030131,1},1},{{0,1003000131,1},1}]','[]','[]'),(32080207,0,1000,0,4,0,1,0,'[{{0,1007040131,1},1},{{0,1003000131,1},1}]','[]','[]'),(32080208,0,1000,0,0,0,1,0,'[{{0,1005000131,1},1},{{0,1009000131,1},1}]','[]','[]'),(32080211,0,1000,0,1,0,1,0,'[{{0,1001010232,1},1},{{0,1002010232,1},1},{{0,1003000232,1},1},{{0,1004010232,1},1},{{0,1006010232,1},1},{{0,1007010232,1},1},{{0,1008010232,1},1},{{0,1010010232,1},1}]','[]','[1001010232,1002010232,1003000232,1004010232,1005000232,1006010232,1007010232,1008010232,1009000232,1010010232]'),(32080211,0,1000,0,2,0,1,0,'[{{0,1001020232,1},1},{{0,1002020232,1},1},{{0,1003000232,1},1},{{0,1004020232,1},1},{{0,1006020232,1},1},{{0,1007020232,1},1},{{0,1008020232,1},1},{{0,1010020232,1},1}]','[]','[1001020232,1002020232,1003000232,1004020232,1005000232,1006020232,1007020232,1008020232,1009000232,1010020232]'),(32080211,0,1000,0,3,0,1,0,'[{{0,1001030232,1},1},{{0,1002030232,1},1},{{0,1003000232,1},1},{{0,1004030232,1},1},{{0,1006030232,1},1},{{0,1007030232,1},1},{{0,1008030232,1},1},{{0,1010030232,1},1}]','[]','[1001030232,1002030232,1003000232,1004030232,1005000232,1006030232,1007030232,1008030232,1009000232,1010030232]'),(32080211,0,1000,0,4,0,1,0,'[{{0,1001040232,1},1},{{0,1002040232,1},1},{{0,1003000232,1},1},{{0,1004040232,1},1},{{0,1006040232,1},1},{{0,1007040232,1},1},{{0,1008040232,1},1},{{0,1010040232,1},1}]','[]','[1001040232,1002040232,1003000232,1004040232,1005000232,1006040232,1007040232,1008040232,1009000232,1010040232]'),(32080212,0,1000,0,1,0,1,0,'[{{0,1002010232,1},1},{{0,1004010232,1},1},{{0,1006010232,1},1},{{0,1008010232,1},1},{{0,1010010232,1},1}]','[]','[1002010232,1004010232,1006010232,1008010232,1010010232]'),(32080212,0,1000,0,2,0,1,0,'[{{0,1002020232,1},1},{{0,1004020232,1},1},{{0,1006020232,1},1},{{0,1008020232,1},1},{{0,1010020232,1},1}]','[]','[1002020232,1004020232,1006020232,1008020232,1010020232]'),(32080212,0,1000,0,3,0,1,0,'[{{0,1002030232,1},1},{{0,1004030232,1},1},{{0,1006030232,1},1},{{0,1008030232,1},1},{{0,1010030232,1},1}]','[]','[1002030232,1004030232,1006030232,1008030232,1010030232]'),(32080212,0,1000,0,4,0,1,0,'[{{0,1002040232,1},1},{{0,1004040232,1},1},{{0,1006040232,1},1},{{0,1008040232,1},1},{{0,1010040232,1},1}]','[]','[1002040232,1004040232,1006040232,1008040232,1010040232]'),(32080213,0,1000,0,1,0,1,0,'[{{0,1001010232,1},1},{{0,1007010232,1},1}]','[]','[1001010232,1007010232]'),(32080213,0,1000,0,2,0,1,0,'[{{0,1001020232,1},1},{{0,1007020232,1},1}]','[]','[1001020232,1007020232]'),(32080213,0,1000,0,3,0,1,0,'[{{0,1001030232,1},1},{{0,1007030232,1},1}]','[]','[1001030232,1007030232]'),(32080213,0,1000,0,4,0,1,0,'[{{0,1001040232,1},1},{{0,1007040232,1},1}]','[]','[1001040232,1007040232]'),(32080215,0,1000,0,1,0,1,0,'[{{0,1002010232,1},1},{{0,1004010232,1},1},{{0,1006010232,1},1},{{0,1008010232,1},1},{{0,1010010232,1},1},{{0,1001010232,1},1}]','[]','[1002010232,1004010232,1006010232,1008010232,1010010232,1001010232]'),(32080215,0,1000,0,2,0,1,0,'[{{0,1002020232,1},1},{{0,1004020232,1},1},{{0,1006020232,1},1},{{0,1008020232,1},1},{{0,1010020232,1},1},{{0,1001020232,1},1}]','[]','[1002020232,1004020232,1006020232,1008020232,1010020232,1001020232]'),(32080215,0,1000,0,3,0,1,0,'[{{0,1002030232,1},1},{{0,1004030232,1},1},{{0,1006030232,1},1},{{0,1008030232,1},1},{{0,1010030232,1},1},{{0,1001030232,1},1}]','[]','[1002030232,1004030232,1006030232,1008030232,1010030232,1001030232]'),(32080215,0,1000,0,4,0,1,0,'[{{0,1002040232,1},1},{{0,1004040232,1},1},{{0,1006040232,1},1},{{0,1008040232,1},1},{{0,1010040232,1},1},{{0,1001040232,1},1}]','[]','[1002040232,1004040232,1006040232,1008040232,1010040232,1001040232]'),(32080216,0,1000,0,1,0,1,0,'[{{0,1007010232,1},1},{{0,1003000232,1},1},{{0,1005000232,1},1},{{0,1009000232,1},1}]','[]','[1007010232,1003000232,1005000232,1009000232]'),(32080216,0,1000,0,2,0,1,0,'[{{0,1007020232,1},1},{{0,1003000232,1},1},{{0,1005000232,1},1},{{0,1009000232,1},1}]','[]','[1007020232,1003000232,1005000232,1009000232]'),(32080216,0,1000,0,3,0,1,0,'[{{0,1007030232,1},1},{{0,1003000232,1},1},{{0,1005000232,1},1},{{0,1009000232,1},1}]','[]','[1007030232,1003000232,1005000232,1009000232]'),(32080216,0,1000,0,4,0,1,0,'[{{0,1007040232,1},1},{{0,1003000232,1},1},{{0,1005000232,1},1},{{0,1009000232,1},1}]','[]','[1007040232,1003000232,1005000232,1009000232]'),(32080217,0,1000,0,1,0,1,0,'[{{0,1007010232,1},1},{{0,1003000232,1},1}]','[]','[1007010232,1003000232]'),(32080217,0,1000,0,2,0,1,0,'[{{0,1007020232,1},1},{{0,1003000232,1},1}]','[]','[1007020232,1003000232]'),(32080217,0,1000,0,3,0,1,0,'[{{0,1007030232,1},1},{{0,1003000232,1},1}]','[]','[1007030232,1003000232]'),(32080217,0,1000,0,4,0,1,0,'[{{0,1007040232,1},1},{{0,1003000232,1},1}]','[]','[1007040232,1003000232]'),(32080218,0,1000,0,0,0,1,0,'[{{0,1005000232,1},1},{{0,1009000232,1},1}]','[]','[1005000232,1009000232]'),(32080221,0,1000,0,1,0,1,0,'[{{0,1001010241,1},1},{{0,1002010241,1},1},{{0,1003000241,1},1},{{0,1004010241,1},1},{{0,1006010241,1},1},{{0,1007010241,1},1},{{0,1008010241,1},1},{{0,1010010241,1},1}]','[]','[]'),(32080221,0,1000,0,2,0,1,0,'[{{0,1001020241,1},1},{{0,1002020241,1},1},{{0,1003000241,1},1},{{0,1004020241,1},1},{{0,1006020241,1},1},{{0,1007020241,1},1},{{0,1008020241,1},1},{{0,1010020241,1},1}]','[]','[]'),(32080221,0,1000,0,3,0,1,0,'[{{0,1001030241,1},1},{{0,1002030241,1},1},{{0,1003000241,1},1},{{0,1004030241,1},1},{{0,1006030241,1},1},{{0,1007030241,1},1},{{0,1008030241,1},1},{{0,1010030241,1},1}]','[]','[]'),(32080221,0,1000,0,4,0,1,0,'[{{0,1001040241,1},1},{{0,1002040241,1},1},{{0,1003000241,1},1},{{0,1004040241,1},1},{{0,1006040241,1},1},{{0,1007040241,1},1},{{0,1008040241,1},1},{{0,1010040241,1},1}]','[]','[]'),(32080222,0,1000,0,1,0,1,0,'[{{0,1002010241,1},1},{{0,1004010241,1},1},{{0,1006010241,1},1},{{0,1008010241,1},1},{{0,1010010241,1},1}]','[]','[]'),(32080222,0,1000,0,2,0,1,0,'[{{0,1002020241,1},1},{{0,1004020241,1},1},{{0,1006020241,1},1},{{0,1008020241,1},1},{{0,1010020241,1},1}]','[]','[]'),(32080222,0,1000,0,3,0,1,0,'[{{0,1002030241,1},1},{{0,1004030241,1},1},{{0,1006030241,1},1},{{0,1008030241,1},1},{{0,1010030241,1},1}]','[]','[]'),(32080222,0,1000,0,4,0,1,0,'[{{0,1002040241,1},1},{{0,1004040241,1},1},{{0,1006040241,1},1},{{0,1008040241,1},1},{{0,1010040241,1},1}]','[]','[]'),(32080223,0,1000,0,1,0,1,0,'[{{0,1001010241,1},1},{{0,1007010241,1},1}]','[]','[]'),(32080223,0,1000,0,2,0,1,0,'[{{0,1001020241,1},1},{{0,1007020241,1},1}]','[]','[]'),(32080223,0,1000,0,3,0,1,0,'[{{0,1001030241,1},1},{{0,1007030241,1},1}]','[]','[]'),(32080223,0,1000,0,4,0,1,0,'[{{0,1001040241,1},1},{{0,1007040241,1},1}]','[]','[]'),(32080225,0,1000,0,1,0,1,0,'[{{0,1002010241,1},1},{{0,1004010241,1},1},{{0,1006010241,1},1},{{0,1008010241,1},1},{{0,1010010241,1},1},{{0,1001010241,1},1}]','[]','[]'),(32080225,0,1000,0,2,0,1,0,'[{{0,1002020241,1},1},{{0,1004020241,1},1},{{0,1006020241,1},1},{{0,1008020241,1},1},{{0,1010020241,1},1},{{0,1001020241,1},1}]','[]','[]'),(32080225,0,1000,0,3,0,1,0,'[{{0,1002030241,1},1},{{0,1004030241,1},1},{{0,1006030241,1},1},{{0,1008030241,1},1},{{0,1010030241,1},1},{{0,1001030241,1},1}]','[]','[]'),(32080225,0,1000,0,4,0,1,0,'[{{0,1002040241,1},1},{{0,1004040241,1},1},{{0,1006040241,1},1},{{0,1008040241,1},1},{{0,1010040241,1},1},{{0,1001040241,1},1}]','[]','[]'),(32080226,0,1000,0,1,0,1,0,'[{{0,1007010241,1},1},{{0,1003000241,1},1},{{0,1005000241,1},1},{{0,1009000241,1},1}]','[]','[]'),(32080226,0,1000,0,2,0,1,0,'[{{0,1007020241,1},1},{{0,1003000241,1},1},{{0,1005000241,1},1},{{0,1009000241,1},1}]','[]','[]'),(32080226,0,1000,0,3,0,1,0,'[{{0,1007030241,1},1},{{0,1003000241,1},1},{{0,1005000241,1},1},{{0,1009000241,1},1}]','[]','[]'),(32080226,0,1000,0,4,0,1,0,'[{{0,1007040241,1},1},{{0,1003000241,1},1},{{0,1005000241,1},1},{{0,1009000241,1},1}]','[]','[]'),(32080227,0,1000,0,1,0,1,0,'[{{0,1007010241,1},1},{{0,1003000241,1},1}]','[]','[]'),(32080227,0,1000,0,2,0,1,0,'[{{0,1007020241,1},1},{{0,1003000241,1},1}]','[]','[]'),(32080227,0,1000,0,3,0,1,0,'[{{0,1007030241,1},1},{{0,1003000241,1},1}]','[]','[]'),(32080227,0,1000,0,4,0,1,0,'[{{0,1007040241,1},1},{{0,1003000241,1},1}]','[]','[]'),(32080228,0,1000,0,0,0,1,0,'[{{0,1005000241,1},1},{{0,1009000241,1},1}]','[]','[]'),(32080231,0,1000,0,1,0,1,0,'[{{0,1001010242,1},1},{{0,1002010242,1},1},{{0,1003000242,1},1},{{0,1004010242,1},1},{{0,1006010242,1},1},{{0,1007010242,1},1},{{0,1008010242,1},1},{{0,1010010242,1},1}]','[]','[1001010242,1002010242,1003000242,1004010242,1005000242,1006010242,1007010242,1008010242,1009000242,1010010242]'),(32080231,0,1000,0,2,0,1,0,'[{{0,1001020242,1},1},{{0,1002020242,1},1},{{0,1003000242,1},1},{{0,1004020242,1},1},{{0,1006020242,1},1},{{0,1007020242,1},1},{{0,1008020242,1},1},{{0,1010020242,1},1}]','[]','[1001020242,1002020242,1003000242,1004020242,1005000242,1006020242,1007020242,1008020242,1009000242,1010020242]'),(32080231,0,1000,0,3,0,1,0,'[{{0,1001030242,1},1},{{0,1002030242,1},1},{{0,1003000242,1},1},{{0,1004030242,1},1},{{0,1006030242,1},1},{{0,1007030242,1},1},{{0,1008030242,1},1},{{0,1010030242,1},1}]','[]','[1001030242,1002030242,1003000242,1004030242,1005000242,1006030242,1007030242,1008030242,1009000242,1010030242]'),(32080231,0,1000,0,4,0,1,0,'[{{0,1001040242,1},1},{{0,1002040242,1},1},{{0,1003000242,1},1},{{0,1004040242,1},1},{{0,1006040242,1},1},{{0,1007040242,1},1},{{0,1008040242,1},1},{{0,1010040242,1},1}]','[]','[1001040242,1002040242,1003000242,1004040242,1005000242,1006040242,1007040242,1008040242,1009000242,1010040242]'),(32080232,0,1000,0,1,0,1,0,'[{{0,1002010242,1},1},{{0,1004010242,1},1},{{0,1006010242,1},1},{{0,1008010242,1},1},{{0,1010010242,1},1}]','[]','[1002010242,1004010242,1006010242,1008010242,1010010242]'),(32080232,0,1000,0,2,0,1,0,'[{{0,1002020242,1},1},{{0,1004020242,1},1},{{0,1006020242,1},1},{{0,1008020242,1},1},{{0,1010020242,1},1}]','[]','[1002020242,1004020242,1006020242,1008020242,1010020242]'),(32080232,0,1000,0,3,0,1,0,'[{{0,1002030242,1},1},{{0,1004030242,1},1},{{0,1006030242,1},1},{{0,1008030242,1},1},{{0,1010030242,1},1}]','[]','[1002030242,1004030242,1006030242,1008030242,1010030242]'),(32080232,0,1000,0,4,0,1,0,'[{{0,1002040242,1},1},{{0,1004040242,1},1},{{0,1006040242,1},1},{{0,1008040242,1},1},{{0,1010040242,1},1}]','[]','[1002040242,1004040242,1006040242,1008040242,1010040242]'),(32080233,0,1000,0,1,0,1,0,'[{{0,1001010242,1},1},{{0,1007010242,1},1}]','[]','[1001010242,1007010242]'),(32080233,0,1000,0,2,0,1,0,'[{{0,1001020242,1},1},{{0,1007020242,1},1}]','[]','[1001020242,1007020242]'),(32080233,0,1000,0,3,0,1,0,'[{{0,1001030242,1},1},{{0,1007030242,1},1}]','[]','[1001030242,1007030242]'),(32080233,0,1000,0,4,0,1,0,'[{{0,1001040242,1},1},{{0,1007040242,1},1}]','[]','[1001040242,1007040242]'),(32080235,0,1000,0,1,0,1,0,'[{{0,1002010242,1},1},{{0,1004010242,1},1},{{0,1006010242,1},1},{{0,1008010242,1},1},{{0,1010010242,1},1},{{0,1001010242,1},1}]','[]','[1002010242,1004010242,1006010242,1008010242,1010010242,1001010242]'),(32080235,0,1000,0,2,0,1,0,'[{{0,1002020242,1},1},{{0,1004020242,1},1},{{0,1006020242,1},1},{{0,1008020242,1},1},{{0,1010020242,1},1},{{0,1001020242,1},1}]','[]','[1002020242,1004020242,1006020242,1008020242,1010020242,1001020242]'),(32080235,0,1000,0,3,0,1,0,'[{{0,1002030242,1},1},{{0,1004030242,1},1},{{0,1006030242,1},1},{{0,1008030242,1},1},{{0,1010030242,1},1},{{0,1001030242,1},1}]','[]','[1002030242,1004030242,1006030242,1008030242,1010030242,1001030242]'),(32080235,0,1000,0,4,0,1,0,'[{{0,1002040242,1},1},{{0,1004040242,1},1},{{0,1006040242,1},1},{{0,1008040242,1},1},{{0,1010040242,1},1},{{0,1001040242,1},1}]','[]','[1002040242,1004040242,1006040242,1008040242,1010040242,1001040242]'),(32080236,0,1000,0,1,0,1,0,'[{{0,1007010242,1},1},{{0,1003000242,1},1},{{0,1005000242,1},1},{{0,1009000242,1},1}]','[]','[1007010242,1003000242,1005000242,1009000242]'),(32080236,0,1000,0,2,0,1,0,'[{{0,1007020242,1},1},{{0,1003000242,1},1},{{0,1005000242,1},1},{{0,1009000242,1},1}]','[]','[1007020242,1003000242,1005000242,1009000242]'),(32080236,0,1000,0,3,0,1,0,'[{{0,1007030242,1},1},{{0,1003000242,1},1},{{0,1005000242,1},1},{{0,1009000242,1},1}]','[]','[1007030242,1003000242,1005000242,1009000242]'),(32080236,0,1000,0,4,0,1,0,'[{{0,1007040242,1},1},{{0,1003000242,1},1},{{0,1005000242,1},1},{{0,1009000242,1},1}]','[]','[1007040242,1003000242,1005000242,1009000242]'),(32080237,0,1000,0,1,0,1,0,'[{{0,1007010242,1},1},{{0,1003000242,1},1}]','[]','[1007010242,1003000242]'),(32080237,0,1000,0,2,0,1,0,'[{{0,1007020242,1},1},{{0,1003000242,1},1}]','[]','[1007020242,1003000242]'),(32080237,0,1000,0,3,0,1,0,'[{{0,1007030242,1},1},{{0,1003000242,1},1}]','[]','[1007030242,1003000242]'),(32080237,0,1000,0,4,0,1,0,'[{{0,1007040242,1},1},{{0,1003000242,1},1}]','[]','[1007040242,1003000242]'),(32080238,0,1000,0,0,0,1,0,'[{{0,1005000242,1},1},{{0,1009000242,1},1}]','[]','[1005000242,1009000242]'),(32080241,0,1000,0,1,0,1,0,'[{{0,1001010243,1},1},{{0,1002010243,1},1},{{0,1003000243,1},1},{{0,1004010243,1},1},{{0,1006010243,1},1},{{0,1007010243,1},1},{{0,1008010243,1},1},{{0,1010010243,1},1}]','[]','[1001010243,1002010243,1003000243,1004010243,1005000243,1006010243,1007010243,1008010243,1009000243,1010010243]'),(32080241,0,1000,0,2,0,1,0,'[{{0,1001020243,1},1},{{0,1002020243,1},1},{{0,1003000243,1},1},{{0,1004020243,1},1},{{0,1006020243,1},1},{{0,1007020243,1},1},{{0,1008020243,1},1},{{0,1010020243,1},1}]','[]','[1001020243,1002020243,1003000243,1004020243,1005000243,1006020243,1007020243,1008020243,1009000243,1010020243]'),(32080241,0,1000,0,3,0,1,0,'[{{0,1001030243,1},1},{{0,1002030243,1},1},{{0,1003000243,1},1},{{0,1004030243,1},1},{{0,1006030243,1},1},{{0,1007030243,1},1},{{0,1008030243,1},1},{{0,1010030243,1},1}]','[]','[1001030243,1002030243,1003000243,1004030243,1005000243,1006030243,1007030243,1008030243,1009000243,1010030243]'),(32080241,0,1000,0,4,0,1,0,'[{{0,1001040243,1},1},{{0,1002040243,1},1},{{0,1003000243,1},1},{{0,1004040243,1},1},{{0,1006040243,1},1},{{0,1007040243,1},1},{{0,1008040243,1},1},{{0,1010040243,1},1}]','[]','[1001040243,1002040243,1003000243,1004040243,1005000243,1006040243,1007040243,1008040243,1009000243,1010040243]'),(32080242,0,1000,0,1,0,1,0,'[{{0,1002010243,1},1},{{0,1004010243,1},1},{{0,1006010243,1},1},{{0,1008010243,1},1},{{0,1010010243,1},1}]','[]','[1002010243,1004010243,1006010243,1008010243,1010010243]'),(32080242,0,1000,0,2,0,1,0,'[{{0,1002020243,1},1},{{0,1004020243,1},1},{{0,1006020243,1},1},{{0,1008020243,1},1},{{0,1010020243,1},1}]','[]','[1002020243,1004020243,1006020243,1008020243,1010020243]'),(32080242,0,1000,0,3,0,1,0,'[{{0,1002030243,1},1},{{0,1004030243,1},1},{{0,1006030243,1},1},{{0,1008030243,1},1},{{0,1010030243,1},1}]','[]','[1002030243,1004030243,1006030243,1008030243,1010030243]'),(32080242,0,1000,0,4,0,1,0,'[{{0,1002040243,1},1},{{0,1004040243,1},1},{{0,1006040243,1},1},{{0,1008040243,1},1},{{0,1010040243,1},1}]','[]','[1002040243,1004040243,1006040243,1008040243,1010040243]'),(32080243,0,1000,0,1,0,1,0,'[{{0,1001010243,1},1},{{0,1007010243,1},1}]','[]','[1001010243,1007010243]'),(32080243,0,1000,0,2,0,1,0,'[{{0,1001020243,1},1},{{0,1007020243,1},1}]','[]','[1001020243,1007020243]'),(32080243,0,1000,0,3,0,1,0,'[{{0,1001030243,1},1},{{0,1007030243,1},1}]','[]','[1001030243,1007030243]'),(32080243,0,1000,0,4,0,1,0,'[{{0,1001040243,1},1},{{0,1007040243,1},1}]','[]','[1001040243,1007040243]'),(32080245,0,1000,0,1,0,1,0,'[{{0,1002010243,1},1},{{0,1004010243,1},1},{{0,1006010243,1},1},{{0,1008010243,1},1},{{0,1010010243,1},1},{{0,1001010243,1},1}]','[]','[1002010243,1004010243,1006010243,1008010243,1010010243,1001010243]'),(32080245,0,1000,0,2,0,1,0,'[{{0,1002020243,1},1},{{0,1004020243,1},1},{{0,1006020243,1},1},{{0,1008020243,1},1},{{0,1010020243,1},1},{{0,1001020243,1},1}]','[]','[1002020243,1004020243,1006020243,1008020243,1010020243,1001020243]'),(32080245,0,1000,0,3,0,1,0,'[{{0,1002030243,1},1},{{0,1004030243,1},1},{{0,1006030243,1},1},{{0,1008030243,1},1},{{0,1010030243,1},1},{{0,1001030243,1},1}]','[]','[1002030243,1004030243,1006030243,1008030243,1010030243,1001030243]'),(32080245,0,1000,0,4,0,1,0,'[{{0,1002040243,1},1},{{0,1004040243,1},1},{{0,1006040243,1},1},{{0,1008040243,1},1},{{0,1010040243,1},1},{{0,1001040243,1},1}]','[]','[1002040243,1004040243,1006040243,1008040243,1010040243,1001040243]'),(32080246,0,1000,0,1,0,1,0,'[{{0,1007010243,1},1},{{0,1003000243,1},1},{{0,1005000243,1},1},{{0,1009000243,1},1}]','[]','[1007010243,1003000243,1005000243,1009000243]'),(32080246,0,1000,0,2,0,1,0,'[{{0,1007020243,1},1},{{0,1003000243,1},1},{{0,1005000243,1},1},{{0,1009000243,1},1}]','[]','[1007020243,1003000243,1005000243,1009000243]'),(32080246,0,1000,0,3,0,1,0,'[{{0,1007030243,1},1},{{0,1003000243,1},1},{{0,1005000243,1},1},{{0,1009000243,1},1}]','[]','[1007030243,1003000243,1005000243,1009000243]'),(32080246,0,1000,0,4,0,1,0,'[{{0,1007040243,1},1},{{0,1003000243,1},1},{{0,1005000243,1},1},{{0,1009000243,1},1}]','[]','[1007040243,1003000243,1005000243,1009000243]'),(32080247,0,1000,0,1,0,1,0,'[{{0,1007010243,1},1},{{0,1003000243,1},1}]','[]','[1007010243,1003000243]'),(32080247,0,1000,0,2,0,1,0,'[{{0,1007020243,1},1},{{0,1003000243,1},1}]','[]','[1007020243,1003000243]'),(32080247,0,1000,0,3,0,1,0,'[{{0,1007030243,1},1},{{0,1003000243,1},1}]','[]','[1007030243,1003000243]'),(32080247,0,1000,0,4,0,1,0,'[{{0,1007040243,1},1},{{0,1003000243,1},1}]','[]','[1007040243,1003000243]'),(32080248,0,1000,0,0,0,1,0,'[{{0,1005000243,1},1},{{0,1009000243,1},1}]','[]','[1005000243,1009000243]'),(32080251,0,1000,0,1,0,1,0,'[{{0,1001010253,1},1},{{0,1002010253,1},1},{{0,1003000253,1},1},{{0,1004010253,1},1},{{0,1006010253,1},1},{{0,1007010253,1},1},{{0,1008010253,1},1},{{0,1010010253,1},1}]','[]','[1001010253,1002010253,1003000253,1004010253,1005000253,1006010253,1007010253,1008010253,1009000253,1010010253]'),(32080251,0,1000,0,2,0,1,0,'[{{0,1001020253,1},1},{{0,1002020253,1},1},{{0,1003000253,1},1},{{0,1004020253,1},1},{{0,1006020253,1},1},{{0,1007020253,1},1},{{0,1008020253,1},1},{{0,1010020253,1},1}]','[]','[1001020253,1002020253,1003000253,1004020253,1005000253,1006020253,1007020253,1008020253,1009000253,1010020253]'),(32080251,0,1000,0,3,0,1,0,'[{{0,1001030253,1},1},{{0,1002030253,1},1},{{0,1003000253,1},1},{{0,1004030253,1},1},{{0,1006030253,1},1},{{0,1007030253,1},1},{{0,1008030253,1},1},{{0,1010030253,1},1}]','[]','[1001030253,1002030253,1003000253,1004030253,1005000253,1006030253,1007030253,1008030253,1009000253,1010030253]'),(32080251,0,1000,0,4,0,1,0,'[{{0,1001040253,1},1},{{0,1002040253,1},1},{{0,1003000253,1},1},{{0,1004040253,1},1},{{0,1006040253,1},1},{{0,1007040253,1},1},{{0,1008040253,1},1},{{0,1010040253,1},1}]','[]','[1001040253,1002040253,1003000253,1004040253,1005000253,1006040253,1007040253,1008040253,1009000253,1010040253]'),(32080252,0,1000,0,1,0,1,0,'[{{0,1002010253,1},1},{{0,1004010253,1},1},{{0,1006010253,1},1},{{0,1008010253,1},1},{{0,1010010253,1},1}]','[]','[1002010253,1004010253,1006010253,1008010253,1010010253]'),(32080252,0,1000,0,2,0,1,0,'[{{0,1002020253,1},1},{{0,1004020253,1},1},{{0,1006020253,1},1},{{0,1008020253,1},1},{{0,1010020253,1},1}]','[]','[1002020253,1004020253,1006020253,1008020253,1010020253]'),(32080252,0,1000,0,3,0,1,0,'[{{0,1002030253,1},1},{{0,1004030253,1},1},{{0,1006030253,1},1},{{0,1008030253,1},1},{{0,1010030253,1},1}]','[]','[1002030253,1004030253,1006030253,1008030253,1010030253]'),(32080252,0,1000,0,4,0,1,0,'[{{0,1002040253,1},1},{{0,1004040253,1},1},{{0,1006040253,1},1},{{0,1008040253,1},1},{{0,1010040253,1},1}]','[]','[1002040253,1004040253,1006040253,1008040253,1010040253]'),(32080253,0,1000,0,1,0,1,0,'[{{0,1001010253,1},1},{{0,1007010253,1},1}]','[]','[1001010253,1007010253]'),(32080253,0,1000,0,2,0,1,0,'[{{0,1001020253,1},1},{{0,1007020253,1},1}]','[]','[1001020253,1007020253]'),(32080253,0,1000,0,3,0,1,0,'[{{0,1001030253,1},1},{{0,1007030253,1},1}]','[]','[1001030253,1007030253]'),(32080253,0,1000,0,4,0,1,0,'[{{0,1001040253,1},1},{{0,1007040253,1},1}]','[]','[1001040253,1007040253]'),(32080255,0,1000,0,1,0,1,0,'[{{0,1002010253,1},1},{{0,1004010253,1},1},{{0,1006010253,1},1},{{0,1008010253,1},1},{{0,1010010253,1},1},{{0,1001010253,1},1}]','[]','[1002010253,1004010253,1006010253,1008010253,1010010253,1001010253]'),(32080255,0,1000,0,2,0,1,0,'[{{0,1002020253,1},1},{{0,1004020253,1},1},{{0,1006020253,1},1},{{0,1008020253,1},1},{{0,1010020253,1},1},{{0,1001020253,1},1}]','[]','[1002020253,1004020253,1006020253,1008020253,1010020253,1001020253]'),(32080255,0,1000,0,3,0,1,0,'[{{0,1002030253,1},1},{{0,1004030253,1},1},{{0,1006030253,1},1},{{0,1008030253,1},1},{{0,1010030253,1},1},{{0,1001030253,1},1}]','[]','[1002030253,1004030253,1006030253,1008030253,1010030253,1001030253]'),(32080255,0,1000,0,4,0,1,0,'[{{0,1002040253,1},1},{{0,1004040253,1},1},{{0,1006040253,1},1},{{0,1008040253,1},1},{{0,1010040253,1},1},{{0,1001040253,1},1}]','[]','[1002040253,1004040253,1006040253,1008040253,1010040253,1001040253]'),(32080256,0,1000,0,1,0,1,0,'[{{0,1007010253,1},1},{{0,1003000253,1},1},{{0,1005000253,1},1},{{0,1009000253,1},1}]','[]','[1007010253,1003000253,1005000253,1009000253]'),(32080256,0,1000,0,2,0,1,0,'[{{0,1007020253,1},1},{{0,1003000253,1},1},{{0,1005000253,1},1},{{0,1009000253,1},1}]','[]','[1007020253,1003000253,1005000253,1009000253]'),(32080256,0,1000,0,3,0,1,0,'[{{0,1007030253,1},1},{{0,1003000253,1},1},{{0,1005000253,1},1},{{0,1009000253,1},1}]','[]','[1007030253,1003000253,1005000253,1009000253]'),(32080256,0,1000,0,4,0,1,0,'[{{0,1007040253,1},1},{{0,1003000253,1},1},{{0,1005000253,1},1},{{0,1009000253,1},1}]','[]','[1007040253,1003000253,1005000253,1009000253]'),(32080257,0,1000,0,1,0,1,0,'[{{0,1007010253,1},1},{{0,1003000253,1},1}]','[]','[1007010253,1003000253]'),(32080257,0,1000,0,2,0,1,0,'[{{0,1007020253,1},1},{{0,1003000253,1},1}]','[]','[1007020253,1003000253]'),(32080257,0,1000,0,3,0,1,0,'[{{0,1007030253,1},1},{{0,1003000253,1},1}]','[]','[1007030253,1003000253]'),(32080257,0,1000,0,4,0,1,0,'[{{0,1007040253,1},1},{{0,1003000253,1},1}]','[]','[1007040253,1003000253]'),(32080258,0,1000,0,0,0,1,0,'[{{0,1005000253,1},1},{{0,1009000253,1},1}]','[]','[1005000253,1009000253]'),(32080261,0,1000,0,1,0,1,0,'[{{0,1001010263,1},1},{{0,1002010263,1},1},{{0,1003000263,1},1},{{0,1004010263,1},1},{{0,1006010263,1},1},{{0,1007010263,1},1},{{0,1008010263,1},1},{{0,1010010263,1},1}]','[]','[1001010263,1002010263,1003000263,1004010263,1005000263,1006010263,1007010263,1008010263,1009000263,1010010263]'),(32080261,0,1000,0,2,0,1,0,'[{{0,1001020263,1},1},{{0,1002020263,1},1},{{0,1003000263,1},1},{{0,1004020263,1},1},{{0,1006020263,1},1},{{0,1007020263,1},1},{{0,1008020263,1},1},{{0,1010020263,1},1}]','[]','[1001020263,1002020263,1003000263,1004020263,1005000263,1006020263,1007020263,1008020263,1009000263,1010020263]'),(32080261,0,1000,0,3,0,1,0,'[{{0,1001030263,1},1},{{0,1002030263,1},1},{{0,1003000263,1},1},{{0,1004030263,1},1},{{0,1006030263,1},1},{{0,1007030263,1},1},{{0,1008030263,1},1},{{0,1010030263,1},1}]','[]','[1001030263,1002030263,1003000263,1004030263,1005000263,1006030263,1007030263,1008030263,1009000263,1010030263]'),(32080261,0,1000,0,4,0,1,0,'[{{0,1001040263,1},1},{{0,1002040263,1},1},{{0,1003000263,1},1},{{0,1004040263,1},1},{{0,1006040263,1},1},{{0,1007040263,1},1},{{0,1008040263,1},1},{{0,1010040263,1},1}]','[]','[1001040263,1002040263,1003000263,1004040263,1005000263,1006040263,1007040263,1008040263,1009000263,1010040263]'),(32080262,0,1000,0,1,0,1,0,'[{{0,1002010263,1},1},{{0,1004010263,1},1},{{0,1006010263,1},1},{{0,1008010263,1},1},{{0,1010010263,1},1}]','[]','[1002010263,1004010263,1006010263,1008010263,1010010263]'),(32080262,0,1000,0,2,0,1,0,'[{{0,1002020263,1},1},{{0,1004020263,1},1},{{0,1006020263,1},1},{{0,1008020263,1},1},{{0,1010020263,1},1}]','[]','[1002020263,1004020263,1006020263,1008020263,1010020263]'),(32080262,0,1000,0,3,0,1,0,'[{{0,1002030263,1},1},{{0,1004030263,1},1},{{0,1006030263,1},1},{{0,1008030263,1},1},{{0,1010030263,1},1}]','[]','[1002030263,1004030263,1006030263,1008030263,1010030263]'),(32080262,0,1000,0,4,0,1,0,'[{{0,1002040263,1},1},{{0,1004040263,1},1},{{0,1006040263,1},1},{{0,1008040263,1},1},{{0,1010040263,1},1}]','[]','[1002040263,1004040263,1006040263,1008040263,1010040263]'),(32080263,0,1000,0,1,0,1,0,'[{{0,1001010263,1},1},{{0,1007010263,1},1}]','[]','[1001010263,1007010263]'),(32080263,0,1000,0,2,0,1,0,'[{{0,1001020263,1},1},{{0,1007020263,1},1}]','[]','[1001020263,1007020263]'),(32080263,0,1000,0,3,0,1,0,'[{{0,1001030263,1},1},{{0,1007030263,1},1}]','[]','[1001030263,1007030263]'),(32080263,0,1000,0,4,0,1,0,'[{{0,1001040263,1},1},{{0,1007040263,1},1}]','[]','[1001040263,1007040263]'),(32080265,0,1000,0,1,0,1,0,'[{{0,1002010263,1},1},{{0,1004010263,1},1},{{0,1006010263,1},1},{{0,1008010263,1},1},{{0,1010010263,1},1},{{0,1001010263,1},1}]','[]','[1002010263,1004010263,1006010263,1008010263,1010010263,1001010263]'),(32080265,0,1000,0,2,0,1,0,'[{{0,1002020263,1},1},{{0,1004020263,1},1},{{0,1006020263,1},1},{{0,1008020263,1},1},{{0,1010020263,1},1},{{0,1001020263,1},1}]','[]','[1002020263,1004020263,1006020263,1008020263,1010020263,1001020263]'),(32080265,0,1000,0,3,0,1,0,'[{{0,1002030263,1},1},{{0,1004030263,1},1},{{0,1006030263,1},1},{{0,1008030263,1},1},{{0,1010030263,1},1},{{0,1001030263,1},1}]','[]','[1002030263,1004030263,1006030263,1008030263,1010030263,1001030263]'),(32080265,0,1000,0,4,0,1,0,'[{{0,1002040263,1},1},{{0,1004040263,1},1},{{0,1006040263,1},1},{{0,1008040263,1},1},{{0,1010040263,1},1},{{0,1001040263,1},1}]','[]','[1002040263,1004040263,1006040263,1008040263,1010040263,1001040263]'),(32080266,0,1000,0,1,0,1,0,'[{{0,1007010263,1},1},{{0,1003000263,1},1},{{0,1005000263,1},1},{{0,1009000263,1},1}]','[]','[1007010263,1003000263,1005000263,1009000263]'),(32080266,0,1000,0,2,0,1,0,'[{{0,1007020263,1},1},{{0,1003000263,1},1},{{0,1005000263,1},1},{{0,1009000263,1},1}]','[]','[1007020263,1003000263,1005000263,1009000263]'),(32080266,0,1000,0,3,0,1,0,'[{{0,1007030263,1},1},{{0,1003000263,1},1},{{0,1005000263,1},1},{{0,1009000263,1},1}]','[]','[1007030263,1003000263,1005000263,1009000263]'),(32080266,0,1000,0,4,0,1,0,'[{{0,1007040263,1},1},{{0,1003000263,1},1},{{0,1005000263,1},1},{{0,1009000263,1},1}]','[]','[1007040263,1003000263,1005000263,1009000263]'),(32080267,0,1000,0,1,0,1,0,'[{{0,1007010263,1},1},{{0,1003000263,1},1}]','[]','[1007010263,1003000263]'),(32080267,0,1000,0,2,0,1,0,'[{{0,1007020263,1},1},{{0,1003000263,1},1}]','[]','[1007020263,1003000263]'),(32080267,0,1000,0,3,0,1,0,'[{{0,1007030263,1},1},{{0,1003000263,1},1}]','[]','[1007030263,1003000263]'),(32080267,0,1000,0,4,0,1,0,'[{{0,1007040263,1},1},{{0,1003000263,1},1}]','[]','[1007040263,1003000263]'),(32080268,0,1000,0,0,0,1,0,'[{{0,1005000263,1},1},{{0,1009000263,1},1}]','[]','[1005000263,1009000263]'),(32080271,0,1000,0,1,0,1,0,'[{{0,1001010200,1},1},{{0,1002010200,1},1},{{0,1003000200,1},1},{{0,1004010200,1},1},{{0,1006010200,1},1},{{0,1007010200,1},1},{{0,1008010200,1},1},{{0,1010010200,1},1}]','[]','[]'),(32080271,0,1000,0,2,0,1,0,'[{{0,1001020200,1},1},{{0,1002020200,1},1},{{0,1003000200,1},1},{{0,1004020200,1},1},{{0,1006020200,1},1},{{0,1007020200,1},1},{{0,1008020200,1},1},{{0,1010020200,1},1}]','[]','[]'),(32080271,0,1000,0,3,0,1,0,'[{{0,1001030200,1},1},{{0,1002030200,1},1},{{0,1003000200,1},1},{{0,1004030200,1},1},{{0,1006030200,1},1},{{0,1007030200,1},1},{{0,1008030200,1},1},{{0,1010030200,1},1}]','[]','[]'),(32080271,0,1000,0,4,0,1,0,'[{{0,1001040200,1},1},{{0,1002040200,1},1},{{0,1003000200,1},1},{{0,1004040200,1},1},{{0,1006040200,1},1},{{0,1007040200,1},1},{{0,1008040200,1},1},{{0,1010040200,1},1}]','[]','[]'),(32080272,0,1000,0,1,0,1,0,'[{{0,1002010200,1},1},{{0,1004010200,1},1},{{0,1006010200,1},1},{{0,1008010200,1},1},{{0,1010010200,1},1}]','[]','[]'),(32080272,0,1000,0,2,0,1,0,'[{{0,1002020200,1},1},{{0,1004020200,1},1},{{0,1006020200,1},1},{{0,1008020200,1},1},{{0,1010020200,1},1}]','[]','[]'),(32080272,0,1000,0,3,0,1,0,'[{{0,1002030200,1},1},{{0,1004030200,1},1},{{0,1006030200,1},1},{{0,1008030200,1},1},{{0,1010030200,1},1}]','[]','[]'),(32080272,0,1000,0,4,0,1,0,'[{{0,1002040200,1},1},{{0,1004040200,1},1},{{0,1006040200,1},1},{{0,1008040200,1},1},{{0,1010040200,1},1}]','[]','[]'),(32080273,0,1000,0,1,0,1,0,'[{{0,1001010200,1},1},{{0,1007010200,1},1}]','[]','[]'),(32080273,0,1000,0,2,0,1,0,'[{{0,1001020200,1},1},{{0,1007020200,1},1}]','[]','[]'),(32080273,0,1000,0,3,0,1,0,'[{{0,1001030200,1},1},{{0,1007030200,1},1}]','[]','[]'),(32080273,0,1000,0,4,0,1,0,'[{{0,1001040200,1},1},{{0,1007040200,1},1}]','[]','[]'),(32080275,0,1000,0,1,0,1,0,'[{{0,1002010200,1},1},{{0,1004010200,1},1},{{0,1006010200,1},1},{{0,1008010200,1},1},{{0,1010010200,1},1},{{0,1001010200,1},1}]','[]','[]'),(32080275,0,1000,0,2,0,1,0,'[{{0,1002020200,1},1},{{0,1004020200,1},1},{{0,1006020200,1},1},{{0,1008020200,1},1},{{0,1010020200,1},1},{{0,1001020200,1},1}]','[]','[]'),(32080275,0,1000,0,3,0,1,0,'[{{0,1002030200,1},1},{{0,1004030200,1},1},{{0,1006030200,1},1},{{0,1008030200,1},1},{{0,1010030200,1},1},{{0,1001030200,1},1}]','[]','[]'),(32080275,0,1000,0,4,0,1,0,'[{{0,1002040200,1},1},{{0,1004040200,1},1},{{0,1006040200,1},1},{{0,1008040200,1},1},{{0,1010040200,1},1},{{0,1001040200,1},1}]','[]','[]'),(32080276,0,1000,0,1,0,1,0,'[{{0,1007010200,1},1},{{0,1003000200,1},1},{{0,1005000200,1},1},{{0,1009000200,1},1}]','[]','[]'),(32080276,0,1000,0,2,0,1,0,'[{{0,1007020200,1},1},{{0,1003000200,1},1},{{0,1005000200,1},1},{{0,1009000200,1},1}]','[]','[]'),(32080276,0,1000,0,3,0,1,0,'[{{0,1007030200,1},1},{{0,1003000200,1},1},{{0,1005000200,1},1},{{0,1009000200,1},1}]','[]','[]'),(32080276,0,1000,0,4,0,1,0,'[{{0,1007040200,1},1},{{0,1003000200,1},1},{{0,1005000200,1},1},{{0,1009000200,1},1}]','[]','[]'),(32080277,0,1000,0,1,0,1,0,'[{{0,1007010200,1},1},{{0,1003000200,1},1}]','[]','[]'),(32080277,0,1000,0,2,0,1,0,'[{{0,1007020200,1},1},{{0,1003000200,1},1}]','[]','[]'),(32080277,0,1000,0,3,0,1,0,'[{{0,1007030200,1},1},{{0,1003000200,1},1}]','[]','[]'),(32080277,0,1000,0,4,0,1,0,'[{{0,1007040200,1},1},{{0,1003000200,1},1}]','[]','[]'),(32080278,0,1000,0,0,0,1,0,'[{{0,1005000200,1},1},{{0,1009000200,1},1}]','[]','[]'),(32080281,0,1000,0,1,0,1,0,'[{{0,1001010210,1},1},{{0,1002010210,1},1},{{0,1003000210,1},1},{{0,1004010210,1},1},{{0,1006010210,1},1},{{0,1007010210,1},1},{{0,1008010210,1},1},{{0,1010010210,1},1}]','[]','[]'),(32080281,0,1000,0,2,0,1,0,'[{{0,1001020210,1},1},{{0,1002020210,1},1},{{0,1003000210,1},1},{{0,1004020210,1},1},{{0,1006020210,1},1},{{0,1007020210,1},1},{{0,1008020210,1},1},{{0,1010020210,1},1}]','[]','[]'),(32080281,0,1000,0,3,0,1,0,'[{{0,1001030210,1},1},{{0,1002030210,1},1},{{0,1003000210,1},1},{{0,1004030210,1},1},{{0,1006030210,1},1},{{0,1007030210,1},1},{{0,1008030210,1},1},{{0,1010030210,1},1}]','[]','[]'),(32080281,0,1000,0,4,0,1,0,'[{{0,1001040210,1},1},{{0,1002040210,1},1},{{0,1003000210,1},1},{{0,1004040210,1},1},{{0,1006040210,1},1},{{0,1007040210,1},1},{{0,1008040210,1},1},{{0,1010040210,1},1}]','[]','[]'),(32080282,0,1000,0,1,0,1,0,'[{{0,1002010210,1},1},{{0,1004010210,1},1},{{0,1006010210,1},1},{{0,1008010210,1},1},{{0,1010010210,1},1}]','[]','[]'),(32080282,0,1000,0,2,0,1,0,'[{{0,1002020210,1},1},{{0,1004020210,1},1},{{0,1006020210,1},1},{{0,1008020210,1},1},{{0,1010020210,1},1}]','[]','[]'),(32080282,0,1000,0,3,0,1,0,'[{{0,1002030210,1},1},{{0,1004030210,1},1},{{0,1006030210,1},1},{{0,1008030210,1},1},{{0,1010030210,1},1}]','[]','[]'),(32080282,0,1000,0,4,0,1,0,'[{{0,1002040210,1},1},{{0,1004040210,1},1},{{0,1006040210,1},1},{{0,1008040210,1},1},{{0,1010040210,1},1}]','[]','[]'),(32080283,0,1000,0,1,0,1,0,'[{{0,1001010210,1},1},{{0,1007010210,1},1}]','[]','[]'),(32080283,0,1000,0,2,0,1,0,'[{{0,1001020210,1},1},{{0,1007020210,1},1}]','[]','[]'),(32080283,0,1000,0,3,0,1,0,'[{{0,1001030210,1},1},{{0,1007030210,1},1}]','[]','[]'),(32080283,0,1000,0,4,0,1,0,'[{{0,1001040210,1},1},{{0,1007040210,1},1}]','[]','[]'),(32080285,0,1000,0,1,0,1,0,'[{{0,1002010210,1},1},{{0,1004010210,1},1},{{0,1006010210,1},1},{{0,1008010210,1},1},{{0,1010010210,1},1},{{0,1001010210,1},1}]','[]','[]'),(32080285,0,1000,0,2,0,1,0,'[{{0,1002020210,1},1},{{0,1004020210,1},1},{{0,1006020210,1},1},{{0,1008020210,1},1},{{0,1010020210,1},1},{{0,1001020210,1},1}]','[]','[]'),(32080285,0,1000,0,3,0,1,0,'[{{0,1002030210,1},1},{{0,1004030210,1},1},{{0,1006030210,1},1},{{0,1008030210,1},1},{{0,1010030210,1},1},{{0,1001030210,1},1}]','[]','[]'),(32080285,0,1000,0,4,0,1,0,'[{{0,1002040210,1},1},{{0,1004040210,1},1},{{0,1006040210,1},1},{{0,1008040210,1},1},{{0,1010040210,1},1},{{0,1001040210,1},1}]','[]','[]'),(32080286,0,1000,0,1,0,1,0,'[{{0,1007010210,1},1},{{0,1003000210,1},1},{{0,1005000210,1},1},{{0,1009000210,1},1}]','[]','[]'),(32080286,0,1000,0,2,0,1,0,'[{{0,1007020210,1},1},{{0,1003000210,1},1},{{0,1005000210,1},1},{{0,1009000210,1},1}]','[]','[]'),(32080286,0,1000,0,3,0,1,0,'[{{0,1007030210,1},1},{{0,1003000210,1},1},{{0,1005000210,1},1},{{0,1009000210,1},1}]','[]','[]'),(32080286,0,1000,0,4,0,1,0,'[{{0,1007040210,1},1},{{0,1003000210,1},1},{{0,1005000210,1},1},{{0,1009000210,1},1}]','[]','[]'),(32080287,0,1000,0,1,0,1,0,'[{{0,1007010210,1},1},{{0,1003000210,1},1}]','[]','[]'),(32080287,0,1000,0,2,0,1,0,'[{{0,1007020210,1},1},{{0,1003000210,1},1}]','[]','[]'),(32080287,0,1000,0,3,0,1,0,'[{{0,1007030210,1},1},{{0,1003000210,1},1}]','[]','[]'),(32080287,0,1000,0,4,0,1,0,'[{{0,1007040210,1},1},{{0,1003000210,1},1}]','[]','[]'),(32080288,0,1000,0,0,0,1,0,'[{{0,1005000210,1},1},{{0,1009000210,1},1}]','[]','[]'),(32080291,0,1000,0,1,0,1,0,'[{{0,1001010220,1},1},{{0,1002010220,1},1},{{0,1003000220,1},1},{{0,1004010220,1},1},{{0,1006010220,1},1},{{0,1007010220,1},1},{{0,1008010220,1},1},{{0,1010010220,1},1}]','[]','[]'),(32080291,0,1000,0,2,0,1,0,'[{{0,1001020220,1},1},{{0,1002020220,1},1},{{0,1003000220,1},1},{{0,1004020220,1},1},{{0,1006020220,1},1},{{0,1007020220,1},1},{{0,1008020220,1},1},{{0,1010020220,1},1}]','[]','[]'),(32080291,0,1000,0,3,0,1,0,'[{{0,1001030220,1},1},{{0,1002030220,1},1},{{0,1003000220,1},1},{{0,1004030220,1},1},{{0,1006030220,1},1},{{0,1007030220,1},1},{{0,1008030220,1},1},{{0,1010030220,1},1}]','[]','[]'),(32080291,0,1000,0,4,0,1,0,'[{{0,1001040220,1},1},{{0,1002040220,1},1},{{0,1003000220,1},1},{{0,1004040220,1},1},{{0,1006040220,1},1},{{0,1007040220,1},1},{{0,1008040220,1},1},{{0,1010040220,1},1}]','[]','[]'),(32080292,0,1000,0,1,0,1,0,'[{{0,1002010220,1},1},{{0,1004010220,1},1},{{0,1006010220,1},1},{{0,1008010220,1},1},{{0,1010010220,1},1}]','[]','[]'),(32080292,0,1000,0,2,0,1,0,'[{{0,1002020220,1},1},{{0,1004020220,1},1},{{0,1006020220,1},1},{{0,1008020220,1},1},{{0,1010020220,1},1}]','[]','[]'),(32080292,0,1000,0,3,0,1,0,'[{{0,1002030220,1},1},{{0,1004030220,1},1},{{0,1006030220,1},1},{{0,1008030220,1},1},{{0,1010030220,1},1}]','[]','[]'),(32080292,0,1000,0,4,0,1,0,'[{{0,1002040220,1},1},{{0,1004040220,1},1},{{0,1006040220,1},1},{{0,1008040220,1},1},{{0,1010040220,1},1}]','[]','[]'),(32080293,0,1000,0,1,0,1,0,'[{{0,1001010220,1},1},{{0,1007010220,1},1}]','[]','[]'),(32080293,0,1000,0,2,0,1,0,'[{{0,1001020220,1},1},{{0,1007020220,1},1}]','[]','[]'),(32080293,0,1000,0,3,0,1,0,'[{{0,1001030220,1},1},{{0,1007030220,1},1}]','[]','[]'),(32080293,0,1000,0,4,0,1,0,'[{{0,1001040220,1},1},{{0,1007040220,1},1}]','[]','[]'),(32080295,0,1000,0,1,0,1,0,'[{{0,1002010220,1},1},{{0,1004010220,1},1},{{0,1006010220,1},1},{{0,1008010220,1},1},{{0,1010010220,1},1},{{0,1001010220,1},1}]','[]','[]'),(32080295,0,1000,0,2,0,1,0,'[{{0,1002020220,1},1},{{0,1004020220,1},1},{{0,1006020220,1},1},{{0,1008020220,1},1},{{0,1010020220,1},1},{{0,1001020220,1},1}]','[]','[]'),(32080295,0,1000,0,3,0,1,0,'[{{0,1002030220,1},1},{{0,1004030220,1},1},{{0,1006030220,1},1},{{0,1008030220,1},1},{{0,1010030220,1},1},{{0,1001030220,1},1}]','[]','[]'),(32080295,0,1000,0,4,0,1,0,'[{{0,1002040220,1},1},{{0,1004040220,1},1},{{0,1006040220,1},1},{{0,1008040220,1},1},{{0,1010040220,1},1},{{0,1001040220,1},1}]','[]','[]'),(32080296,0,1000,0,1,0,1,0,'[{{0,1007010220,1},1},{{0,1003000220,1},1},{{0,1005000220,1},1},{{0,1009000220,1},1}]','[]','[]'),(32080296,0,1000,0,2,0,1,0,'[{{0,1007020220,1},1},{{0,1003000220,1},1},{{0,1005000220,1},1},{{0,1009000220,1},1}]','[]','[]'),(32080296,0,1000,0,3,0,1,0,'[{{0,1007030220,1},1},{{0,1003000220,1},1},{{0,1005000220,1},1},{{0,1009000220,1},1}]','[]','[]'),(32080296,0,1000,0,4,0,1,0,'[{{0,1007040220,1},1},{{0,1003000220,1},1},{{0,1005000220,1},1},{{0,1009000220,1},1}]','[]','[]'),(32080297,0,1000,0,1,0,1,0,'[{{0,1007010220,1},1},{{0,1003000220,1},1}]','[]','[]'),(32080297,0,1000,0,2,0,1,0,'[{{0,1007020220,1},1},{{0,1003000220,1},1}]','[]','[]'),(32080297,0,1000,0,3,0,1,0,'[{{0,1007030220,1},1},{{0,1003000220,1},1}]','[]','[]'),(32080297,0,1000,0,4,0,1,0,'[{{0,1007040220,1},1},{{0,1003000220,1},1}]','[]','[]'),(32080298,0,1000,0,0,0,1,0,'[{{0,1005000220,1},1},{{0,1009000220,1},1}]','[]','[]'),(32080301,0,1000,0,1,0,1,0,'[{{0,1001010231,1},1},{{0,1002010231,1},1},{{0,1003000231,1},1},{{0,1004010231,1},1},{{0,1006010231,1},1},{{0,1007010231,1},1},{{0,1008010231,1},1},{{0,1010010231,1},1}]','[]','[]'),(32080301,0,1000,0,2,0,1,0,'[{{0,1001020231,1},1},{{0,1002020231,1},1},{{0,1003000231,1},1},{{0,1004020231,1},1},{{0,1006020231,1},1},{{0,1007020231,1},1},{{0,1008020231,1},1},{{0,1010020231,1},1}]','[]','[]'),(32080301,0,1000,0,3,0,1,0,'[{{0,1001030231,1},1},{{0,1002030231,1},1},{{0,1003000231,1},1},{{0,1004030231,1},1},{{0,1006030231,1},1},{{0,1007030231,1},1},{{0,1008030231,1},1},{{0,1010030231,1},1}]','[]','[]'),(32080301,0,1000,0,4,0,1,0,'[{{0,1001040231,1},1},{{0,1002040231,1},1},{{0,1003000231,1},1},{{0,1004040231,1},1},{{0,1006040231,1},1},{{0,1007040231,1},1},{{0,1008040231,1},1},{{0,1010040231,1},1}]','[]','[]'),(32080302,0,1000,0,1,0,1,0,'[{{0,1002010231,1},1},{{0,1004010231,1},1},{{0,1006010231,1},1},{{0,1008010231,1},1},{{0,1010010231,1},1}]','[]','[]'),(32080302,0,1000,0,2,0,1,0,'[{{0,1002020231,1},1},{{0,1004020231,1},1},{{0,1006020231,1},1},{{0,1008020231,1},1},{{0,1010020231,1},1}]','[]','[]'),(32080302,0,1000,0,3,0,1,0,'[{{0,1002030231,1},1},{{0,1004030231,1},1},{{0,1006030231,1},1},{{0,1008030231,1},1},{{0,1010030231,1},1}]','[]','[]'),(32080302,0,1000,0,4,0,1,0,'[{{0,1002040231,1},1},{{0,1004040231,1},1},{{0,1006040231,1},1},{{0,1008040231,1},1},{{0,1010040231,1},1}]','[]','[]'),(32080303,0,1000,0,1,0,1,0,'[{{0,1001010231,1},1},{{0,1007010231,1},1}]','[]','[]'),(32080303,0,1000,0,2,0,1,0,'[{{0,1001020231,1},1},{{0,1007020231,1},1}]','[]','[]'),(32080303,0,1000,0,3,0,1,0,'[{{0,1001030231,1},1},{{0,1007030231,1},1}]','[]','[]'),(32080303,0,1000,0,4,0,1,0,'[{{0,1001040231,1},1},{{0,1007040231,1},1}]','[]','[]'),(32080305,0,1000,0,1,0,1,0,'[{{0,1002010231,1},1},{{0,1004010231,1},1},{{0,1006010231,1},1},{{0,1008010231,1},1},{{0,1010010231,1},1},{{0,1001010231,1},1}]','[]','[]'),(32080305,0,1000,0,2,0,1,0,'[{{0,1002020231,1},1},{{0,1004020231,1},1},{{0,1006020231,1},1},{{0,1008020231,1},1},{{0,1010020231,1},1},{{0,1001020231,1},1}]','[]','[]'),(32080305,0,1000,0,3,0,1,0,'[{{0,1002030231,1},1},{{0,1004030231,1},1},{{0,1006030231,1},1},{{0,1008030231,1},1},{{0,1010030231,1},1},{{0,1001030231,1},1}]','[]','[]'),(32080305,0,1000,0,4,0,1,0,'[{{0,1002040231,1},1},{{0,1004040231,1},1},{{0,1006040231,1},1},{{0,1008040231,1},1},{{0,1010040231,1},1},{{0,1001040231,1},1}]','[]','[]'),(32080306,0,1000,0,1,0,1,0,'[{{0,1007010231,1},1},{{0,1003000231,1},1},{{0,1005000231,1},1},{{0,1009000231,1},1}]','[]','[]'),(32080306,0,1000,0,2,0,1,0,'[{{0,1007020231,1},1},{{0,1003000231,1},1},{{0,1005000231,1},1},{{0,1009000231,1},1}]','[]','[]'),(32080306,0,1000,0,3,0,1,0,'[{{0,1007030231,1},1},{{0,1003000231,1},1},{{0,1005000231,1},1},{{0,1009000231,1},1}]','[]','[]'),(32080306,0,1000,0,4,0,1,0,'[{{0,1007040231,1},1},{{0,1003000231,1},1},{{0,1005000231,1},1},{{0,1009000231,1},1}]','[]','[]'),(32080307,0,1000,0,1,0,1,0,'[{{0,1007010231,1},1},{{0,1003000231,1},1}]','[]','[]'),(32080307,0,1000,0,2,0,1,0,'[{{0,1007020231,1},1},{{0,1003000231,1},1}]','[]','[]'),(32080307,0,1000,0,3,0,1,0,'[{{0,1007030231,1},1},{{0,1003000231,1},1}]','[]','[]'),(32080307,0,1000,0,4,0,1,0,'[{{0,1007040231,1},1},{{0,1003000231,1},1}]','[]','[]'),(32080308,0,1000,0,0,0,1,0,'[{{0,1005000231,1},1},{{0,1009000231,1},1}]','[]','[]'),(32080311,0,1000,0,1,0,1,0,'[{{0,1001010332,1},1},{{0,1002010332,1},1},{{0,1003000332,1},1},{{0,1004010332,1},1},{{0,1006010332,1},1},{{0,1007010332,1},1},{{0,1008010332,1},1},{{0,1010010332,1},1}]','[]','[1001010332,1002010332,1003000332,1004010332,1005000332,1006010332,1007010332,1008010332,1009000332,1010010332]'),(32080311,0,1000,0,2,0,1,0,'[{{0,1001020332,1},1},{{0,1002020332,1},1},{{0,1003000332,1},1},{{0,1004020332,1},1},{{0,1006020332,1},1},{{0,1007020332,1},1},{{0,1008020332,1},1},{{0,1010020332,1},1}]','[]','[1001020332,1002020332,1003000332,1004020332,1005000332,1006020332,1007020332,1008020332,1009000332,1010020332]'),(32080311,0,1000,0,3,0,1,0,'[{{0,1001030332,1},1},{{0,1002030332,1},1},{{0,1003000332,1},1},{{0,1004030332,1},1},{{0,1006030332,1},1},{{0,1007030332,1},1},{{0,1008030332,1},1},{{0,1010030332,1},1}]','[]','[1001030332,1002030332,1003000332,1004030332,1005000332,1006030332,1007030332,1008030332,1009000332,1010030332]'),(32080311,0,1000,0,4,0,1,0,'[{{0,1001040332,1},1},{{0,1002040332,1},1},{{0,1003000332,1},1},{{0,1004040332,1},1},{{0,1006040332,1},1},{{0,1007040332,1},1},{{0,1008040332,1},1},{{0,1010040332,1},1}]','[]','[1001040332,1002040332,1003000332,1004040332,1005000332,1006040332,1007040332,1008040332,1009000332,1010040332]'),(32080312,0,1000,0,1,0,1,0,'[{{0,1002010332,1},1},{{0,1004010332,1},1},{{0,1006010332,1},1},{{0,1008010332,1},1},{{0,1010010332,1},1}]','[]','[1002010332,1004010332,1006010332,1008010332,1010010332]'),(32080312,0,1000,0,2,0,1,0,'[{{0,1002020332,1},1},{{0,1004020332,1},1},{{0,1006020332,1},1},{{0,1008020332,1},1},{{0,1010020332,1},1}]','[]','[1002020332,1004020332,1006020332,1008020332,1010020332]'),(32080312,0,1000,0,3,0,1,0,'[{{0,1002030332,1},1},{{0,1004030332,1},1},{{0,1006030332,1},1},{{0,1008030332,1},1},{{0,1010030332,1},1}]','[]','[1002030332,1004030332,1006030332,1008030332,1010030332]'),(32080312,0,1000,0,4,0,1,0,'[{{0,1002040332,1},1},{{0,1004040332,1},1},{{0,1006040332,1},1},{{0,1008040332,1},1},{{0,1010040332,1},1}]','[]','[1002040332,1004040332,1006040332,1008040332,1010040332]'),(32080313,0,1000,0,1,0,1,0,'[{{0,1001010332,1},1},{{0,1007010332,1},1}]','[]','[1001010332,1007010332]'),(32080313,0,1000,0,2,0,1,0,'[{{0,1001020332,1},1},{{0,1007020332,1},1}]','[]','[1001020332,1007020332]'),(32080313,0,1000,0,3,0,1,0,'[{{0,1001030332,1},1},{{0,1007030332,1},1}]','[]','[1001030332,1007030332]'),(32080313,0,1000,0,4,0,1,0,'[{{0,1001040332,1},1},{{0,1007040332,1},1}]','[]','[1001040332,1007040332]'),(32080315,0,1000,0,1,0,1,0,'[{{0,1002010332,1},1},{{0,1004010332,1},1},{{0,1006010332,1},1},{{0,1008010332,1},1},{{0,1010010332,1},1},{{0,1001010332,1},1}]','[]','[1002010332,1004010332,1006010332,1008010332,1010010332,1001010332]'),(32080315,0,1000,0,2,0,1,0,'[{{0,1002020332,1},1},{{0,1004020332,1},1},{{0,1006020332,1},1},{{0,1008020332,1},1},{{0,1010020332,1},1},{{0,1001020332,1},1}]','[]','[1002020332,1004020332,1006020332,1008020332,1010020332,1001020332]'),(32080315,0,1000,0,3,0,1,0,'[{{0,1002030332,1},1},{{0,1004030332,1},1},{{0,1006030332,1},1},{{0,1008030332,1},1},{{0,1010030332,1},1},{{0,1001030332,1},1}]','[]','[1002030332,1004030332,1006030332,1008030332,1010030332,1001030332]'),(32080315,0,1000,0,4,0,1,0,'[{{0,1002040332,1},1},{{0,1004040332,1},1},{{0,1006040332,1},1},{{0,1008040332,1},1},{{0,1010040332,1},1},{{0,1001040332,1},1}]','[]','[1002040332,1004040332,1006040332,1008040332,1010040332,1001040332]'),(32080316,0,1000,0,1,0,1,0,'[{{0,1007010332,1},1},{{0,1003000332,1},1},{{0,1005000332,1},1},{{0,1009000332,1},1}]','[]','[1007010332,1003000332,1005000332,1009000332]'),(32080316,0,1000,0,2,0,1,0,'[{{0,1007020332,1},1},{{0,1003000332,1},1},{{0,1005000332,1},1},{{0,1009000332,1},1}]','[]','[1007020332,1003000332,1005000332,1009000332]'),(32080316,0,1000,0,3,0,1,0,'[{{0,1007030332,1},1},{{0,1003000332,1},1},{{0,1005000332,1},1},{{0,1009000332,1},1}]','[]','[1007030332,1003000332,1005000332,1009000332]'),(32080316,0,1000,0,4,0,1,0,'[{{0,1007040332,1},1},{{0,1003000332,1},1},{{0,1005000332,1},1},{{0,1009000332,1},1}]','[]','[1007040332,1003000332,1005000332,1009000332]'),(32080317,0,1000,0,1,0,1,0,'[{{0,1007010332,1},1},{{0,1003000332,1},1}]','[]','[1007010332,1003000332]'),(32080317,0,1000,0,2,0,1,0,'[{{0,1007020332,1},1},{{0,1003000332,1},1}]','[]','[1007020332,1003000332]'),(32080317,0,1000,0,3,0,1,0,'[{{0,1007030332,1},1},{{0,1003000332,1},1}]','[]','[1007030332,1003000332]'),(32080317,0,1000,0,4,0,1,0,'[{{0,1007040332,1},1},{{0,1003000332,1},1}]','[]','[1007040332,1003000332]'),(32080318,0,1000,0,0,0,1,0,'[{{0,1005000332,1},1},{{0,1009000332,1},1}]','[]','[1005000332,1009000332]'),(32080321,0,1000,0,1,0,1,0,'[{{0,1001010341,1},1},{{0,1002010341,1},1},{{0,1003000341,1},1},{{0,1004010341,1},1},{{0,1006010341,1},1},{{0,1007010341,1},1},{{0,1008010341,1},1},{{0,1010010341,1},1}]','[]','[]'),(32080321,0,1000,0,2,0,1,0,'[{{0,1001020341,1},1},{{0,1002020341,1},1},{{0,1003000341,1},1},{{0,1004020341,1},1},{{0,1006020341,1},1},{{0,1007020341,1},1},{{0,1008020341,1},1},{{0,1010020341,1},1}]','[]','[]'),(32080321,0,1000,0,3,0,1,0,'[{{0,1001030341,1},1},{{0,1002030341,1},1},{{0,1003000341,1},1},{{0,1004030341,1},1},{{0,1006030341,1},1},{{0,1007030341,1},1},{{0,1008030341,1},1},{{0,1010030341,1},1}]','[]','[]'),(32080321,0,1000,0,4,0,1,0,'[{{0,1001040341,1},1},{{0,1002040341,1},1},{{0,1003000341,1},1},{{0,1004040341,1},1},{{0,1006040341,1},1},{{0,1007040341,1},1},{{0,1008040341,1},1},{{0,1010040341,1},1}]','[]','[]'),(32080322,0,1000,0,1,0,1,0,'[{{0,1002010341,1},1},{{0,1004010341,1},1},{{0,1006010341,1},1},{{0,1008010341,1},1},{{0,1010010341,1},1}]','[]','[]'),(32080322,0,1000,0,2,0,1,0,'[{{0,1002020341,1},1},{{0,1004020341,1},1},{{0,1006020341,1},1},{{0,1008020341,1},1},{{0,1010020341,1},1}]','[]','[]'),(32080322,0,1000,0,3,0,1,0,'[{{0,1002030341,1},1},{{0,1004030341,1},1},{{0,1006030341,1},1},{{0,1008030341,1},1},{{0,1010030341,1},1}]','[]','[]'),(32080322,0,1000,0,4,0,1,0,'[{{0,1002040341,1},1},{{0,1004040341,1},1},{{0,1006040341,1},1},{{0,1008040341,1},1},{{0,1010040341,1},1}]','[]','[]'),(32080323,0,1000,0,1,0,1,0,'[{{0,1001010341,1},1},{{0,1007010341,1},1}]','[]','[]'),(32080323,0,1000,0,2,0,1,0,'[{{0,1001020341,1},1},{{0,1007020341,1},1}]','[]','[]'),(32080323,0,1000,0,3,0,1,0,'[{{0,1001030341,1},1},{{0,1007030341,1},1}]','[]','[]'),(32080323,0,1000,0,4,0,1,0,'[{{0,1001040341,1},1},{{0,1007040341,1},1}]','[]','[]'),(32080325,0,1000,0,1,0,1,0,'[{{0,1002010341,1},1},{{0,1004010341,1},1},{{0,1006010341,1},1},{{0,1008010341,1},1},{{0,1010010341,1},1},{{0,1001010341,1},1}]','[]','[]'),(32080325,0,1000,0,2,0,1,0,'[{{0,1002020341,1},1},{{0,1004020341,1},1},{{0,1006020341,1},1},{{0,1008020341,1},1},{{0,1010020341,1},1},{{0,1001020341,1},1}]','[]','[]'),(32080325,0,1000,0,3,0,1,0,'[{{0,1002030341,1},1},{{0,1004030341,1},1},{{0,1006030341,1},1},{{0,1008030341,1},1},{{0,1010030341,1},1},{{0,1001030341,1},1}]','[]','[]'),(32080325,0,1000,0,4,0,1,0,'[{{0,1002040341,1},1},{{0,1004040341,1},1},{{0,1006040341,1},1},{{0,1008040341,1},1},{{0,1010040341,1},1},{{0,1001040341,1},1}]','[]','[]'),(32080326,0,1000,0,1,0,1,0,'[{{0,1007010341,1},1},{{0,1003000341,1},1},{{0,1005000341,1},1},{{0,1009000341,1},1}]','[]','[]'),(32080326,0,1000,0,2,0,1,0,'[{{0,1007020341,1},1},{{0,1003000341,1},1},{{0,1005000341,1},1},{{0,1009000341,1},1}]','[]','[]'),(32080326,0,1000,0,3,0,1,0,'[{{0,1007030341,1},1},{{0,1003000341,1},1},{{0,1005000341,1},1},{{0,1009000341,1},1}]','[]','[]'),(32080326,0,1000,0,4,0,1,0,'[{{0,1007040341,1},1},{{0,1003000341,1},1},{{0,1005000341,1},1},{{0,1009000341,1},1}]','[]','[]'),(32080327,0,1000,0,1,0,1,0,'[{{0,1007010341,1},1},{{0,1003000341,1},1}]','[]','[]'),(32080327,0,1000,0,2,0,1,0,'[{{0,1007020341,1},1},{{0,1003000341,1},1}]','[]','[]'),(32080327,0,1000,0,3,0,1,0,'[{{0,1007030341,1},1},{{0,1003000341,1},1}]','[]','[]'),(32080327,0,1000,0,4,0,1,0,'[{{0,1007040341,1},1},{{0,1003000341,1},1}]','[]','[]'),(32080328,0,1000,0,0,0,1,0,'[{{0,1005000341,1},1},{{0,1009000341,1},1}]','[]','[]'),(32080331,0,1000,0,1,0,1,0,'[{{0,1001010342,1},1},{{0,1002010342,1},1},{{0,1003000342,1},1},{{0,1004010342,1},1},{{0,1006010342,1},1},{{0,1007010342,1},1},{{0,1008010342,1},1},{{0,1010010342,1},1}]','[]','[1001010342,1002010342,1003000342,1004010342,1005000342,1006010342,1007010342,1008010342,1009000342,1010010342]'),(32080331,0,1000,0,2,0,1,0,'[{{0,1001020342,1},1},{{0,1002020342,1},1},{{0,1003000342,1},1},{{0,1004020342,1},1},{{0,1006020342,1},1},{{0,1007020342,1},1},{{0,1008020342,1},1},{{0,1010020342,1},1}]','[]','[1001020342,1002020342,1003000342,1004020342,1005000342,1006020342,1007020342,1008020342,1009000342,1010020342]'),(32080331,0,1000,0,3,0,1,0,'[{{0,1001030342,1},1},{{0,1002030342,1},1},{{0,1003000342,1},1},{{0,1004030342,1},1},{{0,1006030342,1},1},{{0,1007030342,1},1},{{0,1008030342,1},1},{{0,1010030342,1},1}]','[]','[1001030342,1002030342,1003000342,1004030342,1005000342,1006030342,1007030342,1008030342,1009000342,1010030342]'),(32080331,0,1000,0,4,0,1,0,'[{{0,1001040342,1},1},{{0,1002040342,1},1},{{0,1003000342,1},1},{{0,1004040342,1},1},{{0,1006040342,1},1},{{0,1007040342,1},1},{{0,1008040342,1},1},{{0,1010040342,1},1}]','[]','[1001040342,1002040342,1003000342,1004040342,1005000342,1006040342,1007040342,1008040342,1009000342,1010040342]'),(32080332,0,1000,0,1,0,1,0,'[{{0,1002010342,1},1},{{0,1004010342,1},1},{{0,1006010342,1},1},{{0,1008010342,1},1},{{0,1010010342,1},1}]','[]','[1002010342,1004010342,1006010342,1008010342,1010010342]'),(32080332,0,1000,0,2,0,1,0,'[{{0,1002020342,1},1},{{0,1004020342,1},1},{{0,1006020342,1},1},{{0,1008020342,1},1},{{0,1010020342,1},1}]','[]','[1002020342,1004020342,1006020342,1008020342,1010020342]'),(32080332,0,1000,0,3,0,1,0,'[{{0,1002030342,1},1},{{0,1004030342,1},1},{{0,1006030342,1},1},{{0,1008030342,1},1},{{0,1010030342,1},1}]','[]','[1002030342,1004030342,1006030342,1008030342,1010030342]'),(32080332,0,1000,0,4,0,1,0,'[{{0,1002040342,1},1},{{0,1004040342,1},1},{{0,1006040342,1},1},{{0,1008040342,1},1},{{0,1010040342,1},1}]','[]','[1002040342,1004040342,1006040342,1008040342,1010040342]'),(32080333,0,1000,0,1,0,1,0,'[{{0,1001010342,1},1},{{0,1007010342,1},1}]','[]','[1001010342,1007010342]'),(32080333,0,1000,0,2,0,1,0,'[{{0,1001020342,1},1},{{0,1007020342,1},1}]','[]','[1001020342,1007020342]'),(32080333,0,1000,0,3,0,1,0,'[{{0,1001030342,1},1},{{0,1007030342,1},1}]','[]','[1001030342,1007030342]'),(32080333,0,1000,0,4,0,1,0,'[{{0,1001040342,1},1},{{0,1007040342,1},1}]','[]','[1001040342,1007040342]'),(32080335,0,1000,0,1,0,1,0,'[{{0,1002010342,1},1},{{0,1004010342,1},1},{{0,1006010342,1},1},{{0,1008010342,1},1},{{0,1010010342,1},1},{{0,1001010342,1},1}]','[]','[1002010342,1004010342,1006010342,1008010342,1010010342,1001010342]'),(32080335,0,1000,0,2,0,1,0,'[{{0,1002020342,1},1},{{0,1004020342,1},1},{{0,1006020342,1},1},{{0,1008020342,1},1},{{0,1010020342,1},1},{{0,1001020342,1},1}]','[]','[1002020342,1004020342,1006020342,1008020342,1010020342,1001020342]'),(32080335,0,1000,0,3,0,1,0,'[{{0,1002030342,1},1},{{0,1004030342,1},1},{{0,1006030342,1},1},{{0,1008030342,1},1},{{0,1010030342,1},1},{{0,1001030342,1},1}]','[]','[1002030342,1004030342,1006030342,1008030342,1010030342,1001030342]'),(32080335,0,1000,0,4,0,1,0,'[{{0,1002040342,1},1},{{0,1004040342,1},1},{{0,1006040342,1},1},{{0,1008040342,1},1},{{0,1010040342,1},1},{{0,1001040342,1},1}]','[]','[1002040342,1004040342,1006040342,1008040342,1010040342,1001040342]'),(32080336,0,1000,0,1,0,1,0,'[{{0,1007010342,1},1},{{0,1003000342,1},1},{{0,1005000342,1},1},{{0,1009000342,1},1}]','[]','[1007010342,1003000342,1005000342,1009000342]'),(32080336,0,1000,0,2,0,1,0,'[{{0,1007020342,1},1},{{0,1003000342,1},1},{{0,1005000342,1},1},{{0,1009000342,1},1}]','[]','[1007020342,1003000342,1005000342,1009000342]'),(32080336,0,1000,0,3,0,1,0,'[{{0,1007030342,1},1},{{0,1003000342,1},1},{{0,1005000342,1},1},{{0,1009000342,1},1}]','[]','[1007030342,1003000342,1005000342,1009000342]'),(32080336,0,1000,0,4,0,1,0,'[{{0,1007040342,1},1},{{0,1003000342,1},1},{{0,1005000342,1},1},{{0,1009000342,1},1}]','[]','[1007040342,1003000342,1005000342,1009000342]'),(32080337,0,1000,0,1,0,1,0,'[{{0,1007010342,1},1},{{0,1003000342,1},1}]','[]','[1007010342,1003000342]'),(32080337,0,1000,0,2,0,1,0,'[{{0,1007020342,1},1},{{0,1003000342,1},1}]','[]','[1007020342,1003000342]'),(32080337,0,1000,0,3,0,1,0,'[{{0,1007030342,1},1},{{0,1003000342,1},1}]','[]','[1007030342,1003000342]'),(32080337,0,1000,0,4,0,1,0,'[{{0,1007040342,1},1},{{0,1003000342,1},1}]','[]','[1007040342,1003000342]'),(32080338,0,1000,0,0,0,1,0,'[{{0,1005000342,1},1},{{0,1009000342,1},1}]','[]','[1005000342,1009000342]'),(32080341,0,1000,0,1,0,1,0,'[{{0,1001010343,1},1},{{0,1002010343,1},1},{{0,1003000343,1},1},{{0,1004010343,1},1},{{0,1006010343,1},1},{{0,1007010343,1},1},{{0,1008010343,1},1},{{0,1010010343,1},1}]','[]','[1001010343,1002010343,1003000343,1004010343,1005000343,1006010343,1007010343,1008010343,1009000343,1010010343]'),(32080341,0,1000,0,2,0,1,0,'[{{0,1001020343,1},1},{{0,1002020343,1},1},{{0,1003000343,1},1},{{0,1004020343,1},1},{{0,1006020343,1},1},{{0,1007020343,1},1},{{0,1008020343,1},1},{{0,1010020343,1},1}]','[]','[1001020343,1002020343,1003000343,1004020343,1005000343,1006020343,1007020343,1008020343,1009000343,1010020343]'),(32080341,0,1000,0,3,0,1,0,'[{{0,1001030343,1},1},{{0,1002030343,1},1},{{0,1003000343,1},1},{{0,1004030343,1},1},{{0,1006030343,1},1},{{0,1007030343,1},1},{{0,1008030343,1},1},{{0,1010030343,1},1}]','[]','[1001030343,1002030343,1003000343,1004030343,1005000343,1006030343,1007030343,1008030343,1009000343,1010030343]'),(32080341,0,1000,0,4,0,1,0,'[{{0,1001040343,1},1},{{0,1002040343,1},1},{{0,1003000343,1},1},{{0,1004040343,1},1},{{0,1006040343,1},1},{{0,1007040343,1},1},{{0,1008040343,1},1},{{0,1010040343,1},1}]','[]','[1001040343,1002040343,1003000343,1004040343,1005000343,1006040343,1007040343,1008040343,1009000343,1010040343]'),(32080342,0,1000,0,1,0,1,0,'[{{0,1002010343,1},1},{{0,1004010343,1},1},{{0,1006010343,1},1},{{0,1008010343,1},1},{{0,1010010343,1},1}]','[]','[1002010343,1004010343,1006010343,1008010343,1010010343]'),(32080342,0,1000,0,2,0,1,0,'[{{0,1002020343,1},1},{{0,1004020343,1},1},{{0,1006020343,1},1},{{0,1008020343,1},1},{{0,1010020343,1},1}]','[]','[1002020343,1004020343,1006020343,1008020343,1010020343]'),(32080342,0,1000,0,3,0,1,0,'[{{0,1002030343,1},1},{{0,1004030343,1},1},{{0,1006030343,1},1},{{0,1008030343,1},1},{{0,1010030343,1},1}]','[]','[1002030343,1004030343,1006030343,1008030343,1010030343]'),(32080342,0,1000,0,4,0,1,0,'[{{0,1002040343,1},1},{{0,1004040343,1},1},{{0,1006040343,1},1},{{0,1008040343,1},1},{{0,1010040343,1},1}]','[]','[1002040343,1004040343,1006040343,1008040343,1010040343]'),(32080343,0,1000,0,1,0,1,0,'[{{0,1001010343,1},1},{{0,1007010343,1},1}]','[]','[1001010343,1007010343]'),(32080343,0,1000,0,2,0,1,0,'[{{0,1001020343,1},1},{{0,1007020343,1},1}]','[]','[1001020343,1007020343]'),(32080343,0,1000,0,3,0,1,0,'[{{0,1001030343,1},1},{{0,1007030343,1},1}]','[]','[1001030343,1007030343]'),(32080343,0,1000,0,4,0,1,0,'[{{0,1001040343,1},1},{{0,1007040343,1},1}]','[]','[1001040343,1007040343]'),(32080345,0,1000,0,1,0,1,0,'[{{0,1002010343,1},1},{{0,1004010343,1},1},{{0,1006010343,1},1},{{0,1008010343,1},1},{{0,1010010343,1},1},{{0,1001010343,1},1}]','[]','[1002010343,1004010343,1006010343,1008010343,1010010343,1001010343]'),(32080345,0,1000,0,2,0,1,0,'[{{0,1002020343,1},1},{{0,1004020343,1},1},{{0,1006020343,1},1},{{0,1008020343,1},1},{{0,1010020343,1},1},{{0,1001020343,1},1}]','[]','[1002020343,1004020343,1006020343,1008020343,1010020343,1001020343]'),(32080345,0,1000,0,3,0,1,0,'[{{0,1002030343,1},1},{{0,1004030343,1},1},{{0,1006030343,1},1},{{0,1008030343,1},1},{{0,1010030343,1},1},{{0,1001030343,1},1}]','[]','[1002030343,1004030343,1006030343,1008030343,1010030343,1001030343]'),(32080345,0,1000,0,4,0,1,0,'[{{0,1002040343,1},1},{{0,1004040343,1},1},{{0,1006040343,1},1},{{0,1008040343,1},1},{{0,1010040343,1},1},{{0,1001040343,1},1}]','[]','[1002040343,1004040343,1006040343,1008040343,1010040343,1001040343]'),(32080346,0,1000,0,1,0,1,0,'[{{0,1007010343,1},1},{{0,1003000343,1},1},{{0,1005000343,1},1},{{0,1009000343,1},1}]','[]','[1007010343,1003000343,1005000343,1009000343]'),(32080346,0,1000,0,2,0,1,0,'[{{0,1007020343,1},1},{{0,1003000343,1},1},{{0,1005000343,1},1},{{0,1009000343,1},1}]','[]','[1007020343,1003000343,1005000343,1009000343]'),(32080346,0,1000,0,3,0,1,0,'[{{0,1007030343,1},1},{{0,1003000343,1},1},{{0,1005000343,1},1},{{0,1009000343,1},1}]','[]','[1007030343,1003000343,1005000343,1009000343]'),(32080346,0,1000,0,4,0,1,0,'[{{0,1007040343,1},1},{{0,1003000343,1},1},{{0,1005000343,1},1},{{0,1009000343,1},1}]','[]','[1007040343,1003000343,1005000343,1009000343]'),(32080347,0,1000,0,1,0,1,0,'[{{0,1007010343,1},1},{{0,1003000343,1},1}]','[]','[1007010343,1003000343]'),(32080347,0,1000,0,2,0,1,0,'[{{0,1007020343,1},1},{{0,1003000343,1},1}]','[]','[1007020343,1003000343]'),(32080347,0,1000,0,3,0,1,0,'[{{0,1007030343,1},1},{{0,1003000343,1},1}]','[]','[1007030343,1003000343]'),(32080347,0,1000,0,4,0,1,0,'[{{0,1007040343,1},1},{{0,1003000343,1},1}]','[]','[1007040343,1003000343]'),(32080348,0,1000,0,0,0,1,0,'[{{0,1005000343,1},1},{{0,1009000343,1},1}]','[]','[1005000343,1009000343]'),(32080351,0,1000,0,1,0,1,0,'[{{0,1001010353,1},1},{{0,1002010353,1},1},{{0,1003000353,1},1},{{0,1004010353,1},1},{{0,1006010353,1},1},{{0,1007010353,1},1},{{0,1008010353,1},1},{{0,1010010353,1},1}]','[]','[1001010353,1002010353,1003000353,1004010353,1005000353,1006010353,1007010353,1008010353,1009000353,1010010353]'),(32080351,0,1000,0,2,0,1,0,'[{{0,1001020353,1},1},{{0,1002020353,1},1},{{0,1003000353,1},1},{{0,1004020353,1},1},{{0,1006020353,1},1},{{0,1007020353,1},1},{{0,1008020353,1},1},{{0,1010020353,1},1}]','[]','[1001020353,1002020353,1003000353,1004020353,1005000353,1006020353,1007020353,1008020353,1009000353,1010020353]'),(32080351,0,1000,0,3,0,1,0,'[{{0,1001030353,1},1},{{0,1002030353,1},1},{{0,1003000353,1},1},{{0,1004030353,1},1},{{0,1006030353,1},1},{{0,1007030353,1},1},{{0,1008030353,1},1},{{0,1010030353,1},1}]','[]','[1001030353,1002030353,1003000353,1004030353,1005000353,1006030353,1007030353,1008030353,1009000353,1010030353]'),(32080351,0,1000,0,4,0,1,0,'[{{0,1001040353,1},1},{{0,1002040353,1},1},{{0,1003000353,1},1},{{0,1004040353,1},1},{{0,1006040353,1},1},{{0,1007040353,1},1},{{0,1008040353,1},1},{{0,1010040353,1},1}]','[]','[1001040353,1002040353,1003000353,1004040353,1005000353,1006040353,1007040353,1008040353,1009000353,1010040353]'),(32080352,0,1000,0,1,0,1,0,'[{{0,1002010353,1},1},{{0,1004010353,1},1},{{0,1006010353,1},1},{{0,1008010353,1},1},{{0,1010010353,1},1}]','[]','[1002010353,1004010353,1006010353,1008010353,1010010353]'),(32080352,0,1000,0,2,0,1,0,'[{{0,1002020353,1},1},{{0,1004020353,1},1},{{0,1006020353,1},1},{{0,1008020353,1},1},{{0,1010020353,1},1}]','[]','[1002020353,1004020353,1006020353,1008020353,1010020353]'),(32080352,0,1000,0,3,0,1,0,'[{{0,1002030353,1},1},{{0,1004030353,1},1},{{0,1006030353,1},1},{{0,1008030353,1},1},{{0,1010030353,1},1}]','[]','[1002030353,1004030353,1006030353,1008030353,1010030353]'),(32080352,0,1000,0,4,0,1,0,'[{{0,1002040353,1},1},{{0,1004040353,1},1},{{0,1006040353,1},1},{{0,1008040353,1},1},{{0,1010040353,1},1}]','[]','[1002040353,1004040353,1006040353,1008040353,1010040353]'),(32080353,0,1000,0,1,0,1,0,'[{{0,1001010353,1},1},{{0,1007010353,1},1}]','[]','[1001010353,1007010353]'),(32080353,0,1000,0,2,0,1,0,'[{{0,1001020353,1},1},{{0,1007020353,1},1}]','[]','[1001020353,1007020353]'),(32080353,0,1000,0,3,0,1,0,'[{{0,1001030353,1},1},{{0,1007030353,1},1}]','[]','[1001030353,1007030353]'),(32080353,0,1000,0,4,0,1,0,'[{{0,1001040353,1},1},{{0,1007040353,1},1}]','[]','[1001040353,1007040353]'),(32080355,0,1000,0,1,0,1,0,'[{{0,1002010353,1},1},{{0,1004010353,1},1},{{0,1006010353,1},1},{{0,1008010353,1},1},{{0,1010010353,1},1},{{0,1001010353,1},1}]','[]','[1002010353,1004010353,1006010353,1008010353,1010010353,1001010353]'),(32080355,0,1000,0,2,0,1,0,'[{{0,1002020353,1},1},{{0,1004020353,1},1},{{0,1006020353,1},1},{{0,1008020353,1},1},{{0,1010020353,1},1},{{0,1001020353,1},1}]','[]','[1002020353,1004020353,1006020353,1008020353,1010020353,1001020353]'),(32080355,0,1000,0,3,0,1,0,'[{{0,1002030353,1},1},{{0,1004030353,1},1},{{0,1006030353,1},1},{{0,1008030353,1},1},{{0,1010030353,1},1},{{0,1001030353,1},1}]','[]','[1002030353,1004030353,1006030353,1008030353,1010030353,1001030353]'),(32080355,0,1000,0,4,0,1,0,'[{{0,1002040353,1},1},{{0,1004040353,1},1},{{0,1006040353,1},1},{{0,1008040353,1},1},{{0,1010040353,1},1},{{0,1001040353,1},1}]','[]','[1002040353,1004040353,1006040353,1008040353,1010040353,1001040353]'),(32080356,0,1000,0,1,0,1,0,'[{{0,1007010353,1},1},{{0,1003000353,1},1},{{0,1005000353,1},1},{{0,1009000353,1},1}]','[]','[1007010353,1003000353,1005000353,1009000353]'),(32080356,0,1000,0,2,0,1,0,'[{{0,1007020353,1},1},{{0,1003000353,1},1},{{0,1005000353,1},1},{{0,1009000353,1},1}]','[]','[1007020353,1003000353,1005000353,1009000353]'),(32080356,0,1000,0,3,0,1,0,'[{{0,1007030353,1},1},{{0,1003000353,1},1},{{0,1005000353,1},1},{{0,1009000353,1},1}]','[]','[1007030353,1003000353,1005000353,1009000353]'),(32080356,0,1000,0,4,0,1,0,'[{{0,1007040353,1},1},{{0,1003000353,1},1},{{0,1005000353,1},1},{{0,1009000353,1},1}]','[]','[1007040353,1003000353,1005000353,1009000353]'),(32080357,0,1000,0,1,0,1,0,'[{{0,1007010353,1},1},{{0,1003000353,1},1}]','[]','[1007010353,1003000353]'),(32080357,0,1000,0,2,0,1,0,'[{{0,1007020353,1},1},{{0,1003000353,1},1}]','[]','[1007020353,1003000353]'),(32080357,0,1000,0,3,0,1,0,'[{{0,1007030353,1},1},{{0,1003000353,1},1}]','[]','[1007030353,1003000353]'),(32080357,0,1000,0,4,0,1,0,'[{{0,1007040353,1},1},{{0,1003000353,1},1}]','[]','[1007040353,1003000353]'),(32080358,0,1000,0,0,0,1,0,'[{{0,1005000353,1},1},{{0,1009000353,1},1}]','[]','[1005000353,1009000353]'),(32080361,0,1000,0,1,0,1,0,'[{{0,1001010363,1},1},{{0,1002010363,1},1},{{0,1003000363,1},1},{{0,1004010363,1},1},{{0,1006010363,1},1},{{0,1007010363,1},1},{{0,1008010363,1},1},{{0,1010010363,1},1}]','[]','[1001010363,1002010363,1003000363,1004010363,1005000363,1006010363,1007010363,1008010363,1009000363,1010010363]'),(32080361,0,1000,0,2,0,1,0,'[{{0,1001020363,1},1},{{0,1002020363,1},1},{{0,1003000363,1},1},{{0,1004020363,1},1},{{0,1006020363,1},1},{{0,1007020363,1},1},{{0,1008020363,1},1},{{0,1010020363,1},1}]','[]','[1001020363,1002020363,1003000363,1004020363,1005000363,1006020363,1007020363,1008020363,1009000363,1010020363]'),(32080361,0,1000,0,3,0,1,0,'[{{0,1001030363,1},1},{{0,1002030363,1},1},{{0,1003000363,1},1},{{0,1004030363,1},1},{{0,1006030363,1},1},{{0,1007030363,1},1},{{0,1008030363,1},1},{{0,1010030363,1},1}]','[]','[1001030363,1002030363,1003000363,1004030363,1005000363,1006030363,1007030363,1008030363,1009000363,1010030363]'),(32080361,0,1000,0,4,0,1,0,'[{{0,1001040363,1},1},{{0,1002040363,1},1},{{0,1003000363,1},1},{{0,1004040363,1},1},{{0,1006040363,1},1},{{0,1007040363,1},1},{{0,1008040363,1},1},{{0,1010040363,1},1}]','[]','[1001040363,1002040363,1003000363,1004040363,1005000363,1006040363,1007040363,1008040363,1009000363,1010040363]'),(32080362,0,1000,0,1,0,1,0,'[{{0,1002010363,1},1},{{0,1004010363,1},1},{{0,1006010363,1},1},{{0,1008010363,1},1},{{0,1010010363,1},1}]','[]','[1002010363,1004010363,1006010363,1008010363,1010010363]'),(32080362,0,1000,0,2,0,1,0,'[{{0,1002020363,1},1},{{0,1004020363,1},1},{{0,1006020363,1},1},{{0,1008020363,1},1},{{0,1010020363,1},1}]','[]','[1002020363,1004020363,1006020363,1008020363,1010020363]'),(32080362,0,1000,0,3,0,1,0,'[{{0,1002030363,1},1},{{0,1004030363,1},1},{{0,1006030363,1},1},{{0,1008030363,1},1},{{0,1010030363,1},1}]','[]','[1002030363,1004030363,1006030363,1008030363,1010030363]'),(32080362,0,1000,0,4,0,1,0,'[{{0,1002040363,1},1},{{0,1004040363,1},1},{{0,1006040363,1},1},{{0,1008040363,1},1},{{0,1010040363,1},1}]','[]','[1002040363,1004040363,1006040363,1008040363,1010040363]'),(32080363,0,1000,0,1,0,1,0,'[{{0,1001010363,1},1},{{0,1007010363,1},1}]','[]','[1001010363,1007010363]'),(32080363,0,1000,0,2,0,1,0,'[{{0,1001020363,1},1},{{0,1007020363,1},1}]','[]','[1001020363,1007020363]'),(32080363,0,1000,0,3,0,1,0,'[{{0,1001030363,1},1},{{0,1007030363,1},1}]','[]','[1001030363,1007030363]'),(32080363,0,1000,0,4,0,1,0,'[{{0,1001040363,1},1},{{0,1007040363,1},1}]','[]','[1001040363,1007040363]'),(32080365,0,1000,0,1,0,1,0,'[{{0,1002010363,1},1},{{0,1004010363,1},1},{{0,1006010363,1},1},{{0,1008010363,1},1},{{0,1010010363,1},1},{{0,1001010363,1},1}]','[]','[1002010363,1004010363,1006010363,1008010363,1010010363,1001010363]'),(32080365,0,1000,0,2,0,1,0,'[{{0,1002020363,1},1},{{0,1004020363,1},1},{{0,1006020363,1},1},{{0,1008020363,1},1},{{0,1010020363,1},1},{{0,1001020363,1},1}]','[]','[1002020363,1004020363,1006020363,1008020363,1010020363,1001020363]'),(32080365,0,1000,0,3,0,1,0,'[{{0,1002030363,1},1},{{0,1004030363,1},1},{{0,1006030363,1},1},{{0,1008030363,1},1},{{0,1010030363,1},1},{{0,1001030363,1},1}]','[]','[1002030363,1004030363,1006030363,1008030363,1010030363,1001030363]'),(32080365,0,1000,0,4,0,1,0,'[{{0,1002040363,1},1},{{0,1004040363,1},1},{{0,1006040363,1},1},{{0,1008040363,1},1},{{0,1010040363,1},1},{{0,1001040363,1},1}]','[]','[1002040363,1004040363,1006040363,1008040363,1010040363,1001040363]'),(32080366,0,1000,0,1,0,1,0,'[{{0,1007010363,1},1},{{0,1003000363,1},1},{{0,1005000363,1},1},{{0,1009000363,1},1}]','[]','[1007010363,1003000363,1005000363,1009000363]'),(32080366,0,1000,0,2,0,1,0,'[{{0,1007020363,1},1},{{0,1003000363,1},1},{{0,1005000363,1},1},{{0,1009000363,1},1}]','[]','[1007020363,1003000363,1005000363,1009000363]'),(32080366,0,1000,0,3,0,1,0,'[{{0,1007030363,1},1},{{0,1003000363,1},1},{{0,1005000363,1},1},{{0,1009000363,1},1}]','[]','[1007030363,1003000363,1005000363,1009000363]'),(32080366,0,1000,0,4,0,1,0,'[{{0,1007040363,1},1},{{0,1003000363,1},1},{{0,1005000363,1},1},{{0,1009000363,1},1}]','[]','[1007040363,1003000363,1005000363,1009000363]'),(32080367,0,1000,0,1,0,1,0,'[{{0,1007010363,1},1},{{0,1003000363,1},1}]','[]','[1007010363,1003000363]'),(32080367,0,1000,0,2,0,1,0,'[{{0,1007020363,1},1},{{0,1003000363,1},1}]','[]','[1007020363,1003000363]'),(32080367,0,1000,0,3,0,1,0,'[{{0,1007030363,1},1},{{0,1003000363,1},1}]','[]','[1007030363,1003000363]'),(32080367,0,1000,0,4,0,1,0,'[{{0,1007040363,1},1},{{0,1003000363,1},1}]','[]','[1007040363,1003000363]'),(32080368,0,1000,0,0,0,1,0,'[{{0,1005000363,1},1},{{0,1009000363,1},1}]','[]','[1005000363,1009000363]'),(32080371,0,1000,0,1,0,1,0,'[{{0,1001010300,1},1},{{0,1002010300,1},1},{{0,1003000300,1},1},{{0,1004010300,1},1},{{0,1006010300,1},1},{{0,1007010300,1},1},{{0,1008010300,1},1},{{0,1010010300,1},1}]','[]','[]'),(32080371,0,1000,0,2,0,1,0,'[{{0,1001020300,1},1},{{0,1002020300,1},1},{{0,1003000300,1},1},{{0,1004020300,1},1},{{0,1006020300,1},1},{{0,1007020300,1},1},{{0,1008020300,1},1},{{0,1010020300,1},1}]','[]','[]'),(32080371,0,1000,0,3,0,1,0,'[{{0,1001030300,1},1},{{0,1002030300,1},1},{{0,1003000300,1},1},{{0,1004030300,1},1},{{0,1006030300,1},1},{{0,1007030300,1},1},{{0,1008030300,1},1},{{0,1010030300,1},1}]','[]','[]'),(32080371,0,1000,0,4,0,1,0,'[{{0,1001040300,1},1},{{0,1002040300,1},1},{{0,1003000300,1},1},{{0,1004040300,1},1},{{0,1006040300,1},1},{{0,1007040300,1},1},{{0,1008040300,1},1},{{0,1010040300,1},1}]','[]','[]'),(32080372,0,1000,0,1,0,1,0,'[{{0,1002010300,1},1},{{0,1004010300,1},1},{{0,1006010300,1},1},{{0,1008010300,1},1},{{0,1010010300,1},1}]','[]','[]'),(32080372,0,1000,0,2,0,1,0,'[{{0,1002020300,1},1},{{0,1004020300,1},1},{{0,1006020300,1},1},{{0,1008020300,1},1},{{0,1010020300,1},1}]','[]','[]'),(32080372,0,1000,0,3,0,1,0,'[{{0,1002030300,1},1},{{0,1004030300,1},1},{{0,1006030300,1},1},{{0,1008030300,1},1},{{0,1010030300,1},1}]','[]','[]'),(32080372,0,1000,0,4,0,1,0,'[{{0,1002040300,1},1},{{0,1004040300,1},1},{{0,1006040300,1},1},{{0,1008040300,1},1},{{0,1010040300,1},1}]','[]','[]'),(32080373,0,1000,0,1,0,1,0,'[{{0,1001010300,1},1},{{0,1007010300,1},1}]','[]','[]'),(32080373,0,1000,0,2,0,1,0,'[{{0,1001020300,1},1},{{0,1007020300,1},1}]','[]','[]'),(32080373,0,1000,0,3,0,1,0,'[{{0,1001030300,1},1},{{0,1007030300,1},1}]','[]','[]'),(32080373,0,1000,0,4,0,1,0,'[{{0,1001040300,1},1},{{0,1007040300,1},1}]','[]','[]'),(32080375,0,1000,0,1,0,1,0,'[{{0,1002010300,1},1},{{0,1004010300,1},1},{{0,1006010300,1},1},{{0,1008010300,1},1},{{0,1010010300,1},1},{{0,1001010300,1},1}]','[]','[]'),(32080375,0,1000,0,2,0,1,0,'[{{0,1002020300,1},1},{{0,1004020300,1},1},{{0,1006020300,1},1},{{0,1008020300,1},1},{{0,1010020300,1},1},{{0,1001020300,1},1}]','[]','[]'),(32080375,0,1000,0,3,0,1,0,'[{{0,1002030300,1},1},{{0,1004030300,1},1},{{0,1006030300,1},1},{{0,1008030300,1},1},{{0,1010030300,1},1},{{0,1001030300,1},1}]','[]','[]'),(32080375,0,1000,0,4,0,1,0,'[{{0,1002040300,1},1},{{0,1004040300,1},1},{{0,1006040300,1},1},{{0,1008040300,1},1},{{0,1010040300,1},1},{{0,1001040300,1},1}]','[]','[]'),(32080376,0,1000,0,1,0,1,0,'[{{0,1007010300,1},1},{{0,1003000300,1},1},{{0,1005000300,1},1},{{0,1009000300,1},1}]','[]','[]'),(32080376,0,1000,0,2,0,1,0,'[{{0,1007020300,1},1},{{0,1003000300,1},1},{{0,1005000300,1},1},{{0,1009000300,1},1}]','[]','[]'),(32080376,0,1000,0,3,0,1,0,'[{{0,1007030300,1},1},{{0,1003000300,1},1},{{0,1005000300,1},1},{{0,1009000300,1},1}]','[]','[]'),(32080376,0,1000,0,4,0,1,0,'[{{0,1007040300,1},1},{{0,1003000300,1},1},{{0,1005000300,1},1},{{0,1009000300,1},1}]','[]','[]'),(32080377,0,1000,0,1,0,1,0,'[{{0,1007010300,1},1},{{0,1003000300,1},1}]','[]','[]'),(32080377,0,1000,0,2,0,1,0,'[{{0,1007020300,1},1},{{0,1003000300,1},1}]','[]','[]'),(32080377,0,1000,0,3,0,1,0,'[{{0,1007030300,1},1},{{0,1003000300,1},1}]','[]','[]'),(32080377,0,1000,0,4,0,1,0,'[{{0,1007040300,1},1},{{0,1003000300,1},1}]','[]','[]'),(32080378,0,1000,0,0,0,1,0,'[{{0,1005000300,1},1},{{0,1009000300,1},1}]','[]','[]'),(32080381,0,1000,0,1,0,1,0,'[{{0,1001010310,1},1},{{0,1002010310,1},1},{{0,1003000310,1},1},{{0,1004010310,1},1},{{0,1006010310,1},1},{{0,1007010310,1},1},{{0,1008010310,1},1},{{0,1010010310,1},1}]','[]','[]'),(32080381,0,1000,0,2,0,1,0,'[{{0,1001020310,1},1},{{0,1002020310,1},1},{{0,1003000310,1},1},{{0,1004020310,1},1},{{0,1006020310,1},1},{{0,1007020310,1},1},{{0,1008020310,1},1},{{0,1010020310,1},1}]','[]','[]'),(32080381,0,1000,0,3,0,1,0,'[{{0,1001030310,1},1},{{0,1002030310,1},1},{{0,1003000310,1},1},{{0,1004030310,1},1},{{0,1006030310,1},1},{{0,1007030310,1},1},{{0,1008030310,1},1},{{0,1010030310,1},1}]','[]','[]'),(32080381,0,1000,0,4,0,1,0,'[{{0,1001040310,1},1},{{0,1002040310,1},1},{{0,1003000310,1},1},{{0,1004040310,1},1},{{0,1006040310,1},1},{{0,1007040310,1},1},{{0,1008040310,1},1},{{0,1010040310,1},1}]','[]','[]'),(32080382,0,1000,0,1,0,1,0,'[{{0,1002010310,1},1},{{0,1004010310,1},1},{{0,1006010310,1},1},{{0,1008010310,1},1},{{0,1010010310,1},1}]','[]','[]'),(32080382,0,1000,0,2,0,1,0,'[{{0,1002020310,1},1},{{0,1004020310,1},1},{{0,1006020310,1},1},{{0,1008020310,1},1},{{0,1010020310,1},1}]','[]','[]'),(32080382,0,1000,0,3,0,1,0,'[{{0,1002030310,1},1},{{0,1004030310,1},1},{{0,1006030310,1},1},{{0,1008030310,1},1},{{0,1010030310,1},1}]','[]','[]'),(32080382,0,1000,0,4,0,1,0,'[{{0,1002040310,1},1},{{0,1004040310,1},1},{{0,1006040310,1},1},{{0,1008040310,1},1},{{0,1010040310,1},1}]','[]','[]'),(32080383,0,1000,0,1,0,1,0,'[{{0,1001010310,1},1},{{0,1007010310,1},1}]','[]','[]'),(32080383,0,1000,0,2,0,1,0,'[{{0,1001020310,1},1},{{0,1007020310,1},1}]','[]','[]'),(32080383,0,1000,0,3,0,1,0,'[{{0,1001030310,1},1},{{0,1007030310,1},1}]','[]','[]'),(32080383,0,1000,0,4,0,1,0,'[{{0,1001040310,1},1},{{0,1007040310,1},1}]','[]','[]'),(32080385,0,1000,0,1,0,1,0,'[{{0,1002010310,1},1},{{0,1004010310,1},1},{{0,1006010310,1},1},{{0,1008010310,1},1},{{0,1010010310,1},1},{{0,1001010310,1},1}]','[]','[]'),(32080385,0,1000,0,2,0,1,0,'[{{0,1002020310,1},1},{{0,1004020310,1},1},{{0,1006020310,1},1},{{0,1008020310,1},1},{{0,1010020310,1},1},{{0,1001020310,1},1}]','[]','[]'),(32080385,0,1000,0,3,0,1,0,'[{{0,1002030310,1},1},{{0,1004030310,1},1},{{0,1006030310,1},1},{{0,1008030310,1},1},{{0,1010030310,1},1},{{0,1001030310,1},1}]','[]','[]'),(32080385,0,1000,0,4,0,1,0,'[{{0,1002040310,1},1},{{0,1004040310,1},1},{{0,1006040310,1},1},{{0,1008040310,1},1},{{0,1010040310,1},1},{{0,1001040310,1},1}]','[]','[]'),(32080386,0,1000,0,1,0,1,0,'[{{0,1007010310,1},1},{{0,1003000310,1},1},{{0,1005000310,1},1},{{0,1009000310,1},1}]','[]','[]'),(32080386,0,1000,0,2,0,1,0,'[{{0,1007020310,1},1},{{0,1003000310,1},1},{{0,1005000310,1},1},{{0,1009000310,1},1}]','[]','[]'),(32080386,0,1000,0,3,0,1,0,'[{{0,1007030310,1},1},{{0,1003000310,1},1},{{0,1005000310,1},1},{{0,1009000310,1},1}]','[]','[]'),(32080386,0,1000,0,4,0,1,0,'[{{0,1007040310,1},1},{{0,1003000310,1},1},{{0,1005000310,1},1},{{0,1009000310,1},1}]','[]','[]'),(32080387,0,1000,0,1,0,1,0,'[{{0,1007010310,1},1},{{0,1003000310,1},1}]','[]','[]'),(32080387,0,1000,0,2,0,1,0,'[{{0,1007020310,1},1},{{0,1003000310,1},1}]','[]','[]'),(32080387,0,1000,0,3,0,1,0,'[{{0,1007030310,1},1},{{0,1003000310,1},1}]','[]','[]'),(32080387,0,1000,0,4,0,1,0,'[{{0,1007040310,1},1},{{0,1003000310,1},1}]','[]','[]'),(32080388,0,1000,0,0,0,1,0,'[{{0,1005000310,1},1},{{0,1009000310,1},1}]','[]','[]'),(32080391,0,1000,0,1,0,1,0,'[{{0,1001010320,1},1},{{0,1002010320,1},1},{{0,1003000320,1},1},{{0,1004010320,1},1},{{0,1006010320,1},1},{{0,1007010320,1},1},{{0,1008010320,1},1},{{0,1010010320,1},1}]','[]','[]'),(32080391,0,1000,0,2,0,1,0,'[{{0,1001020320,1},1},{{0,1002020320,1},1},{{0,1003000320,1},1},{{0,1004020320,1},1},{{0,1006020320,1},1},{{0,1007020320,1},1},{{0,1008020320,1},1},{{0,1010020320,1},1}]','[]','[]'),(32080391,0,1000,0,3,0,1,0,'[{{0,1001030320,1},1},{{0,1002030320,1},1},{{0,1003000320,1},1},{{0,1004030320,1},1},{{0,1006030320,1},1},{{0,1007030320,1},1},{{0,1008030320,1},1},{{0,1010030320,1},1}]','[]','[]'),(32080391,0,1000,0,4,0,1,0,'[{{0,1001040320,1},1},{{0,1002040320,1},1},{{0,1003000320,1},1},{{0,1004040320,1},1},{{0,1006040320,1},1},{{0,1007040320,1},1},{{0,1008040320,1},1},{{0,1010040320,1},1}]','[]','[]'),(32080392,0,1000,0,1,0,1,0,'[{{0,1002010320,1},1},{{0,1004010320,1},1},{{0,1006010320,1},1},{{0,1008010320,1},1},{{0,1010010320,1},1}]','[]','[]'),(32080392,0,1000,0,2,0,1,0,'[{{0,1002020320,1},1},{{0,1004020320,1},1},{{0,1006020320,1},1},{{0,1008020320,1},1},{{0,1010020320,1},1}]','[]','[]'),(32080392,0,1000,0,3,0,1,0,'[{{0,1002030320,1},1},{{0,1004030320,1},1},{{0,1006030320,1},1},{{0,1008030320,1},1},{{0,1010030320,1},1}]','[]','[]'),(32080392,0,1000,0,4,0,1,0,'[{{0,1002040320,1},1},{{0,1004040320,1},1},{{0,1006040320,1},1},{{0,1008040320,1},1},{{0,1010040320,1},1}]','[]','[]'),(32080393,0,1000,0,1,0,1,0,'[{{0,1001010320,1},1},{{0,1007010320,1},1}]','[]','[]'),(32080393,0,1000,0,2,0,1,0,'[{{0,1001020320,1},1},{{0,1007020320,1},1}]','[]','[]'),(32080393,0,1000,0,3,0,1,0,'[{{0,1001030320,1},1},{{0,1007030320,1},1}]','[]','[]'),(32080393,0,1000,0,4,0,1,0,'[{{0,1001040320,1},1},{{0,1007040320,1},1}]','[]','[]'),(32080395,0,1000,0,1,0,1,0,'[{{0,1002010320,1},1},{{0,1004010320,1},1},{{0,1006010320,1},1},{{0,1008010320,1},1},{{0,1010010320,1},1},{{0,1001010320,1},1}]','[]','[]'),(32080395,0,1000,0,2,0,1,0,'[{{0,1002020320,1},1},{{0,1004020320,1},1},{{0,1006020320,1},1},{{0,1008020320,1},1},{{0,1010020320,1},1},{{0,1001020320,1},1}]','[]','[]'),(32080395,0,1000,0,3,0,1,0,'[{{0,1002030320,1},1},{{0,1004030320,1},1},{{0,1006030320,1},1},{{0,1008030320,1},1},{{0,1010030320,1},1},{{0,1001030320,1},1}]','[]','[]'),(32080395,0,1000,0,4,0,1,0,'[{{0,1002040320,1},1},{{0,1004040320,1},1},{{0,1006040320,1},1},{{0,1008040320,1},1},{{0,1010040320,1},1},{{0,1001040320,1},1}]','[]','[]'),(32080396,0,1000,0,1,0,1,0,'[{{0,1007010320,1},1},{{0,1003000320,1},1},{{0,1005000320,1},1},{{0,1009000320,1},1}]','[]','[]'),(32080396,0,1000,0,2,0,1,0,'[{{0,1007020320,1},1},{{0,1003000320,1},1},{{0,1005000320,1},1},{{0,1009000320,1},1}]','[]','[]'),(32080396,0,1000,0,3,0,1,0,'[{{0,1007030320,1},1},{{0,1003000320,1},1},{{0,1005000320,1},1},{{0,1009000320,1},1}]','[]','[]'),(32080396,0,1000,0,4,0,1,0,'[{{0,1007040320,1},1},{{0,1003000320,1},1},{{0,1005000320,1},1},{{0,1009000320,1},1}]','[]','[]'),(32080397,0,1000,0,1,0,1,0,'[{{0,1007010320,1},1},{{0,1003000320,1},1}]','[]','[]'),(32080397,0,1000,0,2,0,1,0,'[{{0,1007020320,1},1},{{0,1003000320,1},1}]','[]','[]'),(32080397,0,1000,0,3,0,1,0,'[{{0,1007030320,1},1},{{0,1003000320,1},1}]','[]','[]'),(32080397,0,1000,0,4,0,1,0,'[{{0,1007040320,1},1},{{0,1003000320,1},1}]','[]','[]'),(32080398,0,1000,0,0,0,1,0,'[{{0,1005000320,1},1},{{0,1009000320,1},1}]','[]','[]'),(32080401,0,1000,0,1,0,1,0,'[{{0,1001010331,1},1},{{0,1002010331,1},1},{{0,1003000331,1},1},{{0,1004010331,1},1},{{0,1006010331,1},1},{{0,1007010331,1},1},{{0,1008010331,1},1},{{0,1010010331,1},1}]','[]','[]'),(32080401,0,1000,0,2,0,1,0,'[{{0,1001020331,1},1},{{0,1002020331,1},1},{{0,1003000331,1},1},{{0,1004020331,1},1},{{0,1006020331,1},1},{{0,1007020331,1},1},{{0,1008020331,1},1},{{0,1010020331,1},1}]','[]','[]'),(32080401,0,1000,0,3,0,1,0,'[{{0,1001030331,1},1},{{0,1002030331,1},1},{{0,1003000331,1},1},{{0,1004030331,1},1},{{0,1006030331,1},1},{{0,1007030331,1},1},{{0,1008030331,1},1},{{0,1010030331,1},1}]','[]','[]'),(32080401,0,1000,0,4,0,1,0,'[{{0,1001040331,1},1},{{0,1002040331,1},1},{{0,1003000331,1},1},{{0,1004040331,1},1},{{0,1006040331,1},1},{{0,1007040331,1},1},{{0,1008040331,1},1},{{0,1010040331,1},1}]','[]','[]'),(32080402,0,1000,0,1,0,1,0,'[{{0,1002010331,1},1},{{0,1004010331,1},1},{{0,1006010331,1},1},{{0,1008010331,1},1},{{0,1010010331,1},1}]','[]','[]'),(32080402,0,1000,0,2,0,1,0,'[{{0,1002020331,1},1},{{0,1004020331,1},1},{{0,1006020331,1},1},{{0,1008020331,1},1},{{0,1010020331,1},1}]','[]','[]'),(32080402,0,1000,0,3,0,1,0,'[{{0,1002030331,1},1},{{0,1004030331,1},1},{{0,1006030331,1},1},{{0,1008030331,1},1},{{0,1010030331,1},1}]','[]','[]'),(32080402,0,1000,0,4,0,1,0,'[{{0,1002040331,1},1},{{0,1004040331,1},1},{{0,1006040331,1},1},{{0,1008040331,1},1},{{0,1010040331,1},1}]','[]','[]'),(32080403,0,1000,0,1,0,1,0,'[{{0,1001010331,1},1},{{0,1007010331,1},1}]','[]','[]'),(32080403,0,1000,0,2,0,1,0,'[{{0,1001020331,1},1},{{0,1007020331,1},1}]','[]','[]'),(32080403,0,1000,0,3,0,1,0,'[{{0,1001030331,1},1},{{0,1007030331,1},1}]','[]','[]'),(32080403,0,1000,0,4,0,1,0,'[{{0,1001040331,1},1},{{0,1007040331,1},1}]','[]','[]'),(32080405,0,1000,0,1,0,1,0,'[{{0,1002010331,1},1},{{0,1004010331,1},1},{{0,1006010331,1},1},{{0,1008010331,1},1},{{0,1010010331,1},1},{{0,1001010331,1},1}]','[]','[]'),(32080405,0,1000,0,2,0,1,0,'[{{0,1002020331,1},1},{{0,1004020331,1},1},{{0,1006020331,1},1},{{0,1008020331,1},1},{{0,1010020331,1},1},{{0,1001020331,1},1}]','[]','[]'),(32080405,0,1000,0,3,0,1,0,'[{{0,1002030331,1},1},{{0,1004030331,1},1},{{0,1006030331,1},1},{{0,1008030331,1},1},{{0,1010030331,1},1},{{0,1001030331,1},1}]','[]','[]'),(32080405,0,1000,0,4,0,1,0,'[{{0,1002040331,1},1},{{0,1004040331,1},1},{{0,1006040331,1},1},{{0,1008040331,1},1},{{0,1010040331,1},1},{{0,1001040331,1},1}]','[]','[]'),(32080406,0,1000,0,1,0,1,0,'[{{0,1007010331,1},1},{{0,1003000331,1},1},{{0,1005000331,1},1},{{0,1009000331,1},1}]','[]','[]'),(32080406,0,1000,0,2,0,1,0,'[{{0,1007020331,1},1},{{0,1003000331,1},1},{{0,1005000331,1},1},{{0,1009000331,1},1}]','[]','[]'),(32080406,0,1000,0,3,0,1,0,'[{{0,1007030331,1},1},{{0,1003000331,1},1},{{0,1005000331,1},1},{{0,1009000331,1},1}]','[]','[]'),(32080406,0,1000,0,4,0,1,0,'[{{0,1007040331,1},1},{{0,1003000331,1},1},{{0,1005000331,1},1},{{0,1009000331,1},1}]','[]','[]'),(32080407,0,1000,0,1,0,1,0,'[{{0,1007010331,1},1},{{0,1003000331,1},1}]','[]','[]'),(32080407,0,1000,0,2,0,1,0,'[{{0,1007020331,1},1},{{0,1003000331,1},1}]','[]','[]'),(32080407,0,1000,0,3,0,1,0,'[{{0,1007030331,1},1},{{0,1003000331,1},1}]','[]','[]'),(32080407,0,1000,0,4,0,1,0,'[{{0,1007040331,1},1},{{0,1003000331,1},1}]','[]','[]'),(32080408,0,1000,0,0,0,1,0,'[{{0,1005000331,1},1},{{0,1009000331,1},1}]','[]','[]'),(32080411,0,1000,0,1,0,1,0,'[{{0,1001010432,1},1},{{0,1002010432,1},1},{{0,1003000432,1},1},{{0,1004010432,1},1},{{0,1006010432,1},1},{{0,1007010432,1},1},{{0,1008010432,1},1},{{0,1010010432,1},1}]','[]','[1001010432,1002010432,1003000432,1004010432,1005000432,1006010432,1007010432,1008010432,1009000432,1010010432]'),(32080411,0,1000,0,2,0,1,0,'[{{0,1001020432,1},1},{{0,1002020432,1},1},{{0,1003000432,1},1},{{0,1004020432,1},1},{{0,1006020432,1},1},{{0,1007020432,1},1},{{0,1008020432,1},1},{{0,1010020432,1},1}]','[]','[1001020432,1002020432,1003000432,1004020432,1005000432,1006020432,1007020432,1008020432,1009000432,1010020432]'),(32080411,0,1000,0,3,0,1,0,'[{{0,1001030432,1},1},{{0,1002030432,1},1},{{0,1003000432,1},1},{{0,1004030432,1},1},{{0,1006030432,1},1},{{0,1007030432,1},1},{{0,1008030432,1},1},{{0,1010030432,1},1}]','[]','[1001030432,1002030432,1003000432,1004030432,1005000432,1006030432,1007030432,1008030432,1009000432,1010030432]'),(32080411,0,1000,0,4,0,1,0,'[{{0,1001040432,1},1},{{0,1002040432,1},1},{{0,1003000432,1},1},{{0,1004040432,1},1},{{0,1006040432,1},1},{{0,1007040432,1},1},{{0,1008040432,1},1},{{0,1010040432,1},1}]','[]','[1001040432,1002040432,1003000432,1004040432,1005000432,1006040432,1007040432,1008040432,1009000432,1010040432]'),(32080412,0,1000,0,1,0,1,0,'[{{0,1002010432,1},1},{{0,1004010432,1},1},{{0,1006010432,1},1},{{0,1008010432,1},1},{{0,1010010432,1},1}]','[]','[1002010432,1004010432,1006010432,1008010432,1010010432]'),(32080412,0,1000,0,2,0,1,0,'[{{0,1002020432,1},1},{{0,1004020432,1},1},{{0,1006020432,1},1},{{0,1008020432,1},1},{{0,1010020432,1},1}]','[]','[1002020432,1004020432,1006020432,1008020432,1010020432]'),(32080412,0,1000,0,3,0,1,0,'[{{0,1002030432,1},1},{{0,1004030432,1},1},{{0,1006030432,1},1},{{0,1008030432,1},1},{{0,1010030432,1},1}]','[]','[1002030432,1004030432,1006030432,1008030432,1010030432]'),(32080412,0,1000,0,4,0,1,0,'[{{0,1002040432,1},1},{{0,1004040432,1},1},{{0,1006040432,1},1},{{0,1008040432,1},1},{{0,1010040432,1},1}]','[]','[1002040432,1004040432,1006040432,1008040432,1010040432]'),(32080413,0,1000,0,1,0,1,0,'[{{0,1001010432,1},1},{{0,1007010432,1},1}]','[]','[1001010432,1007010432]'),(32080413,0,1000,0,2,0,1,0,'[{{0,1001020432,1},1},{{0,1007020432,1},1}]','[]','[1001020432,1007020432]'),(32080413,0,1000,0,3,0,1,0,'[{{0,1001030432,1},1},{{0,1007030432,1},1}]','[]','[1001030432,1007030432]'),(32080413,0,1000,0,4,0,1,0,'[{{0,1001040432,1},1},{{0,1007040432,1},1}]','[]','[1001040432,1007040432]'),(32080415,0,1000,0,1,0,1,0,'[{{0,1002010432,1},1},{{0,1004010432,1},1},{{0,1006010432,1},1},{{0,1008010432,1},1},{{0,1010010432,1},1},{{0,1001010432,1},1}]','[]','[1002010432,1004010432,1006010432,1008010432,1010010432,1001010432]'),(32080415,0,1000,0,2,0,1,0,'[{{0,1002020432,1},1},{{0,1004020432,1},1},{{0,1006020432,1},1},{{0,1008020432,1},1},{{0,1010020432,1},1},{{0,1001020432,1},1}]','[]','[1002020432,1004020432,1006020432,1008020432,1010020432,1001020432]'),(32080415,0,1000,0,3,0,1,0,'[{{0,1002030432,1},1},{{0,1004030432,1},1},{{0,1006030432,1},1},{{0,1008030432,1},1},{{0,1010030432,1},1},{{0,1001030432,1},1}]','[]','[1002030432,1004030432,1006030432,1008030432,1010030432,1001030432]'),(32080415,0,1000,0,4,0,1,0,'[{{0,1002040432,1},1},{{0,1004040432,1},1},{{0,1006040432,1},1},{{0,1008040432,1},1},{{0,1010040432,1},1},{{0,1001040432,1},1}]','[]','[1002040432,1004040432,1006040432,1008040432,1010040432,1001040432]'),(32080416,0,1000,0,1,0,1,0,'[{{0,1007010432,1},1},{{0,1003000432,1},1},{{0,1005000432,1},1},{{0,1009000432,1},1}]','[]','[1007010432,1003000432,1005000432,1009000432]'),(32080416,0,1000,0,2,0,1,0,'[{{0,1007020432,1},1},{{0,1003000432,1},1},{{0,1005000432,1},1},{{0,1009000432,1},1}]','[]','[1007020432,1003000432,1005000432,1009000432]'),(32080416,0,1000,0,3,0,1,0,'[{{0,1007030432,1},1},{{0,1003000432,1},1},{{0,1005000432,1},1},{{0,1009000432,1},1}]','[]','[1007030432,1003000432,1005000432,1009000432]'),(32080416,0,1000,0,4,0,1,0,'[{{0,1007040432,1},1},{{0,1003000432,1},1},{{0,1005000432,1},1},{{0,1009000432,1},1}]','[]','[1007040432,1003000432,1005000432,1009000432]'),(32080417,0,1000,0,1,0,1,0,'[{{0,1007010432,1},1},{{0,1003000432,1},1}]','[]','[1007010432,1003000432]'),(32080417,0,1000,0,2,0,1,0,'[{{0,1007020432,1},1},{{0,1003000432,1},1}]','[]','[1007020432,1003000432]'),(32080417,0,1000,0,3,0,1,0,'[{{0,1007030432,1},1},{{0,1003000432,1},1}]','[]','[1007030432,1003000432]'),(32080417,0,1000,0,4,0,1,0,'[{{0,1007040432,1},1},{{0,1003000432,1},1}]','[]','[1007040432,1003000432]'),(32080418,0,1000,0,0,0,1,0,'[{{0,1005000432,1},1},{{0,1009000432,1},1}]','[]','[1005000432,1009000432]'),(32080421,0,1000,0,1,0,1,0,'[{{0,1001010441,1},1},{{0,1002010441,1},1},{{0,1003000441,1},1},{{0,1004010441,1},1},{{0,1006010441,1},1},{{0,1007010441,1},1},{{0,1008010441,1},1},{{0,1010010441,1},1}]','[]','[]'),(32080421,0,1000,0,2,0,1,0,'[{{0,1001020441,1},1},{{0,1002020441,1},1},{{0,1003000441,1},1},{{0,1004020441,1},1},{{0,1006020441,1},1},{{0,1007020441,1},1},{{0,1008020441,1},1},{{0,1010020441,1},1}]','[]','[]'),(32080421,0,1000,0,3,0,1,0,'[{{0,1001030441,1},1},{{0,1002030441,1},1},{{0,1003000441,1},1},{{0,1004030441,1},1},{{0,1006030441,1},1},{{0,1007030441,1},1},{{0,1008030441,1},1},{{0,1010030441,1},1}]','[]','[]'),(32080421,0,1000,0,4,0,1,0,'[{{0,1001040441,1},1},{{0,1002040441,1},1},{{0,1003000441,1},1},{{0,1004040441,1},1},{{0,1006040441,1},1},{{0,1007040441,1},1},{{0,1008040441,1},1},{{0,1010040441,1},1}]','[]','[]'),(32080422,0,1000,0,1,0,1,0,'[{{0,1002010441,1},1},{{0,1004010441,1},1},{{0,1006010441,1},1},{{0,1008010441,1},1},{{0,1010010441,1},1}]','[]','[]'),(32080422,0,1000,0,2,0,1,0,'[{{0,1002020441,1},1},{{0,1004020441,1},1},{{0,1006020441,1},1},{{0,1008020441,1},1},{{0,1010020441,1},1}]','[]','[]'),(32080422,0,1000,0,3,0,1,0,'[{{0,1002030441,1},1},{{0,1004030441,1},1},{{0,1006030441,1},1},{{0,1008030441,1},1},{{0,1010030441,1},1}]','[]','[]'),(32080422,0,1000,0,4,0,1,0,'[{{0,1002040441,1},1},{{0,1004040441,1},1},{{0,1006040441,1},1},{{0,1008040441,1},1},{{0,1010040441,1},1}]','[]','[]'),(32080423,0,1000,0,1,0,1,0,'[{{0,1001010441,1},1},{{0,1007010441,1},1}]','[]','[]'),(32080423,0,1000,0,2,0,1,0,'[{{0,1001020441,1},1},{{0,1007020441,1},1}]','[]','[]'),(32080423,0,1000,0,3,0,1,0,'[{{0,1001030441,1},1},{{0,1007030441,1},1}]','[]','[]'),(32080423,0,1000,0,4,0,1,0,'[{{0,1001040441,1},1},{{0,1007040441,1},1}]','[]','[]'),(32080425,0,1000,0,1,0,1,0,'[{{0,1002010441,1},1},{{0,1004010441,1},1},{{0,1006010441,1},1},{{0,1008010441,1},1},{{0,1010010441,1},1},{{0,1001010441,1},1}]','[]','[]'),(32080425,0,1000,0,2,0,1,0,'[{{0,1002020441,1},1},{{0,1004020441,1},1},{{0,1006020441,1},1},{{0,1008020441,1},1},{{0,1010020441,1},1},{{0,1001020441,1},1}]','[]','[]'),(32080425,0,1000,0,3,0,1,0,'[{{0,1002030441,1},1},{{0,1004030441,1},1},{{0,1006030441,1},1},{{0,1008030441,1},1},{{0,1010030441,1},1},{{0,1001030441,1},1}]','[]','[]'),(32080425,0,1000,0,4,0,1,0,'[{{0,1002040441,1},1},{{0,1004040441,1},1},{{0,1006040441,1},1},{{0,1008040441,1},1},{{0,1010040441,1},1},{{0,1001040441,1},1}]','[]','[]'),(32080426,0,1000,0,1,0,1,0,'[{{0,1007010441,1},1},{{0,1003000441,1},1},{{0,1005000441,1},1},{{0,1009000441,1},1}]','[]','[]'),(32080426,0,1000,0,2,0,1,0,'[{{0,1007020441,1},1},{{0,1003000441,1},1},{{0,1005000441,1},1},{{0,1009000441,1},1}]','[]','[]'),(32080426,0,1000,0,3,0,1,0,'[{{0,1007030441,1},1},{{0,1003000441,1},1},{{0,1005000441,1},1},{{0,1009000441,1},1}]','[]','[]'),(32080426,0,1000,0,4,0,1,0,'[{{0,1007040441,1},1},{{0,1003000441,1},1},{{0,1005000441,1},1},{{0,1009000441,1},1}]','[]','[]'),(32080427,0,1000,0,1,0,1,0,'[{{0,1007010441,1},1},{{0,1003000441,1},1}]','[]','[]'),(32080427,0,1000,0,2,0,1,0,'[{{0,1007020441,1},1},{{0,1003000441,1},1}]','[]','[]'),(32080427,0,1000,0,3,0,1,0,'[{{0,1007030441,1},1},{{0,1003000441,1},1}]','[]','[]'),(32080427,0,1000,0,4,0,1,0,'[{{0,1007040441,1},1},{{0,1003000441,1},1}]','[]','[]'),(32080428,0,1000,0,0,0,1,0,'[{{0,1005000441,1},1},{{0,1009000441,1},1}]','[]','[]'),(32080431,0,1000,0,1,0,1,0,'[{{0,1001010442,1},1},{{0,1002010442,1},1},{{0,1003000442,1},1},{{0,1004010442,1},1},{{0,1006010442,1},1},{{0,1007010442,1},1},{{0,1008010442,1},1},{{0,1010010442,1},1}]','[]','[1001010442,1002010442,1003000442,1004010442,1005000442,1006010442,1007010442,1008010442,1009000442,1010010442]'),(32080431,0,1000,0,2,0,1,0,'[{{0,1001020442,1},1},{{0,1002020442,1},1},{{0,1003000442,1},1},{{0,1004020442,1},1},{{0,1006020442,1},1},{{0,1007020442,1},1},{{0,1008020442,1},1},{{0,1010020442,1},1}]','[]','[1001020442,1002020442,1003000442,1004020442,1005000442,1006020442,1007020442,1008020442,1009000442,1010020442]'),(32080431,0,1000,0,3,0,1,0,'[{{0,1001030442,1},1},{{0,1002030442,1},1},{{0,1003000442,1},1},{{0,1004030442,1},1},{{0,1006030442,1},1},{{0,1007030442,1},1},{{0,1008030442,1},1},{{0,1010030442,1},1}]','[]','[1001030442,1002030442,1003000442,1004030442,1005000442,1006030442,1007030442,1008030442,1009000442,1010030442]'),(32080431,0,1000,0,4,0,1,0,'[{{0,1001040442,1},1},{{0,1002040442,1},1},{{0,1003000442,1},1},{{0,1004040442,1},1},{{0,1006040442,1},1},{{0,1007040442,1},1},{{0,1008040442,1},1},{{0,1010040442,1},1}]','[]','[1001040442,1002040442,1003000442,1004040442,1005000442,1006040442,1007040442,1008040442,1009000442,1010040442]'),(32080432,0,1000,0,1,0,1,0,'[{{0,1002010442,1},1},{{0,1004010442,1},1},{{0,1006010442,1},1},{{0,1008010442,1},1},{{0,1010010442,1},1}]','[]','[1002010442,1004010442,1006010442,1008010442,1010010442]'),(32080432,0,1000,0,2,0,1,0,'[{{0,1002020442,1},1},{{0,1004020442,1},1},{{0,1006020442,1},1},{{0,1008020442,1},1},{{0,1010020442,1},1}]','[]','[1002020442,1004020442,1006020442,1008020442,1010020442]'),(32080432,0,1000,0,3,0,1,0,'[{{0,1002030442,1},1},{{0,1004030442,1},1},{{0,1006030442,1},1},{{0,1008030442,1},1},{{0,1010030442,1},1}]','[]','[1002030442,1004030442,1006030442,1008030442,1010030442]'),(32080432,0,1000,0,4,0,1,0,'[{{0,1002040442,1},1},{{0,1004040442,1},1},{{0,1006040442,1},1},{{0,1008040442,1},1},{{0,1010040442,1},1}]','[]','[1002040442,1004040442,1006040442,1008040442,1010040442]'),(32080433,0,1000,0,1,0,1,0,'[{{0,1001010442,1},1},{{0,1007010442,1},1}]','[]','[1001010442,1007010442]'),(32080433,0,1000,0,2,0,1,0,'[{{0,1001020442,1},1},{{0,1007020442,1},1}]','[]','[1001020442,1007020442]'),(32080433,0,1000,0,3,0,1,0,'[{{0,1001030442,1},1},{{0,1007030442,1},1}]','[]','[1001030442,1007030442]'),(32080433,0,1000,0,4,0,1,0,'[{{0,1001040442,1},1},{{0,1007040442,1},1}]','[]','[1001040442,1007040442]'),(32080435,0,1000,0,1,0,1,0,'[{{0,1002010442,1},1},{{0,1004010442,1},1},{{0,1006010442,1},1},{{0,1008010442,1},1},{{0,1010010442,1},1},{{0,1001010442,1},1}]','[]','[1002010442,1004010442,1006010442,1008010442,1010010442,1001010442]'),(32080435,0,1000,0,2,0,1,0,'[{{0,1002020442,1},1},{{0,1004020442,1},1},{{0,1006020442,1},1},{{0,1008020442,1},1},{{0,1010020442,1},1},{{0,1001020442,1},1}]','[]','[1002020442,1004020442,1006020442,1008020442,1010020442,1001020442]'),(32080435,0,1000,0,3,0,1,0,'[{{0,1002030442,1},1},{{0,1004030442,1},1},{{0,1006030442,1},1},{{0,1008030442,1},1},{{0,1010030442,1},1},{{0,1001030442,1},1}]','[]','[1002030442,1004030442,1006030442,1008030442,1010030442,1001030442]'),(32080435,0,1000,0,4,0,1,0,'[{{0,1002040442,1},1},{{0,1004040442,1},1},{{0,1006040442,1},1},{{0,1008040442,1},1},{{0,1010040442,1},1},{{0,1001040442,1},1}]','[]','[1002040442,1004040442,1006040442,1008040442,1010040442,1001040442]'),(32080436,0,1000,0,1,0,1,0,'[{{0,1007010442,1},1},{{0,1003000442,1},1},{{0,1005000442,1},1},{{0,1009000442,1},1}]','[]','[1007010442,1003000442,1005000442,1009000442]'),(32080436,0,1000,0,2,0,1,0,'[{{0,1007020442,1},1},{{0,1003000442,1},1},{{0,1005000442,1},1},{{0,1009000442,1},1}]','[]','[1007020442,1003000442,1005000442,1009000442]'),(32080436,0,1000,0,3,0,1,0,'[{{0,1007030442,1},1},{{0,1003000442,1},1},{{0,1005000442,1},1},{{0,1009000442,1},1}]','[]','[1007030442,1003000442,1005000442,1009000442]'),(32080436,0,1000,0,4,0,1,0,'[{{0,1007040442,1},1},{{0,1003000442,1},1},{{0,1005000442,1},1},{{0,1009000442,1},1}]','[]','[1007040442,1003000442,1005000442,1009000442]'),(32080437,0,1000,0,1,0,1,0,'[{{0,1007010442,1},1},{{0,1003000442,1},1}]','[]','[1007010442,1003000442]'),(32080437,0,1000,0,2,0,1,0,'[{{0,1007020442,1},1},{{0,1003000442,1},1}]','[]','[1007020442,1003000442]'),(32080437,0,1000,0,3,0,1,0,'[{{0,1007030442,1},1},{{0,1003000442,1},1}]','[]','[1007030442,1003000442]'),(32080437,0,1000,0,4,0,1,0,'[{{0,1007040442,1},1},{{0,1003000442,1},1}]','[]','[1007040442,1003000442]'),(32080438,0,1000,0,0,0,1,0,'[{{0,1005000442,1},1},{{0,1009000442,1},1}]','[]','[1005000442,1009000442]'),(32080441,0,1000,0,1,0,1,0,'[{{0,1001010443,1},1},{{0,1002010443,1},1},{{0,1003000443,1},1},{{0,1004010443,1},1},{{0,1006010443,1},1},{{0,1007010443,1},1},{{0,1008010443,1},1},{{0,1010010443,1},1}]','[]','[1001010443,1002010443,1003000443,1004010443,1005000443,1006010443,1007010443,1008010443,1009000443,1010010443]'),(32080441,0,1000,0,2,0,1,0,'[{{0,1001020443,1},1},{{0,1002020443,1},1},{{0,1003000443,1},1},{{0,1004020443,1},1},{{0,1006020443,1},1},{{0,1007020443,1},1},{{0,1008020443,1},1},{{0,1010020443,1},1}]','[]','[1001020443,1002020443,1003000443,1004020443,1005000443,1006020443,1007020443,1008020443,1009000443,1010020443]'),(32080441,0,1000,0,3,0,1,0,'[{{0,1001030443,1},1},{{0,1002030443,1},1},{{0,1003000443,1},1},{{0,1004030443,1},1},{{0,1006030443,1},1},{{0,1007030443,1},1},{{0,1008030443,1},1},{{0,1010030443,1},1}]','[]','[1001030443,1002030443,1003000443,1004030443,1005000443,1006030443,1007030443,1008030443,1009000443,1010030443]'),(32080441,0,1000,0,4,0,1,0,'[{{0,1001040443,1},1},{{0,1002040443,1},1},{{0,1003000443,1},1},{{0,1004040443,1},1},{{0,1006040443,1},1},{{0,1007040443,1},1},{{0,1008040443,1},1},{{0,1010040443,1},1}]','[]','[1001040443,1002040443,1003000443,1004040443,1005000443,1006040443,1007040443,1008040443,1009000443,1010040443]'),(32080442,0,1000,0,1,0,1,0,'[{{0,1002010443,1},1},{{0,1004010443,1},1},{{0,1006010443,1},1},{{0,1008010443,1},1},{{0,1010010443,1},1}]','[]','[1002010443,1004010443,1006010443,1008010443,1010010443]'),(32080442,0,1000,0,2,0,1,0,'[{{0,1002020443,1},1},{{0,1004020443,1},1},{{0,1006020443,1},1},{{0,1008020443,1},1},{{0,1010020443,1},1}]','[]','[1002020443,1004020443,1006020443,1008020443,1010020443]'),(32080442,0,1000,0,3,0,1,0,'[{{0,1002030443,1},1},{{0,1004030443,1},1},{{0,1006030443,1},1},{{0,1008030443,1},1},{{0,1010030443,1},1}]','[]','[1002030443,1004030443,1006030443,1008030443,1010030443]'),(32080442,0,1000,0,4,0,1,0,'[{{0,1002040443,1},1},{{0,1004040443,1},1},{{0,1006040443,1},1},{{0,1008040443,1},1},{{0,1010040443,1},1}]','[]','[1002040443,1004040443,1006040443,1008040443,1010040443]'),(32080443,0,1000,0,1,0,1,0,'[{{0,1001010443,1},1},{{0,1007010443,1},1}]','[]','[1001010443,1007010443]'),(32080443,0,1000,0,2,0,1,0,'[{{0,1001020443,1},1},{{0,1007020443,1},1}]','[]','[1001020443,1007020443]'),(32080443,0,1000,0,3,0,1,0,'[{{0,1001030443,1},1},{{0,1007030443,1},1}]','[]','[1001030443,1007030443]'),(32080443,0,1000,0,4,0,1,0,'[{{0,1001040443,1},1},{{0,1007040443,1},1}]','[]','[1001040443,1007040443]'),(32080445,0,1000,0,1,0,1,0,'[{{0,1002010443,1},1},{{0,1004010443,1},1},{{0,1006010443,1},1},{{0,1008010443,1},1},{{0,1010010443,1},1},{{0,1001010443,1},1}]','[]','[1002010443,1004010443,1006010443,1008010443,1010010443,1001010443]'),(32080445,0,1000,0,2,0,1,0,'[{{0,1002020443,1},1},{{0,1004020443,1},1},{{0,1006020443,1},1},{{0,1008020443,1},1},{{0,1010020443,1},1},{{0,1001020443,1},1}]','[]','[1002020443,1004020443,1006020443,1008020443,1010020443,1001020443]'),(32080445,0,1000,0,3,0,1,0,'[{{0,1002030443,1},1},{{0,1004030443,1},1},{{0,1006030443,1},1},{{0,1008030443,1},1},{{0,1010030443,1},1},{{0,1001030443,1},1}]','[]','[1002030443,1004030443,1006030443,1008030443,1010030443,1001030443]'),(32080445,0,1000,0,4,0,1,0,'[{{0,1002040443,1},1},{{0,1004040443,1},1},{{0,1006040443,1},1},{{0,1008040443,1},1},{{0,1010040443,1},1},{{0,1001040443,1},1}]','[]','[1002040443,1004040443,1006040443,1008040443,1010040443,1001040443]'),(32080446,0,1000,0,1,0,1,0,'[{{0,1007010443,1},1},{{0,1003000443,1},1},{{0,1005000443,1},1},{{0,1009000443,1},1}]','[]','[1007010443,1003000443,1005000443,1009000443]'),(32080446,0,1000,0,2,0,1,0,'[{{0,1007020443,1},1},{{0,1003000443,1},1},{{0,1005000443,1},1},{{0,1009000443,1},1}]','[]','[1007020443,1003000443,1005000443,1009000443]'),(32080446,0,1000,0,3,0,1,0,'[{{0,1007030443,1},1},{{0,1003000443,1},1},{{0,1005000443,1},1},{{0,1009000443,1},1}]','[]','[1007030443,1003000443,1005000443,1009000443]'),(32080446,0,1000,0,4,0,1,0,'[{{0,1007040443,1},1},{{0,1003000443,1},1},{{0,1005000443,1},1},{{0,1009000443,1},1}]','[]','[1007040443,1003000443,1005000443,1009000443]'),(32080447,0,1000,0,1,0,1,0,'[{{0,1007010443,1},1},{{0,1003000443,1},1}]','[]','[1007010443,1003000443]'),(32080447,0,1000,0,2,0,1,0,'[{{0,1007020443,1},1},{{0,1003000443,1},1}]','[]','[1007020443,1003000443]'),(32080447,0,1000,0,3,0,1,0,'[{{0,1007030443,1},1},{{0,1003000443,1},1}]','[]','[1007030443,1003000443]'),(32080447,0,1000,0,4,0,1,0,'[{{0,1007040443,1},1},{{0,1003000443,1},1}]','[]','[1007040443,1003000443]'),(32080448,0,1000,0,0,0,1,0,'[{{0,1005000443,1},1},{{0,1009000443,1},1}]','[]','[1005000443,1009000443]'),(32080451,0,1000,0,1,0,1,0,'[{{0,1001010453,1},1},{{0,1002010453,1},1},{{0,1003000453,1},1},{{0,1004010453,1},1},{{0,1006010453,1},1},{{0,1007010453,1},1},{{0,1008010453,1},1},{{0,1010010453,1},1}]','[]','[1001010453,1002010453,1003000453,1004010453,1005000453,1006010453,1007010453,1008010453,1009000453,1010010453]'),(32080451,0,1000,0,2,0,1,0,'[{{0,1001020453,1},1},{{0,1002020453,1},1},{{0,1003000453,1},1},{{0,1004020453,1},1},{{0,1006020453,1},1},{{0,1007020453,1},1},{{0,1008020453,1},1},{{0,1010020453,1},1}]','[]','[1001020453,1002020453,1003000453,1004020453,1005000453,1006020453,1007020453,1008020453,1009000453,1010020453]'),(32080451,0,1000,0,3,0,1,0,'[{{0,1001030453,1},1},{{0,1002030453,1},1},{{0,1003000453,1},1},{{0,1004030453,1},1},{{0,1006030453,1},1},{{0,1007030453,1},1},{{0,1008030453,1},1},{{0,1010030453,1},1}]','[]','[1001030453,1002030453,1003000453,1004030453,1005000453,1006030453,1007030453,1008030453,1009000453,1010030453]'),(32080451,0,1000,0,4,0,1,0,'[{{0,1001040453,1},1},{{0,1002040453,1},1},{{0,1003000453,1},1},{{0,1004040453,1},1},{{0,1006040453,1},1},{{0,1007040453,1},1},{{0,1008040453,1},1},{{0,1010040453,1},1}]','[]','[1001040453,1002040453,1003000453,1004040453,1005000453,1006040453,1007040453,1008040453,1009000453,1010040453]'),(32080452,0,1000,0,1,0,1,0,'[{{0,1002010453,1},1},{{0,1004010453,1},1},{{0,1006010453,1},1},{{0,1008010453,1},1},{{0,1010010453,1},1}]','[]','[1002010453,1004010453,1006010453,1008010453,1010010453]'),(32080452,0,1000,0,2,0,1,0,'[{{0,1002020453,1},1},{{0,1004020453,1},1},{{0,1006020453,1},1},{{0,1008020453,1},1},{{0,1010020453,1},1}]','[]','[1002020453,1004020453,1006020453,1008020453,1010020453]'),(32080452,0,1000,0,3,0,1,0,'[{{0,1002030453,1},1},{{0,1004030453,1},1},{{0,1006030453,1},1},{{0,1008030453,1},1},{{0,1010030453,1},1}]','[]','[1002030453,1004030453,1006030453,1008030453,1010030453]'),(32080452,0,1000,0,4,0,1,0,'[{{0,1002040453,1},1},{{0,1004040453,1},1},{{0,1006040453,1},1},{{0,1008040453,1},1},{{0,1010040453,1},1}]','[]','[1002040453,1004040453,1006040453,1008040453,1010040453]'),(32080453,0,1000,0,1,0,1,0,'[{{0,1001010453,1},1},{{0,1007010453,1},1}]','[]','[1001010453,1007010453]'),(32080453,0,1000,0,2,0,1,0,'[{{0,1001020453,1},1},{{0,1007020453,1},1}]','[]','[1001020453,1007020453]'),(32080453,0,1000,0,3,0,1,0,'[{{0,1001030453,1},1},{{0,1007030453,1},1}]','[]','[1001030453,1007030453]'),(32080453,0,1000,0,4,0,1,0,'[{{0,1001040453,1},1},{{0,1007040453,1},1}]','[]','[1001040453,1007040453]'),(32080455,0,1000,0,1,0,1,0,'[{{0,1002010453,1},1},{{0,1004010453,1},1},{{0,1006010453,1},1},{{0,1008010453,1},1},{{0,1010010453,1},1},{{0,1001010453,1},1}]','[]','[1002010453,1004010453,1006010453,1008010453,1010010453,1001010453]'),(32080455,0,1000,0,2,0,1,0,'[{{0,1002020453,1},1},{{0,1004020453,1},1},{{0,1006020453,1},1},{{0,1008020453,1},1},{{0,1010020453,1},1},{{0,1001020453,1},1}]','[]','[1002020453,1004020453,1006020453,1008020453,1010020453,1001020453]'),(32080455,0,1000,0,3,0,1,0,'[{{0,1002030453,1},1},{{0,1004030453,1},1},{{0,1006030453,1},1},{{0,1008030453,1},1},{{0,1010030453,1},1},{{0,1001030453,1},1}]','[]','[1002030453,1004030453,1006030453,1008030453,1010030453,1001030453]'),(32080455,0,1000,0,4,0,1,0,'[{{0,1002040453,1},1},{{0,1004040453,1},1},{{0,1006040453,1},1},{{0,1008040453,1},1},{{0,1010040453,1},1},{{0,1001040453,1},1}]','[]','[1002040453,1004040453,1006040453,1008040453,1010040453,1001040453]'),(32080456,0,1000,0,1,0,1,0,'[{{0,1007010453,1},1},{{0,1003000453,1},1},{{0,1005000453,1},1},{{0,1009000453,1},1}]','[]','[1007010453,1003000453,1005000453,1009000453]'),(32080456,0,1000,0,2,0,1,0,'[{{0,1007020453,1},1},{{0,1003000453,1},1},{{0,1005000453,1},1},{{0,1009000453,1},1}]','[]','[1007020453,1003000453,1005000453,1009000453]'),(32080456,0,1000,0,3,0,1,0,'[{{0,1007030453,1},1},{{0,1003000453,1},1},{{0,1005000453,1},1},{{0,1009000453,1},1}]','[]','[1007030453,1003000453,1005000453,1009000453]'),(32080456,0,1000,0,4,0,1,0,'[{{0,1007040453,1},1},{{0,1003000453,1},1},{{0,1005000453,1},1},{{0,1009000453,1},1}]','[]','[1007040453,1003000453,1005000453,1009000453]'),(32080457,0,1000,0,1,0,1,0,'[{{0,1007010453,1},1},{{0,1003000453,1},1}]','[]','[1007010453,1003000453]'),(32080457,0,1000,0,2,0,1,0,'[{{0,1007020453,1},1},{{0,1003000453,1},1}]','[]','[1007020453,1003000453]'),(32080457,0,1000,0,3,0,1,0,'[{{0,1007030453,1},1},{{0,1003000453,1},1}]','[]','[1007030453,1003000453]'),(32080457,0,1000,0,4,0,1,0,'[{{0,1007040453,1},1},{{0,1003000453,1},1}]','[]','[1007040453,1003000453]'),(32080458,0,1000,0,0,0,1,0,'[{{0,1005000453,1},1},{{0,1009000453,1},1}]','[]','[1005000453,1009000453]'),(32080461,0,1000,0,1,0,1,0,'[{{0,1001010463,1},1},{{0,1002010463,1},1},{{0,1003000463,1},1},{{0,1004010463,1},1},{{0,1006010463,1},1},{{0,1007010463,1},1},{{0,1008010463,1},1},{{0,1010010463,1},1}]','[]','[1001010463,1002010463,1003000463,1004010463,1005000463,1006010463,1007010463,1008010463,1009000463,1010010463]'),(32080461,0,1000,0,2,0,1,0,'[{{0,1001020463,1},1},{{0,1002020463,1},1},{{0,1003000463,1},1},{{0,1004020463,1},1},{{0,1006020463,1},1},{{0,1007020463,1},1},{{0,1008020463,1},1},{{0,1010020463,1},1}]','[]','[1001020463,1002020463,1003000463,1004020463,1005000463,1006020463,1007020463,1008020463,1009000463,1010020463]'),(32080461,0,1000,0,3,0,1,0,'[{{0,1001030463,1},1},{{0,1002030463,1},1},{{0,1003000463,1},1},{{0,1004030463,1},1},{{0,1006030463,1},1},{{0,1007030463,1},1},{{0,1008030463,1},1},{{0,1010030463,1},1}]','[]','[1001030463,1002030463,1003000463,1004030463,1005000463,1006030463,1007030463,1008030463,1009000463,1010030463]'),(32080461,0,1000,0,4,0,1,0,'[{{0,1001040463,1},1},{{0,1002040463,1},1},{{0,1003000463,1},1},{{0,1004040463,1},1},{{0,1006040463,1},1},{{0,1007040463,1},1},{{0,1008040463,1},1},{{0,1010040463,1},1}]','[]','[1001040463,1002040463,1003000463,1004040463,1005000463,1006040463,1007040463,1008040463,1009000463,1010040463]'),(32080462,0,1000,0,1,0,1,0,'[{{0,1002010463,1},1},{{0,1004010463,1},1},{{0,1006010463,1},1},{{0,1008010463,1},1},{{0,1010010463,1},1}]','[]','[1002010463,1004010463,1006010463,1008010463,1010010463]'),(32080462,0,1000,0,2,0,1,0,'[{{0,1002020463,1},1},{{0,1004020463,1},1},{{0,1006020463,1},1},{{0,1008020463,1},1},{{0,1010020463,1},1}]','[]','[1002020463,1004020463,1006020463,1008020463,1010020463]'),(32080462,0,1000,0,3,0,1,0,'[{{0,1002030463,1},1},{{0,1004030463,1},1},{{0,1006030463,1},1},{{0,1008030463,1},1},{{0,1010030463,1},1}]','[]','[1002030463,1004030463,1006030463,1008030463,1010030463]'),(32080462,0,1000,0,4,0,1,0,'[{{0,1002040463,1},1},{{0,1004040463,1},1},{{0,1006040463,1},1},{{0,1008040463,1},1},{{0,1010040463,1},1}]','[]','[1002040463,1004040463,1006040463,1008040463,1010040463]'),(32080463,0,1000,0,1,0,1,0,'[{{0,1001010463,1},1},{{0,1007010463,1},1}]','[]','[1001010463,1007010463]'),(32080463,0,1000,0,2,0,1,0,'[{{0,1001020463,1},1},{{0,1007020463,1},1}]','[]','[1001020463,1007020463]'),(32080463,0,1000,0,3,0,1,0,'[{{0,1001030463,1},1},{{0,1007030463,1},1}]','[]','[1001030463,1007030463]'),(32080463,0,1000,0,4,0,1,0,'[{{0,1001040463,1},1},{{0,1007040463,1},1}]','[]','[1001040463,1007040463]'),(32080465,0,1000,0,1,0,1,0,'[{{0,1002010463,1},1},{{0,1004010463,1},1},{{0,1006010463,1},1},{{0,1008010463,1},1},{{0,1010010463,1},1},{{0,1001010463,1},1}]','[]','[1002010463,1004010463,1006010463,1008010463,1010010463,1001010463]'),(32080465,0,1000,0,2,0,1,0,'[{{0,1002020463,1},1},{{0,1004020463,1},1},{{0,1006020463,1},1},{{0,1008020463,1},1},{{0,1010020463,1},1},{{0,1001020463,1},1}]','[]','[1002020463,1004020463,1006020463,1008020463,1010020463,1001020463]'),(32080465,0,1000,0,3,0,1,0,'[{{0,1002030463,1},1},{{0,1004030463,1},1},{{0,1006030463,1},1},{{0,1008030463,1},1},{{0,1010030463,1},1},{{0,1001030463,1},1}]','[]','[1002030463,1004030463,1006030463,1008030463,1010030463,1001030463]'),(32080465,0,1000,0,4,0,1,0,'[{{0,1002040463,1},1},{{0,1004040463,1},1},{{0,1006040463,1},1},{{0,1008040463,1},1},{{0,1010040463,1},1},{{0,1001040463,1},1}]','[]','[1002040463,1004040463,1006040463,1008040463,1010040463,1001040463]'),(32080466,0,1000,0,1,0,1,0,'[{{0,1007010463,1},1},{{0,1003000463,1},1},{{0,1005000463,1},1},{{0,1009000463,1},1}]','[]','[1007010463,1003000463,1005000463,1009000463]'),(32080466,0,1000,0,2,0,1,0,'[{{0,1007020463,1},1},{{0,1003000463,1},1},{{0,1005000463,1},1},{{0,1009000463,1},1}]','[]','[1007020463,1003000463,1005000463,1009000463]'),(32080466,0,1000,0,3,0,1,0,'[{{0,1007030463,1},1},{{0,1003000463,1},1},{{0,1005000463,1},1},{{0,1009000463,1},1}]','[]','[1007030463,1003000463,1005000463,1009000463]'),(32080466,0,1000,0,4,0,1,0,'[{{0,1007040463,1},1},{{0,1003000463,1},1},{{0,1005000463,1},1},{{0,1009000463,1},1}]','[]','[1007040463,1003000463,1005000463,1009000463]'),(32080467,0,1000,0,1,0,1,0,'[{{0,1007010463,1},1},{{0,1003000463,1},1}]','[]','[1007010463,1003000463]'),(32080467,0,1000,0,2,0,1,0,'[{{0,1007020463,1},1},{{0,1003000463,1},1}]','[]','[1007020463,1003000463]'),(32080467,0,1000,0,3,0,1,0,'[{{0,1007030463,1},1},{{0,1003000463,1},1}]','[]','[1007030463,1003000463]'),(32080467,0,1000,0,4,0,1,0,'[{{0,1007040463,1},1},{{0,1003000463,1},1}]','[]','[1007040463,1003000463]'),(32080468,0,1000,0,0,0,1,0,'[{{0,1005000463,1},1},{{0,1009000463,1},1}]','[]','[1005000463,1009000463]'),(32080471,0,1000,0,1,0,1,0,'[{{0,1001010400,1},1},{{0,1002010400,1},1},{{0,1003000400,1},1},{{0,1004010400,1},1},{{0,1006010400,1},1},{{0,1007010400,1},1},{{0,1008010400,1},1},{{0,1010010400,1},1}]','[]','[]'),(32080471,0,1000,0,2,0,1,0,'[{{0,1001020400,1},1},{{0,1002020400,1},1},{{0,1003000400,1},1},{{0,1004020400,1},1},{{0,1006020400,1},1},{{0,1007020400,1},1},{{0,1008020400,1},1},{{0,1010020400,1},1}]','[]','[]'),(32080471,0,1000,0,3,0,1,0,'[{{0,1001030400,1},1},{{0,1002030400,1},1},{{0,1003000400,1},1},{{0,1004030400,1},1},{{0,1006030400,1},1},{{0,1007030400,1},1},{{0,1008030400,1},1},{{0,1010030400,1},1}]','[]','[]'),(32080471,0,1000,0,4,0,1,0,'[{{0,1001040400,1},1},{{0,1002040400,1},1},{{0,1003000400,1},1},{{0,1004040400,1},1},{{0,1006040400,1},1},{{0,1007040400,1},1},{{0,1008040400,1},1},{{0,1010040400,1},1}]','[]','[]'),(32080472,0,1000,0,1,0,1,0,'[{{0,1002010400,1},1},{{0,1004010400,1},1},{{0,1006010400,1},1},{{0,1008010400,1},1},{{0,1010010400,1},1}]','[]','[]'),(32080472,0,1000,0,2,0,1,0,'[{{0,1002020400,1},1},{{0,1004020400,1},1},{{0,1006020400,1},1},{{0,1008020400,1},1},{{0,1010020400,1},1}]','[]','[]'),(32080472,0,1000,0,3,0,1,0,'[{{0,1002030400,1},1},{{0,1004030400,1},1},{{0,1006030400,1},1},{{0,1008030400,1},1},{{0,1010030400,1},1}]','[]','[]'),(32080472,0,1000,0,4,0,1,0,'[{{0,1002040400,1},1},{{0,1004040400,1},1},{{0,1006040400,1},1},{{0,1008040400,1},1},{{0,1010040400,1},1}]','[]','[]'),(32080473,0,1000,0,1,0,1,0,'[{{0,1001010400,1},1},{{0,1007010400,1},1}]','[]','[]'),(32080473,0,1000,0,2,0,1,0,'[{{0,1001020400,1},1},{{0,1007020400,1},1}]','[]','[]'),(32080473,0,1000,0,3,0,1,0,'[{{0,1001030400,1},1},{{0,1007030400,1},1}]','[]','[]'),(32080473,0,1000,0,4,0,1,0,'[{{0,1001040400,1},1},{{0,1007040400,1},1}]','[]','[]'),(32080475,0,1000,0,1,0,1,0,'[{{0,1002010400,1},1},{{0,1004010400,1},1},{{0,1006010400,1},1},{{0,1008010400,1},1},{{0,1010010400,1},1},{{0,1001010400,1},1}]','[]','[]'),(32080475,0,1000,0,2,0,1,0,'[{{0,1002020400,1},1},{{0,1004020400,1},1},{{0,1006020400,1},1},{{0,1008020400,1},1},{{0,1010020400,1},1},{{0,1001020400,1},1}]','[]','[]'),(32080475,0,1000,0,3,0,1,0,'[{{0,1002030400,1},1},{{0,1004030400,1},1},{{0,1006030400,1},1},{{0,1008030400,1},1},{{0,1010030400,1},1},{{0,1001030400,1},1}]','[]','[]'),(32080475,0,1000,0,4,0,1,0,'[{{0,1002040400,1},1},{{0,1004040400,1},1},{{0,1006040400,1},1},{{0,1008040400,1},1},{{0,1010040400,1},1},{{0,1001040400,1},1}]','[]','[]'),(32080476,0,1000,0,1,0,1,0,'[{{0,1007010400,1},1},{{0,1003000400,1},1},{{0,1005000400,1},1},{{0,1009000400,1},1}]','[]','[]'),(32080476,0,1000,0,2,0,1,0,'[{{0,1007020400,1},1},{{0,1003000400,1},1},{{0,1005000400,1},1},{{0,1009000400,1},1}]','[]','[]'),(32080476,0,1000,0,3,0,1,0,'[{{0,1007030400,1},1},{{0,1003000400,1},1},{{0,1005000400,1},1},{{0,1009000400,1},1}]','[]','[]'),(32080476,0,1000,0,4,0,1,0,'[{{0,1007040400,1},1},{{0,1003000400,1},1},{{0,1005000400,1},1},{{0,1009000400,1},1}]','[]','[]'),(32080477,0,1000,0,1,0,1,0,'[{{0,1007010400,1},1},{{0,1003000400,1},1}]','[]','[]'),(32080477,0,1000,0,2,0,1,0,'[{{0,1007020400,1},1},{{0,1003000400,1},1}]','[]','[]'),(32080477,0,1000,0,3,0,1,0,'[{{0,1007030400,1},1},{{0,1003000400,1},1}]','[]','[]'),(32080477,0,1000,0,4,0,1,0,'[{{0,1007040400,1},1},{{0,1003000400,1},1}]','[]','[]'),(32080478,0,1000,0,0,0,1,0,'[{{0,1005000400,1},1},{{0,1009000400,1},1}]','[]','[]'),(32080481,0,1000,0,1,0,1,0,'[{{0,1001010410,1},1},{{0,1002010410,1},1},{{0,1003000410,1},1},{{0,1004010410,1},1},{{0,1006010410,1},1},{{0,1007010410,1},1},{{0,1008010410,1},1},{{0,1010010410,1},1}]','[]','[]'),(32080481,0,1000,0,2,0,1,0,'[{{0,1001020410,1},1},{{0,1002020410,1},1},{{0,1003000410,1},1},{{0,1004020410,1},1},{{0,1006020410,1},1},{{0,1007020410,1},1},{{0,1008020410,1},1},{{0,1010020410,1},1}]','[]','[]'),(32080481,0,1000,0,3,0,1,0,'[{{0,1001030410,1},1},{{0,1002030410,1},1},{{0,1003000410,1},1},{{0,1004030410,1},1},{{0,1006030410,1},1},{{0,1007030410,1},1},{{0,1008030410,1},1},{{0,1010030410,1},1}]','[]','[]'),(32080481,0,1000,0,4,0,1,0,'[{{0,1001040410,1},1},{{0,1002040410,1},1},{{0,1003000410,1},1},{{0,1004040410,1},1},{{0,1006040410,1},1},{{0,1007040410,1},1},{{0,1008040410,1},1},{{0,1010040410,1},1}]','[]','[]'),(32080482,0,1000,0,1,0,1,0,'[{{0,1002010410,1},1},{{0,1004010410,1},1},{{0,1006010410,1},1},{{0,1008010410,1},1},{{0,1010010410,1},1}]','[]','[]'),(32080482,0,1000,0,2,0,1,0,'[{{0,1002020410,1},1},{{0,1004020410,1},1},{{0,1006020410,1},1},{{0,1008020410,1},1},{{0,1010020410,1},1}]','[]','[]'),(32080482,0,1000,0,3,0,1,0,'[{{0,1002030410,1},1},{{0,1004030410,1},1},{{0,1006030410,1},1},{{0,1008030410,1},1},{{0,1010030410,1},1}]','[]','[]'),(32080482,0,1000,0,4,0,1,0,'[{{0,1002040410,1},1},{{0,1004040410,1},1},{{0,1006040410,1},1},{{0,1008040410,1},1},{{0,1010040410,1},1}]','[]','[]'),(32080483,0,1000,0,1,0,1,0,'[{{0,1001010410,1},1},{{0,1007010410,1},1}]','[]','[]'),(32080483,0,1000,0,2,0,1,0,'[{{0,1001020410,1},1},{{0,1007020410,1},1}]','[]','[]'),(32080483,0,1000,0,3,0,1,0,'[{{0,1001030410,1},1},{{0,1007030410,1},1}]','[]','[]'),(32080483,0,1000,0,4,0,1,0,'[{{0,1001040410,1},1},{{0,1007040410,1},1}]','[]','[]'),(32080485,0,1000,0,1,0,1,0,'[{{0,1002010410,1},1},{{0,1004010410,1},1},{{0,1006010410,1},1},{{0,1008010410,1},1},{{0,1010010410,1},1},{{0,1001010410,1},1}]','[]','[]'),(32080485,0,1000,0,2,0,1,0,'[{{0,1002020410,1},1},{{0,1004020410,1},1},{{0,1006020410,1},1},{{0,1008020410,1},1},{{0,1010020410,1},1},{{0,1001020410,1},1}]','[]','[]'),(32080485,0,1000,0,3,0,1,0,'[{{0,1002030410,1},1},{{0,1004030410,1},1},{{0,1006030410,1},1},{{0,1008030410,1},1},{{0,1010030410,1},1},{{0,1001030410,1},1}]','[]','[]'),(32080485,0,1000,0,4,0,1,0,'[{{0,1002040410,1},1},{{0,1004040410,1},1},{{0,1006040410,1},1},{{0,1008040410,1},1},{{0,1010040410,1},1},{{0,1001040410,1},1}]','[]','[]'),(32080486,0,1000,0,1,0,1,0,'[{{0,1007010410,1},1},{{0,1003000410,1},1},{{0,1005000410,1},1},{{0,1009000410,1},1}]','[]','[]'),(32080486,0,1000,0,2,0,1,0,'[{{0,1007020410,1},1},{{0,1003000410,1},1},{{0,1005000410,1},1},{{0,1009000410,1},1}]','[]','[]'),(32080486,0,1000,0,3,0,1,0,'[{{0,1007030410,1},1},{{0,1003000410,1},1},{{0,1005000410,1},1},{{0,1009000410,1},1}]','[]','[]'),(32080486,0,1000,0,4,0,1,0,'[{{0,1007040410,1},1},{{0,1003000410,1},1},{{0,1005000410,1},1},{{0,1009000410,1},1}]','[]','[]'),(32080487,0,1000,0,1,0,1,0,'[{{0,1007010410,1},1},{{0,1003000410,1},1}]','[]','[]'),(32080487,0,1000,0,2,0,1,0,'[{{0,1007020410,1},1},{{0,1003000410,1},1}]','[]','[]'),(32080487,0,1000,0,3,0,1,0,'[{{0,1007030410,1},1},{{0,1003000410,1},1}]','[]','[]'),(32080487,0,1000,0,4,0,1,0,'[{{0,1007040410,1},1},{{0,1003000410,1},1}]','[]','[]'),(32080488,0,1000,0,0,0,1,0,'[{{0,1005000410,1},1},{{0,1009000410,1},1}]','[]','[]'),(32080491,0,1000,0,1,0,1,0,'[{{0,1001010420,1},1},{{0,1002010420,1},1},{{0,1003000420,1},1},{{0,1004010420,1},1},{{0,1006010420,1},1},{{0,1007010420,1},1},{{0,1008010420,1},1},{{0,1010010420,1},1}]','[]','[]'),(32080491,0,1000,0,2,0,1,0,'[{{0,1001020420,1},1},{{0,1002020420,1},1},{{0,1003000420,1},1},{{0,1004020420,1},1},{{0,1006020420,1},1},{{0,1007020420,1},1},{{0,1008020420,1},1},{{0,1010020420,1},1}]','[]','[]'),(32080491,0,1000,0,3,0,1,0,'[{{0,1001030420,1},1},{{0,1002030420,1},1},{{0,1003000420,1},1},{{0,1004030420,1},1},{{0,1006030420,1},1},{{0,1007030420,1},1},{{0,1008030420,1},1},{{0,1010030420,1},1}]','[]','[]'),(32080491,0,1000,0,4,0,1,0,'[{{0,1001040420,1},1},{{0,1002040420,1},1},{{0,1003000420,1},1},{{0,1004040420,1},1},{{0,1006040420,1},1},{{0,1007040420,1},1},{{0,1008040420,1},1},{{0,1010040420,1},1}]','[]','[]'),(32080492,0,1000,0,1,0,1,0,'[{{0,1002010420,1},1},{{0,1004010420,1},1},{{0,1006010420,1},1},{{0,1008010420,1},1},{{0,1010010420,1},1}]','[]','[]'),(32080492,0,1000,0,2,0,1,0,'[{{0,1002020420,1},1},{{0,1004020420,1},1},{{0,1006020420,1},1},{{0,1008020420,1},1},{{0,1010020420,1},1}]','[]','[]'),(32080492,0,1000,0,3,0,1,0,'[{{0,1002030420,1},1},{{0,1004030420,1},1},{{0,1006030420,1},1},{{0,1008030420,1},1},{{0,1010030420,1},1}]','[]','[]'),(32080492,0,1000,0,4,0,1,0,'[{{0,1002040420,1},1},{{0,1004040420,1},1},{{0,1006040420,1},1},{{0,1008040420,1},1},{{0,1010040420,1},1}]','[]','[]'),(32080493,0,1000,0,1,0,1,0,'[{{0,1001010420,1},1},{{0,1007010420,1},1}]','[]','[]'),(32080493,0,1000,0,2,0,1,0,'[{{0,1001020420,1},1},{{0,1007020420,1},1}]','[]','[]'),(32080493,0,1000,0,3,0,1,0,'[{{0,1001030420,1},1},{{0,1007030420,1},1}]','[]','[]'),(32080493,0,1000,0,4,0,1,0,'[{{0,1001040420,1},1},{{0,1007040420,1},1}]','[]','[]'),(32080495,0,1000,0,1,0,1,0,'[{{0,1002010420,1},1},{{0,1004010420,1},1},{{0,1006010420,1},1},{{0,1008010420,1},1},{{0,1010010420,1},1},{{0,1001010420,1},1}]','[]','[]'),(32080495,0,1000,0,2,0,1,0,'[{{0,1002020420,1},1},{{0,1004020420,1},1},{{0,1006020420,1},1},{{0,1008020420,1},1},{{0,1010020420,1},1},{{0,1001020420,1},1}]','[]','[]'),(32080495,0,1000,0,3,0,1,0,'[{{0,1002030420,1},1},{{0,1004030420,1},1},{{0,1006030420,1},1},{{0,1008030420,1},1},{{0,1010030420,1},1},{{0,1001030420,1},1}]','[]','[]'),(32080495,0,1000,0,4,0,1,0,'[{{0,1002040420,1},1},{{0,1004040420,1},1},{{0,1006040420,1},1},{{0,1008040420,1},1},{{0,1010040420,1},1},{{0,1001040420,1},1}]','[]','[]'),(32080496,0,1000,0,1,0,1,0,'[{{0,1007010420,1},1},{{0,1003000420,1},1},{{0,1005000420,1},1},{{0,1009000420,1},1}]','[]','[]'),(32080496,0,1000,0,2,0,1,0,'[{{0,1007020420,1},1},{{0,1003000420,1},1},{{0,1005000420,1},1},{{0,1009000420,1},1}]','[]','[]'),(32080496,0,1000,0,3,0,1,0,'[{{0,1007030420,1},1},{{0,1003000420,1},1},{{0,1005000420,1},1},{{0,1009000420,1},1}]','[]','[]'),(32080496,0,1000,0,4,0,1,0,'[{{0,1007040420,1},1},{{0,1003000420,1},1},{{0,1005000420,1},1},{{0,1009000420,1},1}]','[]','[]'),(32080497,0,1000,0,1,0,1,0,'[{{0,1007010420,1},1},{{0,1003000420,1},1}]','[]','[]'),(32080497,0,1000,0,2,0,1,0,'[{{0,1007020420,1},1},{{0,1003000420,1},1}]','[]','[]'),(32080497,0,1000,0,3,0,1,0,'[{{0,1007030420,1},1},{{0,1003000420,1},1}]','[]','[]'),(32080497,0,1000,0,4,0,1,0,'[{{0,1007040420,1},1},{{0,1003000420,1},1}]','[]','[]'),(32080498,0,1000,0,0,0,1,0,'[{{0,1005000420,1},1},{{0,1009000420,1},1}]','[]','[]'),(32080501,0,1000,0,1,0,1,0,'[{{0,1001010431,1},1},{{0,1002010431,1},1},{{0,1003000431,1},1},{{0,1004010431,1},1},{{0,1006010431,1},1},{{0,1007010431,1},1},{{0,1008010431,1},1},{{0,1010010431,1},1}]','[]','[]'),(32080501,0,1000,0,2,0,1,0,'[{{0,1001020431,1},1},{{0,1002020431,1},1},{{0,1003000431,1},1},{{0,1004020431,1},1},{{0,1006020431,1},1},{{0,1007020431,1},1},{{0,1008020431,1},1},{{0,1010020431,1},1}]','[]','[]'),(32080501,0,1000,0,3,0,1,0,'[{{0,1001030431,1},1},{{0,1002030431,1},1},{{0,1003000431,1},1},{{0,1004030431,1},1},{{0,1006030431,1},1},{{0,1007030431,1},1},{{0,1008030431,1},1},{{0,1010030431,1},1}]','[]','[]'),(32080501,0,1000,0,4,0,1,0,'[{{0,1001040431,1},1},{{0,1002040431,1},1},{{0,1003000431,1},1},{{0,1004040431,1},1},{{0,1006040431,1},1},{{0,1007040431,1},1},{{0,1008040431,1},1},{{0,1010040431,1},1}]','[]','[]'),(32080502,0,1000,0,1,0,1,0,'[{{0,1002010431,1},1},{{0,1004010431,1},1},{{0,1006010431,1},1},{{0,1008010431,1},1},{{0,1010010431,1},1}]','[]','[]'),(32080502,0,1000,0,2,0,1,0,'[{{0,1002020431,1},1},{{0,1004020431,1},1},{{0,1006020431,1},1},{{0,1008020431,1},1},{{0,1010020431,1},1}]','[]','[]'),(32080502,0,1000,0,3,0,1,0,'[{{0,1002030431,1},1},{{0,1004030431,1},1},{{0,1006030431,1},1},{{0,1008030431,1},1},{{0,1010030431,1},1}]','[]','[]'),(32080502,0,1000,0,4,0,1,0,'[{{0,1002040431,1},1},{{0,1004040431,1},1},{{0,1006040431,1},1},{{0,1008040431,1},1},{{0,1010040431,1},1}]','[]','[]'),(32080503,0,1000,0,1,0,1,0,'[{{0,1001010431,1},1},{{0,1007010431,1},1}]','[]','[]'),(32080503,0,1000,0,2,0,1,0,'[{{0,1001020431,1},1},{{0,1007020431,1},1}]','[]','[]'),(32080503,0,1000,0,3,0,1,0,'[{{0,1001030431,1},1},{{0,1007030431,1},1}]','[]','[]'),(32080503,0,1000,0,4,0,1,0,'[{{0,1001040431,1},1},{{0,1007040431,1},1}]','[]','[]'),(32080505,0,1000,0,1,0,1,0,'[{{0,1002010431,1},1},{{0,1004010431,1},1},{{0,1006010431,1},1},{{0,1008010431,1},1},{{0,1010010431,1},1},{{0,1001010431,1},1}]','[]','[]'),(32080505,0,1000,0,2,0,1,0,'[{{0,1002020431,1},1},{{0,1004020431,1},1},{{0,1006020431,1},1},{{0,1008020431,1},1},{{0,1010020431,1},1},{{0,1001020431,1},1}]','[]','[]'),(32080505,0,1000,0,3,0,1,0,'[{{0,1002030431,1},1},{{0,1004030431,1},1},{{0,1006030431,1},1},{{0,1008030431,1},1},{{0,1010030431,1},1},{{0,1001030431,1},1}]','[]','[]'),(32080505,0,1000,0,4,0,1,0,'[{{0,1002040431,1},1},{{0,1004040431,1},1},{{0,1006040431,1},1},{{0,1008040431,1},1},{{0,1010040431,1},1},{{0,1001040431,1},1}]','[]','[]'),(32080506,0,1000,0,1,0,1,0,'[{{0,1007010431,1},1},{{0,1003000431,1},1},{{0,1005000431,1},1},{{0,1009000431,1},1}]','[]','[]'),(32080506,0,1000,0,2,0,1,0,'[{{0,1007020431,1},1},{{0,1003000431,1},1},{{0,1005000431,1},1},{{0,1009000431,1},1}]','[]','[]'),(32080506,0,1000,0,3,0,1,0,'[{{0,1007030431,1},1},{{0,1003000431,1},1},{{0,1005000431,1},1},{{0,1009000431,1},1}]','[]','[]'),(32080506,0,1000,0,4,0,1,0,'[{{0,1007040431,1},1},{{0,1003000431,1},1},{{0,1005000431,1},1},{{0,1009000431,1},1}]','[]','[]'),(32080507,0,1000,0,1,0,1,0,'[{{0,1007010431,1},1},{{0,1003000431,1},1}]','[]','[]'),(32080507,0,1000,0,2,0,1,0,'[{{0,1007020431,1},1},{{0,1003000431,1},1}]','[]','[]'),(32080507,0,1000,0,3,0,1,0,'[{{0,1007030431,1},1},{{0,1003000431,1},1}]','[]','[]'),(32080507,0,1000,0,4,0,1,0,'[{{0,1007040431,1},1},{{0,1003000431,1},1}]','[]','[]'),(32080508,0,1000,0,0,0,1,0,'[{{0,1005000431,1},1},{{0,1009000431,1},1}]','[]','[]'),(32080511,0,1000,0,1,0,1,0,'[{{0,1001010532,1},1},{{0,1002010532,1},1},{{0,1003000532,1},1},{{0,1004010532,1},1},{{0,1006010532,1},1},{{0,1007010532,1},1},{{0,1008010532,1},1},{{0,1010010532,1},1}]','[]','[1001010532,1002010532,1003000532,1004010532,1005000532,1006010532,1007010532,1008010532,1009000532,1010010532]'),(32080511,0,1000,0,2,0,1,0,'[{{0,1001020532,1},1},{{0,1002020532,1},1},{{0,1003000532,1},1},{{0,1004020532,1},1},{{0,1006020532,1},1},{{0,1007020532,1},1},{{0,1008020532,1},1},{{0,1010020532,1},1}]','[]','[1001020532,1002020532,1003000532,1004020532,1005000532,1006020532,1007020532,1008020532,1009000532,1010020532]'),(32080511,0,1000,0,3,0,1,0,'[{{0,1001030532,1},1},{{0,1002030532,1},1},{{0,1003000532,1},1},{{0,1004030532,1},1},{{0,1006030532,1},1},{{0,1007030532,1},1},{{0,1008030532,1},1},{{0,1010030532,1},1}]','[]','[1001030532,1002030532,1003000532,1004030532,1005000532,1006030532,1007030532,1008030532,1009000532,1010030532]'),(32080511,0,1000,0,4,0,1,0,'[{{0,1001040532,1},1},{{0,1002040532,1},1},{{0,1003000532,1},1},{{0,1004040532,1},1},{{0,1006040532,1},1},{{0,1007040532,1},1},{{0,1008040532,1},1},{{0,1010040532,1},1}]','[]','[1001040532,1002040532,1003000532,1004040532,1005000532,1006040532,1007040532,1008040532,1009000532,1010040532]'),(32080512,0,1000,0,1,0,1,0,'[{{0,1002010532,1},1},{{0,1004010532,1},1},{{0,1006010532,1},1},{{0,1008010532,1},1},{{0,1010010532,1},1}]','[]','[1002010532,1004010532,1006010532,1008010532,1010010532]'),(32080512,0,1000,0,2,0,1,0,'[{{0,1002020532,1},1},{{0,1004020532,1},1},{{0,1006020532,1},1},{{0,1008020532,1},1},{{0,1010020532,1},1}]','[]','[1002020532,1004020532,1006020532,1008020532,1010020532]'),(32080512,0,1000,0,3,0,1,0,'[{{0,1002030532,1},1},{{0,1004030532,1},1},{{0,1006030532,1},1},{{0,1008030532,1},1},{{0,1010030532,1},1}]','[]','[1002030532,1004030532,1006030532,1008030532,1010030532]'),(32080512,0,1000,0,4,0,1,0,'[{{0,1002040532,1},1},{{0,1004040532,1},1},{{0,1006040532,1},1},{{0,1008040532,1},1},{{0,1010040532,1},1}]','[]','[1002040532,1004040532,1006040532,1008040532,1010040532]'),(32080513,0,1000,0,1,0,1,0,'[{{0,1001010532,1},1},{{0,1007010532,1},1}]','[]','[1001010532,1007010532]'),(32080513,0,1000,0,2,0,1,0,'[{{0,1001020532,1},1},{{0,1007020532,1},1}]','[]','[1001020532,1007020532]'),(32080513,0,1000,0,3,0,1,0,'[{{0,1001030532,1},1},{{0,1007030532,1},1}]','[]','[1001030532,1007030532]'),(32080513,0,1000,0,4,0,1,0,'[{{0,1001040532,1},1},{{0,1007040532,1},1}]','[]','[1001040532,1007040532]'),(32080515,0,1000,0,1,0,1,0,'[{{0,1002010532,1},1},{{0,1004010532,1},1},{{0,1006010532,1},1},{{0,1008010532,1},1},{{0,1010010532,1},1},{{0,1001010532,1},1}]','[]','[1002010532,1004010532,1006010532,1008010532,1010010532,1001010532]'),(32080515,0,1000,0,2,0,1,0,'[{{0,1002020532,1},1},{{0,1004020532,1},1},{{0,1006020532,1},1},{{0,1008020532,1},1},{{0,1010020532,1},1},{{0,1001020532,1},1}]','[]','[1002020532,1004020532,1006020532,1008020532,1010020532,1001020532]'),(32080515,0,1000,0,3,0,1,0,'[{{0,1002030532,1},1},{{0,1004030532,1},1},{{0,1006030532,1},1},{{0,1008030532,1},1},{{0,1010030532,1},1},{{0,1001030532,1},1}]','[]','[1002030532,1004030532,1006030532,1008030532,1010030532,1001030532]'),(32080515,0,1000,0,4,0,1,0,'[{{0,1002040532,1},1},{{0,1004040532,1},1},{{0,1006040532,1},1},{{0,1008040532,1},1},{{0,1010040532,1},1},{{0,1001040532,1},1}]','[]','[1002040532,1004040532,1006040532,1008040532,1010040532,1001040532]'),(32080516,0,1000,0,1,0,1,0,'[{{0,1007010532,1},1},{{0,1003000532,1},1},{{0,1005000532,1},1},{{0,1009000532,1},1}]','[]','[1007010532,1003000532,1005000532,1009000532]'),(32080516,0,1000,0,2,0,1,0,'[{{0,1007020532,1},1},{{0,1003000532,1},1},{{0,1005000532,1},1},{{0,1009000532,1},1}]','[]','[1007020532,1003000532,1005000532,1009000532]'),(32080516,0,1000,0,3,0,1,0,'[{{0,1007030532,1},1},{{0,1003000532,1},1},{{0,1005000532,1},1},{{0,1009000532,1},1}]','[]','[1007030532,1003000532,1005000532,1009000532]'),(32080516,0,1000,0,4,0,1,0,'[{{0,1007040532,1},1},{{0,1003000532,1},1},{{0,1005000532,1},1},{{0,1009000532,1},1}]','[]','[1007040532,1003000532,1005000532,1009000532]'),(32080517,0,1000,0,1,0,1,0,'[{{0,1007010532,1},1},{{0,1003000532,1},1}]','[]','[1007010532,1003000532]'),(32080517,0,1000,0,2,0,1,0,'[{{0,1007020532,1},1},{{0,1003000532,1},1}]','[]','[1007020532,1003000532]'),(32080517,0,1000,0,3,0,1,0,'[{{0,1007030532,1},1},{{0,1003000532,1},1}]','[]','[1007030532,1003000532]'),(32080517,0,1000,0,4,0,1,0,'[{{0,1007040532,1},1},{{0,1003000532,1},1}]','[]','[1007040532,1003000532]'),(32080518,0,1000,0,0,0,1,0,'[{{0,1005000532,1},1},{{0,1009000532,1},1}]','[]','[1005000532,1009000532]'),(32080521,0,1000,0,1,0,1,0,'[{{0,1001010541,1},1},{{0,1002010541,1},1},{{0,1003000541,1},1},{{0,1004010541,1},1},{{0,1006010541,1},1},{{0,1007010541,1},1},{{0,1008010541,1},1},{{0,1010010541,1},1}]','[]','[]'),(32080521,0,1000,0,2,0,1,0,'[{{0,1001020541,1},1},{{0,1002020541,1},1},{{0,1003000541,1},1},{{0,1004020541,1},1},{{0,1006020541,1},1},{{0,1007020541,1},1},{{0,1008020541,1},1},{{0,1010020541,1},1}]','[]','[]'),(32080521,0,1000,0,3,0,1,0,'[{{0,1001030541,1},1},{{0,1002030541,1},1},{{0,1003000541,1},1},{{0,1004030541,1},1},{{0,1006030541,1},1},{{0,1007030541,1},1},{{0,1008030541,1},1},{{0,1010030541,1},1}]','[]','[]'),(32080521,0,1000,0,4,0,1,0,'[{{0,1001040541,1},1},{{0,1002040541,1},1},{{0,1003000541,1},1},{{0,1004040541,1},1},{{0,1006040541,1},1},{{0,1007040541,1},1},{{0,1008040541,1},1},{{0,1010040541,1},1}]','[]','[]'),(32080522,0,1000,0,1,0,1,0,'[{{0,1002010541,1},1},{{0,1004010541,1},1},{{0,1006010541,1},1},{{0,1008010541,1},1},{{0,1010010541,1},1}]','[]','[]'),(32080522,0,1000,0,2,0,1,0,'[{{0,1002020541,1},1},{{0,1004020541,1},1},{{0,1006020541,1},1},{{0,1008020541,1},1},{{0,1010020541,1},1}]','[]','[]'),(32080522,0,1000,0,3,0,1,0,'[{{0,1002030541,1},1},{{0,1004030541,1},1},{{0,1006030541,1},1},{{0,1008030541,1},1},{{0,1010030541,1},1}]','[]','[]'),(32080522,0,1000,0,4,0,1,0,'[{{0,1002040541,1},1},{{0,1004040541,1},1},{{0,1006040541,1},1},{{0,1008040541,1},1},{{0,1010040541,1},1}]','[]','[]'),(32080523,0,1000,0,1,0,1,0,'[{{0,1001010541,1},1},{{0,1007010541,1},1}]','[]','[]'),(32080523,0,1000,0,2,0,1,0,'[{{0,1001020541,1},1},{{0,1007020541,1},1}]','[]','[]'),(32080523,0,1000,0,3,0,1,0,'[{{0,1001030541,1},1},{{0,1007030541,1},1}]','[]','[]'),(32080523,0,1000,0,4,0,1,0,'[{{0,1001040541,1},1},{{0,1007040541,1},1}]','[]','[]'),(32080525,0,1000,0,1,0,1,0,'[{{0,1002010541,1},1},{{0,1004010541,1},1},{{0,1006010541,1},1},{{0,1008010541,1},1},{{0,1010010541,1},1},{{0,1001010541,1},1}]','[]','[]'),(32080525,0,1000,0,2,0,1,0,'[{{0,1002020541,1},1},{{0,1004020541,1},1},{{0,1006020541,1},1},{{0,1008020541,1},1},{{0,1010020541,1},1},{{0,1001020541,1},1}]','[]','[]'),(32080525,0,1000,0,3,0,1,0,'[{{0,1002030541,1},1},{{0,1004030541,1},1},{{0,1006030541,1},1},{{0,1008030541,1},1},{{0,1010030541,1},1},{{0,1001030541,1},1}]','[]','[]'),(32080525,0,1000,0,4,0,1,0,'[{{0,1002040541,1},1},{{0,1004040541,1},1},{{0,1006040541,1},1},{{0,1008040541,1},1},{{0,1010040541,1},1},{{0,1001040541,1},1}]','[]','[]'),(32080526,0,1000,0,1,0,1,0,'[{{0,1007010541,1},1},{{0,1003000541,1},1},{{0,1005000541,1},1},{{0,1009000541,1},1}]','[]','[]'),(32080526,0,1000,0,2,0,1,0,'[{{0,1007020541,1},1},{{0,1003000541,1},1},{{0,1005000541,1},1},{{0,1009000541,1},1}]','[]','[]'),(32080526,0,1000,0,3,0,1,0,'[{{0,1007030541,1},1},{{0,1003000541,1},1},{{0,1005000541,1},1},{{0,1009000541,1},1}]','[]','[]'),(32080526,0,1000,0,4,0,1,0,'[{{0,1007040541,1},1},{{0,1003000541,1},1},{{0,1005000541,1},1},{{0,1009000541,1},1}]','[]','[]'),(32080527,0,1000,0,1,0,1,0,'[{{0,1007010541,1},1},{{0,1003000541,1},1}]','[]','[]'),(32080527,0,1000,0,2,0,1,0,'[{{0,1007020541,1},1},{{0,1003000541,1},1}]','[]','[]'),(32080527,0,1000,0,3,0,1,0,'[{{0,1007030541,1},1},{{0,1003000541,1},1}]','[]','[]'),(32080527,0,1000,0,4,0,1,0,'[{{0,1007040541,1},1},{{0,1003000541,1},1}]','[]','[]'),(32080528,0,1000,0,0,0,1,0,'[{{0,1005000541,1},1},{{0,1009000541,1},1}]','[]','[]'),(32080531,0,1000,0,1,0,1,0,'[{{0,1001010542,1},1},{{0,1002010542,1},1},{{0,1003000542,1},1},{{0,1004010542,1},1},{{0,1006010542,1},1},{{0,1007010542,1},1},{{0,1008010542,1},1},{{0,1010010542,1},1}]','[]','[1001010542,1002010542,1003000542,1004010542,1005000542,1006010542,1007010542,1008010542,1009000542,1010010542]'),(32080531,0,1000,0,2,0,1,0,'[{{0,1001020542,1},1},{{0,1002020542,1},1},{{0,1003000542,1},1},{{0,1004020542,1},1},{{0,1006020542,1},1},{{0,1007020542,1},1},{{0,1008020542,1},1},{{0,1010020542,1},1}]','[]','[1001020542,1002020542,1003000542,1004020542,1005000542,1006020542,1007020542,1008020542,1009000542,1010020542]'),(32080531,0,1000,0,3,0,1,0,'[{{0,1001030542,1},1},{{0,1002030542,1},1},{{0,1003000542,1},1},{{0,1004030542,1},1},{{0,1006030542,1},1},{{0,1007030542,1},1},{{0,1008030542,1},1},{{0,1010030542,1},1}]','[]','[1001030542,1002030542,1003000542,1004030542,1005000542,1006030542,1007030542,1008030542,1009000542,1010030542]'),(32080531,0,1000,0,4,0,1,0,'[{{0,1001040542,1},1},{{0,1002040542,1},1},{{0,1003000542,1},1},{{0,1004040542,1},1},{{0,1006040542,1},1},{{0,1007040542,1},1},{{0,1008040542,1},1},{{0,1010040542,1},1}]','[]','[1001040542,1002040542,1003000542,1004040542,1005000542,1006040542,1007040542,1008040542,1009000542,1010040542]'),(32080532,0,1000,0,1,0,1,0,'[{{0,1002010542,1},1},{{0,1004010542,1},1},{{0,1006010542,1},1},{{0,1008010542,1},1},{{0,1010010542,1},1}]','[]','[1002010542,1004010542,1006010542,1008010542,1010010542]'),(32080532,0,1000,0,2,0,1,0,'[{{0,1002020542,1},1},{{0,1004020542,1},1},{{0,1006020542,1},1},{{0,1008020542,1},1},{{0,1010020542,1},1}]','[]','[1002020542,1004020542,1006020542,1008020542,1010020542]'),(32080532,0,1000,0,3,0,1,0,'[{{0,1002030542,1},1},{{0,1004030542,1},1},{{0,1006030542,1},1},{{0,1008030542,1},1},{{0,1010030542,1},1}]','[]','[1002030542,1004030542,1006030542,1008030542,1010030542]'),(32080532,0,1000,0,4,0,1,0,'[{{0,1002040542,1},1},{{0,1004040542,1},1},{{0,1006040542,1},1},{{0,1008040542,1},1},{{0,1010040542,1},1}]','[]','[1002040542,1004040542,1006040542,1008040542,1010040542]'),(32080533,0,1000,0,1,0,1,0,'[{{0,1001010542,1},1},{{0,1007010542,1},1}]','[]','[1001010542,1007010542]'),(32080533,0,1000,0,2,0,1,0,'[{{0,1001020542,1},1},{{0,1007020542,1},1}]','[]','[1001020542,1007020542]'),(32080533,0,1000,0,3,0,1,0,'[{{0,1001030542,1},1},{{0,1007030542,1},1}]','[]','[1001030542,1007030542]'),(32080533,0,1000,0,4,0,1,0,'[{{0,1001040542,1},1},{{0,1007040542,1},1}]','[]','[1001040542,1007040542]'),(32080535,0,1000,0,1,0,1,0,'[{{0,1002010542,1},1},{{0,1004010542,1},1},{{0,1006010542,1},1},{{0,1008010542,1},1},{{0,1010010542,1},1},{{0,1001010542,1},1}]','[]','[1002010542,1004010542,1006010542,1008010542,1010010542,1001010542]'),(32080535,0,1000,0,2,0,1,0,'[{{0,1002020542,1},1},{{0,1004020542,1},1},{{0,1006020542,1},1},{{0,1008020542,1},1},{{0,1010020542,1},1},{{0,1001020542,1},1}]','[]','[1002020542,1004020542,1006020542,1008020542,1010020542,1001020542]'),(32080535,0,1000,0,3,0,1,0,'[{{0,1002030542,1},1},{{0,1004030542,1},1},{{0,1006030542,1},1},{{0,1008030542,1},1},{{0,1010030542,1},1},{{0,1001030542,1},1}]','[]','[1002030542,1004030542,1006030542,1008030542,1010030542,1001030542]'),(32080535,0,1000,0,4,0,1,0,'[{{0,1002040542,1},1},{{0,1004040542,1},1},{{0,1006040542,1},1},{{0,1008040542,1},1},{{0,1010040542,1},1},{{0,1001040542,1},1}]','[]','[1002040542,1004040542,1006040542,1008040542,1010040542,1001040542]'),(32080536,0,1000,0,1,0,1,0,'[{{0,1007010542,1},1},{{0,1003000542,1},1},{{0,1005000542,1},1},{{0,1009000542,1},1}]','[]','[1007010542,1003000542,1005000542,1009000542]'),(32080536,0,1000,0,2,0,1,0,'[{{0,1007020542,1},1},{{0,1003000542,1},1},{{0,1005000542,1},1},{{0,1009000542,1},1}]','[]','[1007020542,1003000542,1005000542,1009000542]'),(32080536,0,1000,0,3,0,1,0,'[{{0,1007030542,1},1},{{0,1003000542,1},1},{{0,1005000542,1},1},{{0,1009000542,1},1}]','[]','[1007030542,1003000542,1005000542,1009000542]'),(32080536,0,1000,0,4,0,1,0,'[{{0,1007040542,1},1},{{0,1003000542,1},1},{{0,1005000542,1},1},{{0,1009000542,1},1}]','[]','[1007040542,1003000542,1005000542,1009000542]'),(32080537,0,1000,0,1,0,1,0,'[{{0,1007010542,1},1},{{0,1003000542,1},1}]','[]','[1007010542,1003000542]'),(32080537,0,1000,0,2,0,1,0,'[{{0,1007020542,1},1},{{0,1003000542,1},1}]','[]','[1007020542,1003000542]'),(32080537,0,1000,0,3,0,1,0,'[{{0,1007030542,1},1},{{0,1003000542,1},1}]','[]','[1007030542,1003000542]'),(32080537,0,1000,0,4,0,1,0,'[{{0,1007040542,1},1},{{0,1003000542,1},1}]','[]','[1007040542,1003000542]'),(32080538,0,1000,0,0,0,1,0,'[{{0,1005000542,1},1},{{0,1009000542,1},1}]','[]','[1005000542,1009000542]'),(32080541,0,1000,0,1,0,1,0,'[{{0,1001010543,1},1},{{0,1002010543,1},1},{{0,1003000543,1},1},{{0,1004010543,1},1},{{0,1006010543,1},1},{{0,1007010543,1},1},{{0,1008010543,1},1},{{0,1010010543,1},1}]','[]','[1001010543,1002010543,1003000543,1004010543,1005000543,1006010543,1007010543,1008010543,1009000543,1010010543]'),(32080541,0,1000,0,2,0,1,0,'[{{0,1001020543,1},1},{{0,1002020543,1},1},{{0,1003000543,1},1},{{0,1004020543,1},1},{{0,1006020543,1},1},{{0,1007020543,1},1},{{0,1008020543,1},1},{{0,1010020543,1},1}]','[]','[1001020543,1002020543,1003000543,1004020543,1005000543,1006020543,1007020543,1008020543,1009000543,1010020543]'),(32080541,0,1000,0,3,0,1,0,'[{{0,1001030543,1},1},{{0,1002030543,1},1},{{0,1003000543,1},1},{{0,1004030543,1},1},{{0,1006030543,1},1},{{0,1007030543,1},1},{{0,1008030543,1},1},{{0,1010030543,1},1}]','[]','[1001030543,1002030543,1003000543,1004030543,1005000543,1006030543,1007030543,1008030543,1009000543,1010030543]'),(32080541,0,1000,0,4,0,1,0,'[{{0,1001040543,1},1},{{0,1002040543,1},1},{{0,1003000543,1},1},{{0,1004040543,1},1},{{0,1006040543,1},1},{{0,1007040543,1},1},{{0,1008040543,1},1},{{0,1010040543,1},1}]','[]','[1001040543,1002040543,1003000543,1004040543,1005000543,1006040543,1007040543,1008040543,1009000543,1010040543]'),(32080542,0,1000,0,1,0,1,0,'[{{0,1002010543,1},1},{{0,1004010543,1},1},{{0,1006010543,1},1},{{0,1008010543,1},1},{{0,1010010543,1},1}]','[]','[1002010543,1004010543,1006010543,1008010543,1010010543]'),(32080542,0,1000,0,2,0,1,0,'[{{0,1002020543,1},1},{{0,1004020543,1},1},{{0,1006020543,1},1},{{0,1008020543,1},1},{{0,1010020543,1},1}]','[]','[1002020543,1004020543,1006020543,1008020543,1010020543]'),(32080542,0,1000,0,3,0,1,0,'[{{0,1002030543,1},1},{{0,1004030543,1},1},{{0,1006030543,1},1},{{0,1008030543,1},1},{{0,1010030543,1},1}]','[]','[1002030543,1004030543,1006030543,1008030543,1010030543]'),(32080542,0,1000,0,4,0,1,0,'[{{0,1002040543,1},1},{{0,1004040543,1},1},{{0,1006040543,1},1},{{0,1008040543,1},1},{{0,1010040543,1},1}]','[]','[1002040543,1004040543,1006040543,1008040543,1010040543]'),(32080543,0,1000,0,1,0,1,0,'[{{0,1001010543,1},1},{{0,1007010543,1},1}]','[]','[1001010543,1007010543]'),(32080543,0,1000,0,2,0,1,0,'[{{0,1001020543,1},1},{{0,1007020543,1},1}]','[]','[1001020543,1007020543]'),(32080543,0,1000,0,3,0,1,0,'[{{0,1001030543,1},1},{{0,1007030543,1},1}]','[]','[1001030543,1007030543]'),(32080543,0,1000,0,4,0,1,0,'[{{0,1001040543,1},1},{{0,1007040543,1},1}]','[]','[1001040543,1007040543]'),(32080545,0,1000,0,1,0,1,0,'[{{0,1002010543,1},1},{{0,1004010543,1},1},{{0,1006010543,1},1},{{0,1008010543,1},1},{{0,1010010543,1},1},{{0,1001010543,1},1}]','[]','[1002010543,1004010543,1006010543,1008010543,1010010543,1001010543]'),(32080545,0,1000,0,2,0,1,0,'[{{0,1002020543,1},1},{{0,1004020543,1},1},{{0,1006020543,1},1},{{0,1008020543,1},1},{{0,1010020543,1},1},{{0,1001020543,1},1}]','[]','[1002020543,1004020543,1006020543,1008020543,1010020543,1001020543]'),(32080545,0,1000,0,3,0,1,0,'[{{0,1002030543,1},1},{{0,1004030543,1},1},{{0,1006030543,1},1},{{0,1008030543,1},1},{{0,1010030543,1},1},{{0,1001030543,1},1}]','[]','[1002030543,1004030543,1006030543,1008030543,1010030543,1001030543]'),(32080545,0,1000,0,4,0,1,0,'[{{0,1002040543,1},1},{{0,1004040543,1},1},{{0,1006040543,1},1},{{0,1008040543,1},1},{{0,1010040543,1},1},{{0,1001040543,1},1}]','[]','[1002040543,1004040543,1006040543,1008040543,1010040543,1001040543]'),(32080546,0,1000,0,1,0,1,0,'[{{0,1007010543,1},1},{{0,1003000543,1},1},{{0,1005000543,1},1},{{0,1009000543,1},1}]','[]','[1007010543,1003000543,1005000543,1009000543]'),(32080546,0,1000,0,2,0,1,0,'[{{0,1007020543,1},1},{{0,1003000543,1},1},{{0,1005000543,1},1},{{0,1009000543,1},1}]','[]','[1007020543,1003000543,1005000543,1009000543]'),(32080546,0,1000,0,3,0,1,0,'[{{0,1007030543,1},1},{{0,1003000543,1},1},{{0,1005000543,1},1},{{0,1009000543,1},1}]','[]','[1007030543,1003000543,1005000543,1009000543]'),(32080546,0,1000,0,4,0,1,0,'[{{0,1007040543,1},1},{{0,1003000543,1},1},{{0,1005000543,1},1},{{0,1009000543,1},1}]','[]','[1007040543,1003000543,1005000543,1009000543]'),(32080547,0,1000,0,1,0,1,0,'[{{0,1007010543,1},1},{{0,1003000543,1},1}]','[]','[1007010543,1003000543]'),(32080547,0,1000,0,2,0,1,0,'[{{0,1007020543,1},1},{{0,1003000543,1},1}]','[]','[1007020543,1003000543]'),(32080547,0,1000,0,3,0,1,0,'[{{0,1007030543,1},1},{{0,1003000543,1},1}]','[]','[1007030543,1003000543]'),(32080547,0,1000,0,4,0,1,0,'[{{0,1007040543,1},1},{{0,1003000543,1},1}]','[]','[1007040543,1003000543]'),(32080548,0,1000,0,0,0,1,0,'[{{0,1005000543,1},1},{{0,1009000543,1},1}]','[]','[1005000543,1009000543]'),(32080551,0,1000,0,1,0,1,0,'[{{0,1001010553,1},1},{{0,1002010553,1},1},{{0,1003000553,1},1},{{0,1004010553,1},1},{{0,1006010553,1},1},{{0,1007010553,1},1},{{0,1008010553,1},1},{{0,1010010553,1},1}]','[]','[1001010553,1002010553,1003000553,1004010553,1005000553,1006010553,1007010553,1008010553,1009000553,1010010553]'),(32080551,0,1000,0,2,0,1,0,'[{{0,1001020553,1},1},{{0,1002020553,1},1},{{0,1003000553,1},1},{{0,1004020553,1},1},{{0,1006020553,1},1},{{0,1007020553,1},1},{{0,1008020553,1},1},{{0,1010020553,1},1}]','[]','[1001020553,1002020553,1003000553,1004020553,1005000553,1006020553,1007020553,1008020553,1009000553,1010020553]'),(32080551,0,1000,0,3,0,1,0,'[{{0,1001030553,1},1},{{0,1002030553,1},1},{{0,1003000553,1},1},{{0,1004030553,1},1},{{0,1006030553,1},1},{{0,1007030553,1},1},{{0,1008030553,1},1},{{0,1010030553,1},1}]','[]','[1001030553,1002030553,1003000553,1004030553,1005000553,1006030553,1007030553,1008030553,1009000553,1010030553]'),(32080551,0,1000,0,4,0,1,0,'[{{0,1001040553,1},1},{{0,1002040553,1},1},{{0,1003000553,1},1},{{0,1004040553,1},1},{{0,1006040553,1},1},{{0,1007040553,1},1},{{0,1008040553,1},1},{{0,1010040553,1},1}]','[]','[1001040553,1002040553,1003000553,1004040553,1005000553,1006040553,1007040553,1008040553,1009000553,1010040553]'),(32080552,0,1000,0,1,0,1,0,'[{{0,1002010553,1},1},{{0,1004010553,1},1},{{0,1006010553,1},1},{{0,1008010553,1},1},{{0,1010010553,1},1}]','[]','[1002010553,1004010553,1006010553,1008010553,1010010553]'),(32080552,0,1000,0,2,0,1,0,'[{{0,1002020553,1},1},{{0,1004020553,1},1},{{0,1006020553,1},1},{{0,1008020553,1},1},{{0,1010020553,1},1}]','[]','[1002020553,1004020553,1006020553,1008020553,1010020553]'),(32080552,0,1000,0,3,0,1,0,'[{{0,1002030553,1},1},{{0,1004030553,1},1},{{0,1006030553,1},1},{{0,1008030553,1},1},{{0,1010030553,1},1}]','[]','[1002030553,1004030553,1006030553,1008030553,1010030553]'),(32080552,0,1000,0,4,0,1,0,'[{{0,1002040553,1},1},{{0,1004040553,1},1},{{0,1006040553,1},1},{{0,1008040553,1},1},{{0,1010040553,1},1}]','[]','[1002040553,1004040553,1006040553,1008040553,1010040553]'),(32080553,0,1000,0,1,0,1,0,'[{{0,1001010553,1},1},{{0,1007010553,1},1}]','[]','[1001010553,1007010553]'),(32080553,0,1000,0,2,0,1,0,'[{{0,1001020553,1},1},{{0,1007020553,1},1}]','[]','[1001020553,1007020553]'),(32080553,0,1000,0,3,0,1,0,'[{{0,1001030553,1},1},{{0,1007030553,1},1}]','[]','[1001030553,1007030553]'),(32080553,0,1000,0,4,0,1,0,'[{{0,1001040553,1},1},{{0,1007040553,1},1}]','[]','[1001040553,1007040553]'),(32080555,0,1000,0,1,0,1,0,'[{{0,1002010553,1},1},{{0,1004010553,1},1},{{0,1006010553,1},1},{{0,1008010553,1},1},{{0,1010010553,1},1},{{0,1001010553,1},1}]','[]','[1002010553,1004010553,1006010553,1008010553,1010010553,1001010553]'),(32080555,0,1000,0,2,0,1,0,'[{{0,1002020553,1},1},{{0,1004020553,1},1},{{0,1006020553,1},1},{{0,1008020553,1},1},{{0,1010020553,1},1},{{0,1001020553,1},1}]','[]','[1002020553,1004020553,1006020553,1008020553,1010020553,1001020553]'),(32080555,0,1000,0,3,0,1,0,'[{{0,1002030553,1},1},{{0,1004030553,1},1},{{0,1006030553,1},1},{{0,1008030553,1},1},{{0,1010030553,1},1},{{0,1001030553,1},1}]','[]','[1002030553,1004030553,1006030553,1008030553,1010030553,1001030553]'),(32080555,0,1000,0,4,0,1,0,'[{{0,1002040553,1},1},{{0,1004040553,1},1},{{0,1006040553,1},1},{{0,1008040553,1},1},{{0,1010040553,1},1},{{0,1001040553,1},1}]','[]','[1002040553,1004040553,1006040553,1008040553,1010040553,1001040553]'),(32080556,0,1000,0,1,0,1,0,'[{{0,1007010553,1},1},{{0,1003000553,1},1},{{0,1005000553,1},1},{{0,1009000553,1},1}]','[]','[1007010553,1003000553,1005000553,1009000553]'),(32080556,0,1000,0,2,0,1,0,'[{{0,1007020553,1},1},{{0,1003000553,1},1},{{0,1005000553,1},1},{{0,1009000553,1},1}]','[]','[1007020553,1003000553,1005000553,1009000553]'),(32080556,0,1000,0,3,0,1,0,'[{{0,1007030553,1},1},{{0,1003000553,1},1},{{0,1005000553,1},1},{{0,1009000553,1},1}]','[]','[1007030553,1003000553,1005000553,1009000553]'),(32080556,0,1000,0,4,0,1,0,'[{{0,1007040553,1},1},{{0,1003000553,1},1},{{0,1005000553,1},1},{{0,1009000553,1},1}]','[]','[1007040553,1003000553,1005000553,1009000553]'),(32080557,0,1000,0,1,0,1,0,'[{{0,1007010553,1},1},{{0,1003000553,1},1}]','[]','[1007010553,1003000553]'),(32080557,0,1000,0,2,0,1,0,'[{{0,1007020553,1},1},{{0,1003000553,1},1}]','[]','[1007020553,1003000553]'),(32080557,0,1000,0,3,0,1,0,'[{{0,1007030553,1},1},{{0,1003000553,1},1}]','[]','[1007030553,1003000553]'),(32080557,0,1000,0,4,0,1,0,'[{{0,1007040553,1},1},{{0,1003000553,1},1}]','[]','[1007040553,1003000553]'),(32080558,0,1000,0,0,0,1,0,'[{{0,1005000553,1},1},{{0,1009000553,1},1}]','[]','[1005000553,1009000553]'),(32080561,0,1000,0,1,0,1,0,'[{{0,1001010563,1},1},{{0,1002010563,1},1},{{0,1003000563,1},1},{{0,1004010563,1},1},{{0,1006010563,1},1},{{0,1007010563,1},1},{{0,1008010563,1},1},{{0,1010010563,1},1}]','[]','[1001010563,1002010563,1003000563,1004010563,1005000563,1006010563,1007010563,1008010563,1009000563,1010010563]'),(32080561,0,1000,0,2,0,1,0,'[{{0,1001020563,1},1},{{0,1002020563,1},1},{{0,1003000563,1},1},{{0,1004020563,1},1},{{0,1006020563,1},1},{{0,1007020563,1},1},{{0,1008020563,1},1},{{0,1010020563,1},1}]','[]','[1001020563,1002020563,1003000563,1004020563,1005000563,1006020563,1007020563,1008020563,1009000563,1010020563]'),(32080561,0,1000,0,3,0,1,0,'[{{0,1001030563,1},1},{{0,1002030563,1},1},{{0,1003000563,1},1},{{0,1004030563,1},1},{{0,1006030563,1},1},{{0,1007030563,1},1},{{0,1008030563,1},1},{{0,1010030563,1},1}]','[]','[1001030563,1002030563,1003000563,1004030563,1005000563,1006030563,1007030563,1008030563,1009000563,1010030563]'),(32080561,0,1000,0,4,0,1,0,'[{{0,1001040563,1},1},{{0,1002040563,1},1},{{0,1003000563,1},1},{{0,1004040563,1},1},{{0,1006040563,1},1},{{0,1007040563,1},1},{{0,1008040563,1},1},{{0,1010040563,1},1}]','[]','[1001040563,1002040563,1003000563,1004040563,1005000563,1006040563,1007040563,1008040563,1009000563,1010040563]'),(32080562,0,1000,0,1,0,1,0,'[{{0,1002010563,1},1},{{0,1004010563,1},1},{{0,1006010563,1},1},{{0,1008010563,1},1},{{0,1010010563,1},1}]','[]','[1002010563,1004010563,1006010563,1008010563,1010010563]'),(32080562,0,1000,0,2,0,1,0,'[{{0,1002020563,1},1},{{0,1004020563,1},1},{{0,1006020563,1},1},{{0,1008020563,1},1},{{0,1010020563,1},1}]','[]','[1002020563,1004020563,1006020563,1008020563,1010020563]'),(32080562,0,1000,0,3,0,1,0,'[{{0,1002030563,1},1},{{0,1004030563,1},1},{{0,1006030563,1},1},{{0,1008030563,1},1},{{0,1010030563,1},1}]','[]','[1002030563,1004030563,1006030563,1008030563,1010030563]'),(32080562,0,1000,0,4,0,1,0,'[{{0,1002040563,1},1},{{0,1004040563,1},1},{{0,1006040563,1},1},{{0,1008040563,1},1},{{0,1010040563,1},1}]','[]','[1002040563,1004040563,1006040563,1008040563,1010040563]'),(32080563,0,1000,0,1,0,1,0,'[{{0,1001010563,1},1},{{0,1007010563,1},1}]','[]','[1001010563,1007010563]'),(32080563,0,1000,0,2,0,1,0,'[{{0,1001020563,1},1},{{0,1007020563,1},1}]','[]','[1001020563,1007020563]'),(32080563,0,1000,0,3,0,1,0,'[{{0,1001030563,1},1},{{0,1007030563,1},1}]','[]','[1001030563,1007030563]'),(32080563,0,1000,0,4,0,1,0,'[{{0,1001040563,1},1},{{0,1007040563,1},1}]','[]','[1001040563,1007040563]'),(32080565,0,1000,0,1,0,1,0,'[{{0,1002010563,1},1},{{0,1004010563,1},1},{{0,1006010563,1},1},{{0,1008010563,1},1},{{0,1010010563,1},1},{{0,1001010563,1},1}]','[]','[1002010563,1004010563,1006010563,1008010563,1010010563,1001010563]'),(32080565,0,1000,0,2,0,1,0,'[{{0,1002020563,1},1},{{0,1004020563,1},1},{{0,1006020563,1},1},{{0,1008020563,1},1},{{0,1010020563,1},1},{{0,1001020563,1},1}]','[]','[1002020563,1004020563,1006020563,1008020563,1010020563,1001020563]'),(32080565,0,1000,0,3,0,1,0,'[{{0,1002030563,1},1},{{0,1004030563,1},1},{{0,1006030563,1},1},{{0,1008030563,1},1},{{0,1010030563,1},1},{{0,1001030563,1},1}]','[]','[1002030563,1004030563,1006030563,1008030563,1010030563,1001030563]'),(32080565,0,1000,0,4,0,1,0,'[{{0,1002040563,1},1},{{0,1004040563,1},1},{{0,1006040563,1},1},{{0,1008040563,1},1},{{0,1010040563,1},1},{{0,1001040563,1},1}]','[]','[1002040563,1004040563,1006040563,1008040563,1010040563,1001040563]'),(32080566,0,1000,0,1,0,1,0,'[{{0,1007010563,1},1},{{0,1003000563,1},1},{{0,1005000563,1},1},{{0,1009000563,1},1}]','[]','[1007010563,1003000563,1005000563,1009000563]'),(32080566,0,1000,0,2,0,1,0,'[{{0,1007020563,1},1},{{0,1003000563,1},1},{{0,1005000563,1},1},{{0,1009000563,1},1}]','[]','[1007020563,1003000563,1005000563,1009000563]'),(32080566,0,1000,0,3,0,1,0,'[{{0,1007030563,1},1},{{0,1003000563,1},1},{{0,1005000563,1},1},{{0,1009000563,1},1}]','[]','[1007030563,1003000563,1005000563,1009000563]'),(32080566,0,1000,0,4,0,1,0,'[{{0,1007040563,1},1},{{0,1003000563,1},1},{{0,1005000563,1},1},{{0,1009000563,1},1}]','[]','[1007040563,1003000563,1005000563,1009000563]'),(32080567,0,1000,0,1,0,1,0,'[{{0,1007010563,1},1},{{0,1003000563,1},1}]','[]','[1007010563,1003000563]'),(32080567,0,1000,0,2,0,1,0,'[{{0,1007020563,1},1},{{0,1003000563,1},1}]','[]','[1007020563,1003000563]'),(32080567,0,1000,0,3,0,1,0,'[{{0,1007030563,1},1},{{0,1003000563,1},1}]','[]','[1007030563,1003000563]'),(32080567,0,1000,0,4,0,1,0,'[{{0,1007040563,1},1},{{0,1003000563,1},1}]','[]','[1007040563,1003000563]'),(32080568,0,1000,0,0,0,1,0,'[{{0,1005000563,1},1},{{0,1009000563,1},1}]','[]','[1005000563,1009000563]'),(32080571,0,1000,0,1,0,1,0,'[{{0,1001010500,1},1},{{0,1002010500,1},1},{{0,1003000500,1},1},{{0,1004010500,1},1},{{0,1006010500,1},1},{{0,1007010500,1},1},{{0,1008010500,1},1},{{0,1010010500,1},1}]','[]','[]'),(32080571,0,1000,0,2,0,1,0,'[{{0,1001020500,1},1},{{0,1002020500,1},1},{{0,1003000500,1},1},{{0,1004020500,1},1},{{0,1006020500,1},1},{{0,1007020500,1},1},{{0,1008020500,1},1},{{0,1010020500,1},1}]','[]','[]'),(32080571,0,1000,0,3,0,1,0,'[{{0,1001030500,1},1},{{0,1002030500,1},1},{{0,1003000500,1},1},{{0,1004030500,1},1},{{0,1006030500,1},1},{{0,1007030500,1},1},{{0,1008030500,1},1},{{0,1010030500,1},1}]','[]','[]'),(32080571,0,1000,0,4,0,1,0,'[{{0,1001040500,1},1},{{0,1002040500,1},1},{{0,1003000500,1},1},{{0,1004040500,1},1},{{0,1006040500,1},1},{{0,1007040500,1},1},{{0,1008040500,1},1},{{0,1010040500,1},1}]','[]','[]'),(32080572,0,1000,0,1,0,1,0,'[{{0,1002010500,1},1},{{0,1004010500,1},1},{{0,1006010500,1},1},{{0,1008010500,1},1},{{0,1010010500,1},1}]','[]','[]'),(32080572,0,1000,0,2,0,1,0,'[{{0,1002020500,1},1},{{0,1004020500,1},1},{{0,1006020500,1},1},{{0,1008020500,1},1},{{0,1010020500,1},1}]','[]','[]'),(32080572,0,1000,0,3,0,1,0,'[{{0,1002030500,1},1},{{0,1004030500,1},1},{{0,1006030500,1},1},{{0,1008030500,1},1},{{0,1010030500,1},1}]','[]','[]'),(32080572,0,1000,0,4,0,1,0,'[{{0,1002040500,1},1},{{0,1004040500,1},1},{{0,1006040500,1},1},{{0,1008040500,1},1},{{0,1010040500,1},1}]','[]','[]'),(32080573,0,1000,0,1,0,1,0,'[{{0,1001010500,1},1},{{0,1007010500,1},1}]','[]','[]'),(32080573,0,1000,0,2,0,1,0,'[{{0,1001020500,1},1},{{0,1007020500,1},1}]','[]','[]'),(32080573,0,1000,0,3,0,1,0,'[{{0,1001030500,1},1},{{0,1007030500,1},1}]','[]','[]'),(32080573,0,1000,0,4,0,1,0,'[{{0,1001040500,1},1},{{0,1007040500,1},1}]','[]','[]'),(32080575,0,1000,0,1,0,1,0,'[{{0,1002010500,1},1},{{0,1004010500,1},1},{{0,1006010500,1},1},{{0,1008010500,1},1},{{0,1010010500,1},1},{{0,1001010500,1},1}]','[]','[]'),(32080575,0,1000,0,2,0,1,0,'[{{0,1002020500,1},1},{{0,1004020500,1},1},{{0,1006020500,1},1},{{0,1008020500,1},1},{{0,1010020500,1},1},{{0,1001020500,1},1}]','[]','[]'),(32080575,0,1000,0,3,0,1,0,'[{{0,1002030500,1},1},{{0,1004030500,1},1},{{0,1006030500,1},1},{{0,1008030500,1},1},{{0,1010030500,1},1},{{0,1001030500,1},1}]','[]','[]'),(32080575,0,1000,0,4,0,1,0,'[{{0,1002040500,1},1},{{0,1004040500,1},1},{{0,1006040500,1},1},{{0,1008040500,1},1},{{0,1010040500,1},1},{{0,1001040500,1},1}]','[]','[]'),(32080576,0,1000,0,1,0,1,0,'[{{0,1007010500,1},1},{{0,1003000500,1},1},{{0,1005000500,1},1},{{0,1009000500,1},1}]','[]','[]'),(32080576,0,1000,0,2,0,1,0,'[{{0,1007020500,1},1},{{0,1003000500,1},1},{{0,1005000500,1},1},{{0,1009000500,1},1}]','[]','[]'),(32080576,0,1000,0,3,0,1,0,'[{{0,1007030500,1},1},{{0,1003000500,1},1},{{0,1005000500,1},1},{{0,1009000500,1},1}]','[]','[]'),(32080576,0,1000,0,4,0,1,0,'[{{0,1007040500,1},1},{{0,1003000500,1},1},{{0,1005000500,1},1},{{0,1009000500,1},1}]','[]','[]'),(32080577,0,1000,0,1,0,1,0,'[{{0,1007010500,1},1},{{0,1003000500,1},1}]','[]','[]'),(32080577,0,1000,0,2,0,1,0,'[{{0,1007020500,1},1},{{0,1003000500,1},1}]','[]','[]'),(32080577,0,1000,0,3,0,1,0,'[{{0,1007030500,1},1},{{0,1003000500,1},1}]','[]','[]'),(32080577,0,1000,0,4,0,1,0,'[{{0,1007040500,1},1},{{0,1003000500,1},1}]','[]','[]'),(32080578,0,1000,0,0,0,1,0,'[{{0,1005000500,1},1},{{0,1009000500,1},1}]','[]','[]'),(32080581,0,1000,0,1,0,1,0,'[{{0,1001010510,1},1},{{0,1002010510,1},1},{{0,1003000510,1},1},{{0,1004010510,1},1},{{0,1006010510,1},1},{{0,1007010510,1},1},{{0,1008010510,1},1},{{0,1010010510,1},1}]','[]','[]'),(32080581,0,1000,0,2,0,1,0,'[{{0,1001020510,1},1},{{0,1002020510,1},1},{{0,1003000510,1},1},{{0,1004020510,1},1},{{0,1006020510,1},1},{{0,1007020510,1},1},{{0,1008020510,1},1},{{0,1010020510,1},1}]','[]','[]'),(32080581,0,1000,0,3,0,1,0,'[{{0,1001030510,1},1},{{0,1002030510,1},1},{{0,1003000510,1},1},{{0,1004030510,1},1},{{0,1006030510,1},1},{{0,1007030510,1},1},{{0,1008030510,1},1},{{0,1010030510,1},1}]','[]','[]'),(32080581,0,1000,0,4,0,1,0,'[{{0,1001040510,1},1},{{0,1002040510,1},1},{{0,1003000510,1},1},{{0,1004040510,1},1},{{0,1006040510,1},1},{{0,1007040510,1},1},{{0,1008040510,1},1},{{0,1010040510,1},1}]','[]','[]'),(32080582,0,1000,0,1,0,1,0,'[{{0,1002010510,1},1},{{0,1004010510,1},1},{{0,1006010510,1},1},{{0,1008010510,1},1},{{0,1010010510,1},1}]','[]','[]'),(32080582,0,1000,0,2,0,1,0,'[{{0,1002020510,1},1},{{0,1004020510,1},1},{{0,1006020510,1},1},{{0,1008020510,1},1},{{0,1010020510,1},1}]','[]','[]'),(32080582,0,1000,0,3,0,1,0,'[{{0,1002030510,1},1},{{0,1004030510,1},1},{{0,1006030510,1},1},{{0,1008030510,1},1},{{0,1010030510,1},1}]','[]','[]'),(32080582,0,1000,0,4,0,1,0,'[{{0,1002040510,1},1},{{0,1004040510,1},1},{{0,1006040510,1},1},{{0,1008040510,1},1},{{0,1010040510,1},1}]','[]','[]'),(32080583,0,1000,0,1,0,1,0,'[{{0,1001010510,1},1},{{0,1007010510,1},1}]','[]','[]'),(32080583,0,1000,0,2,0,1,0,'[{{0,1001020510,1},1},{{0,1007020510,1},1}]','[]','[]'),(32080583,0,1000,0,3,0,1,0,'[{{0,1001030510,1},1},{{0,1007030510,1},1}]','[]','[]'),(32080583,0,1000,0,4,0,1,0,'[{{0,1001040510,1},1},{{0,1007040510,1},1}]','[]','[]'),(32080585,0,1000,0,1,0,1,0,'[{{0,1002010510,1},1},{{0,1004010510,1},1},{{0,1006010510,1},1},{{0,1008010510,1},1},{{0,1010010510,1},1},{{0,1001010510,1},1}]','[]','[]'),(32080585,0,1000,0,2,0,1,0,'[{{0,1002020510,1},1},{{0,1004020510,1},1},{{0,1006020510,1},1},{{0,1008020510,1},1},{{0,1010020510,1},1},{{0,1001020510,1},1}]','[]','[]'),(32080585,0,1000,0,3,0,1,0,'[{{0,1002030510,1},1},{{0,1004030510,1},1},{{0,1006030510,1},1},{{0,1008030510,1},1},{{0,1010030510,1},1},{{0,1001030510,1},1}]','[]','[]'),(32080585,0,1000,0,4,0,1,0,'[{{0,1002040510,1},1},{{0,1004040510,1},1},{{0,1006040510,1},1},{{0,1008040510,1},1},{{0,1010040510,1},1},{{0,1001040510,1},1}]','[]','[]'),(32080586,0,1000,0,1,0,1,0,'[{{0,1007010510,1},1},{{0,1003000510,1},1},{{0,1005000510,1},1},{{0,1009000510,1},1}]','[]','[]'),(32080586,0,1000,0,2,0,1,0,'[{{0,1007020510,1},1},{{0,1003000510,1},1},{{0,1005000510,1},1},{{0,1009000510,1},1}]','[]','[]'),(32080586,0,1000,0,3,0,1,0,'[{{0,1007030510,1},1},{{0,1003000510,1},1},{{0,1005000510,1},1},{{0,1009000510,1},1}]','[]','[]'),(32080586,0,1000,0,4,0,1,0,'[{{0,1007040510,1},1},{{0,1003000510,1},1},{{0,1005000510,1},1},{{0,1009000510,1},1}]','[]','[]'),(32080587,0,1000,0,1,0,1,0,'[{{0,1007010510,1},1},{{0,1003000510,1},1}]','[]','[]'),(32080587,0,1000,0,2,0,1,0,'[{{0,1007020510,1},1},{{0,1003000510,1},1}]','[]','[]'),(32080587,0,1000,0,3,0,1,0,'[{{0,1007030510,1},1},{{0,1003000510,1},1}]','[]','[]'),(32080587,0,1000,0,4,0,1,0,'[{{0,1007040510,1},1},{{0,1003000510,1},1}]','[]','[]'),(32080588,0,1000,0,0,0,1,0,'[{{0,1005000510,1},1},{{0,1009000510,1},1}]','[]','[]'),(32080591,0,1000,0,1,0,1,0,'[{{0,1001010520,1},1},{{0,1002010520,1},1},{{0,1003000520,1},1},{{0,1004010520,1},1},{{0,1006010520,1},1},{{0,1007010520,1},1},{{0,1008010520,1},1},{{0,1010010520,1},1}]','[]','[]'),(32080591,0,1000,0,2,0,1,0,'[{{0,1001020520,1},1},{{0,1002020520,1},1},{{0,1003000520,1},1},{{0,1004020520,1},1},{{0,1006020520,1},1},{{0,1007020520,1},1},{{0,1008020520,1},1},{{0,1010020520,1},1}]','[]','[]'),(32080591,0,1000,0,3,0,1,0,'[{{0,1001030520,1},1},{{0,1002030520,1},1},{{0,1003000520,1},1},{{0,1004030520,1},1},{{0,1006030520,1},1},{{0,1007030520,1},1},{{0,1008030520,1},1},{{0,1010030520,1},1}]','[]','[]'),(32080591,0,1000,0,4,0,1,0,'[{{0,1001040520,1},1},{{0,1002040520,1},1},{{0,1003000520,1},1},{{0,1004040520,1},1},{{0,1006040520,1},1},{{0,1007040520,1},1},{{0,1008040520,1},1},{{0,1010040520,1},1}]','[]','[]'),(32080592,0,1000,0,1,0,1,0,'[{{0,1002010520,1},1},{{0,1004010520,1},1},{{0,1006010520,1},1},{{0,1008010520,1},1},{{0,1010010520,1},1}]','[]','[]'),(32080592,0,1000,0,2,0,1,0,'[{{0,1002020520,1},1},{{0,1004020520,1},1},{{0,1006020520,1},1},{{0,1008020520,1},1},{{0,1010020520,1},1}]','[]','[]'),(32080592,0,1000,0,3,0,1,0,'[{{0,1002030520,1},1},{{0,1004030520,1},1},{{0,1006030520,1},1},{{0,1008030520,1},1},{{0,1010030520,1},1}]','[]','[]'),(32080592,0,1000,0,4,0,1,0,'[{{0,1002040520,1},1},{{0,1004040520,1},1},{{0,1006040520,1},1},{{0,1008040520,1},1},{{0,1010040520,1},1}]','[]','[]'),(32080593,0,1000,0,1,0,1,0,'[{{0,1001010520,1},1},{{0,1007010520,1},1}]','[]','[]'),(32080593,0,1000,0,2,0,1,0,'[{{0,1001020520,1},1},{{0,1007020520,1},1}]','[]','[]'),(32080593,0,1000,0,3,0,1,0,'[{{0,1001030520,1},1},{{0,1007030520,1},1}]','[]','[]'),(32080593,0,1000,0,4,0,1,0,'[{{0,1001040520,1},1},{{0,1007040520,1},1}]','[]','[]'),(32080595,0,1000,0,1,0,1,0,'[{{0,1002010520,1},1},{{0,1004010520,1},1},{{0,1006010520,1},1},{{0,1008010520,1},1},{{0,1010010520,1},1},{{0,1001010520,1},1}]','[]','[]'),(32080595,0,1000,0,2,0,1,0,'[{{0,1002020520,1},1},{{0,1004020520,1},1},{{0,1006020520,1},1},{{0,1008020520,1},1},{{0,1010020520,1},1},{{0,1001020520,1},1}]','[]','[]'),(32080595,0,1000,0,3,0,1,0,'[{{0,1002030520,1},1},{{0,1004030520,1},1},{{0,1006030520,1},1},{{0,1008030520,1},1},{{0,1010030520,1},1},{{0,1001030520,1},1}]','[]','[]'),(32080595,0,1000,0,4,0,1,0,'[{{0,1002040520,1},1},{{0,1004040520,1},1},{{0,1006040520,1},1},{{0,1008040520,1},1},{{0,1010040520,1},1},{{0,1001040520,1},1}]','[]','[]'),(32080596,0,1000,0,1,0,1,0,'[{{0,1007010520,1},1},{{0,1003000520,1},1},{{0,1005000520,1},1},{{0,1009000520,1},1}]','[]','[]'),(32080596,0,1000,0,2,0,1,0,'[{{0,1007020520,1},1},{{0,1003000520,1},1},{{0,1005000520,1},1},{{0,1009000520,1},1}]','[]','[]'),(32080596,0,1000,0,3,0,1,0,'[{{0,1007030520,1},1},{{0,1003000520,1},1},{{0,1005000520,1},1},{{0,1009000520,1},1}]','[]','[]'),(32080596,0,1000,0,4,0,1,0,'[{{0,1007040520,1},1},{{0,1003000520,1},1},{{0,1005000520,1},1},{{0,1009000520,1},1}]','[]','[]'),(32080597,0,1000,0,1,0,1,0,'[{{0,1007010520,1},1},{{0,1003000520,1},1}]','[]','[]'),(32080597,0,1000,0,2,0,1,0,'[{{0,1007020520,1},1},{{0,1003000520,1},1}]','[]','[]'),(32080597,0,1000,0,3,0,1,0,'[{{0,1007030520,1},1},{{0,1003000520,1},1}]','[]','[]'),(32080597,0,1000,0,4,0,1,0,'[{{0,1007040520,1},1},{{0,1003000520,1},1}]','[]','[]'),(32080598,0,1000,0,0,0,1,0,'[{{0,1005000520,1},1},{{0,1009000520,1},1}]','[]','[]'),(32080601,0,1000,0,1,0,1,0,'[{{0,1001010531,1},1},{{0,1002010531,1},1},{{0,1003000531,1},1},{{0,1004010531,1},1},{{0,1006010531,1},1},{{0,1007010531,1},1},{{0,1008010531,1},1},{{0,1010010531,1},1}]','[]','[]'),(32080601,0,1000,0,2,0,1,0,'[{{0,1001020531,1},1},{{0,1002020531,1},1},{{0,1003000531,1},1},{{0,1004020531,1},1},{{0,1006020531,1},1},{{0,1007020531,1},1},{{0,1008020531,1},1},{{0,1010020531,1},1}]','[]','[]'),(32080601,0,1000,0,3,0,1,0,'[{{0,1001030531,1},1},{{0,1002030531,1},1},{{0,1003000531,1},1},{{0,1004030531,1},1},{{0,1006030531,1},1},{{0,1007030531,1},1},{{0,1008030531,1},1},{{0,1010030531,1},1}]','[]','[]'),(32080601,0,1000,0,4,0,1,0,'[{{0,1001040531,1},1},{{0,1002040531,1},1},{{0,1003000531,1},1},{{0,1004040531,1},1},{{0,1006040531,1},1},{{0,1007040531,1},1},{{0,1008040531,1},1},{{0,1010040531,1},1}]','[]','[]'),(32080602,0,1000,0,1,0,1,0,'[{{0,1002010531,1},1},{{0,1004010531,1},1},{{0,1006010531,1},1},{{0,1008010531,1},1},{{0,1010010531,1},1}]','[]','[]'),(32080602,0,1000,0,2,0,1,0,'[{{0,1002020531,1},1},{{0,1004020531,1},1},{{0,1006020531,1},1},{{0,1008020531,1},1},{{0,1010020531,1},1}]','[]','[]'),(32080602,0,1000,0,3,0,1,0,'[{{0,1002030531,1},1},{{0,1004030531,1},1},{{0,1006030531,1},1},{{0,1008030531,1},1},{{0,1010030531,1},1}]','[]','[]'),(32080602,0,1000,0,4,0,1,0,'[{{0,1002040531,1},1},{{0,1004040531,1},1},{{0,1006040531,1},1},{{0,1008040531,1},1},{{0,1010040531,1},1}]','[]','[]'),(32080603,0,1000,0,1,0,1,0,'[{{0,1001010531,1},1},{{0,1007010531,1},1}]','[]','[]'),(32080603,0,1000,0,2,0,1,0,'[{{0,1001020531,1},1},{{0,1007020531,1},1}]','[]','[]'),(32080603,0,1000,0,3,0,1,0,'[{{0,1001030531,1},1},{{0,1007030531,1},1}]','[]','[]'),(32080603,0,1000,0,4,0,1,0,'[{{0,1001040531,1},1},{{0,1007040531,1},1}]','[]','[]'),(32080605,0,1000,0,1,0,1,0,'[{{0,1002010531,1},1},{{0,1004010531,1},1},{{0,1006010531,1},1},{{0,1008010531,1},1},{{0,1010010531,1},1},{{0,1001010531,1},1}]','[]','[]'),(32080605,0,1000,0,2,0,1,0,'[{{0,1002020531,1},1},{{0,1004020531,1},1},{{0,1006020531,1},1},{{0,1008020531,1},1},{{0,1010020531,1},1},{{0,1001020531,1},1}]','[]','[]'),(32080605,0,1000,0,3,0,1,0,'[{{0,1002030531,1},1},{{0,1004030531,1},1},{{0,1006030531,1},1},{{0,1008030531,1},1},{{0,1010030531,1},1},{{0,1001030531,1},1}]','[]','[]'),(32080605,0,1000,0,4,0,1,0,'[{{0,1002040531,1},1},{{0,1004040531,1},1},{{0,1006040531,1},1},{{0,1008040531,1},1},{{0,1010040531,1},1},{{0,1001040531,1},1}]','[]','[]'),(32080606,0,1000,0,1,0,1,0,'[{{0,1007010531,1},1},{{0,1003000531,1},1},{{0,1005000531,1},1},{{0,1009000531,1},1}]','[]','[]'),(32080606,0,1000,0,2,0,1,0,'[{{0,1007020531,1},1},{{0,1003000531,1},1},{{0,1005000531,1},1},{{0,1009000531,1},1}]','[]','[]'),(32080606,0,1000,0,3,0,1,0,'[{{0,1007030531,1},1},{{0,1003000531,1},1},{{0,1005000531,1},1},{{0,1009000531,1},1}]','[]','[]'),(32080606,0,1000,0,4,0,1,0,'[{{0,1007040531,1},1},{{0,1003000531,1},1},{{0,1005000531,1},1},{{0,1009000531,1},1}]','[]','[]'),(32080607,0,1000,0,1,0,1,0,'[{{0,1007010531,1},1},{{0,1003000531,1},1}]','[]','[]'),(32080607,0,1000,0,2,0,1,0,'[{{0,1007020531,1},1},{{0,1003000531,1},1}]','[]','[]'),(32080607,0,1000,0,3,0,1,0,'[{{0,1007030531,1},1},{{0,1003000531,1},1}]','[]','[]'),(32080607,0,1000,0,4,0,1,0,'[{{0,1007040531,1},1},{{0,1003000531,1},1}]','[]','[]'),(32080608,0,1000,0,0,0,1,0,'[{{0,1005000531,1},1},{{0,1009000531,1},1}]','[]','[]'),(32080611,0,1000,0,1,0,1,0,'[{{0,1001010632,1},1},{{0,1002010632,1},1},{{0,1003000632,1},1},{{0,1004010632,1},1},{{0,1006010632,1},1},{{0,1007010632,1},1},{{0,1008010632,1},1},{{0,1010010632,1},1}]','[]','[1001010632,1002010632,1003000632,1004010632,1005000632,1006010632,1007010632,1008010632,1009000632,1010010632]'),(32080611,0,1000,0,2,0,1,0,'[{{0,1001020632,1},1},{{0,1002020632,1},1},{{0,1003000632,1},1},{{0,1004020632,1},1},{{0,1006020632,1},1},{{0,1007020632,1},1},{{0,1008020632,1},1},{{0,1010020632,1},1}]','[]','[1001020632,1002020632,1003000632,1004020632,1005000632,1006020632,1007020632,1008020632,1009000632,1010020632]'),(32080611,0,1000,0,3,0,1,0,'[{{0,1001030632,1},1},{{0,1002030632,1},1},{{0,1003000632,1},1},{{0,1004030632,1},1},{{0,1006030632,1},1},{{0,1007030632,1},1},{{0,1008030632,1},1},{{0,1010030632,1},1}]','[]','[1001030632,1002030632,1003000632,1004030632,1005000632,1006030632,1007030632,1008030632,1009000632,1010030632]'),(32080611,0,1000,0,4,0,1,0,'[{{0,1001040632,1},1},{{0,1002040632,1},1},{{0,1003000632,1},1},{{0,1004040632,1},1},{{0,1006040632,1},1},{{0,1007040632,1},1},{{0,1008040632,1},1},{{0,1010040632,1},1}]','[]','[1001040632,1002040632,1003000632,1004040632,1005000632,1006040632,1007040632,1008040632,1009000632,1010040632]'),(32080612,0,1000,0,1,0,1,0,'[{{0,1002010632,1},1},{{0,1004010632,1},1},{{0,1006010632,1},1},{{0,1008010632,1},1},{{0,1010010632,1},1}]','[]','[1002010632,1004010632,1006010632,1008010632,1010010632]'),(32080612,0,1000,0,2,0,1,0,'[{{0,1002020632,1},1},{{0,1004020632,1},1},{{0,1006020632,1},1},{{0,1008020632,1},1},{{0,1010020632,1},1}]','[]','[1002020632,1004020632,1006020632,1008020632,1010020632]'),(32080612,0,1000,0,3,0,1,0,'[{{0,1002030632,1},1},{{0,1004030632,1},1},{{0,1006030632,1},1},{{0,1008030632,1},1},{{0,1010030632,1},1}]','[]','[1002030632,1004030632,1006030632,1008030632,1010030632]'),(32080612,0,1000,0,4,0,1,0,'[{{0,1002040632,1},1},{{0,1004040632,1},1},{{0,1006040632,1},1},{{0,1008040632,1},1},{{0,1010040632,1},1}]','[]','[1002040632,1004040632,1006040632,1008040632,1010040632]'),(32080613,0,1000,0,1,0,1,0,'[{{0,1001010632,1},1},{{0,1007010632,1},1}]','[]','[1001010632,1007010632]'),(32080613,0,1000,0,2,0,1,0,'[{{0,1001020632,1},1},{{0,1007020632,1},1}]','[]','[1001020632,1007020632]'),(32080613,0,1000,0,3,0,1,0,'[{{0,1001030632,1},1},{{0,1007030632,1},1}]','[]','[1001030632,1007030632]'),(32080613,0,1000,0,4,0,1,0,'[{{0,1001040632,1},1},{{0,1007040632,1},1}]','[]','[1001040632,1007040632]'),(32080615,0,1000,0,1,0,1,0,'[{{0,1002010632,1},1},{{0,1004010632,1},1},{{0,1006010632,1},1},{{0,1008010632,1},1},{{0,1010010632,1},1},{{0,1001010632,1},1}]','[]','[1002010632,1004010632,1006010632,1008010632,1010010632,1001010632]'),(32080615,0,1000,0,2,0,1,0,'[{{0,1002020632,1},1},{{0,1004020632,1},1},{{0,1006020632,1},1},{{0,1008020632,1},1},{{0,1010020632,1},1},{{0,1001020632,1},1}]','[]','[1002020632,1004020632,1006020632,1008020632,1010020632,1001020632]'),(32080615,0,1000,0,3,0,1,0,'[{{0,1002030632,1},1},{{0,1004030632,1},1},{{0,1006030632,1},1},{{0,1008030632,1},1},{{0,1010030632,1},1},{{0,1001030632,1},1}]','[]','[1002030632,1004030632,1006030632,1008030632,1010030632,1001030632]'),(32080615,0,1000,0,4,0,1,0,'[{{0,1002040632,1},1},{{0,1004040632,1},1},{{0,1006040632,1},1},{{0,1008040632,1},1},{{0,1010040632,1},1},{{0,1001040632,1},1}]','[]','[1002040632,1004040632,1006040632,1008040632,1010040632,1001040632]'),(32080616,0,1000,0,1,0,1,0,'[{{0,1007010632,1},1},{{0,1003000632,1},1},{{0,1005000632,1},1},{{0,1009000632,1},1}]','[]','[1007010632,1003000632,1005000632,1009000632]'),(32080616,0,1000,0,2,0,1,0,'[{{0,1007020632,1},1},{{0,1003000632,1},1},{{0,1005000632,1},1},{{0,1009000632,1},1}]','[]','[1007020632,1003000632,1005000632,1009000632]'),(32080616,0,1000,0,3,0,1,0,'[{{0,1007030632,1},1},{{0,1003000632,1},1},{{0,1005000632,1},1},{{0,1009000632,1},1}]','[]','[1007030632,1003000632,1005000632,1009000632]'),(32080616,0,1000,0,4,0,1,0,'[{{0,1007040632,1},1},{{0,1003000632,1},1},{{0,1005000632,1},1},{{0,1009000632,1},1}]','[]','[1007040632,1003000632,1005000632,1009000632]'),(32080617,0,1000,0,1,0,1,0,'[{{0,1007010632,1},1},{{0,1003000632,1},1}]','[]','[1007010632,1003000632]'),(32080617,0,1000,0,2,0,1,0,'[{{0,1007020632,1},1},{{0,1003000632,1},1}]','[]','[1007020632,1003000632]'),(32080617,0,1000,0,3,0,1,0,'[{{0,1007030632,1},1},{{0,1003000632,1},1}]','[]','[1007030632,1003000632]'),(32080617,0,1000,0,4,0,1,0,'[{{0,1007040632,1},1},{{0,1003000632,1},1}]','[]','[1007040632,1003000632]'),(32080618,0,1000,0,0,0,1,0,'[{{0,1005000632,1},1},{{0,1009000632,1},1}]','[]','[1005000632,1009000632]'),(32080621,0,1000,0,1,0,1,0,'[{{0,1001010641,1},1},{{0,1002010641,1},1},{{0,1003000641,1},1},{{0,1004010641,1},1},{{0,1006010641,1},1},{{0,1007010641,1},1},{{0,1008010641,1},1},{{0,1010010641,1},1}]','[]','[]'),(32080621,0,1000,0,2,0,1,0,'[{{0,1001020641,1},1},{{0,1002020641,1},1},{{0,1003000641,1},1},{{0,1004020641,1},1},{{0,1006020641,1},1},{{0,1007020641,1},1},{{0,1008020641,1},1},{{0,1010020641,1},1}]','[]','[]'),(32080621,0,1000,0,3,0,1,0,'[{{0,1001030641,1},1},{{0,1002030641,1},1},{{0,1003000641,1},1},{{0,1004030641,1},1},{{0,1006030641,1},1},{{0,1007030641,1},1},{{0,1008030641,1},1},{{0,1010030641,1},1}]','[]','[]'),(32080621,0,1000,0,4,0,1,0,'[{{0,1001040641,1},1},{{0,1002040641,1},1},{{0,1003000641,1},1},{{0,1004040641,1},1},{{0,1006040641,1},1},{{0,1007040641,1},1},{{0,1008040641,1},1},{{0,1010040641,1},1}]','[]','[]'),(32080622,0,1000,0,1,0,1,0,'[{{0,1002010641,1},1},{{0,1004010641,1},1},{{0,1006010641,1},1},{{0,1008010641,1},1},{{0,1010010641,1},1}]','[]','[]'),(32080622,0,1000,0,2,0,1,0,'[{{0,1002020641,1},1},{{0,1004020641,1},1},{{0,1006020641,1},1},{{0,1008020641,1},1},{{0,1010020641,1},1}]','[]','[]'),(32080622,0,1000,0,3,0,1,0,'[{{0,1002030641,1},1},{{0,1004030641,1},1},{{0,1006030641,1},1},{{0,1008030641,1},1},{{0,1010030641,1},1}]','[]','[]'),(32080622,0,1000,0,4,0,1,0,'[{{0,1002040641,1},1},{{0,1004040641,1},1},{{0,1006040641,1},1},{{0,1008040641,1},1},{{0,1010040641,1},1}]','[]','[]'),(32080623,0,1000,0,1,0,1,0,'[{{0,1001010641,1},1},{{0,1007010641,1},1}]','[]','[]'),(32080623,0,1000,0,2,0,1,0,'[{{0,1001020641,1},1},{{0,1007020641,1},1}]','[]','[]'),(32080623,0,1000,0,3,0,1,0,'[{{0,1001030641,1},1},{{0,1007030641,1},1}]','[]','[]'),(32080623,0,1000,0,4,0,1,0,'[{{0,1001040641,1},1},{{0,1007040641,1},1}]','[]','[]'),(32080625,0,1000,0,1,0,1,0,'[{{0,1002010641,1},1},{{0,1004010641,1},1},{{0,1006010641,1},1},{{0,1008010641,1},1},{{0,1010010641,1},1},{{0,1001010641,1},1}]','[]','[]'),(32080625,0,1000,0,2,0,1,0,'[{{0,1002020641,1},1},{{0,1004020641,1},1},{{0,1006020641,1},1},{{0,1008020641,1},1},{{0,1010020641,1},1},{{0,1001020641,1},1}]','[]','[]'),(32080625,0,1000,0,3,0,1,0,'[{{0,1002030641,1},1},{{0,1004030641,1},1},{{0,1006030641,1},1},{{0,1008030641,1},1},{{0,1010030641,1},1},{{0,1001030641,1},1}]','[]','[]'),(32080625,0,1000,0,4,0,1,0,'[{{0,1002040641,1},1},{{0,1004040641,1},1},{{0,1006040641,1},1},{{0,1008040641,1},1},{{0,1010040641,1},1},{{0,1001040641,1},1}]','[]','[]'),(32080626,0,1000,0,1,0,1,0,'[{{0,1007010641,1},1},{{0,1003000641,1},1},{{0,1005000641,1},1},{{0,1009000641,1},1}]','[]','[]'),(32080626,0,1000,0,2,0,1,0,'[{{0,1007020641,1},1},{{0,1003000641,1},1},{{0,1005000641,1},1},{{0,1009000641,1},1}]','[]','[]'),(32080626,0,1000,0,3,0,1,0,'[{{0,1007030641,1},1},{{0,1003000641,1},1},{{0,1005000641,1},1},{{0,1009000641,1},1}]','[]','[]'),(32080626,0,1000,0,4,0,1,0,'[{{0,1007040641,1},1},{{0,1003000641,1},1},{{0,1005000641,1},1},{{0,1009000641,1},1}]','[]','[]'),(32080627,0,1000,0,1,0,1,0,'[{{0,1007010641,1},1},{{0,1003000641,1},1}]','[]','[]'),(32080627,0,1000,0,2,0,1,0,'[{{0,1007020641,1},1},{{0,1003000641,1},1}]','[]','[]'),(32080627,0,1000,0,3,0,1,0,'[{{0,1007030641,1},1},{{0,1003000641,1},1}]','[]','[]'),(32080627,0,1000,0,4,0,1,0,'[{{0,1007040641,1},1},{{0,1003000641,1},1}]','[]','[]'),(32080628,0,1000,0,0,0,1,0,'[{{0,1005000641,1},1},{{0,1009000641,1},1}]','[]','[]'),(32080631,0,1000,0,1,0,1,0,'[{{0,1001010642,1},1},{{0,1002010642,1},1},{{0,1003000642,1},1},{{0,1004010642,1},1},{{0,1006010642,1},1},{{0,1007010642,1},1},{{0,1008010642,1},1},{{0,1010010642,1},1}]','[]','[1001010642,1002010642,1003000642,1004010642,1005000642,1006010642,1007010642,1008010642,1009000642,1010010642]'),(32080631,0,1000,0,2,0,1,0,'[{{0,1001020642,1},1},{{0,1002020642,1},1},{{0,1003000642,1},1},{{0,1004020642,1},1},{{0,1006020642,1},1},{{0,1007020642,1},1},{{0,1008020642,1},1},{{0,1010020642,1},1}]','[]','[1001020642,1002020642,1003000642,1004020642,1005000642,1006020642,1007020642,1008020642,1009000642,1010020642]'),(32080631,0,1000,0,3,0,1,0,'[{{0,1001030642,1},1},{{0,1002030642,1},1},{{0,1003000642,1},1},{{0,1004030642,1},1},{{0,1006030642,1},1},{{0,1007030642,1},1},{{0,1008030642,1},1},{{0,1010030642,1},1}]','[]','[1001030642,1002030642,1003000642,1004030642,1005000642,1006030642,1007030642,1008030642,1009000642,1010030642]'),(32080631,0,1000,0,4,0,1,0,'[{{0,1001040642,1},1},{{0,1002040642,1},1},{{0,1003000642,1},1},{{0,1004040642,1},1},{{0,1006040642,1},1},{{0,1007040642,1},1},{{0,1008040642,1},1},{{0,1010040642,1},1}]','[]','[1001040642,1002040642,1003000642,1004040642,1005000642,1006040642,1007040642,1008040642,1009000642,1010040642]'),(32080632,0,1000,0,1,0,1,0,'[{{0,1002010642,1},1},{{0,1004010642,1},1},{{0,1006010642,1},1},{{0,1008010642,1},1},{{0,1010010642,1},1}]','[]','[1002010642,1004010642,1006010642,1008010642,1010010642]'),(32080632,0,1000,0,2,0,1,0,'[{{0,1002020642,1},1},{{0,1004020642,1},1},{{0,1006020642,1},1},{{0,1008020642,1},1},{{0,1010020642,1},1}]','[]','[1002020642,1004020642,1006020642,1008020642,1010020642]'),(32080632,0,1000,0,3,0,1,0,'[{{0,1002030642,1},1},{{0,1004030642,1},1},{{0,1006030642,1},1},{{0,1008030642,1},1},{{0,1010030642,1},1}]','[]','[1002030642,1004030642,1006030642,1008030642,1010030642]'),(32080632,0,1000,0,4,0,1,0,'[{{0,1002040642,1},1},{{0,1004040642,1},1},{{0,1006040642,1},1},{{0,1008040642,1},1},{{0,1010040642,1},1}]','[]','[1002040642,1004040642,1006040642,1008040642,1010040642]'),(32080633,0,1000,0,1,0,1,0,'[{{0,1001010642,1},1},{{0,1007010642,1},1}]','[]','[1001010642,1007010642]'),(32080633,0,1000,0,2,0,1,0,'[{{0,1001020642,1},1},{{0,1007020642,1},1}]','[]','[1001020642,1007020642]'),(32080633,0,1000,0,3,0,1,0,'[{{0,1001030642,1},1},{{0,1007030642,1},1}]','[]','[1001030642,1007030642]'),(32080633,0,1000,0,4,0,1,0,'[{{0,1001040642,1},1},{{0,1007040642,1},1}]','[]','[1001040642,1007040642]'),(32080635,0,1000,0,1,0,1,0,'[{{0,1002010642,1},1},{{0,1004010642,1},1},{{0,1006010642,1},1},{{0,1008010642,1},1},{{0,1010010642,1},1},{{0,1001010642,1},1}]','[]','[1002010642,1004010642,1006010642,1008010642,1010010642,1001010642]'),(32080635,0,1000,0,2,0,1,0,'[{{0,1002020642,1},1},{{0,1004020642,1},1},{{0,1006020642,1},1},{{0,1008020642,1},1},{{0,1010020642,1},1},{{0,1001020642,1},1}]','[]','[1002020642,1004020642,1006020642,1008020642,1010020642,1001020642]'),(32080635,0,1000,0,3,0,1,0,'[{{0,1002030642,1},1},{{0,1004030642,1},1},{{0,1006030642,1},1},{{0,1008030642,1},1},{{0,1010030642,1},1},{{0,1001030642,1},1}]','[]','[1002030642,1004030642,1006030642,1008030642,1010030642,1001030642]'),(32080635,0,1000,0,4,0,1,0,'[{{0,1002040642,1},1},{{0,1004040642,1},1},{{0,1006040642,1},1},{{0,1008040642,1},1},{{0,1010040642,1},1},{{0,1001040642,1},1}]','[]','[1002040642,1004040642,1006040642,1008040642,1010040642,1001040642]'),(32080636,0,1000,0,1,0,1,0,'[{{0,1007010642,1},1},{{0,1003000642,1},1},{{0,1005000642,1},1},{{0,1009000642,1},1}]','[]','[1007010642,1003000642,1005000642,1009000642]'),(32080636,0,1000,0,2,0,1,0,'[{{0,1007020642,1},1},{{0,1003000642,1},1},{{0,1005000642,1},1},{{0,1009000642,1},1}]','[]','[1007020642,1003000642,1005000642,1009000642]'),(32080636,0,1000,0,3,0,1,0,'[{{0,1007030642,1},1},{{0,1003000642,1},1},{{0,1005000642,1},1},{{0,1009000642,1},1}]','[]','[1007030642,1003000642,1005000642,1009000642]'),(32080636,0,1000,0,4,0,1,0,'[{{0,1007040642,1},1},{{0,1003000642,1},1},{{0,1005000642,1},1},{{0,1009000642,1},1}]','[]','[1007040642,1003000642,1005000642,1009000642]'),(32080637,0,1000,0,1,0,1,0,'[{{0,1007010642,1},1},{{0,1003000642,1},1}]','[]','[1007010642,1003000642]'),(32080637,0,1000,0,2,0,1,0,'[{{0,1007020642,1},1},{{0,1003000642,1},1}]','[]','[1007020642,1003000642]'),(32080637,0,1000,0,3,0,1,0,'[{{0,1007030642,1},1},{{0,1003000642,1},1}]','[]','[1007030642,1003000642]'),(32080637,0,1000,0,4,0,1,0,'[{{0,1007040642,1},1},{{0,1003000642,1},1}]','[]','[1007040642,1003000642]'),(32080638,0,1000,0,0,0,1,0,'[{{0,1005000642,1},1},{{0,1009000642,1},1}]','[]','[1005000642,1009000642]'),(32080641,0,1000,0,1,0,1,0,'[{{0,1001010643,1},1},{{0,1002010643,1},1},{{0,1003000643,1},1},{{0,1004010643,1},1},{{0,1006010643,1},1},{{0,1007010643,1},1},{{0,1008010643,1},1},{{0,1010010643,1},1}]','[]','[1001010643,1002010643,1003000643,1004010643,1005000643,1006010643,1007010643,1008010643,1009000643,1010010643]'),(32080641,0,1000,0,2,0,1,0,'[{{0,1001020643,1},1},{{0,1002020643,1},1},{{0,1003000643,1},1},{{0,1004020643,1},1},{{0,1006020643,1},1},{{0,1007020643,1},1},{{0,1008020643,1},1},{{0,1010020643,1},1}]','[]','[1001020643,1002020643,1003000643,1004020643,1005000643,1006020643,1007020643,1008020643,1009000643,1010020643]'),(32080641,0,1000,0,3,0,1,0,'[{{0,1001030643,1},1},{{0,1002030643,1},1},{{0,1003000643,1},1},{{0,1004030643,1},1},{{0,1006030643,1},1},{{0,1007030643,1},1},{{0,1008030643,1},1},{{0,1010030643,1},1}]','[]','[1001030643,1002030643,1003000643,1004030643,1005000643,1006030643,1007030643,1008030643,1009000643,1010030643]'),(32080641,0,1000,0,4,0,1,0,'[{{0,1001040643,1},1},{{0,1002040643,1},1},{{0,1003000643,1},1},{{0,1004040643,1},1},{{0,1006040643,1},1},{{0,1007040643,1},1},{{0,1008040643,1},1},{{0,1010040643,1},1}]','[]','[1001040643,1002040643,1003000643,1004040643,1005000643,1006040643,1007040643,1008040643,1009000643,1010040643]'),(32080642,0,1000,0,1,0,1,0,'[{{0,1002010643,1},1},{{0,1004010643,1},1},{{0,1006010643,1},1},{{0,1008010643,1},1},{{0,1010010643,1},1}]','[]','[1002010643,1004010643,1006010643,1008010643,1010010643]'),(32080642,0,1000,0,2,0,1,0,'[{{0,1002020643,1},1},{{0,1004020643,1},1},{{0,1006020643,1},1},{{0,1008020643,1},1},{{0,1010020643,1},1}]','[]','[1002020643,1004020643,1006020643,1008020643,1010020643]'),(32080642,0,1000,0,3,0,1,0,'[{{0,1002030643,1},1},{{0,1004030643,1},1},{{0,1006030643,1},1},{{0,1008030643,1},1},{{0,1010030643,1},1}]','[]','[1002030643,1004030643,1006030643,1008030643,1010030643]'),(32080642,0,1000,0,4,0,1,0,'[{{0,1002040643,1},1},{{0,1004040643,1},1},{{0,1006040643,1},1},{{0,1008040643,1},1},{{0,1010040643,1},1}]','[]','[1002040643,1004040643,1006040643,1008040643,1010040643]'),(32080643,0,1000,0,1,0,1,0,'[{{0,1001010643,1},1},{{0,1007010643,1},1}]','[]','[1001010643,1007010643]'),(32080643,0,1000,0,2,0,1,0,'[{{0,1001020643,1},1},{{0,1007020643,1},1}]','[]','[1001020643,1007020643]'),(32080643,0,1000,0,3,0,1,0,'[{{0,1001030643,1},1},{{0,1007030643,1},1}]','[]','[1001030643,1007030643]'),(32080643,0,1000,0,4,0,1,0,'[{{0,1001040643,1},1},{{0,1007040643,1},1}]','[]','[1001040643,1007040643]'),(32080645,0,1000,0,1,0,1,0,'[{{0,1002010643,1},1},{{0,1004010643,1},1},{{0,1006010643,1},1},{{0,1008010643,1},1},{{0,1010010643,1},1},{{0,1001010643,1},1}]','[]','[1002010643,1004010643,1006010643,1008010643,1010010643,1001010643]'),(32080645,0,1000,0,2,0,1,0,'[{{0,1002020643,1},1},{{0,1004020643,1},1},{{0,1006020643,1},1},{{0,1008020643,1},1},{{0,1010020643,1},1},{{0,1001020643,1},1}]','[]','[1002020643,1004020643,1006020643,1008020643,1010020643,1001020643]'),(32080645,0,1000,0,3,0,1,0,'[{{0,1002030643,1},1},{{0,1004030643,1},1},{{0,1006030643,1},1},{{0,1008030643,1},1},{{0,1010030643,1},1},{{0,1001030643,1},1}]','[]','[1002030643,1004030643,1006030643,1008030643,1010030643,1001030643]'),(32080645,0,1000,0,4,0,1,0,'[{{0,1002040643,1},1},{{0,1004040643,1},1},{{0,1006040643,1},1},{{0,1008040643,1},1},{{0,1010040643,1},1},{{0,1001040643,1},1}]','[]','[1002040643,1004040643,1006040643,1008040643,1010040643,1001040643]'),(32080646,0,1000,0,1,0,1,0,'[{{0,1007010643,1},1},{{0,1003000643,1},1},{{0,1005000643,1},1},{{0,1009000643,1},1}]','[]','[1007010643,1003000643,1005000643,1009000643]'),(32080646,0,1000,0,2,0,1,0,'[{{0,1007020643,1},1},{{0,1003000643,1},1},{{0,1005000643,1},1},{{0,1009000643,1},1}]','[]','[1007020643,1003000643,1005000643,1009000643]'),(32080646,0,1000,0,3,0,1,0,'[{{0,1007030643,1},1},{{0,1003000643,1},1},{{0,1005000643,1},1},{{0,1009000643,1},1}]','[]','[1007030643,1003000643,1005000643,1009000643]'),(32080646,0,1000,0,4,0,1,0,'[{{0,1007040643,1},1},{{0,1003000643,1},1},{{0,1005000643,1},1},{{0,1009000643,1},1}]','[]','[1007040643,1003000643,1005000643,1009000643]'),(32080647,0,1000,0,1,0,1,0,'[{{0,1007010643,1},1},{{0,1003000643,1},1}]','[]','[1007010643,1003000643]'),(32080647,0,1000,0,2,0,1,0,'[{{0,1007020643,1},1},{{0,1003000643,1},1}]','[]','[1007020643,1003000643]'),(32080647,0,1000,0,3,0,1,0,'[{{0,1007030643,1},1},{{0,1003000643,1},1}]','[]','[1007030643,1003000643]'),(32080647,0,1000,0,4,0,1,0,'[{{0,1007040643,1},1},{{0,1003000643,1},1}]','[]','[1007040643,1003000643]'),(32080648,0,1000,0,0,0,1,0,'[{{0,1005000643,1},1},{{0,1009000643,1},1}]','[]','[1005000643,1009000643]'),(32080651,0,1000,0,1,0,1,0,'[{{0,1001010653,1},1},{{0,1002010653,1},1},{{0,1003000653,1},1},{{0,1004010653,1},1},{{0,1006010653,1},1},{{0,1007010653,1},1},{{0,1008010653,1},1},{{0,1010010653,1},1}]','[]','[1001010653,1002010653,1003000653,1004010653,1005000653,1006010653,1007010653,1008010653,1009000653,1010010653]'),(32080651,0,1000,0,2,0,1,0,'[{{0,1001020653,1},1},{{0,1002020653,1},1},{{0,1003000653,1},1},{{0,1004020653,1},1},{{0,1006020653,1},1},{{0,1007020653,1},1},{{0,1008020653,1},1},{{0,1010020653,1},1}]','[]','[1001020653,1002020653,1003000653,1004020653,1005000653,1006020653,1007020653,1008020653,1009000653,1010020653]'),(32080651,0,1000,0,3,0,1,0,'[{{0,1001030653,1},1},{{0,1002030653,1},1},{{0,1003000653,1},1},{{0,1004030653,1},1},{{0,1006030653,1},1},{{0,1007030653,1},1},{{0,1008030653,1},1},{{0,1010030653,1},1}]','[]','[1001030653,1002030653,1003000653,1004030653,1005000653,1006030653,1007030653,1008030653,1009000653,1010030653]'),(32080651,0,1000,0,4,0,1,0,'[{{0,1001040653,1},1},{{0,1002040653,1},1},{{0,1003000653,1},1},{{0,1004040653,1},1},{{0,1006040653,1},1},{{0,1007040653,1},1},{{0,1008040653,1},1},{{0,1010040653,1},1}]','[]','[1001040653,1002040653,1003000653,1004040653,1005000653,1006040653,1007040653,1008040653,1009000653,1010040653]'),(32080652,0,1000,0,1,0,1,0,'[{{0,1002010653,1},1},{{0,1004010653,1},1},{{0,1006010653,1},1},{{0,1008010653,1},1},{{0,1010010653,1},1}]','[]','[1002010653,1004010653,1006010653,1008010653,1010010653]'),(32080652,0,1000,0,2,0,1,0,'[{{0,1002020653,1},1},{{0,1004020653,1},1},{{0,1006020653,1},1},{{0,1008020653,1},1},{{0,1010020653,1},1}]','[]','[1002020653,1004020653,1006020653,1008020653,1010020653]'),(32080652,0,1000,0,3,0,1,0,'[{{0,1002030653,1},1},{{0,1004030653,1},1},{{0,1006030653,1},1},{{0,1008030653,1},1},{{0,1010030653,1},1}]','[]','[1002030653,1004030653,1006030653,1008030653,1010030653]'),(32080652,0,1000,0,4,0,1,0,'[{{0,1002040653,1},1},{{0,1004040653,1},1},{{0,1006040653,1},1},{{0,1008040653,1},1},{{0,1010040653,1},1}]','[]','[1002040653,1004040653,1006040653,1008040653,1010040653]'),(32080653,0,1000,0,1,0,1,0,'[{{0,1001010653,1},1},{{0,1007010653,1},1}]','[]','[1001010653,1007010653]'),(32080653,0,1000,0,2,0,1,0,'[{{0,1001020653,1},1},{{0,1007020653,1},1}]','[]','[1001020653,1007020653]'),(32080653,0,1000,0,3,0,1,0,'[{{0,1001030653,1},1},{{0,1007030653,1},1}]','[]','[1001030653,1007030653]'),(32080653,0,1000,0,4,0,1,0,'[{{0,1001040653,1},1},{{0,1007040653,1},1}]','[]','[1001040653,1007040653]'),(32080655,0,1000,0,1,0,1,0,'[{{0,1002010653,1},1},{{0,1004010653,1},1},{{0,1006010653,1},1},{{0,1008010653,1},1},{{0,1010010653,1},1},{{0,1001010653,1},1}]','[]','[1002010653,1004010653,1006010653,1008010653,1010010653,1001010653]'),(32080655,0,1000,0,2,0,1,0,'[{{0,1002020653,1},1},{{0,1004020653,1},1},{{0,1006020653,1},1},{{0,1008020653,1},1},{{0,1010020653,1},1},{{0,1001020653,1},1}]','[]','[1002020653,1004020653,1006020653,1008020653,1010020653,1001020653]'),(32080655,0,1000,0,3,0,1,0,'[{{0,1002030653,1},1},{{0,1004030653,1},1},{{0,1006030653,1},1},{{0,1008030653,1},1},{{0,1010030653,1},1},{{0,1001030653,1},1}]','[]','[1002030653,1004030653,1006030653,1008030653,1010030653,1001030653]'),(32080655,0,1000,0,4,0,1,0,'[{{0,1002040653,1},1},{{0,1004040653,1},1},{{0,1006040653,1},1},{{0,1008040653,1},1},{{0,1010040653,1},1},{{0,1001040653,1},1}]','[]','[1002040653,1004040653,1006040653,1008040653,1010040653,1001040653]'),(32080656,0,1000,0,1,0,1,0,'[{{0,1007010653,1},1},{{0,1003000653,1},1},{{0,1005000653,1},1},{{0,1009000653,1},1}]','[]','[1007010653,1003000653,1005000653,1009000653]'),(32080656,0,1000,0,2,0,1,0,'[{{0,1007020653,1},1},{{0,1003000653,1},1},{{0,1005000653,1},1},{{0,1009000653,1},1}]','[]','[1007020653,1003000653,1005000653,1009000653]'),(32080656,0,1000,0,3,0,1,0,'[{{0,1007030653,1},1},{{0,1003000653,1},1},{{0,1005000653,1},1},{{0,1009000653,1},1}]','[]','[1007030653,1003000653,1005000653,1009000653]'),(32080656,0,1000,0,4,0,1,0,'[{{0,1007040653,1},1},{{0,1003000653,1},1},{{0,1005000653,1},1},{{0,1009000653,1},1}]','[]','[1007040653,1003000653,1005000653,1009000653]'),(32080657,0,1000,0,1,0,1,0,'[{{0,1007010653,1},1},{{0,1003000653,1},1}]','[]','[1007010653,1003000653]'),(32080657,0,1000,0,2,0,1,0,'[{{0,1007020653,1},1},{{0,1003000653,1},1}]','[]','[1007020653,1003000653]'),(32080657,0,1000,0,3,0,1,0,'[{{0,1007030653,1},1},{{0,1003000653,1},1}]','[]','[1007030653,1003000653]'),(32080657,0,1000,0,4,0,1,0,'[{{0,1007040653,1},1},{{0,1003000653,1},1}]','[]','[1007040653,1003000653]'),(32080658,0,1000,0,0,0,1,0,'[{{0,1005000653,1},1},{{0,1009000653,1},1}]','[]','[1005000653,1009000653]'),(32080661,0,1000,0,1,0,1,0,'[{{0,1001010663,1},1},{{0,1002010663,1},1},{{0,1003000663,1},1},{{0,1004010663,1},1},{{0,1006010663,1},1},{{0,1007010663,1},1},{{0,1008010663,1},1},{{0,1010010663,1},1}]','[]','[1001010663,1002010663,1003000663,1004010663,1005000663,1006010663,1007010663,1008010663,1009000663,1010010663]'),(32080661,0,1000,0,2,0,1,0,'[{{0,1001020663,1},1},{{0,1002020663,1},1},{{0,1003000663,1},1},{{0,1004020663,1},1},{{0,1006020663,1},1},{{0,1007020663,1},1},{{0,1008020663,1},1},{{0,1010020663,1},1}]','[]','[1001020663,1002020663,1003000663,1004020663,1005000663,1006020663,1007020663,1008020663,1009000663,1010020663]'),(32080661,0,1000,0,3,0,1,0,'[{{0,1001030663,1},1},{{0,1002030663,1},1},{{0,1003000663,1},1},{{0,1004030663,1},1},{{0,1006030663,1},1},{{0,1007030663,1},1},{{0,1008030663,1},1},{{0,1010030663,1},1}]','[]','[1001030663,1002030663,1003000663,1004030663,1005000663,1006030663,1007030663,1008030663,1009000663,1010030663]'),(32080661,0,1000,0,4,0,1,0,'[{{0,1001040663,1},1},{{0,1002040663,1},1},{{0,1003000663,1},1},{{0,1004040663,1},1},{{0,1006040663,1},1},{{0,1007040663,1},1},{{0,1008040663,1},1},{{0,1010040663,1},1}]','[]','[1001040663,1002040663,1003000663,1004040663,1005000663,1006040663,1007040663,1008040663,1009000663,1010040663]'),(32080662,0,1000,0,1,0,1,0,'[{{0,1002010663,1},1},{{0,1004010663,1},1},{{0,1006010663,1},1},{{0,1008010663,1},1},{{0,1010010663,1},1}]','[]','[1002010663,1004010663,1006010663,1008010663,1010010663]'),(32080662,0,1000,0,2,0,1,0,'[{{0,1002020663,1},1},{{0,1004020663,1},1},{{0,1006020663,1},1},{{0,1008020663,1},1},{{0,1010020663,1},1}]','[]','[1002020663,1004020663,1006020663,1008020663,1010020663]'),(32080662,0,1000,0,3,0,1,0,'[{{0,1002030663,1},1},{{0,1004030663,1},1},{{0,1006030663,1},1},{{0,1008030663,1},1},{{0,1010030663,1},1}]','[]','[1002030663,1004030663,1006030663,1008030663,1010030663]'),(32080662,0,1000,0,4,0,1,0,'[{{0,1002040663,1},1},{{0,1004040663,1},1},{{0,1006040663,1},1},{{0,1008040663,1},1},{{0,1010040663,1},1}]','[]','[1002040663,1004040663,1006040663,1008040663,1010040663]'),(32080663,0,1000,0,1,0,1,0,'[{{0,1001010663,1},1},{{0,1007010663,1},1}]','[]','[1001010663,1007010663]'),(32080663,0,1000,0,2,0,1,0,'[{{0,1001020663,1},1},{{0,1007020663,1},1}]','[]','[1001020663,1007020663]'),(32080663,0,1000,0,3,0,1,0,'[{{0,1001030663,1},1},{{0,1007030663,1},1}]','[]','[1001030663,1007030663]'),(32080663,0,1000,0,4,0,1,0,'[{{0,1001040663,1},1},{{0,1007040663,1},1}]','[]','[1001040663,1007040663]'),(32080665,0,1000,0,1,0,1,0,'[{{0,1002010663,1},1},{{0,1004010663,1},1},{{0,1006010663,1},1},{{0,1008010663,1},1},{{0,1010010663,1},1},{{0,1001010663,1},1}]','[]','[1002010663,1004010663,1006010663,1008010663,1010010663,1001010663]'),(32080665,0,1000,0,2,0,1,0,'[{{0,1002020663,1},1},{{0,1004020663,1},1},{{0,1006020663,1},1},{{0,1008020663,1},1},{{0,1010020663,1},1},{{0,1001020663,1},1}]','[]','[1002020663,1004020663,1006020663,1008020663,1010020663,1001020663]'),(32080665,0,1000,0,3,0,1,0,'[{{0,1002030663,1},1},{{0,1004030663,1},1},{{0,1006030663,1},1},{{0,1008030663,1},1},{{0,1010030663,1},1},{{0,1001030663,1},1}]','[]','[1002030663,1004030663,1006030663,1008030663,1010030663,1001030663]'),(32080665,0,1000,0,4,0,1,0,'[{{0,1002040663,1},1},{{0,1004040663,1},1},{{0,1006040663,1},1},{{0,1008040663,1},1},{{0,1010040663,1},1},{{0,1001040663,1},1}]','[]','[1002040663,1004040663,1006040663,1008040663,1010040663,1001040663]'),(32080666,0,1000,0,1,0,1,0,'[{{0,1007010663,1},1},{{0,1003000663,1},1},{{0,1005000663,1},1},{{0,1009000663,1},1}]','[]','[1007010663,1003000663,1005000663,1009000663]'),(32080666,0,1000,0,2,0,1,0,'[{{0,1007020663,1},1},{{0,1003000663,1},1},{{0,1005000663,1},1},{{0,1009000663,1},1}]','[]','[1007020663,1003000663,1005000663,1009000663]'),(32080666,0,1000,0,3,0,1,0,'[{{0,1007030663,1},1},{{0,1003000663,1},1},{{0,1005000663,1},1},{{0,1009000663,1},1}]','[]','[1007030663,1003000663,1005000663,1009000663]'),(32080666,0,1000,0,4,0,1,0,'[{{0,1007040663,1},1},{{0,1003000663,1},1},{{0,1005000663,1},1},{{0,1009000663,1},1}]','[]','[1007040663,1003000663,1005000663,1009000663]'),(32080667,0,1000,0,1,0,1,0,'[{{0,1007010663,1},1},{{0,1003000663,1},1}]','[]','[1007010663,1003000663]'),(32080667,0,1000,0,2,0,1,0,'[{{0,1007020663,1},1},{{0,1003000663,1},1}]','[]','[1007020663,1003000663]'),(32080667,0,1000,0,3,0,1,0,'[{{0,1007030663,1},1},{{0,1003000663,1},1}]','[]','[1007030663,1003000663]'),(32080667,0,1000,0,4,0,1,0,'[{{0,1007040663,1},1},{{0,1003000663,1},1}]','[]','[1007040663,1003000663]'),(32080668,0,1000,0,0,0,1,0,'[{{0,1005000663,1},1},{{0,1009000663,1},1}]','[]','[1005000663,1009000663]'),(32080671,0,1000,0,1,0,1,0,'[{{0,1001010600,1},1},{{0,1002010600,1},1},{{0,1003000600,1},1},{{0,1004010600,1},1},{{0,1006010600,1},1},{{0,1007010600,1},1},{{0,1008010600,1},1},{{0,1010010600,1},1}]','[]','[]'),(32080671,0,1000,0,2,0,1,0,'[{{0,1001020600,1},1},{{0,1002020600,1},1},{{0,1003000600,1},1},{{0,1004020600,1},1},{{0,1006020600,1},1},{{0,1007020600,1},1},{{0,1008020600,1},1},{{0,1010020600,1},1}]','[]','[]'),(32080671,0,1000,0,3,0,1,0,'[{{0,1001030600,1},1},{{0,1002030600,1},1},{{0,1003000600,1},1},{{0,1004030600,1},1},{{0,1006030600,1},1},{{0,1007030600,1},1},{{0,1008030600,1},1},{{0,1010030600,1},1}]','[]','[]'),(32080671,0,1000,0,4,0,1,0,'[{{0,1001040600,1},1},{{0,1002040600,1},1},{{0,1003000600,1},1},{{0,1004040600,1},1},{{0,1006040600,1},1},{{0,1007040600,1},1},{{0,1008040600,1},1},{{0,1010040600,1},1}]','[]','[]'),(32080672,0,1000,0,1,0,1,0,'[{{0,1002010600,1},1},{{0,1004010600,1},1},{{0,1006010600,1},1},{{0,1008010600,1},1},{{0,1010010600,1},1}]','[]','[]'),(32080672,0,1000,0,2,0,1,0,'[{{0,1002020600,1},1},{{0,1004020600,1},1},{{0,1006020600,1},1},{{0,1008020600,1},1},{{0,1010020600,1},1}]','[]','[]'),(32080672,0,1000,0,3,0,1,0,'[{{0,1002030600,1},1},{{0,1004030600,1},1},{{0,1006030600,1},1},{{0,1008030600,1},1},{{0,1010030600,1},1}]','[]','[]'),(32080672,0,1000,0,4,0,1,0,'[{{0,1002040600,1},1},{{0,1004040600,1},1},{{0,1006040600,1},1},{{0,1008040600,1},1},{{0,1010040600,1},1}]','[]','[]'),(32080673,0,1000,0,1,0,1,0,'[{{0,1001010600,1},1},{{0,1007010600,1},1}]','[]','[]'),(32080673,0,1000,0,2,0,1,0,'[{{0,1001020600,1},1},{{0,1007020600,1},1}]','[]','[]'),(32080673,0,1000,0,3,0,1,0,'[{{0,1001030600,1},1},{{0,1007030600,1},1}]','[]','[]'),(32080673,0,1000,0,4,0,1,0,'[{{0,1001040600,1},1},{{0,1007040600,1},1}]','[]','[]'),(32080675,0,1000,0,1,0,1,0,'[{{0,1002010600,1},1},{{0,1004010600,1},1},{{0,1006010600,1},1},{{0,1008010600,1},1},{{0,1010010600,1},1},{{0,1001010600,1},1}]','[]','[]'),(32080675,0,1000,0,2,0,1,0,'[{{0,1002020600,1},1},{{0,1004020600,1},1},{{0,1006020600,1},1},{{0,1008020600,1},1},{{0,1010020600,1},1},{{0,1001020600,1},1}]','[]','[]'),(32080675,0,1000,0,3,0,1,0,'[{{0,1002030600,1},1},{{0,1004030600,1},1},{{0,1006030600,1},1},{{0,1008030600,1},1},{{0,1010030600,1},1},{{0,1001030600,1},1}]','[]','[]'),(32080675,0,1000,0,4,0,1,0,'[{{0,1002040600,1},1},{{0,1004040600,1},1},{{0,1006040600,1},1},{{0,1008040600,1},1},{{0,1010040600,1},1},{{0,1001040600,1},1}]','[]','[]'),(32080676,0,1000,0,1,0,1,0,'[{{0,1007010600,1},1},{{0,1003000600,1},1},{{0,1005000600,1},1},{{0,1009000600,1},1}]','[]','[]'),(32080676,0,1000,0,2,0,1,0,'[{{0,1007020600,1},1},{{0,1003000600,1},1},{{0,1005000600,1},1},{{0,1009000600,1},1}]','[]','[]'),(32080676,0,1000,0,3,0,1,0,'[{{0,1007030600,1},1},{{0,1003000600,1},1},{{0,1005000600,1},1},{{0,1009000600,1},1}]','[]','[]'),(32080676,0,1000,0,4,0,1,0,'[{{0,1007040600,1},1},{{0,1003000600,1},1},{{0,1005000600,1},1},{{0,1009000600,1},1}]','[]','[]'),(32080677,0,1000,0,1,0,1,0,'[{{0,1007010600,1},1},{{0,1003000600,1},1}]','[]','[]'),(32080677,0,1000,0,2,0,1,0,'[{{0,1007020600,1},1},{{0,1003000600,1},1}]','[]','[]'),(32080677,0,1000,0,3,0,1,0,'[{{0,1007030600,1},1},{{0,1003000600,1},1}]','[]','[]'),(32080677,0,1000,0,4,0,1,0,'[{{0,1007040600,1},1},{{0,1003000600,1},1}]','[]','[]'),(32080678,0,1000,0,0,0,1,0,'[{{0,1005000600,1},1},{{0,1009000600,1},1}]','[]','[]'),(32080681,0,1000,0,1,0,1,0,'[{{0,1001010610,1},1},{{0,1002010610,1},1},{{0,1003000610,1},1},{{0,1004010610,1},1},{{0,1006010610,1},1},{{0,1007010610,1},1},{{0,1008010610,1},1},{{0,1010010610,1},1}]','[]','[]'),(32080681,0,1000,0,2,0,1,0,'[{{0,1001020610,1},1},{{0,1002020610,1},1},{{0,1003000610,1},1},{{0,1004020610,1},1},{{0,1006020610,1},1},{{0,1007020610,1},1},{{0,1008020610,1},1},{{0,1010020610,1},1}]','[]','[]'),(32080681,0,1000,0,3,0,1,0,'[{{0,1001030610,1},1},{{0,1002030610,1},1},{{0,1003000610,1},1},{{0,1004030610,1},1},{{0,1006030610,1},1},{{0,1007030610,1},1},{{0,1008030610,1},1},{{0,1010030610,1},1}]','[]','[]'),(32080681,0,1000,0,4,0,1,0,'[{{0,1001040610,1},1},{{0,1002040610,1},1},{{0,1003000610,1},1},{{0,1004040610,1},1},{{0,1006040610,1},1},{{0,1007040610,1},1},{{0,1008040610,1},1},{{0,1010040610,1},1}]','[]','[]'),(32080682,0,1000,0,1,0,1,0,'[{{0,1002010610,1},1},{{0,1004010610,1},1},{{0,1006010610,1},1},{{0,1008010610,1},1},{{0,1010010610,1},1}]','[]','[]'),(32080682,0,1000,0,2,0,1,0,'[{{0,1002020610,1},1},{{0,1004020610,1},1},{{0,1006020610,1},1},{{0,1008020610,1},1},{{0,1010020610,1},1}]','[]','[]'),(32080682,0,1000,0,3,0,1,0,'[{{0,1002030610,1},1},{{0,1004030610,1},1},{{0,1006030610,1},1},{{0,1008030610,1},1},{{0,1010030610,1},1}]','[]','[]'),(32080682,0,1000,0,4,0,1,0,'[{{0,1002040610,1},1},{{0,1004040610,1},1},{{0,1006040610,1},1},{{0,1008040610,1},1},{{0,1010040610,1},1}]','[]','[]'),(32080683,0,1000,0,1,0,1,0,'[{{0,1001010610,1},1},{{0,1007010610,1},1}]','[]','[]'),(32080683,0,1000,0,2,0,1,0,'[{{0,1001020610,1},1},{{0,1007020610,1},1}]','[]','[]'),(32080683,0,1000,0,3,0,1,0,'[{{0,1001030610,1},1},{{0,1007030610,1},1}]','[]','[]'),(32080683,0,1000,0,4,0,1,0,'[{{0,1001040610,1},1},{{0,1007040610,1},1}]','[]','[]'),(32080685,0,1000,0,1,0,1,0,'[{{0,1002010610,1},1},{{0,1004010610,1},1},{{0,1006010610,1},1},{{0,1008010610,1},1},{{0,1010010610,1},1},{{0,1001010610,1},1}]','[]','[]'),(32080685,0,1000,0,2,0,1,0,'[{{0,1002020610,1},1},{{0,1004020610,1},1},{{0,1006020610,1},1},{{0,1008020610,1},1},{{0,1010020610,1},1},{{0,1001020610,1},1}]','[]','[]'),(32080685,0,1000,0,3,0,1,0,'[{{0,1002030610,1},1},{{0,1004030610,1},1},{{0,1006030610,1},1},{{0,1008030610,1},1},{{0,1010030610,1},1},{{0,1001030610,1},1}]','[]','[]'),(32080685,0,1000,0,4,0,1,0,'[{{0,1002040610,1},1},{{0,1004040610,1},1},{{0,1006040610,1},1},{{0,1008040610,1},1},{{0,1010040610,1},1},{{0,1001040610,1},1}]','[]','[]'),(32080686,0,1000,0,1,0,1,0,'[{{0,1007010610,1},1},{{0,1003000610,1},1},{{0,1005000610,1},1},{{0,1009000610,1},1}]','[]','[]'),(32080686,0,1000,0,2,0,1,0,'[{{0,1007020610,1},1},{{0,1003000610,1},1},{{0,1005000610,1},1},{{0,1009000610,1},1}]','[]','[]'),(32080686,0,1000,0,3,0,1,0,'[{{0,1007030610,1},1},{{0,1003000610,1},1},{{0,1005000610,1},1},{{0,1009000610,1},1}]','[]','[]'),(32080686,0,1000,0,4,0,1,0,'[{{0,1007040610,1},1},{{0,1003000610,1},1},{{0,1005000610,1},1},{{0,1009000610,1},1}]','[]','[]'),(32080687,0,1000,0,1,0,1,0,'[{{0,1007010610,1},1},{{0,1003000610,1},1}]','[]','[]'),(32080687,0,1000,0,2,0,1,0,'[{{0,1007020610,1},1},{{0,1003000610,1},1}]','[]','[]'),(32080687,0,1000,0,3,0,1,0,'[{{0,1007030610,1},1},{{0,1003000610,1},1}]','[]','[]'),(32080687,0,1000,0,4,0,1,0,'[{{0,1007040610,1},1},{{0,1003000610,1},1}]','[]','[]'),(32080688,0,1000,0,0,0,1,0,'[{{0,1005000610,1},1},{{0,1009000610,1},1}]','[]','[]'),(32080691,0,1000,0,1,0,1,0,'[{{0,1001010620,1},1},{{0,1002010620,1},1},{{0,1003000620,1},1},{{0,1004010620,1},1},{{0,1006010620,1},1},{{0,1007010620,1},1},{{0,1008010620,1},1},{{0,1010010620,1},1}]','[]','[]'),(32080691,0,1000,0,2,0,1,0,'[{{0,1001020620,1},1},{{0,1002020620,1},1},{{0,1003000620,1},1},{{0,1004020620,1},1},{{0,1006020620,1},1},{{0,1007020620,1},1},{{0,1008020620,1},1},{{0,1010020620,1},1}]','[]','[]'),(32080691,0,1000,0,3,0,1,0,'[{{0,1001030620,1},1},{{0,1002030620,1},1},{{0,1003000620,1},1},{{0,1004030620,1},1},{{0,1006030620,1},1},{{0,1007030620,1},1},{{0,1008030620,1},1},{{0,1010030620,1},1}]','[]','[]'),(32080691,0,1000,0,4,0,1,0,'[{{0,1001040620,1},1},{{0,1002040620,1},1},{{0,1003000620,1},1},{{0,1004040620,1},1},{{0,1006040620,1},1},{{0,1007040620,1},1},{{0,1008040620,1},1},{{0,1010040620,1},1}]','[]','[]'),(32080692,0,1000,0,1,0,1,0,'[{{0,1002010620,1},1},{{0,1004010620,1},1},{{0,1006010620,1},1},{{0,1008010620,1},1},{{0,1010010620,1},1}]','[]','[]'),(32080692,0,1000,0,2,0,1,0,'[{{0,1002020620,1},1},{{0,1004020620,1},1},{{0,1006020620,1},1},{{0,1008020620,1},1},{{0,1010020620,1},1}]','[]','[]'),(32080692,0,1000,0,3,0,1,0,'[{{0,1002030620,1},1},{{0,1004030620,1},1},{{0,1006030620,1},1},{{0,1008030620,1},1},{{0,1010030620,1},1}]','[]','[]'),(32080692,0,1000,0,4,0,1,0,'[{{0,1002040620,1},1},{{0,1004040620,1},1},{{0,1006040620,1},1},{{0,1008040620,1},1},{{0,1010040620,1},1}]','[]','[]'),(32080693,0,1000,0,1,0,1,0,'[{{0,1001010620,1},1},{{0,1007010620,1},1}]','[]','[]'),(32080693,0,1000,0,2,0,1,0,'[{{0,1001020620,1},1},{{0,1007020620,1},1}]','[]','[]'),(32080693,0,1000,0,3,0,1,0,'[{{0,1001030620,1},1},{{0,1007030620,1},1}]','[]','[]'),(32080693,0,1000,0,4,0,1,0,'[{{0,1001040620,1},1},{{0,1007040620,1},1}]','[]','[]'),(32080695,0,1000,0,1,0,1,0,'[{{0,1002010620,1},1},{{0,1004010620,1},1},{{0,1006010620,1},1},{{0,1008010620,1},1},{{0,1010010620,1},1},{{0,1001010620,1},1}]','[]','[]'),(32080695,0,1000,0,2,0,1,0,'[{{0,1002020620,1},1},{{0,1004020620,1},1},{{0,1006020620,1},1},{{0,1008020620,1},1},{{0,1010020620,1},1},{{0,1001020620,1},1}]','[]','[]'),(32080695,0,1000,0,3,0,1,0,'[{{0,1002030620,1},1},{{0,1004030620,1},1},{{0,1006030620,1},1},{{0,1008030620,1},1},{{0,1010030620,1},1},{{0,1001030620,1},1}]','[]','[]'),(32080695,0,1000,0,4,0,1,0,'[{{0,1002040620,1},1},{{0,1004040620,1},1},{{0,1006040620,1},1},{{0,1008040620,1},1},{{0,1010040620,1},1},{{0,1001040620,1},1}]','[]','[]'),(32080696,0,1000,0,1,0,1,0,'[{{0,1007010620,1},1},{{0,1003000620,1},1},{{0,1005000620,1},1},{{0,1009000620,1},1}]','[]','[]'),(32080696,0,1000,0,2,0,1,0,'[{{0,1007020620,1},1},{{0,1003000620,1},1},{{0,1005000620,1},1},{{0,1009000620,1},1}]','[]','[]'),(32080696,0,1000,0,3,0,1,0,'[{{0,1007030620,1},1},{{0,1003000620,1},1},{{0,1005000620,1},1},{{0,1009000620,1},1}]','[]','[]'),(32080696,0,1000,0,4,0,1,0,'[{{0,1007040620,1},1},{{0,1003000620,1},1},{{0,1005000620,1},1},{{0,1009000620,1},1}]','[]','[]'),(32080697,0,1000,0,1,0,1,0,'[{{0,1007010620,1},1},{{0,1003000620,1},1}]','[]','[]'),(32080697,0,1000,0,2,0,1,0,'[{{0,1007020620,1},1},{{0,1003000620,1},1}]','[]','[]'),(32080697,0,1000,0,3,0,1,0,'[{{0,1007030620,1},1},{{0,1003000620,1},1}]','[]','[]'),(32080697,0,1000,0,4,0,1,0,'[{{0,1007040620,1},1},{{0,1003000620,1},1}]','[]','[]'),(32080698,0,1000,0,0,0,1,0,'[{{0,1005000620,1},1},{{0,1009000620,1},1}]','[]','[]'),(32080701,0,1000,0,1,0,1,0,'[{{0,1001010631,1},1},{{0,1002010631,1},1},{{0,1003000631,1},1},{{0,1004010631,1},1},{{0,1006010631,1},1},{{0,1007010631,1},1},{{0,1008010631,1},1},{{0,1010010631,1},1}]','[]','[]'),(32080701,0,1000,0,2,0,1,0,'[{{0,1001020631,1},1},{{0,1002020631,1},1},{{0,1003000631,1},1},{{0,1004020631,1},1},{{0,1006020631,1},1},{{0,1007020631,1},1},{{0,1008020631,1},1},{{0,1010020631,1},1}]','[]','[]'),(32080701,0,1000,0,3,0,1,0,'[{{0,1001030631,1},1},{{0,1002030631,1},1},{{0,1003000631,1},1},{{0,1004030631,1},1},{{0,1006030631,1},1},{{0,1007030631,1},1},{{0,1008030631,1},1},{{0,1010030631,1},1}]','[]','[]'),(32080701,0,1000,0,4,0,1,0,'[{{0,1001040631,1},1},{{0,1002040631,1},1},{{0,1003000631,1},1},{{0,1004040631,1},1},{{0,1006040631,1},1},{{0,1007040631,1},1},{{0,1008040631,1},1},{{0,1010040631,1},1}]','[]','[]'),(32080702,0,1000,0,1,0,1,0,'[{{0,1002010631,1},1},{{0,1004010631,1},1},{{0,1006010631,1},1},{{0,1008010631,1},1},{{0,1010010631,1},1}]','[]','[]'),(32080702,0,1000,0,2,0,1,0,'[{{0,1002020631,1},1},{{0,1004020631,1},1},{{0,1006020631,1},1},{{0,1008020631,1},1},{{0,1010020631,1},1}]','[]','[]'),(32080702,0,1000,0,3,0,1,0,'[{{0,1002030631,1},1},{{0,1004030631,1},1},{{0,1006030631,1},1},{{0,1008030631,1},1},{{0,1010030631,1},1}]','[]','[]'),(32080702,0,1000,0,4,0,1,0,'[{{0,1002040631,1},1},{{0,1004040631,1},1},{{0,1006040631,1},1},{{0,1008040631,1},1},{{0,1010040631,1},1}]','[]','[]'),(32080703,0,1000,0,1,0,1,0,'[{{0,1001010631,1},1},{{0,1007010631,1},1}]','[]','[]'),(32080703,0,1000,0,2,0,1,0,'[{{0,1001020631,1},1},{{0,1007020631,1},1}]','[]','[]'),(32080703,0,1000,0,3,0,1,0,'[{{0,1001030631,1},1},{{0,1007030631,1},1}]','[]','[]'),(32080703,0,1000,0,4,0,1,0,'[{{0,1001040631,1},1},{{0,1007040631,1},1}]','[]','[]'),(32080705,0,1000,0,1,0,1,0,'[{{0,1002010631,1},1},{{0,1004010631,1},1},{{0,1006010631,1},1},{{0,1008010631,1},1},{{0,1010010631,1},1},{{0,1001010631,1},1}]','[]','[]'),(32080705,0,1000,0,2,0,1,0,'[{{0,1002020631,1},1},{{0,1004020631,1},1},{{0,1006020631,1},1},{{0,1008020631,1},1},{{0,1010020631,1},1},{{0,1001020631,1},1}]','[]','[]'),(32080705,0,1000,0,3,0,1,0,'[{{0,1002030631,1},1},{{0,1004030631,1},1},{{0,1006030631,1},1},{{0,1008030631,1},1},{{0,1010030631,1},1},{{0,1001030631,1},1}]','[]','[]'),(32080705,0,1000,0,4,0,1,0,'[{{0,1002040631,1},1},{{0,1004040631,1},1},{{0,1006040631,1},1},{{0,1008040631,1},1},{{0,1010040631,1},1},{{0,1001040631,1},1}]','[]','[]'),(32080706,0,1000,0,1,0,1,0,'[{{0,1007010631,1},1},{{0,1003000631,1},1},{{0,1005000631,1},1},{{0,1009000631,1},1}]','[]','[]'),(32080706,0,1000,0,2,0,1,0,'[{{0,1007020631,1},1},{{0,1003000631,1},1},{{0,1005000631,1},1},{{0,1009000631,1},1}]','[]','[]'),(32080706,0,1000,0,3,0,1,0,'[{{0,1007030631,1},1},{{0,1003000631,1},1},{{0,1005000631,1},1},{{0,1009000631,1},1}]','[]','[]'),(32080706,0,1000,0,4,0,1,0,'[{{0,1007040631,1},1},{{0,1003000631,1},1},{{0,1005000631,1},1},{{0,1009000631,1},1}]','[]','[]'),(32080707,0,1000,0,1,0,1,0,'[{{0,1007010631,1},1},{{0,1003000631,1},1}]','[]','[]'),(32080707,0,1000,0,2,0,1,0,'[{{0,1007020631,1},1},{{0,1003000631,1},1}]','[]','[]'),(32080707,0,1000,0,3,0,1,0,'[{{0,1007030631,1},1},{{0,1003000631,1},1}]','[]','[]'),(32080707,0,1000,0,4,0,1,0,'[{{0,1007040631,1},1},{{0,1003000631,1},1}]','[]','[]'),(32080708,0,1000,0,0,0,1,0,'[{{0,1005000631,1},1},{{0,1009000631,1},1}]','[]','[]'),(32080711,0,1000,0,1,0,1,0,'[{{0,1001010732,1},1},{{0,1002010732,1},1},{{0,1003000732,1},1},{{0,1004010732,1},1},{{0,1006010732,1},1},{{0,1007010732,1},1},{{0,1008010732,1},1},{{0,1010010732,1},1}]','[]','[1001010732,1002010732,1003000732,1004010732,1005000732,1006010732,1007010732,1008010732,1009000732,1010010732]'),(32080711,0,1000,0,2,0,1,0,'[{{0,1001020732,1},1},{{0,1002020732,1},1},{{0,1003000732,1},1},{{0,1004020732,1},1},{{0,1006020732,1},1},{{0,1007020732,1},1},{{0,1008020732,1},1},{{0,1010020732,1},1}]','[]','[1001020732,1002020732,1003000732,1004020732,1005000732,1006020732,1007020732,1008020732,1009000732,1010020732]'),(32080711,0,1000,0,3,0,1,0,'[{{0,1001030732,1},1},{{0,1002030732,1},1},{{0,1003000732,1},1},{{0,1004030732,1},1},{{0,1006030732,1},1},{{0,1007030732,1},1},{{0,1008030732,1},1},{{0,1010030732,1},1}]','[]','[1001030732,1002030732,1003000732,1004030732,1005000732,1006030732,1007030732,1008030732,1009000732,1010030732]'),(32080711,0,1000,0,4,0,1,0,'[{{0,1001040732,1},1},{{0,1002040732,1},1},{{0,1003000732,1},1},{{0,1004040732,1},1},{{0,1006040732,1},1},{{0,1007040732,1},1},{{0,1008040732,1},1},{{0,1010040732,1},1}]','[]','[1001040732,1002040732,1003000732,1004040732,1005000732,1006040732,1007040732,1008040732,1009000732,1010040732]'),(32080712,0,1000,0,1,0,1,0,'[{{0,1002010732,1},1},{{0,1004010732,1},1},{{0,1006010732,1},1},{{0,1008010732,1},1},{{0,1010010732,1},1}]','[]','[1002010732,1004010732,1006010732,1008010732,1010010732]'),(32080712,0,1000,0,2,0,1,0,'[{{0,1002020732,1},1},{{0,1004020732,1},1},{{0,1006020732,1},1},{{0,1008020732,1},1},{{0,1010020732,1},1}]','[]','[1002020732,1004020732,1006020732,1008020732,1010020732]'),(32080712,0,1000,0,3,0,1,0,'[{{0,1002030732,1},1},{{0,1004030732,1},1},{{0,1006030732,1},1},{{0,1008030732,1},1},{{0,1010030732,1},1}]','[]','[1002030732,1004030732,1006030732,1008030732,1010030732]'),(32080712,0,1000,0,4,0,1,0,'[{{0,1002040732,1},1},{{0,1004040732,1},1},{{0,1006040732,1},1},{{0,1008040732,1},1},{{0,1010040732,1},1}]','[]','[1002040732,1004040732,1006040732,1008040732,1010040732]'),(32080713,0,1000,0,1,0,1,0,'[{{0,1001010732,1},1},{{0,1007010732,1},1}]','[]','[1001010732,1007010732]'),(32080713,0,1000,0,2,0,1,0,'[{{0,1001020732,1},1},{{0,1007020732,1},1}]','[]','[1001020732,1007020732]'),(32080713,0,1000,0,3,0,1,0,'[{{0,1001030732,1},1},{{0,1007030732,1},1}]','[]','[1001030732,1007030732]'),(32080713,0,1000,0,4,0,1,0,'[{{0,1001040732,1},1},{{0,1007040732,1},1}]','[]','[1001040732,1007040732]'),(32080715,0,1000,0,1,0,1,0,'[{{0,1002010732,1},1},{{0,1004010732,1},1},{{0,1006010732,1},1},{{0,1008010732,1},1},{{0,1010010732,1},1},{{0,1001010732,1},1}]','[]','[1002010732,1004010732,1006010732,1008010732,1010010732,1001010732]'),(32080715,0,1000,0,2,0,1,0,'[{{0,1002020732,1},1},{{0,1004020732,1},1},{{0,1006020732,1},1},{{0,1008020732,1},1},{{0,1010020732,1},1},{{0,1001020732,1},1}]','[]','[1002020732,1004020732,1006020732,1008020732,1010020732,1001020732]'),(32080715,0,1000,0,3,0,1,0,'[{{0,1002030732,1},1},{{0,1004030732,1},1},{{0,1006030732,1},1},{{0,1008030732,1},1},{{0,1010030732,1},1},{{0,1001030732,1},1}]','[]','[1002030732,1004030732,1006030732,1008030732,1010030732,1001030732]'),(32080715,0,1000,0,4,0,1,0,'[{{0,1002040732,1},1},{{0,1004040732,1},1},{{0,1006040732,1},1},{{0,1008040732,1},1},{{0,1010040732,1},1},{{0,1001040732,1},1}]','[]','[1002040732,1004040732,1006040732,1008040732,1010040732,1001040732]'),(32080716,0,1000,0,1,0,1,0,'[{{0,1007010732,1},1},{{0,1003000732,1},1},{{0,1005000732,1},1},{{0,1009000732,1},1}]','[]','[1007010732,1003000732,1005000732,1009000732]'),(32080716,0,1000,0,2,0,1,0,'[{{0,1007020732,1},1},{{0,1003000732,1},1},{{0,1005000732,1},1},{{0,1009000732,1},1}]','[]','[1007020732,1003000732,1005000732,1009000732]'),(32080716,0,1000,0,3,0,1,0,'[{{0,1007030732,1},1},{{0,1003000732,1},1},{{0,1005000732,1},1},{{0,1009000732,1},1}]','[]','[1007030732,1003000732,1005000732,1009000732]'),(32080716,0,1000,0,4,0,1,0,'[{{0,1007040732,1},1},{{0,1003000732,1},1},{{0,1005000732,1},1},{{0,1009000732,1},1}]','[]','[1007040732,1003000732,1005000732,1009000732]'),(32080717,0,1000,0,1,0,1,0,'[{{0,1007010732,1},1},{{0,1003000732,1},1}]','[]','[1007010732,1003000732]'),(32080717,0,1000,0,2,0,1,0,'[{{0,1007020732,1},1},{{0,1003000732,1},1}]','[]','[1007020732,1003000732]'),(32080717,0,1000,0,3,0,1,0,'[{{0,1007030732,1},1},{{0,1003000732,1},1}]','[]','[1007030732,1003000732]'),(32080717,0,1000,0,4,0,1,0,'[{{0,1007040732,1},1},{{0,1003000732,1},1}]','[]','[1007040732,1003000732]'),(32080718,0,1000,0,0,0,1,0,'[{{0,1005000732,1},1},{{0,1009000732,1},1}]','[]','[1005000732,1009000732]'),(32080721,0,1000,0,1,0,1,0,'[{{0,1001010741,1},1},{{0,1002010741,1},1},{{0,1003000741,1},1},{{0,1004010741,1},1},{{0,1006010741,1},1},{{0,1007010741,1},1},{{0,1008010741,1},1},{{0,1010010741,1},1}]','[]','[]'),(32080721,0,1000,0,2,0,1,0,'[{{0,1001020741,1},1},{{0,1002020741,1},1},{{0,1003000741,1},1},{{0,1004020741,1},1},{{0,1006020741,1},1},{{0,1007020741,1},1},{{0,1008020741,1},1},{{0,1010020741,1},1}]','[]','[]'),(32080721,0,1000,0,3,0,1,0,'[{{0,1001030741,1},1},{{0,1002030741,1},1},{{0,1003000741,1},1},{{0,1004030741,1},1},{{0,1006030741,1},1},{{0,1007030741,1},1},{{0,1008030741,1},1},{{0,1010030741,1},1}]','[]','[]'),(32080721,0,1000,0,4,0,1,0,'[{{0,1001040741,1},1},{{0,1002040741,1},1},{{0,1003000741,1},1},{{0,1004040741,1},1},{{0,1006040741,1},1},{{0,1007040741,1},1},{{0,1008040741,1},1},{{0,1010040741,1},1}]','[]','[]'),(32080722,0,1000,0,1,0,1,0,'[{{0,1002010741,1},1},{{0,1004010741,1},1},{{0,1006010741,1},1},{{0,1008010741,1},1},{{0,1010010741,1},1}]','[]','[]'),(32080722,0,1000,0,2,0,1,0,'[{{0,1002020741,1},1},{{0,1004020741,1},1},{{0,1006020741,1},1},{{0,1008020741,1},1},{{0,1010020741,1},1}]','[]','[]'),(32080722,0,1000,0,3,0,1,0,'[{{0,1002030741,1},1},{{0,1004030741,1},1},{{0,1006030741,1},1},{{0,1008030741,1},1},{{0,1010030741,1},1}]','[]','[]'),(32080722,0,1000,0,4,0,1,0,'[{{0,1002040741,1},1},{{0,1004040741,1},1},{{0,1006040741,1},1},{{0,1008040741,1},1},{{0,1010040741,1},1}]','[]','[]'),(32080723,0,1000,0,1,0,1,0,'[{{0,1001010741,1},1},{{0,1007010741,1},1}]','[]','[]'),(32080723,0,1000,0,2,0,1,0,'[{{0,1001020741,1},1},{{0,1007020741,1},1}]','[]','[]'),(32080723,0,1000,0,3,0,1,0,'[{{0,1001030741,1},1},{{0,1007030741,1},1}]','[]','[]'),(32080723,0,1000,0,4,0,1,0,'[{{0,1001040741,1},1},{{0,1007040741,1},1}]','[]','[]'),(32080725,0,1000,0,1,0,1,0,'[{{0,1002010741,1},1},{{0,1004010741,1},1},{{0,1006010741,1},1},{{0,1008010741,1},1},{{0,1010010741,1},1},{{0,1001010741,1},1}]','[]','[]'),(32080725,0,1000,0,2,0,1,0,'[{{0,1002020741,1},1},{{0,1004020741,1},1},{{0,1006020741,1},1},{{0,1008020741,1},1},{{0,1010020741,1},1},{{0,1001020741,1},1}]','[]','[]'),(32080725,0,1000,0,3,0,1,0,'[{{0,1002030741,1},1},{{0,1004030741,1},1},{{0,1006030741,1},1},{{0,1008030741,1},1},{{0,1010030741,1},1},{{0,1001030741,1},1}]','[]','[]'),(32080725,0,1000,0,4,0,1,0,'[{{0,1002040741,1},1},{{0,1004040741,1},1},{{0,1006040741,1},1},{{0,1008040741,1},1},{{0,1010040741,1},1},{{0,1001040741,1},1}]','[]','[]'),(32080726,0,1000,0,1,0,1,0,'[{{0,1007010741,1},1},{{0,1003000741,1},1},{{0,1005000741,1},1},{{0,1009000741,1},1}]','[]','[]'),(32080726,0,1000,0,2,0,1,0,'[{{0,1007020741,1},1},{{0,1003000741,1},1},{{0,1005000741,1},1},{{0,1009000741,1},1}]','[]','[]'),(32080726,0,1000,0,3,0,1,0,'[{{0,1007030741,1},1},{{0,1003000741,1},1},{{0,1005000741,1},1},{{0,1009000741,1},1}]','[]','[]'),(32080726,0,1000,0,4,0,1,0,'[{{0,1007040741,1},1},{{0,1003000741,1},1},{{0,1005000741,1},1},{{0,1009000741,1},1}]','[]','[]'),(32080727,0,1000,0,1,0,1,0,'[{{0,1007010741,1},1},{{0,1003000741,1},1}]','[]','[]'),(32080727,0,1000,0,2,0,1,0,'[{{0,1007020741,1},1},{{0,1003000741,1},1}]','[]','[]'),(32080727,0,1000,0,3,0,1,0,'[{{0,1007030741,1},1},{{0,1003000741,1},1}]','[]','[]'),(32080727,0,1000,0,4,0,1,0,'[{{0,1007040741,1},1},{{0,1003000741,1},1}]','[]','[]'),(32080728,0,1000,0,0,0,1,0,'[{{0,1005000741,1},1},{{0,1009000741,1},1}]','[]','[]'),(32080731,0,1000,0,1,0,1,0,'[{{0,1001010742,1},1},{{0,1002010742,1},1},{{0,1003000742,1},1},{{0,1004010742,1},1},{{0,1006010742,1},1},{{0,1007010742,1},1},{{0,1008010742,1},1},{{0,1010010742,1},1}]','[]','[1001010742,1002010742,1003000742,1004010742,1005000742,1006010742,1007010742,1008010742,1009000742,1010010742]'),(32080731,0,1000,0,2,0,1,0,'[{{0,1001020742,1},1},{{0,1002020742,1},1},{{0,1003000742,1},1},{{0,1004020742,1},1},{{0,1006020742,1},1},{{0,1007020742,1},1},{{0,1008020742,1},1},{{0,1010020742,1},1}]','[]','[1001020742,1002020742,1003000742,1004020742,1005000742,1006020742,1007020742,1008020742,1009000742,1010020742]'),(32080731,0,1000,0,3,0,1,0,'[{{0,1001030742,1},1},{{0,1002030742,1},1},{{0,1003000742,1},1},{{0,1004030742,1},1},{{0,1006030742,1},1},{{0,1007030742,1},1},{{0,1008030742,1},1},{{0,1010030742,1},1}]','[]','[1001030742,1002030742,1003000742,1004030742,1005000742,1006030742,1007030742,1008030742,1009000742,1010030742]'),(32080731,0,1000,0,4,0,1,0,'[{{0,1001040742,1},1},{{0,1002040742,1},1},{{0,1003000742,1},1},{{0,1004040742,1},1},{{0,1006040742,1},1},{{0,1007040742,1},1},{{0,1008040742,1},1},{{0,1010040742,1},1}]','[]','[1001040742,1002040742,1003000742,1004040742,1005000742,1006040742,1007040742,1008040742,1009000742,1010040742]'),(32080732,0,1000,0,1,0,1,0,'[{{0,1002010742,1},1},{{0,1004010742,1},1},{{0,1006010742,1},1},{{0,1008010742,1},1},{{0,1010010742,1},1}]','[]','[1002010742,1004010742,1006010742,1008010742,1010010742]'),(32080732,0,1000,0,2,0,1,0,'[{{0,1002020742,1},1},{{0,1004020742,1},1},{{0,1006020742,1},1},{{0,1008020742,1},1},{{0,1010020742,1},1}]','[]','[1002020742,1004020742,1006020742,1008020742,1010020742]'),(32080732,0,1000,0,3,0,1,0,'[{{0,1002030742,1},1},{{0,1004030742,1},1},{{0,1006030742,1},1},{{0,1008030742,1},1},{{0,1010030742,1},1}]','[]','[1002030742,1004030742,1006030742,1008030742,1010030742]'),(32080732,0,1000,0,4,0,1,0,'[{{0,1002040742,1},1},{{0,1004040742,1},1},{{0,1006040742,1},1},{{0,1008040742,1},1},{{0,1010040742,1},1}]','[]','[1002040742,1004040742,1006040742,1008040742,1010040742]'),(32080733,0,1000,0,1,0,1,0,'[{{0,1001010742,1},1},{{0,1007010742,1},1}]','[]','[1001010742,1007010742]'),(32080733,0,1000,0,2,0,1,0,'[{{0,1001020742,1},1},{{0,1007020742,1},1}]','[]','[1001020742,1007020742]'),(32080733,0,1000,0,3,0,1,0,'[{{0,1001030742,1},1},{{0,1007030742,1},1}]','[]','[1001030742,1007030742]'),(32080733,0,1000,0,4,0,1,0,'[{{0,1001040742,1},1},{{0,1007040742,1},1}]','[]','[1001040742,1007040742]'),(32080735,0,1000,0,1,0,1,0,'[{{0,1002010742,1},1},{{0,1004010742,1},1},{{0,1006010742,1},1},{{0,1008010742,1},1},{{0,1010010742,1},1},{{0,1001010742,1},1}]','[]','[1002010742,1004010742,1006010742,1008010742,1010010742,1001010742]'),(32080735,0,1000,0,2,0,1,0,'[{{0,1002020742,1},1},{{0,1004020742,1},1},{{0,1006020742,1},1},{{0,1008020742,1},1},{{0,1010020742,1},1},{{0,1001020742,1},1}]','[]','[1002020742,1004020742,1006020742,1008020742,1010020742,1001020742]'),(32080735,0,1000,0,3,0,1,0,'[{{0,1002030742,1},1},{{0,1004030742,1},1},{{0,1006030742,1},1},{{0,1008030742,1},1},{{0,1010030742,1},1},{{0,1001030742,1},1}]','[]','[1002030742,1004030742,1006030742,1008030742,1010030742,1001030742]'),(32080735,0,1000,0,4,0,1,0,'[{{0,1002040742,1},1},{{0,1004040742,1},1},{{0,1006040742,1},1},{{0,1008040742,1},1},{{0,1010040742,1},1},{{0,1001040742,1},1}]','[]','[1002040742,1004040742,1006040742,1008040742,1010040742,1001040742]'),(32080736,0,1000,0,1,0,1,0,'[{{0,1007010742,1},1},{{0,1003000742,1},1},{{0,1005000742,1},1},{{0,1009000742,1},1}]','[]','[1007010742,1003000742,1005000742,1009000742]'),(32080736,0,1000,0,2,0,1,0,'[{{0,1007020742,1},1},{{0,1003000742,1},1},{{0,1005000742,1},1},{{0,1009000742,1},1}]','[]','[1007020742,1003000742,1005000742,1009000742]'),(32080736,0,1000,0,3,0,1,0,'[{{0,1007030742,1},1},{{0,1003000742,1},1},{{0,1005000742,1},1},{{0,1009000742,1},1}]','[]','[1007030742,1003000742,1005000742,1009000742]'),(32080736,0,1000,0,4,0,1,0,'[{{0,1007040742,1},1},{{0,1003000742,1},1},{{0,1005000742,1},1},{{0,1009000742,1},1}]','[]','[1007040742,1003000742,1005000742,1009000742]'),(32080737,0,1000,0,1,0,1,0,'[{{0,1007010742,1},1},{{0,1003000742,1},1}]','[]','[1007010742,1003000742]'),(32080737,0,1000,0,2,0,1,0,'[{{0,1007020742,1},1},{{0,1003000742,1},1}]','[]','[1007020742,1003000742]'),(32080737,0,1000,0,3,0,1,0,'[{{0,1007030742,1},1},{{0,1003000742,1},1}]','[]','[1007030742,1003000742]'),(32080737,0,1000,0,4,0,1,0,'[{{0,1007040742,1},1},{{0,1003000742,1},1}]','[]','[1007040742,1003000742]'),(32080738,0,1000,0,0,0,1,0,'[{{0,1005000742,1},1},{{0,1009000742,1},1}]','[]','[1005000742,1009000742]'),(32080741,0,1000,0,1,0,1,0,'[{{0,1001010743,1},1},{{0,1002010743,1},1},{{0,1003000743,1},1},{{0,1004010743,1},1},{{0,1006010743,1},1},{{0,1007010743,1},1},{{0,1008010743,1},1},{{0,1010010743,1},1}]','[]','[1001010743,1002010743,1003000743,1004010743,1005000743,1006010743,1007010743,1008010743,1009000743,1010010743]'),(32080741,0,1000,0,2,0,1,0,'[{{0,1001020743,1},1},{{0,1002020743,1},1},{{0,1003000743,1},1},{{0,1004020743,1},1},{{0,1006020743,1},1},{{0,1007020743,1},1},{{0,1008020743,1},1},{{0,1010020743,1},1}]','[]','[1001020743,1002020743,1003000743,1004020743,1005000743,1006020743,1007020743,1008020743,1009000743,1010020743]'),(32080741,0,1000,0,3,0,1,0,'[{{0,1001030743,1},1},{{0,1002030743,1},1},{{0,1003000743,1},1},{{0,1004030743,1},1},{{0,1006030743,1},1},{{0,1007030743,1},1},{{0,1008030743,1},1},{{0,1010030743,1},1}]','[]','[1001030743,1002030743,1003000743,1004030743,1005000743,1006030743,1007030743,1008030743,1009000743,1010030743]'),(32080741,0,1000,0,4,0,1,0,'[{{0,1001040743,1},1},{{0,1002040743,1},1},{{0,1003000743,1},1},{{0,1004040743,1},1},{{0,1006040743,1},1},{{0,1007040743,1},1},{{0,1008040743,1},1},{{0,1010040743,1},1}]','[]','[1001040743,1002040743,1003000743,1004040743,1005000743,1006040743,1007040743,1008040743,1009000743,1010040743]'),(32080742,0,1000,0,1,0,1,0,'[{{0,1002010743,1},1},{{0,1004010743,1},1},{{0,1006010743,1},1},{{0,1008010743,1},1},{{0,1010010743,1},1}]','[]','[1002010743,1004010743,1006010743,1008010743,1010010743]'),(32080742,0,1000,0,2,0,1,0,'[{{0,1002020743,1},1},{{0,1004020743,1},1},{{0,1006020743,1},1},{{0,1008020743,1},1},{{0,1010020743,1},1}]','[]','[1002020743,1004020743,1006020743,1008020743,1010020743]'),(32080742,0,1000,0,3,0,1,0,'[{{0,1002030743,1},1},{{0,1004030743,1},1},{{0,1006030743,1},1},{{0,1008030743,1},1},{{0,1010030743,1},1}]','[]','[1002030743,1004030743,1006030743,1008030743,1010030743]'),(32080742,0,1000,0,4,0,1,0,'[{{0,1002040743,1},1},{{0,1004040743,1},1},{{0,1006040743,1},1},{{0,1008040743,1},1},{{0,1010040743,1},1}]','[]','[1002040743,1004040743,1006040743,1008040743,1010040743]'),(32080743,0,1000,0,1,0,1,0,'[{{0,1001010743,1},1},{{0,1007010743,1},1}]','[]','[1001010743,1007010743]'),(32080743,0,1000,0,2,0,1,0,'[{{0,1001020743,1},1},{{0,1007020743,1},1}]','[]','[1001020743,1007020743]'),(32080743,0,1000,0,3,0,1,0,'[{{0,1001030743,1},1},{{0,1007030743,1},1}]','[]','[1001030743,1007030743]'),(32080743,0,1000,0,4,0,1,0,'[{{0,1001040743,1},1},{{0,1007040743,1},1}]','[]','[1001040743,1007040743]'),(32080745,0,1000,0,1,0,1,0,'[{{0,1002010743,1},1},{{0,1004010743,1},1},{{0,1006010743,1},1},{{0,1008010743,1},1},{{0,1010010743,1},1},{{0,1001010743,1},1}]','[]','[1002010743,1004010743,1006010743,1008010743,1010010743,1001010743]'),(32080745,0,1000,0,2,0,1,0,'[{{0,1002020743,1},1},{{0,1004020743,1},1},{{0,1006020743,1},1},{{0,1008020743,1},1},{{0,1010020743,1},1},{{0,1001020743,1},1}]','[]','[1002020743,1004020743,1006020743,1008020743,1010020743,1001020743]'),(32080745,0,1000,0,3,0,1,0,'[{{0,1002030743,1},1},{{0,1004030743,1},1},{{0,1006030743,1},1},{{0,1008030743,1},1},{{0,1010030743,1},1},{{0,1001030743,1},1}]','[]','[1002030743,1004030743,1006030743,1008030743,1010030743,1001030743]'),(32080745,0,1000,0,4,0,1,0,'[{{0,1002040743,1},1},{{0,1004040743,1},1},{{0,1006040743,1},1},{{0,1008040743,1},1},{{0,1010040743,1},1},{{0,1001040743,1},1}]','[]','[1002040743,1004040743,1006040743,1008040743,1010040743,1001040743]'),(32080746,0,1000,0,1,0,1,0,'[{{0,1007010743,1},1},{{0,1003000743,1},1},{{0,1005000743,1},1},{{0,1009000743,1},1}]','[]','[1007010743,1003000743,1005000743,1009000743]'),(32080746,0,1000,0,2,0,1,0,'[{{0,1007020743,1},1},{{0,1003000743,1},1},{{0,1005000743,1},1},{{0,1009000743,1},1}]','[]','[1007020743,1003000743,1005000743,1009000743]'),(32080746,0,1000,0,3,0,1,0,'[{{0,1007030743,1},1},{{0,1003000743,1},1},{{0,1005000743,1},1},{{0,1009000743,1},1}]','[]','[1007030743,1003000743,1005000743,1009000743]'),(32080746,0,1000,0,4,0,1,0,'[{{0,1007040743,1},1},{{0,1003000743,1},1},{{0,1005000743,1},1},{{0,1009000743,1},1}]','[]','[1007040743,1003000743,1005000743,1009000743]'),(32080747,0,1000,0,1,0,1,0,'[{{0,1007010743,1},1},{{0,1003000743,1},1}]','[]','[1007010743,1003000743]'),(32080747,0,1000,0,2,0,1,0,'[{{0,1007020743,1},1},{{0,1003000743,1},1}]','[]','[1007020743,1003000743]'),(32080747,0,1000,0,3,0,1,0,'[{{0,1007030743,1},1},{{0,1003000743,1},1}]','[]','[1007030743,1003000743]'),(32080747,0,1000,0,4,0,1,0,'[{{0,1007040743,1},1},{{0,1003000743,1},1}]','[]','[1007040743,1003000743]'),(32080748,0,1000,0,0,0,1,0,'[{{0,1005000743,1},1},{{0,1009000743,1},1}]','[]','[1005000743,1009000743]'),(32080751,0,1000,0,1,0,1,0,'[{{0,1001010753,1},1},{{0,1002010753,1},1},{{0,1003000753,1},1},{{0,1004010753,1},1},{{0,1006010753,1},1},{{0,1007010753,1},1},{{0,1008010753,1},1},{{0,1010010753,1},1}]','[]','[1001010753,1002010753,1003000753,1004010753,1005000753,1006010753,1007010753,1008010753,1009000753,1010010753]'),(32080751,0,1000,0,2,0,1,0,'[{{0,1001020753,1},1},{{0,1002020753,1},1},{{0,1003000753,1},1},{{0,1004020753,1},1},{{0,1006020753,1},1},{{0,1007020753,1},1},{{0,1008020753,1},1},{{0,1010020753,1},1}]','[]','[1001020753,1002020753,1003000753,1004020753,1005000753,1006020753,1007020753,1008020753,1009000753,1010020753]'),(32080751,0,1000,0,3,0,1,0,'[{{0,1001030753,1},1},{{0,1002030753,1},1},{{0,1003000753,1},1},{{0,1004030753,1},1},{{0,1006030753,1},1},{{0,1007030753,1},1},{{0,1008030753,1},1},{{0,1010030753,1},1}]','[]','[1001030753,1002030753,1003000753,1004030753,1005000753,1006030753,1007030753,1008030753,1009000753,1010030753]'),(32080751,0,1000,0,4,0,1,0,'[{{0,1001040753,1},1},{{0,1002040753,1},1},{{0,1003000753,1},1},{{0,1004040753,1},1},{{0,1006040753,1},1},{{0,1007040753,1},1},{{0,1008040753,1},1},{{0,1010040753,1},1}]','[]','[1001040753,1002040753,1003000753,1004040753,1005000753,1006040753,1007040753,1008040753,1009000753,1010040753]'),(32080752,0,1000,0,1,0,1,0,'[{{0,1002010753,1},1},{{0,1004010753,1},1},{{0,1006010753,1},1},{{0,1008010753,1},1},{{0,1010010753,1},1}]','[]','[1002010753,1004010753,1006010753,1008010753,1010010753]'),(32080752,0,1000,0,2,0,1,0,'[{{0,1002020753,1},1},{{0,1004020753,1},1},{{0,1006020753,1},1},{{0,1008020753,1},1},{{0,1010020753,1},1}]','[]','[1002020753,1004020753,1006020753,1008020753,1010020753]'),(32080752,0,1000,0,3,0,1,0,'[{{0,1002030753,1},1},{{0,1004030753,1},1},{{0,1006030753,1},1},{{0,1008030753,1},1},{{0,1010030753,1},1}]','[]','[1002030753,1004030753,1006030753,1008030753,1010030753]'),(32080752,0,1000,0,4,0,1,0,'[{{0,1002040753,1},1},{{0,1004040753,1},1},{{0,1006040753,1},1},{{0,1008040753,1},1},{{0,1010040753,1},1}]','[]','[1002040753,1004040753,1006040753,1008040753,1010040753]'),(32080753,0,1000,0,1,0,1,0,'[{{0,1001010753,1},1},{{0,1007010753,1},1}]','[]','[1001010753,1007010753]'),(32080753,0,1000,0,2,0,1,0,'[{{0,1001020753,1},1},{{0,1007020753,1},1}]','[]','[1001020753,1007020753]'),(32080753,0,1000,0,3,0,1,0,'[{{0,1001030753,1},1},{{0,1007030753,1},1}]','[]','[1001030753,1007030753]'),(32080753,0,1000,0,4,0,1,0,'[{{0,1001040753,1},1},{{0,1007040753,1},1}]','[]','[1001040753,1007040753]'),(32080755,0,1000,0,1,0,1,0,'[{{0,1002010753,1},1},{{0,1004010753,1},1},{{0,1006010753,1},1},{{0,1008010753,1},1},{{0,1010010753,1},1},{{0,1001010753,1},1}]','[]','[1002010753,1004010753,1006010753,1008010753,1010010753,1001010753]'),(32080755,0,1000,0,2,0,1,0,'[{{0,1002020753,1},1},{{0,1004020753,1},1},{{0,1006020753,1},1},{{0,1008020753,1},1},{{0,1010020753,1},1},{{0,1001020753,1},1}]','[]','[1002020753,1004020753,1006020753,1008020753,1010020753,1001020753]'),(32080755,0,1000,0,3,0,1,0,'[{{0,1002030753,1},1},{{0,1004030753,1},1},{{0,1006030753,1},1},{{0,1008030753,1},1},{{0,1010030753,1},1},{{0,1001030753,1},1}]','[]','[1002030753,1004030753,1006030753,1008030753,1010030753,1001030753]'),(32080755,0,1000,0,4,0,1,0,'[{{0,1002040753,1},1},{{0,1004040753,1},1},{{0,1006040753,1},1},{{0,1008040753,1},1},{{0,1010040753,1},1},{{0,1001040753,1},1}]','[]','[1002040753,1004040753,1006040753,1008040753,1010040753,1001040753]'),(32080756,0,1000,0,1,0,1,0,'[{{0,1007010753,1},1},{{0,1003000753,1},1},{{0,1005000753,1},1},{{0,1009000753,1},1}]','[]','[1007010753,1003000753,1005000753,1009000753]'),(32080756,0,1000,0,2,0,1,0,'[{{0,1007020753,1},1},{{0,1003000753,1},1},{{0,1005000753,1},1},{{0,1009000753,1},1}]','[]','[1007020753,1003000753,1005000753,1009000753]'),(32080756,0,1000,0,3,0,1,0,'[{{0,1007030753,1},1},{{0,1003000753,1},1},{{0,1005000753,1},1},{{0,1009000753,1},1}]','[]','[1007030753,1003000753,1005000753,1009000753]'),(32080756,0,1000,0,4,0,1,0,'[{{0,1007040753,1},1},{{0,1003000753,1},1},{{0,1005000753,1},1},{{0,1009000753,1},1}]','[]','[1007040753,1003000753,1005000753,1009000753]'),(32080757,0,1000,0,1,0,1,0,'[{{0,1007010753,1},1},{{0,1003000753,1},1}]','[]','[1007010753,1003000753]'),(32080757,0,1000,0,2,0,1,0,'[{{0,1007020753,1},1},{{0,1003000753,1},1}]','[]','[1007020753,1003000753]'),(32080757,0,1000,0,3,0,1,0,'[{{0,1007030753,1},1},{{0,1003000753,1},1}]','[]','[1007030753,1003000753]'),(32080757,0,1000,0,4,0,1,0,'[{{0,1007040753,1},1},{{0,1003000753,1},1}]','[]','[1007040753,1003000753]'),(32080758,0,1000,0,0,0,1,0,'[{{0,1005000753,1},1},{{0,1009000753,1},1}]','[]','[1005000753,1009000753]'),(32080761,0,1000,0,1,0,1,0,'[{{0,1001010763,1},1},{{0,1002010763,1},1},{{0,1003000763,1},1},{{0,1004010763,1},1},{{0,1006010763,1},1},{{0,1007010763,1},1},{{0,1008010763,1},1},{{0,1010010763,1},1}]','[]','[1001010763,1002010763,1003000763,1004010763,1005000763,1006010763,1007010763,1008010763,1009000763,1010010763]'),(32080761,0,1000,0,2,0,1,0,'[{{0,1001020763,1},1},{{0,1002020763,1},1},{{0,1003000763,1},1},{{0,1004020763,1},1},{{0,1006020763,1},1},{{0,1007020763,1},1},{{0,1008020763,1},1},{{0,1010020763,1},1}]','[]','[1001020763,1002020763,1003000763,1004020763,1005000763,1006020763,1007020763,1008020763,1009000763,1010020763]'),(32080761,0,1000,0,3,0,1,0,'[{{0,1001030763,1},1},{{0,1002030763,1},1},{{0,1003000763,1},1},{{0,1004030763,1},1},{{0,1006030763,1},1},{{0,1007030763,1},1},{{0,1008030763,1},1},{{0,1010030763,1},1}]','[]','[1001030763,1002030763,1003000763,1004030763,1005000763,1006030763,1007030763,1008030763,1009000763,1010030763]'),(32080761,0,1000,0,4,0,1,0,'[{{0,1001040763,1},1},{{0,1002040763,1},1},{{0,1003000763,1},1},{{0,1004040763,1},1},{{0,1006040763,1},1},{{0,1007040763,1},1},{{0,1008040763,1},1},{{0,1010040763,1},1}]','[]','[1001040763,1002040763,1003000763,1004040763,1005000763,1006040763,1007040763,1008040763,1009000763,1010040763]'),(32080762,0,1000,0,1,0,1,0,'[{{0,1002010763,1},1},{{0,1004010763,1},1},{{0,1006010763,1},1},{{0,1008010763,1},1},{{0,1010010763,1},1}]','[]','[1002010763,1004010763,1006010763,1008010763,1010010763]'),(32080762,0,1000,0,2,0,1,0,'[{{0,1002020763,1},1},{{0,1004020763,1},1},{{0,1006020763,1},1},{{0,1008020763,1},1},{{0,1010020763,1},1}]','[]','[1002020763,1004020763,1006020763,1008020763,1010020763]'),(32080762,0,1000,0,3,0,1,0,'[{{0,1002030763,1},1},{{0,1004030763,1},1},{{0,1006030763,1},1},{{0,1008030763,1},1},{{0,1010030763,1},1}]','[]','[1002030763,1004030763,1006030763,1008030763,1010030763]'),(32080762,0,1000,0,4,0,1,0,'[{{0,1002040763,1},1},{{0,1004040763,1},1},{{0,1006040763,1},1},{{0,1008040763,1},1},{{0,1010040763,1},1}]','[]','[1002040763,1004040763,1006040763,1008040763,1010040763]'),(32080763,0,1000,0,1,0,1,0,'[{{0,1001010763,1},1},{{0,1007010763,1},1}]','[]','[1001010763,1007010763]'),(32080763,0,1000,0,2,0,1,0,'[{{0,1001020763,1},1},{{0,1007020763,1},1}]','[]','[1001020763,1007020763]'),(32080763,0,1000,0,3,0,1,0,'[{{0,1001030763,1},1},{{0,1007030763,1},1}]','[]','[1001030763,1007030763]'),(32080763,0,1000,0,4,0,1,0,'[{{0,1001040763,1},1},{{0,1007040763,1},1}]','[]','[1001040763,1007040763]'),(32080765,0,1000,0,1,0,1,0,'[{{0,1002010763,1},1},{{0,1004010763,1},1},{{0,1006010763,1},1},{{0,1008010763,1},1},{{0,1010010763,1},1},{{0,1001010763,1},1}]','[]','[1002010763,1004010763,1006010763,1008010763,1010010763,1001010763]'),(32080765,0,1000,0,2,0,1,0,'[{{0,1002020763,1},1},{{0,1004020763,1},1},{{0,1006020763,1},1},{{0,1008020763,1},1},{{0,1010020763,1},1},{{0,1001020763,1},1}]','[]','[1002020763,1004020763,1006020763,1008020763,1010020763,1001020763]'),(32080765,0,1000,0,3,0,1,0,'[{{0,1002030763,1},1},{{0,1004030763,1},1},{{0,1006030763,1},1},{{0,1008030763,1},1},{{0,1010030763,1},1},{{0,1001030763,1},1}]','[]','[1002030763,1004030763,1006030763,1008030763,1010030763,1001030763]'),(32080765,0,1000,0,4,0,1,0,'[{{0,1002040763,1},1},{{0,1004040763,1},1},{{0,1006040763,1},1},{{0,1008040763,1},1},{{0,1010040763,1},1},{{0,1001040763,1},1}]','[]','[1002040763,1004040763,1006040763,1008040763,1010040763,1001040763]'),(32080766,0,1000,0,1,0,1,0,'[{{0,1007010763,1},1},{{0,1003000763,1},1},{{0,1005000763,1},1},{{0,1009000763,1},1}]','[]','[1007010763,1003000763,1005000763,1009000763]'),(32080766,0,1000,0,2,0,1,0,'[{{0,1007020763,1},1},{{0,1003000763,1},1},{{0,1005000763,1},1},{{0,1009000763,1},1}]','[]','[1007020763,1003000763,1005000763,1009000763]'),(32080766,0,1000,0,3,0,1,0,'[{{0,1007030763,1},1},{{0,1003000763,1},1},{{0,1005000763,1},1},{{0,1009000763,1},1}]','[]','[1007030763,1003000763,1005000763,1009000763]'),(32080766,0,1000,0,4,0,1,0,'[{{0,1007040763,1},1},{{0,1003000763,1},1},{{0,1005000763,1},1},{{0,1009000763,1},1}]','[]','[1007040763,1003000763,1005000763,1009000763]'),(32080767,0,1000,0,1,0,1,0,'[{{0,1007010763,1},1},{{0,1003000763,1},1}]','[]','[1007010763,1003000763]'),(32080767,0,1000,0,2,0,1,0,'[{{0,1007020763,1},1},{{0,1003000763,1},1}]','[]','[1007020763,1003000763]'),(32080767,0,1000,0,3,0,1,0,'[{{0,1007030763,1},1},{{0,1003000763,1},1}]','[]','[1007030763,1003000763]'),(32080767,0,1000,0,4,0,1,0,'[{{0,1007040763,1},1},{{0,1003000763,1},1}]','[]','[1007040763,1003000763]'),(32080768,0,1000,0,0,0,1,0,'[{{0,1005000763,1},1},{{0,1009000763,1},1}]','[]','[1005000763,1009000763]'),(32080771,0,1000,0,1,0,1,0,'[{{0,1001010700,1},1},{{0,1002010700,1},1},{{0,1003000700,1},1},{{0,1004010700,1},1},{{0,1006010700,1},1},{{0,1007010700,1},1},{{0,1008010700,1},1},{{0,1010010700,1},1}]','[]','[]'),(32080771,0,1000,0,2,0,1,0,'[{{0,1001020700,1},1},{{0,1002020700,1},1},{{0,1003000700,1},1},{{0,1004020700,1},1},{{0,1006020700,1},1},{{0,1007020700,1},1},{{0,1008020700,1},1},{{0,1010020700,1},1}]','[]','[]'),(32080771,0,1000,0,3,0,1,0,'[{{0,1001030700,1},1},{{0,1002030700,1},1},{{0,1003000700,1},1},{{0,1004030700,1},1},{{0,1006030700,1},1},{{0,1007030700,1},1},{{0,1008030700,1},1},{{0,1010030700,1},1}]','[]','[]'),(32080771,0,1000,0,4,0,1,0,'[{{0,1001040700,1},1},{{0,1002040700,1},1},{{0,1003000700,1},1},{{0,1004040700,1},1},{{0,1006040700,1},1},{{0,1007040700,1},1},{{0,1008040700,1},1},{{0,1010040700,1},1}]','[]','[]'),(32080772,0,1000,0,1,0,1,0,'[{{0,1002010700,1},1},{{0,1004010700,1},1},{{0,1006010700,1},1},{{0,1008010700,1},1},{{0,1010010700,1},1}]','[]','[]'),(32080772,0,1000,0,2,0,1,0,'[{{0,1002020700,1},1},{{0,1004020700,1},1},{{0,1006020700,1},1},{{0,1008020700,1},1},{{0,1010020700,1},1}]','[]','[]'),(32080772,0,1000,0,3,0,1,0,'[{{0,1002030700,1},1},{{0,1004030700,1},1},{{0,1006030700,1},1},{{0,1008030700,1},1},{{0,1010030700,1},1}]','[]','[]'),(32080772,0,1000,0,4,0,1,0,'[{{0,1002040700,1},1},{{0,1004040700,1},1},{{0,1006040700,1},1},{{0,1008040700,1},1},{{0,1010040700,1},1}]','[]','[]'),(32080773,0,1000,0,1,0,1,0,'[{{0,1001010700,1},1},{{0,1007010700,1},1}]','[]','[]'),(32080773,0,1000,0,2,0,1,0,'[{{0,1001020700,1},1},{{0,1007020700,1},1}]','[]','[]'),(32080773,0,1000,0,3,0,1,0,'[{{0,1001030700,1},1},{{0,1007030700,1},1}]','[]','[]'),(32080773,0,1000,0,4,0,1,0,'[{{0,1001040700,1},1},{{0,1007040700,1},1}]','[]','[]'),(32080775,0,1000,0,1,0,1,0,'[{{0,1002010700,1},1},{{0,1004010700,1},1},{{0,1006010700,1},1},{{0,1008010700,1},1},{{0,1010010700,1},1},{{0,1001010700,1},1}]','[]','[]'),(32080775,0,1000,0,2,0,1,0,'[{{0,1002020700,1},1},{{0,1004020700,1},1},{{0,1006020700,1},1},{{0,1008020700,1},1},{{0,1010020700,1},1},{{0,1001020700,1},1}]','[]','[]'),(32080775,0,1000,0,3,0,1,0,'[{{0,1002030700,1},1},{{0,1004030700,1},1},{{0,1006030700,1},1},{{0,1008030700,1},1},{{0,1010030700,1},1},{{0,1001030700,1},1}]','[]','[]'),(32080775,0,1000,0,4,0,1,0,'[{{0,1002040700,1},1},{{0,1004040700,1},1},{{0,1006040700,1},1},{{0,1008040700,1},1},{{0,1010040700,1},1},{{0,1001040700,1},1}]','[]','[]'),(32080776,0,1000,0,1,0,1,0,'[{{0,1007010700,1},1},{{0,1003000700,1},1},{{0,1005000700,1},1},{{0,1009000700,1},1}]','[]','[]'),(32080776,0,1000,0,2,0,1,0,'[{{0,1007020700,1},1},{{0,1003000700,1},1},{{0,1005000700,1},1},{{0,1009000700,1},1}]','[]','[]'),(32080776,0,1000,0,3,0,1,0,'[{{0,1007030700,1},1},{{0,1003000700,1},1},{{0,1005000700,1},1},{{0,1009000700,1},1}]','[]','[]'),(32080776,0,1000,0,4,0,1,0,'[{{0,1007040700,1},1},{{0,1003000700,1},1},{{0,1005000700,1},1},{{0,1009000700,1},1}]','[]','[]'),(32080777,0,1000,0,1,0,1,0,'[{{0,1007010700,1},1},{{0,1003000700,1},1}]','[]','[]'),(32080777,0,1000,0,2,0,1,0,'[{{0,1007020700,1},1},{{0,1003000700,1},1}]','[]','[]'),(32080777,0,1000,0,3,0,1,0,'[{{0,1007030700,1},1},{{0,1003000700,1},1}]','[]','[]'),(32080777,0,1000,0,4,0,1,0,'[{{0,1007040700,1},1},{{0,1003000700,1},1}]','[]','[]'),(32080778,0,1000,0,0,0,1,0,'[{{0,1005000700,1},1},{{0,1009000700,1},1}]','[]','[]'),(32080781,0,1000,0,1,0,1,0,'[{{0,1001010710,1},1},{{0,1002010710,1},1},{{0,1003000710,1},1},{{0,1004010710,1},1},{{0,1006010710,1},1},{{0,1007010710,1},1},{{0,1008010710,1},1},{{0,1010010710,1},1}]','[]','[]'),(32080781,0,1000,0,2,0,1,0,'[{{0,1001020710,1},1},{{0,1002020710,1},1},{{0,1003000710,1},1},{{0,1004020710,1},1},{{0,1006020710,1},1},{{0,1007020710,1},1},{{0,1008020710,1},1},{{0,1010020710,1},1}]','[]','[]'),(32080781,0,1000,0,3,0,1,0,'[{{0,1001030710,1},1},{{0,1002030710,1},1},{{0,1003000710,1},1},{{0,1004030710,1},1},{{0,1006030710,1},1},{{0,1007030710,1},1},{{0,1008030710,1},1},{{0,1010030710,1},1}]','[]','[]'),(32080781,0,1000,0,4,0,1,0,'[{{0,1001040710,1},1},{{0,1002040710,1},1},{{0,1003000710,1},1},{{0,1004040710,1},1},{{0,1006040710,1},1},{{0,1007040710,1},1},{{0,1008040710,1},1},{{0,1010040710,1},1}]','[]','[]'),(32080782,0,1000,0,1,0,1,0,'[{{0,1002010710,1},1},{{0,1004010710,1},1},{{0,1006010710,1},1},{{0,1008010710,1},1},{{0,1010010710,1},1}]','[]','[]'),(32080782,0,1000,0,2,0,1,0,'[{{0,1002020710,1},1},{{0,1004020710,1},1},{{0,1006020710,1},1},{{0,1008020710,1},1},{{0,1010020710,1},1}]','[]','[]'),(32080782,0,1000,0,3,0,1,0,'[{{0,1002030710,1},1},{{0,1004030710,1},1},{{0,1006030710,1},1},{{0,1008030710,1},1},{{0,1010030710,1},1}]','[]','[]'),(32080782,0,1000,0,4,0,1,0,'[{{0,1002040710,1},1},{{0,1004040710,1},1},{{0,1006040710,1},1},{{0,1008040710,1},1},{{0,1010040710,1},1}]','[]','[]'),(32080783,0,1000,0,1,0,1,0,'[{{0,1001010710,1},1},{{0,1007010710,1},1}]','[]','[]'),(32080783,0,1000,0,2,0,1,0,'[{{0,1001020710,1},1},{{0,1007020710,1},1}]','[]','[]'),(32080783,0,1000,0,3,0,1,0,'[{{0,1001030710,1},1},{{0,1007030710,1},1}]','[]','[]'),(32080783,0,1000,0,4,0,1,0,'[{{0,1001040710,1},1},{{0,1007040710,1},1}]','[]','[]'),(32080785,0,1000,0,1,0,1,0,'[{{0,1002010710,1},1},{{0,1004010710,1},1},{{0,1006010710,1},1},{{0,1008010710,1},1},{{0,1010010710,1},1},{{0,1001010710,1},1}]','[]','[]'),(32080785,0,1000,0,2,0,1,0,'[{{0,1002020710,1},1},{{0,1004020710,1},1},{{0,1006020710,1},1},{{0,1008020710,1},1},{{0,1010020710,1},1},{{0,1001020710,1},1}]','[]','[]'),(32080785,0,1000,0,3,0,1,0,'[{{0,1002030710,1},1},{{0,1004030710,1},1},{{0,1006030710,1},1},{{0,1008030710,1},1},{{0,1010030710,1},1},{{0,1001030710,1},1}]','[]','[]'),(32080785,0,1000,0,4,0,1,0,'[{{0,1002040710,1},1},{{0,1004040710,1},1},{{0,1006040710,1},1},{{0,1008040710,1},1},{{0,1010040710,1},1},{{0,1001040710,1},1}]','[]','[]'),(32080786,0,1000,0,1,0,1,0,'[{{0,1007010710,1},1},{{0,1003000710,1},1},{{0,1005000710,1},1},{{0,1009000710,1},1}]','[]','[]'),(32080786,0,1000,0,2,0,1,0,'[{{0,1007020710,1},1},{{0,1003000710,1},1},{{0,1005000710,1},1},{{0,1009000710,1},1}]','[]','[]'),(32080786,0,1000,0,3,0,1,0,'[{{0,1007030710,1},1},{{0,1003000710,1},1},{{0,1005000710,1},1},{{0,1009000710,1},1}]','[]','[]'),(32080786,0,1000,0,4,0,1,0,'[{{0,1007040710,1},1},{{0,1003000710,1},1},{{0,1005000710,1},1},{{0,1009000710,1},1}]','[]','[]'),(32080787,0,1000,0,1,0,1,0,'[{{0,1007010710,1},1},{{0,1003000710,1},1}]','[]','[]'),(32080787,0,1000,0,2,0,1,0,'[{{0,1007020710,1},1},{{0,1003000710,1},1}]','[]','[]'),(32080787,0,1000,0,3,0,1,0,'[{{0,1007030710,1},1},{{0,1003000710,1},1}]','[]','[]'),(32080787,0,1000,0,4,0,1,0,'[{{0,1007040710,1},1},{{0,1003000710,1},1}]','[]','[]'),(32080788,0,1000,0,0,0,1,0,'[{{0,1005000710,1},1},{{0,1009000710,1},1}]','[]','[]'),(32080791,0,1000,0,1,0,1,0,'[{{0,1001010720,1},1},{{0,1002010720,1},1},{{0,1003000720,1},1},{{0,1004010720,1},1},{{0,1006010720,1},1},{{0,1007010720,1},1},{{0,1008010720,1},1},{{0,1010010720,1},1}]','[]','[]'),(32080791,0,1000,0,2,0,1,0,'[{{0,1001020720,1},1},{{0,1002020720,1},1},{{0,1003000720,1},1},{{0,1004020720,1},1},{{0,1006020720,1},1},{{0,1007020720,1},1},{{0,1008020720,1},1},{{0,1010020720,1},1}]','[]','[]'),(32080791,0,1000,0,3,0,1,0,'[{{0,1001030720,1},1},{{0,1002030720,1},1},{{0,1003000720,1},1},{{0,1004030720,1},1},{{0,1006030720,1},1},{{0,1007030720,1},1},{{0,1008030720,1},1},{{0,1010030720,1},1}]','[]','[]'),(32080791,0,1000,0,4,0,1,0,'[{{0,1001040720,1},1},{{0,1002040720,1},1},{{0,1003000720,1},1},{{0,1004040720,1},1},{{0,1006040720,1},1},{{0,1007040720,1},1},{{0,1008040720,1},1},{{0,1010040720,1},1}]','[]','[]'),(32080792,0,1000,0,1,0,1,0,'[{{0,1002010720,1},1},{{0,1004010720,1},1},{{0,1006010720,1},1},{{0,1008010720,1},1},{{0,1010010720,1},1}]','[]','[]'),(32080792,0,1000,0,2,0,1,0,'[{{0,1002020720,1},1},{{0,1004020720,1},1},{{0,1006020720,1},1},{{0,1008020720,1},1},{{0,1010020720,1},1}]','[]','[]'),(32080792,0,1000,0,3,0,1,0,'[{{0,1002030720,1},1},{{0,1004030720,1},1},{{0,1006030720,1},1},{{0,1008030720,1},1},{{0,1010030720,1},1}]','[]','[]'),(32080792,0,1000,0,4,0,1,0,'[{{0,1002040720,1},1},{{0,1004040720,1},1},{{0,1006040720,1},1},{{0,1008040720,1},1},{{0,1010040720,1},1}]','[]','[]'),(32080793,0,1000,0,1,0,1,0,'[{{0,1001010720,1},1},{{0,1007010720,1},1}]','[]','[]'),(32080793,0,1000,0,2,0,1,0,'[{{0,1001020720,1},1},{{0,1007020720,1},1}]','[]','[]'),(32080793,0,1000,0,3,0,1,0,'[{{0,1001030720,1},1},{{0,1007030720,1},1}]','[]','[]'),(32080793,0,1000,0,4,0,1,0,'[{{0,1001040720,1},1},{{0,1007040720,1},1}]','[]','[]'),(32080795,0,1000,0,1,0,1,0,'[{{0,1002010720,1},1},{{0,1004010720,1},1},{{0,1006010720,1},1},{{0,1008010720,1},1},{{0,1010010720,1},1},{{0,1001010720,1},1}]','[]','[]'),(32080795,0,1000,0,2,0,1,0,'[{{0,1002020720,1},1},{{0,1004020720,1},1},{{0,1006020720,1},1},{{0,1008020720,1},1},{{0,1010020720,1},1},{{0,1001020720,1},1}]','[]','[]'),(32080795,0,1000,0,3,0,1,0,'[{{0,1002030720,1},1},{{0,1004030720,1},1},{{0,1006030720,1},1},{{0,1008030720,1},1},{{0,1010030720,1},1},{{0,1001030720,1},1}]','[]','[]'),(32080795,0,1000,0,4,0,1,0,'[{{0,1002040720,1},1},{{0,1004040720,1},1},{{0,1006040720,1},1},{{0,1008040720,1},1},{{0,1010040720,1},1},{{0,1001040720,1},1}]','[]','[]'),(32080796,0,1000,0,1,0,1,0,'[{{0,1007010720,1},1},{{0,1003000720,1},1},{{0,1005000720,1},1},{{0,1009000720,1},1}]','[]','[]'),(32080796,0,1000,0,2,0,1,0,'[{{0,1007020720,1},1},{{0,1003000720,1},1},{{0,1005000720,1},1},{{0,1009000720,1},1}]','[]','[]'),(32080796,0,1000,0,3,0,1,0,'[{{0,1007030720,1},1},{{0,1003000720,1},1},{{0,1005000720,1},1},{{0,1009000720,1},1}]','[]','[]'),(32080796,0,1000,0,4,0,1,0,'[{{0,1007040720,1},1},{{0,1003000720,1},1},{{0,1005000720,1},1},{{0,1009000720,1},1}]','[]','[]'),(32080797,0,1000,0,1,0,1,0,'[{{0,1007010720,1},1},{{0,1003000720,1},1}]','[]','[]'),(32080797,0,1000,0,2,0,1,0,'[{{0,1007020720,1},1},{{0,1003000720,1},1}]','[]','[]'),(32080797,0,1000,0,3,0,1,0,'[{{0,1007030720,1},1},{{0,1003000720,1},1}]','[]','[]'),(32080797,0,1000,0,4,0,1,0,'[{{0,1007040720,1},1},{{0,1003000720,1},1}]','[]','[]'),(32080798,0,1000,0,0,0,1,0,'[{{0,1005000720,1},1},{{0,1009000720,1},1}]','[]','[]'),(32080801,0,1000,0,1,0,1,0,'[{{0,1001010731,1},1},{{0,1002010731,1},1},{{0,1003000731,1},1},{{0,1004010731,1},1},{{0,1006010731,1},1},{{0,1007010731,1},1},{{0,1008010731,1},1},{{0,1010010731,1},1}]','[]','[]'),(32080801,0,1000,0,2,0,1,0,'[{{0,1001020731,1},1},{{0,1002020731,1},1},{{0,1003000731,1},1},{{0,1004020731,1},1},{{0,1006020731,1},1},{{0,1007020731,1},1},{{0,1008020731,1},1},{{0,1010020731,1},1}]','[]','[]'),(32080801,0,1000,0,3,0,1,0,'[{{0,1001030731,1},1},{{0,1002030731,1},1},{{0,1003000731,1},1},{{0,1004030731,1},1},{{0,1006030731,1},1},{{0,1007030731,1},1},{{0,1008030731,1},1},{{0,1010030731,1},1}]','[]','[]'),(32080801,0,1000,0,4,0,1,0,'[{{0,1001040731,1},1},{{0,1002040731,1},1},{{0,1003000731,1},1},{{0,1004040731,1},1},{{0,1006040731,1},1},{{0,1007040731,1},1},{{0,1008040731,1},1},{{0,1010040731,1},1}]','[]','[]'),(32080802,0,1000,0,1,0,1,0,'[{{0,1002010731,1},1},{{0,1004010731,1},1},{{0,1006010731,1},1},{{0,1008010731,1},1},{{0,1010010731,1},1}]','[]','[]'),(32080802,0,1000,0,2,0,1,0,'[{{0,1002020731,1},1},{{0,1004020731,1},1},{{0,1006020731,1},1},{{0,1008020731,1},1},{{0,1010020731,1},1}]','[]','[]'),(32080802,0,1000,0,3,0,1,0,'[{{0,1002030731,1},1},{{0,1004030731,1},1},{{0,1006030731,1},1},{{0,1008030731,1},1},{{0,1010030731,1},1}]','[]','[]'),(32080802,0,1000,0,4,0,1,0,'[{{0,1002040731,1},1},{{0,1004040731,1},1},{{0,1006040731,1},1},{{0,1008040731,1},1},{{0,1010040731,1},1}]','[]','[]'),(32080803,0,1000,0,1,0,1,0,'[{{0,1001010731,1},1},{{0,1007010731,1},1}]','[]','[]'),(32080803,0,1000,0,2,0,1,0,'[{{0,1001020731,1},1},{{0,1007020731,1},1}]','[]','[]'),(32080803,0,1000,0,3,0,1,0,'[{{0,1001030731,1},1},{{0,1007030731,1},1}]','[]','[]'),(32080803,0,1000,0,4,0,1,0,'[{{0,1001040731,1},1},{{0,1007040731,1},1}]','[]','[]'),(32080805,0,1000,0,1,0,1,0,'[{{0,1002010731,1},1},{{0,1004010731,1},1},{{0,1006010731,1},1},{{0,1008010731,1},1},{{0,1010010731,1},1},{{0,1001010731,1},1}]','[]','[]'),(32080805,0,1000,0,2,0,1,0,'[{{0,1002020731,1},1},{{0,1004020731,1},1},{{0,1006020731,1},1},{{0,1008020731,1},1},{{0,1010020731,1},1},{{0,1001020731,1},1}]','[]','[]'),(32080805,0,1000,0,3,0,1,0,'[{{0,1002030731,1},1},{{0,1004030731,1},1},{{0,1006030731,1},1},{{0,1008030731,1},1},{{0,1010030731,1},1},{{0,1001030731,1},1}]','[]','[]'),(32080805,0,1000,0,4,0,1,0,'[{{0,1002040731,1},1},{{0,1004040731,1},1},{{0,1006040731,1},1},{{0,1008040731,1},1},{{0,1010040731,1},1},{{0,1001040731,1},1}]','[]','[]'),(32080806,0,1000,0,1,0,1,0,'[{{0,1007010731,1},1},{{0,1003000731,1},1},{{0,1005000731,1},1},{{0,1009000731,1},1}]','[]','[]'),(32080806,0,1000,0,2,0,1,0,'[{{0,1007020731,1},1},{{0,1003000731,1},1},{{0,1005000731,1},1},{{0,1009000731,1},1}]','[]','[]'),(32080806,0,1000,0,3,0,1,0,'[{{0,1007030731,1},1},{{0,1003000731,1},1},{{0,1005000731,1},1},{{0,1009000731,1},1}]','[]','[]'),(32080806,0,1000,0,4,0,1,0,'[{{0,1007040731,1},1},{{0,1003000731,1},1},{{0,1005000731,1},1},{{0,1009000731,1},1}]','[]','[]'),(32080807,0,1000,0,1,0,1,0,'[{{0,1007010731,1},1},{{0,1003000731,1},1}]','[]','[]'),(32080807,0,1000,0,2,0,1,0,'[{{0,1007020731,1},1},{{0,1003000731,1},1}]','[]','[]'),(32080807,0,1000,0,3,0,1,0,'[{{0,1007030731,1},1},{{0,1003000731,1},1}]','[]','[]'),(32080807,0,1000,0,4,0,1,0,'[{{0,1007040731,1},1},{{0,1003000731,1},1}]','[]','[]'),(32080808,0,1000,0,0,0,1,0,'[{{0,1005000731,1},1},{{0,1009000731,1},1}]','[]','[]'),(32080811,0,1000,0,1,0,1,0,'[{{0,1001010832,1},1},{{0,1002010832,1},1},{{0,1003000832,1},1},{{0,1004010832,1},1},{{0,1006010832,1},1},{{0,1007010832,1},1},{{0,1008010832,1},1},{{0,1010010832,1},1}]','[]','[1001010832,1002010832,1003000832,1004010832,1005000832,1006010832,1007010832,1008010832,1009000832,1010010832]'),(32080811,0,1000,0,2,0,1,0,'[{{0,1001020832,1},1},{{0,1002020832,1},1},{{0,1003000832,1},1},{{0,1004020832,1},1},{{0,1006020832,1},1},{{0,1007020832,1},1},{{0,1008020832,1},1},{{0,1010020832,1},1}]','[]','[1001020832,1002020832,1003000832,1004020832,1005000832,1006020832,1007020832,1008020832,1009000832,1010020832]'),(32080811,0,1000,0,3,0,1,0,'[{{0,1001030832,1},1},{{0,1002030832,1},1},{{0,1003000832,1},1},{{0,1004030832,1},1},{{0,1006030832,1},1},{{0,1007030832,1},1},{{0,1008030832,1},1},{{0,1010030832,1},1}]','[]','[1001030832,1002030832,1003000832,1004030832,1005000832,1006030832,1007030832,1008030832,1009000832,1010030832]'),(32080811,0,1000,0,4,0,1,0,'[{{0,1001040832,1},1},{{0,1002040832,1},1},{{0,1003000832,1},1},{{0,1004040832,1},1},{{0,1006040832,1},1},{{0,1007040832,1},1},{{0,1008040832,1},1},{{0,1010040832,1},1}]','[]','[1001040832,1002040832,1003000832,1004040832,1005000832,1006040832,1007040832,1008040832,1009000832,1010040832]'),(32080812,0,1000,0,1,0,1,0,'[{{0,1002010832,1},1},{{0,1004010832,1},1},{{0,1006010832,1},1},{{0,1008010832,1},1},{{0,1010010832,1},1}]','[]','[1002010832,1004010832,1006010832,1008010832,1010010832]'),(32080812,0,1000,0,2,0,1,0,'[{{0,1002020832,1},1},{{0,1004020832,1},1},{{0,1006020832,1},1},{{0,1008020832,1},1},{{0,1010020832,1},1}]','[]','[1002020832,1004020832,1006020832,1008020832,1010020832]'),(32080812,0,1000,0,3,0,1,0,'[{{0,1002030832,1},1},{{0,1004030832,1},1},{{0,1006030832,1},1},{{0,1008030832,1},1},{{0,1010030832,1},1}]','[]','[1002030832,1004030832,1006030832,1008030832,1010030832]'),(32080812,0,1000,0,4,0,1,0,'[{{0,1002040832,1},1},{{0,1004040832,1},1},{{0,1006040832,1},1},{{0,1008040832,1},1},{{0,1010040832,1},1}]','[]','[1002040832,1004040832,1006040832,1008040832,1010040832]'),(32080813,0,1000,0,1,0,1,0,'[{{0,1001010832,1},1},{{0,1007010832,1},1}]','[]','[1001010832,1007010832]'),(32080813,0,1000,0,2,0,1,0,'[{{0,1001020832,1},1},{{0,1007020832,1},1}]','[]','[1001020832,1007020832]'),(32080813,0,1000,0,3,0,1,0,'[{{0,1001030832,1},1},{{0,1007030832,1},1}]','[]','[1001030832,1007030832]'),(32080813,0,1000,0,4,0,1,0,'[{{0,1001040832,1},1},{{0,1007040832,1},1}]','[]','[1001040832,1007040832]'),(32080815,0,1000,0,1,0,1,0,'[{{0,1002010832,1},1},{{0,1004010832,1},1},{{0,1006010832,1},1},{{0,1008010832,1},1},{{0,1010010832,1},1},{{0,1001010832,1},1}]','[]','[1002010832,1004010832,1006010832,1008010832,1010010832,1001010832]'),(32080815,0,1000,0,2,0,1,0,'[{{0,1002020832,1},1},{{0,1004020832,1},1},{{0,1006020832,1},1},{{0,1008020832,1},1},{{0,1010020832,1},1},{{0,1001020832,1},1}]','[]','[1002020832,1004020832,1006020832,1008020832,1010020832,1001020832]'),(32080815,0,1000,0,3,0,1,0,'[{{0,1002030832,1},1},{{0,1004030832,1},1},{{0,1006030832,1},1},{{0,1008030832,1},1},{{0,1010030832,1},1},{{0,1001030832,1},1}]','[]','[1002030832,1004030832,1006030832,1008030832,1010030832,1001030832]'),(32080815,0,1000,0,4,0,1,0,'[{{0,1002040832,1},1},{{0,1004040832,1},1},{{0,1006040832,1},1},{{0,1008040832,1},1},{{0,1010040832,1},1},{{0,1001040832,1},1}]','[]','[1002040832,1004040832,1006040832,1008040832,1010040832,1001040832]'),(32080816,0,1000,0,1,0,1,0,'[{{0,1007010832,1},1},{{0,1003000832,1},1},{{0,1005000832,1},1},{{0,1009000832,1},1}]','[]','[1007010832,1003000832,1005000832,1009000832]'),(32080816,0,1000,0,2,0,1,0,'[{{0,1007020832,1},1},{{0,1003000832,1},1},{{0,1005000832,1},1},{{0,1009000832,1},1}]','[]','[1007020832,1003000832,1005000832,1009000832]'),(32080816,0,1000,0,3,0,1,0,'[{{0,1007030832,1},1},{{0,1003000832,1},1},{{0,1005000832,1},1},{{0,1009000832,1},1}]','[]','[1007030832,1003000832,1005000832,1009000832]'),(32080816,0,1000,0,4,0,1,0,'[{{0,1007040832,1},1},{{0,1003000832,1},1},{{0,1005000832,1},1},{{0,1009000832,1},1}]','[]','[1007040832,1003000832,1005000832,1009000832]'),(32080817,0,1000,0,1,0,1,0,'[{{0,1007010832,1},1},{{0,1003000832,1},1}]','[]','[1007010832,1003000832]'),(32080817,0,1000,0,2,0,1,0,'[{{0,1007020832,1},1},{{0,1003000832,1},1}]','[]','[1007020832,1003000832]'),(32080817,0,1000,0,3,0,1,0,'[{{0,1007030832,1},1},{{0,1003000832,1},1}]','[]','[1007030832,1003000832]'),(32080817,0,1000,0,4,0,1,0,'[{{0,1007040832,1},1},{{0,1003000832,1},1}]','[]','[1007040832,1003000832]'),(32080818,0,1000,0,0,0,1,0,'[{{0,1005000832,1},1},{{0,1009000832,1},1}]','[]','[1005000832,1009000832]'),(32080821,0,1000,0,1,0,1,0,'[{{0,1001010841,1},1},{{0,1002010841,1},1},{{0,1003000841,1},1},{{0,1004010841,1},1},{{0,1006010841,1},1},{{0,1007010841,1},1},{{0,1008010841,1},1},{{0,1010010841,1},1}]','[]','[]'),(32080821,0,1000,0,2,0,1,0,'[{{0,1001020841,1},1},{{0,1002020841,1},1},{{0,1003000841,1},1},{{0,1004020841,1},1},{{0,1006020841,1},1},{{0,1007020841,1},1},{{0,1008020841,1},1},{{0,1010020841,1},1}]','[]','[]'),(32080821,0,1000,0,3,0,1,0,'[{{0,1001030841,1},1},{{0,1002030841,1},1},{{0,1003000841,1},1},{{0,1004030841,1},1},{{0,1006030841,1},1},{{0,1007030841,1},1},{{0,1008030841,1},1},{{0,1010030841,1},1}]','[]','[]'),(32080821,0,1000,0,4,0,1,0,'[{{0,1001040841,1},1},{{0,1002040841,1},1},{{0,1003000841,1},1},{{0,1004040841,1},1},{{0,1006040841,1},1},{{0,1007040841,1},1},{{0,1008040841,1},1},{{0,1010040841,1},1}]','[]','[]'),(32080822,0,1000,0,1,0,1,0,'[{{0,1002010841,1},1},{{0,1004010841,1},1},{{0,1006010841,1},1},{{0,1008010841,1},1},{{0,1010010841,1},1}]','[]','[]'),(32080822,0,1000,0,2,0,1,0,'[{{0,1002020841,1},1},{{0,1004020841,1},1},{{0,1006020841,1},1},{{0,1008020841,1},1},{{0,1010020841,1},1}]','[]','[]'),(32080822,0,1000,0,3,0,1,0,'[{{0,1002030841,1},1},{{0,1004030841,1},1},{{0,1006030841,1},1},{{0,1008030841,1},1},{{0,1010030841,1},1}]','[]','[]'),(32080822,0,1000,0,4,0,1,0,'[{{0,1002040841,1},1},{{0,1004040841,1},1},{{0,1006040841,1},1},{{0,1008040841,1},1},{{0,1010040841,1},1}]','[]','[]'),(32080823,0,1000,0,1,0,1,0,'[{{0,1001010841,1},1},{{0,1007010841,1},1}]','[]','[]'),(32080823,0,1000,0,2,0,1,0,'[{{0,1001020841,1},1},{{0,1007020841,1},1}]','[]','[]'),(32080823,0,1000,0,3,0,1,0,'[{{0,1001030841,1},1},{{0,1007030841,1},1}]','[]','[]'),(32080823,0,1000,0,4,0,1,0,'[{{0,1001040841,1},1},{{0,1007040841,1},1}]','[]','[]'),(32080825,0,1000,0,1,0,1,0,'[{{0,1002010841,1},1},{{0,1004010841,1},1},{{0,1006010841,1},1},{{0,1008010841,1},1},{{0,1010010841,1},1},{{0,1001010841,1},1}]','[]','[]'),(32080825,0,1000,0,2,0,1,0,'[{{0,1002020841,1},1},{{0,1004020841,1},1},{{0,1006020841,1},1},{{0,1008020841,1},1},{{0,1010020841,1},1},{{0,1001020841,1},1}]','[]','[]'),(32080825,0,1000,0,3,0,1,0,'[{{0,1002030841,1},1},{{0,1004030841,1},1},{{0,1006030841,1},1},{{0,1008030841,1},1},{{0,1010030841,1},1},{{0,1001030841,1},1}]','[]','[]'),(32080825,0,1000,0,4,0,1,0,'[{{0,1002040841,1},1},{{0,1004040841,1},1},{{0,1006040841,1},1},{{0,1008040841,1},1},{{0,1010040841,1},1},{{0,1001040841,1},1}]','[]','[]'),(32080826,0,1000,0,1,0,1,0,'[{{0,1007010841,1},1},{{0,1003000841,1},1},{{0,1005000841,1},1},{{0,1009000841,1},1}]','[]','[]'),(32080826,0,1000,0,2,0,1,0,'[{{0,1007020841,1},1},{{0,1003000841,1},1},{{0,1005000841,1},1},{{0,1009000841,1},1}]','[]','[]'),(32080826,0,1000,0,3,0,1,0,'[{{0,1007030841,1},1},{{0,1003000841,1},1},{{0,1005000841,1},1},{{0,1009000841,1},1}]','[]','[]'),(32080826,0,1000,0,4,0,1,0,'[{{0,1007040841,1},1},{{0,1003000841,1},1},{{0,1005000841,1},1},{{0,1009000841,1},1}]','[]','[]'),(32080827,0,1000,0,1,0,1,0,'[{{0,1007010841,1},1},{{0,1003000841,1},1}]','[]','[]'),(32080827,0,1000,0,2,0,1,0,'[{{0,1007020841,1},1},{{0,1003000841,1},1}]','[]','[]'),(32080827,0,1000,0,3,0,1,0,'[{{0,1007030841,1},1},{{0,1003000841,1},1}]','[]','[]'),(32080827,0,1000,0,4,0,1,0,'[{{0,1007040841,1},1},{{0,1003000841,1},1}]','[]','[]'),(32080828,0,1000,0,0,0,1,0,'[{{0,1005000841,1},1},{{0,1009000841,1},1}]','[]','[]'),(32080831,0,1000,0,1,0,1,0,'[{{0,1001010842,1},1},{{0,1002010842,1},1},{{0,1003000842,1},1},{{0,1004010842,1},1},{{0,1006010842,1},1},{{0,1007010842,1},1},{{0,1008010842,1},1},{{0,1010010842,1},1}]','[]','[1001010842,1002010842,1003000842,1004010842,1005000842,1006010842,1007010842,1008010842,1009000842,1010010842]'),(32080831,0,1000,0,2,0,1,0,'[{{0,1001020842,1},1},{{0,1002020842,1},1},{{0,1003000842,1},1},{{0,1004020842,1},1},{{0,1006020842,1},1},{{0,1007020842,1},1},{{0,1008020842,1},1},{{0,1010020842,1},1}]','[]','[1001020842,1002020842,1003000842,1004020842,1005000842,1006020842,1007020842,1008020842,1009000842,1010020842]'),(32080831,0,1000,0,3,0,1,0,'[{{0,1001030842,1},1},{{0,1002030842,1},1},{{0,1003000842,1},1},{{0,1004030842,1},1},{{0,1006030842,1},1},{{0,1007030842,1},1},{{0,1008030842,1},1},{{0,1010030842,1},1}]','[]','[1001030842,1002030842,1003000842,1004030842,1005000842,1006030842,1007030842,1008030842,1009000842,1010030842]'),(32080831,0,1000,0,4,0,1,0,'[{{0,1001040842,1},1},{{0,1002040842,1},1},{{0,1003000842,1},1},{{0,1004040842,1},1},{{0,1006040842,1},1},{{0,1007040842,1},1},{{0,1008040842,1},1},{{0,1010040842,1},1}]','[]','[1001040842,1002040842,1003000842,1004040842,1005000842,1006040842,1007040842,1008040842,1009000842,1010040842]'),(32080832,0,1000,0,1,0,1,0,'[{{0,1002010842,1},1},{{0,1004010842,1},1},{{0,1006010842,1},1},{{0,1008010842,1},1},{{0,1010010842,1},1}]','[]','[1002010842,1004010842,1006010842,1008010842,1010010842]'),(32080832,0,1000,0,2,0,1,0,'[{{0,1002020842,1},1},{{0,1004020842,1},1},{{0,1006020842,1},1},{{0,1008020842,1},1},{{0,1010020842,1},1}]','[]','[1002020842,1004020842,1006020842,1008020842,1010020842]'),(32080832,0,1000,0,3,0,1,0,'[{{0,1002030842,1},1},{{0,1004030842,1},1},{{0,1006030842,1},1},{{0,1008030842,1},1},{{0,1010030842,1},1}]','[]','[1002030842,1004030842,1006030842,1008030842,1010030842]'),(32080832,0,1000,0,4,0,1,0,'[{{0,1002040842,1},1},{{0,1004040842,1},1},{{0,1006040842,1},1},{{0,1008040842,1},1},{{0,1010040842,1},1}]','[]','[1002040842,1004040842,1006040842,1008040842,1010040842]'),(32080833,0,1000,0,1,0,1,0,'[{{0,1001010842,1},1},{{0,1007010842,1},1}]','[]','[1001010842,1007010842]'),(32080833,0,1000,0,2,0,1,0,'[{{0,1001020842,1},1},{{0,1007020842,1},1}]','[]','[1001020842,1007020842]'),(32080833,0,1000,0,3,0,1,0,'[{{0,1001030842,1},1},{{0,1007030842,1},1}]','[]','[1001030842,1007030842]'),(32080833,0,1000,0,4,0,1,0,'[{{0,1001040842,1},1},{{0,1007040842,1},1}]','[]','[1001040842,1007040842]'),(32080835,0,1000,0,1,0,1,0,'[{{0,1002010842,1},1},{{0,1004010842,1},1},{{0,1006010842,1},1},{{0,1008010842,1},1},{{0,1010010842,1},1},{{0,1001010842,1},1}]','[]','[1002010842,1004010842,1006010842,1008010842,1010010842,1001010842]'),(32080835,0,1000,0,2,0,1,0,'[{{0,1002020842,1},1},{{0,1004020842,1},1},{{0,1006020842,1},1},{{0,1008020842,1},1},{{0,1010020842,1},1},{{0,1001020842,1},1}]','[]','[1002020842,1004020842,1006020842,1008020842,1010020842,1001020842]'),(32080835,0,1000,0,3,0,1,0,'[{{0,1002030842,1},1},{{0,1004030842,1},1},{{0,1006030842,1},1},{{0,1008030842,1},1},{{0,1010030842,1},1},{{0,1001030842,1},1}]','[]','[1002030842,1004030842,1006030842,1008030842,1010030842,1001030842]'),(32080835,0,1000,0,4,0,1,0,'[{{0,1002040842,1},1},{{0,1004040842,1},1},{{0,1006040842,1},1},{{0,1008040842,1},1},{{0,1010040842,1},1},{{0,1001040842,1},1}]','[]','[1002040842,1004040842,1006040842,1008040842,1010040842,1001040842]'),(32080836,0,1000,0,1,0,1,0,'[{{0,1007010842,1},1},{{0,1003000842,1},1},{{0,1005000842,1},1},{{0,1009000842,1},1}]','[]','[1007010842,1003000842,1005000842,1009000842]'),(32080836,0,1000,0,2,0,1,0,'[{{0,1007020842,1},1},{{0,1003000842,1},1},{{0,1005000842,1},1},{{0,1009000842,1},1}]','[]','[1007020842,1003000842,1005000842,1009000842]'),(32080836,0,1000,0,3,0,1,0,'[{{0,1007030842,1},1},{{0,1003000842,1},1},{{0,1005000842,1},1},{{0,1009000842,1},1}]','[]','[1007030842,1003000842,1005000842,1009000842]'),(32080836,0,1000,0,4,0,1,0,'[{{0,1007040842,1},1},{{0,1003000842,1},1},{{0,1005000842,1},1},{{0,1009000842,1},1}]','[]','[1007040842,1003000842,1005000842,1009000842]'),(32080837,0,1000,0,1,0,1,0,'[{{0,1007010842,1},1},{{0,1003000842,1},1}]','[]','[1007010842,1003000842]'),(32080837,0,1000,0,2,0,1,0,'[{{0,1007020842,1},1},{{0,1003000842,1},1}]','[]','[1007020842,1003000842]'),(32080837,0,1000,0,3,0,1,0,'[{{0,1007030842,1},1},{{0,1003000842,1},1}]','[]','[1007030842,1003000842]'),(32080837,0,1000,0,4,0,1,0,'[{{0,1007040842,1},1},{{0,1003000842,1},1}]','[]','[1007040842,1003000842]'),(32080838,0,1000,0,0,0,1,0,'[{{0,1005000842,1},1},{{0,1009000842,1},1}]','[]','[1005000842,1009000842]'),(32080841,0,1000,0,1,0,1,0,'[{{0,1001010843,1},1},{{0,1002010843,1},1},{{0,1003000843,1},1},{{0,1004010843,1},1},{{0,1006010843,1},1},{{0,1007010843,1},1},{{0,1008010843,1},1},{{0,1010010843,1},1}]','[]','[1001010843,1002010843,1003000843,1004010843,1005000843,1006010843,1007010843,1008010843,1009000843,1010010843]'),(32080841,0,1000,0,2,0,1,0,'[{{0,1001020843,1},1},{{0,1002020843,1},1},{{0,1003000843,1},1},{{0,1004020843,1},1},{{0,1006020843,1},1},{{0,1007020843,1},1},{{0,1008020843,1},1},{{0,1010020843,1},1}]','[]','[1001020843,1002020843,1003000843,1004020843,1005000843,1006020843,1007020843,1008020843,1009000843,1010020843]'),(32080841,0,1000,0,3,0,1,0,'[{{0,1001030843,1},1},{{0,1002030843,1},1},{{0,1003000843,1},1},{{0,1004030843,1},1},{{0,1006030843,1},1},{{0,1007030843,1},1},{{0,1008030843,1},1},{{0,1010030843,1},1}]','[]','[1001030843,1002030843,1003000843,1004030843,1005000843,1006030843,1007030843,1008030843,1009000843,1010030843]'),(32080841,0,1000,0,4,0,1,0,'[{{0,1001040843,1},1},{{0,1002040843,1},1},{{0,1003000843,1},1},{{0,1004040843,1},1},{{0,1006040843,1},1},{{0,1007040843,1},1},{{0,1008040843,1},1},{{0,1010040843,1},1}]','[]','[1001040843,1002040843,1003000843,1004040843,1005000843,1006040843,1007040843,1008040843,1009000843,1010040843]'),(32080842,0,1000,0,1,0,1,0,'[{{0,1002010843,1},1},{{0,1004010843,1},1},{{0,1006010843,1},1},{{0,1008010843,1},1},{{0,1010010843,1},1}]','[]','[1002010843,1004010843,1006010843,1008010843,1010010843]'),(32080842,0,1000,0,2,0,1,0,'[{{0,1002020843,1},1},{{0,1004020843,1},1},{{0,1006020843,1},1},{{0,1008020843,1},1},{{0,1010020843,1},1}]','[]','[1002020843,1004020843,1006020843,1008020843,1010020843]'),(32080842,0,1000,0,3,0,1,0,'[{{0,1002030843,1},1},{{0,1004030843,1},1},{{0,1006030843,1},1},{{0,1008030843,1},1},{{0,1010030843,1},1}]','[]','[1002030843,1004030843,1006030843,1008030843,1010030843]'),(32080842,0,1000,0,4,0,1,0,'[{{0,1002040843,1},1},{{0,1004040843,1},1},{{0,1006040843,1},1},{{0,1008040843,1},1},{{0,1010040843,1},1}]','[]','[1002040843,1004040843,1006040843,1008040843,1010040843]'),(32080843,0,1000,0,1,0,1,0,'[{{0,1001010843,1},1},{{0,1007010843,1},1}]','[]','[1001010843,1007010843]'),(32080843,0,1000,0,2,0,1,0,'[{{0,1001020843,1},1},{{0,1007020843,1},1}]','[]','[1001020843,1007020843]'),(32080843,0,1000,0,3,0,1,0,'[{{0,1001030843,1},1},{{0,1007030843,1},1}]','[]','[1001030843,1007030843]'),(32080843,0,1000,0,4,0,1,0,'[{{0,1001040843,1},1},{{0,1007040843,1},1}]','[]','[1001040843,1007040843]'),(32080845,0,1000,0,1,0,1,0,'[{{0,1002010843,1},1},{{0,1004010843,1},1},{{0,1006010843,1},1},{{0,1008010843,1},1},{{0,1010010843,1},1},{{0,1001010843,1},1}]','[]','[1002010843,1004010843,1006010843,1008010843,1010010843,1001010843]'),(32080845,0,1000,0,2,0,1,0,'[{{0,1002020843,1},1},{{0,1004020843,1},1},{{0,1006020843,1},1},{{0,1008020843,1},1},{{0,1010020843,1},1},{{0,1001020843,1},1}]','[]','[1002020843,1004020843,1006020843,1008020843,1010020843,1001020843]'),(32080845,0,1000,0,3,0,1,0,'[{{0,1002030843,1},1},{{0,1004030843,1},1},{{0,1006030843,1},1},{{0,1008030843,1},1},{{0,1010030843,1},1},{{0,1001030843,1},1}]','[]','[1002030843,1004030843,1006030843,1008030843,1010030843,1001030843]'),(32080845,0,1000,0,4,0,1,0,'[{{0,1002040843,1},1},{{0,1004040843,1},1},{{0,1006040843,1},1},{{0,1008040843,1},1},{{0,1010040843,1},1},{{0,1001040843,1},1}]','[]','[1002040843,1004040843,1006040843,1008040843,1010040843,1001040843]'),(32080846,0,1000,0,1,0,1,0,'[{{0,1007010843,1},1},{{0,1003000843,1},1},{{0,1005000843,1},1},{{0,1009000843,1},1}]','[]','[1007010843,1003000843,1005000843,1009000843]'),(32080846,0,1000,0,2,0,1,0,'[{{0,1007020843,1},1},{{0,1003000843,1},1},{{0,1005000843,1},1},{{0,1009000843,1},1}]','[]','[1007020843,1003000843,1005000843,1009000843]'),(32080846,0,1000,0,3,0,1,0,'[{{0,1007030843,1},1},{{0,1003000843,1},1},{{0,1005000843,1},1},{{0,1009000843,1},1}]','[]','[1007030843,1003000843,1005000843,1009000843]'),(32080846,0,1000,0,4,0,1,0,'[{{0,1007040843,1},1},{{0,1003000843,1},1},{{0,1005000843,1},1},{{0,1009000843,1},1}]','[]','[1007040843,1003000843,1005000843,1009000843]'),(32080847,0,1000,0,1,0,1,0,'[{{0,1007010843,1},1},{{0,1003000843,1},1}]','[]','[1007010843,1003000843]'),(32080847,0,1000,0,2,0,1,0,'[{{0,1007020843,1},1},{{0,1003000843,1},1}]','[]','[1007020843,1003000843]'),(32080847,0,1000,0,3,0,1,0,'[{{0,1007030843,1},1},{{0,1003000843,1},1}]','[]','[1007030843,1003000843]'),(32080847,0,1000,0,4,0,1,0,'[{{0,1007040843,1},1},{{0,1003000843,1},1}]','[]','[1007040843,1003000843]'),(32080848,0,1000,0,0,0,1,0,'[{{0,1005000843,1},1},{{0,1009000843,1},1}]','[]','[1005000843,1009000843]'),(32080851,0,1000,0,1,0,1,0,'[{{0,1001010853,1},1},{{0,1002010853,1},1},{{0,1003000853,1},1},{{0,1004010853,1},1},{{0,1006010853,1},1},{{0,1007010853,1},1},{{0,1008010853,1},1},{{0,1010010853,1},1}]','[]','[1001010853,1002010853,1003000853,1004010853,1005000853,1006010853,1007010853,1008010853,1009000853,1010010853]'),(32080851,0,1000,0,2,0,1,0,'[{{0,1001020853,1},1},{{0,1002020853,1},1},{{0,1003000853,1},1},{{0,1004020853,1},1},{{0,1006020853,1},1},{{0,1007020853,1},1},{{0,1008020853,1},1},{{0,1010020853,1},1}]','[]','[1001020853,1002020853,1003000853,1004020853,1005000853,1006020853,1007020853,1008020853,1009000853,1010020853]'),(32080851,0,1000,0,3,0,1,0,'[{{0,1001030853,1},1},{{0,1002030853,1},1},{{0,1003000853,1},1},{{0,1004030853,1},1},{{0,1006030853,1},1},{{0,1007030853,1},1},{{0,1008030853,1},1},{{0,1010030853,1},1}]','[]','[1001030853,1002030853,1003000853,1004030853,1005000853,1006030853,1007030853,1008030853,1009000853,1010030853]'),(32080851,0,1000,0,4,0,1,0,'[{{0,1001040853,1},1},{{0,1002040853,1},1},{{0,1003000853,1},1},{{0,1004040853,1},1},{{0,1006040853,1},1},{{0,1007040853,1},1},{{0,1008040853,1},1},{{0,1010040853,1},1}]','[]','[1001040853,1002040853,1003000853,1004040853,1005000853,1006040853,1007040853,1008040853,1009000853,1010040853]'),(32080852,0,1000,0,1,0,1,0,'[{{0,1002010853,1},1},{{0,1004010853,1},1},{{0,1006010853,1},1},{{0,1008010853,1},1},{{0,1010010853,1},1}]','[]','[1002010853,1004010853,1006010853,1008010853,1010010853]'),(32080852,0,1000,0,2,0,1,0,'[{{0,1002020853,1},1},{{0,1004020853,1},1},{{0,1006020853,1},1},{{0,1008020853,1},1},{{0,1010020853,1},1}]','[]','[1002020853,1004020853,1006020853,1008020853,1010020853]'),(32080852,0,1000,0,3,0,1,0,'[{{0,1002030853,1},1},{{0,1004030853,1},1},{{0,1006030853,1},1},{{0,1008030853,1},1},{{0,1010030853,1},1}]','[]','[1002030853,1004030853,1006030853,1008030853,1010030853]'),(32080852,0,1000,0,4,0,1,0,'[{{0,1002040853,1},1},{{0,1004040853,1},1},{{0,1006040853,1},1},{{0,1008040853,1},1},{{0,1010040853,1},1}]','[]','[1002040853,1004040853,1006040853,1008040853,1010040853]'),(32080853,0,1000,0,1,0,1,0,'[{{0,1001010853,1},1},{{0,1007010853,1},1}]','[]','[1001010853,1007010853]'),(32080853,0,1000,0,2,0,1,0,'[{{0,1001020853,1},1},{{0,1007020853,1},1}]','[]','[1001020853,1007020853]'),(32080853,0,1000,0,3,0,1,0,'[{{0,1001030853,1},1},{{0,1007030853,1},1}]','[]','[1001030853,1007030853]'),(32080853,0,1000,0,4,0,1,0,'[{{0,1001040853,1},1},{{0,1007040853,1},1}]','[]','[1001040853,1007040853]'),(32080855,0,1000,0,1,0,1,0,'[{{0,1002010853,1},1},{{0,1004010853,1},1},{{0,1006010853,1},1},{{0,1008010853,1},1},{{0,1010010853,1},1},{{0,1001010853,1},1}]','[]','[1002010853,1004010853,1006010853,1008010853,1010010853,1001010853]'),(32080855,0,1000,0,2,0,1,0,'[{{0,1002020853,1},1},{{0,1004020853,1},1},{{0,1006020853,1},1},{{0,1008020853,1},1},{{0,1010020853,1},1},{{0,1001020853,1},1}]','[]','[1002020853,1004020853,1006020853,1008020853,1010020853,1001020853]'),(32080855,0,1000,0,3,0,1,0,'[{{0,1002030853,1},1},{{0,1004030853,1},1},{{0,1006030853,1},1},{{0,1008030853,1},1},{{0,1010030853,1},1},{{0,1001030853,1},1}]','[]','[1002030853,1004030853,1006030853,1008030853,1010030853,1001030853]'),(32080855,0,1000,0,4,0,1,0,'[{{0,1002040853,1},1},{{0,1004040853,1},1},{{0,1006040853,1},1},{{0,1008040853,1},1},{{0,1010040853,1},1},{{0,1001040853,1},1}]','[]','[1002040853,1004040853,1006040853,1008040853,1010040853,1001040853]'),(32080856,0,1000,0,1,0,1,0,'[{{0,1007010853,1},1},{{0,1003000853,1},1},{{0,1005000853,1},1},{{0,1009000853,1},1}]','[]','[1007010853,1003000853,1005000853,1009000853]'),(32080856,0,1000,0,2,0,1,0,'[{{0,1007020853,1},1},{{0,1003000853,1},1},{{0,1005000853,1},1},{{0,1009000853,1},1}]','[]','[1007020853,1003000853,1005000853,1009000853]'),(32080856,0,1000,0,3,0,1,0,'[{{0,1007030853,1},1},{{0,1003000853,1},1},{{0,1005000853,1},1},{{0,1009000853,1},1}]','[]','[1007030853,1003000853,1005000853,1009000853]'),(32080856,0,1000,0,4,0,1,0,'[{{0,1007040853,1},1},{{0,1003000853,1},1},{{0,1005000853,1},1},{{0,1009000853,1},1}]','[]','[1007040853,1003000853,1005000853,1009000853]'),(32080857,0,1000,0,1,0,1,0,'[{{0,1007010853,1},1},{{0,1003000853,1},1}]','[]','[1007010853,1003000853]'),(32080857,0,1000,0,2,0,1,0,'[{{0,1007020853,1},1},{{0,1003000853,1},1}]','[]','[1007020853,1003000853]'),(32080857,0,1000,0,3,0,1,0,'[{{0,1007030853,1},1},{{0,1003000853,1},1}]','[]','[1007030853,1003000853]'),(32080857,0,1000,0,4,0,1,0,'[{{0,1007040853,1},1},{{0,1003000853,1},1}]','[]','[1007040853,1003000853]'),(32080858,0,1000,0,0,0,1,0,'[{{0,1005000853,1},1},{{0,1009000853,1},1}]','[]','[1005000853,1009000853]'),(32080861,0,1000,0,1,0,1,0,'[{{0,1001010863,1},1},{{0,1002010863,1},1},{{0,1003000863,1},1},{{0,1004010863,1},1},{{0,1006010863,1},1},{{0,1007010863,1},1},{{0,1008010863,1},1},{{0,1010010863,1},1}]','[]','[1001010863,1002010863,1003000863,1004010863,1005000863,1006010863,1007010863,1008010863,1009000863,1010010863]'),(32080861,0,1000,0,2,0,1,0,'[{{0,1001020863,1},1},{{0,1002020863,1},1},{{0,1003000863,1},1},{{0,1004020863,1},1},{{0,1006020863,1},1},{{0,1007020863,1},1},{{0,1008020863,1},1},{{0,1010020863,1},1}]','[]','[1001020863,1002020863,1003000863,1004020863,1005000863,1006020863,1007020863,1008020863,1009000863,1010020863]'),(32080861,0,1000,0,3,0,1,0,'[{{0,1001030863,1},1},{{0,1002030863,1},1},{{0,1003000863,1},1},{{0,1004030863,1},1},{{0,1006030863,1},1},{{0,1007030863,1},1},{{0,1008030863,1},1},{{0,1010030863,1},1}]','[]','[1001030863,1002030863,1003000863,1004030863,1005000863,1006030863,1007030863,1008030863,1009000863,1010030863]'),(32080861,0,1000,0,4,0,1,0,'[{{0,1001040863,1},1},{{0,1002040863,1},1},{{0,1003000863,1},1},{{0,1004040863,1},1},{{0,1006040863,1},1},{{0,1007040863,1},1},{{0,1008040863,1},1},{{0,1010040863,1},1}]','[]','[1001040863,1002040863,1003000863,1004040863,1005000863,1006040863,1007040863,1008040863,1009000863,1010040863]'),(32080862,0,1000,0,1,0,1,0,'[{{0,1002010863,1},1},{{0,1004010863,1},1},{{0,1006010863,1},1},{{0,1008010863,1},1},{{0,1010010863,1},1}]','[]','[1002010863,1004010863,1006010863,1008010863,1010010863]'),(32080862,0,1000,0,2,0,1,0,'[{{0,1002020863,1},1},{{0,1004020863,1},1},{{0,1006020863,1},1},{{0,1008020863,1},1},{{0,1010020863,1},1}]','[]','[1002020863,1004020863,1006020863,1008020863,1010020863]'),(32080862,0,1000,0,3,0,1,0,'[{{0,1002030863,1},1},{{0,1004030863,1},1},{{0,1006030863,1},1},{{0,1008030863,1},1},{{0,1010030863,1},1}]','[]','[1002030863,1004030863,1006030863,1008030863,1010030863]'),(32080862,0,1000,0,4,0,1,0,'[{{0,1002040863,1},1},{{0,1004040863,1},1},{{0,1006040863,1},1},{{0,1008040863,1},1},{{0,1010040863,1},1}]','[]','[1002040863,1004040863,1006040863,1008040863,1010040863]'),(32080863,0,1000,0,1,0,1,0,'[{{0,1001010863,1},1},{{0,1007010863,1},1}]','[]','[1001010863,1007010863]'),(32080863,0,1000,0,2,0,1,0,'[{{0,1001020863,1},1},{{0,1007020863,1},1}]','[]','[1001020863,1007020863]'),(32080863,0,1000,0,3,0,1,0,'[{{0,1001030863,1},1},{{0,1007030863,1},1}]','[]','[1001030863,1007030863]'),(32080863,0,1000,0,4,0,1,0,'[{{0,1001040863,1},1},{{0,1007040863,1},1}]','[]','[1001040863,1007040863]'),(32080865,0,1000,0,1,0,1,0,'[{{0,1002010863,1},1},{{0,1004010863,1},1},{{0,1006010863,1},1},{{0,1008010863,1},1},{{0,1010010863,1},1},{{0,1001010863,1},1}]','[]','[1002010863,1004010863,1006010863,1008010863,1010010863,1001010863]'),(32080865,0,1000,0,2,0,1,0,'[{{0,1002020863,1},1},{{0,1004020863,1},1},{{0,1006020863,1},1},{{0,1008020863,1},1},{{0,1010020863,1},1},{{0,1001020863,1},1}]','[]','[1002020863,1004020863,1006020863,1008020863,1010020863,1001020863]'),(32080865,0,1000,0,3,0,1,0,'[{{0,1002030863,1},1},{{0,1004030863,1},1},{{0,1006030863,1},1},{{0,1008030863,1},1},{{0,1010030863,1},1},{{0,1001030863,1},1}]','[]','[1002030863,1004030863,1006030863,1008030863,1010030863,1001030863]'),(32080865,0,1000,0,4,0,1,0,'[{{0,1002040863,1},1},{{0,1004040863,1},1},{{0,1006040863,1},1},{{0,1008040863,1},1},{{0,1010040863,1},1},{{0,1001040863,1},1}]','[]','[1002040863,1004040863,1006040863,1008040863,1010040863,1001040863]'),(32080866,0,1000,0,1,0,1,0,'[{{0,1007010863,1},1},{{0,1003000863,1},1},{{0,1005000863,1},1},{{0,1009000863,1},1}]','[]','[1007010863,1003000863,1005000863,1009000863]'),(32080866,0,1000,0,2,0,1,0,'[{{0,1007020863,1},1},{{0,1003000863,1},1},{{0,1005000863,1},1},{{0,1009000863,1},1}]','[]','[1007020863,1003000863,1005000863,1009000863]'),(32080866,0,1000,0,3,0,1,0,'[{{0,1007030863,1},1},{{0,1003000863,1},1},{{0,1005000863,1},1},{{0,1009000863,1},1}]','[]','[1007030863,1003000863,1005000863,1009000863]'),(32080866,0,1000,0,4,0,1,0,'[{{0,1007040863,1},1},{{0,1003000863,1},1},{{0,1005000863,1},1},{{0,1009000863,1},1}]','[]','[1007040863,1003000863,1005000863,1009000863]'),(32080867,0,1000,0,1,0,1,0,'[{{0,1007010863,1},1},{{0,1003000863,1},1}]','[]','[1007010863,1003000863]'),(32080867,0,1000,0,2,0,1,0,'[{{0,1007020863,1},1},{{0,1003000863,1},1}]','[]','[1007020863,1003000863]'),(32080867,0,1000,0,3,0,1,0,'[{{0,1007030863,1},1},{{0,1003000863,1},1}]','[]','[1007030863,1003000863]'),(32080867,0,1000,0,4,0,1,0,'[{{0,1007040863,1},1},{{0,1003000863,1},1}]','[]','[1007040863,1003000863]'),(32080868,0,1000,0,0,0,1,0,'[{{0,1005000863,1},1},{{0,1009000863,1},1}]','[]','[1005000863,1009000863]'),(32080871,0,1000,0,1,0,1,0,'[{{0,1001010800,1},1},{{0,1002010800,1},1},{{0,1003000800,1},1},{{0,1004010800,1},1},{{0,1006010800,1},1},{{0,1007010800,1},1},{{0,1008010800,1},1},{{0,1010010800,1},1}]','[]','[]'),(32080871,0,1000,0,2,0,1,0,'[{{0,1001020800,1},1},{{0,1002020800,1},1},{{0,1003000800,1},1},{{0,1004020800,1},1},{{0,1006020800,1},1},{{0,1007020800,1},1},{{0,1008020800,1},1},{{0,1010020800,1},1}]','[]','[]'),(32080871,0,1000,0,3,0,1,0,'[{{0,1001030800,1},1},{{0,1002030800,1},1},{{0,1003000800,1},1},{{0,1004030800,1},1},{{0,1006030800,1},1},{{0,1007030800,1},1},{{0,1008030800,1},1},{{0,1010030800,1},1}]','[]','[]'),(32080871,0,1000,0,4,0,1,0,'[{{0,1001040800,1},1},{{0,1002040800,1},1},{{0,1003000800,1},1},{{0,1004040800,1},1},{{0,1006040800,1},1},{{0,1007040800,1},1},{{0,1008040800,1},1},{{0,1010040800,1},1}]','[]','[]'),(32080872,0,1000,0,1,0,1,0,'[{{0,1002010800,1},1},{{0,1004010800,1},1},{{0,1006010800,1},1},{{0,1008010800,1},1},{{0,1010010800,1},1}]','[]','[]'),(32080872,0,1000,0,2,0,1,0,'[{{0,1002020800,1},1},{{0,1004020800,1},1},{{0,1006020800,1},1},{{0,1008020800,1},1},{{0,1010020800,1},1}]','[]','[]'),(32080872,0,1000,0,3,0,1,0,'[{{0,1002030800,1},1},{{0,1004030800,1},1},{{0,1006030800,1},1},{{0,1008030800,1},1},{{0,1010030800,1},1}]','[]','[]'),(32080872,0,1000,0,4,0,1,0,'[{{0,1002040800,1},1},{{0,1004040800,1},1},{{0,1006040800,1},1},{{0,1008040800,1},1},{{0,1010040800,1},1}]','[]','[]'),(32080873,0,1000,0,1,0,1,0,'[{{0,1001010800,1},1},{{0,1007010800,1},1}]','[]','[]'),(32080873,0,1000,0,2,0,1,0,'[{{0,1001020800,1},1},{{0,1007020800,1},1}]','[]','[]'),(32080873,0,1000,0,3,0,1,0,'[{{0,1001030800,1},1},{{0,1007030800,1},1}]','[]','[]'),(32080873,0,1000,0,4,0,1,0,'[{{0,1001040800,1},1},{{0,1007040800,1},1}]','[]','[]'),(32080875,0,1000,0,1,0,1,0,'[{{0,1002010800,1},1},{{0,1004010800,1},1},{{0,1006010800,1},1},{{0,1008010800,1},1},{{0,1010010800,1},1},{{0,1001010800,1},1}]','[]','[]'),(32080875,0,1000,0,2,0,1,0,'[{{0,1002020800,1},1},{{0,1004020800,1},1},{{0,1006020800,1},1},{{0,1008020800,1},1},{{0,1010020800,1},1},{{0,1001020800,1},1}]','[]','[]'),(32080875,0,1000,0,3,0,1,0,'[{{0,1002030800,1},1},{{0,1004030800,1},1},{{0,1006030800,1},1},{{0,1008030800,1},1},{{0,1010030800,1},1},{{0,1001030800,1},1}]','[]','[]'),(32080875,0,1000,0,4,0,1,0,'[{{0,1002040800,1},1},{{0,1004040800,1},1},{{0,1006040800,1},1},{{0,1008040800,1},1},{{0,1010040800,1},1},{{0,1001040800,1},1}]','[]','[]'),(32080876,0,1000,0,1,0,1,0,'[{{0,1007010800,1},1},{{0,1003000800,1},1},{{0,1005000800,1},1},{{0,1009000800,1},1}]','[]','[]'),(32080876,0,1000,0,2,0,1,0,'[{{0,1007020800,1},1},{{0,1003000800,1},1},{{0,1005000800,1},1},{{0,1009000800,1},1}]','[]','[]'),(32080876,0,1000,0,3,0,1,0,'[{{0,1007030800,1},1},{{0,1003000800,1},1},{{0,1005000800,1},1},{{0,1009000800,1},1}]','[]','[]'),(32080876,0,1000,0,4,0,1,0,'[{{0,1007040800,1},1},{{0,1003000800,1},1},{{0,1005000800,1},1},{{0,1009000800,1},1}]','[]','[]'),(32080877,0,1000,0,1,0,1,0,'[{{0,1007010800,1},1},{{0,1003000800,1},1}]','[]','[]'),(32080877,0,1000,0,2,0,1,0,'[{{0,1007020800,1},1},{{0,1003000800,1},1}]','[]','[]'),(32080877,0,1000,0,3,0,1,0,'[{{0,1007030800,1},1},{{0,1003000800,1},1}]','[]','[]'),(32080877,0,1000,0,4,0,1,0,'[{{0,1007040800,1},1},{{0,1003000800,1},1}]','[]','[]'),(32080878,0,1000,0,0,0,1,0,'[{{0,1005000800,1},1},{{0,1009000800,1},1}]','[]','[]'),(32080881,0,1000,0,1,0,1,0,'[{{0,1001010810,1},1},{{0,1002010810,1},1},{{0,1003000810,1},1},{{0,1004010810,1},1},{{0,1006010810,1},1},{{0,1007010810,1},1},{{0,1008010810,1},1},{{0,1010010810,1},1}]','[]','[]'),(32080881,0,1000,0,2,0,1,0,'[{{0,1001020810,1},1},{{0,1002020810,1},1},{{0,1003000810,1},1},{{0,1004020810,1},1},{{0,1006020810,1},1},{{0,1007020810,1},1},{{0,1008020810,1},1},{{0,1010020810,1},1}]','[]','[]'),(32080881,0,1000,0,3,0,1,0,'[{{0,1001030810,1},1},{{0,1002030810,1},1},{{0,1003000810,1},1},{{0,1004030810,1},1},{{0,1006030810,1},1},{{0,1007030810,1},1},{{0,1008030810,1},1},{{0,1010030810,1},1}]','[]','[]'),(32080881,0,1000,0,4,0,1,0,'[{{0,1001040810,1},1},{{0,1002040810,1},1},{{0,1003000810,1},1},{{0,1004040810,1},1},{{0,1006040810,1},1},{{0,1007040810,1},1},{{0,1008040810,1},1},{{0,1010040810,1},1}]','[]','[]'),(32080882,0,1000,0,1,0,1,0,'[{{0,1002010810,1},1},{{0,1004010810,1},1},{{0,1006010810,1},1},{{0,1008010810,1},1},{{0,1010010810,1},1}]','[]','[]'),(32080882,0,1000,0,2,0,1,0,'[{{0,1002020810,1},1},{{0,1004020810,1},1},{{0,1006020810,1},1},{{0,1008020810,1},1},{{0,1010020810,1},1}]','[]','[]'),(32080882,0,1000,0,3,0,1,0,'[{{0,1002030810,1},1},{{0,1004030810,1},1},{{0,1006030810,1},1},{{0,1008030810,1},1},{{0,1010030810,1},1}]','[]','[]'),(32080882,0,1000,0,4,0,1,0,'[{{0,1002040810,1},1},{{0,1004040810,1},1},{{0,1006040810,1},1},{{0,1008040810,1},1},{{0,1010040810,1},1}]','[]','[]'),(32080883,0,1000,0,1,0,1,0,'[{{0,1001010810,1},1},{{0,1007010810,1},1}]','[]','[]'),(32080883,0,1000,0,2,0,1,0,'[{{0,1001020810,1},1},{{0,1007020810,1},1}]','[]','[]'),(32080883,0,1000,0,3,0,1,0,'[{{0,1001030810,1},1},{{0,1007030810,1},1}]','[]','[]'),(32080883,0,1000,0,4,0,1,0,'[{{0,1001040810,1},1},{{0,1007040810,1},1}]','[]','[]'),(32080885,0,1000,0,1,0,1,0,'[{{0,1002010810,1},1},{{0,1004010810,1},1},{{0,1006010810,1},1},{{0,1008010810,1},1},{{0,1010010810,1},1},{{0,1001010810,1},1}]','[]','[]'),(32080885,0,1000,0,2,0,1,0,'[{{0,1002020810,1},1},{{0,1004020810,1},1},{{0,1006020810,1},1},{{0,1008020810,1},1},{{0,1010020810,1},1},{{0,1001020810,1},1}]','[]','[]'),(32080885,0,1000,0,3,0,1,0,'[{{0,1002030810,1},1},{{0,1004030810,1},1},{{0,1006030810,1},1},{{0,1008030810,1},1},{{0,1010030810,1},1},{{0,1001030810,1},1}]','[]','[]'),(32080885,0,1000,0,4,0,1,0,'[{{0,1002040810,1},1},{{0,1004040810,1},1},{{0,1006040810,1},1},{{0,1008040810,1},1},{{0,1010040810,1},1},{{0,1001040810,1},1}]','[]','[]'),(32080886,0,1000,0,1,0,1,0,'[{{0,1007010810,1},1},{{0,1003000810,1},1},{{0,1005000810,1},1},{{0,1009000810,1},1}]','[]','[]'),(32080886,0,1000,0,2,0,1,0,'[{{0,1007020810,1},1},{{0,1003000810,1},1},{{0,1005000810,1},1},{{0,1009000810,1},1}]','[]','[]'),(32080886,0,1000,0,3,0,1,0,'[{{0,1007030810,1},1},{{0,1003000810,1},1},{{0,1005000810,1},1},{{0,1009000810,1},1}]','[]','[]'),(32080886,0,1000,0,4,0,1,0,'[{{0,1007040810,1},1},{{0,1003000810,1},1},{{0,1005000810,1},1},{{0,1009000810,1},1}]','[]','[]'),(32080887,0,1000,0,1,0,1,0,'[{{0,1007010810,1},1},{{0,1003000810,1},1}]','[]','[]'),(32080887,0,1000,0,2,0,1,0,'[{{0,1007020810,1},1},{{0,1003000810,1},1}]','[]','[]'),(32080887,0,1000,0,3,0,1,0,'[{{0,1007030810,1},1},{{0,1003000810,1},1}]','[]','[]'),(32080887,0,1000,0,4,0,1,0,'[{{0,1007040810,1},1},{{0,1003000810,1},1}]','[]','[]'),(32080888,0,1000,0,0,0,1,0,'[{{0,1005000810,1},1},{{0,1009000810,1},1}]','[]','[]'),(32080891,0,1000,0,1,0,1,0,'[{{0,1001010820,1},1},{{0,1002010820,1},1},{{0,1003000820,1},1},{{0,1004010820,1},1},{{0,1006010820,1},1},{{0,1007010820,1},1},{{0,1008010820,1},1},{{0,1010010820,1},1}]','[]','[]'),(32080891,0,1000,0,2,0,1,0,'[{{0,1001020820,1},1},{{0,1002020820,1},1},{{0,1003000820,1},1},{{0,1004020820,1},1},{{0,1006020820,1},1},{{0,1007020820,1},1},{{0,1008020820,1},1},{{0,1010020820,1},1}]','[]','[]'),(32080891,0,1000,0,3,0,1,0,'[{{0,1001030820,1},1},{{0,1002030820,1},1},{{0,1003000820,1},1},{{0,1004030820,1},1},{{0,1006030820,1},1},{{0,1007030820,1},1},{{0,1008030820,1},1},{{0,1010030820,1},1}]','[]','[]'),(32080891,0,1000,0,4,0,1,0,'[{{0,1001040820,1},1},{{0,1002040820,1},1},{{0,1003000820,1},1},{{0,1004040820,1},1},{{0,1006040820,1},1},{{0,1007040820,1},1},{{0,1008040820,1},1},{{0,1010040820,1},1}]','[]','[]'),(32080892,0,1000,0,1,0,1,0,'[{{0,1002010820,1},1},{{0,1004010820,1},1},{{0,1006010820,1},1},{{0,1008010820,1},1},{{0,1010010820,1},1}]','[]','[]'),(32080892,0,1000,0,2,0,1,0,'[{{0,1002020820,1},1},{{0,1004020820,1},1},{{0,1006020820,1},1},{{0,1008020820,1},1},{{0,1010020820,1},1}]','[]','[]'),(32080892,0,1000,0,3,0,1,0,'[{{0,1002030820,1},1},{{0,1004030820,1},1},{{0,1006030820,1},1},{{0,1008030820,1},1},{{0,1010030820,1},1}]','[]','[]'),(32080892,0,1000,0,4,0,1,0,'[{{0,1002040820,1},1},{{0,1004040820,1},1},{{0,1006040820,1},1},{{0,1008040820,1},1},{{0,1010040820,1},1}]','[]','[]'),(32080893,0,1000,0,1,0,1,0,'[{{0,1001010820,1},1},{{0,1007010820,1},1}]','[]','[]'),(32080893,0,1000,0,2,0,1,0,'[{{0,1001020820,1},1},{{0,1007020820,1},1}]','[]','[]'),(32080893,0,1000,0,3,0,1,0,'[{{0,1001030820,1},1},{{0,1007030820,1},1}]','[]','[]'),(32080893,0,1000,0,4,0,1,0,'[{{0,1001040820,1},1},{{0,1007040820,1},1}]','[]','[]'),(32080895,0,1000,0,1,0,1,0,'[{{0,1002010820,1},1},{{0,1004010820,1},1},{{0,1006010820,1},1},{{0,1008010820,1},1},{{0,1010010820,1},1},{{0,1001010820,1},1}]','[]','[]'),(32080895,0,1000,0,2,0,1,0,'[{{0,1002020820,1},1},{{0,1004020820,1},1},{{0,1006020820,1},1},{{0,1008020820,1},1},{{0,1010020820,1},1},{{0,1001020820,1},1}]','[]','[]'),(32080895,0,1000,0,3,0,1,0,'[{{0,1002030820,1},1},{{0,1004030820,1},1},{{0,1006030820,1},1},{{0,1008030820,1},1},{{0,1010030820,1},1},{{0,1001030820,1},1}]','[]','[]'),(32080895,0,1000,0,4,0,1,0,'[{{0,1002040820,1},1},{{0,1004040820,1},1},{{0,1006040820,1},1},{{0,1008040820,1},1},{{0,1010040820,1},1},{{0,1001040820,1},1}]','[]','[]'),(32080896,0,1000,0,1,0,1,0,'[{{0,1007010820,1},1},{{0,1003000820,1},1},{{0,1005000820,1},1},{{0,1009000820,1},1}]','[]','[]'),(32080896,0,1000,0,2,0,1,0,'[{{0,1007020820,1},1},{{0,1003000820,1},1},{{0,1005000820,1},1},{{0,1009000820,1},1}]','[]','[]'),(32080896,0,1000,0,3,0,1,0,'[{{0,1007030820,1},1},{{0,1003000820,1},1},{{0,1005000820,1},1},{{0,1009000820,1},1}]','[]','[]'),(32080896,0,1000,0,4,0,1,0,'[{{0,1007040820,1},1},{{0,1003000820,1},1},{{0,1005000820,1},1},{{0,1009000820,1},1}]','[]','[]'),(32080897,0,1000,0,1,0,1,0,'[{{0,1007010820,1},1},{{0,1003000820,1},1}]','[]','[]'),(32080897,0,1000,0,2,0,1,0,'[{{0,1007020820,1},1},{{0,1003000820,1},1}]','[]','[]'),(32080897,0,1000,0,3,0,1,0,'[{{0,1007030820,1},1},{{0,1003000820,1},1}]','[]','[]'),(32080897,0,1000,0,4,0,1,0,'[{{0,1007040820,1},1},{{0,1003000820,1},1}]','[]','[]'),(32080898,0,1000,0,0,0,1,0,'[{{0,1005000820,1},1},{{0,1009000820,1},1}]','[]','[]'),(32080901,0,1000,0,1,0,1,0,'[{{0,1001010831,1},1},{{0,1002010831,1},1},{{0,1003000831,1},1},{{0,1004010831,1},1},{{0,1006010831,1},1},{{0,1007010831,1},1},{{0,1008010831,1},1},{{0,1010010831,1},1}]','[]','[]'),(32080901,0,1000,0,2,0,1,0,'[{{0,1001020831,1},1},{{0,1002020831,1},1},{{0,1003000831,1},1},{{0,1004020831,1},1},{{0,1006020831,1},1},{{0,1007020831,1},1},{{0,1008020831,1},1},{{0,1010020831,1},1}]','[]','[]'),(32080901,0,1000,0,3,0,1,0,'[{{0,1001030831,1},1},{{0,1002030831,1},1},{{0,1003000831,1},1},{{0,1004030831,1},1},{{0,1006030831,1},1},{{0,1007030831,1},1},{{0,1008030831,1},1},{{0,1010030831,1},1}]','[]','[]'),(32080901,0,1000,0,4,0,1,0,'[{{0,1001040831,1},1},{{0,1002040831,1},1},{{0,1003000831,1},1},{{0,1004040831,1},1},{{0,1006040831,1},1},{{0,1007040831,1},1},{{0,1008040831,1},1},{{0,1010040831,1},1}]','[]','[]'),(32080902,0,1000,0,1,0,1,0,'[{{0,1002010831,1},1},{{0,1004010831,1},1},{{0,1006010831,1},1},{{0,1008010831,1},1},{{0,1010010831,1},1}]','[]','[]'),(32080902,0,1000,0,2,0,1,0,'[{{0,1002020831,1},1},{{0,1004020831,1},1},{{0,1006020831,1},1},{{0,1008020831,1},1},{{0,1010020831,1},1}]','[]','[]'),(32080902,0,1000,0,3,0,1,0,'[{{0,1002030831,1},1},{{0,1004030831,1},1},{{0,1006030831,1},1},{{0,1008030831,1},1},{{0,1010030831,1},1}]','[]','[]'),(32080902,0,1000,0,4,0,1,0,'[{{0,1002040831,1},1},{{0,1004040831,1},1},{{0,1006040831,1},1},{{0,1008040831,1},1},{{0,1010040831,1},1}]','[]','[]'),(32080903,0,1000,0,1,0,1,0,'[{{0,1001010831,1},1},{{0,1007010831,1},1}]','[]','[]'),(32080903,0,1000,0,2,0,1,0,'[{{0,1001020831,1},1},{{0,1007020831,1},1}]','[]','[]'),(32080903,0,1000,0,3,0,1,0,'[{{0,1001030831,1},1},{{0,1007030831,1},1}]','[]','[]'),(32080903,0,1000,0,4,0,1,0,'[{{0,1001040831,1},1},{{0,1007040831,1},1}]','[]','[]'),(32080905,0,1000,0,1,0,1,0,'[{{0,1002010831,1},1},{{0,1004010831,1},1},{{0,1006010831,1},1},{{0,1008010831,1},1},{{0,1010010831,1},1},{{0,1001010831,1},1}]','[]','[]'),(32080905,0,1000,0,2,0,1,0,'[{{0,1002020831,1},1},{{0,1004020831,1},1},{{0,1006020831,1},1},{{0,1008020831,1},1},{{0,1010020831,1},1},{{0,1001020831,1},1}]','[]','[]'),(32080905,0,1000,0,3,0,1,0,'[{{0,1002030831,1},1},{{0,1004030831,1},1},{{0,1006030831,1},1},{{0,1008030831,1},1},{{0,1010030831,1},1},{{0,1001030831,1},1}]','[]','[]'),(32080905,0,1000,0,4,0,1,0,'[{{0,1002040831,1},1},{{0,1004040831,1},1},{{0,1006040831,1},1},{{0,1008040831,1},1},{{0,1010040831,1},1},{{0,1001040831,1},1}]','[]','[]'),(32080906,0,1000,0,1,0,1,0,'[{{0,1007010831,1},1},{{0,1003000831,1},1},{{0,1005000831,1},1},{{0,1009000831,1},1}]','[]','[]'),(32080906,0,1000,0,2,0,1,0,'[{{0,1007020831,1},1},{{0,1003000831,1},1},{{0,1005000831,1},1},{{0,1009000831,1},1}]','[]','[]'),(32080906,0,1000,0,3,0,1,0,'[{{0,1007030831,1},1},{{0,1003000831,1},1},{{0,1005000831,1},1},{{0,1009000831,1},1}]','[]','[]'),(32080906,0,1000,0,4,0,1,0,'[{{0,1007040831,1},1},{{0,1003000831,1},1},{{0,1005000831,1},1},{{0,1009000831,1},1}]','[]','[]'),(32080907,0,1000,0,1,0,1,0,'[{{0,1007010831,1},1},{{0,1003000831,1},1}]','[]','[]'),(32080907,0,1000,0,2,0,1,0,'[{{0,1007020831,1},1},{{0,1003000831,1},1}]','[]','[]'),(32080907,0,1000,0,3,0,1,0,'[{{0,1007030831,1},1},{{0,1003000831,1},1}]','[]','[]'),(32080907,0,1000,0,4,0,1,0,'[{{0,1007040831,1},1},{{0,1003000831,1},1}]','[]','[]'),(32080908,0,1000,0,0,0,1,0,'[{{0,1005000831,1},1},{{0,1009000831,1},1}]','[]','[]'),(32080911,0,1000,0,1,0,1,0,'[{{0,1001010932,1},1},{{0,1002010932,1},1},{{0,1003000932,1},1},{{0,1004010932,1},1},{{0,1006010932,1},1},{{0,1007010932,1},1},{{0,1008010932,1},1},{{0,1010010932,1},1}]','[]','[1001010932,1002010932,1003000932,1004010932,1005000932,1006010932,1007010932,1008010932,1009000932,1010010932]'),(32080911,0,1000,0,2,0,1,0,'[{{0,1001020932,1},1},{{0,1002020932,1},1},{{0,1003000932,1},1},{{0,1004020932,1},1},{{0,1006020932,1},1},{{0,1007020932,1},1},{{0,1008020932,1},1},{{0,1010020932,1},1}]','[]','[1001020932,1002020932,1003000932,1004020932,1005000932,1006020932,1007020932,1008020932,1009000932,1010020932]'),(32080911,0,1000,0,3,0,1,0,'[{{0,1001030932,1},1},{{0,1002030932,1},1},{{0,1003000932,1},1},{{0,1004030932,1},1},{{0,1006030932,1},1},{{0,1007030932,1},1},{{0,1008030932,1},1},{{0,1010030932,1},1}]','[]','[1001030932,1002030932,1003000932,1004030932,1005000932,1006030932,1007030932,1008030932,1009000932,1010030932]'),(32080911,0,1000,0,4,0,1,0,'[{{0,1001040932,1},1},{{0,1002040932,1},1},{{0,1003000932,1},1},{{0,1004040932,1},1},{{0,1006040932,1},1},{{0,1007040932,1},1},{{0,1008040932,1},1},{{0,1010040932,1},1}]','[]','[1001040932,1002040932,1003000932,1004040932,1005000932,1006040932,1007040932,1008040932,1009000932,1010040932]'),(32080912,0,1000,0,1,0,1,0,'[{{0,1002010932,1},1},{{0,1004010932,1},1},{{0,1006010932,1},1},{{0,1008010932,1},1},{{0,1010010932,1},1}]','[]','[1002010932,1004010932,1006010932,1008010932,1010010932]'),(32080912,0,1000,0,2,0,1,0,'[{{0,1002020932,1},1},{{0,1004020932,1},1},{{0,1006020932,1},1},{{0,1008020932,1},1},{{0,1010020932,1},1}]','[]','[1002020932,1004020932,1006020932,1008020932,1010020932]'),(32080912,0,1000,0,3,0,1,0,'[{{0,1002030932,1},1},{{0,1004030932,1},1},{{0,1006030932,1},1},{{0,1008030932,1},1},{{0,1010030932,1},1}]','[]','[1002030932,1004030932,1006030932,1008030932,1010030932]'),(32080912,0,1000,0,4,0,1,0,'[{{0,1002040932,1},1},{{0,1004040932,1},1},{{0,1006040932,1},1},{{0,1008040932,1},1},{{0,1010040932,1},1}]','[]','[1002040932,1004040932,1006040932,1008040932,1010040932]'),(32080913,0,1000,0,1,0,1,0,'[{{0,1001010932,1},1},{{0,1007010932,1},1}]','[]','[1001010932,1007010932]'),(32080913,0,1000,0,2,0,1,0,'[{{0,1001020932,1},1},{{0,1007020932,1},1}]','[]','[1001020932,1007020932]'),(32080913,0,1000,0,3,0,1,0,'[{{0,1001030932,1},1},{{0,1007030932,1},1}]','[]','[1001030932,1007030932]'),(32080913,0,1000,0,4,0,1,0,'[{{0,1001040932,1},1},{{0,1007040932,1},1}]','[]','[1001040932,1007040932]'),(32080915,0,1000,0,1,0,1,0,'[{{0,1002010932,1},1},{{0,1004010932,1},1},{{0,1006010932,1},1},{{0,1008010932,1},1},{{0,1010010932,1},1},{{0,1001010932,1},1}]','[]','[1002010932,1004010932,1006010932,1008010932,1010010932,1001010932]'),(32080915,0,1000,0,2,0,1,0,'[{{0,1002020932,1},1},{{0,1004020932,1},1},{{0,1006020932,1},1},{{0,1008020932,1},1},{{0,1010020932,1},1},{{0,1001020932,1},1}]','[]','[1002020932,1004020932,1006020932,1008020932,1010020932,1001020932]'),(32080915,0,1000,0,3,0,1,0,'[{{0,1002030932,1},1},{{0,1004030932,1},1},{{0,1006030932,1},1},{{0,1008030932,1},1},{{0,1010030932,1},1},{{0,1001030932,1},1}]','[]','[1002030932,1004030932,1006030932,1008030932,1010030932,1001030932]'),(32080915,0,1000,0,4,0,1,0,'[{{0,1002040932,1},1},{{0,1004040932,1},1},{{0,1006040932,1},1},{{0,1008040932,1},1},{{0,1010040932,1},1},{{0,1001040932,1},1}]','[]','[1002040932,1004040932,1006040932,1008040932,1010040932,1001040932]'),(32080916,0,1000,0,1,0,1,0,'[{{0,1007010932,1},1},{{0,1003000932,1},1},{{0,1005000932,1},1},{{0,1009000932,1},1}]','[]','[1007010932,1003000932,1005000932,1009000932]'),(32080916,0,1000,0,2,0,1,0,'[{{0,1007020932,1},1},{{0,1003000932,1},1},{{0,1005000932,1},1},{{0,1009000932,1},1}]','[]','[1007020932,1003000932,1005000932,1009000932]'),(32080916,0,1000,0,3,0,1,0,'[{{0,1007030932,1},1},{{0,1003000932,1},1},{{0,1005000932,1},1},{{0,1009000932,1},1}]','[]','[1007030932,1003000932,1005000932,1009000932]'),(32080916,0,1000,0,4,0,1,0,'[{{0,1007040932,1},1},{{0,1003000932,1},1},{{0,1005000932,1},1},{{0,1009000932,1},1}]','[]','[1007040932,1003000932,1005000932,1009000932]'),(32080917,0,1000,0,1,0,1,0,'[{{0,1007010932,1},1},{{0,1003000932,1},1}]','[]','[1007010932,1003000932]'),(32080917,0,1000,0,2,0,1,0,'[{{0,1007020932,1},1},{{0,1003000932,1},1}]','[]','[1007020932,1003000932]'),(32080917,0,1000,0,3,0,1,0,'[{{0,1007030932,1},1},{{0,1003000932,1},1}]','[]','[1007030932,1003000932]'),(32080917,0,1000,0,4,0,1,0,'[{{0,1007040932,1},1},{{0,1003000932,1},1}]','[]','[1007040932,1003000932]'),(32080918,0,1000,0,0,0,1,0,'[{{0,1005000932,1},1},{{0,1009000932,1},1}]','[]','[1005000932,1009000932]'),(32080921,0,1000,0,1,0,1,0,'[{{0,1001010941,1},1},{{0,1002010941,1},1},{{0,1003000941,1},1},{{0,1004010941,1},1},{{0,1006010941,1},1},{{0,1007010941,1},1},{{0,1008010941,1},1},{{0,1010010941,1},1}]','[]','[]'),(32080921,0,1000,0,2,0,1,0,'[{{0,1001020941,1},1},{{0,1002020941,1},1},{{0,1003000941,1},1},{{0,1004020941,1},1},{{0,1006020941,1},1},{{0,1007020941,1},1},{{0,1008020941,1},1},{{0,1010020941,1},1}]','[]','[]'),(32080921,0,1000,0,3,0,1,0,'[{{0,1001030941,1},1},{{0,1002030941,1},1},{{0,1003000941,1},1},{{0,1004030941,1},1},{{0,1006030941,1},1},{{0,1007030941,1},1},{{0,1008030941,1},1},{{0,1010030941,1},1}]','[]','[]'),(32080921,0,1000,0,4,0,1,0,'[{{0,1001040941,1},1},{{0,1002040941,1},1},{{0,1003000941,1},1},{{0,1004040941,1},1},{{0,1006040941,1},1},{{0,1007040941,1},1},{{0,1008040941,1},1},{{0,1010040941,1},1}]','[]','[]'),(32080922,0,1000,0,1,0,1,0,'[{{0,1002010941,1},1},{{0,1004010941,1},1},{{0,1006010941,1},1},{{0,1008010941,1},1},{{0,1010010941,1},1}]','[]','[]'),(32080922,0,1000,0,2,0,1,0,'[{{0,1002020941,1},1},{{0,1004020941,1},1},{{0,1006020941,1},1},{{0,1008020941,1},1},{{0,1010020941,1},1}]','[]','[]'),(32080922,0,1000,0,3,0,1,0,'[{{0,1002030941,1},1},{{0,1004030941,1},1},{{0,1006030941,1},1},{{0,1008030941,1},1},{{0,1010030941,1},1}]','[]','[]'),(32080922,0,1000,0,4,0,1,0,'[{{0,1002040941,1},1},{{0,1004040941,1},1},{{0,1006040941,1},1},{{0,1008040941,1},1},{{0,1010040941,1},1}]','[]','[]'),(32080923,0,1000,0,1,0,1,0,'[{{0,1001010941,1},1},{{0,1007010941,1},1}]','[]','[]'),(32080923,0,1000,0,2,0,1,0,'[{{0,1001020941,1},1},{{0,1007020941,1},1}]','[]','[]'),(32080923,0,1000,0,3,0,1,0,'[{{0,1001030941,1},1},{{0,1007030941,1},1}]','[]','[]'),(32080923,0,1000,0,4,0,1,0,'[{{0,1001040941,1},1},{{0,1007040941,1},1}]','[]','[]'),(32080925,0,1000,0,1,0,1,0,'[{{0,1002010941,1},1},{{0,1004010941,1},1},{{0,1006010941,1},1},{{0,1008010941,1},1},{{0,1010010941,1},1},{{0,1001010941,1},1}]','[]','[]'),(32080925,0,1000,0,2,0,1,0,'[{{0,1002020941,1},1},{{0,1004020941,1},1},{{0,1006020941,1},1},{{0,1008020941,1},1},{{0,1010020941,1},1},{{0,1001020941,1},1}]','[]','[]'),(32080925,0,1000,0,3,0,1,0,'[{{0,1002030941,1},1},{{0,1004030941,1},1},{{0,1006030941,1},1},{{0,1008030941,1},1},{{0,1010030941,1},1},{{0,1001030941,1},1}]','[]','[]'),(32080925,0,1000,0,4,0,1,0,'[{{0,1002040941,1},1},{{0,1004040941,1},1},{{0,1006040941,1},1},{{0,1008040941,1},1},{{0,1010040941,1},1},{{0,1001040941,1},1}]','[]','[]'),(32080926,0,1000,0,1,0,1,0,'[{{0,1007010941,1},1},{{0,1003000941,1},1},{{0,1005000941,1},1},{{0,1009000941,1},1}]','[]','[]'),(32080926,0,1000,0,2,0,1,0,'[{{0,1007020941,1},1},{{0,1003000941,1},1},{{0,1005000941,1},1},{{0,1009000941,1},1}]','[]','[]'),(32080926,0,1000,0,3,0,1,0,'[{{0,1007030941,1},1},{{0,1003000941,1},1},{{0,1005000941,1},1},{{0,1009000941,1},1}]','[]','[]'),(32080926,0,1000,0,4,0,1,0,'[{{0,1007040941,1},1},{{0,1003000941,1},1},{{0,1005000941,1},1},{{0,1009000941,1},1}]','[]','[]'),(32080927,0,1000,0,1,0,1,0,'[{{0,1007010941,1},1},{{0,1003000941,1},1}]','[]','[]'),(32080927,0,1000,0,2,0,1,0,'[{{0,1007020941,1},1},{{0,1003000941,1},1}]','[]','[]'),(32080927,0,1000,0,3,0,1,0,'[{{0,1007030941,1},1},{{0,1003000941,1},1}]','[]','[]'),(32080927,0,1000,0,4,0,1,0,'[{{0,1007040941,1},1},{{0,1003000941,1},1}]','[]','[]'),(32080928,0,1000,0,0,0,1,0,'[{{0,1005000941,1},1},{{0,1009000941,1},1}]','[]','[]'),(32080931,0,1000,0,1,0,1,0,'[{{0,1001010942,1},1},{{0,1002010942,1},1},{{0,1003000942,1},1},{{0,1004010942,1},1},{{0,1006010942,1},1},{{0,1007010942,1},1},{{0,1008010942,1},1},{{0,1010010942,1},1}]','[]','[1001010942,1002010942,1003000942,1004010942,1005000942,1006010942,1007010942,1008010942,1009000942,1010010942]'),(32080931,0,1000,0,2,0,1,0,'[{{0,1001020942,1},1},{{0,1002020942,1},1},{{0,1003000942,1},1},{{0,1004020942,1},1},{{0,1006020942,1},1},{{0,1007020942,1},1},{{0,1008020942,1},1},{{0,1010020942,1},1}]','[]','[1001020942,1002020942,1003000942,1004020942,1005000942,1006020942,1007020942,1008020942,1009000942,1010020942]'),(32080931,0,1000,0,3,0,1,0,'[{{0,1001030942,1},1},{{0,1002030942,1},1},{{0,1003000942,1},1},{{0,1004030942,1},1},{{0,1006030942,1},1},{{0,1007030942,1},1},{{0,1008030942,1},1},{{0,1010030942,1},1}]','[]','[1001030942,1002030942,1003000942,1004030942,1005000942,1006030942,1007030942,1008030942,1009000942,1010030942]'),(32080931,0,1000,0,4,0,1,0,'[{{0,1001040942,1},1},{{0,1002040942,1},1},{{0,1003000942,1},1},{{0,1004040942,1},1},{{0,1006040942,1},1},{{0,1007040942,1},1},{{0,1008040942,1},1},{{0,1010040942,1},1}]','[]','[1001040942,1002040942,1003000942,1004040942,1005000942,1006040942,1007040942,1008040942,1009000942,1010040942]'),(32080932,0,1000,0,1,0,1,0,'[{{0,1002010942,1},1},{{0,1004010942,1},1},{{0,1006010942,1},1},{{0,1008010942,1},1},{{0,1010010942,1},1}]','[]','[1002010942,1004010942,1006010942,1008010942,1010010942]'),(32080932,0,1000,0,2,0,1,0,'[{{0,1002020942,1},1},{{0,1004020942,1},1},{{0,1006020942,1},1},{{0,1008020942,1},1},{{0,1010020942,1},1}]','[]','[1002020942,1004020942,1006020942,1008020942,1010020942]'),(32080932,0,1000,0,3,0,1,0,'[{{0,1002030942,1},1},{{0,1004030942,1},1},{{0,1006030942,1},1},{{0,1008030942,1},1},{{0,1010030942,1},1}]','[]','[1002030942,1004030942,1006030942,1008030942,1010030942]'),(32080932,0,1000,0,4,0,1,0,'[{{0,1002040942,1},1},{{0,1004040942,1},1},{{0,1006040942,1},1},{{0,1008040942,1},1},{{0,1010040942,1},1}]','[]','[1002040942,1004040942,1006040942,1008040942,1010040942]'),(32080933,0,1000,0,1,0,1,0,'[{{0,1001010942,1},1},{{0,1007010942,1},1}]','[]','[1001010942,1007010942]'),(32080933,0,1000,0,2,0,1,0,'[{{0,1001020942,1},1},{{0,1007020942,1},1}]','[]','[1001020942,1007020942]'),(32080933,0,1000,0,3,0,1,0,'[{{0,1001030942,1},1},{{0,1007030942,1},1}]','[]','[1001030942,1007030942]'),(32080933,0,1000,0,4,0,1,0,'[{{0,1001040942,1},1},{{0,1007040942,1},1}]','[]','[1001040942,1007040942]'),(32080935,0,1000,0,1,0,1,0,'[{{0,1002010942,1},1},{{0,1004010942,1},1},{{0,1006010942,1},1},{{0,1008010942,1},1},{{0,1010010942,1},1},{{0,1001010942,1},1}]','[]','[1002010942,1004010942,1006010942,1008010942,1010010942,1001010942]'),(32080935,0,1000,0,2,0,1,0,'[{{0,1002020942,1},1},{{0,1004020942,1},1},{{0,1006020942,1},1},{{0,1008020942,1},1},{{0,1010020942,1},1},{{0,1001020942,1},1}]','[]','[1002020942,1004020942,1006020942,1008020942,1010020942,1001020942]'),(32080935,0,1000,0,3,0,1,0,'[{{0,1002030942,1},1},{{0,1004030942,1},1},{{0,1006030942,1},1},{{0,1008030942,1},1},{{0,1010030942,1},1},{{0,1001030942,1},1}]','[]','[1002030942,1004030942,1006030942,1008030942,1010030942,1001030942]'),(32080935,0,1000,0,4,0,1,0,'[{{0,1002040942,1},1},{{0,1004040942,1},1},{{0,1006040942,1},1},{{0,1008040942,1},1},{{0,1010040942,1},1},{{0,1001040942,1},1}]','[]','[1002040942,1004040942,1006040942,1008040942,1010040942,1001040942]'),(32080936,0,1000,0,1,0,1,0,'[{{0,1007010942,1},1},{{0,1003000942,1},1},{{0,1005000942,1},1},{{0,1009000942,1},1}]','[]','[1007010942,1003000942,1005000942,1009000942]'),(32080936,0,1000,0,2,0,1,0,'[{{0,1007020942,1},1},{{0,1003000942,1},1},{{0,1005000942,1},1},{{0,1009000942,1},1}]','[]','[1007020942,1003000942,1005000942,1009000942]'),(32080936,0,1000,0,3,0,1,0,'[{{0,1007030942,1},1},{{0,1003000942,1},1},{{0,1005000942,1},1},{{0,1009000942,1},1}]','[]','[1007030942,1003000942,1005000942,1009000942]'),(32080936,0,1000,0,4,0,1,0,'[{{0,1007040942,1},1},{{0,1003000942,1},1},{{0,1005000942,1},1},{{0,1009000942,1},1}]','[]','[1007040942,1003000942,1005000942,1009000942]'),(32080937,0,1000,0,1,0,1,0,'[{{0,1007010942,1},1},{{0,1003000942,1},1}]','[]','[1007010942,1003000942]'),(32080937,0,1000,0,2,0,1,0,'[{{0,1007020942,1},1},{{0,1003000942,1},1}]','[]','[1007020942,1003000942]'),(32080937,0,1000,0,3,0,1,0,'[{{0,1007030942,1},1},{{0,1003000942,1},1}]','[]','[1007030942,1003000942]'),(32080937,0,1000,0,4,0,1,0,'[{{0,1007040942,1},1},{{0,1003000942,1},1}]','[]','[1007040942,1003000942]'),(32080938,0,1000,0,0,0,1,0,'[{{0,1005000942,1},1},{{0,1009000942,1},1}]','[]','[1005000942,1009000942]'),(32080941,0,1000,0,1,0,1,0,'[{{0,1001010943,1},1},{{0,1002010943,1},1},{{0,1003000943,1},1},{{0,1004010943,1},1},{{0,1006010943,1},1},{{0,1007010943,1},1},{{0,1008010943,1},1},{{0,1010010943,1},1}]','[]','[1001010943,1002010943,1003000943,1004010943,1005000943,1006010943,1007010943,1008010943,1009000943,1010010943]'),(32080941,0,1000,0,2,0,1,0,'[{{0,1001020943,1},1},{{0,1002020943,1},1},{{0,1003000943,1},1},{{0,1004020943,1},1},{{0,1006020943,1},1},{{0,1007020943,1},1},{{0,1008020943,1},1},{{0,1010020943,1},1}]','[]','[1001020943,1002020943,1003000943,1004020943,1005000943,1006020943,1007020943,1008020943,1009000943,1010020943]'),(32080941,0,1000,0,3,0,1,0,'[{{0,1001030943,1},1},{{0,1002030943,1},1},{{0,1003000943,1},1},{{0,1004030943,1},1},{{0,1006030943,1},1},{{0,1007030943,1},1},{{0,1008030943,1},1},{{0,1010030943,1},1}]','[]','[1001030943,1002030943,1003000943,1004030943,1005000943,1006030943,1007030943,1008030943,1009000943,1010030943]'),(32080941,0,1000,0,4,0,1,0,'[{{0,1001040943,1},1},{{0,1002040943,1},1},{{0,1003000943,1},1},{{0,1004040943,1},1},{{0,1006040943,1},1},{{0,1007040943,1},1},{{0,1008040943,1},1},{{0,1010040943,1},1}]','[]','[1001040943,1002040943,1003000943,1004040943,1005000943,1006040943,1007040943,1008040943,1009000943,1010040943]'),(32080942,0,1000,0,1,0,1,0,'[{{0,1002010943,1},1},{{0,1004010943,1},1},{{0,1006010943,1},1},{{0,1008010943,1},1},{{0,1010010943,1},1}]','[]','[1002010943,1004010943,1006010943,1008010943,1010010943]'),(32080942,0,1000,0,2,0,1,0,'[{{0,1002020943,1},1},{{0,1004020943,1},1},{{0,1006020943,1},1},{{0,1008020943,1},1},{{0,1010020943,1},1}]','[]','[1002020943,1004020943,1006020943,1008020943,1010020943]'),(32080942,0,1000,0,3,0,1,0,'[{{0,1002030943,1},1},{{0,1004030943,1},1},{{0,1006030943,1},1},{{0,1008030943,1},1},{{0,1010030943,1},1}]','[]','[1002030943,1004030943,1006030943,1008030943,1010030943]'),(32080942,0,1000,0,4,0,1,0,'[{{0,1002040943,1},1},{{0,1004040943,1},1},{{0,1006040943,1},1},{{0,1008040943,1},1},{{0,1010040943,1},1}]','[]','[1002040943,1004040943,1006040943,1008040943,1010040943]'),(32080943,0,1000,0,1,0,1,0,'[{{0,1001010943,1},1},{{0,1007010943,1},1}]','[]','[1001010943,1007010943]'),(32080943,0,1000,0,2,0,1,0,'[{{0,1001020943,1},1},{{0,1007020943,1},1}]','[]','[1001020943,1007020943]'),(32080943,0,1000,0,3,0,1,0,'[{{0,1001030943,1},1},{{0,1007030943,1},1}]','[]','[1001030943,1007030943]'),(32080943,0,1000,0,4,0,1,0,'[{{0,1001040943,1},1},{{0,1007040943,1},1}]','[]','[1001040943,1007040943]'),(32080945,0,1000,0,1,0,1,0,'[{{0,1002010943,1},1},{{0,1004010943,1},1},{{0,1006010943,1},1},{{0,1008010943,1},1},{{0,1010010943,1},1},{{0,1001010943,1},1}]','[]','[1002010943,1004010943,1006010943,1008010943,1010010943,1001010943]'),(32080945,0,1000,0,2,0,1,0,'[{{0,1002020943,1},1},{{0,1004020943,1},1},{{0,1006020943,1},1},{{0,1008020943,1},1},{{0,1010020943,1},1},{{0,1001020943,1},1}]','[]','[1002020943,1004020943,1006020943,1008020943,1010020943,1001020943]'),(32080945,0,1000,0,3,0,1,0,'[{{0,1002030943,1},1},{{0,1004030943,1},1},{{0,1006030943,1},1},{{0,1008030943,1},1},{{0,1010030943,1},1},{{0,1001030943,1},1}]','[]','[1002030943,1004030943,1006030943,1008030943,1010030943,1001030943]'),(32080945,0,1000,0,4,0,1,0,'[{{0,1002040943,1},1},{{0,1004040943,1},1},{{0,1006040943,1},1},{{0,1008040943,1},1},{{0,1010040943,1},1},{{0,1001040943,1},1}]','[]','[1002040943,1004040943,1006040943,1008040943,1010040943,1001040943]'),(32080946,0,1000,0,1,0,1,0,'[{{0,1007010943,1},1},{{0,1003000943,1},1},{{0,1005000943,1},1},{{0,1009000943,1},1}]','[]','[1007010943,1003000943,1005000943,1009000943]'),(32080946,0,1000,0,2,0,1,0,'[{{0,1007020943,1},1},{{0,1003000943,1},1},{{0,1005000943,1},1},{{0,1009000943,1},1}]','[]','[1007020943,1003000943,1005000943,1009000943]'),(32080946,0,1000,0,3,0,1,0,'[{{0,1007030943,1},1},{{0,1003000943,1},1},{{0,1005000943,1},1},{{0,1009000943,1},1}]','[]','[1007030943,1003000943,1005000943,1009000943]'),(32080946,0,1000,0,4,0,1,0,'[{{0,1007040943,1},1},{{0,1003000943,1},1},{{0,1005000943,1},1},{{0,1009000943,1},1}]','[]','[1007040943,1003000943,1005000943,1009000943]'),(32080947,0,1000,0,1,0,1,0,'[{{0,1007010943,1},1},{{0,1003000943,1},1}]','[]','[1007010943,1003000943]'),(32080947,0,1000,0,2,0,1,0,'[{{0,1007020943,1},1},{{0,1003000943,1},1}]','[]','[1007020943,1003000943]'),(32080947,0,1000,0,3,0,1,0,'[{{0,1007030943,1},1},{{0,1003000943,1},1}]','[]','[1007030943,1003000943]'),(32080947,0,1000,0,4,0,1,0,'[{{0,1007040943,1},1},{{0,1003000943,1},1}]','[]','[1007040943,1003000943]'),(32080948,0,1000,0,0,0,1,0,'[{{0,1005000943,1},1},{{0,1009000943,1},1}]','[]','[1005000943,1009000943]'),(32080951,0,1000,0,1,0,1,0,'[{{0,1001010953,1},1},{{0,1002010953,1},1},{{0,1003000953,1},1},{{0,1004010953,1},1},{{0,1006010953,1},1},{{0,1007010953,1},1},{{0,1008010953,1},1},{{0,1010010953,1},1}]','[]','[1001010953,1002010953,1003000953,1004010953,1005000953,1006010953,1007010953,1008010953,1009000953,1010010953]'),(32080951,0,1000,0,2,0,1,0,'[{{0,1001020953,1},1},{{0,1002020953,1},1},{{0,1003000953,1},1},{{0,1004020953,1},1},{{0,1006020953,1},1},{{0,1007020953,1},1},{{0,1008020953,1},1},{{0,1010020953,1},1}]','[]','[1001020953,1002020953,1003000953,1004020953,1005000953,1006020953,1007020953,1008020953,1009000953,1010020953]'),(32080951,0,1000,0,3,0,1,0,'[{{0,1001030953,1},1},{{0,1002030953,1},1},{{0,1003000953,1},1},{{0,1004030953,1},1},{{0,1006030953,1},1},{{0,1007030953,1},1},{{0,1008030953,1},1},{{0,1010030953,1},1}]','[]','[1001030953,1002030953,1003000953,1004030953,1005000953,1006030953,1007030953,1008030953,1009000953,1010030953]'),(32080951,0,1000,0,4,0,1,0,'[{{0,1001040953,1},1},{{0,1002040953,1},1},{{0,1003000953,1},1},{{0,1004040953,1},1},{{0,1006040953,1},1},{{0,1007040953,1},1},{{0,1008040953,1},1},{{0,1010040953,1},1}]','[]','[1001040953,1002040953,1003000953,1004040953,1005000953,1006040953,1007040953,1008040953,1009000953,1010040953]'),(32080952,0,1000,0,1,0,1,0,'[{{0,1002010953,1},1},{{0,1004010953,1},1},{{0,1006010953,1},1},{{0,1008010953,1},1},{{0,1010010953,1},1}]','[]','[1002010953,1004010953,1006010953,1008010953,1010010953]'),(32080952,0,1000,0,2,0,1,0,'[{{0,1002020953,1},1},{{0,1004020953,1},1},{{0,1006020953,1},1},{{0,1008020953,1},1},{{0,1010020953,1},1}]','[]','[1002020953,1004020953,1006020953,1008020953,1010020953]'),(32080952,0,1000,0,3,0,1,0,'[{{0,1002030953,1},1},{{0,1004030953,1},1},{{0,1006030953,1},1},{{0,1008030953,1},1},{{0,1010030953,1},1}]','[]','[1002030953,1004030953,1006030953,1008030953,1010030953]'),(32080952,0,1000,0,4,0,1,0,'[{{0,1002040953,1},1},{{0,1004040953,1},1},{{0,1006040953,1},1},{{0,1008040953,1},1},{{0,1010040953,1},1}]','[]','[1002040953,1004040953,1006040953,1008040953,1010040953]'),(32080953,0,1000,0,1,0,1,0,'[{{0,1001010953,1},1},{{0,1007010953,1},1}]','[]','[1001010953,1007010953]'),(32080953,0,1000,0,2,0,1,0,'[{{0,1001020953,1},1},{{0,1007020953,1},1}]','[]','[1001020953,1007020953]'),(32080953,0,1000,0,3,0,1,0,'[{{0,1001030953,1},1},{{0,1007030953,1},1}]','[]','[1001030953,1007030953]'),(32080953,0,1000,0,4,0,1,0,'[{{0,1001040953,1},1},{{0,1007040953,1},1}]','[]','[1001040953,1007040953]'),(32080955,0,1000,0,1,0,1,0,'[{{0,1002010953,1},1},{{0,1004010953,1},1},{{0,1006010953,1},1},{{0,1008010953,1},1},{{0,1010010953,1},1},{{0,1001010953,1},1}]','[]','[1002010953,1004010953,1006010953,1008010953,1010010953,1001010953]'),(32080955,0,1000,0,2,0,1,0,'[{{0,1002020953,1},1},{{0,1004020953,1},1},{{0,1006020953,1},1},{{0,1008020953,1},1},{{0,1010020953,1},1},{{0,1001020953,1},1}]','[]','[1002020953,1004020953,1006020953,1008020953,1010020953,1001020953]'),(32080955,0,1000,0,3,0,1,0,'[{{0,1002030953,1},1},{{0,1004030953,1},1},{{0,1006030953,1},1},{{0,1008030953,1},1},{{0,1010030953,1},1},{{0,1001030953,1},1}]','[]','[1002030953,1004030953,1006030953,1008030953,1010030953,1001030953]'),(32080955,0,1000,0,4,0,1,0,'[{{0,1002040953,1},1},{{0,1004040953,1},1},{{0,1006040953,1},1},{{0,1008040953,1},1},{{0,1010040953,1},1},{{0,1001040953,1},1}]','[]','[1002040953,1004040953,1006040953,1008040953,1010040953,1001040953]'),(32080956,0,1000,0,1,0,1,0,'[{{0,1007010953,1},1},{{0,1003000953,1},1},{{0,1005000953,1},1},{{0,1009000953,1},1}]','[]','[1007010953,1003000953,1005000953,1009000953]'),(32080956,0,1000,0,2,0,1,0,'[{{0,1007020953,1},1},{{0,1003000953,1},1},{{0,1005000953,1},1},{{0,1009000953,1},1}]','[]','[1007020953,1003000953,1005000953,1009000953]'),(32080956,0,1000,0,3,0,1,0,'[{{0,1007030953,1},1},{{0,1003000953,1},1},{{0,1005000953,1},1},{{0,1009000953,1},1}]','[]','[1007030953,1003000953,1005000953,1009000953]'),(32080956,0,1000,0,4,0,1,0,'[{{0,1007040953,1},1},{{0,1003000953,1},1},{{0,1005000953,1},1},{{0,1009000953,1},1}]','[]','[1007040953,1003000953,1005000953,1009000953]'),(32080957,0,1000,0,1,0,1,0,'[{{0,1007010953,1},1},{{0,1003000953,1},1}]','[]','[1007010953,1003000953]'),(32080957,0,1000,0,2,0,1,0,'[{{0,1007020953,1},1},{{0,1003000953,1},1}]','[]','[1007020953,1003000953]'),(32080957,0,1000,0,3,0,1,0,'[{{0,1007030953,1},1},{{0,1003000953,1},1}]','[]','[1007030953,1003000953]'),(32080957,0,1000,0,4,0,1,0,'[{{0,1007040953,1},1},{{0,1003000953,1},1}]','[]','[1007040953,1003000953]'),(32080958,0,1000,0,0,0,1,0,'[{{0,1005000953,1},1},{{0,1009000953,1},1}]','[]','[1005000953,1009000953]'),(32080961,0,1000,0,1,0,1,0,'[{{0,1001010963,1},1},{{0,1002010963,1},1},{{0,1003000963,1},1},{{0,1004010963,1},1},{{0,1006010963,1},1},{{0,1007010963,1},1},{{0,1008010963,1},1},{{0,1010010963,1},1}]','[]','[1001010963,1002010963,1003000963,1004010963,1005000963,1006010963,1007010963,1008010963,1009000963,1010010963]'),(32080961,0,1000,0,2,0,1,0,'[{{0,1001020963,1},1},{{0,1002020963,1},1},{{0,1003000963,1},1},{{0,1004020963,1},1},{{0,1006020963,1},1},{{0,1007020963,1},1},{{0,1008020963,1},1},{{0,1010020963,1},1}]','[]','[1001020963,1002020963,1003000963,1004020963,1005000963,1006020963,1007020963,1008020963,1009000963,1010020963]'),(32080961,0,1000,0,3,0,1,0,'[{{0,1001030963,1},1},{{0,1002030963,1},1},{{0,1003000963,1},1},{{0,1004030963,1},1},{{0,1006030963,1},1},{{0,1007030963,1},1},{{0,1008030963,1},1},{{0,1010030963,1},1}]','[]','[1001030963,1002030963,1003000963,1004030963,1005000963,1006030963,1007030963,1008030963,1009000963,1010030963]'),(32080961,0,1000,0,4,0,1,0,'[{{0,1001040963,1},1},{{0,1002040963,1},1},{{0,1003000963,1},1},{{0,1004040963,1},1},{{0,1006040963,1},1},{{0,1007040963,1},1},{{0,1008040963,1},1},{{0,1010040963,1},1}]','[]','[1001040963,1002040963,1003000963,1004040963,1005000963,1006040963,1007040963,1008040963,1009000963,1010040963]'),(32080962,0,1000,0,1,0,1,0,'[{{0,1002010963,1},1},{{0,1004010963,1},1},{{0,1006010963,1},1},{{0,1008010963,1},1},{{0,1010010963,1},1}]','[]','[1002010963,1004010963,1006010963,1008010963,1010010963]'),(32080962,0,1000,0,2,0,1,0,'[{{0,1002020963,1},1},{{0,1004020963,1},1},{{0,1006020963,1},1},{{0,1008020963,1},1},{{0,1010020963,1},1}]','[]','[1002020963,1004020963,1006020963,1008020963,1010020963]'),(32080962,0,1000,0,3,0,1,0,'[{{0,1002030963,1},1},{{0,1004030963,1},1},{{0,1006030963,1},1},{{0,1008030963,1},1},{{0,1010030963,1},1}]','[]','[1002030963,1004030963,1006030963,1008030963,1010030963]'),(32080962,0,1000,0,4,0,1,0,'[{{0,1002040963,1},1},{{0,1004040963,1},1},{{0,1006040963,1},1},{{0,1008040963,1},1},{{0,1010040963,1},1}]','[]','[1002040963,1004040963,1006040963,1008040963,1010040963]'),(32080963,0,1000,0,1,0,1,0,'[{{0,1001010963,1},1},{{0,1007010963,1},1}]','[]','[1001010963,1007010963]'),(32080963,0,1000,0,2,0,1,0,'[{{0,1001020963,1},1},{{0,1007020963,1},1}]','[]','[1001020963,1007020963]'),(32080963,0,1000,0,3,0,1,0,'[{{0,1001030963,1},1},{{0,1007030963,1},1}]','[]','[1001030963,1007030963]'),(32080963,0,1000,0,4,0,1,0,'[{{0,1001040963,1},1},{{0,1007040963,1},1}]','[]','[1001040963,1007040963]'),(32080965,0,1000,0,1,0,1,0,'[{{0,1002010963,1},1},{{0,1004010963,1},1},{{0,1006010963,1},1},{{0,1008010963,1},1},{{0,1010010963,1},1},{{0,1001010963,1},1}]','[]','[1002010963,1004010963,1006010963,1008010963,1010010963,1001010963]'),(32080965,0,1000,0,2,0,1,0,'[{{0,1002020963,1},1},{{0,1004020963,1},1},{{0,1006020963,1},1},{{0,1008020963,1},1},{{0,1010020963,1},1},{{0,1001020963,1},1}]','[]','[1002020963,1004020963,1006020963,1008020963,1010020963,1001020963]'),(32080965,0,1000,0,3,0,1,0,'[{{0,1002030963,1},1},{{0,1004030963,1},1},{{0,1006030963,1},1},{{0,1008030963,1},1},{{0,1010030963,1},1},{{0,1001030963,1},1}]','[]','[1002030963,1004030963,1006030963,1008030963,1010030963,1001030963]'),(32080965,0,1000,0,4,0,1,0,'[{{0,1002040963,1},1},{{0,1004040963,1},1},{{0,1006040963,1},1},{{0,1008040963,1},1},{{0,1010040963,1},1},{{0,1001040963,1},1}]','[]','[1002040963,1004040963,1006040963,1008040963,1010040963,1001040963]'),(32080966,0,1000,0,1,0,1,0,'[{{0,1007010963,1},1},{{0,1003000963,1},1},{{0,1005000963,1},1},{{0,1009000963,1},1}]','[]','[1007010963,1003000963,1005000963,1009000963]'),(32080966,0,1000,0,2,0,1,0,'[{{0,1007020963,1},1},{{0,1003000963,1},1},{{0,1005000963,1},1},{{0,1009000963,1},1}]','[]','[1007020963,1003000963,1005000963,1009000963]'),(32080966,0,1000,0,3,0,1,0,'[{{0,1007030963,1},1},{{0,1003000963,1},1},{{0,1005000963,1},1},{{0,1009000963,1},1}]','[]','[1007030963,1003000963,1005000963,1009000963]'),(32080966,0,1000,0,4,0,1,0,'[{{0,1007040963,1},1},{{0,1003000963,1},1},{{0,1005000963,1},1},{{0,1009000963,1},1}]','[]','[1007040963,1003000963,1005000963,1009000963]'),(32080967,0,1000,0,1,0,1,0,'[{{0,1007010963,1},1},{{0,1003000963,1},1}]','[]','[1007010963,1003000963]'),(32080967,0,1000,0,2,0,1,0,'[{{0,1007020963,1},1},{{0,1003000963,1},1}]','[]','[1007020963,1003000963]'),(32080967,0,1000,0,3,0,1,0,'[{{0,1007030963,1},1},{{0,1003000963,1},1}]','[]','[1007030963,1003000963]'),(32080967,0,1000,0,4,0,1,0,'[{{0,1007040963,1},1},{{0,1003000963,1},1}]','[]','[1007040963,1003000963]'),(32080968,0,1000,0,0,0,1,0,'[{{0,1005000963,1},1},{{0,1009000963,1},1}]','[]','[1005000963,1009000963]'),(32080971,0,1000,0,1,0,1,0,'[{{0,1001010900,1},1},{{0,1002010900,1},1},{{0,1003000900,1},1},{{0,1004010900,1},1},{{0,1006010900,1},1},{{0,1007010900,1},1},{{0,1008010900,1},1},{{0,1010010900,1},1}]','[]','[]'),(32080971,0,1000,0,2,0,1,0,'[{{0,1001020900,1},1},{{0,1002020900,1},1},{{0,1003000900,1},1},{{0,1004020900,1},1},{{0,1006020900,1},1},{{0,1007020900,1},1},{{0,1008020900,1},1},{{0,1010020900,1},1}]','[]','[]'),(32080971,0,1000,0,3,0,1,0,'[{{0,1001030900,1},1},{{0,1002030900,1},1},{{0,1003000900,1},1},{{0,1004030900,1},1},{{0,1006030900,1},1},{{0,1007030900,1},1},{{0,1008030900,1},1},{{0,1010030900,1},1}]','[]','[]'),(32080971,0,1000,0,4,0,1,0,'[{{0,1001040900,1},1},{{0,1002040900,1},1},{{0,1003000900,1},1},{{0,1004040900,1},1},{{0,1006040900,1},1},{{0,1007040900,1},1},{{0,1008040900,1},1},{{0,1010040900,1},1}]','[]','[]'),(32080972,0,1000,0,1,0,1,0,'[{{0,1002010900,1},1},{{0,1004010900,1},1},{{0,1006010900,1},1},{{0,1008010900,1},1},{{0,1010010900,1},1}]','[]','[]'),(32080972,0,1000,0,2,0,1,0,'[{{0,1002020900,1},1},{{0,1004020900,1},1},{{0,1006020900,1},1},{{0,1008020900,1},1},{{0,1010020900,1},1}]','[]','[]'),(32080972,0,1000,0,3,0,1,0,'[{{0,1002030900,1},1},{{0,1004030900,1},1},{{0,1006030900,1},1},{{0,1008030900,1},1},{{0,1010030900,1},1}]','[]','[]'),(32080972,0,1000,0,4,0,1,0,'[{{0,1002040900,1},1},{{0,1004040900,1},1},{{0,1006040900,1},1},{{0,1008040900,1},1},{{0,1010040900,1},1}]','[]','[]'),(32080973,0,1000,0,1,0,1,0,'[{{0,1001010900,1},1},{{0,1007010900,1},1}]','[]','[]'),(32080973,0,1000,0,2,0,1,0,'[{{0,1001020900,1},1},{{0,1007020900,1},1}]','[]','[]'),(32080973,0,1000,0,3,0,1,0,'[{{0,1001030900,1},1},{{0,1007030900,1},1}]','[]','[]'),(32080973,0,1000,0,4,0,1,0,'[{{0,1001040900,1},1},{{0,1007040900,1},1}]','[]','[]'),(32080975,0,1000,0,1,0,1,0,'[{{0,1002010900,1},1},{{0,1004010900,1},1},{{0,1006010900,1},1},{{0,1008010900,1},1},{{0,1010010900,1},1},{{0,1001010900,1},1}]','[]','[]'),(32080975,0,1000,0,2,0,1,0,'[{{0,1002020900,1},1},{{0,1004020900,1},1},{{0,1006020900,1},1},{{0,1008020900,1},1},{{0,1010020900,1},1},{{0,1001020900,1},1}]','[]','[]'),(32080975,0,1000,0,3,0,1,0,'[{{0,1002030900,1},1},{{0,1004030900,1},1},{{0,1006030900,1},1},{{0,1008030900,1},1},{{0,1010030900,1},1},{{0,1001030900,1},1}]','[]','[]'),(32080975,0,1000,0,4,0,1,0,'[{{0,1002040900,1},1},{{0,1004040900,1},1},{{0,1006040900,1},1},{{0,1008040900,1},1},{{0,1010040900,1},1},{{0,1001040900,1},1}]','[]','[]'),(32080976,0,1000,0,1,0,1,0,'[{{0,1007010900,1},1},{{0,1003000900,1},1},{{0,1005000900,1},1},{{0,1009000900,1},1}]','[]','[]'),(32080976,0,1000,0,2,0,1,0,'[{{0,1007020900,1},1},{{0,1003000900,1},1},{{0,1005000900,1},1},{{0,1009000900,1},1}]','[]','[]'),(32080976,0,1000,0,3,0,1,0,'[{{0,1007030900,1},1},{{0,1003000900,1},1},{{0,1005000900,1},1},{{0,1009000900,1},1}]','[]','[]'),(32080976,0,1000,0,4,0,1,0,'[{{0,1007040900,1},1},{{0,1003000900,1},1},{{0,1005000900,1},1},{{0,1009000900,1},1}]','[]','[]'),(32080977,0,1000,0,1,0,1,0,'[{{0,1007010900,1},1},{{0,1003000900,1},1}]','[]','[]'),(32080977,0,1000,0,2,0,1,0,'[{{0,1007020900,1},1},{{0,1003000900,1},1}]','[]','[]'),(32080977,0,1000,0,3,0,1,0,'[{{0,1007030900,1},1},{{0,1003000900,1},1}]','[]','[]'),(32080977,0,1000,0,4,0,1,0,'[{{0,1007040900,1},1},{{0,1003000900,1},1}]','[]','[]'),(32080978,0,1000,0,0,0,1,0,'[{{0,1005000900,1},1},{{0,1009000900,1},1}]','[]','[]'),(32080981,0,1000,0,1,0,1,0,'[{{0,1001010910,1},1},{{0,1002010910,1},1},{{0,1003000910,1},1},{{0,1004010910,1},1},{{0,1006010910,1},1},{{0,1007010910,1},1},{{0,1008010910,1},1},{{0,1010010910,1},1}]','[]','[]'),(32080981,0,1000,0,2,0,1,0,'[{{0,1001020910,1},1},{{0,1002020910,1},1},{{0,1003000910,1},1},{{0,1004020910,1},1},{{0,1006020910,1},1},{{0,1007020910,1},1},{{0,1008020910,1},1},{{0,1010020910,1},1}]','[]','[]'),(32080981,0,1000,0,3,0,1,0,'[{{0,1001030910,1},1},{{0,1002030910,1},1},{{0,1003000910,1},1},{{0,1004030910,1},1},{{0,1006030910,1},1},{{0,1007030910,1},1},{{0,1008030910,1},1},{{0,1010030910,1},1}]','[]','[]'),(32080981,0,1000,0,4,0,1,0,'[{{0,1001040910,1},1},{{0,1002040910,1},1},{{0,1003000910,1},1},{{0,1004040910,1},1},{{0,1006040910,1},1},{{0,1007040910,1},1},{{0,1008040910,1},1},{{0,1010040910,1},1}]','[]','[]'),(32080982,0,1000,0,1,0,1,0,'[{{0,1002010910,1},1},{{0,1004010910,1},1},{{0,1006010910,1},1},{{0,1008010910,1},1},{{0,1010010910,1},1}]','[]','[]'),(32080982,0,1000,0,2,0,1,0,'[{{0,1002020910,1},1},{{0,1004020910,1},1},{{0,1006020910,1},1},{{0,1008020910,1},1},{{0,1010020910,1},1}]','[]','[]'),(32080982,0,1000,0,3,0,1,0,'[{{0,1002030910,1},1},{{0,1004030910,1},1},{{0,1006030910,1},1},{{0,1008030910,1},1},{{0,1010030910,1},1}]','[]','[]'),(32080982,0,1000,0,4,0,1,0,'[{{0,1002040910,1},1},{{0,1004040910,1},1},{{0,1006040910,1},1},{{0,1008040910,1},1},{{0,1010040910,1},1}]','[]','[]'),(32080983,0,1000,0,1,0,1,0,'[{{0,1001010910,1},1},{{0,1007010910,1},1}]','[]','[]'),(32080983,0,1000,0,2,0,1,0,'[{{0,1001020910,1},1},{{0,1007020910,1},1}]','[]','[]'),(32080983,0,1000,0,3,0,1,0,'[{{0,1001030910,1},1},{{0,1007030910,1},1}]','[]','[]'),(32080983,0,1000,0,4,0,1,0,'[{{0,1001040910,1},1},{{0,1007040910,1},1}]','[]','[]'),(32080985,0,1000,0,1,0,1,0,'[{{0,1002010910,1},1},{{0,1004010910,1},1},{{0,1006010910,1},1},{{0,1008010910,1},1},{{0,1010010910,1},1},{{0,1001010910,1},1}]','[]','[]'),(32080985,0,1000,0,2,0,1,0,'[{{0,1002020910,1},1},{{0,1004020910,1},1},{{0,1006020910,1},1},{{0,1008020910,1},1},{{0,1010020910,1},1},{{0,1001020910,1},1}]','[]','[]'),(32080985,0,1000,0,3,0,1,0,'[{{0,1002030910,1},1},{{0,1004030910,1},1},{{0,1006030910,1},1},{{0,1008030910,1},1},{{0,1010030910,1},1},{{0,1001030910,1},1}]','[]','[]'),(32080985,0,1000,0,4,0,1,0,'[{{0,1002040910,1},1},{{0,1004040910,1},1},{{0,1006040910,1},1},{{0,1008040910,1},1},{{0,1010040910,1},1},{{0,1001040910,1},1}]','[]','[]'),(32080986,0,1000,0,1,0,1,0,'[{{0,1007010910,1},1},{{0,1003000910,1},1},{{0,1005000910,1},1},{{0,1009000910,1},1}]','[]','[]'),(32080986,0,1000,0,2,0,1,0,'[{{0,1007020910,1},1},{{0,1003000910,1},1},{{0,1005000910,1},1},{{0,1009000910,1},1}]','[]','[]'),(32080986,0,1000,0,3,0,1,0,'[{{0,1007030910,1},1},{{0,1003000910,1},1},{{0,1005000910,1},1},{{0,1009000910,1},1}]','[]','[]'),(32080986,0,1000,0,4,0,1,0,'[{{0,1007040910,1},1},{{0,1003000910,1},1},{{0,1005000910,1},1},{{0,1009000910,1},1}]','[]','[]'),(32080987,0,1000,0,1,0,1,0,'[{{0,1007010910,1},1},{{0,1003000910,1},1}]','[]','[]'),(32080987,0,1000,0,2,0,1,0,'[{{0,1007020910,1},1},{{0,1003000910,1},1}]','[]','[]'),(32080987,0,1000,0,3,0,1,0,'[{{0,1007030910,1},1},{{0,1003000910,1},1}]','[]','[]'),(32080987,0,1000,0,4,0,1,0,'[{{0,1007040910,1},1},{{0,1003000910,1},1}]','[]','[]'),(32080988,0,1000,0,0,0,1,0,'[{{0,1005000910,1},1},{{0,1009000910,1},1}]','[]','[]'),(32080991,0,1000,0,1,0,1,0,'[{{0,1001010920,1},1},{{0,1002010920,1},1},{{0,1003000920,1},1},{{0,1004010920,1},1},{{0,1006010920,1},1},{{0,1007010920,1},1},{{0,1008010920,1},1},{{0,1010010920,1},1}]','[]','[]'),(32080991,0,1000,0,2,0,1,0,'[{{0,1001020920,1},1},{{0,1002020920,1},1},{{0,1003000920,1},1},{{0,1004020920,1},1},{{0,1006020920,1},1},{{0,1007020920,1},1},{{0,1008020920,1},1},{{0,1010020920,1},1}]','[]','[]'),(32080991,0,1000,0,3,0,1,0,'[{{0,1001030920,1},1},{{0,1002030920,1},1},{{0,1003000920,1},1},{{0,1004030920,1},1},{{0,1006030920,1},1},{{0,1007030920,1},1},{{0,1008030920,1},1},{{0,1010030920,1},1}]','[]','[]'),(32080991,0,1000,0,4,0,1,0,'[{{0,1001040920,1},1},{{0,1002040920,1},1},{{0,1003000920,1},1},{{0,1004040920,1},1},{{0,1006040920,1},1},{{0,1007040920,1},1},{{0,1008040920,1},1},{{0,1010040920,1},1}]','[]','[]'),(32080992,0,1000,0,1,0,1,0,'[{{0,1002010920,1},1},{{0,1004010920,1},1},{{0,1006010920,1},1},{{0,1008010920,1},1},{{0,1010010920,1},1}]','[]','[]'),(32080992,0,1000,0,2,0,1,0,'[{{0,1002020920,1},1},{{0,1004020920,1},1},{{0,1006020920,1},1},{{0,1008020920,1},1},{{0,1010020920,1},1}]','[]','[]'),(32080992,0,1000,0,3,0,1,0,'[{{0,1002030920,1},1},{{0,1004030920,1},1},{{0,1006030920,1},1},{{0,1008030920,1},1},{{0,1010030920,1},1}]','[]','[]'),(32080992,0,1000,0,4,0,1,0,'[{{0,1002040920,1},1},{{0,1004040920,1},1},{{0,1006040920,1},1},{{0,1008040920,1},1},{{0,1010040920,1},1}]','[]','[]'),(32080993,0,1000,0,1,0,1,0,'[{{0,1001010920,1},1},{{0,1007010920,1},1}]','[]','[]'),(32080993,0,1000,0,2,0,1,0,'[{{0,1001020920,1},1},{{0,1007020920,1},1}]','[]','[]'),(32080993,0,1000,0,3,0,1,0,'[{{0,1001030920,1},1},{{0,1007030920,1},1}]','[]','[]'),(32080993,0,1000,0,4,0,1,0,'[{{0,1001040920,1},1},{{0,1007040920,1},1}]','[]','[]'),(32080995,0,1000,0,1,0,1,0,'[{{0,1002010920,1},1},{{0,1004010920,1},1},{{0,1006010920,1},1},{{0,1008010920,1},1},{{0,1010010920,1},1},{{0,1001010920,1},1}]','[]','[]'),(32080995,0,1000,0,2,0,1,0,'[{{0,1002020920,1},1},{{0,1004020920,1},1},{{0,1006020920,1},1},{{0,1008020920,1},1},{{0,1010020920,1},1},{{0,1001020920,1},1}]','[]','[]'),(32080995,0,1000,0,3,0,1,0,'[{{0,1002030920,1},1},{{0,1004030920,1},1},{{0,1006030920,1},1},{{0,1008030920,1},1},{{0,1010030920,1},1},{{0,1001030920,1},1}]','[]','[]'),(32080995,0,1000,0,4,0,1,0,'[{{0,1002040920,1},1},{{0,1004040920,1},1},{{0,1006040920,1},1},{{0,1008040920,1},1},{{0,1010040920,1},1},{{0,1001040920,1},1}]','[]','[]'),(32080996,0,1000,0,1,0,1,0,'[{{0,1007010920,1},1},{{0,1003000920,1},1},{{0,1005000920,1},1},{{0,1009000920,1},1}]','[]','[]'),(32080996,0,1000,0,2,0,1,0,'[{{0,1007020920,1},1},{{0,1003000920,1},1},{{0,1005000920,1},1},{{0,1009000920,1},1}]','[]','[]'),(32080996,0,1000,0,3,0,1,0,'[{{0,1007030920,1},1},{{0,1003000920,1},1},{{0,1005000920,1},1},{{0,1009000920,1},1}]','[]','[]'),(32080996,0,1000,0,4,0,1,0,'[{{0,1007040920,1},1},{{0,1003000920,1},1},{{0,1005000920,1},1},{{0,1009000920,1},1}]','[]','[]'),(32080997,0,1000,0,1,0,1,0,'[{{0,1007010920,1},1},{{0,1003000920,1},1}]','[]','[]'),(32080997,0,1000,0,2,0,1,0,'[{{0,1007020920,1},1},{{0,1003000920,1},1}]','[]','[]'),(32080997,0,1000,0,3,0,1,0,'[{{0,1007030920,1},1},{{0,1003000920,1},1}]','[]','[]'),(32080997,0,1000,0,4,0,1,0,'[{{0,1007040920,1},1},{{0,1003000920,1},1}]','[]','[]'),(32080998,0,1000,0,0,0,1,0,'[{{0,1005000920,1},1},{{0,1009000920,1},1}]','[]','[]'),(32081001,0,1000,0,1,0,1,0,'[{{0,1001010931,1},1},{{0,1002010931,1},1},{{0,1003000931,1},1},{{0,1004010931,1},1},{{0,1006010931,1},1},{{0,1007010931,1},1},{{0,1008010931,1},1},{{0,1010010931,1},1}]','[]','[]'),(32081001,0,1000,0,2,0,1,0,'[{{0,1001020931,1},1},{{0,1002020931,1},1},{{0,1003000931,1},1},{{0,1004020931,1},1},{{0,1006020931,1},1},{{0,1007020931,1},1},{{0,1008020931,1},1},{{0,1010020931,1},1}]','[]','[]'),(32081001,0,1000,0,3,0,1,0,'[{{0,1001030931,1},1},{{0,1002030931,1},1},{{0,1003000931,1},1},{{0,1004030931,1},1},{{0,1006030931,1},1},{{0,1007030931,1},1},{{0,1008030931,1},1},{{0,1010030931,1},1}]','[]','[]'),(32081001,0,1000,0,4,0,1,0,'[{{0,1001040931,1},1},{{0,1002040931,1},1},{{0,1003000931,1},1},{{0,1004040931,1},1},{{0,1006040931,1},1},{{0,1007040931,1},1},{{0,1008040931,1},1},{{0,1010040931,1},1}]','[]','[]'),(32081002,0,1000,0,1,0,1,0,'[{{0,1002010931,1},1},{{0,1004010931,1},1},{{0,1006010931,1},1},{{0,1008010931,1},1},{{0,1010010931,1},1}]','[]','[]'),(32081002,0,1000,0,2,0,1,0,'[{{0,1002020931,1},1},{{0,1004020931,1},1},{{0,1006020931,1},1},{{0,1008020931,1},1},{{0,1010020931,1},1}]','[]','[]'),(32081002,0,1000,0,3,0,1,0,'[{{0,1002030931,1},1},{{0,1004030931,1},1},{{0,1006030931,1},1},{{0,1008030931,1},1},{{0,1010030931,1},1}]','[]','[]'),(32081002,0,1000,0,4,0,1,0,'[{{0,1002040931,1},1},{{0,1004040931,1},1},{{0,1006040931,1},1},{{0,1008040931,1},1},{{0,1010040931,1},1}]','[]','[]'),(32081003,0,1000,0,1,0,1,0,'[{{0,1001010931,1},1},{{0,1007010931,1},1}]','[]','[]'),(32081003,0,1000,0,2,0,1,0,'[{{0,1001020931,1},1},{{0,1007020931,1},1}]','[]','[]'),(32081003,0,1000,0,3,0,1,0,'[{{0,1001030931,1},1},{{0,1007030931,1},1}]','[]','[]'),(32081003,0,1000,0,4,0,1,0,'[{{0,1001040931,1},1},{{0,1007040931,1},1}]','[]','[]'),(32081005,0,1000,0,1,0,1,0,'[{{0,1002010931,1},1},{{0,1004010931,1},1},{{0,1006010931,1},1},{{0,1008010931,1},1},{{0,1010010931,1},1},{{0,1001010931,1},1}]','[]','[]'),(32081005,0,1000,0,2,0,1,0,'[{{0,1002020931,1},1},{{0,1004020931,1},1},{{0,1006020931,1},1},{{0,1008020931,1},1},{{0,1010020931,1},1},{{0,1001020931,1},1}]','[]','[]'),(32081005,0,1000,0,3,0,1,0,'[{{0,1002030931,1},1},{{0,1004030931,1},1},{{0,1006030931,1},1},{{0,1008030931,1},1},{{0,1010030931,1},1},{{0,1001030931,1},1}]','[]','[]'),(32081005,0,1000,0,4,0,1,0,'[{{0,1002040931,1},1},{{0,1004040931,1},1},{{0,1006040931,1},1},{{0,1008040931,1},1},{{0,1010040931,1},1},{{0,1001040931,1},1}]','[]','[]'),(32081006,0,1000,0,1,0,1,0,'[{{0,1007010931,1},1},{{0,1003000931,1},1},{{0,1005000931,1},1},{{0,1009000931,1},1}]','[]','[]'),(32081006,0,1000,0,2,0,1,0,'[{{0,1007020931,1},1},{{0,1003000931,1},1},{{0,1005000931,1},1},{{0,1009000931,1},1}]','[]','[]'),(32081006,0,1000,0,3,0,1,0,'[{{0,1007030931,1},1},{{0,1003000931,1},1},{{0,1005000931,1},1},{{0,1009000931,1},1}]','[]','[]'),(32081006,0,1000,0,4,0,1,0,'[{{0,1007040931,1},1},{{0,1003000931,1},1},{{0,1005000931,1},1},{{0,1009000931,1},1}]','[]','[]'),(32081007,0,1000,0,1,0,1,0,'[{{0,1007010931,1},1},{{0,1003000931,1},1}]','[]','[]'),(32081007,0,1000,0,2,0,1,0,'[{{0,1007020931,1},1},{{0,1003000931,1},1}]','[]','[]'),(32081007,0,1000,0,3,0,1,0,'[{{0,1007030931,1},1},{{0,1003000931,1},1}]','[]','[]'),(32081007,0,1000,0,4,0,1,0,'[{{0,1007040931,1},1},{{0,1003000931,1},1}]','[]','[]'),(32081008,0,1000,0,0,0,1,0,'[{{0,1005000931,1},1},{{0,1009000931,1},1}]','[]','[]'),(32081011,0,1000,0,1,0,1,0,'[{{0,1001011032,1},1},{{0,1002011032,1},1},{{0,1003001032,1},1},{{0,1004011032,1},1},{{0,1006011032,1},1},{{0,1007011032,1},1},{{0,1008011032,1},1},{{0,1010011032,1},1}]','[]','[1001011032,1002011032,1003001032,1004011032,1005001032,1006011032,1007011032,1008011032,1009001032,1010011032]'),(32081011,0,1000,0,2,0,1,0,'[{{0,1001021032,1},1},{{0,1002021032,1},1},{{0,1003001032,1},1},{{0,1004021032,1},1},{{0,1006021032,1},1},{{0,1007021032,1},1},{{0,1008021032,1},1},{{0,1010021032,1},1}]','[]','[1001021032,1002021032,1003001032,1004021032,1005001032,1006021032,1007021032,1008021032,1009001032,1010021032]'),(32081011,0,1000,0,3,0,1,0,'[{{0,1001031032,1},1},{{0,1002031032,1},1},{{0,1003001032,1},1},{{0,1004031032,1},1},{{0,1006031032,1},1},{{0,1007031032,1},1},{{0,1008031032,1},1},{{0,1010031032,1},1}]','[]','[1001031032,1002031032,1003001032,1004031032,1005001032,1006031032,1007031032,1008031032,1009001032,1010031032]'),(32081011,0,1000,0,4,0,1,0,'[{{0,1001041032,1},1},{{0,1002041032,1},1},{{0,1003001032,1},1},{{0,1004041032,1},1},{{0,1006041032,1},1},{{0,1007041032,1},1},{{0,1008041032,1},1},{{0,1010041032,1},1}]','[]','[1001041032,1002041032,1003001032,1004041032,1005001032,1006041032,1007041032,1008041032,1009001032,1010041032]'),(32081012,0,1000,0,1,0,1,0,'[{{0,1002011032,1},1},{{0,1004011032,1},1},{{0,1006011032,1},1},{{0,1008011032,1},1},{{0,1010011032,1},1}]','[]','[1002011032,1004011032,1006011032,1008011032,1010011032]'),(32081012,0,1000,0,2,0,1,0,'[{{0,1002021032,1},1},{{0,1004021032,1},1},{{0,1006021032,1},1},{{0,1008021032,1},1},{{0,1010021032,1},1}]','[]','[1002021032,1004021032,1006021032,1008021032,1010021032]'),(32081012,0,1000,0,3,0,1,0,'[{{0,1002031032,1},1},{{0,1004031032,1},1},{{0,1006031032,1},1},{{0,1008031032,1},1},{{0,1010031032,1},1}]','[]','[1002031032,1004031032,1006031032,1008031032,1010031032]'),(32081012,0,1000,0,4,0,1,0,'[{{0,1002041032,1},1},{{0,1004041032,1},1},{{0,1006041032,1},1},{{0,1008041032,1},1},{{0,1010041032,1},1}]','[]','[1002041032,1004041032,1006041032,1008041032,1010041032]'),(32081013,0,1000,0,1,0,1,0,'[{{0,1001011032,1},1},{{0,1007011032,1},1}]','[]','[1001011032,1007011032]'),(32081013,0,1000,0,2,0,1,0,'[{{0,1001021032,1},1},{{0,1007021032,1},1}]','[]','[1001021032,1007021032]'),(32081013,0,1000,0,3,0,1,0,'[{{0,1001031032,1},1},{{0,1007031032,1},1}]','[]','[1001031032,1007031032]'),(32081013,0,1000,0,4,0,1,0,'[{{0,1001041032,1},1},{{0,1007041032,1},1}]','[]','[1001041032,1007041032]'),(32081015,0,1000,0,1,0,1,0,'[{{0,1002011032,1},1},{{0,1004011032,1},1},{{0,1006011032,1},1},{{0,1008011032,1},1},{{0,1010011032,1},1},{{0,1001011032,1},1}]','[]','[1002011032,1004011032,1006011032,1008011032,1010011032,1001011032]'),(32081015,0,1000,0,2,0,1,0,'[{{0,1002021032,1},1},{{0,1004021032,1},1},{{0,1006021032,1},1},{{0,1008021032,1},1},{{0,1010021032,1},1},{{0,1001021032,1},1}]','[]','[1002021032,1004021032,1006021032,1008021032,1010021032,1001021032]'),(32081015,0,1000,0,3,0,1,0,'[{{0,1002031032,1},1},{{0,1004031032,1},1},{{0,1006031032,1},1},{{0,1008031032,1},1},{{0,1010031032,1},1},{{0,1001031032,1},1}]','[]','[1002031032,1004031032,1006031032,1008031032,1010031032,1001031032]'),(32081015,0,1000,0,4,0,1,0,'[{{0,1002041032,1},1},{{0,1004041032,1},1},{{0,1006041032,1},1},{{0,1008041032,1},1},{{0,1010041032,1},1},{{0,1001041032,1},1}]','[]','[1002041032,1004041032,1006041032,1008041032,1010041032,1001041032]'),(32081016,0,1000,0,1,0,1,0,'[{{0,1007011032,1},1},{{0,1003001032,1},1},{{0,1005001032,1},1},{{0,1009001032,1},1}]','[]','[1007011032,1003001032,1005001032,1009001032]'),(32081016,0,1000,0,2,0,1,0,'[{{0,1007021032,1},1},{{0,1003001032,1},1},{{0,1005001032,1},1},{{0,1009001032,1},1}]','[]','[1007021032,1003001032,1005001032,1009001032]'),(32081016,0,1000,0,3,0,1,0,'[{{0,1007031032,1},1},{{0,1003001032,1},1},{{0,1005001032,1},1},{{0,1009001032,1},1}]','[]','[1007031032,1003001032,1005001032,1009001032]'),(32081016,0,1000,0,4,0,1,0,'[{{0,1007041032,1},1},{{0,1003001032,1},1},{{0,1005001032,1},1},{{0,1009001032,1},1}]','[]','[1007041032,1003001032,1005001032,1009001032]'),(32081017,0,1000,0,1,0,1,0,'[{{0,1007011032,1},1},{{0,1003001032,1},1}]','[]','[1007011032,1003001032]'),(32081017,0,1000,0,2,0,1,0,'[{{0,1007021032,1},1},{{0,1003001032,1},1}]','[]','[1007021032,1003001032]'),(32081017,0,1000,0,3,0,1,0,'[{{0,1007031032,1},1},{{0,1003001032,1},1}]','[]','[1007031032,1003001032]'),(32081017,0,1000,0,4,0,1,0,'[{{0,1007041032,1},1},{{0,1003001032,1},1}]','[]','[1007041032,1003001032]'),(32081018,0,1000,0,0,0,1,0,'[{{0,1005001032,1},1},{{0,1009001032,1},1}]','[]','[1005001032,1009001032]'),(32081021,0,1000,0,1,0,1,0,'[{{0,1001011041,1},1},{{0,1002011041,1},1},{{0,1003001041,1},1},{{0,1004011041,1},1},{{0,1006011041,1},1},{{0,1007011041,1},1},{{0,1008011041,1},1},{{0,1010011041,1},1}]','[]','[]'),(32081021,0,1000,0,2,0,1,0,'[{{0,1001021041,1},1},{{0,1002021041,1},1},{{0,1003001041,1},1},{{0,1004021041,1},1},{{0,1006021041,1},1},{{0,1007021041,1},1},{{0,1008021041,1},1},{{0,1010021041,1},1}]','[]','[]'),(32081021,0,1000,0,3,0,1,0,'[{{0,1001031041,1},1},{{0,1002031041,1},1},{{0,1003001041,1},1},{{0,1004031041,1},1},{{0,1006031041,1},1},{{0,1007031041,1},1},{{0,1008031041,1},1},{{0,1010031041,1},1}]','[]','[]'),(32081021,0,1000,0,4,0,1,0,'[{{0,1001041041,1},1},{{0,1002041041,1},1},{{0,1003001041,1},1},{{0,1004041041,1},1},{{0,1006041041,1},1},{{0,1007041041,1},1},{{0,1008041041,1},1},{{0,1010041041,1},1}]','[]','[]'),(32081022,0,1000,0,1,0,1,0,'[{{0,1002011041,1},1},{{0,1004011041,1},1},{{0,1006011041,1},1},{{0,1008011041,1},1},{{0,1010011041,1},1}]','[]','[]'),(32081022,0,1000,0,2,0,1,0,'[{{0,1002021041,1},1},{{0,1004021041,1},1},{{0,1006021041,1},1},{{0,1008021041,1},1},{{0,1010021041,1},1}]','[]','[]'),(32081022,0,1000,0,3,0,1,0,'[{{0,1002031041,1},1},{{0,1004031041,1},1},{{0,1006031041,1},1},{{0,1008031041,1},1},{{0,1010031041,1},1}]','[]','[]'),(32081022,0,1000,0,4,0,1,0,'[{{0,1002041041,1},1},{{0,1004041041,1},1},{{0,1006041041,1},1},{{0,1008041041,1},1},{{0,1010041041,1},1}]','[]','[]'),(32081023,0,1000,0,1,0,1,0,'[{{0,1001011041,1},1},{{0,1007011041,1},1}]','[]','[]'),(32081023,0,1000,0,2,0,1,0,'[{{0,1001021041,1},1},{{0,1007021041,1},1}]','[]','[]'),(32081023,0,1000,0,3,0,1,0,'[{{0,1001031041,1},1},{{0,1007031041,1},1}]','[]','[]'),(32081023,0,1000,0,4,0,1,0,'[{{0,1001041041,1},1},{{0,1007041041,1},1}]','[]','[]'),(32081025,0,1000,0,1,0,1,0,'[{{0,1002011041,1},1},{{0,1004011041,1},1},{{0,1006011041,1},1},{{0,1008011041,1},1},{{0,1010011041,1},1},{{0,1001011041,1},1}]','[]','[]'),(32081025,0,1000,0,2,0,1,0,'[{{0,1002021041,1},1},{{0,1004021041,1},1},{{0,1006021041,1},1},{{0,1008021041,1},1},{{0,1010021041,1},1},{{0,1001021041,1},1}]','[]','[]'),(32081025,0,1000,0,3,0,1,0,'[{{0,1002031041,1},1},{{0,1004031041,1},1},{{0,1006031041,1},1},{{0,1008031041,1},1},{{0,1010031041,1},1},{{0,1001031041,1},1}]','[]','[]'),(32081025,0,1000,0,4,0,1,0,'[{{0,1002041041,1},1},{{0,1004041041,1},1},{{0,1006041041,1},1},{{0,1008041041,1},1},{{0,1010041041,1},1},{{0,1001041041,1},1}]','[]','[]'),(32081026,0,1000,0,1,0,1,0,'[{{0,1007011041,1},1},{{0,1003001041,1},1},{{0,1005001041,1},1},{{0,1009001041,1},1}]','[]','[]'),(32081026,0,1000,0,2,0,1,0,'[{{0,1007021041,1},1},{{0,1003001041,1},1},{{0,1005001041,1},1},{{0,1009001041,1},1}]','[]','[]'),(32081026,0,1000,0,3,0,1,0,'[{{0,1007031041,1},1},{{0,1003001041,1},1},{{0,1005001041,1},1},{{0,1009001041,1},1}]','[]','[]'),(32081026,0,1000,0,4,0,1,0,'[{{0,1007041041,1},1},{{0,1003001041,1},1},{{0,1005001041,1},1},{{0,1009001041,1},1}]','[]','[]'),(32081027,0,1000,0,1,0,1,0,'[{{0,1007011041,1},1},{{0,1003001041,1},1}]','[]','[]'),(32081027,0,1000,0,2,0,1,0,'[{{0,1007021041,1},1},{{0,1003001041,1},1}]','[]','[]'),(32081027,0,1000,0,3,0,1,0,'[{{0,1007031041,1},1},{{0,1003001041,1},1}]','[]','[]'),(32081027,0,1000,0,4,0,1,0,'[{{0,1007041041,1},1},{{0,1003001041,1},1}]','[]','[]'),(32081028,0,1000,0,0,0,1,0,'[{{0,1005001041,1},1},{{0,1009001041,1},1}]','[]','[]'),(32081031,0,1000,0,1,0,1,0,'[{{0,1001011042,1},1},{{0,1002011042,1},1},{{0,1003001042,1},1},{{0,1004011042,1},1},{{0,1006011042,1},1},{{0,1007011042,1},1},{{0,1008011042,1},1},{{0,1010011042,1},1}]','[]','[1001011042,1002011042,1003001042,1004011042,1005001042,1006011042,1007011042,1008011042,1009001042,1010011042]'),(32081031,0,1000,0,2,0,1,0,'[{{0,1001021042,1},1},{{0,1002021042,1},1},{{0,1003001042,1},1},{{0,1004021042,1},1},{{0,1006021042,1},1},{{0,1007021042,1},1},{{0,1008021042,1},1},{{0,1010021042,1},1}]','[]','[1001021042,1002021042,1003001042,1004021042,1005001042,1006021042,1007021042,1008021042,1009001042,1010021042]'),(32081031,0,1000,0,3,0,1,0,'[{{0,1001031042,1},1},{{0,1002031042,1},1},{{0,1003001042,1},1},{{0,1004031042,1},1},{{0,1006031042,1},1},{{0,1007031042,1},1},{{0,1008031042,1},1},{{0,1010031042,1},1}]','[]','[1001031042,1002031042,1003001042,1004031042,1005001042,1006031042,1007031042,1008031042,1009001042,1010031042]'),(32081031,0,1000,0,4,0,1,0,'[{{0,1001041042,1},1},{{0,1002041042,1},1},{{0,1003001042,1},1},{{0,1004041042,1},1},{{0,1006041042,1},1},{{0,1007041042,1},1},{{0,1008041042,1},1},{{0,1010041042,1},1}]','[]','[1001041042,1002041042,1003001042,1004041042,1005001042,1006041042,1007041042,1008041042,1009001042,1010041042]'),(32081032,0,1000,0,1,0,1,0,'[{{0,1002011042,1},1},{{0,1004011042,1},1},{{0,1006011042,1},1},{{0,1008011042,1},1},{{0,1010011042,1},1}]','[]','[1002011042,1004011042,1006011042,1008011042,1010011042]'),(32081032,0,1000,0,2,0,1,0,'[{{0,1002021042,1},1},{{0,1004021042,1},1},{{0,1006021042,1},1},{{0,1008021042,1},1},{{0,1010021042,1},1}]','[]','[1002021042,1004021042,1006021042,1008021042,1010021042]'),(32081032,0,1000,0,3,0,1,0,'[{{0,1002031042,1},1},{{0,1004031042,1},1},{{0,1006031042,1},1},{{0,1008031042,1},1},{{0,1010031042,1},1}]','[]','[1002031042,1004031042,1006031042,1008031042,1010031042]'),(32081032,0,1000,0,4,0,1,0,'[{{0,1002041042,1},1},{{0,1004041042,1},1},{{0,1006041042,1},1},{{0,1008041042,1},1},{{0,1010041042,1},1}]','[]','[1002041042,1004041042,1006041042,1008041042,1010041042]'),(32081033,0,1000,0,1,0,1,0,'[{{0,1001011042,1},1},{{0,1007011042,1},1}]','[]','[1001011042,1007011042]'),(32081033,0,1000,0,2,0,1,0,'[{{0,1001021042,1},1},{{0,1007021042,1},1}]','[]','[1001021042,1007021042]'),(32081033,0,1000,0,3,0,1,0,'[{{0,1001031042,1},1},{{0,1007031042,1},1}]','[]','[1001031042,1007031042]'),(32081033,0,1000,0,4,0,1,0,'[{{0,1001041042,1},1},{{0,1007041042,1},1}]','[]','[1001041042,1007041042]'),(32081035,0,1000,0,1,0,1,0,'[{{0,1002011042,1},1},{{0,1004011042,1},1},{{0,1006011042,1},1},{{0,1008011042,1},1},{{0,1010011042,1},1},{{0,1001011042,1},1}]','[]','[1002011042,1004011042,1006011042,1008011042,1010011042,1001011042]'),(32081035,0,1000,0,2,0,1,0,'[{{0,1002021042,1},1},{{0,1004021042,1},1},{{0,1006021042,1},1},{{0,1008021042,1},1},{{0,1010021042,1},1},{{0,1001021042,1},1}]','[]','[1002021042,1004021042,1006021042,1008021042,1010021042,1001021042]'),(32081035,0,1000,0,3,0,1,0,'[{{0,1002031042,1},1},{{0,1004031042,1},1},{{0,1006031042,1},1},{{0,1008031042,1},1},{{0,1010031042,1},1},{{0,1001031042,1},1}]','[]','[1002031042,1004031042,1006031042,1008031042,1010031042,1001031042]'),(32081035,0,1000,0,4,0,1,0,'[{{0,1002041042,1},1},{{0,1004041042,1},1},{{0,1006041042,1},1},{{0,1008041042,1},1},{{0,1010041042,1},1},{{0,1001041042,1},1}]','[]','[1002041042,1004041042,1006041042,1008041042,1010041042,1001041042]'),(32081036,0,1000,0,1,0,1,0,'[{{0,1007011042,1},1},{{0,1003001042,1},1},{{0,1005001042,1},1},{{0,1009001042,1},1}]','[]','[1007011042,1003001042,1005001042,1009001042]'),(32081036,0,1000,0,2,0,1,0,'[{{0,1007021042,1},1},{{0,1003001042,1},1},{{0,1005001042,1},1},{{0,1009001042,1},1}]','[]','[1007021042,1003001042,1005001042,1009001042]'),(32081036,0,1000,0,3,0,1,0,'[{{0,1007031042,1},1},{{0,1003001042,1},1},{{0,1005001042,1},1},{{0,1009001042,1},1}]','[]','[1007031042,1003001042,1005001042,1009001042]'),(32081036,0,1000,0,4,0,1,0,'[{{0,1007041042,1},1},{{0,1003001042,1},1},{{0,1005001042,1},1},{{0,1009001042,1},1}]','[]','[1007041042,1003001042,1005001042,1009001042]'),(32081037,0,1000,0,1,0,1,0,'[{{0,1007011042,1},1},{{0,1003001042,1},1}]','[]','[1007011042,1003001042]'),(32081037,0,1000,0,2,0,1,0,'[{{0,1007021042,1},1},{{0,1003001042,1},1}]','[]','[1007021042,1003001042]'),(32081037,0,1000,0,3,0,1,0,'[{{0,1007031042,1},1},{{0,1003001042,1},1}]','[]','[1007031042,1003001042]'),(32081037,0,1000,0,4,0,1,0,'[{{0,1007041042,1},1},{{0,1003001042,1},1}]','[]','[1007041042,1003001042]'),(32081038,0,1000,0,0,0,1,0,'[{{0,1005001042,1},1},{{0,1009001042,1},1}]','[]','[1005001042,1009001042]'),(32081041,0,1000,0,1,0,1,0,'[{{0,1001011043,1},1},{{0,1002011043,1},1},{{0,1003001043,1},1},{{0,1004011043,1},1},{{0,1006011043,1},1},{{0,1007011043,1},1},{{0,1008011043,1},1},{{0,1010011043,1},1}]','[]','[1001011043,1002011043,1003001043,1004011043,1005001043,1006011043,1007011043,1008011043,1009001043,1010011043]'),(32081041,0,1000,0,2,0,1,0,'[{{0,1001021043,1},1},{{0,1002021043,1},1},{{0,1003001043,1},1},{{0,1004021043,1},1},{{0,1006021043,1},1},{{0,1007021043,1},1},{{0,1008021043,1},1},{{0,1010021043,1},1}]','[]','[1001021043,1002021043,1003001043,1004021043,1005001043,1006021043,1007021043,1008021043,1009001043,1010021043]'),(32081041,0,1000,0,3,0,1,0,'[{{0,1001031043,1},1},{{0,1002031043,1},1},{{0,1003001043,1},1},{{0,1004031043,1},1},{{0,1006031043,1},1},{{0,1007031043,1},1},{{0,1008031043,1},1},{{0,1010031043,1},1}]','[]','[1001031043,1002031043,1003001043,1004031043,1005001043,1006031043,1007031043,1008031043,1009001043,1010031043]'),(32081041,0,1000,0,4,0,1,0,'[{{0,1001041043,1},1},{{0,1002041043,1},1},{{0,1003001043,1},1},{{0,1004041043,1},1},{{0,1006041043,1},1},{{0,1007041043,1},1},{{0,1008041043,1},1},{{0,1010041043,1},1}]','[]','[1001041043,1002041043,1003001043,1004041043,1005001043,1006041043,1007041043,1008041043,1009001043,1010041043]'),(32081042,0,1000,0,1,0,1,0,'[{{0,1002011043,1},1},{{0,1004011043,1},1},{{0,1006011043,1},1},{{0,1008011043,1},1},{{0,1010011043,1},1}]','[]','[1002011043,1004011043,1006011043,1008011043,1010011043]'),(32081042,0,1000,0,2,0,1,0,'[{{0,1002021043,1},1},{{0,1004021043,1},1},{{0,1006021043,1},1},{{0,1008021043,1},1},{{0,1010021043,1},1}]','[]','[1002021043,1004021043,1006021043,1008021043,1010021043]'),(32081042,0,1000,0,3,0,1,0,'[{{0,1002031043,1},1},{{0,1004031043,1},1},{{0,1006031043,1},1},{{0,1008031043,1},1},{{0,1010031043,1},1}]','[]','[1002031043,1004031043,1006031043,1008031043,1010031043]'),(32081042,0,1000,0,4,0,1,0,'[{{0,1002041043,1},1},{{0,1004041043,1},1},{{0,1006041043,1},1},{{0,1008041043,1},1},{{0,1010041043,1},1}]','[]','[1002041043,1004041043,1006041043,1008041043,1010041043]'),(32081043,0,1000,0,1,0,1,0,'[{{0,1001011043,1},1},{{0,1007011043,1},1}]','[]','[1001011043,1007011043]'),(32081043,0,1000,0,2,0,1,0,'[{{0,1001021043,1},1},{{0,1007021043,1},1}]','[]','[1001021043,1007021043]'),(32081043,0,1000,0,3,0,1,0,'[{{0,1001031043,1},1},{{0,1007031043,1},1}]','[]','[1001031043,1007031043]'),(32081043,0,1000,0,4,0,1,0,'[{{0,1001041043,1},1},{{0,1007041043,1},1}]','[]','[1001041043,1007041043]'),(32081045,0,1000,0,1,0,1,0,'[{{0,1002011043,1},1},{{0,1004011043,1},1},{{0,1006011043,1},1},{{0,1008011043,1},1},{{0,1010011043,1},1},{{0,1001011043,1},1}]','[]','[1002011043,1004011043,1006011043,1008011043,1010011043,1001011043]'),(32081045,0,1000,0,2,0,1,0,'[{{0,1002021043,1},1},{{0,1004021043,1},1},{{0,1006021043,1},1},{{0,1008021043,1},1},{{0,1010021043,1},1},{{0,1001021043,1},1}]','[]','[1002021043,1004021043,1006021043,1008021043,1010021043,1001021043]'),(32081045,0,1000,0,3,0,1,0,'[{{0,1002031043,1},1},{{0,1004031043,1},1},{{0,1006031043,1},1},{{0,1008031043,1},1},{{0,1010031043,1},1},{{0,1001031043,1},1}]','[]','[1002031043,1004031043,1006031043,1008031043,1010031043,1001031043]'),(32081045,0,1000,0,4,0,1,0,'[{{0,1002041043,1},1},{{0,1004041043,1},1},{{0,1006041043,1},1},{{0,1008041043,1},1},{{0,1010041043,1},1},{{0,1001041043,1},1}]','[]','[1002041043,1004041043,1006041043,1008041043,1010041043,1001041043]'),(32081046,0,1000,0,1,0,1,0,'[{{0,1007011043,1},1},{{0,1003001043,1},1},{{0,1005001043,1},1},{{0,1009001043,1},1}]','[]','[1007011043,1003001043,1005001043,1009001043]'),(32081046,0,1000,0,2,0,1,0,'[{{0,1007021043,1},1},{{0,1003001043,1},1},{{0,1005001043,1},1},{{0,1009001043,1},1}]','[]','[1007021043,1003001043,1005001043,1009001043]'),(32081046,0,1000,0,3,0,1,0,'[{{0,1007031043,1},1},{{0,1003001043,1},1},{{0,1005001043,1},1},{{0,1009001043,1},1}]','[]','[1007031043,1003001043,1005001043,1009001043]'),(32081046,0,1000,0,4,0,1,0,'[{{0,1007041043,1},1},{{0,1003001043,1},1},{{0,1005001043,1},1},{{0,1009001043,1},1}]','[]','[1007041043,1003001043,1005001043,1009001043]'),(32081047,0,1000,0,1,0,1,0,'[{{0,1007011043,1},1},{{0,1003001043,1},1}]','[]','[1007011043,1003001043]'),(32081047,0,1000,0,2,0,1,0,'[{{0,1007021043,1},1},{{0,1003001043,1},1}]','[]','[1007021043,1003001043]'),(32081047,0,1000,0,3,0,1,0,'[{{0,1007031043,1},1},{{0,1003001043,1},1}]','[]','[1007031043,1003001043]'),(32081047,0,1000,0,4,0,1,0,'[{{0,1007041043,1},1},{{0,1003001043,1},1}]','[]','[1007041043,1003001043]'),(32081048,0,1000,0,0,0,1,0,'[{{0,1005001043,1},1},{{0,1009001043,1},1}]','[]','[1005001043,1009001043]'),(32081051,0,1000,0,1,0,1,0,'[{{0,1001011053,1},1},{{0,1002011053,1},1},{{0,1003001053,1},1},{{0,1004011053,1},1},{{0,1006011053,1},1},{{0,1007011053,1},1},{{0,1008011053,1},1},{{0,1010011053,1},1}]','[]','[1001011053,1002011053,1003001053,1004011053,1005001053,1006011053,1007011053,1008011053,1009001053,1010011053]'),(32081051,0,1000,0,2,0,1,0,'[{{0,1001021053,1},1},{{0,1002021053,1},1},{{0,1003001053,1},1},{{0,1004021053,1},1},{{0,1006021053,1},1},{{0,1007021053,1},1},{{0,1008021053,1},1},{{0,1010021053,1},1}]','[]','[1001021053,1002021053,1003001053,1004021053,1005001053,1006021053,1007021053,1008021053,1009001053,1010021053]'),(32081051,0,1000,0,3,0,1,0,'[{{0,1001031053,1},1},{{0,1002031053,1},1},{{0,1003001053,1},1},{{0,1004031053,1},1},{{0,1006031053,1},1},{{0,1007031053,1},1},{{0,1008031053,1},1},{{0,1010031053,1},1}]','[]','[1001031053,1002031053,1003001053,1004031053,1005001053,1006031053,1007031053,1008031053,1009001053,1010031053]'),(32081051,0,1000,0,4,0,1,0,'[{{0,1001041053,1},1},{{0,1002041053,1},1},{{0,1003001053,1},1},{{0,1004041053,1},1},{{0,1006041053,1},1},{{0,1007041053,1},1},{{0,1008041053,1},1},{{0,1010041053,1},1}]','[]','[1001041053,1002041053,1003001053,1004041053,1005001053,1006041053,1007041053,1008041053,1009001053,1010041053]'),(32081052,0,1000,0,1,0,1,0,'[{{0,1002011053,1},1},{{0,1004011053,1},1},{{0,1006011053,1},1},{{0,1008011053,1},1},{{0,1010011053,1},1}]','[]','[1002011053,1004011053,1006011053,1008011053,1010011053]'),(32081052,0,1000,0,2,0,1,0,'[{{0,1002021053,1},1},{{0,1004021053,1},1},{{0,1006021053,1},1},{{0,1008021053,1},1},{{0,1010021053,1},1}]','[]','[1002021053,1004021053,1006021053,1008021053,1010021053]'),(32081052,0,1000,0,3,0,1,0,'[{{0,1002031053,1},1},{{0,1004031053,1},1},{{0,1006031053,1},1},{{0,1008031053,1},1},{{0,1010031053,1},1}]','[]','[1002031053,1004031053,1006031053,1008031053,1010031053]'),(32081052,0,1000,0,4,0,1,0,'[{{0,1002041053,1},1},{{0,1004041053,1},1},{{0,1006041053,1},1},{{0,1008041053,1},1},{{0,1010041053,1},1}]','[]','[1002041053,1004041053,1006041053,1008041053,1010041053]'),(32081053,0,1000,0,1,0,1,0,'[{{0,1001011053,1},1},{{0,1007011053,1},1}]','[]','[1001011053,1007011053]'),(32081053,0,1000,0,2,0,1,0,'[{{0,1001021053,1},1},{{0,1007021053,1},1}]','[]','[1001021053,1007021053]'),(32081053,0,1000,0,3,0,1,0,'[{{0,1001031053,1},1},{{0,1007031053,1},1}]','[]','[1001031053,1007031053]'),(32081053,0,1000,0,4,0,1,0,'[{{0,1001041053,1},1},{{0,1007041053,1},1}]','[]','[1001041053,1007041053]'),(32081055,0,1000,0,1,0,1,0,'[{{0,1002011053,1},1},{{0,1004011053,1},1},{{0,1006011053,1},1},{{0,1008011053,1},1},{{0,1010011053,1},1},{{0,1001011053,1},1}]','[]','[1002011053,1004011053,1006011053,1008011053,1010011053,1001011053]'),(32081055,0,1000,0,2,0,1,0,'[{{0,1002021053,1},1},{{0,1004021053,1},1},{{0,1006021053,1},1},{{0,1008021053,1},1},{{0,1010021053,1},1},{{0,1001021053,1},1}]','[]','[1002021053,1004021053,1006021053,1008021053,1010021053,1001021053]'),(32081055,0,1000,0,3,0,1,0,'[{{0,1002031053,1},1},{{0,1004031053,1},1},{{0,1006031053,1},1},{{0,1008031053,1},1},{{0,1010031053,1},1},{{0,1001031053,1},1}]','[]','[1002031053,1004031053,1006031053,1008031053,1010031053,1001031053]'),(32081055,0,1000,0,4,0,1,0,'[{{0,1002041053,1},1},{{0,1004041053,1},1},{{0,1006041053,1},1},{{0,1008041053,1},1},{{0,1010041053,1},1},{{0,1001041053,1},1}]','[]','[1002041053,1004041053,1006041053,1008041053,1010041053,1001041053]'),(32081056,0,1000,0,1,0,1,0,'[{{0,1007011053,1},1},{{0,1003001053,1},1},{{0,1005001053,1},1},{{0,1009001053,1},1}]','[]','[1007011053,1003001053,1005001053,1009001053]'),(32081056,0,1000,0,2,0,1,0,'[{{0,1007021053,1},1},{{0,1003001053,1},1},{{0,1005001053,1},1},{{0,1009001053,1},1}]','[]','[1007021053,1003001053,1005001053,1009001053]'),(32081056,0,1000,0,3,0,1,0,'[{{0,1007031053,1},1},{{0,1003001053,1},1},{{0,1005001053,1},1},{{0,1009001053,1},1}]','[]','[1007031053,1003001053,1005001053,1009001053]'),(32081056,0,1000,0,4,0,1,0,'[{{0,1007041053,1},1},{{0,1003001053,1},1},{{0,1005001053,1},1},{{0,1009001053,1},1}]','[]','[1007041053,1003001053,1005001053,1009001053]'),(32081057,0,1000,0,1,0,1,0,'[{{0,1007011053,1},1},{{0,1003001053,1},1}]','[]','[1007011053,1003001053]'),(32081057,0,1000,0,2,0,1,0,'[{{0,1007021053,1},1},{{0,1003001053,1},1}]','[]','[1007021053,1003001053]'),(32081057,0,1000,0,3,0,1,0,'[{{0,1007031053,1},1},{{0,1003001053,1},1}]','[]','[1007031053,1003001053]'),(32081057,0,1000,0,4,0,1,0,'[{{0,1007041053,1},1},{{0,1003001053,1},1}]','[]','[1007041053,1003001053]'),(32081058,0,1000,0,0,0,1,0,'[{{0,1005001053,1},1},{{0,1009001053,1},1}]','[]','[1005001053,1009001053]'),(32081061,0,1000,0,1,0,1,0,'[{{0,1001011063,1},1},{{0,1002011063,1},1},{{0,1003001063,1},1},{{0,1004011063,1},1},{{0,1006011063,1},1},{{0,1007011063,1},1},{{0,1008011063,1},1},{{0,1010011063,1},1}]','[]','[1001011063,1002011063,1003001063,1004011063,1005001063,1006011063,1007011063,1008011063,1009001063,1010011063]'),(32081061,0,1000,0,2,0,1,0,'[{{0,1001021063,1},1},{{0,1002021063,1},1},{{0,1003001063,1},1},{{0,1004021063,1},1},{{0,1006021063,1},1},{{0,1007021063,1},1},{{0,1008021063,1},1},{{0,1010021063,1},1}]','[]','[1001021063,1002021063,1003001063,1004021063,1005001063,1006021063,1007021063,1008021063,1009001063,1010021063]'),(32081061,0,1000,0,3,0,1,0,'[{{0,1001031063,1},1},{{0,1002031063,1},1},{{0,1003001063,1},1},{{0,1004031063,1},1},{{0,1006031063,1},1},{{0,1007031063,1},1},{{0,1008031063,1},1},{{0,1010031063,1},1}]','[]','[1001031063,1002031063,1003001063,1004031063,1005001063,1006031063,1007031063,1008031063,1009001063,1010031063]'),(32081061,0,1000,0,4,0,1,0,'[{{0,1001041063,1},1},{{0,1002041063,1},1},{{0,1003001063,1},1},{{0,1004041063,1},1},{{0,1006041063,1},1},{{0,1007041063,1},1},{{0,1008041063,1},1},{{0,1010041063,1},1}]','[]','[1001041063,1002041063,1003001063,1004041063,1005001063,1006041063,1007041063,1008041063,1009001063,1010041063]'),(32081062,0,1000,0,1,0,1,0,'[{{0,1002011063,1},1},{{0,1004011063,1},1},{{0,1006011063,1},1},{{0,1008011063,1},1},{{0,1010011063,1},1}]','[]','[1002011063,1004011063,1006011063,1008011063,1010011063]'),(32081062,0,1000,0,2,0,1,0,'[{{0,1002021063,1},1},{{0,1004021063,1},1},{{0,1006021063,1},1},{{0,1008021063,1},1},{{0,1010021063,1},1}]','[]','[1002021063,1004021063,1006021063,1008021063,1010021063]'),(32081062,0,1000,0,3,0,1,0,'[{{0,1002031063,1},1},{{0,1004031063,1},1},{{0,1006031063,1},1},{{0,1008031063,1},1},{{0,1010031063,1},1}]','[]','[1002031063,1004031063,1006031063,1008031063,1010031063]'),(32081062,0,1000,0,4,0,1,0,'[{{0,1002041063,1},1},{{0,1004041063,1},1},{{0,1006041063,1},1},{{0,1008041063,1},1},{{0,1010041063,1},1}]','[]','[1002041063,1004041063,1006041063,1008041063,1010041063]'),(32081063,0,1000,0,1,0,1,0,'[{{0,1001011063,1},1},{{0,1007011063,1},1}]','[]','[1001011063,1007011063]'),(32081063,0,1000,0,2,0,1,0,'[{{0,1001021063,1},1},{{0,1007021063,1},1}]','[]','[1001021063,1007021063]'),(32081063,0,1000,0,3,0,1,0,'[{{0,1001031063,1},1},{{0,1007031063,1},1}]','[]','[1001031063,1007031063]'),(32081063,0,1000,0,4,0,1,0,'[{{0,1001041063,1},1},{{0,1007041063,1},1}]','[]','[1001041063,1007041063]'),(32081065,0,1000,0,1,0,1,0,'[{{0,1002011063,1},1},{{0,1004011063,1},1},{{0,1006011063,1},1},{{0,1008011063,1},1},{{0,1010011063,1},1},{{0,1001011063,1},1}]','[]','[1002011063,1004011063,1006011063,1008011063,1010011063,1001011063]'),(32081065,0,1000,0,2,0,1,0,'[{{0,1002021063,1},1},{{0,1004021063,1},1},{{0,1006021063,1},1},{{0,1008021063,1},1},{{0,1010021063,1},1},{{0,1001021063,1},1}]','[]','[1002021063,1004021063,1006021063,1008021063,1010021063,1001021063]'),(32081065,0,1000,0,3,0,1,0,'[{{0,1002031063,1},1},{{0,1004031063,1},1},{{0,1006031063,1},1},{{0,1008031063,1},1},{{0,1010031063,1},1},{{0,1001031063,1},1}]','[]','[1002031063,1004031063,1006031063,1008031063,1010031063,1001031063]'),(32081065,0,1000,0,4,0,1,0,'[{{0,1002041063,1},1},{{0,1004041063,1},1},{{0,1006041063,1},1},{{0,1008041063,1},1},{{0,1010041063,1},1},{{0,1001041063,1},1}]','[]','[1002041063,1004041063,1006041063,1008041063,1010041063,1001041063]'),(32081066,0,1000,0,1,0,1,0,'[{{0,1007011063,1},1},{{0,1003001063,1},1},{{0,1005001063,1},1},{{0,1009001063,1},1}]','[]','[1007011063,1003001063,1005001063,1009001063]'),(32081066,0,1000,0,2,0,1,0,'[{{0,1007021063,1},1},{{0,1003001063,1},1},{{0,1005001063,1},1},{{0,1009001063,1},1}]','[]','[1007021063,1003001063,1005001063,1009001063]'),(32081066,0,1000,0,3,0,1,0,'[{{0,1007031063,1},1},{{0,1003001063,1},1},{{0,1005001063,1},1},{{0,1009001063,1},1}]','[]','[1007031063,1003001063,1005001063,1009001063]'),(32081066,0,1000,0,4,0,1,0,'[{{0,1007041063,1},1},{{0,1003001063,1},1},{{0,1005001063,1},1},{{0,1009001063,1},1}]','[]','[1007041063,1003001063,1005001063,1009001063]'),(32081067,0,1000,0,1,0,1,0,'[{{0,1007011063,1},1},{{0,1003001063,1},1}]','[]','[1007011063,1003001063]'),(32081067,0,1000,0,2,0,1,0,'[{{0,1007021063,1},1},{{0,1003001063,1},1}]','[]','[1007021063,1003001063]'),(32081067,0,1000,0,3,0,1,0,'[{{0,1007031063,1},1},{{0,1003001063,1},1}]','[]','[1007031063,1003001063]'),(32081067,0,1000,0,4,0,1,0,'[{{0,1007041063,1},1},{{0,1003001063,1},1}]','[]','[1007041063,1003001063]'),(32081068,0,1000,0,0,0,1,0,'[{{0,1005001063,1},1},{{0,1009001063,1},1}]','[]','[1005001063,1009001063]'),(32081071,0,1000,0,1,0,1,0,'[{{0,1001011000,1},1},{{0,1002011000,1},1},{{0,1003001000,1},1},{{0,1004011000,1},1},{{0,1006011000,1},1},{{0,1007011000,1},1},{{0,1008011000,1},1},{{0,1010011000,1},1}]','[]','[]'),(32081071,0,1000,0,2,0,1,0,'[{{0,1001021000,1},1},{{0,1002021000,1},1},{{0,1003001000,1},1},{{0,1004021000,1},1},{{0,1006021000,1},1},{{0,1007021000,1},1},{{0,1008021000,1},1},{{0,1010021000,1},1}]','[]','[]'),(32081071,0,1000,0,3,0,1,0,'[{{0,1001031000,1},1},{{0,1002031000,1},1},{{0,1003001000,1},1},{{0,1004031000,1},1},{{0,1006031000,1},1},{{0,1007031000,1},1},{{0,1008031000,1},1},{{0,1010031000,1},1}]','[]','[]'),(32081071,0,1000,0,4,0,1,0,'[{{0,1001041000,1},1},{{0,1002041000,1},1},{{0,1003001000,1},1},{{0,1004041000,1},1},{{0,1006041000,1},1},{{0,1007041000,1},1},{{0,1008041000,1},1},{{0,1010041000,1},1}]','[]','[]'),(32081072,0,1000,0,1,0,1,0,'[{{0,1002011000,1},1},{{0,1004011000,1},1},{{0,1006011000,1},1},{{0,1008011000,1},1},{{0,1010011000,1},1}]','[]','[]'),(32081072,0,1000,0,2,0,1,0,'[{{0,1002021000,1},1},{{0,1004021000,1},1},{{0,1006021000,1},1},{{0,1008021000,1},1},{{0,1010021000,1},1}]','[]','[]'),(32081072,0,1000,0,3,0,1,0,'[{{0,1002031000,1},1},{{0,1004031000,1},1},{{0,1006031000,1},1},{{0,1008031000,1},1},{{0,1010031000,1},1}]','[]','[]'),(32081072,0,1000,0,4,0,1,0,'[{{0,1002041000,1},1},{{0,1004041000,1},1},{{0,1006041000,1},1},{{0,1008041000,1},1},{{0,1010041000,1},1}]','[]','[]'),(32081073,0,1000,0,1,0,1,0,'[{{0,1001011000,1},1},{{0,1007011000,1},1}]','[]','[]'),(32081073,0,1000,0,2,0,1,0,'[{{0,1001021000,1},1},{{0,1007021000,1},1}]','[]','[]'),(32081073,0,1000,0,3,0,1,0,'[{{0,1001031000,1},1},{{0,1007031000,1},1}]','[]','[]'),(32081073,0,1000,0,4,0,1,0,'[{{0,1001041000,1},1},{{0,1007041000,1},1}]','[]','[]'),(32081075,0,1000,0,1,0,1,0,'[{{0,1002011000,1},1},{{0,1004011000,1},1},{{0,1006011000,1},1},{{0,1008011000,1},1},{{0,1010011000,1},1},{{0,1001011000,1},1}]','[]','[]'),(32081075,0,1000,0,2,0,1,0,'[{{0,1002021000,1},1},{{0,1004021000,1},1},{{0,1006021000,1},1},{{0,1008021000,1},1},{{0,1010021000,1},1},{{0,1001021000,1},1}]','[]','[]'),(32081075,0,1000,0,3,0,1,0,'[{{0,1002031000,1},1},{{0,1004031000,1},1},{{0,1006031000,1},1},{{0,1008031000,1},1},{{0,1010031000,1},1},{{0,1001031000,1},1}]','[]','[]'),(32081075,0,1000,0,4,0,1,0,'[{{0,1002041000,1},1},{{0,1004041000,1},1},{{0,1006041000,1},1},{{0,1008041000,1},1},{{0,1010041000,1},1},{{0,1001041000,1},1}]','[]','[]'),(32081076,0,1000,0,1,0,1,0,'[{{0,1007011000,1},1},{{0,1003001000,1},1},{{0,1005001000,1},1},{{0,1009001000,1},1}]','[]','[]'),(32081076,0,1000,0,2,0,1,0,'[{{0,1007021000,1},1},{{0,1003001000,1},1},{{0,1005001000,1},1},{{0,1009001000,1},1}]','[]','[]'),(32081076,0,1000,0,3,0,1,0,'[{{0,1007031000,1},1},{{0,1003001000,1},1},{{0,1005001000,1},1},{{0,1009001000,1},1}]','[]','[]'),(32081076,0,1000,0,4,0,1,0,'[{{0,1007041000,1},1},{{0,1003001000,1},1},{{0,1005001000,1},1},{{0,1009001000,1},1}]','[]','[]'),(32081077,0,1000,0,1,0,1,0,'[{{0,1007011000,1},1},{{0,1003001000,1},1}]','[]','[]'),(32081077,0,1000,0,2,0,1,0,'[{{0,1007021000,1},1},{{0,1003001000,1},1}]','[]','[]'),(32081077,0,1000,0,3,0,1,0,'[{{0,1007031000,1},1},{{0,1003001000,1},1}]','[]','[]'),(32081077,0,1000,0,4,0,1,0,'[{{0,1007041000,1},1},{{0,1003001000,1},1}]','[]','[]'),(32081078,0,1000,0,0,0,1,0,'[{{0,1005001000,1},1},{{0,1009001000,1},1}]','[]','[]'),(32081081,0,1000,0,1,0,1,0,'[{{0,1001011010,1},1},{{0,1002011010,1},1},{{0,1003001010,1},1},{{0,1004011010,1},1},{{0,1006011010,1},1},{{0,1007011010,1},1},{{0,1008011010,1},1},{{0,1010011010,1},1}]','[]','[]'),(32081081,0,1000,0,2,0,1,0,'[{{0,1001021010,1},1},{{0,1002021010,1},1},{{0,1003001010,1},1},{{0,1004021010,1},1},{{0,1006021010,1},1},{{0,1007021010,1},1},{{0,1008021010,1},1},{{0,1010021010,1},1}]','[]','[]'),(32081081,0,1000,0,3,0,1,0,'[{{0,1001031010,1},1},{{0,1002031010,1},1},{{0,1003001010,1},1},{{0,1004031010,1},1},{{0,1006031010,1},1},{{0,1007031010,1},1},{{0,1008031010,1},1},{{0,1010031010,1},1}]','[]','[]'),(32081081,0,1000,0,4,0,1,0,'[{{0,1001041010,1},1},{{0,1002041010,1},1},{{0,1003001010,1},1},{{0,1004041010,1},1},{{0,1006041010,1},1},{{0,1007041010,1},1},{{0,1008041010,1},1},{{0,1010041010,1},1}]','[]','[]'),(32081082,0,1000,0,1,0,1,0,'[{{0,1002011010,1},1},{{0,1004011010,1},1},{{0,1006011010,1},1},{{0,1008011010,1},1},{{0,1010011010,1},1}]','[]','[]'),(32081082,0,1000,0,2,0,1,0,'[{{0,1002021010,1},1},{{0,1004021010,1},1},{{0,1006021010,1},1},{{0,1008021010,1},1},{{0,1010021010,1},1}]','[]','[]'),(32081082,0,1000,0,3,0,1,0,'[{{0,1002031010,1},1},{{0,1004031010,1},1},{{0,1006031010,1},1},{{0,1008031010,1},1},{{0,1010031010,1},1}]','[]','[]'),(32081082,0,1000,0,4,0,1,0,'[{{0,1002041010,1},1},{{0,1004041010,1},1},{{0,1006041010,1},1},{{0,1008041010,1},1},{{0,1010041010,1},1}]','[]','[]'),(32081083,0,1000,0,1,0,1,0,'[{{0,1001011010,1},1},{{0,1007011010,1},1}]','[]','[]'),(32081083,0,1000,0,2,0,1,0,'[{{0,1001021010,1},1},{{0,1007021010,1},1}]','[]','[]'),(32081083,0,1000,0,3,0,1,0,'[{{0,1001031010,1},1},{{0,1007031010,1},1}]','[]','[]'),(32081083,0,1000,0,4,0,1,0,'[{{0,1001041010,1},1},{{0,1007041010,1},1}]','[]','[]'),(32081085,0,1000,0,1,0,1,0,'[{{0,1002011010,1},1},{{0,1004011010,1},1},{{0,1006011010,1},1},{{0,1008011010,1},1},{{0,1010011010,1},1},{{0,1001011010,1},1}]','[]','[]'),(32081085,0,1000,0,2,0,1,0,'[{{0,1002021010,1},1},{{0,1004021010,1},1},{{0,1006021010,1},1},{{0,1008021010,1},1},{{0,1010021010,1},1},{{0,1001021010,1},1}]','[]','[]'),(32081085,0,1000,0,3,0,1,0,'[{{0,1002031010,1},1},{{0,1004031010,1},1},{{0,1006031010,1},1},{{0,1008031010,1},1},{{0,1010031010,1},1},{{0,1001031010,1},1}]','[]','[]'),(32081085,0,1000,0,4,0,1,0,'[{{0,1002041010,1},1},{{0,1004041010,1},1},{{0,1006041010,1},1},{{0,1008041010,1},1},{{0,1010041010,1},1},{{0,1001041010,1},1}]','[]','[]'),(32081086,0,1000,0,1,0,1,0,'[{{0,1007011010,1},1},{{0,1003001010,1},1},{{0,1005001010,1},1},{{0,1009001010,1},1}]','[]','[]'),(32081086,0,1000,0,2,0,1,0,'[{{0,1007021010,1},1},{{0,1003001010,1},1},{{0,1005001010,1},1},{{0,1009001010,1},1}]','[]','[]'),(32081086,0,1000,0,3,0,1,0,'[{{0,1007031010,1},1},{{0,1003001010,1},1},{{0,1005001010,1},1},{{0,1009001010,1},1}]','[]','[]'),(32081086,0,1000,0,4,0,1,0,'[{{0,1007041010,1},1},{{0,1003001010,1},1},{{0,1005001010,1},1},{{0,1009001010,1},1}]','[]','[]'),(32081087,0,1000,0,1,0,1,0,'[{{0,1007011010,1},1},{{0,1003001010,1},1}]','[]','[]'),(32081087,0,1000,0,2,0,1,0,'[{{0,1007021010,1},1},{{0,1003001010,1},1}]','[]','[]'),(32081087,0,1000,0,3,0,1,0,'[{{0,1007031010,1},1},{{0,1003001010,1},1}]','[]','[]'),(32081087,0,1000,0,4,0,1,0,'[{{0,1007041010,1},1},{{0,1003001010,1},1}]','[]','[]'),(32081088,0,1000,0,0,0,1,0,'[{{0,1005001010,1},1},{{0,1009001010,1},1}]','[]','[]'),(32081091,0,1000,0,1,0,1,0,'[{{0,1001011020,1},1},{{0,1002011020,1},1},{{0,1003001020,1},1},{{0,1004011020,1},1},{{0,1006011020,1},1},{{0,1007011020,1},1},{{0,1008011020,1},1},{{0,1010011020,1},1}]','[]','[]'),(32081091,0,1000,0,2,0,1,0,'[{{0,1001021020,1},1},{{0,1002021020,1},1},{{0,1003001020,1},1},{{0,1004021020,1},1},{{0,1006021020,1},1},{{0,1007021020,1},1},{{0,1008021020,1},1},{{0,1010021020,1},1}]','[]','[]'),(32081091,0,1000,0,3,0,1,0,'[{{0,1001031020,1},1},{{0,1002031020,1},1},{{0,1003001020,1},1},{{0,1004031020,1},1},{{0,1006031020,1},1},{{0,1007031020,1},1},{{0,1008031020,1},1},{{0,1010031020,1},1}]','[]','[]'),(32081091,0,1000,0,4,0,1,0,'[{{0,1001041020,1},1},{{0,1002041020,1},1},{{0,1003001020,1},1},{{0,1004041020,1},1},{{0,1006041020,1},1},{{0,1007041020,1},1},{{0,1008041020,1},1},{{0,1010041020,1},1}]','[]','[]'),(32081092,0,1000,0,1,0,1,0,'[{{0,1002011020,1},1},{{0,1004011020,1},1},{{0,1006011020,1},1},{{0,1008011020,1},1},{{0,1010011020,1},1}]','[]','[]'),(32081092,0,1000,0,2,0,1,0,'[{{0,1002021020,1},1},{{0,1004021020,1},1},{{0,1006021020,1},1},{{0,1008021020,1},1},{{0,1010021020,1},1}]','[]','[]'),(32081092,0,1000,0,3,0,1,0,'[{{0,1002031020,1},1},{{0,1004031020,1},1},{{0,1006031020,1},1},{{0,1008031020,1},1},{{0,1010031020,1},1}]','[]','[]'),(32081092,0,1000,0,4,0,1,0,'[{{0,1002041020,1},1},{{0,1004041020,1},1},{{0,1006041020,1},1},{{0,1008041020,1},1},{{0,1010041020,1},1}]','[]','[]'),(32081093,0,1000,0,1,0,1,0,'[{{0,1001011020,1},1},{{0,1007011020,1},1}]','[]','[]'),(32081093,0,1000,0,2,0,1,0,'[{{0,1001021020,1},1},{{0,1007021020,1},1}]','[]','[]'),(32081093,0,1000,0,3,0,1,0,'[{{0,1001031020,1},1},{{0,1007031020,1},1}]','[]','[]'),(32081093,0,1000,0,4,0,1,0,'[{{0,1001041020,1},1},{{0,1007041020,1},1}]','[]','[]'),(32081095,0,1000,0,1,0,1,0,'[{{0,1002011020,1},1},{{0,1004011020,1},1},{{0,1006011020,1},1},{{0,1008011020,1},1},{{0,1010011020,1},1},{{0,1001011020,1},1}]','[]','[]'),(32081095,0,1000,0,2,0,1,0,'[{{0,1002021020,1},1},{{0,1004021020,1},1},{{0,1006021020,1},1},{{0,1008021020,1},1},{{0,1010021020,1},1},{{0,1001021020,1},1}]','[]','[]'),(32081095,0,1000,0,3,0,1,0,'[{{0,1002031020,1},1},{{0,1004031020,1},1},{{0,1006031020,1},1},{{0,1008031020,1},1},{{0,1010031020,1},1},{{0,1001031020,1},1}]','[]','[]'),(32081095,0,1000,0,4,0,1,0,'[{{0,1002041020,1},1},{{0,1004041020,1},1},{{0,1006041020,1},1},{{0,1008041020,1},1},{{0,1010041020,1},1},{{0,1001041020,1},1}]','[]','[]'),(32081096,0,1000,0,1,0,1,0,'[{{0,1007011020,1},1},{{0,1003001020,1},1},{{0,1005001020,1},1},{{0,1009001020,1},1}]','[]','[]'),(32081096,0,1000,0,2,0,1,0,'[{{0,1007021020,1},1},{{0,1003001020,1},1},{{0,1005001020,1},1},{{0,1009001020,1},1}]','[]','[]'),(32081096,0,1000,0,3,0,1,0,'[{{0,1007031020,1},1},{{0,1003001020,1},1},{{0,1005001020,1},1},{{0,1009001020,1},1}]','[]','[]'),(32081096,0,1000,0,4,0,1,0,'[{{0,1007041020,1},1},{{0,1003001020,1},1},{{0,1005001020,1},1},{{0,1009001020,1},1}]','[]','[]'),(32081097,0,1000,0,1,0,1,0,'[{{0,1007011020,1},1},{{0,1003001020,1},1}]','[]','[]'),(32081097,0,1000,0,2,0,1,0,'[{{0,1007021020,1},1},{{0,1003001020,1},1}]','[]','[]'),(32081097,0,1000,0,3,0,1,0,'[{{0,1007031020,1},1},{{0,1003001020,1},1}]','[]','[]'),(32081097,0,1000,0,4,0,1,0,'[{{0,1007041020,1},1},{{0,1003001020,1},1}]','[]','[]'),(32081098,0,1000,0,0,0,1,0,'[{{0,1005001020,1},1},{{0,1009001020,1},1}]','[]','[]'),(32081101,0,1000,0,1,0,1,0,'[{{0,1001011031,1},1},{{0,1002011031,1},1},{{0,1003001031,1},1},{{0,1004011031,1},1},{{0,1006011031,1},1},{{0,1007011031,1},1},{{0,1008011031,1},1},{{0,1010011031,1},1}]','[]','[]'),(32081101,0,1000,0,2,0,1,0,'[{{0,1001021031,1},1},{{0,1002021031,1},1},{{0,1003001031,1},1},{{0,1004021031,1},1},{{0,1006021031,1},1},{{0,1007021031,1},1},{{0,1008021031,1},1},{{0,1010021031,1},1}]','[]','[]'),(32081101,0,1000,0,3,0,1,0,'[{{0,1001031031,1},1},{{0,1002031031,1},1},{{0,1003001031,1},1},{{0,1004031031,1},1},{{0,1006031031,1},1},{{0,1007031031,1},1},{{0,1008031031,1},1},{{0,1010031031,1},1}]','[]','[]'),(32081101,0,1000,0,4,0,1,0,'[{{0,1001041031,1},1},{{0,1002041031,1},1},{{0,1003001031,1},1},{{0,1004041031,1},1},{{0,1006041031,1},1},{{0,1007041031,1},1},{{0,1008041031,1},1},{{0,1010041031,1},1}]','[]','[]'),(32081102,0,1000,0,1,0,1,0,'[{{0,1002011031,1},1},{{0,1004011031,1},1},{{0,1006011031,1},1},{{0,1008011031,1},1},{{0,1010011031,1},1}]','[]','[]'),(32081102,0,1000,0,2,0,1,0,'[{{0,1002021031,1},1},{{0,1004021031,1},1},{{0,1006021031,1},1},{{0,1008021031,1},1},{{0,1010021031,1},1}]','[]','[]'),(32081102,0,1000,0,3,0,1,0,'[{{0,1002031031,1},1},{{0,1004031031,1},1},{{0,1006031031,1},1},{{0,1008031031,1},1},{{0,1010031031,1},1}]','[]','[]'),(32081102,0,1000,0,4,0,1,0,'[{{0,1002041031,1},1},{{0,1004041031,1},1},{{0,1006041031,1},1},{{0,1008041031,1},1},{{0,1010041031,1},1}]','[]','[]'),(32081103,0,1000,0,1,0,1,0,'[{{0,1001011031,1},1},{{0,1007011031,1},1}]','[]','[]'),(32081103,0,1000,0,2,0,1,0,'[{{0,1001021031,1},1},{{0,1007021031,1},1}]','[]','[]'),(32081103,0,1000,0,3,0,1,0,'[{{0,1001031031,1},1},{{0,1007031031,1},1}]','[]','[]'),(32081103,0,1000,0,4,0,1,0,'[{{0,1001041031,1},1},{{0,1007041031,1},1}]','[]','[]'),(32081105,0,1000,0,1,0,1,0,'[{{0,1002011031,1},1},{{0,1004011031,1},1},{{0,1006011031,1},1},{{0,1008011031,1},1},{{0,1010011031,1},1},{{0,1001011031,1},1}]','[]','[]'),(32081105,0,1000,0,2,0,1,0,'[{{0,1002021031,1},1},{{0,1004021031,1},1},{{0,1006021031,1},1},{{0,1008021031,1},1},{{0,1010021031,1},1},{{0,1001021031,1},1}]','[]','[]'),(32081105,0,1000,0,3,0,1,0,'[{{0,1002031031,1},1},{{0,1004031031,1},1},{{0,1006031031,1},1},{{0,1008031031,1},1},{{0,1010031031,1},1},{{0,1001031031,1},1}]','[]','[]'),(32081105,0,1000,0,4,0,1,0,'[{{0,1002041031,1},1},{{0,1004041031,1},1},{{0,1006041031,1},1},{{0,1008041031,1},1},{{0,1010041031,1},1},{{0,1001041031,1},1}]','[]','[]'),(32081106,0,1000,0,1,0,1,0,'[{{0,1007011031,1},1},{{0,1003001031,1},1},{{0,1005001031,1},1},{{0,1009001031,1},1}]','[]','[]'),(32081106,0,1000,0,2,0,1,0,'[{{0,1007021031,1},1},{{0,1003001031,1},1},{{0,1005001031,1},1},{{0,1009001031,1},1}]','[]','[]'),(32081106,0,1000,0,3,0,1,0,'[{{0,1007031031,1},1},{{0,1003001031,1},1},{{0,1005001031,1},1},{{0,1009001031,1},1}]','[]','[]'),(32081106,0,1000,0,4,0,1,0,'[{{0,1007041031,1},1},{{0,1003001031,1},1},{{0,1005001031,1},1},{{0,1009001031,1},1}]','[]','[]'),(32081107,0,1000,0,1,0,1,0,'[{{0,1007011031,1},1},{{0,1003001031,1},1}]','[]','[]'),(32081107,0,1000,0,2,0,1,0,'[{{0,1007021031,1},1},{{0,1003001031,1},1}]','[]','[]'),(32081107,0,1000,0,3,0,1,0,'[{{0,1007031031,1},1},{{0,1003001031,1},1}]','[]','[]'),(32081107,0,1000,0,4,0,1,0,'[{{0,1007041031,1},1},{{0,1003001031,1},1}]','[]','[]'),(32081108,0,1000,0,0,0,1,0,'[{{0,1005001031,1},1},{{0,1009001031,1},1}]','[]','[]'),(32081111,0,1000,0,1,0,1,0,'[{{0,1001011132,1},1},{{0,1002011132,1},1},{{0,1003001132,1},1},{{0,1004011132,1},1},{{0,1006011132,1},1},{{0,1007011132,1},1},{{0,1008011132,1},1},{{0,1010011132,1},1}]','[]','[1001011132,1002011132,1003001132,1004011132,1005001132,1006011132,1007011132,1008011132,1009001132,1010011132]'),(32081111,0,1000,0,2,0,1,0,'[{{0,1001021132,1},1},{{0,1002021132,1},1},{{0,1003001132,1},1},{{0,1004021132,1},1},{{0,1006021132,1},1},{{0,1007021132,1},1},{{0,1008021132,1},1},{{0,1010021132,1},1}]','[]','[1001021132,1002021132,1003001132,1004021132,1005001132,1006021132,1007021132,1008021132,1009001132,1010021132]'),(32081111,0,1000,0,3,0,1,0,'[{{0,1001031132,1},1},{{0,1002031132,1},1},{{0,1003001132,1},1},{{0,1004031132,1},1},{{0,1006031132,1},1},{{0,1007031132,1},1},{{0,1008031132,1},1},{{0,1010031132,1},1}]','[]','[1001031132,1002031132,1003001132,1004031132,1005001132,1006031132,1007031132,1008031132,1009001132,1010031132]'),(32081111,0,1000,0,4,0,1,0,'[{{0,1001041132,1},1},{{0,1002041132,1},1},{{0,1003001132,1},1},{{0,1004041132,1},1},{{0,1006041132,1},1},{{0,1007041132,1},1},{{0,1008041132,1},1},{{0,1010041132,1},1}]','[]','[1001041132,1002041132,1003001132,1004041132,1005001132,1006041132,1007041132,1008041132,1009001132,1010041132]'),(32081112,0,1000,0,1,0,1,0,'[{{0,1002011132,1},1},{{0,1004011132,1},1},{{0,1006011132,1},1},{{0,1008011132,1},1},{{0,1010011132,1},1}]','[]','[1002011132,1004011132,1006011132,1008011132,1010011132]'),(32081112,0,1000,0,2,0,1,0,'[{{0,1002021132,1},1},{{0,1004021132,1},1},{{0,1006021132,1},1},{{0,1008021132,1},1},{{0,1010021132,1},1}]','[]','[1002021132,1004021132,1006021132,1008021132,1010021132]'),(32081112,0,1000,0,3,0,1,0,'[{{0,1002031132,1},1},{{0,1004031132,1},1},{{0,1006031132,1},1},{{0,1008031132,1},1},{{0,1010031132,1},1}]','[]','[1002031132,1004031132,1006031132,1008031132,1010031132]'),(32081112,0,1000,0,4,0,1,0,'[{{0,1002041132,1},1},{{0,1004041132,1},1},{{0,1006041132,1},1},{{0,1008041132,1},1},{{0,1010041132,1},1}]','[]','[1002041132,1004041132,1006041132,1008041132,1010041132]'),(32081113,0,1000,0,1,0,1,0,'[{{0,1001011132,1},1},{{0,1007011132,1},1}]','[]','[1001011132,1007011132]'),(32081113,0,1000,0,2,0,1,0,'[{{0,1001021132,1},1},{{0,1007021132,1},1}]','[]','[1001021132,1007021132]'),(32081113,0,1000,0,3,0,1,0,'[{{0,1001031132,1},1},{{0,1007031132,1},1}]','[]','[1001031132,1007031132]'),(32081113,0,1000,0,4,0,1,0,'[{{0,1001041132,1},1},{{0,1007041132,1},1}]','[]','[1001041132,1007041132]'),(32081115,0,1000,0,1,0,1,0,'[{{0,1002011132,1},1},{{0,1004011132,1},1},{{0,1006011132,1},1},{{0,1008011132,1},1},{{0,1010011132,1},1},{{0,1001011132,1},1}]','[]','[1002011132,1004011132,1006011132,1008011132,1010011132,1001011132]'),(32081115,0,1000,0,2,0,1,0,'[{{0,1002021132,1},1},{{0,1004021132,1},1},{{0,1006021132,1},1},{{0,1008021132,1},1},{{0,1010021132,1},1},{{0,1001021132,1},1}]','[]','[1002021132,1004021132,1006021132,1008021132,1010021132,1001021132]'),(32081115,0,1000,0,3,0,1,0,'[{{0,1002031132,1},1},{{0,1004031132,1},1},{{0,1006031132,1},1},{{0,1008031132,1},1},{{0,1010031132,1},1},{{0,1001031132,1},1}]','[]','[1002031132,1004031132,1006031132,1008031132,1010031132,1001031132]'),(32081115,0,1000,0,4,0,1,0,'[{{0,1002041132,1},1},{{0,1004041132,1},1},{{0,1006041132,1},1},{{0,1008041132,1},1},{{0,1010041132,1},1},{{0,1001041132,1},1}]','[]','[1002041132,1004041132,1006041132,1008041132,1010041132,1001041132]'),(32081116,0,1000,0,1,0,1,0,'[{{0,1007011132,1},1},{{0,1003001132,1},1},{{0,1005001132,1},1},{{0,1009001132,1},1}]','[]','[1007011132,1003001132,1005001132,1009001132]'),(32081116,0,1000,0,2,0,1,0,'[{{0,1007021132,1},1},{{0,1003001132,1},1},{{0,1005001132,1},1},{{0,1009001132,1},1}]','[]','[1007021132,1003001132,1005001132,1009001132]'),(32081116,0,1000,0,3,0,1,0,'[{{0,1007031132,1},1},{{0,1003001132,1},1},{{0,1005001132,1},1},{{0,1009001132,1},1}]','[]','[1007031132,1003001132,1005001132,1009001132]'),(32081116,0,1000,0,4,0,1,0,'[{{0,1007041132,1},1},{{0,1003001132,1},1},{{0,1005001132,1},1},{{0,1009001132,1},1}]','[]','[1007041132,1003001132,1005001132,1009001132]'),(32081117,0,1000,0,1,0,1,0,'[{{0,1007011132,1},1},{{0,1003001132,1},1}]','[]','[1007011132,1003001132]'),(32081117,0,1000,0,2,0,1,0,'[{{0,1007021132,1},1},{{0,1003001132,1},1}]','[]','[1007021132,1003001132]'),(32081117,0,1000,0,3,0,1,0,'[{{0,1007031132,1},1},{{0,1003001132,1},1}]','[]','[1007031132,1003001132]'),(32081117,0,1000,0,4,0,1,0,'[{{0,1007041132,1},1},{{0,1003001132,1},1}]','[]','[1007041132,1003001132]'),(32081118,0,1000,0,0,0,1,0,'[{{0,1005001132,1},1},{{0,1009001132,1},1}]','[]','[1005001132,1009001132]'),(32081121,0,1000,0,1,0,1,0,'[{{0,1001011141,1},1},{{0,1002011141,1},1},{{0,1003001141,1},1},{{0,1004011141,1},1},{{0,1006011141,1},1},{{0,1007011141,1},1},{{0,1008011141,1},1},{{0,1010011141,1},1}]','[]','[]'),(32081121,0,1000,0,2,0,1,0,'[{{0,1001021141,1},1},{{0,1002021141,1},1},{{0,1003001141,1},1},{{0,1004021141,1},1},{{0,1006021141,1},1},{{0,1007021141,1},1},{{0,1008021141,1},1},{{0,1010021141,1},1}]','[]','[]'),(32081121,0,1000,0,3,0,1,0,'[{{0,1001031141,1},1},{{0,1002031141,1},1},{{0,1003001141,1},1},{{0,1004031141,1},1},{{0,1006031141,1},1},{{0,1007031141,1},1},{{0,1008031141,1},1},{{0,1010031141,1},1}]','[]','[]'),(32081121,0,1000,0,4,0,1,0,'[{{0,1001041141,1},1},{{0,1002041141,1},1},{{0,1003001141,1},1},{{0,1004041141,1},1},{{0,1006041141,1},1},{{0,1007041141,1},1},{{0,1008041141,1},1},{{0,1010041141,1},1}]','[]','[]'),(32081122,0,1000,0,1,0,1,0,'[{{0,1002011141,1},1},{{0,1004011141,1},1},{{0,1006011141,1},1},{{0,1008011141,1},1},{{0,1010011141,1},1}]','[]','[]'),(32081122,0,1000,0,2,0,1,0,'[{{0,1002021141,1},1},{{0,1004021141,1},1},{{0,1006021141,1},1},{{0,1008021141,1},1},{{0,1010021141,1},1}]','[]','[]'),(32081122,0,1000,0,3,0,1,0,'[{{0,1002031141,1},1},{{0,1004031141,1},1},{{0,1006031141,1},1},{{0,1008031141,1},1},{{0,1010031141,1},1}]','[]','[]'),(32081122,0,1000,0,4,0,1,0,'[{{0,1002041141,1},1},{{0,1004041141,1},1},{{0,1006041141,1},1},{{0,1008041141,1},1},{{0,1010041141,1},1}]','[]','[]'),(32081123,0,1000,0,1,0,1,0,'[{{0,1001011141,1},1},{{0,1007011141,1},1}]','[]','[]'),(32081123,0,1000,0,2,0,1,0,'[{{0,1001021141,1},1},{{0,1007021141,1},1}]','[]','[]'),(32081123,0,1000,0,3,0,1,0,'[{{0,1001031141,1},1},{{0,1007031141,1},1}]','[]','[]'),(32081123,0,1000,0,4,0,1,0,'[{{0,1001041141,1},1},{{0,1007041141,1},1}]','[]','[]'),(32081125,0,1000,0,1,0,1,0,'[{{0,1002011141,1},1},{{0,1004011141,1},1},{{0,1006011141,1},1},{{0,1008011141,1},1},{{0,1010011141,1},1},{{0,1001011141,1},1}]','[]','[]'),(32081125,0,1000,0,2,0,1,0,'[{{0,1002021141,1},1},{{0,1004021141,1},1},{{0,1006021141,1},1},{{0,1008021141,1},1},{{0,1010021141,1},1},{{0,1001021141,1},1}]','[]','[]'),(32081125,0,1000,0,3,0,1,0,'[{{0,1002031141,1},1},{{0,1004031141,1},1},{{0,1006031141,1},1},{{0,1008031141,1},1},{{0,1010031141,1},1},{{0,1001031141,1},1}]','[]','[]'),(32081125,0,1000,0,4,0,1,0,'[{{0,1002041141,1},1},{{0,1004041141,1},1},{{0,1006041141,1},1},{{0,1008041141,1},1},{{0,1010041141,1},1},{{0,1001041141,1},1}]','[]','[]'),(32081126,0,1000,0,1,0,1,0,'[{{0,1007011141,1},1},{{0,1003001141,1},1},{{0,1005001141,1},1},{{0,1009001141,1},1}]','[]','[]'),(32081126,0,1000,0,2,0,1,0,'[{{0,1007021141,1},1},{{0,1003001141,1},1},{{0,1005001141,1},1},{{0,1009001141,1},1}]','[]','[]'),(32081126,0,1000,0,3,0,1,0,'[{{0,1007031141,1},1},{{0,1003001141,1},1},{{0,1005001141,1},1},{{0,1009001141,1},1}]','[]','[]'),(32081126,0,1000,0,4,0,1,0,'[{{0,1007041141,1},1},{{0,1003001141,1},1},{{0,1005001141,1},1},{{0,1009001141,1},1}]','[]','[]'),(32081127,0,1000,0,1,0,1,0,'[{{0,1007011141,1},1},{{0,1003001141,1},1}]','[]','[]'),(32081127,0,1000,0,2,0,1,0,'[{{0,1007021141,1},1},{{0,1003001141,1},1}]','[]','[]'),(32081127,0,1000,0,3,0,1,0,'[{{0,1007031141,1},1},{{0,1003001141,1},1}]','[]','[]'),(32081127,0,1000,0,4,0,1,0,'[{{0,1007041141,1},1},{{0,1003001141,1},1}]','[]','[]'),(32081128,0,1000,0,0,0,1,0,'[{{0,1005001141,1},1},{{0,1009001141,1},1}]','[]','[]'),(32081131,0,1000,0,1,0,1,0,'[{{0,1001011142,1},1},{{0,1002011142,1},1},{{0,1003001142,1},1},{{0,1004011142,1},1},{{0,1006011142,1},1},{{0,1007011142,1},1},{{0,1008011142,1},1},{{0,1010011142,1},1}]','[]','[1001011142,1002011142,1003001142,1004011142,1005001142,1006011142,1007011142,1008011142,1009001142,1010011142]'),(32081131,0,1000,0,2,0,1,0,'[{{0,1001021142,1},1},{{0,1002021142,1},1},{{0,1003001142,1},1},{{0,1004021142,1},1},{{0,1006021142,1},1},{{0,1007021142,1},1},{{0,1008021142,1},1},{{0,1010021142,1},1}]','[]','[1001021142,1002021142,1003001142,1004021142,1005001142,1006021142,1007021142,1008021142,1009001142,1010021142]'),(32081131,0,1000,0,3,0,1,0,'[{{0,1001031142,1},1},{{0,1002031142,1},1},{{0,1003001142,1},1},{{0,1004031142,1},1},{{0,1006031142,1},1},{{0,1007031142,1},1},{{0,1008031142,1},1},{{0,1010031142,1},1}]','[]','[1001031142,1002031142,1003001142,1004031142,1005001142,1006031142,1007031142,1008031142,1009001142,1010031142]'),(32081131,0,1000,0,4,0,1,0,'[{{0,1001041142,1},1},{{0,1002041142,1},1},{{0,1003001142,1},1},{{0,1004041142,1},1},{{0,1006041142,1},1},{{0,1007041142,1},1},{{0,1008041142,1},1},{{0,1010041142,1},1}]','[]','[1001041142,1002041142,1003001142,1004041142,1005001142,1006041142,1007041142,1008041142,1009001142,1010041142]'),(32081132,0,1000,0,1,0,1,0,'[{{0,1002011142,1},1},{{0,1004011142,1},1},{{0,1006011142,1},1},{{0,1008011142,1},1},{{0,1010011142,1},1}]','[]','[1002011142,1004011142,1006011142,1008011142,1010011142]'),(32081132,0,1000,0,2,0,1,0,'[{{0,1002021142,1},1},{{0,1004021142,1},1},{{0,1006021142,1},1},{{0,1008021142,1},1},{{0,1010021142,1},1}]','[]','[1002021142,1004021142,1006021142,1008021142,1010021142]'),(32081132,0,1000,0,3,0,1,0,'[{{0,1002031142,1},1},{{0,1004031142,1},1},{{0,1006031142,1},1},{{0,1008031142,1},1},{{0,1010031142,1},1}]','[]','[1002031142,1004031142,1006031142,1008031142,1010031142]'),(32081132,0,1000,0,4,0,1,0,'[{{0,1002041142,1},1},{{0,1004041142,1},1},{{0,1006041142,1},1},{{0,1008041142,1},1},{{0,1010041142,1},1}]','[]','[1002041142,1004041142,1006041142,1008041142,1010041142]'),(32081133,0,1000,0,1,0,1,0,'[{{0,1001011142,1},1},{{0,1007011142,1},1}]','[]','[1001011142,1007011142]'),(32081133,0,1000,0,2,0,1,0,'[{{0,1001021142,1},1},{{0,1007021142,1},1}]','[]','[1001021142,1007021142]'),(32081133,0,1000,0,3,0,1,0,'[{{0,1001031142,1},1},{{0,1007031142,1},1}]','[]','[1001031142,1007031142]'),(32081133,0,1000,0,4,0,1,0,'[{{0,1001041142,1},1},{{0,1007041142,1},1}]','[]','[1001041142,1007041142]'),(32081135,0,1000,0,1,0,1,0,'[{{0,1002011142,1},1},{{0,1004011142,1},1},{{0,1006011142,1},1},{{0,1008011142,1},1},{{0,1010011142,1},1},{{0,1001011142,1},1}]','[]','[1002011142,1004011142,1006011142,1008011142,1010011142,1001011142]'),(32081135,0,1000,0,2,0,1,0,'[{{0,1002021142,1},1},{{0,1004021142,1},1},{{0,1006021142,1},1},{{0,1008021142,1},1},{{0,1010021142,1},1},{{0,1001021142,1},1}]','[]','[1002021142,1004021142,1006021142,1008021142,1010021142,1001021142]'),(32081135,0,1000,0,3,0,1,0,'[{{0,1002031142,1},1},{{0,1004031142,1},1},{{0,1006031142,1},1},{{0,1008031142,1},1},{{0,1010031142,1},1},{{0,1001031142,1},1}]','[]','[1002031142,1004031142,1006031142,1008031142,1010031142,1001031142]'),(32081135,0,1000,0,4,0,1,0,'[{{0,1002041142,1},1},{{0,1004041142,1},1},{{0,1006041142,1},1},{{0,1008041142,1},1},{{0,1010041142,1},1},{{0,1001041142,1},1}]','[]','[1002041142,1004041142,1006041142,1008041142,1010041142,1001041142]'),(32081136,0,1000,0,1,0,1,0,'[{{0,1007011142,1},1},{{0,1003001142,1},1},{{0,1005001142,1},1},{{0,1009001142,1},1}]','[]','[1007011142,1003001142,1005001142,1009001142]'),(32081136,0,1000,0,2,0,1,0,'[{{0,1007021142,1},1},{{0,1003001142,1},1},{{0,1005001142,1},1},{{0,1009001142,1},1}]','[]','[1007021142,1003001142,1005001142,1009001142]'),(32081136,0,1000,0,3,0,1,0,'[{{0,1007031142,1},1},{{0,1003001142,1},1},{{0,1005001142,1},1},{{0,1009001142,1},1}]','[]','[1007031142,1003001142,1005001142,1009001142]'),(32081136,0,1000,0,4,0,1,0,'[{{0,1007041142,1},1},{{0,1003001142,1},1},{{0,1005001142,1},1},{{0,1009001142,1},1}]','[]','[1007041142,1003001142,1005001142,1009001142]'),(32081137,0,1000,0,1,0,1,0,'[{{0,1007011142,1},1},{{0,1003001142,1},1}]','[]','[1007011142,1003001142]'),(32081137,0,1000,0,2,0,1,0,'[{{0,1007021142,1},1},{{0,1003001142,1},1}]','[]','[1007021142,1003001142]'),(32081137,0,1000,0,3,0,1,0,'[{{0,1007031142,1},1},{{0,1003001142,1},1}]','[]','[1007031142,1003001142]'),(32081137,0,1000,0,4,0,1,0,'[{{0,1007041142,1},1},{{0,1003001142,1},1}]','[]','[1007041142,1003001142]'),(32081138,0,1000,0,0,0,1,0,'[{{0,1005001142,1},1},{{0,1009001142,1},1}]','[]','[1005001142,1009001142]'),(32081141,0,1000,0,1,0,1,0,'[{{0,1001011143,1},1},{{0,1002011143,1},1},{{0,1003001143,1},1},{{0,1004011143,1},1},{{0,1006011143,1},1},{{0,1007011143,1},1},{{0,1008011143,1},1},{{0,1010011143,1},1}]','[]','[1001011143,1002011143,1003001143,1004011143,1005001143,1006011143,1007011143,1008011143,1009001143,1010011143]'),(32081141,0,1000,0,2,0,1,0,'[{{0,1001021143,1},1},{{0,1002021143,1},1},{{0,1003001143,1},1},{{0,1004021143,1},1},{{0,1006021143,1},1},{{0,1007021143,1},1},{{0,1008021143,1},1},{{0,1010021143,1},1}]','[]','[1001021143,1002021143,1003001143,1004021143,1005001143,1006021143,1007021143,1008021143,1009001143,1010021143]'),(32081141,0,1000,0,3,0,1,0,'[{{0,1001031143,1},1},{{0,1002031143,1},1},{{0,1003001143,1},1},{{0,1004031143,1},1},{{0,1006031143,1},1},{{0,1007031143,1},1},{{0,1008031143,1},1},{{0,1010031143,1},1}]','[]','[1001031143,1002031143,1003001143,1004031143,1005001143,1006031143,1007031143,1008031143,1009001143,1010031143]'),(32081141,0,1000,0,4,0,1,0,'[{{0,1001041143,1},1},{{0,1002041143,1},1},{{0,1003001143,1},1},{{0,1004041143,1},1},{{0,1006041143,1},1},{{0,1007041143,1},1},{{0,1008041143,1},1},{{0,1010041143,1},1}]','[]','[1001041143,1002041143,1003001143,1004041143,1005001143,1006041143,1007041143,1008041143,1009001143,1010041143]'),(32081142,0,1000,0,1,0,1,0,'[{{0,1002011143,1},1},{{0,1004011143,1},1},{{0,1006011143,1},1},{{0,1008011143,1},1},{{0,1010011143,1},1}]','[]','[1002011143,1004011143,1006011143,1008011143,1010011143]'),(32081142,0,1000,0,2,0,1,0,'[{{0,1002021143,1},1},{{0,1004021143,1},1},{{0,1006021143,1},1},{{0,1008021143,1},1},{{0,1010021143,1},1}]','[]','[1002021143,1004021143,1006021143,1008021143,1010021143]'),(32081142,0,1000,0,3,0,1,0,'[{{0,1002031143,1},1},{{0,1004031143,1},1},{{0,1006031143,1},1},{{0,1008031143,1},1},{{0,1010031143,1},1}]','[]','[1002031143,1004031143,1006031143,1008031143,1010031143]'),(32081142,0,1000,0,4,0,1,0,'[{{0,1002041143,1},1},{{0,1004041143,1},1},{{0,1006041143,1},1},{{0,1008041143,1},1},{{0,1010041143,1},1}]','[]','[1002041143,1004041143,1006041143,1008041143,1010041143]'),(32081143,0,1000,0,1,0,1,0,'[{{0,1001011143,1},1},{{0,1007011143,1},1}]','[]','[1001011143,1007011143]'),(32081143,0,1000,0,2,0,1,0,'[{{0,1001021143,1},1},{{0,1007021143,1},1}]','[]','[1001021143,1007021143]'),(32081143,0,1000,0,3,0,1,0,'[{{0,1001031143,1},1},{{0,1007031143,1},1}]','[]','[1001031143,1007031143]'),(32081143,0,1000,0,4,0,1,0,'[{{0,1001041143,1},1},{{0,1007041143,1},1}]','[]','[1001041143,1007041143]'),(32081145,0,1000,0,1,0,1,0,'[{{0,1002011143,1},1},{{0,1004011143,1},1},{{0,1006011143,1},1},{{0,1008011143,1},1},{{0,1010011143,1},1},{{0,1001011143,1},1}]','[]','[1002011143,1004011143,1006011143,1008011143,1010011143,1001011143]'),(32081145,0,1000,0,2,0,1,0,'[{{0,1002021143,1},1},{{0,1004021143,1},1},{{0,1006021143,1},1},{{0,1008021143,1},1},{{0,1010021143,1},1},{{0,1001021143,1},1}]','[]','[1002021143,1004021143,1006021143,1008021143,1010021143,1001021143]'),(32081145,0,1000,0,3,0,1,0,'[{{0,1002031143,1},1},{{0,1004031143,1},1},{{0,1006031143,1},1},{{0,1008031143,1},1},{{0,1010031143,1},1},{{0,1001031143,1},1}]','[]','[1002031143,1004031143,1006031143,1008031143,1010031143,1001031143]'),(32081145,0,1000,0,4,0,1,0,'[{{0,1002041143,1},1},{{0,1004041143,1},1},{{0,1006041143,1},1},{{0,1008041143,1},1},{{0,1010041143,1},1},{{0,1001041143,1},1}]','[]','[1002041143,1004041143,1006041143,1008041143,1010041143,1001041143]'),(32081146,0,1000,0,1,0,1,0,'[{{0,1007011143,1},1},{{0,1003001143,1},1},{{0,1005001143,1},1},{{0,1009001143,1},1}]','[]','[1007011143,1003001143,1005001143,1009001143]'),(32081146,0,1000,0,2,0,1,0,'[{{0,1007021143,1},1},{{0,1003001143,1},1},{{0,1005001143,1},1},{{0,1009001143,1},1}]','[]','[1007021143,1003001143,1005001143,1009001143]'),(32081146,0,1000,0,3,0,1,0,'[{{0,1007031143,1},1},{{0,1003001143,1},1},{{0,1005001143,1},1},{{0,1009001143,1},1}]','[]','[1007031143,1003001143,1005001143,1009001143]'),(32081146,0,1000,0,4,0,1,0,'[{{0,1007041143,1},1},{{0,1003001143,1},1},{{0,1005001143,1},1},{{0,1009001143,1},1}]','[]','[1007041143,1003001143,1005001143,1009001143]'),(32081147,0,1000,0,1,0,1,0,'[{{0,1007011143,1},1},{{0,1003001143,1},1}]','[]','[1007011143,1003001143]'),(32081147,0,1000,0,2,0,1,0,'[{{0,1007021143,1},1},{{0,1003001143,1},1}]','[]','[1007021143,1003001143]'),(32081147,0,1000,0,3,0,1,0,'[{{0,1007031143,1},1},{{0,1003001143,1},1}]','[]','[1007031143,1003001143]'),(32081147,0,1000,0,4,0,1,0,'[{{0,1007041143,1},1},{{0,1003001143,1},1}]','[]','[1007041143,1003001143]'),(32081148,0,1000,0,0,0,1,0,'[{{0,1005001143,1},1},{{0,1009001143,1},1}]','[]','[1005001143,1009001143]'),(32081151,0,1000,0,1,0,1,0,'[{{0,1001011153,1},1},{{0,1002011153,1},1},{{0,1003001153,1},1},{{0,1004011153,1},1},{{0,1006011153,1},1},{{0,1007011153,1},1},{{0,1008011153,1},1},{{0,1010011153,1},1}]','[]','[1001011153,1002011153,1003001153,1004011153,1005001153,1006011153,1007011153,1008011153,1009001153,1010011153]'),(32081151,0,1000,0,2,0,1,0,'[{{0,1001021153,1},1},{{0,1002021153,1},1},{{0,1003001153,1},1},{{0,1004021153,1},1},{{0,1006021153,1},1},{{0,1007021153,1},1},{{0,1008021153,1},1},{{0,1010021153,1},1}]','[]','[1001021153,1002021153,1003001153,1004021153,1005001153,1006021153,1007021153,1008021153,1009001153,1010021153]'),(32081151,0,1000,0,3,0,1,0,'[{{0,1001031153,1},1},{{0,1002031153,1},1},{{0,1003001153,1},1},{{0,1004031153,1},1},{{0,1006031153,1},1},{{0,1007031153,1},1},{{0,1008031153,1},1},{{0,1010031153,1},1}]','[]','[1001031153,1002031153,1003001153,1004031153,1005001153,1006031153,1007031153,1008031153,1009001153,1010031153]'),(32081151,0,1000,0,4,0,1,0,'[{{0,1001041153,1},1},{{0,1002041153,1},1},{{0,1003001153,1},1},{{0,1004041153,1},1},{{0,1006041153,1},1},{{0,1007041153,1},1},{{0,1008041153,1},1},{{0,1010041153,1},1}]','[]','[1001041153,1002041153,1003001153,1004041153,1005001153,1006041153,1007041153,1008041153,1009001153,1010041153]'),(32081152,0,1000,0,1,0,1,0,'[{{0,1002011153,1},1},{{0,1004011153,1},1},{{0,1006011153,1},1},{{0,1008011153,1},1},{{0,1010011153,1},1}]','[]','[1002011153,1004011153,1006011153,1008011153,1010011153]'),(32081152,0,1000,0,2,0,1,0,'[{{0,1002021153,1},1},{{0,1004021153,1},1},{{0,1006021153,1},1},{{0,1008021153,1},1},{{0,1010021153,1},1}]','[]','[1002021153,1004021153,1006021153,1008021153,1010021153]'),(32081152,0,1000,0,3,0,1,0,'[{{0,1002031153,1},1},{{0,1004031153,1},1},{{0,1006031153,1},1},{{0,1008031153,1},1},{{0,1010031153,1},1}]','[]','[1002031153,1004031153,1006031153,1008031153,1010031153]'),(32081152,0,1000,0,4,0,1,0,'[{{0,1002041153,1},1},{{0,1004041153,1},1},{{0,1006041153,1},1},{{0,1008041153,1},1},{{0,1010041153,1},1}]','[]','[1002041153,1004041153,1006041153,1008041153,1010041153]'),(32081153,0,1000,0,1,0,1,0,'[{{0,1001011153,1},1},{{0,1007011153,1},1}]','[]','[1001011153,1007011153]'),(32081153,0,1000,0,2,0,1,0,'[{{0,1001021153,1},1},{{0,1007021153,1},1}]','[]','[1001021153,1007021153]'),(32081153,0,1000,0,3,0,1,0,'[{{0,1001031153,1},1},{{0,1007031153,1},1}]','[]','[1001031153,1007031153]'),(32081153,0,1000,0,4,0,1,0,'[{{0,1001041153,1},1},{{0,1007041153,1},1}]','[]','[1001041153,1007041153]'),(32081155,0,1000,0,1,0,1,0,'[{{0,1002011153,1},1},{{0,1004011153,1},1},{{0,1006011153,1},1},{{0,1008011153,1},1},{{0,1010011153,1},1},{{0,1001011153,1},1}]','[]','[1002011153,1004011153,1006011153,1008011153,1010011153,1001011153]'),(32081155,0,1000,0,2,0,1,0,'[{{0,1002021153,1},1},{{0,1004021153,1},1},{{0,1006021153,1},1},{{0,1008021153,1},1},{{0,1010021153,1},1},{{0,1001021153,1},1}]','[]','[1002021153,1004021153,1006021153,1008021153,1010021153,1001021153]'),(32081155,0,1000,0,3,0,1,0,'[{{0,1002031153,1},1},{{0,1004031153,1},1},{{0,1006031153,1},1},{{0,1008031153,1},1},{{0,1010031153,1},1},{{0,1001031153,1},1}]','[]','[1002031153,1004031153,1006031153,1008031153,1010031153,1001031153]'),(32081155,0,1000,0,4,0,1,0,'[{{0,1002041153,1},1},{{0,1004041153,1},1},{{0,1006041153,1},1},{{0,1008041153,1},1},{{0,1010041153,1},1},{{0,1001041153,1},1}]','[]','[1002041153,1004041153,1006041153,1008041153,1010041153,1001041153]'),(32081156,0,1000,0,1,0,1,0,'[{{0,1007011153,1},1},{{0,1003001153,1},1},{{0,1005001153,1},1},{{0,1009001153,1},1}]','[]','[1007011153,1003001153,1005001153,1009001153]'),(32081156,0,1000,0,2,0,1,0,'[{{0,1007021153,1},1},{{0,1003001153,1},1},{{0,1005001153,1},1},{{0,1009001153,1},1}]','[]','[1007021153,1003001153,1005001153,1009001153]'),(32081156,0,1000,0,3,0,1,0,'[{{0,1007031153,1},1},{{0,1003001153,1},1},{{0,1005001153,1},1},{{0,1009001153,1},1}]','[]','[1007031153,1003001153,1005001153,1009001153]'),(32081156,0,1000,0,4,0,1,0,'[{{0,1007041153,1},1},{{0,1003001153,1},1},{{0,1005001153,1},1},{{0,1009001153,1},1}]','[]','[1007041153,1003001153,1005001153,1009001153]'),(32081157,0,1000,0,1,0,1,0,'[{{0,1007011153,1},1},{{0,1003001153,1},1}]','[]','[1007011153,1003001153]'),(32081157,0,1000,0,2,0,1,0,'[{{0,1007021153,1},1},{{0,1003001153,1},1}]','[]','[1007021153,1003001153]'),(32081157,0,1000,0,3,0,1,0,'[{{0,1007031153,1},1},{{0,1003001153,1},1}]','[]','[1007031153,1003001153]'),(32081157,0,1000,0,4,0,1,0,'[{{0,1007041153,1},1},{{0,1003001153,1},1}]','[]','[1007041153,1003001153]'),(32081158,0,1000,0,0,0,1,0,'[{{0,1005001153,1},1},{{0,1009001153,1},1}]','[]','[1005001153,1009001153]'),(32081161,0,1000,0,1,0,1,0,'[{{0,1001011163,1},1},{{0,1002011163,1},1},{{0,1003001163,1},1},{{0,1004011163,1},1},{{0,1006011163,1},1},{{0,1007011163,1},1},{{0,1008011163,1},1},{{0,1010011163,1},1}]','[]','[1001011163,1002011163,1003001163,1004011163,1005001163,1006011163,1007011163,1008011163,1009001163,1010011163]'),(32081161,0,1000,0,2,0,1,0,'[{{0,1001021163,1},1},{{0,1002021163,1},1},{{0,1003001163,1},1},{{0,1004021163,1},1},{{0,1006021163,1},1},{{0,1007021163,1},1},{{0,1008021163,1},1},{{0,1010021163,1},1}]','[]','[1001021163,1002021163,1003001163,1004021163,1005001163,1006021163,1007021163,1008021163,1009001163,1010021163]'),(32081161,0,1000,0,3,0,1,0,'[{{0,1001031163,1},1},{{0,1002031163,1},1},{{0,1003001163,1},1},{{0,1004031163,1},1},{{0,1006031163,1},1},{{0,1007031163,1},1},{{0,1008031163,1},1},{{0,1010031163,1},1}]','[]','[1001031163,1002031163,1003001163,1004031163,1005001163,1006031163,1007031163,1008031163,1009001163,1010031163]'),(32081161,0,1000,0,4,0,1,0,'[{{0,1001041163,1},1},{{0,1002041163,1},1},{{0,1003001163,1},1},{{0,1004041163,1},1},{{0,1006041163,1},1},{{0,1007041163,1},1},{{0,1008041163,1},1},{{0,1010041163,1},1}]','[]','[1001041163,1002041163,1003001163,1004041163,1005001163,1006041163,1007041163,1008041163,1009001163,1010041163]'),(32081162,0,1000,0,1,0,1,0,'[{{0,1002011163,1},1},{{0,1004011163,1},1},{{0,1006011163,1},1},{{0,1008011163,1},1},{{0,1010011163,1},1}]','[]','[1002011163,1004011163,1006011163,1008011163,1010011163]'),(32081162,0,1000,0,2,0,1,0,'[{{0,1002021163,1},1},{{0,1004021163,1},1},{{0,1006021163,1},1},{{0,1008021163,1},1},{{0,1010021163,1},1}]','[]','[1002021163,1004021163,1006021163,1008021163,1010021163]'),(32081162,0,1000,0,3,0,1,0,'[{{0,1002031163,1},1},{{0,1004031163,1},1},{{0,1006031163,1},1},{{0,1008031163,1},1},{{0,1010031163,1},1}]','[]','[1002031163,1004031163,1006031163,1008031163,1010031163]'),(32081162,0,1000,0,4,0,1,0,'[{{0,1002041163,1},1},{{0,1004041163,1},1},{{0,1006041163,1},1},{{0,1008041163,1},1},{{0,1010041163,1},1}]','[]','[1002041163,1004041163,1006041163,1008041163,1010041163]'),(32081163,0,1000,0,1,0,1,0,'[{{0,1001011163,1},1},{{0,1007011163,1},1}]','[]','[1001011163,1007011163]'),(32081163,0,1000,0,2,0,1,0,'[{{0,1001021163,1},1},{{0,1007021163,1},1}]','[]','[1001021163,1007021163]'),(32081163,0,1000,0,3,0,1,0,'[{{0,1001031163,1},1},{{0,1007031163,1},1}]','[]','[1001031163,1007031163]'),(32081163,0,1000,0,4,0,1,0,'[{{0,1001041163,1},1},{{0,1007041163,1},1}]','[]','[1001041163,1007041163]'),(32081165,0,1000,0,1,0,1,0,'[{{0,1002011163,1},1},{{0,1004011163,1},1},{{0,1006011163,1},1},{{0,1008011163,1},1},{{0,1010011163,1},1},{{0,1001011163,1},1}]','[]','[1002011163,1004011163,1006011163,1008011163,1010011163,1001011163]'),(32081165,0,1000,0,2,0,1,0,'[{{0,1002021163,1},1},{{0,1004021163,1},1},{{0,1006021163,1},1},{{0,1008021163,1},1},{{0,1010021163,1},1},{{0,1001021163,1},1}]','[]','[1002021163,1004021163,1006021163,1008021163,1010021163,1001021163]'),(32081165,0,1000,0,3,0,1,0,'[{{0,1002031163,1},1},{{0,1004031163,1},1},{{0,1006031163,1},1},{{0,1008031163,1},1},{{0,1010031163,1},1},{{0,1001031163,1},1}]','[]','[1002031163,1004031163,1006031163,1008031163,1010031163,1001031163]'),(32081165,0,1000,0,4,0,1,0,'[{{0,1002041163,1},1},{{0,1004041163,1},1},{{0,1006041163,1},1},{{0,1008041163,1},1},{{0,1010041163,1},1},{{0,1001041163,1},1}]','[]','[1002041163,1004041163,1006041163,1008041163,1010041163,1001041163]'),(32081166,0,1000,0,1,0,1,0,'[{{0,1007011163,1},1},{{0,1003001163,1},1},{{0,1005001163,1},1},{{0,1009001163,1},1}]','[]','[1007011163,1003001163,1005001163,1009001163]'),(32081166,0,1000,0,2,0,1,0,'[{{0,1007021163,1},1},{{0,1003001163,1},1},{{0,1005001163,1},1},{{0,1009001163,1},1}]','[]','[1007021163,1003001163,1005001163,1009001163]'),(32081166,0,1000,0,3,0,1,0,'[{{0,1007031163,1},1},{{0,1003001163,1},1},{{0,1005001163,1},1},{{0,1009001163,1},1}]','[]','[1007031163,1003001163,1005001163,1009001163]'),(32081166,0,1000,0,4,0,1,0,'[{{0,1007041163,1},1},{{0,1003001163,1},1},{{0,1005001163,1},1},{{0,1009001163,1},1}]','[]','[1007041163,1003001163,1005001163,1009001163]'),(32081167,0,1000,0,1,0,1,0,'[{{0,1007011163,1},1},{{0,1003001163,1},1}]','[]','[1007011163,1003001163]'),(32081167,0,1000,0,2,0,1,0,'[{{0,1007021163,1},1},{{0,1003001163,1},1}]','[]','[1007021163,1003001163]'),(32081167,0,1000,0,3,0,1,0,'[{{0,1007031163,1},1},{{0,1003001163,1},1}]','[]','[1007031163,1003001163]'),(32081167,0,1000,0,4,0,1,0,'[{{0,1007041163,1},1},{{0,1003001163,1},1}]','[]','[1007041163,1003001163]'),(32081168,0,1000,0,0,0,1,0,'[{{0,1005001163,1},1},{{0,1009001163,1},1}]','[]','[1005001163,1009001163]'),(32081171,0,1000,0,1,0,1,0,'[{{0,1001011100,1},1},{{0,1002011100,1},1},{{0,1003001100,1},1},{{0,1004011100,1},1},{{0,1006011100,1},1},{{0,1007011100,1},1},{{0,1008011100,1},1},{{0,1010011100,1},1}]','[]','[]'),(32081171,0,1000,0,2,0,1,0,'[{{0,1001021100,1},1},{{0,1002021100,1},1},{{0,1003001100,1},1},{{0,1004021100,1},1},{{0,1006021100,1},1},{{0,1007021100,1},1},{{0,1008021100,1},1},{{0,1010021100,1},1}]','[]','[]'),(32081171,0,1000,0,3,0,1,0,'[{{0,1001031100,1},1},{{0,1002031100,1},1},{{0,1003001100,1},1},{{0,1004031100,1},1},{{0,1006031100,1},1},{{0,1007031100,1},1},{{0,1008031100,1},1},{{0,1010031100,1},1}]','[]','[]'),(32081171,0,1000,0,4,0,1,0,'[{{0,1001041100,1},1},{{0,1002041100,1},1},{{0,1003001100,1},1},{{0,1004041100,1},1},{{0,1006041100,1},1},{{0,1007041100,1},1},{{0,1008041100,1},1},{{0,1010041100,1},1}]','[]','[]'),(32081172,0,1000,0,1,0,1,0,'[{{0,1002011100,1},1},{{0,1004011100,1},1},{{0,1006011100,1},1},{{0,1008011100,1},1},{{0,1010011100,1},1}]','[]','[]'),(32081172,0,1000,0,2,0,1,0,'[{{0,1002021100,1},1},{{0,1004021100,1},1},{{0,1006021100,1},1},{{0,1008021100,1},1},{{0,1010021100,1},1}]','[]','[]'),(32081172,0,1000,0,3,0,1,0,'[{{0,1002031100,1},1},{{0,1004031100,1},1},{{0,1006031100,1},1},{{0,1008031100,1},1},{{0,1010031100,1},1}]','[]','[]'),(32081172,0,1000,0,4,0,1,0,'[{{0,1002041100,1},1},{{0,1004041100,1},1},{{0,1006041100,1},1},{{0,1008041100,1},1},{{0,1010041100,1},1}]','[]','[]'),(32081173,0,1000,0,1,0,1,0,'[{{0,1001011100,1},1},{{0,1007011100,1},1}]','[]','[]'),(32081173,0,1000,0,2,0,1,0,'[{{0,1001021100,1},1},{{0,1007021100,1},1}]','[]','[]'),(32081173,0,1000,0,3,0,1,0,'[{{0,1001031100,1},1},{{0,1007031100,1},1}]','[]','[]'),(32081173,0,1000,0,4,0,1,0,'[{{0,1001041100,1},1},{{0,1007041100,1},1}]','[]','[]'),(32081175,0,1000,0,1,0,1,0,'[{{0,1002011100,1},1},{{0,1004011100,1},1},{{0,1006011100,1},1},{{0,1008011100,1},1},{{0,1010011100,1},1},{{0,1001011100,1},1}]','[]','[]'),(32081175,0,1000,0,2,0,1,0,'[{{0,1002021100,1},1},{{0,1004021100,1},1},{{0,1006021100,1},1},{{0,1008021100,1},1},{{0,1010021100,1},1},{{0,1001021100,1},1}]','[]','[]'),(32081175,0,1000,0,3,0,1,0,'[{{0,1002031100,1},1},{{0,1004031100,1},1},{{0,1006031100,1},1},{{0,1008031100,1},1},{{0,1010031100,1},1},{{0,1001031100,1},1}]','[]','[]'),(32081175,0,1000,0,4,0,1,0,'[{{0,1002041100,1},1},{{0,1004041100,1},1},{{0,1006041100,1},1},{{0,1008041100,1},1},{{0,1010041100,1},1},{{0,1001041100,1},1}]','[]','[]'),(32081176,0,1000,0,1,0,1,0,'[{{0,1007011100,1},1},{{0,1003001100,1},1},{{0,1005001100,1},1},{{0,1009001100,1},1}]','[]','[]'),(32081176,0,1000,0,2,0,1,0,'[{{0,1007021100,1},1},{{0,1003001100,1},1},{{0,1005001100,1},1},{{0,1009001100,1},1}]','[]','[]'),(32081176,0,1000,0,3,0,1,0,'[{{0,1007031100,1},1},{{0,1003001100,1},1},{{0,1005001100,1},1},{{0,1009001100,1},1}]','[]','[]'),(32081176,0,1000,0,4,0,1,0,'[{{0,1007041100,1},1},{{0,1003001100,1},1},{{0,1005001100,1},1},{{0,1009001100,1},1}]','[]','[]'),(32081177,0,1000,0,1,0,1,0,'[{{0,1007011100,1},1},{{0,1003001100,1},1}]','[]','[]'),(32081177,0,1000,0,2,0,1,0,'[{{0,1007021100,1},1},{{0,1003001100,1},1}]','[]','[]'),(32081177,0,1000,0,3,0,1,0,'[{{0,1007031100,1},1},{{0,1003001100,1},1}]','[]','[]'),(32081177,0,1000,0,4,0,1,0,'[{{0,1007041100,1},1},{{0,1003001100,1},1}]','[]','[]'),(32081178,0,1000,0,0,0,1,0,'[{{0,1005001100,1},1},{{0,1009001100,1},1}]','[]','[]'),(32081181,0,1000,0,1,0,1,0,'[{{0,1001011110,1},1},{{0,1002011110,1},1},{{0,1003001110,1},1},{{0,1004011110,1},1},{{0,1006011110,1},1},{{0,1007011110,1},1},{{0,1008011110,1},1},{{0,1010011110,1},1}]','[]','[]'),(32081181,0,1000,0,2,0,1,0,'[{{0,1001021110,1},1},{{0,1002021110,1},1},{{0,1003001110,1},1},{{0,1004021110,1},1},{{0,1006021110,1},1},{{0,1007021110,1},1},{{0,1008021110,1},1},{{0,1010021110,1},1}]','[]','[]'),(32081181,0,1000,0,3,0,1,0,'[{{0,1001031110,1},1},{{0,1002031110,1},1},{{0,1003001110,1},1},{{0,1004031110,1},1},{{0,1006031110,1},1},{{0,1007031110,1},1},{{0,1008031110,1},1},{{0,1010031110,1},1}]','[]','[]'),(32081181,0,1000,0,4,0,1,0,'[{{0,1001041110,1},1},{{0,1002041110,1},1},{{0,1003001110,1},1},{{0,1004041110,1},1},{{0,1006041110,1},1},{{0,1007041110,1},1},{{0,1008041110,1},1},{{0,1010041110,1},1}]','[]','[]'),(32081182,0,1000,0,1,0,1,0,'[{{0,1002011110,1},1},{{0,1004011110,1},1},{{0,1006011110,1},1},{{0,1008011110,1},1},{{0,1010011110,1},1}]','[]','[]'),(32081182,0,1000,0,2,0,1,0,'[{{0,1002021110,1},1},{{0,1004021110,1},1},{{0,1006021110,1},1},{{0,1008021110,1},1},{{0,1010021110,1},1}]','[]','[]'),(32081182,0,1000,0,3,0,1,0,'[{{0,1002031110,1},1},{{0,1004031110,1},1},{{0,1006031110,1},1},{{0,1008031110,1},1},{{0,1010031110,1},1}]','[]','[]'),(32081182,0,1000,0,4,0,1,0,'[{{0,1002041110,1},1},{{0,1004041110,1},1},{{0,1006041110,1},1},{{0,1008041110,1},1},{{0,1010041110,1},1}]','[]','[]'),(32081183,0,1000,0,1,0,1,0,'[{{0,1001011110,1},1},{{0,1007011110,1},1}]','[]','[]'),(32081183,0,1000,0,2,0,1,0,'[{{0,1001021110,1},1},{{0,1007021110,1},1}]','[]','[]'),(32081183,0,1000,0,3,0,1,0,'[{{0,1001031110,1},1},{{0,1007031110,1},1}]','[]','[]'),(32081183,0,1000,0,4,0,1,0,'[{{0,1001041110,1},1},{{0,1007041110,1},1}]','[]','[]'),(32081185,0,1000,0,1,0,1,0,'[{{0,1002011110,1},1},{{0,1004011110,1},1},{{0,1006011110,1},1},{{0,1008011110,1},1},{{0,1010011110,1},1},{{0,1001011110,1},1}]','[]','[]'),(32081185,0,1000,0,2,0,1,0,'[{{0,1002021110,1},1},{{0,1004021110,1},1},{{0,1006021110,1},1},{{0,1008021110,1},1},{{0,1010021110,1},1},{{0,1001021110,1},1}]','[]','[]'),(32081185,0,1000,0,3,0,1,0,'[{{0,1002031110,1},1},{{0,1004031110,1},1},{{0,1006031110,1},1},{{0,1008031110,1},1},{{0,1010031110,1},1},{{0,1001031110,1},1}]','[]','[]'),(32081185,0,1000,0,4,0,1,0,'[{{0,1002041110,1},1},{{0,1004041110,1},1},{{0,1006041110,1},1},{{0,1008041110,1},1},{{0,1010041110,1},1},{{0,1001041110,1},1}]','[]','[]'),(32081186,0,1000,0,1,0,1,0,'[{{0,1007011110,1},1},{{0,1003001110,1},1},{{0,1005001110,1},1},{{0,1009001110,1},1}]','[]','[]'),(32081186,0,1000,0,2,0,1,0,'[{{0,1007021110,1},1},{{0,1003001110,1},1},{{0,1005001110,1},1},{{0,1009001110,1},1}]','[]','[]'),(32081186,0,1000,0,3,0,1,0,'[{{0,1007031110,1},1},{{0,1003001110,1},1},{{0,1005001110,1},1},{{0,1009001110,1},1}]','[]','[]'),(32081186,0,1000,0,4,0,1,0,'[{{0,1007041110,1},1},{{0,1003001110,1},1},{{0,1005001110,1},1},{{0,1009001110,1},1}]','[]','[]'),(32081187,0,1000,0,1,0,1,0,'[{{0,1007011110,1},1},{{0,1003001110,1},1}]','[]','[]'),(32081187,0,1000,0,2,0,1,0,'[{{0,1007021110,1},1},{{0,1003001110,1},1}]','[]','[]'),(32081187,0,1000,0,3,0,1,0,'[{{0,1007031110,1},1},{{0,1003001110,1},1}]','[]','[]'),(32081187,0,1000,0,4,0,1,0,'[{{0,1007041110,1},1},{{0,1003001110,1},1}]','[]','[]'),(32081188,0,1000,0,0,0,1,0,'[{{0,1005001110,1},1},{{0,1009001110,1},1}]','[]','[]'),(32081191,0,1000,0,1,0,1,0,'[{{0,1001011120,1},1},{{0,1002011120,1},1},{{0,1003001120,1},1},{{0,1004011120,1},1},{{0,1006011120,1},1},{{0,1007011120,1},1},{{0,1008011120,1},1},{{0,1010011120,1},1}]','[]','[]'),(32081191,0,1000,0,2,0,1,0,'[{{0,1001021120,1},1},{{0,1002021120,1},1},{{0,1003001120,1},1},{{0,1004021120,1},1},{{0,1006021120,1},1},{{0,1007021120,1},1},{{0,1008021120,1},1},{{0,1010021120,1},1}]','[]','[]'),(32081191,0,1000,0,3,0,1,0,'[{{0,1001031120,1},1},{{0,1002031120,1},1},{{0,1003001120,1},1},{{0,1004031120,1},1},{{0,1006031120,1},1},{{0,1007031120,1},1},{{0,1008031120,1},1},{{0,1010031120,1},1}]','[]','[]'),(32081191,0,1000,0,4,0,1,0,'[{{0,1001041120,1},1},{{0,1002041120,1},1},{{0,1003001120,1},1},{{0,1004041120,1},1},{{0,1006041120,1},1},{{0,1007041120,1},1},{{0,1008041120,1},1},{{0,1010041120,1},1}]','[]','[]'),(32081192,0,1000,0,1,0,1,0,'[{{0,1002011120,1},1},{{0,1004011120,1},1},{{0,1006011120,1},1},{{0,1008011120,1},1},{{0,1010011120,1},1}]','[]','[]'),(32081192,0,1000,0,2,0,1,0,'[{{0,1002021120,1},1},{{0,1004021120,1},1},{{0,1006021120,1},1},{{0,1008021120,1},1},{{0,1010021120,1},1}]','[]','[]'),(32081192,0,1000,0,3,0,1,0,'[{{0,1002031120,1},1},{{0,1004031120,1},1},{{0,1006031120,1},1},{{0,1008031120,1},1},{{0,1010031120,1},1}]','[]','[]'),(32081192,0,1000,0,4,0,1,0,'[{{0,1002041120,1},1},{{0,1004041120,1},1},{{0,1006041120,1},1},{{0,1008041120,1},1},{{0,1010041120,1},1}]','[]','[]'),(32081193,0,1000,0,1,0,1,0,'[{{0,1001011120,1},1},{{0,1007011120,1},1}]','[]','[]'),(32081193,0,1000,0,2,0,1,0,'[{{0,1001021120,1},1},{{0,1007021120,1},1}]','[]','[]'),(32081193,0,1000,0,3,0,1,0,'[{{0,1001031120,1},1},{{0,1007031120,1},1}]','[]','[]'),(32081193,0,1000,0,4,0,1,0,'[{{0,1001041120,1},1},{{0,1007041120,1},1}]','[]','[]'),(32081195,0,1000,0,1,0,1,0,'[{{0,1002011120,1},1},{{0,1004011120,1},1},{{0,1006011120,1},1},{{0,1008011120,1},1},{{0,1010011120,1},1},{{0,1001011120,1},1}]','[]','[]'),(32081195,0,1000,0,2,0,1,0,'[{{0,1002021120,1},1},{{0,1004021120,1},1},{{0,1006021120,1},1},{{0,1008021120,1},1},{{0,1010021120,1},1},{{0,1001021120,1},1}]','[]','[]'),(32081195,0,1000,0,3,0,1,0,'[{{0,1002031120,1},1},{{0,1004031120,1},1},{{0,1006031120,1},1},{{0,1008031120,1},1},{{0,1010031120,1},1},{{0,1001031120,1},1}]','[]','[]'),(32081195,0,1000,0,4,0,1,0,'[{{0,1002041120,1},1},{{0,1004041120,1},1},{{0,1006041120,1},1},{{0,1008041120,1},1},{{0,1010041120,1},1},{{0,1001041120,1},1}]','[]','[]'),(32081196,0,1000,0,1,0,1,0,'[{{0,1007011120,1},1},{{0,1003001120,1},1},{{0,1005001120,1},1},{{0,1009001120,1},1}]','[]','[]'),(32081196,0,1000,0,2,0,1,0,'[{{0,1007021120,1},1},{{0,1003001120,1},1},{{0,1005001120,1},1},{{0,1009001120,1},1}]','[]','[]'),(32081196,0,1000,0,3,0,1,0,'[{{0,1007031120,1},1},{{0,1003001120,1},1},{{0,1005001120,1},1},{{0,1009001120,1},1}]','[]','[]'),(32081196,0,1000,0,4,0,1,0,'[{{0,1007041120,1},1},{{0,1003001120,1},1},{{0,1005001120,1},1},{{0,1009001120,1},1}]','[]','[]'),(32081197,0,1000,0,1,0,1,0,'[{{0,1007011120,1},1},{{0,1003001120,1},1}]','[]','[]'),(32081197,0,1000,0,2,0,1,0,'[{{0,1007021120,1},1},{{0,1003001120,1},1}]','[]','[]'),(32081197,0,1000,0,3,0,1,0,'[{{0,1007031120,1},1},{{0,1003001120,1},1}]','[]','[]'),(32081197,0,1000,0,4,0,1,0,'[{{0,1007041120,1},1},{{0,1003001120,1},1}]','[]','[]'),(32081198,0,1000,0,0,0,1,0,'[{{0,1005001120,1},1},{{0,1009001120,1},1}]','[]','[]'),(32081201,0,1000,0,1,0,1,0,'[{{0,1001011131,1},1},{{0,1002011131,1},1},{{0,1003001131,1},1},{{0,1004011131,1},1},{{0,1006011131,1},1},{{0,1007011131,1},1},{{0,1008011131,1},1},{{0,1010011131,1},1}]','[]','[]'),(32081201,0,1000,0,2,0,1,0,'[{{0,1001021131,1},1},{{0,1002021131,1},1},{{0,1003001131,1},1},{{0,1004021131,1},1},{{0,1006021131,1},1},{{0,1007021131,1},1},{{0,1008021131,1},1},{{0,1010021131,1},1}]','[]','[]'),(32081201,0,1000,0,3,0,1,0,'[{{0,1001031131,1},1},{{0,1002031131,1},1},{{0,1003001131,1},1},{{0,1004031131,1},1},{{0,1006031131,1},1},{{0,1007031131,1},1},{{0,1008031131,1},1},{{0,1010031131,1},1}]','[]','[]'),(32081201,0,1000,0,4,0,1,0,'[{{0,1001041131,1},1},{{0,1002041131,1},1},{{0,1003001131,1},1},{{0,1004041131,1},1},{{0,1006041131,1},1},{{0,1007041131,1},1},{{0,1008041131,1},1},{{0,1010041131,1},1}]','[]','[]'),(32081202,0,1000,0,1,0,1,0,'[{{0,1002011131,1},1},{{0,1004011131,1},1},{{0,1006011131,1},1},{{0,1008011131,1},1},{{0,1010011131,1},1}]','[]','[]'),(32081202,0,1000,0,2,0,1,0,'[{{0,1002021131,1},1},{{0,1004021131,1},1},{{0,1006021131,1},1},{{0,1008021131,1},1},{{0,1010021131,1},1}]','[]','[]'),(32081202,0,1000,0,3,0,1,0,'[{{0,1002031131,1},1},{{0,1004031131,1},1},{{0,1006031131,1},1},{{0,1008031131,1},1},{{0,1010031131,1},1}]','[]','[]'),(32081202,0,1000,0,4,0,1,0,'[{{0,1002041131,1},1},{{0,1004041131,1},1},{{0,1006041131,1},1},{{0,1008041131,1},1},{{0,1010041131,1},1}]','[]','[]'),(32081203,0,1000,0,1,0,1,0,'[{{0,1001011131,1},1},{{0,1007011131,1},1}]','[]','[]'),(32081203,0,1000,0,2,0,1,0,'[{{0,1001021131,1},1},{{0,1007021131,1},1}]','[]','[]'),(32081203,0,1000,0,3,0,1,0,'[{{0,1001031131,1},1},{{0,1007031131,1},1}]','[]','[]'),(32081203,0,1000,0,4,0,1,0,'[{{0,1001041131,1},1},{{0,1007041131,1},1}]','[]','[]'),(32081205,0,1000,0,1,0,1,0,'[{{0,1002011131,1},1},{{0,1004011131,1},1},{{0,1006011131,1},1},{{0,1008011131,1},1},{{0,1010011131,1},1},{{0,1001011131,1},1}]','[]','[]'),(32081205,0,1000,0,2,0,1,0,'[{{0,1002021131,1},1},{{0,1004021131,1},1},{{0,1006021131,1},1},{{0,1008021131,1},1},{{0,1010021131,1},1},{{0,1001021131,1},1}]','[]','[]'),(32081205,0,1000,0,3,0,1,0,'[{{0,1002031131,1},1},{{0,1004031131,1},1},{{0,1006031131,1},1},{{0,1008031131,1},1},{{0,1010031131,1},1},{{0,1001031131,1},1}]','[]','[]'),(32081205,0,1000,0,4,0,1,0,'[{{0,1002041131,1},1},{{0,1004041131,1},1},{{0,1006041131,1},1},{{0,1008041131,1},1},{{0,1010041131,1},1},{{0,1001041131,1},1}]','[]','[]'),(32081206,0,1000,0,1,0,1,0,'[{{0,1007011131,1},1},{{0,1003001131,1},1},{{0,1005001131,1},1},{{0,1009001131,1},1}]','[]','[]'),(32081206,0,1000,0,2,0,1,0,'[{{0,1007021131,1},1},{{0,1003001131,1},1},{{0,1005001131,1},1},{{0,1009001131,1},1}]','[]','[]'),(32081206,0,1000,0,3,0,1,0,'[{{0,1007031131,1},1},{{0,1003001131,1},1},{{0,1005001131,1},1},{{0,1009001131,1},1}]','[]','[]'),(32081206,0,1000,0,4,0,1,0,'[{{0,1007041131,1},1},{{0,1003001131,1},1},{{0,1005001131,1},1},{{0,1009001131,1},1}]','[]','[]'),(32081207,0,1000,0,1,0,1,0,'[{{0,1007011131,1},1},{{0,1003001131,1},1}]','[]','[]'),(32081207,0,1000,0,2,0,1,0,'[{{0,1007021131,1},1},{{0,1003001131,1},1}]','[]','[]'),(32081207,0,1000,0,3,0,1,0,'[{{0,1007031131,1},1},{{0,1003001131,1},1}]','[]','[]'),(32081207,0,1000,0,4,0,1,0,'[{{0,1007041131,1},1},{{0,1003001131,1},1}]','[]','[]'),(32081208,0,1000,0,0,0,1,0,'[{{0,1005001131,1},1},{{0,1009001131,1},1}]','[]','[]'),(32081211,0,1000,0,1,0,1,0,'[{{0,1001011232,1},1},{{0,1002011232,1},1},{{0,1003001232,1},1},{{0,1004011232,1},1},{{0,1006011232,1},1},{{0,1007011232,1},1},{{0,1008011232,1},1},{{0,1010011232,1},1}]','[]','[1001011232,1002011232,1003001232,1004011232,1005001232,1006011232,1007011232,1008011232,1009001232,1010011232]'),(32081211,0,1000,0,2,0,1,0,'[{{0,1001021232,1},1},{{0,1002021232,1},1},{{0,1003001232,1},1},{{0,1004021232,1},1},{{0,1006021232,1},1},{{0,1007021232,1},1},{{0,1008021232,1},1},{{0,1010021232,1},1}]','[]','[1001021232,1002021232,1003001232,1004021232,1005001232,1006021232,1007021232,1008021232,1009001232,1010021232]'),(32081211,0,1000,0,3,0,1,0,'[{{0,1001031232,1},1},{{0,1002031232,1},1},{{0,1003001232,1},1},{{0,1004031232,1},1},{{0,1006031232,1},1},{{0,1007031232,1},1},{{0,1008031232,1},1},{{0,1010031232,1},1}]','[]','[1001031232,1002031232,1003001232,1004031232,1005001232,1006031232,1007031232,1008031232,1009001232,1010031232]'),(32081211,0,1000,0,4,0,1,0,'[{{0,1001041232,1},1},{{0,1002041232,1},1},{{0,1003001232,1},1},{{0,1004041232,1},1},{{0,1006041232,1},1},{{0,1007041232,1},1},{{0,1008041232,1},1},{{0,1010041232,1},1}]','[]','[1001041232,1002041232,1003001232,1004041232,1005001232,1006041232,1007041232,1008041232,1009001232,1010041232]'),(32081212,0,1000,0,1,0,1,0,'[{{0,1002011232,1},1},{{0,1004011232,1},1},{{0,1006011232,1},1},{{0,1008011232,1},1},{{0,1010011232,1},1}]','[]','[1002011232,1004011232,1006011232,1008011232,1010011232]'),(32081212,0,1000,0,2,0,1,0,'[{{0,1002021232,1},1},{{0,1004021232,1},1},{{0,1006021232,1},1},{{0,1008021232,1},1},{{0,1010021232,1},1}]','[]','[1002021232,1004021232,1006021232,1008021232,1010021232]'),(32081212,0,1000,0,3,0,1,0,'[{{0,1002031232,1},1},{{0,1004031232,1},1},{{0,1006031232,1},1},{{0,1008031232,1},1},{{0,1010031232,1},1}]','[]','[1002031232,1004031232,1006031232,1008031232,1010031232]'),(32081212,0,1000,0,4,0,1,0,'[{{0,1002041232,1},1},{{0,1004041232,1},1},{{0,1006041232,1},1},{{0,1008041232,1},1},{{0,1010041232,1},1}]','[]','[1002041232,1004041232,1006041232,1008041232,1010041232]'),(32081213,0,1000,0,1,0,1,0,'[{{0,1001011232,1},1},{{0,1007011232,1},1}]','[]','[1001011232,1007011232]'),(32081213,0,1000,0,2,0,1,0,'[{{0,1001021232,1},1},{{0,1007021232,1},1}]','[]','[1001021232,1007021232]'),(32081213,0,1000,0,3,0,1,0,'[{{0,1001031232,1},1},{{0,1007031232,1},1}]','[]','[1001031232,1007031232]'),(32081213,0,1000,0,4,0,1,0,'[{{0,1001041232,1},1},{{0,1007041232,1},1}]','[]','[1001041232,1007041232]'),(32081215,0,1000,0,1,0,1,0,'[{{0,1002011232,1},1},{{0,1004011232,1},1},{{0,1006011232,1},1},{{0,1008011232,1},1},{{0,1010011232,1},1},{{0,1001011232,1},1}]','[]','[1002011232,1004011232,1006011232,1008011232,1010011232,1001011232]'),(32081215,0,1000,0,2,0,1,0,'[{{0,1002021232,1},1},{{0,1004021232,1},1},{{0,1006021232,1},1},{{0,1008021232,1},1},{{0,1010021232,1},1},{{0,1001021232,1},1}]','[]','[1002021232,1004021232,1006021232,1008021232,1010021232,1001021232]'),(32081215,0,1000,0,3,0,1,0,'[{{0,1002031232,1},1},{{0,1004031232,1},1},{{0,1006031232,1},1},{{0,1008031232,1},1},{{0,1010031232,1},1},{{0,1001031232,1},1}]','[]','[1002031232,1004031232,1006031232,1008031232,1010031232,1001031232]'),(32081215,0,1000,0,4,0,1,0,'[{{0,1002041232,1},1},{{0,1004041232,1},1},{{0,1006041232,1},1},{{0,1008041232,1},1},{{0,1010041232,1},1},{{0,1001041232,1},1}]','[]','[1002041232,1004041232,1006041232,1008041232,1010041232,1001041232]'),(32081216,0,1000,0,1,0,1,0,'[{{0,1007011232,1},1},{{0,1003001232,1},1},{{0,1005001232,1},1},{{0,1009001232,1},1}]','[]','[1007011232,1003001232,1005001232,1009001232]'),(32081216,0,1000,0,2,0,1,0,'[{{0,1007021232,1},1},{{0,1003001232,1},1},{{0,1005001232,1},1},{{0,1009001232,1},1}]','[]','[1007021232,1003001232,1005001232,1009001232]'),(32081216,0,1000,0,3,0,1,0,'[{{0,1007031232,1},1},{{0,1003001232,1},1},{{0,1005001232,1},1},{{0,1009001232,1},1}]','[]','[1007031232,1003001232,1005001232,1009001232]'),(32081216,0,1000,0,4,0,1,0,'[{{0,1007041232,1},1},{{0,1003001232,1},1},{{0,1005001232,1},1},{{0,1009001232,1},1}]','[]','[1007041232,1003001232,1005001232,1009001232]'),(32081217,0,1000,0,1,0,1,0,'[{{0,1007011232,1},1},{{0,1003001232,1},1}]','[]','[1007011232,1003001232]'),(32081217,0,1000,0,2,0,1,0,'[{{0,1007021232,1},1},{{0,1003001232,1},1}]','[]','[1007021232,1003001232]'),(32081217,0,1000,0,3,0,1,0,'[{{0,1007031232,1},1},{{0,1003001232,1},1}]','[]','[1007031232,1003001232]'),(32081217,0,1000,0,4,0,1,0,'[{{0,1007041232,1},1},{{0,1003001232,1},1}]','[]','[1007041232,1003001232]'),(32081218,0,1000,0,0,0,1,0,'[{{0,1005001232,1},1},{{0,1009001232,1},1}]','[]','[1005001232,1009001232]'),(32081221,0,1000,0,1,0,1,0,'[{{0,1001011241,1},1},{{0,1002011241,1},1},{{0,1003001241,1},1},{{0,1004011241,1},1},{{0,1006011241,1},1},{{0,1007011241,1},1},{{0,1008011241,1},1},{{0,1010011241,1},1}]','[]','[]'),(32081221,0,1000,0,2,0,1,0,'[{{0,1001021241,1},1},{{0,1002021241,1},1},{{0,1003001241,1},1},{{0,1004021241,1},1},{{0,1006021241,1},1},{{0,1007021241,1},1},{{0,1008021241,1},1},{{0,1010021241,1},1}]','[]','[]'),(32081221,0,1000,0,3,0,1,0,'[{{0,1001031241,1},1},{{0,1002031241,1},1},{{0,1003001241,1},1},{{0,1004031241,1},1},{{0,1006031241,1},1},{{0,1007031241,1},1},{{0,1008031241,1},1},{{0,1010031241,1},1}]','[]','[]'),(32081221,0,1000,0,4,0,1,0,'[{{0,1001041241,1},1},{{0,1002041241,1},1},{{0,1003001241,1},1},{{0,1004041241,1},1},{{0,1006041241,1},1},{{0,1007041241,1},1},{{0,1008041241,1},1},{{0,1010041241,1},1}]','[]','[]'),(32081222,0,1000,0,1,0,1,0,'[{{0,1002011241,1},1},{{0,1004011241,1},1},{{0,1006011241,1},1},{{0,1008011241,1},1},{{0,1010011241,1},1}]','[]','[]'),(32081222,0,1000,0,2,0,1,0,'[{{0,1002021241,1},1},{{0,1004021241,1},1},{{0,1006021241,1},1},{{0,1008021241,1},1},{{0,1010021241,1},1}]','[]','[]'),(32081222,0,1000,0,3,0,1,0,'[{{0,1002031241,1},1},{{0,1004031241,1},1},{{0,1006031241,1},1},{{0,1008031241,1},1},{{0,1010031241,1},1}]','[]','[]'),(32081222,0,1000,0,4,0,1,0,'[{{0,1002041241,1},1},{{0,1004041241,1},1},{{0,1006041241,1},1},{{0,1008041241,1},1},{{0,1010041241,1},1}]','[]','[]'),(32081223,0,1000,0,1,0,1,0,'[{{0,1001011241,1},1},{{0,1007011241,1},1}]','[]','[]'),(32081223,0,1000,0,2,0,1,0,'[{{0,1001021241,1},1},{{0,1007021241,1},1}]','[]','[]'),(32081223,0,1000,0,3,0,1,0,'[{{0,1001031241,1},1},{{0,1007031241,1},1}]','[]','[]'),(32081223,0,1000,0,4,0,1,0,'[{{0,1001041241,1},1},{{0,1007041241,1},1}]','[]','[]'),(32081225,0,1000,0,1,0,1,0,'[{{0,1002011241,1},1},{{0,1004011241,1},1},{{0,1006011241,1},1},{{0,1008011241,1},1},{{0,1010011241,1},1},{{0,1001011241,1},1}]','[]','[]'),(32081225,0,1000,0,2,0,1,0,'[{{0,1002021241,1},1},{{0,1004021241,1},1},{{0,1006021241,1},1},{{0,1008021241,1},1},{{0,1010021241,1},1},{{0,1001021241,1},1}]','[]','[]'),(32081225,0,1000,0,3,0,1,0,'[{{0,1002031241,1},1},{{0,1004031241,1},1},{{0,1006031241,1},1},{{0,1008031241,1},1},{{0,1010031241,1},1},{{0,1001031241,1},1}]','[]','[]'),(32081225,0,1000,0,4,0,1,0,'[{{0,1002041241,1},1},{{0,1004041241,1},1},{{0,1006041241,1},1},{{0,1008041241,1},1},{{0,1010041241,1},1},{{0,1001041241,1},1}]','[]','[]'),(32081226,0,1000,0,1,0,1,0,'[{{0,1007011241,1},1},{{0,1003001241,1},1},{{0,1005001241,1},1},{{0,1009001241,1},1}]','[]','[]'),(32081226,0,1000,0,2,0,1,0,'[{{0,1007021241,1},1},{{0,1003001241,1},1},{{0,1005001241,1},1},{{0,1009001241,1},1}]','[]','[]'),(32081226,0,1000,0,3,0,1,0,'[{{0,1007031241,1},1},{{0,1003001241,1},1},{{0,1005001241,1},1},{{0,1009001241,1},1}]','[]','[]'),(32081226,0,1000,0,4,0,1,0,'[{{0,1007041241,1},1},{{0,1003001241,1},1},{{0,1005001241,1},1},{{0,1009001241,1},1}]','[]','[]'),(32081227,0,1000,0,1,0,1,0,'[{{0,1007011241,1},1},{{0,1003001241,1},1}]','[]','[]'),(32081227,0,1000,0,2,0,1,0,'[{{0,1007021241,1},1},{{0,1003001241,1},1}]','[]','[]'),(32081227,0,1000,0,3,0,1,0,'[{{0,1007031241,1},1},{{0,1003001241,1},1}]','[]','[]'),(32081227,0,1000,0,4,0,1,0,'[{{0,1007041241,1},1},{{0,1003001241,1},1}]','[]','[]'),(32081228,0,1000,0,0,0,1,0,'[{{0,1005001241,1},1},{{0,1009001241,1},1}]','[]','[]'),(32081231,0,1000,0,1,0,1,0,'[{{0,1001011242,1},1},{{0,1002011242,1},1},{{0,1003001242,1},1},{{0,1004011242,1},1},{{0,1006011242,1},1},{{0,1007011242,1},1},{{0,1008011242,1},1},{{0,1010011242,1},1}]','[]','[1001011242,1002011242,1003001242,1004011242,1005001242,1006011242,1007011242,1008011242,1009001242,1010011242]'),(32081231,0,1000,0,2,0,1,0,'[{{0,1001021242,1},1},{{0,1002021242,1},1},{{0,1003001242,1},1},{{0,1004021242,1},1},{{0,1006021242,1},1},{{0,1007021242,1},1},{{0,1008021242,1},1},{{0,1010021242,1},1}]','[]','[1001021242,1002021242,1003001242,1004021242,1005001242,1006021242,1007021242,1008021242,1009001242,1010021242]'),(32081231,0,1000,0,3,0,1,0,'[{{0,1001031242,1},1},{{0,1002031242,1},1},{{0,1003001242,1},1},{{0,1004031242,1},1},{{0,1006031242,1},1},{{0,1007031242,1},1},{{0,1008031242,1},1},{{0,1010031242,1},1}]','[]','[1001031242,1002031242,1003001242,1004031242,1005001242,1006031242,1007031242,1008031242,1009001242,1010031242]'),(32081231,0,1000,0,4,0,1,0,'[{{0,1001041242,1},1},{{0,1002041242,1},1},{{0,1003001242,1},1},{{0,1004041242,1},1},{{0,1006041242,1},1},{{0,1007041242,1},1},{{0,1008041242,1},1},{{0,1010041242,1},1}]','[]','[1001041242,1002041242,1003001242,1004041242,1005001242,1006041242,1007041242,1008041242,1009001242,1010041242]'),(32081232,0,1000,0,1,0,1,0,'[{{0,1002011242,1},1},{{0,1004011242,1},1},{{0,1006011242,1},1},{{0,1008011242,1},1},{{0,1010011242,1},1}]','[]','[1002011242,1004011242,1006011242,1008011242,1010011242]'),(32081232,0,1000,0,2,0,1,0,'[{{0,1002021242,1},1},{{0,1004021242,1},1},{{0,1006021242,1},1},{{0,1008021242,1},1},{{0,1010021242,1},1}]','[]','[1002021242,1004021242,1006021242,1008021242,1010021242]'),(32081232,0,1000,0,3,0,1,0,'[{{0,1002031242,1},1},{{0,1004031242,1},1},{{0,1006031242,1},1},{{0,1008031242,1},1},{{0,1010031242,1},1}]','[]','[1002031242,1004031242,1006031242,1008031242,1010031242]'),(32081232,0,1000,0,4,0,1,0,'[{{0,1002041242,1},1},{{0,1004041242,1},1},{{0,1006041242,1},1},{{0,1008041242,1},1},{{0,1010041242,1},1}]','[]','[1002041242,1004041242,1006041242,1008041242,1010041242]'),(32081233,0,1000,0,1,0,1,0,'[{{0,1001011242,1},1},{{0,1007011242,1},1}]','[]','[1001011242,1007011242]'),(32081233,0,1000,0,2,0,1,0,'[{{0,1001021242,1},1},{{0,1007021242,1},1}]','[]','[1001021242,1007021242]'),(32081233,0,1000,0,3,0,1,0,'[{{0,1001031242,1},1},{{0,1007031242,1},1}]','[]','[1001031242,1007031242]'),(32081233,0,1000,0,4,0,1,0,'[{{0,1001041242,1},1},{{0,1007041242,1},1}]','[]','[1001041242,1007041242]'),(32081235,0,1000,0,1,0,1,0,'[{{0,1002011242,1},1},{{0,1004011242,1},1},{{0,1006011242,1},1},{{0,1008011242,1},1},{{0,1010011242,1},1},{{0,1001011242,1},1}]','[]','[1002011242,1004011242,1006011242,1008011242,1010011242,1001011242]'),(32081235,0,1000,0,2,0,1,0,'[{{0,1002021242,1},1},{{0,1004021242,1},1},{{0,1006021242,1},1},{{0,1008021242,1},1},{{0,1010021242,1},1},{{0,1001021242,1},1}]','[]','[1002021242,1004021242,1006021242,1008021242,1010021242,1001021242]'),(32081235,0,1000,0,3,0,1,0,'[{{0,1002031242,1},1},{{0,1004031242,1},1},{{0,1006031242,1},1},{{0,1008031242,1},1},{{0,1010031242,1},1},{{0,1001031242,1},1}]','[]','[1002031242,1004031242,1006031242,1008031242,1010031242,1001031242]'),(32081235,0,1000,0,4,0,1,0,'[{{0,1002041242,1},1},{{0,1004041242,1},1},{{0,1006041242,1},1},{{0,1008041242,1},1},{{0,1010041242,1},1},{{0,1001041242,1},1}]','[]','[1002041242,1004041242,1006041242,1008041242,1010041242,1001041242]'),(32081236,0,1000,0,1,0,1,0,'[{{0,1007011242,1},1},{{0,1003001242,1},1},{{0,1005001242,1},1},{{0,1009001242,1},1}]','[]','[1007011242,1003001242,1005001242,1009001242]'),(32081236,0,1000,0,2,0,1,0,'[{{0,1007021242,1},1},{{0,1003001242,1},1},{{0,1005001242,1},1},{{0,1009001242,1},1}]','[]','[1007021242,1003001242,1005001242,1009001242]'),(32081236,0,1000,0,3,0,1,0,'[{{0,1007031242,1},1},{{0,1003001242,1},1},{{0,1005001242,1},1},{{0,1009001242,1},1}]','[]','[1007031242,1003001242,1005001242,1009001242]'),(32081236,0,1000,0,4,0,1,0,'[{{0,1007041242,1},1},{{0,1003001242,1},1},{{0,1005001242,1},1},{{0,1009001242,1},1}]','[]','[1007041242,1003001242,1005001242,1009001242]'),(32081237,0,1000,0,1,0,1,0,'[{{0,1007011242,1},1},{{0,1003001242,1},1}]','[]','[1007011242,1003001242]'),(32081237,0,1000,0,2,0,1,0,'[{{0,1007021242,1},1},{{0,1003001242,1},1}]','[]','[1007021242,1003001242]'),(32081237,0,1000,0,3,0,1,0,'[{{0,1007031242,1},1},{{0,1003001242,1},1}]','[]','[1007031242,1003001242]'),(32081237,0,1000,0,4,0,1,0,'[{{0,1007041242,1},1},{{0,1003001242,1},1}]','[]','[1007041242,1003001242]'),(32081238,0,1000,0,0,0,1,0,'[{{0,1005001242,1},1},{{0,1009001242,1},1}]','[]','[1005001242,1009001242]'),(32081241,0,1000,0,1,0,1,0,'[{{0,1001011243,1},1},{{0,1002011243,1},1},{{0,1003001243,1},1},{{0,1004011243,1},1},{{0,1006011243,1},1},{{0,1007011243,1},1},{{0,1008011243,1},1},{{0,1010011243,1},1}]','[]','[1001011243,1002011243,1003001243,1004011243,1005001243,1006011243,1007011243,1008011243,1009001243,1010011243]'),(32081241,0,1000,0,2,0,1,0,'[{{0,1001021243,1},1},{{0,1002021243,1},1},{{0,1003001243,1},1},{{0,1004021243,1},1},{{0,1006021243,1},1},{{0,1007021243,1},1},{{0,1008021243,1},1},{{0,1010021243,1},1}]','[]','[1001021243,1002021243,1003001243,1004021243,1005001243,1006021243,1007021243,1008021243,1009001243,1010021243]'),(32081241,0,1000,0,3,0,1,0,'[{{0,1001031243,1},1},{{0,1002031243,1},1},{{0,1003001243,1},1},{{0,1004031243,1},1},{{0,1006031243,1},1},{{0,1007031243,1},1},{{0,1008031243,1},1},{{0,1010031243,1},1}]','[]','[1001031243,1002031243,1003001243,1004031243,1005001243,1006031243,1007031243,1008031243,1009001243,1010031243]'),(32081241,0,1000,0,4,0,1,0,'[{{0,1001041243,1},1},{{0,1002041243,1},1},{{0,1003001243,1},1},{{0,1004041243,1},1},{{0,1006041243,1},1},{{0,1007041243,1},1},{{0,1008041243,1},1},{{0,1010041243,1},1}]','[]','[1001041243,1002041243,1003001243,1004041243,1005001243,1006041243,1007041243,1008041243,1009001243,1010041243]'),(32081242,0,1000,0,1,0,1,0,'[{{0,1002011243,1},1},{{0,1004011243,1},1},{{0,1006011243,1},1},{{0,1008011243,1},1},{{0,1010011243,1},1}]','[]','[1002011243,1004011243,1006011243,1008011243,1010011243]'),(32081242,0,1000,0,2,0,1,0,'[{{0,1002021243,1},1},{{0,1004021243,1},1},{{0,1006021243,1},1},{{0,1008021243,1},1},{{0,1010021243,1},1}]','[]','[1002021243,1004021243,1006021243,1008021243,1010021243]'),(32081242,0,1000,0,3,0,1,0,'[{{0,1002031243,1},1},{{0,1004031243,1},1},{{0,1006031243,1},1},{{0,1008031243,1},1},{{0,1010031243,1},1}]','[]','[1002031243,1004031243,1006031243,1008031243,1010031243]'),(32081242,0,1000,0,4,0,1,0,'[{{0,1002041243,1},1},{{0,1004041243,1},1},{{0,1006041243,1},1},{{0,1008041243,1},1},{{0,1010041243,1},1}]','[]','[1002041243,1004041243,1006041243,1008041243,1010041243]'),(32081243,0,1000,0,1,0,1,0,'[{{0,1001011243,1},1},{{0,1007011243,1},1}]','[]','[1001011243,1007011243]'),(32081243,0,1000,0,2,0,1,0,'[{{0,1001021243,1},1},{{0,1007021243,1},1}]','[]','[1001021243,1007021243]'),(32081243,0,1000,0,3,0,1,0,'[{{0,1001031243,1},1},{{0,1007031243,1},1}]','[]','[1001031243,1007031243]'),(32081243,0,1000,0,4,0,1,0,'[{{0,1001041243,1},1},{{0,1007041243,1},1}]','[]','[1001041243,1007041243]'),(32081245,0,1000,0,1,0,1,0,'[{{0,1002011243,1},1},{{0,1004011243,1},1},{{0,1006011243,1},1},{{0,1008011243,1},1},{{0,1010011243,1},1},{{0,1001011243,1},1}]','[]','[1002011243,1004011243,1006011243,1008011243,1010011243,1001011243]'),(32081245,0,1000,0,2,0,1,0,'[{{0,1002021243,1},1},{{0,1004021243,1},1},{{0,1006021243,1},1},{{0,1008021243,1},1},{{0,1010021243,1},1},{{0,1001021243,1},1}]','[]','[1002021243,1004021243,1006021243,1008021243,1010021243,1001021243]'),(32081245,0,1000,0,3,0,1,0,'[{{0,1002031243,1},1},{{0,1004031243,1},1},{{0,1006031243,1},1},{{0,1008031243,1},1},{{0,1010031243,1},1},{{0,1001031243,1},1}]','[]','[1002031243,1004031243,1006031243,1008031243,1010031243,1001031243]'),(32081245,0,1000,0,4,0,1,0,'[{{0,1002041243,1},1},{{0,1004041243,1},1},{{0,1006041243,1},1},{{0,1008041243,1},1},{{0,1010041243,1},1},{{0,1001041243,1},1}]','[]','[1002041243,1004041243,1006041243,1008041243,1010041243,1001041243]'),(32081246,0,1000,0,1,0,1,0,'[{{0,1007011243,1},1},{{0,1003001243,1},1},{{0,1005001243,1},1},{{0,1009001243,1},1}]','[]','[1007011243,1003001243,1005001243,1009001243]'),(32081246,0,1000,0,2,0,1,0,'[{{0,1007021243,1},1},{{0,1003001243,1},1},{{0,1005001243,1},1},{{0,1009001243,1},1}]','[]','[1007021243,1003001243,1005001243,1009001243]'),(32081246,0,1000,0,3,0,1,0,'[{{0,1007031243,1},1},{{0,1003001243,1},1},{{0,1005001243,1},1},{{0,1009001243,1},1}]','[]','[1007031243,1003001243,1005001243,1009001243]'),(32081246,0,1000,0,4,0,1,0,'[{{0,1007041243,1},1},{{0,1003001243,1},1},{{0,1005001243,1},1},{{0,1009001243,1},1}]','[]','[1007041243,1003001243,1005001243,1009001243]'),(32081247,0,1000,0,1,0,1,0,'[{{0,1007011243,1},1},{{0,1003001243,1},1}]','[]','[1007011243,1003001243]'),(32081247,0,1000,0,2,0,1,0,'[{{0,1007021243,1},1},{{0,1003001243,1},1}]','[]','[1007021243,1003001243]'),(32081247,0,1000,0,3,0,1,0,'[{{0,1007031243,1},1},{{0,1003001243,1},1}]','[]','[1007031243,1003001243]'),(32081247,0,1000,0,4,0,1,0,'[{{0,1007041243,1},1},{{0,1003001243,1},1}]','[]','[1007041243,1003001243]'),(32081248,0,1000,0,0,0,1,0,'[{{0,1005001243,1},1},{{0,1009001243,1},1}]','[]','[1005001243,1009001243]'),(32081251,0,1000,0,1,0,1,0,'[{{0,1001011253,1},1},{{0,1002011253,1},1},{{0,1003001253,1},1},{{0,1004011253,1},1},{{0,1006011253,1},1},{{0,1007011253,1},1},{{0,1008011253,1},1},{{0,1010011253,1},1}]','[]','[1001011253,1002011253,1003001253,1004011253,1005001253,1006011253,1007011253,1008011253,1009001253,1010011253]'),(32081251,0,1000,0,2,0,1,0,'[{{0,1001021253,1},1},{{0,1002021253,1},1},{{0,1003001253,1},1},{{0,1004021253,1},1},{{0,1006021253,1},1},{{0,1007021253,1},1},{{0,1008021253,1},1},{{0,1010021253,1},1}]','[]','[1001021253,1002021253,1003001253,1004021253,1005001253,1006021253,1007021253,1008021253,1009001253,1010021253]'),(32081251,0,1000,0,3,0,1,0,'[{{0,1001031253,1},1},{{0,1002031253,1},1},{{0,1003001253,1},1},{{0,1004031253,1},1},{{0,1006031253,1},1},{{0,1007031253,1},1},{{0,1008031253,1},1},{{0,1010031253,1},1}]','[]','[1001031253,1002031253,1003001253,1004031253,1005001253,1006031253,1007031253,1008031253,1009001253,1010031253]'),(32081251,0,1000,0,4,0,1,0,'[{{0,1001041253,1},1},{{0,1002041253,1},1},{{0,1003001253,1},1},{{0,1004041253,1},1},{{0,1006041253,1},1},{{0,1007041253,1},1},{{0,1008041253,1},1},{{0,1010041253,1},1}]','[]','[1001041253,1002041253,1003001253,1004041253,1005001253,1006041253,1007041253,1008041253,1009001253,1010041253]'),(32081252,0,1000,0,1,0,1,0,'[{{0,1002011253,1},1},{{0,1004011253,1},1},{{0,1006011253,1},1},{{0,1008011253,1},1},{{0,1010011253,1},1}]','[]','[1002011253,1004011253,1006011253,1008011253,1010011253]'),(32081252,0,1000,0,2,0,1,0,'[{{0,1002021253,1},1},{{0,1004021253,1},1},{{0,1006021253,1},1},{{0,1008021253,1},1},{{0,1010021253,1},1}]','[]','[1002021253,1004021253,1006021253,1008021253,1010021253]'),(32081252,0,1000,0,3,0,1,0,'[{{0,1002031253,1},1},{{0,1004031253,1},1},{{0,1006031253,1},1},{{0,1008031253,1},1},{{0,1010031253,1},1}]','[]','[1002031253,1004031253,1006031253,1008031253,1010031253]'),(32081252,0,1000,0,4,0,1,0,'[{{0,1002041253,1},1},{{0,1004041253,1},1},{{0,1006041253,1},1},{{0,1008041253,1},1},{{0,1010041253,1},1}]','[]','[1002041253,1004041253,1006041253,1008041253,1010041253]'),(32081253,0,1000,0,1,0,1,0,'[{{0,1001011253,1},1},{{0,1007011253,1},1}]','[]','[1001011253,1007011253]'),(32081253,0,1000,0,2,0,1,0,'[{{0,1001021253,1},1},{{0,1007021253,1},1}]','[]','[1001021253,1007021253]'),(32081253,0,1000,0,3,0,1,0,'[{{0,1001031253,1},1},{{0,1007031253,1},1}]','[]','[1001031253,1007031253]'),(32081253,0,1000,0,4,0,1,0,'[{{0,1001041253,1},1},{{0,1007041253,1},1}]','[]','[1001041253,1007041253]'),(32081255,0,1000,0,1,0,1,0,'[{{0,1002011253,1},1},{{0,1004011253,1},1},{{0,1006011253,1},1},{{0,1008011253,1},1},{{0,1010011253,1},1},{{0,1001011253,1},1}]','[]','[1002011253,1004011253,1006011253,1008011253,1010011253,1001011253]'),(32081255,0,1000,0,2,0,1,0,'[{{0,1002021253,1},1},{{0,1004021253,1},1},{{0,1006021253,1},1},{{0,1008021253,1},1},{{0,1010021253,1},1},{{0,1001021253,1},1}]','[]','[1002021253,1004021253,1006021253,1008021253,1010021253,1001021253]'),(32081255,0,1000,0,3,0,1,0,'[{{0,1002031253,1},1},{{0,1004031253,1},1},{{0,1006031253,1},1},{{0,1008031253,1},1},{{0,1010031253,1},1},{{0,1001031253,1},1}]','[]','[1002031253,1004031253,1006031253,1008031253,1010031253,1001031253]'),(32081255,0,1000,0,4,0,1,0,'[{{0,1002041253,1},1},{{0,1004041253,1},1},{{0,1006041253,1},1},{{0,1008041253,1},1},{{0,1010041253,1},1},{{0,1001041253,1},1}]','[]','[1002041253,1004041253,1006041253,1008041253,1010041253,1001041253]'),(32081256,0,1000,0,1,0,1,0,'[{{0,1007011253,1},1},{{0,1003001253,1},1},{{0,1005001253,1},1},{{0,1009001253,1},1}]','[]','[1007011253,1003001253,1005001253,1009001253]'),(32081256,0,1000,0,2,0,1,0,'[{{0,1007021253,1},1},{{0,1003001253,1},1},{{0,1005001253,1},1},{{0,1009001253,1},1}]','[]','[1007021253,1003001253,1005001253,1009001253]'),(32081256,0,1000,0,3,0,1,0,'[{{0,1007031253,1},1},{{0,1003001253,1},1},{{0,1005001253,1},1},{{0,1009001253,1},1}]','[]','[1007031253,1003001253,1005001253,1009001253]'),(32081256,0,1000,0,4,0,1,0,'[{{0,1007041253,1},1},{{0,1003001253,1},1},{{0,1005001253,1},1},{{0,1009001253,1},1}]','[]','[1007041253,1003001253,1005001253,1009001253]'),(32081257,0,1000,0,1,0,1,0,'[{{0,1007011253,1},1},{{0,1003001253,1},1}]','[]','[1007011253,1003001253]'),(32081257,0,1000,0,2,0,1,0,'[{{0,1007021253,1},1},{{0,1003001253,1},1}]','[]','[1007021253,1003001253]'),(32081257,0,1000,0,3,0,1,0,'[{{0,1007031253,1},1},{{0,1003001253,1},1}]','[]','[1007031253,1003001253]'),(32081257,0,1000,0,4,0,1,0,'[{{0,1007041253,1},1},{{0,1003001253,1},1}]','[]','[1007041253,1003001253]'),(32081258,0,1000,0,0,0,1,0,'[{{0,1005001253,1},1},{{0,1009001253,1},1}]','[]','[1005001253,1009001253]'),(32081261,0,1000,0,1,0,1,0,'[{{0,1001011263,1},1},{{0,1002011263,1},1},{{0,1003001263,1},1},{{0,1004011263,1},1},{{0,1006011263,1},1},{{0,1007011263,1},1},{{0,1008011263,1},1},{{0,1010011263,1},1}]','[]','[1001011263,1002011263,1003001263,1004011263,1005001263,1006011263,1007011263,1008011263,1009001263,1010011263]'),(32081261,0,1000,0,2,0,1,0,'[{{0,1001021263,1},1},{{0,1002021263,1},1},{{0,1003001263,1},1},{{0,1004021263,1},1},{{0,1006021263,1},1},{{0,1007021263,1},1},{{0,1008021263,1},1},{{0,1010021263,1},1}]','[]','[1001021263,1002021263,1003001263,1004021263,1005001263,1006021263,1007021263,1008021263,1009001263,1010021263]'),(32081261,0,1000,0,3,0,1,0,'[{{0,1001031263,1},1},{{0,1002031263,1},1},{{0,1003001263,1},1},{{0,1004031263,1},1},{{0,1006031263,1},1},{{0,1007031263,1},1},{{0,1008031263,1},1},{{0,1010031263,1},1}]','[]','[1001031263,1002031263,1003001263,1004031263,1005001263,1006031263,1007031263,1008031263,1009001263,1010031263]'),(32081261,0,1000,0,4,0,1,0,'[{{0,1001041263,1},1},{{0,1002041263,1},1},{{0,1003001263,1},1},{{0,1004041263,1},1},{{0,1006041263,1},1},{{0,1007041263,1},1},{{0,1008041263,1},1},{{0,1010041263,1},1}]','[]','[1001041263,1002041263,1003001263,1004041263,1005001263,1006041263,1007041263,1008041263,1009001263,1010041263]'),(32081262,0,1000,0,1,0,1,0,'[{{0,1002011263,1},1},{{0,1004011263,1},1},{{0,1006011263,1},1},{{0,1008011263,1},1},{{0,1010011263,1},1}]','[]','[1002011263,1004011263,1006011263,1008011263,1010011263]'),(32081262,0,1000,0,2,0,1,0,'[{{0,1002021263,1},1},{{0,1004021263,1},1},{{0,1006021263,1},1},{{0,1008021263,1},1},{{0,1010021263,1},1}]','[]','[1002021263,1004021263,1006021263,1008021263,1010021263]'),(32081262,0,1000,0,3,0,1,0,'[{{0,1002031263,1},1},{{0,1004031263,1},1},{{0,1006031263,1},1},{{0,1008031263,1},1},{{0,1010031263,1},1}]','[]','[1002031263,1004031263,1006031263,1008031263,1010031263]'),(32081262,0,1000,0,4,0,1,0,'[{{0,1002041263,1},1},{{0,1004041263,1},1},{{0,1006041263,1},1},{{0,1008041263,1},1},{{0,1010041263,1},1}]','[]','[1002041263,1004041263,1006041263,1008041263,1010041263]'),(32081263,0,1000,0,1,0,1,0,'[{{0,1001011263,1},1},{{0,1007011263,1},1}]','[]','[1001011263,1007011263]'),(32081263,0,1000,0,2,0,1,0,'[{{0,1001021263,1},1},{{0,1007021263,1},1}]','[]','[1001021263,1007021263]'),(32081263,0,1000,0,3,0,1,0,'[{{0,1001031263,1},1},{{0,1007031263,1},1}]','[]','[1001031263,1007031263]'),(32081263,0,1000,0,4,0,1,0,'[{{0,1001041263,1},1},{{0,1007041263,1},1}]','[]','[1001041263,1007041263]'),(32081265,0,1000,0,1,0,1,0,'[{{0,1002011263,1},1},{{0,1004011263,1},1},{{0,1006011263,1},1},{{0,1008011263,1},1},{{0,1010011263,1},1},{{0,1001011263,1},1}]','[]','[1002011263,1004011263,1006011263,1008011263,1010011263,1001011263]'),(32081265,0,1000,0,2,0,1,0,'[{{0,1002021263,1},1},{{0,1004021263,1},1},{{0,1006021263,1},1},{{0,1008021263,1},1},{{0,1010021263,1},1},{{0,1001021263,1},1}]','[]','[1002021263,1004021263,1006021263,1008021263,1010021263,1001021263]'),(32081265,0,1000,0,3,0,1,0,'[{{0,1002031263,1},1},{{0,1004031263,1},1},{{0,1006031263,1},1},{{0,1008031263,1},1},{{0,1010031263,1},1},{{0,1001031263,1},1}]','[]','[1002031263,1004031263,1006031263,1008031263,1010031263,1001031263]'),(32081265,0,1000,0,4,0,1,0,'[{{0,1002041263,1},1},{{0,1004041263,1},1},{{0,1006041263,1},1},{{0,1008041263,1},1},{{0,1010041263,1},1},{{0,1001041263,1},1}]','[]','[1002041263,1004041263,1006041263,1008041263,1010041263,1001041263]'),(32081266,0,1000,0,1,0,1,0,'[{{0,1007011263,1},1},{{0,1003001263,1},1},{{0,1005001263,1},1},{{0,1009001263,1},1}]','[]','[1007011263,1003001263,1005001263,1009001263]'),(32081266,0,1000,0,2,0,1,0,'[{{0,1007021263,1},1},{{0,1003001263,1},1},{{0,1005001263,1},1},{{0,1009001263,1},1}]','[]','[1007021263,1003001263,1005001263,1009001263]'),(32081266,0,1000,0,3,0,1,0,'[{{0,1007031263,1},1},{{0,1003001263,1},1},{{0,1005001263,1},1},{{0,1009001263,1},1}]','[]','[1007031263,1003001263,1005001263,1009001263]'),(32081266,0,1000,0,4,0,1,0,'[{{0,1007041263,1},1},{{0,1003001263,1},1},{{0,1005001263,1},1},{{0,1009001263,1},1}]','[]','[1007041263,1003001263,1005001263,1009001263]'),(32081267,0,1000,0,1,0,1,0,'[{{0,1007011263,1},1},{{0,1003001263,1},1}]','[]','[1007011263,1003001263]'),(32081267,0,1000,0,2,0,1,0,'[{{0,1007021263,1},1},{{0,1003001263,1},1}]','[]','[1007021263,1003001263]'),(32081267,0,1000,0,3,0,1,0,'[{{0,1007031263,1},1},{{0,1003001263,1},1}]','[]','[1007031263,1003001263]'),(32081267,0,1000,0,4,0,1,0,'[{{0,1007041263,1},1},{{0,1003001263,1},1}]','[]','[1007041263,1003001263]'),(32081268,0,1000,0,0,0,1,0,'[{{0,1005001263,1},1},{{0,1009001263,1},1}]','[]','[1005001263,1009001263]'),(32081271,0,1000,0,1,0,1,0,'[{{0,1001011200,1},1},{{0,1002011200,1},1},{{0,1003001200,1},1},{{0,1004011200,1},1},{{0,1006011200,1},1},{{0,1007011200,1},1},{{0,1008011200,1},1},{{0,1010011200,1},1}]','[]','[]'),(32081271,0,1000,0,2,0,1,0,'[{{0,1001021200,1},1},{{0,1002021200,1},1},{{0,1003001200,1},1},{{0,1004021200,1},1},{{0,1006021200,1},1},{{0,1007021200,1},1},{{0,1008021200,1},1},{{0,1010021200,1},1}]','[]','[]'),(32081271,0,1000,0,3,0,1,0,'[{{0,1001031200,1},1},{{0,1002031200,1},1},{{0,1003001200,1},1},{{0,1004031200,1},1},{{0,1006031200,1},1},{{0,1007031200,1},1},{{0,1008031200,1},1},{{0,1010031200,1},1}]','[]','[]'),(32081271,0,1000,0,4,0,1,0,'[{{0,1001041200,1},1},{{0,1002041200,1},1},{{0,1003001200,1},1},{{0,1004041200,1},1},{{0,1006041200,1},1},{{0,1007041200,1},1},{{0,1008041200,1},1},{{0,1010041200,1},1}]','[]','[]'),(32081272,0,1000,0,1,0,1,0,'[{{0,1002011200,1},1},{{0,1004011200,1},1},{{0,1006011200,1},1},{{0,1008011200,1},1},{{0,1010011200,1},1}]','[]','[]'),(32081272,0,1000,0,2,0,1,0,'[{{0,1002021200,1},1},{{0,1004021200,1},1},{{0,1006021200,1},1},{{0,1008021200,1},1},{{0,1010021200,1},1}]','[]','[]'),(32081272,0,1000,0,3,0,1,0,'[{{0,1002031200,1},1},{{0,1004031200,1},1},{{0,1006031200,1},1},{{0,1008031200,1},1},{{0,1010031200,1},1}]','[]','[]'),(32081272,0,1000,0,4,0,1,0,'[{{0,1002041200,1},1},{{0,1004041200,1},1},{{0,1006041200,1},1},{{0,1008041200,1},1},{{0,1010041200,1},1}]','[]','[]'),(32081273,0,1000,0,1,0,1,0,'[{{0,1001011200,1},1},{{0,1007011200,1},1}]','[]','[]'),(32081273,0,1000,0,2,0,1,0,'[{{0,1001021200,1},1},{{0,1007021200,1},1}]','[]','[]'),(32081273,0,1000,0,3,0,1,0,'[{{0,1001031200,1},1},{{0,1007031200,1},1}]','[]','[]'),(32081273,0,1000,0,4,0,1,0,'[{{0,1001041200,1},1},{{0,1007041200,1},1}]','[]','[]'),(32081275,0,1000,0,1,0,1,0,'[{{0,1002011200,1},1},{{0,1004011200,1},1},{{0,1006011200,1},1},{{0,1008011200,1},1},{{0,1010011200,1},1},{{0,1001011200,1},1}]','[]','[]'),(32081275,0,1000,0,2,0,1,0,'[{{0,1002021200,1},1},{{0,1004021200,1},1},{{0,1006021200,1},1},{{0,1008021200,1},1},{{0,1010021200,1},1},{{0,1001021200,1},1}]','[]','[]'),(32081275,0,1000,0,3,0,1,0,'[{{0,1002031200,1},1},{{0,1004031200,1},1},{{0,1006031200,1},1},{{0,1008031200,1},1},{{0,1010031200,1},1},{{0,1001031200,1},1}]','[]','[]'),(32081275,0,1000,0,4,0,1,0,'[{{0,1002041200,1},1},{{0,1004041200,1},1},{{0,1006041200,1},1},{{0,1008041200,1},1},{{0,1010041200,1},1},{{0,1001041200,1},1}]','[]','[]'),(32081276,0,1000,0,1,0,1,0,'[{{0,1007011200,1},1},{{0,1003001200,1},1},{{0,1005001200,1},1},{{0,1009001200,1},1}]','[]','[]'),(32081276,0,1000,0,2,0,1,0,'[{{0,1007021200,1},1},{{0,1003001200,1},1},{{0,1005001200,1},1},{{0,1009001200,1},1}]','[]','[]'),(32081276,0,1000,0,3,0,1,0,'[{{0,1007031200,1},1},{{0,1003001200,1},1},{{0,1005001200,1},1},{{0,1009001200,1},1}]','[]','[]'),(32081276,0,1000,0,4,0,1,0,'[{{0,1007041200,1},1},{{0,1003001200,1},1},{{0,1005001200,1},1},{{0,1009001200,1},1}]','[]','[]'),(32081277,0,1000,0,1,0,1,0,'[{{0,1007011200,1},1},{{0,1003001200,1},1}]','[]','[]'),(32081277,0,1000,0,2,0,1,0,'[{{0,1007021200,1},1},{{0,1003001200,1},1}]','[]','[]'),(32081277,0,1000,0,3,0,1,0,'[{{0,1007031200,1},1},{{0,1003001200,1},1}]','[]','[]'),(32081277,0,1000,0,4,0,1,0,'[{{0,1007041200,1},1},{{0,1003001200,1},1}]','[]','[]'),(32081278,0,1000,0,0,0,1,0,'[{{0,1005001200,1},1},{{0,1009001200,1},1}]','[]','[]'),(32081281,0,1000,0,1,0,1,0,'[{{0,1001011210,1},1},{{0,1002011210,1},1},{{0,1003001210,1},1},{{0,1004011210,1},1},{{0,1006011210,1},1},{{0,1007011210,1},1},{{0,1008011210,1},1},{{0,1010011210,1},1}]','[]','[]'),(32081281,0,1000,0,2,0,1,0,'[{{0,1001021210,1},1},{{0,1002021210,1},1},{{0,1003001210,1},1},{{0,1004021210,1},1},{{0,1006021210,1},1},{{0,1007021210,1},1},{{0,1008021210,1},1},{{0,1010021210,1},1}]','[]','[]'),(32081281,0,1000,0,3,0,1,0,'[{{0,1001031210,1},1},{{0,1002031210,1},1},{{0,1003001210,1},1},{{0,1004031210,1},1},{{0,1006031210,1},1},{{0,1007031210,1},1},{{0,1008031210,1},1},{{0,1010031210,1},1}]','[]','[]'),(32081281,0,1000,0,4,0,1,0,'[{{0,1001041210,1},1},{{0,1002041210,1},1},{{0,1003001210,1},1},{{0,1004041210,1},1},{{0,1006041210,1},1},{{0,1007041210,1},1},{{0,1008041210,1},1},{{0,1010041210,1},1}]','[]','[]'),(32081282,0,1000,0,1,0,1,0,'[{{0,1002011210,1},1},{{0,1004011210,1},1},{{0,1006011210,1},1},{{0,1008011210,1},1},{{0,1010011210,1},1}]','[]','[]'),(32081282,0,1000,0,2,0,1,0,'[{{0,1002021210,1},1},{{0,1004021210,1},1},{{0,1006021210,1},1},{{0,1008021210,1},1},{{0,1010021210,1},1}]','[]','[]'),(32081282,0,1000,0,3,0,1,0,'[{{0,1002031210,1},1},{{0,1004031210,1},1},{{0,1006031210,1},1},{{0,1008031210,1},1},{{0,1010031210,1},1}]','[]','[]'),(32081282,0,1000,0,4,0,1,0,'[{{0,1002041210,1},1},{{0,1004041210,1},1},{{0,1006041210,1},1},{{0,1008041210,1},1},{{0,1010041210,1},1}]','[]','[]'),(32081283,0,1000,0,1,0,1,0,'[{{0,1001011210,1},1},{{0,1007011210,1},1}]','[]','[]'),(32081283,0,1000,0,2,0,1,0,'[{{0,1001021210,1},1},{{0,1007021210,1},1}]','[]','[]'),(32081283,0,1000,0,3,0,1,0,'[{{0,1001031210,1},1},{{0,1007031210,1},1}]','[]','[]'),(32081283,0,1000,0,4,0,1,0,'[{{0,1001041210,1},1},{{0,1007041210,1},1}]','[]','[]'),(32081285,0,1000,0,1,0,1,0,'[{{0,1002011210,1},1},{{0,1004011210,1},1},{{0,1006011210,1},1},{{0,1008011210,1},1},{{0,1010011210,1},1},{{0,1001011210,1},1}]','[]','[]'),(32081285,0,1000,0,2,0,1,0,'[{{0,1002021210,1},1},{{0,1004021210,1},1},{{0,1006021210,1},1},{{0,1008021210,1},1},{{0,1010021210,1},1},{{0,1001021210,1},1}]','[]','[]'),(32081285,0,1000,0,3,0,1,0,'[{{0,1002031210,1},1},{{0,1004031210,1},1},{{0,1006031210,1},1},{{0,1008031210,1},1},{{0,1010031210,1},1},{{0,1001031210,1},1}]','[]','[]'),(32081285,0,1000,0,4,0,1,0,'[{{0,1002041210,1},1},{{0,1004041210,1},1},{{0,1006041210,1},1},{{0,1008041210,1},1},{{0,1010041210,1},1},{{0,1001041210,1},1}]','[]','[]'),(32081286,0,1000,0,1,0,1,0,'[{{0,1007011210,1},1},{{0,1003001210,1},1},{{0,1005001210,1},1},{{0,1009001210,1},1}]','[]','[]'),(32081286,0,1000,0,2,0,1,0,'[{{0,1007021210,1},1},{{0,1003001210,1},1},{{0,1005001210,1},1},{{0,1009001210,1},1}]','[]','[]'),(32081286,0,1000,0,3,0,1,0,'[{{0,1007031210,1},1},{{0,1003001210,1},1},{{0,1005001210,1},1},{{0,1009001210,1},1}]','[]','[]'),(32081286,0,1000,0,4,0,1,0,'[{{0,1007041210,1},1},{{0,1003001210,1},1},{{0,1005001210,1},1},{{0,1009001210,1},1}]','[]','[]'),(32081287,0,1000,0,1,0,1,0,'[{{0,1007011210,1},1},{{0,1003001210,1},1}]','[]','[]'),(32081287,0,1000,0,2,0,1,0,'[{{0,1007021210,1},1},{{0,1003001210,1},1}]','[]','[]'),(32081287,0,1000,0,3,0,1,0,'[{{0,1007031210,1},1},{{0,1003001210,1},1}]','[]','[]'),(32081287,0,1000,0,4,0,1,0,'[{{0,1007041210,1},1},{{0,1003001210,1},1}]','[]','[]'),(32081288,0,1000,0,0,0,1,0,'[{{0,1005001210,1},1},{{0,1009001210,1},1}]','[]','[]'),(32081291,0,1000,0,1,0,1,0,'[{{0,1001011220,1},1},{{0,1002011220,1},1},{{0,1003001220,1},1},{{0,1004011220,1},1},{{0,1006011220,1},1},{{0,1007011220,1},1},{{0,1008011220,1},1},{{0,1010011220,1},1}]','[]','[]'),(32081291,0,1000,0,2,0,1,0,'[{{0,1001021220,1},1},{{0,1002021220,1},1},{{0,1003001220,1},1},{{0,1004021220,1},1},{{0,1006021220,1},1},{{0,1007021220,1},1},{{0,1008021220,1},1},{{0,1010021220,1},1}]','[]','[]'),(32081291,0,1000,0,3,0,1,0,'[{{0,1001031220,1},1},{{0,1002031220,1},1},{{0,1003001220,1},1},{{0,1004031220,1},1},{{0,1006031220,1},1},{{0,1007031220,1},1},{{0,1008031220,1},1},{{0,1010031220,1},1}]','[]','[]'),(32081291,0,1000,0,4,0,1,0,'[{{0,1001041220,1},1},{{0,1002041220,1},1},{{0,1003001220,1},1},{{0,1004041220,1},1},{{0,1006041220,1},1},{{0,1007041220,1},1},{{0,1008041220,1},1},{{0,1010041220,1},1}]','[]','[]'),(32081292,0,1000,0,1,0,1,0,'[{{0,1002011220,1},1},{{0,1004011220,1},1},{{0,1006011220,1},1},{{0,1008011220,1},1},{{0,1010011220,1},1}]','[]','[]'),(32081292,0,1000,0,2,0,1,0,'[{{0,1002021220,1},1},{{0,1004021220,1},1},{{0,1006021220,1},1},{{0,1008021220,1},1},{{0,1010021220,1},1}]','[]','[]'),(32081292,0,1000,0,3,0,1,0,'[{{0,1002031220,1},1},{{0,1004031220,1},1},{{0,1006031220,1},1},{{0,1008031220,1},1},{{0,1010031220,1},1}]','[]','[]'),(32081292,0,1000,0,4,0,1,0,'[{{0,1002041220,1},1},{{0,1004041220,1},1},{{0,1006041220,1},1},{{0,1008041220,1},1},{{0,1010041220,1},1}]','[]','[]'),(32081293,0,1000,0,1,0,1,0,'[{{0,1001011220,1},1},{{0,1007011220,1},1}]','[]','[]'),(32081293,0,1000,0,2,0,1,0,'[{{0,1001021220,1},1},{{0,1007021220,1},1}]','[]','[]'),(32081293,0,1000,0,3,0,1,0,'[{{0,1001031220,1},1},{{0,1007031220,1},1}]','[]','[]'),(32081293,0,1000,0,4,0,1,0,'[{{0,1001041220,1},1},{{0,1007041220,1},1}]','[]','[]'),(32081295,0,1000,0,1,0,1,0,'[{{0,1002011220,1},1},{{0,1004011220,1},1},{{0,1006011220,1},1},{{0,1008011220,1},1},{{0,1010011220,1},1},{{0,1001011220,1},1}]','[]','[]'),(32081295,0,1000,0,2,0,1,0,'[{{0,1002021220,1},1},{{0,1004021220,1},1},{{0,1006021220,1},1},{{0,1008021220,1},1},{{0,1010021220,1},1},{{0,1001021220,1},1}]','[]','[]'),(32081295,0,1000,0,3,0,1,0,'[{{0,1002031220,1},1},{{0,1004031220,1},1},{{0,1006031220,1},1},{{0,1008031220,1},1},{{0,1010031220,1},1},{{0,1001031220,1},1}]','[]','[]'),(32081295,0,1000,0,4,0,1,0,'[{{0,1002041220,1},1},{{0,1004041220,1},1},{{0,1006041220,1},1},{{0,1008041220,1},1},{{0,1010041220,1},1},{{0,1001041220,1},1}]','[]','[]'),(32081296,0,1000,0,1,0,1,0,'[{{0,1007011220,1},1},{{0,1003001220,1},1},{{0,1005001220,1},1},{{0,1009001220,1},1}]','[]','[]'),(32081296,0,1000,0,2,0,1,0,'[{{0,1007021220,1},1},{{0,1003001220,1},1},{{0,1005001220,1},1},{{0,1009001220,1},1}]','[]','[]'),(32081296,0,1000,0,3,0,1,0,'[{{0,1007031220,1},1},{{0,1003001220,1},1},{{0,1005001220,1},1},{{0,1009001220,1},1}]','[]','[]'),(32081296,0,1000,0,4,0,1,0,'[{{0,1007041220,1},1},{{0,1003001220,1},1},{{0,1005001220,1},1},{{0,1009001220,1},1}]','[]','[]'),(32081297,0,1000,0,1,0,1,0,'[{{0,1007011220,1},1},{{0,1003001220,1},1}]','[]','[]'),(32081297,0,1000,0,2,0,1,0,'[{{0,1007021220,1},1},{{0,1003001220,1},1}]','[]','[]'),(32081297,0,1000,0,3,0,1,0,'[{{0,1007031220,1},1},{{0,1003001220,1},1}]','[]','[]'),(32081297,0,1000,0,4,0,1,0,'[{{0,1007041220,1},1},{{0,1003001220,1},1}]','[]','[]'),(32081298,0,1000,0,0,0,1,0,'[{{0,1005001220,1},1},{{0,1009001220,1},1}]','[]','[]'),(32081301,0,1000,0,1,0,1,0,'[{{0,1001011231,1},1},{{0,1002011231,1},1},{{0,1003001231,1},1},{{0,1004011231,1},1},{{0,1006011231,1},1},{{0,1007011231,1},1},{{0,1008011231,1},1},{{0,1010011231,1},1}]','[]','[]'),(32081301,0,1000,0,2,0,1,0,'[{{0,1001021231,1},1},{{0,1002021231,1},1},{{0,1003001231,1},1},{{0,1004021231,1},1},{{0,1006021231,1},1},{{0,1007021231,1},1},{{0,1008021231,1},1},{{0,1010021231,1},1}]','[]','[]'),(32081301,0,1000,0,3,0,1,0,'[{{0,1001031231,1},1},{{0,1002031231,1},1},{{0,1003001231,1},1},{{0,1004031231,1},1},{{0,1006031231,1},1},{{0,1007031231,1},1},{{0,1008031231,1},1},{{0,1010031231,1},1}]','[]','[]'),(32081301,0,1000,0,4,0,1,0,'[{{0,1001041231,1},1},{{0,1002041231,1},1},{{0,1003001231,1},1},{{0,1004041231,1},1},{{0,1006041231,1},1},{{0,1007041231,1},1},{{0,1008041231,1},1},{{0,1010041231,1},1}]','[]','[]'),(32081302,0,1000,0,1,0,1,0,'[{{0,1002011231,1},1},{{0,1004011231,1},1},{{0,1006011231,1},1},{{0,1008011231,1},1},{{0,1010011231,1},1}]','[]','[]'),(32081302,0,1000,0,2,0,1,0,'[{{0,1002021231,1},1},{{0,1004021231,1},1},{{0,1006021231,1},1},{{0,1008021231,1},1},{{0,1010021231,1},1}]','[]','[]'),(32081302,0,1000,0,3,0,1,0,'[{{0,1002031231,1},1},{{0,1004031231,1},1},{{0,1006031231,1},1},{{0,1008031231,1},1},{{0,1010031231,1},1}]','[]','[]'),(32081302,0,1000,0,4,0,1,0,'[{{0,1002041231,1},1},{{0,1004041231,1},1},{{0,1006041231,1},1},{{0,1008041231,1},1},{{0,1010041231,1},1}]','[]','[]'),(32081303,0,1000,0,1,0,1,0,'[{{0,1001011231,1},1},{{0,1007011231,1},1}]','[]','[]'),(32081303,0,1000,0,2,0,1,0,'[{{0,1001021231,1},1},{{0,1007021231,1},1}]','[]','[]'),(32081303,0,1000,0,3,0,1,0,'[{{0,1001031231,1},1},{{0,1007031231,1},1}]','[]','[]'),(32081303,0,1000,0,4,0,1,0,'[{{0,1001041231,1},1},{{0,1007041231,1},1}]','[]','[]'),(32081305,0,1000,0,1,0,1,0,'[{{0,1002011231,1},1},{{0,1004011231,1},1},{{0,1006011231,1},1},{{0,1008011231,1},1},{{0,1010011231,1},1},{{0,1001011231,1},1}]','[]','[]'),(32081305,0,1000,0,2,0,1,0,'[{{0,1002021231,1},1},{{0,1004021231,1},1},{{0,1006021231,1},1},{{0,1008021231,1},1},{{0,1010021231,1},1},{{0,1001021231,1},1}]','[]','[]'),(32081305,0,1000,0,3,0,1,0,'[{{0,1002031231,1},1},{{0,1004031231,1},1},{{0,1006031231,1},1},{{0,1008031231,1},1},{{0,1010031231,1},1},{{0,1001031231,1},1}]','[]','[]'),(32081305,0,1000,0,4,0,1,0,'[{{0,1002041231,1},1},{{0,1004041231,1},1},{{0,1006041231,1},1},{{0,1008041231,1},1},{{0,1010041231,1},1},{{0,1001041231,1},1}]','[]','[]'),(32081306,0,1000,0,1,0,1,0,'[{{0,1007011231,1},1},{{0,1003001231,1},1},{{0,1005001231,1},1},{{0,1009001231,1},1}]','[]','[]'),(32081306,0,1000,0,2,0,1,0,'[{{0,1007021231,1},1},{{0,1003001231,1},1},{{0,1005001231,1},1},{{0,1009001231,1},1}]','[]','[]'),(32081306,0,1000,0,3,0,1,0,'[{{0,1007031231,1},1},{{0,1003001231,1},1},{{0,1005001231,1},1},{{0,1009001231,1},1}]','[]','[]'),(32081306,0,1000,0,4,0,1,0,'[{{0,1007041231,1},1},{{0,1003001231,1},1},{{0,1005001231,1},1},{{0,1009001231,1},1}]','[]','[]'),(32081307,0,1000,0,1,0,1,0,'[{{0,1007011231,1},1},{{0,1003001231,1},1}]','[]','[]'),(32081307,0,1000,0,2,0,1,0,'[{{0,1007021231,1},1},{{0,1003001231,1},1}]','[]','[]'),(32081307,0,1000,0,3,0,1,0,'[{{0,1007031231,1},1},{{0,1003001231,1},1}]','[]','[]'),(32081307,0,1000,0,4,0,1,0,'[{{0,1007041231,1},1},{{0,1003001231,1},1}]','[]','[]'),(32081308,0,1000,0,0,0,1,0,'[{{0,1005001231,1},1},{{0,1009001231,1},1}]','[]','[]'),(32081311,0,1000,0,1,0,1,0,'[{{0,1001011332,1},1},{{0,1002011332,1},1},{{0,1003001332,1},1},{{0,1004011332,1},1},{{0,1006011332,1},1},{{0,1007011332,1},1},{{0,1008011332,1},1},{{0,1010011332,1},1}]','[]','[1001011332,1002011332,1003001332,1004011332,1005001332,1006011332,1007011332,1008011332,1009001332,1010011332]'),(32081311,0,1000,0,2,0,1,0,'[{{0,1001021332,1},1},{{0,1002021332,1},1},{{0,1003001332,1},1},{{0,1004021332,1},1},{{0,1006021332,1},1},{{0,1007021332,1},1},{{0,1008021332,1},1},{{0,1010021332,1},1}]','[]','[1001021332,1002021332,1003001332,1004021332,1005001332,1006021332,1007021332,1008021332,1009001332,1010021332]'),(32081311,0,1000,0,3,0,1,0,'[{{0,1001031332,1},1},{{0,1002031332,1},1},{{0,1003001332,1},1},{{0,1004031332,1},1},{{0,1006031332,1},1},{{0,1007031332,1},1},{{0,1008031332,1},1},{{0,1010031332,1},1}]','[]','[1001031332,1002031332,1003001332,1004031332,1005001332,1006031332,1007031332,1008031332,1009001332,1010031332]'),(32081311,0,1000,0,4,0,1,0,'[{{0,1001041332,1},1},{{0,1002041332,1},1},{{0,1003001332,1},1},{{0,1004041332,1},1},{{0,1006041332,1},1},{{0,1007041332,1},1},{{0,1008041332,1},1},{{0,1010041332,1},1}]','[]','[1001041332,1002041332,1003001332,1004041332,1005001332,1006041332,1007041332,1008041332,1009001332,1010041332]'),(32081312,0,1000,0,1,0,1,0,'[{{0,1002011332,1},1},{{0,1004011332,1},1},{{0,1006011332,1},1},{{0,1008011332,1},1},{{0,1010011332,1},1}]','[]','[1002011332,1004011332,1006011332,1008011332,1010011332]'),(32081312,0,1000,0,2,0,1,0,'[{{0,1002021332,1},1},{{0,1004021332,1},1},{{0,1006021332,1},1},{{0,1008021332,1},1},{{0,1010021332,1},1}]','[]','[1002021332,1004021332,1006021332,1008021332,1010021332]'),(32081312,0,1000,0,3,0,1,0,'[{{0,1002031332,1},1},{{0,1004031332,1},1},{{0,1006031332,1},1},{{0,1008031332,1},1},{{0,1010031332,1},1}]','[]','[1002031332,1004031332,1006031332,1008031332,1010031332]'),(32081312,0,1000,0,4,0,1,0,'[{{0,1002041332,1},1},{{0,1004041332,1},1},{{0,1006041332,1},1},{{0,1008041332,1},1},{{0,1010041332,1},1}]','[]','[1002041332,1004041332,1006041332,1008041332,1010041332]'),(32081313,0,1000,0,1,0,1,0,'[{{0,1001011332,1},1},{{0,1007011332,1},1}]','[]','[1001011332,1007011332]'),(32081313,0,1000,0,2,0,1,0,'[{{0,1001021332,1},1},{{0,1007021332,1},1}]','[]','[1001021332,1007021332]'),(32081313,0,1000,0,3,0,1,0,'[{{0,1001031332,1},1},{{0,1007031332,1},1}]','[]','[1001031332,1007031332]'),(32081313,0,1000,0,4,0,1,0,'[{{0,1001041332,1},1},{{0,1007041332,1},1}]','[]','[1001041332,1007041332]'),(32081315,0,1000,0,1,0,1,0,'[{{0,1002011332,1},1},{{0,1004011332,1},1},{{0,1006011332,1},1},{{0,1008011332,1},1},{{0,1010011332,1},1},{{0,1001011332,1},1}]','[]','[1002011332,1004011332,1006011332,1008011332,1010011332,1001011332]'),(32081315,0,1000,0,2,0,1,0,'[{{0,1002021332,1},1},{{0,1004021332,1},1},{{0,1006021332,1},1},{{0,1008021332,1},1},{{0,1010021332,1},1},{{0,1001021332,1},1}]','[]','[1002021332,1004021332,1006021332,1008021332,1010021332,1001021332]'),(32081315,0,1000,0,3,0,1,0,'[{{0,1002031332,1},1},{{0,1004031332,1},1},{{0,1006031332,1},1},{{0,1008031332,1},1},{{0,1010031332,1},1},{{0,1001031332,1},1}]','[]','[1002031332,1004031332,1006031332,1008031332,1010031332,1001031332]'),(32081315,0,1000,0,4,0,1,0,'[{{0,1002041332,1},1},{{0,1004041332,1},1},{{0,1006041332,1},1},{{0,1008041332,1},1},{{0,1010041332,1},1},{{0,1001041332,1},1}]','[]','[1002041332,1004041332,1006041332,1008041332,1010041332,1001041332]'),(32081316,0,1000,0,1,0,1,0,'[{{0,1007011332,1},1},{{0,1003001332,1},1},{{0,1005001332,1},1},{{0,1009001332,1},1}]','[]','[1007011332,1003001332,1005001332,1009001332]'),(32081316,0,1000,0,2,0,1,0,'[{{0,1007021332,1},1},{{0,1003001332,1},1},{{0,1005001332,1},1},{{0,1009001332,1},1}]','[]','[1007021332,1003001332,1005001332,1009001332]'),(32081316,0,1000,0,3,0,1,0,'[{{0,1007031332,1},1},{{0,1003001332,1},1},{{0,1005001332,1},1},{{0,1009001332,1},1}]','[]','[1007031332,1003001332,1005001332,1009001332]'),(32081316,0,1000,0,4,0,1,0,'[{{0,1007041332,1},1},{{0,1003001332,1},1},{{0,1005001332,1},1},{{0,1009001332,1},1}]','[]','[1007041332,1003001332,1005001332,1009001332]'),(32081317,0,1000,0,1,0,1,0,'[{{0,1007011332,1},1},{{0,1003001332,1},1}]','[]','[1007011332,1003001332]'),(32081317,0,1000,0,2,0,1,0,'[{{0,1007021332,1},1},{{0,1003001332,1},1}]','[]','[1007021332,1003001332]'),(32081317,0,1000,0,3,0,1,0,'[{{0,1007031332,1},1},{{0,1003001332,1},1}]','[]','[1007031332,1003001332]'),(32081317,0,1000,0,4,0,1,0,'[{{0,1007041332,1},1},{{0,1003001332,1},1}]','[]','[1007041332,1003001332]'),(32081318,0,1000,0,0,0,1,0,'[{{0,1005001332,1},1},{{0,1009001332,1},1}]','[]','[1005001332,1009001332]'),(32081321,0,1000,0,1,0,1,0,'[{{0,1001011341,1},1},{{0,1002011341,1},1},{{0,1003001341,1},1},{{0,1004011341,1},1},{{0,1006011341,1},1},{{0,1007011341,1},1},{{0,1008011341,1},1},{{0,1010011341,1},1}]','[]','[]'),(32081321,0,1000,0,2,0,1,0,'[{{0,1001021341,1},1},{{0,1002021341,1},1},{{0,1003001341,1},1},{{0,1004021341,1},1},{{0,1006021341,1},1},{{0,1007021341,1},1},{{0,1008021341,1},1},{{0,1010021341,1},1}]','[]','[]'),(32081321,0,1000,0,3,0,1,0,'[{{0,1001031341,1},1},{{0,1002031341,1},1},{{0,1003001341,1},1},{{0,1004031341,1},1},{{0,1006031341,1},1},{{0,1007031341,1},1},{{0,1008031341,1},1},{{0,1010031341,1},1}]','[]','[]'),(32081321,0,1000,0,4,0,1,0,'[{{0,1001041341,1},1},{{0,1002041341,1},1},{{0,1003001341,1},1},{{0,1004041341,1},1},{{0,1006041341,1},1},{{0,1007041341,1},1},{{0,1008041341,1},1},{{0,1010041341,1},1}]','[]','[]'),(32081322,0,1000,0,1,0,1,0,'[{{0,1002011341,1},1},{{0,1004011341,1},1},{{0,1006011341,1},1},{{0,1008011341,1},1},{{0,1010011341,1},1}]','[]','[]'),(32081322,0,1000,0,2,0,1,0,'[{{0,1002021341,1},1},{{0,1004021341,1},1},{{0,1006021341,1},1},{{0,1008021341,1},1},{{0,1010021341,1},1}]','[]','[]'),(32081322,0,1000,0,3,0,1,0,'[{{0,1002031341,1},1},{{0,1004031341,1},1},{{0,1006031341,1},1},{{0,1008031341,1},1},{{0,1010031341,1},1}]','[]','[]'),(32081322,0,1000,0,4,0,1,0,'[{{0,1002041341,1},1},{{0,1004041341,1},1},{{0,1006041341,1},1},{{0,1008041341,1},1},{{0,1010041341,1},1}]','[]','[]'),(32081323,0,1000,0,1,0,1,0,'[{{0,1001011341,1},1},{{0,1007011341,1},1}]','[]','[]'),(32081323,0,1000,0,2,0,1,0,'[{{0,1001021341,1},1},{{0,1007021341,1},1}]','[]','[]'),(32081323,0,1000,0,3,0,1,0,'[{{0,1001031341,1},1},{{0,1007031341,1},1}]','[]','[]'),(32081323,0,1000,0,4,0,1,0,'[{{0,1001041341,1},1},{{0,1007041341,1},1}]','[]','[]'),(32081325,0,1000,0,1,0,1,0,'[{{0,1002011341,1},1},{{0,1004011341,1},1},{{0,1006011341,1},1},{{0,1008011341,1},1},{{0,1010011341,1},1},{{0,1001011341,1},1}]','[]','[]'),(32081325,0,1000,0,2,0,1,0,'[{{0,1002021341,1},1},{{0,1004021341,1},1},{{0,1006021341,1},1},{{0,1008021341,1},1},{{0,1010021341,1},1},{{0,1001021341,1},1}]','[]','[]'),(32081325,0,1000,0,3,0,1,0,'[{{0,1002031341,1},1},{{0,1004031341,1},1},{{0,1006031341,1},1},{{0,1008031341,1},1},{{0,1010031341,1},1},{{0,1001031341,1},1}]','[]','[]'),(32081325,0,1000,0,4,0,1,0,'[{{0,1002041341,1},1},{{0,1004041341,1},1},{{0,1006041341,1},1},{{0,1008041341,1},1},{{0,1010041341,1},1},{{0,1001041341,1},1}]','[]','[]'),(32081326,0,1000,0,1,0,1,0,'[{{0,1007011341,1},1},{{0,1003001341,1},1},{{0,1005001341,1},1},{{0,1009001341,1},1}]','[]','[]'),(32081326,0,1000,0,2,0,1,0,'[{{0,1007021341,1},1},{{0,1003001341,1},1},{{0,1005001341,1},1},{{0,1009001341,1},1}]','[]','[]'),(32081326,0,1000,0,3,0,1,0,'[{{0,1007031341,1},1},{{0,1003001341,1},1},{{0,1005001341,1},1},{{0,1009001341,1},1}]','[]','[]'),(32081326,0,1000,0,4,0,1,0,'[{{0,1007041341,1},1},{{0,1003001341,1},1},{{0,1005001341,1},1},{{0,1009001341,1},1}]','[]','[]'),(32081327,0,1000,0,1,0,1,0,'[{{0,1007011341,1},1},{{0,1003001341,1},1}]','[]','[]'),(32081327,0,1000,0,2,0,1,0,'[{{0,1007021341,1},1},{{0,1003001341,1},1}]','[]','[]'),(32081327,0,1000,0,3,0,1,0,'[{{0,1007031341,1},1},{{0,1003001341,1},1}]','[]','[]'),(32081327,0,1000,0,4,0,1,0,'[{{0,1007041341,1},1},{{0,1003001341,1},1}]','[]','[]'),(32081328,0,1000,0,0,0,1,0,'[{{0,1005001341,1},1},{{0,1009001341,1},1}]','[]','[]'),(32081331,0,1000,0,1,0,1,0,'[{{0,1001011342,1},1},{{0,1002011342,1},1},{{0,1003001342,1},1},{{0,1004011342,1},1},{{0,1006011342,1},1},{{0,1007011342,1},1},{{0,1008011342,1},1},{{0,1010011342,1},1}]','[]','[1001011342,1002011342,1003001342,1004011342,1005001342,1006011342,1007011342,1008011342,1009001342,1010011342]'),(32081331,0,1000,0,2,0,1,0,'[{{0,1001021342,1},1},{{0,1002021342,1},1},{{0,1003001342,1},1},{{0,1004021342,1},1},{{0,1006021342,1},1},{{0,1007021342,1},1},{{0,1008021342,1},1},{{0,1010021342,1},1}]','[]','[1001021342,1002021342,1003001342,1004021342,1005001342,1006021342,1007021342,1008021342,1009001342,1010021342]'),(32081331,0,1000,0,3,0,1,0,'[{{0,1001031342,1},1},{{0,1002031342,1},1},{{0,1003001342,1},1},{{0,1004031342,1},1},{{0,1006031342,1},1},{{0,1007031342,1},1},{{0,1008031342,1},1},{{0,1010031342,1},1}]','[]','[1001031342,1002031342,1003001342,1004031342,1005001342,1006031342,1007031342,1008031342,1009001342,1010031342]'),(32081331,0,1000,0,4,0,1,0,'[{{0,1001041342,1},1},{{0,1002041342,1},1},{{0,1003001342,1},1},{{0,1004041342,1},1},{{0,1006041342,1},1},{{0,1007041342,1},1},{{0,1008041342,1},1},{{0,1010041342,1},1}]','[]','[1001041342,1002041342,1003001342,1004041342,1005001342,1006041342,1007041342,1008041342,1009001342,1010041342]'),(32081332,0,1000,0,1,0,1,0,'[{{0,1002011342,1},1},{{0,1004011342,1},1},{{0,1006011342,1},1},{{0,1008011342,1},1},{{0,1010011342,1},1}]','[]','[1002011342,1004011342,1006011342,1008011342,1010011342]'),(32081332,0,1000,0,2,0,1,0,'[{{0,1002021342,1},1},{{0,1004021342,1},1},{{0,1006021342,1},1},{{0,1008021342,1},1},{{0,1010021342,1},1}]','[]','[1002021342,1004021342,1006021342,1008021342,1010021342]'),(32081332,0,1000,0,3,0,1,0,'[{{0,1002031342,1},1},{{0,1004031342,1},1},{{0,1006031342,1},1},{{0,1008031342,1},1},{{0,1010031342,1},1}]','[]','[1002031342,1004031342,1006031342,1008031342,1010031342]'),(32081332,0,1000,0,4,0,1,0,'[{{0,1002041342,1},1},{{0,1004041342,1},1},{{0,1006041342,1},1},{{0,1008041342,1},1},{{0,1010041342,1},1}]','[]','[1002041342,1004041342,1006041342,1008041342,1010041342]'),(32081333,0,1000,0,1,0,1,0,'[{{0,1001011342,1},1},{{0,1007011342,1},1}]','[]','[1001011342,1007011342]'),(32081333,0,1000,0,2,0,1,0,'[{{0,1001021342,1},1},{{0,1007021342,1},1}]','[]','[1001021342,1007021342]'),(32081333,0,1000,0,3,0,1,0,'[{{0,1001031342,1},1},{{0,1007031342,1},1}]','[]','[1001031342,1007031342]'),(32081333,0,1000,0,4,0,1,0,'[{{0,1001041342,1},1},{{0,1007041342,1},1}]','[]','[1001041342,1007041342]'),(32081335,0,1000,0,1,0,1,0,'[{{0,1002011342,1},1},{{0,1004011342,1},1},{{0,1006011342,1},1},{{0,1008011342,1},1},{{0,1010011342,1},1},{{0,1001011342,1},1}]','[]','[1002011342,1004011342,1006011342,1008011342,1010011342,1001011342]'),(32081335,0,1000,0,2,0,1,0,'[{{0,1002021342,1},1},{{0,1004021342,1},1},{{0,1006021342,1},1},{{0,1008021342,1},1},{{0,1010021342,1},1},{{0,1001021342,1},1}]','[]','[1002021342,1004021342,1006021342,1008021342,1010021342,1001021342]'),(32081335,0,1000,0,3,0,1,0,'[{{0,1002031342,1},1},{{0,1004031342,1},1},{{0,1006031342,1},1},{{0,1008031342,1},1},{{0,1010031342,1},1},{{0,1001031342,1},1}]','[]','[1002031342,1004031342,1006031342,1008031342,1010031342,1001031342]'),(32081335,0,1000,0,4,0,1,0,'[{{0,1002041342,1},1},{{0,1004041342,1},1},{{0,1006041342,1},1},{{0,1008041342,1},1},{{0,1010041342,1},1},{{0,1001041342,1},1}]','[]','[1002041342,1004041342,1006041342,1008041342,1010041342,1001041342]'),(32081336,0,1000,0,1,0,1,0,'[{{0,1007011342,1},1},{{0,1003001342,1},1},{{0,1005001342,1},1},{{0,1009001342,1},1}]','[]','[1007011342,1003001342,1005001342,1009001342]'),(32081336,0,1000,0,2,0,1,0,'[{{0,1007021342,1},1},{{0,1003001342,1},1},{{0,1005001342,1},1},{{0,1009001342,1},1}]','[]','[1007021342,1003001342,1005001342,1009001342]'),(32081336,0,1000,0,3,0,1,0,'[{{0,1007031342,1},1},{{0,1003001342,1},1},{{0,1005001342,1},1},{{0,1009001342,1},1}]','[]','[1007031342,1003001342,1005001342,1009001342]'),(32081336,0,1000,0,4,0,1,0,'[{{0,1007041342,1},1},{{0,1003001342,1},1},{{0,1005001342,1},1},{{0,1009001342,1},1}]','[]','[1007041342,1003001342,1005001342,1009001342]'),(32081337,0,1000,0,1,0,1,0,'[{{0,1007011342,1},1},{{0,1003001342,1},1}]','[]','[1007011342,1003001342]'),(32081337,0,1000,0,2,0,1,0,'[{{0,1007021342,1},1},{{0,1003001342,1},1}]','[]','[1007021342,1003001342]'),(32081337,0,1000,0,3,0,1,0,'[{{0,1007031342,1},1},{{0,1003001342,1},1}]','[]','[1007031342,1003001342]'),(32081337,0,1000,0,4,0,1,0,'[{{0,1007041342,1},1},{{0,1003001342,1},1}]','[]','[1007041342,1003001342]'),(32081338,0,1000,0,0,0,1,0,'[{{0,1005001342,1},1},{{0,1009001342,1},1}]','[]','[1005001342,1009001342]'),(32081341,0,1000,0,1,0,1,0,'[{{0,1001011343,1},1},{{0,1002011343,1},1},{{0,1003001343,1},1},{{0,1004011343,1},1},{{0,1006011343,1},1},{{0,1007011343,1},1},{{0,1008011343,1},1},{{0,1010011343,1},1}]','[]','[1001011343,1002011343,1003001343,1004011343,1005001343,1006011343,1007011343,1008011343,1009001343,1010011343]'),(32081341,0,1000,0,2,0,1,0,'[{{0,1001021343,1},1},{{0,1002021343,1},1},{{0,1003001343,1},1},{{0,1004021343,1},1},{{0,1006021343,1},1},{{0,1007021343,1},1},{{0,1008021343,1},1},{{0,1010021343,1},1}]','[]','[1001021343,1002021343,1003001343,1004021343,1005001343,1006021343,1007021343,1008021343,1009001343,1010021343]'),(32081341,0,1000,0,3,0,1,0,'[{{0,1001031343,1},1},{{0,1002031343,1},1},{{0,1003001343,1},1},{{0,1004031343,1},1},{{0,1006031343,1},1},{{0,1007031343,1},1},{{0,1008031343,1},1},{{0,1010031343,1},1}]','[]','[1001031343,1002031343,1003001343,1004031343,1005001343,1006031343,1007031343,1008031343,1009001343,1010031343]'),(32081341,0,1000,0,4,0,1,0,'[{{0,1001041343,1},1},{{0,1002041343,1},1},{{0,1003001343,1},1},{{0,1004041343,1},1},{{0,1006041343,1},1},{{0,1007041343,1},1},{{0,1008041343,1},1},{{0,1010041343,1},1}]','[]','[1001041343,1002041343,1003001343,1004041343,1005001343,1006041343,1007041343,1008041343,1009001343,1010041343]'),(32081342,0,1000,0,1,0,1,0,'[{{0,1002011343,1},1},{{0,1004011343,1},1},{{0,1006011343,1},1},{{0,1008011343,1},1},{{0,1010011343,1},1}]','[]','[1002011343,1004011343,1006011343,1008011343,1010011343]'),(32081342,0,1000,0,2,0,1,0,'[{{0,1002021343,1},1},{{0,1004021343,1},1},{{0,1006021343,1},1},{{0,1008021343,1},1},{{0,1010021343,1},1}]','[]','[1002021343,1004021343,1006021343,1008021343,1010021343]'),(32081342,0,1000,0,3,0,1,0,'[{{0,1002031343,1},1},{{0,1004031343,1},1},{{0,1006031343,1},1},{{0,1008031343,1},1},{{0,1010031343,1},1}]','[]','[1002031343,1004031343,1006031343,1008031343,1010031343]'),(32081342,0,1000,0,4,0,1,0,'[{{0,1002041343,1},1},{{0,1004041343,1},1},{{0,1006041343,1},1},{{0,1008041343,1},1},{{0,1010041343,1},1}]','[]','[1002041343,1004041343,1006041343,1008041343,1010041343]'),(32081343,0,1000,0,1,0,1,0,'[{{0,1001011343,1},1},{{0,1007011343,1},1}]','[]','[1001011343,1007011343]'),(32081343,0,1000,0,2,0,1,0,'[{{0,1001021343,1},1},{{0,1007021343,1},1}]','[]','[1001021343,1007021343]'),(32081343,0,1000,0,3,0,1,0,'[{{0,1001031343,1},1},{{0,1007031343,1},1}]','[]','[1001031343,1007031343]'),(32081343,0,1000,0,4,0,1,0,'[{{0,1001041343,1},1},{{0,1007041343,1},1}]','[]','[1001041343,1007041343]'),(32081345,0,1000,0,1,0,1,0,'[{{0,1002011343,1},1},{{0,1004011343,1},1},{{0,1006011343,1},1},{{0,1008011343,1},1},{{0,1010011343,1},1},{{0,1001011343,1},1}]','[]','[1002011343,1004011343,1006011343,1008011343,1010011343,1001011343]'),(32081345,0,1000,0,2,0,1,0,'[{{0,1002021343,1},1},{{0,1004021343,1},1},{{0,1006021343,1},1},{{0,1008021343,1},1},{{0,1010021343,1},1},{{0,1001021343,1},1}]','[]','[1002021343,1004021343,1006021343,1008021343,1010021343,1001021343]'),(32081345,0,1000,0,3,0,1,0,'[{{0,1002031343,1},1},{{0,1004031343,1},1},{{0,1006031343,1},1},{{0,1008031343,1},1},{{0,1010031343,1},1},{{0,1001031343,1},1}]','[]','[1002031343,1004031343,1006031343,1008031343,1010031343,1001031343]'),(32081345,0,1000,0,4,0,1,0,'[{{0,1002041343,1},1},{{0,1004041343,1},1},{{0,1006041343,1},1},{{0,1008041343,1},1},{{0,1010041343,1},1},{{0,1001041343,1},1}]','[]','[1002041343,1004041343,1006041343,1008041343,1010041343,1001041343]'),(32081346,0,1000,0,1,0,1,0,'[{{0,1007011343,1},1},{{0,1003001343,1},1},{{0,1005001343,1},1},{{0,1009001343,1},1}]','[]','[1007011343,1003001343,1005001343,1009001343]'),(32081346,0,1000,0,2,0,1,0,'[{{0,1007021343,1},1},{{0,1003001343,1},1},{{0,1005001343,1},1},{{0,1009001343,1},1}]','[]','[1007021343,1003001343,1005001343,1009001343]'),(32081346,0,1000,0,3,0,1,0,'[{{0,1007031343,1},1},{{0,1003001343,1},1},{{0,1005001343,1},1},{{0,1009001343,1},1}]','[]','[1007031343,1003001343,1005001343,1009001343]'),(32081346,0,1000,0,4,0,1,0,'[{{0,1007041343,1},1},{{0,1003001343,1},1},{{0,1005001343,1},1},{{0,1009001343,1},1}]','[]','[1007041343,1003001343,1005001343,1009001343]'),(32081347,0,1000,0,1,0,1,0,'[{{0,1007011343,1},1},{{0,1003001343,1},1}]','[]','[1007011343,1003001343]'),(32081347,0,1000,0,2,0,1,0,'[{{0,1007021343,1},1},{{0,1003001343,1},1}]','[]','[1007021343,1003001343]'),(32081347,0,1000,0,3,0,1,0,'[{{0,1007031343,1},1},{{0,1003001343,1},1}]','[]','[1007031343,1003001343]'),(32081347,0,1000,0,4,0,1,0,'[{{0,1007041343,1},1},{{0,1003001343,1},1}]','[]','[1007041343,1003001343]'),(32081348,0,1000,0,0,0,1,0,'[{{0,1005001343,1},1},{{0,1009001343,1},1}]','[]','[1005001343,1009001343]'),(32081351,0,1000,0,1,0,1,0,'[{{0,1001011353,1},1},{{0,1002011353,1},1},{{0,1003001353,1},1},{{0,1004011353,1},1},{{0,1006011353,1},1},{{0,1007011353,1},1},{{0,1008011353,1},1},{{0,1010011353,1},1}]','[]','[1001011353,1002011353,1003001353,1004011353,1005001353,1006011353,1007011353,1008011353,1009001353,1010011353]'),(32081351,0,1000,0,2,0,1,0,'[{{0,1001021353,1},1},{{0,1002021353,1},1},{{0,1003001353,1},1},{{0,1004021353,1},1},{{0,1006021353,1},1},{{0,1007021353,1},1},{{0,1008021353,1},1},{{0,1010021353,1},1}]','[]','[1001021353,1002021353,1003001353,1004021353,1005001353,1006021353,1007021353,1008021353,1009001353,1010021353]'),(32081351,0,1000,0,3,0,1,0,'[{{0,1001031353,1},1},{{0,1002031353,1},1},{{0,1003001353,1},1},{{0,1004031353,1},1},{{0,1006031353,1},1},{{0,1007031353,1},1},{{0,1008031353,1},1},{{0,1010031353,1},1}]','[]','[1001031353,1002031353,1003001353,1004031353,1005001353,1006031353,1007031353,1008031353,1009001353,1010031353]'),(32081351,0,1000,0,4,0,1,0,'[{{0,1001041353,1},1},{{0,1002041353,1},1},{{0,1003001353,1},1},{{0,1004041353,1},1},{{0,1006041353,1},1},{{0,1007041353,1},1},{{0,1008041353,1},1},{{0,1010041353,1},1}]','[]','[1001041353,1002041353,1003001353,1004041353,1005001353,1006041353,1007041353,1008041353,1009001353,1010041353]'),(32081352,0,1000,0,1,0,1,0,'[{{0,1002011353,1},1},{{0,1004011353,1},1},{{0,1006011353,1},1},{{0,1008011353,1},1},{{0,1010011353,1},1}]','[]','[1002011353,1004011353,1006011353,1008011353,1010011353]'),(32081352,0,1000,0,2,0,1,0,'[{{0,1002021353,1},1},{{0,1004021353,1},1},{{0,1006021353,1},1},{{0,1008021353,1},1},{{0,1010021353,1},1}]','[]','[1002021353,1004021353,1006021353,1008021353,1010021353]'),(32081352,0,1000,0,3,0,1,0,'[{{0,1002031353,1},1},{{0,1004031353,1},1},{{0,1006031353,1},1},{{0,1008031353,1},1},{{0,1010031353,1},1}]','[]','[1002031353,1004031353,1006031353,1008031353,1010031353]'),(32081352,0,1000,0,4,0,1,0,'[{{0,1002041353,1},1},{{0,1004041353,1},1},{{0,1006041353,1},1},{{0,1008041353,1},1},{{0,1010041353,1},1}]','[]','[1002041353,1004041353,1006041353,1008041353,1010041353]'),(32081353,0,1000,0,1,0,1,0,'[{{0,1001011353,1},1},{{0,1007011353,1},1}]','[]','[1001011353,1007011353]'),(32081353,0,1000,0,2,0,1,0,'[{{0,1001021353,1},1},{{0,1007021353,1},1}]','[]','[1001021353,1007021353]'),(32081353,0,1000,0,3,0,1,0,'[{{0,1001031353,1},1},{{0,1007031353,1},1}]','[]','[1001031353,1007031353]'),(32081353,0,1000,0,4,0,1,0,'[{{0,1001041353,1},1},{{0,1007041353,1},1}]','[]','[1001041353,1007041353]'),(32081355,0,1000,0,1,0,1,0,'[{{0,1002011353,1},1},{{0,1004011353,1},1},{{0,1006011353,1},1},{{0,1008011353,1},1},{{0,1010011353,1},1},{{0,1001011353,1},1}]','[]','[1002011353,1004011353,1006011353,1008011353,1010011353,1001011353]'),(32081355,0,1000,0,2,0,1,0,'[{{0,1002021353,1},1},{{0,1004021353,1},1},{{0,1006021353,1},1},{{0,1008021353,1},1},{{0,1010021353,1},1},{{0,1001021353,1},1}]','[]','[1002021353,1004021353,1006021353,1008021353,1010021353,1001021353]'),(32081355,0,1000,0,3,0,1,0,'[{{0,1002031353,1},1},{{0,1004031353,1},1},{{0,1006031353,1},1},{{0,1008031353,1},1},{{0,1010031353,1},1},{{0,1001031353,1},1}]','[]','[1002031353,1004031353,1006031353,1008031353,1010031353,1001031353]'),(32081355,0,1000,0,4,0,1,0,'[{{0,1002041353,1},1},{{0,1004041353,1},1},{{0,1006041353,1},1},{{0,1008041353,1},1},{{0,1010041353,1},1},{{0,1001041353,1},1}]','[]','[1002041353,1004041353,1006041353,1008041353,1010041353,1001041353]'),(32081356,0,1000,0,1,0,1,0,'[{{0,1007011353,1},1},{{0,1003001353,1},1},{{0,1005001353,1},1},{{0,1009001353,1},1}]','[]','[1007011353,1003001353,1005001353,1009001353]'),(32081356,0,1000,0,2,0,1,0,'[{{0,1007021353,1},1},{{0,1003001353,1},1},{{0,1005001353,1},1},{{0,1009001353,1},1}]','[]','[1007021353,1003001353,1005001353,1009001353]'),(32081356,0,1000,0,3,0,1,0,'[{{0,1007031353,1},1},{{0,1003001353,1},1},{{0,1005001353,1},1},{{0,1009001353,1},1}]','[]','[1007031353,1003001353,1005001353,1009001353]'),(32081356,0,1000,0,4,0,1,0,'[{{0,1007041353,1},1},{{0,1003001353,1},1},{{0,1005001353,1},1},{{0,1009001353,1},1}]','[]','[1007041353,1003001353,1005001353,1009001353]'),(32081357,0,1000,0,1,0,1,0,'[{{0,1007011353,1},1},{{0,1003001353,1},1}]','[]','[1007011353,1003001353]'),(32081357,0,1000,0,2,0,1,0,'[{{0,1007021353,1},1},{{0,1003001353,1},1}]','[]','[1007021353,1003001353]'),(32081357,0,1000,0,3,0,1,0,'[{{0,1007031353,1},1},{{0,1003001353,1},1}]','[]','[1007031353,1003001353]'),(32081357,0,1000,0,4,0,1,0,'[{{0,1007041353,1},1},{{0,1003001353,1},1}]','[]','[1007041353,1003001353]'),(32081358,0,1000,0,0,0,1,0,'[{{0,1005001353,1},1},{{0,1009001353,1},1}]','[]','[1005001353,1009001353]'),(32081361,0,1000,0,1,0,1,0,'[{{0,1001011363,1},1},{{0,1002011363,1},1},{{0,1003001363,1},1},{{0,1004011363,1},1},{{0,1006011363,1},1},{{0,1007011363,1},1},{{0,1008011363,1},1},{{0,1010011363,1},1}]','[]','[1001011363,1002011363,1003001363,1004011363,1005001363,1006011363,1007011363,1008011363,1009001363,1010011363]'),(32081361,0,1000,0,2,0,1,0,'[{{0,1001021363,1},1},{{0,1002021363,1},1},{{0,1003001363,1},1},{{0,1004021363,1},1},{{0,1006021363,1},1},{{0,1007021363,1},1},{{0,1008021363,1},1},{{0,1010021363,1},1}]','[]','[1001021363,1002021363,1003001363,1004021363,1005001363,1006021363,1007021363,1008021363,1009001363,1010021363]'),(32081361,0,1000,0,3,0,1,0,'[{{0,1001031363,1},1},{{0,1002031363,1},1},{{0,1003001363,1},1},{{0,1004031363,1},1},{{0,1006031363,1},1},{{0,1007031363,1},1},{{0,1008031363,1},1},{{0,1010031363,1},1}]','[]','[1001031363,1002031363,1003001363,1004031363,1005001363,1006031363,1007031363,1008031363,1009001363,1010031363]'),(32081361,0,1000,0,4,0,1,0,'[{{0,1001041363,1},1},{{0,1002041363,1},1},{{0,1003001363,1},1},{{0,1004041363,1},1},{{0,1006041363,1},1},{{0,1007041363,1},1},{{0,1008041363,1},1},{{0,1010041363,1},1}]','[]','[1001041363,1002041363,1003001363,1004041363,1005001363,1006041363,1007041363,1008041363,1009001363,1010041363]'),(32081362,0,1000,0,1,0,1,0,'[{{0,1002011363,1},1},{{0,1004011363,1},1},{{0,1006011363,1},1},{{0,1008011363,1},1},{{0,1010011363,1},1}]','[]','[1002011363,1004011363,1006011363,1008011363,1010011363]'),(32081362,0,1000,0,2,0,1,0,'[{{0,1002021363,1},1},{{0,1004021363,1},1},{{0,1006021363,1},1},{{0,1008021363,1},1},{{0,1010021363,1},1}]','[]','[1002021363,1004021363,1006021363,1008021363,1010021363]'),(32081362,0,1000,0,3,0,1,0,'[{{0,1002031363,1},1},{{0,1004031363,1},1},{{0,1006031363,1},1},{{0,1008031363,1},1},{{0,1010031363,1},1}]','[]','[1002031363,1004031363,1006031363,1008031363,1010031363]'),(32081362,0,1000,0,4,0,1,0,'[{{0,1002041363,1},1},{{0,1004041363,1},1},{{0,1006041363,1},1},{{0,1008041363,1},1},{{0,1010041363,1},1}]','[]','[1002041363,1004041363,1006041363,1008041363,1010041363]'),(32081363,0,1000,0,1,0,1,0,'[{{0,1001011363,1},1},{{0,1007011363,1},1}]','[]','[1001011363,1007011363]'),(32081363,0,1000,0,2,0,1,0,'[{{0,1001021363,1},1},{{0,1007021363,1},1}]','[]','[1001021363,1007021363]'),(32081363,0,1000,0,3,0,1,0,'[{{0,1001031363,1},1},{{0,1007031363,1},1}]','[]','[1001031363,1007031363]'),(32081363,0,1000,0,4,0,1,0,'[{{0,1001041363,1},1},{{0,1007041363,1},1}]','[]','[1001041363,1007041363]'),(32081365,0,1000,0,1,0,1,0,'[{{0,1002011363,1},1},{{0,1004011363,1},1},{{0,1006011363,1},1},{{0,1008011363,1},1},{{0,1010011363,1},1},{{0,1001011363,1},1}]','[]','[1002011363,1004011363,1006011363,1008011363,1010011363,1001011363]'),(32081365,0,1000,0,2,0,1,0,'[{{0,1002021363,1},1},{{0,1004021363,1},1},{{0,1006021363,1},1},{{0,1008021363,1},1},{{0,1010021363,1},1},{{0,1001021363,1},1}]','[]','[1002021363,1004021363,1006021363,1008021363,1010021363,1001021363]'),(32081365,0,1000,0,3,0,1,0,'[{{0,1002031363,1},1},{{0,1004031363,1},1},{{0,1006031363,1},1},{{0,1008031363,1},1},{{0,1010031363,1},1},{{0,1001031363,1},1}]','[]','[1002031363,1004031363,1006031363,1008031363,1010031363,1001031363]'),(32081365,0,1000,0,4,0,1,0,'[{{0,1002041363,1},1},{{0,1004041363,1},1},{{0,1006041363,1},1},{{0,1008041363,1},1},{{0,1010041363,1},1},{{0,1001041363,1},1}]','[]','[1002041363,1004041363,1006041363,1008041363,1010041363,1001041363]'),(32081366,0,1000,0,1,0,1,0,'[{{0,1007011363,1},1},{{0,1003001363,1},1},{{0,1005001363,1},1},{{0,1009001363,1},1}]','[]','[1007011363,1003001363,1005001363,1009001363]'),(32081366,0,1000,0,2,0,1,0,'[{{0,1007021363,1},1},{{0,1003001363,1},1},{{0,1005001363,1},1},{{0,1009001363,1},1}]','[]','[1007021363,1003001363,1005001363,1009001363]'),(32081366,0,1000,0,3,0,1,0,'[{{0,1007031363,1},1},{{0,1003001363,1},1},{{0,1005001363,1},1},{{0,1009001363,1},1}]','[]','[1007031363,1003001363,1005001363,1009001363]'),(32081366,0,1000,0,4,0,1,0,'[{{0,1007041363,1},1},{{0,1003001363,1},1},{{0,1005001363,1},1},{{0,1009001363,1},1}]','[]','[1007041363,1003001363,1005001363,1009001363]'),(32081367,0,1000,0,1,0,1,0,'[{{0,1007011363,1},1},{{0,1003001363,1},1}]','[]','[1007011363,1003001363]'),(32081367,0,1000,0,2,0,1,0,'[{{0,1007021363,1},1},{{0,1003001363,1},1}]','[]','[1007021363,1003001363]'),(32081367,0,1000,0,3,0,1,0,'[{{0,1007031363,1},1},{{0,1003001363,1},1}]','[]','[1007031363,1003001363]'),(32081367,0,1000,0,4,0,1,0,'[{{0,1007041363,1},1},{{0,1003001363,1},1}]','[]','[1007041363,1003001363]'),(32081368,0,1000,0,0,0,1,0,'[{{0,1005001363,1},1},{{0,1009001363,1},1}]','[]','[1005001363,1009001363]'),(32081371,0,1000,0,1,0,1,0,'[{{0,1001011300,1},1},{{0,1002011300,1},1},{{0,1003001300,1},1},{{0,1004011300,1},1},{{0,1006011300,1},1},{{0,1007011300,1},1},{{0,1008011300,1},1},{{0,1010011300,1},1}]','[]','[]'),(32081371,0,1000,0,2,0,1,0,'[{{0,1001021300,1},1},{{0,1002021300,1},1},{{0,1003001300,1},1},{{0,1004021300,1},1},{{0,1006021300,1},1},{{0,1007021300,1},1},{{0,1008021300,1},1},{{0,1010021300,1},1}]','[]','[]'),(32081371,0,1000,0,3,0,1,0,'[{{0,1001031300,1},1},{{0,1002031300,1},1},{{0,1003001300,1},1},{{0,1004031300,1},1},{{0,1006031300,1},1},{{0,1007031300,1},1},{{0,1008031300,1},1},{{0,1010031300,1},1}]','[]','[]'),(32081371,0,1000,0,4,0,1,0,'[{{0,1001041300,1},1},{{0,1002041300,1},1},{{0,1003001300,1},1},{{0,1004041300,1},1},{{0,1006041300,1},1},{{0,1007041300,1},1},{{0,1008041300,1},1},{{0,1010041300,1},1}]','[]','[]'),(32081372,0,1000,0,1,0,1,0,'[{{0,1002011300,1},1},{{0,1004011300,1},1},{{0,1006011300,1},1},{{0,1008011300,1},1},{{0,1010011300,1},1}]','[]','[]'),(32081372,0,1000,0,2,0,1,0,'[{{0,1002021300,1},1},{{0,1004021300,1},1},{{0,1006021300,1},1},{{0,1008021300,1},1},{{0,1010021300,1},1}]','[]','[]'),(32081372,0,1000,0,3,0,1,0,'[{{0,1002031300,1},1},{{0,1004031300,1},1},{{0,1006031300,1},1},{{0,1008031300,1},1},{{0,1010031300,1},1}]','[]','[]'),(32081372,0,1000,0,4,0,1,0,'[{{0,1002041300,1},1},{{0,1004041300,1},1},{{0,1006041300,1},1},{{0,1008041300,1},1},{{0,1010041300,1},1}]','[]','[]'),(32081373,0,1000,0,1,0,1,0,'[{{0,1001011300,1},1},{{0,1007011300,1},1}]','[]','[]'),(32081373,0,1000,0,2,0,1,0,'[{{0,1001021300,1},1},{{0,1007021300,1},1}]','[]','[]'),(32081373,0,1000,0,3,0,1,0,'[{{0,1001031300,1},1},{{0,1007031300,1},1}]','[]','[]'),(32081373,0,1000,0,4,0,1,0,'[{{0,1001041300,1},1},{{0,1007041300,1},1}]','[]','[]'),(32081375,0,1000,0,1,0,1,0,'[{{0,1002011300,1},1},{{0,1004011300,1},1},{{0,1006011300,1},1},{{0,1008011300,1},1},{{0,1010011300,1},1},{{0,1001011300,1},1}]','[]','[]'),(32081375,0,1000,0,2,0,1,0,'[{{0,1002021300,1},1},{{0,1004021300,1},1},{{0,1006021300,1},1},{{0,1008021300,1},1},{{0,1010021300,1},1},{{0,1001021300,1},1}]','[]','[]'),(32081375,0,1000,0,3,0,1,0,'[{{0,1002031300,1},1},{{0,1004031300,1},1},{{0,1006031300,1},1},{{0,1008031300,1},1},{{0,1010031300,1},1},{{0,1001031300,1},1}]','[]','[]'),(32081375,0,1000,0,4,0,1,0,'[{{0,1002041300,1},1},{{0,1004041300,1},1},{{0,1006041300,1},1},{{0,1008041300,1},1},{{0,1010041300,1},1},{{0,1001041300,1},1}]','[]','[]'),(32081376,0,1000,0,1,0,1,0,'[{{0,1007011300,1},1},{{0,1003001300,1},1},{{0,1005001300,1},1},{{0,1009001300,1},1}]','[]','[]'),(32081376,0,1000,0,2,0,1,0,'[{{0,1007021300,1},1},{{0,1003001300,1},1},{{0,1005001300,1},1},{{0,1009001300,1},1}]','[]','[]'),(32081376,0,1000,0,3,0,1,0,'[{{0,1007031300,1},1},{{0,1003001300,1},1},{{0,1005001300,1},1},{{0,1009001300,1},1}]','[]','[]'),(32081376,0,1000,0,4,0,1,0,'[{{0,1007041300,1},1},{{0,1003001300,1},1},{{0,1005001300,1},1},{{0,1009001300,1},1}]','[]','[]'),(32081377,0,1000,0,1,0,1,0,'[{{0,1007011300,1},1},{{0,1003001300,1},1}]','[]','[]'),(32081377,0,1000,0,2,0,1,0,'[{{0,1007021300,1},1},{{0,1003001300,1},1}]','[]','[]'),(32081377,0,1000,0,3,0,1,0,'[{{0,1007031300,1},1},{{0,1003001300,1},1}]','[]','[]'),(32081377,0,1000,0,4,0,1,0,'[{{0,1007041300,1},1},{{0,1003001300,1},1}]','[]','[]'),(32081378,0,1000,0,0,0,1,0,'[{{0,1005001300,1},1},{{0,1009001300,1},1}]','[]','[]'),(32081381,0,1000,0,1,0,1,0,'[{{0,1001011310,1},1},{{0,1002011310,1},1},{{0,1003001310,1},1},{{0,1004011310,1},1},{{0,1006011310,1},1},{{0,1007011310,1},1},{{0,1008011310,1},1},{{0,1010011310,1},1}]','[]','[]'),(32081381,0,1000,0,2,0,1,0,'[{{0,1001021310,1},1},{{0,1002021310,1},1},{{0,1003001310,1},1},{{0,1004021310,1},1},{{0,1006021310,1},1},{{0,1007021310,1},1},{{0,1008021310,1},1},{{0,1010021310,1},1}]','[]','[]'),(32081381,0,1000,0,3,0,1,0,'[{{0,1001031310,1},1},{{0,1002031310,1},1},{{0,1003001310,1},1},{{0,1004031310,1},1},{{0,1006031310,1},1},{{0,1007031310,1},1},{{0,1008031310,1},1},{{0,1010031310,1},1}]','[]','[]'),(32081381,0,1000,0,4,0,1,0,'[{{0,1001041310,1},1},{{0,1002041310,1},1},{{0,1003001310,1},1},{{0,1004041310,1},1},{{0,1006041310,1},1},{{0,1007041310,1},1},{{0,1008041310,1},1},{{0,1010041310,1},1}]','[]','[]'),(32081382,0,1000,0,1,0,1,0,'[{{0,1002011310,1},1},{{0,1004011310,1},1},{{0,1006011310,1},1},{{0,1008011310,1},1},{{0,1010011310,1},1}]','[]','[]'),(32081382,0,1000,0,2,0,1,0,'[{{0,1002021310,1},1},{{0,1004021310,1},1},{{0,1006021310,1},1},{{0,1008021310,1},1},{{0,1010021310,1},1}]','[]','[]'),(32081382,0,1000,0,3,0,1,0,'[{{0,1002031310,1},1},{{0,1004031310,1},1},{{0,1006031310,1},1},{{0,1008031310,1},1},{{0,1010031310,1},1}]','[]','[]'),(32081382,0,1000,0,4,0,1,0,'[{{0,1002041310,1},1},{{0,1004041310,1},1},{{0,1006041310,1},1},{{0,1008041310,1},1},{{0,1010041310,1},1}]','[]','[]'),(32081383,0,1000,0,1,0,1,0,'[{{0,1001011310,1},1},{{0,1007011310,1},1}]','[]','[]'),(32081383,0,1000,0,2,0,1,0,'[{{0,1001021310,1},1},{{0,1007021310,1},1}]','[]','[]'),(32081383,0,1000,0,3,0,1,0,'[{{0,1001031310,1},1},{{0,1007031310,1},1}]','[]','[]'),(32081383,0,1000,0,4,0,1,0,'[{{0,1001041310,1},1},{{0,1007041310,1},1}]','[]','[]'),(32081385,0,1000,0,1,0,1,0,'[{{0,1002011310,1},1},{{0,1004011310,1},1},{{0,1006011310,1},1},{{0,1008011310,1},1},{{0,1010011310,1},1},{{0,1001011310,1},1}]','[]','[]'),(32081385,0,1000,0,2,0,1,0,'[{{0,1002021310,1},1},{{0,1004021310,1},1},{{0,1006021310,1},1},{{0,1008021310,1},1},{{0,1010021310,1},1},{{0,1001021310,1},1}]','[]','[]'),(32081385,0,1000,0,3,0,1,0,'[{{0,1002031310,1},1},{{0,1004031310,1},1},{{0,1006031310,1},1},{{0,1008031310,1},1},{{0,1010031310,1},1},{{0,1001031310,1},1}]','[]','[]'),(32081385,0,1000,0,4,0,1,0,'[{{0,1002041310,1},1},{{0,1004041310,1},1},{{0,1006041310,1},1},{{0,1008041310,1},1},{{0,1010041310,1},1},{{0,1001041310,1},1}]','[]','[]'),(32081386,0,1000,0,1,0,1,0,'[{{0,1007011310,1},1},{{0,1003001310,1},1},{{0,1005001310,1},1},{{0,1009001310,1},1}]','[]','[]'),(32081386,0,1000,0,2,0,1,0,'[{{0,1007021310,1},1},{{0,1003001310,1},1},{{0,1005001310,1},1},{{0,1009001310,1},1}]','[]','[]'),(32081386,0,1000,0,3,0,1,0,'[{{0,1007031310,1},1},{{0,1003001310,1},1},{{0,1005001310,1},1},{{0,1009001310,1},1}]','[]','[]'),(32081386,0,1000,0,4,0,1,0,'[{{0,1007041310,1},1},{{0,1003001310,1},1},{{0,1005001310,1},1},{{0,1009001310,1},1}]','[]','[]'),(32081387,0,1000,0,1,0,1,0,'[{{0,1007011310,1},1},{{0,1003001310,1},1}]','[]','[]'),(32081387,0,1000,0,2,0,1,0,'[{{0,1007021310,1},1},{{0,1003001310,1},1}]','[]','[]'),(32081387,0,1000,0,3,0,1,0,'[{{0,1007031310,1},1},{{0,1003001310,1},1}]','[]','[]'),(32081387,0,1000,0,4,0,1,0,'[{{0,1007041310,1},1},{{0,1003001310,1},1}]','[]','[]'),(32081388,0,1000,0,0,0,1,0,'[{{0,1005001310,1},1},{{0,1009001310,1},1}]','[]','[]'),(32081391,0,1000,0,1,0,1,0,'[{{0,1001011320,1},1},{{0,1002011320,1},1},{{0,1003001320,1},1},{{0,1004011320,1},1},{{0,1006011320,1},1},{{0,1007011320,1},1},{{0,1008011320,1},1},{{0,1010011320,1},1}]','[]','[]'),(32081391,0,1000,0,2,0,1,0,'[{{0,1001021320,1},1},{{0,1002021320,1},1},{{0,1003001320,1},1},{{0,1004021320,1},1},{{0,1006021320,1},1},{{0,1007021320,1},1},{{0,1008021320,1},1},{{0,1010021320,1},1}]','[]','[]'),(32081391,0,1000,0,3,0,1,0,'[{{0,1001031320,1},1},{{0,1002031320,1},1},{{0,1003001320,1},1},{{0,1004031320,1},1},{{0,1006031320,1},1},{{0,1007031320,1},1},{{0,1008031320,1},1},{{0,1010031320,1},1}]','[]','[]'),(32081391,0,1000,0,4,0,1,0,'[{{0,1001041320,1},1},{{0,1002041320,1},1},{{0,1003001320,1},1},{{0,1004041320,1},1},{{0,1006041320,1},1},{{0,1007041320,1},1},{{0,1008041320,1},1},{{0,1010041320,1},1}]','[]','[]'),(32081392,0,1000,0,1,0,1,0,'[{{0,1002011320,1},1},{{0,1004011320,1},1},{{0,1006011320,1},1},{{0,1008011320,1},1},{{0,1010011320,1},1}]','[]','[]'),(32081392,0,1000,0,2,0,1,0,'[{{0,1002021320,1},1},{{0,1004021320,1},1},{{0,1006021320,1},1},{{0,1008021320,1},1},{{0,1010021320,1},1}]','[]','[]'),(32081392,0,1000,0,3,0,1,0,'[{{0,1002031320,1},1},{{0,1004031320,1},1},{{0,1006031320,1},1},{{0,1008031320,1},1},{{0,1010031320,1},1}]','[]','[]'),(32081392,0,1000,0,4,0,1,0,'[{{0,1002041320,1},1},{{0,1004041320,1},1},{{0,1006041320,1},1},{{0,1008041320,1},1},{{0,1010041320,1},1}]','[]','[]'),(32081393,0,1000,0,1,0,1,0,'[{{0,1001011320,1},1},{{0,1007011320,1},1}]','[]','[]'),(32081393,0,1000,0,2,0,1,0,'[{{0,1001021320,1},1},{{0,1007021320,1},1}]','[]','[]'),(32081393,0,1000,0,3,0,1,0,'[{{0,1001031320,1},1},{{0,1007031320,1},1}]','[]','[]'),(32081393,0,1000,0,4,0,1,0,'[{{0,1001041320,1},1},{{0,1007041320,1},1}]','[]','[]'),(32081395,0,1000,0,1,0,1,0,'[{{0,1002011320,1},1},{{0,1004011320,1},1},{{0,1006011320,1},1},{{0,1008011320,1},1},{{0,1010011320,1},1},{{0,1001011320,1},1}]','[]','[]'),(32081395,0,1000,0,2,0,1,0,'[{{0,1002021320,1},1},{{0,1004021320,1},1},{{0,1006021320,1},1},{{0,1008021320,1},1},{{0,1010021320,1},1},{{0,1001021320,1},1}]','[]','[]'),(32081395,0,1000,0,3,0,1,0,'[{{0,1002031320,1},1},{{0,1004031320,1},1},{{0,1006031320,1},1},{{0,1008031320,1},1},{{0,1010031320,1},1},{{0,1001031320,1},1}]','[]','[]'),(32081395,0,1000,0,4,0,1,0,'[{{0,1002041320,1},1},{{0,1004041320,1},1},{{0,1006041320,1},1},{{0,1008041320,1},1},{{0,1010041320,1},1},{{0,1001041320,1},1}]','[]','[]'),(32081396,0,1000,0,1,0,1,0,'[{{0,1007011320,1},1},{{0,1003001320,1},1},{{0,1005001320,1},1},{{0,1009001320,1},1}]','[]','[]'),(32081396,0,1000,0,2,0,1,0,'[{{0,1007021320,1},1},{{0,1003001320,1},1},{{0,1005001320,1},1},{{0,1009001320,1},1}]','[]','[]'),(32081396,0,1000,0,3,0,1,0,'[{{0,1007031320,1},1},{{0,1003001320,1},1},{{0,1005001320,1},1},{{0,1009001320,1},1}]','[]','[]'),(32081396,0,1000,0,4,0,1,0,'[{{0,1007041320,1},1},{{0,1003001320,1},1},{{0,1005001320,1},1},{{0,1009001320,1},1}]','[]','[]'),(32081397,0,1000,0,1,0,1,0,'[{{0,1007011320,1},1},{{0,1003001320,1},1}]','[]','[]'),(32081397,0,1000,0,2,0,1,0,'[{{0,1007021320,1},1},{{0,1003001320,1},1}]','[]','[]'),(32081397,0,1000,0,3,0,1,0,'[{{0,1007031320,1},1},{{0,1003001320,1},1}]','[]','[]'),(32081397,0,1000,0,4,0,1,0,'[{{0,1007041320,1},1},{{0,1003001320,1},1}]','[]','[]'),(32081398,0,1000,0,0,0,1,0,'[{{0,1005001320,1},1},{{0,1009001320,1},1}]','[]','[]'),(32081401,0,1000,0,1,0,1,0,'[{{0,1001011331,1},1},{{0,1002011331,1},1},{{0,1003001331,1},1},{{0,1004011331,1},1},{{0,1006011331,1},1},{{0,1007011331,1},1},{{0,1008011331,1},1},{{0,1010011331,1},1}]','[]','[]'),(32081401,0,1000,0,2,0,1,0,'[{{0,1001021331,1},1},{{0,1002021331,1},1},{{0,1003001331,1},1},{{0,1004021331,1},1},{{0,1006021331,1},1},{{0,1007021331,1},1},{{0,1008021331,1},1},{{0,1010021331,1},1}]','[]','[]'),(32081401,0,1000,0,3,0,1,0,'[{{0,1001031331,1},1},{{0,1002031331,1},1},{{0,1003001331,1},1},{{0,1004031331,1},1},{{0,1006031331,1},1},{{0,1007031331,1},1},{{0,1008031331,1},1},{{0,1010031331,1},1}]','[]','[]'),(32081401,0,1000,0,4,0,1,0,'[{{0,1001041331,1},1},{{0,1002041331,1},1},{{0,1003001331,1},1},{{0,1004041331,1},1},{{0,1006041331,1},1},{{0,1007041331,1},1},{{0,1008041331,1},1},{{0,1010041331,1},1}]','[]','[]'),(32081402,0,1000,0,1,0,1,0,'[{{0,1002011331,1},1},{{0,1004011331,1},1},{{0,1006011331,1},1},{{0,1008011331,1},1},{{0,1010011331,1},1}]','[]','[]'),(32081402,0,1000,0,2,0,1,0,'[{{0,1002021331,1},1},{{0,1004021331,1},1},{{0,1006021331,1},1},{{0,1008021331,1},1},{{0,1010021331,1},1}]','[]','[]'),(32081402,0,1000,0,3,0,1,0,'[{{0,1002031331,1},1},{{0,1004031331,1},1},{{0,1006031331,1},1},{{0,1008031331,1},1},{{0,1010031331,1},1}]','[]','[]'),(32081402,0,1000,0,4,0,1,0,'[{{0,1002041331,1},1},{{0,1004041331,1},1},{{0,1006041331,1},1},{{0,1008041331,1},1},{{0,1010041331,1},1}]','[]','[]'),(32081403,0,1000,0,1,0,1,0,'[{{0,1001011331,1},1},{{0,1007011331,1},1}]','[]','[]'),(32081403,0,1000,0,2,0,1,0,'[{{0,1001021331,1},1},{{0,1007021331,1},1}]','[]','[]'),(32081403,0,1000,0,3,0,1,0,'[{{0,1001031331,1},1},{{0,1007031331,1},1}]','[]','[]'),(32081403,0,1000,0,4,0,1,0,'[{{0,1001041331,1},1},{{0,1007041331,1},1}]','[]','[]'),(32081405,0,1000,0,1,0,1,0,'[{{0,1002011331,1},1},{{0,1004011331,1},1},{{0,1006011331,1},1},{{0,1008011331,1},1},{{0,1010011331,1},1},{{0,1001011331,1},1}]','[]','[]'),(32081405,0,1000,0,2,0,1,0,'[{{0,1002021331,1},1},{{0,1004021331,1},1},{{0,1006021331,1},1},{{0,1008021331,1},1},{{0,1010021331,1},1},{{0,1001021331,1},1}]','[]','[]'),(32081405,0,1000,0,3,0,1,0,'[{{0,1002031331,1},1},{{0,1004031331,1},1},{{0,1006031331,1},1},{{0,1008031331,1},1},{{0,1010031331,1},1},{{0,1001031331,1},1}]','[]','[]'),(32081405,0,1000,0,4,0,1,0,'[{{0,1002041331,1},1},{{0,1004041331,1},1},{{0,1006041331,1},1},{{0,1008041331,1},1},{{0,1010041331,1},1},{{0,1001041331,1},1}]','[]','[]'),(32081406,0,1000,0,1,0,1,0,'[{{0,1007011331,1},1},{{0,1003001331,1},1},{{0,1005001331,1},1},{{0,1009001331,1},1}]','[]','[]'),(32081406,0,1000,0,2,0,1,0,'[{{0,1007021331,1},1},{{0,1003001331,1},1},{{0,1005001331,1},1},{{0,1009001331,1},1}]','[]','[]'),(32081406,0,1000,0,3,0,1,0,'[{{0,1007031331,1},1},{{0,1003001331,1},1},{{0,1005001331,1},1},{{0,1009001331,1},1}]','[]','[]'),(32081406,0,1000,0,4,0,1,0,'[{{0,1007041331,1},1},{{0,1003001331,1},1},{{0,1005001331,1},1},{{0,1009001331,1},1}]','[]','[]'),(32081407,0,1000,0,1,0,1,0,'[{{0,1007011331,1},1},{{0,1003001331,1},1}]','[]','[]'),(32081407,0,1000,0,2,0,1,0,'[{{0,1007021331,1},1},{{0,1003001331,1},1}]','[]','[]'),(32081407,0,1000,0,3,0,1,0,'[{{0,1007031331,1},1},{{0,1003001331,1},1}]','[]','[]'),(32081407,0,1000,0,4,0,1,0,'[{{0,1007041331,1},1},{{0,1003001331,1},1}]','[]','[]'),(32081408,0,1000,0,0,0,1,0,'[{{0,1005001331,1},1},{{0,1009001331,1},1}]','[]','[]'),(32081411,0,1000,0,1,0,1,0,'[{{0,1001011432,1},1},{{0,1002011432,1},1},{{0,1003001432,1},1},{{0,1004011432,1},1},{{0,1006011432,1},1},{{0,1007011432,1},1},{{0,1008011432,1},1},{{0,1010011432,1},1}]','[]','[1001011432,1002011432,1003001432,1004011432,1005001432,1006011432,1007011432,1008011432,1009001432,1010011432]'),(32081411,0,1000,0,2,0,1,0,'[{{0,1001021432,1},1},{{0,1002021432,1},1},{{0,1003001432,1},1},{{0,1004021432,1},1},{{0,1006021432,1},1},{{0,1007021432,1},1},{{0,1008021432,1},1},{{0,1010021432,1},1}]','[]','[1001021432,1002021432,1003001432,1004021432,1005001432,1006021432,1007021432,1008021432,1009001432,1010021432]'),(32081411,0,1000,0,3,0,1,0,'[{{0,1001031432,1},1},{{0,1002031432,1},1},{{0,1003001432,1},1},{{0,1004031432,1},1},{{0,1006031432,1},1},{{0,1007031432,1},1},{{0,1008031432,1},1},{{0,1010031432,1},1}]','[]','[1001031432,1002031432,1003001432,1004031432,1005001432,1006031432,1007031432,1008031432,1009001432,1010031432]'),(32081411,0,1000,0,4,0,1,0,'[{{0,1001041432,1},1},{{0,1002041432,1},1},{{0,1003001432,1},1},{{0,1004041432,1},1},{{0,1006041432,1},1},{{0,1007041432,1},1},{{0,1008041432,1},1},{{0,1010041432,1},1}]','[]','[1001041432,1002041432,1003001432,1004041432,1005001432,1006041432,1007041432,1008041432,1009001432,1010041432]'),(32081412,0,1000,0,1,0,1,0,'[{{0,1002011432,1},1},{{0,1004011432,1},1},{{0,1006011432,1},1},{{0,1008011432,1},1},{{0,1010011432,1},1}]','[]','[1002011432,1004011432,1006011432,1008011432,1010011432]'),(32081412,0,1000,0,2,0,1,0,'[{{0,1002021432,1},1},{{0,1004021432,1},1},{{0,1006021432,1},1},{{0,1008021432,1},1},{{0,1010021432,1},1}]','[]','[1002021432,1004021432,1006021432,1008021432,1010021432]'),(32081412,0,1000,0,3,0,1,0,'[{{0,1002031432,1},1},{{0,1004031432,1},1},{{0,1006031432,1},1},{{0,1008031432,1},1},{{0,1010031432,1},1}]','[]','[1002031432,1004031432,1006031432,1008031432,1010031432]'),(32081412,0,1000,0,4,0,1,0,'[{{0,1002041432,1},1},{{0,1004041432,1},1},{{0,1006041432,1},1},{{0,1008041432,1},1},{{0,1010041432,1},1}]','[]','[1002041432,1004041432,1006041432,1008041432,1010041432]'),(32081413,0,1000,0,1,0,1,0,'[{{0,1001011432,1},1},{{0,1007011432,1},1}]','[]','[1001011432,1007011432]'),(32081413,0,1000,0,2,0,1,0,'[{{0,1001021432,1},1},{{0,1007021432,1},1}]','[]','[1001021432,1007021432]'),(32081413,0,1000,0,3,0,1,0,'[{{0,1001031432,1},1},{{0,1007031432,1},1}]','[]','[1001031432,1007031432]'),(32081413,0,1000,0,4,0,1,0,'[{{0,1001041432,1},1},{{0,1007041432,1},1}]','[]','[1001041432,1007041432]'),(32081415,0,1000,0,1,0,1,0,'[{{0,1002011432,1},1},{{0,1004011432,1},1},{{0,1006011432,1},1},{{0,1008011432,1},1},{{0,1010011432,1},1},{{0,1001011432,1},1}]','[]','[1002011432,1004011432,1006011432,1008011432,1010011432,1001011432]'),(32081415,0,1000,0,2,0,1,0,'[{{0,1002021432,1},1},{{0,1004021432,1},1},{{0,1006021432,1},1},{{0,1008021432,1},1},{{0,1010021432,1},1},{{0,1001021432,1},1}]','[]','[1002021432,1004021432,1006021432,1008021432,1010021432,1001021432]'),(32081415,0,1000,0,3,0,1,0,'[{{0,1002031432,1},1},{{0,1004031432,1},1},{{0,1006031432,1},1},{{0,1008031432,1},1},{{0,1010031432,1},1},{{0,1001031432,1},1}]','[]','[1002031432,1004031432,1006031432,1008031432,1010031432,1001031432]'),(32081415,0,1000,0,4,0,1,0,'[{{0,1002041432,1},1},{{0,1004041432,1},1},{{0,1006041432,1},1},{{0,1008041432,1},1},{{0,1010041432,1},1},{{0,1001041432,1},1}]','[]','[1002041432,1004041432,1006041432,1008041432,1010041432,1001041432]'),(32081416,0,1000,0,1,0,1,0,'[{{0,1007011432,1},1},{{0,1003001432,1},1},{{0,1005001432,1},1},{{0,1009001432,1},1}]','[]','[1007011432,1003001432,1005001432,1009001432]'),(32081416,0,1000,0,2,0,1,0,'[{{0,1007021432,1},1},{{0,1003001432,1},1},{{0,1005001432,1},1},{{0,1009001432,1},1}]','[]','[1007021432,1003001432,1005001432,1009001432]'),(32081416,0,1000,0,3,0,1,0,'[{{0,1007031432,1},1},{{0,1003001432,1},1},{{0,1005001432,1},1},{{0,1009001432,1},1}]','[]','[1007031432,1003001432,1005001432,1009001432]'),(32081416,0,1000,0,4,0,1,0,'[{{0,1007041432,1},1},{{0,1003001432,1},1},{{0,1005001432,1},1},{{0,1009001432,1},1}]','[]','[1007041432,1003001432,1005001432,1009001432]'),(32081417,0,1000,0,1,0,1,0,'[{{0,1007011432,1},1},{{0,1003001432,1},1}]','[]','[1007011432,1003001432]'),(32081417,0,1000,0,2,0,1,0,'[{{0,1007021432,1},1},{{0,1003001432,1},1}]','[]','[1007021432,1003001432]'),(32081417,0,1000,0,3,0,1,0,'[{{0,1007031432,1},1},{{0,1003001432,1},1}]','[]','[1007031432,1003001432]'),(32081417,0,1000,0,4,0,1,0,'[{{0,1007041432,1},1},{{0,1003001432,1},1}]','[]','[1007041432,1003001432]'),(32081418,0,1000,0,0,0,1,0,'[{{0,1005001432,1},1},{{0,1009001432,1},1}]','[]','[1005001432,1009001432]'),(32081421,0,1000,0,1,0,1,0,'[{{0,1001011441,1},1},{{0,1002011441,1},1},{{0,1003001441,1},1},{{0,1004011441,1},1},{{0,1006011441,1},1},{{0,1007011441,1},1},{{0,1008011441,1},1},{{0,1010011441,1},1}]','[]','[]'),(32081421,0,1000,0,2,0,1,0,'[{{0,1001021441,1},1},{{0,1002021441,1},1},{{0,1003001441,1},1},{{0,1004021441,1},1},{{0,1006021441,1},1},{{0,1007021441,1},1},{{0,1008021441,1},1},{{0,1010021441,1},1}]','[]','[]'),(32081421,0,1000,0,3,0,1,0,'[{{0,1001031441,1},1},{{0,1002031441,1},1},{{0,1003001441,1},1},{{0,1004031441,1},1},{{0,1006031441,1},1},{{0,1007031441,1},1},{{0,1008031441,1},1},{{0,1010031441,1},1}]','[]','[]'),(32081421,0,1000,0,4,0,1,0,'[{{0,1001041441,1},1},{{0,1002041441,1},1},{{0,1003001441,1},1},{{0,1004041441,1},1},{{0,1006041441,1},1},{{0,1007041441,1},1},{{0,1008041441,1},1},{{0,1010041441,1},1}]','[]','[]'),(32081422,0,1000,0,1,0,1,0,'[{{0,1002011441,1},1},{{0,1004011441,1},1},{{0,1006011441,1},1},{{0,1008011441,1},1},{{0,1010011441,1},1}]','[]','[]'),(32081422,0,1000,0,2,0,1,0,'[{{0,1002021441,1},1},{{0,1004021441,1},1},{{0,1006021441,1},1},{{0,1008021441,1},1},{{0,1010021441,1},1}]','[]','[]'),(32081422,0,1000,0,3,0,1,0,'[{{0,1002031441,1},1},{{0,1004031441,1},1},{{0,1006031441,1},1},{{0,1008031441,1},1},{{0,1010031441,1},1}]','[]','[]'),(32081422,0,1000,0,4,0,1,0,'[{{0,1002041441,1},1},{{0,1004041441,1},1},{{0,1006041441,1},1},{{0,1008041441,1},1},{{0,1010041441,1},1}]','[]','[]'),(32081423,0,1000,0,1,0,1,0,'[{{0,1001011441,1},1},{{0,1007011441,1},1}]','[]','[]'),(32081423,0,1000,0,2,0,1,0,'[{{0,1001021441,1},1},{{0,1007021441,1},1}]','[]','[]'),(32081423,0,1000,0,3,0,1,0,'[{{0,1001031441,1},1},{{0,1007031441,1},1}]','[]','[]'),(32081423,0,1000,0,4,0,1,0,'[{{0,1001041441,1},1},{{0,1007041441,1},1}]','[]','[]'),(32081425,0,1000,0,1,0,1,0,'[{{0,1002011441,1},1},{{0,1004011441,1},1},{{0,1006011441,1},1},{{0,1008011441,1},1},{{0,1010011441,1},1},{{0,1001011441,1},1}]','[]','[]'),(32081425,0,1000,0,2,0,1,0,'[{{0,1002021441,1},1},{{0,1004021441,1},1},{{0,1006021441,1},1},{{0,1008021441,1},1},{{0,1010021441,1},1},{{0,1001021441,1},1}]','[]','[]'),(32081425,0,1000,0,3,0,1,0,'[{{0,1002031441,1},1},{{0,1004031441,1},1},{{0,1006031441,1},1},{{0,1008031441,1},1},{{0,1010031441,1},1},{{0,1001031441,1},1}]','[]','[]'),(32081425,0,1000,0,4,0,1,0,'[{{0,1002041441,1},1},{{0,1004041441,1},1},{{0,1006041441,1},1},{{0,1008041441,1},1},{{0,1010041441,1},1},{{0,1001041441,1},1}]','[]','[]'),(32081426,0,1000,0,1,0,1,0,'[{{0,1007011441,1},1},{{0,1003001441,1},1},{{0,1005001441,1},1},{{0,1009001441,1},1}]','[]','[]'),(32081426,0,1000,0,2,0,1,0,'[{{0,1007021441,1},1},{{0,1003001441,1},1},{{0,1005001441,1},1},{{0,1009001441,1},1}]','[]','[]'),(32081426,0,1000,0,3,0,1,0,'[{{0,1007031441,1},1},{{0,1003001441,1},1},{{0,1005001441,1},1},{{0,1009001441,1},1}]','[]','[]'),(32081426,0,1000,0,4,0,1,0,'[{{0,1007041441,1},1},{{0,1003001441,1},1},{{0,1005001441,1},1},{{0,1009001441,1},1}]','[]','[]'),(32081427,0,1000,0,1,0,1,0,'[{{0,1007011441,1},1},{{0,1003001441,1},1}]','[]','[]'),(32081427,0,1000,0,2,0,1,0,'[{{0,1007021441,1},1},{{0,1003001441,1},1}]','[]','[]'),(32081427,0,1000,0,3,0,1,0,'[{{0,1007031441,1},1},{{0,1003001441,1},1}]','[]','[]'),(32081427,0,1000,0,4,0,1,0,'[{{0,1007041441,1},1},{{0,1003001441,1},1}]','[]','[]'),(32081428,0,1000,0,0,0,1,0,'[{{0,1005001441,1},1},{{0,1009001441,1},1}]','[]','[]'),(32081431,0,1000,0,1,0,1,0,'[{{0,1001011442,1},1},{{0,1002011442,1},1},{{0,1003001442,1},1},{{0,1004011442,1},1},{{0,1006011442,1},1},{{0,1007011442,1},1},{{0,1008011442,1},1},{{0,1010011442,1},1}]','[]','[1001011442,1002011442,1003001442,1004011442,1005001442,1006011442,1007011442,1008011442,1009001442,1010011442]'),(32081431,0,1000,0,2,0,1,0,'[{{0,1001021442,1},1},{{0,1002021442,1},1},{{0,1003001442,1},1},{{0,1004021442,1},1},{{0,1006021442,1},1},{{0,1007021442,1},1},{{0,1008021442,1},1},{{0,1010021442,1},1}]','[]','[1001021442,1002021442,1003001442,1004021442,1005001442,1006021442,1007021442,1008021442,1009001442,1010021442]'),(32081431,0,1000,0,3,0,1,0,'[{{0,1001031442,1},1},{{0,1002031442,1},1},{{0,1003001442,1},1},{{0,1004031442,1},1},{{0,1006031442,1},1},{{0,1007031442,1},1},{{0,1008031442,1},1},{{0,1010031442,1},1}]','[]','[1001031442,1002031442,1003001442,1004031442,1005001442,1006031442,1007031442,1008031442,1009001442,1010031442]'),(32081431,0,1000,0,4,0,1,0,'[{{0,1001041442,1},1},{{0,1002041442,1},1},{{0,1003001442,1},1},{{0,1004041442,1},1},{{0,1006041442,1},1},{{0,1007041442,1},1},{{0,1008041442,1},1},{{0,1010041442,1},1}]','[]','[1001041442,1002041442,1003001442,1004041442,1005001442,1006041442,1007041442,1008041442,1009001442,1010041442]'),(32081432,0,1000,0,1,0,1,0,'[{{0,1002011442,1},1},{{0,1004011442,1},1},{{0,1006011442,1},1},{{0,1008011442,1},1},{{0,1010011442,1},1}]','[]','[1002011442,1004011442,1006011442,1008011442,1010011442]'),(32081432,0,1000,0,2,0,1,0,'[{{0,1002021442,1},1},{{0,1004021442,1},1},{{0,1006021442,1},1},{{0,1008021442,1},1},{{0,1010021442,1},1}]','[]','[1002021442,1004021442,1006021442,1008021442,1010021442]'),(32081432,0,1000,0,3,0,1,0,'[{{0,1002031442,1},1},{{0,1004031442,1},1},{{0,1006031442,1},1},{{0,1008031442,1},1},{{0,1010031442,1},1}]','[]','[1002031442,1004031442,1006031442,1008031442,1010031442]'),(32081432,0,1000,0,4,0,1,0,'[{{0,1002041442,1},1},{{0,1004041442,1},1},{{0,1006041442,1},1},{{0,1008041442,1},1},{{0,1010041442,1},1}]','[]','[1002041442,1004041442,1006041442,1008041442,1010041442]'),(32081433,0,1000,0,1,0,1,0,'[{{0,1001011442,1},1},{{0,1007011442,1},1}]','[]','[1001011442,1007011442]'),(32081433,0,1000,0,2,0,1,0,'[{{0,1001021442,1},1},{{0,1007021442,1},1}]','[]','[1001021442,1007021442]'),(32081433,0,1000,0,3,0,1,0,'[{{0,1001031442,1},1},{{0,1007031442,1},1}]','[]','[1001031442,1007031442]'),(32081433,0,1000,0,4,0,1,0,'[{{0,1001041442,1},1},{{0,1007041442,1},1}]','[]','[1001041442,1007041442]'),(32081435,0,1000,0,1,0,1,0,'[{{0,1002011442,1},1},{{0,1004011442,1},1},{{0,1006011442,1},1},{{0,1008011442,1},1},{{0,1010011442,1},1},{{0,1001011442,1},1}]','[]','[1002011442,1004011442,1006011442,1008011442,1010011442,1001011442]'),(32081435,0,1000,0,2,0,1,0,'[{{0,1002021442,1},1},{{0,1004021442,1},1},{{0,1006021442,1},1},{{0,1008021442,1},1},{{0,1010021442,1},1},{{0,1001021442,1},1}]','[]','[1002021442,1004021442,1006021442,1008021442,1010021442,1001021442]'),(32081435,0,1000,0,3,0,1,0,'[{{0,1002031442,1},1},{{0,1004031442,1},1},{{0,1006031442,1},1},{{0,1008031442,1},1},{{0,1010031442,1},1},{{0,1001031442,1},1}]','[]','[1002031442,1004031442,1006031442,1008031442,1010031442,1001031442]'),(32081435,0,1000,0,4,0,1,0,'[{{0,1002041442,1},1},{{0,1004041442,1},1},{{0,1006041442,1},1},{{0,1008041442,1},1},{{0,1010041442,1},1},{{0,1001041442,1},1}]','[]','[1002041442,1004041442,1006041442,1008041442,1010041442,1001041442]'),(32081436,0,1000,0,1,0,1,0,'[{{0,1007011442,1},1},{{0,1003001442,1},1},{{0,1005001442,1},1},{{0,1009001442,1},1}]','[]','[1007011442,1003001442,1005001442,1009001442]'),(32081436,0,1000,0,2,0,1,0,'[{{0,1007021442,1},1},{{0,1003001442,1},1},{{0,1005001442,1},1},{{0,1009001442,1},1}]','[]','[1007021442,1003001442,1005001442,1009001442]'),(32081436,0,1000,0,3,0,1,0,'[{{0,1007031442,1},1},{{0,1003001442,1},1},{{0,1005001442,1},1},{{0,1009001442,1},1}]','[]','[1007031442,1003001442,1005001442,1009001442]'),(32081436,0,1000,0,4,0,1,0,'[{{0,1007041442,1},1},{{0,1003001442,1},1},{{0,1005001442,1},1},{{0,1009001442,1},1}]','[]','[1007041442,1003001442,1005001442,1009001442]'),(32081437,0,1000,0,1,0,1,0,'[{{0,1007011442,1},1},{{0,1003001442,1},1}]','[]','[1007011442,1003001442]'),(32081437,0,1000,0,2,0,1,0,'[{{0,1007021442,1},1},{{0,1003001442,1},1}]','[]','[1007021442,1003001442]'),(32081437,0,1000,0,3,0,1,0,'[{{0,1007031442,1},1},{{0,1003001442,1},1}]','[]','[1007031442,1003001442]'),(32081437,0,1000,0,4,0,1,0,'[{{0,1007041442,1},1},{{0,1003001442,1},1}]','[]','[1007041442,1003001442]'),(32081438,0,1000,0,0,0,1,0,'[{{0,1005001442,1},1},{{0,1009001442,1},1}]','[]','[1005001442,1009001442]'),(32081441,0,1000,0,1,0,1,0,'[{{0,1001011443,1},1},{{0,1002011443,1},1},{{0,1003001443,1},1},{{0,1004011443,1},1},{{0,1006011443,1},1},{{0,1007011443,1},1},{{0,1008011443,1},1},{{0,1010011443,1},1}]','[]','[1001011443,1002011443,1003001443,1004011443,1005001443,1006011443,1007011443,1008011443,1009001443,1010011443]'),(32081441,0,1000,0,2,0,1,0,'[{{0,1001021443,1},1},{{0,1002021443,1},1},{{0,1003001443,1},1},{{0,1004021443,1},1},{{0,1006021443,1},1},{{0,1007021443,1},1},{{0,1008021443,1},1},{{0,1010021443,1},1}]','[]','[1001021443,1002021443,1003001443,1004021443,1005001443,1006021443,1007021443,1008021443,1009001443,1010021443]'),(32081441,0,1000,0,3,0,1,0,'[{{0,1001031443,1},1},{{0,1002031443,1},1},{{0,1003001443,1},1},{{0,1004031443,1},1},{{0,1006031443,1},1},{{0,1007031443,1},1},{{0,1008031443,1},1},{{0,1010031443,1},1}]','[]','[1001031443,1002031443,1003001443,1004031443,1005001443,1006031443,1007031443,1008031443,1009001443,1010031443]'),(32081441,0,1000,0,4,0,1,0,'[{{0,1001041443,1},1},{{0,1002041443,1},1},{{0,1003001443,1},1},{{0,1004041443,1},1},{{0,1006041443,1},1},{{0,1007041443,1},1},{{0,1008041443,1},1},{{0,1010041443,1},1}]','[]','[1001041443,1002041443,1003001443,1004041443,1005001443,1006041443,1007041443,1008041443,1009001443,1010041443]'),(32081442,0,1000,0,1,0,1,0,'[{{0,1002011443,1},1},{{0,1004011443,1},1},{{0,1006011443,1},1},{{0,1008011443,1},1},{{0,1010011443,1},1}]','[]','[1002011443,1004011443,1006011443,1008011443,1010011443]'),(32081442,0,1000,0,2,0,1,0,'[{{0,1002021443,1},1},{{0,1004021443,1},1},{{0,1006021443,1},1},{{0,1008021443,1},1},{{0,1010021443,1},1}]','[]','[1002021443,1004021443,1006021443,1008021443,1010021443]'),(32081442,0,1000,0,3,0,1,0,'[{{0,1002031443,1},1},{{0,1004031443,1},1},{{0,1006031443,1},1},{{0,1008031443,1},1},{{0,1010031443,1},1}]','[]','[1002031443,1004031443,1006031443,1008031443,1010031443]'),(32081442,0,1000,0,4,0,1,0,'[{{0,1002041443,1},1},{{0,1004041443,1},1},{{0,1006041443,1},1},{{0,1008041443,1},1},{{0,1010041443,1},1}]','[]','[1002041443,1004041443,1006041443,1008041443,1010041443]'),(32081443,0,1000,0,1,0,1,0,'[{{0,1001011443,1},1},{{0,1007011443,1},1}]','[]','[1001011443,1007011443]'),(32081443,0,1000,0,2,0,1,0,'[{{0,1001021443,1},1},{{0,1007021443,1},1}]','[]','[1001021443,1007021443]'),(32081443,0,1000,0,3,0,1,0,'[{{0,1001031443,1},1},{{0,1007031443,1},1}]','[]','[1001031443,1007031443]'),(32081443,0,1000,0,4,0,1,0,'[{{0,1001041443,1},1},{{0,1007041443,1},1}]','[]','[1001041443,1007041443]'),(32081445,0,1000,0,1,0,1,0,'[{{0,1002011443,1},1},{{0,1004011443,1},1},{{0,1006011443,1},1},{{0,1008011443,1},1},{{0,1010011443,1},1},{{0,1001011443,1},1}]','[]','[1002011443,1004011443,1006011443,1008011443,1010011443,1001011443]'),(32081445,0,1000,0,2,0,1,0,'[{{0,1002021443,1},1},{{0,1004021443,1},1},{{0,1006021443,1},1},{{0,1008021443,1},1},{{0,1010021443,1},1},{{0,1001021443,1},1}]','[]','[1002021443,1004021443,1006021443,1008021443,1010021443,1001021443]'),(32081445,0,1000,0,3,0,1,0,'[{{0,1002031443,1},1},{{0,1004031443,1},1},{{0,1006031443,1},1},{{0,1008031443,1},1},{{0,1010031443,1},1},{{0,1001031443,1},1}]','[]','[1002031443,1004031443,1006031443,1008031443,1010031443,1001031443]'),(32081445,0,1000,0,4,0,1,0,'[{{0,1002041443,1},1},{{0,1004041443,1},1},{{0,1006041443,1},1},{{0,1008041443,1},1},{{0,1010041443,1},1},{{0,1001041443,1},1}]','[]','[1002041443,1004041443,1006041443,1008041443,1010041443,1001041443]'),(32081446,0,1000,0,1,0,1,0,'[{{0,1007011443,1},1},{{0,1003001443,1},1},{{0,1005001443,1},1},{{0,1009001443,1},1}]','[]','[1007011443,1003001443,1005001443,1009001443]'),(32081446,0,1000,0,2,0,1,0,'[{{0,1007021443,1},1},{{0,1003001443,1},1},{{0,1005001443,1},1},{{0,1009001443,1},1}]','[]','[1007021443,1003001443,1005001443,1009001443]'),(32081446,0,1000,0,3,0,1,0,'[{{0,1007031443,1},1},{{0,1003001443,1},1},{{0,1005001443,1},1},{{0,1009001443,1},1}]','[]','[1007031443,1003001443,1005001443,1009001443]'),(32081446,0,1000,0,4,0,1,0,'[{{0,1007041443,1},1},{{0,1003001443,1},1},{{0,1005001443,1},1},{{0,1009001443,1},1}]','[]','[1007041443,1003001443,1005001443,1009001443]'),(32081447,0,1000,0,1,0,1,0,'[{{0,1007011443,1},1},{{0,1003001443,1},1}]','[]','[1007011443,1003001443]'),(32081447,0,1000,0,2,0,1,0,'[{{0,1007021443,1},1},{{0,1003001443,1},1}]','[]','[1007021443,1003001443]'),(32081447,0,1000,0,3,0,1,0,'[{{0,1007031443,1},1},{{0,1003001443,1},1}]','[]','[1007031443,1003001443]'),(32081447,0,1000,0,4,0,1,0,'[{{0,1007041443,1},1},{{0,1003001443,1},1}]','[]','[1007041443,1003001443]'),(32081448,0,1000,0,0,0,1,0,'[{{0,1005001443,1},1},{{0,1009001443,1},1}]','[]','[1005001443,1009001443]'),(32081451,0,1000,0,1,0,1,0,'[{{0,1001011453,1},1},{{0,1002011453,1},1},{{0,1003001453,1},1},{{0,1004011453,1},1},{{0,1006011453,1},1},{{0,1007011453,1},1},{{0,1008011453,1},1},{{0,1010011453,1},1}]','[]','[1001011453,1002011453,1003001453,1004011453,1005001453,1006011453,1007011453,1008011453,1009001453,1010011453]'),(32081451,0,1000,0,2,0,1,0,'[{{0,1001021453,1},1},{{0,1002021453,1},1},{{0,1003001453,1},1},{{0,1004021453,1},1},{{0,1006021453,1},1},{{0,1007021453,1},1},{{0,1008021453,1},1},{{0,1010021453,1},1}]','[]','[1001021453,1002021453,1003001453,1004021453,1005001453,1006021453,1007021453,1008021453,1009001453,1010021453]'),(32081451,0,1000,0,3,0,1,0,'[{{0,1001031453,1},1},{{0,1002031453,1},1},{{0,1003001453,1},1},{{0,1004031453,1},1},{{0,1006031453,1},1},{{0,1007031453,1},1},{{0,1008031453,1},1},{{0,1010031453,1},1}]','[]','[1001031453,1002031453,1003001453,1004031453,1005001453,1006031453,1007031453,1008031453,1009001453,1010031453]'),(32081451,0,1000,0,4,0,1,0,'[{{0,1001041453,1},1},{{0,1002041453,1},1},{{0,1003001453,1},1},{{0,1004041453,1},1},{{0,1006041453,1},1},{{0,1007041453,1},1},{{0,1008041453,1},1},{{0,1010041453,1},1}]','[]','[1001041453,1002041453,1003001453,1004041453,1005001453,1006041453,1007041453,1008041453,1009001453,1010041453]'),(32081452,0,1000,0,1,0,1,0,'[{{0,1002011453,1},1},{{0,1004011453,1},1},{{0,1006011453,1},1},{{0,1008011453,1},1},{{0,1010011453,1},1}]','[]','[1002011453,1004011453,1006011453,1008011453,1010011453]'),(32081452,0,1000,0,2,0,1,0,'[{{0,1002021453,1},1},{{0,1004021453,1},1},{{0,1006021453,1},1},{{0,1008021453,1},1},{{0,1010021453,1},1}]','[]','[1002021453,1004021453,1006021453,1008021453,1010021453]'),(32081452,0,1000,0,3,0,1,0,'[{{0,1002031453,1},1},{{0,1004031453,1},1},{{0,1006031453,1},1},{{0,1008031453,1},1},{{0,1010031453,1},1}]','[]','[1002031453,1004031453,1006031453,1008031453,1010031453]'),(32081452,0,1000,0,4,0,1,0,'[{{0,1002041453,1},1},{{0,1004041453,1},1},{{0,1006041453,1},1},{{0,1008041453,1},1},{{0,1010041453,1},1}]','[]','[1002041453,1004041453,1006041453,1008041453,1010041453]'),(32081453,0,1000,0,1,0,1,0,'[{{0,1001011453,1},1},{{0,1007011453,1},1}]','[]','[1001011453,1007011453]'),(32081453,0,1000,0,2,0,1,0,'[{{0,1001021453,1},1},{{0,1007021453,1},1}]','[]','[1001021453,1007021453]'),(32081453,0,1000,0,3,0,1,0,'[{{0,1001031453,1},1},{{0,1007031453,1},1}]','[]','[1001031453,1007031453]'),(32081453,0,1000,0,4,0,1,0,'[{{0,1001041453,1},1},{{0,1007041453,1},1}]','[]','[1001041453,1007041453]'),(32081455,0,1000,0,1,0,1,0,'[{{0,1002011453,1},1},{{0,1004011453,1},1},{{0,1006011453,1},1},{{0,1008011453,1},1},{{0,1010011453,1},1},{{0,1001011453,1},1}]','[]','[1002011453,1004011453,1006011453,1008011453,1010011453,1001011453]'),(32081455,0,1000,0,2,0,1,0,'[{{0,1002021453,1},1},{{0,1004021453,1},1},{{0,1006021453,1},1},{{0,1008021453,1},1},{{0,1010021453,1},1},{{0,1001021453,1},1}]','[]','[1002021453,1004021453,1006021453,1008021453,1010021453,1001021453]'),(32081455,0,1000,0,3,0,1,0,'[{{0,1002031453,1},1},{{0,1004031453,1},1},{{0,1006031453,1},1},{{0,1008031453,1},1},{{0,1010031453,1},1},{{0,1001031453,1},1}]','[]','[1002031453,1004031453,1006031453,1008031453,1010031453,1001031453]'),(32081455,0,1000,0,4,0,1,0,'[{{0,1002041453,1},1},{{0,1004041453,1},1},{{0,1006041453,1},1},{{0,1008041453,1},1},{{0,1010041453,1},1},{{0,1001041453,1},1}]','[]','[1002041453,1004041453,1006041453,1008041453,1010041453,1001041453]'),(32081456,0,1000,0,1,0,1,0,'[{{0,1007011453,1},1},{{0,1003001453,1},1},{{0,1005001453,1},1},{{0,1009001453,1},1}]','[]','[1007011453,1003001453,1005001453,1009001453]'),(32081456,0,1000,0,2,0,1,0,'[{{0,1007021453,1},1},{{0,1003001453,1},1},{{0,1005001453,1},1},{{0,1009001453,1},1}]','[]','[1007021453,1003001453,1005001453,1009001453]'),(32081456,0,1000,0,3,0,1,0,'[{{0,1007031453,1},1},{{0,1003001453,1},1},{{0,1005001453,1},1},{{0,1009001453,1},1}]','[]','[1007031453,1003001453,1005001453,1009001453]'),(32081456,0,1000,0,4,0,1,0,'[{{0,1007041453,1},1},{{0,1003001453,1},1},{{0,1005001453,1},1},{{0,1009001453,1},1}]','[]','[1007041453,1003001453,1005001453,1009001453]'),(32081457,0,1000,0,1,0,1,0,'[{{0,1007011453,1},1},{{0,1003001453,1},1}]','[]','[1007011453,1003001453]'),(32081457,0,1000,0,2,0,1,0,'[{{0,1007021453,1},1},{{0,1003001453,1},1}]','[]','[1007021453,1003001453]'),(32081457,0,1000,0,3,0,1,0,'[{{0,1007031453,1},1},{{0,1003001453,1},1}]','[]','[1007031453,1003001453]'),(32081457,0,1000,0,4,0,1,0,'[{{0,1007041453,1},1},{{0,1003001453,1},1}]','[]','[1007041453,1003001453]'),(32081458,0,1000,0,0,0,1,0,'[{{0,1005001453,1},1},{{0,1009001453,1},1}]','[]','[1005001453,1009001453]'),(32081461,0,1000,0,1,0,1,0,'[{{0,1001011463,1},1},{{0,1002011463,1},1},{{0,1003001463,1},1},{{0,1004011463,1},1},{{0,1006011463,1},1},{{0,1007011463,1},1},{{0,1008011463,1},1},{{0,1010011463,1},1}]','[]','[1001011463,1002011463,1003001463,1004011463,1005001463,1006011463,1007011463,1008011463,1009001463,1010011463]'),(32081461,0,1000,0,2,0,1,0,'[{{0,1001021463,1},1},{{0,1002021463,1},1},{{0,1003001463,1},1},{{0,1004021463,1},1},{{0,1006021463,1},1},{{0,1007021463,1},1},{{0,1008021463,1},1},{{0,1010021463,1},1}]','[]','[1001021463,1002021463,1003001463,1004021463,1005001463,1006021463,1007021463,1008021463,1009001463,1010021463]'),(32081461,0,1000,0,3,0,1,0,'[{{0,1001031463,1},1},{{0,1002031463,1},1},{{0,1003001463,1},1},{{0,1004031463,1},1},{{0,1006031463,1},1},{{0,1007031463,1},1},{{0,1008031463,1},1},{{0,1010031463,1},1}]','[]','[1001031463,1002031463,1003001463,1004031463,1005001463,1006031463,1007031463,1008031463,1009001463,1010031463]'),(32081461,0,1000,0,4,0,1,0,'[{{0,1001041463,1},1},{{0,1002041463,1},1},{{0,1003001463,1},1},{{0,1004041463,1},1},{{0,1006041463,1},1},{{0,1007041463,1},1},{{0,1008041463,1},1},{{0,1010041463,1},1}]','[]','[1001041463,1002041463,1003001463,1004041463,1005001463,1006041463,1007041463,1008041463,1009001463,1010041463]'),(32081462,0,1000,0,1,0,1,0,'[{{0,1002011463,1},1},{{0,1004011463,1},1},{{0,1006011463,1},1},{{0,1008011463,1},1},{{0,1010011463,1},1}]','[]','[1002011463,1004011463,1006011463,1008011463,1010011463]'),(32081462,0,1000,0,2,0,1,0,'[{{0,1002021463,1},1},{{0,1004021463,1},1},{{0,1006021463,1},1},{{0,1008021463,1},1},{{0,1010021463,1},1}]','[]','[1002021463,1004021463,1006021463,1008021463,1010021463]'),(32081462,0,1000,0,3,0,1,0,'[{{0,1002031463,1},1},{{0,1004031463,1},1},{{0,1006031463,1},1},{{0,1008031463,1},1},{{0,1010031463,1},1}]','[]','[1002031463,1004031463,1006031463,1008031463,1010031463]'),(32081462,0,1000,0,4,0,1,0,'[{{0,1002041463,1},1},{{0,1004041463,1},1},{{0,1006041463,1},1},{{0,1008041463,1},1},{{0,1010041463,1},1}]','[]','[1002041463,1004041463,1006041463,1008041463,1010041463]'),(32081463,0,1000,0,1,0,1,0,'[{{0,1001011463,1},1},{{0,1007011463,1},1}]','[]','[1001011463,1007011463]'),(32081463,0,1000,0,2,0,1,0,'[{{0,1001021463,1},1},{{0,1007021463,1},1}]','[]','[1001021463,1007021463]'),(32081463,0,1000,0,3,0,1,0,'[{{0,1001031463,1},1},{{0,1007031463,1},1}]','[]','[1001031463,1007031463]'),(32081463,0,1000,0,4,0,1,0,'[{{0,1001041463,1},1},{{0,1007041463,1},1}]','[]','[1001041463,1007041463]'),(32081465,0,1000,0,1,0,1,0,'[{{0,1002011463,1},1},{{0,1004011463,1},1},{{0,1006011463,1},1},{{0,1008011463,1},1},{{0,1010011463,1},1},{{0,1001011463,1},1}]','[]','[1002011463,1004011463,1006011463,1008011463,1010011463,1001011463]'),(32081465,0,1000,0,2,0,1,0,'[{{0,1002021463,1},1},{{0,1004021463,1},1},{{0,1006021463,1},1},{{0,1008021463,1},1},{{0,1010021463,1},1},{{0,1001021463,1},1}]','[]','[1002021463,1004021463,1006021463,1008021463,1010021463,1001021463]'),(32081465,0,1000,0,3,0,1,0,'[{{0,1002031463,1},1},{{0,1004031463,1},1},{{0,1006031463,1},1},{{0,1008031463,1},1},{{0,1010031463,1},1},{{0,1001031463,1},1}]','[]','[1002031463,1004031463,1006031463,1008031463,1010031463,1001031463]'),(32081465,0,1000,0,4,0,1,0,'[{{0,1002041463,1},1},{{0,1004041463,1},1},{{0,1006041463,1},1},{{0,1008041463,1},1},{{0,1010041463,1},1},{{0,1001041463,1},1}]','[]','[1002041463,1004041463,1006041463,1008041463,1010041463,1001041463]'),(32081466,0,1000,0,1,0,1,0,'[{{0,1007011463,1},1},{{0,1003001463,1},1},{{0,1005001463,1},1},{{0,1009001463,1},1}]','[]','[1007011463,1003001463,1005001463,1009001463]'),(32081466,0,1000,0,2,0,1,0,'[{{0,1007021463,1},1},{{0,1003001463,1},1},{{0,1005001463,1},1},{{0,1009001463,1},1}]','[]','[1007021463,1003001463,1005001463,1009001463]'),(32081466,0,1000,0,3,0,1,0,'[{{0,1007031463,1},1},{{0,1003001463,1},1},{{0,1005001463,1},1},{{0,1009001463,1},1}]','[]','[1007031463,1003001463,1005001463,1009001463]'),(32081466,0,1000,0,4,0,1,0,'[{{0,1007041463,1},1},{{0,1003001463,1},1},{{0,1005001463,1},1},{{0,1009001463,1},1}]','[]','[1007041463,1003001463,1005001463,1009001463]'),(32081467,0,1000,0,1,0,1,0,'[{{0,1007011463,1},1},{{0,1003001463,1},1}]','[]','[1007011463,1003001463]'),(32081467,0,1000,0,2,0,1,0,'[{{0,1007021463,1},1},{{0,1003001463,1},1}]','[]','[1007021463,1003001463]'),(32081467,0,1000,0,3,0,1,0,'[{{0,1007031463,1},1},{{0,1003001463,1},1}]','[]','[1007031463,1003001463]'),(32081467,0,1000,0,4,0,1,0,'[{{0,1007041463,1},1},{{0,1003001463,1},1}]','[]','[1007041463,1003001463]'),(32081468,0,1000,0,0,0,1,0,'[{{0,1005001463,1},1},{{0,1009001463,1},1}]','[]','[1005001463,1009001463]'),(32081471,0,1000,0,1,0,1,0,'[{{0,1001011400,1},1},{{0,1002011400,1},1},{{0,1003001400,1},1},{{0,1004011400,1},1},{{0,1006011400,1},1},{{0,1007011400,1},1},{{0,1008011400,1},1},{{0,1010011400,1},1}]','[]','[]'),(32081471,0,1000,0,2,0,1,0,'[{{0,1001021400,1},1},{{0,1002021400,1},1},{{0,1003001400,1},1},{{0,1004021400,1},1},{{0,1006021400,1},1},{{0,1007021400,1},1},{{0,1008021400,1},1},{{0,1010021400,1},1}]','[]','[]'),(32081471,0,1000,0,3,0,1,0,'[{{0,1001031400,1},1},{{0,1002031400,1},1},{{0,1003001400,1},1},{{0,1004031400,1},1},{{0,1006031400,1},1},{{0,1007031400,1},1},{{0,1008031400,1},1},{{0,1010031400,1},1}]','[]','[]'),(32081471,0,1000,0,4,0,1,0,'[{{0,1001041400,1},1},{{0,1002041400,1},1},{{0,1003001400,1},1},{{0,1004041400,1},1},{{0,1006041400,1},1},{{0,1007041400,1},1},{{0,1008041400,1},1},{{0,1010041400,1},1}]','[]','[]'),(32081472,0,1000,0,1,0,1,0,'[{{0,1002011400,1},1},{{0,1004011400,1},1},{{0,1006011400,1},1},{{0,1008011400,1},1},{{0,1010011400,1},1}]','[]','[]'),(32081472,0,1000,0,2,0,1,0,'[{{0,1002021400,1},1},{{0,1004021400,1},1},{{0,1006021400,1},1},{{0,1008021400,1},1},{{0,1010021400,1},1}]','[]','[]'),(32081472,0,1000,0,3,0,1,0,'[{{0,1002031400,1},1},{{0,1004031400,1},1},{{0,1006031400,1},1},{{0,1008031400,1},1},{{0,1010031400,1},1}]','[]','[]'),(32081472,0,1000,0,4,0,1,0,'[{{0,1002041400,1},1},{{0,1004041400,1},1},{{0,1006041400,1},1},{{0,1008041400,1},1},{{0,1010041400,1},1}]','[]','[]'),(32081473,0,1000,0,1,0,1,0,'[{{0,1001011400,1},1},{{0,1007011400,1},1}]','[]','[]'),(32081473,0,1000,0,2,0,1,0,'[{{0,1001021400,1},1},{{0,1007021400,1},1}]','[]','[]'),(32081473,0,1000,0,3,0,1,0,'[{{0,1001031400,1},1},{{0,1007031400,1},1}]','[]','[]'),(32081473,0,1000,0,4,0,1,0,'[{{0,1001041400,1},1},{{0,1007041400,1},1}]','[]','[]'),(32081475,0,1000,0,1,0,1,0,'[{{0,1002011400,1},1},{{0,1004011400,1},1},{{0,1006011400,1},1},{{0,1008011400,1},1},{{0,1010011400,1},1},{{0,1001011400,1},1}]','[]','[]'),(32081475,0,1000,0,2,0,1,0,'[{{0,1002021400,1},1},{{0,1004021400,1},1},{{0,1006021400,1},1},{{0,1008021400,1},1},{{0,1010021400,1},1},{{0,1001021400,1},1}]','[]','[]'),(32081475,0,1000,0,3,0,1,0,'[{{0,1002031400,1},1},{{0,1004031400,1},1},{{0,1006031400,1},1},{{0,1008031400,1},1},{{0,1010031400,1},1},{{0,1001031400,1},1}]','[]','[]'),(32081475,0,1000,0,4,0,1,0,'[{{0,1002041400,1},1},{{0,1004041400,1},1},{{0,1006041400,1},1},{{0,1008041400,1},1},{{0,1010041400,1},1},{{0,1001041400,1},1}]','[]','[]'),(32081476,0,1000,0,1,0,1,0,'[{{0,1007011400,1},1},{{0,1003001400,1},1},{{0,1005001400,1},1},{{0,1009001400,1},1}]','[]','[]'),(32081476,0,1000,0,2,0,1,0,'[{{0,1007021400,1},1},{{0,1003001400,1},1},{{0,1005001400,1},1},{{0,1009001400,1},1}]','[]','[]'),(32081476,0,1000,0,3,0,1,0,'[{{0,1007031400,1},1},{{0,1003001400,1},1},{{0,1005001400,1},1},{{0,1009001400,1},1}]','[]','[]'),(32081476,0,1000,0,4,0,1,0,'[{{0,1007041400,1},1},{{0,1003001400,1},1},{{0,1005001400,1},1},{{0,1009001400,1},1}]','[]','[]'),(32081477,0,1000,0,1,0,1,0,'[{{0,1007011400,1},1},{{0,1003001400,1},1}]','[]','[]'),(32081477,0,1000,0,2,0,1,0,'[{{0,1007021400,1},1},{{0,1003001400,1},1}]','[]','[]'),(32081477,0,1000,0,3,0,1,0,'[{{0,1007031400,1},1},{{0,1003001400,1},1}]','[]','[]'),(32081477,0,1000,0,4,0,1,0,'[{{0,1007041400,1},1},{{0,1003001400,1},1}]','[]','[]'),(32081478,0,1000,0,0,0,1,0,'[{{0,1005001400,1},1},{{0,1009001400,1},1}]','[]','[]'),(32081481,0,1000,0,1,0,1,0,'[{{0,1001011410,1},1},{{0,1002011410,1},1},{{0,1003001410,1},1},{{0,1004011410,1},1},{{0,1006011410,1},1},{{0,1007011410,1},1},{{0,1008011410,1},1},{{0,1010011410,1},1}]','[]','[]'),(32081481,0,1000,0,2,0,1,0,'[{{0,1001021410,1},1},{{0,1002021410,1},1},{{0,1003001410,1},1},{{0,1004021410,1},1},{{0,1006021410,1},1},{{0,1007021410,1},1},{{0,1008021410,1},1},{{0,1010021410,1},1}]','[]','[]'),(32081481,0,1000,0,3,0,1,0,'[{{0,1001031410,1},1},{{0,1002031410,1},1},{{0,1003001410,1},1},{{0,1004031410,1},1},{{0,1006031410,1},1},{{0,1007031410,1},1},{{0,1008031410,1},1},{{0,1010031410,1},1}]','[]','[]'),(32081481,0,1000,0,4,0,1,0,'[{{0,1001041410,1},1},{{0,1002041410,1},1},{{0,1003001410,1},1},{{0,1004041410,1},1},{{0,1006041410,1},1},{{0,1007041410,1},1},{{0,1008041410,1},1},{{0,1010041410,1},1}]','[]','[]'),(32081482,0,1000,0,1,0,1,0,'[{{0,1002011410,1},1},{{0,1004011410,1},1},{{0,1006011410,1},1},{{0,1008011410,1},1},{{0,1010011410,1},1}]','[]','[]'),(32081482,0,1000,0,2,0,1,0,'[{{0,1002021410,1},1},{{0,1004021410,1},1},{{0,1006021410,1},1},{{0,1008021410,1},1},{{0,1010021410,1},1}]','[]','[]'),(32081482,0,1000,0,3,0,1,0,'[{{0,1002031410,1},1},{{0,1004031410,1},1},{{0,1006031410,1},1},{{0,1008031410,1},1},{{0,1010031410,1},1}]','[]','[]'),(32081482,0,1000,0,4,0,1,0,'[{{0,1002041410,1},1},{{0,1004041410,1},1},{{0,1006041410,1},1},{{0,1008041410,1},1},{{0,1010041410,1},1}]','[]','[]'),(32081483,0,1000,0,1,0,1,0,'[{{0,1001011410,1},1},{{0,1007011410,1},1}]','[]','[]'),(32081483,0,1000,0,2,0,1,0,'[{{0,1001021410,1},1},{{0,1007021410,1},1}]','[]','[]'),(32081483,0,1000,0,3,0,1,0,'[{{0,1001031410,1},1},{{0,1007031410,1},1}]','[]','[]'),(32081483,0,1000,0,4,0,1,0,'[{{0,1001041410,1},1},{{0,1007041410,1},1}]','[]','[]'),(32081485,0,1000,0,1,0,1,0,'[{{0,1002011410,1},1},{{0,1004011410,1},1},{{0,1006011410,1},1},{{0,1008011410,1},1},{{0,1010011410,1},1},{{0,1001011410,1},1}]','[]','[]'),(32081485,0,1000,0,2,0,1,0,'[{{0,1002021410,1},1},{{0,1004021410,1},1},{{0,1006021410,1},1},{{0,1008021410,1},1},{{0,1010021410,1},1},{{0,1001021410,1},1}]','[]','[]'),(32081485,0,1000,0,3,0,1,0,'[{{0,1002031410,1},1},{{0,1004031410,1},1},{{0,1006031410,1},1},{{0,1008031410,1},1},{{0,1010031410,1},1},{{0,1001031410,1},1}]','[]','[]'),(32081485,0,1000,0,4,0,1,0,'[{{0,1002041410,1},1},{{0,1004041410,1},1},{{0,1006041410,1},1},{{0,1008041410,1},1},{{0,1010041410,1},1},{{0,1001041410,1},1}]','[]','[]'),(32081486,0,1000,0,1,0,1,0,'[{{0,1007011410,1},1},{{0,1003001410,1},1},{{0,1005001410,1},1},{{0,1009001410,1},1}]','[]','[]'),(32081486,0,1000,0,2,0,1,0,'[{{0,1007021410,1},1},{{0,1003001410,1},1},{{0,1005001410,1},1},{{0,1009001410,1},1}]','[]','[]'),(32081486,0,1000,0,3,0,1,0,'[{{0,1007031410,1},1},{{0,1003001410,1},1},{{0,1005001410,1},1},{{0,1009001410,1},1}]','[]','[]'),(32081486,0,1000,0,4,0,1,0,'[{{0,1007041410,1},1},{{0,1003001410,1},1},{{0,1005001410,1},1},{{0,1009001410,1},1}]','[]','[]'),(32081487,0,1000,0,1,0,1,0,'[{{0,1007011410,1},1},{{0,1003001410,1},1}]','[]','[]'),(32081487,0,1000,0,2,0,1,0,'[{{0,1007021410,1},1},{{0,1003001410,1},1}]','[]','[]'),(32081487,0,1000,0,3,0,1,0,'[{{0,1007031410,1},1},{{0,1003001410,1},1}]','[]','[]'),(32081487,0,1000,0,4,0,1,0,'[{{0,1007041410,1},1},{{0,1003001410,1},1}]','[]','[]'),(32081488,0,1000,0,0,0,1,0,'[{{0,1005001410,1},1},{{0,1009001410,1},1}]','[]','[]'),(32081491,0,1000,0,1,0,1,0,'[{{0,1001011420,1},1},{{0,1002011420,1},1},{{0,1003001420,1},1},{{0,1004011420,1},1},{{0,1006011420,1},1},{{0,1007011420,1},1},{{0,1008011420,1},1},{{0,1010011420,1},1}]','[]','[]'),(32081491,0,1000,0,2,0,1,0,'[{{0,1001021420,1},1},{{0,1002021420,1},1},{{0,1003001420,1},1},{{0,1004021420,1},1},{{0,1006021420,1},1},{{0,1007021420,1},1},{{0,1008021420,1},1},{{0,1010021420,1},1}]','[]','[]'),(32081491,0,1000,0,3,0,1,0,'[{{0,1001031420,1},1},{{0,1002031420,1},1},{{0,1003001420,1},1},{{0,1004031420,1},1},{{0,1006031420,1},1},{{0,1007031420,1},1},{{0,1008031420,1},1},{{0,1010031420,1},1}]','[]','[]'),(32081491,0,1000,0,4,0,1,0,'[{{0,1001041420,1},1},{{0,1002041420,1},1},{{0,1003001420,1},1},{{0,1004041420,1},1},{{0,1006041420,1},1},{{0,1007041420,1},1},{{0,1008041420,1},1},{{0,1010041420,1},1}]','[]','[]'),(32081492,0,1000,0,1,0,1,0,'[{{0,1002011420,1},1},{{0,1004011420,1},1},{{0,1006011420,1},1},{{0,1008011420,1},1},{{0,1010011420,1},1}]','[]','[]'),(32081492,0,1000,0,2,0,1,0,'[{{0,1002021420,1},1},{{0,1004021420,1},1},{{0,1006021420,1},1},{{0,1008021420,1},1},{{0,1010021420,1},1}]','[]','[]'),(32081492,0,1000,0,3,0,1,0,'[{{0,1002031420,1},1},{{0,1004031420,1},1},{{0,1006031420,1},1},{{0,1008031420,1},1},{{0,1010031420,1},1}]','[]','[]'),(32081492,0,1000,0,4,0,1,0,'[{{0,1002041420,1},1},{{0,1004041420,1},1},{{0,1006041420,1},1},{{0,1008041420,1},1},{{0,1010041420,1},1}]','[]','[]'),(32081493,0,1000,0,1,0,1,0,'[{{0,1001011420,1},1},{{0,1007011420,1},1}]','[]','[]'),(32081493,0,1000,0,2,0,1,0,'[{{0,1001021420,1},1},{{0,1007021420,1},1}]','[]','[]'),(32081493,0,1000,0,3,0,1,0,'[{{0,1001031420,1},1},{{0,1007031420,1},1}]','[]','[]'),(32081493,0,1000,0,4,0,1,0,'[{{0,1001041420,1},1},{{0,1007041420,1},1}]','[]','[]'),(32081495,0,1000,0,1,0,1,0,'[{{0,1002011420,1},1},{{0,1004011420,1},1},{{0,1006011420,1},1},{{0,1008011420,1},1},{{0,1010011420,1},1},{{0,1001011420,1},1}]','[]','[]'),(32081495,0,1000,0,2,0,1,0,'[{{0,1002021420,1},1},{{0,1004021420,1},1},{{0,1006021420,1},1},{{0,1008021420,1},1},{{0,1010021420,1},1},{{0,1001021420,1},1}]','[]','[]'),(32081495,0,1000,0,3,0,1,0,'[{{0,1002031420,1},1},{{0,1004031420,1},1},{{0,1006031420,1},1},{{0,1008031420,1},1},{{0,1010031420,1},1},{{0,1001031420,1},1}]','[]','[]'),(32081495,0,1000,0,4,0,1,0,'[{{0,1002041420,1},1},{{0,1004041420,1},1},{{0,1006041420,1},1},{{0,1008041420,1},1},{{0,1010041420,1},1},{{0,1001041420,1},1}]','[]','[]'),(32081496,0,1000,0,1,0,1,0,'[{{0,1007011420,1},1},{{0,1003001420,1},1},{{0,1005001420,1},1},{{0,1009001420,1},1}]','[]','[]'),(32081496,0,1000,0,2,0,1,0,'[{{0,1007021420,1},1},{{0,1003001420,1},1},{{0,1005001420,1},1},{{0,1009001420,1},1}]','[]','[]'),(32081496,0,1000,0,3,0,1,0,'[{{0,1007031420,1},1},{{0,1003001420,1},1},{{0,1005001420,1},1},{{0,1009001420,1},1}]','[]','[]'),(32081496,0,1000,0,4,0,1,0,'[{{0,1007041420,1},1},{{0,1003001420,1},1},{{0,1005001420,1},1},{{0,1009001420,1},1}]','[]','[]'),(32081497,0,1000,0,1,0,1,0,'[{{0,1007011420,1},1},{{0,1003001420,1},1}]','[]','[]'),(32081497,0,1000,0,2,0,1,0,'[{{0,1007021420,1},1},{{0,1003001420,1},1}]','[]','[]'),(32081497,0,1000,0,3,0,1,0,'[{{0,1007031420,1},1},{{0,1003001420,1},1}]','[]','[]'),(32081497,0,1000,0,4,0,1,0,'[{{0,1007041420,1},1},{{0,1003001420,1},1}]','[]','[]'),(32081498,0,1000,0,0,0,1,0,'[{{0,1005001420,1},1},{{0,1009001420,1},1}]','[]','[]'),(32081501,0,1000,0,1,0,1,0,'[{{0,1001011431,1},1},{{0,1002011431,1},1},{{0,1003001431,1},1},{{0,1004011431,1},1},{{0,1006011431,1},1},{{0,1007011431,1},1},{{0,1008011431,1},1},{{0,1010011431,1},1}]','[]','[]'),(32081501,0,1000,0,2,0,1,0,'[{{0,1001021431,1},1},{{0,1002021431,1},1},{{0,1003001431,1},1},{{0,1004021431,1},1},{{0,1006021431,1},1},{{0,1007021431,1},1},{{0,1008021431,1},1},{{0,1010021431,1},1}]','[]','[]'),(32081501,0,1000,0,3,0,1,0,'[{{0,1001031431,1},1},{{0,1002031431,1},1},{{0,1003001431,1},1},{{0,1004031431,1},1},{{0,1006031431,1},1},{{0,1007031431,1},1},{{0,1008031431,1},1},{{0,1010031431,1},1}]','[]','[]'),(32081501,0,1000,0,4,0,1,0,'[{{0,1001041431,1},1},{{0,1002041431,1},1},{{0,1003001431,1},1},{{0,1004041431,1},1},{{0,1006041431,1},1},{{0,1007041431,1},1},{{0,1008041431,1},1},{{0,1010041431,1},1}]','[]','[]'),(32081502,0,1000,0,1,0,1,0,'[{{0,1002011431,1},1},{{0,1004011431,1},1},{{0,1006011431,1},1},{{0,1008011431,1},1},{{0,1010011431,1},1}]','[]','[]'),(32081502,0,1000,0,2,0,1,0,'[{{0,1002021431,1},1},{{0,1004021431,1},1},{{0,1006021431,1},1},{{0,1008021431,1},1},{{0,1010021431,1},1}]','[]','[]'),(32081502,0,1000,0,3,0,1,0,'[{{0,1002031431,1},1},{{0,1004031431,1},1},{{0,1006031431,1},1},{{0,1008031431,1},1},{{0,1010031431,1},1}]','[]','[]'),(32081502,0,1000,0,4,0,1,0,'[{{0,1002041431,1},1},{{0,1004041431,1},1},{{0,1006041431,1},1},{{0,1008041431,1},1},{{0,1010041431,1},1}]','[]','[]'),(32081503,0,1000,0,1,0,1,0,'[{{0,1001011431,1},1},{{0,1007011431,1},1}]','[]','[]'),(32081503,0,1000,0,2,0,1,0,'[{{0,1001021431,1},1},{{0,1007021431,1},1}]','[]','[]'),(32081503,0,1000,0,3,0,1,0,'[{{0,1001031431,1},1},{{0,1007031431,1},1}]','[]','[]'),(32081503,0,1000,0,4,0,1,0,'[{{0,1001041431,1},1},{{0,1007041431,1},1}]','[]','[]'),(32081505,0,1000,0,1,0,1,0,'[{{0,1002011431,1},1},{{0,1004011431,1},1},{{0,1006011431,1},1},{{0,1008011431,1},1},{{0,1010011431,1},1},{{0,1001011431,1},1}]','[]','[]'),(32081505,0,1000,0,2,0,1,0,'[{{0,1002021431,1},1},{{0,1004021431,1},1},{{0,1006021431,1},1},{{0,1008021431,1},1},{{0,1010021431,1},1},{{0,1001021431,1},1}]','[]','[]'),(32081505,0,1000,0,3,0,1,0,'[{{0,1002031431,1},1},{{0,1004031431,1},1},{{0,1006031431,1},1},{{0,1008031431,1},1},{{0,1010031431,1},1},{{0,1001031431,1},1}]','[]','[]'),(32081505,0,1000,0,4,0,1,0,'[{{0,1002041431,1},1},{{0,1004041431,1},1},{{0,1006041431,1},1},{{0,1008041431,1},1},{{0,1010041431,1},1},{{0,1001041431,1},1}]','[]','[]'),(32081506,0,1000,0,1,0,1,0,'[{{0,1007011431,1},1},{{0,1003001431,1},1},{{0,1005001431,1},1},{{0,1009001431,1},1}]','[]','[]'),(32081506,0,1000,0,2,0,1,0,'[{{0,1007021431,1},1},{{0,1003001431,1},1},{{0,1005001431,1},1},{{0,1009001431,1},1}]','[]','[]'),(32081506,0,1000,0,3,0,1,0,'[{{0,1007031431,1},1},{{0,1003001431,1},1},{{0,1005001431,1},1},{{0,1009001431,1},1}]','[]','[]'),(32081506,0,1000,0,4,0,1,0,'[{{0,1007041431,1},1},{{0,1003001431,1},1},{{0,1005001431,1},1},{{0,1009001431,1},1}]','[]','[]'),(32081507,0,1000,0,1,0,1,0,'[{{0,1007011431,1},1},{{0,1003001431,1},1}]','[]','[]'),(32081507,0,1000,0,2,0,1,0,'[{{0,1007021431,1},1},{{0,1003001431,1},1}]','[]','[]'),(32081507,0,1000,0,3,0,1,0,'[{{0,1007031431,1},1},{{0,1003001431,1},1}]','[]','[]'),(32081507,0,1000,0,4,0,1,0,'[{{0,1007041431,1},1},{{0,1003001431,1},1}]','[]','[]'),(32081508,0,1000,0,0,0,1,0,'[{{0,1005001431,1},1},{{0,1009001431,1},1}]','[]','[]'),(32081511,0,1000,0,1,0,1,0,'[{{0,1001011532,1},1},{{0,1002011532,1},1},{{0,1003001532,1},1},{{0,1004011532,1},1},{{0,1006011532,1},1},{{0,1007011532,1},1},{{0,1008011532,1},1},{{0,1010011532,1},1}]','[]','[1001011532,1002011532,1003001532,1004011532,1005001532,1006011532,1007011532,1008011532,1009001532,1010011532]'),(32081511,0,1000,0,2,0,1,0,'[{{0,1001021532,1},1},{{0,1002021532,1},1},{{0,1003001532,1},1},{{0,1004021532,1},1},{{0,1006021532,1},1},{{0,1007021532,1},1},{{0,1008021532,1},1},{{0,1010021532,1},1}]','[]','[1001021532,1002021532,1003001532,1004021532,1005001532,1006021532,1007021532,1008021532,1009001532,1010021532]'),(32081511,0,1000,0,3,0,1,0,'[{{0,1001031532,1},1},{{0,1002031532,1},1},{{0,1003001532,1},1},{{0,1004031532,1},1},{{0,1006031532,1},1},{{0,1007031532,1},1},{{0,1008031532,1},1},{{0,1010031532,1},1}]','[]','[1001031532,1002031532,1003001532,1004031532,1005001532,1006031532,1007031532,1008031532,1009001532,1010031532]'),(32081511,0,1000,0,4,0,1,0,'[{{0,1001041532,1},1},{{0,1002041532,1},1},{{0,1003001532,1},1},{{0,1004041532,1},1},{{0,1006041532,1},1},{{0,1007041532,1},1},{{0,1008041532,1},1},{{0,1010041532,1},1}]','[]','[1001041532,1002041532,1003001532,1004041532,1005001532,1006041532,1007041532,1008041532,1009001532,1010041532]'),(32081512,0,1000,0,1,0,1,0,'[{{0,1002011532,1},1},{{0,1004011532,1},1},{{0,1006011532,1},1},{{0,1008011532,1},1},{{0,1010011532,1},1}]','[]','[1002011532,1004011532,1006011532,1008011532,1010011532]'),(32081512,0,1000,0,2,0,1,0,'[{{0,1002021532,1},1},{{0,1004021532,1},1},{{0,1006021532,1},1},{{0,1008021532,1},1},{{0,1010021532,1},1}]','[]','[1002021532,1004021532,1006021532,1008021532,1010021532]'),(32081512,0,1000,0,3,0,1,0,'[{{0,1002031532,1},1},{{0,1004031532,1},1},{{0,1006031532,1},1},{{0,1008031532,1},1},{{0,1010031532,1},1}]','[]','[1002031532,1004031532,1006031532,1008031532,1010031532]'),(32081512,0,1000,0,4,0,1,0,'[{{0,1002041532,1},1},{{0,1004041532,1},1},{{0,1006041532,1},1},{{0,1008041532,1},1},{{0,1010041532,1},1}]','[]','[1002041532,1004041532,1006041532,1008041532,1010041532]'),(32081513,0,1000,0,1,0,1,0,'[{{0,1001011532,1},1},{{0,1007011532,1},1}]','[]','[1001011532,1007011532]'),(32081513,0,1000,0,2,0,1,0,'[{{0,1001021532,1},1},{{0,1007021532,1},1}]','[]','[1001021532,1007021532]'),(32081513,0,1000,0,3,0,1,0,'[{{0,1001031532,1},1},{{0,1007031532,1},1}]','[]','[1001031532,1007031532]'),(32081513,0,1000,0,4,0,1,0,'[{{0,1001041532,1},1},{{0,1007041532,1},1}]','[]','[1001041532,1007041532]'),(32081515,0,1000,0,1,0,1,0,'[{{0,1002011532,1},1},{{0,1004011532,1},1},{{0,1006011532,1},1},{{0,1008011532,1},1},{{0,1010011532,1},1},{{0,1001011532,1},1}]','[]','[1002011532,1004011532,1006011532,1008011532,1010011532,1001011532]'),(32081515,0,1000,0,2,0,1,0,'[{{0,1002021532,1},1},{{0,1004021532,1},1},{{0,1006021532,1},1},{{0,1008021532,1},1},{{0,1010021532,1},1},{{0,1001021532,1},1}]','[]','[1002021532,1004021532,1006021532,1008021532,1010021532,1001021532]'),(32081515,0,1000,0,3,0,1,0,'[{{0,1002031532,1},1},{{0,1004031532,1},1},{{0,1006031532,1},1},{{0,1008031532,1},1},{{0,1010031532,1},1},{{0,1001031532,1},1}]','[]','[1002031532,1004031532,1006031532,1008031532,1010031532,1001031532]'),(32081515,0,1000,0,4,0,1,0,'[{{0,1002041532,1},1},{{0,1004041532,1},1},{{0,1006041532,1},1},{{0,1008041532,1},1},{{0,1010041532,1},1},{{0,1001041532,1},1}]','[]','[1002041532,1004041532,1006041532,1008041532,1010041532,1001041532]'),(32081516,0,1000,0,1,0,1,0,'[{{0,1007011532,1},1},{{0,1003001532,1},1},{{0,1005001532,1},1},{{0,1009001532,1},1}]','[]','[1007011532,1003001532,1005001532,1009001532]'),(32081516,0,1000,0,2,0,1,0,'[{{0,1007021532,1},1},{{0,1003001532,1},1},{{0,1005001532,1},1},{{0,1009001532,1},1}]','[]','[1007021532,1003001532,1005001532,1009001532]'),(32081516,0,1000,0,3,0,1,0,'[{{0,1007031532,1},1},{{0,1003001532,1},1},{{0,1005001532,1},1},{{0,1009001532,1},1}]','[]','[1007031532,1003001532,1005001532,1009001532]'),(32081516,0,1000,0,4,0,1,0,'[{{0,1007041532,1},1},{{0,1003001532,1},1},{{0,1005001532,1},1},{{0,1009001532,1},1}]','[]','[1007041532,1003001532,1005001532,1009001532]'),(32081517,0,1000,0,1,0,1,0,'[{{0,1007011532,1},1},{{0,1003001532,1},1}]','[]','[1007011532,1003001532]'),(32081517,0,1000,0,2,0,1,0,'[{{0,1007021532,1},1},{{0,1003001532,1},1}]','[]','[1007021532,1003001532]'),(32081517,0,1000,0,3,0,1,0,'[{{0,1007031532,1},1},{{0,1003001532,1},1}]','[]','[1007031532,1003001532]'),(32081517,0,1000,0,4,0,1,0,'[{{0,1007041532,1},1},{{0,1003001532,1},1}]','[]','[1007041532,1003001532]'),(32081518,0,1000,0,0,0,1,0,'[{{0,1005001532,1},1},{{0,1009001532,1},1}]','[]','[1005001532,1009001532]'),(32081521,0,1000,0,1,0,1,0,'[{{0,1001011541,1},1},{{0,1002011541,1},1},{{0,1003001541,1},1},{{0,1004011541,1},1},{{0,1006011541,1},1},{{0,1007011541,1},1},{{0,1008011541,1},1},{{0,1010011541,1},1}]','[]','[]'),(32081521,0,1000,0,2,0,1,0,'[{{0,1001021541,1},1},{{0,1002021541,1},1},{{0,1003001541,1},1},{{0,1004021541,1},1},{{0,1006021541,1},1},{{0,1007021541,1},1},{{0,1008021541,1},1},{{0,1010021541,1},1}]','[]','[]'),(32081521,0,1000,0,3,0,1,0,'[{{0,1001031541,1},1},{{0,1002031541,1},1},{{0,1003001541,1},1},{{0,1004031541,1},1},{{0,1006031541,1},1},{{0,1007031541,1},1},{{0,1008031541,1},1},{{0,1010031541,1},1}]','[]','[]'),(32081521,0,1000,0,4,0,1,0,'[{{0,1001041541,1},1},{{0,1002041541,1},1},{{0,1003001541,1},1},{{0,1004041541,1},1},{{0,1006041541,1},1},{{0,1007041541,1},1},{{0,1008041541,1},1},{{0,1010041541,1},1}]','[]','[]'),(32081522,0,1000,0,1,0,1,0,'[{{0,1002011541,1},1},{{0,1004011541,1},1},{{0,1006011541,1},1},{{0,1008011541,1},1},{{0,1010011541,1},1}]','[]','[]'),(32081522,0,1000,0,2,0,1,0,'[{{0,1002021541,1},1},{{0,1004021541,1},1},{{0,1006021541,1},1},{{0,1008021541,1},1},{{0,1010021541,1},1}]','[]','[]'),(32081522,0,1000,0,3,0,1,0,'[{{0,1002031541,1},1},{{0,1004031541,1},1},{{0,1006031541,1},1},{{0,1008031541,1},1},{{0,1010031541,1},1}]','[]','[]'),(32081522,0,1000,0,4,0,1,0,'[{{0,1002041541,1},1},{{0,1004041541,1},1},{{0,1006041541,1},1},{{0,1008041541,1},1},{{0,1010041541,1},1}]','[]','[]'),(32081523,0,1000,0,1,0,1,0,'[{{0,1001011541,1},1},{{0,1007011541,1},1}]','[]','[]'),(32081523,0,1000,0,2,0,1,0,'[{{0,1001021541,1},1},{{0,1007021541,1},1}]','[]','[]'),(32081523,0,1000,0,3,0,1,0,'[{{0,1001031541,1},1},{{0,1007031541,1},1}]','[]','[]'),(32081523,0,1000,0,4,0,1,0,'[{{0,1001041541,1},1},{{0,1007041541,1},1}]','[]','[]'),(32081525,0,1000,0,1,0,1,0,'[{{0,1002011541,1},1},{{0,1004011541,1},1},{{0,1006011541,1},1},{{0,1008011541,1},1},{{0,1010011541,1},1},{{0,1001011541,1},1}]','[]','[]'),(32081525,0,1000,0,2,0,1,0,'[{{0,1002021541,1},1},{{0,1004021541,1},1},{{0,1006021541,1},1},{{0,1008021541,1},1},{{0,1010021541,1},1},{{0,1001021541,1},1}]','[]','[]'),(32081525,0,1000,0,3,0,1,0,'[{{0,1002031541,1},1},{{0,1004031541,1},1},{{0,1006031541,1},1},{{0,1008031541,1},1},{{0,1010031541,1},1},{{0,1001031541,1},1}]','[]','[]'),(32081525,0,1000,0,4,0,1,0,'[{{0,1002041541,1},1},{{0,1004041541,1},1},{{0,1006041541,1},1},{{0,1008041541,1},1},{{0,1010041541,1},1},{{0,1001041541,1},1}]','[]','[]'),(32081526,0,1000,0,1,0,1,0,'[{{0,1007011541,1},1},{{0,1003001541,1},1},{{0,1005001541,1},1},{{0,1009001541,1},1}]','[]','[]'),(32081526,0,1000,0,2,0,1,0,'[{{0,1007021541,1},1},{{0,1003001541,1},1},{{0,1005001541,1},1},{{0,1009001541,1},1}]','[]','[]'),(32081526,0,1000,0,3,0,1,0,'[{{0,1007031541,1},1},{{0,1003001541,1},1},{{0,1005001541,1},1},{{0,1009001541,1},1}]','[]','[]'),(32081526,0,1000,0,4,0,1,0,'[{{0,1007041541,1},1},{{0,1003001541,1},1},{{0,1005001541,1},1},{{0,1009001541,1},1}]','[]','[]'),(32081527,0,1000,0,1,0,1,0,'[{{0,1007011541,1},1},{{0,1003001541,1},1}]','[]','[]'),(32081527,0,1000,0,2,0,1,0,'[{{0,1007021541,1},1},{{0,1003001541,1},1}]','[]','[]'),(32081527,0,1000,0,3,0,1,0,'[{{0,1007031541,1},1},{{0,1003001541,1},1}]','[]','[]'),(32081527,0,1000,0,4,0,1,0,'[{{0,1007041541,1},1},{{0,1003001541,1},1}]','[]','[]'),(32081528,0,1000,0,0,0,1,0,'[{{0,1005001541,1},1},{{0,1009001541,1},1}]','[]','[]'),(32081531,0,1000,0,1,0,1,0,'[{{0,1001011542,1},1},{{0,1002011542,1},1},{{0,1003001542,1},1},{{0,1004011542,1},1},{{0,1006011542,1},1},{{0,1007011542,1},1},{{0,1008011542,1},1},{{0,1010011542,1},1}]','[]','[1001011542,1002011542,1003001542,1004011542,1005001542,1006011542,1007011542,1008011542,1009001542,1010011542]'),(32081531,0,1000,0,2,0,1,0,'[{{0,1001021542,1},1},{{0,1002021542,1},1},{{0,1003001542,1},1},{{0,1004021542,1},1},{{0,1006021542,1},1},{{0,1007021542,1},1},{{0,1008021542,1},1},{{0,1010021542,1},1}]','[]','[1001021542,1002021542,1003001542,1004021542,1005001542,1006021542,1007021542,1008021542,1009001542,1010021542]'),(32081531,0,1000,0,3,0,1,0,'[{{0,1001031542,1},1},{{0,1002031542,1},1},{{0,1003001542,1},1},{{0,1004031542,1},1},{{0,1006031542,1},1},{{0,1007031542,1},1},{{0,1008031542,1},1},{{0,1010031542,1},1}]','[]','[1001031542,1002031542,1003001542,1004031542,1005001542,1006031542,1007031542,1008031542,1009001542,1010031542]'),(32081531,0,1000,0,4,0,1,0,'[{{0,1001041542,1},1},{{0,1002041542,1},1},{{0,1003001542,1},1},{{0,1004041542,1},1},{{0,1006041542,1},1},{{0,1007041542,1},1},{{0,1008041542,1},1},{{0,1010041542,1},1}]','[]','[1001041542,1002041542,1003001542,1004041542,1005001542,1006041542,1007041542,1008041542,1009001542,1010041542]'),(32081532,0,1000,0,1,0,1,0,'[{{0,1002011542,1},1},{{0,1004011542,1},1},{{0,1006011542,1},1},{{0,1008011542,1},1},{{0,1010011542,1},1}]','[]','[1002011542,1004011542,1006011542,1008011542,1010011542]'),(32081532,0,1000,0,2,0,1,0,'[{{0,1002021542,1},1},{{0,1004021542,1},1},{{0,1006021542,1},1},{{0,1008021542,1},1},{{0,1010021542,1},1}]','[]','[1002021542,1004021542,1006021542,1008021542,1010021542]'),(32081532,0,1000,0,3,0,1,0,'[{{0,1002031542,1},1},{{0,1004031542,1},1},{{0,1006031542,1},1},{{0,1008031542,1},1},{{0,1010031542,1},1}]','[]','[1002031542,1004031542,1006031542,1008031542,1010031542]'),(32081532,0,1000,0,4,0,1,0,'[{{0,1002041542,1},1},{{0,1004041542,1},1},{{0,1006041542,1},1},{{0,1008041542,1},1},{{0,1010041542,1},1}]','[]','[1002041542,1004041542,1006041542,1008041542,1010041542]'),(32081533,0,1000,0,1,0,1,0,'[{{0,1001011542,1},1},{{0,1007011542,1},1}]','[]','[1001011542,1007011542]'),(32081533,0,1000,0,2,0,1,0,'[{{0,1001021542,1},1},{{0,1007021542,1},1}]','[]','[1001021542,1007021542]'),(32081533,0,1000,0,3,0,1,0,'[{{0,1001031542,1},1},{{0,1007031542,1},1}]','[]','[1001031542,1007031542]'),(32081533,0,1000,0,4,0,1,0,'[{{0,1001041542,1},1},{{0,1007041542,1},1}]','[]','[1001041542,1007041542]'),(32081535,0,1000,0,1,0,1,0,'[{{0,1002011542,1},1},{{0,1004011542,1},1},{{0,1006011542,1},1},{{0,1008011542,1},1},{{0,1010011542,1},1},{{0,1001011542,1},1}]','[]','[1002011542,1004011542,1006011542,1008011542,1010011542,1001011542]'),(32081535,0,1000,0,2,0,1,0,'[{{0,1002021542,1},1},{{0,1004021542,1},1},{{0,1006021542,1},1},{{0,1008021542,1},1},{{0,1010021542,1},1},{{0,1001021542,1},1}]','[]','[1002021542,1004021542,1006021542,1008021542,1010021542,1001021542]'),(32081535,0,1000,0,3,0,1,0,'[{{0,1002031542,1},1},{{0,1004031542,1},1},{{0,1006031542,1},1},{{0,1008031542,1},1},{{0,1010031542,1},1},{{0,1001031542,1},1}]','[]','[1002031542,1004031542,1006031542,1008031542,1010031542,1001031542]'),(32081535,0,1000,0,4,0,1,0,'[{{0,1002041542,1},1},{{0,1004041542,1},1},{{0,1006041542,1},1},{{0,1008041542,1},1},{{0,1010041542,1},1},{{0,1001041542,1},1}]','[]','[1002041542,1004041542,1006041542,1008041542,1010041542,1001041542]'),(32081536,0,1000,0,1,0,1,0,'[{{0,1007011542,1},1},{{0,1003001542,1},1},{{0,1005001542,1},1},{{0,1009001542,1},1}]','[]','[1007011542,1003001542,1005001542,1009001542]'),(32081536,0,1000,0,2,0,1,0,'[{{0,1007021542,1},1},{{0,1003001542,1},1},{{0,1005001542,1},1},{{0,1009001542,1},1}]','[]','[1007021542,1003001542,1005001542,1009001542]'),(32081536,0,1000,0,3,0,1,0,'[{{0,1007031542,1},1},{{0,1003001542,1},1},{{0,1005001542,1},1},{{0,1009001542,1},1}]','[]','[1007031542,1003001542,1005001542,1009001542]'),(32081536,0,1000,0,4,0,1,0,'[{{0,1007041542,1},1},{{0,1003001542,1},1},{{0,1005001542,1},1},{{0,1009001542,1},1}]','[]','[1007041542,1003001542,1005001542,1009001542]'),(32081537,0,1000,0,1,0,1,0,'[{{0,1007011542,1},1},{{0,1003001542,1},1}]','[]','[1007011542,1003001542]'),(32081537,0,1000,0,2,0,1,0,'[{{0,1007021542,1},1},{{0,1003001542,1},1}]','[]','[1007021542,1003001542]'),(32081537,0,1000,0,3,0,1,0,'[{{0,1007031542,1},1},{{0,1003001542,1},1}]','[]','[1007031542,1003001542]'),(32081537,0,1000,0,4,0,1,0,'[{{0,1007041542,1},1},{{0,1003001542,1},1}]','[]','[1007041542,1003001542]'),(32081538,0,1000,0,0,0,1,0,'[{{0,1005001542,1},1},{{0,1009001542,1},1}]','[]','[1005001542,1009001542]'),(32081541,0,1000,0,1,0,1,0,'[{{0,1001011543,1},1},{{0,1002011543,1},1},{{0,1003001543,1},1},{{0,1004011543,1},1},{{0,1006011543,1},1},{{0,1007011543,1},1},{{0,1008011543,1},1},{{0,1010011543,1},1}]','[]','[1001011543,1002011543,1003001543,1004011543,1005001543,1006011543,1007011543,1008011543,1009001543,1010011543]'),(32081541,0,1000,0,2,0,1,0,'[{{0,1001021543,1},1},{{0,1002021543,1},1},{{0,1003001543,1},1},{{0,1004021543,1},1},{{0,1006021543,1},1},{{0,1007021543,1},1},{{0,1008021543,1},1},{{0,1010021543,1},1}]','[]','[1001021543,1002021543,1003001543,1004021543,1005001543,1006021543,1007021543,1008021543,1009001543,1010021543]'),(32081541,0,1000,0,3,0,1,0,'[{{0,1001031543,1},1},{{0,1002031543,1},1},{{0,1003001543,1},1},{{0,1004031543,1},1},{{0,1006031543,1},1},{{0,1007031543,1},1},{{0,1008031543,1},1},{{0,1010031543,1},1}]','[]','[1001031543,1002031543,1003001543,1004031543,1005001543,1006031543,1007031543,1008031543,1009001543,1010031543]'),(32081541,0,1000,0,4,0,1,0,'[{{0,1001041543,1},1},{{0,1002041543,1},1},{{0,1003001543,1},1},{{0,1004041543,1},1},{{0,1006041543,1},1},{{0,1007041543,1},1},{{0,1008041543,1},1},{{0,1010041543,1},1}]','[]','[1001041543,1002041543,1003001543,1004041543,1005001543,1006041543,1007041543,1008041543,1009001543,1010041543]'),(32081542,0,1000,0,1,0,1,0,'[{{0,1002011543,1},1},{{0,1004011543,1},1},{{0,1006011543,1},1},{{0,1008011543,1},1},{{0,1010011543,1},1}]','[]','[1002011543,1004011543,1006011543,1008011543,1010011543]'),(32081542,0,1000,0,2,0,1,0,'[{{0,1002021543,1},1},{{0,1004021543,1},1},{{0,1006021543,1},1},{{0,1008021543,1},1},{{0,1010021543,1},1}]','[]','[1002021543,1004021543,1006021543,1008021543,1010021543]'),(32081542,0,1000,0,3,0,1,0,'[{{0,1002031543,1},1},{{0,1004031543,1},1},{{0,1006031543,1},1},{{0,1008031543,1},1},{{0,1010031543,1},1}]','[]','[1002031543,1004031543,1006031543,1008031543,1010031543]'),(32081542,0,1000,0,4,0,1,0,'[{{0,1002041543,1},1},{{0,1004041543,1},1},{{0,1006041543,1},1},{{0,1008041543,1},1},{{0,1010041543,1},1}]','[]','[1002041543,1004041543,1006041543,1008041543,1010041543]'),(32081543,0,1000,0,1,0,1,0,'[{{0,1001011543,1},1},{{0,1007011543,1},1}]','[]','[1001011543,1007011543]'),(32081543,0,1000,0,2,0,1,0,'[{{0,1001021543,1},1},{{0,1007021543,1},1}]','[]','[1001021543,1007021543]'),(32081543,0,1000,0,3,0,1,0,'[{{0,1001031543,1},1},{{0,1007031543,1},1}]','[]','[1001031543,1007031543]'),(32081543,0,1000,0,4,0,1,0,'[{{0,1001041543,1},1},{{0,1007041543,1},1}]','[]','[1001041543,1007041543]'),(32081545,0,1000,0,1,0,1,0,'[{{0,1002011543,1},1},{{0,1004011543,1},1},{{0,1006011543,1},1},{{0,1008011543,1},1},{{0,1010011543,1},1},{{0,1001011543,1},1}]','[]','[1002011543,1004011543,1006011543,1008011543,1010011543,1001011543]'),(32081545,0,1000,0,2,0,1,0,'[{{0,1002021543,1},1},{{0,1004021543,1},1},{{0,1006021543,1},1},{{0,1008021543,1},1},{{0,1010021543,1},1},{{0,1001021543,1},1}]','[]','[1002021543,1004021543,1006021543,1008021543,1010021543,1001021543]'),(32081545,0,1000,0,3,0,1,0,'[{{0,1002031543,1},1},{{0,1004031543,1},1},{{0,1006031543,1},1},{{0,1008031543,1},1},{{0,1010031543,1},1},{{0,1001031543,1},1}]','[]','[1002031543,1004031543,1006031543,1008031543,1010031543,1001031543]'),(32081545,0,1000,0,4,0,1,0,'[{{0,1002041543,1},1},{{0,1004041543,1},1},{{0,1006041543,1},1},{{0,1008041543,1},1},{{0,1010041543,1},1},{{0,1001041543,1},1}]','[]','[1002041543,1004041543,1006041543,1008041543,1010041543,1001041543]'),(32081546,0,1000,0,1,0,1,0,'[{{0,1007011543,1},1},{{0,1003001543,1},1},{{0,1005001543,1},1},{{0,1009001543,1},1}]','[]','[1007011543,1003001543,1005001543,1009001543]'),(32081546,0,1000,0,2,0,1,0,'[{{0,1007021543,1},1},{{0,1003001543,1},1},{{0,1005001543,1},1},{{0,1009001543,1},1}]','[]','[1007021543,1003001543,1005001543,1009001543]'),(32081546,0,1000,0,3,0,1,0,'[{{0,1007031543,1},1},{{0,1003001543,1},1},{{0,1005001543,1},1},{{0,1009001543,1},1}]','[]','[1007031543,1003001543,1005001543,1009001543]'),(32081546,0,1000,0,4,0,1,0,'[{{0,1007041543,1},1},{{0,1003001543,1},1},{{0,1005001543,1},1},{{0,1009001543,1},1}]','[]','[1007041543,1003001543,1005001543,1009001543]'),(32081547,0,1000,0,1,0,1,0,'[{{0,1007011543,1},1},{{0,1003001543,1},1}]','[]','[1007011543,1003001543]'),(32081547,0,1000,0,2,0,1,0,'[{{0,1007021543,1},1},{{0,1003001543,1},1}]','[]','[1007021543,1003001543]'),(32081547,0,1000,0,3,0,1,0,'[{{0,1007031543,1},1},{{0,1003001543,1},1}]','[]','[1007031543,1003001543]'),(32081547,0,1000,0,4,0,1,0,'[{{0,1007041543,1},1},{{0,1003001543,1},1}]','[]','[1007041543,1003001543]'),(32081548,0,1000,0,0,0,1,0,'[{{0,1005001543,1},1},{{0,1009001543,1},1}]','[]','[1005001543,1009001543]'),(32081551,0,1000,0,1,0,1,0,'[{{0,1001011553,1},1},{{0,1002011553,1},1},{{0,1003001553,1},1},{{0,1004011553,1},1},{{0,1006011553,1},1},{{0,1007011553,1},1},{{0,1008011553,1},1},{{0,1010011553,1},1}]','[]','[1001011553,1002011553,1003001553,1004011553,1005001553,1006011553,1007011553,1008011553,1009001553,1010011553]'),(32081551,0,1000,0,2,0,1,0,'[{{0,1001021553,1},1},{{0,1002021553,1},1},{{0,1003001553,1},1},{{0,1004021553,1},1},{{0,1006021553,1},1},{{0,1007021553,1},1},{{0,1008021553,1},1},{{0,1010021553,1},1}]','[]','[1001021553,1002021553,1003001553,1004021553,1005001553,1006021553,1007021553,1008021553,1009001553,1010021553]'),(32081551,0,1000,0,3,0,1,0,'[{{0,1001031553,1},1},{{0,1002031553,1},1},{{0,1003001553,1},1},{{0,1004031553,1},1},{{0,1006031553,1},1},{{0,1007031553,1},1},{{0,1008031553,1},1},{{0,1010031553,1},1}]','[]','[1001031553,1002031553,1003001553,1004031553,1005001553,1006031553,1007031553,1008031553,1009001553,1010031553]'),(32081551,0,1000,0,4,0,1,0,'[{{0,1001041553,1},1},{{0,1002041553,1},1},{{0,1003001553,1},1},{{0,1004041553,1},1},{{0,1006041553,1},1},{{0,1007041553,1},1},{{0,1008041553,1},1},{{0,1010041553,1},1}]','[]','[1001041553,1002041553,1003001553,1004041553,1005001553,1006041553,1007041553,1008041553,1009001553,1010041553]'),(32081552,0,1000,0,1,0,1,0,'[{{0,1002011553,1},1},{{0,1004011553,1},1},{{0,1006011553,1},1},{{0,1008011553,1},1},{{0,1010011553,1},1}]','[]','[1002011553,1004011553,1006011553,1008011553,1010011553]'),(32081552,0,1000,0,2,0,1,0,'[{{0,1002021553,1},1},{{0,1004021553,1},1},{{0,1006021553,1},1},{{0,1008021553,1},1},{{0,1010021553,1},1}]','[]','[1002021553,1004021553,1006021553,1008021553,1010021553]'),(32081552,0,1000,0,3,0,1,0,'[{{0,1002031553,1},1},{{0,1004031553,1},1},{{0,1006031553,1},1},{{0,1008031553,1},1},{{0,1010031553,1},1}]','[]','[1002031553,1004031553,1006031553,1008031553,1010031553]'),(32081552,0,1000,0,4,0,1,0,'[{{0,1002041553,1},1},{{0,1004041553,1},1},{{0,1006041553,1},1},{{0,1008041553,1},1},{{0,1010041553,1},1}]','[]','[1002041553,1004041553,1006041553,1008041553,1010041553]'),(32081553,0,1000,0,1,0,1,0,'[{{0,1001011553,1},1},{{0,1007011553,1},1}]','[]','[1001011553,1007011553]'),(32081553,0,1000,0,2,0,1,0,'[{{0,1001021553,1},1},{{0,1007021553,1},1}]','[]','[1001021553,1007021553]'),(32081553,0,1000,0,3,0,1,0,'[{{0,1001031553,1},1},{{0,1007031553,1},1}]','[]','[1001031553,1007031553]'),(32081553,0,1000,0,4,0,1,0,'[{{0,1001041553,1},1},{{0,1007041553,1},1}]','[]','[1001041553,1007041553]'),(32081555,0,1000,0,1,0,1,0,'[{{0,1002011553,1},1},{{0,1004011553,1},1},{{0,1006011553,1},1},{{0,1008011553,1},1},{{0,1010011553,1},1},{{0,1001011553,1},1}]','[]','[1002011553,1004011553,1006011553,1008011553,1010011553,1001011553]'),(32081555,0,1000,0,2,0,1,0,'[{{0,1002021553,1},1},{{0,1004021553,1},1},{{0,1006021553,1},1},{{0,1008021553,1},1},{{0,1010021553,1},1},{{0,1001021553,1},1}]','[]','[1002021553,1004021553,1006021553,1008021553,1010021553,1001021553]'),(32081555,0,1000,0,3,0,1,0,'[{{0,1002031553,1},1},{{0,1004031553,1},1},{{0,1006031553,1},1},{{0,1008031553,1},1},{{0,1010031553,1},1},{{0,1001031553,1},1}]','[]','[1002031553,1004031553,1006031553,1008031553,1010031553,1001031553]'),(32081555,0,1000,0,4,0,1,0,'[{{0,1002041553,1},1},{{0,1004041553,1},1},{{0,1006041553,1},1},{{0,1008041553,1},1},{{0,1010041553,1},1},{{0,1001041553,1},1}]','[]','[1002041553,1004041553,1006041553,1008041553,1010041553,1001041553]'),(32081556,0,1000,0,1,0,1,0,'[{{0,1007011553,1},1},{{0,1003001553,1},1},{{0,1005001553,1},1},{{0,1009001553,1},1}]','[]','[1007011553,1003001553,1005001553,1009001553]'),(32081556,0,1000,0,2,0,1,0,'[{{0,1007021553,1},1},{{0,1003001553,1},1},{{0,1005001553,1},1},{{0,1009001553,1},1}]','[]','[1007021553,1003001553,1005001553,1009001553]'),(32081556,0,1000,0,3,0,1,0,'[{{0,1007031553,1},1},{{0,1003001553,1},1},{{0,1005001553,1},1},{{0,1009001553,1},1}]','[]','[1007031553,1003001553,1005001553,1009001553]'),(32081556,0,1000,0,4,0,1,0,'[{{0,1007041553,1},1},{{0,1003001553,1},1},{{0,1005001553,1},1},{{0,1009001553,1},1}]','[]','[1007041553,1003001553,1005001553,1009001553]'),(32081557,0,1000,0,1,0,1,0,'[{{0,1007011553,1},1},{{0,1003001553,1},1}]','[]','[1007011553,1003001553]'),(32081557,0,1000,0,2,0,1,0,'[{{0,1007021553,1},1},{{0,1003001553,1},1}]','[]','[1007021553,1003001553]'),(32081557,0,1000,0,3,0,1,0,'[{{0,1007031553,1},1},{{0,1003001553,1},1}]','[]','[1007031553,1003001553]'),(32081557,0,1000,0,4,0,1,0,'[{{0,1007041553,1},1},{{0,1003001553,1},1}]','[]','[1007041553,1003001553]'),(32081558,0,1000,0,0,0,1,0,'[{{0,1005001553,1},1},{{0,1009001553,1},1}]','[]','[1005001553,1009001553]'),(32081561,0,1000,0,1,0,1,0,'[{{0,1001011563,1},1},{{0,1002011563,1},1},{{0,1003001563,1},1},{{0,1004011563,1},1},{{0,1006011563,1},1},{{0,1007011563,1},1},{{0,1008011563,1},1},{{0,1010011563,1},1}]','[]','[1001011563,1002011563,1003001563,1004011563,1005001563,1006011563,1007011563,1008011563,1009001563,1010011563]'),(32081561,0,1000,0,2,0,1,0,'[{{0,1001021563,1},1},{{0,1002021563,1},1},{{0,1003001563,1},1},{{0,1004021563,1},1},{{0,1006021563,1},1},{{0,1007021563,1},1},{{0,1008021563,1},1},{{0,1010021563,1},1}]','[]','[1001021563,1002021563,1003001563,1004021563,1005001563,1006021563,1007021563,1008021563,1009001563,1010021563]'),(32081561,0,1000,0,3,0,1,0,'[{{0,1001031563,1},1},{{0,1002031563,1},1},{{0,1003001563,1},1},{{0,1004031563,1},1},{{0,1006031563,1},1},{{0,1007031563,1},1},{{0,1008031563,1},1},{{0,1010031563,1},1}]','[]','[1001031563,1002031563,1003001563,1004031563,1005001563,1006031563,1007031563,1008031563,1009001563,1010031563]'),(32081561,0,1000,0,4,0,1,0,'[{{0,1001041563,1},1},{{0,1002041563,1},1},{{0,1003001563,1},1},{{0,1004041563,1},1},{{0,1006041563,1},1},{{0,1007041563,1},1},{{0,1008041563,1},1},{{0,1010041563,1},1}]','[]','[1001041563,1002041563,1003001563,1004041563,1005001563,1006041563,1007041563,1008041563,1009001563,1010041563]'),(32081562,0,1000,0,1,0,1,0,'[{{0,1002011563,1},1},{{0,1004011563,1},1},{{0,1006011563,1},1},{{0,1008011563,1},1},{{0,1010011563,1},1}]','[]','[1002011563,1004011563,1006011563,1008011563,1010011563]'),(32081562,0,1000,0,2,0,1,0,'[{{0,1002021563,1},1},{{0,1004021563,1},1},{{0,1006021563,1},1},{{0,1008021563,1},1},{{0,1010021563,1},1}]','[]','[1002021563,1004021563,1006021563,1008021563,1010021563]'),(32081562,0,1000,0,3,0,1,0,'[{{0,1002031563,1},1},{{0,1004031563,1},1},{{0,1006031563,1},1},{{0,1008031563,1},1},{{0,1010031563,1},1}]','[]','[1002031563,1004031563,1006031563,1008031563,1010031563]'),(32081562,0,1000,0,4,0,1,0,'[{{0,1002041563,1},1},{{0,1004041563,1},1},{{0,1006041563,1},1},{{0,1008041563,1},1},{{0,1010041563,1},1}]','[]','[1002041563,1004041563,1006041563,1008041563,1010041563]'),(32081563,0,1000,0,1,0,1,0,'[{{0,1001011563,1},1},{{0,1007011563,1},1}]','[]','[1001011563,1007011563]'),(32081563,0,1000,0,2,0,1,0,'[{{0,1001021563,1},1},{{0,1007021563,1},1}]','[]','[1001021563,1007021563]'),(32081563,0,1000,0,3,0,1,0,'[{{0,1001031563,1},1},{{0,1007031563,1},1}]','[]','[1001031563,1007031563]'),(32081563,0,1000,0,4,0,1,0,'[{{0,1001041563,1},1},{{0,1007041563,1},1}]','[]','[1001041563,1007041563]'),(32081565,0,1000,0,1,0,1,0,'[{{0,1002011563,1},1},{{0,1004011563,1},1},{{0,1006011563,1},1},{{0,1008011563,1},1},{{0,1010011563,1},1},{{0,1001011563,1},1}]','[]','[1002011563,1004011563,1006011563,1008011563,1010011563,1001011563]'),(32081565,0,1000,0,2,0,1,0,'[{{0,1002021563,1},1},{{0,1004021563,1},1},{{0,1006021563,1},1},{{0,1008021563,1},1},{{0,1010021563,1},1},{{0,1001021563,1},1}]','[]','[1002021563,1004021563,1006021563,1008021563,1010021563,1001021563]'),(32081565,0,1000,0,3,0,1,0,'[{{0,1002031563,1},1},{{0,1004031563,1},1},{{0,1006031563,1},1},{{0,1008031563,1},1},{{0,1010031563,1},1},{{0,1001031563,1},1}]','[]','[1002031563,1004031563,1006031563,1008031563,1010031563,1001031563]'),(32081565,0,1000,0,4,0,1,0,'[{{0,1002041563,1},1},{{0,1004041563,1},1},{{0,1006041563,1},1},{{0,1008041563,1},1},{{0,1010041563,1},1},{{0,1001041563,1},1}]','[]','[1002041563,1004041563,1006041563,1008041563,1010041563,1001041563]'),(32081566,0,1000,0,1,0,1,0,'[{{0,1007011563,1},1},{{0,1003001563,1},1},{{0,1005001563,1},1},{{0,1009001563,1},1}]','[]','[1007011563,1003001563,1005001563,1009001563]'),(32081566,0,1000,0,2,0,1,0,'[{{0,1007021563,1},1},{{0,1003001563,1},1},{{0,1005001563,1},1},{{0,1009001563,1},1}]','[]','[1007021563,1003001563,1005001563,1009001563]'),(32081566,0,1000,0,3,0,1,0,'[{{0,1007031563,1},1},{{0,1003001563,1},1},{{0,1005001563,1},1},{{0,1009001563,1},1}]','[]','[1007031563,1003001563,1005001563,1009001563]'),(32081566,0,1000,0,4,0,1,0,'[{{0,1007041563,1},1},{{0,1003001563,1},1},{{0,1005001563,1},1},{{0,1009001563,1},1}]','[]','[1007041563,1003001563,1005001563,1009001563]'),(32081567,0,1000,0,1,0,1,0,'[{{0,1007011563,1},1},{{0,1003001563,1},1}]','[]','[1007011563,1003001563]'),(32081567,0,1000,0,2,0,1,0,'[{{0,1007021563,1},1},{{0,1003001563,1},1}]','[]','[1007021563,1003001563]'),(32081567,0,1000,0,3,0,1,0,'[{{0,1007031563,1},1},{{0,1003001563,1},1}]','[]','[1007031563,1003001563]'),(32081567,0,1000,0,4,0,1,0,'[{{0,1007041563,1},1},{{0,1003001563,1},1}]','[]','[1007041563,1003001563]'),(32081568,0,1000,0,0,0,1,0,'[{{0,1005001563,1},1},{{0,1009001563,1},1}]','[]','[1005001563,1009001563]'),(32081571,0,1000,0,1,0,1,0,'[{{0,1001011500,1},1},{{0,1002011500,1},1},{{0,1003001500,1},1},{{0,1004011500,1},1},{{0,1006011500,1},1},{{0,1007011500,1},1},{{0,1008011500,1},1},{{0,1010011500,1},1}]','[]','[]'),(32081571,0,1000,0,2,0,1,0,'[{{0,1001021500,1},1},{{0,1002021500,1},1},{{0,1003001500,1},1},{{0,1004021500,1},1},{{0,1006021500,1},1},{{0,1007021500,1},1},{{0,1008021500,1},1},{{0,1010021500,1},1}]','[]','[]'),(32081571,0,1000,0,3,0,1,0,'[{{0,1001031500,1},1},{{0,1002031500,1},1},{{0,1003001500,1},1},{{0,1004031500,1},1},{{0,1006031500,1},1},{{0,1007031500,1},1},{{0,1008031500,1},1},{{0,1010031500,1},1}]','[]','[]'),(32081571,0,1000,0,4,0,1,0,'[{{0,1001041500,1},1},{{0,1002041500,1},1},{{0,1003001500,1},1},{{0,1004041500,1},1},{{0,1006041500,1},1},{{0,1007041500,1},1},{{0,1008041500,1},1},{{0,1010041500,1},1}]','[]','[]'),(32081572,0,1000,0,1,0,1,0,'[{{0,1002011500,1},1},{{0,1004011500,1},1},{{0,1006011500,1},1},{{0,1008011500,1},1},{{0,1010011500,1},1}]','[]','[]'),(32081572,0,1000,0,2,0,1,0,'[{{0,1002021500,1},1},{{0,1004021500,1},1},{{0,1006021500,1},1},{{0,1008021500,1},1},{{0,1010021500,1},1}]','[]','[]'),(32081572,0,1000,0,3,0,1,0,'[{{0,1002031500,1},1},{{0,1004031500,1},1},{{0,1006031500,1},1},{{0,1008031500,1},1},{{0,1010031500,1},1}]','[]','[]'),(32081572,0,1000,0,4,0,1,0,'[{{0,1002041500,1},1},{{0,1004041500,1},1},{{0,1006041500,1},1},{{0,1008041500,1},1},{{0,1010041500,1},1}]','[]','[]'),(32081573,0,1000,0,1,0,1,0,'[{{0,1001011500,1},1},{{0,1007011500,1},1}]','[]','[]'),(32081573,0,1000,0,2,0,1,0,'[{{0,1001021500,1},1},{{0,1007021500,1},1}]','[]','[]'),(32081573,0,1000,0,3,0,1,0,'[{{0,1001031500,1},1},{{0,1007031500,1},1}]','[]','[]'),(32081573,0,1000,0,4,0,1,0,'[{{0,1001041500,1},1},{{0,1007041500,1},1}]','[]','[]'),(32081575,0,1000,0,1,0,1,0,'[{{0,1002011500,1},1},{{0,1004011500,1},1},{{0,1006011500,1},1},{{0,1008011500,1},1},{{0,1010011500,1},1},{{0,1001011500,1},1}]','[]','[]'),(32081575,0,1000,0,2,0,1,0,'[{{0,1002021500,1},1},{{0,1004021500,1},1},{{0,1006021500,1},1},{{0,1008021500,1},1},{{0,1010021500,1},1},{{0,1001021500,1},1}]','[]','[]'),(32081575,0,1000,0,3,0,1,0,'[{{0,1002031500,1},1},{{0,1004031500,1},1},{{0,1006031500,1},1},{{0,1008031500,1},1},{{0,1010031500,1},1},{{0,1001031500,1},1}]','[]','[]'),(32081575,0,1000,0,4,0,1,0,'[{{0,1002041500,1},1},{{0,1004041500,1},1},{{0,1006041500,1},1},{{0,1008041500,1},1},{{0,1010041500,1},1},{{0,1001041500,1},1}]','[]','[]'),(32081576,0,1000,0,1,0,1,0,'[{{0,1007011500,1},1},{{0,1003001500,1},1},{{0,1005001500,1},1},{{0,1009001500,1},1}]','[]','[]'),(32081576,0,1000,0,2,0,1,0,'[{{0,1007021500,1},1},{{0,1003001500,1},1},{{0,1005001500,1},1},{{0,1009001500,1},1}]','[]','[]'),(32081576,0,1000,0,3,0,1,0,'[{{0,1007031500,1},1},{{0,1003001500,1},1},{{0,1005001500,1},1},{{0,1009001500,1},1}]','[]','[]'),(32081576,0,1000,0,4,0,1,0,'[{{0,1007041500,1},1},{{0,1003001500,1},1},{{0,1005001500,1},1},{{0,1009001500,1},1}]','[]','[]'),(32081577,0,1000,0,1,0,1,0,'[{{0,1007011500,1},1},{{0,1003001500,1},1}]','[]','[]'),(32081577,0,1000,0,2,0,1,0,'[{{0,1007021500,1},1},{{0,1003001500,1},1}]','[]','[]'),(32081577,0,1000,0,3,0,1,0,'[{{0,1007031500,1},1},{{0,1003001500,1},1}]','[]','[]'),(32081577,0,1000,0,4,0,1,0,'[{{0,1007041500,1},1},{{0,1003001500,1},1}]','[]','[]'),(32081578,0,1000,0,0,0,1,0,'[{{0,1005001500,1},1},{{0,1009001500,1},1}]','[]','[]'),(32081581,0,1000,0,1,0,1,0,'[{{0,1001011510,1},1},{{0,1002011510,1},1},{{0,1003001510,1},1},{{0,1004011510,1},1},{{0,1006011510,1},1},{{0,1007011510,1},1},{{0,1008011510,1},1},{{0,1010011510,1},1}]','[]','[]'),(32081581,0,1000,0,2,0,1,0,'[{{0,1001021510,1},1},{{0,1002021510,1},1},{{0,1003001510,1},1},{{0,1004021510,1},1},{{0,1006021510,1},1},{{0,1007021510,1},1},{{0,1008021510,1},1},{{0,1010021510,1},1}]','[]','[]'),(32081581,0,1000,0,3,0,1,0,'[{{0,1001031510,1},1},{{0,1002031510,1},1},{{0,1003001510,1},1},{{0,1004031510,1},1},{{0,1006031510,1},1},{{0,1007031510,1},1},{{0,1008031510,1},1},{{0,1010031510,1},1}]','[]','[]'),(32081581,0,1000,0,4,0,1,0,'[{{0,1001041510,1},1},{{0,1002041510,1},1},{{0,1003001510,1},1},{{0,1004041510,1},1},{{0,1006041510,1},1},{{0,1007041510,1},1},{{0,1008041510,1},1},{{0,1010041510,1},1}]','[]','[]'),(32081582,0,1000,0,1,0,1,0,'[{{0,1002011510,1},1},{{0,1004011510,1},1},{{0,1006011510,1},1},{{0,1008011510,1},1},{{0,1010011510,1},1}]','[]','[]'),(32081582,0,1000,0,2,0,1,0,'[{{0,1002021510,1},1},{{0,1004021510,1},1},{{0,1006021510,1},1},{{0,1008021510,1},1},{{0,1010021510,1},1}]','[]','[]'),(32081582,0,1000,0,3,0,1,0,'[{{0,1002031510,1},1},{{0,1004031510,1},1},{{0,1006031510,1},1},{{0,1008031510,1},1},{{0,1010031510,1},1}]','[]','[]'),(32081582,0,1000,0,4,0,1,0,'[{{0,1002041510,1},1},{{0,1004041510,1},1},{{0,1006041510,1},1},{{0,1008041510,1},1},{{0,1010041510,1},1}]','[]','[]'),(32081583,0,1000,0,1,0,1,0,'[{{0,1001011510,1},1},{{0,1007011510,1},1}]','[]','[]'),(32081583,0,1000,0,2,0,1,0,'[{{0,1001021510,1},1},{{0,1007021510,1},1}]','[]','[]'),(32081583,0,1000,0,3,0,1,0,'[{{0,1001031510,1},1},{{0,1007031510,1},1}]','[]','[]'),(32081583,0,1000,0,4,0,1,0,'[{{0,1001041510,1},1},{{0,1007041510,1},1}]','[]','[]'),(32081585,0,1000,0,1,0,1,0,'[{{0,1002011510,1},1},{{0,1004011510,1},1},{{0,1006011510,1},1},{{0,1008011510,1},1},{{0,1010011510,1},1},{{0,1001011510,1},1}]','[]','[]'),(32081585,0,1000,0,2,0,1,0,'[{{0,1002021510,1},1},{{0,1004021510,1},1},{{0,1006021510,1},1},{{0,1008021510,1},1},{{0,1010021510,1},1},{{0,1001021510,1},1}]','[]','[]'),(32081585,0,1000,0,3,0,1,0,'[{{0,1002031510,1},1},{{0,1004031510,1},1},{{0,1006031510,1},1},{{0,1008031510,1},1},{{0,1010031510,1},1},{{0,1001031510,1},1}]','[]','[]'),(32081585,0,1000,0,4,0,1,0,'[{{0,1002041510,1},1},{{0,1004041510,1},1},{{0,1006041510,1},1},{{0,1008041510,1},1},{{0,1010041510,1},1},{{0,1001041510,1},1}]','[]','[]'),(32081586,0,1000,0,1,0,1,0,'[{{0,1007011510,1},1},{{0,1003001510,1},1},{{0,1005001510,1},1},{{0,1009001510,1},1}]','[]','[]'),(32081586,0,1000,0,2,0,1,0,'[{{0,1007021510,1},1},{{0,1003001510,1},1},{{0,1005001510,1},1},{{0,1009001510,1},1}]','[]','[]'),(32081586,0,1000,0,3,0,1,0,'[{{0,1007031510,1},1},{{0,1003001510,1},1},{{0,1005001510,1},1},{{0,1009001510,1},1}]','[]','[]'),(32081586,0,1000,0,4,0,1,0,'[{{0,1007041510,1},1},{{0,1003001510,1},1},{{0,1005001510,1},1},{{0,1009001510,1},1}]','[]','[]'),(32081587,0,1000,0,1,0,1,0,'[{{0,1007011510,1},1},{{0,1003001510,1},1}]','[]','[]'),(32081587,0,1000,0,2,0,1,0,'[{{0,1007021510,1},1},{{0,1003001510,1},1}]','[]','[]'),(32081587,0,1000,0,3,0,1,0,'[{{0,1007031510,1},1},{{0,1003001510,1},1}]','[]','[]'),(32081587,0,1000,0,4,0,1,0,'[{{0,1007041510,1},1},{{0,1003001510,1},1}]','[]','[]'),(32081588,0,1000,0,0,0,1,0,'[{{0,1005001510,1},1},{{0,1009001510,1},1}]','[]','[]'),(32081591,0,1000,0,1,0,1,0,'[{{0,1001011520,1},1},{{0,1002011520,1},1},{{0,1003001520,1},1},{{0,1004011520,1},1},{{0,1006011520,1},1},{{0,1007011520,1},1},{{0,1008011520,1},1},{{0,1010011520,1},1}]','[]','[]'),(32081591,0,1000,0,2,0,1,0,'[{{0,1001021520,1},1},{{0,1002021520,1},1},{{0,1003001520,1},1},{{0,1004021520,1},1},{{0,1006021520,1},1},{{0,1007021520,1},1},{{0,1008021520,1},1},{{0,1010021520,1},1}]','[]','[]'),(32081591,0,1000,0,3,0,1,0,'[{{0,1001031520,1},1},{{0,1002031520,1},1},{{0,1003001520,1},1},{{0,1004031520,1},1},{{0,1006031520,1},1},{{0,1007031520,1},1},{{0,1008031520,1},1},{{0,1010031520,1},1}]','[]','[]'),(32081591,0,1000,0,4,0,1,0,'[{{0,1001041520,1},1},{{0,1002041520,1},1},{{0,1003001520,1},1},{{0,1004041520,1},1},{{0,1006041520,1},1},{{0,1007041520,1},1},{{0,1008041520,1},1},{{0,1010041520,1},1}]','[]','[]'),(32081592,0,1000,0,1,0,1,0,'[{{0,1002011520,1},1},{{0,1004011520,1},1},{{0,1006011520,1},1},{{0,1008011520,1},1},{{0,1010011520,1},1}]','[]','[]'),(32081592,0,1000,0,2,0,1,0,'[{{0,1002021520,1},1},{{0,1004021520,1},1},{{0,1006021520,1},1},{{0,1008021520,1},1},{{0,1010021520,1},1}]','[]','[]'),(32081592,0,1000,0,3,0,1,0,'[{{0,1002031520,1},1},{{0,1004031520,1},1},{{0,1006031520,1},1},{{0,1008031520,1},1},{{0,1010031520,1},1}]','[]','[]'),(32081592,0,1000,0,4,0,1,0,'[{{0,1002041520,1},1},{{0,1004041520,1},1},{{0,1006041520,1},1},{{0,1008041520,1},1},{{0,1010041520,1},1}]','[]','[]'),(32081593,0,1000,0,1,0,1,0,'[{{0,1001011520,1},1},{{0,1007011520,1},1}]','[]','[]'),(32081593,0,1000,0,2,0,1,0,'[{{0,1001021520,1},1},{{0,1007021520,1},1}]','[]','[]'),(32081593,0,1000,0,3,0,1,0,'[{{0,1001031520,1},1},{{0,1007031520,1},1}]','[]','[]'),(32081593,0,1000,0,4,0,1,0,'[{{0,1001041520,1},1},{{0,1007041520,1},1}]','[]','[]'),(32081595,0,1000,0,1,0,1,0,'[{{0,1002011520,1},1},{{0,1004011520,1},1},{{0,1006011520,1},1},{{0,1008011520,1},1},{{0,1010011520,1},1},{{0,1001011520,1},1}]','[]','[]'),(32081595,0,1000,0,2,0,1,0,'[{{0,1002021520,1},1},{{0,1004021520,1},1},{{0,1006021520,1},1},{{0,1008021520,1},1},{{0,1010021520,1},1},{{0,1001021520,1},1}]','[]','[]'),(32081595,0,1000,0,3,0,1,0,'[{{0,1002031520,1},1},{{0,1004031520,1},1},{{0,1006031520,1},1},{{0,1008031520,1},1},{{0,1010031520,1},1},{{0,1001031520,1},1}]','[]','[]'),(32081595,0,1000,0,4,0,1,0,'[{{0,1002041520,1},1},{{0,1004041520,1},1},{{0,1006041520,1},1},{{0,1008041520,1},1},{{0,1010041520,1},1},{{0,1001041520,1},1}]','[]','[]'),(32081596,0,1000,0,1,0,1,0,'[{{0,1007011520,1},1},{{0,1003001520,1},1},{{0,1005001520,1},1},{{0,1009001520,1},1}]','[]','[]'),(32081596,0,1000,0,2,0,1,0,'[{{0,1007021520,1},1},{{0,1003001520,1},1},{{0,1005001520,1},1},{{0,1009001520,1},1}]','[]','[]'),(32081596,0,1000,0,3,0,1,0,'[{{0,1007031520,1},1},{{0,1003001520,1},1},{{0,1005001520,1},1},{{0,1009001520,1},1}]','[]','[]'),(32081596,0,1000,0,4,0,1,0,'[{{0,1007041520,1},1},{{0,1003001520,1},1},{{0,1005001520,1},1},{{0,1009001520,1},1}]','[]','[]'),(32081597,0,1000,0,1,0,1,0,'[{{0,1007011520,1},1},{{0,1003001520,1},1}]','[]','[]'),(32081597,0,1000,0,2,0,1,0,'[{{0,1007021520,1},1},{{0,1003001520,1},1}]','[]','[]'),(32081597,0,1000,0,3,0,1,0,'[{{0,1007031520,1},1},{{0,1003001520,1},1}]','[]','[]'),(32081597,0,1000,0,4,0,1,0,'[{{0,1007041520,1},1},{{0,1003001520,1},1}]','[]','[]'),(32081598,0,1000,0,0,0,1,0,'[{{0,1005001520,1},1},{{0,1009001520,1},1}]','[]','[]'),(32081601,0,1000,0,1,0,1,0,'[{{0,1001011531,1},1},{{0,1002011531,1},1},{{0,1003001531,1},1},{{0,1004011531,1},1},{{0,1006011531,1},1},{{0,1007011531,1},1},{{0,1008011531,1},1},{{0,1010011531,1},1}]','[]','[]'),(32081601,0,1000,0,2,0,1,0,'[{{0,1001021531,1},1},{{0,1002021531,1},1},{{0,1003001531,1},1},{{0,1004021531,1},1},{{0,1006021531,1},1},{{0,1007021531,1},1},{{0,1008021531,1},1},{{0,1010021531,1},1}]','[]','[]'),(32081601,0,1000,0,3,0,1,0,'[{{0,1001031531,1},1},{{0,1002031531,1},1},{{0,1003001531,1},1},{{0,1004031531,1},1},{{0,1006031531,1},1},{{0,1007031531,1},1},{{0,1008031531,1},1},{{0,1010031531,1},1}]','[]','[]'),(32081601,0,1000,0,4,0,1,0,'[{{0,1001041531,1},1},{{0,1002041531,1},1},{{0,1003001531,1},1},{{0,1004041531,1},1},{{0,1006041531,1},1},{{0,1007041531,1},1},{{0,1008041531,1},1},{{0,1010041531,1},1}]','[]','[]'),(32081602,0,1000,0,1,0,1,0,'[{{0,1002011531,1},1},{{0,1004011531,1},1},{{0,1006011531,1},1},{{0,1008011531,1},1},{{0,1010011531,1},1}]','[]','[]'),(32081602,0,1000,0,2,0,1,0,'[{{0,1002021531,1},1},{{0,1004021531,1},1},{{0,1006021531,1},1},{{0,1008021531,1},1},{{0,1010021531,1},1}]','[]','[]'),(32081602,0,1000,0,3,0,1,0,'[{{0,1002031531,1},1},{{0,1004031531,1},1},{{0,1006031531,1},1},{{0,1008031531,1},1},{{0,1010031531,1},1}]','[]','[]'),(32081602,0,1000,0,4,0,1,0,'[{{0,1002041531,1},1},{{0,1004041531,1},1},{{0,1006041531,1},1},{{0,1008041531,1},1},{{0,1010041531,1},1}]','[]','[]'),(32081603,0,1000,0,1,0,1,0,'[{{0,1001011531,1},1},{{0,1007011531,1},1}]','[]','[]'),(32081603,0,1000,0,2,0,1,0,'[{{0,1001021531,1},1},{{0,1007021531,1},1}]','[]','[]'),(32081603,0,1000,0,3,0,1,0,'[{{0,1001031531,1},1},{{0,1007031531,1},1}]','[]','[]'),(32081603,0,1000,0,4,0,1,0,'[{{0,1001041531,1},1},{{0,1007041531,1},1}]','[]','[]'),(32081605,0,1000,0,1,0,1,0,'[{{0,1002011531,1},1},{{0,1004011531,1},1},{{0,1006011531,1},1},{{0,1008011531,1},1},{{0,1010011531,1},1},{{0,1001011531,1},1}]','[]','[]'),(32081605,0,1000,0,2,0,1,0,'[{{0,1002021531,1},1},{{0,1004021531,1},1},{{0,1006021531,1},1},{{0,1008021531,1},1},{{0,1010021531,1},1},{{0,1001021531,1},1}]','[]','[]'),(32081605,0,1000,0,3,0,1,0,'[{{0,1002031531,1},1},{{0,1004031531,1},1},{{0,1006031531,1},1},{{0,1008031531,1},1},{{0,1010031531,1},1},{{0,1001031531,1},1}]','[]','[]'),(32081605,0,1000,0,4,0,1,0,'[{{0,1002041531,1},1},{{0,1004041531,1},1},{{0,1006041531,1},1},{{0,1008041531,1},1},{{0,1010041531,1},1},{{0,1001041531,1},1}]','[]','[]'),(32081606,0,1000,0,1,0,1,0,'[{{0,1007011531,1},1},{{0,1003001531,1},1},{{0,1005001531,1},1},{{0,1009001531,1},1}]','[]','[]'),(32081606,0,1000,0,2,0,1,0,'[{{0,1007021531,1},1},{{0,1003001531,1},1},{{0,1005001531,1},1},{{0,1009001531,1},1}]','[]','[]'),(32081606,0,1000,0,3,0,1,0,'[{{0,1007031531,1},1},{{0,1003001531,1},1},{{0,1005001531,1},1},{{0,1009001531,1},1}]','[]','[]'),(32081606,0,1000,0,4,0,1,0,'[{{0,1007041531,1},1},{{0,1003001531,1},1},{{0,1005001531,1},1},{{0,1009001531,1},1}]','[]','[]'),(32081607,0,1000,0,1,0,1,0,'[{{0,1007011531,1},1},{{0,1003001531,1},1}]','[]','[]'),(32081607,0,1000,0,2,0,1,0,'[{{0,1007021531,1},1},{{0,1003001531,1},1}]','[]','[]'),(32081607,0,1000,0,3,0,1,0,'[{{0,1007031531,1},1},{{0,1003001531,1},1}]','[]','[]'),(32081607,0,1000,0,4,0,1,0,'[{{0,1007041531,1},1},{{0,1003001531,1},1}]','[]','[]'),(32081608,0,1000,0,0,0,1,0,'[{{0,1005001531,1},1},{{0,1009001531,1},1}]','[]','[]'),(32081611,0,1000,0,1,0,1,0,'[{{0,1001011632,1},1},{{0,1002011632,1},1},{{0,1003001632,1},1},{{0,1004011632,1},1},{{0,1006011632,1},1},{{0,1007011632,1},1},{{0,1008011632,1},1},{{0,1010011632,1},1}]','[]','[1001011632,1002011632,1003001632,1004011632,1005001632,1006011632,1007011632,1008011632,1009001632,1010011632]'),(32081611,0,1000,0,2,0,1,0,'[{{0,1001021632,1},1},{{0,1002021632,1},1},{{0,1003001632,1},1},{{0,1004021632,1},1},{{0,1006021632,1},1},{{0,1007021632,1},1},{{0,1008021632,1},1},{{0,1010021632,1},1}]','[]','[1001021632,1002021632,1003001632,1004021632,1005001632,1006021632,1007021632,1008021632,1009001632,1010021632]'),(32081611,0,1000,0,3,0,1,0,'[{{0,1001031632,1},1},{{0,1002031632,1},1},{{0,1003001632,1},1},{{0,1004031632,1},1},{{0,1006031632,1},1},{{0,1007031632,1},1},{{0,1008031632,1},1},{{0,1010031632,1},1}]','[]','[1001031632,1002031632,1003001632,1004031632,1005001632,1006031632,1007031632,1008031632,1009001632,1010031632]'),(32081611,0,1000,0,4,0,1,0,'[{{0,1001041632,1},1},{{0,1002041632,1},1},{{0,1003001632,1},1},{{0,1004041632,1},1},{{0,1006041632,1},1},{{0,1007041632,1},1},{{0,1008041632,1},1},{{0,1010041632,1},1}]','[]','[1001041632,1002041632,1003001632,1004041632,1005001632,1006041632,1007041632,1008041632,1009001632,1010041632]'),(32081612,0,1000,0,1,0,1,0,'[{{0,1002011632,1},1},{{0,1004011632,1},1},{{0,1006011632,1},1},{{0,1008011632,1},1},{{0,1010011632,1},1}]','[]','[1002011632,1004011632,1006011632,1008011632,1010011632]'),(32081612,0,1000,0,2,0,1,0,'[{{0,1002021632,1},1},{{0,1004021632,1},1},{{0,1006021632,1},1},{{0,1008021632,1},1},{{0,1010021632,1},1}]','[]','[1002021632,1004021632,1006021632,1008021632,1010021632]'),(32081612,0,1000,0,3,0,1,0,'[{{0,1002031632,1},1},{{0,1004031632,1},1},{{0,1006031632,1},1},{{0,1008031632,1},1},{{0,1010031632,1},1}]','[]','[1002031632,1004031632,1006031632,1008031632,1010031632]'),(32081612,0,1000,0,4,0,1,0,'[{{0,1002041632,1},1},{{0,1004041632,1},1},{{0,1006041632,1},1},{{0,1008041632,1},1},{{0,1010041632,1},1}]','[]','[1002041632,1004041632,1006041632,1008041632,1010041632]'),(32081613,0,1000,0,1,0,1,0,'[{{0,1001011632,1},1},{{0,1007011632,1},1}]','[]','[1001011632,1007011632]'),(32081613,0,1000,0,2,0,1,0,'[{{0,1001021632,1},1},{{0,1007021632,1},1}]','[]','[1001021632,1007021632]'),(32081613,0,1000,0,3,0,1,0,'[{{0,1001031632,1},1},{{0,1007031632,1},1}]','[]','[1001031632,1007031632]'),(32081613,0,1000,0,4,0,1,0,'[{{0,1001041632,1},1},{{0,1007041632,1},1}]','[]','[1001041632,1007041632]'),(32081615,0,1000,0,1,0,1,0,'[{{0,1002011632,1},1},{{0,1004011632,1},1},{{0,1006011632,1},1},{{0,1008011632,1},1},{{0,1010011632,1},1},{{0,1001011632,1},1}]','[]','[1002011632,1004011632,1006011632,1008011632,1010011632,1001011632]'),(32081615,0,1000,0,2,0,1,0,'[{{0,1002021632,1},1},{{0,1004021632,1},1},{{0,1006021632,1},1},{{0,1008021632,1},1},{{0,1010021632,1},1},{{0,1001021632,1},1}]','[]','[1002021632,1004021632,1006021632,1008021632,1010021632,1001021632]'),(32081615,0,1000,0,3,0,1,0,'[{{0,1002031632,1},1},{{0,1004031632,1},1},{{0,1006031632,1},1},{{0,1008031632,1},1},{{0,1010031632,1},1},{{0,1001031632,1},1}]','[]','[1002031632,1004031632,1006031632,1008031632,1010031632,1001031632]'),(32081615,0,1000,0,4,0,1,0,'[{{0,1002041632,1},1},{{0,1004041632,1},1},{{0,1006041632,1},1},{{0,1008041632,1},1},{{0,1010041632,1},1},{{0,1001041632,1},1}]','[]','[1002041632,1004041632,1006041632,1008041632,1010041632,1001041632]'),(32081616,0,1000,0,1,0,1,0,'[{{0,1007011632,1},1},{{0,1003001632,1},1},{{0,1005001632,1},1},{{0,1009001632,1},1}]','[]','[1007011632,1003001632,1005001632,1009001632]'),(32081616,0,1000,0,2,0,1,0,'[{{0,1007021632,1},1},{{0,1003001632,1},1},{{0,1005001632,1},1},{{0,1009001632,1},1}]','[]','[1007021632,1003001632,1005001632,1009001632]'),(32081616,0,1000,0,3,0,1,0,'[{{0,1007031632,1},1},{{0,1003001632,1},1},{{0,1005001632,1},1},{{0,1009001632,1},1}]','[]','[1007031632,1003001632,1005001632,1009001632]'),(32081616,0,1000,0,4,0,1,0,'[{{0,1007041632,1},1},{{0,1003001632,1},1},{{0,1005001632,1},1},{{0,1009001632,1},1}]','[]','[1007041632,1003001632,1005001632,1009001632]'),(32081617,0,1000,0,1,0,1,0,'[{{0,1007011632,1},1},{{0,1003001632,1},1}]','[]','[1007011632,1003001632]'),(32081617,0,1000,0,2,0,1,0,'[{{0,1007021632,1},1},{{0,1003001632,1},1}]','[]','[1007021632,1003001632]'),(32081617,0,1000,0,3,0,1,0,'[{{0,1007031632,1},1},{{0,1003001632,1},1}]','[]','[1007031632,1003001632]'),(32081617,0,1000,0,4,0,1,0,'[{{0,1007041632,1},1},{{0,1003001632,1},1}]','[]','[1007041632,1003001632]'),(32081618,0,1000,0,0,0,1,0,'[{{0,1005001632,1},1},{{0,1009001632,1},1}]','[]','[1005001632,1009001632]'),(32081621,0,1000,0,1,0,1,0,'[{{0,1001011641,1},1},{{0,1002011641,1},1},{{0,1003001641,1},1},{{0,1004011641,1},1},{{0,1006011641,1},1},{{0,1007011641,1},1},{{0,1008011641,1},1},{{0,1010011641,1},1}]','[]','[]'),(32081621,0,1000,0,2,0,1,0,'[{{0,1001021641,1},1},{{0,1002021641,1},1},{{0,1003001641,1},1},{{0,1004021641,1},1},{{0,1006021641,1},1},{{0,1007021641,1},1},{{0,1008021641,1},1},{{0,1010021641,1},1}]','[]','[]'),(32081621,0,1000,0,3,0,1,0,'[{{0,1001031641,1},1},{{0,1002031641,1},1},{{0,1003001641,1},1},{{0,1004031641,1},1},{{0,1006031641,1},1},{{0,1007031641,1},1},{{0,1008031641,1},1},{{0,1010031641,1},1}]','[]','[]'),(32081621,0,1000,0,4,0,1,0,'[{{0,1001041641,1},1},{{0,1002041641,1},1},{{0,1003001641,1},1},{{0,1004041641,1},1},{{0,1006041641,1},1},{{0,1007041641,1},1},{{0,1008041641,1},1},{{0,1010041641,1},1}]','[]','[]'),(32081622,0,1000,0,1,0,1,0,'[{{0,1002011641,1},1},{{0,1004011641,1},1},{{0,1006011641,1},1},{{0,1008011641,1},1},{{0,1010011641,1},1}]','[]','[]'),(32081622,0,1000,0,2,0,1,0,'[{{0,1002021641,1},1},{{0,1004021641,1},1},{{0,1006021641,1},1},{{0,1008021641,1},1},{{0,1010021641,1},1}]','[]','[]'),(32081622,0,1000,0,3,0,1,0,'[{{0,1002031641,1},1},{{0,1004031641,1},1},{{0,1006031641,1},1},{{0,1008031641,1},1},{{0,1010031641,1},1}]','[]','[]'),(32081622,0,1000,0,4,0,1,0,'[{{0,1002041641,1},1},{{0,1004041641,1},1},{{0,1006041641,1},1},{{0,1008041641,1},1},{{0,1010041641,1},1}]','[]','[]'),(32081623,0,1000,0,1,0,1,0,'[{{0,1001011641,1},1},{{0,1007011641,1},1}]','[]','[]'),(32081623,0,1000,0,2,0,1,0,'[{{0,1001021641,1},1},{{0,1007021641,1},1}]','[]','[]'),(32081623,0,1000,0,3,0,1,0,'[{{0,1001031641,1},1},{{0,1007031641,1},1}]','[]','[]'),(32081623,0,1000,0,4,0,1,0,'[{{0,1001041641,1},1},{{0,1007041641,1},1}]','[]','[]'),(32081625,0,1000,0,1,0,1,0,'[{{0,1002011641,1},1},{{0,1004011641,1},1},{{0,1006011641,1},1},{{0,1008011641,1},1},{{0,1010011641,1},1},{{0,1001011641,1},1}]','[]','[]'),(32081625,0,1000,0,2,0,1,0,'[{{0,1002021641,1},1},{{0,1004021641,1},1},{{0,1006021641,1},1},{{0,1008021641,1},1},{{0,1010021641,1},1},{{0,1001021641,1},1}]','[]','[]'),(32081625,0,1000,0,3,0,1,0,'[{{0,1002031641,1},1},{{0,1004031641,1},1},{{0,1006031641,1},1},{{0,1008031641,1},1},{{0,1010031641,1},1},{{0,1001031641,1},1}]','[]','[]'),(32081625,0,1000,0,4,0,1,0,'[{{0,1002041641,1},1},{{0,1004041641,1},1},{{0,1006041641,1},1},{{0,1008041641,1},1},{{0,1010041641,1},1},{{0,1001041641,1},1}]','[]','[]'),(32081626,0,1000,0,1,0,1,0,'[{{0,1007011641,1},1},{{0,1003001641,1},1},{{0,1005001641,1},1},{{0,1009001641,1},1}]','[]','[]'),(32081626,0,1000,0,2,0,1,0,'[{{0,1007021641,1},1},{{0,1003001641,1},1},{{0,1005001641,1},1},{{0,1009001641,1},1}]','[]','[]'),(32081626,0,1000,0,3,0,1,0,'[{{0,1007031641,1},1},{{0,1003001641,1},1},{{0,1005001641,1},1},{{0,1009001641,1},1}]','[]','[]'),(32081626,0,1000,0,4,0,1,0,'[{{0,1007041641,1},1},{{0,1003001641,1},1},{{0,1005001641,1},1},{{0,1009001641,1},1}]','[]','[]'),(32081627,0,1000,0,1,0,1,0,'[{{0,1007011641,1},1},{{0,1003001641,1},1}]','[]','[]'),(32081627,0,1000,0,2,0,1,0,'[{{0,1007021641,1},1},{{0,1003001641,1},1}]','[]','[]'),(32081627,0,1000,0,3,0,1,0,'[{{0,1007031641,1},1},{{0,1003001641,1},1}]','[]','[]'),(32081627,0,1000,0,4,0,1,0,'[{{0,1007041641,1},1},{{0,1003001641,1},1}]','[]','[]'),(32081628,0,1000,0,0,0,1,0,'[{{0,1005001641,1},1},{{0,1009001641,1},1}]','[]','[]'),(32081631,0,1000,0,1,0,1,0,'[{{0,1001011642,1},1},{{0,1002011642,1},1},{{0,1003001642,1},1},{{0,1004011642,1},1},{{0,1006011642,1},1},{{0,1007011642,1},1},{{0,1008011642,1},1},{{0,1010011642,1},1}]','[]','[1001011642,1002011642,1003001642,1004011642,1005001642,1006011642,1007011642,1008011642,1009001642,1010011642]'),(32081631,0,1000,0,2,0,1,0,'[{{0,1001021642,1},1},{{0,1002021642,1},1},{{0,1003001642,1},1},{{0,1004021642,1},1},{{0,1006021642,1},1},{{0,1007021642,1},1},{{0,1008021642,1},1},{{0,1010021642,1},1}]','[]','[1001021642,1002021642,1003001642,1004021642,1005001642,1006021642,1007021642,1008021642,1009001642,1010021642]'),(32081631,0,1000,0,3,0,1,0,'[{{0,1001031642,1},1},{{0,1002031642,1},1},{{0,1003001642,1},1},{{0,1004031642,1},1},{{0,1006031642,1},1},{{0,1007031642,1},1},{{0,1008031642,1},1},{{0,1010031642,1},1}]','[]','[1001031642,1002031642,1003001642,1004031642,1005001642,1006031642,1007031642,1008031642,1009001642,1010031642]'),(32081631,0,1000,0,4,0,1,0,'[{{0,1001041642,1},1},{{0,1002041642,1},1},{{0,1003001642,1},1},{{0,1004041642,1},1},{{0,1006041642,1},1},{{0,1007041642,1},1},{{0,1008041642,1},1},{{0,1010041642,1},1}]','[]','[1001041642,1002041642,1003001642,1004041642,1005001642,1006041642,1007041642,1008041642,1009001642,1010041642]'),(32081632,0,1000,0,1,0,1,0,'[{{0,1002011642,1},1},{{0,1004011642,1},1},{{0,1006011642,1},1},{{0,1008011642,1},1},{{0,1010011642,1},1}]','[]','[1002011642,1004011642,1006011642,1008011642,1010011642]'),(32081632,0,1000,0,2,0,1,0,'[{{0,1002021642,1},1},{{0,1004021642,1},1},{{0,1006021642,1},1},{{0,1008021642,1},1},{{0,1010021642,1},1}]','[]','[1002021642,1004021642,1006021642,1008021642,1010021642]'),(32081632,0,1000,0,3,0,1,0,'[{{0,1002031642,1},1},{{0,1004031642,1},1},{{0,1006031642,1},1},{{0,1008031642,1},1},{{0,1010031642,1},1}]','[]','[1002031642,1004031642,1006031642,1008031642,1010031642]'),(32081632,0,1000,0,4,0,1,0,'[{{0,1002041642,1},1},{{0,1004041642,1},1},{{0,1006041642,1},1},{{0,1008041642,1},1},{{0,1010041642,1},1}]','[]','[1002041642,1004041642,1006041642,1008041642,1010041642]'),(32081633,0,1000,0,1,0,1,0,'[{{0,1001011642,1},1},{{0,1007011642,1},1}]','[]','[1001011642,1007011642]'),(32081633,0,1000,0,2,0,1,0,'[{{0,1001021642,1},1},{{0,1007021642,1},1}]','[]','[1001021642,1007021642]'),(32081633,0,1000,0,3,0,1,0,'[{{0,1001031642,1},1},{{0,1007031642,1},1}]','[]','[1001031642,1007031642]'),(32081633,0,1000,0,4,0,1,0,'[{{0,1001041642,1},1},{{0,1007041642,1},1}]','[]','[1001041642,1007041642]'),(32081635,0,1000,0,1,0,1,0,'[{{0,1002011642,1},1},{{0,1004011642,1},1},{{0,1006011642,1},1},{{0,1008011642,1},1},{{0,1010011642,1},1},{{0,1001011642,1},1}]','[]','[1002011642,1004011642,1006011642,1008011642,1010011642,1001011642]'),(32081635,0,1000,0,2,0,1,0,'[{{0,1002021642,1},1},{{0,1004021642,1},1},{{0,1006021642,1},1},{{0,1008021642,1},1},{{0,1010021642,1},1},{{0,1001021642,1},1}]','[]','[1002021642,1004021642,1006021642,1008021642,1010021642,1001021642]'),(32081635,0,1000,0,3,0,1,0,'[{{0,1002031642,1},1},{{0,1004031642,1},1},{{0,1006031642,1},1},{{0,1008031642,1},1},{{0,1010031642,1},1},{{0,1001031642,1},1}]','[]','[1002031642,1004031642,1006031642,1008031642,1010031642,1001031642]'),(32081635,0,1000,0,4,0,1,0,'[{{0,1002041642,1},1},{{0,1004041642,1},1},{{0,1006041642,1},1},{{0,1008041642,1},1},{{0,1010041642,1},1},{{0,1001041642,1},1}]','[]','[1002041642,1004041642,1006041642,1008041642,1010041642,1001041642]'),(32081636,0,1000,0,1,0,1,0,'[{{0,1007011642,1},1},{{0,1003001642,1},1},{{0,1005001642,1},1},{{0,1009001642,1},1}]','[]','[1007011642,1003001642,1005001642,1009001642]'),(32081636,0,1000,0,2,0,1,0,'[{{0,1007021642,1},1},{{0,1003001642,1},1},{{0,1005001642,1},1},{{0,1009001642,1},1}]','[]','[1007021642,1003001642,1005001642,1009001642]'),(32081636,0,1000,0,3,0,1,0,'[{{0,1007031642,1},1},{{0,1003001642,1},1},{{0,1005001642,1},1},{{0,1009001642,1},1}]','[]','[1007031642,1003001642,1005001642,1009001642]'),(32081636,0,1000,0,4,0,1,0,'[{{0,1007041642,1},1},{{0,1003001642,1},1},{{0,1005001642,1},1},{{0,1009001642,1},1}]','[]','[1007041642,1003001642,1005001642,1009001642]'),(32081637,0,1000,0,1,0,1,0,'[{{0,1007011642,1},1},{{0,1003001642,1},1}]','[]','[1007011642,1003001642]'),(32081637,0,1000,0,2,0,1,0,'[{{0,1007021642,1},1},{{0,1003001642,1},1}]','[]','[1007021642,1003001642]'),(32081637,0,1000,0,3,0,1,0,'[{{0,1007031642,1},1},{{0,1003001642,1},1}]','[]','[1007031642,1003001642]'),(32081637,0,1000,0,4,0,1,0,'[{{0,1007041642,1},1},{{0,1003001642,1},1}]','[]','[1007041642,1003001642]'),(32081638,0,1000,0,0,0,1,0,'[{{0,1005001642,1},1},{{0,1009001642,1},1}]','[]','[1005001642,1009001642]'),(32081641,0,1000,0,1,0,1,0,'[{{0,1001011643,1},1},{{0,1002011643,1},1},{{0,1003001643,1},1},{{0,1004011643,1},1},{{0,1006011643,1},1},{{0,1007011643,1},1},{{0,1008011643,1},1},{{0,1010011643,1},1}]','[]','[1001011643,1002011643,1003001643,1004011643,1005001643,1006011643,1007011643,1008011643,1009001643,1010011643]'),(32081641,0,1000,0,2,0,1,0,'[{{0,1001021643,1},1},{{0,1002021643,1},1},{{0,1003001643,1},1},{{0,1004021643,1},1},{{0,1006021643,1},1},{{0,1007021643,1},1},{{0,1008021643,1},1},{{0,1010021643,1},1}]','[]','[1001021643,1002021643,1003001643,1004021643,1005001643,1006021643,1007021643,1008021643,1009001643,1010021643]'),(32081641,0,1000,0,3,0,1,0,'[{{0,1001031643,1},1},{{0,1002031643,1},1},{{0,1003001643,1},1},{{0,1004031643,1},1},{{0,1006031643,1},1},{{0,1007031643,1},1},{{0,1008031643,1},1},{{0,1010031643,1},1}]','[]','[1001031643,1002031643,1003001643,1004031643,1005001643,1006031643,1007031643,1008031643,1009001643,1010031643]'),(32081641,0,1000,0,4,0,1,0,'[{{0,1001041643,1},1},{{0,1002041643,1},1},{{0,1003001643,1},1},{{0,1004041643,1},1},{{0,1006041643,1},1},{{0,1007041643,1},1},{{0,1008041643,1},1},{{0,1010041643,1},1}]','[]','[1001041643,1002041643,1003001643,1004041643,1005001643,1006041643,1007041643,1008041643,1009001643,1010041643]'),(32081642,0,1000,0,1,0,1,0,'[{{0,1002011643,1},1},{{0,1004011643,1},1},{{0,1006011643,1},1},{{0,1008011643,1},1},{{0,1010011643,1},1}]','[]','[1002011643,1004011643,1006011643,1008011643,1010011643]'),(32081642,0,1000,0,2,0,1,0,'[{{0,1002021643,1},1},{{0,1004021643,1},1},{{0,1006021643,1},1},{{0,1008021643,1},1},{{0,1010021643,1},1}]','[]','[1002021643,1004021643,1006021643,1008021643,1010021643]'),(32081642,0,1000,0,3,0,1,0,'[{{0,1002031643,1},1},{{0,1004031643,1},1},{{0,1006031643,1},1},{{0,1008031643,1},1},{{0,1010031643,1},1}]','[]','[1002031643,1004031643,1006031643,1008031643,1010031643]'),(32081642,0,1000,0,4,0,1,0,'[{{0,1002041643,1},1},{{0,1004041643,1},1},{{0,1006041643,1},1},{{0,1008041643,1},1},{{0,1010041643,1},1}]','[]','[1002041643,1004041643,1006041643,1008041643,1010041643]'),(32081643,0,1000,0,1,0,1,0,'[{{0,1001011643,1},1},{{0,1007011643,1},1}]','[]','[1001011643,1007011643]'),(32081643,0,1000,0,2,0,1,0,'[{{0,1001021643,1},1},{{0,1007021643,1},1}]','[]','[1001021643,1007021643]'),(32081643,0,1000,0,3,0,1,0,'[{{0,1001031643,1},1},{{0,1007031643,1},1}]','[]','[1001031643,1007031643]'),(32081643,0,1000,0,4,0,1,0,'[{{0,1001041643,1},1},{{0,1007041643,1},1}]','[]','[1001041643,1007041643]'),(32081645,0,1000,0,1,0,1,0,'[{{0,1002011643,1},1},{{0,1004011643,1},1},{{0,1006011643,1},1},{{0,1008011643,1},1},{{0,1010011643,1},1},{{0,1001011643,1},1}]','[]','[1002011643,1004011643,1006011643,1008011643,1010011643,1001011643]'),(32081645,0,1000,0,2,0,1,0,'[{{0,1002021643,1},1},{{0,1004021643,1},1},{{0,1006021643,1},1},{{0,1008021643,1},1},{{0,1010021643,1},1},{{0,1001021643,1},1}]','[]','[1002021643,1004021643,1006021643,1008021643,1010021643,1001021643]'),(32081645,0,1000,0,3,0,1,0,'[{{0,1002031643,1},1},{{0,1004031643,1},1},{{0,1006031643,1},1},{{0,1008031643,1},1},{{0,1010031643,1},1},{{0,1001031643,1},1}]','[]','[1002031643,1004031643,1006031643,1008031643,1010031643,1001031643]'),(32081645,0,1000,0,4,0,1,0,'[{{0,1002041643,1},1},{{0,1004041643,1},1},{{0,1006041643,1},1},{{0,1008041643,1},1},{{0,1010041643,1},1},{{0,1001041643,1},1}]','[]','[1002041643,1004041643,1006041643,1008041643,1010041643,1001041643]'),(32081646,0,1000,0,1,0,1,0,'[{{0,1007011643,1},1},{{0,1003001643,1},1},{{0,1005001643,1},1},{{0,1009001643,1},1}]','[]','[1007011643,1003001643,1005001643,1009001643]'),(32081646,0,1000,0,2,0,1,0,'[{{0,1007021643,1},1},{{0,1003001643,1},1},{{0,1005001643,1},1},{{0,1009001643,1},1}]','[]','[1007021643,1003001643,1005001643,1009001643]'),(32081646,0,1000,0,3,0,1,0,'[{{0,1007031643,1},1},{{0,1003001643,1},1},{{0,1005001643,1},1},{{0,1009001643,1},1}]','[]','[1007031643,1003001643,1005001643,1009001643]'),(32081646,0,1000,0,4,0,1,0,'[{{0,1007041643,1},1},{{0,1003001643,1},1},{{0,1005001643,1},1},{{0,1009001643,1},1}]','[]','[1007041643,1003001643,1005001643,1009001643]'),(32081647,0,1000,0,1,0,1,0,'[{{0,1007011643,1},1},{{0,1003001643,1},1}]','[]','[1007011643,1003001643]'),(32081647,0,1000,0,2,0,1,0,'[{{0,1007021643,1},1},{{0,1003001643,1},1}]','[]','[1007021643,1003001643]'),(32081647,0,1000,0,3,0,1,0,'[{{0,1007031643,1},1},{{0,1003001643,1},1}]','[]','[1007031643,1003001643]'),(32081647,0,1000,0,4,0,1,0,'[{{0,1007041643,1},1},{{0,1003001643,1},1}]','[]','[1007041643,1003001643]'),(32081648,0,1000,0,0,0,1,0,'[{{0,1005001643,1},1},{{0,1009001643,1},1}]','[]','[1005001643,1009001643]'),(32081651,0,1000,0,1,0,1,0,'[{{0,1001011653,1},1},{{0,1002011653,1},1},{{0,1003001653,1},1},{{0,1004011653,1},1},{{0,1006011653,1},1},{{0,1007011653,1},1}]','[]','[1001011653,1002011653,1003001653,1004011653,1005001653,1006011653,1007011653,1008011653,1009001653,1010011653]'),(32081651,0,1000,0,2,0,1,0,'[{{0,1001021653,1},1},{{0,1002021653,1},1},{{0,1003001653,1},1},{{0,1004021653,1},1},{{0,1006021653,1},1},{{0,1007021653,1},1}]','[]','[1001021653,1002021653,1003001653,1004021653,1005001653,1006021653,1007021653,1008021653,1009001653,1010021653]'),(32081651,0,1000,0,3,0,1,0,'[{{0,1001031653,1},1},{{0,1002031653,1},1},{{0,1003001653,1},1},{{0,1004031653,1},1},{{0,1006031653,1},1},{{0,1007031653,1},1}]','[]','[1001031653,1002031653,1003001653,1004031653,1005001653,1006031653,1007031653,1008031653,1009001653,1010031653]'),(32081651,0,1000,0,4,0,1,0,'[{{0,1001041653,1},1},{{0,1002041653,1},1},{{0,1003001653,1},1},{{0,1004041653,1},1},{{0,1006041653,1},1},{{0,1007041653,1},1}]','[]','[1001041653,1002041653,1003001653,1004041653,1005001653,1006041653,1007041653,1008041653,1009001653,1010041653]'),(32081652,0,1000,0,1,0,1,0,'[{{0,1002011653,1},1},{{0,1004011653,1},1},{{0,1006011653,1},1},{{0,1008011653,1},1},{{0,1010011653,1},1}]','[]','[1002011653,1004011653,1006011653,1008011653,1010011653]'),(32081652,0,1000,0,2,0,1,0,'[{{0,1002021653,1},1},{{0,1004021653,1},1},{{0,1006021653,1},1},{{0,1008021653,1},1},{{0,1010021653,1},1}]','[]','[1002021653,1004021653,1006021653,1008021653,1010021653]'),(32081652,0,1000,0,3,0,1,0,'[{{0,1002031653,1},1},{{0,1004031653,1},1},{{0,1006031653,1},1},{{0,1008031653,1},1},{{0,1010031653,1},1}]','[]','[1002031653,1004031653,1006031653,1008031653,1010031653]'),(32081652,0,1000,0,4,0,1,0,'[{{0,1002041653,1},1},{{0,1004041653,1},1},{{0,1006041653,1},1},{{0,1008041653,1},1},{{0,1010041653,1},1}]','[]','[1002041653,1004041653,1006041653,1008041653,1010041653]'),(32081653,0,1000,0,1,0,1,0,'[{{0,1001011653,1},1},{{0,1007011653,1},1}]','[]','[1001011653,1007011653]'),(32081653,0,1000,0,2,0,1,0,'[{{0,1001021653,1},1},{{0,1007021653,1},1}]','[]','[1001021653,1007021653]'),(32081653,0,1000,0,3,0,1,0,'[{{0,1001031653,1},1},{{0,1007031653,1},1}]','[]','[1001031653,1007031653]'),(32081653,0,1000,0,4,0,1,0,'[{{0,1001041653,1},1},{{0,1007041653,1},1}]','[]','[1001041653,1007041653]'),(32081655,0,1000,0,1,0,1,0,'[{{0,1002011653,1},1},{{0,1004011653,1},1},{{0,1006011653,1},1},{{0,1008011653,1},1},{{0,1010011653,1},1},{{0,1001011653,1},1}]','[]','[1002011653,1004011653,1006011653,1008011653,1010011653,1001011653]'),(32081655,0,1000,0,2,0,1,0,'[{{0,1002021653,1},1},{{0,1004021653,1},1},{{0,1006021653,1},1},{{0,1008021653,1},1},{{0,1010021653,1},1},{{0,1001021653,1},1}]','[]','[1002021653,1004021653,1006021653,1008021653,1010021653,1001021653]'),(32081655,0,1000,0,3,0,1,0,'[{{0,1002031653,1},1},{{0,1004031653,1},1},{{0,1006031653,1},1},{{0,1008031653,1},1},{{0,1010031653,1},1},{{0,1001031653,1},1}]','[]','[1002031653,1004031653,1006031653,1008031653,1010031653,1001031653]'),(32081655,0,1000,0,4,0,1,0,'[{{0,1002041653,1},1},{{0,1004041653,1},1},{{0,1006041653,1},1},{{0,1008041653,1},1},{{0,1010041653,1},1},{{0,1001041653,1},1}]','[]','[1002041653,1004041653,1006041653,1008041653,1010041653,1001041653]'),(32081656,0,1000,0,1,0,1,0,'[{{0,1007011653,1},1},{{0,1003001653,1},1},{{0,1005001653,1},1},{{0,1009001653,1},1}]','[]','[1007011653,1003001653,1005001653,1009001653]'),(32081656,0,1000,0,2,0,1,0,'[{{0,1007021653,1},1},{{0,1003001653,1},1},{{0,1005001653,1},1},{{0,1009001653,1},1}]','[]','[1007021653,1003001653,1005001653,1009001653]'),(32081656,0,1000,0,3,0,1,0,'[{{0,1007031653,1},1},{{0,1003001653,1},1},{{0,1005001653,1},1},{{0,1009001653,1},1}]','[]','[1007031653,1003001653,1005001653,1009001653]'),(32081656,0,1000,0,4,0,1,0,'[{{0,1007041653,1},1},{{0,1003001653,1},1},{{0,1005001653,1},1},{{0,1009001653,1},1}]','[]','[1007041653,1003001653,1005001653,1009001653]'),(32081657,0,1000,0,1,0,1,0,'[{{0,1007011653,1},1},{{0,1003001653,1},1}]','[]','[1007011653,1003001653]'),(32081657,0,1000,0,2,0,1,0,'[{{0,1007021653,1},1},{{0,1003001653,1},1}]','[]','[1007021653,1003001653]'),(32081657,0,1000,0,3,0,1,0,'[{{0,1007031653,1},1},{{0,1003001653,1},1}]','[]','[1007031653,1003001653]'),(32081657,0,1000,0,4,0,1,0,'[{{0,1007041653,1},1},{{0,1003001653,1},1}]','[]','[1007041653,1003001653]'),(32081658,0,1000,0,0,0,1,0,'[{{0,1005001653,1},1},{{0,1009001653,1},1}]','[]','[1005001653,1009001653]'),(32081661,0,1000,0,1,0,1,0,'[{{0,1001011663,1},1},{{0,1002011663,1},1},{{0,1003001663,1},1},{{0,1004011663,1},1},{{0,1006011663,1},1},{{0,1007011663,1},1}]','[]','[1001011663,1002011663,1003001663,1004011663,1005001663,1006011663,1007011663,1008011663,1009001663,1010011663]'),(32081661,0,1000,0,2,0,1,0,'[{{0,1001021663,1},1},{{0,1002021663,1},1},{{0,1003001663,1},1},{{0,1004021663,1},1},{{0,1006021663,1},1},{{0,1007021663,1},1}]','[]','[1001021663,1002021663,1003001663,1004021663,1005001663,1006021663,1007021663,1008021663,1009001663,1010021663]'),(32081661,0,1000,0,3,0,1,0,'[{{0,1001031663,1},1},{{0,1002031663,1},1},{{0,1003001663,1},1},{{0,1004031663,1},1},{{0,1006031663,1},1},{{0,1007031663,1},1}]','[]','[1001031663,1002031663,1003001663,1004031663,1005001663,1006031663,1007031663,1008031663,1009001663,1010031663]'),(32081661,0,1000,0,4,0,1,0,'[{{0,1001041663,1},1},{{0,1002041663,1},1},{{0,1003001663,1},1},{{0,1004041663,1},1},{{0,1006041663,1},1},{{0,1007041663,1},1}]','[]','[1001041663,1002041663,1003001663,1004041663,1005001663,1006041663,1007041663,1008041663,1009001663,1010041663]'),(32081662,0,1000,0,1,0,1,0,'[{{0,1002011663,1},1},{{0,1004011663,1},1},{{0,1006011663,1},1},{{0,1008011663,1},1},{{0,1010011663,1},1}]','[]','[1002011663,1004011663,1006011663,1008011663,1010011663]'),(32081662,0,1000,0,2,0,1,0,'[{{0,1002021663,1},1},{{0,1004021663,1},1},{{0,1006021663,1},1},{{0,1008021663,1},1},{{0,1010021663,1},1}]','[]','[1002021663,1004021663,1006021663,1008021663,1010021663]'),(32081662,0,1000,0,3,0,1,0,'[{{0,1002031663,1},1},{{0,1004031663,1},1},{{0,1006031663,1},1},{{0,1008031663,1},1},{{0,1010031663,1},1}]','[]','[1002031663,1004031663,1006031663,1008031663,1010031663]'),(32081662,0,1000,0,4,0,1,0,'[{{0,1002041663,1},1},{{0,1004041663,1},1},{{0,1006041663,1},1},{{0,1008041663,1},1},{{0,1010041663,1},1}]','[]','[1002041663,1004041663,1006041663,1008041663,1010041663]'),(32081663,0,1000,0,1,0,1,0,'[{{0,1001011663,1},1},{{0,1007011663,1},1}]','[]','[1001011663,1007011663]'),(32081663,0,1000,0,2,0,1,0,'[{{0,1001021663,1},1},{{0,1007021663,1},1}]','[]','[1001021663,1007021663]'),(32081663,0,1000,0,3,0,1,0,'[{{0,1001031663,1},1},{{0,1007031663,1},1}]','[]','[1001031663,1007031663]'),(32081663,0,1000,0,4,0,1,0,'[{{0,1001041663,1},1},{{0,1007041663,1},1}]','[]','[1001041663,1007041663]'),(32081665,0,1000,0,1,0,1,0,'[{{0,1002011663,1},1},{{0,1004011663,1},1},{{0,1006011663,1},1},{{0,1008011663,1},1},{{0,1010011663,1},1},{{0,1001011663,1},1}]','[]','[1002011663,1004011663,1006011663,1008011663,1010011663,1001011663]'),(32081665,0,1000,0,2,0,1,0,'[{{0,1002021663,1},1},{{0,1004021663,1},1},{{0,1006021663,1},1},{{0,1008021663,1},1},{{0,1010021663,1},1},{{0,1001021663,1},1}]','[]','[1002021663,1004021663,1006021663,1008021663,1010021663,1001021663]'),(32081665,0,1000,0,3,0,1,0,'[{{0,1002031663,1},1},{{0,1004031663,1},1},{{0,1006031663,1},1},{{0,1008031663,1},1},{{0,1010031663,1},1},{{0,1001031663,1},1}]','[]','[1002031663,1004031663,1006031663,1008031663,1010031663,1001031663]'),(32081665,0,1000,0,4,0,1,0,'[{{0,1002041663,1},1},{{0,1004041663,1},1},{{0,1006041663,1},1},{{0,1008041663,1},1},{{0,1010041663,1},1},{{0,1001041663,1},1}]','[]','[1002041663,1004041663,1006041663,1008041663,1010041663,1001041663]'),(32081666,0,1000,0,1,0,1,0,'[{{0,1007011663,1},1},{{0,1003001663,1},1},{{0,1005001663,1},1},{{0,1009001663,1},1}]','[]','[1007011663,1003001663,1005001663,1009001663]'),(32081666,0,1000,0,2,0,1,0,'[{{0,1007021663,1},1},{{0,1003001663,1},1},{{0,1005001663,1},1},{{0,1009001663,1},1}]','[]','[1007021663,1003001663,1005001663,1009001663]'),(32081666,0,1000,0,3,0,1,0,'[{{0,1007031663,1},1},{{0,1003001663,1},1},{{0,1005001663,1},1},{{0,1009001663,1},1}]','[]','[1007031663,1003001663,1005001663,1009001663]'),(32081666,0,1000,0,4,0,1,0,'[{{0,1007041663,1},1},{{0,1003001663,1},1},{{0,1005001663,1},1},{{0,1009001663,1},1}]','[]','[1007041663,1003001663,1005001663,1009001663]'),(32081667,0,1000,0,1,0,1,0,'[{{0,1007011663,1},1},{{0,1003001663,1},1}]','[]','[1007011663,1003001663]'),(32081667,0,1000,0,2,0,1,0,'[{{0,1007021663,1},1},{{0,1003001663,1},1}]','[]','[1007021663,1003001663]'),(32081667,0,1000,0,3,0,1,0,'[{{0,1007031663,1},1},{{0,1003001663,1},1}]','[]','[1007031663,1003001663]'),(32081667,0,1000,0,4,0,1,0,'[{{0,1007041663,1},1},{{0,1003001663,1},1}]','[]','[1007041663,1003001663]'),(32081668,0,1000,0,0,0,1,0,'[{{0,1005001663,1},1},{{0,1009001663,1},1}]','[]','[1005001663,1009001663]'),(32081671,0,1000,0,1,0,1,0,'[{{0,1001011600,1},1},{{0,1002011600,1},1},{{0,1003001600,1},1},{{0,1004011600,1},1},{{0,1006011600,1},1},{{0,1007011600,1},1}]','[]','[]'),(32081671,0,1000,0,2,0,1,0,'[{{0,1001021600,1},1},{{0,1002021600,1},1},{{0,1003001600,1},1},{{0,1004021600,1},1},{{0,1006021600,1},1},{{0,1007021600,1},1}]','[]','[]'),(32081671,0,1000,0,3,0,1,0,'[{{0,1001031600,1},1},{{0,1002031600,1},1},{{0,1003001600,1},1},{{0,1004031600,1},1},{{0,1006031600,1},1},{{0,1007031600,1},1}]','[]','[]'),(32081671,0,1000,0,4,0,1,0,'[{{0,1001041600,1},1},{{0,1002041600,1},1},{{0,1003001600,1},1},{{0,1004041600,1},1},{{0,1006041600,1},1},{{0,1007041600,1},1}]','[]','[]'),(32081672,0,1000,0,1,0,1,0,'[{{0,1002011600,1},1},{{0,1004011600,1},1},{{0,1006011600,1},1},{{0,1008011600,1},1},{{0,1010011600,1},1}]','[]','[]'),(32081672,0,1000,0,2,0,1,0,'[{{0,1002021600,1},1},{{0,1004021600,1},1},{{0,1006021600,1},1},{{0,1008021600,1},1},{{0,1010021600,1},1}]','[]','[]'),(32081672,0,1000,0,3,0,1,0,'[{{0,1002031600,1},1},{{0,1004031600,1},1},{{0,1006031600,1},1},{{0,1008031600,1},1},{{0,1010031600,1},1}]','[]','[]'),(32081672,0,1000,0,4,0,1,0,'[{{0,1002041600,1},1},{{0,1004041600,1},1},{{0,1006041600,1},1},{{0,1008041600,1},1},{{0,1010041600,1},1}]','[]','[]'),(32081673,0,1000,0,1,0,1,0,'[{{0,1001011600,1},1},{{0,1007011600,1},1}]','[]','[]'),(32081673,0,1000,0,2,0,1,0,'[{{0,1001021600,1},1},{{0,1007021600,1},1}]','[]','[]'),(32081673,0,1000,0,3,0,1,0,'[{{0,1001031600,1},1},{{0,1007031600,1},1}]','[]','[]'),(32081673,0,1000,0,4,0,1,0,'[{{0,1001041600,1},1},{{0,1007041600,1},1}]','[]','[]'),(32081675,0,1000,0,1,0,1,0,'[{{0,1002011600,1},1},{{0,1004011600,1},1},{{0,1006011600,1},1},{{0,1008011600,1},1},{{0,1010011600,1},1},{{0,1001011600,1},1}]','[]','[]'),(32081675,0,1000,0,2,0,1,0,'[{{0,1002021600,1},1},{{0,1004021600,1},1},{{0,1006021600,1},1},{{0,1008021600,1},1},{{0,1010021600,1},1},{{0,1001021600,1},1}]','[]','[]'),(32081675,0,1000,0,3,0,1,0,'[{{0,1002031600,1},1},{{0,1004031600,1},1},{{0,1006031600,1},1},{{0,1008031600,1},1},{{0,1010031600,1},1},{{0,1001031600,1},1}]','[]','[]'),(32081675,0,1000,0,4,0,1,0,'[{{0,1002041600,1},1},{{0,1004041600,1},1},{{0,1006041600,1},1},{{0,1008041600,1},1},{{0,1010041600,1},1},{{0,1001041600,1},1}]','[]','[]'),(32081676,0,1000,0,1,0,1,0,'[{{0,1007011600,1},1},{{0,1003001600,1},1},{{0,1005001600,1},1},{{0,1009001600,1},1}]','[]','[]'),(32081676,0,1000,0,2,0,1,0,'[{{0,1007021600,1},1},{{0,1003001600,1},1},{{0,1005001600,1},1},{{0,1009001600,1},1}]','[]','[]'),(32081676,0,1000,0,3,0,1,0,'[{{0,1007031600,1},1},{{0,1003001600,1},1},{{0,1005001600,1},1},{{0,1009001600,1},1}]','[]','[]'),(32081676,0,1000,0,4,0,1,0,'[{{0,1007041600,1},1},{{0,1003001600,1},1},{{0,1005001600,1},1},{{0,1009001600,1},1}]','[]','[]'),(32081677,0,1000,0,1,0,1,0,'[{{0,1007011600,1},1},{{0,1003001600,1},1}]','[]','[]'),(32081677,0,1000,0,2,0,1,0,'[{{0,1007021600,1},1},{{0,1003001600,1},1}]','[]','[]'),(32081677,0,1000,0,3,0,1,0,'[{{0,1007031600,1},1},{{0,1003001600,1},1}]','[]','[]'),(32081677,0,1000,0,4,0,1,0,'[{{0,1007041600,1},1},{{0,1003001600,1},1}]','[]','[]'),(32081678,0,1000,0,0,0,1,0,'[{{0,1005001600,1},1},{{0,1009001600,1},1}]','[]','[]'),(32081681,0,1000,0,1,0,1,0,'[{{0,1001011610,1},1},{{0,1002011610,1},1},{{0,1003001610,1},1},{{0,1004011610,1},1},{{0,1006011610,1},1},{{0,1007011610,1},1}]','[]','[]'),(32081681,0,1000,0,2,0,1,0,'[{{0,1001021610,1},1},{{0,1002021610,1},1},{{0,1003001610,1},1},{{0,1004021610,1},1},{{0,1006021610,1},1},{{0,1007021610,1},1}]','[]','[]'),(32081681,0,1000,0,3,0,1,0,'[{{0,1001031610,1},1},{{0,1002031610,1},1},{{0,1003001610,1},1},{{0,1004031610,1},1},{{0,1006031610,1},1},{{0,1007031610,1},1}]','[]','[]'),(32081681,0,1000,0,4,0,1,0,'[{{0,1001041610,1},1},{{0,1002041610,1},1},{{0,1003001610,1},1},{{0,1004041610,1},1},{{0,1006041610,1},1},{{0,1007041610,1},1}]','[]','[]'),(32081682,0,1000,0,1,0,1,0,'[{{0,1002011610,1},1},{{0,1004011610,1},1},{{0,1006011610,1},1},{{0,1008011610,1},1},{{0,1010011610,1},1}]','[]','[]'),(32081682,0,1000,0,2,0,1,0,'[{{0,1002021610,1},1},{{0,1004021610,1},1},{{0,1006021610,1},1},{{0,1008021610,1},1},{{0,1010021610,1},1}]','[]','[]'),(32081682,0,1000,0,3,0,1,0,'[{{0,1002031610,1},1},{{0,1004031610,1},1},{{0,1006031610,1},1},{{0,1008031610,1},1},{{0,1010031610,1},1}]','[]','[]'),(32081682,0,1000,0,4,0,1,0,'[{{0,1002041610,1},1},{{0,1004041610,1},1},{{0,1006041610,1},1},{{0,1008041610,1},1},{{0,1010041610,1},1}]','[]','[]'),(32081683,0,1000,0,1,0,1,0,'[{{0,1001011610,1},1},{{0,1007011610,1},1}]','[]','[]'),(32081683,0,1000,0,2,0,1,0,'[{{0,1001021610,1},1},{{0,1007021610,1},1}]','[]','[]'),(32081683,0,1000,0,3,0,1,0,'[{{0,1001031610,1},1},{{0,1007031610,1},1}]','[]','[]'),(32081683,0,1000,0,4,0,1,0,'[{{0,1001041610,1},1},{{0,1007041610,1},1}]','[]','[]'),(32081685,0,1000,0,1,0,1,0,'[{{0,1002011610,1},1},{{0,1004011610,1},1},{{0,1006011610,1},1},{{0,1008011610,1},1},{{0,1010011610,1},1},{{0,1001011610,1},1}]','[]','[]'),(32081685,0,1000,0,2,0,1,0,'[{{0,1002021610,1},1},{{0,1004021610,1},1},{{0,1006021610,1},1},{{0,1008021610,1},1},{{0,1010021610,1},1},{{0,1001021610,1},1}]','[]','[]'),(32081685,0,1000,0,3,0,1,0,'[{{0,1002031610,1},1},{{0,1004031610,1},1},{{0,1006031610,1},1},{{0,1008031610,1},1},{{0,1010031610,1},1},{{0,1001031610,1},1}]','[]','[]'),(32081685,0,1000,0,4,0,1,0,'[{{0,1002041610,1},1},{{0,1004041610,1},1},{{0,1006041610,1},1},{{0,1008041610,1},1},{{0,1010041610,1},1},{{0,1001041610,1},1}]','[]','[]'),(32081686,0,1000,0,1,0,1,0,'[{{0,1007011610,1},1},{{0,1003001610,1},1},{{0,1005001610,1},1},{{0,1009001610,1},1}]','[]','[]'),(32081686,0,1000,0,2,0,1,0,'[{{0,1007021610,1},1},{{0,1003001610,1},1},{{0,1005001610,1},1},{{0,1009001610,1},1}]','[]','[]'),(32081686,0,1000,0,3,0,1,0,'[{{0,1007031610,1},1},{{0,1003001610,1},1},{{0,1005001610,1},1},{{0,1009001610,1},1}]','[]','[]'),(32081686,0,1000,0,4,0,1,0,'[{{0,1007041610,1},1},{{0,1003001610,1},1},{{0,1005001610,1},1},{{0,1009001610,1},1}]','[]','[]'),(32081687,0,1000,0,1,0,1,0,'[{{0,1007011610,1},1},{{0,1003001610,1},1}]','[]','[]'),(32081687,0,1000,0,2,0,1,0,'[{{0,1007021610,1},1},{{0,1003001610,1},1}]','[]','[]'),(32081687,0,1000,0,3,0,1,0,'[{{0,1007031610,1},1},{{0,1003001610,1},1}]','[]','[]'),(32081687,0,1000,0,4,0,1,0,'[{{0,1007041610,1},1},{{0,1003001610,1},1}]','[]','[]'),(32081688,0,1000,0,0,0,1,0,'[{{0,1005001610,1},1},{{0,1009001610,1},1}]','[]','[]'),(32081691,0,1000,0,1,0,1,0,'[{{0,1001011620,1},1},{{0,1002011620,1},1},{{0,1003001620,1},1},{{0,1004011620,1},1},{{0,1006011620,1},1},{{0,1007011620,1},1}]','[]','[]'),(32081691,0,1000,0,2,0,1,0,'[{{0,1001021620,1},1},{{0,1002021620,1},1},{{0,1003001620,1},1},{{0,1004021620,1},1},{{0,1006021620,1},1},{{0,1007021620,1},1}]','[]','[]'),(32081691,0,1000,0,3,0,1,0,'[{{0,1001031620,1},1},{{0,1002031620,1},1},{{0,1003001620,1},1},{{0,1004031620,1},1},{{0,1006031620,1},1},{{0,1007031620,1},1}]','[]','[]'),(32081691,0,1000,0,4,0,1,0,'[{{0,1001041620,1},1},{{0,1002041620,1},1},{{0,1003001620,1},1},{{0,1004041620,1},1},{{0,1006041620,1},1},{{0,1007041620,1},1}]','[]','[]'),(32081692,0,1000,0,1,0,1,0,'[{{0,1002011620,1},1},{{0,1004011620,1},1},{{0,1006011620,1},1},{{0,1008011620,1},1},{{0,1010011620,1},1}]','[]','[]'),(32081692,0,1000,0,2,0,1,0,'[{{0,1002021620,1},1},{{0,1004021620,1},1},{{0,1006021620,1},1},{{0,1008021620,1},1},{{0,1010021620,1},1}]','[]','[]'),(32081692,0,1000,0,3,0,1,0,'[{{0,1002031620,1},1},{{0,1004031620,1},1},{{0,1006031620,1},1},{{0,1008031620,1},1},{{0,1010031620,1},1}]','[]','[]'),(32081692,0,1000,0,4,0,1,0,'[{{0,1002041620,1},1},{{0,1004041620,1},1},{{0,1006041620,1},1},{{0,1008041620,1},1},{{0,1010041620,1},1}]','[]','[]'),(32081693,0,1000,0,1,0,1,0,'[{{0,1001011620,1},1},{{0,1007011620,1},1}]','[]','[]'),(32081693,0,1000,0,2,0,1,0,'[{{0,1001021620,1},1},{{0,1007021620,1},1}]','[]','[]'),(32081693,0,1000,0,3,0,1,0,'[{{0,1001031620,1},1},{{0,1007031620,1},1}]','[]','[]'),(32081693,0,1000,0,4,0,1,0,'[{{0,1001041620,1},1},{{0,1007041620,1},1}]','[]','[]'),(32081695,0,1000,0,1,0,1,0,'[{{0,1002011620,1},1},{{0,1004011620,1},1},{{0,1006011620,1},1},{{0,1008011620,1},1},{{0,1010011620,1},1},{{0,1001011620,1},1}]','[]','[]'),(32081695,0,1000,0,2,0,1,0,'[{{0,1002021620,1},1},{{0,1004021620,1},1},{{0,1006021620,1},1},{{0,1008021620,1},1},{{0,1010021620,1},1},{{0,1001021620,1},1}]','[]','[]'),(32081695,0,1000,0,3,0,1,0,'[{{0,1002031620,1},1},{{0,1004031620,1},1},{{0,1006031620,1},1},{{0,1008031620,1},1},{{0,1010031620,1},1},{{0,1001031620,1},1}]','[]','[]'),(32081695,0,1000,0,4,0,1,0,'[{{0,1002041620,1},1},{{0,1004041620,1},1},{{0,1006041620,1},1},{{0,1008041620,1},1},{{0,1010041620,1},1},{{0,1001041620,1},1}]','[]','[]'),(32081696,0,1000,0,1,0,1,0,'[{{0,1007011620,1},1},{{0,1003001620,1},1},{{0,1005001620,1},1},{{0,1009001620,1},1}]','[]','[]'),(32081696,0,1000,0,2,0,1,0,'[{{0,1007021620,1},1},{{0,1003001620,1},1},{{0,1005001620,1},1},{{0,1009001620,1},1}]','[]','[]'),(32081696,0,1000,0,3,0,1,0,'[{{0,1007031620,1},1},{{0,1003001620,1},1},{{0,1005001620,1},1},{{0,1009001620,1},1}]','[]','[]'),(32081696,0,1000,0,4,0,1,0,'[{{0,1007041620,1},1},{{0,1003001620,1},1},{{0,1005001620,1},1},{{0,1009001620,1},1}]','[]','[]'),(32081697,0,1000,0,1,0,1,0,'[{{0,1007011620,1},1},{{0,1003001620,1},1}]','[]','[]'),(32081697,0,1000,0,2,0,1,0,'[{{0,1007021620,1},1},{{0,1003001620,1},1}]','[]','[]'),(32081697,0,1000,0,3,0,1,0,'[{{0,1007031620,1},1},{{0,1003001620,1},1}]','[]','[]'),(32081697,0,1000,0,4,0,1,0,'[{{0,1007041620,1},1},{{0,1003001620,1},1}]','[]','[]'),(32081698,0,1000,0,0,0,1,0,'[{{0,1005001620,1},1},{{0,1009001620,1},1}]','[]','[]'),(32081701,0,1000,0,1,0,1,0,'[{{0,1001011631,1},1},{{0,1002011631,1},1},{{0,1003001631,1},1},{{0,1004011631,1},1},{{0,1006011631,1},1},{{0,1007011631,1},1}]','[]','[]'),(32081701,0,1000,0,2,0,1,0,'[{{0,1001021631,1},1},{{0,1002021631,1},1},{{0,1003001631,1},1},{{0,1004021631,1},1},{{0,1006021631,1},1},{{0,1007021631,1},1}]','[]','[]'),(32081701,0,1000,0,3,0,1,0,'[{{0,1001031631,1},1},{{0,1002031631,1},1},{{0,1003001631,1},1},{{0,1004031631,1},1},{{0,1006031631,1},1},{{0,1007031631,1},1}]','[]','[]'),(32081701,0,1000,0,4,0,1,0,'[{{0,1001041631,1},1},{{0,1002041631,1},1},{{0,1003001631,1},1},{{0,1004041631,1},1},{{0,1006041631,1},1},{{0,1007041631,1},1}]','[]','[]'),(32081702,0,1000,0,1,0,1,0,'[{{0,1002011631,1},1},{{0,1004011631,1},1},{{0,1006011631,1},1},{{0,1008011631,1},1},{{0,1010011631,1},1}]','[]','[]'),(32081702,0,1000,0,2,0,1,0,'[{{0,1002021631,1},1},{{0,1004021631,1},1},{{0,1006021631,1},1},{{0,1008021631,1},1},{{0,1010021631,1},1}]','[]','[]'),(32081702,0,1000,0,3,0,1,0,'[{{0,1002031631,1},1},{{0,1004031631,1},1},{{0,1006031631,1},1},{{0,1008031631,1},1},{{0,1010031631,1},1}]','[]','[]'),(32081702,0,1000,0,4,0,1,0,'[{{0,1002041631,1},1},{{0,1004041631,1},1},{{0,1006041631,1},1},{{0,1008041631,1},1},{{0,1010041631,1},1}]','[]','[]'),(32081703,0,1000,0,1,0,1,0,'[{{0,1001011631,1},1},{{0,1007011631,1},1}]','[]','[]'),(32081703,0,1000,0,2,0,1,0,'[{{0,1001021631,1},1},{{0,1007021631,1},1}]','[]','[]'),(32081703,0,1000,0,3,0,1,0,'[{{0,1001031631,1},1},{{0,1007031631,1},1}]','[]','[]'),(32081703,0,1000,0,4,0,1,0,'[{{0,1001041631,1},1},{{0,1007041631,1},1}]','[]','[]'),(32081705,0,1000,0,1,0,1,0,'[{{0,1002011631,1},1},{{0,1004011631,1},1},{{0,1006011631,1},1},{{0,1008011631,1},1},{{0,1010011631,1},1},{{0,1001011631,1},1}]','[]','[]'),(32081705,0,1000,0,2,0,1,0,'[{{0,1002021631,1},1},{{0,1004021631,1},1},{{0,1006021631,1},1},{{0,1008021631,1},1},{{0,1010021631,1},1},{{0,1001021631,1},1}]','[]','[]'),(32081705,0,1000,0,3,0,1,0,'[{{0,1002031631,1},1},{{0,1004031631,1},1},{{0,1006031631,1},1},{{0,1008031631,1},1},{{0,1010031631,1},1},{{0,1001031631,1},1}]','[]','[]'),(32081705,0,1000,0,4,0,1,0,'[{{0,1002041631,1},1},{{0,1004041631,1},1},{{0,1006041631,1},1},{{0,1008041631,1},1},{{0,1010041631,1},1},{{0,1001041631,1},1}]','[]','[]'),(32081706,0,1000,0,1,0,1,0,'[{{0,1007011631,1},1},{{0,1003001631,1},1},{{0,1005001631,1},1},{{0,1009001631,1},1}]','[]','[]'),(32081706,0,1000,0,2,0,1,0,'[{{0,1007021631,1},1},{{0,1003001631,1},1},{{0,1005001631,1},1},{{0,1009001631,1},1}]','[]','[]'),(32081706,0,1000,0,3,0,1,0,'[{{0,1007031631,1},1},{{0,1003001631,1},1},{{0,1005001631,1},1},{{0,1009001631,1},1}]','[]','[]'),(32081706,0,1000,0,4,0,1,0,'[{{0,1007041631,1},1},{{0,1003001631,1},1},{{0,1005001631,1},1},{{0,1009001631,1},1}]','[]','[]'),(32081707,0,1000,0,1,0,1,0,'[{{0,1007011631,1},1},{{0,1003001631,1},1}]','[]','[]'),(32081707,0,1000,0,2,0,1,0,'[{{0,1007021631,1},1},{{0,1003001631,1},1}]','[]','[]'),(32081707,0,1000,0,3,0,1,0,'[{{0,1007031631,1},1},{{0,1003001631,1},1}]','[]','[]'),(32081707,0,1000,0,4,0,1,0,'[{{0,1007041631,1},1},{{0,1003001631,1},1}]','[]','[]'),(32081708,0,1000,0,0,0,1,0,'[{{0,1005001631,1},1},{{0,1009001631,1},1}]','[]','[]'),(32090001,0,1000,0,0,0,1,1,'[{{100,17010001,50},50},{{100,17010001,55},50},{{100,17010001,60},50},{{100,17010001,65},50},{{100,17010001,70},50},{{100,17010001,75},50},{{100,17010001,80},50},{{100,17010001,80},50},{{100,17010001,85},50}]','[]','[]'),(32090002,0,1000,0,0,0,1,1,'[{{100,17010002,20},5},{{100,17010002,25},5},{{100,17010002,30},5},{{100,17010002,35},5}]','[]','[]'),(32090003,0,1000,0,0,0,1,1,'[{{100,17010003,4},1},{{100,17010003,5},1},{{100,17010003,6},1},{{100,17010003,7},1},{{100,17010003,8},1}]','[]','[]'),(32100002,0,1000,0,0,0,1,1,'[]','[]','[]'),(32100003,0,1000,0,0,0,1,1,'[]','[]','[]'),(32100004,0,1000,0,0,0,1,1,'[]','[]','[]'),(32100005,0,1000,0,0,0,1,1,'[]','[]','[]'),(32100006,0,1000,0,0,0,1,1,'[]','[]','[]'),(32100007,0,1000,0,0,0,1,1,'[]','[]','[]'),(32100008,0,1000,0,0,0,1,1,'[]','[]','[]'),(32100009,0,1000,0,0,0,1,1,'[]','[]','[]'),(32100010,0,1000,0,0,0,1,1,'[]','[]','[]'),(32100011,0,1000,0,0,0,1,1,'[]','[]','[]'),(32100012,0,1000,0,0,0,1,1,'[]','[]','[]'),(32100013,0,1000,0,0,0,1,1,'[]','[]','[]'),(32100014,0,1000,0,0,0,1,1,'[]','[]','[]'),(32100015,0,1000,0,0,0,1,1,'[]','[]','[]'),(32100016,0,1000,0,0,0,1,1,'[]','[]','[]'),(32110011,0,1000,0,0,0,1,1,'[{{0,18071010,1},10},{{0,18072010,1},10},{{0,18073010,1},10},{{0,18074010,1},10}]','[]','[18071010,18072010,18073010,18074010]'),(32110012,0,1000,0,0,0,1,1,'[{{0,18071110,1},10},{{0,18072110,1},10},{{0,18073110,1},10},{{0,18074110,1},10}]','[]','[18071110,18072110,18073110,18074110]'),(32110013,0,1000,0,0,0,1,1,'[{{0,18071210,1},10},{{0,18072210,1},10},{{0,18073210,1},10},{{0,18074210,1},10}]','[]','[18071210,18072210,18073210,18074210]'),(32110014,0,1000,0,0,0,1,1,'[{{0,18071310,1},10},{{0,18072310,1},10},{{0,18073310,1},10},{{0,18074310,1},10}]','[]','[18071310,18072310,18073310,18074310]'),(32110021,0,1000,0,0,0,1,1,'[{{0,18071009,1},10},{{0,18072009,1},10},{{0,18073009,1},10},{{0,18074009,1},10}]','[]','[18071009,18072009,18073009,18074009]'),(32110022,0,1000,0,0,0,1,1,'[{{0,18071109,1},10},{{0,18072109,1},10},{{0,18073109,1},10},{{0,18074109,1},10}]','[]','[18071109,18072109,18073109,18074109]'),(32110023,0,1000,0,0,0,1,1,'[{{0,18071209,1},10},{{0,18072209,1},10},{{0,18073209,1},10},{{0,18074209,1},10}]','[]','[18071209,18072209,18073209,18074209]'),(32110024,0,1000,0,0,0,1,1,'[{{0,18071309,1},10},{{0,18072309,1},10},{{0,18073309,1},10},{{0,18074309,1},10}]','[]','[18071309,18072309,18073309,18074309]'),(32110031,0,1000,0,0,0,1,1,'[{{0,18071008,1},10},{{0,18072008,1},10},{{0,18073008,1},10},{{0,18074008,1},10}]','[]','[18071008,18072008,18073008,18074008]'),(32110032,0,1000,0,0,0,1,1,'[{{0,18071108,1},10},{{0,18072108,1},10},{{0,18073108,1},10},{{0,18074108,1},10}]','[]','[18071108,18072108,18073108,18074108]'),(32110033,0,1000,0,0,0,1,1,'[{{0,18071208,1},10},{{0,18072208,1},10},{{0,18073208,1},10},{{0,18074208,1},10}]','[]','[18071208,18072208,18073208,18074208]'),(32110034,0,1000,0,0,0,1,1,'[{{0,18071308,1},10},{{0,18072308,1},10},{{0,18073308,1},10},{{0,18074308,1},10}]','[]','[18071308,18072308,18073308,18074308]'),(32110041,0,1000,0,0,0,1,1,'[{{0,18071007,1},10},{{0,18072007,1},10},{{0,18073007,1},10},{{0,18074007,1},10}]','[]','[18071007,18072007,18073007,18074007]'),(32110042,0,1000,0,0,0,1,1,'[{{0,18071107,1},10},{{0,18072107,1},10},{{0,18073107,1},10},{{0,18074107,1},10}]','[]','[18071107,18072107,18073107,18074107]'),(32110043,0,1000,0,0,0,1,1,'[{{0,18071207,1},10},{{0,18072207,1},10},{{0,18073207,1},10},{{0,18074207,1},10}]','[]','[18071207,18072207,18073207,18074207]'),(32110044,0,1000,0,0,0,1,1,'[{{0,18071307,1},10},{{0,18072307,1},10},{{0,18073307,1},10},{{0,18074307,1},10}]','[]','[18071307,18072307,18073307,18074307]'),(32110051,0,1000,0,0,0,1,1,'[{{0,18071006,1},10},{{0,18072006,1},10},{{0,18073006,1},10},{{0,18074006,1},10}]','[]','[]'),(32110052,0,1000,0,0,0,1,1,'[{{0,18071106,1},10},{{0,18072106,1},10},{{0,18073106,1},10},{{0,18074106,1},10}]','[]','[]'),(32110053,0,1000,0,0,0,1,1,'[{{0,18071206,1},10},{{0,18072206,1},10},{{0,18073206,1},10},{{0,18074206,1},10}]','[]','[]'),(32110054,0,1000,0,0,0,1,1,'[{{0,18071306,1},10},{{0,18072306,1},10},{{0,18073306,1},10},{{0,18074306,1},10}]','[]','[]'),(32110061,0,1000,0,0,0,1,1,'[{{0,18071004,1},10},{{0,18072004,1},10},{{0,18073004,1},10},{{0,18074004,1},10}]','[]','[]'),(32110062,0,1000,0,0,0,1,1,'[{{0,18071104,1},10},{{0,18072104,1},10},{{0,18073104,1},10},{{0,18074104,1},10}]','[]','[]'),(32110063,0,1000,0,0,0,1,1,'[{{0,18071204,1},10},{{0,18072204,1},10},{{0,18073204,1},10},{{0,18074204,1},10}]','[]','[]'),(32110064,0,1000,0,0,0,1,1,'[{{0,18071304,1},10},{{0,18072304,1},10},{{0,18073304,1},10},{{0,18074304,1},10}]','[]','[]'),(32110071,0,1000,0,0,0,1,1,'[{{0,18071005,1},10},{{0,18072005,1},10},{{0,18073005,1},10},{{0,18074005,1},10}]','[]','[]'),(32110072,0,1000,0,0,0,1,1,'[{{0,18071105,1},10},{{0,18072105,1},10},{{0,18073105,1},10},{{0,18074105,1},10}]','[]','[]'),(32110073,0,1000,0,0,0,1,1,'[{{0,18071205,1},10},{{0,18072205,1},10},{{0,18073205,1},10},{{0,18074205,1},10}]','[]','[]'),(32110074,0,1000,0,0,0,1,1,'[{{0,18071305,1},10},{{0,18072305,1},10},{{0,18073305,1},10},{{0,18074305,1},10}]','[]','[]'),(32110081,1,1000,0,0,0,1,0,'[{{0,18071001,1},10},{{0,18072001,1},10},{{0,18073001,1},10},{{0,18074001,1},10}]','[]','[]'),(32110082,1,1000,0,0,0,1,0,'[{{0,18071101,1},10},{{0,18072101,1},10},{{0,18073101,1},10},{{0,18074101,1},10}]','[]','[]'),(32110083,1,1000,0,0,0,1,0,'[{{0,18071201,1},10},{{0,18072201,1},10},{{0,18073201,1},10},{{0,18074201,1},10}]','[]','[]'),(32110084,1,1000,0,0,0,1,0,'[{{0,18071301,1},10},{{0,18072301,1},10},{{0,18073301,1},10},{{0,18074301,1},10}]','[]','[]'),(32110091,1,1000,0,0,0,1,0,'[{{0,18071002,1},10},{{0,18072002,1},10},{{0,18073002,1},10},{{0,18074002,1},10}]','[]','[]'),(32110092,1,1000,0,0,0,1,0,'[{{0,18071102,1},10},{{0,18072102,1},10},{{0,18073102,1},10},{{0,18074102,1},10}]','[]','[]'),(32110093,1,1000,0,0,0,1,0,'[{{0,18071202,1},10},{{0,18072202,1},10},{{0,18073202,1},10},{{0,18074202,1},10}]','[]','[]'),(32110094,1,1000,0,0,0,1,0,'[{{0,18071302,1},10},{{0,18072302,1},10},{{0,18073302,1},10},{{0,18074302,1},10}]','[]','[]'),(32110101,0,1000,0,0,0,1,1,'[{{0,18071001,1},25},{{0,18072001,1},25},{{0,18073001,1},25},{{0,18074001,1},25},{{0,18071004,1},2},{{0,18072004,1},2},{{0,18073004,1},2},{{0,18074004,1},2}]','[]','[]'),(32110102,0,1000,0,0,0,1,1,'[{{0,18071101,1},25},{{0,18072101,1},25},{{0,18073101,1},25},{{0,18074101,1},25},{{0,18071104,1},2},{{0,18072104,1},2},{{0,18073104,1},2},{{0,18074104,1},2}]','[]','[]'),(32110103,0,1000,0,0,0,1,1,'[{{0,18071201,1},25},{{0,18072201,1},25},{{0,18073201,1},25},{{0,18074201,1},25},{{0,18071204,1},2},{{0,18072204,1},2},{{0,18073204,1},2},{{0,18074204,1},2}]','[]','[]'),(32110104,0,1000,0,0,0,1,1,'[{{0,18071301,1},25},{{0,18072301,1},25},{{0,18073301,1},25},{{0,18074301,1},25},{{0,18071304,1},2},{{0,18072304,1},2},{{0,18073304,1},2},{{0,18074304,1},2}]','[]','[18071301,18072301,18073301,18074301]'),(32110201,0,1000,0,0,0,1,1,'[{{0,18071001,1},75},{{0,18072001,1},75},{{0,18073001,1},75},{{0,18074001,1},75},{{0,18071004,1},15},{{0,18072004,1},15},{{0,18073004,1},15},{{0,18074004,1},15},{{0,18071007,1},5},{{0,18072007,1},5},{{0,18073007,1},5},{{0,18074007,1},5},{{0,18071101,1},5},{{0,18072101,1},5},{{0,18073101,1},5},{{0,18074101,1},5},{{0,18071104,1},1},{{0,18072104,1},1},{{0,18073104,1},1},{{0,18074104,1},1}]','[]','[18071007,18072007,18073007,18074007]'),(32110202,0,1000,0,0,0,1,1,'[{{0,18071101,1},75},{{0,18072101,1},75},{{0,18073101,1},75},{{0,18074101,1},75},{{0,18071104,1},15},{{0,18072104,1},15},{{0,18073104,1},15},{{0,18074104,1},15},{{0,18071107,1},5},{{0,18072107,1},5},{{0,18073107,1},5},{{0,18074107,1},5},{{0,18071201,1},5},{{0,18072201,1},5},{{0,18073201,1},5},{{0,18074201,1},5},{{0,18071204,1},1},{{0,18072204,1},1},{{0,18073204,1},1},{{0,18074204,1},1}]','[]','[18071107,18072107,18073107,18074107]'),(32110203,0,1000,0,0,0,1,1,'[{{0,18071201,1},75},{{0,18072201,1},75},{{0,18073201,1},75},{{0,18074201,1},75},{{0,18071204,1},15},{{0,18072204,1},15},{{0,18073204,1},15},{{0,18074204,1},15},{{0,18071207,1},5},{{0,18072207,1},5},{{0,18073207,1},5},{{0,18074207,1},5},{{0,18071301,1},5},{{0,18072301,1},5},{{0,18073301,1},5},{{0,18074301,1},5},{{0,18071304,1},1},{{0,18072304,1},1},{{0,18073304,1},1},{{0,18074304,1},1}]','[]','[18071207,18072207,18073207,18074207]'),(32110204,0,1000,0,0,0,1,1,'[{{0,18071301,1},80},{{0,18072301,1},80},{{0,18073301,1},80},{{0,18074301,1},80},{{0,18071304,1},15},{{0,18072304,1},15},{{0,18073304,1},15},{{0,18074304,1},15},{{0,18071307,1},4},{{0,18072307,1},4},{{0,18073307,1},4},{{0,18074307,1},4},{{0,18071311,1},1},{{0,18072311,1},1},{{0,18073311,1},1},{{0,18074311,1},1}]','[]','[18071301,18072301,18073301,18074301,18071304,18072304,18073304,18074304,18071307,18072307,18073307,18074307,18071311,18072311,18073311,18074311]'),(32111001,1,1000,0,0,0,1,0,'[{{0,18071003,1},10},{{0,18072003,1},10},{{0,18073003,1},10},{{0,18074003,1},10}]','[]','[]'),(32111002,1,1000,0,0,0,1,0,'[{{0,18071103,1},10},{{0,18072103,1},10},{{0,18073103,1},10},{{0,18074103,1},10}]','[]','[]'),(32111003,1,1000,0,0,0,1,0,'[{{0,18071203,1},10},{{0,18072203,1},10},{{0,18073203,1},10},{{0,18074203,1},10}]','[]','[]'),(32111004,1,1000,0,0,0,1,0,'[{{0,18071303,1},10},{{0,18072303,1},10},{{0,18073303,1},10},{{0,18074303,1},10}]','[]','[]'),(32120101,610,1000,0,0,0,1,0,'[{{0,21010101,1},857},{{0,21010102,1},857},{{0,21010103,1},857},{{0,21010104,1},857},{{0,21010105,1},857},{{0,21010106,1},857},{{0,21010107,1},857},{{0,21010108,1},857},{{0,21010109,1},857},{{0,21010110,1},857},{{0,21010201,1},142},{{0,21010202,1},142},{{0,21010203,1},142},{{0,21010204,1},142},{{0,21010205,1},142},{{0,21010206,1},142},{{0,21010207,1},142},{{0,21010208,1},142},{{0,21010209,1},142},{{0,21010210,1},142}]','[{0,21020001,1}]','[]'),(32120102,610,1000,0,0,0,1,0,'[{{0,21010101,1},857},{{0,21010102,1},857},{{0,21010103,1},857},{{0,21010104,1},857},{{0,21010105,1},857},{{0,21010106,1},857},{{0,21010107,1},857},{{0,21010108,1},857},{{0,21010109,1},857},{{0,21010110,1},857},{{0,21010201,1},142},{{0,21010202,1},142},{{0,21010203,1},142},{{0,21010204,1},142},{{0,21010205,1},142},{{0,21010206,1},142},{{0,21010207,1},142},{{0,21010208,1},142},{{0,21010209,1},142},{{0,21010210,1},142}]','[{0,21020001,1}]','[]'),(32120201,610,1000,0,0,0,1,0,'[{{0,21010101,1},789},{{0,21010102,1},789},{{0,21010103,1},789},{{0,21010104,1},789},{{0,21010105,1},789},{{0,21010106,1},789},{{0,21010107,1},789},{{0,21010108,1},789},{{0,21010109,1},789},{{0,21010110,1},789},{{0,21010301,1},210},{{0,21010302,1},210},{{0,21010303,1},210},{{0,21010304,1},210},{{0,21010305,1},210},{{0,21010306,1},210},{{0,21010307,1},210},{{0,21010308,1},210},{{0,21010309,1},210},{{0,21010310,1},210}]','[{0,21020001,1}]','[]'),(32120202,610,1000,0,0,0,1,0,'[{{0,21010101,1},789},{{0,21010102,1},789},{{0,21010103,1},789},{{0,21010104,1},789},{{0,21010105,1},789},{{0,21010106,1},789},{{0,21010107,1},789},{{0,21010108,1},789},{{0,21010109,1},789},{{0,21010110,1},789},{{0,21010301,1},210},{{0,21010302,1},210},{{0,21010303,1},210},{{0,21010304,1},210},{{0,21010305,1},210},{{0,21010306,1},210},{{0,21010307,1},210},{{0,21010308,1},210},{{0,21010309,1},210},{{0,21010310,1},210}]','[{0,21020001,1}]','[]'),(32120301,610,1000,0,0,0,1,0,'[{{0,21010101,1},750},{{0,21010102,1},750},{{0,21010103,1},750},{{0,21010104,1},750},{{0,21010105,1},750},{{0,21010106,1},750},{{0,21010107,1},750},{{0,21010108,1},750},{{0,21010109,1},750},{{0,21010110,1},750},{{0,21010401,1},250},{{0,21010402,1},250},{{0,21010403,1},250},{{0,21010404,1},250},{{0,21010405,1},250},{{0,21010411,1},250},{{0,21010407,1},250},{{0,21010408,1},250},{{0,21010409,1},250},{{0,21010410,1},250}]','[{0,21020001,2}]','[]'),(32120302,610,1000,0,0,0,1,0,'[{{0,21010101,1},750},{{0,21010102,1},750},{{0,21010103,1},750},{{0,21010104,1},750},{{0,21010105,1},750},{{0,21010106,1},750},{{0,21010107,1},750},{{0,21010108,1},750},{{0,21010109,1},750},{{0,21010110,1},750},{{0,21010401,1},250},{{0,21010402,1},250},{{0,21010403,1},250},{{0,21010404,1},250},{{0,21010405,1},250},{{0,21010411,1},250},{{0,21010407,1},250},{{0,21010408,1},250},{{0,21010409,1},250},{{0,21010410,1},250}]','[{0,21020001,2}]','[]'),(32120401,610,1000,0,0,0,1,0,'[{{0,21010101,1},714},{{0,21010102,1},714},{{0,21010103,1},714},{{0,21010104,1},714},{{0,21010105,1},714},{{0,21010106,1},714},{{0,21010107,1},714},{{0,21010108,1},714},{{0,21010109,1},714},{{0,21010110,1},714},{{0,21010401,1},285},{{0,21010402,1},285},{{0,21010403,1},285},{{0,21010404,1},285},{{0,21010405,1},285},{{0,21010411,1},285},{{0,21010407,1},285},{{0,21010408,1},285},{{0,21010409,1},285},{{0,21010410,1},285}]','[{0,21020001,2}]','[]'),(32120402,610,1000,0,0,0,1,0,'[{{0,21010101,1},714},{{0,21010102,1},714},{{0,21010103,1},714},{{0,21010104,1},714},{{0,21010105,1},714},{{0,21010106,1},714},{{0,21010107,1},714},{{0,21010108,1},714},{{0,21010109,1},714},{{0,21010110,1},714},{{0,21010401,1},285},{{0,21010402,1},285},{{0,21010403,1},285},{{0,21010404,1},285},{{0,21010405,1},285},{{0,21010411,1},285},{{0,21010407,1},285},{{0,21010408,1},285},{{0,21010409,1},285},{{0,21010410,1},285}]','[{0,21020001,2}]','[]'),(32130001,0,1000,0,0,0,1,1,'[{{0,16040101,1},90},{{0,16040102,1},8},{{0,16040103,1},2},{{0,16040201,1},90},{{0,16040202,1},8},{{0,16040203,1},2},{{0,16040301,1},90},{{0,16040302,1},8},{{0,16040303,1},2},{{0,16040401,1},90},{{0,16040402,1},8},{{0,16040403,1},2},{{0,16040501,1},90},{{0,16040502,1},8},{{0,16040503,1},2},{{0,16040601,1},90},{{0,16040602,1},8},{{0,16040603,1},2}]','[]','[]'),(32130002,0,1000,0,0,0,1,1,'[{{0,16040101,1},8370},{{0,16040102,1},744},{{0,16040103,1},186},{{0,16040201,1},8370},{{0,16040202,1},744},{{0,16040203,1},186},{{0,16040301,1},8370},{{0,16040302,1},744},{{0,16040303,1},186},{{0,16040401,1},8370},{{0,16040402,1},744},{{0,16040403,1},186},{{0,16040501,1},8370},{{0,16040502,1},744},{{0,16040503,1},186},{{0,16040601,1},8370},{{0,16040602,1},744},{{0,16040603,1},186},{{0,16040111,1},450},{{0,16040112,1},40},{{0,16040113,1},10},{{0,16040211,1},450},{{0,16040212,1},40},{{0,16040213,1},10},{{0,16040311,1},450},{{0,16040312,1},40},{{0,16040313,1},10},{{0,16040411,1},450},{{0,16040412,1},40},{{0,16040413,1},10},{{0,16040511,1},450},{{0,16040512,1},40},{{0,16040513,1},10},{{0,16040611,1},450},{{0,16040612,1},40},{{0,16040613,1},10},{{0,16040121,1},90},{{0,16040122,1},8},{{0,16040123,1},2},{{0,16040221,1},90},{{0,16040222,1},8},{{0,16040223,1},2},{{0,16040321,1},90},{{0,16040322,1},8},{{0,16040323,1},2},{{0,16040421,1},90},{{0,16040422,1},8},{{0,16040423,1},2},{{0,16040521,1},90},{{0,16040522,1},8},{{0,16040523,1},2},{{0,16040621,1},90},{{0,16040622,1},8},{{0,16040623,1},2},{{0,16040131,1},90},{{0,16040132,1},8},{{0,16040133,1},2},{{0,16040231,1},90},{{0,16040232,1},8},{{0,16040233,1},2},{{0,16040331,1},90},{{0,16040332,1},8},{{0,16040333,1},2},{{0,16040431,1},90},{{0,16040432,1},8},{{0,16040433,1},2},{{0,16040531,1},90},{{0,16040532,1},8},{{0,16040533,1},2},{{0,16040631,1},90},{{0,16040632,1},8},{{0,16040633,1},2}]','[]','[]'),(32130003,0,1000,0,0,0,1,1,'[{{0,16040101,1},7110},{{0,16040102,1},632},{{0,16040103,1},158},{{0,16040201,1},7110},{{0,16040202,1},632},{{0,16040203,1},158},{{0,16040301,1},7110},{{0,16040302,1},632},{{0,16040303,1},158},{{0,16040401,1},7110},{{0,16040402,1},632},{{0,16040403,1},158},{{0,16040501,1},7110},{{0,16040502,1},632},{{0,16040503,1},158},{{0,16040601,1},7110},{{0,16040602,1},632},{{0,16040603,1},158},{{0,16040111,1},900},{{0,16040112,1},80},{{0,16040113,1},20},{{0,16040211,1},900},{{0,16040212,1},80},{{0,16040213,1},20},{{0,16040311,1},900},{{0,16040312,1},80},{{0,16040313,1},20},{{0,16040411,1},900},{{0,16040412,1},80},{{0,16040413,1},20},{{0,16040511,1},900},{{0,16040512,1},80},{{0,16040513,1},20},{{0,16040611,1},900},{{0,16040612,1},80},{{0,16040613,1},20},{{0,16040121,1},900},{{0,16040122,1},80},{{0,16040123,1},20},{{0,16040221,1},900},{{0,16040222,1},80},{{0,16040223,1},20},{{0,16040321,1},900},{{0,16040322,1},80},{{0,16040323,1},20},{{0,16040421,1},900},{{0,16040422,1},80},{{0,16040423,1},20},{{0,16040521,1},900},{{0,16040522,1},80},{{0,16040523,1},20},{{0,16040621,1},900},{{0,16040622,1},80},{{0,16040623,1},20},{{0,16040131,1},90},{{0,16040132,1},8},{{0,16040133,1},2},{{0,16040231,1},90},{{0,16040232,1},8},{{0,16040233,1},2},{{0,16040331,1},90},{{0,16040332,1},8},{{0,16040333,1},2},{{0,16040431,1},90},{{0,16040432,1},8},{{0,16040433,1},2},{{0,16040531,1},90},{{0,16040532,1},8},{{0,16040533,1},2},{{0,16040631,1},90},{{0,16040632,1},8},{{0,16040633,1},2}]','[]','[]'),(32130004,1,1000,0,0,0,1,1,'[{{0,16040113,1},10},{{0,16040213,1},10},{{0,16040313,1},5},{{0,16040413,1},5},{{0,16040513,1},1},{{0,16040613,1},1}]','[]','[]'),(32140001,0,1000,0,0,0,1,1,'[{{0,14140110,1},25},{{0,14140210,1},25},{{0,14140310,1},25},{{0,14140410,1},25}]','[]','[]'),(32140002,0,1000,0,0,0,1,1,'[{{0,14140510,1},25},{{0,14140610,1},25},{{0,14140710,1},25},{{0,14140810,1},25}]','[]','[]'),(32150001,0,1000,0,0,0,1,1,'[{{0,5201014,1},25},{{0,5201024,1},25},{{0,5201034,1},25},{{0,5201044,1},25},{{0,5201054,1},25},{{0,5201064,1},25},{{0,5201074,1},25},{{0,5201084,1},25},{{0,5201094,1},25},{{0,5201104,1},25},{{0,5201144,1},25},{{0,5201154,1},25},{{0,5201164,1},25},{{0,5201174,1},25},{{0,5201184,1},25},{{0,5201194,1},25}]','[]','[]'),(32150002,1,150,0,0,0,1,1,'[{{0,5201010,1},25},{{0,5201011,1},50},{{0,5201012,1},25},{{0,5201020,1},25},{{0,5201021,1},50},{{0,5201022,1},25},{{0,5201030,1},25},{{0,5201031,1},50},{{0,5201032,1},25},{{0,5201040,1},25},{{0,5201041,1},50},{{0,5201042,1},25}]','[]','[]'),(32150002,151,250,0,0,0,1,1,'[{{0,5201010,1},25},{{0,5201011,1},50},{{0,5201012,1},25},{{0,5201020,1},25},{{0,5201021,1},50},{{0,5201022,1},25},{{0,5201030,1},25},{{0,5201031,1},50},{{0,5201032,1},25},{{0,5201040,1},25},{{0,5201041,1},50},{{0,5201042,1},25},{{0,5201140,1},25},{{0,5201141,1},50},{{0,5201142,1},25}]','[]','[]'),(32150002,251,300,0,0,0,1,1,'[{{0,5201010,1},25},{{0,5201011,1},50},{{0,5201012,1},25},{{0,5201020,1},25},{{0,5201021,1},50},{{0,5201022,1},25},{{0,5201030,1},25},{{0,5201031,1},50},{{0,5201032,1},25},{{0,5201040,1},25},{{0,5201041,1},50},{{0,5201042,1},25},{{0,5201140,1},25},{{0,5201141,1},50},{{0,5201142,1},25},{{0,5201050,1},25},{{0,5201051,1},50},{{0,5201052,1},25},{{0,5201060,1},25},{{0,5201061,1},50},{{0,5201062,1},25},{{0,5201070,1},25},{{0,5201071,1},50},{{0,5201072,1},25}]','[]','[]'),(32150002,301,450,0,0,0,1,1,'[{{0,5201010,1},25},{{0,5201011,1},50},{{0,5201012,1},25},{{0,5201020,1},25},{{0,5201021,1},50},{{0,5201022,1},25},{{0,5201030,1},25},{{0,5201031,1},50},{{0,5201032,1},25},{{0,5201040,1},25},{{0,5201041,1},50},{{0,5201042,1},25},{{0,5201140,1},25},{{0,5201141,1},50},{{0,5201142,1},25},{{0,5201050,1},25},{{0,5201051,1},50},{{0,5201052,1},25},{{0,5201060,1},25},{{0,5201061,1},50},{{0,5201062,1},25},{{0,5201070,1},25},{{0,5201071,1},50},{{0,5201072,1},25},{{0,5201080,1},25},{{0,5201081,1},50},{{0,5201082,1},25},{{0,5201090,1},25},{{0,5201091,1},50},{{0,5201092,1},25},{{0,5201100,1},25},{{0,5201101,1},50},{{0,5201102,1},25}]','[]','[]'),(32150002,451,500,0,0,0,1,1,'[{{0,5201010,1},25},{{0,5201011,1},50},{{0,5201012,1},25},{{0,5201020,1},25},{{0,5201021,1},50},{{0,5201022,1},25},{{0,5201030,1},25},{{0,5201031,1},50},{{0,5201032,1},25},{{0,5201040,1},25},{{0,5201041,1},50},{{0,5201042,1},25},{{0,5201140,1},25},{{0,5201141,1},50},{{0,5201142,1},25},{{0,5201050,1},25},{{0,5201051,1},50},{{0,5201052,1},25},{{0,5201060,1},25},{{0,5201061,1},50},{{0,5201062,1},25},{{0,5201070,1},25},{{0,5201071,1},50},{{0,5201072,1},25},{{0,5201080,1},25},{{0,5201081,1},50},{{0,5201082,1},25},{{0,5201090,1},25},{{0,5201091,1},50},{{0,5201092,1},25},{{0,5201100,1},25},{{0,5201101,1},50},{{0,5201102,1},25},{{0,5201170,1},25},{{0,5201171,1},50},{{0,5201172,1},25},{{0,5201180,1},25},{{0,5201181,1},50},{{0,5201182,1},25},{{0,5201150,1},25},{{0,5201151,1},50},{{0,5201152,1},25}]','[]','[]'),(32150002,501,1000,0,0,0,1,1,'[{{0,5201010,1},25},{{0,5201011,1},50},{{0,5201012,1},25},{{0,5201020,1},25},{{0,5201021,1},50},{{0,5201022,1},25},{{0,5201030,1},25},{{0,5201031,1},50},{{0,5201032,1},25},{{0,5201040,1},25},{{0,5201041,1},50},{{0,5201042,1},25},{{0,5201140,1},25},{{0,5201141,1},50},{{0,5201142,1},25},{{0,5201050,1},25},{{0,5201051,1},50},{{0,5201052,1},25},{{0,5201060,1},25},{{0,5201061,1},50},{{0,5201062,1},25},{{0,5201070,1},25},{{0,5201071,1},50},{{0,5201072,1},25},{{0,5201080,1},25},{{0,5201081,1},50},{{0,5201082,1},25},{{0,5201090,1},25},{{0,5201091,1},50},{{0,5201092,1},25},{{0,5201100,1},25},{{0,5201101,1},50},{{0,5201102,1},25},{{0,5201170,1},25},{{0,5201171,1},50},{{0,5201172,1},25},{{0,5201180,1},25},{{0,5201181,1},50},{{0,5201182,1},25},{{0,5201150,1},25},{{0,5201151,1},50},{{0,5201152,1},25},{{0,5201160,1},25},{{0,5201161,1},50},{{0,5201162,1},25},{{0,5201190,1},25},{{0,5201191,1},50},{{0,5201192,1},25}]','[]','[]'),(32150003,1,150,0,0,0,1,1,'[{{0,5201011,1},17},{{0,5201012,1},80},{{0,5201013,1},3},{{0,5201021,1},17},{{0,5201022,1},80},{{0,5201023,1},3},{{0,5201031,1},17},{{0,5201032,1},80},{{0,5201033,1},3},{{0,5201041,1},17},{{0,5201042,1},80},{{0,5201043,1},3}]','[]','[5201012,5201013,5201022,5201023]'),(32150003,151,250,0,0,0,1,1,'[{{0,5201011,1},17},{{0,5201012,1},80},{{0,5201013,1},3},{{0,5201021,1},17},{{0,5201022,1},80},{{0,5201023,1},3},{{0,5201031,1},17},{{0,5201032,1},80},{{0,5201033,1},3},{{0,5201041,1},17},{{0,5201042,1},80},{{0,5201043,1},3},{{0,5201141,1},17},{{0,5201142,1},80},{{0,5201143,1},3}]','[]','[5201012,5201013,5201022,5201023,5201032,5201033,5201042,5201043]'),(32150003,251,300,0,0,0,1,1,'[{{0,5201011,1},17},{{0,5201012,1},80},{{0,5201013,1},3},{{0,5201021,1},17},{{0,5201022,1},80},{{0,5201023,1},3},{{0,5201031,1},17},{{0,5201032,1},80},{{0,5201033,1},3},{{0,5201041,1},17},{{0,5201042,1},80},{{0,5201043,1},3},{{0,5201141,1},17},{{0,5201142,1},80},{{0,5201143,1},3},{{0,5201051,1},17},{{0,5201052,1},80},{{0,5201053,1},3},{{0,5201061,1},17},{{0,5201062,1},80},{{0,5201063,1},3},{{0,5201071,1},17},{{0,5201072,1},80},{{0,5201073,1},3}]','[]','[5201012,5201013,5201022,5201023,5201032,5201033,5201042,5201043,5201052,5201053,5201062,5201063]'),(32150003,301,450,0,0,0,1,1,'[{{0,5201011,1},17},{{0,5201012,1},80},{{0,5201013,1},3},{{0,5201021,1},17},{{0,5201022,1},80},{{0,5201023,1},3},{{0,5201031,1},17},{{0,5201032,1},80},{{0,5201033,1},3},{{0,5201041,1},17},{{0,5201042,1},80},{{0,5201043,1},3},{{0,5201141,1},17},{{0,5201142,1},80},{{0,5201143,1},3},{{0,5201051,1},17},{{0,5201052,1},80},{{0,5201053,1},3},{{0,5201061,1},17},{{0,5201062,1},80},{{0,5201063,1},3},{{0,5201071,1},17},{{0,5201072,1},80},{{0,5201073,1},3},{{0,5201081,1},17},{{0,5201082,1},80},{{0,5201083,1},3},{{0,5201091,1},17},{{0,5201092,1},80},{{0,5201093,1},3},{{0,5201101,1},17},{{0,5201102,1},80},{{0,5201103,1},3}]','[]','[5201012,5201013,5201022,5201023,5201032,5201033,5201042,5201043,5201052,5201053,5201062,5201063,5201072,5201073,5201082,5201083]'),(32150003,451,500,0,0,0,1,1,'[{{0,5201011,1},17},{{0,5201012,1},80},{{0,5201013,1},3},{{0,5201021,1},17},{{0,5201022,1},80},{{0,5201023,1},3},{{0,5201031,1},17},{{0,5201032,1},80},{{0,5201033,1},3},{{0,5201041,1},17},{{0,5201042,1},80},{{0,5201043,1},3},{{0,5201141,1},17},{{0,5201142,1},80},{{0,5201143,1},3},{{0,5201051,1},17},{{0,5201052,1},80},{{0,5201053,1},3},{{0,5201061,1},17},{{0,5201062,1},80},{{0,5201063,1},3},{{0,5201071,1},17},{{0,5201072,1},80},{{0,5201073,1},3},{{0,5201081,1},17},{{0,5201082,1},80},{{0,5201083,1},3},{{0,5201091,1},17},{{0,5201092,1},80},{{0,5201093,1},3},{{0,5201101,1},17},{{0,5201102,1},80},{{0,5201103,1},3},{{0,5201171,1},17},{{0,5201172,1},80},{{0,5201173,1},3},{{0,5201181,1},17},{{0,5201182,1},80},{{0,5201183,1},3},{{0,5201151,1},17},{{0,5201152,1},80},{{0,5201153,1},3}]','[]','[5201012,5201013,5201022,5201023,5201032,5201033,5201042,5201043,5201052,5201053,5201062,5201063,5201072,5201073,5201082,5201083,5201092,5201093]'),(32150003,501,1000,0,0,0,1,1,'[{{0,5201011,1},17},{{0,5201012,1},80},{{0,5201013,1},3},{{0,5201021,1},17},{{0,5201022,1},80},{{0,5201023,1},3},{{0,5201031,1},17},{{0,5201032,1},80},{{0,5201033,1},3},{{0,5201041,1},17},{{0,5201042,1},80},{{0,5201043,1},3},{{0,5201141,1},17},{{0,5201142,1},80},{{0,5201143,1},3},{{0,5201051,1},17},{{0,5201052,1},80},{{0,5201053,1},3},{{0,5201061,1},17},{{0,5201062,1},80},{{0,5201063,1},3},{{0,5201071,1},17},{{0,5201072,1},80},{{0,5201073,1},3},{{0,5201081,1},17},{{0,5201082,1},80},{{0,5201083,1},3},{{0,5201091,1},17},{{0,5201092,1},80},{{0,5201093,1},3},{{0,5201101,1},17},{{0,5201102,1},80},{{0,5201103,1},3},{{0,5201171,1},17},{{0,5201172,1},80},{{0,5201173,1},3},{{0,5201181,1},17},{{0,5201182,1},80},{{0,5201183,1},3},{{0,5201151,1},17},{{0,5201152,1},80},{{0,5201153,1},3},{{0,5201161,1},17},{{0,5201162,1},80},{{0,5201163,1},3},{{0,5201191,1},17},{{0,5201192,1},80},{{0,5201193,1},3}]','[]','[5201012,5201013,5201022,5201023,5201032,5201033,5201042,5201043,5201052,5201053,5201062,5201063,5201072,5201073,5201082,5201083,5201092,5201093,5201102,5201103]'),(32150004,1,1000,0,0,0,1,0,'[{{0,24020002,1},45},{{0,24020003,1},45},{{0,24020004,1},10},{{0,16010002,1},45},{{0,16010003,1},45},{{0,16010004,1},10},{{0,20020002,1},45},{{0,20020003,1},45},{{0,20020004,1},10}]','[]','[]'),(32160001,1,1000,0,0,0,1,1,'[{{0,5201014,1},2},{{0,5201013,1},10},{{0,5201024,1},2},{{0,5201023,1},10},{{0,5201034,1},2},{{0,5201033,1},10},{{0,5201044,1},2},{{0,5201043,1},10},{{0,5201054,1},2},{{0,5201053,1},10},{{0,5201064,1},2},{{0,5201063,1},10},{{0,5201074,1},2},{{0,5201073,1},10},{{0,5201084,1},2},{{0,5201083,1},10},{{0,5201094,1},2},{{0,5201093,1},10},{{0,5201104,1},2},{{0,5201103,1},10},{{0,5203005,5},360},{{0,5203004,5},696}]','[]','[5201014,5201024,5201034,5201044,5201054,5201064,5201074,5201084,5201094,5201104,5201013,5201023,5201033,5201043,5201053,5201063,5201073,5201083,5201093,5201103]'),(32160002,1,1000,0,0,0,1,1,'[{{0,20040003,1},5},{{0,20040002,1},10},{{0,20040001,1},20},{{0,20060003,2},65}]','[]','[20040003,20040002,20040001,20060003]'),(32160003,1,1000,0,0,0,1,0,'[{{0,18041004,3},100},{{0,18041006,3},100},{{0,18041002,3},100},{{0,18041007,3},100},{{0,18041004,6},40},{{0,18041006,6},40},{{0,18041002,6},40},{{0,18041007,6},40},{{0,18041004,10},10},{{0,18041006,10},10},{{0,18041002,10},10},{{0,18041007,10},10}]','[]','[18041004,18041006,18041002,18041007,18041004,18041006,18041002,18041007,18041004,18041006,18041002,18041007]'),(32160004,1,1000,0,0,0,1,0,'[{{0,18054801,1},100},{{0,18050801,1},100},{{0,18050901,1},100},{{0,18051001,1},100},{{0,18051101,1},100},{{0,18051201,1},100},{{0,18053601,1},50},{{0,18053901,1},50},{{0,18054401,1},10}]','[]','[18054801,18050801,18050901,18051001,18051101,18051201,18053601,18053901,18054401]'),(32160005,0,1000,0,0,0,1,0,'[{{0,5203001,1},50},{{0,5203002,1},40},{{0,5203003,1},10}]','[]','[]'),(32160006,1,150,0,0,0,1,1,'[{{0,5201010,1},25},{{0,5201011,1},50},{{0,5201012,1},25},{{0,5201020,1},25},{{0,5201021,1},50},{{0,5201022,1},25},{{0,5201030,1},25},{{0,5201031,1},50},{{0,5201032,1},25},{{0,5201040,1},25},{{0,5201041,1},50},{{0,5201042,1},25},{{0,5201140,1},25},{{0,5201141,1},50},{{0,5201142,1},25}]','[]','[]'),(32160006,151,250,0,0,0,1,1,'[{{0,5201010,1},25},{{0,5201011,1},50},{{0,5201012,1},25},{{0,5201020,1},25},{{0,5201021,1},50},{{0,5201022,1},25},{{0,5201030,1},25},{{0,5201031,1},50},{{0,5201032,1},25},{{0,5201040,1},25},{{0,5201041,1},50},{{0,5201042,1},25},{{0,5201140,1},25},{{0,5201141,1},50},{{0,5201142,1},25},{{0,5201050,1},25},{{0,5201051,1},50},{{0,5201052,1},25},{{0,5201060,1},25},{{0,5201061,1},50},{{0,5201062,1},25},{{0,5201070,1},25},{{0,5201071,1},50},{{0,5201072,1},25}]','[]','[]'),(32160006,251,300,0,0,0,1,1,'[{{0,5201010,1},25},{{0,5201011,1},50},{{0,5201012,1},25},{{0,5201020,1},25},{{0,5201021,1},50},{{0,5201022,1},25},{{0,5201030,1},25},{{0,5201031,1},50},{{0,5201032,1},25},{{0,5201040,1},25},{{0,5201041,1},50},{{0,5201042,1},25},{{0,5201140,1},25},{{0,5201141,1},50},{{0,5201142,1},25},{{0,5201050,1},25},{{0,5201051,1},50},{{0,5201052,1},25},{{0,5201060,1},25},{{0,5201061,1},50},{{0,5201062,1},25},{{0,5201070,1},25},{{0,5201071,1},50},{{0,5201072,1},25},{{0,5201080,1},25},{{0,5201081,1},50},{{0,5201082,1},25},{{0,5201090,1},25},{{0,5201091,1},50},{{0,5201092,1},25},{{0,5201100,1},25},{{0,5201101,1},50},{{0,5201102,1},25}]','[]','[]'),(32160006,301,450,0,0,0,1,1,'[{{0,5201010,1},25},{{0,5201011,1},50},{{0,5201012,1},25},{{0,5201020,1},25},{{0,5201021,1},50},{{0,5201022,1},25},{{0,5201030,1},25},{{0,5201031,1},50},{{0,5201032,1},25},{{0,5201040,1},25},{{0,5201041,1},50},{{0,5201042,1},25},{{0,5201140,1},25},{{0,5201141,1},50},{{0,5201142,1},25},{{0,5201050,1},25},{{0,5201051,1},50},{{0,5201052,1},25},{{0,5201060,1},25},{{0,5201061,1},50},{{0,5201062,1},25},{{0,5201070,1},25},{{0,5201071,1},50},{{0,5201072,1},25},{{0,5201080,1},25},{{0,5201081,1},50},{{0,5201082,1},25},{{0,5201090,1},25},{{0,5201091,1},50},{{0,5201092,1},25},{{0,5201100,1},25},{{0,5201101,1},50},{{0,5201102,1},25},{{0,5201170,1},25},{{0,5201171,1},50},{{0,5201172,1},25},{{0,5201180,1},25},{{0,5201181,1},50},{{0,5201182,1},25},{{0,5201150,1},25},{{0,5201151,1},50},{{0,5201152,1},25}]','[]','[]'),(32160006,451,500,0,0,0,1,1,'[{{0,5201010,1},25},{{0,5201011,1},50},{{0,5201012,1},25},{{0,5201020,1},25},{{0,5201021,1},50},{{0,5201022,1},25},{{0,5201030,1},25},{{0,5201031,1},50},{{0,5201032,1},25},{{0,5201040,1},25},{{0,5201041,1},50},{{0,5201042,1},25},{{0,5201140,1},25},{{0,5201141,1},50},{{0,5201142,1},25},{{0,5201050,1},25},{{0,5201051,1},50},{{0,5201052,1},25},{{0,5201060,1},25},{{0,5201061,1},50},{{0,5201062,1},25},{{0,5201070,1},25},{{0,5201071,1},50},{{0,5201072,1},25},{{0,5201080,1},25},{{0,5201081,1},50},{{0,5201082,1},25},{{0,5201090,1},25},{{0,5201091,1},50},{{0,5201092,1},25},{{0,5201100,1},25},{{0,5201101,1},50},{{0,5201102,1},25},{{0,5201170,1},25},{{0,5201171,1},50},{{0,5201172,1},25},{{0,5201180,1},25},{{0,5201181,1},50},{{0,5201182,1},25},{{0,5201150,1},25},{{0,5201151,1},50},{{0,5201152,1},25},{{0,5201160,1},25},{{0,5201161,1},50},{{0,5201162,1},25},{{0,5201190,1},25},{{0,5201191,1},50},{{0,5201192,1},25}]','[]','[]'),(32160006,501,1000,0,0,0,1,1,'[{{0,5201010,1},25},{{0,5201011,1},50},{{0,5201012,1},25},{{0,5201020,1},25},{{0,5201021,1},50},{{0,5201022,1},25},{{0,5201030,1},25},{{0,5201031,1},50},{{0,5201032,1},25},{{0,5201040,1},25},{{0,5201041,1},50},{{0,5201042,1},25},{{0,5201140,1},25},{{0,5201141,1},50},{{0,5201142,1},25},{{0,5201050,1},25},{{0,5201051,1},50},{{0,5201052,1},25},{{0,5201060,1},25},{{0,5201061,1},50},{{0,5201062,1},25},{{0,5201070,1},25},{{0,5201071,1},50},{{0,5201072,1},25},{{0,5201080,1},25},{{0,5201081,1},50},{{0,5201082,1},25},{{0,5201090,1},25},{{0,5201091,1},50},{{0,5201092,1},25},{{0,5201100,1},25},{{0,5201101,1},50},{{0,5201102,1},25},{{0,5201170,1},25},{{0,5201171,1},50},{{0,5201172,1},25},{{0,5201180,1},25},{{0,5201181,1},50},{{0,5201182,1},25},{{0,5201150,1},25},{{0,5201151,1},50},{{0,5201152,1},25},{{0,5201160,1},25},{{0,5201161,1},50},{{0,5201162,1},25},{{0,5201190,1},25},{{0,5201191,1},50},{{0,5201192,1},25}]','[]','[]'),(32160007,0,1000,0,0,0,0,0,'[]','[{0,5203004,8},{255,36160008,40}]','[]'),(32160008,0,1000,0,1,0,1,0,'[{{0,53010103,1},1}]','[]','[]'),(32160008,0,1000,0,2,0,1,0,'[{{0,53010203,1},1}]','[]','[]'),(32160008,0,1000,0,4,0,1,0,'[{{0,53010403,1},1}]','[]','[]'),(32160009,0,1000,0,1,0,1,0,'[{{0,53010102,1},1}]','[]','[]'),(32160009,0,1000,0,2,0,1,0,'[{{0,53010202,1},1}]','[]','[]'),(32160009,0,1000,0,4,0,1,0,'[{{0,53010402,1},1}]','[]','[]'),(32160010,0,1000,0,1,0,1,0,'[{{0,53010105,1},1}]','[]','[]'),(32160010,0,1000,0,2,0,1,0,'[{{0,53010205,1},1}]','[]','[]'),(32160010,0,1000,0,4,0,1,0,'[{{0,53010405,1},1}]','[]','[]'),(32160011,0,1000,0,0,0,1,0,'[]','[]','[]'),(32160012,0,1000,0,0,0,1,0,'[{{0,11040003,1},1},{{0,11040004,1},1},{{0,11040005,1},1}]','[]','[]'),(32160013,0,1000,0,0,0,1,0,'[{{100,18041002,1},10},{{100,18041003,1},10},{{100,18041004,1},10},{{100,18041005,1},10},{{100,18041006,1},10},{{100,18041007,1},10}]','[]','[]'),(32160014,0,1000,0,0,0,1,0,'[]','[{0,38250001,10}]','[]'),(32160015,0,1000,0,0,0,3,0,'[{{0,16040101,1},1},{{0,16040201,1},1},{{0,16040301,1},1},{{0,16040111,1},1},{{0,16040211,1},1},{{0,16040311,1},1}]','[]','[]'),(32160016,0,1000,0,0,0,2,0,'[{{0,16040101,1},1},{{0,16040201,1},1},{{0,16040301,1},1},{{0,16040111,1},1},{{0,16040211,1},1},{{0,16040311,1},1}]','[]','[]'),(32160017,0,1000,0,0,0,1,0,'[{{0,16040101,1},1},{{0,16040201,1},1},{{0,16040301,1},1},{{0,16040111,1},1},{{0,16040211,1},1},{{0,16040311,1},1}]','[]','[]'),(32160018,0,1000,0,0,0,3,0,'[{{0,11040003,1},1},{{0,11040004,1},1},{{0,11040005,1},1}]','[]','[]'),(32160019,0,1000,0,0,0,2,0,'[{{0,11040003,1},1},{{0,11040004,1},1},{{0,11040005,1},1}]','[]','[]'),(32160020,0,1000,0,0,0,1,0,'[{{0,11040003,1},1},{{0,11040004,1},1},{{0,11040005,1},1}]','[]','[]'),(32160021,0,1000,0,0,0,1,0,'[{{0,38280620,1},1}]','[]','[]'),(32160022,0,1000,0,0,0,1,0,'[]','[]','[]'),(32160023,0,1000,0,0,0,1,0,'[]','[]','[]'),(32160024,0,1000,0,0,0,1,0,'[]','[]','[]'),(32170001,1,1000,0,0,0,1,1,'[{{0,16040101,1},1},{{0,16040201,1},1},{{0,16040301,1},1}]','[]','[]'),(32170002,1,1000,0,0,0,1,1,'[{{0,16040102,1},1},{{0,16040202,1},1},{{0,16040302,1},1}]','[]','[]'),(32170003,1,1000,0,0,0,1,1,'[{{0,16040103,1},1},{{0,16040203,1},1},{{0,16040303,1},1}]','[]','[]'),(32170004,1,1000,0,0,0,1,1,'[{{0,16040104,1},1},{{0,16040204,1},1},{{0,16040304,1},1}]','[]','[]'),(32170005,1,1000,0,0,0,1,1,'[{{0,16040105,1},1},{{0,16040205,1},1},{{0,16040305,1},1}]','[]','[]'),(32170101,1,1000,0,0,0,1,1,'[{{0,16040111,1},1},{{0,16040211,1},1},{{0,16040311,1},1}]','[]','[]'),(32170102,1,1000,0,0,0,1,1,'[{{0,16040112,1},1},{{0,16040212,1},1},{{0,16040312,1},1}]','[]','[]'),(32170103,1,1000,0,0,0,1,1,'[{{0,16040113,1},1},{{0,16040213,1},1},{{0,16040313,1},1}]','[]','[]'),(32170104,1,1000,0,0,0,1,1,'[{{0,16040114,1},1},{{0,16040214,1},1},{{0,16040314,1},1}]','[]','[]'),(32170105,1,1000,0,0,0,1,1,'[{{0,16040115,1},1},{{0,16040215,1},1},{{0,16040315,1},1}]','[]','[]'),(32170201,1,1000,0,0,0,1,1,'[{{0,16040121,1},1},{{0,16040221,1},1},{{0,16040321,1},1}]','[]','[]'),(32170202,1,1000,0,0,0,1,1,'[{{0,16040122,1},1},{{0,16040222,1},1},{{0,16040322,1},1}]','[]','[]'),(32170203,1,1000,0,0,0,1,1,'[{{0,16040123,1},1},{{0,16040223,1},1},{{0,16040323,1},1}]','[]','[]'),(32170204,1,1000,0,0,0,1,1,'[{{0,16040124,1},1},{{0,16040224,1},1},{{0,16040324,1},1}]','[]','[]'),(32170205,1,1000,0,0,0,1,1,'[{{0,16040125,1},1},{{0,16040225,1},1},{{0,16040325,1},1}]','[]','[]'),(32170301,1,1000,0,0,0,1,1,'[{{0,16040131,1},1},{{0,16040231,1},1},{{0,16040331,1},1}]','[]','[16040131,16040231,16040331,16040431,16040531,16040631]'),(32170302,1,1000,0,0,0,1,1,'[{{0,16040132,1},1},{{0,16040232,1},1},{{0,16040332,1},1}]','[]','[16040132,16040232,16040332,16040432,16040532,16040632]'),(32170303,1,1000,0,0,0,1,1,'[{{0,16040133,1},1},{{0,16040233,1},1},{{0,16040333,1},1}]','[]','[16040133,16040233,16040333,16040433,16040533,16040633]'),(32170304,1,1000,0,0,0,1,1,'[{{0,16040134,1},1},{{0,16040234,1},1},{{0,16040334,1},1}]','[]','[16040134,16040234,16040334,16040434,16040534,16040634]'),(32170305,1,1000,0,0,0,1,1,'[{{0,16040135,1},1},{{0,16040235,1},1},{{0,16040335,1},1}]','[]','[16040135,16040235,16040335,16040435,16040535,16040635]'),(32170401,1,1000,0,0,0,1,1,'[{{0,16040141,1},1},{{0,16040241,1},1},{{0,16040341,1},1}]','[]','[16040141,16040241,16040341,16040441,16040541,16040641]'),(32170402,1,1000,0,0,0,1,1,'[{{0,16040142,1},1},{{0,16040242,1},1},{{0,16040342,1},1}]','[]','[16040142,16040242,16040342,16040442,16040542,16040642]'),(32170403,1,1000,0,0,0,1,1,'[{{0,16040143,1},1},{{0,16040243,1},1},{{0,16040343,1},1}]','[]','[16040143,16040243,16040343,16040443,16040543,16040643]'),(32170404,1,1000,0,0,0,1,1,'[{{0,16040144,1},1},{{0,16040244,1},1},{{0,16040344,1},1}]','[]','[16040144,16040244,16040344,16040444,16040544,16040644]'),(32170405,1,1000,0,0,0,1,1,'[{{0,16040145,1},1},{{0,16040245,1},1},{{0,16040345,1},1}]','[]','[16040145,16040245,16040345,16040445,16040545,16040645]'),(32170501,1,1000,0,0,0,1,1,'[{{0,16040151,1},1},{{0,16040251,1},1},{{0,16040351,1},1}]','[]','[16040151,16040251,16040351,16040451,16040551,16040651]'),(32170502,1,1000,0,0,0,1,1,'[{{0,16040152,1},1},{{0,16040252,1},1},{{0,16040352,1},1}]','[]','[16040152,16040252,16040352,16040452,16040552,16040652]'),(32170503,1,1000,0,0,0,1,1,'[{{0,16040153,1},1},{{0,16040253,1},1},{{0,16040353,1},1}]','[]','[16040153,16040253,16040353,16040453,16040553,16040653]'),(32170504,1,1000,0,0,0,1,1,'[{{0,16040154,1},1},{{0,16040254,1},1},{{0,16040354,1},1}]','[]','[16040154,16040254,16040354,16040454,16040554,16040654]'),(32170505,1,1000,0,0,0,1,1,'[{{0,16040155,1},1},{{0,16040255,1},1},{{0,16040355,1},1}]','[]','[16040155,16040255,16040355,16040455,16040555,16040655]');
/*!40000 ALTER TABLE `base_gift_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_global_counter`
--

DROP TABLE IF EXISTS `base_global_counter`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_global_counter` (
  `module` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `id` int(11) unsigned NOT NULL DEFAULT '1' COMMENT '次数id',
  `limit` int(11) unsigned DEFAULT '1' COMMENT '上限',
  `about` varchar(1000) DEFAULT '' COMMENT '描述',
  PRIMARY KEY (`module`,`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_global_counter`
--

LOCK TABLES `base_global_counter` WRITE;
/*!40000 ALTER TABLE `base_global_counter` DISABLE KEYS */;
INSERT INTO `base_global_counter` VALUES (604,1,0,'时间偏移量（用于秘籍）'),(604,2,0,'当前第几届');
/*!40000 ALTER TABLE `base_global_counter` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_global_counter_extra`
--

DROP TABLE IF EXISTS `base_global_counter_extra`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_global_counter_extra` (
  `module` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `sub_module` int(11) NOT NULL DEFAULT '1' COMMENT '功能子id',
  `limit` int(11) unsigned DEFAULT '1' COMMENT '上限',
  `about` varchar(1000) DEFAULT '' COMMENT '描述',
  PRIMARY KEY (`module`,`sub_module`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_global_counter_extra`
--

LOCK TABLES `base_global_counter_extra` WRITE;
/*!40000 ALTER TABLE `base_global_counter_extra` DISABLE KEYS */;
INSERT INTO `base_global_counter_extra` VALUES (150,1,0,'全局怪物掉落上限'),(331,4,0,'开服集字'),(331,22,0,'烟花活动物品全服次数'),(416,1,0,'寻宝积分兑换次数'),(417,1,0,'福利等级礼包');
/*!40000 ALTER TABLE `base_global_counter_extra` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_god`
--

DROP TABLE IF EXISTS `base_god`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_god` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '降神id',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '名字',
  `skill` varchar(255) NOT NULL DEFAULT '[]' COMMENT '技能列表',
  `condition` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗内容',
  `other_cond` varchar(50) NOT NULL DEFAULT '[]' COMMENT '其它激活条件',
  `resource` varchar(50) NOT NULL DEFAULT '0' COMMENT '资源',
  `icon_id` int(11) NOT NULL DEFAULT '0' COMMENT '图标id',
  `effect` varchar(50) NOT NULL COMMENT '特效名字',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='降神配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_god`
--

LOCK TABLES `base_god` WRITE;
/*!40000 ALTER TABLE `base_god` DISABLE KEYS */;
INSERT INTO `base_god` VALUES (1001,'光辉神','[16000100,16000101,16000102,16000103,16000110,16000120,16000130]','[]','[{lv,24}]','203021',11010003,'ui_godclutchshot_guangmingshen'),(1002,'冰雪女王','[16000200,16000201,16000202,16000203,16000210,16000220,16000230]','[{0,11010004,8}]','[]','203017',11010020,'ui_godclutchshot_bingshen'),(1003,'月神','[16000300,16000301,16000302,16000303,16000310,16000320,16000330]','[{0,11010005,1}]','[]','203022',11010005,'ui_godclutchshot_yueshen'),(1004,'波塞冬','[16000010,16000011,16000012,16000013,16000014,16000015,16000016]','[{0,11010001,1}]','[]','601003',11010001,'ui_godclutchshot_bsd'),(1005,'雅典娜','[16000020,16000021,16000022,16000023,16000024,16000025,16000026]','[{0,11010002,1}]','[]','601001',11010002,'ui_godclutchshot_yadianna'),(1006,'哈迪斯','[16000400,16000401,16000402,16000403,16000410,16000420,16000430]','[{0,11010006,1}]','[]','203018',11010006,'ui_godclutchshot_hadisi');
/*!40000 ALTER TABLE `base_god` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_god_dun_id_dot`
--

DROP TABLE IF EXISTS `base_god_dun_id_dot`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_god_dun_id_dot` (
  `dun_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本id',
  `dot` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '初始怒气值',
  PRIMARY KEY (`dun_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_god_dun_id_dot`
--

LOCK TABLES `base_god_dun_id_dot` WRITE;
/*!40000 ALTER TABLE `base_god_dun_id_dot` DISABLE KEYS */;
INSERT INTO `base_god_dun_id_dot` VALUES (1002,2800),(1003,2700),(2201,2800),(2202,2800),(2203,2800),(2301,2700),(2302,2700),(2303,2600),(2304,2600),(2305,2800),(5405,2325),(10000,2800),(10002,2800),(10003,2800),(10030,2700);
/*!40000 ALTER TABLE `base_god_dun_id_dot` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_god_dun_type_dot`
--

DROP TABLE IF EXISTS `base_god_dun_type_dot`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_god_dun_type_dot` (
  `dun_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本类型',
  `dot` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '初始怒气值',
  PRIMARY KEY (`dun_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_god_dun_type_dot`
--

LOCK TABLES `base_god_dun_type_dot` WRITE;
/*!40000 ALTER TABLE `base_god_dun_type_dot` DISABLE KEYS */;
INSERT INTO `base_god_dun_type_dot` VALUES (4,1650),(20,2850);
/*!40000 ALTER TABLE `base_god_dun_type_dot` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_god_lv`
--

DROP TABLE IF EXISTS `base_god_lv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_god_lv` (
  `god_id` int(11) NOT NULL DEFAULT '0' COMMENT '降神id',
  `grade` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '阶数',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '星级',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '升级经验',
  `attr` varchar(512) NOT NULL DEFAULT '[]' COMMENT '属性',
  `every_attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '每一次增加属性',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '升级道具/经验',
  `num` int(11) NOT NULL DEFAULT '0' COMMENT '单次使用所需个数',
  PRIMARY KEY (`grade`,`lv`,`god_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='进阶升星配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_god_lv`
--

LOCK TABLES `base_god_lv` WRITE;
/*!40000 ALTER TABLE `base_god_lv` DISABLE KEYS */;
INSERT INTO `base_god_lv` VALUES (1001,1,0,10,'[{1,41},{2,833},{5,20},{6,20}]','[2,20]','[{11020001,10}]',1),(1002,1,0,10,'[{1,135},{2,2708},{5,67},{6,67}]','[2,21]','[{11020001,10}]',3),(1003,1,0,10,'[{1,250},{2,4999},{5,124},{6,124}]','[2,26]','[{11020001,10}]',3),(1004,1,0,10,'[{1,395},{2,7916},{5,198},{6,198}]','[2,31]','[{11020001,10}]',3),(1005,1,0,10,'[{1,318},{2,6375},{5,159},{6,159}]','[2,24]','[{11020001,10}]',3),(1006,1,0,30,'[{1,547},{2,10937},{5,273},{6,273}]','[2,36]','[{11020001,10}]',3),(1001,1,1,20,'[{1,47},{2,957},{5,23},{6,23}]','[1,1]','[{11020001,10}]',1),(1002,1,1,20,'[{1,142},{2,2856},{5,70},{6,70}]','[1,1]','[{11020001,10}]',3),(1003,1,1,20,'[{1,258},{2,5175},{5,128},{6,128}]','[1,1]','[{11020001,10}]',3),(1004,1,1,20,'[{1,404},{2,8115},{5,202},{6,202}]','[1,2]','[{11020001,10}]',3),(1005,1,1,20,'[{1,327},{2,6555},{5,163},{6,163}]','[1,1]','[{11020001,10}]',3),(1006,1,1,30,'[{1,557},{2,11138},{5,278},{6,278}]','[1,2]','[{11020001,10}]',3),(1001,1,2,30,'[{1,53},{2,1085},{5,26},{6,26}]','[2,20]','[{11020001,10}]',2),(1002,1,2,30,'[{1,149},{2,3009},{5,73},{6,73}]','[2,23]','[{11020001,10}]',3),(1003,1,2,30,'[{1,267},{2,5357},{5,132},{6,132}]','[2,28]','[{11020001,10}]',3),(1004,1,2,30,'[{1,414},{2,8322},{5,207},{6,207}]','[2,31]','[{11020001,10}]',3),(1005,1,2,30,'[{1,336},{2,6742},{5,167},{6,167}]','[2,26]','[{11020001,10}]',3),(1006,1,2,30,'[{1,567},{2,11347},{5,283},{6,283}]','[2,38]','[{11020001,10}]',3),(1001,1,3,30,'[{1,59},{2,1217},{5,29},{6,29}]','[1,1]','[{11020001,10}]',2),(1002,1,3,30,'[{1,156},{2,3167},{5,76},{6,76}]','[1,1]','[{11020001,10}]',3),(1003,1,3,30,'[{1,276},{2,5545},{5,136},{6,136}]','[1,1]','[{11020001,10}]',3),(1004,1,3,30,'[{1,424},{2,8536},{5,212},{6,212}]','[1,2]','[{11020001,10}]',3),(1005,1,3,30,'[{1,345},{2,6935},{5,171},{6,171}]','[1,1]','[{11020001,10}]',3),(1006,1,3,30,'[{1,577},{2,11564},{5,288},{6,288}]','[1,2]','[{11020001,10}]',3),(1001,1,4,30,'[{1,65},{2,1353},{5,32},{6,32}]','[2,21]','[{11020001,10}]',2),(1002,1,4,30,'[{1,164},{2,3330},{5,80},{6,80}]','[2,24]','[{11020001,10}]',3),(1003,1,4,30,'[{1,285},{2,5739},{5,140},{6,140}]','[2,29]','[{11020001,10}]',3),(1004,1,4,30,'[{1,435},{2,8757},{5,217},{6,217}]','[2,34]','[{11020001,10}]',3),(1005,1,4,30,'[{1,354},{2,7134},{5,175},{6,175}]','[2,26]','[{11020001,10}]',3),(1006,1,4,30,'[{1,588},{2,11788},{5,293},{6,293}]','[2,39]','[{11020001,10}]',3),(1001,1,5,30,'[{1,72},{2,1492},{5,35},{6,35}]','[1,1]','[{11020001,10}]',2),(1002,1,5,30,'[{1,172},{2,3498},{5,84},{6,84}]','[1,1]','[{11020001,10}]',3),(1003,1,5,30,'[{1,295},{2,5939},{5,145},{6,145}]','[1,2]','[{11020001,10}]',3),(1004,1,5,30,'[{1,446},{2,8985},{5,222},{6,222}]','[1,2]','[{11020001,10}]',3),(1005,1,5,30,'[{1,364},{2,7340},{5,180},{6,180}]','[1,1]','[{11020001,10}]',3),(1006,1,5,30,'[{1,599},{2,12020},{5,298},{6,298}]','[1,2]','[{11020001,10}]',3),(1001,2,0,50,'[{1,79},{2,1642},{5,38},{6,38}]','[2,23]','[{11020001,10}]',2),(1002,2,0,50,'[{1,181},{2,3679},{5,88},{6,88}]','[2,26]','[{11020001,10}]',3),(1003,2,0,50,'[{1,305},{2,6156},{5,150},{6,150}]','[2,31]','[{11020001,10}]',3),(1004,2,0,50,'[{1,458},{2,9233},{5,228},{6,228}]','[2,36]','[{11020001,10}]',3),(1005,2,0,50,'[{1,375},{2,7563},{5,185},{6,185}]','[2,30]','[{11020001,10}]',3),(1006,2,0,45,'[{1,611},{2,12274},{5,304},{6,304}]','[2,42]','[{11020001,10}]',3),(1001,2,1,50,'[{1,86},{2,1796},{5,41},{6,41}]','[1,1]','[{11020001,10}]',2),(1002,2,1,50,'[{1,190},{2,3866},{5,92},{6,92}]','[1,1]','[{11020001,10}]',3),(1003,2,1,50,'[{1,316},{2,6379},{5,155},{6,155}]','[1,2]','[{11020001,10}]',3),(1004,2,1,50,'[{1,470},{2,9489},{5,234},{6,234}]','[1,2]','[{11020001,10}]',3),(1005,2,1,50,'[{1,386},{2,7793},{5,190},{6,190}]','[1,1]','[{11020001,10}]',3),(1006,2,1,45,'[{1,624},{2,12537},{5,310},{6,310}]','[1,2]','[{11020001,10}]',3),(1001,2,2,50,'[{1,93},{2,1954},{5,44},{6,44}]','[2,23]','[{11020001,10}]',2),(1002,2,2,50,'[{1,199},{2,4058},{5,96},{6,96}]','[2,29]','[{11020001,10}]',3),(1003,2,2,50,'[{1,327},{2,6609},{5,160},{6,160}]','[2,34]','[{11020001,10}]',3),(1004,2,2,50,'[{1,483},{2,9753},{5,240},{6,240}]','[2,39]','[{11020001,10}]',3),(1005,2,2,50,'[{1,397},{2,8031},{5,195},{6,195}]','[2,31]','[{11020001,10}]',3),(1006,2,2,45,'[{1,637},{2,12809},{5,316},{6,316}]','[2,46]','[{11020001,10}]',3),(1001,2,3,50,'[{1,101},{2,2116},{5,48},{6,48}]','[1,1]','[{11020001,10}]',2),(1002,2,3,50,'[{1,208},{2,4256},{5,100},{6,100}]','[1,1]','[{11020001,10}]',3),(1003,2,3,50,'[{1,338},{2,6846},{5,165},{6,165}]','[1,2]','[{11020001,10}]',3),(1004,2,3,50,'[{1,496},{2,10024},{5,246},{6,246}]','[1,2]','[{11020001,10}]',3),(1005,2,3,50,'[{1,409},{2,8276},{5,201},{6,201}]','[1,2]','[{11020001,10}]',3),(1006,2,3,45,'[{1,651},{2,13089},{5,323},{6,323}]','[1,2]','[{11020001,10}]',3),(1001,2,4,50,'[{1,109},{2,2283},{5,52},{6,52}]','[2,26]','[{11020001,10}]',2),(1002,2,4,50,'[{1,218},{2,4459},{5,105},{6,105}]','[2,31]','[{11020001,10}]',3),(1003,2,4,50,'[{1,350},{2,7089},{5,171},{6,171}]','[2,36]','[{11020001,10}]',3),(1004,2,4,50,'[{1,509},{2,10303},{5,252},{6,252}]','[2,39]','[{11020001,10}]',3),(1005,2,4,50,'[{1,421},{2,8528},{5,207},{6,207}]','[2,32]','[{11020001,10}]',3),(1006,2,4,45,'[{1,665},{2,13378},{5,330},{6,330}]','[2,47]','[{11020001,10}]',3),(1001,2,5,50,'[{1,117},{2,2454},{5,56},{6,56}]','[1,1]','[{11020001,10}]',2),(1002,2,5,50,'[{1,228},{2,4668},{5,110},{6,110}]','[1,2]','[{11020001,10}]',3),(1003,2,5,50,'[{1,362},{2,7339},{5,177},{6,177}]','[1,2]','[{11020001,10}]',3),(1004,2,5,50,'[{1,523},{2,10590},{5,259},{6,259}]','[1,2]','[{11020001,10}]',3),(1005,2,5,50,'[{1,433},{2,8787},{5,213},{6,213}]','[1,2]','[{11020001,10}]',3),(1006,2,5,45,'[{1,679},{2,13676},{5,337},{6,337}]','[1,3]','[{11020001,10}]',3),(1001,3,0,60,'[{1,126},{2,2637},{5,60},{6,60}]','[2,28]','[{11020001,10}]',3),(1002,3,0,60,'[{1,239},{2,4893},{5,115},{6,115}]','[2,33]','[{11020001,10}]',3),(1003,3,0,60,'[{1,375},{2,7609},{5,183},{6,183}]','[2,37]','[{11020001,10}]',3),(1004,3,0,60,'[{1,538},{2,10901},{5,266},{6,266}]','[2,42]','[{11020001,10}]',3),(1005,3,0,60,'[{1,447},{2,9067},{5,220},{6,220}]','[2,36]','[{11020001,10}]',3),(1006,3,0,60,'[{1,695},{2,14000},{5,345},{6,345}]','[2,52]','[{11020001,10}]',3),(1001,3,1,60,'[{1,135},{2,2829},{5,64},{6,64}]','[1,1]','[{11020001,10}]',3),(1002,3,1,60,'[{1,250},{2,5129},{5,120},{6,120}]','[1,2]','[{11020001,10}]',3),(1003,3,1,60,'[{1,389},{2,7892},{5,190},{6,190}]','[1,2]','[{11020001,10}]',3),(1004,3,1,60,'[{1,554},{2,11228},{5,274},{6,274}]','[1,2]','[{11020001,10}]',3),(1005,3,1,60,'[{1,461},{2,9361},{5,227},{6,227}]','[1,2]','[{11020001,10}]',3),(1006,3,1,60,'[{1,712},{2,14342},{5,353},{6,353}]','[1,3]','[{11020001,10}]',3),(1001,3,2,60,'[{1,145},{2,3029},{5,69},{6,69}]','[2,28]','[{11020001,10}]',3),(1002,3,2,60,'[{1,262},{2,5375},{5,126},{6,126}]','[2,34]','[{11020001,10}]',3),(1003,3,2,60,'[{1,403},{2,8189},{5,197},{6,197}]','[2,41]','[{11020001,10}]',3),(1004,3,2,60,'[{1,571},{2,11571},{5,282},{6,282}]','[2,46]','[{11020001,10}]',3),(1005,3,2,60,'[{1,476},{2,9669},{5,234},{6,234}]','[2,37]','[{11020001,10}]',3),(1006,3,2,60,'[{1,729},{2,14701},{5,361},{6,361}]','[2,54]','[{11020001,10}]',3),(1001,3,3,60,'[{1,155},{2,3237},{5,74},{6,74}]','[1,1]','[{11020001,10}]',3),(1002,3,3,60,'[{1,274},{2,5632},{5,132},{6,132}]','[1,2]','[{11020001,10}]',3),(1003,3,3,60,'[{1,418},{2,8499},{5,204},{6,204}]','[1,2]','[{11020001,10}]',3),(1004,3,3,60,'[{1,588},{2,11930},{5,290},{6,290}]','[1,2]','[{11020001,10}]',3),(1005,3,3,60,'[{1,492},{2,9992},{5,242},{6,242}]','[1,2]','[{11020001,10}]',3),(1006,3,3,60,'[{1,747},{2,15078},{5,370},{6,370}]','[1,3]','[{11020001,10}]',3),(1001,3,4,60,'[{1,165},{2,3454},{5,79},{6,79}]','[2,30]','[{11020001,10}]',3),(1002,3,4,60,'[{1,287},{2,5900},{5,138},{6,138}]','[2,36]','[{11020001,10}]',3),(1003,3,4,60,'[{1,434},{2,8822},{5,212},{6,212}]','[2,41]','[{11020001,10}]',3),(1004,3,4,60,'[{1,606},{2,12304},{5,299},{6,299}]','[2,47]','[{11020001,10}]',3),(1005,3,4,60,'[{1,508},{2,10329},{5,250},{6,250}]','[2,37]','[{11020001,10}]',3),(1006,3,4,60,'[{1,766},{2,15472},{5,379},{6,379}]','[2,55]','[{11020001,10}]',3),(1001,3,5,60,'[{1,176},{2,3679},{5,84},{6,84}]','[1,2]','[{11020001,10}]',3),(1002,3,5,60,'[{1,300},{2,6179},{5,144},{6,144}]','[1,2]','[{11020001,10}]',3),(1003,3,5,60,'[{1,450},{2,9159},{5,220},{6,220}]','[1,2]','[{11020001,10}]',3),(1004,3,5,60,'[{1,625},{2,12694},{5,308},{6,308}]','[1,2]','[{11020001,10}]',3),(1005,3,5,60,'[{1,525},{2,10680},{5,258},{6,258}]','[1,2]','[{11020001,10}]',3),(1006,3,5,60,'[{1,786},{2,15884},{5,389},{6,389}]','[1,3]','[{11020001,10}]',3),(1001,4,0,80,'[{1,188},{2,3918},{5,90},{6,90}]','[2,32]','[{11020001,10}]',3),(1002,4,0,80,'[{1,314},{2,6477},{5,151},{6,151}]','[2,39]','[{11020001,10}]',3),(1003,4,0,80,'[{1,468},{2,9519},{5,229},{6,229}]','[2,44]','[{11020001,10}]',3),(1004,4,0,80,'[{1,645},{2,13112},{5,318},{6,318}]','[2,51]','[{11020001,10}]',3),(1005,4,0,80,'[{1,543},{2,11056},{5,267},{6,267}]','[2,41]','[{11020001,10}]',3),(1006,4,0,90,'[{1,808},{2,16326},{5,400},{6,400}]','[2,61]','[{11020001,10}]',3),(1001,4,1,80,'[{1,200},{2,4168},{5,96},{6,96}]','[1,2]','[{11020001,10}]',3),(1002,4,1,80,'[{1,329},{2,6788},{5,158},{6,158}]','[1,2]','[{11020001,10}]',3),(1003,4,1,80,'[{1,486},{2,9896},{5,238},{6,238}]','[1,2]','[{11020001,10}]',3),(1004,4,1,80,'[{1,666},{2,13550},{5,328},{6,328}]','[1,3]','[{11020001,10}]',3),(1005,4,1,80,'[{1,562},{2,11449},{5,276},{6,276}]','[1,2]','[{11020001,10}]',3),(1006,4,1,90,'[{1,831},{2,16790},{5,411},{6,411}]','[1,3]','[{11020001,10}]',3),(1001,4,2,80,'[{1,213},{2,4428},{5,102},{6,102}]','[2,34]','[{11020001,10}]',3),(1002,4,2,80,'[{1,345},{2,7113},{5,166},{6,166}]','[2,39]','[{11020001,10}]',3),(1003,4,2,80,'[{1,505},{2,10289},{5,247},{6,247}]','[2,47]','[{11020001,10}]',3),(1004,4,2,80,'[{1,688},{2,14007},{5,339},{6,339}]','[2,54]','[{11020001,10}]',3),(1005,4,2,80,'[{1,582},{2,11860},{5,286},{6,286}]','[2,44]','[{11020001,10}]',3),(1006,4,2,90,'[{1,855},{2,17276},{5,423},{6,423}]','[2,64]','[{11020001,10}]',3),(1001,4,3,80,'[{1,226},{2,4699},{5,108},{6,108}]','[1,2]','[{11020001,10}]',3),(1002,4,3,80,'[{1,361},{2,7452},{5,174},{6,174}]','[1,2]','[{11020001,10}]',3),(1003,4,3,80,'[{1,525},{2,10699},{5,257},{6,257}]','[1,2]','[{11020001,10}]',3),(1004,4,3,80,'[{1,711},{2,14484},{5,350},{6,350}]','[1,3]','[{11020001,10}]',3),(1005,4,3,80,'[{1,603},{2,12289},{5,296},{6,296}]','[1,2]','[{11020001,10}]',3),(1006,4,3,90,'[{1,880},{2,17784},{5,435},{6,435}]','[1,3]','[{11020001,10}]',3),(1001,4,4,80,'[{1,240},{2,4980},{5,115},{6,115}]','[2,34]','[{11020001,10}]',3),(1002,4,4,80,'[{1,378},{2,7804},{5,182},{6,182}]','[2,42]','[{11020001,10}]',3),(1003,4,4,80,'[{1,546},{2,11126},{5,267},{6,267}]','[2,49]','[{11020001,10}]',3),(1004,4,4,80,'[{1,735},{2,14981},{5,362},{6,362}]','[2,55]','[{11020001,10}]',3),(1005,4,4,80,'[{1,625},{2,12735},{5,307},{6,307}]','[2,46]','[{11020001,10}]',3),(1006,4,4,90,'[{1,906},{2,18314},{5,448},{6,448}]','[2,67]','[{11020001,10}]',3),(1001,4,5,80,'[{1,254},{2,5272},{5,122},{6,122}]','[1,2]','[{11020001,10}]',3),(1002,4,5,80,'[{1,396},{2,8170},{5,191},{6,191}]','[1,2]','[{11020001,10}]',3),(1003,4,5,80,'[{1,568},{2,11569},{5,278},{6,278}]','[1,3]','[{11020001,10}]',3),(1004,4,5,80,'[{1,760},{2,15498},{5,374},{6,374}]','[1,3]','[{11020001,10}]',3),(1005,4,5,80,'[{1,648},{2,13199},{5,318},{6,318}]','[1,2]','[{11020001,10}]',3),(1006,4,5,90,'[{1,933},{2,18866},{5,461},{6,461}]','[1,3]','[{11020001,10}]',3),(1001,5,0,100,'[{1,269},{2,5580},{5,129},{6,129}]','[2,38]','[{11020001,10}]',3),(1002,5,0,100,'[{1,415},{2,8557},{5,200},{6,200}]','[2,46]','[{11020001,10}]',3),(1003,5,0,100,'[{1,591},{2,12039},{5,289},{6,289}]','[2,52]','[{11020001,10}]',3),(1004,5,0,100,'[{1,787},{2,16047},{5,387},{6,387}]','[2,60]','[{11020001,10}]',3),(1005,5,0,100,'[{1,672},{2,13692},{5,330},{6,330}]','[2,49]','[{11020001,10}]',3),(1006,5,0,120,'[{1,962},{2,19453},{5,475},{6,475}]','[2,70]','[{11020001,10}]',3),(1001,5,1,100,'[{1,285},{2,5901},{5,137},{6,137}]','[1,2]','[{11020001,10}]',3),(1002,5,1,100,'[{1,435},{2,8961},{5,210},{6,210}]','[1,2]','[{11020001,10}]',3),(1003,5,1,100,'[{1,615},{2,12529},{5,301},{6,301}]','[1,3]','[{11020001,10}]',3),(1004,5,1,100,'[{1,815},{2,16619},{5,401},{6,401}]','[1,3]','[{11020001,10}]',3),(1005,5,1,100,'[{1,697},{2,14206},{5,342},{6,342}]','[1,2]','[{11020001,10}]',3),(1006,5,1,120,'[{1,992},{2,20066},{5,490},{6,490}]','[1,4]','[{11020001,10}]',3),(1001,5,2,100,'[{1,301},{2,6234},{5,145},{6,145}]','[2,39]','[{11020001,10}]',3),(1002,5,2,100,'[{1,456},{2,9381},{5,220},{6,220}]','[2,47]','[{11020001,10}]',3),(1003,5,2,100,'[{1,640},{2,13039},{5,313},{6,313}]','[2,54]','[{11020001,10}]',3),(1004,5,2,100,'[{1,844},{2,17215},{5,415},{6,415}]','[2,62]','[{11020001,10}]',3),(1005,5,2,100,'[{1,723},{2,14741},{5,355},{6,355}]','[2,51]','[{11020001,10}]',3),(1006,5,2,120,'[{1,1023},{2,20705},{5,505},{6,505}]','[2,75]','[{11020001,10}]',3),(1001,5,3,100,'[{1,318},{2,6580},{5,153},{6,153}]','[1,2]','[{11020001,10}]',3),(1002,5,3,100,'[{1,477},{2,9817},{5,230},{6,230}]','[1,2]','[{11020001,10}]',3),(1003,5,3,100,'[{1,666},{2,13569},{5,326},{6,326}]','[1,3]','[{11020001,10}]',3),(1004,5,3,100,'[{1,875},{2,17835},{5,430},{6,430}]','[1,3]','[{11020001,10}]',3),(1005,5,3,100,'[{1,750},{2,15297},{5,368},{6,368}]','[1,3]','[{11020001,10}]',3),(1006,5,3,120,'[{1,1056},{2,21370},{5,521},{6,521}]','[1,4]','[{11020001,10}]',3),(1001,5,4,100,'[{1,335},{2,6938},{5,161},{6,161}]','[2,41]','[{11020001,10}]',3),(1002,5,4,100,'[{1,499},{2,10269},{5,241},{6,241}]','[2,47]','[{11020001,10}]',3),(1003,5,4,100,'[{1,693},{2,14119},{5,339},{6,339}]','[2,57]','[{11020001,10}]',3),(1004,5,4,100,'[{1,907},{2,18479},{5,446},{6,446}]','[2,65]','[{11020001,10}]',3),(1005,5,4,100,'[{1,778},{2,15875},{5,382},{6,382}]','[2,52]','[{11020001,10}]',3),(1006,5,4,120,'[{1,1090},{2,22062},{5,538},{6,538}]','[2,76]','[{11020001,10}]',3),(1001,5,5,100,'[{1,353},{2,7309},{5,170},{6,170}]','[1,2]','[{11020001,10}]',3),(1002,5,5,100,'[{1,522},{2,10738},{5,252},{6,252}]','[1,3]','[{11020001,10}]',3),(1003,5,5,100,'[{1,721},{2,14689},{5,353},{6,353}]','[1,3]','[{11020001,10}]',3),(1004,5,5,100,'[{1,940},{2,19146},{5,462},{6,462}]','[1,3]','[{11020001,10}]',3),(1005,5,5,100,'[{1,807},{2,16474},{5,396},{6,396}]','[1,3]','[{11020001,10}]',3),(1006,5,5,120,'[{1,1125},{2,22780},{5,555},{6,555}]','[1,4]','[{11020001,10}]',3),(1001,6,0,130,'[{1,372},{2,7698},{5,179},{6,179}]','[2,42]','[{11020001,10}]',3),(1002,6,0,130,'[{1,546},{2,11231},{5,264},{6,264}]','[2,52]','[{11020001,10}]',3),(1003,6,0,130,'[{1,751},{2,15289},{5,368},{6,368}]','[2,60]','[{11020001,10}]',3),(1004,6,0,130,'[{1,975},{2,19849},{5,479},{6,479}]','[2,69]','[{11020001,10}]',3),(1005,6,0,130,'[{1,838},{2,17105},{5,411},{6,411}]','[2,57]','[{11020001,10}]',3),(1006,6,0,150,'[{1,1162},{2,23537},{5,573},{6,573}]','[2,82]','[{11020001,10}]',3),(1001,6,1,130,'[{1,392},{2,8100},{5,189},{6,189}]','[1,2]','[{11020001,10}]',3),(1002,6,1,130,'[{1,571},{2,11740},{5,276},{6,276}]','[1,3]','[{11020001,10}]',3),(1003,6,1,130,'[{1,782},{2,15909},{5,383},{6,383}]','[1,3]','[{11020001,10}]',3),(1004,6,1,130,'[{1,1011},{2,20576},{5,497},{6,497}]','[1,3]','[{11020001,10}]',3),(1005,6,1,130,'[{1,870},{2,17757},{5,427},{6,427}]','[1,3]','[{11020001,10}]',3),(1006,6,1,150,'[{1,1201},{2,24321},{5,592},{6,592}]','[1,4]','[{11020001,10}]',3),(1001,6,2,130,'[{1,412},{2,8514},{5,199},{6,199}]','[2,44]','[{11020001,10}]',3),(1002,6,2,130,'[{1,597},{2,12265},{5,289},{6,289}]','[2,54]','[{11020001,10}]',3),(1003,6,2,130,'[{1,814},{2,16549},{5,399},{6,399}]','[2,62]','[{11020001,10}]',3),(1004,6,2,130,'[{1,1048},{2,21326},{5,515},{6,515}]','[2,70]','[{11020001,10}]',3),(1005,6,2,130,'[{1,903},{2,18430},{5,443},{6,443}]','[2,59]','[{11020001,10}]',3),(1006,6,2,150,'[{1,1241},{2,25131},{5,612},{6,612}]','[2,83]','[{11020001,10}]',3),(1001,6,3,130,'[{1,433},{2,8941},{5,209},{6,209}]','[1,2]','[{11020001,10}]',3),(1002,6,3,130,'[{1,624},{2,12807},{5,302},{6,302}]','[1,3]','[{11020001,10}]',3),(1003,6,3,130,'[{1,847},{2,17209},{5,415},{6,415}]','[1,3]','[{11020001,10}]',3),(1004,6,3,130,'[{1,1086},{2,22100},{5,534},{6,534}]','[1,4]','[{11020001,10}]',3),(1005,6,3,130,'[{1,937},{2,19124},{5,460},{6,460}]','[1,3]','[{11020001,10}]',3),(1006,6,3,150,'[{1,1282},{2,25967},{5,632},{6,632}]','[1,4]','[{11020001,10}]',3),(1001,6,4,130,'[{1,455},{2,9380},{5,220},{6,220}]','[2,46]','[{11020001,10}]',3),(1002,6,4,130,'[{1,651},{2,13365},{5,315},{6,315}]','[2,55]','[{11020001,10}]',3),(1003,6,4,130,'[{1,881},{2,17889},{5,432},{6,432}]','[2,65]','[{11020001,10}]',3),(1004,6,4,130,'[{1,1125},{2,22898},{5,553},{6,553}]','[2,73]','[{11020001,10}]',3),(1005,6,4,130,'[{1,972},{2,19840},{5,477},{6,477}]','[2,60]','[{11020001,10}]',3),(1006,6,4,150,'[{1,1325},{2,26829},{5,653},{6,653}]','[2,88]','[{11020001,10}]',3),(1001,6,5,130,'[{1,477},{2,9832},{5,231},{6,231}]','[1,2]','[{11020001,10}]',3),(1002,6,5,130,'[{1,679},{2,13939},{5,329},{6,329}]','[1,3]','[{11020001,10}]',3),(1003,6,5,130,'[{1,916},{2,18589},{5,449},{6,449}]','[1,3]','[{11020001,10}]',3),(1004,6,5,130,'[{1,1166},{2,23720},{5,573},{6,573}]','[1,4]','[{11020001,10}]',3),(1005,6,5,130,'[{1,1008},{2,20577},{5,495},{6,495}]','[1,3]','[{11020001,10}]',3),(1006,6,5,150,'[{1,1369},{2,27718},{5,675},{6,675}]','[1,5]','[{11020001,10}]',3),(1001,7,0,150,'[{1,500},{2,10305},{5,242},{6,242}]','[2,49]','[{11020001,10}]',3),(1002,7,0,150,'[{1,709},{2,14540},{5,344},{6,344}]','[2,59]','[{11020001,10}]',3),(1003,7,0,150,'[{1,952},{2,19322},{5,467},{6,467}]','[2,68]','[{11020001,10}]',3),(1004,7,0,150,'[{1,1209},{2,24581},{5,594},{6,594}]','[2,78]','[{11020001,10}]',3),(1005,7,0,150,'[{1,1046},{2,21349},{5,514},{6,514}]','[2,64]','[{11020001,10}]',3),(1006,7,0,210,'[{1,1415},{2,28650},{5,698},{6,698}]','[2,93]','[{11020001,10}]',3),(1001,7,1,150,'[{1,524},{2,10790},{5,254},{6,254}]','[1,2]','[{11020001,10}]',3),(1002,7,1,150,'[{1,739},{2,15158},{5,359},{6,359}]','[1,3]','[{11020001,10}]',3),(1003,7,1,150,'[{1,989},{2,20075},{5,485},{6,485}]','[1,3]','[{11020001,10}]',3),(1004,7,1,150,'[{1,1253},{2,25466},{5,616},{6,616}]','[1,4]','[{11020001,10}]',3),(1005,7,1,150,'[{1,1085},{2,22143},{5,533},{6,533}]','[1,3]','[{11020001,10}]',3),(1006,7,1,210,'[{1,1462},{2,29609},{5,721},{6,721}]','[1,5]','[{11020001,10}]',3),(1001,7,2,150,'[{1,548},{2,11288},{5,266},{6,266}]','[2,51]','[{11020001,10}]',3),(1002,7,2,150,'[{1,770},{2,15792},{5,374},{6,374}]','[2,60]','[{11020001,10}]',3),(1003,7,2,150,'[{1,1027},{2,20848},{5,504},{6,504}]','[2,72]','[{11020001,10}]',3),(1004,7,2,150,'[{1,1298},{2,26375},{5,638},{6,638}]','[2,81]','[{11020001,10}]',3),(1005,7,2,150,'[{1,1125},{2,22958},{5,553},{6,553}]','[2,65]','[{11020001,10}]',3),(1006,7,2,210,'[{1,1511},{2,30594},{5,745},{6,745}]','[2,96]','[{11020001,10}]',3),(1001,7,3,150,'[{1,573},{2,11798},{5,278},{6,278}]','[1,3]','[{11020001,10}]',3),(1002,7,3,150,'[{1,802},{2,16442},{5,390},{6,390}]','[1,3]','[{11020001,10}]',3),(1003,7,3,150,'[{1,1066},{2,21641},{5,523},{6,523}]','[1,4]','[{11020001,10}]',3),(1004,7,3,150,'[{1,1344},{2,27307},{5,661},{6,661}]','[1,4]','[{11020001,10}]',3),(1005,7,3,150,'[{1,1166},{2,23794},{5,573},{6,573}]','[1,3]','[{11020001,10}]',3),(1006,7,3,210,'[{1,1561},{2,31605},{5,770},{6,770}]','[1,5]','[{11020001,10}]',3),(1001,7,4,150,'[{1,599},{2,12321},{5,291},{6,291}]','[2,52]','[{11020001,10}]',3),(1002,7,4,150,'[{1,835},{2,17108},{5,406},{6,406}]','[2,62]','[{11020001,10}]',3),(1003,7,4,150,'[{1,1106},{2,22454},{5,543},{6,543}]','[2,73]','[{11020001,10}]',3),(1004,7,4,150,'[{1,1391},{2,28263},{5,684},{6,684}]','[2,83]','[{11020001,10}]',3),(1005,7,4,150,'[{1,1208},{2,24651},{5,594},{6,594}]','[2,69]','[{11020001,10}]',3),(1006,7,4,210,'[{1,1612},{2,32642},{5,795},{6,795}]','[2,99]','[{11020001,10}]',3),(1001,7,5,150,'[{1,625},{2,12856},{5,304},{6,304}]','[1,3]','[{11020001,10}]',3),(1002,7,5,150,'[{1,869},{2,17791},{5,423},{6,423}]','[1,3]','[{11020001,10}]',3),(1003,7,5,150,'[{1,1147},{2,23287},{5,563},{6,563}]','[1,4]','[{11020001,10}]',3),(1004,7,5,150,'[{1,1440},{2,29243},{5,708},{6,708}]','[1,4]','[{11020001,10}]',3),(1005,7,5,150,'[{1,1251},{2,25530},{5,615},{6,615}]','[1,4]','[{11020001,10}]',3),(1006,7,5,210,'[{1,1665},{2,33706},{5,821},{6,821}]','[1,5]','[{11020001,10}]',3),(1001,8,0,200,'[{1,653},{2,13416},{5,318},{6,318}]','[2,55]','[{11020001,10}]',3),(1002,8,0,200,'[{1,904},{2,18506},{5,440},{6,440}]','[2,65]','[{11020001,10}]',3),(1003,8,0,200,'[{1,1190},{2,24160},{5,584},{6,584}]','[2,78]','[{11020001,10}]',3),(1004,8,0,200,'[{1,1491},{2,30270},{5,733},{6,733}]','[2,88]','[{11020001,10}]',3),(1005,8,0,200,'[{1,1297},{2,26451},{5,638},{6,638}]','[2,72]','[{11020001,10}]',3),(1006,8,0,280,'[{1,1720},{2,34822},{5,848},{6,848}]','[2,106]','[{11020001,10}]',3),(1001,8,1,200,'[{1,681},{2,13993},{5,332},{6,332}]','[1,3]','[{11020001,10}]',3),(1002,8,1,200,'[{1,940},{2,19243},{5,458},{6,458}]','[1,3]','[{11020001,10}]',3),(1003,8,1,200,'[{1,1235},{2,25060},{5,606},{6,606}]','[1,4]','[{11020001,10}]',3),(1004,8,1,200,'[{1,1543},{2,31329},{5,759},{6,759}]','[1,5]','[{11020001,10}]',3),(1005,8,1,200,'[{1,1344},{2,27400},{5,661},{6,661}]','[1,4]','[{11020001,10}]',3),(1006,8,1,280,'[{1,1777},{2,35973},{5,876},{6,876}]','[1,5]','[{11020001,10}]',3),(1001,8,2,200,'[{1,710},{2,14587},{5,346},{6,346}]','[2,57]','[{11020001,10}]',3),(1002,8,2,200,'[{1,977},{2,20001},{5,476},{6,476}]','[2,70]','[{11020001,10}]',3),(1003,8,2,200,'[{1,1281},{2,25987},{5,629},{6,629}]','[2,80]','[{11020001,10}]',3),(1004,8,2,200,'[{1,1597},{2,32420},{5,786},{6,786}]','[2,93]','[{11020001,10}]',3),(1005,8,2,200,'[{1,1392},{2,28378},{5,685},{6,685}]','[2,75]','[{11020001,10}]',3),(1006,8,2,280,'[{1,1836},{2,37159},{5,905},{6,905}]','[2,109]','[{11020001,10}]',3),(1001,8,3,200,'[{1,740},{2,15197},{5,361},{6,361}]','[1,3]','[{11020001,10}]',3),(1002,8,3,200,'[{1,1016},{2,20781},{5,495},{6,495}]','[1,3]','[{11020001,10}]',3),(1003,8,3,200,'[{1,1328},{2,26940},{5,652},{6,652}]','[1,4]','[{11020001,10}]',3),(1004,8,3,200,'[{1,1653},{2,33542},{5,814},{6,814}]','[1,5]','[{11020001,10}]',3),(1005,8,3,200,'[{1,1442},{2,29384},{5,710},{6,710}]','[1,4]','[{11020001,10}]',3),(1006,8,3,280,'[{1,1897},{2,38380},{5,935},{6,935}]','[1,6]','[{11020001,10}]',3),(1001,8,4,200,'[{1,771},{2,15824},{5,376},{6,376}]','[2,59]','[{11020001,10}]',3),(1002,8,4,200,'[{1,1056},{2,21583},{5,515},{6,515}]','[2,70]','[{11020001,10}]',3),(1003,8,4,200,'[{1,1377},{2,27920},{5,676},{6,676}]','[2,83]','[{11020001,10}]',3),(1004,8,4,200,'[{1,1710},{2,34696},{5,842},{6,842}]','[2,94]','[{11020001,10}]',3),(1005,8,4,200,'[{1,1493},{2,30418},{5,735},{6,735}]','[2,77]','[{11020001,10}]',3),(1006,8,4,280,'[{1,1959},{2,39636},{5,966},{6,966}]','[2,112]','[{11020001,10}]',3),(1001,8,5,200,'[{1,803},{2,16468},{5,392},{6,392}]','[1,3]','[{11020001,10}]',3),(1002,8,5,200,'[{1,1097},{2,22406},{5,535},{6,535}]','[1,4]','[{11020001,10}]',3),(1003,8,5,200,'[{1,1427},{2,28927},{5,701},{6,701}]','[1,4]','[{11020001,10}]',3),(1004,8,5,200,'[{1,1769},{2,35882},{5,871},{6,871}]','[1,5]','[{11020001,10}]',3),(1005,8,5,200,'[{1,1546},{2,31481},{5,761},{6,761}]','[1,4]','[{11020001,10}]',3),(1006,8,5,280,'[{1,2023},{2,40927},{5,998},{6,998}]','[1,6]','[{11020001,10}]',3),(1001,9,0,280,'[{1,836},{2,17137},{5,408},{6,408}]','[2,62]','[{11020002,20}]',3),(1002,9,0,280,'[{1,1139},{2,23262},{5,556},{6,556}]','[2,73]','[{11020002,20}]',3),(1003,9,0,280,'[{1,1479},{2,29974},{5,727},{6,727}]','[2,87]','[{11020002,20}]',3),(1004,9,0,280,'[{1,1830},{2,37115},{5,901},{6,901}]','[2,99]','[{11020002,20}]',3),(1005,9,0,280,'[{1,1601},{2,32586},{5,788},{6,788}]','[2,82]','[{11020002,20}]',3),(1006,9,0,390,'[{1,2090},{2,42271},{5,1031},{6,1031}]','[2,118]','[{11020002,20}]',3),(1001,9,1,280,'[{1,870},{2,17822},{5,425},{6,425}]','[1,3]','[{11020002,20}]',3),(1002,9,1,280,'[{1,1182},{2,24140},{5,577},{6,577}]','[1,4]','[{11020002,20}]',3),(1003,9,1,280,'[{1,1532},{2,31047},{5,753},{6,753}]','[1,4]','[{11020002,20}]',3),(1004,9,1,280,'[{1,1893},{2,38380},{5,932},{6,932}]','[1,5]','[{11020002,20}]',3),(1005,9,1,280,'[{1,1657},{2,33720},{5,816},{6,816}]','[1,4]','[{11020002,20}]',3),(1006,9,1,390,'[{1,2158},{2,43650},{5,1065},{6,1065}]','[1,6]','[{11020002,20}]',3),(1001,9,2,280,'[{1,905},{2,18524},{5,442},{6,442}]','[2,65]','[{11020002,20}]',3),(1002,9,2,280,'[{1,1226},{2,25039},{5,599},{6,599}]','[2,76]','[{11020002,20}]',3),(1003,9,2,280,'[{1,1587},{2,32147},{5,780},{6,780}]','[2,89]','[{11020002,20}]',3),(1004,9,2,280,'[{1,1957},{2,39677},{5,964},{6,964}]','[2,101]','[{11020002,20}]',3),(1005,9,2,280,'[{1,1715},{2,34882},{5,845},{6,845}]','[2,83]','[{11020002,20}]',3),(1006,9,2,390,'[{1,2228},{2,45064},{5,1100},{6,1100}]','[2,122]','[{11020002,20}]',3),(1001,9,3,280,'[{1,940},{2,19243},{5,459},{6,459}]','[1,3]','[{11020002,20}]',3),(1002,9,3,280,'[{1,1272},{2,25960},{5,622},{6,622}]','[1,4]','[{11020002,20}]',3),(1003,9,3,280,'[{1,1643},{2,33274},{5,808},{6,808}]','[1,5]','[{11020002,20}]',3),(1004,9,3,280,'[{1,2023},{2,41005},{5,997},{6,997}]','[1,5]','[{11020002,20}]',3),(1005,9,3,280,'[{1,1774},{2,36072},{5,874},{6,874}]','[1,4]','[{11020002,20}]',3),(1006,9,3,390,'[{1,2300},{2,46513},{5,1136},{6,1136}]','[1,6]','[{11020002,20}]',3),(1001,9,4,280,'[{1,976},{2,19978},{5,477},{6,477}]','[2,65]','[{11020002,20}]',3),(1002,9,4,280,'[{1,1319},{2,26903},{5,645},{6,645}]','[2,80]','[{11020002,20}]',3),(1003,9,4,280,'[{1,1700},{2,34427},{5,836},{6,836}]','[2,93]','[{11020002,20}]',3),(1004,9,4,280,'[{1,2091},{2,42365},{5,1031},{6,1031}]','[2,106]','[{11020002,20}]',3),(1005,9,4,280,'[{1,1834},{2,37291},{5,904},{6,904}]','[2,85]','[{11020002,20}]',3),(1006,9,4,390,'[{1,2374},{2,47997},{5,1173},{6,1173}]','[2,124]','[{11020002,20}]',3),(1001,9,5,280,'[{1,1013},{2,20730},{5,495},{6,495}]','[1,3]','[{11020002,20}]',3),(1002,9,5,280,'[{1,1367},{2,27867},{5,669},{6,669}]','[1,4]','[{11020002,20}]',3),(1003,9,5,280,'[{1,1759},{2,35607},{5,865},{6,865}]','[1,5]','[{11020002,20}]',3),(1004,9,5,280,'[{1,2160},{2,43757},{5,1065},{6,1065}]','[1,5]','[{11020002,20}]',3),(1005,9,5,280,'[{1,1896},{2,38538},{5,935},{6,935}]','[1,4]','[{11020002,20}]',3),(1006,9,5,390,'[{1,2449},{2,49516},{5,1210},{6,1210}]','[1,6]','[{11020002,20}]',3),(1001,10,0,360,'[{1,1052},{2,21515},{5,514},{6,514}]','[2,70]','[{11020002,20}]',3),(1002,10,0,360,'[{1,1417},{2,28875},{5,694},{6,694}]','[2,85]','[{11020002,20}]',3),(1003,10,0,360,'[{1,1820},{2,36840},{5,895},{6,895}]','[2,96]','[{11020002,20}]',3),(1004,10,0,360,'[{1,2232},{2,45212},{5,1101},{6,1101}]','[2,111]','[{11020002,20}]',3),(1005,10,0,360,'[{1,1961},{2,39842},{5,967},{6,967}]','[2,90]','[{11020002,20}]',3),(1006,10,0,500,'[{1,2528},{2,51105},{5,1249},{6,1249}]','[2,132]','[{11020002,20}]',3),(1001,10,1,360,'[{1,1092},{2,22321},{5,534},{6,534}]','[1,4]','[{11020002,20}]',3),(1002,10,1,360,'[{1,1468},{2,29910},{5,719},{6,719}]','[1,4]','[{11020002,20}]',3),(1003,10,1,360,'[{1,1883},{2,38107},{5,926},{6,926}]','[1,5]','[{11020002,20}]',3),(1004,10,1,360,'[{1,2306},{2,46707},{5,1138},{6,1138}]','[1,6]','[{11020002,20}]',3),(1005,10,1,360,'[{1,2027},{2,41181},{5,1000},{6,1000}]','[1,5]','[{11020002,20}]',3),(1006,10,1,500,'[{1,2609},{2,52737},{5,1289},{6,1289}]','[1,7]','[{11020002,20}]',3),(1001,10,2,360,'[{1,1133},{2,23148},{5,554},{6,554}]','[2,72]','[{11020002,20}]',3),(1002,10,2,360,'[{1,1521},{2,30972},{5,745},{6,745}]','[2,87]','[{11020002,20}]',3),(1003,10,2,360,'[{1,1948},{2,39407},{5,958},{6,958}]','[2,101]','[{11020002,20}]',3),(1004,10,2,360,'[{1,2382},{2,48241},{5,1176},{6,1176}]','[2,114]','[{11020002,20}]',3),(1005,10,2,360,'[{1,2095},{2,42555},{5,1034},{6,1034}]','[2,95]','[{11020002,20}]',3),(1006,10,2,500,'[{1,2692},{2,54413},{5,1330},{6,1330}]','[2,137]','[{11020002,20}]',3),(1001,10,3,360,'[{1,1175},{2,23996},{5,575},{6,575}]','[1,4]','[{11020002,20}]',3),(1002,10,3,360,'[{1,1575},{2,32061},{5,772},{6,772}]','[1,4]','[{11020002,20}]',3),(1003,10,3,360,'[{1,2014},{2,40740},{5,991},{6,991}]','[1,5]','[{11020002,20}]',3),(1004,10,3,360,'[{1,2460},{2,49815},{5,1215},{6,1215}]','[1,6]','[{11020002,20}]',3),(1005,10,3,360,'[{1,2165},{2,43965},{5,1069},{6,1069}]','[1,5]','[{11020002,20}]',3),(1006,10,3,500,'[{1,2778},{2,56133},{5,1373},{6,1373}]','[1,7]','[{11020002,20}]',3),(1001,10,4,360,'[{1,1218},{2,24865},{5,596},{6,596}]','[2,75]','[{11020002,20}]',3),(1002,10,4,360,'[{1,1630},{2,33177},{5,799},{6,799}]','[2,89]','[{11020002,20}]',3),(1003,10,4,360,'[{1,2082},{2,42107},{5,1025},{6,1025}]','[2,105]','[{11020002,20}]',3),(1004,10,4,360,'[{1,2540},{2,51428},{5,1255},{6,1255}]','[2,119]','[{11020002,20}]',3),(1005,10,4,360,'[{1,2237},{2,45410},{5,1105},{6,1105}]','[2,98]','[{11020002,20}]',3),(1006,10,4,500,'[{1,2866},{2,57897},{5,1417},{6,1417}]','[2,142]','[{11020002,20}]',3),(1001,10,5,360,'[{1,1262},{2,25754},{5,618},{6,618}]','[1,4]','[{11020002,20}]',3),(1002,10,5,360,'[{1,1687},{2,34320},{5,827},{6,827}]','[1,5]','[{11020002,20}]',3),(1003,10,5,360,'[{1,2152},{2,43507},{5,1060},{6,1060}]','[1,5]','[{11020002,20}]',3),(1004,10,5,360,'[{1,2622},{2,53081},{5,1296},{6,1296}]','[1,6]','[{11020002,20}]',3),(1005,10,5,360,'[{1,2311},{2,46891},{5,1142},{6,1142}]','[1,5]','[{11020002,20}]',3),(1006,10,5,500,'[{1,2956},{2,59704},{5,1462},{6,1462}]','[1,7]','[{11020002,20}]',3),(1001,11,0,480,'[{1,1308},{2,26677},{5,641},{6,641}]','[2,78]','[{11020002,20}]',3),(1002,11,0,480,'[{1,1746},{2,35506},{5,856},{6,856}]','[2,94]','[{11020002,20}]',3),(1003,11,0,480,'[{1,2224},{2,44960},{5,1096},{6,1096}]','[2,111]','[{11020002,20}]',3),(1004,11,0,480,'[{1,2707},{2,54797},{5,1338},{6,1338}]','[2,126]','[{11020002,20}]',3),(1005,11,0,480,'[{1,2387},{2,48428},{5,1180},{6,1180}]','[2,101]','[{11020002,20}]',3),(1006,11,0,620,'[{1,3049},{2,61581},{5,1508},{6,1508}]','[2,150]','[{11020002,20}]',3),(1001,11,1,480,'[{1,1355},{2,27621},{5,664},{6,664}]','[1,4]','[{11020002,20}]',3),(1002,11,1,480,'[{1,1806},{2,36719},{5,886},{6,886}]','[1,5]','[{11020002,20}]',3),(1003,11,1,480,'[{1,2298},{2,46447},{5,1133},{6,1133}]','[1,6]','[{11020002,20}]',3),(1004,11,1,480,'[{1,2794},{2,56553},{5,1381},{6,1381}]','[1,6]','[{11020002,20}]',3),(1005,11,1,480,'[{1,2465},{2,50001},{5,1219},{6,1219}]','[1,5]','[{11020002,20}]',3),(1006,11,1,620,'[{1,3145},{2,63502},{5,1556},{6,1556}]','[1,8]','[{11020002,20}]',3),(1001,11,2,480,'[{1,1403},{2,28585},{5,688},{6,688}]','[2,80]','[{11020002,20}]',3),(1002,11,2,480,'[{1,1868},{2,37959},{5,917},{6,917}]','[2,98]','[{11020002,20}]',3),(1003,11,2,480,'[{1,2374},{2,47967},{5,1171},{6,1171}]','[2,112]','[{11020002,20}]',3),(1004,11,2,480,'[{1,2883},{2,58348},{5,1425},{6,1425}]','[2,129]','[{11020002,20}]',3),(1005,11,2,480,'[{1,2545},{2,51609},{5,1259},{6,1259}]','[2,104]','[{11020002,20}]',3),(1006,11,2,620,'[{1,3243},{2,65467},{5,1605},{6,1605}]','[2,153]','[{11020002,20}]',3),(1001,11,3,480,'[{1,1452},{2,29570},{5,712},{6,712}]','[1,4]','[{11020002,20}]',3),(1002,11,3,480,'[{1,1931},{2,39227},{5,948},{6,948}]','[1,5]','[{11020002,20}]',3),(1003,11,3,480,'[{1,2451},{2,49520},{5,1209},{6,1209}]','[1,6]','[{11020002,20}]',3),(1004,11,3,480,'[{1,2974},{2,60183},{5,1470},{6,1470}]','[1,7]','[{11020002,20}]',3),(1005,11,3,480,'[{1,2627},{2,53253},{5,1300},{6,1300}]','[1,5]','[{11020002,20}]',3),(1006,11,3,620,'[{1,3343},{2,67476},{5,1655},{6,1655}]','[1,8]','[{11020002,20}]',3),(1001,11,4,480,'[{1,1502},{2,30576},{5,737},{6,737}]','[2,83]','[{11020002,20}]',3),(1002,11,4,480,'[{1,1995},{2,40522},{5,980},{6,980}]','[2,99]','[{11020002,20}]',3),(1003,11,4,480,'[{1,2530},{2,51107},{5,1248},{6,1248}]','[2,117]','[{11020002,20}]',3),(1004,11,4,480,'[{1,3067},{2,62058},{5,1516},{6,1516}]','[2,133]','[{11020002,20}]',3),(1005,11,4,480,'[{1,2710},{2,54932},{5,1341},{6,1341}]','[2,107]','[{11020002,20}]',3),(1006,11,4,620,'[{1,3445},{2,69528},{5,1706},{6,1706}]','[2,158]','[{11020002,20}]',3),(1001,11,5,480,'[{1,1553},{2,31603},{5,762},{6,762}]','[1,4]','[{11020002,20}]',3),(1002,11,5,480,'[{1,2061},{2,41844},{5,1013},{6,1013}]','[1,5]','[{11020002,20}]',3),(1003,11,5,480,'[{1,2611},{2,52727},{5,1288},{6,1288}]','[1,6]','[{11020002,20}]',3),(1004,11,5,480,'[{1,3162},{2,63972},{5,1563},{6,1563}]','[1,7]','[{11020002,20}]',3),(1005,11,5,480,'[{1,2795},{2,56646},{5,1383},{6,1383}]','[1,6]','[{11020002,20}]',3),(1006,11,5,620,'[{1,3549},{2,71624},{5,1758},{6,1758}]','[1,8]','[{11020002,20}]',3),(1001,12,0,600,'[{1,1606},{2,32663},{5,788},{6,788}]','[2,88]','[{11020002,20}]',3),(1002,12,0,600,'[{1,2129},{2,43209},{5,1047},{6,1047}]','[2,104]','[{11020002,20}]',3),(1003,12,0,600,'[{1,2694},{2,54400},{5,1329},{6,1329}]','[2,122]','[{11020002,20}]',3),(1004,12,0,600,'[{1,3260},{2,65949},{5,1612},{6,1612}]','[2,139]','[{11020002,20}]',3),(1005,12,0,600,'[{1,2883},{2,58417},{5,1427},{6,1427}]','[2,112]','[{11020002,20}]',3),(1006,12,0,780,'[{1,3657},{2,73790},{5,1812},{6,1812}]','[2,166]','[{11020002,20}]',3),(1001,12,1,600,'[{1,1660},{2,33744},{5,815},{6,815}]','[1,4]','[{11020002,20}]',3),(1002,12,1,600,'[{1,2198},{2,44601},{5,1081},{6,1081}]','[1,5]','[{11020002,20}]',3),(1003,12,1,600,'[{1,2779},{2,56107},{5,1371},{6,1371}]','[1,6]','[{11020002,20}]',3),(1004,12,1,600,'[{1,3360},{2,67966},{5,1662},{6,1662}]','[1,7]','[{11020002,20}]',3),(1005,12,1,600,'[{1,2973},{2,60223},{5,1472},{6,1472}]','[1,6]','[{11020002,20}]',3),(1006,12,1,780,'[{1,3767},{2,76000},{5,1867},{6,1867}]','[1,8]','[{11020002,20}]',3),(1001,12,2,600,'[{1,1715},{2,34846},{5,842},{6,842}]','[2,89]','[{11020002,20}]',3),(1002,12,2,600,'[{1,2268},{2,46020},{5,1116},{6,1116}]','[2,108]','[{11020002,20}]',3),(1003,12,2,600,'[{1,2866},{2,57847},{5,1414},{6,1414}]','[2,125]','[{11020002,20}]',3),(1004,12,2,600,'[{1,3462},{2,70023},{5,1713},{6,1713}]','[2,143]','[{11020002,20}]',3),(1005,12,2,600,'[{1,3065},{2,62065},{5,1518},{6,1518}]','[2,116]','[{11020002,20}]',3),(1006,12,2,780,'[{1,3879},{2,78254},{5,1923},{6,1923}]','[2,171]','[{11020002,20}]',3),(1001,12,3,600,'[{1,1771},{2,35969},{5,870},{6,870}]','[1,5]','[{11020002,20}]',3),(1002,12,3,600,'[{1,2340},{2,47466},{5,1152},{6,1152}]','[1,5]','[{11020002,20}]',3),(1003,12,3,600,'[{1,2954},{2,59620},{5,1458},{6,1458}]','[1,6]','[{11020002,20}]',3),(1004,12,3,600,'[{1,3566},{2,72119},{5,1765},{6,1765}]','[1,7]','[{11020002,20}]',3),(1005,12,3,600,'[{1,3158},{2,63942},{5,1564},{6,1564}]','[1,6]','[{11020002,20}]',3),(1006,12,3,780,'[{1,3993},{2,80551},{5,1980},{6,1980}]','[1,9]','[{11020002,20}]',3),(1001,12,4,600,'[{1,1828},{2,37113},{5,898},{6,898}]','[2,93]','[{11020002,20}]',3),(1002,12,4,600,'[{1,2413},{2,48939},{5,1188},{6,1188}]','[2,111]','[{11020002,20}]',3),(1003,12,4,600,'[{1,3044},{2,61427},{5,1503},{6,1503}]','[2,129]','[{11020002,20}]',3),(1004,12,4,600,'[{1,3672},{2,74255},{5,1818},{6,1818}]','[2,147]','[{11020002,20}]',3),(1005,12,4,600,'[{1,3253},{2,65855},{5,1611},{6,1611}]','[2,119]','[{11020002,20}]',3),(1006,12,4,780,'[{1,4110},{2,82892},{5,2038},{6,2038}]','[2,174]','[{11020002,20}]',3),(1001,12,5,600,'[{1,1886},{2,38277},{5,927},{6,927}]','[1,5]','[{11020002,20}]',3),(1002,12,5,600,'[{1,2488},{2,50439},{5,1225},{6,1225}]','[1,6]','[{11020002,20}]',3),(1003,12,5,600,'[{1,3136},{2,63267},{5,1548},{6,1548}]','[1,7]','[{11020002,20}]',3),(1004,12,5,600,'[{1,3780},{2,76430},{5,1872},{6,1872}]','[1,8]','[{11020002,20}]',3),(1005,12,5,600,'[{1,3350},{2,67803},{5,1659},{6,1659}]','[1,6]','[{11020002,20}]',3),(1006,12,5,780,'[{1,4229},{2,85277},{5,2097},{6,2097}]','[1,9]','[{11020002,20}]',3),(1001,13,0,760,'[{1,1945},{2,39475},{5,956},{6,956}]','[2,96]','[{11020002,20}]',3),(1002,13,0,760,'[{1,2565},{2,51983},{5,1263},{6,1263}]','[2,116]','[{11020002,20}]',3),(1003,13,0,760,'[{1,3230},{2,65160},{5,1595},{6,1595}]','[2,134]','[{11020002,20}]',3),(1004,13,0,760,'[{1,3891},{2,78669},{5,1928},{6,1928}]','[2,155]','[{11020002,20}]',3),(1005,13,0,760,'[{1,3450},{2,69808},{5,1709},{6,1709}]','[2,125]','[{11020002,20}]',3),(1006,13,0,950,'[{1,4351},{2,87732},{5,2158},{6,2158}]','[2,182]','[{11020002,20}]',3),(1001,13,1,760,'[{1,2005},{2,40694},{5,986},{6,986}]','[1,5]','[{11020002,20}]',3),(1002,13,1,760,'[{1,2643},{2,53554},{5,1302},{6,1302}]','[1,6]','[{11020002,20}]',3),(1003,13,1,760,'[{1,3326},{2,67087},{5,1643},{6,1643}]','[1,7]','[{11020002,20}]',3),(1004,13,1,760,'[{1,4004},{2,80947},{5,1984},{6,1984}]','[1,8]','[{11020002,20}]',3),(1005,13,1,760,'[{1,3552},{2,71848},{5,1759},{6,1759}]','[1,6]','[{11020002,20}]',3),(1006,13,1,950,'[{1,4475},{2,90231},{5,2220},{6,2220}]','[1,9]','[{11020002,20}]',3),(1001,13,2,760,'[{1,2067},{2,41933},{5,1017},{6,1017}]','[2,98]','[{11020002,20}]',3),(1002,13,2,760,'[{1,2722},{2,55152},{5,1341},{6,1341}]','[2,117]','[{11020002,20}]',3),(1003,13,2,760,'[{1,3424},{2,69047},{5,1691},{6,1691}]','[2,137]','[{11020002,20}]',3),(1004,13,2,760,'[{1,4119},{2,83265},{5,2041},{6,2041}]','[2,156]','[{11020002,20}]',3),(1005,13,2,760,'[{1,3655},{2,73924},{5,1810},{6,1810}]','[2,127]','[{11020002,20}]',3),(1006,13,2,950,'[{1,4602},{2,92773},{5,2283},{6,2283}]','[2,186]','[{11020002,20}]',3),(1001,13,3,760,'[{1,2130},{2,43193},{5,1048},{6,1048}]','[1,5]','[{11020002,20}]',3),(1002,13,3,760,'[{1,2803},{2,56777},{5,1381},{6,1381}]','[1,6]','[{11020002,20}]',3),(1003,13,3,760,'[{1,3523},{2,71040},{5,1740},{6,1740}]','[1,7]','[{11020002,20}]',3),(1004,13,3,760,'[{1,4236},{2,85622},{5,2099},{6,2099}]','[1,8]','[{11020002,20}]',3),(1005,13,3,760,'[{1,3760},{2,76035},{5,1862},{6,1862}]','[1,6]','[{11020002,20}]',3),(1006,13,3,950,'[{1,4731},{2,95359},{5,2347},{6,2347}]','[1,9]','[{11020002,20}]',3),(1001,13,4,760,'[{1,2194},{2,44474},{5,1080},{6,1080}]','[2,101]','[{11020002,20}]',3),(1002,13,4,760,'[{1,2885},{2,58429},{5,1422},{6,1422}]','[2,120]','[{11020002,20}]',3),(1003,13,4,760,'[{1,3624},{2,73067},{5,1790},{6,1790}]','[2,140]','[{11020002,20}]',3),(1004,13,4,760,'[{1,4355},{2,88019},{5,2158},{6,2158}]','[2,161]','[{11020002,20}]',3),(1005,13,4,760,'[{1,3867},{2,78181},{5,1915},{6,1915}]','[2,132]','[{11020002,20}]',3),(1006,13,4,950,'[{1,4862},{2,97989},{5,2412},{6,2412}]','[2,192]','[{11020002,20}]',3),(1001,13,5,760,'[{1,2259},{2,45776},{5,1112},{6,1112}]','[1,5]','[{11020002,20}]',3),(1002,13,5,760,'[{1,2968},{2,60108},{5,1463},{6,1463}]','[1,6]','[{11020002,20}]',3),(1003,13,5,760,'[{1,3727},{2,75127},{5,1841},{6,1841}]','[1,7]','[{11020002,20}]',3),(1004,13,5,760,'[{1,4476},{2,90456},{5,2218},{6,2218}]','[1,8]','[{11020002,20}]',3),(1005,13,5,760,'[{1,3976},{2,80363},{5,1969},{6,1969}]','[1,7]','[{11020002,20}]',3),(1006,13,5,950,'[{1,4995},{2,100663},{5,2478},{6,2478}]','[1,10]','[{11020002,20}]',3),(1001,14,0,920,'[{1,2325},{2,47111},{5,1145},{6,1145}]','[2,105]','[{11020002,20}]',3),(1002,14,0,920,'[{1,3054},{2,61831},{5,1506},{6,1506}]','[2,126]','[{11020002,20}]',3),(1003,14,0,920,'[{1,3832},{2,77240},{5,1893},{6,1893}]','[2,147]','[{11020002,20}]',3),(1004,14,0,920,'[{1,4601},{2,92956},{5,2280},{6,2280}]','[2,168]','[{11020002,20}]',3),(1005,14,0,920,'[{1,4087},{2,82602},{5,2024},{6,2024}]','[2,135]','[{11020002,20}]',3),(1006,14,0,1150,'[{1,5132},{2,103407},{5,2546},{6,2546}]','[2,199]','[{11020002,20}]',3),(1001,14,1,920,'[{1,2392},{2,48467},{5,1178},{6,1178}]','[1,5]','[{11020002,20}]',3),(1002,14,1,920,'[{1,3141},{2,63581},{5,1549},{6,1549}]','[1,6]','[{11020002,20}]',3),(1003,14,1,920,'[{1,3939},{2,79387},{5,1946},{6,1946}]','[1,7]','[{11020002,20}]',3),(1004,14,1,920,'[{1,4727},{2,95496},{5,2343},{6,2343}]','[1,8]','[{11020002,20}]',3),(1005,14,1,920,'[{1,4200},{2,84876},{5,2080},{6,2080}]','[1,7]','[{11020002,20}]',3),(1006,14,1,1150,'[{1,5271},{2,106194},{5,2615},{6,2615}]','[1,10]','[{11020002,20}]',3),(1001,14,2,920,'[{1,2460},{2,49844},{5,1212},{6,1212}]','[2,107]','[{11020002,20}]',3),(1002,14,2,920,'[{1,3229},{2,65358},{5,1593},{6,1593}]','[2,129]','[{11020002,20}]',3),(1003,14,2,920,'[{1,4048},{2,81567},{5,2000},{6,2000}]','[2,150]','[{11020002,20}]',3),(1004,14,2,920,'[{1,4855},{2,98075},{5,2407},{6,2407}]','[2,173]','[{11020002,20}]',3),(1005,14,2,920,'[{1,4315},{2,87185},{5,2137},{6,2137}]','[2,138]','[{11020002,20}]',3),(1006,14,2,1150,'[{1,5412},{2,109025},{5,2685},{6,2685}]','[2,204]','[{11020002,20}]',3),(1001,14,3,920,'[{1,2529},{2,51242},{5,1246},{6,1246}]','[1,5]','[{11020002,20}]',3),(1002,14,3,920,'[{1,3319},{2,67162},{5,1638},{6,1638}]','[1,6]','[{11020002,20}]',3),(1003,14,3,920,'[{1,4158},{2,83780},{5,2055},{6,2055}]','[1,8]','[{11020002,20}]',3),(1004,14,3,920,'[{1,4985},{2,100694},{5,2472},{6,2472}]','[1,9]','[{11020002,20}]',3),(1005,14,3,920,'[{1,4432},{2,89530},{5,2195},{6,2195}]','[1,7]','[{11020002,20}]',3),(1006,14,3,1150,'[{1,5555},{2,111900},{5,2756},{6,2756}]','[1,10]','[{11020002,20}]',3),(1001,14,4,920,'[{1,2599},{2,52661},{5,1281},{6,1281}]','[2,109]','[{11020002,20}]',3),(1002,14,4,920,'[{1,3410},{2,68993},{5,1683},{6,1683}]','[2,132]','[{11020002,20}]',3),(1003,14,4,920,'[{1,4270},{2,86027},{5,2111},{6,2111}]','[2,153]','[{11020002,20}]',3),(1004,14,4,920,'[{1,5117},{2,103352},{5,2538},{6,2538}]','[2,174]','[{11020002,20}]',3),(1005,14,4,920,'[{1,4551},{2,91910},{5,2254},{6,2254}]','[2,142]','[{11020002,20}]',3),(1006,14,4,1150,'[{1,5700},{2,114819},{5,2828},{6,2828}]','[2,209]','[{11020002,20}]',3),(1001,14,5,920,'[{1,2671},{2,54100},{5,1317},{6,1317}]','[1,6]','[{11020002,20}]',3),(1002,14,5,920,'[{1,3502},{2,70851},{5,1729},{6,1729}]','[1,7]','[{11020002,20}]',3),(1003,14,5,920,'[{1,4384},{2,88307},{5,2167},{6,2167}]','[1,8]','[{11020002,20}]',3),(1004,14,5,920,'[{1,5251},{2,106050},{5,2605},{6,2605}]','[1,9]','[{11020002,20}]',3),(1005,14,5,920,'[{1,4671},{2,94326},{5,2314},{6,2314}]','[1,7]','[{11020002,20}]',3),(1006,14,5,1150,'[{1,5848},{2,117781},{5,2902},{6,2902}]','[1,11]','[{11020002,20}]',3),(1001,15,0,1120,'[{1,2744},{2,55573},{5,1353},{6,1353}]','[2,112]','[{11020002,20}]',3),(1002,15,0,1120,'[{1,3597},{2,72752},{5,1776},{6,1776}]','[2,135]','[{11020002,20}]',3),(1003,15,0,1120,'[{1,4500},{2,90640},{5,2225},{6,2225}]','[2,158]','[{11020002,20}]',3),(1004,15,0,1120,'[{1,5389},{2,108811},{5,2674},{6,2674}]','[2,181]','[{11020002,20}]',3),(1005,15,0,1120,'[{1,4794},{2,96798},{5,2375},{6,2375}]','[2,148]','[{11020002,20}]',3),(1006,15,0,1400,'[{1,5999},{2,120813},{5,2977},{6,2977}]','[2,217]','[{11020002,20}]',3),(1001,15,1,1120,'[{1,2818},{2,57067},{5,1390},{6,1390}]','[1,6]','[{11020002,20}]',3),(1002,15,1,1120,'[{1,3693},{2,74680},{5,1824},{6,1824}]','[1,7]','[{11020002,20}]',3),(1003,15,1,1120,'[{1,4618},{2,93007},{5,2284},{6,2284}]','[1,8]','[{11020002,20}]',3),(1004,15,1,1120,'[{1,5529},{2,111612},{5,2744},{6,2744}]','[1,9]','[{11020002,20}]',3),(1005,15,1,1120,'[{1,4919},{2,99306},{5,2437},{6,2437}]','[1,7]','[{11020002,20}]',3),(1006,15,1,1400,'[{1,6152},{2,123889},{5,3053},{6,3053}]','[1,11]','[{11020002,20}]',3),(1001,15,2,1120,'[{1,2893},{2,58581},{5,1427},{6,1427}]','[2,116]','[{11020002,20}]',3),(1002,15,2,1120,'[{1,3790},{2,76635},{5,1872},{6,1872}]','[2,140]','[{11020002,20}]',3),(1003,15,2,1120,'[{1,4738},{2,95407},{5,2343},{6,2343}]','[2,163]','[{11020002,20}]',3),(1004,15,2,1120,'[{1,5671},{2,114452},{5,2815},{6,2815}]','[2,184]','[{11020002,20}]',3),(1005,15,2,1120,'[{1,5046},{2,101849},{5,2500},{6,2500}]','[2,150]','[{11020002,20}]',3),(1006,15,2,1400,'[{1,6308},{2,127009},{5,3131},{6,3131}]','[2,220]','[{11020002,20}]',3),(1001,15,3,1120,'[{1,2969},{2,60116},{5,1465},{6,1465}]','[1,6]','[{11020002,20}]',3),(1002,15,3,1120,'[{1,3889},{2,78618},{5,1921},{6,1921}]','[1,7]','[{11020002,20}]',3),(1003,15,3,1120,'[{1,4859},{2,97840},{5,2403},{6,2403}]','[1,8]','[{11020002,20}]',3),(1004,15,3,1120,'[{1,5815},{2,117332},{5,2887},{6,2887}]','[1,9]','[{11020002,20}]',3),(1005,15,3,1120,'[{1,5174},{2,104428},{5,2564},{6,2564}]','[1,8]','[{11020002,20}]',3),(1006,15,3,1400,'[{1,6466},{2,130173},{5,3210},{6,3210}]','[1,11]','[{11020002,20}]',3),(1001,15,4,1120,'[{1,3046},{2,61672},{5,1503},{6,1503}]','[2,119]','[{11020002,20}]',3),(1002,15,4,1120,'[{1,3989},{2,80628},{5,1971},{6,1971}]','[2,142]','[{11020002,20}]',3),(1003,15,4,1120,'[{1,4982},{2,100307},{5,2464},{6,2464}]','[2,166]','[{11020002,20}]',3),(1004,15,4,1120,'[{1,5960},{2,120252},{5,2960},{6,2960}]','[2,189]','[{11020002,20}]',3),(1005,15,4,1120,'[{1,5304},{2,107042},{5,2629},{6,2629}]','[2,153]','[{11020002,20}]',3),(1006,15,4,1400,'[{1,6626},{2,133380},{5,3290},{6,3290}]','[2,225]','[{11020002,20}]',3),(1001,15,5,1120,'[{1,3124},{2,63249},{5,1542},{6,1542}]','[1,6]','[{11020002,20}]',3),(1002,15,5,1120,'[{1,4090},{2,82665},{5,2021},{6,2021}]','[1,7]','[{11020002,20}]',3),(1003,15,5,1120,'[{1,5107},{2,102807},{5,2526},{6,2526}]','[1,9]','[{11020002,20}]',3),(1004,15,5,1120,'[{1,6107},{2,123211},{5,3034},{6,3034}]','[1,10]','[{11020002,20}]',3),(1005,15,5,1120,'[{1,5436},{2,109691},{5,2695},{6,2695}]','[1,8]','[{11020002,20}]',3),(1006,15,5,1400,'[{1,6788},{2,136631},{5,3371},{6,3371}]','[1,11]','[{11020002,20}]',3),(1001,16,0,1360,'[{1,3204},{2,64859},{5,1582},{6,1582}]','[2,122]','[{11020002,20}]',3),(1002,16,0,1360,'[{1,4194},{2,84745},{5,2073},{6,2073}]','[2,147]','[{11020002,20}]',3),(1003,16,0,1360,'[{1,5234},{2,105360},{5,2589},{6,2589}]','[2,171]','[{11020002,20}]',3),(1004,16,0,1360,'[{1,6258},{2,126233},{5,3109},{6,3109}]','[2,195]','[{11020002,20}]',3),(1005,16,0,1360,'[{1,5571},{2,112397},{5,2762},{6,2762}]','[2,158]','[{11020002,20}]',3),(1006,16,0,1700,'[{1,6954},{2,139952},{5,3454},{6,3454}]','[2,233]','[{11020002,20}]',3),(1001,16,1,1360,'[{1,3285},{2,66490},{5,1622},{6,1622}]','[1,6]','[{11020002,20}]',3),(1002,16,1,1360,'[{1,4299},{2,86852},{5,2125},{6,2125}]','[1,7]','[{11020002,20}]',3),(1003,16,1,1360,'[{1,5363},{2,107947},{5,2653},{6,2653}]','[1,9]','[{11020002,20}]',3),(1004,16,1,1360,'[{1,6411},{2,129295},{5,3185},{6,3185}]','[1,10]','[{11020002,20}]',3),(1005,16,1,1360,'[{1,5708},{2,115138},{5,2830},{6,2830}]','[1,8]','[{11020002,20}]',3),(1006,16,1,1700,'[{1,7122},{2,143317},{5,3538},{6,3538}]','[1,12]','[{11020002,20}]',3),(1001,16,2,1360,'[{1,3367},{2,68142},{5,1663},{6,1663}]','[2,124]','[{11020002,20}]',3),(1002,16,2,1360,'[{1,4405},{2,88986},{5,2178},{6,2178}]','[2,150]','[{11020002,20}]',3),(1003,16,2,1360,'[{1,5494},{2,110567},{5,2718},{6,2718}]','[2,175]','[{11020002,20}]',3),(1004,16,2,1360,'[{1,6566},{2,132397},{5,3262},{6,3262}]','[2,199]','[{11020002,20}]',3),(1005,16,2,1360,'[{1,5846},{2,117915},{5,2899},{6,2899}]','[2,163]','[{11020002,20}]',3),(1006,16,2,1700,'[{1,7292},{2,146726},{5,3623},{6,3623}]','[2,236]','[{11020002,20}]',3),(1001,16,3,1360,'[{1,3450},{2,69815},{5,1704},{6,1704}]','[1,6]','[{11020002,20}]',3),(1002,16,3,1360,'[{1,4513},{2,91147},{5,2232},{6,2232}]','[1,8]','[{11020002,20}]',3),(1003,16,3,1360,'[{1,5626},{2,113220},{5,2784},{6,2784}]','[1,9]','[{11020002,20}]',3),(1004,16,3,1360,'[{1,6723},{2,135538},{5,3340},{6,3340}]','[1,10]','[{11020002,20}]',3),(1005,16,3,1360,'[{1,5986},{2,120727},{5,2969},{6,2969}]','[1,8]','[{11020002,20}]',3),(1006,16,3,1700,'[{1,7464},{2,150178},{5,3709},{6,3709}]','[1,12]','[{11020002,20}]',3),(1001,16,4,1360,'[{1,3534},{2,71509},{5,1746},{6,1746}]','[2,127]','[{11020002,20}]',3),(1002,16,4,1360,'[{1,4622},{2,93335},{5,2286},{6,2286}]','[2,151]','[{11020002,20}]',3),(1003,16,4,1360,'[{1,5760},{2,115907},{5,2851},{6,2851}]','[2,178]','[{11020002,20}]',3),(1004,16,4,1360,'[{1,6882},{2,138719},{5,3419},{6,3419}]','[2,203]','[{11020002,20}]',3),(1005,16,4,1360,'[{1,6128},{2,123575},{5,3040},{6,3040}]','[2,166]','[{11020002,20}]',3),(1006,16,4,1700,'[{1,7638},{2,153674},{5,3796},{6,3796}]','[2,241]','[{11020002,20}]',3),(1001,16,5,1360,'[{1,3619},{2,73223},{5,1788},{6,1788}]','[1,6]','[{11020002,20}]',3),(1002,16,5,1360,'[{1,4732},{2,95550},{5,2341},{6,2341}]','[1,8]','[{11020002,20}]',3),(1003,16,5,1360,'[{1,5896},{2,118627},{5,2918},{6,2918}]','[1,9]','[{11020002,20}]',3),(1004,16,5,1360,'[{1,7043},{2,141939},{5,3499},{6,3499}]','[1,10]','[{11020002,20}]',3),(1005,16,5,1360,'[{1,6272},{2,126458},{5,3112},{6,3112}]','[1,8]','[{11020002,20}]',3),(1006,16,5,1700,'[{1,7815},{2,157214},{5,3884},{6,3884}]','[1,12]','[{11020002,20}]',3),(1001,17,0,1640,'[{1,3706},{2,74975},{5,1831},{6,1831}]','[2,132]','[{11020003,40}]',3),(1002,17,0,1640,'[{1,4845},{2,97814},{5,2397},{6,2397}]','[2,158]','[{11020003,40}]',3),(1003,17,0,1640,'[{1,6035},{2,121407},{5,2987},{6,2987}]','[2,184]','[{11020003,40}]',3),(1004,17,0,1640,'[{1,7207},{2,145231},{5,3581},{6,3581}]','[2,210]','[{11020003,40}]',3),(1005,17,0,1640,'[{1,6419},{2,129405},{5,3185},{6,3185}]','[2,171]','[{11020003,40}]',3),(1006,17,0,2050,'[{1,7995},{2,160833},{5,3974},{6,3974}]','[2,249]','[{11020003,40}]',3),(1001,17,1,1640,'[{1,3794},{2,76752},{5,1875},{6,1875}]','[1,7]','[{11020003,40}]',3),(1002,17,1,1640,'[{1,4959},{2,100111},{5,2454},{6,2454}]','[1,8]','[{11020003,40}]',3),(1003,17,1,1640,'[{1,6176},{2,124227},{5,3057},{6,3057}]','[1,9]','[{11020003,40}]',3),(1004,17,1,1640,'[{1,7373},{2,148570},{5,3664},{6,3664}]','[1,11]','[{11020003,40}]',3),(1005,17,1,1640,'[{1,6568},{2,132394},{5,3259},{6,3259}]','[1,9]','[{11020003,40}]',3),(1006,17,1,2050,'[{1,8178},{2,164504},{5,4065},{6,4065}]','[1,13]','[{11020003,40}]',3),(1001,17,2,1640,'[{1,3884},{2,78554},{5,1920},{6,1920}]','[2,133]','[{11020003,40}]',3),(1002,17,2,1640,'[{1,5075},{2,102440},{5,2512},{6,2512}]','[2,162]','[{11020003,40}]',3),(1003,17,2,1640,'[{1,6319},{2,127087},{5,3128},{6,3128}]','[2,188]','[{11020003,40}]',3),(1004,17,2,1640,'[{1,7542},{2,151957},{5,3748},{6,3748}]','[2,215]','[{11020003,40}]',3),(1005,17,2,1640,'[{1,6719},{2,135426},{5,3334},{6,3334}]','[2,175]','[{11020003,40}]',3),(1006,17,2,2050,'[{1,8364},{2,168228},{5,4158},{6,4158}]','[2,254]','[{11020003,40}]',3),(1001,17,3,1640,'[{1,3975},{2,80381},{5,1965},{6,1965}]','[1,7]','[{11020003,40}]',3),(1002,17,3,1640,'[{1,5193},{2,104802},{5,2571},{6,2571}]','[1,8]','[{11020003,40}]',3),(1003,17,3,1640,'[{1,6464},{2,129987},{5,3200},{6,3200}]','[1,9]','[{11020003,40}]',3),(1004,17,3,1640,'[{1,7713},{2,155391},{5,3833},{6,3833}]','[1,11]','[{11020003,40}]',3),(1005,17,3,1640,'[{1,6872},{2,138500},{5,3410},{6,3410}]','[1,9]','[{11020003,40}]',3),(1006,17,3,2050,'[{1,8552},{2,172004},{5,4252},{6,4252}]','[1,13]','[{11020003,40}]',3),(1001,17,4,1640,'[{1,4067},{2,82233},{5,2011},{6,2011}]','[2,137]','[{11020003,40}]',3),(1002,17,4,1640,'[{1,5312},{2,107196},{5,2630},{6,2630}]','[2,165]','[{11020003,40}]',3),(1003,17,4,1640,'[{1,6611},{2,132927},{5,3273},{6,3273}]','[2,192]','[{11020003,40}]',3),(1004,17,4,1640,'[{1,7887},{2,158873},{5,3920},{6,3920}]','[2,220]','[{11020003,40}]',3),(1005,17,4,1640,'[{1,7027},{2,141617},{5,3487},{6,3487}]','[2,178]','[{11020003,40}]',3),(1006,17,4,2050,'[{1,8743},{2,175833},{5,4347},{6,4347}]','[2,259]','[{11020003,40}]',3),(1001,17,5,1640,'[{1,4160},{2,84110},{5,2057},{6,2057}]','[1,7]','[{11020003,40}]',3),(1002,17,5,1640,'[{1,5433},{2,109623},{5,2690},{6,2690}]','[1,8]','[{11020003,40}]',3),(1003,17,5,1640,'[{1,6760},{2,135907},{5,3347},{6,3347}]','[1,10]','[{11020003,40}]',3),(1004,17,5,1640,'[{1,8063},{2,162402},{5,4008},{6,4008}]','[1,11]','[{11020003,40}]',3),(1005,17,5,1640,'[{1,7185},{2,144776},{5,3565},{6,3565}]','[1,9]','[{11020003,40}]',3),(1006,17,5,2050,'[{1,8937},{2,179714},{5,4444},{6,4444}]','[1,13]','[{11020003,40}]',3),(1001,18,0,1960,'[{1,4255},{2,86024},{5,2104},{6,2104}]','[2,140]','[{11020003,40}]',3),(1002,18,0,1960,'[{1,5556},{2,112098},{5,2751},{6,2751}]','[2,169]','[{11020003,40}]',3),(1003,18,0,1960,'[{1,6912},{2,138947},{5,3422},{6,3422}]','[2,197]','[{11020003,40}]',3),(1004,18,0,1960,'[{1,8243},{2,166002},{5,4098},{6,4098}]','[2,225]','[{11020003,40}]',3),(1005,18,0,1960,'[{1,7346},{2,147999},{5,3645},{6,3645}]','[2,184]','[{11020003,40}]',3),(1006,18,0,2450,'[{1,9135},{2,183674},{5,4543},{6,4543}]','[2,269]','[{11020003,40}]',3),(1001,18,1,1960,'[{1,4352},{2,87963},{5,2152},{6,2152}]','[1,7]','[{11020003,40}]',3),(1002,18,1,1960,'[{1,5681},{2,114606},{5,2813},{6,2813}]','[1,9]','[{11020003,40}]',3),(1003,18,1,1960,'[{1,7066},{2,142027},{5,3498},{6,3498}]','[1,10]','[{11020003,40}]',3),(1004,18,1,1960,'[{1,8425},{2,169650},{5,4189},{6,4189}]','[1,11]','[{11020003,40}]',3),(1005,18,1,1960,'[{1,7509},{2,151265},{5,3726},{6,3726}]','[1,9]','[{11020003,40}]',3),(1006,18,1,2450,'[{1,9335},{2,187686},{5,4643},{6,4643}]','[1,14]','[{11020003,40}]',3),(1001,18,2,1960,'[{1,4450},{2,89927},{5,2201},{6,2201}]','[2,143]','[{11020003,40}]',3),(1002,18,2,1960,'[{1,5808},{2,117146},{5,2876},{6,2876}]','[2,172]','[{11020003,40}]',3),(1003,18,2,1960,'[{1,7222},{2,145147},{5,3575},{6,3575}]','[2,202]','[{11020003,40}]',3),(1004,18,2,1960,'[{1,8609},{2,173345},{5,4281},{6,4281}]','[2,230]','[{11020003,40}]',3),(1005,18,2,1960,'[{1,7674},{2,154573},{5,3808},{6,3808}]','[2,187]','[{11020003,40}]',3),(1006,18,2,2450,'[{1,9538},{2,191751},{5,4744},{6,4744}]','[2,273]','[{11020003,40}]',3),(1001,18,3,1960,'[{1,4549},{2,91916},{5,2250},{6,2250}]','[1,7]','[{11020003,40}]',3),(1002,18,3,1960,'[{1,5936},{2,119719},{5,2940},{6,2940}]','[1,9]','[{11020003,40}]',3),(1003,18,3,1960,'[{1,7380},{2,148307},{5,3653},{6,3653}]','[1,10]','[{11020003,40}]',3),(1004,18,3,1960,'[{1,8796},{2,177088},{5,4374},{6,4374}]','[1,12]','[{11020003,40}]',3),(1005,18,3,1960,'[{1,7841},{2,157924},{5,3891},{6,3891}]','[1,9]','[{11020003,40}]',3),(1006,18,3,2450,'[{1,9743},{2,195868},{5,4846},{6,4846}]','[1,14]','[{11020003,40}]',3),(1001,18,4,1960,'[{1,4649},{2,93930},{5,2300},{6,2300}]','[2,147]','[{11020003,40}]',3),(1002,18,4,1960,'[{1,6066},{2,122324},{5,3005},{6,3005}]','[2,176]','[{11020003,40}]',3),(1003,18,4,1960,'[{1,7540},{2,151507},{5,3732},{6,3732}]','[2,206]','[{11020003,40}]',3),(1004,18,4,1960,'[{1,8985},{2,180878},{5,4468},{6,4468}]','[2,235]','[{11020003,40}]',3),(1005,18,4,1960,'[{1,8010},{2,161317},{5,3975},{6,3975}]','[2,191]','[{11020003,40}]',3),(1006,18,4,2450,'[{1,9951},{2,200038},{5,4950},{6,4950}]','[2,279]','[{11020003,40}]',3),(1001,18,5,1960,'[{1,4751},{2,95969},{5,2351},{6,2351}]','[1,8]','[{11020003,40}]',3),(1002,18,5,1960,'[{1,6197},{2,124962},{5,3070},{6,3070}]','[1,9]','[{11020003,40}]',3),(1003,18,5,1960,'[{1,7702},{2,154747},{5,3812},{6,3812}]','[1,10]','[{11020003,40}]',3),(1004,18,5,1960,'[{1,9176},{2,184716},{5,4564},{6,4564}]','[1,12]','[{11020003,40}]',3),(1005,18,5,1960,'[{1,8181},{2,164753},{5,4060},{6,4060}]','[1,10]','[{11020003,40}]',3),(1006,18,5,2450,'[{1,10162},{2,204260},{5,5055},{6,5055}]','[1,14]','[{11020003,40}]',3),(1001,19,0,2320,'[{1,4854},{2,98046},{5,2402},{6,2402}]','[2,152]','[{11020003,40}]',3),(1002,19,0,2320,'[{1,6331},{2,127649},{5,3137},{6,3137}]','[2,183]','[{11020003,40}]',3),(1003,19,0,2320,'[{1,7867},{2,158047},{5,3894},{6,3894}]','[2,212]','[{11020003,40}]',3),(1004,19,0,2320,'[{1,9371},{2,188625},{5,4661},{6,4661}]','[2,243]','[{11020003,40}]',3),(1005,19,0,2320,'[{1,8356},{2,168252},{5,4147},{6,4147}]','[2,197]','[{11020003,40}]',3),(1006,19,0,2900,'[{1,10377},{2,208561},{5,5162},{6,5162}]','[2,287]','[{11020003,40}]',3),(1001,19,1,2320,'[{1,4959},{2,100148},{5,2454},{6,2454}]','[1,8]','[{11020003,40}]',3),(1002,19,1,2320,'[{1,6466},{2,130368},{5,3204},{6,3204}]','[1,9]','[{11020003,40}]',3),(1003,19,1,2320,'[{1,8034},{2,161387},{5,3977},{6,3977}]','[1,11]','[{11020003,40}]',3),(1004,19,1,2320,'[{1,9568},{2,192582},{5,4759},{6,4759}]','[1,12]','[{11020003,40}]',3),(1005,19,1,2320,'[{1,8533},{2,171794},{5,4235},{6,4235}]','[1,10]','[{11020003,40}]',3),(1006,19,1,2900,'[{1,10594},{2,212915},{5,5270},{6,5270}]','[1,14]','[{11020003,40}]',3),(1001,19,2,2320,'[{1,5065},{2,102275},{5,2507},{6,2507}]','[2,153]','[{11020003,40}]',3),(1002,19,2,2320,'[{1,6603},{2,133120},{5,3272},{6,3272}]','[2,186]','[{11020003,40}]',3),(1003,19,2,2320,'[{1,8203},{2,164767},{5,4061},{6,4061}]','[2,215]','[{11020003,40}]',3),(1004,19,2,2320,'[{1,9768},{2,196586},{5,4859},{6,4859}]','[2,246]','[{11020003,40}]',3),(1005,19,2,2320,'[{1,8712},{2,175378},{5,4324},{6,4324}]','[2,200]','[{11020003,40}]',3),(1006,19,2,2900,'[{1,10814},{2,217321},{5,5380},{6,5380}]','[2,292]','[{11020003,40}]',3),(1001,19,3,2320,'[{1,5172},{2,104427},{5,2560},{6,2560}]','[1,8]','[{11020003,40}]',3),(1002,19,3,2320,'[{1,6742},{2,135904},{5,3341},{6,3341}]','[1,9]','[{11020003,40}]',3),(1003,19,3,2320,'[{1,8374},{2,168187},{5,4146},{6,4146}]','[1,11]','[{11020003,40}]',3),(1004,19,3,2320,'[{1,9970},{2,200638},{5,4960},{6,4960}]','[1,12]','[{11020003,40}]',3),(1005,19,3,2320,'[{1,8893},{2,179005},{5,4414},{6,4414}]','[1,10]','[{11020003,40}]',3),(1006,19,3,2900,'[{1,11037},{2,221780},{5,5491},{6,5491}]','[1,15]','[{11020003,40}]',3),(1001,19,4,2320,'[{1,5280},{2,106604},{5,2614},{6,2614}]','[2,157]','[{11020003,40}]',3),(1002,19,4,2320,'[{1,6882},{2,138721},{5,3411},{6,3411}]','[2,189]','[{11020003,40}]',3),(1003,19,4,2320,'[{1,8547},{2,171647},{5,4232},{6,4232}]','[2,218]','[{11020003,40}]',3),(1004,19,4,2320,'[{1,10174},{2,204737},{5,5062},{6,5062}]','[2,251]','[{11020003,40}]',3),(1005,19,4,2320,'[{1,9076},{2,182674},{5,4505},{6,4505}]','[2,204]','[{11020003,40}]',3),(1006,19,4,2900,'[{1,11262},{2,226291},{5,5603},{6,5603}]','[2,298]','[{11020003,40}]',3),(1001,19,5,2320,'[{1,5390},{2,108806},{5,2669},{6,2669}]','[1,8]','[{11020003,40}]',3),(1002,19,5,2320,'[{1,7024},{2,141570},{5,3482},{6,3482}]','[1,10]','[{11020003,40}]',3),(1003,19,5,2320,'[{1,8722},{2,175147},{5,4319},{6,4319}]','[1,11]','[{11020003,40}]',3),(1004,19,5,2320,'[{1,10381},{2,208884},{5,5165},{6,5165}]','[1,13]','[{11020003,40}]',3),(1005,19,5,2320,'[{1,9261},{2,186386},{5,4597},{6,4597}]','[1,10]','[{11020003,40}]',3),(1006,19,5,2900,'[{1,11490},{2,230855},{5,5717},{6,5717}]','[1,15]','[{11020003,40}]',3),(1001,20,0,2720,'[{1,5502},{2,111045},{5,2725},{6,2725}]','[2,162]','[{11020003,40}]',3),(1002,20,0,2720,'[{1,7168},{2,144468},{5,3554},{6,3554}]','[2,192]','[{11020003,40}]',3),(1003,20,0,2720,'[{1,8900},{2,178707},{5,4407},{6,4407}]','[2,225]','[{11020003,40}]',3),(1004,20,0,2720,'[{1,10591},{2,213102},{5,5270},{6,5270}]','[2,257]','[{11020003,40}]',3),(1005,20,0,2720,'[{1,9449},{2,190162},{5,4691},{6,4691}]','[2,210]','[{11020003,40}]',3),(1006,20,0,3400,'[{1,11722},{2,235497},{5,5833},{6,5833}]','[2,306]','[{11020003,40}]',3),(1001,20,1,2720,'[{1,5615},{2,113309},{5,2781},{6,2781}]','[1,8]','[{11020003,40}]',3),(1002,20,1,2720,'[{1,7314},{2,147398},{5,3627},{6,3627}]','[1,10]','[{11020003,40}]',3),(1003,20,1,2720,'[{1,9080},{2,182307},{5,4496},{6,4496}]','[1,11]','[{11020003,40}]',3),(1004,20,1,2720,'[{1,10804},{2,217367},{5,5376},{6,5376}]','[1,13]','[{11020003,40}]',3),(1005,20,1,2720,'[{1,9639},{2,193980},{5,4786},{6,4786}]','[1,11]','[{11020003,40}]',3),(1006,20,1,3400,'[{1,11956},{2,240192},{5,5950},{6,5950}]','[1,15]','[{11020003,40}]',3),(1001,20,2,2720,'[{1,5729},{2,115598},{5,2838},{6,2838}]','[2,165]','[{11020003,40}]',3),(1002,20,2,2720,'[{1,7462},{2,150361},{5,3701},{6,3701}]','[2,197]','[{11020003,40}]',3),(1003,20,2,2720,'[{1,9262},{2,185947},{5,4586},{6,4586}]','[2,228]','[{11020003,40}]',3),(1004,20,2,2720,'[{1,11019},{2,221680},{5,5483},{6,5483}]','[2,262]','[{11020003,40}]',3),(1005,20,2,2720,'[{1,9832},{2,197841},{5,4882},{6,4882}]','[2,213]','[{11020003,40}]',3),(1006,20,2,3400,'[{1,12193},{2,244939},{5,6068},{6,6068}]','[2,312]','[{11020003,40}]',3),(1001,20,3,2720,'[{1,5844},{2,117912},{5,2895},{6,2895}]','[1,8]','[{11020003,40}]',3),(1002,20,3,2720,'[{1,7611},{2,153356},{5,3775},{6,3775}]','[1,10]','[{11020003,40}]',3),(1003,20,3,2720,'[{1,9446},{2,189627},{5,4677},{6,4677}]','[1,12]','[{11020003,40}]',3),(1004,20,3,2720,'[{1,11237},{2,226040},{5,5592},{6,5592}]','[1,13]','[{11020003,40}]',3),(1005,20,3,2720,'[{1,10027},{2,201744},{5,4979},{6,4979}]','[1,11]','[{11020003,40}]',3),(1006,20,3,3400,'[{1,12433},{2,249739},{5,6188},{6,6188}]','[1,16]','[{11020003,40}]',3),(1001,20,4,2720,'[{1,5961},{2,120251},{5,2953},{6,2953}]','[2,166]','[{11020003,40}]',3),(1002,20,4,2720,'[{1,7762},{2,156384},{5,3850},{6,3850}]','[2,201]','[{11020003,40}]',3),(1003,20,4,2720,'[{1,9632},{2,193347},{5,4769},{6,4769}]','[2,233]','[{11020003,40}]',3),(1004,20,4,2720,'[{1,11457},{2,230448},{5,5702},{6,5702}]','[2,268]','[{11020003,40}]',3),(1005,20,4,2720,'[{1,10224},{2,205690},{5,5077},{6,5077}]','[2,217]','[{11020003,40}]',3),(1006,20,4,3400,'[{1,12675},{2,254591},{5,6309},{6,6309}]','[2,316]','[{11020003,40}]',3),(1001,20,5,2720,'[{1,6079},{2,122615},{5,3012},{6,3012}]','[1,9]','[{11020003,40}]',3),(1002,20,5,2720,'[{1,7915},{2,159444},{5,3926},{6,3926}]','[1,10]','[{11020003,40}]',3),(1003,20,5,2720,'[{1,9820},{2,197107},{5,4862},{6,4862}]','[1,12]','[{11020003,40}]',3),(1004,20,5,2720,'[{1,11679},{2,234903},{5,5813},{6,5813}]','[1,13]','[{11020003,40}]',3),(1005,20,5,2720,'[{1,10423},{2,209678},{5,5176},{6,5176}]','[1,11]','[{11020003,40}]',3),(1006,20,5,3400,'[{1,12920},{2,259496},{5,6431},{6,6431}]','[1,16]','[{11020003,40}]',3),(1001,21,0,3120,'[{1,6199},{2,125021},{5,3072},{6,3072}]','[2,171]','[{11020003,40}]',3),(1002,21,0,3120,'[{1,8070},{2,162559},{5,4003},{6,4003}]','[2,205]','[{11020003,40}]',3),(1003,21,0,3120,'[{1,10011},{2,200934},{5,4957},{6,4957}]','[2,239]','[{11020003,40}]',3),(1004,21,0,3120,'[{1,11905},{2,239438},{5,5926},{6,5926}]','[2,274]','[{11020003,40}]',3),(1005,21,0,3120,'[{1,10625},{2,213737},{5,5277},{6,5277}]','[2,223]','[{11020003,40}]',3),(1006,21,0,3900,'[{1,13169},{2,264488},{5,6555},{6,6555}]','[2,324]','[{11020003,40}]',3),(1001,21,1,3120,'[{1,6320},{2,127456},{5,3132},{6,3132}]','[1,9]','[{11020003,40}]',3),(1002,21,1,3120,'[{1,8227},{2,165712},{5,4081},{6,4081}]','[1,10]','[{11020003,40}]',3),(1003,21,1,3120,'[{1,10204},{2,204807},{5,5053},{6,5053}]','[1,12]','[{11020003,40}]',3),(1004,21,1,3120,'[{1,12134},{2,244028},{5,6040},{6,6040}]','[1,14]','[{11020003,40}]',3),(1005,21,1,3120,'[{1,10830},{2,217846},{5,5379},{6,5379}]','[1,11]','[{11020003,40}]',3),(1006,21,1,3900,'[{1,13421},{2,269542},{5,6681},{6,6681}]','[1,16]','[{11020003,40}]',3),(1001,21,2,3120,'[{1,6443},{2,129920},{5,3193},{6,3193}]','[2,173]','[{11020003,40}]',3),(1002,21,2,3120,'[{1,8386},{2,168902},{5,4160},{6,4160}]','[2,209]','[{11020003,40}]',3),(1003,21,2,3120,'[{1,10400},{2,208727},{5,5150},{6,5150}]','[2,243]','[{11020003,40}]',3),(1004,21,2,3120,'[{1,12366},{2,248673},{5,6156},{6,6156}]','[2,277]','[{11020003,40}]',3),(1005,21,2,3120,'[{1,11037},{2,222004},{5,5482},{6,5482}]','[2,227]','[{11020003,40}]',3),(1006,21,2,3900,'[{1,13676},{2,274657},{5,6808},{6,6808}]','[2,329]','[{11020003,40}]',3),(1001,21,3,3120,'[{1,6567},{2,132414},{5,3255},{6,3255}]','[1,9]','[{11020003,40}]',3),(1002,21,3,3120,'[{1,8547},{2,172130},{5,4240},{6,4240}]','[1,11]','[{11020003,40}]',3),(1003,21,3,3120,'[{1,10598},{2,212694},{5,5249},{6,5249}]','[1,12]','[{11020003,40}]',3),(1004,21,3,3120,'[{1,12601},{2,253374},{5,6273},{6,6273}]','[1,14]','[{11020003,40}]',3),(1005,21,3,3120,'[{1,11247},{2,226212},{5,5587},{6,5587}]','[1,11]','[{11020003,40}]',3),(1006,21,3,3900,'[{1,13934},{2,279833},{5,6937},{6,6937}]','[1,17]','[{11020003,40}]',3),(1001,21,4,3120,'[{1,6693},{2,134937},{5,3318},{6,3318}]','[2,176]','[{11020003,40}]',3),(1002,21,4,3120,'[{1,8710},{2,175396},{5,4321},{6,4321}]','[2,212]','[{11020003,40}]',3),(1003,21,4,3120,'[{1,10798},{2,216707},{5,5349},{6,5349}]','[2,248]','[{11020003,40}]',3),(1004,21,4,3120,'[{1,12838},{2,258130},{5,6391},{6,6391}]','[2,284]','[{11020003,40}]',3),(1005,21,4,3120,'[{1,11459},{2,230469},{5,5693},{6,5693}]','[2,228]','[{11020003,40}]',3),(1006,21,4,3900,'[{1,14195},{2,285070},{5,7067},{6,7067}]','[2,336]','[{11020003,40}]',3),(1001,21,5,3120,'[{1,6820},{2,137489},{5,3381},{6,3381}]','[1,9]','[{11020003,40}]',3),(1002,21,5,3120,'[{1,8875},{2,178700},{5,4403},{6,4403}]','[1,11]','[{11020003,40}]',3),(1003,21,5,3120,'[{1,11001},{2,220767},{5,5450},{6,5450}]','[1,13]','[{11020003,40}]',3),(1004,21,5,3120,'[{1,13078},{2,262942},{5,6511},{6,6511}]','[1,14]','[{11020003,40}]',3),(1005,21,5,3120,'[{1,11674},{2,234776},{5,5800},{6,5800}]','[1,12]','[{11020003,40}]',3),(1006,21,5,3900,'[{1,14460},{2,290369},{5,7199},{6,7199}]','[1,17]','[{11020003,40}]',3),(1001,22,0,3520,'[{1,6949},{2,140083},{5,3445},{6,3445}]','[2,179]','[{11020003,40}]',3),(1002,22,0,3520,'[{1,9042},{2,182058},{5,4486},{6,4486}]','[2,217]','[{11020003,40}]',3),(1003,22,0,3520,'[{1,11207},{2,224894},{5,5553},{6,5553}]','[2,254]','[{11020003,40}]',3),(1004,22,0,3520,'[{1,13322},{2,267833},{5,6633},{6,6633}]','[2,290]','[{11020003,40}]',3),(1005,22,0,3520,'[{1,11892},{2,239154},{5,5909},{6,5909}]','[2,234]','[{11020003,40}]',3),(1006,22,0,4400,'[{1,14729},{2,295755},{5,7333},{6,7333}]','[2,344]','[{11020003,40}]',3),(1001,22,1,3520,'[{1,7080},{2,142706},{5,3510},{6,3510}]','[1,9]','[{11020003,40}]',3),(1002,22,1,3520,'[{1,9211},{2,185454},{5,4570},{6,4570}]','[1,11]','[{11020003,40}]',3),(1003,22,1,3520,'[{1,11415},{2,229067},{5,5657},{6,5657}]','[1,13]','[{11020003,40}]',3),(1004,22,1,3520,'[{1,13569},{2,272779},{5,6756},{6,6756}]','[1,15]','[{11020003,40}]',3),(1005,22,1,3520,'[{1,12113},{2,243581},{5,6019},{6,6019}]','[1,12]','[{11020003,40}]',3),(1006,22,1,4400,'[{1,15001},{2,301202},{5,7469},{6,7469}]','[1,17]','[{11020003,40}]',3),(1001,22,2,3520,'[{1,7212},{2,145358},{5,3576},{6,3576}]','[2,184]','[{11020003,40}]',3),(1002,22,2,3520,'[{1,9382},{2,188888},{5,4655},{6,4655}]','[2,220]','[{11020003,40}]',3),(1003,22,2,3520,'[{1,11626},{2,233287},{5,5762},{6,5762}]','[2,258]','[{11020003,40}]',3),(1004,22,2,3520,'[{1,13819},{2,277781},{5,6881},{6,6881}]','[2,293]','[{11020003,40}]',3),(1005,22,2,3520,'[{1,12336},{2,248058},{5,6130},{6,6130}]','[2,239]','[{11020003,40}]',3),(1006,22,2,4400,'[{1,15276},{2,306711},{5,7606},{6,7606}]','[2,349]','[{11020003,40}]',3),(1001,22,3,3520,'[{1,7346},{2,148039},{5,3643},{6,3643}]','[1,9]','[{11020003,40}]',3),(1002,22,3,3520,'[{1,9555},{2,192360},{5,4741},{6,4741}]','[1,11]','[{11020003,40}]',3),(1003,22,3,3520,'[{1,11839},{2,237554},{5,5868},{6,5868}]','[1,13]','[{11020003,40}]',3),(1004,22,3,3520,'[{1,14071},{2,282838},{5,7007},{6,7007}]','[1,15]','[{11020003,40}]',3),(1005,22,3,3520,'[{1,12562},{2,252585},{5,6243},{6,6243}]','[1,12]','[{11020003,40}]',3),(1006,22,3,4400,'[{1,15554},{2,312281},{5,7745},{6,7745}]','[1,18]','[{11020003,40}]',3),(1001,22,4,3520,'[{1,7481},{2,150749},{5,3710},{6,3710}]','[2,186]','[{11020003,40}]',3),(1002,22,4,3520,'[{1,9730},{2,195870},{5,4828},{6,4828}]','[2,223]','[{11020003,40}]',3),(1003,22,4,3520,'[{1,12054},{2,241867},{5,5975},{6,5975}]','[2,261]','[{11020003,40}]',3),(1004,22,4,3520,'[{1,14326},{2,287950},{5,7134},{6,7134}]','[2,298]','[{11020003,40}]',3),(1005,22,4,3520,'[{1,12790},{2,257161},{5,6357},{6,6357}]','[2,243]','[{11020003,40}]',3),(1006,22,4,4400,'[{1,15835},{2,317912},{5,7885},{6,7885}]','[2,353]','[{11020003,40}]',3),(1001,22,5,3520,'[{1,7618},{2,153488},{5,3778},{6,3778}]','[1,10]','[{11020003,40}]',3),(1002,22,5,3520,'[{1,9907},{2,199418},{5,4916},{6,4916}]','[1,11]','[{11020003,40}]',3),(1003,22,5,3520,'[{1,12272},{2,246227},{5,6083},{6,6083}]','[1,13]','[{11020003,40}]',3),(1004,22,5,3520,'[{1,14584},{2,293118},{5,7263},{6,7263}]','[1,15]','[{11020003,40}]',3),(1005,22,5,3520,'[{1,13021},{2,261787},{5,6472},{6,6472}]','[1,12]','[{11020003,40}]',3),(1006,22,5,4400,'[{1,16119},{2,323604},{5,8027},{6,8027}]','[1,18]','[{11020003,40}]',3),(1001,23,0,3920,'[{1,7757},{2,156269},{5,3847},{6,3847}]','[2,190]','[{11020003,40}]',3),(1002,23,0,3920,'[{1,10087},{2,203020},{5,5006},{6,5006}]','[2,228]','[{11020003,40}]',3),(1003,23,0,3920,'[{1,12493},{2,250654},{5,6193},{6,6193}]','[2,267]','[{11020003,40}]',3),(1004,23,0,3920,'[{1,14846},{2,298365},{5,7394},{6,7394}]','[2,305]','[{11020003,40}]',3),(1005,23,0,3920,'[{1,13255},{2,266484},{5,6589},{6,6589}]','[2,248]','[{11020003,40}]',3),(1006,23,0,4900,'[{1,16408},{2,329384},{5,8171},{6,8171}]','[2,362]','[{11020003,40}]',3),(1001,23,1,3920,'[{1,7897},{2,159079},{5,3917},{6,3917}]','[1,10]','[{11020003,40}]',3),(1002,23,1,3920,'[{1,10269},{2,206660},{5,5097},{6,5097}]','[1,12]','[{11020003,40}]',3),(1003,23,1,3920,'[{1,12716},{2,255127},{5,6304},{6,6304}]','[1,13]','[{11020003,40}]',3),(1004,23,1,3920,'[{1,15111},{2,303667},{5,7526},{6,7526}]','[1,15]','[{11020003,40}]',3),(1005,23,1,3920,'[{1,13492},{2,271230},{5,6707},{6,6707}]','[1,12]','[{11020003,40}]',3),(1006,23,1,4900,'[{1,16700},{2,335225},{5,8317},{6,8317}]','[1,18]','[{11020003,40}]',3),(1001,23,2,3920,'[{1,8039},{2,161918},{5,3988},{6,3988}]','[2,194]','[{11020003,40}]',3),(1002,23,2,3920,'[{1,10452},{2,210338},{5,5188},{6,5188}]','[2,232]','[{11020003,40}]',3),(1003,23,2,3920,'[{1,12942},{2,259647},{5,6416},{6,6416}]','[2,271]','[{11020003,40}]',3),(1004,23,2,3920,'[{1,15378},{2,309025},{5,7660},{6,7660}]','[2,309]','[{11020003,40}]',3),(1005,23,2,3920,'[{1,13731},{2,276026},{5,6826},{6,6826}]','[2,251]','[{11020003,40}]',3),(1006,23,2,4900,'[{1,16995},{2,341127},{5,8464},{6,8464}]','[2,368]','[{11020003,40}]',3),(1001,23,3,3920,'[{1,8182},{2,164787},{5,4059},{6,4059}]','[1,10]','[{11020003,40}]',3),(1002,23,3,3920,'[{1,10637},{2,214054},{5,5280},{6,5280}]','[1,12]','[{11020003,40}]',3),(1003,23,3,3920,'[{1,13170},{2,264214},{5,6530},{6,6530}]','[1,14]','[{11020003,40}]',3),(1004,23,3,3920,'[{1,15648},{2,314438},{5,7795},{6,7795}]','[1,16]','[{11020003,40}]',3),(1005,23,3,3920,'[{1,13973},{2,280871},{5,6947},{6,6947}]','[1,13]','[{11020003,40}]',3),(1006,23,3,4900,'[{1,17293},{2,347091},{5,8613},{6,8613}]','[1,19]','[{11020003,40}]',3),(1001,23,4,3920,'[{1,8326},{2,167685},{5,4131},{6,4131}]','[2,195]','[{11020003,40}]',3),(1002,23,4,3920,'[{1,10824},{2,217808},{5,5373},{6,5373}]','[2,236]','[{11020003,40}]',3),(1003,23,4,3920,'[{1,13400},{2,268827},{5,6645},{6,6645}]','[2,274]','[{11020003,40}]',3),(1004,23,4,3920,'[{1,15921},{2,319907},{5,7931},{6,7931}]','[2,313]','[{11020003,40}]',3),(1005,23,4,3920,'[{1,14217},{2,285766},{5,7069},{6,7069}]','[2,256]','[{11020003,40}]',3),(1006,23,4,4900,'[{1,17594},{2,353116},{5,8763},{6,8763}]','[2,373]','[{11020003,40}]',3),(1001,23,5,3920,'[{1,8472},{2,170612},{5,4204},{6,4204}]','[1,10]','[{11020003,40}]',3),(1002,23,5,3920,'[{1,11013},{2,221600},{5,5467},{6,5467}]','[1,12]','[{11020003,40}]',3),(1003,23,5,3920,'[{1,13633},{2,273487},{5,6761},{6,6761}]','[1,14]','[{11020003,40}]',3),(1004,23,5,3920,'[{1,16197},{2,325431},{5,8069},{6,8069}]','[1,16]','[{11020003,40}]',3),(1005,23,5,3920,'[{1,14464},{2,290710},{5,7192},{6,7192}]','[1,13]','[{11020003,40}]',3),(1006,23,5,4900,'[{1,17898},{2,359202},{5,8915},{6,8915}]','[1,19]','[{11020003,40}]',3),(1001,24,0,4320,'[{1,8620},{2,173581},{5,4278},{6,4278}]','[2,201]','[{11020003,40}]',3),(1002,24,0,4320,'[{1,11205},{2,225446},{5,5563},{6,5563}]','[2,241]','[{11020003,40}]',3),(1003,24,0,4320,'[{1,13869},{2,278214},{5,6879},{6,6879}]','[2,282]','[{11020003,40}]',3),(1004,24,0,4320,'[{1,16477},{2,331034},{5,8209},{6,8209}]','[2,321]','[{11020003,40}]',3),(1005,24,0,4320,'[{1,14714},{2,295725},{5,7317},{6,7317}]','[2,261]','[{11020003,40}]',3),(1006,24,0,5400,'[{1,18206},{2,365376},{5,9069},{6,9069}]','[2,381]','[{11020003,40}]',3),(1001,24,1,4320,'[{1,8769},{2,176579},{5,4352},{6,4352}]','[1,10]','[{11020003,40}]',3),(1002,24,1,4320,'[{1,11399},{2,229330},{5,5660},{6,5660}]','[1,12]','[{11020003,40}]',3),(1003,24,1,4320,'[{1,14107},{2,282987},{5,6998},{6,6998}]','[1,14]','[{11020003,40}]',3),(1004,24,1,4320,'[{1,16759},{2,336693},{5,8350},{6,8350}]','[1,16]','[{11020003,40}]',3),(1005,24,1,4320,'[{1,14967},{2,300790},{5,7443},{6,7443}]','[1,13]','[{11020003,40}]',3),(1006,24,1,5400,'[{1,18517},{2,371611},{5,9224},{6,9224}]','[1,19]','[{11020003,40}]',3),(1001,24,2,4320,'[{1,8920},{2,179606},{5,4427},{6,4427}]','[2,204]','[{11020003,40}]',3),(1002,24,2,4320,'[{1,11595},{2,233252},{5,5758},{6,5758}]','[2,245]','[{11020003,40}]',3),(1003,24,2,4320,'[{1,14348},{2,287807},{5,7118},{6,7118}]','[2,285]','[{11020003,40}]',3),(1004,24,2,4320,'[{1,17044},{2,342407},{5,8492},{6,8492}]','[2,326]','[{11020003,40}]',3),(1005,24,2,4320,'[{1,15222},{2,305904},{5,7570},{6,7570}]','[2,264]','[{11020003,40}]',3),(1006,24,2,5400,'[{1,18831},{2,377907},{5,9381},{6,9381}]','[2,386]','[{11020003,40}]',3),(1001,24,3,4320,'[{1,9072},{2,182662},{5,4503},{6,4503}]','[1,10]','[{11020003,40}]',3),(1002,24,3,4320,'[{1,11792},{2,237212},{5,5856},{6,5856}]','[1,12]','[{11020003,40}]',3),(1003,24,3,4320,'[{1,14591},{2,292674},{5,7239},{6,7239}]','[1,14]','[{11020003,40}]',3),(1004,24,3,4320,'[{1,17332},{2,348177},{5,8636},{6,8636}]','[1,16]','[{11020003,40}]',3),(1005,24,3,4320,'[{1,15480},{2,311068},{5,7699},{6,7699}]','[1,13]','[{11020003,40}]',3),(1006,24,3,5400,'[{1,19148},{2,384264},{5,9539},{6,9539}]','[1,19]','[{11020003,40}]',3),(1001,24,4,4320,'[{1,9226},{2,185747},{5,4580},{6,4580}]','[2,205]','[{11020003,40}]',3),(1002,24,4,4320,'[{1,11991},{2,241209},{5,5955},{6,5955}]','[2,247]','[{11020003,40}]',3),(1003,24,4,4320,'[{1,14836},{2,297587},{5,7361},{6,7361}]','[2,288]','[{11020003,40}]',3),(1004,24,4,4320,'[{1,17623},{2,354002},{5,8781},{6,8781}]','[2,329]','[{11020003,40}]',3),(1005,24,4,4320,'[{1,15740},{2,316282},{5,7829},{6,7829}]','[2,269]','[{11020003,40}]',3),(1006,24,4,5400,'[{1,19469},{2,390683},{5,9699},{6,9699}]','[2,393]','[{11020003,40}]',3),(1001,24,5,4320,'[{1,9381},{2,188861},{5,4657},{6,4657}]','[1,10]','[{11020003,40}]',3),(1002,24,5,4320,'[{1,12192},{2,245244},{5,6055},{6,6055}]','[1,13]','[{11020003,40}]',3),(1003,24,5,4320,'[{1,15084},{2,302547},{5,7484},{6,7484}]','[1,15]','[{11020003,40}]',3),(1004,24,5,4320,'[{1,17917},{2,359882},{5,8928},{6,8928}]','[1,17]','[{11020003,40}]',3),(1005,24,5,4320,'[{1,16003},{2,321545},{5,7960},{6,7960}]','[1,14]','[{11020003,40}]',3),(1006,24,5,5400,'[{1,19793},{2,397163},{5,9861},{6,9861}]','[1,20]','[{11020003,40}]',3),(1001,25,0,4720,'[{1,9538},{2,192017},{5,4735},{6,4735}]','[2,210]','[{11020003,40}]',3),(1002,25,0,4720,'[{1,12396},{2,249334},{5,6157},{6,6157}]','[2,253]','[{11020003,40}]',3),(1003,25,0,4720,'[{1,15335},{2,307574},{5,7609},{6,7609}]','[2,295]','[{11020003,40}]',3),(1004,25,0,4720,'[{1,18214},{2,365842},{5,9077},{6,9077}]','[2,337]','[{11020003,40}]',3),(1005,25,0,4720,'[{1,16269},{2,326879},{5,8093},{6,8093}]','[2,274]','[{11020003,40}]',3),(1006,25,0,5900,'[{1,20121},{2,403730},{5,10025},{6,10025}]','[2,401]','[{11020003,40}]',3),(1001,25,1,4720,'[{1,9697},{2,195202},{5,4814},{6,4814}]','[1,11]','[{11020003,40}]',3),(1002,25,1,4720,'[{1,12602},{2,253461},{5,6260},{6,6260}]','[1,13]','[{11020003,40}]',3),(1003,25,1,4720,'[{1,15588},{2,312647},{5,7735},{6,7735}]','[1,15]','[{11020003,40}]',3),(1004,25,1,4720,'[{1,18514},{2,371857},{5,9227},{6,9227}]','[1,17]','[{11020003,40}]',3),(1005,25,1,4720,'[{1,16538},{2,332263},{5,8227},{6,8227}]','[1,14]','[{11020003,40}]',3),(1006,25,1,5900,'[{1,20452},{2,410359},{5,10190},{6,10190}]','[1,20]','[{11020003,40}]',3),(1001,25,2,4720,'[{1,9857},{2,198416},{5,4894},{6,4894}]','[2,214]','[{11020003,40}]',3),(1002,25,2,4720,'[{1,12810},{2,257626},{5,6364},{6,6364}]','[2,256]','[{11020003,40}]',3),(1003,25,2,4720,'[{1,15844},{2,317767},{5,7862},{6,7862}]','[2,298]','[{11020003,40}]',3),(1004,25,2,4720,'[{1,18817},{2,377927},{5,9378},{6,9378}]','[2,342]','[{11020003,40}]',3),(1005,25,2,4720,'[{1,16809},{2,337696},{5,8362},{6,8362}]','[2,277]','[{11020003,40}]',3),(1006,25,2,5900,'[{1,20786},{2,417049},{5,10357},{6,10357}]','[2,406]','[{11020003,40}]',3),(1001,25,3,4720,'[{1,10019},{2,201660},{5,4975},{6,4975}]','[1,11]','[{11020003,40}]',3),(1002,25,3,4720,'[{1,13020},{2,261829},{5,6469},{6,6469}]','[1,13]','[{11020003,40}]',3),(1003,25,3,4720,'[{1,16102},{2,322934},{5,7991},{6,7991}]','[1,15]','[{11020003,40}]',3),(1004,25,3,4720,'[{1,19123},{2,384053},{5,9531},{6,9531}]','[1,17]','[{11020003,40}]',3),(1005,25,3,4720,'[{1,17083},{2,343179},{5,8499},{6,8499}]','[1,14]','[{11020003,40}]',3),(1006,25,3,5900,'[{1,21123},{2,423800},{5,10525},{6,10525}]','[1,20]','[{11020003,40}]',3),(1001,25,4,4720,'[{1,10182},{2,204933},{5,5056},{6,5056}]','[2,215]','[{11020003,40}]',3),(1002,25,4,4720,'[{1,13232},{2,266070},{5,6575},{6,6575}]','[2,259]','[{11020003,40}]',3),(1003,25,4,4720,'[{1,16362},{2,328147},{5,8121},{6,8121}]','[2,303]','[{11020003,40}]',3),(1004,25,4,4720,'[{1,19432},{2,390234},{5,9685},{6,9685}]','[2,346]','[{11020003,40}]',3),(1005,25,4,4720,'[{1,17359},{2,348711},{5,8637},{6,8637}]','[2,282]','[{11020003,40}]',3),(1006,25,4,5900,'[{1,21463},{2,430612},{5,10695},{6,10695}]','[2,410]','[{11020003,40}]',3),(1001,25,5,0,'[{1,10347},{2,208235},{5,5138},{6,5138}]','[]','[{11020003,40}]',3),(1002,25,5,0,'[{1,13445},{2,270349},{5,6681},{6,6681}]','[]','[{11020003,40}]',3),(1003,25,5,0,'[{1,16625},{2,333407},{5,8252},{6,8252}]','[]','[{11020003,40}]',3),(1004,25,5,0,'[{1,19743},{2,396471},{5,9840},{6,9840}]','[]','[{11020003,40}]',3),(1005,25,5,0,'[{1,17638},{2,354293},{5,8776},{6,8776}]','[]','[{11020003,40}]',3),(1006,25,5,0,'[{1,21806},{2,437486},{5,10866},{6,10866}]','[]','[{11020003,40}]',3);
/*!40000 ALTER TABLE `base_god_lv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_god_pyx`
--

DROP TABLE IF EXISTS `base_god_pyx`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_god_pyx` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '圣器id',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '圣器名称',
  `god_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '降神id',
  `seal_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT '印记列表',
  `skill_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '专属id',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗内容',
  `resource` varchar(50) NOT NULL DEFAULT '0' COMMENT '形象资源',
  `icon_resource` varchar(50) NOT NULL COMMENT '图标资源',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='圣器配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_god_pyx`
--

LOCK TABLES `base_god_pyx` WRITE;
/*!40000 ALTER TABLE `base_god_pyx` DISABLE KEYS */;
INSERT INTO `base_god_pyx` VALUES (11030001,'太阳权杖',1001,'[110300051,110300052,110300053,110300054]',30000001,'[{0,11030003,1}]','203021','11030003'),(11030002,'霜之哀伤',1002,'[110300041,110300042,110300043,110300044]',30000002,'[{0,11030004,8}]','203017','11030020'),(11030003,'月牙天冲',1003,'[110300031,110300032,110300033,110300034]',30000003,'[{0,11030005,1}]','203022','11030005'),(11030004,'海神之戟',1004,'[110300011,110300012,110300013,110300014]',30000004,'[{0,11030001,1}]','601003','11030001'),(11030005,'荣耀之枪',1005,'[110300021,110300022,110300023,110300024]',30000005,'[{0,11030002,1}]','601001','11030002'),(11030006,'亡者黑镰',1006,'[110300061,110300062,110300063,110300064]',30000006,'[{0,11030006,1}]','203018','11030006');
/*!40000 ALTER TABLE `base_god_pyx` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_god_pyx_lv`
--

DROP TABLE IF EXISTS `base_god_pyx_lv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_god_pyx_lv` (
  `pyx_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '圣器id',
  `pyx_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '圣器等级',
  `attr` varchar(512) NOT NULL DEFAULT '[]' COMMENT '属性',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗内容',
  `skill_lv` int(11) NOT NULL DEFAULT '0' COMMENT '专属技能等级',
  PRIMARY KEY (`pyx_id`,`pyx_lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_god_pyx_lv`
--

LOCK TABLES `base_god_pyx_lv` WRITE;
/*!40000 ALTER TABLE `base_god_pyx_lv` DISABLE KEYS */;
INSERT INTO `base_god_pyx_lv` VALUES (11030001,0,'[{3,79},{4,79},{7,79},{8,79}]','[{0,11030003,1}]',1),(11030001,1,'[{3,132},{4,132},{7,132},{8,132}]','[{0,11030003,1}]',2),(11030001,2,'[{3,242},{4,242},{7,242},{8,242}]','[{0,11030003,2}]',3),(11030001,3,'[{3,444},{4,444},{7,444},{8,444}]','[{0,11030003,3}]',4),(11030001,4,'[{3,738},{4,738},{7,738},{8,738}]','[{0,11030003,4}]',5),(11030001,5,'[{3,1123},{4,1123},{7,1123},{8,1123}]','[{0,11030003,5}]',6),(11030001,6,'[{3,1600},{4,1600},{7,1600},{8,1600}]','[{0,11030003,6}]',7),(11030001,7,'[{3,2169},{4,2169},{7,2169},{8,2169}]','[{0,11030003,7}]',8),(11030001,8,'[{3,2829},{4,2829},{7,2829},{8,2829}]','[{0,11030003,8}]',9),(11030001,9,'[{3,3581},{4,3581},{7,3581},{8,3581}]','[{0,11030003,9}]',10),(11030001,10,'[{3,4425},{4,4425},{7,4425},{8,4425}]','[]',10),(11030002,0,'[{3,121},{4,121},{7,121},{8,121}]','[{0,11030004,8}]',1),(11030002,1,'[{3,201},{4,201},{7,201},{8,201}]','[{0,11030004,8}]',2),(11030002,2,'[{3,373},{4,373},{7,373},{8,373}]','[{0,11030004,16}]',3),(11030002,3,'[{3,657},{4,657},{7,657},{8,657}]','[{0,11030004,24}]',4),(11030002,4,'[{3,1052},{4,1052},{7,1052},{8,1052}]','[{0,11030004,32}]',5),(11030002,5,'[{3,1558},{4,1558},{7,1558},{8,1558}]','[{0,11030004,40}]',6),(11030002,6,'[{3,2175},{4,2175},{7,2175},{8,2175}]','[{0,11030004,48}]',7),(11030002,7,'[{3,2904},{4,2904},{7,2904},{8,2904}]','[{0,11030004,56}]',8),(11030002,8,'[{3,3744},{4,3744},{7,3744},{8,3744}]','[{0,11030004,64}]',9),(11030002,9,'[{3,4695},{4,4695},{7,4695},{8,4695}]','[{0,11030004,72}]',10),(11030002,10,'[{3,5758},{4,5758},{7,5758},{8,5758}]','[]',10),(11030003,0,'[{3,191},{4,191},{7,191},{8,191}]','[{0,11030005,1}]',1),(11030003,1,'[{3,318},{4,318},{7,318},{8,318}]','[{0,11030005,1}]',2),(11030003,2,'[{3,601},{4,601},{7,601},{8,601}]','[{0,11030005,2}]',3),(11030003,3,'[{3,1001},{4,1001},{7,1001},{8,1001}]','[{0,11030005,3}]',4),(11030003,4,'[{3,1518},{4,1518},{7,1518},{8,1518}]','[{0,11030005,4}]',5),(11030003,5,'[{3,2152},{4,2152},{7,2152},{8,2152}]','[{0,11030005,5}]',6),(11030003,6,'[{3,2903},{4,2903},{7,2903},{8,2903}]','[{0,11030005,6}]',7),(11030003,7,'[{3,3772},{4,3772},{7,3772},{8,3772}]','[{0,11030005,7}]',8),(11030003,8,'[{3,4758},{4,4758},{7,4758},{8,4758}]','[{0,11030005,8}]',9),(11030003,9,'[{3,5861},{4,5861},{7,5861},{8,5861}]','[{0,11030005,9}]',10),(11030003,10,'[{3,7081},{4,7081},{7,7081},{8,7081}]','[]',10),(11030004,0,'[{3,277},{4,277},{7,277},{8,277}]','[{0,11030001,1}]',1),(11030004,1,'[{3,462},{4,462},{7,462},{8,462}]','[{0,11030001,1}]',2),(11030004,2,'[{3,882},{4,882},{7,882},{8,882}]','[{0,11030001,2}]',3),(11030004,3,'[{3,1418},{4,1418},{7,1418},{8,1418}]','[{0,11030001,3}]',4),(11030004,4,'[{3,2069},{4,2069},{7,2069},{8,2069}]','[{0,11030001,4}]',5),(11030004,5,'[{3,2836},{4,2836},{7,2836},{8,2836}]','[{0,11030001,5}]',6),(11030004,6,'[{3,3719},{4,3719},{7,3719},{8,3719}]','[{0,11030001,6}]',7),(11030004,7,'[{3,4717},{4,4717},{7,4717},{8,4717}]','[{0,11030001,7}]',8),(11030004,8,'[{3,5831},{4,5831},{7,5831},{8,5831}]','[{0,11030001,8}]',9),(11030004,9,'[{3,7060},{4,7060},{7,7060},{8,7060}]','[{0,11030001,9}]',10),(11030004,10,'[{3,8405},{4,8405},{7,8405},{8,8405}]','[]',10),(11030005,0,'[{3,226},{4,226},{7,226},{8,226}]','[{0,11030002,1}]',1),(11030005,1,'[{3,376},{4,376},{7,376},{8,376}]','[{0,11030002,1}]',2),(11030005,2,'[{3,714},{4,714},{7,714},{8,714}]','[{0,11030002,2}]',3),(11030005,3,'[{3,1166},{4,1166},{7,1166},{8,1166}]','[{0,11030002,3}]',4),(11030005,4,'[{3,1733},{4,1733},{7,1733},{8,1733}]','[{0,11030002,4}]',5),(11030005,5,'[{3,2414},{4,2414},{7,2414},{8,2414}]','[{0,11030002,5}]',6),(11030005,6,'[{3,3209},{4,3209},{7,3209},{8,3209}]','[{0,11030002,6}]',7),(11030005,7,'[{3,4118},{4,4118},{7,4118},{8,4118}]','[{0,11030002,7}]',8),(11030005,8,'[{3,5141},{4,5141},{7,5141},{8,5141}]','[{0,11030002,8}]',9),(11030005,9,'[{3,6278},{4,6278},{7,6278},{8,6278}]','[{0,11030002,9}]',10),(11030005,10,'[{3,7529},{4,7529},{7,7529},{8,7529}]','[]',10),(11030006,0,'[{3,362},{4,362},{7,362},{8,362}]','[{0,11030006,1}]',1),(11030006,1,'[{3,604},{4,604},{7,604},{8,604}]','[{0,11030006,1}]',2),(11030006,2,'[{3,1162},{4,1162},{7,1162},{8,1162}]','[{0,11030006,2}]',3),(11030006,3,'[{3,1822},{4,1822},{7,1822},{8,1822}]','[{0,11030006,3}]',4),(11030006,4,'[{3,2584},{4,2584},{7,2584},{8,2584}]','[{0,11030006,4}]',5),(11030006,5,'[{3,3448},{4,3448},{7,3448},{8,3448}]','[{0,11030006,5}]',6),(11030006,6,'[{3,4414},{4,4414},{7,4414},{8,4414}]','[{0,11030006,6}]',7),(11030006,7,'[{3,5482},{4,5482},{7,5482},{8,5482}]','[{0,11030006,7}]',8),(11030006,8,'[{3,6652},{4,6652},{7,6652},{8,6652}]','[{0,11030006,8}]',9),(11030006,9,'[{3,7924},{4,7924},{7,7924},{8,7924}]','[{0,11030006,9}]',10),(11030006,10,'[{3,9298},{4,9298},{7,9298},{8,9298}]','[]',10);
/*!40000 ALTER TABLE `base_god_pyx_lv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_god_rune`
--

DROP TABLE IF EXISTS `base_god_rune`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_god_rune` (
  `rune_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '符文id',
  `name` varchar(50) NOT NULL DEFAULT '""' COMMENT '名字',
  `need_grade` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开启所需降神总阶',
  `attr` varchar(512) NOT NULL DEFAULT '[]' COMMENT '符文基础属性',
  `description` varchar(255) NOT NULL DEFAULT '' COMMENT '描述',
  `icon` int(11) NOT NULL DEFAULT '0' COMMENT '图标id',
  PRIMARY KEY (`rune_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_god_rune`
--

LOCK TABLES `base_god_rune` WRITE;
/*!40000 ALTER TABLE `base_god_rune` DISABLE KEYS */;
INSERT INTO `base_god_rune` VALUES (1,'壹之符文',12,'[]','F1',18040001),(2,'贰之符文',16,'[]','F2',18040002),(3,'叁之符文',20,'[]','F3',18040003),(4,'肆之符文',24,'[]','F4',18040004),(5,'伍之符文',28,'[]','F5',18040005),(6,'陆之符文',32,'[]','F6',18040006);
/*!40000 ALTER TABLE `base_god_rune` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_god_rune_goods`
--

DROP TABLE IF EXISTS `base_god_rune_goods`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_god_rune_goods` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '印记id',
  `type` int(11) NOT NULL DEFAULT '0' COMMENT '类型',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '初始阶数',
  `description` varchar(255) NOT NULL DEFAULT '' COMMENT '描述',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_god_rune_goods`
--

LOCK TABLES `base_god_rune_goods` WRITE;
/*!40000 ALTER TABLE `base_god_rune_goods` DISABLE KEYS */;
INSERT INTO `base_god_rune_goods` VALUES (55010001,1,1,'测试用攻击印记'),(55010002,2,1,''),(55010003,3,1,''),(55010004,4,1,''),(55010005,5,1,''),(55010006,6,1,''),(55010007,7,1,''),(55010008,8,1,''),(55010009,9,1,'');
/*!40000 ALTER TABLE `base_god_rune_goods` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_god_rune_goods_lv`
--

DROP TABLE IF EXISTS `base_god_rune_goods_lv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_god_rune_goods_lv` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '符文印记id',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '阶数',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗材料',
  `attr` varchar(512) NOT NULL DEFAULT '[]' COMMENT '属性',
  PRIMARY KEY (`id`,`lv`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_god_rune_goods_lv`
--

LOCK TABLES `base_god_rune_goods_lv` WRITE;
/*!40000 ALTER TABLE `base_god_rune_goods_lv` DISABLE KEYS */;
INSERT INTO `base_god_rune_goods_lv` VALUES (55010001,1,'[{55010001,1}]','[{2,12000},{15,400},{11,80}]'),(55010001,2,'[{55010001,2}]','[{2,21600},{15,720},{11,120}]'),(55010001,3,'[{55010001,4}]','[{2,36000},{15,1200},{11,180}]'),(55010001,4,'[{55010001,8}]','[{2,60000},{15,2000},{11,260}]'),(55010001,5,'[{55010001,16}]','[{2,90000},{15,3000},{11,360}]'),(55010001,6,'[]','[{2,135000},{15,4500},{11,480}]'),(55010002,1,'[{55010002,1}]','[{3,480},{16,400},{12,80}]'),(55010002,2,'[{55010002,2}]','[{3,864},{16,720},{12,120}]'),(55010002,3,'[{55010002,4}]','[{3,1440},{16,1200},{12,180}]'),(55010002,4,'[{55010002,8}]','[{3,2400},{16,2000},{12,260}]'),(55010002,5,'[{55010002,16}]','[{3,3600},{16,3000},{12,360}]'),(55010002,6,'[]','[{3,5400},{16,4500},{12,480}]'),(55010003,1,'[{55010003,1}]','[{1,600},{4,480},{13,80}]'),(55010003,2,'[{55010003,2}]','[{1,1080},{4,864},{13,120}]'),(55010003,3,'[{55010003,4}]','[{1,1800},{4,1440},{13,180}]'),(55010003,4,'[{55010003,8}]','[{1,3000},{4,2400},{13,260}]'),(55010003,5,'[{55010003,16}]','[{1,4500},{4,3600},{13,360}]'),(55010003,6,'[]','[{1,6750},{4,5400},{13,480}]'),(55010004,1,'[{55010004,1}]','[{2,30000},{15,1000},{11,200},{21,0}]'),(55010004,2,'[{55010004,2}]','[{2,54000},{15,1800},{11,300},{21,0}]'),(55010004,3,'[{55010004,4}]','[{2,90000},{15,3000},{11,450},{21,0}]'),(55010004,4,'[{55010004,8}]','[{2,150000},{15,5000},{11,650},{21,300}]'),(55010004,5,'[{55010004,16}]','[{2,225000},{15,7500},{11,900},{21,500}]'),(55010004,6,'[]','[{2,337500},{15,11250},{11,1200},{21,750}]'),(55010005,1,'[{55010005,1}]','[{3,1200},{16,1000},{12,200},{22,0}]'),(55010005,2,'[{55010005,2}]','[{3,2160},{16,1800},{12,300},{22,0}]'),(55010005,3,'[{55010005,4}]','[{3,3600},{16,3000},{12,450},{22,0}]'),(55010005,4,'[{55010005,8}]','[{3,6000},{16,5000},{12,650},{22,300}]'),(55010005,5,'[{55010005,16}]','[{3,9000},{16,7500},{12,900},{22,500}]'),(55010005,6,'[]','[{3,13500},{16,11250},{12,1200},{22,750}]'),(55010006,1,'[{55010006,1}]','[{1,1500},{4,1200},{13,200},{23,0}]'),(55010006,2,'[{55010006,2}]','[{1,2700},{4,2160},{13,300},{23,0}]'),(55010006,3,'[{55010006,4}]','[{1,4500},{4,3600},{13,450},{23,0}]'),(55010006,4,'[{55010006,8}]','[{1,7500},{4,6000},{13,650},{23,300}]'),(55010006,5,'[{55010006,16}]','[{1,11250},{4,9000},{13,900},{23,500}]'),(55010006,6,'[]','[{1,16875},{4,13500},{13,1200},{23,750}]'),(55010007,1,'[{55010007,1}]','[{2,30000},{15,1000},{14,200},{24,0}]'),(55010007,2,'[{55010007,2}]','[{2,54000},{15,1800},{14,300},{24,0}]'),(55010007,3,'[{55010007,4}]','[{2,90000},{15,3000},{14,450},{24,0}]'),(55010007,4,'[{55010007,8}]','[{2,150000},{15,5000},{14,650},{24,300}]'),(55010007,5,'[{55010007,16}]','[{2,225000},{15,7500},{14,900},{24,500}]'),(55010007,6,'[]','[{2,337500},{15,11250},{14,1200},{24,750}]'),(55010008,1,'[{55010008,1}]','[{3,1200},{16,1000},{52,400},{25,0}]'),(55010008,2,'[{55010008,2}]','[{3,2160},{16,1800},{52,600},{25,0}]'),(55010008,3,'[{55010008,4}]','[{3,3600},{16,3000},{52,900},{25,0}]'),(55010008,4,'[{55010008,8}]','[{3,6000},{16,5000},{52,1300},{25,300}]'),(55010008,5,'[{55010008,16}]','[{3,9000},{16,7500},{52,1800},{25,500}]'),(55010008,6,'[]','[{3,13500},{16,11250},{52,2400},{25,750}]'),(55010009,1,'[{55010009,1}]','[{1,1500},{4,1200},{53,400},{26,0}]'),(55010009,2,'[{55010009,2}]','[{1,2700},{4,2160},{53,600},{26,0}]'),(55010009,3,'[{55010009,4}]','[{1,4500},{4,3600},{53,900},{26,0}]'),(55010009,4,'[{55010009,8}]','[{1,7500},{4,6000},{53,1300},{26,300}]'),(55010009,5,'[{55010009,16}]','[{1,11250},{4,9000},{53,1800},{26,500}]'),(55010009,6,'[]','[{1,16875},{4,13500},{53,2400},{26,750}]');
/*!40000 ALTER TABLE `base_god_rune_goods_lv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_god_rune_goods_skill`
--

DROP TABLE IF EXISTS `base_god_rune_goods_skill`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_god_rune_goods_skill` (
  `skill_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能id',
  `extra_anger` varchar(50) NOT NULL DEFAULT '0' COMMENT '额外怒气值',
  `need_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT '激活所需印记',
  PRIMARY KEY (`skill_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_god_rune_goods_skill`
--

LOCK TABLES `base_god_rune_goods_skill` WRITE;
/*!40000 ALTER TABLE `base_god_rune_goods_skill` DISABLE KEYS */;
INSERT INTO `base_god_rune_goods_skill` VALUES (16002010,'{0,0}','[1,2,3]'),(16002020,'{0,0}','[4,5,6]'),(16002030,'{0,0}','[7,8,9]'),(16002040,'{0,0}','[4,6,8]'),(16002050,'{0,0}','[5,7,9]');
/*!40000 ALTER TABLE `base_god_rune_goods_skill` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_god_rune_lv`
--

DROP TABLE IF EXISTS `base_god_rune_lv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_god_rune_lv` (
  `rune_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '符文id',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `need_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '升级所需经验',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗内容',
  `attr` varchar(512) NOT NULL DEFAULT '[]' COMMENT '强化属性',
  PRIMARY KEY (`rune_id`,`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_god_rune_lv`
--

LOCK TABLES `base_god_rune_lv` WRITE;
/*!40000 ALTER TABLE `base_god_rune_lv` DISABLE KEYS */;
INSERT INTO `base_god_rune_lv` VALUES (1,0,30,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,2175},{1,109}]'),(1,1,55,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,4463},{1,223}]'),(1,2,80,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,6863},{1,343}]'),(1,3,105,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,9376},{1,469}]'),(1,4,130,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,12001},{1,600}]'),(1,5,155,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,14739},{1,737}]'),(1,6,180,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,17589},{1,880}]'),(1,7,205,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,20552},{1,1028}]'),(1,8,230,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,23627},{1,1182}]'),(1,9,2000,'[{11070010,1000}]','[{2,26815},{1,1341}]'),(1,10,280,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,31503},{1,1575}]'),(1,11,305,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,34803},{1,1740}]'),(1,12,330,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,38216},{1,1911}]'),(1,13,355,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,41741},{1,2087}]'),(1,14,380,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,45379},{1,2269}]'),(1,15,405,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,49129},{1,2457}]'),(1,16,430,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,52992},{1,2650}]'),(1,17,455,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,56967},{1,2849}]'),(1,18,480,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,61055},{1,3053}]'),(1,19,4000,'[{11070010,1000}]','[{2,65255},{1,3263}]'),(1,20,530,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,71330},{1,3567}]'),(1,21,555,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,75643},{1,3783}]'),(1,22,580,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,80068},{1,4004}]'),(1,23,605,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,84606},{1,4231}]'),(1,24,630,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,89256},{1,4464}]'),(1,25,655,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,94019},{1,4702}]'),(1,26,680,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,98894},{1,4946}]'),(1,27,705,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,103882},{1,5195}]'),(1,28,730,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,108982},{1,5450}]'),(1,29,6000,'[{11070010,1000}]','[{2,114195},{1,5711}]'),(1,30,780,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,121658},{1,6084}]'),(1,31,805,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,126983},{1,6350}]'),(1,32,830,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,132421},{1,6622}]'),(1,33,855,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,137971},{1,6900}]'),(1,34,880,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,143634},{1,7183}]'),(1,35,905,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,149409},{1,7472}]'),(1,36,930,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,155297},{1,7766}]'),(1,37,955,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,161297},{1,8066}]'),(1,38,980,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,167410},{1,8372}]'),(1,39,8000,'[{11070010,1000}]','[{2,173635},{1,8683}]'),(1,40,1030,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,182485},{1,9126}]'),(1,41,1055,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,188823},{1,9443}]'),(1,42,1080,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,195273},{1,9766}]'),(1,43,1105,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,201836},{1,10094}]'),(1,44,1130,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,208511},{1,10428}]'),(1,45,1155,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,215299},{1,10767}]'),(1,46,1180,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,222199},{1,11112}]'),(1,47,1205,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,229212},{1,11463}]'),(1,48,1230,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,236337},{1,11819}]'),(1,49,10000,'[{11070010,1000}]','[{2,243575},{1,12181}]'),(1,50,1280,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,253813},{1,12693}]'),(1,51,1305,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,261163},{1,13061}]'),(1,52,1330,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,268626},{1,13434}]'),(1,53,1355,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,276201},{1,13813}]'),(1,54,1380,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,283889},{1,14197}]'),(1,55,1405,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,291689},{1,14587}]'),(1,56,1430,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,299602},{1,14983}]'),(1,57,1455,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,307627},{1,15384}]'),(1,58,1480,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,315765},{1,15791}]'),(1,59,12000,'[{11070010,1000}]','[{2,324015},{1,16204}]'),(1,60,1530,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,335640},{1,16785}]'),(1,61,1555,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,344003},{1,17203}]'),(1,62,1580,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,352478},{1,17627}]'),(1,63,1605,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,361066},{1,18056}]'),(1,64,1630,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,369766},{1,18491}]'),(1,65,1655,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,378579},{1,18932}]'),(1,66,1680,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,387504},{1,19378}]'),(1,67,1705,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,396542},{1,19830}]'),(1,68,1730,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,405692},{1,20288}]'),(1,69,15000,'[{11070010,1000}]','[{2,414955},{1,20751}]'),(1,70,1780,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,427968},{1,21402}]'),(1,71,1805,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,437343},{1,21871}]'),(1,72,1830,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,446831},{1,22345}]'),(1,73,1855,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,456431},{1,22825}]'),(1,74,1880,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,466144},{1,23311}]'),(1,75,1905,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,475969},{1,23802}]'),(1,76,1930,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,485907},{1,24299}]'),(1,77,1955,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,495957},{1,24802}]'),(1,78,1980,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,506120},{1,25310}]'),(1,79,18000,'[{11070010,1000}]','[{2,516395},{1,25824}]'),(1,80,2030,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,530795},{1,26544}]'),(1,81,2055,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,541183},{1,27063}]'),(1,82,2080,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,551683},{1,27588}]'),(1,83,2105,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,562296},{1,28119}]'),(1,84,2130,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,573021},{1,28655}]'),(1,85,2155,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,583859},{1,29197}]'),(1,86,2180,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,594809},{1,29745}]'),(1,87,2205,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,605872},{1,30298}]'),(1,88,2230,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,617047},{1,30857}]'),(1,89,21000,'[{11070010,1000}]','[{2,628335},{1,31421}]'),(1,90,2280,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,644123},{1,32210}]'),(1,91,2305,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,655523},{1,32780}]'),(1,92,2330,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,667036},{1,33356}]'),(1,93,2355,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,678661},{1,33937}]'),(1,94,2380,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,690399},{1,34524}]'),(1,95,2405,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,702249},{1,35117}]'),(1,96,2430,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,714212},{1,35715}]'),(1,97,2455,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,726287},{1,36319}]'),(1,98,2480,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,738475},{1,36928}]'),(1,99,0,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,750775},{1,37543}]'),(2,0,35,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,104},{4,104}]'),(2,1,65,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,214},{4,214}]'),(2,2,95,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,329},{4,329}]'),(2,3,125,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,450},{4,450}]'),(2,4,155,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,576},{4,576}]'),(2,5,185,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,707},{4,707}]'),(2,6,215,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,844},{4,844}]'),(2,7,245,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,986},{4,986}]'),(2,8,275,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,1134},{4,1134}]'),(2,9,3000,'[{11070010,1000}]','[{3,1287},{4,1287}]'),(2,10,335,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,1512},{4,1512}]'),(2,11,365,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,1670},{4,1670}]'),(2,12,395,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,1834},{4,1834}]'),(2,13,425,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,2003},{4,2003}]'),(2,14,455,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,2178},{4,2178}]'),(2,15,485,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,2358},{4,2358}]'),(2,16,515,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,2543},{4,2543}]'),(2,17,545,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,2734},{4,2734}]'),(2,18,575,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,2930},{4,2930}]'),(2,19,5000,'[{11070010,1000}]','[{3,3132},{4,3132}]'),(2,20,635,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,3424},{4,3424}]'),(2,21,665,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,3631},{4,3631}]'),(2,22,695,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,3843},{4,3843}]'),(2,23,725,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,4061},{4,4061}]'),(2,24,755,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,4284},{4,4284}]'),(2,25,785,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,4513},{4,4513}]'),(2,26,815,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,4747},{4,4747}]'),(2,27,845,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,4986},{4,4986}]'),(2,28,875,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,5231},{4,5231}]'),(2,29,7000,'[{11070010,1000}]','[{3,5481},{4,5481}]'),(2,30,935,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,5839},{4,5839}]'),(2,31,965,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,6095},{4,6095}]'),(2,32,995,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,6356},{4,6356}]'),(2,33,1025,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,6622},{4,6622}]'),(2,34,1055,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,6894},{4,6894}]'),(2,35,1085,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,7171},{4,7171}]'),(2,36,1115,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,7454},{4,7454}]'),(2,37,1145,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,7742},{4,7742}]'),(2,38,1175,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,8035},{4,8035}]'),(2,39,9000,'[{11070010,1000}]','[{3,8334},{4,8334}]'),(2,40,1235,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,8759},{4,8759}]'),(2,41,1265,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,9063},{4,9063}]'),(2,42,1295,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,9373},{4,9373}]'),(2,43,1325,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,9688},{4,9688}]'),(2,44,1355,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,10008},{4,10008}]'),(2,45,1385,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,10334},{4,10334}]'),(2,46,1415,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,10665},{4,10665}]'),(2,47,1445,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,11002},{4,11002}]'),(2,48,1475,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,11344},{4,11344}]'),(2,49,11000,'[{11070010,1000}]','[{3,11691},{4,11691}]'),(2,50,1535,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,12182},{4,12182}]'),(2,51,1565,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,12535},{4,12535}]'),(2,52,1595,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,12893},{4,12893}]'),(2,53,1625,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,13257},{4,13257}]'),(2,54,1655,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,13626},{4,13626}]'),(2,55,1685,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,14000},{4,14000}]'),(2,56,1715,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,14380},{4,14380}]'),(2,57,1745,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,14765},{4,14765}]'),(2,58,1775,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,15156},{4,15156}]'),(2,59,13000,'[{11070010,1000}]','[{3,15552},{4,15552}]'),(2,60,1835,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,16110},{4,16110}]'),(2,61,1865,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,16511},{4,16511}]'),(2,62,1895,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,16918},{4,16918}]'),(2,63,1925,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,17330},{4,17330}]'),(2,64,1955,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,17748},{4,17748}]'),(2,65,1985,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,18171},{4,18171}]'),(2,66,2015,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,18599},{4,18599}]'),(2,67,2045,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,19033},{4,19033}]'),(2,68,2075,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,19472},{4,19472}]'),(2,69,16000,'[{11070010,1000}]','[{3,19917},{4,19917}]'),(2,70,2135,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,20542},{4,20542}]'),(2,71,2165,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,20992},{4,20992}]'),(2,72,2195,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,21447},{4,21447}]'),(2,73,2225,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,21908},{4,21908}]'),(2,74,2255,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,22374},{4,22374}]'),(2,75,2285,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,22846},{4,22846}]'),(2,76,2315,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,23323},{4,23323}]'),(2,77,2345,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,23805},{4,23805}]'),(2,78,2375,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,24293},{4,24293}]'),(2,79,19000,'[{11070010,1000}]','[{3,24786},{4,24786}]'),(2,80,2435,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,25477},{4,25477}]'),(2,81,2465,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,25976},{4,25976}]'),(2,82,2495,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,26480},{4,26480}]'),(2,83,2525,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,26989},{4,26989}]'),(2,84,2555,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,27504},{4,27504}]'),(2,85,2585,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,28024},{4,28024}]'),(2,86,2615,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,28550},{4,28550}]'),(2,87,2645,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,29081},{4,29081}]'),(2,88,2675,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,29617},{4,29617}]'),(2,89,22000,'[{11070010,1000}]','[{3,30159},{4,30159}]'),(2,90,2735,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,30917},{4,30917}]'),(2,91,2765,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,31464},{4,31464}]'),(2,92,2795,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,32017},{4,32017}]'),(2,93,2825,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,32575},{4,32575}]'),(2,94,2855,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,33138},{4,33138}]'),(2,95,2885,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,33707},{4,33707}]'),(2,96,2915,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,34281},{4,34281}]'),(2,97,2945,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,34861},{4,34861}]'),(2,98,2975,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,35446},{4,35446}]'),(2,99,0,'[{11070001,30},{11070002,100},{11070003,300}]','[{3,36036},{4,36036}]'),(3,0,40,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,61},{6,61}]'),(3,1,75,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,125},{6,125}]'),(3,2,110,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,192},{6,192}]'),(3,3,145,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,262},{6,262}]'),(3,4,180,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,336},{6,336}]'),(3,5,215,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,413},{6,413}]'),(3,6,250,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,493},{6,493}]'),(3,7,285,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,576},{6,576}]'),(3,8,320,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,662},{6,662}]'),(3,9,4000,'[{11070010,1000}]','[{5,751},{6,751}]'),(3,10,390,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,882},{6,882}]'),(3,11,425,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,974},{6,974}]'),(3,12,460,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,1070},{6,1070}]'),(3,13,495,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,1169},{6,1169}]'),(3,14,530,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,1271},{6,1271}]'),(3,15,565,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,1376},{6,1376}]'),(3,16,600,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,1484},{6,1484}]'),(3,17,635,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,1595},{6,1595}]'),(3,18,670,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,1709},{6,1709}]'),(3,19,6000,'[{11070010,1000}]','[{5,1827},{6,1827}]'),(3,20,740,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,1997},{6,1997}]'),(3,21,775,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,2118},{6,2118}]'),(3,22,810,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,2242},{6,2242}]'),(3,23,845,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,2369},{6,2369}]'),(3,24,880,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,2499},{6,2499}]'),(3,25,915,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,2632},{6,2632}]'),(3,26,950,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,2769},{6,2769}]'),(3,27,985,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,2909},{6,2909}]'),(3,28,1020,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,3052},{6,3052}]'),(3,29,8000,'[{11070010,1000}]','[{5,3198},{6,3198}]'),(3,30,1090,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,3407},{6,3407}]'),(3,31,1125,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,3556},{6,3556}]'),(3,32,1160,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,3708},{6,3708}]'),(3,33,1195,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,3863},{6,3863}]'),(3,34,1230,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,4022},{6,4022}]'),(3,35,1265,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,4184},{6,4184}]'),(3,36,1300,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,4349},{6,4349}]'),(3,37,1335,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,4517},{6,4517}]'),(3,38,1370,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,4688},{6,4688}]'),(3,39,10000,'[{11070010,1000}]','[{5,4862},{6,4862}]'),(3,40,1440,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,5110},{6,5110}]'),(3,41,1475,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,5287},{6,5287}]'),(3,42,1510,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,5468},{6,5468}]'),(3,43,1545,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,5652},{6,5652}]'),(3,44,1580,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,5839},{6,5839}]'),(3,45,1615,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,6029},{6,6029}]'),(3,46,1650,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,6222},{6,6222}]'),(3,47,1685,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,6418},{6,6418}]'),(3,48,1720,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,6618},{6,6618}]'),(3,49,12000,'[{11070010,1000}]','[{5,6821},{6,6821}]'),(3,50,1790,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,7108},{6,7108}]'),(3,51,1825,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,7314},{6,7314}]'),(3,52,1860,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,7523},{6,7523}]'),(3,53,1895,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,7735},{6,7735}]'),(3,54,1930,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,7950},{6,7950}]'),(3,55,1965,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,8168},{6,8168}]'),(3,56,2000,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,8390},{6,8390}]'),(3,57,2035,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,8615},{6,8615}]'),(3,58,2070,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,8843},{6,8843}]'),(3,59,14000,'[{11070010,1000}]','[{5,9074},{6,9074}]'),(3,60,2140,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,9400},{6,9400}]'),(3,61,2175,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,9634},{6,9634}]'),(3,62,2210,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,9871},{6,9871}]'),(3,63,2245,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,10111},{6,10111}]'),(3,64,2280,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,10355},{6,10355}]'),(3,65,2315,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,10602},{6,10602}]'),(3,66,2350,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,10852},{6,10852}]'),(3,67,2385,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,11105},{6,11105}]'),(3,68,2420,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,11361},{6,11361}]'),(3,69,17000,'[{11070010,1000}]','[{5,11620},{6,11620}]'),(3,70,2490,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,11984},{6,11984}]'),(3,71,2525,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,12247},{6,12247}]'),(3,72,2560,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,12513},{6,12513}]'),(3,73,2595,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,12782},{6,12782}]'),(3,74,2630,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,13054},{6,13054}]'),(3,75,2665,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,13329},{6,13329}]'),(3,76,2700,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,13607},{6,13607}]'),(3,77,2735,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,13888},{6,13888}]'),(3,78,2770,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,14173},{6,14173}]'),(3,79,20000,'[{11070010,1000}]','[{5,14461},{6,14461}]'),(3,80,2840,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,14864},{6,14864}]'),(3,81,2875,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,15155},{6,15155}]'),(3,82,2910,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,15449},{6,15449}]'),(3,83,2945,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,15746},{6,15746}]'),(3,84,2980,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,16046},{6,16046}]'),(3,85,3015,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,16349},{6,16349}]'),(3,86,3050,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,16656},{6,16656}]'),(3,87,3085,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,16966},{6,16966}]'),(3,88,3120,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,17279},{6,17279}]'),(3,89,23000,'[{11070010,1000}]','[{5,17595},{6,17595}]'),(3,90,3190,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,18037},{6,18037}]'),(3,91,3225,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,18356},{6,18356}]'),(3,92,3260,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,18678},{6,18678}]'),(3,93,3295,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,19004},{6,19004}]'),(3,94,3330,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,19333},{6,19333}]'),(3,95,3365,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,19665},{6,19665}]'),(3,96,3400,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,20000},{6,20000}]'),(3,97,3435,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,20338},{6,20338}]'),(3,98,3470,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,20679},{6,20679}]'),(3,99,0,'[{11070001,30},{11070002,100},{11070003,300}]','[{5,21023},{6,21023}]'),(4,0,45,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,3480},{4,139}]'),(4,1,85,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,7140},{4,285}]'),(4,2,125,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,10980},{4,439}]'),(4,3,165,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,15000},{4,600}]'),(4,4,205,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,19200},{4,768}]'),(4,5,245,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,23580},{4,943}]'),(4,6,285,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,28140},{4,1125}]'),(4,7,325,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,32880},{4,1315}]'),(4,8,365,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,37800},{4,1512}]'),(4,9,5000,'[{11070010,1000}]','[{2,42900},{4,1716}]'),(4,10,445,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,50400},{4,2016}]'),(4,11,485,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,55680},{4,2227}]'),(4,12,525,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,61140},{4,2445}]'),(4,13,565,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,66780},{4,2671}]'),(4,14,605,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,72600},{4,2904}]'),(4,15,645,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,78600},{4,3144}]'),(4,16,685,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,84780},{4,3391}]'),(4,17,725,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,91140},{4,3645}]'),(4,18,765,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,97680},{4,3907}]'),(4,19,7000,'[{11070010,1000}]','[{2,104400},{4,4176}]'),(4,20,845,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,114120},{4,4565}]'),(4,21,885,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,121020},{4,4841}]'),(4,22,925,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,128100},{4,5124}]'),(4,23,965,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,135360},{4,5414}]'),(4,24,1005,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,142800},{4,5712}]'),(4,25,1045,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,150420},{4,6017}]'),(4,26,1085,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,158220},{4,6329}]'),(4,27,1125,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,166200},{4,6648}]'),(4,28,1165,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,174360},{4,6974}]'),(4,29,9000,'[{11070010,1000}]','[{2,182700},{4,7308}]'),(4,30,1245,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,194640},{4,7786}]'),(4,31,1285,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,203160},{4,8127}]'),(4,32,1325,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,211860},{4,8475}]'),(4,33,1365,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,220740},{4,8830}]'),(4,34,1405,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,229800},{4,9192}]'),(4,35,1445,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,239040},{4,9562}]'),(4,36,1485,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,248460},{4,9939}]'),(4,37,1525,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,258060},{4,10323}]'),(4,38,1565,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,267840},{4,10714}]'),(4,39,11000,'[{11070010,1000}]','[{2,277800},{4,11112}]'),(4,40,1645,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,291960},{4,11678}]'),(4,41,1685,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,302100},{4,12084}]'),(4,42,1725,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,312420},{4,12497}]'),(4,43,1765,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,322920},{4,12917}]'),(4,44,1805,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,333600},{4,13344}]'),(4,45,1845,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,344460},{4,13778}]'),(4,46,1885,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,355500},{4,14220}]'),(4,47,1925,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,366720},{4,14669}]'),(4,48,1965,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,378120},{4,15125}]'),(4,49,13000,'[{11070010,1000}]','[{2,389700},{4,15588}]'),(4,50,2045,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,406080},{4,16243}]'),(4,51,2085,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,417840},{4,16713}]'),(4,52,2125,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,429780},{4,17191}]'),(4,53,2165,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,441900},{4,17676}]'),(4,54,2205,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,454200},{4,18168}]'),(4,55,2245,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,466680},{4,18667}]'),(4,56,2285,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,479340},{4,19173}]'),(4,57,2325,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,492180},{4,19687}]'),(4,58,2365,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,505200},{4,20208}]'),(4,59,15000,'[{11070010,1000}]','[{2,518400},{4,20736}]'),(4,60,2445,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,537000},{4,21480}]'),(4,61,2485,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,550380},{4,22015}]'),(4,62,2525,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,563940},{4,22557}]'),(4,63,2565,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,577680},{4,23107}]'),(4,64,2605,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,591600},{4,23664}]'),(4,65,2645,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,605700},{4,24228}]'),(4,66,2685,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,619980},{4,24799}]'),(4,67,2725,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,634440},{4,25377}]'),(4,68,2765,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,649080},{4,25963}]'),(4,69,18000,'[{11070010,1000}]','[{2,663900},{4,26556}]'),(4,70,2845,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,684720},{4,27389}]'),(4,71,2885,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,699720},{4,27989}]'),(4,72,2925,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,714900},{4,28596}]'),(4,73,2965,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,730260},{4,29210}]'),(4,74,3005,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,745800},{4,29832}]'),(4,75,3045,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,761520},{4,30461}]'),(4,76,3085,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,777420},{4,31097}]'),(4,77,3125,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,793500},{4,31740}]'),(4,78,3165,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,809760},{4,32390}]'),(4,79,21000,'[{11070010,1000}]','[{2,826200},{4,33048}]'),(4,80,3245,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,849240},{4,33970}]'),(4,81,3285,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,865860},{4,34635}]'),(4,82,3325,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,882660},{4,35307}]'),(4,83,3365,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,899640},{4,35986}]'),(4,84,3405,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,916800},{4,36672}]'),(4,85,3445,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,934140},{4,37366}]'),(4,86,3485,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,951660},{4,38067}]'),(4,87,3525,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,969360},{4,38775}]'),(4,88,3565,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,987240},{4,39490}]'),(4,89,24000,'[{11070010,1000}]','[{2,1005300},{4,40212}]'),(4,90,3645,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,1030560},{4,41222}]'),(4,91,3685,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,1048800},{4,41952}]'),(4,92,3725,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,1067220},{4,42689}]'),(4,93,3765,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,1085820},{4,43433}]'),(4,94,3805,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,1104600},{4,44184}]'),(4,95,3845,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,1123560},{4,44942}]'),(4,96,3885,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,1142700},{4,45708}]'),(4,97,3925,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,1162020},{4,46481}]'),(4,98,3965,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,1181520},{4,47261}]'),(4,99,0,'[{11070001,30},{11070002,100},{11070003,300}]','[{2,1201200},{4,48048}]'),(5,0,50,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,196},{3,157}]'),(5,1,95,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,402},{3,322}]'),(5,2,140,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,618},{3,495}]'),(5,3,185,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,844},{3,676}]'),(5,4,230,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,1080},{3,865}]'),(5,5,275,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,1326},{3,1062}]'),(5,6,320,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,1583},{3,1267}]'),(5,7,365,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,1850},{3,1480}]'),(5,8,410,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,2127},{3,1701}]'),(5,9,6000,'[{11070010,1000}]','[{1,2414},{3,1931}]'),(5,10,500,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,2836},{3,2269}]'),(5,11,545,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,3133},{3,2507}]'),(5,12,590,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,3440},{3,2753}]'),(5,13,635,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,3757},{3,3007}]'),(5,14,680,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,4084},{3,3269}]'),(5,15,725,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,4422},{3,3539}]'),(5,16,770,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,4770},{3,3817}]'),(5,17,815,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,5128},{3,4103}]'),(5,18,860,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,5496},{3,4397}]'),(5,19,8000,'[{11070010,1000}]','[{1,5874},{3,4699}]'),(5,20,950,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,6421},{3,5136}]'),(5,21,995,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,6809},{3,5447}]'),(5,22,1040,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,7207},{3,5766}]'),(5,23,1085,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,7615},{3,6093}]'),(5,24,1130,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,8034},{3,6428}]'),(5,25,1175,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,8463},{3,6771}]'),(5,26,1220,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,8902},{3,7122}]'),(5,27,1265,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,9351},{3,7481}]'),(5,28,1310,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,9810},{3,7848}]'),(5,29,10000,'[{11070010,1000}]','[{1,10279},{3,8223}]'),(5,30,1400,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,10951},{3,8760}]'),(5,31,1445,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,11430},{3,9143}]'),(5,32,1490,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,11919},{3,9535}]'),(5,33,1535,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,12419},{3,9935}]'),(5,34,1580,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,12929},{3,10343}]'),(5,35,1625,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,13449},{3,10759}]'),(5,36,1670,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,13979},{3,11183}]'),(5,37,1715,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,14519},{3,11615}]'),(5,38,1760,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,15069},{3,12055}]'),(5,39,12000,'[{11070010,1000}]','[{1,15629},{3,12503}]'),(5,40,1850,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,16426},{3,13140}]'),(5,41,1895,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,16996},{3,13596}]'),(5,42,1940,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,17577},{3,14060}]'),(5,43,1985,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,18168},{3,14533}]'),(5,44,2030,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,18769},{3,15014}]'),(5,45,2075,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,19380},{3,15503}]'),(5,46,2120,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,20001},{3,16000}]'),(5,47,2165,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,20632},{3,16505}]'),(5,48,2210,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,21273},{3,17018}]'),(5,49,14000,'[{11070010,1000}]','[{1,21924},{3,17539}]'),(5,50,2300,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,22845},{3,18276}]'),(5,51,2345,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,23507},{3,18805}]'),(5,52,2390,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,24179},{3,19342}]'),(5,53,2435,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,24861},{3,19887}]'),(5,54,2480,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,25553},{3,20441}]'),(5,55,2525,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,26255},{3,21003}]'),(5,56,2570,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,26967},{3,21573}]'),(5,57,2615,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,27689},{3,22151}]'),(5,58,2660,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,28421},{3,22737}]'),(5,59,16000,'[{11070010,1000}]','[{1,29164},{3,23331}]'),(5,60,2750,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,30210},{3,24168}]'),(5,61,2795,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,30963},{3,24770}]'),(5,62,2840,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,31726},{3,25380}]'),(5,63,2885,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,32499},{3,25998}]'),(5,64,2930,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,33282},{3,26624}]'),(5,65,2975,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,34075},{3,27259}]'),(5,66,3020,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,34878},{3,27902}]'),(5,67,3065,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,35691},{3,28553}]'),(5,68,3110,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,36515},{3,29212}]'),(5,69,19000,'[{11070010,1000}]','[{1,37349},{3,29879}]'),(5,70,3200,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,38520},{3,30816}]'),(5,71,3245,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,39364},{3,31491}]'),(5,72,3290,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,40218},{3,32174}]'),(5,73,3335,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,41082},{3,32865}]'),(5,74,3380,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,41956},{3,33564}]'),(5,75,3425,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,42840},{3,34271}]'),(5,76,3470,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,43734},{3,34987}]'),(5,77,3515,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,44639},{3,35711}]'),(5,78,3560,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,45554},{3,36443}]'),(5,79,22000,'[{11070010,1000}]','[{1,46479},{3,37183}]'),(5,80,3650,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,47775},{3,38220}]'),(5,81,3695,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,48710},{3,38968}]'),(5,82,3740,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,49655},{3,39724}]'),(5,83,3785,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,50610},{3,40488}]'),(5,84,3830,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,51575},{3,41260}]'),(5,85,3875,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,52550},{3,42040}]'),(5,86,3920,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,53536},{3,42828}]'),(5,87,3965,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,54532},{3,43625}]'),(5,88,4010,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,55538},{3,44430}]'),(5,89,25000,'[{11070010,1000}]','[{1,56554},{3,45243}]'),(5,90,4100,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,57975},{3,46380}]'),(5,91,4145,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,59001},{3,47201}]'),(5,92,4190,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,60037},{3,48030}]'),(5,93,4235,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,61083},{3,48867}]'),(5,94,4280,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,62139},{3,49712}]'),(5,95,4325,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,63206},{3,50565}]'),(5,96,4370,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,64283},{3,51426}]'),(5,97,4415,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,65370},{3,52295}]'),(5,98,4460,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,66467},{3,53173}]'),(5,99,0,'[{11070001,30},{11070002,100},{11070003,300}]','[{1,67574},{3,54059}]'),(6,0,55,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,87},{8,87}]'),(6,1,105,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,179},{8,179}]'),(6,2,155,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,275},{8,275}]'),(6,3,205,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,376},{8,376}]'),(6,4,255,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,481},{8,481}]'),(6,5,305,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,591},{8,591}]'),(6,6,355,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,705},{8,705}]'),(6,7,405,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,824},{8,824}]'),(6,8,455,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,947},{8,947}]'),(6,9,7000,'[{11070010,1000}]','[{7,1075},{8,1075}]'),(6,10,555,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,1263},{8,1263}]'),(6,11,605,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,1395},{8,1395}]'),(6,12,655,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,1532},{8,1532}]'),(6,13,705,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,1673},{8,1673}]'),(6,14,755,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,1819},{8,1819}]'),(6,15,805,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,1969},{8,1969}]'),(6,16,855,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,2124},{8,2124}]'),(6,17,905,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,2283},{8,2283}]'),(6,18,955,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,2447},{8,2447}]'),(6,19,9000,'[{11070010,1000}]','[{7,2615},{8,2615}]'),(6,20,1055,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,2858},{8,2858}]'),(6,21,1105,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,3031},{8,3031}]'),(6,22,1155,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,3208},{8,3208}]'),(6,23,1205,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,3390},{8,3390}]'),(6,24,1255,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,3576},{8,3576}]'),(6,25,1305,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,3767},{8,3767}]'),(6,26,1355,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,3962},{8,3962}]'),(6,27,1405,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,4162},{8,4162}]'),(6,28,1455,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,4366},{8,4366}]'),(6,29,11000,'[{11070010,1000}]','[{7,4575},{8,4575}]'),(6,30,1555,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,4874},{8,4874}]'),(6,31,1605,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,5087},{8,5087}]'),(6,32,1655,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,5305},{8,5305}]'),(6,33,1705,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,5527},{8,5527}]'),(6,34,1755,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,5754},{8,5754}]'),(6,35,1805,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,5985},{8,5985}]'),(6,36,1855,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,6221},{8,6221}]'),(6,37,1905,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,6461},{8,6461}]'),(6,38,1955,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,6706},{8,6706}]'),(6,39,13000,'[{11070010,1000}]','[{7,6955},{8,6955}]'),(6,40,2055,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,7309},{8,7309}]'),(6,41,2105,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,7563},{8,7563}]'),(6,42,2155,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,7821},{8,7821}]'),(6,43,2205,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,8084},{8,8084}]'),(6,44,2255,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,8351},{8,8351}]'),(6,45,2305,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,8623},{8,8623}]'),(6,46,2355,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,8899},{8,8899}]'),(6,47,2405,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,9180},{8,9180}]'),(6,48,2455,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,9465},{8,9465}]'),(6,49,15000,'[{11070010,1000}]','[{7,9755},{8,9755}]'),(6,50,2555,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,10165},{8,10165}]'),(6,51,2605,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,10459},{8,10459}]'),(6,52,2655,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,10758},{8,10758}]'),(6,53,2705,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,11061},{8,11061}]'),(6,54,2755,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,11369},{8,11369}]'),(6,55,2805,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,11681},{8,11681}]'),(6,56,2855,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,11998},{8,11998}]'),(6,57,2905,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,12319},{8,12319}]'),(6,58,2955,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,12645},{8,12645}]'),(6,59,17000,'[{11070010,1000}]','[{7,12975},{8,12975}]'),(6,60,3055,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,13440},{8,13440}]'),(6,61,3105,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,13775},{8,13775}]'),(6,62,3155,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,14114},{8,14114}]'),(6,63,3205,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,14458},{8,14458}]'),(6,64,3255,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,14806},{8,14806}]'),(6,65,3305,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,15159},{8,15159}]'),(6,66,3355,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,15516},{8,15516}]'),(6,67,3405,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,15878},{8,15878}]'),(6,68,3455,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,16244},{8,16244}]'),(6,69,20000,'[{11070010,1000}]','[{7,16615},{8,16615}]'),(6,70,3555,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,17136},{8,17136}]'),(6,71,3605,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,17511},{8,17511}]'),(6,72,3655,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,17891},{8,17891}]'),(6,73,3705,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,18275},{8,18275}]'),(6,74,3755,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,18664},{8,18664}]'),(6,75,3805,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,19057},{8,19057}]'),(6,76,3855,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,19455},{8,19455}]'),(6,77,3905,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,19857},{8,19857}]'),(6,78,3955,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,20264},{8,20264}]'),(6,79,23000,'[{11070010,1000}]','[{7,20675},{8,20675}]'),(6,80,4055,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,21251},{8,21251}]'),(6,81,4105,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,21667},{8,21667}]'),(6,82,4155,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,22087},{8,22087}]'),(6,83,4205,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,22512},{8,22512}]'),(6,84,4255,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,22941},{8,22941}]'),(6,85,4305,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,23375},{8,23375}]'),(6,86,4355,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,23813},{8,23813}]'),(6,87,4405,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,24256},{8,24256}]'),(6,88,4455,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,24703},{8,24703}]'),(6,89,26000,'[{11070010,1000}]','[{7,25155},{8,25155}]'),(6,90,4555,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,25787},{8,25787}]'),(6,91,4605,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,26243},{8,26243}]'),(6,92,4655,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,26704},{8,26704}]'),(6,93,4705,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,27169},{8,27169}]'),(6,94,4755,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,27639},{8,27639}]'),(6,95,4805,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,28113},{8,28113}]'),(6,96,4855,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,28592},{8,28592}]'),(6,97,4905,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,29075},{8,29075}]'),(6,98,4955,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,29563},{8,29563}]'),(6,99,0,'[{11070001,30},{11070002,100},{11070003,300}]','[{7,30055},{8,30055}]');
/*!40000 ALTER TABLE `base_god_rune_lv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_god_rune_pos`
--

DROP TABLE IF EXISTS `base_god_rune_pos`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_god_rune_pos` (
  `pos` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '槽位',
  `need_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开启所需符文总等级',
  PRIMARY KEY (`pos`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_god_rune_pos`
--

LOCK TABLES `base_god_rune_pos` WRITE;
/*!40000 ALTER TABLE `base_god_rune_pos` DISABLE KEYS */;
INSERT INTO `base_god_rune_pos` VALUES (1,20),(2,30),(3,40);
/*!40000 ALTER TABLE `base_god_rune_pos` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_god_seal`
--

DROP TABLE IF EXISTS `base_god_seal`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_god_seal` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '印记id',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '名字',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '升级消耗',
  `attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '属性',
  `icon` varchar(50) NOT NULL COMMENT '图标',
  `description` varchar(50) NOT NULL COMMENT '描述',
  PRIMARY KEY (`id`,`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='印记配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_god_seal`
--

LOCK TABLES `base_god_seal` WRITE;
/*!40000 ALTER TABLE `base_god_seal` DISABLE KEYS */;
INSERT INTO `base_god_seal` VALUES (110300011,1,'1级攻击印记','[{0,11040001,2}]','[{1,90},{60,300}]','12010005','波塞冬攻击提升<color@7>3%+90</color>'),(110300011,2,'2级攻击印记','[{0,11040001,3}]','[{1,220},{60,600}]','12010005','波塞冬攻击提升<color@7>6%+220</color>'),(110300011,3,'3级攻击印记','[{0,11040001,4}]','[{1,390},{60,900}]','12010005','波塞冬攻击提升<color@7>9%+390</color>'),(110300011,4,'4级攻击印记','[{0,11040001,5}]','[{1,600},{60,1200}]','12010005','波塞冬攻击提升<color@7>12%+600</color>'),(110300011,5,'5级攻击印记','[{0,11040001,6}]','[{1,850},{60,1500}]','12010005','波塞冬攻击提升<color@7>15%+850</color>'),(110300011,6,'6级攻击印记','[{0,11040001,7}]','[{1,1140},{60,1800}]','12010005','波塞冬攻击提升<color@7>18%+1140</color>'),(110300011,7,'7级攻击印记','[{0,11040001,8}]','[{1,1470},{60,2100}]','12010005','波塞冬攻击提升<color@7>21%+1470</color>'),(110300011,8,'8级攻击印记','[{0,11040001,9}]','[{1,1840},{60,2400}]','12010005','波塞冬攻击提升<color@7>24%+1840</color>'),(110300011,9,'9级攻击印记','[{0,11040001,10}]','[{1,2250},{60,2700}]','12010005','波塞冬攻击提升<color@7>27%+2250</color>'),(110300011,10,'10级攻击印记','[{0,11040001,12}]','[{1,2700},{60,3000}]','12010005','波塞冬攻击提升<color@7>30%+2700</color>'),(110300011,11,'11级攻击印记','[{0,11040001,14}]','[{1,3190},{60,3300}]','12010005','波塞冬攻击提升<color@7>33%+3190</color>'),(110300011,12,'12级攻击印记','[{0,11040001,16}]','[{1,3720},{60,3600}]','12010005','波塞冬攻击提升<color@7>36%+3720</color>'),(110300011,13,'13级攻击印记','[{0,11040001,18}]','[{1,4290},{60,3900}]','12010005','波塞冬攻击提升<color@7>39%+4290</color>'),(110300011,14,'14级攻击印记','[{0,11040001,20}]','[{1,4900},{60,4200}]','12010005','波塞冬攻击提升<color@7>42%+4900</color>'),(110300011,15,'15级攻击印记','[{0,11040001,22}]','[{1,5550},{60,4500}]','12010005','波塞冬攻击提升<color@7>45%+5550</color>'),(110300011,16,'16级攻击印记','[{0,11040001,24}]','[{1,6240},{60,4800}]','12010005','波塞冬攻击提升<color@7>48%+6240</color>'),(110300011,17,'17级攻击印记','[{0,11040001,26}]','[{1,6970},{60,5100}]','12010005','波塞冬攻击提升<color@7>51%+6970</color>'),(110300011,18,'18级攻击印记','[{0,11040001,28}]','[{1,7740},{60,5400}]','12010005','波塞冬攻击提升<color@7>54%+7740</color>'),(110300011,19,'19级攻击印记','[{0,11040001,30}]','[{1,8550},{60,5700}]','12010005','波塞冬攻击提升<color@7>57%+8550</color>'),(110300011,20,'20级攻击印记','[]','[{1,9400},{60,6000}]','12010005','波塞冬攻击提升<color@7>60%+9400</color>'),(110300012,1,'1级生命印记','[{0,11040001,2}]','[{2,1800},{61,300}]','60404201','波塞冬生命提升<color@7>3%+1800</color>'),(110300012,2,'2级生命印记','[{0,11040001,3}]','[{2,4400},{61,600}]','60404201','波塞冬生命提升<color@7>6%+4400</color>'),(110300012,3,'3级生命印记','[{0,11040001,4}]','[{2,7800},{61,900}]','60404201','波塞冬生命提升<color@7>9%+7800</color>'),(110300012,4,'4级生命印记','[{0,11040001,5}]','[{2,12000},{61,1200}]','60404201','波塞冬生命提升<color@7>12%+12000</color>'),(110300012,5,'5级生命印记','[{0,11040001,6}]','[{2,17000},{61,1500}]','60404201','波塞冬生命提升<color@7>15%+17000</color>'),(110300012,6,'6级生命印记','[{0,11040001,7}]','[{2,22800},{61,1800}]','60404201','波塞冬生命提升<color@7>18%+22800</color>'),(110300012,7,'7级生命印记','[{0,11040001,8}]','[{2,29400},{61,2100}]','60404201','波塞冬生命提升<color@7>21%+29400</color>'),(110300012,8,'8级生命印记','[{0,11040001,9}]','[{2,36800},{61,2400}]','60404201','波塞冬生命提升<color@7>24%+36800</color>'),(110300012,9,'9级生命印记','[{0,11040001,10}]','[{2,45000},{61,2700}]','60404201','波塞冬生命提升<color@7>27%+45000</color>'),(110300012,10,'10级生命印记','[{0,11040001,12}]','[{2,54000},{61,3000}]','60404201','波塞冬生命提升<color@7>30%+54000</color>'),(110300012,11,'11级生命印记','[{0,11040001,14}]','[{2,63800},{61,3300}]','60404201','波塞冬生命提升<color@7>33%+63800</color>'),(110300012,12,'12级生命印记','[{0,11040001,16}]','[{2,74400},{61,3600}]','60404201','波塞冬生命提升<color@7>36%+74400</color>'),(110300012,13,'13级生命印记','[{0,11040001,18}]','[{2,85800},{61,3900}]','60404201','波塞冬生命提升<color@7>39%+85800</color>'),(110300012,14,'14级生命印记','[{0,11040001,20}]','[{2,98000},{61,4200}]','60404201','波塞冬生命提升<color@7>42%+98000</color>'),(110300012,15,'15级生命印记','[{0,11040001,22}]','[{2,111000},{61,4500}]','60404201','波塞冬生命提升<color@7>45%+111000</color>'),(110300012,16,'16级生命印记','[{0,11040001,24}]','[{2,124800},{61,4800}]','60404201','波塞冬生命提升<color@7>48%+124800</color>'),(110300012,17,'17级生命印记','[{0,11040001,26}]','[{2,139400},{61,5100}]','60404201','波塞冬生命提升<color@7>51%+139400</color>'),(110300012,18,'18级生命印记','[{0,11040001,28}]','[{2,154800},{61,5400}]','60404201','波塞冬生命提升<color@7>54%+154800</color>'),(110300012,19,'19级生命印记','[{0,11040001,30}]','[{2,171000},{61,5700}]','60404201','波塞冬生命提升<color@7>57%+171000</color>'),(110300012,20,'20级生命印记','[]','[{2,188000},{61,6000}]','60404201','波塞冬生命提升<color@7>60%+188000</color>'),(110300013,1,'1级命中印记','[{0,11040001,2}]','[{5,36},{64,300}]','12010201','波塞冬命中提升<color@7>3%+36</color>'),(110300013,2,'2级命中印记','[{0,11040001,3}]','[{5,88},{64,600}]','12010201','波塞冬命中提升<color@7>6%+88</color>'),(110300013,3,'3级命中印记','[{0,11040001,4}]','[{5,156},{64,900}]','12010201','波塞冬命中提升<color@7>9%+156</color>'),(110300013,4,'4级命中印记','[{0,11040001,5}]','[{5,240},{64,1200}]','12010201','波塞冬命中提升<color@7>12%+240</color>'),(110300013,5,'5级命中印记','[{0,11040001,6}]','[{5,340},{64,1500}]','12010201','波塞冬命中提升<color@7>15%+340</color>'),(110300013,6,'6级命中印记','[{0,11040001,7}]','[{5,456},{64,1800}]','12010201','波塞冬命中提升<color@7>18%+456</color>'),(110300013,7,'7级命中印记','[{0,11040001,8}]','[{5,588},{64,2100}]','12010201','波塞冬命中提升<color@7>21%+588</color>'),(110300013,8,'8级命中印记','[{0,11040001,9}]','[{5,736},{64,2400}]','12010201','波塞冬命中提升<color@7>24%+736</color>'),(110300013,9,'9级命中印记','[{0,11040001,10}]','[{5,900},{64,2700}]','12010201','波塞冬命中提升<color@7>27%+900</color>'),(110300013,10,'10级命中印记','[{0,11040001,12}]','[{5,1080},{64,3000}]','12010201','波塞冬命中提升<color@7>30%+1080</color>'),(110300013,11,'11级命中印记','[{0,11040001,14}]','[{5,1276},{64,3300}]','12010201','波塞冬命中提升<color@7>33%+1276</color>'),(110300013,12,'12级命中印记','[{0,11040001,16}]','[{5,1488},{64,3600}]','12010201','波塞冬命中提升<color@7>36%+1488</color>'),(110300013,13,'13级命中印记','[{0,11040001,18}]','[{5,1716},{64,3900}]','12010201','波塞冬命中提升<color@7>39%+1716</color>'),(110300013,14,'14级命中印记','[{0,11040001,20}]','[{5,1960},{64,4200}]','12010201','波塞冬命中提升<color@7>42%+1960</color>'),(110300013,15,'15级命中印记','[{0,11040001,22}]','[{5,2220},{64,4500}]','12010201','波塞冬命中提升<color@7>45%+2220</color>'),(110300013,16,'16级命中印记','[{0,11040001,24}]','[{5,2496},{64,4800}]','12010201','波塞冬命中提升<color@7>48%+2496</color>'),(110300013,17,'17级命中印记','[{0,11040001,26}]','[{5,2788},{64,5100}]','12010201','波塞冬命中提升<color@7>51%+2788</color>'),(110300013,18,'18级命中印记','[{0,11040001,28}]','[{5,3096},{64,5400}]','12010201','波塞冬命中提升<color@7>54%+3096</color>'),(110300013,19,'19级命中印记','[{0,11040001,30}]','[{5,3420},{64,5700}]','12010201','波塞冬命中提升<color@7>57%+3420</color>'),(110300013,20,'20级命中印记','[]','[{5,3760},{64,6000}]','12010201','波塞冬命中提升<color@7>60%+3760</color>'),(110300014,1,'1级闪避印记','[{0,11040001,2}]','[{6,36},{65,300}]','12010105','波塞冬闪避提升<color@7>3%+36</color>'),(110300014,2,'2级闪避印记','[{0,11040001,3}]','[{6,88},{65,600}]','12010105','波塞冬闪避提升<color@7>6%+88</color>'),(110300014,3,'3级闪避印记','[{0,11040001,4}]','[{6,156},{65,900}]','12010105','波塞冬闪避提升<color@7>9%+156</color>'),(110300014,4,'4级闪避印记','[{0,11040001,5}]','[{6,240},{65,1200}]','12010105','波塞冬闪避提升<color@7>12%+240</color>'),(110300014,5,'5级闪避印记','[{0,11040001,6}]','[{6,340},{65,1500}]','12010105','波塞冬闪避提升<color@7>15%+340</color>'),(110300014,6,'6级闪避印记','[{0,11040001,7}]','[{6,456},{65,1800}]','12010105','波塞冬闪避提升<color@7>18%+456</color>'),(110300014,7,'7级闪避印记','[{0,11040001,8}]','[{6,588},{65,2100}]','12010105','波塞冬闪避提升<color@7>21%+588</color>'),(110300014,8,'8级闪避印记','[{0,11040001,9}]','[{6,736},{65,2400}]','12010105','波塞冬闪避提升<color@7>24%+736</color>'),(110300014,9,'9级闪避印记','[{0,11040001,10}]','[{6,900},{65,2700}]','12010105','波塞冬闪避提升<color@7>27%+900</color>'),(110300014,10,'10级闪避印记','[{0,11040001,12}]','[{6,1080},{65,3000}]','12010105','波塞冬闪避提升<color@7>30%+1080</color>'),(110300014,11,'11级闪避印记','[{0,11040001,14}]','[{6,1276},{65,3300}]','12010105','波塞冬闪避提升<color@7>33%+1276</color>'),(110300014,12,'12级闪避印记','[{0,11040001,16}]','[{6,1488},{65,3600}]','12010105','波塞冬闪避提升<color@7>36%+1488</color>'),(110300014,13,'13级闪避印记','[{0,11040001,18}]','[{6,1716},{65,3900}]','12010105','波塞冬闪避提升<color@7>39%+1716</color>'),(110300014,14,'14级闪避印记','[{0,11040001,20}]','[{6,1960},{65,4200}]','12010105','波塞冬闪避提升<color@7>42%+1960</color>'),(110300014,15,'15级闪避印记','[{0,11040001,22}]','[{6,2220},{65,4500}]','12010105','波塞冬闪避提升<color@7>45%+2220</color>'),(110300014,16,'16级闪避印记','[{0,11040001,24}]','[{6,2496},{65,4800}]','12010105','波塞冬闪避提升<color@7>48%+2496</color>'),(110300014,17,'17级闪避印记','[{0,11040001,26}]','[{6,2788},{65,5100}]','12010105','波塞冬闪避提升<color@7>51%+2788</color>'),(110300014,18,'18级闪避印记','[{0,11040001,28}]','[{6,3096},{65,5400}]','12010105','波塞冬闪避提升<color@7>54%+3096</color>'),(110300014,19,'19级闪避印记','[{0,11040001,30}]','[{6,3420},{65,5700}]','12010105','波塞冬闪避提升<color@7>57%+3420</color>'),(110300014,20,'20级闪避印记','[]','[{6,3760},{65,6000}]','12010105','波塞冬闪避提升<color@7>60%+3760</color>'),(110300021,1,'1级攻击印记','[{0,11040002,2}]','[{1,80},{60,300}]','12010005','雅典娜攻击提升<color@7>3%+80</color>'),(110300021,2,'2级攻击印记','[{0,11040002,3}]','[{1,200},{60,600}]','12010005','雅典娜攻击提升<color@7>6%+200</color>'),(110300021,3,'3级攻击印记','[{0,11040002,4}]','[{1,360},{60,900}]','12010005','雅典娜攻击提升<color@7>9%+360</color>'),(110300021,4,'4级攻击印记','[{0,11040002,5}]','[{1,560},{60,1200}]','12010005','雅典娜攻击提升<color@7>12%+560</color>'),(110300021,5,'5级攻击印记','[{0,11040002,6}]','[{1,800},{60,1500}]','12010005','雅典娜攻击提升<color@7>15%+800</color>'),(110300021,6,'6级攻击印记','[{0,11040002,7}]','[{1,1080},{60,1800}]','12010005','雅典娜攻击提升<color@7>18%+1080</color>'),(110300021,7,'7级攻击印记','[{0,11040002,8}]','[{1,1400},{60,2100}]','12010005','雅典娜攻击提升<color@7>21%+1400</color>'),(110300021,8,'8级攻击印记','[{0,11040002,9}]','[{1,1760},{60,2400}]','12010005','雅典娜攻击提升<color@7>24%+1760</color>'),(110300021,9,'9级攻击印记','[{0,11040002,10}]','[{1,2160},{60,2700}]','12010005','雅典娜攻击提升<color@7>27%+2160</color>'),(110300021,10,'10级攻击印记','[{0,11040002,12}]','[{1,2600},{60,3000}]','12010005','雅典娜攻击提升<color@7>30%+2600</color>'),(110300021,11,'11级攻击印记','[{0,11040002,14}]','[{1,3080},{60,3300}]','12010005','雅典娜攻击提升<color@7>33%+3080</color>'),(110300021,12,'12级攻击印记','[{0,11040002,16}]','[{1,3600},{60,3600}]','12010005','雅典娜攻击提升<color@7>36%+3600</color>'),(110300021,13,'13级攻击印记','[{0,11040002,18}]','[{1,4160},{60,3900}]','12010005','雅典娜攻击提升<color@7>39%+4160</color>'),(110300021,14,'14级攻击印记','[{0,11040002,20}]','[{1,4760},{60,4200}]','12010005','雅典娜攻击提升<color@7>42%+4760</color>'),(110300021,15,'15级攻击印记','[{0,11040002,22}]','[{1,5400},{60,4500}]','12010005','雅典娜攻击提升<color@7>45%+5400</color>'),(110300021,16,'16级攻击印记','[{0,11040002,24}]','[{1,6080},{60,4800}]','12010005','雅典娜攻击提升<color@7>48%+6080</color>'),(110300021,17,'17级攻击印记','[{0,11040002,26}]','[{1,6800},{60,5100}]','12010005','雅典娜攻击提升<color@7>51%+6800</color>'),(110300021,18,'18级攻击印记','[{0,11040002,28}]','[{1,7560},{60,5400}]','12010005','雅典娜攻击提升<color@7>54%+7560</color>'),(110300021,19,'19级攻击印记','[{0,11040002,30}]','[{1,8360},{60,5700}]','12010005','雅典娜攻击提升<color@7>57%+8360</color>'),(110300021,20,'20级攻击印记','[]','[{1,9200},{60,6000}]','12010005','雅典娜攻击提升<color@7>60%+9200</color>'),(110300022,1,'1级生命印记','[{0,11040002,2}]','[{2,1600},{61,300}]','60404201','雅典娜生命提升<color@7>3%+1600</color>'),(110300022,2,'2级生命印记','[{0,11040002,3}]','[{2,4000},{61,600}]','60404201','雅典娜生命提升<color@7>6%+4000</color>'),(110300022,3,'3级生命印记','[{0,11040002,4}]','[{2,7200},{61,900}]','60404201','雅典娜生命提升<color@7>9%+7200</color>'),(110300022,4,'4级生命印记','[{0,11040002,5}]','[{2,11200},{61,1200}]','60404201','雅典娜生命提升<color@7>12%+11200</color>'),(110300022,5,'5级生命印记','[{0,11040002,6}]','[{2,16000},{61,1500}]','60404201','雅典娜生命提升<color@7>15%+16000</color>'),(110300022,6,'6级生命印记','[{0,11040002,7}]','[{2,21600},{61,1800}]','60404201','雅典娜生命提升<color@7>18%+21600</color>'),(110300022,7,'7级生命印记','[{0,11040002,8}]','[{2,28000},{61,2100}]','60404201','雅典娜生命提升<color@7>21%+28000</color>'),(110300022,8,'8级生命印记','[{0,11040002,9}]','[{2,35200},{61,2400}]','60404201','雅典娜生命提升<color@7>24%+35200</color>'),(110300022,9,'9级生命印记','[{0,11040002,10}]','[{2,43200},{61,2700}]','60404201','雅典娜生命提升<color@7>27%+43200</color>'),(110300022,10,'10级生命印记','[{0,11040002,12}]','[{2,52000},{61,3000}]','60404201','雅典娜生命提升<color@7>30%+52000</color>'),(110300022,11,'11级生命印记','[{0,11040002,14}]','[{2,61600},{61,3300}]','60404201','雅典娜生命提升<color@7>33%+61600</color>'),(110300022,12,'12级生命印记','[{0,11040002,16}]','[{2,72000},{61,3600}]','60404201','雅典娜生命提升<color@7>36%+72000</color>'),(110300022,13,'13级生命印记','[{0,11040002,18}]','[{2,83200},{61,3900}]','60404201','雅典娜生命提升<color@7>39%+83200</color>'),(110300022,14,'14级生命印记','[{0,11040002,20}]','[{2,95200},{61,4200}]','60404201','雅典娜生命提升<color@7>42%+95200</color>'),(110300022,15,'15级生命印记','[{0,11040002,22}]','[{2,108000},{61,4500}]','60404201','雅典娜生命提升<color@7>45%+108000</color>'),(110300022,16,'16级生命印记','[{0,11040002,24}]','[{2,121600},{61,4800}]','60404201','雅典娜生命提升<color@7>48%+121600</color>'),(110300022,17,'17级生命印记','[{0,11040002,26}]','[{2,136000},{61,5100}]','60404201','雅典娜生命提升<color@7>51%+136000</color>'),(110300022,18,'18级生命印记','[{0,11040002,28}]','[{2,151200},{61,5400}]','60404201','雅典娜生命提升<color@7>54%+151200</color>'),(110300022,19,'19级生命印记','[{0,11040002,30}]','[{2,167200},{61,5700}]','60404201','雅典娜生命提升<color@7>57%+167200</color>'),(110300022,20,'20级生命印记','[]','[{2,184000},{61,6000}]','60404201','雅典娜生命提升<color@7>60%+184000</color>'),(110300023,1,'1级命中印记','[{0,11040002,2}]','[{5,32},{64,300}]','12010201','雅典娜命中提升<color@7>3%+32</color>'),(110300023,2,'2级命中印记','[{0,11040002,3}]','[{5,80},{64,600}]','12010201','雅典娜命中提升<color@7>6%+80</color>'),(110300023,3,'3级命中印记','[{0,11040002,4}]','[{5,144},{64,900}]','12010201','雅典娜命中提升<color@7>9%+144</color>'),(110300023,4,'4级命中印记','[{0,11040002,5}]','[{5,224},{64,1200}]','12010201','雅典娜命中提升<color@7>12%+224</color>'),(110300023,5,'5级命中印记','[{0,11040002,6}]','[{5,320},{64,1500}]','12010201','雅典娜命中提升<color@7>15%+320</color>'),(110300023,6,'6级命中印记','[{0,11040002,7}]','[{5,432},{64,1800}]','12010201','雅典娜命中提升<color@7>18%+432</color>'),(110300023,7,'7级命中印记','[{0,11040002,8}]','[{5,560},{64,2100}]','12010201','雅典娜命中提升<color@7>21%+560</color>'),(110300023,8,'8级命中印记','[{0,11040002,9}]','[{5,704},{64,2400}]','12010201','雅典娜命中提升<color@7>24%+704</color>'),(110300023,9,'9级命中印记','[{0,11040002,10}]','[{5,864},{64,2700}]','12010201','雅典娜命中提升<color@7>27%+864</color>'),(110300023,10,'10级命中印记','[{0,11040002,12}]','[{5,1040},{64,3000}]','12010201','雅典娜命中提升<color@7>30%+1040</color>'),(110300023,11,'11级命中印记','[{0,11040002,14}]','[{5,1232},{64,3300}]','12010201','雅典娜命中提升<color@7>33%+1232</color>'),(110300023,12,'12级命中印记','[{0,11040002,16}]','[{5,1440},{64,3600}]','12010201','雅典娜命中提升<color@7>36%+1440</color>'),(110300023,13,'13级命中印记','[{0,11040002,18}]','[{5,1664},{64,3900}]','12010201','雅典娜命中提升<color@7>39%+1664</color>'),(110300023,14,'14级命中印记','[{0,11040002,20}]','[{5,1904},{64,4200}]','12010201','雅典娜命中提升<color@7>42%+1904</color>'),(110300023,15,'15级命中印记','[{0,11040002,22}]','[{5,2160},{64,4500}]','12010201','雅典娜命中提升<color@7>45%+2160</color>'),(110300023,16,'16级命中印记','[{0,11040002,24}]','[{5,2432},{64,4800}]','12010201','雅典娜命中提升<color@7>48%+2432</color>'),(110300023,17,'17级命中印记','[{0,11040002,26}]','[{5,2720},{64,5100}]','12010201','雅典娜命中提升<color@7>51%+2720</color>'),(110300023,18,'18级命中印记','[{0,11040002,28}]','[{5,3024},{64,5400}]','12010201','雅典娜命中提升<color@7>54%+3024</color>'),(110300023,19,'19级命中印记','[{0,11040002,30}]','[{5,3344},{64,5700}]','12010201','雅典娜命中提升<color@7>57%+3344</color>'),(110300023,20,'20级命中印记','[]','[{5,3680},{64,6000}]','12010201','雅典娜命中提升<color@7>60%+3680</color>'),(110300024,1,'1级闪避印记','[{0,11040002,2}]','[{6,32},{65,300}]','12010105','雅典娜闪避提升<color@7>3%+32</color>'),(110300024,2,'2级闪避印记','[{0,11040002,3}]','[{6,80},{65,600}]','12010105','雅典娜闪避提升<color@7>6%+80</color>'),(110300024,3,'3级闪避印记','[{0,11040002,4}]','[{6,144},{65,900}]','12010105','雅典娜闪避提升<color@7>9%+144</color>'),(110300024,4,'4级闪避印记','[{0,11040002,5}]','[{6,224},{65,1200}]','12010105','雅典娜闪避提升<color@7>12%+224</color>'),(110300024,5,'5级闪避印记','[{0,11040002,6}]','[{6,320},{65,1500}]','12010105','雅典娜闪避提升<color@7>15%+320</color>'),(110300024,6,'6级闪避印记','[{0,11040002,7}]','[{6,432},{65,1800}]','12010105','雅典娜闪避提升<color@7>18%+432</color>'),(110300024,7,'7级闪避印记','[{0,11040002,8}]','[{6,560},{65,2100}]','12010105','雅典娜闪避提升<color@7>21%+560</color>'),(110300024,8,'8级闪避印记','[{0,11040002,9}]','[{6,704},{65,2400}]','12010105','雅典娜闪避提升<color@7>24%+704</color>'),(110300024,9,'9级闪避印记','[{0,11040002,10}]','[{6,864},{65,2700}]','12010105','雅典娜闪避提升<color@7>27%+864</color>'),(110300024,10,'10级闪避印记','[{0,11040002,12}]','[{6,1040},{65,3000}]','12010105','雅典娜闪避提升<color@7>30%+1040</color>'),(110300024,11,'11级闪避印记','[{0,11040002,14}]','[{6,1232},{65,3300}]','12010105','雅典娜闪避提升<color@7>33%+1232</color>'),(110300024,12,'12级闪避印记','[{0,11040002,16}]','[{6,1440},{65,3600}]','12010105','雅典娜闪避提升<color@7>36%+1440</color>'),(110300024,13,'13级闪避印记','[{0,11040002,18}]','[{6,1664},{65,3900}]','12010105','雅典娜闪避提升<color@7>39%+1664</color>'),(110300024,14,'14级闪避印记','[{0,11040002,20}]','[{6,1904},{65,4200}]','12010105','雅典娜闪避提升<color@7>42%+1904</color>'),(110300024,15,'15级闪避印记','[{0,11040002,22}]','[{6,2160},{65,4500}]','12010105','雅典娜闪避提升<color@7>45%+2160</color>'),(110300024,16,'16级闪避印记','[{0,11040002,24}]','[{6,2432},{65,4800}]','12010105','雅典娜闪避提升<color@7>48%+2432</color>'),(110300024,17,'17级闪避印记','[{0,11040002,26}]','[{6,2720},{65,5100}]','12010105','雅典娜闪避提升<color@7>51%+2720</color>'),(110300024,18,'18级闪避印记','[{0,11040002,28}]','[{6,3024},{65,5400}]','12010105','雅典娜闪避提升<color@7>54%+3024</color>'),(110300024,19,'19级闪避印记','[{0,11040002,30}]','[{6,3344},{65,5700}]','12010105','雅典娜闪避提升<color@7>57%+3344</color>'),(110300024,20,'20级闪避印记','[]','[{6,3680},{65,6000}]','12010105','雅典娜闪避提升<color@7>60%+3680</color>'),(110300031,1,'1级攻击印记','[{0,11040005,2}]','[{1,70},{60,300}]','12010005','月神攻击提升<color@7>3%+70</color>'),(110300031,2,'2级攻击印记','[{0,11040005,3}]','[{1,175},{60,600}]','12010005','月神攻击提升<color@7>6%+175</color>'),(110300031,3,'3级攻击印记','[{0,11040005,4}]','[{1,315},{60,900}]','12010005','月神攻击提升<color@7>9%+315</color>'),(110300031,4,'4级攻击印记','[{0,11040005,5}]','[{1,490},{60,1200}]','12010005','月神攻击提升<color@7>12%+490</color>'),(110300031,5,'5级攻击印记','[{0,11040005,6}]','[{1,700},{60,1500}]','12010005','月神攻击提升<color@7>15%+700</color>'),(110300031,6,'6级攻击印记','[{0,11040005,7}]','[{1,945},{60,1800}]','12010005','月神攻击提升<color@7>18%+945</color>'),(110300031,7,'7级攻击印记','[{0,11040005,8}]','[{1,1225},{60,2100}]','12010005','月神攻击提升<color@7>21%+1225</color>'),(110300031,8,'8级攻击印记','[{0,11040005,9}]','[{1,1540},{60,2400}]','12010005','月神攻击提升<color@7>24%+1540</color>'),(110300031,9,'9级攻击印记','[{0,11040005,10}]','[{1,1890},{60,2700}]','12010005','月神攻击提升<color@7>27%+1890</color>'),(110300031,10,'10级攻击印记','[{0,11040005,12}]','[{1,2275},{60,3000}]','12010005','月神攻击提升<color@7>30%+2275</color>'),(110300031,11,'11级攻击印记','[{0,11040005,14}]','[{1,2695},{60,3300}]','12010005','月神攻击提升<color@7>33%+2695</color>'),(110300031,12,'12级攻击印记','[{0,11040005,16}]','[{1,3150},{60,3600}]','12010005','月神攻击提升<color@7>36%+3150</color>'),(110300031,13,'13级攻击印记','[{0,11040005,18}]','[{1,3640},{60,3900}]','12010005','月神攻击提升<color@7>39%+3640</color>'),(110300031,14,'14级攻击印记','[{0,11040005,20}]','[{1,4165},{60,4200}]','12010005','月神攻击提升<color@7>42%+4165</color>'),(110300031,15,'15级攻击印记','[{0,11040005,22}]','[{1,4725},{60,4500}]','12010005','月神攻击提升<color@7>45%+4725</color>'),(110300031,16,'16级攻击印记','[{0,11040005,24}]','[{1,5320},{60,4800}]','12010005','月神攻击提升<color@7>48%+5320</color>'),(110300031,17,'17级攻击印记','[{0,11040005,26}]','[{1,5950},{60,5100}]','12010005','月神攻击提升<color@7>51%+5950</color>'),(110300031,18,'18级攻击印记','[{0,11040005,28}]','[{1,6615},{60,5400}]','12010005','月神攻击提升<color@7>54%+6615</color>'),(110300031,19,'19级攻击印记','[{0,11040005,30}]','[{1,7315},{60,5700}]','12010005','月神攻击提升<color@7>57%+7315</color>'),(110300031,20,'20级攻击印记','[]','[{1,8050},{60,6000}]','12010005','月神攻击提升<color@7>60%+8050</color>'),(110300032,1,'1级生命印记','[{0,11040005,2}]','[{2,1400},{61,300}]','60404201','月神生命提升<color@7>3%+1400</color>'),(110300032,2,'2级生命印记','[{0,11040005,3}]','[{2,3500},{61,600}]','60404201','月神生命提升<color@7>6%+3500</color>'),(110300032,3,'3级生命印记','[{0,11040005,4}]','[{2,6300},{61,900}]','60404201','月神生命提升<color@7>9%+6300</color>'),(110300032,4,'4级生命印记','[{0,11040005,5}]','[{2,9800},{61,1200}]','60404201','月神生命提升<color@7>12%+9800</color>'),(110300032,5,'5级生命印记','[{0,11040005,6}]','[{2,14000},{61,1500}]','60404201','月神生命提升<color@7>15%+14000</color>'),(110300032,6,'6级生命印记','[{0,11040005,7}]','[{2,18900},{61,1800}]','60404201','月神生命提升<color@7>18%+18900</color>'),(110300032,7,'7级生命印记','[{0,11040005,8}]','[{2,24500},{61,2100}]','60404201','月神生命提升<color@7>21%+24500</color>'),(110300032,8,'8级生命印记','[{0,11040005,9}]','[{2,30800},{61,2400}]','60404201','月神生命提升<color@7>24%+30800</color>'),(110300032,9,'9级生命印记','[{0,11040005,10}]','[{2,37800},{61,2700}]','60404201','月神生命提升<color@7>27%+37800</color>'),(110300032,10,'10级生命印记','[{0,11040005,12}]','[{2,45500},{61,3000}]','60404201','月神生命提升<color@7>30%+45500</color>'),(110300032,11,'11级生命印记','[{0,11040005,14}]','[{2,53900},{61,3300}]','60404201','月神生命提升<color@7>33%+53900</color>'),(110300032,12,'12级生命印记','[{0,11040005,16}]','[{2,63000},{61,3600}]','60404201','月神生命提升<color@7>36%+63000</color>'),(110300032,13,'13级生命印记','[{0,11040005,18}]','[{2,72800},{61,3900}]','60404201','月神生命提升<color@7>39%+72800</color>'),(110300032,14,'14级生命印记','[{0,11040005,20}]','[{2,83300},{61,4200}]','60404201','月神生命提升<color@7>42%+83300</color>'),(110300032,15,'15级生命印记','[{0,11040005,22}]','[{2,94500},{61,4500}]','60404201','月神生命提升<color@7>45%+94500</color>'),(110300032,16,'16级生命印记','[{0,11040005,24}]','[{2,106400},{61,4800}]','60404201','月神生命提升<color@7>48%+106400</color>'),(110300032,17,'17级生命印记','[{0,11040005,26}]','[{2,119000},{61,5100}]','60404201','月神生命提升<color@7>51%+119000</color>'),(110300032,18,'18级生命印记','[{0,11040005,28}]','[{2,132300},{61,5400}]','60404201','月神生命提升<color@7>54%+132300</color>'),(110300032,19,'19级生命印记','[{0,11040005,30}]','[{2,146300},{61,5700}]','60404201','月神生命提升<color@7>57%+146300</color>'),(110300032,20,'20级生命印记','[]','[{2,161000},{61,6000}]','60404201','月神生命提升<color@7>60%+161000</color>'),(110300033,1,'1级命中印记','[{0,11040005,2}]','[{5,28},{64,300}]','12010201','月神命中提升<color@7>3%+28</color>'),(110300033,2,'2级命中印记','[{0,11040005,3}]','[{5,70},{64,600}]','12010201','月神命中提升<color@7>6%+70</color>'),(110300033,3,'3级命中印记','[{0,11040005,4}]','[{5,126},{64,900}]','12010201','月神命中提升<color@7>9%+126</color>'),(110300033,4,'4级命中印记','[{0,11040005,5}]','[{5,196},{64,1200}]','12010201','月神命中提升<color@7>12%+196</color>'),(110300033,5,'5级命中印记','[{0,11040005,6}]','[{5,280},{64,1500}]','12010201','月神命中提升<color@7>15%+280</color>'),(110300033,6,'6级命中印记','[{0,11040005,7}]','[{5,378},{64,1800}]','12010201','月神命中提升<color@7>18%+378</color>'),(110300033,7,'7级命中印记','[{0,11040005,8}]','[{5,490},{64,2100}]','12010201','月神命中提升<color@7>21%+490</color>'),(110300033,8,'8级命中印记','[{0,11040005,9}]','[{5,616},{64,2400}]','12010201','月神命中提升<color@7>24%+616</color>'),(110300033,9,'9级命中印记','[{0,11040005,10}]','[{5,756},{64,2700}]','12010201','月神命中提升<color@7>27%+756</color>'),(110300033,10,'10级命中印记','[{0,11040005,12}]','[{5,910},{64,3000}]','12010201','月神命中提升<color@7>30%+910</color>'),(110300033,11,'11级命中印记','[{0,11040005,14}]','[{5,1078},{64,3300}]','12010201','月神命中提升<color@7>33%+1078</color>'),(110300033,12,'12级命中印记','[{0,11040005,16}]','[{5,1260},{64,3600}]','12010201','月神命中提升<color@7>36%+1260</color>'),(110300033,13,'13级命中印记','[{0,11040005,18}]','[{5,1456},{64,3900}]','12010201','月神命中提升<color@7>39%+1456</color>'),(110300033,14,'14级命中印记','[{0,11040005,20}]','[{5,1666},{64,4200}]','12010201','月神命中提升<color@7>42%+1666</color>'),(110300033,15,'15级命中印记','[{0,11040005,22}]','[{5,1890},{64,4500}]','12010201','月神命中提升<color@7>45%+1890</color>'),(110300033,16,'16级命中印记','[{0,11040005,24}]','[{5,2128},{64,4800}]','12010201','月神命中提升<color@7>48%+2128</color>'),(110300033,17,'17级命中印记','[{0,11040005,26}]','[{5,2380},{64,5100}]','12010201','月神命中提升<color@7>51%+2380</color>'),(110300033,18,'18级命中印记','[{0,11040005,28}]','[{5,2646},{64,5400}]','12010201','月神命中提升<color@7>54%+2646</color>'),(110300033,19,'19级命中印记','[{0,11040005,30}]','[{5,2926},{64,5700}]','12010201','月神命中提升<color@7>57%+2926</color>'),(110300033,20,'20级命中印记','[]','[{5,3220},{64,6000}]','12010201','月神命中提升<color@7>60%+3220</color>'),(110300034,1,'1级闪避印记','[{0,11040005,2}]','[{6,28},{65,300}]','12010105','月神闪避提升<color@7>3%+28</color>'),(110300034,2,'2级闪避印记','[{0,11040005,3}]','[{6,70},{65,600}]','12010105','月神闪避提升<color@7>6%+70</color>'),(110300034,3,'3级闪避印记','[{0,11040005,4}]','[{6,126},{65,900}]','12010105','月神闪避提升<color@7>9%+126</color>'),(110300034,4,'4级闪避印记','[{0,11040005,5}]','[{6,196},{65,1200}]','12010105','月神闪避提升<color@7>12%+196</color>'),(110300034,5,'5级闪避印记','[{0,11040005,6}]','[{6,280},{65,1500}]','12010105','月神闪避提升<color@7>15%+280</color>'),(110300034,6,'6级闪避印记','[{0,11040005,7}]','[{6,378},{65,1800}]','12010105','月神闪避提升<color@7>18%+378</color>'),(110300034,7,'7级闪避印记','[{0,11040005,8}]','[{6,490},{65,2100}]','12010105','月神闪避提升<color@7>21%+490</color>'),(110300034,8,'8级闪避印记','[{0,11040005,9}]','[{6,616},{65,2400}]','12010105','月神闪避提升<color@7>24%+616</color>'),(110300034,9,'9级闪避印记','[{0,11040005,10}]','[{6,756},{65,2700}]','12010105','月神闪避提升<color@7>27%+756</color>'),(110300034,10,'10级闪避印记','[{0,11040005,12}]','[{6,910},{65,3000}]','12010105','月神闪避提升<color@7>30%+910</color>'),(110300034,11,'11级闪避印记','[{0,11040005,14}]','[{6,1078},{65,3300}]','12010105','月神闪避提升<color@7>33%+1078</color>'),(110300034,12,'12级闪避印记','[{0,11040005,16}]','[{6,1260},{65,3600}]','12010105','月神闪避提升<color@7>36%+1260</color>'),(110300034,13,'13级闪避印记','[{0,11040005,18}]','[{6,1456},{65,3900}]','12010105','月神闪避提升<color@7>39%+1456</color>'),(110300034,14,'14级闪避印记','[{0,11040005,20}]','[{6,1666},{65,4200}]','12010105','月神闪避提升<color@7>42%+1666</color>'),(110300034,15,'15级闪避印记','[{0,11040005,22}]','[{6,1890},{65,4500}]','12010105','月神闪避提升<color@7>45%+1890</color>'),(110300034,16,'16级闪避印记','[{0,11040005,24}]','[{6,2128},{65,4800}]','12010105','月神闪避提升<color@7>48%+2128</color>'),(110300034,17,'17级闪避印记','[{0,11040005,26}]','[{6,2380},{65,5100}]','12010105','月神闪避提升<color@7>51%+2380</color>'),(110300034,18,'18级闪避印记','[{0,11040005,28}]','[{6,2646},{65,5400}]','12010105','月神闪避提升<color@7>54%+2646</color>'),(110300034,19,'19级闪避印记','[{0,11040005,30}]','[{6,2926},{65,5700}]','12010105','月神闪避提升<color@7>57%+2926</color>'),(110300034,20,'20级闪避印记','[]','[{6,3220},{65,6000}]','12010105','月神闪避提升<color@7>60%+3220</color>'),(110300041,1,'1级攻击印记','[{0,11040004,2}]','[{1,60},{60,300}]','12010005','冰雪女王攻击提升<color@7>3%+60</color>'),(110300041,2,'2级攻击印记','[{0,11040004,3}]','[{1,150},{60,600}]','12010005','冰雪女王攻击提升<color@7>6%+150</color>'),(110300041,3,'3级攻击印记','[{0,11040004,4}]','[{1,270},{60,900}]','12010005','冰雪女王攻击提升<color@7>9%+270</color>'),(110300041,4,'4级攻击印记','[{0,11040004,5}]','[{1,420},{60,1200}]','12010005','冰雪女王攻击提升<color@7>12%+420</color>'),(110300041,5,'5级攻击印记','[{0,11040004,6}]','[{1,600},{60,1500}]','12010005','冰雪女王攻击提升<color@7>15%+600</color>'),(110300041,6,'6级攻击印记','[{0,11040004,7}]','[{1,810},{60,1800}]','12010005','冰雪女王攻击提升<color@7>18%+810</color>'),(110300041,7,'7级攻击印记','[{0,11040004,8}]','[{1,1050},{60,2100}]','12010005','冰雪女王攻击提升<color@7>21%+1050</color>'),(110300041,8,'8级攻击印记','[{0,11040004,9}]','[{1,1320},{60,2400}]','12010005','冰雪女王攻击提升<color@7>24%+1320</color>'),(110300041,9,'9级攻击印记','[{0,11040004,10}]','[{1,1620},{60,2700}]','12010005','冰雪女王攻击提升<color@7>27%+1620</color>'),(110300041,10,'10级攻击印记','[{0,11040004,12}]','[{1,1950},{60,3000}]','12010005','冰雪女王攻击提升<color@7>30%+1950</color>'),(110300041,11,'11级攻击印记','[{0,11040004,14}]','[{1,2310},{60,3300}]','12010005','冰雪女王攻击提升<color@7>33%+2310</color>'),(110300041,12,'12级攻击印记','[{0,11040004,16}]','[{1,2700},{60,3600}]','12010005','冰雪女王攻击提升<color@7>36%+2700</color>'),(110300041,13,'13级攻击印记','[{0,11040004,18}]','[{1,3120},{60,3900}]','12010005','冰雪女王攻击提升<color@7>39%+3120</color>'),(110300041,14,'14级攻击印记','[{0,11040004,20}]','[{1,3570},{60,4200}]','12010005','冰雪女王攻击提升<color@7>42%+3570</color>'),(110300041,15,'15级攻击印记','[{0,11040004,22}]','[{1,4050},{60,4500}]','12010005','冰雪女王攻击提升<color@7>45%+4050</color>'),(110300041,16,'16级攻击印记','[{0,11040004,24}]','[{1,4560},{60,4800}]','12010005','冰雪女王攻击提升<color@7>48%+4560</color>'),(110300041,17,'17级攻击印记','[{0,11040004,26}]','[{1,5100},{60,5100}]','12010005','冰雪女王攻击提升<color@7>51%+5100</color>'),(110300041,18,'18级攻击印记','[{0,11040004,28}]','[{1,5670},{60,5400}]','12010005','冰雪女王攻击提升<color@7>54%+5670</color>'),(110300041,19,'19级攻击印记','[{0,11040004,30}]','[{1,6270},{60,5700}]','12010005','冰雪女王攻击提升<color@7>57%+6270</color>'),(110300041,20,'20级攻击印记','[]','[{1,6900},{60,6000}]','12010005','冰雪女王攻击提升<color@7>60%+6900</color>'),(110300042,1,'1级生命印记','[{0,11040004,2}]','[{2,1200},{61,300}]','60404201','冰雪女王生命提升<color@7>3%+1200</color>'),(110300042,2,'2级生命印记','[{0,11040004,3}]','[{2,3000},{61,600}]','60404201','冰雪女王生命提升<color@7>6%+3000</color>'),(110300042,3,'3级生命印记','[{0,11040004,4}]','[{2,5400},{61,900}]','60404201','冰雪女王生命提升<color@7>9%+5400</color>'),(110300042,4,'4级生命印记','[{0,11040004,5}]','[{2,8400},{61,1200}]','60404201','冰雪女王生命提升<color@7>12%+8400</color>'),(110300042,5,'5级生命印记','[{0,11040004,6}]','[{2,12000},{61,1500}]','60404201','冰雪女王生命提升<color@7>15%+12000</color>'),(110300042,6,'6级生命印记','[{0,11040004,7}]','[{2,16200},{61,1800}]','60404201','冰雪女王生命提升<color@7>18%+16200</color>'),(110300042,7,'7级生命印记','[{0,11040004,8}]','[{2,21000},{61,2100}]','60404201','冰雪女王生命提升<color@7>21%+21000</color>'),(110300042,8,'8级生命印记','[{0,11040004,9}]','[{2,26400},{61,2400}]','60404201','冰雪女王生命提升<color@7>24%+26400</color>'),(110300042,9,'9级生命印记','[{0,11040004,10}]','[{2,32400},{61,2700}]','60404201','冰雪女王生命提升<color@7>27%+32400</color>'),(110300042,10,'10级生命印记','[{0,11040004,12}]','[{2,39000},{61,3000}]','60404201','冰雪女王生命提升<color@7>30%+39000</color>'),(110300042,11,'11级生命印记','[{0,11040004,14}]','[{2,46200},{61,3300}]','60404201','冰雪女王生命提升<color@7>33%+46200</color>'),(110300042,12,'12级生命印记','[{0,11040004,16}]','[{2,54000},{61,3600}]','60404201','冰雪女王生命提升<color@7>36%+54000</color>'),(110300042,13,'13级生命印记','[{0,11040004,18}]','[{2,62400},{61,3900}]','60404201','冰雪女王生命提升<color@7>39%+62400</color>'),(110300042,14,'14级生命印记','[{0,11040004,20}]','[{2,71400},{61,4200}]','60404201','冰雪女王生命提升<color@7>42%+71400</color>'),(110300042,15,'15级生命印记','[{0,11040004,22}]','[{2,81000},{61,4500}]','60404201','冰雪女王生命提升<color@7>45%+81000</color>'),(110300042,16,'16级生命印记','[{0,11040004,24}]','[{2,91200},{61,4800}]','60404201','冰雪女王生命提升<color@7>48%+91200</color>'),(110300042,17,'17级生命印记','[{0,11040004,26}]','[{2,102000},{61,5100}]','60404201','冰雪女王生命提升<color@7>51%+102000</color>'),(110300042,18,'18级生命印记','[{0,11040004,28}]','[{2,113400},{61,5400}]','60404201','冰雪女王生命提升<color@7>54%+113400</color>'),(110300042,19,'19级生命印记','[{0,11040004,30}]','[{2,125400},{61,5700}]','60404201','冰雪女王生命提升<color@7>57%+125400</color>'),(110300042,20,'20级生命印记','[]','[{2,138000},{61,6000}]','60404201','冰雪女王生命提升<color@7>60%+138000</color>'),(110300043,1,'1级命中印记','[{0,11040004,2}]','[{5,24},{64,300}]','12010201','冰雪女王命中提升<color@7>3%+24</color>'),(110300043,2,'2级命中印记','[{0,11040004,3}]','[{5,60},{64,600}]','12010201','冰雪女王命中提升<color@7>6%+60</color>'),(110300043,3,'3级命中印记','[{0,11040004,4}]','[{5,108},{64,900}]','12010201','冰雪女王命中提升<color@7>9%+108</color>'),(110300043,4,'4级命中印记','[{0,11040004,5}]','[{5,168},{64,1200}]','12010201','冰雪女王命中提升<color@7>12%+168</color>'),(110300043,5,'5级命中印记','[{0,11040004,6}]','[{5,240},{64,1500}]','12010201','冰雪女王命中提升<color@7>15%+240</color>'),(110300043,6,'6级命中印记','[{0,11040004,7}]','[{5,324},{64,1800}]','12010201','冰雪女王命中提升<color@7>18%+324</color>'),(110300043,7,'7级命中印记','[{0,11040004,8}]','[{5,420},{64,2100}]','12010201','冰雪女王命中提升<color@7>21%+420</color>'),(110300043,8,'8级命中印记','[{0,11040004,9}]','[{5,528},{64,2400}]','12010201','冰雪女王命中提升<color@7>24%+528</color>'),(110300043,9,'9级命中印记','[{0,11040004,10}]','[{5,648},{64,2700}]','12010201','冰雪女王命中提升<color@7>27%+648</color>'),(110300043,10,'10级命中印记','[{0,11040004,12}]','[{5,780},{64,3000}]','12010201','冰雪女王命中提升<color@7>30%+780</color>'),(110300043,11,'11级命中印记','[{0,11040004,14}]','[{5,924},{64,3300}]','12010201','冰雪女王命中提升<color@7>33%+924</color>'),(110300043,12,'12级命中印记','[{0,11040004,16}]','[{5,1080},{64,3600}]','12010201','冰雪女王命中提升<color@7>36%+1080</color>'),(110300043,13,'13级命中印记','[{0,11040004,18}]','[{5,1248},{64,3900}]','12010201','冰雪女王命中提升<color@7>39%+1248</color>'),(110300043,14,'14级命中印记','[{0,11040004,20}]','[{5,1428},{64,4200}]','12010201','冰雪女王命中提升<color@7>42%+1428</color>'),(110300043,15,'15级命中印记','[{0,11040004,22}]','[{5,1620},{64,4500}]','12010201','冰雪女王命中提升<color@7>45%+1620</color>'),(110300043,16,'16级命中印记','[{0,11040004,24}]','[{5,1824},{64,4800}]','12010201','冰雪女王命中提升<color@7>48%+1824</color>'),(110300043,17,'17级命中印记','[{0,11040004,26}]','[{5,2040},{64,5100}]','12010201','冰雪女王命中提升<color@7>51%+2040</color>'),(110300043,18,'18级命中印记','[{0,11040004,28}]','[{5,2268},{64,5400}]','12010201','冰雪女王命中提升<color@7>54%+2268</color>'),(110300043,19,'19级命中印记','[{0,11040004,30}]','[{5,2508},{64,5700}]','12010201','冰雪女王命中提升<color@7>57%+2508</color>'),(110300043,20,'20级命中印记','[]','[{5,2760},{64,6000}]','12010201','冰雪女王命中提升<color@7>60%+2760</color>'),(110300044,1,'1级闪避印记','[{0,11040004,2}]','[{6,24},{65,300}]','12010105','冰雪女王闪避提升<color@7>3%+24</color>'),(110300044,2,'2级闪避印记','[{0,11040004,3}]','[{6,60},{65,600}]','12010105','冰雪女王闪避提升<color@7>6%+60</color>'),(110300044,3,'3级闪避印记','[{0,11040004,4}]','[{6,108},{65,900}]','12010105','冰雪女王闪避提升<color@7>9%+108</color>'),(110300044,4,'4级闪避印记','[{0,11040004,5}]','[{6,168},{65,1200}]','12010105','冰雪女王闪避提升<color@7>12%+168</color>'),(110300044,5,'5级闪避印记','[{0,11040004,6}]','[{6,240},{65,1500}]','12010105','冰雪女王闪避提升<color@7>15%+240</color>'),(110300044,6,'6级闪避印记','[{0,11040004,7}]','[{6,324},{65,1800}]','12010105','冰雪女王闪避提升<color@7>18%+324</color>'),(110300044,7,'7级闪避印记','[{0,11040004,8}]','[{6,420},{65,2100}]','12010105','冰雪女王闪避提升<color@7>21%+420</color>'),(110300044,8,'8级闪避印记','[{0,11040004,9}]','[{6,528},{65,2400}]','12010105','冰雪女王闪避提升<color@7>24%+528</color>'),(110300044,9,'9级闪避印记','[{0,11040004,10}]','[{6,648},{65,2700}]','12010105','冰雪女王闪避提升<color@7>27%+648</color>'),(110300044,10,'10级闪避印记','[{0,11040004,12}]','[{6,780},{65,3000}]','12010105','冰雪女王闪避提升<color@7>30%+780</color>'),(110300044,11,'11级闪避印记','[{0,11040004,14}]','[{6,924},{65,3300}]','12010105','冰雪女王闪避提升<color@7>33%+924</color>'),(110300044,12,'12级闪避印记','[{0,11040004,16}]','[{6,1080},{65,3600}]','12010105','冰雪女王闪避提升<color@7>36%+1080</color>'),(110300044,13,'13级闪避印记','[{0,11040004,18}]','[{6,1248},{65,3900}]','12010105','冰雪女王闪避提升<color@7>39%+1248</color>'),(110300044,14,'14级闪避印记','[{0,11040004,20}]','[{6,1428},{65,4200}]','12010105','冰雪女王闪避提升<color@7>42%+1428</color>'),(110300044,15,'15级闪避印记','[{0,11040004,22}]','[{6,1620},{65,4500}]','12010105','冰雪女王闪避提升<color@7>45%+1620</color>'),(110300044,16,'16级闪避印记','[{0,11040004,24}]','[{6,1824},{65,4800}]','12010105','冰雪女王闪避提升<color@7>48%+1824</color>'),(110300044,17,'17级闪避印记','[{0,11040004,26}]','[{6,2040},{65,5100}]','12010105','冰雪女王闪避提升<color@7>51%+2040</color>'),(110300044,18,'18级闪避印记','[{0,11040004,28}]','[{6,2268},{65,5400}]','12010105','冰雪女王闪避提升<color@7>54%+2268</color>'),(110300044,19,'19级闪避印记','[{0,11040004,30}]','[{6,2508},{65,5700}]','12010105','冰雪女王闪避提升<color@7>57%+2508</color>'),(110300044,20,'20级闪避印记','[]','[{6,2760},{65,6000}]','12010105','冰雪女王闪避提升<color@7>60%+2760</color>'),(110300051,1,'1级攻击印记','[{0,11040003,2}]','[{1,50},{60,300}]','12010005','光辉神攻击提升<color@7>3%+50</color>'),(110300051,2,'2级攻击印记','[{0,11040003,3}]','[{1,125},{60,600}]','12010005','光辉神攻击提升<color@7>6%+125</color>'),(110300051,3,'3级攻击印记','[{0,11040003,4}]','[{1,225},{60,900}]','12010005','光辉神攻击提升<color@7>9%+225</color>'),(110300051,4,'4级攻击印记','[{0,11040003,5}]','[{1,350},{60,1200}]','12010005','光辉神攻击提升<color@7>12%+350</color>'),(110300051,5,'5级攻击印记','[{0,11040003,6}]','[{1,500},{60,1500}]','12010005','光辉神攻击提升<color@7>15%+500</color>'),(110300051,6,'6级攻击印记','[{0,11040003,7}]','[{1,675},{60,1800}]','12010005','光辉神攻击提升<color@7>18%+675</color>'),(110300051,7,'7级攻击印记','[{0,11040003,8}]','[{1,875},{60,2100}]','12010005','光辉神攻击提升<color@7>21%+875</color>'),(110300051,8,'8级攻击印记','[{0,11040003,9}]','[{1,1100},{60,2400}]','12010005','光辉神攻击提升<color@7>24%+1100</color>'),(110300051,9,'9级攻击印记','[{0,11040003,10}]','[{1,1350},{60,2700}]','12010005','光辉神攻击提升<color@7>27%+1350</color>'),(110300051,10,'10级攻击印记','[{0,11040003,12}]','[{1,1625},{60,3000}]','12010005','光辉神攻击提升<color@7>30%+1625</color>'),(110300051,11,'11级攻击印记','[{0,11040003,14}]','[{1,1925},{60,3300}]','12010005','光辉神攻击提升<color@7>33%+1925</color>'),(110300051,12,'12级攻击印记','[{0,11040003,16}]','[{1,2250},{60,3600}]','12010005','光辉神攻击提升<color@7>36%+2250</color>'),(110300051,13,'13级攻击印记','[{0,11040003,18}]','[{1,2600},{60,3900}]','12010005','光辉神攻击提升<color@7>39%+2600</color>'),(110300051,14,'14级攻击印记','[{0,11040003,20}]','[{1,2975},{60,4200}]','12010005','光辉神攻击提升<color@7>42%+2975</color>'),(110300051,15,'15级攻击印记','[{0,11040003,22}]','[{1,3375},{60,4500}]','12010005','光辉神攻击提升<color@7>45%+3375</color>'),(110300051,16,'16级攻击印记','[{0,11040003,24}]','[{1,3800},{60,4800}]','12010005','光辉神攻击提升<color@7>48%+3800</color>'),(110300051,17,'17级攻击印记','[{0,11040003,26}]','[{1,4250},{60,5100}]','12010005','光辉神攻击提升<color@7>51%+4250</color>'),(110300051,18,'18级攻击印记','[{0,11040003,28}]','[{1,4725},{60,5400}]','12010005','光辉神攻击提升<color@7>54%+4725</color>'),(110300051,19,'19级攻击印记','[{0,11040003,30}]','[{1,5225},{60,5700}]','12010005','光辉神攻击提升<color@7>57%+5225</color>'),(110300051,20,'20级攻击印记','[]','[{1,5750},{60,6000}]','12010005','光辉神攻击提升<color@7>60%+5750</color>'),(110300052,1,'1级生命印记','[{0,11040003,2}]','[{2,1000},{61,300}]','60404201','光辉神生命提升<color@7>3%+1000</color>'),(110300052,2,'2级生命印记','[{0,11040003,3}]','[{2,2500},{61,600}]','60404201','光辉神生命提升<color@7>6%+2500</color>'),(110300052,3,'3级生命印记','[{0,11040003,4}]','[{2,4500},{61,900}]','60404201','光辉神生命提升<color@7>9%+4500</color>'),(110300052,4,'4级生命印记','[{0,11040003,5}]','[{2,7000},{61,1200}]','60404201','光辉神生命提升<color@7>12%+7000</color>'),(110300052,5,'5级生命印记','[{0,11040003,6}]','[{2,10000},{61,1500}]','60404201','光辉神生命提升<color@7>15%+10000</color>'),(110300052,6,'6级生命印记','[{0,11040003,7}]','[{2,13500},{61,1800}]','60404201','光辉神生命提升<color@7>18%+13500</color>'),(110300052,7,'7级生命印记','[{0,11040003,8}]','[{2,17500},{61,2100}]','60404201','光辉神生命提升<color@7>21%+17500</color>'),(110300052,8,'8级生命印记','[{0,11040003,9}]','[{2,22000},{61,2400}]','60404201','光辉神生命提升<color@7>24%+22000</color>'),(110300052,9,'9级生命印记','[{0,11040003,10}]','[{2,27000},{61,2700}]','60404201','光辉神生命提升<color@7>27%+27000</color>'),(110300052,10,'10级生命印记','[{0,11040003,12}]','[{2,32500},{61,3000}]','60404201','光辉神生命提升<color@7>30%+32500</color>'),(110300052,11,'11级生命印记','[{0,11040003,14}]','[{2,38500},{61,3300}]','60404201','光辉神生命提升<color@7>33%+38500</color>'),(110300052,12,'12级生命印记','[{0,11040003,16}]','[{2,45000},{61,3600}]','60404201','光辉神生命提升<color@7>36%+45000</color>'),(110300052,13,'13级生命印记','[{0,11040003,18}]','[{2,52000},{61,3900}]','60404201','光辉神生命提升<color@7>39%+52000</color>'),(110300052,14,'14级生命印记','[{0,11040003,20}]','[{2,59500},{61,4200}]','60404201','光辉神生命提升<color@7>42%+59500</color>'),(110300052,15,'15级生命印记','[{0,11040003,22}]','[{2,67500},{61,4500}]','60404201','光辉神生命提升<color@7>45%+67500</color>'),(110300052,16,'16级生命印记','[{0,11040003,24}]','[{2,76000},{61,4800}]','60404201','光辉神生命提升<color@7>48%+76000</color>'),(110300052,17,'17级生命印记','[{0,11040003,26}]','[{2,85000},{61,5100}]','60404201','光辉神生命提升<color@7>51%+85000</color>'),(110300052,18,'18级生命印记','[{0,11040003,28}]','[{2,94500},{61,5400}]','60404201','光辉神生命提升<color@7>54%+94500</color>'),(110300052,19,'19级生命印记','[{0,11040003,30}]','[{2,104500},{61,5700}]','60404201','光辉神生命提升<color@7>57%+104500</color>'),(110300052,20,'20级生命印记','[]','[{2,115000},{61,6000}]','60404201','光辉神生命提升<color@7>60%+115000</color>'),(110300053,1,'1级命中印记','[{0,11040003,2}]','[{5,20},{64,300}]','12010201','光辉神命中提升<color@7>3%+20</color>'),(110300053,2,'2级命中印记','[{0,11040003,3}]','[{5,50},{64,600}]','12010201','光辉神命中提升<color@7>6%+50</color>'),(110300053,3,'3级命中印记','[{0,11040003,4}]','[{5,90},{64,900}]','12010201','光辉神命中提升<color@7>9%+90</color>'),(110300053,4,'4级命中印记','[{0,11040003,5}]','[{5,140},{64,1200}]','12010201','光辉神命中提升<color@7>12%+140</color>'),(110300053,5,'5级命中印记','[{0,11040003,6}]','[{5,200},{64,1500}]','12010201','光辉神命中提升<color@7>15%+200</color>'),(110300053,6,'6级命中印记','[{0,11040003,7}]','[{5,270},{64,1800}]','12010201','光辉神命中提升<color@7>18%+270</color>'),(110300053,7,'7级命中印记','[{0,11040003,8}]','[{5,350},{64,2100}]','12010201','光辉神命中提升<color@7>21%+350</color>'),(110300053,8,'8级命中印记','[{0,11040003,9}]','[{5,440},{64,2400}]','12010201','光辉神命中提升<color@7>24%+440</color>'),(110300053,9,'9级命中印记','[{0,11040003,10}]','[{5,540},{64,2700}]','12010201','光辉神命中提升<color@7>27%+540</color>'),(110300053,10,'10级命中印记','[{0,11040003,12}]','[{5,650},{64,3000}]','12010201','光辉神命中提升<color@7>30%+650</color>'),(110300053,11,'11级命中印记','[{0,11040003,14}]','[{5,770},{64,3300}]','12010201','光辉神命中提升<color@7>33%+770</color>'),(110300053,12,'12级命中印记','[{0,11040003,16}]','[{5,900},{64,3600}]','12010201','光辉神命中提升<color@7>36%+900</color>'),(110300053,13,'13级命中印记','[{0,11040003,18}]','[{5,1040},{64,3900}]','12010201','光辉神命中提升<color@7>39%+1040</color>'),(110300053,14,'14级命中印记','[{0,11040003,20}]','[{5,1190},{64,4200}]','12010201','光辉神命中提升<color@7>42%+1190</color>'),(110300053,15,'15级命中印记','[{0,11040003,22}]','[{5,1350},{64,4500}]','12010201','光辉神命中提升<color@7>45%+1350</color>'),(110300053,16,'16级命中印记','[{0,11040003,24}]','[{5,1520},{64,4800}]','12010201','光辉神命中提升<color@7>48%+1520</color>'),(110300053,17,'17级命中印记','[{0,11040003,26}]','[{5,1700},{64,5100}]','12010201','光辉神命中提升<color@7>51%+1700</color>'),(110300053,18,'18级命中印记','[{0,11040003,28}]','[{5,1890},{64,5400}]','12010201','光辉神命中提升<color@7>54%+1890</color>'),(110300053,19,'19级命中印记','[{0,11040003,30}]','[{5,2090},{64,5700}]','12010201','光辉神命中提升<color@7>57%+2090</color>'),(110300053,20,'20级命中印记','[]','[{5,2300},{64,6000}]','12010201','光辉神命中提升<color@7>60%+2300</color>'),(110300054,1,'1级闪避印记','[{0,11040003,2}]','[{6,20},{65,300}]','12010105','光辉神闪避提升<color@7>3%+20</color>'),(110300054,2,'2级闪避印记','[{0,11040003,3}]','[{6,50},{65,600}]','12010105','光辉神闪避提升<color@7>6%+50</color>'),(110300054,3,'3级闪避印记','[{0,11040003,4}]','[{6,90},{65,900}]','12010105','光辉神闪避提升<color@7>9%+90</color>'),(110300054,4,'4级闪避印记','[{0,11040003,5}]','[{6,140},{65,1200}]','12010105','光辉神闪避提升<color@7>12%+140</color>'),(110300054,5,'5级闪避印记','[{0,11040003,6}]','[{6,200},{65,1500}]','12010105','光辉神闪避提升<color@7>15%+200</color>'),(110300054,6,'6级闪避印记','[{0,11040003,7}]','[{6,270},{65,1800}]','12010105','光辉神闪避提升<color@7>18%+270</color>'),(110300054,7,'7级闪避印记','[{0,11040003,8}]','[{6,350},{65,2100}]','12010105','光辉神闪避提升<color@7>21%+350</color>'),(110300054,8,'8级闪避印记','[{0,11040003,9}]','[{6,440},{65,2400}]','12010105','光辉神闪避提升<color@7>24%+440</color>'),(110300054,9,'9级闪避印记','[{0,11040003,10}]','[{6,540},{65,2700}]','12010105','光辉神闪避提升<color@7>27%+540</color>'),(110300054,10,'10级闪避印记','[{0,11040003,12}]','[{6,650},{65,3000}]','12010105','光辉神闪避提升<color@7>30%+650</color>'),(110300054,11,'11级闪避印记','[{0,11040003,14}]','[{6,770},{65,3300}]','12010105','光辉神闪避提升<color@7>33%+770</color>'),(110300054,12,'12级闪避印记','[{0,11040003,16}]','[{6,900},{65,3600}]','12010105','光辉神闪避提升<color@7>36%+900</color>'),(110300054,13,'13级闪避印记','[{0,11040003,18}]','[{6,1040},{65,3900}]','12010105','光辉神闪避提升<color@7>39%+1040</color>'),(110300054,14,'14级闪避印记','[{0,11040003,20}]','[{6,1190},{65,4200}]','12010105','光辉神闪避提升<color@7>42%+1190</color>'),(110300054,15,'15级闪避印记','[{0,11040003,22}]','[{6,1350},{65,4500}]','12010105','光辉神闪避提升<color@7>45%+1350</color>'),(110300054,16,'16级闪避印记','[{0,11040003,24}]','[{6,1520},{65,4800}]','12010105','光辉神闪避提升<color@7>48%+1520</color>'),(110300054,17,'17级闪避印记','[{0,11040003,26}]','[{6,1700},{65,5100}]','12010105','光辉神闪避提升<color@7>51%+1700</color>'),(110300054,18,'18级闪避印记','[{0,11040003,28}]','[{6,1890},{65,5400}]','12010105','光辉神闪避提升<color@7>54%+1890</color>'),(110300054,19,'19级闪避印记','[{0,11040003,30}]','[{6,2090},{65,5700}]','12010105','光辉神闪避提升<color@7>57%+2090</color>'),(110300054,20,'20级闪避印记','[]','[{6,2300},{65,6000}]','12010105','光辉神闪避提升<color@7>60%+2300</color>'),(110300061,1,'1级攻击印记','[{0,11040006,2}]','[{1,125},{60,300}]','12010005','死神攻击提升<color@7>3%+125</color>'),(110300061,2,'2级攻击印记','[{0,11040006,3}]','[{1,300},{60,600}]','12010005','死神攻击提升<color@7>6%+300</color>'),(110300061,3,'3级攻击印记','[{0,11040006,4}]','[{1,525},{60,900}]','12010005','死神攻击提升<color@7>9%+525</color>'),(110300061,4,'4级攻击印记','[{0,11040006,5}]','[{1,800},{60,1200}]','12010005','死神攻击提升<color@7>12%+800</color>'),(110300061,5,'5级攻击印记','[{0,11040006,6}]','[{1,1125},{60,1500}]','12010005','死神攻击提升<color@7>15%+1125</color>'),(110300061,6,'6级攻击印记','[{0,11040006,7}]','[{1,1500},{60,1800}]','12010005','死神攻击提升<color@7>18%+1500</color>'),(110300061,7,'7级攻击印记','[{0,11040006,8}]','[{1,1925},{60,2100}]','12010005','死神攻击提升<color@7>21%+1925</color>'),(110300061,8,'8级攻击印记','[{0,11040006,9}]','[{1,2400},{60,2400}]','12010005','死神攻击提升<color@7>24%+2400</color>'),(110300061,9,'9级攻击印记','[{0,11040006,10}]','[{1,2925},{60,2700}]','12010005','死神攻击提升<color@7>27%+2925</color>'),(110300061,10,'10级攻击印记','[{0,11040006,12}]','[{1,3500},{60,3000}]','12010005','死神攻击提升<color@7>30%+3500</color>'),(110300061,11,'11级攻击印记','[{0,11040006,14}]','[{1,4125},{60,3300}]','12010005','死神攻击提升<color@7>33%+4125</color>'),(110300061,12,'12级攻击印记','[{0,11040006,16}]','[{1,4800},{60,3600}]','12010005','死神攻击提升<color@7>36%+4800</color>'),(110300061,13,'13级攻击印记','[{0,11040006,18}]','[{1,5525},{60,3900}]','12010005','死神攻击提升<color@7>39%+5525</color>'),(110300061,14,'14级攻击印记','[{0,11040006,20}]','[{1,6300},{60,4200}]','12010005','死神攻击提升<color@7>42%+6300</color>'),(110300061,15,'15级攻击印记','[{0,11040006,22}]','[{1,7125},{60,4500}]','12010005','死神攻击提升<color@7>45%+7125</color>'),(110300061,16,'16级攻击印记','[{0,11040006,24}]','[{1,8000},{60,4800}]','12010005','死神攻击提升<color@7>48%+8000</color>'),(110300061,17,'17级攻击印记','[{0,11040006,26}]','[{1,8925},{60,5100}]','12010005','死神攻击提升<color@7>51%+8925</color>'),(110300061,18,'18级攻击印记','[{0,11040006,28}]','[{1,9900},{60,5400}]','12010005','死神攻击提升<color@7>54%+9900</color>'),(110300061,19,'19级攻击印记','[{0,11040006,30}]','[{1,10925},{60,5700}]','12010005','死神攻击提升<color@7>57%+10925</color>'),(110300061,20,'20级攻击印记','[]','[{1,12000},{60,6000}]','12010005','死神攻击提升<color@7>60%+12000</color>'),(110300062,1,'1级生命印记','[{0,11040006,2}]','[{2,2500},{61,300}]','60404201','死神生命提升<color@7>3%+2500</color>'),(110300062,2,'2级生命印记','[{0,11040006,3}]','[{2,6000},{61,600}]','60404201','死神生命提升<color@7>6%+6000</color>'),(110300062,3,'3级生命印记','[{0,11040006,4}]','[{2,10500},{61,900}]','60404201','死神生命提升<color@7>9%+10500</color>'),(110300062,4,'4级生命印记','[{0,11040006,5}]','[{2,16000},{61,1200}]','60404201','死神生命提升<color@7>12%+16000</color>'),(110300062,5,'5级生命印记','[{0,11040006,6}]','[{2,22500},{61,1500}]','60404201','死神生命提升<color@7>15%+22500</color>'),(110300062,6,'6级生命印记','[{0,11040006,7}]','[{2,30000},{61,1800}]','60404201','死神生命提升<color@7>18%+30000</color>'),(110300062,7,'7级生命印记','[{0,11040006,8}]','[{2,38500},{61,2100}]','60404201','死神生命提升<color@7>21%+38500</color>'),(110300062,8,'8级生命印记','[{0,11040006,9}]','[{2,48000},{61,2400}]','60404201','死神生命提升<color@7>24%+48000</color>'),(110300062,9,'9级生命印记','[{0,11040006,10}]','[{2,58500},{61,2700}]','60404201','死神生命提升<color@7>27%+58500</color>'),(110300062,10,'10级生命印记','[{0,11040006,12}]','[{2,70000},{61,3000}]','60404201','死神生命提升<color@7>30%+70000</color>'),(110300062,11,'11级生命印记','[{0,11040006,14}]','[{2,82500},{61,3300}]','60404201','死神生命提升<color@7>33%+82500</color>'),(110300062,12,'12级生命印记','[{0,11040006,16}]','[{2,96000},{61,3600}]','60404201','死神生命提升<color@7>36%+96000</color>'),(110300062,13,'13级生命印记','[{0,11040006,18}]','[{2,110500},{61,3900}]','60404201','死神生命提升<color@7>39%+110500</color>'),(110300062,14,'14级生命印记','[{0,11040006,20}]','[{2,126000},{61,4200}]','60404201','死神生命提升<color@7>42%+126000</color>'),(110300062,15,'15级生命印记','[{0,11040006,22}]','[{2,142500},{61,4500}]','60404201','死神生命提升<color@7>45%+142500</color>'),(110300062,16,'16级生命印记','[{0,11040006,24}]','[{2,160000},{61,4800}]','60404201','死神生命提升<color@7>48%+160000</color>'),(110300062,17,'17级生命印记','[{0,11040006,26}]','[{2,178500},{61,5100}]','60404201','死神生命提升<color@7>51%+178500</color>'),(110300062,18,'18级生命印记','[{0,11040006,28}]','[{2,198000},{61,5400}]','60404201','死神生命提升<color@7>54%+198000</color>'),(110300062,19,'19级生命印记','[{0,11040006,30}]','[{2,218500},{61,5700}]','60404201','死神生命提升<color@7>57%+218500</color>'),(110300062,20,'20级生命印记','[]','[{2,240000},{61,6000}]','60404201','死神生命提升<color@7>60%+240000</color>'),(110300063,1,'1级命中印记','[{0,11040006,2}]','[{5,50},{64,300}]','12010201','死神命中提升<color@7>3%+50</color>'),(110300063,2,'2级命中印记','[{0,11040006,3}]','[{5,120},{64,600}]','12010201','死神命中提升<color@7>6%+120</color>'),(110300063,3,'3级命中印记','[{0,11040006,4}]','[{5,210},{64,900}]','12010201','死神命中提升<color@7>9%+210</color>'),(110300063,4,'4级命中印记','[{0,11040006,5}]','[{5,320},{64,1200}]','12010201','死神命中提升<color@7>12%+320</color>'),(110300063,5,'5级命中印记','[{0,11040006,6}]','[{5,450},{64,1500}]','12010201','死神命中提升<color@7>15%+450</color>'),(110300063,6,'6级命中印记','[{0,11040006,7}]','[{5,600},{64,1800}]','12010201','死神命中提升<color@7>18%+600</color>'),(110300063,7,'7级命中印记','[{0,11040006,8}]','[{5,770},{64,2100}]','12010201','死神命中提升<color@7>21%+770</color>'),(110300063,8,'8级命中印记','[{0,11040006,9}]','[{5,960},{64,2400}]','12010201','死神命中提升<color@7>24%+960</color>'),(110300063,9,'9级命中印记','[{0,11040006,10}]','[{5,1170},{64,2700}]','12010201','死神命中提升<color@7>27%+1170</color>'),(110300063,10,'10级命中印记','[{0,11040006,12}]','[{5,1400},{64,3000}]','12010201','死神命中提升<color@7>30%+1400</color>'),(110300063,11,'11级命中印记','[{0,11040006,14}]','[{5,1650},{64,3300}]','12010201','死神命中提升<color@7>33%+1650</color>'),(110300063,12,'12级命中印记','[{0,11040006,16}]','[{5,1920},{64,3600}]','12010201','死神命中提升<color@7>36%+1920</color>'),(110300063,13,'13级命中印记','[{0,11040006,18}]','[{5,2210},{64,3900}]','12010201','死神命中提升<color@7>39%+2210</color>'),(110300063,14,'14级命中印记','[{0,11040006,20}]','[{5,2520},{64,4200}]','12010201','死神命中提升<color@7>42%+2520</color>'),(110300063,15,'15级命中印记','[{0,11040006,22}]','[{5,2850},{64,4500}]','12010201','死神命中提升<color@7>45%+2850</color>'),(110300063,16,'16级命中印记','[{0,11040006,24}]','[{5,3200},{64,4800}]','12010201','死神命中提升<color@7>48%+3200</color>'),(110300063,17,'17级命中印记','[{0,11040006,26}]','[{5,3570},{64,5100}]','12010201','死神命中提升<color@7>51%+3570</color>'),(110300063,18,'18级命中印记','[{0,11040006,28}]','[{5,3960},{64,5400}]','12010201','死神命中提升<color@7>54%+3960</color>'),(110300063,19,'19级命中印记','[{0,11040006,30}]','[{5,4370},{64,5700}]','12010201','死神命中提升<color@7>57%+4370</color>'),(110300063,20,'20级命中印记','[]','[{5,4800},{64,6000}]','12010201','死神命中提升<color@7>60%+4800</color>'),(110300064,1,'1级闪避印记','[{0,11040006,2}]','[{6,50},{65,300}]','12010105','死神闪避提升<color@7>3%+50</color>'),(110300064,2,'2级闪避印记','[{0,11040006,3}]','[{6,120},{65,600}]','12010105','死神闪避提升<color@7>6%+120</color>'),(110300064,3,'3级闪避印记','[{0,11040006,4}]','[{6,210},{65,900}]','12010105','死神闪避提升<color@7>9%+210</color>'),(110300064,4,'4级闪避印记','[{0,11040006,5}]','[{6,320},{65,1200}]','12010105','死神闪避提升<color@7>12%+320</color>'),(110300064,5,'5级闪避印记','[{0,11040006,6}]','[{6,450},{65,1500}]','12010105','死神闪避提升<color@7>15%+450</color>'),(110300064,6,'6级闪避印记','[{0,11040006,7}]','[{6,600},{65,1800}]','12010105','死神闪避提升<color@7>18%+600</color>'),(110300064,7,'7级闪避印记','[{0,11040006,8}]','[{6,770},{65,2100}]','12010105','死神闪避提升<color@7>21%+770</color>'),(110300064,8,'8级闪避印记','[{0,11040006,9}]','[{6,960},{65,2400}]','12010105','死神闪避提升<color@7>24%+960</color>'),(110300064,9,'9级闪避印记','[{0,11040006,10}]','[{6,1170},{65,2700}]','12010105','死神闪避提升<color@7>27%+1170</color>'),(110300064,10,'10级闪避印记','[{0,11040006,12}]','[{6,1400},{65,3000}]','12010105','死神闪避提升<color@7>30%+1400</color>'),(110300064,11,'11级闪避印记','[{0,11040006,14}]','[{6,1650},{65,3300}]','12010105','死神闪避提升<color@7>33%+1650</color>'),(110300064,12,'12级闪避印记','[{0,11040006,16}]','[{6,1920},{65,3600}]','12010105','死神闪避提升<color@7>36%+1920</color>'),(110300064,13,'13级闪避印记','[{0,11040006,18}]','[{6,2210},{65,3900}]','12010105','死神闪避提升<color@7>39%+2210</color>'),(110300064,14,'14级闪避印记','[{0,11040006,20}]','[{6,2520},{65,4200}]','12010105','死神闪避提升<color@7>42%+2520</color>'),(110300064,15,'15级闪避印记','[{0,11040006,22}]','[{6,2850},{65,4500}]','12010105','死神闪避提升<color@7>45%+2850</color>'),(110300064,16,'16级闪避印记','[{0,11040006,24}]','[{6,3200},{65,4800}]','12010105','死神闪避提升<color@7>48%+3200</color>'),(110300064,17,'17级闪避印记','[{0,11040006,26}]','[{6,3570},{65,5100}]','12010105','死神闪避提升<color@7>51%+3570</color>'),(110300064,18,'18级闪避印记','[{0,11040006,28}]','[{6,3960},{65,5400}]','12010105','死神闪避提升<color@7>54%+3960</color>'),(110300064,19,'19级闪避印记','[{0,11040006,30}]','[{6,4370},{65,5700}]','12010105','死神闪避提升<color@7>57%+4370</color>'),(110300064,20,'20级闪避印记','[]','[{6,4800},{65,6000}]','12010105','死神闪避提升<color@7>60%+4800</color>');
/*!40000 ALTER TABLE `base_god_seal` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_god_skill_lv`
--

DROP TABLE IF EXISTS `base_god_skill_lv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_god_skill_lv` (
  `god_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '降神id',
  `grade` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '阶数',
  `grade_max` int(11) NOT NULL DEFAULT '0' COMMENT '阶数上限',
  `skill_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '主动技能等级',
  PRIMARY KEY (`god_id`,`grade`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_god_skill_lv`
--

LOCK TABLES `base_god_skill_lv` WRITE;
/*!40000 ALTER TABLE `base_god_skill_lv` DISABLE KEYS */;
INSERT INTO `base_god_skill_lv` VALUES (1001,1,4,1),(1001,5,9,2),(1001,10,14,3),(1001,15,19,4),(1001,20,24,5),(1001,25,999,6),(1002,1,4,1),(1002,5,9,2),(1002,10,14,3),(1002,15,19,4),(1002,20,24,5),(1002,25,999,6),(1003,1,4,1),(1003,5,9,2),(1003,10,14,3),(1003,15,19,4),(1003,20,24,5),(1003,25,999,6),(1004,1,4,1),(1004,5,9,2),(1004,10,14,3),(1004,15,19,4),(1004,20,24,5),(1004,25,999,6),(1005,1,4,1),(1005,5,9,2),(1005,10,14,3),(1005,15,19,4),(1005,20,24,5),(1005,25,999,6),(1006,1,4,1),(1006,5,9,2),(1006,10,14,3),(1006,15,19,4),(1006,20,24,5),(1006,25,999,6);
/*!40000 ALTER TABLE `base_god_skill_lv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_goods`
--

DROP TABLE IF EXISTS `base_goods`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_goods` (
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品编号',
  `goods_name` varchar(50) NOT NULL COMMENT '物品名称@lang@',
  `intro` text NOT NULL COMMENT '物品描述信息@lang@',
  `attr_intor` varchar(1024) NOT NULL COMMENT '属性描述@lang@',
  `combat_intor` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战力描述',
  `getway` text NOT NULL COMMENT '获得途径@lang@',
  `getway_url` varchar(255) NOT NULL DEFAULT '' COMMENT '获取途径链接',
  `bind` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '绑定类型，0非绑，1绑定 ',
  `trade` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否交易，0不可交易，1可交易',
  `sell` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否出售，0不可出售 ，1可出售',
  `type` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型ID',
  `subtype` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '物品子类型ID',
  `sell_category` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '市场商品类型',
  `sell_subcategory` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '市场商品子类型',
  `equip_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '装备类型，0为无',
  `goods_icon` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品图标',
  `career_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '职业限制，0为不限',
  `level` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '等级需求，0为不限',
  `max_overlap` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '可叠加数，0为不可叠加',
  `color` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '物品颜色，0 白色，1 绿色，2 蓝色，3 紫色，4 黄色，5 橙色，6 红色',
  `expire_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '过期类型(0无类型,1开服天数,2合服天数)',
  `expire_day` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '过期天数',
  `expire_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '有效期，0为不限，单位为秒',
  `trade_price` varchar(512) NOT NULL DEFAULT '[]' COMMENT '交易基准价格',
  `lock_time` int(11) unsigned NOT NULL COMMENT '交易锁定期',
  `use` int(11) unsigned NOT NULL COMMENT '是否可使用，(0：不可使用，1：可使用)',
  `compose` int(11) unsigned NOT NULL COMMENT '是否可合成，(0：不可合成，1：可合成)',
  `quick_use` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '获得立即使用',
  `base_attrlist` varchar(512) NOT NULL DEFAULT '[]' COMMENT ' [{属性类型,值}]',
  `addition` varchar(512) NOT NULL DEFAULT '[]' COMMENT '附加属性',
  `model_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '模型资源id',
  `sex` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '性别限制##0为不限，1男，2女',
  `turn` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '转职限制##0为不限，1为1转，2为2转，以此类推...需要向下兼容，1转开启的道具，2转3转N转也可以使用',
  `jump` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否可以跳转:0否;1是，仅用于显示“跳转”按钮，和“使用”字段互斥，只能有一个填“1”',
  PRIMARY KEY (`goods_id`),
  KEY `type` (`type`),
  KEY `subtype` (`subtype`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_goods`
--

LOCK TABLES `base_goods` WRITE;
/*!40000 ALTER TABLE `base_goods` DISABLE KEYS */;
INSERT INTO `base_goods` VALUES (11,'皮思卡托的烈焰法杖','皮卡丘之杖','',0,'','[{0,0,0}]',0,1,1,10,1,0,0,1,50010103,0,1,0,6,0,0,0,'[{1,9999999}]',0,0,0,0,'[{1,9999999},{2,999999999},{81,10000},{18,500}]','[]',0,0,0,0),(12,'测试宝石2','每使用一次就可以向徐少要一顿宵夜','',0,'','[{0,0,0}]',0,0,0,14,99,0,0,0,14010002,0,0,99999,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(13,'测试宝石3','每使用一次就可以向陈扬要一顿宵夜','',0,'','[{0,0,0}]',0,0,0,14,99,0,0,0,14010003,0,0,99999,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(14,'测试宝石4','每使用一次就可以向聪少要一顿宵夜','',0,'','[{0,0,0}]',0,0,0,14,99,0,0,0,14010004,0,0,99999,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(15,'一个鸡蛋','砸中对方，扣除1点魅力值','',0,'【砸蛋界面购买】','[{0,0,0}]',1,0,0,38,4,0,0,0,20010002,0,100,0,0,0,0,0,'[]',0,1,0,1,'[]','[]',0,0,0,1),(16,'一筐鸡蛋','砸中对方，扣除100点魅力值','',0,'【砸蛋界面购买】','[{0,0,0}]',1,0,0,38,4,0,0,0,38100007,0,150,0,3,0,0,0,'[]',0,1,0,1,'[]','[]',0,0,0,1),(510101,'VIP认证礼包','内含神秘道具奖励，运营活动中获得','',0,'【运营活动】','[{0,0,0}]',1,0,1,51,1,4,6,0,32000000,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(510102,'510102','内含神秘道具奖励，运营活动中获得','',0,'【运营活动】','[{0,0,0}]',1,0,1,51,1,4,6,0,32000000,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(510103,'510103','内含神秘道具奖励，运营活动中获得','',0,'【运营活动】','[{0,0,0}]',1,0,1,51,1,4,6,0,32000000,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(510104,'510104','内含神秘道具奖励，运营活动中获得','',0,'【运营活动】','[{0,0,0}]',1,0,1,51,1,4,6,0,32000000,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(510105,'510105','内含神秘道具奖励，运营活动中获得','',0,'【运营活动】','[{0,0,0}]',1,0,1,51,1,4,6,0,32000000,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(510106,'510106','内含神秘道具奖励，运营活动中获得','',0,'【运营活动】','[{0,0,0}]',1,0,1,51,1,4,6,0,32000000,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(510107,'510107','内含神秘道具奖励，运营活动中获得','',0,'【运营活动】','[{0,0,0}]',1,0,1,51,1,4,6,0,32000000,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(510108,'510108','内含神秘道具奖励，运营活动中获得','',0,'【运营活动】','[{0,0,0}]',1,0,1,51,1,4,6,0,32000000,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(510109,'510109','内含神秘道具奖励，运营活动中获得','',0,'【运营活动】','[{0,0,0}]',1,0,1,51,1,4,6,0,32000000,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(510110,'510110','内含神秘道具奖励，运营活动中获得','',0,'【运营活动】','[{0,0,0}]',1,0,1,51,1,4,6,0,32000000,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(510111,'510111','内含神秘道具奖励，运营活动中获得','',0,'【运营活动】','[{0,0,0}]',1,0,1,51,1,4,6,0,32000000,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(510112,'510112','内含神秘道具奖励，运营活动中获得','',0,'【运营活动】','[{0,0,0}]',1,0,1,51,1,4,6,0,32000000,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(510113,'510113','内含神秘道具奖励，运营活动中获得','',0,'【运营活动】','[{0,0,0}]',1,0,1,51,1,4,6,0,32000000,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(510114,'510114','内含神秘道具奖励，运营活动中获得','',0,'【运营活动】','[{0,0,0}]',1,0,1,51,1,4,6,0,32000000,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(510115,'510115','内含神秘道具奖励，运营活动中获得','',0,'【运营活动】','[{0,0,0}]',1,0,1,51,1,4,6,0,32000000,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(510116,'510116','内含神秘道具奖励，运营活动中获得','',0,'【运营活动】','[{0,0,0}]',1,0,1,51,1,4,6,0,32000000,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(510117,'510117','内含神秘道具奖励，运营活动中获得','',0,'【运营活动】','[{0,0,0}]',1,0,1,51,1,4,6,0,32000000,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(510118,'510118','内含神秘道具奖励，运营活动中获得','',0,'【运营活动】','[{0,0,0}]',1,0,1,51,1,4,6,0,32000000,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(510119,'510119','内含神秘道具奖励，运营活动中获得','',0,'【运营活动】','[{0,0,0}]',1,0,1,51,1,4,6,0,32000000,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(510120,'510120','内含神秘道具奖励，运营活动中获得','',0,'【运营活动】','[{0,0,0}]',1,0,1,51,1,4,6,0,32000000,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(4901001,'新贵一族','贵族VIP1玩家的专属称号','生命 + 1200,攻击 + 60,破甲 + 30,防御 + 30',1,'【vip礼包】','[{450,1,1}]',1,0,0,49,1,0,0,0,4901001,0,0,9999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4901002,'华丽贵族','贵族VIP4玩家的专属称号','生命 + 2400,攻击 + 120,破甲 + 60,防御 + 60',1,'【vip礼包】','[{450,1,1}]',1,0,0,49,1,0,0,0,4901002,0,0,9999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4901003,'典雅贵族','贵族VIP6玩家的专属称号','生命 + 10400,攻击 + 520,破甲 + 260,防御 + 260',1,'【vip礼包】','[{450,1,1}]',1,0,0,49,1,0,0,0,4901003,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4901004,'荣耀贵族','贵族VIP8玩家的专属称号','生命 + 15400,攻击 + 770,破甲 + 385,防御 + 385',1,'【vip礼包】','[{450,1,1}]',1,0,0,49,1,0,0,0,4901004,0,0,9999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4901005,'星曜贵族','贵族VIP10玩家的专属称号','生命 + 40000,攻击 + 2000,破甲 + 1000,防御 + 1000',1,'【vip礼包】','[{450,1,1}]',1,0,0,49,1,0,0,0,4901005,0,0,9999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4901006,'世袭贵族','贵族VIP12玩家的专属称号','生命 + 46000,攻击 + 2300,破甲 + 1150,防御 + 1150',1,'【vip礼包】','[{450,1,1}]',1,0,0,49,1,0,0,0,4901006,0,0,9999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4901007,'永恒贵族','贵族VIP14玩家的专属称号','生命 + 52200,攻击 + 2610,破甲 + 1305,防御 + 1305',1,'【vip礼包】','[{450,1,1}]',1,0,0,49,1,0,0,0,4901007,0,0,9999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4901008,'至尊贵族','贵族VIP15玩家的专属称号','生命 + 58400,攻击 + 2920,破甲 + 1460,防御 + 1460',1,'【vip礼包】','[{450,1,1}]',1,0,0,49,1,0,0,0,4901008,0,0,9999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4901009,'发家致富','投资传奇计划中投资1880档获得','生命 + 2000,攻击 + 100,命中 + 25,闪避 + 25',1,'【投资计划】','[{159,0,1}]',1,0,0,49,1,0,0,0,4901009,0,0,9999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4901010,'富可敌国','投资巅峰计划中投资1880档获得','生命 + 3200,攻击 + 160,命中 + 45,闪避 + 45',1,'【投资计划】','[{159,0,1}]',1,0,0,49,1,0,0,0,4901010,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4901011,'富甲天下','投资巅峰计划中投资2880档获得','生命 + 5400,攻击 + 270,命中 + 65,闪避 + 65',1,'【投资计划】','[{159,0,1}]',1,0,0,49,1,0,0,0,4901011,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4901012,'荣耀至尊','至尊贵族商店专属称号，激活后可获得超强属性，效果持续24小时：','生命加成+2%,攻击加成+2%,PVE伤害+4%,PVP伤害+4%',1,'【至尊商店】','[{450,1,1}]',1,0,0,49,1,0,0,0,4901012,0,0,9999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4902001,'十方新星','实时刷新，竞技前十名获得','生命 + 2400,攻击 + 120,破甲 + 60,防御 + 60',1,'【竞技场】','[{280,0,1}]',1,0,0,49,1,0,0,0,4902001,0,0,9999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4902002,'决斗之光','实时刷新，竞技排名第3名获得','生命 + 3600,攻击 + 180,破甲 + 90,防御 + 90',1,'【竞技场】','[{280,0,1}]',1,0,0,49,1,0,0,0,4902002,0,0,9999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4902003,'决斗大师','实时刷新，竞技排名第2名获得','生命 + 4200,攻击 + 210,破甲 + 105,防御 + 105',1,'【竞技场】','[{280,0,1}]',1,0,0,49,1,0,0,0,4902003,0,0,9999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4902004,'决斗之王','实时刷新，竞技排名第1名获得','生命 + 5000,攻击 + 250,破甲 + 125,防御 + 125',1,'【竞技场】','[{280,0,1}]',1,0,0,49,1,0,0,0,4902004,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4902005,'战神无双','实时刷新称号归属，本服战力榜第1名专属称号','生命 + 4000,攻击 + 200,破甲 + 100,防御 + 100',1,'【排行榜】','[{0,0,0}]',1,0,0,49,1,0,0,0,4902005,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4902006,'登峰造极','实时刷新称号归属，本服等级榜第1名专属称号','生命 + 4000,攻击 + 200,命中 + 50,闪避 + 50',1,'【排行榜】','[{0,0,0}]',1,0,0,49,1,0,0,0,4902006,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4902007,'神行千里','每日0点刷新称号归属，本服坐骑榜第1名专属称号','生命 + 4000,攻击 + 200,暴击 + 50,韧性 + 50',1,'【排行榜】','[{0,0,0}]',1,0,0,49,1,0,0,0,4902007,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4902008,'逐风之翼','每日0点刷新称号归属，本服翅膀榜第1名专属称号','生命 + 4000,攻击 + 200,破甲 + 100,防御 + 100',1,'【排行榜】','[{0,0,0}]',1,0,0,49,1,0,0,0,4902008,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4902009,'神兵天降','每日0点刷新称号归属，本服宝具榜第1名专属称号','生命 + 4000,攻击 + 200,命中 + 50,闪避 + 50',1,'【排行榜】','[{0,0,0}]',1,0,0,49,1,0,0,0,4902009,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4902010,'神域领主','每日0点刷新称号归属，本服降神榜第1名专属称号','生命 + 4000,攻击 + 200,暴击 + 50,韧性 + 50',1,'【排行榜】','[{0,0,0}]',1,0,0,49,1,0,0,0,4902010,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4902011,'圣灵统领','每日0点刷新称号归属，本服圣灵榜第1名专属称号','生命 + 4000,攻击 + 200,破甲 + 100,防御 + 100',1,'【排行榜】','[{0,0,0}]',1,0,0,49,1,0,0,0,4902011,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4902012,'星辰之怒','每日0点刷新称号归属，本服星灵榜第1名专属称号','生命 + 4000,攻击 + 200,命中 + 50,闪避 + 50',1,'【排行榜】','[{0,0,0}]',1,0,0,49,1,0,0,0,4902012,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4902013,'时尚达人','每日0点刷新称号归属，本服时装榜第1名专属称号','生命 + 4000,攻击 + 200,暴击 + 50,韧性 + 50',1,'【排行榜】','[{0,0,0}]',1,0,0,49,1,0,0,0,4902013,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4902014,'绝对魔王','每日0点刷新称号归属，本服魔剑士职业榜第1名专属称号','生命 + 4000,攻击 + 200,破甲 + 100,防御 + 100',1,'【排行榜】','[{0,0,0}]',1,0,0,49,1,0,0,0,4902014,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4902015,'驭龙统帅','每日0点刷新称号归属，本服龙骑士职业榜第1名专属称号','生命 + 4000,攻击 + 200,破甲 + 100,防御 + 100',1,'【排行榜】','[{0,0,0}]',1,0,0,49,1,0,0,0,4902015,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4902016,'枪炮玫瑰','每日0点刷新称号归属，本服重炮手职业榜第1名专属称号','生命 + 4000,攻击 + 200,破甲 + 100,防御 + 100',1,'【排行榜】','[{0,0,0}]',1,0,0,49,1,0,0,0,4902016,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4902017,'冲级狂人','等级礼包称号','生命 + 4000,攻击 + 200,命中 + 60,闪避 + 60',1,'【开服活动】','[{0,0,0}]',1,0,0,49,1,0,0,0,4902017,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4902018,'战力狂人','战力礼包称号','生命 + 4000,攻击 + 200,暴击 + 60,韧性 + 60',1,'【战力送礼】','[{0,0,0}]',1,0,0,49,1,0,0,0,4902018,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4902019,'最强装备','每日0点刷新称号归属，本服装备榜第1名专属称号','生命 + 4000,攻击 + 200,破甲 + 100,防御 + 100',1,'【排行榜】','[{0,0,0}]',1,0,0,49,1,0,0,0,4902019,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4902020,'绝对巅峰','每日0点刷新称号归属，跨服等级榜第1名专属称号','生命 + 4000,攻击 + 200,破甲 + 100,防御 + 100',1,'【跨服排行榜】','[{0,0,0}]',1,0,0,49,1,0,0,0,4902020,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4902021,'跨服战神','每日0点刷新称号归属，跨服战力榜第1名专属称号','生命 + 4000,攻击 + 200,命中 + 60,闪避 + 60',1,'【跨服排行榜】','[{0,0,0}]',1,0,0,49,1,0,0,0,4902021,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4902022,'装备之王','每日0点刷新称号归属，跨服装备榜第1名专属称号','生命 + 4000,攻击 + 200,暴击 + 60,韧性 + 60',1,'【跨服排行榜】','[{0,0,0}]',1,0,0,49,1,0,0,0,4902022,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4903001,'星界游侠','成就称号Ⅰ','生命 + 2320,攻击 + 116,命中 + 29,闪避 + 29',1,'【成就奖励】','[{0,0,0}]',1,0,0,49,1,0,0,0,4903001,0,0,9999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4903002,'星界守护','成就称号Ⅱ','生命 + 4320,攻击 + 216,命中 + 54,闪避 + 54',1,'【成就奖励】','[{0,0,0}]',1,0,0,49,1,0,0,0,4903002,0,0,9999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4903003,'星界英杰','成就称号Ⅲ','生命 + 6400,攻击 + 320,命中 + 80,闪避 + 80',1,'【成就奖励】','[{0,0,0}]',1,0,0,49,1,0,0,0,4903003,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4903004,'星界领主','成就称号Ⅳ','生命 + 1000,攻击 + 50,暴击 + 12,韧性 + 12',1,'【成就奖励】','[{0,0,0}]',1,0,0,49,1,0,0,0,4903004,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4904001,'小行星','任务称号Ⅰ','生命 + 500,攻击 + 25',1,'【任务奖励】','[{0,0,0}]',1,0,0,49,1,0,0,0,4904001,0,0,9999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4904002,'暗星云','任务称号Ⅱ','生命 + 800,攻击 + 40,暴击 + 10,韧性 + 10',1,'【任务奖励】','[{0,0,0}]',1,0,0,49,1,0,0,0,4904002,0,0,9999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4904003,'原恒星','任务称号Ⅲ','生命 + 1600,攻击 + 80,暴击 + 20,韧性 + 20',1,'【任务奖励】','[{0,0,0}]',1,0,0,49,1,0,0,0,4904003,0,0,9999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4904004,'主序星','任务称号Ⅳ','生命 + 2000,攻击 + 100,暴击 + 40,韧性 + 40',1,'【任务奖励】','[{0,0,0}]',1,0,0,49,1,0,0,0,4904004,0,0,9999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4904005,'超巨星','任务称号Ⅴ','生命 + 3000,攻击 + 150,命中 + 60,闪避 + 60',1,'【任务奖励】','[{0,0,0}]',1,0,0,49,1,0,0,0,4904005,0,0,9999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4904006,'辉耀星','任务称号Ⅵ','生命 + 5000,攻击 + 250,命中 + 80,闪避 + 80',1,'【任务奖励】','[{0,0,0}]',1,0,0,49,1,0,0,0,4904006,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4904007,'超新星','任务称号Ⅶ','生命 + 6000,攻击 + 300,破甲 + 200,防御 + 200',1,'【任务奖励】','[{0,0,0}]',1,0,0,49,1,0,0,0,4904007,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4904008,'极超新星','任务称号Ⅷ','生命 + 8000,攻击 + 400,暴击 + 75,韧性 + 75',1,'【任务奖励】','[{0,0,0}]',1,0,0,49,1,0,0,0,4904008,0,0,9999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4905001,'智多星','智慧达人中获得第1名获得','生命 + 2800,攻击 + 140,命中 + 35,闪避 + 35',1,'【中午答题】','[{174,0,1}]',1,0,0,49,1,0,0,0,4905001,0,0,9999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4905002,'魅力新人王','魅力海滩中魅力值第1名获得','生命 + 2800,攻击 + 140,暴击 + 35,韧性 + 35',1,'【魅力海滩】','[{418,0,1}]',1,0,0,49,1,0,0,0,4905002,0,0,9999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4905003,'冲上云霄','护送最高等级飞艇获得','生命 + 2800,攻击 + 140,破甲 + 70,防御 + 70',1,'【护送飞艇】','[{500,0,1}]',1,0,0,49,1,0,0,0,4905003,0,0,9999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4905004,'蝴蝶捕手','捕蝶活动中取得第1名','生命 + 3600,攻击 + 180,破甲 + 90,防御 + 90',1,'【捕蝶】','[{429,0,1}]',1,0,0,49,1,0,0,0,4905004,0,0,9999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4906001,'无畏勇士','公会争霸第3名成员','生命 + 2000,攻击 + 100,破甲 + 50,防御 + 50',1,'【公会争霸】','[{402,4,1}]',1,0,0,49,1,0,0,0,4906001,0,0,9999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4906002,'荣耀勇士','公会争霸第2名成员','生命 + 3400,攻击 + 170,破甲 + 85,防御 + 85',1,'【公会争霸】','[{402,4,1}]',1,0,0,49,1,0,0,0,4906002,0,0,9999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4906003,'地表最强','公会争霸第1名成员','生命 + 4800,攻击 + 240,破甲 + 120,防御 + 120',1,'【公会争霸】','[{402,4,1}]',1,0,0,49,1,0,0,0,4906003,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4906004,'最强会长','公会争霸第1名会长','生命 + 6400,攻击 + 320,破甲 + 160,防御 + 160',1,'【公会争霸】','[{402,4,1}]',1,0,0,49,1,0,0,0,4906004,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4907001,'气宇轩昂','获得魅力周榜男榜第1名','生命 + 2000,攻击 + 100,命中 + 25,闪避 + 25',1,'【魅力榜】','[{221,1,1}]',1,0,0,49,1,0,0,0,4907001,0,0,9999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4907002,'国色天香','获得魅力周榜女榜第1名','生命 + 2000,攻击 + 100,命中 + 25,闪避 + 25',1,'【魅力榜】','[{221,1,1}]',1,0,0,49,1,0,0,0,4907002,0,0,9999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4907003,'风流倜傥','获得魅力榜男榜第1名','生命 + 3600,攻击 + 180,暴击 + 45,韧性 + 45',1,'【魅力榜】','[{221,1,1}]',1,0,0,49,1,0,0,0,4907003,0,0,9999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4907004,'倾国倾城','获得魅力榜女榜第1名','生命 + 3600,攻击 + 180,暴击 + 45,韧性 + 45',1,'【魅力榜】','[{221,1,1}]',1,0,0,49,1,0,0,0,4907004,0,0,9999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4907005,'名门君子','获得跨服魅力榜男榜第1名','生命 + 5400,攻击 + 270,破甲 + 135,防御 + 135',1,'【魅力榜】','[{221,1,1}]',1,0,0,49,1,0,0,0,4907005,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4907006,'绝世佳人','获得跨服魅力榜女榜第1名','生命 + 5400,攻击 + 270,破甲 + 135,防御 + 135',1,'【魅力榜】','[{221,1,1}]',1,0,0,49,1,0,0,0,4907006,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4907007,'玫瑰之恋','举行简约婚礼获得','生命 + 2000,攻击 + 100,破甲 + 50,防御 + 50',1,'【婚礼】','[{8,1,1}]',1,0,0,49,1,0,0,0,4907007,0,0,9999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4907008,'永恒之恋','举行豪华婚礼获得','生命 + 3600,攻击 + 180,破甲 + 90,防御 + 90',1,'【婚礼】','[{8,1,1}]',1,0,0,49,1,0,0,0,4907008,0,0,9999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4907009,'世纪之恋','举行世纪婚礼获得','生命 + 5000,攻击 + 250,破甲 + 125,防御 + 125',1,'【婚礼】','[{8,1,1}]',1,0,0,49,1,0,0,0,4907009,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4907010,'恋爱大作战','举行简约巡游获得','生命 + 2000,攻击 + 100,破甲 + 50,防御 + 50',1,'【婚礼】','[{8,1,1}]',1,0,0,49,1,0,0,0,4907010,0,0,9999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4907011,'蜜月大冒险','举行豪华巡游获得','生命 + 3600,攻击 + 180,破甲 + 90,防御 + 90',1,'【婚礼】','[{8,1,1}]',1,0,0,49,1,0,0,0,4907011,0,0,9999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4907012,'甜蜜恋旅人','举行世纪巡游获得','生命 + 5000,攻击 + 250,破甲 + 125,防御 + 125',1,'【婚礼】','[{8,1,1}]',1,0,0,49,1,0,0,0,4907012,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4908001,'冲级高手','获得开服冲榜【等级榜】第4~10名','生命 + 4160,攻击 + 208,破甲 + 104,防御 + 104',1,'【开服活动】','[{0,0,0}]',1,0,0,49,1,0,0,0,4908001,0,0,9999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4908002,'冲级达人','获得开服冲榜【等级榜】第2~3名','生命 + 6400,攻击 + 320,破甲 + 160,防御 + 160',1,'【开服活动】','[{0,0,0}]',1,0,0,49,1,0,0,0,4908002,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4908003,'俯瞰众生','获得开服冲榜【等级榜】第1名','生命 + 10000,攻击 + 500,破甲 + 250,防御 + 250',1,'【开服活动】','[{0,0,0}]',1,0,0,49,1,0,0,0,4908003,0,0,9999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4908004,'神殿守护者','获得开服冲榜【降神榜】第3名','生命 + 4160,攻击 + 208,命中 + 52,闪避 + 52',1,'【开服活动】','[{0,0,0}]',1,0,0,49,1,0,0,0,4908004,0,0,9999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4908005,'神殿审判者','获得开服冲榜【降神榜】第2名','生命 + 6400,攻击 + 320,命中 + 80,闪避 + 80',1,'【开服活动】','[{0,0,0}]',1,0,0,49,1,0,0,0,4908005,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4908006,'神殿裁决者','获得开服冲榜【降神榜】第1名','生命 + 10000,攻击 + 500,命中 + 125,闪避 + 125',1,'【开服活动】','[{0,0,0}]',1,0,0,49,1,0,0,0,4908006,0,0,9999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4908007,'星灵守护者','获得开服冲榜【坐骑榜】第3名','生命 + 4160,攻击 + 208,暴击 + 52,韧性 + 52',1,'【开服活动】','[{0,0,0}]',1,0,0,49,1,1,0,0,4908007,0,0,9999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4908008,'星灵圣骑士','获得开服冲榜【星灵榜】第2名','生命 + 6400,攻击 + 320,破甲 + 160,防御 + 160,暴击 + 80,韧性 + 80',1,'【开服活动】','[{0,0,0}]',1,0,0,49,1,1,0,0,4908008,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4908009,'星灵圣团长','获得开服冲榜【星灵榜】第1名','生命 + 10000,攻击 + 500,破甲 + 250,防御 + 250,暴击 + 125,韧性 + 125',1,'【开服活动】','[{0,0,0}]',1,0,0,49,1,1,0,0,4908009,0,0,9999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4908010,'富据一方','获得开服冲榜【充值榜】第3名','生命 + 4200,攻击 + 210,破甲 + 105,防御 + 105',1,'【开服活动】','[{0,0,0}]',1,0,0,49,1,0,0,0,4908010,0,0,9999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4908011,'资产领袖','获得开服冲榜【充值榜】第2名','生命 + 6400,攻击 + 320,破甲 + 160,防御 + 160',1,'【开服活动】','[{0,0,0}]',1,0,0,49,1,0,0,0,4908011,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4908012,'为所欲为','获得开服冲榜【充值榜】第1名','生命 + 10000,攻击 + 500,破甲 + 250,防御 + 250',1,'【开服活动】','[{0,0,0}]',1,0,0,49,1,0,0,0,4908012,0,0,9999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4908013,'宝石达人','获得开服冲榜【装备榜】第4~10名','生命 + 4200,攻击 + 210,命中 + 52,闪避 + 52',1,'【开服活动】','[{0,0,0}]',1,0,0,49,1,0,0,0,4908013,0,0,9999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4908014,'宝石之心','获得开服冲榜【装备榜】第2~3名','生命 + 6400,攻击 + 320,命中 + 80,闪避 + 80',1,'【开服活动】','[{0,0,0}]',1,0,0,49,1,0,0,0,4908014,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4908015,'宝石大亨','获得开服冲榜【装备榜】第1名','生命 + 10000,攻击 + 500,命中 + 125,闪避 + 125',1,'【开服活动】','[{0,0,0}]',1,0,0,49,1,0,0,0,4908015,0,0,9999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4908016,'战力达人','获得开服冲榜【战力榜】第4~10名','生命 + 4200,攻击 + 210,暴击 + 52,韧性 + 52',1,'【开服活动】','[{0,0,0}]',1,0,0,49,1,0,0,0,4908016,0,0,9999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4908017,'战力强者','获得开服冲榜【战力榜】第2~3名','生命 + 6400,攻击 + 320,暴击 + 80,韧性 + 80',1,'【开服活动】','[{0,0,0}]',1,0,0,49,1,0,0,0,4908017,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4908018,'战力无双','获得开服冲榜【战力榜】第1名','生命 + 10000,攻击 + 500,暴击 + 125,韧性 + 125',1,'【开服活动】','[{0,0,0}]',1,0,0,49,1,0,0,0,4908018,0,0,9999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4908019,'三世恋人','完成开服活动【三世恋人】后获得','生命 + 11000,攻击 + 550,破甲 + 275,防御 + 275',1,'【开服活动】','[{0,0,0}]',1,0,0,49,1,0,0,0,4908019,0,0,9999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4908020,'创世筑梦者','七天登录奖励','生命 + 2000,攻击 + 100',1,'【冲级豪礼】','[{0,0,0}]',1,0,0,49,1,0,0,0,4908020,0,0,9999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4908021,'创世勇士','开服奖励','生命 + 2000,攻击 + 100',1,'【开服活动】','[{0,0,0}]',1,0,0,49,1,0,0,0,4908021,0,0,9999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4908022,'星之守护者','七天登录奖励','生命 + 2400,攻击 + 120,破甲 + 55,防御 + 55',1,'【七日登陆】','[{0,0,0}]',1,0,0,49,1,1,0,0,4908022,0,0,999999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4908023,'星界旅行者','连续登录10天获得','生命 + 4000,攻击 + 200,破甲 + 90,防御 + 90',1,'【七日登陆】','[{0,0,0}]',1,0,0,49,1,1,0,0,4908023,0,0,999999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4908024,'大旅行家','连续登录20天获得','生命 + 6800,攻击 + 340,命中 + 85,闪避 + 85',1,'【七日登陆】','[{0,0,0}]',1,0,0,49,1,1,0,0,4908024,0,0,999999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4908025,'时间守护者','连续登录28天获得','生命 + 5800,攻击 + 290,破甲 + 240,防御 + 240,暴击 + 90,韧性 + 90',1,'【七日登陆】','[{0,0,0}]',1,0,0,49,1,1,0,0,4908025,0,0,999999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4908026,'人生赢家','0元豪礼购买获得','攻击 + 70,破甲 + 40,命中 + 24,暴击 + 24',1,'【0元豪礼】','[{0,0,0}]',1,0,0,49,1,1,0,0,4908026,0,0,999999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4909001,'荆棘修罗','丛林突围积分排名第二奖励','生命 + 3600,攻击 + 180,暴击 + 45,韧性 + 45',1,'【丛林突围】','[{0,0,0}]',1,0,0,49,1,0,0,0,4909001,0,0,9999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4909002,'荆棘主宰','丛林突围积分排名第一奖励','生命 + 5400,攻击 + 270,暴击 + 65,韧性 + 65',1,'【丛林突围】','[{0,0,0}]',1,0,0,49,1,0,0,0,4909002,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4909003,'荆棘使者','丛林突围积分排名第三奖励','生命 + 2400,攻击 + 120,暴击 + 30,韧性 + 30',1,'【丛林突围】','[{0,0,0}]',1,0,0,49,1,0,0,0,4909003,0,0,9999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4910001,'屠魔战神','取得荣耀战神伤害排名第1','生命 + 3600,攻击 + 180,命中 + 45,闪避 + 45',1,'【荣耀战神】','[{605,0,1}]',1,0,0,49,1,0,0,0,4910001,0,0,9999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4910002,'致命一击','取得荣耀战神活动中夺得最后一击','生命 + 3600,攻击 + 180,暴击 + 45,韧性 + 45',1,'【荣耀战神】','[{605,0,1}]',1,0,0,49,1,0,0,0,4910002,0,0,9999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4911001,'不屈青铜','跨服3V3商店积分兑换','生命 + 720,攻击 + 36,破甲 + 18,防御 + 18',1,'【跨服3v3】','[{650,1,1}]',1,0,0,49,1,0,0,0,4911001,0,0,9999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4911002,'倔强白银','跨服3V3商店积分兑换','生命 + 1480,攻击 + 74,破甲 + 37,防御 + 37',1,'【跨服3v3】','[{650,1,1}]',1,0,0,49,1,0,0,0,4911002,0,0,9999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4911003,'英勇黄金','跨服3V3商店积分兑换','生命 + 2320,攻击 + 116,破甲 + 58,防御 + 58',1,'【跨服3v3】','[{650,1,1}]',1,0,0,49,1,0,0,0,4911003,0,0,9999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4911004,'华贵铂金','跨服3V3商店积分兑换','生命 + 3200,攻击 + 160,破甲 + 80,防御 + 80',1,'【跨服3v3】','[{650,1,1}]',1,0,0,49,1,0,0,0,4911004,0,0,9999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4911005,'永恒钻石','跨服3V3商店积分兑换','生命 + 4200,攻击 + 210,破甲 + 105,防御 + 105',1,'【跨服3v3】','[{650,1,1}]',1,0,0,49,1,0,0,0,4911005,0,0,9999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4911006,'荣耀王者','跨服3V3商店积分兑换','生命 + 5400,攻击 + 270,破甲 + 135,防御 + 135',1,'【跨服3v3】','[{650,1,1}]',1,0,0,49,1,0,0,0,4911006,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4911007,'无双传说','跨服3V3商店积分兑换','生命 + 6400,攻击 + 320,破甲 + 160,防御 + 160',1,'【跨服3v3】','[{650,1,1}]',1,0,0,49,1,0,0,0,4911007,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4911008,'战斗大师','跨服3V3商店积分兑换','生命 + 7600,攻击 + 380,破甲 + 190,防御 + 190',1,'【跨服3v3】','[{650,1,1}]',1,0,0,49,1,0,0,0,4911008,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4911009,'传说战神','跨服3V3中总排名第3名赛季奖励','生命 + 8600,攻击 + 430,破甲 + 215,防御 + 215',1,'【跨服3v3】','[{650,1,1}]',1,0,0,49,1,0,0,0,4911009,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4911010,'无冕之王','跨服3V3中总排名第2名赛季奖励','生命 + 10800,攻击 + 540,破甲 + 270,防御 + 270',1,'【跨服3v3】','[{650,1,1}]',1,0,0,49,1,0,0,0,4911010,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4911011,'战争之王','跨服3V3中总排名第1名赛季奖励','生命 + 13000,攻击 + 650,破甲 + 325,防御 + 325',1,'【跨服3v3】','[{650,1,1}]',1,0,0,49,1,0,0,0,4911011,0,0,9999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4912001,'以一当十','获得跨服1VN第3名','生命 + 4600,攻击 + 230,破甲 + 115,防御 + 115',1,'【跨服1vn】','[{621,0,1}]',1,0,0,49,1,0,0,0,4912001,0,0,9999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4912002,'一骑当千','获得跨服1VN第2名','生命 + 8600,攻击 + 430,破甲 + 215,防御 + 215',1,'【跨服1vn】','[{621,0,1}]',1,0,0,49,1,0,0,0,4912002,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4912003,'浴血屠戮','获得跨服1VN第1名','生命 + 12000,攻击 + 600,破甲 + 300,防御 + 300',1,'【跨服1vn】','[{621,0,1}]',1,0,0,49,1,0,0,0,4912003,0,0,9999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4912004,'无人之境','获得跨服1VN七轮守擂全胜','生命 + 5400,攻击 + 270,破甲 + 135,防御 + 135',1,'【跨服1vn】','[{621,0,1}]',1,0,0,49,1,0,0,0,4912004,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4913001,'巅峰荣耀','获得巅峰竞技第3名','生命 + 3600,攻击 + 180,破甲 + 90,防御 + 90',1,'【巅峰竞技】','[{281,0,1}]',1,0,0,49,1,0,0,0,4913001,0,0,9999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4913002,'巅峰战神','获得巅峰竞技第2名','生命 + 5400,攻击 + 270,破甲 + 135,防御 + 135',1,'【巅峰竞技】','[{281,0,1}]',1,0,0,49,1,0,0,0,4913002,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4913003,'世界之巅','获得巅峰竞技第1名','生命 + 7000,攻击 + 350,破甲 + 175,防御 + 175',1,'【巅峰竞技】','[{281,0,1}]',1,0,0,49,1,0,0,0,4913003,0,0,9999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4914001,'人间兵器','获得跨服争霸击杀排名第3名','生命 + 2800,攻击 + 140,命中 + 35,闪避 + 35',1,'【跨服争霸】','[{0,0,0}]',1,0,0,49,1,0,0,0,4914001,0,0,9999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4914002,'征服王者','获得跨服争霸击杀排名第2名','生命 + 4300,攻击 + 215,命中 + 55,闪避 + 55',1,'【跨服争霸】','[{0,0,0}]',1,0,0,49,1,0,0,0,4914002,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4914003,'苍穹君主','获得跨服争霸击杀排名第1名','生命 + 6400,攻击 + 320,命中 + 80,闪避 + 80',1,'【跨服争霸】','[{0,0,0}]',1,0,0,49,1,0,0,0,4914003,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4915001,'钻石爱好者','获得钻石大战第3~4名','生命 + 3200,攻击 + 160,命中 + 32,闪避 + 32',1,'【钻石大战】','[{137,0,1}]',1,0,0,49,1,0,0,0,4915001,0,0,9999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4915002,'钻石收藏家','获得钻石大战第2名','生命 + 4800,攻击 + 240,命中 + 52,闪避 + 52',1,'【钻石大战】','[{137,0,1}]',1,0,0,49,1,0,0,0,4915002,0,0,9999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4915003,'钻石收割者','钻石大战中获得第1名','生命 + 6400,攻击 + 320,命中 + 80,闪避 + 80',1,'【钻石大战】','[{137,0,1}]',1,0,0,49,1,0,0,0,4915003,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4916001,'乘风破浪','无尽海域中击杀排名第3名','生命 + 2800,攻击 + 140,命中 + 35,闪避 + 35',1,'【无尽海域】','[{0,0,0}]',1,0,0,49,1,0,0,0,4916001,0,0,9999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4916002,'海域传说','无尽海域中击杀排名第2名','生命 + 4300,攻击 + 215,命中 + 55,闪避 + 55',1,'【无尽海域】','[{0,0,0}]',1,0,0,49,1,0,0,0,4916002,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4916003,'海域霸主','无尽海域中击杀排名第1名','生命 + 6400,攻击 + 320,命中 + 80,闪避 + 80',1,'【无尽海域】','[{0,0,0}]',1,0,0,49,1,0,0,0,4916003,0,0,9999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4916004,'浪得飞起','无尽海域中被击败次数最多的玩家获得','生命 + 2000,攻击 + 100,命中 + 15,闪避 + 15',1,'【无尽海域】','[{0,0,0}]',1,0,0,49,1,0,0,0,4916004,0,0,9999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4917001,'？？？？','运营活动称号','生命 + 8000,攻击 + 400,破甲 + 320,防御 + 320',1,'【运营活动】','[{0,0,0}]',1,0,0,49,1,1,0,0,4917001,0,0,999999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4917002,'自带BGM','运营活动称号','生命 + 6000,攻击 + 300,暴击 + 120,韧性 + 120',1,'【运营活动】','[{0,0,0}]',1,0,0,49,1,1,0,0,4917002,0,0,999999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4917003,'幸运之星','运营活动称号','生命 + 8000,攻击 + 400,命中 + 160,闪避 + 160',1,'【运营活动】','[{0,0,0}]',1,0,0,49,1,1,0,0,4917003,0,0,999999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4917004,'至尊裁决者','运营活动称号','生命 + 7500,攻击 + 375,命中 + 150,闪避 + 150',1,'【运营活动】','[{0,0,0}]',1,0,0,49,1,1,0,0,4917004,0,0,999999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4917005,'海洋之王','运营活动称号','生命 + 7500,攻击 + 375,破甲 + 300,防御 + 300',1,'【运营活动】','[{0,0,0}]',1,0,0,49,1,1,0,0,4917005,0,0,999999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4917006,'圣月之光','运营活动称号','生命 + 7500,攻击 + 375,暴击 + 150,韧性 + 150',1,'【运营活动】','[{0,0,0}]',1,0,0,49,1,1,0,0,4917006,0,0,999999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4917007,'萌兔守护者','运营活动称号','生命 + 7500,攻击 + 375,破甲 + 300,防御 + 300',1,'【运营活动】','[{0,0,0}]',1,0,0,49,1,1,0,0,4917007,0,0,999999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4917008,'黑猫守护者','运营活动称号','生命 + 7500,攻击 + 375,命中 + 150,闪避 + 150',1,'【运营活动】','[{0,0,0}]',1,0,0,49,1,1,0,0,4917008,0,0,999999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4917009,'小熊守护者','运营活动称号','生命 + 7500,攻击 + 375,暴击 + 150,韧性 + 150',1,'【运营活动】','[{0,0,0}]',1,0,0,49,1,1,0,0,4917009,0,0,999999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4917010,'蛋蛋的忧伤','运营活动称号','生命 + 4700,攻击 + 235,破甲 + 188,防御 + 188',1,'【运营活动】','[{0,0,0}]',1,0,0,49,1,0,0,0,4917010,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4917011,'过于优秀','运营活动称号','生命 + 4700,攻击 + 235,命中 + 94,闪避 + 94',1,'【运营活动】','[{0,0,0}]',1,0,0,49,1,0,0,0,4917011,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4917012,'浪起来','运营活动称号','生命 + 4700,攻击 + 235,暴击 + 94,韧性 + 94',1,'【运营活动】','[{0,0,0}]',1,0,0,49,1,0,0,0,4917012,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4917013,'清凉一夏','运营活动称号','破甲 + 188,防御 + 188,命中 + 94,闪避 + 94',1,'【运营活动】','[{0,0,0}]',1,0,0,49,1,0,0,0,4917013,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4918001,'战场裁决者','三英会战中积分未获胜方排名前三名','生命 + 2400,攻击 + 120,暴击 + 30,韧性 + 30',1,'【三英会战】','[{0,0,0}]',1,0,0,49,1,0,0,0,4918001,0,0,9999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4918002,'战场审判者','三英会战中胜利方积分排名第2-3名','生命 + 3600,攻击 + 180,暴击 + 45,韧性 + 45',1,'【三英会战】','[{0,0,0}]',1,0,0,49,1,0,0,0,4918002,0,0,9999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(4918003,'战场掌控者','三英会战中胜利方积分排名第1名','生命 + 5700,攻击 + 285,暴击 + 60,韧性 + 60',1,'【三英会战】','[{0,0,0}]',1,0,0,49,1,0,0,0,4918003,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(5201010,'攻击魂珠','装配在魂珠界面，可以大幅度提升攻击','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201010,0,1,0,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201011,'攻击魂珠','装配在魂珠界面，可以大幅度提升攻击','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201011,0,1,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201012,'攻击魂珠','装配在魂珠界面，可以大幅度提升攻击','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201012,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201013,'攻击魂珠','装配在魂珠界面，可以大幅度提升攻击','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201013,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201014,'攻击魂珠','装配在魂珠界面，可以大幅度提升攻击','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201014,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201020,'生命魂珠','装配在魂珠界面，可以大幅度提升生命','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201020,0,1,0,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201021,'生命魂珠','装配在魂珠界面，可以大幅度提升生命','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201021,0,1,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201022,'生命魂珠','装配在魂珠界面，可以大幅度提升生命','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201022,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201023,'生命魂珠','装配在魂珠界面，可以大幅度提升生命','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201023,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201024,'生命魂珠','装配在魂珠界面，可以大幅度提升生命','',0,'【魂珠寻宝,魂珠塔,运营活动】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201024,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201030,'破甲魂珠','装配在魂珠界面，可以大幅度提升破甲','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201030,0,1,0,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201031,'破甲魂珠','装配在魂珠界面，可以大幅度提升破甲','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201031,0,1,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201032,'破甲魂珠','装配在魂珠界面，可以大幅度提升破甲','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201032,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201033,'破甲魂珠','装配在魂珠界面，可以大幅度提升破甲','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201033,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201034,'破甲魂珠','装配在魂珠界面，可以大幅度提升破甲','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201034,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201040,'防御魂珠','装配在魂珠界面，可以大幅度提升防御','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201040,0,1,0,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201041,'防御魂珠','装配在魂珠界面，可以大幅度提升防御','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201041,0,1,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201042,'防御魂珠','装配在魂珠界面，可以大幅度提升防御','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201042,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201043,'防御魂珠','装配在魂珠界面，可以大幅度提升防御','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201043,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201044,'防御魂珠','装配在魂珠界面，可以大幅度提升防御','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201044,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201050,'命中魂珠','装配在魂珠界面，可以大幅度提升命中','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201050,0,1,0,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201051,'命中魂珠','装配在魂珠界面，可以大幅度提升命中','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201051,0,1,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201052,'命中魂珠','装配在魂珠界面，可以大幅度提升命中','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201052,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201053,'命中魂珠','装配在魂珠界面，可以大幅度提升命中','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201053,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201054,'命中魂珠','装配在魂珠界面，可以大幅度提升命中','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201054,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201060,'闪避魂珠','装配在魂珠界面，可以大幅度提升闪避','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201060,0,1,0,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201061,'闪避魂珠','装配在魂珠界面，可以大幅度提升闪避','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201061,0,1,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201062,'闪避魂珠','装配在魂珠界面，可以大幅度提升闪避','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201062,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201063,'闪避魂珠','装配在魂珠界面，可以大幅度提升闪避','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201063,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201064,'闪避魂珠','装配在魂珠界面，可以大幅度提升闪避','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201064,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201070,'暴击魂珠','装配在魂珠界面，可以大幅度提升暴击','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201070,0,1,0,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201071,'暴击魂珠','装配在魂珠界面，可以大幅度提升暴击','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201071,0,1,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201072,'暴击魂珠','装配在魂珠界面，可以大幅度提升暴击','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201072,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201073,'暴击魂珠','装配在魂珠界面，可以大幅度提升暴击','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201073,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201074,'暴击魂珠','装配在魂珠界面，可以大幅度提升暴击','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201074,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201080,'韧性魂珠','装配在魂珠界面，可以大幅度提升韧性','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201080,0,1,0,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201081,'韧性魂珠','装配在魂珠界面，可以大幅度提升韧性','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201081,0,1,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201082,'韧性魂珠','装配在魂珠界面，可以大幅度提升韧性','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201082,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201083,'韧性魂珠','装配在魂珠界面，可以大幅度提升韧性','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201083,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201084,'韧性魂珠','装配在魂珠界面，可以大幅度提升韧性','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201084,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201090,'固伤魂珠','装配在魂珠界面，可以大幅度提升固定伤害','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201090,0,1,0,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201091,'固伤魂珠','装配在魂珠界面，可以大幅度提升固定伤害','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201091,0,1,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201092,'固伤魂珠','装配在魂珠界面，可以大幅度提升固定伤害','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201092,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201093,'固伤魂珠','装配在魂珠界面，可以大幅度提升固定伤害','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201093,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201094,'固伤魂珠','装配在魂珠界面，可以大幅度提升韧性','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201094,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201100,'固防魂珠','装配在魂珠界面，可以大幅度提升固定防御','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201100,0,1,0,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201101,'固防魂珠','装配在魂珠界面，可以大幅度提升固定防御','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201101,0,1,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201102,'固防魂珠','装配在魂珠界面，可以大幅度提升固定防御','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201102,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201103,'固防魂珠','装配在魂珠界面，可以大幅度提升固定防御','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201103,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201104,'固防魂珠','装配在魂珠界面，可以大幅度提升固定防御','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201104,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201110,'暴伤魂珠(弃用)','装配在魂珠界面，可以大幅度提升爆伤','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201110,0,1,0,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201111,'暴伤魂珠(弃用)','装配在魂珠界面，可以大幅度提升爆伤','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201111,0,1,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201112,'暴伤魂珠(弃用)','装配在魂珠界面，可以大幅度提升爆伤','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201112,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201113,'暴伤魂珠(弃用)','装配在魂珠界面，可以大幅度提升爆伤','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201113,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201114,'暴伤魂珠(弃用)','装配在魂珠界面，可以大幅度提升爆伤','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201114,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201120,'抗暴魂珠(弃用)','装配在魂珠界面，可以大幅度提升抗暴','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201120,0,1,0,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201121,'抗暴魂珠(弃用)','装配在魂珠界面，可以大幅度提升抗暴','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201121,0,1,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201122,'抗暴魂珠(弃用)','装配在魂珠界面，可以大幅度提升抗暴','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201122,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201123,'抗暴魂珠(弃用)','装配在魂珠界面，可以大幅度提升抗暴','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201123,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201124,'抗暴魂珠(弃用)','装配在魂珠界面，可以大幅度提升抗暴','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201124,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201130,'移速魂珠(弃用)','装配在魂珠界面，可以大幅度提升移动速度','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201140,0,1,0,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201131,'移速魂珠(弃用)','装配在魂珠界面，可以大幅度提升移动速度','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201141,0,1,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201132,'移速魂珠(弃用)','装配在魂珠界面，可以大幅度提升移动速度','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201142,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201133,'移速魂珠(弃用)','装配在魂珠界面，可以大幅度提升移动速度','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201143,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201134,'移速魂珠(弃用)','装配在魂珠界面，可以大幅度提升移动速度','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201144,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201140,'经验魂珠','装配在魂珠界面，可以大幅度提升经验加成','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201130,0,1,0,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201141,'经验魂珠','装配在魂珠界面，可以大幅度提升经验加成','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201131,0,1,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201142,'经验魂珠','装配在魂珠界面，可以大幅度提升经验加成','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201132,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201143,'经验魂珠','装配在魂珠界面，可以大幅度提升经验加成','',0,'【魂珠寻宝,魂珠塔,运营活动】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201133,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201144,'经验魂珠','装配在魂珠界面，可以大幅度提升经验加成','',0,'【魂珠寻宝,魂珠塔,运营活动】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201134,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201150,'武器攻击魂珠','装配在魂珠界面，可以大幅度提升武器攻击','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201150,0,1,0,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201151,'武器攻击魂珠','装配在魂珠界面，可以大幅度提升武器攻击','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201151,0,1,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201152,'武器攻击魂珠','装配在魂珠界面，可以大幅度提升武器攻击','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201152,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201153,'武器攻击魂珠','装配在魂珠界面，可以大幅度提升武器攻击','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201153,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201154,'武器攻击魂珠','装配在魂珠界面，可以大幅度提升武器攻击','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201154,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201160,'武器破甲魂珠','装配在魂珠界面，可以大幅度提升武器破甲','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201160,0,1,0,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201161,'武器破甲魂珠','装配在魂珠界面，可以大幅度提升武器破甲','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201161,0,1,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201162,'武器破甲魂珠','装配在魂珠界面，可以大幅度提升武器破甲','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201162,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201163,'武器破甲魂珠','装配在魂珠界面，可以大幅度提升武器破甲','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201163,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201164,'武器破甲魂珠','装配在魂珠界面，可以大幅度提升武器破甲','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201164,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201170,'防具生命魂珠','装配在魂珠界面，可以大幅度提升防具生命','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201170,0,1,0,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201171,'防具生命魂珠','装配在魂珠界面，可以大幅度提升防具生命','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201171,0,1,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201172,'防具生命魂珠','装配在魂珠界面，可以大幅度提升防具生命','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201172,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201173,'防具生命魂珠','装配在魂珠界面，可以大幅度提升防具生命','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201173,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201174,'防具生命魂珠','装配在魂珠界面，可以大幅度提升防具生命','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201174,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201180,'防具防御魂珠','装配在魂珠界面，可以大幅度提升防具防御','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201180,0,1,0,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201181,'防具防御魂珠','装配在魂珠界面，可以大幅度提升防具防御','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201181,0,1,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201182,'防具防御魂珠','装配在魂珠界面，可以大幅度提升防具防御','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201182,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201183,'防具防御魂珠','装配在魂珠界面，可以大幅度提升防具防御','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201183,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201184,'防具防御魂珠','装配在魂珠界面，可以大幅度提升防具防御','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201184,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201190,'饰品攻击魂珠','装配在魂珠界面，可以大幅度提升饰品攻击','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201190,0,1,0,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201191,'饰品攻击魂珠','装配在魂珠界面，可以大幅度提升饰品攻击','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201191,0,1,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201192,'饰品攻击魂珠','装配在魂珠界面，可以大幅度提升饰品攻击','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201192,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201193,'饰品攻击魂珠','装配在魂珠界面，可以大幅度提升饰品攻击','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201193,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201194,'饰品攻击魂珠','装配在魂珠界面，可以大幅度提升饰品攻击','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201194,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201200,'饰品破甲魂珠','装配在魂珠界面，可以大幅度提升饰品破甲','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201200,0,1,0,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201201,'饰品破甲魂珠','装配在魂珠界面，可以大幅度提升饰品破甲','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201201,0,1,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201202,'饰品破甲魂珠','装配在魂珠界面，可以大幅度提升饰品破甲','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201202,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201203,'饰品破甲魂珠','装配在魂珠界面，可以大幅度提升饰品破甲','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201203,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201204,'饰品破甲魂珠','装配在魂珠界面，可以大幅度提升饰品破甲','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201204,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201210,'基础攻击魂珠(弃用)','装配在魂珠界面，可以大幅度提升基础攻击','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201210,0,1,0,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201211,'基础攻击魂珠(弃用)','装配在魂珠界面，可以大幅度提升基础攻击','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201211,0,1,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201212,'基础攻击魂珠(弃用)','装配在魂珠界面，可以大幅度提升基础攻击','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201212,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201213,'基础攻击魂珠(弃用)','装配在魂珠界面，可以大幅度提升基础攻击','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201213,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201214,'基础攻击魂珠(弃用)','装配在魂珠界面，可以大幅度提升基础攻击','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201214,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201220,'基础生命魂珠(弃用)','装配在魂珠界面，可以大幅度提升基础生命','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201220,0,1,0,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201221,'基础生命魂珠(弃用)','装配在魂珠界面，可以大幅度提升基础生命','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201221,0,1,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201222,'基础生命魂珠(弃用)','装配在魂珠界面，可以大幅度提升基础生命','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201222,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201223,'基础生命魂珠(弃用)','装配在魂珠界面，可以大幅度提升基础生命','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201223,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201224,'基础生命魂珠(弃用)','装配在魂珠界面，可以大幅度提升基础生命','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201224,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201230,'基础破甲魂珠(弃用)','装配在魂珠界面，可以大幅度提升基础破甲','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201230,0,1,0,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201231,'基础破甲魂珠(弃用)','装配在魂珠界面，可以大幅度提升基础破甲','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201231,0,1,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201232,'基础破甲魂珠(弃用)','装配在魂珠界面，可以大幅度提升基础破甲','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201232,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201233,'基础破甲魂珠(弃用)','装配在魂珠界面，可以大幅度提升基础破甲','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201233,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201234,'基础破甲魂珠(弃用)','装配在魂珠界面，可以大幅度提升基础破甲','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201234,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201240,'基础防御魂珠(弃用)','装配在魂珠界面，可以大幅度提升基础防御','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201240,0,1,0,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201241,'基础防御魂珠(弃用)','装配在魂珠界面，可以大幅度提升基础防御','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201241,0,1,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201242,'基础防御魂珠(弃用)','装配在魂珠界面，可以大幅度提升基础防御','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201242,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201243,'基础防御魂珠(弃用)','装配在魂珠界面，可以大幅度提升基础防御','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201243,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201244,'基础防御魂珠(弃用)','装配在魂珠界面，可以大幅度提升基础防御','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201244,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201250,'攻击加成魂珠(弃用)','装配在魂珠界面，可以大幅度提升攻击加成','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201250,0,1,0,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201251,'攻击加成魂珠(弃用)','装配在魂珠界面，可以大幅度提升攻击加成','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201251,0,1,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201252,'攻击加成魂珠(弃用)','装配在魂珠界面，可以大幅度提升攻击加成','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201252,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201253,'攻击加成魂珠(弃用)','装配在魂珠界面，可以大幅度提升攻击加成','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201253,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201254,'攻击加成魂珠(弃用)','装配在魂珠界面，可以大幅度提升攻击加成','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201254,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201260,'生命加成魂珠(弃用)','装配在魂珠界面，可以大幅度提升生命加成','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201260,0,1,0,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201261,'生命加成魂珠(弃用)','装配在魂珠界面，可以大幅度提升生命加成','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201261,0,1,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201262,'生命加成魂珠(弃用)','装配在魂珠界面，可以大幅度提升生命加成','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201262,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201263,'生命加成魂珠(弃用)','装配在魂珠界面，可以大幅度提升生命加成','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201263,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201264,'生命加成魂珠(弃用)','装配在魂珠界面，可以大幅度提升生命加成','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201264,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201270,'破甲加成魂珠(弃用)','装配在魂珠界面，可以大幅度提升破甲加成','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201270,0,1,0,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201271,'破甲加成魂珠(弃用)','装配在魂珠界面，可以大幅度提升破甲加成','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201271,0,1,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201272,'破甲加成魂珠(弃用)','装配在魂珠界面，可以大幅度提升破甲加成','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201272,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201273,'破甲加成魂珠(弃用)','装配在魂珠界面，可以大幅度提升破甲加成','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201273,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201274,'破甲加成魂珠(弃用)','装配在魂珠界面，可以大幅度提升破甲加成','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201274,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201280,'防御加成魂珠(弃用)','装配在魂珠界面，可以大幅度提升防御加成','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201280,0,1,0,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201281,'防御加成魂珠(弃用)','装配在魂珠界面，可以大幅度提升防御加成','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201281,0,1,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201282,'防御加成魂珠(弃用)','装配在魂珠界面，可以大幅度提升防御加成','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201282,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201283,'防御加成魂珠(弃用)','装配在魂珠界面，可以大幅度提升防御加成','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201283,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5201284,'防御加成魂珠(弃用)','装配在魂珠界面，可以大幅度提升防御加成','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,1,0,0,0,5201284,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5202015,'致命一击魂珠','装配在魂珠界面，攻击5%概率追加额外100%伤害','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,2,0,0,0,141000132,0,1,0,5,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5202025,'绝对闪避魂珠','装配在魂珠界面，受到攻击5%概率100%闪避这次伤害','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,2,0,0,0,141000132,0,1,0,5,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5203001,'供养魂珠','分解后可以获得500魂珠经验','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,3,0,0,0,5203001,0,1,0,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5203002,'供养魂珠','分解后可以获得1000魂珠经验','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,3,0,0,0,5203002,0,1,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5203003,'供养魂珠','分解后可以获得2000魂珠经验','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,3,0,0,0,5203003,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5203004,'供养魂珠','分解后可以获得5000魂珠经验','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,3,0,0,0,5203004,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5203005,'供养魂珠','分解后可以获得10000魂珠经验','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,52,3,0,0,0,5203005,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5204001,'融魂之炎','融合魂珠的材料，可以将魂珠属性融合附加强大战力','',0,'【活动获得】','[{0,0,0}]',0,0,0,52,4,0,0,0,5204001,0,240,9999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(5205001,'[良好]淬魂药剂','淬炼双属性魂珠，至多可以提供额外一条属性','',0,'【活动获得】','[{0,0,0}]',0,0,0,52,5,0,0,0,5205001,0,1,9999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5205002,'[精品]淬魂药剂','淬炼双属性魂珠，至多可以提供额外两条属性','',0,'【活动获得】','[{0,0,0}]',0,0,0,52,5,0,0,0,5205002,0,1,9999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206012,'攻击破甲魂珠(弃用)','装配在魂珠界面，可以同时提升攻击破甲','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206012,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206013,'攻击破甲魂珠(弃用)','装配在魂珠界面，可以同时提升攻击破甲','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206013,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206014,'攻击破甲魂珠(弃用)','装配在魂珠界面，可以同时提升攻击破甲','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206014,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206022,'攻击命中魂珠(弃用)','装配在魂珠界面，可以同时提升攻击命中','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206022,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206023,'攻击命中魂珠(弃用)','装配在魂珠界面，可以同时提升攻击命中','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206023,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206024,'攻击命中魂珠(弃用)','装配在魂珠界面，可以同时提升攻击命中','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206024,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206032,'攻击暴击魂珠(弃用)','装配在魂珠界面，可以同时提升攻击暴击','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206032,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206033,'攻击暴击魂珠(弃用)','装配在魂珠界面，可以同时提升攻击暴击','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206033,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206034,'攻击暴击魂珠(弃用)','装配在魂珠界面，可以同时提升攻击暴击','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206034,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206042,'攻击固伤魂珠(弃用)','装配在魂珠界面，可以同时提升攻击固伤','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206042,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206043,'攻击固伤魂珠(弃用)','装配在魂珠界面，可以同时提升攻击固伤','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206043,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206044,'攻击固伤魂珠(弃用)','装配在魂珠界面，可以同时提升攻击固伤','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206044,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206052,'攻击暴伤魂珠(弃用)','装配在魂珠界面，可以同时提升攻击暴伤','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206052,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206053,'攻击暴伤魂珠(弃用)','装配在魂珠界面，可以同时提升攻击暴伤','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206053,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206054,'攻击暴伤魂珠(弃用)','装配在魂珠界面，可以同时提升攻击暴伤','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206054,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206062,'破甲命中魂珠(弃用)','装配在魂珠界面，可以同时提升破甲命中','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206062,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206063,'破甲命中魂珠(弃用)','装配在魂珠界面，可以同时提升破甲命中','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206063,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206064,'破甲命中魂珠(弃用)','装配在魂珠界面，可以同时提升破甲命中','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206064,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206072,'破甲暴击魂珠(弃用)','装配在魂珠界面，可以同时提升破甲暴击','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206072,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206073,'破甲暴击魂珠(弃用)','装配在魂珠界面，可以同时提升破甲暴击','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206073,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206074,'破甲暴击魂珠(弃用)','装配在魂珠界面，可以同时提升破甲暴击','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206074,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206082,'破甲固伤魂珠(弃用)','装配在魂珠界面，可以同时提升破甲固伤','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206082,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206083,'破甲固伤魂珠(弃用)','装配在魂珠界面，可以同时提升破甲固伤','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206083,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206084,'破甲固伤魂珠(弃用)','装配在魂珠界面，可以同时提升破甲固伤','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206084,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206092,'破甲暴伤魂珠(弃用)','装配在魂珠界面，可以同时提升破甲暴伤','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206092,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206093,'破甲暴伤魂珠(弃用)','装配在魂珠界面，可以同时提升破甲暴伤','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206093,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206094,'破甲暴伤魂珠(弃用)','装配在魂珠界面，可以同时提升破甲暴伤','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206094,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206102,'命中暴击魂珠(弃用)','装配在魂珠界面，可以同时提升命中暴击','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206102,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206103,'命中暴击魂珠(弃用)','装配在魂珠界面，可以同时提升命中暴击','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206103,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206104,'命中暴击魂珠(弃用)','装配在魂珠界面，可以同时提升命中暴击','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206104,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206112,'命中固伤魂珠(弃用)','装配在魂珠界面，可以同时提升命中固伤','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206112,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206113,'命中固伤魂珠(弃用)','装配在魂珠界面，可以同时提升命中固伤','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206113,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206114,'命中固伤魂珠(弃用)','装配在魂珠界面，可以同时提升命中固伤','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206114,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206122,'命中暴伤魂珠(弃用)','装配在魂珠界面，可以同时提升命中暴伤','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206122,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206123,'命中暴伤魂珠(弃用)','装配在魂珠界面，可以同时提升命中暴伤','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206123,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206124,'命中暴伤魂珠(弃用)','装配在魂珠界面，可以同时提升命中暴伤','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206124,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206132,'暴击固伤魂珠(弃用)','装配在魂珠界面，可以同时提升暴击固伤','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206132,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206133,'暴击固伤魂珠(弃用)','装配在魂珠界面，可以同时提升暴击固伤','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206133,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206134,'暴击固伤魂珠(弃用)','装配在魂珠界面，可以同时提升暴击固伤','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206134,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206142,'暴击暴伤魂珠(弃用)','装配在魂珠界面，可以同时提升暴击暴伤','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206142,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206143,'暴击暴伤魂珠(弃用)','装配在魂珠界面，可以同时提升暴击暴伤','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206143,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206144,'暴击暴伤魂珠(弃用)','装配在魂珠界面，可以同时提升暴击暴伤','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206144,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206152,'固伤暴伤魂珠(弃用)','装配在魂珠界面，可以同时提升固伤暴伤','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206152,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206153,'固伤暴伤魂珠(弃用)','装配在魂珠界面，可以同时提升固伤暴伤','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206153,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206154,'固伤暴伤魂珠(弃用)','装配在魂珠界面，可以同时提升固伤暴伤','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206154,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206162,'生命防御魂珠(弃用)','装配在魂珠界面，可以同时提升生命防御','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206162,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206163,'生命防御魂珠(弃用)','装配在魂珠界面，可以同时提升生命防御','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206163,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206164,'生命防御魂珠(弃用)','装配在魂珠界面，可以同时提升生命防御','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206164,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206172,'生命闪避魂珠(弃用)','装配在魂珠界面，可以同时提升生命闪避','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206172,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206173,'生命闪避魂珠(弃用)','装配在魂珠界面，可以同时提升生命闪避','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206173,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206174,'生命闪避魂珠(弃用)','装配在魂珠界面，可以同时提升生命闪避','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206174,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206182,'生命韧性魂珠(弃用)','装配在魂珠界面，可以同时提升生命韧性','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206182,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206183,'生命韧性魂珠(弃用)','装配在魂珠界面，可以同时提升生命韧性','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206183,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206184,'生命韧性魂珠(弃用)','装配在魂珠界面，可以同时提升生命韧性','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206184,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206192,'生命固防魂珠(弃用)','装配在魂珠界面，可以同时提升生命固防','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206192,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206193,'生命固防魂珠(弃用)','装配在魂珠界面，可以同时提升生命固防','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206193,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206194,'生命固防魂珠(弃用)','装配在魂珠界面，可以同时提升生命固防','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206194,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206202,'生命抗暴魂珠(弃用)','装配在魂珠界面，可以同时提升生命抗暴','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206202,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206203,'生命抗暴魂珠(弃用)','装配在魂珠界面，可以同时提升生命抗暴','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206203,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206204,'生命抗暴魂珠(弃用)','装配在魂珠界面，可以同时提升生命抗暴','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206204,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206212,'防御闪避魂珠(弃用)','装配在魂珠界面，可以同时提升防御闪避','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206212,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206213,'防御闪避魂珠(弃用)','装配在魂珠界面，可以同时提升防御闪避','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206213,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206214,'防御闪避魂珠(弃用)','装配在魂珠界面，可以同时提升防御闪避','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206214,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206222,'防御韧性魂珠(弃用)','装配在魂珠界面，可以同时提升防御韧性','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206222,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206223,'防御韧性魂珠(弃用)','装配在魂珠界面，可以同时提升防御韧性','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206223,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206224,'防御韧性魂珠(弃用)','装配在魂珠界面，可以同时提升防御韧性','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206224,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206232,'防御固防魂珠(弃用)','装配在魂珠界面，可以同时提升防御固防','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206232,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206233,'防御固防魂珠(弃用)','装配在魂珠界面，可以同时提升防御固防','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206233,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206234,'防御固防魂珠(弃用)','装配在魂珠界面，可以同时提升防御固防','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206234,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206242,'防御抗暴魂珠(弃用)','装配在魂珠界面，可以同时提升防御抗暴','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206242,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206243,'防御抗暴魂珠(弃用)','装配在魂珠界面，可以同时提升防御抗暴','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206243,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206244,'防御抗暴魂珠(弃用)','装配在魂珠界面，可以同时提升防御抗暴','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206244,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206252,'闪避韧性魂珠(弃用)','装配在魂珠界面，可以同时提升闪避韧性','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206252,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206253,'闪避韧性魂珠(弃用)','装配在魂珠界面，可以同时提升闪避韧性','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206253,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206254,'闪避韧性魂珠(弃用)','装配在魂珠界面，可以同时提升闪避韧性','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206254,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206262,'闪避固防魂珠(弃用)','装配在魂珠界面，可以同时提升闪避固防','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206262,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206263,'闪避固防魂珠(弃用)','装配在魂珠界面，可以同时提升闪避固防','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206263,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206264,'闪避固防魂珠(弃用)','装配在魂珠界面，可以同时提升闪避固防','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206264,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206272,'闪避抗暴魂珠(弃用)','装配在魂珠界面，可以同时提升闪避抗暴','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206272,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206273,'闪避抗暴魂珠(弃用)','装配在魂珠界面，可以同时提升闪避抗暴','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206273,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206274,'闪避抗暴魂珠(弃用)','装配在魂珠界面，可以同时提升闪避抗暴','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206274,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206282,'韧性固防魂珠(弃用)','装配在魂珠界面，可以同时提升韧性固防','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206282,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206283,'韧性固防魂珠(弃用)','装配在魂珠界面，可以同时提升韧性固防','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206283,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206284,'韧性固防魂珠(弃用)','装配在魂珠界面，可以同时提升韧性固防','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206284,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206292,'韧性抗暴魂珠(弃用)','装配在魂珠界面，可以同时提升韧性抗暴','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206292,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206293,'韧性抗暴魂珠(弃用)','装配在魂珠界面，可以同时提升韧性抗暴','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206293,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206294,'韧性抗暴魂珠(弃用)','装配在魂珠界面，可以同时提升韧性抗暴','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206294,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206302,'固防抗暴魂珠(弃用)','装配在魂珠界面，可以同时提升固防抗暴','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206302,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206303,'固防抗暴魂珠(弃用)','装配在魂珠界面，可以同时提升固防抗暴','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206303,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206304,'固防抗暴魂珠(弃用)','装配在魂珠界面，可以同时提升固防抗暴','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206304,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206312,'双力魂·魂珠','装配在魂珠界面，可以同时提升武器攻击、攻击','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206312,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206313,'双力魂·魂珠','装配在魂珠界面，可以同时提升武器攻击、攻击','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206313,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206314,'双力魂·魂珠','装配在魂珠界面，可以同时提升武器攻击、攻击','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206314,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206322,'血双魂·魂珠','装配在魂珠界面，可以同时提升装备生命、生命','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206322,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206323,'血双魂·魂珠','装配在魂珠界面，可以同时提升装备生命、生命','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206323,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206324,'血双魂·魂珠','装配在魂珠界面，可以同时提升装备生命、生命','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206324,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206332,'碾双魂·魂珠','装配在魂珠界面，可以同时提升武器破甲、破甲','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206332,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206333,'碾双魂·魂珠','装配在魂珠界面，可以同时提升武器破甲、破甲','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206333,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206334,'碾双魂·魂珠','装配在魂珠界面，可以同时提升武器破甲、破甲','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206334,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206342,'盾双魂·魂珠','装配在魂珠界面，可以同时提升防具防御、防御','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206342,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206343,'盾双魂·魂珠','装配在魂珠界面，可以同时提升装备防御、防御','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206343,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206344,'盾双魂·魂珠','装配在魂珠界面，可以同时提升装备防御、防御','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206344,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206352,'破双魂·魂珠','装配在魂珠界面，可以同时提升饰品攻击、命中','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206352,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206353,'破双魂·魂珠','装配在魂珠界面，可以同时提升饰品攻击、命中','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206353,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206354,'破双魂·魂珠','装配在魂珠界面，可以同时提升饰品攻击、命中','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206354,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206362,'影双魂·魂珠','装配在魂珠界面，可以同时提升经验加成、闪避','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206362,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206363,'影双魂·魂珠','装配在魂珠界面，可以同时提升经验加成、闪避','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206363,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206364,'影双魂·魂珠','装配在魂珠界面，可以同时提升经验加成、闪避','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206364,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206372,'灭双魂·魂珠','装配在魂珠界面，可以同时提升固定攻击、暴击','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206372,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206373,'灭双魂·魂珠','装配在魂珠界面，可以同时提升固定攻击、暴击','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206373,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206374,'灭双魂·魂珠','装配在魂珠界面，可以同时提升固定攻击、暴击','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206374,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206382,'防双魂·魂珠','装配在魂珠界面，可以同时提升固定防御、韧性','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206382,0,1,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206383,'防双魂·魂珠','装配在魂珠界面，可以同时提升固定防御、韧性','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206383,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(5206384,'防双魂·魂珠','装配在魂珠界面，可以同时提升固定防御、韧性','',0,'【魂珠融合】','[{0,0,0}]',0,0,0,52,6,0,0,0,5206384,0,1,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(11010001,'波塞冬','激活降神：波塞冬，在降神界面中使用。\\n激活立即获得<color=#4eae1a>65616战力</color>，后面更可通过<color=#4eae1a>培养获得更多战力</color>！','',65616,'【运营活动】','[{0,0,0}]',0,0,0,11,1,0,0,0,11010001,0,25,99,4,0,0,0,'[]',0,0,0,0,'[]','[]',601003,0,0,1),(11010002,'雅典娜','激活降神：雅典娜，在降神界面中使用。\\n激活立即获得<color=#4eae1a>55635战力</color>，后面更可通过<color=#4eae1a>培养获得更多战力</color>！','',55635,'【vip礼包】','[{159,3,1}]',0,0,0,11,1,1,0,0,11010002,0,25,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(11010003,'光辉神','激活降神：光辉神，在降神界面中使用。\\n激活立即获得<color=#4eae1a>3750战力</color>，后面更可通过<color=#4eae1a>培养获得更多战力</color>！','',3750,'【运营活动】','[{0,0,0}]',0,0,0,11,1,1,0,0,11010003,0,25,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',203021,0,0,1),(11010004,'冰雪女王碎片','集齐<color=#4eae1a>8</color>个碎片即可激活降神：冰雪女王，在降神界面中使用。\\n激活立即获得<color=#4eae1a>36108+战力</color>，后面更可通过<color=#4eae1a>培养获得更多战力</color>！','',36108,'【限时目标】','[{501,0,1}]',0,0,0,11,1,0,0,0,11010004,0,25,99,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(11010005,'月神','激活降神：月神，在降神界面中使用。\\n激活立即获得<color=#4eae1a>47399战力</color>，后面更可通过<color=#4eae1a>培养获得更多战力</color>！','',47399,'【运营活动】','[{0,0,0}]',0,0,0,11,1,0,0,0,11010005,0,25,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',203022,0,0,1),(11010006,'哈迪斯','激活降神：哈迪斯，在降神界面中使用。\\n激活立即获得<color=#4eae1a>84177战力</color>，后面更可通过<color=#4eae1a>培养获得更多战力</color>！','',84177,'【运营活动】','[{0,0,0}]',0,0,0,11,1,0,0,0,11010006,0,25,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',203018,0,0,1),(11020001,'初级神源之火','降神升阶道具，适用于1-8阶，增加10点经验值','',0,'【降神副本,公会守卫,商城,运营活动】','[{610,36,1},{402,3,0},{153,1,0}]',0,0,0,11,2,1,0,0,11020001,0,12,99999,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(11020002,'中级神源之火','降神升阶道具，适用于9-16阶，增加20点经验值','',0,'【降神副本,公会守卫,材料合成】','[{610,36,1},{402,3,0},{150,5,0}]',0,0,0,11,2,1,0,0,11020002,0,12,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(11020003,'高级神源之火','降神升阶道具，适用于17-25阶，增加40点经验值','',0,'【降神副本,公会守卫,材料合成】','[{610,36,1},{402,3,0},{150,5,0}]',0,0,0,11,2,1,0,0,11020003,0,12,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(11030001,'海神三叉戟','激活波塞冬武器：三叉戟，在【降神】-【降神圣器】中使用','',68580,'【运营活动】','[{0,0,0}]',0,0,0,11,3,0,0,0,11030001,0,1,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(11030002,'荣耀之枪','激活女武神武器：胜利之枪，在【降神】-【降神圣器】中使用','',57840,'【vip礼包】','[{159,3,1}]',0,0,0,11,3,1,0,0,11030002,0,1,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(11030003,'太阳权杖','激活光辉神武器：太阳权杖，在【降神】-【降神圣器】中使用','',21880,'【0元圣器】','[{0,0,0}]',0,0,0,11,3,1,0,0,11030003,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(11030004,'霜之哀伤碎片','集齐<color=#4eae1a>8</color>个碎片，即可激活冰雪女王武器：霜之哀伤，在【降神】-【降神圣器】中使用','',33090,'【限时目标】','[{501,0,1}]',0,0,0,11,3,0,0,0,11030004,0,1,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(11030005,'月牙天冲','激活月神武器：月牙天冲，在【降神】-【降神圣器】中使用。','',48620,'【运营活动】','[{0,0,0}]',0,0,0,11,3,0,0,0,11030005,0,1,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(11030006,'亡者黑镰','激活死神-哈迪斯武器：亡者黑镰，在【降神】-【降神圣器】中使用','',89360,'【运营活动】','[{0,0,0}]',0,0,0,11,3,0,0,0,11030006,0,1,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(11040001,'波塞冬印记','降神圣器印记的升级道具','',0,'【运营活动】','[{0,0,0}]',0,0,0,11,4,0,0,0,11040001,0,12,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(11040002,'女武神印记','降神圣器印记的升级道具','',0,'【运营活动】','[{0,0,0}]',0,0,0,11,4,0,0,0,11040002,0,12,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(11040003,'光辉神印记','降神圣器印记的升级道具','',0,'【荣耀商城,运营活动】','[{0,0,0}]',0,0,0,11,4,0,0,0,11040003,0,12,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(11040004,'冰雪印记','降神圣器印记的升级道具','',0,'【荣耀商城,运营活动】','[{280,0,1}]',0,0,0,11,4,0,0,0,11040004,0,12,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(11040005,'月神印记','降神圣器印记的升级道具','',0,'【荣耀商城,运营活动】','[{280,0,1}]',0,0,0,11,4,0,0,0,11040005,0,12,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(11040006,'死神印记','降神圣器印记的升级道具','',0,'【运营活动】','[{280,0,1}]',0,0,0,11,4,0,0,0,11040006,0,12,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(11050001,'碎片·波塞冬','集齐<color=#4eae1a>30</color>个碎片,在【合成】中合成,即可激活降神：波塞冬，在降神界面中使用。\\n激活立即获得<color=#4eae1a>35616战力</color>，后面更可通过<color=#4eae1a>培养获得更多战力</color>！','',35616,'【运营活动】','[{0,0,0}]',0,0,0,11,5,0,0,0,11050001,0,25,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',601003,0,0,1),(11050002,'碎片·雅典娜','集齐<color=#4eae1a>30</color>个碎片,在【合成】中合成,即可激活降神：雅典娜，在降神界面中使用。\\n激活立即获得<color=#4eae1a>28635战力</color>，后面更可通过<color=#4eae1a>培养获得更多战力</color>！','',28635,'【vip礼包】','[{159,3,1}]',0,0,0,11,5,1,0,0,11050002,0,25,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(11050003,'碎片·光辉神','集齐<color=#4eae1a>30</color>个碎片,在【合成】中合成,即可激活降神：光辉神，在降神界面中使用。\\n激活立即获得<color=#4eae1a>3750战力</color>，后面更可通过<color=#4eae1a>培养获得更多战力</color>！','',3750,'【星之轨迹】','[{425,0,1}]',0,0,0,11,5,1,0,0,11050003,0,25,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',203021,0,0,1),(11050004,'碎片·月神','集齐<color=#4eae1a>30</color>个碎片,在【合成】中合成,即可激活降神：月神，在降神界面中使用。\\n激活立即获得<color=#4eae1a>22399战力</color>，后面更可通过<color=#4eae1a>培养获得更多战力</color>！','',22399,'【运营活动】','[{425,0,1}]',0,0,0,11,5,0,0,0,11050004,0,25,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',203022,0,0,1),(11050005,'碎片·哈迪斯','集齐<color=#4eae1a>30</color>个碎片,在【合成】中合成,即可激活降神：哈迪斯，在降神界面中使用。\\n激活立即获得<color=#4eae1a>49177战力</color>，后面更可通过<color=#4eae1a>培养获得更多战力</color>！','',49177,'【运营活动】','[{425,0,1}]',0,0,0,11,5,0,0,0,11050005,0,25,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',203018,0,0,1),(11060001,'碎片·海神三叉戟','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成,即可激活波塞冬神器：海神三叉戟，在【降神】-【降神圣器】中使用','',68580,'【运营活动】','[{0,0,0}]',0,0,0,11,6,0,0,0,11060001,0,1,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(11060002,'碎片·荣耀之枪','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成,即可激活雅典娜神器：荣耀之枪，在【降神】-【降神圣器】中使用','',57840,'【vip礼包】','[{159,3,1}]',0,0,0,11,6,1,0,0,11060002,0,1,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(11060003,'碎片·太阳权杖','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成,即可激活光辉神神器：太阳权杖，在【降神】-【降神圣器】中使用','',21880,'【运营活动】','[{425,0,1}]',0,0,0,11,6,1,0,0,11060003,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(11060004,'碎片·月牙天冲','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成,即可激活月神神器：月牙天冲，在【降神】-【降神圣器】中使用','',48620,'【运营活动】','[{425,0,1}]',0,0,0,11,6,0,0,0,11060004,0,1,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(11060005,'碎片·亡者黑镰','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成,即可激活哈迪斯神器：亡者黑镰，在【降神】-【降神圣器】中使用','',89360,'【运营活动】','[{0,0,0}]',0,0,0,11,6,0,0,0,11060005,0,1,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(11070001,'初级神符碎片','用于符文强化，可以提供30点升级经验','',0,'【降神塔,商城购买,运营活动】','[{610,9,1},{153,2,0}]',1,1,0,11,7,1,2,0,11070001,0,0,99999,1,0,0,0,'[{1,21}]',0,0,0,0,'[]','[]',0,0,0,1),(11070002,'中级神符碎片','用于符文强化，可以提供100点升级经验','',0,'【每周限购,运营活动】','[{153,1,0}]',1,1,0,11,7,1,2,0,11070002,0,0,99999,2,1,0,0,'[{1,22}]',0,0,0,0,'[]','[]',0,0,0,1),(11070003,'高级神符碎片','用于符文强化，可以提供300点升级经验','',0,'【运营活动】','[{0,0,0}]',1,1,0,11,7,1,2,0,11070003,0,0,99999,3,2,0,0,'[{1,23}]',0,0,0,0,'[]','[]',0,0,0,1),(11070010,'超越之符','符文强化中突破时所需的材料，可以提供1000点突破经验值','',0,'【降神塔,商城购买】','[{610,9,1},{153,7,0}]',1,1,0,11,7,1,2,0,11070010,0,0,99999,3,3,0,0,'[{1,24}]',0,0,0,0,'[]','[]',0,0,0,1),(12010001,'新婚礼服','激活时装衣服：新婚礼服，在【时装】-【衣服】中使用','生命 + 3360,防御 + 84,韧性 + 28',6860,'【举行婚礼】','[{0,0,0}]',0,0,1,12,1,0,0,0,12010001,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12010002,'战国甲胄','激活时装衣服：战国甲胄，在【时装】-【衣服】中使用','生命 + 4320,防御 + 108,韧性 + 36',6860,'【运营活动】','[{0,0,0}]',0,0,0,12,1,0,0,0,12010002,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12010003,'西域风情','激活时装衣服：西域风情，在【时装】-【衣服】中使用','生命 + 2400,防御 + 60,韧性 + 20',4900,'【运营活动】','[{0,0,0}]',0,0,0,12,1,0,0,0,12010003,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12010004,'偶像礼服','激活时装衣服：偶像礼服，在【时装】-【衣服】中使用','生命 + 3580,防御 + 90,韧性 + 30',3430,'【七日登录】','[{0,0,0}]',0,0,0,12,1,0,0,0,12010004,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12010005,'水手服饰','激活时装衣服：水手服饰，在【时装】-【衣服】中使用','生命 + 1820,防御 + 46,韧性 + 15',7330,'【冲级豪礼,成就奖励】','[{0,0,0}]',0,0,0,12,1,0,0,0,12010005,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12010006,'海盗船长','激活时装衣服：海盗船长，在【时装】-【衣服】中使用','生命 + 2860,防御 + 72,韧性 + 24',5860,'【运营活动】','[{0,0,0}]',0,0,0,12,1,0,0,0,12010006,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12010007,'叛逆青春','激活时装衣服：叛逆青春，在【时装】-【衣服】中使用','生命 + 5060,防御 + 127,韧性 + 42',5860,'【运营活动】','[{0,0,0}]',0,0,0,12,1,0,0,0,12010007,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12010008,'变身熊猫','激活时装衣服：变身熊猫，在【时装】-【衣服】中使用','生命 + 4320,防御 + 108,韧性 + 36',8820,'【时装商城】','[{0,0,0}]',0,0,0,12,1,0,0,0,12010008,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12010009,'传奇海怪','激活时装衣服：变身熊猫，在【时装】-【衣服】中使用','生命 + 3740,防御 + 94,韧性 + 31',7640,'【运营活动】','[{0,0,0}]',0,0,0,12,1,0,0,0,12010009,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12010010,'劳动光荣','激活时装衣服：劳动套装，在【时装】-【衣服】中使用','生命 + 3740,防御 + 94,韧性 + 31',7640,'【运营活动】','[{0,0,0}]',0,0,0,12,1,0,0,0,12010010,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12010011,'童心未泯','激活时装衣服：童心未泯，在【时装】-【衣服】中使用','生命 + 3740,防御 + 94,韧性 + 31',7640,'【运营活动】','[{0,0,0}]',0,0,0,12,1,0,0,0,12010011,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(12010012,'管弦乐手','激活时装衣服：管弦乐手，在【时装】-【衣服】中使用','生命 + 3300,防御 + 83,韧性 + 28',7640,'【首充获得】','[{0,0,0}]',0,0,0,12,1,0,0,0,12010012,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(12011001,'新婚礼服·15天','激活时装衣服：新婚礼服，在【时装】-【衣服】中使用\\n温馨提醒：\\n当时装·新婚礼服被永久激活后，限时时装只能用于出售','生命 + 3360,防御 + 84,韧性 + 28',6860,'【举行婚礼】','[{0,0,0}]',0,0,1,12,1,0,0,0,12010001,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12012001,'新婚礼服·7天','激活时装衣服：新婚礼服，在【时装】-【衣服】中使用\\n温馨提醒：\\n当时装·新婚礼服被永久激活后，限时时装只能用于出售','生命 + 3360,防御 + 84,韧性 + 28',6860,'【举行婚礼】','[{0,0,0}]',0,0,1,12,1,0,0,0,12010001,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12013001,'新婚礼服·3天','激活时装衣服：新婚礼服，在【时装】-【衣服】中使用\\n温馨提醒：\\n当时装·新婚礼服被永久激活后，限时时装只能用于出售','生命 + 3360,防御 + 84,韧性 + 28',6860,'【举行婚礼】','[{0,0,0}]',0,0,1,12,1,0,0,0,12010001,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12020001,'甜蜜花束','激活时装武器：甜蜜花束，在【时装】-【武器】中使用','攻击 + 205,破甲 + 84,暴伤值 + 21',6830,'【运营活动】','[{0,0,0}]',0,0,0,12,2,0,0,0,12020001,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12020002,'战国寒芒','激活时装武器：战国寒芒，在【时装】-【武器】中使用','攻击 + 265,破甲 + 108,暴伤值 + 27',6850,'【运营活动】','[{0,0,0}]',0,0,0,12,2,0,0,0,12020002,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12020003,'西域武器','激活时装武器：西域武器，在【时装】-【武器】中使用','攻击 + 148,破甲 + 60,暴伤值 + 15',4910,'【运营活动】','[{0,0,0}]',0,0,0,12,2,0,0,0,12020003,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12020004,'偶像乐器','激活时装武器：偶像乐器，在【时装】-【武器】中使用','攻击 + 220,破甲 + 90,暴伤值 + 22',3410,'【运营活动】','[{0,0,0}]',0,0,0,12,2,0,0,0,12020004,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12020005,'水手武器','激活时装武器：水手武器，在【时装】-【武器】中使用','攻击 + 112,破甲 + 46,暴伤值 + 11',7310,'【成就奖励】','[{0,0,0}]',0,0,0,12,2,0,0,0,12020005,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12020006,'海盗之力','激活时装武器：海盗之力，在【时装】-【武器】中使用','攻击 + 175,破甲 + 72,暴伤值 + 18',5840,'【运营活动】','[{0,0,0}]',0,0,0,12,2,0,0,0,12020006,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12020007,'街头武器','激活时装武器：街头武器，在【时装】-【武器】中使用','攻击 + 310,破甲 + 127,暴伤值 + 31',5840,'【运营活动】','[{0,0,0}]',0,0,0,12,2,0,0,0,12020007,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12020008,'熊猫口粮','激活时装武器：熊猫口粮，在【时装】-【武器】中使用','攻击 + 265,破甲 + 108,暴伤值 + 27',8810,'【时装商城】','[{0,0,0}]',0,0,0,12,2,0,0,0,12020008,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12020009,'传奇海怪','激活时装武器：传奇海怪，在【时装】-【武器】中使用','攻击 + 230,破甲 + 94,暴伤值 + 23',7640,'【运营活动】','[{0,0,0}]',0,0,0,12,2,0,0,0,12020009,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12020010,'劳动工具','激活时装武器：劳动工具，在【时装】-【武器】中使用','攻击 + 230,破甲 + 94,暴伤值 + 23',7640,'【运营活动】','[{0,0,0}]',0,0,0,12,2,0,0,0,12020010,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12020011,'童心玩具','激活时装武器：童心玩具，在【时装】-【武器】中使用','攻击 + 230,破甲 + 94,暴伤值 + 23',7640,'【运营活动】','[{0,0,0}]',0,0,0,12,2,0,0,0,12020011,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12020012,'管弦乐器','激活时装武器：管弦乐器，在【时装】-【武器】中使用','攻击 + 203,破甲 + 83,暴伤值 + 20',7640,'【首充获得】','[{0,0,0}]',0,0,0,12,2,0,0,0,12020012,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12021001,'甜蜜花束·15天','激活时装武器：甜蜜花束，在【时装】-【武器】中使用\\n温馨提醒：\\n当时装·甜蜜花束被永久激活后，限时时装只能用于出售','攻击 + 205,破甲 + 84,暴伤值 + 21',6830,'【运营活动】','[{0,0,0}]',0,0,1,12,2,1,0,0,12020001,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12022001,'甜蜜花束·7天','激活时装武器：甜蜜花束，在【时装】-【武器】中使用\\n温馨提醒：\\n当时装·甜蜜花束被永久激活后，限时时装只能用于出售','攻击 + 205,破甲 + 84,暴伤值 + 21',6830,'【运营活动】','[{0,0,0}]',0,0,1,12,2,1,0,0,12020001,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12023001,'甜蜜花束·3天','激活时装武器：甜蜜花束，在【时装】-【武器】中使用\\n温馨提醒：\\n当时装·甜蜜花束被永久激活后，限时时装只能用于出售','攻击 + 205,破甲 + 84,暴伤值 + 21',6830,'【运营活动】','[{0,0,0}]',0,0,1,12,2,1,0,0,12020001,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12030001,'新婚发饰','激活时装头饰：新婚发饰，在【时装】-【头饰】中使用','攻击 + 168,命中 + 42,暴击 + 28',6860,'【运营活动】','[{0,0,0}]',0,0,0,12,3,0,0,0,12030001,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12030002,'战国头盔','激活时装头饰：战国头盔，在【时装】-【头饰】中使用','攻击 + 216,命中 + 54,暴击 + 36',6860,'【运营活动】','[{0,0,0}]',0,0,0,12,3,0,0,0,12030002,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12030003,'西域面纱','激活时装头饰：西域面纱，在【时装】-【头饰】中使用','攻击 + 120,命中 + 30,暴击 + 20',4900,'【运营活动】','[{0,0,0}]',0,0,0,12,3,0,0,0,12030003,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12030004,'偶像造型','激活时装头饰：偶像造型，在【时装】-【头饰】中使用','攻击 + 179,命中 + 45,暴击 + 30',3430,'【七日登录】','[{0,0,0}]',0,0,0,12,3,0,0,0,12030004,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12030005,'水手之帽','激活时装头饰：水手之帽，在【时装】-【头饰】中使用','攻击 + 91,命中 + 23,暴击 + 15',7330,'【冲级豪礼,成就奖励】','[{0,0,0}]',0,0,0,12,3,0,0,0,12030005,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12030006,'船长之帽','激活时装头饰：航海之帽，在【时装】-【头饰】中使用','攻击 + 143,命中 + 36,暴击 + 24',5860,'【运营活动】','[{0,0,0}]',0,0,0,12,3,0,0,0,12030006,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12030007,'青春头饰','激活时装头饰：叛逆头饰，在【时装】-【头饰】中使用','攻击 + 253,命中 + 63,暴击 + 42',5860,'【运营活动】','[{0,0,0}]',0,0,0,12,3,0,0,0,12030007,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12030008,'熊猫头饰','激活时装头饰：熊猫头饰，在【时装】-【头饰】中使用','攻击 + 216,命中 + 54,暴击 + 36',8820,'【时装商城】','[{0,0,0}]',0,0,0,12,3,0,0,0,12030008,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12030009,'传奇海怪','激活时装头饰：熊猫头饰，在【时装】-【头饰】中使用','攻击 + 187,命中 + 47,暴击 + 31',7640,'【运营活动】','[{0,0,0}]',0,0,0,12,3,0,0,0,12030009,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12030010,'劳动头饰','激活时装头饰：劳动头饰，在【时装】-【头饰】中使用','攻击 + 187,命中 + 47,暴击 + 31',7640,'【运营活动】','[{0,0,0}]',0,0,0,12,3,0,0,0,12030010,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12030011,'童心发饰','激活时装头饰：童心发饰，在【时装】-【头饰】中使用','攻击 + 187,命中 + 47,暴击 + 31',7640,'【运营活动】','[{0,0,0}]',0,0,0,12,3,0,0,0,12030011,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12030012,'乐队头饰','激活时装头饰：乐队发饰，在【时装】-【头饰】中使用','攻击 + 165,命中 + 41,暴击 + 28',7640,'【首充获得】','[{0,0,0}]',0,0,0,12,3,0,0,0,12030012,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12031001,'新婚发饰·15天','激活时装头饰：新婚发饰，在【时装】-【头饰】中使用\\n温馨提醒：\\n当时装·新婚发饰被永久激活后，限时时装只能用于出售','攻击 + 168,命中 + 42,暴击 + 28',6860,'【举行婚礼】','[{0,0,0}]',0,0,1,12,3,1,0,0,12030001,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12032001,'新婚发饰·7天','激活时装头饰：新婚发饰，在【时装】-【头饰】中使用\\n温馨提醒：\\n当时装·新婚发饰被永久激活后，限时时装只能用于出售','攻击 + 168,命中 + 42,暴击 + 28',6860,'【举行婚礼】','[{0,0,0}]',0,0,1,12,3,1,0,0,12030001,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12033001,'新婚发饰·3天','激活时装头饰：新婚发饰，在【时装】-【头饰】中使用\\n温馨提醒：\\n当时装·新婚发饰被永久激活后，限时时装只能用于出售','攻击 + 168,命中 + 42,暴击 + 28',6860,'【举行婚礼】','[{0,0,0}]',0,0,1,12,3,1,0,0,12030001,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12040001,'玫瑰之恋','激活时装足迹：玫瑰之恋，在【时装】-【足迹】中使用','生命 + 4100,闪避 + 42,抗暴值 + 21',6830,'【运营活动】','[{0,0,0}]',0,0,0,12,4,0,0,0,12040001,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12040002,'战争之炎','激活时装足迹：战争之炎，在【时装】-【足迹】中使用','生命 + 5300,闪避 + 54,抗暴值 + 27',6850,'【运营活动】','[{0,0,0}]',0,0,0,12,4,0,0,0,12040002,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12040003,'黄金之沙','激活时装足迹：黄金之沙，在【时装】-【足迹】中使用','生命 + 2960,闪避 + 30,抗暴值 + 15',4910,'【运营活动】','[{0,0,0}]',0,0,0,12,4,0,0,0,12040003,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12040004,'律动音符','激活时装足迹：律动音符，在【时装】-【足迹】中使用','生命 + 4400,闪避 + 45,抗暴值 + 22',3410,'【运营活动】','[{0,0,0}]',0,0,0,12,4,0,0,0,12040004,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12040005,'海洋之友','激活时装足迹：海洋之友，在【时装】-【足迹】中使用','生命 + 2240,闪避 + 23,抗暴值 + 11',7310,'【成就奖励,运营活动】','[{0,0,0}]',0,0,0,12,4,0,0,0,12040005,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12040006,'伟大航线','激活时装足迹：伟大航线，在【时装】-【足迹】中使用','生命 + 3500,闪避 + 36,抗暴值 + 18',5840,'【运营活动】','[{0,0,0}]',0,0,0,12,4,0,0,0,12040006,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12040007,'青春之焰','激活时装足迹：青春之焰，在【时装】-【足迹】中使用','生命 + 6200,闪避 + 63,抗暴值 + 31',5840,'【运营活动】','[{0,0,0}]',0,0,0,12,4,0,0,0,12040007,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12040008,'黑白萌印','激活时装足迹：黑白萌印，在【时装】-【足迹】中使用','生命 + 5300,闪避 + 54,抗暴值 + 27',8810,'【时装商城】','[{0,0,0}]',0,0,0,12,4,0,0,0,12040008,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12040009,'新主角','','生命 + 4600,闪避 + 47,抗暴值 + 23',7640,'','[{0,0,0}]',0,0,0,12,4,0,0,0,12040009,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12041001,'玫瑰之恋·15天','激活时装足迹：玫瑰之恋，在【时装】-【足迹】中使用\\n温馨提醒：\\n当时装·玫瑰之恋被永久激活后，限时时装只能用于出售','生命 + 4100,闪避 + 42,抗暴值 + 21',6830,'【举行婚礼】','[{0,0,0}]',0,0,1,12,4,1,0,0,12040001,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12042001,'玫瑰之恋·7天','激活时装足迹：玫瑰之恋，在【时装】-【足迹】中使用\\n温馨提醒：\\n当时装·玫瑰之恋被永久激活后，限时时装只能用于出售','生命 + 4100,闪避 + 42,抗暴值 + 21',6830,'【举行婚礼】','[{0,0,0}]',0,0,1,12,4,1,0,0,12040001,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12043001,'玫瑰之恋·3天','激活时装足迹：玫瑰之恋，在【时装】-【足迹】中使用\\n温馨提醒：\\n当时装·玫瑰之恋被永久激活后，限时时装只能用于出售','生命 + 4100,闪避 + 42,抗暴值 + 21',6830,'【举行婚礼】','[{0,0,0}]',0,0,1,12,4,1,0,0,12040001,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12060001,'衣服时装精华','可用来提升时装衣服部位的等级','',0,'【时装分解】','[{0,0,0}]',0,0,0,12,6,0,0,0,12060001,0,1,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(12060002,'武器时装精华','可用来提升时装武器部位的等级','',0,'【时装分解】','[{0,0,0}]',0,0,0,12,6,0,0,0,12060002,0,1,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(12060003,'头饰时装精华','可用来提升时装头饰部位的等级','',0,'【时装分解】','[{0,0,0}]',0,0,0,12,6,0,0,0,12060003,0,1,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(12060004,'足迹时装精华','可用来提升时装足迹部位的等级','',0,'【时装分解】','[{0,0,0}]',0,0,0,12,6,0,0,0,12060004,0,1,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(12070001,'雪国蚕丝','可在任意时装衣服升星时，抵用1个时装物品消耗','',0,'【活动获得】','[{0,0,0}]',0,0,0,12,7,0,0,0,12060003,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(12070002,'华丽精钢','可在任意时装武器升星时，抵用1个时装物品消耗','',0,'【活动获得】','[{0,0,0}]',0,0,0,12,7,0,0,0,12060004,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(12070003,'精致布料','可在任意时装头饰升星时，抵用1个时装物品消耗','',0,'【活动获得】','[{0,0,0}]',0,0,0,12,7,0,0,0,12060003,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(12070004,'纯白羊毛','可在任意时装足迹升星时，抵用1个时装物品消耗','',0,'【活动获得】','[{0,0,0}]',0,0,0,12,7,0,0,0,12060004,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(12070005,'霜语寒晶','可在任意时装特效升星时，抵用1个时装物品消耗','',0,'【活动获得】','[{0,0,0}]',0,0,0,12,7,0,0,0,12060003,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(12070006,'多彩花羽','可在任意时装背饰升星时，抵用1个时装物品消耗','',0,'【活动获得】','[{0,0,0}]',0,0,0,12,7,0,0,0,12060004,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(12120000,'万能染色剂','用来解锁时装颜色','',0,'【商城】','[{0,0,0}]',0,1,1,12,5,4,4,0,12120000,0,1,99999,2,0,0,0,'[{1,20}]',0,0,0,0,'[]','[]',0,0,0,1),(12120001,'绿色染色剂','用来解锁时装颜色','',0,'【商城】','[{153,1,1}]',0,1,1,12,5,4,4,0,12120001,0,1,99999,2,0,0,0,'[{1,20}]',0,0,0,0,'[]','[]',0,0,0,1),(12120002,'红色染色剂','用来解锁时装颜色','',0,'【商城】','[{153,1,1}]',0,1,1,12,5,4,4,0,12120002,0,1,99999,2,0,0,0,'[{1,20}]',0,0,0,0,'[]','[]',0,0,0,1),(12120003,'白色染色剂','用来解锁时装颜色','',0,'【商城】','[{153,1,1}]',0,1,1,12,5,4,4,0,12120003,0,1,99999,2,0,0,0,'[{1,20}]',0,0,0,0,'[]','[]',0,0,0,1),(12120004,'紫色染色剂','用来解锁时装颜色','',0,'【商城】','[{153,1,1}]',0,1,1,12,5,4,4,0,12120004,0,1,99999,2,0,0,0,'[{1,20}]',0,0,0,0,'[]','[]',0,0,0,1),(12120005,'黑色染色剂','用来解锁时装颜色','',0,'【商城】','[{153,1,1}]',0,1,1,12,5,4,4,0,12120005,0,1,99999,2,0,0,0,'[{1,20}]',0,0,0,0,'[]','[]',0,0,0,1),(12120006,'金色染色剂','用来解锁时装颜色','',0,'【商城】','[{153,1,1}]',0,1,1,12,5,4,4,0,12120006,0,1,99999,2,0,0,0,'[{1,20}]',0,0,0,0,'[]','[]',0,0,0,1),(12120007,'蓝色染色剂','用来解锁时装颜色','',0,'【商城】','[{0,0,0}]',0,0,1,12,5,0,0,0,12120007,0,1,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12120008,'橙色染色剂','用来解锁时装颜色','',0,'【商城】','[{0,0,0}]',0,0,1,12,5,0,0,0,12120008,0,1,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(12120009,'粉色染色剂','用来解锁时装颜色','',0,'【商城】','[{153,2,1}]',0,0,1,12,5,0,0,0,12120009,0,1,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(14010101,'1级攻击宝石','可以镶嵌在武器、项链、刻痕、副手、戒指','攻击+45',0,'【商城,运营活动】','[{153,2,1}]',0,0,0,14,1,0,0,0,14010101,0,99,99999,0,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14010102,'2级攻击宝石','可以镶嵌在武器、项链、刻痕、副手、戒指','攻击+90',0,'【商城,运营活动】','[{153,2,1}]',0,0,0,14,1,0,0,0,14010102,0,99,99999,1,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14010103,'3级攻击宝石','可以镶嵌在武器、项链、刻痕、副手、戒指','攻击+180',0,'【商城,运营活动】','[{153,2,1}]',0,0,0,14,1,0,0,0,14010103,0,99,99999,1,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14010104,'4级攻击宝石','可以镶嵌在武器、项链、刻痕、副手、戒指','攻击+365',0,'【装备寻宝,商城】','[{416,0,1},{153,1,0}]',0,0,0,14,1,0,0,0,14010104,0,99,99999,2,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14010105,'5级攻击宝石','可以镶嵌在武器、项链、刻痕、副手、戒指','攻击+735',0,'【装备寻宝,商城】','[{416,0,1},{153,1,0}]',0,0,0,14,1,0,0,0,14010105,0,99,99999,2,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14010106,'6级攻击宝石','可以镶嵌在武器、项链、刻痕、副手、戒指','攻击+1470',0,'【装备寻宝,商城】','[{416,0,1},{153,1,0}]',0,0,0,14,1,0,0,0,14010106,0,99,99999,2,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14010107,'7级攻击宝石','可以镶嵌在武器、项链、刻痕、副手、戒指','攻击+2500',0,'【宝石合成】','[{0,0,0}]',0,0,0,14,1,0,0,0,14010107,0,99,99999,3,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14010108,'8级攻击宝石','可以镶嵌在武器、项链、刻痕、副手、戒指','攻击+4000',0,'【宝石合成】','[{0,0,0}]',0,0,0,14,1,0,0,0,14010108,0,99,99999,3,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14010109,'9级攻击宝石','可以镶嵌在武器、项链、刻痕、副手、戒指','攻击+6000',0,'【宝石合成】','[{0,0,0}]',0,0,0,14,1,0,0,0,14010109,0,99,99999,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14010301,'1级破甲宝石','可以镶嵌在武器、项链、刻痕、副手、戒指','破甲+36',0,'【商城,运营活动】','[{153,2,1}]',0,0,0,14,3,0,0,0,14010301,0,99,99999,0,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14010302,'2级破甲宝石','可以镶嵌在武器、项链、刻痕、副手、戒指','破甲+72',0,'【商城,运营活动】','[{153,2,1}]',0,0,0,14,3,0,0,0,14010302,0,99,99999,1,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14010303,'3级破甲宝石','可以镶嵌在武器、项链、刻痕、副手、戒指','破甲+145',0,'【商城,运营活动】','[{153,2,1}]',0,0,0,14,3,0,0,0,14010303,0,99,99999,1,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14010304,'4级破甲宝石','可以镶嵌在武器、项链、刻痕、副手、戒指','破甲+294',0,'【装备寻宝,商城】','[{416,0,1},{153,1,0}]',0,0,0,14,3,0,0,0,14010304,0,99,99999,2,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14010305,'5级破甲宝石','可以镶嵌在武器、项链、刻痕、副手、戒指','破甲+588',0,'【装备寻宝,商城】','[{416,0,1},{153,1,0}]',0,0,0,14,3,0,0,0,14010305,0,99,99999,2,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14010306,'6级破甲宝石','可以镶嵌在武器、项链、刻痕、副手、戒指','破甲+1160',0,'【装备寻宝,商城】','[{416,0,1},{153,1,0}]',0,0,0,14,3,0,0,0,14010306,0,99,99999,2,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14010307,'7级破甲宝石','可以镶嵌在武器、项链、刻痕、副手、戒指','破甲+2000',0,'【宝石合成】','[{0,0,0}]',0,0,0,14,3,0,0,0,14010307,0,99,99999,3,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14010308,'8级破甲宝石','可以镶嵌在武器、项链、刻痕、副手、戒指','破甲+3200',0,'【宝石合成】','[{0,0,0}]',0,0,0,14,3,0,0,0,14010308,0,99,99999,3,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14010309,'9级破甲宝石','可以镶嵌在武器、项链、刻痕、副手、戒指','破甲+4800',0,'【宝石合成】','[{0,0,0}]',0,0,0,14,3,0,0,0,14010309,0,99,99999,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14010501,'1级命中宝石','可以镶嵌在武器、项链、刻痕、副手、戒指','命中+18',0,'【商城,运营活动】','[{153,2,1}]',0,0,0,14,5,0,0,0,14010501,0,99,99999,0,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14010502,'2级命中宝石','可以镶嵌在武器、项链、刻痕、副手、戒指','命中+36',0,'【商城,运营活动】','[{153,2,1}]',0,0,0,14,5,0,0,0,14010502,0,99,99999,1,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14010503,'3级命中宝石','可以镶嵌在武器、项链、刻痕、副手、戒指','命中+72',0,'【商城,运营活动】','[{153,2,1}]',0,0,0,14,5,0,0,0,14010503,0,99,99999,1,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14010504,'4级命中宝石','可以镶嵌在武器、项链、刻痕、副手、戒指','命中+144',0,'【装备寻宝,商城】','[{416,0,1},{153,1,0}]',0,0,0,14,5,0,0,0,14010504,0,99,99999,2,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14010505,'5级命中宝石','可以镶嵌在武器、项链、刻痕、副手、戒指','命中+294',0,'【装备寻宝,商城】','[{416,0,1},{153,1,0}]',0,0,0,14,5,0,0,0,14010505,0,99,99999,2,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14010506,'6级命中宝石','可以镶嵌在武器、项链、刻痕、副手、戒指','命中+588',0,'【装备寻宝,商城】','[{416,0,1},{153,1,0}]',0,0,0,14,5,0,0,0,14010506,0,99,99999,2,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14010507,'7级命中宝石','可以镶嵌在武器、项链、刻痕、副手、戒指','命中+1000',0,'【宝石合成】','[{0,0,0}]',0,0,0,14,5,0,0,0,14010507,0,99,99999,3,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14010508,'8级命中宝石','可以镶嵌在武器、项链、刻痕、副手、戒指','命中+1600',0,'【宝石合成】','[{0,0,0}]',0,0,0,14,5,0,0,0,14010508,0,99,99999,3,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14010509,'9级命中宝石','可以镶嵌在武器、项链、刻痕、副手、戒指','命中+2400',0,'【宝石合成】','[{0,0,0}]',0,0,0,14,5,0,0,0,14010509,0,99,99999,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14010701,'1级暴击宝石','可以镶嵌在武器、项链、刻痕、副手、戒指','暴击+18',0,'【商城,运营活动】','[{153,2,1}]',0,0,0,14,7,0,0,0,14010701,0,99,99999,0,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14010702,'2级暴击宝石','可以镶嵌在武器、项链、刻痕、副手、戒指','暴击+36',0,'【商城,运营活动】','[{153,2,1}]',0,0,0,14,7,0,0,0,14010702,0,99,99999,1,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14010703,'3级暴击宝石','可以镶嵌在武器、项链、刻痕、副手、戒指','暴击+72',0,'【商城,运营活动】','[{153,2,1}]',0,0,0,14,7,0,0,0,14010703,0,99,99999,1,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14010704,'4级暴击宝石','可以镶嵌在武器、项链、刻痕、副手、戒指','暴击+144',0,'【装备寻宝,商城】','[{416,0,1},{153,1,0}]',0,0,0,14,7,0,0,0,14010704,0,99,99999,2,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14010705,'5级暴击宝石','可以镶嵌在武器、项链、刻痕、副手、戒指','暴击+294',0,'【装备寻宝,商城】','[{416,0,1},{153,1,0}]',0,0,0,14,7,0,0,0,14010705,0,99,99999,2,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14010706,'6级暴击宝石','可以镶嵌在武器、项链、刻痕、副手、戒指','暴击+588',0,'【装备寻宝,商城】','[{416,0,1},{153,1,0}]',0,0,0,14,7,0,0,0,14010706,0,99,99999,2,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14010707,'7级暴击宝石','可以镶嵌在武器、项链、刻痕、副手、戒指','暴击+1000',0,'【宝石合成】','[{0,0,0}]',0,0,0,14,7,0,0,0,14010707,0,99,99999,3,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14010708,'8级暴击宝石','可以镶嵌在武器、项链、刻痕、副手、戒指','暴击+1600',0,'【宝石合成】','[{0,0,0}]',0,0,0,14,7,0,0,0,14010708,0,99,99999,3,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14010709,'9级暴击宝石','可以镶嵌在武器、项链、刻痕、副手、戒指','暴击+2400',0,'【宝石合成】','[{0,0,0}]',0,0,0,14,7,0,0,0,14010709,0,99,99999,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14020201,'1级生命宝石','可以镶嵌在头盔、衣服、裤子、护腕、鞋子','生命+900',0,'【商城,运营活动】','[{153,2,1}]',0,0,0,14,2,0,0,0,14020201,0,99,99999,0,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14020202,'2级生命宝石','可以镶嵌在头盔、衣服、裤子、护腕、鞋子','生命+1800',0,'【商城,运营活动】','[{153,2,1}]',0,0,0,14,2,0,0,0,14020202,0,99,99999,1,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14020203,'3级生命宝石','可以镶嵌在头盔、衣服、裤子、护腕、鞋子','生命+3600',0,'【商城,运营活动】','[{153,2,1}]',0,0,0,14,2,0,0,0,14020203,0,99,99999,1,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14020204,'4级生命宝石','可以镶嵌在头盔、衣服、裤子、护腕、鞋子','生命+7200',0,'【装备寻宝,商城】','[{416,0,1},{153,1,0}]',0,0,0,14,2,0,0,0,14020204,0,99,99999,2,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14020205,'5级生命宝石','可以镶嵌在头盔、衣服、裤子、护腕、鞋子','生命+14700',0,'【装备寻宝,商城】','[{416,0,1},{153,1,0}]',0,0,0,14,2,0,0,0,14020205,0,99,99999,2,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14020206,'6级生命宝石','可以镶嵌在头盔、衣服、裤子、护腕、鞋子','生命+29400',0,'【装备寻宝,商城】','[{416,0,1},{153,1,0}]',0,0,0,14,2,0,0,0,14020206,0,99,99999,2,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14020207,'7级生命宝石','可以镶嵌在头盔、衣服、裤子、护腕、鞋子','生命+50000',0,'【宝石合成】','[{0,0,0}]',0,0,0,14,2,0,0,0,14020207,0,99,99999,3,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14020208,'8级生命宝石','可以镶嵌在头盔、衣服、裤子、护腕、鞋子','生命+80000',0,'【宝石合成】','[{0,0,0}]',0,0,0,14,2,0,0,0,14020208,0,99,99999,3,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14020209,'9级生命宝石','可以镶嵌在头盔、衣服、裤子、护腕、鞋子','生命+120000',0,'【宝石合成】','[{0,0,0}]',0,0,0,14,2,0,0,0,14020209,0,99,99999,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14020401,'1级防御宝石','可以镶嵌在头盔、衣服、裤子、护腕、鞋子','防御+36',0,'【商城,运营活动】','[{153,2,1}]',0,0,0,14,4,0,0,0,14020401,0,99,99999,0,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14020402,'2级防御宝石','可以镶嵌在头盔、衣服、裤子、护腕、鞋子','防御+72',0,'【商城,运营活动】','[{153,2,1}]',0,0,0,14,4,0,0,0,14020402,0,99,99999,1,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14020403,'3级防御宝石','可以镶嵌在头盔、衣服、裤子、护腕、鞋子','防御+145',0,'【商城,运营活动】','[{153,2,1}]',0,0,0,14,4,0,0,0,14020403,0,99,99999,1,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14020404,'4级防御宝石','可以镶嵌在头盔、衣服、裤子、护腕、鞋子','防御+294',0,'【装备寻宝,商城】','[{416,0,1},{153,1,0}]',0,0,0,14,4,0,0,0,14020404,0,99,99999,2,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14020405,'5级防御宝石','可以镶嵌在头盔、衣服、裤子、护腕、鞋子','防御+588',0,'【装备寻宝,商城】','[{416,0,1},{153,1,0}]',0,0,0,14,4,0,0,0,14020405,0,99,99999,2,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14020406,'6级防御宝石','可以镶嵌在头盔、衣服、裤子、护腕、鞋子','防御+1160',0,'【装备寻宝,商城】','[{416,0,1},{153,1,0}]',0,0,0,14,4,0,0,0,14020406,0,99,99999,2,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14020407,'7级防御宝石','可以镶嵌在头盔、衣服、裤子、护腕、鞋子','防御+2000',0,'【宝石合成】','[{0,0,0}]',0,0,0,14,4,0,0,0,14020407,0,99,99999,3,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14020408,'8级防御宝石','可以镶嵌在头盔、衣服、裤子、护腕、鞋子','防御+3200',0,'【宝石合成】','[{0,0,0}]',0,0,0,14,4,0,0,0,14020408,0,99,99999,3,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14020409,'9级防御宝石','可以镶嵌在头盔、衣服、裤子、护腕、鞋子','防御+4800',0,'【宝石合成】','[{0,0,0}]',0,0,0,14,4,0,0,0,14020409,0,99,99999,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14020601,'1级闪避宝石','可以镶嵌在头盔、衣服、裤子、护腕、鞋子','闪避+18',0,'【商城,运营活动】','[{153,2,1}]',0,0,0,14,6,0,0,0,14020601,0,99,99999,0,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14020602,'2级闪避宝石','可以镶嵌在头盔、衣服、裤子、护腕、鞋子','闪避+36',0,'【商城,运营活动】','[{153,2,1}]',0,0,0,14,6,0,0,0,14020602,0,99,99999,1,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14020603,'3级闪避宝石','可以镶嵌在头盔、衣服、裤子、护腕、鞋子','闪避+72',0,'【商城,运营活动】','[{153,2,1}]',0,0,0,14,6,0,0,0,14020603,0,99,99999,1,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14020604,'4级闪避宝石','可以镶嵌在头盔、衣服、裤子、护腕、鞋子','闪避+144',0,'【装备寻宝,商城】','[{416,0,1},{153,1,0}]',0,0,0,14,6,0,0,0,14020604,0,99,99999,2,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14020605,'5级闪避宝石','可以镶嵌在头盔、衣服、裤子、护腕、鞋子','闪避+294',0,'【装备寻宝,商城】','[{416,0,1},{153,1,0}]',0,0,0,14,6,0,0,0,14020605,0,99,99999,2,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14020606,'6级闪避宝石','可以镶嵌在头盔、衣服、裤子、护腕、鞋子','闪避+588',0,'【装备寻宝,商城】','[{416,0,1},{153,1,0}]',0,0,0,14,6,0,0,0,14020606,0,99,99999,2,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14020607,'7级闪避宝石','可以镶嵌在头盔、衣服、裤子、护腕、鞋子','闪避+1000',0,'【宝石合成】','[{0,0,0}]',0,0,0,14,6,0,0,0,14020607,0,99,99999,3,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14020608,'8级闪避宝石','可以镶嵌在头盔、衣服、裤子、护腕、鞋子','闪避+1600',0,'【宝石合成】','[{0,0,0}]',0,0,0,14,6,0,0,0,14020608,0,99,99999,3,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14020609,'9级闪避宝石','可以镶嵌在头盔、衣服、裤子、护腕、鞋子','闪避+2400',0,'【宝石合成】','[{0,0,0}]',0,0,0,14,6,0,0,0,14020609,0,99,99999,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14020801,'1级韧性宝石','可以镶嵌在头盔、衣服、裤子、护腕、鞋子','韧性+18',0,'【商城,运营活动】','[{153,2,1}]',0,0,0,14,8,0,0,0,14020801,0,99,99999,0,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14020802,'2级韧性宝石','可以镶嵌在头盔、衣服、裤子、护腕、鞋子','韧性+36',0,'【商城,运营活动】','[{153,2,1}]',0,0,0,14,8,0,0,0,14020802,0,99,99999,1,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14020803,'3级韧性宝石','可以镶嵌在头盔、衣服、裤子、护腕、鞋子','韧性+72',0,'【商城,运营活动】','[{153,2,1}]',0,0,0,14,8,0,0,0,14020803,0,99,99999,1,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14020804,'4级韧性宝石','可以镶嵌在头盔、衣服、裤子、护腕、鞋子','韧性+144',0,'【装备寻宝,商城】','[{416,0,1},{153,1,0}]',0,0,0,14,8,0,0,0,14020804,0,99,99999,2,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14020805,'5级韧性宝石','可以镶嵌在头盔、衣服、裤子、护腕、鞋子','韧性+294',0,'【装备寻宝,商城】','[{416,0,1},{153,1,0}]',0,0,0,14,8,0,0,0,14020805,0,99,99999,2,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14020806,'6级韧性宝石','可以镶嵌在头盔、衣服、裤子、护腕、鞋子','韧性+588',0,'【装备寻宝,商城】','[{416,0,1},{153,1,0}]',0,0,0,14,8,0,0,0,14020806,0,99,99999,2,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14020807,'7级韧性宝石','可以镶嵌在头盔、衣服、裤子、护腕、鞋子','韧性+1000',0,'【宝石合成】','[{0,0,0}]',0,0,0,14,8,0,0,0,14020807,0,99,99999,3,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14020808,'8级韧性宝石','可以镶嵌在头盔、衣服、裤子、护腕、鞋子','韧性+1600',0,'【宝石合成】','[{0,0,0}]',0,0,0,14,8,0,0,0,14020808,0,99,99999,3,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14020809,'9级韧性宝石','可以镶嵌在头盔、衣服、裤子、护腕、鞋子','韧性+2400',0,'【宝石合成】','[{0,0,0}]',0,0,0,14,8,0,0,0,14020809,0,99,99999,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(14100013,'攻击破甲宝石','可以镶嵌在武器、项链、刻痕、副手、戒指','',0,'【宝石合成,运营活动】','[{150,2,1},{0,0,0}]',1,0,0,14,9,1,0,0,141000139,0,340,1,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(14100015,'攻击命中宝石','可以镶嵌在武器、项链、刻痕、副手、戒指','',0,'【宝石合成,运营活动】','[{150,2,1},{0,0,0}]',1,0,0,14,9,1,0,0,141000159,0,340,1,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(14100024,'生命防御宝石','可以镶嵌在头盔、衣服、裤子、护腕、鞋子','',0,'【宝石合成,运营活动】','[{150,2,1},{0,0,0}]',1,0,0,14,10,1,0,0,141000249,0,340,1,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(14100026,'生命闪避宝石','可以镶嵌在头盔、衣服、裤子、护腕、鞋子','',0,'【宝石合成,运营活动】','[{150,2,1},{0,0,0}]',1,0,0,14,10,1,0,0,141000269,0,340,1,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(14100035,'破甲命中宝石','可以镶嵌在武器、项链、刻痕、副手、戒指','',0,'【宝石合成,运营活动】','[{150,2,1},{0,0,0}]',1,0,0,14,9,1,0,0,141000359,0,340,1,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(14100037,'破甲暴击宝石','可以镶嵌在武器、项链、刻痕、副手、戒指','',0,'【宝石合成,运营活动】','[{150,2,1},{0,0,0}]',1,0,0,14,9,1,0,0,141000379,0,340,1,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(14100046,'防御闪避宝石','可以镶嵌在头盔、衣服、裤子、护腕、鞋子','',0,'【宝石合成,运营活动】','[{150,2,1},{0,0,0}]',1,0,0,14,10,1,0,0,141000469,0,340,1,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(14100048,'防御韧性宝石','可以镶嵌在头盔、衣服、裤子、护腕、鞋子','',0,'【宝石合成,运营活动】','[{150,2,1},{0,0,0}]',1,0,0,14,10,1,0,0,141000489,0,340,1,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(14100057,'命中暴击宝石','可以镶嵌在武器、项链、刻痕、副手、戒指','',0,'【宝石合成,运营活动】','[{150,2,1},{0,0,0}]',1,0,0,14,9,1,0,0,141000579,0,340,1,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(14100068,'闪避韧性宝石','可以镶嵌在头盔、衣服、裤子、护腕、鞋子','',0,'【宝石合成,运营活动】','[{150,2,1},{0,0,0}]',1,0,0,14,10,1,0,0,141000689,0,340,1,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(14100071,'暴击攻击宝石','可以镶嵌在武器、项链、刻痕、副手、戒指','',0,'【宝石合成,运营活动】','[{150,2,1},{0,0,0}]',1,0,0,14,9,1,0,0,141000719,0,340,1,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(14100082,'韧性生命宝石','可以镶嵌在头盔、衣服、裤子、护腕、鞋子','',0,'【宝石合成,运营活动】','[{150,2,1},{0,0,0}]',1,0,0,14,10,1,0,0,141000829,0,340,1,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(14110001,'利刃精粹','360级开启双属性宝石，可以用于合成攻击型双属性宝石，也可以用于双属性宝石的升阶','',0,'【跨服1VN】','[{621,0,1}]',0,0,0,14,11,1,0,0,14110003,0,340,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(14110002,'坚盾精粹','360级开启双属性宝石，可以用于合成防御型双属性宝石，也可以用于双属性宝石的升阶','',0,'【跨服1VN】','[{621,0,1}]',0,0,0,14,11,1,0,0,14110004,0,340,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(14110003,'致命晶石','双属性宝石2阶及以上的进阶材料，可以为双属性宝石增加<color=#4eae1a>致命一击</color>效果','',0,'【跨服1VN】','[{621,0,1}]',0,0,0,14,11,1,0,0,14110001,0,340,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(14110004,'神佑晶石','双属性宝石2阶及以上的进阶材料，可以为双属性宝石增加<color=#4eae1a>致命抵抗</color>效果','',0,'【跨服1VN】','[{621,0,1}]',0,0,0,14,11,1,0,0,14110002,0,340,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(14120001,'宝石碎片','矿脉中闪闪发光的宝石碎片，可以用来合成任意一种基础一级宝石','',0,'【运营活动】','[{0,0,0}]',0,0,0,14,12,0,0,0,14120001,0,0,99999,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(14130001,'1级宝石','一个1级 生命/攻击 宝石','',0,'【运营活动】','[{0,0,0}]',0,0,0,14,0,0,0,0,14010101,0,0,99999,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(14130002,'1级宝石','一个1级 生命/攻击/破甲/防御 宝石','',0,'【运营活动】','[{0,0,0}]',0,0,0,14,0,0,0,0,14010301,0,0,99999,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(14130003,'1级宝石','一个1级 生命/攻击/破甲/防御/命中/闪避 宝石','',0,'【运营活动】','[{0,0,0}]',0,0,0,14,0,0,0,0,14020601,0,0,99999,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(14130004,'1级宝石','一个1级 生命/攻击/破甲/防御/命中/闪避/暴击/韧性 宝石','',0,'【运营活动】','[{0,0,0}]',0,0,0,14,0,0,0,0,14020801,0,0,99999,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(14140110,'星耀宝石【初级】','霸主的象征，实力的见证。可镶嵌在VIP孔位上的顶级宝石\\n<color=#FF2400>伤害加深   +9%\\n命中加成   +7.5%</color>','',0,'【跨服1vn】','[{621,0,1}]',1,0,0,14,13,1,0,0,14140110,0,0,999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(14140111,'星耀宝石【中级】','霸主的象征，实力的见证。可镶嵌在VIP孔位上的顶级宝石\\n<color=#FF2400>伤害加深   +16%\\n命中加成   +13.5%</color>','',0,'【宝石合成,跨服1vn】','[{150,2,1},{621,0,1}]',1,0,0,14,13,1,0,0,14140111,0,0,999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(14140112,'星耀宝石【特级】','霸主的象征，实力的见证。可镶嵌在VIP孔位上的顶级宝石\\n<color=#FF2400>伤害加深   +24%\\n命中加成   +20%</color>','',0,'【宝石合成,跨服1vn】','[{150,2,1},{621,0,1}]',1,0,0,14,13,1,0,0,14140112,0,0,999,5,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(14140210,'月华宝石【初级】','霸主的象征，实力的见证。可镶嵌在VIP孔位上的顶级宝石\\n<color=#FF2400>技能伤害加深   +11.3%\\n暴击加成   +7.5%</color>','',0,'【跨服1vn】','[{621,0,1}]',1,0,0,14,13,1,0,0,14140210,0,0,999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(14140211,'月华宝石【中级】','霸主的象征，实力的见证。可镶嵌在VIP孔位上的顶级宝石\\n<color=#FF2400>技能伤害加深   +20.25%\\n暴击加成   +13.5%</color>','',0,'【宝石合成,跨服1vn】','[{150,2,1},{621,0,1}]',1,0,0,14,13,1,0,0,14140211,0,0,999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(14140212,'月华宝石【特级】','霸主的象征，实力的见证。可镶嵌在VIP孔位上的顶级宝石\\n<color=#FF2400>技能伤害加深   +30.4%\\n暴击加成   +20%</color>','',0,'【宝石合成,跨服1vn】','[{150,2,1},{621,0,1}]',1,0,0,14,13,1,0,0,14140212,0,0,999,5,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(14140310,'阳炎宝石【初级】','霸主的象征，实力的见证。可镶嵌在VIP孔位上的顶级宝石\\n<color=#FF2400>PVE伤害加深   +15%\\n攻击加成   +7.5%</color>','',0,'【跨服1vn】','[{621,0,1}]',1,0,0,14,13,1,0,0,14140310,0,0,999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(14140311,'阳炎宝石【中级】','霸主的象征，实力的见证。可镶嵌在VIP孔位上的顶级宝石\\n<color=#FF2400>PVE伤害加深   +27%\\n攻击加成   +13.5%</color>','',0,'【宝石合成,跨服1vn】','[{150,2,1},{621,0,1}]',1,0,0,14,13,1,0,0,14140311,0,0,999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(14140312,'阳炎宝石【特级】','霸主的象征，实力的见证。可镶嵌在VIP孔位上的顶级宝石\\n<color=#FF2400>PVE伤害加深   +40.5%\\n攻击加成   +20%</color>','',0,'【宝石合成,跨服1vn】','[{150,2,1},{621,0,1}]',1,0,0,14,13,1,0,0,14140312,0,0,999,5,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(14140410,'晨辉宝石【初级】','霸主的象征，实力的见证。可镶嵌在VIP孔位上的顶级宝石\\n<color=#FF2400>PVP伤害加深   +15%\\n破甲加成   +7.5%</color>','',0,'【跨服1vn】','[{621,0,1}]',1,0,0,14,13,1,0,0,14140410,0,0,999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(14140411,'晨辉宝石【中级】','霸主的象征，实力的见证。可镶嵌在VIP孔位上的顶级宝石\\n<color=#FF2400>PVP伤害加深   +27%\\n破甲加成   +13.5%</color>','',0,'【宝石合成,跨服1vn】','[{150,2,1},{621,0,1}]',1,0,0,14,13,1,0,0,14140411,0,0,999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(14140412,'晨辉宝石【特级】','霸主的象征，实力的见证。可镶嵌在VIP孔位上的顶级宝石\\n<color=#FF2400>PVP伤害加深   +40.5%\\n破甲加成   +20%</color>','',0,'【宝石合成,跨服1vn】','[{150,2,1},{621,0,1}]',1,0,0,14,13,1,0,0,14140412,0,0,999,5,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(14140510,'风灵宝石【初级】','霸主的象征，实力的见证。可镶嵌在VIP孔位上的顶级宝石\\n<color=#FF2400>伤害减免   +9%\\n闪避加成   +7.5%</color>','',0,'【跨服1vn】','[{621,0,1}]',1,0,0,14,14,1,0,0,14140510,0,0,999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(14140511,'风灵宝石【中级】','霸主的象征，实力的见证。可镶嵌在VIP孔位上的顶级宝石\\n<color=#FF2400>伤害减免   +16%\\n闪避加成   +13.5%</color>','',0,'【宝石合成,跨服1vn】','[{150,2,1},{621,0,1}]',1,0,0,14,14,1,0,0,14140511,0,0,999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(14140512,'风灵宝石【特级】','霸主的象征，实力的见证。可镶嵌在VIP孔位上的顶级宝石\\n<color=#FF2400>伤害减免   +24%\\n闪避加成   +20%</color>','',0,'【宝石合成,跨服1vn】','[{150,2,1},{621,0,1}]',1,0,0,14,14,1,0,0,14140512,0,0,999,5,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(14140610,'木魂宝石【初级】','霸主的象征，实力的见证。可镶嵌在VIP孔位上的顶级宝石\\n<color=#FF2400>技能伤害减免   +11.3%\\n韧性加成   +7.5%</color>','',0,'【跨服1vn】','[{621,0,1}]',1,0,0,14,14,1,0,0,14140610,0,0,999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(14140611,'木魂宝石【中级】','霸主的象征，实力的见证。可镶嵌在VIP孔位上的顶级宝石\\n<color=#FF2400>技能伤害减免   +20.25%\\n韧性加成   +13.5%</color>','',0,'【宝石合成,跨服1vn】','[{150,2,1},{621,0,1}]',1,0,0,14,14,1,0,0,14140611,0,0,999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(14140612,'木魂宝石【特级】','霸主的象征，实力的见证。可镶嵌在VIP孔位上的顶级宝石\\n<color=#FF2400>技能伤害减免   +30.4%\\n韧性加成   +20%</color>','',0,'【宝石合成,跨服1vn】','[{150,2,1},{621,0,1}]',1,0,0,14,14,1,0,0,14140612,0,0,999,5,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(14140710,'土曜宝石【初级】','霸主的象征，实力的见证。可镶嵌在VIP孔位上的顶级宝石\\n<color=#FF2400>PVE伤害减免   +15%\\n生命加成   +7.5%</color>','',0,'【跨服1vn】','[{621,0,1}]',1,0,0,14,14,1,0,0,14140710,0,0,999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(14140711,'土曜宝石【中级】','霸主的象征，实力的见证。可镶嵌在VIP孔位上的顶级宝石\\n<color=#FF2400>PVE伤害减免   +27%\\n生命加成   +13.5%</color>','',0,'【宝石合成,跨服1vn】','[{150,2,1},{621,0,1}]',1,0,0,14,14,1,0,0,14140711,0,0,999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(14140712,'土曜宝石【特级】','霸主的象征，实力的见证。可镶嵌在VIP孔位上的顶级宝石\\n<color=#FF2400>PVE伤害减免   +40.5%\\n生命加成   +20%</color>','',0,'【宝石合成,跨服1vn】','[{150,2,1},{621,0,1}]',1,0,0,14,14,1,0,0,14140712,0,0,999,5,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(14140810,'冰晶宝石【初级】','霸主的象征，实力的见证。可镶嵌在VIP孔位上的顶级宝石\\n<color=#FF2400>PVP伤害减免   +15%\\n防御加成   +7.5%</color>','',0,'【跨服1vn】','[{621,0,1}]',1,0,0,14,14,1,0,0,14140810,0,0,999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(14140811,'冰晶宝石【中级】','霸主的象征，实力的见证。可镶嵌在VIP孔位上的顶级宝石\\n<color=#FF2400>PVP伤害减免   +27%\\n防御加成   +13.5%</color>','',0,'【宝石合成,跨服1vn】','[{150,2,1},{621,0,1}]',1,0,0,14,14,1,0,0,14140811,0,0,999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(14140812,'冰晶宝石【特级】','霸主的象征，实力的见证。可镶嵌在VIP孔位上的顶级宝石\\n<color=#FF2400>PVP伤害减免   +40.5%\\n防御加成   +20%</color>','',0,'【宝石合成,跨服1vn】','[{150,2,1},{621,0,1}]',1,0,0,14,14,1,0,0,14140812,0,0,999,5,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(15010001,'光明号角','可用于激活圣器：光明号角','',0,'【活动获得】','[{0,0,0}]',0,0,0,15,1,0,0,0,15010001,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(15010002,'祷告之书','可用于激活圣器：祷告之书','',0,'【活动获得】','[{0,0,0}]',0,0,0,15,1,0,0,0,15010002,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(15010003,'起源之火','可用于激活圣器：起源之火','',0,'【活动获得】','[{0,0,0}]',0,0,0,15,1,0,0,0,15010003,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(15010004,'烈焰之心','可用于激活圣器：烈焰之心','',0,'【活动获得】','[{0,0,0}]',0,0,0,15,1,0,0,0,15010004,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(15010005,'霜语皇冠','可用于激活圣器：霜语皇冠','',0,'【活动获得】','[{0,0,0}]',0,0,0,15,1,0,0,0,15010005,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(15010006,'镇魂十字','可用于激活圣器：镇魂十字','',0,'【活动获得】','[{0,0,0}]',0,0,0,15,1,0,0,0,15010006,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(15010007,'起源之水','可用于激活圣器：起源之水','',0,'【活动获得】','[{0,0,0}]',0,0,0,15,1,0,0,0,15010007,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(15010008,'航海宝珠','可用于激活圣器：航海宝珠','',0,'【活动获得】','[{0,0,0}]',0,0,0,15,1,0,0,0,15010008,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(15010009,'恶魔契约','可用于激活圣器：恶魔契约','',0,'【活动获得】','[{0,0,0}]',0,0,0,15,1,0,0,0,15010009,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(15010010,'死亡圣杯','可用于激活圣器：死亡圣杯','',0,'【活动获得】','[{0,0,0}]',0,0,0,15,1,0,0,0,15010010,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(15010011,'冥府之钥','可用于激活圣器：冥府之钥','',0,'【活动获得】','[{0,0,0}]',0,0,0,15,1,0,0,0,15010011,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(15010012,'灵魂汲取','可用于激活圣器：灵魂汲取','',0,'【活动获得】','[{0,0,0}]',0,0,0,15,1,0,0,0,15010012,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(15020101,'初级烈火晶核','可用于暴怒之火升阶,提供30经验','',0,'【竞技场,运营活动】','[{280,0,1}]',0,0,0,15,2,0,0,0,15020101,0,70,99999,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(15020102,'中级烈火晶核','可用于暴怒之火升阶,提供100经验','',0,'【竞技场】','[{280,0,1}]',0,0,0,15,2,0,0,0,15020102,0,70,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(15020103,'高级烈火晶核','可用于暴怒之火升阶,提供300经验','',0,'【竞技场】','[{280,0,1}]',0,0,0,15,2,0,0,0,15020103,0,70,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(15020201,'初级圣水晶核','可用于温润之水升阶,提供30经验','',0,'【巅峰竞技,运营活动】','[{281,0,1}]',0,0,0,15,2,0,0,0,15020201,0,70,99999,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(15020202,'中级圣水晶核','可用于温润之水升阶,提供100经验','',0,'【巅峰竞技】','[{281,0,1}]',0,0,0,15,2,0,0,0,15020202,0,70,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(15020203,'高级圣水晶核','可用于温润之水升阶,提供300经验','',0,'【巅峰竞技】','[{281,0,1}]',0,0,0,15,2,0,0,0,15020203,0,70,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(15020301,'初级摄魂晶核','可用于摄魂行者升阶,提供30经验','',0,'【首领狩猎】','[{460,2,0}]',0,0,0,15,2,1,0,0,15020301,0,70,99999,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(15020302,'中级摄魂晶核','可用于摄魂行者升阶,提供100经验','',0,'【首领狩猎】','[{460,2,0}]',0,0,0,15,2,1,0,0,15020302,0,70,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(15020303,'高级摄魂晶核','可用于摄魂行者升阶,提供300经验','',0,'【首领狩猎】','[{460,2,0}]',0,0,0,15,2,1,0,0,15020303,0,70,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(16010001,'凶兽源石','蕴含着神圣的气息，可以提升坐骑属性','生命  +1200,抗暴值  +25',1950,'【寻宝,运营活动】','[{416,0,1}]',0,0,0,16,1,1,0,0,16010001,0,50,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(16010002,'蛮兽源石','蕴含着神圣的气息，可以提升坐骑属性','攻击  +60,暴击  +16',2000,'【寻宝,运营活动】','[{416,0,1}]',0,0,0,16,1,1,0,0,16010002,0,50,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(16010003,'巨兽源石','蕴含着神圣的气息，可以提升坐骑属性','暴击  +35,抗暴值  +50,坐骑生命 +0.5%',4000,'【寻宝,运营活动】','[{416,0,1}]',0,0,0,16,1,1,0,0,16010003,0,50,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(16010004,'魔兽源石','蕴含着神圣的气息，可以提升坐骑属性','生命  +3600,攻击  +180,抗暴值  +75,坐骑攻击 +1%',9450,'【寻宝,运营活动】','[{416,0,1}]',0,0,0,16,1,1,0,0,16010004,0,50,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(16020001,'初级坐骑树果','适用于1-4阶，增加30点坐骑祝福值','',0,'【商城,运营活动】','[{153,1,1},{153,7,0}]',0,0,0,16,2,0,0,0,16020001,0,25,99999,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(16020002,'中级坐骑树果','适用于5-8阶，增加90点坐骑祝福值','',0,'【材料合成,运营活动】','[{150,5,1},{153,7,0}]',0,0,0,16,2,0,0,0,16020002,0,25,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(16020003,'高级坐骑树果','适用于9-12阶，增加270点坐骑祝福值','',0,'【材料合成,运营活动】','[{150,5,1},{153,7,0}]',0,0,0,16,2,0,0,0,16020003,0,25,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(16030001,'赤焰飓风','激活坐骑外观：赤焰飓风，在【坐骑】-【幻形】中使用。','攻击+840,生命+16800,抗暴值+210,坐骑生命加成+0.6%,伤害减免+3%',39900,'【运营活动】','[{0,0,0}]',0,0,0,16,3,1,0,0,16030001,0,25,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',302002,0,0,1),(16030002,'旋翼飞空艇','激活坐骑外观：旋翼飞空艇，在【坐骑】-【幻形】中使用。','攻击 + 415,生命 + 8300,抗暴值 + 104,坐骑攻击加成 + 0.4%,伤害加成 + 2%',19720,'【运营活动】','[{423,1,1}]',0,0,0,16,3,1,0,0,16030002,0,25,999999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(16030003,'呆萌兔','激活坐骑外观：呆萌兔，在【坐骑】-【幻形】中使用。','攻击 + 290,生命 + 5800,抗暴值 + 73',13790,'【七日登录】','[{175,1,1}]',0,0,0,16,3,1,0,0,16030003,0,25,999999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(16030004,'尸烬龙','激活坐骑外观：尸烬龙，在【坐骑】-【幻形】中使用。','攻击 + 5430,生命 + 108600,抗暴值 + 1358,坐骑攻击加成 + 0.8%,会心一击 + 4%',257940,'【运营活动,1VN竞拍】','[{621,0,1}]',0,0,0,16,3,1,0,0,16030004,0,25,999999,5,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(16030005,'利维坦','激活坐骑外观：利维坦，在【坐骑】-【幻形】中使用。','攻击+1220,生命+24400,抗暴值+305,坐骑生命加成+0.8%,致命一击+2%',57950,'【运营活动】','[{0,0,0}]',0,0,0,16,3,1,0,0,16030005,0,25,999999,4,0,0,0,'[]',0,0,0,0,'[]','[]',302006,0,0,1),(16030006,'旅行蜗牛','激活坐骑外观：旅行蜗牛，在【坐骑】-【幻形】中使用。','攻击+540,生命+10800,抗暴值+135,坐骑攻击加成+0.5%,技能伤害+1.5%',25650,'【运营活动】','[{0,0,0}]',0,0,0,16,3,1,0,0,16030006,0,25,999999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(16030007,'机械达人','激活坐骑外观：机械达人，在【坐骑】-【幻形】中使用。','攻击+1500,生命+30000,抗暴值+375,坐骑生命加成+0.8%,暴击率+1.5%',71250,'【运营活动】','[{0,0,0}]',0,0,0,16,3,1,0,0,16030007,0,25,999999,4,0,0,0,'[]',0,0,0,0,'[]','[]',302013,0,0,1),(16030008,'猫咪飞椅','激活坐骑外观：猫咪飞椅，在【坐骑】-【幻形】中使用。','攻击+1540,生命+30800,抗暴值+385,坐骑攻击加成+0.8%,生命加成+1.2%',73150,'【运营活动】','[{0,0,0}]',0,0,0,16,3,1,0,0,16030008,0,25,999999,4,0,0,0,'[]',0,0,0,0,'[]','[]',302012,0,0,1),(16030009,'魔法飞毯','激活坐骑外观：魔法飞毯，在【坐骑】-【幻形】中使用。','攻击+1580,生命+31600,抗暴值+395,坐骑生命加成+0%,爆伤加成+3%',75050,'【运营活动】','[{0,0,0}]',0,0,0,16,3,1,0,0,16030009,0,25,999999,4,0,0,0,'[]',0,0,0,0,'[]','[]',302011,0,0,1),(16030010,'白熊首领','激活坐骑外观：白熊首领，在【坐骑】-【幻形】中使用。','攻击+1620,生命+32400,抗暴值+405,坐骑攻击加成+0.8%,攻击加成+1.2%',76950,'【运营活动】','[{0,0,0}]',0,0,0,16,3,1,0,0,16030010,0,25,999999,4,0,0,0,'[]',0,0,0,0,'[]','[]',302009,0,0,1),(16030011,'夏日闲鸭','激活坐骑外观：夏日闲鸭，在【坐骑】-【幻形】中使用。','攻击+1450,生命+29000,抗暴值+363,坐骑攻击加成+0.8%,技能伤害+2%',68890,'【运营活动】','[{0,0,0}]',0,0,0,16,3,1,0,0,16030011,0,25,999999,4,0,0,0,'[]',0,0,0,0,'[]','[]',302012,0,0,1),(16030012,'科技魔狼','激活坐骑外观：科技魔狼，在【坐骑】-【幻形】中使用。','攻击+1450,生命+29000,抗暴值+363,坐骑生命加成+0.8%,技能减免+2%',68890,'【运营活动】','[{0,0,0}]',0,0,0,16,3,1,0,0,16030012,0,25,999999,4,0,0,0,'[]',0,0,0,0,'[]','[]',302011,0,0,1),(16030013,'大佬座驾','激活坐骑外观：大佬座驾，在【坐骑】-【幻形】中使用。','攻击+1450,生命+29000,抗暴值+363,坐骑生命加成+0.8%,PVP伤害+2.5%',68890,'【运营活动】','[{0,0,0}]',0,0,0,16,3,1,0,0,16030013,0,25,999999,4,0,0,0,'[]',0,0,0,0,'[]','[]',302009,0,0,1),(16040101,'锈蚀·兽灵面铠','绿1星兽灵面铠【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040100,0,1,1,0,0,0,0,'[{1,28}]',0,0,0,0,'[{1,174},{3,261}]','[]',0,0,0,0),(16040102,'锈蚀·兽灵面铠','绿2星兽灵面铠【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040100,0,1,1,0,0,0,0,'[{1,39}]',0,0,0,0,'[{1,261},{3,392}]','[]',0,0,0,0),(16040103,'锈蚀·兽灵面铠','绿3星兽灵面铠【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040100,0,1,1,0,0,0,0,'[{1,48}]',0,0,0,0,'[{1,348},{3,522}]','[]',0,0,0,0),(16040104,'锈蚀·兽灵面铠','绿4星兽灵面铠【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040100,0,1,1,0,0,0,0,'[{1,62}]',0,0,0,0,'[{1,435},{3,653}]','[]',0,0,0,0),(16040105,'锈蚀·兽灵面铠','绿5星兽灵面铠【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040100,0,1,1,0,0,0,0,'[{1,78}]',0,0,0,0,'[{1,522},{3,783}]','[]',0,0,0,0),(16040111,'平凡·兽灵面铠','蓝1星兽灵面铠【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040100,0,1,1,1,0,0,0,'[{1,69}]',0,0,0,0,'[{1,470},{3,705}]','[]',0,0,0,0),(16040112,'平凡·兽灵面铠','蓝2星兽灵面铠【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040100,0,1,1,1,0,0,0,'[{1,98}]',0,0,0,0,'[{1,705},{3,1057}]','[]',0,0,0,0),(16040113,'平凡·兽灵面铠','蓝3星兽灵面铠【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040100,0,1,1,1,0,0,0,'[{1,125}]',0,0,0,0,'[{1,940},{3,1409}]','[]',0,0,0,0),(16040114,'平凡·兽灵面铠','蓝4星兽灵面铠【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040100,0,1,1,1,0,0,0,'[{1,209}]',0,0,0,0,'[{1,1174},{3,1761}]','[]',0,0,0,0),(16040115,'平凡·兽灵面铠','蓝5星兽灵面铠【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040100,0,1,1,1,0,0,0,'[{1,289}]',0,0,0,0,'[{1,1409},{3,2114}]','[]',0,0,0,0),(16040121,'完好·兽灵面铠','紫1星兽灵面铠【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040100,0,1,1,2,0,0,0,'[{1,247}]',0,0,0,0,'[{1,1218},{3,1827}]','[]',0,0,0,0),(16040122,'完好·兽灵面铠','紫2星兽灵面铠【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040100,0,1,1,2,0,0,0,'[{1,354}]',0,0,0,0,'[{1,1827},{3,2740}]','[]',0,0,0,0),(16040123,'完好·兽灵面铠','紫3星兽灵面铠【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040100,0,1,1,2,0,0,0,'[{1,454}]',0,0,0,0,'[{1,2435},{3,3653}]','[]',0,0,0,0),(16040124,'完好·兽灵面铠','紫4星兽灵面铠【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040100,0,1,1,2,0,0,0,'[{1,777}]',0,0,0,0,'[{1,3044},{3,4566}]','[]',0,0,0,0),(16040125,'完好·兽灵面铠','紫5星兽灵面铠【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040100,0,1,1,2,0,0,0,'[{1,1101}]',0,0,0,0,'[{1,3653},{3,5479}]','[]',0,0,0,0),(16040131,'精良·兽灵面铠','橙1星兽灵面铠【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040100,0,1,1,3,0,0,0,'[{1,939}]',0,0,0,0,'[{1,3131},{3,4696}]','[]',0,0,0,0),(16040132,'精良·兽灵面铠','橙2星兽灵面铠【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040100,0,1,1,3,0,0,0,'[{1,1379}]',0,0,0,0,'[{1,4696},{3,7044}]','[]',0,0,0,0),(16040133,'精良·兽灵面铠','橙3星兽灵面铠【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040100,0,1,1,3,0,0,0,'[{1,1819}]',0,0,0,0,'[{1,6261},{3,9392}]','[]',0,0,0,0),(16040134,'精良·兽灵面铠','橙4星兽灵面铠【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040100,0,1,1,3,0,0,0,'[{1,3113}]',0,0,0,0,'[{1,7827},{3,11740}]','[]',0,0,0,0),(16040135,'精良·兽灵面铠','橙5星兽灵面铠【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040100,0,1,1,3,0,0,0,'[{1,4407}]',0,0,0,0,'[{1,9392},{3,14087}]','[]',0,0,0,0),(16040141,'稀有·兽灵面铠','红1星兽灵面铠【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040100,0,1,1,4,0,0,0,'[{1,3760}]',0,0,0,0,'[{1,8696},{3,13044}]','[]',0,0,0,0),(16040142,'稀有·兽灵面铠','红2星兽灵面铠【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040100,0,1,1,4,0,0,0,'[{1,5523}]',0,0,0,0,'[{1,10435},{3,15653}]','[]',0,0,0,0),(16040143,'稀有·兽灵面铠','红3星兽灵面铠【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040100,0,1,1,4,0,0,0,'[{1,7285}]',0,0,0,0,'[{1,13044},{3,19566}]','[]',0,0,0,0),(16040144,'稀有·兽灵面铠','红4星兽灵面铠【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040100,0,1,1,4,0,0,0,'[{1,12470}]',0,0,0,0,'[{1,15653},{3,23479}]','[]',0,0,0,0),(16040145,'稀有·兽灵面铠','红5星兽灵面铠【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040100,0,1,1,4,0,0,0,'[{1,17655}]',0,0,0,0,'[{1,19131},{3,28696}]','[]',0,0,0,0),(16040151,'卓越·兽灵面铠','粉1星兽灵面铠【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040100,0,1,1,5,0,0,0,'[{1,16439}]',0,0,0,0,'[{1,9566},{3,14348}]','[]',0,0,0,0),(16040152,'卓越·兽灵面铠','粉2星兽灵面铠【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040100,0,1,1,5,0,0,0,'[{1,23014}]',0,0,0,0,'[{1,11305},{3,16957}]','[]',0,0,0,0),(16040153,'卓越·兽灵面铠','粉3星兽灵面铠【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040100,0,1,1,5,0,0,0,'[{1,35344}]',0,0,0,0,'[{1,13914},{3,20870}]','[]',0,0,0,0),(16040154,'卓越·兽灵面铠','粉4星兽灵面铠【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040100,0,1,1,5,0,0,0,'[{1,47672}]',0,0,0,0,'[{1,15653},{3,23479}]','[]',0,0,0,0),(16040155,'卓越·兽灵面铠','粉5星兽灵面铠【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040100,0,1,1,5,0,0,0,'[{1,60001}]',0,0,0,0,'[{1,20870},{3,31305}]','[]',0,0,0,0),(16040201,'锈蚀·兽灵刃爪','绿1星兽灵刃爪【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040200,0,1,1,0,0,0,0,'[{1,28}]',0,0,0,0,'[{2,3479},{4,261}]','[]',0,0,0,0),(16040202,'锈蚀·兽灵刃爪','绿2星兽灵刃爪【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040200,0,1,1,0,0,0,0,'[{1,38}]',0,0,0,0,'[{2,5218},{4,392}]','[]',0,0,0,0),(16040203,'锈蚀·兽灵刃爪','绿3星兽灵刃爪【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040200,0,1,1,0,0,0,0,'[{1,48}]',0,0,0,0,'[{2,6957},{4,522}]','[]',0,0,0,0),(16040204,'锈蚀·兽灵刃爪','绿4星兽灵刃爪【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040200,0,1,1,0,0,0,0,'[{1,61}]',0,0,0,0,'[{2,8696},{4,653}]','[]',0,0,0,0),(16040205,'锈蚀·兽灵刃爪','绿5星兽灵刃爪【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040200,0,1,1,0,0,0,0,'[{1,78}]',0,0,0,0,'[{2,10435},{4,783}]','[]',0,0,0,0),(16040211,'平凡·兽灵刃爪','蓝1星兽灵刃爪【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040200,0,1,1,1,0,0,0,'[{1,69}]',0,0,0,0,'[{2,9392},{4,705}]','[]',0,0,0,0),(16040212,'平凡·兽灵刃爪','蓝2星兽灵刃爪【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040200,0,1,1,1,0,0,0,'[{1,98}]',0,0,0,0,'[{2,14087},{4,1057}]','[]',0,0,0,0),(16040213,'平凡·兽灵刃爪','蓝3星兽灵刃爪【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040200,0,1,1,1,0,0,0,'[{1,125}]',0,0,0,0,'[{2,18783},{4,1409}]','[]',0,0,0,0),(16040214,'平凡·兽灵刃爪','蓝4星兽灵刃爪【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040200,0,1,1,1,0,0,0,'[{1,209}]',0,0,0,0,'[{2,23479},{4,1761}]','[]',0,0,0,0),(16040215,'平凡·兽灵刃爪','蓝5星兽灵刃爪【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040200,0,1,1,1,0,0,0,'[{1,288}]',0,0,0,0,'[{2,28174},{4,2114}]','[]',0,0,0,0),(16040221,'完好·兽灵刃爪','紫1星兽灵刃爪【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040200,0,1,1,2,0,0,0,'[{1,246}]',0,0,0,0,'[{2,24348},{4,1827}]','[]',0,0,0,0),(16040222,'完好·兽灵刃爪','紫2星兽灵刃爪【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040200,0,1,1,2,0,0,0,'[{1,353}]',0,0,0,0,'[{2,36522},{4,2740}]','[]',0,0,0,0),(16040223,'完好·兽灵刃爪','紫3星兽灵刃爪【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040200,0,1,1,2,0,0,0,'[{1,454}]',0,0,0,0,'[{2,48696},{4,3653}]','[]',0,0,0,0),(16040224,'完好·兽灵刃爪','紫4星兽灵刃爪【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040200,0,1,1,2,0,0,0,'[{1,777}]',0,0,0,0,'[{2,60870},{4,4566}]','[]',0,0,0,0),(16040225,'完好·兽灵刃爪','紫5星兽灵刃爪【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040200,0,1,1,2,0,0,0,'[{1,1100}]',0,0,0,0,'[{2,73044},{4,5479}]','[]',0,0,0,0),(16040231,'精良·兽灵刃爪','橙1星兽灵刃爪【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040200,0,1,1,3,0,0,0,'[{1,939}]',0,0,0,0,'[{2,62609},{4,4696}]','[]',0,0,0,0),(16040232,'精良·兽灵刃爪','橙2星兽灵刃爪【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040200,0,1,1,3,0,0,0,'[{1,1379}]',0,0,0,0,'[{2,93914},{4,7044}]','[]',0,0,0,0),(16040233,'精良·兽灵刃爪','橙3星兽灵刃爪【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040200,0,1,1,3,0,0,0,'[{1,1819}]',0,0,0,0,'[{2,125218},{4,9392}]','[]',0,0,0,0),(16040234,'精良·兽灵刃爪','橙4星兽灵刃爪【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040200,0,1,1,3,0,0,0,'[{1,3113}]',0,0,0,0,'[{2,156522},{4,11740}]','[]',0,0,0,0),(16040235,'精良·兽灵刃爪','橙5星兽灵刃爪【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040200,0,1,1,3,0,0,0,'[{1,4407}]',0,0,0,0,'[{2,187827},{4,14087}]','[]',0,0,0,0),(16040241,'稀有·兽灵刃爪','红1星兽灵刃爪【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040200,0,1,1,4,0,0,0,'[{1,3760}]',0,0,0,0,'[{2,173913},{4,13044}]','[]',0,0,0,0),(16040242,'稀有·兽灵刃爪','红2星兽灵刃爪【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040200,0,1,1,4,0,0,0,'[{1,5523}]',0,0,0,0,'[{2,208696},{4,15653}]','[]',0,0,0,0),(16040243,'稀有·兽灵刃爪','红3星兽灵刃爪【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040200,0,1,1,4,0,0,0,'[{1,7285}]',0,0,0,0,'[{2,260870},{4,19566}]','[]',0,0,0,0),(16040244,'稀有·兽灵刃爪','红4星兽灵刃爪【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040200,0,1,1,4,0,0,0,'[{1,12470}]',0,0,0,0,'[{2,313044},{4,23479}]','[]',0,0,0,0),(16040245,'稀有·兽灵刃爪','红5星兽灵刃爪【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040200,0,1,1,4,0,0,0,'[{1,17654}]',0,0,0,0,'[{2,382609},{4,28696}]','[]',0,0,0,0),(16040251,'卓越·兽灵刃爪','粉1星兽灵刃爪【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040200,0,1,1,5,0,0,0,'[{1,16439}]',0,0,0,0,'[{2,191305},{4,14348}]','[]',0,0,0,0),(16040252,'卓越·兽灵刃爪','粉2星兽灵刃爪【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040200,0,1,1,5,0,0,0,'[{1,23014}]',0,0,0,0,'[{2,226087},{4,16957}]','[]',0,0,0,0),(16040253,'卓越·兽灵刃爪','粉3星兽灵刃爪【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040200,0,1,1,5,0,0,0,'[{1,35343}]',0,0,0,0,'[{2,278261},{4,20870}]','[]',0,0,0,0),(16040254,'卓越·兽灵刃爪','粉4星兽灵刃爪【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040200,0,1,1,5,0,0,0,'[{1,47671}]',0,0,0,0,'[{2,313044},{4,23479}]','[]',0,0,0,0),(16040255,'卓越·兽灵刃爪','粉5星兽灵刃爪【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040200,0,1,1,5,0,0,0,'[{1,60000}]',0,0,0,0,'[{2,417392},{4,31305}]','[]',0,0,0,0),(16040301,'锈蚀·兽灵挂饰','绿1星兽灵挂饰【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040300,0,1,1,0,0,0,0,'[{1,29}]',0,0,0,0,'[{1,174},{5,131}]','[]',0,0,0,0),(16040302,'锈蚀·兽灵挂饰','绿2星兽灵挂饰【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040300,0,1,1,0,0,0,0,'[{1,39}]',0,0,0,0,'[{1,261},{5,196}]','[]',0,0,0,0),(16040303,'锈蚀·兽灵挂饰','绿3星兽灵挂饰【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040300,0,1,1,0,0,0,0,'[{1,48}]',0,0,0,0,'[{1,348},{5,261}]','[]',0,0,0,0),(16040304,'锈蚀·兽灵挂饰','绿4星兽灵挂饰【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040300,0,1,1,0,0,0,0,'[{1,62}]',0,0,0,0,'[{1,435},{5,327}]','[]',0,0,0,0),(16040305,'锈蚀·兽灵挂饰','绿5星兽灵挂饰【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040300,0,1,1,0,0,0,0,'[{1,78}]',0,0,0,0,'[{1,522},{5,392}]','[]',0,0,0,0),(16040311,'平凡·兽灵挂饰','蓝1星兽灵挂饰【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040300,0,1,1,1,0,0,0,'[{1,69}]',0,0,0,0,'[{1,470},{5,353}]','[]',0,0,0,0),(16040312,'平凡·兽灵挂饰','蓝2星兽灵挂饰【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040300,0,1,1,1,0,0,0,'[{1,98}]',0,0,0,0,'[{1,705},{5,529}]','[]',0,0,0,0),(16040313,'平凡·兽灵挂饰','蓝3星兽灵挂饰【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040300,0,1,1,1,0,0,0,'[{1,126}]',0,0,0,0,'[{1,940},{5,705}]','[]',0,0,0,0),(16040314,'平凡·兽灵挂饰','蓝4星兽灵挂饰【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040300,0,1,1,1,0,0,0,'[{1,209}]',0,0,0,0,'[{1,1174},{5,881}]','[]',0,0,0,0),(16040315,'平凡·兽灵挂饰','蓝5星兽灵挂饰【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040300,0,1,1,1,0,0,0,'[{1,289}]',0,0,0,0,'[{1,1409},{5,1057}]','[]',0,0,0,0),(16040321,'完好·兽灵挂饰','紫1星兽灵挂饰【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040300,0,1,1,2,0,0,0,'[{1,247}]',0,0,0,0,'[{1,1218},{5,914}]','[]',0,0,0,0),(16040322,'完好·兽灵挂饰','紫2星兽灵挂饰【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040300,0,1,1,2,0,0,0,'[{1,354}]',0,0,0,0,'[{1,1827},{5,1370}]','[]',0,0,0,0),(16040323,'完好·兽灵挂饰','紫3星兽灵挂饰【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040300,0,1,1,2,0,0,0,'[{1,454}]',0,0,0,0,'[{1,2435},{5,1827}]','[]',0,0,0,0),(16040324,'完好·兽灵挂饰','紫4星兽灵挂饰【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040300,0,1,1,2,0,0,0,'[{1,778}]',0,0,0,0,'[{1,3044},{5,2283}]','[]',0,0,0,0),(16040325,'完好·兽灵挂饰','紫5星兽灵挂饰【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040300,0,1,1,2,0,0,0,'[{1,1101}]',0,0,0,0,'[{1,3653},{5,2740}]','[]',0,0,0,0),(16040331,'精良·兽灵挂饰','橙1星兽灵挂饰【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040300,0,1,1,3,0,0,0,'[{1,939}]',0,0,0,0,'[{1,3131},{5,2348}]','[]',0,0,0,0),(16040332,'精良·兽灵挂饰','橙2星兽灵挂饰【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040300,0,1,1,3,0,0,0,'[{1,1380}]',0,0,0,0,'[{1,4696},{5,3522}]','[]',0,0,0,0),(16040333,'精良·兽灵挂饰','橙3星兽灵挂饰【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040300,0,1,1,3,0,0,0,'[{1,1819}]',0,0,0,0,'[{1,6261},{5,4696}]','[]',0,0,0,0),(16040334,'精良·兽灵挂饰','橙4星兽灵挂饰【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040300,0,1,1,3,0,0,0,'[{1,3113}]',0,0,0,0,'[{1,7827},{5,5870}]','[]',0,0,0,0),(16040335,'精良·兽灵挂饰','橙5星兽灵挂饰【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040300,0,1,1,3,0,0,0,'[{1,4408}]',0,0,0,0,'[{1,9392},{5,7044}]','[]',0,0,0,0),(16040341,'稀有·兽灵挂饰','红1星兽灵挂饰【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040300,0,1,1,4,0,0,0,'[{1,3761}]',0,0,0,0,'[{1,8696},{5,6522}]','[]',0,0,0,0),(16040342,'稀有·兽灵挂饰','红2星兽灵挂饰【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040300,0,1,1,4,0,0,0,'[{1,5524}]',0,0,0,0,'[{1,10435},{5,7827}]','[]',0,0,0,0),(16040343,'稀有·兽灵挂饰','红3星兽灵挂饰【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040300,0,1,1,4,0,0,0,'[{1,7285}]',0,0,0,0,'[{1,13044},{5,9783}]','[]',0,0,0,0),(16040344,'稀有·兽灵挂饰','红4星兽灵挂饰【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040300,0,1,1,4,0,0,0,'[{1,12470}]',0,0,0,0,'[{1,15653},{5,11740}]','[]',0,0,0,0),(16040345,'稀有·兽灵挂饰','红5星兽灵挂饰【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040300,0,1,1,4,0,0,0,'[{1,17655}]',0,0,0,0,'[{1,19131},{5,14348}]','[]',0,0,0,0),(16040351,'卓越·兽灵挂饰','粉1星兽灵挂饰【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040300,0,1,1,5,0,0,0,'[{1,16439}]',0,0,0,0,'[{1,9566},{5,7174}]','[]',0,0,0,0),(16040352,'卓越·兽灵挂饰','粉2星兽灵挂饰【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040300,0,1,1,5,0,0,0,'[{1,23015}]',0,0,0,0,'[{1,11305},{5,8479}]','[]',0,0,0,0),(16040353,'卓越·兽灵挂饰','粉3星兽灵挂饰【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040300,0,1,1,5,0,0,0,'[{1,35344}]',0,0,0,0,'[{1,13914},{5,10435}]','[]',0,0,0,0),(16040354,'卓越·兽灵挂饰','粉4星兽灵挂饰【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040300,0,1,1,5,0,0,0,'[{1,47672}]',0,0,0,0,'[{1,15653},{5,11740}]','[]',0,0,0,0),(16040355,'卓越·兽灵挂饰','粉5星兽灵挂饰【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040300,0,1,1,5,0,0,0,'[{1,60001}]',0,0,0,0,'[{1,20870},{5,15653}]','[]',0,0,0,0),(16040401,'锈蚀·兽灵刻痕','绿1星兽灵刻痕【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040400,0,1,1,0,0,0,0,'[{1,28}]',0,0,0,0,'[{2,3479},{6,131}]','[]',0,0,0,0),(16040402,'锈蚀·兽灵刻痕','绿2星兽灵刻痕【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040400,0,1,1,0,0,0,0,'[{1,38}]',0,0,0,0,'[{2,5218},{6,196}]','[]',0,0,0,0),(16040403,'锈蚀·兽灵刻痕','绿3星兽灵刻痕【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040400,0,1,1,0,0,0,0,'[{1,48}]',0,0,0,0,'[{2,6957},{6,261}]','[]',0,0,0,0),(16040404,'锈蚀·兽灵刻痕','绿4星兽灵刻痕【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040400,0,1,1,0,0,0,0,'[{1,61}]',0,0,0,0,'[{2,8696},{6,327}]','[]',0,0,0,0),(16040405,'锈蚀·兽灵刻痕','绿5星兽灵刻痕【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040400,0,1,1,0,0,0,0,'[{1,78}]',0,0,0,0,'[{2,10435},{6,392}]','[]',0,0,0,0),(16040411,'平凡·兽灵刻痕','蓝1星兽灵刻痕【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040400,0,1,1,1,0,0,0,'[{1,69}]',0,0,0,0,'[{2,9392},{6,353}]','[]',0,0,0,0),(16040412,'平凡·兽灵刻痕','蓝2星兽灵刻痕【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040400,0,1,1,1,0,0,0,'[{1,98}]',0,0,0,0,'[{2,14087},{6,529}]','[]',0,0,0,0),(16040413,'平凡·兽灵刻痕','蓝3星兽灵刻痕【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040400,0,1,1,1,0,0,0,'[{1,126}]',0,0,0,0,'[{2,18783},{6,705}]','[]',0,0,0,0),(16040414,'平凡·兽灵刻痕','蓝4星兽灵刻痕【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040400,0,1,1,1,0,0,0,'[{1,209}]',0,0,0,0,'[{2,23479},{6,881}]','[]',0,0,0,0),(16040415,'平凡·兽灵刻痕','蓝5星兽灵刻痕【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040400,0,1,1,1,0,0,0,'[{1,289}]',0,0,0,0,'[{2,28174},{6,1057}]','[]',0,0,0,0),(16040421,'完好·兽灵刻痕','紫1星兽灵刻痕【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040400,0,1,1,2,0,0,0,'[{1,247}]',0,0,0,0,'[{2,24348},{6,914}]','[]',0,0,0,0),(16040422,'完好·兽灵刻痕','紫2星兽灵刻痕【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040400,0,1,1,2,0,0,0,'[{1,354}]',0,0,0,0,'[{2,36522},{6,1370}]','[]',0,0,0,0),(16040423,'完好·兽灵刻痕','紫3星兽灵刻痕【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040400,0,1,1,2,0,0,0,'[{1,454}]',0,0,0,0,'[{2,48696},{6,1827}]','[]',0,0,0,0),(16040424,'完好·兽灵刻痕','紫4星兽灵刻痕【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040400,0,1,1,2,0,0,0,'[{1,778}]',0,0,0,0,'[{2,60870},{6,2283}]','[]',0,0,0,0),(16040425,'完好·兽灵刻痕','紫5星兽灵刻痕【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040400,0,1,1,2,0,0,0,'[{1,1100}]',0,0,0,0,'[{2,73044},{6,2740}]','[]',0,0,0,0),(16040431,'精良·兽灵刻痕','橙1星兽灵刻痕【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040400,0,1,1,3,0,0,0,'[{1,939}]',0,0,0,0,'[{2,62609},{6,2348}]','[]',0,0,0,0),(16040432,'精良·兽灵刻痕','橙2星兽灵刻痕【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040400,0,1,1,3,0,0,0,'[{1,1379}]',0,0,0,0,'[{2,93914},{6,3522}]','[]',0,0,0,0),(16040433,'精良·兽灵刻痕','橙3星兽灵刻痕【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040400,0,1,1,3,0,0,0,'[{1,1819}]',0,0,0,0,'[{2,125218},{6,4696}]','[]',0,0,0,0),(16040434,'精良·兽灵刻痕','橙4星兽灵刻痕【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040400,0,1,1,3,0,0,0,'[{1,3113}]',0,0,0,0,'[{2,156522},{6,5870}]','[]',0,0,0,0),(16040435,'精良·兽灵刻痕','橙5星兽灵刻痕【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040400,0,1,1,3,0,0,0,'[{1,4408}]',0,0,0,0,'[{2,187827},{6,7044}]','[]',0,0,0,0),(16040441,'稀有·兽灵刻痕','红1星兽灵刻痕【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040400,0,1,1,4,0,0,0,'[{1,3760}]',0,0,0,0,'[{2,173913},{6,6522}]','[]',0,0,0,0),(16040442,'稀有·兽灵刻痕','红2星兽灵刻痕【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040400,0,1,1,4,0,0,0,'[{1,5523}]',0,0,0,0,'[{2,208696},{6,7827}]','[]',0,0,0,0),(16040443,'稀有·兽灵刻痕','红3星兽灵刻痕【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040400,0,1,1,4,0,0,0,'[{1,7285}]',0,0,0,0,'[{2,260870},{6,9783}]','[]',0,0,0,0),(16040444,'稀有·兽灵刻痕','红4星兽灵刻痕【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040400,0,1,1,4,0,0,0,'[{1,12470}]',0,0,0,0,'[{2,313044},{6,11740}]','[]',0,0,0,0),(16040445,'稀有·兽灵刻痕','红5星兽灵刻痕【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040400,0,1,1,4,0,0,0,'[{1,17654}]',0,0,0,0,'[{2,382609},{6,14348}]','[]',0,0,0,0),(16040451,'卓越·兽灵刻痕','粉1星兽灵刻痕【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040400,0,1,1,5,0,0,0,'[{1,16439}]',0,0,0,0,'[{2,191305},{6,7174}]','[]',0,0,0,0),(16040452,'卓越·兽灵刻痕','粉2星兽灵刻痕【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040400,0,1,1,5,0,0,0,'[{1,23015}]',0,0,0,0,'[{2,226087},{6,8479}]','[]',0,0,0,0),(16040453,'卓越·兽灵刻痕','粉3星兽灵刻痕【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040400,0,1,1,5,0,0,0,'[{1,35343}]',0,0,0,0,'[{2,278261},{6,10435}]','[]',0,0,0,0),(16040454,'卓越·兽灵刻痕','粉4星兽灵刻痕【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040400,0,1,1,5,0,0,0,'[{1,47671}]',0,0,0,0,'[{2,313044},{6,11740}]','[]',0,0,0,0),(16040455,'卓越·兽灵刻痕','粉5星兽灵刻痕【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040400,0,1,1,5,0,0,0,'[{1,60001}]',0,0,0,0,'[{2,417392},{6,15653}]','[]',0,0,0,0),(16040501,'锈蚀·兽灵符文','绿1星兽灵符文【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040500,0,1,1,0,0,0,0,'[{1,29}]',0,0,0,0,'[{1,174},{7,131}]','[]',0,0,0,0),(16040502,'锈蚀·兽灵符文','绿2星兽灵符文【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040500,0,1,1,0,0,0,0,'[{1,39}]',0,0,0,0,'[{1,261},{7,196}]','[]',0,0,0,0),(16040503,'锈蚀·兽灵符文','绿3星兽灵符文【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040500,0,1,1,0,0,0,0,'[{1,48}]',0,0,0,0,'[{1,348},{7,261}]','[]',0,0,0,0),(16040504,'锈蚀·兽灵符文','绿4星兽灵符文【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040500,0,1,1,0,0,0,0,'[{1,62}]',0,0,0,0,'[{1,435},{7,327}]','[]',0,0,0,0),(16040505,'锈蚀·兽灵符文','绿5星兽灵符文【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040500,0,1,1,0,0,0,0,'[{1,78}]',0,0,0,0,'[{1,522},{7,392}]','[]',0,0,0,0),(16040511,'平凡·兽灵符文','蓝1星兽灵符文【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040500,0,1,1,1,0,0,0,'[{1,69}]',0,0,0,0,'[{1,470},{7,353}]','[]',0,0,0,0),(16040512,'平凡·兽灵符文','蓝2星兽灵符文【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040500,0,1,1,1,0,0,0,'[{1,98}]',0,0,0,0,'[{1,705},{7,529}]','[]',0,0,0,0),(16040513,'平凡·兽灵符文','蓝3星兽灵符文【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040500,0,1,1,1,0,0,0,'[{1,126}]',0,0,0,0,'[{1,940},{7,705}]','[]',0,0,0,0),(16040514,'平凡·兽灵符文','蓝4星兽灵符文【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040500,0,1,1,1,0,0,0,'[{1,209}]',0,0,0,0,'[{1,1174},{7,881}]','[]',0,0,0,0),(16040515,'平凡·兽灵符文','蓝5星兽灵符文【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040500,0,1,1,1,0,0,0,'[{1,289}]',0,0,0,0,'[{1,1409},{7,1057}]','[]',0,0,0,0),(16040521,'完好·兽灵符文','紫1星兽灵符文【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040500,0,1,1,2,0,0,0,'[{1,247}]',0,0,0,0,'[{1,1218},{7,914}]','[]',0,0,0,0),(16040522,'完好·兽灵符文','紫2星兽灵符文【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040500,0,1,1,2,0,0,0,'[{1,354}]',0,0,0,0,'[{1,1827},{7,1370}]','[]',0,0,0,0),(16040523,'完好·兽灵符文','紫3星兽灵符文【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040500,0,1,1,2,0,0,0,'[{1,454}]',0,0,0,0,'[{1,2435},{7,1827}]','[]',0,0,0,0),(16040524,'完好·兽灵符文','紫4星兽灵符文【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040500,0,1,1,2,0,0,0,'[{1,778}]',0,0,0,0,'[{1,3044},{7,2283}]','[]',0,0,0,0),(16040525,'完好·兽灵符文','紫5星兽灵符文【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040500,0,1,1,2,0,0,0,'[{1,1101}]',0,0,0,0,'[{1,3653},{7,2740}]','[]',0,0,0,0),(16040531,'精良·兽灵符文','橙1星兽灵符文【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040500,0,1,1,3,0,0,0,'[{1,939}]',0,0,0,0,'[{1,3131},{7,2348}]','[]',0,0,0,0),(16040532,'精良·兽灵符文','橙2星兽灵符文【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040500,0,1,1,3,0,0,0,'[{1,1380}]',0,0,0,0,'[{1,4696},{7,3522}]','[]',0,0,0,0),(16040533,'精良·兽灵符文','橙3星兽灵符文【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040500,0,1,1,3,0,0,0,'[{1,1819}]',0,0,0,0,'[{1,6261},{7,4696}]','[]',0,0,0,0),(16040534,'精良·兽灵符文','橙4星兽灵符文【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040500,0,1,1,3,0,0,0,'[{1,3113}]',0,0,0,0,'[{1,7827},{7,5870}]','[]',0,0,0,0),(16040535,'精良·兽灵符文','橙5星兽灵符文【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040500,0,1,1,3,0,0,0,'[{1,4408}]',0,0,0,0,'[{1,9392},{7,7044}]','[]',0,0,0,0),(16040541,'稀有·兽灵符文','红1星兽灵符文【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040500,0,1,1,4,0,0,0,'[{1,3761}]',0,0,0,0,'[{1,8696},{7,6522}]','[]',0,0,0,0),(16040542,'稀有·兽灵符文','红2星兽灵符文【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040500,0,1,1,4,0,0,0,'[{1,5524}]',0,0,0,0,'[{1,10435},{7,7827}]','[]',0,0,0,0),(16040543,'稀有·兽灵符文','红3星兽灵符文【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040500,0,1,1,4,0,0,0,'[{1,7285}]',0,0,0,0,'[{1,13044},{7,9783}]','[]',0,0,0,0),(16040544,'稀有·兽灵符文','红4星兽灵符文【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040500,0,1,1,4,0,0,0,'[{1,12470}]',0,0,0,0,'[{1,15653},{7,11740}]','[]',0,0,0,0),(16040545,'稀有·兽灵符文','红5星兽灵符文【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040500,0,1,1,4,0,0,0,'[{1,17655}]',0,0,0,0,'[{1,19131},{7,14348}]','[]',0,0,0,0),(16040551,'卓越·兽灵符文','粉1星兽灵符文【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040500,0,1,1,5,0,0,0,'[{1,16439}]',0,0,0,0,'[{1,9566},{7,7174}]','[]',0,0,0,0),(16040552,'卓越·兽灵符文','粉2星兽灵符文【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040500,0,1,1,5,0,0,0,'[{1,23015}]',0,0,0,0,'[{1,11305},{7,8479}]','[]',0,0,0,0),(16040553,'卓越·兽灵符文','粉3星兽灵符文【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040500,0,1,1,5,0,0,0,'[{1,35344}]',0,0,0,0,'[{1,13914},{7,10435}]','[]',0,0,0,0),(16040554,'卓越·兽灵符文','粉4星兽灵符文【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040500,0,1,1,5,0,0,0,'[{1,47672}]',0,0,0,0,'[{1,15653},{7,11740}]','[]',0,0,0,0),(16040555,'卓越·兽灵符文','粉5星兽灵符文【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040500,0,1,1,5,0,0,0,'[{1,60001}]',0,0,0,0,'[{1,20870},{7,15653}]','[]',0,0,0,0),(16040601,'锈蚀·兽灵坐鞍','绿1星兽灵坐鞍【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040600,0,1,1,0,0,0,0,'[{1,28}]',0,0,0,0,'[{2,3479},{8,131}]','[]',0,0,0,0),(16040602,'锈蚀·兽灵坐鞍','绿2星兽灵坐鞍【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040600,0,1,1,0,0,0,0,'[{1,38}]',0,0,0,0,'[{2,5218},{8,196}]','[]',0,0,0,0),(16040603,'锈蚀·兽灵坐鞍','绿3星兽灵坐鞍【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040600,0,1,1,0,0,0,0,'[{1,48}]',0,0,0,0,'[{2,6957},{8,261}]','[]',0,0,0,0),(16040604,'锈蚀·兽灵坐鞍','绿4星兽灵坐鞍【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040600,0,1,1,0,0,0,0,'[{1,61}]',0,0,0,0,'[{2,8696},{8,327}]','[]',0,0,0,0),(16040605,'锈蚀·兽灵坐鞍','绿5星兽灵坐鞍【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040600,0,1,1,0,0,0,0,'[{1,78}]',0,0,0,0,'[{2,10435},{8,392}]','[]',0,0,0,0),(16040611,'平凡·兽灵坐鞍','蓝1星兽灵坐鞍【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040600,0,1,1,1,0,0,0,'[{1,69}]',0,0,0,0,'[{2,9392},{8,353}]','[]',0,0,0,0),(16040612,'平凡·兽灵坐鞍','蓝2星兽灵坐鞍【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040600,0,1,1,1,0,0,0,'[{1,98}]',0,0,0,0,'[{2,14087},{8,529}]','[]',0,0,0,0),(16040613,'平凡·兽灵坐鞍','蓝3星兽灵坐鞍【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040600,0,1,1,1,0,0,0,'[{1,126}]',0,0,0,0,'[{2,18783},{8,705}]','[]',0,0,0,0),(16040614,'平凡·兽灵坐鞍','蓝4星兽灵坐鞍【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040600,0,1,1,1,0,0,0,'[{1,209}]',0,0,0,0,'[{2,23479},{8,881}]','[]',0,0,0,0),(16040615,'平凡·兽灵坐鞍','蓝5星兽灵坐鞍【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040600,0,1,1,1,0,0,0,'[{1,289}]',0,0,0,0,'[{2,28174},{8,1057}]','[]',0,0,0,0),(16040621,'完好·兽灵坐鞍','紫1星兽灵坐鞍【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040600,0,1,1,2,0,0,0,'[{1,247}]',0,0,0,0,'[{2,24348},{8,914}]','[]',0,0,0,0),(16040622,'完好·兽灵坐鞍','紫2星兽灵坐鞍【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040600,0,1,1,2,0,0,0,'[{1,354}]',0,0,0,0,'[{2,36522},{8,1370}]','[]',0,0,0,0),(16040623,'完好·兽灵坐鞍','紫3星兽灵坐鞍【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040600,0,1,1,2,0,0,0,'[{1,454}]',0,0,0,0,'[{2,48696},{8,1827}]','[]',0,0,0,0),(16040624,'完好·兽灵坐鞍','紫4星兽灵坐鞍【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040600,0,1,1,2,0,0,0,'[{1,778}]',0,0,0,0,'[{2,60870},{8,2283}]','[]',0,0,0,0),(16040625,'完好·兽灵坐鞍','紫5星兽灵坐鞍【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040600,0,1,1,2,0,0,0,'[{1,1100}]',0,0,0,0,'[{2,73044},{8,2740}]','[]',0,0,0,0),(16040631,'精良·兽灵坐鞍','橙1星兽灵坐鞍【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040600,0,1,1,3,0,0,0,'[{1,939}]',0,0,0,0,'[{2,62609},{8,2348}]','[]',0,0,0,0),(16040632,'精良·兽灵坐鞍','橙2星兽灵坐鞍【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040600,0,1,1,3,0,0,0,'[{1,1379}]',0,0,0,0,'[{2,93914},{8,3522}]','[]',0,0,0,0),(16040633,'精良·兽灵坐鞍','橙3星兽灵坐鞍【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040600,0,1,1,3,0,0,0,'[{1,1819}]',0,0,0,0,'[{2,125218},{8,4696}]','[]',0,0,0,0),(16040634,'精良·兽灵坐鞍','橙4星兽灵坐鞍【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040600,0,1,1,3,0,0,0,'[{1,3113}]',0,0,0,0,'[{2,156522},{8,5870}]','[]',0,0,0,0),(16040635,'精良·兽灵坐鞍','橙5星兽灵坐鞍【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040600,0,1,1,3,0,0,0,'[{1,4408}]',0,0,0,0,'[{2,187827},{8,7044}]','[]',0,0,0,0),(16040641,'稀有·兽灵坐鞍','红1星兽灵坐鞍【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040600,0,1,1,4,0,0,0,'[{1,3760}]',0,0,0,0,'[{2,173913},{8,6522}]','[]',0,0,0,0),(16040642,'稀有·兽灵坐鞍','红2星兽灵坐鞍【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040600,0,1,1,4,0,0,0,'[{1,5523}]',0,0,0,0,'[{2,208696},{8,7827}]','[]',0,0,0,0),(16040643,'稀有·兽灵坐鞍','红3星兽灵坐鞍【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040600,0,1,1,4,0,0,0,'[{1,7285}]',0,0,0,0,'[{2,260870},{8,9783}]','[]',0,0,0,0),(16040644,'稀有·兽灵坐鞍','红4星兽灵坐鞍【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040600,0,1,1,4,0,0,0,'[{1,12470}]',0,0,0,0,'[{2,313044},{8,11740}]','[]',0,0,0,0),(16040645,'稀有·兽灵坐鞍','红5星兽灵坐鞍【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040600,0,1,1,4,0,0,0,'[{1,17654}]',0,0,0,0,'[{2,382609},{8,14348}]','[]',0,0,0,0),(16040651,'卓越·兽灵坐鞍','粉1星兽灵坐鞍【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040600,0,1,1,5,0,0,0,'[{1,16439}]',0,0,0,0,'[{2,191305},{8,7174}]','[]',0,0,0,0),(16040652,'卓越·兽灵坐鞍','粉2星兽灵坐鞍【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040600,0,1,1,5,0,0,0,'[{1,23015}]',0,0,0,0,'[{2,226087},{8,8479}]','[]',0,0,0,0),(16040653,'卓越·兽灵坐鞍','粉3星兽灵坐鞍【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040600,0,1,1,5,0,0,0,'[{1,35343}]',0,0,0,0,'[{2,278261},{8,10435}]','[]',0,0,0,0),(16040654,'卓越·兽灵坐鞍','粉4星兽灵坐鞍【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040600,0,1,1,5,0,0,0,'[{1,47671}]',0,0,0,0,'[{2,313044},{8,11740}]','[]',0,0,0,0),(16040655,'卓越·兽灵坐鞍','粉5星兽灵坐鞍【通用】','',0,'【跨服入侵】','[{609,0,1}]',0,0,0,16,4,0,0,0,16040600,0,1,1,5,0,0,0,'[{1,60001}]',0,0,0,0,'[{2,417392},{8,15653}]','[]',0,0,0,0),(16050001,'兽灵晶尘','用于坐骑装备升级的材料，提供1点经验','',0,'【跨服入侵,分解兽灵装备】','[{609,0,1},{160,4,1}]',0,0,0,16,5,0,0,0,16050001,0,1,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(16060001,'兽灵晶石（旧）','旧系统材料','',0,'【跨服入侵,分解兽灵装备】','[{609,0,1},{160,4,1}]',0,0,0,16,6,0,0,0,16060001,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(16060002,'兽灵萤石（旧）','旧系统材料','',0,'【跨服入侵,分解兽灵装备】','[{609,0,1},{160,4,1}]',0,0,0,16,6,0,0,0,16060002,0,1,99999,6,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(16070001,'赤焰飓风·7天版','激活坐骑外观：未来鲨鱼，在【坐骑】-【幻形】中使用。\\n激活立即获得<color=#4eae1a>12730战力</color>，后面更可通过培养获得更多战力！','',12730,'【运营活动】','[{423,1,1}]',0,0,0,16,7,0,0,0,16030001,0,25,999999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(16080000,'绿1星祭品','打造绿色坐骑装备可以作为任意部位的1星祭品使用','',0,'【运营活动】','[{0,0,0}]',0,0,0,16,8,0,0,0,16040100,0,1,999,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(16080001,'蓝1星祭品','打造蓝色坐骑装备可以作为任意部位的1星祭品使用','',0,'【运营活动】','[{0,0,0}]',0,0,0,16,8,0,0,0,16040100,0,1,999,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(16080002,'紫1星祭品','打造紫色坐骑装备可以作为任意部位的1星祭品使用','',0,'【运营活动】','[{0,0,0}]',0,0,0,16,8,0,0,0,16040100,0,1,999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(16080003,'橙1星祭品','打造橙色坐骑装备可以作为任意部位的1星祭品使用','',0,'【运营活动】','[{0,0,0}]',0,0,0,16,8,0,0,0,16040100,0,1,999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(16080004,'红1星祭品','打造红色坐骑装备可以作为任意部位的1星祭品使用','',0,'【运营活动】','[{0,0,0}]',0,0,0,16,8,0,0,0,16040100,0,1,999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(16080005,'粉1星祭品','打造粉色坐骑装备可以作为任意部位的1星祭品使用','',0,'【运营活动】','[{0,0,0}]',0,0,0,16,8,0,0,0,16040100,0,1,999,5,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(16080100,'绿5星祭品','打造绿色坐骑装备可以作为任意部位的5星祭品使用','',0,'【运营活动】','[{0,0,0}]',0,0,0,16,8,0,0,0,16040100,0,1,999,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(16080101,'蓝5星祭品','打造蓝色坐骑装备可以作为任意部位的5星祭品使用','',0,'【运营活动】','[{0,0,0}]',0,0,0,16,8,0,0,0,16040100,0,1,999,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(16080102,'紫5星祭品','打造紫色坐骑装备可以作为任意部位的5星祭品使用','',0,'【运营活动】','[{0,0,0}]',0,0,0,16,8,0,0,0,16040100,0,1,999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(16080103,'橙5星祭品','打造橙色坐骑装备可以作为任意部位的5星祭品使用','',0,'【运营活动】','[{0,0,0}]',0,0,0,16,8,0,0,0,16040100,0,1,999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(16080104,'红5星祭品','打造红色坐骑装备可以作为任意部位的5星祭品使用','',0,'【运营活动】','[{0,0,0}]',0,0,0,16,8,0,0,0,16040100,0,1,999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(16080105,'粉5星祭品','打造粉色坐骑装备可以作为任意部位的5星祭品使用','',0,'【运营活动】','[{0,0,0}]',0,0,0,16,8,0,0,0,16040100,0,1,999,5,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(16090001,'赤焰飓风碎片','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活坐骑外观·赤焰飓风\\n激活立即获得\\n','攻击+840,生命+16800,抗暴值+210,坐骑生命加成+0.6%,伤害减免+3%',39900,'【运营活动】','[{0,0,0}]',0,0,0,16,9,1,0,0,16090001,0,25,99999,4,0,0,0,'[]',0,0,1,0,'[]','[]',302002,0,0,0),(16090002,'旋翼飞空艇碎片','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活坐骑外观·旋翼飞空艇\\n激活立即获得\\n','攻击 + 415,生命 + 8300,抗暴值 + 104,坐骑攻击加成 + 0.4%,伤害加成 + 2%',19720,'【运营活动】','[{0,0,0}]',0,0,0,16,9,1,0,0,16090002,0,25,999999,3,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(16090003,'呆萌兔碎片','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活坐骑外观·呆萌兔\\n激活立即获得\\n','攻击 + 290,生命 + 5800,抗暴值 + 73',13790,'【运营活动】','[{0,0,0}]',0,0,0,16,9,1,0,0,16090003,0,25,999999,3,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(16090004,'尸烬龙碎片','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活坐骑外观·尸烬龙\\n激活立即获得\\n','攻击 + 5430,生命 + 108600,抗暴值 + 1358,坐骑攻击加成 + 0.8%,会心一击 + 4%',257940,'【1VN竞拍,运营活动】','[{0,0,0}]',0,0,0,16,9,1,0,0,16090004,0,25,999999,5,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(16090005,'利维坦碎片','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活坐骑外观·利维坦\\n激活立即获得\\n','攻击+1220,生命+24400,抗暴值+305,坐骑生命加成+0.8%,致命一击+2%',57950,'【运营活动】','[{0,0,0}]',0,0,0,16,9,1,0,0,16090005,0,25,999999,4,0,0,0,'[]',0,0,1,0,'[]','[]',302006,0,0,0),(16090006,'旅行蜗牛碎片','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活坐骑外观·旅行蜗牛\\n激活立即获得\\n','攻击+540,生命+10800,抗暴值+135,坐骑攻击加成+0.5%,技能伤害+1.5%',25650,'【运营活动】','[{0,0,0}]',0,0,0,16,9,1,0,0,16090006,0,25,999999,3,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(16090007,'机械达人碎片','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活坐骑外观·机械达人\\n激活立即获得\\n','攻击+1500,生命+30000,抗暴值+375,坐骑生命加成+0.8%,暴击率+1.5%',71250,'【运营活动】','[{0,0,0}]',0,0,0,16,9,1,0,0,16090007,0,25,999999,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(16090008,'猫咪飞椅碎片','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活坐骑外观·猫咪飞椅\\n激活立即获得\\n','攻击+1540,生命+30800,抗暴值+385,坐骑攻击加成+0.8%,生命加成+1.2%',73150,'【运营活动】','[{0,0,0}]',0,0,0,16,9,1,0,0,16090008,0,25,999999,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(16090009,'魔法飞毯碎片','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活坐骑外观·魔法飞毯\\n激活立即获得\\n','攻击+1580,生命+31600,抗暴值+395,坐骑生命加成+0%,爆伤加成+3%',75050,'【运营活动】','[{0,0,0}]',0,0,0,16,9,1,0,0,16090009,0,25,999999,4,0,0,0,'[]',0,0,1,0,'[]','[]',302011,0,0,0),(16090010,'白熊首领碎片','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活坐骑外观·白熊首领\\n激活立即获得\\n','攻击+1620,生命+32400,抗暴值+405,坐骑攻击加成+0.8%,攻击加成+1.2%',76950,'【运营活动】','[{0,0,0}]',0,0,0,16,9,1,0,0,16090010,0,25,999999,4,0,0,0,'[]',0,0,1,0,'[]','[]',302009,0,0,0),(16090011,'夏日闲鸭碎片','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活坐骑外观·夏日闲鸭\\n激活立即获得\\n','攻击+1450,生命+29000,抗暴值+363,坐骑攻击加成+0.8%,技能伤害+2%',68890,'【运营活动】','[{0,0,0}]',0,0,0,16,9,1,0,0,16090011,0,25,999999,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(16090012,'科技魔狼碎片','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活坐骑外观·科技魔狼\\n激活立即获得\\n','攻击+1450,生命+29000,抗暴值+363,坐骑生命加成+0.8%,技能减免+2%',68890,'【运营活动】','[{0,0,0}]',0,0,0,16,9,1,0,0,16090012,0,25,999999,4,0,0,0,'[]',0,0,1,0,'[]','[]',302011,0,0,0),(16090013,'大佬座驾碎片','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活坐骑外观·大佬座驾\\n激活立即获得\\n','攻击+1450,生命+29000,抗暴值+363,坐骑生命加成+0.8%,PVP伤害+2.5%',68890,'【运营活动】','[{0,0,0}]',0,0,0,16,9,1,0,0,16090013,0,25,999999,4,0,0,0,'[]',0,0,1,0,'[]','[]',302009,0,0,0),(17010001,'破碎神格','晋升神格的材料','',0,'【神格试炼,离线挂机,三英会战】','[{610,23,1},{90,4,0}]',0,1,0,17,1,4,2,0,17010001,0,0,99999,1,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,1),(17010002,'精品神格','晋升神格的材料','',0,'【神格试炼,离线挂机,三英会战】','[{610,23,1},{90,4,0}]',0,1,0,17,1,4,2,0,17010002,0,100,99999,2,0,0,0,'[{1,10}]',0,0,0,0,'[]','[]',0,0,0,1),(17010003,'完美神格','晋升神格的材料','',0,'【神格试炼,离线挂机,三英会战】','[{610,23,1},{90,4,0}]',0,1,0,17,1,4,2,0,17010003,0,100,99999,3,0,0,0,'[{1,100}]',0,0,0,0,'[]','[]',0,0,0,1),(17020001,'光明神晶','蕴含着神圣的气息，可以提升神格属性','生命  +500,破甲  +20',1000,'【装备寻宝,运营活动,三英会战】','[{416,0,1}]',0,0,0,17,2,0,0,0,17020001,0,50,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(17020002,'黑暗神晶','蕴含着神圣的气息，可以提升神格属性','攻击  +50,防御  +40',2000,'【装备寻宝,运营活动,三英会战】','[{416,0,1}]',0,0,0,17,2,1,0,0,17020002,0,50,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(17020003,'秩序神晶','蕴含着神圣的气息，可以提升神格属性','生命  +1600,攻击  +80,神格生命加成  +0.5%,神格防御加成  +0.5%',3200,'【装备寻宝,运营活动】','[{416,0,1}]',0,0,0,17,2,1,0,0,17020003,0,50,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(17020004,'混沌神晶','蕴含着神圣的气息，可以提升神格属性','破甲  +120,防御  +120,神格攻击加成  +1%,神格破甲加成  +1%',6000,'【装备寻宝,运营活动】','[{416,0,1}]',0,0,0,17,2,1,0,0,17020004,0,50,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(17030101,'雷霆法则【1级】','\\n<color=#4eae1a>攻击  + 2400</color>\\n<color=#4eae1a>破甲  + 1200</color>\\n<color=#4eae1a>生命加成  + 2%</color>\\n<color=#4eae1a>攻击加成  + 2%</color>\\n蕴含强大的禁锢之力，每次攻击都有15%的概率麻痹目标，使其无法攻击和移动，持续1.5s','',78000,'【龙王秘宝,运营活动】','[{416,0,1}]',0,0,0,17,3,0,0,0,17030101,0,110,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(17030102,'雷霆法则【2级】','\\n<color=#4eae1a>攻击  + 4800</color>\\n<color=#4eae1a>破甲  + 2400</color>\\n<color=#4eae1a>生命加成  + 3%</color>\\n<color=#4eae1a>攻击加成  + 3%</color>\\n蕴含强大的禁锢之力，每次攻击都有15%的概率麻痹目标，使其无法攻击和移动，持续1.75s','',156000,'【龙王秘宝,运营活动】','[{416,0,1}]',0,0,0,17,3,0,0,0,17030101,0,110,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(17030103,'雷霆法则【3级】','\\n<color=#4eae1a>攻击  + 9600</color>\\n<color=#4eae1a>破甲  + 4800</color>\\n<color=#4eae1a>生命加成  + 4%</color>\\n<color=#4eae1a>攻击加成  + 4%</color>\\n<color=#4eae1a>致命一击  + 2%</color>\\n蕴含强大的禁锢之力，每次攻击都有15%的概率麻痹目标，使其无法攻击和移动，持续2s','',312000,'【龙王秘宝,运营活动】','[{416,0,1}]',0,0,0,17,3,0,0,0,17030101,0,110,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(17030104,'雷霆法则【4级】','\\n<color=#4eae1a>攻击  + 19200</color>\\n<color=#4eae1a>破甲  + 9600</color>\\n<color=#4eae1a>生命加成  + 6%</color>\\n<color=#4eae1a>攻击加成  + 6%</color>\\n<color=#4eae1a>致命一击  + 4%</color>\\n蕴含强大的禁锢之力，每次攻击都有15%的概率麻痹目标，使其无法攻击和移动，持续2.25s','',624000,'【龙王秘宝,运营活动】','[{416,0,1}]',0,0,0,17,3,0,0,0,17030101,0,110,0,5,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(17030105,'雷霆法则【5级】','\\n<color=#4eae1a>攻击  + 38400</color>\\n<color=#4eae1a>破甲  + 19200</color>\\n<color=#4eae1a>生命加成  + 8%</color>\\n<color=#4eae1a>攻击加成  + 8%</color>\\n<color=#4eae1a>致命一击  + 6%</color>\\n蕴含强大的禁锢之力，每次攻击都有15%的概率麻痹目标，使其无法攻击和移动，持续2.5s','',1248000,'【龙王秘宝,运营活动】','[{416,0,1}]',0,0,0,17,3,0,0,0,17030101,0,110,0,5,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(17030201,'生命法则【1级】','\\n<color=#4eae1a>生命  + 48000</color>\\n<color=#4eae1a>防御  + 1200</color>\\n<color=#4eae1a>生命加成  + 2%</color>\\n<color=#4eae1a>攻击加成  + 2%</color>\\n蕴含强大的治愈之力，每次攻击都有15%的概率回复生命，回复效果为所造成的最终伤害的60%','',78000,'【龙王秘宝,运营活动】','[{416,0,1}]',0,0,0,17,3,0,0,0,17030201,0,110,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(17030202,'生命法则【2级】','\\n<color=#4eae1a>生命  + 96000</color>\\n<color=#4eae1a>防御  + 2400</color>\\n<color=#4eae1a>生命加成  + 3%</color>\\n<color=#4eae1a>攻击加成  + 3%</color>\\n蕴含强大的治愈之力，每次攻击都有15%的概率回复生命，回复效果为所造成的最终伤害的70%','',156000,'【龙王秘宝,运营活动】','[{416,0,1}]',0,0,0,17,3,0,0,0,17030201,0,110,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(17030203,'生命法则【3级】','\\n<color=#4eae1a>生命  + 192000</color>\\n<color=#4eae1a>防御  + 4800</color>\\n<color=#4eae1a>生命加成  + 4%</color>\\n<color=#4eae1a>攻击加成  + 4%</color>\\n<color=#4eae1a>致命一击  + 2%</color>\\n蕴含强大的治愈之力，每次攻击都有15%的概率回复生命，回复效果为所造成的最终伤害的80%','',312000,'【龙王秘宝,运营活动】','[{416,0,1}]',0,0,0,17,3,0,0,0,17030201,0,110,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(17030204,'生命法则【4级】','\\n<color=#4eae1a>生命  + 384000</color>\\n<color=#4eae1a>防御  + 9600</color>\\n<color=#4eae1a>生命加成  + 6%</color>\\n<color=#4eae1a>攻击加成  + 6%</color>\\n<color=#4eae1a>致命一击  + 4%</color>\\n蕴含强大的治愈之力，每次攻击都有15%的概率回复生命，回复效果为所造成的最终伤害的90%','',624000,'【龙王秘宝,运营活动】','[{416,0,1}]',0,0,0,17,3,0,0,0,17030201,0,110,0,5,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(17030205,'生命法则【5级】','\\n<color=#4eae1a>生命  + 768000</color>\\n<color=#4eae1a>防御  + 19200</color>\\n<color=#4eae1a>生命加成  + 8%</color>\\n<color=#4eae1a>攻击加成  + 8%</color>\\n<color=#4eae1a>致命一击  + 6%</color>\\n蕴含强大的治愈之力，每次攻击都有15%的概率回复生命，回复效果为所造成的最终伤害的100%','',1248000,'【龙王秘宝,运营活动】','[{416,0,1}]',0,0,0,17,3,0,0,0,17030201,0,110,0,5,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(17030301,'光明法则【1级】','\\n<color=#4eae1a>攻击  + 2400</color>\\n<color=#4eae1a>破甲  + 1200</color>\\n<color=#4eae1a>生命加成  + 2%</color>\\n<color=#4eae1a>攻击加成  + 2%</color>\\n蕴含强大的生命之力，角色死亡后立即复活，并恢复生命上限35%的血量','',78000,'【龙王秘宝,运营活动】','[{416,0,1}]',0,0,0,17,3,0,0,0,17030301,0,110,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(17030302,'光明法则【2级】','\\n<color=#4eae1a>攻击  + 4800</color>\\n<color=#4eae1a>破甲  + 2400</color>\\n<color=#4eae1a>生命加成  + 3%</color>\\n<color=#4eae1a>攻击加成  + 3%</color>\\n蕴含强大的生命之力，角色死亡后立即复活，并恢复生命上限50%的血量','',156000,'【龙王秘宝,运营活动】','[{416,0,1}]',0,0,0,17,3,0,0,0,17030301,0,110,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(17030303,'光明法则【3级】','\\n<color=#4eae1a>攻击  + 9600</color>\\n<color=#4eae1a>破甲  + 4800</color>\\n<color=#4eae1a>生命加成  + 4%</color>\\n<color=#4eae1a>攻击加成  + 4%</color>\\n<color=#4eae1a>致命一击  + 2%</color>\\n蕴含强大的生命之力，角色死亡后立即复活，并恢复生命上限65%的血量','',312000,'【龙王秘宝,运营活动】','[{416,0,1}]',0,0,0,17,3,0,0,0,17030301,0,110,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(17030304,'光明法则【4级】','\\n<color=#4eae1a>攻击  + 19200</color>\\n<color=#4eae1a>破甲  + 9600</color>\\n<color=#4eae1a>生命加成  + 6%</color>\\n<color=#4eae1a>攻击加成  + 6%</color>\\n<color=#4eae1a>致命一击  + 4%</color>\\n蕴含强大的生命之力，角色死亡后立即复活，并恢复生命上限80%的血量','',624000,'【龙王秘宝,运营活动】','[{416,0,1}]',0,0,0,17,3,0,0,0,17030301,0,110,0,5,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(17030305,'光明法则【5级】','\\n<color=#4eae1a>攻击  + 38400</color>\\n<color=#4eae1a>破甲  + 19200</color>\\n<color=#4eae1a>生命加成  + 8%</color>\\n<color=#4eae1a>攻击加成  + 8%</color>\\n<color=#4eae1a>致命一击  + 6%</color>\\n蕴含强大的生命之力，角色死亡后立即复活，并恢复生命上限100%的血量','',1248000,'【龙王秘宝,运营活动】','[{416,0,1}]',0,0,0,17,3,0,0,0,17030301,0,110,0,5,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(17030401,'大地法则【1级】','\\n<color=#4eae1a>生命  + 48000</color>\\n<color=#4eae1a>防御  + 1200</color>\\n<color=#4eae1a>生命加成  + 2%</color>\\n<color=#4eae1a>攻击加成  + 2%</color>\\n蕴含强大的守护之力，受到攻击时有15%的概率获得60%的伤害减免','',78000,'【龙王秘宝,运营活动】','[{416,0,1}]',0,0,0,17,3,0,0,0,17030401,0,110,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(17030402,'大地法则【2级】','\\n<color=#4eae1a>生命  + 96000</color>\\n<color=#4eae1a>防御  + 2400</color>\\n<color=#4eae1a>生命加成  + 3%</color>\\n<color=#4eae1a>攻击加成  + 3%</color>\\n蕴含强大的守护之力，受到攻击时有15%的概率获得70%的伤害减免','',156000,'【龙王秘宝,运营活动】','[{416,0,1}]',0,0,0,17,3,0,0,0,17030401,0,110,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(17030403,'大地法则【3级】','\\n<color=#4eae1a>生命  + 192000</color>\\n<color=#4eae1a>防御  + 4800</color>\\n<color=#4eae1a>生命加成  + 4%</color>\\n<color=#4eae1a>攻击加成  + 4%</color>\\n<color=#4eae1a>致命一击  + 2%</color>\\n蕴含强大的守护之力，受到攻击时有15%的概率获得80%的伤害减免','',312000,'【龙王秘宝,运营活动】','[{416,0,1}]',0,0,0,17,3,0,0,0,17030401,0,110,0,5,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(17030404,'大地法则【4级】','\\n<color=#4eae1a>生命  + 384000</color>\\n<color=#4eae1a>防御  + 9600</color>\\n<color=#4eae1a>生命加成  + 6%</color>\\n<color=#4eae1a>攻击加成  + 6%</color>\\n<color=#4eae1a>致命一击  + 4%</color>\\n蕴含强大的守护之力，受到攻击时有15%的概率获得90%的伤害减免','',624000,'【龙王秘宝,运营活动】','[{416,0,1}]',0,0,0,17,3,0,0,0,17030401,0,110,0,5,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(17030405,'大地法则【5级】','\\n<color=#4eae1a>生命  + 768000</color>\\n<color=#4eae1a>防御  + 19200</color>\\n<color=#4eae1a>生命加成  + 8%</color>\\n<color=#4eae1a>攻击加成  + 8%</color>\\n<color=#4eae1a>致命一击  + 6%</color>\\n蕴含强大的守护之力，受到攻击时有15%的概率获得100%的伤害减免','',1248000,'【龙王秘宝,运营活动】','[{416,0,1}]',0,0,0,17,3,0,0,0,17030401,0,110,0,5,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(17040001,'法则精华','法则精华，用来提升2级法则的必须物品','',0,'【龙王秘宝-兑换商店】','[{153,1,1}]',0,0,0,17,4,1,0,0,17040001,0,110,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(17040002,'法则精魂','法则精魂，用来提升3级以上法则的必须物品','',0,'【龙王秘宝-兑换商店】','[{153,1,1}]',0,0,0,17,4,1,0,0,17040002,0,110,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(18010001,'星灵召唤券','在星空之门可以召唤星灵','',0,'【商城】','[{153,1,1}]',0,0,1,38,18,0,0,0,18010001,0,50,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(18020001,'初级星辰之砂','适用于1-10阶，增加10点星灵祝福值','',0,'【星灵副本,捕蝶,公会守卫,商城】','[{610,22,1},{429,0,0},{402,3,0},{153,2,0}]',0,0,0,18,2,1,0,0,18020001,0,12,99999,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(18020002,'中级星辰之砂','适用于11-20阶，增加30点星灵祝福值','',0,'【星灵副本,捕蝶,公会守卫,材料合成】','[{610,22,1},{429,0,0},{402,3,0},{150,5,0}]',0,0,0,18,2,0,0,0,18020002,0,12,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(18020003,'高级星辰之砂','适用于21-30阶，增加100点星灵祝福值','',0,'【星灵副本,捕蝶,公会守卫,材料合成】','[{610,22,1},{429,0,0},{402,3,0},{150,5,0}]',0,0,0,18,2,0,0,0,18020003,0,12,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(18030001,'小宇宙星核','用于小宇宙的突破','',0,'【首领遗迹,运营活动】','[{460,1,1}]',0,1,0,18,3,4,6,0,18030001,0,12,99999,4,0,0,0,'[{1,250}]',0,0,1,0,'[]','[]',0,0,0,1),(18030002,'小宇宙星核碎片','用于小宇宙星核的合成','',0,'【首领遗迹,运营活动】','[{460,1,1}]',0,1,0,18,3,4,6,0,18030002,0,12,99999,4,0,0,0,'[{1,250}]',0,0,1,0,'[]','[]',0,0,0,1),(18040001,'萌羊座','用于激活星灵外观：萌羊座，在【星灵】-【图鉴】中使用','',7626,'【开服活动】','[{0,0,0}]',0,0,0,18,4,0,0,0,18040001,0,12,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18040002,'白羊座','用于激活星灵外观：白羊座，在【星灵】-【图鉴】中使用','',12736,'【运营活动】','[{0,0,0}]',0,0,0,18,4,0,0,0,18040002,0,12,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',501003,0,0,1),(18040003,'金牛座','用于激活星灵外观：金牛座，在【星灵】-【图鉴】中使用','',12738,'【七日登录】','[{175,1,1}]',0,0,0,18,4,0,0,0,18040003,0,25,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',501004,0,0,1),(18040004,'双子座','用于激活星灵外观：双子座，在【星灵】-【图鉴】中使用','',12748,'【运营活动】','[{0,0,0}]',0,0,0,18,4,0,0,0,18040004,0,12,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',501005,0,0,1),(18040005,'巨蟹座','用于激活星灵外观：巨蟹座，在【星灵】-【图鉴】中使用','',12735,'【运营活动】','[{0,0,0}]',0,0,0,18,4,0,0,0,18040005,0,12,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',501006,0,0,1),(18040006,'狮子座','用于激活星灵外观：狮子座，在【星灵】-【图鉴】中使用','',12738,'【运营活动】','[{159,3,1}]',0,0,0,18,4,0,0,0,18040006,0,25,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',501007,0,0,1),(18040007,'处女座','用于激活星灵外观：处女座，在【星灵】-【图鉴】中使用','',12745,'【运营活动】','[{0,0,0}]',0,0,0,18,4,0,0,0,18040007,0,25,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',501008,0,0,1),(18040008,'蛇夫座','用于激活星灵外观：蛇夫座，在【星灵】-【图鉴】中使用','',29940,'【运营活动】','[{0,0,0}]',0,0,0,18,4,0,0,0,18040008,0,25,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',501008,0,0,1),(18040101,'熊霸霸','用于激活星灵外观：熊霸霸，在【星灵】-【图鉴】中使用','',7621,'【运营活动】','[{0,0,0}]',0,0,0,18,4,0,0,0,18040101,0,12,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',202028,0,0,1),(18040102,'难大师','用于激活星灵外观：难大师，在【星灵】-【图鉴】中使用','',7584,'【运营活动】','[{0,0,0}]',0,0,0,18,4,0,0,0,18040102,0,12,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',202003,0,0,1),(18040103,'代号09','用于激活星灵外观：代号09，在【星灵】-【图鉴】中使用','',7586,'【运营活动】','[{0,0,0}]',0,0,0,18,4,0,0,0,18040103,0,12,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',202015,0,0,1),(18040104,'修罗虎','用于激活星灵外观：修罗虎，在【星灵】-【图鉴】中使用','',7576,'【运营活动】','[{0,0,0}]',0,0,0,18,4,0,0,0,18040104,0,12,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',202029,0,0,1),(18040105,'暗影忍者','用于激活星灵外观：暗影忍者，在【星灵】-【图鉴】中使用','',7593,'【运营活动】','[{0,0,0}]',0,0,0,18,4,0,0,0,18040105,0,12,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',202027,0,0,1),(18041001,'萌羊座碎片','集齐<color=#4eae1a>10</color>个碎片，在【合成】中合成，即可激活星灵外观·萌羊座','',7626,'【运营活动】','[{0,0,0}]',0,0,0,18,20,0,0,0,18041001,0,12,99999,2,0,0,0,'[]',0,0,1,0,'[]','[]',501002,0,0,0),(18041002,'白羊座碎片','集齐<color=#4eae1a>10</color>个碎片，在【合成】中合成，即可激活星灵外观·白羊座','',12736,'【运营活动】','[{0,0,0}]',0,0,0,18,20,0,0,0,18041002,0,12,99999,3,0,0,0,'[]',0,0,1,0,'[]','[]',501003,0,0,0),(18041003,'金牛座碎片','集齐<color=#4eae1a>10</color>个碎片，在【合成】中合成，即可激活星灵外观·金牛座','',12738,'【每日签到,运营活动】','[{417,1,1}]',0,0,0,18,20,0,0,0,18041003,0,25,99999,3,0,0,0,'[]',0,0,1,0,'[]','[]',501004,0,0,0),(18041004,'双子座碎片','集齐<color=#4eae1a>10</color>个碎片，在【合成】中合成，即可激活星灵外观·双子座','',12748,'【运营活动】','[{0,0,0}]',0,0,0,18,20,0,0,0,18041004,0,12,99999,3,0,0,0,'[]',0,0,1,0,'[]','[]',501005,0,0,0),(18041005,'巨蟹座碎片','集齐<color=#4eae1a>10</color>个碎片，在【合成】中合成，即可激活星灵外观·巨蟹座','',12735,'【运营活动】','[{0,0,0}]',0,0,0,18,20,0,0,0,18041005,0,12,99999,3,0,0,0,'[]',0,0,1,0,'[]','[]',501006,0,0,0),(18041006,'狮子座碎片','集齐<color=#4eae1a>10</color>个碎片，在【合成】中合成，即可激活星灵外观·狮子座','',12738,'【运营活动】','[{0,0,0}]',0,0,0,18,20,0,0,0,18041006,0,25,99999,3,0,0,0,'[]',0,0,1,0,'[]','[]',501007,0,0,0),(18041007,'处女座碎片','集齐<color=#4eae1a>10</color>个碎片，在【合成】中合成，即可激活星灵外观·处女座','',12745,'【运营活动】','[{0,0,0}]',0,0,0,18,20,0,0,0,18041007,0,25,99999,3,0,0,0,'[]',0,0,1,0,'[]','[]',501007,0,0,0),(18041008,'蛇夫座碎片','集齐<color=#4eae1a>10</color>个碎片，在【合成】中合成，即可激活星灵外观·蛇夫座','',29940,'【运营活动】','[{0,0,0}]',0,0,0,18,20,0,0,0,18041008,0,25,99999,4,0,0,0,'[]',0,0,1,0,'[]','[]',501007,0,0,0),(18041101,'熊霸霸碎片','集齐<color=#4eae1a>10</color>个碎片，在【合成】中合成，即可激活星灵外观·熊霸霸','',7621,'【运营活动】','[{0,0,0}]',0,0,0,18,20,0,0,0,18041101,0,12,99999,2,0,0,0,'[]',0,0,1,0,'[]','[]',501002,0,0,1),(18041102,'难大师碎片','集齐<color=#4eae1a>10</color>个碎片，在【合成】中合成，即可激活星灵外观·难大师','',7584,'【运营活动】','[{0,0,0}]',0,0,0,18,20,0,0,0,18041102,0,12,99999,2,0,0,0,'[]',0,0,1,0,'[]','[]',501002,0,0,0),(18041103,'代号09碎片','集齐<color=#4eae1a>10</color>个碎片，在【合成】中合成，即可激活星灵外观·代号09','',7586,'【运营活动】','[{0,0,0}]',0,0,0,18,20,0,0,0,18041103,0,12,99999,2,0,0,0,'[]',0,0,1,0,'[]','[]',501002,0,0,1),(18041104,'修罗虎碎片','集齐<color=#4eae1a>10</color>个碎片，在【合成】中合成，即可激活星灵外观·修罗虎','',7576,'【运营活动】','[{0,0,0}]',0,0,0,18,20,0,0,0,18041104,0,12,99999,2,0,0,0,'[]',0,0,1,0,'[]','[]',501002,0,0,0),(18041105,'暗影忍者碎片','集齐<color=#4eae1a>10</color>个碎片，在【合成】中合成，即可激活星灵外观·暗影忍者','',7593,'【运营活动】','[{0,0,0}]',0,0,0,18,20,0,0,0,18041105,0,12,99999,2,0,0,0,'[]',0,0,1,0,'[]','[]',501002,0,0,0),(18050101,'攻击之灵·星','星灵被动技能书，效果：星灵攻击属性提升150点','',0,'【星界试炼】','',0,0,0,18,5,0,0,0,18050101,0,12,99999,1,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18050201,'破甲之灵·星','星灵被动技能书，效果：星灵破甲属性提升120点','',0,'【星界试炼】','',0,0,0,18,5,0,0,0,18050201,0,12,99999,1,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18050301,'防御之灵·星','星灵被动技能书，效果：星灵防御属性提升120点','',0,'【星界试炼】','',0,0,0,18,5,0,0,0,18050301,0,12,99999,1,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18050401,'命中之灵·星','星灵被动技能书，效果：星灵命中属性提升60点','',0,'【星界试炼】','',0,0,0,18,5,0,0,0,18050401,0,12,99999,1,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18050501,'闪避之灵·星','星灵被动技能书，效果：星灵闪避属性提升60点','',0,'【星界试炼】','',0,0,0,18,5,0,0,0,18050501,0,12,99999,1,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18050601,'暴击之灵·星','星灵被动技能书，效果：星灵暴击属性提升60点','',0,'【星界试炼】','',0,0,0,18,5,0,0,0,18050601,0,12,99999,1,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18050701,'韧性之灵·星','星灵被动技能书，效果：星灵韧性属性提升60点','',0,'【星界试炼】','',0,0,0,18,5,0,0,0,18050701,0,12,99999,1,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18050801,'攻击之心·星','星灵被动技能书，效果：星灵攻击属性提升2.5%,同时增加150点攻击','',0,'【星界试炼】','',0,0,0,18,5,0,0,0,18050801,0,12,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18050901,'破甲之心·星','星灵被动技能书，效果：星灵破甲属性提升2.5%,同时增加120点破甲','',0,'【星界试炼,运营活动】','',0,0,0,18,5,0,0,0,18050901,0,12,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18051001,'防御之心·星','星灵被动技能书，效果：星灵防御属性提升2.5%,同时增加120点防御','',0,'【星界试炼】','',0,0,0,18,5,0,0,0,18051001,0,12,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18051101,'命中之心·星','星灵被动技能书，效果：星灵命中属性提升2.5%,同时增加60点命中','',0,'【星界试炼】','',0,0,0,18,5,0,0,0,18051101,0,12,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18051201,'闪避之心·星','星灵被动技能书，效果：星灵闪避属性提升2.5%,同时增加60点闪避','',0,'【星界试炼】','',0,0,0,18,5,0,0,0,18051201,0,12,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18051301,'暴击之心·星','星灵被动技能书，效果：星灵暴击属性提升2.5%,同时增加60点暴击','',0,'【星界试炼】','',0,0,0,18,5,0,0,0,18051301,0,12,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18051401,'韧性之心·星','星灵被动技能书，效果：星灵韧性属性提升2.5%,同时增加60点韧性','',0,'【星界试炼】','',0,0,0,18,5,0,0,0,18051401,0,12,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18051501,'治疗之心·星','星灵被动技能书，效果：星灵的治疗效果+4%','',0,'【星界试炼】','',0,0,0,18,5,0,0,0,18051501,0,12,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18051601,'自愈之心·星','星灵被动技能书，效果：星灵被治疗效果+4%','',0,'【星界试炼】','',0,0,0,18,5,0,0,0,18051601,0,12,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18051701,'攻击之魂·战','星灵被动技能书，效果：出战时，所有出战星灵攻击属性提升2.5%,同时增加180点攻击','',0,'【星界试炼】','',0,0,0,18,5,0,0,0,18051701,0,12,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18051801,'破甲之魂·战','星灵被动技能书，效果：出战时，所有出战星灵破甲属性提升2.5%,同时增加144点破甲','',0,'【星界试炼】','',0,0,0,18,5,0,0,0,18051801,0,12,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18051901,'防御之魂·战','星灵被动技能书，效果：出战时，所有出战星灵防御属性提升2.5%,同时增加144点防御','',0,'【星界试炼】','',0,0,0,18,5,0,0,0,18051901,0,12,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18052001,'命中之魂·战','星灵被动技能书，效果：出战时，所有出战星灵命中属性提升2.5%,同时增加72点命中','',0,'【星界试炼】','',0,0,0,18,5,0,0,0,18052001,0,12,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18052101,'闪避之魂·战','星灵被动技能书，效果：出战时，所有出战星灵闪避属性提升2.5%,同时增加72点闪避','',0,'【星界试炼】','',0,0,0,18,5,0,0,0,18052101,0,12,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18052201,'暴击之魂·战','星灵被动技能书，效果：出战时，所有出战星灵暴击属性提升2.5%,同时增加72点暴击','',0,'【星界试炼】','',0,0,0,18,5,0,0,0,18052201,0,12,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18052301,'韧性之魂·战','星灵被动技能书，效果：出战时，所有出战星灵韧性属性提升2.5%,同时增加72点韧性','',0,'【星界试炼】','',0,0,0,18,5,0,0,0,18052301,0,12,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18052401,'攻击神魂·主','星灵被动技能书，效果：出战时，提升主角攻击属性2%,同时增加240点攻击','',0,'【星界试炼】','',0,0,0,18,5,0,0,0,18052401,0,12,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18052501,'破甲神魂·主','星灵被动技能书，效果：出战时，提升主角破甲属性2%,同时增加192点破甲','',0,'【星界试炼】','',0,0,0,18,5,0,0,0,18052501,0,12,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18052601,'防御神魂·主','星灵被动技能书，效果：出战时，提升主角防御属性2%,同时增加192点防御','',0,'【星界试炼】','',0,0,0,18,5,0,0,0,18052601,0,12,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18052701,'命中神魂·主','星灵被动技能书，效果：出战时，提升主角命中属性2%,同时增加96点命中','',0,'【星界试炼】','',0,0,0,18,5,0,0,0,18052701,0,12,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18052801,'闪避神魂·主','星灵被动技能书，效果：出战时，提升主角闪避属性2%,同时增加96点闪避','',0,'【星界试炼】','',0,0,0,18,5,0,0,0,18052801,0,12,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18052901,'暴击神魂·主','星灵被动技能书，效果：出战时，提升主角暴击属性2%,同时增加96点暴击','',0,'【星界试炼】','',0,0,0,18,5,0,0,0,18052901,0,12,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18053001,'韧性神魂·主','星灵被动技能书，效果：出战时，提升主角韧性属性2%,同时增加96点韧性','',0,'【星界试炼】','',0,0,0,18,5,0,0,0,18053001,0,12,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18053101,'技伤神魂·主','星灵被动技能书，效果：出战时，提升主角技能伤害2.8%','',0,'【星界试炼】','',0,0,0,18,5,0,0,0,18053101,0,12,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18053201,'技免神魂·主','星灵被动技能书，效果：出战时，提升主角技能伤害减免2.8%','',0,'【星界试炼】','',0,0,0,18,5,0,0,0,18053201,0,12,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18053301,'伤害神魂·主','星灵被动技能书，效果：出战时，提升主角伤害加成2.4%','',0,'【星界试炼】','',0,0,0,18,5,0,0,0,18053301,0,12,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18053401,'减伤神魂·主','星灵被动技能书，效果：出战时，提升主角伤害减免2.4%','',0,'【星界试炼】','',0,0,0,18,5,0,0,0,18053401,0,12,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18053501,'自愈神魂·主','星灵被动技能书，效果：出战时，提升主角被治疗效果3%','',0,'【星界试炼】','',0,0,0,18,5,0,0,0,18053501,0,12,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18053601,'护身之灵','星灵被动技能书，效果：身上有负面状态时，提升伤害减免4%','',0,'【星界试炼】','',0,0,0,18,5,0,0,0,18053601,0,12,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18053701,'大地之护','星灵被动技能书，效果：身上有负面状态时，提升防御值4%','',0,'【星界试炼】','',0,0,0,18,5,0,0,0,18053701,0,12,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18053801,'岩石之甲','星灵被动技能书，效果：身上有负面状态时，提升技能伤害减免4%','',0,'【星界试炼】','',0,0,0,18,5,0,0,0,18053801,0,12,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18053901,'森林之心','星灵被动技能书，效果：身上有负面状态时，受治疗效果提升5%','',0,'【星界试炼】','',0,0,0,18,5,0,0,0,18053901,0,12,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18054001,'寒灵之触','星灵被动技能书，效果：攻击眩晕目标时，伤害提升4%','',0,'【星界试炼】','',0,0,0,18,5,0,0,0,18054001,0,12,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18054101,'奥术之光','星灵被动技能书，效果：攻击沉默目标时，技能伤害提升4%','',0,'【星界试炼】','',0,0,0,18,5,0,0,0,18054101,0,12,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18054201,'专注之眼','星灵被动技能书，效果：攻击禁锢目标时，破甲提升4%','',0,'【星界试炼】','',0,0,0,18,5,0,0,0,18054201,0,12,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18054301,'治愈之魂','星灵被动技能书，效果：血量低于10%时，立刻回血15%，CD80s','',0,'【星界试炼】','',0,0,0,18,5,0,0,0,18054301,0,12,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18054401,'圣水印记','星灵被动技能书，效果：血量低于20%时，触发回血效果，每秒回血3%，持续5s,CD80s','',0,'【星界试炼,运营活动】','',0,0,0,18,5,0,0,0,18054401,0,12,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18054501,'复生之魂','星灵被动技能书，效果：受到致死伤害时，免疫该次伤害，并立即回血8%，并在后续的3s内累计回血12%，CD90s','',0,'【星界试炼】','',0,0,0,18,5,0,0,0,18054501,0,12,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18054601,'致命之魂','星灵被动技能书，效果：攻击时，有6.5%直接扣除目标8%的生命值，CD60s','',0,'【星界试炼】','',0,0,0,18,5,0,0,0,18054601,0,12,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18054701,'生命之灵·星','星灵被动技能书，效果：星灵生命属性提升3000点','',0,'【星界试炼】','',0,0,0,18,5,0,0,0,18054701,0,12,99999,1,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18054801,'生命之心·星','星灵被动技能书，效果：星灵生命属性提升2.5%,同时增加3000点生命','',0,'【星界试炼】','',0,0,0,18,5,0,0,0,18054801,0,12,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18060001,'通用学习笔记','用于提升星灵技能等级，可以获得20点技能经验','',0,'【星界试炼,运营活动】','',0,0,0,18,5,1,0,0,18060001,0,12,99999,0,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18060002,'通用学习手册','用于提升星灵技能等级，可以获得40点技能经验','',0,'【星界试炼,运营活动】','',0,0,0,18,5,1,0,0,18060002,0,12,99999,1,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18060003,'通用学习宝典','用于提升星灵技能等级，可以获得60点技能经验','',0,'【星界试炼,运营活动】','',0,0,0,18,5,1,0,0,18060003,0,12,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',501002,0,0,1),(18071001,'[初学]星愿羽毛笔','蓝色武器【星灵-普通】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18071001,0,1,0,1,0,0,0,'[]',0,0,0,0,'[{1,250},{5,100}]','[]',0,0,0,0),(18071002,'[初学]星愿羽毛笔','蓝色+1武器【星灵-普通】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18071001,0,1,0,1,0,0,0,'[]',0,0,1,0,'[{1,375},{5,150}]','[]',0,0,0,0),(18071003,'[初学]星愿羽毛笔','蓝色+2武器【星灵-普通】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18071001,0,1,0,1,0,0,0,'[]',0,0,1,0,'[{1,500},{5,200}]','[]',0,0,0,0),(18071004,'[初学]星愿羽毛笔','紫色武器【星灵-普通】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18071001,0,1,0,2,0,0,0,'[]',0,0,1,0,'[{1,625},{5,250}]','[]',0,0,0,0),(18071005,'[初学]星愿羽毛笔','紫色+1武器【星灵-普通】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18071001,0,1,0,2,0,0,0,'[]',0,0,1,0,'[{1,750},{5,300}]','[]',0,0,0,0),(18071006,'[初学]星愿羽毛笔','紫色+2武器【星灵-普通】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18071001,0,1,0,2,0,0,0,'[]',0,0,1,0,'[{1,875},{5,350}]','[]',0,0,0,0),(18071007,'[初学]星愿羽毛笔','橙色武器【星灵-普通】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18071001,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{1,1000},{5,400}]','[]',0,0,0,0),(18071008,'[初学]星愿羽毛笔','橙色+1武器【星灵-普通】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18071001,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{1,1125},{5,450}]','[]',0,0,0,0),(18071009,'[初学]星愿羽毛笔','橙色+2武器【星灵-普通】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18071001,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{1,1250},{5,500}]','[]',0,0,0,0),(18071010,'[初学]星愿羽毛笔','橙色+3武器【星灵-普通】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18071001,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{1,1375},{5,550}]','[]',0,0,0,0),(18071011,'[初学]星愿羽毛笔','红色武器【星灵-普通】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18071001,0,1,0,4,0,0,0,'[]',0,0,0,0,'[{1,1500},{5,600}]','[]',0,0,0,0),(18071101,'[精锐]星语之誓','蓝色武器【星灵-珍贵】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18071101,0,1,0,1,0,0,0,'[]',0,0,0,0,'[{1,800},{5,320}]','[]',0,0,0,0),(18071102,'[精锐]星语之誓','蓝色+1武器【星灵-珍贵】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18071101,0,1,0,1,0,0,0,'[]',0,0,1,0,'[{1,1000},{5,400}]','[]',0,0,0,0),(18071103,'[精锐]星语之誓','蓝色+2武器【星灵-珍贵】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18071101,0,1,0,1,0,0,0,'[]',0,0,1,0,'[{1,1200},{5,480}]','[]',0,0,0,0),(18071104,'[精锐]星语之誓','紫色武器【星灵-珍贵】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18071101,0,1,0,2,0,0,0,'[]',0,0,1,0,'[{1,1400},{5,560}]','[]',0,0,0,0),(18071105,'[精锐]星语之誓','紫色+1武器【星灵-珍贵】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18071101,0,1,0,2,0,0,0,'[]',0,0,1,0,'[{1,1600},{5,640}]','[]',0,0,0,0),(18071106,'[精锐]星语之誓','紫色+2武器【星灵-珍贵】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18071101,0,1,0,2,0,0,0,'[]',0,0,1,0,'[{1,1800},{5,720}]','[]',0,0,0,0),(18071107,'[精锐]星语之誓','橙色武器【星灵-珍贵】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18071101,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{1,2000},{5,800}]','[]',0,0,0,0),(18071108,'[精锐]星语之誓','橙色+1武器【星灵-珍贵】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18071101,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{1,2200},{5,880}]','[]',0,0,0,0),(18071109,'[精锐]星语之誓','橙色+2武器【星灵-珍贵】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18071101,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{1,2400},{5,960}]','[]',0,0,0,0),(18071110,'[精锐]星语之誓','橙色+3武器【星灵-珍贵】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18071101,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{1,2600},{5,1040}]','[]',0,0,0,0),(18071111,'[精锐]星语之誓','红色武器【星灵-珍贵】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18071101,0,1,0,4,0,0,0,'[]',0,0,0,0,'[{1,2800},{5,1120}]','[]',0,0,0,0),(18071201,'[勇者]星芒之书','蓝色武器【星灵-稀有】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18071201,0,1,0,1,0,0,0,'[]',0,0,0,0,'[{1,1650},{5,660}]','[]',0,0,0,0),(18071202,'[勇者]星芒之书','蓝色+1武器【星灵-稀有】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18071201,0,1,0,1,0,0,0,'[]',0,0,1,0,'[{1,1900},{5,760}]','[]',0,0,0,0),(18071203,'[勇者]星芒之书','蓝色+2武器【星灵-稀有】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18071201,0,1,0,1,0,0,0,'[]',0,0,1,0,'[{1,2150},{5,860}]','[]',0,0,0,0),(18071204,'[勇者]星芒之书','紫色武器【星灵-稀有】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18071201,0,1,0,2,0,0,0,'[]',0,0,1,0,'[{1,2400},{5,960}]','[]',0,0,0,0),(18071205,'[勇者]星芒之书','紫色+1武器【星灵-稀有】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18071201,0,1,0,2,0,0,0,'[]',0,0,1,0,'[{1,2650},{5,1060}]','[]',0,0,0,0),(18071206,'[勇者]星芒之书','紫色+2武器【星灵-稀有】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18071201,0,1,0,2,0,0,0,'[]',0,0,1,0,'[{1,2900},{5,1160}]','[]',0,0,0,0),(18071207,'[勇者]星芒之书','橙色武器【星灵-稀有】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18071201,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{1,3150},{5,1260}]','[]',0,0,0,0),(18071208,'[勇者]星芒之书','橙色+1武器【星灵-稀有】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18071201,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{1,3400},{5,1360}]','[]',0,0,0,0),(18071209,'[勇者]星芒之书','橙色+2武器【星灵-稀有】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18071201,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{1,3650},{5,1460}]','[]',0,0,0,0),(18071210,'[勇者]星芒之书','橙色+3武器【星灵-稀有】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18071201,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{1,3900},{5,1560}]','[]',0,0,0,0),(18071211,'[勇者]星芒之书','红色武器【星灵-稀有】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18071201,0,1,0,4,0,0,0,'[]',0,0,0,0,'[{1,4150},{5,1660}]','[]',0,0,0,0),(18071301,'[领主]星曜法杖','蓝色武器【星灵-传奇】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18071301,0,1,0,1,0,0,0,'[]',0,0,0,0,'[{1,2900},{5,1160}]','[]',0,0,0,0),(18071302,'[领主]星曜法杖','蓝色+1武器【星灵-传奇】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18071301,0,1,0,1,0,0,0,'[]',0,0,1,0,'[{1,3200},{5,1280}]','[]',0,0,0,0),(18071303,'[领主]星曜法杖','蓝色+2武器【星灵-传奇】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18071301,0,1,0,1,0,0,0,'[]',0,0,1,0,'[{1,3500},{5,1400}]','[]',0,0,0,0),(18071304,'[领主]星曜法杖','紫色武器【星灵-传奇】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18071301,0,1,0,2,0,0,0,'[]',0,0,1,0,'[{1,3800},{5,1520}]','[]',0,0,0,0),(18071305,'[领主]星曜法杖','紫色+1武器【星灵-传奇】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18071301,0,1,0,2,0,0,0,'[]',0,0,1,0,'[{1,4100},{5,1640}]','[]',0,0,0,0),(18071306,'[领主]星曜法杖','紫色+2武器【星灵-传奇】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18071301,0,1,0,2,0,0,0,'[]',0,0,1,0,'[{1,4400},{5,1760}]','[]',0,0,0,0),(18071307,'[领主]星曜法杖','橙色武器【星灵-传奇】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18071301,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{1,4700},{5,1880}]','[]',0,0,0,0),(18071308,'[领主]星曜法杖','橙色+1武器【星灵-传奇】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18071301,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{1,5000},{5,2000}]','[]',0,0,0,0),(18071309,'[领主]星曜法杖','橙色+2武器【星灵-传奇】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18071301,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{1,5300},{5,2120}]','[]',0,0,0,0),(18071310,'[领主]星曜法杖','橙色+3武器【星灵-传奇】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18071301,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{1,5600},{5,2240}]','[]',0,0,0,0),(18071311,'[领主]星曜法杖','红色武器【星灵-传奇】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18071301,0,1,0,4,0,0,0,'[]',0,0,0,0,'[{1,5900},{5,2360}]','[]',0,0,0,0),(18072001,'[初学]星愿礼服','蓝色头盔【星灵-普通】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18072001,0,1,0,1,0,0,0,'[]',0,0,0,0,'[{2,5000},{6,100}]','[]',0,0,0,0),(18072002,'[初学]星愿礼服','蓝色+1头盔【星灵-普通】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18072001,0,1,0,1,0,0,0,'[]',0,0,1,0,'[{2,7500},{6,150}]','[]',0,0,0,0),(18072003,'[初学]星愿礼服','蓝色+2头盔【星灵-普通】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18072001,0,1,0,1,0,0,0,'[]',0,0,1,0,'[{2,10000},{6,200}]','[]',0,0,0,0),(18072004,'[初学]星愿礼服','紫色头盔【星灵-普通】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18072001,0,1,0,2,0,0,0,'[]',0,0,1,0,'[{2,12500},{6,250}]','[]',0,0,0,0),(18072005,'[初学]星愿礼服','紫色+1头盔【星灵-普通】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18072001,0,1,0,2,0,0,0,'[]',0,0,1,0,'[{2,15000},{6,300}]','[]',0,0,0,0),(18072006,'[初学]星愿礼服','紫色+2头盔【星灵-普通】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18072001,0,1,0,2,0,0,0,'[]',0,0,1,0,'[{2,17500},{6,350}]','[]',0,0,0,0),(18072007,'[初学]星愿礼服','橙色头盔【星灵-普通】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18072001,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{2,20000},{6,400}]','[]',0,0,0,0),(18072008,'[初学]星愿礼服','橙色+1头盔【星灵-普通】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18072001,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{2,22500},{6,450}]','[]',0,0,0,0),(18072009,'[初学]星愿礼服','橙色+2头盔【星灵-普通】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18072001,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{2,25000},{6,500}]','[]',0,0,0,0),(18072010,'[初学]星愿礼服','橙色+3头盔【星灵-普通】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18072001,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{2,27500},{6,550}]','[]',0,0,0,0),(18072011,'[初学]星愿礼服','红色头盔【星灵-普通】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18072001,0,1,0,4,0,0,0,'[]',0,0,0,0,'[{2,30000},{6,600}]','[]',0,0,0,0),(18072101,'[精锐]星语礼服','蓝色头盔【星灵-珍贵】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18072101,0,1,0,1,0,0,0,'[]',0,0,0,0,'[{2,16000},{6,320}]','[]',0,0,0,0),(18072102,'[精锐]星语礼服','蓝色+1头盔【星灵-珍贵】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18072101,0,1,0,1,0,0,0,'[]',0,0,1,0,'[{2,20000},{6,400}]','[]',0,0,0,0),(18072103,'[精锐]星语礼服','蓝色+2头盔【星灵-珍贵】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18072101,0,1,0,1,0,0,0,'[]',0,0,1,0,'[{2,24000},{6,480}]','[]',0,0,0,0),(18072104,'[精锐]星语礼服','紫色头盔【星灵-珍贵】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18072101,0,1,0,2,0,0,0,'[]',0,0,1,0,'[{2,28000},{6,560}]','[]',0,0,0,0),(18072105,'[精锐]星语礼服','紫色+1头盔【星灵-珍贵】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18072101,0,1,0,2,0,0,0,'[]',0,0,1,0,'[{2,32000},{6,640}]','[]',0,0,0,0),(18072106,'[精锐]星语礼服','紫色+2头盔【星灵-珍贵】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18072101,0,1,0,2,0,0,0,'[]',0,0,1,0,'[{2,36000},{6,720}]','[]',0,0,0,0),(18072107,'[精锐]星语礼服','橙色头盔【星灵-珍贵】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18072101,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{2,40000},{6,800}]','[]',0,0,0,0),(18072108,'[精锐]星语礼服','橙色+1头盔【星灵-珍贵】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18072101,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{2,44000},{6,880}]','[]',0,0,0,0),(18072109,'[精锐]星语礼服','橙色+2头盔【星灵-珍贵】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18072101,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{2,48000},{6,960}]','[]',0,0,0,0),(18072110,'[精锐]星语礼服','橙色+3头盔【星灵-珍贵】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18072101,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{2,52000},{6,1040}]','[]',0,0,0,0),(18072111,'[精锐]星语礼服','红色头盔【星灵-珍贵】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18072101,0,1,0,4,0,0,0,'[]',0,0,0,0,'[{2,56000},{6,1120}]','[]',0,0,0,0),(18072201,'[勇者]星芒礼服','蓝色头盔【星灵-稀有】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18072201,0,1,0,1,0,0,0,'[]',0,0,0,0,'[{2,33000},{6,660}]','[]',0,0,0,0),(18072202,'[勇者]星芒礼服','蓝色+1头盔【星灵-稀有】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18072201,0,1,0,1,0,0,0,'[]',0,0,1,0,'[{2,38000},{6,760}]','[]',0,0,0,0),(18072203,'[勇者]星芒礼服','蓝色+2头盔【星灵-稀有】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18072201,0,1,0,1,0,0,0,'[]',0,0,1,0,'[{2,43000},{6,860}]','[]',0,0,0,0),(18072204,'[勇者]星芒礼服','紫色头盔【星灵-稀有】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18072201,0,1,0,2,0,0,0,'[]',0,0,1,0,'[{2,48000},{6,960}]','[]',0,0,0,0),(18072205,'[勇者]星芒礼服','紫色+1头盔【星灵-稀有】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18072201,0,1,0,2,0,0,0,'[]',0,0,1,0,'[{2,53000},{6,1060}]','[]',0,0,0,0),(18072206,'[勇者]星芒礼服','紫色+2头盔【星灵-稀有】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18072201,0,1,0,2,0,0,0,'[]',0,0,1,0,'[{2,58000},{6,1160}]','[]',0,0,0,0),(18072207,'[勇者]星芒礼服','橙色头盔【星灵-稀有】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18072201,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{2,63000},{6,1260}]','[]',0,0,0,0),(18072208,'[勇者]星芒礼服','橙色+1头盔【星灵-稀有】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18072201,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{2,68000},{6,1360}]','[]',0,0,0,0),(18072209,'[勇者]星芒礼服','橙色+2头盔【星灵-稀有】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18072201,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{2,73000},{6,1460}]','[]',0,0,0,0),(18072210,'[勇者]星芒礼服','橙色+3头盔【星灵-稀有】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18072201,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{2,78000},{6,1560}]','[]',0,0,0,0),(18072211,'[勇者]星芒礼服','红色头盔【星灵-稀有】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18072201,0,1,0,4,0,0,0,'[]',0,0,0,0,'[{2,83000},{6,1660}]','[]',0,0,0,0),(18072301,'[领主]星曜礼服','蓝色头盔【星灵-传奇】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18072301,0,1,0,1,0,0,0,'[]',0,0,0,0,'[{2,58000},{6,1160}]','[]',0,0,0,0),(18072302,'[领主]星曜礼服','蓝色+1头盔【星灵-传奇】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18072301,0,1,0,1,0,0,0,'[]',0,0,1,0,'[{2,64000},{6,1280}]','[]',0,0,0,0),(18072303,'[领主]星曜礼服','蓝色+2头盔【星灵-传奇】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18072301,0,1,0,1,0,0,0,'[]',0,0,1,0,'[{2,70000},{6,1400}]','[]',0,0,0,0),(18072304,'[领主]星曜礼服','紫色头盔【星灵-传奇】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18072301,0,1,0,2,0,0,0,'[]',0,0,1,0,'[{2,76000},{6,1520}]','[]',0,0,0,0),(18072305,'[领主]星曜礼服','紫色+1头盔【星灵-传奇】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18072301,0,1,0,2,0,0,0,'[]',0,0,1,0,'[{2,82000},{6,1640}]','[]',0,0,0,0),(18072306,'[领主]星曜礼服','紫色+2头盔【星灵-传奇】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18072301,0,1,0,2,0,0,0,'[]',0,0,1,0,'[{2,88000},{6,1760}]','[]',0,0,0,0),(18072307,'[领主]星曜礼服','橙色头盔【星灵-传奇】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18072301,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{2,94000},{6,1880}]','[]',0,0,0,0),(18072308,'[领主]星曜礼服','橙色+1头盔【星灵-传奇】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18072301,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{2,100000},{6,2000}]','[]',0,0,0,0),(18072309,'[领主]星曜礼服','橙色+2头盔【星灵-传奇】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18072301,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{2,106000},{6,2120}]','[]',0,0,0,0),(18072310,'[领主]星曜礼服','橙色+3头盔【星灵-传奇】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18072301,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{2,112000},{6,2240}]','[]',0,0,0,0),(18072311,'[领主]星曜礼服','红色头盔【星灵-传奇】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18072301,0,1,0,4,0,0,0,'[]',0,0,0,0,'[{2,118000},{6,2360}]','[]',0,0,0,0),(18073001,'[初学]星愿记事本','蓝色戒指【星灵-普通】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18073001,0,1,0,1,0,0,0,'[]',0,0,0,0,'[{3,200},{7,100}]','[]',0,0,0,0),(18073002,'[初学]星愿记事本','蓝色+1戒指【星灵-普通】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18073001,0,1,0,1,0,0,0,'[]',0,0,1,0,'[{3,300},{7,150}]','[]',0,0,0,0),(18073003,'[初学]星愿记事本','蓝色+2戒指【星灵-普通】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18073001,0,1,0,1,0,0,0,'[]',0,0,1,0,'[{3,400},{7,200}]','[]',0,0,0,0),(18073004,'[初学]星愿记事本','紫色戒指【星灵-普通】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18073001,0,1,0,2,0,0,0,'[]',0,0,1,0,'[{3,500},{7,250}]','[]',0,0,0,0),(18073005,'[初学]星愿记事本','紫色+1戒指【星灵-普通】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18073001,0,1,0,2,0,0,0,'[]',0,0,1,0,'[{3,600},{7,300}]','[]',0,0,0,0),(18073006,'[初学]星愿记事本','紫色+2戒指【星灵-普通】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18073001,0,1,0,2,0,0,0,'[]',0,0,1,0,'[{3,700},{7,350}]','[]',0,0,0,0),(18073007,'[初学]星愿记事本','橙色戒指【星灵-普通】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18073001,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{3,800},{7,400}]','[]',0,0,0,0),(18073008,'[初学]星愿记事本','橙色+1戒指【星灵-普通】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18073001,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{3,900},{7,450}]','[]',0,0,0,0),(18073009,'[初学]星愿记事本','橙色+2戒指【星灵-普通】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18073001,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{3,1000},{7,500}]','[]',0,0,0,0),(18073010,'[初学]星愿记事本','橙色+3戒指【星灵-普通】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18073001,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{3,1100},{7,550}]','[]',0,0,0,0),(18073011,'[初学]星愿记事本','红色戒指【星灵-普通】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18073001,0,1,0,4,0,0,0,'[]',0,0,0,0,'[{3,1200},{7,600}]','[]',0,0,0,0),(18073101,'[精锐]星语宝石','蓝色戒指【星灵-珍贵】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18073101,0,1,0,1,0,0,0,'[]',0,0,0,0,'[{3,640},{7,320}]','[]',0,0,0,0),(18073102,'[精锐]星语宝石','蓝色+1戒指【星灵-珍贵】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18073101,0,1,0,1,0,0,0,'[]',0,0,1,0,'[{3,800},{7,400}]','[]',0,0,0,0),(18073103,'[精锐]星语宝石','蓝色+2戒指【星灵-珍贵】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18073101,0,1,0,1,0,0,0,'[]',0,0,1,0,'[{3,960},{7,480}]','[]',0,0,0,0),(18073104,'[精锐]星语宝石','紫色戒指【星灵-珍贵】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18073101,0,1,0,2,0,0,0,'[]',0,0,1,0,'[{3,1120},{7,560}]','[]',0,0,0,0),(18073105,'[精锐]星语宝石','紫色+1戒指【星灵-珍贵】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18073101,0,1,0,2,0,0,0,'[]',0,0,1,0,'[{3,1280},{7,640}]','[]',0,0,0,0),(18073106,'[精锐]星语宝石','紫色+2戒指【星灵-珍贵】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18073101,0,1,0,2,0,0,0,'[]',0,0,1,0,'[{3,1440},{7,720}]','[]',0,0,0,0),(18073107,'[精锐]星语宝石','橙色戒指【星灵-珍贵】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18073101,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{3,1600},{7,800}]','[]',0,0,0,0),(18073108,'[精锐]星语宝石','橙色+1戒指【星灵-珍贵】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18073101,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{3,1760},{7,880}]','[]',0,0,0,0),(18073109,'[精锐]星语宝石','橙色+2戒指【星灵-珍贵】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18073101,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{3,1920},{7,960}]','[]',0,0,0,0),(18073110,'[精锐]星语宝石','橙色+3戒指【星灵-珍贵】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18073101,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{3,2080},{7,1040}]','[]',0,0,0,0),(18073111,'[精锐]星语宝石','红色戒指【星灵-珍贵】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18073101,0,1,0,4,0,0,0,'[]',0,0,0,0,'[{3,2240},{7,1120}]','[]',0,0,0,0),(18073201,'[勇者]星芒匕首','蓝色戒指【星灵-稀有】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18073201,0,1,0,1,0,0,0,'[]',0,0,0,0,'[{3,1320},{7,660}]','[]',0,0,0,0),(18073202,'[勇者]星芒匕首','蓝色+1戒指【星灵-稀有】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18073201,0,1,0,1,0,0,0,'[]',0,0,1,0,'[{3,1520},{7,760}]','[]',0,0,0,0),(18073203,'[勇者]星芒匕首','蓝色+2戒指【星灵-稀有】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18073201,0,1,0,1,0,0,0,'[]',0,0,1,0,'[{3,1720},{7,860}]','[]',0,0,0,0),(18073204,'[勇者]星芒匕首','紫色戒指【星灵-稀有】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18073201,0,1,0,2,0,0,0,'[]',0,0,1,0,'[{3,1920},{7,960}]','[]',0,0,0,0),(18073205,'[勇者]星芒匕首','紫色+1戒指【星灵-稀有】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18073201,0,1,0,2,0,0,0,'[]',0,0,1,0,'[{3,2120},{7,1060}]','[]',0,0,0,0),(18073206,'[勇者]星芒匕首','紫色+2戒指【星灵-稀有】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18073201,0,1,0,2,0,0,0,'[]',0,0,1,0,'[{3,2320},{7,1160}]','[]',0,0,0,0),(18073207,'[勇者]星芒匕首','橙色戒指【星灵-稀有】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18073201,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{3,2520},{7,1260}]','[]',0,0,0,0),(18073208,'[勇者]星芒匕首','橙色+1戒指【星灵-稀有】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18073201,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{3,2720},{7,1360}]','[]',0,0,0,0),(18073209,'[勇者]星芒匕首','橙色+2戒指【星灵-稀有】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18073201,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{3,2920},{7,1460}]','[]',0,0,0,0),(18073210,'[勇者]星芒匕首','橙色+3戒指【星灵-稀有】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18073201,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{3,3120},{7,1560}]','[]',0,0,0,0),(18073211,'[勇者]星芒匕首','红色戒指【星灵-稀有】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18073201,0,1,0,4,0,0,0,'[]',0,0,0,0,'[{3,3320},{7,1660}]','[]',0,0,0,0),(18073301,'[领主]星曜罗盘','蓝色戒指【星灵-传奇】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18073301,0,1,0,1,0,0,0,'[]',0,0,0,0,'[{3,2320},{7,1160}]','[]',0,0,0,0),(18073302,'[领主]星曜罗盘','蓝色+1戒指【星灵-传奇】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18073301,0,1,0,1,0,0,0,'[]',0,0,1,0,'[{3,2560},{7,1280}]','[]',0,0,0,0),(18073303,'[领主]星曜罗盘','蓝色+2戒指【星灵-传奇】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18073301,0,1,0,1,0,0,0,'[]',0,0,1,0,'[{3,2800},{7,1400}]','[]',0,0,0,0),(18073304,'[领主]星曜罗盘','紫色戒指【星灵-传奇】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18073301,0,1,0,2,0,0,0,'[]',0,0,1,0,'[{3,3040},{7,1520}]','[]',0,0,0,0),(18073305,'[领主]星曜罗盘','紫色+1戒指【星灵-传奇】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18073301,0,1,0,2,0,0,0,'[]',0,0,1,0,'[{3,3280},{7,1640}]','[]',0,0,0,0),(18073306,'[领主]星曜罗盘','紫色+2戒指【星灵-传奇】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18073301,0,1,0,2,0,0,0,'[]',0,0,1,0,'[{3,3520},{7,1760}]','[]',0,0,0,0),(18073307,'[领主]星曜罗盘','橙色戒指【星灵-传奇】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18073301,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{3,3760},{7,1880}]','[]',0,0,0,0),(18073308,'[领主]星曜罗盘','橙色+1戒指【星灵-传奇】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18073301,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{3,4000},{7,2000}]','[]',0,0,0,0),(18073309,'[领主]星曜罗盘','橙色+2戒指【星灵-传奇】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18073301,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{3,4240},{7,2120}]','[]',0,0,0,0),(18073310,'[领主]星曜罗盘','橙色+3戒指【星灵-传奇】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18073301,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{3,4480},{7,2240}]','[]',0,0,0,0),(18073311,'[领主]星曜罗盘','红色戒指【星灵-传奇】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18073301,0,1,0,4,0,0,0,'[]',0,0,0,0,'[{3,4720},{7,2360}]','[]',0,0,0,0),(18074001,'[初学]星愿之靴','蓝色护腕【星灵-普通】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18074001,0,1,0,1,0,0,0,'[]',0,0,0,0,'[{4,200},{8,100}]','[]',0,0,0,0),(18074002,'[初学]星愿之靴','蓝色+1护腕【星灵-普通】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18074001,0,1,0,1,0,0,0,'[]',0,0,1,0,'[{4,300},{8,150}]','[]',0,0,0,0),(18074003,'[初学]星愿之靴','蓝色+2护腕【星灵-普通】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18074001,0,1,0,1,0,0,0,'[]',0,0,1,0,'[{4,400},{8,200}]','[]',0,0,0,0),(18074004,'[初学]星愿之靴','紫色护腕【星灵-普通】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18074001,0,1,0,2,0,0,0,'[]',0,0,1,0,'[{4,500},{8,250}]','[]',0,0,0,0),(18074005,'[初学]星愿之靴','紫色+1护腕【星灵-普通】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18074001,0,1,0,2,0,0,0,'[]',0,0,1,0,'[{4,600},{8,300}]','[]',0,0,0,0),(18074006,'[初学]星愿之靴','紫色+2护腕【星灵-普通】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18074001,0,1,0,2,0,0,0,'[]',0,0,1,0,'[{4,700},{8,350}]','[]',0,0,0,0),(18074007,'[初学]星愿之靴','橙色护腕【星灵-普通】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18074001,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{4,800},{8,400}]','[]',0,0,0,0),(18074008,'[初学]星愿之靴','橙色+1护腕【星灵-普通】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18074001,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{4,900},{8,450}]','[]',0,0,0,0),(18074009,'[初学]星愿之靴','橙色+2护腕【星灵-普通】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18074001,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{4,1000},{8,500}]','[]',0,0,0,0),(18074010,'[初学]星愿之靴','橙色+3护腕【星灵-普通】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18074001,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{4,1100},{8,550}]','[]',0,0,0,0),(18074011,'[初学]星愿之靴','红色护腕【星灵-普通】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18074001,0,1,0,4,0,0,0,'[]',0,0,0,0,'[{4,1200},{8,600}]','[]',0,0,0,0),(18074101,'[精锐]星语短靴','蓝色护腕【星灵-珍贵】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18074101,0,1,0,1,0,0,0,'[]',0,0,0,0,'[{4,640},{8,320}]','[]',0,0,0,0),(18074102,'[精锐]星语短靴','蓝色+1护腕【星灵-珍贵】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18074101,0,1,0,1,0,0,0,'[]',0,0,1,0,'[{4,800},{8,400}]','[]',0,0,0,0),(18074103,'[精锐]星语短靴','蓝色+2护腕【星灵-珍贵】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18074101,0,1,0,1,0,0,0,'[]',0,0,1,0,'[{4,960},{8,480}]','[]',0,0,0,0),(18074104,'[精锐]星语短靴','紫色护腕【星灵-珍贵】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18074101,0,1,0,2,0,0,0,'[]',0,0,1,0,'[{4,1120},{8,560}]','[]',0,0,0,0),(18074105,'[精锐]星语短靴','紫色+1护腕【星灵-珍贵】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18074101,0,1,0,2,0,0,0,'[]',0,0,1,0,'[{4,1280},{8,640}]','[]',0,0,0,0),(18074106,'[精锐]星语短靴','紫色+2护腕【星灵-珍贵】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18074101,0,1,0,2,0,0,0,'[]',0,0,1,0,'[{4,1440},{8,720}]','[]',0,0,0,0),(18074107,'[精锐]星语短靴','橙色护腕【星灵-珍贵】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18074101,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{4,1600},{8,800}]','[]',0,0,0,0),(18074108,'[精锐]星语短靴','橙色+1护腕【星灵-珍贵】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18074101,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{4,1760},{8,880}]','[]',0,0,0,0),(18074109,'[精锐]星语短靴','橙色+2护腕【星灵-珍贵】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18074101,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{4,1920},{8,960}]','[]',0,0,0,0),(18074110,'[精锐]星语短靴','橙色+3护腕【星灵-珍贵】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18074101,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{4,2080},{8,1040}]','[]',0,0,0,0),(18074111,'[精锐]星语短靴','红色护腕【星灵-珍贵】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18074101,0,1,0,4,0,0,0,'[]',0,0,0,0,'[{4,2240},{8,1120}]','[]',0,0,0,0),(18074201,'[勇者]星芒布靴','蓝色护腕【星灵-稀有】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18074201,0,1,0,1,0,0,0,'[]',0,0,0,0,'[{4,1320},{8,660}]','[]',0,0,0,0),(18074202,'[勇者]星芒布靴','蓝色+1护腕【星灵-稀有】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18074201,0,1,0,1,0,0,0,'[]',0,0,1,0,'[{4,1520},{8,760}]','[]',0,0,0,0),(18074203,'[勇者]星芒布靴','蓝色+2护腕【星灵-稀有】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18074201,0,1,0,1,0,0,0,'[]',0,0,1,0,'[{4,1720},{8,860}]','[]',0,0,0,0),(18074204,'[勇者]星芒布靴','紫色护腕【星灵-稀有】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18074201,0,1,0,2,0,0,0,'[]',0,0,1,0,'[{4,1920},{8,960}]','[]',0,0,0,0),(18074205,'[勇者]星芒布靴','紫色+1护腕【星灵-稀有】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18074201,0,1,0,2,0,0,0,'[]',0,0,1,0,'[{4,2120},{8,1060}]','[]',0,0,0,0),(18074206,'[勇者]星芒布靴','紫色+2护腕【星灵-稀有】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18074201,0,1,0,2,0,0,0,'[]',0,0,1,0,'[{4,2320},{8,1160}]','[]',0,0,0,0),(18074207,'[勇者]星芒布靴','橙色护腕【星灵-稀有】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18074201,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{4,2520},{8,1260}]','[]',0,0,0,0),(18074208,'[勇者]星芒布靴','橙色+1护腕【星灵-稀有】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18074201,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{4,2720},{8,1360}]','[]',0,0,0,0),(18074209,'[勇者]星芒布靴','橙色+2护腕【星灵-稀有】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18074201,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{4,2920},{8,1460}]','[]',0,0,0,0),(18074210,'[勇者]星芒布靴','橙色+3护腕【星灵-稀有】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18074201,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{4,3120},{8,1560}]','[]',0,0,0,0),(18074211,'[勇者]星芒布靴','红色护腕【星灵-稀有】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18074201,0,1,0,4,0,0,0,'[]',0,0,0,0,'[{4,3320},{8,1660}]','[]',0,0,0,0),(18074301,'[领主]星曜长靴','蓝色护腕【星灵-传奇】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18074301,0,1,0,1,0,0,0,'[]',0,0,0,0,'[{4,2320},{8,1160}]','[]',0,0,0,0),(18074302,'[领主]星曜长靴','蓝色+1护腕【星灵-传奇】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18074301,0,1,0,1,0,0,0,'[]',0,0,1,0,'[{4,2560},{8,1280}]','[]',0,0,0,0),(18074303,'[领主]星曜长靴','蓝色+2护腕【星灵-传奇】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18074301,0,1,0,1,0,0,0,'[]',0,0,1,0,'[{4,2800},{8,1400}]','[]',0,0,0,0),(18074304,'[领主]星曜长靴','紫色护腕【星灵-传奇】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18074301,0,1,0,2,0,0,0,'[]',0,0,1,0,'[{4,3040},{8,1520}]','[]',0,0,0,0),(18074305,'[领主]星曜长靴','紫色+1护腕【星灵-传奇】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18074301,0,1,0,2,0,0,0,'[]',0,0,1,0,'[{4,3280},{8,1640}]','[]',0,0,0,0),(18074306,'[领主]星曜长靴','紫色+2护腕【星灵-传奇】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18074301,0,1,0,2,0,0,0,'[]',0,0,1,0,'[{4,3520},{8,1760}]','[]',0,0,0,0),(18074307,'[领主]星曜长靴','橙色护腕【星灵-传奇】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18074301,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{4,3760},{8,1880}]','[]',0,0,0,0),(18074308,'[领主]星曜长靴','橙色+1护腕【星灵-传奇】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18074301,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{4,4000},{8,2000}]','[]',0,0,0,0),(18074309,'[领主]星曜长靴','橙色+2护腕【星灵-传奇】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18074301,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{4,4240},{8,2120}]','[]',0,0,0,0),(18074310,'[领主]星曜长靴','橙色+3护腕【星灵-传奇】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18074301,0,1,0,3,0,0,0,'[]',0,0,1,0,'[{4,4480},{8,2240}]','[]',0,0,0,0),(18074311,'[领主]星曜长靴','红色护腕【星灵-传奇】','',0,'【星灵争霸】','',0,0,1,18,7,0,0,0,18074301,0,1,0,4,0,0,0,'[]',0,0,0,0,'[{4,4720},{8,2360}]','[]',0,0,0,0),(18190001,'普通星陨','星灵装备成长材料','',0,'【星空之门】','[{0,0,0}]',0,0,0,18,19,1,0,0,18190001,0,12,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(18190002,'珍贵星陨','星灵装备成长材料','',0,'【星空之门】','[{0,0,0}]',0,0,0,18,19,1,0,0,18190002,0,12,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(18190003,'稀有星陨','星灵装备成长材料','',0,'【星空之门】','[{0,0,0}]',0,0,0,18,19,1,0,0,18190003,0,12,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(18190004,'传奇星陨','星灵装备成长材料','',0,'【星空之门】','[{0,0,0}]',0,0,0,18,19,1,0,0,18190004,0,12,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(19010001,'铭文·重击','可用于激活重击铭文，提升技能伤害，满级伤害加成高达<color=#4eae1a>62%！</color>','',0,'【拍卖行】','[{11,1,1}]',0,0,0,19,1,1,0,0,19010001,1,50,999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(19010002,'铭文·割裂','可用于激活割裂铭文，对敌人造成流血伤害，满级后每秒造成<color=#4eae1a>技能基础伤害*48%的</color>额外伤害','',0,'【拍卖行】','[{11,1,1}]',0,0,0,19,1,0,0,0,19010002,1,50,999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(19010003,'铭文·刺伤','可用于激活刺伤铭文，提升技能伤害，满级伤害加成高达<color=#4eae1a>77%！</color>','',0,'【拍卖行】','[{11,1,1}]',0,0,0,19,1,0,0,0,19010003,1,50,999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(19010004,'铭文·泥沼','可用于激活泥沼铭文，增加技能的强力效果，满级后<color=#4eae1a>25%</color>的概率降低目标<color=#4eae1a>30%</color>的移速','',0,'【拍卖行】','[{11,1,1}]',0,0,0,19,1,0,0,0,19010004,1,50,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(19010005,'铭文·暴怒','可用于激活暴怒铭文，提升技能伤害，满级伤害加成高达<color=#4eae1a>91%！</color>','',0,'【拍卖行】','[{11,1,1}]',0,0,0,19,1,0,0,0,19010005,1,50,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(19010006,'铭文·震慑','可用于激活震慑铭文，增加技能强力效果，满级后攻击有<color=#4eae1a>25%</color>的概率降低对方<color=#4eae1a>25%</color>的防御','',0,'【拍卖行】','[{11,1,1}]',0,0,0,19,1,0,0,0,19010006,1,50,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(19010007,'铭文·斩痕','可用于激活斩痕铭文，提升技能伤害，满级伤害加成高达<color=#4eae1a>173%！</color>','',0,'【拍卖行】','[{11,1,1}]',0,0,0,19,1,0,0,0,19010007,1,50,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(19010008,'铭文·空震','可用于激活空震铭文，增加技能强力效果，满级后攻击敌人时，有<color=#4eae1a>30%</color>概率眩晕敌人<color=#4eae1a>2</color>秒','',0,'【拍卖行】','[{11,1,1}]',0,0,0,19,1,0,0,0,19010008,1,50,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(19010011,'铭文·翔击','可用于激活翔击铭文，提升技能伤害，满级伤害加成高达<color=#4eae1a>58%！</color>','',0,'【拍卖行】','[{11,1,1}]',0,0,0,19,1,0,0,0,19010011,2,50,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(19010012,'铭文·龙吼','可用于激活龙吼铭文，增加技能强力效果，满级后攻击有<color=#4eae1a>25%</color>的概率提高自身<color=#4eae1a>25%</color>的攻击','',0,'【拍卖行】','[{11,1,1}]',0,0,0,19,1,0,0,0,19010012,2,50,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(19010013,'铭文·光击','可用于激活光击铭文，提升技能伤害，满级伤害加成高达<color=#4eae1a>163%！</color>','',0,'【拍卖行】','[{11,1,1}]',0,0,0,19,1,0,0,0,19010013,2,50,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(19010014,'铭文·流沙','可用于激活流沙铭文，增加技能强力效果，满级后有<color=#4eae1a>25%</color>的概率降低目标<color=#4eae1a>30%</color>的移速','',0,'【拍卖行】','[{11,1,1}]',0,0,0,19,1,0,0,0,19010014,2,50,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(19010015,'铭文·龙息','可用于激活龙息铭文，提升技能伤害，满级伤害加成高达<color=#4eae1a>106%！</color>','',0,'【拍卖行】','[{11,1,1}]',0,0,0,19,1,0,0,0,19010015,2,50,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(19010016,'铭文·电疗','可用于激活电疗铭文，对敌人造成流血伤害，满级后每秒造成<color=#4eae1a>技能基础伤害*48%的</color>额外伤害','',0,'【拍卖行】','[{11,1,1}]',0,0,0,19,1,0,0,0,19010016,2,50,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(19010017,'铭文·龙怒','可用于激活龙怒铭文，提升技能伤害，满级伤害加成高达<color=#4eae1a>163%！</color>','',0,'【拍卖行】','[{11,1,1}]',0,0,0,19,1,0,0,0,19010017,2,50,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(19010018,'铭文·天罚','可用于激活天罚铭文，增加技能强力效果，满级后攻击敌人时，有<color=#4eae1a>30%</color>概率眩晕敌人<color=#4eae1a>2</color>秒','',0,'【拍卖行】','[{11,1,1}]',0,0,0,19,1,0,0,0,19010018,2,50,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(19010021,'铭文·怒','可用于激活怒之铭文','',0,'【拍卖行】','[{11,1,1}]',0,0,0,19,1,0,0,0,19010021,0,50,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(19010022,'铭文·风','可用于激活风之铭文','',0,'【拍卖行】','[{11,1,1}]',0,0,0,19,1,0,0,0,19010022,0,50,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(19010023,'铭文·雷','可用于激活雷之铭文','',0,'【拍卖行】','[{11,1,1}]',0,0,0,19,1,0,0,0,19010023,0,50,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(19010024,'铭文·电','可用于激活电之铭文','',0,'【拍卖行】','[{11,1,1}]',0,0,0,19,1,0,0,0,19010024,0,50,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(19010025,'铭文·金','可用于激活金之铭文','',0,'【拍卖行】','[{11,1,1}]',0,0,0,19,1,0,0,0,19010025,0,50,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(19010026,'铭文·魂','可用于激活魂之铭文','',0,'【拍卖行】','[{11,1,1}]',0,0,0,19,1,0,0,0,19010026,0,50,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(19010027,'铭文·暗','可用于激活暗之铭文','',0,'【拍卖行】','[{11,1,1}]',0,0,0,19,1,0,0,0,19010027,0,50,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(19010028,'铭文·氪','可用于激活氪之铭文','',0,'【拍卖行】','[{11,1,1}]',0,0,0,19,1,0,0,0,19010028,0,50,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(19010031,'铭文·怒焰','可用于激活怒焰铭文，提升技能伤害，满级伤害加成高达<color=#4eae1a>72%！</color>','',0,'【拍卖行】','[{11,1,1}]',0,0,0,19,1,0,0,0,19010031,4,50,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(19010032,'铭文·致盲','可用于激活致盲铭文，增加技能强力效果，满级候攻击有<color=#4eae1a>25%</color>的概率降低目标<color=#4eae1a>25%</color>的命中','',0,'【拍卖行】','[{11,1,1}]',0,0,0,19,1,0,0,0,19010032,4,50,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(19010033,'铭文·聚能','可用于激活聚能铭文，提升技能伤害，满级伤害加成高达<color=#4eae1a>96%！</color>','',0,'【拍卖行】','[{11,1,1}]',0,0,0,19,1,0,0,0,19010033,4,50,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(19010034,'铭文·泯灭','可用于激活泯灭铭文，对敌人造成流血伤害，满级后每秒造成<color=#4eae1a>技能基础伤害*48%的</color>额外伤害','',0,'【拍卖行】','[{11,1,1}]',0,0,0,19,1,0,0,0,19010034,4,50,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(19010035,'铭文·磁暴','可用于激活磁暴铭文，提升技能伤害，满级伤害加成高达<color=#4eae1a>139%！</color>','',0,'【拍卖行】','[{11,1,1}]',0,0,0,19,1,0,0,0,19010035,4,50,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(19010036,'铭文·旋涡','可用于激活旋涡铭文，增加技能强力效果，满级后有<color=#4eae1a>25%</color>的概率降低目标<color=#4eae1a>30%</color>的移速','',0,'【拍卖行】','[{11,1,1}]',0,0,0,19,1,0,0,0,19010036,4,50,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(19010037,'铭文·弹幕','可用于激活弹幕铭文，提升技能伤害，满级伤害加成高达<color=#4eae1a>163%！</color>','',0,'【拍卖行】','[{11,1,1}]',0,0,0,19,1,0,0,0,19010037,4,50,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(19010038,'铭文·核爆','可用于激活核爆铭文，增加技能强力效果，满级后攻击敌人时，有<color=#4eae1a>30%</color>概率眩晕敌人<color=#4eae1a>2</color>秒','',0,'【拍卖行】','[{11,1,1}]',0,0,0,19,1,0,0,0,19010038,4,50,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(20010011,'暗裔之翼','暗裔之翼\\n装备后立即获得','攻击  +1120,生命  +22400,暴伤值  +720',66400,'【翅膀合成】','[{161,1,1}]',0,1,0,20,1,2,1,0,20010011,1,40,0,3,0,0,0,'[{1,200}]',0,0,0,0,'[{1,1120},{2,22400},{48,720}]','[]',401001,0,0,1),(20010012,'暗影魔翼','暗影魔翼\\n装备后立即获得','攻击  +2800,生命  +56000,暴伤值  +1800',166000,'【翅膀合成】','[{161,1,1}]',0,1,0,20,1,2,1,0,20010012,1,40,0,3,0,0,0,'[{1,1000}]',0,0,0,0,'[{1,2800},{2,56000},{48,1800}]','[]',401002,0,0,1),(20010013,'断罪之翼','断罪之翼\\n装备后立即获得','攻击  +4480,生命  +89600,暴伤值  +2880,会心一击%  +150',415600,'【翅膀合成,vip礼包】','[{161,1,1},{450,1,1}]',0,1,0,20,1,2,1,0,20010013,1,40,0,4,0,0,0,'[{1,4000}]',0,0,0,0,'[{1,4480},{2,89600},{48,2880},{54,150}]','[]',401003,0,0,1),(20010014,'幽冥魔魂','幽冥魔魂\\n装备后立即获得','攻击  +12600,生命  +252000,暴伤值  +8100,会心一击  +300%',1047000,'【翅膀合成】','[{161,1,1}]',0,1,0,20,1,2,1,0,20010014,1,40,0,4,0,0,0,'[{1,8000}]',0,0,0,0,'[{1,12600},{2,252000},{48,8100},{54,300}]','[]',401004,0,0,1),(20010015,'余烬狱火','余烬狱火\\n装备后立即获得','攻击  +25200,生命  +504000,暴伤值  +16200,会心一击  +500%',1994000,'【翅膀合成】','[{161,1,1}]',0,1,0,20,1,2,1,0,20010015,1,40,0,5,0,0,0,'[{1,100000}]',0,0,0,0,'[{1,25200},{2,504000},{48,16200},{54,500}]','[]',401005,0,0,1),(20010016,'灾厄龙神','灾厄龙神\\n装备后立即获得','攻击  +42000,生命  +840000,暴伤值  +27000,会心一击  +800%',3290000,'【翅膀合成】','[{161,1,1}]',0,1,0,20,1,2,1,0,20010016,1,40,0,5,0,0,0,'[{1,900000}]',0,0,0,0,'[{1,42000},{2,840000},{48,27000},{54,800}]','[]',401006,0,0,1),(20010021,'光明之翼','光明之翼\\n装备后立即获得','攻击  +1120,生命  +22400,暴伤值  +720',66400,'【翅膀合成】','[{161,1,1}]',0,1,0,20,1,2,1,0,20010021,2,40,0,3,0,0,0,'[{1,200}]',0,0,0,0,'[{1,1120},{2,22400},{48,720}]','[]',402001,0,0,1),(20010022,'流光天羽','流光天羽\\n装备后立即获得','攻击  +2800,生命  +56000,暴伤值  +1800',166000,'【翅膀合成】','[{161,1,1}]',0,1,0,20,1,2,1,0,20010022,2,40,0,3,0,0,0,'[{1,1000}]',0,0,0,0,'[{1,2800},{2,56000},{48,1800}]','[]',402002,0,0,1),(20010023,'裁决锋羽','裁决锋羽\\n装备后立即获得','攻击  +4480,生命  +89600,暴伤值  +2880,会心一击  +150%',415600,'【翅膀合成,vip礼包】','[{161,1,1},{450,1,1}]',0,1,0,20,1,2,1,0,20010023,2,40,0,4,0,0,0,'[{1,4000}]',0,0,0,0,'[{1,4480},{2,89600},{48,2880},{54,150}]','[]',402003,0,0,1),(20010024,'天国余晖','天国余晖\\n装备后立即获得','攻击  +12600,生命  +252000,暴伤值  +8100,会心一击  +300%',1047000,'【翅膀合成】','[{161,1,1}]',0,1,0,20,1,2,1,0,20010024,2,40,0,4,0,0,0,'[{1,8000}]',0,0,0,0,'[{1,12600},{2,252000},{48,8100},{54,300}]','[]',402004,0,0,1),(20010025,'涅槃火凤','涅槃火凤\\n装备后立即获得','攻击  +25200,生命  +504000,暴伤值  +16200,会心一击  +500%',1994000,'【翅膀合成】','[{161,1,1}]',0,1,0,20,1,2,1,0,20010025,2,40,0,5,0,0,0,'[{1,100000}]',0,0,0,0,'[{1,25200},{2,504000},{48,16200},{54,500}]','[]',402005,0,0,1),(20010026,'圣晶天翼','圣晶天翼\\n装备后立即获得','攻击  +42000,生命  +840000,暴伤值  +27000,会心一击  +800%',3290000,'【翅膀合成】','[{161,1,1}]',0,1,0,20,1,2,1,0,20010026,2,40,0,5,0,0,0,'[{1,900000}]',0,0,0,0,'[{1,42000},{2,840000},{48,27000},{54,800}]','[]',402006,0,0,1),(20010031,'精灵之翼','精灵之翼\\n装备后立即获得','攻击  +1120,生命  +22400,暴伤值  +720',66400,'【翅膀合成】','[{161,1,1}]',0,1,0,20,1,0,0,0,20030003,3,40,0,3,0,0,0,'[{1,200}]',0,0,0,0,'[{1,1120},{2,22400},{48,720}]','[]',402003,0,0,1),(20010032,'丛林之翼','丛林之翼\\n装备后立即获得','攻击  +2800,生命  +56000,暴伤值  +1800',166000,'【翅膀合成】','[{161,1,1}]',0,1,0,20,1,0,0,0,20030006,3,40,0,3,0,0,0,'[{1,1000}]',0,0,0,0,'[{1,2800},{2,56000},{48,1800}]','[]',200004,0,0,1),(20010033,'上古之翼','上古之翼\\n装备后立即获得','攻击  +4480,生命  +89600,暴伤值  +2880,会心一击  +150%',415600,'【翅膀合成,vip礼包】','[{161,1,1},{450,1,1}]',0,1,0,20,1,0,0,0,20030001,3,40,0,4,0,0,0,'[{1,4000}]',0,0,0,0,'[{1,4480},{2,89600},{48,2880},{54,150}]','[]',200007,0,0,1),(20010034,'【魔导师】4阶翅膀','【魔导师】4阶翅膀\\n装备后立即获得','攻击  +12600,生命  +252000,暴伤值  +8100,会心一击  +300%',1047000,'【翅膀合成】','[{161,1,1}]',0,1,0,20,1,1,0,0,45010006,3,40,0,4,0,0,0,'[{1,8000}]',0,0,0,0,'[{1,12600},{2,252000},{48,8100},{54,300}]','[]',402001,0,0,1),(20010035,'【魔导师】5阶翅膀','【魔导师】5阶翅膀\\n装备后立即获得','攻击  +25200,生命  +504000,暴伤值  +16200,会心一击  +500%',1994000,'【翅膀合成】','[{161,1,1}]',0,1,0,20,1,1,0,0,45010105,3,40,0,5,0,0,0,'[{1,100000}]',0,0,0,0,'[{1,25200},{2,504000},{48,16200},{54,500}]','[]',200005,0,0,1),(20010036,'【魔导师】6阶翅膀','【魔导师】6阶翅膀\\n装备后立即获得','攻击  +42000,生命  +840000,暴伤值  +27000,会心一击  +800%',3290000,'【翅膀合成】','[{161,1,1}]',0,1,0,20,1,1,0,0,45010106,3,40,0,3,0,0,0,'[{1,900000}]',0,0,0,0,'[{1,42000},{2,840000},{48,27000},{54,800}]','[]',200008,0,0,1),(20010041,'零之使翼','零之使翼\\n装备后立即获得','攻击  +1120,生命  +22400,暴伤值  +720',66400,'【翅膀合成】','[{161,1,1}]',0,1,0,20,1,2,1,0,20010041,4,40,0,3,0,0,0,'[{1,200}]',0,0,0,0,'[{1,1120},{2,22400},{48,720}]','[]',404001,0,0,1),(20010042,'仿生蝶翼','仿生蝶翼\\n装备后立即获得','攻击  +2800,生命  +56000,暴伤值  +1800',166000,'【翅膀合成】','[{161,1,1}]',0,1,0,20,1,2,1,0,20010042,4,40,0,3,0,0,0,'[{1,1000}]',0,0,0,0,'[{1,2800},{2,56000},{48,1800}]','[]',404002,0,0,1),(20010043,'机械红莲','机械红莲\\n装备后立即获得','攻击  +4480,生命  +89600,暴伤值  +2880,会心一击  +150%',415600,'【翅膀合成,vip礼包】','[{161,1,1},{450,1,1}]',0,1,0,20,1,2,1,0,20010043,4,40,0,4,0,0,0,'[{1,4000}]',0,0,0,0,'[{1,4480},{2,89600},{48,2880},{54,150}]','[]',404003,0,0,1),(20010044,'机动突击','机动突击\\n装备后立即获得','攻击  +12600,生命  +252000,暴伤值  +8100,会心一击  +300%',1047000,'【翅膀合成】','[{161,1,1}]',0,1,0,20,1,2,1,0,20010044,4,40,0,4,0,0,0,'[{1,8000}]',0,0,0,0,'[{1,12600},{2,252000},{48,8100},{54,300}]','[]',404004,0,0,1),(20010045,'赛博科技','赛博科技\\n装备后立即获得','攻击  +25200,生命  +504000,暴伤值  +16200,会心一击  +500%',1994000,'【翅膀合成】','[{161,1,1}]',0,1,0,20,1,2,1,0,20010045,4,40,0,5,0,0,0,'[{1,100000}]',0,0,0,0,'[{1,25200},{2,504000},{48,16200},{54,500}]','[]',404005,0,0,1),(20010046,'机械纪元','机械纪元\\n装备后立即获得','攻击  +42000,生命  +840000,暴伤值  +27000,会心一击  +800%',3290000,'【翅膀合成】','[{161,1,1}]',0,1,0,20,1,2,1,0,20010046,4,40,0,5,0,0,0,'[{1,900000}]',0,0,0,0,'[{1,42000},{2,840000},{48,27000},{54,800}]','[]',404006,0,0,1),(20020001,'日羽源石','蕴含着神圣的气息，可以提升翅膀属性','生命  +1200,暴伤值  +25',1950,'【丛林突围,运营活动】','[{606,0,1}]',0,1,0,20,2,0,0,0,20020001,0,50,99999,2,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,1),(20020002,'暗羽源石','蕴含着神圣的气息，可以提升翅膀属性','攻击  +60,韧性  +16',2000,'【丛林突围,运营活动】','[{606,0,1}]',0,1,0,20,2,0,0,0,20020002,0,50,99999,2,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,1),(20020003,'圣羽源石','蕴含着神圣的气息，可以提升翅膀属性','韧性  +30,暴伤值  +50,翅膀生命  +0.5%',8000,'【丛林突围,运营活动】','[{606,0,1}]',0,1,0,20,2,0,0,0,20020003,0,50,99999,3,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,1),(20020004,'魔羽源石','蕴含着神圣的气息，可以提升翅膀属性','生命  +3600,攻击  +180,暴伤值  +75,翅膀攻击  +1%',9450,'【运营活动】','[{0,0,0}]',0,1,0,20,2,0,0,0,20020004,0,50,99999,4,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,1),(20030001,'战争光环','战争光环\\n激活立即获得\\n','攻击+750,生命+15000,爆伤值+188,翅膀攻击加成+1%,闪避率+1.1%',35640,'【运营活动】','[{0,0,0}]',0,1,0,20,3,0,0,0,20030001,0,40,0,4,0,0,0,'[{1,1}]',0,0,0,0,'[{1,1120},{2,22400},{48,720}]','[]',404001,0,0,1),(20030002,'夏日浪板','夏日浪板\\n激活立即获得\\n','攻击  +1120,生命  +22400,暴伤值  +720',66400,'【运营活动】','[{0,0,0}]',0,1,0,20,3,0,0,0,20030002,0,40,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{1,1120},{2,22400},{48,720}]','[]',404001,0,0,1),(20030003,'涂鸦浪板','涂鸦浪板\\n激活立即获得\\n','攻击+668,生命+13360,爆伤值+167,翅膀攻击加成+0.6%,韧性率+1%',31730,'【运营活动】','[{0,0,0}]',0,1,0,20,3,0,0,0,20030003,0,40,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{1,1120},{2,22400},{48,720}]','[]',404001,0,0,1),(20030004,'大白鲨浪板','大白鲨浪板\\n激活立即获得\\n','攻击  +1120,生命  +22400,暴伤值  +720',66400,'【运营活动】','[{0,0,0}]',0,1,0,20,3,0,0,0,20030004,0,40,0,4,0,0,0,'[{1,1}]',0,0,0,0,'[{1,1120},{2,22400},{48,720}]','[]',404001,0,0,1),(20030005,'未来浪板','未来浪板\\n激活立即获得\\n','攻击+290,生命+5800,爆伤值+73',13790,'【运营活动】','[{0,0,0}]',0,1,0,20,3,0,0,0,20030005,0,40,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{1,1120},{2,22400},{48,720}]','[]',404001,0,0,1),(20030006,'雷霆之主','雷霆之主\\n激活立即获得\\n','攻击+710,生命+14200,爆伤值+178,翅膀生命加成+0.6%,闪避率+1.2%',33760,'【运营活动】','[{0,0,0}]',0,1,0,20,3,0,0,0,20030006,0,40,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{1,1120},{2,22400},{48,720}]','[]',404001,0,0,1),(20030007,'海底世界','海底世界\\n激活立即获得\\n','攻击+1384,生命+27680,爆伤值+346,翅膀攻击加成+1%,伤害加成+1.8%',65760,'【运营活动】','[{0,0,0}]',0,1,0,20,3,0,0,0,20030007,0,40,0,4,0,0,0,'[{1,1}]',0,0,0,0,'[{1,1120},{2,22400},{48,720}]','[]',404001,0,0,1),(20030008,'幽影狼幡','幽影狼幡\\n激活立即获得\\n','攻击+710,生命+14200,爆伤值+178,翅膀攻击加成+0.6%,命中率+1.2%',33760,'【运营活动】','[{0,0,0}]',0,1,0,20,3,0,0,0,20030008,0,40,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{1,1120},{2,22400},{48,720}]','[]',404001,0,0,1),(20030009,'熊猫奇遇','熊猫奇遇\\n激活立即获得\\n','攻击+542,生命+10840,爆伤值+136,翅膀生命加成+0.8%,命中率+1.5%',25760,'【运营活动】','[{0,0,0}]',0,1,0,20,3,0,0,0,20030009,0,40,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{1,1120},{2,22400},{48,720}]','[]',404001,0,0,1),(20030010,'圣月罗盘','圣月罗盘\\n激活立即获得\\n','攻击+1552,生命+31040,爆伤值+388,翅膀生命加成+0%,伤害减免+1.8%',73760,'【运营活动】','[{0,0,0}]',0,1,0,20,3,0,0,0,20030010,0,40,0,4,0,0,0,'[{1,1}]',0,0,0,0,'[{1,1120},{2,22400},{48,720}]','[]',404001,0,0,1),(20030011,'长耳兔','长耳兔\\n激活立即获得\\n','攻击+1569,生命+31380,爆伤值+392,翅膀生命加成+1%,pve伤害+2.5%',74520,'【运营活动】','[{0,0,0}]',0,1,0,20,3,0,0,0,20030011,0,40,0,4,0,0,0,'[{1,1}]',0,0,0,0,'[{1,1120},{2,22400},{48,720}]','[]',404001,0,0,1),(20030012,'魔法黑猫','魔法黑猫\\n激活立即获得\\n','攻击+1582,生命+31640,爆伤值+396,翅膀生命加成+1%,pvp伤害+2.5%',75160,'【运营活动】','[{0,0,0}]',0,1,0,20,3,0,0,0,20030012,0,40,0,4,0,0,0,'[{1,1}]',0,0,0,0,'[{1,1120},{2,22400},{48,720}]','[]',404001,0,0,1),(20030013,'小熊鼓手','小熊鼓手\\n激活立即获得\\n','攻击+1594,生命+31880,爆伤值+399,翅膀攻击加成+1%,pvp伤害减免+2.5%',75730,'【运营活动】','[{0,0,0}]',0,1,0,20,3,0,0,0,20030013,0,40,0,4,0,0,0,'[{1,1}]',0,0,0,0,'[{1,1120},{2,22400},{48,720}]','[]',404001,0,0,1),(20030014,'马戏团柯基','马戏团柯基\\n激活立即获得\\n','攻击+710,生命+14200,爆伤值+178,翅膀攻击加成+0.6%,暴击率+1.2%',33760,'【运营活动】','[{0,0,0}]',0,1,0,20,3,0,0,0,20030014,0,40,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{1,1120},{2,22400},{48,720}]','[]',404001,0,0,1),(20030015,'蜜语花束','蜜语花束\\n激活立即获得\\n','攻击+710,生命+14200,爆伤值+178,翅膀生命加成+0.6%,韧性率+1.2%',33760,'【运营活动】','[{0,0,0}]',0,1,0,20,3,0,0,0,20030015,0,40,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{1,1120},{2,22400},{48,720}]','[]',404001,0,0,1),(20040000,'催化神石','高级翅膀的合成材料','',0,'【运营活动】','[{0,0,0}]',0,1,0,20,4,0,0,0,20040000,0,40,99999,4,0,0,0,'[{1,800}]',0,0,0,0,'[]','[]',0,0,0,1),(20040001,'轻盈之羽','1代翅膀的合成材料，激活翅膀后\\n<color=#4eae1a>攻击  +1120</color>\\n<color=#4eae1a>生命  +22400</color>\\n<color=#4eae1a>暴伤值  +720</color>\\n','',66400,'【首领boss,运营活动】','[{460,1,1},{460,2,0},{460,4,0}]',0,1,0,20,4,2,2,0,20040001,0,40,99999,3,0,0,0,'[{1,200}]',0,0,0,0,'[]','[]',0,0,0,1),(20040002,'迅疾之羽','2代翅膀的合成材料，激活翅膀后\\n<color=#4eae1a>攻击  +2800</color>\\n<color=#4eae1a>生命  +56000</color>\\n<color=#4eae1a>暴伤值  +1800</color>\\n','',166000,'【每日签到,首领boss】','[{460,1,1},{460,2,0},{460,4,0}]',0,1,0,20,4,2,2,0,20040002,0,40,99999,3,0,0,0,'[{1,350}]',0,0,0,0,'[]','[]',0,0,0,1),(20040003,'风驰之羽','3代翅膀的合成材料，激活翅膀后\\n<color=#4eae1a>攻击  +4480</color>\\n<color=#4eae1a>生命  +89600</color>\\n<color=#4eae1a>暴伤值  +2880</color>\\n<color=#4eae1a>会心一击  +1.5%</color>\\n','',415600,'【首领boss】','[{460,1,1},{460,2,0},{460,4,0}]',0,1,0,20,4,2,2,0,20040003,0,40,99999,4,0,0,0,'[{1,500}]',0,0,0,0,'[]','[]',0,0,0,1),(20040004,'飞掠之羽','4代翅膀的合成材料，激活翅膀后\\n<color=#4eae1a>攻击  +12600</color>\\n<color=#4eae1a>生命  +252000</color>\\n<color=#4eae1a>暴伤值  +8100</color>\\n<color=#4eae1a>会心一击  +3%</color>\\n','',1047000,'【首领boss】','[{460,1,1},{460,2,0},{460,4,0}]',0,1,0,20,4,2,2,0,20040004,0,40,99999,4,0,0,0,'[{1,800}]',0,0,0,0,'[]','[]',0,0,0,1),(20040005,'疾闪之羽','5代翅膀的合成材料，激活翅膀后\\n<color=#4eae1a>攻击  +25200</color>\\n<color=#4eae1a>生命  +504000</color>\\n<color=#4eae1a>暴伤值  +16200</color>\\n<color=#4eae1a>会心一击  +5%</color>\\n','',1994000,'【首领boss】','[{460,1,1},{460,2,0},{460,4,0}]',0,1,0,20,4,2,2,0,20040005,0,40,99999,5,0,0,0,'[{1,1000}]',0,0,0,0,'[]','[]',0,0,0,1),(20040006,'翔天之羽','6代翅膀的合成材料，激活翅膀后\\n<color=#4eae1a>攻击  +42000</color>\\n<color=#4eae1a>生命  +840000</color>\\n<color=#4eae1a>暴伤值  +27000</color>\\n<color=#4eae1a>会心一击  +8%</color>\\n','',3290000,'【首领boss】','[{460,1,1},{460,2,0},{460,4,0}]',0,1,0,20,4,2,2,0,20040006,0,40,99999,5,0,0,0,'[{1,1500}]',0,0,0,0,'[]','[]',0,0,0,1),(20041000,'催化神石碎片','可以合成催化神石','',0,'【首领boss】','[{460,1,1},{460,2,0},{460,4,0}]',0,1,0,20,4,0,0,0,20041000,0,40,99999,3,0,0,0,'[{1,80}]',0,0,0,0,'[]','[]',0,0,0,1),(20041001,'轻盈之羽碎片','轻盈之羽的合成材料','',0,'【首领boss】','[{460,1,1},{460,2,0},{460,4,0}]',0,1,0,20,4,0,0,0,20041001,0,40,99999,3,0,0,0,'[{1,20}]',0,0,0,0,'[]','[]',0,0,0,1),(20041002,'迅疾之羽碎片','迅疾之羽的合成材料','',0,'【首领boss】','[{460,1,1},{460,2,0},{460,4,0}]',0,1,0,20,4,0,0,0,20041002,0,40,99999,3,0,0,0,'[{1,35}]',0,0,0,0,'[]','[]',0,0,0,1),(20041003,'风驰之羽碎片','风驰之羽的合成材料','',0,'【首领boss】','[{460,1,1},{460,2,0},{460,4,0}]',0,1,0,20,4,0,0,0,20041003,0,40,99999,4,0,0,0,'[{1,50}]',0,0,0,0,'[]','[]',0,0,0,1),(20041004,'飞掠之羽碎片','飞掠之羽的合成材料','',0,'【首领boss】','[{460,1,1},{460,2,0},{460,4,0}]',0,1,0,20,4,0,0,0,20041004,0,40,99999,4,0,0,0,'[{1,80}]',0,0,0,0,'[]','[]',0,0,0,1),(20041005,'疾闪之羽碎片','疾闪之羽的合成材料','',0,'【首领boss】','[{460,1,1},{460,2,0},{460,4,0}]',0,1,0,20,4,0,0,0,20041005,0,40,99999,5,0,0,0,'[{1,100}]',0,0,0,0,'[]','[]',0,0,0,1),(20041006,'翔天之羽碎片','翔天之羽的合成材料','',0,'【首领boss】','[{460,1,1},{460,2,0},{460,4,0}]',0,1,0,20,4,0,0,0,20041006,0,40,99999,5,0,0,0,'[{1,150}]',0,0,0,0,'[]','[]',0,0,0,1),(20050001,'暗黑之翼限时','激活翅膀外观：暗黑之翼，在【翅膀】-【幻形】中使用。\\n激活立即获得\\n<color=#4eae1a>战力+40000</color>\\n<color=#4eae1a>攻击+1000</color>\\n<color=#4eae1a>气血+20000</color>\\n<color=#4eae1a>破甲+1000</color>\\n<color=#4eae1a>防御+1000</color>\\n<color=#4eae1a>破甲+1%</color>\\n\\n\\n后面更可通过<color=#4eae1a>培养获得更多战力</color>！','',40000,'【世界首领,个人首领】','[{0,0,0}]',0,1,0,20,5,0,0,0,20030008,0,40,1,4,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,1),(20050002,'恶魔之翼','恶魔之翼\\n激活立即获得\\n','攻击  +1120,生命  +22400,暴伤值  +720',66400,'【运营活动】','[{0,0,0}]',0,1,0,20,5,0,0,0,20010011,1,40,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{1,1120},{2,22400},{48,720}]','[]',401001,0,0,1),(20050003,'洁白之翼','洁白之翼\\n激活立即获得\\n','攻击  +1120,生命  +22400,暴伤值  +720',66400,'【运营活动】','[{0,0,0}]',0,1,0,20,5,0,0,0,20010021,2,40,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{1,1120},{2,22400},{48,720}]','[]',402001,0,0,1),(20050004,'精灵之翼','精灵之翼\\n激活立即获得\\n','攻击  +1120,生命  +22400,暴伤值  +720',66400,'【运营活动】','[{0,0,0}]',0,1,0,20,5,0,0,0,20010031,3,40,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{1,1120},{2,22400},{48,720}]','[]',403001,0,0,1),(20050005,'机械之翼','机械之翼\\n激活立即获得\\n','攻击  +1120,生命  +22400,暴伤值  +720',66400,'【运营活动】','[{0,0,0}]',0,1,0,20,5,0,0,0,20010041,4,40,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{1,1120},{2,22400},{48,720}]','[]',404001,0,0,1),(20060001,'初级羽翼纹章','用于翅膀精炼，提供10点精炼值','',0,'【首领boss,运营活动】','[{460,1,1},{0,0,0}]',0,1,0,20,6,0,0,0,20060002,0,40,99999,1,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,1),(20060002,'中级羽翼纹章','用于翅膀精炼，提供30点精炼值','',0,'【首领boss,运营活动】','[{460,1,1},{0,0,0}]',0,1,0,20,6,0,0,0,20060001,0,40,99999,2,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,1),(20060003,'高级羽翼纹章','用于翅膀精炼，提供100点精炼值','',0,'【首领boss,运营活动】','[{460,1,1},{0,0,0}]',0,1,0,20,6,0,0,0,20060003,0,40,99999,3,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,1),(20070001,'碎片·暗黑之翼','激活翅膀外观：暗黑之翼，在【翅膀】-【幻形】中使用。\\n激活立即获得\\n<color=#4eae1a>战力+40000</color>\\n<color=#4eae1a>攻击+1000</color>\\n<color=#4eae1a>气血+20000</color>\\n<color=#4eae1a>破甲+1000</color>\\n<color=#4eae1a>防御+1000</color>\\n<color=#4eae1a>破甲+1%</color>\\n\\n\\n后面更可通过<color=#4eae1a>培养获得更多战力</color>！','',40000,'【世界首领,个人首领】','[{0,0,0}]',0,1,0,20,7,0,0,0,20030008,0,40,99999,4,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,1),(20070002,'碎片·恶魔之翼','集齐<color=#4eae1a>30</color>个碎片，即可激活幻化翅膀·恶魔之翼\\n激活立即获得\\n','攻击  +1120,生命  +22400,暴伤值  +720',66400,'【运营活动】','[{0,0,0}]',0,1,0,20,7,0,0,0,20010011,1,40,99999,2,0,0,0,'[{1,1}]',0,0,0,0,'[{1,1120},{2,22400},{48,720}]','[]',401001,0,0,1),(20070003,'碎片·洁白之翼','集齐<color=#4eae1a>30</color>个碎片，即可激活幻化翅膀·洁白之翼\\n激活立即获得\\n','攻击  +1120,生命  +22400,暴伤值  +720',66400,'【运营活动】','[{0,0,0}]',0,1,0,20,7,0,0,0,20010021,2,40,99999,2,0,0,0,'[{1,1}]',0,0,0,0,'[{1,1120},{2,22400},{48,720}]','[]',402001,0,0,1),(20070004,'碎片·精灵之翼','集齐<color=#4eae1a>30</color>个碎片，即可激活幻化翅膀·精灵之翼\\n激活立即获得\\n','攻击  +1120,生命  +22400,暴伤值  +720',66400,'【运营活动】','[{0,0,0}]',0,1,0,20,7,0,0,0,20010031,3,40,99999,2,0,0,0,'[{1,1}]',0,0,0,0,'[{1,1120},{2,22400},{48,720}]','[]',403001,0,0,1),(20070005,'碎片·机械之翼','集齐<color=#4eae1a>30</color>个碎片，即可激活幻化翅膀·机械之翼\\n激活立即获得\\n','攻击  +1120,生命  +22400,暴伤值  +720',66400,'【运营活动】','[{0,0,0}]',0,1,0,20,7,0,0,0,20010041,4,40,99999,2,0,0,0,'[{1,1}]',0,0,0,0,'[{1,1120},{2,22400},{48,720}]','[]',404001,0,0,1),(20070006,'碎片·战争光环','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活幻化翅膀·战争光环\\n激活立即获得\\n','攻击+750,生命+15000,爆伤值+188,翅膀攻击加成+1%,闪避率+1.1%',35640,'【运营活动】','[{0,0,0}]',0,1,0,20,7,0,0,0,20070006,0,40,99999,4,0,0,0,'[{1,1}]',0,0,1,0,'[{1,1120},{2,22400},{48,720}]','[]',404001,0,0,0),(20070007,'碎片·夏日浪板','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活幻化翅膀·夏日浪板\\n激活立即获得\\n','攻击  +1120,生命  +22400,暴伤值  +720',66400,'【运营活动】','[{0,0,0}]',0,1,0,20,7,0,0,0,20070007,0,40,99999,3,0,0,0,'[{1,1}]',0,0,1,0,'[{1,1120},{2,22400},{48,720}]','[]',404001,0,0,0),(20070008,'碎片·涂鸦浪板','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活幻化翅膀·涂鸦浪板\\n激活立即获得\\n','攻击+668,生命+13360,爆伤值+167,翅膀攻击加成+0.6%,韧性率+1%',31730,'【运营活动】','[{0,0,0}]',0,1,0,20,7,0,0,0,20070008,0,40,99999,3,0,0,0,'[{1,1}]',0,0,1,0,'[{1,1120},{2,22400},{48,720}]','[]',404001,0,0,0),(20070009,'碎片·大白鲨浪板','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活幻化翅膀·大白鲨浪板\\n激活立即获得\\n','攻击  +1120,生命  +22400,暴伤值  +720',66400,'【运营活动】','[{0,0,0}]',0,1,0,20,7,0,0,0,20070009,0,40,99999,3,0,0,0,'[{1,1}]',0,0,1,0,'[{1,1120},{2,22400},{48,720}]','[]',404001,0,0,0),(20070010,'碎片·未来浪板','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活幻化翅膀·未来浪板\\n激活立即获得\\n','攻击+290,生命+5800,爆伤值+73',13790,'【运营活动】','[{0,0,0}]',0,1,0,20,7,0,0,0,20070010,0,40,99999,3,0,0,0,'[{1,1}]',0,0,1,0,'[{1,1120},{2,22400},{48,720}]','[]',404001,0,0,0),(20070011,'碎片·雷霆之主','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活幻化翅膀·雷霆之主\\n激活立即获得\\n','攻击+710,生命+14200,爆伤值+178,翅膀生命加成+0.6%,闪避率+1.2%',33760,'【运营活动】','[{0,0,0}]',0,1,0,20,7,0,0,0,20070011,0,40,99999,3,0,0,0,'[{1,1}]',0,0,1,0,'[{1,1120},{2,22400},{48,720}]','[]',404001,0,0,0),(20070012,'碎片·海底世界','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活幻化翅膀·海底世界\\n激活立即获得\\n','攻击+1384,生命+27680,爆伤值+346,翅膀攻击加成+1%,伤害加成+1.8%',65760,'【运营活动】','[{0,0,0}]',0,1,0,20,7,0,0,0,20070012,0,40,99999,3,0,0,0,'[{1,1}]',0,0,1,0,'[{1,1120},{2,22400},{48,720}]','[]',404001,0,0,0),(20070013,'碎片·幽影狼幡','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活幻化翅膀·幽影狼幡\\n激活立即获得\\n','攻击+710,生命+14200,爆伤值+178,翅膀攻击加成+0.6%,命中率+1.2%',33760,'【运营活动】','[{0,0,0}]',0,1,0,20,7,0,0,0,20070013,0,40,99999,3,0,0,0,'[{1,1}]',0,0,1,0,'[{1,1120},{2,22400},{48,720}]','[]',404001,0,0,0),(20070014,'碎片·熊猫奇遇','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活幻化翅膀·熊猫奇遇\\n激活立即获得\\n','攻击+542,生命+10840,爆伤值+136,翅膀生命加成+0.8%,命中率+1.5%',25760,'【运营活动】','[{0,0,0}]',0,1,0,20,7,0,0,0,20070014,0,40,99999,3,0,0,0,'[{1,1}]',0,0,1,0,'[{1,1120},{2,22400},{48,720}]','[]',404001,0,0,0),(20070015,'碎片·圣月罗盘','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活幻化翅膀·圣月罗盘\\n激活立即获得\\n','攻击+1552,生命+31040,爆伤值+388,翅膀生命加成+0%,伤害减免+1.8%',73760,'【运营活动】','[{0,0,0}]',0,1,0,20,7,0,0,0,20070015,0,40,99999,3,0,0,0,'[{1,1}]',0,0,1,0,'[{1,1120},{2,22400},{48,720}]','[]',404001,0,0,0),(20070016,'碎片·长耳兔','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活幻化翅膀·长耳兔\\n激活立即获得\\n','攻击+1569,生命+31380,爆伤值+392,翅膀生命加成+1%,pve伤害+2.5%',74520,'【运营活动】','[{0,0,0}]',0,1,0,20,7,0,0,0,20070016,0,40,99999,3,0,0,0,'[{1,1}]',0,0,1,0,'[{1,1120},{2,22400},{48,720}]','[]',404001,0,0,0),(20070017,'碎片·魔法黑猫','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活幻化翅膀·魔法黑猫\\n激活立即获得\\n','攻击+1582,生命+31640,爆伤值+396,翅膀生命加成+1%,pvp伤害+2.5%',75160,'【运营活动】','[{0,0,0}]',0,1,0,20,7,0,0,0,20070017,0,40,99999,3,0,0,0,'[{1,1}]',0,0,1,0,'[{1,1120},{2,22400},{48,720}]','[]',404001,0,0,0),(20070018,'碎片·小熊鼓手','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活幻化翅膀·小熊鼓手\\n激活立即获得\\n','攻击+1594,生命+31880,爆伤值+399,翅膀攻击加成+1%,pvp伤害减免+2.5%',75730,'【运营活动】','[{0,0,0}]',0,1,0,20,7,0,0,0,20070018,0,40,99999,3,0,0,0,'[{1,1}]',0,0,1,0,'[{1,1120},{2,22400},{48,720}]','[]',404001,0,0,0),(20070019,'碎片·马戏团柯基','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活幻化翅膀·马戏团柯基\\n激活立即获得\\n','攻击+710,生命+14200,爆伤值+178,翅膀攻击加成+0.6%,暴击率+1.2%',33760,'【运营活动】','[{0,0,0}]',0,1,0,20,7,0,0,0,20070019,0,40,99999,3,0,0,0,'[{1,1}]',0,0,1,0,'[{1,1120},{2,22400},{48,720}]','[]',404001,0,0,0),(20070020,'碎片·蜜语花束','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活幻化翅膀·蜜语花束\\n激活立即获得\\n','攻击+710,生命+14200,爆伤值+178,翅膀生命加成+0.6%,韧性率+1.2%',33760,'【运营活动】','[{0,0,0}]',0,1,0,20,7,0,0,0,20070020,0,40,99999,3,0,0,0,'[{1,1}]',0,0,1,0,'[{1,1120},{2,22400},{48,720}]','[]',404001,0,0,0),(21010101,'小马头冠星痕','小马星痕中的头盔星痕','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010201,0,0,0,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010102,'小马战甲星痕','星痕A2','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010202,0,0,0,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010103,'小犬下装星痕','星痕A3','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010203,0,0,0,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010104,'小犬战靴星痕','星痕A4','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010204,0,0,0,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010105,'蛇夫手套星痕','星痕A5','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010205,0,0,0,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010106,'蛇夫武器星痕','星痕A6','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010206,0,0,0,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010107,'蛇夫盾牌星痕','星痕A7','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010207,0,0,0,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010108,'鲸鱼项链星痕','星痕A8','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010208,0,0,0,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010109,'鲸鱼手镯星痕','星痕A9','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010209,0,0,0,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010110,'鲸鱼戒指星痕','星痕A10','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010210,0,0,0,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010201,'天坛头冠星痕','星痕B1','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010301,0,0,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010202,'天坛战甲星痕','星痕B2','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010302,0,0,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010203,'山案下装星痕','星痕B3','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010303,0,0,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010204,'山案战靴星痕','星痕B4','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010304,0,0,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010205,'绘架手套星痕','星痕B5','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010305,0,0,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010206,'绘架武器星痕','星痕B6','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010306,0,0,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010207,'绘架盾牌星痕','星痕B7','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010307,0,0,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010208,'天燕项链星痕','星痕B8','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010308,0,0,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010209,'天燕手镯星痕','星痕B9','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010309,0,0,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010210,'天燕戒指星痕','星痕B10','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010310,0,0,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010301,'飞鱼头冠星痕','星痕C1','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010301,0,0,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010302,'飞鱼战甲星痕','星痕C2','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010302,0,0,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010303,'飞鱼下装星痕','星痕C3','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010303,0,0,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010304,'飞鱼战靴星痕','星痕C4','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010304,0,0,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010305,'矩尺手套星痕','星痕C5','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010305,0,0,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010306,'矩尺武器星痕','星痕C6','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010306,0,0,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010307,'矩尺盾牌星痕','星痕C7','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010307,0,0,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010308,'矩尺项链星痕','星痕C8','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010308,0,0,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010309,'矩尺手镯星痕','星痕C9','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010309,0,0,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010310,'矩尺戒指星痕','星痕C10','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010310,0,0,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010401,'剑鱼头冠星痕','星痕D1','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010301,0,0,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010402,'剑鱼战甲星痕','星痕D2','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010302,0,0,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010403,'剑鱼下装星痕','星痕D3','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010303,0,0,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010404,'剑鱼战靴星痕','星痕D4','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010304,0,0,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010405,'孔雀手套星痕','星痕D5','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010305,0,0,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010406,'孔雀武器星痕','星痕D6','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010306,0,0,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010407,'孔雀盾牌星痕','星痕D7','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010307,0,0,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010408,'孔雀项链星痕','星痕D8','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010308,0,0,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010409,'孔雀手镯星痕','星痕D9','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010309,0,0,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010410,'孔雀戒指星痕','星痕D10','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010310,0,0,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010411,'剑鱼耳坠星痕','星痕D11','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010311,0,0,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010412,'剑鱼圣痕星痕','星痕D12','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010312,0,0,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010501,'鹿豹头冠星痕','星痕E1','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010401,0,0,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010502,'蝎虎战甲星痕','星痕E2','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010402,0,0,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010503,'仙女下装星痕','星痕E3','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010403,0,0,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010504,'鹿豹战靴星痕','星痕E4','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010404,0,0,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010505,'蝎虎手套星痕','星痕E5','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010405,0,0,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010506,'蝎虎武器星痕','星痕E6','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010406,0,0,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010507,'蝎虎盾牌星痕','星痕E7','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010407,0,0,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010508,'仙女项链星痕','星痕E8','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010408,0,0,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010509,'仙女手镯星痕','星痕E9','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010409,0,0,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010510,'仙女戒指星痕','星痕E10','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010410,0,0,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010511,'鹿豹耳坠星痕','星痕E11','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010411,0,0,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010512,'鹿豹圣痕星痕','星痕E12','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010412,0,0,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010601,'御夫头冠星痕','星痕F1','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010401,0,0,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010602,'御夫战甲星痕','星痕F2','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010402,0,0,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010603,'御夫下装星痕','星痕F3','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010403,0,0,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010604,'御夫战靴星痕','星痕F4','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010404,0,0,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010605,'猎犬手套星痕','星痕F5','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010405,0,0,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010606,'猎犬武器星痕','星痕F6','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010406,0,0,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010607,'猎犬盾牌星痕','星痕F7','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010407,0,0,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010608,'猎犬项链星痕','星痕F8','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010408,0,0,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010609,'猎犬手镯星痕','星痕F9','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010409,0,0,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010610,'猎犬戒指星痕','星痕F10','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010410,0,0,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010701,'狐狸头冠星痕','星痕G1','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010401,0,0,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010702,'狐狸战甲星痕','星痕G2','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010402,0,0,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010703,'天鹅下装星痕','星痕G3','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010403,0,0,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010704,'天鹅战靴星痕','星痕G4','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010404,0,0,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010705,'狐狸手套星痕','星痕G5','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010405,0,0,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010706,'狐狸武器星痕','星痕G6','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010406,0,0,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010707,'狐狸盾牌星痕','星痕G7','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010407,0,0,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010708,'天鹅项链星痕','星痕G8','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010408,0,0,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010709,'天鹅手镯星痕','星痕G9','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010409,0,0,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010710,'天鹅戒指星痕','星痕G10','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010410,0,0,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010801,'小狮头冠星痕','星痕H1','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010401,0,0,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010802,'小狮战甲星痕','星痕H2','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010402,0,0,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010803,'小狮下装星痕','星痕H3','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010403,0,0,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010804,'小狮战靴星痕','星痕H4','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010404,0,0,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010805,'英仙手套星痕','星痕H5','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010405,0,0,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010806,'英仙武器星痕','星痕H6','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010406,0,0,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010807,'英仙盾牌星痕','星痕H7','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010407,0,0,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010808,'英仙项链星痕','星痕H8','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010408,0,0,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010809,'英仙手镯星痕','星痕H9','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010409,0,0,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010810,'英仙戒指星痕','星痕H10','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010410,0,0,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010811,'小狮耳坠星痕','星痕H11','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010411,0,0,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010812,'小狮圣痕星痕','星痕H12','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010412,0,0,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010901,'三角头冠星痕','星痕I1','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010501,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010902,'牧夫战甲星痕','星痕I2','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010502,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010903,'飞马下装星痕','星痕I3','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010503,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010904,'三角战靴星痕','星痕I4','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010504,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010905,'牧夫手套星痕','星痕I5','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010505,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010906,'牧夫武器星痕','星痕I6','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010506,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010907,'牧夫盾牌星痕','星痕I7','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010507,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010908,'飞马项链星痕','星痕I8','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010508,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010909,'飞马手镯星痕','星痕I9','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010509,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010910,'飞马戒指星痕','星痕I10','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010510,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010911,'三角耳坠星痕','星痕I11','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010511,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21010912,'三角圣痕星痕','星痕I12','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010512,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21011001,'天箭头冠星痕','星痕J1','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010501,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21011002,'天箭战甲星痕','星痕J2','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010502,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21011003,'天箭下装星痕','星痕J3','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010503,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21011004,'天箭战靴星痕','星痕J4','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010504,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21011005,'巨蟹手套星痕','星痕J5','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010505,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21011006,'巨蟹武器星痕','星痕J6','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010506,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21011007,'巨蟹盾牌星痕','星痕J7','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010507,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21011008,'巨蟹项链星痕','星痕J8','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010508,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21011009,'巨蟹手镯星痕','星痕J9','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010509,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21011010,'巨蟹戒指星痕','星痕J10','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010510,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21011101,'人马头冠星痕','星痕K1','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010501,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21011102,'人马战甲星痕','星痕K2','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010502,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21011103,'双子下装星痕','星痕K3','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010503,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21011104,'双子战靴星痕','星痕K4','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010504,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21011105,'人马手套星痕','星痕K5','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010505,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21011106,'人马武器星痕','星痕K6','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010506,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21011107,'人马盾牌星痕','星痕K7','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010507,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21011108,'双子项链星痕','星痕K8','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010508,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21011109,'双子手镯星痕','星痕K9','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010509,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21011110,'双子戒指星痕','星痕K10','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010510,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21011201,'宝瓶头冠星痕','星痕L1','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010501,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21011202,'宝瓶战甲星痕','星痕L2','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010502,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21011203,'宝瓶下装星痕','星痕L3','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010503,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21011204,'宝瓶战靴星痕','星痕L4','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010504,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21011205,'室女手套星痕','星痕L5','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010505,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21011206,'室女武器星痕','星痕L6','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010506,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21011207,'室女盾牌星痕','星痕L7','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010507,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21011208,'室女项链星痕','星痕L8','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010508,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21011209,'室女手镯星痕','星痕L9','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010509,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21011210,'室女戒指星痕','星痕L10','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010510,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21011211,'宝瓶耳坠星痕','星痕L11','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010511,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21011212,'宝瓶圣痕星痕','星痕L12','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010512,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21011301,'双鱼头冠星痕','星痕M1','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010501,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21011302,'双鱼战甲星痕','星痕M2','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010502,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21011303,'双鱼下装星痕','星痕M3','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010503,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21011304,'双鱼战靴星痕','星痕M4','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010504,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21011305,'双鱼手套星痕','星痕M5','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010505,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21011306,'双鱼武器星痕','星痕M6','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010506,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21011307,'双鱼盾牌星痕','星痕M7','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010507,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21011308,'双鱼项链星痕','星痕M8','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010508,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21011309,'双鱼手镯星痕','星痕M9','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010509,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21011310,'双鱼戒指星痕','星痕M10','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010510,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21011311,'双鱼耳坠星痕','星痕M11','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010511,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21011312,'双鱼圣痕星痕','星痕M12','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21010512,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21011401,'天秤头冠星痕','星痕N1','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21011401,0,0,0,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(21011402,'天秤战甲星痕','星痕N2','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21011402,0,0,0,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(21011403,'天秤下装星痕','星痕N3','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21011403,0,0,0,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(21011404,'天秤战靴星痕','星痕N4','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21011404,0,0,0,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(21011405,'天秤手套星痕','星痕N5','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21011405,0,0,0,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(21011406,'天秤武器星痕','星痕N6','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21011406,0,0,0,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(21011407,'天秤盾牌星痕','星痕N7','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21011407,0,0,0,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(21011408,'天秤项链星痕','星痕N8','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21011408,0,0,0,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(21011409,'天秤手镯星痕','星痕N9','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21011409,0,0,0,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(21011410,'天秤戒指星痕','星痕N10','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21011410,0,0,0,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(21011411,'天秤耳坠星痕','星痕N11','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21011411,0,0,0,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(21011412,'天秤圣痕星痕','星痕N12','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21011412,0,0,0,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(21011501,'摩羯头冠星痕','星痕O1','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21011501,0,0,0,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(21011502,'摩羯战甲星痕','星痕O2','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21011502,0,0,0,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(21011503,'摩羯下装星痕','星痕O3','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21011503,0,0,0,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(21011504,'摩羯战靴星痕','星痕O4','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21011504,0,0,0,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(21011505,'摩羯手套星痕','星痕O5','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21011505,0,0,0,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(21011506,'摩羯武器星痕','星痕O6','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21011506,0,0,0,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(21011507,'摩羯盾牌星痕','星痕O7','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21011507,0,0,0,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(21011508,'摩羯项链星痕','星痕O8','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21011508,0,0,0,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(21011509,'摩羯手镯星痕','星痕O9','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21011509,0,0,0,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(21011510,'摩羯戒指星痕','星痕O10','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21011510,0,0,0,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(21011511,'摩羯耳坠星痕','星痕O11','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21011511,0,0,0,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(21011512,'摩羯圣痕星痕','星痕O12','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21011512,0,0,0,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(21011601,'狮子头冠星痕','星痕P1','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21011601,0,0,0,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(21011602,'狮子战甲星痕','星痕P2','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21011602,0,0,0,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(21011603,'狮子下装星痕','星痕P3','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21011603,0,0,0,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(21011604,'狮子战靴星痕','星痕P4','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21011604,0,0,0,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(21011605,'狮子手套星痕','星痕P5','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21011605,0,0,0,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(21011606,'狮子武器星痕','星痕P6','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21011606,0,0,0,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(21011607,'狮子盾牌星痕','星痕P7','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21011607,0,0,0,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(21011608,'狮子项链星痕','星痕P8','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21011608,0,0,0,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(21011609,'狮子手镯星痕','星痕P9','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21011609,0,0,0,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(21011610,'狮子戒指星痕','星痕P10','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21011610,0,0,0,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(21011611,'狮子耳坠星痕','星痕P11','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21011611,0,0,0,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(21011612,'狮子圣痕星痕','星痕P12','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21011612,0,0,0,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(21011701,'白羊头冠星痕','星痕Q1','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21011701,0,0,0,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(21011702,'白羊战甲星痕','星痕Q2','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21011702,0,0,0,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(21011703,'白羊下装星痕','星痕Q3','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21011703,0,0,0,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(21011704,'白羊战靴星痕','星痕Q4','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21011704,0,0,0,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(21011705,'白羊手套星痕','星痕Q5','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21011705,0,0,0,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(21011706,'白羊武器星痕','星痕Q6','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21011706,0,0,0,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(21011707,'白羊盾牌星痕','星痕Q7','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21011707,0,0,0,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(21011708,'白羊项链星痕','星痕Q8','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21011708,0,0,0,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(21011709,'白羊手镯星痕','星痕Q9','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21011709,0,0,0,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(21011710,'白羊戒指星痕','星痕Q10','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21011710,0,0,0,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(21011711,'白羊耳坠星痕','星痕Q11','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21011711,0,0,0,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(21011712,'白羊圣痕星痕','星痕Q12','',0,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,1,0,0,0,21011712,0,0,0,4,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(21020001,'星痕碎片','星痕强化材料，可通过分解星痕获得','',0,'【分解星痕获得】','[{0,0,0}]',0,0,0,21,2,0,0,0,21020001,0,0,999999,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21030001,'星痕印章','合成高阶星痕套装所需要的物品，可通过拆分高阶星痕获得。（拆分高阶星痕可无损返还所有合成材料，可随意替换为您需要的套装哦）','',0,'【拆分星痕获得】','[{0,0,0}]',0,0,0,21,2,1,0,0,21030001,0,0,999999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21040001,'陨星之印·一','星痕铸魂使用，强化星痕区域的材料','生命+1000,攻击+50',2000,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,2,1,0,0,21040001,0,0,999999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21040002,'陨星之印·二','星痕铸魂使用，强化星痕区域的材料','火系伤害+40,火系防御+40,风系伤害+40,风系防御+40',4800,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,2,1,0,0,21040002,0,0,999999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21040003,'陨星之印·三','星痕铸魂使用，强化星痕区域的材料','冰系伤害+40,冰系防御+40,雷系伤害+40,雷系防御+40',4800,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,2,0,0,0,21040003,0,0,999999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(21040004,'陨星之印·四','星痕铸魂使用，强化星痕区域的材料','生命+4000,攻击+4000,元素伤害+0.5%,元素防御+0.5%',8000,'【时空乱流掉落】','[{0,0,0}]',0,0,0,21,2,0,0,0,21040004,0,0,999999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(24010001,'初级宝具纹章','适用于1-60级的宝具，可以提升宝具经验值30','',0,'【巅峰竞技,丛林突围,三英会战】','[{281,0,1},{606,0,1},{153,7,0}]',0,0,0,24,1,1,0,0,24010001,0,50,99999,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(24010002,'中级宝具纹章','适用于61-150级的宝具，可以提升宝具经验值100','',0,'【巅峰竞技,丛林突围,三英会战】','[{281,0,1},{606,0,1},{153,7,0}]',0,0,0,24,1,1,0,0,24010002,0,50,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(24010003,'高级宝具纹章','适用于151-240级的宝具，可以提升宝具经验值300','',0,'【巅峰竞技,丛林突围,三英会战】','[{281,0,1},{606,0,1},{153,7,0}]',0,0,0,24,1,1,0,0,24010003,0,50,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(24020001,'山铜宝具石','蕴含着神圣的气息，可以提升宝具属性','生命  +450,命中  +12',1000,'【丛林突围,首领狩猎,运营活动,三英会战】','[{606,0,1},{460,4,1}]',0,0,0,24,2,0,0,0,24020001,0,50,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(24020002,'青钢宝具石','蕴含着神圣的气息，可以提升宝具属性','攻击  +40,闪避  +25',2000,'【丛林突围,运营活动,三英会战】','[{606,0,1}]',0,0,0,24,2,0,0,0,24020002,0,50,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(24020003,'瑟银宝具石','蕴含着神圣的气息，可以提升宝具属性','生命  +1500,攻击  +75,宝具生命加成  +0.5%,宝具闪避加成  +0.5%',3200,'【丛林突围,运营活动】','[{606,0,1}]',0,0,0,24,2,0,0,0,24020003,0,50,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(24020004,'精金宝具石','蕴含着神圣的气息，可以提升宝具属性','命中  +60,闪避  +60,宝具攻击加成  +1%,宝具命中加成  +1%',6000,'【运营活动】','[{0,0,0}]',0,0,0,24,2,1,0,0,24020004,0,50,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(24030001,'龙魂宝珠','激活宝具外观：龙魂宝珠，在【宝具】-【幻化】','攻击+515,生命+10300,命中+129,闪避+129,boss伤害+1%',33500,'【首领会所,运营活动】','[{460,4,1}]',0,1,0,24,3,4,5,0,24030001,0,50,99999,4,0,0,0,'[{1,688}]',0,0,0,0,'[]','[]',0,0,0,1),(24030002,'失落魔方','激活宝具外观：失落魔方，在【宝具】-【幻化】','攻击+642,生命+12840,命中+161,闪避+161,pve伤害+1%',41780,'【首领会所,运营活动】','[{460,4,1}]',0,1,0,24,3,4,5,0,24030002,0,50,99999,4,0,0,0,'[{1,888}]',0,0,0,0,'[]','[]',0,0,0,1),(24030003,'古神典籍','激活宝具外观：古神典籍，在【宝具】-【幻化】','攻击+826,生命+16520,命中+207,闪避+207,pvp伤害+1%',53740,'【首领会所】','[{460,4,1}]',0,1,0,24,3,4,5,0,24030003,0,50,99999,4,0,0,0,'[{1,1088}]',0,0,0,0,'[]','[]',0,0,0,1),(24030004,'海洋之心','激活宝具外观：海洋之心，在【宝具】-【幻化】','攻击+1011,生命+20220,命中+253,闪避+253,技能伤害+1%',65740,'【首领会所】','[{460,4,1}]',0,1,0,24,3,4,5,0,24030004,0,50,99999,4,0,0,0,'[{1,1288}]',0,0,0,0,'[]','[]',0,0,0,1),(24030005,'海洋护符','激活宝具外观：海洋护符，在【宝具】-【幻化】','攻击+1134,生命+22680,命中+284,闪避+284,技能减免+1%',73760,'【首领会所】','[{460,4,1}]',0,1,0,24,3,4,5,0,24030005,0,50,99999,4,0,0,0,'[{1,1488}]',0,0,0,0,'[]','[]',0,0,0,1),(24030006,'航海宝珠','激活宝具外观：航海宝珠，在【宝具】-【幻化】','攻击+1257,生命+25140,命中+314,闪避+314,伤害加成+1%',81680,'【首领会所】','[{460,4,1}]',0,1,0,24,3,4,5,0,24030006,0,50,99999,4,0,0,0,'[{1,1688}]',0,0,0,0,'[]','[]',0,0,0,1),(24030007,'善恶天秤','激活宝具外观：善恶天秤，在【宝具】-【幻化】','攻击+1626,生命+32520,命中+407,闪避+407,伤害减免+1%',105740,'【首领会所】','[{460,4,1}]',0,1,0,24,3,4,5,0,24030007,0,50,99999,4,0,0,0,'[{1,1688}]',0,0,0,0,'[]','[]',0,0,0,1),(24030008,'许愿神灯（暂代）','激活宝具外观：许愿神灯，在【宝具】-【幻化】','战力   +998',0,'【首领boss】','[{460,2,1}]',0,1,0,24,3,4,5,0,24030008,0,50,99999,4,0,0,0,'[{1,9999}]',0,0,0,0,'[]','[]',0,0,0,1),(24030009,'创世女神（暂代）','激活宝具外观：创世女神，在【宝具】-【幻化】','战力   +998',0,'【首领boss】','[{460,2,1}]',0,1,0,24,3,4,5,0,24030009,0,50,99999,5,0,0,0,'[{1,9999}]',0,0,0,0,'[]','[]',0,0,0,1),(24031001,'龙魂宝珠碎片','集齐<color=#4eae1a>10</color>个碎片，在【合成】中合成，即可激活宝具外观·龙魂宝珠\\n激活立即获得\\n','攻击+515,生命+10300,命中+129,闪避+129,boss伤害+1%',33500,'【首领会所】','[{460,4,1}]',0,1,0,24,4,4,5,0,24031001,0,50,99999,3,0,0,0,'[{1,69}]',0,0,0,0,'[]','[]',0,0,0,1),(24031002,'失落魔方碎片','集齐<color=#4eae1a>10</color>个碎片，在【合成】中合成，即可激活宝具外观·失落魔方\\n激活立即获得\\n','攻击+642,生命+12840,命中+161,闪避+161,pve伤害+1%',41780,'【首领会所】','[{460,4,1}]',0,1,0,24,4,4,5,0,24031002,0,50,99999,3,0,0,0,'[{1,89}]',0,0,0,0,'[]','[]',0,0,0,1),(24031003,'古神典籍碎片','集齐<color=#4eae1a>10</color>个碎片，在【合成】中合成，即可激活宝具外观·古神典籍\\n激活立即获得\\n','攻击+826,生命+16520,命中+207,闪避+207,pvp伤害+1%',53740,'【首领会所，开服冲榜目标】','[{460,4,1}]',0,1,0,24,4,4,5,0,24031003,0,50,99999,4,0,0,0,'[{1,109}]',0,0,0,0,'[]','[]',0,0,0,1),(24031004,'海洋之心碎片','集齐<color=#4eae1a>10</color>个碎片，在【合成】中合成，即可激活宝具外观·海洋之心\\n激活立即获得\\n','攻击+1011,生命+20220,命中+253,闪避+253,技能伤害+1%',65740,'【首领会所】','[{460,4,1}]',0,1,0,24,4,4,5,0,24031004,0,50,99999,4,0,0,0,'[{1,129}]',0,0,0,0,'[]','[]',0,0,0,1),(24031005,'海洋护符碎片','集齐<color=#4eae1a>10</color>个碎片，在【合成】中合成，即可激活宝具外观·海洋护符\\n激活立即获得\\n','攻击+1134,生命+22680,命中+284,闪避+284,技能减免+1%',73760,'【首领会所】','[{460,4,1}]',0,1,0,24,4,4,5,0,24031005,0,50,99999,4,0,0,0,'[{1,149}]',0,0,0,0,'[]','[]',0,0,0,1),(24031006,'航海宝珠碎片','集齐<color=#4eae1a>10</color>个碎片，在【合成】中合成，即可激活宝具外观·航海宝珠\\n激活立即获得\\n','攻击+1257,生命+25140,命中+314,闪避+314,伤害加成+1%',81680,'【首领boss】','[{460,4,1}]',0,1,0,24,4,4,5,0,24031006,0,50,99999,4,0,0,0,'[{1,169}]',0,0,0,0,'[]','[]',0,0,0,1),(24031007,'善恶天秤碎片','集齐<color=#4eae1a>10</color>个碎片，在【合成】中合成，即可激活宝具外观·善恶天秤\\n激活立即获得\\n','攻击+1626,生命+32520,命中+407,闪避+407,伤害减免+1%',105740,'【首领会所】','[{460,4,1}]',0,1,0,24,4,4,5,0,24031007,0,50,99999,4,0,0,0,'[{1,169}]',0,0,0,0,'[]','[]',0,0,0,1),(24031008,'许愿神灯碎片（暂代）','合成宝具外形许愿神灯','',0,'【首领boss】','[{460,4,1}]',0,1,0,24,4,4,5,0,24030008,0,50,99999,4,0,0,0,'[{1,1000}]',0,0,0,0,'[]','[]',0,0,0,1),(24031009,'创世女神碎片（暂代）','合成宝具外形创世女神','',0,'【首领boss】','[{460,4,1}]',0,1,0,24,4,4,5,0,24030009,0,50,99999,5,0,0,0,'[{1,1000}]',0,0,0,0,'[]','[]',0,0,0,1),(32000000,'物品测试礼包','里面装满了各种制服，营养不良和自控能力差的玩家请勿打开请勿打开请勿打开！%gift_to_itemlist   【我觉得你又写了bug】','',0,'【运营活动】','[{0,0,0}]',1,0,1,32,1,0,0,0,32000000,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32000011,'初级晶石宝箱','<color=#835741>用途：</color>\\n打开后可在以下奖励表中随机获得一个：\\n<color=#cf5afb>光明神晶</color>\\n<color=#cf5afb>黑暗神晶</color>\\n<color=#cf5afb>山铜宝具石</color>\\n<color=#cf5afb>青钢宝具石</color>\\n\\n<color=#835741>描述：</color>\\n闪耀着光芒的晶石宝箱，来开箱子检验一下今天的运气吧~','',0,'【运营活动】','[{0,0,0}]',0,0,1,32,1,0,0,0,32000010,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32000012,'中级晶石宝箱','<color=#835741>用途：</color>\\n打开后可在以下奖励表中随机获得一个：\\n<color=#cf5afb>黑暗神晶</color>\\n<color=#fba65a>秩序神晶</color>\\n<color=#cf5afb>青钢宝具石</color>\\n<color=#fba65a>瑟银宝具石</color>\\n\\n<color=#835741>描述：</color>\\n闪耀着光芒的晶石宝箱，来开箱子检验一下今天的运气吧~','',0,'【运营活动】','[{0,0,0}]',0,0,1,32,1,0,0,0,32000010,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32000013,'高级晶石宝箱','<color=#835741>用途：</color>\\n打开后可在以下奖励表中随机获得一个：\\n<color=#fba65a>秩序神晶</color>\\n<color=#ff4f4f>混沌神晶</color>\\n<color=#fba65a>瑟银宝具石</color>\\n<color=#ff4f4f>精金宝具石</color>\\n\\n<color=#835741>描述：</color>\\n闪耀着光芒的晶石宝箱，来开箱子检验一下今天的运气吧~','',0,'【运营活动】','[{0,0,0}]',0,0,1,32,1,0,0,0,32000010,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32000021,'初级源石宝箱','<color=#835741>用途：</color>\\n打开后可在以下奖励表中随机获得一个：\\n<color=#cf5afb>凶兽源石</color>\\n<color=#cf5afb>蛮兽源石</color>\\n<color=#cf5afb>日羽源石</color>\\n<color=#cf5afb>暗羽源石</color>\\n\\n<color=#835741>描述：</color>\\n闪耀着光芒的源石宝箱，来开箱子检验一下今天的运气吧~','',0,'【运营活动】','[{0,0,0}]',0,0,1,32,1,0,0,0,32000020,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32000022,'中级源石宝箱','<color=#835741>用途：</color>\\n打开后可在以下奖励表中随机获得一个：\\n<color=#cf5afb>蛮兽源石</color>\\n<color=#fba65a>巨兽源石</color>\\n<color=#cf5afb>暗羽源石</color>\\n<color=#fba65a>圣羽源石</color>\\n\\n<color=#835741>描述：</color>\\n闪耀着光芒的源石宝箱，来开箱子检验一下今天的运气吧~','',0,'【运营活动】','[{0,0,0}]',0,0,1,32,1,0,0,0,32000020,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32000023,'高级源石宝箱','<color=#835741>用途：</color>\\n打开后可在以下奖励表中随机获得一个：\\n<color=#fba65a>巨兽源石</color>\\n<color=#ff4f4f>魔兽源石</color>\\n<color=#fba65a>圣羽源石</color>\\n<color=#ff4f4f>魔羽源石</color>\\n\\n<color=#835741>描述：</color>\\n闪耀着光芒的源石宝箱，来开箱子检验一下今天的运气吧~','',0,'【运营活动】','[{0,0,0}]',0,0,1,32,1,0,0,0,32000020,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32000024,'尊享冲级礼包','200级开启获得：<color=#60a0ff>初级神源之火*10</color>\\n240级开启获得：<color=#60a0ff>初级宝具纹章*10</color>\\n280级开启获得：<color=#60a0ff>初级坐骑树果*10</color>\\n320级开启获得：<color=#60a0ff>3级攻击宝石*1，3级生命宝石*1</color>\\n','',0,'【运营活动】','[{0,0,0}]',0,0,1,32,1,0,0,0,32000003,0,200,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32000025,'尊享冲级礼包','200级开启获得：<color=#60a0ff>初级神源之火*10</color>\\n240级开启获得：<color=#60a0ff>初级宝具纹章*10</color>\\n280级开启获得：<color=#60a0ff>初级坐骑树果*10</color>\\n320级开启获得：<color=#60a0ff>3级攻击宝石*1，3级生命宝石*1</color>\\n','',0,'【运营活动】','[{0,0,0}]',0,0,1,32,1,0,0,0,32000003,0,240,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32000026,'尊享冲级礼包','200级开启获得：<color=#60a0ff>初级神源之火*10</color>\\n240级开启获得：<color=#60a0ff>初级宝具纹章*10</color>\\n280级开启获得：<color=#60a0ff>初级坐骑树果*10</color>\\n320级开启获得：<color=#60a0ff>3级攻击宝石*1，3级生命宝石*1</color>\\n','',0,'【运营活动】','[{}]',0,0,1,32,1,0,0,0,32000003,0,280,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32000027,'尊享冲级礼包','200级开启获得：<color=#60a0ff>初级神源之火*10</color>\\n240级开启获得：<color=#60a0ff>初级宝具纹章*10</color>\\n280级开启获得：<color=#60a0ff>初级坐骑树果*10</color>\\n320级开启获得：<color=#60a0ff>3级攻击宝石*1，3级生命宝石*1</color>\\n','',0,'【运营活动】','[{}]',0,0,1,32,1,0,0,0,32000003,0,320,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32000028,'首领晶石宝箱','<color=#835741>用途：</color>\\n打开后可以下奖励表中随机获得一个：\\n<color=#cf5afb>光明神晶</color>\\n<color=#cf5afb>山铜宝具石</color>\\n\\n<color=#835741>描述：</color>\\n闪耀着光芒的晶石宝箱，来开箱子检验一下今天的运气吧~','',0,'【首领狩猎】','[{460,4,1}]',0,0,1,32,1,0,0,0,32000004,0,100,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32000029,'1阶翅膀宝箱','<color=#835741>用途：</color>\\n打开后即可获得本职业<color=#cf5afb>1阶翅膀</color>\\n\\n<color=#835741>描述：</color>\\n风之主神炼制的宝箱，据说只要把风关进来，打开的时候就能得到一双翅膀','',0,'【运营活动】','[{}]',0,0,1,32,1,0,0,0,32000005,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32000030,'2阶翅膀宝箱','<color=#835741>用途：</color>\\n打开后即可获得本职业<color=#fba65a>2阶翅膀</color>\\n\\n<color=#835741>描述：</color>\\n风之主神炼制的宝箱，据说只要把风关进来，打开的时候就能得到一双翅膀','',0,'【运营活动】','[{}]',0,0,1,32,1,0,0,0,32000005,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32000031,'3阶翅膀宝箱','<color=#835741>用途：</color>\\n打开后即可获得本职业<color=#ff4f4f>3阶翅膀</color>\\n\\n<color=#835741>描述：</color>\\n风之主神炼制的宝箱，据说只要把风关进来，打开的时候就能得到一双翅膀','',0,'【运营活动】','[{}]',0,0,1,32,1,0,0,0,32000005,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32000032,'4阶翅膀宝箱','<color=#835741>用途：</color>\\n打开后即可获得本职业<color=#ff4f4f>4阶翅膀</color>\\n\\n<color=#835741>描述：</color>\\n风之主神炼制的宝箱，据说只要把风关进来，打开的时候就能得到一双翅膀','',0,'【运营活动】','[{}]',0,0,1,32,1,0,0,0,32000005,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32000033,'5阶翅膀宝箱','<color=#835741>用途：</color>\\n打开后即可获得本职业<color=#ff539c>5阶翅膀</color>\\n\\n<color=#835741>描述：</color>\\n风之主神炼制的宝箱，据说只要把风关进来，打开的时候就能得到一双翅膀','',0,'【运营活动】','[{}]',0,0,1,32,1,0,0,0,32000005,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32000034,'6阶翅膀宝箱','<color=#835741>用途：</color>\\n打开后即可获得本职业<color=#ff539c>6阶翅膀</color>\\n\\n<color=#835741>描述：</color>\\n风之主神炼制的宝箱，据说只要把风关进来，打开的时候就能得到一双翅膀','',0,'【运营活动】','[{}]',0,0,1,32,1,0,0,0,32000005,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32000035,'4阶红2星副手宝箱','打开获得本职业4阶红2星副手','',0,'【运营活动】','[{}]',0,0,1,32,1,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32000036,'6阶神装武器宝箱','打开获得本职业6阶幻彩武器','',0,'【运营活动】','[{}]',0,0,1,32,1,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32000037,'开服红装宝箱','打开获得本职业对应的装备','',0,'【运营活动】','[{}]',0,0,1,32,1,1,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32000038,'5阶红2星副手礼包','打开获得本职业5阶红2星副手','',0,'【云购活动】','[{0,0,0}]',0,0,1,32,1,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32000039,'6阶红2星副手礼包','打开获得本职业6阶红2星副手','',0,'【云购活动】','[{0,0,0}]',0,0,1,32,1,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32000040,'6阶红3星副手礼包','打开获得本职业6阶红3星副手','',0,'【云购活动】','[{0,0,0}]',0,0,1,32,1,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32000041,'6阶粉色副手礼包','打开获得本职业6阶粉色副手','',0,'【云购活动】','[{0,0,0}]',0,0,1,32,1,0,0,0,32080002,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32010001,'百万金币','使用可获得百万金币，百万富翁不是梦！','',0,'【运营活动】','[{0,0,0}]',0,0,1,32,1,0,0,0,32010001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32010003,'30绑钻','有钱在手心不慌，使用获得30绑钻','',0,'【运营活动】','[{0,0,0}]',0,0,1,32,1,0,0,0,32010003,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32010004,'十万金币','打开可获得10万金币','',0,'【运营活动】','[{0,0,0}]',0,0,1,32,1,0,0,0,32010001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32010006,'缤纷染色礼包','开启可随机获得染色剂一个','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,1,0,0,0,32010006,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32010015,'时装礼包(头)','开启后可获得：正义发饰x1、高级坐骑祝福星卷x1、2倍经验药水x2、金币x10万\\n\\n额外赠送<color=#4eae1a>时装礼包（武）</color>\\n<color=#4eae1a>获得礼包后第2天登录可免费开启！</color>','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,1,0,0,0,12030002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32010016,'时装礼包(武)','开启后可获得：正义裁决x1、高级坐精灵祝福星卷x1、2倍经验药水x2、金币x10万\\n\\n<color=#4eae1a>获得礼包后第2天登录可免费开启！</color>','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,1,0,0,0,12020002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32010031,'1万金币','打开可获得1万金币','',0,'【运营活动】','[{0,0,0}]',0,0,1,32,1,0,0,0,32010031,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32010032,'5万金币','打开可获得2万金币','',0,'【运营活动】','[{0,0,0}]',0,0,1,32,1,0,0,0,32010032,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32010033,'10万金币','打开可获得10万金币','',0,'【运营活动】','[{0,0,0}]',0,0,1,32,1,0,0,0,32010033,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32010034,'100万金币','打开可获得100万金币','',0,'【运营活动】','[{0,0,0}]',0,0,1,32,1,0,0,0,32010034,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32010035,'15万金币','打开可获得15万金币','',0,'【运营活动】','[{0,0,0}]',0,0,1,32,1,0,0,0,32010035,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32010036,'20万金币','打开可获得20万金币','',0,'【运营活动】','[{0,0,0}]',0,0,1,32,1,0,0,0,32010036,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32010037,'120万金币','打开可获得120万金币','',0,'【运营活动】','[{0,0,0}]',0,0,1,32,1,0,0,0,32010037,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32010038,'150万金币','打开可获得150万金币','',0,'【运营活动】','[{0,0,0}]',0,0,1,32,1,0,0,0,32010038,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32010041,'5绑钻','打开可获得5绑钻','',0,'【运营活动】','[{0,0,0}]',0,0,1,32,1,0,0,0,32010041,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32010042,'10绑钻','打开可获得10绑钻','',0,'【运营活动】','[{0,0,0}]',0,0,1,32,1,0,0,0,32010042,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32010043,'20绑钻','打开可获得20绑钻','',0,'【运营活动】','[{0,0,0}]',0,0,1,32,1,0,0,0,32010043,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32010044,'50绑钻','打开可获得50绑钻','',0,'【运营活动】','[{0,0,0}]',0,0,1,32,1,0,0,0,32010044,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32010045,'100绑钻','打开可获得100绑钻','',0,'【运营活动】','[{0,0,0}]',0,0,1,32,1,0,0,0,32010045,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32010046,'15绑钻','打开可获得15绑钻','',0,'【运营活动】','[{0,0,0}]',0,0,1,32,1,0,0,0,32010046,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32010047,'30绑钻','打开可获得30绑钻','',0,'【运营活动】','[{0,0,0}]',0,0,1,32,1,0,0,0,32010047,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32010048,'1绑钻','打开可获得1绑钻','',0,'【运营活动】','[{0,0,0}]',0,0,1,32,1,0,0,0,32010048,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32010052,'荒野游侠(套)','打开可获得完整一套<color=#4eae1a>荒野游侠3件套时装</color>，让帅气与战力共存！\\n\\n<color=#4eae1a>衣服时装：荒野游侠*1</color>\\n<color=#4eae1a>武器时装：混乱之源*1</color>\\n<color=#4eae1a>头饰时装：游侠毡帽*1</color>\\n\\n可在【角色】-【时装】使用和查看时装效果！','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,1,0,0,0,32010009,0,1,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32010053,'新婚礼服(套)','打开可获得完整一套<color=#4eae1a>新婚礼服3件套时装</color>，让帅气与战力共存！\\n\\n<color=#4eae1a>衣服时装：新婚礼服*1</color>\\n<color=#4eae1a>武器时装：新婚花束*1</color>\\n<color=#4eae1a>头饰时装：新婚发饰*1</color>\\n\\n可在【角色】-【时装】使用和查看时装效果！','',0,'【运营活动】','[{0,0,0}]',1,0,0,32,1,0,0,0,32010009,0,1,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32010054,'时装礼包(衣)','开启后可获得：\\n至高正义x1，可在【时装】-【衣服】中使用。\\n激活立即获得<color=#4eae1a>4800战力</color>，后面更可通过<color=#62e875>培养获得更多战力</color>！\\n\\n额外赠送<color=#4eae1a>时装礼包（头）x1</color>，获得礼包后第2天登录可免费开启！','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,2,0,0,0,12010002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32010057,'星空宝箱','打开可获得道具：\\n<color=#60a0ff>1.5倍经验药水*2</color>\\n<color=#9c6cff>50绑钻</color>\\n<color=#60a0ff>3000吞噬值</color>','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,1,0,0,0,32010008,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32010067,'阴阳师(套)','打开可获得完整一套<color=#4eae1a>阴阳师3件套时装</color>，让帅气与战力共存！\\n\\n<color=#4eae1a>衣服时装：阴阳师*1</color>\\n<color=#4eae1a>武器时装：招魂法灯*1</color>\\n<color=#4eae1a>头饰时装：祭典乌帽*1</color>\\n\\n可在【角色】-【时装】使用和查看时装效果！','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,1,0,0,0,32010009,0,1,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32020111,'普通装备套装石箱','开启可随机获得1颗普通装备套装石','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,2,0,0,0,32020111,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32020112,'普通防具套装石箱','开启可随机获得1颗普通防具套装石','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,2,0,0,0,32020112,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32020113,'普通武器套装石箱','开启可随机获得1颗普通武器套装石','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,2,0,0,0,32020113,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32020114,'普通首饰套装石箱','开启可随机获得1颗普通首饰套装石','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,2,0,0,0,32020114,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32020121,'完美装备套装石箱','开启可随机获得1颗完美装备套装石','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,2,0,0,0,32020111,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32020122,'完美防具套装石箱','开启可随机获得1颗完美防具套装石','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,2,0,0,0,32020112,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32020123,'完美武器套装石箱','开启可随机获得1颗完美武器套装石','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,2,0,0,0,32020113,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32020124,'完美首饰套装石箱','开启可随机获得1颗完美首饰套装石','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,2,0,0,0,32020114,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32030101,'1级宝石袋','闪闪发光的宝石袋，开启可随机获得1颗1级宝石','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,3,0,0,0,32030001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32030102,'1级红宝石袋','闪闪发光的宝石袋，开启可随机获得1颗1级攻击、破甲、命中、暴击宝石','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,3,0,0,0,32030002,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32030103,'1级蓝宝石袋','闪闪发光的宝石袋，开启可随机获得1颗1级生命、防御、闪避、韧性宝石','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,3,0,0,0,32030003,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32030201,'2级宝石袋','闪闪发光的宝石袋，开启可随机获得1颗2级宝石','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,3,0,0,0,32030001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32030202,'2级红宝石袋','闪闪发光的宝石袋，开启可随机获得1颗2级攻击、破甲、命中、暴击宝石','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,3,0,0,0,32030002,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32030203,'2级蓝宝石袋','闪闪发光的宝石袋，开启可随机获得1颗2级生命、防御、闪避、韧性宝石','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,3,0,0,0,32030003,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32030301,'3级宝石袋','闪闪发光的宝石袋，开启可随机获得1颗3级宝石','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,3,0,0,0,32030001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32030302,'3级红宝石袋','闪闪发光的宝石袋，开启可随机获得1颗3级攻击、破甲、命中、暴击宝石','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,3,0,0,0,32030002,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32030303,'3级蓝宝石袋','闪闪发光的宝石袋，开启可随机获得1颗3级生命、防御、闪避、韧性宝石','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,3,0,0,0,32030003,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32030401,'4级宝石袋','闪闪发光的宝石袋，开启可随机获得1颗4级宝石','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,3,0,0,0,32030001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32030402,'4级红宝石袋','闪闪发光的宝石袋，开启可随机获得1颗4级攻击、破甲、命中、暴击宝石','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,3,0,0,0,32030002,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32030403,'4级蓝宝石袋','闪闪发光的宝石袋，开启可随机获得1颗4级生命、防御、闪避、韧性宝石','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,3,0,0,0,32030003,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32030501,'5级宝石袋','闪闪发光的宝石袋，开启可随机获得1颗5级宝石','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,3,0,0,0,32030001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32030502,'5级红宝石袋','闪闪发光的宝石袋，开启可随机获得1颗5级攻击、破甲、命中、暴击宝石','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,3,0,0,0,32030002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32030503,'5级蓝宝石袋','闪闪发光的宝石袋，开启可随机获得1颗5级生命、防御、闪避、韧性宝石','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,3,0,0,0,32030003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32030601,'6级宝石袋','闪闪发光的宝石袋，开启可随机获得1颗6级宝石','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,3,0,0,0,32030001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32030602,'6级红宝石袋','闪闪发光的宝石袋，开启可随机获得1颗6级攻击、破甲、命中、暴击宝石','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,3,0,0,0,32030002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32030603,'6级蓝宝石袋','闪闪发光的宝石袋，开启可随机获得1颗6级生命、防御、闪避、韧性宝石','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,3,0,0,0,32030003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32030701,'7级宝石袋','闪闪发光的宝石袋，开启可随机获得1颗7级宝石','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,3,0,0,0,32030001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32030702,'7级红宝石袋','闪闪发光的宝石袋，开启可随机获得1颗7级攻击、破甲、命中、暴击宝石','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,3,0,0,0,32030002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32030703,'7级蓝宝石袋','闪闪发光的宝石袋，开启可随机获得1颗7级生命、防御、闪避、韧性宝石','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,3,0,0,0,32030003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32030801,'8级宝石袋','闪闪发光的宝石袋，开启可随机获得1颗8级宝石','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,3,0,0,0,32030001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32030802,'8级红宝石袋','闪闪发光的宝石袋，开启可随机获得1颗8级攻击、破甲、命中、暴击宝石','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,3,0,0,0,32030002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32030803,'8级蓝宝石袋','闪闪发光的宝石袋，开启可随机获得1颗8级生命、防御、闪避、韧性宝石','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,3,0,0,0,32030003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32030901,'9级宝石袋','闪闪发光的宝石袋，开启可随机获得1颗9级宝石','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,3,0,0,0,32030001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32030902,'9级红宝石袋','闪闪发光的宝石袋，开启可随机获得1颗9级攻击、破甲、命中、暴击宝石','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,3,0,0,0,32030002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32030903,'9级蓝宝石袋','闪闪发光的宝石袋，开启可随机获得1颗9级生命、防御、闪避、韧性宝石','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,3,0,0,0,32030003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32040001,'1阶星痕礼包','1阶星痕礼包','',0,'【运营活动】','[{}]',1,0,0,32,4,0,0,0,32000000,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32040002,'2阶星痕礼包','2阶星痕礼包','',0,'【运营活动】','[{}]',1,0,0,32,4,0,0,0,32000000,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32040003,'3阶星痕礼包','3阶星痕礼包','',0,'【运营活动】','[{}]',1,0,0,32,4,0,0,0,32000000,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32040004,'4阶星痕礼包','4阶星痕礼包','',0,'【运营活动】','[{}]',1,0,0,32,4,0,0,0,32000000,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32040005,'5阶星痕礼包','5阶星痕礼包','',0,'【运营活动】','[{}]',1,0,0,32,4,0,0,0,32000000,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32040006,'6阶星痕礼包','6阶星痕礼包','',0,'【运营活动】','[{}]',1,0,0,32,4,0,0,0,32000000,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32040007,'7阶星痕礼包','7阶星痕礼包','',0,'【运营活动】','[{}]',1,0,0,32,4,0,0,0,32000000,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32040008,'8阶星痕礼包','8阶星痕礼包','',0,'【运营活动】','[{0,0,0}]',1,0,0,32,4,0,0,0,32000000,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32040009,'9阶星痕礼包','9阶星痕礼包','',0,'【运营活动】','[{0,0,0}]',1,0,0,32,4,0,0,0,32000000,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32040010,'10阶星痕礼包','10阶星痕礼包','',0,'【运营活动】','[{0,0,0}]',1,0,0,32,4,0,0,0,32000000,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32040011,'11阶星痕礼包','11阶星痕礼包','',0,'【运营活动】','[{0,0,0}]',1,0,0,32,4,0,0,0,32000000,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32040012,'12阶星痕礼包','12阶星痕礼包','',0,'【运营活动】','[{0,0,0}]',1,0,0,32,4,0,0,0,32000000,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32040013,'13阶星痕礼包','13阶星痕礼包','',0,'【运营活动】','[{0,0,0}]',1,0,0,32,4,0,0,0,32000000,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32040014,'14阶星痕礼包','14阶星痕礼包','',0,'【运营活动】','[{0,0,0}]',1,0,0,32,4,0,0,0,32000000,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32040015,'15阶星痕礼包','15阶星痕礼包','',0,'【运营活动】','[{0,0,0}]',1,0,0,32,4,0,0,0,32000000,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32040016,'16阶星痕礼包','16阶星痕礼包','',0,'【运营活动】','[{0,0,0}]',1,0,0,32,4,0,0,0,32000000,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32040017,'17阶星痕礼包','17阶星痕礼包','',0,'【运营活动】','[{0,0,0}]',1,0,0,32,4,0,0,0,32000000,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32040101,'小马星痕礼包','开启获得小马星痕之一','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,4,0,0,0,32040401,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32040102,'小犬星痕礼包','开启获得小犬星痕之一','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,4,0,0,0,32040401,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32040103,'蛇夫星痕礼包','开启获得蛇夫星痕之一','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,4,0,0,0,32040401,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32040104,'鲸鱼星痕礼包','开启获得鲸鱼星痕之一','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,4,0,0,0,32040401,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32040201,'天坛星痕礼包','开启获得天坛星痕之一','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,4,0,0,0,32040401,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32040202,'山案星痕礼包','开启获得山案星痕之一','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,4,0,0,0,32040401,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32040203,'绘架星痕礼包','开启获得绘架星痕之一','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,4,0,0,0,32040401,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32040204,'天燕星痕礼包','开启获得天燕星痕之一','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,4,0,0,0,32040401,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32040301,'飞鱼星痕礼包','开启获得飞鱼星痕之一','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,4,0,0,0,32040401,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32040302,'矩尺星痕礼包','开启获得矩尺星痕之一','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,4,0,0,0,32040401,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32040401,'剑鱼星痕礼包','开启获得剑鱼星痕之一','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,4,0,0,0,32040401,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32040402,'孔雀星痕礼包','开启获得孔雀星痕之一','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,4,0,0,0,32040401,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32040501,'鹿豹星痕礼包','开启获得鹿豹星痕之一','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,4,0,0,0,32040401,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32040502,'蝎虎星痕礼包','开启获得蝎虎星痕之一','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,4,0,0,0,32040401,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32040503,'仙女星痕礼包','开启获得仙女星痕之一','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,4,0,0,0,32040401,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32040601,'御夫星痕礼包','开启获得御夫星痕之一','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,4,0,0,0,32040401,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32040602,'猎犬星痕礼包','开启获得猎犬星痕之一','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,4,0,0,0,32040401,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32040701,'狐狸星痕礼包','开启获得狐狸星痕之一','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,4,0,0,0,32040401,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32040702,'天鹅星痕礼包','开启获得天鹅星痕之一','',0,'【运营活动】','[{0,0,0}]',1,0,0,32,4,0,0,0,32040401,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32040801,'小狮星痕礼包','开启获得小狮星痕之一','',0,'【运营活动】','[{0,0,0}]',1,0,0,32,4,0,0,0,32040401,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32040802,'英仙星痕礼包','开启获得英仙星痕之一','',0,'【运营活动】','[{0,0,0}]',1,0,0,32,4,0,0,0,32040401,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32040901,'三角星痕礼包','开启获得三角星痕之一','',0,'【运营活动】','[{0,0,0}]',1,0,0,32,4,0,0,0,32040401,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32040902,'牧夫星痕礼包','开启获得牧夫星痕之一','',0,'【运营活动】','[{0,0,0}]',1,0,0,32,4,0,0,0,32040401,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32040903,'飞马星痕礼包','开启获得飞马星痕之一','',0,'【运营活动】','[{0,0,0}]',1,0,0,32,4,0,0,0,32040401,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32041001,'天箭星痕礼包','开启获得天箭星痕之一','',0,'【运营活动】','[{0,0,0}]',1,0,0,32,4,0,0,0,32040401,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32041002,'巨蟹星痕礼包','开启获得巨蟹星痕之一','',0,'【运营活动】','[{0,0,0}]',1,0,0,32,4,0,0,0,32040401,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32041101,'人马星痕礼包','开启获得人马星痕之一','',0,'【运营活动】','[{0,0,0}]',1,0,0,32,4,0,0,0,32040401,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32041102,'双子星痕礼包','开启获得双子星痕之一','',0,'【运营活动】','[{0,0,0}]',1,0,0,32,4,0,0,0,32040401,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32041201,'宝瓶星痕礼包','开启获得宝瓶星痕之一','',0,'【运营活动】','[{0,0,0}]',1,0,0,32,4,0,0,0,32040401,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32041202,'室女星痕礼包','开启获得室女星痕之一','',0,'【运营活动】','[{0,0,0}]',1,0,0,32,4,0,0,0,32040401,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32041301,'双鱼星痕礼包','开启获得双鱼星痕之一','',0,'【运营活动】','[{0,0,0}]',1,0,0,32,4,0,0,0,32040401,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32041401,'天秤星痕礼包','开启获得天秤星痕之一','',0,'【运营活动】','[{0,0,0}]',1,0,0,32,4,0,0,0,32040401,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32041501,'摩羯星痕礼包','开启获得摩羯星痕之一','',0,'【运营活动】','[{0,0,0}]',1,0,0,32,4,0,0,0,32040401,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32041601,'狮子星痕礼包','开启获得狮子星痕之一','',0,'【运营活动】','[{0,0,0}]',1,0,0,32,4,0,0,0,32040401,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32041701,'白羊星痕礼包','开启获得白羊星痕之一','',0,'【运营活动】','[{0,0,0}]',1,0,0,32,4,0,0,0,32040401,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32050004,'浓情巧克力','充满甜蜜的巧克力，食用后可获得一定数量的<color=#ff4f4f>恩爱值</color>！','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,1,1,0,0,32050004,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32050005,'暖心围脖','温暖整个冬天的围脖，使用后可可获得一定数量的<color=#ff4f4f>恩爱值</color>！','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,1,1,0,0,32050005,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32050006,'蜜意香水','满满爱意的限量版香水，使用后可获得大量的<color=#ff4f4f>恩爱值</color>！','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,1,1,0,0,32050006,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32060002,'星灵蓝色技能书包','打开获得一本蓝色的星灵技能学习书','',0,'【运营活动】','[{}]',0,0,0,32,1,0,0,0,32060002,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32060003,'星灵紫色技能书包','打开获得一本紫色的星灵技能学习书','',0,'【运营活动】','[{}]',0,0,0,32,1,0,0,0,32060002,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32060004,'星灵橙色技能书包','打开获得一本橙色的星灵技能学习书','',0,'【运营活动】','[{}]',0,0,0,32,1,0,0,0,32060002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32070001,'蓝色星灵碎片包','打开获得蓝色星灵碎片*1','',0,'【捕蝶】','[{0,0,0}]',0,0,0,32,1,0,0,0,32070001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32070003,'橙色星灵碎片包','打开获得橙色星灵碎片*1','',0,'【捕蝶】','[{0,0,0}]',0,0,0,32,1,0,0,0,32070001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080001,'初级伤害铭文礼包','打开获得本职业第1技能的橙色铭文*1，增加技能伤害','',0,'【荣耀战神】','[{0,0,0}]',0,0,0,32,1,1,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080002,'初级效果铭文礼包','打开获得本职业第1技能的红色铭文*1，增加技能特殊效果','',0,'【荣耀战神】','[{0,0,0}]',0,0,0,32,1,1,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080003,'中级伤害铭文礼包','打开获得本职业第1、2技能的橙色铭文*1，增加技能的伤害','',0,'【荣耀战神】','[{0,0,0}]',0,0,0,32,1,1,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080004,'中级效果铭文礼包','打开获得本职业第1、2技能的红色铭文*1，增加技能的特殊效果','',0,'【荣耀战神】','[{0,0,0}]',0,0,0,32,1,1,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080005,'高级伤害铭文礼包','打开获得本职业第1、2、3技能的橙色铭文*1，增加技能伤害','',0,'【荣耀战神】','[{0,0,0}]',0,0,0,32,1,1,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080006,'高级效果铭文礼包','打开获得本职业第1、2、3技能的红色铭文*1，增加技能特殊效果','',0,'【荣耀战神】','[{0,0,0}]',0,0,0,32,1,1,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080007,'特级伤害铭文礼包','打开获得本职业第1、2、3、4技能的橙色铭文*1，增加技能伤害','',0,'【荣耀战神】','[{0,0,0}]',0,0,0,32,1,1,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080008,'特级效果铭文礼包','打开获得本职业第1、2、3、4技能的红色铭文*1，增加技能特殊效果','',0,'【荣耀战神】','[{0,0,0}]',0,0,0,32,1,1,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080111,'1阶橙2星装备礼包','开启可随机获得1件1阶橙2星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080112,'1阶橙2星防具礼包','开启可随机获得1件1阶橙2星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080113,'1阶橙2星武器礼包','开启可随机获得1件1阶橙2星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080114,'1阶橙2星首饰礼包','开启可随机获得1件1阶橙2星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080115,'1阶橙2星核心礼包','开启可随机获得1件1阶橙2星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080116,'1阶橙2星配件礼包','开启可随机获得1件1阶橙2星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080117,'1阶橙2星附件礼包','开启可随机获得1件1阶橙2星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080118,'1阶橙2星驱魔礼包','开启可随机获得1件1阶橙2星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080121,'1阶红1星装备礼包','开启可随机获得1件1阶红1星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080122,'1阶红1星防具礼包','开启可随机获得1件1阶红1星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080123,'1阶红1星武器礼包','开启可随机获得1件1阶红1星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080124,'1阶红1星首饰礼包','开启可随机获得1件1阶红1星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080125,'1阶红1星核心礼包','开启可随机获得1件1阶红1星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080126,'1阶红1星配件礼包','开启可随机获得1件1阶红1星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080127,'1阶红1星附件礼包','开启可随机获得1件1阶红1星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080128,'1阶红1星驱魔礼包','开启可随机获得1件1阶红1星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080131,'1阶红2星装备礼包','开启可随机获得1件1阶红2星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080132,'1阶红2星防具礼包','开启可随机获得1件1阶红2星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080133,'1阶红2星武器礼包','开启可随机获得1件1阶红2星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080134,'1阶红2星首饰礼包','开启可随机获得1件1阶红2星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080135,'1阶红2星核心礼包','开启可随机获得1件1阶红2星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080136,'1阶红2星配件礼包','开启可随机获得1件1阶红2星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080137,'1阶红2星附件礼包','开启可随机获得1件1阶红2星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080138,'1阶红2星驱魔礼包','开启可随机获得1件1阶红2星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080141,'1阶红3星装备礼包','开启可随机获得1件1阶红3星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080142,'1阶红3星防具礼包','开启可随机获得1件1阶红3星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080143,'1阶红3星武器礼包','开启可随机获得1件1阶红3星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080144,'1阶红3星首饰礼包','开启可随机获得1件1阶红3星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080145,'1阶红3星核心礼包','开启可随机获得1件1阶红3星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080146,'1阶红3星配件礼包','开启可随机获得1件1阶红3星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080147,'1阶红3星附件礼包','开启可随机获得1件1阶红3星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080148,'1阶红3星驱魔礼包','开启可随机获得1件1阶红3星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080151,'1阶粉色装备礼包','开启可随机获得1件1阶粉色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080152,'1阶粉色防具礼包','开启可随机获得1件1阶粉色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080153,'1阶粉色武器礼包','开启可随机获得1件1阶粉色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080154,'1阶粉色首饰礼包','开启可随机获得1件1阶粉色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080155,'1阶粉色核心礼包','开启可随机获得1件1阶粉色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080156,'1阶粉色配件礼包','开启可随机获得1件1阶粉色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080157,'1阶粉色附件礼包','开启可随机获得1件1阶粉色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080158,'1阶粉色驱魔礼包','开启可随机获得1件1阶粉色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080161,'1阶神装装备礼包','开启可随机获得1件1阶神装随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080162,'1阶神装防具礼包','开启可随机获得1件1阶神装防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080163,'1阶神装武器礼包','开启可随机获得1件1阶神装武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080164,'1阶神装首饰礼包','开启可随机获得1件1阶神装首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080165,'1阶神装核心礼包','开启可随机获得1件1阶神装核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080166,'1阶神装配件礼包','开启可随机获得1件1阶神装配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080167,'1阶神装附件礼包','开启可随机获得1件1阶神装附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080168,'1阶神装驱魔礼包','开启可随机获得1件1阶神装驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080171,'1阶绿色装备礼包','开启可随机获得1件1阶绿色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080172,'1阶绿色防具礼包','开启可随机获得1件1阶绿色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080173,'1阶绿色武器礼包','开启可随机获得1件1阶绿色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080174,'1阶绿色首饰礼包','开启可随机获得1件1阶绿色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080175,'1阶绿色核心礼包','开启可随机获得1件1阶绿色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080176,'1阶绿色配件礼包','开启可随机获得1件1阶绿色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080177,'1阶绿色附件礼包','开启可随机获得1件1阶绿色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080178,'1阶绿色驱魔礼包','开启可随机获得1件1阶绿色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080181,'1阶蓝色装备礼包','开启可随机获得1件1阶蓝色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080182,'1阶蓝色防具礼包','开启可随机获得1件1阶蓝色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080183,'1阶蓝色武器礼包','开启可随机获得1件1阶蓝色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080184,'1阶蓝色首饰礼包','开启可随机获得1件1阶蓝色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080185,'1阶蓝色核心礼包','开启可随机获得1件1阶蓝色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080186,'1阶蓝色配件礼包','开启可随机获得1件1阶蓝色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080187,'1阶蓝色附件礼包','开启可随机获得1件1阶蓝色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080188,'1阶蓝色驱魔礼包','开启可随机获得1件1阶蓝色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080191,'1阶紫色装备礼包','开启可随机获得1件1阶紫色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080192,'1阶紫色防具礼包','开启可随机获得1件1阶紫色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080193,'1阶紫色武器礼包','开启可随机获得1件1阶紫色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080194,'1阶紫色首饰礼包','开启可随机获得1件1阶紫色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080195,'1阶紫色核心礼包','开启可随机获得1件1阶紫色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080196,'1阶紫色配件礼包','开启可随机获得1件1阶紫色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080197,'1阶紫色附件礼包','开启可随机获得1件1阶紫色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080198,'1阶紫色驱魔礼包','开启可随机获得1件1阶紫色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080201,'1阶橙1星装备礼包','开启可随机获得1件1阶橙1星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080202,'1阶橙1星防具礼包','开启可随机获得1件1阶橙1星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080203,'1阶橙1星武器礼包','开启可随机获得1件1阶橙1星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080204,'1阶橙1星首饰礼包','开启可随机获得1件1阶橙1星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080205,'1阶橙1星核心礼包','开启可随机获得1件1阶橙1星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080206,'1阶橙1星配件礼包','开启可随机获得1件1阶橙1星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080207,'1阶橙1星附件礼包','开启可随机获得1件1阶橙1星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080208,'1阶橙1星驱魔礼包','开启可随机获得1件1阶橙1星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080211,'2阶橙2星装备礼包','开启可随机获得1件2阶橙2星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080212,'2阶橙2星防具礼包','开启可随机获得1件2阶橙2星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080213,'2阶橙2星武器礼包','开启可随机获得1件2阶橙2星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080214,'2阶橙2星首饰礼包','开启可随机获得1件2阶橙2星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080215,'2阶橙2星核心礼包','开启可随机获得1件2阶橙2星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080216,'2阶橙2星配件礼包','开启可随机获得1件2阶橙2星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080217,'2阶橙2星附件礼包','开启可随机获得1件2阶橙2星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080218,'2阶橙2星驱魔礼包','开启可随机获得1件2阶橙2星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080221,'2阶红1星装备礼包','开启可随机获得1件2阶红1星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080222,'2阶红1星防具礼包','开启可随机获得1件2阶红1星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080223,'2阶红1星武器礼包','开启可随机获得1件2阶红1星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080224,'2阶红1星首饰礼包','开启可随机获得1件2阶红1星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080225,'2阶红1星核心礼包','开启可随机获得1件2阶红1星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080226,'2阶红1星配件礼包','开启可随机获得1件2阶红1星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080227,'2阶红1星附件礼包','开启可随机获得1件2阶红1星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080228,'2阶红1星驱魔礼包','开启可随机获得1件2阶红1星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080231,'2阶红2星装备礼包','开启可随机获得1件2阶红2星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080232,'2阶红2星防具礼包','开启可随机获得1件2阶红2星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080233,'2阶红2星武器礼包','开启可随机获得1件2阶红2星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080234,'2阶红2星首饰礼包','开启可随机获得1件2阶红2星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080235,'2阶红2星核心礼包','开启可随机获得1件2阶红2星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080236,'2阶红2星配件礼包','开启可随机获得1件2阶红2星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080237,'2阶红2星附件礼包','开启可随机获得1件2阶红2星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080238,'2阶红2星驱魔礼包','开启可随机获得1件2阶红2星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080241,'2阶红3星装备礼包','开启可随机获得1件2阶红3星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080242,'2阶红3星防具礼包','开启可随机获得1件2阶红3星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080243,'2阶红3星武器礼包','开启可随机获得1件2阶红3星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080244,'2阶红3星首饰礼包','开启可随机获得1件2阶红3星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080245,'2阶红3星核心礼包','开启可随机获得1件2阶红3星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080246,'2阶红3星配件礼包','开启可随机获得1件2阶红3星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080247,'2阶红3星附件礼包','开启可随机获得1件2阶红3星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080248,'2阶红3星驱魔礼包','开启可随机获得1件2阶红3星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080251,'2阶粉色装备礼包','开启可随机获得1件2阶粉色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080252,'2阶粉色防具礼包','开启可随机获得1件2阶粉色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080253,'2阶粉色武器礼包','开启可随机获得1件2阶粉色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080254,'2阶粉色首饰礼包','开启可随机获得1件2阶粉色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080255,'2阶粉色核心礼包','开启可随机获得1件2阶粉色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080256,'2阶粉色配件礼包','开启可随机获得1件2阶粉色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080257,'2阶粉色附件礼包','开启可随机获得1件2阶粉色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080258,'2阶粉色驱魔礼包','开启可随机获得1件2阶粉色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080261,'2阶神装装备礼包','开启可随机获得1件2阶神装随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080262,'2阶神装防具礼包','开启可随机获得1件2阶神装防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080263,'2阶神装武器礼包','开启可随机获得1件2阶神装武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080264,'2阶神装首饰礼包','开启可随机获得1件2阶神装首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080265,'2阶神装核心礼包','开启可随机获得1件2阶神装核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080266,'2阶神装配件礼包','开启可随机获得1件2阶神装配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080267,'2阶神装附件礼包','开启可随机获得1件2阶神装附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080268,'2阶神装驱魔礼包','开启可随机获得1件2阶神装驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080271,'2阶绿色装备礼包','开启可随机获得1件2阶绿色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080272,'2阶绿色防具礼包','开启可随机获得1件2阶绿色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080273,'2阶绿色武器礼包','开启可随机获得1件2阶绿色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080274,'2阶绿色首饰礼包','开启可随机获得1件2阶绿色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080275,'2阶绿色核心礼包','开启可随机获得1件2阶绿色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080276,'2阶绿色配件礼包','开启可随机获得1件2阶绿色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080277,'2阶绿色附件礼包','开启可随机获得1件2阶绿色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080278,'2阶绿色驱魔礼包','开启可随机获得1件2阶绿色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080281,'2阶蓝色装备礼包','开启可随机获得1件2阶蓝色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080282,'2阶蓝色防具礼包','开启可随机获得1件2阶蓝色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080283,'2阶蓝色武器礼包','开启可随机获得1件2阶蓝色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080284,'2阶蓝色首饰礼包','开启可随机获得1件2阶蓝色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080285,'2阶蓝色核心礼包','开启可随机获得1件2阶蓝色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080286,'2阶蓝色配件礼包','开启可随机获得1件2阶蓝色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080287,'2阶蓝色附件礼包','开启可随机获得1件2阶蓝色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080288,'2阶蓝色驱魔礼包','开启可随机获得1件2阶蓝色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080291,'2阶紫色装备礼包','开启可随机获得1件2阶紫色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080292,'2阶紫色防具礼包','开启可随机获得1件2阶紫色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080293,'2阶紫色武器礼包','开启可随机获得1件2阶紫色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080294,'2阶紫色首饰礼包','开启可随机获得1件2阶紫色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080295,'2阶紫色核心礼包','开启可随机获得1件2阶紫色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080296,'2阶紫色配件礼包','开启可随机获得1件2阶紫色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080297,'2阶紫色附件礼包','开启可随机获得1件2阶紫色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080298,'2阶紫色驱魔礼包','开启可随机获得1件2阶紫色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080301,'2阶橙1星装备礼包','开启可随机获得1件2阶橙1星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080302,'2阶橙1星防具礼包','开启可随机获得1件2阶橙1星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080303,'2阶橙1星武器礼包','开启可随机获得1件2阶橙1星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080304,'2阶橙1星首饰礼包','开启可随机获得1件2阶橙1星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080305,'2阶橙1星核心礼包','开启可随机获得1件2阶橙1星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080306,'2阶橙1星配件礼包','开启可随机获得1件2阶橙1星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080307,'2阶橙1星附件礼包','开启可随机获得1件2阶橙1星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080308,'2阶橙1星驱魔礼包','开启可随机获得1件2阶橙1星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080311,'3阶橙2星装备礼包','开启可随机获得1件3阶橙2星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080312,'3阶橙2星防具礼包','开启可随机获得1件3阶橙2星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080313,'3阶橙2星武器礼包','开启可随机获得1件3阶橙2星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080314,'3阶橙2星首饰礼包','开启可随机获得1件3阶橙2星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080315,'3阶橙2星核心礼包','开启可随机获得1件3阶橙2星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080316,'3阶橙2星配件礼包','开启可随机获得1件3阶橙2星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080317,'3阶橙2星附件礼包','开启可随机获得1件3阶橙2星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080318,'3阶橙2星驱魔礼包','开启可随机获得1件3阶橙2星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080321,'3阶红1星装备礼包','开启可随机获得1件3阶红1星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080322,'3阶红1星防具礼包','开启可随机获得1件3阶红1星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080323,'3阶红1星武器礼包','开启可随机获得1件3阶红1星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080324,'3阶红1星首饰礼包','开启可随机获得1件3阶红1星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080325,'3阶红1星核心礼包','开启可随机获得1件3阶红1星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080326,'3阶红1星配件礼包','开启可随机获得1件3阶红1星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080327,'3阶红1星附件礼包','开启可随机获得1件3阶红1星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080328,'3阶红1星驱魔礼包','开启可随机获得1件3阶红1星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080331,'3阶红2星装备礼包','开启可随机获得1件3阶红2星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080332,'3阶红2星防具礼包','开启可随机获得1件3阶红2星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080333,'3阶红2星武器礼包','开启可随机获得1件3阶红2星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080334,'3阶红2星首饰礼包','开启可随机获得1件3阶红2星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080335,'3阶红2星核心礼包','开启可随机获得1件3阶红2星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080336,'3阶红2星配件礼包','开启可随机获得1件3阶红2星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080337,'3阶红2星附件礼包','开启可随机获得1件3阶红2星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080338,'3阶红2星驱魔礼包','开启可随机获得1件3阶红2星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080341,'3阶红3星装备礼包','开启可随机获得1件3阶红3星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080342,'3阶红3星防具礼包','开启可随机获得1件3阶红3星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080343,'3阶红3星武器礼包','开启可随机获得1件3阶红3星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080344,'3阶红3星首饰礼包','开启可随机获得1件3阶红3星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080345,'3阶红3星核心礼包','开启可随机获得1件3阶红3星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080346,'3阶红3星配件礼包','开启可随机获得1件3阶红3星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080347,'3阶红3星附件礼包','开启可随机获得1件3阶红3星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080348,'3阶红3星驱魔礼包','开启可随机获得1件3阶红3星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080351,'3阶粉色装备礼包','开启可随机获得1件3阶粉色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080352,'3阶粉色防具礼包','开启可随机获得1件3阶粉色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080353,'3阶粉色武器礼包','开启可随机获得1件3阶粉色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080354,'3阶粉色首饰礼包','开启可随机获得1件3阶粉色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080355,'3阶粉色核心礼包','开启可随机获得1件3阶粉色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080356,'3阶粉色配件礼包','开启可随机获得1件3阶粉色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080357,'3阶粉色附件礼包','开启可随机获得1件3阶粉色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080358,'3阶粉色驱魔礼包','开启可随机获得1件3阶粉色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080361,'3阶神装装备礼包','开启可随机获得1件3阶神装随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080362,'3阶神装防具礼包','开启可随机获得1件3阶神装防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080363,'3阶神装武器礼包','开启可随机获得1件3阶神装武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080364,'3阶神装首饰礼包','开启可随机获得1件3阶神装首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080365,'3阶神装核心礼包','开启可随机获得1件3阶神装核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080366,'3阶神装配件礼包','开启可随机获得1件3阶神装配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080367,'3阶神装附件礼包','开启可随机获得1件3阶神装附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080368,'3阶神装驱魔礼包','开启可随机获得1件3阶神装驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080371,'3阶绿色装备礼包','开启可随机获得1件3阶绿色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080372,'3阶绿色防具礼包','开启可随机获得1件3阶绿色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080373,'3阶绿色武器礼包','开启可随机获得1件3阶绿色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080374,'3阶绿色首饰礼包','开启可随机获得1件3阶绿色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080375,'3阶绿色核心礼包','开启可随机获得1件3阶绿色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080376,'3阶绿色配件礼包','开启可随机获得1件3阶绿色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080377,'3阶绿色附件礼包','开启可随机获得1件3阶绿色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080378,'3阶绿色驱魔礼包','开启可随机获得1件3阶绿色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080381,'3阶蓝色装备礼包','开启可随机获得1件3阶蓝色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080382,'3阶蓝色防具礼包','开启可随机获得1件3阶蓝色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080383,'3阶蓝色武器礼包','开启可随机获得1件3阶蓝色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080384,'3阶蓝色首饰礼包','开启可随机获得1件3阶蓝色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080385,'3阶蓝色核心礼包','开启可随机获得1件3阶蓝色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080386,'3阶蓝色配件礼包','开启可随机获得1件3阶蓝色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080387,'3阶蓝色附件礼包','开启可随机获得1件3阶蓝色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080388,'3阶蓝色驱魔礼包','开启可随机获得1件3阶蓝色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080391,'3阶紫色装备礼包','开启可随机获得1件3阶紫色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080392,'3阶紫色防具礼包','开启可随机获得1件3阶紫色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080393,'3阶紫色武器礼包','开启可随机获得1件3阶紫色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080394,'3阶紫色首饰礼包','开启可随机获得1件3阶紫色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080395,'3阶紫色核心礼包','开启可随机获得1件3阶紫色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080396,'3阶紫色配件礼包','开启可随机获得1件3阶紫色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080397,'3阶紫色附件礼包','开启可随机获得1件3阶紫色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080398,'3阶紫色驱魔礼包','开启可随机获得1件3阶紫色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080401,'3阶橙1星装备礼包','开启可随机获得1件3阶橙1星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080402,'3阶橙1星防具礼包','开启可随机获得1件3阶橙1星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080403,'3阶橙1星武器礼包','开启可随机获得1件3阶橙1星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080404,'3阶橙1星首饰礼包','开启可随机获得1件3阶橙1星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080405,'3阶橙1星核心礼包','开启可随机获得1件3阶橙1星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080406,'3阶橙1星配件礼包','开启可随机获得1件3阶橙1星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080407,'3阶橙1星附件礼包','开启可随机获得1件3阶橙1星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080408,'3阶橙1星驱魔礼包','开启可随机获得1件3阶橙1星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080411,'4阶橙2星装备礼包','开启可随机获得1件4阶橙2星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080412,'4阶橙2星防具礼包','开启可随机获得1件4阶橙2星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080413,'4阶橙2星武器礼包','开启可随机获得1件4阶橙2星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080414,'4阶橙2星首饰礼包','开启可随机获得1件4阶橙2星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080415,'4阶橙2星核心礼包','开启可随机获得1件4阶橙2星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080416,'4阶橙2星配件礼包','开启可随机获得1件4阶橙2星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080417,'4阶橙2星附件礼包','开启可随机获得1件4阶橙2星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080418,'4阶橙2星驱魔礼包','开启可随机获得1件4阶橙2星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080421,'4阶红1星装备礼包','开启可随机获得1件4阶红1星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080422,'4阶红1星防具礼包','开启可随机获得1件4阶红1星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080423,'4阶红1星武器礼包','开启可随机获得1件4阶红1星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080424,'4阶红1星首饰礼包','开启可随机获得1件4阶红1星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080425,'4阶红1星核心礼包','开启可随机获得1件4阶红1星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080426,'4阶红1星配件礼包','开启可随机获得1件4阶红1星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080427,'4阶红1星附件礼包','开启可随机获得1件4阶红1星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080428,'4阶红1星驱魔礼包','开启可随机获得1件4阶红1星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080431,'4阶红2星装备礼包','开启可随机获得1件4阶红2星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080432,'4阶红2星防具礼包','开启可随机获得1件4阶红2星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080433,'4阶红2星武器礼包','开启可随机获得1件4阶红2星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080434,'4阶红2星首饰礼包','开启可随机获得1件4阶红2星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080435,'4阶红2星核心礼包','开启可随机获得1件4阶红2星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080436,'4阶红2星配件礼包','开启可随机获得1件4阶红2星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080437,'4阶红2星附件礼包','开启可随机获得1件4阶红2星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080438,'4阶红2星驱魔礼包','开启可随机获得1件4阶红2星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080441,'4阶红3星装备礼包','开启可随机获得1件4阶红3星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080442,'4阶红3星防具礼包','开启可随机获得1件4阶红3星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080443,'4阶红3星武器礼包','开启可随机获得1件4阶红3星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080444,'4阶红3星首饰礼包','开启可随机获得1件4阶红3星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080445,'4阶红3星核心礼包','开启可随机获得1件4阶红3星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080446,'4阶红3星配件礼包','开启可随机获得1件4阶红3星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080447,'4阶红3星附件礼包','开启可随机获得1件4阶红3星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080448,'4阶红3星驱魔礼包','开启可随机获得1件4阶红3星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080451,'4阶粉色装备礼包','开启可随机获得1件4阶粉色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080452,'4阶粉色防具礼包','开启可随机获得1件4阶粉色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080453,'4阶粉色武器礼包','开启可随机获得1件4阶粉色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080454,'4阶粉色首饰礼包','开启可随机获得1件4阶粉色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080455,'4阶粉色核心礼包','开启可随机获得1件4阶粉色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080456,'4阶粉色配件礼包','开启可随机获得1件4阶粉色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080457,'4阶粉色附件礼包','开启可随机获得1件4阶粉色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080458,'4阶粉色驱魔礼包','开启可随机获得1件4阶粉色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080461,'4阶神装装备礼包','开启可随机获得1件4阶神装随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080462,'4阶神装防具礼包','开启可随机获得1件4阶神装防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080463,'4阶神装武器礼包','开启可随机获得1件4阶神装武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080464,'4阶神装首饰礼包','开启可随机获得1件4阶神装首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080465,'4阶神装核心礼包','开启可随机获得1件4阶神装核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080466,'4阶神装配件礼包','开启可随机获得1件4阶神装配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080467,'4阶神装附件礼包','开启可随机获得1件4阶神装附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080468,'4阶神装驱魔礼包','开启可随机获得1件4阶神装驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080471,'4阶绿色装备礼包','开启可随机获得1件4阶绿色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080472,'4阶绿色防具礼包','开启可随机获得1件4阶绿色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080473,'4阶绿色武器礼包','开启可随机获得1件4阶绿色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080474,'4阶绿色首饰礼包','开启可随机获得1件4阶绿色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080475,'4阶绿色核心礼包','开启可随机获得1件4阶绿色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080476,'4阶绿色配件礼包','开启可随机获得1件4阶绿色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080477,'4阶绿色附件礼包','开启可随机获得1件4阶绿色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080478,'4阶绿色驱魔礼包','开启可随机获得1件4阶绿色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080481,'4阶蓝色装备礼包','开启可随机获得1件4阶蓝色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080482,'4阶蓝色防具礼包','开启可随机获得1件4阶蓝色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080483,'4阶蓝色武器礼包','开启可随机获得1件4阶蓝色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080484,'4阶蓝色首饰礼包','开启可随机获得1件4阶蓝色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080485,'4阶蓝色核心礼包','开启可随机获得1件4阶蓝色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080486,'4阶蓝色配件礼包','开启可随机获得1件4阶蓝色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080487,'4阶蓝色附件礼包','开启可随机获得1件4阶蓝色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080488,'4阶蓝色驱魔礼包','开启可随机获得1件4阶蓝色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080491,'4阶紫色装备礼包','开启可随机获得1件4阶紫色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080492,'4阶紫色防具礼包','开启可随机获得1件4阶紫色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080493,'4阶紫色武器礼包','开启可随机获得1件4阶紫色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080494,'4阶紫色首饰礼包','开启可随机获得1件4阶紫色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080495,'4阶紫色核心礼包','开启可随机获得1件4阶紫色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080496,'4阶紫色配件礼包','开启可随机获得1件4阶紫色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080497,'4阶紫色附件礼包','开启可随机获得1件4阶紫色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080498,'4阶紫色驱魔礼包','开启可随机获得1件4阶紫色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080501,'4阶橙1星装备礼包','开启可随机获得1件4阶橙1星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080502,'4阶橙1星防具礼包','开启可随机获得1件4阶橙1星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080503,'4阶橙1星武器礼包','开启可随机获得1件4阶橙1星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080504,'4阶橙1星首饰礼包','开启可随机获得1件4阶橙1星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080505,'4阶橙1星核心礼包','开启可随机获得1件4阶橙1星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080506,'4阶橙1星配件礼包','开启可随机获得1件4阶橙1星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080507,'4阶橙1星附件礼包','开启可随机获得1件4阶橙1星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080508,'4阶橙1星驱魔礼包','开启可随机获得1件4阶橙1星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080511,'5阶橙2星装备礼包','开启可随机获得1件5阶橙2星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080512,'5阶橙2星防具礼包','开启可随机获得1件5阶橙2星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080513,'5阶橙2星武器礼包','开启可随机获得1件5阶橙2星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080514,'5阶橙2星首饰礼包','开启可随机获得1件5阶橙2星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080515,'5阶橙2星核心礼包','开启可随机获得1件5阶橙2星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080516,'5阶橙2星配件礼包','开启可随机获得1件5阶橙2星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080517,'5阶橙2星附件礼包','开启可随机获得1件5阶橙2星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080518,'5阶橙2星驱魔礼包','开启可随机获得1件5阶橙2星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080521,'5阶红1星装备礼包','开启可随机获得1件5阶红1星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080522,'5阶红1星防具礼包','开启可随机获得1件5阶红1星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080523,'5阶红1星武器礼包','开启可随机获得1件5阶红1星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080524,'5阶红1星首饰礼包','开启可随机获得1件5阶红1星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080525,'5阶红1星核心礼包','开启可随机获得1件5阶红1星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080526,'5阶红1星配件礼包','开启可随机获得1件5阶红1星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080527,'5阶红1星附件礼包','开启可随机获得1件5阶红1星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080528,'5阶红1星驱魔礼包','开启可随机获得1件5阶红1星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080531,'5阶红2星装备礼包','开启可随机获得1件5阶红2星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080532,'5阶红2星防具礼包','开启可随机获得1件5阶红2星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080533,'5阶红2星武器礼包','开启可随机获得1件5阶红2星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080534,'5阶红2星首饰礼包','开启可随机获得1件5阶红2星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080535,'5阶红2星核心礼包','开启可随机获得1件5阶红2星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080536,'5阶红2星配件礼包','开启可随机获得1件5阶红2星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080537,'5阶红2星附件礼包','开启可随机获得1件5阶红2星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080538,'5阶红2星驱魔礼包','开启可随机获得1件5阶红2星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080541,'5阶红3星装备礼包','开启可随机获得1件5阶红3星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080542,'5阶红3星防具礼包','开启可随机获得1件5阶红3星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080543,'5阶红3星武器礼包','开启可随机获得1件5阶红3星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080544,'5阶红3星首饰礼包','开启可随机获得1件5阶红3星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080545,'5阶红3星核心礼包','开启可随机获得1件5阶红3星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080546,'5阶红3星配件礼包','开启可随机获得1件5阶红3星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080547,'5阶红3星附件礼包','开启可随机获得1件5阶红3星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080548,'5阶红3星驱魔礼包','开启可随机获得1件5阶红3星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080551,'5阶粉色装备礼包','开启可随机获得1件5阶粉色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080552,'5阶粉色防具礼包','开启可随机获得1件5阶粉色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080553,'5阶粉色武器礼包','开启可随机获得1件5阶粉色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080554,'5阶粉色首饰礼包','开启可随机获得1件5阶粉色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080555,'5阶粉色核心礼包','开启可随机获得1件5阶粉色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080556,'5阶粉色配件礼包','开启可随机获得1件5阶粉色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080557,'5阶粉色附件礼包','开启可随机获得1件5阶粉色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080558,'5阶粉色驱魔礼包','开启可随机获得1件5阶粉色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080561,'5阶神装装备礼包','开启可随机获得1件5阶神装随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080562,'5阶神装防具礼包','开启可随机获得1件5阶神装防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080563,'5阶神装武器礼包','开启可随机获得1件5阶神装武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080564,'5阶神装首饰礼包','开启可随机获得1件5阶神装首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080565,'5阶神装核心礼包','开启可随机获得1件5阶神装核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080566,'5阶神装配件礼包','开启可随机获得1件5阶神装配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080567,'5阶神装附件礼包','开启可随机获得1件5阶神装附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080568,'5阶神装驱魔礼包','开启可随机获得1件5阶神装驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080571,'5阶绿色装备礼包','开启可随机获得1件5阶绿色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080572,'5阶绿色防具礼包','开启可随机获得1件5阶绿色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080573,'5阶绿色武器礼包','开启可随机获得1件5阶绿色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080574,'5阶绿色首饰礼包','开启可随机获得1件5阶绿色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080575,'5阶绿色核心礼包','开启可随机获得1件5阶绿色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080576,'5阶绿色配件礼包','开启可随机获得1件5阶绿色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080577,'5阶绿色附件礼包','开启可随机获得1件5阶绿色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080578,'5阶绿色驱魔礼包','开启可随机获得1件5阶绿色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080581,'5阶蓝色装备礼包','开启可随机获得1件5阶蓝色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080582,'5阶蓝色防具礼包','开启可随机获得1件5阶蓝色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080583,'5阶蓝色武器礼包','开启可随机获得1件5阶蓝色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080584,'5阶蓝色首饰礼包','开启可随机获得1件5阶蓝色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080585,'5阶蓝色核心礼包','开启可随机获得1件5阶蓝色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080586,'5阶蓝色配件礼包','开启可随机获得1件5阶蓝色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080587,'5阶蓝色附件礼包','开启可随机获得1件5阶蓝色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080588,'5阶蓝色驱魔礼包','开启可随机获得1件5阶蓝色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080591,'5阶紫色装备礼包','开启可随机获得1件5阶紫色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080592,'5阶紫色防具礼包','开启可随机获得1件5阶紫色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080593,'5阶紫色武器礼包','开启可随机获得1件5阶紫色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080594,'5阶紫色首饰礼包','开启可随机获得1件5阶紫色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080595,'5阶紫色核心礼包','开启可随机获得1件5阶紫色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080596,'5阶紫色配件礼包','开启可随机获得1件5阶紫色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080597,'5阶紫色附件礼包','开启可随机获得1件5阶紫色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080598,'5阶紫色驱魔礼包','开启可随机获得1件5阶紫色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080601,'5阶橙1星装备礼包','开启可随机获得1件5阶橙1星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080602,'5阶橙1星防具礼包','开启可随机获得1件5阶橙1星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080603,'5阶橙1星武器礼包','开启可随机获得1件5阶橙1星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080604,'5阶橙1星首饰礼包','开启可随机获得1件5阶橙1星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080605,'5阶橙1星核心礼包','开启可随机获得1件5阶橙1星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080606,'5阶橙1星配件礼包','开启可随机获得1件5阶橙1星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080607,'5阶橙1星附件礼包','开启可随机获得1件5阶橙1星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080608,'5阶橙1星驱魔礼包','开启可随机获得1件5阶橙1星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080611,'6阶橙2星装备礼包','开启可随机获得1件6阶橙2星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080612,'6阶橙2星防具礼包','开启可随机获得1件6阶橙2星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080613,'6阶橙2星武器礼包','开启可随机获得1件6阶橙2星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080614,'6阶橙2星首饰礼包','开启可随机获得1件6阶橙2星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080615,'6阶橙2星核心礼包','开启可随机获得1件6阶橙2星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080616,'6阶橙2星配件礼包','开启可随机获得1件6阶橙2星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080617,'6阶橙2星附件礼包','开启可随机获得1件6阶橙2星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080618,'6阶橙2星驱魔礼包','开启可随机获得1件6阶橙2星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080621,'6阶红1星装备礼包','开启可随机获得1件6阶红1星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080622,'6阶红1星防具礼包','开启可随机获得1件6阶红1星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080623,'6阶红1星武器礼包','开启可随机获得1件6阶红1星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080624,'6阶红1星首饰礼包','开启可随机获得1件6阶红1星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080625,'6阶红1星核心礼包','开启可随机获得1件6阶红1星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080626,'6阶红1星配件礼包','开启可随机获得1件6阶红1星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080627,'6阶红1星附件礼包','开启可随机获得1件6阶红1星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080628,'6阶红1星驱魔礼包','开启可随机获得1件6阶红1星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080631,'6阶红2星装备礼包','开启可随机获得1件6阶红2星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080632,'6阶红2星防具礼包','开启可随机获得1件6阶红2星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080633,'6阶红2星武器礼包','开启可随机获得1件6阶红2星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080634,'6阶红2星首饰礼包','开启可随机获得1件6阶红2星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080635,'6阶红2星核心礼包','开启可随机获得1件6阶红2星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080636,'6阶红2星配件礼包','开启可随机获得1件6阶红2星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080637,'6阶红2星附件礼包','开启可随机获得1件6阶红2星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080638,'6阶红2星驱魔礼包','开启可随机获得1件6阶红2星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080641,'6阶红3星装备礼包','开启可随机获得1件6阶红3星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080642,'6阶红3星防具礼包','开启可随机获得1件6阶红3星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080643,'6阶红3星武器礼包','开启可随机获得1件6阶红3星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080644,'6阶红3星首饰礼包','开启可随机获得1件6阶红3星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080645,'6阶红3星核心礼包','开启可随机获得1件6阶红3星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080646,'6阶红3星配件礼包','开启可随机获得1件6阶红3星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080647,'6阶红3星附件礼包','开启可随机获得1件6阶红3星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080648,'6阶红3星驱魔礼包','开启可随机获得1件6阶红3星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080651,'6阶粉色装备礼包','开启可随机获得1件6阶粉色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080652,'6阶粉色防具礼包','开启可随机获得1件6阶粉色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080653,'6阶粉色武器礼包','开启可随机获得1件6阶粉色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080654,'6阶粉色首饰礼包','开启可随机获得1件6阶粉色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080655,'6阶粉色核心礼包','开启可随机获得1件6阶粉色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080656,'6阶粉色配件礼包','开启可随机获得1件6阶粉色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080657,'6阶粉色附件礼包','开启可随机获得1件6阶粉色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080658,'6阶粉色驱魔礼包','开启可随机获得1件6阶粉色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080661,'6阶神装装备礼包','开启可随机获得1件6阶神装随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080662,'6阶神装防具礼包','开启可随机获得1件6阶神装防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080663,'6阶神装武器礼包','开启可随机获得1件6阶神装武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080664,'6阶神装首饰礼包','开启可随机获得1件6阶神装首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080665,'6阶神装核心礼包','开启可随机获得1件6阶神装核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080666,'6阶神装配件礼包','开启可随机获得1件6阶神装配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080667,'6阶神装附件礼包','开启可随机获得1件6阶神装附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080668,'6阶神装驱魔礼包','开启可随机获得1件6阶神装驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080671,'6阶绿色装备礼包','开启可随机获得1件6阶绿色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080672,'6阶绿色防具礼包','开启可随机获得1件6阶绿色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080673,'6阶绿色武器礼包','开启可随机获得1件6阶绿色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080674,'6阶绿色首饰礼包','开启可随机获得1件6阶绿色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080675,'6阶绿色核心礼包','开启可随机获得1件6阶绿色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080676,'6阶绿色配件礼包','开启可随机获得1件6阶绿色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080677,'6阶绿色附件礼包','开启可随机获得1件6阶绿色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080678,'6阶绿色驱魔礼包','开启可随机获得1件6阶绿色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080681,'6阶蓝色装备礼包','开启可随机获得1件6阶蓝色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080682,'6阶蓝色防具礼包','开启可随机获得1件6阶蓝色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080683,'6阶蓝色武器礼包','开启可随机获得1件6阶蓝色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080684,'6阶蓝色首饰礼包','开启可随机获得1件6阶蓝色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080685,'6阶蓝色核心礼包','开启可随机获得1件6阶蓝色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080686,'6阶蓝色配件礼包','开启可随机获得1件6阶蓝色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080687,'6阶蓝色附件礼包','开启可随机获得1件6阶蓝色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080688,'6阶蓝色驱魔礼包','开启可随机获得1件6阶蓝色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080691,'6阶紫色装备礼包','开启可随机获得1件6阶紫色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080692,'6阶紫色防具礼包','开启可随机获得1件6阶紫色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080693,'6阶紫色武器礼包','开启可随机获得1件6阶紫色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080694,'6阶紫色首饰礼包','开启可随机获得1件6阶紫色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080695,'6阶紫色核心礼包','开启可随机获得1件6阶紫色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080696,'6阶紫色配件礼包','开启可随机获得1件6阶紫色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080697,'6阶紫色附件礼包','开启可随机获得1件6阶紫色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080698,'6阶紫色驱魔礼包','开启可随机获得1件6阶紫色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080701,'6阶橙1星装备礼包','开启可随机获得1件6阶橙1星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080702,'6阶橙1星防具礼包','开启可随机获得1件6阶橙1星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080703,'6阶橙1星武器礼包','开启可随机获得1件6阶橙1星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080704,'6阶橙1星首饰礼包','开启可随机获得1件6阶橙1星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080705,'6阶橙1星核心礼包','开启可随机获得1件6阶橙1星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080706,'6阶橙1星配件礼包','开启可随机获得1件6阶橙1星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080707,'6阶橙1星附件礼包','开启可随机获得1件6阶橙1星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080708,'6阶橙1星驱魔礼包','开启可随机获得1件6阶橙1星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080711,'7阶橙2星装备礼包','开启可随机获得1件7阶橙2星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080712,'7阶橙2星防具礼包','开启可随机获得1件7阶橙2星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080713,'7阶橙2星武器礼包','开启可随机获得1件7阶橙2星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080714,'7阶橙2星首饰礼包','开启可随机获得1件7阶橙2星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080715,'7阶橙2星核心礼包','开启可随机获得1件7阶橙2星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080716,'7阶橙2星配件礼包','开启可随机获得1件7阶橙2星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080717,'7阶橙2星附件礼包','开启可随机获得1件7阶橙2星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080718,'7阶橙2星驱魔礼包','开启可随机获得1件7阶橙2星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080721,'7阶红1星装备礼包','开启可随机获得1件7阶红1星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080722,'7阶红1星防具礼包','开启可随机获得1件7阶红1星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080723,'7阶红1星武器礼包','开启可随机获得1件7阶红1星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080724,'7阶红1星首饰礼包','开启可随机获得1件7阶红1星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080725,'7阶红1星核心礼包','开启可随机获得1件7阶红1星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080726,'7阶红1星配件礼包','开启可随机获得1件7阶红1星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080727,'7阶红1星附件礼包','开启可随机获得1件7阶红1星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080728,'7阶红1星驱魔礼包','开启可随机获得1件7阶红1星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080731,'7阶红2星装备礼包','开启可随机获得1件7阶红2星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080732,'7阶红2星防具礼包','开启可随机获得1件7阶红2星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080733,'7阶红2星武器礼包','开启可随机获得1件7阶红2星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080734,'7阶红2星首饰礼包','开启可随机获得1件7阶红2星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080735,'7阶红2星核心礼包','开启可随机获得1件7阶红2星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080736,'7阶红2星配件礼包','开启可随机获得1件7阶红2星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080737,'7阶红2星附件礼包','开启可随机获得1件7阶红2星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080738,'7阶红2星驱魔礼包','开启可随机获得1件7阶红2星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080741,'7阶红3星装备礼包','开启可随机获得1件7阶红3星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080742,'7阶红3星防具礼包','开启可随机获得1件7阶红3星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080743,'7阶红3星武器礼包','开启可随机获得1件7阶红3星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080744,'7阶红3星首饰礼包','开启可随机获得1件7阶红3星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080745,'7阶红3星核心礼包','开启可随机获得1件7阶红3星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080746,'7阶红3星配件礼包','开启可随机获得1件7阶红3星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080747,'7阶红3星附件礼包','开启可随机获得1件7阶红3星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080748,'7阶红3星驱魔礼包','开启可随机获得1件7阶红3星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080751,'7阶粉色装备礼包','开启可随机获得1件7阶粉色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080752,'7阶粉色防具礼包','开启可随机获得1件7阶粉色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080753,'7阶粉色武器礼包','开启可随机获得1件7阶粉色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080754,'7阶粉色首饰礼包','开启可随机获得1件7阶粉色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080755,'7阶粉色核心礼包','开启可随机获得1件7阶粉色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080756,'7阶粉色配件礼包','开启可随机获得1件7阶粉色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080757,'7阶粉色附件礼包','开启可随机获得1件7阶粉色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080758,'7阶粉色驱魔礼包','开启可随机获得1件7阶粉色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080761,'7阶神装装备礼包','开启可随机获得1件7阶神装随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080762,'7阶神装防具礼包','开启可随机获得1件7阶神装防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080763,'7阶神装武器礼包','开启可随机获得1件7阶神装武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080764,'7阶神装首饰礼包','开启可随机获得1件7阶神装首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080765,'7阶神装核心礼包','开启可随机获得1件7阶神装核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080766,'7阶神装配件礼包','开启可随机获得1件7阶神装配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080767,'7阶神装附件礼包','开启可随机获得1件7阶神装附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080768,'7阶神装驱魔礼包','开启可随机获得1件7阶神装驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080771,'7阶绿色装备礼包','开启可随机获得1件7阶绿色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080772,'7阶绿色防具礼包','开启可随机获得1件7阶绿色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080773,'7阶绿色武器礼包','开启可随机获得1件7阶绿色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080774,'7阶绿色首饰礼包','开启可随机获得1件7阶绿色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080775,'7阶绿色核心礼包','开启可随机获得1件7阶绿色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080776,'7阶绿色配件礼包','开启可随机获得1件7阶绿色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080777,'7阶绿色附件礼包','开启可随机获得1件7阶绿色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080778,'7阶绿色驱魔礼包','开启可随机获得1件7阶绿色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080781,'7阶蓝色装备礼包','开启可随机获得1件7阶蓝色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080782,'7阶蓝色防具礼包','开启可随机获得1件7阶蓝色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080783,'7阶蓝色武器礼包','开启可随机获得1件7阶蓝色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080784,'7阶蓝色首饰礼包','开启可随机获得1件7阶蓝色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080785,'7阶蓝色核心礼包','开启可随机获得1件7阶蓝色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080786,'7阶蓝色配件礼包','开启可随机获得1件7阶蓝色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080787,'7阶蓝色附件礼包','开启可随机获得1件7阶蓝色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080788,'7阶蓝色驱魔礼包','开启可随机获得1件7阶蓝色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080791,'7阶紫色装备礼包','开启可随机获得1件7阶紫色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080792,'7阶紫色防具礼包','开启可随机获得1件7阶紫色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080793,'7阶紫色武器礼包','开启可随机获得1件7阶紫色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080794,'7阶紫色首饰礼包','开启可随机获得1件7阶紫色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080795,'7阶紫色核心礼包','开启可随机获得1件7阶紫色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080796,'7阶紫色配件礼包','开启可随机获得1件7阶紫色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080797,'7阶紫色附件礼包','开启可随机获得1件7阶紫色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080798,'7阶紫色驱魔礼包','开启可随机获得1件7阶紫色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080801,'7阶橙1星装备礼包','开启可随机获得1件7阶橙1星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080802,'7阶橙1星防具礼包','开启可随机获得1件7阶橙1星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080803,'7阶橙1星武器礼包','开启可随机获得1件7阶橙1星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080804,'7阶橙1星首饰礼包','开启可随机获得1件7阶橙1星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080805,'7阶橙1星核心礼包','开启可随机获得1件7阶橙1星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080806,'7阶橙1星配件礼包','开启可随机获得1件7阶橙1星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080807,'7阶橙1星附件礼包','开启可随机获得1件7阶橙1星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080808,'7阶橙1星驱魔礼包','开启可随机获得1件7阶橙1星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080811,'8阶橙2星装备礼包','开启可随机获得1件8阶橙2星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080812,'8阶橙2星防具礼包','开启可随机获得1件8阶橙2星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080813,'8阶橙2星武器礼包','开启可随机获得1件8阶橙2星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080814,'8阶橙2星首饰礼包','开启可随机获得1件8阶橙2星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080815,'8阶橙2星核心礼包','开启可随机获得1件8阶橙2星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080816,'8阶橙2星配件礼包','开启可随机获得1件8阶橙2星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080817,'8阶橙2星附件礼包','开启可随机获得1件8阶橙2星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080818,'8阶橙2星驱魔礼包','开启可随机获得1件8阶橙2星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080821,'8阶红1星装备礼包','开启可随机获得1件8阶红1星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080822,'8阶红1星防具礼包','开启可随机获得1件8阶红1星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080823,'8阶红1星武器礼包','开启可随机获得1件8阶红1星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080824,'8阶红1星首饰礼包','开启可随机获得1件8阶红1星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080825,'8阶红1星核心礼包','开启可随机获得1件8阶红1星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080826,'8阶红1星配件礼包','开启可随机获得1件8阶红1星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080827,'8阶红1星附件礼包','开启可随机获得1件8阶红1星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080828,'8阶红1星驱魔礼包','开启可随机获得1件8阶红1星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080831,'8阶红2星装备礼包','开启可随机获得1件8阶红2星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080832,'8阶红2星防具礼包','开启可随机获得1件8阶红2星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080833,'8阶红2星武器礼包','开启可随机获得1件8阶红2星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080834,'8阶红2星首饰礼包','开启可随机获得1件8阶红2星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080835,'8阶红2星核心礼包','开启可随机获得1件8阶红2星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080836,'8阶红2星配件礼包','开启可随机获得1件8阶红2星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080837,'8阶红2星附件礼包','开启可随机获得1件8阶红2星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080838,'8阶红2星驱魔礼包','开启可随机获得1件8阶红2星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080841,'8阶红3星装备礼包','开启可随机获得1件8阶红3星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080842,'8阶红3星防具礼包','开启可随机获得1件8阶红3星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080843,'8阶红3星武器礼包','开启可随机获得1件8阶红3星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080844,'8阶红3星首饰礼包','开启可随机获得1件8阶红3星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080845,'8阶红3星核心礼包','开启可随机获得1件8阶红3星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080846,'8阶红3星配件礼包','开启可随机获得1件8阶红3星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080847,'8阶红3星附件礼包','开启可随机获得1件8阶红3星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080848,'8阶红3星驱魔礼包','开启可随机获得1件8阶红3星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080851,'8阶粉色装备礼包','开启可随机获得1件8阶粉色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080852,'8阶粉色防具礼包','开启可随机获得1件8阶粉色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080853,'8阶粉色武器礼包','开启可随机获得1件8阶粉色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080854,'8阶粉色首饰礼包','开启可随机获得1件8阶粉色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080855,'8阶粉色核心礼包','开启可随机获得1件8阶粉色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080856,'8阶粉色配件礼包','开启可随机获得1件8阶粉色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080857,'8阶粉色附件礼包','开启可随机获得1件8阶粉色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080858,'8阶粉色驱魔礼包','开启可随机获得1件8阶粉色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080861,'8阶神装装备礼包','开启可随机获得1件8阶神装随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080862,'8阶神装防具礼包','开启可随机获得1件8阶神装防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080863,'8阶神装武器礼包','开启可随机获得1件8阶神装武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080864,'8阶神装首饰礼包','开启可随机获得1件8阶神装首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080865,'8阶神装核心礼包','开启可随机获得1件8阶神装核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080866,'8阶神装配件礼包','开启可随机获得1件8阶神装配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080867,'8阶神装附件礼包','开启可随机获得1件8阶神装附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080868,'8阶神装驱魔礼包','开启可随机获得1件8阶神装驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080871,'8阶绿色装备礼包','开启可随机获得1件8阶绿色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080872,'8阶绿色防具礼包','开启可随机获得1件8阶绿色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080873,'8阶绿色武器礼包','开启可随机获得1件8阶绿色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080874,'8阶绿色首饰礼包','开启可随机获得1件8阶绿色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080875,'8阶绿色核心礼包','开启可随机获得1件8阶绿色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080876,'8阶绿色配件礼包','开启可随机获得1件8阶绿色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080877,'8阶绿色附件礼包','开启可随机获得1件8阶绿色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080878,'8阶绿色驱魔礼包','开启可随机获得1件8阶绿色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080881,'8阶蓝色装备礼包','开启可随机获得1件8阶蓝色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080882,'8阶蓝色防具礼包','开启可随机获得1件8阶蓝色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080883,'8阶蓝色武器礼包','开启可随机获得1件8阶蓝色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080884,'8阶蓝色首饰礼包','开启可随机获得1件8阶蓝色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080885,'8阶蓝色核心礼包','开启可随机获得1件8阶蓝色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080886,'8阶蓝色配件礼包','开启可随机获得1件8阶蓝色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080887,'8阶蓝色附件礼包','开启可随机获得1件8阶蓝色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080888,'8阶蓝色驱魔礼包','开启可随机获得1件8阶蓝色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080891,'8阶紫色装备礼包','开启可随机获得1件8阶紫色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080892,'8阶紫色防具礼包','开启可随机获得1件8阶紫色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080893,'8阶紫色武器礼包','开启可随机获得1件8阶紫色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080894,'8阶紫色首饰礼包','开启可随机获得1件8阶紫色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080895,'8阶紫色核心礼包','开启可随机获得1件8阶紫色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080896,'8阶紫色配件礼包','开启可随机获得1件8阶紫色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080897,'8阶紫色附件礼包','开启可随机获得1件8阶紫色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080898,'8阶紫色驱魔礼包','开启可随机获得1件8阶紫色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080901,'8阶橙1星装备礼包','开启可随机获得1件8阶橙1星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080902,'8阶橙1星防具礼包','开启可随机获得1件8阶橙1星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080903,'8阶橙1星武器礼包','开启可随机获得1件8阶橙1星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080904,'8阶橙1星首饰礼包','开启可随机获得1件8阶橙1星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080905,'8阶橙1星核心礼包','开启可随机获得1件8阶橙1星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080906,'8阶橙1星配件礼包','开启可随机获得1件8阶橙1星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080907,'8阶橙1星附件礼包','开启可随机获得1件8阶橙1星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080908,'8阶橙1星驱魔礼包','开启可随机获得1件8阶橙1星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080911,'9阶橙2星装备礼包','开启可随机获得1件9阶橙2星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080912,'9阶橙2星防具礼包','开启可随机获得1件9阶橙2星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080913,'9阶橙2星武器礼包','开启可随机获得1件9阶橙2星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080914,'9阶橙2星首饰礼包','开启可随机获得1件9阶橙2星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080915,'9阶橙2星核心礼包','开启可随机获得1件9阶橙2星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080916,'9阶橙2星配件礼包','开启可随机获得1件9阶橙2星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080917,'9阶橙2星附件礼包','开启可随机获得1件9阶橙2星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080918,'9阶橙2星驱魔礼包','开启可随机获得1件9阶橙2星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080921,'9阶红1星装备礼包','开启可随机获得1件9阶红1星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080922,'9阶红1星防具礼包','开启可随机获得1件9阶红1星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080923,'9阶红1星武器礼包','开启可随机获得1件9阶红1星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080924,'9阶红1星首饰礼包','开启可随机获得1件9阶红1星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080925,'9阶红1星核心礼包','开启可随机获得1件9阶红1星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080926,'9阶红1星配件礼包','开启可随机获得1件9阶红1星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080927,'9阶红1星附件礼包','开启可随机获得1件9阶红1星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080928,'9阶红1星驱魔礼包','开启可随机获得1件9阶红1星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080931,'9阶红2星装备礼包','开启可随机获得1件9阶红2星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080932,'9阶红2星防具礼包','开启可随机获得1件9阶红2星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080933,'9阶红2星武器礼包','开启可随机获得1件9阶红2星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080934,'9阶红2星首饰礼包','开启可随机获得1件9阶红2星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080935,'9阶红2星核心礼包','开启可随机获得1件9阶红2星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080936,'9阶红2星配件礼包','开启可随机获得1件9阶红2星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080937,'9阶红2星附件礼包','开启可随机获得1件9阶红2星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080938,'9阶红2星驱魔礼包','开启可随机获得1件9阶红2星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080941,'9阶红3星装备礼包','开启可随机获得1件9阶红3星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080942,'9阶红3星防具礼包','开启可随机获得1件9阶红3星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080943,'9阶红3星武器礼包','开启可随机获得1件9阶红3星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080944,'9阶红3星首饰礼包','开启可随机获得1件9阶红3星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080945,'9阶红3星核心礼包','开启可随机获得1件9阶红3星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080946,'9阶红3星配件礼包','开启可随机获得1件9阶红3星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080947,'9阶红3星附件礼包','开启可随机获得1件9阶红3星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080948,'9阶红3星驱魔礼包','开启可随机获得1件9阶红3星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080951,'9阶粉色装备礼包','开启可随机获得1件9阶粉色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080952,'9阶粉色防具礼包','开启可随机获得1件9阶粉色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080953,'9阶粉色武器礼包','开启可随机获得1件9阶粉色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080954,'9阶粉色首饰礼包','开启可随机获得1件9阶粉色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080955,'9阶粉色核心礼包','开启可随机获得1件9阶粉色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080956,'9阶粉色配件礼包','开启可随机获得1件9阶粉色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080957,'9阶粉色附件礼包','开启可随机获得1件9阶粉色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080958,'9阶粉色驱魔礼包','开启可随机获得1件9阶粉色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080961,'9阶神装装备礼包','开启可随机获得1件9阶神装随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080962,'9阶神装防具礼包','开启可随机获得1件9阶神装防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080963,'9阶神装武器礼包','开启可随机获得1件9阶神装武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080964,'9阶神装首饰礼包','开启可随机获得1件9阶神装首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080965,'9阶神装核心礼包','开启可随机获得1件9阶神装核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080966,'9阶神装配件礼包','开启可随机获得1件9阶神装配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080967,'9阶神装附件礼包','开启可随机获得1件9阶神装附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080968,'9阶神装驱魔礼包','开启可随机获得1件9阶神装驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080971,'9阶绿色装备礼包','开启可随机获得1件9阶绿色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080972,'9阶绿色防具礼包','开启可随机获得1件9阶绿色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080973,'9阶绿色武器礼包','开启可随机获得1件9阶绿色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080974,'9阶绿色首饰礼包','开启可随机获得1件9阶绿色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080975,'9阶绿色核心礼包','开启可随机获得1件9阶绿色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080976,'9阶绿色配件礼包','开启可随机获得1件9阶绿色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080977,'9阶绿色附件礼包','开启可随机获得1件9阶绿色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080978,'9阶绿色驱魔礼包','开启可随机获得1件9阶绿色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080981,'9阶蓝色装备礼包','开启可随机获得1件9阶蓝色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080982,'9阶蓝色防具礼包','开启可随机获得1件9阶蓝色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080983,'9阶蓝色武器礼包','开启可随机获得1件9阶蓝色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080984,'9阶蓝色首饰礼包','开启可随机获得1件9阶蓝色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080985,'9阶蓝色核心礼包','开启可随机获得1件9阶蓝色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080986,'9阶蓝色配件礼包','开启可随机获得1件9阶蓝色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080987,'9阶蓝色附件礼包','开启可随机获得1件9阶蓝色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080988,'9阶蓝色驱魔礼包','开启可随机获得1件9阶蓝色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080991,'9阶紫色装备礼包','开启可随机获得1件9阶紫色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080992,'9阶紫色防具礼包','开启可随机获得1件9阶紫色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080993,'9阶紫色武器礼包','开启可随机获得1件9阶紫色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080994,'9阶紫色首饰礼包','开启可随机获得1件9阶紫色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080995,'9阶紫色核心礼包','开启可随机获得1件9阶紫色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080996,'9阶紫色配件礼包','开启可随机获得1件9阶紫色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080997,'9阶紫色附件礼包','开启可随机获得1件9阶紫色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32080998,'9阶紫色驱魔礼包','开启可随机获得1件9阶紫色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081001,'9阶橙1星装备礼包','开启可随机获得1件9阶橙1星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081002,'9阶橙1星防具礼包','开启可随机获得1件9阶橙1星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081003,'9阶橙1星武器礼包','开启可随机获得1件9阶橙1星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081004,'9阶橙1星首饰礼包','开启可随机获得1件9阶橙1星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081005,'9阶橙1星核心礼包','开启可随机获得1件9阶橙1星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081006,'9阶橙1星配件礼包','开启可随机获得1件9阶橙1星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081007,'9阶橙1星附件礼包','开启可随机获得1件9阶橙1星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081008,'9阶橙1星驱魔礼包','开启可随机获得1件9阶橙1星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081011,'10阶橙2星装备礼包','开启可随机获得1件10阶橙2星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081012,'10阶橙2星防具礼包','开启可随机获得1件10阶橙2星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081013,'10阶橙2星武器礼包','开启可随机获得1件10阶橙2星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081014,'10阶橙2星首饰礼包','开启可随机获得1件10阶橙2星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081015,'10阶橙2星核心礼包','开启可随机获得1件10阶橙2星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081016,'10阶橙2星配件礼包','开启可随机获得1件10阶橙2星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081017,'10阶橙2星附件礼包','开启可随机获得1件10阶橙2星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081018,'10阶橙2星驱魔礼包','开启可随机获得1件10阶橙2星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081021,'10阶红1星装备礼包','开启可随机获得1件10阶红1星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081022,'10阶红1星防具礼包','开启可随机获得1件10阶红1星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081023,'10阶红1星武器礼包','开启可随机获得1件10阶红1星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081024,'10阶红1星首饰礼包','开启可随机获得1件10阶红1星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081025,'10阶红1星核心礼包','开启可随机获得1件10阶红1星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081026,'10阶红1星配件礼包','开启可随机获得1件10阶红1星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081027,'10阶红1星附件礼包','开启可随机获得1件10阶红1星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081028,'10阶红1星驱魔礼包','开启可随机获得1件10阶红1星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081031,'10阶红2星装备礼包','开启可随机获得1件10阶红2星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081032,'10阶红2星防具礼包','开启可随机获得1件10阶红2星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081033,'10阶红2星武器礼包','开启可随机获得1件10阶红2星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081034,'10阶红2星首饰礼包','开启可随机获得1件10阶红2星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081035,'10阶红2星核心礼包','开启可随机获得1件10阶红2星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081036,'10阶红2星配件礼包','开启可随机获得1件10阶红2星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081037,'10阶红2星附件礼包','开启可随机获得1件10阶红2星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081038,'10阶红2星驱魔礼包','开启可随机获得1件10阶红2星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081041,'10阶红3星装备礼包','开启可随机获得1件10阶红3星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081042,'10阶红3星防具礼包','开启可随机获得1件10阶红3星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081043,'10阶红3星武器礼包','开启可随机获得1件10阶红3星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081044,'10阶红3星首饰礼包','开启可随机获得1件10阶红3星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081045,'10阶红3星核心礼包','开启可随机获得1件10阶红3星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081046,'10阶红3星配件礼包','开启可随机获得1件10阶红3星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081047,'10阶红3星附件礼包','开启可随机获得1件10阶红3星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081048,'10阶红3星驱魔礼包','开启可随机获得1件10阶红3星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081051,'10阶粉色装备礼包','开启可随机获得1件10阶粉色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081052,'10阶粉色防具礼包','开启可随机获得1件10阶粉色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081053,'10阶粉色武器礼包','开启可随机获得1件10阶粉色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081054,'10阶粉色首饰礼包','开启可随机获得1件10阶粉色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081055,'10阶粉色核心礼包','开启可随机获得1件10阶粉色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081056,'10阶粉色配件礼包','开启可随机获得1件10阶粉色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081057,'10阶粉色附件礼包','开启可随机获得1件10阶粉色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081058,'10阶粉色驱魔礼包','开启可随机获得1件10阶粉色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081061,'10阶神装装备礼包','开启可随机获得1件10阶神装随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081062,'10阶神装防具礼包','开启可随机获得1件10阶神装防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081063,'10阶神装武器礼包','开启可随机获得1件10阶神装武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081064,'10阶神装首饰礼包','开启可随机获得1件10阶神装首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081065,'10阶神装核心礼包','开启可随机获得1件10阶神装核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081066,'10阶神装配件礼包','开启可随机获得1件10阶神装配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081067,'10阶神装附件礼包','开启可随机获得1件10阶神装附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081068,'10阶神装驱魔礼包','开启可随机获得1件10阶神装驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081071,'10阶绿色装备礼包','开启可随机获得1件10阶绿色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081072,'10阶绿色防具礼包','开启可随机获得1件10阶绿色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081073,'10阶绿色武器礼包','开启可随机获得1件10阶绿色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081074,'10阶绿色首饰礼包','开启可随机获得1件10阶绿色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081075,'10阶绿色核心礼包','开启可随机获得1件10阶绿色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081076,'10阶绿色配件礼包','开启可随机获得1件10阶绿色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081077,'10阶绿色附件礼包','开启可随机获得1件10阶绿色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081078,'10阶绿色驱魔礼包','开启可随机获得1件10阶绿色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081081,'10阶蓝色装备礼包','开启可随机获得1件10阶蓝色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081082,'10阶蓝色防具礼包','开启可随机获得1件10阶蓝色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081083,'10阶蓝色武器礼包','开启可随机获得1件10阶蓝色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081084,'10阶蓝色首饰礼包','开启可随机获得1件10阶蓝色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081085,'10阶蓝色核心礼包','开启可随机获得1件10阶蓝色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081086,'10阶蓝色配件礼包','开启可随机获得1件10阶蓝色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081087,'10阶蓝色附件礼包','开启可随机获得1件10阶蓝色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081088,'10阶蓝色驱魔礼包','开启可随机获得1件10阶蓝色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081091,'10阶紫色装备礼包','开启可随机获得1件10阶紫色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081092,'10阶紫色防具礼包','开启可随机获得1件10阶紫色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081093,'10阶紫色武器礼包','开启可随机获得1件10阶紫色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081094,'10阶紫色首饰礼包','开启可随机获得1件10阶紫色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081095,'10阶紫色核心礼包','开启可随机获得1件10阶紫色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081096,'10阶紫色配件礼包','开启可随机获得1件10阶紫色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081097,'10阶紫色附件礼包','开启可随机获得1件10阶紫色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081098,'10阶紫色驱魔礼包','开启可随机获得1件10阶紫色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081101,'10阶橙1星装备礼包','开启可随机获得1件10阶橙1星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081102,'10阶橙1星防具礼包','开启可随机获得1件10阶橙1星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081103,'10阶橙1星武器礼包','开启可随机获得1件10阶橙1星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081104,'10阶橙1星首饰礼包','开启可随机获得1件10阶橙1星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081105,'10阶橙1星核心礼包','开启可随机获得1件10阶橙1星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081106,'10阶橙1星配件礼包','开启可随机获得1件10阶橙1星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081107,'10阶橙1星附件礼包','开启可随机获得1件10阶橙1星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081108,'10阶橙1星驱魔礼包','开启可随机获得1件10阶橙1星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081111,'11阶橙2星装备礼包','开启可随机获得1件11阶橙2星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081112,'11阶橙2星防具礼包','开启可随机获得1件11阶橙2星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081113,'11阶橙2星武器礼包','开启可随机获得1件11阶橙2星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081114,'11阶橙2星首饰礼包','开启可随机获得1件11阶橙2星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081115,'11阶橙2星核心礼包','开启可随机获得1件11阶橙2星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081116,'11阶橙2星配件礼包','开启可随机获得1件11阶橙2星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081117,'11阶橙2星附件礼包','开启可随机获得1件11阶橙2星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081118,'11阶橙2星驱魔礼包','开启可随机获得1件11阶橙2星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081121,'11阶红1星装备礼包','开启可随机获得1件11阶红1星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081122,'11阶红1星防具礼包','开启可随机获得1件11阶红1星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081123,'11阶红1星武器礼包','开启可随机获得1件11阶红1星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081124,'11阶红1星首饰礼包','开启可随机获得1件11阶红1星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081125,'11阶红1星核心礼包','开启可随机获得1件11阶红1星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081126,'11阶红1星配件礼包','开启可随机获得1件11阶红1星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081127,'11阶红1星附件礼包','开启可随机获得1件11阶红1星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081128,'11阶红1星驱魔礼包','开启可随机获得1件11阶红1星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081131,'11阶红2星装备礼包','开启可随机获得1件11阶红2星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081132,'11阶红2星防具礼包','开启可随机获得1件11阶红2星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081133,'11阶红2星武器礼包','开启可随机获得1件11阶红2星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081134,'11阶红2星首饰礼包','开启可随机获得1件11阶红2星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081135,'11阶红2星核心礼包','开启可随机获得1件11阶红2星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081136,'11阶红2星配件礼包','开启可随机获得1件11阶红2星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081137,'11阶红2星附件礼包','开启可随机获得1件11阶红2星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081138,'11阶红2星驱魔礼包','开启可随机获得1件11阶红2星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081141,'11阶红3星装备礼包','开启可随机获得1件11阶红3星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081142,'11阶红3星防具礼包','开启可随机获得1件11阶红3星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081143,'11阶红3星武器礼包','开启可随机获得1件11阶红3星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081144,'11阶红3星首饰礼包','开启可随机获得1件11阶红3星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081145,'11阶红3星核心礼包','开启可随机获得1件11阶红3星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081146,'11阶红3星配件礼包','开启可随机获得1件11阶红3星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081147,'11阶红3星附件礼包','开启可随机获得1件11阶红3星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081148,'11阶红3星驱魔礼包','开启可随机获得1件11阶红3星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081151,'11阶粉色装备礼包','开启可随机获得1件11阶粉色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081152,'11阶粉色防具礼包','开启可随机获得1件11阶粉色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081153,'11阶粉色武器礼包','开启可随机获得1件11阶粉色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081154,'11阶粉色首饰礼包','开启可随机获得1件11阶粉色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081155,'11阶粉色核心礼包','开启可随机获得1件11阶粉色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081156,'11阶粉色配件礼包','开启可随机获得1件11阶粉色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081157,'11阶粉色附件礼包','开启可随机获得1件11阶粉色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081158,'11阶粉色驱魔礼包','开启可随机获得1件11阶粉色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081161,'11阶神装装备礼包','开启可随机获得1件11阶神装随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081162,'11阶神装防具礼包','开启可随机获得1件11阶神装防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081163,'11阶神装武器礼包','开启可随机获得1件11阶神装武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081164,'11阶神装首饰礼包','开启可随机获得1件11阶神装首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081165,'11阶神装核心礼包','开启可随机获得1件11阶神装核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081166,'11阶神装配件礼包','开启可随机获得1件11阶神装配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081167,'11阶神装附件礼包','开启可随机获得1件11阶神装附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081168,'11阶神装驱魔礼包','开启可随机获得1件11阶神装驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081171,'11阶绿色装备礼包','开启可随机获得1件11阶绿色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081172,'11阶绿色防具礼包','开启可随机获得1件11阶绿色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081173,'11阶绿色武器礼包','开启可随机获得1件11阶绿色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081174,'11阶绿色首饰礼包','开启可随机获得1件11阶绿色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081175,'11阶绿色核心礼包','开启可随机获得1件11阶绿色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081176,'11阶绿色配件礼包','开启可随机获得1件11阶绿色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081177,'11阶绿色附件礼包','开启可随机获得1件11阶绿色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081178,'11阶绿色驱魔礼包','开启可随机获得1件11阶绿色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081181,'11阶蓝色装备礼包','开启可随机获得1件11阶蓝色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081182,'11阶蓝色防具礼包','开启可随机获得1件11阶蓝色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081183,'11阶蓝色武器礼包','开启可随机获得1件11阶蓝色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081184,'11阶蓝色首饰礼包','开启可随机获得1件11阶蓝色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081185,'11阶蓝色核心礼包','开启可随机获得1件11阶蓝色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081186,'11阶蓝色配件礼包','开启可随机获得1件11阶蓝色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081187,'11阶蓝色附件礼包','开启可随机获得1件11阶蓝色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081188,'11阶蓝色驱魔礼包','开启可随机获得1件11阶蓝色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081191,'11阶紫色装备礼包','开启可随机获得1件11阶紫色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081192,'11阶紫色防具礼包','开启可随机获得1件11阶紫色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081193,'11阶紫色武器礼包','开启可随机获得1件11阶紫色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081194,'11阶紫色首饰礼包','开启可随机获得1件11阶紫色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081195,'11阶紫色核心礼包','开启可随机获得1件11阶紫色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081196,'11阶紫色配件礼包','开启可随机获得1件11阶紫色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081197,'11阶紫色附件礼包','开启可随机获得1件11阶紫色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081198,'11阶紫色驱魔礼包','开启可随机获得1件11阶紫色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081201,'11阶橙1星装备礼包','开启可随机获得1件11阶橙1星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081202,'11阶橙1星防具礼包','开启可随机获得1件11阶橙1星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081203,'11阶橙1星武器礼包','开启可随机获得1件11阶橙1星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081204,'11阶橙1星首饰礼包','开启可随机获得1件11阶橙1星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081205,'11阶橙1星核心礼包','开启可随机获得1件11阶橙1星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081206,'11阶橙1星配件礼包','开启可随机获得1件11阶橙1星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081207,'11阶橙1星附件礼包','开启可随机获得1件11阶橙1星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081208,'11阶橙1星驱魔礼包','开启可随机获得1件11阶橙1星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081211,'12阶橙2星装备礼包','开启可随机获得1件12阶橙2星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081212,'12阶橙2星防具礼包','开启可随机获得1件12阶橙2星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081213,'12阶橙2星武器礼包','开启可随机获得1件12阶橙2星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081214,'12阶橙2星首饰礼包','开启可随机获得1件12阶橙2星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081215,'12阶橙2星核心礼包','开启可随机获得1件12阶橙2星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081216,'12阶橙2星配件礼包','开启可随机获得1件12阶橙2星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081217,'12阶橙2星附件礼包','开启可随机获得1件12阶橙2星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081218,'12阶橙2星驱魔礼包','开启可随机获得1件12阶橙2星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081221,'12阶红1星装备礼包','开启可随机获得1件12阶红1星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081222,'12阶红1星防具礼包','开启可随机获得1件12阶红1星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081223,'12阶红1星武器礼包','开启可随机获得1件12阶红1星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081224,'12阶红1星首饰礼包','开启可随机获得1件12阶红1星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081225,'12阶红1星核心礼包','开启可随机获得1件12阶红1星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081226,'12阶红1星配件礼包','开启可随机获得1件12阶红1星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081227,'12阶红1星附件礼包','开启可随机获得1件12阶红1星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081228,'12阶红1星驱魔礼包','开启可随机获得1件12阶红1星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081231,'12阶红2星装备礼包','开启可随机获得1件12阶红2星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081232,'12阶红2星防具礼包','开启可随机获得1件12阶红2星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081233,'12阶红2星武器礼包','开启可随机获得1件12阶红2星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081234,'12阶红2星首饰礼包','开启可随机获得1件12阶红2星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081235,'12阶红2星核心礼包','开启可随机获得1件12阶红2星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081236,'12阶红2星配件礼包','开启可随机获得1件12阶红2星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081237,'12阶红2星附件礼包','开启可随机获得1件12阶红2星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081238,'12阶红2星驱魔礼包','开启可随机获得1件12阶红2星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081241,'12阶红3星装备礼包','开启可随机获得1件12阶红3星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081242,'12阶红3星防具礼包','开启可随机获得1件12阶红3星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081243,'12阶红3星武器礼包','开启可随机获得1件12阶红3星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081244,'12阶红3星首饰礼包','开启可随机获得1件12阶红3星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081245,'12阶红3星核心礼包','开启可随机获得1件12阶红3星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081246,'12阶红3星配件礼包','开启可随机获得1件12阶红3星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081247,'12阶红3星附件礼包','开启可随机获得1件12阶红3星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081248,'12阶红3星驱魔礼包','开启可随机获得1件12阶红3星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081251,'12阶粉色装备礼包','开启可随机获得1件12阶粉色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081252,'12阶粉色防具礼包','开启可随机获得1件12阶粉色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081253,'12阶粉色武器礼包','开启可随机获得1件12阶粉色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081254,'12阶粉色首饰礼包','开启可随机获得1件12阶粉色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081255,'12阶粉色核心礼包','开启可随机获得1件12阶粉色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081256,'12阶粉色配件礼包','开启可随机获得1件12阶粉色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081257,'12阶粉色附件礼包','开启可随机获得1件12阶粉色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081258,'12阶粉色驱魔礼包','开启可随机获得1件12阶粉色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081261,'12阶神装装备礼包','开启可随机获得1件12阶神装随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081262,'12阶神装防具礼包','开启可随机获得1件12阶神装防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081263,'12阶神装武器礼包','开启可随机获得1件12阶神装武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081264,'12阶神装首饰礼包','开启可随机获得1件12阶神装首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081265,'12阶神装核心礼包','开启可随机获得1件12阶神装核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081266,'12阶神装配件礼包','开启可随机获得1件12阶神装配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081267,'12阶神装附件礼包','开启可随机获得1件12阶神装附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081268,'12阶神装驱魔礼包','开启可随机获得1件12阶神装驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081271,'12阶绿色装备礼包','开启可随机获得1件12阶绿色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081272,'12阶绿色防具礼包','开启可随机获得1件12阶绿色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081273,'12阶绿色武器礼包','开启可随机获得1件12阶绿色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081274,'12阶绿色首饰礼包','开启可随机获得1件12阶绿色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081275,'12阶绿色核心礼包','开启可随机获得1件12阶绿色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081276,'12阶绿色配件礼包','开启可随机获得1件12阶绿色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081277,'12阶绿色附件礼包','开启可随机获得1件12阶绿色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081278,'12阶绿色驱魔礼包','开启可随机获得1件12阶绿色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081281,'12阶蓝色装备礼包','开启可随机获得1件12阶蓝色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081282,'12阶蓝色防具礼包','开启可随机获得1件12阶蓝色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081283,'12阶蓝色武器礼包','开启可随机获得1件12阶蓝色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081284,'12阶蓝色首饰礼包','开启可随机获得1件12阶蓝色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081285,'12阶蓝色核心礼包','开启可随机获得1件12阶蓝色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081286,'12阶蓝色配件礼包','开启可随机获得1件12阶蓝色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081287,'12阶蓝色附件礼包','开启可随机获得1件12阶蓝色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081288,'12阶蓝色驱魔礼包','开启可随机获得1件12阶蓝色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081291,'12阶紫色装备礼包','开启可随机获得1件12阶紫色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081292,'12阶紫色防具礼包','开启可随机获得1件12阶紫色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081293,'12阶紫色武器礼包','开启可随机获得1件12阶紫色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081294,'12阶紫色首饰礼包','开启可随机获得1件12阶紫色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081295,'12阶紫色核心礼包','开启可随机获得1件12阶紫色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081296,'12阶紫色配件礼包','开启可随机获得1件12阶紫色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081297,'12阶紫色附件礼包','开启可随机获得1件12阶紫色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081298,'12阶紫色驱魔礼包','开启可随机获得1件12阶紫色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081301,'12阶橙1星装备礼包','开启可随机获得1件12阶橙1星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081302,'12阶橙1星防具礼包','开启可随机获得1件12阶橙1星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081303,'12阶橙1星武器礼包','开启可随机获得1件12阶橙1星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081304,'12阶橙1星首饰礼包','开启可随机获得1件12阶橙1星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081305,'12阶橙1星核心礼包','开启可随机获得1件12阶橙1星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081306,'12阶橙1星配件礼包','开启可随机获得1件12阶橙1星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081307,'12阶橙1星附件礼包','开启可随机获得1件12阶橙1星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081308,'12阶橙1星驱魔礼包','开启可随机获得1件12阶橙1星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081311,'13阶橙2星装备礼包','开启可随机获得1件13阶橙2星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081312,'13阶橙2星防具礼包','开启可随机获得1件13阶橙2星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081313,'13阶橙2星武器礼包','开启可随机获得1件13阶橙2星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081314,'13阶橙2星首饰礼包','开启可随机获得1件13阶橙2星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081315,'13阶橙2星核心礼包','开启可随机获得1件13阶橙2星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081316,'13阶橙2星配件礼包','开启可随机获得1件13阶橙2星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081317,'13阶橙2星附件礼包','开启可随机获得1件13阶橙2星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081318,'13阶橙2星驱魔礼包','开启可随机获得1件13阶橙2星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081321,'13阶红1星装备礼包','开启可随机获得1件13阶红1星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081322,'13阶红1星防具礼包','开启可随机获得1件13阶红1星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081323,'13阶红1星武器礼包','开启可随机获得1件13阶红1星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081324,'13阶红1星首饰礼包','开启可随机获得1件13阶红1星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081325,'13阶红1星核心礼包','开启可随机获得1件13阶红1星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081326,'13阶红1星配件礼包','开启可随机获得1件13阶红1星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081327,'13阶红1星附件礼包','开启可随机获得1件13阶红1星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081328,'13阶红1星驱魔礼包','开启可随机获得1件13阶红1星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081331,'13阶红2星装备礼包','开启可随机获得1件13阶红2星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081332,'13阶红2星防具礼包','开启可随机获得1件13阶红2星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081333,'13阶红2星武器礼包','开启可随机获得1件13阶红2星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081334,'13阶红2星首饰礼包','开启可随机获得1件13阶红2星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081335,'13阶红2星核心礼包','开启可随机获得1件13阶红2星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081336,'13阶红2星配件礼包','开启可随机获得1件13阶红2星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081337,'13阶红2星附件礼包','开启可随机获得1件13阶红2星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081338,'13阶红2星驱魔礼包','开启可随机获得1件13阶红2星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081341,'13阶红3星装备礼包','开启可随机获得1件13阶红3星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081342,'13阶红3星防具礼包','开启可随机获得1件13阶红3星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081343,'13阶红3星武器礼包','开启可随机获得1件13阶红3星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081344,'13阶红3星首饰礼包','开启可随机获得1件13阶红3星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081345,'13阶红3星核心礼包','开启可随机获得1件13阶红3星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081346,'13阶红3星配件礼包','开启可随机获得1件13阶红3星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081347,'13阶红3星附件礼包','开启可随机获得1件13阶红3星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081348,'13阶红3星驱魔礼包','开启可随机获得1件13阶红3星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081351,'13阶粉色装备礼包','开启可随机获得1件13阶粉色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081352,'13阶粉色防具礼包','开启可随机获得1件13阶粉色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081353,'13阶粉色武器礼包','开启可随机获得1件13阶粉色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081354,'13阶粉色首饰礼包','开启可随机获得1件13阶粉色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081355,'13阶粉色核心礼包','开启可随机获得1件13阶粉色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081356,'13阶粉色配件礼包','开启可随机获得1件13阶粉色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081357,'13阶粉色附件礼包','开启可随机获得1件13阶粉色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081358,'13阶粉色驱魔礼包','开启可随机获得1件13阶粉色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081361,'13阶神装装备礼包','开启可随机获得1件13阶神装随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081362,'13阶神装防具礼包','开启可随机获得1件13阶神装防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081363,'13阶神装武器礼包','开启可随机获得1件13阶神装武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081364,'13阶神装首饰礼包','开启可随机获得1件13阶神装首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081365,'13阶神装核心礼包','开启可随机获得1件13阶神装核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081366,'13阶神装配件礼包','开启可随机获得1件13阶神装配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081367,'13阶神装附件礼包','开启可随机获得1件13阶神装附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081368,'13阶神装驱魔礼包','开启可随机获得1件13阶神装驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081371,'13阶绿色装备礼包','开启可随机获得1件13阶绿色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081372,'13阶绿色防具礼包','开启可随机获得1件13阶绿色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081373,'13阶绿色武器礼包','开启可随机获得1件13阶绿色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081374,'13阶绿色首饰礼包','开启可随机获得1件13阶绿色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081375,'13阶绿色核心礼包','开启可随机获得1件13阶绿色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081376,'13阶绿色配件礼包','开启可随机获得1件13阶绿色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081377,'13阶绿色附件礼包','开启可随机获得1件13阶绿色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081378,'13阶绿色驱魔礼包','开启可随机获得1件13阶绿色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081381,'13阶蓝色装备礼包','开启可随机获得1件13阶蓝色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081382,'13阶蓝色防具礼包','开启可随机获得1件13阶蓝色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081383,'13阶蓝色武器礼包','开启可随机获得1件13阶蓝色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081384,'13阶蓝色首饰礼包','开启可随机获得1件13阶蓝色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081385,'13阶蓝色核心礼包','开启可随机获得1件13阶蓝色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081386,'13阶蓝色配件礼包','开启可随机获得1件13阶蓝色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081387,'13阶蓝色附件礼包','开启可随机获得1件13阶蓝色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081388,'13阶蓝色驱魔礼包','开启可随机获得1件13阶蓝色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081391,'13阶紫色装备礼包','开启可随机获得1件13阶紫色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081392,'13阶紫色防具礼包','开启可随机获得1件13阶紫色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081393,'13阶紫色武器礼包','开启可随机获得1件13阶紫色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081394,'13阶紫色首饰礼包','开启可随机获得1件13阶紫色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081395,'13阶紫色核心礼包','开启可随机获得1件13阶紫色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081396,'13阶紫色配件礼包','开启可随机获得1件13阶紫色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081397,'13阶紫色附件礼包','开启可随机获得1件13阶紫色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081398,'13阶紫色驱魔礼包','开启可随机获得1件13阶紫色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081401,'13阶橙1星装备礼包','开启可随机获得1件13阶橙1星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081402,'13阶橙1星防具礼包','开启可随机获得1件13阶橙1星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081403,'13阶橙1星武器礼包','开启可随机获得1件13阶橙1星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081404,'13阶橙1星首饰礼包','开启可随机获得1件13阶橙1星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081405,'13阶橙1星核心礼包','开启可随机获得1件13阶橙1星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081406,'13阶橙1星配件礼包','开启可随机获得1件13阶橙1星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081407,'13阶橙1星附件礼包','开启可随机获得1件13阶橙1星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081408,'13阶橙1星驱魔礼包','开启可随机获得1件13阶橙1星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081411,'14阶橙2星装备礼包','开启可随机获得1件14阶橙2星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081412,'14阶橙2星防具礼包','开启可随机获得1件14阶橙2星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081413,'14阶橙2星武器礼包','开启可随机获得1件14阶橙2星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081414,'14阶橙2星首饰礼包','开启可随机获得1件14阶橙2星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081415,'14阶橙2星核心礼包','开启可随机获得1件14阶橙2星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081416,'14阶橙2星配件礼包','开启可随机获得1件14阶橙2星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081417,'14阶橙2星附件礼包','开启可随机获得1件14阶橙2星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081418,'14阶橙2星驱魔礼包','开启可随机获得1件14阶橙2星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081421,'14阶红1星装备礼包','开启可随机获得1件14阶红1星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081422,'14阶红1星防具礼包','开启可随机获得1件14阶红1星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081423,'14阶红1星武器礼包','开启可随机获得1件14阶红1星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081424,'14阶红1星首饰礼包','开启可随机获得1件14阶红1星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081425,'14阶红1星核心礼包','开启可随机获得1件14阶红1星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081426,'14阶红1星配件礼包','开启可随机获得1件14阶红1星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081427,'14阶红1星附件礼包','开启可随机获得1件14阶红1星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081428,'14阶红1星驱魔礼包','开启可随机获得1件14阶红1星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081431,'14阶红2星装备礼包','开启可随机获得1件14阶红2星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081432,'14阶红2星防具礼包','开启可随机获得1件14阶红2星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081433,'14阶红2星武器礼包','开启可随机获得1件14阶红2星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081434,'14阶红2星首饰礼包','开启可随机获得1件14阶红2星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081435,'14阶红2星核心礼包','开启可随机获得1件14阶红2星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081436,'14阶红2星配件礼包','开启可随机获得1件14阶红2星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081437,'14阶红2星附件礼包','开启可随机获得1件14阶红2星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081438,'14阶红2星驱魔礼包','开启可随机获得1件14阶红2星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081441,'14阶红3星装备礼包','开启可随机获得1件14阶红3星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081442,'14阶红3星防具礼包','开启可随机获得1件14阶红3星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081443,'14阶红3星武器礼包','开启可随机获得1件14阶红3星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081444,'14阶红3星首饰礼包','开启可随机获得1件14阶红3星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081445,'14阶红3星核心礼包','开启可随机获得1件14阶红3星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081446,'14阶红3星配件礼包','开启可随机获得1件14阶红3星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081447,'14阶红3星附件礼包','开启可随机获得1件14阶红3星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081448,'14阶红3星驱魔礼包','开启可随机获得1件14阶红3星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081451,'14阶粉色装备礼包','开启可随机获得1件14阶粉色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081452,'14阶粉色防具礼包','开启可随机获得1件14阶粉色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081453,'14阶粉色武器礼包','开启可随机获得1件14阶粉色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081454,'14阶粉色首饰礼包','开启可随机获得1件14阶粉色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081455,'14阶粉色核心礼包','开启可随机获得1件14阶粉色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081456,'14阶粉色配件礼包','开启可随机获得1件14阶粉色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081457,'14阶粉色附件礼包','开启可随机获得1件14阶粉色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081458,'14阶粉色驱魔礼包','开启可随机获得1件14阶粉色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081461,'14阶神装装备礼包','开启可随机获得1件14阶神装随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081462,'14阶神装防具礼包','开启可随机获得1件14阶神装防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081463,'14阶神装武器礼包','开启可随机获得1件14阶神装武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081464,'14阶神装首饰礼包','开启可随机获得1件14阶神装首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081465,'14阶神装核心礼包','开启可随机获得1件14阶神装核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081466,'14阶神装配件礼包','开启可随机获得1件14阶神装配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081467,'14阶神装附件礼包','开启可随机获得1件14阶神装附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081468,'14阶神装驱魔礼包','开启可随机获得1件14阶神装驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081471,'14阶绿色装备礼包','开启可随机获得1件14阶绿色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081472,'14阶绿色防具礼包','开启可随机获得1件14阶绿色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081473,'14阶绿色武器礼包','开启可随机获得1件14阶绿色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081474,'14阶绿色首饰礼包','开启可随机获得1件14阶绿色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081475,'14阶绿色核心礼包','开启可随机获得1件14阶绿色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081476,'14阶绿色配件礼包','开启可随机获得1件14阶绿色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081477,'14阶绿色附件礼包','开启可随机获得1件14阶绿色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081478,'14阶绿色驱魔礼包','开启可随机获得1件14阶绿色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081481,'14阶蓝色装备礼包','开启可随机获得1件14阶蓝色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081482,'14阶蓝色防具礼包','开启可随机获得1件14阶蓝色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081483,'14阶蓝色武器礼包','开启可随机获得1件14阶蓝色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081484,'14阶蓝色首饰礼包','开启可随机获得1件14阶蓝色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081485,'14阶蓝色核心礼包','开启可随机获得1件14阶蓝色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081486,'14阶蓝色配件礼包','开启可随机获得1件14阶蓝色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081487,'14阶蓝色附件礼包','开启可随机获得1件14阶蓝色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081488,'14阶蓝色驱魔礼包','开启可随机获得1件14阶蓝色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081491,'14阶紫色装备礼包','开启可随机获得1件14阶紫色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081492,'14阶紫色防具礼包','开启可随机获得1件14阶紫色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081493,'14阶紫色武器礼包','开启可随机获得1件14阶紫色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081494,'14阶紫色首饰礼包','开启可随机获得1件14阶紫色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081495,'14阶紫色核心礼包','开启可随机获得1件14阶紫色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081496,'14阶紫色配件礼包','开启可随机获得1件14阶紫色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081497,'14阶紫色附件礼包','开启可随机获得1件14阶紫色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081498,'14阶紫色驱魔礼包','开启可随机获得1件14阶紫色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081501,'14阶橙1星装备礼包','开启可随机获得1件14阶橙1星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081502,'14阶橙1星防具礼包','开启可随机获得1件14阶橙1星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081503,'14阶橙1星武器礼包','开启可随机获得1件14阶橙1星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081504,'14阶橙1星首饰礼包','开启可随机获得1件14阶橙1星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081505,'14阶橙1星核心礼包','开启可随机获得1件14阶橙1星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081506,'14阶橙1星配件礼包','开启可随机获得1件14阶橙1星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081507,'14阶橙1星附件礼包','开启可随机获得1件14阶橙1星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081508,'14阶橙1星驱魔礼包','开启可随机获得1件14阶橙1星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081511,'15阶橙2星装备礼包','开启可随机获得1件15阶橙2星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081512,'15阶橙2星防具礼包','开启可随机获得1件15阶橙2星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081513,'15阶橙2星武器礼包','开启可随机获得1件15阶橙2星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081514,'15阶橙2星首饰礼包','开启可随机获得1件15阶橙2星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081515,'15阶橙2星核心礼包','开启可随机获得1件15阶橙2星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081516,'15阶橙2星配件礼包','开启可随机获得1件15阶橙2星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081517,'15阶橙2星附件礼包','开启可随机获得1件15阶橙2星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081518,'15阶橙2星驱魔礼包','开启可随机获得1件15阶橙2星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081521,'15阶红1星装备礼包','开启可随机获得1件15阶红1星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081522,'15阶红1星防具礼包','开启可随机获得1件15阶红1星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081523,'15阶红1星武器礼包','开启可随机获得1件15阶红1星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081524,'15阶红1星首饰礼包','开启可随机获得1件15阶红1星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081525,'15阶红1星核心礼包','开启可随机获得1件15阶红1星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081526,'15阶红1星配件礼包','开启可随机获得1件15阶红1星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081527,'15阶红1星附件礼包','开启可随机获得1件15阶红1星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081528,'15阶红1星驱魔礼包','开启可随机获得1件15阶红1星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081531,'15阶红2星装备礼包','开启可随机获得1件15阶红2星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081532,'15阶红2星防具礼包','开启可随机获得1件15阶红2星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081533,'15阶红2星武器礼包','开启可随机获得1件15阶红2星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081534,'15阶红2星首饰礼包','开启可随机获得1件15阶红2星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081535,'15阶红2星核心礼包','开启可随机获得1件15阶红2星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081536,'15阶红2星配件礼包','开启可随机获得1件15阶红2星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081537,'15阶红2星附件礼包','开启可随机获得1件15阶红2星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081538,'15阶红2星驱魔礼包','开启可随机获得1件15阶红2星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081541,'15阶红3星装备礼包','开启可随机获得1件15阶红3星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081542,'15阶红3星防具礼包','开启可随机获得1件15阶红3星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081543,'15阶红3星武器礼包','开启可随机获得1件15阶红3星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081544,'15阶红3星首饰礼包','开启可随机获得1件15阶红3星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081545,'15阶红3星核心礼包','开启可随机获得1件15阶红3星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081546,'15阶红3星配件礼包','开启可随机获得1件15阶红3星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081547,'15阶红3星附件礼包','开启可随机获得1件15阶红3星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081548,'15阶红3星驱魔礼包','开启可随机获得1件15阶红3星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081551,'15阶粉色装备礼包','开启可随机获得1件15阶粉色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081552,'15阶粉色防具礼包','开启可随机获得1件15阶粉色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081553,'15阶粉色武器礼包','开启可随机获得1件15阶粉色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081554,'15阶粉色首饰礼包','开启可随机获得1件15阶粉色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081555,'15阶粉色核心礼包','开启可随机获得1件15阶粉色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081556,'15阶粉色配件礼包','开启可随机获得1件15阶粉色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081557,'15阶粉色附件礼包','开启可随机获得1件15阶粉色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081558,'15阶粉色驱魔礼包','开启可随机获得1件15阶粉色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081561,'15阶神装装备礼包','开启可随机获得1件15阶神装随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081562,'15阶神装防具礼包','开启可随机获得1件15阶神装防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081563,'15阶神装武器礼包','开启可随机获得1件15阶神装武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081564,'15阶神装首饰礼包','开启可随机获得1件15阶神装首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081565,'15阶神装核心礼包','开启可随机获得1件15阶神装核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081566,'15阶神装配件礼包','开启可随机获得1件15阶神装配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081567,'15阶神装附件礼包','开启可随机获得1件15阶神装附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081568,'15阶神装驱魔礼包','开启可随机获得1件15阶神装驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081571,'15阶绿色装备礼包','开启可随机获得1件15阶绿色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081572,'15阶绿色防具礼包','开启可随机获得1件15阶绿色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081573,'15阶绿色武器礼包','开启可随机获得1件15阶绿色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081574,'15阶绿色首饰礼包','开启可随机获得1件15阶绿色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081575,'15阶绿色核心礼包','开启可随机获得1件15阶绿色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081576,'15阶绿色配件礼包','开启可随机获得1件15阶绿色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081577,'15阶绿色附件礼包','开启可随机获得1件15阶绿色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081578,'15阶绿色驱魔礼包','开启可随机获得1件15阶绿色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081581,'15阶蓝色装备礼包','开启可随机获得1件15阶蓝色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081582,'15阶蓝色防具礼包','开启可随机获得1件15阶蓝色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081583,'15阶蓝色武器礼包','开启可随机获得1件15阶蓝色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081584,'15阶蓝色首饰礼包','开启可随机获得1件15阶蓝色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081585,'15阶蓝色核心礼包','开启可随机获得1件15阶蓝色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081586,'15阶蓝色配件礼包','开启可随机获得1件15阶蓝色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081587,'15阶蓝色附件礼包','开启可随机获得1件15阶蓝色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081588,'15阶蓝色驱魔礼包','开启可随机获得1件15阶蓝色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081591,'15阶紫色装备礼包','开启可随机获得1件15阶紫色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081592,'15阶紫色防具礼包','开启可随机获得1件15阶紫色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081593,'15阶紫色武器礼包','开启可随机获得1件15阶紫色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081594,'15阶紫色首饰礼包','开启可随机获得1件15阶紫色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081595,'15阶紫色核心礼包','开启可随机获得1件15阶紫色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081596,'15阶紫色配件礼包','开启可随机获得1件15阶紫色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081597,'15阶紫色附件礼包','开启可随机获得1件15阶紫色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081598,'15阶紫色驱魔礼包','开启可随机获得1件15阶紫色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081601,'15阶橙1星装备礼包','开启可随机获得1件15阶橙1星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081602,'15阶橙1星防具礼包','开启可随机获得1件15阶橙1星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081603,'15阶橙1星武器礼包','开启可随机获得1件15阶橙1星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081604,'15阶橙1星首饰礼包','开启可随机获得1件15阶橙1星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081605,'15阶橙1星核心礼包','开启可随机获得1件15阶橙1星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081606,'15阶橙1星配件礼包','开启可随机获得1件15阶橙1星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081607,'15阶橙1星附件礼包','开启可随机获得1件15阶橙1星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081608,'15阶橙1星驱魔礼包','开启可随机获得1件15阶橙1星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081611,'16阶橙2星装备礼包','开启可随机获得1件16阶橙2星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081612,'16阶橙2星防具礼包','开启可随机获得1件16阶橙2星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081613,'16阶橙2星武器礼包','开启可随机获得1件16阶橙2星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081614,'16阶橙2星首饰礼包','开启可随机获得1件16阶橙2星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081615,'16阶橙2星核心礼包','开启可随机获得1件16阶橙2星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081616,'16阶橙2星配件礼包','开启可随机获得1件16阶橙2星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081617,'16阶橙2星附件礼包','开启可随机获得1件16阶橙2星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081618,'16阶橙2星驱魔礼包','开启可随机获得1件16阶橙2星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081621,'16阶红1星装备礼包','开启可随机获得1件16阶红1星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081622,'16阶红1星防具礼包','开启可随机获得1件16阶红1星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081623,'16阶红1星武器礼包','开启可随机获得1件16阶红1星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081624,'16阶红1星首饰礼包','开启可随机获得1件16阶红1星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081625,'16阶红1星核心礼包','开启可随机获得1件16阶红1星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081626,'16阶红1星配件礼包','开启可随机获得1件16阶红1星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081627,'16阶红1星附件礼包','开启可随机获得1件16阶红1星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081628,'16阶红1星驱魔礼包','开启可随机获得1件16阶红1星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081631,'16阶红2星装备礼包','开启可随机获得1件16阶红2星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081632,'16阶红2星防具礼包','开启可随机获得1件16阶红2星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081633,'16阶红2星武器礼包','开启可随机获得1件16阶红2星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081634,'16阶红2星首饰礼包','开启可随机获得1件16阶红2星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081635,'16阶红2星核心礼包','开启可随机获得1件16阶红2星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081636,'16阶红2星配件礼包','开启可随机获得1件16阶红2星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081637,'16阶红2星附件礼包','开启可随机获得1件16阶红2星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081638,'16阶红2星驱魔礼包','开启可随机获得1件16阶红2星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081641,'16阶红3星装备礼包','开启可随机获得1件16阶红3星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081642,'16阶红3星防具礼包','开启可随机获得1件16阶红3星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081643,'16阶红3星武器礼包','开启可随机获得1件16阶红3星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081644,'16阶红3星首饰礼包','开启可随机获得1件16阶红3星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081645,'16阶红3星核心礼包','开启可随机获得1件16阶红3星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081646,'16阶红3星配件礼包','开启可随机获得1件16阶红3星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081647,'16阶红3星附件礼包','开启可随机获得1件16阶红3星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081648,'16阶红3星驱魔礼包','开启可随机获得1件16阶红3星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081651,'16阶粉色装备礼包','开启可随机获得1件16阶粉色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081652,'16阶粉色防具礼包','开启可随机获得1件16阶粉色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081653,'16阶粉色武器礼包','开启可随机获得1件16阶粉色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081654,'16阶粉色首饰礼包','开启可随机获得1件16阶粉色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081655,'16阶粉色核心礼包','开启可随机获得1件16阶粉色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081656,'16阶粉色配件礼包','开启可随机获得1件16阶粉色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081657,'16阶粉色附件礼包','开启可随机获得1件16阶粉色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081658,'16阶粉色驱魔礼包','开启可随机获得1件16阶粉色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081661,'16阶神装装备礼包','开启可随机获得1件16阶神装随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081662,'16阶神装防具礼包','开启可随机获得1件16阶神装防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081663,'16阶神装武器礼包','开启可随机获得1件16阶神装武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081664,'16阶神装首饰礼包','开启可随机获得1件16阶神装首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081665,'16阶神装核心礼包','开启可随机获得1件16阶神装核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081666,'16阶神装配件礼包','开启可随机获得1件16阶神装配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081667,'16阶神装附件礼包','开启可随机获得1件16阶神装附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081668,'16阶神装驱魔礼包','开启可随机获得1件16阶神装驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081671,'16阶绿色装备礼包','开启可随机获得1件16阶绿色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081672,'16阶绿色防具礼包','开启可随机获得1件16阶绿色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081673,'16阶绿色武器礼包','开启可随机获得1件16阶绿色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081674,'16阶绿色首饰礼包','开启可随机获得1件16阶绿色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081675,'16阶绿色核心礼包','开启可随机获得1件16阶绿色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081676,'16阶绿色配件礼包','开启可随机获得1件16阶绿色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081677,'16阶绿色附件礼包','开启可随机获得1件16阶绿色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081678,'16阶绿色驱魔礼包','开启可随机获得1件16阶绿色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081681,'16阶蓝色装备礼包','开启可随机获得1件16阶蓝色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081682,'16阶蓝色防具礼包','开启可随机获得1件16阶蓝色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081683,'16阶蓝色武器礼包','开启可随机获得1件16阶蓝色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081684,'16阶蓝色首饰礼包','开启可随机获得1件16阶蓝色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081685,'16阶蓝色核心礼包','开启可随机获得1件16阶蓝色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081686,'16阶蓝色配件礼包','开启可随机获得1件16阶蓝色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081687,'16阶蓝色附件礼包','开启可随机获得1件16阶蓝色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081688,'16阶蓝色驱魔礼包','开启可随机获得1件16阶蓝色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081691,'16阶紫色装备礼包','开启可随机获得1件16阶紫色随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081692,'16阶紫色防具礼包','开启可随机获得1件16阶紫色防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081693,'16阶紫色武器礼包','开启可随机获得1件16阶紫色武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081694,'16阶紫色首饰礼包','开启可随机获得1件16阶紫色首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081695,'16阶紫色核心礼包','开启可随机获得1件16阶紫色核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081696,'16阶紫色配件礼包','开启可随机获得1件16阶紫色配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081697,'16阶紫色附件礼包','开启可随机获得1件16阶紫色附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081698,'16阶紫色驱魔礼包','开启可随机获得1件16阶紫色驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081701,'16阶橙1星装备礼包','开启可随机获得1件16阶橙1星随机装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081702,'16阶橙1星防具礼包','开启可随机获得1件16阶橙1星防具装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081703,'16阶橙1星武器礼包','开启可随机获得1件16阶橙1星武器装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081704,'16阶橙1星首饰礼包','开启可随机获得1件16阶橙1星首饰装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080004,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081705,'16阶橙1星核心礼包','开启可随机获得1件16阶橙1星核心装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081706,'16阶橙1星配件礼包','开启可随机获得1件16阶橙1星配件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081707,'16阶橙1星附件礼包','开启可随机获得1件16阶橙1星附件装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32081708,'16阶橙1星驱魔礼包','开启可随机获得1件16阶橙1星驱魔装备','',0,'【装备副本】','[{0,0,0}]',0,0,1,32,8,0,0,0,32080001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32090001,'破碎神格礼包','打开获得50-85个破碎神格','',0,'【荣耀战神】','[{0,0,0}]',0,0,0,32,9,0,0,0,32050002,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32090002,'精品神格礼包','打开获得20-35个精品神格','',0,'【荣耀战神】','[{0,0,0}]',0,0,0,32,9,0,0,0,32050002,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32090003,'完美神格礼包','打开获得4-8个完美神格','',0,'【荣耀战神】','[{0,0,0}]',0,0,0,32,9,0,0,0,32050002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32100002,'2阶装备包','打开获得多件装备，可能获得橙色红色装备','',0,'【装备副本】','[{0,0,0}]',0,0,0,32,10,0,0,0,32080002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32100003,'3阶装备包','打开获得多件装备，可能获得橙色红色装备','',0,'【装备副本】','[{0,0,0}]',0,0,0,32,10,0,0,0,32080002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32100004,'4阶装备包','打开获得多件装备，可能获得橙色红色装备','',0,'【装备副本】','[{0,0,0}]',0,0,0,32,10,0,0,0,32080002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32100005,'5阶装备包','打开获得多件装备，可能获得橙色红色装备','',0,'【装备副本】','[{0,0,0}]',0,0,0,32,10,0,0,0,32080002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32100006,'6阶装备包','打开获得多件装备，可能获得橙色红色装备','',0,'【装备副本】','[{0,0,0}]',0,0,0,32,10,0,0,0,32080002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32100007,'7阶装备包','打开获得多件装备，可能获得橙色红色装备','',0,'【装备副本】','[{0,0,0}]',0,0,0,32,10,0,0,0,32080002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32100008,'8阶装备包','打开获得多件装备，可能获得橙色红色装备','',0,'【装备副本】','[{0,0,0}]',0,0,0,32,10,0,0,0,32080002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32100009,'9阶装备包','打开获得多件装备，可能获得橙色红色装备','',0,'【装备副本】','[{0,0,0}]',0,0,0,32,10,0,0,0,32080002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32100010,'10阶装备包','打开获得多件装备，可能获得橙色红色装备','',0,'【装备副本】','[{0,0,0}]',0,0,0,32,10,0,0,0,32080002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32100011,'11阶装备包','打开获得多件装备，可能获得橙色红色装备','',0,'【装备副本】','[{0,0,0}]',0,0,0,32,10,0,0,0,32080002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32100012,'12阶装备包','打开获得多件装备，可能获得橙色红色装备','',0,'【装备副本】','[{0,0,0}]',0,0,0,32,10,0,0,0,32080002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32100013,'13阶装备包','打开获得多件装备，可能获得橙色红色装备','',0,'【装备副本】','[{0,0,0}]',0,0,0,32,10,0,0,0,32080002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32100014,'14阶装备包','打开获得多件装备，可能获得橙色红色装备','',0,'【装备副本】','[{0,0,0}]',0,0,0,32,10,0,0,0,32080002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32100015,'15阶装备包','打开获得多件装备，可能获得橙色红色装备','',0,'【装备副本】','[{0,0,0}]',0,0,0,32,10,0,0,0,32080002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32100016,'16阶装备包','打开获得多件装备，可能获得橙色红色装备','',0,'【装备副本】','[{0,0,0}]',0,0,0,32,10,0,0,0,32080002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32110011,'橙+3普通灵装箱','打开获得橙+3普通星灵装备','',0,'【星灵争霸】','[{0,0,0}]',0,0,0,32,11,0,0,0,32110000,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32110012,'橙+3珍贵灵装箱','打开获得橙+3珍贵星灵装备','',0,'【星灵争霸】','[{0,0,0}]',0,0,0,32,11,0,0,0,32110000,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32110013,'橙+3稀有灵装箱','打开获得橙+3稀有星灵装备','',0,'【星灵争霸】','[{0,0,0}]',0,0,0,32,11,0,0,0,32110000,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32110014,'橙+3传奇灵装箱','打开获得橙+3传奇星灵装备','',0,'【星灵争霸】','[{0,0,0}]',0,0,0,32,11,0,0,0,32110000,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32110021,'橙+2普通灵装箱','打开获得橙+2普通星灵装备','',0,'【星灵争霸】','[{0,0,0}]',0,0,0,32,11,0,0,0,32110000,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32110022,'橙+2珍贵灵装箱','打开获得橙+2珍贵星灵装备','',0,'【星灵争霸】','[{0,0,0}]',0,0,0,32,11,0,0,0,32110000,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32110023,'橙+2稀有灵装箱','打开获得橙+2稀有星灵装备','',0,'【星灵争霸】','[{0,0,0}]',0,0,0,32,11,0,0,0,32110000,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32110024,'橙+2传奇灵装箱','打开获得橙+2传奇星灵装备','',0,'【星灵争霸】','[{0,0,0}]',0,0,0,32,11,0,0,0,32110000,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32110031,'橙+1普通灵装箱','打开获得橙+1普通星灵装备','',0,'【星灵争霸】','[{0,0,0}]',0,0,0,32,11,0,0,0,32110000,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32110032,'橙+1珍贵灵装箱','打开获得橙+1珍贵星灵装备','',0,'【星灵争霸】','[{0,0,0}]',0,0,0,32,11,0,0,0,32110000,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32110033,'橙+1稀有灵装箱','打开获得橙+1稀有星灵装备','',0,'【星灵争霸】','[{0,0,0}]',0,0,0,32,11,0,0,0,32110000,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32110034,'橙+1传奇灵装箱','打开获得橙+1传奇星灵装备','',0,'【星灵争霸】','[{0,0,0}]',0,0,0,32,11,0,0,0,32110000,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32110041,'橙色普通灵装箱','打开获得橙色普通星灵装备','',0,'【星灵争霸】','[{0,0,0}]',0,0,0,32,11,0,0,0,32110000,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32110042,'橙色珍贵灵装箱','打开获得橙色珍贵星灵装备','',0,'【星灵争霸】','[{0,0,0}]',0,0,0,32,11,0,0,0,32110000,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32110043,'橙色稀有灵装箱','打开获得橙色稀有星灵装备','',0,'【星灵争霸】','[{0,0,0}]',0,0,0,32,11,0,0,0,32110000,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32110044,'橙色传奇灵装箱','打开获得橙色传奇星灵装备','',0,'【星灵争霸】','[{0,0,0}]',0,0,0,32,11,0,0,0,32110000,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32110051,'紫+2普通灵装箱','打开获得紫+2普通星灵装备','',0,'【星灵争霸】','[{0,0,0}]',0,0,0,32,11,0,0,0,32110000,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32110052,'紫+2珍贵灵装箱','打开获得紫+2珍贵星灵装备','',0,'【星灵争霸】','[{0,0,0}]',0,0,0,32,11,0,0,0,32110000,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32110053,'紫+2稀有灵装箱','打开获得紫+2稀有星灵装备','',0,'【星灵争霸】','[{0,0,0}]',0,0,0,32,11,0,0,0,32110000,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32110054,'紫+2传奇灵装箱','打开获得紫+2传奇星灵装备','',0,'【星灵争霸】','[{0,0,0}]',0,0,0,32,11,0,0,0,32110000,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32110061,'紫色普通灵装箱','打开获得紫色普通星灵装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,11,0,0,0,32110000,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32110062,'紫色珍贵灵装箱','打开获得紫色珍贵星灵装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,11,0,0,0,32110000,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32110063,'紫色稀有灵装箱','打开获得紫色稀有星灵装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,11,0,0,0,32110000,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32110064,'紫色传奇灵装箱','打开获得紫色传奇星灵装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,11,0,0,0,32110000,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32110071,'紫+1普通灵装箱','打开获得紫+1普通星灵装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,11,0,0,0,32110000,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32110072,'紫+1珍贵灵装箱','打开获得紫+1珍贵星灵装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,11,0,0,0,32110000,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32110073,'紫+1稀有灵装箱','打开获得紫+1稀有星灵装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,11,0,0,0,32110000,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32110074,'紫+1传奇灵装箱','打开获得紫+1传奇星灵装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,11,0,0,0,32110000,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32110081,'蓝色普通灵装箱','打开获得蓝色普通星灵装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,11,0,0,0,32110000,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32110082,'蓝色珍贵灵装箱','打开获得蓝色珍贵星灵装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,11,0,0,0,32110000,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32110083,'蓝色稀有灵装箱','打开获得蓝色稀有星灵装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,11,0,0,0,32110000,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32110084,'蓝色传奇灵装箱','打开获得蓝色传奇星灵装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,11,0,0,0,32110000,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32110091,'蓝+1普通灵装箱','打开获得蓝+1普通星灵装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,11,0,0,0,32110000,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32110092,'蓝+1珍贵灵装箱','打开获得蓝+1珍贵星灵装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,11,0,0,0,32110000,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32110093,'蓝+1稀有灵装箱','打开获得蓝+1稀有星灵装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,11,0,0,0,32110000,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32110094,'蓝+1传奇灵装箱','打开获得蓝+1传奇星灵装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,11,0,0,0,32110000,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32110101,'基础普通灵装箱','打开获得蓝色星灵装备','',0,'【星灵争霸】','[{0,0,0}]',0,0,0,32,11,0,0,0,32110000,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32110102,'基础珍贵灵装箱','打开获得蓝色星灵装备','',0,'【星灵争霸】','[{0,0,0}]',0,0,0,32,11,0,0,0,32110000,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32110103,'基础稀有灵装箱','打开获得蓝色星灵装备','',0,'【星灵争霸】','[{0,0,0}]',0,0,0,32,11,0,0,0,32110000,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32110104,'基础传奇灵装箱','打开获得蓝色星灵装备','',0,'【星灵争霸】','[{0,0,0}]',0,0,0,32,11,0,0,0,32110000,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32110201,'惊喜普通灵装箱','打开获得星灵装备，概率获得紫色橙色装备','',0,'【星灵争霸】','[{0,0,0}]',0,0,0,32,11,0,0,0,32110000,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32110202,'惊喜珍贵灵装箱','打开获得星灵装备，概率获得紫色橙色装备','',0,'【星灵争霸】','[{0,0,0}]',0,0,0,32,11,0,0,0,32110000,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32110203,'惊喜稀有灵装箱','打开获得星灵装备，概率获得紫色橙色装备','',0,'【星灵争霸】','[{0,0,0}]',0,0,0,32,11,0,0,0,32110000,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32110204,'惊喜传奇灵装箱','打开获得星灵装备，概率获得紫色橙色装备','',0,'【星灵争霸】','[{0,0,0}]',0,0,0,32,11,0,0,0,32110000,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32111001,'蓝+2普通灵装箱','打开获得蓝+2普通星灵装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,11,0,0,0,32110000,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32111002,'蓝+2珍贵灵装箱','打开获得蓝+2珍贵星灵装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,11,0,0,0,32110000,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32111003,'蓝+2稀有灵装箱','打开获得蓝+2稀有星灵装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,11,0,0,0,32110000,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32111004,'蓝+2传奇灵装箱','打开获得蓝+2传奇星灵装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,11,0,0,0,32110000,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32120101,'星痕惊喜礼包','开启后可获得星辰碎片，还可获得随机星痕','',0,'【时空乱流】','[{0,0,0}]',1,0,0,32,12,1,0,0,32080002,0,0,99999,1,0,0,0,'[]',0,1,0,1,'[]','[]',0,0,0,0),(32120102,'星痕惊喜礼包','开启后可获得星辰碎片，还可获得随机星痕','',0,'【时空乱流】','[{0,0,0}]',0,0,0,32,12,0,0,0,32080002,0,0,99999,1,0,0,0,'[]',0,1,0,1,'[]','[]',0,0,0,0),(32120201,'星痕惊喜礼包','开启后可获得星辰碎片，还可获得随机星痕','',0,'【时空乱流】','[{0,0,0}]',0,0,0,32,12,0,0,0,32080003,0,0,99999,1,0,0,0,'[]',0,1,0,1,'[]','[]',0,0,0,0),(32120202,'星痕惊喜礼包','开启后可获得星辰碎片，还可获得随机星痕','',0,'【时空乱流】','[{0,0,0}]',0,0,0,32,12,0,0,0,32080004,0,0,99999,1,0,0,0,'[]',0,1,0,1,'[]','[]',0,0,0,0),(32120301,'星痕惊喜礼包','开启后可获得星辰碎片，还可获得随机星痕','',0,'【时空乱流】','[{0,0,0}]',0,0,0,32,12,0,0,0,32080004,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32120302,'星痕惊喜礼包','开启后可获得星辰碎片，还可获得随机星痕','',0,'【时空乱流】','[{0,0,0}]',0,0,0,32,12,1,0,0,32080004,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32120401,'星痕惊喜礼包','开启后可获得星辰碎片，还可获得随机星痕','',0,'【时空乱流】','[{0,0,0}]',0,0,0,32,12,0,0,0,32080004,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32120402,'星痕惊喜礼包','开启后可获得星辰碎片，还可获得随机星痕','',0,'【时空乱流】','[{0,0,0}]',0,0,0,32,12,1,0,0,32080004,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32130001,'坐骑装备箱','开启后可获得随机坐骑装备','',0,'【跨服入侵】','[{0,0,0}]',1,0,0,32,13,1,0,0,32170001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32130002,'坐骑装备箱','开启后可获得随机坐骑装备，有可能获得蓝色品质的装备哦','',0,'【跨服入侵】','[{0,0,0}]',1,0,0,32,13,1,0,0,32170001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32130003,'坐骑装备箱','开启后可获得随机坐骑装备，有可能获得橙色品质的珍贵装备哦','',0,'【跨服入侵】','[{0,0,0}]',1,0,0,32,13,1,0,0,32170002,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32130004,'蓝3星坐骑装备箱','开启后可获得随机蓝3星坐骑装备','',0,'【运营活动】','[{0,0,0}]',1,0,0,32,13,1,0,0,32170001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32140001,'绝版攻击宝石箱','开启后可随机获得以下宝石中的一个：\\n<color=#fba65a>初级星耀宝石</color>\\n<color=#fba65a>初级月华宝石</color>\\n<color=#fba65a>初级阳炎宝石</color>\\n<color=#fba65a>初级晨辉宝石</color>','',0,'【跨服1VN】','[{0,0,0}]',1,0,0,32,14,1,0,0,32140001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32140002,'绝版防御宝石箱','开启后可随机获得以下宝石中的一个：\\n<color=#fba65a>初级风灵宝石</color>\\n<color=#fba65a>初级木魂宝石</color>\\n<color=#fba65a>初级土耀宝石</color>\\n<color=#fba65a>初级冰晶宝石</color>','',0,'【跨服1VN】','[{0,0,0}]',1,0,0,32,14,1,0,0,32140002,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32150001,'红色珍贵魂珠礼包','开启后可随机获得一个红色品质魂珠','',0,'【魂珠寻宝】','[{0,0,0}]',1,0,0,32,15,1,0,0,32150001,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32150002,'幸运魂珠包','开启后可随机获得一个绿色蓝色魂珠，概率获得紫色魂珠','',0,'【魂珠副本】','[{0,0,0}]',1,0,0,32,15,1,0,0,32150001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32150003,'奇迹魂珠包','开启后可随机获得一个魂珠，最高可以获得橙色魂珠！','',0,'【魂珠副本】','[{0,0,0}]',1,0,0,32,15,1,0,0,32150001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32150004,'魂石箱子','开启后可随机获得以下魂石中的一个：\\n<color=#f14041>精金宝具石</color>\\n<color=#f14041>魔兽源石</color>\\n<color=#f14041>魔羽源石</color>\\n<color=#f18310>瑟银宝具石</color>\\n<color=#f18310>巨兽源石</color>\\n<color=#f18310>圣羽源石</color>\\n<color=#f54bff>青钢宝具石</color>\\n<color=#f54bff>蛮兽源石</color>\\n<color=#f54bff>暗羽源石</color>\\n','',0,'【运营活动】','[{0,0,0}]',1,0,0,32,15,1,0,0,32000005,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32160001,'幸运魂珠箱','开启<color=#4eae1a>概率</color>获得以下物品中的1件\\n<color=#f14041>随机红色魂珠*1</color>\\n<color=#f14041>红色供养魂珠*5</color>\\n<color=#f18310>随机橙色魂珠*1</color>\\n<color=#f18310>橙色供养魂珠*5</color>','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,16,1,0,0,32150001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32160002,'幸运羽毛箱','开启<color=#4eae1a>概率</color>获得以下物品中的1件\\n翅膀合成材料\\n<color=#f14041>  风驰之羽*1</color>\\n<color=#f18310>  迅疾之羽*1</color>\\n<color=#f54bff>  轻盈之羽*1</color>\\n\\n翅膀精炼材料\\n<color=#f18310>  传奇羽魂*2</color>','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,16,1,0,0,32000005,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32160003,'sr星灵碎片箱','开启<color=#4eae1a>概率</color>获得:\\n随机sr级星灵碎片*3\\nsr级星灵碎片*6\\nsr级星灵碎片*10','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,16,1,0,0,32160003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32160004,'星灵技能书箱','开启获得随机紫色或橙色星灵技能书','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,16,1,0,0,32080002,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32160005,'魂珠经验宝箱','开启获得随机品质的1个供养魂珠','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,16,1,0,0,32150001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32160006,'魂珠宝箱','开启随机获得1个已解锁魂珠','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,16,1,0,0,32150001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32160007,'魂珠灵石礼包','开启可获得橙色供养魂珠*8，魂珠灵石*40','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,16,1,0,0,32050003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32160008,'强袭·光武礼包','开启获得本职业对应强袭·光武','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,16,1,0,0,32050003,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32160009,'焚烬·光武礼包','开启获得本职业对应焚烬·光武','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,16,1,0,0,32050003,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32160010,'暗裔·光武礼包','开启获得本职业对应暗裔·光武','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,16,1,0,0,32150001,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32160011,'（随机)坐骑碎片礼包','开启随机获得1个坐骑碎片','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,16,1,0,0,32150001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32160012,'（随机)降神碎片礼包','开启随机获得1个降神碎片','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,16,1,0,0,32150001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32160013,'（随机)星灵碎片礼包','开启随机获得1个星灵碎片','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,16,1,0,0,32150001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32160014,'洗炼石礼包','开启随机获得10个洗练石','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,16,1,0,0,32150001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32160015,'坐骑装备大礼包','开启随机获得1件坐骑装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,16,1,0,0,32150001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32160016,'坐骑装备中礼包','开启随机获得1件坐骑装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,16,1,0,0,32150001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32160017,'坐骑装备小礼包','开启随机获得1件坐骑装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,16,1,0,0,32150001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32160018,'降神印记大礼包','开启随机获得3个降神印记','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,16,1,0,0,32150001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32160019,'降神印记中礼包','开启随机获得2个降神印记','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,16,1,0,0,32150001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32160020,'降神印记小礼包','开启随机获得1个降神印记','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,16,1,0,0,32150001,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32160021,'神装合成材料礼包','开启随机获得1个神装合成材料','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,16,1,0,0,32150001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32160022,'高级魂器礼包','开启随机获得1个高级魂器','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,16,1,0,0,32150001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32160023,'珍品魂器礼包','开启随机获得1个珍品魂器','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,16,1,0,0,32150001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32160024,'1星橙色魂器礼包','开启随机获得1个1星橙色魂器','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,16,1,0,0,32150001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32170001,'绿1星坐骑装备箱','开启获得随机一件绿1星坐骑装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,17,1,0,0,32170001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32170002,'绿2星坐骑装备箱','开启获得随机一件绿2星坐骑装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,17,1,0,0,32170001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32170003,'绿3星坐骑装备箱','开启获得随机一件绿3星坐骑装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,17,1,0,0,32170001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32170004,'绿4星坐骑装备箱','开启获得随机一件绿4星坐骑装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,17,1,0,0,32170001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32170005,'绿5星坐骑装备箱','开启获得随机一件绿5星坐骑装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,17,1,0,0,32170001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32170101,'蓝1星坐骑装备箱','开启获得随机一件蓝1星坐骑装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,17,1,0,0,32170001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32170102,'蓝2星坐骑装备箱','开启获得随机一件蓝2星坐骑装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,17,1,0,0,32170001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32170103,'蓝3星坐骑装备箱','开启获得随机一件蓝3星坐骑装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,17,1,0,0,32170001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32170104,'蓝4星坐骑装备箱','开启获得随机一件蓝4星坐骑装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,17,1,0,0,32170001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32170105,'蓝5星坐骑装备箱','开启获得随机一件蓝5星坐骑装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,17,1,0,0,32170001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32170201,'紫1星坐骑装备箱','开启获得随机一件紫1星坐骑装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,17,1,0,0,32170002,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32170202,'紫2星坐骑装备箱','开启获得随机一件紫2星坐骑装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,17,1,0,0,32170002,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32170203,'紫3星坐骑装备箱','开启获得随机一件紫3星坐骑装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,17,1,0,0,32170002,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32170204,'紫4星坐骑装备箱','开启获得随机一件紫4星坐骑装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,17,1,0,0,32170002,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32170205,'紫5星坐骑装备箱','开启获得随机一件紫5星坐骑装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,17,1,0,0,32170002,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32170301,'橙1星坐骑装备箱','开启获得随机一件橙1星坐骑装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,17,1,0,0,32170003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32170302,'橙2星坐骑装备箱','开启获得随机一件橙2星坐骑装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,17,1,0,0,32170003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32170303,'橙3星坐骑装备箱','开启获得随机一件橙3星坐骑装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,17,1,0,0,32170003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32170304,'橙4星坐骑装备箱','开启获得随机一件橙4星坐骑装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,17,1,0,0,32170003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32170305,'橙5星坐骑装备箱','开启获得随机一件橙5星坐骑装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,17,1,0,0,32170003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32170401,'红1星坐骑装备箱','开启获得随机一件红1星坐骑装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,17,1,0,0,32170003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32170402,'红2星坐骑装备箱','开启获得随机一件红2星坐骑装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,17,1,0,0,32170003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32170403,'红3星坐骑装备箱','开启获得随机一件红3星坐骑装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,17,1,0,0,32170003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32170404,'红4星坐骑装备箱','开启获得随机一件红4星坐骑装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,17,1,0,0,32170003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32170405,'红5星坐骑装备箱','开启获得随机一件红5星坐骑装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,17,1,0,0,32170003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32170501,'粉1星坐骑装备箱','开启获得随机一件粉1星坐骑装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,17,1,0,0,32170003,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32170502,'粉2星坐骑装备箱','开启获得随机一件粉2星坐骑装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,17,1,0,0,32170003,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32170503,'粉3星坐骑装备箱','开启获得随机一件粉3星坐骑装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,17,1,0,0,32170003,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32170504,'粉4星坐骑装备箱','开启获得随机一件粉4星坐骑装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,17,1,0,0,32170003,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(32170505,'粉5星坐骑装备箱','开启获得随机一件粉5星坐骑装备','',0,'【运营活动】','[{0,0,0}]',0,0,0,32,17,1,0,0,32170003,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34010001,'霸主神装武器盒','公会争霸给予强者的奖励','',0,'【公会争霸】','[{402,4,1}]',0,0,0,34,0,1,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34010002,'霸主神装首饰盒','公会争霸给予强者的奖励','',0,'【公会争霸】','[{402,4,1}]',0,0,0,34,0,0,0,0,32080071,0,0,99999,6,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34010003,'1级红宝石自选包','打开可以得到一颗指定宝石','',0,'【运营活动】','[{0,0,0}]',0,0,0,34,0,0,0,0,32010009,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34010004,'1级蓝宝石自选包','打开可以得到一颗指定宝石','',0,'【运营活动】','[{0,0,0}]',0,0,0,34,0,0,0,0,32010006,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34010005,'2级红宝石自选包','打开可以得到一颗指定宝石','',0,'【运营活动】','[{0,0,0}]',0,0,0,34,0,0,0,0,32010009,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34010006,'2级蓝宝石自选包','打开可以得到一颗指定宝石','',0,'【运营活动】','[{0,0,0}]',0,0,0,34,0,0,0,0,32010009,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34010007,'3级红宝石自选包','打开可以得到一颗指定宝石','',0,'【运营活动】','[{0,0,0}]',0,0,0,34,0,0,0,0,32010006,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34010008,'3级蓝宝石自选包','打开可以得到一颗指定宝石','',0,'【运营活动】','[{0,0,0}]',0,0,0,34,0,0,0,0,32010009,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34010009,'4级红宝石自选包','打开可以得到一颗指定宝石','',0,'【运营活动】','[{0,0,0}]',0,0,0,34,0,0,0,0,32010006,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34010010,'4级蓝宝石自选包','打开可以得到一颗指定宝石','',0,'【运营活动】','[{0,0,0}]',0,0,0,34,0,0,0,0,32010009,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34010011,'5级红宝石自选包','打开可以得到一颗指定宝石','',0,'【运营活动】','[{0,0,0}]',0,0,0,34,0,0,0,0,32010006,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34010012,'5级蓝宝石自选包','打开可以得到一颗指定宝石','',0,'【运营活动】','[{0,0,0}]',0,0,0,34,0,0,0,0,32010009,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34010013,'6级红宝石自选包','打开可以得到一颗指定宝石','',0,'【运营活动】','[{0,0,0}]',0,0,0,34,0,0,0,0,32010006,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34010014,'6级蓝宝石自选包','打开可以得到一颗指定宝石','',0,'【运营活动】','[{0,0,0}]',0,0,0,34,0,0,0,0,32010009,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34010015,'7级红宝石自选包','打开可以得到一颗指定宝石','',0,'【运营活动】','[{0,0,0}]',0,0,0,34,0,0,0,0,32010006,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34010016,'7级蓝宝石自选包','打开可以得到一颗指定宝石','',0,'【运营活动】','[{0,0,0}]',0,0,0,34,0,0,0,0,32010007,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34010017,'8级红宝石自选包','打开可以得到一颗指定宝石','',0,'【运营活动,跨服1vn】','[{621,0,1}]',0,0,0,34,0,0,0,0,32010006,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34010018,'8级蓝宝石自选包','打开可以得到一颗指定宝石','',0,'【运营活动,跨服1vn】','[{621,0,1}]',0,0,0,34,0,0,0,0,32010009,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34010019,'9级红宝石自选包','打开可以得到一颗指定宝石','',0,'【运营活动】','[{0,0,0}]',0,0,0,34,0,0,0,0,32010006,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34010020,'9级蓝宝石自选包','打开可以得到一颗指定宝石','',0,'【运营活动】','[{0,0,0}]',0,0,0,34,0,0,0,0,32010007,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34010021,'狂暴之力星灵包','打开可以从以下道具中选择一个\\n<color=#f18310>金牛座碎片*4</color>\\n<color=#f18310>狮子座碎片*4</color>\\n<color=#f18310>白羊座碎片*4</color>','',0,'【运营活动】','[{0,0,0}]',0,0,0,34,0,0,0,0,32160003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34010022,'sr星灵包(自选)','打开可以从以下星灵中选择一个\\n<color=#f18310>金牛座*1</color>\\n<color=#f18310>双子座*1</color>\\n<color=#f18310>白羊座*1</color>','',0,'【运营活动】','[{0,0,0}]',0,0,0,34,0,0,0,0,32160003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34010023,'（自选）相框礼包','打开可以得到一个指定道具','',0,'【运营活动】','[{0,0,0}]',0,0,0,34,0,0,0,0,32010006,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34010024,'（自选）称号礼包','打开可以得到一个指定道具','',0,'【运营活动】','[{0,0,0}]',0,0,0,34,0,0,0,0,32010006,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34010025,'（自选)坐骑碎片礼包','打开可以得到一个指定道具','',0,'【运营活动】','[{0,0,0}]',0,0,0,34,0,0,0,0,32010006,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34010026,'（自选)降神碎片礼包','打开可以得到一个指定道具','',0,'【运营活动】','[{0,0,0}]',0,0,0,34,0,0,0,0,32010006,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34010027,'（自选)星灵碎片礼包','打开可以得到一个指定道具','',0,'【运营活动】','[{0,0,0}]',0,0,0,34,0,0,0,0,32010006,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34010028,'（自选）6星神魂礼包','打开可以得到一个指定道具','',0,'【运营活动】','[{0,0,0}]',0,0,0,34,0,0,0,0,32010006,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34020001,'绿1星自选兽灵箱','开启选择一件绿1星兽灵装备','',0,'【跨服入侵商店】','[{0,0,0}]',0,0,0,34,0,1,0,0,32170001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34020002,'绿2星自选兽灵箱','开启选择一件绿2星兽灵装备','',0,'【跨服入侵商店】','[{0,0,0}]',0,0,0,34,0,1,0,0,32170001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34020003,'绿3星自选兽灵箱','开启选择一件绿3星兽灵装备','',0,'【跨服入侵商店】','[{0,0,0}]',0,0,0,34,0,1,0,0,32170001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34020004,'绿4星自选兽灵箱','开启选择一件绿4星兽灵装备','',0,'【跨服入侵商店】','[{0,0,0}]',0,0,0,34,0,1,0,0,32170001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34020005,'绿5星自选兽灵箱','开启选择一件绿5星兽灵装备','',0,'【跨服入侵商店】','[{0,0,0}]',0,0,0,34,0,1,0,0,32170001,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34020101,'蓝1星自选兽灵箱','开启选择一件蓝1星兽灵装备','',0,'【跨服入侵商店】','[{0,0,0}]',0,0,0,34,0,1,0,0,32170001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34020102,'蓝2星自选兽灵箱','开启选择一件蓝2星兽灵装备','',0,'【跨服入侵商店】','[{0,0,0}]',0,0,0,34,0,1,0,0,32170001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34020103,'蓝3星自选兽灵箱','开启选择一件蓝3星兽灵装备','',0,'【跨服入侵商店】','[{0,0,0}]',0,0,0,34,0,1,0,0,32170001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34020104,'蓝4星自选兽灵箱','开启选择一件蓝4星兽灵装备','',0,'【跨服入侵商店】','[{0,0,0}]',0,0,0,34,0,1,0,0,32170001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34020105,'蓝5星自选兽灵箱','开启选择一件蓝5星兽灵装备','',0,'【跨服入侵商店】','[{0,0,0}]',0,0,0,34,0,1,0,0,32170001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34020201,'紫1星自选兽灵箱','开启选择一件紫1星兽灵装备','',0,'【跨服入侵商店】','[{0,0,0}]',0,0,0,34,0,1,0,0,32170002,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34020202,'紫2星自选兽灵箱','开启选择一件紫2星兽灵装备','',0,'【跨服入侵商店】','[{0,0,0}]',0,0,0,34,0,1,0,0,32170002,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34020203,'紫3星自选兽灵箱','开启选择一件紫3星兽灵装备','',0,'【跨服入侵商店】','[{0,0,0}]',0,0,0,34,0,1,0,0,32170002,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34020204,'紫4星自选兽灵箱','开启选择一件紫4星兽灵装备','',0,'【跨服入侵商店】','[{0,0,0}]',0,0,0,34,0,1,0,0,32170002,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34020205,'紫5星自选兽灵箱','开启选择一件紫5星兽灵装备','',0,'【跨服入侵商店】','[{0,0,0}]',0,0,0,34,0,1,0,0,32170002,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34020301,'橙1星自选兽灵箱','开启选择一件橙1星兽灵装备','',0,'【跨服入侵商店】','[{0,0,0}]',0,0,0,34,0,1,0,0,32170003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34020302,'橙2星自选兽灵箱','开启选择一件橙2星兽灵装备','',0,'【跨服入侵商店】','[{0,0,0}]',0,0,0,34,0,1,0,0,32170003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34020303,'橙3星自选兽灵箱','开启选择一件橙3星兽灵装备','',0,'【跨服入侵商店】','[{0,0,0}]',0,0,0,34,0,1,0,0,32170003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34020304,'橙4星自选兽灵箱','开启选择一件橙4星兽灵装备','',0,'【跨服入侵商店】','[{0,0,0}]',0,0,0,34,0,1,0,0,32170003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34020305,'橙5星自选兽灵箱','开启选择一件橙5星兽灵装备','',0,'【跨服入侵商店】','[{0,0,0}]',0,0,0,34,0,1,0,0,32170003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34020401,'红1星自选兽灵箱','开启选择一件红1星兽灵装备','',0,'【跨服入侵商店】','[{0,0,0}]',0,0,0,34,0,1,0,0,32170003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34020402,'红2星自选兽灵箱','开启选择一件红2星兽灵装备','',0,'【跨服入侵商店】','[{0,0,0}]',0,0,0,34,0,1,0,0,32170003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34020403,'红3星自选兽灵箱','开启选择一件红3星兽灵装备','',0,'【跨服入侵商店】','[{0,0,0}]',0,0,0,34,0,1,0,0,32170003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34020404,'红4星自选兽灵箱','开启选择一件红4星兽灵装备','',0,'【跨服入侵商店】','[{0,0,0}]',0,0,0,34,0,1,0,0,32170003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34020405,'红5星自选兽灵箱','开启选择一件红5星兽灵装备','',0,'【跨服入侵商店】','[{0,0,0}]',0,0,0,34,0,1,0,0,32170003,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34020501,'粉1星自选兽灵箱','开启选择一件粉1星兽灵装备','',0,'【跨服入侵商店】','[{0,0,0}]',0,0,0,34,0,1,0,0,32170003,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34020502,'粉2星自选兽灵箱','开启选择一件粉2星兽灵装备','',0,'【跨服入侵商店】','[{0,0,0}]',0,0,0,34,0,1,0,0,32170003,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34020503,'粉3星自选兽灵箱','开启选择一件粉3星兽灵装备','',0,'【跨服入侵商店】','[{0,0,0}]',0,0,0,34,0,1,0,0,32170003,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34020504,'粉4星自选兽灵箱','开启选择一件粉4星兽灵装备','',0,'【跨服入侵商店】','[{0,0,0}]',0,0,0,34,0,1,0,0,32170003,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(34020505,'粉5星自选兽灵箱','开启选择一件粉5星兽灵装备','',0,'【跨服入侵商店】','[{0,0,0}]',0,0,0,34,0,1,0,0,32170003,0,0,99999,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(36010001,'钻石','充值获得的货币，可用于购买物品','',0,'【充值】','[{0,0,0}]',0,0,0,36,1,0,0,0,36010001,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(36010002,'粉钻','除了市场交易不能使用外，可以在其他任何途径下优先替代钻石使用。使用效果与使用钻石一致，即可增加VIP经验，也会被计算到钻石消费活动中。','',0,'【交易】','[{0,0,0}]',0,0,0,36,10,0,0,0,36010002,0,0,9999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(36020001,'绑钻','游戏内产出的货币，可用来购买商品','',0,'【运营活动】','[{0,0,0}]',0,0,0,36,2,0,0,0,36020001,0,0,9999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(36030001,'金币','游戏内产出的货币，可用来购买商品','',0,'【金币矿洞,日常任务】','[{90,3,1},{300,2,1}]',0,0,0,36,3,0,0,0,36030001,0,0,9999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(36040001,'贵族2·月度卡','首次使用可直升黄金VIP2，增加<color=#f18310>30天</color>贵族时间，尊贵特权随心享：\\n<color=#f18310>专属贵族礼包；\\n杀怪经验+10%；\\n免费飞行；</color>\\n\\n使用后获得对应的贵族经验与使用时间，使用多张贵族卡只取最高经验，开通黄金贵族后每天登录签到+5点经验，消耗钻石也能增加贵族经验哦！','',0,'【商城】','[{153,1,1}]',0,0,0,36,4,1,0,0,36040001,0,0,9999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(36040002,'贵族3·季度卡','首次使用可直升黄金VIP3，增加<color=#f18310>90天</color>贵族时间，尊贵特权随心享：\\n<color=#f18310>专属贵族礼包；\\n杀怪经验+10%；\\n免费飞行；</color>\\n\\n使用后获得对应的贵族经验与使用时间，使用多张贵族卡只取最高经验，开通贵族后每天登录签到可+5点经验，消耗钻石也能增加贵族经验哦！','',0,'【商城】','[{153,1,1}]',0,0,0,36,4,1,0,0,36040002,0,0,9999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(36040003,'贵族4·半年卡','首次使用可直升黄金VIP4，增加<color=#f18310>180天</color>贵族时间，尊贵特权随心享：\\n<color=#f18310>专属贵族豪华礼包；\\n杀怪经验+20%；\\n免费飞行；</color>\\n\\n使用后获得对应的贵族经验与使用时间，使用多张贵族卡只取最高经验，开通贵族后每天登录签到可+5点经验，消耗钻石也能增加贵族经验哦！','',0,'【商城】','[{153,1,1}]',0,0,0,36,4,1,0,0,36040003,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(36040004,'永久白银卡','贵族特权永久享受！使用后可限时享受<color=#f18310>免费无限飞行</color>，打怪<color=#f18310>经验增加10%</color>的贵族专属特权。','',0,'【新手活动】','[{0,0,0}]',1,0,1,36,4,0,0,0,36040004,0,0,9999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(36040005,'至尊贵族卡','使用后可升级为更高级的荣耀贵族，享受更多荣耀专属的特权~','',0,'【商城】','[{153,1,1}]',0,0,0,36,4,1,0,0,36040005,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(36040006,'白银VIP3','使用后晋升至白银VIP3，可以享受白银VIP专属特权','',0,'【新手活动】','[{0,0,0}]',1,0,1,36,4,0,0,0,36040006,0,0,9999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(36040007,'白银VIP5','使用后晋升至白银VIP5，可以享受白银VIP专属特权','',0,'【新手活动】','[{0,0,0}]',1,0,1,36,4,0,0,0,36040007,0,0,9999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(36040008,'至尊贵族体验卡','使用后可体验至尊贵族特权','',0,'【商城】','[{153,1,1}]',0,0,0,36,4,1,0,0,36040005,0,0,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(36040009,'20·VIP经验','使用后可增加20点VIP经验值','',0,'【运营活动】','[{0,0,0}]',1,0,1,36,4,0,0,0,36040009,0,0,9999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(36040010,'30·VIP经验','使用后可增加30点VIP经验值','',0,'【运营活动】','[{0,0,0}]',1,0,1,36,4,0,0,0,36040010,0,0,9999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(36050001,'公会贡献','可用于学习公会技能','',0,'【公会任务,公会争霸】','[{300,2,1},{402,4,1}]',0,0,0,36,5,0,0,0,36050001,0,0,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(36050002,'公会资金','可用来提升公会技能等级上限','',0,'【公会任务,公会争霸】','[{300,2,1},{402,4,1}]',0,0,0,36,5,0,0,0,36050002,0,0,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(36050003,'公会成长值','可用来提升公会等级','',0,'【公会任务】','[{300,2,1}]',0,0,0,36,5,0,0,0,36050003,0,0,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(36060001,'经验','在世界中闯荡累积的生存经验，可以提升人物等级，解锁强大功能！','',0,'【经验副本,日常任务,公会任务】','[{610,31,1},{300,2,1},{300,2,1}]',0,0,0,36,3,0,0,0,36060001,0,0,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(36070001,'魅力值','魅力值','',0,'【礼物赠送】','[{223,1,1}]',0,0,0,36,7,0,0,0,36070001,0,0,0,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(36070002,'花香值','花香值','',0,'【礼物赠送】','[{223,1,1}]',0,0,0,36,7,0,0,0,36070002,0,0,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(36090001,'海神币','无尽海域通用货币。可以在商城-海神宝库中兑换珍稀道具','',0,'【无尽海域】','[{607,0,1}]',0,0,0,36,9,1,0,0,36090001,0,0,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(36100001,'吞噬值','吞噬值','',0,'【装备吞噬】','[{0,0,0}]',0,0,0,36,255,0,0,0,36070001,0,0,0,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(36160001,'荣耀勋章','可在荣耀商城中购买商品','',0,'【竞技场】','[{280,0,1}]',0,0,0,36,16,0,0,0,36160001,0,0,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(36160002,'竞技声望','可在3V3商城中购买商品','',0,'【跨服3v3】','[{650,1,1}]',0,0,0,36,255,0,0,0,36160002,0,0,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(36160003,'跨服城战积分','跨服城战积分','',0,'【无尽海域】','[{607,0,1}]',0,0,0,36,255,0,0,0,36160003,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(36160004,'星魂之力','星灵装备强化时使用的神秘宝物','',0,'','[{0,0,0}]',0,0,0,36,255,0,0,0,36160003,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(36160005,'星魂币','用于星界商店兑换兑换','',0,'【星界试炼】','[{0,0,0}]',1,0,0,36,255,0,0,0,36160005,0,0,99999,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(36160006,'入侵币','可在跨服入侵商店中购买商品','',0,'【跨服入侵】','[{0,0,0}]',0,0,0,36,255,0,0,0,36160002,0,0,0,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(36160007,'魂珠经验','用于培养魂珠','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,36,255,0,0,0,36160003,0,1,0,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(36160008,'魂珠碎片','用于兑换魂珠','',0,'【魂珠寻宝,魂珠塔】','[{0,0,0}]',0,0,0,36,255,0,0,0,36160004,0,1,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(36160009,'至尊币','用于至尊VIP商城','',0,'【充值,至尊VIP日常任务】','[{0,0,0}]',0,0,0,36,255,0,0,0,36160009,0,0,999999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(36180001,'寻宝积分','用于寻宝积分兑换','',0,'【龙王秘宝】','[{416,0,1}]',1,0,0,36,18,0,0,0,36180001,0,0,99999,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(36210001,'60钻石卡','女神的祝福，使用获得60钻石','',0,'【运营活动】','[{0,0,0}]',0,0,1,36,21,0,0,0,36210001,0,0,99999,3,0,0,604800,'[]',0,1,0,0,'[]','[]',0,0,0,0),(36210002,'300钻石卡','女神的祝福，使用获得300钻石','',0,'【运营活动】','[{0,0,0}]',0,0,1,36,21,0,0,0,36210002,0,0,99999,3,0,0,604800,'[]',0,1,0,0,'[]','[]',0,0,0,0),(36210003,'680钻石卡','女神的祝福，使用获得680钻石','',0,'【运营活动】','[{0,0,0}]',0,0,1,36,21,0,0,0,36210003,0,0,99999,3,0,0,604800,'[]',0,1,0,0,'[]','[]',0,0,0,0),(36210004,'1280钻石卡','女神的祝福，使用获得1280钻石','',0,'【运营活动】','[{0,0,0}]',0,0,1,36,21,0,0,0,36210004,0,0,99999,3,0,0,604800,'[]',0,1,0,0,'[]','[]',0,0,0,0),(36210005,'1980钻石卡','女神的祝福，使用获得1980钻石','',0,'【运营活动】','[{0,0,0}]',0,0,1,36,21,0,0,0,36210005,0,0,99999,3,0,0,604800,'[]',0,1,0,0,'[]','[]',0,0,0,0),(36210006,'3280钻石卡','女神的祝福，使用获得3280钻石','',0,'【运营活动】','[{0,0,0}]',0,0,1,36,21,0,0,0,36210006,0,0,99999,3,0,0,604800,'[]',0,1,0,0,'[]','[]',0,0,0,0),(36210007,'6480钻石卡','女神的祝福，使用获得6480钻石','',0,'【运营活动】','[{0,0,0}]',0,0,1,36,21,0,0,0,36210007,0,0,99999,3,0,0,604800,'[]',0,1,0,0,'[]','[]',0,0,0,0),(36210008,'18元绑定钻石礼包','女神的祝福，使用激活7天的绑钻礼包','',0,'【运营活动】','[{0,0,0}]',0,0,1,36,21,0,0,0,36210008,0,0,99999,3,0,0,604800,'[]',0,1,0,0,'[]','[]',0,0,0,0),(36210009,'12元每日礼包卡','打开可获得充值-每日礼包的奖励','',0,'【运营活动】','[{0,0,0}]',0,0,0,36,21,1,0,0,36210009,0,1,999999,0,0,0,604800,'[]',0,1,0,0,'[]','[]',0,0,0,0),(37010000,'测试经验书','测试经验书','',0,'【装备副本,原罪祭坛】','[{0,0,0}]',0,0,0,37,1,0,0,0,37010001,0,0,99,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(37010001,'直升1级书[220]','220级前使用增加1级经验,220级以上使用增加经验：<color=#4eae1a>12000000</color>','',0,'【运营活动】','[{0,0,0}]',0,0,0,37,1,1,0,0,37010001,0,0,99,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(37010002,'直升1级书[280]','280级前使用增加1级经验,280级以上使用增加经验：<color=#4eae1a>57000000</color>','',0,'【运营活动】','[{0,0,0}]',0,0,0,37,1,1,0,0,37010001,0,0,99,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(37010101,'1阶经验书','使用后可增加角色经验：<color=#4eae1a>155000</color>','',0,'【首领boss,运营活动】','[{0,0,0}]',0,0,0,37,1,0,0,0,37010101,0,0,99,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(37010102,'2阶经验书','使用后可增加角色经验：<color=#4eae1a>620000</color>','',0,'【首领boss,运营活动】','[{0,0,0}]',0,0,0,37,1,0,0,0,37010102,0,0,99,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(37010103,'3阶经验书','使用后可增加角色经验：<color=#4eae1a>750000</color>','',0,'【首领boss,运营活动】','[{0,0,0}]',0,0,0,37,1,0,0,0,37010103,0,0,99,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(37010201,'4阶经验书','使用后可增加角色经验：<color=#4eae1a>1100000</color>','',0,'【首领boss,运营活动】','[{0,0,0}]',0,0,0,37,1,0,0,0,37010201,0,0,99,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(37010202,'5阶经验书','使用后可增加角色经验：<color=#4eae1a>1400000</color>','',0,'【首领boss,运营活动】','[{0,0,0}]',0,0,0,37,1,0,0,0,37010202,0,0,99,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(37010203,'6阶经验书','使用后可增加角色经验：<color=#4eae1a>50000</color>','',0,'【首领boss】','[{0,0,0}]',0,0,0,37,1,0,0,0,37010203,0,0,99,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(37010301,'7阶经验书','使用后可增加角色经验：<color=#4eae1a>100000</color>','',0,'【首领boss】','[{0,0,0}]',0,0,0,37,1,0,0,0,37010003,0,0,99,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(37010302,'8阶经验书','使用后可增加角色经验：<color=#4eae1a>200000</color>','',0,'【首领boss】','[{0,0,0}]',0,0,0,37,1,0,0,0,37010003,0,0,99,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(37010303,'9阶经验书','使用后可增加角色经验：<color=#4eae1a>500000</color>','',0,'【首领boss】','[{0,0,0}]',0,0,0,37,1,0,0,0,37010003,0,0,99,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(37010401,'10阶经验书','使用后可增加角色经验：<color=#4eae1a>1000000</color>','',0,'【首领boss】','[{0,0,0}]',0,0,0,37,1,0,0,0,37010004,0,0,99,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(37010402,'特阶经验书','使用后可增加角色经验：<color=#4eae1a>2000000</color>','',0,'【首领boss】','[{0,0,0}]',0,0,0,37,1,0,0,0,37010004,0,0,99,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(37010403,'超阶经验书','使用后可增加角色经验：<color=#4eae1a>5000000</color>','',0,'【首领boss】','[{0,0,0}]',0,0,0,37,1,0,0,0,37010005,0,0,99,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(37010501,'副本1阶经验书','使用后可增加角色经验：<color=#4eae1a>1000</color>','',0,'【副本掉落】','[{0,0,0}]',0,0,0,37,1,0,0,0,37010101,0,0,99,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(37010502,'副本2阶经验书','使用后可增加角色经验：<color=#4eae1a>2000</color>','',0,'【副本掉落】','[{0,0,0}]',0,0,0,37,1,0,0,0,37010102,0,0,99,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(37010503,'副本3阶经验书','使用后可增加角色经验：<color=#4eae1a>5000</color>','',0,'【副本掉落】','[{0,0,0}]',0,0,0,37,1,0,0,0,37010103,0,0,99,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(37010504,'副本4阶经验书','使用后可增加角色经验：<color=#4eae1a>10000</color>','',0,'【副本掉落】','[{0,0,0}]',0,0,0,37,1,0,0,0,37010201,0,0,99,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(37010505,'副本5阶经验书','使用后可增加角色经验：<color=#4eae1a>20000</color>','',0,'【副本掉落】','[{0,0,0}]',0,0,0,37,1,0,0,0,37010202,0,0,99,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(37010506,'副本6阶经验书','使用后可增加角色经验：<color=#4eae1a>50000</color>','',0,'【副本掉落】','[{0,0,0}]',0,0,0,37,1,0,0,0,37010203,0,0,99,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(37010507,'副本7阶经验书','使用后可增加角色经验：<color=#4eae1a>100000</color>','',0,'【副本掉落】','[{0,0,0}]',0,0,0,37,1,0,0,0,37010003,0,0,99,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(37010508,'副本8阶经验书','使用后可增加角色经验：<color=#4eae1a>200000</color>','',0,'【副本掉落】','[{0,0,0}]',0,0,0,37,1,0,0,0,37010003,0,0,99,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(37010509,'副本9阶经验书','使用后可增加角色经验：<color=#4eae1a>500000</color>','',0,'【副本掉落】','[{0,0,0}]',0,0,0,37,1,0,0,0,37010003,0,0,99,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(37010510,'副本10阶经验书','使用后可增加角色经验：<color=#4eae1a>1000000</color>','',0,'【副本掉落】','[{0,0,0}]',0,0,0,37,1,0,0,0,37010004,0,0,99,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(37010511,'副本特阶经验书','使用后可增加角色经验：<color=#4eae1a>2000000</color>','',0,'【副本掉落】','[{0,0,0}]',0,0,0,37,1,0,0,0,37010004,0,0,99,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(37010512,'副本超阶经验书','使用后可增加角色经验：<color=#4eae1a>5000000</color>','',0,'【副本掉落】','[{0,0,0}]',0,0,0,37,1,0,0,0,37010005,0,0,99,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(37020001,'1.5倍经验药水','使用后获得<color=#4eae1a>1.5倍</color>杀怪经验加成<color=#f18310>（秘境远征中同样有效）</color>，持续时间<color=#4eae1a>1小时</color>\\n\\n温馨提醒：\\n不同倍数一起使用时只会保留一种效果，同倍数一起使用会叠加时间','',0,'【福利,运营活动】','[{417,4,1}]',0,0,0,37,2,0,0,0,37020001,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(37020002,'2倍经验药水','使用后获得<color=#4eae1a>2倍</color>杀怪经验加成<color=#f18310>（秘境远征中同样有效）</color>，持续时间<color=#4eae1a>1小时</color>\\n\\n温馨提醒：\\n不同倍数一起使用时只会保留一种效果，同倍数一起使用会叠加时间','',0,'【每日累充,商城,运营活动】','[{153,1,1}]',0,0,0,37,2,0,0,0,37020002,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(37020003,'2.5倍经验药水','使用后获得<color=#4eae1a>2.5倍</color>杀怪经验加成<color=#f18310>（秘境远征中同样有效）</color>，持续时间<color=#4eae1a>1小时</color>\\n\\n温馨提醒：\\n不同倍数一起使用时只会保留一种效果，同倍数一起使用会叠加时间','',0,'【运营活动】','[{0,0,0}]',0,0,0,37,2,0,0,0,37020003,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(37020004,'3倍经验药水','使用后获得<color=#4eae1a>3倍</color>杀怪经验加成<color=#f18310>（秘境远征中同样有效）</color>，持续时间<color=#4eae1a>1小时</color>\\n\\n温馨提醒：\\n不同倍数一起使用时只会保留一种效果，同倍数一起使用会叠加时间','',0,'【运营活动】','[{0,0,0}]',0,0,0,37,2,0,0,0,37020004,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(37030001,'活力','活力值','',0,'日常活动','[{0,0,0}]',0,0,0,37,3,0,0,0,37030001,0,0,999999,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(37030002,'活力红茶','使用后可增加1000点活力值','',0,'【商城】','[{0,0,0}]',0,0,0,37,3,1,0,0,37030002,0,0,999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(37040001,'答题加速BUFF','用于中午答题加速','',0,'【场景自带】','[{0,0,0}]',0,1,0,37,4,0,0,0,12010002,0,0,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,0),(37050001,'绝对防御','VIP专属技能：绝对防御。免受一切PVP伤害','',0,'【场景自带】','[{0,0,0}]',0,1,0,37,4,0,0,0,12010002,0,0,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,0),(38030001,'经验副本入场券','进入【经验秘境】必需的物品\\n\\n可在【副本】—【单人副本】页签中进入经验副本秘境','',0,'【福利,商城,野外挂机】','[{153,1,1},{90,4,1}]',0,1,1,38,3,4,1,0,38030001,0,70,99999,1,0,0,0,'[{1,80}]',0,0,0,0,'[]','[]',0,0,0,1),(38030002,'狩猎门票','进入首领狩猎副本必备的道具。','',0,'【商城,运营活动】','[{153,1,1}]',0,0,1,38,3,0,0,0,38030002,0,120,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(38030003,'混乱魔域门票','需要混乱魔域准入令才能够进入<color=#4eae1a>【混乱魔域】</color>哦\\n可通过<color=#4eae1a>【混乱符印】</color>和<color=#4eae1a>【魔域令牌】</color>合成','',0,'【每日累充,商城,野外挂机】','[{153,1,1},{90,4,1}]',0,1,1,38,3,4,1,0,38030003,0,220,99999,2,0,0,0,'[{1,100}]',0,0,0,0,'[]','[]',0,0,0,1),(38030004,'混乱符印','可通过<color=#4eae1a>【合成-道具合成】</color>与<color=#4eae1a>【魔域令牌】</color>合成<color=#4eae1a>【混乱魔域准入令】</color>','',0,'【野外挂机】','[{90,4,1}]',0,1,1,38,3,4,1,0,38030004,0,220,99999,2,0,0,0,'[{1,50}]',0,0,1,0,'[]','[]',0,0,0,0),(38030005,'魔域令牌','可通过<color=#4eae1a>【合成-道具合成】</color>与<color=#4eae1a>【混乱符印】</color>合成<color=#4eae1a>【混乱魔域准入令】</color>','',0,'【野外挂机】','[{90,4,1}]',0,1,1,38,3,4,1,0,38030005,0,220,99999,2,0,0,0,'[{1,50}]',0,0,1,0,'[]','[]',0,0,0,0),(38030006,'经验羊皮卷','可通过<color=#4eae1a>【合成-道具合成】</color>与<color=#4eae1a>【经验传送符】</color>合成<color=#4eae1a>【经验副本入场券】</color>','',0,'【野外挂机】','[{90,4,1}]',0,1,1,38,3,4,1,0,38030006,0,70,99999,1,0,0,0,'[{1,40}]',0,0,1,0,'[]','[]',0,0,0,0),(38030007,'经验传送符','可通过<color=#4eae1a>【合成-道具合成】</color>与<color=#4eae1a>【经验羊皮卷】</color>合成<color=#4eae1a>【经验副本入场券】</color>','',0,'【野外挂机】','[{90,4,1}]',0,1,1,38,3,4,1,0,38030007,0,70,99999,1,0,0,0,'[{1,40}]',0,0,1,0,'[]','[]',0,0,0,0),(38030008,'超级入场券','【不消耗次数地进入一次经验副本！非常稀有！】','',0,'【商城】','[{153,1,1}]',0,0,0,38,3,0,0,0,38030008,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(38030009,'首领会所门票','【使用可以免费进入首领会所】','',0,'【运营活动】','[{0,0,0}]',0,0,0,38,3,0,0,0,38030008,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(38040001,'扩容剪刀','可以从来扩展背包和仓库格子的钥匙','',0,'【商城,运营活动】','[{0,0,0}]',0,0,0,38,4,0,0,0,38040001,0,0,99999,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(38040004,'十倍掉率药水','使用后稀有物品掉率提高10倍','',0,'【绑定GM】','[{0,0,0}]',0,0,0,38,4,0,0,0,38040003,0,0,99999,5,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(38040005,'博学之证','经验馆主进化石','',0,'【商城】','[{153,1,1}]',0,0,1,38,4,0,0,0,38040005,0,0,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(38040006,'神圣之证','白羊天使进化石','',0,'【商城】','[{153,1,1}]',0,0,1,38,4,0,0,0,38040006,0,0,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(38040010,'扫荡券','可用来扫荡单人副本','',0,'【福利,商城,野外挂机】','[{153,1,1},{90,4,1}]',0,1,0,38,4,4,1,0,38040010,0,0,99999,1,0,0,0,'[{1,5}]',0,0,0,0,'[]','[]',0,0,0,0),(38040013,'信物·萌羊座','可在【信物有礼】活动中换取丰厚奖励，在活动开启期间，所有野外怪物都有概率掉落','',0,'【开服活动】','[{0,0,0}]',1,0,1,38,4,0,0,0,38040013,0,80,99999,1,1,9,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(38040014,'信物·金牛座','可在【信物有礼】活动中换取丰厚奖励，在活动开启期间，所有野外怪物都有概率掉落','',0,'【开服活动】','[{0,0,0}]',1,0,1,38,4,0,0,0,38040014,0,80,99999,1,1,9,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(38040015,'信物·射手座','可在【信物有礼】活动中换取丰厚奖励，在活动开启期间，所有野外怪物都有概率掉落','',0,'【开服活动】','[{0,0,0}]',1,0,1,38,4,0,0,0,38040015,0,80,99999,1,1,9,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(38040016,'信物·双子座','可在【信物有礼】活动中换取丰厚奖励，在活动开启期间，所有野外怪物都有概率掉落','',0,'【开服活动】','[{0,0,0}]',1,0,1,38,4,0,0,0,38040016,0,80,99999,1,1,9,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(38040017,'信物·狮子座','可在【信物有礼】活动中换取丰厚奖励，在活动开启期间，所有野外怪物都有概率掉落','',0,'【开服活动】','[{0,0,0}]',1,0,1,38,4,0,0,0,38040017,0,80,99999,2,1,9,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(38040027,'变性秘卷','中世纪巫师为了完整体验人生而发明的秘术，使用后可以变更新性别以游历世界','',0,'【常用道具商城】','[{0,0,0}]',1,0,0,38,4,0,0,0,38040027,0,200,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(38040035,'星钻入场券','拥有它才能参加【星钻联赛】，联赛内无论输赢都能获得丰厚奖励，在联赛期间还可以消耗入场券购买复活次数','',0,'【每日重置】','[{0,0,0}]',1,0,1,38,1,0,0,0,38040035,0,0,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(38040101,'战争号角','副本鼓舞，每次增加10%攻击力','',0,'【商城】','[{153,1,1}]',1,0,1,38,4,0,0,0,38050002,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(38040102,'号令战角','副本鼓舞，每次增加5%攻击力','',0,'【野外挂机】','[{90,4,1}]',1,1,1,38,4,4,6,0,38050002,0,0,99999,1,0,0,0,'[{1,5}]',0,0,0,0,'[]','[]',0,0,0,1),(38040201,'星之四叶花','在吞食界面使用，萌羊吞食后可以增加1500点的吞食经验','',0,'【公会仓库】','[{0,0,0}]',0,0,0,18,1,1,0,0,38040201,0,95,9999,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(38040300,'基础重铸石','装备重铸的基础材料','',0,'【重铸副本】','[{610,42,1}]',0,1,1,38,4,0,0,0,38040300,0,0,99999,1,0,0,0,'[{1,5}]',0,0,0,0,'[]','[]',0,0,0,0),(38040301,'初·土极石','防御类装备的重铸材料','',0,'【重铸副本】','[{610,42,1}]',0,1,1,38,4,0,0,0,38040301,0,0,99999,2,0,0,0,'[{1,10}]',0,0,0,0,'[]','[]',0,0,0,0),(38040302,'初·火极石','攻击类装备的重铸材料','',0,'【重铸副本】','[{610,42,1}]',0,1,1,38,4,0,0,0,38040302,0,0,99999,2,0,0,0,'[{1,15}]',0,0,0,0,'[]','[]',0,0,0,0),(38040303,'圣·土极石','防御类装备的重铸材料','',0,'【重铸副本】','[{610,42,1}]',0,1,1,38,4,0,0,0,38040303,0,0,99999,3,0,0,0,'[{1,999}]',0,0,0,0,'[]','[]',0,0,0,0),(38040304,'圣·火极石','攻击类装备的重铸材料','',0,'【重铸副本】','[{610,42,1}]',0,1,1,38,4,0,0,0,38040304,0,0,99999,3,0,0,0,'[{1,999}]',0,0,0,0,'[]','[]',0,0,0,0),(38040305,'神·土极石','防御类装备的重铸材料','',0,'【重铸副本】','[{610,42,1}]',0,1,1,38,4,0,0,0,38040305,0,0,99999,4,0,0,0,'[{1,999}]',0,0,0,0,'[]','[]',0,0,0,0),(38040306,'神·火极石','攻击类装备的重铸材料','',0,'【重铸副本】','[{610,42,1}]',0,1,1,38,4,0,0,0,38040306,0,0,99999,4,0,0,0,'[{1,999}]',0,0,0,0,'[]','[]',0,0,0,0),(38040307,'凡·雷极石','饰品类装备的重铸材料','',0,'【重铸副本】','[{610,42,1}]',0,1,1,38,4,0,0,0,38040307,0,0,99999,2,0,0,0,'[{1,999}]',0,0,0,0,'[]','[]',0,0,0,0),(38040308,'圣·雷极石','饰品类装备的重铸材料','',0,'【重铸副本】','[{610,42,1}]',0,1,1,38,4,0,0,0,38040308,0,0,99999,3,0,0,0,'[{1,999}]',0,0,0,0,'[]','[]',0,0,0,0),(38040309,'神·雷极石','饰品类装备的重铸材料','',0,'【重铸副本】','[{610,42,1}]',0,1,1,38,4,0,0,0,38040309,0,0,99999,4,0,0,0,'[{1,999}]',0,0,0,0,'[]','[]',0,0,0,0),(38040400,'刻痕升阶徽记','饰品类装备的重铸材料','',0,'【巅峰寻宝】','[{416,0,1}]',0,1,1,38,4,0,0,0,38040400,0,0,99999,4,0,0,0,'[{1,999}]',0,0,0,0,'[]','[]',0,0,0,0),(38040401,'戒指升阶徽记','饰品类装备的重铸材料','',0,'【巅峰寻宝】','[{416,0,1}]',0,1,1,38,4,0,0,0,38040401,0,0,99999,4,0,0,0,'[{1,999}]',0,0,0,0,'[]','[]',0,0,0,0),(38040402,'刻痕升星徽记','饰品类装备的重铸材料','',0,'【至尊寻宝】','[{416,0,1}]',0,1,1,38,4,0,0,0,38040402,0,0,99999,4,0,0,0,'[{1,999}]',0,0,0,0,'[]','[]',0,0,0,0),(38040403,'戒指升星徽记','饰品类装备的重铸材料','',0,'【至尊寻宝】','[{416,0,1}]',0,1,1,38,4,0,0,0,38040403,0,0,99999,4,0,0,0,'[{1,999}]',0,0,0,0,'[]','[]',0,0,0,0),(38050001,'喇叭','使用后发送喇叭消息','',0,'【商城】','[{153,1,1}]',0,0,1,38,5,0,0,0,38050001,0,110,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(38050002,'跨服喇叭','使用后发送跨服消息','',0,'【商城】','[{153,1,1}]',0,0,1,38,5,0,0,0,38050001,0,0,99,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(38070001,'远征燃料卡(2小时)','使用后增加<color=#93e725>2小时</color>离线时间，可叠加使用延长时间，最高不超过20小时\\n\\n50级开启离线挂机功能，离线也能打怪，睡觉照样升级！','',0,'【在线奖励】','[{417,1,1}]',0,0,0,38,7,0,0,0,38070001,0,70,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(38070002,'远征燃料卡(5小时)','使用后增加<color=#93e725>5小时</color>离线时间，可叠加使用延长时间，最高不超过20小时\\n\\n50级开启离线挂机功能，离线也能打怪，睡觉照样升级！','',0,'【商城】','[{417,1,1}]',0,0,0,38,7,0,0,0,38070002,0,70,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(38080000,'测试红包','这是一个测试用的红包','',0,'【运营活动】','[{0,0,0}]',0,0,1,38,8,0,0,0,32050005,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(38080030,'30钻红包','30钻红包','',0,'【运营活动,世界boss】','[{460,1,1}]',0,0,1,38,8,0,0,0,38080030,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(38080050,'50钻红包','50钻红包','',0,'【运营活动,世界boss】','[{460,1,1}]',0,0,1,38,8,0,0,0,38080050,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(38080100,'100钻红包','100钻红包','',0,'【运营活动】','[{0,0,0}]',0,0,1,38,8,0,0,0,32050005,0,0,99999,4,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(38090001,'洗恶书','使用之后，可以立刻消除一点红名值','',0,'【商城】','[{153,1,1}]',0,0,0,38,9,0,0,0,38090001,0,0,999999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(38100001,'1朵鲜花','1朵鲜艳的玫瑰花\\n\\n可赠送给其他玩家增加自身1点花香值，若对方为好友则可额外增加1点亲密度','',0,'【每日签到,野外挂机,运营活动】','[{90,4,1}]',0,1,0,38,10,4,6,0,38100001,0,0,99999,0,0,0,0,'[{1,2}]',0,0,1,0,'[]','[]',0,0,0,1),(38100002,'真爱永恒','我对你的爱直到永远\\n\\n可赠送给其他玩家增加自身75点花香值，若对方为好友则可额外增加75点亲密度','',0,'【商城】','[{153,1,1}]',0,0,0,38,10,1,0,0,38100002,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(38100003,'梦幻水晶','我和你的爱情，好像水晶\\n\\n可赠送给其他玩家增加自身560点花香值，若对方为好友则可额外增加560点亲密度','',0,'【商城,运营活动】','[{153,1,1}]',0,0,0,38,10,1,0,0,38100003,0,0,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(38100004,'心心相印','只送给懂我的心的你\\n\\n可赠送给其他玩家增加自身120点花香值，若对方为好友则可额外增加120点亲密度','',0,'【商城】','[{153,1,1}]',0,0,0,38,10,1,0,0,38100004,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(38100005,'真情告白','愿得一人心，白首莫相离！\\n\\n可赠送给其他玩家增加自身240点花香值，若对方为好友则可额外增加240点亲密度','',0,'【商城】','[{153,1,1}]',0,0,0,38,10,1,0,0,38100005,0,0,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(38100006,'生日快乐','祝生快，生快，生快！\\n\\n可赠送给其他玩家增加自身180点花香值，若对方为好友则可额外增加180点亲密度','',0,'【商城】','[{153,1,1}]',0,0,0,38,10,1,0,0,38100006,0,0,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(38100007,'爱意小心心','嘻嘻，接受我的小心心吧！\\n\\n可赠送给其他玩家增加自身40点花香值，若对方为好友则可额外增加40点亲密度','',0,'【每日累充,商城】','[{153,1,1}]',0,0,0,38,10,1,0,0,38100007,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(38100008,'恭贺礼花','恭贺恭贺，天天快乐！\\n\\n可赠送给其他玩家增加自身6点花香值，若对方为好友则可额外增加6点亲密度','',0,'【商城】','[{153,1,1}]',0,0,0,38,10,0,0,0,38100008,0,0,99999,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(38100009,'9朵鲜花','9朵鲜艳的玫瑰花\\n\\n可赠送给其他玩家增加自身10点花香值，若对方为好友则可额外增加10点亲密度','',0,'【野外挂机,合成】','[{90,4,1}]',0,0,0,38,10,0,0,0,38100009,0,0,99999,2,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,1),(38100010,'99朵鲜花','99朵鲜艳的玫瑰花，代表真诚长久的爱意！\\n\\n可赠送给其他玩家增加自身120点花香值，若对方为好友则可额外增加120点亲密度','',0,'【野外挂机,合成】','[{90,4,1}]',0,0,0,38,10,1,0,0,38100010,0,0,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(38100012,'天降礼盒','天降礼盒啦！\\n\\n可赠送给其他玩家增加自身15点花香值，若对方为好友则可额外增加15点亲密度','',0,'【商城】','[{153,1,1}]',0,0,0,38,10,0,0,0,38100012,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(38110001,'风神翎羽','一转所需物品','',0,'【野外挂机,商城】','[{90,4,1},{153,1,1}]',0,1,1,38,11,4,3,0,38110001,0,0,99999,1,0,0,0,'[{1,5}]',0,0,0,0,'[]','[]',0,0,0,0),(38110002,'暗裔之爪','二转所需物品','',0,'【野外挂机,商城】','[{90,4,1},{153,1,1}]',0,1,1,38,11,4,3,0,38110002,0,0,99999,1,0,0,0,'[{1,10}]',0,0,0,0,'[]','[]',0,0,0,0),(38110003,'盖娅源石','三转所需物品','',0,'【野外挂机,商城】','[{90,4,1},{153,1,1}]',0,1,1,38,11,4,3,0,38110003,0,0,99999,2,0,0,0,'[{1,15}]',0,0,0,0,'[]','[]',0,0,0,0),(38110004,'破法戒指','四转所需物品','',0,'【野外挂机,商城】','[{90,4,1},{153,1,1}]',0,1,1,38,11,0,0,0,38110004,0,0,99999,3,0,0,0,'[{1,999}]',0,0,0,0,'[]','[]',0,0,0,0),(38110005,'烈火勋章','五转所需物品之一','',0,'【野外挂机,商城】','[{90,4,1},{153,1,1}]',0,1,1,38,11,0,0,0,38110005,0,0,99999,3,0,0,0,'[{1,999}]',0,0,0,0,'[]','[]',0,0,0,0),(38110006,'潮汐宝珠','五转所需物品之一','',0,'【野外挂机,商城】','[{90,4,1},{153,1,1}]',0,1,1,38,11,0,0,0,38110006,0,0,99999,3,0,0,0,'[{1,999}]',0,0,0,0,'[]','[]',0,0,0,0),(38110007,'灭魂假面','五转所需物品之一','',0,'【野外挂机,商城】','[{90,4,1},{153,1,1}]',0,1,1,38,11,0,0,0,38110007,0,0,99999,3,0,0,0,'[{1,999}]',0,0,0,0,'[]','[]',0,0,0,0),(38120001,'天赋技能重置卡','使用后，所有天赋技能将重置，并归还已经获得的天赋技能点。','',0,'','[{0,0,0}]',0,1,0,38,12,0,0,0,38120001,0,0,99999,2,0,0,0,'[{1,999}]',0,0,0,0,'[]','[]',0,0,0,1),(38130001,'小飞鞋','传说是信使赫尔墨斯最喜欢的一双鞋，使用后能一跃千里！','',0,'【野外挂机,商城】','[{90,4,1},{153,1,1}]',0,1,1,38,13,4,6,0,38130001,0,0,99999,1,0,0,0,'[{1,5}]',0,0,0,0,'[]','[]',0,0,0,0),(38140001,'华丽单身狗','华丽单身狗装扮','生命 + 3400,破甲 + 85',5525,'【运营活动】','[{0,0,0}]',0,1,0,38,14,0,0,0,38140001,0,0,99999,3,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,1),(38140002,'萌羊星座','来自萌羊星座的她','生命 + 2200,破甲 + 55',3575,'【商城,运营活动】','[{0,0,0}]',0,1,0,38,14,0,0,0,38140002,0,0,99999,2,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,1),(38140003,'高级贵族','高级贵族专属装扮','生命 + 4880,破甲 + 122',7930,'【运营活动】','[{0,0,0}]',0,1,0,38,14,0,0,0,38140003,0,0,99999,3,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,1),(38140004,'中级贵族','中级贵族专属装扮','生命 + 3580,破甲 + 90',5830,'【运营活动】','[{0,0,0}]',0,1,0,38,14,0,0,0,38140004,0,0,99999,3,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,1),(38140005,'初级贵族','初级贵族专属装扮','生命 + 2280,破甲 + 57',3705,'【运营活动】','[{0,0,0}]',0,1,0,38,14,0,0,0,38140005,0,0,99999,1,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,1),(38140006,'玫瑰之约','玫瑰之约，浪漫之夜','生命 + 3960,破甲 + 99',6435,'【运营活动】','[{0,0,0}]',0,1,0,38,14,0,0,0,38140006,0,0,99999,3,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,1),(38140007,'吃瓜群众','吃瓜群众装扮——看热闹的','生命 + 2380,破甲 + 60',3880,'【运营活动】','[{0,0,0}]',0,1,0,38,14,0,0,0,38140007,0,0,99999,1,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,1),(38140008,'自然之力','感受自然的力量吧','生命 + 3580,破甲 + 90',5830,'【运营活动】','[{0,0,0}]',0,1,0,38,14,0,0,0,38140008,0,0,99999,3,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,1),(38141000,'萌羊接线生','嗨，你们好啊~','',0,'【运营活动】','[{0,0,0}]',0,1,0,38,14,0,0,0,38140002,0,0,99999,1,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,1),(38142000,'萌羊指导员','嗨，你们好啊~','',0,'【运营活动】','[{0,0,0}]',0,1,0,38,14,0,0,0,38140002,0,0,99999,1,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,1),(38150001,'华丽单身狗','华丽单身狗装扮','攻击 + 170,防御 + 85',5525,'【运营活动】','[{0,0,0}]',0,1,0,38,15,0,0,0,38150001,0,0,99999,3,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,1),(38150002,'萌羊星座','来自萌羊星座的她','攻击 + 110,防御 + 55',3575,'【商城,运营活动】','[{0,0,0}]',0,1,0,38,15,0,0,0,38150002,0,0,99999,2,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,1),(38150003,'高级贵族','高级贵族专属装扮','攻击 + 244,防御 + 122',7930,'【运营活动】','[{0,0,0}]',0,1,0,38,15,0,0,0,38150003,0,0,99999,3,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,1),(38150004,'中级贵族','中级贵族专属装扮','攻击 + 179,防御 + 90',5830,'【运营活动】','[{0,0,0}]',0,1,0,38,15,0,0,0,38150004,0,0,99999,3,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,1),(38150005,'初级贵族','初级贵族专属装扮','攻击 + 114,防御 + 57',3705,'【运营活动】','[{0,0,0}]',0,1,0,38,15,0,0,0,38150005,0,0,99999,1,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,1),(38150006,'玫瑰之约','玫瑰之约，浪漫之夜','攻击 + 198,防御 + 99',6435,'【运营活动】','[{0,0,0}]',0,1,0,38,15,0,0,0,38150006,0,0,99999,3,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,1),(38150007,'吃瓜群众','吃瓜群众装扮——看热闹的','攻击 + 119,防御 + 60',3880,'【运营活动】','[{0,0,0}]',0,1,0,38,15,0,0,0,38150007,0,0,99999,1,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,1),(38150008,'自然之力','感受自然的力量吧','攻击 + 179,防御 + 90',5830,'【运营活动】','[{0,0,0}]',0,1,0,38,15,0,0,0,38150008,0,0,99999,3,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,1),(38151000,'萌羊接线生','嗨，你们好啊~','',0,'【运营活动】','[{0,0,0}]',0,1,0,38,15,0,0,0,38150002,0,0,99999,1,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,1),(38152000,'萌羊指导员','嗨，你们好啊~','',0,'【运营活动】','[{0,0,0}]',0,1,0,38,15,0,0,0,38150002,0,0,99999,1,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,1),(38160001,'遗迹疲劳药水','使用后可消除一点当天的首领遗迹首领疲劳度','',0,'【每日累充,运营活动】','[{339,1,1}]',1,1,0,38,16,0,0,0,38160001,0,1,99999,4,0,0,0,'[{1,1}]',0,1,0,0,'[]','[]',0,0,0,0),(38170001,'幻兽疲劳药（暂时没用）','使用后当天的幻兽之域首领疲劳度+1，增加的疲劳值不会累积到第二天','',0,'【运营活动】','[{0,0,0}]',1,1,0,38,17,0,0,0,38160001,0,1,99999,2,0,0,0,'[{1,1}]',0,1,0,0,'[]','[]',0,0,0,0),(38180001,'装备秘钥','可在装备寻宝中抽取极品道具','',0,'【商城,运营活动】','[{153,1,1}]',0,1,0,38,18,0,0,0,38180001,0,68,99999,3,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,1),(38180002,'巅峰秘钥','可在巅峰寻宝中抽取极品道具','',0,'【运营活动】','[{0,0,0}]',0,1,0,38,18,0,0,0,38180002,0,370,99999,3,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,1),(38180003,'至尊秘钥','可在至尊寻宝中抽取极品道具','',0,'【运营活动】','[{0,0,0}]',0,1,0,38,18,0,0,0,38180003,0,480,99999,3,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,1),(38180005,'幸运券','用于幸运之星','',0,'【运营活动】','[{0,0,0}]',0,1,0,38,18,0,0,0,38180005,0,50,99999,3,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,1),(38180006,'小金锤','用于砸蛋活动','',0,'【运营活动】','[{0,0,0}]',0,1,0,38,18,0,0,0,38180006,0,50,99999,3,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,1),(38180007,'鉴宝令','可在幸运鉴宝中鉴定稀有物品','',0,'【运营活动】','[{0,0,0}]',0,1,0,38,18,0,0,0,38180007,0,50,99999,3,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,1),(38180008,'刷新神果','<color=#835741>用途：</color>\\n可用于刷新幸运神树的奖池的奖励\\n\\n<color=#835741>描述：</color>\\n幸运神树树叶内最深处的树果，使用后可让整棵神树重获新生，简直就是神树的福音！','',0,'【快速购买】','[{0,0,0}]',0,0,0,38,18,1,0,0,38180008,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(38180009,'幸运树果','<color=#835741>用途：</color>\\n幸运神树中抽奖所需要消耗的道具\\n\\n<color=#835741>描述：</color>\\n幸运神树成熟掉落的树果，不可食用，唯一的用途便是让其他幸运树果快速成熟~哎，树果何苦为难树果~','',0,'【快速购买】','[{0,0,0}]',0,0,0,38,18,1,0,0,38180009,0,1,9999,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(38180010,'魂珠寻宝券','用于魂珠寻宝','',0,'【魂珠寻宝,运营活动】','[{0,0,0}]',0,0,0,38,18,0,0,0,38180010,0,70,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(38180011,'周一祈愿券','<color=#835741>用途：</color>\\n使用后可在周一祈愿活动中抽取丰厚的礼品\\n\\n<color=#835741>描述：</color>\\n今~天~真~的~是~元~气~满~满~啊~','',0,'【周一祈愿每日任务】','[{0,0,0}]',0,0,0,38,18,1,0,0,38180011,0,1,9999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(38180012,'扭蛋币','用于超级扭蛋活动','',0,'【快速购买】','[{0,0,0}]',0,0,0,38,18,0,0,0,38180012,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(38180013,'跨服云购券','用于跨服云购活动','',0,'【快速购买】','[{0,0,0}]',0,0,0,38,18,0,0,0,38180013,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(38180014,'冲榜召唤券','用于限时冲榜活动','',0,'【快速购买】','[{0,0,0}]',0,0,0,38,18,0,0,0,38180014,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(38180015,'万能幸运券','用于各类【运营活动】中，有一定概率抽取到极品道具','',0,'【快速购买,运营活动】','[{0,0,0}]',0,0,0,38,18,0,0,0,38180014,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(38180016,'魂珠十连券','用于魂珠寻宝，凭此道具可以免费享受一次魂珠寻宝十连抽，十连必出橙色魂珠','',0,'【魂珠寻宝,运营活动】','[{0,0,0}]',0,0,0,38,18,0,0,0,38180016,0,70,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(38190001,'公会奖章','公会任务中所需要的道具','',0,'【野外挂机】','[{90,4,1}]',0,1,0,38,19,4,6,0,36160002,0,1,99999,0,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,1),(38210001,'角色改名卡','用于修改角色昵称','',0,'【商城】','[{153,1,1}]',0,1,0,38,21,0,0,0,38210001,0,1,99999,3,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,1),(38210002,'公会改名卡','用于修改公会名称','',0,'【商城】','[{153,1,1}]',0,1,0,38,21,0,0,0,38210002,0,1,99999,3,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,1),(38220003,'钻石大战门票','<color=#835741>用途：</color>\\n钻石大战活动需要消耗1张门票来报名。此外，在没有被淘汰的情况下，可以消耗1张门票购买挑战命数！\\n○钻石大战中的优胜者可以获得大量钻石奖励\\n\\n<color=#835741>描述：</color>\\n你以为它是一张纸，其实他是一个吹风机......说错了，是一大堆钻石！','',0,'【充值-每日礼包】','[{0,0,0}]',0,1,0,38,22,1,0,0,38220003,0,1,99999,3,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,0),(38220004,'代金券','跨服1VN竞拍代金券','',0,'【1VN守擂赛获得】','[{0,0,0}]',0,1,0,38,22,0,0,0,38220004,0,1,99999,2,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,0),(38220005,'钻石大战命数','钻石大战战斗生命','',0,'【钻石大战购买】','[{0,0,0}]',0,1,0,38,22,0,0,0,382200005,0,0,0,4,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,0),(38220006,'夏日雪糕','运营活动-收集道具','',0,'【运营活动】','[{0,0,0}]',0,1,0,38,22,0,0,0,38220006,0,50,99999,3,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,1),(38220007,'红枫叶','运营活动-收集道具','',0,'【运营活动】','[{0,0,0}]',0,1,0,38,22,0,0,0,38220007,0,50,99999,3,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,0),(38220008,'黄金麦穗','运营活动-收集道具','',0,'【运营活动】','[{0,0,0}]',0,1,0,38,22,0,0,0,38220008,0,50,99999,3,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,0),(38220009,'庆典气球','运营活动-收集道具','',0,'【运营活动】','[{0,0,0}]',0,1,0,38,22,0,0,0,38220009,0,50,99999,3,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,0),(38220011,'橙色答题神兽卡','在公会篝火内使用，可召唤橙色答题神兽','',0,'【公会篝火】','[{403,0,1}]',0,1,0,38,22,0,0,0,38220002,0,1,99999,3,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,0),(38220012,'紫色答题神兽卡','在公会篝火内使用，可召唤紫色答题神兽','',0,'【公会篝火】','[{403,0,1}]',0,1,0,38,22,0,0,0,38220001,0,1,99999,2,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,0),(38220013,'蓝色答题神兽卡','在公会篝火内使用，可召唤蓝色答题神兽','',0,'【公会篝火】','[{403,0,1}]',0,1,0,38,22,0,0,0,38220013,0,1,99999,1,0,0,0,'[{1,1}]',0,0,0,0,'[]','[]',0,0,0,0),(38230003,'[全职]项链修罗石','修罗之力凝聚而成的石头,可以用它为装备锻造<修罗套装>,同时穿戴多件套装可激活强大的套装属性\\n\\n在【打造】—【套装】界面使用,可锻造<修罗套装>','',0,'【混乱魔域】','[{460,8,1},{460,1,0}]',0,1,1,38,23,3,4,3,38230003,0,0,99999,2,0,0,0,'[{1,30}]',0,0,1,0,'[]','[]',0,0,0,1),(38230005,'[全职]刻痕修罗石','修罗之力凝聚而成的石头,可以用它为装备锻造<修罗套装>,同时穿戴多件套装可激活强大的套装属性\\n\\n在【打造】—【套装】界面使用,可锻造<修罗套装>','',0,'【混乱魔域】','[{460,8,1},{460,1,0}]',0,1,1,38,23,3,4,5,38230005,0,0,99999,2,0,0,0,'[{1,30}]',0,0,1,0,'[]','[]',0,0,0,1),(38230009,'[全职]戒指修罗石','修罗之力凝聚而成的石头,可以用它为装备锻造<修罗套装>,同时穿戴多件套装可激活强大的套装属性\\n\\n在【打造】—【套装】界面使用,可锻造<修罗套装>','',0,'【混乱魔域】','[{460,8,1},{460,1,0}]',0,1,1,38,23,3,4,9,38230009,0,0,99999,2,0,0,0,'[{1,30}]',0,0,1,0,'[]','[]',0,0,0,1),(38230101,'[魔剑]武器霸者石','修罗之力凝聚而成的石头,可以用它为装备锻造<修罗套装>,同时穿戴多件套装可激活强大的套装属性\\n\\n在【打造】—【套装】界面使用,可锻造<修罗套装>','',0,'【混乱魔域,首领狩猎】','[{460,8,1},{460,1,0}]',0,1,1,38,23,3,1,1,38230101,1,0,99999,2,0,0,0,'[{1,6}]',0,0,1,0,'[]','[]',0,0,0,1),(38230102,'[魔剑]头盔霸者石','霸者之力凝聚而成的石头,可以用它为装备锻造<霸者套装>,同时穿戴多件套装可激活强大的套装属性\\n\\n在【打造】—【套装】界面使用,可锻造<霸者套装>','',0,'【混乱魔域】','[{460,8,1},{460,1,0}]',0,1,1,38,23,3,1,2,38230102,1,0,99999,2,0,0,0,'[{1,3}]',0,0,1,0,'[]','[]',0,0,0,1),(38230104,'[魔剑]衣服霸者石','霸者之力凝聚而成的石头,可以用它为装备锻造<霸者套装>,同时穿戴多件套装可激活强大的套装属性\\n\\n在【打造】—【套装】界面使用,可锻造<霸者套装>','',0,'【混乱魔域】','[{460,8,1},{460,1,0}]',0,1,1,38,23,3,1,4,38230104,1,0,99999,2,0,0,0,'[{1,3}]',0,0,1,0,'[]','[]',0,0,0,1),(38230106,'[魔剑]裤子霸者石','霸者之力凝聚而成的石头,可以用它为装备锻造<霸者套装>,同时穿戴多件套装可激活强大的套装属性\\n\\n在【打造】—【套装】界面使用,可锻造<霸者套装>','',0,'【混乱魔域】','[{460,8,1},{460,1,0}]',0,1,1,38,23,3,1,6,38230106,1,0,99999,2,0,0,0,'[{1,3}]',0,0,1,0,'[]','[]',0,0,0,1),(38230107,'[魔剑]副手修罗石','修罗之力凝聚而成的石头,可以用它为装备锻造<修罗套装>,同时穿戴多件套装可激活强大的套装属性\\n\\n在【打造】—【套装】界面使用,可锻造<修罗套装>','',0,'【混乱魔域】','[{460,8,1},{460,1,0}]',0,1,1,38,23,3,1,7,38230107,1,0,99999,2,0,0,0,'[{1,6}]',0,0,1,0,'[]','[]',0,0,0,1),(38230108,'[魔剑]护腕霸者石','霸者之力凝聚而成的石头,可以用它为装备锻造<霸者套装>,同时穿戴多件套装可激活强大的套装属性\\n\\n在【打造】—【套装】界面使用,可锻造<霸者套装>','',0,'【混乱魔域】','[{460,8,1},{460,1,0}]',0,1,1,38,23,3,1,8,38230108,1,0,99999,2,0,0,0,'[{1,3}]',0,0,1,0,'[]','[]',0,0,0,1),(38230110,'[魔剑]鞋子霸者石','霸者之力凝聚而成的石头,可以用它为装备锻造<霸者套装>,同时穿戴多件套装可激活强大的套装属性\\n\\n在【打造】—【套装】界面使用,可锻造<霸者套装>','',0,'【混乱魔域】','[{460,8,1},{460,1,0}]',0,1,1,38,23,3,1,10,38230110,1,0,99999,2,0,0,0,'[{1,3}]',0,0,1,0,'[]','[]',0,0,0,1),(38230201,'[龙骑]武器霸者石','修罗之力凝聚而成的石头,可以用它为装备锻造<修罗套装>,同时穿戴多件套装可激活强大的套装属性\\n\\n在【打造】—【套装】界面使用,可锻造<修罗套装>','',0,'【混乱魔域,首领之家】','[{460,8,1},{460,1,0}]',0,1,1,38,23,3,2,1,38230201,2,0,99999,2,0,0,0,'[{1,6}]',0,0,1,0,'[]','[]',0,0,0,1),(38230202,'[龙骑]头盔霸者石','霸者之力凝聚而成的石头,可以用它为装备锻造<霸者套装>,同时穿戴多件套装可激活强大的套装属性\\n\\n在【打造】—【套装】界面使用,可锻造<霸者套装>','',0,'【混乱魔域】','[{460,8,1},{460,1,0}]',0,1,1,38,23,3,2,2,38230202,2,0,99999,2,0,0,0,'[{1,3}]',0,0,1,0,'[]','[]',0,0,0,1),(38230204,'[龙骑]衣服霸者石','霸者之力凝聚而成的石头,可以用它为装备锻造<霸者套装>,同时穿戴多件套装可激活强大的套装属性\\n\\n在【打造】—【套装】界面使用,可锻造<霸者套装>','',0,'【混乱魔域】','[{460,8,1},{460,1,0}]',0,1,1,38,23,3,2,4,38230204,2,0,99999,2,0,0,0,'[{1,3}]',0,0,1,0,'[]','[]',0,0,0,1),(38230206,'[龙骑]裤子霸者石','霸者之力凝聚而成的石头,可以用它为装备锻造<霸者套装>,同时穿戴多件套装可激活强大的套装属性\\n\\n在【打造】—【套装】界面使用,可锻造<霸者套装>','',0,'【混乱魔域】','[{460,8,1},{460,1,0}]',0,1,1,38,23,3,2,6,38230206,2,0,99999,2,0,0,0,'[{1,3}]',0,0,1,0,'[]','[]',0,0,0,1),(38230207,'[龙骑]副手修罗石','修罗之力凝聚而成的石头,可以用它为装备锻造<修罗套装>,同时穿戴多件套装可激活强大的套装属性\\n\\n在【打造】—【套装】界面使用,可锻造<修罗套装>','',0,'【混乱魔域】','[{460,8,1},{460,1,0}]',0,1,1,38,23,3,2,7,38230207,2,0,99999,2,0,0,0,'[{1,6}]',0,0,1,0,'[]','[]',0,0,0,1),(38230208,'[龙骑]护腕霸者石','霸者之力凝聚而成的石头,可以用它为装备锻造<霸者套装>,同时穿戴多件套装可激活强大的套装属性\\n\\n在【打造】—【套装】界面使用,可锻造<霸者套装>','',0,'【混乱魔域】','[{460,8,1},{460,1,0}]',0,1,1,38,23,3,2,8,38230208,2,0,99999,2,0,0,0,'[{1,3}]',0,0,1,0,'[]','[]',0,0,0,1),(38230210,'[龙骑]鞋子霸者石','霸者之力凝聚而成的石头,可以用它为装备锻造<霸者套装>,同时穿戴多件套装可激活强大的套装属性\\n\\n在【打造】—【套装】界面使用,可锻造<霸者套装>','',0,'【混乱魔域】','[{460,8,1},{460,1,0}]',0,1,1,38,23,3,2,10,38230210,2,0,99999,2,0,0,0,'[{1,3}]',0,0,1,0,'[]','[]',0,0,0,1),(38230301,'[魔导]武器霸者石','修罗之力凝聚而成的石头,可以用它为装备锻造<修罗套装>,同时穿戴多件套装可激活强大的套装属性\\n\\n在【打造】—【套装】界面使用,可锻造<修罗套装>','',0,'【混乱魔域,原罪祭坛】','[{460,8,1},{460,1,0}]',0,1,1,38,23,0,0,1,38230001,3,0,99999,2,0,0,0,'[{1,6}]',0,0,1,0,'[]','[]',0,0,0,1),(38230302,'[魔导]头盔霸者石','霸者之力凝聚而成的石头,可以用它为装备锻造<霸者套装>,同时穿戴多件套装可激活强大的套装属性\\n\\n在【打造】—【套装】界面使用,可锻造<霸者套装>','',0,'【混乱魔域】','[{460,8,1},{460,1,0}]',0,1,1,38,23,0,0,2,38230002,3,0,99999,2,0,0,0,'[{1,3}]',0,0,1,0,'[]','[]',0,0,0,1),(38230304,'[魔导]衣服霸者石','霸者之力凝聚而成的石头,可以用它为装备锻造<霸者套装>,同时穿戴多件套装可激活强大的套装属性\\n\\n在【打造】—【套装】界面使用,可锻造<霸者套装>','',0,'【混乱魔域】','[{460,8,1},{460,1,0}]',0,1,1,38,23,0,0,4,38230004,3,0,99999,2,0,0,0,'[{1,3}]',0,0,1,0,'[]','[]',0,0,0,1),(38230306,'[魔导]裤子霸者石','霸者之力凝聚而成的石头,可以用它为装备锻造<霸者套装>,同时穿戴多件套装可激活强大的套装属性\\n\\n在【打造】—【套装】界面使用,可锻造<霸者套装>','',0,'【混乱魔域】','[{460,8,1},{460,1,0}]',0,1,1,38,23,0,0,6,38230006,3,0,99999,2,0,0,0,'[{1,3}]',0,0,1,0,'[]','[]',0,0,0,1),(38230307,'[魔导]副手修罗石','修罗之力凝聚而成的石头,可以用它为装备锻造<修罗套装>,同时穿戴多件套装可激活强大的套装属性\\n\\n在【打造】—【套装】界面使用,可锻造<修罗套装>','',0,'【混乱魔域】','[{460,8,1},{460,1,0}]',0,1,1,38,23,0,0,7,38230007,3,0,99999,2,0,0,0,'[{1,6}]',0,0,1,0,'[]','[]',0,0,0,1),(38230308,'[魔导]护腕霸者石','霸者之力凝聚而成的石头,可以用它为装备锻造<霸者套装>,同时穿戴多件套装可激活强大的套装属性\\n\\n在【打造】—【套装】界面使用,可锻造<霸者套装>','',0,'【混乱魔域】','[{460,8,1},{460,1,0}]',0,1,1,38,23,0,0,8,38230008,3,0,99999,2,0,0,0,'[{1,3}]',0,0,1,0,'[]','[]',0,0,0,1),(38230310,'[魔导]鞋子霸者石','霸者之力凝聚而成的石头,可以用它为装备锻造<霸者套装>,同时穿戴多件套装可激活强大的套装属性\\n\\n在【打造】—【套装】界面使用,可锻造<霸者套装>','',0,'【混乱魔域】','[{460,8,1},{460,1,0}]',0,1,1,38,23,0,0,10,38230010,3,0,99999,2,0,0,0,'[{1,3}]',0,0,1,0,'[]','[]',0,0,0,1),(38230401,'[重炮]武器霸者石','修罗之力凝聚而成的石头,可以用它为装备锻造<修罗套装>,同时穿戴多件套装可激活强大的套装属性\\n\\n在【打造】—【套装】界面使用,可锻造<修罗套装>','',0,'【混乱魔域,世界boss】','[{460,8,1},{460,1,0}]',0,1,1,38,23,3,3,1,38230401,4,0,99999,2,0,0,0,'[{1,6}]',0,0,1,0,'[]','[]',0,0,0,1),(38230402,'[重炮]头盔霸者石','霸者之力凝聚而成的石头,可以用它为装备锻造<霸者套装>,同时穿戴多件套装可激活强大的套装属性\\n\\n在【打造】—【套装】界面使用,可锻造<霸者套装>','',0,'【混乱魔域】','[{460,8,1},{460,1,0}]',0,1,1,38,23,3,3,2,38230402,4,0,99999,2,0,0,0,'[{1,3}]',0,0,1,0,'[]','[]',0,0,0,1),(38230404,'[重炮]衣服霸者石','霸者之力凝聚而成的石头,可以用它为装备锻造<霸者套装>,同时穿戴多件套装可激活强大的套装属性\\n\\n在【打造】—【套装】界面使用,可锻造<霸者套装>','',0,'【混乱魔域】','[{460,8,1},{460,1,0}]',0,1,1,38,23,3,3,4,38230404,4,0,99999,2,0,0,0,'[{1,3}]',0,0,1,0,'[]','[]',0,0,0,1),(38230406,'[重炮]裤子霸者石','霸者之力凝聚而成的石头,可以用它为装备锻造<霸者套装>,同时穿戴多件套装可激活强大的套装属性\\n\\n在【打造】—【套装】界面使用,可锻造<霸者套装>','',0,'【混乱魔域】','[{460,8,1},{460,1,0}]',0,1,1,38,23,3,3,6,38230406,4,0,99999,2,0,0,0,'[{1,3}]',0,0,1,0,'[]','[]',0,0,0,1),(38230407,'[重炮]副手修罗石','修罗之力凝聚而成的石头,可以用它为装备锻造<修罗套装>,同时穿戴多件套装可激活强大的套装属性\\n\\n在【打造】—【套装】界面使用,可锻造<修罗套装>','',0,'【混乱魔域】','[{460,8,1},{460,1,0}]',0,1,1,38,23,3,3,7,38230407,4,0,99999,2,0,0,0,'[{1,6}]',0,0,1,0,'[]','[]',0,0,0,1),(38230408,'[重炮]护腕霸者石','霸者之力凝聚而成的石头,可以用它为装备锻造<霸者套装>,同时穿戴多件套装可激活强大的套装属性\\n\\n在【打造】—【套装】界面使用,可锻造<霸者套装>','',0,'【混乱魔域】','[{460,8,1},{460,1,0}]',0,1,1,38,23,3,3,8,38230408,4,0,99999,2,0,0,0,'[{1,3}]',0,0,1,0,'[]','[]',0,0,0,1),(38230410,'[重炮]鞋子霸者石','霸者之力凝聚而成的石头,可以用它为装备锻造<霸者套装>,同时穿戴多件套装可激活强大的套装属性\\n\\n在【打造】—【套装】界面使用,可锻造<霸者套装>','',0,'【混乱魔域】','[{460,8,1},{460,1,0}]',0,1,1,38,23,3,3,10,38230410,4,0,99999,2,0,0,0,'[{1,3}]',0,0,1,0,'[]','[]',0,0,0,1),(38240001,'[全职]武器泰坦石','天脉神力凝聚的石头,可以和<修罗套装>发生高能反应,使其进化成<战神套装>,赋予强大的属性\\n\\n在【打造】—【套装】界面中使用可,将<修罗套装>锻造为<战神套装>','',0,'【混乱魔域】','[{460,8,1},{460,1,0}]',0,1,1,38,24,3,5,1,38240001,0,0,99999,3,0,0,0,'[{1,24}]',0,0,1,0,'[]','[]',0,0,0,1),(38240002,'[全职]头盔泰坦石','地脉神力凝聚的石头,可以和<霸者套装>发生高能反应,使其进化成<泰坦套装>,赋予强大的属性\\n\\n在【打造】—【套装】界面中使用可,将<霸者套装>锻造为<泰坦套装>','',0,'【混乱魔域】','[{460,8,1},{460,1,0}]',0,1,1,38,24,3,5,2,38240002,0,0,99999,3,0,0,0,'[{1,12}]',0,0,1,0,'[]','[]',0,0,0,1),(38240003,'[全职]项链战神石','天脉神力凝聚的石头,可以和<修罗套装>发生高能反应,使其进化成<战神套装>,赋予强大的属性\\n\\n在【打造】—【套装】界面中使用可,将<修罗套装>锻造为<战神套装>','',0,'【混乱魔域】','[{460,8,1},{460,1,0}]',0,1,1,38,24,3,5,3,38240003,0,0,99999,3,0,0,0,'[{1,120}]',0,0,1,0,'[]','[]',0,0,0,1),(38240004,'[全职]衣服泰坦石','地脉神力凝聚的石头,可以和<霸者套装>发生高能反应,使其进化成<泰坦套装>,赋予强大的属性\\n\\n在【打造】—【套装】界面中使用可,将<霸者套装>锻造为<泰坦套装>','',0,'【混乱魔域】','[{460,8,1},{460,1,0}]',0,1,1,38,24,3,5,4,38240004,0,0,99999,3,0,0,0,'[{1,12}]',0,0,1,0,'[]','[]',0,0,0,1),(38240005,'[全职]刻痕战神石','天脉神力凝聚的石头,可以和<修罗套装>发生高能反应,使其进化成<战神套装>,赋予强大的属性\\n\\n在【打造】—【套装】界面中使用可,将<修罗套装>锻造为<战神套装>','',0,'【混乱魔域】','[{460,8,1},{460,1,0}]',0,1,1,38,24,3,5,5,38240005,0,0,99999,3,0,0,0,'[{1,120}]',0,0,1,0,'[]','[]',0,0,0,1),(38240006,'[全职]裤子泰坦石','地脉神力凝聚的石头,可以和<霸者套装>发生高能反应,使其进化成<泰坦套装>,赋予强大的属性\\n\\n在【打造】—【套装】界面中使用可,将<霸者套装>锻造为<泰坦套装>','',0,'【混乱魔域】','[{460,8,1},{460,1,0}]',0,1,1,38,24,3,5,6,38240006,0,0,99999,3,0,0,0,'[{1,12}]',0,0,1,0,'[]','[]',0,0,0,1),(38240007,'[全职]副手战神石','天脉神力凝聚的石头,可以和<修罗套装>发生高能反应,使其进化成<战神套装>,赋予强大的属性\\n\\n在【打造】—【套装】界面中使用可,将<修罗套装>锻造为<战神套装>','',0,'【混乱魔域】','[{460,8,1},{460,1,0}]',0,1,1,38,24,3,5,7,38240007,0,0,99999,3,0,0,0,'[{1,24}]',0,0,1,0,'[]','[]',0,0,0,1),(38240008,'[全职]护腕泰坦石','地脉神力凝聚的石头,可以和<霸者套装>发生高能反应,使其进化成<泰坦套装>,赋予强大的属性\\n\\n在【打造】—【套装】界面中使用可,将<霸者套装>锻造为<泰坦套装>','',0,'【混乱魔域】','[{460,8,1},{460,1,0}]',0,1,1,38,24,3,5,8,38240008,0,0,99999,3,0,0,0,'[{1,12}]',0,0,1,0,'[]','[]',0,0,0,1),(38240009,'[全职]戒指战神石','天脉神力凝聚的石头,可以和<修罗套装>发生高能反应,使其进化成<战神套装>,赋予强大的属性\\n\\n在【打造】—【套装】界面中使用可,将<修罗套装>锻造为<战神套装>','',0,'【混乱魔域】','[{460,8,1},{460,1,0}]',0,1,1,38,24,3,5,9,38240009,0,0,99999,3,0,0,0,'[{1,240}]',0,0,1,0,'[]','[]',0,0,0,1),(38240010,'[全职]鞋子泰坦石','地脉神力凝聚的石头,可以和<霸者套装>发生高能反应,使其进化成<泰坦套装>,赋予强大的属性\\n\\n在【打造】—【套装】界面中使用可,将<霸者套装>锻造为<泰坦套装>','',0,'【混乱魔域】','[{460,8,1},{460,1,0}]',0,1,1,38,24,3,5,10,38240010,0,0,99999,3,0,0,0,'[{1,12}]',0,0,1,0,'[]','[]',0,0,0,1),(38250001,'神炼石','装备升段所需材料，升段后装备可洗出更强的洗炼属性\\n\\n可在【打造】—【洗炼】里使用','',0,'【商城】','[{610,38,0},{153,2,1}]',0,0,1,38,25,1,0,0,38250001,0,260,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(38260001,'洗炼石','洗炼装备所需材料，可为装备额外增加4条洗炼属性，战力爆表\\n\\n可在【打造】—【洗炼】里进行洗炼操作','',0,'【洗炼副本,运营活动,三英会战】','[{610,38,1}]',0,0,1,38,26,1,0,0,38260001,0,260,99999,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(38260002,'橙色洗炼石','洗炼装备所需材料，可为装备额外增加橙色洗炼属性，战力爆表\\n\\n可在【打造】—【洗炼】里进行洗炼操作','',0,'【洗炼副本,商城,三英会战】','[{610,38,0},{153,2,1}]',0,0,1,38,25,1,0,0,38260002,0,260,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(38260003,'红色洗炼石','洗炼装备所需材料，可为装备额外增加红色洗炼属性，战力爆表\\n\\n可在【打造】—【洗炼】里进行洗炼操作','',0,'【洗炼副本,商城】','[{610,38,0},{153,2,1}]',0,0,1,38,26,1,0,0,38260003,0,260,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(38270011,'霸者防具石碎片','霸者之力凝聚而成的石头碎片,可以用它合成头盔、衣服、裤子、护腕、鞋子套装石，锻造<霸者套装>','',0,'【混乱魔域】','[{460,8,1},{460,1,0}]',0,1,1,38,27,3,6,2,38270011,0,0,99999,2,0,0,0,'[{1,1}]',0,0,1,0,'[]','[]',0,0,0,0),(38270012,'修罗武器石碎片','修罗之力凝聚而成的石头碎片,可以用它合成武器、副手套装石，锻造<修罗套装>','',0,'【混乱魔域】','[{460,8,1},{460,1,0}]',0,1,1,38,27,3,6,1,38270012,0,0,99999,2,0,0,0,'[{1,2}]',0,0,1,0,'[]','[]',0,0,0,0),(38270013,'修罗首饰石碎片','修罗之力凝聚而成的石头碎片,可以用它合成项链、戒指、刻痕套装石，锻造<修罗套装>','',0,'【混乱魔域】','[{460,8,1},{460,1,0}]',0,1,1,38,27,3,6,3,38270013,0,0,99999,2,0,0,0,'[{1,3}]',0,0,1,0,'[]','[]',0,0,0,0),(38270021,'泰坦防具石碎片','地脉神力凝聚的石头,可以用它合成头盔、衣服、裤子、护腕、鞋子套装石，锻造<泰坦套装>','',0,'【混乱魔域】','[{460,8,1},{460,1,0}]',0,1,1,38,27,3,6,2,38270021,0,0,99999,3,0,0,0,'[{1,2}]',0,0,1,0,'[]','[]',0,0,0,0),(38270022,'战神武器石碎片','天脉神力凝聚的石头,可以用它合成武器、副手套装石,锻造<战神套装>','',0,'【混乱魔域】','[{460,8,1},{460,1,0}]',0,1,1,38,27,3,6,1,38270022,0,0,99999,3,0,0,0,'[{1,4}]',0,0,1,0,'[]','[]',0,0,0,0),(38270023,'战神首饰石碎片','天脉神力凝聚的石头,可以用它合成项链、戒指、刻痕套装石,锻造<战神套装>','',0,'【混乱魔域】','[{460,8,1},{460,1,0}]',0,1,1,38,27,3,6,3,38270023,0,0,99999,3,0,0,0,'[{1,12}]',0,0,1,0,'[]','[]',0,0,0,0),(38280510,'粉装防具石','合成粉装防具所需材料，战力爆表\\n\\n可在【合成】里进行合成操作','',0,'【商城-海神宝库】,【运营活动】','[{0,0,0}]',0,0,0,38,28,1,0,0,38280510,0,100,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(38280511,'粉装防具石碎片','合成粉装防具石所需材料\\n\\n可在【合成】里进行合成操作','',0,'【商城-海神宝库】,【运营活动】','[{0,0,0}]',0,0,0,38,28,1,0,0,38280511,0,100,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(38280520,'粉装武饰石','合成粉装武器首饰所需材料，战力爆表\\n\\n可在【合成】里进行合成操作','',0,'【商城-海神宝库】,【运营活动】','[{0,0,0}]',0,0,0,38,28,1,0,0,38280520,0,100,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(38280521,'粉装武饰石碎片','合成粉装石武器首饰所需材料\\n\\n可在【合成】里进行合成操作','',0,'【商城-海神宝库】,【运营活动】','[{0,0,0}]',0,0,0,38,28,1,0,0,38280521,0,100,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(38280620,'神装武饰石','合成神装所需材料，战力爆表\\n\\n可在【合成】里进行合成操作','',0,'【商城-海神宝库】,【运营活动】','[{0,0,0}]',0,0,0,38,28,1,0,0,38280620,0,100,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(38280621,'神装武饰石碎片','合成神装石所需材料\\n\\n可在【合成】里进行合成操作','',0,'【商城-海神宝库】,【运营活动】','[{0,0,0}]',0,0,0,38,28,1,0,0,38280621,0,100,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(38300002,'金币守护·30天','宝藏守护中的金币守护，使用后在金币矿洞中上阵可增加50%的金币收益','',0,'【商城】','[{153,1,1}]',0,0,1,38,30,0,0,0,38300002,0,0,99,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(38300003,'道具守护·30天','使用后派遣道具守护到宝藏处工作，上阵后增加20%道具收益','',0,'【商城】','[{153,1,1}]',0,0,1,38,30,0,0,0,38300003,0,0,0,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(38300004,'经验守护·30天','宝藏守护中的全能守护，使用后在经验书馆中上阵可增加50%的经验收益','',0,'【商城】','[{153,1,1}]',0,0,1,38,30,0,0,0,38300004,0,0,0,5,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(38320001,'矿工1号招募券','每日额外产出10万金币!','',0,'【新手活动】','[{0,0,0}]',1,0,0,38,32,1,0,0,38320001,0,68,99999,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(38320002,'矿工2号招募券','每日额外产出35万金币!','',0,'【运营活动】','[{0,0,0}]',1,0,0,38,32,1,0,0,38320001,0,68,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(38320003,'矿工3号招募券','每日额外产出65万金币!','',0,'【运营活动,vip礼包】','[{450,1,1}]',1,0,0,38,32,1,0,0,38320001,0,68,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(38320004,'矿工4号招募券','每日额外产出95万金币!','',0,'【商城】','[{153,2,1}]',1,0,0,38,32,1,0,0,38320001,0,68,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(38320005,'矿工5号招募券','每日额外产出250万金币!','',0,'【运营活动】','[{0,0,0}]',1,0,0,38,32,1,0,0,38320001,0,68,99999,5,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(38330001,'绿色飞艇护送券','护送绿色飞艇必要物品。\\n\\n<color=#835741>描述：</color>\\n护送飞艇可获得海量金币和经验哦！最高品质还能获得绑钻奖励哦~快快来参与哦','',0,'【日常任务,野外挂机】','[{300,2,1},{90,4,1}]',0,0,1,38,33,0,0,0,38330001,0,0,99,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(38330002,'蓝色飞艇护送券','护送蓝色飞艇必要物品。\\n\\n<color=#835741>描述：</color>\\n护送飞艇可获得海量金币和经验哦！最高品质还能获得绑钻奖励哦~快快来参与哦','',0,'【商城,道具合成】','[{153,1,1},{150,3,1}]',0,0,1,38,33,0,0,0,38330002,0,0,99,1,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(38330003,'紫色飞艇护送券','护送紫色飞艇必要物品。\\n\\n<color=#835741>描述：</color>\\n护送飞艇可获得海量金币和经验哦！最高品质还能获得绑钻奖励哦~快快来参与哦','',0,'【福利,商城,道具合成】','[{153,1,1},{150,3,1}]',0,0,0,38,33,0,0,0,38330003,0,0,99,2,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(38330004,'橙色飞艇护送券','护送橙色飞艇必要物品。\\n\\n<color=#835741>描述：</color>\\n护送飞艇可获得海量金币和经验哦！最高品质还能获得绑钻奖励哦~快快来参与哦','',0,'【每日累充,福利,商城,道具合成】','[{153,1,1},{150,3,1}]',0,0,0,38,33,0,0,0,38330004,0,0,99,3,0,0,0,'[]',0,0,1,0,'[]','[]',0,0,0,0),(38340001,'经验副本次数券','【使用后增加经验副本次数】','',0,'【运营活动】','[{0,0,0}]',0,0,0,38,34,0,0,0,38030008,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(38340002,'星灵副本次数券','【使用后增加星灵副本次数】','',0,'','[{0,0,0}]',0,0,0,38,34,0,0,0,38030008,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(38340003,'降神副本次数券','【使用后增加降神副本次数】','',0,'','[{0,0,0}]',0,0,0,38,34,0,0,0,38030008,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(38340004,'洗炼副本次数券','【使用后增加洗炼副本次数】','',0,'','[{0,0,0}]',0,0,0,38,34,0,0,0,38030008,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(38340005,'情侣副本次数券','【使用后增加情侣副本次数】','',0,'','[{0,0,0}]',0,0,0,38,34,0,0,0,38030008,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(38340006,'装备副本次数券','【使用后增加装备副本次数】','',0,'','[{0,0,0}]',0,0,0,38,34,0,0,0,38030008,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(38340007,'宝石副本扫荡券','【使用后增加宝石副本扫荡次数】','',0,'','[{0,0,0}]',0,0,0,38,35,0,0,0,38030008,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(40010001,'天然琥珀','使用之后，戒指属性增加\\n\\n可在【婚姻】—【结婚戒指】里进行戒指打磨操作','攻击+75,气血+1500',0,'【运营活动】','[{0,0,0}]',0,0,0,40,1,0,0,0,40010001,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(40010002,'玛瑙玉髓','使用之后，戒指属性增加\\n\\n可在【婚姻】—【结婚戒指】里进行戒指打磨操作','攻击+300,破甲+360',0,'【运营活动】','[{0,0,0}]',0,0,0,40,1,0,0,0,40010002,0,0,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(40010003,'水晶钻石','使用之后，戒指属性增加\\n\\n可在【婚姻】—【结婚戒指】里进行戒指打磨操作','气血+6000,防御+360',0,'【运营活动】','[{0,0,0}]',0,0,0,40,1,0,0,0,40010003,0,0,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(40010011,'爱情结晶','戒指升星所需材料，可增加25点戒指升星祝福值\\n\\n可在【婚姻】—【结婚戒指】里进行戒指升星操作','',0,'【情侣副本,婚礼活动,爱情宝盒】','[{610,34,1},{8,1,1}]',0,0,0,40,1,0,0,0,40010011,0,0,99999,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(40010012,'永恒晶石','戒指升星所需材料，可增加150点戒指升星祝福值\\n\\n可在【婚姻】—【结婚戒指】里进行戒指升星操作','',0,'【情侣副本,婚礼活动,运营活动】','[{610,34,1},{8,1,1}]',0,0,0,40,1,0,0,0,40010012,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(40020001,'简约婚礼卡','已结婚的玩家可用此道具再次免费举办一场简约婚礼，使用后将获得简约婚礼奖励。使用本卡时双方不用离婚即可再次举办婚礼','',0,'','[{0,0,0}]',0,0,0,40,2,0,0,0,40020004,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(40020002,'隆重婚礼卡','已结婚的玩家可用此道具再次免费举办一场隆重婚礼，使用后将获得隆重婚礼奖励。使用本卡时双方不用离婚即可再次举办婚礼','',0,'','[{0,0,0}]',0,0,0,40,2,0,0,0,40020005,0,0,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(40020003,'豪华婚礼卡','已结婚的玩家可用此道具再次免费举办一场豪华婚礼，使用后将获得豪华婚礼奖励。使用本卡时双方不用离婚即可再次举办婚礼','',0,'','[{0,0,0}]',0,0,0,40,2,0,0,0,40020006,0,0,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(40020004,'简约巡游卡','已结婚的玩家可用此道具再次免费举办一场简约巡游，使用后将获得简约婚礼奖励。使用本卡时双方不用离婚即可再次举办巡游','',0,'','[{0,0,0}]',0,0,0,40,2,0,0,0,40020004,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(40020005,'隆重巡游卡','已结婚的玩家可用此道具再次免费举办一场隆重巡游，使用后将获得隆重婚礼奖励。使用本卡时双方不用离婚即可再次举办巡游','',0,'','[{0,0,0}]',0,0,0,40,2,0,0,0,40020005,0,0,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(40020006,'豪华巡游卡','已结婚的玩家可用此道具再次免费举办一场豪华巡游，使用后将获得豪华婚礼奖励。使用本卡时双方不用离婚即可再次举办巡游','',0,'','[{0,0,0}]',0,0,0,40,2,0,0,0,40020006,0,0,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(40030101,'初始宝宝升级书','仅可用于初始宝宝的升级道具','',0,'【情侣副本,婚礼活动】','[{610,34,1},{8,1,1}]',0,0,0,40,3,0,0,0,40030001,0,0,99999,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(40030201,'进阶宝宝升级书','仅可用于进阶宝宝的升级道具','',0,'【情侣副本,婚礼活动】','[{610,34,1},{8,1,1}]',0,0,0,40,3,0,0,0,40030001,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(40030301,'稀有宝宝升级书','仅可用于稀有宝宝的升级道具','',0,'【情侣副本,婚礼活动】','[{610,34,1},{8,1,1}]',0,0,0,40,3,0,0,0,40030001,0,0,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(40040001,'恩爱值','可用来培养同心结\\n\\n可在【婚姻】—【同心结】里进行培养操作','',0,'【情侣副本,婚礼活动,爱情宝盒】','[{610,34,1},{8,1,1}]',0,0,0,40,1,0,0,0,40040001,0,0,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(40040101,'绿色天赋书','仅可用于宝宝学习绿色天赋','',0,'','[{0,0,0}]',0,0,0,40,4,0,0,0,40030002,0,0,99999,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(40040102,'蓝色天赋书','仅可用于宝宝学习蓝色天赋','',0,'','[{0,0,0}]',0,0,0,40,4,0,0,0,40030002,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(40040103,'紫色天赋书','仅可用于宝宝学习紫色天赋','',0,'','[{0,0,0}]',0,0,0,40,4,0,0,0,40030002,0,0,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(40040104,'橙色天赋书','仅可用于宝宝学习橙色天赋','',0,'','[{0,0,0}]',0,0,0,40,4,0,0,0,40030002,0,0,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(40050001,'爱情信物','双方求婚必备爱情信物','',0,'【商城】','[{153,1,1}]',0,0,0,40,1,0,0,0,40050001,0,0,9999,5,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(40050101,'绿色天赋重置书','仅可用于重置宝宝绿色天赋','',0,'','[{0,0,0}]',0,0,0,40,5,0,0,0,40030003,0,0,99999,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(40050102,'蓝色天赋重置书','仅可用于重置宝宝蓝色天赋','',0,'【商城】','[{0,0,0}]',0,0,0,40,5,0,0,0,40030003,0,0,99999,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(40050103,'紫色天赋重置书','仅可用于重置宝宝紫色天赋','',0,'【商城】','[{0,0,0}]',0,0,0,40,5,0,0,0,40030003,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(40050104,'橙色天赋重置书','仅可用于重置宝宝橙色天赋','',0,'【商城】','[{0,0,0}]',0,0,0,40,5,0,0,0,40030003,0,0,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(40060101,'绿蓝天赋提升书','仅用于绿色天赋提升至蓝色天赋','',0,'【商城】','[{0,0,0}]',0,0,0,40,6,0,0,0,40030004,0,0,99999,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(40060102,'蓝紫天赋提升书','仅用于蓝色天赋提升至紫色天赋','',0,'【商城】','[{0,0,0}]',0,0,0,40,6,0,0,0,40030004,0,0,99999,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(40060103,'紫橙天赋提升书','仅用于紫色天赋提升至橙色天赋','',0,'【商城】','[{0,0,0}]',0,0,0,40,6,0,0,0,40030004,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(40070101,'小苍宝宝激活书','激活宝宝·小苍宝宝','',0,'【商城】','[{0,0,0}]',0,0,0,40,7,0,0,0,40030006,0,0,99999,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(40070201,'JY宝宝激活书','激活宝宝·JY宝宝','',0,'【商城】','[{0,0,0}]',0,0,0,40,7,0,0,0,40030007,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(40070202,'囚徒宝宝激活书','激活宝宝·囚徒宝宝','',0,'【商城】','[{0,0,0}]',0,0,0,40,7,0,0,0,40030007,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(40070301,'鼠大王宝宝激活书','激活宝宝·鼠大王宝宝','',0,'【商城】','[{0,0,0}]',0,0,0,40,7,0,0,0,40030008,0,0,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(40070302,'酒神宝宝激活书','激活宝宝·酒神宝宝','',0,'【商城】','[{0,0,0}]',0,0,0,40,7,0,0,0,40030008,0,0,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(40070303,'skr宝宝激活书','激活宝宝·skr宝宝','',0,'【商城】','[{0,0,0}]',0,0,0,40,7,0,0,0,40030008,0,0,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(40070401,'育儿指南','激活宝宝（单身玩家）','',0,'【商城】','[{0,0,0}]',0,0,0,40,7,0,0,0,40030008,0,0,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(42010001,'兽魂魔晶','用来召唤公会神兽的材料，捐献给公会可获得贡献奖励','',0,'【公会周常】','[{0,0,0}]',1,0,0,42,1,0,0,0,42010001,0,0,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(42020001,'美味的烤野猪','增加1000点公会贡献值','',0,'【公会晚宴】','[{0,0,0}]',1,0,0,42,2,0,0,0,42020001,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(42030001,'主宰者','霸主将获得攻击提升2%、生命提升2%的加成','',0,'【公会争霸】','[{0,0,0}]',0,0,0,42,3,0,0,0,42030001,0,0,0,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(42030002,'士气鼓舞','生命+10%，攻击+10%，防御+10%','',0,'','[{0,0,0}]',0,0,0,42,3,0,0,0,42030002,0,0,0,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(45010001,'图鉴·藏宝蟹','使用可以激活或升级图鉴收藏-藏宝蟹','',0,'【野外掉落】','[{0,0,0}]',0,1,0,45,1,5,1,0,38180005,0,1,99999,0,0,0,0,'[{1,25}]',0,1,0,0,'[]','[]',0,0,0,0),(45010002,'图鉴·魔化藏宝蟹','使用可以激活或升级图鉴收藏-魔化藏宝蟹','',0,'【野外掉落】','[{0,0,0}]',0,1,0,45,1,5,1,0,38180005,0,1,99999,0,0,0,0,'[{1,25}]',0,1,0,0,'[]','[]',0,0,0,0),(45010003,'图鉴·树桩怪','使用可以激活或升级图鉴收藏-树桩怪','',0,'【野外掉落】','[{0,0,0}]',0,1,0,45,1,5,1,0,38180005,0,1,99999,0,0,0,0,'[{1,25}]',0,1,0,0,'[]','[]',0,0,0,0),(45010004,'图鉴·火鸡骑士','使用可以激活或升级图鉴收藏-火鸡骑士','',0,'【野外掉落】','[{0,0,0}]',0,1,0,45,1,5,1,0,38180005,0,1,99999,0,0,0,0,'[{1,25}]',0,1,0,0,'[]','[]',0,0,0,0),(45010005,'图鉴·强盗','使用可以激活或升级图鉴收藏-强盗','',0,'【野外掉落】','[{0,0,0}]',0,1,0,45,1,5,1,0,38180005,0,1,99999,0,0,0,0,'[{1,25}]',0,1,0,0,'[]','[]',0,0,0,0),(45010006,'图鉴·叛变佣兵','使用可以激活或升级图鉴收藏-叛变佣兵','',0,'【野外掉落】','[{0,0,0}]',0,1,0,45,1,5,1,0,38180005,0,1,99999,0,0,0,0,'[{1,25}]',0,1,0,0,'[]','[]',0,0,0,0),(45010007,'图鉴·魔化傀儡','使用可以激活或升级图鉴收藏-魔化傀儡','',0,'【野外掉落】','[{0,0,0}]',0,1,0,45,1,5,1,0,38180005,0,1,99999,0,0,0,0,'[{1,25}]',0,1,0,0,'[]','[]',0,0,0,0),(45010008,'图鉴·魔化楔形虫','使用可以激活或升级图鉴收藏-魔化楔形虫','',0,'【野外掉落】','[{0,0,0}]',0,1,0,45,1,5,1,0,38180005,0,1,99999,0,0,0,0,'[{1,25}]',0,1,0,0,'[]','[]',0,0,0,0),(45010009,'图鉴·魔化机兵','使用可以激活或升级图鉴收藏-魔化机兵','',0,'【野外掉落】','[{0,0,0}]',0,1,0,45,1,5,1,0,38180005,0,1,99999,0,0,0,0,'[{1,25}]',0,1,0,0,'[]','[]',0,0,0,0),(45010010,'图鉴·魔化难民','使用可以激活或升级图鉴收藏-魔化难民','',0,'【野外掉落】','[{0,0,0}]',0,1,0,45,1,5,1,0,38180005,0,1,99999,0,0,0,0,'[{1,25}]',0,1,0,0,'[]','[]',0,0,0,0),(45010011,'图鉴·暗影狼','使用可以激活或升级图鉴收藏-暗影狼','',0,'【野外掉落】','[{0,0,0}]',0,1,0,45,1,5,1,0,38180005,0,1,99999,0,0,0,0,'[{1,25}]',0,1,0,0,'[]','[]',0,0,0,0),(45010012,'图鉴·骷髅兵','使用可以激活或升级图鉴收藏-骷髅兵','',0,'【野外掉落】','[{0,0,0}]',0,1,0,45,1,5,1,0,38180005,0,1,99999,0,0,0,0,'[{1,25}]',0,1,0,0,'[]','[]',0,0,0,0),(45010013,'图鉴·史莱姆','使用可以激活或升级图鉴收藏-史莱姆','',0,'【野外掉落】','[{0,0,0}]',0,1,0,45,1,5,1,0,38180005,0,1,99999,0,0,0,0,'[{1,25}]',0,1,0,0,'[]','[]',0,0,0,0),(45010014,'图鉴·哥布林','使用可以激活或升级图鉴收藏-哥布林','',0,'【野外掉落】','[{0,0,0}]',0,1,0,45,1,5,1,0,38180005,0,1,99999,0,0,0,0,'[{1,25}]',0,1,0,0,'[]','[]',0,0,0,0),(45010015,'图鉴·沼泽妖精','使用可以激活或升级图鉴收藏-沼泽妖精','',0,'【野外掉落】','[{0,0,0}]',0,1,0,45,1,5,1,0,38180005,0,1,99999,0,0,0,0,'[{1,25}]',0,1,0,0,'[]','[]',0,0,0,0),(45010016,'图鉴·蜥蜴人','使用可以激活或升级图鉴收藏-蜥蜴人','',0,'【野外掉落】','[{0,0,0}]',0,1,0,45,1,5,1,0,38180005,0,1,99999,0,0,0,0,'[{1,25}]',0,1,0,0,'[]','[]',0,0,0,0),(45010101,'图鉴·吞噬花','使用可以激活或升级图鉴收藏-吞噬花','',0,'【野外掉落】','[{0,0,0}]',0,1,0,45,1,5,2,0,38180005,0,1,99999,1,0,0,0,'[{1,40}]',0,1,0,0,'[]','[]',0,0,0,0),(45010102,'图鉴·森林妖精','使用可以激活或升级图鉴收藏-森林妖精','',0,'【野外掉落】','[{0,0,0}]',0,1,0,45,1,5,2,0,38180005,0,1,99999,1,0,0,0,'[{1,40}]',0,1,0,0,'[]','[]',0,0,0,0),(45010103,'图鉴·精灵侍卫','使用可以激活或升级图鉴收藏-精灵侍卫','',0,'【野外掉落】','[{0,0,0}]',0,1,0,45,1,5,2,0,38180005,0,1,99999,1,0,0,0,'[{1,40}]',0,1,0,0,'[]','[]',0,0,0,0),(45010104,'图鉴·岩龟','使用可以激活或升级图鉴收藏-岩龟','',0,'【野外掉落】','[{0,0,0}]',0,1,0,45,1,5,2,0,38180005,0,1,99999,1,0,0,0,'[{1,40}]',0,1,0,0,'[]','[]',0,0,0,0),(45010105,'图鉴·雪原企鹅','使用可以激活或升级图鉴收藏-雪原企鹅','',0,'【野外掉落】','[{0,0,0}]',0,1,0,45,1,5,2,0,38180005,0,1,99999,1,0,0,0,'[{1,40}]',0,1,0,0,'[]','[]',0,0,0,0),(45010106,'图鉴·雪岩怪','使用可以激活或升级图鉴收藏-雪岩怪','',0,'【野外掉落】','[{0,0,0}]',0,1,0,45,1,5,2,0,38180005,0,1,99999,1,0,0,0,'[{1,40}]',0,1,0,0,'[]','[]',0,0,0,0),(45010107,'图鉴·机械犬','使用可以激活或升级图鉴收藏-机械犬','',0,'【野外掉落】','[{0,0,0}]',0,1,0,45,1,5,2,0,38180005,0,1,99999,1,0,0,0,'[{1,40}]',0,1,0,0,'[]','[]',0,0,0,0),(45010108,'图鉴·恶魔幼体','使用可以激活或升级图鉴收藏-恶魔幼体','',0,'【野外掉落】','[{0,0,0}]',0,1,0,45,1,5,2,0,38180005,0,1,99999,1,0,0,0,'[{1,40}]',0,1,0,0,'[]','[]',0,0,0,0),(45010109,'图鉴·鱼人守卫','使用可以激活或升级图鉴收藏-鱼人守卫','',0,'【野外掉落】','[{0,0,0}]',0,1,0,45,1,5,2,0,38180005,0,1,99999,1,0,0,0,'[{1,40}]',0,1,0,0,'[]','[]',0,0,0,0),(45010110,'图鉴·鱼人刺客','使用可以激活或升级图鉴收藏-鱼人刺客','',0,'【野外掉落】','[{0,0,0}]',0,1,0,45,1,5,2,0,38180005,0,1,99999,1,0,0,0,'[{1,40}]',0,1,0,0,'[]','[]',0,0,0,0),(45010111,'图鉴·巨齿鲨','使用可以激活或升级图鉴收藏-巨齿鲨','',0,'【野外掉落】','[{0,0,0}]',0,1,0,45,1,5,2,0,38180005,0,1,99999,1,0,0,0,'[{1,40}]',0,1,0,0,'[]','[]',0,0,0,0),(45010112,'图鉴·海蜥蜴','使用可以激活或升级图鉴收藏-海蜥蜴','',0,'【野外掉落】','[{0,0,0}]',0,1,0,45,1,5,2,0,38180005,0,1,99999,1,0,0,0,'[{1,40}]',0,1,0,0,'[]','[]',0,0,0,0),(45010113,'图鉴·半人马','使用可以激活或升级图鉴收藏-半人马','',0,'【野外掉落】','[{0,0,0}]',0,1,0,45,1,5,2,0,38180005,0,1,99999,1,0,0,0,'[{1,40}]',0,1,0,0,'[]','[]',0,0,0,0),(45010114,'图鉴·食人花','使用可以激活或升级图鉴收藏-食人花','',0,'【野外掉落】','[{0,0,0}]',0,1,0,45,1,5,2,0,38180005,0,1,99999,1,0,0,0,'[{1,40}]',0,1,0,0,'[]','[]',0,0,0,0),(45010115,'图鉴·冰霜泰坦','使用可以激活或升级图鉴收藏-冰霜泰坦','',0,'【野外掉落】','[{0,0,0}]',0,1,0,45,1,5,2,0,38180005,0,1,99999,1,0,0,0,'[{1,40}]',0,1,0,0,'[]','[]',0,0,0,0),(45010116,'图鉴·冰霜巨龙','使用可以激活或升级图鉴收藏-冰霜巨龙','',0,'【野外掉落】','[{0,0,0}]',0,1,0,45,1,5,2,0,38180005,0,1,99999,1,0,0,0,'[{1,40}]',0,1,0,0,'[]','[]',0,0,0,0),(45010117,'图鉴·阿努比斯','使用可以激活或升级图鉴收藏-阿努比斯','',0,'【野外掉落】','[{0,0,0}]',0,1,0,45,1,5,2,0,38180005,0,1,99999,1,0,0,0,'[{1,40}]',0,1,0,0,'[]','[]',0,0,0,0),(45010118,'图鉴·美杜莎','使用可以激活或升级图鉴收藏-美杜莎','',0,'【野外掉落】','[{0,0,0}]',0,1,0,45,1,5,2,0,38180005,0,1,99999,1,0,0,0,'[{1,40}]',0,1,0,0,'[]','[]',0,0,0,0),(45010201,'图鉴·暗裔恶魔','使用可以激活或升级图鉴收藏-暗裔恶魔','',0,'【野外掉落】','[{0,0,0}]',0,1,0,45,1,5,3,0,38180005,0,1,99999,2,0,0,0,'[{1,65}]',0,1,0,0,'[]','[]',0,0,0,0),(45010202,'图鉴·质量检测员','使用可以激活或升级图鉴收藏-质量检测员','',0,'【野外掉落】','[{0,0,0}]',0,1,0,45,1,5,3,0,38180005,0,1,99999,2,0,0,0,'[{1,65}]',0,1,0,0,'[]','[]',0,0,0,0),(45010203,'图鉴·海龙王','使用可以激活或升级图鉴收藏-海龙王','',0,'【野外掉落】','[{0,0,0}]',0,1,0,45,1,5,3,0,38180005,0,1,99999,2,0,0,0,'[{1,65}]',0,1,0,0,'[]','[]',0,0,0,0),(45010204,'图鉴·暗裔猎手','使用可以激活或升级图鉴收藏-暗裔猎手','',0,'【野外掉落】','[{0,0,0}]',0,1,0,45,1,5,3,0,38180005,0,1,99999,2,0,0,0,'[{1,65}]',0,1,0,0,'[]','[]',0,0,0,0),(45010205,'图鉴·蜘蛛女皇','使用可以激活或升级图鉴收藏-蜘蛛女皇','',0,'【野外掉落】','[{0,0,0}]',0,1,0,45,1,5,3,0,38180005,0,1,99999,2,0,0,0,'[{1,65}]',0,1,0,0,'[]','[]',0,0,0,0),(45010206,'图鉴·愤怒','使用可以激活或升级图鉴收藏-愤怒','',0,'【野外掉落】','[{0,0,0}]',0,1,0,45,1,5,3,0,38180005,0,1,99999,2,0,0,0,'[{1,65}]',0,1,0,0,'[]','[]',0,0,0,0),(45010301,'图鉴·怠惰','使用可以激活或升级图鉴收藏-怠惰','',0,'【野外掉落】','[{0,0,0}]',0,1,0,45,1,5,4,0,38180005,0,1,99999,3,0,0,0,'[{1,100}]',0,1,0,0,'[]','[]',0,0,0,0),(45010302,'图鉴·嫉妒','使用可以激活或升级图鉴收藏-嫉妒','',0,'【野外掉落】','[{0,0,0}]',0,1,0,45,1,5,4,0,38180005,0,1,99999,3,0,0,0,'[{1,100}]',0,1,0,0,'[]','[]',0,0,0,0),(45010303,'图鉴·暴食','使用可以激活或升级图鉴收藏-暴食','',0,'【野外掉落】','[{0,0,0}]',0,1,0,45,1,5,4,0,38180005,0,1,99999,3,0,0,0,'[{1,100}]',0,1,0,0,'[]','[]',0,0,0,0),(45010304,'图鉴·色欲','使用可以激活或升级图鉴收藏-色欲','',0,'【野外掉落】','[{0,0,0}]',0,1,0,45,1,5,4,0,38180005,0,1,99999,3,0,0,0,'[{1,100}]',0,1,0,0,'[]','[]',0,0,0,0),(45010305,'图鉴·死神','使用可以激活或升级图鉴收藏-死神','',0,'【野外掉落】','[{0,0,0}]',0,1,0,45,1,5,4,0,38180005,0,1,99999,3,0,0,0,'[{1,100}]',0,1,0,0,'[]','[]',0,0,0,0),(45010306,'图鉴·迦楼罗','使用可以激活或升级图鉴收藏-迦楼罗','',0,'【野外掉落】','[{0,0,0}]',0,1,0,45,1,5,4,0,38180005,0,1,99999,3,0,0,0,'[{1,100}]',0,1,0,0,'[]','[]',0,0,0,0),(45010401,'图鉴·八岐大蛇','使用可以激活或升级图鉴收藏-八岐大蛇','',0,'【野外掉落】','[{0,0,0}]',0,1,0,45,1,5,5,0,38180005,0,1,99999,4,0,0,0,'[{1,130}]',0,1,0,0,'[]','[]',0,0,0,0),(45010402,'图鉴·熔岩战神','使用可以激活或升级图鉴收藏-熔岩战神','',0,'【野外掉落】','[{0,0,0}]',0,1,0,45,1,5,5,0,38180005,0,1,99999,4,0,0,0,'[{1,130}]',0,1,0,0,'[]','[]',0,0,0,0),(45010403,'图鉴·巴哈姆特','使用可以激活或升级图鉴收藏-巴哈姆特','',0,'【野外掉落】','[{0,0,0}]',0,1,0,45,1,5,5,0,38180005,0,1,99999,4,0,0,0,'[{1,130}]',0,1,0,0,'[]','[]',0,0,0,0),(46010001,'食谱·黄金烤鸡','<color=#835741>用途：</color>\\n厨师食谱，可在【烹饪】中搭配锅碗瓢盆与猛火使用，使用后可烹饪出黄金烤鸡。\\n\\n<color=#835741>描述：</color>\\n至于为什么每做一道菜都要消耗一个食谱......毕竟生火最好的材料就是纸','',0,'【许愿池】','[{0,0,0}]',0,0,0,46,1,0,0,0,46010001,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(46010002,'食谱·麻辣烤鱼','<color=#835741>用途：</color>\\n厨师食谱，可在【烹饪】中搭配锅碗瓢盆与猛火使用，使用后可烹饪出麻辣烤鱼。\\n\\n<color=#835741>描述：</color>\\n至于为什么每做一道菜都要消耗一个食谱......毕竟生火最好的材料就是纸','',0,'【许愿池】','[{0,0,0}]',0,0,0,46,1,0,0,0,46010002,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(46010003,'食谱·肉汉堡','<color=#835741>用途：</color>\\n厨师食谱，可在【烹饪】中搭配锅碗瓢盆与猛火使用，使用后可烹饪出肉汉堡。\\n\\n<color=#835741>描述：</color>\\n至于为什么每做一道菜都要消耗一个食谱......毕竟生火最好的材料就是纸','',0,'【许愿池】','[{0,0,0}]',0,0,0,46,1,0,0,0,46010003,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(46010004,'食谱·三明治','<color=#835741>用途：</color>\\n厨师食谱，可在【烹饪】中搭配锅碗瓢盆与猛火使用，使用后可烹饪出三明治。\\n\\n<color=#835741>描述：</color>\\n至于为什么每做一道菜都要消耗一个食谱......毕竟生火最好的材料就是纸','',0,'【许愿池】','[{0,0,0}]',0,0,0,46,1,0,0,0,46010004,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(46010005,'食谱·巧克力','<color=#835741>用途：</color>\\n厨师食谱，可在【烹饪】中搭配锅碗瓢盆与猛火使用，使用后可烹饪出巧克力。\\n\\n<color=#835741>描述：</color>\\n至于为什么每做一道菜都要消耗一个食谱......毕竟生火最好的材料就是纸','',0,'【许愿池】','[{0,0,0}]',0,0,0,46,1,0,0,0,46010005,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(46010006,'食谱·火山牛排','<color=#835741>用途：</color>\\n厨师食谱，可在【烹饪】中搭配锅碗瓢盆与猛火使用，使用后可烹饪出火山牛排。\\n\\n<color=#835741>描述：</color>\\n至于为什么每做一道菜都要消耗一个食谱......毕竟生火最好的材料就是纸','',0,'【许愿池】','[{0,0,0}]',0,0,0,46,1,0,0,0,46010006,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(46010007,'食谱·香料面包','<color=#835741>用途：</color>\\n厨师食谱，可在【烹饪】中搭配锅碗瓢盆与猛火使用，使用后可烹饪出香料面包。\\n\\n<color=#835741>描述：</color>\\n至于为什么每做一道菜都要消耗一个食谱......毕竟生火最好的材料就是纸','',0,'【许愿池】','[{0,0,0}]',0,0,0,46,1,0,0,0,46010007,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(46010008,'食谱·布丁奶茶','<color=#835741>用途：</color>\\n厨师食谱，可在【烹饪】中搭配锅碗瓢盆与猛火使用，使用后可烹饪出布丁奶茶。\\n\\n<color=#835741>描述：</color>\\n至于为什么每做一道菜都要消耗一个食谱......毕竟生火最好的材料就是纸','',0,'【许愿池】','[{0,0,0}]',0,0,0,46,1,0,0,0,46010008,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(46010009,'食谱·海风蔬菜卷','<color=#835741>用途：</color>\\n厨师食谱，可在【烹饪】中搭配锅碗瓢盆与猛火使用，使用后可烹饪出海风蔬菜卷。\\n\\n<color=#835741>描述：</color>\\n至于为什么每做一道菜都要消耗一个食谱......毕竟生火最好的材料就是纸','',0,'【许愿池】','[{0,0,0}]',0,0,0,46,1,0,0,0,46010009,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(46010010,'食谱·炙烤鱼排','<color=#835741>用途：</color>\\n厨师食谱，可在【烹饪】中搭配锅碗瓢盆与猛火使用，使用后可烹饪出炙烤鱼排。\\n\\n<color=#835741>描述：</color>\\n至于为什么每做一道菜都要消耗一个食谱......毕竟生火最好的材料就是纸','',0,'【许愿池】','[{0,0,0}]',0,0,0,46,1,0,0,0,46010010,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(46010011,'食谱·彩色蘑菇汤','<color=#835741>用途：</color>\\n厨师食谱，可在【烹饪】中搭配锅碗瓢盆与猛火使用，使用后可烹饪出彩色蘑菇汤。\\n\\n<color=#835741>描述：</color>\\n至于为什么每做一道菜都要消耗一个食谱......毕竟生火最好的材料就是纸','',0,'【许愿池】','[{0,0,0}]',0,0,0,46,1,0,0,0,46010011,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(46010012,'食谱·皇室蛋糕','<color=#835741>用途：</color>\\n厨师食谱，可在【烹饪】中搭配锅碗瓢盆与猛火使用，使用后可烹饪出皇室蛋糕。\\n\\n<color=#835741>描述：</color>\\n至于为什么每做一道菜都要消耗一个食谱......毕竟生火最好的材料就是纸','',0,'【许愿池】','[{0,0,0}]',0,0,0,46,1,0,0,0,46010012,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(46010013,'食谱·海盐布丁','<color=#835741>用途：</color>\\n厨师食谱，可在【烹饪】中搭配锅碗瓢盆与猛火使用，使用后可烹饪出海盐布丁。\\n\\n<color=#835741>描述：</color>\\n至于为什么每做一道菜都要消耗一个食谱......毕竟生火最好的材料就是纸','',0,'【许愿池】','[{0,0,0}]',0,0,0,46,1,0,0,0,46010013,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(46010014,'食谱·香辣烤沙蝎','<color=#835741>用途：</color>\\n厨师食谱，可在【烹饪】中搭配锅碗瓢盆与猛火使用，使用后可烹饪出香辣烤沙蝎。\\n\\n<color=#835741>描述：</color>\\n至于为什么每做一道菜都要消耗一个食谱......毕竟生火最好的材料就是纸','',0,'【许愿池】','[{0,0,0}]',0,0,0,46,1,0,0,0,46010014,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(46010015,'食谱·勇者团子','<color=#835741>用途：</color>\\n厨师食谱，可在【烹饪】中搭配锅碗瓢盆与猛火使用，使用后可烹饪出勇者团子。\\n\\n<color=#835741>描述：</color>\\n至于为什么每做一道菜都要消耗一个食谱......毕竟生火最好的材料就是纸','',0,'【许愿池】','[{0,0,0}]',0,0,0,46,1,0,0,0,46010015,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(46010016,'食谱·炮击果冻','<color=#835741>用途：</color>\\n厨师食谱，可在【烹饪】中搭配锅碗瓢盆与猛火使用，使用后可烹饪出炮击果冻。\\n\\n<color=#835741>描述：</color>\\n至于为什么每做一道菜都要消耗一个食谱......毕竟生火最好的材料就是纸','',0,'【许愿池】','[{0,0,0}]',0,0,0,46,1,0,0,0,46010016,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(46010017,'食谱·骑士蛋卷','<color=#835741>用途：</color>\\n厨师食谱，可在【烹饪】中搭配锅碗瓢盆与猛火使用，使用后可烹饪出骑士蛋卷。\\n\\n<color=#835741>描述：</color>\\n至于为什么每做一道菜都要消耗一个食谱......毕竟生火最好的材料就是纸','',0,'【许愿池】','[{0,0,0}]',0,0,0,46,1,0,0,0,46010022,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(46010018,'食谱·魔法雪糕','<color=#835741>用途：</color>\\n厨师食谱，可在【烹饪】中搭配锅碗瓢盆与猛火使用，使用后可烹饪出魔法雪糕。\\n\\n<color=#835741>描述：</color>\\n至于为什么每做一道菜都要消耗一个食谱......毕竟生火最好的材料就是纸','',0,'【许愿池】','[{0,0,0}]',0,0,0,46,1,0,0,0,46010017,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(46010019,'食谱·奇迹小脆饼','<color=#835741>用途：</color>\\n厨师食谱，可在【烹饪】中搭配锅碗瓢盆与猛火使用，使用后可烹饪出奇迹小脆饼。\\n\\n<color=#835741>描述：</color>\\n至于为什么每做一道菜都要消耗一个食谱......毕竟生火最好的材料就是纸','',0,'【运营活动】','[{0,0,0}]',0,0,0,46,1,0,0,0,46010018,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46010020,'食谱·王者沙拉','<color=#835741>用途：</color>\\n厨师食谱，可在【烹饪】中搭配锅碗瓢盆与猛火使用，使用后可烹饪出王者沙拉。\\n\\n<color=#835741>描述：</color>\\n至于为什么每做一道菜都要消耗一个食谱......毕竟生火最好的材料就是纸','',0,'【运营活动】','[{0,0,0}]',0,0,0,46,1,0,0,0,46010019,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46010021,'食谱·龙王雪花膏','<color=#835741>用途：</color>\\n厨师食谱，可在【烹饪】中搭配锅碗瓢盆与猛火使用，使用后可烹饪出龙王雪花膏。\\n\\n<color=#835741>描述：</color>\\n至于为什么每做一道菜都要消耗一个食谱......毕竟生火最好的材料就是纸','',0,'【运营活动】','[{0,0,0}]',0,0,0,46,1,0,0,0,46010020,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46010022,'食谱·海灵鲜果茶','<color=#835741>用途：</color>\\n厨师食谱，可在【烹饪】中搭配锅碗瓢盆与猛火使用，使用后可烹饪出海灵鲜果茶。\\n\\n<color=#835741>描述：</color>\\n至于为什么每做一道菜都要消耗一个食谱......毕竟生火最好的材料就是纸','',0,'【运营活动】','[{0,0,0}]',0,0,0,46,1,0,0,0,46010021,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020011,'可口·烤鸡','将鸡烤制金黄吧！  出自《食客志》\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~\\n\\n<color=#835741>描述：</color>\\n','攻击 + 300',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,2,0,0,0,46020011,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020012,'美味·烤鸡','将鸡烤制金黄吧！  出自《食客志》\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','攻击 + 500',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,2,0,0,0,46020012,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020013,'佳肴·烤鸡','将鸡烤制金黄吧！  出自《食客志》\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','攻击 + 800',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,2,0,0,0,46020013,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020014,'珍品·烤鸡','将鸡烤制金黄吧！  出自《食客志》\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','攻击 + 1200',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,2,0,0,0,46020014,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020021,'可口·烤鱼','烤鱼，吃的就是火的炙热感\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','破甲 + 300',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,2,0,0,0,46020021,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020022,'美味·烤鱼','烤鱼，吃的就是火的炙热感\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','破甲 + 500',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,2,0,0,0,46020022,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020023,'佳肴·烤鱼','烤鱼，吃的就是火的炙热感\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','破甲 + 800',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,2,0,0,0,46020023,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020024,'珍品·烤鱼','烤鱼，吃的就是火的炙热感\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','破甲 + 1200',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,2,0,0,0,46020024,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020031,'可口·汉堡','两块简简单单的面包，一块简简单单的肉，一顿简简单单的减肥快乐餐\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','防御 + 300',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,2,0,0,0,46020031,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020032,'美味·汉堡','两块简简单单的面包，一块简简单单的肉，一顿简简单单的减肥快乐餐\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','防御 + 500',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,2,0,0,0,46020032,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020033,'佳肴·汉堡','两块简简单单的面包，一块简简单单的肉，一顿简简单单的减肥快乐餐\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','防御 + 800',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,2,0,0,0,46020033,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020034,'珍品·汉堡','两块简简单单的面包，一块简简单单的肉，一顿简简单单的减肥快乐餐\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','防御 + 1200',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,2,0,0,0,46020033,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020041,'可口·三明治','三明治的形状十分规则，有一种很自律的感觉\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','命中 + 300',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,2,0,0,0,46020041,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020042,'美味·三明治','三明治的形状十分规则，有一种很自律的感觉\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','命中 + 500',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,2,0,0,0,46020042,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020043,'佳肴·三明治','三明治的形状十分规则，有一种很自律的感觉\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','命中 + 800',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,2,0,0,0,46020043,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020044,'珍品·三明治','三明治的形状十分规则，有一种很自律的感觉\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','命中 + 1200',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,2,0,0,0,46020043,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020051,'可口·巧克力','“原味的巧克力就是苦的啊”\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','闪避 + 300',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,2,0,0,0,46020051,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020052,'美味·巧克力','“原味的巧克力就是苦的啊”\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','闪避 + 500',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,2,0,0,0,46020052,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020053,'佳肴·巧克力','“原味的巧克力就是苦的啊”\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','闪避 + 800',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,2,0,0,0,46020053,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020054,'珍品·巧克力','“原味的巧克力就是苦的啊”\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','闪避 + 1200',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,2,0,0,0,46020053,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020061,'可口·牛排','龙族所圈养的牛，比别的地方的牛还牛，所以肉质非常好。出自《食材志》\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','暴击 + 300',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,2,0,0,0,46020061,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020062,'美味·牛排','龙族所圈养的牛，比别的地方的牛还牛，所以肉质非常好。出自《食材志》\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','暴击 + 500',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,2,0,0,0,46020061,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020063,'佳肴·牛排','龙族所圈养的牛，比别的地方的牛还牛，所以肉质非常好。出自《食材志》\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','暴击 + 800',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,2,0,0,0,46020061,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020064,'珍品·牛排','龙族所圈养的牛，比别的地方的牛还牛，所以肉质非常好。出自《食材志》\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','暴击 + 1200',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,2,0,0,0,46020061,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020071,'可口·面包','“我只是一块小面包，好不好吃我自己知道！”出自《食物志》\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','韧性 + 300',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,2,0,0,0,46020071,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020072,'美味·面包','“我只是一块小面包，好不好吃我自己知道！”出自《食物志》\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','韧性 + 500',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,2,0,0,0,46020072,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020073,'佳肴·面包','“我只是一块小面包，好不好吃我自己知道！”出自《食物志》\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','韧性 + 800',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,2,0,0,0,46020073,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020074,'珍品·面包','“我只是一块小面包，好不好吃我自己知道！”出自《食物志》\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','韧性 + 1200',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,2,0,0,0,46020074,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020081,'可口·奶茶','奶味、茶味与原味。出自《食神志》\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','暴伤值 + 300',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,2,0,0,0,46020081,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020082,'美味·奶茶','奶味、茶味与原味。出自《食神志》\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','暴伤值 + 500',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,2,0,0,0,46020082,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020083,'佳肴·奶茶','奶味、茶味与原味。出自《食神志》\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','暴伤值 + 800',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,2,0,0,0,46020083,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020084,'珍品·奶茶','奶味、茶味与原味。出自《食神志》\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','暴伤值 + 1200',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,2,0,0,0,46020083,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020091,'可口·蔬菜卷','浓烈的海盐味被番茄的清新所带走。这就像烈阳下的沙滩上，躺椅上的你迎来了一阵清爽的海风\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','抗暴值 + 300',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,2,0,0,0,46020091,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020092,'美味·蔬菜卷','浓烈的海盐味被番茄的清新所带走。这就像烈阳下的沙滩上，躺椅上的你迎来了一阵清爽的海风\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','抗暴值 + 500',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,2,0,0,0,46020092,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020093,'佳肴·蔬菜卷','浓烈的海盐味被番茄的清新所带走。这就像烈阳下的沙滩上，躺椅上的你迎来了一阵清爽的海风\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','抗暴值 + 800',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,2,0,0,0,46020093,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020094,'珍品·蔬菜卷','浓烈的海盐味被番茄的清新所带走。这就像烈阳下的沙滩上，躺椅上的你迎来了一阵清爽的海风\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','抗暴值 + 1200',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,2,0,0,0,46020093,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020101,'可口·鱼排','如何快速的烹饪这道菜，就是把鱼放到魔剑士的手上~\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','冰系伤害 + 300,冰系伤害加成 + 5%',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,3,0,0,0,46020101,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020102,'美味·鱼排','如何快速的烹饪这道菜，就是把鱼放到魔剑士的手上~\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','冰系伤害 + 500,冰系伤害加成 + 6%',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,3,0,0,0,46020102,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020103,'佳肴·鱼排','如何快速的烹饪这道菜，就是把鱼放到魔剑士的手上~\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','冰系伤害 + 800,冰系伤害加成 + 7%',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,3,0,0,0,46020103,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020104,'珍品·鱼排','如何快速的烹饪这道菜，就是把鱼放到魔剑士的手上~\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','冰系伤害 + 1200,冰系伤害加成 + 8%',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,3,0,0,0,46020103,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020111,'可口·蘑菇汤','虽然看起来是有毒的样子，但它是蘑菇林的名菜，被评为星球十大料理之一\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','冰系防御 + 300,冰系防御加成 + 5%',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,3,0,0,0,46020111,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020112,'美味·蘑菇汤','虽然看起来是有毒的样子，但它是蘑菇林的名菜，被评为星球十大料理之一\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','冰系防御 + 500,冰系防御加成 + 6%',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,3,0,0,0,46020111,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020113,'佳肴·蘑菇汤','虽然看起来是有毒的样子，但它是蘑菇林的名菜，被评为星球十大料理之一\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','冰系防御 + 800,冰系防御加成 + 7%',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,3,0,0,0,46020111,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020114,'珍品·蘑菇汤','虽然看起来是有毒的样子，但它是蘑菇林的名菜，被评为星球十大料理之一\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','冰系防御 + 1200,冰系防御加成 + 8%',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,3,0,0,0,46020111,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020121,'可口·蛋糕','据说只要拿着这个蛋糕去森林里，就能“召唤”出一脸贪吃的精灵\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','雷系伤害 + 300,雷系伤害加成 + 5%',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,3,0,0,0,46020121,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020122,'美味·蛋糕','据说只要拿着这个蛋糕去森林里，就能“召唤”出一脸贪吃的精灵\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','雷系伤害 + 500,雷系伤害加成 + 6%',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,3,0,0,0,46020122,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020123,'佳肴·蛋糕','据说只要拿着这个蛋糕去森林里，就能“召唤”出一脸贪吃的精灵\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','雷系伤害 + 800,雷系伤害加成 + 7%',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,3,0,0,0,46020123,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020124,'珍品·蛋糕','据说只要拿着这个蛋糕去森林里，就能“召唤”出一脸贪吃的精灵\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','雷系伤害 + 1200,雷系伤害加成 + 8%',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,3,0,0,0,46020123,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020131,'可口·布丁','“你以为我系一个布丁，但其实我真的只是一个布丁。”出自《食物的自辩》\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','雷系防御 + 300,雷系防御加成 + 5%',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,3,0,0,0,46020131,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020132,'美味·布丁','“你以为我系一个布丁，但其实我真的只是一个布丁。”出自《食物的自辩》\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','雷系防御 + 500,雷系防御加成 + 6%',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,3,0,0,0,46020132,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020133,'佳肴·布丁','“你以为我系一个布丁，但其实我真的只是一个布丁。”出自《食物的自辩》\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','雷系防御 + 800,雷系防御加成 + 7%',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,3,0,0,0,46020133,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020134,'珍品·布丁','“你以为我系一个布丁，但其实我真的只是一个布丁。”出自《食物的自辩》\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','雷系防御 + 1200,雷系防御加成 + 8%',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,3,0,0,0,46020133,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020141,'可口·烤蝎','这只蝎子中暑了，不如我们……\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','火系伤害 + 300,火系伤害加成 + 5%',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,3,0,0,0,46020141,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020142,'美味·烤蝎','这只蝎子中暑了，不如我们……\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','火系伤害 + 500,火系伤害加成 + 6%',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,3,0,0,0,46020142,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020143,'佳肴·烤蝎','这只蝎子中暑了，不如我们……\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','火系伤害 + 800,火系伤害加成 + 7%',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,3,0,0,0,46020143,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020144,'珍品·烤蝎','这只蝎子中暑了，不如我们……\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','火系伤害 + 1200,火系伤害加成 + 8%',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,3,0,0,0,46020143,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020151,'可口·团子','“我什么都不知道，因为我只是一个团子啊。”出自《假如食物会说话》\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','火系防御 + 300,火系防御加成 + 5%',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,3,0,0,0,46020151,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020152,'美味·团子','“我什么都不知道，因为我只是一个团子啊。”出自《假如食物会说话》\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','火系防御 + 500,火系防御加成 + 6%',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,3,0,0,0,46020151,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020153,'佳肴·团子','“我什么都不知道，因为我只是一个团子啊。”出自《假如食物会说话》\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','火系防御 + 800,火系防御加成 + 7%',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,3,0,0,0,46020153,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020154,'珍品·团子','“我什么都不知道，因为我只是一个团子啊。”出自《假如食物会说话》\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','火系防御 + 1200,火系防御加成 + 8%',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,3,0,0,0,46020153,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020161,'可口·果冻','重炮手摸着她的耳朵说这个相貌平平的布丁其实是一个炸弹\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','风系伤害 + 300,风系伤害加成 + 5%',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,3,0,0,0,46020161,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020162,'美味·果冻','重炮手摸着她的耳朵说这个相貌平平的布丁其实是一个炸弹\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','风系伤害 + 500,风系伤害加成 + 6%',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,3,0,0,0,46020161,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020163,'佳肴·果冻','重炮手摸着她的耳朵说这个相貌平平的布丁其实是一个炸弹\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','风系伤害 + 800,风系伤害加成 + 7%',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,3,0,0,0,46020163,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020164,'珍品·果冻','重炮手摸着她的耳朵说这个相貌平平的布丁其实是一个炸弹\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','风系伤害 + 1200,风系伤害加成 + 8%',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,3,0,0,0,46020163,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020171,'可口·蛋卷','尽管看起来很普通，但却是龙骑士最爱的食物\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','风系防御 + 300,风系防御加成 + 5%',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,3,0,0,0,46020171,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020172,'美味·蛋卷','尽管看起来很普通，但却是龙骑士最爱的食物\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','风系防御 + 500,风系防御加成 + 6%',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,3,0,0,0,46020171,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020173,'佳肴·蛋卷','尽管看起来很普通，但却是龙骑士最爱的食物\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','风系防御 + 800,风系防御加成 + 7%',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,3,0,0,0,46020173,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020174,'珍品·蛋卷','尽管看起来很普通，但却是龙骑士最爱的食物\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','风系防御 + 1200,风系防御加成 + 8%',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,3,0,0,0,46020173,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020181,'可口·雪糕','拥有多重属性的魔导师，最爱吃这些极端加极端的食物\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','会心一击 + 5%',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,3,0,0,0,46020181,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020182,'美味·雪糕','拥有多重属性的魔导师，最爱吃这些极端加极端的食物\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','会心一击 + 6%',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,3,0,0,0,46020181,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020183,'佳肴·雪糕','拥有多重属性的魔导师，最爱吃这些极端加极端的食物\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','会心一击 + 7%',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,3,0,0,0,46020183,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020184,'珍品·雪糕','拥有多重属性的魔导师，最爱吃这些极端加极端的食物\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','会心一击 + 8%',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,3,0,0,0,46020183,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020193,'佳肴·奇迹小脆饼','精灵回廊中诞生的小饼干，据说对它许下的愿望都可以实现~你要吃饼干吗~\\n○温馨提醒：食用效果持续1小时,同属性加成类型的食物一起食用时，加成效果会被替换~\\n\\n<color=#835813>描述：</color>\\n','经验加成 + 15%',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,4,0,0,0,46020193,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020194,'珍品·奇迹小脆饼','精灵回廊中诞生的小饼干，据说对它许下的愿望都可以实现~你要吃饼干吗~\\n○温馨提醒：食用效果持续1小时,同属性加成类型的食物一起食用时，加成效果会被替换~\\n\\n<color=#835814>描述：</color>\\n','经验加成 + 20%',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,4,0,0,0,46020193,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020203,'佳肴·王者沙拉','最强的人，也逃不过变成美味的俘虏\\n○温馨提醒：食用效果持续1小时,同属性加成类型的食物一起食用时，加成效果会被替换~\\n\\n<color=#835815>描述：</color>\\n','移动速度 + 20',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,4,0,0,0,46020203,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020204,'珍品·王者沙拉','最强的人，也逃不过变成美味的俘虏\\n○温馨提醒：食用效果持续1小时,同属性加成类型的食物一起食用时，加成效果会被替换~\\n\\n<color=#835816>描述：</color>\\n','移动速度 + 30',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,4,0,0,0,46020203,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020213,'佳肴·龙王雪花糕','龙族之王很喜欢这道精致的茶点\\n○温馨提醒：食用效果持续1小时,同属性加成类型的食物一起食用时，加成效果会被替换~\\n\\n<color=#835817>描述：</color>\\n','生命回复 + 3%',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,4,0,0,0,46020213,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020214,'珍品·龙王雪花糕','龙族之王很喜欢这道精致的茶点\\n○温馨提醒：食用效果持续1小时,同属性加成类型的食物一起食用时，加成效果会被替换~\\n\\n<color=#835818>描述：</color>\\n','生命回复 + 5%',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,4,0,0,0,46020213,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020223,'佳肴·海灵鲜果茶','海族先知冥想前都要喝上一杯海灵鲜果茶\\n○温馨提醒：食用效果持续1小时,同属性加成类型的食物一起食用时，加成效果会被替换~\\n\\n<color=#835819>描述：</color>\\n','伤害加深 + 15%',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,4,0,0,0,46020223,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020224,'珍品·海灵鲜果茶','海族先知冥想前都要喝上一杯海灵鲜果茶\\n○温馨提醒：食用效果持续1小时,同属性加成类型的食物一起食用时，加成效果会被替换~\\n\\n<color=#835820>描述：</color>\\n','伤害加深 + 20%',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,4,0,0,0,46020223,0,0,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020231,'可口·炸虾','中暑的虾不要扔掉，裹上鸡蛋液，撒上面包糠，放进油锅里炸至两面金黄，隔壁的小孩都馋哭了！\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','攻击 + 150',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,3,0,0,0,46020231,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020232,'美味·炸虾','中暑的虾不要扔掉，裹上鸡蛋液，撒上面包糠，放进油锅里炸至两面金黄，隔壁的小孩都馋哭了！\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','攻击 + 250',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,3,0,0,0,46020231,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020233,'佳肴·炸虾','中暑的虾不要扔掉，裹上鸡蛋液，撒上面包糠，放进油锅里炸至两面金黄，隔壁的小孩都馋哭了！\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','攻击 + 400',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,3,0,0,0,46020231,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020241,'可口·芝士块','伟大的哲学家沃夏编德曾经说过：芝士就是力量！\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','破甲 + 150',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,3,0,0,0,46020241,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020242,'美味·芝士块','伟大的哲学家沃夏编德曾经说过：芝士就是力量！\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','破甲 + 250',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,3,0,0,0,46020241,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020243,'佳肴·芝士块','伟大的哲学家沃夏编德曾经说过：芝士就是力量！\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','破甲 + 400',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,3,0,0,0,46020241,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020251,'可口·紫菜寿司','你的两块寿司中有一块是超辣的，如果我吃掉了一块（#嚼嚼嚼），那么剩下那块是辣还是不辣呢？\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','防御 + 150',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,3,0,0,0,46020251,0,0,99999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020252,'美味·紫菜寿司','你的两块寿司中有一块是超辣的，如果我吃掉了一块（#嚼嚼嚼），那么剩下那块是辣还是不辣呢？\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','防御 + 250',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,3,0,0,0,46020251,0,0,99999,1,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(46020253,'佳肴·紫菜寿司','你的两块寿司中有一块是超辣的，如果我吃掉了一块（#嚼嚼嚼），那么剩下那块是辣还是不辣呢？\\n○温馨提醒：食用效果持续0.5小时。各种食物的加持效果会互相覆盖，请选择最适合的料理食用吧~~\\n\\n<color=#835741>描述：</color>\\n','防御 + 400',0,'【食物烹饪】','[{0,0,0}]',0,0,0,46,3,0,0,0,46020251,0,0,99999,2,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(47010001,'图纸·蜜语圆床','图纸','',0,'【运营活动】','[{0,0,0}]',0,0,0,47,1,0,0,0,47010001,0,0,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(47010002,'图纸·温馨沙发','图纸','',0,'【运营活动】','[{0,0,0}]',0,0,0,47,1,0,0,0,47010002,0,0,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(47010003,'图纸·典雅茶几','图纸','',0,'【运营活动】','[{0,0,0}]',0,0,0,47,1,0,0,0,47010003,0,0,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(47010004,'图纸·复古台灯','图纸','',0,'【运营活动】','[{0,0,0}]',0,0,0,47,1,0,0,0,47010004,0,0,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(47010005,'图纸·花语吊篮','图纸','',0,'【运营活动】','[{0,0,0}]',0,0,0,47,1,0,0,0,47010005,0,0,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(47010006,'图纸·丰收屏风','图纸','',0,'【运营活动】','[{0,0,0}]',0,0,0,47,1,0,0,0,47010006,0,0,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(47010007,'图纸·爱意纱窗','图纸','',0,'【运营活动】','[{0,0,0}]',0,0,0,47,1,0,0,0,47010007,0,0,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(47030011,'【良好】朴素小床','家具','',0,'【打造获得】','[{0,0,0}]',0,0,1,47,3,0,0,0,47030011,0,0,99999,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47030012,'【精致】朴素小床','家具','',0,'【打造获得】','[{0,0,0}]',0,0,1,47,3,0,0,0,47030011,0,0,99999,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47030013,'【华丽】朴素小床','家具','',0,'【打造获得】','[{0,0,0}]',0,0,1,47,3,0,0,0,47030011,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47030014,'【完美】朴素小床','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,3,0,0,0,47030011,0,0,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47030021,'【良好】褐色书柜','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,3,0,0,0,47030021,0,0,99999,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47030022,'【精致】褐色书柜','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,3,0,0,0,47030021,0,0,99999,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47030023,'【华丽】褐色书柜','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,3,0,0,0,47030021,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47030024,'【完美】褐色书柜','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,3,0,0,0,47030021,0,0,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47030031,'【良好】白色衣柜','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,3,0,0,0,47030031,0,0,99999,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47030032,'【精致】白色衣柜','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,3,0,0,0,47030031,0,0,99999,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47030033,'【华丽】白色衣柜','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,3,0,0,0,47030031,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47030034,'【完美】白色衣柜','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,3,0,0,0,47030031,0,0,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47030041,'【完美】蜜语圆床','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,3,0,0,0,47030041,0,0,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47040011,'【良好】红色圆凳','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,4,0,0,0,47040011,0,0,99999,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47040012,'【精致】红色圆凳','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,4,0,0,0,47040011,0,0,99999,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47040013,'【华丽】红色圆凳','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,4,0,0,0,47040011,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47040014,'【完美】红色圆凳','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,4,0,0,0,47040011,0,0,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47040021,'【良好】红色椅子','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,4,0,0,0,47040021,0,0,99999,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47040022,'【精致】红色椅子','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,4,0,0,0,47040021,0,0,99999,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47040023,'【华丽】红色椅子','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,4,0,0,0,47040021,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47040024,'【完美】红色椅子','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,4,0,0,0,47040021,0,0,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47040031,'【良好】简易圆桌','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,4,0,0,0,47040031,0,0,99999,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47040032,'【精致】简易圆桌','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,4,0,0,0,47040031,0,0,99999,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47040033,'【华丽】简易圆桌','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,4,0,0,0,47040031,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47040034,'【完美】简易圆桌','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,4,0,0,0,47040031,0,0,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47040041,'【良好】方形书桌','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,4,0,0,0,47040041,0,0,99999,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47040042,'【精致】方形书桌','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,4,0,0,0,47040041,0,0,99999,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47040043,'【华丽】方形书桌','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,4,0,0,0,47040041,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47040044,'【完美】方形书桌','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,4,0,0,0,47040041,0,0,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47040051,'【良好】简约茶几','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,4,0,0,0,47040051,0,0,99999,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47040052,'【精致】简约茶几','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,4,0,0,0,47040051,0,0,99999,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47040053,'【华丽】简约茶几','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,4,0,0,0,47040051,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47040054,'【完美】简约茶几','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,4,0,0,0,47040051,0,0,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47040061,'【完美】温馨沙发','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,4,0,0,0,47040061,0,0,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47040071,'【完美】典雅茶几','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,4,0,0,0,47040071,0,0,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47050011,'【良好】小伞台灯','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,5,0,0,0,47050011,0,0,99999,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47050012,'【精致】小伞台灯','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,5,0,0,0,47050011,0,0,99999,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47050013,'【华丽】小伞台灯','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,5,0,0,0,47050011,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47050014,'【完美】小伞台灯','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,5,0,0,0,47050011,0,0,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47050021,'【良好】风景屏风','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,5,0,0,0,47050021,0,0,99999,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47050022,'【精致】风景屏风','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,5,0,0,0,47050021,0,0,99999,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47050023,'【华丽】风景屏风','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,5,0,0,0,47050021,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47050024,'【完美】风景屏风','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,5,0,0,0,47050021,0,0,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47050031,'【良好】小树盆栽','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,5,0,0,0,47050031,0,0,99999,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47050032,'【精致】小树盆栽','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,5,0,0,0,47050031,0,0,99999,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47050033,'【华丽】小树盆栽','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,5,0,0,0,47050031,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47050034,'【完美】小树盆栽','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,5,0,0,0,47050031,0,0,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47050041,'【完美】复古台灯','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,5,0,0,0,47050041,0,0,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47050051,'【完美】花语吊篮','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,5,0,0,0,47050051,0,0,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47050061,'【完美】丰收屏风','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,5,0,0,0,47050061,0,0,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47060011,'【良好】圆顶窗户','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,6,0,0,0,47060011,0,0,99999,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47060012,'【精致】圆顶窗户','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,6,0,0,0,47060011,0,0,99999,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47060013,'【华丽】圆顶窗户','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,6,0,0,0,47060011,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47060014,'【完美】圆顶窗户','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,6,0,0,0,47060011,0,0,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47060021,'【良好】纯净纱窗','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,6,0,0,0,47060021,0,0,99999,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47060022,'【精致】纯净纱窗','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,6,0,0,0,47060021,0,0,99999,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47060023,'【华丽】纯净纱窗','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,6,0,0,0,47060021,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47060024,'【完美】纯净纱窗','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,6,0,0,0,47060021,0,0,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47060031,'【良好】灰色墙纸','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,6,0,0,0,47060031,0,0,99999,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47060032,'【精致】灰色墙纸','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,6,0,0,0,47060031,0,0,99999,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47060033,'【华丽】灰色墙纸','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,6,0,0,0,47060031,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47060034,'【完美】灰色墙纸','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,6,0,0,0,47060031,0,0,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47060035,'【一层】灰色墙纸','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,6,0,0,0,47060031,0,0,99999,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47060036,'【二层】灰色墙纸','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,6,0,0,0,47060031,0,0,99999,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47060037,'【中级】灰色墙纸','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,6,0,0,0,47060031,0,0,99999,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47060038,'【一层】灰色墙纸','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,6,0,0,0,47060031,0,0,99999,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47060039,'【二层】灰色墙纸','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,6,0,0,0,47060031,0,0,99999,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47060041,'【完美】爱意纱窗','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,6,0,0,0,47060041,0,0,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47070011,'【良好】圆形地毯','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,7,0,0,0,47070011,0,0,99999,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47070012,'【精致】圆形地毯','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,7,0,0,0,47070011,0,0,99999,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47070013,'【华丽】圆形地毯','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,7,0,0,0,47070011,0,0,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(47070014,'【完美】圆形地毯','家具','',0,'【打造获得】','[{0,0,0}]',0,0,0,47,7,0,0,0,47070011,0,0,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(48010001,'木材','家园生活材料','',0,'','[{0,0,0}]',0,0,0,48,1,0,0,0,48010001,0,250,9999,0,0,0,0,'[]',0,0,0,1,'[]','[]',0,0,0,0),(48020001,'铁矿','家园生活材料','',0,'','[{0,0,0}]',0,0,0,48,2,0,0,0,48020001,0,250,9999,0,0,0,0,'[]',0,0,0,1,'[]','[]',0,0,0,0),(48030001,'石料','家园生活材料','',0,'','[{0,0,0}]',0,0,0,48,3,0,0,0,48030001,0,250,9999,0,0,0,0,'[]',0,0,0,1,'[]','[]',0,0,0,0),(48040001,'家园币','家园内唯一流通货币','',0,'','[{0,0,0}]',0,0,0,48,4,0,0,0,48040001,0,250,99999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(48040002,'许愿币','家园许愿池消耗品','',0,'','[{0,0,0}]',0,0,0,48,8,0,0,0,36300002,0,250,999999,0,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(48050001,'地契','家园激活道具\\n激活后可以体验新颖的家园系统，激活更多成长线，还能够装饰自己的房屋哦','',0,'【商城】','[{0,0,0}]',0,0,1,48,5,0,0,0,48050001,0,250,9999,3,0,0,0,'[]',0,1,0,0,'[]','[]',0,0,0,0),(48050002,'房屋共享卡','使用之后，伴侣双方可以共享房屋和家具哦','',0,'【商城】','[{0,0,0}]',0,0,1,48,5,0,0,0,48050001,0,250,9999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(48060101,'5min加速卡','使用后可减少任意建筑升级时间\\n减少时间：5分钟','',0,'【运营活动】','[{0,0,0}]',0,0,0,48,6,4,7,0,38180005,0,1,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(48060102,'10min加速卡','使用后可减少任意建筑升级时间\\n减少时间：10分钟','',0,'【运营活动】','[{0,0,0}]',0,0,0,48,6,4,7,0,38180005,0,1,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(48060103,'30min加速卡','使用后可减少任意建筑升级时间\\n减少时间：30分钟','',0,'【运营活动】','[{0,0,0}]',0,0,0,48,6,4,7,0,38180005,0,1,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(48060201,'伐木场加速卡','使用后可减少伐木场建筑升级时间\\n减少时间：5分钟','',0,'【运营活动】','[{0,0,0}]',0,0,0,48,6,4,7,0,38180005,0,1,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(48060202,'铁矿场加速卡','使用后可减少铁矿场建筑升级时间\\n减少时间：5分钟','',0,'【运营活动】','[{0,0,0}]',0,0,0,48,6,4,7,0,38180005,0,1,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(48060203,'石料场加速卡','使用后可减少石料建筑升级时间\\n减少时间：5分钟','',0,'【运营活动】','[{0,0,0}]',0,0,0,48,6,4,7,0,38180005,0,1,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(48060204,'鱼塘加速卡','使用后可减少鱼塘建筑升级时间\\n减少时间：5分钟','',0,'【运营活动】','[{0,0,0}]',0,0,0,48,6,4,7,0,38180005,0,1,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(48060205,'打造坊加速卡','使用后可减少打造坊建筑升级时间\\n减少时间：5分钟','',0,'【运营活动】','[{0,0,0}]',0,0,0,48,6,4,7,0,38180005,0,1,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(48060206,'餐厅加速卡','使用后可减少餐厅建筑升级时间\\n减少时间：5分钟','',0,'【运营活动】','[{0,0,0}]',0,0,0,48,6,4,7,0,38180005,0,1,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(48060207,'房屋加速卡','使用后可减少房屋建筑升级时间\\n减少时间：5分钟','',0,'【运营活动】','[{0,0,0}]',0,0,0,48,6,4,7,0,38180005,0,1,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(48060208,'雕像加速卡','使用后可减少雕像建筑升级时间\\n减少时间：5分钟','',0,'【运营活动】','[{0,0,0}]',0,0,0,48,6,4,7,0,38180005,0,1,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(48060209,'许愿池加速卡','使用后可减少许愿池建筑升级时间\\n减少时间：5分钟','',0,'【运营活动】','[{0,0,0}]',0,0,0,48,6,4,7,0,38180005,0,1,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(48060210,'任务场加速卡','使用后可减少任务场建筑升级时间\\n减少时间：5分钟','',0,'【运营活动】','[{0,0,0}]',0,0,0,48,6,4,7,0,38180005,0,1,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(48060211,'研究所加速卡','使用后可减少研究所建筑升级时间\\n减少时间：5分钟','',0,'【运营活动】','[{0,0,0}]',0,0,0,48,6,4,7,0,38180005,0,1,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(48070001,'临时队列卡','使用后可增加一个持续24小时的建筑升级队列','',0,'【运营活动】','[{0,0,0}]',0,0,0,48,7,4,7,0,38180005,0,1,9999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(50010101,'普通鱼竿','简单鱼竿，提升紫色鱼类上钩的几率<color=#4eae1a>+5%</color>','',0,'【渔具商店】','[{0,0,0}]',0,0,1,50,1,1,0,0,50010101,0,170,9999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(50010102,'中级鱼竿','中级鱼竿，提升橙色鱼类上钩的几率<color=#4eae1a>+10%</color>','',0,'【渔具商店】','[{0,0,0}]',0,0,1,50,1,1,0,0,50010102,0,170,9999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(50010103,'顶级鱼竿','顶级鱼竿，提升红色鱼类上钩的几率<color=#4eae1a>+10%</color>','',0,'【渔具商店】','[{0,0,0}]',0,0,1,50,1,1,0,0,50010103,0,170,9999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(50010201,'普通鱼饵','使用普通鱼饵钓鱼，可提升橙色鱼类上钩的几率<color=#4eae1a>+1%</color>','',0,'【渔具商店】','[{0,0,0}]',0,0,1,50,1,1,0,0,50010201,0,170,9999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(50010202,'稀有鱼饵','使用顶级鱼饵钓鱼，可提升红色鱼类上钩的几率哦<color=#4eae1a>+5%</color>','',0,'【渔具商店】','[{0,0,0}]',0,0,1,50,1,1,0,0,50010202,0,170,9999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(50020101,'鳕鱼','这是一条来自星界的幻想鱼','',0,'【钓鱼】','[{0,0,0}]',0,0,1,50,2,0,0,0,50020101,0,170,9999,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(50020102,'三文鱼','这是一条来自星界的幻想鱼','',0,'【钓鱼】','[{0,0,0}]',0,0,1,50,2,0,0,0,50020102,0,170,9999,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(50020103,'九纹龙','这是一条来自星界的幻想鱼','',0,'【钓鱼】','[{0,0,0}]',0,0,1,50,2,0,0,0,50020103,0,170,9999,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(50020104,'黄金尖尾鲈','这是一条来自星界的幻想鱼','',0,'【钓鱼】','[{0,0,0}]',0,0,1,50,2,0,0,0,50020104,0,170,9999,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(50020105,'珊瑚美人','这是一条来自星界的幻想鱼','',0,'【钓鱼】','[{0,0,0}]',0,0,1,50,2,0,0,0,50020105,0,170,9999,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(50020106,'龙鱼','这是一条来自星界的幻想鱼','',0,'【钓鱼】','[{0,0,0}]',0,0,1,50,2,0,0,0,50020106,0,170,9999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(50020107,'破浪剑鱼','这是一条来自星界的幻想鱼','',0,'【钓鱼】','[{0,0,0}]',0,0,1,50,2,0,0,0,50020107,0,170,9999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(50020108,'黄金鲶鱼','这是一条来自星界的幻想鱼','',0,'【钓鱼】','[{0,0,0}]',0,0,1,50,2,0,0,0,50020108,0,170,9999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(50020109,'彩斑河豚','这是一条来自星界的幻想鱼','',0,'【钓鱼】','[{0,0,0}]',0,0,1,50,2,0,0,0,50020109,0,170,9999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(50020110,'小丑鱼','这是一条来自星界的幻想鱼','',0,'【钓鱼】','[{0,0,0}]',0,0,1,50,2,0,0,0,50020110,0,170,9999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(50020111,'彩虹鱼','这是一条来自星界的幻想鱼','',0,'【钓鱼】','[{0,0,0}]',0,0,1,50,2,0,0,0,50020111,0,170,9999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(50030101,'章鱼','这是一条来自星界的幻想奇珍','',0,'【钓鱼】','[{0,0,0}]',0,0,1,50,3,0,0,0,50030101,0,170,9999,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(50030102,'龙尾虾','这是一条来自星界的幻想奇珍','',0,'【钓鱼】','[{0,0,0}]',0,0,1,50,3,0,0,0,50030102,0,170,9999,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(50030103,'鲍鱼','这是一条来自星界的幻想奇珍','',0,'【钓鱼】','[{0,0,0}]',0,0,1,50,3,0,0,0,50030103,0,170,9999,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(50030104,'珍宝蟹','这是一条来自星界的幻想奇珍','',0,'【钓鱼】','[{0,0,0}]',0,0,1,50,3,0,0,0,50030104,0,170,9999,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(50030105,'黄金海星','这是一条来自星界的幻想奇珍','',0,'【钓鱼】','[{0,0,0}]',0,0,1,50,3,0,0,0,50030105,0,170,9999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(50030106,'红玉珊瑚','这是一条来自星界的幻想奇珍','',0,'【钓鱼】','[{0,0,0}]',0,0,1,50,3,0,0,0,50030106,0,170,9999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(50030107,'寄居蟹','这是一条来自星界的幻想奇珍','',0,'【钓鱼】','[{0,0,0}]',0,0,1,50,3,0,0,0,50030107,0,170,9999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(50030108,'幼生海草','这是一条来自星界的幻想奇珍','',0,'【钓鱼】','[{0,0,0}]',0,0,1,50,3,0,0,0,50030108,0,170,9999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(50040101,'珍珠贝','这是一个星界的幻想贝壳','',0,'【钓鱼】','[{0,0,0}]',0,0,1,50,4,0,0,0,50040101,0,170,9999,0,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(50040102,'黄金螺','这是一个星界的幻想贝壳','',0,'【钓鱼】','[{0,0,0}]',0,0,1,50,4,0,0,0,50040102,0,170,9999,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(50040103,'火焰贝壳','这是一个星界的幻想贝壳','',0,'【钓鱼】','[{0,0,0}]',0,0,1,50,4,0,0,0,50040103,0,170,9999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(50040104,'石斑螺','这是一个星界的幻想贝壳','',0,'【钓鱼】','[{0,0,0}]',0,0,1,50,4,0,0,0,50040104,0,170,9999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(53010101,'寒鸦·寒霜大剑','寒鸦·寒霜大剑','攻击+774,破甲+619,命中+495,命中率+1%',55705,'【运营活动】','[{0,0,0}]',0,0,0,53,1,0,0,0,53010101,1,1,99999,6,0,0,0,'[]',0,0,0,0,'[{1,1000}]','[]',0,0,0,1),(53010102,'焚烬·龙焰斩剑','焚烬·龙焰斩剑','攻击+1200,破甲+960,命中+768,技能伤害+1%',86400,'【巅峰寻宝】','[{0,0,0}]',0,0,0,53,1,0,0,0,53010102,1,1,99999,6,0,0,0,'[]',0,0,0,0,'[{1,1000}]','[]',0,0,0,1),(53010103,'天火·强袭军刀','天火·强袭军刀','攻击+800,破甲+640,命中+512,pvp伤害+1%',57600,'【装备寻宝】','[{416,0,1}]',0,0,0,53,1,0,0,0,53010103,1,1,99999,6,0,0,0,'[]',0,0,0,0,'[{1,1000}]','[]',0,0,0,1),(53010104,'圣言·裁决圣剑','圣言·裁决圣剑','攻击+858,破甲+686,命中+549,暴击率+0.8%',61760,'【运营活动】','[{0,0,0}]',0,0,0,53,1,0,0,0,53010104,1,1,99999,6,0,0,0,'[]',0,0,0,0,'[{1,1000}]','[]',0,0,0,1),(53010105,'暗裔·灾厄魔剑','暗裔·灾厄魔剑','攻击+1650,破甲+1320,命中+1056,伤害加成+1%',118800,'【至尊寻宝】','[{0,0,0}]',0,0,0,53,1,0,0,0,53010105,1,1,99999,6,0,0,0,'[]',0,0,0,0,'[{1,1000}]','[]',0,0,0,1),(53010201,'寒鸦·冰晶长枪','寒鸦·冰晶长枪','攻击+774,破甲+619,命中+495,命中率+1%',55705,'【运营活动】','[{0,0,0}]',0,0,0,53,1,0,0,0,53010201,2,1,99999,6,0,0,0,'[]',0,0,0,0,'[{1,1000}]','[]',0,0,0,1),(53010202,'焚烬·屠龙炎枪','焚烬·屠龙炎枪','攻击+1200,破甲+960,命中+768,技能伤害+1%',86400,'【巅峰寻宝】','[{0,0,0}]',0,0,0,53,1,0,0,0,53010202,2,1,99999,6,0,0,0,'[]',0,0,0,0,'[{1,1000}]','[]',0,0,0,1),(53010203,'雷云·突击枪刃','雷云·突击枪刃','攻击+800,破甲+640,命中+512,pvp伤害+1%',57600,'【装备寻宝】','[{416,0,1}]',0,0,0,53,1,0,0,0,53010203,2,1,99999,6,0,0,0,'[]',0,0,0,0,'[{1,1000}]','[]',0,0,0,1),(53010204,'圣言·断罪圣枪','圣言·断罪圣枪','攻击+858,破甲+686,命中+549,暴击率+0.8%',61760,'【运营活动】','[{0,0,0}]',0,0,0,53,1,0,0,0,53010204,2,1,99999,6,0,0,0,'[]',0,0,0,0,'[{1,1000}]','[]',0,0,0,1),(53010205,'暗裔·屠戮魔枪','暗裔·屠戮魔枪','攻击+1650,破甲+1320,命中+1056,伤害加成+1%',118800,'【至尊寻宝】','[{0,0,0}]',0,0,0,53,1,0,0,0,53010205,2,1,99999,6,0,0,0,'[]',0,0,0,0,'[{1,1000}]','[]',0,0,0,1),(53010401,'寒鸦·凛冬重炮','寒鸦·凛冬重炮','攻击+774,破甲+619,命中+495,命中率+1%',55705,'【运营活动】','[{0,0,0}]',0,0,0,53,1,0,0,0,53010401,4,1,99999,6,0,0,0,'[]',0,0,0,0,'[{1,1000}]','[]',0,0,0,1),(53010402,'焚烬·龙神火炮','焚烬·龙神火炮','攻击+1200,破甲+960,命中+768,技能伤害+1%',86400,'【巅峰寻宝】','[{0,0,0}]',0,0,0,53,1,0,0,0,53010402,4,1,99999,6,0,0,0,'[]',0,0,0,0,'[{1,1000}]','[]',0,0,0,1),(53010403,'复仇·离子火炮','复仇·离子火炮','攻击+800,破甲+640,命中+512,pvp伤害+1%',57600,'【装备寻宝】','[{416,0,1}]',0,0,0,53,1,0,0,0,53010403,4,1,99999,6,0,0,0,'[]',0,0,0,0,'[{1,1000}]','[]',0,0,0,1),(53010404,'圣言·真理火炮','圣言·真理火炮','攻击+858,破甲+686,命中+549,暴击率+0.8%',61760,'【运营活动】','[{0,0,0}]',0,0,0,53,1,0,0,0,53010404,4,1,99999,6,0,0,0,'[]',0,0,0,0,'[{1,1000}]','[]',0,0,0,1),(53010405,'暗裔·死亡魔炮','暗裔·死亡魔炮','攻击+1650,破甲+1320,命中+1056,伤害加成+1%',118800,'【至尊寻宝】','[{0,0,0}]',0,0,0,53,1,0,0,0,53010405,4,1,99999,6,0,0,0,'[]',0,0,0,0,'[{1,1000}]','[]',0,0,0,1),(53020010,'初级专武髓液','专武初级升级材料,专武经验+30','',0,'【运营活动】','[{0,0,0}]',0,0,0,53,2,0,0,0,53020010,0,1,99999,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(53020020,'中级专武髓液','专武中级升级材料,专武经验+100','',0,'【每日累充,运营活动】','[{0,0,0}]',0,0,0,53,2,0,0,0,53020020,0,1,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(53020030,'高级专武髓液','专武高级升级材料,专武经验+200','',0,'【运营活动】','[{0,0,0}]',0,0,0,53,2,0,0,0,53020030,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(53030010,'破甲魂晶','提升专武属性的材料','破甲+80',2000,'【每日累充,运营活动】','[{0,0,0}]',0,0,0,53,3,0,0,0,53030010,0,1,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(53030020,'命中魂晶','提升专武属性的材料','命中+40',2000,'【每日累充,运营活动】','[{0,0,0}]',0,0,0,53,3,0,0,0,53030020,0,1,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(53030030,'全属性复合魂晶','提升专武复合属性的材料','破甲+80,命中+40,局部全属性+1%',4000,'【每日累充,运营活动】','[{0,0,0}]',0,0,0,53,3,0,0,0,53030030,0,1,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(53040101,'碎片·寒霜大剑','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活光武·寒鸦·寒霜大剑\\n激活立即获得\\n','攻击+774,破甲+619,命中+495,命中率+1%',55705,'【运营活动】','[{0,0,0}]',0,0,0,53,4,0,0,0,53040101,0,1,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(53040102,'碎片·龙焰斩剑','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活光武·焚烬·龙焰斩剑\\n激活立即获得\\n','攻击+1200,破甲+960,命中+768,技能伤害+1%',86400,'【运营活动】','[{0,0,0}]',0,0,0,53,4,0,0,0,53040102,0,1,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(53040103,'碎片·强袭军刀','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活光武·天火·强袭军刀\\n激活立即获得\\n','攻击+800,破甲+640,命中+512,pvp伤害+1%',57600,'【运营活动】','[{0,0,0}]',0,0,0,53,4,0,0,0,53040103,0,1,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(53040104,'碎片·裁决圣剑','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活光武·圣言·裁决圣剑\\n激活立即获得\\n','攻击+858,破甲+686,命中+549,暴击率+0.8%',61760,'【运营活动】','[{0,0,0}]',0,0,0,53,4,0,0,0,53040104,0,1,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(53040105,'碎片·灾厄魔剑','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活光武·暗裔·灾厄魔剑\\n激活立即获得\\n','攻击+1650,破甲+1320,命中+1056,伤害加成+1%',118800,'【运营活动】','[{0,0,0}]',0,0,0,53,4,0,0,0,53040105,0,1,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(53040201,'碎片·冰晶长枪','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活光武·寒鸦·冰晶长枪\\n激活立即获得\\n','攻击+774,破甲+619,命中+495,命中率+1%',55705,'【运营活动】','[{0,0,0}]',0,0,0,53,4,0,0,0,53040201,0,1,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(53040202,'碎片·屠龙炎枪','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活光武·焚烬·屠龙炎枪\\n激活立即获得\\n','攻击+1200,破甲+960,命中+768,技能伤害+1%',86400,'【运营活动】','[{0,0,0}]',0,0,0,53,4,0,0,0,53040202,0,1,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(53040203,'碎片·突击枪刃','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活光武·雷云·突击枪刃\\n激活立即获得\\n','攻击+800,破甲+640,命中+512,pvp伤害+1%',57600,'【运营活动】','[{0,0,0}]',0,0,0,53,4,0,0,0,53040203,0,1,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(53040204,'碎片·断罪圣枪','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活光武·圣言·断罪圣枪\\n激活立即获得\\n','攻击+858,破甲+686,命中+549,暴击率+0.8%',61760,'【运营活动】','[{0,0,0}]',0,0,0,53,4,0,0,0,53040204,0,1,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(53040205,'碎片·屠戮魔枪','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活光武·暗裔·屠戮魔枪\\n激活立即获得\\n','攻击+1650,破甲+1320,命中+1056,伤害加成+1%',118800,'【运营活动】','[{0,0,0}]',0,0,0,53,4,0,0,0,53040205,0,1,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(53040401,'碎片·凛冬重炮','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活光武·寒鸦·凛冬重炮\\n激活立即获得\\n','攻击+774,破甲+619,命中+495,命中率+1%',55705,'【运营活动】','[{0,0,0}]',0,0,0,53,4,0,0,0,53040401,0,1,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(53040402,'碎片·龙神火炮','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活光武·焚烬·龙神火炮\\n激活立即获得\\n','攻击+1200,破甲+960,命中+768,技能伤害+1%',86400,'【运营活动】','[{0,0,0}]',0,0,0,53,4,0,0,0,53040402,0,1,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(53040403,'碎片·离子火炮','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活光武·复仇·离子火炮\\n激活立即获得\\n','攻击+800,破甲+640,命中+512,pvp伤害+1%',57600,'【运营活动】','[{0,0,0}]',0,0,0,53,4,0,0,0,53040403,0,1,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(53040404,'碎片·真理火炮','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活光武·圣言·真理火炮\\n激活立即获得\\n','攻击+858,破甲+686,命中+549,暴击率+0.8%',61760,'【运营活动】','[{0,0,0}]',0,0,0,53,4,0,0,0,53040404,0,1,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(53040405,'碎片·死亡魔炮','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活光武·暗裔·死亡魔炮\\n激活立即获得\\n','攻击+1650,破甲+1320,命中+1056,伤害加成+1%',118800,'【运营活动】','[{0,0,0}]',0,0,0,53,4,0,0,0,53040405,0,1,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(54010001,'初级神奇糖果','适用于1-9阶，增加30点宝宝经验值','',0,'【运营活动】','[{153,7,0},{610,43,1}]',0,0,0,54,1,0,0,0,54010001,0,315,99999,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(54010002,'中级神奇糖果','适用于10-18阶，增加90点宝宝经验值','',0,'【运营活动】','[{153,7,0},{610,43,1}]',0,0,0,54,1,0,0,0,54010002,0,315,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(54010003,'高级神奇糖果','适用于19-25阶，增加270点宝宝经验值','',0,'【运营活动】','[{153,7,0},{610,43,1}]',0,0,0,54,1,0,0,0,54010003,0,315,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(54020001,'初级宝宝棒棒糖','蕴含着甜蜜的气息，可以提升宝宝属性','生命+2000',2000,'【运营活动】','[{0,0,0}]',0,0,0,54,2,1,0,0,54020001,0,315,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(54020002,'中级宝宝棒棒糖','蕴含着甜蜜的气息，可以提升宝宝属性','攻击+100',2000,'【运营活动】','[{0,0,0}]',0,0,0,54,2,1,0,0,54020002,0,315,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(54020003,'高级宝宝棒棒糖','蕴含着甜蜜的气息，可以提升宝宝属性','命中+40,闪避+40,宝宝全属性+1%',4000,'【运营活动】','[{0,0,0}]',0,0,0,54,2,1,0,0,54020003,0,315,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(54030001,'童年滑板','激活宝宝坐骑外观：童年滑板，在【宝宝】-【坐骑】中使用。','攻击+495,生命+9900,命中+198,闪避+198,boss伤害+1%',43800,'【运营活动】','[{0,0,0},{610,43,1}]',0,0,0,54,3,1,0,0,54030001,0,315,999999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(54030002,'大眼萌云','激活宝宝坐骑外观：大眼萌云，在【宝宝】-【坐骑】中使用。','攻击+1047,生命+20940,命中+419,闪避+419,pve伤害+2%,局部生命0.8%',92380,'【运营活动】','[{0,0,0}]',0,0,0,54,3,1,0,0,54030002,0,315,999999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(54030003,'极速飞行','激活宝宝坐骑外观：极速飞行，在【宝宝】-【坐骑】中使用。','攻击+1172,生命+23440,命中+469,闪避+469,pvp伤害+2%,局部攻击0.9%',102420,'【运营活动】','[{0,0,0}]',0,0,0,54,3,1,0,0,54030003,0,315,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(54030004,'海贼王船','激活宝宝坐骑外观：海贼王船，在【宝宝】-【坐骑】中使用。','攻击+1322,生命+26440,命中+529,闪避+529,技能伤害+2%,局部命中1%',105760,'【运营活动】','[{0,0,0}]',0,0,0,54,3,1,0,0,54030004,0,315,999999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(54030051,'童年滑板·7天','激活宝宝坐骑外观：童年滑板，在【宝宝】-【坐骑】中使用。','攻击+495,生命+9900,命中+198,闪避+198,boss伤害+1%',43800,'【运营活动】','[{0,0,0}]',0,0,0,54,3,1,0,0,54030001,0,315,999999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(54040001,'初级齿轮玩具','适用于1-5阶，增加30点宝宝坐骑经验值','',0,'【运营活动】','[{153,7,0},{610,43,1}]',0,0,0,54,4,0,0,0,54040001,0,315,99999,1,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(54040002,'中级齿轮玩具','适用于6-8阶，增加90点宝宝坐骑经验值','',0,'【运营活动】','[{153,7,0},{610,43,1}]',0,0,0,54,4,0,0,0,54040002,0,315,99999,2,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(54040003,'高级齿轮玩具','适用于9-10阶，增加270点宝宝坐骑经验值','',0,'【运营活动】','[{153,7,0},{610,43,1}]',0,0,0,54,4,0,0,0,54040003,0,315,99999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(54050001,'蛋蛋壳菲菲','激活宝宝外形时装：蛋蛋壳菲菲，在【宝宝】-【时装】中使用。','攻击+946,生命+18920,破甲+757,防御+757,命中率+1%',75790,'【运营活动】','[{0,0,0}]',0,0,0,54,5,1,0,0,54050001,0,315,999999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(54050002,'蘑菇屋娜娜','激活宝宝外形时装：蘑菇屋娜娜，在【宝宝】-【时装】中使用。','攻击+946,生命+18920,暴击+378,韧性+378,闪避率+1%',56840,'【运营活动】','[{0,0,0}]',0,0,0,54,5,1,0,0,54050002,0,315,999999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(54050003,'小法师露露','激活宝宝外形时装：小法师露露，在【宝宝】-【时装】中使用。','攻击+946,生命+18920,破甲+757,防御+757,暴击率+1%',75690,'【运营活动】','[{0,0,0}]',0,0,0,54,5,1,0,0,54050003,0,315,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(54050053,'小法师露露·七天','激活宝宝外形时装：小法师露露，在【宝宝】-【时装】中使用。','攻击+946,生命+18920,破甲+757,防御+757,暴击率+1%',75690,'【运营活动】','[{0,0,0}]',0,0,0,54,5,1,0,0,54050003,0,315,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(54060101,'童年滑板碎片','集齐<color=#4eae1a>10</color>个碎片，在【合成】中合成，即可激活宝宝坐骑·童年滑板\\n激活立即获得\\n','攻击+495,生命+9900,命中+198,闪避+198,boss伤害+1%',43800,'【运营活动】','[{610,43,1}]',0,0,0,54,6,1,0,0,54060101,0,315,999999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(54060102,'大眼萌云碎片','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活宝宝坐骑·大眼萌云\\n激活立即获得\\n','攻击+1047,生命+20940,命中+419,闪避+419,pve伤害+2%,局部生命0.8%',92380,'【运营活动】','[{0,0,0}]',0,0,0,54,6,1,0,0,54060102,0,315,999999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(54060103,'极速飞行碎片','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活宝宝坐骑·极速飞行\\n激活立即获得\\n','攻击+1172,生命+23440,命中+469,闪避+469,pvp伤害+2%,局部攻击0.9%',102420,'【运营活动】','[{0,0,0}]',0,0,0,54,6,1,0,0,54060103,0,315,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(54060104,'海贼王船碎片','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活宝宝坐骑·海贼王船\\n激活立即获得\\n','攻击+1322,生命+26440,命中+529,闪避+529,技能伤害+2%,局部命中1%',105760,'【运营活动】','[{0,0,0}]',0,0,0,54,6,1,0,0,54060104,0,315,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(54060201,'蛋蛋壳菲菲碎片','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活宝宝外观·蛋蛋壳菲菲\\n激活立即获得\\n','攻击+946,生命+18920,破甲+757,防御+757,命中率+1%',75790,'【运营活动】','[{0,0,0}]',0,0,0,54,6,1,0,0,54060201,0,315,999999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(54060202,'蘑菇屋娜娜碎片','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活宝宝外观·蘑菇屋娜娜\\n激活立即获得\\n','攻击+946,生命+18920,暴击+378,韧性+378,闪避率+1%',56840,'【运营活动】','[{0,0,0}]',0,0,0,54,6,1,0,0,54060202,0,315,999999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(54060203,'小法师露露碎片','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活宝宝外观·小法师露露\\n激活立即获得\\n','攻击+946,生命+18920,破甲+757,防御+757,暴击率+1%',75690,'【运营活动】','[{0,0,0}]',0,0,0,54,6,1,0,0,54060203,0,315,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(54060301,'小小翅膀碎片','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活宝宝外观·小小翅膀\\n激活立即获得\\n','攻击+946,生命+18920,破甲+757,防御+757,命中率+1%',75790,'【运营活动】','[{0,0,0}]',0,0,0,54,6,1,0,0,54060301,0,315,999999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(54060302,'小熊书包碎片','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活宝宝外观·小熊书包\\n激活立即获得\\n','攻击+946,生命+18920,暴击+378,韧性+378,闪避率+1%',56840,'【运营活动】','[{0,0,0}]',0,0,0,54,6,1,0,0,54060302,0,315,999999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(54060303,'惊喜萌兔碎片','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活宝宝外观·惊喜萌兔\\n激活立即获得\\n','攻击+946,生命+18920,破甲+757,防御+757,暴击率+1%',75690,'【运营活动】','[{0,0,0}]',0,0,0,54,6,1,0,0,54060303,0,315,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(54060304,'小小气球碎片','集齐<color=#4eae1a>30</color>个碎片，在【合成】中合成，即可激活宝宝外观·小小气球\\n激活立即获得\\n','攻击+946,生命+18920,破甲+757,防御+757,暴击率+1%',75690,'【运营活动】','[{0,0,0}]',0,0,0,54,6,1,0,0,54060304,0,315,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(54070001,'小小翅膀','激活宝宝外形翅膀：小小翅膀，在【宝宝】-【翅膀】中使用。','攻击+946,生命+18920,破甲+757,防御+757,命中率+1%',75790,'【运营活动】','[{0,0,0}]',0,0,0,54,7,1,0,0,54070001,0,315,999999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(54070002,'小熊书包','激活宝宝外形翅膀：小熊书包，在【宝宝】-【翅膀】中使用。','攻击+946,生命+18920,暴击+378,韧性+378,闪避率+1%',56840,'【运营活动】','[{0,0,0}]',0,0,0,54,7,1,0,0,54070002,0,315,999999,3,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(54070003,'惊喜萌兔','激活宝宝外形翅膀：惊喜萌兔，在【宝宝】-【翅膀】中使用。','攻击+946,生命+18920,破甲+757,防御+757,暴击率+1%',75690,'【运营活动】','[{0,0,0}]',0,0,0,54,7,1,0,0,54070003,0,315,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(54070004,'小小气球','激活宝宝外形翅膀：小小气球，在【宝宝】-【翅膀】中使用。','攻击+946,生命+18920,破甲+757,防御+757,暴击率+1%',75690,'【运营活动】','[{0,0,0}]',0,0,0,54,7,1,0,0,54070004,0,315,99999,4,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,1),(55010001,'火之神印','富有火之魔力的神印，可以提供大量强力属性','',0,'【降神塔,运营活动】','[{610,9,1}]',1,1,0,55,1,1,2,0,55010001,0,0,0,2,0,0,0,'[{1,21}]',0,0,0,0,'[{1,100}]','[]',0,0,0,0),(55010002,'风之神印','富有风之魔力的神印，可以提供大量强力属性','',0,'【降神塔,运营活动】','[{610,9,1}]',1,1,0,55,1,1,2,0,55010002,0,0,0,2,0,0,0,'[{1,21}]',0,0,0,0,'[{1,100}]','[]',0,0,0,0),(55010003,'水之神印','富有水之魔力的神印，可以提供大量强力属性','',0,'【降神塔,运营活动】','[{610,9,1}]',1,1,0,55,1,1,2,0,55010003,0,0,0,2,0,0,0,'[{1,21}]',0,0,0,0,'[{1,100}]','[]',0,0,0,0),(55010004,'土之神印','富有土之魔力的神印，可以提供大量强力属性','',0,'【降神塔,运营活动】','[{610,9,1}]',1,1,0,55,1,1,2,0,55010004,0,0,0,3,0,0,0,'[{1,21}]',0,0,0,0,'[{1,100}]','[]',0,0,0,0),(55010005,'冰之神印','富有冰之魔力的神印，可以提供大量强力属性','',0,'【降神塔,运营活动】','[{610,9,1}]',1,1,0,55,1,1,2,0,55010005,0,0,0,3,0,0,0,'[{1,21}]',0,0,0,0,'[{1,100}]','[]',0,0,0,0),(55010006,'雷之神印','富有雷之魔力的神印，可以提供大量强力属性','',0,'【降神塔,运营活动】','[{610,9,1}]',1,1,0,55,1,1,2,0,55010006,0,0,0,3,0,0,0,'[{1,21}]',0,0,0,0,'[{1,100}]','[]',0,0,0,0),(55010007,'日之神印','富有阳光之魔力的神印，可以提供大量强力属性','',0,'【降神塔,运营活动】','[{610,9,1}]',1,1,0,55,1,1,2,0,55010007,0,0,0,3,0,0,0,'[{1,21}]',0,0,0,0,'[{1,100}]','[]',0,0,0,0),(55010008,'月之神印','富有月光之魔力的神印，可以提供大量强力属性','',0,'【降神塔,运营活动】','[{610,9,1}]',1,1,0,55,1,1,2,0,55010008,0,0,0,3,0,0,0,'[{1,21}]',0,0,0,0,'[{1,100}]','[]',0,0,0,0),(55010009,'星之神印','富有星辰之魔力的神印，可以提供大量强力属性','',0,'【降神塔,运营活动】','[{610,9,1}]',1,1,0,55,1,1,2,0,55010009,0,0,0,3,0,0,0,'[{1,21}]',0,0,0,0,'[{1,100}]','[]',0,0,0,0),(1001010100,'学徒之刃','1阶绿色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001010100,1,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,45},{3,22}]','[]',0,0,0,0),(1001010110,'学徒之刃','1阶蓝色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001010100,1,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{1,67},{3,33}]','[]',0,0,0,0),(1001010120,'学徒之刃','1阶紫色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001010100,1,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{1,122},{3,61}]','[]',0,0,0,0),(1001010131,'学徒之刃','1阶橙1星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001010100,1,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{1,149},{3,74}]','[]',0,0,0,0),(1001010132,'学徒之刃','1阶橙2星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001010100,1,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{1,149},{3,74}]','[]',0,0,0,0),(1001010141,'学徒之刃','1阶红1星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001010100,1,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{1,223},{3,112}]','[]',0,0,0,0),(1001010142,'学徒之刃','1阶红2星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001010100,1,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{1,223},{3,112}]','[]',0,0,0,0),(1001010143,'学徒之刃','1阶红3星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001010100,1,1,0,4,0,0,0,'[{1,9}]',0,0,0,0,'[{1,223},{3,112}]','[]',0,0,0,0),(1001010153,'学徒之刃','1阶粉色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001010100,1,1,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,357},{3,179}]','[]',0,0,0,0),(1001010163,'学徒之刃','1阶神装武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001010100,1,1,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,446},{3,223}]','[]',0,0,0,0),(1001010200,'冒险之刃','2阶绿色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001010200,1,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,76},{3,38}]','[]',0,0,0,0),(1001010210,'冒险之刃','2阶蓝色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001010200,1,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{1,115},{3,57}]','[]',0,0,0,0),(1001010220,'冒险之刃','2阶紫色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001010200,1,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{1,209},{3,104}]','[]',0,0,0,0),(1001010231,'冒险之刃','2阶橙1星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001010200,1,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{1,255},{3,127}]','[]',0,0,0,0),(1001010232,'冒险之刃','2阶橙2星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001010200,1,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{1,255},{3,127}]','[]',0,0,0,0),(1001010241,'冒险之刃','2阶红1星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001010200,1,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{1,382},{3,191}]','[]',0,0,0,0),(1001010242,'冒险之刃','2阶红2星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001010200,1,1,0,4,0,0,0,'[{1,5}]',0,0,0,0,'[{1,382},{3,191}]','[]',0,0,0,0),(1001010243,'冒险之刃','2阶红3星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001010200,1,1,0,4,0,0,0,'[{1,15}]',0,0,0,0,'[{1,382},{3,191}]','[]',0,0,0,0),(1001010253,'冒险之刃','2阶粉色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001010200,1,1,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,612},{3,306}]','[]',0,0,0,0),(1001010263,'冒险之刃','2阶神装武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001010200,1,1,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,764},{3,382}]','[]',0,0,0,0),(1001010300,'勇者之刃','3阶绿色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001010300,1,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,182},{3,91}]','[]',0,0,0,0),(1001010310,'勇者之刃','3阶蓝色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001010300,1,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{1,273},{3,137}]','[]',0,0,0,0),(1001010320,'勇者之刃','3阶紫色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001010300,1,1,0,2,0,0,0,'[{1,2}]',0,0,0,0,'[{1,498},{3,249}]','[]',0,0,0,0),(1001010331,'勇者之刃','3阶橙1星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001010300,1,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{1,607},{3,303}]','[]',0,0,0,0),(1001010332,'勇者之刃','3阶橙2星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001010300,1,1,0,3,0,0,0,'[{1,3}]',0,0,0,0,'[{1,607},{3,303}]','[]',0,0,0,0),(1001010341,'勇者之刃','3阶红1星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001010300,1,1,0,4,0,0,0,'[{1,5}]',0,0,0,0,'[{1,911},{3,456}]','[]',0,0,0,0),(1001010342,'勇者之刃','3阶红2星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001010300,1,1,0,4,0,0,0,'[{1,7}]',0,0,0,0,'[{1,911},{3,456}]','[]',0,0,0,0),(1001010343,'勇者之刃','3阶红3星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001010300,1,1,0,4,0,0,0,'[{1,22}]',0,0,0,0,'[{1,911},{3,456}]','[]',0,0,0,0),(1001010353,'勇者之刃','3阶粉色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001010300,1,1,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,1458},{3,729}]','[]',0,0,0,0),(1001010363,'勇者之刃','3阶神装武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001010300,1,1,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,1822},{3,911}]','[]',0,0,0,0),(1001010400,'先驱之刃','4阶绿色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001010400,1,100,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,367},{3,183}]','[]',0,0,0,0),(1001010410,'先驱之刃','4阶蓝色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001010400,1,100,0,1,0,0,0,'[{1,2}]',0,0,0,0,'[{1,550},{3,275}]','[]',0,0,0,0),(1001010420,'先驱之刃','4阶紫色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001010400,1,100,0,2,0,0,0,'[{1,4}]',0,0,0,0,'[{1,1002},{3,501}]','[]',0,0,0,0),(1001010431,'先驱之刃','4阶橙1星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001010400,1,100,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{1,1222},{3,611}]','[]',0,0,0,0),(1001010432,'先驱之刃','4阶橙2星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001010400,1,100,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{1,1222},{3,611}]','[]',0,0,0,0),(1001010441,'先驱之刃','4阶红1星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001010400,1,100,0,4,0,0,0,'[{1,14}]',0,0,0,0,'[{1,1835},{3,917}]','[]',0,0,0,0),(1001010442,'先驱之刃','4阶红2星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001010400,1,100,0,4,0,0,0,'[{1,21}]',0,0,0,0,'[{1,1835},{3,917}]','[]',0,0,0,0),(1001010443,'先驱之刃','4阶红3星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001010400,1,100,0,4,0,0,0,'[{1,62}]',0,0,0,0,'[{1,1835},{3,917}]','[]',0,0,0,0),(1001010453,'先驱之刃','4阶粉色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001010400,1,100,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,2935},{3,1468}]','[]',0,0,0,0),(1001010463,'先驱之刃','4阶神装武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001010400,1,100,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,3669},{3,1835}]','[]',0,0,0,0),(1001010500,'荣誉之刃','5阶绿色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001010500,1,150,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,635},{3,318}]','[]',0,0,1,0),(1001010510,'荣誉之刃','5阶蓝色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001010500,1,150,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{1,953},{3,477}]','[]',0,0,1,0),(1001010520,'荣誉之刃','5阶紫色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001010500,1,150,0,2,0,0,0,'[{1,8}]',0,0,0,0,'[{1,1735},{3,867}]','[]',0,0,1,0),(1001010531,'荣誉之刃','5阶橙1星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001010500,1,150,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{1,2116},{3,1058}]','[]',0,0,1,0),(1001010532,'荣誉之刃','5阶橙2星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001010500,1,150,0,3,0,0,0,'[{1,13}]',0,0,0,0,'[{1,2116},{3,1058}]','[]',0,0,1,0),(1001010541,'荣誉之刃','5阶红1星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001010500,1,150,0,4,0,0,0,'[{1,26}]',0,0,0,0,'[{1,3177},{3,1588}]','[]',0,0,1,0),(1001010542,'荣誉之刃','5阶红2星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001010500,1,150,0,4,0,0,0,'[{1,39}]',0,0,0,0,'[{1,3177},{3,1588}]','[]',0,0,1,0),(1001010543,'荣誉之刃','5阶红3星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001010500,1,150,0,4,0,0,0,'[{1,115}]',0,0,0,0,'[{1,3177},{3,1588}]','[]',0,0,1,0),(1001010553,'荣誉之刃','5阶粉色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001010500,1,150,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,5083},{3,2542}]','[]',0,0,1,0),(1001010563,'荣誉之刃','5阶神装武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001010500,1,150,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,6354},{3,3177}]','[]',0,0,1,0),(1001010600,'贤者之刃','6阶绿色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001010600,1,180,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,993},{3,496}]','[]',0,0,1,0),(1001010610,'贤者之刃','6阶蓝色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001010600,1,180,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{1,1489},{3,744}]','[]',0,0,1,0),(1001010620,'贤者之刃','6阶紫色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001010600,1,180,0,2,0,0,0,'[{1,8}]',0,0,0,0,'[{1,2710},{3,1355}]','[]',0,0,1,0),(1001010631,'贤者之刃','6阶橙1星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001010600,1,180,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{1,3305},{3,1653}]','[]',0,0,1,0),(1001010632,'贤者之刃','6阶橙2星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001010600,1,180,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{1,3305},{3,1653}]','[]',0,0,1,0),(1001010641,'贤者之刃','6阶红1星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001010600,1,180,0,4,0,0,0,'[{1,33}]',0,0,0,0,'[{1,4963},{3,2481}]','[]',0,0,1,0),(1001010642,'贤者之刃','6阶红2星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001010600,1,180,0,4,0,0,0,'[{1,51}]',0,0,0,0,'[{1,4963},{3,2481}]','[]',0,0,1,0),(1001010643,'贤者之刃','6阶红3星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001010600,1,180,0,4,0,0,0,'[{1,190}]',0,0,0,0,'[{1,4963},{3,2481}]','[]',0,0,1,0),(1001010653,'贤者之刃','6阶粉色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001010600,1,180,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,7940},{3,3970}]','[]',0,0,1,0),(1001010663,'贤者之刃','6阶神装武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001010600,1,180,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,9925},{3,4963}]','[]',0,0,1,0),(1001010700,'征服之刃','7阶绿色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001010700,1,220,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,1443},{3,722}]','[]',0,0,2,0),(1001010710,'征服之刃','7阶蓝色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001010700,1,220,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{1,2165},{3,1082}]','[]',0,0,2,0),(1001010720,'征服之刃','7阶紫色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001010700,1,220,0,2,0,0,0,'[{1,10}]',0,0,0,0,'[{1,3940},{3,1970}]','[]',0,0,2,0),(1001010731,'征服之刃','7阶橙1星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001010700,1,220,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{1,4806},{3,2403}]','[]',0,0,2,0),(1001010732,'征服之刃','7阶橙2星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001010700,1,220,0,3,0,0,0,'[{1,17}]',0,0,0,0,'[{1,4806},{3,2403}]','[]',0,0,2,0),(1001010741,'征服之刃','7阶红1星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001010700,1,220,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{1,7216},{3,3608}]','[]',0,0,2,0),(1001010742,'征服之刃','7阶红2星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001010700,1,220,0,4,0,0,0,'[{1,75}]',0,0,0,0,'[{1,7216},{3,3608}]','[]',0,0,2,0),(1001010743,'征服之刃','7阶红3星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001010700,1,220,0,4,0,0,0,'[{1,272}]',0,0,0,0,'[{1,7216},{3,3608}]','[]',0,0,2,0),(1001010753,'征服之刃','7阶粉色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001010700,1,220,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,11546},{3,5773}]','[]',0,0,2,0),(1001010763,'征服之刃','7阶神装武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001010700,1,220,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,14432},{3,7216}]','[]',0,0,2,0),(1001010800,'秩序之刃','8阶绿色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001010800,1,260,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,1992},{3,996}]','[]',0,0,2,0),(1001010810,'秩序之刃','8阶蓝色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001010800,1,260,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{1,2989},{3,1494}]','[]',0,0,2,0),(1001010820,'秩序之刃','8阶紫色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001010800,1,260,0,2,0,0,0,'[{1,12}]',0,0,0,0,'[{1,5439},{3,2720}]','[]',0,0,2,0),(1001010831,'秩序之刃','8阶橙1星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001010800,1,260,0,3,0,0,0,'[{1,16}]',0,0,0,0,'[{1,6635},{3,3317}]','[]',0,0,2,0),(1001010832,'秩序之刃','8阶橙2星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001010800,1,260,0,3,0,0,0,'[{1,20}]',0,0,0,0,'[{1,6635},{3,3317}]','[]',0,0,2,0),(1001010841,'秩序之刃','8阶红1星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001010800,1,260,0,4,0,0,0,'[{1,52}]',0,0,0,0,'[{1,9962},{3,4981}]','[]',0,0,2,0),(1001010842,'秩序之刃','8阶红2星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001010800,1,260,0,4,0,0,0,'[{1,84}]',0,0,0,0,'[{1,9962},{3,4981}]','[]',0,0,2,0),(1001010843,'秩序之刃','8阶红3星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001010800,1,260,0,4,0,0,0,'[{1,380}]',0,0,0,0,'[{1,9962},{3,4981}]','[]',0,0,2,0),(1001010853,'秩序之刃','8阶粉色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001010800,1,260,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,15939},{3,7970}]','[]',0,0,2,0),(1001010863,'秩序之刃','8阶神装武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001010800,1,260,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,19924},{3,9962}]','[]',0,0,2,0),(1001010900,'守护之刃','9阶绿色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001010900,1,300,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{1,2644},{3,1322}]','[]',0,0,3,0),(1001010910,'守护之刃','9阶蓝色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001010900,1,300,0,1,0,0,0,'[{1,7}]',0,0,0,0,'[{1,3966},{3,1983}]','[]',0,0,3,0),(1001010920,'守护之刃','9阶紫色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001010900,1,300,0,2,0,0,0,'[{1,13}]',0,0,0,0,'[{1,7219},{3,3609}]','[]',0,0,3,0),(1001010931,'守护之刃','9阶橙1星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001010900,1,300,0,3,0,0,0,'[{1,17}]',0,0,0,0,'[{1,8805},{3,4403}]','[]',0,0,3,0),(1001010932,'守护之刃','9阶橙2星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001010900,1,300,0,3,0,0,0,'[{1,21}]',0,0,0,0,'[{1,8805},{3,4403}]','[]',0,0,3,0),(1001010941,'守护之刃','9阶红1星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001010900,1,300,0,4,0,0,0,'[{1,61}]',0,0,0,0,'[{1,13221},{3,6611}]','[]',0,0,3,0),(1001010942,'守护之刃','9阶红2星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001010900,1,300,0,4,0,0,0,'[{1,100}]',0,0,0,0,'[{1,13221},{3,6611}]','[]',0,0,3,0),(1001010943,'守护之刃','9阶红3星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001010900,1,300,0,4,0,0,0,'[{1,530}]',0,0,0,0,'[{1,13221},{3,6611}]','[]',0,0,3,0),(1001010953,'守护之刃','9阶粉色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001010900,1,300,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,21154},{3,10577}]','[]',0,0,3,0),(1001010963,'守护之刃','9阶神装武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001010900,1,300,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,26443},{3,13221}]','[]',0,0,3,0),(1001011000,'信仰之刃','10阶绿色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001011000,1,355,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{1,3404},{3,1702}]','[]',0,0,4,0),(1001011010,'信仰之刃','10阶蓝色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001011000,1,355,0,1,0,0,0,'[{1,7}]',0,0,0,0,'[{1,5107},{3,2553}]','[]',0,0,4,0),(1001011020,'信仰之刃','10阶紫色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001011000,1,355,0,2,0,0,0,'[{1,13}]',0,0,0,0,'[{1,9294},{3,4647}]','[]',0,0,4,0),(1001011031,'信仰之刃','10阶橙1星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001011000,1,355,0,3,0,0,0,'[{1,18}]',0,0,0,0,'[{1,11337},{3,5668}]','[]',0,0,4,0),(1001011032,'信仰之刃','10阶橙2星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001011000,1,355,0,3,0,0,0,'[{1,22}]',0,0,0,0,'[{1,11337},{3,5668}]','[]',0,0,4,0),(1001011041,'信仰之刃','10阶红1星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001011000,1,355,0,4,0,0,0,'[{1,74}]',0,0,0,0,'[{1,17022},{3,8511}]','[]',0,0,4,0),(1001011042,'信仰之刃','10阶红2星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001011000,1,355,0,4,0,0,0,'[{1,125}]',0,0,0,0,'[{1,17022},{3,8511}]','[]',0,0,4,0),(1001011043,'信仰之刃','10阶红3星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001011000,1,355,0,4,0,0,0,'[{1,730}]',0,0,0,0,'[{1,17022},{3,8511}]','[]',0,0,4,0),(1001011053,'信仰之刃','10阶粉色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001011000,1,355,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,27235},{3,13618}]','[]',0,0,4,0),(1001011063,'信仰之刃','10阶神装武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001011000,1,355,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,34044},{3,17022}]','[]',0,0,4,0),(1001011100,'天行之刃','11阶绿色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001011100,1,400,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{1,4278},{3,2139}]','[]',0,0,4,0),(1001011110,'天行之刃','11阶蓝色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001011100,1,400,0,1,0,0,0,'[{1,8}]',0,0,0,0,'[{1,6417},{3,3208}]','[]',0,0,4,0),(1001011120,'天行之刃','11阶紫色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001011100,1,400,0,2,0,0,0,'[{1,15}]',0,0,0,0,'[{1,11678},{3,5839}]','[]',0,0,4,0),(1001011131,'天行之刃','11阶橙1星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001011100,1,400,0,3,0,0,0,'[{1,20}]',0,0,0,0,'[{1,14245},{3,7122}]','[]',0,0,4,0),(1001011132,'天行之刃','11阶橙2星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001011100,1,400,0,3,0,0,0,'[{1,25}]',0,0,0,0,'[{1,14245},{3,7122}]','[]',0,0,4,0),(1001011141,'天行之刃','11阶红1星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001011100,1,400,0,4,0,0,0,'[{1,84}]',0,0,0,0,'[{1,21389},{3,10694}]','[]',0,0,4,0),(1001011142,'天行之刃','11阶红2星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001011100,1,400,0,4,0,0,0,'[{1,142}]',0,0,0,0,'[{1,21389},{3,10694}]','[]',0,0,4,0),(1001011143,'天行之刃','11阶红3星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001011100,1,400,0,4,0,0,0,'[{1,1005}]',0,0,0,0,'[{1,21389},{3,10694}]','[]',0,0,4,0),(1001011153,'天行之刃','11阶粉色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001011100,1,400,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,34222},{3,17111}]','[]',0,0,4,0),(1001011163,'天行之刃','11阶神装武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001011100,1,400,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,42777},{3,21389}]','[]',0,0,4,0),(1001011200,'命运之刃','12阶绿色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001011200,1,500,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{1,5269},{3,2635}]','[]',0,0,5,0),(1001011210,'命运之刃','12阶蓝色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001011200,1,500,0,1,0,0,0,'[{1,8}]',0,0,0,0,'[{1,7904},{3,3952}]','[]',0,0,5,0),(1001011220,'命运之刃','12阶紫色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001011200,1,500,0,2,0,0,0,'[{1,16}]',0,0,0,0,'[{1,14384},{3,7192}]','[]',0,0,5,0),(1001011231,'命运之刃','12阶橙1星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001011200,1,500,0,3,0,0,0,'[{1,22}]',0,0,0,0,'[{1,17546},{3,8773}]','[]',0,0,5,0),(1001011232,'命运之刃','12阶橙2星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001011200,1,500,0,3,0,0,0,'[{1,27}]',0,0,0,0,'[{1,17546},{3,8773}]','[]',0,0,5,0),(1001011241,'命运之刃','12阶红1星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001011200,1,500,0,4,0,0,0,'[{1,114}]',0,0,0,0,'[{1,26345},{3,13173}]','[]',0,0,5,0),(1001011242,'命运之刃','12阶红2星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001011200,1,500,0,4,0,0,0,'[{1,200}]',0,0,0,0,'[{1,26345},{3,13173}]','[]',0,0,5,0),(1001011243,'命运之刃','12阶红3星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001011200,1,500,0,4,0,0,0,'[{1,1464}]',0,0,0,0,'[{1,26345},{3,13173}]','[]',0,0,5,0),(1001011253,'命运之刃','12阶粉色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001011200,1,500,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,42152},{3,21076}]','[]',0,0,5,0),(1001011263,'命运之刃','12阶神装武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001011200,1,500,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,52690},{3,26345}]','[]',0,0,5,0),(1001011300,'制裁之刃','13阶绿色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001011300,1,520,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{1,6383},{3,3192}]','[]',0,0,5,0),(1001011310,'制裁之刃','13阶蓝色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001011300,1,520,0,1,0,0,0,'[{1,9}]',0,0,0,0,'[{1,9575},{3,4787}]','[]',0,0,5,0),(1001011320,'制裁之刃','13阶紫色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001011300,1,520,0,2,0,0,0,'[{1,18}]',0,0,0,0,'[{1,17426},{3,8713}]','[]',0,0,5,0),(1001011331,'制裁之刃','13阶橙1星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001011300,1,520,0,3,0,0,0,'[{1,24}]',0,0,0,0,'[{1,21256},{3,10628}]','[]',0,0,5,0),(1001011332,'制裁之刃','13阶橙2星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001011300,1,520,0,3,0,0,0,'[{1,30}]',0,0,0,0,'[{1,21256},{3,10628}]','[]',0,0,5,0),(1001011341,'制裁之刃','13阶红1星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001011300,1,520,0,4,0,0,0,'[{1,132}]',0,0,0,0,'[{1,31916},{3,15958}]','[]',0,0,5,0),(1001011342,'制裁之刃','13阶红2星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001011300,1,520,0,4,0,0,0,'[{1,234}]',0,0,0,0,'[{1,31916},{3,15958}]','[]',0,0,5,0),(1001011343,'制裁之刃','13阶红3星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001011300,1,520,0,4,0,0,0,'[{1,2047}]',0,0,0,0,'[{1,31916},{3,15958}]','[]',0,0,5,0),(1001011353,'制裁之刃','13阶粉色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001011300,1,520,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,51066},{3,25533}]','[]',0,0,5,0),(1001011363,'制裁之刃','13阶神装武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001011300,1,520,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,63832},{3,31916}]','[]',0,0,5,0),(1001011400,'审判之刃','14阶绿色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001011400,1,620,0,0,0,0,0,'[{1,4}]',0,0,0,0,'[{1,7625},{3,3813}]','[]',0,0,6,0),(1001011410,'审判之刃','14阶蓝色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001011400,1,620,0,1,0,0,0,'[{1,10}]',0,0,0,0,'[{1,11438},{3,5719}]','[]',0,0,6,0),(1001011420,'审判之刃','14阶紫色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001011400,1,620,0,2,0,0,0,'[{1,20}]',0,0,0,0,'[{1,20817},{3,10408}]','[]',0,0,6,0),(1001011431,'审判之刃','14阶橙1星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001011400,1,620,0,3,0,0,0,'[{1,27}]',0,0,0,0,'[{1,25392},{3,12696}]','[]',0,0,6,0),(1001011432,'审判之刃','14阶橙2星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001011400,1,620,0,3,0,0,0,'[{1,34}]',0,0,0,0,'[{1,25392},{3,12696}]','[]',0,0,6,0),(1001011441,'审判之刃','14阶红1星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001011400,1,620,0,4,0,0,0,'[{1,150}]',0,0,0,0,'[{1,38126},{3,19063}]','[]',0,0,6,0),(1001011442,'审判之刃','14阶红2星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001011400,1,620,0,4,0,0,0,'[{1,267}]',0,0,0,0,'[{1,38126},{3,19063}]','[]',0,0,6,0),(1001011443,'审判之刃','14阶红3星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001011400,1,620,0,4,0,0,0,'[{1,2647}]',0,0,0,0,'[{1,38126},{3,19063}]','[]',0,0,6,0),(1001011453,'审判之刃','14阶粉色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001011400,1,620,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,61002},{3,30501}]','[]',0,0,6,0),(1001011463,'审判之刃','14阶神装武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001011400,1,620,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,76253},{3,38126}]','[]',0,0,6,0),(1001011500,'毁灭之刃','15阶绿色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001011500,1,650,0,0,0,0,0,'[{1,4}]',0,0,0,0,'[{1,9000},{3,4500}]','[]',0,0,6,0),(1001011510,'毁灭之刃','15阶蓝色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001011500,1,650,0,1,0,0,0,'[{1,11}]',0,0,0,0,'[{1,13500},{3,6750}]','[]',0,0,6,0),(1001011520,'毁灭之刃','15阶紫色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001011500,1,650,0,2,0,0,0,'[{1,22}]',0,0,0,0,'[{1,24570},{3,12285}]','[]',0,0,6,0),(1001011531,'毁灭之刃','15阶橙1星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001011500,1,650,0,3,0,0,0,'[{1,30}]',0,0,0,0,'[{1,29970},{3,14985}]','[]',0,0,6,0),(1001011532,'毁灭之刃','15阶橙2星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001011500,1,650,0,3,0,0,0,'[{1,37}]',0,0,0,0,'[{1,29970},{3,14985}]','[]',0,0,6,0),(1001011541,'毁灭之刃','15阶红1星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001011500,1,650,0,4,0,0,0,'[{1,169}]',0,0,0,0,'[{1,45000},{3,22500}]','[]',0,0,6,0),(1001011542,'毁灭之刃','15阶红2星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001011500,1,650,0,4,0,0,0,'[{1,300}]',0,0,0,0,'[{1,45000},{3,22500}]','[]',0,0,6,0),(1001011543,'毁灭之刃','15阶红3星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001011500,1,650,0,4,0,0,0,'[{1,3147}]',0,0,0,0,'[{1,45000},{3,22500}]','[]',0,0,6,0),(1001011553,'毁灭之刃','15阶粉色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001011500,1,650,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,72000},{3,36000}]','[]',0,0,6,0),(1001011563,'毁灭之刃','15阶神装武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001011500,1,650,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,90000},{3,45000}]','[]',0,0,6,0),(1001011600,'混沌之刃','16阶绿色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001011500,1,700,0,0,0,0,0,'[{1,5}]',0,0,0,0,'[{1,10512},{3,5256}]','[]',0,0,6,0),(1001011610,'混沌之刃','16阶蓝色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001011500,1,700,0,1,0,0,0,'[{1,13}]',0,0,0,0,'[{1,15768},{3,7884}]','[]',0,0,6,0),(1001011620,'混沌之刃','16阶紫色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001011500,1,700,0,2,0,0,0,'[{1,25}]',0,0,0,0,'[{1,28699},{3,14349}]','[]',0,0,6,0),(1001011631,'混沌之刃','16阶橙1星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001011500,1,700,0,3,0,0,0,'[{1,34}]',0,0,0,0,'[{1,35006},{3,17503}]','[]',0,0,6,0),(1001011632,'混沌之刃','16阶橙2星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001011500,1,700,0,3,0,0,0,'[{1,42}]',0,0,0,0,'[{1,35006},{3,17503}]','[]',0,0,6,0),(1001011641,'混沌之刃','16阶红1星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001011500,1,700,0,4,0,0,0,'[{1,205}]',0,0,0,0,'[{1,52562},{3,26281}]','[]',0,0,6,0),(1001011642,'混沌之刃','16阶红2星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001011500,1,700,0,4,0,0,0,'[{1,367}]',0,0,0,0,'[{1,52562},{3,26281}]','[]',0,0,6,0),(1001011643,'混沌之刃','16阶红3星武器【魔剑士】','',0,'','',0,1,1,10,1,1,1,1,1001011500,1,700,0,4,0,0,0,'[{1,3747}]',0,0,0,0,'[{1,52562},{3,26281}]','[]',0,0,6,0),(1001011653,'混沌之刃','16阶粉色武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001011500,1,700,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,84099},{3,42049}]','[]',0,0,6,0),(1001011663,'混沌之刃','16阶神装武器【魔剑士】','',0,'','',0,0,1,10,1,0,0,1,1001011500,1,700,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,105123},{3,52562}]','[]',0,0,6,0),(1001020100,'学徒长枪','1阶绿色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001020100,2,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,45},{3,22}]','[]',0,0,0,0),(1001020110,'学徒长枪','1阶蓝色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001020100,2,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{1,67},{3,33}]','[]',0,0,0,0),(1001020120,'学徒长枪','1阶紫色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001020100,2,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{1,122},{3,61}]','[]',0,0,0,0),(1001020131,'学徒长枪','1阶橙1星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001020100,2,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{1,149},{3,74}]','[]',0,0,0,0),(1001020132,'学徒长枪','1阶橙2星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001020100,2,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{1,149},{3,74}]','[]',0,0,0,0),(1001020141,'学徒长枪','1阶红1星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001020100,2,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{1,223},{3,112}]','[]',0,0,0,0),(1001020142,'学徒长枪','1阶红2星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001020100,2,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{1,223},{3,112}]','[]',0,0,0,0),(1001020143,'学徒长枪','1阶红3星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001020100,2,1,0,4,0,0,0,'[{1,9}]',0,0,0,0,'[{1,223},{3,112}]','[]',0,0,0,0),(1001020153,'学徒长枪','1阶粉色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001020100,2,1,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,357},{3,179}]','[]',0,0,0,0),(1001020163,'学徒长枪','1阶神装武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001020100,2,1,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,446},{3,223}]','[]',0,0,0,0),(1001020200,'冒险长枪','2阶绿色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001020200,2,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,76},{3,38}]','[]',0,0,0,0),(1001020210,'冒险长枪','2阶蓝色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001020200,2,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{1,115},{3,57}]','[]',0,0,0,0),(1001020220,'冒险长枪','2阶紫色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001020200,2,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{1,209},{3,104}]','[]',0,0,0,0),(1001020231,'冒险长枪','2阶橙1星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001020200,2,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{1,255},{3,127}]','[]',0,0,0,0),(1001020232,'冒险长枪','2阶橙2星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001020200,2,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{1,255},{3,127}]','[]',0,0,0,0),(1001020241,'冒险长枪','2阶红1星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001020200,2,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{1,382},{3,191}]','[]',0,0,0,0),(1001020242,'冒险长枪','2阶红2星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001020200,2,1,0,4,0,0,0,'[{1,5}]',0,0,0,0,'[{1,382},{3,191}]','[]',0,0,0,0),(1001020243,'冒险长枪','2阶红3星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001020200,2,1,0,4,0,0,0,'[{1,15}]',0,0,0,0,'[{1,382},{3,191}]','[]',0,0,0,0),(1001020253,'冒险长枪','2阶粉色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001020200,2,1,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,612},{3,306}]','[]',0,0,0,0),(1001020263,'冒险长枪','2阶神装武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001020200,2,1,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,764},{3,382}]','[]',0,0,0,0),(1001020300,'勇者长枪','3阶绿色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001020300,2,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,182},{3,91}]','[]',0,0,0,0),(1001020310,'勇者长枪','3阶蓝色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001020300,2,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{1,273},{3,137}]','[]',0,0,0,0),(1001020320,'勇者长枪','3阶紫色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001020300,2,1,0,2,0,0,0,'[{1,2}]',0,0,0,0,'[{1,498},{3,249}]','[]',0,0,0,0),(1001020331,'勇者长枪','3阶橙1星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001020300,2,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{1,607},{3,303}]','[]',0,0,0,0),(1001020332,'勇者长枪','3阶橙2星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001020300,2,1,0,3,0,0,0,'[{1,3}]',0,0,0,0,'[{1,607},{3,303}]','[]',0,0,0,0),(1001020341,'勇者长枪','3阶红1星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001020300,2,1,0,4,0,0,0,'[{1,5}]',0,0,0,0,'[{1,911},{3,456}]','[]',0,0,0,0),(1001020342,'勇者长枪','3阶红2星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001020300,2,1,0,4,0,0,0,'[{1,7}]',0,0,0,0,'[{1,911},{3,456}]','[]',0,0,0,0),(1001020343,'勇者长枪','3阶红3星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001020300,2,1,0,4,0,0,0,'[{1,22}]',0,0,0,0,'[{1,911},{3,456}]','[]',0,0,0,0),(1001020353,'勇者长枪','3阶粉色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001020300,2,1,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,1458},{3,729}]','[]',0,0,0,0),(1001020363,'勇者长枪','3阶神装武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001020300,2,1,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,1822},{3,911}]','[]',0,0,0,0),(1001020400,'先驱长枪','4阶绿色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001020400,2,100,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,367},{3,183}]','[]',0,0,0,0),(1001020410,'先驱长枪','4阶蓝色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001020400,2,100,0,1,0,0,0,'[{1,2}]',0,0,0,0,'[{1,550},{3,275}]','[]',0,0,0,0),(1001020420,'先驱长枪','4阶紫色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001020400,2,100,0,2,0,0,0,'[{1,4}]',0,0,0,0,'[{1,1002},{3,501}]','[]',0,0,0,0),(1001020431,'先驱长枪','4阶橙1星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001020400,2,100,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{1,1222},{3,611}]','[]',0,0,0,0),(1001020432,'先驱长枪','4阶橙2星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001020400,2,100,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{1,1222},{3,611}]','[]',0,0,0,0),(1001020441,'先驱长枪','4阶红1星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001020400,2,100,0,4,0,0,0,'[{1,14}]',0,0,0,0,'[{1,1835},{3,917}]','[]',0,0,0,0),(1001020442,'先驱长枪','4阶红2星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001020400,2,100,0,4,0,0,0,'[{1,21}]',0,0,0,0,'[{1,1835},{3,917}]','[]',0,0,0,0),(1001020443,'先驱长枪','4阶红3星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001020400,2,100,0,4,0,0,0,'[{1,62}]',0,0,0,0,'[{1,1835},{3,917}]','[]',0,0,0,0),(1001020453,'先驱长枪','4阶粉色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001020400,2,100,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,2935},{3,1468}]','[]',0,0,0,0),(1001020463,'先驱长枪','4阶神装武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001020400,2,100,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,3669},{3,1835}]','[]',0,0,0,0),(1001020500,'荣誉长枪','5阶绿色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001020500,2,150,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,635},{3,318}]','[]',0,0,1,0),(1001020510,'荣誉长枪','5阶蓝色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001020500,2,150,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{1,953},{3,477}]','[]',0,0,1,0),(1001020520,'荣誉长枪','5阶紫色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001020500,2,150,0,2,0,0,0,'[{1,8}]',0,0,0,0,'[{1,1735},{3,867}]','[]',0,0,1,0),(1001020531,'荣誉长枪','5阶橙1星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001020500,2,150,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{1,2116},{3,1058}]','[]',0,0,1,0),(1001020532,'荣誉长枪','5阶橙2星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001020500,2,150,0,3,0,0,0,'[{1,13}]',0,0,0,0,'[{1,2116},{3,1058}]','[]',0,0,1,0),(1001020541,'荣誉长枪','5阶红1星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001020500,2,150,0,4,0,0,0,'[{1,26}]',0,0,0,0,'[{1,3177},{3,1588}]','[]',0,0,1,0),(1001020542,'荣誉长枪','5阶红2星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001020500,2,150,0,4,0,0,0,'[{1,39}]',0,0,0,0,'[{1,3177},{3,1588}]','[]',0,0,1,0),(1001020543,'荣誉长枪','5阶红3星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001020500,2,150,0,4,0,0,0,'[{1,115}]',0,0,0,0,'[{1,3177},{3,1588}]','[]',0,0,1,0),(1001020553,'荣誉长枪','5阶粉色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001020500,2,150,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,5083},{3,2542}]','[]',0,0,1,0),(1001020563,'荣誉长枪','5阶神装武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001020500,2,150,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,6354},{3,3177}]','[]',0,0,1,0),(1001020600,'贤者长枪','6阶绿色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001020600,2,180,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,993},{3,496}]','[]',0,0,1,0),(1001020610,'贤者长枪','6阶蓝色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001020600,2,180,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{1,1489},{3,744}]','[]',0,0,1,0),(1001020620,'贤者长枪','6阶紫色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001020600,2,180,0,2,0,0,0,'[{1,8}]',0,0,0,0,'[{1,2710},{3,1355}]','[]',0,0,1,0),(1001020631,'贤者长枪','6阶橙1星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001020600,2,180,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{1,3305},{3,1653}]','[]',0,0,1,0),(1001020632,'贤者长枪','6阶橙2星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001020600,2,180,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{1,3305},{3,1653}]','[]',0,0,1,0),(1001020641,'贤者长枪','6阶红1星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001020600,2,180,0,4,0,0,0,'[{1,33}]',0,0,0,0,'[{1,4963},{3,2481}]','[]',0,0,1,0),(1001020642,'贤者长枪','6阶红2星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001020600,2,180,0,4,0,0,0,'[{1,51}]',0,0,0,0,'[{1,4963},{3,2481}]','[]',0,0,1,0),(1001020643,'贤者长枪','6阶红3星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001020600,2,180,0,4,0,0,0,'[{1,190}]',0,0,0,0,'[{1,4963},{3,2481}]','[]',0,0,1,0),(1001020653,'贤者长枪','6阶粉色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001020600,2,180,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,7940},{3,3970}]','[]',0,0,1,0),(1001020663,'贤者长枪','6阶神装武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001020600,2,180,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,9925},{3,4963}]','[]',0,0,1,0),(1001020700,'征服长枪','7阶绿色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001020700,2,220,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,1443},{3,722}]','[]',0,0,2,0),(1001020710,'征服长枪','7阶蓝色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001020700,2,220,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{1,2165},{3,1082}]','[]',0,0,2,0),(1001020720,'征服长枪','7阶紫色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001020700,2,220,0,2,0,0,0,'[{1,10}]',0,0,0,0,'[{1,3940},{3,1970}]','[]',0,0,2,0),(1001020731,'征服长枪','7阶橙1星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001020700,2,220,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{1,4806},{3,2403}]','[]',0,0,2,0),(1001020732,'征服长枪','7阶橙2星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001020700,2,220,0,3,0,0,0,'[{1,17}]',0,0,0,0,'[{1,4806},{3,2403}]','[]',0,0,2,0),(1001020741,'征服长枪','7阶红1星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001020700,2,220,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{1,7216},{3,3608}]','[]',0,0,2,0),(1001020742,'征服长枪','7阶红2星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001020700,2,220,0,4,0,0,0,'[{1,75}]',0,0,0,0,'[{1,7216},{3,3608}]','[]',0,0,2,0),(1001020743,'征服长枪','7阶红3星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001020700,2,220,0,4,0,0,0,'[{1,272}]',0,0,0,0,'[{1,7216},{3,3608}]','[]',0,0,2,0),(1001020753,'征服长枪','7阶粉色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001020700,2,220,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,11546},{3,5773}]','[]',0,0,2,0),(1001020763,'征服长枪','7阶神装武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001020700,2,220,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,14432},{3,7216}]','[]',0,0,2,0),(1001020800,'秩序长枪','8阶绿色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001020800,2,260,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,1992},{3,996}]','[]',0,0,2,0),(1001020810,'秩序长枪','8阶蓝色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001020800,2,260,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{1,2989},{3,1494}]','[]',0,0,2,0),(1001020820,'秩序长枪','8阶紫色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001020800,2,260,0,2,0,0,0,'[{1,12}]',0,0,0,0,'[{1,5439},{3,2720}]','[]',0,0,2,0),(1001020831,'秩序长枪','8阶橙1星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001020800,2,260,0,3,0,0,0,'[{1,16}]',0,0,0,0,'[{1,6635},{3,3317}]','[]',0,0,2,0),(1001020832,'秩序长枪','8阶橙2星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001020800,2,260,0,3,0,0,0,'[{1,20}]',0,0,0,0,'[{1,6635},{3,3317}]','[]',0,0,2,0),(1001020841,'秩序长枪','8阶红1星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001020800,2,260,0,4,0,0,0,'[{1,52}]',0,0,0,0,'[{1,9962},{3,4981}]','[]',0,0,2,0),(1001020842,'秩序长枪','8阶红2星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001020800,2,260,0,4,0,0,0,'[{1,84}]',0,0,0,0,'[{1,9962},{3,4981}]','[]',0,0,2,0),(1001020843,'秩序长枪','8阶红3星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001020800,2,260,0,4,0,0,0,'[{1,380}]',0,0,0,0,'[{1,9962},{3,4981}]','[]',0,0,2,0),(1001020853,'秩序长枪','8阶粉色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001020800,2,260,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,15939},{3,7970}]','[]',0,0,2,0),(1001020863,'秩序长枪','8阶神装武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001020800,2,260,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,19924},{3,9962}]','[]',0,0,2,0),(1001020900,'守护长枪','9阶绿色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001020900,2,300,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{1,2644},{3,1322}]','[]',0,0,3,0),(1001020910,'守护长枪','9阶蓝色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001020900,2,300,0,1,0,0,0,'[{1,7}]',0,0,0,0,'[{1,3966},{3,1983}]','[]',0,0,3,0),(1001020920,'守护长枪','9阶紫色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001020900,2,300,0,2,0,0,0,'[{1,13}]',0,0,0,0,'[{1,7219},{3,3609}]','[]',0,0,3,0),(1001020931,'守护长枪','9阶橙1星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001020900,2,300,0,3,0,0,0,'[{1,17}]',0,0,0,0,'[{1,8805},{3,4403}]','[]',0,0,3,0),(1001020932,'守护长枪','9阶橙2星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001020900,2,300,0,3,0,0,0,'[{1,21}]',0,0,0,0,'[{1,8805},{3,4403}]','[]',0,0,3,0),(1001020941,'守护长枪','9阶红1星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001020900,2,300,0,4,0,0,0,'[{1,61}]',0,0,0,0,'[{1,13221},{3,6611}]','[]',0,0,3,0),(1001020942,'守护长枪','9阶红2星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001020900,2,300,0,4,0,0,0,'[{1,100}]',0,0,0,0,'[{1,13221},{3,6611}]','[]',0,0,3,0),(1001020943,'守护长枪','9阶红3星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001020900,2,300,0,4,0,0,0,'[{1,530}]',0,0,0,0,'[{1,13221},{3,6611}]','[]',0,0,3,0),(1001020953,'守护长枪','9阶粉色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001020900,2,300,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,21154},{3,10577}]','[]',0,0,3,0),(1001020963,'守护长枪','9阶神装武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001020900,2,300,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,26443},{3,13221}]','[]',0,0,3,0),(1001021000,'信仰长枪','10阶绿色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001021000,2,355,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{1,3404},{3,1702}]','[]',0,0,4,0),(1001021010,'信仰长枪','10阶蓝色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001021000,2,355,0,1,0,0,0,'[{1,7}]',0,0,0,0,'[{1,5107},{3,2553}]','[]',0,0,4,0),(1001021020,'信仰长枪','10阶紫色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001021000,2,355,0,2,0,0,0,'[{1,13}]',0,0,0,0,'[{1,9294},{3,4647}]','[]',0,0,4,0),(1001021031,'信仰长枪','10阶橙1星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001021000,2,355,0,3,0,0,0,'[{1,18}]',0,0,0,0,'[{1,11337},{3,5668}]','[]',0,0,4,0),(1001021032,'信仰长枪','10阶橙2星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001021000,2,355,0,3,0,0,0,'[{1,22}]',0,0,0,0,'[{1,11337},{3,5668}]','[]',0,0,4,0),(1001021041,'信仰长枪','10阶红1星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001021000,2,355,0,4,0,0,0,'[{1,74}]',0,0,0,0,'[{1,17022},{3,8511}]','[]',0,0,4,0),(1001021042,'信仰长枪','10阶红2星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001021000,2,355,0,4,0,0,0,'[{1,125}]',0,0,0,0,'[{1,17022},{3,8511}]','[]',0,0,4,0),(1001021043,'信仰长枪','10阶红3星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001021000,2,355,0,4,0,0,0,'[{1,730}]',0,0,0,0,'[{1,17022},{3,8511}]','[]',0,0,4,0),(1001021053,'信仰长枪','10阶粉色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001021000,2,355,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,27235},{3,13618}]','[]',0,0,4,0),(1001021063,'信仰长枪','10阶神装武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001021000,2,355,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,34044},{3,17022}]','[]',0,0,4,0),(1001021100,'天行长枪','11阶绿色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001021100,2,400,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{1,4278},{3,2139}]','[]',0,0,4,0),(1001021110,'天行长枪','11阶蓝色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001021100,2,400,0,1,0,0,0,'[{1,8}]',0,0,0,0,'[{1,6417},{3,3208}]','[]',0,0,4,0),(1001021120,'天行长枪','11阶紫色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001021100,2,400,0,2,0,0,0,'[{1,15}]',0,0,0,0,'[{1,11678},{3,5839}]','[]',0,0,4,0),(1001021131,'天行长枪','11阶橙1星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001021100,2,400,0,3,0,0,0,'[{1,20}]',0,0,0,0,'[{1,14245},{3,7122}]','[]',0,0,4,0),(1001021132,'天行长枪','11阶橙2星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001021100,2,400,0,3,0,0,0,'[{1,25}]',0,0,0,0,'[{1,14245},{3,7122}]','[]',0,0,4,0),(1001021141,'天行长枪','11阶红1星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001021100,2,400,0,4,0,0,0,'[{1,84}]',0,0,0,0,'[{1,21389},{3,10694}]','[]',0,0,4,0),(1001021142,'天行长枪','11阶红2星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001021100,2,400,0,4,0,0,0,'[{1,142}]',0,0,0,0,'[{1,21389},{3,10694}]','[]',0,0,4,0),(1001021143,'天行长枪','11阶红3星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001021100,2,400,0,4,0,0,0,'[{1,1005}]',0,0,0,0,'[{1,21389},{3,10694}]','[]',0,0,4,0),(1001021153,'天行长枪','11阶粉色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001021100,2,400,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,34222},{3,17111}]','[]',0,0,4,0),(1001021163,'天行长枪','11阶神装武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001021100,2,400,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,42777},{3,21389}]','[]',0,0,4,0),(1001021200,'命运长枪','12阶绿色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001021200,2,500,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{1,5269},{3,2635}]','[]',0,0,5,0),(1001021210,'命运长枪','12阶蓝色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001021200,2,500,0,1,0,0,0,'[{1,8}]',0,0,0,0,'[{1,7904},{3,3952}]','[]',0,0,5,0),(1001021220,'命运长枪','12阶紫色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001021200,2,500,0,2,0,0,0,'[{1,16}]',0,0,0,0,'[{1,14384},{3,7192}]','[]',0,0,5,0),(1001021231,'命运长枪','12阶橙1星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001021200,2,500,0,3,0,0,0,'[{1,22}]',0,0,0,0,'[{1,17546},{3,8773}]','[]',0,0,5,0),(1001021232,'命运长枪','12阶橙2星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001021200,2,500,0,3,0,0,0,'[{1,27}]',0,0,0,0,'[{1,17546},{3,8773}]','[]',0,0,5,0),(1001021241,'命运长枪','12阶红1星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001021200,2,500,0,4,0,0,0,'[{1,114}]',0,0,0,0,'[{1,26345},{3,13173}]','[]',0,0,5,0),(1001021242,'命运长枪','12阶红2星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001021200,2,500,0,4,0,0,0,'[{1,200}]',0,0,0,0,'[{1,26345},{3,13173}]','[]',0,0,5,0),(1001021243,'命运长枪','12阶红3星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001021200,2,500,0,4,0,0,0,'[{1,1464}]',0,0,0,0,'[{1,26345},{3,13173}]','[]',0,0,5,0),(1001021253,'命运长枪','12阶粉色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001021200,2,500,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,42152},{3,21076}]','[]',0,0,5,0),(1001021263,'命运长枪','12阶神装武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001021200,2,500,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,52690},{3,26345}]','[]',0,0,5,0),(1001021300,'制裁长枪','13阶绿色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001021300,2,520,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{1,6383},{3,3192}]','[]',0,0,5,0),(1001021310,'制裁长枪','13阶蓝色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001021300,2,520,0,1,0,0,0,'[{1,9}]',0,0,0,0,'[{1,9575},{3,4787}]','[]',0,0,5,0),(1001021320,'制裁长枪','13阶紫色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001021300,2,520,0,2,0,0,0,'[{1,18}]',0,0,0,0,'[{1,17426},{3,8713}]','[]',0,0,5,0),(1001021331,'制裁长枪','13阶橙1星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001021300,2,520,0,3,0,0,0,'[{1,24}]',0,0,0,0,'[{1,21256},{3,10628}]','[]',0,0,5,0),(1001021332,'制裁长枪','13阶橙2星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001021300,2,520,0,3,0,0,0,'[{1,30}]',0,0,0,0,'[{1,21256},{3,10628}]','[]',0,0,5,0),(1001021341,'制裁长枪','13阶红1星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001021300,2,520,0,4,0,0,0,'[{1,132}]',0,0,0,0,'[{1,31916},{3,15958}]','[]',0,0,5,0),(1001021342,'制裁长枪','13阶红2星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001021300,2,520,0,4,0,0,0,'[{1,234}]',0,0,0,0,'[{1,31916},{3,15958}]','[]',0,0,5,0),(1001021343,'制裁长枪','13阶红3星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001021300,2,520,0,4,0,0,0,'[{1,2047}]',0,0,0,0,'[{1,31916},{3,15958}]','[]',0,0,5,0),(1001021353,'制裁长枪','13阶粉色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001021300,2,520,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,51066},{3,25533}]','[]',0,0,5,0),(1001021363,'制裁长枪','13阶神装武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001021300,2,520,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,63832},{3,31916}]','[]',0,0,5,0),(1001021400,'审判长枪','14阶绿色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001021400,2,620,0,0,0,0,0,'[{1,4}]',0,0,0,0,'[{1,7625},{3,3813}]','[]',0,0,6,0),(1001021410,'审判长枪','14阶蓝色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001021400,2,620,0,1,0,0,0,'[{1,10}]',0,0,0,0,'[{1,11438},{3,5719}]','[]',0,0,6,0),(1001021420,'审判长枪','14阶紫色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001021400,2,620,0,2,0,0,0,'[{1,20}]',0,0,0,0,'[{1,20817},{3,10408}]','[]',0,0,6,0),(1001021431,'审判长枪','14阶橙1星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001021400,2,620,0,3,0,0,0,'[{1,27}]',0,0,0,0,'[{1,25392},{3,12696}]','[]',0,0,6,0),(1001021432,'审判长枪','14阶橙2星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001021400,2,620,0,3,0,0,0,'[{1,34}]',0,0,0,0,'[{1,25392},{3,12696}]','[]',0,0,6,0),(1001021441,'审判长枪','14阶红1星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001021400,2,620,0,4,0,0,0,'[{1,150}]',0,0,0,0,'[{1,38126},{3,19063}]','[]',0,0,6,0),(1001021442,'审判长枪','14阶红2星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001021400,2,620,0,4,0,0,0,'[{1,267}]',0,0,0,0,'[{1,38126},{3,19063}]','[]',0,0,6,0),(1001021443,'审判长枪','14阶红3星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001021400,2,620,0,4,0,0,0,'[{1,2647}]',0,0,0,0,'[{1,38126},{3,19063}]','[]',0,0,6,0),(1001021453,'审判长枪','14阶粉色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001021400,2,620,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,61002},{3,30501}]','[]',0,0,6,0),(1001021463,'审判长枪','14阶神装武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001021400,2,620,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,76253},{3,38126}]','[]',0,0,6,0),(1001021500,'毁灭长枪','15阶绿色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001021500,2,650,0,0,0,0,0,'[{1,4}]',0,0,0,0,'[{1,9000},{3,4500}]','[]',0,0,6,0),(1001021510,'毁灭长枪','15阶蓝色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001021500,2,650,0,1,0,0,0,'[{1,11}]',0,0,0,0,'[{1,13500},{3,6750}]','[]',0,0,6,0),(1001021520,'毁灭长枪','15阶紫色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001021500,2,650,0,2,0,0,0,'[{1,22}]',0,0,0,0,'[{1,24570},{3,12285}]','[]',0,0,6,0),(1001021531,'毁灭长枪','15阶橙1星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001021500,2,650,0,3,0,0,0,'[{1,30}]',0,0,0,0,'[{1,29970},{3,14985}]','[]',0,0,6,0),(1001021532,'毁灭长枪','15阶橙2星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001021500,2,650,0,3,0,0,0,'[{1,37}]',0,0,0,0,'[{1,29970},{3,14985}]','[]',0,0,6,0),(1001021541,'毁灭长枪','15阶红1星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001021500,2,650,0,4,0,0,0,'[{1,169}]',0,0,0,0,'[{1,45000},{3,22500}]','[]',0,0,6,0),(1001021542,'毁灭长枪','15阶红2星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001021500,2,650,0,4,0,0,0,'[{1,300}]',0,0,0,0,'[{1,45000},{3,22500}]','[]',0,0,6,0),(1001021543,'毁灭长枪','15阶红3星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001021500,2,650,0,4,0,0,0,'[{1,3147}]',0,0,0,0,'[{1,45000},{3,22500}]','[]',0,0,6,0),(1001021553,'毁灭长枪','15阶粉色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001021500,2,650,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,72000},{3,36000}]','[]',0,0,6,0),(1001021563,'毁灭长枪','15阶神装武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001021500,2,650,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,90000},{3,45000}]','[]',0,0,6,0),(1001021600,'混沌长枪','16阶绿色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001021500,2,700,0,0,0,0,0,'[{1,5}]',0,0,0,0,'[{1,10512},{3,5256}]','[]',0,0,6,0),(1001021610,'混沌长枪','16阶蓝色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001021500,2,700,0,1,0,0,0,'[{1,13}]',0,0,0,0,'[{1,15768},{3,7884}]','[]',0,0,6,0),(1001021620,'混沌长枪','16阶紫色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001021500,2,700,0,2,0,0,0,'[{1,25}]',0,0,0,0,'[{1,28699},{3,14349}]','[]',0,0,6,0),(1001021631,'混沌长枪','16阶橙1星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001021500,2,700,0,3,0,0,0,'[{1,34}]',0,0,0,0,'[{1,35006},{3,17503}]','[]',0,0,6,0),(1001021632,'混沌长枪','16阶橙2星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001021500,2,700,0,3,0,0,0,'[{1,42}]',0,0,0,0,'[{1,35006},{3,17503}]','[]',0,0,6,0),(1001021641,'混沌长枪','16阶红1星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001021500,2,700,0,4,0,0,0,'[{1,205}]',0,0,0,0,'[{1,52562},{3,26281}]','[]',0,0,6,0),(1001021642,'混沌长枪','16阶红2星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001021500,2,700,0,4,0,0,0,'[{1,367}]',0,0,0,0,'[{1,52562},{3,26281}]','[]',0,0,6,0),(1001021643,'混沌长枪','16阶红3星武器【龙骑士】','',0,'','',0,1,1,10,1,1,1,1,1001021500,2,700,0,4,0,0,0,'[{1,3747}]',0,0,0,0,'[{1,52562},{3,26281}]','[]',0,0,6,0),(1001021653,'混沌长枪','16阶粉色武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001021500,2,700,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,84099},{3,42049}]','[]',0,0,6,0),(1001021663,'混沌长枪','16阶神装武器【龙骑士】','',0,'','',0,0,1,10,1,0,0,1,1001021500,2,700,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,105123},{3,52562}]','[]',0,0,6,0),(1001030100,'学徒法杖','1阶绿色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001030100,3,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,45},{3,22}]','[]',0,0,0,0),(1001030110,'学徒法杖','1阶蓝色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001030100,3,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{1,67},{3,33}]','[]',0,0,0,0),(1001030120,'学徒法杖','1阶紫色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001030100,3,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{1,122},{3,61}]','[]',0,0,0,0),(1001030131,'学徒法杖','1阶橙1星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001030100,3,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{1,149},{3,74}]','[]',0,0,0,0),(1001030132,'学徒法杖','1阶橙2星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001030100,3,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{1,149},{3,74}]','[]',0,0,0,0),(1001030141,'学徒法杖','1阶红1星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001030100,3,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{1,223},{3,112}]','[]',0,0,0,0),(1001030142,'学徒法杖','1阶红2星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001030100,3,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{1,223},{3,112}]','[]',0,0,0,0),(1001030143,'学徒法杖','1阶红3星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001030100,3,1,0,4,0,0,0,'[{1,9}]',0,0,0,0,'[{1,223},{3,112}]','[]',0,0,0,0),(1001030153,'学徒法杖','1阶粉色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001030100,3,1,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,357},{3,179}]','[]',0,0,0,0),(1001030163,'学徒法杖','1阶神装武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001030100,3,1,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,446},{3,223}]','[]',0,0,0,0),(1001030200,'冒险法杖','2阶绿色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001030200,3,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,76},{3,38}]','[]',0,0,0,0),(1001030210,'冒险法杖','2阶蓝色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001030200,3,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{1,115},{3,57}]','[]',0,0,0,0),(1001030220,'冒险法杖','2阶紫色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001030200,3,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{1,209},{3,104}]','[]',0,0,0,0),(1001030231,'冒险法杖','2阶橙1星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001030200,3,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{1,255},{3,127}]','[]',0,0,0,0),(1001030232,'冒险法杖','2阶橙2星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001030200,3,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{1,255},{3,127}]','[]',0,0,0,0),(1001030241,'冒险法杖','2阶红1星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001030200,3,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{1,382},{3,191}]','[]',0,0,0,0),(1001030242,'冒险法杖','2阶红2星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001030200,3,1,0,4,0,0,0,'[{1,5}]',0,0,0,0,'[{1,382},{3,191}]','[]',0,0,0,0),(1001030243,'冒险法杖','2阶红3星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001030200,3,1,0,4,0,0,0,'[{1,15}]',0,0,0,0,'[{1,382},{3,191}]','[]',0,0,0,0),(1001030253,'冒险法杖','2阶粉色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001030200,3,1,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,612},{3,306}]','[]',0,0,0,0),(1001030263,'冒险法杖','2阶神装武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001030200,3,1,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,764},{3,382}]','[]',0,0,0,0),(1001030300,'勇者法杖','3阶绿色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001030300,3,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,182},{3,91}]','[]',0,0,0,0),(1001030310,'勇者法杖','3阶蓝色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001030300,3,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{1,273},{3,137}]','[]',0,0,0,0),(1001030320,'勇者法杖','3阶紫色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001030300,3,1,0,2,0,0,0,'[{1,2}]',0,0,0,0,'[{1,498},{3,249}]','[]',0,0,0,0),(1001030331,'勇者法杖','3阶橙1星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001030300,3,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{1,607},{3,303}]','[]',0,0,0,0),(1001030332,'勇者法杖','3阶橙2星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001030300,3,1,0,3,0,0,0,'[{1,3}]',0,0,0,0,'[{1,607},{3,303}]','[]',0,0,0,0),(1001030341,'勇者法杖','3阶红1星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001030300,3,1,0,4,0,0,0,'[{1,5}]',0,0,0,0,'[{1,911},{3,456}]','[]',0,0,0,0),(1001030342,'勇者法杖','3阶红2星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001030300,3,1,0,4,0,0,0,'[{1,7}]',0,0,0,0,'[{1,911},{3,456}]','[]',0,0,0,0),(1001030343,'勇者法杖','3阶红3星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001030300,3,1,0,4,0,0,0,'[{1,22}]',0,0,0,0,'[{1,911},{3,456}]','[]',0,0,0,0),(1001030353,'勇者法杖','3阶粉色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001030300,3,1,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,1458},{3,729}]','[]',0,0,0,0),(1001030363,'勇者法杖','3阶神装武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001030300,3,1,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,1822},{3,911}]','[]',0,0,0,0),(1001030400,'先驱法杖','4阶绿色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001030400,3,100,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,367},{3,183}]','[]',0,0,0,0),(1001030410,'先驱法杖','4阶蓝色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001030400,3,100,0,1,0,0,0,'[{1,2}]',0,0,0,0,'[{1,550},{3,275}]','[]',0,0,0,0),(1001030420,'先驱法杖','4阶紫色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001030400,3,100,0,2,0,0,0,'[{1,4}]',0,0,0,0,'[{1,1002},{3,501}]','[]',0,0,0,0),(1001030431,'先驱法杖','4阶橙1星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001030400,3,100,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{1,1222},{3,611}]','[]',0,0,0,0),(1001030432,'先驱法杖','4阶橙2星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001030400,3,100,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{1,1222},{3,611}]','[]',0,0,0,0),(1001030441,'先驱法杖','4阶红1星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001030400,3,100,0,4,0,0,0,'[{1,14}]',0,0,0,0,'[{1,1835},{3,917}]','[]',0,0,0,0),(1001030442,'先驱法杖','4阶红2星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001030400,3,100,0,4,0,0,0,'[{1,21}]',0,0,0,0,'[{1,1835},{3,917}]','[]',0,0,0,0),(1001030443,'先驱法杖','4阶红3星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001030400,3,100,0,4,0,0,0,'[{1,62}]',0,0,0,0,'[{1,1835},{3,917}]','[]',0,0,0,0),(1001030453,'先驱法杖','4阶粉色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001030400,3,100,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,2935},{3,1468}]','[]',0,0,0,0),(1001030463,'先驱法杖','4阶神装武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001030400,3,100,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,3669},{3,1835}]','[]',0,0,0,0),(1001030500,'荣誉法杖','5阶绿色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001030500,3,150,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,635},{3,318}]','[]',0,0,1,0),(1001030510,'荣誉法杖','5阶蓝色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001030500,3,150,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{1,953},{3,477}]','[]',0,0,1,0),(1001030520,'荣誉法杖','5阶紫色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001030500,3,150,0,2,0,0,0,'[{1,8}]',0,0,0,0,'[{1,1735},{3,867}]','[]',0,0,1,0),(1001030531,'荣誉法杖','5阶橙1星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001030500,3,150,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{1,2116},{3,1058}]','[]',0,0,1,0),(1001030532,'荣誉法杖','5阶橙2星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001030500,3,150,0,3,0,0,0,'[{1,13}]',0,0,0,0,'[{1,2116},{3,1058}]','[]',0,0,1,0),(1001030541,'荣誉法杖','5阶红1星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001030500,3,150,0,4,0,0,0,'[{1,26}]',0,0,0,0,'[{1,3177},{3,1588}]','[]',0,0,1,0),(1001030542,'荣誉法杖','5阶红2星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001030500,3,150,0,4,0,0,0,'[{1,39}]',0,0,0,0,'[{1,3177},{3,1588}]','[]',0,0,1,0),(1001030543,'荣誉法杖','5阶红3星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001030500,3,150,0,4,0,0,0,'[{1,115}]',0,0,0,0,'[{1,3177},{3,1588}]','[]',0,0,1,0),(1001030553,'荣誉法杖','5阶粉色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001030500,3,150,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,5083},{3,2542}]','[]',0,0,1,0),(1001030563,'荣誉法杖','5阶神装武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001030500,3,150,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,6354},{3,3177}]','[]',0,0,1,0),(1001030600,'贤者法杖','6阶绿色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001030600,3,180,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,993},{3,496}]','[]',0,0,1,0),(1001030610,'贤者法杖','6阶蓝色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001030600,3,180,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{1,1489},{3,744}]','[]',0,0,1,0),(1001030620,'贤者法杖','6阶紫色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001030600,3,180,0,2,0,0,0,'[{1,8}]',0,0,0,0,'[{1,2710},{3,1355}]','[]',0,0,1,0),(1001030631,'贤者法杖','6阶橙1星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001030600,3,180,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{1,3305},{3,1653}]','[]',0,0,1,0),(1001030632,'贤者法杖','6阶橙2星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001030600,3,180,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{1,3305},{3,1653}]','[]',0,0,1,0),(1001030641,'贤者法杖','6阶红1星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001030600,3,180,0,4,0,0,0,'[{1,33}]',0,0,0,0,'[{1,4963},{3,2481}]','[]',0,0,1,0),(1001030642,'贤者法杖','6阶红2星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001030600,3,180,0,4,0,0,0,'[{1,51}]',0,0,0,0,'[{1,4963},{3,2481}]','[]',0,0,1,0),(1001030643,'贤者法杖','6阶红3星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001030600,3,180,0,4,0,0,0,'[{1,190}]',0,0,0,0,'[{1,4963},{3,2481}]','[]',0,0,1,0),(1001030653,'贤者法杖','6阶粉色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001030600,3,180,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,7940},{3,3970}]','[]',0,0,1,0),(1001030663,'贤者法杖','6阶神装武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001030600,3,180,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,9925},{3,4963}]','[]',0,0,1,0),(1001030700,'征服法杖','7阶绿色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001030700,3,220,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,1443},{3,722}]','[]',0,0,2,0),(1001030710,'征服法杖','7阶蓝色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001030700,3,220,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{1,2165},{3,1082}]','[]',0,0,2,0),(1001030720,'征服法杖','7阶紫色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001030700,3,220,0,2,0,0,0,'[{1,10}]',0,0,0,0,'[{1,3940},{3,1970}]','[]',0,0,2,0),(1001030731,'征服法杖','7阶橙1星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001030700,3,220,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{1,4806},{3,2403}]','[]',0,0,2,0),(1001030732,'征服法杖','7阶橙2星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001030700,3,220,0,3,0,0,0,'[{1,17}]',0,0,0,0,'[{1,4806},{3,2403}]','[]',0,0,2,0),(1001030741,'征服法杖','7阶红1星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001030700,3,220,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{1,7216},{3,3608}]','[]',0,0,2,0),(1001030742,'征服法杖','7阶红2星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001030700,3,220,0,4,0,0,0,'[{1,75}]',0,0,0,0,'[{1,7216},{3,3608}]','[]',0,0,2,0),(1001030743,'征服法杖','7阶红3星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001030700,3,220,0,4,0,0,0,'[{1,272}]',0,0,0,0,'[{1,7216},{3,3608}]','[]',0,0,2,0),(1001030753,'征服法杖','7阶粉色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001030700,3,220,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,11546},{3,5773}]','[]',0,0,2,0),(1001030763,'征服法杖','7阶神装武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001030700,3,220,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,14432},{3,7216}]','[]',0,0,2,0),(1001030800,'秩序法杖','8阶绿色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001030800,3,260,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,1992},{3,996}]','[]',0,0,2,0),(1001030810,'秩序法杖','8阶蓝色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001030800,3,260,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{1,2989},{3,1494}]','[]',0,0,2,0),(1001030820,'秩序法杖','8阶紫色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001030800,3,260,0,2,0,0,0,'[{1,12}]',0,0,0,0,'[{1,5439},{3,2720}]','[]',0,0,2,0),(1001030831,'秩序法杖','8阶橙1星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001030800,3,260,0,3,0,0,0,'[{1,16}]',0,0,0,0,'[{1,6635},{3,3317}]','[]',0,0,2,0),(1001030832,'秩序法杖','8阶橙2星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001030800,3,260,0,3,0,0,0,'[{1,20}]',0,0,0,0,'[{1,6635},{3,3317}]','[]',0,0,2,0),(1001030841,'秩序法杖','8阶红1星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001030800,3,260,0,4,0,0,0,'[{1,52}]',0,0,0,0,'[{1,9962},{3,4981}]','[]',0,0,2,0),(1001030842,'秩序法杖','8阶红2星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001030800,3,260,0,4,0,0,0,'[{1,84}]',0,0,0,0,'[{1,9962},{3,4981}]','[]',0,0,2,0),(1001030843,'秩序法杖','8阶红3星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001030800,3,260,0,4,0,0,0,'[{1,380}]',0,0,0,0,'[{1,9962},{3,4981}]','[]',0,0,2,0),(1001030853,'秩序法杖','8阶粉色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001030800,3,260,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,15939},{3,7970}]','[]',0,0,2,0),(1001030863,'秩序法杖','8阶神装武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001030800,3,260,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,19924},{3,9962}]','[]',0,0,2,0),(1001030900,'守护法杖','9阶绿色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001030900,3,300,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{1,2644},{3,1322}]','[]',0,0,3,0),(1001030910,'守护法杖','9阶蓝色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001030900,3,300,0,1,0,0,0,'[{1,7}]',0,0,0,0,'[{1,3966},{3,1983}]','[]',0,0,3,0),(1001030920,'守护法杖','9阶紫色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001030900,3,300,0,2,0,0,0,'[{1,13}]',0,0,0,0,'[{1,7219},{3,3609}]','[]',0,0,3,0),(1001030931,'守护法杖','9阶橙1星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001030900,3,300,0,3,0,0,0,'[{1,17}]',0,0,0,0,'[{1,8805},{3,4403}]','[]',0,0,3,0),(1001030932,'守护法杖','9阶橙2星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001030900,3,300,0,3,0,0,0,'[{1,21}]',0,0,0,0,'[{1,8805},{3,4403}]','[]',0,0,3,0),(1001030941,'守护法杖','9阶红1星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001030900,3,300,0,4,0,0,0,'[{1,61}]',0,0,0,0,'[{1,13221},{3,6611}]','[]',0,0,3,0),(1001030942,'守护法杖','9阶红2星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001030900,3,300,0,4,0,0,0,'[{1,100}]',0,0,0,0,'[{1,13221},{3,6611}]','[]',0,0,3,0),(1001030943,'守护法杖','9阶红3星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001030900,3,300,0,4,0,0,0,'[{1,530}]',0,0,0,0,'[{1,13221},{3,6611}]','[]',0,0,3,0),(1001030953,'守护法杖','9阶粉色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001030900,3,300,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,21154},{3,10577}]','[]',0,0,3,0),(1001030963,'守护法杖','9阶神装武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001030900,3,300,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,26443},{3,13221}]','[]',0,0,3,0),(1001031000,'信仰法杖','10阶绿色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001031000,3,355,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{1,3404},{3,1702}]','[]',0,0,4,0),(1001031010,'信仰法杖','10阶蓝色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001031000,3,355,0,1,0,0,0,'[{1,7}]',0,0,0,0,'[{1,5107},{3,2553}]','[]',0,0,4,0),(1001031020,'信仰法杖','10阶紫色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001031000,3,355,0,2,0,0,0,'[{1,13}]',0,0,0,0,'[{1,9294},{3,4647}]','[]',0,0,4,0),(1001031031,'信仰法杖','10阶橙1星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001031000,3,355,0,3,0,0,0,'[{1,18}]',0,0,0,0,'[{1,11337},{3,5668}]','[]',0,0,4,0),(1001031032,'信仰法杖','10阶橙2星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001031000,3,355,0,3,0,0,0,'[{1,22}]',0,0,0,0,'[{1,11337},{3,5668}]','[]',0,0,4,0),(1001031041,'信仰法杖','10阶红1星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001031000,3,355,0,4,0,0,0,'[{1,74}]',0,0,0,0,'[{1,17022},{3,8511}]','[]',0,0,4,0),(1001031042,'信仰法杖','10阶红2星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001031000,3,355,0,4,0,0,0,'[{1,125}]',0,0,0,0,'[{1,17022},{3,8511}]','[]',0,0,4,0),(1001031043,'信仰法杖','10阶红3星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001031000,3,355,0,4,0,0,0,'[{1,730}]',0,0,0,0,'[{1,17022},{3,8511}]','[]',0,0,4,0),(1001031053,'信仰法杖','10阶粉色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001031000,3,355,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,27235},{3,13618}]','[]',0,0,4,0),(1001031063,'信仰法杖','10阶神装武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001031000,3,355,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,34044},{3,17022}]','[]',0,0,4,0),(1001031100,'天行法杖','11阶绿色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001031100,3,400,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{1,4278},{3,2139}]','[]',0,0,4,0),(1001031110,'天行法杖','11阶蓝色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001031100,3,400,0,1,0,0,0,'[{1,8}]',0,0,0,0,'[{1,6417},{3,3208}]','[]',0,0,4,0),(1001031120,'天行法杖','11阶紫色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001031100,3,400,0,2,0,0,0,'[{1,15}]',0,0,0,0,'[{1,11678},{3,5839}]','[]',0,0,4,0),(1001031131,'天行法杖','11阶橙1星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001031100,3,400,0,3,0,0,0,'[{1,20}]',0,0,0,0,'[{1,14245},{3,7122}]','[]',0,0,4,0),(1001031132,'天行法杖','11阶橙2星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001031100,3,400,0,3,0,0,0,'[{1,25}]',0,0,0,0,'[{1,14245},{3,7122}]','[]',0,0,4,0),(1001031141,'天行法杖','11阶红1星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001031100,3,400,0,4,0,0,0,'[{1,84}]',0,0,0,0,'[{1,21389},{3,10694}]','[]',0,0,4,0),(1001031142,'天行法杖','11阶红2星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001031100,3,400,0,4,0,0,0,'[{1,142}]',0,0,0,0,'[{1,21389},{3,10694}]','[]',0,0,4,0),(1001031143,'天行法杖','11阶红3星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001031100,3,400,0,4,0,0,0,'[{1,1005}]',0,0,0,0,'[{1,21389},{3,10694}]','[]',0,0,4,0),(1001031153,'天行法杖','11阶粉色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001031100,3,400,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,34222},{3,17111}]','[]',0,0,4,0),(1001031163,'天行法杖','11阶神装武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001031100,3,400,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,42777},{3,21389}]','[]',0,0,4,0),(1001031200,'命运法杖','12阶绿色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001031200,3,500,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{1,5269},{3,2635}]','[]',0,0,5,0),(1001031210,'命运法杖','12阶蓝色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001031200,3,500,0,1,0,0,0,'[{1,8}]',0,0,0,0,'[{1,7904},{3,3952}]','[]',0,0,5,0),(1001031220,'命运法杖','12阶紫色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001031200,3,500,0,2,0,0,0,'[{1,16}]',0,0,0,0,'[{1,14384},{3,7192}]','[]',0,0,5,0),(1001031231,'命运法杖','12阶橙1星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001031200,3,500,0,3,0,0,0,'[{1,22}]',0,0,0,0,'[{1,17546},{3,8773}]','[]',0,0,5,0),(1001031232,'命运法杖','12阶橙2星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001031200,3,500,0,3,0,0,0,'[{1,27}]',0,0,0,0,'[{1,17546},{3,8773}]','[]',0,0,5,0),(1001031241,'命运法杖','12阶红1星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001031200,3,500,0,4,0,0,0,'[{1,114}]',0,0,0,0,'[{1,26345},{3,13173}]','[]',0,0,5,0),(1001031242,'命运法杖','12阶红2星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001031200,3,500,0,4,0,0,0,'[{1,200}]',0,0,0,0,'[{1,26345},{3,13173}]','[]',0,0,5,0),(1001031243,'命运法杖','12阶红3星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001031200,3,500,0,4,0,0,0,'[{1,1464}]',0,0,0,0,'[{1,26345},{3,13173}]','[]',0,0,5,0),(1001031253,'命运法杖','12阶粉色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001031200,3,500,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,42152},{3,21076}]','[]',0,0,5,0),(1001031263,'命运法杖','12阶神装武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001031200,3,500,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,52690},{3,26345}]','[]',0,0,5,0),(1001031300,'制裁法杖','13阶绿色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001031300,3,520,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{1,6383},{3,3192}]','[]',0,0,5,0),(1001031310,'制裁法杖','13阶蓝色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001031300,3,520,0,1,0,0,0,'[{1,9}]',0,0,0,0,'[{1,9575},{3,4787}]','[]',0,0,5,0),(1001031320,'制裁法杖','13阶紫色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001031300,3,520,0,2,0,0,0,'[{1,18}]',0,0,0,0,'[{1,17426},{3,8713}]','[]',0,0,5,0),(1001031331,'制裁法杖','13阶橙1星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001031300,3,520,0,3,0,0,0,'[{1,24}]',0,0,0,0,'[{1,21256},{3,10628}]','[]',0,0,5,0),(1001031332,'制裁法杖','13阶橙2星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001031300,3,520,0,3,0,0,0,'[{1,30}]',0,0,0,0,'[{1,21256},{3,10628}]','[]',0,0,5,0),(1001031341,'制裁法杖','13阶红1星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001031300,3,520,0,4,0,0,0,'[{1,132}]',0,0,0,0,'[{1,31916},{3,15958}]','[]',0,0,5,0),(1001031342,'制裁法杖','13阶红2星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001031300,3,520,0,4,0,0,0,'[{1,234}]',0,0,0,0,'[{1,31916},{3,15958}]','[]',0,0,5,0),(1001031343,'制裁法杖','13阶红3星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001031300,3,520,0,4,0,0,0,'[{1,2047}]',0,0,0,0,'[{1,31916},{3,15958}]','[]',0,0,5,0),(1001031353,'制裁法杖','13阶粉色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001031300,3,520,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,51066},{3,25533}]','[]',0,0,5,0),(1001031363,'制裁法杖','13阶神装武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001031300,3,520,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,63832},{3,31916}]','[]',0,0,5,0),(1001031400,'审判法杖','14阶绿色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001031400,3,620,0,0,0,0,0,'[{1,4}]',0,0,0,0,'[{1,7625},{3,3813}]','[]',0,0,6,0),(1001031410,'审判法杖','14阶蓝色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001031400,3,620,0,1,0,0,0,'[{1,10}]',0,0,0,0,'[{1,11438},{3,5719}]','[]',0,0,6,0),(1001031420,'审判法杖','14阶紫色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001031400,3,620,0,2,0,0,0,'[{1,20}]',0,0,0,0,'[{1,20817},{3,10408}]','[]',0,0,6,0),(1001031431,'审判法杖','14阶橙1星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001031400,3,620,0,3,0,0,0,'[{1,27}]',0,0,0,0,'[{1,25392},{3,12696}]','[]',0,0,6,0),(1001031432,'审判法杖','14阶橙2星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001031400,3,620,0,3,0,0,0,'[{1,34}]',0,0,0,0,'[{1,25392},{3,12696}]','[]',0,0,6,0),(1001031441,'审判法杖','14阶红1星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001031400,3,620,0,4,0,0,0,'[{1,150}]',0,0,0,0,'[{1,38126},{3,19063}]','[]',0,0,6,0),(1001031442,'审判法杖','14阶红2星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001031400,3,620,0,4,0,0,0,'[{1,267}]',0,0,0,0,'[{1,38126},{3,19063}]','[]',0,0,6,0),(1001031443,'审判法杖','14阶红3星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001031400,3,620,0,4,0,0,0,'[{1,2647}]',0,0,0,0,'[{1,38126},{3,19063}]','[]',0,0,6,0),(1001031453,'审判法杖','14阶粉色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001031400,3,620,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,61002},{3,30501}]','[]',0,0,6,0),(1001031463,'审判法杖','14阶神装武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001031400,3,620,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,76253},{3,38126}]','[]',0,0,6,0),(1001031500,'毁灭法杖','15阶绿色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001031500,3,650,0,0,0,0,0,'[{1,4}]',0,0,0,0,'[{1,9000},{3,4500}]','[]',0,0,6,0),(1001031510,'毁灭法杖','15阶蓝色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001031500,3,650,0,1,0,0,0,'[{1,11}]',0,0,0,0,'[{1,13500},{3,6750}]','[]',0,0,6,0),(1001031520,'毁灭法杖','15阶紫色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001031500,3,650,0,2,0,0,0,'[{1,22}]',0,0,0,0,'[{1,24570},{3,12285}]','[]',0,0,6,0),(1001031531,'毁灭法杖','15阶橙1星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001031500,3,650,0,3,0,0,0,'[{1,30}]',0,0,0,0,'[{1,29970},{3,14985}]','[]',0,0,6,0),(1001031532,'毁灭法杖','15阶橙2星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001031500,3,650,0,3,0,0,0,'[{1,37}]',0,0,0,0,'[{1,29970},{3,14985}]','[]',0,0,6,0),(1001031541,'毁灭法杖','15阶红1星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001031500,3,650,0,4,0,0,0,'[{1,169}]',0,0,0,0,'[{1,45000},{3,22500}]','[]',0,0,6,0),(1001031542,'毁灭法杖','15阶红2星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001031500,3,650,0,4,0,0,0,'[{1,300}]',0,0,0,0,'[{1,45000},{3,22500}]','[]',0,0,6,0),(1001031543,'毁灭法杖','15阶红3星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001031500,3,650,0,4,0,0,0,'[{1,3147}]',0,0,0,0,'[{1,45000},{3,22500}]','[]',0,0,6,0),(1001031553,'毁灭法杖','15阶粉色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001031500,3,650,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,72000},{3,36000}]','[]',0,0,6,0),(1001031563,'毁灭法杖','15阶神装武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001031500,3,650,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,90000},{3,45000}]','[]',0,0,6,0),(1001031600,'混沌法杖','16阶绿色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001031500,3,700,0,0,0,0,0,'[{1,5}]',0,0,0,0,'[{1,10512},{3,5256}]','[]',0,0,6,0),(1001031610,'混沌法杖','16阶蓝色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001031500,3,700,0,1,0,0,0,'[{1,13}]',0,0,0,0,'[{1,15768},{3,7884}]','[]',0,0,6,0),(1001031620,'混沌法杖','16阶紫色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001031500,3,700,0,2,0,0,0,'[{1,25}]',0,0,0,0,'[{1,28699},{3,14349}]','[]',0,0,6,0),(1001031631,'混沌法杖','16阶橙1星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001031500,3,700,0,3,0,0,0,'[{1,34}]',0,0,0,0,'[{1,35006},{3,17503}]','[]',0,0,6,0),(1001031632,'混沌法杖','16阶橙2星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001031500,3,700,0,3,0,0,0,'[{1,42}]',0,0,0,0,'[{1,35006},{3,17503}]','[]',0,0,6,0),(1001031641,'混沌法杖','16阶红1星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001031500,3,700,0,4,0,0,0,'[{1,205}]',0,0,0,0,'[{1,52562},{3,26281}]','[]',0,0,6,0),(1001031642,'混沌法杖','16阶红2星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001031500,3,700,0,4,0,0,0,'[{1,367}]',0,0,0,0,'[{1,52562},{3,26281}]','[]',0,0,6,0),(1001031643,'混沌法杖','16阶红3星武器【魔导师】','',0,'','',0,1,1,10,1,1,1,1,1001031500,3,700,0,4,0,0,0,'[{1,3747}]',0,0,0,0,'[{1,52562},{3,26281}]','[]',0,0,6,0),(1001031653,'混沌法杖','16阶粉色武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001031500,3,700,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,84099},{3,42049}]','[]',0,0,6,0),(1001031663,'混沌法杖','16阶神装武器【魔导师】','',0,'','',0,0,1,10,1,0,0,1,1001031500,3,700,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,105123},{3,52562}]','[]',0,0,6,0),(1001040100,'学徒光炮','1阶绿色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001040100,4,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,45},{3,22}]','[]',0,0,0,0),(1001040110,'学徒光炮','1阶蓝色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001040100,4,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{1,67},{3,33}]','[]',0,0,0,0),(1001040120,'学徒光炮','1阶紫色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001040100,4,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{1,122},{3,61}]','[]',0,0,0,0),(1001040131,'学徒光炮','1阶橙1星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001040100,4,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{1,149},{3,74}]','[]',0,0,0,0),(1001040132,'学徒光炮','1阶橙2星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001040100,4,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{1,149},{3,74}]','[]',0,0,0,0),(1001040141,'学徒光炮','1阶红1星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001040100,4,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{1,223},{3,112}]','[]',0,0,0,0),(1001040142,'学徒光炮','1阶红2星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001040100,4,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{1,223},{3,112}]','[]',0,0,0,0),(1001040143,'学徒光炮','1阶红3星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001040100,4,1,0,4,0,0,0,'[{1,9}]',0,0,0,0,'[{1,223},{3,112}]','[]',0,0,0,0),(1001040153,'学徒光炮','1阶粉色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001040100,4,1,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,357},{3,179}]','[]',0,0,0,0),(1001040163,'学徒光炮','1阶神装武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001040100,4,1,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,446},{3,223}]','[]',0,0,0,0),(1001040200,'冒险光炮','2阶绿色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001040200,4,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,76},{3,38}]','[]',0,0,0,0),(1001040210,'冒险光炮','2阶蓝色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001040200,4,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{1,115},{3,57}]','[]',0,0,0,0),(1001040220,'冒险光炮','2阶紫色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001040200,4,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{1,209},{3,104}]','[]',0,0,0,0),(1001040231,'冒险光炮','2阶橙1星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001040200,4,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{1,255},{3,127}]','[]',0,0,0,0),(1001040232,'冒险光炮','2阶橙2星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001040200,4,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{1,255},{3,127}]','[]',0,0,0,0),(1001040241,'冒险光炮','2阶红1星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001040200,4,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{1,382},{3,191}]','[]',0,0,0,0),(1001040242,'冒险光炮','2阶红2星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001040200,4,1,0,4,0,0,0,'[{1,5}]',0,0,0,0,'[{1,382},{3,191}]','[]',0,0,0,0),(1001040243,'冒险光炮','2阶红3星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001040200,4,1,0,4,0,0,0,'[{1,15}]',0,0,0,0,'[{1,382},{3,191}]','[]',0,0,0,0),(1001040253,'冒险光炮','2阶粉色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001040200,4,1,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,612},{3,306}]','[]',0,0,0,0),(1001040263,'冒险光炮','2阶神装武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001040200,4,1,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,764},{3,382}]','[]',0,0,0,0),(1001040300,'勇者光炮','3阶绿色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001040300,4,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,182},{3,91}]','[]',0,0,0,0),(1001040310,'勇者光炮','3阶蓝色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001040300,4,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{1,273},{3,137}]','[]',0,0,0,0),(1001040320,'勇者光炮','3阶紫色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001040300,4,1,0,2,0,0,0,'[{1,2}]',0,0,0,0,'[{1,498},{3,249}]','[]',0,0,0,0),(1001040331,'勇者光炮','3阶橙1星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001040300,4,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{1,607},{3,303}]','[]',0,0,0,0),(1001040332,'勇者光炮','3阶橙2星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001040300,4,1,0,3,0,0,0,'[{1,3}]',0,0,0,0,'[{1,607},{3,303}]','[]',0,0,0,0),(1001040341,'勇者光炮','3阶红1星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001040300,4,1,0,4,0,0,0,'[{1,5}]',0,0,0,0,'[{1,911},{3,456}]','[]',0,0,0,0),(1001040342,'勇者光炮','3阶红2星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001040300,4,1,0,4,0,0,0,'[{1,7}]',0,0,0,0,'[{1,911},{3,456}]','[]',0,0,0,0),(1001040343,'勇者光炮','3阶红3星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001040300,4,1,0,4,0,0,0,'[{1,22}]',0,0,0,0,'[{1,911},{3,456}]','[]',0,0,0,0),(1001040353,'勇者光炮','3阶粉色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001040300,4,1,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,1458},{3,729}]','[]',0,0,0,0),(1001040363,'勇者光炮','3阶神装武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001040300,4,1,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,1822},{3,911}]','[]',0,0,0,0),(1001040400,'先驱光炮','4阶绿色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001040400,4,100,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,367},{3,183}]','[]',0,0,0,0),(1001040410,'先驱光炮','4阶蓝色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001040400,4,100,0,1,0,0,0,'[{1,2}]',0,0,0,0,'[{1,550},{3,275}]','[]',0,0,0,0),(1001040420,'先驱光炮','4阶紫色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001040400,4,100,0,2,0,0,0,'[{1,4}]',0,0,0,0,'[{1,1002},{3,501}]','[]',0,0,0,0),(1001040431,'先驱光炮','4阶橙1星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001040400,4,100,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{1,1222},{3,611}]','[]',0,0,0,0),(1001040432,'先驱光炮','4阶橙2星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001040400,4,100,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{1,1222},{3,611}]','[]',0,0,0,0),(1001040441,'先驱光炮','4阶红1星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001040400,4,100,0,4,0,0,0,'[{1,14}]',0,0,0,0,'[{1,1835},{3,917}]','[]',0,0,0,0),(1001040442,'先驱光炮','4阶红2星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001040400,4,100,0,4,0,0,0,'[{1,21}]',0,0,0,0,'[{1,1835},{3,917}]','[]',0,0,0,0),(1001040443,'先驱光炮','4阶红3星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001040400,4,100,0,4,0,0,0,'[{1,62}]',0,0,0,0,'[{1,1835},{3,917}]','[]',0,0,0,0),(1001040453,'先驱光炮','4阶粉色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001040400,4,100,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,2935},{3,1468}]','[]',0,0,0,0),(1001040463,'先驱光炮','4阶神装武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001040400,4,100,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,3669},{3,1835}]','[]',0,0,0,0),(1001040500,'荣誉光炮','5阶绿色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001040500,4,150,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,635},{3,318}]','[]',0,0,1,0),(1001040510,'荣誉光炮','5阶蓝色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001040500,4,150,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{1,953},{3,477}]','[]',0,0,1,0),(1001040520,'荣誉光炮','5阶紫色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001040500,4,150,0,2,0,0,0,'[{1,8}]',0,0,0,0,'[{1,1735},{3,867}]','[]',0,0,1,0),(1001040531,'荣誉光炮','5阶橙1星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001040500,4,150,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{1,2116},{3,1058}]','[]',0,0,1,0),(1001040532,'荣誉光炮','5阶橙2星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001040500,4,150,0,3,0,0,0,'[{1,13}]',0,0,0,0,'[{1,2116},{3,1058}]','[]',0,0,1,0),(1001040541,'荣誉光炮','5阶红1星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001040500,4,150,0,4,0,0,0,'[{1,26}]',0,0,0,0,'[{1,3177},{3,1588}]','[]',0,0,1,0),(1001040542,'荣誉光炮','5阶红2星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001040500,4,150,0,4,0,0,0,'[{1,39}]',0,0,0,0,'[{1,3177},{3,1588}]','[]',0,0,1,0),(1001040543,'荣誉光炮','5阶红3星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001040500,4,150,0,4,0,0,0,'[{1,115}]',0,0,0,0,'[{1,3177},{3,1588}]','[]',0,0,1,0),(1001040553,'荣誉光炮','5阶粉色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001040500,4,150,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,5083},{3,2542}]','[]',0,0,1,0),(1001040563,'荣誉光炮','5阶神装武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001040500,4,150,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,6354},{3,3177}]','[]',0,0,1,0),(1001040600,'贤者光炮','6阶绿色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001040600,4,180,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,993},{3,496}]','[]',0,0,1,0),(1001040610,'贤者光炮','6阶蓝色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001040600,4,180,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{1,1489},{3,744}]','[]',0,0,1,0),(1001040620,'贤者光炮','6阶紫色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001040600,4,180,0,2,0,0,0,'[{1,8}]',0,0,0,0,'[{1,2710},{3,1355}]','[]',0,0,1,0),(1001040631,'贤者光炮','6阶橙1星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001040600,4,180,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{1,3305},{3,1653}]','[]',0,0,1,0),(1001040632,'贤者光炮','6阶橙2星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001040600,4,180,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{1,3305},{3,1653}]','[]',0,0,1,0),(1001040641,'贤者光炮','6阶红1星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001040600,4,180,0,4,0,0,0,'[{1,33}]',0,0,0,0,'[{1,4963},{3,2481}]','[]',0,0,1,0),(1001040642,'贤者光炮','6阶红2星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001040600,4,180,0,4,0,0,0,'[{1,51}]',0,0,0,0,'[{1,4963},{3,2481}]','[]',0,0,1,0),(1001040643,'贤者光炮','6阶红3星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001040600,4,180,0,4,0,0,0,'[{1,190}]',0,0,0,0,'[{1,4963},{3,2481}]','[]',0,0,1,0),(1001040653,'贤者光炮','6阶粉色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001040600,4,180,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,7940},{3,3970}]','[]',0,0,1,0),(1001040663,'贤者光炮','6阶神装武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001040600,4,180,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,9925},{3,4963}]','[]',0,0,1,0),(1001040700,'征服光炮','7阶绿色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001040700,4,220,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,1443},{3,722}]','[]',0,0,2,0),(1001040710,'征服光炮','7阶蓝色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001040700,4,220,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{1,2165},{3,1082}]','[]',0,0,2,0),(1001040720,'征服光炮','7阶紫色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001040700,4,220,0,2,0,0,0,'[{1,10}]',0,0,0,0,'[{1,3940},{3,1970}]','[]',0,0,2,0),(1001040731,'征服光炮','7阶橙1星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001040700,4,220,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{1,4806},{3,2403}]','[]',0,0,2,0),(1001040732,'征服光炮','7阶橙2星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001040700,4,220,0,3,0,0,0,'[{1,17}]',0,0,0,0,'[{1,4806},{3,2403}]','[]',0,0,2,0),(1001040741,'征服光炮','7阶红1星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001040700,4,220,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{1,7216},{3,3608}]','[]',0,0,2,0),(1001040742,'征服光炮','7阶红2星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001040700,4,220,0,4,0,0,0,'[{1,75}]',0,0,0,0,'[{1,7216},{3,3608}]','[]',0,0,2,0),(1001040743,'征服光炮','7阶红3星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001040700,4,220,0,4,0,0,0,'[{1,272}]',0,0,0,0,'[{1,7216},{3,3608}]','[]',0,0,2,0),(1001040753,'征服光炮','7阶粉色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001040700,4,220,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,11546},{3,5773}]','[]',0,0,2,0),(1001040763,'征服光炮','7阶神装武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001040700,4,220,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,14432},{3,7216}]','[]',0,0,2,0),(1001040800,'秩序光炮','8阶绿色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001040800,4,260,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,1992},{3,996}]','[]',0,0,2,0),(1001040810,'秩序光炮','8阶蓝色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001040800,4,260,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{1,2989},{3,1494}]','[]',0,0,2,0),(1001040820,'秩序光炮','8阶紫色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001040800,4,260,0,2,0,0,0,'[{1,12}]',0,0,0,0,'[{1,5439},{3,2720}]','[]',0,0,2,0),(1001040831,'秩序光炮','8阶橙1星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001040800,4,260,0,3,0,0,0,'[{1,16}]',0,0,0,0,'[{1,6635},{3,3317}]','[]',0,0,2,0),(1001040832,'秩序光炮','8阶橙2星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001040800,4,260,0,3,0,0,0,'[{1,20}]',0,0,0,0,'[{1,6635},{3,3317}]','[]',0,0,2,0),(1001040841,'秩序光炮','8阶红1星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001040800,4,260,0,4,0,0,0,'[{1,52}]',0,0,0,0,'[{1,9962},{3,4981}]','[]',0,0,2,0),(1001040842,'秩序光炮','8阶红2星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001040800,4,260,0,4,0,0,0,'[{1,84}]',0,0,0,0,'[{1,9962},{3,4981}]','[]',0,0,2,0),(1001040843,'秩序光炮','8阶红3星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001040800,4,260,0,4,0,0,0,'[{1,380}]',0,0,0,0,'[{1,9962},{3,4981}]','[]',0,0,2,0),(1001040853,'秩序光炮','8阶粉色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001040800,4,260,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,15939},{3,7970}]','[]',0,0,2,0),(1001040863,'秩序光炮','8阶神装武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001040800,4,260,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,19924},{3,9962}]','[]',0,0,2,0),(1001040900,'守护光炮','9阶绿色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001040900,4,300,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{1,2644},{3,1322}]','[]',0,0,3,0),(1001040910,'守护光炮','9阶蓝色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001040900,4,300,0,1,0,0,0,'[{1,7}]',0,0,0,0,'[{1,3966},{3,1983}]','[]',0,0,3,0),(1001040920,'守护光炮','9阶紫色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001040900,4,300,0,2,0,0,0,'[{1,13}]',0,0,0,0,'[{1,7219},{3,3609}]','[]',0,0,3,0),(1001040931,'守护光炮','9阶橙1星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001040900,4,300,0,3,0,0,0,'[{1,17}]',0,0,0,0,'[{1,8805},{3,4403}]','[]',0,0,3,0),(1001040932,'守护光炮','9阶橙2星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001040900,4,300,0,3,0,0,0,'[{1,21}]',0,0,0,0,'[{1,8805},{3,4403}]','[]',0,0,3,0),(1001040941,'守护光炮','9阶红1星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001040900,4,300,0,4,0,0,0,'[{1,61}]',0,0,0,0,'[{1,13221},{3,6611}]','[]',0,0,3,0),(1001040942,'守护光炮','9阶红2星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001040900,4,300,0,4,0,0,0,'[{1,100}]',0,0,0,0,'[{1,13221},{3,6611}]','[]',0,0,3,0),(1001040943,'守护光炮','9阶红3星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001040900,4,300,0,4,0,0,0,'[{1,530}]',0,0,0,0,'[{1,13221},{3,6611}]','[]',0,0,3,0),(1001040953,'守护光炮','9阶粉色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001040900,4,300,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,21154},{3,10577}]','[]',0,0,3,0),(1001040963,'守护光炮','9阶神装武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001040900,4,300,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,26443},{3,13221}]','[]',0,0,3,0),(1001041000,'信仰光炮','10阶绿色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001041000,4,355,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{1,3404},{3,1702}]','[]',0,0,4,0),(1001041010,'信仰光炮','10阶蓝色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001041000,4,355,0,1,0,0,0,'[{1,7}]',0,0,0,0,'[{1,5107},{3,2553}]','[]',0,0,4,0),(1001041020,'信仰光炮','10阶紫色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001041000,4,355,0,2,0,0,0,'[{1,13}]',0,0,0,0,'[{1,9294},{3,4647}]','[]',0,0,4,0),(1001041031,'信仰光炮','10阶橙1星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001041000,4,355,0,3,0,0,0,'[{1,18}]',0,0,0,0,'[{1,11337},{3,5668}]','[]',0,0,4,0),(1001041032,'信仰光炮','10阶橙2星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001041000,4,355,0,3,0,0,0,'[{1,22}]',0,0,0,0,'[{1,11337},{3,5668}]','[]',0,0,4,0),(1001041041,'信仰光炮','10阶红1星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001041000,4,355,0,4,0,0,0,'[{1,74}]',0,0,0,0,'[{1,17022},{3,8511}]','[]',0,0,4,0),(1001041042,'信仰光炮','10阶红2星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001041000,4,355,0,4,0,0,0,'[{1,125}]',0,0,0,0,'[{1,17022},{3,8511}]','[]',0,0,4,0),(1001041043,'信仰光炮','10阶红3星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001041000,4,355,0,4,0,0,0,'[{1,730}]',0,0,0,0,'[{1,17022},{3,8511}]','[]',0,0,4,0),(1001041053,'信仰光炮','10阶粉色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001041000,4,355,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,27235},{3,13618}]','[]',0,0,4,0),(1001041063,'信仰光炮','10阶神装武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001041000,4,355,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,34044},{3,17022}]','[]',0,0,4,0),(1001041100,'天行光炮','11阶绿色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001041100,4,400,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{1,4278},{3,2139}]','[]',0,0,4,0),(1001041110,'天行光炮','11阶蓝色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001041100,4,400,0,1,0,0,0,'[{1,8}]',0,0,0,0,'[{1,6417},{3,3208}]','[]',0,0,4,0),(1001041120,'天行光炮','11阶紫色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001041100,4,400,0,2,0,0,0,'[{1,15}]',0,0,0,0,'[{1,11678},{3,5839}]','[]',0,0,4,0),(1001041131,'天行光炮','11阶橙1星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001041100,4,400,0,3,0,0,0,'[{1,20}]',0,0,0,0,'[{1,14245},{3,7122}]','[]',0,0,4,0),(1001041132,'天行光炮','11阶橙2星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001041100,4,400,0,3,0,0,0,'[{1,25}]',0,0,0,0,'[{1,14245},{3,7122}]','[]',0,0,4,0),(1001041141,'天行光炮','11阶红1星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001041100,4,400,0,4,0,0,0,'[{1,84}]',0,0,0,0,'[{1,21389},{3,10694}]','[]',0,0,4,0),(1001041142,'天行光炮','11阶红2星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001041100,4,400,0,4,0,0,0,'[{1,142}]',0,0,0,0,'[{1,21389},{3,10694}]','[]',0,0,4,0),(1001041143,'天行光炮','11阶红3星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001041100,4,400,0,4,0,0,0,'[{1,1005}]',0,0,0,0,'[{1,21389},{3,10694}]','[]',0,0,4,0),(1001041153,'天行光炮','11阶粉色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001041100,4,400,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,34222},{3,17111}]','[]',0,0,4,0),(1001041163,'天行光炮','11阶神装武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001041100,4,400,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,42777},{3,21389}]','[]',0,0,4,0),(1001041200,'命运光炮','12阶绿色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001041200,4,500,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{1,5269},{3,2635}]','[]',0,0,5,0),(1001041210,'命运光炮','12阶蓝色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001041200,4,500,0,1,0,0,0,'[{1,8}]',0,0,0,0,'[{1,7904},{3,3952}]','[]',0,0,5,0),(1001041220,'命运光炮','12阶紫色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001041200,4,500,0,2,0,0,0,'[{1,16}]',0,0,0,0,'[{1,14384},{3,7192}]','[]',0,0,5,0),(1001041231,'命运光炮','12阶橙1星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001041200,4,500,0,3,0,0,0,'[{1,22}]',0,0,0,0,'[{1,17546},{3,8773}]','[]',0,0,5,0),(1001041232,'命运光炮','12阶橙2星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001041200,4,500,0,3,0,0,0,'[{1,27}]',0,0,0,0,'[{1,17546},{3,8773}]','[]',0,0,5,0),(1001041241,'命运光炮','12阶红1星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001041200,4,500,0,4,0,0,0,'[{1,114}]',0,0,0,0,'[{1,26345},{3,13173}]','[]',0,0,5,0),(1001041242,'命运光炮','12阶红2星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001041200,4,500,0,4,0,0,0,'[{1,200}]',0,0,0,0,'[{1,26345},{3,13173}]','[]',0,0,5,0),(1001041243,'命运光炮','12阶红3星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001041200,4,500,0,4,0,0,0,'[{1,1464}]',0,0,0,0,'[{1,26345},{3,13173}]','[]',0,0,5,0),(1001041253,'命运光炮','12阶粉色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001041200,4,500,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,42152},{3,21076}]','[]',0,0,5,0),(1001041263,'命运光炮','12阶神装武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001041200,4,500,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,52690},{3,26345}]','[]',0,0,5,0),(1001041300,'制裁光炮','13阶绿色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001041300,4,520,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{1,6383},{3,3192}]','[]',0,0,5,0),(1001041310,'制裁光炮','13阶蓝色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001041300,4,520,0,1,0,0,0,'[{1,9}]',0,0,0,0,'[{1,9575},{3,4787}]','[]',0,0,5,0),(1001041320,'制裁光炮','13阶紫色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001041300,4,520,0,2,0,0,0,'[{1,18}]',0,0,0,0,'[{1,17426},{3,8713}]','[]',0,0,5,0),(1001041331,'制裁光炮','13阶橙1星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001041300,4,520,0,3,0,0,0,'[{1,24}]',0,0,0,0,'[{1,21256},{3,10628}]','[]',0,0,5,0),(1001041332,'制裁光炮','13阶橙2星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001041300,4,520,0,3,0,0,0,'[{1,30}]',0,0,0,0,'[{1,21256},{3,10628}]','[]',0,0,5,0),(1001041341,'制裁光炮','13阶红1星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001041300,4,520,0,4,0,0,0,'[{1,132}]',0,0,0,0,'[{1,31916},{3,15958}]','[]',0,0,5,0),(1001041342,'制裁光炮','13阶红2星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001041300,4,520,0,4,0,0,0,'[{1,234}]',0,0,0,0,'[{1,31916},{3,15958}]','[]',0,0,5,0),(1001041343,'制裁光炮','13阶红3星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001041300,4,520,0,4,0,0,0,'[{1,2047}]',0,0,0,0,'[{1,31916},{3,15958}]','[]',0,0,5,0),(1001041353,'制裁光炮','13阶粉色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001041300,4,520,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,51066},{3,25533}]','[]',0,0,5,0),(1001041363,'制裁光炮','13阶神装武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001041300,4,520,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,63832},{3,31916}]','[]',0,0,5,0),(1001041400,'审判光炮','14阶绿色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001041400,4,620,0,0,0,0,0,'[{1,4}]',0,0,0,0,'[{1,7625},{3,3813}]','[]',0,0,6,0),(1001041410,'审判光炮','14阶蓝色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001041400,4,620,0,1,0,0,0,'[{1,10}]',0,0,0,0,'[{1,11438},{3,5719}]','[]',0,0,6,0),(1001041420,'审判光炮','14阶紫色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001041400,4,620,0,2,0,0,0,'[{1,20}]',0,0,0,0,'[{1,20817},{3,10408}]','[]',0,0,6,0),(1001041431,'审判光炮','14阶橙1星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001041400,4,620,0,3,0,0,0,'[{1,27}]',0,0,0,0,'[{1,25392},{3,12696}]','[]',0,0,6,0),(1001041432,'审判光炮','14阶橙2星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001041400,4,620,0,3,0,0,0,'[{1,34}]',0,0,0,0,'[{1,25392},{3,12696}]','[]',0,0,6,0),(1001041441,'审判光炮','14阶红1星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001041400,4,620,0,4,0,0,0,'[{1,150}]',0,0,0,0,'[{1,38126},{3,19063}]','[]',0,0,6,0),(1001041442,'审判光炮','14阶红2星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001041400,4,620,0,4,0,0,0,'[{1,267}]',0,0,0,0,'[{1,38126},{3,19063}]','[]',0,0,6,0),(1001041443,'审判光炮','14阶红3星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001041400,4,620,0,4,0,0,0,'[{1,2647}]',0,0,0,0,'[{1,38126},{3,19063}]','[]',0,0,6,0),(1001041453,'审判光炮','14阶粉色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001041400,4,620,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,61002},{3,30501}]','[]',0,0,6,0),(1001041463,'审判光炮','14阶神装武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001041400,4,620,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,76253},{3,38126}]','[]',0,0,6,0),(1001041500,'毁灭光炮','15阶绿色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001041500,4,650,0,0,0,0,0,'[{1,4}]',0,0,0,0,'[{1,9000},{3,4500}]','[]',0,0,6,0),(1001041510,'毁灭光炮','15阶蓝色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001041500,4,650,0,1,0,0,0,'[{1,11}]',0,0,0,0,'[{1,13500},{3,6750}]','[]',0,0,6,0),(1001041520,'毁灭光炮','15阶紫色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001041500,4,650,0,2,0,0,0,'[{1,22}]',0,0,0,0,'[{1,24570},{3,12285}]','[]',0,0,6,0),(1001041531,'毁灭光炮','15阶橙1星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001041500,4,650,0,3,0,0,0,'[{1,30}]',0,0,0,0,'[{1,29970},{3,14985}]','[]',0,0,6,0),(1001041532,'毁灭光炮','15阶橙2星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001041500,4,650,0,3,0,0,0,'[{1,37}]',0,0,0,0,'[{1,29970},{3,14985}]','[]',0,0,6,0),(1001041541,'毁灭光炮','15阶红1星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001041500,4,650,0,4,0,0,0,'[{1,169}]',0,0,0,0,'[{1,45000},{3,22500}]','[]',0,0,6,0),(1001041542,'毁灭光炮','15阶红2星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001041500,4,650,0,4,0,0,0,'[{1,300}]',0,0,0,0,'[{1,45000},{3,22500}]','[]',0,0,6,0),(1001041543,'毁灭光炮','15阶红3星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001041500,4,650,0,4,0,0,0,'[{1,3147}]',0,0,0,0,'[{1,45000},{3,22500}]','[]',0,0,6,0),(1001041553,'毁灭光炮','15阶粉色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001041500,4,650,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,72000},{3,36000}]','[]',0,0,6,0),(1001041563,'毁灭光炮','15阶神装武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001041500,4,650,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,90000},{3,45000}]','[]',0,0,6,0),(1001041600,'混沌光炮','16阶绿色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001041500,4,700,0,0,0,0,0,'[{1,5}]',0,0,0,0,'[{1,10512},{3,5256}]','[]',0,0,6,0),(1001041610,'混沌光炮','16阶蓝色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001041500,4,700,0,1,0,0,0,'[{1,13}]',0,0,0,0,'[{1,15768},{3,7884}]','[]',0,0,6,0),(1001041620,'混沌光炮','16阶紫色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001041500,4,700,0,2,0,0,0,'[{1,25}]',0,0,0,0,'[{1,28699},{3,14349}]','[]',0,0,6,0),(1001041631,'混沌光炮','16阶橙1星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001041500,4,700,0,3,0,0,0,'[{1,34}]',0,0,0,0,'[{1,35006},{3,17503}]','[]',0,0,6,0),(1001041632,'混沌光炮','16阶橙2星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001041500,4,700,0,3,0,0,0,'[{1,42}]',0,0,0,0,'[{1,35006},{3,17503}]','[]',0,0,6,0),(1001041641,'混沌光炮','16阶红1星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001041500,4,700,0,4,0,0,0,'[{1,205}]',0,0,0,0,'[{1,52562},{3,26281}]','[]',0,0,6,0),(1001041642,'混沌光炮','16阶红2星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001041500,4,700,0,4,0,0,0,'[{1,367}]',0,0,0,0,'[{1,52562},{3,26281}]','[]',0,0,6,0),(1001041643,'混沌光炮','16阶红3星武器【重炮手】','',0,'','',0,1,1,10,1,1,1,1,1001041500,4,700,0,4,0,0,0,'[{1,3747}]',0,0,0,0,'[{1,52562},{3,26281}]','[]',0,0,6,0),(1001041653,'混沌光炮','16阶粉色武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001041500,4,700,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,84099},{3,42049}]','[]',0,0,6,0),(1001041663,'混沌光炮','16阶神装武器【重炮手】','',0,'','',0,0,1,10,1,0,0,1,1001041500,4,700,0,6,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,105123},{3,52562}]','[]',0,0,6,0),(1002010100,'学徒战盔','1阶绿色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002010100,1,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,487},{4,12}]','[]',0,0,0,0),(1002010110,'学徒战盔','1阶蓝色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002010100,1,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,731},{4,18}]','[]',0,0,0,0),(1002010120,'学徒战盔','1阶紫色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002010100,1,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1330},{4,33}]','[]',0,0,0,0),(1002010131,'学徒战盔','1阶橙1星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002010100,1,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1622},{4,41}]','[]',0,0,0,0),(1002010132,'学徒战盔','1阶橙2星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002010100,1,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1622},{4,41}]','[]',0,0,0,0),(1002010141,'学徒战盔','1阶红1星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002010100,1,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{2,2435},{4,61}]','[]',0,0,0,0),(1002010142,'学徒战盔','1阶红2星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002010100,1,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{2,2435},{4,61}]','[]',0,0,0,0),(1002010143,'学徒战盔','1阶红3星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002010100,1,1,0,4,0,0,0,'[{1,7}]',0,0,0,0,'[{2,2435},{4,61}]','[]',0,0,0,0),(1002010153,'学徒战盔','1阶粉色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002010100,1,1,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,3896},{4,97}]','[]',0,0,0,0),(1002010163,'学徒战盔','1阶神装头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002010100,1,1,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,4870},{4,122}]','[]',0,0,0,0),(1002010200,'冒险战盔','2阶绿色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002010200,1,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,834},{4,21}]','[]',0,0,0,0),(1002010210,'冒险战盔','2阶蓝色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002010200,1,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1251},{4,31}]','[]',0,0,0,0),(1002010220,'冒险战盔','2阶紫色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002010200,1,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2277},{4,57}]','[]',0,0,0,0),(1002010231,'冒险战盔','2阶橙1星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002010200,1,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{2,2777},{4,69}]','[]',0,0,0,0),(1002010232,'冒险战盔','2阶橙2星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002010200,1,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{2,2777},{4,69}]','[]',0,0,0,0),(1002010241,'冒险战盔','2阶红1星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002010200,1,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{2,4170},{4,104}]','[]',0,0,0,0),(1002010242,'冒险战盔','2阶红2星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002010200,1,1,0,4,0,0,0,'[{1,4}]',0,0,0,0,'[{2,4170},{4,104}]','[]',0,0,0,0),(1002010243,'冒险战盔','2阶红3星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002010200,1,1,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,4170},{4,104}]','[]',0,0,0,0),(1002010253,'冒险战盔','2阶粉色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002010200,1,1,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,6671},{4,167}]','[]',0,0,0,0),(1002010263,'冒险战盔','2阶神装头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002010200,1,1,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,8339},{4,208}]','[]',0,0,0,0),(1002010300,'勇者战盔','3阶绿色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002010300,1,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1988},{4,50}]','[]',0,0,0,0),(1002010310,'勇者战盔','3阶蓝色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002010300,1,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2982},{4,75}]','[]',0,0,0,0),(1002010320,'勇者战盔','3阶紫色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002010300,1,1,0,2,0,0,0,'[{1,2}]',0,0,0,0,'[{2,5427},{4,136}]','[]',0,0,0,0),(1002010331,'勇者战盔','3阶橙1星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002010300,1,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6620},{4,166}]','[]',0,0,0,0),(1002010332,'勇者战盔','3阶橙2星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002010300,1,1,0,3,0,0,0,'[{1,3}]',0,0,0,0,'[{2,6620},{4,166}]','[]',0,0,0,0),(1002010341,'勇者战盔','3阶红1星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002010300,1,1,0,4,0,0,0,'[{1,4}]',0,0,0,0,'[{2,9940},{4,249}]','[]',0,0,0,0),(1002010342,'勇者战盔','3阶红2星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002010300,1,1,0,4,0,0,0,'[{1,6}]',0,0,0,0,'[{2,9940},{4,249}]','[]',0,0,0,0),(1002010343,'勇者战盔','3阶红3星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002010300,1,1,0,4,0,0,0,'[{1,18}]',0,0,0,0,'[{2,9940},{4,249}]','[]',0,0,0,0),(1002010353,'勇者战盔','3阶粉色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002010300,1,1,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,15904},{4,398}]','[]',0,0,0,0),(1002010363,'勇者战盔','3阶神装头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002010300,1,1,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,19881},{4,497}]','[]',0,0,0,0),(1002010400,'先驱战盔','4阶绿色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002010400,1,100,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,4003},{4,100}]','[]',0,0,0,0),(1002010410,'先驱战盔','4阶蓝色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002010400,1,100,0,1,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6004},{4,150}]','[]',0,0,0,0),(1002010420,'先驱战盔','4阶紫色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002010400,1,100,0,2,0,0,0,'[{1,4}]',0,0,0,0,'[{2,10928},{4,273}]','[]',0,0,0,0),(1002010431,'先驱战盔','4阶橙1星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002010400,1,100,0,3,0,0,0,'[{1,5}]',0,0,0,0,'[{2,13329},{4,333}]','[]',0,0,0,0),(1002010432,'先驱战盔','4阶橙2星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002010400,1,100,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,13329},{4,333}]','[]',0,0,0,0),(1002010441,'先驱战盔','4阶红1星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002010400,1,100,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1002010442,'先驱战盔','4阶红2星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002010400,1,100,0,4,0,0,0,'[{1,18}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1002010443,'先驱战盔','4阶红3星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002010400,1,100,0,4,0,0,0,'[{1,51}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1002010453,'先驱战盔','4阶粉色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002010400,1,100,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,32022},{4,801}]','[]',0,0,0,0),(1002010463,'先驱战盔','4阶神装头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002010400,1,100,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,40028},{4,1001}]','[]',0,0,0,0),(1002010500,'荣誉战盔','5阶绿色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002010500,1,150,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6932},{4,173}]','[]',0,0,1,0),(1002010510,'荣誉战盔','5阶蓝色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002010500,1,150,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,10397},{4,260}]','[]',0,0,1,0),(1002010520,'荣誉战盔','5阶紫色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002010500,1,150,0,2,0,0,0,'[{1,7}]',0,0,0,0,'[{2,18923},{4,473}]','[]',0,0,1,0),(1002010531,'荣誉战盔','5阶橙1星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002010500,1,150,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,1,0),(1002010532,'荣誉战盔','5阶橙2星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002010500,1,150,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,1,0),(1002010541,'荣誉战盔','5阶红1星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002010500,1,150,0,4,0,0,0,'[{1,21}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,1,0),(1002010542,'荣誉战盔','5阶红2星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002010500,1,150,0,4,0,0,0,'[{1,32}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,1,0),(1002010543,'荣誉战盔','5阶红3星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002010500,1,150,0,4,0,0,0,'[{1,95}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,1,0),(1002010553,'荣誉战盔','5阶粉色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002010500,1,150,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,55452},{4,1386}]','[]',0,0,1,0),(1002010563,'荣誉战盔','5阶神装头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002010500,1,150,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,69315},{4,1733}]','[]',0,0,1,0),(1002010600,'贤者战盔','6阶绿色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002010600,1,180,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,10828},{4,271}]','[]',0,0,1,0),(1002010610,'贤者战盔','6阶蓝色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002010600,1,180,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,16241},{4,406}]','[]',0,0,1,0),(1002010620,'贤者战盔','6阶紫色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002010600,1,180,0,2,0,0,0,'[{1,7}]',0,0,0,0,'[{2,29559},{4,739}]','[]',0,0,1,0),(1002010631,'贤者战盔','6阶橙1星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002010600,1,180,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{2,36056},{4,901}]','[]',0,0,1,0),(1002010632,'贤者战盔','6阶橙2星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002010600,1,180,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{2,36056},{4,901}]','[]',0,0,1,0),(1002010641,'贤者战盔','6阶红1星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002010600,1,180,0,4,0,0,0,'[{1,27}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,1,0),(1002010642,'贤者战盔','6阶红2星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002010600,1,180,0,4,0,0,0,'[{1,42}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,1,0),(1002010643,'贤者战盔','6阶红3星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002010600,1,180,0,4,0,0,0,'[{1,156}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,1,0),(1002010653,'贤者战盔','6阶粉色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002010600,1,180,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,86620},{4,2166}]','[]',0,0,1,0),(1002010663,'贤者战盔','6阶神装头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002010600,1,180,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,108276},{4,2707}]','[]',0,0,1,0),(1002010700,'征服战盔','7阶绿色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002010700,1,220,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,15744},{4,394}]','[]',0,0,2,0),(1002010710,'征服战盔','7阶蓝色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002010700,1,220,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,23616},{4,590}]','[]',0,0,2,0),(1002010720,'征服战盔','7阶紫色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002010700,1,220,0,2,0,0,0,'[{1,9}]',0,0,0,0,'[{2,42982},{4,1075}]','[]',0,0,2,0),(1002010731,'征服战盔','7阶橙1星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002010700,1,220,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{2,52429},{4,1311}]','[]',0,0,2,0),(1002010732,'征服战盔','7阶橙2星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002010700,1,220,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{2,52429},{4,1311}]','[]',0,0,2,0),(1002010741,'征服战盔','7阶红1星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002010700,1,220,0,4,0,0,0,'[{1,38}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,2,0),(1002010742,'征服战盔','7阶红2星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002010700,1,220,0,4,0,0,0,'[{1,62}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,2,0),(1002010743,'征服战盔','7阶红3星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002010700,1,220,0,4,0,0,0,'[{1,223}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,2,0),(1002010753,'征服战盔','7阶粉色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002010700,1,220,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,125955},{4,3149}]','[]',0,0,2,0),(1002010763,'征服战盔','7阶神装头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002010700,1,220,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,157443},{4,3936}]','[]',0,0,2,0),(1002010800,'秩序战盔','8阶绿色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002010800,1,260,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,21735},{4,543}]','[]',0,0,2,0),(1002010810,'秩序战盔','8阶蓝色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002010800,1,260,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,32603},{4,815}]','[]',0,0,2,0),(1002010820,'秩序战盔','8阶紫色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002010800,1,260,0,2,0,0,0,'[{1,10}]',0,0,0,0,'[{2,59337},{4,1483}]','[]',0,0,2,0),(1002010831,'秩序战盔','8阶橙1星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002010800,1,260,0,3,0,0,0,'[{1,13}]',0,0,0,0,'[{2,72378},{4,1809}]','[]',0,0,2,0),(1002010832,'秩序战盔','8阶橙2星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002010800,1,260,0,3,0,0,0,'[{1,16}]',0,0,0,0,'[{2,72378},{4,1809}]','[]',0,0,2,0),(1002010841,'秩序战盔','8阶红1星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002010800,1,260,0,4,0,0,0,'[{1,42}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,2,0),(1002010842,'秩序战盔','8阶红2星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002010800,1,260,0,4,0,0,0,'[{1,69}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,2,0),(1002010843,'秩序战盔','8阶红3星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002010800,1,260,0,4,0,0,0,'[{1,311}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,2,0),(1002010853,'秩序战盔','8阶粉色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002010800,1,260,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,173881},{4,4347}]','[]',0,0,2,0),(1002010863,'秩序战盔','8阶神装头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002010800,1,260,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,217352},{4,5434}]','[]',0,0,2,0),(1002010900,'守护战盔','9阶绿色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002010900,1,300,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,28847},{4,721}]','[]',0,0,3,0),(1002010910,'守护战盔','9阶蓝色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002010900,1,300,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{2,43270},{4,1082}]','[]',0,0,3,0),(1002010920,'守护战盔','9阶紫色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002010900,1,300,0,2,0,0,0,'[{1,11}]',0,0,0,0,'[{2,78752},{4,1969}]','[]',0,0,3,0),(1002010931,'守护战盔','9阶橙1星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002010900,1,300,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{2,96060},{4,2401}]','[]',0,0,3,0),(1002010932,'守护战盔','9阶橙2星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002010900,1,300,0,3,0,0,0,'[{1,18}]',0,0,0,0,'[{2,96060},{4,2401}]','[]',0,0,3,0),(1002010941,'守护战盔','9阶红1星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002010900,1,300,0,4,0,0,0,'[{1,50}]',0,0,0,0,'[{2,144234},{4,3606}]','[]',0,0,3,0),(1002010942,'守护战盔','9阶红2星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002010900,1,300,0,4,0,0,0,'[{1,82}]',0,0,0,0,'[{2,144234},{4,3606}]','[]',0,0,3,0),(1002010943,'守护战盔','9阶红3星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002010900,1,300,0,4,0,0,0,'[{1,434}]',0,0,0,0,'[{2,144234},{4,3606}]','[]',0,0,3,0),(1002010953,'守护战盔','9阶粉色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002010900,1,300,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,230774},{4,5769}]','[]',0,0,3,0),(1002010963,'守护战盔','9阶神装头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002010900,1,300,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,288468},{4,7212}]','[]',0,0,3,0),(1002011000,'信仰战盔','10阶绿色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002011000,1,355,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,37139},{4,928}]','[]',0,0,4,0),(1002011010,'信仰战盔','10阶蓝色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002011000,1,355,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{2,55709},{4,1393}]','[]',0,0,4,0),(1002011020,'信仰战盔','10阶紫色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002011000,1,355,0,2,0,0,0,'[{1,11}]',0,0,0,0,'[{2,101390},{4,2535}]','[]',0,0,4,0),(1002011031,'信仰战盔','10阶橙1星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002011000,1,355,0,3,0,0,0,'[{1,15}]',0,0,0,0,'[{2,123674},{4,3092}]','[]',0,0,4,0),(1002011032,'信仰战盔','10阶橙2星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002011000,1,355,0,3,0,0,0,'[{1,18}]',0,0,0,0,'[{2,123674},{4,3092}]','[]',0,0,4,0),(1002011041,'信仰战盔','10阶红1星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002011000,1,355,0,4,0,0,0,'[{1,60}]',0,0,0,0,'[{2,185696},{4,4642}]','[]',0,0,4,0),(1002011042,'信仰战盔','10阶红2星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002011000,1,355,0,4,0,0,0,'[{1,103}]',0,0,0,0,'[{2,185696},{4,4642}]','[]',0,0,4,0),(1002011043,'信仰战盔','10阶红3星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002011000,1,355,0,4,0,0,0,'[{1,598}]',0,0,0,0,'[{2,185696},{4,4642}]','[]',0,0,4,0),(1002011053,'信仰战盔','10阶粉色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002011000,1,355,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,297114},{4,7428}]','[]',0,0,4,0),(1002011063,'信仰战盔','10阶神装头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002011000,1,355,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,371392},{4,9285}]','[]',0,0,4,0),(1002011100,'天行战盔','11阶绿色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002011100,1,400,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{2,46666},{4,1167}]','[]',0,0,4,0),(1002011110,'天行战盔','11阶蓝色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002011100,1,400,0,1,0,0,0,'[{1,7}]',0,0,0,0,'[{2,69999},{4,1750}]','[]',0,0,4,0),(1002011120,'天行战盔','11阶紫色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002011100,1,400,0,2,0,0,0,'[{1,13}]',0,0,0,0,'[{2,127398},{4,3185}]','[]',0,0,4,0),(1002011131,'天行战盔','11阶橙1星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002011100,1,400,0,3,0,0,0,'[{1,17}]',0,0,0,0,'[{2,155397},{4,3885}]','[]',0,0,4,0),(1002011132,'天行战盔','11阶橙2星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002011100,1,400,0,3,0,0,0,'[{1,21}]',0,0,0,0,'[{2,155397},{4,3885}]','[]',0,0,4,0),(1002011141,'天行战盔','11阶红1星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002011100,1,400,0,4,0,0,0,'[{1,69}]',0,0,0,0,'[{2,233329},{4,5833}]','[]',0,0,4,0),(1002011142,'天行战盔','11阶红2星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002011100,1,400,0,4,0,0,0,'[{1,116}]',0,0,0,0,'[{2,233329},{4,5833}]','[]',0,0,4,0),(1002011143,'天行战盔','11阶红3星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002011100,1,400,0,4,0,0,0,'[{1,823}]',0,0,0,0,'[{2,233329},{4,5833}]','[]',0,0,4,0),(1002011153,'天行战盔','11阶粉色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002011100,1,400,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,373327},{4,9333}]','[]',0,0,4,0),(1002011163,'天行战盔','11阶神装头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002011100,1,400,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,466659},{4,11666}]','[]',0,0,4,0),(1002011200,'命运战盔','12阶绿色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002011200,1,500,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{2,57480},{4,1437}]','[]',0,0,5,0),(1002011210,'命运战盔','12阶蓝色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002011200,1,500,0,1,0,0,0,'[{1,7}]',0,0,0,0,'[{2,86220},{4,2156}]','[]',0,0,5,0),(1002011220,'命运战盔','12阶紫色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002011200,1,500,0,2,0,0,0,'[{1,14}]',0,0,0,0,'[{2,156921},{4,3923}]','[]',0,0,5,0),(1002011231,'命运战盔','12阶橙1星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002011200,1,500,0,3,0,0,0,'[{1,18}]',0,0,0,0,'[{2,191409},{4,4785}]','[]',0,0,5,0),(1002011232,'命运战盔','12阶橙2星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002011200,1,500,0,3,0,0,0,'[{1,22}]',0,0,0,0,'[{2,191409},{4,4785}]','[]',0,0,5,0),(1002011241,'命运战盔','12阶红1星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002011200,1,500,0,4,0,0,0,'[{1,93}]',0,0,0,0,'[{2,287400},{4,7185}]','[]',0,0,5,0),(1002011242,'命运战盔','12阶红2星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002011200,1,500,0,4,0,0,0,'[{1,164}]',0,0,0,0,'[{2,287400},{4,7185}]','[]',0,0,5,0),(1002011243,'命运战盔','12阶红3星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002011200,1,500,0,4,0,0,0,'[{1,1198}]',0,0,0,0,'[{2,287400},{4,7185}]','[]',0,0,5,0),(1002011253,'命运战盔','12阶粉色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002011200,1,500,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,459841},{4,11496}]','[]',0,0,5,0),(1002011263,'命运战盔','12阶神装头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002011200,1,500,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,574801},{4,14370}]','[]',0,0,5,0),(1002011300,'制裁战盔','13阶绿色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002011300,1,520,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{2,69635},{4,1741}]','[]',0,0,5,0),(1002011310,'制裁战盔','13阶蓝色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002011300,1,520,0,1,0,0,0,'[{1,8}]',0,0,0,0,'[{2,104453},{4,2611}]','[]',0,0,5,0),(1002011320,'制裁战盔','13阶紫色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002011300,1,520,0,2,0,0,0,'[{1,15}]',0,0,0,0,'[{2,190104},{4,4753}]','[]',0,0,5,0),(1002011331,'制裁战盔','13阶橙1星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002011300,1,520,0,3,0,0,0,'[{1,20}]',0,0,0,0,'[{2,231885},{4,5797}]','[]',0,0,5,0),(1002011332,'制裁战盔','13阶橙2星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002011300,1,520,0,3,0,0,0,'[{1,25}]',0,0,0,0,'[{2,231885},{4,5797}]','[]',0,0,5,0),(1002011341,'制裁战盔','13阶红1星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002011300,1,520,0,4,0,0,0,'[{1,108}]',0,0,0,0,'[{2,348176},{4,8704}]','[]',0,0,5,0),(1002011342,'制裁战盔','13阶红2星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002011300,1,520,0,4,0,0,0,'[{1,191}]',0,0,0,0,'[{2,348176},{4,8704}]','[]',0,0,5,0),(1002011343,'制裁战盔','13阶红3星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002011300,1,520,0,4,0,0,0,'[{1,1675}]',0,0,0,0,'[{2,348176},{4,8704}]','[]',0,0,5,0),(1002011353,'制裁战盔','13阶粉色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002011300,1,520,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,557082},{4,13927}]','[]',0,0,5,0),(1002011363,'制裁战盔','13阶神装头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002011300,1,520,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,696352},{4,17409}]','[]',0,0,5,0),(1002011400,'审判战盔','14阶绿色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002011400,1,620,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{2,83185},{4,2080}]','[]',0,0,6,0),(1002011410,'审判战盔','14阶蓝色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002011400,1,620,0,1,0,0,0,'[{1,9}]',0,0,0,0,'[{2,124777},{4,3119}]','[]',0,0,6,0),(1002011420,'审判战盔','14阶紫色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002011400,1,620,0,2,0,0,0,'[{1,17}]',0,0,0,0,'[{2,227094},{4,5677}]','[]',0,0,6,0),(1002011431,'审判战盔','14阶橙1星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002011400,1,620,0,3,0,0,0,'[{1,22}]',0,0,0,0,'[{2,277005},{4,6925}]','[]',0,0,6,0),(1002011432,'审判战盔','14阶橙2星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002011400,1,620,0,3,0,0,0,'[{1,28}]',0,0,0,0,'[{2,277005},{4,6925}]','[]',0,0,6,0),(1002011441,'审判战盔','14阶红1星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002011400,1,620,0,4,0,0,0,'[{1,123}]',0,0,0,0,'[{2,415923},{4,10398}]','[]',0,0,6,0),(1002011442,'审判战盔','14阶红2星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002011400,1,620,0,4,0,0,0,'[{1,219}]',0,0,0,0,'[{2,415923},{4,10398}]','[]',0,0,6,0),(1002011443,'审判战盔','14阶红3星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002011400,1,620,0,4,0,0,0,'[{1,2166}]',0,0,0,0,'[{2,415923},{4,10398}]','[]',0,0,6,0),(1002011453,'审判战盔','14阶粉色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002011400,1,620,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,665478},{4,16637}]','[]',0,0,6,0),(1002011463,'审判战盔','14阶神装头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002011400,1,620,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,831847},{4,20796}]','[]',0,0,6,0),(1002011500,'毁灭战盔','15阶绿色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002011500,1,650,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{2,98182},{4,2455}]','[]',0,0,6,0),(1002011510,'毁灭战盔','15阶蓝色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002011500,1,650,0,1,0,0,0,'[{1,9}]',0,0,0,0,'[{2,147273},{4,3682}]','[]',0,0,6,0),(1002011520,'毁灭战盔','15阶紫色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002011500,1,650,0,2,0,0,0,'[{1,18}]',0,0,0,0,'[{2,268036},{4,6701}]','[]',0,0,6,0),(1002011531,'毁灭战盔','15阶橙1星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002011500,1,650,0,3,0,0,0,'[{1,24}]',0,0,0,0,'[{2,326945},{4,8174}]','[]',0,0,6,0),(1002011532,'毁灭战盔','15阶橙2星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002011500,1,650,0,3,0,0,0,'[{1,30}]',0,0,0,0,'[{2,326945},{4,8174}]','[]',0,0,6,0),(1002011541,'毁灭战盔','15阶红1星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002011500,1,650,0,4,0,0,0,'[{1,138}]',0,0,0,0,'[{2,490909},{4,12273}]','[]',0,0,6,0),(1002011542,'毁灭战盔','15阶红2星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002011500,1,650,0,4,0,0,0,'[{1,246}]',0,0,0,0,'[{2,490909},{4,12273}]','[]',0,0,6,0),(1002011543,'毁灭战盔','15阶红3星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002011500,1,650,0,4,0,0,0,'[{1,2575}]',0,0,0,0,'[{2,490909},{4,12273}]','[]',0,0,6,0),(1002011553,'毁灭战盔','15阶粉色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002011500,1,650,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,785455},{4,19636}]','[]',0,0,6,0),(1002011563,'毁灭战盔','15阶神装头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002011500,1,650,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,981818},{4,24545}]','[]',0,0,6,0),(1002011600,'混沌战盔','16阶绿色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002011500,1,700,0,0,0,0,0,'[{1,4}]',0,0,0,0,'[{2,114680},{4,2867}]','[]',0,0,6,0),(1002011610,'混沌战盔','16阶蓝色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002011500,1,700,0,1,0,0,0,'[{1,11}]',0,0,0,0,'[{2,172020},{4,4300}]','[]',0,0,6,0),(1002011620,'混沌战盔','16阶紫色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002011500,1,700,0,2,0,0,0,'[{1,21}]',0,0,0,0,'[{2,313076},{4,7827}]','[]',0,0,6,0),(1002011631,'混沌战盔','16阶橙1星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002011500,1,700,0,3,0,0,0,'[{1,28}]',0,0,0,0,'[{2,381884},{4,9547}]','[]',0,0,6,0),(1002011632,'混沌战盔','16阶橙2星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002011500,1,700,0,3,0,0,0,'[{1,35}]',0,0,0,0,'[{2,381884},{4,9547}]','[]',0,0,6,0),(1002011641,'混沌战盔','16阶红1星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002011500,1,700,0,4,0,0,0,'[{1,168}]',0,0,0,0,'[{2,573400},{4,14335}]','[]',0,0,6,0),(1002011642,'混沌战盔','16阶红2星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002011500,1,700,0,4,0,0,0,'[{1,300}]',0,0,0,0,'[{2,573400},{4,14335}]','[]',0,0,6,0),(1002011643,'混沌战盔','16阶红3星头盔【魔剑士】','',0,'','',0,1,1,10,2,1,2,2,1002011500,1,700,0,4,0,0,0,'[{1,3066}]',0,0,0,0,'[{2,573400},{4,14335}]','[]',0,0,6,0),(1002011653,'混沌战盔','16阶粉色头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002011500,1,700,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,917440},{4,22936}]','[]',0,0,6,0),(1002011663,'混沌战盔','16阶神装头盔【魔剑士】','',0,'','',0,0,1,10,2,0,0,2,1002011500,1,700,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,1146800},{4,28670}]','[]',0,0,6,0),(1002020100,'学徒头盔','1阶绿色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002020100,2,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,487},{4,12}]','[]',0,0,0,0),(1002020110,'学徒头盔','1阶蓝色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002020100,2,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,731},{4,18}]','[]',0,0,0,0),(1002020120,'学徒头盔','1阶紫色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002020100,2,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1330},{4,33}]','[]',0,0,0,0),(1002020131,'学徒头盔','1阶橙1星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002020100,2,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1622},{4,41}]','[]',0,0,0,0),(1002020132,'学徒头盔','1阶橙2星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002020100,2,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1622},{4,41}]','[]',0,0,0,0),(1002020141,'学徒头盔','1阶红1星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002020100,2,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{2,2435},{4,61}]','[]',0,0,0,0),(1002020142,'学徒头盔','1阶红2星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002020100,2,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{2,2435},{4,61}]','[]',0,0,0,0),(1002020143,'学徒头盔','1阶红3星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002020100,2,1,0,4,0,0,0,'[{1,7}]',0,0,0,0,'[{2,2435},{4,61}]','[]',0,0,0,0),(1002020153,'学徒头盔','1阶粉色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002020100,2,1,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,3896},{4,97}]','[]',0,0,0,0),(1002020163,'学徒头盔','1阶神装头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002020100,2,1,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,4870},{4,122}]','[]',0,0,0,0),(1002020200,'冒险头盔','2阶绿色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002020200,2,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,834},{4,21}]','[]',0,0,0,0),(1002020210,'冒险头盔','2阶蓝色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002020200,2,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1251},{4,31}]','[]',0,0,0,0),(1002020220,'冒险头盔','2阶紫色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002020200,2,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2277},{4,57}]','[]',0,0,0,0),(1002020231,'冒险头盔','2阶橙1星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002020200,2,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{2,2777},{4,69}]','[]',0,0,0,0),(1002020232,'冒险头盔','2阶橙2星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002020200,2,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{2,2777},{4,69}]','[]',0,0,0,0),(1002020241,'冒险头盔','2阶红1星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002020200,2,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{2,4170},{4,104}]','[]',0,0,0,0),(1002020242,'冒险头盔','2阶红2星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002020200,2,1,0,4,0,0,0,'[{1,4}]',0,0,0,0,'[{2,4170},{4,104}]','[]',0,0,0,0),(1002020243,'冒险头盔','2阶红3星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002020200,2,1,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,4170},{4,104}]','[]',0,0,0,0),(1002020253,'冒险头盔','2阶粉色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002020200,2,1,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,6671},{4,167}]','[]',0,0,0,0),(1002020263,'冒险头盔','2阶神装头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002020200,2,1,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,8339},{4,208}]','[]',0,0,0,0),(1002020300,'勇者头盔','3阶绿色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002020300,2,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1988},{4,50}]','[]',0,0,0,0),(1002020310,'勇者头盔','3阶蓝色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002020300,2,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2982},{4,75}]','[]',0,0,0,0),(1002020320,'勇者头盔','3阶紫色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002020300,2,1,0,2,0,0,0,'[{1,2}]',0,0,0,0,'[{2,5427},{4,136}]','[]',0,0,0,0),(1002020331,'勇者头盔','3阶橙1星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002020300,2,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6620},{4,166}]','[]',0,0,0,0),(1002020332,'勇者头盔','3阶橙2星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002020300,2,1,0,3,0,0,0,'[{1,3}]',0,0,0,0,'[{2,6620},{4,166}]','[]',0,0,0,0),(1002020341,'勇者头盔','3阶红1星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002020300,2,1,0,4,0,0,0,'[{1,4}]',0,0,0,0,'[{2,9940},{4,249}]','[]',0,0,0,0),(1002020342,'勇者头盔','3阶红2星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002020300,2,1,0,4,0,0,0,'[{1,6}]',0,0,0,0,'[{2,9940},{4,249}]','[]',0,0,0,0),(1002020343,'勇者头盔','3阶红3星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002020300,2,1,0,4,0,0,0,'[{1,18}]',0,0,0,0,'[{2,9940},{4,249}]','[]',0,0,0,0),(1002020353,'勇者头盔','3阶粉色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002020300,2,1,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,15904},{4,398}]','[]',0,0,0,0),(1002020363,'勇者头盔','3阶神装头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002020300,2,1,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,19881},{4,497}]','[]',0,0,0,0),(1002020400,'先驱头盔','4阶绿色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002020400,2,100,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,4003},{4,100}]','[]',0,0,0,0),(1002020410,'先驱头盔','4阶蓝色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002020400,2,100,0,1,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6004},{4,150}]','[]',0,0,0,0),(1002020420,'先驱头盔','4阶紫色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002020400,2,100,0,2,0,0,0,'[{1,4}]',0,0,0,0,'[{2,10928},{4,273}]','[]',0,0,0,0),(1002020431,'先驱头盔','4阶橙1星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002020400,2,100,0,3,0,0,0,'[{1,5}]',0,0,0,0,'[{2,13329},{4,333}]','[]',0,0,0,0),(1002020432,'先驱头盔','4阶橙2星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002020400,2,100,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,13329},{4,333}]','[]',0,0,0,0),(1002020441,'先驱头盔','4阶红1星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002020400,2,100,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1002020442,'先驱头盔','4阶红2星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002020400,2,100,0,4,0,0,0,'[{1,18}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1002020443,'先驱头盔','4阶红3星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002020400,2,100,0,4,0,0,0,'[{1,51}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1002020453,'先驱头盔','4阶粉色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002020400,2,100,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,32022},{4,801}]','[]',0,0,0,0),(1002020463,'先驱头盔','4阶神装头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002020400,2,100,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,40028},{4,1001}]','[]',0,0,0,0),(1002020500,'荣誉头盔','5阶绿色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002020500,2,150,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6932},{4,173}]','[]',0,0,1,0),(1002020510,'荣誉头盔','5阶蓝色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002020500,2,150,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,10397},{4,260}]','[]',0,0,1,0),(1002020520,'荣誉头盔','5阶紫色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002020500,2,150,0,2,0,0,0,'[{1,7}]',0,0,0,0,'[{2,18923},{4,473}]','[]',0,0,1,0),(1002020531,'荣誉头盔','5阶橙1星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002020500,2,150,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,1,0),(1002020532,'荣誉头盔','5阶橙2星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002020500,2,150,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,1,0),(1002020541,'荣誉头盔','5阶红1星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002020500,2,150,0,4,0,0,0,'[{1,21}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,1,0),(1002020542,'荣誉头盔','5阶红2星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002020500,2,150,0,4,0,0,0,'[{1,32}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,1,0),(1002020543,'荣誉头盔','5阶红3星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002020500,2,150,0,4,0,0,0,'[{1,95}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,1,0),(1002020553,'荣誉头盔','5阶粉色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002020500,2,150,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,55452},{4,1386}]','[]',0,0,1,0),(1002020563,'荣誉头盔','5阶神装头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002020500,2,150,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,69315},{4,1733}]','[]',0,0,1,0),(1002020600,'贤者头盔','6阶绿色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002020600,2,180,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,10828},{4,271}]','[]',0,0,1,0),(1002020610,'贤者头盔','6阶蓝色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002020600,2,180,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,16241},{4,406}]','[]',0,0,1,0),(1002020620,'贤者头盔','6阶紫色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002020600,2,180,0,2,0,0,0,'[{1,7}]',0,0,0,0,'[{2,29559},{4,739}]','[]',0,0,1,0),(1002020631,'贤者头盔','6阶橙1星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002020600,2,180,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{2,36056},{4,901}]','[]',0,0,1,0),(1002020632,'贤者头盔','6阶橙2星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002020600,2,180,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{2,36056},{4,901}]','[]',0,0,1,0),(1002020641,'贤者头盔','6阶红1星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002020600,2,180,0,4,0,0,0,'[{1,27}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,1,0),(1002020642,'贤者头盔','6阶红2星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002020600,2,180,0,4,0,0,0,'[{1,42}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,1,0),(1002020643,'贤者头盔','6阶红3星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002020600,2,180,0,4,0,0,0,'[{1,156}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,1,0),(1002020653,'贤者头盔','6阶粉色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002020600,2,180,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,86620},{4,2166}]','[]',0,0,1,0),(1002020663,'贤者头盔','6阶神装头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002020600,2,180,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,108276},{4,2707}]','[]',0,0,1,0),(1002020700,'征服头盔','7阶绿色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002020700,2,220,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,15744},{4,394}]','[]',0,0,2,0),(1002020710,'征服头盔','7阶蓝色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002020700,2,220,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,23616},{4,590}]','[]',0,0,2,0),(1002020720,'征服头盔','7阶紫色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002020700,2,220,0,2,0,0,0,'[{1,9}]',0,0,0,0,'[{2,42982},{4,1075}]','[]',0,0,2,0),(1002020731,'征服头盔','7阶橙1星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002020700,2,220,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{2,52429},{4,1311}]','[]',0,0,2,0),(1002020732,'征服头盔','7阶橙2星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002020700,2,220,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{2,52429},{4,1311}]','[]',0,0,2,0),(1002020741,'征服头盔','7阶红1星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002020700,2,220,0,4,0,0,0,'[{1,38}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,2,0),(1002020742,'征服头盔','7阶红2星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002020700,2,220,0,4,0,0,0,'[{1,62}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,2,0),(1002020743,'征服头盔','7阶红3星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002020700,2,220,0,4,0,0,0,'[{1,223}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,2,0),(1002020753,'征服头盔','7阶粉色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002020700,2,220,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,125955},{4,3149}]','[]',0,0,2,0),(1002020763,'征服头盔','7阶神装头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002020700,2,220,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,157443},{4,3936}]','[]',0,0,2,0),(1002020800,'秩序头盔','8阶绿色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002020800,2,260,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,21735},{4,543}]','[]',0,0,2,0),(1002020810,'秩序头盔','8阶蓝色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002020800,2,260,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,32603},{4,815}]','[]',0,0,2,0),(1002020820,'秩序头盔','8阶紫色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002020800,2,260,0,2,0,0,0,'[{1,10}]',0,0,0,0,'[{2,59337},{4,1483}]','[]',0,0,2,0),(1002020831,'秩序头盔','8阶橙1星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002020800,2,260,0,3,0,0,0,'[{1,13}]',0,0,0,0,'[{2,72378},{4,1809}]','[]',0,0,2,0),(1002020832,'秩序头盔','8阶橙2星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002020800,2,260,0,3,0,0,0,'[{1,16}]',0,0,0,0,'[{2,72378},{4,1809}]','[]',0,0,2,0),(1002020841,'秩序头盔','8阶红1星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002020800,2,260,0,4,0,0,0,'[{1,42}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,2,0),(1002020842,'秩序头盔','8阶红2星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002020800,2,260,0,4,0,0,0,'[{1,69}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,2,0),(1002020843,'秩序头盔','8阶红3星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002020800,2,260,0,4,0,0,0,'[{1,311}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,2,0),(1002020853,'秩序头盔','8阶粉色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002020800,2,260,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,173881},{4,4347}]','[]',0,0,2,0),(1002020863,'秩序头盔','8阶神装头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002020800,2,260,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,217352},{4,5434}]','[]',0,0,2,0),(1002020900,'守护头盔','9阶绿色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002020900,2,300,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,28847},{4,721}]','[]',0,0,3,0),(1002020910,'守护头盔','9阶蓝色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002020900,2,300,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{2,43270},{4,1082}]','[]',0,0,3,0),(1002020920,'守护头盔','9阶紫色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002020900,2,300,0,2,0,0,0,'[{1,11}]',0,0,0,0,'[{2,78752},{4,1969}]','[]',0,0,3,0),(1002020931,'守护头盔','9阶橙1星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002020900,2,300,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{2,96060},{4,2401}]','[]',0,0,3,0),(1002020932,'守护头盔','9阶橙2星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002020900,2,300,0,3,0,0,0,'[{1,18}]',0,0,0,0,'[{2,96060},{4,2401}]','[]',0,0,3,0),(1002020941,'守护头盔','9阶红1星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002020900,2,300,0,4,0,0,0,'[{1,50}]',0,0,0,0,'[{2,144234},{4,3606}]','[]',0,0,3,0),(1002020942,'守护头盔','9阶红2星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002020900,2,300,0,4,0,0,0,'[{1,82}]',0,0,0,0,'[{2,144234},{4,3606}]','[]',0,0,3,0),(1002020943,'守护头盔','9阶红3星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002020900,2,300,0,4,0,0,0,'[{1,434}]',0,0,0,0,'[{2,144234},{4,3606}]','[]',0,0,3,0),(1002020953,'守护头盔','9阶粉色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002020900,2,300,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,230774},{4,5769}]','[]',0,0,3,0),(1002020963,'守护头盔','9阶神装头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002020900,2,300,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,288468},{4,7212}]','[]',0,0,3,0),(1002021000,'信仰头盔','10阶绿色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002021000,2,355,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,37139},{4,928}]','[]',0,0,4,0),(1002021010,'信仰头盔','10阶蓝色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002021000,2,355,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{2,55709},{4,1393}]','[]',0,0,4,0),(1002021020,'信仰头盔','10阶紫色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002021000,2,355,0,2,0,0,0,'[{1,11}]',0,0,0,0,'[{2,101390},{4,2535}]','[]',0,0,4,0),(1002021031,'信仰头盔','10阶橙1星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002021000,2,355,0,3,0,0,0,'[{1,15}]',0,0,0,0,'[{2,123674},{4,3092}]','[]',0,0,4,0),(1002021032,'信仰头盔','10阶橙2星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002021000,2,355,0,3,0,0,0,'[{1,18}]',0,0,0,0,'[{2,123674},{4,3092}]','[]',0,0,4,0),(1002021041,'信仰头盔','10阶红1星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002021000,2,355,0,4,0,0,0,'[{1,60}]',0,0,0,0,'[{2,185696},{4,4642}]','[]',0,0,4,0),(1002021042,'信仰头盔','10阶红2星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002021000,2,355,0,4,0,0,0,'[{1,103}]',0,0,0,0,'[{2,185696},{4,4642}]','[]',0,0,4,0),(1002021043,'信仰头盔','10阶红3星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002021000,2,355,0,4,0,0,0,'[{1,598}]',0,0,0,0,'[{2,185696},{4,4642}]','[]',0,0,4,0),(1002021053,'信仰头盔','10阶粉色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002021000,2,355,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,297114},{4,7428}]','[]',0,0,4,0),(1002021063,'信仰头盔','10阶神装头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002021000,2,355,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,371392},{4,9285}]','[]',0,0,4,0),(1002021100,'天行头盔','11阶绿色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002021100,2,400,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{2,46666},{4,1167}]','[]',0,0,4,0),(1002021110,'天行头盔','11阶蓝色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002021100,2,400,0,1,0,0,0,'[{1,7}]',0,0,0,0,'[{2,69999},{4,1750}]','[]',0,0,4,0),(1002021120,'天行头盔','11阶紫色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002021100,2,400,0,2,0,0,0,'[{1,13}]',0,0,0,0,'[{2,127398},{4,3185}]','[]',0,0,4,0),(1002021131,'天行头盔','11阶橙1星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002021100,2,400,0,3,0,0,0,'[{1,17}]',0,0,0,0,'[{2,155397},{4,3885}]','[]',0,0,4,0),(1002021132,'天行头盔','11阶橙2星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002021100,2,400,0,3,0,0,0,'[{1,21}]',0,0,0,0,'[{2,155397},{4,3885}]','[]',0,0,4,0),(1002021141,'天行头盔','11阶红1星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002021100,2,400,0,4,0,0,0,'[{1,69}]',0,0,0,0,'[{2,233329},{4,5833}]','[]',0,0,4,0),(1002021142,'天行头盔','11阶红2星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002021100,2,400,0,4,0,0,0,'[{1,116}]',0,0,0,0,'[{2,233329},{4,5833}]','[]',0,0,4,0),(1002021143,'天行头盔','11阶红3星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002021100,2,400,0,4,0,0,0,'[{1,823}]',0,0,0,0,'[{2,233329},{4,5833}]','[]',0,0,4,0),(1002021153,'天行头盔','11阶粉色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002021100,2,400,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,373327},{4,9333}]','[]',0,0,4,0),(1002021163,'天行头盔','11阶神装头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002021100,2,400,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,466659},{4,11666}]','[]',0,0,4,0),(1002021200,'命运头盔','12阶绿色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002021200,2,500,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{2,57480},{4,1437}]','[]',0,0,5,0),(1002021210,'命运头盔','12阶蓝色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002021200,2,500,0,1,0,0,0,'[{1,7}]',0,0,0,0,'[{2,86220},{4,2156}]','[]',0,0,5,0),(1002021220,'命运头盔','12阶紫色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002021200,2,500,0,2,0,0,0,'[{1,14}]',0,0,0,0,'[{2,156921},{4,3923}]','[]',0,0,5,0),(1002021231,'命运头盔','12阶橙1星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002021200,2,500,0,3,0,0,0,'[{1,18}]',0,0,0,0,'[{2,191409},{4,4785}]','[]',0,0,5,0),(1002021232,'命运头盔','12阶橙2星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002021200,2,500,0,3,0,0,0,'[{1,22}]',0,0,0,0,'[{2,191409},{4,4785}]','[]',0,0,5,0),(1002021241,'命运头盔','12阶红1星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002021200,2,500,0,4,0,0,0,'[{1,93}]',0,0,0,0,'[{2,287400},{4,7185}]','[]',0,0,5,0),(1002021242,'命运头盔','12阶红2星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002021200,2,500,0,4,0,0,0,'[{1,164}]',0,0,0,0,'[{2,287400},{4,7185}]','[]',0,0,5,0),(1002021243,'命运头盔','12阶红3星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002021200,2,500,0,4,0,0,0,'[{1,1198}]',0,0,0,0,'[{2,287400},{4,7185}]','[]',0,0,5,0),(1002021253,'命运头盔','12阶粉色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002021200,2,500,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,459841},{4,11496}]','[]',0,0,5,0),(1002021263,'命运头盔','12阶神装头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002021200,2,500,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,574801},{4,14370}]','[]',0,0,5,0),(1002021300,'制裁头盔','13阶绿色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002021300,2,520,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{2,69635},{4,1741}]','[]',0,0,5,0),(1002021310,'制裁头盔','13阶蓝色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002021300,2,520,0,1,0,0,0,'[{1,8}]',0,0,0,0,'[{2,104453},{4,2611}]','[]',0,0,5,0),(1002021320,'制裁头盔','13阶紫色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002021300,2,520,0,2,0,0,0,'[{1,15}]',0,0,0,0,'[{2,190104},{4,4753}]','[]',0,0,5,0),(1002021331,'制裁头盔','13阶橙1星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002021300,2,520,0,3,0,0,0,'[{1,20}]',0,0,0,0,'[{2,231885},{4,5797}]','[]',0,0,5,0),(1002021332,'制裁头盔','13阶橙2星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002021300,2,520,0,3,0,0,0,'[{1,25}]',0,0,0,0,'[{2,231885},{4,5797}]','[]',0,0,5,0),(1002021341,'制裁头盔','13阶红1星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002021300,2,520,0,4,0,0,0,'[{1,108}]',0,0,0,0,'[{2,348176},{4,8704}]','[]',0,0,5,0),(1002021342,'制裁头盔','13阶红2星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002021300,2,520,0,4,0,0,0,'[{1,191}]',0,0,0,0,'[{2,348176},{4,8704}]','[]',0,0,5,0),(1002021343,'制裁头盔','13阶红3星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002021300,2,520,0,4,0,0,0,'[{1,1675}]',0,0,0,0,'[{2,348176},{4,8704}]','[]',0,0,5,0),(1002021353,'制裁头盔','13阶粉色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002021300,2,520,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,557082},{4,13927}]','[]',0,0,5,0),(1002021363,'制裁头盔','13阶神装头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002021300,2,520,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,696352},{4,17409}]','[]',0,0,5,0),(1002021400,'审判头盔','14阶绿色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002021400,2,620,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{2,83185},{4,2080}]','[]',0,0,6,0),(1002021410,'审判头盔','14阶蓝色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002021400,2,620,0,1,0,0,0,'[{1,9}]',0,0,0,0,'[{2,124777},{4,3119}]','[]',0,0,6,0),(1002021420,'审判头盔','14阶紫色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002021400,2,620,0,2,0,0,0,'[{1,17}]',0,0,0,0,'[{2,227094},{4,5677}]','[]',0,0,6,0),(1002021431,'审判头盔','14阶橙1星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002021400,2,620,0,3,0,0,0,'[{1,22}]',0,0,0,0,'[{2,277005},{4,6925}]','[]',0,0,6,0),(1002021432,'审判头盔','14阶橙2星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002021400,2,620,0,3,0,0,0,'[{1,28}]',0,0,0,0,'[{2,277005},{4,6925}]','[]',0,0,6,0),(1002021441,'审判头盔','14阶红1星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002021400,2,620,0,4,0,0,0,'[{1,123}]',0,0,0,0,'[{2,415923},{4,10398}]','[]',0,0,6,0),(1002021442,'审判头盔','14阶红2星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002021400,2,620,0,4,0,0,0,'[{1,219}]',0,0,0,0,'[{2,415923},{4,10398}]','[]',0,0,6,0),(1002021443,'审判头盔','14阶红3星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002021400,2,620,0,4,0,0,0,'[{1,2166}]',0,0,0,0,'[{2,415923},{4,10398}]','[]',0,0,6,0),(1002021453,'审判头盔','14阶粉色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002021400,2,620,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,665478},{4,16637}]','[]',0,0,6,0),(1002021463,'审判头盔','14阶神装头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002021400,2,620,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,831847},{4,20796}]','[]',0,0,6,0),(1002021500,'毁灭头盔','15阶绿色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002021500,2,650,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{2,98182},{4,2455}]','[]',0,0,6,0),(1002021510,'毁灭头盔','15阶蓝色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002021500,2,650,0,1,0,0,0,'[{1,9}]',0,0,0,0,'[{2,147273},{4,3682}]','[]',0,0,6,0),(1002021520,'毁灭头盔','15阶紫色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002021500,2,650,0,2,0,0,0,'[{1,18}]',0,0,0,0,'[{2,268036},{4,6701}]','[]',0,0,6,0),(1002021531,'毁灭头盔','15阶橙1星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002021500,2,650,0,3,0,0,0,'[{1,24}]',0,0,0,0,'[{2,326945},{4,8174}]','[]',0,0,6,0),(1002021532,'毁灭头盔','15阶橙2星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002021500,2,650,0,3,0,0,0,'[{1,30}]',0,0,0,0,'[{2,326945},{4,8174}]','[]',0,0,6,0),(1002021541,'毁灭头盔','15阶红1星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002021500,2,650,0,4,0,0,0,'[{1,138}]',0,0,0,0,'[{2,490909},{4,12273}]','[]',0,0,6,0),(1002021542,'毁灭头盔','15阶红2星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002021500,2,650,0,4,0,0,0,'[{1,246}]',0,0,0,0,'[{2,490909},{4,12273}]','[]',0,0,6,0),(1002021543,'毁灭头盔','15阶红3星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002021500,2,650,0,4,0,0,0,'[{1,2575}]',0,0,0,0,'[{2,490909},{4,12273}]','[]',0,0,6,0),(1002021553,'毁灭头盔','15阶粉色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002021500,2,650,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,785455},{4,19636}]','[]',0,0,6,0),(1002021563,'毁灭头盔','15阶神装头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002021500,2,650,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,981818},{4,24545}]','[]',0,0,6,0),(1002021600,'混沌头盔','16阶绿色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002021500,2,700,0,0,0,0,0,'[{1,4}]',0,0,0,0,'[{2,114680},{4,2867}]','[]',0,0,6,0),(1002021610,'混沌头盔','16阶蓝色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002021500,2,700,0,1,0,0,0,'[{1,11}]',0,0,0,0,'[{2,172020},{4,4300}]','[]',0,0,6,0),(1002021620,'混沌头盔','16阶紫色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002021500,2,700,0,2,0,0,0,'[{1,21}]',0,0,0,0,'[{2,313076},{4,7827}]','[]',0,0,6,0),(1002021631,'混沌头盔','16阶橙1星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002021500,2,700,0,3,0,0,0,'[{1,28}]',0,0,0,0,'[{2,381884},{4,9547}]','[]',0,0,6,0),(1002021632,'混沌头盔','16阶橙2星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002021500,2,700,0,3,0,0,0,'[{1,35}]',0,0,0,0,'[{2,381884},{4,9547}]','[]',0,0,6,0),(1002021641,'混沌头盔','16阶红1星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002021500,2,700,0,4,0,0,0,'[{1,168}]',0,0,0,0,'[{2,573400},{4,14335}]','[]',0,0,6,0),(1002021642,'混沌头盔','16阶红2星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002021500,2,700,0,4,0,0,0,'[{1,300}]',0,0,0,0,'[{2,573400},{4,14335}]','[]',0,0,6,0),(1002021643,'混沌头盔','16阶红3星头盔【龙骑士】','',0,'','',0,1,1,10,2,1,2,2,1002021500,2,700,0,4,0,0,0,'[{1,3066}]',0,0,0,0,'[{2,573400},{4,14335}]','[]',0,0,6,0),(1002021653,'混沌头盔','16阶粉色头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002021500,2,700,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,917440},{4,22936}]','[]',0,0,6,0),(1002021663,'混沌头盔','16阶神装头盔【龙骑士】','',0,'','',0,0,1,10,2,0,0,2,1002021500,2,700,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,1146800},{4,28670}]','[]',0,0,6,0),(1002030100,'学徒头冠','1阶绿色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002030100,3,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,487},{4,12}]','[]',0,0,0,0),(1002030110,'学徒头冠','1阶蓝色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002030100,3,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,731},{4,18}]','[]',0,0,0,0),(1002030120,'学徒头冠','1阶紫色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002030100,3,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1330},{4,33}]','[]',0,0,0,0),(1002030131,'学徒头冠','1阶橙1星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002030100,3,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1622},{4,41}]','[]',0,0,0,0),(1002030132,'学徒头冠','1阶橙2星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002030100,3,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1622},{4,41}]','[]',0,0,0,0),(1002030141,'学徒头冠','1阶红1星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002030100,3,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{2,2435},{4,61}]','[]',0,0,0,0),(1002030142,'学徒头冠','1阶红2星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002030100,3,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{2,2435},{4,61}]','[]',0,0,0,0),(1002030143,'学徒头冠','1阶红3星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002030100,3,1,0,4,0,0,0,'[{1,7}]',0,0,0,0,'[{2,2435},{4,61}]','[]',0,0,0,0),(1002030153,'学徒头冠','1阶粉色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002030100,3,1,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,3896},{4,97}]','[]',0,0,0,0),(1002030163,'学徒头冠','1阶神装头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002030100,3,1,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,4870},{4,122}]','[]',0,0,0,0),(1002030200,'冒险头冠','2阶绿色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002030200,3,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,834},{4,21}]','[]',0,0,0,0),(1002030210,'冒险头冠','2阶蓝色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002030200,3,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1251},{4,31}]','[]',0,0,0,0),(1002030220,'冒险头冠','2阶紫色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002030200,3,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2277},{4,57}]','[]',0,0,0,0),(1002030231,'冒险头冠','2阶橙1星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002030200,3,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{2,2777},{4,69}]','[]',0,0,0,0),(1002030232,'冒险头冠','2阶橙2星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002030200,3,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{2,2777},{4,69}]','[]',0,0,0,0),(1002030241,'冒险头冠','2阶红1星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002030200,3,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{2,4170},{4,104}]','[]',0,0,0,0),(1002030242,'冒险头冠','2阶红2星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002030200,3,1,0,4,0,0,0,'[{1,4}]',0,0,0,0,'[{2,4170},{4,104}]','[]',0,0,0,0),(1002030243,'冒险头冠','2阶红3星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002030200,3,1,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,4170},{4,104}]','[]',0,0,0,0),(1002030253,'冒险头冠','2阶粉色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002030200,3,1,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,6671},{4,167}]','[]',0,0,0,0),(1002030263,'冒险头冠','2阶神装头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002030200,3,1,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,8339},{4,208}]','[]',0,0,0,0),(1002030300,'勇者头冠','3阶绿色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002030300,3,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1988},{4,50}]','[]',0,0,0,0),(1002030310,'勇者头冠','3阶蓝色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002030300,3,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2982},{4,75}]','[]',0,0,0,0),(1002030320,'勇者头冠','3阶紫色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002030300,3,1,0,2,0,0,0,'[{1,2}]',0,0,0,0,'[{2,5427},{4,136}]','[]',0,0,0,0),(1002030331,'勇者头冠','3阶橙1星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002030300,3,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6620},{4,166}]','[]',0,0,0,0),(1002030332,'勇者头冠','3阶橙2星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002030300,3,1,0,3,0,0,0,'[{1,3}]',0,0,0,0,'[{2,6620},{4,166}]','[]',0,0,0,0),(1002030341,'勇者头冠','3阶红1星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002030300,3,1,0,4,0,0,0,'[{1,4}]',0,0,0,0,'[{2,9940},{4,249}]','[]',0,0,0,0),(1002030342,'勇者头冠','3阶红2星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002030300,3,1,0,4,0,0,0,'[{1,6}]',0,0,0,0,'[{2,9940},{4,249}]','[]',0,0,0,0),(1002030343,'勇者头冠','3阶红3星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002030300,3,1,0,4,0,0,0,'[{1,18}]',0,0,0,0,'[{2,9940},{4,249}]','[]',0,0,0,0),(1002030353,'勇者头冠','3阶粉色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002030300,3,1,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,15904},{4,398}]','[]',0,0,0,0),(1002030363,'勇者头冠','3阶神装头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002030300,3,1,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,19881},{4,497}]','[]',0,0,0,0),(1002030400,'先驱头冠','4阶绿色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002030400,3,100,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,4003},{4,100}]','[]',0,0,0,0),(1002030410,'先驱头冠','4阶蓝色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002030400,3,100,0,1,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6004},{4,150}]','[]',0,0,0,0),(1002030420,'先驱头冠','4阶紫色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002030400,3,100,0,2,0,0,0,'[{1,4}]',0,0,0,0,'[{2,10928},{4,273}]','[]',0,0,0,0),(1002030431,'先驱头冠','4阶橙1星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002030400,3,100,0,3,0,0,0,'[{1,5}]',0,0,0,0,'[{2,13329},{4,333}]','[]',0,0,0,0),(1002030432,'先驱头冠','4阶橙2星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002030400,3,100,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,13329},{4,333}]','[]',0,0,0,0),(1002030441,'先驱头冠','4阶红1星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002030400,3,100,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1002030442,'先驱头冠','4阶红2星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002030400,3,100,0,4,0,0,0,'[{1,18}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1002030443,'先驱头冠','4阶红3星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002030400,3,100,0,4,0,0,0,'[{1,51}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1002030453,'先驱头冠','4阶粉色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002030400,3,100,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,32022},{4,801}]','[]',0,0,0,0),(1002030463,'先驱头冠','4阶神装头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002030400,3,100,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,40028},{4,1001}]','[]',0,0,0,0),(1002030500,'荣誉头冠','5阶绿色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002030500,3,150,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6932},{4,173}]','[]',0,0,1,0),(1002030510,'荣誉头冠','5阶蓝色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002030500,3,150,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,10397},{4,260}]','[]',0,0,1,0),(1002030520,'荣誉头冠','5阶紫色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002030500,3,150,0,2,0,0,0,'[{1,7}]',0,0,0,0,'[{2,18923},{4,473}]','[]',0,0,1,0),(1002030531,'荣誉头冠','5阶橙1星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002030500,3,150,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,1,0),(1002030532,'荣誉头冠','5阶橙2星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002030500,3,150,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,1,0),(1002030541,'荣誉头冠','5阶红1星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002030500,3,150,0,4,0,0,0,'[{1,21}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,1,0),(1002030542,'荣誉头冠','5阶红2星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002030500,3,150,0,4,0,0,0,'[{1,32}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,1,0),(1002030543,'荣誉头冠','5阶红3星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002030500,3,150,0,4,0,0,0,'[{1,95}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,1,0),(1002030553,'荣誉头冠','5阶粉色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002030500,3,150,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,55452},{4,1386}]','[]',0,0,1,0),(1002030563,'荣誉头冠','5阶神装头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002030500,3,150,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,69315},{4,1733}]','[]',0,0,1,0),(1002030600,'贤者头冠','6阶绿色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002030600,3,180,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,10828},{4,271}]','[]',0,0,1,0),(1002030610,'贤者头冠','6阶蓝色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002030600,3,180,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,16241},{4,406}]','[]',0,0,1,0),(1002030620,'贤者头冠','6阶紫色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002030600,3,180,0,2,0,0,0,'[{1,7}]',0,0,0,0,'[{2,29559},{4,739}]','[]',0,0,1,0),(1002030631,'贤者头冠','6阶橙1星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002030600,3,180,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{2,36056},{4,901}]','[]',0,0,1,0),(1002030632,'贤者头冠','6阶橙2星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002030600,3,180,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{2,36056},{4,901}]','[]',0,0,1,0),(1002030641,'贤者头冠','6阶红1星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002030600,3,180,0,4,0,0,0,'[{1,27}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,1,0),(1002030642,'贤者头冠','6阶红2星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002030600,3,180,0,4,0,0,0,'[{1,42}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,1,0),(1002030643,'贤者头冠','6阶红3星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002030600,3,180,0,4,0,0,0,'[{1,156}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,1,0),(1002030653,'贤者头冠','6阶粉色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002030600,3,180,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,86620},{4,2166}]','[]',0,0,1,0),(1002030663,'贤者头冠','6阶神装头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002030600,3,180,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,108276},{4,2707}]','[]',0,0,1,0),(1002030700,'征服头冠','7阶绿色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002030700,3,220,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,15744},{4,394}]','[]',0,0,2,0),(1002030710,'征服头冠','7阶蓝色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002030700,3,220,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,23616},{4,590}]','[]',0,0,2,0),(1002030720,'征服头冠','7阶紫色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002030700,3,220,0,2,0,0,0,'[{1,9}]',0,0,0,0,'[{2,42982},{4,1075}]','[]',0,0,2,0),(1002030731,'征服头冠','7阶橙1星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002030700,3,220,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{2,52429},{4,1311}]','[]',0,0,2,0),(1002030732,'征服头冠','7阶橙2星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002030700,3,220,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{2,52429},{4,1311}]','[]',0,0,2,0),(1002030741,'征服头冠','7阶红1星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002030700,3,220,0,4,0,0,0,'[{1,38}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,2,0),(1002030742,'征服头冠','7阶红2星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002030700,3,220,0,4,0,0,0,'[{1,62}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,2,0),(1002030743,'征服头冠','7阶红3星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002030700,3,220,0,4,0,0,0,'[{1,223}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,2,0),(1002030753,'征服头冠','7阶粉色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002030700,3,220,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,125955},{4,3149}]','[]',0,0,2,0),(1002030763,'征服头冠','7阶神装头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002030700,3,220,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,157443},{4,3936}]','[]',0,0,2,0),(1002030800,'秩序头冠','8阶绿色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002030800,3,260,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,21735},{4,543}]','[]',0,0,2,0),(1002030810,'秩序头冠','8阶蓝色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002030800,3,260,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,32603},{4,815}]','[]',0,0,2,0),(1002030820,'秩序头冠','8阶紫色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002030800,3,260,0,2,0,0,0,'[{1,10}]',0,0,0,0,'[{2,59337},{4,1483}]','[]',0,0,2,0),(1002030831,'秩序头冠','8阶橙1星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002030800,3,260,0,3,0,0,0,'[{1,13}]',0,0,0,0,'[{2,72378},{4,1809}]','[]',0,0,2,0),(1002030832,'秩序头冠','8阶橙2星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002030800,3,260,0,3,0,0,0,'[{1,16}]',0,0,0,0,'[{2,72378},{4,1809}]','[]',0,0,2,0),(1002030841,'秩序头冠','8阶红1星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002030800,3,260,0,4,0,0,0,'[{1,42}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,2,0),(1002030842,'秩序头冠','8阶红2星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002030800,3,260,0,4,0,0,0,'[{1,69}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,2,0),(1002030843,'秩序头冠','8阶红3星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002030800,3,260,0,4,0,0,0,'[{1,311}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,2,0),(1002030853,'秩序头冠','8阶粉色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002030800,3,260,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,173881},{4,4347}]','[]',0,0,2,0),(1002030863,'秩序头冠','8阶神装头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002030800,3,260,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,217352},{4,5434}]','[]',0,0,2,0),(1002030900,'守护头冠','9阶绿色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002030900,3,300,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,28847},{4,721}]','[]',0,0,3,0),(1002030910,'守护头冠','9阶蓝色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002030900,3,300,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{2,43270},{4,1082}]','[]',0,0,3,0),(1002030920,'守护头冠','9阶紫色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002030900,3,300,0,2,0,0,0,'[{1,11}]',0,0,0,0,'[{2,78752},{4,1969}]','[]',0,0,3,0),(1002030931,'守护头冠','9阶橙1星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002030900,3,300,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{2,96060},{4,2401}]','[]',0,0,3,0),(1002030932,'守护头冠','9阶橙2星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002030900,3,300,0,3,0,0,0,'[{1,18}]',0,0,0,0,'[{2,96060},{4,2401}]','[]',0,0,3,0),(1002030941,'守护头冠','9阶红1星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002030900,3,300,0,4,0,0,0,'[{1,50}]',0,0,0,0,'[{2,144234},{4,3606}]','[]',0,0,3,0),(1002030942,'守护头冠','9阶红2星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002030900,3,300,0,4,0,0,0,'[{1,82}]',0,0,0,0,'[{2,144234},{4,3606}]','[]',0,0,3,0),(1002030943,'守护头冠','9阶红3星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002030900,3,300,0,4,0,0,0,'[{1,434}]',0,0,0,0,'[{2,144234},{4,3606}]','[]',0,0,3,0),(1002030953,'守护头冠','9阶粉色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002030900,3,300,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,230774},{4,5769}]','[]',0,0,3,0),(1002030963,'守护头冠','9阶神装头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002030900,3,300,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,288468},{4,7212}]','[]',0,0,3,0),(1002031000,'信仰头冠','10阶绿色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002031000,3,355,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,37139},{4,928}]','[]',0,0,4,0),(1002031010,'信仰头冠','10阶蓝色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002031000,3,355,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{2,55709},{4,1393}]','[]',0,0,4,0),(1002031020,'信仰头冠','10阶紫色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002031000,3,355,0,2,0,0,0,'[{1,11}]',0,0,0,0,'[{2,101390},{4,2535}]','[]',0,0,4,0),(1002031031,'信仰头冠','10阶橙1星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002031000,3,355,0,3,0,0,0,'[{1,15}]',0,0,0,0,'[{2,123674},{4,3092}]','[]',0,0,4,0),(1002031032,'信仰头冠','10阶橙2星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002031000,3,355,0,3,0,0,0,'[{1,18}]',0,0,0,0,'[{2,123674},{4,3092}]','[]',0,0,4,0),(1002031041,'信仰头冠','10阶红1星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002031000,3,355,0,4,0,0,0,'[{1,60}]',0,0,0,0,'[{2,185696},{4,4642}]','[]',0,0,4,0),(1002031042,'信仰头冠','10阶红2星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002031000,3,355,0,4,0,0,0,'[{1,103}]',0,0,0,0,'[{2,185696},{4,4642}]','[]',0,0,4,0),(1002031043,'信仰头冠','10阶红3星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002031000,3,355,0,4,0,0,0,'[{1,598}]',0,0,0,0,'[{2,185696},{4,4642}]','[]',0,0,4,0),(1002031053,'信仰头冠','10阶粉色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002031000,3,355,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,297114},{4,7428}]','[]',0,0,4,0),(1002031063,'信仰头冠','10阶神装头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002031000,3,355,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,371392},{4,9285}]','[]',0,0,4,0),(1002031100,'天行头冠','11阶绿色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002031100,3,400,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{2,46666},{4,1167}]','[]',0,0,4,0),(1002031110,'天行头冠','11阶蓝色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002031100,3,400,0,1,0,0,0,'[{1,7}]',0,0,0,0,'[{2,69999},{4,1750}]','[]',0,0,4,0),(1002031120,'天行头冠','11阶紫色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002031100,3,400,0,2,0,0,0,'[{1,13}]',0,0,0,0,'[{2,127398},{4,3185}]','[]',0,0,4,0),(1002031131,'天行头冠','11阶橙1星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002031100,3,400,0,3,0,0,0,'[{1,17}]',0,0,0,0,'[{2,155397},{4,3885}]','[]',0,0,4,0),(1002031132,'天行头冠','11阶橙2星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002031100,3,400,0,3,0,0,0,'[{1,21}]',0,0,0,0,'[{2,155397},{4,3885}]','[]',0,0,4,0),(1002031141,'天行头冠','11阶红1星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002031100,3,400,0,4,0,0,0,'[{1,69}]',0,0,0,0,'[{2,233329},{4,5833}]','[]',0,0,4,0),(1002031142,'天行头冠','11阶红2星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002031100,3,400,0,4,0,0,0,'[{1,116}]',0,0,0,0,'[{2,233329},{4,5833}]','[]',0,0,4,0),(1002031143,'天行头冠','11阶红3星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002031100,3,400,0,4,0,0,0,'[{1,823}]',0,0,0,0,'[{2,233329},{4,5833}]','[]',0,0,4,0),(1002031153,'天行头冠','11阶粉色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002031100,3,400,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,373327},{4,9333}]','[]',0,0,4,0),(1002031163,'天行头冠','11阶神装头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002031100,3,400,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,466659},{4,11666}]','[]',0,0,4,0),(1002031200,'命运头冠','12阶绿色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002031200,3,500,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{2,57480},{4,1437}]','[]',0,0,5,0),(1002031210,'命运头冠','12阶蓝色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002031200,3,500,0,1,0,0,0,'[{1,7}]',0,0,0,0,'[{2,86220},{4,2156}]','[]',0,0,5,0),(1002031220,'命运头冠','12阶紫色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002031200,3,500,0,2,0,0,0,'[{1,14}]',0,0,0,0,'[{2,156921},{4,3923}]','[]',0,0,5,0),(1002031231,'命运头冠','12阶橙1星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002031200,3,500,0,3,0,0,0,'[{1,18}]',0,0,0,0,'[{2,191409},{4,4785}]','[]',0,0,5,0),(1002031232,'命运头冠','12阶橙2星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002031200,3,500,0,3,0,0,0,'[{1,22}]',0,0,0,0,'[{2,191409},{4,4785}]','[]',0,0,5,0),(1002031241,'命运头冠','12阶红1星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002031200,3,500,0,4,0,0,0,'[{1,93}]',0,0,0,0,'[{2,287400},{4,7185}]','[]',0,0,5,0),(1002031242,'命运头冠','12阶红2星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002031200,3,500,0,4,0,0,0,'[{1,164}]',0,0,0,0,'[{2,287400},{4,7185}]','[]',0,0,5,0),(1002031243,'命运头冠','12阶红3星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002031200,3,500,0,4,0,0,0,'[{1,1198}]',0,0,0,0,'[{2,287400},{4,7185}]','[]',0,0,5,0),(1002031253,'命运头冠','12阶粉色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002031200,3,500,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,459841},{4,11496}]','[]',0,0,5,0),(1002031263,'命运头冠','12阶神装头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002031200,3,500,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,574801},{4,14370}]','[]',0,0,5,0),(1002031300,'制裁头冠','13阶绿色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002031300,3,520,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{2,69635},{4,1741}]','[]',0,0,5,0),(1002031310,'制裁头冠','13阶蓝色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002031300,3,520,0,1,0,0,0,'[{1,8}]',0,0,0,0,'[{2,104453},{4,2611}]','[]',0,0,5,0),(1002031320,'制裁头冠','13阶紫色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002031300,3,520,0,2,0,0,0,'[{1,15}]',0,0,0,0,'[{2,190104},{4,4753}]','[]',0,0,5,0),(1002031331,'制裁头冠','13阶橙1星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002031300,3,520,0,3,0,0,0,'[{1,20}]',0,0,0,0,'[{2,231885},{4,5797}]','[]',0,0,5,0),(1002031332,'制裁头冠','13阶橙2星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002031300,3,520,0,3,0,0,0,'[{1,25}]',0,0,0,0,'[{2,231885},{4,5797}]','[]',0,0,5,0),(1002031341,'制裁头冠','13阶红1星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002031300,3,520,0,4,0,0,0,'[{1,108}]',0,0,0,0,'[{2,348176},{4,8704}]','[]',0,0,5,0),(1002031342,'制裁头冠','13阶红2星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002031300,3,520,0,4,0,0,0,'[{1,191}]',0,0,0,0,'[{2,348176},{4,8704}]','[]',0,0,5,0),(1002031343,'制裁头冠','13阶红3星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002031300,3,520,0,4,0,0,0,'[{1,1675}]',0,0,0,0,'[{2,348176},{4,8704}]','[]',0,0,5,0),(1002031353,'制裁头冠','13阶粉色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002031300,3,520,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,557082},{4,13927}]','[]',0,0,5,0),(1002031363,'制裁头冠','13阶神装头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002031300,3,520,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,696352},{4,17409}]','[]',0,0,5,0),(1002031400,'审判头冠','14阶绿色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002031400,3,620,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{2,83185},{4,2080}]','[]',0,0,6,0),(1002031410,'审判头冠','14阶蓝色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002031400,3,620,0,1,0,0,0,'[{1,9}]',0,0,0,0,'[{2,124777},{4,3119}]','[]',0,0,6,0),(1002031420,'审判头冠','14阶紫色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002031400,3,620,0,2,0,0,0,'[{1,17}]',0,0,0,0,'[{2,227094},{4,5677}]','[]',0,0,6,0),(1002031431,'审判头冠','14阶橙1星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002031400,3,620,0,3,0,0,0,'[{1,22}]',0,0,0,0,'[{2,277005},{4,6925}]','[]',0,0,6,0),(1002031432,'审判头冠','14阶橙2星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002031400,3,620,0,3,0,0,0,'[{1,28}]',0,0,0,0,'[{2,277005},{4,6925}]','[]',0,0,6,0),(1002031441,'审判头冠','14阶红1星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002031400,3,620,0,4,0,0,0,'[{1,123}]',0,0,0,0,'[{2,415923},{4,10398}]','[]',0,0,6,0),(1002031442,'审判头冠','14阶红2星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002031400,3,620,0,4,0,0,0,'[{1,219}]',0,0,0,0,'[{2,415923},{4,10398}]','[]',0,0,6,0),(1002031443,'审判头冠','14阶红3星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002031400,3,620,0,4,0,0,0,'[{1,2166}]',0,0,0,0,'[{2,415923},{4,10398}]','[]',0,0,6,0),(1002031453,'审判头冠','14阶粉色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002031400,3,620,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,665478},{4,16637}]','[]',0,0,6,0),(1002031463,'审判头冠','14阶神装头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002031400,3,620,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,831847},{4,20796}]','[]',0,0,6,0),(1002031500,'毁灭头冠','15阶绿色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002031500,3,650,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{2,98182},{4,2455}]','[]',0,0,6,0),(1002031510,'毁灭头冠','15阶蓝色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002031500,3,650,0,1,0,0,0,'[{1,9}]',0,0,0,0,'[{2,147273},{4,3682}]','[]',0,0,6,0),(1002031520,'毁灭头冠','15阶紫色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002031500,3,650,0,2,0,0,0,'[{1,18}]',0,0,0,0,'[{2,268036},{4,6701}]','[]',0,0,6,0),(1002031531,'毁灭头冠','15阶橙1星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002031500,3,650,0,3,0,0,0,'[{1,24}]',0,0,0,0,'[{2,326945},{4,8174}]','[]',0,0,6,0),(1002031532,'毁灭头冠','15阶橙2星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002031500,3,650,0,3,0,0,0,'[{1,30}]',0,0,0,0,'[{2,326945},{4,8174}]','[]',0,0,6,0),(1002031541,'毁灭头冠','15阶红1星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002031500,3,650,0,4,0,0,0,'[{1,138}]',0,0,0,0,'[{2,490909},{4,12273}]','[]',0,0,6,0),(1002031542,'毁灭头冠','15阶红2星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002031500,3,650,0,4,0,0,0,'[{1,246}]',0,0,0,0,'[{2,490909},{4,12273}]','[]',0,0,6,0),(1002031543,'毁灭头冠','15阶红3星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002031500,3,650,0,4,0,0,0,'[{1,2575}]',0,0,0,0,'[{2,490909},{4,12273}]','[]',0,0,6,0),(1002031553,'毁灭头冠','15阶粉色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002031500,3,650,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,785455},{4,19636}]','[]',0,0,6,0),(1002031563,'毁灭头冠','15阶神装头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002031500,3,650,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,981818},{4,24545}]','[]',0,0,6,0),(1002031600,'混沌头冠','16阶绿色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002031500,3,700,0,0,0,0,0,'[{1,4}]',0,0,0,0,'[{2,114680},{4,2867}]','[]',0,0,6,0),(1002031610,'混沌头冠','16阶蓝色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002031500,3,700,0,1,0,0,0,'[{1,11}]',0,0,0,0,'[{2,172020},{4,4300}]','[]',0,0,6,0),(1002031620,'混沌头冠','16阶紫色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002031500,3,700,0,2,0,0,0,'[{1,21}]',0,0,0,0,'[{2,313076},{4,7827}]','[]',0,0,6,0),(1002031631,'混沌头冠','16阶橙1星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002031500,3,700,0,3,0,0,0,'[{1,28}]',0,0,0,0,'[{2,381884},{4,9547}]','[]',0,0,6,0),(1002031632,'混沌头冠','16阶橙2星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002031500,3,700,0,3,0,0,0,'[{1,35}]',0,0,0,0,'[{2,381884},{4,9547}]','[]',0,0,6,0),(1002031641,'混沌头冠','16阶红1星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002031500,3,700,0,4,0,0,0,'[{1,168}]',0,0,0,0,'[{2,573400},{4,14335}]','[]',0,0,6,0),(1002031642,'混沌头冠','16阶红2星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002031500,3,700,0,4,0,0,0,'[{1,300}]',0,0,0,0,'[{2,573400},{4,14335}]','[]',0,0,6,0),(1002031643,'混沌头冠','16阶红3星头盔【魔导师】','',0,'','',0,1,1,10,2,1,2,2,1002031500,3,700,0,4,0,0,0,'[{1,3066}]',0,0,0,0,'[{2,573400},{4,14335}]','[]',0,0,6,0),(1002031653,'混沌头冠','16阶粉色头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002031500,3,700,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,917440},{4,22936}]','[]',0,0,6,0),(1002031663,'混沌头冠','16阶神装头盔【魔导师】','',0,'','',0,0,1,10,2,0,0,2,1002031500,3,700,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,1146800},{4,28670}]','[]',0,0,6,0),(1002040100,'学徒皮帽','1阶绿色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002040100,4,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,487},{4,12}]','[]',0,0,0,0),(1002040110,'学徒皮帽','1阶蓝色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002040100,4,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,731},{4,18}]','[]',0,0,0,0),(1002040120,'学徒皮帽','1阶紫色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002040100,4,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1330},{4,33}]','[]',0,0,0,0),(1002040131,'学徒皮帽','1阶橙1星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002040100,4,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1622},{4,41}]','[]',0,0,0,0),(1002040132,'学徒皮帽','1阶橙2星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002040100,4,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1622},{4,41}]','[]',0,0,0,0),(1002040141,'学徒皮帽','1阶红1星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002040100,4,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{2,2435},{4,61}]','[]',0,0,0,0);
INSERT INTO `base_goods` VALUES (1002040142,'学徒皮帽','1阶红2星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002040100,4,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{2,2435},{4,61}]','[]',0,0,0,0),(1002040143,'学徒皮帽','1阶红3星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002040100,4,1,0,4,0,0,0,'[{1,7}]',0,0,0,0,'[{2,2435},{4,61}]','[]',0,0,0,0),(1002040153,'学徒皮帽','1阶粉色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002040100,4,1,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,3896},{4,97}]','[]',0,0,0,0),(1002040163,'学徒皮帽','1阶神装头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002040100,4,1,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,4870},{4,122}]','[]',0,0,0,0),(1002040200,'冒险皮帽','2阶绿色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002040200,4,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,834},{4,21}]','[]',0,0,0,0),(1002040210,'冒险皮帽','2阶蓝色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002040200,4,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1251},{4,31}]','[]',0,0,0,0),(1002040220,'冒险皮帽','2阶紫色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002040200,4,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2277},{4,57}]','[]',0,0,0,0),(1002040231,'冒险皮帽','2阶橙1星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002040200,4,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{2,2777},{4,69}]','[]',0,0,0,0),(1002040232,'冒险皮帽','2阶橙2星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002040200,4,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{2,2777},{4,69}]','[]',0,0,0,0),(1002040241,'冒险皮帽','2阶红1星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002040200,4,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{2,4170},{4,104}]','[]',0,0,0,0),(1002040242,'冒险皮帽','2阶红2星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002040200,4,1,0,4,0,0,0,'[{1,4}]',0,0,0,0,'[{2,4170},{4,104}]','[]',0,0,0,0),(1002040243,'冒险皮帽','2阶红3星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002040200,4,1,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,4170},{4,104}]','[]',0,0,0,0),(1002040253,'冒险皮帽','2阶粉色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002040200,4,1,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,6671},{4,167}]','[]',0,0,0,0),(1002040263,'冒险皮帽','2阶神装头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002040200,4,1,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,8339},{4,208}]','[]',0,0,0,0),(1002040300,'勇者皮帽','3阶绿色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002040300,4,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1988},{4,50}]','[]',0,0,0,0),(1002040310,'勇者皮帽','3阶蓝色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002040300,4,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2982},{4,75}]','[]',0,0,0,0),(1002040320,'勇者皮帽','3阶紫色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002040300,4,1,0,2,0,0,0,'[{1,2}]',0,0,0,0,'[{2,5427},{4,136}]','[]',0,0,0,0),(1002040331,'勇者皮帽','3阶橙1星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002040300,4,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6620},{4,166}]','[]',0,0,0,0),(1002040332,'勇者皮帽','3阶橙2星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002040300,4,1,0,3,0,0,0,'[{1,3}]',0,0,0,0,'[{2,6620},{4,166}]','[]',0,0,0,0),(1002040341,'勇者皮帽','3阶红1星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002040300,4,1,0,4,0,0,0,'[{1,4}]',0,0,0,0,'[{2,9940},{4,249}]','[]',0,0,0,0),(1002040342,'勇者皮帽','3阶红2星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002040300,4,1,0,4,0,0,0,'[{1,6}]',0,0,0,0,'[{2,9940},{4,249}]','[]',0,0,0,0),(1002040343,'勇者皮帽','3阶红3星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002040300,4,1,0,4,0,0,0,'[{1,18}]',0,0,0,0,'[{2,9940},{4,249}]','[]',0,0,0,0),(1002040353,'勇者皮帽','3阶粉色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002040300,4,1,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,15904},{4,398}]','[]',0,0,0,0),(1002040363,'勇者皮帽','3阶神装头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002040300,4,1,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,19881},{4,497}]','[]',0,0,0,0),(1002040400,'先驱皮帽','4阶绿色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002040400,4,100,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,4003},{4,100}]','[]',0,0,0,0),(1002040410,'先驱皮帽','4阶蓝色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002040400,4,100,0,1,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6004},{4,150}]','[]',0,0,0,0),(1002040420,'先驱皮帽','4阶紫色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002040400,4,100,0,2,0,0,0,'[{1,4}]',0,0,0,0,'[{2,10928},{4,273}]','[]',0,0,0,0),(1002040431,'先驱皮帽','4阶橙1星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002040400,4,100,0,3,0,0,0,'[{1,5}]',0,0,0,0,'[{2,13329},{4,333}]','[]',0,0,0,0),(1002040432,'先驱皮帽','4阶橙2星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002040400,4,100,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,13329},{4,333}]','[]',0,0,0,0),(1002040441,'先驱皮帽','4阶红1星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002040400,4,100,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1002040442,'先驱皮帽','4阶红2星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002040400,4,100,0,4,0,0,0,'[{1,18}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1002040443,'先驱皮帽','4阶红3星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002040400,4,100,0,4,0,0,0,'[{1,51}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1002040453,'先驱皮帽','4阶粉色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002040400,4,100,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,32022},{4,801}]','[]',0,0,0,0),(1002040463,'先驱皮帽','4阶神装头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002040400,4,100,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,40028},{4,1001}]','[]',0,0,0,0),(1002040500,'荣誉皮帽','5阶绿色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002040500,4,150,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6932},{4,173}]','[]',0,0,1,0),(1002040510,'荣誉皮帽','5阶蓝色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002040500,4,150,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,10397},{4,260}]','[]',0,0,1,0),(1002040520,'荣誉皮帽','5阶紫色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002040500,4,150,0,2,0,0,0,'[{1,7}]',0,0,0,0,'[{2,18923},{4,473}]','[]',0,0,1,0),(1002040531,'荣誉皮帽','5阶橙1星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002040500,4,150,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,1,0),(1002040532,'荣誉皮帽','5阶橙2星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002040500,4,150,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,1,0),(1002040541,'荣誉皮帽','5阶红1星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002040500,4,150,0,4,0,0,0,'[{1,21}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,1,0),(1002040542,'荣誉皮帽','5阶红2星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002040500,4,150,0,4,0,0,0,'[{1,32}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,1,0),(1002040543,'荣誉皮帽','5阶红3星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002040500,4,150,0,4,0,0,0,'[{1,95}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,1,0),(1002040553,'荣誉皮帽','5阶粉色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002040500,4,150,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,55452},{4,1386}]','[]',0,0,1,0),(1002040563,'荣誉皮帽','5阶神装头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002040500,4,150,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,69315},{4,1733}]','[]',0,0,1,0),(1002040600,'贤者皮帽','6阶绿色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002040600,4,180,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,10828},{4,271}]','[]',0,0,1,0),(1002040610,'贤者皮帽','6阶蓝色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002040600,4,180,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,16241},{4,406}]','[]',0,0,1,0),(1002040620,'贤者皮帽','6阶紫色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002040600,4,180,0,2,0,0,0,'[{1,7}]',0,0,0,0,'[{2,29559},{4,739}]','[]',0,0,1,0),(1002040631,'贤者皮帽','6阶橙1星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002040600,4,180,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{2,36056},{4,901}]','[]',0,0,1,0),(1002040632,'贤者皮帽','6阶橙2星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002040600,4,180,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{2,36056},{4,901}]','[]',0,0,1,0),(1002040641,'贤者皮帽','6阶红1星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002040600,4,180,0,4,0,0,0,'[{1,27}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,1,0),(1002040642,'贤者皮帽','6阶红2星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002040600,4,180,0,4,0,0,0,'[{1,42}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,1,0),(1002040643,'贤者皮帽','6阶红3星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002040600,4,180,0,4,0,0,0,'[{1,156}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,1,0),(1002040653,'贤者皮帽','6阶粉色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002040600,4,180,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,86620},{4,2166}]','[]',0,0,1,0),(1002040663,'贤者皮帽','6阶神装头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002040600,4,180,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,108276},{4,2707}]','[]',0,0,1,0),(1002040700,'征服皮帽','7阶绿色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002040700,4,220,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,15744},{4,394}]','[]',0,0,2,0),(1002040710,'征服皮帽','7阶蓝色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002040700,4,220,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,23616},{4,590}]','[]',0,0,2,0),(1002040720,'征服皮帽','7阶紫色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002040700,4,220,0,2,0,0,0,'[{1,9}]',0,0,0,0,'[{2,42982},{4,1075}]','[]',0,0,2,0),(1002040731,'征服皮帽','7阶橙1星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002040700,4,220,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{2,52429},{4,1311}]','[]',0,0,2,0),(1002040732,'征服皮帽','7阶橙2星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002040700,4,220,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{2,52429},{4,1311}]','[]',0,0,2,0),(1002040741,'征服皮帽','7阶红1星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002040700,4,220,0,4,0,0,0,'[{1,38}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,2,0),(1002040742,'征服皮帽','7阶红2星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002040700,4,220,0,4,0,0,0,'[{1,62}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,2,0),(1002040743,'征服皮帽','7阶红3星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002040700,4,220,0,4,0,0,0,'[{1,223}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,2,0),(1002040753,'征服皮帽','7阶粉色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002040700,4,220,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,125955},{4,3149}]','[]',0,0,2,0),(1002040763,'征服皮帽','7阶神装头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002040700,4,220,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,157443},{4,3936}]','[]',0,0,2,0),(1002040800,'秩序皮帽','8阶绿色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002040800,4,260,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,21735},{4,543}]','[]',0,0,2,0),(1002040810,'秩序皮帽','8阶蓝色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002040800,4,260,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,32603},{4,815}]','[]',0,0,2,0),(1002040820,'秩序皮帽','8阶紫色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002040800,4,260,0,2,0,0,0,'[{1,10}]',0,0,0,0,'[{2,59337},{4,1483}]','[]',0,0,2,0),(1002040831,'秩序皮帽','8阶橙1星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002040800,4,260,0,3,0,0,0,'[{1,13}]',0,0,0,0,'[{2,72378},{4,1809}]','[]',0,0,2,0),(1002040832,'秩序皮帽','8阶橙2星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002040800,4,260,0,3,0,0,0,'[{1,16}]',0,0,0,0,'[{2,72378},{4,1809}]','[]',0,0,2,0),(1002040841,'秩序皮帽','8阶红1星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002040800,4,260,0,4,0,0,0,'[{1,42}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,2,0),(1002040842,'秩序皮帽','8阶红2星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002040800,4,260,0,4,0,0,0,'[{1,69}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,2,0),(1002040843,'秩序皮帽','8阶红3星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002040800,4,260,0,4,0,0,0,'[{1,311}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,2,0),(1002040853,'秩序皮帽','8阶粉色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002040800,4,260,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,173881},{4,4347}]','[]',0,0,2,0),(1002040863,'秩序皮帽','8阶神装头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002040800,4,260,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,217352},{4,5434}]','[]',0,0,2,0),(1002040900,'守护皮帽','9阶绿色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002040900,4,300,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,28847},{4,721}]','[]',0,0,3,0),(1002040910,'守护皮帽','9阶蓝色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002040900,4,300,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{2,43270},{4,1082}]','[]',0,0,3,0),(1002040920,'守护皮帽','9阶紫色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002040900,4,300,0,2,0,0,0,'[{1,11}]',0,0,0,0,'[{2,78752},{4,1969}]','[]',0,0,3,0),(1002040931,'守护皮帽','9阶橙1星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002040900,4,300,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{2,96060},{4,2401}]','[]',0,0,3,0),(1002040932,'守护皮帽','9阶橙2星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002040900,4,300,0,3,0,0,0,'[{1,18}]',0,0,0,0,'[{2,96060},{4,2401}]','[]',0,0,3,0),(1002040941,'守护皮帽','9阶红1星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002040900,4,300,0,4,0,0,0,'[{1,50}]',0,0,0,0,'[{2,144234},{4,3606}]','[]',0,0,3,0),(1002040942,'守护皮帽','9阶红2星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002040900,4,300,0,4,0,0,0,'[{1,82}]',0,0,0,0,'[{2,144234},{4,3606}]','[]',0,0,3,0),(1002040943,'守护皮帽','9阶红3星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002040900,4,300,0,4,0,0,0,'[{1,434}]',0,0,0,0,'[{2,144234},{4,3606}]','[]',0,0,3,0),(1002040953,'守护皮帽','9阶粉色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002040900,4,300,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,230774},{4,5769}]','[]',0,0,3,0),(1002040963,'守护皮帽','9阶神装头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002040900,4,300,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,288468},{4,7212}]','[]',0,0,3,0),(1002041000,'信仰皮帽','10阶绿色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002041000,4,355,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,37139},{4,928}]','[]',0,0,4,0),(1002041010,'信仰皮帽','10阶蓝色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002041000,4,355,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{2,55709},{4,1393}]','[]',0,0,4,0),(1002041020,'信仰皮帽','10阶紫色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002041000,4,355,0,2,0,0,0,'[{1,11}]',0,0,0,0,'[{2,101390},{4,2535}]','[]',0,0,4,0),(1002041031,'信仰皮帽','10阶橙1星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002041000,4,355,0,3,0,0,0,'[{1,15}]',0,0,0,0,'[{2,123674},{4,3092}]','[]',0,0,4,0),(1002041032,'信仰皮帽','10阶橙2星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002041000,4,355,0,3,0,0,0,'[{1,18}]',0,0,0,0,'[{2,123674},{4,3092}]','[]',0,0,4,0),(1002041041,'信仰皮帽','10阶红1星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002041000,4,355,0,4,0,0,0,'[{1,60}]',0,0,0,0,'[{2,185696},{4,4642}]','[]',0,0,4,0),(1002041042,'信仰皮帽','10阶红2星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002041000,4,355,0,4,0,0,0,'[{1,103}]',0,0,0,0,'[{2,185696},{4,4642}]','[]',0,0,4,0),(1002041043,'信仰皮帽','10阶红3星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002041000,4,355,0,4,0,0,0,'[{1,598}]',0,0,0,0,'[{2,185696},{4,4642}]','[]',0,0,4,0),(1002041053,'信仰皮帽','10阶粉色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002041000,4,355,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,297114},{4,7428}]','[]',0,0,4,0),(1002041063,'信仰皮帽','10阶神装头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002041000,4,355,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,371392},{4,9285}]','[]',0,0,4,0),(1002041100,'天行皮帽','11阶绿色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002041100,4,400,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{2,46666},{4,1167}]','[]',0,0,4,0),(1002041110,'天行皮帽','11阶蓝色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002041100,4,400,0,1,0,0,0,'[{1,7}]',0,0,0,0,'[{2,69999},{4,1750}]','[]',0,0,4,0),(1002041120,'天行皮帽','11阶紫色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002041100,4,400,0,2,0,0,0,'[{1,13}]',0,0,0,0,'[{2,127398},{4,3185}]','[]',0,0,4,0),(1002041131,'天行皮帽','11阶橙1星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002041100,4,400,0,3,0,0,0,'[{1,17}]',0,0,0,0,'[{2,155397},{4,3885}]','[]',0,0,4,0),(1002041132,'天行皮帽','11阶橙2星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002041100,4,400,0,3,0,0,0,'[{1,21}]',0,0,0,0,'[{2,155397},{4,3885}]','[]',0,0,4,0),(1002041141,'天行皮帽','11阶红1星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002041100,4,400,0,4,0,0,0,'[{1,69}]',0,0,0,0,'[{2,233329},{4,5833}]','[]',0,0,4,0),(1002041142,'天行皮帽','11阶红2星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002041100,4,400,0,4,0,0,0,'[{1,116}]',0,0,0,0,'[{2,233329},{4,5833}]','[]',0,0,4,0),(1002041143,'天行皮帽','11阶红3星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002041100,4,400,0,4,0,0,0,'[{1,823}]',0,0,0,0,'[{2,233329},{4,5833}]','[]',0,0,4,0),(1002041153,'天行皮帽','11阶粉色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002041100,4,400,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,373327},{4,9333}]','[]',0,0,4,0),(1002041163,'天行皮帽','11阶神装头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002041100,4,400,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,466659},{4,11666}]','[]',0,0,4,0),(1002041200,'命运皮帽','12阶绿色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002041200,4,500,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{2,57480},{4,1437}]','[]',0,0,5,0),(1002041210,'命运皮帽','12阶蓝色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002041200,4,500,0,1,0,0,0,'[{1,7}]',0,0,0,0,'[{2,86220},{4,2156}]','[]',0,0,5,0),(1002041220,'命运皮帽','12阶紫色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002041200,4,500,0,2,0,0,0,'[{1,14}]',0,0,0,0,'[{2,156921},{4,3923}]','[]',0,0,5,0),(1002041231,'命运皮帽','12阶橙1星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002041200,4,500,0,3,0,0,0,'[{1,18}]',0,0,0,0,'[{2,191409},{4,4785}]','[]',0,0,5,0),(1002041232,'命运皮帽','12阶橙2星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002041200,4,500,0,3,0,0,0,'[{1,22}]',0,0,0,0,'[{2,191409},{4,4785}]','[]',0,0,5,0),(1002041241,'命运皮帽','12阶红1星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002041200,4,500,0,4,0,0,0,'[{1,93}]',0,0,0,0,'[{2,287400},{4,7185}]','[]',0,0,5,0),(1002041242,'命运皮帽','12阶红2星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002041200,4,500,0,4,0,0,0,'[{1,164}]',0,0,0,0,'[{2,287400},{4,7185}]','[]',0,0,5,0),(1002041243,'命运皮帽','12阶红3星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002041200,4,500,0,4,0,0,0,'[{1,1198}]',0,0,0,0,'[{2,287400},{4,7185}]','[]',0,0,5,0),(1002041253,'命运皮帽','12阶粉色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002041200,4,500,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,459841},{4,11496}]','[]',0,0,5,0),(1002041263,'命运皮帽','12阶神装头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002041200,4,500,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,574801},{4,14370}]','[]',0,0,5,0),(1002041300,'制裁皮帽','13阶绿色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002041300,4,520,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{2,69635},{4,1741}]','[]',0,0,5,0),(1002041310,'制裁皮帽','13阶蓝色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002041300,4,520,0,1,0,0,0,'[{1,8}]',0,0,0,0,'[{2,104453},{4,2611}]','[]',0,0,5,0),(1002041320,'制裁皮帽','13阶紫色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002041300,4,520,0,2,0,0,0,'[{1,15}]',0,0,0,0,'[{2,190104},{4,4753}]','[]',0,0,5,0),(1002041331,'制裁皮帽','13阶橙1星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002041300,4,520,0,3,0,0,0,'[{1,20}]',0,0,0,0,'[{2,231885},{4,5797}]','[]',0,0,5,0),(1002041332,'制裁皮帽','13阶橙2星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002041300,4,520,0,3,0,0,0,'[{1,25}]',0,0,0,0,'[{2,231885},{4,5797}]','[]',0,0,5,0),(1002041341,'制裁皮帽','13阶红1星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002041300,4,520,0,4,0,0,0,'[{1,108}]',0,0,0,0,'[{2,348176},{4,8704}]','[]',0,0,5,0),(1002041342,'制裁皮帽','13阶红2星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002041300,4,520,0,4,0,0,0,'[{1,191}]',0,0,0,0,'[{2,348176},{4,8704}]','[]',0,0,5,0),(1002041343,'制裁皮帽','13阶红3星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002041300,4,520,0,4,0,0,0,'[{1,1675}]',0,0,0,0,'[{2,348176},{4,8704}]','[]',0,0,5,0),(1002041353,'制裁皮帽','13阶粉色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002041300,4,520,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,557082},{4,13927}]','[]',0,0,5,0),(1002041363,'制裁皮帽','13阶神装头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002041300,4,520,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,696352},{4,17409}]','[]',0,0,5,0),(1002041400,'审判皮帽','14阶绿色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002041400,4,620,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{2,83185},{4,2080}]','[]',0,0,6,0),(1002041410,'审判皮帽','14阶蓝色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002041400,4,620,0,1,0,0,0,'[{1,9}]',0,0,0,0,'[{2,124777},{4,3119}]','[]',0,0,6,0),(1002041420,'审判皮帽','14阶紫色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002041400,4,620,0,2,0,0,0,'[{1,17}]',0,0,0,0,'[{2,227094},{4,5677}]','[]',0,0,6,0),(1002041431,'审判皮帽','14阶橙1星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002041400,4,620,0,3,0,0,0,'[{1,22}]',0,0,0,0,'[{2,277005},{4,6925}]','[]',0,0,6,0),(1002041432,'审判皮帽','14阶橙2星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002041400,4,620,0,3,0,0,0,'[{1,28}]',0,0,0,0,'[{2,277005},{4,6925}]','[]',0,0,6,0),(1002041441,'审判皮帽','14阶红1星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002041400,4,620,0,4,0,0,0,'[{1,123}]',0,0,0,0,'[{2,415923},{4,10398}]','[]',0,0,6,0),(1002041442,'审判皮帽','14阶红2星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002041400,4,620,0,4,0,0,0,'[{1,219}]',0,0,0,0,'[{2,415923},{4,10398}]','[]',0,0,6,0),(1002041443,'审判皮帽','14阶红3星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002041400,4,620,0,4,0,0,0,'[{1,2166}]',0,0,0,0,'[{2,415923},{4,10398}]','[]',0,0,6,0),(1002041453,'审判皮帽','14阶粉色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002041400,4,620,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,665478},{4,16637}]','[]',0,0,6,0),(1002041463,'审判皮帽','14阶神装头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002041400,4,620,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,831847},{4,20796}]','[]',0,0,6,0),(1002041500,'毁灭皮帽','15阶绿色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002041500,4,650,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{2,98182},{4,2455}]','[]',0,0,6,0),(1002041510,'毁灭皮帽','15阶蓝色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002041500,4,650,0,1,0,0,0,'[{1,9}]',0,0,0,0,'[{2,147273},{4,3682}]','[]',0,0,6,0),(1002041520,'毁灭皮帽','15阶紫色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002041500,4,650,0,2,0,0,0,'[{1,18}]',0,0,0,0,'[{2,268036},{4,6701}]','[]',0,0,6,0),(1002041531,'毁灭皮帽','15阶橙1星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002041500,4,650,0,3,0,0,0,'[{1,24}]',0,0,0,0,'[{2,326945},{4,8174}]','[]',0,0,6,0),(1002041532,'毁灭皮帽','15阶橙2星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002041500,4,650,0,3,0,0,0,'[{1,30}]',0,0,0,0,'[{2,326945},{4,8174}]','[]',0,0,6,0),(1002041541,'毁灭皮帽','15阶红1星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002041500,4,650,0,4,0,0,0,'[{1,138}]',0,0,0,0,'[{2,490909},{4,12273}]','[]',0,0,6,0),(1002041542,'毁灭皮帽','15阶红2星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002041500,4,650,0,4,0,0,0,'[{1,246}]',0,0,0,0,'[{2,490909},{4,12273}]','[]',0,0,6,0),(1002041543,'毁灭皮帽','15阶红3星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002041500,4,650,0,4,0,0,0,'[{1,2575}]',0,0,0,0,'[{2,490909},{4,12273}]','[]',0,0,6,0),(1002041553,'毁灭皮帽','15阶粉色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002041500,4,650,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,785455},{4,19636}]','[]',0,0,6,0),(1002041563,'毁灭皮帽','15阶神装头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002041500,4,650,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,981818},{4,24545}]','[]',0,0,6,0),(1002041600,'混沌皮帽','16阶绿色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002041500,4,700,0,0,0,0,0,'[{1,4}]',0,0,0,0,'[{2,114680},{4,2867}]','[]',0,0,6,0),(1002041610,'混沌皮帽','16阶蓝色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002041500,4,700,0,1,0,0,0,'[{1,11}]',0,0,0,0,'[{2,172020},{4,4300}]','[]',0,0,6,0),(1002041620,'混沌皮帽','16阶紫色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002041500,4,700,0,2,0,0,0,'[{1,21}]',0,0,0,0,'[{2,313076},{4,7827}]','[]',0,0,6,0),(1002041631,'混沌皮帽','16阶橙1星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002041500,4,700,0,3,0,0,0,'[{1,28}]',0,0,0,0,'[{2,381884},{4,9547}]','[]',0,0,6,0),(1002041632,'混沌皮帽','16阶橙2星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002041500,4,700,0,3,0,0,0,'[{1,35}]',0,0,0,0,'[{2,381884},{4,9547}]','[]',0,0,6,0),(1002041641,'混沌皮帽','16阶红1星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002041500,4,700,0,4,0,0,0,'[{1,168}]',0,0,0,0,'[{2,573400},{4,14335}]','[]',0,0,6,0),(1002041642,'混沌皮帽','16阶红2星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002041500,4,700,0,4,0,0,0,'[{1,300}]',0,0,0,0,'[{2,573400},{4,14335}]','[]',0,0,6,0),(1002041643,'混沌皮帽','16阶红3星头盔【重炮手】','',0,'','',0,1,1,10,2,1,2,2,1002041500,4,700,0,4,0,0,0,'[{1,3066}]',0,0,0,0,'[{2,573400},{4,14335}]','[]',0,0,6,0),(1002041653,'混沌皮帽','16阶粉色头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002041500,4,700,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,917440},{4,22936}]','[]',0,0,6,0),(1002041663,'混沌皮帽','16阶神装头盔【重炮手】','',0,'','',0,0,1,10,2,0,0,2,1002041500,4,700,0,6,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,1146800},{4,28670}]','[]',0,0,6,0),(1003000100,'学徒项链','1阶绿色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003000100,0,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,30},{3,15}]','[]',0,0,0,0),(1003000110,'学徒项链','1阶蓝色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003000100,0,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{1,45},{3,22}]','[]',0,0,0,0),(1003000120,'学徒项链','1阶紫色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003000100,0,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{1,81},{3,41}]','[]',0,0,0,0),(1003000131,'学徒项链','1阶橙1星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003000100,0,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{1,99},{3,50}]','[]',0,0,0,0),(1003000132,'学徒项链','1阶橙2星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003000100,0,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{1,99},{3,50}]','[]',0,0,0,0),(1003000141,'学徒项链','1阶红1星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003000100,0,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{1,149},{3,74}]','[]',0,0,0,0),(1003000142,'学徒项链','1阶红2星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003000100,0,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{1,149},{3,74}]','[]',0,0,0,0),(1003000143,'学徒项链','1阶红3星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003000100,0,1,0,4,0,0,0,'[{1,6}]',0,0,0,0,'[{1,149},{3,74}]','[]',0,0,0,0),(1003000153,'学徒项链','1阶粉色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003000100,0,1,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,238},{3,119}]','[]',0,0,0,0),(1003000163,'学徒项链','1阶神装项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003000100,0,1,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,298},{3,149}]','[]',0,0,0,0),(1003000200,'冒险项链','2阶绿色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003000200,0,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,51},{3,25}]','[]',0,0,0,0),(1003000210,'冒险项链','2阶蓝色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003000200,0,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{1,76},{3,38}]','[]',0,0,0,0),(1003000220,'冒险项链','2阶紫色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003000200,0,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{1,139},{3,70}]','[]',0,0,0,0),(1003000231,'冒险项链','2阶橙1星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003000200,0,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{1,170},{3,85}]','[]',0,0,0,0),(1003000232,'冒险项链','2阶橙2星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003000200,0,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{1,170},{3,85}]','[]',0,0,0,0),(1003000241,'冒险项链','2阶红1星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003000200,0,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{1,255},{3,127}]','[]',0,0,0,0),(1003000242,'冒险项链','2阶红2星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003000200,0,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{1,255},{3,127}]','[]',0,0,0,0),(1003000243,'冒险项链','2阶红3星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003000200,0,1,0,4,0,0,0,'[{1,10}]',0,0,0,0,'[{1,255},{3,127}]','[]',0,0,0,0),(1003000253,'冒险项链','2阶粉色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003000200,0,1,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,408},{3,204}]','[]',0,0,0,0),(1003000263,'冒险项链','2阶神装项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003000200,0,1,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,510},{3,255}]','[]',0,0,0,0),(1003000300,'勇者项链','3阶绿色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003000300,0,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,121},{3,61}]','[]',0,0,0,0),(1003000310,'勇者项链','3阶蓝色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003000300,0,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{1,182},{3,91}]','[]',0,0,0,0),(1003000320,'勇者项链','3阶紫色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003000300,0,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{1,332},{3,166}]','[]',0,0,0,0),(1003000331,'勇者项链','3阶橙1星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003000300,0,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{1,405},{3,202}]','[]',0,0,0,0),(1003000332,'勇者项链','3阶橙2星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003000300,0,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{1,405},{3,202}]','[]',0,0,0,0),(1003000341,'勇者项链','3阶红1星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003000300,0,1,0,4,0,0,0,'[{1,4}]',0,0,0,0,'[{1,607},{3,304}]','[]',0,0,0,0),(1003000342,'勇者项链','3阶红2星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003000300,0,1,0,4,0,0,0,'[{1,5}]',0,0,0,0,'[{1,607},{3,304}]','[]',0,0,0,0),(1003000343,'勇者项链','3阶红3星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003000300,0,1,0,4,0,0,0,'[{1,15}]',0,0,0,0,'[{1,607},{3,304}]','[]',0,0,0,0),(1003000353,'勇者项链','3阶粉色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003000300,0,1,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,972},{3,486}]','[]',0,0,0,0),(1003000363,'勇者项链','3阶神装项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003000300,0,1,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,1215},{3,607}]','[]',0,0,0,0),(1003000400,'先驱项链','4阶绿色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003000400,0,100,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,245},{3,122}]','[]',0,0,0,0),(1003000410,'先驱项链','4阶蓝色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003000400,0,100,0,1,0,0,0,'[{1,2}]',0,0,0,0,'[{1,367},{3,183}]','[]',0,0,0,0),(1003000420,'先驱项链','4阶紫色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003000400,0,100,0,2,0,0,0,'[{1,3}]',0,0,0,0,'[{1,668},{3,334}]','[]',0,0,0,0),(1003000431,'先驱项链','4阶橙1星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003000400,0,100,0,3,0,0,0,'[{1,4}]',0,0,0,0,'[{1,815},{3,407}]','[]',0,0,0,0),(1003000432,'先驱项链','4阶橙2星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003000400,0,100,0,3,0,0,0,'[{1,5}]',0,0,0,0,'[{1,815},{3,407}]','[]',0,0,0,0),(1003000441,'先驱项链','4阶红1星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003000400,0,100,0,4,0,0,0,'[{1,10}]',0,0,0,0,'[{1,1223},{3,612}]','[]',0,0,0,0),(1003000442,'先驱项链','4阶红2星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003000400,0,100,0,4,0,0,0,'[{1,14}]',0,0,0,0,'[{1,1223},{3,612}]','[]',0,0,0,0),(1003000443,'先驱项链','4阶红3星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003000400,0,100,0,4,0,0,0,'[{1,42}]',0,0,0,0,'[{1,1223},{3,612}]','[]',0,0,0,0),(1003000453,'先驱项链','4阶粉色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003000400,0,100,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,1957},{3,978}]','[]',0,0,0,0),(1003000463,'先驱项链','4阶神装项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003000400,0,100,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,2446},{3,1223}]','[]',0,0,0,0),(1003000500,'荣誉项链','5阶绿色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003000500,0,150,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,424},{3,212}]','[]',0,0,1,0),(1003000510,'荣誉项链','5阶蓝色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003000500,0,150,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{1,635},{3,318}]','[]',0,0,1,0),(1003000520,'荣誉项链','5阶紫色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003000500,0,150,0,2,0,0,0,'[{1,5}]',0,0,0,0,'[{1,1156},{3,578}]','[]',0,0,1,0),(1003000531,'荣誉项链','5阶橙1星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003000500,0,150,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{1,1411},{3,705}]','[]',0,0,1,0),(1003000532,'荣誉项链','5阶橙2星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003000500,0,150,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{1,1411},{3,705}]','[]',0,0,1,0),(1003000541,'荣誉项链','5阶红1星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003000500,0,150,0,4,0,0,0,'[{1,17}]',0,0,0,0,'[{1,2118},{3,1059}]','[]',0,0,1,0),(1003000542,'荣誉项链','5阶红2星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003000500,0,150,0,4,0,0,0,'[{1,26}]',0,0,0,0,'[{1,2118},{3,1059}]','[]',0,0,1,0),(1003000543,'荣誉项链','5阶红3星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003000500,0,150,0,4,0,0,0,'[{1,77}]',0,0,0,0,'[{1,2118},{3,1059}]','[]',0,0,1,0),(1003000553,'荣誉项链','5阶粉色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003000500,0,150,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,3389},{3,1694}]','[]',0,0,1,0),(1003000563,'荣誉项链','5阶神装项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003000500,0,150,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,4236},{3,2118}]','[]',0,0,1,0),(1003000600,'贤者项链','6阶绿色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003000600,0,180,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,662},{3,331}]','[]',0,0,1,0),(1003000610,'贤者项链','6阶蓝色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003000600,0,180,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{1,993},{3,496}]','[]',0,0,1,0),(1003000620,'贤者项链','6阶紫色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003000600,0,180,0,2,0,0,0,'[{1,6}]',0,0,0,0,'[{1,1806},{3,903}]','[]',0,0,1,0),(1003000631,'贤者项链','6阶橙1星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003000600,0,180,0,3,0,0,0,'[{1,8}]',0,0,0,0,'[{1,2203},{3,1102}]','[]',0,0,1,0),(1003000632,'贤者项链','6阶橙2星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003000600,0,180,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{1,2203},{3,1102}]','[]',0,0,1,0),(1003000641,'贤者项链','6阶红1星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003000600,0,180,0,4,0,0,0,'[{1,22}]',0,0,0,0,'[{1,3308},{3,1654}]','[]',0,0,1,0),(1003000642,'贤者项链','6阶红2星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003000600,0,180,0,4,0,0,0,'[{1,34}]',0,0,0,0,'[{1,3308},{3,1654}]','[]',0,0,1,0),(1003000643,'贤者项链','6阶红3星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003000600,0,180,0,4,0,0,0,'[{1,127}]',0,0,0,0,'[{1,3308},{3,1654}]','[]',0,0,1,0),(1003000653,'贤者项链','6阶粉色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003000600,0,180,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,5293},{3,2647}]','[]',0,0,1,0),(1003000663,'贤者项链','6阶神装项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003000600,0,180,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,6617},{3,3308}]','[]',0,0,1,0),(1003000700,'征服项链','7阶绿色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003000700,0,220,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,962},{3,481}]','[]',0,0,2,0),(1003000710,'征服项链','7阶蓝色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003000700,0,220,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{1,1443},{3,722}]','[]',0,0,2,0),(1003000720,'征服项链','7阶紫色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003000700,0,220,0,2,0,0,0,'[{1,7}]',0,0,0,0,'[{1,2627},{3,1313}]','[]',0,0,2,0),(1003000731,'征服项链','7阶橙1星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003000700,0,220,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{1,3204},{3,1602}]','[]',0,0,2,0),(1003000732,'征服项链','7阶橙2星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003000700,0,220,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{1,3204},{3,1602}]','[]',0,0,2,0),(1003000741,'征服项链','7阶红1星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003000700,0,220,0,4,0,0,0,'[{1,31}]',0,0,0,0,'[{1,4811},{3,2405}]','[]',0,0,2,0),(1003000742,'征服项链','7阶红2星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003000700,0,220,0,4,0,0,0,'[{1,50}]',0,0,0,0,'[{1,4811},{3,2405}]','[]',0,0,2,0),(1003000743,'征服项链','7阶红3星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003000700,0,220,0,4,0,0,0,'[{1,182}]',0,0,0,0,'[{1,4811},{3,2405}]','[]',0,0,2,0),(1003000753,'征服项链','7阶粉色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003000700,0,220,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,7697},{3,3849}]','[]',0,0,2,0),(1003000763,'征服项链','7阶神装项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003000700,0,220,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,9622},{3,4811}]','[]',0,0,2,0),(1003000800,'秩序项链','8阶绿色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003000800,0,260,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,1328},{3,664}]','[]',0,0,2,0),(1003000810,'秩序项链','8阶蓝色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003000800,0,260,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{1,1992},{3,996}]','[]',0,0,2,0),(1003000820,'秩序项链','8阶紫色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003000800,0,260,0,2,0,0,0,'[{1,8}]',0,0,0,0,'[{1,3626},{3,1813}]','[]',0,0,2,0),(1003000831,'秩序项链','8阶橙1星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003000800,0,260,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{1,4423},{3,2212}]','[]',0,0,2,0),(1003000832,'秩序项链','8阶橙2星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003000800,0,260,0,3,0,0,0,'[{1,13}]',0,0,0,0,'[{1,4423},{3,2212}]','[]',0,0,2,0),(1003000841,'秩序项链','8阶红1星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003000800,0,260,0,4,0,0,0,'[{1,35}]',0,0,0,0,'[{1,6641},{3,3321}]','[]',0,0,2,0),(1003000842,'秩序项链','8阶红2星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003000800,0,260,0,4,0,0,0,'[{1,56}]',0,0,0,0,'[{1,6641},{3,3321}]','[]',0,0,2,0),(1003000843,'秩序项链','8阶红3星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003000800,0,260,0,4,0,0,0,'[{1,254}]',0,0,0,0,'[{1,6641},{3,3321}]','[]',0,0,2,0),(1003000853,'秩序项链','8阶粉色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003000800,0,260,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,10626},{3,5313}]','[]',0,0,2,0),(1003000863,'秩序项链','8阶神装项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003000800,0,260,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,13283},{3,6641}]','[]',0,0,2,0),(1003000900,'守护项链','9阶绿色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003000900,0,300,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,1763},{3,881}]','[]',0,0,3,0),(1003000910,'守护项链','9阶蓝色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003000900,0,300,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{1,2644},{3,1322}]','[]',0,0,3,0),(1003000920,'守护项链','9阶紫色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003000900,0,300,0,2,0,0,0,'[{1,9}]',0,0,0,0,'[{1,4813},{3,2406}]','[]',0,0,3,0),(1003000931,'守护项链','9阶橙1星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003000900,0,300,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{1,5870},{3,2935}]','[]',0,0,3,0),(1003000932,'守护项链','9阶橙2星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003000900,0,300,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{1,5870},{3,2935}]','[]',0,0,3,0),(1003000941,'守护项链','9阶红1星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003000900,0,300,0,4,0,0,0,'[{1,41}]',0,0,0,0,'[{1,8814},{3,4407}]','[]',0,0,3,0),(1003000942,'守护项链','9阶红2星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003000900,0,300,0,4,0,0,0,'[{1,67}]',0,0,0,0,'[{1,8814},{3,4407}]','[]',0,0,3,0),(1003000943,'守护项链','9阶红3星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003000900,0,300,0,4,0,0,0,'[{1,354}]',0,0,0,0,'[{1,8814},{3,4407}]','[]',0,0,3,0),(1003000953,'守护项链','9阶粉色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003000900,0,300,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,14103},{3,7051}]','[]',0,0,3,0),(1003000963,'守护项链','9阶神装项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003000900,0,300,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,17629},{3,8814}]','[]',0,0,3,0),(1003001000,'信仰项链','10阶绿色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003001000,0,355,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,2270},{3,1135}]','[]',0,0,4,0),(1003001010,'信仰项链','10阶蓝色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003001000,0,355,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{1,3404},{3,1702}]','[]',0,0,4,0),(1003001020,'信仰项链','10阶紫色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003001000,0,355,0,2,0,0,0,'[{1,9}]',0,0,0,0,'[{1,6196},{3,3098}]','[]',0,0,4,0),(1003001031,'信仰项链','10阶橙1星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003001000,0,355,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{1,7558},{3,3779}]','[]',0,0,4,0),(1003001032,'信仰项链','10阶橙2星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003001000,0,355,0,3,0,0,0,'[{1,15}]',0,0,0,0,'[{1,7558},{3,3779}]','[]',0,0,4,0),(1003001041,'信仰项链','10阶红1星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003001000,0,355,0,4,0,0,0,'[{1,49}]',0,0,0,0,'[{1,11348},{3,5674}]','[]',0,0,4,0),(1003001042,'信仰项链','10阶红2星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003001000,0,355,0,4,0,0,0,'[{1,84}]',0,0,0,0,'[{1,11348},{3,5674}]','[]',0,0,4,0),(1003001043,'信仰项链','10阶红3星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003001000,0,355,0,4,0,0,0,'[{1,487}]',0,0,0,0,'[{1,11348},{3,5674}]','[]',0,0,4,0),(1003001053,'信仰项链','10阶粉色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003001000,0,355,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,18157},{3,9078}]','[]',0,0,4,0),(1003001063,'信仰项链','10阶神装项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003001000,0,355,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,22696},{3,11348}]','[]',0,0,4,0),(1003001100,'天行项链','11阶绿色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003001100,0,400,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,2852},{3,1426}]','[]',0,0,4,0),(1003001110,'天行项链','11阶蓝色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003001100,0,400,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{1,4278},{3,2139}]','[]',0,0,4,0),(1003001120,'天行项链','11阶紫色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003001100,0,400,0,2,0,0,0,'[{1,10}]',0,0,0,0,'[{1,7785},{3,3893}]','[]',0,0,4,0),(1003001131,'天行项链','11阶橙1星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003001100,0,400,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{1,9497},{3,4748}]','[]',0,0,4,0),(1003001132,'天行项链','11阶橙2星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003001100,0,400,0,3,0,0,0,'[{1,17}]',0,0,0,0,'[{1,9497},{3,4748}]','[]',0,0,4,0),(1003001141,'天行项链','11阶红1星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003001100,0,400,0,4,0,0,0,'[{1,56}]',0,0,0,0,'[{1,14259},{3,7130}]','[]',0,0,4,0),(1003001142,'天行项链','11阶红2星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003001100,0,400,0,4,0,0,0,'[{1,95}]',0,0,0,0,'[{1,14259},{3,7130}]','[]',0,0,4,0),(1003001143,'天行项链','11阶红3星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003001100,0,400,0,4,0,0,0,'[{1,670}]',0,0,0,0,'[{1,14259},{3,7130}]','[]',0,0,4,0),(1003001153,'天行项链','11阶粉色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003001100,0,400,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,22814},{3,11407}]','[]',0,0,4,0),(1003001163,'天行项链','11阶神装项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003001100,0,400,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,28518},{3,14259}]','[]',0,0,4,0),(1003001200,'命运项链','12阶绿色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003001200,0,500,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,3513},{3,1756}]','[]',0,0,5,0),(1003001210,'命运项链','12阶蓝色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003001200,0,500,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{1,5269},{3,2635}]','[]',0,0,5,0),(1003001220,'命运项链','12阶紫色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003001200,0,500,0,2,0,0,0,'[{1,11}]',0,0,0,0,'[{1,9590},{3,4795}]','[]',0,0,5,0),(1003001231,'命运项链','12阶橙1星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003001200,0,500,0,3,0,0,0,'[{1,15}]',0,0,0,0,'[{1,11697},{3,5849}]','[]',0,0,5,0),(1003001232,'命运项链','12阶橙2星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003001200,0,500,0,3,0,0,0,'[{1,18}]',0,0,0,0,'[{1,11697},{3,5849}]','[]',0,0,5,0),(1003001241,'命运项链','12阶红1星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003001200,0,500,0,4,0,0,0,'[{1,76}]',0,0,0,0,'[{1,17563},{3,8782}]','[]',0,0,5,0),(1003001242,'命运项链','12阶红2星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003001200,0,500,0,4,0,0,0,'[{1,134}]',0,0,0,0,'[{1,17563},{3,8782}]','[]',0,0,5,0),(1003001243,'命运项链','12阶红3星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003001200,0,500,0,4,0,0,0,'[{1,976}]',0,0,0,0,'[{1,17563},{3,8782}]','[]',0,0,5,0),(1003001253,'命运项链','12阶粉色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003001200,0,500,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,28101},{3,14051}]','[]',0,0,5,0),(1003001263,'命运项链','12阶神装项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003001200,0,500,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,35127},{3,17563}]','[]',0,0,5,0),(1003001300,'制裁项链','13阶绿色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003001300,0,520,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,4255},{3,2128}]','[]',0,0,5,0),(1003001310,'制裁项链','13阶蓝色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003001300,0,520,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{1,6383},{3,3192}]','[]',0,0,5,0),(1003001320,'制裁项链','13阶紫色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003001300,0,520,0,2,0,0,0,'[{1,12}]',0,0,0,0,'[{1,11617},{3,5809}]','[]',0,0,5,0),(1003001331,'制裁项链','13阶橙1星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003001300,0,520,0,3,0,0,0,'[{1,16}]',0,0,0,0,'[{1,14171},{3,7085}]','[]',0,0,5,0),(1003001332,'制裁项链','13阶橙2星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003001300,0,520,0,3,0,0,0,'[{1,20}]',0,0,0,0,'[{1,14171},{3,7085}]','[]',0,0,5,0),(1003001341,'制裁项链','13阶红1星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003001300,0,520,0,4,0,0,0,'[{1,88}]',0,0,0,0,'[{1,21277},{3,10639}]','[]',0,0,5,0),(1003001342,'制裁项链','13阶红2星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003001300,0,520,0,4,0,0,0,'[{1,156}]',0,0,0,0,'[{1,21277},{3,10639}]','[]',0,0,5,0),(1003001343,'制裁项链','13阶红3星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003001300,0,520,0,4,0,0,0,'[{1,1365}]',0,0,0,0,'[{1,21277},{3,10639}]','[]',0,0,5,0),(1003001353,'制裁项链','13阶粉色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003001300,0,520,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,34044},{3,17022}]','[]',0,0,5,0),(1003001363,'制裁项链','13阶神装项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003001300,0,520,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,42555},{3,21277}]','[]',0,0,5,0),(1003001400,'审判项链','14阶绿色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003001400,0,620,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{1,5084},{3,2542}]','[]',0,0,6,0),(1003001410,'审判项链','14阶蓝色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003001400,0,620,0,1,0,0,0,'[{1,7}]',0,0,0,0,'[{1,7625},{3,3813}]','[]',0,0,6,0),(1003001420,'审判项链','14阶紫色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003001400,0,620,0,2,0,0,0,'[{1,14}]',0,0,0,0,'[{1,13878},{3,6939}]','[]',0,0,6,0),(1003001431,'审判项链','14阶橙1星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003001400,0,620,0,3,0,0,0,'[{1,18}]',0,0,0,0,'[{1,16928},{3,8464}]','[]',0,0,6,0),(1003001432,'审判项链','14阶橙2星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003001400,0,620,0,3,0,0,0,'[{1,23}]',0,0,0,0,'[{1,16928},{3,8464}]','[]',0,0,6,0),(1003001441,'审判项链','14阶红1星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003001400,0,620,0,4,0,0,0,'[{1,100}]',0,0,0,0,'[{1,25418},{3,12709}]','[]',0,0,6,0),(1003001442,'审判项链','14阶红2星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003001400,0,620,0,4,0,0,0,'[{1,178}]',0,0,0,0,'[{1,25418},{3,12709}]','[]',0,0,6,0),(1003001443,'审判项链','14阶红3星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003001400,0,620,0,4,0,0,0,'[{1,1765}]',0,0,0,0,'[{1,25418},{3,12709}]','[]',0,0,6,0),(1003001453,'审判项链','14阶粉色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003001400,0,620,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,40668},{3,20334}]','[]',0,0,6,0),(1003001463,'审判项链','14阶神装项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003001400,0,620,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,50835},{3,25418}]','[]',0,0,6,0),(1003001500,'毁灭项链','15阶绿色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003001500,0,650,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{1,6000},{3,3000}]','[]',0,0,6,0),(1003001510,'毁灭项链','15阶蓝色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003001500,0,650,0,1,0,0,0,'[{1,8}]',0,0,0,0,'[{1,9000},{3,4500}]','[]',0,0,6,0),(1003001520,'毁灭项链','15阶紫色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003001500,0,650,0,2,0,0,0,'[{1,15}]',0,0,0,0,'[{1,16380},{3,8190}]','[]',0,0,6,0),(1003001531,'毁灭项链','15阶橙1星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003001500,0,650,0,3,0,0,0,'[{1,20}]',0,0,0,0,'[{1,19980},{3,9990}]','[]',0,0,6,0),(1003001532,'毁灭项链','15阶橙2星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003001500,0,650,0,3,0,0,0,'[{1,25}]',0,0,0,0,'[{1,19980},{3,9990}]','[]',0,0,6,0),(1003001541,'毁灭项链','15阶红1星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003001500,0,650,0,4,0,0,0,'[{1,113}]',0,0,0,0,'[{1,30000},{3,15000}]','[]',0,0,6,0),(1003001542,'毁灭项链','15阶红2星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003001500,0,650,0,4,0,0,0,'[{1,200}]',0,0,0,0,'[{1,30000},{3,15000}]','[]',0,0,6,0),(1003001543,'毁灭项链','15阶红3星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003001500,0,650,0,4,0,0,0,'[{1,2098}]',0,0,0,0,'[{1,30000},{3,15000}]','[]',0,0,6,0),(1003001553,'毁灭项链','15阶粉色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003001500,0,650,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,48000},{3,24000}]','[]',0,0,6,0),(1003001563,'毁灭项链','15阶神装项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003001500,0,650,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,60000},{3,30000}]','[]',0,0,6,0),(1003001600,'混沌项链','16阶绿色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003001500,0,700,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{1,7008},{3,3504}]','[]',0,0,6,0),(1003001610,'混沌项链','16阶蓝色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003001500,0,700,0,1,0,0,0,'[{1,9}]',0,0,0,0,'[{1,10512},{3,5256}]','[]',0,0,6,0),(1003001620,'混沌项链','16阶紫色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003001500,0,700,0,2,0,0,0,'[{1,17}]',0,0,0,0,'[{1,19132},{3,9566}]','[]',0,0,6,0),(1003001631,'混沌项链','16阶橙1星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003001500,0,700,0,3,0,0,0,'[{1,23}]',0,0,0,0,'[{1,23337},{3,11669}]','[]',0,0,6,0),(1003001632,'混沌项链','16阶橙2星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003001500,0,700,0,3,0,0,0,'[{1,28}]',0,0,0,0,'[{1,23337},{3,11669}]','[]',0,0,6,0),(1003001641,'混沌项链','16阶红1星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003001500,0,700,0,4,0,0,0,'[{1,137}]',0,0,0,0,'[{1,35041},{3,17521}]','[]',0,0,6,0),(1003001642,'混沌项链','16阶红2星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003001500,0,700,0,4,0,0,0,'[{1,245}]',0,0,0,0,'[{1,35041},{3,17521}]','[]',0,0,6,0),(1003001643,'混沌项链','16阶红3星项链【通用】','',0,'','',0,1,1,10,3,1,3,3,1003001500,0,700,0,4,0,0,0,'[{1,2498}]',0,0,0,0,'[{1,35041},{3,17521}]','[]',0,0,6,0),(1003001653,'混沌项链','16阶粉色项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003001500,0,700,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,56066},{3,28033}]','[]',0,0,6,0),(1003001663,'混沌项链','16阶神装项链【通用】','',0,'','',0,0,1,10,3,0,0,3,1003001500,0,700,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,70082},{3,35041}]','[]',0,0,6,0),(1004010100,'学徒战甲','1阶绿色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004010100,1,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,731},{4,18}]','[]',0,0,0,0),(1004010110,'学徒战甲','1阶蓝色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004010100,1,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1096},{4,27}]','[]',0,0,0,0),(1004010120,'学徒战甲','1阶紫色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004010100,1,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1994},{4,50}]','[]',0,0,0,0),(1004010131,'学徒战甲','1阶橙1星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004010100,1,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2433},{4,61}]','[]',0,0,0,0),(1004010132,'学徒战甲','1阶橙2星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004010100,1,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2433},{4,61}]','[]',0,0,0,0),(1004010141,'学徒战甲','1阶红1星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004010100,1,1,0,4,0,0,0,'[{1,1}]',0,0,0,0,'[{2,3653},{4,91}]','[]',0,0,0,0),(1004010142,'学徒战甲','1阶红2星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004010100,1,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{2,3653},{4,91}]','[]',0,0,0,0),(1004010143,'学徒战甲','1阶红3星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004010100,1,1,0,4,0,0,0,'[{1,5}]',0,0,0,0,'[{2,3653},{4,91}]','[]',0,0,0,0),(1004010153,'学徒战甲','1阶粉色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004010100,1,1,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,5844},{4,146}]','[]',0,0,0,0),(1004010163,'学徒战甲','1阶神装衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004010100,1,1,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,7305},{4,183}]','[]',0,0,0,0),(1004010200,'冒险战甲','2阶绿色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004010200,1,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1251},{4,31}]','[]',0,0,0,0),(1004010210,'冒险战甲','2阶蓝色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004010200,1,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1876},{4,47}]','[]',0,0,0,0),(1004010220,'冒险战甲','2阶紫色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004010200,1,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,3415},{4,85}]','[]',0,0,0,0),(1004010231,'冒险战甲','2阶橙1星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004010200,1,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,4165},{4,104}]','[]',0,0,0,0),(1004010232,'冒险战甲','2阶橙2星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004010200,1,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,4165},{4,104}]','[]',0,0,0,0),(1004010241,'冒险战甲','2阶红1星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004010200,1,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6254},{4,156}]','[]',0,0,0,0),(1004010242,'冒险战甲','2阶红2星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004010200,1,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{2,6254},{4,156}]','[]',0,0,0,0),(1004010243,'冒险战甲','2阶红3星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004010200,1,1,0,4,0,0,0,'[{1,8}]',0,0,0,0,'[{2,6254},{4,156}]','[]',0,0,0,0),(1004010253,'冒险战甲','2阶粉色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004010200,1,1,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,10007},{4,250}]','[]',0,0,0,0),(1004010263,'冒险战甲','2阶神装衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004010200,1,1,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,12509},{4,313}]','[]',0,0,0,0),(1004010300,'勇者战甲','3阶绿色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004010300,1,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2982},{4,75}]','[]',0,0,0,0),(1004010310,'勇者战甲','3阶蓝色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004010300,1,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,4473},{4,112}]','[]',0,0,0,0),(1004010320,'勇者战甲','3阶紫色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004010300,1,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,8141},{4,204}]','[]',0,0,0,0),(1004010331,'勇者战甲','3阶橙1星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004010300,1,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{2,9930},{4,248}]','[]',0,0,0,0),(1004010332,'勇者战甲','3阶橙2星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004010300,1,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{2,9930},{4,248}]','[]',0,0,0,0),(1004010341,'勇者战甲','3阶红1星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004010300,1,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{2,14910},{4,373}]','[]',0,0,0,0),(1004010342,'勇者战甲','3阶红2星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004010300,1,1,0,4,0,0,0,'[{1,4}]',0,0,0,0,'[{2,14910},{4,373}]','[]',0,0,0,0),(1004010343,'勇者战甲','3阶红3星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004010300,1,1,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,14910},{4,373}]','[]',0,0,0,0),(1004010353,'勇者战甲','3阶粉色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004010300,1,1,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,23857},{4,596}]','[]',0,0,0,0),(1004010363,'勇者战甲','3阶神装衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004010300,1,1,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,29821},{4,746}]','[]',0,0,0,0),(1004010400,'先驱战甲','4阶绿色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004010400,1,100,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,6004},{4,150}]','[]',0,0,0,0),(1004010410,'先驱战甲','4阶蓝色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004010400,1,100,0,1,0,0,0,'[{1,2}]',0,0,0,0,'[{2,9006},{4,225}]','[]',0,0,0,0),(1004010420,'先驱战甲','4阶紫色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004010400,1,100,0,2,0,0,0,'[{1,3}]',0,0,0,0,'[{2,16391},{4,410}]','[]',0,0,0,0),(1004010431,'先驱战甲','4阶橙1星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004010400,1,100,0,3,0,0,0,'[{1,3}]',0,0,0,0,'[{2,19994},{4,500}]','[]',0,0,0,0),(1004010432,'先驱战甲','4阶橙2星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004010400,1,100,0,3,0,0,0,'[{1,4}]',0,0,0,0,'[{2,19994},{4,500}]','[]',0,0,0,0),(1004010441,'先驱战甲','4阶红1星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004010400,1,100,0,4,0,0,0,'[{1,8}]',0,0,0,0,'[{2,30021},{4,751}]','[]',0,0,0,0),(1004010442,'先驱战甲','4阶红2星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004010400,1,100,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,30021},{4,751}]','[]',0,0,0,0),(1004010443,'先驱战甲','4阶红3星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004010400,1,100,0,4,0,0,0,'[{1,34}]',0,0,0,0,'[{2,30021},{4,751}]','[]',0,0,0,0),(1004010453,'先驱战甲','4阶粉色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004010400,1,100,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,48034},{4,1201}]','[]',0,0,0,0),(1004010463,'先驱战甲','4阶神装衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004010400,1,100,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,60042},{4,1501}]','[]',0,0,0,0),(1004010500,'荣誉战甲','5阶绿色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004010500,1,150,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,10397},{4,260}]','[]',0,0,1,0),(1004010510,'荣誉战甲','5阶蓝色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004010500,1,150,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{2,15596},{4,390}]','[]',0,0,1,0),(1004010520,'荣誉战甲','5阶紫色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004010500,1,150,0,2,0,0,0,'[{1,5}]',0,0,0,0,'[{2,28384},{4,710}]','[]',0,0,1,0),(1004010531,'荣誉战甲','5阶橙1星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004010500,1,150,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,34623},{4,866}]','[]',0,0,1,0),(1004010532,'荣誉战甲','5阶橙2星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004010500,1,150,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{2,34623},{4,866}]','[]',0,0,1,0),(1004010541,'荣誉战甲','5阶红1星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004010500,1,150,0,4,0,0,0,'[{1,14}]',0,0,0,0,'[{2,51986},{4,1300}]','[]',0,0,1,0),(1004010542,'荣誉战甲','5阶红2星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004010500,1,150,0,4,0,0,0,'[{1,21}]',0,0,0,0,'[{2,51986},{4,1300}]','[]',0,0,1,0),(1004010543,'荣誉战甲','5阶红3星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004010500,1,150,0,4,0,0,0,'[{1,63}]',0,0,0,0,'[{2,51986},{4,1300}]','[]',0,0,1,0),(1004010553,'荣誉战甲','5阶粉色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004010500,1,150,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,83178},{4,2079}]','[]',0,0,1,0),(1004010563,'荣誉战甲','5阶神装衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004010500,1,150,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,103973},{4,2599}]','[]',0,0,1,0),(1004010600,'贤者战甲','6阶绿色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004010600,1,180,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,16241},{4,406}]','[]',0,0,1,0),(1004010610,'贤者战甲','6阶蓝色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004010600,1,180,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{2,24362},{4,609}]','[]',0,0,1,0),(1004010620,'贤者战甲','6阶紫色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004010600,1,180,0,2,0,0,0,'[{1,5}]',0,0,0,0,'[{2,44339},{4,1108}]','[]',0,0,1,0),(1004010631,'贤者战甲','6阶橙1星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004010600,1,180,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,54084},{4,1352}]','[]',0,0,1,0),(1004010632,'贤者战甲','6阶橙2星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004010600,1,180,0,3,0,0,0,'[{1,8}]',0,0,0,0,'[{2,54084},{4,1352}]','[]',0,0,1,0),(1004010641,'贤者战甲','6阶红1星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004010600,1,180,0,4,0,0,0,'[{1,18}]',0,0,0,0,'[{2,81207},{4,2030}]','[]',0,0,1,0),(1004010642,'贤者战甲','6阶红2星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004010600,1,180,0,4,0,0,0,'[{1,28}]',0,0,0,0,'[{2,81207},{4,2030}]','[]',0,0,1,0),(1004010643,'贤者战甲','6阶红3星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004010600,1,180,0,4,0,0,0,'[{1,104}]',0,0,0,0,'[{2,81207},{4,2030}]','[]',0,0,1,0),(1004010653,'贤者战甲','6阶粉色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004010600,1,180,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,129931},{4,3248}]','[]',0,0,1,0),(1004010663,'贤者战甲','6阶神装衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004010600,1,180,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,162413},{4,4060}]','[]',0,0,1,0),(1004010700,'征服战甲','7阶绿色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004010700,1,220,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,23616},{4,590}]','[]',0,0,2,0),(1004010710,'征服战甲','7阶蓝色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004010700,1,220,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{2,35425},{4,886}]','[]',0,0,2,0),(1004010720,'征服战甲','7阶紫色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004010700,1,220,0,2,0,0,0,'[{1,6}]',0,0,0,0,'[{2,64473},{4,1612}]','[]',0,0,2,0),(1004010731,'征服战甲','7阶橙1星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004010700,1,220,0,3,0,0,0,'[{1,8}]',0,0,0,0,'[{2,78643},{4,1966}]','[]',0,0,2,0),(1004010732,'征服战甲','7阶橙2星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004010700,1,220,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,78643},{4,1966}]','[]',0,0,2,0),(1004010741,'征服战甲','7阶红1星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004010700,1,220,0,4,0,0,0,'[{1,25}]',0,0,0,0,'[{2,118082},{4,2952}]','[]',0,0,2,0),(1004010742,'征服战甲','7阶红2星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004010700,1,220,0,4,0,0,0,'[{1,41}]',0,0,0,0,'[{2,118082},{4,2952}]','[]',0,0,2,0),(1004010743,'征服战甲','7阶红3星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004010700,1,220,0,4,0,0,0,'[{1,149}]',0,0,0,0,'[{2,118082},{4,2952}]','[]',0,0,2,0),(1004010753,'征服战甲','7阶粉色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004010700,1,220,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,188932},{4,4723}]','[]',0,0,2,0),(1004010763,'征服战甲','7阶神装衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004010700,1,220,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,236165},{4,5904}]','[]',0,0,2,0),(1004010800,'秩序战甲','8阶绿色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004010800,1,260,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,32603},{4,815}]','[]',0,0,2,0),(1004010810,'秩序战甲','8阶蓝色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004010800,1,260,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,48904},{4,1223}]','[]',0,0,2,0),(1004010820,'秩序战甲','8阶紫色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004010800,1,260,0,2,0,0,0,'[{1,7}]',0,0,0,0,'[{2,89005},{4,2225}]','[]',0,0,2,0),(1004010831,'秩序战甲','8阶橙1星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004010800,1,260,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{2,108567},{4,2714}]','[]',0,0,2,0),(1004010832,'秩序战甲','8阶橙2星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004010800,1,260,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{2,108567},{4,2714}]','[]',0,0,2,0),(1004010841,'秩序战甲','8阶红1星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004010800,1,260,0,4,0,0,0,'[{1,28}]',0,0,0,0,'[{2,163014},{4,4075}]','[]',0,0,2,0),(1004010842,'秩序战甲','8阶红2星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004010800,1,260,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{2,163014},{4,4075}]','[]',0,0,2,0),(1004010843,'秩序战甲','8阶红3星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004010800,1,260,0,4,0,0,0,'[{1,208}]',0,0,0,0,'[{2,163014},{4,4075}]','[]',0,0,2,0),(1004010853,'秩序战甲','8阶粉色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004010800,1,260,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,260822},{4,6521}]','[]',0,0,2,0),(1004010863,'秩序战甲','8阶神装衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004010800,1,260,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,326027},{4,8151}]','[]',0,0,2,0),(1004010900,'守护战甲','9阶绿色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004010900,1,300,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,43270},{4,1082}]','[]',0,0,3,0),(1004010910,'守护战甲','9阶蓝色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004010900,1,300,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,64905},{4,1623}]','[]',0,0,3,0),(1004010920,'守护战甲','9阶紫色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004010900,1,300,0,2,0,0,0,'[{1,7}]',0,0,0,0,'[{2,118128},{4,2953}]','[]',0,0,3,0),(1004010931,'守护战甲','9阶橙1星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004010900,1,300,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,144090},{4,3602}]','[]',0,0,3,0),(1004010932,'守护战甲','9阶橙2星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004010900,1,300,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{2,144090},{4,3602}]','[]',0,0,3,0),(1004010941,'守护战甲','9阶红1星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004010900,1,300,0,4,0,0,0,'[{1,33}]',0,0,0,0,'[{2,216351},{4,5409}]','[]',0,0,3,0),(1004010942,'守护战甲','9阶红2星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004010900,1,300,0,4,0,0,0,'[{1,55}]',0,0,0,0,'[{2,216351},{4,5409}]','[]',0,0,3,0),(1004010943,'守护战甲','9阶红3星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004010900,1,300,0,4,0,0,0,'[{1,290}]',0,0,0,0,'[{2,216351},{4,5409}]','[]',0,0,3,0),(1004010953,'守护战甲','9阶粉色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004010900,1,300,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,346161},{4,8654}]','[]',0,0,3,0),(1004010963,'守护战甲','9阶神装衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004010900,1,300,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,432702},{4,10818}]','[]',0,0,3,0),(1004011000,'信仰战甲','10阶绿色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004011000,1,355,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,55709},{4,1393}]','[]',0,0,4,0),(1004011010,'信仰战甲','10阶蓝色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004011000,1,355,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,83563},{4,2089}]','[]',0,0,4,0),(1004011020,'信仰战甲','10阶紫色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004011000,1,355,0,2,0,0,0,'[{1,8}]',0,0,0,0,'[{2,152085},{4,3802}]','[]',0,0,4,0),(1004011031,'信仰战甲','10阶橙1星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004011000,1,355,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,185510},{4,4638}]','[]',0,0,4,0),(1004011032,'信仰战甲','10阶橙2星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004011000,1,355,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{2,185510},{4,4638}]','[]',0,0,4,0),(1004011041,'信仰战甲','10阶红1星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004011000,1,355,0,4,0,0,0,'[{1,40}]',0,0,0,0,'[{2,278544},{4,6964}]','[]',0,0,4,0),(1004011042,'信仰战甲','10阶红2星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004011000,1,355,0,4,0,0,0,'[{1,69}]',0,0,0,0,'[{2,278544},{4,6964}]','[]',0,0,4,0),(1004011043,'信仰战甲','10阶红3星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004011000,1,355,0,4,0,0,0,'[{1,399}]',0,0,0,0,'[{2,278544},{4,6964}]','[]',0,0,4,0),(1004011053,'信仰战甲','10阶粉色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004011000,1,355,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,445671},{4,11142}]','[]',0,0,4,0),(1004011063,'信仰战甲','10阶神装衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004011000,1,355,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,557089},{4,13927}]','[]',0,0,4,0),(1004011100,'天行战甲','11阶绿色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004011100,1,400,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,69999},{4,1750}]','[]',0,0,4,0),(1004011110,'天行战甲','11阶蓝色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004011100,1,400,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,104998},{4,2625}]','[]',0,0,4,0),(1004011120,'天行战甲','11阶紫色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004011100,1,400,0,2,0,0,0,'[{1,9}]',0,0,0,0,'[{2,191097},{4,4777}]','[]',0,0,4,0),(1004011131,'天行战甲','11阶橙1星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004011100,1,400,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{2,233096},{4,5827}]','[]',0,0,4,0),(1004011132,'天行战甲','11阶橙2星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004011100,1,400,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{2,233096},{4,5827}]','[]',0,0,4,0),(1004011141,'天行战甲','11阶红1星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004011100,1,400,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{2,349994},{4,8750}]','[]',0,0,4,0),(1004011142,'天行战甲','11阶红2星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004011100,1,400,0,4,0,0,0,'[{1,78}]',0,0,0,0,'[{2,349994},{4,8750}]','[]',0,0,4,0),(1004011143,'天行战甲','11阶红3星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004011100,1,400,0,4,0,0,0,'[{1,549}]',0,0,0,0,'[{2,349994},{4,8750}]','[]',0,0,4,0),(1004011153,'天行战甲','11阶粉色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004011100,1,400,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,559991},{4,14000}]','[]',0,0,4,0),(1004011163,'天行战甲','11阶神装衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004011100,1,400,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,699988},{4,17500}]','[]',0,0,4,0),(1004011200,'命运战甲','12阶绿色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004011200,1,500,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,86220},{4,2156}]','[]',0,0,5,0),(1004011210,'命运战甲','12阶蓝色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004011200,1,500,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,129330},{4,3233}]','[]',0,0,5,0),(1004011220,'命运战甲','12阶紫色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004011200,1,500,0,2,0,0,0,'[{1,9}]',0,0,0,0,'[{2,235381},{4,5885}]','[]',0,0,5,0),(1004011231,'命运战甲','12阶橙1星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004011200,1,500,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{2,287113},{4,7178}]','[]',0,0,5,0),(1004011232,'命运战甲','12阶橙2星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004011200,1,500,0,3,0,0,0,'[{1,15}]',0,0,0,0,'[{2,287113},{4,7178}]','[]',0,0,5,0),(1004011241,'命运战甲','12阶红1星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004011200,1,500,0,4,0,0,0,'[{1,62}]',0,0,0,0,'[{2,431101},{4,10778}]','[]',0,0,5,0),(1004011242,'命运战甲','12阶红2星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004011200,1,500,0,4,0,0,0,'[{1,110}]',0,0,0,0,'[{2,431101},{4,10778}]','[]',0,0,5,0),(1004011243,'命运战甲','12阶红3星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004011200,1,500,0,4,0,0,0,'[{1,799}]',0,0,0,0,'[{2,431101},{4,10778}]','[]',0,0,5,0),(1004011253,'命运战甲','12阶粉色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004011200,1,500,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,689761},{4,17244}]','[]',0,0,5,0),(1004011263,'命运战甲','12阶神装衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004011200,1,500,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,862201},{4,21555}]','[]',0,0,5,0),(1004011300,'制裁战甲','13阶绿色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004011300,1,520,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,104453},{4,2611}]','[]',0,0,5,0),(1004011310,'制裁战甲','13阶蓝色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004011300,1,520,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,156679},{4,3917}]','[]',0,0,5,0),(1004011320,'制裁战甲','13阶紫色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004011300,1,520,0,2,0,0,0,'[{1,10}]',0,0,0,0,'[{2,285156},{4,7129}]','[]',0,0,5,0),(1004011331,'制裁战甲','13阶橙1星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004011300,1,520,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{2,347828},{4,8696}]','[]',0,0,5,0),(1004011332,'制裁战甲','13阶橙2星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004011300,1,520,0,3,0,0,0,'[{1,17}]',0,0,0,0,'[{2,347828},{4,8696}]','[]',0,0,5,0),(1004011341,'制裁战甲','13阶红1星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004011300,1,520,0,4,0,0,0,'[{1,72}]',0,0,0,0,'[{2,522264},{4,13057}]','[]',0,0,5,0),(1004011342,'制裁战甲','13阶红2星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004011300,1,520,0,4,0,0,0,'[{1,128}]',0,0,0,0,'[{2,522264},{4,13057}]','[]',0,0,5,0),(1004011343,'制裁战甲','13阶红3星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004011300,1,520,0,4,0,0,0,'[{1,1117}]',0,0,0,0,'[{2,522264},{4,13057}]','[]',0,0,5,0),(1004011353,'制裁战甲','13阶粉色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004011300,1,520,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,835623},{4,20891}]','[]',0,0,5,0),(1004011363,'制裁战甲','13阶神装衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004011300,1,520,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,1044529},{4,26113}]','[]',0,0,5,0),(1004011400,'审判战甲','14阶绿色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004011400,1,620,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,124777},{4,3119}]','[]',0,0,6,0),(1004011410,'审判战甲','14阶蓝色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004011400,1,620,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{2,187166},{4,4679}]','[]',0,0,6,0),(1004011420,'审判战甲','14阶紫色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004011400,1,620,0,2,0,0,0,'[{1,11}]',0,0,0,0,'[{2,340641},{4,8516}]','[]',0,0,6,0),(1004011431,'审判战甲','14阶橙1星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004011400,1,620,0,3,0,0,0,'[{1,15}]',0,0,0,0,'[{2,415508},{4,10388}]','[]',0,0,6,0),(1004011432,'审判战甲','14阶橙2星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004011400,1,620,0,3,0,0,0,'[{1,19}]',0,0,0,0,'[{2,415508},{4,10388}]','[]',0,0,6,0),(1004011441,'审判战甲','14阶红1星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004011400,1,620,0,4,0,0,0,'[{1,82}]',0,0,0,0,'[{2,623885},{4,15597}]','[]',0,0,6,0),(1004011442,'审判战甲','14阶红2星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004011400,1,620,0,4,0,0,0,'[{1,146}]',0,0,0,0,'[{2,623885},{4,15597}]','[]',0,0,6,0),(1004011443,'审判战甲','14阶红3星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004011400,1,620,0,4,0,0,0,'[{1,1444}]',0,0,0,0,'[{2,623885},{4,15597}]','[]',0,0,6,0),(1004011453,'审判战甲','14阶粉色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004011400,1,620,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,998216},{4,24955}]','[]',0,0,6,0),(1004011463,'审判战甲','14阶神装衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004011400,1,620,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,1247770},{4,31194}]','[]',0,0,6,0),(1004011500,'毁灭战甲','15阶绿色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004011500,1,650,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,147273},{4,3682}]','[]',0,0,6,0),(1004011510,'毁灭战甲','15阶蓝色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004011500,1,650,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{2,220909},{4,5523}]','[]',0,0,6,0),(1004011520,'毁灭战甲','15阶紫色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004011500,1,650,0,2,0,0,0,'[{1,12}]',0,0,0,0,'[{2,402055},{4,10051}]','[]',0,0,6,0),(1004011531,'毁灭战甲','15阶橙1星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004011500,1,650,0,3,0,0,0,'[{1,16}]',0,0,0,0,'[{2,490418},{4,12260}]','[]',0,0,6,0),(1004011532,'毁灭战甲','15阶橙2星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004011500,1,650,0,3,0,0,0,'[{1,20}]',0,0,0,0,'[{2,490418},{4,12260}]','[]',0,0,6,0),(1004011541,'毁灭战甲','15阶红1星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004011500,1,650,0,4,0,0,0,'[{1,92}]',0,0,0,0,'[{2,736364},{4,18409}]','[]',0,0,6,0),(1004011542,'毁灭战甲','15阶红2星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004011500,1,650,0,4,0,0,0,'[{1,164}]',0,0,0,0,'[{2,736364},{4,18409}]','[]',0,0,6,0),(1004011543,'毁灭战甲','15阶红3星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004011500,1,650,0,4,0,0,0,'[{1,1717}]',0,0,0,0,'[{2,736364},{4,18409}]','[]',0,0,6,0),(1004011553,'毁灭战甲','15阶粉色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004011500,1,650,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,1178182},{4,29455}]','[]',0,0,6,0),(1004011563,'毁灭战甲','15阶神装衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004011500,1,650,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,1472727},{4,36818}]','[]',0,0,6,0),(1004011600,'混沌战甲','16阶绿色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004011500,1,700,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{2,172020},{4,4300}]','[]',0,0,6,0),(1004011610,'混沌战甲','16阶蓝色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004011500,1,700,0,1,0,0,0,'[{1,7}]',0,0,0,0,'[{2,258030},{4,6451}]','[]',0,0,6,0),(1004011620,'混沌战甲','16阶紫色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004011500,1,700,0,2,0,0,0,'[{1,14}]',0,0,0,0,'[{2,469615},{4,11740}]','[]',0,0,6,0),(1004011631,'混沌战甲','16阶橙1星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004011500,1,700,0,3,0,0,0,'[{1,19}]',0,0,0,0,'[{2,572827},{4,14321}]','[]',0,0,6,0),(1004011632,'混沌战甲','16阶橙2星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004011500,1,700,0,3,0,0,0,'[{1,23}]',0,0,0,0,'[{2,572827},{4,14321}]','[]',0,0,6,0),(1004011641,'混沌战甲','16阶红1星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004011500,1,700,0,4,0,0,0,'[{1,112}]',0,0,0,0,'[{2,860100},{4,21502}]','[]',0,0,6,0),(1004011642,'混沌战甲','16阶红2星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004011500,1,700,0,4,0,0,0,'[{1,200}]',0,0,0,0,'[{2,860100},{4,21502}]','[]',0,0,6,0),(1004011643,'混沌战甲','16阶红3星衣服【魔剑士】','',0,'','',0,1,1,10,4,1,2,4,1004011500,1,700,0,4,0,0,0,'[{1,2044}]',0,0,0,0,'[{2,860100},{4,21502}]','[]',0,0,6,0),(1004011653,'混沌战甲','16阶粉色衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004011500,1,700,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,1376160},{4,34404}]','[]',0,0,6,0),(1004011663,'混沌战甲','16阶神装衣服【魔剑士】','',0,'','',0,0,1,10,4,0,0,4,1004011500,1,700,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,1720200},{4,43005}]','[]',0,0,6,0),(1004020100,'学徒胸甲','1阶绿色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004020100,2,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,731},{4,18}]','[]',0,0,0,0),(1004020110,'学徒胸甲','1阶蓝色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004020100,2,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1096},{4,27}]','[]',0,0,0,0),(1004020120,'学徒胸甲','1阶紫色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004020100,2,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1994},{4,50}]','[]',0,0,0,0),(1004020131,'学徒胸甲','1阶橙1星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004020100,2,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2433},{4,61}]','[]',0,0,0,0),(1004020132,'学徒胸甲','1阶橙2星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004020100,2,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2433},{4,61}]','[]',0,0,0,0),(1004020141,'学徒胸甲','1阶红1星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004020100,2,1,0,4,0,0,0,'[{1,1}]',0,0,0,0,'[{2,3653},{4,91}]','[]',0,0,0,0),(1004020142,'学徒胸甲','1阶红2星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004020100,2,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{2,3653},{4,91}]','[]',0,0,0,0),(1004020143,'学徒胸甲','1阶红3星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004020100,2,1,0,4,0,0,0,'[{1,5}]',0,0,0,0,'[{2,3653},{4,91}]','[]',0,0,0,0),(1004020153,'学徒胸甲','1阶粉色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004020100,2,1,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,5844},{4,146}]','[]',0,0,0,0),(1004020163,'学徒胸甲','1阶神装衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004020100,2,1,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,7305},{4,183}]','[]',0,0,0,0),(1004020200,'冒险胸甲','2阶绿色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004020200,2,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1251},{4,31}]','[]',0,0,0,0),(1004020210,'冒险胸甲','2阶蓝色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004020200,2,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1876},{4,47}]','[]',0,0,0,0),(1004020220,'冒险胸甲','2阶紫色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004020200,2,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,3415},{4,85}]','[]',0,0,0,0),(1004020231,'冒险胸甲','2阶橙1星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004020200,2,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,4165},{4,104}]','[]',0,0,0,0),(1004020232,'冒险胸甲','2阶橙2星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004020200,2,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,4165},{4,104}]','[]',0,0,0,0),(1004020241,'冒险胸甲','2阶红1星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004020200,2,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6254},{4,156}]','[]',0,0,0,0),(1004020242,'冒险胸甲','2阶红2星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004020200,2,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{2,6254},{4,156}]','[]',0,0,0,0),(1004020243,'冒险胸甲','2阶红3星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004020200,2,1,0,4,0,0,0,'[{1,8}]',0,0,0,0,'[{2,6254},{4,156}]','[]',0,0,0,0),(1004020253,'冒险胸甲','2阶粉色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004020200,2,1,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,10007},{4,250}]','[]',0,0,0,0),(1004020263,'冒险胸甲','2阶神装衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004020200,2,1,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,12509},{4,313}]','[]',0,0,0,0),(1004020300,'勇者胸甲','3阶绿色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004020300,2,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2982},{4,75}]','[]',0,0,0,0),(1004020310,'勇者胸甲','3阶蓝色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004020300,2,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,4473},{4,112}]','[]',0,0,0,0),(1004020320,'勇者胸甲','3阶紫色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004020300,2,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,8141},{4,204}]','[]',0,0,0,0),(1004020331,'勇者胸甲','3阶橙1星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004020300,2,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{2,9930},{4,248}]','[]',0,0,0,0),(1004020332,'勇者胸甲','3阶橙2星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004020300,2,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{2,9930},{4,248}]','[]',0,0,0,0),(1004020341,'勇者胸甲','3阶红1星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004020300,2,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{2,14910},{4,373}]','[]',0,0,0,0),(1004020342,'勇者胸甲','3阶红2星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004020300,2,1,0,4,0,0,0,'[{1,4}]',0,0,0,0,'[{2,14910},{4,373}]','[]',0,0,0,0),(1004020343,'勇者胸甲','3阶红3星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004020300,2,1,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,14910},{4,373}]','[]',0,0,0,0),(1004020353,'勇者胸甲','3阶粉色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004020300,2,1,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,23857},{4,596}]','[]',0,0,0,0),(1004020363,'勇者胸甲','3阶神装衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004020300,2,1,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,29821},{4,746}]','[]',0,0,0,0),(1004020400,'先驱胸甲','4阶绿色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004020400,2,100,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,6004},{4,150}]','[]',0,0,0,0),(1004020410,'先驱胸甲','4阶蓝色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004020400,2,100,0,1,0,0,0,'[{1,2}]',0,0,0,0,'[{2,9006},{4,225}]','[]',0,0,0,0),(1004020420,'先驱胸甲','4阶紫色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004020400,2,100,0,2,0,0,0,'[{1,3}]',0,0,0,0,'[{2,16391},{4,410}]','[]',0,0,0,0),(1004020431,'先驱胸甲','4阶橙1星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004020400,2,100,0,3,0,0,0,'[{1,3}]',0,0,0,0,'[{2,19994},{4,500}]','[]',0,0,0,0),(1004020432,'先驱胸甲','4阶橙2星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004020400,2,100,0,3,0,0,0,'[{1,4}]',0,0,0,0,'[{2,19994},{4,500}]','[]',0,0,0,0),(1004020441,'先驱胸甲','4阶红1星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004020400,2,100,0,4,0,0,0,'[{1,8}]',0,0,0,0,'[{2,30021},{4,751}]','[]',0,0,0,0),(1004020442,'先驱胸甲','4阶红2星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004020400,2,100,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,30021},{4,751}]','[]',0,0,0,0),(1004020443,'先驱胸甲','4阶红3星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004020400,2,100,0,4,0,0,0,'[{1,34}]',0,0,0,0,'[{2,30021},{4,751}]','[]',0,0,0,0),(1004020453,'先驱胸甲','4阶粉色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004020400,2,100,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,48034},{4,1201}]','[]',0,0,0,0),(1004020463,'先驱胸甲','4阶神装衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004020400,2,100,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,60042},{4,1501}]','[]',0,0,0,0),(1004020500,'荣誉胸甲','5阶绿色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004020500,2,150,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,10397},{4,260}]','[]',0,0,1,0),(1004020510,'荣誉胸甲','5阶蓝色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004020500,2,150,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{2,15596},{4,390}]','[]',0,0,1,0),(1004020520,'荣誉胸甲','5阶紫色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004020500,2,150,0,2,0,0,0,'[{1,5}]',0,0,0,0,'[{2,28384},{4,710}]','[]',0,0,1,0),(1004020531,'荣誉胸甲','5阶橙1星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004020500,2,150,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,34623},{4,866}]','[]',0,0,1,0),(1004020532,'荣誉胸甲','5阶橙2星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004020500,2,150,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{2,34623},{4,866}]','[]',0,0,1,0),(1004020541,'荣誉胸甲','5阶红1星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004020500,2,150,0,4,0,0,0,'[{1,14}]',0,0,0,0,'[{2,51986},{4,1300}]','[]',0,0,1,0),(1004020542,'荣誉胸甲','5阶红2星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004020500,2,150,0,4,0,0,0,'[{1,21}]',0,0,0,0,'[{2,51986},{4,1300}]','[]',0,0,1,0),(1004020543,'荣誉胸甲','5阶红3星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004020500,2,150,0,4,0,0,0,'[{1,63}]',0,0,0,0,'[{2,51986},{4,1300}]','[]',0,0,1,0),(1004020553,'荣誉胸甲','5阶粉色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004020500,2,150,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,83178},{4,2079}]','[]',0,0,1,0),(1004020563,'荣誉胸甲','5阶神装衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004020500,2,150,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,103973},{4,2599}]','[]',0,0,1,0),(1004020600,'贤者胸甲','6阶绿色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004020600,2,180,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,16241},{4,406}]','[]',0,0,1,0),(1004020610,'贤者胸甲','6阶蓝色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004020600,2,180,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{2,24362},{4,609}]','[]',0,0,1,0),(1004020620,'贤者胸甲','6阶紫色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004020600,2,180,0,2,0,0,0,'[{1,5}]',0,0,0,0,'[{2,44339},{4,1108}]','[]',0,0,1,0),(1004020631,'贤者胸甲','6阶橙1星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004020600,2,180,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,54084},{4,1352}]','[]',0,0,1,0),(1004020632,'贤者胸甲','6阶橙2星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004020600,2,180,0,3,0,0,0,'[{1,8}]',0,0,0,0,'[{2,54084},{4,1352}]','[]',0,0,1,0),(1004020641,'贤者胸甲','6阶红1星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004020600,2,180,0,4,0,0,0,'[{1,18}]',0,0,0,0,'[{2,81207},{4,2030}]','[]',0,0,1,0),(1004020642,'贤者胸甲','6阶红2星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004020600,2,180,0,4,0,0,0,'[{1,28}]',0,0,0,0,'[{2,81207},{4,2030}]','[]',0,0,1,0),(1004020643,'贤者胸甲','6阶红3星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004020600,2,180,0,4,0,0,0,'[{1,104}]',0,0,0,0,'[{2,81207},{4,2030}]','[]',0,0,1,0),(1004020653,'贤者胸甲','6阶粉色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004020600,2,180,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,129931},{4,3248}]','[]',0,0,1,0),(1004020663,'贤者胸甲','6阶神装衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004020600,2,180,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,162413},{4,4060}]','[]',0,0,1,0),(1004020700,'征服胸甲','7阶绿色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004020700,2,220,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,23616},{4,590}]','[]',0,0,2,0),(1004020710,'征服胸甲','7阶蓝色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004020700,2,220,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{2,35425},{4,886}]','[]',0,0,2,0),(1004020720,'征服胸甲','7阶紫色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004020700,2,220,0,2,0,0,0,'[{1,6}]',0,0,0,0,'[{2,64473},{4,1612}]','[]',0,0,2,0),(1004020731,'征服胸甲','7阶橙1星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004020700,2,220,0,3,0,0,0,'[{1,8}]',0,0,0,0,'[{2,78643},{4,1966}]','[]',0,0,2,0),(1004020732,'征服胸甲','7阶橙2星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004020700,2,220,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,78643},{4,1966}]','[]',0,0,2,0),(1004020741,'征服胸甲','7阶红1星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004020700,2,220,0,4,0,0,0,'[{1,25}]',0,0,0,0,'[{2,118082},{4,2952}]','[]',0,0,2,0),(1004020742,'征服胸甲','7阶红2星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004020700,2,220,0,4,0,0,0,'[{1,41}]',0,0,0,0,'[{2,118082},{4,2952}]','[]',0,0,2,0),(1004020743,'征服胸甲','7阶红3星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004020700,2,220,0,4,0,0,0,'[{1,149}]',0,0,0,0,'[{2,118082},{4,2952}]','[]',0,0,2,0),(1004020753,'征服胸甲','7阶粉色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004020700,2,220,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,188932},{4,4723}]','[]',0,0,2,0),(1004020763,'征服胸甲','7阶神装衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004020700,2,220,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,236165},{4,5904}]','[]',0,0,2,0),(1004020800,'秩序胸甲','8阶绿色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004020800,2,260,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,32603},{4,815}]','[]',0,0,2,0),(1004020810,'秩序胸甲','8阶蓝色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004020800,2,260,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,48904},{4,1223}]','[]',0,0,2,0),(1004020820,'秩序胸甲','8阶紫色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004020800,2,260,0,2,0,0,0,'[{1,7}]',0,0,0,0,'[{2,89005},{4,2225}]','[]',0,0,2,0),(1004020831,'秩序胸甲','8阶橙1星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004020800,2,260,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{2,108567},{4,2714}]','[]',0,0,2,0),(1004020832,'秩序胸甲','8阶橙2星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004020800,2,260,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{2,108567},{4,2714}]','[]',0,0,2,0),(1004020841,'秩序胸甲','8阶红1星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004020800,2,260,0,4,0,0,0,'[{1,28}]',0,0,0,0,'[{2,163014},{4,4075}]','[]',0,0,2,0),(1004020842,'秩序胸甲','8阶红2星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004020800,2,260,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{2,163014},{4,4075}]','[]',0,0,2,0),(1004020843,'秩序胸甲','8阶红3星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004020800,2,260,0,4,0,0,0,'[{1,208}]',0,0,0,0,'[{2,163014},{4,4075}]','[]',0,0,2,0),(1004020853,'秩序胸甲','8阶粉色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004020800,2,260,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,260822},{4,6521}]','[]',0,0,2,0),(1004020863,'秩序胸甲','8阶神装衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004020800,2,260,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,326027},{4,8151}]','[]',0,0,2,0),(1004020900,'守护胸甲','9阶绿色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004020900,2,300,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,43270},{4,1082}]','[]',0,0,3,0),(1004020910,'守护胸甲','9阶蓝色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004020900,2,300,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,64905},{4,1623}]','[]',0,0,3,0),(1004020920,'守护胸甲','9阶紫色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004020900,2,300,0,2,0,0,0,'[{1,7}]',0,0,0,0,'[{2,118128},{4,2953}]','[]',0,0,3,0),(1004020931,'守护胸甲','9阶橙1星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004020900,2,300,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,144090},{4,3602}]','[]',0,0,3,0),(1004020932,'守护胸甲','9阶橙2星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004020900,2,300,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{2,144090},{4,3602}]','[]',0,0,3,0),(1004020941,'守护胸甲','9阶红1星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004020900,2,300,0,4,0,0,0,'[{1,33}]',0,0,0,0,'[{2,216351},{4,5409}]','[]',0,0,3,0),(1004020942,'守护胸甲','9阶红2星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004020900,2,300,0,4,0,0,0,'[{1,55}]',0,0,0,0,'[{2,216351},{4,5409}]','[]',0,0,3,0),(1004020943,'守护胸甲','9阶红3星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004020900,2,300,0,4,0,0,0,'[{1,290}]',0,0,0,0,'[{2,216351},{4,5409}]','[]',0,0,3,0),(1004020953,'守护胸甲','9阶粉色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004020900,2,300,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,346161},{4,8654}]','[]',0,0,3,0),(1004020963,'守护胸甲','9阶神装衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004020900,2,300,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,432702},{4,10818}]','[]',0,0,3,0),(1004021000,'信仰胸甲','10阶绿色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004021000,2,355,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,55709},{4,1393}]','[]',0,0,4,0),(1004021010,'信仰胸甲','10阶蓝色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004021000,2,355,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,83563},{4,2089}]','[]',0,0,4,0),(1004021020,'信仰胸甲','10阶紫色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004021000,2,355,0,2,0,0,0,'[{1,8}]',0,0,0,0,'[{2,152085},{4,3802}]','[]',0,0,4,0),(1004021031,'信仰胸甲','10阶橙1星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004021000,2,355,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,185510},{4,4638}]','[]',0,0,4,0),(1004021032,'信仰胸甲','10阶橙2星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004021000,2,355,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{2,185510},{4,4638}]','[]',0,0,4,0),(1004021041,'信仰胸甲','10阶红1星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004021000,2,355,0,4,0,0,0,'[{1,40}]',0,0,0,0,'[{2,278544},{4,6964}]','[]',0,0,4,0),(1004021042,'信仰胸甲','10阶红2星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004021000,2,355,0,4,0,0,0,'[{1,69}]',0,0,0,0,'[{2,278544},{4,6964}]','[]',0,0,4,0),(1004021043,'信仰胸甲','10阶红3星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004021000,2,355,0,4,0,0,0,'[{1,399}]',0,0,0,0,'[{2,278544},{4,6964}]','[]',0,0,4,0),(1004021053,'信仰胸甲','10阶粉色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004021000,2,355,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,445671},{4,11142}]','[]',0,0,4,0),(1004021063,'信仰胸甲','10阶神装衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004021000,2,355,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,557089},{4,13927}]','[]',0,0,4,0),(1004021100,'天行胸甲','11阶绿色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004021100,2,400,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,69999},{4,1750}]','[]',0,0,4,0),(1004021110,'天行胸甲','11阶蓝色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004021100,2,400,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,104998},{4,2625}]','[]',0,0,4,0),(1004021120,'天行胸甲','11阶紫色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004021100,2,400,0,2,0,0,0,'[{1,9}]',0,0,0,0,'[{2,191097},{4,4777}]','[]',0,0,4,0),(1004021131,'天行胸甲','11阶橙1星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004021100,2,400,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{2,233096},{4,5827}]','[]',0,0,4,0),(1004021132,'天行胸甲','11阶橙2星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004021100,2,400,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{2,233096},{4,5827}]','[]',0,0,4,0),(1004021141,'天行胸甲','11阶红1星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004021100,2,400,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{2,349994},{4,8750}]','[]',0,0,4,0),(1004021142,'天行胸甲','11阶红2星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004021100,2,400,0,4,0,0,0,'[{1,78}]',0,0,0,0,'[{2,349994},{4,8750}]','[]',0,0,4,0),(1004021143,'天行胸甲','11阶红3星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004021100,2,400,0,4,0,0,0,'[{1,549}]',0,0,0,0,'[{2,349994},{4,8750}]','[]',0,0,4,0),(1004021153,'天行胸甲','11阶粉色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004021100,2,400,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,559991},{4,14000}]','[]',0,0,4,0),(1004021163,'天行胸甲','11阶神装衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004021100,2,400,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,699988},{4,17500}]','[]',0,0,4,0),(1004021200,'命运胸甲','12阶绿色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004021200,2,500,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,86220},{4,2156}]','[]',0,0,5,0),(1004021210,'命运胸甲','12阶蓝色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004021200,2,500,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,129330},{4,3233}]','[]',0,0,5,0),(1004021220,'命运胸甲','12阶紫色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004021200,2,500,0,2,0,0,0,'[{1,9}]',0,0,0,0,'[{2,235381},{4,5885}]','[]',0,0,5,0),(1004021231,'命运胸甲','12阶橙1星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004021200,2,500,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{2,287113},{4,7178}]','[]',0,0,5,0),(1004021232,'命运胸甲','12阶橙2星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004021200,2,500,0,3,0,0,0,'[{1,15}]',0,0,0,0,'[{2,287113},{4,7178}]','[]',0,0,5,0),(1004021241,'命运胸甲','12阶红1星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004021200,2,500,0,4,0,0,0,'[{1,62}]',0,0,0,0,'[{2,431101},{4,10778}]','[]',0,0,5,0),(1004021242,'命运胸甲','12阶红2星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004021200,2,500,0,4,0,0,0,'[{1,110}]',0,0,0,0,'[{2,431101},{4,10778}]','[]',0,0,5,0),(1004021243,'命运胸甲','12阶红3星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004021200,2,500,0,4,0,0,0,'[{1,799}]',0,0,0,0,'[{2,431101},{4,10778}]','[]',0,0,5,0),(1004021253,'命运胸甲','12阶粉色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004021200,2,500,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,689761},{4,17244}]','[]',0,0,5,0),(1004021263,'命运胸甲','12阶神装衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004021200,2,500,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,862201},{4,21555}]','[]',0,0,5,0),(1004021300,'制裁胸甲','13阶绿色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004021300,2,520,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,104453},{4,2611}]','[]',0,0,5,0),(1004021310,'制裁胸甲','13阶蓝色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004021300,2,520,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,156679},{4,3917}]','[]',0,0,5,0),(1004021320,'制裁胸甲','13阶紫色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004021300,2,520,0,2,0,0,0,'[{1,10}]',0,0,0,0,'[{2,285156},{4,7129}]','[]',0,0,5,0),(1004021331,'制裁胸甲','13阶橙1星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004021300,2,520,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{2,347828},{4,8696}]','[]',0,0,5,0),(1004021332,'制裁胸甲','13阶橙2星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004021300,2,520,0,3,0,0,0,'[{1,17}]',0,0,0,0,'[{2,347828},{4,8696}]','[]',0,0,5,0),(1004021341,'制裁胸甲','13阶红1星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004021300,2,520,0,4,0,0,0,'[{1,72}]',0,0,0,0,'[{2,522264},{4,13057}]','[]',0,0,5,0),(1004021342,'制裁胸甲','13阶红2星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004021300,2,520,0,4,0,0,0,'[{1,128}]',0,0,0,0,'[{2,522264},{4,13057}]','[]',0,0,5,0),(1004021343,'制裁胸甲','13阶红3星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004021300,2,520,0,4,0,0,0,'[{1,1117}]',0,0,0,0,'[{2,522264},{4,13057}]','[]',0,0,5,0),(1004021353,'制裁胸甲','13阶粉色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004021300,2,520,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,835623},{4,20891}]','[]',0,0,5,0),(1004021363,'制裁胸甲','13阶神装衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004021300,2,520,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,1044529},{4,26113}]','[]',0,0,5,0),(1004021400,'审判胸甲','14阶绿色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004021400,2,620,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,124777},{4,3119}]','[]',0,0,6,0),(1004021410,'审判胸甲','14阶蓝色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004021400,2,620,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{2,187166},{4,4679}]','[]',0,0,6,0),(1004021420,'审判胸甲','14阶紫色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004021400,2,620,0,2,0,0,0,'[{1,11}]',0,0,0,0,'[{2,340641},{4,8516}]','[]',0,0,6,0),(1004021431,'审判胸甲','14阶橙1星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004021400,2,620,0,3,0,0,0,'[{1,15}]',0,0,0,0,'[{2,415508},{4,10388}]','[]',0,0,6,0),(1004021432,'审判胸甲','14阶橙2星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004021400,2,620,0,3,0,0,0,'[{1,19}]',0,0,0,0,'[{2,415508},{4,10388}]','[]',0,0,6,0),(1004021441,'审判胸甲','14阶红1星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004021400,2,620,0,4,0,0,0,'[{1,82}]',0,0,0,0,'[{2,623885},{4,15597}]','[]',0,0,6,0),(1004021442,'审判胸甲','14阶红2星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004021400,2,620,0,4,0,0,0,'[{1,146}]',0,0,0,0,'[{2,623885},{4,15597}]','[]',0,0,6,0),(1004021443,'审判胸甲','14阶红3星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004021400,2,620,0,4,0,0,0,'[{1,1444}]',0,0,0,0,'[{2,623885},{4,15597}]','[]',0,0,6,0),(1004021453,'审判胸甲','14阶粉色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004021400,2,620,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,998216},{4,24955}]','[]',0,0,6,0),(1004021463,'审判胸甲','14阶神装衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004021400,2,620,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,1247770},{4,31194}]','[]',0,0,6,0),(1004021500,'毁灭胸甲','15阶绿色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004021500,2,650,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,147273},{4,3682}]','[]',0,0,6,0),(1004021510,'毁灭胸甲','15阶蓝色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004021500,2,650,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{2,220909},{4,5523}]','[]',0,0,6,0),(1004021520,'毁灭胸甲','15阶紫色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004021500,2,650,0,2,0,0,0,'[{1,12}]',0,0,0,0,'[{2,402055},{4,10051}]','[]',0,0,6,0),(1004021531,'毁灭胸甲','15阶橙1星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004021500,2,650,0,3,0,0,0,'[{1,16}]',0,0,0,0,'[{2,490418},{4,12260}]','[]',0,0,6,0),(1004021532,'毁灭胸甲','15阶橙2星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004021500,2,650,0,3,0,0,0,'[{1,20}]',0,0,0,0,'[{2,490418},{4,12260}]','[]',0,0,6,0),(1004021541,'毁灭胸甲','15阶红1星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004021500,2,650,0,4,0,0,0,'[{1,92}]',0,0,0,0,'[{2,736364},{4,18409}]','[]',0,0,6,0),(1004021542,'毁灭胸甲','15阶红2星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004021500,2,650,0,4,0,0,0,'[{1,164}]',0,0,0,0,'[{2,736364},{4,18409}]','[]',0,0,6,0),(1004021543,'毁灭胸甲','15阶红3星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004021500,2,650,0,4,0,0,0,'[{1,1717}]',0,0,0,0,'[{2,736364},{4,18409}]','[]',0,0,6,0),(1004021553,'毁灭胸甲','15阶粉色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004021500,2,650,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,1178182},{4,29455}]','[]',0,0,6,0),(1004021563,'毁灭胸甲','15阶神装衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004021500,2,650,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,1472727},{4,36818}]','[]',0,0,6,0),(1004021600,'混沌胸甲','16阶绿色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004021500,2,700,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{2,172020},{4,4300}]','[]',0,0,6,0),(1004021610,'混沌胸甲','16阶蓝色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004021500,2,700,0,1,0,0,0,'[{1,7}]',0,0,0,0,'[{2,258030},{4,6451}]','[]',0,0,6,0),(1004021620,'混沌胸甲','16阶紫色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004021500,2,700,0,2,0,0,0,'[{1,14}]',0,0,0,0,'[{2,469615},{4,11740}]','[]',0,0,6,0),(1004021631,'混沌胸甲','16阶橙1星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004021500,2,700,0,3,0,0,0,'[{1,19}]',0,0,0,0,'[{2,572827},{4,14321}]','[]',0,0,6,0),(1004021632,'混沌胸甲','16阶橙2星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004021500,2,700,0,3,0,0,0,'[{1,23}]',0,0,0,0,'[{2,572827},{4,14321}]','[]',0,0,6,0),(1004021641,'混沌胸甲','16阶红1星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004021500,2,700,0,4,0,0,0,'[{1,112}]',0,0,0,0,'[{2,860100},{4,21502}]','[]',0,0,6,0),(1004021642,'混沌胸甲','16阶红2星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004021500,2,700,0,4,0,0,0,'[{1,200}]',0,0,0,0,'[{2,860100},{4,21502}]','[]',0,0,6,0),(1004021643,'混沌胸甲','16阶红3星衣服【龙骑士】','',0,'','',0,1,1,10,4,1,2,4,1004021500,2,700,0,4,0,0,0,'[{1,2044}]',0,0,0,0,'[{2,860100},{4,21502}]','[]',0,0,6,0),(1004021653,'混沌胸甲','16阶粉色衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004021500,2,700,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,1376160},{4,34404}]','[]',0,0,6,0),(1004021663,'混沌胸甲','16阶神装衣服【龙骑士】','',0,'','',0,0,1,10,4,0,0,4,1004021500,2,700,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,1720200},{4,43005}]','[]',0,0,6,0),(1004030100,'学徒裙甲','1阶绿色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004030100,3,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,731},{4,18}]','[]',0,0,0,0),(1004030110,'学徒裙甲','1阶蓝色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004030100,3,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1096},{4,27}]','[]',0,0,0,0),(1004030120,'学徒裙甲','1阶紫色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004030100,3,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1994},{4,50}]','[]',0,0,0,0),(1004030131,'学徒裙甲','1阶橙1星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004030100,3,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2433},{4,61}]','[]',0,0,0,0),(1004030132,'学徒裙甲','1阶橙2星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004030100,3,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2433},{4,61}]','[]',0,0,0,0),(1004030141,'学徒裙甲','1阶红1星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004030100,3,1,0,4,0,0,0,'[{1,1}]',0,0,0,0,'[{2,3653},{4,91}]','[]',0,0,0,0),(1004030142,'学徒裙甲','1阶红2星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004030100,3,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{2,3653},{4,91}]','[]',0,0,0,0),(1004030143,'学徒裙甲','1阶红3星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004030100,3,1,0,4,0,0,0,'[{1,5}]',0,0,0,0,'[{2,3653},{4,91}]','[]',0,0,0,0),(1004030153,'学徒裙甲','1阶粉色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004030100,3,1,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,5844},{4,146}]','[]',0,0,0,0),(1004030163,'学徒裙甲','1阶神装衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004030100,3,1,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,7305},{4,183}]','[]',0,0,0,0),(1004030200,'冒险裙甲','2阶绿色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004030200,3,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1251},{4,31}]','[]',0,0,0,0),(1004030210,'冒险裙甲','2阶蓝色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004030200,3,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1876},{4,47}]','[]',0,0,0,0),(1004030220,'冒险裙甲','2阶紫色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004030200,3,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,3415},{4,85}]','[]',0,0,0,0),(1004030231,'冒险裙甲','2阶橙1星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004030200,3,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,4165},{4,104}]','[]',0,0,0,0),(1004030232,'冒险裙甲','2阶橙2星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004030200,3,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,4165},{4,104}]','[]',0,0,0,0),(1004030241,'冒险裙甲','2阶红1星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004030200,3,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6254},{4,156}]','[]',0,0,0,0),(1004030242,'冒险裙甲','2阶红2星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004030200,3,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{2,6254},{4,156}]','[]',0,0,0,0),(1004030243,'冒险裙甲','2阶红3星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004030200,3,1,0,4,0,0,0,'[{1,8}]',0,0,0,0,'[{2,6254},{4,156}]','[]',0,0,0,0),(1004030253,'冒险裙甲','2阶粉色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004030200,3,1,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,10007},{4,250}]','[]',0,0,0,0),(1004030263,'冒险裙甲','2阶神装衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004030200,3,1,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,12509},{4,313}]','[]',0,0,0,0),(1004030300,'勇者裙甲','3阶绿色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004030300,3,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2982},{4,75}]','[]',0,0,0,0),(1004030310,'勇者裙甲','3阶蓝色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004030300,3,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,4473},{4,112}]','[]',0,0,0,0),(1004030320,'勇者裙甲','3阶紫色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004030300,3,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,8141},{4,204}]','[]',0,0,0,0),(1004030331,'勇者裙甲','3阶橙1星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004030300,3,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{2,9930},{4,248}]','[]',0,0,0,0),(1004030332,'勇者裙甲','3阶橙2星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004030300,3,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{2,9930},{4,248}]','[]',0,0,0,0),(1004030341,'勇者裙甲','3阶红1星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004030300,3,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{2,14910},{4,373}]','[]',0,0,0,0),(1004030342,'勇者裙甲','3阶红2星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004030300,3,1,0,4,0,0,0,'[{1,4}]',0,0,0,0,'[{2,14910},{4,373}]','[]',0,0,0,0),(1004030343,'勇者裙甲','3阶红3星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004030300,3,1,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,14910},{4,373}]','[]',0,0,0,0),(1004030353,'勇者裙甲','3阶粉色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004030300,3,1,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,23857},{4,596}]','[]',0,0,0,0),(1004030363,'勇者裙甲','3阶神装衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004030300,3,1,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,29821},{4,746}]','[]',0,0,0,0),(1004030400,'先驱裙甲','4阶绿色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004030400,3,100,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,6004},{4,150}]','[]',0,0,0,0),(1004030410,'先驱裙甲','4阶蓝色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004030400,3,100,0,1,0,0,0,'[{1,2}]',0,0,0,0,'[{2,9006},{4,225}]','[]',0,0,0,0),(1004030420,'先驱裙甲','4阶紫色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004030400,3,100,0,2,0,0,0,'[{1,3}]',0,0,0,0,'[{2,16391},{4,410}]','[]',0,0,0,0),(1004030431,'先驱裙甲','4阶橙1星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004030400,3,100,0,3,0,0,0,'[{1,3}]',0,0,0,0,'[{2,19994},{4,500}]','[]',0,0,0,0),(1004030432,'先驱裙甲','4阶橙2星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004030400,3,100,0,3,0,0,0,'[{1,4}]',0,0,0,0,'[{2,19994},{4,500}]','[]',0,0,0,0),(1004030441,'先驱裙甲','4阶红1星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004030400,3,100,0,4,0,0,0,'[{1,8}]',0,0,0,0,'[{2,30021},{4,751}]','[]',0,0,0,0),(1004030442,'先驱裙甲','4阶红2星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004030400,3,100,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,30021},{4,751}]','[]',0,0,0,0),(1004030443,'先驱裙甲','4阶红3星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004030400,3,100,0,4,0,0,0,'[{1,34}]',0,0,0,0,'[{2,30021},{4,751}]','[]',0,0,0,0),(1004030453,'先驱裙甲','4阶粉色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004030400,3,100,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,48034},{4,1201}]','[]',0,0,0,0),(1004030463,'先驱裙甲','4阶神装衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004030400,3,100,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,60042},{4,1501}]','[]',0,0,0,0),(1004030500,'荣誉裙甲','5阶绿色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004030500,3,150,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,10397},{4,260}]','[]',0,0,1,0),(1004030510,'荣誉裙甲','5阶蓝色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004030500,3,150,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{2,15596},{4,390}]','[]',0,0,1,0),(1004030520,'荣誉裙甲','5阶紫色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004030500,3,150,0,2,0,0,0,'[{1,5}]',0,0,0,0,'[{2,28384},{4,710}]','[]',0,0,1,0),(1004030531,'荣誉裙甲','5阶橙1星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004030500,3,150,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,34623},{4,866}]','[]',0,0,1,0),(1004030532,'荣誉裙甲','5阶橙2星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004030500,3,150,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{2,34623},{4,866}]','[]',0,0,1,0),(1004030541,'荣誉裙甲','5阶红1星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004030500,3,150,0,4,0,0,0,'[{1,14}]',0,0,0,0,'[{2,51986},{4,1300}]','[]',0,0,1,0),(1004030542,'荣誉裙甲','5阶红2星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004030500,3,150,0,4,0,0,0,'[{1,21}]',0,0,0,0,'[{2,51986},{4,1300}]','[]',0,0,1,0),(1004030543,'荣誉裙甲','5阶红3星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004030500,3,150,0,4,0,0,0,'[{1,63}]',0,0,0,0,'[{2,51986},{4,1300}]','[]',0,0,1,0),(1004030553,'荣誉裙甲','5阶粉色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004030500,3,150,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,83178},{4,2079}]','[]',0,0,1,0),(1004030563,'荣誉裙甲','5阶神装衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004030500,3,150,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,103973},{4,2599}]','[]',0,0,1,0),(1004030600,'贤者裙甲','6阶绿色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004030600,3,180,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,16241},{4,406}]','[]',0,0,1,0),(1004030610,'贤者裙甲','6阶蓝色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004030600,3,180,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{2,24362},{4,609}]','[]',0,0,1,0),(1004030620,'贤者裙甲','6阶紫色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004030600,3,180,0,2,0,0,0,'[{1,5}]',0,0,0,0,'[{2,44339},{4,1108}]','[]',0,0,1,0),(1004030631,'贤者裙甲','6阶橙1星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004030600,3,180,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,54084},{4,1352}]','[]',0,0,1,0),(1004030632,'贤者裙甲','6阶橙2星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004030600,3,180,0,3,0,0,0,'[{1,8}]',0,0,0,0,'[{2,54084},{4,1352}]','[]',0,0,1,0),(1004030641,'贤者裙甲','6阶红1星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004030600,3,180,0,4,0,0,0,'[{1,18}]',0,0,0,0,'[{2,81207},{4,2030}]','[]',0,0,1,0),(1004030642,'贤者裙甲','6阶红2星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004030600,3,180,0,4,0,0,0,'[{1,28}]',0,0,0,0,'[{2,81207},{4,2030}]','[]',0,0,1,0),(1004030643,'贤者裙甲','6阶红3星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004030600,3,180,0,4,0,0,0,'[{1,104}]',0,0,0,0,'[{2,81207},{4,2030}]','[]',0,0,1,0),(1004030653,'贤者裙甲','6阶粉色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004030600,3,180,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,129931},{4,3248}]','[]',0,0,1,0),(1004030663,'贤者裙甲','6阶神装衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004030600,3,180,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,162413},{4,4060}]','[]',0,0,1,0),(1004030700,'征服裙甲','7阶绿色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004030700,3,220,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,23616},{4,590}]','[]',0,0,2,0),(1004030710,'征服裙甲','7阶蓝色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004030700,3,220,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{2,35425},{4,886}]','[]',0,0,2,0),(1004030720,'征服裙甲','7阶紫色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004030700,3,220,0,2,0,0,0,'[{1,6}]',0,0,0,0,'[{2,64473},{4,1612}]','[]',0,0,2,0),(1004030731,'征服裙甲','7阶橙1星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004030700,3,220,0,3,0,0,0,'[{1,8}]',0,0,0,0,'[{2,78643},{4,1966}]','[]',0,0,2,0),(1004030732,'征服裙甲','7阶橙2星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004030700,3,220,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,78643},{4,1966}]','[]',0,0,2,0),(1004030741,'征服裙甲','7阶红1星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004030700,3,220,0,4,0,0,0,'[{1,25}]',0,0,0,0,'[{2,118082},{4,2952}]','[]',0,0,2,0),(1004030742,'征服裙甲','7阶红2星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004030700,3,220,0,4,0,0,0,'[{1,41}]',0,0,0,0,'[{2,118082},{4,2952}]','[]',0,0,2,0),(1004030743,'征服裙甲','7阶红3星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004030700,3,220,0,4,0,0,0,'[{1,149}]',0,0,0,0,'[{2,118082},{4,2952}]','[]',0,0,2,0),(1004030753,'征服裙甲','7阶粉色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004030700,3,220,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,188932},{4,4723}]','[]',0,0,2,0),(1004030763,'征服裙甲','7阶神装衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004030700,3,220,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,236165},{4,5904}]','[]',0,0,2,0),(1004030800,'秩序裙甲','8阶绿色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004030800,3,260,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,32603},{4,815}]','[]',0,0,2,0),(1004030810,'秩序裙甲','8阶蓝色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004030800,3,260,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,48904},{4,1223}]','[]',0,0,2,0),(1004030820,'秩序裙甲','8阶紫色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004030800,3,260,0,2,0,0,0,'[{1,7}]',0,0,0,0,'[{2,89005},{4,2225}]','[]',0,0,2,0),(1004030831,'秩序裙甲','8阶橙1星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004030800,3,260,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{2,108567},{4,2714}]','[]',0,0,2,0),(1004030832,'秩序裙甲','8阶橙2星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004030800,3,260,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{2,108567},{4,2714}]','[]',0,0,2,0),(1004030841,'秩序裙甲','8阶红1星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004030800,3,260,0,4,0,0,0,'[{1,28}]',0,0,0,0,'[{2,163014},{4,4075}]','[]',0,0,2,0),(1004030842,'秩序裙甲','8阶红2星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004030800,3,260,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{2,163014},{4,4075}]','[]',0,0,2,0),(1004030843,'秩序裙甲','8阶红3星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004030800,3,260,0,4,0,0,0,'[{1,208}]',0,0,0,0,'[{2,163014},{4,4075}]','[]',0,0,2,0),(1004030853,'秩序裙甲','8阶粉色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004030800,3,260,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,260822},{4,6521}]','[]',0,0,2,0),(1004030863,'秩序裙甲','8阶神装衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004030800,3,260,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,326027},{4,8151}]','[]',0,0,2,0),(1004030900,'守护裙甲','9阶绿色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004030900,3,300,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,43270},{4,1082}]','[]',0,0,3,0),(1004030910,'守护裙甲','9阶蓝色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004030900,3,300,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,64905},{4,1623}]','[]',0,0,3,0),(1004030920,'守护裙甲','9阶紫色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004030900,3,300,0,2,0,0,0,'[{1,7}]',0,0,0,0,'[{2,118128},{4,2953}]','[]',0,0,3,0),(1004030931,'守护裙甲','9阶橙1星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004030900,3,300,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,144090},{4,3602}]','[]',0,0,3,0),(1004030932,'守护裙甲','9阶橙2星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004030900,3,300,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{2,144090},{4,3602}]','[]',0,0,3,0),(1004030941,'守护裙甲','9阶红1星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004030900,3,300,0,4,0,0,0,'[{1,33}]',0,0,0,0,'[{2,216351},{4,5409}]','[]',0,0,3,0),(1004030942,'守护裙甲','9阶红2星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004030900,3,300,0,4,0,0,0,'[{1,55}]',0,0,0,0,'[{2,216351},{4,5409}]','[]',0,0,3,0),(1004030943,'守护裙甲','9阶红3星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004030900,3,300,0,4,0,0,0,'[{1,290}]',0,0,0,0,'[{2,216351},{4,5409}]','[]',0,0,3,0),(1004030953,'守护裙甲','9阶粉色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004030900,3,300,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,346161},{4,8654}]','[]',0,0,3,0),(1004030963,'守护裙甲','9阶神装衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004030900,3,300,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,432702},{4,10818}]','[]',0,0,3,0),(1004031000,'信仰裙甲','10阶绿色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004031000,3,355,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,55709},{4,1393}]','[]',0,0,4,0),(1004031010,'信仰裙甲','10阶蓝色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004031000,3,355,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,83563},{4,2089}]','[]',0,0,4,0),(1004031020,'信仰裙甲','10阶紫色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004031000,3,355,0,2,0,0,0,'[{1,8}]',0,0,0,0,'[{2,152085},{4,3802}]','[]',0,0,4,0),(1004031031,'信仰裙甲','10阶橙1星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004031000,3,355,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,185510},{4,4638}]','[]',0,0,4,0),(1004031032,'信仰裙甲','10阶橙2星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004031000,3,355,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{2,185510},{4,4638}]','[]',0,0,4,0),(1004031041,'信仰裙甲','10阶红1星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004031000,3,355,0,4,0,0,0,'[{1,40}]',0,0,0,0,'[{2,278544},{4,6964}]','[]',0,0,4,0),(1004031042,'信仰裙甲','10阶红2星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004031000,3,355,0,4,0,0,0,'[{1,69}]',0,0,0,0,'[{2,278544},{4,6964}]','[]',0,0,4,0),(1004031043,'信仰裙甲','10阶红3星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004031000,3,355,0,4,0,0,0,'[{1,399}]',0,0,0,0,'[{2,278544},{4,6964}]','[]',0,0,4,0),(1004031053,'信仰裙甲','10阶粉色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004031000,3,355,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,445671},{4,11142}]','[]',0,0,4,0),(1004031063,'信仰裙甲','10阶神装衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004031000,3,355,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,557089},{4,13927}]','[]',0,0,4,0),(1004031100,'天行裙甲','11阶绿色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004031100,3,400,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,69999},{4,1750}]','[]',0,0,4,0),(1004031110,'天行裙甲','11阶蓝色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004031100,3,400,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,104998},{4,2625}]','[]',0,0,4,0),(1004031120,'天行裙甲','11阶紫色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004031100,3,400,0,2,0,0,0,'[{1,9}]',0,0,0,0,'[{2,191097},{4,4777}]','[]',0,0,4,0),(1004031131,'天行裙甲','11阶橙1星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004031100,3,400,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{2,233096},{4,5827}]','[]',0,0,4,0),(1004031132,'天行裙甲','11阶橙2星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004031100,3,400,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{2,233096},{4,5827}]','[]',0,0,4,0),(1004031141,'天行裙甲','11阶红1星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004031100,3,400,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{2,349994},{4,8750}]','[]',0,0,4,0),(1004031142,'天行裙甲','11阶红2星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004031100,3,400,0,4,0,0,0,'[{1,78}]',0,0,0,0,'[{2,349994},{4,8750}]','[]',0,0,4,0),(1004031143,'天行裙甲','11阶红3星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004031100,3,400,0,4,0,0,0,'[{1,549}]',0,0,0,0,'[{2,349994},{4,8750}]','[]',0,0,4,0),(1004031153,'天行裙甲','11阶粉色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004031100,3,400,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,559991},{4,14000}]','[]',0,0,4,0),(1004031163,'天行裙甲','11阶神装衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004031100,3,400,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,699988},{4,17500}]','[]',0,0,4,0),(1004031200,'命运裙甲','12阶绿色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004031200,3,500,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,86220},{4,2156}]','[]',0,0,5,0),(1004031210,'命运裙甲','12阶蓝色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004031200,3,500,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,129330},{4,3233}]','[]',0,0,5,0),(1004031220,'命运裙甲','12阶紫色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004031200,3,500,0,2,0,0,0,'[{1,9}]',0,0,0,0,'[{2,235381},{4,5885}]','[]',0,0,5,0),(1004031231,'命运裙甲','12阶橙1星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004031200,3,500,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{2,287113},{4,7178}]','[]',0,0,5,0),(1004031232,'命运裙甲','12阶橙2星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004031200,3,500,0,3,0,0,0,'[{1,15}]',0,0,0,0,'[{2,287113},{4,7178}]','[]',0,0,5,0),(1004031241,'命运裙甲','12阶红1星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004031200,3,500,0,4,0,0,0,'[{1,62}]',0,0,0,0,'[{2,431101},{4,10778}]','[]',0,0,5,0),(1004031242,'命运裙甲','12阶红2星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004031200,3,500,0,4,0,0,0,'[{1,110}]',0,0,0,0,'[{2,431101},{4,10778}]','[]',0,0,5,0),(1004031243,'命运裙甲','12阶红3星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004031200,3,500,0,4,0,0,0,'[{1,799}]',0,0,0,0,'[{2,431101},{4,10778}]','[]',0,0,5,0),(1004031253,'命运裙甲','12阶粉色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004031200,3,500,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,689761},{4,17244}]','[]',0,0,5,0),(1004031263,'命运裙甲','12阶神装衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004031200,3,500,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,862201},{4,21555}]','[]',0,0,5,0),(1004031300,'制裁裙甲','13阶绿色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004031300,3,520,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,104453},{4,2611}]','[]',0,0,5,0),(1004031310,'制裁裙甲','13阶蓝色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004031300,3,520,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,156679},{4,3917}]','[]',0,0,5,0),(1004031320,'制裁裙甲','13阶紫色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004031300,3,520,0,2,0,0,0,'[{1,10}]',0,0,0,0,'[{2,285156},{4,7129}]','[]',0,0,5,0),(1004031331,'制裁裙甲','13阶橙1星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004031300,3,520,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{2,347828},{4,8696}]','[]',0,0,5,0),(1004031332,'制裁裙甲','13阶橙2星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004031300,3,520,0,3,0,0,0,'[{1,17}]',0,0,0,0,'[{2,347828},{4,8696}]','[]',0,0,5,0),(1004031341,'制裁裙甲','13阶红1星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004031300,3,520,0,4,0,0,0,'[{1,72}]',0,0,0,0,'[{2,522264},{4,13057}]','[]',0,0,5,0),(1004031342,'制裁裙甲','13阶红2星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004031300,3,520,0,4,0,0,0,'[{1,128}]',0,0,0,0,'[{2,522264},{4,13057}]','[]',0,0,5,0),(1004031343,'制裁裙甲','13阶红3星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004031300,3,520,0,4,0,0,0,'[{1,1117}]',0,0,0,0,'[{2,522264},{4,13057}]','[]',0,0,5,0),(1004031353,'制裁裙甲','13阶粉色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004031300,3,520,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,835623},{4,20891}]','[]',0,0,5,0),(1004031363,'制裁裙甲','13阶神装衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004031300,3,520,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,1044529},{4,26113}]','[]',0,0,5,0),(1004031400,'审判裙甲','14阶绿色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004031400,3,620,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,124777},{4,3119}]','[]',0,0,6,0),(1004031410,'审判裙甲','14阶蓝色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004031400,3,620,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{2,187166},{4,4679}]','[]',0,0,6,0),(1004031420,'审判裙甲','14阶紫色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004031400,3,620,0,2,0,0,0,'[{1,11}]',0,0,0,0,'[{2,340641},{4,8516}]','[]',0,0,6,0),(1004031431,'审判裙甲','14阶橙1星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004031400,3,620,0,3,0,0,0,'[{1,15}]',0,0,0,0,'[{2,415508},{4,10388}]','[]',0,0,6,0),(1004031432,'审判裙甲','14阶橙2星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004031400,3,620,0,3,0,0,0,'[{1,19}]',0,0,0,0,'[{2,415508},{4,10388}]','[]',0,0,6,0),(1004031441,'审判裙甲','14阶红1星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004031400,3,620,0,4,0,0,0,'[{1,82}]',0,0,0,0,'[{2,623885},{4,15597}]','[]',0,0,6,0),(1004031442,'审判裙甲','14阶红2星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004031400,3,620,0,4,0,0,0,'[{1,146}]',0,0,0,0,'[{2,623885},{4,15597}]','[]',0,0,6,0),(1004031443,'审判裙甲','14阶红3星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004031400,3,620,0,4,0,0,0,'[{1,1444}]',0,0,0,0,'[{2,623885},{4,15597}]','[]',0,0,6,0),(1004031453,'审判裙甲','14阶粉色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004031400,3,620,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,998216},{4,24955}]','[]',0,0,6,0),(1004031463,'审判裙甲','14阶神装衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004031400,3,620,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,1247770},{4,31194}]','[]',0,0,6,0),(1004031500,'毁灭裙甲','15阶绿色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004031500,3,650,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,147273},{4,3682}]','[]',0,0,6,0),(1004031510,'毁灭裙甲','15阶蓝色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004031500,3,650,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{2,220909},{4,5523}]','[]',0,0,6,0),(1004031520,'毁灭裙甲','15阶紫色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004031500,3,650,0,2,0,0,0,'[{1,12}]',0,0,0,0,'[{2,402055},{4,10051}]','[]',0,0,6,0),(1004031531,'毁灭裙甲','15阶橙1星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004031500,3,650,0,3,0,0,0,'[{1,16}]',0,0,0,0,'[{2,490418},{4,12260}]','[]',0,0,6,0),(1004031532,'毁灭裙甲','15阶橙2星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004031500,3,650,0,3,0,0,0,'[{1,20}]',0,0,0,0,'[{2,490418},{4,12260}]','[]',0,0,6,0),(1004031541,'毁灭裙甲','15阶红1星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004031500,3,650,0,4,0,0,0,'[{1,92}]',0,0,0,0,'[{2,736364},{4,18409}]','[]',0,0,6,0),(1004031542,'毁灭裙甲','15阶红2星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004031500,3,650,0,4,0,0,0,'[{1,164}]',0,0,0,0,'[{2,736364},{4,18409}]','[]',0,0,6,0),(1004031543,'毁灭裙甲','15阶红3星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004031500,3,650,0,4,0,0,0,'[{1,1717}]',0,0,0,0,'[{2,736364},{4,18409}]','[]',0,0,6,0),(1004031553,'毁灭裙甲','15阶粉色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004031500,3,650,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,1178182},{4,29455}]','[]',0,0,6,0),(1004031563,'毁灭裙甲','15阶神装衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004031500,3,650,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,1472727},{4,36818}]','[]',0,0,6,0),(1004031600,'混沌裙甲','16阶绿色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004031500,3,700,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{2,172020},{4,4300}]','[]',0,0,6,0),(1004031610,'混沌裙甲','16阶蓝色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004031500,3,700,0,1,0,0,0,'[{1,7}]',0,0,0,0,'[{2,258030},{4,6451}]','[]',0,0,6,0),(1004031620,'混沌裙甲','16阶紫色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004031500,3,700,0,2,0,0,0,'[{1,14}]',0,0,0,0,'[{2,469615},{4,11740}]','[]',0,0,6,0),(1004031631,'混沌裙甲','16阶橙1星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004031500,3,700,0,3,0,0,0,'[{1,19}]',0,0,0,0,'[{2,572827},{4,14321}]','[]',0,0,6,0),(1004031632,'混沌裙甲','16阶橙2星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004031500,3,700,0,3,0,0,0,'[{1,23}]',0,0,0,0,'[{2,572827},{4,14321}]','[]',0,0,6,0),(1004031641,'混沌裙甲','16阶红1星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004031500,3,700,0,4,0,0,0,'[{1,112}]',0,0,0,0,'[{2,860100},{4,21502}]','[]',0,0,6,0),(1004031642,'混沌裙甲','16阶红2星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004031500,3,700,0,4,0,0,0,'[{1,200}]',0,0,0,0,'[{2,860100},{4,21502}]','[]',0,0,6,0),(1004031643,'混沌裙甲','16阶红3星衣服【魔导师】','',0,'','',0,1,1,10,4,1,2,4,1004031500,3,700,0,4,0,0,0,'[{1,2044}]',0,0,0,0,'[{2,860100},{4,21502}]','[]',0,0,6,0),(1004031653,'混沌裙甲','16阶粉色衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004031500,3,700,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,1376160},{4,34404}]','[]',0,0,6,0),(1004031663,'混沌裙甲','16阶神装衣服【魔导师】','',0,'','',0,0,1,10,4,0,0,4,1004031500,3,700,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,1720200},{4,43005}]','[]',0,0,6,0),(1004040100,'学徒皮甲','1阶绿色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004040100,4,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,731},{4,18}]','[]',0,0,0,0),(1004040110,'学徒皮甲','1阶蓝色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004040100,4,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1096},{4,27}]','[]',0,0,0,0),(1004040120,'学徒皮甲','1阶紫色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004040100,4,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1994},{4,50}]','[]',0,0,0,0),(1004040131,'学徒皮甲','1阶橙1星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004040100,4,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2433},{4,61}]','[]',0,0,0,0),(1004040132,'学徒皮甲','1阶橙2星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004040100,4,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2433},{4,61}]','[]',0,0,0,0),(1004040141,'学徒皮甲','1阶红1星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004040100,4,1,0,4,0,0,0,'[{1,1}]',0,0,0,0,'[{2,3653},{4,91}]','[]',0,0,0,0),(1004040142,'学徒皮甲','1阶红2星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004040100,4,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{2,3653},{4,91}]','[]',0,0,0,0),(1004040143,'学徒皮甲','1阶红3星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004040100,4,1,0,4,0,0,0,'[{1,5}]',0,0,0,0,'[{2,3653},{4,91}]','[]',0,0,0,0),(1004040153,'学徒皮甲','1阶粉色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004040100,4,1,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,5844},{4,146}]','[]',0,0,0,0),(1004040163,'学徒皮甲','1阶神装衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004040100,4,1,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,7305},{4,183}]','[]',0,0,0,0),(1004040200,'冒险皮甲','2阶绿色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004040200,4,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1251},{4,31}]','[]',0,0,0,0),(1004040210,'冒险皮甲','2阶蓝色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004040200,4,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1876},{4,47}]','[]',0,0,0,0),(1004040220,'冒险皮甲','2阶紫色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004040200,4,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,3415},{4,85}]','[]',0,0,0,0),(1004040231,'冒险皮甲','2阶橙1星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004040200,4,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,4165},{4,104}]','[]',0,0,0,0),(1004040232,'冒险皮甲','2阶橙2星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004040200,4,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,4165},{4,104}]','[]',0,0,0,0),(1004040241,'冒险皮甲','2阶红1星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004040200,4,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6254},{4,156}]','[]',0,0,0,0),(1004040242,'冒险皮甲','2阶红2星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004040200,4,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{2,6254},{4,156}]','[]',0,0,0,0),(1004040243,'冒险皮甲','2阶红3星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004040200,4,1,0,4,0,0,0,'[{1,8}]',0,0,0,0,'[{2,6254},{4,156}]','[]',0,0,0,0),(1004040253,'冒险皮甲','2阶粉色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004040200,4,1,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,10007},{4,250}]','[]',0,0,0,0),(1004040263,'冒险皮甲','2阶神装衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004040200,4,1,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,12509},{4,313}]','[]',0,0,0,0),(1004040300,'勇者皮甲','3阶绿色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004040300,4,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2982},{4,75}]','[]',0,0,0,0),(1004040310,'勇者皮甲','3阶蓝色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004040300,4,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,4473},{4,112}]','[]',0,0,0,0),(1004040320,'勇者皮甲','3阶紫色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004040300,4,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,8141},{4,204}]','[]',0,0,0,0),(1004040331,'勇者皮甲','3阶橙1星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004040300,4,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{2,9930},{4,248}]','[]',0,0,0,0),(1004040332,'勇者皮甲','3阶橙2星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004040300,4,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{2,9930},{4,248}]','[]',0,0,0,0),(1004040341,'勇者皮甲','3阶红1星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004040300,4,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{2,14910},{4,373}]','[]',0,0,0,0),(1004040342,'勇者皮甲','3阶红2星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004040300,4,1,0,4,0,0,0,'[{1,4}]',0,0,0,0,'[{2,14910},{4,373}]','[]',0,0,0,0),(1004040343,'勇者皮甲','3阶红3星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004040300,4,1,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,14910},{4,373}]','[]',0,0,0,0),(1004040353,'勇者皮甲','3阶粉色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004040300,4,1,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,23857},{4,596}]','[]',0,0,0,0),(1004040363,'勇者皮甲','3阶神装衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004040300,4,1,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,29821},{4,746}]','[]',0,0,0,0),(1004040400,'先驱皮甲','4阶绿色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004040400,4,100,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,6004},{4,150}]','[]',0,0,0,0),(1004040410,'先驱皮甲','4阶蓝色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004040400,4,100,0,1,0,0,0,'[{1,2}]',0,0,0,0,'[{2,9006},{4,225}]','[]',0,0,0,0),(1004040420,'先驱皮甲','4阶紫色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004040400,4,100,0,2,0,0,0,'[{1,3}]',0,0,0,0,'[{2,16391},{4,410}]','[]',0,0,0,0),(1004040431,'先驱皮甲','4阶橙1星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004040400,4,100,0,3,0,0,0,'[{1,3}]',0,0,0,0,'[{2,19994},{4,500}]','[]',0,0,0,0),(1004040432,'先驱皮甲','4阶橙2星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004040400,4,100,0,3,0,0,0,'[{1,4}]',0,0,0,0,'[{2,19994},{4,500}]','[]',0,0,0,0),(1004040441,'先驱皮甲','4阶红1星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004040400,4,100,0,4,0,0,0,'[{1,8}]',0,0,0,0,'[{2,30021},{4,751}]','[]',0,0,0,0),(1004040442,'先驱皮甲','4阶红2星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004040400,4,100,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,30021},{4,751}]','[]',0,0,0,0),(1004040443,'先驱皮甲','4阶红3星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004040400,4,100,0,4,0,0,0,'[{1,34}]',0,0,0,0,'[{2,30021},{4,751}]','[]',0,0,0,0),(1004040453,'先驱皮甲','4阶粉色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004040400,4,100,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,48034},{4,1201}]','[]',0,0,0,0),(1004040463,'先驱皮甲','4阶神装衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004040400,4,100,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,60042},{4,1501}]','[]',0,0,0,0),(1004040500,'荣誉皮甲','5阶绿色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004040500,4,150,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,10397},{4,260}]','[]',0,0,1,0),(1004040510,'荣誉皮甲','5阶蓝色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004040500,4,150,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{2,15596},{4,390}]','[]',0,0,1,0),(1004040520,'荣誉皮甲','5阶紫色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004040500,4,150,0,2,0,0,0,'[{1,5}]',0,0,0,0,'[{2,28384},{4,710}]','[]',0,0,1,0),(1004040531,'荣誉皮甲','5阶橙1星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004040500,4,150,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,34623},{4,866}]','[]',0,0,1,0),(1004040532,'荣誉皮甲','5阶橙2星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004040500,4,150,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{2,34623},{4,866}]','[]',0,0,1,0),(1004040541,'荣誉皮甲','5阶红1星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004040500,4,150,0,4,0,0,0,'[{1,14}]',0,0,0,0,'[{2,51986},{4,1300}]','[]',0,0,1,0),(1004040542,'荣誉皮甲','5阶红2星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004040500,4,150,0,4,0,0,0,'[{1,21}]',0,0,0,0,'[{2,51986},{4,1300}]','[]',0,0,1,0),(1004040543,'荣誉皮甲','5阶红3星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004040500,4,150,0,4,0,0,0,'[{1,63}]',0,0,0,0,'[{2,51986},{4,1300}]','[]',0,0,1,0),(1004040553,'荣誉皮甲','5阶粉色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004040500,4,150,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,83178},{4,2079}]','[]',0,0,1,0),(1004040563,'荣誉皮甲','5阶神装衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004040500,4,150,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,103973},{4,2599}]','[]',0,0,1,0),(1004040600,'贤者皮甲','6阶绿色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004040600,4,180,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,16241},{4,406}]','[]',0,0,1,0),(1004040610,'贤者皮甲','6阶蓝色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004040600,4,180,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{2,24362},{4,609}]','[]',0,0,1,0),(1004040620,'贤者皮甲','6阶紫色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004040600,4,180,0,2,0,0,0,'[{1,5}]',0,0,0,0,'[{2,44339},{4,1108}]','[]',0,0,1,0),(1004040631,'贤者皮甲','6阶橙1星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004040600,4,180,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,54084},{4,1352}]','[]',0,0,1,0),(1004040632,'贤者皮甲','6阶橙2星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004040600,4,180,0,3,0,0,0,'[{1,8}]',0,0,0,0,'[{2,54084},{4,1352}]','[]',0,0,1,0),(1004040641,'贤者皮甲','6阶红1星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004040600,4,180,0,4,0,0,0,'[{1,18}]',0,0,0,0,'[{2,81207},{4,2030}]','[]',0,0,1,0),(1004040642,'贤者皮甲','6阶红2星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004040600,4,180,0,4,0,0,0,'[{1,28}]',0,0,0,0,'[{2,81207},{4,2030}]','[]',0,0,1,0),(1004040643,'贤者皮甲','6阶红3星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004040600,4,180,0,4,0,0,0,'[{1,104}]',0,0,0,0,'[{2,81207},{4,2030}]','[]',0,0,1,0),(1004040653,'贤者皮甲','6阶粉色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004040600,4,180,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,129931},{4,3248}]','[]',0,0,1,0),(1004040663,'贤者皮甲','6阶神装衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004040600,4,180,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,162413},{4,4060}]','[]',0,0,1,0),(1004040700,'征服皮甲','7阶绿色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004040700,4,220,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,23616},{4,590}]','[]',0,0,2,0),(1004040710,'征服皮甲','7阶蓝色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004040700,4,220,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{2,35425},{4,886}]','[]',0,0,2,0),(1004040720,'征服皮甲','7阶紫色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004040700,4,220,0,2,0,0,0,'[{1,6}]',0,0,0,0,'[{2,64473},{4,1612}]','[]',0,0,2,0),(1004040731,'征服皮甲','7阶橙1星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004040700,4,220,0,3,0,0,0,'[{1,8}]',0,0,0,0,'[{2,78643},{4,1966}]','[]',0,0,2,0),(1004040732,'征服皮甲','7阶橙2星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004040700,4,220,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,78643},{4,1966}]','[]',0,0,2,0),(1004040741,'征服皮甲','7阶红1星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004040700,4,220,0,4,0,0,0,'[{1,25}]',0,0,0,0,'[{2,118082},{4,2952}]','[]',0,0,2,0),(1004040742,'征服皮甲','7阶红2星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004040700,4,220,0,4,0,0,0,'[{1,41}]',0,0,0,0,'[{2,118082},{4,2952}]','[]',0,0,2,0),(1004040743,'征服皮甲','7阶红3星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004040700,4,220,0,4,0,0,0,'[{1,149}]',0,0,0,0,'[{2,118082},{4,2952}]','[]',0,0,2,0),(1004040753,'征服皮甲','7阶粉色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004040700,4,220,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,188932},{4,4723}]','[]',0,0,2,0),(1004040763,'征服皮甲','7阶神装衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004040700,4,220,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,236165},{4,5904}]','[]',0,0,2,0),(1004040800,'秩序皮甲','8阶绿色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004040800,4,260,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,32603},{4,815}]','[]',0,0,2,0),(1004040810,'秩序皮甲','8阶蓝色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004040800,4,260,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,48904},{4,1223}]','[]',0,0,2,0),(1004040820,'秩序皮甲','8阶紫色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004040800,4,260,0,2,0,0,0,'[{1,7}]',0,0,0,0,'[{2,89005},{4,2225}]','[]',0,0,2,0),(1004040831,'秩序皮甲','8阶橙1星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004040800,4,260,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{2,108567},{4,2714}]','[]',0,0,2,0),(1004040832,'秩序皮甲','8阶橙2星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004040800,4,260,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{2,108567},{4,2714}]','[]',0,0,2,0),(1004040841,'秩序皮甲','8阶红1星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004040800,4,260,0,4,0,0,0,'[{1,28}]',0,0,0,0,'[{2,163014},{4,4075}]','[]',0,0,2,0),(1004040842,'秩序皮甲','8阶红2星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004040800,4,260,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{2,163014},{4,4075}]','[]',0,0,2,0),(1004040843,'秩序皮甲','8阶红3星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004040800,4,260,0,4,0,0,0,'[{1,208}]',0,0,0,0,'[{2,163014},{4,4075}]','[]',0,0,2,0),(1004040853,'秩序皮甲','8阶粉色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004040800,4,260,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,260822},{4,6521}]','[]',0,0,2,0),(1004040863,'秩序皮甲','8阶神装衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004040800,4,260,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,326027},{4,8151}]','[]',0,0,2,0),(1004040900,'守护皮甲','9阶绿色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004040900,4,300,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,43270},{4,1082}]','[]',0,0,3,0),(1004040910,'守护皮甲','9阶蓝色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004040900,4,300,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,64905},{4,1623}]','[]',0,0,3,0),(1004040920,'守护皮甲','9阶紫色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004040900,4,300,0,2,0,0,0,'[{1,7}]',0,0,0,0,'[{2,118128},{4,2953}]','[]',0,0,3,0),(1004040931,'守护皮甲','9阶橙1星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004040900,4,300,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,144090},{4,3602}]','[]',0,0,3,0),(1004040932,'守护皮甲','9阶橙2星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004040900,4,300,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{2,144090},{4,3602}]','[]',0,0,3,0),(1004040941,'守护皮甲','9阶红1星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004040900,4,300,0,4,0,0,0,'[{1,33}]',0,0,0,0,'[{2,216351},{4,5409}]','[]',0,0,3,0),(1004040942,'守护皮甲','9阶红2星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004040900,4,300,0,4,0,0,0,'[{1,55}]',0,0,0,0,'[{2,216351},{4,5409}]','[]',0,0,3,0),(1004040943,'守护皮甲','9阶红3星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004040900,4,300,0,4,0,0,0,'[{1,290}]',0,0,0,0,'[{2,216351},{4,5409}]','[]',0,0,3,0),(1004040953,'守护皮甲','9阶粉色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004040900,4,300,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,346161},{4,8654}]','[]',0,0,3,0),(1004040963,'守护皮甲','9阶神装衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004040900,4,300,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,432702},{4,10818}]','[]',0,0,3,0),(1004041000,'信仰皮甲','10阶绿色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004041000,4,355,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,55709},{4,1393}]','[]',0,0,4,0),(1004041010,'信仰皮甲','10阶蓝色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004041000,4,355,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,83563},{4,2089}]','[]',0,0,4,0),(1004041020,'信仰皮甲','10阶紫色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004041000,4,355,0,2,0,0,0,'[{1,8}]',0,0,0,0,'[{2,152085},{4,3802}]','[]',0,0,4,0),(1004041031,'信仰皮甲','10阶橙1星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004041000,4,355,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,185510},{4,4638}]','[]',0,0,4,0),(1004041032,'信仰皮甲','10阶橙2星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004041000,4,355,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{2,185510},{4,4638}]','[]',0,0,4,0),(1004041041,'信仰皮甲','10阶红1星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004041000,4,355,0,4,0,0,0,'[{1,40}]',0,0,0,0,'[{2,278544},{4,6964}]','[]',0,0,4,0),(1004041042,'信仰皮甲','10阶红2星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004041000,4,355,0,4,0,0,0,'[{1,69}]',0,0,0,0,'[{2,278544},{4,6964}]','[]',0,0,4,0),(1004041043,'信仰皮甲','10阶红3星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004041000,4,355,0,4,0,0,0,'[{1,399}]',0,0,0,0,'[{2,278544},{4,6964}]','[]',0,0,4,0),(1004041053,'信仰皮甲','10阶粉色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004041000,4,355,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,445671},{4,11142}]','[]',0,0,4,0),(1004041063,'信仰皮甲','10阶神装衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004041000,4,355,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,557089},{4,13927}]','[]',0,0,4,0),(1004041100,'天行皮甲','11阶绿色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004041100,4,400,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,69999},{4,1750}]','[]',0,0,4,0),(1004041110,'天行皮甲','11阶蓝色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004041100,4,400,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,104998},{4,2625}]','[]',0,0,4,0),(1004041120,'天行皮甲','11阶紫色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004041100,4,400,0,2,0,0,0,'[{1,9}]',0,0,0,0,'[{2,191097},{4,4777}]','[]',0,0,4,0),(1004041131,'天行皮甲','11阶橙1星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004041100,4,400,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{2,233096},{4,5827}]','[]',0,0,4,0),(1004041132,'天行皮甲','11阶橙2星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004041100,4,400,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{2,233096},{4,5827}]','[]',0,0,4,0),(1004041141,'天行皮甲','11阶红1星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004041100,4,400,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{2,349994},{4,8750}]','[]',0,0,4,0),(1004041142,'天行皮甲','11阶红2星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004041100,4,400,0,4,0,0,0,'[{1,78}]',0,0,0,0,'[{2,349994},{4,8750}]','[]',0,0,4,0),(1004041143,'天行皮甲','11阶红3星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004041100,4,400,0,4,0,0,0,'[{1,549}]',0,0,0,0,'[{2,349994},{4,8750}]','[]',0,0,4,0),(1004041153,'天行皮甲','11阶粉色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004041100,4,400,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,559991},{4,14000}]','[]',0,0,4,0),(1004041163,'天行皮甲','11阶神装衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004041100,4,400,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,699988},{4,17500}]','[]',0,0,4,0),(1004041200,'命运皮甲','12阶绿色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004041200,4,500,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,86220},{4,2156}]','[]',0,0,5,0),(1004041210,'命运皮甲','12阶蓝色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004041200,4,500,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,129330},{4,3233}]','[]',0,0,5,0),(1004041220,'命运皮甲','12阶紫色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004041200,4,500,0,2,0,0,0,'[{1,9}]',0,0,0,0,'[{2,235381},{4,5885}]','[]',0,0,5,0),(1004041231,'命运皮甲','12阶橙1星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004041200,4,500,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{2,287113},{4,7178}]','[]',0,0,5,0),(1004041232,'命运皮甲','12阶橙2星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004041200,4,500,0,3,0,0,0,'[{1,15}]',0,0,0,0,'[{2,287113},{4,7178}]','[]',0,0,5,0),(1004041241,'命运皮甲','12阶红1星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004041200,4,500,0,4,0,0,0,'[{1,62}]',0,0,0,0,'[{2,431101},{4,10778}]','[]',0,0,5,0),(1004041242,'命运皮甲','12阶红2星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004041200,4,500,0,4,0,0,0,'[{1,110}]',0,0,0,0,'[{2,431101},{4,10778}]','[]',0,0,5,0),(1004041243,'命运皮甲','12阶红3星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004041200,4,500,0,4,0,0,0,'[{1,799}]',0,0,0,0,'[{2,431101},{4,10778}]','[]',0,0,5,0),(1004041253,'命运皮甲','12阶粉色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004041200,4,500,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,689761},{4,17244}]','[]',0,0,5,0),(1004041263,'命运皮甲','12阶神装衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004041200,4,500,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,862201},{4,21555}]','[]',0,0,5,0),(1004041300,'制裁皮甲','13阶绿色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004041300,4,520,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,104453},{4,2611}]','[]',0,0,5,0),(1004041310,'制裁皮甲','13阶蓝色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004041300,4,520,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,156679},{4,3917}]','[]',0,0,5,0),(1004041320,'制裁皮甲','13阶紫色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004041300,4,520,0,2,0,0,0,'[{1,10}]',0,0,0,0,'[{2,285156},{4,7129}]','[]',0,0,5,0),(1004041331,'制裁皮甲','13阶橙1星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004041300,4,520,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{2,347828},{4,8696}]','[]',0,0,5,0),(1004041332,'制裁皮甲','13阶橙2星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004041300,4,520,0,3,0,0,0,'[{1,17}]',0,0,0,0,'[{2,347828},{4,8696}]','[]',0,0,5,0),(1004041341,'制裁皮甲','13阶红1星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004041300,4,520,0,4,0,0,0,'[{1,72}]',0,0,0,0,'[{2,522264},{4,13057}]','[]',0,0,5,0),(1004041342,'制裁皮甲','13阶红2星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004041300,4,520,0,4,0,0,0,'[{1,128}]',0,0,0,0,'[{2,522264},{4,13057}]','[]',0,0,5,0),(1004041343,'制裁皮甲','13阶红3星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004041300,4,520,0,4,0,0,0,'[{1,1117}]',0,0,0,0,'[{2,522264},{4,13057}]','[]',0,0,5,0),(1004041353,'制裁皮甲','13阶粉色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004041300,4,520,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,835623},{4,20891}]','[]',0,0,5,0),(1004041363,'制裁皮甲','13阶神装衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004041300,4,520,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,1044529},{4,26113}]','[]',0,0,5,0),(1004041400,'审判皮甲','14阶绿色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004041400,4,620,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,124777},{4,3119}]','[]',0,0,6,0),(1004041410,'审判皮甲','14阶蓝色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004041400,4,620,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{2,187166},{4,4679}]','[]',0,0,6,0),(1004041420,'审判皮甲','14阶紫色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004041400,4,620,0,2,0,0,0,'[{1,11}]',0,0,0,0,'[{2,340641},{4,8516}]','[]',0,0,6,0),(1004041431,'审判皮甲','14阶橙1星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004041400,4,620,0,3,0,0,0,'[{1,15}]',0,0,0,0,'[{2,415508},{4,10388}]','[]',0,0,6,0),(1004041432,'审判皮甲','14阶橙2星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004041400,4,620,0,3,0,0,0,'[{1,19}]',0,0,0,0,'[{2,415508},{4,10388}]','[]',0,0,6,0),(1004041441,'审判皮甲','14阶红1星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004041400,4,620,0,4,0,0,0,'[{1,82}]',0,0,0,0,'[{2,623885},{4,15597}]','[]',0,0,6,0),(1004041442,'审判皮甲','14阶红2星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004041400,4,620,0,4,0,0,0,'[{1,146}]',0,0,0,0,'[{2,623885},{4,15597}]','[]',0,0,6,0),(1004041443,'审判皮甲','14阶红3星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004041400,4,620,0,4,0,0,0,'[{1,1444}]',0,0,0,0,'[{2,623885},{4,15597}]','[]',0,0,6,0),(1004041453,'审判皮甲','14阶粉色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004041400,4,620,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,998216},{4,24955}]','[]',0,0,6,0),(1004041463,'审判皮甲','14阶神装衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004041400,4,620,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,1247770},{4,31194}]','[]',0,0,6,0),(1004041500,'毁灭皮甲','15阶绿色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004041500,4,650,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,147273},{4,3682}]','[]',0,0,6,0),(1004041510,'毁灭皮甲','15阶蓝色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004041500,4,650,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{2,220909},{4,5523}]','[]',0,0,6,0),(1004041520,'毁灭皮甲','15阶紫色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004041500,4,650,0,2,0,0,0,'[{1,12}]',0,0,0,0,'[{2,402055},{4,10051}]','[]',0,0,6,0),(1004041531,'毁灭皮甲','15阶橙1星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004041500,4,650,0,3,0,0,0,'[{1,16}]',0,0,0,0,'[{2,490418},{4,12260}]','[]',0,0,6,0),(1004041532,'毁灭皮甲','15阶橙2星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004041500,4,650,0,3,0,0,0,'[{1,20}]',0,0,0,0,'[{2,490418},{4,12260}]','[]',0,0,6,0),(1004041541,'毁灭皮甲','15阶红1星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004041500,4,650,0,4,0,0,0,'[{1,92}]',0,0,0,0,'[{2,736364},{4,18409}]','[]',0,0,6,0),(1004041542,'毁灭皮甲','15阶红2星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004041500,4,650,0,4,0,0,0,'[{1,164}]',0,0,0,0,'[{2,736364},{4,18409}]','[]',0,0,6,0),(1004041543,'毁灭皮甲','15阶红3星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004041500,4,650,0,4,0,0,0,'[{1,1717}]',0,0,0,0,'[{2,736364},{4,18409}]','[]',0,0,6,0),(1004041553,'毁灭皮甲','15阶粉色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004041500,4,650,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,1178182},{4,29455}]','[]',0,0,6,0),(1004041563,'毁灭皮甲','15阶神装衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004041500,4,650,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,1472727},{4,36818}]','[]',0,0,6,0),(1004041600,'混沌皮甲','16阶绿色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004041500,4,700,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{2,172020},{4,4300}]','[]',0,0,6,0),(1004041610,'混沌皮甲','16阶蓝色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004041500,4,700,0,1,0,0,0,'[{1,7}]',0,0,0,0,'[{2,258030},{4,6451}]','[]',0,0,6,0),(1004041620,'混沌皮甲','16阶紫色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004041500,4,700,0,2,0,0,0,'[{1,14}]',0,0,0,0,'[{2,469615},{4,11740}]','[]',0,0,6,0),(1004041631,'混沌皮甲','16阶橙1星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004041500,4,700,0,3,0,0,0,'[{1,19}]',0,0,0,0,'[{2,572827},{4,14321}]','[]',0,0,6,0),(1004041632,'混沌皮甲','16阶橙2星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004041500,4,700,0,3,0,0,0,'[{1,23}]',0,0,0,0,'[{2,572827},{4,14321}]','[]',0,0,6,0),(1004041641,'混沌皮甲','16阶红1星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004041500,4,700,0,4,0,0,0,'[{1,112}]',0,0,0,0,'[{2,860100},{4,21502}]','[]',0,0,6,0),(1004041642,'混沌皮甲','16阶红2星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004041500,4,700,0,4,0,0,0,'[{1,200}]',0,0,0,0,'[{2,860100},{4,21502}]','[]',0,0,6,0),(1004041643,'混沌皮甲','16阶红3星衣服【重炮手】','',0,'','',0,1,1,10,4,1,2,4,1004041500,4,700,0,4,0,0,0,'[{1,2044}]',0,0,0,0,'[{2,860100},{4,21502}]','[]',0,0,6,0),(1004041653,'混沌皮甲','16阶粉色衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004041500,4,700,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,1376160},{4,34404}]','[]',0,0,6,0),(1004041663,'混沌皮甲','16阶神装衣服【重炮手】','',0,'','',0,0,1,10,4,0,0,4,1004041500,4,700,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,1720200},{4,43005}]','[]',0,0,6,0),(1005000100,'学徒刻痕','1阶绿色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005000100,0,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,15},{3,7}]','[]',0,0,0,0),(1005000110,'学徒刻痕','1阶蓝色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005000100,0,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{1,22},{3,11}]','[]',0,0,0,0),(1005000120,'学徒刻痕','1阶紫色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005000100,0,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{1,41},{3,20}]','[]',0,0,0,0),(1005000131,'学徒刻痕','1阶橙1星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005000100,0,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{1,50},{3,25}]','[]',0,0,0,0),(1005000132,'学徒刻痕','1阶橙2星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005000100,0,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{1,50},{3,25}]','[]',0,0,0,0),(1005000141,'学徒刻痕','1阶红1星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005000100,0,1,0,4,0,0,0,'[{1,1}]',0,0,0,0,'[{1,74},{3,37}]','[]',0,0,0,0),(1005000142,'学徒刻痕','1阶红2星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005000100,0,1,0,4,0,0,0,'[{1,1}]',0,0,0,0,'[{1,74},{3,37}]','[]',0,0,0,0),(1005000143,'学徒刻痕','1阶红3星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005000100,0,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{1,74},{3,37}]','[]',0,0,0,0),(1005000153,'学徒刻痕','1阶粉色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005000100,0,1,0,5,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,119},{3,60}]','[]',0,0,0,0),(1005000163,'学徒刻痕','1阶神装刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005000100,0,1,0,6,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,149},{3,74}]','[]',0,0,0,0),(1005000200,'冒险刻痕','2阶绿色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005000200,0,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,25},{3,13}]','[]',0,0,0,0),(1005000210,'冒险刻痕','2阶蓝色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005000200,0,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{1,38},{3,19}]','[]',0,0,0,0),(1005000220,'冒险刻痕','2阶紫色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005000200,0,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{1,70},{3,35}]','[]',0,0,0,0),(1005000231,'冒险刻痕','2阶橙1星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005000200,0,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{1,85},{3,42}]','[]',0,0,0,0),(1005000232,'冒险刻痕','2阶橙2星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005000200,0,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{1,85},{3,42}]','[]',0,0,0,0),(1005000241,'冒险刻痕','2阶红1星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005000200,0,1,0,4,0,0,0,'[{1,1}]',0,0,0,0,'[{1,127},{3,64}]','[]',0,0,0,0),(1005000242,'冒险刻痕','2阶红2星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005000200,0,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{1,127},{3,64}]','[]',0,0,0,0),(1005000243,'冒险刻痕','2阶红3星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005000200,0,1,0,4,0,0,0,'[{1,5}]',0,0,0,0,'[{1,127},{3,64}]','[]',0,0,0,0),(1005000253,'冒险刻痕','2阶粉色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005000200,0,1,0,5,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,204},{3,102}]','[]',0,0,0,0),(1005000263,'冒险刻痕','2阶神装刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005000200,0,1,0,6,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,255},{3,127}]','[]',0,0,0,0),(1005000300,'勇者刻痕','3阶绿色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005000300,0,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,61},{3,30}]','[]',0,0,0,0),(1005000310,'勇者刻痕','3阶蓝色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005000300,0,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{1,91},{3,46}]','[]',0,0,0,0),(1005000320,'勇者刻痕','3阶紫色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005000300,0,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{1,166},{3,83}]','[]',0,0,0,0),(1005000331,'勇者刻痕','3阶橙1星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005000300,0,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{1,202},{3,101}]','[]',0,0,0,0),(1005000332,'勇者刻痕','3阶橙2星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005000300,0,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{1,202},{3,101}]','[]',0,0,0,0),(1005000341,'勇者刻痕','3阶红1星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005000300,0,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{1,304},{3,152}]','[]',0,0,0,0),(1005000342,'勇者刻痕','3阶红2星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005000300,0,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{1,304},{3,152}]','[]',0,0,0,0),(1005000343,'勇者刻痕','3阶红3星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005000300,0,1,0,4,0,0,0,'[{1,8}]',0,0,0,0,'[{1,304},{3,152}]','[]',0,0,0,0),(1005000353,'勇者刻痕','3阶粉色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005000300,0,1,0,5,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,486},{3,243}]','[]',0,0,0,0),(1005000363,'勇者刻痕','3阶神装刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005000300,0,1,0,6,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,607},{3,304}]','[]',0,0,0,0),(1005000400,'先驱刻痕','4阶绿色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005000400,0,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,122},{3,61}]','[]',0,0,0,0),(1005000410,'先驱刻痕','4阶蓝色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005000400,0,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{1,183},{3,92}]','[]',0,0,0,0),(1005000420,'先驱刻痕','4阶紫色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005000400,0,1,0,2,0,0,0,'[{1,2}]',0,0,0,0,'[{1,334},{3,167}]','[]',0,0,0,0),(1005000431,'先驱刻痕','4阶橙1星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005000400,0,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{1,407},{3,204}]','[]',0,0,0,0),(1005000432,'先驱刻痕','4阶橙2星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005000400,0,1,0,3,0,0,0,'[{1,3}]',0,0,0,0,'[{1,407},{3,204}]','[]',0,0,0,0),(1005000441,'先驱刻痕','4阶红1星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005000400,0,1,0,4,0,0,0,'[{1,5}]',0,0,0,0,'[{1,612},{3,306}]','[]',0,0,0,0),(1005000442,'先驱刻痕','4阶红2星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005000400,0,1,0,4,0,0,0,'[{1,7}]',0,0,0,0,'[{1,612},{3,306}]','[]',0,0,0,0),(1005000443,'先驱刻痕','4阶红3星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005000400,0,1,0,4,0,0,0,'[{1,21}]',0,0,0,0,'[{1,612},{3,306}]','[]',0,0,0,0),(1005000453,'先驱刻痕','4阶粉色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005000400,0,1,0,5,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,978},{3,489}]','[]',0,0,0,0),(1005000463,'先驱刻痕','4阶神装刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005000400,0,1,0,6,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,1223},{3,612}]','[]',0,0,0,0),(1005000500,'荣誉刻痕','5阶绿色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005000500,0,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,212},{3,106}]','[]',0,0,0,0),(1005000510,'荣誉刻痕','5阶蓝色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005000500,0,1,0,1,0,0,0,'[{1,2}]',0,0,0,0,'[{1,318},{3,159}]','[]',0,0,0,0),(1005000520,'荣誉刻痕','5阶紫色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005000500,0,1,0,2,0,0,0,'[{1,3}]',0,0,0,0,'[{1,578},{3,289}]','[]',0,0,0,0),(1005000531,'荣誉刻痕','5阶橙1星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005000500,0,1,0,3,0,0,0,'[{1,4}]',0,0,0,0,'[{1,705},{3,353}]','[]',0,0,0,0),(1005000532,'荣誉刻痕','5阶橙2星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005000500,0,1,0,3,0,0,0,'[{1,5}]',0,0,0,0,'[{1,705},{3,353}]','[]',0,0,0,0),(1005000541,'荣誉刻痕','5阶红1星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005000500,0,1,0,4,0,0,0,'[{1,9}]',0,0,0,0,'[{1,1059},{3,529}]','[]',0,0,0,0),(1005000542,'荣誉刻痕','5阶红2星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005000500,0,1,0,4,0,0,0,'[{1,13}]',0,0,0,0,'[{1,1059},{3,529}]','[]',0,0,0,0),(1005000543,'荣誉刻痕','5阶红3星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005000500,0,1,0,4,0,0,0,'[{1,39}]',0,0,0,0,'[{1,1059},{3,529}]','[]',0,0,0,0),(1005000553,'荣誉刻痕','5阶粉色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005000500,0,1,0,5,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,1694},{3,847}]','[]',0,0,0,0),(1005000563,'荣誉刻痕','5阶神装刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005000500,0,1,0,6,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,2118},{3,1059}]','[]',0,0,0,0),(1005000600,'贤者刻痕','6阶绿色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005000600,0,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,331},{3,165}]','[]',0,0,0,0),(1005000610,'贤者刻痕','6阶蓝色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005000600,0,1,0,1,0,0,0,'[{1,2}]',0,0,0,0,'[{1,496},{3,248}]','[]',0,0,0,0),(1005000620,'贤者刻痕','6阶紫色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005000600,0,1,0,2,0,0,0,'[{1,3}]',0,0,0,0,'[{1,903},{3,452}]','[]',0,0,0,0),(1005000631,'贤者刻痕','6阶橙1星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005000600,0,1,0,3,0,0,0,'[{1,4}]',0,0,0,0,'[{1,1102},{3,551}]','[]',0,0,0,0),(1005000632,'贤者刻痕','6阶橙2星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005000600,0,1,0,3,0,0,0,'[{1,5}]',0,0,0,0,'[{1,1102},{3,551}]','[]',0,0,0,0),(1005000641,'贤者刻痕','6阶红1星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005000600,0,1,0,4,0,0,0,'[{1,11}]',0,0,0,0,'[{1,1654},{3,827}]','[]',0,0,0,0),(1005000642,'贤者刻痕','6阶红2星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005000600,0,1,0,4,0,0,0,'[{1,17}]',0,0,0,0,'[{1,1654},{3,827}]','[]',0,0,0,0),(1005000643,'贤者刻痕','6阶红3星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005000600,0,1,0,4,0,0,0,'[{1,64}]',0,0,0,0,'[{1,1654},{3,827}]','[]',0,0,0,0),(1005000653,'贤者刻痕','6阶粉色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005000600,0,1,0,5,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,2647},{3,1323}]','[]',0,0,0,0),(1005000663,'贤者刻痕','6阶神装刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005000600,0,1,0,6,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,3308},{3,1654}]','[]',0,0,0,0),(1005000700,'征服刻痕','7阶绿色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005000700,0,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,481},{3,241}]','[]',0,0,0,0),(1005000710,'征服刻痕','7阶蓝色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005000700,0,1,0,1,0,0,0,'[{1,2}]',0,0,0,0,'[{1,722},{3,361}]','[]',0,0,0,0),(1005000720,'征服刻痕','7阶紫色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005000700,0,1,0,2,0,0,0,'[{1,4}]',0,0,0,0,'[{1,1313},{3,657}]','[]',0,0,0,0),(1005000731,'征服刻痕','7阶橙1星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005000700,0,1,0,3,0,0,0,'[{1,5}]',0,0,0,0,'[{1,1602},{3,801}]','[]',0,0,0,0),(1005000732,'征服刻痕','7阶橙2星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005000700,0,1,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{1,1602},{3,801}]','[]',0,0,0,0),(1005000741,'征服刻痕','7阶红1星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005000700,0,1,0,4,0,0,0,'[{1,16}]',0,0,0,0,'[{1,2405},{3,1203}]','[]',0,0,0,0),(1005000742,'征服刻痕','7阶红2星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005000700,0,1,0,4,0,0,0,'[{1,25}]',0,0,0,0,'[{1,2405},{3,1203}]','[]',0,0,0,0),(1005000743,'征服刻痕','7阶红3星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005000700,0,1,0,4,0,0,0,'[{1,91}]',0,0,0,0,'[{1,2405},{3,1203}]','[]',0,0,0,0),(1005000753,'征服刻痕','7阶粉色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005000700,0,1,0,5,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,3849},{3,1924}]','[]',0,0,0,0),(1005000763,'征服刻痕','7阶神装刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005000700,0,1,0,6,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,4811},{3,2405}]','[]',0,0,0,0),(1005000800,'秩序刻痕','8阶绿色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005000800,0,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,664},{3,332}]','[]',0,0,0,0),(1005000810,'秩序刻痕','8阶蓝色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005000800,0,1,0,1,0,0,0,'[{1,2}]',0,0,0,0,'[{1,996},{3,498}]','[]',0,0,0,0),(1005000820,'秩序刻痕','8阶紫色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005000800,0,1,0,2,0,0,0,'[{1,4}]',0,0,0,0,'[{1,1813},{3,907}]','[]',0,0,0,0),(1005000831,'秩序刻痕','8阶橙1星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005000800,0,1,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{1,2212},{3,1106}]','[]',0,0,0,0),(1005000832,'秩序刻痕','8阶橙2星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005000800,0,1,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{1,2212},{3,1106}]','[]',0,0,0,0),(1005000841,'秩序刻痕','8阶红1星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005000800,0,1,0,4,0,0,0,'[{1,18}]',0,0,0,0,'[{1,3321},{3,1660}]','[]',0,0,0,0),(1005000842,'秩序刻痕','8阶红2星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005000800,0,1,0,4,0,0,0,'[{1,28}]',0,0,0,0,'[{1,3321},{3,1660}]','[]',0,0,0,0),(1005000843,'秩序刻痕','8阶红3星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005000800,0,1,0,4,0,0,0,'[{1,127}]',0,0,0,0,'[{1,3321},{3,1660}]','[]',0,0,0,0),(1005000853,'秩序刻痕','8阶粉色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005000800,0,1,0,5,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,5313},{3,2657}]','[]',0,0,0,0),(1005000863,'秩序刻痕','8阶神装刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005000800,0,1,0,6,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,6641},{3,3321}]','[]',0,0,0,0),(1005000900,'守护刻痕','9阶绿色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005000900,0,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,881},{3,441}]','[]',0,0,0,0),(1005000910,'守护刻痕','9阶蓝色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005000900,0,1,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{1,1322},{3,661}]','[]',0,0,0,0),(1005000920,'守护刻痕','9阶紫色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005000900,0,1,0,2,0,0,0,'[{1,5}]',0,0,0,0,'[{1,2406},{3,1203}]','[]',0,0,0,0),(1005000931,'守护刻痕','9阶橙1星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005000900,0,1,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{1,2935},{3,1468}]','[]',0,0,0,0),(1005000932,'守护刻痕','9阶橙2星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005000900,0,1,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{1,2935},{3,1468}]','[]',0,0,0,0),(1005000941,'守护刻痕','9阶红1星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005000900,0,1,0,4,0,0,0,'[{1,21}]',0,0,0,0,'[{1,4407},{3,2204}]','[]',0,0,0,0),(1005000942,'守护刻痕','9阶红2星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005000900,0,1,0,4,0,0,0,'[{1,34}]',0,0,0,0,'[{1,4407},{3,2204}]','[]',0,0,0,0),(1005000943,'守护刻痕','9阶红3星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005000900,0,1,0,4,0,0,0,'[{1,177}]',0,0,0,0,'[{1,4407},{3,2204}]','[]',0,0,0,0),(1005000953,'守护刻痕','9阶粉色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005000900,0,1,0,5,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,7051},{3,3526}]','[]',0,0,0,0),(1005000963,'守护刻痕','9阶神装刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005000900,0,1,0,6,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,8814},{3,4407}]','[]',0,0,0,0),(1005001000,'信仰刻痕','10阶绿色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005001000,0,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,1135},{3,567}]','[]',0,0,0,0),(1005001010,'信仰刻痕','10阶蓝色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005001000,0,1,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{1,1702},{3,851}]','[]',0,0,0,0),(1005001020,'信仰刻痕','10阶紫色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005001000,0,1,0,2,0,0,0,'[{1,5}]',0,0,0,0,'[{1,3098},{3,1549}]','[]',0,0,0,0),(1005001031,'信仰刻痕','10阶橙1星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005001000,0,1,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{1,3779},{3,1889}]','[]',0,0,0,0),(1005001032,'信仰刻痕','10阶橙2星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005001000,0,1,0,3,0,0,0,'[{1,8}]',0,0,0,0,'[{1,3779},{3,1889}]','[]',0,0,0,0),(1005001041,'信仰刻痕','10阶红1星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005001000,0,1,0,4,0,0,0,'[{1,25}]',0,0,0,0,'[{1,5674},{3,2837}]','[]',0,0,0,0),(1005001042,'信仰刻痕','10阶红2星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005001000,0,1,0,4,0,0,0,'[{1,42}]',0,0,0,0,'[{1,5674},{3,2837}]','[]',0,0,0,0),(1005001043,'信仰刻痕','10阶红3星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005001000,0,1,0,4,0,0,0,'[{1,244}]',0,0,0,0,'[{1,5674},{3,2837}]','[]',0,0,0,0),(1005001053,'信仰刻痕','10阶粉色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005001000,0,1,0,5,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,9078},{3,4539}]','[]',0,0,0,0),(1005001063,'信仰刻痕','10阶神装刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005001000,0,1,0,6,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,11348},{3,5674}]','[]',0,0,0,0),(1005001100,'天行刻痕','11阶绿色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005001100,0,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,1426},{3,713}]','[]',0,0,0,0),(1005001110,'天行刻痕','11阶蓝色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005001100,0,1,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{1,2139},{3,1069}]','[]',0,0,0,0),(1005001120,'天行刻痕','11阶紫色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005001100,0,1,0,2,0,0,0,'[{1,5}]',0,0,0,0,'[{1,3893},{3,1946}]','[]',0,0,0,0),(1005001131,'天行刻痕','11阶橙1星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005001100,0,1,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{1,4748},{3,2374}]','[]',0,0,0,0),(1005001132,'天行刻痕','11阶橙2星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005001100,0,1,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{1,4748},{3,2374}]','[]',0,0,0,0),(1005001141,'天行刻痕','11阶红1星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005001100,0,1,0,4,0,0,0,'[{1,28}]',0,0,0,0,'[{1,7130},{3,3565}]','[]',0,0,0,0),(1005001142,'天行刻痕','11阶红2星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005001100,0,1,0,4,0,0,0,'[{1,48}]',0,0,0,0,'[{1,7130},{3,3565}]','[]',0,0,0,0),(1005001143,'天行刻痕','11阶红3星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005001100,0,1,0,4,0,0,0,'[{1,335}]',0,0,0,0,'[{1,7130},{3,3565}]','[]',0,0,0,0),(1005001153,'天行刻痕','11阶粉色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005001100,0,1,0,5,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,11407},{3,5704}]','[]',0,0,0,0),(1005001163,'天行刻痕','11阶神装刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005001100,0,1,0,6,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,14259},{3,7130}]','[]',0,0,0,0),(1005001200,'命运刻痕','12阶绿色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005001200,0,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,1756},{3,878}]','[]',0,0,0,0),(1005001210,'命运刻痕','12阶蓝色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005001200,0,1,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{1,2635},{3,1317}]','[]',0,0,0,0),(1005001220,'命运刻痕','12阶紫色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005001200,0,1,0,2,0,0,0,'[{1,6}]',0,0,0,0,'[{1,4795},{3,2397}]','[]',0,0,0,0),(1005001231,'命运刻痕','12阶橙1星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005001200,0,1,0,3,0,0,0,'[{1,8}]',0,0,0,0,'[{1,5849},{3,2924}]','[]',0,0,0,0),(1005001232,'命运刻痕','12阶橙2星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005001200,0,1,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{1,5849},{3,2924}]','[]',0,0,0,0),(1005001241,'命运刻痕','12阶红1星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005001200,0,1,0,4,0,0,0,'[{1,38}]',0,0,0,0,'[{1,8782},{3,4391}]','[]',0,0,0,0),(1005001242,'命运刻痕','12阶红2星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005001200,0,1,0,4,0,0,0,'[{1,67}]',0,0,0,0,'[{1,8782},{3,4391}]','[]',0,0,0,0),(1005001243,'命运刻痕','12阶红3星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005001200,0,1,0,4,0,0,0,'[{1,488}]',0,0,0,0,'[{1,8782},{3,4391}]','[]',0,0,0,0),(1005001253,'命运刻痕','12阶粉色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005001200,0,1,0,5,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,14051},{3,7025}]','[]',0,0,0,0),(1005001263,'命运刻痕','12阶神装刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005001200,0,1,0,6,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,17563},{3,8782}]','[]',0,0,0,0),(1005001300,'制裁刻痕','13阶绿色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005001300,0,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,2128},{3,1064}]','[]',0,0,0,0),(1005001310,'制裁刻痕','13阶蓝色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005001300,0,1,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{1,3192},{3,1596}]','[]',0,0,0,0),(1005001320,'制裁刻痕','13阶紫色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005001300,0,1,0,2,0,0,0,'[{1,6}]',0,0,0,0,'[{1,5809},{3,2904}]','[]',0,0,0,0),(1005001331,'制裁刻痕','13阶橙1星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005001300,0,1,0,3,0,0,0,'[{1,8}]',0,0,0,0,'[{1,7085},{3,3543}]','[]',0,0,0,0),(1005001332,'制裁刻痕','13阶橙2星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005001300,0,1,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{1,7085},{3,3543}]','[]',0,0,0,0),(1005001341,'制裁刻痕','13阶红1星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005001300,0,1,0,4,0,0,0,'[{1,44}]',0,0,0,0,'[{1,10639},{3,5319}]','[]',0,0,0,0),(1005001342,'制裁刻痕','13阶红2星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005001300,0,1,0,4,0,0,0,'[{1,78}]',0,0,0,0,'[{1,10639},{3,5319}]','[]',0,0,0,0),(1005001343,'制裁刻痕','13阶红3星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005001300,0,1,0,4,0,0,0,'[{1,683}]',0,0,0,0,'[{1,10639},{3,5319}]','[]',0,0,0,0),(1005001353,'制裁刻痕','13阶粉色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005001300,0,1,0,5,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,17022},{3,8511}]','[]',0,0,0,0),(1005001363,'制裁刻痕','13阶神装刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005001300,0,1,0,6,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,21277},{3,10639}]','[]',0,0,0,0),(1005001400,'审判刻痕','14阶绿色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005001400,0,1,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,2542},{3,1271}]','[]',0,0,0,0),(1005001410,'审判刻痕','14阶蓝色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005001400,0,1,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{1,3813},{3,1906}]','[]',0,0,0,0),(1005001420,'审判刻痕','14阶紫色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005001400,0,1,0,2,0,0,0,'[{1,7}]',0,0,0,0,'[{1,6939},{3,3469}]','[]',0,0,0,0),(1005001431,'审判刻痕','14阶橙1星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005001400,0,1,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{1,8464},{3,4232}]','[]',0,0,0,0),(1005001432,'审判刻痕','14阶橙2星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005001400,0,1,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{1,8464},{3,4232}]','[]',0,0,0,0),(1005001441,'审判刻痕','14阶红1星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005001400,0,1,0,4,0,0,0,'[{1,50}]',0,0,0,0,'[{1,12709},{3,6354}]','[]',0,0,0,0),(1005001442,'审判刻痕','14阶红2星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005001400,0,1,0,4,0,0,0,'[{1,89}]',0,0,0,0,'[{1,12709},{3,6354}]','[]',0,0,0,0),(1005001443,'审判刻痕','14阶红3星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005001400,0,1,0,4,0,0,0,'[{1,883}]',0,0,0,0,'[{1,12709},{3,6354}]','[]',0,0,0,0),(1005001453,'审判刻痕','14阶粉色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005001400,0,1,0,5,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,20334},{3,10167}]','[]',0,0,0,0),(1005001463,'审判刻痕','14阶神装刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005001400,0,1,0,6,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,25418},{3,12709}]','[]',0,0,0,0),(1005001500,'毁灭刻痕','15阶绿色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005001500,0,1,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,3000},{3,1500}]','[]',0,0,0,0),(1005001510,'毁灭刻痕','15阶蓝色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005001500,0,1,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{1,4500},{3,2250}]','[]',0,0,0,0),(1005001520,'毁灭刻痕','15阶紫色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005001500,0,1,0,2,0,0,0,'[{1,8}]',0,0,0,0,'[{1,8190},{3,4095}]','[]',0,0,0,0),(1005001531,'毁灭刻痕','15阶橙1星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005001500,0,1,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{1,9990},{3,4995}]','[]',0,0,0,0),(1005001532,'毁灭刻痕','15阶橙2星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005001500,0,1,0,3,0,0,0,'[{1,13}]',0,0,0,0,'[{1,9990},{3,4995}]','[]',0,0,0,0),(1005001541,'毁灭刻痕','15阶红1星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005001500,0,1,0,4,0,0,0,'[{1,57}]',0,0,0,0,'[{1,15000},{3,7500}]','[]',0,0,0,0),(1005001542,'毁灭刻痕','15阶红2星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005001500,0,1,0,4,0,0,0,'[{1,100}]',0,0,0,0,'[{1,15000},{3,7500}]','[]',0,0,0,0),(1005001543,'毁灭刻痕','15阶红3星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005001500,0,1,0,4,0,0,0,'[{1,1049}]',0,0,0,0,'[{1,15000},{3,7500}]','[]',0,0,0,0),(1005001553,'毁灭刻痕','15阶粉色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005001500,0,1,0,5,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,24000},{3,12000}]','[]',0,0,0,0),(1005001563,'毁灭刻痕','15阶神装刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005001500,0,1,0,6,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,30000},{3,15000}]','[]',0,0,0,0),(1005001600,'混沌刻痕','16阶绿色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005001500,0,1,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,3504},{3,1752}]','[]',0,0,0,0),(1005001610,'混沌刻痕','16阶蓝色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005001500,0,1,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{1,5256},{3,2628}]','[]',0,0,0,0),(1005001620,'混沌刻痕','16阶紫色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005001500,0,1,0,2,0,0,0,'[{1,9}]',0,0,0,0,'[{1,9566},{3,4783}]','[]',0,0,0,0),(1005001631,'混沌刻痕','16阶橙1星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005001500,0,1,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{1,11669},{3,5834}]','[]',0,0,0,0),(1005001632,'混沌刻痕','16阶橙2星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005001500,0,1,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{1,11669},{3,5834}]','[]',0,0,0,0),(1005001641,'混沌刻痕','16阶红1星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005001500,0,1,0,4,0,0,0,'[{1,69}]',0,0,0,0,'[{1,17521},{3,8760}]','[]',0,0,0,0),(1005001642,'混沌刻痕','16阶红2星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005001500,0,1,0,4,0,0,0,'[{1,123}]',0,0,0,0,'[{1,17521},{3,8760}]','[]',0,0,0,0),(1005001643,'混沌刻痕','16阶红3星刻痕【通用】','',0,'','',0,1,1,10,5,1,3,5,1005001500,0,1,0,4,0,0,0,'[{1,1249}]',0,0,0,0,'[{1,17521},{3,8760}]','[]',0,0,0,0),(1005001653,'混沌刻痕','16阶粉色刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005001500,0,1,0,5,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,28033},{3,14016}]','[]',0,0,0,0),(1005001663,'混沌刻痕','16阶神装刻痕【通用】','',0,'','',0,0,1,10,5,0,0,5,1005001500,0,1,0,6,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,35041},{3,17521}]','[]',0,0,0,0),(1006010100,'学徒战腿','1阶绿色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006010100,1,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,487},{4,12}]','[]',0,0,0,0),(1006010110,'学徒战腿','1阶蓝色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006010100,1,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,731},{4,18}]','[]',0,0,0,0),(1006010120,'学徒战腿','1阶紫色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006010100,1,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1330},{4,33}]','[]',0,0,0,0),(1006010131,'学徒战腿','1阶橙1星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006010100,1,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1622},{4,41}]','[]',0,0,0,0),(1006010132,'学徒战腿','1阶橙2星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006010100,1,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1622},{4,41}]','[]',0,0,0,0),(1006010141,'学徒战腿','1阶红1星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006010100,1,1,0,4,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2435},{4,61}]','[]',0,0,0,0),(1006010142,'学徒战腿','1阶红2星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006010100,1,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{2,2435},{4,61}]','[]',0,0,0,0),(1006010143,'学徒战腿','1阶红3星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006010100,1,1,0,4,0,0,0,'[{1,5}]',0,0,0,0,'[{2,2435},{4,61}]','[]',0,0,0,0),(1006010153,'学徒战腿','1阶粉色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006010100,1,1,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,3896},{4,97}]','[]',0,0,0,0),(1006010163,'学徒战腿','1阶神装裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006010100,1,1,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,4870},{4,122}]','[]',0,0,0,0),(1006010200,'冒险战腿','2阶绿色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006010200,1,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,834},{4,21}]','[]',0,0,0,0),(1006010210,'冒险战腿','2阶蓝色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006010200,1,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1251},{4,31}]','[]',0,0,0,0),(1006010220,'冒险战腿','2阶紫色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006010200,1,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2277},{4,57}]','[]',0,0,0,0),(1006010231,'冒险战腿','2阶橙1星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006010200,1,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2777},{4,69}]','[]',0,0,0,0),(1006010232,'冒险战腿','2阶橙2星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006010200,1,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2777},{4,69}]','[]',0,0,0,0),(1006010241,'冒险战腿','2阶红1星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006010200,1,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{2,4170},{4,104}]','[]',0,0,0,0),(1006010242,'冒险战腿','2阶红2星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006010200,1,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{2,4170},{4,104}]','[]',0,0,0,0),(1006010243,'冒险战腿','2阶红3星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006010200,1,1,0,4,0,0,0,'[{1,8}]',0,0,0,0,'[{2,4170},{4,104}]','[]',0,0,0,0),(1006010253,'冒险战腿','2阶粉色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006010200,1,1,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,6671},{4,167}]','[]',0,0,0,0),(1006010263,'冒险战腿','2阶神装裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006010200,1,1,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,8339},{4,208}]','[]',0,0,0,0),(1006010300,'勇者战腿','3阶绿色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006010300,1,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1988},{4,50}]','[]',0,0,0,0),(1006010310,'勇者战腿','3阶蓝色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006010300,1,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2982},{4,75}]','[]',0,0,0,0),(1006010320,'勇者战腿','3阶紫色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006010300,1,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,5427},{4,136}]','[]',0,0,0,0),(1006010331,'勇者战腿','3阶橙1星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006010300,1,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6620},{4,166}]','[]',0,0,0,0),(1006010332,'勇者战腿','3阶橙2星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006010300,1,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6620},{4,166}]','[]',0,0,0,0),(1006010341,'勇者战腿','3阶红1星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006010300,1,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{2,9940},{4,249}]','[]',0,0,0,0),(1006010342,'勇者战腿','3阶红2星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006010300,1,1,0,4,0,0,0,'[{1,4}]',0,0,0,0,'[{2,9940},{4,249}]','[]',0,0,0,0),(1006010343,'勇者战腿','3阶红3星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006010300,1,1,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,9940},{4,249}]','[]',0,0,0,0),(1006010353,'勇者战腿','3阶粉色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006010300,1,1,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,15904},{4,398}]','[]',0,0,0,0),(1006010363,'勇者战腿','3阶神装裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006010300,1,1,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,19881},{4,497}]','[]',0,0,0,0),(1006010400,'先驱战腿','4阶绿色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006010400,1,100,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,4003},{4,100}]','[]',0,0,0,0),(1006010410,'先驱战腿','4阶蓝色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006010400,1,100,0,1,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6004},{4,150}]','[]',0,0,0,0),(1006010420,'先驱战腿','4阶紫色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006010400,1,100,0,2,0,0,0,'[{1,3}]',0,0,0,0,'[{2,10928},{4,273}]','[]',0,0,0,0),(1006010431,'先驱战腿','4阶橙1星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006010400,1,100,0,3,0,0,0,'[{1,3}]',0,0,0,0,'[{2,13329},{4,333}]','[]',0,0,0,0),(1006010432,'先驱战腿','4阶橙2星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006010400,1,100,0,3,0,0,0,'[{1,4}]',0,0,0,0,'[{2,13329},{4,333}]','[]',0,0,0,0),(1006010441,'先驱战腿','4阶红1星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006010400,1,100,0,4,0,0,0,'[{1,8}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1006010442,'先驱战腿','4阶红2星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006010400,1,100,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1006010443,'先驱战腿','4阶红3星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006010400,1,100,0,4,0,0,0,'[{1,34}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1006010453,'先驱战腿','4阶粉色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006010400,1,100,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,32022},{4,801}]','[]',0,0,0,0),(1006010463,'先驱战腿','4阶神装裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006010400,1,100,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,40028},{4,1001}]','[]',0,0,0,0),(1006010500,'荣誉战腿','5阶绿色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006010500,1,150,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,6932},{4,173}]','[]',0,0,1,0),(1006010510,'荣誉战腿','5阶蓝色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006010500,1,150,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{2,10397},{4,260}]','[]',0,0,1,0),(1006010520,'荣誉战腿','5阶紫色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006010500,1,150,0,2,0,0,0,'[{1,5}]',0,0,0,0,'[{2,18923},{4,473}]','[]',0,0,1,0),(1006010531,'荣誉战腿','5阶橙1星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006010500,1,150,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,1,0),(1006010532,'荣誉战腿','5阶橙2星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006010500,1,150,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,1,0),(1006010541,'荣誉战腿','5阶红1星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006010500,1,150,0,4,0,0,0,'[{1,14}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,1,0),(1006010542,'荣誉战腿','5阶红2星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006010500,1,150,0,4,0,0,0,'[{1,21}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,1,0),(1006010543,'荣誉战腿','5阶红3星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006010500,1,150,0,4,0,0,0,'[{1,63}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,1,0),(1006010553,'荣誉战腿','5阶粉色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006010500,1,150,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,55452},{4,1386}]','[]',0,0,1,0),(1006010563,'荣誉战腿','5阶神装裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006010500,1,150,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,69315},{4,1733}]','[]',0,0,1,0),(1006010600,'贤者战腿','6阶绿色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006010600,1,180,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,10828},{4,271}]','[]',0,0,1,0),(1006010610,'贤者战腿','6阶蓝色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006010600,1,180,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{2,16241},{4,406}]','[]',0,0,1,0),(1006010620,'贤者战腿','6阶紫色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006010600,1,180,0,2,0,0,0,'[{1,5}]',0,0,0,0,'[{2,29559},{4,739}]','[]',0,0,1,0),(1006010631,'贤者战腿','6阶橙1星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006010600,1,180,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,36056},{4,901}]','[]',0,0,1,0),(1006010632,'贤者战腿','6阶橙2星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006010600,1,180,0,3,0,0,0,'[{1,8}]',0,0,0,0,'[{2,36056},{4,901}]','[]',0,0,1,0),(1006010641,'贤者战腿','6阶红1星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006010600,1,180,0,4,0,0,0,'[{1,18}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,1,0),(1006010642,'贤者战腿','6阶红2星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006010600,1,180,0,4,0,0,0,'[{1,28}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,1,0),(1006010643,'贤者战腿','6阶红3星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006010600,1,180,0,4,0,0,0,'[{1,104}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,1,0),(1006010653,'贤者战腿','6阶粉色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006010600,1,180,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,86620},{4,2166}]','[]',0,0,1,0),(1006010663,'贤者战腿','6阶神装裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006010600,1,180,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,108276},{4,2707}]','[]',0,0,1,0),(1006010700,'征服战腿','7阶绿色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006010700,1,220,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,15744},{4,394}]','[]',0,0,2,0),(1006010710,'征服战腿','7阶蓝色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006010700,1,220,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{2,23616},{4,590}]','[]',0,0,2,0),(1006010720,'征服战腿','7阶紫色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006010700,1,220,0,2,0,0,0,'[{1,6}]',0,0,0,0,'[{2,42982},{4,1075}]','[]',0,0,2,0),(1006010731,'征服战腿','7阶橙1星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006010700,1,220,0,3,0,0,0,'[{1,8}]',0,0,0,0,'[{2,52429},{4,1311}]','[]',0,0,2,0),(1006010732,'征服战腿','7阶橙2星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006010700,1,220,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,52429},{4,1311}]','[]',0,0,2,0),(1006010741,'征服战腿','7阶红1星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006010700,1,220,0,4,0,0,0,'[{1,25}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,2,0),(1006010742,'征服战腿','7阶红2星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006010700,1,220,0,4,0,0,0,'[{1,41}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,2,0),(1006010743,'征服战腿','7阶红3星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006010700,1,220,0,4,0,0,0,'[{1,149}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,2,0),(1006010753,'征服战腿','7阶粉色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006010700,1,220,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,125955},{4,3149}]','[]',0,0,2,0),(1006010763,'征服战腿','7阶神装裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006010700,1,220,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,157443},{4,3936}]','[]',0,0,2,0),(1006010800,'秩序战腿','8阶绿色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006010800,1,260,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,21735},{4,543}]','[]',0,0,2,0),(1006010810,'秩序战腿','8阶蓝色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006010800,1,260,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,32603},{4,815}]','[]',0,0,2,0),(1006010820,'秩序战腿','8阶紫色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006010800,1,260,0,2,0,0,0,'[{1,7}]',0,0,0,0,'[{2,59337},{4,1483}]','[]',0,0,2,0),(1006010831,'秩序战腿','8阶橙1星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006010800,1,260,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{2,72378},{4,1809}]','[]',0,0,2,0),(1006010832,'秩序战腿','8阶橙2星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006010800,1,260,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{2,72378},{4,1809}]','[]',0,0,2,0),(1006010841,'秩序战腿','8阶红1星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006010800,1,260,0,4,0,0,0,'[{1,28}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,2,0),(1006010842,'秩序战腿','8阶红2星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006010800,1,260,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,2,0),(1006010843,'秩序战腿','8阶红3星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006010800,1,260,0,4,0,0,0,'[{1,208}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,2,0),(1006010853,'秩序战腿','8阶粉色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006010800,1,260,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,173881},{4,4347}]','[]',0,0,2,0),(1006010863,'秩序战腿','8阶神装裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006010800,1,260,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,217352},{4,5434}]','[]',0,0,2,0),(1006010900,'守护战腿','9阶绿色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006010900,1,300,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,28847},{4,721}]','[]',0,0,3,0),(1006010910,'守护战腿','9阶蓝色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006010900,1,300,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,43270},{4,1082}]','[]',0,0,3,0),(1006010920,'守护战腿','9阶紫色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006010900,1,300,0,2,0,0,0,'[{1,7}]',0,0,0,0,'[{2,78752},{4,1969}]','[]',0,0,3,0),(1006010931,'守护战腿','9阶橙1星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006010900,1,300,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,96060},{4,2401}]','[]',0,0,3,0),(1006010932,'守护战腿','9阶橙2星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006010900,1,300,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{2,96060},{4,2401}]','[]',0,0,3,0),(1006010941,'守护战腿','9阶红1星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006010900,1,300,0,4,0,0,0,'[{1,33}]',0,0,0,0,'[{2,144234},{4,3606}]','[]',0,0,3,0),(1006010942,'守护战腿','9阶红2星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006010900,1,300,0,4,0,0,0,'[{1,55}]',0,0,0,0,'[{2,144234},{4,3606}]','[]',0,0,3,0),(1006010943,'守护战腿','9阶红3星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006010900,1,300,0,4,0,0,0,'[{1,290}]',0,0,0,0,'[{2,144234},{4,3606}]','[]',0,0,3,0),(1006010953,'守护战腿','9阶粉色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006010900,1,300,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,230774},{4,5769}]','[]',0,0,3,0),(1006010963,'守护战腿','9阶神装裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006010900,1,300,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,288468},{4,7212}]','[]',0,0,3,0),(1006011000,'信仰战腿','10阶绿色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006011000,1,355,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,37139},{4,928}]','[]',0,0,4,0),(1006011010,'信仰战腿','10阶蓝色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006011000,1,355,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,55709},{4,1393}]','[]',0,0,4,0),(1006011020,'信仰战腿','10阶紫色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006011000,1,355,0,2,0,0,0,'[{1,8}]',0,0,0,0,'[{2,101390},{4,2535}]','[]',0,0,4,0),(1006011031,'信仰战腿','10阶橙1星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006011000,1,355,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,123674},{4,3092}]','[]',0,0,4,0),(1006011032,'信仰战腿','10阶橙2星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006011000,1,355,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{2,123674},{4,3092}]','[]',0,0,4,0),(1006011041,'信仰战腿','10阶红1星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006011000,1,355,0,4,0,0,0,'[{1,40}]',0,0,0,0,'[{2,185696},{4,4642}]','[]',0,0,4,0),(1006011042,'信仰战腿','10阶红2星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006011000,1,355,0,4,0,0,0,'[{1,69}]',0,0,0,0,'[{2,185696},{4,4642}]','[]',0,0,4,0),(1006011043,'信仰战腿','10阶红3星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006011000,1,355,0,4,0,0,0,'[{1,399}]',0,0,0,0,'[{2,185696},{4,4642}]','[]',0,0,4,0),(1006011053,'信仰战腿','10阶粉色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006011000,1,355,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,297114},{4,7428}]','[]',0,0,4,0),(1006011063,'信仰战腿','10阶神装裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006011000,1,355,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,371392},{4,9285}]','[]',0,0,4,0),(1006011100,'天行战腿','11阶绿色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006011100,1,400,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,46666},{4,1167}]','[]',0,0,4,0),(1006011110,'天行战腿','11阶蓝色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006011100,1,400,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,69999},{4,1750}]','[]',0,0,4,0),(1006011120,'天行战腿','11阶紫色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006011100,1,400,0,2,0,0,0,'[{1,9}]',0,0,0,0,'[{2,127398},{4,3185}]','[]',0,0,4,0),(1006011131,'天行战腿','11阶橙1星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006011100,1,400,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{2,155397},{4,3885}]','[]',0,0,4,0),(1006011132,'天行战腿','11阶橙2星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006011100,1,400,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{2,155397},{4,3885}]','[]',0,0,4,0),(1006011141,'天行战腿','11阶红1星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006011100,1,400,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{2,233329},{4,5833}]','[]',0,0,4,0),(1006011142,'天行战腿','11阶红2星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006011100,1,400,0,4,0,0,0,'[{1,78}]',0,0,0,0,'[{2,233329},{4,5833}]','[]',0,0,4,0),(1006011143,'天行战腿','11阶红3星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006011100,1,400,0,4,0,0,0,'[{1,549}]',0,0,0,0,'[{2,233329},{4,5833}]','[]',0,0,4,0),(1006011153,'天行战腿','11阶粉色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006011100,1,400,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,373327},{4,9333}]','[]',0,0,4,0),(1006011163,'天行战腿','11阶神装裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006011100,1,400,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,466659},{4,11666}]','[]',0,0,4,0),(1006011200,'命运战腿','12阶绿色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006011200,1,500,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,57480},{4,1437}]','[]',0,0,5,0),(1006011210,'命运战腿','12阶蓝色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006011200,1,500,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,86220},{4,2156}]','[]',0,0,5,0),(1006011220,'命运战腿','12阶紫色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006011200,1,500,0,2,0,0,0,'[{1,9}]',0,0,0,0,'[{2,156921},{4,3923}]','[]',0,0,5,0),(1006011231,'命运战腿','12阶橙1星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006011200,1,500,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{2,191409},{4,4785}]','[]',0,0,5,0),(1006011232,'命运战腿','12阶橙2星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006011200,1,500,0,3,0,0,0,'[{1,15}]',0,0,0,0,'[{2,191409},{4,4785}]','[]',0,0,5,0),(1006011241,'命运战腿','12阶红1星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006011200,1,500,0,4,0,0,0,'[{1,62}]',0,0,0,0,'[{2,287400},{4,7185}]','[]',0,0,5,0),(1006011242,'命运战腿','12阶红2星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006011200,1,500,0,4,0,0,0,'[{1,110}]',0,0,0,0,'[{2,287400},{4,7185}]','[]',0,0,5,0),(1006011243,'命运战腿','12阶红3星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006011200,1,500,0,4,0,0,0,'[{1,799}]',0,0,0,0,'[{2,287400},{4,7185}]','[]',0,0,5,0),(1006011253,'命运战腿','12阶粉色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006011200,1,500,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,459841},{4,11496}]','[]',0,0,5,0),(1006011263,'命运战腿','12阶神装裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006011200,1,500,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,574801},{4,14370}]','[]',0,0,5,0),(1006011300,'制裁战腿','13阶绿色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006011300,1,520,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,69635},{4,1741}]','[]',0,0,5,0),(1006011310,'制裁战腿','13阶蓝色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006011300,1,520,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,104453},{4,2611}]','[]',0,0,5,0),(1006011320,'制裁战腿','13阶紫色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006011300,1,520,0,2,0,0,0,'[{1,10}]',0,0,0,0,'[{2,190104},{4,4753}]','[]',0,0,5,0),(1006011331,'制裁战腿','13阶橙1星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006011300,1,520,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{2,231885},{4,5797}]','[]',0,0,5,0),(1006011332,'制裁战腿','13阶橙2星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006011300,1,520,0,3,0,0,0,'[{1,17}]',0,0,0,0,'[{2,231885},{4,5797}]','[]',0,0,5,0),(1006011341,'制裁战腿','13阶红1星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006011300,1,520,0,4,0,0,0,'[{1,72}]',0,0,0,0,'[{2,348176},{4,8704}]','[]',0,0,5,0),(1006011342,'制裁战腿','13阶红2星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006011300,1,520,0,4,0,0,0,'[{1,128}]',0,0,0,0,'[{2,348176},{4,8704}]','[]',0,0,5,0),(1006011343,'制裁战腿','13阶红3星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006011300,1,520,0,4,0,0,0,'[{1,1117}]',0,0,0,0,'[{2,348176},{4,8704}]','[]',0,0,5,0),(1006011353,'制裁战腿','13阶粉色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006011300,1,520,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,557082},{4,13927}]','[]',0,0,5,0),(1006011363,'制裁战腿','13阶神装裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006011300,1,520,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,696352},{4,17409}]','[]',0,0,5,0),(1006011400,'审判战腿','14阶绿色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006011400,1,620,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,83185},{4,2080}]','[]',0,0,6,0),(1006011410,'审判战腿','14阶蓝色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006011400,1,620,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{2,124777},{4,3119}]','[]',0,0,6,0),(1006011420,'审判战腿','14阶紫色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006011400,1,620,0,2,0,0,0,'[{1,11}]',0,0,0,0,'[{2,227094},{4,5677}]','[]',0,0,6,0),(1006011431,'审判战腿','14阶橙1星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006011400,1,620,0,3,0,0,0,'[{1,15}]',0,0,0,0,'[{2,277005},{4,6925}]','[]',0,0,6,0),(1006011432,'审判战腿','14阶橙2星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006011400,1,620,0,3,0,0,0,'[{1,19}]',0,0,0,0,'[{2,277005},{4,6925}]','[]',0,0,6,0),(1006011441,'审判战腿','14阶红1星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006011400,1,620,0,4,0,0,0,'[{1,82}]',0,0,0,0,'[{2,415923},{4,10398}]','[]',0,0,6,0),(1006011442,'审判战腿','14阶红2星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006011400,1,620,0,4,0,0,0,'[{1,146}]',0,0,0,0,'[{2,415923},{4,10398}]','[]',0,0,6,0),(1006011443,'审判战腿','14阶红3星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006011400,1,620,0,4,0,0,0,'[{1,1444}]',0,0,0,0,'[{2,415923},{4,10398}]','[]',0,0,6,0),(1006011453,'审判战腿','14阶粉色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006011400,1,620,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,665478},{4,16637}]','[]',0,0,6,0),(1006011463,'审判战腿','14阶神装裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006011400,1,620,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,831847},{4,20796}]','[]',0,0,6,0),(1006011500,'毁灭战腿','15阶绿色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006011500,1,650,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,98182},{4,2455}]','[]',0,0,6,0),(1006011510,'毁灭战腿','15阶蓝色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006011500,1,650,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{2,147273},{4,3682}]','[]',0,0,6,0),(1006011520,'毁灭战腿','15阶紫色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006011500,1,650,0,2,0,0,0,'[{1,12}]',0,0,0,0,'[{2,268036},{4,6701}]','[]',0,0,6,0),(1006011531,'毁灭战腿','15阶橙1星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006011500,1,650,0,3,0,0,0,'[{1,16}]',0,0,0,0,'[{2,326945},{4,8174}]','[]',0,0,6,0),(1006011532,'毁灭战腿','15阶橙2星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006011500,1,650,0,3,0,0,0,'[{1,20}]',0,0,0,0,'[{2,326945},{4,8174}]','[]',0,0,6,0),(1006011541,'毁灭战腿','15阶红1星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006011500,1,650,0,4,0,0,0,'[{1,92}]',0,0,0,0,'[{2,490909},{4,12273}]','[]',0,0,6,0),(1006011542,'毁灭战腿','15阶红2星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006011500,1,650,0,4,0,0,0,'[{1,164}]',0,0,0,0,'[{2,490909},{4,12273}]','[]',0,0,6,0),(1006011543,'毁灭战腿','15阶红3星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006011500,1,650,0,4,0,0,0,'[{1,1717}]',0,0,0,0,'[{2,490909},{4,12273}]','[]',0,0,6,0),(1006011553,'毁灭战腿','15阶粉色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006011500,1,650,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,785455},{4,19636}]','[]',0,0,6,0),(1006011563,'毁灭战腿','15阶神装裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006011500,1,650,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,981818},{4,24545}]','[]',0,0,6,0),(1006011600,'混沌战腿','16阶绿色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006011500,1,700,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{2,114680},{4,2867}]','[]',0,0,6,0),(1006011610,'混沌战腿','16阶蓝色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006011500,1,700,0,1,0,0,0,'[{1,7}]',0,0,0,0,'[{2,172020},{4,4300}]','[]',0,0,6,0),(1006011620,'混沌战腿','16阶紫色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006011500,1,700,0,2,0,0,0,'[{1,14}]',0,0,0,0,'[{2,313076},{4,7827}]','[]',0,0,6,0),(1006011631,'混沌战腿','16阶橙1星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006011500,1,700,0,3,0,0,0,'[{1,19}]',0,0,0,0,'[{2,381884},{4,9547}]','[]',0,0,6,0),(1006011632,'混沌战腿','16阶橙2星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006011500,1,700,0,3,0,0,0,'[{1,23}]',0,0,0,0,'[{2,381884},{4,9547}]','[]',0,0,6,0),(1006011641,'混沌战腿','16阶红1星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006011500,1,700,0,4,0,0,0,'[{1,112}]',0,0,0,0,'[{2,573400},{4,14335}]','[]',0,0,6,0),(1006011642,'混沌战腿','16阶红2星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006011500,1,700,0,4,0,0,0,'[{1,200}]',0,0,0,0,'[{2,573400},{4,14335}]','[]',0,0,6,0),(1006011643,'混沌战腿','16阶红3星裤子【魔剑士】','',0,'','',0,1,1,10,6,1,2,6,1006011500,1,700,0,4,0,0,0,'[{1,2044}]',0,0,0,0,'[{2,573400},{4,14335}]','[]',0,0,6,0),(1006011653,'混沌战腿','16阶粉色裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006011500,1,700,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,917440},{4,22936}]','[]',0,0,6,0),(1006011663,'混沌战腿','16阶神装裤子【魔剑士】','',0,'','',0,0,1,10,6,0,0,6,1006011500,1,700,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,1146800},{4,28670}]','[]',0,0,6,0),(1006020100,'学徒护腿','1阶绿色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006020100,2,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,487},{4,12}]','[]',0,0,0,0),(1006020110,'学徒护腿','1阶蓝色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006020100,2,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,731},{4,18}]','[]',0,0,0,0),(1006020120,'学徒护腿','1阶紫色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006020100,2,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1330},{4,33}]','[]',0,0,0,0),(1006020131,'学徒护腿','1阶橙1星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006020100,2,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1622},{4,41}]','[]',0,0,0,0),(1006020132,'学徒护腿','1阶橙2星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006020100,2,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1622},{4,41}]','[]',0,0,0,0),(1006020141,'学徒护腿','1阶红1星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006020100,2,1,0,4,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2435},{4,61}]','[]',0,0,0,0),(1006020142,'学徒护腿','1阶红2星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006020100,2,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{2,2435},{4,61}]','[]',0,0,0,0),(1006020143,'学徒护腿','1阶红3星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006020100,2,1,0,4,0,0,0,'[{1,5}]',0,0,0,0,'[{2,2435},{4,61}]','[]',0,0,0,0),(1006020153,'学徒护腿','1阶粉色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006020100,2,1,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,3896},{4,97}]','[]',0,0,0,0),(1006020163,'学徒护腿','1阶神装裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006020100,2,1,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,4870},{4,122}]','[]',0,0,0,0),(1006020200,'冒险护腿','2阶绿色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006020200,2,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,834},{4,21}]','[]',0,0,0,0),(1006020210,'冒险护腿','2阶蓝色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006020200,2,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1251},{4,31}]','[]',0,0,0,0),(1006020220,'冒险护腿','2阶紫色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006020200,2,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2277},{4,57}]','[]',0,0,0,0),(1006020231,'冒险护腿','2阶橙1星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006020200,2,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2777},{4,69}]','[]',0,0,0,0),(1006020232,'冒险护腿','2阶橙2星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006020200,2,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2777},{4,69}]','[]',0,0,0,0),(1006020241,'冒险护腿','2阶红1星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006020200,2,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{2,4170},{4,104}]','[]',0,0,0,0),(1006020242,'冒险护腿','2阶红2星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006020200,2,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{2,4170},{4,104}]','[]',0,0,0,0),(1006020243,'冒险护腿','2阶红3星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006020200,2,1,0,4,0,0,0,'[{1,8}]',0,0,0,0,'[{2,4170},{4,104}]','[]',0,0,0,0),(1006020253,'冒险护腿','2阶粉色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006020200,2,1,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,6671},{4,167}]','[]',0,0,0,0),(1006020263,'冒险护腿','2阶神装裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006020200,2,1,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,8339},{4,208}]','[]',0,0,0,0),(1006020300,'勇者护腿','3阶绿色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006020300,2,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1988},{4,50}]','[]',0,0,0,0),(1006020310,'勇者护腿','3阶蓝色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006020300,2,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2982},{4,75}]','[]',0,0,0,0),(1006020320,'勇者护腿','3阶紫色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006020300,2,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,5427},{4,136}]','[]',0,0,0,0),(1006020331,'勇者护腿','3阶橙1星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006020300,2,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6620},{4,166}]','[]',0,0,0,0),(1006020332,'勇者护腿','3阶橙2星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006020300,2,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6620},{4,166}]','[]',0,0,0,0),(1006020341,'勇者护腿','3阶红1星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006020300,2,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{2,9940},{4,249}]','[]',0,0,0,0),(1006020342,'勇者护腿','3阶红2星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006020300,2,1,0,4,0,0,0,'[{1,4}]',0,0,0,0,'[{2,9940},{4,249}]','[]',0,0,0,0),(1006020343,'勇者护腿','3阶红3星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006020300,2,1,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,9940},{4,249}]','[]',0,0,0,0),(1006020353,'勇者护腿','3阶粉色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006020300,2,1,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,15904},{4,398}]','[]',0,0,0,0),(1006020363,'勇者护腿','3阶神装裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006020300,2,1,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,19881},{4,497}]','[]',0,0,0,0),(1006020400,'先驱护腿','4阶绿色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006020400,2,100,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,4003},{4,100}]','[]',0,0,0,0),(1006020410,'先驱护腿','4阶蓝色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006020400,2,100,0,1,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6004},{4,150}]','[]',0,0,0,0),(1006020420,'先驱护腿','4阶紫色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006020400,2,100,0,2,0,0,0,'[{1,3}]',0,0,0,0,'[{2,10928},{4,273}]','[]',0,0,0,0),(1006020431,'先驱护腿','4阶橙1星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006020400,2,100,0,3,0,0,0,'[{1,3}]',0,0,0,0,'[{2,13329},{4,333}]','[]',0,0,0,0),(1006020432,'先驱护腿','4阶橙2星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006020400,2,100,0,3,0,0,0,'[{1,4}]',0,0,0,0,'[{2,13329},{4,333}]','[]',0,0,0,0),(1006020441,'先驱护腿','4阶红1星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006020400,2,100,0,4,0,0,0,'[{1,8}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1006020442,'先驱护腿','4阶红2星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006020400,2,100,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1006020443,'先驱护腿','4阶红3星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006020400,2,100,0,4,0,0,0,'[{1,34}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1006020453,'先驱护腿','4阶粉色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006020400,2,100,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,32022},{4,801}]','[]',0,0,0,0),(1006020463,'先驱护腿','4阶神装裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006020400,2,100,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,40028},{4,1001}]','[]',0,0,0,0),(1006020500,'荣誉护腿','5阶绿色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006020500,2,150,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,6932},{4,173}]','[]',0,0,1,0),(1006020510,'荣誉护腿','5阶蓝色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006020500,2,150,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{2,10397},{4,260}]','[]',0,0,1,0),(1006020520,'荣誉护腿','5阶紫色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006020500,2,150,0,2,0,0,0,'[{1,5}]',0,0,0,0,'[{2,18923},{4,473}]','[]',0,0,1,0),(1006020531,'荣誉护腿','5阶橙1星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006020500,2,150,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,1,0),(1006020532,'荣誉护腿','5阶橙2星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006020500,2,150,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,1,0),(1006020541,'荣誉护腿','5阶红1星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006020500,2,150,0,4,0,0,0,'[{1,14}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,1,0),(1006020542,'荣誉护腿','5阶红2星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006020500,2,150,0,4,0,0,0,'[{1,21}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,1,0),(1006020543,'荣誉护腿','5阶红3星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006020500,2,150,0,4,0,0,0,'[{1,63}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,1,0),(1006020553,'荣誉护腿','5阶粉色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006020500,2,150,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,55452},{4,1386}]','[]',0,0,1,0),(1006020563,'荣誉护腿','5阶神装裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006020500,2,150,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,69315},{4,1733}]','[]',0,0,1,0),(1006020600,'贤者护腿','6阶绿色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006020600,2,180,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,10828},{4,271}]','[]',0,0,1,0),(1006020610,'贤者护腿','6阶蓝色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006020600,2,180,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{2,16241},{4,406}]','[]',0,0,1,0),(1006020620,'贤者护腿','6阶紫色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006020600,2,180,0,2,0,0,0,'[{1,5}]',0,0,0,0,'[{2,29559},{4,739}]','[]',0,0,1,0),(1006020631,'贤者护腿','6阶橙1星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006020600,2,180,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,36056},{4,901}]','[]',0,0,1,0),(1006020632,'贤者护腿','6阶橙2星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006020600,2,180,0,3,0,0,0,'[{1,8}]',0,0,0,0,'[{2,36056},{4,901}]','[]',0,0,1,0),(1006020641,'贤者护腿','6阶红1星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006020600,2,180,0,4,0,0,0,'[{1,18}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,1,0),(1006020642,'贤者护腿','6阶红2星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006020600,2,180,0,4,0,0,0,'[{1,28}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,1,0),(1006020643,'贤者护腿','6阶红3星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006020600,2,180,0,4,0,0,0,'[{1,104}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,1,0),(1006020653,'贤者护腿','6阶粉色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006020600,2,180,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,86620},{4,2166}]','[]',0,0,1,0),(1006020663,'贤者护腿','6阶神装裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006020600,2,180,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,108276},{4,2707}]','[]',0,0,1,0),(1006020700,'征服护腿','7阶绿色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006020700,2,220,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,15744},{4,394}]','[]',0,0,2,0),(1006020710,'征服护腿','7阶蓝色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006020700,2,220,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{2,23616},{4,590}]','[]',0,0,2,0),(1006020720,'征服护腿','7阶紫色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006020700,2,220,0,2,0,0,0,'[{1,6}]',0,0,0,0,'[{2,42982},{4,1075}]','[]',0,0,2,0),(1006020731,'征服护腿','7阶橙1星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006020700,2,220,0,3,0,0,0,'[{1,8}]',0,0,0,0,'[{2,52429},{4,1311}]','[]',0,0,2,0),(1006020732,'征服护腿','7阶橙2星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006020700,2,220,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,52429},{4,1311}]','[]',0,0,2,0),(1006020741,'征服护腿','7阶红1星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006020700,2,220,0,4,0,0,0,'[{1,25}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,2,0),(1006020742,'征服护腿','7阶红2星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006020700,2,220,0,4,0,0,0,'[{1,41}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,2,0),(1006020743,'征服护腿','7阶红3星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006020700,2,220,0,4,0,0,0,'[{1,149}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,2,0),(1006020753,'征服护腿','7阶粉色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006020700,2,220,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,125955},{4,3149}]','[]',0,0,2,0),(1006020763,'征服护腿','7阶神装裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006020700,2,220,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,157443},{4,3936}]','[]',0,0,2,0),(1006020800,'秩序护腿','8阶绿色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006020800,2,260,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,21735},{4,543}]','[]',0,0,2,0),(1006020810,'秩序护腿','8阶蓝色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006020800,2,260,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,32603},{4,815}]','[]',0,0,2,0),(1006020820,'秩序护腿','8阶紫色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006020800,2,260,0,2,0,0,0,'[{1,7}]',0,0,0,0,'[{2,59337},{4,1483}]','[]',0,0,2,0),(1006020831,'秩序护腿','8阶橙1星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006020800,2,260,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{2,72378},{4,1809}]','[]',0,0,2,0),(1006020832,'秩序护腿','8阶橙2星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006020800,2,260,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{2,72378},{4,1809}]','[]',0,0,2,0),(1006020841,'秩序护腿','8阶红1星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006020800,2,260,0,4,0,0,0,'[{1,28}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,2,0),(1006020842,'秩序护腿','8阶红2星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006020800,2,260,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,2,0),(1006020843,'秩序护腿','8阶红3星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006020800,2,260,0,4,0,0,0,'[{1,208}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,2,0),(1006020853,'秩序护腿','8阶粉色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006020800,2,260,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,173881},{4,4347}]','[]',0,0,2,0),(1006020863,'秩序护腿','8阶神装裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006020800,2,260,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,217352},{4,5434}]','[]',0,0,2,0),(1006020900,'守护护腿','9阶绿色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006020900,2,300,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,28847},{4,721}]','[]',0,0,3,0),(1006020910,'守护护腿','9阶蓝色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006020900,2,300,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,43270},{4,1082}]','[]',0,0,3,0),(1006020920,'守护护腿','9阶紫色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006020900,2,300,0,2,0,0,0,'[{1,7}]',0,0,0,0,'[{2,78752},{4,1969}]','[]',0,0,3,0),(1006020931,'守护护腿','9阶橙1星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006020900,2,300,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,96060},{4,2401}]','[]',0,0,3,0),(1006020932,'守护护腿','9阶橙2星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006020900,2,300,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{2,96060},{4,2401}]','[]',0,0,3,0),(1006020941,'守护护腿','9阶红1星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006020900,2,300,0,4,0,0,0,'[{1,33}]',0,0,0,0,'[{2,144234},{4,3606}]','[]',0,0,3,0),(1006020942,'守护护腿','9阶红2星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006020900,2,300,0,4,0,0,0,'[{1,55}]',0,0,0,0,'[{2,144234},{4,3606}]','[]',0,0,3,0),(1006020943,'守护护腿','9阶红3星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006020900,2,300,0,4,0,0,0,'[{1,290}]',0,0,0,0,'[{2,144234},{4,3606}]','[]',0,0,3,0),(1006020953,'守护护腿','9阶粉色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006020900,2,300,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,230774},{4,5769}]','[]',0,0,3,0),(1006020963,'守护护腿','9阶神装裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006020900,2,300,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,288468},{4,7212}]','[]',0,0,3,0),(1006021000,'信仰护腿','10阶绿色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006021000,2,355,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,37139},{4,928}]','[]',0,0,4,0),(1006021010,'信仰护腿','10阶蓝色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006021000,2,355,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,55709},{4,1393}]','[]',0,0,4,0),(1006021020,'信仰护腿','10阶紫色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006021000,2,355,0,2,0,0,0,'[{1,8}]',0,0,0,0,'[{2,101390},{4,2535}]','[]',0,0,4,0),(1006021031,'信仰护腿','10阶橙1星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006021000,2,355,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,123674},{4,3092}]','[]',0,0,4,0),(1006021032,'信仰护腿','10阶橙2星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006021000,2,355,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{2,123674},{4,3092}]','[]',0,0,4,0),(1006021041,'信仰护腿','10阶红1星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006021000,2,355,0,4,0,0,0,'[{1,40}]',0,0,0,0,'[{2,185696},{4,4642}]','[]',0,0,4,0),(1006021042,'信仰护腿','10阶红2星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006021000,2,355,0,4,0,0,0,'[{1,69}]',0,0,0,0,'[{2,185696},{4,4642}]','[]',0,0,4,0),(1006021043,'信仰护腿','10阶红3星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006021000,2,355,0,4,0,0,0,'[{1,399}]',0,0,0,0,'[{2,185696},{4,4642}]','[]',0,0,4,0),(1006021053,'信仰护腿','10阶粉色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006021000,2,355,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,297114},{4,7428}]','[]',0,0,4,0),(1006021063,'信仰护腿','10阶神装裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006021000,2,355,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,371392},{4,9285}]','[]',0,0,4,0),(1006021100,'天行护腿','11阶绿色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006021100,2,400,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,46666},{4,1167}]','[]',0,0,4,0),(1006021110,'天行护腿','11阶蓝色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006021100,2,400,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,69999},{4,1750}]','[]',0,0,4,0),(1006021120,'天行护腿','11阶紫色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006021100,2,400,0,2,0,0,0,'[{1,9}]',0,0,0,0,'[{2,127398},{4,3185}]','[]',0,0,4,0),(1006021131,'天行护腿','11阶橙1星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006021100,2,400,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{2,155397},{4,3885}]','[]',0,0,4,0),(1006021132,'天行护腿','11阶橙2星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006021100,2,400,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{2,155397},{4,3885}]','[]',0,0,4,0),(1006021141,'天行护腿','11阶红1星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006021100,2,400,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{2,233329},{4,5833}]','[]',0,0,4,0),(1006021142,'天行护腿','11阶红2星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006021100,2,400,0,4,0,0,0,'[{1,78}]',0,0,0,0,'[{2,233329},{4,5833}]','[]',0,0,4,0),(1006021143,'天行护腿','11阶红3星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006021100,2,400,0,4,0,0,0,'[{1,549}]',0,0,0,0,'[{2,233329},{4,5833}]','[]',0,0,4,0),(1006021153,'天行护腿','11阶粉色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006021100,2,400,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,373327},{4,9333}]','[]',0,0,4,0),(1006021163,'天行护腿','11阶神装裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006021100,2,400,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,466659},{4,11666}]','[]',0,0,4,0),(1006021200,'命运护腿','12阶绿色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006021200,2,500,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,57480},{4,1437}]','[]',0,0,5,0),(1006021210,'命运护腿','12阶蓝色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006021200,2,500,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,86220},{4,2156}]','[]',0,0,5,0),(1006021220,'命运护腿','12阶紫色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006021200,2,500,0,2,0,0,0,'[{1,9}]',0,0,0,0,'[{2,156921},{4,3923}]','[]',0,0,5,0),(1006021231,'命运护腿','12阶橙1星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006021200,2,500,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{2,191409},{4,4785}]','[]',0,0,5,0),(1006021232,'命运护腿','12阶橙2星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006021200,2,500,0,3,0,0,0,'[{1,15}]',0,0,0,0,'[{2,191409},{4,4785}]','[]',0,0,5,0),(1006021241,'命运护腿','12阶红1星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006021200,2,500,0,4,0,0,0,'[{1,62}]',0,0,0,0,'[{2,287400},{4,7185}]','[]',0,0,5,0),(1006021242,'命运护腿','12阶红2星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006021200,2,500,0,4,0,0,0,'[{1,110}]',0,0,0,0,'[{2,287400},{4,7185}]','[]',0,0,5,0),(1006021243,'命运护腿','12阶红3星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006021200,2,500,0,4,0,0,0,'[{1,799}]',0,0,0,0,'[{2,287400},{4,7185}]','[]',0,0,5,0),(1006021253,'命运护腿','12阶粉色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006021200,2,500,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,459841},{4,11496}]','[]',0,0,5,0),(1006021263,'命运护腿','12阶神装裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006021200,2,500,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,574801},{4,14370}]','[]',0,0,5,0),(1006021300,'制裁护腿','13阶绿色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006021300,2,520,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,69635},{4,1741}]','[]',0,0,5,0),(1006021310,'制裁护腿','13阶蓝色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006021300,2,520,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,104453},{4,2611}]','[]',0,0,5,0),(1006021320,'制裁护腿','13阶紫色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006021300,2,520,0,2,0,0,0,'[{1,10}]',0,0,0,0,'[{2,190104},{4,4753}]','[]',0,0,5,0),(1006021331,'制裁护腿','13阶橙1星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006021300,2,520,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{2,231885},{4,5797}]','[]',0,0,5,0),(1006021332,'制裁护腿','13阶橙2星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006021300,2,520,0,3,0,0,0,'[{1,17}]',0,0,0,0,'[{2,231885},{4,5797}]','[]',0,0,5,0),(1006021341,'制裁护腿','13阶红1星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006021300,2,520,0,4,0,0,0,'[{1,72}]',0,0,0,0,'[{2,348176},{4,8704}]','[]',0,0,5,0),(1006021342,'制裁护腿','13阶红2星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006021300,2,520,0,4,0,0,0,'[{1,128}]',0,0,0,0,'[{2,348176},{4,8704}]','[]',0,0,5,0),(1006021343,'制裁护腿','13阶红3星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006021300,2,520,0,4,0,0,0,'[{1,1117}]',0,0,0,0,'[{2,348176},{4,8704}]','[]',0,0,5,0),(1006021353,'制裁护腿','13阶粉色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006021300,2,520,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,557082},{4,13927}]','[]',0,0,5,0),(1006021363,'制裁护腿','13阶神装裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006021300,2,520,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,696352},{4,17409}]','[]',0,0,5,0),(1006021400,'审判护腿','14阶绿色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006021400,2,620,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,83185},{4,2080}]','[]',0,0,6,0),(1006021410,'审判护腿','14阶蓝色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006021400,2,620,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{2,124777},{4,3119}]','[]',0,0,6,0),(1006021420,'审判护腿','14阶紫色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006021400,2,620,0,2,0,0,0,'[{1,11}]',0,0,0,0,'[{2,227094},{4,5677}]','[]',0,0,6,0),(1006021431,'审判护腿','14阶橙1星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006021400,2,620,0,3,0,0,0,'[{1,15}]',0,0,0,0,'[{2,277005},{4,6925}]','[]',0,0,6,0),(1006021432,'审判护腿','14阶橙2星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006021400,2,620,0,3,0,0,0,'[{1,19}]',0,0,0,0,'[{2,277005},{4,6925}]','[]',0,0,6,0),(1006021441,'审判护腿','14阶红1星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006021400,2,620,0,4,0,0,0,'[{1,82}]',0,0,0,0,'[{2,415923},{4,10398}]','[]',0,0,6,0),(1006021442,'审判护腿','14阶红2星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006021400,2,620,0,4,0,0,0,'[{1,146}]',0,0,0,0,'[{2,415923},{4,10398}]','[]',0,0,6,0),(1006021443,'审判护腿','14阶红3星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006021400,2,620,0,4,0,0,0,'[{1,1444}]',0,0,0,0,'[{2,415923},{4,10398}]','[]',0,0,6,0),(1006021453,'审判护腿','14阶粉色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006021400,2,620,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,665478},{4,16637}]','[]',0,0,6,0),(1006021463,'审判护腿','14阶神装裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006021400,2,620,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,831847},{4,20796}]','[]',0,0,6,0),(1006021500,'毁灭护腿','15阶绿色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006021500,2,650,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,98182},{4,2455}]','[]',0,0,6,0),(1006021510,'毁灭护腿','15阶蓝色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006021500,2,650,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{2,147273},{4,3682}]','[]',0,0,6,0),(1006021520,'毁灭护腿','15阶紫色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006021500,2,650,0,2,0,0,0,'[{1,12}]',0,0,0,0,'[{2,268036},{4,6701}]','[]',0,0,6,0),(1006021531,'毁灭护腿','15阶橙1星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006021500,2,650,0,3,0,0,0,'[{1,16}]',0,0,0,0,'[{2,326945},{4,8174}]','[]',0,0,6,0),(1006021532,'毁灭护腿','15阶橙2星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006021500,2,650,0,3,0,0,0,'[{1,20}]',0,0,0,0,'[{2,326945},{4,8174}]','[]',0,0,6,0),(1006021541,'毁灭护腿','15阶红1星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006021500,2,650,0,4,0,0,0,'[{1,92}]',0,0,0,0,'[{2,490909},{4,12273}]','[]',0,0,6,0),(1006021542,'毁灭护腿','15阶红2星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006021500,2,650,0,4,0,0,0,'[{1,164}]',0,0,0,0,'[{2,490909},{4,12273}]','[]',0,0,6,0),(1006021543,'毁灭护腿','15阶红3星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006021500,2,650,0,4,0,0,0,'[{1,1717}]',0,0,0,0,'[{2,490909},{4,12273}]','[]',0,0,6,0),(1006021553,'毁灭护腿','15阶粉色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006021500,2,650,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,785455},{4,19636}]','[]',0,0,6,0),(1006021563,'毁灭护腿','15阶神装裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006021500,2,650,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,981818},{4,24545}]','[]',0,0,6,0),(1006021600,'混沌护腿','16阶绿色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006021500,2,700,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{2,114680},{4,2867}]','[]',0,0,6,0),(1006021610,'混沌护腿','16阶蓝色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006021500,2,700,0,1,0,0,0,'[{1,7}]',0,0,0,0,'[{2,172020},{4,4300}]','[]',0,0,6,0),(1006021620,'混沌护腿','16阶紫色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006021500,2,700,0,2,0,0,0,'[{1,14}]',0,0,0,0,'[{2,313076},{4,7827}]','[]',0,0,6,0),(1006021631,'混沌护腿','16阶橙1星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006021500,2,700,0,3,0,0,0,'[{1,19}]',0,0,0,0,'[{2,381884},{4,9547}]','[]',0,0,6,0),(1006021632,'混沌护腿','16阶橙2星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006021500,2,700,0,3,0,0,0,'[{1,23}]',0,0,0,0,'[{2,381884},{4,9547}]','[]',0,0,6,0),(1006021641,'混沌护腿','16阶红1星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006021500,2,700,0,4,0,0,0,'[{1,112}]',0,0,0,0,'[{2,573400},{4,14335}]','[]',0,0,6,0),(1006021642,'混沌护腿','16阶红2星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006021500,2,700,0,4,0,0,0,'[{1,200}]',0,0,0,0,'[{2,573400},{4,14335}]','[]',0,0,6,0),(1006021643,'混沌护腿','16阶红3星裤子【龙骑士】','',0,'','',0,1,1,10,6,1,2,6,1006021500,2,700,0,4,0,0,0,'[{1,2044}]',0,0,0,0,'[{2,573400},{4,14335}]','[]',0,0,6,0),(1006021653,'混沌护腿','16阶粉色裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006021500,2,700,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,917440},{4,22936}]','[]',0,0,6,0),(1006021663,'混沌护腿','16阶神装裤子【龙骑士】','',0,'','',0,0,1,10,6,0,0,6,1006021500,2,700,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,1146800},{4,28670}]','[]',0,0,6,0),(1006030100,'学徒裤裙','1阶绿色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006030100,3,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,487},{4,12}]','[]',0,0,0,0),(1006030110,'学徒裤裙','1阶蓝色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006030100,3,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,731},{4,18}]','[]',0,0,0,0),(1006030120,'学徒裤裙','1阶紫色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006030100,3,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1330},{4,33}]','[]',0,0,0,0),(1006030131,'学徒裤裙','1阶橙1星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006030100,3,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1622},{4,41}]','[]',0,0,0,0),(1006030132,'学徒裤裙','1阶橙2星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006030100,3,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1622},{4,41}]','[]',0,0,0,0),(1006030141,'学徒裤裙','1阶红1星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006030100,3,1,0,4,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2435},{4,61}]','[]',0,0,0,0),(1006030142,'学徒裤裙','1阶红2星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006030100,3,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{2,2435},{4,61}]','[]',0,0,0,0),(1006030143,'学徒裤裙','1阶红3星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006030100,3,1,0,4,0,0,0,'[{1,5}]',0,0,0,0,'[{2,2435},{4,61}]','[]',0,0,0,0),(1006030153,'学徒裤裙','1阶粉色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006030100,3,1,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,3896},{4,97}]','[]',0,0,0,0),(1006030163,'学徒裤裙','1阶神装裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006030100,3,1,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,4870},{4,122}]','[]',0,0,0,0),(1006030200,'冒险裤裙','2阶绿色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006030200,3,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,834},{4,21}]','[]',0,0,0,0),(1006030210,'冒险裤裙','2阶蓝色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006030200,3,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1251},{4,31}]','[]',0,0,0,0),(1006030220,'冒险裤裙','2阶紫色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006030200,3,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2277},{4,57}]','[]',0,0,0,0),(1006030231,'冒险裤裙','2阶橙1星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006030200,3,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2777},{4,69}]','[]',0,0,0,0),(1006030232,'冒险裤裙','2阶橙2星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006030200,3,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2777},{4,69}]','[]',0,0,0,0),(1006030241,'冒险裤裙','2阶红1星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006030200,3,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{2,4170},{4,104}]','[]',0,0,0,0),(1006030242,'冒险裤裙','2阶红2星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006030200,3,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{2,4170},{4,104}]','[]',0,0,0,0),(1006030243,'冒险裤裙','2阶红3星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006030200,3,1,0,4,0,0,0,'[{1,8}]',0,0,0,0,'[{2,4170},{4,104}]','[]',0,0,0,0),(1006030253,'冒险裤裙','2阶粉色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006030200,3,1,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,6671},{4,167}]','[]',0,0,0,0),(1006030263,'冒险裤裙','2阶神装裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006030200,3,1,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,8339},{4,208}]','[]',0,0,0,0),(1006030300,'勇者裤裙','3阶绿色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006030300,3,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1988},{4,50}]','[]',0,0,0,0),(1006030310,'勇者裤裙','3阶蓝色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006030300,3,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2982},{4,75}]','[]',0,0,0,0),(1006030320,'勇者裤裙','3阶紫色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006030300,3,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,5427},{4,136}]','[]',0,0,0,0),(1006030331,'勇者裤裙','3阶橙1星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006030300,3,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6620},{4,166}]','[]',0,0,0,0),(1006030332,'勇者裤裙','3阶橙2星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006030300,3,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6620},{4,166}]','[]',0,0,0,0),(1006030341,'勇者裤裙','3阶红1星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006030300,3,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{2,9940},{4,249}]','[]',0,0,0,0),(1006030342,'勇者裤裙','3阶红2星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006030300,3,1,0,4,0,0,0,'[{1,4}]',0,0,0,0,'[{2,9940},{4,249}]','[]',0,0,0,0),(1006030343,'勇者裤裙','3阶红3星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006030300,3,1,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,9940},{4,249}]','[]',0,0,0,0),(1006030353,'勇者裤裙','3阶粉色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006030300,3,1,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,15904},{4,398}]','[]',0,0,0,0),(1006030363,'勇者裤裙','3阶神装裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006030300,3,1,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,19881},{4,497}]','[]',0,0,0,0),(1006030400,'先驱裤裙','4阶绿色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006030400,3,100,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,4003},{4,100}]','[]',0,0,0,0),(1006030410,'先驱裤裙','4阶蓝色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006030400,3,100,0,1,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6004},{4,150}]','[]',0,0,0,0),(1006030420,'先驱裤裙','4阶紫色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006030400,3,100,0,2,0,0,0,'[{1,3}]',0,0,0,0,'[{2,10928},{4,273}]','[]',0,0,0,0),(1006030431,'先驱裤裙','4阶橙1星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006030400,3,100,0,3,0,0,0,'[{1,3}]',0,0,0,0,'[{2,13329},{4,333}]','[]',0,0,0,0),(1006030432,'先驱裤裙','4阶橙2星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006030400,3,100,0,3,0,0,0,'[{1,4}]',0,0,0,0,'[{2,13329},{4,333}]','[]',0,0,0,0),(1006030441,'先驱裤裙','4阶红1星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006030400,3,100,0,4,0,0,0,'[{1,8}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1006030442,'先驱裤裙','4阶红2星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006030400,3,100,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1006030443,'先驱裤裙','4阶红3星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006030400,3,100,0,4,0,0,0,'[{1,34}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1006030453,'先驱裤裙','4阶粉色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006030400,3,100,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,32022},{4,801}]','[]',0,0,0,0),(1006030463,'先驱裤裙','4阶神装裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006030400,3,100,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,40028},{4,1001}]','[]',0,0,0,0),(1006030500,'荣誉裤裙','5阶绿色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006030500,3,150,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,6932},{4,173}]','[]',0,0,1,0),(1006030510,'荣誉裤裙','5阶蓝色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006030500,3,150,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{2,10397},{4,260}]','[]',0,0,1,0),(1006030520,'荣誉裤裙','5阶紫色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006030500,3,150,0,2,0,0,0,'[{1,5}]',0,0,0,0,'[{2,18923},{4,473}]','[]',0,0,1,0),(1006030531,'荣誉裤裙','5阶橙1星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006030500,3,150,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,1,0),(1006030532,'荣誉裤裙','5阶橙2星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006030500,3,150,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,1,0),(1006030541,'荣誉裤裙','5阶红1星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006030500,3,150,0,4,0,0,0,'[{1,14}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,1,0),(1006030542,'荣誉裤裙','5阶红2星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006030500,3,150,0,4,0,0,0,'[{1,21}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,1,0),(1006030543,'荣誉裤裙','5阶红3星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006030500,3,150,0,4,0,0,0,'[{1,63}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,1,0),(1006030553,'荣誉裤裙','5阶粉色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006030500,3,150,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,55452},{4,1386}]','[]',0,0,1,0),(1006030563,'荣誉裤裙','5阶神装裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006030500,3,150,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,69315},{4,1733}]','[]',0,0,1,0),(1006030600,'贤者裤裙','6阶绿色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006030600,3,180,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,10828},{4,271}]','[]',0,0,1,0),(1006030610,'贤者裤裙','6阶蓝色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006030600,3,180,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{2,16241},{4,406}]','[]',0,0,1,0),(1006030620,'贤者裤裙','6阶紫色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006030600,3,180,0,2,0,0,0,'[{1,5}]',0,0,0,0,'[{2,29559},{4,739}]','[]',0,0,1,0),(1006030631,'贤者裤裙','6阶橙1星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006030600,3,180,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,36056},{4,901}]','[]',0,0,1,0),(1006030632,'贤者裤裙','6阶橙2星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006030600,3,180,0,3,0,0,0,'[{1,8}]',0,0,0,0,'[{2,36056},{4,901}]','[]',0,0,1,0),(1006030641,'贤者裤裙','6阶红1星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006030600,3,180,0,4,0,0,0,'[{1,18}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,1,0),(1006030642,'贤者裤裙','6阶红2星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006030600,3,180,0,4,0,0,0,'[{1,28}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,1,0),(1006030643,'贤者裤裙','6阶红3星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006030600,3,180,0,4,0,0,0,'[{1,104}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,1,0),(1006030653,'贤者裤裙','6阶粉色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006030600,3,180,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,86620},{4,2166}]','[]',0,0,1,0),(1006030663,'贤者裤裙','6阶神装裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006030600,3,180,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,108276},{4,2707}]','[]',0,0,1,0),(1006030700,'征服裤裙','7阶绿色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006030700,3,220,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,15744},{4,394}]','[]',0,0,2,0),(1006030710,'征服裤裙','7阶蓝色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006030700,3,220,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{2,23616},{4,590}]','[]',0,0,2,0),(1006030720,'征服裤裙','7阶紫色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006030700,3,220,0,2,0,0,0,'[{1,6}]',0,0,0,0,'[{2,42982},{4,1075}]','[]',0,0,2,0),(1006030731,'征服裤裙','7阶橙1星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006030700,3,220,0,3,0,0,0,'[{1,8}]',0,0,0,0,'[{2,52429},{4,1311}]','[]',0,0,2,0),(1006030732,'征服裤裙','7阶橙2星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006030700,3,220,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,52429},{4,1311}]','[]',0,0,2,0),(1006030741,'征服裤裙','7阶红1星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006030700,3,220,0,4,0,0,0,'[{1,25}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,2,0),(1006030742,'征服裤裙','7阶红2星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006030700,3,220,0,4,0,0,0,'[{1,41}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,2,0),(1006030743,'征服裤裙','7阶红3星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006030700,3,220,0,4,0,0,0,'[{1,149}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,2,0),(1006030753,'征服裤裙','7阶粉色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006030700,3,220,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,125955},{4,3149}]','[]',0,0,2,0),(1006030763,'征服裤裙','7阶神装裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006030700,3,220,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,157443},{4,3936}]','[]',0,0,2,0),(1006030800,'秩序裤裙','8阶绿色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006030800,3,260,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,21735},{4,543}]','[]',0,0,2,0),(1006030810,'秩序裤裙','8阶蓝色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006030800,3,260,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,32603},{4,815}]','[]',0,0,2,0),(1006030820,'秩序裤裙','8阶紫色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006030800,3,260,0,2,0,0,0,'[{1,7}]',0,0,0,0,'[{2,59337},{4,1483}]','[]',0,0,2,0),(1006030831,'秩序裤裙','8阶橙1星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006030800,3,260,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{2,72378},{4,1809}]','[]',0,0,2,0),(1006030832,'秩序裤裙','8阶橙2星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006030800,3,260,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{2,72378},{4,1809}]','[]',0,0,2,0),(1006030841,'秩序裤裙','8阶红1星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006030800,3,260,0,4,0,0,0,'[{1,28}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,2,0),(1006030842,'秩序裤裙','8阶红2星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006030800,3,260,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,2,0),(1006030843,'秩序裤裙','8阶红3星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006030800,3,260,0,4,0,0,0,'[{1,208}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,2,0),(1006030853,'秩序裤裙','8阶粉色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006030800,3,260,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,173881},{4,4347}]','[]',0,0,2,0),(1006030863,'秩序裤裙','8阶神装裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006030800,3,260,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,217352},{4,5434}]','[]',0,0,2,0),(1006030900,'守护裤裙','9阶绿色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006030900,3,300,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,28847},{4,721}]','[]',0,0,3,0),(1006030910,'守护裤裙','9阶蓝色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006030900,3,300,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,43270},{4,1082}]','[]',0,0,3,0),(1006030920,'守护裤裙','9阶紫色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006030900,3,300,0,2,0,0,0,'[{1,7}]',0,0,0,0,'[{2,78752},{4,1969}]','[]',0,0,3,0),(1006030931,'守护裤裙','9阶橙1星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006030900,3,300,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,96060},{4,2401}]','[]',0,0,3,0),(1006030932,'守护裤裙','9阶橙2星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006030900,3,300,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{2,96060},{4,2401}]','[]',0,0,3,0),(1006030941,'守护裤裙','9阶红1星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006030900,3,300,0,4,0,0,0,'[{1,33}]',0,0,0,0,'[{2,144234},{4,3606}]','[]',0,0,3,0),(1006030942,'守护裤裙','9阶红2星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006030900,3,300,0,4,0,0,0,'[{1,55}]',0,0,0,0,'[{2,144234},{4,3606}]','[]',0,0,3,0),(1006030943,'守护裤裙','9阶红3星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006030900,3,300,0,4,0,0,0,'[{1,290}]',0,0,0,0,'[{2,144234},{4,3606}]','[]',0,0,3,0),(1006030953,'守护裤裙','9阶粉色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006030900,3,300,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,230774},{4,5769}]','[]',0,0,3,0),(1006030963,'守护裤裙','9阶神装裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006030900,3,300,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,288468},{4,7212}]','[]',0,0,3,0),(1006031000,'信仰裤裙','10阶绿色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006031000,3,355,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,37139},{4,928}]','[]',0,0,4,0),(1006031010,'信仰裤裙','10阶蓝色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006031000,3,355,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,55709},{4,1393}]','[]',0,0,4,0),(1006031020,'信仰裤裙','10阶紫色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006031000,3,355,0,2,0,0,0,'[{1,8}]',0,0,0,0,'[{2,101390},{4,2535}]','[]',0,0,4,0),(1006031031,'信仰裤裙','10阶橙1星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006031000,3,355,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,123674},{4,3092}]','[]',0,0,4,0),(1006031032,'信仰裤裙','10阶橙2星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006031000,3,355,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{2,123674},{4,3092}]','[]',0,0,4,0),(1006031041,'信仰裤裙','10阶红1星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006031000,3,355,0,4,0,0,0,'[{1,40}]',0,0,0,0,'[{2,185696},{4,4642}]','[]',0,0,4,0),(1006031042,'信仰裤裙','10阶红2星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006031000,3,355,0,4,0,0,0,'[{1,69}]',0,0,0,0,'[{2,185696},{4,4642}]','[]',0,0,4,0),(1006031043,'信仰裤裙','10阶红3星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006031000,3,355,0,4,0,0,0,'[{1,399}]',0,0,0,0,'[{2,185696},{4,4642}]','[]',0,0,4,0),(1006031053,'信仰裤裙','10阶粉色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006031000,3,355,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,297114},{4,7428}]','[]',0,0,4,0),(1006031063,'信仰裤裙','10阶神装裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006031000,3,355,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,371392},{4,9285}]','[]',0,0,4,0),(1006031100,'天行裤裙','11阶绿色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006031100,3,400,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,46666},{4,1167}]','[]',0,0,4,0),(1006031110,'天行裤裙','11阶蓝色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006031100,3,400,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,69999},{4,1750}]','[]',0,0,4,0),(1006031120,'天行裤裙','11阶紫色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006031100,3,400,0,2,0,0,0,'[{1,9}]',0,0,0,0,'[{2,127398},{4,3185}]','[]',0,0,4,0),(1006031131,'天行裤裙','11阶橙1星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006031100,3,400,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{2,155397},{4,3885}]','[]',0,0,4,0),(1006031132,'天行裤裙','11阶橙2星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006031100,3,400,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{2,155397},{4,3885}]','[]',0,0,4,0),(1006031141,'天行裤裙','11阶红1星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006031100,3,400,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{2,233329},{4,5833}]','[]',0,0,4,0),(1006031142,'天行裤裙','11阶红2星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006031100,3,400,0,4,0,0,0,'[{1,78}]',0,0,0,0,'[{2,233329},{4,5833}]','[]',0,0,4,0),(1006031143,'天行裤裙','11阶红3星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006031100,3,400,0,4,0,0,0,'[{1,549}]',0,0,0,0,'[{2,233329},{4,5833}]','[]',0,0,4,0),(1006031153,'天行裤裙','11阶粉色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006031100,3,400,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,373327},{4,9333}]','[]',0,0,4,0),(1006031163,'天行裤裙','11阶神装裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006031100,3,400,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,466659},{4,11666}]','[]',0,0,4,0),(1006031200,'命运裤裙','12阶绿色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006031200,3,500,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,57480},{4,1437}]','[]',0,0,5,0),(1006031210,'命运裤裙','12阶蓝色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006031200,3,500,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,86220},{4,2156}]','[]',0,0,5,0),(1006031220,'命运裤裙','12阶紫色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006031200,3,500,0,2,0,0,0,'[{1,9}]',0,0,0,0,'[{2,156921},{4,3923}]','[]',0,0,5,0),(1006031231,'命运裤裙','12阶橙1星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006031200,3,500,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{2,191409},{4,4785}]','[]',0,0,5,0),(1006031232,'命运裤裙','12阶橙2星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006031200,3,500,0,3,0,0,0,'[{1,15}]',0,0,0,0,'[{2,191409},{4,4785}]','[]',0,0,5,0),(1006031241,'命运裤裙','12阶红1星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006031200,3,500,0,4,0,0,0,'[{1,62}]',0,0,0,0,'[{2,287400},{4,7185}]','[]',0,0,5,0),(1006031242,'命运裤裙','12阶红2星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006031200,3,500,0,4,0,0,0,'[{1,110}]',0,0,0,0,'[{2,287400},{4,7185}]','[]',0,0,5,0),(1006031243,'命运裤裙','12阶红3星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006031200,3,500,0,4,0,0,0,'[{1,799}]',0,0,0,0,'[{2,287400},{4,7185}]','[]',0,0,5,0),(1006031253,'命运裤裙','12阶粉色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006031200,3,500,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,459841},{4,11496}]','[]',0,0,5,0),(1006031263,'命运裤裙','12阶神装裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006031200,3,500,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,574801},{4,14370}]','[]',0,0,5,0),(1006031300,'制裁裤裙','13阶绿色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006031300,3,520,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,69635},{4,1741}]','[]',0,0,5,0),(1006031310,'制裁裤裙','13阶蓝色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006031300,3,520,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,104453},{4,2611}]','[]',0,0,5,0),(1006031320,'制裁裤裙','13阶紫色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006031300,3,520,0,2,0,0,0,'[{1,10}]',0,0,0,0,'[{2,190104},{4,4753}]','[]',0,0,5,0),(1006031331,'制裁裤裙','13阶橙1星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006031300,3,520,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{2,231885},{4,5797}]','[]',0,0,5,0),(1006031332,'制裁裤裙','13阶橙2星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006031300,3,520,0,3,0,0,0,'[{1,17}]',0,0,0,0,'[{2,231885},{4,5797}]','[]',0,0,5,0),(1006031341,'制裁裤裙','13阶红1星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006031300,3,520,0,4,0,0,0,'[{1,72}]',0,0,0,0,'[{2,348176},{4,8704}]','[]',0,0,5,0),(1006031342,'制裁裤裙','13阶红2星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006031300,3,520,0,4,0,0,0,'[{1,128}]',0,0,0,0,'[{2,348176},{4,8704}]','[]',0,0,5,0),(1006031343,'制裁裤裙','13阶红3星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006031300,3,520,0,4,0,0,0,'[{1,1117}]',0,0,0,0,'[{2,348176},{4,8704}]','[]',0,0,5,0),(1006031353,'制裁裤裙','13阶粉色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006031300,3,520,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,557082},{4,13927}]','[]',0,0,5,0),(1006031363,'制裁裤裙','13阶神装裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006031300,3,520,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,696352},{4,17409}]','[]',0,0,5,0),(1006031400,'审判裤裙','14阶绿色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006031400,3,620,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,83185},{4,2080}]','[]',0,0,6,0),(1006031410,'审判裤裙','14阶蓝色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006031400,3,620,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{2,124777},{4,3119}]','[]',0,0,6,0),(1006031420,'审判裤裙','14阶紫色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006031400,3,620,0,2,0,0,0,'[{1,11}]',0,0,0,0,'[{2,227094},{4,5677}]','[]',0,0,6,0),(1006031431,'审判裤裙','14阶橙1星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006031400,3,620,0,3,0,0,0,'[{1,15}]',0,0,0,0,'[{2,277005},{4,6925}]','[]',0,0,6,0),(1006031432,'审判裤裙','14阶橙2星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006031400,3,620,0,3,0,0,0,'[{1,19}]',0,0,0,0,'[{2,277005},{4,6925}]','[]',0,0,6,0),(1006031441,'审判裤裙','14阶红1星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006031400,3,620,0,4,0,0,0,'[{1,82}]',0,0,0,0,'[{2,415923},{4,10398}]','[]',0,0,6,0),(1006031442,'审判裤裙','14阶红2星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006031400,3,620,0,4,0,0,0,'[{1,146}]',0,0,0,0,'[{2,415923},{4,10398}]','[]',0,0,6,0),(1006031443,'审判裤裙','14阶红3星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006031400,3,620,0,4,0,0,0,'[{1,1444}]',0,0,0,0,'[{2,415923},{4,10398}]','[]',0,0,6,0),(1006031453,'审判裤裙','14阶粉色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006031400,3,620,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,665478},{4,16637}]','[]',0,0,6,0),(1006031463,'审判裤裙','14阶神装裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006031400,3,620,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,831847},{4,20796}]','[]',0,0,6,0),(1006031500,'毁灭裤裙','15阶绿色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006031500,3,650,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,98182},{4,2455}]','[]',0,0,6,0),(1006031510,'毁灭裤裙','15阶蓝色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006031500,3,650,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{2,147273},{4,3682}]','[]',0,0,6,0),(1006031520,'毁灭裤裙','15阶紫色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006031500,3,650,0,2,0,0,0,'[{1,12}]',0,0,0,0,'[{2,268036},{4,6701}]','[]',0,0,6,0),(1006031531,'毁灭裤裙','15阶橙1星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006031500,3,650,0,3,0,0,0,'[{1,16}]',0,0,0,0,'[{2,326945},{4,8174}]','[]',0,0,6,0),(1006031532,'毁灭裤裙','15阶橙2星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006031500,3,650,0,3,0,0,0,'[{1,20}]',0,0,0,0,'[{2,326945},{4,8174}]','[]',0,0,6,0),(1006031541,'毁灭裤裙','15阶红1星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006031500,3,650,0,4,0,0,0,'[{1,92}]',0,0,0,0,'[{2,490909},{4,12273}]','[]',0,0,6,0),(1006031542,'毁灭裤裙','15阶红2星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006031500,3,650,0,4,0,0,0,'[{1,164}]',0,0,0,0,'[{2,490909},{4,12273}]','[]',0,0,6,0),(1006031543,'毁灭裤裙','15阶红3星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006031500,3,650,0,4,0,0,0,'[{1,1717}]',0,0,0,0,'[{2,490909},{4,12273}]','[]',0,0,6,0),(1006031553,'毁灭裤裙','15阶粉色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006031500,3,650,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,785455},{4,19636}]','[]',0,0,6,0),(1006031563,'毁灭裤裙','15阶神装裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006031500,3,650,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,981818},{4,24545}]','[]',0,0,6,0),(1006031600,'混沌裤裙','16阶绿色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006031500,3,700,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{2,114680},{4,2867}]','[]',0,0,6,0),(1006031610,'混沌裤裙','16阶蓝色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006031500,3,700,0,1,0,0,0,'[{1,7}]',0,0,0,0,'[{2,172020},{4,4300}]','[]',0,0,6,0),(1006031620,'混沌裤裙','16阶紫色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006031500,3,700,0,2,0,0,0,'[{1,14}]',0,0,0,0,'[{2,313076},{4,7827}]','[]',0,0,6,0),(1006031631,'混沌裤裙','16阶橙1星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006031500,3,700,0,3,0,0,0,'[{1,19}]',0,0,0,0,'[{2,381884},{4,9547}]','[]',0,0,6,0),(1006031632,'混沌裤裙','16阶橙2星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006031500,3,700,0,3,0,0,0,'[{1,23}]',0,0,0,0,'[{2,381884},{4,9547}]','[]',0,0,6,0),(1006031641,'混沌裤裙','16阶红1星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006031500,3,700,0,4,0,0,0,'[{1,112}]',0,0,0,0,'[{2,573400},{4,14335}]','[]',0,0,6,0),(1006031642,'混沌裤裙','16阶红2星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006031500,3,700,0,4,0,0,0,'[{1,200}]',0,0,0,0,'[{2,573400},{4,14335}]','[]',0,0,6,0),(1006031643,'混沌裤裙','16阶红3星裤子【魔导师】','',0,'','',0,1,1,10,6,1,2,6,1006031500,3,700,0,4,0,0,0,'[{1,2044}]',0,0,0,0,'[{2,573400},{4,14335}]','[]',0,0,6,0),(1006031653,'混沌裤裙','16阶粉色裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006031500,3,700,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,917440},{4,22936}]','[]',0,0,6,0),(1006031663,'混沌裤裙','16阶神装裤子【魔导师】','',0,'','',0,0,1,10,6,0,0,6,1006031500,3,700,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,1146800},{4,28670}]','[]',0,0,6,0),(1006040100,'学徒绑腿','1阶绿色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006040100,4,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,487},{4,12}]','[]',0,0,0,0),(1006040110,'学徒绑腿','1阶蓝色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006040100,4,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,731},{4,18}]','[]',0,0,0,0),(1006040120,'学徒绑腿','1阶紫色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006040100,4,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1330},{4,33}]','[]',0,0,0,0),(1006040131,'学徒绑腿','1阶橙1星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006040100,4,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1622},{4,41}]','[]',0,0,0,0),(1006040132,'学徒绑腿','1阶橙2星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006040100,4,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1622},{4,41}]','[]',0,0,0,0),(1006040141,'学徒绑腿','1阶红1星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006040100,4,1,0,4,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2435},{4,61}]','[]',0,0,0,0),(1006040142,'学徒绑腿','1阶红2星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006040100,4,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{2,2435},{4,61}]','[]',0,0,0,0),(1006040143,'学徒绑腿','1阶红3星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006040100,4,1,0,4,0,0,0,'[{1,5}]',0,0,0,0,'[{2,2435},{4,61}]','[]',0,0,0,0),(1006040153,'学徒绑腿','1阶粉色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006040100,4,1,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,3896},{4,97}]','[]',0,0,0,0),(1006040163,'学徒绑腿','1阶神装裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006040100,4,1,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,4870},{4,122}]','[]',0,0,0,0),(1006040200,'冒险绑腿','2阶绿色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006040200,4,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,834},{4,21}]','[]',0,0,0,0),(1006040210,'冒险绑腿','2阶蓝色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006040200,4,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1251},{4,31}]','[]',0,0,0,0),(1006040220,'冒险绑腿','2阶紫色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006040200,4,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2277},{4,57}]','[]',0,0,0,0),(1006040231,'冒险绑腿','2阶橙1星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006040200,4,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2777},{4,69}]','[]',0,0,0,0),(1006040232,'冒险绑腿','2阶橙2星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006040200,4,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2777},{4,69}]','[]',0,0,0,0),(1006040241,'冒险绑腿','2阶红1星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006040200,4,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{2,4170},{4,104}]','[]',0,0,0,0),(1006040242,'冒险绑腿','2阶红2星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006040200,4,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{2,4170},{4,104}]','[]',0,0,0,0),(1006040243,'冒险绑腿','2阶红3星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006040200,4,1,0,4,0,0,0,'[{1,8}]',0,0,0,0,'[{2,4170},{4,104}]','[]',0,0,0,0),(1006040253,'冒险绑腿','2阶粉色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006040200,4,1,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,6671},{4,167}]','[]',0,0,0,0),(1006040263,'冒险绑腿','2阶神装裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006040200,4,1,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,8339},{4,208}]','[]',0,0,0,0),(1006040300,'勇者绑腿','3阶绿色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006040300,4,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1988},{4,50}]','[]',0,0,0,0),(1006040310,'勇者绑腿','3阶蓝色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006040300,4,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2982},{4,75}]','[]',0,0,0,0),(1006040320,'勇者绑腿','3阶紫色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006040300,4,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,5427},{4,136}]','[]',0,0,0,0),(1006040331,'勇者绑腿','3阶橙1星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006040300,4,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6620},{4,166}]','[]',0,0,0,0),(1006040332,'勇者绑腿','3阶橙2星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006040300,4,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6620},{4,166}]','[]',0,0,0,0),(1006040341,'勇者绑腿','3阶红1星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006040300,4,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{2,9940},{4,249}]','[]',0,0,0,0),(1006040342,'勇者绑腿','3阶红2星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006040300,4,1,0,4,0,0,0,'[{1,4}]',0,0,0,0,'[{2,9940},{4,249}]','[]',0,0,0,0),(1006040343,'勇者绑腿','3阶红3星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006040300,4,1,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,9940},{4,249}]','[]',0,0,0,0),(1006040353,'勇者绑腿','3阶粉色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006040300,4,1,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,15904},{4,398}]','[]',0,0,0,0),(1006040363,'勇者绑腿','3阶神装裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006040300,4,1,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,19881},{4,497}]','[]',0,0,0,0),(1006040400,'先驱绑腿','4阶绿色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006040400,4,100,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,4003},{4,100}]','[]',0,0,0,0),(1006040410,'先驱绑腿','4阶蓝色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006040400,4,100,0,1,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6004},{4,150}]','[]',0,0,0,0),(1006040420,'先驱绑腿','4阶紫色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006040400,4,100,0,2,0,0,0,'[{1,3}]',0,0,0,0,'[{2,10928},{4,273}]','[]',0,0,0,0),(1006040431,'先驱绑腿','4阶橙1星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006040400,4,100,0,3,0,0,0,'[{1,3}]',0,0,0,0,'[{2,13329},{4,333}]','[]',0,0,0,0),(1006040432,'先驱绑腿','4阶橙2星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006040400,4,100,0,3,0,0,0,'[{1,4}]',0,0,0,0,'[{2,13329},{4,333}]','[]',0,0,0,0),(1006040441,'先驱绑腿','4阶红1星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006040400,4,100,0,4,0,0,0,'[{1,8}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1006040442,'先驱绑腿','4阶红2星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006040400,4,100,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1006040443,'先驱绑腿','4阶红3星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006040400,4,100,0,4,0,0,0,'[{1,34}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1006040453,'先驱绑腿','4阶粉色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006040400,4,100,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,32022},{4,801}]','[]',0,0,0,0),(1006040463,'先驱绑腿','4阶神装裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006040400,4,100,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,40028},{4,1001}]','[]',0,0,0,0),(1006040500,'荣誉绑腿','5阶绿色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006040500,4,150,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,6932},{4,173}]','[]',0,0,1,0),(1006040510,'荣誉绑腿','5阶蓝色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006040500,4,150,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{2,10397},{4,260}]','[]',0,0,1,0),(1006040520,'荣誉绑腿','5阶紫色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006040500,4,150,0,2,0,0,0,'[{1,5}]',0,0,0,0,'[{2,18923},{4,473}]','[]',0,0,1,0),(1006040531,'荣誉绑腿','5阶橙1星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006040500,4,150,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,1,0),(1006040532,'荣誉绑腿','5阶橙2星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006040500,4,150,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,1,0),(1006040541,'荣誉绑腿','5阶红1星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006040500,4,150,0,4,0,0,0,'[{1,14}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,1,0),(1006040542,'荣誉绑腿','5阶红2星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006040500,4,150,0,4,0,0,0,'[{1,21}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,1,0),(1006040543,'荣誉绑腿','5阶红3星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006040500,4,150,0,4,0,0,0,'[{1,63}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,1,0),(1006040553,'荣誉绑腿','5阶粉色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006040500,4,150,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,55452},{4,1386}]','[]',0,0,1,0),(1006040563,'荣誉绑腿','5阶神装裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006040500,4,150,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,69315},{4,1733}]','[]',0,0,1,0),(1006040600,'贤者绑腿','6阶绿色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006040600,4,180,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,10828},{4,271}]','[]',0,0,1,0),(1006040610,'贤者绑腿','6阶蓝色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006040600,4,180,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{2,16241},{4,406}]','[]',0,0,1,0),(1006040620,'贤者绑腿','6阶紫色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006040600,4,180,0,2,0,0,0,'[{1,5}]',0,0,0,0,'[{2,29559},{4,739}]','[]',0,0,1,0),(1006040631,'贤者绑腿','6阶橙1星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006040600,4,180,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,36056},{4,901}]','[]',0,0,1,0),(1006040632,'贤者绑腿','6阶橙2星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006040600,4,180,0,3,0,0,0,'[{1,8}]',0,0,0,0,'[{2,36056},{4,901}]','[]',0,0,1,0),(1006040641,'贤者绑腿','6阶红1星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006040600,4,180,0,4,0,0,0,'[{1,18}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,1,0),(1006040642,'贤者绑腿','6阶红2星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006040600,4,180,0,4,0,0,0,'[{1,28}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,1,0),(1006040643,'贤者绑腿','6阶红3星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006040600,4,180,0,4,0,0,0,'[{1,104}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,1,0),(1006040653,'贤者绑腿','6阶粉色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006040600,4,180,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,86620},{4,2166}]','[]',0,0,1,0),(1006040663,'贤者绑腿','6阶神装裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006040600,4,180,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,108276},{4,2707}]','[]',0,0,1,0),(1006040700,'征服绑腿','7阶绿色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006040700,4,220,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,15744},{4,394}]','[]',0,0,2,0),(1006040710,'征服绑腿','7阶蓝色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006040700,4,220,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{2,23616},{4,590}]','[]',0,0,2,0),(1006040720,'征服绑腿','7阶紫色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006040700,4,220,0,2,0,0,0,'[{1,6}]',0,0,0,0,'[{2,42982},{4,1075}]','[]',0,0,2,0),(1006040731,'征服绑腿','7阶橙1星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006040700,4,220,0,3,0,0,0,'[{1,8}]',0,0,0,0,'[{2,52429},{4,1311}]','[]',0,0,2,0),(1006040732,'征服绑腿','7阶橙2星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006040700,4,220,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,52429},{4,1311}]','[]',0,0,2,0),(1006040741,'征服绑腿','7阶红1星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006040700,4,220,0,4,0,0,0,'[{1,25}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,2,0),(1006040742,'征服绑腿','7阶红2星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006040700,4,220,0,4,0,0,0,'[{1,41}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,2,0),(1006040743,'征服绑腿','7阶红3星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006040700,4,220,0,4,0,0,0,'[{1,149}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,2,0),(1006040753,'征服绑腿','7阶粉色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006040700,4,220,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,125955},{4,3149}]','[]',0,0,2,0),(1006040763,'征服绑腿','7阶神装裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006040700,4,220,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,157443},{4,3936}]','[]',0,0,2,0),(1006040800,'秩序绑腿','8阶绿色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006040800,4,260,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,21735},{4,543}]','[]',0,0,2,0),(1006040810,'秩序绑腿','8阶蓝色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006040800,4,260,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,32603},{4,815}]','[]',0,0,2,0),(1006040820,'秩序绑腿','8阶紫色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006040800,4,260,0,2,0,0,0,'[{1,7}]',0,0,0,0,'[{2,59337},{4,1483}]','[]',0,0,2,0),(1006040831,'秩序绑腿','8阶橙1星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006040800,4,260,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{2,72378},{4,1809}]','[]',0,0,2,0),(1006040832,'秩序绑腿','8阶橙2星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006040800,4,260,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{2,72378},{4,1809}]','[]',0,0,2,0),(1006040841,'秩序绑腿','8阶红1星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006040800,4,260,0,4,0,0,0,'[{1,28}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,2,0),(1006040842,'秩序绑腿','8阶红2星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006040800,4,260,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,2,0),(1006040843,'秩序绑腿','8阶红3星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006040800,4,260,0,4,0,0,0,'[{1,208}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,2,0),(1006040853,'秩序绑腿','8阶粉色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006040800,4,260,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,173881},{4,4347}]','[]',0,0,2,0),(1006040863,'秩序绑腿','8阶神装裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006040800,4,260,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,217352},{4,5434}]','[]',0,0,2,0),(1006040900,'守护绑腿','9阶绿色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006040900,4,300,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,28847},{4,721}]','[]',0,0,3,0),(1006040910,'守护绑腿','9阶蓝色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006040900,4,300,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,43270},{4,1082}]','[]',0,0,3,0),(1006040920,'守护绑腿','9阶紫色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006040900,4,300,0,2,0,0,0,'[{1,7}]',0,0,0,0,'[{2,78752},{4,1969}]','[]',0,0,3,0),(1006040931,'守护绑腿','9阶橙1星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006040900,4,300,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,96060},{4,2401}]','[]',0,0,3,0),(1006040932,'守护绑腿','9阶橙2星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006040900,4,300,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{2,96060},{4,2401}]','[]',0,0,3,0),(1006040941,'守护绑腿','9阶红1星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006040900,4,300,0,4,0,0,0,'[{1,33}]',0,0,0,0,'[{2,144234},{4,3606}]','[]',0,0,3,0),(1006040942,'守护绑腿','9阶红2星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006040900,4,300,0,4,0,0,0,'[{1,55}]',0,0,0,0,'[{2,144234},{4,3606}]','[]',0,0,3,0),(1006040943,'守护绑腿','9阶红3星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006040900,4,300,0,4,0,0,0,'[{1,290}]',0,0,0,0,'[{2,144234},{4,3606}]','[]',0,0,3,0),(1006040953,'守护绑腿','9阶粉色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006040900,4,300,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,230774},{4,5769}]','[]',0,0,3,0),(1006040963,'守护绑腿','9阶神装裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006040900,4,300,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,288468},{4,7212}]','[]',0,0,3,0),(1006041000,'信仰绑腿','10阶绿色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006041000,4,355,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,37139},{4,928}]','[]',0,0,4,0),(1006041010,'信仰绑腿','10阶蓝色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006041000,4,355,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,55709},{4,1393}]','[]',0,0,4,0),(1006041020,'信仰绑腿','10阶紫色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006041000,4,355,0,2,0,0,0,'[{1,8}]',0,0,0,0,'[{2,101390},{4,2535}]','[]',0,0,4,0),(1006041031,'信仰绑腿','10阶橙1星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006041000,4,355,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,123674},{4,3092}]','[]',0,0,4,0),(1006041032,'信仰绑腿','10阶橙2星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006041000,4,355,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{2,123674},{4,3092}]','[]',0,0,4,0),(1006041041,'信仰绑腿','10阶红1星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006041000,4,355,0,4,0,0,0,'[{1,40}]',0,0,0,0,'[{2,185696},{4,4642}]','[]',0,0,4,0),(1006041042,'信仰绑腿','10阶红2星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006041000,4,355,0,4,0,0,0,'[{1,69}]',0,0,0,0,'[{2,185696},{4,4642}]','[]',0,0,4,0),(1006041043,'信仰绑腿','10阶红3星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006041000,4,355,0,4,0,0,0,'[{1,399}]',0,0,0,0,'[{2,185696},{4,4642}]','[]',0,0,4,0),(1006041053,'信仰绑腿','10阶粉色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006041000,4,355,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,297114},{4,7428}]','[]',0,0,4,0),(1006041063,'信仰绑腿','10阶神装裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006041000,4,355,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,371392},{4,9285}]','[]',0,0,4,0),(1006041100,'天行绑腿','11阶绿色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006041100,4,400,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,46666},{4,1167}]','[]',0,0,4,0),(1006041110,'天行绑腿','11阶蓝色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006041100,4,400,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,69999},{4,1750}]','[]',0,0,4,0),(1006041120,'天行绑腿','11阶紫色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006041100,4,400,0,2,0,0,0,'[{1,9}]',0,0,0,0,'[{2,127398},{4,3185}]','[]',0,0,4,0),(1006041131,'天行绑腿','11阶橙1星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006041100,4,400,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{2,155397},{4,3885}]','[]',0,0,4,0),(1006041132,'天行绑腿','11阶橙2星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006041100,4,400,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{2,155397},{4,3885}]','[]',0,0,4,0),(1006041141,'天行绑腿','11阶红1星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006041100,4,400,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{2,233329},{4,5833}]','[]',0,0,4,0),(1006041142,'天行绑腿','11阶红2星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006041100,4,400,0,4,0,0,0,'[{1,78}]',0,0,0,0,'[{2,233329},{4,5833}]','[]',0,0,4,0),(1006041143,'天行绑腿','11阶红3星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006041100,4,400,0,4,0,0,0,'[{1,549}]',0,0,0,0,'[{2,233329},{4,5833}]','[]',0,0,4,0),(1006041153,'天行绑腿','11阶粉色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006041100,4,400,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,373327},{4,9333}]','[]',0,0,4,0),(1006041163,'天行绑腿','11阶神装裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006041100,4,400,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,466659},{4,11666}]','[]',0,0,4,0),(1006041200,'命运绑腿','12阶绿色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006041200,4,500,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,57480},{4,1437}]','[]',0,0,5,0),(1006041210,'命运绑腿','12阶蓝色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006041200,4,500,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,86220},{4,2156}]','[]',0,0,5,0),(1006041220,'命运绑腿','12阶紫色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006041200,4,500,0,2,0,0,0,'[{1,9}]',0,0,0,0,'[{2,156921},{4,3923}]','[]',0,0,5,0),(1006041231,'命运绑腿','12阶橙1星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006041200,4,500,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{2,191409},{4,4785}]','[]',0,0,5,0),(1006041232,'命运绑腿','12阶橙2星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006041200,4,500,0,3,0,0,0,'[{1,15}]',0,0,0,0,'[{2,191409},{4,4785}]','[]',0,0,5,0),(1006041241,'命运绑腿','12阶红1星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006041200,4,500,0,4,0,0,0,'[{1,62}]',0,0,0,0,'[{2,287400},{4,7185}]','[]',0,0,5,0),(1006041242,'命运绑腿','12阶红2星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006041200,4,500,0,4,0,0,0,'[{1,110}]',0,0,0,0,'[{2,287400},{4,7185}]','[]',0,0,5,0),(1006041243,'命运绑腿','12阶红3星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006041200,4,500,0,4,0,0,0,'[{1,799}]',0,0,0,0,'[{2,287400},{4,7185}]','[]',0,0,5,0),(1006041253,'命运绑腿','12阶粉色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006041200,4,500,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,459841},{4,11496}]','[]',0,0,5,0),(1006041263,'命运绑腿','12阶神装裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006041200,4,500,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,574801},{4,14370}]','[]',0,0,5,0),(1006041300,'制裁绑腿','13阶绿色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006041300,4,520,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,69635},{4,1741}]','[]',0,0,5,0),(1006041310,'制裁绑腿','13阶蓝色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006041300,4,520,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,104453},{4,2611}]','[]',0,0,5,0),(1006041320,'制裁绑腿','13阶紫色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006041300,4,520,0,2,0,0,0,'[{1,10}]',0,0,0,0,'[{2,190104},{4,4753}]','[]',0,0,5,0),(1006041331,'制裁绑腿','13阶橙1星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006041300,4,520,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{2,231885},{4,5797}]','[]',0,0,5,0),(1006041332,'制裁绑腿','13阶橙2星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006041300,4,520,0,3,0,0,0,'[{1,17}]',0,0,0,0,'[{2,231885},{4,5797}]','[]',0,0,5,0),(1006041341,'制裁绑腿','13阶红1星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006041300,4,520,0,4,0,0,0,'[{1,72}]',0,0,0,0,'[{2,348176},{4,8704}]','[]',0,0,5,0),(1006041342,'制裁绑腿','13阶红2星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006041300,4,520,0,4,0,0,0,'[{1,128}]',0,0,0,0,'[{2,348176},{4,8704}]','[]',0,0,5,0),(1006041343,'制裁绑腿','13阶红3星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006041300,4,520,0,4,0,0,0,'[{1,1117}]',0,0,0,0,'[{2,348176},{4,8704}]','[]',0,0,5,0),(1006041353,'制裁绑腿','13阶粉色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006041300,4,520,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,557082},{4,13927}]','[]',0,0,5,0),(1006041363,'制裁绑腿','13阶神装裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006041300,4,520,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,696352},{4,17409}]','[]',0,0,5,0),(1006041400,'审判绑腿','14阶绿色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006041400,4,620,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,83185},{4,2080}]','[]',0,0,6,0),(1006041410,'审判绑腿','14阶蓝色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006041400,4,620,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{2,124777},{4,3119}]','[]',0,0,6,0),(1006041420,'审判绑腿','14阶紫色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006041400,4,620,0,2,0,0,0,'[{1,11}]',0,0,0,0,'[{2,227094},{4,5677}]','[]',0,0,6,0),(1006041431,'审判绑腿','14阶橙1星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006041400,4,620,0,3,0,0,0,'[{1,15}]',0,0,0,0,'[{2,277005},{4,6925}]','[]',0,0,6,0),(1006041432,'审判绑腿','14阶橙2星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006041400,4,620,0,3,0,0,0,'[{1,19}]',0,0,0,0,'[{2,277005},{4,6925}]','[]',0,0,6,0),(1006041441,'审判绑腿','14阶红1星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006041400,4,620,0,4,0,0,0,'[{1,82}]',0,0,0,0,'[{2,415923},{4,10398}]','[]',0,0,6,0),(1006041442,'审判绑腿','14阶红2星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006041400,4,620,0,4,0,0,0,'[{1,146}]',0,0,0,0,'[{2,415923},{4,10398}]','[]',0,0,6,0),(1006041443,'审判绑腿','14阶红3星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006041400,4,620,0,4,0,0,0,'[{1,1444}]',0,0,0,0,'[{2,415923},{4,10398}]','[]',0,0,6,0),(1006041453,'审判绑腿','14阶粉色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006041400,4,620,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,665478},{4,16637}]','[]',0,0,6,0),(1006041463,'审判绑腿','14阶神装裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006041400,4,620,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,831847},{4,20796}]','[]',0,0,6,0),(1006041500,'毁灭绑腿','15阶绿色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006041500,4,650,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,98182},{4,2455}]','[]',0,0,6,0),(1006041510,'毁灭绑腿','15阶蓝色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006041500,4,650,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{2,147273},{4,3682}]','[]',0,0,6,0),(1006041520,'毁灭绑腿','15阶紫色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006041500,4,650,0,2,0,0,0,'[{1,12}]',0,0,0,0,'[{2,268036},{4,6701}]','[]',0,0,6,0),(1006041531,'毁灭绑腿','15阶橙1星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006041500,4,650,0,3,0,0,0,'[{1,16}]',0,0,0,0,'[{2,326945},{4,8174}]','[]',0,0,6,0),(1006041532,'毁灭绑腿','15阶橙2星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006041500,4,650,0,3,0,0,0,'[{1,20}]',0,0,0,0,'[{2,326945},{4,8174}]','[]',0,0,6,0),(1006041541,'毁灭绑腿','15阶红1星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006041500,4,650,0,4,0,0,0,'[{1,92}]',0,0,0,0,'[{2,490909},{4,12273}]','[]',0,0,6,0),(1006041542,'毁灭绑腿','15阶红2星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006041500,4,650,0,4,0,0,0,'[{1,164}]',0,0,0,0,'[{2,490909},{4,12273}]','[]',0,0,6,0),(1006041543,'毁灭绑腿','15阶红3星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006041500,4,650,0,4,0,0,0,'[{1,1717}]',0,0,0,0,'[{2,490909},{4,12273}]','[]',0,0,6,0),(1006041553,'毁灭绑腿','15阶粉色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006041500,4,650,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,785455},{4,19636}]','[]',0,0,6,0),(1006041563,'毁灭绑腿','15阶神装裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006041500,4,650,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,981818},{4,24545}]','[]',0,0,6,0),(1006041600,'混沌绑腿','16阶绿色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006041500,4,700,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{2,114680},{4,2867}]','[]',0,0,6,0),(1006041610,'混沌绑腿','16阶蓝色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006041500,4,700,0,1,0,0,0,'[{1,7}]',0,0,0,0,'[{2,172020},{4,4300}]','[]',0,0,6,0),(1006041620,'混沌绑腿','16阶紫色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006041500,4,700,0,2,0,0,0,'[{1,14}]',0,0,0,0,'[{2,313076},{4,7827}]','[]',0,0,6,0),(1006041631,'混沌绑腿','16阶橙1星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006041500,4,700,0,3,0,0,0,'[{1,19}]',0,0,0,0,'[{2,381884},{4,9547}]','[]',0,0,6,0),(1006041632,'混沌绑腿','16阶橙2星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006041500,4,700,0,3,0,0,0,'[{1,23}]',0,0,0,0,'[{2,381884},{4,9547}]','[]',0,0,6,0),(1006041641,'混沌绑腿','16阶红1星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006041500,4,700,0,4,0,0,0,'[{1,112}]',0,0,0,0,'[{2,573400},{4,14335}]','[]',0,0,6,0),(1006041642,'混沌绑腿','16阶红2星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006041500,4,700,0,4,0,0,0,'[{1,200}]',0,0,0,0,'[{2,573400},{4,14335}]','[]',0,0,6,0),(1006041643,'混沌绑腿','16阶红3星裤子【重炮手】','',0,'','',0,1,1,10,6,1,2,6,1006041500,4,700,0,4,0,0,0,'[{1,2044}]',0,0,0,0,'[{2,573400},{4,14335}]','[]',0,0,6,0),(1006041653,'混沌绑腿','16阶粉色裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006041500,4,700,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,917440},{4,22936}]','[]',0,0,6,0),(1006041663,'混沌绑腿','16阶神装裤子【重炮手】','',0,'','',0,0,1,10,6,0,0,6,1006041500,4,700,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,1146800},{4,28670}]','[]',0,0,6,0),(1007010100,'学徒拳爪','1阶绿色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007010100,1,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,30},{3,15}]','[]',0,0,0,0),(1007010110,'学徒拳爪','1阶蓝色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007010100,1,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{1,45},{3,22}]','[]',0,0,0,0),(1007010120,'学徒拳爪','1阶紫色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007010100,1,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{1,81},{3,41}]','[]',0,0,0,0),(1007010131,'学徒拳爪','1阶橙1星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007010100,1,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{1,99},{3,50}]','[]',0,0,0,0),(1007010132,'学徒拳爪','1阶橙2星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007010100,1,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{1,99},{3,50}]','[]',0,0,0,0),(1007010141,'学徒拳爪','1阶红1星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007010100,1,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{1,149},{3,74}]','[]',0,0,0,0),(1007010142,'学徒拳爪','1阶红2星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007010100,1,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{1,149},{3,74}]','[]',0,0,0,0),(1007010143,'学徒拳爪','1阶红3星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007010100,1,1,0,4,0,0,0,'[{1,6}]',0,0,0,0,'[{1,149},{3,74}]','[]',0,0,0,0),(1007010153,'学徒拳爪','1阶粉色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007010100,1,1,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,238},{3,119}]','[]',0,0,0,0),(1007010163,'学徒拳爪','1阶神装副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007010100,1,1,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,298},{3,149}]','[]',0,0,0,0),(1007010200,'冒险拳爪','2阶绿色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007010200,1,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,51},{3,25}]','[]',0,0,0,0),(1007010210,'冒险拳爪','2阶蓝色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007010200,1,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{1,76},{3,38}]','[]',0,0,0,0),(1007010220,'冒险拳爪','2阶紫色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007010200,1,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{1,139},{3,70}]','[]',0,0,0,0),(1007010231,'冒险拳爪','2阶橙1星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007010200,1,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{1,170},{3,85}]','[]',0,0,0,0),(1007010232,'冒险拳爪','2阶橙2星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007010200,1,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{1,170},{3,85}]','[]',0,0,0,0),(1007010241,'冒险拳爪','2阶红1星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007010200,1,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{1,255},{3,127}]','[]',0,0,0,0),(1007010242,'冒险拳爪','2阶红2星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007010200,1,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{1,255},{3,127}]','[]',0,0,0,0),(1007010243,'冒险拳爪','2阶红3星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007010200,1,1,0,4,0,0,0,'[{1,10}]',0,0,0,0,'[{1,255},{3,127}]','[]',0,0,0,0),(1007010253,'冒险拳爪','2阶粉色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007010200,1,1,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,408},{3,204}]','[]',0,0,0,0),(1007010263,'冒险拳爪','2阶神装副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007010200,1,1,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,510},{3,255}]','[]',0,0,0,0),(1007010300,'勇者拳爪','3阶绿色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007010300,1,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,121},{3,61}]','[]',0,0,0,0),(1007010310,'勇者拳爪','3阶蓝色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007010300,1,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{1,182},{3,91}]','[]',0,0,0,0),(1007010320,'勇者拳爪','3阶紫色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007010300,1,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{1,332},{3,166}]','[]',0,0,0,0),(1007010331,'勇者拳爪','3阶橙1星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007010300,1,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{1,405},{3,202}]','[]',0,0,0,0),(1007010332,'勇者拳爪','3阶橙2星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007010300,1,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{1,405},{3,202}]','[]',0,0,0,0),(1007010341,'勇者拳爪','3阶红1星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007010300,1,1,0,4,0,0,0,'[{1,4}]',0,0,0,0,'[{1,607},{3,304}]','[]',0,0,0,0),(1007010342,'勇者拳爪','3阶红2星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007010300,1,1,0,4,0,0,0,'[{1,5}]',0,0,0,0,'[{1,607},{3,304}]','[]',0,0,0,0),(1007010343,'勇者拳爪','3阶红3星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007010300,1,1,0,4,0,0,0,'[{1,15}]',0,0,0,0,'[{1,607},{3,304}]','[]',0,0,0,0),(1007010353,'勇者拳爪','3阶粉色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007010300,1,1,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,972},{3,486}]','[]',0,0,0,0),(1007010363,'勇者拳爪','3阶神装副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007010300,1,1,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,1215},{3,607}]','[]',0,0,0,0),(1007010400,'先驱拳爪','4阶绿色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007010400,1,100,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,245},{3,122}]','[]',0,0,0,0),(1007010410,'先驱拳爪','4阶蓝色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007010400,1,100,0,1,0,0,0,'[{1,2}]',0,0,0,0,'[{1,367},{3,183}]','[]',0,0,0,0),(1007010420,'先驱拳爪','4阶紫色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007010400,1,100,0,2,0,0,0,'[{1,3}]',0,0,0,0,'[{1,668},{3,334}]','[]',0,0,0,0),(1007010431,'先驱拳爪','4阶橙1星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007010400,1,100,0,3,0,0,0,'[{1,4}]',0,0,0,0,'[{1,815},{3,407}]','[]',0,0,0,0),(1007010432,'先驱拳爪','4阶橙2星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007010400,1,100,0,3,0,0,0,'[{1,5}]',0,0,0,0,'[{1,815},{3,407}]','[]',0,0,0,0),(1007010441,'先驱拳爪','4阶红1星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007010400,1,100,0,4,0,0,0,'[{1,10}]',0,0,0,0,'[{1,1223},{3,612}]','[]',0,0,0,0),(1007010442,'先驱拳爪','4阶红2星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007010400,1,100,0,4,0,0,0,'[{1,14}]',0,0,0,0,'[{1,1223},{3,612}]','[]',0,0,0,0),(1007010443,'先驱拳爪','4阶红3星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007010400,1,100,0,4,0,0,0,'[{1,42}]',0,0,0,0,'[{1,1223},{3,612}]','[]',0,0,0,0),(1007010453,'先驱拳爪','4阶粉色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007010400,1,100,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,1957},{3,978}]','[]',0,0,0,0),(1007010463,'先驱拳爪','4阶神装副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007010400,1,100,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,2446},{3,1223}]','[]',0,0,0,0),(1007010500,'荣誉拳爪','5阶绿色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007010500,1,150,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,424},{3,212}]','[]',0,0,1,0),(1007010510,'荣誉拳爪','5阶蓝色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007010500,1,150,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{1,635},{3,318}]','[]',0,0,1,0),(1007010520,'荣誉拳爪','5阶紫色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007010500,1,150,0,2,0,0,0,'[{1,5}]',0,0,0,0,'[{1,1156},{3,578}]','[]',0,0,1,0),(1007010531,'荣誉拳爪','5阶橙1星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007010500,1,150,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{1,1411},{3,705}]','[]',0,0,1,0),(1007010532,'荣誉拳爪','5阶橙2星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007010500,1,150,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{1,1411},{3,705}]','[]',0,0,1,0),(1007010541,'荣誉拳爪','5阶红1星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007010500,1,150,0,4,0,0,0,'[{1,17}]',0,0,0,0,'[{1,2118},{3,1059}]','[]',0,0,1,0),(1007010542,'荣誉拳爪','5阶红2星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007010500,1,150,0,4,0,0,0,'[{1,26}]',0,0,0,0,'[{1,2118},{3,1059}]','[]',0,0,1,0),(1007010543,'荣誉拳爪','5阶红3星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007010500,1,150,0,4,0,0,0,'[{1,77}]',0,0,0,0,'[{1,2118},{3,1059}]','[]',0,0,1,0),(1007010553,'荣誉拳爪','5阶粉色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007010500,1,150,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,3389},{3,1694}]','[]',0,0,1,0),(1007010563,'荣誉拳爪','5阶神装副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007010500,1,150,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,4236},{3,2118}]','[]',0,0,1,0),(1007010600,'贤者拳爪','6阶绿色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007010600,1,180,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,662},{3,331}]','[]',0,0,1,0),(1007010610,'贤者拳爪','6阶蓝色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007010600,1,180,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{1,993},{3,496}]','[]',0,0,1,0),(1007010620,'贤者拳爪','6阶紫色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007010600,1,180,0,2,0,0,0,'[{1,6}]',0,0,0,0,'[{1,1806},{3,903}]','[]',0,0,1,0),(1007010631,'贤者拳爪','6阶橙1星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007010600,1,180,0,3,0,0,0,'[{1,8}]',0,0,0,0,'[{1,2203},{3,1102}]','[]',0,0,1,0),(1007010632,'贤者拳爪','6阶橙2星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007010600,1,180,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{1,2203},{3,1102}]','[]',0,0,1,0),(1007010641,'贤者拳爪','6阶红1星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007010600,1,180,0,4,0,0,0,'[{1,22}]',0,0,0,0,'[{1,3308},{3,1654}]','[]',0,0,1,0),(1007010642,'贤者拳爪','6阶红2星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007010600,1,180,0,4,0,0,0,'[{1,34}]',0,0,0,0,'[{1,3308},{3,1654}]','[]',0,0,1,0),(1007010643,'贤者拳爪','6阶红3星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007010600,1,180,0,4,0,0,0,'[{1,127}]',0,0,0,0,'[{1,3308},{3,1654}]','[]',0,0,1,0),(1007010653,'贤者拳爪','6阶粉色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007010600,1,180,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,5293},{3,2647}]','[]',0,0,1,0),(1007010663,'贤者拳爪','6阶神装副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007010600,1,180,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,6617},{3,3308}]','[]',0,0,1,0),(1007010700,'征服拳爪','7阶绿色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007010700,1,220,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,962},{3,481}]','[]',0,0,2,0),(1007010710,'征服拳爪','7阶蓝色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007010700,1,220,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{1,1443},{3,722}]','[]',0,0,2,0),(1007010720,'征服拳爪','7阶紫色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007010700,1,220,0,2,0,0,0,'[{1,7}]',0,0,0,0,'[{1,2627},{3,1313}]','[]',0,0,2,0),(1007010731,'征服拳爪','7阶橙1星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007010700,1,220,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{1,3204},{3,1602}]','[]',0,0,2,0),(1007010732,'征服拳爪','7阶橙2星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007010700,1,220,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{1,3204},{3,1602}]','[]',0,0,2,0),(1007010741,'征服拳爪','7阶红1星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007010700,1,220,0,4,0,0,0,'[{1,31}]',0,0,0,0,'[{1,4811},{3,2405}]','[]',0,0,2,0),(1007010742,'征服拳爪','7阶红2星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007010700,1,220,0,4,0,0,0,'[{1,50}]',0,0,0,0,'[{1,4811},{3,2405}]','[]',0,0,2,0),(1007010743,'征服拳爪','7阶红3星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007010700,1,220,0,4,0,0,0,'[{1,182}]',0,0,0,0,'[{1,4811},{3,2405}]','[]',0,0,2,0),(1007010753,'征服拳爪','7阶粉色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007010700,1,220,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,7697},{3,3849}]','[]',0,0,2,0),(1007010763,'征服拳爪','7阶神装副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007010700,1,220,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,9622},{3,4811}]','[]',0,0,2,0),(1007010800,'秩序拳爪','8阶绿色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007010800,1,260,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,1328},{3,664}]','[]',0,0,2,0),(1007010810,'秩序拳爪','8阶蓝色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007010800,1,260,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{1,1992},{3,996}]','[]',0,0,2,0),(1007010820,'秩序拳爪','8阶紫色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007010800,1,260,0,2,0,0,0,'[{1,8}]',0,0,0,0,'[{1,3626},{3,1813}]','[]',0,0,2,0),(1007010831,'秩序拳爪','8阶橙1星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007010800,1,260,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{1,4423},{3,2212}]','[]',0,0,2,0),(1007010832,'秩序拳爪','8阶橙2星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007010800,1,260,0,3,0,0,0,'[{1,13}]',0,0,0,0,'[{1,4423},{3,2212}]','[]',0,0,2,0),(1007010841,'秩序拳爪','8阶红1星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007010800,1,260,0,4,0,0,0,'[{1,35}]',0,0,0,0,'[{1,6641},{3,3321}]','[]',0,0,2,0),(1007010842,'秩序拳爪','8阶红2星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007010800,1,260,0,4,0,0,0,'[{1,56}]',0,0,0,0,'[{1,6641},{3,3321}]','[]',0,0,2,0),(1007010843,'秩序拳爪','8阶红3星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007010800,1,260,0,4,0,0,0,'[{1,254}]',0,0,0,0,'[{1,6641},{3,3321}]','[]',0,0,2,0),(1007010853,'秩序拳爪','8阶粉色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007010800,1,260,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,10626},{3,5313}]','[]',0,0,2,0),(1007010863,'秩序拳爪','8阶神装副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007010800,1,260,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,13283},{3,6641}]','[]',0,0,2,0),(1007010900,'守护拳爪','9阶绿色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007010900,1,300,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,1763},{3,881}]','[]',0,0,3,0),(1007010910,'守护拳爪','9阶蓝色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007010900,1,300,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{1,2644},{3,1322}]','[]',0,0,3,0),(1007010920,'守护拳爪','9阶紫色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007010900,1,300,0,2,0,0,0,'[{1,9}]',0,0,0,0,'[{1,4813},{3,2406}]','[]',0,0,3,0),(1007010931,'守护拳爪','9阶橙1星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007010900,1,300,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{1,5870},{3,2935}]','[]',0,0,3,0),(1007010932,'守护拳爪','9阶橙2星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007010900,1,300,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{1,5870},{3,2935}]','[]',0,0,3,0),(1007010941,'守护拳爪','9阶红1星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007010900,1,300,0,4,0,0,0,'[{1,41}]',0,0,0,0,'[{1,8814},{3,4407}]','[]',0,0,3,0),(1007010942,'守护拳爪','9阶红2星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007010900,1,300,0,4,0,0,0,'[{1,67}]',0,0,0,0,'[{1,8814},{3,4407}]','[]',0,0,3,0),(1007010943,'守护拳爪','9阶红3星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007010900,1,300,0,4,0,0,0,'[{1,354}]',0,0,0,0,'[{1,8814},{3,4407}]','[]',0,0,3,0),(1007010953,'守护拳爪','9阶粉色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007010900,1,300,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,14103},{3,7051}]','[]',0,0,3,0),(1007010963,'守护拳爪','9阶神装副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007010900,1,300,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,17629},{3,8814}]','[]',0,0,3,0),(1007011000,'信仰拳爪','10阶绿色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007011000,1,355,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,2270},{3,1135}]','[]',0,0,4,0),(1007011010,'信仰拳爪','10阶蓝色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007011000,1,355,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{1,3404},{3,1702}]','[]',0,0,4,0),(1007011020,'信仰拳爪','10阶紫色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007011000,1,355,0,2,0,0,0,'[{1,9}]',0,0,0,0,'[{1,6196},{3,3098}]','[]',0,0,4,0),(1007011031,'信仰拳爪','10阶橙1星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007011000,1,355,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{1,7558},{3,3779}]','[]',0,0,4,0),(1007011032,'信仰拳爪','10阶橙2星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007011000,1,355,0,3,0,0,0,'[{1,15}]',0,0,0,0,'[{1,7558},{3,3779}]','[]',0,0,4,0),(1007011041,'信仰拳爪','10阶红1星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007011000,1,355,0,4,0,0,0,'[{1,49}]',0,0,0,0,'[{1,11348},{3,5674}]','[]',0,0,4,0),(1007011042,'信仰拳爪','10阶红2星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007011000,1,355,0,4,0,0,0,'[{1,84}]',0,0,0,0,'[{1,11348},{3,5674}]','[]',0,0,4,0),(1007011043,'信仰拳爪','10阶红3星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007011000,1,355,0,4,0,0,0,'[{1,487}]',0,0,0,0,'[{1,11348},{3,5674}]','[]',0,0,4,0),(1007011053,'信仰拳爪','10阶粉色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007011000,1,355,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,18157},{3,9078}]','[]',0,0,4,0),(1007011063,'信仰拳爪','10阶神装副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007011000,1,355,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,22696},{3,11348}]','[]',0,0,4,0),(1007011100,'天行拳爪','11阶绿色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007011100,1,400,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,2852},{3,1426}]','[]',0,0,4,0),(1007011110,'天行拳爪','11阶蓝色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007011100,1,400,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{1,4278},{3,2139}]','[]',0,0,4,0),(1007011120,'天行拳爪','11阶紫色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007011100,1,400,0,2,0,0,0,'[{1,10}]',0,0,0,0,'[{1,7785},{3,3893}]','[]',0,0,4,0),(1007011131,'天行拳爪','11阶橙1星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007011100,1,400,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{1,9497},{3,4748}]','[]',0,0,4,0),(1007011132,'天行拳爪','11阶橙2星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007011100,1,400,0,3,0,0,0,'[{1,17}]',0,0,0,0,'[{1,9497},{3,4748}]','[]',0,0,4,0),(1007011141,'天行拳爪','11阶红1星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007011100,1,400,0,4,0,0,0,'[{1,56}]',0,0,0,0,'[{1,14259},{3,7130}]','[]',0,0,4,0),(1007011142,'天行拳爪','11阶红2星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007011100,1,400,0,4,0,0,0,'[{1,95}]',0,0,0,0,'[{1,14259},{3,7130}]','[]',0,0,4,0),(1007011143,'天行拳爪','11阶红3星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007011100,1,400,0,4,0,0,0,'[{1,670}]',0,0,0,0,'[{1,14259},{3,7130}]','[]',0,0,4,0),(1007011153,'天行拳爪','11阶粉色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007011100,1,400,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,22814},{3,11407}]','[]',0,0,4,0),(1007011163,'天行拳爪','11阶神装副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007011100,1,400,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,28518},{3,14259}]','[]',0,0,4,0),(1007011200,'命运拳爪','12阶绿色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007011200,1,500,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,3513},{3,1756}]','[]',0,0,5,0),(1007011210,'命运拳爪','12阶蓝色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007011200,1,500,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{1,5269},{3,2635}]','[]',0,0,5,0),(1007011220,'命运拳爪','12阶紫色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007011200,1,500,0,2,0,0,0,'[{1,11}]',0,0,0,0,'[{1,9590},{3,4795}]','[]',0,0,5,0),(1007011231,'命运拳爪','12阶橙1星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007011200,1,500,0,3,0,0,0,'[{1,15}]',0,0,0,0,'[{1,11697},{3,5849}]','[]',0,0,5,0),(1007011232,'命运拳爪','12阶橙2星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007011200,1,500,0,3,0,0,0,'[{1,18}]',0,0,0,0,'[{1,11697},{3,5849}]','[]',0,0,5,0),(1007011241,'命运拳爪','12阶红1星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007011200,1,500,0,4,0,0,0,'[{1,76}]',0,0,0,0,'[{1,17563},{3,8782}]','[]',0,0,5,0),(1007011242,'命运拳爪','12阶红2星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007011200,1,500,0,4,0,0,0,'[{1,134}]',0,0,0,0,'[{1,17563},{3,8782}]','[]',0,0,5,0),(1007011243,'命运拳爪','12阶红3星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007011200,1,500,0,4,0,0,0,'[{1,976}]',0,0,0,0,'[{1,17563},{3,8782}]','[]',0,0,5,0),(1007011253,'命运拳爪','12阶粉色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007011200,1,500,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,28101},{3,14051}]','[]',0,0,5,0),(1007011263,'命运拳爪','12阶神装副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007011200,1,500,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,35127},{3,17563}]','[]',0,0,5,0),(1007011300,'制裁拳爪','13阶绿色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007011300,1,520,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,4255},{3,2128}]','[]',0,0,5,0),(1007011310,'制裁拳爪','13阶蓝色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007011300,1,520,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{1,6383},{3,3192}]','[]',0,0,5,0),(1007011320,'制裁拳爪','13阶紫色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007011300,1,520,0,2,0,0,0,'[{1,12}]',0,0,0,0,'[{1,11617},{3,5809}]','[]',0,0,5,0),(1007011331,'制裁拳爪','13阶橙1星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007011300,1,520,0,3,0,0,0,'[{1,16}]',0,0,0,0,'[{1,14171},{3,7085}]','[]',0,0,5,0),(1007011332,'制裁拳爪','13阶橙2星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007011300,1,520,0,3,0,0,0,'[{1,20}]',0,0,0,0,'[{1,14171},{3,7085}]','[]',0,0,5,0),(1007011341,'制裁拳爪','13阶红1星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007011300,1,520,0,4,0,0,0,'[{1,88}]',0,0,0,0,'[{1,21277},{3,10639}]','[]',0,0,5,0),(1007011342,'制裁拳爪','13阶红2星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007011300,1,520,0,4,0,0,0,'[{1,156}]',0,0,0,0,'[{1,21277},{3,10639}]','[]',0,0,5,0),(1007011343,'制裁拳爪','13阶红3星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007011300,1,520,0,4,0,0,0,'[{1,1365}]',0,0,0,0,'[{1,21277},{3,10639}]','[]',0,0,5,0),(1007011353,'制裁拳爪','13阶粉色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007011300,1,520,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,34044},{3,17022}]','[]',0,0,5,0),(1007011363,'制裁拳爪','13阶神装副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007011300,1,520,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,42555},{3,21277}]','[]',0,0,5,0),(1007011400,'审判拳爪','14阶绿色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007011400,1,620,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{1,5084},{3,2542}]','[]',0,0,6,0),(1007011410,'审判拳爪','14阶蓝色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007011400,1,620,0,1,0,0,0,'[{1,7}]',0,0,0,0,'[{1,7625},{3,3813}]','[]',0,0,6,0),(1007011420,'审判拳爪','14阶紫色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007011400,1,620,0,2,0,0,0,'[{1,14}]',0,0,0,0,'[{1,13878},{3,6939}]','[]',0,0,6,0),(1007011431,'审判拳爪','14阶橙1星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007011400,1,620,0,3,0,0,0,'[{1,18}]',0,0,0,0,'[{1,16928},{3,8464}]','[]',0,0,6,0),(1007011432,'审判拳爪','14阶橙2星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007011400,1,620,0,3,0,0,0,'[{1,23}]',0,0,0,0,'[{1,16928},{3,8464}]','[]',0,0,6,0),(1007011441,'审判拳爪','14阶红1星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007011400,1,620,0,4,0,0,0,'[{1,100}]',0,0,0,0,'[{1,25418},{3,12709}]','[]',0,0,6,0),(1007011442,'审判拳爪','14阶红2星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007011400,1,620,0,4,0,0,0,'[{1,178}]',0,0,0,0,'[{1,25418},{3,12709}]','[]',0,0,6,0),(1007011443,'审判拳爪','14阶红3星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007011400,1,620,0,4,0,0,0,'[{1,1765}]',0,0,0,0,'[{1,25418},{3,12709}]','[]',0,0,6,0),(1007011453,'审判拳爪','14阶粉色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007011400,1,620,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,40668},{3,20334}]','[]',0,0,6,0),(1007011463,'审判拳爪','14阶神装副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007011400,1,620,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,50835},{3,25418}]','[]',0,0,6,0),(1007011500,'毁灭拳爪','15阶绿色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007011500,1,650,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{1,6000},{3,3000}]','[]',0,0,6,0),(1007011510,'毁灭拳爪','15阶蓝色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007011500,1,650,0,1,0,0,0,'[{1,8}]',0,0,0,0,'[{1,9000},{3,4500}]','[]',0,0,6,0),(1007011520,'毁灭拳爪','15阶紫色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007011500,1,650,0,2,0,0,0,'[{1,15}]',0,0,0,0,'[{1,16380},{3,8190}]','[]',0,0,6,0),(1007011531,'毁灭拳爪','15阶橙1星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007011500,1,650,0,3,0,0,0,'[{1,20}]',0,0,0,0,'[{1,19980},{3,9990}]','[]',0,0,6,0),(1007011532,'毁灭拳爪','15阶橙2星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007011500,1,650,0,3,0,0,0,'[{1,25}]',0,0,0,0,'[{1,19980},{3,9990}]','[]',0,0,6,0),(1007011541,'毁灭拳爪','15阶红1星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007011500,1,650,0,4,0,0,0,'[{1,113}]',0,0,0,0,'[{1,30000},{3,15000}]','[]',0,0,6,0),(1007011542,'毁灭拳爪','15阶红2星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007011500,1,650,0,4,0,0,0,'[{1,200}]',0,0,0,0,'[{1,30000},{3,15000}]','[]',0,0,6,0),(1007011543,'毁灭拳爪','15阶红3星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007011500,1,650,0,4,0,0,0,'[{1,2098}]',0,0,0,0,'[{1,30000},{3,15000}]','[]',0,0,6,0),(1007011553,'毁灭拳爪','15阶粉色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007011500,1,650,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,48000},{3,24000}]','[]',0,0,6,0),(1007011563,'毁灭拳爪','15阶神装副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007011500,1,650,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,60000},{3,30000}]','[]',0,0,6,0),(1007011600,'混沌拳爪','16阶绿色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007011500,1,700,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{1,7008},{3,3504}]','[]',0,0,6,0),(1007011610,'混沌拳爪','16阶蓝色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007011500,1,700,0,1,0,0,0,'[{1,9}]',0,0,0,0,'[{1,10512},{3,5256}]','[]',0,0,6,0),(1007011620,'混沌拳爪','16阶紫色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007011500,1,700,0,2,0,0,0,'[{1,17}]',0,0,0,0,'[{1,19132},{3,9566}]','[]',0,0,6,0),(1007011631,'混沌拳爪','16阶橙1星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007011500,1,700,0,3,0,0,0,'[{1,23}]',0,0,0,0,'[{1,23337},{3,11669}]','[]',0,0,6,0),(1007011632,'混沌拳爪','16阶橙2星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007011500,1,700,0,3,0,0,0,'[{1,28}]',0,0,0,0,'[{1,23337},{3,11669}]','[]',0,0,6,0),(1007011641,'混沌拳爪','16阶红1星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007011500,1,700,0,4,0,0,0,'[{1,137}]',0,0,0,0,'[{1,35041},{3,17521}]','[]',0,0,6,0),(1007011642,'混沌拳爪','16阶红2星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007011500,1,700,0,4,0,0,0,'[{1,245}]',0,0,0,0,'[{1,35041},{3,17521}]','[]',0,0,6,0),(1007011643,'混沌拳爪','16阶红3星副手【魔剑士】','',0,'','',0,1,1,10,7,1,1,7,1007011500,1,700,0,4,0,0,0,'[{1,2498}]',0,0,0,0,'[{1,35041},{3,17521}]','[]',0,0,6,0),(1007011653,'混沌拳爪','16阶粉色副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007011500,1,700,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,56066},{3,28033}]','[]',0,0,6,0),(1007011663,'混沌拳爪','16阶神装副手【魔剑士】','',0,'','',0,0,1,10,7,0,0,7,1007011500,1,700,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,70082},{3,35041}]','[]',0,0,6,0),(1007020100,'学徒短枪','1阶绿色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007020100,2,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,30},{3,15}]','[]',0,0,0,0),(1007020110,'学徒短枪','1阶蓝色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007020100,2,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{1,45},{3,22}]','[]',0,0,0,0),(1007020120,'学徒短枪','1阶紫色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007020100,2,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{1,81},{3,41}]','[]',0,0,0,0),(1007020131,'学徒短枪','1阶橙1星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007020100,2,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{1,99},{3,50}]','[]',0,0,0,0),(1007020132,'学徒短枪','1阶橙2星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007020100,2,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{1,99},{3,50}]','[]',0,0,0,0),(1007020141,'学徒短枪','1阶红1星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007020100,2,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{1,149},{3,74}]','[]',0,0,0,0),(1007020142,'学徒短枪','1阶红2星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007020100,2,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{1,149},{3,74}]','[]',0,0,0,0),(1007020143,'学徒短枪','1阶红3星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007020100,2,1,0,4,0,0,0,'[{1,6}]',0,0,0,0,'[{1,149},{3,74}]','[]',0,0,0,0),(1007020153,'学徒短枪','1阶粉色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007020100,2,1,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,238},{3,119}]','[]',0,0,0,0),(1007020163,'学徒短枪','1阶神装副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007020100,2,1,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,298},{3,149}]','[]',0,0,0,0),(1007020200,'冒险短枪','2阶绿色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007020200,2,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,51},{3,25}]','[]',0,0,0,0),(1007020210,'冒险短枪','2阶蓝色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007020200,2,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{1,76},{3,38}]','[]',0,0,0,0),(1007020220,'冒险短枪','2阶紫色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007020200,2,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{1,139},{3,70}]','[]',0,0,0,0),(1007020231,'冒险短枪','2阶橙1星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007020200,2,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{1,170},{3,85}]','[]',0,0,0,0),(1007020232,'冒险短枪','2阶橙2星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007020200,2,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{1,170},{3,85}]','[]',0,0,0,0),(1007020241,'冒险短枪','2阶红1星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007020200,2,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{1,255},{3,127}]','[]',0,0,0,0),(1007020242,'冒险短枪','2阶红2星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007020200,2,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{1,255},{3,127}]','[]',0,0,0,0),(1007020243,'冒险短枪','2阶红3星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007020200,2,1,0,4,0,0,0,'[{1,10}]',0,0,0,0,'[{1,255},{3,127}]','[]',0,0,0,0),(1007020253,'冒险短枪','2阶粉色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007020200,2,1,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,408},{3,204}]','[]',0,0,0,0),(1007020263,'冒险短枪','2阶神装副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007020200,2,1,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,510},{3,255}]','[]',0,0,0,0),(1007020300,'勇者短枪','3阶绿色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007020300,2,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,121},{3,61}]','[]',0,0,0,0),(1007020310,'勇者短枪','3阶蓝色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007020300,2,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{1,182},{3,91}]','[]',0,0,0,0),(1007020320,'勇者短枪','3阶紫色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007020300,2,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{1,332},{3,166}]','[]',0,0,0,0),(1007020331,'勇者短枪','3阶橙1星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007020300,2,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{1,405},{3,202}]','[]',0,0,0,0),(1007020332,'勇者短枪','3阶橙2星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007020300,2,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{1,405},{3,202}]','[]',0,0,0,0),(1007020341,'勇者短枪','3阶红1星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007020300,2,1,0,4,0,0,0,'[{1,4}]',0,0,0,0,'[{1,607},{3,304}]','[]',0,0,0,0),(1007020342,'勇者短枪','3阶红2星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007020300,2,1,0,4,0,0,0,'[{1,5}]',0,0,0,0,'[{1,607},{3,304}]','[]',0,0,0,0),(1007020343,'勇者短枪','3阶红3星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007020300,2,1,0,4,0,0,0,'[{1,15}]',0,0,0,0,'[{1,607},{3,304}]','[]',0,0,0,0),(1007020353,'勇者短枪','3阶粉色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007020300,2,1,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,972},{3,486}]','[]',0,0,0,0),(1007020363,'勇者短枪','3阶神装副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007020300,2,1,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,1215},{3,607}]','[]',0,0,0,0),(1007020400,'先驱短枪','4阶绿色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007020400,2,100,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,245},{3,122}]','[]',0,0,0,0),(1007020410,'先驱短枪','4阶蓝色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007020400,2,100,0,1,0,0,0,'[{1,2}]',0,0,0,0,'[{1,367},{3,183}]','[]',0,0,0,0),(1007020420,'先驱短枪','4阶紫色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007020400,2,100,0,2,0,0,0,'[{1,3}]',0,0,0,0,'[{1,668},{3,334}]','[]',0,0,0,0),(1007020431,'先驱短枪','4阶橙1星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007020400,2,100,0,3,0,0,0,'[{1,4}]',0,0,0,0,'[{1,815},{3,407}]','[]',0,0,0,0),(1007020432,'先驱短枪','4阶橙2星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007020400,2,100,0,3,0,0,0,'[{1,5}]',0,0,0,0,'[{1,815},{3,407}]','[]',0,0,0,0),(1007020441,'先驱短枪','4阶红1星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007020400,2,100,0,4,0,0,0,'[{1,10}]',0,0,0,0,'[{1,1223},{3,612}]','[]',0,0,0,0),(1007020442,'先驱短枪','4阶红2星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007020400,2,100,0,4,0,0,0,'[{1,14}]',0,0,0,0,'[{1,1223},{3,612}]','[]',0,0,0,0),(1007020443,'先驱短枪','4阶红3星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007020400,2,100,0,4,0,0,0,'[{1,42}]',0,0,0,0,'[{1,1223},{3,612}]','[]',0,0,0,0),(1007020453,'先驱短枪','4阶粉色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007020400,2,100,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,1957},{3,978}]','[]',0,0,0,0),(1007020463,'先驱短枪','4阶神装副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007020400,2,100,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,2446},{3,1223}]','[]',0,0,0,0),(1007020500,'荣誉短枪','5阶绿色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007020500,2,150,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,424},{3,212}]','[]',0,0,1,0),(1007020510,'荣誉短枪','5阶蓝色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007020500,2,150,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{1,635},{3,318}]','[]',0,0,1,0),(1007020520,'荣誉短枪','5阶紫色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007020500,2,150,0,2,0,0,0,'[{1,5}]',0,0,0,0,'[{1,1156},{3,578}]','[]',0,0,1,0),(1007020531,'荣誉短枪','5阶橙1星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007020500,2,150,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{1,1411},{3,705}]','[]',0,0,1,0),(1007020532,'荣誉短枪','5阶橙2星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007020500,2,150,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{1,1411},{3,705}]','[]',0,0,1,0),(1007020541,'荣誉短枪','5阶红1星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007020500,2,150,0,4,0,0,0,'[{1,17}]',0,0,0,0,'[{1,2118},{3,1059}]','[]',0,0,1,0),(1007020542,'荣誉短枪','5阶红2星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007020500,2,150,0,4,0,0,0,'[{1,26}]',0,0,0,0,'[{1,2118},{3,1059}]','[]',0,0,1,0),(1007020543,'荣誉短枪','5阶红3星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007020500,2,150,0,4,0,0,0,'[{1,77}]',0,0,0,0,'[{1,2118},{3,1059}]','[]',0,0,1,0),(1007020553,'荣誉短枪','5阶粉色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007020500,2,150,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,3389},{3,1694}]','[]',0,0,1,0),(1007020563,'荣誉短枪','5阶神装副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007020500,2,150,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,4236},{3,2118}]','[]',0,0,1,0),(1007020600,'贤者短枪','6阶绿色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007020600,2,180,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,662},{3,331}]','[]',0,0,1,0),(1007020610,'贤者短枪','6阶蓝色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007020600,2,180,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{1,993},{3,496}]','[]',0,0,1,0),(1007020620,'贤者短枪','6阶紫色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007020600,2,180,0,2,0,0,0,'[{1,6}]',0,0,0,0,'[{1,1806},{3,903}]','[]',0,0,1,0),(1007020631,'贤者短枪','6阶橙1星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007020600,2,180,0,3,0,0,0,'[{1,8}]',0,0,0,0,'[{1,2203},{3,1102}]','[]',0,0,1,0),(1007020632,'贤者短枪','6阶橙2星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007020600,2,180,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{1,2203},{3,1102}]','[]',0,0,1,0),(1007020641,'贤者短枪','6阶红1星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007020600,2,180,0,4,0,0,0,'[{1,22}]',0,0,0,0,'[{1,3308},{3,1654}]','[]',0,0,1,0),(1007020642,'贤者短枪','6阶红2星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007020600,2,180,0,4,0,0,0,'[{1,34}]',0,0,0,0,'[{1,3308},{3,1654}]','[]',0,0,1,0),(1007020643,'贤者短枪','6阶红3星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007020600,2,180,0,4,0,0,0,'[{1,127}]',0,0,0,0,'[{1,3308},{3,1654}]','[]',0,0,1,0),(1007020653,'贤者短枪','6阶粉色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007020600,2,180,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,5293},{3,2647}]','[]',0,0,1,0),(1007020663,'贤者短枪','6阶神装副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007020600,2,180,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,6617},{3,3308}]','[]',0,0,1,0),(1007020700,'征服短枪','7阶绿色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007020700,2,220,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,962},{3,481}]','[]',0,0,2,0),(1007020710,'征服短枪','7阶蓝色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007020700,2,220,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{1,1443},{3,722}]','[]',0,0,2,0),(1007020720,'征服短枪','7阶紫色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007020700,2,220,0,2,0,0,0,'[{1,7}]',0,0,0,0,'[{1,2627},{3,1313}]','[]',0,0,2,0),(1007020731,'征服短枪','7阶橙1星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007020700,2,220,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{1,3204},{3,1602}]','[]',0,0,2,0),(1007020732,'征服短枪','7阶橙2星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007020700,2,220,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{1,3204},{3,1602}]','[]',0,0,2,0),(1007020741,'征服短枪','7阶红1星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007020700,2,220,0,4,0,0,0,'[{1,31}]',0,0,0,0,'[{1,4811},{3,2405}]','[]',0,0,2,0),(1007020742,'征服短枪','7阶红2星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007020700,2,220,0,4,0,0,0,'[{1,50}]',0,0,0,0,'[{1,4811},{3,2405}]','[]',0,0,2,0),(1007020743,'征服短枪','7阶红3星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007020700,2,220,0,4,0,0,0,'[{1,182}]',0,0,0,0,'[{1,4811},{3,2405}]','[]',0,0,2,0),(1007020753,'征服短枪','7阶粉色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007020700,2,220,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,7697},{3,3849}]','[]',0,0,2,0),(1007020763,'征服短枪','7阶神装副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007020700,2,220,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,9622},{3,4811}]','[]',0,0,2,0),(1007020800,'秩序短枪','8阶绿色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007020800,2,260,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,1328},{3,664}]','[]',0,0,2,0),(1007020810,'秩序短枪','8阶蓝色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007020800,2,260,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{1,1992},{3,996}]','[]',0,0,2,0),(1007020820,'秩序短枪','8阶紫色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007020800,2,260,0,2,0,0,0,'[{1,8}]',0,0,0,0,'[{1,3626},{3,1813}]','[]',0,0,2,0),(1007020831,'秩序短枪','8阶橙1星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007020800,2,260,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{1,4423},{3,2212}]','[]',0,0,2,0),(1007020832,'秩序短枪','8阶橙2星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007020800,2,260,0,3,0,0,0,'[{1,13}]',0,0,0,0,'[{1,4423},{3,2212}]','[]',0,0,2,0),(1007020841,'秩序短枪','8阶红1星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007020800,2,260,0,4,0,0,0,'[{1,35}]',0,0,0,0,'[{1,6641},{3,3321}]','[]',0,0,2,0),(1007020842,'秩序短枪','8阶红2星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007020800,2,260,0,4,0,0,0,'[{1,56}]',0,0,0,0,'[{1,6641},{3,3321}]','[]',0,0,2,0),(1007020843,'秩序短枪','8阶红3星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007020800,2,260,0,4,0,0,0,'[{1,254}]',0,0,0,0,'[{1,6641},{3,3321}]','[]',0,0,2,0),(1007020853,'秩序短枪','8阶粉色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007020800,2,260,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,10626},{3,5313}]','[]',0,0,2,0),(1007020863,'秩序短枪','8阶神装副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007020800,2,260,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,13283},{3,6641}]','[]',0,0,2,0),(1007020900,'守护短枪','9阶绿色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007020900,2,300,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,1763},{3,881}]','[]',0,0,3,0),(1007020910,'守护短枪','9阶蓝色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007020900,2,300,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{1,2644},{3,1322}]','[]',0,0,3,0),(1007020920,'守护短枪','9阶紫色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007020900,2,300,0,2,0,0,0,'[{1,9}]',0,0,0,0,'[{1,4813},{3,2406}]','[]',0,0,3,0),(1007020931,'守护短枪','9阶橙1星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007020900,2,300,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{1,5870},{3,2935}]','[]',0,0,3,0),(1007020932,'守护短枪','9阶橙2星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007020900,2,300,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{1,5870},{3,2935}]','[]',0,0,3,0),(1007020941,'守护短枪','9阶红1星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007020900,2,300,0,4,0,0,0,'[{1,41}]',0,0,0,0,'[{1,8814},{3,4407}]','[]',0,0,3,0),(1007020942,'守护短枪','9阶红2星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007020900,2,300,0,4,0,0,0,'[{1,67}]',0,0,0,0,'[{1,8814},{3,4407}]','[]',0,0,3,0),(1007020943,'守护短枪','9阶红3星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007020900,2,300,0,4,0,0,0,'[{1,354}]',0,0,0,0,'[{1,8814},{3,4407}]','[]',0,0,3,0),(1007020953,'守护短枪','9阶粉色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007020900,2,300,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,14103},{3,7051}]','[]',0,0,3,0),(1007020963,'守护短枪','9阶神装副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007020900,2,300,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,17629},{3,8814}]','[]',0,0,3,0),(1007021000,'信仰短枪','10阶绿色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007021000,2,355,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,2270},{3,1135}]','[]',0,0,4,0),(1007021010,'信仰短枪','10阶蓝色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007021000,2,355,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{1,3404},{3,1702}]','[]',0,0,4,0),(1007021020,'信仰短枪','10阶紫色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007021000,2,355,0,2,0,0,0,'[{1,9}]',0,0,0,0,'[{1,6196},{3,3098}]','[]',0,0,4,0),(1007021031,'信仰短枪','10阶橙1星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007021000,2,355,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{1,7558},{3,3779}]','[]',0,0,4,0),(1007021032,'信仰短枪','10阶橙2星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007021000,2,355,0,3,0,0,0,'[{1,15}]',0,0,0,0,'[{1,7558},{3,3779}]','[]',0,0,4,0),(1007021041,'信仰短枪','10阶红1星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007021000,2,355,0,4,0,0,0,'[{1,49}]',0,0,0,0,'[{1,11348},{3,5674}]','[]',0,0,4,0),(1007021042,'信仰短枪','10阶红2星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007021000,2,355,0,4,0,0,0,'[{1,84}]',0,0,0,0,'[{1,11348},{3,5674}]','[]',0,0,4,0),(1007021043,'信仰短枪','10阶红3星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007021000,2,355,0,4,0,0,0,'[{1,487}]',0,0,0,0,'[{1,11348},{3,5674}]','[]',0,0,4,0),(1007021053,'信仰短枪','10阶粉色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007021000,2,355,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,18157},{3,9078}]','[]',0,0,4,0),(1007021063,'信仰短枪','10阶神装副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007021000,2,355,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,22696},{3,11348}]','[]',0,0,4,0),(1007021100,'天行短枪','11阶绿色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007021100,2,400,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,2852},{3,1426}]','[]',0,0,4,0),(1007021110,'天行短枪','11阶蓝色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007021100,2,400,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{1,4278},{3,2139}]','[]',0,0,4,0),(1007021120,'天行短枪','11阶紫色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007021100,2,400,0,2,0,0,0,'[{1,10}]',0,0,0,0,'[{1,7785},{3,3893}]','[]',0,0,4,0),(1007021131,'天行短枪','11阶橙1星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007021100,2,400,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{1,9497},{3,4748}]','[]',0,0,4,0),(1007021132,'天行短枪','11阶橙2星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007021100,2,400,0,3,0,0,0,'[{1,17}]',0,0,0,0,'[{1,9497},{3,4748}]','[]',0,0,4,0),(1007021141,'天行短枪','11阶红1星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007021100,2,400,0,4,0,0,0,'[{1,56}]',0,0,0,0,'[{1,14259},{3,7130}]','[]',0,0,4,0),(1007021142,'天行短枪','11阶红2星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007021100,2,400,0,4,0,0,0,'[{1,95}]',0,0,0,0,'[{1,14259},{3,7130}]','[]',0,0,4,0),(1007021143,'天行短枪','11阶红3星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007021100,2,400,0,4,0,0,0,'[{1,670}]',0,0,0,0,'[{1,14259},{3,7130}]','[]',0,0,4,0),(1007021153,'天行短枪','11阶粉色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007021100,2,400,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,22814},{3,11407}]','[]',0,0,4,0),(1007021163,'天行短枪','11阶神装副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007021100,2,400,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,28518},{3,14259}]','[]',0,0,4,0),(1007021200,'命运短枪','12阶绿色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007021200,2,500,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,3513},{3,1756}]','[]',0,0,5,0),(1007021210,'命运短枪','12阶蓝色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007021200,2,500,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{1,5269},{3,2635}]','[]',0,0,5,0),(1007021220,'命运短枪','12阶紫色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007021200,2,500,0,2,0,0,0,'[{1,11}]',0,0,0,0,'[{1,9590},{3,4795}]','[]',0,0,5,0),(1007021231,'命运短枪','12阶橙1星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007021200,2,500,0,3,0,0,0,'[{1,15}]',0,0,0,0,'[{1,11697},{3,5849}]','[]',0,0,5,0),(1007021232,'命运短枪','12阶橙2星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007021200,2,500,0,3,0,0,0,'[{1,18}]',0,0,0,0,'[{1,11697},{3,5849}]','[]',0,0,5,0),(1007021241,'命运短枪','12阶红1星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007021200,2,500,0,4,0,0,0,'[{1,76}]',0,0,0,0,'[{1,17563},{3,8782}]','[]',0,0,5,0),(1007021242,'命运短枪','12阶红2星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007021200,2,500,0,4,0,0,0,'[{1,134}]',0,0,0,0,'[{1,17563},{3,8782}]','[]',0,0,5,0),(1007021243,'命运短枪','12阶红3星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007021200,2,500,0,4,0,0,0,'[{1,976}]',0,0,0,0,'[{1,17563},{3,8782}]','[]',0,0,5,0),(1007021253,'命运短枪','12阶粉色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007021200,2,500,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,28101},{3,14051}]','[]',0,0,5,0),(1007021263,'命运短枪','12阶神装副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007021200,2,500,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,35127},{3,17563}]','[]',0,0,5,0),(1007021300,'制裁短枪','13阶绿色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007021300,2,520,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,4255},{3,2128}]','[]',0,0,5,0),(1007021310,'制裁短枪','13阶蓝色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007021300,2,520,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{1,6383},{3,3192}]','[]',0,0,5,0),(1007021320,'制裁短枪','13阶紫色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007021300,2,520,0,2,0,0,0,'[{1,12}]',0,0,0,0,'[{1,11617},{3,5809}]','[]',0,0,5,0),(1007021331,'制裁短枪','13阶橙1星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007021300,2,520,0,3,0,0,0,'[{1,16}]',0,0,0,0,'[{1,14171},{3,7085}]','[]',0,0,5,0),(1007021332,'制裁短枪','13阶橙2星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007021300,2,520,0,3,0,0,0,'[{1,20}]',0,0,0,0,'[{1,14171},{3,7085}]','[]',0,0,5,0),(1007021341,'制裁短枪','13阶红1星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007021300,2,520,0,4,0,0,0,'[{1,88}]',0,0,0,0,'[{1,21277},{3,10639}]','[]',0,0,5,0),(1007021342,'制裁短枪','13阶红2星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007021300,2,520,0,4,0,0,0,'[{1,156}]',0,0,0,0,'[{1,21277},{3,10639}]','[]',0,0,5,0),(1007021343,'制裁短枪','13阶红3星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007021300,2,520,0,4,0,0,0,'[{1,1365}]',0,0,0,0,'[{1,21277},{3,10639}]','[]',0,0,5,0),(1007021353,'制裁短枪','13阶粉色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007021300,2,520,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,34044},{3,17022}]','[]',0,0,5,0),(1007021363,'制裁短枪','13阶神装副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007021300,2,520,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,42555},{3,21277}]','[]',0,0,5,0),(1007021400,'审判短枪','14阶绿色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007021400,2,620,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{1,5084},{3,2542}]','[]',0,0,6,0),(1007021410,'审判短枪','14阶蓝色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007021400,2,620,0,1,0,0,0,'[{1,7}]',0,0,0,0,'[{1,7625},{3,3813}]','[]',0,0,6,0),(1007021420,'审判短枪','14阶紫色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007021400,2,620,0,2,0,0,0,'[{1,14}]',0,0,0,0,'[{1,13878},{3,6939}]','[]',0,0,6,0),(1007021431,'审判短枪','14阶橙1星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007021400,2,620,0,3,0,0,0,'[{1,18}]',0,0,0,0,'[{1,16928},{3,8464}]','[]',0,0,6,0),(1007021432,'审判短枪','14阶橙2星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007021400,2,620,0,3,0,0,0,'[{1,23}]',0,0,0,0,'[{1,16928},{3,8464}]','[]',0,0,6,0),(1007021441,'审判短枪','14阶红1星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007021400,2,620,0,4,0,0,0,'[{1,100}]',0,0,0,0,'[{1,25418},{3,12709}]','[]',0,0,6,0),(1007021442,'审判短枪','14阶红2星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007021400,2,620,0,4,0,0,0,'[{1,178}]',0,0,0,0,'[{1,25418},{3,12709}]','[]',0,0,6,0),(1007021443,'审判短枪','14阶红3星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007021400,2,620,0,4,0,0,0,'[{1,1765}]',0,0,0,0,'[{1,25418},{3,12709}]','[]',0,0,6,0),(1007021453,'审判短枪','14阶粉色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007021400,2,620,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,40668},{3,20334}]','[]',0,0,6,0),(1007021463,'审判短枪','14阶神装副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007021400,2,620,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,50835},{3,25418}]','[]',0,0,6,0),(1007021500,'毁灭短枪','15阶绿色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007021500,2,650,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{1,6000},{3,3000}]','[]',0,0,6,0),(1007021510,'毁灭短枪','15阶蓝色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007021500,2,650,0,1,0,0,0,'[{1,8}]',0,0,0,0,'[{1,9000},{3,4500}]','[]',0,0,6,0),(1007021520,'毁灭短枪','15阶紫色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007021500,2,650,0,2,0,0,0,'[{1,15}]',0,0,0,0,'[{1,16380},{3,8190}]','[]',0,0,6,0),(1007021531,'毁灭短枪','15阶橙1星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007021500,2,650,0,3,0,0,0,'[{1,20}]',0,0,0,0,'[{1,19980},{3,9990}]','[]',0,0,6,0),(1007021532,'毁灭短枪','15阶橙2星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007021500,2,650,0,3,0,0,0,'[{1,25}]',0,0,0,0,'[{1,19980},{3,9990}]','[]',0,0,6,0),(1007021541,'毁灭短枪','15阶红1星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007021500,2,650,0,4,0,0,0,'[{1,113}]',0,0,0,0,'[{1,30000},{3,15000}]','[]',0,0,6,0),(1007021542,'毁灭短枪','15阶红2星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007021500,2,650,0,4,0,0,0,'[{1,200}]',0,0,0,0,'[{1,30000},{3,15000}]','[]',0,0,6,0),(1007021543,'毁灭短枪','15阶红3星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007021500,2,650,0,4,0,0,0,'[{1,2098}]',0,0,0,0,'[{1,30000},{3,15000}]','[]',0,0,6,0),(1007021553,'毁灭短枪','15阶粉色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007021500,2,650,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,48000},{3,24000}]','[]',0,0,6,0),(1007021563,'毁灭短枪','15阶神装副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007021500,2,650,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,60000},{3,30000}]','[]',0,0,6,0),(1007021600,'混沌短枪','16阶绿色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007021500,2,700,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{1,7008},{3,3504}]','[]',0,0,6,0),(1007021610,'混沌短枪','16阶蓝色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007021500,2,700,0,1,0,0,0,'[{1,9}]',0,0,0,0,'[{1,10512},{3,5256}]','[]',0,0,6,0),(1007021620,'混沌短枪','16阶紫色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007021500,2,700,0,2,0,0,0,'[{1,17}]',0,0,0,0,'[{1,19132},{3,9566}]','[]',0,0,6,0),(1007021631,'混沌短枪','16阶橙1星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007021500,2,700,0,3,0,0,0,'[{1,23}]',0,0,0,0,'[{1,23337},{3,11669}]','[]',0,0,6,0),(1007021632,'混沌短枪','16阶橙2星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007021500,2,700,0,3,0,0,0,'[{1,28}]',0,0,0,0,'[{1,23337},{3,11669}]','[]',0,0,6,0),(1007021641,'混沌短枪','16阶红1星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007021500,2,700,0,4,0,0,0,'[{1,137}]',0,0,0,0,'[{1,35041},{3,17521}]','[]',0,0,6,0),(1007021642,'混沌短枪','16阶红2星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007021500,2,700,0,4,0,0,0,'[{1,245}]',0,0,0,0,'[{1,35041},{3,17521}]','[]',0,0,6,0),(1007021643,'混沌短枪','16阶红3星副手【龙骑士】','',0,'','',0,1,1,10,7,1,1,7,1007021500,2,700,0,4,0,0,0,'[{1,2498}]',0,0,0,0,'[{1,35041},{3,17521}]','[]',0,0,6,0),(1007021653,'混沌短枪','16阶粉色副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007021500,2,700,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,56066},{3,28033}]','[]',0,0,6,0),(1007021663,'混沌短枪','16阶神装副手【龙骑士】','',0,'','',0,0,1,10,7,0,0,7,1007021500,2,700,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,70082},{3,35041}]','[]',0,0,6,0),(1007030100,'学徒法典','1阶绿色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007030100,3,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,30},{3,15}]','[]',0,0,0,0),(1007030110,'学徒法典','1阶蓝色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007030100,3,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{1,45},{3,22}]','[]',0,0,0,0),(1007030120,'学徒法典','1阶紫色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007030100,3,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{1,81},{3,41}]','[]',0,0,0,0),(1007030131,'学徒法典','1阶橙1星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007030100,3,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{1,99},{3,50}]','[]',0,0,0,0),(1007030132,'学徒法典','1阶橙2星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007030100,3,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{1,99},{3,50}]','[]',0,0,0,0),(1007030141,'学徒法典','1阶红1星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007030100,3,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{1,149},{3,74}]','[]',0,0,0,0),(1007030142,'学徒法典','1阶红2星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007030100,3,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{1,149},{3,74}]','[]',0,0,0,0),(1007030143,'学徒法典','1阶红3星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007030100,3,1,0,4,0,0,0,'[{1,6}]',0,0,0,0,'[{1,149},{3,74}]','[]',0,0,0,0),(1007030153,'学徒法典','1阶粉色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007030100,3,1,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,238},{3,119}]','[]',0,0,0,0),(1007030163,'学徒法典','1阶神装副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007030100,3,1,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,298},{3,149}]','[]',0,0,0,0),(1007030200,'冒险法典','2阶绿色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007030200,3,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,51},{3,25}]','[]',0,0,0,0),(1007030210,'冒险法典','2阶蓝色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007030200,3,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{1,76},{3,38}]','[]',0,0,0,0),(1007030220,'冒险法典','2阶紫色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007030200,3,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{1,139},{3,70}]','[]',0,0,0,0),(1007030231,'冒险法典','2阶橙1星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007030200,3,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{1,170},{3,85}]','[]',0,0,0,0),(1007030232,'冒险法典','2阶橙2星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007030200,3,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{1,170},{3,85}]','[]',0,0,0,0),(1007030241,'冒险法典','2阶红1星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007030200,3,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{1,255},{3,127}]','[]',0,0,0,0),(1007030242,'冒险法典','2阶红2星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007030200,3,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{1,255},{3,127}]','[]',0,0,0,0),(1007030243,'冒险法典','2阶红3星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007030200,3,1,0,4,0,0,0,'[{1,10}]',0,0,0,0,'[{1,255},{3,127}]','[]',0,0,0,0),(1007030253,'冒险法典','2阶粉色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007030200,3,1,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,408},{3,204}]','[]',0,0,0,0),(1007030263,'冒险法典','2阶神装副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007030200,3,1,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,510},{3,255}]','[]',0,0,0,0),(1007030300,'勇者法典','3阶绿色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007030300,3,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,121},{3,61}]','[]',0,0,0,0),(1007030310,'勇者法典','3阶蓝色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007030300,3,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{1,182},{3,91}]','[]',0,0,0,0),(1007030320,'勇者法典','3阶紫色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007030300,3,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{1,332},{3,166}]','[]',0,0,0,0),(1007030331,'勇者法典','3阶橙1星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007030300,3,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{1,405},{3,202}]','[]',0,0,0,0),(1007030332,'勇者法典','3阶橙2星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007030300,3,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{1,405},{3,202}]','[]',0,0,0,0),(1007030341,'勇者法典','3阶红1星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007030300,3,1,0,4,0,0,0,'[{1,4}]',0,0,0,0,'[{1,607},{3,304}]','[]',0,0,0,0),(1007030342,'勇者法典','3阶红2星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007030300,3,1,0,4,0,0,0,'[{1,5}]',0,0,0,0,'[{1,607},{3,304}]','[]',0,0,0,0),(1007030343,'勇者法典','3阶红3星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007030300,3,1,0,4,0,0,0,'[{1,15}]',0,0,0,0,'[{1,607},{3,304}]','[]',0,0,0,0),(1007030353,'勇者法典','3阶粉色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007030300,3,1,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,972},{3,486}]','[]',0,0,0,0),(1007030363,'勇者法典','3阶神装副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007030300,3,1,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,1215},{3,607}]','[]',0,0,0,0),(1007030400,'先驱法典','4阶绿色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007030400,3,100,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,245},{3,122}]','[]',0,0,0,0),(1007030410,'先驱法典','4阶蓝色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007030400,3,100,0,1,0,0,0,'[{1,2}]',0,0,0,0,'[{1,367},{3,183}]','[]',0,0,0,0),(1007030420,'先驱法典','4阶紫色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007030400,3,100,0,2,0,0,0,'[{1,3}]',0,0,0,0,'[{1,668},{3,334}]','[]',0,0,0,0),(1007030431,'先驱法典','4阶橙1星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007030400,3,100,0,3,0,0,0,'[{1,4}]',0,0,0,0,'[{1,815},{3,407}]','[]',0,0,0,0),(1007030432,'先驱法典','4阶橙2星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007030400,3,100,0,3,0,0,0,'[{1,5}]',0,0,0,0,'[{1,815},{3,407}]','[]',0,0,0,0),(1007030441,'先驱法典','4阶红1星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007030400,3,100,0,4,0,0,0,'[{1,10}]',0,0,0,0,'[{1,1223},{3,612}]','[]',0,0,0,0),(1007030442,'先驱法典','4阶红2星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007030400,3,100,0,4,0,0,0,'[{1,14}]',0,0,0,0,'[{1,1223},{3,612}]','[]',0,0,0,0),(1007030443,'先驱法典','4阶红3星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007030400,3,100,0,4,0,0,0,'[{1,42}]',0,0,0,0,'[{1,1223},{3,612}]','[]',0,0,0,0),(1007030453,'先驱法典','4阶粉色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007030400,3,100,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,1957},{3,978}]','[]',0,0,0,0),(1007030463,'先驱法典','4阶神装副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007030400,3,100,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,2446},{3,1223}]','[]',0,0,0,0),(1007030500,'荣誉法典','5阶绿色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007030500,3,150,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,424},{3,212}]','[]',0,0,1,0),(1007030510,'荣誉法典','5阶蓝色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007030500,3,150,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{1,635},{3,318}]','[]',0,0,1,0),(1007030520,'荣誉法典','5阶紫色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007030500,3,150,0,2,0,0,0,'[{1,5}]',0,0,0,0,'[{1,1156},{3,578}]','[]',0,0,1,0),(1007030531,'荣誉法典','5阶橙1星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007030500,3,150,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{1,1411},{3,705}]','[]',0,0,1,0),(1007030532,'荣誉法典','5阶橙2星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007030500,3,150,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{1,1411},{3,705}]','[]',0,0,1,0),(1007030541,'荣誉法典','5阶红1星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007030500,3,150,0,4,0,0,0,'[{1,17}]',0,0,0,0,'[{1,2118},{3,1059}]','[]',0,0,1,0),(1007030542,'荣誉法典','5阶红2星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007030500,3,150,0,4,0,0,0,'[{1,26}]',0,0,0,0,'[{1,2118},{3,1059}]','[]',0,0,1,0),(1007030543,'荣誉法典','5阶红3星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007030500,3,150,0,4,0,0,0,'[{1,77}]',0,0,0,0,'[{1,2118},{3,1059}]','[]',0,0,1,0),(1007030553,'荣誉法典','5阶粉色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007030500,3,150,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,3389},{3,1694}]','[]',0,0,1,0),(1007030563,'荣誉法典','5阶神装副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007030500,3,150,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,4236},{3,2118}]','[]',0,0,1,0),(1007030600,'贤者法典','6阶绿色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007030600,3,180,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,662},{3,331}]','[]',0,0,1,0),(1007030610,'贤者法典','6阶蓝色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007030600,3,180,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{1,993},{3,496}]','[]',0,0,1,0),(1007030620,'贤者法典','6阶紫色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007030600,3,180,0,2,0,0,0,'[{1,6}]',0,0,0,0,'[{1,1806},{3,903}]','[]',0,0,1,0),(1007030631,'贤者法典','6阶橙1星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007030600,3,180,0,3,0,0,0,'[{1,8}]',0,0,0,0,'[{1,2203},{3,1102}]','[]',0,0,1,0),(1007030632,'贤者法典','6阶橙2星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007030600,3,180,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{1,2203},{3,1102}]','[]',0,0,1,0),(1007030641,'贤者法典','6阶红1星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007030600,3,180,0,4,0,0,0,'[{1,22}]',0,0,0,0,'[{1,3308},{3,1654}]','[]',0,0,1,0),(1007030642,'贤者法典','6阶红2星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007030600,3,180,0,4,0,0,0,'[{1,34}]',0,0,0,0,'[{1,3308},{3,1654}]','[]',0,0,1,0),(1007030643,'贤者法典','6阶红3星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007030600,3,180,0,4,0,0,0,'[{1,127}]',0,0,0,0,'[{1,3308},{3,1654}]','[]',0,0,1,0),(1007030653,'贤者法典','6阶粉色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007030600,3,180,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,5293},{3,2647}]','[]',0,0,1,0),(1007030663,'贤者法典','6阶神装副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007030600,3,180,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,6617},{3,3308}]','[]',0,0,1,0),(1007030700,'征服法典','7阶绿色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007030700,3,220,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,962},{3,481}]','[]',0,0,2,0),(1007030710,'征服法典','7阶蓝色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007030700,3,220,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{1,1443},{3,722}]','[]',0,0,2,0),(1007030720,'征服法典','7阶紫色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007030700,3,220,0,2,0,0,0,'[{1,7}]',0,0,0,0,'[{1,2627},{3,1313}]','[]',0,0,2,0),(1007030731,'征服法典','7阶橙1星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007030700,3,220,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{1,3204},{3,1602}]','[]',0,0,2,0),(1007030732,'征服法典','7阶橙2星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007030700,3,220,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{1,3204},{3,1602}]','[]',0,0,2,0),(1007030741,'征服法典','7阶红1星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007030700,3,220,0,4,0,0,0,'[{1,31}]',0,0,0,0,'[{1,4811},{3,2405}]','[]',0,0,2,0),(1007030742,'征服法典','7阶红2星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007030700,3,220,0,4,0,0,0,'[{1,50}]',0,0,0,0,'[{1,4811},{3,2405}]','[]',0,0,2,0),(1007030743,'征服法典','7阶红3星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007030700,3,220,0,4,0,0,0,'[{1,182}]',0,0,0,0,'[{1,4811},{3,2405}]','[]',0,0,2,0),(1007030753,'征服法典','7阶粉色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007030700,3,220,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,7697},{3,3849}]','[]',0,0,2,0),(1007030763,'征服法典','7阶神装副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007030700,3,220,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,9622},{3,4811}]','[]',0,0,2,0),(1007030800,'秩序法典','8阶绿色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007030800,3,260,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,1328},{3,664}]','[]',0,0,2,0),(1007030810,'秩序法典','8阶蓝色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007030800,3,260,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{1,1992},{3,996}]','[]',0,0,2,0),(1007030820,'秩序法典','8阶紫色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007030800,3,260,0,2,0,0,0,'[{1,8}]',0,0,0,0,'[{1,3626},{3,1813}]','[]',0,0,2,0),(1007030831,'秩序法典','8阶橙1星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007030800,3,260,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{1,4423},{3,2212}]','[]',0,0,2,0),(1007030832,'秩序法典','8阶橙2星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007030800,3,260,0,3,0,0,0,'[{1,13}]',0,0,0,0,'[{1,4423},{3,2212}]','[]',0,0,2,0),(1007030841,'秩序法典','8阶红1星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007030800,3,260,0,4,0,0,0,'[{1,35}]',0,0,0,0,'[{1,6641},{3,3321}]','[]',0,0,2,0),(1007030842,'秩序法典','8阶红2星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007030800,3,260,0,4,0,0,0,'[{1,56}]',0,0,0,0,'[{1,6641},{3,3321}]','[]',0,0,2,0),(1007030843,'秩序法典','8阶红3星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007030800,3,260,0,4,0,0,0,'[{1,254}]',0,0,0,0,'[{1,6641},{3,3321}]','[]',0,0,2,0),(1007030853,'秩序法典','8阶粉色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007030800,3,260,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,10626},{3,5313}]','[]',0,0,2,0),(1007030863,'秩序法典','8阶神装副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007030800,3,260,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,13283},{3,6641}]','[]',0,0,2,0),(1007030900,'守护法典','9阶绿色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007030900,3,300,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,1763},{3,881}]','[]',0,0,3,0),(1007030910,'守护法典','9阶蓝色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007030900,3,300,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{1,2644},{3,1322}]','[]',0,0,3,0),(1007030920,'守护法典','9阶紫色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007030900,3,300,0,2,0,0,0,'[{1,9}]',0,0,0,0,'[{1,4813},{3,2406}]','[]',0,0,3,0),(1007030931,'守护法典','9阶橙1星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007030900,3,300,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{1,5870},{3,2935}]','[]',0,0,3,0),(1007030932,'守护法典','9阶橙2星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007030900,3,300,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{1,5870},{3,2935}]','[]',0,0,3,0),(1007030941,'守护法典','9阶红1星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007030900,3,300,0,4,0,0,0,'[{1,41}]',0,0,0,0,'[{1,8814},{3,4407}]','[]',0,0,3,0),(1007030942,'守护法典','9阶红2星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007030900,3,300,0,4,0,0,0,'[{1,67}]',0,0,0,0,'[{1,8814},{3,4407}]','[]',0,0,3,0),(1007030943,'守护法典','9阶红3星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007030900,3,300,0,4,0,0,0,'[{1,354}]',0,0,0,0,'[{1,8814},{3,4407}]','[]',0,0,3,0),(1007030953,'守护法典','9阶粉色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007030900,3,300,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,14103},{3,7051}]','[]',0,0,3,0),(1007030963,'守护法典','9阶神装副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007030900,3,300,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,17629},{3,8814}]','[]',0,0,3,0),(1007031000,'信仰法典','10阶绿色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007031000,3,355,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,2270},{3,1135}]','[]',0,0,4,0),(1007031010,'信仰法典','10阶蓝色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007031000,3,355,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{1,3404},{3,1702}]','[]',0,0,4,0),(1007031020,'信仰法典','10阶紫色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007031000,3,355,0,2,0,0,0,'[{1,9}]',0,0,0,0,'[{1,6196},{3,3098}]','[]',0,0,4,0),(1007031031,'信仰法典','10阶橙1星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007031000,3,355,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{1,7558},{3,3779}]','[]',0,0,4,0),(1007031032,'信仰法典','10阶橙2星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007031000,3,355,0,3,0,0,0,'[{1,15}]',0,0,0,0,'[{1,7558},{3,3779}]','[]',0,0,4,0),(1007031041,'信仰法典','10阶红1星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007031000,3,355,0,4,0,0,0,'[{1,49}]',0,0,0,0,'[{1,11348},{3,5674}]','[]',0,0,4,0),(1007031042,'信仰法典','10阶红2星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007031000,3,355,0,4,0,0,0,'[{1,84}]',0,0,0,0,'[{1,11348},{3,5674}]','[]',0,0,4,0),(1007031043,'信仰法典','10阶红3星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007031000,3,355,0,4,0,0,0,'[{1,487}]',0,0,0,0,'[{1,11348},{3,5674}]','[]',0,0,4,0),(1007031053,'信仰法典','10阶粉色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007031000,3,355,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,18157},{3,9078}]','[]',0,0,4,0),(1007031063,'信仰法典','10阶神装副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007031000,3,355,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,22696},{3,11348}]','[]',0,0,4,0),(1007031100,'天行法典','11阶绿色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007031100,3,400,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,2852},{3,1426}]','[]',0,0,4,0),(1007031110,'天行法典','11阶蓝色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007031100,3,400,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{1,4278},{3,2139}]','[]',0,0,4,0),(1007031120,'天行法典','11阶紫色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007031100,3,400,0,2,0,0,0,'[{1,10}]',0,0,0,0,'[{1,7785},{3,3893}]','[]',0,0,4,0),(1007031131,'天行法典','11阶橙1星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007031100,3,400,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{1,9497},{3,4748}]','[]',0,0,4,0),(1007031132,'天行法典','11阶橙2星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007031100,3,400,0,3,0,0,0,'[{1,17}]',0,0,0,0,'[{1,9497},{3,4748}]','[]',0,0,4,0),(1007031141,'天行法典','11阶红1星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007031100,3,400,0,4,0,0,0,'[{1,56}]',0,0,0,0,'[{1,14259},{3,7130}]','[]',0,0,4,0),(1007031142,'天行法典','11阶红2星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007031100,3,400,0,4,0,0,0,'[{1,95}]',0,0,0,0,'[{1,14259},{3,7130}]','[]',0,0,4,0),(1007031143,'天行法典','11阶红3星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007031100,3,400,0,4,0,0,0,'[{1,670}]',0,0,0,0,'[{1,14259},{3,7130}]','[]',0,0,4,0),(1007031153,'天行法典','11阶粉色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007031100,3,400,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,22814},{3,11407}]','[]',0,0,4,0),(1007031163,'天行法典','11阶神装副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007031100,3,400,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,28518},{3,14259}]','[]',0,0,4,0),(1007031200,'命运法典','12阶绿色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007031200,3,500,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,3513},{3,1756}]','[]',0,0,5,0),(1007031210,'命运法典','12阶蓝色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007031200,3,500,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{1,5269},{3,2635}]','[]',0,0,5,0),(1007031220,'命运法典','12阶紫色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007031200,3,500,0,2,0,0,0,'[{1,11}]',0,0,0,0,'[{1,9590},{3,4795}]','[]',0,0,5,0),(1007031231,'命运法典','12阶橙1星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007031200,3,500,0,3,0,0,0,'[{1,15}]',0,0,0,0,'[{1,11697},{3,5849}]','[]',0,0,5,0),(1007031232,'命运法典','12阶橙2星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007031200,3,500,0,3,0,0,0,'[{1,18}]',0,0,0,0,'[{1,11697},{3,5849}]','[]',0,0,5,0),(1007031241,'命运法典','12阶红1星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007031200,3,500,0,4,0,0,0,'[{1,76}]',0,0,0,0,'[{1,17563},{3,8782}]','[]',0,0,5,0),(1007031242,'命运法典','12阶红2星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007031200,3,500,0,4,0,0,0,'[{1,134}]',0,0,0,0,'[{1,17563},{3,8782}]','[]',0,0,5,0),(1007031243,'命运法典','12阶红3星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007031200,3,500,0,4,0,0,0,'[{1,976}]',0,0,0,0,'[{1,17563},{3,8782}]','[]',0,0,5,0),(1007031253,'命运法典','12阶粉色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007031200,3,500,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,28101},{3,14051}]','[]',0,0,5,0),(1007031263,'命运法典','12阶神装副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007031200,3,500,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,35127},{3,17563}]','[]',0,0,5,0),(1007031300,'制裁法典','13阶绿色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007031300,3,520,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,4255},{3,2128}]','[]',0,0,5,0),(1007031310,'制裁法典','13阶蓝色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007031300,3,520,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{1,6383},{3,3192}]','[]',0,0,5,0),(1007031320,'制裁法典','13阶紫色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007031300,3,520,0,2,0,0,0,'[{1,12}]',0,0,0,0,'[{1,11617},{3,5809}]','[]',0,0,5,0),(1007031331,'制裁法典','13阶橙1星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007031300,3,520,0,3,0,0,0,'[{1,16}]',0,0,0,0,'[{1,14171},{3,7085}]','[]',0,0,5,0),(1007031332,'制裁法典','13阶橙2星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007031300,3,520,0,3,0,0,0,'[{1,20}]',0,0,0,0,'[{1,14171},{3,7085}]','[]',0,0,5,0),(1007031341,'制裁法典','13阶红1星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007031300,3,520,0,4,0,0,0,'[{1,88}]',0,0,0,0,'[{1,21277},{3,10639}]','[]',0,0,5,0),(1007031342,'制裁法典','13阶红2星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007031300,3,520,0,4,0,0,0,'[{1,156}]',0,0,0,0,'[{1,21277},{3,10639}]','[]',0,0,5,0),(1007031343,'制裁法典','13阶红3星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007031300,3,520,0,4,0,0,0,'[{1,1365}]',0,0,0,0,'[{1,21277},{3,10639}]','[]',0,0,5,0),(1007031353,'制裁法典','13阶粉色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007031300,3,520,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,34044},{3,17022}]','[]',0,0,5,0),(1007031363,'制裁法典','13阶神装副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007031300,3,520,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,42555},{3,21277}]','[]',0,0,5,0),(1007031400,'审判法典','14阶绿色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007031400,3,620,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{1,5084},{3,2542}]','[]',0,0,6,0),(1007031410,'审判法典','14阶蓝色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007031400,3,620,0,1,0,0,0,'[{1,7}]',0,0,0,0,'[{1,7625},{3,3813}]','[]',0,0,6,0),(1007031420,'审判法典','14阶紫色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007031400,3,620,0,2,0,0,0,'[{1,14}]',0,0,0,0,'[{1,13878},{3,6939}]','[]',0,0,6,0),(1007031431,'审判法典','14阶橙1星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007031400,3,620,0,3,0,0,0,'[{1,18}]',0,0,0,0,'[{1,16928},{3,8464}]','[]',0,0,6,0),(1007031432,'审判法典','14阶橙2星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007031400,3,620,0,3,0,0,0,'[{1,23}]',0,0,0,0,'[{1,16928},{3,8464}]','[]',0,0,6,0),(1007031441,'审判法典','14阶红1星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007031400,3,620,0,4,0,0,0,'[{1,100}]',0,0,0,0,'[{1,25418},{3,12709}]','[]',0,0,6,0),(1007031442,'审判法典','14阶红2星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007031400,3,620,0,4,0,0,0,'[{1,178}]',0,0,0,0,'[{1,25418},{3,12709}]','[]',0,0,6,0),(1007031443,'审判法典','14阶红3星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007031400,3,620,0,4,0,0,0,'[{1,1765}]',0,0,0,0,'[{1,25418},{3,12709}]','[]',0,0,6,0),(1007031453,'审判法典','14阶粉色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007031400,3,620,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,40668},{3,20334}]','[]',0,0,6,0),(1007031463,'审判法典','14阶神装副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007031400,3,620,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,50835},{3,25418}]','[]',0,0,6,0),(1007031500,'毁灭法典','15阶绿色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007031500,3,650,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{1,6000},{3,3000}]','[]',0,0,6,0),(1007031510,'毁灭法典','15阶蓝色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007031500,3,650,0,1,0,0,0,'[{1,8}]',0,0,0,0,'[{1,9000},{3,4500}]','[]',0,0,6,0),(1007031520,'毁灭法典','15阶紫色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007031500,3,650,0,2,0,0,0,'[{1,15}]',0,0,0,0,'[{1,16380},{3,8190}]','[]',0,0,6,0),(1007031531,'毁灭法典','15阶橙1星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007031500,3,650,0,3,0,0,0,'[{1,20}]',0,0,0,0,'[{1,19980},{3,9990}]','[]',0,0,6,0),(1007031532,'毁灭法典','15阶橙2星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007031500,3,650,0,3,0,0,0,'[{1,25}]',0,0,0,0,'[{1,19980},{3,9990}]','[]',0,0,6,0),(1007031541,'毁灭法典','15阶红1星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007031500,3,650,0,4,0,0,0,'[{1,113}]',0,0,0,0,'[{1,30000},{3,15000}]','[]',0,0,6,0),(1007031542,'毁灭法典','15阶红2星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007031500,3,650,0,4,0,0,0,'[{1,200}]',0,0,0,0,'[{1,30000},{3,15000}]','[]',0,0,6,0),(1007031543,'毁灭法典','15阶红3星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007031500,3,650,0,4,0,0,0,'[{1,2098}]',0,0,0,0,'[{1,30000},{3,15000}]','[]',0,0,6,0),(1007031553,'毁灭法典','15阶粉色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007031500,3,650,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,48000},{3,24000}]','[]',0,0,6,0),(1007031563,'毁灭法典','15阶神装副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007031500,3,650,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,60000},{3,30000}]','[]',0,0,6,0),(1007031600,'混沌法典','16阶绿色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007031500,3,700,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{1,7008},{3,3504}]','[]',0,0,6,0),(1007031610,'混沌法典','16阶蓝色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007031500,3,700,0,1,0,0,0,'[{1,9}]',0,0,0,0,'[{1,10512},{3,5256}]','[]',0,0,6,0),(1007031620,'混沌法典','16阶紫色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007031500,3,700,0,2,0,0,0,'[{1,17}]',0,0,0,0,'[{1,19132},{3,9566}]','[]',0,0,6,0),(1007031631,'混沌法典','16阶橙1星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007031500,3,700,0,3,0,0,0,'[{1,23}]',0,0,0,0,'[{1,23337},{3,11669}]','[]',0,0,6,0),(1007031632,'混沌法典','16阶橙2星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007031500,3,700,0,3,0,0,0,'[{1,28}]',0,0,0,0,'[{1,23337},{3,11669}]','[]',0,0,6,0),(1007031641,'混沌法典','16阶红1星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007031500,3,700,0,4,0,0,0,'[{1,137}]',0,0,0,0,'[{1,35041},{3,17521}]','[]',0,0,6,0),(1007031642,'混沌法典','16阶红2星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007031500,3,700,0,4,0,0,0,'[{1,245}]',0,0,0,0,'[{1,35041},{3,17521}]','[]',0,0,6,0),(1007031643,'混沌法典','16阶红3星副手【魔导师】','',0,'','',0,1,1,10,7,1,1,7,1007031500,3,700,0,4,0,0,0,'[{1,2498}]',0,0,0,0,'[{1,35041},{3,17521}]','[]',0,0,6,0),(1007031653,'混沌法典','16阶粉色副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007031500,3,700,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,56066},{3,28033}]','[]',0,0,6,0),(1007031663,'混沌法典','16阶神装副手【魔导师】','',0,'','',0,0,1,10,7,0,0,7,1007031500,3,700,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,70082},{3,35041}]','[]',0,0,6,0),(1007040100,'学徒炮弹','1阶绿色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007040100,4,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,30},{3,15}]','[]',0,0,0,0),(1007040110,'学徒炮弹','1阶蓝色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007040100,4,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{1,45},{3,22}]','[]',0,0,0,0),(1007040120,'学徒炮弹','1阶紫色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007040100,4,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{1,81},{3,41}]','[]',0,0,0,0),(1007040131,'学徒炮弹','1阶橙1星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007040100,4,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{1,99},{3,50}]','[]',0,0,0,0),(1007040132,'学徒炮弹','1阶橙2星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007040100,4,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{1,99},{3,50}]','[]',0,0,0,0),(1007040141,'学徒炮弹','1阶红1星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007040100,4,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{1,149},{3,74}]','[]',0,0,0,0),(1007040142,'学徒炮弹','1阶红2星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007040100,4,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{1,149},{3,74}]','[]',0,0,0,0),(1007040143,'学徒炮弹','1阶红3星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007040100,4,1,0,4,0,0,0,'[{1,6}]',0,0,0,0,'[{1,149},{3,74}]','[]',0,0,0,0),(1007040153,'学徒炮弹','1阶粉色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007040100,4,1,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,238},{3,119}]','[]',0,0,0,0),(1007040163,'学徒炮弹','1阶神装副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007040100,4,1,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,298},{3,149}]','[]',0,0,0,0),(1007040200,'冒险炮弹','2阶绿色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007040200,4,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,51},{3,25}]','[]',0,0,0,0),(1007040210,'冒险炮弹','2阶蓝色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007040200,4,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{1,76},{3,38}]','[]',0,0,0,0),(1007040220,'冒险炮弹','2阶紫色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007040200,4,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{1,139},{3,70}]','[]',0,0,0,0),(1007040231,'冒险炮弹','2阶橙1星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007040200,4,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{1,170},{3,85}]','[]',0,0,0,0),(1007040232,'冒险炮弹','2阶橙2星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007040200,4,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{1,170},{3,85}]','[]',0,0,0,0),(1007040241,'冒险炮弹','2阶红1星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007040200,4,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{1,255},{3,127}]','[]',0,0,0,0),(1007040242,'冒险炮弹','2阶红2星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007040200,4,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{1,255},{3,127}]','[]',0,0,0,0),(1007040243,'冒险炮弹','2阶红3星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007040200,4,1,0,4,0,0,0,'[{1,10}]',0,0,0,0,'[{1,255},{3,127}]','[]',0,0,0,0),(1007040253,'冒险炮弹','2阶粉色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007040200,4,1,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,408},{3,204}]','[]',0,0,0,0),(1007040263,'冒险炮弹','2阶神装副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007040200,4,1,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,510},{3,255}]','[]',0,0,0,0),(1007040300,'勇者炮弹','3阶绿色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007040300,4,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,121},{3,61}]','[]',0,0,0,0),(1007040310,'勇者炮弹','3阶蓝色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007040300,4,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{1,182},{3,91}]','[]',0,0,0,0),(1007040320,'勇者炮弹','3阶紫色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007040300,4,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{1,332},{3,166}]','[]',0,0,0,0),(1007040331,'勇者炮弹','3阶橙1星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007040300,4,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{1,405},{3,202}]','[]',0,0,0,0),(1007040332,'勇者炮弹','3阶橙2星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007040300,4,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{1,405},{3,202}]','[]',0,0,0,0),(1007040341,'勇者炮弹','3阶红1星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007040300,4,1,0,4,0,0,0,'[{1,4}]',0,0,0,0,'[{1,607},{3,304}]','[]',0,0,0,0),(1007040342,'勇者炮弹','3阶红2星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007040300,4,1,0,4,0,0,0,'[{1,5}]',0,0,0,0,'[{1,607},{3,304}]','[]',0,0,0,0),(1007040343,'勇者炮弹','3阶红3星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007040300,4,1,0,4,0,0,0,'[{1,15}]',0,0,0,0,'[{1,607},{3,304}]','[]',0,0,0,0),(1007040353,'勇者炮弹','3阶粉色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007040300,4,1,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,972},{3,486}]','[]',0,0,0,0),(1007040363,'勇者炮弹','3阶神装副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007040300,4,1,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,1215},{3,607}]','[]',0,0,0,0),(1007040400,'先驱炮弹','4阶绿色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007040400,4,100,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,245},{3,122}]','[]',0,0,0,0),(1007040410,'先驱炮弹','4阶蓝色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007040400,4,100,0,1,0,0,0,'[{1,2}]',0,0,0,0,'[{1,367},{3,183}]','[]',0,0,0,0),(1007040420,'先驱炮弹','4阶紫色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007040400,4,100,0,2,0,0,0,'[{1,3}]',0,0,0,0,'[{1,668},{3,334}]','[]',0,0,0,0),(1007040431,'先驱炮弹','4阶橙1星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007040400,4,100,0,3,0,0,0,'[{1,4}]',0,0,0,0,'[{1,815},{3,407}]','[]',0,0,0,0),(1007040432,'先驱炮弹','4阶橙2星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007040400,4,100,0,3,0,0,0,'[{1,5}]',0,0,0,0,'[{1,815},{3,407}]','[]',0,0,0,0),(1007040441,'先驱炮弹','4阶红1星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007040400,4,100,0,4,0,0,0,'[{1,10}]',0,0,0,0,'[{1,1223},{3,612}]','[]',0,0,0,0),(1007040442,'先驱炮弹','4阶红2星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007040400,4,100,0,4,0,0,0,'[{1,14}]',0,0,0,0,'[{1,1223},{3,612}]','[]',0,0,0,0),(1007040443,'先驱炮弹','4阶红3星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007040400,4,100,0,4,0,0,0,'[{1,42}]',0,0,0,0,'[{1,1223},{3,612}]','[]',0,0,0,0),(1007040453,'先驱炮弹','4阶粉色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007040400,4,100,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,1957},{3,978}]','[]',0,0,0,0),(1007040463,'先驱炮弹','4阶神装副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007040400,4,100,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,2446},{3,1223}]','[]',0,0,0,0),(1007040500,'荣誉炮弹','5阶绿色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007040500,4,150,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,424},{3,212}]','[]',0,0,1,0),(1007040510,'荣誉炮弹','5阶蓝色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007040500,4,150,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{1,635},{3,318}]','[]',0,0,1,0),(1007040520,'荣誉炮弹','5阶紫色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007040500,4,150,0,2,0,0,0,'[{1,5}]',0,0,0,0,'[{1,1156},{3,578}]','[]',0,0,1,0),(1007040531,'荣誉炮弹','5阶橙1星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007040500,4,150,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{1,1411},{3,705}]','[]',0,0,1,0),(1007040532,'荣誉炮弹','5阶橙2星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007040500,4,150,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{1,1411},{3,705}]','[]',0,0,1,0),(1007040541,'荣誉炮弹','5阶红1星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007040500,4,150,0,4,0,0,0,'[{1,17}]',0,0,0,0,'[{1,2118},{3,1059}]','[]',0,0,1,0),(1007040542,'荣誉炮弹','5阶红2星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007040500,4,150,0,4,0,0,0,'[{1,26}]',0,0,0,0,'[{1,2118},{3,1059}]','[]',0,0,1,0),(1007040543,'荣誉炮弹','5阶红3星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007040500,4,150,0,4,0,0,0,'[{1,77}]',0,0,0,0,'[{1,2118},{3,1059}]','[]',0,0,1,0),(1007040553,'荣誉炮弹','5阶粉色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007040500,4,150,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,3389},{3,1694}]','[]',0,0,1,0),(1007040563,'荣誉炮弹','5阶神装副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007040500,4,150,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,4236},{3,2118}]','[]',0,0,1,0),(1007040600,'贤者炮弹','6阶绿色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007040600,4,180,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,662},{3,331}]','[]',0,0,1,0),(1007040610,'贤者炮弹','6阶蓝色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007040600,4,180,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{1,993},{3,496}]','[]',0,0,1,0),(1007040620,'贤者炮弹','6阶紫色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007040600,4,180,0,2,0,0,0,'[{1,6}]',0,0,0,0,'[{1,1806},{3,903}]','[]',0,0,1,0),(1007040631,'贤者炮弹','6阶橙1星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007040600,4,180,0,3,0,0,0,'[{1,8}]',0,0,0,0,'[{1,2203},{3,1102}]','[]',0,0,1,0),(1007040632,'贤者炮弹','6阶橙2星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007040600,4,180,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{1,2203},{3,1102}]','[]',0,0,1,0),(1007040641,'贤者炮弹','6阶红1星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007040600,4,180,0,4,0,0,0,'[{1,22}]',0,0,0,0,'[{1,3308},{3,1654}]','[]',0,0,1,0),(1007040642,'贤者炮弹','6阶红2星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007040600,4,180,0,4,0,0,0,'[{1,34}]',0,0,0,0,'[{1,3308},{3,1654}]','[]',0,0,1,0),(1007040643,'贤者炮弹','6阶红3星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007040600,4,180,0,4,0,0,0,'[{1,127}]',0,0,0,0,'[{1,3308},{3,1654}]','[]',0,0,1,0),(1007040653,'贤者炮弹','6阶粉色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007040600,4,180,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,5293},{3,2647}]','[]',0,0,1,0),(1007040663,'贤者炮弹','6阶神装副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007040600,4,180,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,6617},{3,3308}]','[]',0,0,1,0),(1007040700,'征服炮弹','7阶绿色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007040700,4,220,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,962},{3,481}]','[]',0,0,2,0),(1007040710,'征服炮弹','7阶蓝色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007040700,4,220,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{1,1443},{3,722}]','[]',0,0,2,0),(1007040720,'征服炮弹','7阶紫色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007040700,4,220,0,2,0,0,0,'[{1,7}]',0,0,0,0,'[{1,2627},{3,1313}]','[]',0,0,2,0),(1007040731,'征服炮弹','7阶橙1星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007040700,4,220,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{1,3204},{3,1602}]','[]',0,0,2,0),(1007040732,'征服炮弹','7阶橙2星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007040700,4,220,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{1,3204},{3,1602}]','[]',0,0,2,0),(1007040741,'征服炮弹','7阶红1星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007040700,4,220,0,4,0,0,0,'[{1,31}]',0,0,0,0,'[{1,4811},{3,2405}]','[]',0,0,2,0),(1007040742,'征服炮弹','7阶红2星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007040700,4,220,0,4,0,0,0,'[{1,50}]',0,0,0,0,'[{1,4811},{3,2405}]','[]',0,0,2,0),(1007040743,'征服炮弹','7阶红3星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007040700,4,220,0,4,0,0,0,'[{1,182}]',0,0,0,0,'[{1,4811},{3,2405}]','[]',0,0,2,0),(1007040753,'征服炮弹','7阶粉色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007040700,4,220,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,7697},{3,3849}]','[]',0,0,2,0),(1007040763,'征服炮弹','7阶神装副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007040700,4,220,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,9622},{3,4811}]','[]',0,0,2,0),(1007040800,'秩序炮弹','8阶绿色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007040800,4,260,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,1328},{3,664}]','[]',0,0,2,0),(1007040810,'秩序炮弹','8阶蓝色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007040800,4,260,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{1,1992},{3,996}]','[]',0,0,2,0),(1007040820,'秩序炮弹','8阶紫色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007040800,4,260,0,2,0,0,0,'[{1,8}]',0,0,0,0,'[{1,3626},{3,1813}]','[]',0,0,2,0),(1007040831,'秩序炮弹','8阶橙1星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007040800,4,260,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{1,4423},{3,2212}]','[]',0,0,2,0),(1007040832,'秩序炮弹','8阶橙2星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007040800,4,260,0,3,0,0,0,'[{1,13}]',0,0,0,0,'[{1,4423},{3,2212}]','[]',0,0,2,0),(1007040841,'秩序炮弹','8阶红1星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007040800,4,260,0,4,0,0,0,'[{1,35}]',0,0,0,0,'[{1,6641},{3,3321}]','[]',0,0,2,0),(1007040842,'秩序炮弹','8阶红2星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007040800,4,260,0,4,0,0,0,'[{1,56}]',0,0,0,0,'[{1,6641},{3,3321}]','[]',0,0,2,0),(1007040843,'秩序炮弹','8阶红3星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007040800,4,260,0,4,0,0,0,'[{1,254}]',0,0,0,0,'[{1,6641},{3,3321}]','[]',0,0,2,0),(1007040853,'秩序炮弹','8阶粉色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007040800,4,260,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,10626},{3,5313}]','[]',0,0,2,0),(1007040863,'秩序炮弹','8阶神装副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007040800,4,260,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,13283},{3,6641}]','[]',0,0,2,0),(1007040900,'守护炮弹','9阶绿色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007040900,4,300,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,1763},{3,881}]','[]',0,0,3,0),(1007040910,'守护炮弹','9阶蓝色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007040900,4,300,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{1,2644},{3,1322}]','[]',0,0,3,0),(1007040920,'守护炮弹','9阶紫色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007040900,4,300,0,2,0,0,0,'[{1,9}]',0,0,0,0,'[{1,4813},{3,2406}]','[]',0,0,3,0),(1007040931,'守护炮弹','9阶橙1星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007040900,4,300,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{1,5870},{3,2935}]','[]',0,0,3,0),(1007040932,'守护炮弹','9阶橙2星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007040900,4,300,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{1,5870},{3,2935}]','[]',0,0,3,0),(1007040941,'守护炮弹','9阶红1星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007040900,4,300,0,4,0,0,0,'[{1,41}]',0,0,0,0,'[{1,8814},{3,4407}]','[]',0,0,3,0),(1007040942,'守护炮弹','9阶红2星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007040900,4,300,0,4,0,0,0,'[{1,67}]',0,0,0,0,'[{1,8814},{3,4407}]','[]',0,0,3,0),(1007040943,'守护炮弹','9阶红3星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007040900,4,300,0,4,0,0,0,'[{1,354}]',0,0,0,0,'[{1,8814},{3,4407}]','[]',0,0,3,0),(1007040953,'守护炮弹','9阶粉色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007040900,4,300,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,14103},{3,7051}]','[]',0,0,3,0),(1007040963,'守护炮弹','9阶神装副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007040900,4,300,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,17629},{3,8814}]','[]',0,0,3,0),(1007041000,'信仰炮弹','10阶绿色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007041000,4,355,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,2270},{3,1135}]','[]',0,0,4,0),(1007041010,'信仰炮弹','10阶蓝色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007041000,4,355,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{1,3404},{3,1702}]','[]',0,0,4,0),(1007041020,'信仰炮弹','10阶紫色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007041000,4,355,0,2,0,0,0,'[{1,9}]',0,0,0,0,'[{1,6196},{3,3098}]','[]',0,0,4,0),(1007041031,'信仰炮弹','10阶橙1星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007041000,4,355,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{1,7558},{3,3779}]','[]',0,0,4,0),(1007041032,'信仰炮弹','10阶橙2星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007041000,4,355,0,3,0,0,0,'[{1,15}]',0,0,0,0,'[{1,7558},{3,3779}]','[]',0,0,4,0),(1007041041,'信仰炮弹','10阶红1星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007041000,4,355,0,4,0,0,0,'[{1,49}]',0,0,0,0,'[{1,11348},{3,5674}]','[]',0,0,4,0),(1007041042,'信仰炮弹','10阶红2星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007041000,4,355,0,4,0,0,0,'[{1,84}]',0,0,0,0,'[{1,11348},{3,5674}]','[]',0,0,4,0),(1007041043,'信仰炮弹','10阶红3星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007041000,4,355,0,4,0,0,0,'[{1,487}]',0,0,0,0,'[{1,11348},{3,5674}]','[]',0,0,4,0),(1007041053,'信仰炮弹','10阶粉色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007041000,4,355,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,18157},{3,9078}]','[]',0,0,4,0),(1007041063,'信仰炮弹','10阶神装副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007041000,4,355,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,22696},{3,11348}]','[]',0,0,4,0),(1007041100,'天行炮弹','11阶绿色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007041100,4,400,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,2852},{3,1426}]','[]',0,0,4,0),(1007041110,'天行炮弹','11阶蓝色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007041100,4,400,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{1,4278},{3,2139}]','[]',0,0,4,0),(1007041120,'天行炮弹','11阶紫色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007041100,4,400,0,2,0,0,0,'[{1,10}]',0,0,0,0,'[{1,7785},{3,3893}]','[]',0,0,4,0),(1007041131,'天行炮弹','11阶橙1星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007041100,4,400,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{1,9497},{3,4748}]','[]',0,0,4,0),(1007041132,'天行炮弹','11阶橙2星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007041100,4,400,0,3,0,0,0,'[{1,17}]',0,0,0,0,'[{1,9497},{3,4748}]','[]',0,0,4,0),(1007041141,'天行炮弹','11阶红1星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007041100,4,400,0,4,0,0,0,'[{1,56}]',0,0,0,0,'[{1,14259},{3,7130}]','[]',0,0,4,0),(1007041142,'天行炮弹','11阶红2星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007041100,4,400,0,4,0,0,0,'[{1,95}]',0,0,0,0,'[{1,14259},{3,7130}]','[]',0,0,4,0),(1007041143,'天行炮弹','11阶红3星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007041100,4,400,0,4,0,0,0,'[{1,670}]',0,0,0,0,'[{1,14259},{3,7130}]','[]',0,0,4,0),(1007041153,'天行炮弹','11阶粉色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007041100,4,400,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,22814},{3,11407}]','[]',0,0,4,0),(1007041163,'天行炮弹','11阶神装副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007041100,4,400,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,28518},{3,14259}]','[]',0,0,4,0),(1007041200,'命运炮弹','12阶绿色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007041200,4,500,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,3513},{3,1756}]','[]',0,0,5,0),(1007041210,'命运炮弹','12阶蓝色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007041200,4,500,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{1,5269},{3,2635}]','[]',0,0,5,0),(1007041220,'命运炮弹','12阶紫色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007041200,4,500,0,2,0,0,0,'[{1,11}]',0,0,0,0,'[{1,9590},{3,4795}]','[]',0,0,5,0),(1007041231,'命运炮弹','12阶橙1星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007041200,4,500,0,3,0,0,0,'[{1,15}]',0,0,0,0,'[{1,11697},{3,5849}]','[]',0,0,5,0),(1007041232,'命运炮弹','12阶橙2星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007041200,4,500,0,3,0,0,0,'[{1,18}]',0,0,0,0,'[{1,11697},{3,5849}]','[]',0,0,5,0),(1007041241,'命运炮弹','12阶红1星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007041200,4,500,0,4,0,0,0,'[{1,76}]',0,0,0,0,'[{1,17563},{3,8782}]','[]',0,0,5,0),(1007041242,'命运炮弹','12阶红2星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007041200,4,500,0,4,0,0,0,'[{1,134}]',0,0,0,0,'[{1,17563},{3,8782}]','[]',0,0,5,0),(1007041243,'命运炮弹','12阶红3星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007041200,4,500,0,4,0,0,0,'[{1,976}]',0,0,0,0,'[{1,17563},{3,8782}]','[]',0,0,5,0),(1007041253,'命运炮弹','12阶粉色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007041200,4,500,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,28101},{3,14051}]','[]',0,0,5,0),(1007041263,'命运炮弹','12阶神装副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007041200,4,500,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,35127},{3,17563}]','[]',0,0,5,0),(1007041300,'制裁炮弹','13阶绿色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007041300,4,520,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,4255},{3,2128}]','[]',0,0,5,0),(1007041310,'制裁炮弹','13阶蓝色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007041300,4,520,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{1,6383},{3,3192}]','[]',0,0,5,0),(1007041320,'制裁炮弹','13阶紫色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007041300,4,520,0,2,0,0,0,'[{1,12}]',0,0,0,0,'[{1,11617},{3,5809}]','[]',0,0,5,0),(1007041331,'制裁炮弹','13阶橙1星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007041300,4,520,0,3,0,0,0,'[{1,16}]',0,0,0,0,'[{1,14171},{3,7085}]','[]',0,0,5,0),(1007041332,'制裁炮弹','13阶橙2星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007041300,4,520,0,3,0,0,0,'[{1,20}]',0,0,0,0,'[{1,14171},{3,7085}]','[]',0,0,5,0),(1007041341,'制裁炮弹','13阶红1星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007041300,4,520,0,4,0,0,0,'[{1,88}]',0,0,0,0,'[{1,21277},{3,10639}]','[]',0,0,5,0),(1007041342,'制裁炮弹','13阶红2星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007041300,4,520,0,4,0,0,0,'[{1,156}]',0,0,0,0,'[{1,21277},{3,10639}]','[]',0,0,5,0),(1007041343,'制裁炮弹','13阶红3星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007041300,4,520,0,4,0,0,0,'[{1,1365}]',0,0,0,0,'[{1,21277},{3,10639}]','[]',0,0,5,0),(1007041353,'制裁炮弹','13阶粉色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007041300,4,520,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,34044},{3,17022}]','[]',0,0,5,0),(1007041363,'制裁炮弹','13阶神装副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007041300,4,520,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,42555},{3,21277}]','[]',0,0,5,0),(1007041400,'审判炮弹','14阶绿色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007041400,4,620,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{1,5084},{3,2542}]','[]',0,0,6,0),(1007041410,'审判炮弹','14阶蓝色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007041400,4,620,0,1,0,0,0,'[{1,7}]',0,0,0,0,'[{1,7625},{3,3813}]','[]',0,0,6,0),(1007041420,'审判炮弹','14阶紫色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007041400,4,620,0,2,0,0,0,'[{1,14}]',0,0,0,0,'[{1,13878},{3,6939}]','[]',0,0,6,0),(1007041431,'审判炮弹','14阶橙1星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007041400,4,620,0,3,0,0,0,'[{1,18}]',0,0,0,0,'[{1,16928},{3,8464}]','[]',0,0,6,0),(1007041432,'审判炮弹','14阶橙2星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007041400,4,620,0,3,0,0,0,'[{1,23}]',0,0,0,0,'[{1,16928},{3,8464}]','[]',0,0,6,0),(1007041441,'审判炮弹','14阶红1星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007041400,4,620,0,4,0,0,0,'[{1,100}]',0,0,0,0,'[{1,25418},{3,12709}]','[]',0,0,6,0),(1007041442,'审判炮弹','14阶红2星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007041400,4,620,0,4,0,0,0,'[{1,178}]',0,0,0,0,'[{1,25418},{3,12709}]','[]',0,0,6,0),(1007041443,'审判炮弹','14阶红3星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007041400,4,620,0,4,0,0,0,'[{1,1765}]',0,0,0,0,'[{1,25418},{3,12709}]','[]',0,0,6,0),(1007041453,'审判炮弹','14阶粉色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007041400,4,620,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,40668},{3,20334}]','[]',0,0,6,0),(1007041463,'审判炮弹','14阶神装副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007041400,4,620,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,50835},{3,25418}]','[]',0,0,6,0),(1007041500,'毁灭炮弹','15阶绿色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007041500,4,650,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{1,6000},{3,3000}]','[]',0,0,6,0),(1007041510,'毁灭炮弹','15阶蓝色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007041500,4,650,0,1,0,0,0,'[{1,8}]',0,0,0,0,'[{1,9000},{3,4500}]','[]',0,0,6,0),(1007041520,'毁灭炮弹','15阶紫色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007041500,4,650,0,2,0,0,0,'[{1,15}]',0,0,0,0,'[{1,16380},{3,8190}]','[]',0,0,6,0),(1007041531,'毁灭炮弹','15阶橙1星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007041500,4,650,0,3,0,0,0,'[{1,20}]',0,0,0,0,'[{1,19980},{3,9990}]','[]',0,0,6,0),(1007041532,'毁灭炮弹','15阶橙2星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007041500,4,650,0,3,0,0,0,'[{1,25}]',0,0,0,0,'[{1,19980},{3,9990}]','[]',0,0,6,0),(1007041541,'毁灭炮弹','15阶红1星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007041500,4,650,0,4,0,0,0,'[{1,113}]',0,0,0,0,'[{1,30000},{3,15000}]','[]',0,0,6,0),(1007041542,'毁灭炮弹','15阶红2星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007041500,4,650,0,4,0,0,0,'[{1,200}]',0,0,0,0,'[{1,30000},{3,15000}]','[]',0,0,6,0),(1007041543,'毁灭炮弹','15阶红3星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007041500,4,650,0,4,0,0,0,'[{1,2098}]',0,0,0,0,'[{1,30000},{3,15000}]','[]',0,0,6,0),(1007041553,'毁灭炮弹','15阶粉色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007041500,4,650,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,48000},{3,24000}]','[]',0,0,6,0),(1007041563,'毁灭炮弹','15阶神装副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007041500,4,650,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,60000},{3,30000}]','[]',0,0,6,0),(1007041600,'混沌炮弹','16阶绿色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007041500,4,700,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{1,7008},{3,3504}]','[]',0,0,6,0),(1007041610,'混沌炮弹','16阶蓝色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007041500,4,700,0,1,0,0,0,'[{1,9}]',0,0,0,0,'[{1,10512},{3,5256}]','[]',0,0,6,0),(1007041620,'混沌炮弹','16阶紫色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007041500,4,700,0,2,0,0,0,'[{1,17}]',0,0,0,0,'[{1,19132},{3,9566}]','[]',0,0,6,0),(1007041631,'混沌炮弹','16阶橙1星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007041500,4,700,0,3,0,0,0,'[{1,23}]',0,0,0,0,'[{1,23337},{3,11669}]','[]',0,0,6,0),(1007041632,'混沌炮弹','16阶橙2星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007041500,4,700,0,3,0,0,0,'[{1,28}]',0,0,0,0,'[{1,23337},{3,11669}]','[]',0,0,6,0),(1007041641,'混沌炮弹','16阶红1星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007041500,4,700,0,4,0,0,0,'[{1,137}]',0,0,0,0,'[{1,35041},{3,17521}]','[]',0,0,6,0),(1007041642,'混沌炮弹','16阶红2星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007041500,4,700,0,4,0,0,0,'[{1,245}]',0,0,0,0,'[{1,35041},{3,17521}]','[]',0,0,6,0),(1007041643,'混沌炮弹','16阶红3星副手【重炮手】','',0,'','',0,1,1,10,7,1,1,7,1007041500,4,700,0,4,0,0,0,'[{1,2498}]',0,0,0,0,'[{1,35041},{3,17521}]','[]',0,0,6,0),(1007041653,'混沌炮弹','16阶粉色副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007041500,4,700,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,56066},{3,28033}]','[]',0,0,6,0),(1007041663,'混沌炮弹','16阶神装副手【重炮手】','',0,'','',0,0,1,10,7,0,0,7,1007041500,4,700,0,6,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,70082},{3,35041}]','[]',0,0,6,0),(1008010100,'学徒战腕','1阶绿色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008010100,1,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,487},{4,12}]','[]',0,0,0,0),(1008010110,'学徒战腕','1阶蓝色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008010100,1,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,731},{4,18}]','[]',0,0,0,0),(1008010120,'学徒战腕','1阶紫色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008010100,1,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1330},{4,33}]','[]',0,0,0,0),(1008010131,'学徒战腕','1阶橙1星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008010100,1,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1622},{4,41}]','[]',0,0,0,0),(1008010132,'学徒战腕','1阶橙2星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008010100,1,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1622},{4,41}]','[]',0,0,0,0),(1008010141,'学徒战腕','1阶红1星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008010100,1,1,0,4,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2435},{4,61}]','[]',0,0,0,0),(1008010142,'学徒战腕','1阶红2星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008010100,1,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{2,2435},{4,61}]','[]',0,0,0,0),(1008010143,'学徒战腕','1阶红3星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008010100,1,1,0,4,0,0,0,'[{1,5}]',0,0,0,0,'[{2,2435},{4,61}]','[]',0,0,0,0),(1008010153,'学徒战腕','1阶粉色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008010100,1,1,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,3896},{4,97}]','[]',0,0,0,0),(1008010163,'学徒战腕','1阶神装护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008010100,1,1,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,4870},{4,122}]','[]',0,0,0,0),(1008010200,'冒险战腕','2阶绿色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008010200,1,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,834},{4,21}]','[]',0,0,0,0),(1008010210,'冒险战腕','2阶蓝色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008010200,1,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1251},{4,31}]','[]',0,0,0,0),(1008010220,'冒险战腕','2阶紫色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008010200,1,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2277},{4,57}]','[]',0,0,0,0),(1008010231,'冒险战腕','2阶橙1星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008010200,1,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2777},{4,69}]','[]',0,0,0,0),(1008010232,'冒险战腕','2阶橙2星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008010200,1,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2777},{4,69}]','[]',0,0,0,0),(1008010241,'冒险战腕','2阶红1星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008010200,1,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{2,4170},{4,104}]','[]',0,0,0,0),(1008010242,'冒险战腕','2阶红2星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008010200,1,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{2,4170},{4,104}]','[]',0,0,0,0),(1008010243,'冒险战腕','2阶红3星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008010200,1,1,0,4,0,0,0,'[{1,8}]',0,0,0,0,'[{2,4170},{4,104}]','[]',0,0,0,0),(1008010253,'冒险战腕','2阶粉色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008010200,1,1,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,6671},{4,167}]','[]',0,0,0,0),(1008010263,'冒险战腕','2阶神装护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008010200,1,1,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,8339},{4,208}]','[]',0,0,0,0),(1008010300,'勇者战腕','3阶绿色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008010300,1,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1988},{4,50}]','[]',0,0,0,0),(1008010310,'勇者战腕','3阶蓝色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008010300,1,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2982},{4,75}]','[]',0,0,0,0),(1008010320,'勇者战腕','3阶紫色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008010300,1,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,5427},{4,136}]','[]',0,0,0,0),(1008010331,'勇者战腕','3阶橙1星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008010300,1,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6620},{4,166}]','[]',0,0,0,0),(1008010332,'勇者战腕','3阶橙2星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008010300,1,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6620},{4,166}]','[]',0,0,0,0),(1008010341,'勇者战腕','3阶红1星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008010300,1,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{2,9940},{4,249}]','[]',0,0,0,0),(1008010342,'勇者战腕','3阶红2星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008010300,1,1,0,4,0,0,0,'[{1,4}]',0,0,0,0,'[{2,9940},{4,249}]','[]',0,0,0,0),(1008010343,'勇者战腕','3阶红3星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008010300,1,1,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,9940},{4,249}]','[]',0,0,0,0),(1008010353,'勇者战腕','3阶粉色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008010300,1,1,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,15904},{4,398}]','[]',0,0,0,0),(1008010363,'勇者战腕','3阶神装护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008010300,1,1,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,19881},{4,497}]','[]',0,0,0,0),(1008010400,'先驱战腕','4阶绿色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008010400,1,100,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,4003},{4,100}]','[]',0,0,0,0),(1008010410,'先驱战腕','4阶蓝色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008010400,1,100,0,1,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6004},{4,150}]','[]',0,0,0,0),(1008010420,'先驱战腕','4阶紫色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008010400,1,100,0,2,0,0,0,'[{1,3}]',0,0,0,0,'[{2,10928},{4,273}]','[]',0,0,0,0),(1008010431,'先驱战腕','4阶橙1星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008010400,1,100,0,3,0,0,0,'[{1,3}]',0,0,0,0,'[{2,13329},{4,333}]','[]',0,0,0,0),(1008010432,'先驱战腕','4阶橙2星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008010400,1,100,0,3,0,0,0,'[{1,4}]',0,0,0,0,'[{2,13329},{4,333}]','[]',0,0,0,0),(1008010441,'先驱战腕','4阶红1星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008010400,1,100,0,4,0,0,0,'[{1,8}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1008010442,'先驱战腕','4阶红2星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008010400,1,100,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1008010443,'先驱战腕','4阶红3星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008010400,1,100,0,4,0,0,0,'[{1,34}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1008010453,'先驱战腕','4阶粉色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008010400,1,100,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,32022},{4,801}]','[]',0,0,0,0),(1008010463,'先驱战腕','4阶神装护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008010400,1,100,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,40028},{4,1001}]','[]',0,0,0,0),(1008010500,'荣誉战腕','5阶绿色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008010500,1,150,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,6932},{4,173}]','[]',0,0,1,0),(1008010510,'荣誉战腕','5阶蓝色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008010500,1,150,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{2,10397},{4,260}]','[]',0,0,1,0),(1008010520,'荣誉战腕','5阶紫色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008010500,1,150,0,2,0,0,0,'[{1,5}]',0,0,0,0,'[{2,18923},{4,473}]','[]',0,0,1,0),(1008010531,'荣誉战腕','5阶橙1星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008010500,1,150,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,1,0),(1008010532,'荣誉战腕','5阶橙2星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008010500,1,150,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,1,0),(1008010541,'荣誉战腕','5阶红1星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008010500,1,150,0,4,0,0,0,'[{1,14}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,1,0),(1008010542,'荣誉战腕','5阶红2星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008010500,1,150,0,4,0,0,0,'[{1,21}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,1,0),(1008010543,'荣誉战腕','5阶红3星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008010500,1,150,0,4,0,0,0,'[{1,63}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,1,0),(1008010553,'荣誉战腕','5阶粉色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008010500,1,150,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,55452},{4,1386}]','[]',0,0,1,0),(1008010563,'荣誉战腕','5阶神装护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008010500,1,150,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,69315},{4,1733}]','[]',0,0,1,0),(1008010600,'贤者战腕','6阶绿色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008010600,1,180,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,10828},{4,271}]','[]',0,0,1,0),(1008010610,'贤者战腕','6阶蓝色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008010600,1,180,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{2,16241},{4,406}]','[]',0,0,1,0),(1008010620,'贤者战腕','6阶紫色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008010600,1,180,0,2,0,0,0,'[{1,5}]',0,0,0,0,'[{2,29559},{4,739}]','[]',0,0,1,0),(1008010631,'贤者战腕','6阶橙1星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008010600,1,180,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,36056},{4,901}]','[]',0,0,1,0),(1008010632,'贤者战腕','6阶橙2星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008010600,1,180,0,3,0,0,0,'[{1,8}]',0,0,0,0,'[{2,36056},{4,901}]','[]',0,0,1,0),(1008010641,'贤者战腕','6阶红1星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008010600,1,180,0,4,0,0,0,'[{1,18}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,1,0),(1008010642,'贤者战腕','6阶红2星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008010600,1,180,0,4,0,0,0,'[{1,28}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,1,0),(1008010643,'贤者战腕','6阶红3星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008010600,1,180,0,4,0,0,0,'[{1,104}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,1,0),(1008010653,'贤者战腕','6阶粉色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008010600,1,180,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,86620},{4,2166}]','[]',0,0,1,0),(1008010663,'贤者战腕','6阶神装护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008010600,1,180,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,108276},{4,2707}]','[]',0,0,1,0),(1008010700,'征服战腕','7阶绿色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008010700,1,220,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,15744},{4,394}]','[]',0,0,2,0),(1008010710,'征服战腕','7阶蓝色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008010700,1,220,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{2,23616},{4,590}]','[]',0,0,2,0),(1008010720,'征服战腕','7阶紫色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008010700,1,220,0,2,0,0,0,'[{1,6}]',0,0,0,0,'[{2,42982},{4,1075}]','[]',0,0,2,0),(1008010731,'征服战腕','7阶橙1星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008010700,1,220,0,3,0,0,0,'[{1,8}]',0,0,0,0,'[{2,52429},{4,1311}]','[]',0,0,2,0),(1008010732,'征服战腕','7阶橙2星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008010700,1,220,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,52429},{4,1311}]','[]',0,0,2,0),(1008010741,'征服战腕','7阶红1星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008010700,1,220,0,4,0,0,0,'[{1,25}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,2,0),(1008010742,'征服战腕','7阶红2星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008010700,1,220,0,4,0,0,0,'[{1,41}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,2,0),(1008010743,'征服战腕','7阶红3星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008010700,1,220,0,4,0,0,0,'[{1,149}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,2,0),(1008010753,'征服战腕','7阶粉色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008010700,1,220,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,125955},{4,3149}]','[]',0,0,2,0),(1008010763,'征服战腕','7阶神装护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008010700,1,220,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,157443},{4,3936}]','[]',0,0,2,0),(1008010800,'秩序战腕','8阶绿色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008010800,1,260,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,21735},{4,543}]','[]',0,0,2,0),(1008010810,'秩序战腕','8阶蓝色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008010800,1,260,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,32603},{4,815}]','[]',0,0,2,0),(1008010820,'秩序战腕','8阶紫色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008010800,1,260,0,2,0,0,0,'[{1,7}]',0,0,0,0,'[{2,59337},{4,1483}]','[]',0,0,2,0),(1008010831,'秩序战腕','8阶橙1星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008010800,1,260,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{2,72378},{4,1809}]','[]',0,0,2,0),(1008010832,'秩序战腕','8阶橙2星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008010800,1,260,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{2,72378},{4,1809}]','[]',0,0,2,0),(1008010841,'秩序战腕','8阶红1星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008010800,1,260,0,4,0,0,0,'[{1,28}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,2,0),(1008010842,'秩序战腕','8阶红2星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008010800,1,260,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,2,0),(1008010843,'秩序战腕','8阶红3星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008010800,1,260,0,4,0,0,0,'[{1,208}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,2,0),(1008010853,'秩序战腕','8阶粉色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008010800,1,260,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,173881},{4,4347}]','[]',0,0,2,0),(1008010863,'秩序战腕','8阶神装护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008010800,1,260,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,217352},{4,5434}]','[]',0,0,2,0),(1008010900,'守护战腕','9阶绿色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008010900,1,300,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,28847},{4,721}]','[]',0,0,3,0),(1008010910,'守护战腕','9阶蓝色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008010900,1,300,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,43270},{4,1082}]','[]',0,0,3,0),(1008010920,'守护战腕','9阶紫色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008010900,1,300,0,2,0,0,0,'[{1,7}]',0,0,0,0,'[{2,78752},{4,1969}]','[]',0,0,3,0),(1008010931,'守护战腕','9阶橙1星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008010900,1,300,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,96060},{4,2401}]','[]',0,0,3,0),(1008010932,'守护战腕','9阶橙2星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008010900,1,300,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{2,96060},{4,2401}]','[]',0,0,3,0),(1008010941,'守护战腕','9阶红1星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008010900,1,300,0,4,0,0,0,'[{1,33}]',0,0,0,0,'[{2,144234},{4,3606}]','[]',0,0,3,0),(1008010942,'守护战腕','9阶红2星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008010900,1,300,0,4,0,0,0,'[{1,55}]',0,0,0,0,'[{2,144234},{4,3606}]','[]',0,0,3,0),(1008010943,'守护战腕','9阶红3星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008010900,1,300,0,4,0,0,0,'[{1,290}]',0,0,0,0,'[{2,144234},{4,3606}]','[]',0,0,3,0),(1008010953,'守护战腕','9阶粉色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008010900,1,300,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,230774},{4,5769}]','[]',0,0,3,0),(1008010963,'守护战腕','9阶神装护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008010900,1,300,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,288468},{4,7212}]','[]',0,0,3,0),(1008011000,'信仰战腕','10阶绿色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008011000,1,355,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,37139},{4,928}]','[]',0,0,4,0),(1008011010,'信仰战腕','10阶蓝色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008011000,1,355,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,55709},{4,1393}]','[]',0,0,4,0),(1008011020,'信仰战腕','10阶紫色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008011000,1,355,0,2,0,0,0,'[{1,8}]',0,0,0,0,'[{2,101390},{4,2535}]','[]',0,0,4,0),(1008011031,'信仰战腕','10阶橙1星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008011000,1,355,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,123674},{4,3092}]','[]',0,0,4,0),(1008011032,'信仰战腕','10阶橙2星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008011000,1,355,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{2,123674},{4,3092}]','[]',0,0,4,0),(1008011041,'信仰战腕','10阶红1星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008011000,1,355,0,4,0,0,0,'[{1,40}]',0,0,0,0,'[{2,185696},{4,4642}]','[]',0,0,4,0),(1008011042,'信仰战腕','10阶红2星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008011000,1,355,0,4,0,0,0,'[{1,69}]',0,0,0,0,'[{2,185696},{4,4642}]','[]',0,0,4,0),(1008011043,'信仰战腕','10阶红3星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008011000,1,355,0,4,0,0,0,'[{1,399}]',0,0,0,0,'[{2,185696},{4,4642}]','[]',0,0,4,0),(1008011053,'信仰战腕','10阶粉色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008011000,1,355,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,297114},{4,7428}]','[]',0,0,4,0),(1008011063,'信仰战腕','10阶神装护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008011000,1,355,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,371392},{4,9285}]','[]',0,0,4,0),(1008011100,'天行战腕','11阶绿色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008011100,1,400,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,46666},{4,1167}]','[]',0,0,4,0),(1008011110,'天行战腕','11阶蓝色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008011100,1,400,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,69999},{4,1750}]','[]',0,0,4,0),(1008011120,'天行战腕','11阶紫色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008011100,1,400,0,2,0,0,0,'[{1,9}]',0,0,0,0,'[{2,127398},{4,3185}]','[]',0,0,4,0),(1008011131,'天行战腕','11阶橙1星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008011100,1,400,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{2,155397},{4,3885}]','[]',0,0,4,0),(1008011132,'天行战腕','11阶橙2星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008011100,1,400,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{2,155397},{4,3885}]','[]',0,0,4,0),(1008011141,'天行战腕','11阶红1星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008011100,1,400,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{2,233329},{4,5833}]','[]',0,0,4,0),(1008011142,'天行战腕','11阶红2星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008011100,1,400,0,4,0,0,0,'[{1,78}]',0,0,0,0,'[{2,233329},{4,5833}]','[]',0,0,4,0),(1008011143,'天行战腕','11阶红3星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008011100,1,400,0,4,0,0,0,'[{1,549}]',0,0,0,0,'[{2,233329},{4,5833}]','[]',0,0,4,0),(1008011153,'天行战腕','11阶粉色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008011100,1,400,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,373327},{4,9333}]','[]',0,0,4,0),(1008011163,'天行战腕','11阶神装护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008011100,1,400,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,466659},{4,11666}]','[]',0,0,4,0),(1008011200,'命运战腕','12阶绿色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008011200,1,500,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,57480},{4,1437}]','[]',0,0,5,0),(1008011210,'命运战腕','12阶蓝色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008011200,1,500,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,86220},{4,2156}]','[]',0,0,5,0),(1008011220,'命运战腕','12阶紫色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008011200,1,500,0,2,0,0,0,'[{1,9}]',0,0,0,0,'[{2,156921},{4,3923}]','[]',0,0,5,0),(1008011231,'命运战腕','12阶橙1星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008011200,1,500,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{2,191409},{4,4785}]','[]',0,0,5,0),(1008011232,'命运战腕','12阶橙2星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008011200,1,500,0,3,0,0,0,'[{1,15}]',0,0,0,0,'[{2,191409},{4,4785}]','[]',0,0,5,0),(1008011241,'命运战腕','12阶红1星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008011200,1,500,0,4,0,0,0,'[{1,62}]',0,0,0,0,'[{2,287400},{4,7185}]','[]',0,0,5,0),(1008011242,'命运战腕','12阶红2星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008011200,1,500,0,4,0,0,0,'[{1,110}]',0,0,0,0,'[{2,287400},{4,7185}]','[]',0,0,5,0),(1008011243,'命运战腕','12阶红3星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008011200,1,500,0,4,0,0,0,'[{1,799}]',0,0,0,0,'[{2,287400},{4,7185}]','[]',0,0,5,0),(1008011253,'命运战腕','12阶粉色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008011200,1,500,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,459841},{4,11496}]','[]',0,0,5,0),(1008011263,'命运战腕','12阶神装护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008011200,1,500,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,574801},{4,14370}]','[]',0,0,5,0),(1008011300,'制裁战腕','13阶绿色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008011300,1,520,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,69635},{4,1741}]','[]',0,0,5,0),(1008011310,'制裁战腕','13阶蓝色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008011300,1,520,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,104453},{4,2611}]','[]',0,0,5,0),(1008011320,'制裁战腕','13阶紫色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008011300,1,520,0,2,0,0,0,'[{1,10}]',0,0,0,0,'[{2,190104},{4,4753}]','[]',0,0,5,0),(1008011331,'制裁战腕','13阶橙1星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008011300,1,520,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{2,231885},{4,5797}]','[]',0,0,5,0),(1008011332,'制裁战腕','13阶橙2星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008011300,1,520,0,3,0,0,0,'[{1,17}]',0,0,0,0,'[{2,231885},{4,5797}]','[]',0,0,5,0),(1008011341,'制裁战腕','13阶红1星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008011300,1,520,0,4,0,0,0,'[{1,72}]',0,0,0,0,'[{2,348176},{4,8704}]','[]',0,0,5,0),(1008011342,'制裁战腕','13阶红2星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008011300,1,520,0,4,0,0,0,'[{1,128}]',0,0,0,0,'[{2,348176},{4,8704}]','[]',0,0,5,0),(1008011343,'制裁战腕','13阶红3星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008011300,1,520,0,4,0,0,0,'[{1,1117}]',0,0,0,0,'[{2,348176},{4,8704}]','[]',0,0,5,0),(1008011353,'制裁战腕','13阶粉色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008011300,1,520,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,557082},{4,13927}]','[]',0,0,5,0),(1008011363,'制裁战腕','13阶神装护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008011300,1,520,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,696352},{4,17409}]','[]',0,0,5,0),(1008011400,'审判战腕','14阶绿色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008011400,1,620,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,83185},{4,2080}]','[]',0,0,6,0),(1008011410,'审判战腕','14阶蓝色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008011400,1,620,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{2,124777},{4,3119}]','[]',0,0,6,0),(1008011420,'审判战腕','14阶紫色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008011400,1,620,0,2,0,0,0,'[{1,11}]',0,0,0,0,'[{2,227094},{4,5677}]','[]',0,0,6,0),(1008011431,'审判战腕','14阶橙1星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008011400,1,620,0,3,0,0,0,'[{1,15}]',0,0,0,0,'[{2,277005},{4,6925}]','[]',0,0,6,0),(1008011432,'审判战腕','14阶橙2星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008011400,1,620,0,3,0,0,0,'[{1,19}]',0,0,0,0,'[{2,277005},{4,6925}]','[]',0,0,6,0),(1008011441,'审判战腕','14阶红1星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008011400,1,620,0,4,0,0,0,'[{1,82}]',0,0,0,0,'[{2,415923},{4,10398}]','[]',0,0,6,0),(1008011442,'审判战腕','14阶红2星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008011400,1,620,0,4,0,0,0,'[{1,146}]',0,0,0,0,'[{2,415923},{4,10398}]','[]',0,0,6,0),(1008011443,'审判战腕','14阶红3星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008011400,1,620,0,4,0,0,0,'[{1,1444}]',0,0,0,0,'[{2,415923},{4,10398}]','[]',0,0,6,0),(1008011453,'审判战腕','14阶粉色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008011400,1,620,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,665478},{4,16637}]','[]',0,0,6,0),(1008011463,'审判战腕','14阶神装护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008011400,1,620,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,831847},{4,20796}]','[]',0,0,6,0),(1008011500,'毁灭战腕','15阶绿色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008011500,1,650,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,98182},{4,2455}]','[]',0,0,6,0),(1008011510,'毁灭战腕','15阶蓝色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008011500,1,650,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{2,147273},{4,3682}]','[]',0,0,6,0),(1008011520,'毁灭战腕','15阶紫色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008011500,1,650,0,2,0,0,0,'[{1,12}]',0,0,0,0,'[{2,268036},{4,6701}]','[]',0,0,6,0),(1008011531,'毁灭战腕','15阶橙1星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008011500,1,650,0,3,0,0,0,'[{1,16}]',0,0,0,0,'[{2,326945},{4,8174}]','[]',0,0,6,0),(1008011532,'毁灭战腕','15阶橙2星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008011500,1,650,0,3,0,0,0,'[{1,20}]',0,0,0,0,'[{2,326945},{4,8174}]','[]',0,0,6,0),(1008011541,'毁灭战腕','15阶红1星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008011500,1,650,0,4,0,0,0,'[{1,92}]',0,0,0,0,'[{2,490909},{4,12273}]','[]',0,0,6,0),(1008011542,'毁灭战腕','15阶红2星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008011500,1,650,0,4,0,0,0,'[{1,164}]',0,0,0,0,'[{2,490909},{4,12273}]','[]',0,0,6,0),(1008011543,'毁灭战腕','15阶红3星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008011500,1,650,0,4,0,0,0,'[{1,1717}]',0,0,0,0,'[{2,490909},{4,12273}]','[]',0,0,6,0),(1008011553,'毁灭战腕','15阶粉色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008011500,1,650,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,785455},{4,19636}]','[]',0,0,6,0),(1008011563,'毁灭战腕','15阶神装护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008011500,1,650,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,981818},{4,24545}]','[]',0,0,6,0),(1008011600,'混沌战腕','16阶绿色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008011500,1,700,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{2,114680},{4,2867}]','[]',0,0,6,0),(1008011610,'混沌战腕','16阶蓝色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008011500,1,700,0,1,0,0,0,'[{1,7}]',0,0,0,0,'[{2,172020},{4,4300}]','[]',0,0,6,0),(1008011620,'混沌战腕','16阶紫色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008011500,1,700,0,2,0,0,0,'[{1,14}]',0,0,0,0,'[{2,313076},{4,7827}]','[]',0,0,6,0),(1008011631,'混沌战腕','16阶橙1星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008011500,1,700,0,3,0,0,0,'[{1,19}]',0,0,0,0,'[{2,381884},{4,9547}]','[]',0,0,6,0),(1008011632,'混沌战腕','16阶橙2星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008011500,1,700,0,3,0,0,0,'[{1,23}]',0,0,0,0,'[{2,381884},{4,9547}]','[]',0,0,6,0),(1008011641,'混沌战腕','16阶红1星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008011500,1,700,0,4,0,0,0,'[{1,112}]',0,0,0,0,'[{2,573400},{4,14335}]','[]',0,0,6,0),(1008011642,'混沌战腕','16阶红2星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008011500,1,700,0,4,0,0,0,'[{1,200}]',0,0,0,0,'[{2,573400},{4,14335}]','[]',0,0,6,0),(1008011643,'混沌战腕','16阶红3星护腕【魔剑士】','',0,'','',0,1,1,10,8,1,2,8,1008011500,1,700,0,4,0,0,0,'[{1,2044}]',0,0,0,0,'[{2,573400},{4,14335}]','[]',0,0,6,0),(1008011653,'混沌战腕','16阶粉色护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008011500,1,700,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,917440},{4,22936}]','[]',0,0,6,0),(1008011663,'混沌战腕','16阶神装护腕【魔剑士】','',0,'','',0,0,1,10,8,0,0,8,1008011500,1,700,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,1146800},{4,28670}]','[]',0,0,6,0),(1008020100,'学徒护腕','1阶绿色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008020100,2,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,487},{4,12}]','[]',0,0,0,0),(1008020110,'学徒护腕','1阶蓝色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008020100,2,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,731},{4,18}]','[]',0,0,0,0),(1008020120,'学徒护腕','1阶紫色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008020100,2,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1330},{4,33}]','[]',0,0,0,0),(1008020131,'学徒护腕','1阶橙1星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008020100,2,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1622},{4,41}]','[]',0,0,0,0),(1008020132,'学徒护腕','1阶橙2星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008020100,2,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1622},{4,41}]','[]',0,0,0,0),(1008020141,'学徒护腕','1阶红1星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008020100,2,1,0,4,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2435},{4,61}]','[]',0,0,0,0),(1008020142,'学徒护腕','1阶红2星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008020100,2,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{2,2435},{4,61}]','[]',0,0,0,0),(1008020143,'学徒护腕','1阶红3星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008020100,2,1,0,4,0,0,0,'[{1,5}]',0,0,0,0,'[{2,2435},{4,61}]','[]',0,0,0,0),(1008020153,'学徒护腕','1阶粉色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008020100,2,1,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,3896},{4,97}]','[]',0,0,0,0),(1008020163,'学徒护腕','1阶神装护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008020100,2,1,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,4870},{4,122}]','[]',0,0,0,0),(1008020200,'冒险护腕','2阶绿色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008020200,2,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,834},{4,21}]','[]',0,0,0,0),(1008020210,'冒险护腕','2阶蓝色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008020200,2,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1251},{4,31}]','[]',0,0,0,0),(1008020220,'冒险护腕','2阶紫色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008020200,2,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2277},{4,57}]','[]',0,0,0,0),(1008020231,'冒险护腕','2阶橙1星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008020200,2,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2777},{4,69}]','[]',0,0,0,0),(1008020232,'冒险护腕','2阶橙2星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008020200,2,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2777},{4,69}]','[]',0,0,0,0),(1008020241,'冒险护腕','2阶红1星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008020200,2,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{2,4170},{4,104}]','[]',0,0,0,0),(1008020242,'冒险护腕','2阶红2星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008020200,2,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{2,4170},{4,104}]','[]',0,0,0,0),(1008020243,'冒险护腕','2阶红3星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008020200,2,1,0,4,0,0,0,'[{1,8}]',0,0,0,0,'[{2,4170},{4,104}]','[]',0,0,0,0),(1008020253,'冒险护腕','2阶粉色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008020200,2,1,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,6671},{4,167}]','[]',0,0,0,0),(1008020263,'冒险护腕','2阶神装护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008020200,2,1,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,8339},{4,208}]','[]',0,0,0,0),(1008020300,'勇者护腕','3阶绿色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008020300,2,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1988},{4,50}]','[]',0,0,0,0),(1008020310,'勇者护腕','3阶蓝色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008020300,2,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2982},{4,75}]','[]',0,0,0,0),(1008020320,'勇者护腕','3阶紫色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008020300,2,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,5427},{4,136}]','[]',0,0,0,0),(1008020331,'勇者护腕','3阶橙1星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008020300,2,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6620},{4,166}]','[]',0,0,0,0),(1008020332,'勇者护腕','3阶橙2星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008020300,2,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6620},{4,166}]','[]',0,0,0,0),(1008020341,'勇者护腕','3阶红1星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008020300,2,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{2,9940},{4,249}]','[]',0,0,0,0),(1008020342,'勇者护腕','3阶红2星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008020300,2,1,0,4,0,0,0,'[{1,4}]',0,0,0,0,'[{2,9940},{4,249}]','[]',0,0,0,0),(1008020343,'勇者护腕','3阶红3星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008020300,2,1,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,9940},{4,249}]','[]',0,0,0,0),(1008020353,'勇者护腕','3阶粉色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008020300,2,1,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,15904},{4,398}]','[]',0,0,0,0),(1008020363,'勇者护腕','3阶神装护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008020300,2,1,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,19881},{4,497}]','[]',0,0,0,0),(1008020400,'先驱护腕','4阶绿色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008020400,2,100,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,4003},{4,100}]','[]',0,0,0,0),(1008020410,'先驱护腕','4阶蓝色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008020400,2,100,0,1,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6004},{4,150}]','[]',0,0,0,0),(1008020420,'先驱护腕','4阶紫色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008020400,2,100,0,2,0,0,0,'[{1,3}]',0,0,0,0,'[{2,10928},{4,273}]','[]',0,0,0,0),(1008020431,'先驱护腕','4阶橙1星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008020400,2,100,0,3,0,0,0,'[{1,3}]',0,0,0,0,'[{2,13329},{4,333}]','[]',0,0,0,0),(1008020432,'先驱护腕','4阶橙2星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008020400,2,100,0,3,0,0,0,'[{1,4}]',0,0,0,0,'[{2,13329},{4,333}]','[]',0,0,0,0),(1008020441,'先驱护腕','4阶红1星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008020400,2,100,0,4,0,0,0,'[{1,8}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1008020442,'先驱护腕','4阶红2星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008020400,2,100,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1008020443,'先驱护腕','4阶红3星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008020400,2,100,0,4,0,0,0,'[{1,34}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1008020453,'先驱护腕','4阶粉色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008020400,2,100,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,32022},{4,801}]','[]',0,0,0,0),(1008020463,'先驱护腕','4阶神装护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008020400,2,100,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,40028},{4,1001}]','[]',0,0,0,0),(1008020500,'荣誉护腕','5阶绿色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008020500,2,150,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,6932},{4,173}]','[]',0,0,1,0),(1008020510,'荣誉护腕','5阶蓝色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008020500,2,150,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{2,10397},{4,260}]','[]',0,0,1,0),(1008020520,'荣誉护腕','5阶紫色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008020500,2,150,0,2,0,0,0,'[{1,5}]',0,0,0,0,'[{2,18923},{4,473}]','[]',0,0,1,0),(1008020531,'荣誉护腕','5阶橙1星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008020500,2,150,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,1,0),(1008020532,'荣誉护腕','5阶橙2星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008020500,2,150,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,1,0),(1008020541,'荣誉护腕','5阶红1星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008020500,2,150,0,4,0,0,0,'[{1,14}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,1,0),(1008020542,'荣誉护腕','5阶红2星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008020500,2,150,0,4,0,0,0,'[{1,21}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,1,0),(1008020543,'荣誉护腕','5阶红3星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008020500,2,150,0,4,0,0,0,'[{1,63}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,1,0),(1008020553,'荣誉护腕','5阶粉色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008020500,2,150,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,55452},{4,1386}]','[]',0,0,1,0),(1008020563,'荣誉护腕','5阶神装护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008020500,2,150,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,69315},{4,1733}]','[]',0,0,1,0),(1008020600,'贤者护腕','6阶绿色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008020600,2,180,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,10828},{4,271}]','[]',0,0,1,0),(1008020610,'贤者护腕','6阶蓝色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008020600,2,180,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{2,16241},{4,406}]','[]',0,0,1,0),(1008020620,'贤者护腕','6阶紫色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008020600,2,180,0,2,0,0,0,'[{1,5}]',0,0,0,0,'[{2,29559},{4,739}]','[]',0,0,1,0),(1008020631,'贤者护腕','6阶橙1星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008020600,2,180,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,36056},{4,901}]','[]',0,0,1,0),(1008020632,'贤者护腕','6阶橙2星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008020600,2,180,0,3,0,0,0,'[{1,8}]',0,0,0,0,'[{2,36056},{4,901}]','[]',0,0,1,0),(1008020641,'贤者护腕','6阶红1星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008020600,2,180,0,4,0,0,0,'[{1,18}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,1,0),(1008020642,'贤者护腕','6阶红2星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008020600,2,180,0,4,0,0,0,'[{1,28}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,1,0),(1008020643,'贤者护腕','6阶红3星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008020600,2,180,0,4,0,0,0,'[{1,104}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,1,0),(1008020653,'贤者护腕','6阶粉色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008020600,2,180,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,86620},{4,2166}]','[]',0,0,1,0),(1008020663,'贤者护腕','6阶神装护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008020600,2,180,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,108276},{4,2707}]','[]',0,0,1,0),(1008020700,'征服护腕','7阶绿色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008020700,2,220,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,15744},{4,394}]','[]',0,0,2,0),(1008020710,'征服护腕','7阶蓝色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008020700,2,220,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{2,23616},{4,590}]','[]',0,0,2,0),(1008020720,'征服护腕','7阶紫色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008020700,2,220,0,2,0,0,0,'[{1,6}]',0,0,0,0,'[{2,42982},{4,1075}]','[]',0,0,2,0),(1008020731,'征服护腕','7阶橙1星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008020700,2,220,0,3,0,0,0,'[{1,8}]',0,0,0,0,'[{2,52429},{4,1311}]','[]',0,0,2,0),(1008020732,'征服护腕','7阶橙2星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008020700,2,220,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,52429},{4,1311}]','[]',0,0,2,0),(1008020741,'征服护腕','7阶红1星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008020700,2,220,0,4,0,0,0,'[{1,25}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,2,0),(1008020742,'征服护腕','7阶红2星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008020700,2,220,0,4,0,0,0,'[{1,41}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,2,0),(1008020743,'征服护腕','7阶红3星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008020700,2,220,0,4,0,0,0,'[{1,149}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,2,0),(1008020753,'征服护腕','7阶粉色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008020700,2,220,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,125955},{4,3149}]','[]',0,0,2,0),(1008020763,'征服护腕','7阶神装护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008020700,2,220,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,157443},{4,3936}]','[]',0,0,2,0),(1008020800,'秩序护腕','8阶绿色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008020800,2,260,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,21735},{4,543}]','[]',0,0,2,0),(1008020810,'秩序护腕','8阶蓝色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008020800,2,260,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,32603},{4,815}]','[]',0,0,2,0),(1008020820,'秩序护腕','8阶紫色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008020800,2,260,0,2,0,0,0,'[{1,7}]',0,0,0,0,'[{2,59337},{4,1483}]','[]',0,0,2,0),(1008020831,'秩序护腕','8阶橙1星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008020800,2,260,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{2,72378},{4,1809}]','[]',0,0,2,0),(1008020832,'秩序护腕','8阶橙2星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008020800,2,260,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{2,72378},{4,1809}]','[]',0,0,2,0),(1008020841,'秩序护腕','8阶红1星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008020800,2,260,0,4,0,0,0,'[{1,28}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,2,0),(1008020842,'秩序护腕','8阶红2星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008020800,2,260,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,2,0),(1008020843,'秩序护腕','8阶红3星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008020800,2,260,0,4,0,0,0,'[{1,208}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,2,0),(1008020853,'秩序护腕','8阶粉色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008020800,2,260,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,173881},{4,4347}]','[]',0,0,2,0),(1008020863,'秩序护腕','8阶神装护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008020800,2,260,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,217352},{4,5434}]','[]',0,0,2,0),(1008020900,'守护护腕','9阶绿色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008020900,2,300,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,28847},{4,721}]','[]',0,0,3,0),(1008020910,'守护护腕','9阶蓝色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008020900,2,300,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,43270},{4,1082}]','[]',0,0,3,0),(1008020920,'守护护腕','9阶紫色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008020900,2,300,0,2,0,0,0,'[{1,7}]',0,0,0,0,'[{2,78752},{4,1969}]','[]',0,0,3,0),(1008020931,'守护护腕','9阶橙1星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008020900,2,300,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,96060},{4,2401}]','[]',0,0,3,0),(1008020932,'守护护腕','9阶橙2星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008020900,2,300,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{2,96060},{4,2401}]','[]',0,0,3,0),(1008020941,'守护护腕','9阶红1星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008020900,2,300,0,4,0,0,0,'[{1,33}]',0,0,0,0,'[{2,144234},{4,3606}]','[]',0,0,3,0),(1008020942,'守护护腕','9阶红2星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008020900,2,300,0,4,0,0,0,'[{1,55}]',0,0,0,0,'[{2,144234},{4,3606}]','[]',0,0,3,0),(1008020943,'守护护腕','9阶红3星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008020900,2,300,0,4,0,0,0,'[{1,290}]',0,0,0,0,'[{2,144234},{4,3606}]','[]',0,0,3,0),(1008020953,'守护护腕','9阶粉色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008020900,2,300,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,230774},{4,5769}]','[]',0,0,3,0),(1008020963,'守护护腕','9阶神装护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008020900,2,300,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,288468},{4,7212}]','[]',0,0,3,0),(1008021000,'信仰护腕','10阶绿色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008021000,2,355,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,37139},{4,928}]','[]',0,0,4,0),(1008021010,'信仰护腕','10阶蓝色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008021000,2,355,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,55709},{4,1393}]','[]',0,0,4,0),(1008021020,'信仰护腕','10阶紫色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008021000,2,355,0,2,0,0,0,'[{1,8}]',0,0,0,0,'[{2,101390},{4,2535}]','[]',0,0,4,0),(1008021031,'信仰护腕','10阶橙1星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008021000,2,355,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,123674},{4,3092}]','[]',0,0,4,0),(1008021032,'信仰护腕','10阶橙2星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008021000,2,355,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{2,123674},{4,3092}]','[]',0,0,4,0),(1008021041,'信仰护腕','10阶红1星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008021000,2,355,0,4,0,0,0,'[{1,40}]',0,0,0,0,'[{2,185696},{4,4642}]','[]',0,0,4,0),(1008021042,'信仰护腕','10阶红2星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008021000,2,355,0,4,0,0,0,'[{1,69}]',0,0,0,0,'[{2,185696},{4,4642}]','[]',0,0,4,0),(1008021043,'信仰护腕','10阶红3星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008021000,2,355,0,4,0,0,0,'[{1,399}]',0,0,0,0,'[{2,185696},{4,4642}]','[]',0,0,4,0),(1008021053,'信仰护腕','10阶粉色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008021000,2,355,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,297114},{4,7428}]','[]',0,0,4,0),(1008021063,'信仰护腕','10阶神装护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008021000,2,355,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,371392},{4,9285}]','[]',0,0,4,0),(1008021100,'天行护腕','11阶绿色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008021100,2,400,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,46666},{4,1167}]','[]',0,0,4,0),(1008021110,'天行护腕','11阶蓝色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008021100,2,400,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,69999},{4,1750}]','[]',0,0,4,0),(1008021120,'天行护腕','11阶紫色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008021100,2,400,0,2,0,0,0,'[{1,9}]',0,0,0,0,'[{2,127398},{4,3185}]','[]',0,0,4,0),(1008021131,'天行护腕','11阶橙1星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008021100,2,400,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{2,155397},{4,3885}]','[]',0,0,4,0),(1008021132,'天行护腕','11阶橙2星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008021100,2,400,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{2,155397},{4,3885}]','[]',0,0,4,0),(1008021141,'天行护腕','11阶红1星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008021100,2,400,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{2,233329},{4,5833}]','[]',0,0,4,0),(1008021142,'天行护腕','11阶红2星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008021100,2,400,0,4,0,0,0,'[{1,78}]',0,0,0,0,'[{2,233329},{4,5833}]','[]',0,0,4,0),(1008021143,'天行护腕','11阶红3星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008021100,2,400,0,4,0,0,0,'[{1,549}]',0,0,0,0,'[{2,233329},{4,5833}]','[]',0,0,4,0),(1008021153,'天行护腕','11阶粉色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008021100,2,400,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,373327},{4,9333}]','[]',0,0,4,0),(1008021163,'天行护腕','11阶神装护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008021100,2,400,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,466659},{4,11666}]','[]',0,0,4,0),(1008021200,'命运护腕','12阶绿色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008021200,2,500,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,57480},{4,1437}]','[]',0,0,5,0),(1008021210,'命运护腕','12阶蓝色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008021200,2,500,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,86220},{4,2156}]','[]',0,0,5,0),(1008021220,'命运护腕','12阶紫色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008021200,2,500,0,2,0,0,0,'[{1,9}]',0,0,0,0,'[{2,156921},{4,3923}]','[]',0,0,5,0),(1008021231,'命运护腕','12阶橙1星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008021200,2,500,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{2,191409},{4,4785}]','[]',0,0,5,0),(1008021232,'命运护腕','12阶橙2星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008021200,2,500,0,3,0,0,0,'[{1,15}]',0,0,0,0,'[{2,191409},{4,4785}]','[]',0,0,5,0),(1008021241,'命运护腕','12阶红1星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008021200,2,500,0,4,0,0,0,'[{1,62}]',0,0,0,0,'[{2,287400},{4,7185}]','[]',0,0,5,0),(1008021242,'命运护腕','12阶红2星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008021200,2,500,0,4,0,0,0,'[{1,110}]',0,0,0,0,'[{2,287400},{4,7185}]','[]',0,0,5,0),(1008021243,'命运护腕','12阶红3星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008021200,2,500,0,4,0,0,0,'[{1,799}]',0,0,0,0,'[{2,287400},{4,7185}]','[]',0,0,5,0),(1008021253,'命运护腕','12阶粉色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008021200,2,500,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,459841},{4,11496}]','[]',0,0,5,0),(1008021263,'命运护腕','12阶神装护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008021200,2,500,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,574801},{4,14370}]','[]',0,0,5,0),(1008021300,'制裁护腕','13阶绿色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008021300,2,520,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,69635},{4,1741}]','[]',0,0,5,0),(1008021310,'制裁护腕','13阶蓝色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008021300,2,520,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,104453},{4,2611}]','[]',0,0,5,0),(1008021320,'制裁护腕','13阶紫色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008021300,2,520,0,2,0,0,0,'[{1,10}]',0,0,0,0,'[{2,190104},{4,4753}]','[]',0,0,5,0),(1008021331,'制裁护腕','13阶橙1星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008021300,2,520,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{2,231885},{4,5797}]','[]',0,0,5,0),(1008021332,'制裁护腕','13阶橙2星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008021300,2,520,0,3,0,0,0,'[{1,17}]',0,0,0,0,'[{2,231885},{4,5797}]','[]',0,0,5,0),(1008021341,'制裁护腕','13阶红1星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008021300,2,520,0,4,0,0,0,'[{1,72}]',0,0,0,0,'[{2,348176},{4,8704}]','[]',0,0,5,0),(1008021342,'制裁护腕','13阶红2星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008021300,2,520,0,4,0,0,0,'[{1,128}]',0,0,0,0,'[{2,348176},{4,8704}]','[]',0,0,5,0),(1008021343,'制裁护腕','13阶红3星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008021300,2,520,0,4,0,0,0,'[{1,1117}]',0,0,0,0,'[{2,348176},{4,8704}]','[]',0,0,5,0),(1008021353,'制裁护腕','13阶粉色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008021300,2,520,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,557082},{4,13927}]','[]',0,0,5,0),(1008021363,'制裁护腕','13阶神装护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008021300,2,520,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,696352},{4,17409}]','[]',0,0,5,0),(1008021400,'审判护腕','14阶绿色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008021400,2,620,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,83185},{4,2080}]','[]',0,0,6,0),(1008021410,'审判护腕','14阶蓝色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008021400,2,620,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{2,124777},{4,3119}]','[]',0,0,6,0),(1008021420,'审判护腕','14阶紫色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008021400,2,620,0,2,0,0,0,'[{1,11}]',0,0,0,0,'[{2,227094},{4,5677}]','[]',0,0,6,0),(1008021431,'审判护腕','14阶橙1星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008021400,2,620,0,3,0,0,0,'[{1,15}]',0,0,0,0,'[{2,277005},{4,6925}]','[]',0,0,6,0),(1008021432,'审判护腕','14阶橙2星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008021400,2,620,0,3,0,0,0,'[{1,19}]',0,0,0,0,'[{2,277005},{4,6925}]','[]',0,0,6,0),(1008021441,'审判护腕','14阶红1星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008021400,2,620,0,4,0,0,0,'[{1,82}]',0,0,0,0,'[{2,415923},{4,10398}]','[]',0,0,6,0),(1008021442,'审判护腕','14阶红2星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008021400,2,620,0,4,0,0,0,'[{1,146}]',0,0,0,0,'[{2,415923},{4,10398}]','[]',0,0,6,0),(1008021443,'审判护腕','14阶红3星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008021400,2,620,0,4,0,0,0,'[{1,1444}]',0,0,0,0,'[{2,415923},{4,10398}]','[]',0,0,6,0),(1008021453,'审判护腕','14阶粉色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008021400,2,620,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,665478},{4,16637}]','[]',0,0,6,0),(1008021463,'审判护腕','14阶神装护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008021400,2,620,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,831847},{4,20796}]','[]',0,0,6,0),(1008021500,'毁灭护腕','15阶绿色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008021500,2,650,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,98182},{4,2455}]','[]',0,0,6,0),(1008021510,'毁灭护腕','15阶蓝色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008021500,2,650,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{2,147273},{4,3682}]','[]',0,0,6,0),(1008021520,'毁灭护腕','15阶紫色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008021500,2,650,0,2,0,0,0,'[{1,12}]',0,0,0,0,'[{2,268036},{4,6701}]','[]',0,0,6,0),(1008021531,'毁灭护腕','15阶橙1星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008021500,2,650,0,3,0,0,0,'[{1,16}]',0,0,0,0,'[{2,326945},{4,8174}]','[]',0,0,6,0),(1008021532,'毁灭护腕','15阶橙2星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008021500,2,650,0,3,0,0,0,'[{1,20}]',0,0,0,0,'[{2,326945},{4,8174}]','[]',0,0,6,0),(1008021541,'毁灭护腕','15阶红1星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008021500,2,650,0,4,0,0,0,'[{1,92}]',0,0,0,0,'[{2,490909},{4,12273}]','[]',0,0,6,0),(1008021542,'毁灭护腕','15阶红2星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008021500,2,650,0,4,0,0,0,'[{1,164}]',0,0,0,0,'[{2,490909},{4,12273}]','[]',0,0,6,0),(1008021543,'毁灭护腕','15阶红3星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008021500,2,650,0,4,0,0,0,'[{1,1717}]',0,0,0,0,'[{2,490909},{4,12273}]','[]',0,0,6,0),(1008021553,'毁灭护腕','15阶粉色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008021500,2,650,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,785455},{4,19636}]','[]',0,0,6,0),(1008021563,'毁灭护腕','15阶神装护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008021500,2,650,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,981818},{4,24545}]','[]',0,0,6,0),(1008021600,'混沌护腕','16阶绿色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008021500,2,700,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{2,114680},{4,2867}]','[]',0,0,6,0),(1008021610,'混沌护腕','16阶蓝色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008021500,2,700,0,1,0,0,0,'[{1,7}]',0,0,0,0,'[{2,172020},{4,4300}]','[]',0,0,6,0),(1008021620,'混沌护腕','16阶紫色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008021500,2,700,0,2,0,0,0,'[{1,14}]',0,0,0,0,'[{2,313076},{4,7827}]','[]',0,0,6,0),(1008021631,'混沌护腕','16阶橙1星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008021500,2,700,0,3,0,0,0,'[{1,19}]',0,0,0,0,'[{2,381884},{4,9547}]','[]',0,0,6,0),(1008021632,'混沌护腕','16阶橙2星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008021500,2,700,0,3,0,0,0,'[{1,23}]',0,0,0,0,'[{2,381884},{4,9547}]','[]',0,0,6,0),(1008021641,'混沌护腕','16阶红1星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008021500,2,700,0,4,0,0,0,'[{1,112}]',0,0,0,0,'[{2,573400},{4,14335}]','[]',0,0,6,0),(1008021642,'混沌护腕','16阶红2星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008021500,2,700,0,4,0,0,0,'[{1,200}]',0,0,0,0,'[{2,573400},{4,14335}]','[]',0,0,6,0),(1008021643,'混沌护腕','16阶红3星护腕【龙骑士】','',0,'','',0,1,1,10,8,1,2,8,1008021500,2,700,0,4,0,0,0,'[{1,2044}]',0,0,0,0,'[{2,573400},{4,14335}]','[]',0,0,6,0),(1008021653,'混沌护腕','16阶粉色护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008021500,2,700,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,917440},{4,22936}]','[]',0,0,6,0),(1008021663,'混沌护腕','16阶神装护腕【龙骑士】','',0,'','',0,0,1,10,8,0,0,8,1008021500,2,700,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,1146800},{4,28670}]','[]',0,0,6,0),(1008030100,'学徒护手','1阶绿色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008030100,3,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,487},{4,12}]','[]',0,0,0,0),(1008030110,'学徒护手','1阶蓝色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008030100,3,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,731},{4,18}]','[]',0,0,0,0),(1008030120,'学徒护手','1阶紫色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008030100,3,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1330},{4,33}]','[]',0,0,0,0),(1008030131,'学徒护手','1阶橙1星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008030100,3,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1622},{4,41}]','[]',0,0,0,0),(1008030132,'学徒护手','1阶橙2星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008030100,3,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1622},{4,41}]','[]',0,0,0,0),(1008030141,'学徒护手','1阶红1星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008030100,3,1,0,4,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2435},{4,61}]','[]',0,0,0,0),(1008030142,'学徒护手','1阶红2星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008030100,3,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{2,2435},{4,61}]','[]',0,0,0,0),(1008030143,'学徒护手','1阶红3星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008030100,3,1,0,4,0,0,0,'[{1,5}]',0,0,0,0,'[{2,2435},{4,61}]','[]',0,0,0,0),(1008030153,'学徒护手','1阶粉色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008030100,3,1,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,3896},{4,97}]','[]',0,0,0,0),(1008030163,'学徒护手','1阶神装护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008030100,3,1,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,4870},{4,122}]','[]',0,0,0,0),(1008030200,'冒险护手','2阶绿色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008030200,3,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,834},{4,21}]','[]',0,0,0,0),(1008030210,'冒险护手','2阶蓝色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008030200,3,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1251},{4,31}]','[]',0,0,0,0),(1008030220,'冒险护手','2阶紫色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008030200,3,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2277},{4,57}]','[]',0,0,0,0),(1008030231,'冒险护手','2阶橙1星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008030200,3,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2777},{4,69}]','[]',0,0,0,0),(1008030232,'冒险护手','2阶橙2星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008030200,3,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2777},{4,69}]','[]',0,0,0,0),(1008030241,'冒险护手','2阶红1星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008030200,3,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{2,4170},{4,104}]','[]',0,0,0,0),(1008030242,'冒险护手','2阶红2星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008030200,3,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{2,4170},{4,104}]','[]',0,0,0,0),(1008030243,'冒险护手','2阶红3星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008030200,3,1,0,4,0,0,0,'[{1,8}]',0,0,0,0,'[{2,4170},{4,104}]','[]',0,0,0,0),(1008030253,'冒险护手','2阶粉色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008030200,3,1,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,6671},{4,167}]','[]',0,0,0,0),(1008030263,'冒险护手','2阶神装护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008030200,3,1,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,8339},{4,208}]','[]',0,0,0,0),(1008030300,'勇者护手','3阶绿色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008030300,3,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1988},{4,50}]','[]',0,0,0,0),(1008030310,'勇者护手','3阶蓝色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008030300,3,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2982},{4,75}]','[]',0,0,0,0),(1008030320,'勇者护手','3阶紫色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008030300,3,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,5427},{4,136}]','[]',0,0,0,0),(1008030331,'勇者护手','3阶橙1星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008030300,3,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6620},{4,166}]','[]',0,0,0,0),(1008030332,'勇者护手','3阶橙2星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008030300,3,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6620},{4,166}]','[]',0,0,0,0),(1008030341,'勇者护手','3阶红1星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008030300,3,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{2,9940},{4,249}]','[]',0,0,0,0),(1008030342,'勇者护手','3阶红2星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008030300,3,1,0,4,0,0,0,'[{1,4}]',0,0,0,0,'[{2,9940},{4,249}]','[]',0,0,0,0),(1008030343,'勇者护手','3阶红3星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008030300,3,1,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,9940},{4,249}]','[]',0,0,0,0),(1008030353,'勇者护手','3阶粉色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008030300,3,1,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,15904},{4,398}]','[]',0,0,0,0),(1008030363,'勇者护手','3阶神装护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008030300,3,1,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,19881},{4,497}]','[]',0,0,0,0),(1008030400,'先驱护手','4阶绿色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008030400,3,100,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,4003},{4,100}]','[]',0,0,0,0),(1008030410,'先驱护手','4阶蓝色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008030400,3,100,0,1,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6004},{4,150}]','[]',0,0,0,0),(1008030420,'先驱护手','4阶紫色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008030400,3,100,0,2,0,0,0,'[{1,3}]',0,0,0,0,'[{2,10928},{4,273}]','[]',0,0,0,0),(1008030431,'先驱护手','4阶橙1星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008030400,3,100,0,3,0,0,0,'[{1,3}]',0,0,0,0,'[{2,13329},{4,333}]','[]',0,0,0,0),(1008030432,'先驱护手','4阶橙2星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008030400,3,100,0,3,0,0,0,'[{1,4}]',0,0,0,0,'[{2,13329},{4,333}]','[]',0,0,0,0),(1008030441,'先驱护手','4阶红1星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008030400,3,100,0,4,0,0,0,'[{1,8}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1008030442,'先驱护手','4阶红2星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008030400,3,100,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1008030443,'先驱护手','4阶红3星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008030400,3,100,0,4,0,0,0,'[{1,34}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1008030453,'先驱护手','4阶粉色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008030400,3,100,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,32022},{4,801}]','[]',0,0,0,0),(1008030463,'先驱护手','4阶神装护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008030400,3,100,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,40028},{4,1001}]','[]',0,0,0,0),(1008030500,'荣誉护手','5阶绿色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008030500,3,150,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,6932},{4,173}]','[]',0,0,1,0),(1008030510,'荣誉护手','5阶蓝色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008030500,3,150,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{2,10397},{4,260}]','[]',0,0,1,0),(1008030520,'荣誉护手','5阶紫色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008030500,3,150,0,2,0,0,0,'[{1,5}]',0,0,0,0,'[{2,18923},{4,473}]','[]',0,0,1,0),(1008030531,'荣誉护手','5阶橙1星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008030500,3,150,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,1,0),(1008030532,'荣誉护手','5阶橙2星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008030500,3,150,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,1,0),(1008030541,'荣誉护手','5阶红1星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008030500,3,150,0,4,0,0,0,'[{1,14}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,1,0),(1008030542,'荣誉护手','5阶红2星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008030500,3,150,0,4,0,0,0,'[{1,21}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,1,0),(1008030543,'荣誉护手','5阶红3星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008030500,3,150,0,4,0,0,0,'[{1,63}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,1,0),(1008030553,'荣誉护手','5阶粉色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008030500,3,150,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,55452},{4,1386}]','[]',0,0,1,0),(1008030563,'荣誉护手','5阶神装护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008030500,3,150,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,69315},{4,1733}]','[]',0,0,1,0),(1008030600,'贤者护手','6阶绿色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008030600,3,180,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,10828},{4,271}]','[]',0,0,1,0),(1008030610,'贤者护手','6阶蓝色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008030600,3,180,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{2,16241},{4,406}]','[]',0,0,1,0),(1008030620,'贤者护手','6阶紫色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008030600,3,180,0,2,0,0,0,'[{1,5}]',0,0,0,0,'[{2,29559},{4,739}]','[]',0,0,1,0),(1008030631,'贤者护手','6阶橙1星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008030600,3,180,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,36056},{4,901}]','[]',0,0,1,0),(1008030632,'贤者护手','6阶橙2星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008030600,3,180,0,3,0,0,0,'[{1,8}]',0,0,0,0,'[{2,36056},{4,901}]','[]',0,0,1,0),(1008030641,'贤者护手','6阶红1星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008030600,3,180,0,4,0,0,0,'[{1,18}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,1,0),(1008030642,'贤者护手','6阶红2星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008030600,3,180,0,4,0,0,0,'[{1,28}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,1,0),(1008030643,'贤者护手','6阶红3星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008030600,3,180,0,4,0,0,0,'[{1,104}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,1,0),(1008030653,'贤者护手','6阶粉色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008030600,3,180,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,86620},{4,2166}]','[]',0,0,1,0),(1008030663,'贤者护手','6阶神装护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008030600,3,180,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,108276},{4,2707}]','[]',0,0,1,0),(1008030700,'征服护手','7阶绿色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008030700,3,220,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,15744},{4,394}]','[]',0,0,2,0),(1008030710,'征服护手','7阶蓝色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008030700,3,220,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{2,23616},{4,590}]','[]',0,0,2,0),(1008030720,'征服护手','7阶紫色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008030700,3,220,0,2,0,0,0,'[{1,6}]',0,0,0,0,'[{2,42982},{4,1075}]','[]',0,0,2,0),(1008030731,'征服护手','7阶橙1星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008030700,3,220,0,3,0,0,0,'[{1,8}]',0,0,0,0,'[{2,52429},{4,1311}]','[]',0,0,2,0),(1008030732,'征服护手','7阶橙2星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008030700,3,220,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,52429},{4,1311}]','[]',0,0,2,0),(1008030741,'征服护手','7阶红1星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008030700,3,220,0,4,0,0,0,'[{1,25}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,2,0),(1008030742,'征服护手','7阶红2星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008030700,3,220,0,4,0,0,0,'[{1,41}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,2,0),(1008030743,'征服护手','7阶红3星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008030700,3,220,0,4,0,0,0,'[{1,149}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,2,0),(1008030753,'征服护手','7阶粉色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008030700,3,220,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,125955},{4,3149}]','[]',0,0,2,0),(1008030763,'征服护手','7阶神装护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008030700,3,220,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,157443},{4,3936}]','[]',0,0,2,0),(1008030800,'秩序护手','8阶绿色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008030800,3,260,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,21735},{4,543}]','[]',0,0,2,0),(1008030810,'秩序护手','8阶蓝色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008030800,3,260,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,32603},{4,815}]','[]',0,0,2,0),(1008030820,'秩序护手','8阶紫色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008030800,3,260,0,2,0,0,0,'[{1,7}]',0,0,0,0,'[{2,59337},{4,1483}]','[]',0,0,2,0),(1008030831,'秩序护手','8阶橙1星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008030800,3,260,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{2,72378},{4,1809}]','[]',0,0,2,0),(1008030832,'秩序护手','8阶橙2星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008030800,3,260,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{2,72378},{4,1809}]','[]',0,0,2,0),(1008030841,'秩序护手','8阶红1星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008030800,3,260,0,4,0,0,0,'[{1,28}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,2,0),(1008030842,'秩序护手','8阶红2星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008030800,3,260,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,2,0),(1008030843,'秩序护手','8阶红3星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008030800,3,260,0,4,0,0,0,'[{1,208}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,2,0),(1008030853,'秩序护手','8阶粉色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008030800,3,260,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,173881},{4,4347}]','[]',0,0,2,0),(1008030863,'秩序护手','8阶神装护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008030800,3,260,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,217352},{4,5434}]','[]',0,0,2,0),(1008030900,'守护护手','9阶绿色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008030900,3,300,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,28847},{4,721}]','[]',0,0,3,0),(1008030910,'守护护手','9阶蓝色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008030900,3,300,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,43270},{4,1082}]','[]',0,0,3,0),(1008030920,'守护护手','9阶紫色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008030900,3,300,0,2,0,0,0,'[{1,7}]',0,0,0,0,'[{2,78752},{4,1969}]','[]',0,0,3,0),(1008030931,'守护护手','9阶橙1星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008030900,3,300,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,96060},{4,2401}]','[]',0,0,3,0),(1008030932,'守护护手','9阶橙2星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008030900,3,300,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{2,96060},{4,2401}]','[]',0,0,3,0),(1008030941,'守护护手','9阶红1星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008030900,3,300,0,4,0,0,0,'[{1,33}]',0,0,0,0,'[{2,144234},{4,3606}]','[]',0,0,3,0),(1008030942,'守护护手','9阶红2星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008030900,3,300,0,4,0,0,0,'[{1,55}]',0,0,0,0,'[{2,144234},{4,3606}]','[]',0,0,3,0),(1008030943,'守护护手','9阶红3星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008030900,3,300,0,4,0,0,0,'[{1,290}]',0,0,0,0,'[{2,144234},{4,3606}]','[]',0,0,3,0),(1008030953,'守护护手','9阶粉色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008030900,3,300,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,230774},{4,5769}]','[]',0,0,3,0),(1008030963,'守护护手','9阶神装护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008030900,3,300,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,288468},{4,7212}]','[]',0,0,3,0),(1008031000,'信仰护手','10阶绿色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008031000,3,355,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,37139},{4,928}]','[]',0,0,4,0),(1008031010,'信仰护手','10阶蓝色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008031000,3,355,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,55709},{4,1393}]','[]',0,0,4,0),(1008031020,'信仰护手','10阶紫色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008031000,3,355,0,2,0,0,0,'[{1,8}]',0,0,0,0,'[{2,101390},{4,2535}]','[]',0,0,4,0),(1008031031,'信仰护手','10阶橙1星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008031000,3,355,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,123674},{4,3092}]','[]',0,0,4,0),(1008031032,'信仰护手','10阶橙2星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008031000,3,355,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{2,123674},{4,3092}]','[]',0,0,4,0),(1008031041,'信仰护手','10阶红1星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008031000,3,355,0,4,0,0,0,'[{1,40}]',0,0,0,0,'[{2,185696},{4,4642}]','[]',0,0,4,0),(1008031042,'信仰护手','10阶红2星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008031000,3,355,0,4,0,0,0,'[{1,69}]',0,0,0,0,'[{2,185696},{4,4642}]','[]',0,0,4,0),(1008031043,'信仰护手','10阶红3星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008031000,3,355,0,4,0,0,0,'[{1,399}]',0,0,0,0,'[{2,185696},{4,4642}]','[]',0,0,4,0),(1008031053,'信仰护手','10阶粉色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008031000,3,355,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,297114},{4,7428}]','[]',0,0,4,0),(1008031063,'信仰护手','10阶神装护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008031000,3,355,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,371392},{4,9285}]','[]',0,0,4,0),(1008031100,'天行护手','11阶绿色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008031100,3,400,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,46666},{4,1167}]','[]',0,0,4,0),(1008031110,'天行护手','11阶蓝色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008031100,3,400,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,69999},{4,1750}]','[]',0,0,4,0),(1008031120,'天行护手','11阶紫色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008031100,3,400,0,2,0,0,0,'[{1,9}]',0,0,0,0,'[{2,127398},{4,3185}]','[]',0,0,4,0),(1008031131,'天行护手','11阶橙1星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008031100,3,400,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{2,155397},{4,3885}]','[]',0,0,4,0),(1008031132,'天行护手','11阶橙2星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008031100,3,400,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{2,155397},{4,3885}]','[]',0,0,4,0),(1008031141,'天行护手','11阶红1星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008031100,3,400,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{2,233329},{4,5833}]','[]',0,0,4,0),(1008031142,'天行护手','11阶红2星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008031100,3,400,0,4,0,0,0,'[{1,78}]',0,0,0,0,'[{2,233329},{4,5833}]','[]',0,0,4,0),(1008031143,'天行护手','11阶红3星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008031100,3,400,0,4,0,0,0,'[{1,549}]',0,0,0,0,'[{2,233329},{4,5833}]','[]',0,0,4,0),(1008031153,'天行护手','11阶粉色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008031100,3,400,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,373327},{4,9333}]','[]',0,0,4,0),(1008031163,'天行护手','11阶神装护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008031100,3,400,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,466659},{4,11666}]','[]',0,0,4,0),(1008031200,'命运护手','12阶绿色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008031200,3,500,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,57480},{4,1437}]','[]',0,0,5,0),(1008031210,'命运护手','12阶蓝色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008031200,3,500,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,86220},{4,2156}]','[]',0,0,5,0),(1008031220,'命运护手','12阶紫色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008031200,3,500,0,2,0,0,0,'[{1,9}]',0,0,0,0,'[{2,156921},{4,3923}]','[]',0,0,5,0),(1008031231,'命运护手','12阶橙1星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008031200,3,500,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{2,191409},{4,4785}]','[]',0,0,5,0),(1008031232,'命运护手','12阶橙2星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008031200,3,500,0,3,0,0,0,'[{1,15}]',0,0,0,0,'[{2,191409},{4,4785}]','[]',0,0,5,0),(1008031241,'命运护手','12阶红1星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008031200,3,500,0,4,0,0,0,'[{1,62}]',0,0,0,0,'[{2,287400},{4,7185}]','[]',0,0,5,0),(1008031242,'命运护手','12阶红2星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008031200,3,500,0,4,0,0,0,'[{1,110}]',0,0,0,0,'[{2,287400},{4,7185}]','[]',0,0,5,0),(1008031243,'命运护手','12阶红3星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008031200,3,500,0,4,0,0,0,'[{1,799}]',0,0,0,0,'[{2,287400},{4,7185}]','[]',0,0,5,0),(1008031253,'命运护手','12阶粉色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008031200,3,500,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,459841},{4,11496}]','[]',0,0,5,0),(1008031263,'命运护手','12阶神装护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008031200,3,500,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,574801},{4,14370}]','[]',0,0,5,0),(1008031300,'制裁护手','13阶绿色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008031300,3,520,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,69635},{4,1741}]','[]',0,0,5,0),(1008031310,'制裁护手','13阶蓝色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008031300,3,520,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,104453},{4,2611}]','[]',0,0,5,0),(1008031320,'制裁护手','13阶紫色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008031300,3,520,0,2,0,0,0,'[{1,10}]',0,0,0,0,'[{2,190104},{4,4753}]','[]',0,0,5,0),(1008031331,'制裁护手','13阶橙1星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008031300,3,520,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{2,231885},{4,5797}]','[]',0,0,5,0),(1008031332,'制裁护手','13阶橙2星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008031300,3,520,0,3,0,0,0,'[{1,17}]',0,0,0,0,'[{2,231885},{4,5797}]','[]',0,0,5,0),(1008031341,'制裁护手','13阶红1星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008031300,3,520,0,4,0,0,0,'[{1,72}]',0,0,0,0,'[{2,348176},{4,8704}]','[]',0,0,5,0),(1008031342,'制裁护手','13阶红2星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008031300,3,520,0,4,0,0,0,'[{1,128}]',0,0,0,0,'[{2,348176},{4,8704}]','[]',0,0,5,0),(1008031343,'制裁护手','13阶红3星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008031300,3,520,0,4,0,0,0,'[{1,1117}]',0,0,0,0,'[{2,348176},{4,8704}]','[]',0,0,5,0),(1008031353,'制裁护手','13阶粉色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008031300,3,520,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,557082},{4,13927}]','[]',0,0,5,0),(1008031363,'制裁护手','13阶神装护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008031300,3,520,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,696352},{4,17409}]','[]',0,0,5,0),(1008031400,'审判护手','14阶绿色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008031400,3,620,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,83185},{4,2080}]','[]',0,0,6,0),(1008031410,'审判护手','14阶蓝色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008031400,3,620,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{2,124777},{4,3119}]','[]',0,0,6,0),(1008031420,'审判护手','14阶紫色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008031400,3,620,0,2,0,0,0,'[{1,11}]',0,0,0,0,'[{2,227094},{4,5677}]','[]',0,0,6,0),(1008031431,'审判护手','14阶橙1星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008031400,3,620,0,3,0,0,0,'[{1,15}]',0,0,0,0,'[{2,277005},{4,6925}]','[]',0,0,6,0),(1008031432,'审判护手','14阶橙2星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008031400,3,620,0,3,0,0,0,'[{1,19}]',0,0,0,0,'[{2,277005},{4,6925}]','[]',0,0,6,0),(1008031441,'审判护手','14阶红1星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008031400,3,620,0,4,0,0,0,'[{1,82}]',0,0,0,0,'[{2,415923},{4,10398}]','[]',0,0,6,0),(1008031442,'审判护手','14阶红2星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008031400,3,620,0,4,0,0,0,'[{1,146}]',0,0,0,0,'[{2,415923},{4,10398}]','[]',0,0,6,0),(1008031443,'审判护手','14阶红3星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008031400,3,620,0,4,0,0,0,'[{1,1444}]',0,0,0,0,'[{2,415923},{4,10398}]','[]',0,0,6,0),(1008031453,'审判护手','14阶粉色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008031400,3,620,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,665478},{4,16637}]','[]',0,0,6,0),(1008031463,'审判护手','14阶神装护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008031400,3,620,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,831847},{4,20796}]','[]',0,0,6,0),(1008031500,'毁灭护手','15阶绿色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008031500,3,650,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,98182},{4,2455}]','[]',0,0,6,0),(1008031510,'毁灭护手','15阶蓝色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008031500,3,650,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{2,147273},{4,3682}]','[]',0,0,6,0),(1008031520,'毁灭护手','15阶紫色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008031500,3,650,0,2,0,0,0,'[{1,12}]',0,0,0,0,'[{2,268036},{4,6701}]','[]',0,0,6,0),(1008031531,'毁灭护手','15阶橙1星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008031500,3,650,0,3,0,0,0,'[{1,16}]',0,0,0,0,'[{2,326945},{4,8174}]','[]',0,0,6,0),(1008031532,'毁灭护手','15阶橙2星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008031500,3,650,0,3,0,0,0,'[{1,20}]',0,0,0,0,'[{2,326945},{4,8174}]','[]',0,0,6,0),(1008031541,'毁灭护手','15阶红1星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008031500,3,650,0,4,0,0,0,'[{1,92}]',0,0,0,0,'[{2,490909},{4,12273}]','[]',0,0,6,0),(1008031542,'毁灭护手','15阶红2星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008031500,3,650,0,4,0,0,0,'[{1,164}]',0,0,0,0,'[{2,490909},{4,12273}]','[]',0,0,6,0),(1008031543,'毁灭护手','15阶红3星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008031500,3,650,0,4,0,0,0,'[{1,1717}]',0,0,0,0,'[{2,490909},{4,12273}]','[]',0,0,6,0),(1008031553,'毁灭护手','15阶粉色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008031500,3,650,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,785455},{4,19636}]','[]',0,0,6,0),(1008031563,'毁灭护手','15阶神装护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008031500,3,650,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,981818},{4,24545}]','[]',0,0,6,0),(1008031600,'混沌护手','16阶绿色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008031500,3,700,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{2,114680},{4,2867}]','[]',0,0,6,0),(1008031610,'混沌护手','16阶蓝色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008031500,3,700,0,1,0,0,0,'[{1,7}]',0,0,0,0,'[{2,172020},{4,4300}]','[]',0,0,6,0),(1008031620,'混沌护手','16阶紫色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008031500,3,700,0,2,0,0,0,'[{1,14}]',0,0,0,0,'[{2,313076},{4,7827}]','[]',0,0,6,0),(1008031631,'混沌护手','16阶橙1星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008031500,3,700,0,3,0,0,0,'[{1,19}]',0,0,0,0,'[{2,381884},{4,9547}]','[]',0,0,6,0),(1008031632,'混沌护手','16阶橙2星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008031500,3,700,0,3,0,0,0,'[{1,23}]',0,0,0,0,'[{2,381884},{4,9547}]','[]',0,0,6,0),(1008031641,'混沌护手','16阶红1星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008031500,3,700,0,4,0,0,0,'[{1,112}]',0,0,0,0,'[{2,573400},{4,14335}]','[]',0,0,6,0),(1008031642,'混沌护手','16阶红2星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008031500,3,700,0,4,0,0,0,'[{1,200}]',0,0,0,0,'[{2,573400},{4,14335}]','[]',0,0,6,0),(1008031643,'混沌护手','16阶红3星护腕【魔导师】','',0,'','',0,1,1,10,8,1,2,8,1008031500,3,700,0,4,0,0,0,'[{1,2044}]',0,0,0,0,'[{2,573400},{4,14335}]','[]',0,0,6,0),(1008031653,'混沌护手','16阶粉色护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008031500,3,700,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,917440},{4,22936}]','[]',0,0,6,0),(1008031663,'混沌护手','16阶神装护腕【魔导师】','',0,'','',0,0,1,10,8,0,0,8,1008031500,3,700,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,1146800},{4,28670}]','[]',0,0,6,0),(1008040100,'学徒手套','1阶绿色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008040100,4,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,487},{4,12}]','[]',0,0,0,0),(1008040110,'学徒手套','1阶蓝色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008040100,4,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,731},{4,18}]','[]',0,0,0,0),(1008040120,'学徒手套','1阶紫色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008040100,4,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1330},{4,33}]','[]',0,0,0,0),(1008040131,'学徒手套','1阶橙1星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008040100,4,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1622},{4,41}]','[]',0,0,0,0),(1008040132,'学徒手套','1阶橙2星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008040100,4,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1622},{4,41}]','[]',0,0,0,0),(1008040141,'学徒手套','1阶红1星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008040100,4,1,0,4,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2435},{4,61}]','[]',0,0,0,0),(1008040142,'学徒手套','1阶红2星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008040100,4,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{2,2435},{4,61}]','[]',0,0,0,0),(1008040143,'学徒手套','1阶红3星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008040100,4,1,0,4,0,0,0,'[{1,5}]',0,0,0,0,'[{2,2435},{4,61}]','[]',0,0,0,0),(1008040153,'学徒手套','1阶粉色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008040100,4,1,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,3896},{4,97}]','[]',0,0,0,0),(1008040163,'学徒手套','1阶神装护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008040100,4,1,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,4870},{4,122}]','[]',0,0,0,0),(1008040200,'冒险手套','2阶绿色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008040200,4,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,834},{4,21}]','[]',0,0,0,0),(1008040210,'冒险手套','2阶蓝色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008040200,4,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1251},{4,31}]','[]',0,0,0,0),(1008040220,'冒险手套','2阶紫色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008040200,4,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2277},{4,57}]','[]',0,0,0,0),(1008040231,'冒险手套','2阶橙1星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008040200,4,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2777},{4,69}]','[]',0,0,0,0),(1008040232,'冒险手套','2阶橙2星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008040200,4,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2777},{4,69}]','[]',0,0,0,0),(1008040241,'冒险手套','2阶红1星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008040200,4,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{2,4170},{4,104}]','[]',0,0,0,0),(1008040242,'冒险手套','2阶红2星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008040200,4,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{2,4170},{4,104}]','[]',0,0,0,0),(1008040243,'冒险手套','2阶红3星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008040200,4,1,0,4,0,0,0,'[{1,8}]',0,0,0,0,'[{2,4170},{4,104}]','[]',0,0,0,0),(1008040253,'冒险手套','2阶粉色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008040200,4,1,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,6671},{4,167}]','[]',0,0,0,0),(1008040263,'冒险手套','2阶神装护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008040200,4,1,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,8339},{4,208}]','[]',0,0,0,0),(1008040300,'勇者手套','3阶绿色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008040300,4,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1988},{4,50}]','[]',0,0,0,0),(1008040310,'勇者手套','3阶蓝色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008040300,4,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2982},{4,75}]','[]',0,0,0,0),(1008040320,'勇者手套','3阶紫色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008040300,4,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,5427},{4,136}]','[]',0,0,0,0),(1008040331,'勇者手套','3阶橙1星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008040300,4,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6620},{4,166}]','[]',0,0,0,0),(1008040332,'勇者手套','3阶橙2星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008040300,4,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6620},{4,166}]','[]',0,0,0,0),(1008040341,'勇者手套','3阶红1星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008040300,4,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{2,9940},{4,249}]','[]',0,0,0,0),(1008040342,'勇者手套','3阶红2星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008040300,4,1,0,4,0,0,0,'[{1,4}]',0,0,0,0,'[{2,9940},{4,249}]','[]',0,0,0,0),(1008040343,'勇者手套','3阶红3星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008040300,4,1,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,9940},{4,249}]','[]',0,0,0,0),(1008040353,'勇者手套','3阶粉色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008040300,4,1,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,15904},{4,398}]','[]',0,0,0,0),(1008040363,'勇者手套','3阶神装护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008040300,4,1,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,19881},{4,497}]','[]',0,0,0,0),(1008040400,'先驱手套','4阶绿色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008040400,4,100,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,4003},{4,100}]','[]',0,0,0,0),(1008040410,'先驱手套','4阶蓝色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008040400,4,100,0,1,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6004},{4,150}]','[]',0,0,0,0),(1008040420,'先驱手套','4阶紫色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008040400,4,100,0,2,0,0,0,'[{1,3}]',0,0,0,0,'[{2,10928},{4,273}]','[]',0,0,0,0),(1008040431,'先驱手套','4阶橙1星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008040400,4,100,0,3,0,0,0,'[{1,3}]',0,0,0,0,'[{2,13329},{4,333}]','[]',0,0,0,0),(1008040432,'先驱手套','4阶橙2星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008040400,4,100,0,3,0,0,0,'[{1,4}]',0,0,0,0,'[{2,13329},{4,333}]','[]',0,0,0,0),(1008040441,'先驱手套','4阶红1星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008040400,4,100,0,4,0,0,0,'[{1,8}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1008040442,'先驱手套','4阶红2星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008040400,4,100,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1008040443,'先驱手套','4阶红3星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008040400,4,100,0,4,0,0,0,'[{1,34}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1008040453,'先驱手套','4阶粉色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008040400,4,100,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,32022},{4,801}]','[]',0,0,0,0),(1008040463,'先驱手套','4阶神装护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008040400,4,100,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,40028},{4,1001}]','[]',0,0,0,0),(1008040500,'荣誉手套','5阶绿色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008040500,4,150,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,6932},{4,173}]','[]',0,0,1,0),(1008040510,'荣誉手套','5阶蓝色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008040500,4,150,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{2,10397},{4,260}]','[]',0,0,1,0),(1008040520,'荣誉手套','5阶紫色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008040500,4,150,0,2,0,0,0,'[{1,5}]',0,0,0,0,'[{2,18923},{4,473}]','[]',0,0,1,0),(1008040531,'荣誉手套','5阶橙1星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008040500,4,150,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,1,0),(1008040532,'荣誉手套','5阶橙2星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008040500,4,150,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,1,0),(1008040541,'荣誉手套','5阶红1星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008040500,4,150,0,4,0,0,0,'[{1,14}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,1,0),(1008040542,'荣誉手套','5阶红2星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008040500,4,150,0,4,0,0,0,'[{1,21}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,1,0),(1008040543,'荣誉手套','5阶红3星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008040500,4,150,0,4,0,0,0,'[{1,63}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,1,0),(1008040553,'荣誉手套','5阶粉色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008040500,4,150,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,55452},{4,1386}]','[]',0,0,1,0),(1008040563,'荣誉手套','5阶神装护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008040500,4,150,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,69315},{4,1733}]','[]',0,0,1,0),(1008040600,'贤者手套','6阶绿色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008040600,4,180,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,10828},{4,271}]','[]',0,0,1,0),(1008040610,'贤者手套','6阶蓝色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008040600,4,180,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{2,16241},{4,406}]','[]',0,0,1,0),(1008040620,'贤者手套','6阶紫色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008040600,4,180,0,2,0,0,0,'[{1,5}]',0,0,0,0,'[{2,29559},{4,739}]','[]',0,0,1,0),(1008040631,'贤者手套','6阶橙1星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008040600,4,180,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,36056},{4,901}]','[]',0,0,1,0),(1008040632,'贤者手套','6阶橙2星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008040600,4,180,0,3,0,0,0,'[{1,8}]',0,0,0,0,'[{2,36056},{4,901}]','[]',0,0,1,0),(1008040641,'贤者手套','6阶红1星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008040600,4,180,0,4,0,0,0,'[{1,18}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,1,0),(1008040642,'贤者手套','6阶红2星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008040600,4,180,0,4,0,0,0,'[{1,28}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,1,0),(1008040643,'贤者手套','6阶红3星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008040600,4,180,0,4,0,0,0,'[{1,104}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,1,0),(1008040653,'贤者手套','6阶粉色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008040600,4,180,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,86620},{4,2166}]','[]',0,0,1,0),(1008040663,'贤者手套','6阶神装护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008040600,4,180,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,108276},{4,2707}]','[]',0,0,1,0),(1008040700,'征服手套','7阶绿色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008040700,4,220,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,15744},{4,394}]','[]',0,0,2,0),(1008040710,'征服手套','7阶蓝色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008040700,4,220,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{2,23616},{4,590}]','[]',0,0,2,0),(1008040720,'征服手套','7阶紫色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008040700,4,220,0,2,0,0,0,'[{1,6}]',0,0,0,0,'[{2,42982},{4,1075}]','[]',0,0,2,0),(1008040731,'征服手套','7阶橙1星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008040700,4,220,0,3,0,0,0,'[{1,8}]',0,0,0,0,'[{2,52429},{4,1311}]','[]',0,0,2,0),(1008040732,'征服手套','7阶橙2星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008040700,4,220,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,52429},{4,1311}]','[]',0,0,2,0),(1008040741,'征服手套','7阶红1星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008040700,4,220,0,4,0,0,0,'[{1,25}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,2,0),(1008040742,'征服手套','7阶红2星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008040700,4,220,0,4,0,0,0,'[{1,41}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,2,0),(1008040743,'征服手套','7阶红3星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008040700,4,220,0,4,0,0,0,'[{1,149}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,2,0),(1008040753,'征服手套','7阶粉色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008040700,4,220,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,125955},{4,3149}]','[]',0,0,2,0),(1008040763,'征服手套','7阶神装护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008040700,4,220,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,157443},{4,3936}]','[]',0,0,2,0),(1008040800,'秩序手套','8阶绿色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008040800,4,260,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,21735},{4,543}]','[]',0,0,2,0),(1008040810,'秩序手套','8阶蓝色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008040800,4,260,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,32603},{4,815}]','[]',0,0,2,0),(1008040820,'秩序手套','8阶紫色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008040800,4,260,0,2,0,0,0,'[{1,7}]',0,0,0,0,'[{2,59337},{4,1483}]','[]',0,0,2,0),(1008040831,'秩序手套','8阶橙1星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008040800,4,260,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{2,72378},{4,1809}]','[]',0,0,2,0),(1008040832,'秩序手套','8阶橙2星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008040800,4,260,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{2,72378},{4,1809}]','[]',0,0,2,0),(1008040841,'秩序手套','8阶红1星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008040800,4,260,0,4,0,0,0,'[{1,28}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,2,0),(1008040842,'秩序手套','8阶红2星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008040800,4,260,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,2,0),(1008040843,'秩序手套','8阶红3星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008040800,4,260,0,4,0,0,0,'[{1,208}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,2,0),(1008040853,'秩序手套','8阶粉色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008040800,4,260,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,173881},{4,4347}]','[]',0,0,2,0),(1008040863,'秩序手套','8阶神装护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008040800,4,260,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,217352},{4,5434}]','[]',0,0,2,0),(1008040900,'守护手套','9阶绿色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008040900,4,300,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,28847},{4,721}]','[]',0,0,3,0),(1008040910,'守护手套','9阶蓝色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008040900,4,300,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,43270},{4,1082}]','[]',0,0,3,0),(1008040920,'守护手套','9阶紫色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008040900,4,300,0,2,0,0,0,'[{1,7}]',0,0,0,0,'[{2,78752},{4,1969}]','[]',0,0,3,0),(1008040931,'守护手套','9阶橙1星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008040900,4,300,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,96060},{4,2401}]','[]',0,0,3,0),(1008040932,'守护手套','9阶橙2星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008040900,4,300,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{2,96060},{4,2401}]','[]',0,0,3,0),(1008040941,'守护手套','9阶红1星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008040900,4,300,0,4,0,0,0,'[{1,33}]',0,0,0,0,'[{2,144234},{4,3606}]','[]',0,0,3,0),(1008040942,'守护手套','9阶红2星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008040900,4,300,0,4,0,0,0,'[{1,55}]',0,0,0,0,'[{2,144234},{4,3606}]','[]',0,0,3,0),(1008040943,'守护手套','9阶红3星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008040900,4,300,0,4,0,0,0,'[{1,290}]',0,0,0,0,'[{2,144234},{4,3606}]','[]',0,0,3,0),(1008040953,'守护手套','9阶粉色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008040900,4,300,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,230774},{4,5769}]','[]',0,0,3,0),(1008040963,'守护手套','9阶神装护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008040900,4,300,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,288468},{4,7212}]','[]',0,0,3,0),(1008041000,'信仰手套','10阶绿色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008041000,4,355,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,37139},{4,928}]','[]',0,0,4,0),(1008041010,'信仰手套','10阶蓝色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008041000,4,355,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,55709},{4,1393}]','[]',0,0,4,0),(1008041020,'信仰手套','10阶紫色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008041000,4,355,0,2,0,0,0,'[{1,8}]',0,0,0,0,'[{2,101390},{4,2535}]','[]',0,0,4,0),(1008041031,'信仰手套','10阶橙1星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008041000,4,355,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,123674},{4,3092}]','[]',0,0,4,0),(1008041032,'信仰手套','10阶橙2星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008041000,4,355,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{2,123674},{4,3092}]','[]',0,0,4,0),(1008041041,'信仰手套','10阶红1星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008041000,4,355,0,4,0,0,0,'[{1,40}]',0,0,0,0,'[{2,185696},{4,4642}]','[]',0,0,4,0),(1008041042,'信仰手套','10阶红2星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008041000,4,355,0,4,0,0,0,'[{1,69}]',0,0,0,0,'[{2,185696},{4,4642}]','[]',0,0,4,0),(1008041043,'信仰手套','10阶红3星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008041000,4,355,0,4,0,0,0,'[{1,399}]',0,0,0,0,'[{2,185696},{4,4642}]','[]',0,0,4,0),(1008041053,'信仰手套','10阶粉色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008041000,4,355,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,297114},{4,7428}]','[]',0,0,4,0),(1008041063,'信仰手套','10阶神装护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008041000,4,355,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,371392},{4,9285}]','[]',0,0,4,0),(1008041100,'天行手套','11阶绿色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008041100,4,400,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,46666},{4,1167}]','[]',0,0,4,0),(1008041110,'天行手套','11阶蓝色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008041100,4,400,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,69999},{4,1750}]','[]',0,0,4,0),(1008041120,'天行手套','11阶紫色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008041100,4,400,0,2,0,0,0,'[{1,9}]',0,0,0,0,'[{2,127398},{4,3185}]','[]',0,0,4,0),(1008041131,'天行手套','11阶橙1星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008041100,4,400,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{2,155397},{4,3885}]','[]',0,0,4,0),(1008041132,'天行手套','11阶橙2星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008041100,4,400,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{2,155397},{4,3885}]','[]',0,0,4,0),(1008041141,'天行手套','11阶红1星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008041100,4,400,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{2,233329},{4,5833}]','[]',0,0,4,0),(1008041142,'天行手套','11阶红2星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008041100,4,400,0,4,0,0,0,'[{1,78}]',0,0,0,0,'[{2,233329},{4,5833}]','[]',0,0,4,0),(1008041143,'天行手套','11阶红3星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008041100,4,400,0,4,0,0,0,'[{1,549}]',0,0,0,0,'[{2,233329},{4,5833}]','[]',0,0,4,0),(1008041153,'天行手套','11阶粉色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008041100,4,400,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,373327},{4,9333}]','[]',0,0,4,0),(1008041163,'天行手套','11阶神装护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008041100,4,400,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,466659},{4,11666}]','[]',0,0,4,0),(1008041200,'命运手套','12阶绿色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008041200,4,500,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,57480},{4,1437}]','[]',0,0,5,0),(1008041210,'命运手套','12阶蓝色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008041200,4,500,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,86220},{4,2156}]','[]',0,0,5,0),(1008041220,'命运手套','12阶紫色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008041200,4,500,0,2,0,0,0,'[{1,9}]',0,0,0,0,'[{2,156921},{4,3923}]','[]',0,0,5,0),(1008041231,'命运手套','12阶橙1星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008041200,4,500,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{2,191409},{4,4785}]','[]',0,0,5,0),(1008041232,'命运手套','12阶橙2星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008041200,4,500,0,3,0,0,0,'[{1,15}]',0,0,0,0,'[{2,191409},{4,4785}]','[]',0,0,5,0),(1008041241,'命运手套','12阶红1星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008041200,4,500,0,4,0,0,0,'[{1,62}]',0,0,0,0,'[{2,287400},{4,7185}]','[]',0,0,5,0),(1008041242,'命运手套','12阶红2星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008041200,4,500,0,4,0,0,0,'[{1,110}]',0,0,0,0,'[{2,287400},{4,7185}]','[]',0,0,5,0),(1008041243,'命运手套','12阶红3星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008041200,4,500,0,4,0,0,0,'[{1,799}]',0,0,0,0,'[{2,287400},{4,7185}]','[]',0,0,5,0),(1008041253,'命运手套','12阶粉色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008041200,4,500,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,459841},{4,11496}]','[]',0,0,5,0),(1008041263,'命运手套','12阶神装护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008041200,4,500,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,574801},{4,14370}]','[]',0,0,5,0),(1008041300,'制裁手套','13阶绿色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008041300,4,520,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,69635},{4,1741}]','[]',0,0,5,0),(1008041310,'制裁手套','13阶蓝色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008041300,4,520,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,104453},{4,2611}]','[]',0,0,5,0),(1008041320,'制裁手套','13阶紫色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008041300,4,520,0,2,0,0,0,'[{1,10}]',0,0,0,0,'[{2,190104},{4,4753}]','[]',0,0,5,0),(1008041331,'制裁手套','13阶橙1星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008041300,4,520,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{2,231885},{4,5797}]','[]',0,0,5,0),(1008041332,'制裁手套','13阶橙2星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008041300,4,520,0,3,0,0,0,'[{1,17}]',0,0,0,0,'[{2,231885},{4,5797}]','[]',0,0,5,0),(1008041341,'制裁手套','13阶红1星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008041300,4,520,0,4,0,0,0,'[{1,72}]',0,0,0,0,'[{2,348176},{4,8704}]','[]',0,0,5,0),(1008041342,'制裁手套','13阶红2星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008041300,4,520,0,4,0,0,0,'[{1,128}]',0,0,0,0,'[{2,348176},{4,8704}]','[]',0,0,5,0),(1008041343,'制裁手套','13阶红3星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008041300,4,520,0,4,0,0,0,'[{1,1117}]',0,0,0,0,'[{2,348176},{4,8704}]','[]',0,0,5,0),(1008041353,'制裁手套','13阶粉色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008041300,4,520,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,557082},{4,13927}]','[]',0,0,5,0),(1008041363,'制裁手套','13阶神装护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008041300,4,520,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,696352},{4,17409}]','[]',0,0,5,0),(1008041400,'审判手套','14阶绿色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008041400,4,620,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,83185},{4,2080}]','[]',0,0,6,0),(1008041410,'审判手套','14阶蓝色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008041400,4,620,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{2,124777},{4,3119}]','[]',0,0,6,0),(1008041420,'审判手套','14阶紫色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008041400,4,620,0,2,0,0,0,'[{1,11}]',0,0,0,0,'[{2,227094},{4,5677}]','[]',0,0,6,0),(1008041431,'审判手套','14阶橙1星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008041400,4,620,0,3,0,0,0,'[{1,15}]',0,0,0,0,'[{2,277005},{4,6925}]','[]',0,0,6,0),(1008041432,'审判手套','14阶橙2星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008041400,4,620,0,3,0,0,0,'[{1,19}]',0,0,0,0,'[{2,277005},{4,6925}]','[]',0,0,6,0),(1008041441,'审判手套','14阶红1星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008041400,4,620,0,4,0,0,0,'[{1,82}]',0,0,0,0,'[{2,415923},{4,10398}]','[]',0,0,6,0),(1008041442,'审判手套','14阶红2星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008041400,4,620,0,4,0,0,0,'[{1,146}]',0,0,0,0,'[{2,415923},{4,10398}]','[]',0,0,6,0),(1008041443,'审判手套','14阶红3星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008041400,4,620,0,4,0,0,0,'[{1,1444}]',0,0,0,0,'[{2,415923},{4,10398}]','[]',0,0,6,0),(1008041453,'审判手套','14阶粉色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008041400,4,620,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,665478},{4,16637}]','[]',0,0,6,0),(1008041463,'审判手套','14阶神装护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008041400,4,620,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,831847},{4,20796}]','[]',0,0,6,0),(1008041500,'毁灭手套','15阶绿色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008041500,4,650,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,98182},{4,2455}]','[]',0,0,6,0),(1008041510,'毁灭手套','15阶蓝色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008041500,4,650,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{2,147273},{4,3682}]','[]',0,0,6,0),(1008041520,'毁灭手套','15阶紫色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008041500,4,650,0,2,0,0,0,'[{1,12}]',0,0,0,0,'[{2,268036},{4,6701}]','[]',0,0,6,0),(1008041531,'毁灭手套','15阶橙1星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008041500,4,650,0,3,0,0,0,'[{1,16}]',0,0,0,0,'[{2,326945},{4,8174}]','[]',0,0,6,0),(1008041532,'毁灭手套','15阶橙2星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008041500,4,650,0,3,0,0,0,'[{1,20}]',0,0,0,0,'[{2,326945},{4,8174}]','[]',0,0,6,0),(1008041541,'毁灭手套','15阶红1星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008041500,4,650,0,4,0,0,0,'[{1,92}]',0,0,0,0,'[{2,490909},{4,12273}]','[]',0,0,6,0),(1008041542,'毁灭手套','15阶红2星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008041500,4,650,0,4,0,0,0,'[{1,164}]',0,0,0,0,'[{2,490909},{4,12273}]','[]',0,0,6,0),(1008041543,'毁灭手套','15阶红3星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008041500,4,650,0,4,0,0,0,'[{1,1717}]',0,0,0,0,'[{2,490909},{4,12273}]','[]',0,0,6,0),(1008041553,'毁灭手套','15阶粉色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008041500,4,650,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,785455},{4,19636}]','[]',0,0,6,0),(1008041563,'毁灭手套','15阶神装护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008041500,4,650,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,981818},{4,24545}]','[]',0,0,6,0),(1008041600,'混沌手套','16阶绿色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008041500,4,700,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{2,114680},{4,2867}]','[]',0,0,6,0),(1008041610,'混沌手套','16阶蓝色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008041500,4,700,0,1,0,0,0,'[{1,7}]',0,0,0,0,'[{2,172020},{4,4300}]','[]',0,0,6,0),(1008041620,'混沌手套','16阶紫色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008041500,4,700,0,2,0,0,0,'[{1,14}]',0,0,0,0,'[{2,313076},{4,7827}]','[]',0,0,6,0),(1008041631,'混沌手套','16阶橙1星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008041500,4,700,0,3,0,0,0,'[{1,19}]',0,0,0,0,'[{2,381884},{4,9547}]','[]',0,0,6,0),(1008041632,'混沌手套','16阶橙2星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008041500,4,700,0,3,0,0,0,'[{1,23}]',0,0,0,0,'[{2,381884},{4,9547}]','[]',0,0,6,0),(1008041641,'混沌手套','16阶红1星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008041500,4,700,0,4,0,0,0,'[{1,112}]',0,0,0,0,'[{2,573400},{4,14335}]','[]',0,0,6,0),(1008041642,'混沌手套','16阶红2星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008041500,4,700,0,4,0,0,0,'[{1,200}]',0,0,0,0,'[{2,573400},{4,14335}]','[]',0,0,6,0),(1008041643,'混沌手套','16阶红3星护腕【重炮手】','',0,'','',0,1,1,10,8,1,2,8,1008041500,4,700,0,4,0,0,0,'[{1,2044}]',0,0,0,0,'[{2,573400},{4,14335}]','[]',0,0,6,0),(1008041653,'混沌手套','16阶粉色护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008041500,4,700,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,917440},{4,22936}]','[]',0,0,6,0),(1008041663,'混沌手套','16阶神装护腕【重炮手】','',0,'','',0,0,1,10,8,0,0,8,1008041500,4,700,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,1146800},{4,28670}]','[]',0,0,6,0),(1009000100,'学徒之戒','1阶绿色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009000100,0,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,15},{3,7}]','[]',0,0,0,0),(1009000110,'学徒之戒','1阶蓝色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009000100,0,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{1,22},{3,11}]','[]',0,0,0,0),(1009000120,'学徒之戒','1阶紫色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009000100,0,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{1,41},{3,20}]','[]',0,0,0,0),(1009000131,'学徒之戒','1阶橙1星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009000100,0,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{1,50},{3,25}]','[]',0,0,0,0),(1009000132,'学徒之戒','1阶橙2星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009000100,0,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{1,50},{3,25}]','[]',0,0,0,0),(1009000141,'学徒之戒','1阶红1星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009000100,0,1,0,4,0,0,0,'[{1,1}]',0,0,0,0,'[{1,74},{3,37}]','[]',0,0,0,0),(1009000142,'学徒之戒','1阶红2星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009000100,0,1,0,4,0,0,0,'[{1,1}]',0,0,0,0,'[{1,74},{3,37}]','[]',0,0,0,0),(1009000143,'学徒之戒','1阶红3星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009000100,0,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{1,74},{3,37}]','[]',0,0,0,0),(1009000153,'学徒之戒','1阶粉色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009000100,0,1,0,5,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,119},{3,60}]','[]',0,0,0,0),(1009000163,'学徒之戒','1阶神装戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009000100,0,1,0,6,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,149},{3,74}]','[]',0,0,0,0),(1009000200,'冒险之戒','2阶绿色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009000200,0,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,25},{3,13}]','[]',0,0,0,0),(1009000210,'冒险之戒','2阶蓝色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009000200,0,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{1,38},{3,19}]','[]',0,0,0,0),(1009000220,'冒险之戒','2阶紫色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009000200,0,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{1,70},{3,35}]','[]',0,0,0,0),(1009000231,'冒险之戒','2阶橙1星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009000200,0,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{1,85},{3,42}]','[]',0,0,0,0),(1009000232,'冒险之戒','2阶橙2星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009000200,0,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{1,85},{3,42}]','[]',0,0,0,0),(1009000241,'冒险之戒','2阶红1星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009000200,0,1,0,4,0,0,0,'[{1,1}]',0,0,0,0,'[{1,127},{3,64}]','[]',0,0,0,0),(1009000242,'冒险之戒','2阶红2星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009000200,0,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{1,127},{3,64}]','[]',0,0,0,0),(1009000243,'冒险之戒','2阶红3星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009000200,0,1,0,4,0,0,0,'[{1,5}]',0,0,0,0,'[{1,127},{3,64}]','[]',0,0,0,0),(1009000253,'冒险之戒','2阶粉色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009000200,0,1,0,5,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,204},{3,102}]','[]',0,0,0,0),(1009000263,'冒险之戒','2阶神装戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009000200,0,1,0,6,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,255},{3,127}]','[]',0,0,0,0),(1009000300,'勇者之戒','3阶绿色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009000300,0,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,61},{3,30}]','[]',0,0,0,0),(1009000310,'勇者之戒','3阶蓝色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009000300,0,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{1,91},{3,46}]','[]',0,0,0,0),(1009000320,'勇者之戒','3阶紫色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009000300,0,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{1,166},{3,83}]','[]',0,0,0,0),(1009000331,'勇者之戒','3阶橙1星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009000300,0,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{1,202},{3,101}]','[]',0,0,0,0),(1009000332,'勇者之戒','3阶橙2星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009000300,0,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{1,202},{3,101}]','[]',0,0,0,0),(1009000341,'勇者之戒','3阶红1星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009000300,0,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{1,304},{3,152}]','[]',0,0,0,0),(1009000342,'勇者之戒','3阶红2星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009000300,0,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{1,304},{3,152}]','[]',0,0,0,0),(1009000343,'勇者之戒','3阶红3星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009000300,0,1,0,4,0,0,0,'[{1,8}]',0,0,0,0,'[{1,304},{3,152}]','[]',0,0,0,0),(1009000353,'勇者之戒','3阶粉色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009000300,0,1,0,5,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,486},{3,243}]','[]',0,0,0,0),(1009000363,'勇者之戒','3阶神装戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009000300,0,1,0,6,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,607},{3,304}]','[]',0,0,0,0),(1009000400,'先驱之戒','4阶绿色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009000400,0,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,122},{3,61}]','[]',0,0,0,0),(1009000410,'先驱之戒','4阶蓝色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009000400,0,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{1,183},{3,92}]','[]',0,0,0,0),(1009000420,'先驱之戒','4阶紫色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009000400,0,1,0,2,0,0,0,'[{1,2}]',0,0,0,0,'[{1,334},{3,167}]','[]',0,0,0,0),(1009000431,'先驱之戒','4阶橙1星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009000400,0,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{1,407},{3,204}]','[]',0,0,0,0),(1009000432,'先驱之戒','4阶橙2星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009000400,0,1,0,3,0,0,0,'[{1,3}]',0,0,0,0,'[{1,407},{3,204}]','[]',0,0,0,0),(1009000441,'先驱之戒','4阶红1星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009000400,0,1,0,4,0,0,0,'[{1,5}]',0,0,0,0,'[{1,612},{3,306}]','[]',0,0,0,0),(1009000442,'先驱之戒','4阶红2星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009000400,0,1,0,4,0,0,0,'[{1,7}]',0,0,0,0,'[{1,612},{3,306}]','[]',0,0,0,0),(1009000443,'先驱之戒','4阶红3星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009000400,0,1,0,4,0,0,0,'[{1,21}]',0,0,0,0,'[{1,612},{3,306}]','[]',0,0,0,0),(1009000453,'先驱之戒','4阶粉色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009000400,0,1,0,5,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,978},{3,489}]','[]',0,0,0,0),(1009000463,'先驱之戒','4阶神装戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009000400,0,1,0,6,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,1223},{3,612}]','[]',0,0,0,0),(1009000500,'荣誉之戒','5阶绿色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009000500,0,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,212},{3,106}]','[]',0,0,0,0),(1009000510,'荣誉之戒','5阶蓝色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009000500,0,1,0,1,0,0,0,'[{1,2}]',0,0,0,0,'[{1,318},{3,159}]','[]',0,0,0,0),(1009000520,'荣誉之戒','5阶紫色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009000500,0,1,0,2,0,0,0,'[{1,3}]',0,0,0,0,'[{1,578},{3,289}]','[]',0,0,0,0),(1009000531,'荣誉之戒','5阶橙1星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009000500,0,1,0,3,0,0,0,'[{1,4}]',0,0,0,0,'[{1,705},{3,353}]','[]',0,0,0,0),(1009000532,'荣誉之戒','5阶橙2星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009000500,0,1,0,3,0,0,0,'[{1,5}]',0,0,0,0,'[{1,705},{3,353}]','[]',0,0,0,0),(1009000541,'荣誉之戒','5阶红1星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009000500,0,1,0,4,0,0,0,'[{1,9}]',0,0,0,0,'[{1,1059},{3,529}]','[]',0,0,0,0),(1009000542,'荣誉之戒','5阶红2星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009000500,0,1,0,4,0,0,0,'[{1,13}]',0,0,0,0,'[{1,1059},{3,529}]','[]',0,0,0,0),(1009000543,'荣誉之戒','5阶红3星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009000500,0,1,0,4,0,0,0,'[{1,39}]',0,0,0,0,'[{1,1059},{3,529}]','[]',0,0,0,0),(1009000553,'荣誉之戒','5阶粉色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009000500,0,1,0,5,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,1694},{3,847}]','[]',0,0,0,0),(1009000563,'荣誉之戒','5阶神装戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009000500,0,1,0,6,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,2118},{3,1059}]','[]',0,0,0,0),(1009000600,'贤者之戒','6阶绿色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009000600,0,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,331},{3,165}]','[]',0,0,0,0),(1009000610,'贤者之戒','6阶蓝色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009000600,0,1,0,1,0,0,0,'[{1,2}]',0,0,0,0,'[{1,496},{3,248}]','[]',0,0,0,0),(1009000620,'贤者之戒','6阶紫色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009000600,0,1,0,2,0,0,0,'[{1,3}]',0,0,0,0,'[{1,903},{3,452}]','[]',0,0,0,0),(1009000631,'贤者之戒','6阶橙1星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009000600,0,1,0,3,0,0,0,'[{1,4}]',0,0,0,0,'[{1,1102},{3,551}]','[]',0,0,0,0),(1009000632,'贤者之戒','6阶橙2星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009000600,0,1,0,3,0,0,0,'[{1,5}]',0,0,0,0,'[{1,1102},{3,551}]','[]',0,0,0,0),(1009000641,'贤者之戒','6阶红1星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009000600,0,1,0,4,0,0,0,'[{1,11}]',0,0,0,0,'[{1,1654},{3,827}]','[]',0,0,0,0),(1009000642,'贤者之戒','6阶红2星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009000600,0,1,0,4,0,0,0,'[{1,17}]',0,0,0,0,'[{1,1654},{3,827}]','[]',0,0,0,0),(1009000643,'贤者之戒','6阶红3星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009000600,0,1,0,4,0,0,0,'[{1,64}]',0,0,0,0,'[{1,1654},{3,827}]','[]',0,0,0,0),(1009000653,'贤者之戒','6阶粉色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009000600,0,1,0,5,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,2647},{3,1323}]','[]',0,0,0,0),(1009000663,'贤者之戒','6阶神装戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009000600,0,1,0,6,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,3308},{3,1654}]','[]',0,0,0,0),(1009000700,'征服之戒','7阶绿色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009000700,0,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,481},{3,241}]','[]',0,0,0,0),(1009000710,'征服之戒','7阶蓝色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009000700,0,1,0,1,0,0,0,'[{1,2}]',0,0,0,0,'[{1,722},{3,361}]','[]',0,0,0,0),(1009000720,'征服之戒','7阶紫色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009000700,0,1,0,2,0,0,0,'[{1,4}]',0,0,0,0,'[{1,1313},{3,657}]','[]',0,0,0,0),(1009000731,'征服之戒','7阶橙1星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009000700,0,1,0,3,0,0,0,'[{1,5}]',0,0,0,0,'[{1,1602},{3,801}]','[]',0,0,0,0),(1009000732,'征服之戒','7阶橙2星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009000700,0,1,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{1,1602},{3,801}]','[]',0,0,0,0),(1009000741,'征服之戒','7阶红1星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009000700,0,1,0,4,0,0,0,'[{1,16}]',0,0,0,0,'[{1,2405},{3,1203}]','[]',0,0,0,0),(1009000742,'征服之戒','7阶红2星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009000700,0,1,0,4,0,0,0,'[{1,25}]',0,0,0,0,'[{1,2405},{3,1203}]','[]',0,0,0,0),(1009000743,'征服之戒','7阶红3星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009000700,0,1,0,4,0,0,0,'[{1,91}]',0,0,0,0,'[{1,2405},{3,1203}]','[]',0,0,0,0),(1009000753,'征服之戒','7阶粉色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009000700,0,1,0,5,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,3849},{3,1924}]','[]',0,0,0,0),(1009000763,'征服之戒','7阶神装戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009000700,0,1,0,6,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,4811},{3,2405}]','[]',0,0,0,0),(1009000800,'秩序之戒','8阶绿色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009000800,0,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,664},{3,332}]','[]',0,0,0,0),(1009000810,'秩序之戒','8阶蓝色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009000800,0,1,0,1,0,0,0,'[{1,2}]',0,0,0,0,'[{1,996},{3,498}]','[]',0,0,0,0),(1009000820,'秩序之戒','8阶紫色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009000800,0,1,0,2,0,0,0,'[{1,4}]',0,0,0,0,'[{1,1813},{3,907}]','[]',0,0,0,0),(1009000831,'秩序之戒','8阶橙1星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009000800,0,1,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{1,2212},{3,1106}]','[]',0,0,0,0),(1009000832,'秩序之戒','8阶橙2星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009000800,0,1,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{1,2212},{3,1106}]','[]',0,0,0,0),(1009000841,'秩序之戒','8阶红1星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009000800,0,1,0,4,0,0,0,'[{1,18}]',0,0,0,0,'[{1,3321},{3,1660}]','[]',0,0,0,0),(1009000842,'秩序之戒','8阶红2星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009000800,0,1,0,4,0,0,0,'[{1,28}]',0,0,0,0,'[{1,3321},{3,1660}]','[]',0,0,0,0),(1009000843,'秩序之戒','8阶红3星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009000800,0,1,0,4,0,0,0,'[{1,127}]',0,0,0,0,'[{1,3321},{3,1660}]','[]',0,0,0,0),(1009000853,'秩序之戒','8阶粉色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009000800,0,1,0,5,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,5313},{3,2657}]','[]',0,0,0,0),(1009000863,'秩序之戒','8阶神装戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009000800,0,1,0,6,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,6641},{3,3321}]','[]',0,0,0,0),(1009000900,'守护之戒','9阶绿色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009000900,0,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,881},{3,441}]','[]',0,0,0,0),(1009000910,'守护之戒','9阶蓝色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009000900,0,1,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{1,1322},{3,661}]','[]',0,0,0,0),(1009000920,'守护之戒','9阶紫色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009000900,0,1,0,2,0,0,0,'[{1,5}]',0,0,0,0,'[{1,2406},{3,1203}]','[]',0,0,0,0),(1009000931,'守护之戒','9阶橙1星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009000900,0,1,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{1,2935},{3,1468}]','[]',0,0,0,0),(1009000932,'守护之戒','9阶橙2星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009000900,0,1,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{1,2935},{3,1468}]','[]',0,0,0,0),(1009000941,'守护之戒','9阶红1星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009000900,0,1,0,4,0,0,0,'[{1,21}]',0,0,0,0,'[{1,4407},{3,2204}]','[]',0,0,0,0),(1009000942,'守护之戒','9阶红2星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009000900,0,1,0,4,0,0,0,'[{1,34}]',0,0,0,0,'[{1,4407},{3,2204}]','[]',0,0,0,0),(1009000943,'守护之戒','9阶红3星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009000900,0,1,0,4,0,0,0,'[{1,177}]',0,0,0,0,'[{1,4407},{3,2204}]','[]',0,0,0,0),(1009000953,'守护之戒','9阶粉色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009000900,0,1,0,5,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,7051},{3,3526}]','[]',0,0,0,0),(1009000963,'守护之戒','9阶神装戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009000900,0,1,0,6,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,8814},{3,4407}]','[]',0,0,0,0),(1009001000,'信仰之戒','10阶绿色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009001000,0,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,1135},{3,567}]','[]',0,0,0,0),(1009001010,'信仰之戒','10阶蓝色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009001000,0,1,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{1,1702},{3,851}]','[]',0,0,0,0),(1009001020,'信仰之戒','10阶紫色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009001000,0,1,0,2,0,0,0,'[{1,5}]',0,0,0,0,'[{1,3098},{3,1549}]','[]',0,0,0,0),(1009001031,'信仰之戒','10阶橙1星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009001000,0,1,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{1,3779},{3,1889}]','[]',0,0,0,0),(1009001032,'信仰之戒','10阶橙2星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009001000,0,1,0,3,0,0,0,'[{1,8}]',0,0,0,0,'[{1,3779},{3,1889}]','[]',0,0,0,0),(1009001041,'信仰之戒','10阶红1星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009001000,0,1,0,4,0,0,0,'[{1,25}]',0,0,0,0,'[{1,5674},{3,2837}]','[]',0,0,0,0),(1009001042,'信仰之戒','10阶红2星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009001000,0,1,0,4,0,0,0,'[{1,42}]',0,0,0,0,'[{1,5674},{3,2837}]','[]',0,0,0,0),(1009001043,'信仰之戒','10阶红3星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009001000,0,1,0,4,0,0,0,'[{1,244}]',0,0,0,0,'[{1,5674},{3,2837}]','[]',0,0,0,0),(1009001053,'信仰之戒','10阶粉色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009001000,0,1,0,5,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,9078},{3,4539}]','[]',0,0,0,0),(1009001063,'信仰之戒','10阶神装戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009001000,0,1,0,6,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,11348},{3,5674}]','[]',0,0,0,0),(1009001100,'天行之戒','11阶绿色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009001100,0,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,1426},{3,713}]','[]',0,0,0,0),(1009001110,'天行之戒','11阶蓝色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009001100,0,1,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{1,2139},{3,1069}]','[]',0,0,0,0),(1009001120,'天行之戒','11阶紫色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009001100,0,1,0,2,0,0,0,'[{1,5}]',0,0,0,0,'[{1,3893},{3,1946}]','[]',0,0,0,0),(1009001131,'天行之戒','11阶橙1星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009001100,0,1,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{1,4748},{3,2374}]','[]',0,0,0,0),(1009001132,'天行之戒','11阶橙2星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009001100,0,1,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{1,4748},{3,2374}]','[]',0,0,0,0),(1009001141,'天行之戒','11阶红1星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009001100,0,1,0,4,0,0,0,'[{1,28}]',0,0,0,0,'[{1,7130},{3,3565}]','[]',0,0,0,0),(1009001142,'天行之戒','11阶红2星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009001100,0,1,0,4,0,0,0,'[{1,48}]',0,0,0,0,'[{1,7130},{3,3565}]','[]',0,0,0,0),(1009001143,'天行之戒','11阶红3星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009001100,0,1,0,4,0,0,0,'[{1,335}]',0,0,0,0,'[{1,7130},{3,3565}]','[]',0,0,0,0),(1009001153,'天行之戒','11阶粉色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009001100,0,1,0,5,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,11407},{3,5704}]','[]',0,0,0,0),(1009001163,'天行之戒','11阶神装戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009001100,0,1,0,6,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,14259},{3,7130}]','[]',0,0,0,0),(1009001200,'命运之戒','12阶绿色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009001200,0,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,1756},{3,878}]','[]',0,0,0,0),(1009001210,'命运之戒','12阶蓝色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009001200,0,1,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{1,2635},{3,1317}]','[]',0,0,0,0),(1009001220,'命运之戒','12阶紫色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009001200,0,1,0,2,0,0,0,'[{1,6}]',0,0,0,0,'[{1,4795},{3,2397}]','[]',0,0,0,0),(1009001231,'命运之戒','12阶橙1星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009001200,0,1,0,3,0,0,0,'[{1,8}]',0,0,0,0,'[{1,5849},{3,2924}]','[]',0,0,0,0),(1009001232,'命运之戒','12阶橙2星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009001200,0,1,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{1,5849},{3,2924}]','[]',0,0,0,0),(1009001241,'命运之戒','12阶红1星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009001200,0,1,0,4,0,0,0,'[{1,38}]',0,0,0,0,'[{1,8782},{3,4391}]','[]',0,0,0,0),(1009001242,'命运之戒','12阶红2星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009001200,0,1,0,4,0,0,0,'[{1,67}]',0,0,0,0,'[{1,8782},{3,4391}]','[]',0,0,0,0),(1009001243,'命运之戒','12阶红3星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009001200,0,1,0,4,0,0,0,'[{1,488}]',0,0,0,0,'[{1,8782},{3,4391}]','[]',0,0,0,0),(1009001253,'命运之戒','12阶粉色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009001200,0,1,0,5,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,14051},{3,7025}]','[]',0,0,0,0),(1009001263,'命运之戒','12阶神装戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009001200,0,1,0,6,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,17563},{3,8782}]','[]',0,0,0,0),(1009001300,'制裁之戒','13阶绿色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009001300,0,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{1,2128},{3,1064}]','[]',0,0,0,0),(1009001310,'制裁之戒','13阶蓝色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009001300,0,1,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{1,3192},{3,1596}]','[]',0,0,0,0),(1009001320,'制裁之戒','13阶紫色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009001300,0,1,0,2,0,0,0,'[{1,6}]',0,0,0,0,'[{1,5809},{3,2904}]','[]',0,0,0,0),(1009001331,'制裁之戒','13阶橙1星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009001300,0,1,0,3,0,0,0,'[{1,8}]',0,0,0,0,'[{1,7085},{3,3543}]','[]',0,0,0,0),(1009001332,'制裁之戒','13阶橙2星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009001300,0,1,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{1,7085},{3,3543}]','[]',0,0,0,0),(1009001341,'制裁之戒','13阶红1星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009001300,0,1,0,4,0,0,0,'[{1,44}]',0,0,0,0,'[{1,10639},{3,5319}]','[]',0,0,0,0),(1009001342,'制裁之戒','13阶红2星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009001300,0,1,0,4,0,0,0,'[{1,78}]',0,0,0,0,'[{1,10639},{3,5319}]','[]',0,0,0,0),(1009001343,'制裁之戒','13阶红3星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009001300,0,1,0,4,0,0,0,'[{1,683}]',0,0,0,0,'[{1,10639},{3,5319}]','[]',0,0,0,0),(1009001353,'制裁之戒','13阶粉色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009001300,0,1,0,5,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,17022},{3,8511}]','[]',0,0,0,0),(1009001363,'制裁之戒','13阶神装戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009001300,0,1,0,6,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,21277},{3,10639}]','[]',0,0,0,0),(1009001400,'审判之戒','14阶绿色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009001400,0,1,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,2542},{3,1271}]','[]',0,0,0,0),(1009001410,'审判之戒','14阶蓝色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009001400,0,1,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{1,3813},{3,1906}]','[]',0,0,0,0),(1009001420,'审判之戒','14阶紫色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009001400,0,1,0,2,0,0,0,'[{1,7}]',0,0,0,0,'[{1,6939},{3,3469}]','[]',0,0,0,0),(1009001431,'审判之戒','14阶橙1星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009001400,0,1,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{1,8464},{3,4232}]','[]',0,0,0,0),(1009001432,'审判之戒','14阶橙2星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009001400,0,1,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{1,8464},{3,4232}]','[]',0,0,0,0),(1009001441,'审判之戒','14阶红1星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009001400,0,1,0,4,0,0,0,'[{1,50}]',0,0,0,0,'[{1,12709},{3,6354}]','[]',0,0,0,0),(1009001442,'审判之戒','14阶红2星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009001400,0,1,0,4,0,0,0,'[{1,89}]',0,0,0,0,'[{1,12709},{3,6354}]','[]',0,0,0,0),(1009001443,'审判之戒','14阶红3星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009001400,0,1,0,4,0,0,0,'[{1,883}]',0,0,0,0,'[{1,12709},{3,6354}]','[]',0,0,0,0),(1009001453,'审判之戒','14阶粉色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009001400,0,1,0,5,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,20334},{3,10167}]','[]',0,0,0,0),(1009001463,'审判之戒','14阶神装戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009001400,0,1,0,6,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,25418},{3,12709}]','[]',0,0,0,0),(1009001500,'毁灭之戒','15阶绿色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009001500,0,1,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,3000},{3,1500}]','[]',0,0,0,0),(1009001510,'毁灭之戒','15阶蓝色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009001500,0,1,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{1,4500},{3,2250}]','[]',0,0,0,0),(1009001520,'毁灭之戒','15阶紫色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009001500,0,1,0,2,0,0,0,'[{1,8}]',0,0,0,0,'[{1,8190},{3,4095}]','[]',0,0,0,0),(1009001531,'毁灭之戒','15阶橙1星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009001500,0,1,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{1,9990},{3,4995}]','[]',0,0,0,0),(1009001532,'毁灭之戒','15阶橙2星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009001500,0,1,0,3,0,0,0,'[{1,13}]',0,0,0,0,'[{1,9990},{3,4995}]','[]',0,0,0,0),(1009001541,'毁灭之戒','15阶红1星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009001500,0,1,0,4,0,0,0,'[{1,57}]',0,0,0,0,'[{1,15000},{3,7500}]','[]',0,0,0,0),(1009001542,'毁灭之戒','15阶红2星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009001500,0,1,0,4,0,0,0,'[{1,100}]',0,0,0,0,'[{1,15000},{3,7500}]','[]',0,0,0,0),(1009001543,'毁灭之戒','15阶红3星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009001500,0,1,0,4,0,0,0,'[{1,1049}]',0,0,0,0,'[{1,15000},{3,7500}]','[]',0,0,0,0),(1009001553,'毁灭之戒','15阶粉色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009001500,0,1,0,5,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,24000},{3,12000}]','[]',0,0,0,0),(1009001563,'毁灭之戒','15阶神装戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009001500,0,1,0,6,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,30000},{3,15000}]','[]',0,0,0,0),(1009001600,'混沌之戒','16阶绿色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009001500,0,1,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{1,3504},{3,1752}]','[]',0,0,0,0),(1009001610,'混沌之戒','16阶蓝色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009001500,0,1,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{1,5256},{3,2628}]','[]',0,0,0,0),(1009001620,'混沌之戒','16阶紫色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009001500,0,1,0,2,0,0,0,'[{1,9}]',0,0,0,0,'[{1,9566},{3,4783}]','[]',0,0,0,0),(1009001631,'混沌之戒','16阶橙1星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009001500,0,1,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{1,11669},{3,5834}]','[]',0,0,0,0),(1009001632,'混沌之戒','16阶橙2星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009001500,0,1,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{1,11669},{3,5834}]','[]',0,0,0,0),(1009001641,'混沌之戒','16阶红1星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009001500,0,1,0,4,0,0,0,'[{1,69}]',0,0,0,0,'[{1,17521},{3,8760}]','[]',0,0,0,0),(1009001642,'混沌之戒','16阶红2星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009001500,0,1,0,4,0,0,0,'[{1,123}]',0,0,0,0,'[{1,17521},{3,8760}]','[]',0,0,0,0),(1009001643,'混沌之戒','16阶红3星戒指【通用】','',0,'','',0,1,1,10,9,1,3,9,1009001500,0,1,0,4,0,0,0,'[{1,1249}]',0,0,0,0,'[{1,17521},{3,8760}]','[]',0,0,0,0),(1009001653,'混沌之戒','16阶粉色戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009001500,0,1,0,5,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,28033},{3,14016}]','[]',0,0,0,0),(1009001663,'混沌之戒','16阶神装戒指【通用】','',0,'','',0,0,1,10,9,0,0,9,1009001500,0,1,0,6,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,35041},{3,17521}]','[]',0,0,0,0),(1010010100,'学徒战靴','1阶绿色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010010100,1,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,487},{4,12}]','[]',0,0,0,0),(1010010110,'学徒战靴','1阶蓝色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010010100,1,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,731},{4,18}]','[]',0,0,0,0),(1010010120,'学徒战靴','1阶紫色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010010100,1,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1330},{4,33}]','[]',0,0,0,0),(1010010131,'学徒战靴','1阶橙1星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010010100,1,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1622},{4,41}]','[]',0,0,0,0),(1010010132,'学徒战靴','1阶橙2星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010010100,1,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1622},{4,41}]','[]',0,0,0,0),(1010010141,'学徒战靴','1阶红1星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010010100,1,1,0,4,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2435},{4,61}]','[]',0,0,0,0),(1010010142,'学徒战靴','1阶红2星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010010100,1,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{2,2435},{4,61}]','[]',0,0,0,0),(1010010143,'学徒战靴','1阶红3星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010010100,1,1,0,4,0,0,0,'[{1,5}]',0,0,0,0,'[{2,2435},{4,61}]','[]',0,0,0,0),(1010010153,'学徒战靴','1阶粉色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010010100,1,1,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,3896},{4,97}]','[]',0,0,0,0),(1010010163,'学徒战靴','1阶神装鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010010100,1,1,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,4870},{4,122}]','[]',0,0,0,0),(1010010200,'冒险战靴','2阶绿色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010010200,1,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,834},{4,21}]','[]',0,0,0,0),(1010010210,'冒险战靴','2阶蓝色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010010200,1,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1251},{4,31}]','[]',0,0,0,0),(1010010220,'冒险战靴','2阶紫色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010010200,1,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2277},{4,57}]','[]',0,0,0,0),(1010010231,'冒险战靴','2阶橙1星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010010200,1,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2777},{4,69}]','[]',0,0,0,0),(1010010232,'冒险战靴','2阶橙2星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010010200,1,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2777},{4,69}]','[]',0,0,0,0),(1010010241,'冒险战靴','2阶红1星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010010200,1,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{2,4170},{4,104}]','[]',0,0,0,0),(1010010242,'冒险战靴','2阶红2星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010010200,1,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{2,4170},{4,104}]','[]',0,0,0,0),(1010010243,'冒险战靴','2阶红3星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010010200,1,1,0,4,0,0,0,'[{1,8}]',0,0,0,0,'[{2,4170},{4,104}]','[]',0,0,0,0),(1010010253,'冒险战靴','2阶粉色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010010200,1,1,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,6671},{4,167}]','[]',0,0,0,0),(1010010263,'冒险战靴','2阶神装鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010010200,1,1,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,8339},{4,208}]','[]',0,0,0,0),(1010010300,'勇者战靴','3阶绿色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010010300,1,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1988},{4,50}]','[]',0,0,0,0),(1010010310,'勇者战靴','3阶蓝色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010010300,1,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2982},{4,75}]','[]',0,0,0,0),(1010010320,'勇者战靴','3阶紫色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010010300,1,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,5427},{4,136}]','[]',0,0,0,0),(1010010331,'勇者战靴','3阶橙1星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010010300,1,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6620},{4,166}]','[]',0,0,0,0),(1010010332,'勇者战靴','3阶橙2星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010010300,1,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6620},{4,166}]','[]',0,0,0,0),(1010010341,'勇者战靴','3阶红1星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010010300,1,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{2,9940},{4,249}]','[]',0,0,0,0),(1010010342,'勇者战靴','3阶红2星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010010300,1,1,0,4,0,0,0,'[{1,4}]',0,0,0,0,'[{2,9940},{4,249}]','[]',0,0,0,0),(1010010343,'勇者战靴','3阶红3星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010010300,1,1,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,9940},{4,249}]','[]',0,0,0,0),(1010010353,'勇者战靴','3阶粉色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010010300,1,1,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,15904},{4,398}]','[]',0,0,0,0),(1010010363,'勇者战靴','3阶神装鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010010300,1,1,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,19881},{4,497}]','[]',0,0,0,0),(1010010400,'先驱战靴','4阶绿色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010010400,1,100,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,4003},{4,100}]','[]',0,0,0,0),(1010010410,'先驱战靴','4阶蓝色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010010400,1,100,0,1,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6004},{4,150}]','[]',0,0,0,0),(1010010420,'先驱战靴','4阶紫色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010010400,1,100,0,2,0,0,0,'[{1,3}]',0,0,0,0,'[{2,10928},{4,273}]','[]',0,0,0,0),(1010010431,'先驱战靴','4阶橙1星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010010400,1,100,0,3,0,0,0,'[{1,3}]',0,0,0,0,'[{2,13329},{4,333}]','[]',0,0,0,0),(1010010432,'先驱战靴','4阶橙2星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010010400,1,100,0,3,0,0,0,'[{1,4}]',0,0,0,0,'[{2,13329},{4,333}]','[]',0,0,0,0),(1010010441,'先驱战靴','4阶红1星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010010400,1,100,0,4,0,0,0,'[{1,8}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1010010442,'先驱战靴','4阶红2星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010010400,1,100,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1010010443,'先驱战靴','4阶红3星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010010400,1,100,0,4,0,0,0,'[{1,34}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1010010453,'先驱战靴','4阶粉色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010010400,1,100,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,32022},{4,801}]','[]',0,0,0,0),(1010010463,'先驱战靴','4阶神装鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010010400,1,100,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,40028},{4,1001}]','[]',0,0,0,0),(1010010500,'荣誉战靴','5阶绿色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010010500,1,150,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,6932},{4,173}]','[]',0,0,1,0),(1010010510,'荣誉战靴','5阶蓝色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010010500,1,150,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{2,10397},{4,260}]','[]',0,0,1,0),(1010010520,'荣誉战靴','5阶紫色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010010500,1,150,0,2,0,0,0,'[{1,5}]',0,0,0,0,'[{2,18923},{4,473}]','[]',0,0,1,0),(1010010531,'荣誉战靴','5阶橙1星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010010500,1,150,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,1,0),(1010010532,'荣誉战靴','5阶橙2星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010010500,1,150,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,1,0),(1010010541,'荣誉战靴','5阶红1星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010010500,1,150,0,4,0,0,0,'[{1,14}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,1,0),(1010010542,'荣誉战靴','5阶红2星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010010500,1,150,0,4,0,0,0,'[{1,21}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,1,0),(1010010543,'荣誉战靴','5阶红3星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010010500,1,150,0,4,0,0,0,'[{1,63}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,1,0),(1010010553,'荣誉战靴','5阶粉色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010010500,1,150,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,55452},{4,1386}]','[]',0,0,1,0),(1010010563,'荣誉战靴','5阶神装鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010010500,1,150,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,69315},{4,1733}]','[]',0,0,1,0),(1010010600,'贤者战靴','6阶绿色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010010600,1,180,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,10828},{4,271}]','[]',0,0,1,0),(1010010610,'贤者战靴','6阶蓝色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010010600,1,180,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{2,16241},{4,406}]','[]',0,0,1,0),(1010010620,'贤者战靴','6阶紫色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010010600,1,180,0,2,0,0,0,'[{1,5}]',0,0,0,0,'[{2,29559},{4,739}]','[]',0,0,1,0),(1010010631,'贤者战靴','6阶橙1星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010010600,1,180,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,36056},{4,901}]','[]',0,0,1,0),(1010010632,'贤者战靴','6阶橙2星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010010600,1,180,0,3,0,0,0,'[{1,8}]',0,0,0,0,'[{2,36056},{4,901}]','[]',0,0,1,0),(1010010641,'贤者战靴','6阶红1星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010010600,1,180,0,4,0,0,0,'[{1,18}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,1,0),(1010010642,'贤者战靴','6阶红2星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010010600,1,180,0,4,0,0,0,'[{1,28}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,1,0),(1010010643,'贤者战靴','6阶红3星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010010600,1,180,0,4,0,0,0,'[{1,104}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,1,0),(1010010653,'贤者战靴','6阶粉色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010010600,1,180,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,86620},{4,2166}]','[]',0,0,1,0),(1010010663,'贤者战靴','6阶神装鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010010600,1,180,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,108276},{4,2707}]','[]',0,0,1,0),(1010010700,'征服战靴','7阶绿色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010010700,1,220,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,15744},{4,394}]','[]',0,0,2,0),(1010010710,'征服战靴','7阶蓝色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010010700,1,220,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{2,23616},{4,590}]','[]',0,0,2,0),(1010010720,'征服战靴','7阶紫色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010010700,1,220,0,2,0,0,0,'[{1,6}]',0,0,0,0,'[{2,42982},{4,1075}]','[]',0,0,2,0),(1010010731,'征服战靴','7阶橙1星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010010700,1,220,0,3,0,0,0,'[{1,8}]',0,0,0,0,'[{2,52429},{4,1311}]','[]',0,0,2,0),(1010010732,'征服战靴','7阶橙2星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010010700,1,220,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,52429},{4,1311}]','[]',0,0,2,0),(1010010741,'征服战靴','7阶红1星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010010700,1,220,0,4,0,0,0,'[{1,25}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,2,0),(1010010742,'征服战靴','7阶红2星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010010700,1,220,0,4,0,0,0,'[{1,41}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,2,0),(1010010743,'征服战靴','7阶红3星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010010700,1,220,0,4,0,0,0,'[{1,149}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,2,0),(1010010753,'征服战靴','7阶粉色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010010700,1,220,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,125955},{4,3149}]','[]',0,0,2,0),(1010010763,'征服战靴','7阶神装鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010010700,1,220,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,157443},{4,3936}]','[]',0,0,2,0),(1010010800,'秩序战靴','8阶绿色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010010800,1,260,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,21735},{4,543}]','[]',0,0,2,0),(1010010810,'秩序战靴','8阶蓝色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010010800,1,260,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,32603},{4,815}]','[]',0,0,2,0),(1010010820,'秩序战靴','8阶紫色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010010800,1,260,0,2,0,0,0,'[{1,7}]',0,0,0,0,'[{2,59337},{4,1483}]','[]',0,0,2,0),(1010010831,'秩序战靴','8阶橙1星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010010800,1,260,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{2,72378},{4,1809}]','[]',0,0,2,0),(1010010832,'秩序战靴','8阶橙2星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010010800,1,260,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{2,72378},{4,1809}]','[]',0,0,2,0),(1010010841,'秩序战靴','8阶红1星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010010800,1,260,0,4,0,0,0,'[{1,28}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,2,0),(1010010842,'秩序战靴','8阶红2星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010010800,1,260,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,2,0),(1010010843,'秩序战靴','8阶红3星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010010800,1,260,0,4,0,0,0,'[{1,208}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,2,0),(1010010853,'秩序战靴','8阶粉色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010010800,1,260,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,173881},{4,4347}]','[]',0,0,2,0),(1010010863,'秩序战靴','8阶神装鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010010800,1,260,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,217352},{4,5434}]','[]',0,0,2,0),(1010010900,'守护战靴','9阶绿色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010010900,1,300,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,28847},{4,721}]','[]',0,0,3,0),(1010010910,'守护战靴','9阶蓝色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010010900,1,300,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,43270},{4,1082}]','[]',0,0,3,0),(1010010920,'守护战靴','9阶紫色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010010900,1,300,0,2,0,0,0,'[{1,7}]',0,0,0,0,'[{2,78752},{4,1969}]','[]',0,0,3,0),(1010010931,'守护战靴','9阶橙1星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010010900,1,300,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,96060},{4,2401}]','[]',0,0,3,0),(1010010932,'守护战靴','9阶橙2星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010010900,1,300,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{2,96060},{4,2401}]','[]',0,0,3,0),(1010010941,'守护战靴','9阶红1星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010010900,1,300,0,4,0,0,0,'[{1,33}]',0,0,0,0,'[{2,144234},{4,3606}]','[]',0,0,3,0),(1010010942,'守护战靴','9阶红2星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010010900,1,300,0,4,0,0,0,'[{1,55}]',0,0,0,0,'[{2,144234},{4,3606}]','[]',0,0,3,0),(1010010943,'守护战靴','9阶红3星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010010900,1,300,0,4,0,0,0,'[{1,290}]',0,0,0,0,'[{2,144234},{4,3606}]','[]',0,0,3,0),(1010010953,'守护战靴','9阶粉色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010010900,1,300,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,230774},{4,5769}]','[]',0,0,3,0),(1010010963,'守护战靴','9阶神装鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010010900,1,300,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,288468},{4,7212}]','[]',0,0,3,0),(1010011000,'信仰战靴','10阶绿色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010011000,1,355,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,37139},{4,928}]','[]',0,0,4,0),(1010011010,'信仰战靴','10阶蓝色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010011000,1,355,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,55709},{4,1393}]','[]',0,0,4,0),(1010011020,'信仰战靴','10阶紫色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010011000,1,355,0,2,0,0,0,'[{1,8}]',0,0,0,0,'[{2,101390},{4,2535}]','[]',0,0,4,0),(1010011031,'信仰战靴','10阶橙1星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010011000,1,355,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,123674},{4,3092}]','[]',0,0,4,0),(1010011032,'信仰战靴','10阶橙2星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010011000,1,355,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{2,123674},{4,3092}]','[]',0,0,4,0),(1010011041,'信仰战靴','10阶红1星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010011000,1,355,0,4,0,0,0,'[{1,40}]',0,0,0,0,'[{2,185696},{4,4642}]','[]',0,0,4,0),(1010011042,'信仰战靴','10阶红2星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010011000,1,355,0,4,0,0,0,'[{1,69}]',0,0,0,0,'[{2,185696},{4,4642}]','[]',0,0,4,0),(1010011043,'信仰战靴','10阶红3星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010011000,1,355,0,4,0,0,0,'[{1,399}]',0,0,0,0,'[{2,185696},{4,4642}]','[]',0,0,4,0),(1010011053,'信仰战靴','10阶粉色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010011000,1,355,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,297114},{4,7428}]','[]',0,0,4,0),(1010011063,'信仰战靴','10阶神装鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010011000,1,355,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,371392},{4,9285}]','[]',0,0,4,0),(1010011100,'天行战靴','11阶绿色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010011100,1,400,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,46666},{4,1167}]','[]',0,0,4,0),(1010011110,'天行战靴','11阶蓝色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010011100,1,400,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,69999},{4,1750}]','[]',0,0,4,0),(1010011120,'天行战靴','11阶紫色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010011100,1,400,0,2,0,0,0,'[{1,9}]',0,0,0,0,'[{2,127398},{4,3185}]','[]',0,0,4,0),(1010011131,'天行战靴','11阶橙1星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010011100,1,400,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{2,155397},{4,3885}]','[]',0,0,4,0),(1010011132,'天行战靴','11阶橙2星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010011100,1,400,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{2,155397},{4,3885}]','[]',0,0,4,0),(1010011141,'天行战靴','11阶红1星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010011100,1,400,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{2,233329},{4,5833}]','[]',0,0,4,0),(1010011142,'天行战靴','11阶红2星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010011100,1,400,0,4,0,0,0,'[{1,78}]',0,0,0,0,'[{2,233329},{4,5833}]','[]',0,0,4,0),(1010011143,'天行战靴','11阶红3星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010011100,1,400,0,4,0,0,0,'[{1,549}]',0,0,0,0,'[{2,233329},{4,5833}]','[]',0,0,4,0),(1010011153,'天行战靴','11阶粉色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010011100,1,400,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,373327},{4,9333}]','[]',0,0,4,0),(1010011163,'天行战靴','11阶神装鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010011100,1,400,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,466659},{4,11666}]','[]',0,0,4,0),(1010011200,'命运战靴','12阶绿色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010011200,1,500,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,57480},{4,1437}]','[]',0,0,5,0),(1010011210,'命运战靴','12阶蓝色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010011200,1,500,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,86220},{4,2156}]','[]',0,0,5,0),(1010011220,'命运战靴','12阶紫色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010011200,1,500,0,2,0,0,0,'[{1,9}]',0,0,0,0,'[{2,156921},{4,3923}]','[]',0,0,5,0),(1010011231,'命运战靴','12阶橙1星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010011200,1,500,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{2,191409},{4,4785}]','[]',0,0,5,0),(1010011232,'命运战靴','12阶橙2星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010011200,1,500,0,3,0,0,0,'[{1,15}]',0,0,0,0,'[{2,191409},{4,4785}]','[]',0,0,5,0),(1010011241,'命运战靴','12阶红1星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010011200,1,500,0,4,0,0,0,'[{1,62}]',0,0,0,0,'[{2,287400},{4,7185}]','[]',0,0,5,0),(1010011242,'命运战靴','12阶红2星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010011200,1,500,0,4,0,0,0,'[{1,110}]',0,0,0,0,'[{2,287400},{4,7185}]','[]',0,0,5,0),(1010011243,'命运战靴','12阶红3星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010011200,1,500,0,4,0,0,0,'[{1,799}]',0,0,0,0,'[{2,287400},{4,7185}]','[]',0,0,5,0),(1010011253,'命运战靴','12阶粉色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010011200,1,500,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,459841},{4,11496}]','[]',0,0,5,0),(1010011263,'命运战靴','12阶神装鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010011200,1,500,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,574801},{4,14370}]','[]',0,0,5,0),(1010011300,'制裁战靴','13阶绿色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010011300,1,520,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,69635},{4,1741}]','[]',0,0,5,0),(1010011310,'制裁战靴','13阶蓝色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010011300,1,520,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,104453},{4,2611}]','[]',0,0,5,0),(1010011320,'制裁战靴','13阶紫色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010011300,1,520,0,2,0,0,0,'[{1,10}]',0,0,0,0,'[{2,190104},{4,4753}]','[]',0,0,5,0),(1010011331,'制裁战靴','13阶橙1星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010011300,1,520,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{2,231885},{4,5797}]','[]',0,0,5,0),(1010011332,'制裁战靴','13阶橙2星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010011300,1,520,0,3,0,0,0,'[{1,17}]',0,0,0,0,'[{2,231885},{4,5797}]','[]',0,0,5,0),(1010011341,'制裁战靴','13阶红1星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010011300,1,520,0,4,0,0,0,'[{1,72}]',0,0,0,0,'[{2,348176},{4,8704}]','[]',0,0,5,0),(1010011342,'制裁战靴','13阶红2星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010011300,1,520,0,4,0,0,0,'[{1,128}]',0,0,0,0,'[{2,348176},{4,8704}]','[]',0,0,5,0),(1010011343,'制裁战靴','13阶红3星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010011300,1,520,0,4,0,0,0,'[{1,1117}]',0,0,0,0,'[{2,348176},{4,8704}]','[]',0,0,5,0),(1010011353,'制裁战靴','13阶粉色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010011300,1,520,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,557082},{4,13927}]','[]',0,0,5,0),(1010011363,'制裁战靴','13阶神装鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010011300,1,520,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,696352},{4,17409}]','[]',0,0,5,0),(1010011400,'审判战靴','14阶绿色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010011400,1,620,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,83185},{4,2080}]','[]',0,0,6,0),(1010011410,'审判战靴','14阶蓝色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010011400,1,620,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{2,124777},{4,3119}]','[]',0,0,6,0),(1010011420,'审判战靴','14阶紫色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010011400,1,620,0,2,0,0,0,'[{1,11}]',0,0,0,0,'[{2,227094},{4,5677}]','[]',0,0,6,0),(1010011431,'审判战靴','14阶橙1星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010011400,1,620,0,3,0,0,0,'[{1,15}]',0,0,0,0,'[{2,277005},{4,6925}]','[]',0,0,6,0),(1010011432,'审判战靴','14阶橙2星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010011400,1,620,0,3,0,0,0,'[{1,19}]',0,0,0,0,'[{2,277005},{4,6925}]','[]',0,0,6,0),(1010011441,'审判战靴','14阶红1星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010011400,1,620,0,4,0,0,0,'[{1,82}]',0,0,0,0,'[{2,415923},{4,10398}]','[]',0,0,6,0),(1010011442,'审判战靴','14阶红2星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010011400,1,620,0,4,0,0,0,'[{1,146}]',0,0,0,0,'[{2,415923},{4,10398}]','[]',0,0,6,0),(1010011443,'审判战靴','14阶红3星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010011400,1,620,0,4,0,0,0,'[{1,1444}]',0,0,0,0,'[{2,415923},{4,10398}]','[]',0,0,6,0),(1010011453,'审判战靴','14阶粉色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010011400,1,620,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,665478},{4,16637}]','[]',0,0,6,0),(1010011463,'审判战靴','14阶神装鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010011400,1,620,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,831847},{4,20796}]','[]',0,0,6,0),(1010011500,'毁灭战靴','15阶绿色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010011500,1,650,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,98182},{4,2455}]','[]',0,0,6,0),(1010011510,'毁灭战靴','15阶蓝色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010011500,1,650,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{2,147273},{4,3682}]','[]',0,0,6,0),(1010011520,'毁灭战靴','15阶紫色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010011500,1,650,0,2,0,0,0,'[{1,12}]',0,0,0,0,'[{2,268036},{4,6701}]','[]',0,0,6,0),(1010011531,'毁灭战靴','15阶橙1星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010011500,1,650,0,3,0,0,0,'[{1,16}]',0,0,0,0,'[{2,326945},{4,8174}]','[]',0,0,6,0),(1010011532,'毁灭战靴','15阶橙2星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010011500,1,650,0,3,0,0,0,'[{1,20}]',0,0,0,0,'[{2,326945},{4,8174}]','[]',0,0,6,0),(1010011541,'毁灭战靴','15阶红1星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010011500,1,650,0,4,0,0,0,'[{1,92}]',0,0,0,0,'[{2,490909},{4,12273}]','[]',0,0,6,0),(1010011542,'毁灭战靴','15阶红2星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010011500,1,650,0,4,0,0,0,'[{1,164}]',0,0,0,0,'[{2,490909},{4,12273}]','[]',0,0,6,0),(1010011543,'毁灭战靴','15阶红3星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010011500,1,650,0,4,0,0,0,'[{1,1717}]',0,0,0,0,'[{2,490909},{4,12273}]','[]',0,0,6,0),(1010011553,'毁灭战靴','15阶粉色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010011500,1,650,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,785455},{4,19636}]','[]',0,0,6,0),(1010011563,'毁灭战靴','15阶神装鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010011500,1,650,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,981818},{4,24545}]','[]',0,0,6,0),(1010011600,'混沌战靴','16阶绿色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010011500,1,700,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{2,114680},{4,2867}]','[]',0,0,6,0),(1010011610,'混沌战靴','16阶蓝色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010011500,1,700,0,1,0,0,0,'[{1,7}]',0,0,0,0,'[{2,172020},{4,4300}]','[]',0,0,6,0),(1010011620,'混沌战靴','16阶紫色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010011500,1,700,0,2,0,0,0,'[{1,14}]',0,0,0,0,'[{2,313076},{4,7827}]','[]',0,0,6,0),(1010011631,'混沌战靴','16阶橙1星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010011500,1,700,0,3,0,0,0,'[{1,19}]',0,0,0,0,'[{2,381884},{4,9547}]','[]',0,0,6,0),(1010011632,'混沌战靴','16阶橙2星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010011500,1,700,0,3,0,0,0,'[{1,23}]',0,0,0,0,'[{2,381884},{4,9547}]','[]',0,0,6,0),(1010011641,'混沌战靴','16阶红1星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010011500,1,700,0,4,0,0,0,'[{1,112}]',0,0,0,0,'[{2,573400},{4,14335}]','[]',0,0,6,0),(1010011642,'混沌战靴','16阶红2星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010011500,1,700,0,4,0,0,0,'[{1,200}]',0,0,0,0,'[{2,573400},{4,14335}]','[]',0,0,6,0),(1010011643,'混沌战靴','16阶红3星鞋子【魔剑士】','',0,'','',0,1,1,10,10,1,2,10,1010011500,1,700,0,4,0,0,0,'[{1,2044}]',0,0,0,0,'[{2,573400},{4,14335}]','[]',0,0,6,0),(1010011653,'混沌战靴','16阶粉色鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010011500,1,700,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,917440},{4,22936}]','[]',0,0,6,0),(1010011663,'混沌战靴','16阶神装鞋子【魔剑士】','',0,'','',0,0,1,10,10,0,0,10,1010011500,1,700,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,1146800},{4,28670}]','[]',0,0,6,0),(1010020100,'学徒皮靴','1阶绿色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010020100,2,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,487},{4,12}]','[]',0,0,0,0),(1010020110,'学徒皮靴','1阶蓝色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010020100,2,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,731},{4,18}]','[]',0,0,0,0),(1010020120,'学徒皮靴','1阶紫色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010020100,2,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1330},{4,33}]','[]',0,0,0,0),(1010020131,'学徒皮靴','1阶橙1星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010020100,2,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1622},{4,41}]','[]',0,0,0,0),(1010020132,'学徒皮靴','1阶橙2星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010020100,2,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1622},{4,41}]','[]',0,0,0,0),(1010020141,'学徒皮靴','1阶红1星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010020100,2,1,0,4,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2435},{4,61}]','[]',0,0,0,0),(1010020142,'学徒皮靴','1阶红2星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010020100,2,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{2,2435},{4,61}]','[]',0,0,0,0),(1010020143,'学徒皮靴','1阶红3星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010020100,2,1,0,4,0,0,0,'[{1,5}]',0,0,0,0,'[{2,2435},{4,61}]','[]',0,0,0,0),(1010020153,'学徒皮靴','1阶粉色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010020100,2,1,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,3896},{4,97}]','[]',0,0,0,0),(1010020163,'学徒皮靴','1阶神装鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010020100,2,1,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,4870},{4,122}]','[]',0,0,0,0),(1010020200,'冒险皮靴','2阶绿色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010020200,2,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,834},{4,21}]','[]',0,0,0,0),(1010020210,'冒险皮靴','2阶蓝色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010020200,2,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1251},{4,31}]','[]',0,0,0,0),(1010020220,'冒险皮靴','2阶紫色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010020200,2,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2277},{4,57}]','[]',0,0,0,0),(1010020231,'冒险皮靴','2阶橙1星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010020200,2,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2777},{4,69}]','[]',0,0,0,0),(1010020232,'冒险皮靴','2阶橙2星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010020200,2,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2777},{4,69}]','[]',0,0,0,0),(1010020241,'冒险皮靴','2阶红1星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010020200,2,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{2,4170},{4,104}]','[]',0,0,0,0),(1010020242,'冒险皮靴','2阶红2星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010020200,2,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{2,4170},{4,104}]','[]',0,0,0,0),(1010020243,'冒险皮靴','2阶红3星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010020200,2,1,0,4,0,0,0,'[{1,8}]',0,0,0,0,'[{2,4170},{4,104}]','[]',0,0,0,0),(1010020253,'冒险皮靴','2阶粉色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010020200,2,1,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,6671},{4,167}]','[]',0,0,0,0),(1010020263,'冒险皮靴','2阶神装鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010020200,2,1,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,8339},{4,208}]','[]',0,0,0,0),(1010020300,'勇者皮靴','3阶绿色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010020300,2,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1988},{4,50}]','[]',0,0,0,0),(1010020310,'勇者皮靴','3阶蓝色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010020300,2,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2982},{4,75}]','[]',0,0,0,0),(1010020320,'勇者皮靴','3阶紫色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010020300,2,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,5427},{4,136}]','[]',0,0,0,0),(1010020331,'勇者皮靴','3阶橙1星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010020300,2,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6620},{4,166}]','[]',0,0,0,0),(1010020332,'勇者皮靴','3阶橙2星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010020300,2,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6620},{4,166}]','[]',0,0,0,0),(1010020341,'勇者皮靴','3阶红1星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010020300,2,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{2,9940},{4,249}]','[]',0,0,0,0),(1010020342,'勇者皮靴','3阶红2星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010020300,2,1,0,4,0,0,0,'[{1,4}]',0,0,0,0,'[{2,9940},{4,249}]','[]',0,0,0,0),(1010020343,'勇者皮靴','3阶红3星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010020300,2,1,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,9940},{4,249}]','[]',0,0,0,0),(1010020353,'勇者皮靴','3阶粉色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010020300,2,1,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,15904},{4,398}]','[]',0,0,0,0),(1010020363,'勇者皮靴','3阶神装鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010020300,2,1,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,19881},{4,497}]','[]',0,0,0,0),(1010020400,'先驱皮靴','4阶绿色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010020400,2,100,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,4003},{4,100}]','[]',0,0,0,0),(1010020410,'先驱皮靴','4阶蓝色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010020400,2,100,0,1,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6004},{4,150}]','[]',0,0,0,0),(1010020420,'先驱皮靴','4阶紫色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010020400,2,100,0,2,0,0,0,'[{1,3}]',0,0,0,0,'[{2,10928},{4,273}]','[]',0,0,0,0),(1010020431,'先驱皮靴','4阶橙1星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010020400,2,100,0,3,0,0,0,'[{1,3}]',0,0,0,0,'[{2,13329},{4,333}]','[]',0,0,0,0),(1010020432,'先驱皮靴','4阶橙2星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010020400,2,100,0,3,0,0,0,'[{1,4}]',0,0,0,0,'[{2,13329},{4,333}]','[]',0,0,0,0),(1010020441,'先驱皮靴','4阶红1星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010020400,2,100,0,4,0,0,0,'[{1,8}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1010020442,'先驱皮靴','4阶红2星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010020400,2,100,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1010020443,'先驱皮靴','4阶红3星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010020400,2,100,0,4,0,0,0,'[{1,34}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1010020453,'先驱皮靴','4阶粉色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010020400,2,100,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,32022},{4,801}]','[]',0,0,0,0),(1010020463,'先驱皮靴','4阶神装鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010020400,2,100,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,40028},{4,1001}]','[]',0,0,0,0),(1010020500,'荣誉皮靴','5阶绿色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010020500,2,150,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,6932},{4,173}]','[]',0,0,1,0),(1010020510,'荣誉皮靴','5阶蓝色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010020500,2,150,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{2,10397},{4,260}]','[]',0,0,1,0),(1010020520,'荣誉皮靴','5阶紫色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010020500,2,150,0,2,0,0,0,'[{1,5}]',0,0,0,0,'[{2,18923},{4,473}]','[]',0,0,1,0),(1010020531,'荣誉皮靴','5阶橙1星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010020500,2,150,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,1,0),(1010020532,'荣誉皮靴','5阶橙2星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010020500,2,150,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,1,0),(1010020541,'荣誉皮靴','5阶红1星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010020500,2,150,0,4,0,0,0,'[{1,14}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,1,0),(1010020542,'荣誉皮靴','5阶红2星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010020500,2,150,0,4,0,0,0,'[{1,21}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,1,0),(1010020543,'荣誉皮靴','5阶红3星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010020500,2,150,0,4,0,0,0,'[{1,63}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,1,0),(1010020553,'荣誉皮靴','5阶粉色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010020500,2,150,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,55452},{4,1386}]','[]',0,0,1,0),(1010020563,'荣誉皮靴','5阶神装鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010020500,2,150,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,69315},{4,1733}]','[]',0,0,1,0),(1010020600,'贤者皮靴','6阶绿色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010020600,2,180,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,10828},{4,271}]','[]',0,0,1,0),(1010020610,'贤者皮靴','6阶蓝色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010020600,2,180,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{2,16241},{4,406}]','[]',0,0,1,0),(1010020620,'贤者皮靴','6阶紫色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010020600,2,180,0,2,0,0,0,'[{1,5}]',0,0,0,0,'[{2,29559},{4,739}]','[]',0,0,1,0),(1010020631,'贤者皮靴','6阶橙1星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010020600,2,180,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,36056},{4,901}]','[]',0,0,1,0),(1010020632,'贤者皮靴','6阶橙2星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010020600,2,180,0,3,0,0,0,'[{1,8}]',0,0,0,0,'[{2,36056},{4,901}]','[]',0,0,1,0),(1010020641,'贤者皮靴','6阶红1星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010020600,2,180,0,4,0,0,0,'[{1,18}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,1,0),(1010020642,'贤者皮靴','6阶红2星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010020600,2,180,0,4,0,0,0,'[{1,28}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,1,0),(1010020643,'贤者皮靴','6阶红3星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010020600,2,180,0,4,0,0,0,'[{1,104}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,1,0),(1010020653,'贤者皮靴','6阶粉色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010020600,2,180,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,86620},{4,2166}]','[]',0,0,1,0),(1010020663,'贤者皮靴','6阶神装鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010020600,2,180,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,108276},{4,2707}]','[]',0,0,1,0),(1010020700,'征服皮靴','7阶绿色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010020700,2,220,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,15744},{4,394}]','[]',0,0,2,0),(1010020710,'征服皮靴','7阶蓝色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010020700,2,220,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{2,23616},{4,590}]','[]',0,0,2,0),(1010020720,'征服皮靴','7阶紫色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010020700,2,220,0,2,0,0,0,'[{1,6}]',0,0,0,0,'[{2,42982},{4,1075}]','[]',0,0,2,0),(1010020731,'征服皮靴','7阶橙1星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010020700,2,220,0,3,0,0,0,'[{1,8}]',0,0,0,0,'[{2,52429},{4,1311}]','[]',0,0,2,0),(1010020732,'征服皮靴','7阶橙2星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010020700,2,220,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,52429},{4,1311}]','[]',0,0,2,0),(1010020741,'征服皮靴','7阶红1星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010020700,2,220,0,4,0,0,0,'[{1,25}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,2,0),(1010020742,'征服皮靴','7阶红2星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010020700,2,220,0,4,0,0,0,'[{1,41}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,2,0),(1010020743,'征服皮靴','7阶红3星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010020700,2,220,0,4,0,0,0,'[{1,149}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,2,0),(1010020753,'征服皮靴','7阶粉色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010020700,2,220,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,125955},{4,3149}]','[]',0,0,2,0),(1010020763,'征服皮靴','7阶神装鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010020700,2,220,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,157443},{4,3936}]','[]',0,0,2,0),(1010020800,'秩序皮靴','8阶绿色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010020800,2,260,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,21735},{4,543}]','[]',0,0,2,0),(1010020810,'秩序皮靴','8阶蓝色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010020800,2,260,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,32603},{4,815}]','[]',0,0,2,0),(1010020820,'秩序皮靴','8阶紫色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010020800,2,260,0,2,0,0,0,'[{1,7}]',0,0,0,0,'[{2,59337},{4,1483}]','[]',0,0,2,0),(1010020831,'秩序皮靴','8阶橙1星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010020800,2,260,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{2,72378},{4,1809}]','[]',0,0,2,0),(1010020832,'秩序皮靴','8阶橙2星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010020800,2,260,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{2,72378},{4,1809}]','[]',0,0,2,0),(1010020841,'秩序皮靴','8阶红1星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010020800,2,260,0,4,0,0,0,'[{1,28}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,2,0),(1010020842,'秩序皮靴','8阶红2星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010020800,2,260,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,2,0),(1010020843,'秩序皮靴','8阶红3星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010020800,2,260,0,4,0,0,0,'[{1,208}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,2,0),(1010020853,'秩序皮靴','8阶粉色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010020800,2,260,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,173881},{4,4347}]','[]',0,0,2,0),(1010020863,'秩序皮靴','8阶神装鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010020800,2,260,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,217352},{4,5434}]','[]',0,0,2,0),(1010020900,'守护皮靴','9阶绿色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010020900,2,300,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,28847},{4,721}]','[]',0,0,3,0),(1010020910,'守护皮靴','9阶蓝色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010020900,2,300,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,43270},{4,1082}]','[]',0,0,3,0),(1010020920,'守护皮靴','9阶紫色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010020900,2,300,0,2,0,0,0,'[{1,7}]',0,0,0,0,'[{2,78752},{4,1969}]','[]',0,0,3,0),(1010020931,'守护皮靴','9阶橙1星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010020900,2,300,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,96060},{4,2401}]','[]',0,0,3,0),(1010020932,'守护皮靴','9阶橙2星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010020900,2,300,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{2,96060},{4,2401}]','[]',0,0,3,0),(1010020941,'守护皮靴','9阶红1星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010020900,2,300,0,4,0,0,0,'[{1,33}]',0,0,0,0,'[{2,144234},{4,3606}]','[]',0,0,3,0),(1010020942,'守护皮靴','9阶红2星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010020900,2,300,0,4,0,0,0,'[{1,55}]',0,0,0,0,'[{2,144234},{4,3606}]','[]',0,0,3,0),(1010020943,'守护皮靴','9阶红3星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010020900,2,300,0,4,0,0,0,'[{1,290}]',0,0,0,0,'[{2,144234},{4,3606}]','[]',0,0,3,0),(1010020953,'守护皮靴','9阶粉色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010020900,2,300,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,230774},{4,5769}]','[]',0,0,3,0),(1010020963,'守护皮靴','9阶神装鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010020900,2,300,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,288468},{4,7212}]','[]',0,0,3,0),(1010021000,'信仰皮靴','10阶绿色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010021000,2,355,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,37139},{4,928}]','[]',0,0,4,0),(1010021010,'信仰皮靴','10阶蓝色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010021000,2,355,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,55709},{4,1393}]','[]',0,0,4,0),(1010021020,'信仰皮靴','10阶紫色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010021000,2,355,0,2,0,0,0,'[{1,8}]',0,0,0,0,'[{2,101390},{4,2535}]','[]',0,0,4,0),(1010021031,'信仰皮靴','10阶橙1星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010021000,2,355,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,123674},{4,3092}]','[]',0,0,4,0),(1010021032,'信仰皮靴','10阶橙2星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010021000,2,355,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{2,123674},{4,3092}]','[]',0,0,4,0),(1010021041,'信仰皮靴','10阶红1星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010021000,2,355,0,4,0,0,0,'[{1,40}]',0,0,0,0,'[{2,185696},{4,4642}]','[]',0,0,4,0),(1010021042,'信仰皮靴','10阶红2星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010021000,2,355,0,4,0,0,0,'[{1,69}]',0,0,0,0,'[{2,185696},{4,4642}]','[]',0,0,4,0),(1010021043,'信仰皮靴','10阶红3星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010021000,2,355,0,4,0,0,0,'[{1,399}]',0,0,0,0,'[{2,185696},{4,4642}]','[]',0,0,4,0),(1010021053,'信仰皮靴','10阶粉色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010021000,2,355,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,297114},{4,7428}]','[]',0,0,4,0),(1010021063,'信仰皮靴','10阶神装鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010021000,2,355,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,371392},{4,9285}]','[]',0,0,4,0),(1010021100,'天行皮靴','11阶绿色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010021100,2,400,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,46666},{4,1167}]','[]',0,0,4,0),(1010021110,'天行皮靴','11阶蓝色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010021100,2,400,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,69999},{4,1750}]','[]',0,0,4,0),(1010021120,'天行皮靴','11阶紫色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010021100,2,400,0,2,0,0,0,'[{1,9}]',0,0,0,0,'[{2,127398},{4,3185}]','[]',0,0,4,0),(1010021131,'天行皮靴','11阶橙1星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010021100,2,400,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{2,155397},{4,3885}]','[]',0,0,4,0),(1010021132,'天行皮靴','11阶橙2星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010021100,2,400,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{2,155397},{4,3885}]','[]',0,0,4,0),(1010021141,'天行皮靴','11阶红1星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010021100,2,400,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{2,233329},{4,5833}]','[]',0,0,4,0),(1010021142,'天行皮靴','11阶红2星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010021100,2,400,0,4,0,0,0,'[{1,78}]',0,0,0,0,'[{2,233329},{4,5833}]','[]',0,0,4,0),(1010021143,'天行皮靴','11阶红3星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010021100,2,400,0,4,0,0,0,'[{1,549}]',0,0,0,0,'[{2,233329},{4,5833}]','[]',0,0,4,0),(1010021153,'天行皮靴','11阶粉色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010021100,2,400,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,373327},{4,9333}]','[]',0,0,4,0),(1010021163,'天行皮靴','11阶神装鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010021100,2,400,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,466659},{4,11666}]','[]',0,0,4,0),(1010021200,'命运皮靴','12阶绿色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010021200,2,500,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,57480},{4,1437}]','[]',0,0,5,0),(1010021210,'命运皮靴','12阶蓝色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010021200,2,500,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,86220},{4,2156}]','[]',0,0,5,0),(1010021220,'命运皮靴','12阶紫色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010021200,2,500,0,2,0,0,0,'[{1,9}]',0,0,0,0,'[{2,156921},{4,3923}]','[]',0,0,5,0),(1010021231,'命运皮靴','12阶橙1星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010021200,2,500,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{2,191409},{4,4785}]','[]',0,0,5,0),(1010021232,'命运皮靴','12阶橙2星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010021200,2,500,0,3,0,0,0,'[{1,15}]',0,0,0,0,'[{2,191409},{4,4785}]','[]',0,0,5,0),(1010021241,'命运皮靴','12阶红1星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010021200,2,500,0,4,0,0,0,'[{1,62}]',0,0,0,0,'[{2,287400},{4,7185}]','[]',0,0,5,0),(1010021242,'命运皮靴','12阶红2星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010021200,2,500,0,4,0,0,0,'[{1,110}]',0,0,0,0,'[{2,287400},{4,7185}]','[]',0,0,5,0),(1010021243,'命运皮靴','12阶红3星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010021200,2,500,0,4,0,0,0,'[{1,799}]',0,0,0,0,'[{2,287400},{4,7185}]','[]',0,0,5,0),(1010021253,'命运皮靴','12阶粉色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010021200,2,500,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,459841},{4,11496}]','[]',0,0,5,0),(1010021263,'命运皮靴','12阶神装鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010021200,2,500,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,574801},{4,14370}]','[]',0,0,5,0),(1010021300,'制裁皮靴','13阶绿色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010021300,2,520,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,69635},{4,1741}]','[]',0,0,5,0),(1010021310,'制裁皮靴','13阶蓝色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010021300,2,520,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,104453},{4,2611}]','[]',0,0,5,0),(1010021320,'制裁皮靴','13阶紫色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010021300,2,520,0,2,0,0,0,'[{1,10}]',0,0,0,0,'[{2,190104},{4,4753}]','[]',0,0,5,0),(1010021331,'制裁皮靴','13阶橙1星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010021300,2,520,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{2,231885},{4,5797}]','[]',0,0,5,0),(1010021332,'制裁皮靴','13阶橙2星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010021300,2,520,0,3,0,0,0,'[{1,17}]',0,0,0,0,'[{2,231885},{4,5797}]','[]',0,0,5,0),(1010021341,'制裁皮靴','13阶红1星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010021300,2,520,0,4,0,0,0,'[{1,72}]',0,0,0,0,'[{2,348176},{4,8704}]','[]',0,0,5,0),(1010021342,'制裁皮靴','13阶红2星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010021300,2,520,0,4,0,0,0,'[{1,128}]',0,0,0,0,'[{2,348176},{4,8704}]','[]',0,0,5,0),(1010021343,'制裁皮靴','13阶红3星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010021300,2,520,0,4,0,0,0,'[{1,1117}]',0,0,0,0,'[{2,348176},{4,8704}]','[]',0,0,5,0),(1010021353,'制裁皮靴','13阶粉色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010021300,2,520,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,557082},{4,13927}]','[]',0,0,5,0),(1010021363,'制裁皮靴','13阶神装鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010021300,2,520,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,696352},{4,17409}]','[]',0,0,5,0),(1010021400,'审判皮靴','14阶绿色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010021400,2,620,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,83185},{4,2080}]','[]',0,0,6,0),(1010021410,'审判皮靴','14阶蓝色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010021400,2,620,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{2,124777},{4,3119}]','[]',0,0,6,0),(1010021420,'审判皮靴','14阶紫色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010021400,2,620,0,2,0,0,0,'[{1,11}]',0,0,0,0,'[{2,227094},{4,5677}]','[]',0,0,6,0),(1010021431,'审判皮靴','14阶橙1星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010021400,2,620,0,3,0,0,0,'[{1,15}]',0,0,0,0,'[{2,277005},{4,6925}]','[]',0,0,6,0),(1010021432,'审判皮靴','14阶橙2星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010021400,2,620,0,3,0,0,0,'[{1,19}]',0,0,0,0,'[{2,277005},{4,6925}]','[]',0,0,6,0),(1010021441,'审判皮靴','14阶红1星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010021400,2,620,0,4,0,0,0,'[{1,82}]',0,0,0,0,'[{2,415923},{4,10398}]','[]',0,0,6,0),(1010021442,'审判皮靴','14阶红2星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010021400,2,620,0,4,0,0,0,'[{1,146}]',0,0,0,0,'[{2,415923},{4,10398}]','[]',0,0,6,0),(1010021443,'审判皮靴','14阶红3星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010021400,2,620,0,4,0,0,0,'[{1,1444}]',0,0,0,0,'[{2,415923},{4,10398}]','[]',0,0,6,0),(1010021453,'审判皮靴','14阶粉色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010021400,2,620,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,665478},{4,16637}]','[]',0,0,6,0),(1010021463,'审判皮靴','14阶神装鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010021400,2,620,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,831847},{4,20796}]','[]',0,0,6,0),(1010021500,'毁灭皮靴','15阶绿色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010021500,2,650,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,98182},{4,2455}]','[]',0,0,6,0),(1010021510,'毁灭皮靴','15阶蓝色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010021500,2,650,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{2,147273},{4,3682}]','[]',0,0,6,0),(1010021520,'毁灭皮靴','15阶紫色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010021500,2,650,0,2,0,0,0,'[{1,12}]',0,0,0,0,'[{2,268036},{4,6701}]','[]',0,0,6,0),(1010021531,'毁灭皮靴','15阶橙1星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010021500,2,650,0,3,0,0,0,'[{1,16}]',0,0,0,0,'[{2,326945},{4,8174}]','[]',0,0,6,0),(1010021532,'毁灭皮靴','15阶橙2星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010021500,2,650,0,3,0,0,0,'[{1,20}]',0,0,0,0,'[{2,326945},{4,8174}]','[]',0,0,6,0),(1010021541,'毁灭皮靴','15阶红1星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010021500,2,650,0,4,0,0,0,'[{1,92}]',0,0,0,0,'[{2,490909},{4,12273}]','[]',0,0,6,0),(1010021542,'毁灭皮靴','15阶红2星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010021500,2,650,0,4,0,0,0,'[{1,164}]',0,0,0,0,'[{2,490909},{4,12273}]','[]',0,0,6,0),(1010021543,'毁灭皮靴','15阶红3星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010021500,2,650,0,4,0,0,0,'[{1,1717}]',0,0,0,0,'[{2,490909},{4,12273}]','[]',0,0,6,0),(1010021553,'毁灭皮靴','15阶粉色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010021500,2,650,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,785455},{4,19636}]','[]',0,0,6,0),(1010021563,'毁灭皮靴','15阶神装鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010021500,2,650,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,981818},{4,24545}]','[]',0,0,6,0),(1010021600,'混沌皮靴','16阶绿色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010021500,2,700,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{2,114680},{4,2867}]','[]',0,0,6,0),(1010021610,'混沌皮靴','16阶蓝色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010021500,2,700,0,1,0,0,0,'[{1,7}]',0,0,0,0,'[{2,172020},{4,4300}]','[]',0,0,6,0),(1010021620,'混沌皮靴','16阶紫色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010021500,2,700,0,2,0,0,0,'[{1,14}]',0,0,0,0,'[{2,313076},{4,7827}]','[]',0,0,6,0),(1010021631,'混沌皮靴','16阶橙1星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010021500,2,700,0,3,0,0,0,'[{1,19}]',0,0,0,0,'[{2,381884},{4,9547}]','[]',0,0,6,0),(1010021632,'混沌皮靴','16阶橙2星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010021500,2,700,0,3,0,0,0,'[{1,23}]',0,0,0,0,'[{2,381884},{4,9547}]','[]',0,0,6,0),(1010021641,'混沌皮靴','16阶红1星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010021500,2,700,0,4,0,0,0,'[{1,112}]',0,0,0,0,'[{2,573400},{4,14335}]','[]',0,0,6,0),(1010021642,'混沌皮靴','16阶红2星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010021500,2,700,0,4,0,0,0,'[{1,200}]',0,0,0,0,'[{2,573400},{4,14335}]','[]',0,0,6,0),(1010021643,'混沌皮靴','16阶红3星鞋子【龙骑士】','',0,'','',0,1,1,10,10,1,2,10,1010021500,2,700,0,4,0,0,0,'[{1,2044}]',0,0,0,0,'[{2,573400},{4,14335}]','[]',0,0,6,0),(1010021653,'混沌皮靴','16阶粉色鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010021500,2,700,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,917440},{4,22936}]','[]',0,0,6,0),(1010021663,'混沌皮靴','16阶神装鞋子【龙骑士】','',0,'','',0,0,1,10,10,0,0,10,1010021500,2,700,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,1146800},{4,28670}]','[]',0,0,6,0),(1010030100,'学徒长靴','1阶绿色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010030100,3,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,487},{4,12}]','[]',0,0,0,0),(1010030110,'学徒长靴','1阶蓝色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010030100,3,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,731},{4,18}]','[]',0,0,0,0),(1010030120,'学徒长靴','1阶紫色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010030100,3,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1330},{4,33}]','[]',0,0,0,0),(1010030131,'学徒长靴','1阶橙1星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010030100,3,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1622},{4,41}]','[]',0,0,0,0),(1010030132,'学徒长靴','1阶橙2星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010030100,3,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1622},{4,41}]','[]',0,0,0,0),(1010030141,'学徒长靴','1阶红1星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010030100,3,1,0,4,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2435},{4,61}]','[]',0,0,0,0),(1010030142,'学徒长靴','1阶红2星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010030100,3,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{2,2435},{4,61}]','[]',0,0,0,0),(1010030143,'学徒长靴','1阶红3星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010030100,3,1,0,4,0,0,0,'[{1,5}]',0,0,0,0,'[{2,2435},{4,61}]','[]',0,0,0,0),(1010030153,'学徒长靴','1阶粉色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010030100,3,1,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,3896},{4,97}]','[]',0,0,0,0),(1010030163,'学徒长靴','1阶神装鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010030100,3,1,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,4870},{4,122}]','[]',0,0,0,0),(1010030200,'冒险长靴','2阶绿色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010030200,3,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,834},{4,21}]','[]',0,0,0,0),(1010030210,'冒险长靴','2阶蓝色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010030200,3,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1251},{4,31}]','[]',0,0,0,0),(1010030220,'冒险长靴','2阶紫色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010030200,3,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2277},{4,57}]','[]',0,0,0,0),(1010030231,'冒险长靴','2阶橙1星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010030200,3,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2777},{4,69}]','[]',0,0,0,0),(1010030232,'冒险长靴','2阶橙2星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010030200,3,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2777},{4,69}]','[]',0,0,0,0),(1010030241,'冒险长靴','2阶红1星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010030200,3,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{2,4170},{4,104}]','[]',0,0,0,0),(1010030242,'冒险长靴','2阶红2星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010030200,3,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{2,4170},{4,104}]','[]',0,0,0,0),(1010030243,'冒险长靴','2阶红3星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010030200,3,1,0,4,0,0,0,'[{1,8}]',0,0,0,0,'[{2,4170},{4,104}]','[]',0,0,0,0),(1010030253,'冒险长靴','2阶粉色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010030200,3,1,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,6671},{4,167}]','[]',0,0,0,0),(1010030263,'冒险长靴','2阶神装鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010030200,3,1,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,8339},{4,208}]','[]',0,0,0,0),(1010030300,'勇者长靴','3阶绿色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010030300,3,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1988},{4,50}]','[]',0,0,0,0),(1010030310,'勇者长靴','3阶蓝色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010030300,3,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2982},{4,75}]','[]',0,0,0,0),(1010030320,'勇者长靴','3阶紫色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010030300,3,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,5427},{4,136}]','[]',0,0,0,0),(1010030331,'勇者长靴','3阶橙1星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010030300,3,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6620},{4,166}]','[]',0,0,0,0),(1010030332,'勇者长靴','3阶橙2星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010030300,3,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6620},{4,166}]','[]',0,0,0,0),(1010030341,'勇者长靴','3阶红1星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010030300,3,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{2,9940},{4,249}]','[]',0,0,0,0),(1010030342,'勇者长靴','3阶红2星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010030300,3,1,0,4,0,0,0,'[{1,4}]',0,0,0,0,'[{2,9940},{4,249}]','[]',0,0,0,0),(1010030343,'勇者长靴','3阶红3星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010030300,3,1,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,9940},{4,249}]','[]',0,0,0,0),(1010030353,'勇者长靴','3阶粉色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010030300,3,1,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,15904},{4,398}]','[]',0,0,0,0),(1010030363,'勇者长靴','3阶神装鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010030300,3,1,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,19881},{4,497}]','[]',0,0,0,0),(1010030400,'先驱长靴','4阶绿色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010030400,3,100,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,4003},{4,100}]','[]',0,0,0,0),(1010030410,'先驱长靴','4阶蓝色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010030400,3,100,0,1,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6004},{4,150}]','[]',0,0,0,0),(1010030420,'先驱长靴','4阶紫色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010030400,3,100,0,2,0,0,0,'[{1,3}]',0,0,0,0,'[{2,10928},{4,273}]','[]',0,0,0,0),(1010030431,'先驱长靴','4阶橙1星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010030400,3,100,0,3,0,0,0,'[{1,3}]',0,0,0,0,'[{2,13329},{4,333}]','[]',0,0,0,0),(1010030432,'先驱长靴','4阶橙2星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010030400,3,100,0,3,0,0,0,'[{1,4}]',0,0,0,0,'[{2,13329},{4,333}]','[]',0,0,0,0),(1010030441,'先驱长靴','4阶红1星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010030400,3,100,0,4,0,0,0,'[{1,8}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1010030442,'先驱长靴','4阶红2星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010030400,3,100,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1010030443,'先驱长靴','4阶红3星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010030400,3,100,0,4,0,0,0,'[{1,34}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1010030453,'先驱长靴','4阶粉色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010030400,3,100,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,32022},{4,801}]','[]',0,0,0,0),(1010030463,'先驱长靴','4阶神装鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010030400,3,100,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,40028},{4,1001}]','[]',0,0,0,0),(1010030500,'荣誉长靴','5阶绿色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010030500,3,150,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,6932},{4,173}]','[]',0,0,1,0),(1010030510,'荣誉长靴','5阶蓝色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010030500,3,150,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{2,10397},{4,260}]','[]',0,0,1,0),(1010030520,'荣誉长靴','5阶紫色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010030500,3,150,0,2,0,0,0,'[{1,5}]',0,0,0,0,'[{2,18923},{4,473}]','[]',0,0,1,0),(1010030531,'荣誉长靴','5阶橙1星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010030500,3,150,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,1,0),(1010030532,'荣誉长靴','5阶橙2星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010030500,3,150,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,1,0),(1010030541,'荣誉长靴','5阶红1星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010030500,3,150,0,4,0,0,0,'[{1,14}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,1,0),(1010030542,'荣誉长靴','5阶红2星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010030500,3,150,0,4,0,0,0,'[{1,21}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,1,0),(1010030543,'荣誉长靴','5阶红3星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010030500,3,150,0,4,0,0,0,'[{1,63}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,1,0),(1010030553,'荣誉长靴','5阶粉色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010030500,3,150,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,55452},{4,1386}]','[]',0,0,1,0),(1010030563,'荣誉长靴','5阶神装鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010030500,3,150,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,69315},{4,1733}]','[]',0,0,1,0),(1010030600,'贤者长靴','6阶绿色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010030600,3,180,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,10828},{4,271}]','[]',0,0,1,0),(1010030610,'贤者长靴','6阶蓝色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010030600,3,180,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{2,16241},{4,406}]','[]',0,0,1,0),(1010030620,'贤者长靴','6阶紫色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010030600,3,180,0,2,0,0,0,'[{1,5}]',0,0,0,0,'[{2,29559},{4,739}]','[]',0,0,1,0),(1010030631,'贤者长靴','6阶橙1星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010030600,3,180,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,36056},{4,901}]','[]',0,0,1,0),(1010030632,'贤者长靴','6阶橙2星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010030600,3,180,0,3,0,0,0,'[{1,8}]',0,0,0,0,'[{2,36056},{4,901}]','[]',0,0,1,0),(1010030641,'贤者长靴','6阶红1星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010030600,3,180,0,4,0,0,0,'[{1,18}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,1,0),(1010030642,'贤者长靴','6阶红2星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010030600,3,180,0,4,0,0,0,'[{1,28}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,1,0),(1010030643,'贤者长靴','6阶红3星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010030600,3,180,0,4,0,0,0,'[{1,104}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,1,0),(1010030653,'贤者长靴','6阶粉色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010030600,3,180,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,86620},{4,2166}]','[]',0,0,1,0),(1010030663,'贤者长靴','6阶神装鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010030600,3,180,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,108276},{4,2707}]','[]',0,0,1,0),(1010030700,'征服长靴','7阶绿色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010030700,3,220,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,15744},{4,394}]','[]',0,0,2,0),(1010030710,'征服长靴','7阶蓝色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010030700,3,220,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{2,23616},{4,590}]','[]',0,0,2,0),(1010030720,'征服长靴','7阶紫色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010030700,3,220,0,2,0,0,0,'[{1,6}]',0,0,0,0,'[{2,42982},{4,1075}]','[]',0,0,2,0),(1010030731,'征服长靴','7阶橙1星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010030700,3,220,0,3,0,0,0,'[{1,8}]',0,0,0,0,'[{2,52429},{4,1311}]','[]',0,0,2,0),(1010030732,'征服长靴','7阶橙2星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010030700,3,220,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,52429},{4,1311}]','[]',0,0,2,0),(1010030741,'征服长靴','7阶红1星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010030700,3,220,0,4,0,0,0,'[{1,25}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,2,0),(1010030742,'征服长靴','7阶红2星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010030700,3,220,0,4,0,0,0,'[{1,41}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,2,0),(1010030743,'征服长靴','7阶红3星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010030700,3,220,0,4,0,0,0,'[{1,149}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,2,0),(1010030753,'征服长靴','7阶粉色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010030700,3,220,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,125955},{4,3149}]','[]',0,0,2,0),(1010030763,'征服长靴','7阶神装鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010030700,3,220,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,157443},{4,3936}]','[]',0,0,2,0),(1010030800,'秩序长靴','8阶绿色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010030800,3,260,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,21735},{4,543}]','[]',0,0,2,0),(1010030810,'秩序长靴','8阶蓝色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010030800,3,260,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,32603},{4,815}]','[]',0,0,2,0),(1010030820,'秩序长靴','8阶紫色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010030800,3,260,0,2,0,0,0,'[{1,7}]',0,0,0,0,'[{2,59337},{4,1483}]','[]',0,0,2,0),(1010030831,'秩序长靴','8阶橙1星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010030800,3,260,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{2,72378},{4,1809}]','[]',0,0,2,0),(1010030832,'秩序长靴','8阶橙2星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010030800,3,260,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{2,72378},{4,1809}]','[]',0,0,2,0),(1010030841,'秩序长靴','8阶红1星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010030800,3,260,0,4,0,0,0,'[{1,28}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,2,0),(1010030842,'秩序长靴','8阶红2星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010030800,3,260,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,2,0),(1010030843,'秩序长靴','8阶红3星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010030800,3,260,0,4,0,0,0,'[{1,208}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,2,0),(1010030853,'秩序长靴','8阶粉色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010030800,3,260,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,173881},{4,4347}]','[]',0,0,2,0),(1010030863,'秩序长靴','8阶神装鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010030800,3,260,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,217352},{4,5434}]','[]',0,0,2,0),(1010030900,'守护长靴','9阶绿色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010030900,3,300,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,28847},{4,721}]','[]',0,0,3,0),(1010030910,'守护长靴','9阶蓝色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010030900,3,300,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,43270},{4,1082}]','[]',0,0,3,0),(1010030920,'守护长靴','9阶紫色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010030900,3,300,0,2,0,0,0,'[{1,7}]',0,0,0,0,'[{2,78752},{4,1969}]','[]',0,0,3,0),(1010030931,'守护长靴','9阶橙1星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010030900,3,300,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,96060},{4,2401}]','[]',0,0,3,0),(1010030932,'守护长靴','9阶橙2星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010030900,3,300,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{2,96060},{4,2401}]','[]',0,0,3,0),(1010030941,'守护长靴','9阶红1星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010030900,3,300,0,4,0,0,0,'[{1,33}]',0,0,0,0,'[{2,144234},{4,3606}]','[]',0,0,3,0),(1010030942,'守护长靴','9阶红2星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010030900,3,300,0,4,0,0,0,'[{1,55}]',0,0,0,0,'[{2,144234},{4,3606}]','[]',0,0,3,0),(1010030943,'守护长靴','9阶红3星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010030900,3,300,0,4,0,0,0,'[{1,290}]',0,0,0,0,'[{2,144234},{4,3606}]','[]',0,0,3,0),(1010030953,'守护长靴','9阶粉色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010030900,3,300,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,230774},{4,5769}]','[]',0,0,3,0),(1010030963,'守护长靴','9阶神装鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010030900,3,300,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,288468},{4,7212}]','[]',0,0,3,0),(1010031000,'信仰长靴','10阶绿色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010031000,3,355,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,37139},{4,928}]','[]',0,0,4,0),(1010031010,'信仰长靴','10阶蓝色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010031000,3,355,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,55709},{4,1393}]','[]',0,0,4,0),(1010031020,'信仰长靴','10阶紫色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010031000,3,355,0,2,0,0,0,'[{1,8}]',0,0,0,0,'[{2,101390},{4,2535}]','[]',0,0,4,0),(1010031031,'信仰长靴','10阶橙1星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010031000,3,355,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,123674},{4,3092}]','[]',0,0,4,0),(1010031032,'信仰长靴','10阶橙2星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010031000,3,355,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{2,123674},{4,3092}]','[]',0,0,4,0),(1010031041,'信仰长靴','10阶红1星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010031000,3,355,0,4,0,0,0,'[{1,40}]',0,0,0,0,'[{2,185696},{4,4642}]','[]',0,0,4,0),(1010031042,'信仰长靴','10阶红2星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010031000,3,355,0,4,0,0,0,'[{1,69}]',0,0,0,0,'[{2,185696},{4,4642}]','[]',0,0,4,0),(1010031043,'信仰长靴','10阶红3星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010031000,3,355,0,4,0,0,0,'[{1,399}]',0,0,0,0,'[{2,185696},{4,4642}]','[]',0,0,4,0),(1010031053,'信仰长靴','10阶粉色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010031000,3,355,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,297114},{4,7428}]','[]',0,0,4,0),(1010031063,'信仰长靴','10阶神装鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010031000,3,355,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,371392},{4,9285}]','[]',0,0,4,0),(1010031100,'天行长靴','11阶绿色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010031100,3,400,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,46666},{4,1167}]','[]',0,0,4,0),(1010031110,'天行长靴','11阶蓝色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010031100,3,400,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,69999},{4,1750}]','[]',0,0,4,0),(1010031120,'天行长靴','11阶紫色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010031100,3,400,0,2,0,0,0,'[{1,9}]',0,0,0,0,'[{2,127398},{4,3185}]','[]',0,0,4,0),(1010031131,'天行长靴','11阶橙1星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010031100,3,400,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{2,155397},{4,3885}]','[]',0,0,4,0),(1010031132,'天行长靴','11阶橙2星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010031100,3,400,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{2,155397},{4,3885}]','[]',0,0,4,0),(1010031141,'天行长靴','11阶红1星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010031100,3,400,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{2,233329},{4,5833}]','[]',0,0,4,0),(1010031142,'天行长靴','11阶红2星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010031100,3,400,0,4,0,0,0,'[{1,78}]',0,0,0,0,'[{2,233329},{4,5833}]','[]',0,0,4,0),(1010031143,'天行长靴','11阶红3星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010031100,3,400,0,4,0,0,0,'[{1,549}]',0,0,0,0,'[{2,233329},{4,5833}]','[]',0,0,4,0),(1010031153,'天行长靴','11阶粉色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010031100,3,400,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,373327},{4,9333}]','[]',0,0,4,0),(1010031163,'天行长靴','11阶神装鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010031100,3,400,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,466659},{4,11666}]','[]',0,0,4,0),(1010031200,'命运长靴','12阶绿色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010031200,3,500,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,57480},{4,1437}]','[]',0,0,5,0),(1010031210,'命运长靴','12阶蓝色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010031200,3,500,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,86220},{4,2156}]','[]',0,0,5,0),(1010031220,'命运长靴','12阶紫色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010031200,3,500,0,2,0,0,0,'[{1,9}]',0,0,0,0,'[{2,156921},{4,3923}]','[]',0,0,5,0),(1010031231,'命运长靴','12阶橙1星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010031200,3,500,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{2,191409},{4,4785}]','[]',0,0,5,0),(1010031232,'命运长靴','12阶橙2星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010031200,3,500,0,3,0,0,0,'[{1,15}]',0,0,0,0,'[{2,191409},{4,4785}]','[]',0,0,5,0),(1010031241,'命运长靴','12阶红1星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010031200,3,500,0,4,0,0,0,'[{1,62}]',0,0,0,0,'[{2,287400},{4,7185}]','[]',0,0,5,0),(1010031242,'命运长靴','12阶红2星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010031200,3,500,0,4,0,0,0,'[{1,110}]',0,0,0,0,'[{2,287400},{4,7185}]','[]',0,0,5,0),(1010031243,'命运长靴','12阶红3星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010031200,3,500,0,4,0,0,0,'[{1,799}]',0,0,0,0,'[{2,287400},{4,7185}]','[]',0,0,5,0),(1010031253,'命运长靴','12阶粉色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010031200,3,500,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,459841},{4,11496}]','[]',0,0,5,0),(1010031263,'命运长靴','12阶神装鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010031200,3,500,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,574801},{4,14370}]','[]',0,0,5,0),(1010031300,'制裁长靴','13阶绿色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010031300,3,520,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,69635},{4,1741}]','[]',0,0,5,0),(1010031310,'制裁长靴','13阶蓝色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010031300,3,520,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,104453},{4,2611}]','[]',0,0,5,0),(1010031320,'制裁长靴','13阶紫色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010031300,3,520,0,2,0,0,0,'[{1,10}]',0,0,0,0,'[{2,190104},{4,4753}]','[]',0,0,5,0),(1010031331,'制裁长靴','13阶橙1星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010031300,3,520,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{2,231885},{4,5797}]','[]',0,0,5,0),(1010031332,'制裁长靴','13阶橙2星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010031300,3,520,0,3,0,0,0,'[{1,17}]',0,0,0,0,'[{2,231885},{4,5797}]','[]',0,0,5,0),(1010031341,'制裁长靴','13阶红1星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010031300,3,520,0,4,0,0,0,'[{1,72}]',0,0,0,0,'[{2,348176},{4,8704}]','[]',0,0,5,0),(1010031342,'制裁长靴','13阶红2星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010031300,3,520,0,4,0,0,0,'[{1,128}]',0,0,0,0,'[{2,348176},{4,8704}]','[]',0,0,5,0),(1010031343,'制裁长靴','13阶红3星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010031300,3,520,0,4,0,0,0,'[{1,1117}]',0,0,0,0,'[{2,348176},{4,8704}]','[]',0,0,5,0),(1010031353,'制裁长靴','13阶粉色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010031300,3,520,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,557082},{4,13927}]','[]',0,0,5,0),(1010031363,'制裁长靴','13阶神装鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010031300,3,520,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,696352},{4,17409}]','[]',0,0,5,0),(1010031400,'审判长靴','14阶绿色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010031400,3,620,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,83185},{4,2080}]','[]',0,0,6,0),(1010031410,'审判长靴','14阶蓝色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010031400,3,620,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{2,124777},{4,3119}]','[]',0,0,6,0),(1010031420,'审判长靴','14阶紫色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010031400,3,620,0,2,0,0,0,'[{1,11}]',0,0,0,0,'[{2,227094},{4,5677}]','[]',0,0,6,0),(1010031431,'审判长靴','14阶橙1星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010031400,3,620,0,3,0,0,0,'[{1,15}]',0,0,0,0,'[{2,277005},{4,6925}]','[]',0,0,6,0),(1010031432,'审判长靴','14阶橙2星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010031400,3,620,0,3,0,0,0,'[{1,19}]',0,0,0,0,'[{2,277005},{4,6925}]','[]',0,0,6,0),(1010031441,'审判长靴','14阶红1星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010031400,3,620,0,4,0,0,0,'[{1,82}]',0,0,0,0,'[{2,415923},{4,10398}]','[]',0,0,6,0),(1010031442,'审判长靴','14阶红2星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010031400,3,620,0,4,0,0,0,'[{1,146}]',0,0,0,0,'[{2,415923},{4,10398}]','[]',0,0,6,0),(1010031443,'审判长靴','14阶红3星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010031400,3,620,0,4,0,0,0,'[{1,1444}]',0,0,0,0,'[{2,415923},{4,10398}]','[]',0,0,6,0),(1010031453,'审判长靴','14阶粉色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010031400,3,620,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,665478},{4,16637}]','[]',0,0,6,0),(1010031463,'审判长靴','14阶神装鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010031400,3,620,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,831847},{4,20796}]','[]',0,0,6,0),(1010031500,'毁灭长靴','15阶绿色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010031500,3,650,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,98182},{4,2455}]','[]',0,0,6,0),(1010031510,'毁灭长靴','15阶蓝色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010031500,3,650,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{2,147273},{4,3682}]','[]',0,0,6,0),(1010031520,'毁灭长靴','15阶紫色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010031500,3,650,0,2,0,0,0,'[{1,12}]',0,0,0,0,'[{2,268036},{4,6701}]','[]',0,0,6,0),(1010031531,'毁灭长靴','15阶橙1星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010031500,3,650,0,3,0,0,0,'[{1,16}]',0,0,0,0,'[{2,326945},{4,8174}]','[]',0,0,6,0),(1010031532,'毁灭长靴','15阶橙2星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010031500,3,650,0,3,0,0,0,'[{1,20}]',0,0,0,0,'[{2,326945},{4,8174}]','[]',0,0,6,0),(1010031541,'毁灭长靴','15阶红1星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010031500,3,650,0,4,0,0,0,'[{1,92}]',0,0,0,0,'[{2,490909},{4,12273}]','[]',0,0,6,0),(1010031542,'毁灭长靴','15阶红2星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010031500,3,650,0,4,0,0,0,'[{1,164}]',0,0,0,0,'[{2,490909},{4,12273}]','[]',0,0,6,0),(1010031543,'毁灭长靴','15阶红3星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010031500,3,650,0,4,0,0,0,'[{1,1717}]',0,0,0,0,'[{2,490909},{4,12273}]','[]',0,0,6,0),(1010031553,'毁灭长靴','15阶粉色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010031500,3,650,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,785455},{4,19636}]','[]',0,0,6,0),(1010031563,'毁灭长靴','15阶神装鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010031500,3,650,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,981818},{4,24545}]','[]',0,0,6,0),(1010031600,'混沌长靴','16阶绿色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010031500,3,700,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{2,114680},{4,2867}]','[]',0,0,6,0),(1010031610,'混沌长靴','16阶蓝色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010031500,3,700,0,1,0,0,0,'[{1,7}]',0,0,0,0,'[{2,172020},{4,4300}]','[]',0,0,6,0),(1010031620,'混沌长靴','16阶紫色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010031500,3,700,0,2,0,0,0,'[{1,14}]',0,0,0,0,'[{2,313076},{4,7827}]','[]',0,0,6,0),(1010031631,'混沌长靴','16阶橙1星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010031500,3,700,0,3,0,0,0,'[{1,19}]',0,0,0,0,'[{2,381884},{4,9547}]','[]',0,0,6,0),(1010031632,'混沌长靴','16阶橙2星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010031500,3,700,0,3,0,0,0,'[{1,23}]',0,0,0,0,'[{2,381884},{4,9547}]','[]',0,0,6,0),(1010031641,'混沌长靴','16阶红1星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010031500,3,700,0,4,0,0,0,'[{1,112}]',0,0,0,0,'[{2,573400},{4,14335}]','[]',0,0,6,0),(1010031642,'混沌长靴','16阶红2星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010031500,3,700,0,4,0,0,0,'[{1,200}]',0,0,0,0,'[{2,573400},{4,14335}]','[]',0,0,6,0),(1010031643,'混沌长靴','16阶红3星鞋子【魔导师】','',0,'','',0,1,1,10,10,1,2,10,1010031500,3,700,0,4,0,0,0,'[{1,2044}]',0,0,0,0,'[{2,573400},{4,14335}]','[]',0,0,6,0),(1010031653,'混沌长靴','16阶粉色鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010031500,3,700,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,917440},{4,22936}]','[]',0,0,6,0),(1010031663,'混沌长靴','16阶神装鞋子【魔导师】','',0,'','',0,0,1,10,10,0,0,10,1010031500,3,700,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,1146800},{4,28670}]','[]',0,0,6,0),(1010040100,'学徒短靴','1阶绿色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010040100,4,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,487},{4,12}]','[]',0,0,0,0),(1010040110,'学徒短靴','1阶蓝色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010040100,4,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,731},{4,18}]','[]',0,0,0,0),(1010040120,'学徒短靴','1阶紫色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010040100,4,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1330},{4,33}]','[]',0,0,0,0),(1010040131,'学徒短靴','1阶橙1星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010040100,4,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1622},{4,41}]','[]',0,0,0,0),(1010040132,'学徒短靴','1阶橙2星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010040100,4,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1622},{4,41}]','[]',0,0,0,0),(1010040141,'学徒短靴','1阶红1星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010040100,4,1,0,4,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2435},{4,61}]','[]',0,0,0,0),(1010040142,'学徒短靴','1阶红2星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010040100,4,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{2,2435},{4,61}]','[]',0,0,0,0),(1010040143,'学徒短靴','1阶红3星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010040100,4,1,0,4,0,0,0,'[{1,5}]',0,0,0,0,'[{2,2435},{4,61}]','[]',0,0,0,0),(1010040153,'学徒短靴','1阶粉色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010040100,4,1,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,3896},{4,97}]','[]',0,0,0,0),(1010040163,'学徒短靴','1阶神装鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010040100,4,1,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,4870},{4,122}]','[]',0,0,0,0),(1010040200,'冒险短靴','2阶绿色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010040200,4,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,834},{4,21}]','[]',0,0,0,0),(1010040210,'冒险短靴','2阶蓝色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010040200,4,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1251},{4,31}]','[]',0,0,0,0),(1010040220,'冒险短靴','2阶紫色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010040200,4,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2277},{4,57}]','[]',0,0,0,0),(1010040231,'冒险短靴','2阶橙1星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010040200,4,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2777},{4,69}]','[]',0,0,0,0),(1010040232,'冒险短靴','2阶橙2星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010040200,4,1,0,3,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2777},{4,69}]','[]',0,0,0,0),(1010040241,'冒险短靴','2阶红1星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010040200,4,1,0,4,0,0,0,'[{1,2}]',0,0,0,0,'[{2,4170},{4,104}]','[]',0,0,0,0),(1010040242,'冒险短靴','2阶红2星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010040200,4,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{2,4170},{4,104}]','[]',0,0,0,0),(1010040243,'冒险短靴','2阶红3星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010040200,4,1,0,4,0,0,0,'[{1,8}]',0,0,0,0,'[{2,4170},{4,104}]','[]',0,0,0,0),(1010040253,'冒险短靴','2阶粉色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010040200,4,1,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,6671},{4,167}]','[]',0,0,0,0),(1010040263,'冒险短靴','2阶神装鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010040200,4,1,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,8339},{4,208}]','[]',0,0,0,0),(1010040300,'勇者短靴','3阶绿色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010040300,4,1,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,1988},{4,50}]','[]',0,0,0,0),(1010040310,'勇者短靴','3阶蓝色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010040300,4,1,0,1,0,0,0,'[{1,1}]',0,0,0,0,'[{2,2982},{4,75}]','[]',0,0,0,0),(1010040320,'勇者短靴','3阶紫色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010040300,4,1,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,5427},{4,136}]','[]',0,0,0,0),(1010040331,'勇者短靴','3阶橙1星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010040300,4,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6620},{4,166}]','[]',0,0,0,0),(1010040332,'勇者短靴','3阶橙2星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010040300,4,1,0,3,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6620},{4,166}]','[]',0,0,0,0),(1010040341,'勇者短靴','3阶红1星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010040300,4,1,0,4,0,0,0,'[{1,3}]',0,0,0,0,'[{2,9940},{4,249}]','[]',0,0,0,0),(1010040342,'勇者短靴','3阶红2星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010040300,4,1,0,4,0,0,0,'[{1,4}]',0,0,0,0,'[{2,9940},{4,249}]','[]',0,0,0,0),(1010040343,'勇者短靴','3阶红3星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010040300,4,1,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,9940},{4,249}]','[]',0,0,0,0),(1010040353,'勇者短靴','3阶粉色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010040300,4,1,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,15904},{4,398}]','[]',0,0,0,0),(1010040363,'勇者短靴','3阶神装鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010040300,4,1,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,19881},{4,497}]','[]',0,0,0,0),(1010040400,'先驱短靴','4阶绿色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010040400,4,100,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,4003},{4,100}]','[]',0,0,0,0),(1010040410,'先驱短靴','4阶蓝色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010040400,4,100,0,1,0,0,0,'[{1,2}]',0,0,0,0,'[{2,6004},{4,150}]','[]',0,0,0,0),(1010040420,'先驱短靴','4阶紫色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010040400,4,100,0,2,0,0,0,'[{1,3}]',0,0,0,0,'[{2,10928},{4,273}]','[]',0,0,0,0),(1010040431,'先驱短靴','4阶橙1星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010040400,4,100,0,3,0,0,0,'[{1,3}]',0,0,0,0,'[{2,13329},{4,333}]','[]',0,0,0,0),(1010040432,'先驱短靴','4阶橙2星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010040400,4,100,0,3,0,0,0,'[{1,4}]',0,0,0,0,'[{2,13329},{4,333}]','[]',0,0,0,0),(1010040441,'先驱短靴','4阶红1星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010040400,4,100,0,4,0,0,0,'[{1,8}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1010040442,'先驱短靴','4阶红2星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010040400,4,100,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1010040443,'先驱短靴','4阶红3星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010040400,4,100,0,4,0,0,0,'[{1,34}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1010040453,'先驱短靴','4阶粉色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010040400,4,100,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,32022},{4,801}]','[]',0,0,0,0),(1010040463,'先驱短靴','4阶神装鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010040400,4,100,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,40028},{4,1001}]','[]',0,0,0,0),(1010040500,'荣誉短靴','5阶绿色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010040500,4,150,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,6932},{4,173}]','[]',0,0,1,0),(1010040510,'荣誉短靴','5阶蓝色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010040500,4,150,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{2,10397},{4,260}]','[]',0,0,1,0),(1010040520,'荣誉短靴','5阶紫色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010040500,4,150,0,2,0,0,0,'[{1,5}]',0,0,0,0,'[{2,18923},{4,473}]','[]',0,0,1,0),(1010040531,'荣誉短靴','5阶橙1星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010040500,4,150,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,1,0),(1010040532,'荣誉短靴','5阶橙2星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010040500,4,150,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,1,0),(1010040541,'荣誉短靴','5阶红1星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010040500,4,150,0,4,0,0,0,'[{1,14}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,1,0),(1010040542,'荣誉短靴','5阶红2星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010040500,4,150,0,4,0,0,0,'[{1,21}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,1,0),(1010040543,'荣誉短靴','5阶红3星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010040500,4,150,0,4,0,0,0,'[{1,63}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,1,0),(1010040553,'荣誉短靴','5阶粉色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010040500,4,150,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,55452},{4,1386}]','[]',0,0,1,0),(1010040563,'荣誉短靴','5阶神装鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010040500,4,150,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,69315},{4,1733}]','[]',0,0,1,0),(1010040600,'贤者短靴','6阶绿色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010040600,4,180,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,10828},{4,271}]','[]',0,0,1,0),(1010040610,'贤者短靴','6阶蓝色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010040600,4,180,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{2,16241},{4,406}]','[]',0,0,1,0),(1010040620,'贤者短靴','6阶紫色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010040600,4,180,0,2,0,0,0,'[{1,5}]',0,0,0,0,'[{2,29559},{4,739}]','[]',0,0,1,0),(1010040631,'贤者短靴','6阶橙1星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010040600,4,180,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,36056},{4,901}]','[]',0,0,1,0),(1010040632,'贤者短靴','6阶橙2星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010040600,4,180,0,3,0,0,0,'[{1,8}]',0,0,0,0,'[{2,36056},{4,901}]','[]',0,0,1,0),(1010040641,'贤者短靴','6阶红1星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010040600,4,180,0,4,0,0,0,'[{1,18}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,1,0),(1010040642,'贤者短靴','6阶红2星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010040600,4,180,0,4,0,0,0,'[{1,28}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,1,0),(1010040643,'贤者短靴','6阶红3星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010040600,4,180,0,4,0,0,0,'[{1,104}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,1,0),(1010040653,'贤者短靴','6阶粉色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010040600,4,180,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,86620},{4,2166}]','[]',0,0,1,0),(1010040663,'贤者短靴','6阶神装鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010040600,4,180,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,108276},{4,2707}]','[]',0,0,1,0),(1010040700,'征服短靴','7阶绿色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010040700,4,220,0,0,0,0,0,'[{1,1}]',0,0,0,0,'[{2,15744},{4,394}]','[]',0,0,2,0),(1010040710,'征服短靴','7阶蓝色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010040700,4,220,0,1,0,0,0,'[{1,3}]',0,0,0,0,'[{2,23616},{4,590}]','[]',0,0,2,0),(1010040720,'征服短靴','7阶紫色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010040700,4,220,0,2,0,0,0,'[{1,6}]',0,0,0,0,'[{2,42982},{4,1075}]','[]',0,0,2,0),(1010040731,'征服短靴','7阶橙1星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010040700,4,220,0,3,0,0,0,'[{1,8}]',0,0,0,0,'[{2,52429},{4,1311}]','[]',0,0,2,0),(1010040732,'征服短靴','7阶橙2星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010040700,4,220,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,52429},{4,1311}]','[]',0,0,2,0),(1010040741,'征服短靴','7阶红1星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010040700,4,220,0,4,0,0,0,'[{1,25}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,2,0),(1010040742,'征服短靴','7阶红2星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010040700,4,220,0,4,0,0,0,'[{1,41}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,2,0),(1010040743,'征服短靴','7阶红3星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010040700,4,220,0,4,0,0,0,'[{1,149}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,2,0),(1010040753,'征服短靴','7阶粉色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010040700,4,220,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,125955},{4,3149}]','[]',0,0,2,0),(1010040763,'征服短靴','7阶神装鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010040700,4,220,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,157443},{4,3936}]','[]',0,0,2,0),(1010040800,'秩序短靴','8阶绿色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010040800,4,260,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,21735},{4,543}]','[]',0,0,2,0),(1010040810,'秩序短靴','8阶蓝色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010040800,4,260,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,32603},{4,815}]','[]',0,0,2,0),(1010040820,'秩序短靴','8阶紫色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010040800,4,260,0,2,0,0,0,'[{1,7}]',0,0,0,0,'[{2,59337},{4,1483}]','[]',0,0,2,0),(1010040831,'秩序短靴','8阶橙1星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010040800,4,260,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{2,72378},{4,1809}]','[]',0,0,2,0),(1010040832,'秩序短靴','8阶橙2星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010040800,4,260,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{2,72378},{4,1809}]','[]',0,0,2,0),(1010040841,'秩序短靴','8阶红1星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010040800,4,260,0,4,0,0,0,'[{1,28}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,2,0),(1010040842,'秩序短靴','8阶红2星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010040800,4,260,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,2,0),(1010040843,'秩序短靴','8阶红3星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010040800,4,260,0,4,0,0,0,'[{1,208}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,2,0),(1010040853,'秩序短靴','8阶粉色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010040800,4,260,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,173881},{4,4347}]','[]',0,0,2,0),(1010040863,'秩序短靴','8阶神装鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010040800,4,260,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,217352},{4,5434}]','[]',0,0,2,0),(1010040900,'守护短靴','9阶绿色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010040900,4,300,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,28847},{4,721}]','[]',0,0,3,0),(1010040910,'守护短靴','9阶蓝色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010040900,4,300,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,43270},{4,1082}]','[]',0,0,3,0),(1010040920,'守护短靴','9阶紫色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010040900,4,300,0,2,0,0,0,'[{1,7}]',0,0,0,0,'[{2,78752},{4,1969}]','[]',0,0,3,0),(1010040931,'守护短靴','9阶橙1星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010040900,4,300,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,96060},{4,2401}]','[]',0,0,3,0),(1010040932,'守护短靴','9阶橙2星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010040900,4,300,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{2,96060},{4,2401}]','[]',0,0,3,0),(1010040941,'守护短靴','9阶红1星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010040900,4,300,0,4,0,0,0,'[{1,33}]',0,0,0,0,'[{2,144234},{4,3606}]','[]',0,0,3,0),(1010040942,'守护短靴','9阶红2星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010040900,4,300,0,4,0,0,0,'[{1,55}]',0,0,0,0,'[{2,144234},{4,3606}]','[]',0,0,3,0),(1010040943,'守护短靴','9阶红3星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010040900,4,300,0,4,0,0,0,'[{1,290}]',0,0,0,0,'[{2,144234},{4,3606}]','[]',0,0,3,0),(1010040953,'守护短靴','9阶粉色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010040900,4,300,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,230774},{4,5769}]','[]',0,0,3,0),(1010040963,'守护短靴','9阶神装鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010040900,4,300,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,288468},{4,7212}]','[]',0,0,3,0),(1010041000,'信仰短靴','10阶绿色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010041000,4,355,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,37139},{4,928}]','[]',0,0,4,0),(1010041010,'信仰短靴','10阶蓝色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010041000,4,355,0,1,0,0,0,'[{1,4}]',0,0,0,0,'[{2,55709},{4,1393}]','[]',0,0,4,0),(1010041020,'信仰短靴','10阶紫色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010041000,4,355,0,2,0,0,0,'[{1,8}]',0,0,0,0,'[{2,101390},{4,2535}]','[]',0,0,4,0),(1010041031,'信仰短靴','10阶橙1星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010041000,4,355,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,123674},{4,3092}]','[]',0,0,4,0),(1010041032,'信仰短靴','10阶橙2星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010041000,4,355,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{2,123674},{4,3092}]','[]',0,0,4,0),(1010041041,'信仰短靴','10阶红1星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010041000,4,355,0,4,0,0,0,'[{1,40}]',0,0,0,0,'[{2,185696},{4,4642}]','[]',0,0,4,0),(1010041042,'信仰短靴','10阶红2星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010041000,4,355,0,4,0,0,0,'[{1,69}]',0,0,0,0,'[{2,185696},{4,4642}]','[]',0,0,4,0),(1010041043,'信仰短靴','10阶红3星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010041000,4,355,0,4,0,0,0,'[{1,399}]',0,0,0,0,'[{2,185696},{4,4642}]','[]',0,0,4,0),(1010041053,'信仰短靴','10阶粉色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010041000,4,355,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,297114},{4,7428}]','[]',0,0,4,0),(1010041063,'信仰短靴','10阶神装鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010041000,4,355,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,371392},{4,9285}]','[]',0,0,4,0),(1010041100,'天行短靴','11阶绿色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010041100,4,400,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,46666},{4,1167}]','[]',0,0,4,0),(1010041110,'天行短靴','11阶蓝色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010041100,4,400,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,69999},{4,1750}]','[]',0,0,4,0),(1010041120,'天行短靴','11阶紫色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010041100,4,400,0,2,0,0,0,'[{1,9}]',0,0,0,0,'[{2,127398},{4,3185}]','[]',0,0,4,0),(1010041131,'天行短靴','11阶橙1星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010041100,4,400,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{2,155397},{4,3885}]','[]',0,0,4,0),(1010041132,'天行短靴','11阶橙2星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010041100,4,400,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{2,155397},{4,3885}]','[]',0,0,4,0),(1010041141,'天行短靴','11阶红1星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010041100,4,400,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{2,233329},{4,5833}]','[]',0,0,4,0),(1010041142,'天行短靴','11阶红2星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010041100,4,400,0,4,0,0,0,'[{1,78}]',0,0,0,0,'[{2,233329},{4,5833}]','[]',0,0,4,0),(1010041143,'天行短靴','11阶红3星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010041100,4,400,0,4,0,0,0,'[{1,549}]',0,0,0,0,'[{2,233329},{4,5833}]','[]',0,0,4,0),(1010041153,'天行短靴','11阶粉色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010041100,4,400,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,373327},{4,9333}]','[]',0,0,4,0),(1010041163,'天行短靴','11阶神装鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010041100,4,400,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,466659},{4,11666}]','[]',0,0,4,0),(1010041200,'命运短靴','12阶绿色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010041200,4,500,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,57480},{4,1437}]','[]',0,0,5,0),(1010041210,'命运短靴','12阶蓝色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010041200,4,500,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,86220},{4,2156}]','[]',0,0,5,0),(1010041220,'命运短靴','12阶紫色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010041200,4,500,0,2,0,0,0,'[{1,9}]',0,0,0,0,'[{2,156921},{4,3923}]','[]',0,0,5,0),(1010041231,'命运短靴','12阶橙1星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010041200,4,500,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{2,191409},{4,4785}]','[]',0,0,5,0),(1010041232,'命运短靴','12阶橙2星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010041200,4,500,0,3,0,0,0,'[{1,15}]',0,0,0,0,'[{2,191409},{4,4785}]','[]',0,0,5,0),(1010041241,'命运短靴','12阶红1星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010041200,4,500,0,4,0,0,0,'[{1,62}]',0,0,0,0,'[{2,287400},{4,7185}]','[]',0,0,5,0),(1010041242,'命运短靴','12阶红2星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010041200,4,500,0,4,0,0,0,'[{1,110}]',0,0,0,0,'[{2,287400},{4,7185}]','[]',0,0,5,0),(1010041243,'命运短靴','12阶红3星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010041200,4,500,0,4,0,0,0,'[{1,799}]',0,0,0,0,'[{2,287400},{4,7185}]','[]',0,0,5,0),(1010041253,'命运短靴','12阶粉色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010041200,4,500,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,459841},{4,11496}]','[]',0,0,5,0),(1010041263,'命运短靴','12阶神装鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010041200,4,500,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,574801},{4,14370}]','[]',0,0,5,0),(1010041300,'制裁短靴','13阶绿色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010041300,4,520,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,69635},{4,1741}]','[]',0,0,5,0),(1010041310,'制裁短靴','13阶蓝色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010041300,4,520,0,1,0,0,0,'[{1,5}]',0,0,0,0,'[{2,104453},{4,2611}]','[]',0,0,5,0),(1010041320,'制裁短靴','13阶紫色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010041300,4,520,0,2,0,0,0,'[{1,10}]',0,0,0,0,'[{2,190104},{4,4753}]','[]',0,0,5,0),(1010041331,'制裁短靴','13阶橙1星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010041300,4,520,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{2,231885},{4,5797}]','[]',0,0,5,0),(1010041332,'制裁短靴','13阶橙2星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010041300,4,520,0,3,0,0,0,'[{1,17}]',0,0,0,0,'[{2,231885},{4,5797}]','[]',0,0,5,0),(1010041341,'制裁短靴','13阶红1星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010041300,4,520,0,4,0,0,0,'[{1,72}]',0,0,0,0,'[{2,348176},{4,8704}]','[]',0,0,5,0),(1010041342,'制裁短靴','13阶红2星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010041300,4,520,0,4,0,0,0,'[{1,128}]',0,0,0,0,'[{2,348176},{4,8704}]','[]',0,0,5,0),(1010041343,'制裁短靴','13阶红3星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010041300,4,520,0,4,0,0,0,'[{1,1117}]',0,0,0,0,'[{2,348176},{4,8704}]','[]',0,0,5,0),(1010041353,'制裁短靴','13阶粉色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010041300,4,520,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,557082},{4,13927}]','[]',0,0,5,0),(1010041363,'制裁短靴','13阶神装鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010041300,4,520,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,696352},{4,17409}]','[]',0,0,5,0),(1010041400,'审判短靴','14阶绿色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010041400,4,620,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,83185},{4,2080}]','[]',0,0,6,0),(1010041410,'审判短靴','14阶蓝色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010041400,4,620,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{2,124777},{4,3119}]','[]',0,0,6,0),(1010041420,'审判短靴','14阶紫色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010041400,4,620,0,2,0,0,0,'[{1,11}]',0,0,0,0,'[{2,227094},{4,5677}]','[]',0,0,6,0),(1010041431,'审判短靴','14阶橙1星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010041400,4,620,0,3,0,0,0,'[{1,15}]',0,0,0,0,'[{2,277005},{4,6925}]','[]',0,0,6,0),(1010041432,'审判短靴','14阶橙2星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010041400,4,620,0,3,0,0,0,'[{1,19}]',0,0,0,0,'[{2,277005},{4,6925}]','[]',0,0,6,0),(1010041441,'审判短靴','14阶红1星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010041400,4,620,0,4,0,0,0,'[{1,82}]',0,0,0,0,'[{2,415923},{4,10398}]','[]',0,0,6,0),(1010041442,'审判短靴','14阶红2星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010041400,4,620,0,4,0,0,0,'[{1,146}]',0,0,0,0,'[{2,415923},{4,10398}]','[]',0,0,6,0),(1010041443,'审判短靴','14阶红3星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010041400,4,620,0,4,0,0,0,'[{1,1444}]',0,0,0,0,'[{2,415923},{4,10398}]','[]',0,0,6,0),(1010041453,'审判短靴','14阶粉色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010041400,4,620,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,665478},{4,16637}]','[]',0,0,6,0),(1010041463,'审判短靴','14阶神装鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010041400,4,620,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,831847},{4,20796}]','[]',0,0,6,0),(1010041500,'毁灭短靴','15阶绿色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010041500,4,650,0,0,0,0,0,'[{1,2}]',0,0,0,0,'[{2,98182},{4,2455}]','[]',0,0,6,0),(1010041510,'毁灭短靴','15阶蓝色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010041500,4,650,0,1,0,0,0,'[{1,6}]',0,0,0,0,'[{2,147273},{4,3682}]','[]',0,0,6,0),(1010041520,'毁灭短靴','15阶紫色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010041500,4,650,0,2,0,0,0,'[{1,12}]',0,0,0,0,'[{2,268036},{4,6701}]','[]',0,0,6,0),(1010041531,'毁灭短靴','15阶橙1星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010041500,4,650,0,3,0,0,0,'[{1,16}]',0,0,0,0,'[{2,326945},{4,8174}]','[]',0,0,6,0),(1010041532,'毁灭短靴','15阶橙2星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010041500,4,650,0,3,0,0,0,'[{1,20}]',0,0,0,0,'[{2,326945},{4,8174}]','[]',0,0,6,0),(1010041541,'毁灭短靴','15阶红1星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010041500,4,650,0,4,0,0,0,'[{1,92}]',0,0,0,0,'[{2,490909},{4,12273}]','[]',0,0,6,0),(1010041542,'毁灭短靴','15阶红2星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010041500,4,650,0,4,0,0,0,'[{1,164}]',0,0,0,0,'[{2,490909},{4,12273}]','[]',0,0,6,0),(1010041543,'毁灭短靴','15阶红3星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010041500,4,650,0,4,0,0,0,'[{1,1717}]',0,0,0,0,'[{2,490909},{4,12273}]','[]',0,0,6,0),(1010041553,'毁灭短靴','15阶粉色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010041500,4,650,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,785455},{4,19636}]','[]',0,0,6,0),(1010041563,'毁灭短靴','15阶神装鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010041500,4,650,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,981818},{4,24545}]','[]',0,0,6,0),(1010041600,'混沌短靴','16阶绿色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010041500,4,700,0,0,0,0,0,'[{1,3}]',0,0,0,0,'[{2,114680},{4,2867}]','[]',0,0,6,0),(1010041610,'混沌短靴','16阶蓝色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010041500,4,700,0,1,0,0,0,'[{1,7}]',0,0,0,0,'[{2,172020},{4,4300}]','[]',0,0,6,0),(1010041620,'混沌短靴','16阶紫色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010041500,4,700,0,2,0,0,0,'[{1,14}]',0,0,0,0,'[{2,313076},{4,7827}]','[]',0,0,6,0),(1010041631,'混沌短靴','16阶橙1星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010041500,4,700,0,3,0,0,0,'[{1,19}]',0,0,0,0,'[{2,381884},{4,9547}]','[]',0,0,6,0),(1010041632,'混沌短靴','16阶橙2星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010041500,4,700,0,3,0,0,0,'[{1,23}]',0,0,0,0,'[{2,381884},{4,9547}]','[]',0,0,6,0),(1010041641,'混沌短靴','16阶红1星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010041500,4,700,0,4,0,0,0,'[{1,112}]',0,0,0,0,'[{2,573400},{4,14335}]','[]',0,0,6,0),(1010041642,'混沌短靴','16阶红2星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010041500,4,700,0,4,0,0,0,'[{1,200}]',0,0,0,0,'[{2,573400},{4,14335}]','[]',0,0,6,0),(1010041643,'混沌短靴','16阶红3星鞋子【重炮手】','',0,'','',0,1,1,10,10,1,2,10,1010041500,4,700,0,4,0,0,0,'[{1,2044}]',0,0,0,0,'[{2,573400},{4,14335}]','[]',0,0,6,0),(1010041653,'混沌短靴','16阶粉色鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010041500,4,700,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,917440},{4,22936}]','[]',0,0,6,0),(1010041663,'混沌短靴','16阶神装鞋子【重炮手】','',0,'','',0,0,1,10,10,0,0,10,1010041500,4,700,0,6,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,1146800},{4,28670}]','[]',0,0,6,0),(1011000001,'经验馆主','我是经验馆主，用知识赋予你力量！佩戴增加<color=#8E00D2 >50%杀怪经验</color>，还可以<color=#8E00D2 >野外挂机自动拾取掉落物品</color>，挂机必备！','',0,'【打怪掉落,商城】','0',0,0,1,10,11,1,0,11,1011000001,0,0,0,2,0,0,2592000,'[]',0,0,0,0,'[{2,2000},{202,5000}]','[]',0,0,0,0),(1011000002,'白羊天使','听白羊天使的赞歌，抚慰受伤的灵魂！佩戴后<color=#8E00D2 >吸收主人13%伤害并增加100攻击</color>，打架战斗，独抗首领必备之物！','',0,'【商城】','0',0,1,1,10,11,1,0,11,1011000002,0,0,0,3,0,0,2592000,'[]',0,0,0,0,'[{1,100},{10,1300}]','[]',0,0,0,0),(1011000003,'辉曜馆主','我是辉曜馆主，用知识赋予你力量！佩戴增加<color=#8E00D2 >50%杀怪经验</color>，还可以<color=#8E00D2 >野外挂机自动拾取掉落物品</color>，挂机必备！','',0,'【商城】','0',0,0,1,10,11,1,0,11,1011000001,0,0,0,2,0,0,2592000,'[]',0,0,0,0,'[{2,4000},{202,7500}]','[]',0,0,0,0),(1011000004,'神圣白羊','听神圣白羊的赞歌，抚慰受伤的灵魂！佩戴后<color=#8E00D2 >吸收主人20%伤害并增加200攻击</color>，打架战斗，独抗首领必备之物！','',0,'【商城】','0',0,1,1,10,11,1,0,11,1011000002,0,0,0,3,0,0,2592000,'[]',0,0,0,0,'[{1,200},{10,2000}]','[]',0,0,0,0),(1011000005,'经验馆主体验版','我是经验馆主，用知识赋予你力量！佩戴增加<color=#8E00D2 >50%杀怪经验</color>，还可以<color=#8E00D2 >野外挂机自动拾取掉落物品</color>，挂机必备！','',0,'【打怪掉落,商城】','0',0,0,1,10,11,1,0,11,1011000001,0,0,0,2,0,0,1800,'[]',0,0,0,0,'[{2,2000},{202,5000}]','[]',0,0,0,0),(1101010320,'勇者之刃','【冲级豪礼-65】3阶紫色武器【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,0,0,10,1,0,0,1,1001010300,1,0,0,2,0,0,0,'[{1,2}]',0,0,0,0,'[{1,498},{3,249}]','[]',0,0,0,0),(1101010442,'先驱之刃','【开服首充】4阶红2星武器【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,1,1,1,1,1001010400,1,0,0,4,0,0,0,'[{1,21}]',0,0,0,0,'[{1,1835},{3,917}]','[]',0,0,0,0),(1101010531,'荣誉之刃','【冲级豪礼-165】5阶橙1星武器【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,1,1,1,1,1001010500,1,0,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{1,2116},{3,1058}]','[]',0,0,0,0),(1101010532,'荣誉之刃','【勇者盟约】5阶橙2星武器【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,1,1,1,1,1001010500,1,0,0,3,0,0,0,'[{1,13}]',0,0,0,0,'[{1,2116},{3,1058}]','[]',0,0,0,0),(1101010542,'荣誉之刃','【开服首充】5阶红2星武器【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,1,1,1,1,1001010500,1,0,0,4,0,0,0,'[{1,39}]',0,0,0,0,'[{1,3177},{3,1588}]','[]',0,0,0,0),(1101010543,'荣誉之刃','【开服累充】5阶红3星武器【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,1,1,1,1,1001010500,1,0,0,4,0,0,0,'[{1,115}]',0,0,0,0,'[{1,3177},{3,1588}]','[]',0,0,0,0),(1101010641,'贤者之刃','【冲级豪礼-230-250】6阶红1星武器【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,1,1,1,1,1001010600,1,0,0,4,0,0,0,'[{1,33}]',0,0,0,0,'[{1,4963},{3,2481}]','[]',0,0,0,0),(1101010732,'征服之刃','【开服冲榜-第11-30名】7阶橙2星武器【魔剑士】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,1,1,1,1,1001010700,1,0,0,3,0,0,0,'[{1,17}]',0,0,0,0,'[{1,4806},{3,2403}]','[]',0,0,0,0),(1101010742,'征服之刃','【开服冲榜-第4-10名】7阶红2星武器【魔剑士】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,1,1,1,1,1001010700,1,0,0,4,0,0,0,'[{1,75}]',0,0,0,0,'[{1,7216},{3,3608}]','[]',0,0,0,0),(1101010743,'征服之刃','【开服冲榜-第2-3名】7阶红3星武器【魔剑士】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,1,1,1,1,1001010700,1,0,0,4,0,0,0,'[{1,272}]',0,0,0,0,'[{1,7216},{3,3608}]','[]',0,0,0,0),(1101010753,'征服之刃','【开服冲榜-第1名】7阶粉色武器【魔剑士】','',0,'【运营活动】','[{0,0,0}]',0,0,0,10,1,0,0,1,1001010700,1,0,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,11546},{3,5773}]','[]',0,0,0,0),(1101010842,'守护之刃','【冲级豪礼-350-400】8阶红2星武器【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,1,1,1,1,1001010800,1,0,0,4,0,0,0,'[{1,84}]',0,0,0,0,'[{1,9962},{3,4981}]','[]',0,0,0,0),(1101020320,'勇者长枪','【冲级豪礼-65】3阶紫色武器【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,0,0,10,1,0,0,1,1001020300,2,0,0,2,0,0,0,'[{1,2}]',0,0,0,0,'[{1,498},{3,249}]','[]',0,0,0,0),(1101020442,'先驱长枪','【开服首充】4阶红2星武器【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,1,1,1,1,1001020400,2,0,0,4,0,0,0,'[{1,21}]',0,0,0,0,'[{1,1835},{3,917}]','[]',0,0,0,0),(1101020531,'荣誉长枪','【冲级豪礼-165】5阶橙1星武器【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,1,1,1,1,1001020500,2,0,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{1,2116},{3,1058}]','[]',0,0,0,0),(1101020532,'荣誉长枪','【勇者盟约】5阶橙2星武器【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,1,1,1,1,1001020500,2,0,0,3,0,0,0,'[{1,13}]',0,0,0,0,'[{1,2116},{3,1058}]','[]',0,0,0,0),(1101020542,'荣誉长枪','【开服首充】5阶红2星武器【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,1,1,1,1,1001020500,2,0,0,4,0,0,0,'[{1,39}]',0,0,0,0,'[{1,3177},{3,1588}]','[]',0,0,0,0),(1101020543,'荣誉长枪','【开服累充】5阶红3星武器【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,1,1,1,1,1001020500,2,0,0,4,0,0,0,'[{1,115}]',0,0,0,0,'[{1,3177},{3,1588}]','[]',0,0,0,0),(1101020641,'贤者长枪','【冲级豪礼-230-250】6阶红1星武器【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,1,1,1,1,1001020600,2,0,0,4,0,0,0,'[{1,33}]',0,0,0,0,'[{1,4963},{3,2481}]','[]',0,0,0,0),(1101020732,'征服长枪','【开服冲榜-第11-30名】7阶橙2星武器【龙骑士】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,1,1,1,1,1001020700,2,0,0,3,0,0,0,'[{1,17}]',0,0,0,0,'[{1,4806},{3,2403}]','[]',0,0,0,0),(1101020742,'征服长枪','【开服冲榜-第4-10名】7阶红2星武器【龙骑士】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,1,1,1,1,1001020700,2,0,0,4,0,0,0,'[{1,75}]',0,0,0,0,'[{1,7216},{3,3608}]','[]',0,0,0,0),(1101020743,'征服长枪','【开服冲榜-第2-3名】7阶红3星武器【龙骑士】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,1,1,1,1,1001020700,2,0,0,4,0,0,0,'[{1,272}]',0,0,0,0,'[{1,7216},{3,3608}]','[]',0,0,0,0),(1101020753,'征服长枪','【开服冲榜-第1名】7阶粉色武器【龙骑士】','',0,'【运营活动】','[{0,0,0}]',0,0,0,10,1,0,0,1,1001020700,2,0,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,11546},{3,5773}]','[]',0,0,0,0),(1101020842,'守护长枪','【冲级豪礼-350-400】8阶红2星武器【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,1,1,1,1,1001020800,2,0,0,4,0,0,0,'[{1,84}]',0,0,0,0,'[{1,9962},{3,4981}]','[]',0,0,0,0),(1101030320,'勇者法杖','【冲级豪礼-65】3阶紫色武器【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,0,0,10,1,0,0,1,1001030300,3,0,0,2,0,0,0,'[{1,2}]',0,0,0,0,'[{1,498},{3,249}]','[]',0,0,0,0),(1101030442,'先驱法杖','【开服首充】4阶红2星武器【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,1,1,1,1,1001030400,3,0,0,4,0,0,0,'[{1,21}]',0,0,0,0,'[{1,1835},{3,917}]','[]',0,0,0,0),(1101030531,'荣誉法杖','【冲级豪礼-165】5阶橙1星武器【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,1,1,1,1,1001030500,3,0,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{1,2116},{3,1058}]','[]',0,0,0,0),(1101030532,'荣誉法杖','【勇者盟约】5阶橙2星武器【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,1,1,1,1,1001030500,3,0,0,3,0,0,0,'[{1,13}]',0,0,0,0,'[{1,2116},{3,1058}]','[]',0,0,0,0),(1101030542,'荣誉法杖','【开服首充】5阶红2星武器【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,1,1,1,1,1001030500,3,0,0,4,0,0,0,'[{1,39}]',0,0,0,0,'[{1,3177},{3,1588}]','[]',0,0,0,0),(1101030543,'荣誉法杖','【开服累充】5阶红3星武器【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,1,1,1,1,1001030500,3,0,0,4,0,0,0,'[{1,115}]',0,0,0,0,'[{1,3177},{3,1588}]','[]',0,0,0,0),(1101030641,'贤者法杖','【冲级豪礼-230-250】6阶红1星武器【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,1,1,1,1,1001030600,3,0,0,4,0,0,0,'[{1,33}]',0,0,0,0,'[{1,4963},{3,2481}]','[]',0,0,0,0),(1101030732,'征服法杖','【开服冲榜-第11-30名】7阶橙2星武器【魔导师】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,1,1,1,1,1001030700,3,0,0,3,0,0,0,'[{1,17}]',0,0,0,0,'[{1,4806},{3,2403}]','[]',0,0,0,0),(1101030742,'征服法杖','【开服冲榜-第4-10名】7阶红2星武器【魔导师】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,1,1,1,1,1001030700,3,0,0,4,0,0,0,'[{1,75}]',0,0,0,0,'[{1,7216},{3,3608}]','[]',0,0,0,0),(1101030743,'征服法杖','【开服冲榜-第2-3名】7阶红3星武器【魔导师】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,1,1,1,1,1001030700,3,0,0,4,0,0,0,'[{1,272}]',0,0,0,0,'[{1,7216},{3,3608}]','[]',0,0,0,0),(1101030753,'征服法杖','【开服冲榜-第1名】7阶粉色武器【魔导师】','',0,'【运营活动】','[{0,0,0}]',0,0,0,10,1,0,0,1,1001030700,3,0,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,11546},{3,5773}]','[]',0,0,0,0),(1101030842,'守护法杖','【冲级豪礼-350-400】8阶红2星武器【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,1,1,1,1,1001030800,3,0,0,4,0,0,0,'[{1,84}]',0,0,0,0,'[{1,9962},{3,4981}]','[]',0,0,0,0),(1101040320,'勇者光炮','【冲级豪礼-65】3阶紫色武器【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,0,0,10,1,0,0,1,1001040300,4,0,0,2,0,0,0,'[{1,2}]',0,0,0,0,'[{1,498},{3,249}]','[]',0,0,0,0),(1101040442,'先驱光炮','【开服首充】4阶红2星武器【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,1,1,1,1,1001040400,4,0,0,4,0,0,0,'[{1,21}]',0,0,0,0,'[{1,1835},{3,917}]','[]',0,0,0,0),(1101040531,'荣誉光炮','【冲级豪礼-165】5阶橙1星武器【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,1,1,1,1,1001040500,4,0,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{1,2116},{3,1058}]','[]',0,0,0,0),(1101040532,'荣誉光炮','【勇者盟约】5阶橙2星武器【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,1,1,1,1,1001040500,4,0,0,3,0,0,0,'[{1,13}]',0,0,0,0,'[{1,2116},{3,1058}]','[]',0,0,0,0),(1101040542,'荣誉光炮','【开服首充】5阶红2星武器【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,1,1,1,1,1001040500,4,0,0,4,0,0,0,'[{1,39}]',0,0,0,0,'[{1,3177},{3,1588}]','[]',0,0,0,0),(1101040543,'荣誉光炮','【开服累充】5阶红3星武器【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,1,1,1,1,1001040500,4,0,0,4,0,0,0,'[{1,115}]',0,0,0,0,'[{1,3177},{3,1588}]','[]',0,0,0,0),(1101040641,'贤者光炮','【冲级豪礼-230-250】6阶红1星武器【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,1,1,1,1,1001040600,4,0,0,4,0,0,0,'[{1,33}]',0,0,0,0,'[{1,4963},{3,2481}]','[]',0,0,0,0),(1101040732,'征服光炮','【开服冲榜-第11-30名】7阶橙2星武器【重炮手】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,1,1,1,1,1001040700,4,0,0,3,0,0,0,'[{1,17}]',0,0,0,0,'[{1,4806},{3,2403}]','[]',0,0,0,0),(1101040742,'征服光炮','【开服冲榜-第4-10名】7阶红2星武器【重炮手】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,1,1,1,1,1001040700,4,0,0,4,0,0,0,'[{1,75}]',0,0,0,0,'[{1,7216},{3,3608}]','[]',0,0,0,0),(1101040743,'征服光炮','【开服冲榜-第2-3名】7阶红3星武器【重炮手】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,1,1,1,1,1001040700,4,0,0,4,0,0,0,'[{1,272}]',0,0,0,0,'[{1,7216},{3,3608}]','[]',0,0,0,0),(1101040753,'征服光炮','【开服冲榜-第1名】7阶粉色武器【重炮手】','',0,'【运营活动】','[{0,0,0}]',0,0,0,10,1,0,0,1,1001040700,4,0,0,5,0,0,0,'[{1,16667}]',0,0,0,0,'[{1,11546},{3,5773}]','[]',0,0,0,0),(1101040842,'守护光炮','【冲级豪礼-350-400】8阶红2星武器【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,1,1,1,1,1001040800,4,0,0,4,0,0,0,'[{1,84}]',0,0,0,0,'[{1,9962},{3,4981}]','[]',0,0,0,0),(1102010320,'勇者战盔','【冲级豪礼-65】3阶紫色头盔【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,0,0,10,2,0,0,2,1002010300,1,0,0,2,0,0,0,'[{1,2}]',0,0,0,0,'[{2,5427},{4,136}]','[]',0,0,0,0),(1102010442,'先驱战盔','【开服首充】4阶红2星头盔【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,2,1,2,2,1002010400,1,0,0,4,0,0,0,'[{1,18}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1102010531,'荣誉战盔','【冲级豪礼-165】5阶橙1星头盔【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,2,1,2,2,1002010500,1,0,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,0,0),(1102010532,'荣誉战盔','【勇者盟约】5阶橙2星头盔【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,2,1,2,2,1002010500,1,0,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,0,0),(1102010542,'荣誉战盔','【开服首充】5阶红2星头盔【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,2,1,2,2,1002010500,1,0,0,4,0,0,0,'[{1,32}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,0,0),(1102010543,'荣誉战盔','【开服累充】5阶红3星头盔【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,2,1,2,2,1002010500,1,0,0,4,0,0,0,'[{1,95}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,0,0),(1102010641,'贤者战盔','【冲级豪礼-230-250】6阶红1星头盔【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,2,1,2,2,1002010600,1,0,0,4,0,0,0,'[{1,27}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,0,0),(1102010732,'征服战盔','【开服冲榜-第11-30名】7阶橙2星头盔【魔剑士】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,2,1,2,2,1002010700,1,0,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{2,52429},{4,1311}]','[]',0,0,0,0),(1102010742,'征服战盔','【开服冲榜-第4-10名】7阶红2星头盔【魔剑士】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,2,1,2,2,1002010700,1,0,0,4,0,0,0,'[{1,62}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,0,0),(1102010743,'征服战盔','【开服冲榜-第2-3名】7阶红3星头盔【魔剑士】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,2,1,2,2,1002010700,1,0,0,4,0,0,0,'[{1,223}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,0,0),(1102010753,'征服战盔','【开服冲榜-第1名】7阶粉色头盔【魔剑士】','',0,'【运营活动】','[{0,0,0}]',0,0,0,10,2,0,0,2,1002010700,1,0,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,125955},{4,3149}]','[]',0,0,0,0),(1102010842,'守护战盔','【冲级豪礼-350-400】8阶红2星头盔【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,2,1,2,2,1002010800,1,0,0,4,0,0,0,'[{1,69}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,0,0),(1102020320,'勇者头盔','【冲级豪礼-65】3阶紫色头盔【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,0,0,10,2,0,0,2,1002020300,2,0,0,2,0,0,0,'[{1,2}]',0,0,0,0,'[{2,5427},{4,136}]','[]',0,0,0,0),(1102020442,'先驱头盔','【开服首充】4阶红2星头盔【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,2,1,2,2,1002020400,2,0,0,4,0,0,0,'[{1,18}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1102020531,'荣誉头盔','【冲级豪礼-165】5阶橙1星头盔【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,2,1,2,2,1002020500,2,0,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,0,0),(1102020532,'荣誉头盔','【勇者盟约】5阶橙2星头盔【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,2,1,2,2,1002020500,2,0,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,0,0),(1102020542,'荣誉头盔','【开服首充】5阶红2星头盔【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,2,1,2,2,1002020500,2,0,0,4,0,0,0,'[{1,32}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,0,0),(1102020543,'荣誉头盔','【开服累充】5阶红3星头盔【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,2,1,2,2,1002020500,2,0,0,4,0,0,0,'[{1,95}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,0,0),(1102020641,'贤者头盔','【冲级豪礼-230-250】6阶红1星头盔【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,2,1,2,2,1002020600,2,0,0,4,0,0,0,'[{1,27}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,0,0),(1102020732,'征服头盔','【开服冲榜-第11-30名】7阶橙2星头盔【龙骑士】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,2,1,2,2,1002020700,2,0,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{2,52429},{4,1311}]','[]',0,0,0,0),(1102020742,'征服头盔','【开服冲榜-第4-10名】7阶红2星头盔【龙骑士】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,2,1,2,2,1002020700,2,0,0,4,0,0,0,'[{1,62}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,0,0),(1102020743,'征服头盔','【开服冲榜-第2-3名】7阶红3星头盔【龙骑士】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,2,1,2,2,1002020700,2,0,0,4,0,0,0,'[{1,223}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,0,0),(1102020753,'征服头盔','【开服冲榜-第1名】7阶粉色头盔【龙骑士】','',0,'【运营活动】','[{0,0,0}]',0,0,0,10,2,0,0,2,1002020700,2,0,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,125955},{4,3149}]','[]',0,0,0,0),(1102020842,'守护头盔','【冲级豪礼-350-400】8阶红2星头盔【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,2,1,2,2,1002020800,2,0,0,4,0,0,0,'[{1,69}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,0,0),(1102030320,'勇者头冠','【冲级豪礼-65】3阶紫色头盔【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,0,0,10,2,0,0,2,1002030300,3,0,0,2,0,0,0,'[{1,2}]',0,0,0,0,'[{2,5427},{4,136}]','[]',0,0,0,0),(1102030442,'梵焰之刃','【开服首充】4阶红2星头盔【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,1,1,10,1,1,2,1,1001010500,1,0,0,4,0,0,0,'[{1,18}]',0,0,0,0,'[{1,666},{3,233}]','[]',0,0,0,0),(1102030531,'荣誉头冠','【冲级豪礼-165】5阶橙1星头盔【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,2,1,2,2,1002030500,3,0,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,0,0),(1102030532,'荣誉头冠','【勇者盟约】5阶橙2星头盔【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,2,1,2,2,1002030500,3,0,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,0,0),(1102030542,'荣誉头冠','【开服首充】5阶红2星头盔【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,2,1,2,2,1002030500,3,0,0,4,0,0,0,'[{1,32}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,0,0),(1102030543,'荣誉头冠','【开服累充】5阶红3星头盔【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,2,1,2,2,1002030500,3,0,0,4,0,0,0,'[{1,95}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,0,0),(1102030641,'贤者头冠','【冲级豪礼-230-250】6阶红1星头盔【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,2,1,2,2,1002030600,3,0,0,4,0,0,0,'[{1,27}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,0,0),(1102030732,'征服头冠','【开服冲榜-第11-30名】7阶橙2星头盔【魔导师】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,2,1,2,2,1002030700,3,0,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{2,52429},{4,1311}]','[]',0,0,0,0),(1102030742,'征服头冠','【开服冲榜-第4-10名】7阶红2星头盔【魔导师】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,2,1,2,2,1002030700,3,0,0,4,0,0,0,'[{1,62}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,0,0),(1102030743,'征服头冠','【开服冲榜-第2-3名】7阶红3星头盔【魔导师】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,2,1,2,2,1002030700,3,0,0,4,0,0,0,'[{1,223}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,0,0),(1102030753,'征服头冠','【开服冲榜-第1名】7阶粉色头盔【魔导师】','',0,'【运营活动】','[{0,0,0}]',0,0,0,10,2,0,0,2,1002030700,3,0,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,125955},{4,3149}]','[]',0,0,0,0),(1102030842,'守护头冠','【冲级豪礼-350-400】8阶红2星头盔【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,2,1,2,2,1002030800,3,0,0,4,0,0,0,'[{1,69}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,0,0),(1102040320,'勇者皮帽','【冲级豪礼-65】3阶紫色头盔【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,0,0,10,2,0,0,2,1002040300,4,0,0,2,0,0,0,'[{1,2}]',0,0,0,0,'[{2,5427},{4,136}]','[]',0,0,0,0),(1102040442,'梵焰长枪','【开服首充】4阶红2星头盔【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,1,1,10,1,1,2,1,1001020500,2,0,0,4,0,0,0,'[{1,18}]',0,0,0,0,'[{1,666},{3,233}]','[]',0,0,0,0),(1102040531,'荣誉皮帽','【冲级豪礼-165】5阶橙1星头盔【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,2,1,2,2,1002040500,4,0,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,0,0),(1102040532,'荣誉皮帽','【勇者盟约】5阶橙2星头盔【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,2,1,2,2,1002040500,4,0,0,3,0,0,0,'[{1,11}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,0,0),(1102040542,'荣誉皮帽','【开服首充】5阶红2星头盔【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,2,1,2,2,1002040500,4,0,0,4,0,0,0,'[{1,32}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,0,0),(1102040543,'荣誉皮帽','【开服累充】5阶红3星头盔【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,2,1,2,2,1002040500,4,0,0,4,0,0,0,'[{1,95}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,0,0),(1102040641,'贤者皮帽','【冲级豪礼-230-250】6阶红1星头盔【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,2,1,2,2,1002040600,4,0,0,4,0,0,0,'[{1,27}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,0,0),(1102040732,'征服皮帽','【开服冲榜-第11-30名】7阶橙2星头盔【重炮手】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,2,1,2,2,1002040700,4,0,0,3,0,0,0,'[{1,14}]',0,0,0,0,'[{2,52429},{4,1311}]','[]',0,0,0,0),(1102040742,'征服皮帽','【开服冲榜-第4-10名】7阶红2星头盔【重炮手】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,2,1,2,2,1002040700,4,0,0,4,0,0,0,'[{1,62}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,0,0),(1102040743,'征服皮帽','【开服冲榜-第2-3名】7阶红3星头盔【重炮手】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,2,1,2,2,1002040700,4,0,0,4,0,0,0,'[{1,223}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,0,0),(1102040753,'征服皮帽','【开服冲榜-第1名】7阶粉色头盔【重炮手】','',0,'【运营活动】','[{0,0,0}]',0,0,0,10,2,0,0,2,1002040700,4,0,0,5,0,0,0,'[{1,13637}]',0,0,0,0,'[{2,125955},{4,3149}]','[]',0,0,0,0),(1102040842,'守护皮帽','【冲级豪礼-350-400】8阶红2星头盔【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,2,1,2,2,1002040800,4,0,0,4,0,0,0,'[{1,69}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,0,0),(1103000320,'勇者项链','【冲级豪礼-65】3阶紫色项链【通用】','',0,'【运营活动】','[{0,0,0}]',1,0,0,10,3,0,0,3,1003000300,0,0,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{1,332},{3,166}]','[]',0,0,0,0),(1103000442,'梵焰法杖','【开服首充】4阶红2星项链【通用】','',0,'【运营活动】','[{0,0,0}]',1,1,1,10,1,1,3,1,1001030500,3,0,0,4,0,0,0,'[{1,14}]',0,0,0,0,'[{1,666},{3,233}]','[]',0,0,0,0),(1103000531,'荣誉项链','【冲级豪礼-165】5阶橙1星项链【通用】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,3,1,3,3,1003000500,0,0,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{1,1411},{3,705}]','[]',0,0,0,0),(1103000532,'荣誉项链','【勇者盟约】5阶橙2星项链【通用】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,3,1,3,3,1003000500,0,0,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{1,1411},{3,705}]','[]',0,0,0,0),(1103000542,'荣誉项链','【开服首充】5阶红2星项链【通用】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,3,1,3,3,1003000500,0,0,0,4,0,0,0,'[{1,26}]',0,0,0,0,'[{1,2118},{3,1059}]','[]',0,0,0,0),(1103000543,'荣誉项链','【开服累充】5阶红3星项链【通用】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,3,1,3,3,1003000500,0,0,0,4,0,0,0,'[{1,77}]',0,0,0,0,'[{1,2118},{3,1059}]','[]',0,0,0,0),(1103000641,'贤者项链','【冲级豪礼-230-250】6阶红1星项链【通用】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,3,1,3,3,1003000600,0,0,0,4,0,0,0,'[{1,22}]',0,0,0,0,'[{1,3308},{3,1654}]','[]',0,0,0,0),(1103000732,'征服项链','【开服冲榜-第11-30名】7阶橙2星项链【通用】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,3,1,3,3,1003000700,0,0,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{1,3204},{3,1602}]','[]',0,0,0,0),(1103000742,'征服项链','【开服冲榜-第4-10名】7阶红2星项链【通用】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,3,1,3,3,1003000700,0,0,0,4,0,0,0,'[{1,50}]',0,0,0,0,'[{1,4811},{3,2405}]','[]',0,0,0,0),(1103000743,'征服项链','【开服冲榜-第2-3名】7阶红3星项链【通用】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,3,1,3,3,1003000700,0,0,0,4,0,0,0,'[{1,182}]',0,0,0,0,'[{1,4811},{3,2405}]','[]',0,0,0,0),(1103000753,'征服项链','【开服冲榜-第1名】7阶粉色项链【通用】','',0,'【运营活动】','[{0,0,0}]',0,0,0,10,3,0,0,3,1003000700,0,0,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,7697},{3,3849}]','[]',0,0,0,0),(1103000842,'守护项链','【冲级豪礼-350-400】8阶红2星项链【通用】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,3,1,3,3,1003000800,0,0,0,4,0,0,0,'[{1,56}]',0,0,0,0,'[{1,6641},{3,3321}]','[]',0,0,0,0),(1104010320,'勇者战甲','【冲级豪礼-65】3阶紫色衣服【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,0,0,10,4,0,0,4,1004010300,1,0,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,8141},{4,204}]','[]',0,0,0,0),(1104010442,'梵焰光炮','【开服首充】4阶红2星衣服【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,1,1,10,1,1,2,1,1001040500,4,0,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{1,666},{3,233}]','[]',0,0,0,0),(1104010531,'荣誉战甲','【冲级豪礼-165】5阶橙1星衣服【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,4,1,2,4,1004010500,1,0,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,34623},{4,866}]','[]',0,0,0,0),(1104010532,'荣誉战甲','【勇者盟约】5阶橙2星衣服【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,4,1,2,4,1004010500,1,0,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{2,34623},{4,866}]','[]',0,0,0,0),(1104010542,'荣誉战甲','【开服首充】5阶红2星衣服【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,4,1,2,4,1004010500,1,0,0,4,0,0,0,'[{1,21}]',0,0,0,0,'[{2,51986},{4,1300}]','[]',0,0,0,0),(1104010543,'荣誉战甲','【开服累充】5阶红3星衣服【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,4,1,2,4,1004010500,1,0,0,4,0,0,0,'[{1,63}]',0,0,0,0,'[{2,51986},{4,1300}]','[]',0,0,0,0),(1104010641,'贤者战甲','【冲级豪礼-230-250】6阶红1星衣服【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,4,1,2,4,1004010600,1,0,0,4,0,0,0,'[{1,18}]',0,0,0,0,'[{2,81207},{4,2030}]','[]',0,0,0,0),(1104010732,'征服战甲','【开服冲榜-第11-30名】7阶橙2星衣服【魔剑士】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,4,1,2,4,1004010700,1,0,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,78643},{4,1966}]','[]',0,0,0,0),(1104010742,'征服战甲','【开服冲榜-第4-10名】7阶红2星衣服【魔剑士】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,4,1,2,4,1004010700,1,0,0,4,0,0,0,'[{1,41}]',0,0,0,0,'[{2,118082},{4,2952}]','[]',0,0,0,0),(1104010743,'征服战甲','【开服冲榜-第2-3名】7阶红3星衣服【魔剑士】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,4,1,2,4,1004010700,1,0,0,4,0,0,0,'[{1,149}]',0,0,0,0,'[{2,118082},{4,2952}]','[]',0,0,0,0),(1104010753,'征服战甲','【开服冲榜-第1名】7阶粉色衣服【魔剑士】','',0,'【运营活动】','[{0,0,0}]',0,0,0,10,4,0,0,4,1004010700,1,0,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,188932},{4,4723}]','[]',0,0,0,0),(1104010842,'守护战甲','【冲级豪礼-350-400】8阶红2星衣服【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,4,1,2,4,1004010800,1,0,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{2,163014},{4,4075}]','[]',0,0,0,0),(1104020320,'勇者胸甲','【冲级豪礼-65】3阶紫色衣服【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,0,0,10,4,0,0,4,1004020300,2,0,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,8141},{4,204}]','[]',0,0,0,0),(1104020442,'先驱胸甲','【开服首充】4阶红2星衣服【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,4,1,2,4,1004020400,2,0,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,30021},{4,751}]','[]',0,0,0,0),(1104020531,'荣誉胸甲','【冲级豪礼-165】5阶橙1星衣服【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,4,1,2,4,1004020500,2,0,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,34623},{4,866}]','[]',0,0,0,0),(1104020532,'荣誉胸甲','【勇者盟约】5阶橙2星衣服【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,4,1,2,4,1004020500,2,0,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{2,34623},{4,866}]','[]',0,0,0,0),(1104020542,'荣誉胸甲','【开服首充】5阶红2星衣服【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,4,1,2,4,1004020500,2,0,0,4,0,0,0,'[{1,21}]',0,0,0,0,'[{2,51986},{4,1300}]','[]',0,0,0,0),(1104020543,'荣誉胸甲','【开服累充】5阶红3星衣服【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,4,1,2,4,1004020500,2,0,0,4,0,0,0,'[{1,63}]',0,0,0,0,'[{2,51986},{4,1300}]','[]',0,0,0,0),(1104020641,'贤者胸甲','【冲级豪礼-230-250】6阶红1星衣服【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,4,1,2,4,1004020600,2,0,0,4,0,0,0,'[{1,18}]',0,0,0,0,'[{2,81207},{4,2030}]','[]',0,0,0,0),(1104020732,'征服胸甲','【开服冲榜-第11-30名】7阶橙2星衣服【龙骑士】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,4,1,2,4,1004020700,2,0,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,78643},{4,1966}]','[]',0,0,0,0),(1104020742,'征服胸甲','【开服冲榜-第4-10名】7阶红2星衣服【龙骑士】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,4,1,2,4,1004020700,2,0,0,4,0,0,0,'[{1,41}]',0,0,0,0,'[{2,118082},{4,2952}]','[]',0,0,0,0),(1104020743,'征服胸甲','【开服冲榜-第2-3名】7阶红3星衣服【龙骑士】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,4,1,2,4,1004020700,2,0,0,4,0,0,0,'[{1,149}]',0,0,0,0,'[{2,118082},{4,2952}]','[]',0,0,0,0),(1104020753,'征服胸甲','【开服冲榜-第1名】7阶粉色衣服【龙骑士】','',0,'【运营活动】','[{0,0,0}]',0,0,0,10,4,0,0,4,1004020700,2,0,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,188932},{4,4723}]','[]',0,0,0,0),(1104020842,'守护胸甲','【冲级豪礼-350-400】8阶红2星衣服【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,4,1,2,4,1004020800,2,0,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{2,163014},{4,4075}]','[]',0,0,0,0),(1104030320,'勇者裙甲','【冲级豪礼-65】3阶紫色衣服【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,0,0,10,4,0,0,4,1004030300,3,0,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,8141},{4,204}]','[]',0,0,0,0),(1104030442,'先驱裙甲','【开服首充】4阶红2星衣服【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,4,1,2,4,1004030400,3,0,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,30021},{4,751}]','[]',0,0,0,0),(1104030531,'荣誉裙甲','【冲级豪礼-165】5阶橙1星衣服【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,4,1,2,4,1004030500,3,0,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,34623},{4,866}]','[]',0,0,0,0),(1104030532,'荣誉裙甲','【勇者盟约】5阶橙2星衣服【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,4,1,2,4,1004030500,3,0,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{2,34623},{4,866}]','[]',0,0,0,0),(1104030542,'荣誉裙甲','【开服首充】5阶红2星衣服【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,4,1,2,4,1004030500,3,0,0,4,0,0,0,'[{1,21}]',0,0,0,0,'[{2,51986},{4,1300}]','[]',0,0,0,0),(1104030543,'荣誉裙甲','【开服累充】5阶红3星衣服【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,4,1,2,4,1004030500,3,0,0,4,0,0,0,'[{1,63}]',0,0,0,0,'[{2,51986},{4,1300}]','[]',0,0,0,0),(1104030641,'贤者裙甲','【冲级豪礼-230-250】6阶红1星衣服【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,4,1,2,4,1004030600,3,0,0,4,0,0,0,'[{1,18}]',0,0,0,0,'[{2,81207},{4,2030}]','[]',0,0,0,0),(1104030732,'征服裙甲','【开服冲榜-第11-30名】7阶橙2星衣服【魔导师】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,4,1,2,4,1004030700,3,0,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,78643},{4,1966}]','[]',0,0,0,0),(1104030742,'征服裙甲','【开服冲榜-第4-10名】7阶红2星衣服【魔导师】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,4,1,2,4,1004030700,3,0,0,4,0,0,0,'[{1,41}]',0,0,0,0,'[{2,118082},{4,2952}]','[]',0,0,0,0),(1104030743,'征服裙甲','【开服冲榜-第2-3名】7阶红3星衣服【魔导师】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,4,1,2,4,1004030700,3,0,0,4,0,0,0,'[{1,149}]',0,0,0,0,'[{2,118082},{4,2952}]','[]',0,0,0,0),(1104030753,'征服裙甲','【开服冲榜-第1名】7阶粉色衣服【魔导师】','',0,'【运营活动】','[{0,0,0}]',0,0,0,10,4,0,0,4,1004030700,3,0,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,188932},{4,4723}]','[]',0,0,0,0),(1104030842,'守护裙甲','【冲级豪礼-350-400】8阶红2星衣服【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,4,1,2,4,1004030800,3,0,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{2,163014},{4,4075}]','[]',0,0,0,0),(1104040320,'勇者皮甲','【冲级豪礼-65】3阶紫色衣服【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,0,0,10,4,0,0,4,1004040300,4,0,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,8141},{4,204}]','[]',0,0,0,0),(1104040442,'先驱皮甲','【开服首充】4阶红2星衣服【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,4,1,2,4,1004040400,4,0,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,30021},{4,751}]','[]',0,0,0,0),(1104040531,'荣誉皮甲','【冲级豪礼-165】5阶橙1星衣服【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,4,1,2,4,1004040500,4,0,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,34623},{4,866}]','[]',0,0,0,0),(1104040532,'荣誉皮甲','【勇者盟约】5阶橙2星衣服【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,4,1,2,4,1004040500,4,0,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{2,34623},{4,866}]','[]',0,0,0,0),(1104040542,'荣誉皮甲','【开服首充】5阶红2星衣服【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,4,1,2,4,1004040500,4,0,0,4,0,0,0,'[{1,21}]',0,0,0,0,'[{2,51986},{4,1300}]','[]',0,0,0,0),(1104040543,'荣誉皮甲','【开服累充】5阶红3星衣服【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,4,1,2,4,1004040500,4,0,0,4,0,0,0,'[{1,63}]',0,0,0,0,'[{2,51986},{4,1300}]','[]',0,0,0,0),(1104040641,'贤者皮甲','【冲级豪礼-230-250】6阶红1星衣服【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,4,1,2,4,1004040600,4,0,0,4,0,0,0,'[{1,18}]',0,0,0,0,'[{2,81207},{4,2030}]','[]',0,0,0,0),(1104040732,'征服皮甲','【开服冲榜-第11-30名】7阶橙2星衣服【重炮手】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,4,1,2,4,1004040700,4,0,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,78643},{4,1966}]','[]',0,0,0,0),(1104040742,'征服皮甲','【开服冲榜-第4-10名】7阶红2星衣服【重炮手】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,4,1,2,4,1004040700,4,0,0,4,0,0,0,'[{1,41}]',0,0,0,0,'[{2,118082},{4,2952}]','[]',0,0,0,0),(1104040743,'征服皮甲','【开服冲榜-第2-3名】7阶红3星衣服【重炮手】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,4,1,2,4,1004040700,4,0,0,4,0,0,0,'[{1,149}]',0,0,0,0,'[{2,118082},{4,2952}]','[]',0,0,0,0),(1104040753,'征服皮甲','【开服冲榜-第1名】7阶粉色衣服【重炮手】','',0,'【运营活动】','[{0,0,0}]',0,0,0,10,4,0,0,4,1004040700,4,0,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,188932},{4,4723}]','[]',0,0,0,0),(1104040842,'守护皮甲','【冲级豪礼-350-400】8阶红2星衣服【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,4,1,2,4,1004040800,4,0,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{2,163014},{4,4075}]','[]',0,0,0,0),(1105000320,'勇者刻痕','【冲级豪礼-65】3阶紫色刻痕【通用】','',0,'【运营活动】','[{0,0,0}]',1,0,0,10,5,0,0,5,1005000300,0,0,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{1,166},{3,83}]','[]',0,0,0,0),(1105000442,'先驱刻痕','【开服首充】4阶红2星刻痕【通用】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,5,1,3,5,1005000400,0,0,0,4,0,0,0,'[{1,7}]',0,0,0,0,'[{1,612},{3,306}]','[]',0,0,0,0),(1105000531,'荣誉刻痕','【冲级豪礼-165】5阶橙1星刻痕【通用】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,5,1,3,5,1005000500,0,0,0,3,0,0,0,'[{1,4}]',0,0,0,0,'[{1,705},{3,353}]','[]',0,0,0,0),(1105000532,'荣誉刻痕','【勇者盟约】5阶橙2星刻痕【通用】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,5,1,3,5,1005000500,0,0,0,3,0,0,0,'[{1,5}]',0,0,0,0,'[{1,705},{3,353}]','[]',0,0,0,0),(1105000542,'荣誉刻痕','【开服首充】5阶红2星刻痕【通用】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,5,1,3,5,1005000500,0,0,0,4,0,0,0,'[{1,13}]',0,0,0,0,'[{1,1059},{3,529}]','[]',0,0,0,0),(1105000543,'荣誉刻痕','【开服累充】5阶红3星刻痕【通用】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,5,1,3,5,1005000500,0,0,0,4,0,0,0,'[{1,39}]',0,0,0,0,'[{1,1059},{3,529}]','[]',0,0,0,0),(1105000641,'贤者刻痕','【冲级豪礼-230-250】6阶红1星刻痕【通用】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,5,1,3,5,1005000600,0,0,0,4,0,0,0,'[{1,11}]',0,0,0,0,'[{1,1654},{3,827}]','[]',0,0,0,0),(1105000732,'征服刻痕','【开服冲榜-第11-30名】7阶橙2星刻痕【通用】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,5,1,3,5,1005000700,0,0,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{1,1602},{3,801}]','[]',0,0,0,0),(1105000742,'征服刻痕','【开服冲榜-第4-10名】7阶红2星刻痕【通用】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,5,1,3,5,1005000700,0,0,0,4,0,0,0,'[{1,25}]',0,0,0,0,'[{1,2405},{3,1203}]','[]',0,0,0,0),(1105000743,'征服刻痕','【开服冲榜-第2-3名】7阶红3星刻痕【通用】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,5,1,3,5,1005000700,0,0,0,4,0,0,0,'[{1,91}]',0,0,0,0,'[{1,2405},{3,1203}]','[]',0,0,0,0),(1105000753,'征服刻痕','【开服冲榜-第1名】7阶粉色刻痕【通用】','',0,'【运营活动】','[{0,0,0}]',1,0,0,10,5,0,0,5,1005000700,0,0,0,5,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,3849},{3,1924}]','[]',0,0,0,0),(1105000842,'守护刻痕','【冲级豪礼-350-400】8阶红2星刻痕【通用】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,5,1,3,5,1005000800,0,0,0,4,0,0,0,'[{1,28}]',0,0,0,0,'[{1,3321},{3,1660}]','[]',0,0,0,0),(1106010320,'勇者战腿','【冲级豪礼-65】3阶紫色裤子【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,0,0,10,6,0,0,6,1006010300,1,0,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,5427},{4,136}]','[]',0,0,0,0),(1106010442,'先驱战腿','【开服首充】4阶红2星裤子【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,6,1,2,6,1006010400,1,0,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1106010531,'荣誉战腿','【冲级豪礼-165】5阶橙1星裤子【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,6,1,2,6,1006010500,1,0,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,0,0),(1106010532,'荣誉战腿','【勇者盟约】5阶橙2星裤子【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,6,1,2,6,1006010500,1,0,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,0,0),(1106010542,'荣誉战腿','【开服首充】5阶红2星裤子【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,6,1,2,6,1006010500,1,0,0,4,0,0,0,'[{1,21}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,0,0),(1106010543,'荣誉战腿','【开服累充】5阶红3星裤子【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,6,1,2,6,1006010500,1,0,0,4,0,0,0,'[{1,63}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,0,0),(1106010641,'贤者战腿','【冲级豪礼-230-250】6阶红1星裤子【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,6,1,2,6,1006010600,1,0,0,4,0,0,0,'[{1,18}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,0,0),(1106010732,'征服战腿','【开服冲榜-第11-30名】7阶橙2星裤子【魔剑士】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,6,1,2,6,1006010700,1,0,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,52429},{4,1311}]','[]',0,0,0,0),(1106010742,'征服战腿','【开服冲榜-第4-10名】7阶红2星裤子【魔剑士】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,6,1,2,6,1006010700,1,0,0,4,0,0,0,'[{1,41}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,0,0),(1106010743,'征服战腿','【开服冲榜-第2-3名】7阶红3星裤子【魔剑士】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,6,1,2,6,1006010700,1,0,0,4,0,0,0,'[{1,149}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,0,0),(1106010753,'征服战腿','【开服冲榜-第1名】7阶粉色裤子【魔剑士】','',0,'【运营活动】','[{0,0,0}]',0,0,0,10,6,0,0,6,1006010700,1,0,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,125955},{4,3149}]','[]',0,0,0,0),(1106010842,'守护战腿','【冲级豪礼-350-400】8阶红2星裤子【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,6,1,2,6,1006010800,1,0,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,0,0),(1106020320,'勇者护腿','【冲级豪礼-65】3阶紫色裤子【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,0,0,10,6,0,0,6,1006020300,2,0,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,5427},{4,136}]','[]',0,0,0,0),(1106020442,'先驱护腿','【开服首充】4阶红2星裤子【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,6,1,2,6,1006020400,2,0,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1106020531,'荣誉护腿','【冲级豪礼-165】5阶橙1星裤子【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,6,1,2,6,1006020500,2,0,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,0,0),(1106020532,'荣誉护腿','【勇者盟约】5阶橙2星裤子【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,6,1,2,6,1006020500,2,0,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,0,0),(1106020542,'荣誉护腿','【开服首充】5阶红2星裤子【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,6,1,2,6,1006020500,2,0,0,4,0,0,0,'[{1,21}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,0,0),(1106020543,'荣誉护腿','【开服累充】5阶红3星裤子【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,6,1,2,6,1006020500,2,0,0,4,0,0,0,'[{1,63}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,0,0),(1106020641,'贤者护腿','【冲级豪礼-230-250】6阶红1星裤子【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,6,1,2,6,1006020600,2,0,0,4,0,0,0,'[{1,18}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,0,0),(1106020732,'征服护腿','【开服冲榜-第11-30名】7阶橙2星裤子【龙骑士】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,6,1,2,6,1006020700,2,0,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,52429},{4,1311}]','[]',0,0,0,0),(1106020742,'征服护腿','【开服冲榜-第4-10名】7阶红2星裤子【龙骑士】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,6,1,2,6,1006020700,2,0,0,4,0,0,0,'[{1,41}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,0,0),(1106020743,'征服护腿','【开服冲榜-第2-3名】7阶红3星裤子【龙骑士】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,6,1,2,6,1006020700,2,0,0,4,0,0,0,'[{1,149}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,0,0),(1106020753,'征服护腿','【开服冲榜-第1名】7阶粉色裤子【龙骑士】','',0,'【运营活动】','[{0,0,0}]',0,0,0,10,6,0,0,6,1006020700,2,0,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,125955},{4,3149}]','[]',0,0,0,0),(1106020842,'守护护腿','【冲级豪礼-350-400】8阶红2星裤子【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,6,1,2,6,1006020800,2,0,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,0,0),(1106030320,'勇者裤裙','【冲级豪礼-65】3阶紫色裤子【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,0,0,10,6,0,0,6,1006030300,3,0,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,5427},{4,136}]','[]',0,0,0,0),(1106030442,'先驱裤裙','【开服首充】4阶红2星裤子【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,6,1,2,6,1006030400,3,0,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1106030531,'荣誉裤裙','【冲级豪礼-165】5阶橙1星裤子【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,6,1,2,6,1006030500,3,0,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,0,0),(1106030532,'荣誉裤裙','【勇者盟约】5阶橙2星裤子【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,6,1,2,6,1006030500,3,0,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,0,0),(1106030542,'荣誉裤裙','【开服首充】5阶红2星裤子【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,6,1,2,6,1006030500,3,0,0,4,0,0,0,'[{1,21}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,0,0),(1106030543,'荣誉裤裙','【开服累充】5阶红3星裤子【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,6,1,2,6,1006030500,3,0,0,4,0,0,0,'[{1,63}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,0,0),(1106030641,'贤者裤裙','【冲级豪礼-230-250】6阶红1星裤子【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,6,1,2,6,1006030600,3,0,0,4,0,0,0,'[{1,18}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,0,0),(1106030732,'征服裤裙','【开服冲榜-第11-30名】7阶橙2星裤子【魔导师】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,6,1,2,6,1006030700,3,0,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,52429},{4,1311}]','[]',0,0,0,0),(1106030742,'征服裤裙','【开服冲榜-第4-10名】7阶红2星裤子【魔导师】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,6,1,2,6,1006030700,3,0,0,4,0,0,0,'[{1,41}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,0,0),(1106030743,'征服裤裙','【开服冲榜-第2-3名】7阶红3星裤子【魔导师】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,6,1,2,6,1006030700,3,0,0,4,0,0,0,'[{1,149}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,0,0),(1106030753,'征服裤裙','【开服冲榜-第1名】7阶粉色裤子【魔导师】','',0,'【运营活动】','[{0,0,0}]',0,0,0,10,6,0,0,6,1006030700,3,0,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,125955},{4,3149}]','[]',0,0,0,0),(1106030842,'守护裤裙','【冲级豪礼-350-400】8阶红2星裤子【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,6,1,2,6,1006030800,3,0,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,0,0),(1106040320,'勇者绑腿','【冲级豪礼-65】3阶紫色裤子【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,0,0,10,6,0,0,6,1006040300,4,0,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,5427},{4,136}]','[]',0,0,0,0),(1106040442,'先驱绑腿','【开服首充】4阶红2星裤子【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,6,1,2,6,1006040400,4,0,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1106040531,'荣誉绑腿','【冲级豪礼-165】5阶橙1星裤子【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,6,1,2,6,1006040500,4,0,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,0,0),(1106040532,'荣誉绑腿','【勇者盟约】5阶橙2星裤子【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,6,1,2,6,1006040500,4,0,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,0,0),(1106040542,'荣誉绑腿','【开服首充】5阶红2星裤子【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,6,1,2,6,1006040500,4,0,0,4,0,0,0,'[{1,21}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,0,0),(1106040543,'荣誉绑腿','【开服累充】5阶红3星裤子【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,6,1,2,6,1006040500,4,0,0,4,0,0,0,'[{1,63}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,0,0),(1106040641,'贤者绑腿','【冲级豪礼-230-250】6阶红1星裤子【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,6,1,2,6,1006040600,4,0,0,4,0,0,0,'[{1,18}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,0,0),(1106040732,'征服绑腿','【开服冲榜-第11-30名】7阶橙2星裤子【重炮手】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,6,1,2,6,1006040700,4,0,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,52429},{4,1311}]','[]',0,0,0,0),(1106040742,'征服绑腿','【开服冲榜-第4-10名】7阶红2星裤子【重炮手】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,6,1,2,6,1006040700,4,0,0,4,0,0,0,'[{1,41}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,0,0),(1106040743,'征服绑腿','【开服冲榜-第2-3名】7阶红3星裤子【重炮手】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,6,1,2,6,1006040700,4,0,0,4,0,0,0,'[{1,149}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,0,0),(1106040753,'征服绑腿','【开服冲榜-第1名】7阶粉色裤子【重炮手】','',0,'【运营活动】','[{0,0,0}]',0,0,0,10,6,0,0,6,1006040700,4,0,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,125955},{4,3149}]','[]',0,0,0,0),(1106040842,'守护绑腿','【冲级豪礼-350-400】8阶红2星裤子【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,6,1,2,6,1006040800,4,0,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,0,0),(1107010320,'勇者拳爪','【冲级豪礼-65】3阶紫色副手【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,0,0,10,7,0,0,7,1007010300,1,0,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{1,332},{3,166}]','[]',0,0,0,0),(1107010442,'先驱拳爪','【开服首充】4阶红2星副手【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,7,1,1,7,1007010400,1,0,0,4,0,0,0,'[{1,14}]',0,0,0,0,'[{1,1223},{3,612}]','[]',0,0,0,0),(1107010531,'荣誉拳爪','【冲级豪礼-165】5阶橙1星副手【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,7,1,1,7,1007010500,1,0,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{1,1411},{3,705}]','[]',0,0,0,0),(1107010532,'荣誉拳爪','【勇者盟约】5阶橙2星副手【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,7,1,1,7,1007010500,1,0,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{1,1411},{3,705}]','[]',0,0,0,0),(1107010542,'荣誉拳爪','【开服首充】5阶红2星副手【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,7,1,1,7,1007010500,1,0,0,4,0,0,0,'[{1,26}]',0,0,0,0,'[{1,2118},{3,1059}]','[]',0,0,0,0),(1107010543,'荣誉拳爪','【开服累充】5阶红3星副手【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,7,1,1,7,1007010500,1,0,0,4,0,0,0,'[{1,77}]',0,0,0,0,'[{1,2118},{3,1059}]','[]',0,0,0,0),(1107010641,'贤者拳爪','【冲级豪礼-230-250】6阶红1星副手【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,7,1,1,7,1007010600,1,0,0,4,0,0,0,'[{1,22}]',0,0,0,0,'[{1,3308},{3,1654}]','[]',0,0,0,0),(1107010732,'征服拳爪','【开服冲榜-第11-30名】7阶橙2星副手【魔剑士】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,7,1,1,7,1007010700,1,0,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{1,3204},{3,1602}]','[]',0,0,0,0),(1107010742,'征服拳爪','【开服冲榜-第4-10名】7阶红2星副手【魔剑士】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,7,1,1,7,1007010700,1,0,0,4,0,0,0,'[{1,50}]',0,0,0,0,'[{1,4811},{3,2405}]','[]',0,0,0,0),(1107010743,'征服拳爪','【开服冲榜-第2-3名】7阶红3星副手【魔剑士】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,7,1,1,7,1007010700,1,0,0,4,0,0,0,'[{1,182}]',0,0,0,0,'[{1,4811},{3,2405}]','[]',0,0,0,0),(1107010753,'征服拳爪','【开服冲榜-第1名】7阶粉色副手【魔剑士】','',0,'【运营活动】','[{0,0,0}]',0,0,0,10,7,0,0,7,1007010700,1,0,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,7697},{3,3849}]','[]',0,0,0,0),(1107010842,'守护拳爪','【冲级豪礼-350-400】8阶红2星副手【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,7,1,1,7,1007010800,1,0,0,4,0,0,0,'[{1,56}]',0,0,0,0,'[{1,6641},{3,3321}]','[]',0,0,0,0),(1107020320,'勇者短枪','【冲级豪礼-65】3阶紫色副手【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,0,0,10,7,0,0,7,1007020300,2,0,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{1,332},{3,166}]','[]',0,0,0,0),(1107020442,'先驱短枪','【开服首充】4阶红2星副手【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,7,1,1,7,1007020400,2,0,0,4,0,0,0,'[{1,14}]',0,0,0,0,'[{1,1223},{3,612}]','[]',0,0,0,0),(1107020531,'荣誉短枪','【冲级豪礼-165】5阶橙1星副手【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,7,1,1,7,1007020500,2,0,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{1,1411},{3,705}]','[]',0,0,0,0),(1107020532,'荣誉短枪','【勇者盟约】5阶橙2星副手【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,7,1,1,7,1007020500,2,0,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{1,1411},{3,705}]','[]',0,0,0,0),(1107020542,'荣誉短枪','【开服首充】5阶红2星副手【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,7,1,1,7,1007020500,2,0,0,4,0,0,0,'[{1,26}]',0,0,0,0,'[{1,2118},{3,1059}]','[]',0,0,0,0),(1107020543,'荣誉短枪','【开服累充】5阶红3星副手【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,7,1,1,7,1007020500,2,0,0,4,0,0,0,'[{1,77}]',0,0,0,0,'[{1,2118},{3,1059}]','[]',0,0,0,0),(1107020641,'贤者短枪','【冲级豪礼-230-250】6阶红1星副手【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,7,1,1,7,1007020600,2,0,0,4,0,0,0,'[{1,22}]',0,0,0,0,'[{1,3308},{3,1654}]','[]',0,0,0,0),(1107020732,'征服短枪','【开服冲榜-第11-30名】7阶橙2星副手【龙骑士】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,7,1,1,7,1007020700,2,0,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{1,3204},{3,1602}]','[]',0,0,0,0),(1107020742,'征服短枪','【开服冲榜-第4-10名】7阶红2星副手【龙骑士】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,7,1,1,7,1007020700,2,0,0,4,0,0,0,'[{1,50}]',0,0,0,0,'[{1,4811},{3,2405}]','[]',0,0,0,0),(1107020743,'征服短枪','【开服冲榜-第2-3名】7阶红3星副手【龙骑士】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,7,1,1,7,1007020700,2,0,0,4,0,0,0,'[{1,182}]',0,0,0,0,'[{1,4811},{3,2405}]','[]',0,0,0,0),(1107020753,'征服短枪','【开服冲榜-第1名】7阶粉色副手【龙骑士】','',0,'【运营活动】','[{0,0,0}]',0,0,0,10,7,0,0,7,1007020700,2,0,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,7697},{3,3849}]','[]',0,0,0,0),(1107020842,'守护短枪','【冲级豪礼-350-400】8阶红2星副手【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,7,1,1,7,1007020800,2,0,0,4,0,0,0,'[{1,56}]',0,0,0,0,'[{1,6641},{3,3321}]','[]',0,0,0,0),(1107030320,'勇者法典','【冲级豪礼-65】3阶紫色副手【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,0,0,10,7,0,0,7,1007030300,3,0,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{1,332},{3,166}]','[]',0,0,0,0),(1107030442,'先驱法典','【开服首充】4阶红2星副手【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,7,1,1,7,1007030400,3,0,0,4,0,0,0,'[{1,14}]',0,0,0,0,'[{1,1223},{3,612}]','[]',0,0,0,0),(1107030531,'荣誉法典','【冲级豪礼-165】5阶橙1星副手【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,7,1,1,7,1007030500,3,0,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{1,1411},{3,705}]','[]',0,0,0,0),(1107030532,'荣誉法典','【勇者盟约】5阶橙2星副手【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,7,1,1,7,1007030500,3,0,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{1,1411},{3,705}]','[]',0,0,0,0),(1107030542,'荣誉法典','【开服首充】5阶红2星副手【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,7,1,1,7,1007030500,3,0,0,4,0,0,0,'[{1,26}]',0,0,0,0,'[{1,2118},{3,1059}]','[]',0,0,0,0),(1107030543,'荣誉法典','【开服累充】5阶红3星副手【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,7,1,1,7,1007030500,3,0,0,4,0,0,0,'[{1,77}]',0,0,0,0,'[{1,2118},{3,1059}]','[]',0,0,0,0),(1107030641,'贤者法典','【冲级豪礼-230-250】6阶红1星副手【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,7,1,1,7,1007030600,3,0,0,4,0,0,0,'[{1,22}]',0,0,0,0,'[{1,3308},{3,1654}]','[]',0,0,0,0),(1107030732,'征服法典','【开服冲榜-第11-30名】7阶橙2星副手【魔导师】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,7,1,1,7,1007030700,3,0,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{1,3204},{3,1602}]','[]',0,0,0,0),(1107030742,'征服法典','【开服冲榜-第4-10名】7阶红2星副手【魔导师】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,7,1,1,7,1007030700,3,0,0,4,0,0,0,'[{1,50}]',0,0,0,0,'[{1,4811},{3,2405}]','[]',0,0,0,0),(1107030743,'征服法典','【开服冲榜-第2-3名】7阶红3星副手【魔导师】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,7,1,1,7,1007030700,3,0,0,4,0,0,0,'[{1,182}]',0,0,0,0,'[{1,4811},{3,2405}]','[]',0,0,0,0),(1107030753,'征服法典','【开服冲榜-第1名】7阶粉色副手【魔导师】','',0,'【运营活动】','[{0,0,0}]',0,0,0,10,7,0,0,7,1007030700,3,0,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,7697},{3,3849}]','[]',0,0,0,0),(1107030842,'守护法典','【冲级豪礼-350-400】8阶红2星副手【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,7,1,1,7,1007030800,3,0,0,4,0,0,0,'[{1,56}]',0,0,0,0,'[{1,6641},{3,3321}]','[]',0,0,0,0),(1107040320,'勇者炮弹','【冲级豪礼-65】3阶紫色副手【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,0,0,10,7,0,0,7,1007040300,4,0,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{1,332},{3,166}]','[]',0,0,0,0),(1107040442,'先驱炮弹','【开服首充】4阶红2星副手【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,7,1,1,7,1007040400,4,0,0,4,0,0,0,'[{1,14}]',0,0,0,0,'[{1,1223},{3,612}]','[]',0,0,0,0),(1107040531,'荣誉炮弹','【冲级豪礼-165】5阶橙1星副手【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,7,1,1,7,1007040500,4,0,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{1,1411},{3,705}]','[]',0,0,0,0),(1107040532,'荣誉炮弹','【勇者盟约】5阶橙2星副手【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,7,1,1,7,1007040500,4,0,0,3,0,0,0,'[{1,9}]',0,0,0,0,'[{1,1411},{3,705}]','[]',0,0,0,0),(1107040542,'荣誉炮弹','【开服首充】5阶红2星副手【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,7,1,1,7,1007040500,4,0,0,4,0,0,0,'[{1,26}]',0,0,0,0,'[{1,2118},{3,1059}]','[]',0,0,0,0),(1107040543,'荣誉炮弹','【开服累充】5阶红3星副手【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,7,1,1,7,1007040500,4,0,0,4,0,0,0,'[{1,77}]',0,0,0,0,'[{1,2118},{3,1059}]','[]',0,0,0,0),(1107040641,'贤者炮弹','【冲级豪礼-230-250】6阶红1星副手【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,7,1,1,7,1007040600,4,0,0,4,0,0,0,'[{1,22}]',0,0,0,0,'[{1,3308},{3,1654}]','[]',0,0,0,0),(1107040732,'征服炮弹','【开服冲榜-第11-30名】7阶橙2星副手【重炮手】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,7,1,1,7,1007040700,4,0,0,3,0,0,0,'[{1,12}]',0,0,0,0,'[{1,3204},{3,1602}]','[]',0,0,0,0),(1107040742,'征服炮弹','【开服冲榜-第4-10名】7阶红2星副手【重炮手】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,7,1,1,7,1007040700,4,0,0,4,0,0,0,'[{1,50}]',0,0,0,0,'[{1,4811},{3,2405}]','[]',0,0,0,0),(1107040743,'征服炮弹','【开服冲榜-第2-3名】7阶红3星副手【重炮手】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,7,1,1,7,1007040700,4,0,0,4,0,0,0,'[{1,182}]',0,0,0,0,'[{1,4811},{3,2405}]','[]',0,0,0,0),(1107040753,'征服炮弹','【开服冲榜-第1名】7阶粉色副手【重炮手】','',0,'【运营活动】','[{0,0,0}]',0,0,0,10,7,0,0,7,1007040700,4,0,0,5,0,0,0,'[{1,11111}]',0,0,0,0,'[{1,7697},{3,3849}]','[]',0,0,0,0),(1107040842,'守护炮弹','【冲级豪礼-350-400】8阶红2星副手【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,7,1,1,7,1007040800,4,0,0,4,0,0,0,'[{1,56}]',0,0,0,0,'[{1,6641},{3,3321}]','[]',0,0,0,0),(1108010320,'勇者战腕','【冲级豪礼-65】3阶紫色护腕【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,0,0,10,8,0,0,8,1008010300,1,0,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,5427},{4,136}]','[]',0,0,0,0),(1108010442,'先驱战腕','【开服首充】4阶红2星护腕【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,8,1,2,8,1008010400,1,0,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1108010531,'荣誉战腕','【冲级豪礼-165】5阶橙1星护腕【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,8,1,2,8,1008010500,1,0,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,0,0),(1108010532,'荣誉战腕','【勇者盟约】5阶橙2星护腕【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,8,1,2,8,1008010500,1,0,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,0,0),(1108010542,'荣誉战腕','【开服首充】5阶红2星护腕【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,8,1,2,8,1008010500,1,0,0,4,0,0,0,'[{1,21}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,0,0),(1108010543,'荣誉战腕','【开服累充】5阶红3星护腕【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,8,1,2,8,1008010500,1,0,0,4,0,0,0,'[{1,63}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,0,0),(1108010641,'贤者战腕','【冲级豪礼-230-250】6阶红1星护腕【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,8,1,2,8,1008010600,1,0,0,4,0,0,0,'[{1,18}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,0,0),(1108010732,'征服战腕','【开服冲榜-第11-30名】7阶橙2星护腕【魔剑士】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,8,1,2,8,1008010700,1,0,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,52429},{4,1311}]','[]',0,0,0,0),(1108010742,'征服战腕','【开服冲榜-第4-10名】7阶红2星护腕【魔剑士】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,8,1,2,8,1008010700,1,0,0,4,0,0,0,'[{1,41}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,0,0),(1108010743,'征服战腕','【开服冲榜-第2-3名】7阶红3星护腕【魔剑士】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,8,1,2,8,1008010700,1,0,0,4,0,0,0,'[{1,149}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,0,0),(1108010753,'征服战腕','【开服冲榜-第1名】7阶粉色护腕【魔剑士】','',0,'【运营活动】','[{0,0,0}]',0,0,0,10,8,0,0,8,1008010700,1,0,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,125955},{4,3149}]','[]',0,0,0,0),(1108010842,'守护战腕','【冲级豪礼-350-400】8阶红2星护腕【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,8,1,2,8,1008010800,1,0,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,0,0),(1108020320,'勇者护腕','【冲级豪礼-65】3阶紫色护腕【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,0,0,10,8,0,0,8,1008020300,2,0,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,5427},{4,136}]','[]',0,0,0,0),(1108020442,'先驱护腕','【开服首充】4阶红2星护腕【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,8,1,2,8,1008020400,2,0,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1108020531,'荣誉护腕','【冲级豪礼-165】5阶橙1星护腕【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,8,1,2,8,1008020500,2,0,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,0,0),(1108020532,'荣誉护腕','【勇者盟约】5阶橙2星护腕【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,8,1,2,8,1008020500,2,0,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,0,0),(1108020542,'荣誉护腕','【开服首充】5阶红2星护腕【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,8,1,2,8,1008020500,2,0,0,4,0,0,0,'[{1,21}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,0,0),(1108020543,'荣誉护腕','【开服累充】5阶红3星护腕【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,8,1,2,8,1008020500,2,0,0,4,0,0,0,'[{1,63}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,0,0),(1108020641,'贤者护腕','【冲级豪礼-230-250】6阶红1星护腕【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,8,1,2,8,1008020600,2,0,0,4,0,0,0,'[{1,18}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,0,0),(1108020732,'征服护腕','【开服冲榜-第11-30名】7阶橙2星护腕【龙骑士】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,8,1,2,8,1008020700,2,0,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,52429},{4,1311}]','[]',0,0,0,0),(1108020742,'征服护腕','【开服冲榜-第4-10名】7阶红2星护腕【龙骑士】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,8,1,2,8,1008020700,2,0,0,4,0,0,0,'[{1,41}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,0,0),(1108020743,'征服护腕','【开服冲榜-第2-3名】7阶红3星护腕【龙骑士】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,8,1,2,8,1008020700,2,0,0,4,0,0,0,'[{1,149}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,0,0),(1108020753,'征服护腕','【开服冲榜-第1名】7阶粉色护腕【龙骑士】','',0,'【运营活动】','[{0,0,0}]',0,0,0,10,8,0,0,8,1008020700,2,0,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,125955},{4,3149}]','[]',0,0,0,0),(1108020842,'守护护腕','【冲级豪礼-350-400】8阶红2星护腕【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,8,1,2,8,1008020800,2,0,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,0,0),(1108030320,'勇者护手','【冲级豪礼-65】3阶紫色护腕【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,0,0,10,8,0,0,8,1008030300,3,0,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,5427},{4,136}]','[]',0,0,0,0),(1108030442,'先驱护手','【开服首充】4阶红2星护腕【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,8,1,2,8,1008030400,3,0,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1108030531,'荣誉护手','【冲级豪礼-165】5阶橙1星护腕【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,8,1,2,8,1008030500,3,0,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,0,0),(1108030532,'荣誉护手','【勇者盟约】5阶橙2星护腕【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,8,1,2,8,1008030500,3,0,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,0,0),(1108030542,'荣誉护手','【开服首充】5阶红2星护腕【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,8,1,2,8,1008030500,3,0,0,4,0,0,0,'[{1,21}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,0,0),(1108030543,'荣誉护手','【开服累充】5阶红3星护腕【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,8,1,2,8,1008030500,3,0,0,4,0,0,0,'[{1,63}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,0,0),(1108030641,'贤者护手','【冲级豪礼-230-250】6阶红1星护腕【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,8,1,2,8,1008030600,3,0,0,4,0,0,0,'[{1,18}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,0,0),(1108030732,'征服护手','【开服冲榜-第11-30名】7阶橙2星护腕【魔导师】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,8,1,2,8,1008030700,3,0,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,52429},{4,1311}]','[]',0,0,0,0),(1108030742,'征服护手','【开服冲榜-第4-10名】7阶红2星护腕【魔导师】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,8,1,2,8,1008030700,3,0,0,4,0,0,0,'[{1,41}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,0,0),(1108030743,'征服护手','【开服冲榜-第2-3名】7阶红3星护腕【魔导师】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,8,1,2,8,1008030700,3,0,0,4,0,0,0,'[{1,149}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,0,0),(1108030753,'征服护手','【开服冲榜-第1名】7阶粉色护腕【魔导师】','',0,'【运营活动】','[{0,0,0}]',0,0,0,10,8,0,0,8,1008030700,3,0,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,125955},{4,3149}]','[]',0,0,0,0),(1108030842,'守护护手','【冲级豪礼-350-400】8阶红2星护腕【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,8,1,2,8,1008030800,3,0,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,0,0),(1108040320,'勇者手套','【冲级豪礼-65】3阶紫色护腕【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,0,0,10,8,0,0,8,1008040300,4,0,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,5427},{4,136}]','[]',0,0,0,0),(1108040442,'先驱手套','【开服首充】4阶红2星护腕【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,8,1,2,8,1008040400,4,0,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1108040531,'荣誉手套','【冲级豪礼-165】5阶橙1星护腕【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,8,1,2,8,1008040500,4,0,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,0,0),(1108040532,'荣誉手套','【勇者盟约】5阶橙2星护腕【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,8,1,2,8,1008040500,4,0,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,0,0),(1108040542,'荣誉手套','【开服首充】5阶红2星护腕【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,8,1,2,8,1008040500,4,0,0,4,0,0,0,'[{1,21}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,0,0),(1108040543,'荣誉手套','【开服累充】5阶红3星护腕【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,8,1,2,8,1008040500,4,0,0,4,0,0,0,'[{1,63}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,0,0),(1108040641,'贤者手套','【冲级豪礼-230-250】6阶红1星护腕【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,8,1,2,8,1008040600,4,0,0,4,0,0,0,'[{1,18}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,0,0),(1108040732,'征服手套','【开服冲榜-第11-30名】7阶橙2星护腕【重炮手】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,8,1,2,8,1008040700,4,0,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,52429},{4,1311}]','[]',0,0,0,0),(1108040742,'征服手套','【开服冲榜-第4-10名】7阶红2星护腕【重炮手】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,8,1,2,8,1008040700,4,0,0,4,0,0,0,'[{1,41}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,0,0),(1108040743,'征服手套','【开服冲榜-第2-3名】7阶红3星护腕【重炮手】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,8,1,2,8,1008040700,4,0,0,4,0,0,0,'[{1,149}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,0,0),(1108040753,'征服手套','【开服冲榜-第1名】7阶粉色护腕【重炮手】','',0,'【运营活动】','[{0,0,0}]',0,0,0,10,8,0,0,8,1008040700,4,0,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,125955},{4,3149}]','[]',0,0,0,0),(1108040842,'守护手套','【冲级豪礼-350-400】8阶红2星护腕【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,8,1,2,8,1008040800,4,0,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,0,0),(1109000320,'勇者之戒','【冲级豪礼-65】3阶紫色戒指【通用】','',0,'【运营活动】','[{0,0,0}]',1,0,0,10,9,0,0,9,1009000300,0,0,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{1,166},{3,83}]','[]',0,0,0,0),(1109000442,'先驱之戒','【开服首充】4阶红2星戒指【通用】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,9,1,3,9,1009000400,0,0,0,4,0,0,0,'[{1,7}]',0,0,0,0,'[{1,612},{3,306}]','[]',0,0,0,0),(1109000531,'荣誉之戒','【冲级豪礼-165】5阶橙1星戒指【通用】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,9,1,3,9,1009000500,0,0,0,3,0,0,0,'[{1,4}]',0,0,0,0,'[{1,705},{3,353}]','[]',0,0,0,0),(1109000532,'荣誉之戒','【勇者盟约】5阶橙2星戒指【通用】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,9,1,3,9,1009000500,0,0,0,3,0,0,0,'[{1,5}]',0,0,0,0,'[{1,705},{3,353}]','[]',0,0,0,0),(1109000542,'荣誉之戒','【开服首充】5阶红2星戒指【通用】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,9,1,3,9,1009000500,0,0,0,4,0,0,0,'[{1,13}]',0,0,0,0,'[{1,1059},{3,529}]','[]',0,0,0,0),(1109000543,'荣誉之戒','【开服累充】5阶红3星戒指【通用】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,9,1,3,9,1009000500,0,0,0,4,0,0,0,'[{1,39}]',0,0,0,0,'[{1,1059},{3,529}]','[]',0,0,0,0),(1109000641,'贤者之戒','【冲级豪礼-230-250】6阶红1星戒指【通用】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,9,1,3,9,1009000600,0,0,0,4,0,0,0,'[{1,11}]',0,0,0,0,'[{1,1654},{3,827}]','[]',0,0,0,0),(1109000732,'征服之戒','【开服冲榜-第11-30名】7阶橙2星戒指【通用】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,9,1,3,9,1009000700,0,0,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{1,1602},{3,801}]','[]',0,0,0,0),(1109000742,'征服之戒','【开服冲榜-第4-10名】7阶红2星戒指【通用】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,9,1,3,9,1009000700,0,0,0,4,0,0,0,'[{1,25}]',0,0,0,0,'[{1,2405},{3,1203}]','[]',0,0,0,0),(1109000743,'征服之戒','【开服冲榜-第2-3名】7阶红3星戒指【通用】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,9,1,3,9,1009000700,0,0,0,4,0,0,0,'[{1,91}]',0,0,0,0,'[{1,2405},{3,1203}]','[]',0,0,0,0),(1109000753,'征服之戒','【开服冲榜-第1名】7阶粉色戒指【通用】','',0,'【运营活动】','[{0,0,0}]',0,0,0,10,9,0,0,9,1009000700,0,0,0,5,0,0,0,'[{1,5556}]',0,0,0,0,'[{1,3849},{3,1924}]','[]',0,0,0,0),(1109000842,'守护之戒','【冲级豪礼-350-400】8阶红2星戒指【通用】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,9,1,3,9,1009000800,0,0,0,4,0,0,0,'[{1,28}]',0,0,0,0,'[{1,3321},{3,1660}]','[]',0,0,0,0),(1110010320,'勇者战靴','【冲级豪礼-65】3阶紫色鞋子【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,0,0,10,10,0,0,10,1010010300,1,0,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,5427},{4,136}]','[]',0,0,0,0),(1110010442,'先驱战靴','【开服首充】4阶红2星鞋子【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,10,1,2,10,1010010400,1,0,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1110010531,'荣誉战靴','【冲级豪礼-165】5阶橙1星鞋子【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,10,1,2,10,1010010500,1,0,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,0,0),(1110010532,'荣誉战靴','【勇者盟约】5阶橙2星鞋子【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,10,1,2,10,1010010500,1,0,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,0,0),(1110010542,'荣誉战靴','【开服首充】5阶红2星鞋子【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,10,1,2,10,1010010500,1,0,0,4,0,0,0,'[{1,21}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,0,0),(1110010543,'荣誉战靴','【开服累充】5阶红3星鞋子【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,10,1,2,10,1010010500,1,0,0,4,0,0,0,'[{1,63}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,0,0),(1110010641,'贤者战靴','【冲级豪礼-230-250】6阶红1星鞋子【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,10,1,2,10,1010010600,1,0,0,4,0,0,0,'[{1,18}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,0,0),(1110010732,'征服战靴','【开服冲榜-第11-30名】7阶橙2星鞋子【魔剑士】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,10,1,2,10,1010010700,1,0,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,52429},{4,1311}]','[]',0,0,0,0),(1110010742,'征服战靴','【开服冲榜-第4-10名】7阶红2星鞋子【魔剑士】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,10,1,2,10,1010010700,1,0,0,4,0,0,0,'[{1,41}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,0,0),(1110010743,'征服战靴','【开服冲榜-第2-3名】7阶红3星鞋子【魔剑士】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,10,1,2,10,1010010700,1,0,0,4,0,0,0,'[{1,149}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,0,0),(1110010753,'征服战靴','【开服冲榜-第1名】7阶粉色鞋子【魔剑士】','',0,'【运营活动】','[{0,0,0}]',0,0,0,10,10,0,0,10,1010010700,1,0,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,125955},{4,3149}]','[]',0,0,0,0),(1110010842,'守护战靴','【冲级豪礼-350-400】8阶红2星鞋子【魔剑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,10,1,2,10,1010010800,1,0,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,0,0),(1110020320,'勇者皮靴','【冲级豪礼-65】3阶紫色鞋子【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,0,0,10,10,0,0,10,1010020300,2,0,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,5427},{4,136}]','[]',0,0,0,0),(1110020442,'先驱皮靴','【开服首充】4阶红2星鞋子【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,10,1,2,10,1010020400,2,0,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1110020531,'荣誉皮靴','【冲级豪礼-165】5阶橙1星鞋子【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,10,1,2,10,1010020500,2,0,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,0,0),(1110020532,'荣誉皮靴','【勇者盟约】5阶橙2星鞋子【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,10,1,2,10,1010020500,2,0,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,0,0),(1110020542,'荣誉皮靴','【开服首充】5阶红2星鞋子【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,10,1,2,10,1010020500,2,0,0,4,0,0,0,'[{1,21}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,0,0),(1110020543,'荣誉皮靴','【开服累充】5阶红3星鞋子【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,10,1,2,10,1010020500,2,0,0,4,0,0,0,'[{1,63}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,0,0),(1110020641,'贤者皮靴','【冲级豪礼-230-250】6阶红1星鞋子【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,10,1,2,10,1010020600,2,0,0,4,0,0,0,'[{1,18}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,0,0),(1110020732,'征服皮靴','【开服冲榜-第11-30名】7阶橙2星鞋子【龙骑士】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,10,1,2,10,1010020700,2,0,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,52429},{4,1311}]','[]',0,0,0,0),(1110020742,'征服皮靴','【开服冲榜-第4-10名】7阶红2星鞋子【龙骑士】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,10,1,2,10,1010020700,2,0,0,4,0,0,0,'[{1,41}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,0,0),(1110020743,'征服皮靴','【开服冲榜-第2-3名】7阶红3星鞋子【龙骑士】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,10,1,2,10,1010020700,2,0,0,4,0,0,0,'[{1,149}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,0,0),(1110020753,'征服皮靴','【开服冲榜-第1名】7阶粉色鞋子【龙骑士】','',0,'【运营活动】','[{0,0,0}]',0,0,0,10,10,0,0,10,1010020700,2,0,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,125955},{4,3149}]','[]',0,0,0,0),(1110020842,'守护皮靴','【冲级豪礼-350-400】8阶红2星鞋子【龙骑士】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,10,1,2,10,1010020800,2,0,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,0,0),(1110030320,'勇者长靴','【冲级豪礼-65】3阶紫色鞋子【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,0,0,10,10,0,0,10,1010030300,3,0,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,5427},{4,136}]','[]',0,0,0,0),(1110030442,'先驱长靴','【开服首充】4阶红2星鞋子【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,10,1,2,10,1010030400,3,0,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1110030531,'荣誉长靴','【冲级豪礼-165】5阶橙1星鞋子【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,10,1,2,10,1010030500,3,0,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,0,0),(1110030532,'荣誉长靴','【勇者盟约】5阶橙2星鞋子【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,10,1,2,10,1010030500,3,0,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,0,0),(1110030542,'荣誉长靴','【开服首充】5阶红2星鞋子【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,10,1,2,10,1010030500,3,0,0,4,0,0,0,'[{1,21}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,0,0),(1110030543,'荣誉长靴','【开服累充】5阶红3星鞋子【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,10,1,2,10,1010030500,3,0,0,4,0,0,0,'[{1,63}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,0,0),(1110030641,'贤者长靴','【冲级豪礼-230-250】6阶红1星鞋子【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,10,1,2,10,1010030600,3,0,0,4,0,0,0,'[{1,18}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,0,0),(1110030732,'征服长靴','【开服冲榜-第11-30名】7阶橙2星鞋子【魔导师】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,10,1,2,10,1010030700,3,0,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,52429},{4,1311}]','[]',0,0,0,0),(1110030742,'征服长靴','【开服冲榜-第4-10名】7阶红2星鞋子【魔导师】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,10,1,2,10,1010030700,3,0,0,4,0,0,0,'[{1,41}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,0,0),(1110030743,'征服长靴','【开服冲榜-第2-3名】7阶红3星鞋子【魔导师】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,10,1,2,10,1010030700,3,0,0,4,0,0,0,'[{1,149}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,0,0),(1110030753,'征服长靴','【开服冲榜-第1名】7阶粉色鞋子【魔导师】','',0,'【运营活动】','[{0,0,0}]',0,0,0,10,10,0,0,10,1010030700,3,0,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,125955},{4,3149}]','[]',0,0,0,0),(1110030842,'守护长靴','【冲级豪礼-350-400】8阶红2星鞋子【魔导师】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,10,1,2,10,1010030800,3,0,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,0,0),(1110040320,'勇者短靴','【冲级豪礼-65】3阶紫色鞋子【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,0,0,10,10,0,0,10,1010040300,4,0,0,2,0,0,0,'[{1,1}]',0,0,0,0,'[{2,5427},{4,136}]','[]',0,0,0,0),(1110040442,'先驱短靴','【开服首充】4阶红2星鞋子【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,10,1,2,10,1010040400,4,0,0,4,0,0,0,'[{1,12}]',0,0,0,0,'[{2,20014},{4,500}]','[]',0,0,0,0),(1110040531,'荣誉短靴','【冲级豪礼-165】5阶橙1星鞋子【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,10,1,2,10,1010040500,4,0,0,3,0,0,0,'[{1,6}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,0,0),(1110040532,'荣誉短靴','【勇者盟约】5阶橙2星鞋子【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,10,1,2,10,1010040500,4,0,0,3,0,0,0,'[{1,7}]',0,0,0,0,'[{2,23082},{4,577}]','[]',0,0,0,0),(1110040542,'荣誉短靴','【开服首充】5阶红2星鞋子【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,10,1,2,10,1010040500,4,0,0,4,0,0,0,'[{1,21}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,0,0),(1110040543,'荣誉短靴','【开服累充】5阶红3星鞋子【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,10,1,2,10,1010040500,4,0,0,4,0,0,0,'[{1,63}]',0,0,0,0,'[{2,34658},{4,866}]','[]',0,0,0,0),(1110040641,'贤者短靴','【冲级豪礼-230-250】6阶红1星鞋子【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,10,1,2,10,1010040600,4,0,0,4,0,0,0,'[{1,18}]',0,0,0,0,'[{2,54138},{4,1353}]','[]',0,0,0,0),(1110040732,'征服短靴','【开服冲榜-第11-30名】7阶橙2星鞋子【重炮手】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,10,1,2,10,1010040700,4,0,0,3,0,0,0,'[{1,10}]',0,0,0,0,'[{2,52429},{4,1311}]','[]',0,0,0,0),(1110040742,'征服短靴','【开服冲榜-第4-10名】7阶红2星鞋子【重炮手】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,10,1,2,10,1010040700,4,0,0,4,0,0,0,'[{1,41}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,0,0),(1110040743,'征服短靴','【开服冲榜-第2-3名】7阶红3星鞋子【重炮手】','',0,'【运营活动】','[{0,0,0}]',0,1,0,10,10,1,2,10,1010040700,4,0,0,4,0,0,0,'[{1,149}]',0,0,0,0,'[{2,78722},{4,1968}]','[]',0,0,0,0),(1110040753,'征服短靴','【开服冲榜-第1名】7阶粉色鞋子【重炮手】','',0,'【运营活动】','[{0,0,0}]',0,0,0,10,10,0,0,10,1010040700,4,0,0,5,0,0,0,'[{1,9091}]',0,0,0,0,'[{2,125955},{4,3149}]','[]',0,0,0,0),(1110040842,'守护短靴','【冲级豪礼-350-400】8阶红2星鞋子【重炮手】','',0,'【运营活动】','[{0,0,0}]',1,1,0,10,10,1,2,10,1010040800,4,0,0,4,0,0,0,'[{1,46}]',0,0,0,0,'[{2,108676},{4,2717}]','[]',0,0,0,0),(3100000001,'增伤BUFF','三英会战宝箱BUFF','',0,'【三英会战】','[{0,0,0}]',1,0,0,56,1,4,4,0,0,0,0,0,6,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(3100000002,'减伤BUFF','三英会战宝箱BUFF','',0,'【三英会战】','[{0,0,0}]',1,0,0,56,1,4,4,0,0,0,0,0,6,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(3100000003,'移速BUFF','三英会战宝箱BUFF','',0,'【三英会战】','[{0,0,0}]',1,0,0,56,1,4,4,0,0,0,0,0,6,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(3100000004,'回复BUFF','三英会战宝箱BUFF','',0,'【三英会战】','[{0,0,0}]',1,0,0,56,1,4,4,0,0,0,0,0,6,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(3100000005,'反击BUFF','三英会战宝箱BUFF','',0,'【三英会战】','[{0,0,0}]',1,0,0,56,1,4,4,0,0,0,0,0,6,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0),(3100000006,'怒气BUFF','三英会战宝箱BUFF','',0,'【三英会战】','[{0,0,0}]',1,0,0,56,1,4,4,0,0,0,0,0,6,0,0,0,'[]',0,0,0,0,'[]','[]',0,0,0,0);
/*!40000 ALTER TABLE `base_goods` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_goods_attribute`
--

DROP TABLE IF EXISTS `base_goods_attribute`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_goods_attribute` (
  `attribute_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '编号ID',
  `attribute_name` varchar(50) NOT NULL DEFAULT '' COMMENT '属性类型名称@lang@',
  `attribute_about` varchar(255) NOT NULL DEFAULT '' COMMENT '属性类型说明@lang@',
  PRIMARY KEY (`attribute_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品属性类型表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_goods_attribute`
--

LOCK TABLES `base_goods_attribute` WRITE;
/*!40000 ALTER TABLE `base_goods_attribute` DISABLE KEYS */;
INSERT INTO `base_goods_attribute` VALUES (1,'攻击','攻击  战力系数：20'),(2,'生命','生命  战力系数：1'),(3,'破甲','破甲  战力系数：25'),(4,'防御','防御  战力系数：25'),(5,'命中','命中  战力系数：50'),(6,'闪避','闪避  战力系数：50'),(7,'暴击','暴击  战力系数：50'),(8,'坚韧','坚韧  战力系数：50'),(9,'伤害加深（10000表示100%）','伤害加深（10000表示100%）  战力系数：0.2*role_lv'),(10,'伤害减免（10000表示100%）','伤害减免（10000表示100%）  战力系数：0.2*role_lv'),(11,'命中率（10000表示100%）','命中率（10000表示100%）  战力系数：0.24*role_lv'),(12,'闪避率（10000表示100%）','闪避率（10000表示100%）  战力系数：0.24*role_lv'),(13,'暴击率（10000表示100%）','暴击率（10000表示100%）  战力系数：0.24*role_lv'),(14,'韧性率（10000表示100%）','韧性率（10000表示100%）  战力系数：0.24*role_lv'),(15,'固定伤害','固定伤害  战力系数：30'),(16,'固定防御','固定防御  战力系数：30'),(18,'移动速度（初始速度值610，需要扣除战力）','移动速度（初始速度值610，需要扣除战力）  战力系数：20'),(19,'攻击增加百分比（用于全局百分比属性的配置）（10000表示100%）','攻击增加百分比（用于全局百分比属性的配置）（10000表示100%）  战力系数：0'),(20,'生命增加百分比（用于全局百分比属性的配置）（10000表示100%）','生命增加百分比（用于全局百分比属性的配置）（10000表示100%）  战力系数：0'),(21,'破甲增加百分比（用于全局百分比属性的配置）（10000表示100%）','破甲增加百分比（用于全局百分比属性的配置）（10000表示100%）  战力系数：0'),(22,'防御增加百分比（用于全局百分比属性的配置）（10000表示100%）','防御增加百分比（用于全局百分比属性的配置）（10000表示100%）  战力系数：0'),(23,'命中增加百分比（用于全局百分比属性的配置）（10000表示100%）','命中增加百分比（用于全局百分比属性的配置）（10000表示100%）  战力系数：0'),(24,'闪避增加百分比（用于全局百分比属性的配置）（10000表示100%）','闪避增加百分比（用于全局百分比属性的配置）（10000表示100%）  战力系数：0'),(25,'暴击增加百分比（用于全局百分比属性的配置）（10000表示100%）','暴击增加百分比（用于全局百分比属性的配置）（10000表示100%）  战力系数：0'),(26,'坚韧增加百分比（用于全局百分比属性的配置）（10000表示100%）','坚韧增加百分比（用于全局百分比属性的配置）（10000表示100%）  战力系数：0'),(27,'技能伤害百分比（用于全局百分比属性的配置）（10000表示100%）','技能伤害百分比（用于全局百分比属性的配置）（10000表示100%）  战力系数：0.16*role_lv'),(28,'技能减免百分比（用于全局百分比属性的配置）（10000表示100%）','技能减免百分比（用于全局百分比属性的配置）（10000表示100%）  战力系数：0.16*role_lv'),(29,'固定伤害百分比（用于全局百分比属性的配置）（10000表示100%）','固定伤害百分比（用于全局百分比属性的配置）（10000表示100%）  战力系数：0'),(30,'固定防御百分比（用于全局百分比属性的配置）（10000表示100%）','固定防御百分比（用于全局百分比属性的配置）（10000表示100%）  战力系数：0'),(48,'暴伤值','暴伤值  战力系数：30'),(49,'抗暴值','抗暴值  战力系数：30'),(50,'PVE伤害百分比（10000表示100%）','PVE伤害百分比（10000表示100%）  战力系数：0.12*role_lv'),(51,'PVP伤害百分比（10000表示100%）','PVP伤害百分比（10000表示100%）  战力系数：0.12*role_lv'),(52,'暴伤加成百分比（10000表示100%）','暴伤加成百分比（10000表示100%）  战力系数：0.12*role_lv'),(53,'暴伤减免百分比（10000表示100%）','暴伤减免百分比（10000表示100%）  战力系数：0.12*role_lv'),(54,'会心一击触发率（10000表示100%）','会心一击触发率（10000表示100%）  战力系数：0.35*role_lv'),(55,'致命一击触发率（10000表示100%）','致命一击触发率（10000表示100%）  战力系数：0.5*role_lv'),(56,'会心抵抗触发率（10000表示100%）','会心抵抗触发率（10000表示100%）  战力系数：0.35*role_lv'),(57,'致命抵抗触发率（10000表示100%）','致命抵抗触发率（10000表示100%）  战力系数：0.5*role_lv'),(58,'攻击速度增加百分比（用于全局百分比属性的配置）（10000表示100%）','攻击速度增加百分比（用于全局百分比属性的配置）（10000表示100%）  战力系数：0.15*role_lv'),(59,'移动速度增加百分比（用于全局百分比属性的配置）（10000表示100%）','移动速度增加百分比（用于全局百分比属性的配置）（10000表示100%）  战力系数：0'),(60,'局部攻击增加百分比（用于具体系统内部百分比属性的配置）（10000表示100%）','局部攻击增加百分比（用于具体系统内部百分比属性的配置）（10000表示100%）  战力系数：0'),(61,'局部生命增加百分比（用于具体系统内部百分比属性的配置）（10000表示100%）','局部生命增加百分比（用于具体系统内部百分比属性的配置）（10000表示100%）  战力系数：0'),(62,'局部破甲增加百分比（用于具体系统内部百分比属性的配置）（10000表示100%）','局部破甲增加百分比（用于具体系统内部百分比属性的配置）（10000表示100%）  战力系数：0'),(63,'局部防御增加百分比（用于具体系统内部百分比属性的配置）（10000表示100%）','局部防御增加百分比（用于具体系统内部百分比属性的配置）（10000表示100%）  战力系数：0'),(64,'局部命中增加百分比（用于具体系统内部百分比属性的配置）（10000表示100%）','局部命中增加百分比（用于具体系统内部百分比属性的配置）（10000表示100%）  战力系数：0'),(65,'局部闪避增加百分比（用于具体系统内部百分比属性的配置）（10000表示100%）','局部闪避增加百分比（用于具体系统内部百分比属性的配置）（10000表示100%）  战力系数：0'),(66,'局部暴击增加百分比（用于具体系统内部百分比属性的配置）（10000表示100%）','局部暴击增加百分比（用于具体系统内部百分比属性的配置）（10000表示100%）  战力系数：0'),(67,'局部坚韧增加百分比（用于具体系统内部百分比属性的配置）（10000表示100%）','局部坚韧增加百分比（用于具体系统内部百分比属性的配置）（10000表示100%）  战力系数：0'),(68,'局部全属性增加百分比（用于具体系统内部百分比属性的配置）（10000表示100%）','局部全属性增加百分比（用于具体系统内部百分比属性的配置）（10000表示100%）  战力系数：0'),(69,'基础攻击增加百分比（等级属性的百分比加成）（10000表示100%）','基础攻击增加百分比（等级属性的百分比加成）（10000表示100%）  战力系数：0'),(70,'基础生命增加百分比（等级属性的百分比加成）（10000表示100%）','基础生命增加百分比（等级属性的百分比加成）（10000表示100%）  战力系数：0'),(71,'基础破甲增加百分比（等级属性的百分比加成）（10000表示100%）','基础破甲增加百分比（等级属性的百分比加成）（10000表示100%）  战力系数：0'),(72,'基础防御增加百分比（等级属性的百分比加成）（10000表示100%）','基础防御增加百分比（等级属性的百分比加成）（10000表示100%）  战力系数：0'),(73,'基础命中增加百分比（等级属性的百分比加成）（10000表示100%）','基础命中增加百分比（等级属性的百分比加成）（10000表示100%）  战力系数：0'),(74,'基础闪避增加百分比（等级属性的百分比加成）（10000表示100%）','基础闪避增加百分比（等级属性的百分比加成）（10000表示100%）  战力系数：0'),(75,'基础暴击增加百分比（等级属性的百分比加成）（10000表示100%）','基础暴击增加百分比（等级属性的百分比加成）（10000表示100%）  战力系数：0'),(76,'基础坚韧增加百分比（等级属性的百分比加成）（10000表示100%）','基础坚韧增加百分比（等级属性的百分比加成）（10000表示100%）  战力系数：0'),(77,'冰系伤害','冰系伤害  战力系数：30'),(78,'冰系防御','冰系防御  战力系数：30'),(79,'雷系伤害','雷系伤害  战力系数：30'),(80,'雷系防御','雷系防御  战力系数：30'),(81,'火系伤害','火系伤害  战力系数：30'),(82,'火系防御','火系防御  战力系数：30'),(83,'风系伤害','风系伤害  战力系数：30'),(84,'风系防御','风系防御  战力系数：30'),(85,'冰系伤害增加百分比（10000表示100%）','冰系伤害增加百分比（10000表示100%）  战力系数：0'),(86,'冰系防御增加百分比（10000表示100%）','冰系防御增加百分比（10000表示100%）  战力系数：0'),(87,'雷系伤害增加百分比（10000表示100%）','雷系伤害增加百分比（10000表示100%）  战力系数：0'),(88,'雷系防御增加百分比（10000表示100%）','雷系防御增加百分比（10000表示100%）  战力系数：0'),(89,'火系伤害增加百分比（10000表示100%）','火系伤害增加百分比（10000表示100%）  战力系数：0'),(90,'火系防御增加百分比（10000表示100%）','火系防御增加百分比（10000表示100%）  战力系数：0'),(91,'风系伤害增加百分比（10000表示100%）','风系伤害增加百分比（10000表示100%）  战力系数：0'),(92,'风系防御增加百分比（10000表示100%）','风系防御增加百分比（10000表示100%）  战力系数：0'),(201,'血量回复百分比（写死时间间隔为10秒）（10000表示100%）','血量回复百分比（写死时间间隔为10秒）（10000表示100%）  战力系数：0.2*role_lv'),(202,'经验加成百分比（10000表示100%）','经验加成百分比（10000表示100%）  战力系数：0'),(203,'对boss伤害增加百分比（10000表示100%）','对boss伤害增加百分比（10000表示100%）  战力系数：0.12*role_lv'),(210,'珍稀物品（紫色以上）掉率提高百分比（10000表示100%），多个需要叠加','珍稀物品（紫色以上）掉率提高百分比（10000表示100%），多个需要叠加  战力系数：0'),(211,'铜币掉落数量提高百分比（10000代表100%），多个需要叠加','铜币掉落数量提高百分比（10000代表100%），多个需要叠加  战力系数：0'),(221,'武器基础攻击增加百分比（10000表示100%）','武器基础攻击增加百分比（10000表示100%）  战力系数：0'),(222,'武器基础破甲增加百分比（10000表示100%）','武器基础破甲增加百分比（10000表示100%）  战力系数：0'),(223,'防具基础生命增加百分比（10000表示100%）','防具基础生命增加百分比（10000表示100%）  战力系数：0'),(224,'防具基础防御增加百分比（10000表示100%）','防具基础防御增加百分比（10000表示100%）  战力系数：0'),(225,'饰品基础攻击增加百分比（10000表示100%）','饰品基础攻击增加百分比（10000表示100%）  战力系数：0'),(226,'饰品基础破甲增加百分比（10000表示100%）','饰品基础破甲增加百分比（10000表示100%）  战力系数：0'),(230,'PVE伤害减免百分比（10000表示100%）','PVE伤害减免百分比（10000表示100%）  战力系数：0.12*role_lv'),(231,'PVP伤害减免百分比（10000表示100%）','PVP伤害减免百分比（10000表示100%）  战力系数：0.12*role_lv'),(232,'boss伤害减免百分比（10000表示100%）','boss伤害减免百分比（10000表示100%）  战力系数：0.12*role_lv');
/*!40000 ALTER TABLE `base_goods_attribute` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_goods_compose`
--

DROP TABLE IF EXISTS `base_goods_compose`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_goods_compose` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '合成id',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '名字@lang@',
  `extra` varchar(255) NOT NULL DEFAULT '' COMMENT '备注@lang@',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '合成类型',
  `condition` varchar(255) NOT NULL DEFAULT '[]' COMMENT '开启条件',
  `subtype` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '合成方式',
  `regular_mat` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '固定材料',
  `irregular_mat` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '不固定材料',
  `limit_mat` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '限定材料',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '合成消耗',
  `goods` varchar(255) NOT NULL DEFAULT '[]' COMMENT '合成物品',
  `ratio_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '概率类型',
  `ratio` varchar(255) NOT NULL DEFAULT '' COMMENT '概率',
  `bind_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '绑定类型',
  `tv_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '传闻类型 0: 不发传闻 1: 全服传闻',
  `return_goods` varchar(255) NOT NULL DEFAULT '[]' COMMENT '失败返还',
  `module_id` smallint(5) unsigned NOT NULL DEFAULT '150' COMMENT '功能id',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='合成规则';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_goods_compose`
--

LOCK TABLES `base_goods_compose` WRITE;
/*!40000 ALTER TABLE `base_goods_compose` DISABLE KEYS */;
INSERT INTO `base_goods_compose` VALUES (11000001,'1级攻击宝石','1级攻击宝石合成',1,'[{lv,110}]',1,'[{0,14120001,3}]','[]','[]','[]','[{0,14010101,1}]',1,'100',3,0,'[]',150),(11000002,'2级攻击宝石','2级攻击宝石合成',1,'[{lv,110}]',1,'[{0,14010101,3}]','[]','[]','[]','[{0,14010102,1}]',1,'100',3,0,'[]',150),(11000003,'3级攻击宝石','3级攻击宝石合成',1,'[{lv,110}]',1,'[{0,14010102,3}]','[]','[]','[]','[{0,14010103,1}]',1,'100',3,0,'[]',150),(11000004,'4级攻击宝石','4级攻击宝石合成',1,'[{lv,110}]',1,'[{0,14010103,3}]','[]','[]','[]','[{0,14010104,1}]',1,'100',3,0,'[]',150),(11000005,'5级攻击宝石','5级攻击宝石合成',1,'[{lv,250}]',1,'[{0,14010104,3}]','[]','[]','[]','[{0,14010105,1}]',1,'100',3,0,'[]',150),(11000006,'6级攻击宝石','6级攻击宝石合成',1,'[{lv,250}]',1,'[{0,14010105,3}]','[]','[]','[]','[{0,14010106,1}]',1,'100',3,0,'[]',150),(11000007,'7级攻击宝石','7级攻击宝石合成',1,'[{lv,250}]',1,'[{0,14010106,3}]','[]','[]','[]','[{0,14010107,1}]',1,'100',3,0,'[]',150),(11000008,'8级攻击宝石','8级攻击宝石合成',1,'[{lv,250}]',1,'[{0,14010107,3}]','[]','[]','[]','[{0,14010108,1}]',1,'100',3,0,'[]',150),(11000009,'9级攻击宝石','9级攻击宝石合成',1,'[{lv,250}]',1,'[{0,14010108,3}]','[]','[]','[]','[{0,14010109,1}]',1,'100',3,0,'[]',150),(12000001,'1级生命宝石','1级生命宝石合成',1,'[{lv,110}]',1,'[{0,14120001,3}]','[]','[]','[]','[{0,14020201,1}]',1,'100',3,0,'[]',150),(12000002,'2级生命宝石','2级生命宝石合成',1,'[{lv,110}]',1,'[{0,14020201,3}]','[]','[]','[]','[{0,14020202,1}]',1,'100',3,0,'[]',150),(12000003,'3级生命宝石','3级生命宝石合成',1,'[{lv,110}]',1,'[{0,14020202,3}]','[]','[]','[]','[{0,14020203,1}]',1,'100',3,0,'[]',150),(12000004,'4级生命宝石','4级生命宝石合成',1,'[{lv,110}]',1,'[{0,14020203,3}]','[]','[]','[]','[{0,14020204,1}]',1,'100',3,0,'[]',150),(12000005,'5级生命宝石','5级生命宝石合成',1,'[{lv,250}]',1,'[{0,14020204,3}]','[]','[]','[]','[{0,14020205,1}]',1,'100',3,0,'[]',150),(12000006,'6级生命宝石','6级生命宝石合成',1,'[{lv,250}]',1,'[{0,14020205,3}]','[]','[]','[]','[{0,14020206,1}]',1,'100',3,0,'[]',150),(12000007,'7级生命宝石','7级生命宝石合成',1,'[{lv,250}]',1,'[{0,14020206,3}]','[]','[]','[]','[{0,14020207,1}]',1,'100',3,0,'[]',150),(12000008,'8级生命宝石','8级生命宝石合成',1,'[{lv,250}]',1,'[{0,14020207,3}]','[]','[]','[]','[{0,14020208,1}]',1,'100',3,0,'[]',150),(12000009,'9级生命宝石','9级生命宝石合成',1,'[{lv,250}]',1,'[{0,14020208,3}]','[]','[]','[]','[{0,14020209,1}]',1,'100',3,0,'[]',150),(13000001,'1级破甲宝石','1级破甲宝石合成',1,'[{lv,110}]',1,'[{0,14120001,3}]','[]','[]','[]','[{0,14010301,1}]',1,'100',3,0,'[]',150),(13000002,'2级破甲宝石','2级破甲宝石合成',1,'[{lv,110}]',1,'[{0,14010301,3}]','[]','[]','[]','[{0,14010302,1}]',1,'100',3,0,'[]',150),(13000003,'3级破甲宝石','3级破甲宝石合成',1,'[{lv,110}]',1,'[{0,14010302,3}]','[]','[]','[]','[{0,14010303,1}]',1,'100',3,0,'[]',150),(13000004,'4级破甲宝石','4级破甲宝石合成',1,'[{lv,110}]',1,'[{0,14010303,3}]','[]','[]','[]','[{0,14010304,1}]',1,'100',3,0,'[]',150),(13000005,'5级破甲宝石','5级破甲宝石合成',1,'[{lv,250}]',1,'[{0,14010304,3}]','[]','[]','[]','[{0,14010305,1}]',1,'100',3,0,'[]',150),(13000006,'6级破甲宝石','6级破甲宝石合成',1,'[{lv,250}]',1,'[{0,14010305,3}]','[]','[]','[]','[{0,14010306,1}]',1,'100',3,0,'[]',150),(13000007,'7级破甲宝石','7级破甲宝石合成',1,'[{lv,250}]',1,'[{0,14010306,3}]','[]','[]','[]','[{0,14010307,1}]',1,'100',3,0,'[]',150),(13000008,'8级破甲宝石','8级破甲宝石合成',1,'[{lv,250}]',1,'[{0,14010307,3}]','[]','[]','[]','[{0,14010308,1}]',1,'100',3,0,'[]',150),(13000009,'9级破甲宝石','9级破甲宝石合成',1,'[{lv,250}]',1,'[{0,14010308,3}]','[]','[]','[]','[{0,14010309,1}]',1,'100',3,0,'[]',150),(14000001,'1级防御宝石','1级防御宝石合成',1,'[{lv,110}]',1,'[{0,14120001,3}]','[]','[]','[]','[{0,14020401,1}]',1,'100',3,0,'[]',150),(14000002,'2级防御宝石','2级防御宝石合成',1,'[{lv,110}]',1,'[{0,14020401,3}]','[]','[]','[]','[{0,14020402,1}]',1,'100',3,0,'[]',150),(14000003,'3级防御宝石','3级防御宝石合成',1,'[{lv,110}]',1,'[{0,14020402,3}]','[]','[]','[]','[{0,14020403,1}]',1,'100',3,0,'[]',150),(14000004,'4级防御宝石','4级防御宝石合成',1,'[{lv,110}]',1,'[{0,14020403,3}]','[]','[]','[]','[{0,14020404,1}]',1,'100',3,0,'[]',150),(14000005,'5级防御宝石','5级防御宝石合成',1,'[{lv,250}]',1,'[{0,14020404,3}]','[]','[]','[]','[{0,14020405,1}]',1,'100',3,0,'[]',150),(14000006,'6级防御宝石','6级防御宝石合成',1,'[{lv,250}]',1,'[{0,14020405,3}]','[]','[]','[]','[{0,14020406,1}]',1,'100',3,0,'[]',150),(14000007,'7级防御宝石','7级防御宝石合成',1,'[{lv,250}]',1,'[{0,14020406,3}]','[]','[]','[]','[{0,14020407,1}]',1,'100',3,0,'[]',150),(14000008,'8级防御宝石','8级防御宝石合成',1,'[{lv,250}]',1,'[{0,14020407,3}]','[]','[]','[]','[{0,14020408,1}]',1,'100',3,0,'[]',150),(14000009,'9级防御宝石','9级防御宝石合成',1,'[{lv,250}]',1,'[{0,14020408,3}]','[]','[]','[]','[{0,14020409,1}]',1,'100',3,0,'[]',150),(15000001,'1级命中宝石','1级命中宝石合成',1,'[{lv,9999}]',1,'[{0,14120001,3}]','[]','[]','[]','[{0,14010501,1}]',1,'100',3,0,'[]',150),(15000002,'2级命中宝石','2级命中宝石合成',1,'[{lv,9999}]',1,'[{0,14010501,3}]','[]','[]','[]','[{0,14010502,1}]',1,'100',3,0,'[]',150),(15000003,'3级命中宝石','3级命中宝石合成',1,'[{lv,9999}]',1,'[{0,14010502,3}]','[]','[]','[]','[{0,14010503,1}]',1,'100',3,0,'[]',150),(15000004,'4级命中宝石','4级命中宝石合成',1,'[{lv,9999}]',1,'[{0,14010503,3}]','[]','[]','[]','[{0,14010504,1}]',1,'100',3,0,'[]',150),(15000005,'5级命中宝石','5级命中宝石合成',1,'[{lv,9999}]',1,'[{0,14010504,3}]','[]','[]','[]','[{0,14010505,1}]',1,'100',3,0,'[]',150),(15000006,'6级命中宝石','6级命中宝石合成',1,'[{lv,9999}]',1,'[{0,14010505,3}]','[]','[]','[]','[{0,14010506,1}]',1,'100',3,0,'[]',150),(15000007,'7级命中宝石','7级命中宝石合成',1,'[{lv,9999}]',1,'[{0,14010506,3}]','[]','[]','[]','[{0,14010507,1}]',1,'100',3,0,'[]',150),(15000008,'8级命中宝石','8级命中宝石合成',1,'[{lv,9999}]',1,'[{0,14010507,3}]','[]','[]','[]','[{0,14010508,1}]',1,'100',3,0,'[]',150),(15000009,'9级命中宝石','9级命中宝石合成',1,'[{lv,9999}]',1,'[{0,14010508,3}]','[]','[]','[]','[{0,14010509,1}]',1,'100',3,0,'[]',150),(16000001,'1级闪避宝石','1级闪避宝石合成',1,'[{lv,9999}]',1,'[{0,14120001,3}]','[]','[]','[]','[{0,14020601,1}]',1,'100',3,0,'[]',150),(16000002,'2级闪避宝石','2级闪避宝石合成',1,'[{lv,9999}]',1,'[{0,14020601,3}]','[]','[]','[]','[{0,14020602,1}]',1,'100',3,0,'[]',150),(16000003,'3级闪避宝石','3级闪避宝石合成',1,'[{lv,9999}]',1,'[{0,14020602,3}]','[]','[]','[]','[{0,14020603,1}]',1,'100',3,0,'[]',150),(16000004,'4级闪避宝石','4级闪避宝石合成',1,'[{lv,9999}]',1,'[{0,14020603,3}]','[]','[]','[]','[{0,14020604,1}]',1,'100',3,0,'[]',150),(16000005,'5级闪避宝石','5级闪避宝石合成',1,'[{lv,9999}]',1,'[{0,14020604,3}]','[]','[]','[]','[{0,14020605,1}]',1,'100',3,0,'[]',150),(16000006,'6级闪避宝石','6级闪避宝石合成',1,'[{lv,9999}]',1,'[{0,14020605,3}]','[]','[]','[]','[{0,14020606,1}]',1,'100',3,0,'[]',150),(16000007,'7级闪避宝石','7级闪避宝石合成',1,'[{lv,9999}]',1,'[{0,14020606,3}]','[]','[]','[]','[{0,14020607,1}]',1,'100',3,0,'[]',150),(16000008,'8级闪避宝石','8级闪避宝石合成',1,'[{lv,9999}]',1,'[{0,14020607,3}]','[]','[]','[]','[{0,14020608,1}]',1,'100',3,0,'[]',150),(16000009,'9级闪避宝石','9级闪避宝石合成',1,'[{lv,9999}]',1,'[{0,14020608,3}]','[]','[]','[]','[{0,14020609,1}]',1,'100',3,0,'[]',150),(17000001,'1级暴击宝石','1级暴击宝石合成',1,'[{lv,360}]',1,'[{0,14120001,3}]','[]','[]','[]','[{0,14010701,1}]',1,'100',3,0,'[]',150),(17000002,'2级暴击宝石','2级暴击宝石合成',1,'[{lv,360}]',1,'[{0,14010701,3}]','[]','[]','[]','[{0,14010702,1}]',1,'100',3,0,'[]',150),(17000003,'3级暴击宝石','3级暴击宝石合成',1,'[{lv,360}]',1,'[{0,14010702,3}]','[]','[]','[]','[{0,14010703,1}]',1,'100',3,0,'[]',150),(17000004,'4级暴击宝石','4级暴击宝石合成',1,'[{lv,360}]',1,'[{0,14010703,3}]','[]','[]','[]','[{0,14010704,1}]',1,'100',3,0,'[]',150),(17000005,'5级暴击宝石','5级暴击宝石合成',1,'[{lv,360}]',1,'[{0,14010704,3}]','[]','[]','[]','[{0,14010705,1}]',1,'100',3,0,'[]',150),(17000006,'6级暴击宝石','6级暴击宝石合成',1,'[{lv,360}]',1,'[{0,14010705,3}]','[]','[]','[]','[{0,14010706,1}]',1,'100',3,0,'[]',150),(17000007,'7级暴击宝石','7级暴击宝石合成',1,'[{lv,360}]',1,'[{0,14010706,3}]','[]','[]','[]','[{0,14010707,1}]',1,'100',3,0,'[]',150),(17000008,'8级暴击宝石','8级暴击宝石合成',1,'[{lv,360}]',1,'[{0,14010707,3}]','[]','[]','[]','[{0,14010708,1}]',1,'100',3,0,'[]',150),(17000009,'9级暴击宝石','9级暴击宝石合成',1,'[{lv,360}]',1,'[{0,14010708,3}]','[]','[]','[]','[{0,14010709,1}]',1,'100',3,0,'[]',150),(18000001,'1级韧性宝石','1级韧性宝石合成',1,'[{lv,360}]',1,'[{0,14120001,3}]','[]','[]','[]','[{0,14020801,1}]',1,'100',3,0,'[]',150),(18000002,'2级韧性宝石','2级韧性宝石合成',1,'[{lv,360}]',1,'[{0,14020801,3}]','[]','[]','[]','[{0,14020802,1}]',1,'100',3,0,'[]',150),(18000003,'3级韧性宝石','3级韧性宝石合成',1,'[{lv,360}]',1,'[{0,14020802,3}]','[]','[]','[]','[{0,14020803,1}]',1,'100',3,0,'[]',150),(18000004,'4级韧性宝石','4级韧性宝石合成',1,'[{lv,360}]',1,'[{0,14020803,3}]','[]','[]','[]','[{0,14020804,1}]',1,'100',3,0,'[]',150),(18000005,'5级韧性宝石','5级韧性宝石合成',1,'[{lv,360}]',1,'[{0,14020804,3}]','[]','[]','[]','[{0,14020805,1}]',1,'100',3,0,'[]',150),(18000006,'6级韧性宝石','6级韧性宝石合成',1,'[{lv,360}]',1,'[{0,14020805,3}]','[]','[]','[]','[{0,14020806,1}]',1,'100',3,0,'[]',150),(18000007,'7级韧性宝石','7级韧性宝石合成',1,'[{lv,360}]',1,'[{0,14020806,3}]','[]','[]','[]','[{0,14020807,1}]',1,'100',3,0,'[]',150),(18000008,'8级韧性宝石','8级韧性宝石合成',1,'[{lv,360}]',1,'[{0,14020807,3}]','[]','[]','[]','[{0,14020808,1}]',1,'100',3,0,'[]',150),(18000009,'9级韧性宝石','9级韧性宝石合成',1,'[{lv,360}]',1,'[{0,14020808,3}]','[]','[]','[]','[{0,14020809,1}]',1,'100',3,0,'[]',150),(19000001,'攻击破甲宝石','攻击破甲宝石',1,'[{lv,360}]',4,'[{0,14110001,4}]','[]','[{[14010104,14010105,14010106,14010107,14010108,14010109]},{[14010304,14010305,14010306,14010307,14010308,14010309]}]','[]','[{0,14100013,1}]',1,'100',1,0,'[]',150),(19000002,'生命防御宝石','生命防御宝石',1,'[{lv,360}]',4,'[{0,14110002,4}]','[]','[{[14020204,14020205,14020206,14020207,14020208,14020209]},{[14020404,14020405,14020406,14020407,14020408,14020409]}]','[]','[{0,14100024,1}]',1,'100',1,0,'[]',150),(19000003,'破甲命中宝石','破甲命中宝石',1,'[{lv,9999}]',4,'[{0,14110001,4}]','[]','[{[14010304,14010305,14010306,14010307,14010308,14010309]},{[14010504,14010505,14010506,14010507,14010508,14010509]}]','[]','[{0,14100035,1}]',1,'100',1,0,'[]',150),(19000004,'防御闪避宝石','防御闪避宝石',1,'[{lv,9999}]',4,'[{0,14110002,4}]','[]','[{[14020404,14020405,14020406,14020407,14020408,14020409]},{[14020604,14020605,14020606,14020607,14020608,14020609]}]','[]','[{0,14100046,1}]',1,'100',1,0,'[]',150),(19000005,'命中暴击宝石','命中暴击宝石',1,'[{lv,9999}]',4,'[{0,14110001,4}]','[]','[{[14010504,14010505,14010506,14010507,14010508,14010509]},{[14010704,14010705,14010706,14010707,14010708,14010709]}]','[]','[{0,14100057,1}]',1,'100',1,0,'[]',150),(19000006,'闪避韧性宝石','闪避韧性宝石',1,'[{lv,9999}]',4,'[{0,14110002,4}]','[]','[{[14020604,14020605,14020606,14020607,14020608,14020609]},{[14020804,14020805,14020806,14020807,14020808,14020809]}]','[]','[{0,14100068,1}]',1,'100',1,0,'[]',150),(19000007,'暴击攻击宝石','暴击攻击宝石',1,'[{lv,360}]',4,'[{0,14110001,4}]','[]','[{[14010704,14010705,14010706,14010707,14010708,14010709]},{[14010104,14010105,14010106,14010107,14010108,14010109]}]','[]','[{0,14100071,1}]',1,'100',1,0,'[]',150),(19000008,'韧性生命宝石','韧性生命宝石',1,'[{lv,360}]',4,'[{0,14110002,4}]','[]','[{[14020804,14020805,14020806,14020807,14020808,14020809]},{[14020204,14020205,14020206,14020207,14020208,14020209]}]','[]','[{0,14100082,1}]',1,'100',1,0,'[]',150),(19000009,'攻击命中宝石','攻击命中宝石',1,'[{lv,9999}]',4,'[{0,14110001,4}]','[]','[{[14010104,14010105,14010106,14010107,14010108,14010109]},{[14010504,14010505,14010506,14010507,14010508,14010509]}]','[]','[{0,14100015,1}]',1,'100',1,0,'[]',150),(19000010,'生命闪避宝石','生命闪避宝石',1,'[{lv,9999}]',4,'[{0,14110002,4}]','[]','[{[14020204,14020205,14020206,14020207,14020208,14020209]},{[14020604,14020605,14020606,14020607,14020608,14020609]}]','[]','[{0,14100026,1}]',1,'100',1,0,'[]',150),(19000011,'破甲暴击宝石','破甲暴击宝石',1,'[{lv,360}]',4,'[{0,14110001,4}]','[]','[{[14010304,14010305,14010306,14010307,14010308,14010309]},{[14010704,14010705,14010706,14010707,14010708,14010709]}]','[]','[{0,14100037,1}]',1,'100',1,0,'[]',150),(19000012,'防御韧性宝石','防御韧性宝石',1,'[{lv,360}]',4,'[{0,14110002,4}]','[]','[{[14020404,14020405,14020406,14020407,14020408,14020409]},{[14020804,14020805,14020806,14020807,14020808,14020809]}]','[]','[{0,14100048,1}]',1,'100',1,0,'[]',150),(19100001,'中级星耀宝石','中级星耀宝石',1,'[{lv,110},{vip_lv,5}]',1,'[{0,14140110,3}]','[]','[]','[]','[{0,14140111,1}]',1,'100',3,0,'[]',150),(19100002,'特级星耀宝石','特级星耀宝石',1,'[{lv,110},{vip_lv,5}]',1,'[{0,14140111,3}]','[]','[]','[]','[{0,14140112,1}]',1,'100',3,0,'[]',150),(19100003,'中级月华宝石','中级月华宝石',1,'[{lv,110},{vip_lv,5}]',1,'[{0,14140210,3}]','[]','[]','[]','[{0,14140211,1}]',1,'100',3,0,'[]',150),(19100004,'特级月华宝石','特级月华宝石',1,'[{lv,110},{vip_lv,5}]',1,'[{0,14140211,3}]','[]','[]','[]','[{0,14140212,1}]',1,'100',3,0,'[]',150),(19100005,'中级阳炎宝石','中级阳炎宝石',1,'[{lv,110},{vip_lv,5}]',1,'[{0,14140310,3}]','[]','[]','[]','[{0,14140311,1}]',1,'100',3,0,'[]',150),(19100006,'特级阳炎宝石','特级阳炎宝石',1,'[{lv,110},{vip_lv,5}]',1,'[{0,14140311,3}]','[]','[]','[]','[{0,14140312,1}]',1,'100',3,0,'[]',150),(19100007,'中级晨辉宝石','中级晨辉宝石',1,'[{lv,110},{vip_lv,5}]',1,'[{0,14140410,3}]','[]','[]','[]','[{0,14140411,1}]',1,'100',3,0,'[]',150),(19100008,'特级晨辉宝石','特级晨辉宝石',1,'[{lv,110},{vip_lv,5}]',1,'[{0,14140411,3}]','[]','[]','[]','[{0,14140412,1}]',1,'100',3,0,'[]',150),(19200001,'中级风灵宝石','中级风灵宝石',1,'[{lv,110},{vip_lv,5}]',1,'[{0,14140510,3}]','[]','[]','[]','[{0,14140511,1}]',1,'100',3,0,'[]',150),(19200002,'特级风灵宝石','特级风灵宝石',1,'[{lv,110},{vip_lv,5}]',1,'[{0,14140511,3}]','[]','[]','[]','[{0,14140512,1}]',1,'100',3,0,'[]',150),(19200003,'中级木魂宝石','中级木魂宝石',1,'[{lv,110},{vip_lv,5}]',1,'[{0,14140610,3}]','[]','[]','[]','[{0,14140611,1}]',1,'100',3,0,'[]',150),(19200004,'特级木魂宝石','特级木魂宝石',1,'[{lv,110},{vip_lv,5}]',1,'[{0,14140611,3}]','[]','[]','[]','[{0,14140612,1}]',1,'100',3,0,'[]',150),(19200005,'中级土曜宝石','中级土曜宝石',1,'[{lv,110},{vip_lv,5}]',1,'[{0,14140710,3}]','[]','[]','[]','[{0,14140711,1}]',1,'100',3,0,'[]',150),(19200006,'特级土曜宝石','特级土曜宝石',1,'[{lv,110},{vip_lv,5}]',1,'[{0,14140711,3}]','[]','[]','[]','[{0,14140712,1}]',1,'100',3,0,'[]',150),(19200007,'中级冰晶宝石','中级冰晶宝石',1,'[{lv,110},{vip_lv,5}]',1,'[{0,14140810,3}]','[]','[]','[]','[{0,14140811,1}]',1,'100',3,0,'[]',150),(19200008,'特级冰晶宝石','特级冰晶宝石',1,'[{lv,110},{vip_lv,5}]',1,'[{0,14140811,3}]','[]','[]','[]','[{0,14140812,1}]',1,'100',3,0,'[]',150),(21000001,'龙魂宝珠','宝具幻化卡1',1,'[{lv,75}]',1,'[{0,24031001,10}]','[]','[]','[]','[{0,24030001,1}]',1,'100',3,0,'[]',150),(21000002,'失落魔方','宝具幻化卡2',1,'[{lv,75}]',1,'[{0,24031002,10}]','[]','[]','[]','[{0,24030002,1}]',1,'100',3,0,'[]',150),(21000003,'古神典籍','宝具幻化卡3',1,'[{lv,75}]',1,'[{0,24031003,10}]','[]','[]','[]','[{0,24030003,1}]',1,'100',3,0,'[]',150),(21000004,'海洋之心','宝具幻化卡4',1,'[{lv,75}]',1,'[{0,24031004,10}]','[]','[]','[]','[{0,24030004,1}]',1,'100',3,0,'[]',150),(21000005,'海洋护符','宝具幻化卡5',1,'[{lv,75}]',1,'[{0,24031005,10}]','[]','[]','[]','[{0,24030005,1}]',1,'100',3,0,'[]',150),(21000006,'航海宝珠','宝具幻化卡6',1,'[{lv,75}]',1,'[{0,24031006,10}]','[]','[]','[]','[{0,24030006,1}]',1,'100',3,0,'[]',150),(21000007,'善恶天秤','宝具幻化卡7',1,'[{lv,75}]',1,'[{0,24031007,10}]','[]','[]','[]','[{0,24030007,1}]',1,'100',3,0,'[]',150),(21000008,'许愿神灯','宝具幻化卡8',1,'[{lv,1001}]',1,'[{0,24031008,10}]','[]','[]','[]','[{0,24030008,1}]',1,'100',3,0,'[]',150),(21000009,'创世女神','宝具幻化卡9',1,'[{lv,1001}]',1,'[{0,24031009,10}]','[]','[]','[]','[{0,24030009,1}]',1,'100',3,0,'[]',150),(22000001,'萌羊座召唤卡','萌羊座召唤卡',1,'[{lv,75}]',1,'[{0,18041001,10}]','[]','[]','[]','[{0,18040001,1}]',1,'100',3,0,'[]',150),(22000002,'白羊座召唤卡','白羊座召唤卡',1,'[{lv,75}]',1,'[{0,18041002,10}]','[]','[]','[]','[{0,18040002,1}]',1,'100',3,0,'[]',150),(22000003,'金牛座召唤卡','金牛座召唤卡',1,'[{lv,75}]',1,'[{0,18041003,10}]','[]','[]','[]','[{0,18040003,1}]',1,'100',3,0,'[]',150),(22000004,'双子座召唤卡','双子座召唤卡',1,'[{lv,75}]',1,'[{0,18041004,10}]','[]','[]','[]','[{0,18040004,1}]',1,'100',3,0,'[]',150),(22000005,'巨蟹座召唤卡','巨蟹座召唤卡',1,'[{lv,75}]',1,'[{0,18041005,10}]','[]','[]','[]','[{0,18040005,1}]',1,'100',3,0,'[]',150),(22000006,'狮子座召唤卡','狮子座召唤卡',1,'[{lv,75}]',1,'[{0,18041006,10}]','[]','[]','[]','[{0,18040006,1}]',1,'100',3,0,'[]',150),(22000007,'处女座召唤卡','处女座召唤卡',1,'[{lv,75}]',1,'[{0,18041007,10}]','[]','[]','[]','[{0,18040007,1}]',1,'100',3,0,'[]',150),(22001001,'熊霸霸召唤卡','普通星灵召唤卡1',1,'[{lv,75}]',1,'[{0,18041101,10}]','[]','[]','[]','[{0,18040101,1}]',1,'100',3,0,'[]',150),(22001002,'难大师召唤卡','普通星灵召唤卡2',1,'[{lv,75}]',1,'[{0,18041102,10}]','[]','[]','[]','[{0,18040102,1}]',1,'100',3,0,'[]',150),(22001003,'代号09召唤卡','普通星灵召唤卡3',1,'[{lv,75}]',1,'[{0,18041103,10}]','[]','[]','[]','[{0,18040103,1}]',1,'100',3,0,'[]',150),(22001004,'修罗虎召唤卡','普通星灵召唤卡4',1,'[{lv,75}]',1,'[{0,18041104,10}]','[]','[]','[]','[{0,18040104,1}]',1,'100',3,0,'[]',150),(22001005,'暗影忍者召唤卡','普通星灵召唤卡5',1,'[{lv,75}]',1,'[{0,18041105,10}]','[]','[]','[]','[{0,18040105,1}]',1,'100',3,0,'[]',150),(22002001,'蛇夫座召唤卡','蛇夫座召唤卡',1,'[{lv,75}]',1,'[{0,18041008,10}]','[]','[]','[]','[{0,18040008,1}]',1,'100',3,0,'[]',150),(23000001,'赤焰飓风','坐骑幻化1',1,'[{lv,75}]',1,'[{0,16090001,30}]','[]','[]','[]','[{0,16030001,1}]',1,'100',3,0,'[]',150),(23000002,'旋翼飞空艇','坐骑幻化2',1,'[{lv,75}]',1,'[{0,16090002,30}]','[]','[]','[]','[{0,16030002,1}]',1,'100',3,0,'[]',150),(23000003,'呆萌兔','坐骑幻化3',1,'[{lv,75}]',1,'[{0,16090003,30}]','[]','[]','[]','[{0,16030003,1}]',1,'100',3,0,'[]',150),(23000004,'尸烬龙','坐骑幻化4',1,'[{lv,75}]',1,'[{0,16090004,30}]','[]','[]','[]','[{0,16030004,1}]',1,'100',3,0,'[]',150),(23000005,'利维坦','坐骑幻化5',1,'[{lv,75}]',1,'[{0,16090005,30}]','[]','[]','[]','[{0,16030005,1}]',1,'100',3,0,'[]',150),(23000006,'旅行蜗牛','坐骑幻化6',1,'[{lv,75}]',1,'[{0,16090006,30}]','[]','[]','[]','[{0,16030006,1}]',1,'100',3,0,'[]',150),(23000007,'机械达人','坐骑幻化7',1,'[{lv,75}]',1,'[{0,16090007,30}]','[]','[]','[]','[{0,16030007,1}]',1,'100',3,0,'[]',150),(23000008,'猫咪飞椅','坐骑幻化8',1,'[{lv,75}]',1,'[{0,16090008,30}]','[]','[]','[]','[{0,16030008,1}]',1,'100',3,0,'[]',150),(23000009,'魔法飞毯','坐骑幻化9',1,'[{lv,75}]',1,'[{0,16090009,30}]','[]','[]','[]','[{0,16030009,1}]',1,'100',3,0,'[]',150),(23000010,'白熊首领','坐骑幻化10',1,'[{lv,75}]',1,'[{0,16090010,30}]','[]','[]','[]','[{0,16030010,1}]',1,'100',3,0,'[]',150),(23000011,'夏日闲鸭','坐骑幻化10',1,'[{lv,75}]',1,'[{0,16090011,30}]','[]','[]','[]','[{0,16030011,1}]',1,'100',3,0,'[]',150),(23000012,'科技魔狼','坐骑幻化10',1,'[{lv,75}]',1,'[{0,16090012,30}]','[]','[]','[]','[{0,16030012,1}]',1,'100',3,0,'[]',150),(23000013,'大佬座驾','坐骑幻化10',1,'[{lv,75}]',1,'[{0,16090013,30}]','[]','[]','[]','[{0,16030013,1}]',1,'100',3,0,'[]',150),(24000001,'波塞冬','降神幻化1',1,'[{lv,75}]',1,'[{0,11050001,30}]','[]','[]','[]','[{0,11010001,1}]',1,'100',3,0,'[]',150),(24000002,'雅典娜','降神幻化2',1,'[{lv,75}]',1,'[{0,11050002,30}]','[]','[]','[]','[{0,11010002,1}]',1,'100',3,0,'[]',150),(24000003,'光辉神','降神幻化3',1,'[{lv,75}]',1,'[{0,11050003,30}]','[]','[]','[]','[{0,11010003,1}]',1,'100',3,0,'[]',150),(24000004,'月神','降神幻化4',1,'[{lv,75}]',1,'[{0,11050004,30}]','[]','[]','[]','[{0,11010005,1}]',1,'100',3,0,'[]',150),(24000005,'哈迪斯','降神幻化5',1,'[{lv,75}]',1,'[{0,11050005,30}]','[]','[]','[]','[{0,11010006,1}]',1,'100',3,0,'[]',150),(25000001,'海神之戟','降神圣器幻化1',1,'[{lv,75}]',1,'[{0,11060001,30}]','[]','[]','[]','[{0,11030001,1}]',1,'100',3,0,'[]',150),(25000002,'荣耀之枪','降神圣器幻化2',1,'[{lv,75}]',1,'[{0,11060002,30}]','[]','[]','[]','[{0,11030002,1}]',1,'100',3,0,'[]',150),(25000003,'月牙天冲','降神圣器幻化3',1,'[{lv,75}]',1,'[{0,11060004,30}]','[]','[]','[]','[{0,11030005,1}]',1,'100',3,0,'[]',150),(25000004,'亡者黑镰','降神圣器幻化4',1,'[{lv,75}]',1,'[{0,11060005,30}]','[]','[]','[]','[{0,11030006,1}]',1,'100',3,0,'[]',150),(25000005,'太阳权杖','降神圣器幻化5',1,'[{lv,75}]',1,'[{0,11060003,30}]','[]','[]','[]','[{0,11030003,1}]',1,'100',3,0,'[]',150),(26000001,'战争光环','翅膀幻化1',1,'[{lv,75}]',1,'[{0,20070006,30}]','[]','[]','[]','[{0,20030001,1}]',1,'100',3,0,'[]',150),(26000002,'涂鸦浪板','翅膀幻化2',1,'[{lv,75}]',1,'[{0,20070008,30}]','[]','[]','[]','[{0,20030003,1}]',1,'100',3,0,'[]',150),(26000003,'未来浪板','翅膀幻化3',1,'[{lv,75}]',1,'[{0,20070010,30}]','[]','[]','[]','[{0,20030005,1}]',1,'100',3,0,'[]',150),(26000004,'雷霆之主','翅膀幻化4',1,'[{lv,9999}]',1,'[{0,20070011,30}]','[]','[]','[]','[{0,20030006,1}]',1,'100',3,0,'[]',150),(26000005,'海底世界','翅膀幻化5',1,'[{lv,75}]',1,'[{0,20070012,30}]','[]','[]','[]','[{0,20030007,1}]',1,'100',3,0,'[]',150),(26000006,'熊猫奇遇','翅膀幻化6',1,'[{lv,75}]',1,'[{0,20070014,30}]','[]','[]','[]','[{0,20030009,1}]',1,'100',3,0,'[]',150),(26000007,'圣月罗盘','翅膀幻化7',1,'[{lv,75}]',1,'[{0,20070015,30}]','[]','[]','[]','[{0,20030010,1}]',1,'100',3,0,'[]',150),(26000008,'长耳兔','翅膀幻化8',1,'[{lv,75}]',1,'[{0,20070016,30}]','[]','[]','[]','[{0,20030011,1}]',1,'100',3,0,'[]',150),(26000009,'魔法黑猫','翅膀幻化9',1,'[{lv,75}]',1,'[{0,20070017,30}]','[]','[]','[]','[{0,20030012,1}]',1,'100',3,0,'[]',150),(26000010,'小熊鼓手','翅膀幻化10',1,'[{lv,75}]',1,'[{0,20070018,30}]','[]','[]','[]','[{0,20030013,1}]',1,'100',3,0,'[]',150),(27000001,'寒鸦·寒霜大剑','光武幻化1',1,'[{lv,130},{career, 1}]',1,'[{0,53040101,30}]','[]','[]','[]','[{0,53010101,1}]',1,'100',3,0,'[]',150),(27000002,'焚烬·龙焰斩剑','光武幻化2',1,'[{lv,130},{career, 1}]',1,'[{0,53040102,30}]','[]','[]','[]','[{0,53010102,1}]',1,'100',3,0,'[]',150),(27000003,'天火·强袭军刀','光武幻化3',1,'[{lv,130},{career, 1}]',1,'[{0,53040103,30}]','[]','[]','[]','[{0,53010103,1}]',1,'100',3,0,'[]',150),(27000004,'圣言·裁决圣剑','光武幻化4',1,'[{lv,130},{career, 1}]',1,'[{0,53040104,30}]','[]','[]','[]','[{0,53010104,1}]',1,'100',3,0,'[]',150),(27000005,'暗裔·灾厄魔剑','光武幻化5',1,'[{lv,130},{career, 1}]',1,'[{0,53040105,30}]','[]','[]','[]','[{0,53010105,1}]',1,'100',3,0,'[]',150),(27000006,'寒鸦·冰晶长枪','光武幻化6',1,'[{lv,130},{career, 2}]',1,'[{0,53040201,30}]','[]','[]','[]','[{0,53010201,1}]',1,'100',3,0,'[]',150),(27000007,'焚烬·屠龙炎枪','光武幻化7',1,'[{lv,130},{career, 2}]',1,'[{0,53040202,30}]','[]','[]','[]','[{0,53010202,1}]',1,'100',3,0,'[]',150),(27000008,'雷云·突击枪刃','光武幻化8',1,'[{lv,130},{career, 2}]',1,'[{0,53040203,30}]','[]','[]','[]','[{0,53010203,1}]',1,'100',3,0,'[]',150),(27000009,'圣言·断罪圣枪','光武幻化9',1,'[{lv,130},{career, 2}]',1,'[{0,53040204,30}]','[]','[]','[]','[{0,53010204,1}]',1,'100',3,0,'[]',150),(27000010,'暗裔·屠戮魔枪','光武幻化10',1,'[{lv,130},{career, 2}]',1,'[{0,53040205,30}]','[]','[]','[]','[{0,53010205,1}]',1,'100',3,0,'[]',150),(27000011,'寒鸦·凛冬重炮','光武幻化11',1,'[{lv,130},{career, 4}]',1,'[{0,53040401,30}]','[]','[]','[]','[{0,53010401,1}]',1,'100',3,0,'[]',150),(27000012,'焚烬·龙神火炮','光武幻化12',1,'[{lv,130},{career, 4}]',1,'[{0,53040402,30}]','[]','[]','[]','[{0,53010402,1}]',1,'100',3,0,'[]',150),(27000013,'复仇·离子火炮','光武幻化13',1,'[{lv,130},{career, 4}]',1,'[{0,53040403,30}]','[]','[]','[]','[{0,53010403,1}]',1,'100',3,0,'[]',150),(27000014,'圣言·真理火炮','光武幻化14',1,'[{lv,130},{career, 4}]',1,'[{0,53040404,30}]','[]','[]','[]','[{0,53010404,1}]',1,'100',3,0,'[]',150),(27000015,'暗裔·死亡魔炮','光武幻化15',1,'[{lv,130},{career, 4}]',1,'[{0,53040405,30}]','[]','[]','[]','[{0,53010405,1}]',1,'100',3,0,'[]',150),(28000001,'童年滑板','宝宝坐骑1',1,'[{lv,315}]',1,'[{0,54060101,10}]','[]','[]','[]','[{0,54030001,1}]',1,'100',3,0,'[]',150),(28000002,'大眼萌云','宝宝坐骑2',1,'[{lv,315}]',1,'[{0,54060102,30}]','[]','[]','[]','[{0,54030002,1}]',1,'100',3,0,'[]',150),(28000003,'极速飞行','宝宝坐骑3',1,'[{lv,315}]',1,'[{0,54060103,30}]','[]','[]','[]','[{0,54030003,1}]',1,'100',3,0,'[]',150),(28000004,'海贼王船','宝宝坐骑4',1,'[{lv,315}]',1,'[{0,54060104,30}]','[]','[]','[]','[{0,54030004,1}]',1,'100',3,0,'[]',150),(29000001,'蛋蛋壳菲菲','宝宝外观1',1,'[{lv,315}]',1,'[{0,54060201,30}]','[]','[]','[]','[{0,54050001,1}]',1,'100',3,0,'[]',150),(29000002,'蘑菇屋娜娜','宝宝外观2',1,'[{lv,315}]',1,'[{0,54060202,30}]','[]','[]','[]','[{0,54050002,1}]',1,'100',3,0,'[]',150),(29000003,'小法师露露','宝宝外观3',1,'[{lv,315}]',1,'[{0,54060203,30}]','[]','[]','[]','[{0,54050003,1}]',1,'100',3,0,'[]',150),(31070301,'武器','3阶红2星武器【魔剑士】',2,'[{lv,9999}]',2,'[]','[1001010332,1007010332,1001020332,1007020332,1001030332,1007030332,1001040332,1007040332]','[]','[]','[{0,1001010342,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(31070302,'头盔','3阶红2星头盔【魔剑士】',2,'[{lv,9999}]',2,'[]','[1002010332,1004010332,1006010332,1008010332,1010010332,1002020332,1004020332,1006020332,1008020332,1010020332,1002030332,1004030332,1006030332,1008030332,1010030332,1002040332,1004040332,1006040332,1008040332,1010040332]','[]','[]','[{0,1002010342,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(31070303,'项链','3阶红2星项链【通用】',2,'[{lv,9999}]',2,'[]','[1003000332,1003000332,1003000332,1003000332]','[]','[]','[{0,1003000342,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(31070304,'衣服','3阶红2星衣服【魔剑士】',2,'[{lv,9999}]',2,'[]','[1002010332,1004010332,1006010332,1008010332,1010010332,1002020332,1004020332,1006020332,1008020332,1010020332,1002030332,1004030332,1006030332,1008030332,1010030332,1002040332,1004040332,1006040332,1008040332,1010040332]','[]','[]','[{0,1004010342,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(31070305,'刻痕','3阶红2星刻痕【通用】',2,'[{lv,9999}]',2,'[]','[1005000332,1009000332,1005000332,1009000332,1005000332,1009000332,1005000332,1009000332]','[]','[]','[{0,1005000342,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(31070306,'裤子','3阶红2星裤子【魔剑士】',2,'[{lv,9999}]',2,'[]','[1002010332,1004010332,1006010332,1008010332,1010010332,1002020332,1004020332,1006020332,1008020332,1010020332,1002030332,1004030332,1006030332,1008030332,1010030332,1002040332,1004040332,1006040332,1008040332,1010040332]','[]','[]','[{0,1006010342,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(31070307,'副手','3阶红2星副手【魔剑士】',2,'[{lv,9999}]',2,'[]','[1001010332,1007010332,1001020332,1007020332,1001030332,1007030332,1001040332,1007040332]','[]','[]','[{0,1007010342,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(31070308,'护腕','3阶红2星护腕【魔剑士】',2,'[{lv,9999}]',2,'[]','[1002010332,1004010332,1006010332,1008010332,1010010332,1002020332,1004020332,1006020332,1008020332,1010020332,1002030332,1004030332,1006030332,1008030332,1010030332,1002040332,1004040332,1006040332,1008040332,1010040332]','[]','[]','[{0,1008010342,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(31070309,'戒指','3阶红2星戒指【通用】',2,'[{lv,9999}]',2,'[]','[1005000332,1009000332,1005000332,1009000332,1005000332,1009000332,1005000332,1009000332]','[]','[]','[{0,1009000342,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(31070310,'鞋子','3阶红2星鞋子【魔剑士】',2,'[{lv,9999}]',2,'[]','[1002010332,1004010332,1006010332,1008010332,1010010332,1002020332,1004020332,1006020332,1008020332,1010020332,1002030332,1004030332,1006030332,1008030332,1010030332,1002040332,1004040332,1006040332,1008040332,1010040332]','[]','[]','[{0,1010010342,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(31070401,'武器','4阶红2星武器【魔剑士】',2,'[{lv,160}]',2,'[]','[1001010432,1007010432,1001020432,1007020432,1001030432,1007030432,1001040432,1007040432]','[]','[]','[{0,1001010442,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(31070402,'头盔','4阶红2星头盔【魔剑士】',2,'[{lv,160}]',2,'[]','[1002010432,1004010432,1006010432,1008010432,1010010432,1002020432,1004020432,1006020432,1008020432,1010020432,1002030432,1004030432,1006030432,1008030432,1010030432,1002040432,1004040432,1006040432,1008040432,1010040432]','[]','[]','[{0,1002010442,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(31070403,'项链','4阶红2星项链【通用】',2,'[{lv,160}]',2,'[]','[1003000432,1003000432,1003000432,1003000432]','[]','[]','[{0,1003000442,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(31070404,'衣服','4阶红2星衣服【魔剑士】',2,'[{lv,160}]',2,'[]','[1002010432,1004010432,1006010432,1008010432,1010010432,1002020432,1004020432,1006020432,1008020432,1010020432,1002030432,1004030432,1006030432,1008030432,1010030432,1002040432,1004040432,1006040432,1008040432,1010040432]','[]','[]','[{0,1004010442,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(31070405,'刻痕','4阶红2星刻痕【通用】',2,'[{lv,160}]',2,'[]','[1005000432,1009000432,1005000432,1009000432,1005000432,1009000432,1005000432,1009000432]','[]','[]','[{0,1005000442,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(31070406,'裤子','4阶红2星裤子【魔剑士】',2,'[{lv,160}]',2,'[]','[1002010432,1004010432,1006010432,1008010432,1010010432,1002020432,1004020432,1006020432,1008020432,1010020432,1002030432,1004030432,1006030432,1008030432,1010030432,1002040432,1004040432,1006040432,1008040432,1010040432]','[]','[]','[{0,1006010442,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(31070407,'副手','4阶红2星副手【魔剑士】',2,'[{lv,160}]',2,'[]','[1001010432,1007010432,1001020432,1007020432,1001030432,1007030432,1001040432,1007040432]','[]','[]','[{0,1007010442,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(31070408,'护腕','4阶红2星护腕【魔剑士】',2,'[{lv,160}]',2,'[]','[1002010432,1004010432,1006010432,1008010432,1010010432,1002020432,1004020432,1006020432,1008020432,1010020432,1002030432,1004030432,1006030432,1008030432,1010030432,1002040432,1004040432,1006040432,1008040432,1010040432]','[]','[]','[{0,1008010442,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(31070409,'戒指','4阶红2星戒指【通用】',2,'[{lv,160}]',2,'[]','[1005000432,1009000432,1005000432,1009000432,1005000432,1009000432,1005000432,1009000432]','[]','[]','[{0,1009000442,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(31070410,'鞋子','4阶红2星鞋子【魔剑士】',2,'[{lv,160}]',2,'[]','[1002010432,1004010432,1006010432,1008010432,1010010432,1002020432,1004020432,1006020432,1008020432,1010020432,1002030432,1004030432,1006030432,1008030432,1010030432,1002040432,1004040432,1006040432,1008040432,1010040432]','[]','[]','[{0,1010010442,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(31070501,'武器','5阶红2星武器【魔剑士】',2,'[{lv,160}]',2,'[]','[1001010532,1007010532,1001020532,1007020532,1001030532,1007030532,1001040532,1007040532,1101010532,1107010532,1101020532,1107020532,1101030532,1107030532,1101040532,1107040532]','[]','[]','[{0,1001010542,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(31070502,'头盔','5阶红2星头盔【魔剑士】',2,'[{lv,160}]',2,'[]','[1002010532,1004010532,1006010532,1008010532,1010010532,1002020532,1004020532,1006020532,1008020532,1010020532,1002030532,1004030532,1006030532,1008030532,1010030532,1002040532,1004040532,1006040532,1008040532,1010040532,1102010532,1104010532,1106010532,1108010532,1110010532,1102020532,1104020532,1106020532,1108020532,1110020532,1102030532,1104030532,1106030532,1108030532,1110030532,1102040532,1104040532,1106040532,1108040532,1110040532]','[]','[]','[{0,1002010542,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(31070503,'项链','5阶红2星项链【通用】',2,'[{lv,160}]',2,'[]','[1003000532,1003000532,1003000532,1003000532,1103000532,1103000532,1103000532,1103000532]','[]','[]','[{0,1003000542,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(31070504,'衣服','5阶红2星衣服【魔剑士】',2,'[{lv,160}]',2,'[]','[1002010532,1004010532,1006010532,1008010532,1010010532,1002020532,1004020532,1006020532,1008020532,1010020532,1002030532,1004030532,1006030532,1008030532,1010030532,1002040532,1004040532,1006040532,1008040532,1010040532,1102010532,1104010532,1106010532,1108010532,1110010532,1102020532,1104020532,1106020532,1108020532,1110020532,1102030532,1104030532,1106030532,1108030532,1110030532,1102040532,1104040532,1106040532,1108040532,1110040532]','[]','[]','[{0,1004010542,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(31070505,'刻痕','5阶红2星刻痕【通用】',2,'[{lv,160}]',2,'[]','[1005000532,1009000532,1005000532,1009000532,1005000532,1009000532,1005000532,1009000532,1105000532,1109000532,1105000532,1109000532,1105000532,1109000532,1105000532,1109000532]','[]','[]','[{0,1005000542,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(31070506,'裤子','5阶红2星裤子【魔剑士】',2,'[{lv,160}]',2,'[]','[1002010532,1004010532,1006010532,1008010532,1010010532,1002020532,1004020532,1006020532,1008020532,1010020532,1002030532,1004030532,1006030532,1008030532,1010030532,1002040532,1004040532,1006040532,1008040532,1010040532,1102010532,1104010532,1106010532,1108010532,1110010532,1102020532,1104020532,1106020532,1108020532,1110020532,1102030532,1104030532,1106030532,1108030532,1110030532,1102040532,1104040532,1106040532,1108040532,1110040532]','[]','[]','[{0,1006010542,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(31070507,'副手','5阶红2星副手【魔剑士】',2,'[{lv,160}]',2,'[]','[1001010532,1007010532,1001020532,1007020532,1001030532,1007030532,1001040532,1007040532,1101010532,1107010532,1101020532,1107020532,1101030532,1107030532,1101040532,1107040532]','[]','[]','[{0,1007010542,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(31070508,'护腕','5阶红2星护腕【魔剑士】',2,'[{lv,160}]',2,'[]','[1002010532,1004010532,1006010532,1008010532,1010010532,1002020532,1004020532,1006020532,1008020532,1010020532,1002030532,1004030532,1006030532,1008030532,1010030532,1002040532,1004040532,1006040532,1008040532,1010040532,1102010532,1104010532,1106010532,1108010532,1110010532,1102020532,1104020532,1106020532,1108020532,1110020532,1102030532,1104030532,1106030532,1108030532,1110030532,1102040532,1104040532,1106040532,1108040532,1110040532]','[]','[]','[{0,1008010542,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(31070509,'戒指','5阶红2星戒指【通用】',2,'[{lv,160}]',2,'[]','[1005000532,1009000532,1005000532,1009000532,1005000532,1009000532,1005000532,1009000532,1105000532,1109000532,1105000532,1109000532,1105000532,1109000532,1105000532,1109000532]','[]','[]','[{0,1009000542,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(31070510,'鞋子','5阶红2星鞋子【魔剑士】',2,'[{lv,160}]',2,'[]','[1002010532,1004010532,1006010532,1008010532,1010010532,1002020532,1004020532,1006020532,1008020532,1010020532,1002030532,1004030532,1006030532,1008030532,1010030532,1002040532,1004040532,1006040532,1008040532,1010040532,1102010532,1104010532,1106010532,1108010532,1110010532,1102020532,1104020532,1106020532,1108020532,1110020532,1102030532,1104030532,1106030532,1108030532,1110030532,1102040532,1104040532,1106040532,1108040532,1110040532]','[]','[]','[{0,1010010542,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(31070601,'武器','6阶红2星武器【魔剑士】',2,'[{lv,180}]',2,'[]','[1001010632,1007010632,1001020632,1007020632,1001030632,1007030632,1001040632,1007040632]','[]','[]','[{0,1001010642,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(31070602,'头盔','6阶红2星头盔【魔剑士】',2,'[{lv,180}]',2,'[]','[1002010632,1004010632,1006010632,1008010632,1010010632,1002020632,1004020632,1006020632,1008020632,1010020632,1002030632,1004030632,1006030632,1008030632,1010030632,1002040632,1004040632,1006040632,1008040632,1010040632]','[]','[]','[{0,1002010642,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(31070603,'项链','6阶红2星项链【通用】',2,'[{lv,180}]',2,'[]','[1003000632,1003000632,1003000632,1003000632]','[]','[]','[{0,1003000642,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(31070604,'衣服','6阶红2星衣服【魔剑士】',2,'[{lv,180}]',2,'[]','[1002010632,1004010632,1006010632,1008010632,1010010632,1002020632,1004020632,1006020632,1008020632,1010020632,1002030632,1004030632,1006030632,1008030632,1010030632,1002040632,1004040632,1006040632,1008040632,1010040632]','[]','[]','[{0,1004010642,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(31070605,'刻痕','6阶红2星刻痕【通用】',2,'[{lv,180}]',2,'[]','[1005000632,1009000632,1005000632,1009000632,1005000632,1009000632,1005000632,1009000632]','[]','[]','[{0,1005000642,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(31070606,'裤子','6阶红2星裤子【魔剑士】',2,'[{lv,180}]',2,'[]','[1002010632,1004010632,1006010632,1008010632,1010010632,1002020632,1004020632,1006020632,1008020632,1010020632,1002030632,1004030632,1006030632,1008030632,1010030632,1002040632,1004040632,1006040632,1008040632,1010040632]','[]','[]','[{0,1006010642,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(31070607,'副手','6阶红2星副手【魔剑士】',2,'[{lv,180}]',2,'[]','[1001010632,1007010632,1001020632,1007020632,1001030632,1007030632,1001040632,1007040632]','[]','[]','[{0,1007010642,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(31070608,'护腕','6阶红2星护腕【魔剑士】',2,'[{lv,180}]',2,'[]','[1002010632,1004010632,1006010632,1008010632,1010010632,1002020632,1004020632,1006020632,1008020632,1010020632,1002030632,1004030632,1006030632,1008030632,1010030632,1002040632,1004040632,1006040632,1008040632,1010040632]','[]','[]','[{0,1008010642,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(31070609,'戒指','6阶红2星戒指【通用】',2,'[{lv,180}]',2,'[]','[1005000632,1009000632,1005000632,1009000632,1005000632,1009000632,1005000632,1009000632]','[]','[]','[{0,1009000642,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(31070610,'鞋子','6阶红2星鞋子【魔剑士】',2,'[{lv,180}]',2,'[]','[1002010632,1004010632,1006010632,1008010632,1010010632,1002020632,1004020632,1006020632,1008020632,1010020632,1002030632,1004030632,1006030632,1008030632,1010030632,1002040632,1004040632,1006040632,1008040632,1010040632]','[]','[]','[{0,1010010642,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(31070701,'武器','7阶红2星武器【魔剑士】',2,'[{lv,220}]',2,'[]','[1001010732,1007010732,1001020732,1007020732,1001030732,1007030732,1001040732,1007040732,1101010732,1107010732,1101020732,1107020732,1101030732,1107030732,1101040732,1107040732]','[]','[]','[{0,1001010742,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31070702,'头盔','7阶红2星头盔【魔剑士】',2,'[{lv,220}]',2,'[]','[1002010732,1004010732,1006010732,1008010732,1010010732,1002020732,1004020732,1006020732,1008020732,1010020732,1002030732,1004030732,1006030732,1008030732,1010030732,1002040732,1004040732,1006040732,1008040732,1010040732,1102010732,1104010732,1106010732,1108010732,1110010732,1102020732,1104020732,1106020732,1108020732,1110020732,1102030732,1104030732,1106030732,1108030732,1110030732,1102040732,1104040732,1106040732,1108040732,1110040732]','[]','[]','[{0,1002010742,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31070703,'项链','7阶红2星项链【通用】',2,'[{lv,220}]',2,'[]','[1003000732,1003000732,1003000732,1003000732,1103000732,1103000732,1103000732,1103000732]','[]','[]','[{0,1003000742,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31070704,'衣服','7阶红2星衣服【魔剑士】',2,'[{lv,220}]',2,'[]','[1002010732,1004010732,1006010732,1008010732,1010010732,1002020732,1004020732,1006020732,1008020732,1010020732,1002030732,1004030732,1006030732,1008030732,1010030732,1002040732,1004040732,1006040732,1008040732,1010040732,1102010732,1104010732,1106010732,1108010732,1110010732,1102020732,1104020732,1106020732,1108020732,1110020732,1102030732,1104030732,1106030732,1108030732,1110030732,1102040732,1104040732,1106040732,1108040732,1110040732]','[]','[]','[{0,1004010742,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31070705,'刻痕','7阶红2星刻痕【通用】',2,'[{lv,220}]',2,'[]','[1005000732,1009000732,1005000732,1009000732,1005000732,1009000732,1005000732,1009000732,1105000732,1109000732,1105000732,1109000732,1105000732,1109000732,1105000732,1109000732]','[]','[]','[{0,1005000742,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31070706,'裤子','7阶红2星裤子【魔剑士】',2,'[{lv,220}]',2,'[]','[1002010732,1004010732,1006010732,1008010732,1010010732,1002020732,1004020732,1006020732,1008020732,1010020732,1002030732,1004030732,1006030732,1008030732,1010030732,1002040732,1004040732,1006040732,1008040732,1010040732,1102010732,1104010732,1106010732,1108010732,1110010732,1102020732,1104020732,1106020732,1108020732,1110020732,1102030732,1104030732,1106030732,1108030732,1110030732,1102040732,1104040732,1106040732,1108040732,1110040732]','[]','[]','[{0,1006010742,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31070707,'副手','7阶红2星副手【魔剑士】',2,'[{lv,220}]',2,'[]','[1001010732,1007010732,1001020732,1007020732,1001030732,1007030732,1001040732,1007040732,1101010732,1107010732,1101020732,1107020732,1101030732,1107030732,1101040732,1107040732]','[]','[]','[{0,1007010742,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31070708,'护腕','7阶红2星护腕【魔剑士】',2,'[{lv,220}]',2,'[]','[1002010732,1004010732,1006010732,1008010732,1010010732,1002020732,1004020732,1006020732,1008020732,1010020732,1002030732,1004030732,1006030732,1008030732,1010030732,1002040732,1004040732,1006040732,1008040732,1010040732,1102010732,1104010732,1106010732,1108010732,1110010732,1102020732,1104020732,1106020732,1108020732,1110020732,1102030732,1104030732,1106030732,1108030732,1110030732,1102040732,1104040732,1106040732,1108040732,1110040732]','[]','[]','[{0,1008010742,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31070709,'戒指','7阶红2星戒指【通用】',2,'[{lv,220}]',2,'[]','[1005000732,1009000732,1005000732,1009000732,1005000732,1009000732,1005000732,1009000732,1105000732,1109000732,1105000732,1109000732,1105000732,1109000732,1105000732,1109000732]','[]','[]','[{0,1009000742,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31070710,'鞋子','7阶红2星鞋子【魔剑士】',2,'[{lv,220}]',2,'[]','[1002010732,1004010732,1006010732,1008010732,1010010732,1002020732,1004020732,1006020732,1008020732,1010020732,1002030732,1004030732,1006030732,1008030732,1010030732,1002040732,1004040732,1006040732,1008040732,1010040732,1102010732,1104010732,1106010732,1108010732,1110010732,1102020732,1104020732,1106020732,1108020732,1110020732,1102030732,1104030732,1106030732,1108030732,1110030732,1102040732,1104040732,1106040732,1108040732,1110040732]','[]','[]','[{0,1010010742,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31070801,'武器','8阶红2星武器【魔剑士】',2,'[{lv,260}]',2,'[]','[1001010832,1007010832,1001020832,1007020832,1001030832,1007030832,1001040832,1007040832]','[]','[]','[{0,1001010842,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31070802,'头盔','8阶红2星头盔【魔剑士】',2,'[{lv,260}]',2,'[]','[1002010832,1004010832,1006010832,1008010832,1010010832,1002020832,1004020832,1006020832,1008020832,1010020832,1002030832,1004030832,1006030832,1008030832,1010030832,1002040832,1004040832,1006040832,1008040832,1010040832]','[]','[]','[{0,1002010842,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31070803,'项链','8阶红2星项链【通用】',2,'[{lv,260}]',2,'[]','[1003000832,1003000832,1003000832,1003000832]','[]','[]','[{0,1003000842,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31070804,'衣服','8阶红2星衣服【魔剑士】',2,'[{lv,260}]',2,'[]','[1002010832,1004010832,1006010832,1008010832,1010010832,1002020832,1004020832,1006020832,1008020832,1010020832,1002030832,1004030832,1006030832,1008030832,1010030832,1002040832,1004040832,1006040832,1008040832,1010040832]','[]','[]','[{0,1004010842,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31070805,'刻痕','8阶红2星刻痕【通用】',2,'[{lv,260}]',2,'[]','[1005000832,1009000832,1005000832,1009000832,1005000832,1009000832,1005000832,1009000832]','[]','[]','[{0,1005000842,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31070806,'裤子','8阶红2星裤子【魔剑士】',2,'[{lv,260}]',2,'[]','[1002010832,1004010832,1006010832,1008010832,1010010832,1002020832,1004020832,1006020832,1008020832,1010020832,1002030832,1004030832,1006030832,1008030832,1010030832,1002040832,1004040832,1006040832,1008040832,1010040832]','[]','[]','[{0,1006010842,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31070807,'副手','8阶红2星副手【魔剑士】',2,'[{lv,260}]',2,'[]','[1001010832,1007010832,1001020832,1007020832,1001030832,1007030832,1001040832,1007040832]','[]','[]','[{0,1007010842,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31070808,'护腕','8阶红2星护腕【魔剑士】',2,'[{lv,260}]',2,'[]','[1002010832,1004010832,1006010832,1008010832,1010010832,1002020832,1004020832,1006020832,1008020832,1010020832,1002030832,1004030832,1006030832,1008030832,1010030832,1002040832,1004040832,1006040832,1008040832,1010040832]','[]','[]','[{0,1008010842,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31070809,'戒指','8阶红2星戒指【通用】',2,'[{lv,260}]',2,'[]','[1005000832,1009000832,1005000832,1009000832,1005000832,1009000832,1005000832,1009000832]','[]','[]','[{0,1009000842,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31070810,'鞋子','8阶红2星鞋子【魔剑士】',2,'[{lv,260}]',2,'[]','[1002010832,1004010832,1006010832,1008010832,1010010832,1002020832,1004020832,1006020832,1008020832,1010020832,1002030832,1004030832,1006030832,1008030832,1010030832,1002040832,1004040832,1006040832,1008040832,1010040832]','[]','[]','[{0,1010010842,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31070901,'武器','9阶红2星武器【魔剑士】',2,'[{lv,300}]',2,'[]','[1001010932,1007010932,1001020932,1007020932,1001030932,1007030932,1001040932,1007040932]','[]','[]','[{0,1001010942,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31070902,'头盔','9阶红2星头盔【魔剑士】',2,'[{lv,300}]',2,'[]','[1002010932,1004010932,1006010932,1008010932,1010010932,1002020932,1004020932,1006020932,1008020932,1010020932,1002030932,1004030932,1006030932,1008030932,1010030932,1002040932,1004040932,1006040932,1008040932,1010040932]','[]','[]','[{0,1002010942,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31070903,'项链','9阶红2星项链【通用】',2,'[{lv,300}]',2,'[]','[1003000932,1003000932,1003000932,1003000932]','[]','[]','[{0,1003000942,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31070904,'衣服','9阶红2星衣服【魔剑士】',2,'[{lv,300}]',2,'[]','[1002010932,1004010932,1006010932,1008010932,1010010932,1002020932,1004020932,1006020932,1008020932,1010020932,1002030932,1004030932,1006030932,1008030932,1010030932,1002040932,1004040932,1006040932,1008040932,1010040932]','[]','[]','[{0,1004010942,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31070905,'刻痕','9阶红2星刻痕【通用】',2,'[{lv,300}]',2,'[]','[1005000932,1009000932,1005000932,1009000932,1005000932,1009000932,1005000932,1009000932]','[]','[]','[{0,1005000942,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31070906,'裤子','9阶红2星裤子【魔剑士】',2,'[{lv,300}]',2,'[]','[1002010932,1004010932,1006010932,1008010932,1010010932,1002020932,1004020932,1006020932,1008020932,1010020932,1002030932,1004030932,1006030932,1008030932,1010030932,1002040932,1004040932,1006040932,1008040932,1010040932]','[]','[]','[{0,1006010942,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31070907,'副手','9阶红2星副手【魔剑士】',2,'[{lv,300}]',2,'[]','[1001010932,1007010932,1001020932,1007020932,1001030932,1007030932,1001040932,1007040932]','[]','[]','[{0,1007010942,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31070908,'护腕','9阶红2星护腕【魔剑士】',2,'[{lv,300}]',2,'[]','[1002010932,1004010932,1006010932,1008010932,1010010932,1002020932,1004020932,1006020932,1008020932,1010020932,1002030932,1004030932,1006030932,1008030932,1010030932,1002040932,1004040932,1006040932,1008040932,1010040932]','[]','[]','[{0,1008010942,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31070909,'戒指','9阶红2星戒指【通用】',2,'[{lv,300}]',2,'[]','[1005000932,1009000932,1005000932,1009000932,1005000932,1009000932,1005000932,1009000932]','[]','[]','[{0,1009000942,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31070910,'鞋子','9阶红2星鞋子【魔剑士】',2,'[{lv,300}]',2,'[]','[1002010932,1004010932,1006010932,1008010932,1010010932,1002020932,1004020932,1006020932,1008020932,1010020932,1002030932,1004030932,1006030932,1008030932,1010030932,1002040932,1004040932,1006040932,1008040932,1010040932]','[]','[]','[{0,1010010942,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071001,'武器','10阶红2星武器【魔剑士】',2,'[{lv,355}]',2,'[]','[1001011032,1007011032,1001021032,1007021032,1001031032,1007031032,1001041032,1007041032]','[]','[]','[{0,1001011042,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071002,'头盔','10阶红2星头盔【魔剑士】',2,'[{lv,355}]',2,'[]','[1002011032,1004011032,1006011032,1008011032,1010011032,1002021032,1004021032,1006021032,1008021032,1010021032,1002031032,1004031032,1006031032,1008031032,1010031032,1002041032,1004041032,1006041032,1008041032,1010041032]','[]','[]','[{0,1002011042,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071003,'项链','10阶红2星项链【通用】',2,'[{lv,355}]',2,'[]','[1003001032,1003001032,1003001032,1003001032]','[]','[]','[{0,1003001042,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071004,'衣服','10阶红2星衣服【魔剑士】',2,'[{lv,355}]',2,'[]','[1002011032,1004011032,1006011032,1008011032,1010011032,1002021032,1004021032,1006021032,1008021032,1010021032,1002031032,1004031032,1006031032,1008031032,1010031032,1002041032,1004041032,1006041032,1008041032,1010041032]','[]','[]','[{0,1004011042,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071005,'刻痕','10阶红2星刻痕【通用】',2,'[{lv,355}]',2,'[]','[1005001032,1009001032,1005001032,1009001032,1005001032,1009001032,1005001032,1009001032]','[]','[]','[{0,1005001042,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071006,'裤子','10阶红2星裤子【魔剑士】',2,'[{lv,355}]',2,'[]','[1002011032,1004011032,1006011032,1008011032,1010011032,1002021032,1004021032,1006021032,1008021032,1010021032,1002031032,1004031032,1006031032,1008031032,1010031032,1002041032,1004041032,1006041032,1008041032,1010041032]','[]','[]','[{0,1006011042,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071007,'副手','10阶红2星副手【魔剑士】',2,'[{lv,355}]',2,'[]','[1001011032,1007011032,1001021032,1007021032,1001031032,1007031032,1001041032,1007041032]','[]','[]','[{0,1007011042,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071008,'护腕','10阶红2星护腕【魔剑士】',2,'[{lv,355}]',2,'[]','[1002011032,1004011032,1006011032,1008011032,1010011032,1002021032,1004021032,1006021032,1008021032,1010021032,1002031032,1004031032,1006031032,1008031032,1010031032,1002041032,1004041032,1006041032,1008041032,1010041032]','[]','[]','[{0,1008011042,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071009,'戒指','10阶红2星戒指【通用】',2,'[{lv,355}]',2,'[]','[1005001032,1009001032,1005001032,1009001032,1005001032,1009001032,1005001032,1009001032]','[]','[]','[{0,1009001042,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071010,'鞋子','10阶红2星鞋子【魔剑士】',2,'[{lv,355}]',2,'[]','[1002011032,1004011032,1006011032,1008011032,1010011032,1002021032,1004021032,1006021032,1008021032,1010021032,1002031032,1004031032,1006031032,1008031032,1010031032,1002041032,1004041032,1006041032,1008041032,1010041032]','[]','[]','[{0,1010011042,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071101,'武器','11阶红2星武器【魔剑士】',2,'[{lv,400}]',2,'[]','[1001011132,1007011132,1001021132,1007021132,1001031132,1007031132,1001041132,1007041132]','[]','[]','[{0,1001011142,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071102,'头盔','11阶红2星头盔【魔剑士】',2,'[{lv,400}]',2,'[]','[1002011132,1004011132,1006011132,1008011132,1010011132,1002021132,1004021132,1006021132,1008021132,1010021132,1002031132,1004031132,1006031132,1008031132,1010031132,1002041132,1004041132,1006041132,1008041132,1010041132]','[]','[]','[{0,1002011142,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071103,'项链','11阶红2星项链【通用】',2,'[{lv,400}]',2,'[]','[1003001132,1003001132,1003001132,1003001132]','[]','[]','[{0,1003001142,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071104,'衣服','11阶红2星衣服【魔剑士】',2,'[{lv,400}]',2,'[]','[1002011132,1004011132,1006011132,1008011132,1010011132,1002021132,1004021132,1006021132,1008021132,1010021132,1002031132,1004031132,1006031132,1008031132,1010031132,1002041132,1004041132,1006041132,1008041132,1010041132]','[]','[]','[{0,1004011142,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071105,'刻痕','11阶红2星刻痕【通用】',2,'[{lv,400}]',2,'[]','[1005001132,1009001132,1005001132,1009001132,1005001132,1009001132,1005001132,1009001132]','[]','[]','[{0,1005001142,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071106,'裤子','11阶红2星裤子【魔剑士】',2,'[{lv,400}]',2,'[]','[1002011132,1004011132,1006011132,1008011132,1010011132,1002021132,1004021132,1006021132,1008021132,1010021132,1002031132,1004031132,1006031132,1008031132,1010031132,1002041132,1004041132,1006041132,1008041132,1010041132]','[]','[]','[{0,1006011142,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071107,'副手','11阶红2星副手【魔剑士】',2,'[{lv,400}]',2,'[]','[1001011132,1007011132,1001021132,1007021132,1001031132,1007031132,1001041132,1007041132]','[]','[]','[{0,1007011142,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071108,'护腕','11阶红2星护腕【魔剑士】',2,'[{lv,400}]',2,'[]','[1002011132,1004011132,1006011132,1008011132,1010011132,1002021132,1004021132,1006021132,1008021132,1010021132,1002031132,1004031132,1006031132,1008031132,1010031132,1002041132,1004041132,1006041132,1008041132,1010041132]','[]','[]','[{0,1008011142,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071109,'戒指','11阶红2星戒指【通用】',2,'[{lv,400}]',2,'[]','[1005001132,1009001132,1005001132,1009001132,1005001132,1009001132,1005001132,1009001132]','[]','[]','[{0,1009001142,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071110,'鞋子','11阶红2星鞋子【魔剑士】',2,'[{lv,400}]',2,'[]','[1002011132,1004011132,1006011132,1008011132,1010011132,1002021132,1004021132,1006021132,1008021132,1010021132,1002031132,1004031132,1006031132,1008031132,1010031132,1002041132,1004041132,1006041132,1008041132,1010041132]','[]','[]','[{0,1010011142,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071201,'武器','12阶红2星武器【魔剑士】',2,'[{lv,500}]',2,'[]','[1001011232,1007011232,1001021232,1007021232,1001031232,1007031232,1001041232,1007041232]','[]','[]','[{0,1001011242,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071202,'头盔','12阶红2星头盔【魔剑士】',2,'[{lv,500}]',2,'[]','[1002011232,1004011232,1006011232,1008011232,1010011232,1002021232,1004021232,1006021232,1008021232,1010021232,1002031232,1004031232,1006031232,1008031232,1010031232,1002041232,1004041232,1006041232,1008041232,1010041232]','[]','[]','[{0,1002011242,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071203,'项链','12阶红2星项链【通用】',2,'[{lv,500}]',2,'[]','[1003001232,1003001232,1003001232,1003001232]','[]','[]','[{0,1003001242,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071204,'衣服','12阶红2星衣服【魔剑士】',2,'[{lv,500}]',2,'[]','[1002011232,1004011232,1006011232,1008011232,1010011232,1002021232,1004021232,1006021232,1008021232,1010021232,1002031232,1004031232,1006031232,1008031232,1010031232,1002041232,1004041232,1006041232,1008041232,1010041232]','[]','[]','[{0,1004011242,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071205,'刻痕','12阶红2星刻痕【通用】',2,'[{lv,500}]',2,'[]','[1005001232,1009001232,1005001232,1009001232,1005001232,1009001232,1005001232,1009001232]','[]','[]','[{0,1005001242,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071206,'裤子','12阶红2星裤子【魔剑士】',2,'[{lv,500}]',2,'[]','[1002011232,1004011232,1006011232,1008011232,1010011232,1002021232,1004021232,1006021232,1008021232,1010021232,1002031232,1004031232,1006031232,1008031232,1010031232,1002041232,1004041232,1006041232,1008041232,1010041232]','[]','[]','[{0,1006011242,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071207,'副手','12阶红2星副手【魔剑士】',2,'[{lv,500}]',2,'[]','[1001011232,1007011232,1001021232,1007021232,1001031232,1007031232,1001041232,1007041232]','[]','[]','[{0,1007011242,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071208,'护腕','12阶红2星护腕【魔剑士】',2,'[{lv,500}]',2,'[]','[1002011232,1004011232,1006011232,1008011232,1010011232,1002021232,1004021232,1006021232,1008021232,1010021232,1002031232,1004031232,1006031232,1008031232,1010031232,1002041232,1004041232,1006041232,1008041232,1010041232]','[]','[]','[{0,1008011242,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071209,'戒指','12阶红2星戒指【通用】',2,'[{lv,500}]',2,'[]','[1005001232,1009001232,1005001232,1009001232,1005001232,1009001232,1005001232,1009001232]','[]','[]','[{0,1009001242,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071210,'鞋子','12阶红2星鞋子【魔剑士】',2,'[{lv,500}]',2,'[]','[1002011232,1004011232,1006011232,1008011232,1010011232,1002021232,1004021232,1006021232,1008021232,1010021232,1002031232,1004031232,1006031232,1008031232,1010031232,1002041232,1004041232,1006041232,1008041232,1010041232]','[]','[]','[{0,1010011242,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071301,'武器','13阶红2星武器【魔剑士】',2,'[{lv,520}]',2,'[]','[1001011332,1007011332,1001021332,1007021332,1001031332,1007031332,1001041332,1007041332]','[]','[]','[{0,1001011342,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071302,'头盔','13阶红2星头盔【魔剑士】',2,'[{lv,520}]',2,'[]','[1002011332,1004011332,1006011332,1008011332,1010011332,1002021332,1004021332,1006021332,1008021332,1010021332,1002031332,1004031332,1006031332,1008031332,1010031332,1002041332,1004041332,1006041332,1008041332,1010041332]','[]','[]','[{0,1002011342,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071303,'项链','13阶红2星项链【通用】',2,'[{lv,520}]',2,'[]','[1003001332,1003001332,1003001332,1003001332]','[]','[]','[{0,1003001342,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071304,'衣服','13阶红2星衣服【魔剑士】',2,'[{lv,520}]',2,'[]','[1002011332,1004011332,1006011332,1008011332,1010011332,1002021332,1004021332,1006021332,1008021332,1010021332,1002031332,1004031332,1006031332,1008031332,1010031332,1002041332,1004041332,1006041332,1008041332,1010041332]','[]','[]','[{0,1004011342,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071305,'刻痕','13阶红2星刻痕【通用】',2,'[{lv,520}]',2,'[]','[1005001332,1009001332,1005001332,1009001332,1005001332,1009001332,1005001332,1009001332]','[]','[]','[{0,1005001342,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071306,'裤子','13阶红2星裤子【魔剑士】',2,'[{lv,520}]',2,'[]','[1002011332,1004011332,1006011332,1008011332,1010011332,1002021332,1004021332,1006021332,1008021332,1010021332,1002031332,1004031332,1006031332,1008031332,1010031332,1002041332,1004041332,1006041332,1008041332,1010041332]','[]','[]','[{0,1006011342,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071307,'副手','13阶红2星副手【魔剑士】',2,'[{lv,520}]',2,'[]','[1001011332,1007011332,1001021332,1007021332,1001031332,1007031332,1001041332,1007041332]','[]','[]','[{0,1007011342,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071308,'护腕','13阶红2星护腕【魔剑士】',2,'[{lv,520}]',2,'[]','[1002011332,1004011332,1006011332,1008011332,1010011332,1002021332,1004021332,1006021332,1008021332,1010021332,1002031332,1004031332,1006031332,1008031332,1010031332,1002041332,1004041332,1006041332,1008041332,1010041332]','[]','[]','[{0,1008011342,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071309,'戒指','13阶红2星戒指【通用】',2,'[{lv,520}]',2,'[]','[1005001332,1009001332,1005001332,1009001332,1005001332,1009001332,1005001332,1009001332]','[]','[]','[{0,1009001342,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071310,'鞋子','13阶红2星鞋子【魔剑士】',2,'[{lv,520}]',2,'[]','[1002011332,1004011332,1006011332,1008011332,1010011332,1002021332,1004021332,1006021332,1008021332,1010021332,1002031332,1004031332,1006031332,1008031332,1010031332,1002041332,1004041332,1006041332,1008041332,1010041332]','[]','[]','[{0,1010011342,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071401,'武器','14阶红2星武器【魔剑士】',2,'[{lv,620}]',2,'[]','[1001011432,1007011432,1001021432,1007021432,1001031432,1007031432,1001041432,1007041432]','[]','[]','[{0,1001011442,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071402,'头盔','14阶红2星头盔【魔剑士】',2,'[{lv,620}]',2,'[]','[1002011432,1004011432,1006011432,1008011432,1010011432,1002021432,1004021432,1006021432,1008021432,1010021432,1002031432,1004031432,1006031432,1008031432,1010031432,1002041432,1004041432,1006041432,1008041432,1010041432]','[]','[]','[{0,1002011442,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071403,'项链','14阶红2星项链【通用】',2,'[{lv,620}]',2,'[]','[1003001432,1003001432,1003001432,1003001432]','[]','[]','[{0,1003001442,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071404,'衣服','14阶红2星衣服【魔剑士】',2,'[{lv,620}]',2,'[]','[1002011432,1004011432,1006011432,1008011432,1010011432,1002021432,1004021432,1006021432,1008021432,1010021432,1002031432,1004031432,1006031432,1008031432,1010031432,1002041432,1004041432,1006041432,1008041432,1010041432]','[]','[]','[{0,1004011442,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071405,'刻痕','14阶红2星刻痕【通用】',2,'[{lv,620}]',2,'[]','[1005001432,1009001432,1005001432,1009001432,1005001432,1009001432,1005001432,1009001432]','[]','[]','[{0,1005001442,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071406,'裤子','14阶红2星裤子【魔剑士】',2,'[{lv,620}]',2,'[]','[1002011432,1004011432,1006011432,1008011432,1010011432,1002021432,1004021432,1006021432,1008021432,1010021432,1002031432,1004031432,1006031432,1008031432,1010031432,1002041432,1004041432,1006041432,1008041432,1010041432]','[]','[]','[{0,1006011442,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071407,'副手','14阶红2星副手【魔剑士】',2,'[{lv,620}]',2,'[]','[1001011432,1007011432,1001021432,1007021432,1001031432,1007031432,1001041432,1007041432]','[]','[]','[{0,1007011442,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071408,'护腕','14阶红2星护腕【魔剑士】',2,'[{lv,620}]',2,'[]','[1002011432,1004011432,1006011432,1008011432,1010011432,1002021432,1004021432,1006021432,1008021432,1010021432,1002031432,1004031432,1006031432,1008031432,1010031432,1002041432,1004041432,1006041432,1008041432,1010041432]','[]','[]','[{0,1008011442,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071409,'戒指','14阶红2星戒指【通用】',2,'[{lv,620}]',2,'[]','[1005001432,1009001432,1005001432,1009001432,1005001432,1009001432,1005001432,1009001432]','[]','[]','[{0,1009001442,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071410,'鞋子','14阶红2星鞋子【魔剑士】',2,'[{lv,620}]',2,'[]','[1002011432,1004011432,1006011432,1008011432,1010011432,1002021432,1004021432,1006021432,1008021432,1010021432,1002031432,1004031432,1006031432,1008031432,1010031432,1002041432,1004041432,1006041432,1008041432,1010041432]','[]','[]','[{0,1010011442,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071501,'武器','15阶红2星武器【魔剑士】',2,'[{lv,650}]',2,'[]','[1001011532,1007011532,1001021532,1007021532,1001031532,1007031532,1001041532,1007041532]','[]','[]','[{0,1001011542,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071502,'头盔','15阶红2星头盔【魔剑士】',2,'[{lv,650}]',2,'[]','[1002011532,1004011532,1006011532,1008011532,1010011532,1002021532,1004021532,1006021532,1008021532,1010021532,1002031532,1004031532,1006031532,1008031532,1010031532,1002041532,1004041532,1006041532,1008041532,1010041532]','[]','[]','[{0,1002011542,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071503,'项链','15阶红2星项链【通用】',2,'[{lv,650}]',2,'[]','[1003001532,1003001532,1003001532,1003001532]','[]','[]','[{0,1003001542,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071504,'衣服','15阶红2星衣服【魔剑士】',2,'[{lv,650}]',2,'[]','[1002011532,1004011532,1006011532,1008011532,1010011532,1002021532,1004021532,1006021532,1008021532,1010021532,1002031532,1004031532,1006031532,1008031532,1010031532,1002041532,1004041532,1006041532,1008041532,1010041532]','[]','[]','[{0,1004011542,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071505,'刻痕','15阶红2星刻痕【通用】',2,'[{lv,650}]',2,'[]','[1005001532,1009001532,1005001532,1009001532,1005001532,1009001532,1005001532,1009001532]','[]','[]','[{0,1005001542,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071506,'裤子','15阶红2星裤子【魔剑士】',2,'[{lv,650}]',2,'[]','[1002011532,1004011532,1006011532,1008011532,1010011532,1002021532,1004021532,1006021532,1008021532,1010021532,1002031532,1004031532,1006031532,1008031532,1010031532,1002041532,1004041532,1006041532,1008041532,1010041532]','[]','[]','[{0,1006011542,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071507,'副手','15阶红2星副手【魔剑士】',2,'[{lv,650}]',2,'[]','[1001011532,1007011532,1001021532,1007021532,1001031532,1007031532,1001041532,1007041532]','[]','[]','[{0,1007011542,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071508,'护腕','15阶红2星护腕【魔剑士】',2,'[{lv,650}]',2,'[]','[1002011532,1004011532,1006011532,1008011532,1010011532,1002021532,1004021532,1006021532,1008021532,1010021532,1002031532,1004031532,1006031532,1008031532,1010031532,1002041532,1004041532,1006041532,1008041532,1010041532]','[]','[]','[{0,1008011542,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071509,'戒指','15阶红2星戒指【通用】',2,'[{lv,650}]',2,'[]','[1005001532,1009001532,1005001532,1009001532,1005001532,1009001532,1005001532,1009001532]','[]','[]','[{0,1009001542,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071510,'鞋子','15阶红2星鞋子【魔剑士】',2,'[{lv,650}]',2,'[]','[1002011532,1004011532,1006011532,1008011532,1010011532,1002021532,1004021532,1006021532,1008021532,1010021532,1002031532,1004031532,1006031532,1008031532,1010031532,1002041532,1004041532,1006041532,1008041532,1010041532]','[]','[]','[{0,1010011542,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071601,'武器','16阶红2星武器【魔剑士】',2,'[{lv,700}]',2,'[]','[1001011632,1007011632,1001021632,1007021632,1001031632,1007031632,1001041632,1007041632]','[]','[]','[{0,1001011642,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071602,'头盔','16阶红2星头盔【魔剑士】',2,'[{lv,700}]',2,'[]','[1002011632,1004011632,1006011632,1008011632,1010011632,1002021632,1004021632,1006021632,1008021632,1010021632,1002031632,1004031632,1006031632,1008031632,1010031632,1002041632,1004041632,1006041632,1008041632,1010041632]','[]','[]','[{0,1002011642,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071603,'项链','16阶红2星项链【通用】',2,'[{lv,700}]',2,'[]','[1003001632,1003001632,1003001632,1003001632]','[]','[]','[{0,1003001642,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071604,'衣服','16阶红2星衣服【魔剑士】',2,'[{lv,700}]',2,'[]','[1002011632,1004011632,1006011632,1008011632,1010011632,1002021632,1004021632,1006021632,1008021632,1010021632,1002031632,1004031632,1006031632,1008031632,1010031632,1002041632,1004041632,1006041632,1008041632,1010041632]','[]','[]','[{0,1004011642,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071605,'刻痕','16阶红2星刻痕【通用】',2,'[{lv,700}]',2,'[]','[1005001632,1009001632,1005001632,1009001632,1005001632,1009001632,1005001632,1009001632]','[]','[]','[{0,1005001642,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071606,'裤子','16阶红2星裤子【魔剑士】',2,'[{lv,700}]',2,'[]','[1002011632,1004011632,1006011632,1008011632,1010011632,1002021632,1004021632,1006021632,1008021632,1010021632,1002031632,1004031632,1006031632,1008031632,1010031632,1002041632,1004041632,1006041632,1008041632,1010041632]','[]','[]','[{0,1006011642,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071607,'副手','16阶红2星副手【魔剑士】',2,'[{lv,700}]',2,'[]','[1001011632,1007011632,1001021632,1007021632,1001031632,1007031632,1001041632,1007041632]','[]','[]','[{0,1007011642,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071608,'护腕','16阶红2星护腕【魔剑士】',2,'[{lv,700}]',2,'[]','[1002011632,1004011632,1006011632,1008011632,1010011632,1002021632,1004021632,1006021632,1008021632,1010021632,1002031632,1004031632,1006031632,1008031632,1010031632,1002041632,1004041632,1006041632,1008041632,1010041632]','[]','[]','[{0,1008011642,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071609,'戒指','16阶红2星戒指【通用】',2,'[{lv,700}]',2,'[]','[1005001632,1009001632,1005001632,1009001632,1005001632,1009001632,1005001632,1009001632]','[]','[]','[{0,1009001642,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31071610,'鞋子','16阶红2星鞋子【魔剑士】',2,'[{lv,700}]',2,'[]','[1002011632,1004011632,1006011632,1008011632,1010011632,1002021632,1004021632,1006021632,1008021632,1010021632,1002031632,1004031632,1006031632,1008031632,1010031632,1002041632,1004041632,1006041632,1008041632,1010041632]','[]','[]','[{0,1010011642,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31080301,'武器','3阶红3星武器【魔剑士】',2,'[{lv,9999}]',2,'[]','[1001010342,1007010342,1001020342,1007020342,1001030342,1007030342,1001040342,1007040342]','[]','[]','[{0,1001010343,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(31080302,'头盔','3阶红3星头盔【魔剑士】',2,'[{lv,9999}]',2,'[]','[1002010342,1004010342,1006010342,1008010342,1010010342,1002020342,1004020342,1006020342,1008020342,1010020342,1002030342,1004030342,1006030342,1008030342,1010030342,1002040342,1004040342,1006040342,1008040342,1010040342]','[]','[]','[{0,1002010343,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(31080303,'项链','3阶红3星项链【通用】',2,'[{lv,9999}]',2,'[]','[1003000342,1003000342,1003000342,1003000342]','[]','[]','[{0,1003000343,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(31080304,'衣服','3阶红3星衣服【魔剑士】',2,'[{lv,9999}]',2,'[]','[1002010342,1004010342,1006010342,1008010342,1010010342,1002020342,1004020342,1006020342,1008020342,1010020342,1002030342,1004030342,1006030342,1008030342,1010030342,1002040342,1004040342,1006040342,1008040342,1010040342]','[]','[]','[{0,1004010343,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(31080305,'刻痕','3阶红3星刻痕【通用】',2,'[{lv,9999}]',2,'[]','[1005000342,1009000342,1005000342,1009000342,1005000342,1009000342,1005000342,1009000342]','[]','[]','[{0,1005000343,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(31080306,'裤子','3阶红3星裤子【魔剑士】',2,'[{lv,9999}]',2,'[]','[1002010342,1004010342,1006010342,1008010342,1010010342,1002020342,1004020342,1006020342,1008020342,1010020342,1002030342,1004030342,1006030342,1008030342,1010030342,1002040342,1004040342,1006040342,1008040342,1010040342]','[]','[]','[{0,1006010343,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(31080307,'副手','3阶红3星副手【魔剑士】',2,'[{lv,9999}]',2,'[]','[1001010342,1007010342,1001020342,1007020342,1001030342,1007030342,1001040342,1007040342]','[]','[]','[{0,1007010343,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(31080308,'护腕','3阶红3星护腕【魔剑士】',2,'[{lv,9999}]',2,'[]','[1002010342,1004010342,1006010342,1008010342,1010010342,1002020342,1004020342,1006020342,1008020342,1010020342,1002030342,1004030342,1006030342,1008030342,1010030342,1002040342,1004040342,1006040342,1008040342,1010040342]','[]','[]','[{0,1008010343,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(31080309,'戒指','3阶红3星戒指【通用】',2,'[{lv,9999}]',2,'[]','[1005000342,1009000342,1005000342,1009000342,1005000342,1009000342,1005000342,1009000342]','[]','[]','[{0,1009000343,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(31080310,'鞋子','3阶红3星鞋子【魔剑士】',2,'[{lv,9999}]',2,'[]','[1002010342,1004010342,1006010342,1008010342,1010010342,1002020342,1004020342,1006020342,1008020342,1010020342,1002030342,1004030342,1006030342,1008030342,1010030342,1002040342,1004040342,1006040342,1008040342,1010040342]','[]','[]','[{0,1010010343,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(31080401,'武器','4阶红3星武器【魔剑士】',2,'[{lv,160}]',2,'[]','[1001010442,1007010442,1001020442,1007020442,1001030442,1007030442,1001040442,1007040442,1101010442,1107010442,1101020442,1107020442,1101030442,1107030442,1101040442,1107040442]','[]','[]','[{0,1001010443,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(31080402,'头盔','4阶红3星头盔【魔剑士】',2,'[{lv,160}]',2,'[]','[1002010442,1004010442,1006010442,1008010442,1010010442,1002020442,1004020442,1006020442,1008020442,1010020442,1002030442,1004030442,1006030442,1008030442,1010030442,1002040442,1004040442,1006040442,1008040442,1010040442,1102010442,1104010442,1106010442,1108010442,1110010442,1102020442,1104020442,1106020442,1108020442,1110020442,1102030442,1104030442,1106030442,1108030442,1110030442,1102040442,1104040442,1106040442,1108040442,1110040442]','[]','[]','[{0,1002010443,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(31080403,'项链','4阶红3星项链【通用】',2,'[{lv,160}]',2,'[]','[1003000442,1003000442,1003000442,1003000442,1103000442,1103000442,1103000442,1103000442]','[]','[]','[{0,1003000443,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(31080404,'衣服','4阶红3星衣服【魔剑士】',2,'[{lv,160}]',2,'[]','[1002010442,1004010442,1006010442,1008010442,1010010442,1002020442,1004020442,1006020442,1008020442,1010020442,1002030442,1004030442,1006030442,1008030442,1010030442,1002040442,1004040442,1006040442,1008040442,1010040442,1102010442,1104010442,1106010442,1108010442,1110010442,1102020442,1104020442,1106020442,1108020442,1110020442,1102030442,1104030442,1106030442,1108030442,1110030442,1102040442,1104040442,1106040442,1108040442,1110040442]','[]','[]','[{0,1004010443,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(31080405,'刻痕','4阶红3星刻痕【通用】',2,'[{lv,160}]',2,'[]','[1005000442,1009000442,1005000442,1009000442,1005000442,1009000442,1005000442,1009000442,1105000442,1109000442,1105000442,1109000442,1105000442,1109000442,1105000442,1109000442]','[]','[]','[{0,1005000443,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(31080406,'裤子','4阶红3星裤子【魔剑士】',2,'[{lv,160}]',2,'[]','[1002010442,1004010442,1006010442,1008010442,1010010442,1002020442,1004020442,1006020442,1008020442,1010020442,1002030442,1004030442,1006030442,1008030442,1010030442,1002040442,1004040442,1006040442,1008040442,1010040442,1102010442,1104010442,1106010442,1108010442,1110010442,1102020442,1104020442,1106020442,1108020442,1110020442,1102030442,1104030442,1106030442,1108030442,1110030442,1102040442,1104040442,1106040442,1108040442,1110040442]','[]','[]','[{0,1006010443,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(31080407,'副手','4阶红3星副手【魔剑士】',2,'[{lv,160}]',2,'[]','[1001010442,1007010442,1001020442,1007020442,1001030442,1007030442,1001040442,1007040442,1101010442,1107010442,1101020442,1107020442,1101030442,1107030442,1101040442,1107040442]','[]','[]','[{0,1007010443,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(31080408,'护腕','4阶红3星护腕【魔剑士】',2,'[{lv,160}]',2,'[]','[1002010442,1004010442,1006010442,1008010442,1010010442,1002020442,1004020442,1006020442,1008020442,1010020442,1002030442,1004030442,1006030442,1008030442,1010030442,1002040442,1004040442,1006040442,1008040442,1010040442,1102010442,1104010442,1106010442,1108010442,1110010442,1102020442,1104020442,1106020442,1108020442,1110020442,1102030442,1104030442,1106030442,1108030442,1110030442,1102040442,1104040442,1106040442,1108040442,1110040442]','[]','[]','[{0,1008010443,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(31080409,'戒指','4阶红3星戒指【通用】',2,'[{lv,160}]',2,'[]','[1005000442,1009000442,1005000442,1009000442,1005000442,1009000442,1005000442,1009000442,1105000442,1109000442,1105000442,1109000442,1105000442,1109000442,1105000442,1109000442]','[]','[]','[{0,1009000443,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(31080410,'鞋子','4阶红3星鞋子【魔剑士】',2,'[{lv,160}]',2,'[]','[1002010442,1004010442,1006010442,1008010442,1010010442,1002020442,1004020442,1006020442,1008020442,1010020442,1002030442,1004030442,1006030442,1008030442,1010030442,1002040442,1004040442,1006040442,1008040442,1010040442,1102010442,1104010442,1106010442,1108010442,1110010442,1102020442,1104020442,1106020442,1108020442,1110020442,1102030442,1104030442,1106030442,1108030442,1110030442,1102040442,1104040442,1106040442,1108040442,1110040442]','[]','[]','[{0,1010010443,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(31080501,'武器','5阶红3星武器【魔剑士】',2,'[{lv,160}]',2,'[]','[1001010542,1007010542,1001020542,1007020542,1001030542,1007030542,1001040542,1007040542,1101010542,1101020542,1101030542,1101040542]','[]','[]','[{0,1001010543,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(31080502,'头盔','5阶红3星头盔【魔剑士】',2,'[{lv,160}]',2,'[]','[1002010542,1004010542,1006010542,1008010542,1010010542,1002020542,1004020542,1006020542,1008020542,1010020542,1002030542,1004030542,1006030542,1008030542,1010030542,1002040542,1004040542,1006040542,1008040542,1010040542,1102010542,1104010542,1106010542,1102020542,1104020542,1106020542,1102030542,1104030542,1106030542,1102040542,1104040542,1106040542]','[]','[]','[{0,1002010543,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(31080503,'项链','5阶红3星项链【通用】',2,'[{lv,160}]',2,'[]','[1003000542,1003000542,1003000542,1003000542,1103000542,1103000542,1103000542,1103000542]','[]','[]','[{0,1003000543,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(31080504,'衣服','5阶红3星衣服【魔剑士】',2,'[{lv,160}]',2,'[]','[1002010542,1004010542,1006010542,1008010542,1010010542,1002020542,1004020542,1006020542,1008020542,1010020542,1002030542,1004030542,1006030542,1008030542,1010030542,1002040542,1004040542,1006040542,1008040542,1010040542,1102010542,1104010542,1106010542,1102020542,1104020542,1106020542,1102030542,1104030542,1106030542,1102040542,1104040542,1106040542]','[]','[]','[{0,1004010543,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(31080505,'刻痕','5阶红3星刻痕【通用】',2,'[{lv,160}]',2,'[]','[1005000542,1009000542,1005000542,1009000542,1005000542,1009000542,1005000542,1009000542,1105000542,1105000542,1105000542,1105000542]','[]','[]','[{0,1005000543,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(31080506,'裤子','5阶红3星裤子【魔剑士】',2,'[{lv,160}]',2,'[]','[1002010542,1004010542,1006010542,1008010542,1010010542,1002020542,1004020542,1006020542,1008020542,1010020542,1002030542,1004030542,1006030542,1008030542,1010030542,1002040542,1004040542,1006040542,1008040542,1010040542,1102010542,1104010542,1106010542,1102020542,1104020542,1106020542,1102030542,1104030542,1106030542,1102040542,1104040542,1106040542]','[]','[]','[{0,1006010543,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(31080507,'副手','5阶红3星副手【魔剑士】',2,'[{lv,160}]',2,'[]','[1001010542,1007010542,1001020542,1007020542,1001030542,1007030542,1001040542,1007040542,1101010542,1101020542,1101030542,1101040542]','[]','[]','[{0,1007010543,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(31080508,'护腕','5阶红3星护腕【魔剑士】',2,'[{lv,160}]',2,'[]','[1002010542,1004010542,1006010542,1008010542,1010010542,1002020542,1004020542,1006020542,1008020542,1010020542,1002030542,1004030542,1006030542,1008030542,1010030542,1002040542,1004040542,1006040542,1008040542,1010040542,1102010542,1104010542,1106010542,1102020542,1104020542,1106020542,1102030542,1104030542,1106030542,1102040542,1104040542,1106040542]','[]','[]','[{0,1008010543,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(31080509,'戒指','5阶红3星戒指【通用】',2,'[{lv,160}]',2,'[]','[1005000542,1009000542,1005000542,1009000542,1005000542,1009000542,1005000542,1009000542,1105000542,1105000542,1105000542,1105000542]','[]','[]','[{0,1009000543,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(31080510,'鞋子','5阶红3星鞋子【魔剑士】',2,'[{lv,160}]',2,'[]','[1002010542,1004010542,1006010542,1008010542,1010010542,1002020542,1004020542,1006020542,1008020542,1010020542,1002030542,1004030542,1006030542,1008030542,1010030542,1002040542,1004040542,1006040542,1008040542,1010040542,1102010542,1104010542,1106010542,1102020542,1104020542,1106020542,1102030542,1104030542,1106030542,1102040542,1104040542,1106040542]','[]','[]','[{0,1010010543,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(31080601,'武器','6阶红3星武器【魔剑士】',2,'[{lv,180}]',2,'[]','[1001010642,1007010642,1001020642,1007020642,1001030642,1007030642,1001040642,1007040642]','[]','[]','[{0,1001010643,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(31080602,'头盔','6阶红3星头盔【魔剑士】',2,'[{lv,180}]',2,'[]','[1002010642,1004010642,1006010642,1008010642,1010010642,1002020642,1004020642,1006020642,1008020642,1010020642,1002030642,1004030642,1006030642,1008030642,1010030642,1002040642,1004040642,1006040642,1008040642,1010040642]','[]','[]','[{0,1002010643,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(31080603,'项链','6阶红3星项链【通用】',2,'[{lv,180}]',2,'[]','[1003000642,1003000642,1003000642,1003000642]','[]','[]','[{0,1003000643,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(31080604,'衣服','6阶红3星衣服【魔剑士】',2,'[{lv,180}]',2,'[]','[1002010642,1004010642,1006010642,1008010642,1010010642,1002020642,1004020642,1006020642,1008020642,1010020642,1002030642,1004030642,1006030642,1008030642,1010030642,1002040642,1004040642,1006040642,1008040642,1010040642]','[]','[]','[{0,1004010643,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(31080605,'刻痕','6阶红3星刻痕【通用】',2,'[{lv,180}]',2,'[]','[1005000642,1009000642,1005000642,1009000642,1005000642,1009000642,1005000642,1009000642]','[]','[]','[{0,1005000643,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(31080606,'裤子','6阶红3星裤子【魔剑士】',2,'[{lv,180}]',2,'[]','[1002010642,1004010642,1006010642,1008010642,1010010642,1002020642,1004020642,1006020642,1008020642,1010020642,1002030642,1004030642,1006030642,1008030642,1010030642,1002040642,1004040642,1006040642,1008040642,1010040642]','[]','[]','[{0,1006010643,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(31080607,'副手','6阶红3星副手【魔剑士】',2,'[{lv,180}]',2,'[]','[1001010642,1007010642,1001020642,1007020642,1001030642,1007030642,1001040642,1007040642]','[]','[]','[{0,1007010643,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(31080608,'护腕','6阶红3星护腕【魔剑士】',2,'[{lv,180}]',2,'[]','[1002010642,1004010642,1006010642,1008010642,1010010642,1002020642,1004020642,1006020642,1008020642,1010020642,1002030642,1004030642,1006030642,1008030642,1010030642,1002040642,1004040642,1006040642,1008040642,1010040642]','[]','[]','[{0,1008010643,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(31080609,'戒指','6阶红3星戒指【通用】',2,'[{lv,180}]',2,'[]','[1005000642,1009000642,1005000642,1009000642,1005000642,1009000642,1005000642,1009000642]','[]','[]','[{0,1009000643,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(31080610,'鞋子','6阶红3星鞋子【魔剑士】',2,'[{lv,180}]',2,'[]','[1002010642,1004010642,1006010642,1008010642,1010010642,1002020642,1004020642,1006020642,1008020642,1010020642,1002030642,1004030642,1006030642,1008030642,1010030642,1002040642,1004040642,1006040642,1008040642,1010040642]','[]','[]','[{0,1010010643,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(31080701,'武器','7阶红3星武器【魔剑士】',2,'[{lv,220}]',2,'[]','[1001010742,1007010742,1001020742,1007020742,1001030742,1007030742,1001040742,1007040742,1101010742,1107010742,1101020742,1107020742,1101030742,1107030742,1101040742,1107040742]','[]','[]','[{0,1001010743,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31080702,'头盔','7阶红3星头盔【魔剑士】',2,'[{lv,220}]',2,'[]','[1002010742,1004010742,1006010742,1008010742,1010010742,1002020742,1004020742,1006020742,1008020742,1010020742,1002030742,1004030742,1006030742,1008030742,1010030742,1002040742,1004040742,1006040742,1008040742,1010040742,1102010742,1104010742,1106010742,1108010742,1110010742,1102020742,1104020742,1106020742,1108020742,1110020742,1102030742,1104030742,1106030742,1108030742,1110030742,1102040742,1104040742,1106040742,1108040742,1110040742]','[]','[]','[{0,1002010743,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31080703,'项链','7阶红3星项链【通用】',2,'[{lv,220}]',2,'[]','[1003000742,1003000742,1003000742,1003000742,1103000742,1103000742,1103000742,1103000742]','[]','[]','[{0,1003000743,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31080704,'衣服','7阶红3星衣服【魔剑士】',2,'[{lv,220}]',2,'[]','[1002010742,1004010742,1006010742,1008010742,1010010742,1002020742,1004020742,1006020742,1008020742,1010020742,1002030742,1004030742,1006030742,1008030742,1010030742,1002040742,1004040742,1006040742,1008040742,1010040742,1102010742,1104010742,1106010742,1108010742,1110010742,1102020742,1104020742,1106020742,1108020742,1110020742,1102030742,1104030742,1106030742,1108030742,1110030742,1102040742,1104040742,1106040742,1108040742,1110040742]','[]','[]','[{0,1004010743,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31080705,'刻痕','7阶红3星刻痕【通用】',2,'[{lv,220}]',2,'[]','[1005000742,1009000742,1005000742,1009000742,1005000742,1009000742,1005000742,1009000742,1105000742,1109000742,1105000742,1109000742,1105000742,1109000742,1105000742,1109000742]','[]','[]','[{0,1005000743,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31080706,'裤子','7阶红3星裤子【魔剑士】',2,'[{lv,220}]',2,'[]','[1002010742,1004010742,1006010742,1008010742,1010010742,1002020742,1004020742,1006020742,1008020742,1010020742,1002030742,1004030742,1006030742,1008030742,1010030742,1002040742,1004040742,1006040742,1008040742,1010040742,1102010742,1104010742,1106010742,1108010742,1110010742,1102020742,1104020742,1106020742,1108020742,1110020742,1102030742,1104030742,1106030742,1108030742,1110030742,1102040742,1104040742,1106040742,1108040742,1110040742]','[]','[]','[{0,1006010743,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31080707,'副手','7阶红3星副手【魔剑士】',2,'[{lv,220}]',2,'[]','[1001010742,1007010742,1001020742,1007020742,1001030742,1007030742,1001040742,1007040742,1101010742,1107010742,1101020742,1107020742,1101030742,1107030742,1101040742,1107040742]','[]','[]','[{0,1007010743,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31080708,'护腕','7阶红3星护腕【魔剑士】',2,'[{lv,220}]',2,'[]','[1002010742,1004010742,1006010742,1008010742,1010010742,1002020742,1004020742,1006020742,1008020742,1010020742,1002030742,1004030742,1006030742,1008030742,1010030742,1002040742,1004040742,1006040742,1008040742,1010040742,1102010742,1104010742,1106010742,1108010742,1110010742,1102020742,1104020742,1106020742,1108020742,1110020742,1102030742,1104030742,1106030742,1108030742,1110030742,1102040742,1104040742,1106040742,1108040742,1110040742]','[]','[]','[{0,1008010743,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31080709,'戒指','7阶红3星戒指【通用】',2,'[{lv,220}]',2,'[]','[1005000742,1009000742,1005000742,1009000742,1005000742,1009000742,1005000742,1009000742,1105000742,1109000742,1105000742,1109000742,1105000742,1109000742,1105000742,1109000742]','[]','[]','[{0,1009000743,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31080710,'鞋子','7阶红3星鞋子【魔剑士】',2,'[{lv,220}]',2,'[]','[1002010742,1004010742,1006010742,1008010742,1010010742,1002020742,1004020742,1006020742,1008020742,1010020742,1002030742,1004030742,1006030742,1008030742,1010030742,1002040742,1004040742,1006040742,1008040742,1010040742,1102010742,1104010742,1106010742,1108010742,1110010742,1102020742,1104020742,1106020742,1108020742,1110020742,1102030742,1104030742,1106030742,1108030742,1110030742,1102040742,1104040742,1106040742,1108040742,1110040742]','[]','[]','[{0,1010010743,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31080801,'武器','8阶红3星武器【魔剑士】',2,'[{lv,260}]',2,'[]','[1001010842,1007010842,1001020842,1007020842,1001030842,1007030842,1001040842,1007040842,1101010842,1107010842,1101020842,1107020842,1101030842,1107030842,1101040842,1107040842]','[]','[]','[{0,1001010843,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31080802,'头盔','8阶红3星头盔【魔剑士】',2,'[{lv,260}]',2,'[]','[1002010842,1004010842,1006010842,1008010842,1010010842,1002020842,1004020842,1006020842,1008020842,1010020842,1002030842,1004030842,1006030842,1008030842,1010030842,1002040842,1004040842,1006040842,1008040842,1010040842,1102010842,1104010842,1106010842,1108010842,1110010842,1102020842,1104020842,1106020842,1108020842,1110020842,1102030842,1104030842,1106030842,1108030842,1110030842,1102040842,1104040842,1106040842,1108040842,1110040842]','[]','[]','[{0,1002010843,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31080803,'项链','8阶红3星项链【通用】',2,'[{lv,260}]',2,'[]','[1003000842,1003000842,1003000842,1003000842,1103000842,1103000842,1103000842,1103000842]','[]','[]','[{0,1003000843,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31080804,'衣服','8阶红3星衣服【魔剑士】',2,'[{lv,260}]',2,'[]','[1002010842,1004010842,1006010842,1008010842,1010010842,1002020842,1004020842,1006020842,1008020842,1010020842,1002030842,1004030842,1006030842,1008030842,1010030842,1002040842,1004040842,1006040842,1008040842,1010040842,1102010842,1104010842,1106010842,1108010842,1110010842,1102020842,1104020842,1106020842,1108020842,1110020842,1102030842,1104030842,1106030842,1108030842,1110030842,1102040842,1104040842,1106040842,1108040842,1110040842]','[]','[]','[{0,1004010843,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31080805,'刻痕','8阶红3星刻痕【通用】',2,'[{lv,260}]',2,'[]','[1005000842,1009000842,1005000842,1009000842,1005000842,1009000842,1005000842,1009000842,1105000842,1109000842,1105000842,1109000842,1105000842,1109000842,1105000842,1109000842]','[]','[]','[{0,1005000843,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31080806,'裤子','8阶红3星裤子【魔剑士】',2,'[{lv,260}]',2,'[]','[1002010842,1004010842,1006010842,1008010842,1010010842,1002020842,1004020842,1006020842,1008020842,1010020842,1002030842,1004030842,1006030842,1008030842,1010030842,1002040842,1004040842,1006040842,1008040842,1010040842,1102010842,1104010842,1106010842,1108010842,1110010842,1102020842,1104020842,1106020842,1108020842,1110020842,1102030842,1104030842,1106030842,1108030842,1110030842,1102040842,1104040842,1106040842,1108040842,1110040842]','[]','[]','[{0,1006010843,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31080807,'副手','8阶红3星副手【魔剑士】',2,'[{lv,260}]',2,'[]','[1001010842,1007010842,1001020842,1007020842,1001030842,1007030842,1001040842,1007040842,1101010842,1107010842,1101020842,1107020842,1101030842,1107030842,1101040842,1107040842]','[]','[]','[{0,1007010843,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31080808,'护腕','8阶红3星护腕【魔剑士】',2,'[{lv,260}]',2,'[]','[1002010842,1004010842,1006010842,1008010842,1010010842,1002020842,1004020842,1006020842,1008020842,1010020842,1002030842,1004030842,1006030842,1008030842,1010030842,1002040842,1004040842,1006040842,1008040842,1010040842,1102010842,1104010842,1106010842,1108010842,1110010842,1102020842,1104020842,1106020842,1108020842,1110020842,1102030842,1104030842,1106030842,1108030842,1110030842,1102040842,1104040842,1106040842,1108040842,1110040842]','[]','[]','[{0,1008010843,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31080809,'戒指','8阶红3星戒指【通用】',2,'[{lv,260}]',2,'[]','[1005000842,1009000842,1005000842,1009000842,1005000842,1009000842,1005000842,1009000842,1105000842,1109000842,1105000842,1109000842,1105000842,1109000842,1105000842,1109000842]','[]','[]','[{0,1009000843,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31080810,'鞋子','8阶红3星鞋子【魔剑士】',2,'[{lv,260}]',2,'[]','[1002010842,1004010842,1006010842,1008010842,1010010842,1002020842,1004020842,1006020842,1008020842,1010020842,1002030842,1004030842,1006030842,1008030842,1010030842,1002040842,1004040842,1006040842,1008040842,1010040842,1102010842,1104010842,1106010842,1108010842,1110010842,1102020842,1104020842,1106020842,1108020842,1110020842,1102030842,1104030842,1106030842,1108030842,1110030842,1102040842,1104040842,1106040842,1108040842,1110040842]','[]','[]','[{0,1010010843,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31080901,'武器','9阶红3星武器【魔剑士】',2,'[{lv,300}]',2,'[]','[1001010942,1007010942,1001020942,1007020942,1001030942,1007030942,1001040942,1007040942]','[]','[]','[{0,1001010943,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31080902,'头盔','9阶红3星头盔【魔剑士】',2,'[{lv,300}]',2,'[]','[1002010942,1004010942,1006010942,1008010942,1010010942,1002020942,1004020942,1006020942,1008020942,1010020942,1002030942,1004030942,1006030942,1008030942,1010030942,1002040942,1004040942,1006040942,1008040942,1010040942]','[]','[]','[{0,1002010943,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31080903,'项链','9阶红3星项链【通用】',2,'[{lv,300}]',2,'[]','[1003000942,1003000942,1003000942,1003000942]','[]','[]','[{0,1003000943,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31080904,'衣服','9阶红3星衣服【魔剑士】',2,'[{lv,300}]',2,'[]','[1002010942,1004010942,1006010942,1008010942,1010010942,1002020942,1004020942,1006020942,1008020942,1010020942,1002030942,1004030942,1006030942,1008030942,1010030942,1002040942,1004040942,1006040942,1008040942,1010040942]','[]','[]','[{0,1004010943,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31080905,'刻痕','9阶红3星刻痕【通用】',2,'[{lv,300}]',2,'[]','[1005000942,1009000942,1005000942,1009000942,1005000942,1009000942,1005000942,1009000942]','[]','[]','[{0,1005000943,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31080906,'裤子','9阶红3星裤子【魔剑士】',2,'[{lv,300}]',2,'[]','[1002010942,1004010942,1006010942,1008010942,1010010942,1002020942,1004020942,1006020942,1008020942,1010020942,1002030942,1004030942,1006030942,1008030942,1010030942,1002040942,1004040942,1006040942,1008040942,1010040942]','[]','[]','[{0,1006010943,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31080907,'副手','9阶红3星副手【魔剑士】',2,'[{lv,300}]',2,'[]','[1001010942,1007010942,1001020942,1007020942,1001030942,1007030942,1001040942,1007040942]','[]','[]','[{0,1007010943,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31080908,'护腕','9阶红3星护腕【魔剑士】',2,'[{lv,300}]',2,'[]','[1002010942,1004010942,1006010942,1008010942,1010010942,1002020942,1004020942,1006020942,1008020942,1010020942,1002030942,1004030942,1006030942,1008030942,1010030942,1002040942,1004040942,1006040942,1008040942,1010040942]','[]','[]','[{0,1008010943,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31080909,'戒指','9阶红3星戒指【通用】',2,'[{lv,300}]',2,'[]','[1005000942,1009000942,1005000942,1009000942,1005000942,1009000942,1005000942,1009000942]','[]','[]','[{0,1009000943,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31080910,'鞋子','9阶红3星鞋子【魔剑士】',2,'[{lv,300}]',2,'[]','[1002010942,1004010942,1006010942,1008010942,1010010942,1002020942,1004020942,1006020942,1008020942,1010020942,1002030942,1004030942,1006030942,1008030942,1010030942,1002040942,1004040942,1006040942,1008040942,1010040942]','[]','[]','[{0,1010010943,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081001,'武器','10阶红3星武器【魔剑士】',2,'[{lv,355}]',2,'[]','[1001011042,1007011042,1001021042,1007021042,1001031042,1007031042,1001041042,1007041042]','[]','[]','[{0,1001011043,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081002,'头盔','10阶红3星头盔【魔剑士】',2,'[{lv,355}]',2,'[]','[1002011042,1004011042,1006011042,1008011042,1010011042,1002021042,1004021042,1006021042,1008021042,1010021042,1002031042,1004031042,1006031042,1008031042,1010031042,1002041042,1004041042,1006041042,1008041042,1010041042]','[]','[]','[{0,1002011043,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081003,'项链','10阶红3星项链【通用】',2,'[{lv,355}]',2,'[]','[1003001042,1003001042,1003001042,1003001042]','[]','[]','[{0,1003001043,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081004,'衣服','10阶红3星衣服【魔剑士】',2,'[{lv,355}]',2,'[]','[1002011042,1004011042,1006011042,1008011042,1010011042,1002021042,1004021042,1006021042,1008021042,1010021042,1002031042,1004031042,1006031042,1008031042,1010031042,1002041042,1004041042,1006041042,1008041042,1010041042]','[]','[]','[{0,1004011043,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081005,'刻痕','10阶红3星刻痕【通用】',2,'[{lv,355}]',2,'[]','[1005001042,1009001042,1005001042,1009001042,1005001042,1009001042,1005001042,1009001042]','[]','[]','[{0,1005001043,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081006,'裤子','10阶红3星裤子【魔剑士】',2,'[{lv,355}]',2,'[]','[1002011042,1004011042,1006011042,1008011042,1010011042,1002021042,1004021042,1006021042,1008021042,1010021042,1002031042,1004031042,1006031042,1008031042,1010031042,1002041042,1004041042,1006041042,1008041042,1010041042]','[]','[]','[{0,1006011043,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081007,'副手','10阶红3星副手【魔剑士】',2,'[{lv,355}]',2,'[]','[1001011042,1007011042,1001021042,1007021042,1001031042,1007031042,1001041042,1007041042]','[]','[]','[{0,1007011043,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081008,'护腕','10阶红3星护腕【魔剑士】',2,'[{lv,355}]',2,'[]','[1002011042,1004011042,1006011042,1008011042,1010011042,1002021042,1004021042,1006021042,1008021042,1010021042,1002031042,1004031042,1006031042,1008031042,1010031042,1002041042,1004041042,1006041042,1008041042,1010041042]','[]','[]','[{0,1008011043,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081009,'戒指','10阶红3星戒指【通用】',2,'[{lv,355}]',2,'[]','[1005001042,1009001042,1005001042,1009001042,1005001042,1009001042,1005001042,1009001042]','[]','[]','[{0,1009001043,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081010,'鞋子','10阶红3星鞋子【魔剑士】',2,'[{lv,355}]',2,'[]','[1002011042,1004011042,1006011042,1008011042,1010011042,1002021042,1004021042,1006021042,1008021042,1010021042,1002031042,1004031042,1006031042,1008031042,1010031042,1002041042,1004041042,1006041042,1008041042,1010041042]','[]','[]','[{0,1010011043,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081101,'武器','11阶红3星武器【魔剑士】',2,'[{lv,400}]',2,'[]','[1001011142,1007011142,1001021142,1007021142,1001031142,1007031142,1001041142,1007041142]','[]','[]','[{0,1001011143,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081102,'头盔','11阶红3星头盔【魔剑士】',2,'[{lv,400}]',2,'[]','[1002011142,1004011142,1006011142,1008011142,1010011142,1002021142,1004021142,1006021142,1008021142,1010021142,1002031142,1004031142,1006031142,1008031142,1010031142,1002041142,1004041142,1006041142,1008041142,1010041142]','[]','[]','[{0,1002011143,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081103,'项链','11阶红3星项链【通用】',2,'[{lv,400}]',2,'[]','[1003001142,1003001142,1003001142,1003001142]','[]','[]','[{0,1003001143,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081104,'衣服','11阶红3星衣服【魔剑士】',2,'[{lv,400}]',2,'[]','[1002011142,1004011142,1006011142,1008011142,1010011142,1002021142,1004021142,1006021142,1008021142,1010021142,1002031142,1004031142,1006031142,1008031142,1010031142,1002041142,1004041142,1006041142,1008041142,1010041142]','[]','[]','[{0,1004011143,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081105,'刻痕','11阶红3星刻痕【通用】',2,'[{lv,400}]',2,'[]','[1005001142,1009001142,1005001142,1009001142,1005001142,1009001142,1005001142,1009001142]','[]','[]','[{0,1005001143,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081106,'裤子','11阶红3星裤子【魔剑士】',2,'[{lv,400}]',2,'[]','[1002011142,1004011142,1006011142,1008011142,1010011142,1002021142,1004021142,1006021142,1008021142,1010021142,1002031142,1004031142,1006031142,1008031142,1010031142,1002041142,1004041142,1006041142,1008041142,1010041142]','[]','[]','[{0,1006011143,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081107,'副手','11阶红3星副手【魔剑士】',2,'[{lv,400}]',2,'[]','[1001011142,1007011142,1001021142,1007021142,1001031142,1007031142,1001041142,1007041142]','[]','[]','[{0,1007011143,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081108,'护腕','11阶红3星护腕【魔剑士】',2,'[{lv,400}]',2,'[]','[1002011142,1004011142,1006011142,1008011142,1010011142,1002021142,1004021142,1006021142,1008021142,1010021142,1002031142,1004031142,1006031142,1008031142,1010031142,1002041142,1004041142,1006041142,1008041142,1010041142]','[]','[]','[{0,1008011143,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081109,'戒指','11阶红3星戒指【通用】',2,'[{lv,400}]',2,'[]','[1005001142,1009001142,1005001142,1009001142,1005001142,1009001142,1005001142,1009001142]','[]','[]','[{0,1009001143,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081110,'鞋子','11阶红3星鞋子【魔剑士】',2,'[{lv,400}]',2,'[]','[1002011142,1004011142,1006011142,1008011142,1010011142,1002021142,1004021142,1006021142,1008021142,1010021142,1002031142,1004031142,1006031142,1008031142,1010031142,1002041142,1004041142,1006041142,1008041142,1010041142]','[]','[]','[{0,1010011143,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081201,'武器','12阶红3星武器【魔剑士】',2,'[{lv,500}]',2,'[]','[1001011242,1007011242,1001021242,1007021242,1001031242,1007031242,1001041242,1007041242]','[]','[]','[{0,1001011243,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081202,'头盔','12阶红3星头盔【魔剑士】',2,'[{lv,500}]',2,'[]','[1002011242,1004011242,1006011242,1008011242,1010011242,1002021242,1004021242,1006021242,1008021242,1010021242,1002031242,1004031242,1006031242,1008031242,1010031242,1002041242,1004041242,1006041242,1008041242,1010041242]','[]','[]','[{0,1002011243,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081203,'项链','12阶红3星项链【通用】',2,'[{lv,500}]',2,'[]','[1003001242,1003001242,1003001242,1003001242]','[]','[]','[{0,1003001243,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081204,'衣服','12阶红3星衣服【魔剑士】',2,'[{lv,500}]',2,'[]','[1002011242,1004011242,1006011242,1008011242,1010011242,1002021242,1004021242,1006021242,1008021242,1010021242,1002031242,1004031242,1006031242,1008031242,1010031242,1002041242,1004041242,1006041242,1008041242,1010041242]','[]','[]','[{0,1004011243,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081205,'刻痕','12阶红3星刻痕【通用】',2,'[{lv,500}]',2,'[]','[1005001242,1009001242,1005001242,1009001242,1005001242,1009001242,1005001242,1009001242]','[]','[]','[{0,1005001243,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081206,'裤子','12阶红3星裤子【魔剑士】',2,'[{lv,500}]',2,'[]','[1002011242,1004011242,1006011242,1008011242,1010011242,1002021242,1004021242,1006021242,1008021242,1010021242,1002031242,1004031242,1006031242,1008031242,1010031242,1002041242,1004041242,1006041242,1008041242,1010041242]','[]','[]','[{0,1006011243,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081207,'副手','12阶红3星副手【魔剑士】',2,'[{lv,500}]',2,'[]','[1001011242,1007011242,1001021242,1007021242,1001031242,1007031242,1001041242,1007041242]','[]','[]','[{0,1007011243,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081208,'护腕','12阶红3星护腕【魔剑士】',2,'[{lv,500}]',2,'[]','[1002011242,1004011242,1006011242,1008011242,1010011242,1002021242,1004021242,1006021242,1008021242,1010021242,1002031242,1004031242,1006031242,1008031242,1010031242,1002041242,1004041242,1006041242,1008041242,1010041242]','[]','[]','[{0,1008011243,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081209,'戒指','12阶红3星戒指【通用】',2,'[{lv,500}]',2,'[]','[1005001242,1009001242,1005001242,1009001242,1005001242,1009001242,1005001242,1009001242]','[]','[]','[{0,1009001243,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081210,'鞋子','12阶红3星鞋子【魔剑士】',2,'[{lv,500}]',2,'[]','[1002011242,1004011242,1006011242,1008011242,1010011242,1002021242,1004021242,1006021242,1008021242,1010021242,1002031242,1004031242,1006031242,1008031242,1010031242,1002041242,1004041242,1006041242,1008041242,1010041242]','[]','[]','[{0,1010011243,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081301,'武器','13阶红3星武器【魔剑士】',2,'[{lv,520}]',2,'[]','[1001011342,1007011342,1001021342,1007021342,1001031342,1007031342,1001041342,1007041342]','[]','[]','[{0,1001011343,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081302,'头盔','13阶红3星头盔【魔剑士】',2,'[{lv,520}]',2,'[]','[1002011342,1004011342,1006011342,1008011342,1010011342,1002021342,1004021342,1006021342,1008021342,1010021342,1002031342,1004031342,1006031342,1008031342,1010031342,1002041342,1004041342,1006041342,1008041342,1010041342]','[]','[]','[{0,1002011343,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081303,'项链','13阶红3星项链【通用】',2,'[{lv,520}]',2,'[]','[1003001342,1003001342,1003001342,1003001342]','[]','[]','[{0,1003001343,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081304,'衣服','13阶红3星衣服【魔剑士】',2,'[{lv,520}]',2,'[]','[1002011342,1004011342,1006011342,1008011342,1010011342,1002021342,1004021342,1006021342,1008021342,1010021342,1002031342,1004031342,1006031342,1008031342,1010031342,1002041342,1004041342,1006041342,1008041342,1010041342]','[]','[]','[{0,1004011343,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081305,'刻痕','13阶红3星刻痕【通用】',2,'[{lv,520}]',2,'[]','[1005001342,1009001342,1005001342,1009001342,1005001342,1009001342,1005001342,1009001342]','[]','[]','[{0,1005001343,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081306,'裤子','13阶红3星裤子【魔剑士】',2,'[{lv,520}]',2,'[]','[1002011342,1004011342,1006011342,1008011342,1010011342,1002021342,1004021342,1006021342,1008021342,1010021342,1002031342,1004031342,1006031342,1008031342,1010031342,1002041342,1004041342,1006041342,1008041342,1010041342]','[]','[]','[{0,1006011343,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081307,'副手','13阶红3星副手【魔剑士】',2,'[{lv,520}]',2,'[]','[1001011342,1007011342,1001021342,1007021342,1001031342,1007031342,1001041342,1007041342]','[]','[]','[{0,1007011343,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081308,'护腕','13阶红3星护腕【魔剑士】',2,'[{lv,520}]',2,'[]','[1002011342,1004011342,1006011342,1008011342,1010011342,1002021342,1004021342,1006021342,1008021342,1010021342,1002031342,1004031342,1006031342,1008031342,1010031342,1002041342,1004041342,1006041342,1008041342,1010041342]','[]','[]','[{0,1008011343,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081309,'戒指','13阶红3星戒指【通用】',2,'[{lv,520}]',2,'[]','[1005001342,1009001342,1005001342,1009001342,1005001342,1009001342,1005001342,1009001342]','[]','[]','[{0,1009001343,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081310,'鞋子','13阶红3星鞋子【魔剑士】',2,'[{lv,520}]',2,'[]','[1002011342,1004011342,1006011342,1008011342,1010011342,1002021342,1004021342,1006021342,1008021342,1010021342,1002031342,1004031342,1006031342,1008031342,1010031342,1002041342,1004041342,1006041342,1008041342,1010041342]','[]','[]','[{0,1010011343,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081401,'武器','14阶红3星武器【魔剑士】',2,'[{lv,620}]',2,'[]','[1001011442,1007011442,1001021442,1007021442,1001031442,1007031442,1001041442,1007041442]','[]','[]','[{0,1001011443,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081402,'头盔','14阶红3星头盔【魔剑士】',2,'[{lv,620}]',2,'[]','[1002011442,1004011442,1006011442,1008011442,1010011442,1002021442,1004021442,1006021442,1008021442,1010021442,1002031442,1004031442,1006031442,1008031442,1010031442,1002041442,1004041442,1006041442,1008041442,1010041442]','[]','[]','[{0,1002011443,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081403,'项链','14阶红3星项链【通用】',2,'[{lv,620}]',2,'[]','[1003001442,1003001442,1003001442,1003001442]','[]','[]','[{0,1003001443,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081404,'衣服','14阶红3星衣服【魔剑士】',2,'[{lv,620}]',2,'[]','[1002011442,1004011442,1006011442,1008011442,1010011442,1002021442,1004021442,1006021442,1008021442,1010021442,1002031442,1004031442,1006031442,1008031442,1010031442,1002041442,1004041442,1006041442,1008041442,1010041442]','[]','[]','[{0,1004011443,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081405,'刻痕','14阶红3星刻痕【通用】',2,'[{lv,620}]',2,'[]','[1005001442,1009001442,1005001442,1009001442,1005001442,1009001442,1005001442,1009001442]','[]','[]','[{0,1005001443,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081406,'裤子','14阶红3星裤子【魔剑士】',2,'[{lv,620}]',2,'[]','[1002011442,1004011442,1006011442,1008011442,1010011442,1002021442,1004021442,1006021442,1008021442,1010021442,1002031442,1004031442,1006031442,1008031442,1010031442,1002041442,1004041442,1006041442,1008041442,1010041442]','[]','[]','[{0,1006011443,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081407,'副手','14阶红3星副手【魔剑士】',2,'[{lv,620}]',2,'[]','[1001011442,1007011442,1001021442,1007021442,1001031442,1007031442,1001041442,1007041442]','[]','[]','[{0,1007011443,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081408,'护腕','14阶红3星护腕【魔剑士】',2,'[{lv,620}]',2,'[]','[1002011442,1004011442,1006011442,1008011442,1010011442,1002021442,1004021442,1006021442,1008021442,1010021442,1002031442,1004031442,1006031442,1008031442,1010031442,1002041442,1004041442,1006041442,1008041442,1010041442]','[]','[]','[{0,1008011443,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081409,'戒指','14阶红3星戒指【通用】',2,'[{lv,620}]',2,'[]','[1005001442,1009001442,1005001442,1009001442,1005001442,1009001442,1005001442,1009001442]','[]','[]','[{0,1009001443,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081410,'鞋子','14阶红3星鞋子【魔剑士】',2,'[{lv,620}]',2,'[]','[1002011442,1004011442,1006011442,1008011442,1010011442,1002021442,1004021442,1006021442,1008021442,1010021442,1002031442,1004031442,1006031442,1008031442,1010031442,1002041442,1004041442,1006041442,1008041442,1010041442]','[]','[]','[{0,1010011443,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081501,'武器','15阶红3星武器【魔剑士】',2,'[{lv,650}]',2,'[]','[1001011542,1007011542,1001021542,1007021542,1001031542,1007031542,1001041542,1007041542]','[]','[]','[{0,1001011543,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081502,'头盔','15阶红3星头盔【魔剑士】',2,'[{lv,650}]',2,'[]','[1002011542,1004011542,1006011542,1008011542,1010011542,1002021542,1004021542,1006021542,1008021542,1010021542,1002031542,1004031542,1006031542,1008031542,1010031542,1002041542,1004041542,1006041542,1008041542,1010041542]','[]','[]','[{0,1002011543,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081503,'项链','15阶红3星项链【通用】',2,'[{lv,650}]',2,'[]','[1003001542,1003001542,1003001542,1003001542]','[]','[]','[{0,1003001543,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081504,'衣服','15阶红3星衣服【魔剑士】',2,'[{lv,650}]',2,'[]','[1002011542,1004011542,1006011542,1008011542,1010011542,1002021542,1004021542,1006021542,1008021542,1010021542,1002031542,1004031542,1006031542,1008031542,1010031542,1002041542,1004041542,1006041542,1008041542,1010041542]','[]','[]','[{0,1004011543,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081505,'刻痕','15阶红3星刻痕【通用】',2,'[{lv,650}]',2,'[]','[1005001542,1009001542,1005001542,1009001542,1005001542,1009001542,1005001542,1009001542]','[]','[]','[{0,1005001543,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081506,'裤子','15阶红3星裤子【魔剑士】',2,'[{lv,650}]',2,'[]','[1002011542,1004011542,1006011542,1008011542,1010011542,1002021542,1004021542,1006021542,1008021542,1010021542,1002031542,1004031542,1006031542,1008031542,1010031542,1002041542,1004041542,1006041542,1008041542,1010041542]','[]','[]','[{0,1006011543,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081507,'副手','15阶红3星副手【魔剑士】',2,'[{lv,650}]',2,'[]','[1001011542,1007011542,1001021542,1007021542,1001031542,1007031542,1001041542,1007041542]','[]','[]','[{0,1007011543,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081508,'护腕','15阶红3星护腕【魔剑士】',2,'[{lv,650}]',2,'[]','[1002011542,1004011542,1006011542,1008011542,1010011542,1002021542,1004021542,1006021542,1008021542,1010021542,1002031542,1004031542,1006031542,1008031542,1010031542,1002041542,1004041542,1006041542,1008041542,1010041542]','[]','[]','[{0,1008011543,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081509,'戒指','15阶红3星戒指【通用】',2,'[{lv,650}]',2,'[]','[1005001542,1009001542,1005001542,1009001542,1005001542,1009001542,1005001542,1009001542]','[]','[]','[{0,1009001543,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081510,'鞋子','15阶红3星鞋子【魔剑士】',2,'[{lv,650}]',2,'[]','[1002011542,1004011542,1006011542,1008011542,1010011542,1002021542,1004021542,1006021542,1008021542,1010021542,1002031542,1004031542,1006031542,1008031542,1010031542,1002041542,1004041542,1006041542,1008041542,1010041542]','[]','[]','[{0,1010011543,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081601,'武器','16阶红3星武器【魔剑士】',2,'[{lv,700}]',2,'[]','[1001011642,1007011642,1001021642,1007021642,1001031642,1007031642,1001041642,1007041642]','[]','[]','[{0,1001011643,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081602,'头盔','16阶红3星头盔【魔剑士】',2,'[{lv,700}]',2,'[]','[1002011642,1004011642,1006011642,1008011642,1010011642,1002021642,1004021642,1006021642,1008021642,1010021642,1002031642,1004031642,1006031642,1008031642,1010031642,1002041642,1004041642,1006041642,1008041642,1010041642]','[]','[]','[{0,1002011643,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081603,'项链','16阶红3星项链【通用】',2,'[{lv,700}]',2,'[]','[1003001642,1003001642,1003001642,1003001642]','[]','[]','[{0,1003001643,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081604,'衣服','16阶红3星衣服【魔剑士】',2,'[{lv,700}]',2,'[]','[1002011642,1004011642,1006011642,1008011642,1010011642,1002021642,1004021642,1006021642,1008021642,1010021642,1002031642,1004031642,1006031642,1008031642,1010031642,1002041642,1004041642,1006041642,1008041642,1010041642]','[]','[]','[{0,1004011643,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081605,'刻痕','16阶红3星刻痕【通用】',2,'[{lv,700}]',2,'[]','[1005001642,1009001642,1005001642,1009001642,1005001642,1009001642,1005001642,1009001642]','[]','[]','[{0,1005001643,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081606,'裤子','16阶红3星裤子【魔剑士】',2,'[{lv,700}]',2,'[]','[1002011642,1004011642,1006011642,1008011642,1010011642,1002021642,1004021642,1006021642,1008021642,1010021642,1002031642,1004031642,1006031642,1008031642,1010031642,1002041642,1004041642,1006041642,1008041642,1010041642]','[]','[]','[{0,1006011643,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081607,'副手','16阶红3星副手【魔剑士】',2,'[{lv,700}]',2,'[]','[1001011642,1007011642,1001021642,1007021642,1001031642,1007031642,1001041642,1007041642]','[]','[]','[{0,1007011643,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081608,'护腕','16阶红3星护腕【魔剑士】',2,'[{lv,700}]',2,'[]','[1002011642,1004011642,1006011642,1008011642,1010011642,1002021642,1004021642,1006021642,1008021642,1010021642,1002031642,1004031642,1006031642,1008031642,1010031642,1002041642,1004041642,1006041642,1008041642,1010041642]','[]','[]','[{0,1008011643,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081609,'戒指','16阶红3星戒指【通用】',2,'[{lv,700}]',2,'[]','[1005001642,1009001642,1005001642,1009001642,1005001642,1009001642,1005001642,1009001642]','[]','[]','[{0,1009001643,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31081610,'鞋子','16阶红3星鞋子【魔剑士】',2,'[{lv,700}]',2,'[]','[1002011642,1004011642,1006011642,1008011642,1010011642,1002021642,1004021642,1006021642,1008021642,1010021642,1002031642,1004031642,1006031642,1008031642,1010031642,1002041642,1004041642,1006041642,1008041642,1010041642]','[]','[]','[{0,1010011643,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(31090301,'武器','3阶粉色武器【魔剑士】',2,'[{lv,9999}]',3,'[{0,38280520,1}]','[1001010343,1007010343,1001020343,1007020343,1001030343,1007030343,1001040343,1007040343]','[]','[]','[{0,1001010353,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(31090302,'头盔','3阶粉色头盔【魔剑士】',2,'[{lv,9999}]',3,'[{0,38280510,1}]','[1002010343,1004010343,1006010343,1008010343,1010010343,1002020343,1004020343,1006020343,1008020343,1010020343,1002030343,1004030343,1006030343,1008030343,1010030343,1002040343,1004040343,1006040343,1008040343,1010040343]','[]','[]','[{0,1002010353,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(31090303,'项链','3阶粉色项链【通用】',2,'[{lv,9999}]',3,'[{0,38280520,1}]','[1003000343,1003000343,1003000343,1003000343]','[]','[]','[{0,1003000353,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(31090304,'衣服','3阶粉色衣服【魔剑士】',2,'[{lv,9999}]',3,'[{0,38280510,1}]','[1002010343,1004010343,1006010343,1008010343,1010010343,1002020343,1004020343,1006020343,1008020343,1010020343,1002030343,1004030343,1006030343,1008030343,1010030343,1002040343,1004040343,1006040343,1008040343,1010040343]','[]','[]','[{0,1004010353,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(31090305,'刻痕','3阶粉色刻痕【通用】',2,'[{lv,9999}]',3,'[{0,38280520,1}]','[1005000343,1009000343,1005000343,1009000343,1005000343,1009000343,1005000343,1009000343]','[]','[]','[{0,1005000353,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(31090306,'裤子','3阶粉色裤子【魔剑士】',2,'[{lv,9999}]',3,'[{0,38280510,1}]','[1002010343,1004010343,1006010343,1008010343,1010010343,1002020343,1004020343,1006020343,1008020343,1010020343,1002030343,1004030343,1006030343,1008030343,1010030343,1002040343,1004040343,1006040343,1008040343,1010040343]','[]','[]','[{0,1006010353,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(31090307,'副手','3阶粉色副手【魔剑士】',2,'[{lv,9999}]',3,'[{0,38280520,1}]','[1001010343,1007010343,1001020343,1007020343,1001030343,1007030343,1001040343,1007040343]','[]','[]','[{0,1007010353,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(31090308,'护腕','3阶粉色护腕【魔剑士】',2,'[{lv,9999}]',3,'[{0,38280510,1}]','[1002010343,1004010343,1006010343,1008010343,1010010343,1002020343,1004020343,1006020343,1008020343,1010020343,1002030343,1004030343,1006030343,1008030343,1010030343,1002040343,1004040343,1006040343,1008040343,1010040343]','[]','[]','[{0,1008010353,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(31090309,'戒指','3阶粉色戒指【通用】',2,'[{lv,9999}]',3,'[{0,38280520,1}]','[1005000343,1009000343,1005000343,1009000343,1005000343,1009000343,1005000343,1009000343]','[]','[]','[{0,1009000353,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(31090310,'鞋子','3阶粉色鞋子【魔剑士】',2,'[{lv,9999}]',3,'[{0,38280510,1}]','[1002010343,1004010343,1006010343,1008010343,1010010343,1002020343,1004020343,1006020343,1008020343,1010020343,1002030343,1004030343,1006030343,1008030343,1010030343,1002040343,1004040343,1006040343,1008040343,1010040343]','[]','[]','[{0,1010010353,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(31090401,'武器','4阶粉色武器【魔剑士】',2,'[{lv,160}]',3,'[{0,38280520,1}]','[1001010443,1007010443,1001020443,1007020443,1001030443,1007030443,1001040443,1007040443]','[]','[]','[{0,1001010453,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(31090402,'头盔','4阶粉色头盔【魔剑士】',2,'[{lv,160}]',3,'[{0,38280510,1}]','[1002010443,1004010443,1006010443,1008010443,1010010443,1002020443,1004020443,1006020443,1008020443,1010020443,1002030443,1004030443,1006030443,1008030443,1010030443,1002040443,1004040443,1006040443,1008040443,1010040443]','[]','[]','[{0,1002010453,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(31090403,'项链','4阶粉色项链【通用】',2,'[{lv,160}]',3,'[{0,38280520,1}]','[1003000443,1003000443,1003000443,1003000443]','[]','[]','[{0,1003000453,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(31090404,'衣服','4阶粉色衣服【魔剑士】',2,'[{lv,160}]',3,'[{0,38280510,1}]','[1002010443,1004010443,1006010443,1008010443,1010010443,1002020443,1004020443,1006020443,1008020443,1010020443,1002030443,1004030443,1006030443,1008030443,1010030443,1002040443,1004040443,1006040443,1008040443,1010040443]','[]','[]','[{0,1004010453,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(31090405,'刻痕','4阶粉色刻痕【通用】',2,'[{lv,160}]',3,'[{0,38280520,1}]','[1005000443,1009000443,1005000443,1009000443,1005000443,1009000443,1005000443,1009000443]','[]','[]','[{0,1005000453,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(31090406,'裤子','4阶粉色裤子【魔剑士】',2,'[{lv,160}]',3,'[{0,38280510,1}]','[1002010443,1004010443,1006010443,1008010443,1010010443,1002020443,1004020443,1006020443,1008020443,1010020443,1002030443,1004030443,1006030443,1008030443,1010030443,1002040443,1004040443,1006040443,1008040443,1010040443]','[]','[]','[{0,1006010453,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(31090407,'副手','4阶粉色副手【魔剑士】',2,'[{lv,160}]',3,'[{0,38280520,1}]','[1001010443,1007010443,1001020443,1007020443,1001030443,1007030443,1001040443,1007040443]','[]','[]','[{0,1007010453,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(31090408,'护腕','4阶粉色护腕【魔剑士】',2,'[{lv,160}]',3,'[{0,38280510,1}]','[1002010443,1004010443,1006010443,1008010443,1010010443,1002020443,1004020443,1006020443,1008020443,1010020443,1002030443,1004030443,1006030443,1008030443,1010030443,1002040443,1004040443,1006040443,1008040443,1010040443]','[]','[]','[{0,1008010453,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(31090409,'戒指','4阶粉色戒指【通用】',2,'[{lv,160}]',3,'[{0,38280520,1}]','[1005000443,1009000443,1005000443,1009000443,1005000443,1009000443,1005000443,1009000443]','[]','[]','[{0,1009000453,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(31090410,'鞋子','4阶粉色鞋子【魔剑士】',2,'[{lv,160}]',3,'[{0,38280510,1}]','[1002010443,1004010443,1006010443,1008010443,1010010443,1002020443,1004020443,1006020443,1008020443,1010020443,1002030443,1004030443,1006030443,1008030443,1010030443,1002040443,1004040443,1006040443,1008040443,1010040443]','[]','[]','[{0,1010010453,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(31090501,'武器','5阶粉色武器【魔剑士】',2,'[{lv,160}]',3,'[{0,38280520,1}]','[1001010543,1007010543,1001020543,1007020543,1001030543,1007030543,1001040543,1007040543,1101010543,1107010543,1101020543,1107020543,1101030543,1107030543,1101040543,1107040543]','[]','[]','[{0,1001010553,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(31090502,'头盔','5阶粉色头盔【魔剑士】',2,'[{lv,160}]',3,'[{0,38280510,1}]','[1002010543,1004010543,1006010543,1008010543,1010010543,1002020543,1004020543,1006020543,1008020543,1010020543,1002030543,1004030543,1006030543,1008030543,1010030543,1002040543,1004040543,1006040543,1008040543,1010040543,1102010543,1104010543,1106010543,1108010543,1110010543,1102020543,1104020543,1106020543,1108020543,1110020543,1102030543,1104030543,1106030543,1108030543,1110030543,1102040543,1104040543,1106040543,1108040543,1110040543]','[]','[]','[{0,1002010553,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(31090503,'项链','5阶粉色项链【通用】',2,'[{lv,160}]',3,'[{0,38280520,1}]','[1003000543,1003000543,1003000543,1003000543,1103000543,1103000543,1103000543,1103000543]','[]','[]','[{0,1003000553,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(31090504,'衣服','5阶粉色衣服【魔剑士】',2,'[{lv,160}]',3,'[{0,38280510,1}]','[1002010543,1004010543,1006010543,1008010543,1010010543,1002020543,1004020543,1006020543,1008020543,1010020543,1002030543,1004030543,1006030543,1008030543,1010030543,1002040543,1004040543,1006040543,1008040543,1010040543,1102010543,1104010543,1106010543,1108010543,1110010543,1102020543,1104020543,1106020543,1108020543,1110020543,1102030543,1104030543,1106030543,1108030543,1110030543,1102040543,1104040543,1106040543,1108040543,1110040543]','[]','[]','[{0,1004010553,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(31090505,'刻痕','5阶粉色刻痕【通用】',2,'[{lv,160}]',3,'[{0,38280520,1}]','[1005000543,1009000543,1005000543,1009000543,1005000543,1009000543,1005000543,1009000543,1105000543,1109000543,1105000543,1109000543,1105000543,1109000543,1105000543,1109000543]','[]','[]','[{0,1005000553,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(31090506,'裤子','5阶粉色裤子【魔剑士】',2,'[{lv,160}]',3,'[{0,38280510,1}]','[1002010543,1004010543,1006010543,1008010543,1010010543,1002020543,1004020543,1006020543,1008020543,1010020543,1002030543,1004030543,1006030543,1008030543,1010030543,1002040543,1004040543,1006040543,1008040543,1010040543,1102010543,1104010543,1106010543,1108010543,1110010543,1102020543,1104020543,1106020543,1108020543,1110020543,1102030543,1104030543,1106030543,1108030543,1110030543,1102040543,1104040543,1106040543,1108040543,1110040543]','[]','[]','[{0,1006010553,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(31090507,'副手','5阶粉色副手【魔剑士】',2,'[{lv,160}]',3,'[{0,38280520,1}]','[1001010543,1007010543,1001020543,1007020543,1001030543,1007030543,1001040543,1007040543,1101010543,1107010543,1101020543,1107020543,1101030543,1107030543,1101040543,1107040543]','[]','[]','[{0,1007010553,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(31090508,'护腕','5阶粉色护腕【魔剑士】',2,'[{lv,160}]',3,'[{0,38280510,1}]','[1002010543,1004010543,1006010543,1008010543,1010010543,1002020543,1004020543,1006020543,1008020543,1010020543,1002030543,1004030543,1006030543,1008030543,1010030543,1002040543,1004040543,1006040543,1008040543,1010040543,1102010543,1104010543,1106010543,1108010543,1110010543,1102020543,1104020543,1106020543,1108020543,1110020543,1102030543,1104030543,1106030543,1108030543,1110030543,1102040543,1104040543,1106040543,1108040543,1110040543]','[]','[]','[{0,1008010553,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(31090509,'戒指','5阶粉色戒指【通用】',2,'[{lv,160}]',3,'[{0,38280520,1}]','[1005000543,1009000543,1005000543,1009000543,1005000543,1009000543,1005000543,1009000543,1105000543,1109000543,1105000543,1109000543,1105000543,1109000543,1105000543,1109000543]','[]','[]','[{0,1009000553,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(31090510,'鞋子','5阶粉色鞋子【魔剑士】',2,'[{lv,160}]',3,'[{0,38280510,1}]','[1002010543,1004010543,1006010543,1008010543,1010010543,1002020543,1004020543,1006020543,1008020543,1010020543,1002030543,1004030543,1006030543,1008030543,1010030543,1002040543,1004040543,1006040543,1008040543,1010040543,1102010543,1104010543,1106010543,1108010543,1110010543,1102020543,1104020543,1106020543,1108020543,1110020543,1102030543,1104030543,1106030543,1108030543,1110030543,1102040543,1104040543,1106040543,1108040543,1110040543]','[]','[]','[{0,1010010553,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(31090601,'武器','6阶粉色武器【魔剑士】',2,'[{lv,180}]',3,'[{0,38280520,2}]','[1001010643,1007010643,1001020643,1007020643,1001030643,1007030643,1001040643,1007040643]','[]','[]','[{0,1001010653,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280520,2}]',150),(31090602,'头盔','6阶粉色头盔【魔剑士】',2,'[{lv,180}]',3,'[{0,38280510,2}]','[1002010643,1004010643,1006010643,1008010643,1010010643,1002020643,1004020643,1006020643,1008020643,1010020643,1002030643,1004030643,1006030643,1008030643,1010030643,1002040643,1004040643,1006040643,1008040643,1010040643]','[]','[]','[{0,1002010653,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280510,2}]',150),(31090603,'项链','6阶粉色项链【通用】',2,'[{lv,180}]',3,'[{0,38280520,2}]','[1003000643,1003000643,1003000643,1003000643]','[]','[]','[{0,1003000653,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280520,2}]',150),(31090604,'衣服','6阶粉色衣服【魔剑士】',2,'[{lv,180}]',3,'[{0,38280510,2}]','[1002010643,1004010643,1006010643,1008010643,1010010643,1002020643,1004020643,1006020643,1008020643,1010020643,1002030643,1004030643,1006030643,1008030643,1010030643,1002040643,1004040643,1006040643,1008040643,1010040643]','[]','[]','[{0,1004010653,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280510,2}]',150),(31090605,'刻痕','6阶粉色刻痕【通用】',2,'[{lv,180}]',3,'[{0,38280520,2}]','[1005000643,1009000643,1005000643,1009000643,1005000643,1009000643,1005000643,1009000643]','[]','[]','[{0,1005000653,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280520,2}]',150),(31090606,'裤子','6阶粉色裤子【魔剑士】',2,'[{lv,180}]',3,'[{0,38280510,2}]','[1002010643,1004010643,1006010643,1008010643,1010010643,1002020643,1004020643,1006020643,1008020643,1010020643,1002030643,1004030643,1006030643,1008030643,1010030643,1002040643,1004040643,1006040643,1008040643,1010040643]','[]','[]','[{0,1006010653,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280510,2}]',150),(31090607,'副手','6阶粉色副手【魔剑士】',2,'[{lv,180}]',3,'[{0,38280520,2}]','[1001010643,1007010643,1001020643,1007020643,1001030643,1007030643,1001040643,1007040643]','[]','[]','[{0,1007010653,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280520,2}]',150),(31090608,'护腕','6阶粉色护腕【魔剑士】',2,'[{lv,180}]',3,'[{0,38280510,2}]','[1002010643,1004010643,1006010643,1008010643,1010010643,1002020643,1004020643,1006020643,1008020643,1010020643,1002030643,1004030643,1006030643,1008030643,1010030643,1002040643,1004040643,1006040643,1008040643,1010040643]','[]','[]','[{0,1008010653,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280510,2}]',150),(31090609,'戒指','6阶粉色戒指【通用】',2,'[{lv,180}]',3,'[{0,38280520,2}]','[1005000643,1009000643,1005000643,1009000643,1005000643,1009000643,1005000643,1009000643]','[]','[]','[{0,1009000653,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280520,2}]',150),(31090610,'鞋子','6阶粉色鞋子【魔剑士】',2,'[{lv,180}]',3,'[{0,38280510,2}]','[1002010643,1004010643,1006010643,1008010643,1010010643,1002020643,1004020643,1006020643,1008020643,1010020643,1002030643,1004030643,1006030643,1008030643,1010030643,1002040643,1004040643,1006040643,1008040643,1010040643]','[]','[]','[{0,1010010653,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280510,2}]',150),(31090701,'武器','7阶粉色武器【魔剑士】',2,'[{lv,220}]',3,'[{0,38280520,3}]','[1001010743,1007010743,1001020743,1007020743,1001030743,1007030743,1001040743,1007040743,1101010743,1107010743,1101020743,1107020743,1101030743,1107030743,1101040743,1107040743]','[]','[]','[{0,1001010753,1}]',2,'[{1,0},{2,100},{3,100}]',3,1,'[{0,38280520,3}]',150),(31090702,'头盔','7阶粉色头盔【魔剑士】',2,'[{lv,220}]',3,'[{0,38280510,3}]','[1002010743,1004010743,1006010743,1008010743,1010010743,1002020743,1004020743,1006020743,1008020743,1010020743,1002030743,1004030743,1006030743,1008030743,1010030743,1002040743,1004040743,1006040743,1008040743,1010040743,1102010743,1104010743,1106010743,1108010743,1110010743,1102020743,1104020743,1106020743,1108020743,1110020743,1102030743,1104030743,1106030743,1108030743,1110030743,1102040743,1104040743,1106040743,1108040743,1110040743]','[]','[]','[{0,1002010753,1}]',2,'[{1,0},{2,100},{3,100}]',3,1,'[{0,38280510,3}]',150),(31090703,'项链','7阶粉色项链【通用】',2,'[{lv,220}]',3,'[{0,38280520,3}]','[1003000743,1003000743,1003000743,1003000743,1103000743,1103000743,1103000743,1103000743]','[]','[]','[{0,1003000753,1}]',2,'[{1,0},{2,100},{3,100}]',3,1,'[{0,38280520,3}]',150),(31090704,'衣服','7阶粉色衣服【魔剑士】',2,'[{lv,220}]',3,'[{0,38280510,3}]','[1002010743,1004010743,1006010743,1008010743,1010010743,1002020743,1004020743,1006020743,1008020743,1010020743,1002030743,1004030743,1006030743,1008030743,1010030743,1002040743,1004040743,1006040743,1008040743,1010040743,1102010743,1104010743,1106010743,1108010743,1110010743,1102020743,1104020743,1106020743,1108020743,1110020743,1102030743,1104030743,1106030743,1108030743,1110030743,1102040743,1104040743,1106040743,1108040743,1110040743]','[]','[]','[{0,1004010753,1}]',2,'[{1,0},{2,100},{3,100}]',3,1,'[{0,38280510,3}]',150),(31090705,'刻痕','7阶粉色刻痕【通用】',2,'[{lv,220}]',3,'[{0,38280520,3}]','[1005000743,1009000743,1005000743,1009000743,1005000743,1009000743,1005000743,1009000743,1105000743,1109000743,1105000743,1109000743,1105000743,1109000743,1105000743,1109000743]','[]','[]','[{0,1005000753,1}]',2,'[{1,0},{2,100},{3,100}]',3,1,'[{0,38280520,3}]',150),(31090706,'裤子','7阶粉色裤子【魔剑士】',2,'[{lv,220}]',3,'[{0,38280510,3}]','[1002010743,1004010743,1006010743,1008010743,1010010743,1002020743,1004020743,1006020743,1008020743,1010020743,1002030743,1004030743,1006030743,1008030743,1010030743,1002040743,1004040743,1006040743,1008040743,1010040743,1102010743,1104010743,1106010743,1108010743,1110010743,1102020743,1104020743,1106020743,1108020743,1110020743,1102030743,1104030743,1106030743,1108030743,1110030743,1102040743,1104040743,1106040743,1108040743,1110040743]','[]','[]','[{0,1006010753,1}]',2,'[{1,0},{2,100},{3,100}]',3,1,'[{0,38280510,3}]',150),(31090707,'副手','7阶粉色副手【魔剑士】',2,'[{lv,220}]',3,'[{0,38280520,3}]','[1001010743,1007010743,1001020743,1007020743,1001030743,1007030743,1001040743,1007040743,1101010743,1107010743,1101020743,1107020743,1101030743,1107030743,1101040743,1107040743]','[]','[]','[{0,1007010753,1}]',2,'[{1,0},{2,100},{3,100}]',3,1,'[{0,38280520,3}]',150),(31090708,'护腕','7阶粉色护腕【魔剑士】',2,'[{lv,220}]',3,'[{0,38280510,3}]','[1002010743,1004010743,1006010743,1008010743,1010010743,1002020743,1004020743,1006020743,1008020743,1010020743,1002030743,1004030743,1006030743,1008030743,1010030743,1002040743,1004040743,1006040743,1008040743,1010040743,1102010743,1104010743,1106010743,1108010743,1110010743,1102020743,1104020743,1106020743,1108020743,1110020743,1102030743,1104030743,1106030743,1108030743,1110030743,1102040743,1104040743,1106040743,1108040743,1110040743]','[]','[]','[{0,1008010753,1}]',2,'[{1,0},{2,100},{3,100}]',3,1,'[{0,38280510,3}]',150),(31090709,'戒指','7阶粉色戒指【通用】',2,'[{lv,220}]',3,'[{0,38280520,3}]','[1005000743,1009000743,1005000743,1009000743,1005000743,1009000743,1005000743,1009000743,1105000743,1109000743,1105000743,1109000743,1105000743,1109000743,1105000743,1109000743]','[]','[]','[{0,1009000753,1}]',2,'[{1,0},{2,100},{3,100}]',3,1,'[{0,38280520,3}]',150),(31090710,'鞋子','7阶粉色鞋子【魔剑士】',2,'[{lv,220}]',3,'[{0,38280510,3}]','[1002010743,1004010743,1006010743,1008010743,1010010743,1002020743,1004020743,1006020743,1008020743,1010020743,1002030743,1004030743,1006030743,1008030743,1010030743,1002040743,1004040743,1006040743,1008040743,1010040743,1102010743,1104010743,1106010743,1108010743,1110010743,1102020743,1104020743,1106020743,1108020743,1110020743,1102030743,1104030743,1106030743,1108030743,1110030743,1102040743,1104040743,1106040743,1108040743,1110040743]','[]','[]','[{0,1010010753,1}]',2,'[{1,0},{2,100},{3,100}]',3,1,'[{0,38280510,3}]',150),(31090801,'武器','8阶粉色武器【魔剑士】',2,'[{lv,260}]',3,'[{0,38280520,4}]','[1001010843,1007010843,1001020843,1007020843,1001030843,1007030843,1001040843,1007040843]','[]','[]','[{0,1001010853,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280520,4}]',150),(31090802,'头盔','8阶粉色头盔【魔剑士】',2,'[{lv,260}]',3,'[{0,38280510,4}]','[1002010843,1004010843,1006010843,1008010843,1010010843,1002020843,1004020843,1006020843,1008020843,1010020843,1002030843,1004030843,1006030843,1008030843,1010030843,1002040843,1004040843,1006040843,1008040843,1010040843]','[]','[]','[{0,1002010853,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280510,4}]',150),(31090803,'项链','8阶粉色项链【通用】',2,'[{lv,260}]',3,'[{0,38280520,4}]','[1003000843,1003000843,1003000843,1003000843]','[]','[]','[{0,1003000853,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280520,4}]',150),(31090804,'衣服','8阶粉色衣服【魔剑士】',2,'[{lv,260}]',3,'[{0,38280510,4}]','[1002010843,1004010843,1006010843,1008010843,1010010843,1002020843,1004020843,1006020843,1008020843,1010020843,1002030843,1004030843,1006030843,1008030843,1010030843,1002040843,1004040843,1006040843,1008040843,1010040843]','[]','[]','[{0,1004010853,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280510,4}]',150),(31090805,'刻痕','8阶粉色刻痕【通用】',2,'[{lv,260}]',3,'[{0,38280520,4}]','[1005000843,1009000843,1005000843,1009000843,1005000843,1009000843,1005000843,1009000843]','[]','[]','[{0,1005000853,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280520,4}]',150),(31090806,'裤子','8阶粉色裤子【魔剑士】',2,'[{lv,260}]',3,'[{0,38280510,4}]','[1002010843,1004010843,1006010843,1008010843,1010010843,1002020843,1004020843,1006020843,1008020843,1010020843,1002030843,1004030843,1006030843,1008030843,1010030843,1002040843,1004040843,1006040843,1008040843,1010040843]','[]','[]','[{0,1006010853,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280510,4}]',150),(31090807,'副手','8阶粉色副手【魔剑士】',2,'[{lv,260}]',3,'[{0,38280520,4}]','[1001010843,1007010843,1001020843,1007020843,1001030843,1007030843,1001040843,1007040843]','[]','[]','[{0,1007010853,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280520,4}]',150),(31090808,'护腕','8阶粉色护腕【魔剑士】',2,'[{lv,260}]',3,'[{0,38280510,4}]','[1002010843,1004010843,1006010843,1008010843,1010010843,1002020843,1004020843,1006020843,1008020843,1010020843,1002030843,1004030843,1006030843,1008030843,1010030843,1002040843,1004040843,1006040843,1008040843,1010040843]','[]','[]','[{0,1008010853,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280510,4}]',150),(31090809,'戒指','8阶粉色戒指【通用】',2,'[{lv,260}]',3,'[{0,38280520,4}]','[1005000843,1009000843,1005000843,1009000843,1005000843,1009000843,1005000843,1009000843]','[]','[]','[{0,1009000853,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280520,4}]',150),(31090810,'鞋子','8阶粉色鞋子【魔剑士】',2,'[{lv,260}]',3,'[{0,38280510,4}]','[1002010843,1004010843,1006010843,1008010843,1010010843,1002020843,1004020843,1006020843,1008020843,1010020843,1002030843,1004030843,1006030843,1008030843,1010030843,1002040843,1004040843,1006040843,1008040843,1010040843]','[]','[]','[{0,1010010853,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280510,4}]',150),(31090901,'武器','9阶粉色武器【魔剑士】',2,'[{lv,300}]',3,'[{0,38280520,6}]','[1001010943,1007010943,1001020943,1007020943,1001030943,1007030943,1001040943,1007040943]','[]','[]','[{0,1001010953,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280520,6}]',150),(31090902,'头盔','9阶粉色头盔【魔剑士】',2,'[{lv,300}]',3,'[{0,38280510,6}]','[1002010943,1004010943,1006010943,1008010943,1010010943,1002020943,1004020943,1006020943,1008020943,1010020943,1002030943,1004030943,1006030943,1008030943,1010030943,1002040943,1004040943,1006040943,1008040943,1010040943]','[]','[]','[{0,1002010953,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280510,6}]',150),(31090903,'项链','9阶粉色项链【通用】',2,'[{lv,300}]',3,'[{0,38280520,6}]','[1003000943,1003000943,1003000943,1003000943]','[]','[]','[{0,1003000953,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280520,6}]',150),(31090904,'衣服','9阶粉色衣服【魔剑士】',2,'[{lv,300}]',3,'[{0,38280510,6}]','[1002010943,1004010943,1006010943,1008010943,1010010943,1002020943,1004020943,1006020943,1008020943,1010020943,1002030943,1004030943,1006030943,1008030943,1010030943,1002040943,1004040943,1006040943,1008040943,1010040943]','[]','[]','[{0,1004010953,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280510,6}]',150),(31090905,'刻痕','9阶粉色刻痕【通用】',2,'[{lv,300}]',3,'[{0,38280520,6}]','[1005000943,1009000943,1005000943,1009000943,1005000943,1009000943,1005000943,1009000943]','[]','[]','[{0,1005000953,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280520,6}]',150),(31090906,'裤子','9阶粉色裤子【魔剑士】',2,'[{lv,300}]',3,'[{0,38280510,6}]','[1002010943,1004010943,1006010943,1008010943,1010010943,1002020943,1004020943,1006020943,1008020943,1010020943,1002030943,1004030943,1006030943,1008030943,1010030943,1002040943,1004040943,1006040943,1008040943,1010040943]','[]','[]','[{0,1006010953,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280510,6}]',150),(31090907,'副手','9阶粉色副手【魔剑士】',2,'[{lv,300}]',3,'[{0,38280520,6}]','[1001010943,1007010943,1001020943,1007020943,1001030943,1007030943,1001040943,1007040943]','[]','[]','[{0,1007010953,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280520,6}]',150),(31090908,'护腕','9阶粉色护腕【魔剑士】',2,'[{lv,300}]',3,'[{0,38280510,6}]','[1002010943,1004010943,1006010943,1008010943,1010010943,1002020943,1004020943,1006020943,1008020943,1010020943,1002030943,1004030943,1006030943,1008030943,1010030943,1002040943,1004040943,1006040943,1008040943,1010040943]','[]','[]','[{0,1008010953,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280510,6}]',150),(31090909,'戒指','9阶粉色戒指【通用】',2,'[{lv,300}]',3,'[{0,38280520,6}]','[1005000943,1009000943,1005000943,1009000943,1005000943,1009000943,1005000943,1009000943]','[]','[]','[{0,1009000953,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280520,6}]',150),(31090910,'鞋子','9阶粉色鞋子【魔剑士】',2,'[{lv,300}]',3,'[{0,38280510,6}]','[1002010943,1004010943,1006010943,1008010943,1010010943,1002020943,1004020943,1006020943,1008020943,1010020943,1002030943,1004030943,1006030943,1008030943,1010030943,1002040943,1004040943,1006040943,1008040943,1010040943]','[]','[]','[{0,1010010953,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280510,6}]',150),(31091001,'武器','10阶粉色武器【魔剑士】',2,'[{lv,355}]',3,'[{0,38280520,8}]','[1001011043,1007011043,1001021043,1007021043,1001031043,1007031043,1001041043,1007041043]','[]','[]','[{0,1001011053,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,8}]',150),(31091002,'头盔','10阶粉色头盔【魔剑士】',2,'[{lv,355}]',3,'[{0,38280510,8}]','[1002011043,1004011043,1006011043,1008011043,1010011043,1002021043,1004021043,1006021043,1008021043,1010021043,1002031043,1004031043,1006031043,1008031043,1010031043,1002041043,1004041043,1006041043,1008041043,1010041043]','[]','[]','[{0,1002011053,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,8}]',150),(31091003,'项链','10阶粉色项链【通用】',2,'[{lv,355}]',3,'[{0,38280520,8}]','[1003001043,1003001043,1003001043,1003001043]','[]','[]','[{0,1003001053,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,8}]',150),(31091004,'衣服','10阶粉色衣服【魔剑士】',2,'[{lv,355}]',3,'[{0,38280510,8}]','[1002011043,1004011043,1006011043,1008011043,1010011043,1002021043,1004021043,1006021043,1008021043,1010021043,1002031043,1004031043,1006031043,1008031043,1010031043,1002041043,1004041043,1006041043,1008041043,1010041043]','[]','[]','[{0,1004011053,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,8}]',150),(31091005,'刻痕','10阶粉色刻痕【通用】',2,'[{lv,355}]',3,'[{0,38280520,8}]','[1005001043,1009001043,1005001043,1009001043,1005001043,1009001043,1005001043,1009001043]','[]','[]','[{0,1005001053,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,8}]',150),(31091006,'裤子','10阶粉色裤子【魔剑士】',2,'[{lv,355}]',3,'[{0,38280510,8}]','[1002011043,1004011043,1006011043,1008011043,1010011043,1002021043,1004021043,1006021043,1008021043,1010021043,1002031043,1004031043,1006031043,1008031043,1010031043,1002041043,1004041043,1006041043,1008041043,1010041043]','[]','[]','[{0,1006011053,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,8}]',150),(31091007,'副手','10阶粉色副手【魔剑士】',2,'[{lv,355}]',3,'[{0,38280520,8}]','[1001011043,1007011043,1001021043,1007021043,1001031043,1007031043,1001041043,1007041043]','[]','[]','[{0,1007011053,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,8}]',150),(31091008,'护腕','10阶粉色护腕【魔剑士】',2,'[{lv,355}]',3,'[{0,38280510,8}]','[1002011043,1004011043,1006011043,1008011043,1010011043,1002021043,1004021043,1006021043,1008021043,1010021043,1002031043,1004031043,1006031043,1008031043,1010031043,1002041043,1004041043,1006041043,1008041043,1010041043]','[]','[]','[{0,1008011053,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,8}]',150),(31091009,'戒指','10阶粉色戒指【通用】',2,'[{lv,355}]',3,'[{0,38280520,8}]','[1005001043,1009001043,1005001043,1009001043,1005001043,1009001043,1005001043,1009001043]','[]','[]','[{0,1009001053,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,8}]',150),(31091010,'鞋子','10阶粉色鞋子【魔剑士】',2,'[{lv,355}]',3,'[{0,38280510,8}]','[1002011043,1004011043,1006011043,1008011043,1010011043,1002021043,1004021043,1006021043,1008021043,1010021043,1002031043,1004031043,1006031043,1008031043,1010031043,1002041043,1004041043,1006041043,1008041043,1010041043]','[]','[]','[{0,1010011053,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,8}]',150),(31091101,'武器','11阶粉色武器【魔剑士】',2,'[{lv,400}]',3,'[{0,38280520,12}]','[1001011143,1007011143,1001021143,1007021143,1001031143,1007031143,1001041143,1007041143]','[]','[]','[{0,1001011153,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,12}]',150),(31091102,'头盔','11阶粉色头盔【魔剑士】',2,'[{lv,400}]',3,'[{0,38280510,12}]','[1002011143,1004011143,1006011143,1008011143,1010011143,1002021143,1004021143,1006021143,1008021143,1010021143,1002031143,1004031143,1006031143,1008031143,1010031143,1002041143,1004041143,1006041143,1008041143,1010041143]','[]','[]','[{0,1002011153,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,12}]',150),(31091103,'项链','11阶粉色项链【通用】',2,'[{lv,400}]',3,'[{0,38280520,12}]','[1003001143,1003001143,1003001143,1003001143]','[]','[]','[{0,1003001153,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,12}]',150),(31091104,'衣服','11阶粉色衣服【魔剑士】',2,'[{lv,400}]',3,'[{0,38280510,12}]','[1002011143,1004011143,1006011143,1008011143,1010011143,1002021143,1004021143,1006021143,1008021143,1010021143,1002031143,1004031143,1006031143,1008031143,1010031143,1002041143,1004041143,1006041143,1008041143,1010041143]','[]','[]','[{0,1004011153,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,12}]',150),(31091105,'刻痕','11阶粉色刻痕【通用】',2,'[{lv,400}]',3,'[{0,38280520,12}]','[1005001143,1009001143,1005001143,1009001143,1005001143,1009001143,1005001143,1009001143]','[]','[]','[{0,1005001153,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,12}]',150),(31091106,'裤子','11阶粉色裤子【魔剑士】',2,'[{lv,400}]',3,'[{0,38280510,12}]','[1002011143,1004011143,1006011143,1008011143,1010011143,1002021143,1004021143,1006021143,1008021143,1010021143,1002031143,1004031143,1006031143,1008031143,1010031143,1002041143,1004041143,1006041143,1008041143,1010041143]','[]','[]','[{0,1006011153,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,12}]',150),(31091107,'副手','11阶粉色副手【魔剑士】',2,'[{lv,400}]',3,'[{0,38280520,12}]','[1001011143,1007011143,1001021143,1007021143,1001031143,1007031143,1001041143,1007041143]','[]','[]','[{0,1007011153,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,12}]',150),(31091108,'护腕','11阶粉色护腕【魔剑士】',2,'[{lv,400}]',3,'[{0,38280510,12}]','[1002011143,1004011143,1006011143,1008011143,1010011143,1002021143,1004021143,1006021143,1008021143,1010021143,1002031143,1004031143,1006031143,1008031143,1010031143,1002041143,1004041143,1006041143,1008041143,1010041143]','[]','[]','[{0,1008011153,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,12}]',150),(31091109,'戒指','11阶粉色戒指【通用】',2,'[{lv,400}]',3,'[{0,38280520,12}]','[1005001143,1009001143,1005001143,1009001143,1005001143,1009001143,1005001143,1009001143]','[]','[]','[{0,1009001153,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,12}]',150),(31091110,'鞋子','11阶粉色鞋子【魔剑士】',2,'[{lv,400}]',3,'[{0,38280510,12}]','[1002011143,1004011143,1006011143,1008011143,1010011143,1002021143,1004021143,1006021143,1008021143,1010021143,1002031143,1004031143,1006031143,1008031143,1010031143,1002041143,1004041143,1006041143,1008041143,1010041143]','[]','[]','[{0,1010011153,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,12}]',150),(31091201,'武器','12阶粉色武器【魔剑士】',2,'[{lv,500}]',3,'[{0,38280520,16}]','[1001011243,1007011243,1001021243,1007021243,1001031243,1007031243,1001041243,1007041243]','[]','[]','[{0,1001011253,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,16}]',150),(31091202,'头盔','12阶粉色头盔【魔剑士】',2,'[{lv,500}]',3,'[{0,38280510,16}]','[1002011243,1004011243,1006011243,1008011243,1010011243,1002021243,1004021243,1006021243,1008021243,1010021243,1002031243,1004031243,1006031243,1008031243,1010031243,1002041243,1004041243,1006041243,1008041243,1010041243]','[]','[]','[{0,1002011253,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,16}]',150),(31091203,'项链','12阶粉色项链【通用】',2,'[{lv,500}]',3,'[{0,38280520,16}]','[1003001243,1003001243,1003001243,1003001243]','[]','[]','[{0,1003001253,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,16}]',150),(31091204,'衣服','12阶粉色衣服【魔剑士】',2,'[{lv,500}]',3,'[{0,38280510,16}]','[1002011243,1004011243,1006011243,1008011243,1010011243,1002021243,1004021243,1006021243,1008021243,1010021243,1002031243,1004031243,1006031243,1008031243,1010031243,1002041243,1004041243,1006041243,1008041243,1010041243]','[]','[]','[{0,1004011253,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,16}]',150),(31091205,'刻痕','12阶粉色刻痕【通用】',2,'[{lv,500}]',3,'[{0,38280520,16}]','[1005001243,1009001243,1005001243,1009001243,1005001243,1009001243,1005001243,1009001243]','[]','[]','[{0,1005001253,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,16}]',150),(31091206,'裤子','12阶粉色裤子【魔剑士】',2,'[{lv,500}]',3,'[{0,38280510,16}]','[1002011243,1004011243,1006011243,1008011243,1010011243,1002021243,1004021243,1006021243,1008021243,1010021243,1002031243,1004031243,1006031243,1008031243,1010031243,1002041243,1004041243,1006041243,1008041243,1010041243]','[]','[]','[{0,1006011253,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,16}]',150),(31091207,'副手','12阶粉色副手【魔剑士】',2,'[{lv,500}]',3,'[{0,38280520,16}]','[1001011243,1007011243,1001021243,1007021243,1001031243,1007031243,1001041243,1007041243]','[]','[]','[{0,1007011253,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,16}]',150),(31091208,'护腕','12阶粉色护腕【魔剑士】',2,'[{lv,500}]',3,'[{0,38280510,16}]','[1002011243,1004011243,1006011243,1008011243,1010011243,1002021243,1004021243,1006021243,1008021243,1010021243,1002031243,1004031243,1006031243,1008031243,1010031243,1002041243,1004041243,1006041243,1008041243,1010041243]','[]','[]','[{0,1008011253,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,16}]',150),(31091209,'戒指','12阶粉色戒指【通用】',2,'[{lv,500}]',3,'[{0,38280520,16}]','[1005001243,1009001243,1005001243,1009001243,1005001243,1009001243,1005001243,1009001243]','[]','[]','[{0,1009001253,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,16}]',150),(31091210,'鞋子','12阶粉色鞋子【魔剑士】',2,'[{lv,500}]',3,'[{0,38280510,16}]','[1002011243,1004011243,1006011243,1008011243,1010011243,1002021243,1004021243,1006021243,1008021243,1010021243,1002031243,1004031243,1006031243,1008031243,1010031243,1002041243,1004041243,1006041243,1008041243,1010041243]','[]','[]','[{0,1010011253,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,16}]',150),(31091301,'武器','13阶粉色武器【魔剑士】',2,'[{lv,520}]',3,'[{0,38280520,20}]','[1001011343,1007011343,1001021343,1007021343,1001031343,1007031343,1001041343,1007041343]','[]','[]','[{0,1001011353,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,20}]',150),(31091302,'头盔','13阶粉色头盔【魔剑士】',2,'[{lv,520}]',3,'[{0,38280510,20}]','[1002011343,1004011343,1006011343,1008011343,1010011343,1002021343,1004021343,1006021343,1008021343,1010021343,1002031343,1004031343,1006031343,1008031343,1010031343,1002041343,1004041343,1006041343,1008041343,1010041343]','[]','[]','[{0,1002011353,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,20}]',150),(31091303,'项链','13阶粉色项链【通用】',2,'[{lv,520}]',3,'[{0,38280520,20}]','[1003001343,1003001343,1003001343,1003001343]','[]','[]','[{0,1003001353,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,20}]',150),(31091304,'衣服','13阶粉色衣服【魔剑士】',2,'[{lv,520}]',3,'[{0,38280510,20}]','[1002011343,1004011343,1006011343,1008011343,1010011343,1002021343,1004021343,1006021343,1008021343,1010021343,1002031343,1004031343,1006031343,1008031343,1010031343,1002041343,1004041343,1006041343,1008041343,1010041343]','[]','[]','[{0,1004011353,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,20}]',150),(31091305,'刻痕','13阶粉色刻痕【通用】',2,'[{lv,520}]',3,'[{0,38280520,20}]','[1005001343,1009001343,1005001343,1009001343,1005001343,1009001343,1005001343,1009001343]','[]','[]','[{0,1005001353,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,20}]',150),(31091306,'裤子','13阶粉色裤子【魔剑士】',2,'[{lv,520}]',3,'[{0,38280510,20}]','[1002011343,1004011343,1006011343,1008011343,1010011343,1002021343,1004021343,1006021343,1008021343,1010021343,1002031343,1004031343,1006031343,1008031343,1010031343,1002041343,1004041343,1006041343,1008041343,1010041343]','[]','[]','[{0,1006011353,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,20}]',150),(31091307,'副手','13阶粉色副手【魔剑士】',2,'[{lv,520}]',3,'[{0,38280520,20}]','[1001011343,1007011343,1001021343,1007021343,1001031343,1007031343,1001041343,1007041343]','[]','[]','[{0,1007011353,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,20}]',150),(31091308,'护腕','13阶粉色护腕【魔剑士】',2,'[{lv,520}]',3,'[{0,38280510,20}]','[1002011343,1004011343,1006011343,1008011343,1010011343,1002021343,1004021343,1006021343,1008021343,1010021343,1002031343,1004031343,1006031343,1008031343,1010031343,1002041343,1004041343,1006041343,1008041343,1010041343]','[]','[]','[{0,1008011353,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,20}]',150),(31091309,'戒指','13阶粉色戒指【通用】',2,'[{lv,520}]',3,'[{0,38280520,20}]','[1005001343,1009001343,1005001343,1009001343,1005001343,1009001343,1005001343,1009001343]','[]','[]','[{0,1009001353,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,20}]',150),(31091310,'鞋子','13阶粉色鞋子【魔剑士】',2,'[{lv,520}]',3,'[{0,38280510,20}]','[1002011343,1004011343,1006011343,1008011343,1010011343,1002021343,1004021343,1006021343,1008021343,1010021343,1002031343,1004031343,1006031343,1008031343,1010031343,1002041343,1004041343,1006041343,1008041343,1010041343]','[]','[]','[{0,1010011353,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,20}]',150),(31091401,'武器','14阶粉色武器【魔剑士】',2,'[{lv,620}]',3,'[{0,38280520,25}]','[1001011443,1007011443,1001021443,1007021443,1001031443,1007031443,1001041443,1007041443]','[]','[]','[{0,1001011453,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,25}]',150),(31091402,'头盔','14阶粉色头盔【魔剑士】',2,'[{lv,620}]',3,'[{0,38280510,25}]','[1002011443,1004011443,1006011443,1008011443,1010011443,1002021443,1004021443,1006021443,1008021443,1010021443,1002031443,1004031443,1006031443,1008031443,1010031443,1002041443,1004041443,1006041443,1008041443,1010041443]','[]','[]','[{0,1002011453,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,25}]',150),(31091403,'项链','14阶粉色项链【通用】',2,'[{lv,620}]',3,'[{0,38280520,25}]','[1003001443,1003001443,1003001443,1003001443]','[]','[]','[{0,1003001453,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,25}]',150),(31091404,'衣服','14阶粉色衣服【魔剑士】',2,'[{lv,620}]',3,'[{0,38280510,25}]','[1002011443,1004011443,1006011443,1008011443,1010011443,1002021443,1004021443,1006021443,1008021443,1010021443,1002031443,1004031443,1006031443,1008031443,1010031443,1002041443,1004041443,1006041443,1008041443,1010041443]','[]','[]','[{0,1004011453,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,25}]',150),(31091405,'刻痕','14阶粉色刻痕【通用】',2,'[{lv,620}]',3,'[{0,38280520,25}]','[1005001443,1009001443,1005001443,1009001443,1005001443,1009001443,1005001443,1009001443]','[]','[]','[{0,1005001453,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,25}]',150),(31091406,'裤子','14阶粉色裤子【魔剑士】',2,'[{lv,620}]',3,'[{0,38280510,25}]','[1002011443,1004011443,1006011443,1008011443,1010011443,1002021443,1004021443,1006021443,1008021443,1010021443,1002031443,1004031443,1006031443,1008031443,1010031443,1002041443,1004041443,1006041443,1008041443,1010041443]','[]','[]','[{0,1006011453,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,25}]',150),(31091407,'副手','14阶粉色副手【魔剑士】',2,'[{lv,620}]',3,'[{0,38280520,25}]','[1001011443,1007011443,1001021443,1007021443,1001031443,1007031443,1001041443,1007041443]','[]','[]','[{0,1007011453,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,25}]',150),(31091408,'护腕','14阶粉色护腕【魔剑士】',2,'[{lv,620}]',3,'[{0,38280510,25}]','[1002011443,1004011443,1006011443,1008011443,1010011443,1002021443,1004021443,1006021443,1008021443,1010021443,1002031443,1004031443,1006031443,1008031443,1010031443,1002041443,1004041443,1006041443,1008041443,1010041443]','[]','[]','[{0,1008011453,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,25}]',150),(31091409,'戒指','14阶粉色戒指【通用】',2,'[{lv,620}]',3,'[{0,38280520,25}]','[1005001443,1009001443,1005001443,1009001443,1005001443,1009001443,1005001443,1009001443]','[]','[]','[{0,1009001453,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,25}]',150),(31091410,'鞋子','14阶粉色鞋子【魔剑士】',2,'[{lv,620}]',3,'[{0,38280510,25}]','[1002011443,1004011443,1006011443,1008011443,1010011443,1002021443,1004021443,1006021443,1008021443,1010021443,1002031443,1004031443,1006031443,1008031443,1010031443,1002041443,1004041443,1006041443,1008041443,1010041443]','[]','[]','[{0,1010011453,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,25}]',150),(31091501,'武器','15阶粉色武器【魔剑士】',2,'[{lv,650}]',3,'[{0,38280520,30}]','[1001011543,1007011543,1001021543,1007021543,1001031543,1007031543,1001041543,1007041543]','[]','[]','[{0,1001011553,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,30}]',150),(31091502,'头盔','15阶粉色头盔【魔剑士】',2,'[{lv,650}]',3,'[{0,38280510,30}]','[1002011543,1004011543,1006011543,1008011543,1010011543,1002021543,1004021543,1006021543,1008021543,1010021543,1002031543,1004031543,1006031543,1008031543,1010031543,1002041543,1004041543,1006041543,1008041543,1010041543]','[]','[]','[{0,1002011553,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,30}]',150),(31091503,'项链','15阶粉色项链【通用】',2,'[{lv,650}]',3,'[{0,38280520,30}]','[1003001543,1003001543,1003001543,1003001543]','[]','[]','[{0,1003001553,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,30}]',150),(31091504,'衣服','15阶粉色衣服【魔剑士】',2,'[{lv,650}]',3,'[{0,38280510,30}]','[1002011543,1004011543,1006011543,1008011543,1010011543,1002021543,1004021543,1006021543,1008021543,1010021543,1002031543,1004031543,1006031543,1008031543,1010031543,1002041543,1004041543,1006041543,1008041543,1010041543]','[]','[]','[{0,1004011553,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,30}]',150),(31091505,'刻痕','15阶粉色刻痕【通用】',2,'[{lv,650}]',3,'[{0,38280520,30}]','[1005001543,1009001543,1005001543,1009001543,1005001543,1009001543,1005001543,1009001543]','[]','[]','[{0,1005001553,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,30}]',150),(31091506,'裤子','15阶粉色裤子【魔剑士】',2,'[{lv,650}]',3,'[{0,38280510,30}]','[1002011543,1004011543,1006011543,1008011543,1010011543,1002021543,1004021543,1006021543,1008021543,1010021543,1002031543,1004031543,1006031543,1008031543,1010031543,1002041543,1004041543,1006041543,1008041543,1010041543]','[]','[]','[{0,1006011553,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,30}]',150),(31091507,'副手','15阶粉色副手【魔剑士】',2,'[{lv,650}]',3,'[{0,38280520,30}]','[1001011543,1007011543,1001021543,1007021543,1001031543,1007031543,1001041543,1007041543]','[]','[]','[{0,1007011553,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,30}]',150),(31091508,'护腕','15阶粉色护腕【魔剑士】',2,'[{lv,650}]',3,'[{0,38280510,30}]','[1002011543,1004011543,1006011543,1008011543,1010011543,1002021543,1004021543,1006021543,1008021543,1010021543,1002031543,1004031543,1006031543,1008031543,1010031543,1002041543,1004041543,1006041543,1008041543,1010041543]','[]','[]','[{0,1008011553,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,30}]',150),(31091509,'戒指','15阶粉色戒指【通用】',2,'[{lv,650}]',3,'[{0,38280520,30}]','[1005001543,1009001543,1005001543,1009001543,1005001543,1009001543,1005001543,1009001543]','[]','[]','[{0,1009001553,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,30}]',150),(31091510,'鞋子','15阶粉色鞋子【魔剑士】',2,'[{lv,650}]',3,'[{0,38280510,30}]','[1002011543,1004011543,1006011543,1008011543,1010011543,1002021543,1004021543,1006021543,1008021543,1010021543,1002031543,1004031543,1006031543,1008031543,1010031543,1002041543,1004041543,1006041543,1008041543,1010041543]','[]','[]','[{0,1010011553,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,30}]',150),(31091601,'武器','16阶粉色武器【魔剑士】',2,'[{lv,700}]',3,'[{0,38280520,35}]','[1001011643,1007011643,1001021643,1007021643,1001031643,1007031643,1001041643,1007041643]','[]','[]','[{0,1001011653,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,35}]',150),(31091602,'头盔','16阶粉色头盔【魔剑士】',2,'[{lv,700}]',3,'[{0,38280510,35}]','[1002011643,1004011643,1006011643,1008011643,1010011643,1002021643,1004021643,1006021643,1008021643,1010021643,1002031643,1004031643,1006031643,1008031643,1010031643,1002041643,1004041643,1006041643,1008041643,1010041643]','[]','[]','[{0,1002011653,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,35}]',150),(31091603,'项链','16阶粉色项链【通用】',2,'[{lv,700}]',3,'[{0,38280520,35}]','[1003001643,1003001643,1003001643,1003001643]','[]','[]','[{0,1003001653,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,35}]',150),(31091604,'衣服','16阶粉色衣服【魔剑士】',2,'[{lv,700}]',3,'[{0,38280510,35}]','[1002011643,1004011643,1006011643,1008011643,1010011643,1002021643,1004021643,1006021643,1008021643,1010021643,1002031643,1004031643,1006031643,1008031643,1010031643,1002041643,1004041643,1006041643,1008041643,1010041643]','[]','[]','[{0,1004011653,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,35}]',150),(31091605,'刻痕','16阶粉色刻痕【通用】',2,'[{lv,700}]',3,'[{0,38280520,35}]','[1005001643,1009001643,1005001643,1009001643,1005001643,1009001643,1005001643,1009001643]','[]','[]','[{0,1005001653,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,35}]',150),(31091606,'裤子','16阶粉色裤子【魔剑士】',2,'[{lv,700}]',3,'[{0,38280510,35}]','[1002011643,1004011643,1006011643,1008011643,1010011643,1002021643,1004021643,1006021643,1008021643,1010021643,1002031643,1004031643,1006031643,1008031643,1010031643,1002041643,1004041643,1006041643,1008041643,1010041643]','[]','[]','[{0,1006011653,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,35}]',150),(31091607,'副手','16阶粉色副手【魔剑士】',2,'[{lv,700}]',3,'[{0,38280520,35}]','[1001011643,1007011643,1001021643,1007021643,1001031643,1007031643,1001041643,1007041643]','[]','[]','[{0,1007011653,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,35}]',150),(31091608,'护腕','16阶粉色护腕【魔剑士】',2,'[{lv,700}]',3,'[{0,38280510,35}]','[1002011643,1004011643,1006011643,1008011643,1010011643,1002021643,1004021643,1006021643,1008021643,1010021643,1002031643,1004031643,1006031643,1008031643,1010031643,1002041643,1004041643,1006041643,1008041643,1010041643]','[]','[]','[{0,1008011653,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,35}]',150),(31091609,'戒指','16阶粉色戒指【通用】',2,'[{lv,700}]',3,'[{0,38280520,35}]','[1005001643,1009001643,1005001643,1009001643,1005001643,1009001643,1005001643,1009001643]','[]','[]','[{0,1009001653,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,35}]',150),(31091610,'鞋子','16阶粉色鞋子【魔剑士】',2,'[{lv,700}]',3,'[{0,38280510,35}]','[1002011643,1004011643,1006011643,1008011643,1010011643,1002021643,1004021643,1006021643,1008021643,1010021643,1002031643,1004031643,1006031643,1008031643,1010031643,1002041643,1004041643,1006041643,1008041643,1010041643]','[]','[]','[{0,1010011653,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,35}]',150),(31100301,'武器','3阶神装武器【魔剑士】',2,'[{lv,9999}]',3,'[{0,38280620,2}]','[1001010263,1007010263,1001020263,1007020263,1001030263,1007030263,1001040263,1007040263]','[]','[]','[{0,1001010363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100302,'头盔','3阶神装头盔【魔剑士】',2,'[{lv,9999}]',3,'[{0,38280620,2}]','[1002010263,1004010263,1006010263,1008010263,1010010263,1002020263,1004020263,1006020263,1008020263,1010020263,1002030263,1004030263,1006030263,1008030263,1010030263,1002040263,1004040263,1006040263,1008040263,1010040263]','[]','[]','[{0,1002010363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100303,'项链','3阶神装项链【通用】',2,'[{lv,9999}]',3,'[{0,38280620,2}]','[1003000263,1003000263,1003000263,1003000263]','[]','[]','[{0,1003000363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100304,'衣服','3阶神装衣服【魔剑士】',2,'[{lv,9999}]',3,'[{0,38280620,2}]','[1002010263,1004010263,1006010263,1008010263,1010010263,1002020263,1004020263,1006020263,1008020263,1010020263,1002030263,1004030263,1006030263,1008030263,1010030263,1002040263,1004040263,1006040263,1008040263,1010040263]','[]','[]','[{0,1004010363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100305,'刻痕','3阶神装刻痕【通用】',2,'[{lv,9999}]',3,'[{0,38280620,2}]','[1005000263,1009000263,1005000263,1009000263,1005000263,1009000263,1005000263,1009000263]','[]','[]','[{0,1005000363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100306,'裤子','3阶神装裤子【魔剑士】',2,'[{lv,9999}]',3,'[{0,38280620,2}]','[1002010263,1004010263,1006010263,1008010263,1010010263,1002020263,1004020263,1006020263,1008020263,1010020263,1002030263,1004030263,1006030263,1008030263,1010030263,1002040263,1004040263,1006040263,1008040263,1010040263]','[]','[]','[{0,1006010363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100307,'副手','3阶神装副手【魔剑士】',2,'[{lv,9999}]',3,'[{0,38280620,2}]','[1001010263,1007010263,1001020263,1007020263,1001030263,1007030263,1001040263,1007040263]','[]','[]','[{0,1007010363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100308,'护腕','3阶神装护腕【魔剑士】',2,'[{lv,9999}]',3,'[{0,38280620,2}]','[1002010263,1004010263,1006010263,1008010263,1010010263,1002020263,1004020263,1006020263,1008020263,1010020263,1002030263,1004030263,1006030263,1008030263,1010030263,1002040263,1004040263,1006040263,1008040263,1010040263]','[]','[]','[{0,1008010363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100309,'戒指','3阶神装戒指【通用】',2,'[{lv,9999}]',3,'[{0,38280620,2}]','[1005000263,1009000263,1005000263,1009000263,1005000263,1009000263,1005000263,1009000263]','[]','[]','[{0,1009000363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100310,'鞋子','3阶神装鞋子【魔剑士】',2,'[{lv,9999}]',3,'[{0,38280620,2}]','[1002010263,1004010263,1006010263,1008010263,1010010263,1002020263,1004020263,1006020263,1008020263,1010020263,1002030263,1004030263,1006030263,1008030263,1010030263,1002040263,1004040263,1006040263,1008040263,1010040263]','[]','[]','[{0,1010010363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100401,'武器','4阶神装武器【魔剑士】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1001010363,1007010363,1001020363,1007020363,1001030363,1007030363,1001040363,1007040363]','[]','[]','[{0,1001010463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100402,'头盔','4阶神装头盔【魔剑士】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1002010363,1004010363,1006010363,1008010363,1010010363,1002020363,1004020363,1006020363,1008020363,1010020363,1002030363,1004030363,1006030363,1008030363,1010030363,1002040363,1004040363,1006040363,1008040363,1010040363]','[]','[]','[{0,1002010463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100403,'项链','4阶神装项链【通用】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1003000363,1003000363,1003000363,1003000363]','[]','[]','[{0,1003000463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100404,'衣服','4阶神装衣服【魔剑士】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1002010363,1004010363,1006010363,1008010363,1010010363,1002020363,1004020363,1006020363,1008020363,1010020363,1002030363,1004030363,1006030363,1008030363,1010030363,1002040363,1004040363,1006040363,1008040363,1010040363]','[]','[]','[{0,1004010463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100405,'刻痕','4阶神装刻痕【通用】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1005000363,1009000363,1005000363,1009000363,1005000363,1009000363,1005000363,1009000363]','[]','[]','[{0,1005000463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100406,'裤子','4阶神装裤子【魔剑士】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1002010363,1004010363,1006010363,1008010363,1010010363,1002020363,1004020363,1006020363,1008020363,1010020363,1002030363,1004030363,1006030363,1008030363,1010030363,1002040363,1004040363,1006040363,1008040363,1010040363]','[]','[]','[{0,1006010463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100407,'副手','4阶神装副手【魔剑士】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1001010363,1007010363,1001020363,1007020363,1001030363,1007030363,1001040363,1007040363]','[]','[]','[{0,1007010463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100408,'护腕','4阶神装护腕【魔剑士】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1002010363,1004010363,1006010363,1008010363,1010010363,1002020363,1004020363,1006020363,1008020363,1010020363,1002030363,1004030363,1006030363,1008030363,1010030363,1002040363,1004040363,1006040363,1008040363,1010040363]','[]','[]','[{0,1008010463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100409,'戒指','4阶神装戒指【通用】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1005000363,1009000363,1005000363,1009000363,1005000363,1009000363,1005000363,1009000363]','[]','[]','[{0,1009000463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100410,'鞋子','4阶神装鞋子【魔剑士】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1002010363,1004010363,1006010363,1008010363,1010010363,1002020363,1004020363,1006020363,1008020363,1010020363,1002030363,1004030363,1006030363,1008030363,1010030363,1002040363,1004040363,1006040363,1008040363,1010040363]','[]','[]','[{0,1010010463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100501,'武器','5阶神装武器【魔剑士】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1001010463,1007010463,1001020463,1007020463,1001030463,1007030463,1001040463,1007040463]','[]','[]','[{0,1001010563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100502,'头盔','5阶神装头盔【魔剑士】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1002010463,1004010463,1006010463,1008010463,1010010463,1002020463,1004020463,1006020463,1008020463,1010020463,1002030463,1004030463,1006030463,1008030463,1010030463,1002040463,1004040463,1006040463,1008040463,1010040463]','[]','[]','[{0,1002010563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100503,'项链','5阶神装项链【通用】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1003000463,1003000463,1003000463,1003000463]','[]','[]','[{0,1003000563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100504,'衣服','5阶神装衣服【魔剑士】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1002010463,1004010463,1006010463,1008010463,1010010463,1002020463,1004020463,1006020463,1008020463,1010020463,1002030463,1004030463,1006030463,1008030463,1010030463,1002040463,1004040463,1006040463,1008040463,1010040463]','[]','[]','[{0,1004010563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100505,'刻痕','5阶神装刻痕【通用】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1005000463,1009000463,1005000463,1009000463,1005000463,1009000463,1005000463,1009000463]','[]','[]','[{0,1005000563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100506,'裤子','5阶神装裤子【魔剑士】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1002010463,1004010463,1006010463,1008010463,1010010463,1002020463,1004020463,1006020463,1008020463,1010020463,1002030463,1004030463,1006030463,1008030463,1010030463,1002040463,1004040463,1006040463,1008040463,1010040463]','[]','[]','[{0,1006010563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100507,'副手','5阶神装副手【魔剑士】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1001010463,1007010463,1001020463,1007020463,1001030463,1007030463,1001040463,1007040463]','[]','[]','[{0,1007010563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100508,'护腕','5阶神装护腕【魔剑士】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1002010463,1004010463,1006010463,1008010463,1010010463,1002020463,1004020463,1006020463,1008020463,1010020463,1002030463,1004030463,1006030463,1008030463,1010030463,1002040463,1004040463,1006040463,1008040463,1010040463]','[]','[]','[{0,1008010563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100509,'戒指','5阶神装戒指【通用】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1005000463,1009000463,1005000463,1009000463,1005000463,1009000463,1005000463,1009000463]','[]','[]','[{0,1009000563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100510,'鞋子','5阶神装鞋子【魔剑士】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1002010463,1004010463,1006010463,1008010463,1010010463,1002020463,1004020463,1006020463,1008020463,1010020463,1002030463,1004030463,1006030463,1008030463,1010030463,1002040463,1004040463,1006040463,1008040463,1010040463]','[]','[]','[{0,1010010563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100601,'武器','6阶神装武器【魔剑士】',2,'[{lv,180}]',3,'[{0,38280620,2}]','[1001010563,1007010563,1001020563,1007020563,1001030563,1007030563,1001040563,1007040563]','[]','[]','[{0,1001010663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100602,'头盔','6阶神装头盔【魔剑士】',2,'[{lv,180}]',3,'[{0,38280620,2}]','[1002010563,1004010563,1006010563,1008010563,1010010563,1002020563,1004020563,1006020563,1008020563,1010020563,1002030563,1004030563,1006030563,1008030563,1010030563,1002040563,1004040563,1006040563,1008040563,1010040563]','[]','[]','[{0,1002010663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100603,'项链','6阶神装项链【通用】',2,'[{lv,180}]',3,'[{0,38280620,2}]','[1003000563,1003000563,1003000563,1003000563]','[]','[]','[{0,1003000663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100604,'衣服','6阶神装衣服【魔剑士】',2,'[{lv,180}]',3,'[{0,38280620,2}]','[1002010563,1004010563,1006010563,1008010563,1010010563,1002020563,1004020563,1006020563,1008020563,1010020563,1002030563,1004030563,1006030563,1008030563,1010030563,1002040563,1004040563,1006040563,1008040563,1010040563]','[]','[]','[{0,1004010663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100605,'刻痕','6阶神装刻痕【通用】',2,'[{lv,180}]',3,'[{0,38280620,2}]','[1005000563,1009000563,1005000563,1009000563,1005000563,1009000563,1005000563,1009000563]','[]','[]','[{0,1005000663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100606,'裤子','6阶神装裤子【魔剑士】',2,'[{lv,180}]',3,'[{0,38280620,2}]','[1002010563,1004010563,1006010563,1008010563,1010010563,1002020563,1004020563,1006020563,1008020563,1010020563,1002030563,1004030563,1006030563,1008030563,1010030563,1002040563,1004040563,1006040563,1008040563,1010040563]','[]','[]','[{0,1006010663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100607,'副手','6阶神装副手【魔剑士】',2,'[{lv,180}]',3,'[{0,38280620,2}]','[1001010563,1007010563,1001020563,1007020563,1001030563,1007030563,1001040563,1007040563]','[]','[]','[{0,1007010663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100608,'护腕','6阶神装护腕【魔剑士】',2,'[{lv,180}]',3,'[{0,38280620,2}]','[1002010563,1004010563,1006010563,1008010563,1010010563,1002020563,1004020563,1006020563,1008020563,1010020563,1002030563,1004030563,1006030563,1008030563,1010030563,1002040563,1004040563,1006040563,1008040563,1010040563]','[]','[]','[{0,1008010663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100609,'戒指','6阶神装戒指【通用】',2,'[{lv,180}]',3,'[{0,38280620,2}]','[1005000563,1009000563,1005000563,1009000563,1005000563,1009000563,1005000563,1009000563]','[]','[]','[{0,1009000663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100610,'鞋子','6阶神装鞋子【魔剑士】',2,'[{lv,180}]',3,'[{0,38280620,2}]','[1002010563,1004010563,1006010563,1008010563,1010010563,1002020563,1004020563,1006020563,1008020563,1010020563,1002030563,1004030563,1006030563,1008030563,1010030563,1002040563,1004040563,1006040563,1008040563,1010040563]','[]','[]','[{0,1010010663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100701,'武器','7阶神装武器【魔剑士】',2,'[{lv,220}]',3,'[{0,38280620,2}]','[1001010663,1007010663,1001020663,1007020663,1001030663,1007030663,1001040663,1007040663]','[]','[]','[{0,1001010763,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100702,'头盔','7阶神装头盔【魔剑士】',2,'[{lv,220}]',3,'[{0,38280620,2}]','[1002010663,1004010663,1006010663,1008010663,1010010663,1002020663,1004020663,1006020663,1008020663,1010020663,1002030663,1004030663,1006030663,1008030663,1010030663,1002040663,1004040663,1006040663,1008040663,1010040663]','[]','[]','[{0,1002010763,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100703,'项链','7阶神装项链【通用】',2,'[{lv,220}]',3,'[{0,38280620,2}]','[1003000663,1003000663,1003000663,1003000663]','[]','[]','[{0,1003000763,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100704,'衣服','7阶神装衣服【魔剑士】',2,'[{lv,220}]',3,'[{0,38280620,2}]','[1002010663,1004010663,1006010663,1008010663,1010010663,1002020663,1004020663,1006020663,1008020663,1010020663,1002030663,1004030663,1006030663,1008030663,1010030663,1002040663,1004040663,1006040663,1008040663,1010040663]','[]','[]','[{0,1004010763,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100705,'刻痕','7阶神装刻痕【通用】',2,'[{lv,220}]',3,'[{0,38280620,2}]','[1005000663,1009000663,1005000663,1009000663,1005000663,1009000663,1005000663,1009000663]','[]','[]','[{0,1005000763,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100706,'裤子','7阶神装裤子【魔剑士】',2,'[{lv,220}]',3,'[{0,38280620,2}]','[1002010663,1004010663,1006010663,1008010663,1010010663,1002020663,1004020663,1006020663,1008020663,1010020663,1002030663,1004030663,1006030663,1008030663,1010030663,1002040663,1004040663,1006040663,1008040663,1010040663]','[]','[]','[{0,1006010763,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100707,'副手','7阶神装副手【魔剑士】',2,'[{lv,220}]',3,'[{0,38280620,2}]','[1001010663,1007010663,1001020663,1007020663,1001030663,1007030663,1001040663,1007040663]','[]','[]','[{0,1007010763,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100708,'护腕','7阶神装护腕【魔剑士】',2,'[{lv,220}]',3,'[{0,38280620,2}]','[1002010663,1004010663,1006010663,1008010663,1010010663,1002020663,1004020663,1006020663,1008020663,1010020663,1002030663,1004030663,1006030663,1008030663,1010030663,1002040663,1004040663,1006040663,1008040663,1010040663]','[]','[]','[{0,1008010763,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100709,'戒指','7阶神装戒指【通用】',2,'[{lv,220}]',3,'[{0,38280620,2}]','[1005000663,1009000663,1005000663,1009000663,1005000663,1009000663,1005000663,1009000663]','[]','[]','[{0,1009000763,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100710,'鞋子','7阶神装鞋子【魔剑士】',2,'[{lv,220}]',3,'[{0,38280620,2}]','[1002010663,1004010663,1006010663,1008010663,1010010663,1002020663,1004020663,1006020663,1008020663,1010020663,1002030663,1004030663,1006030663,1008030663,1010030663,1002040663,1004040663,1006040663,1008040663,1010040663]','[]','[]','[{0,1010010763,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100801,'武器','8阶神装武器【魔剑士】',2,'[{lv,260}]',3,'[{0,38280620,2}]','[1001010763,1007010763,1001020763,1007020763,1001030763,1007030763,1001040763,1007040763]','[]','[]','[{0,1001010863,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100802,'头盔','8阶神装头盔【魔剑士】',2,'[{lv,260}]',3,'[{0,38280620,2}]','[1002010763,1004010763,1006010763,1008010763,1010010763,1002020763,1004020763,1006020763,1008020763,1010020763,1002030763,1004030763,1006030763,1008030763,1010030763,1002040763,1004040763,1006040763,1008040763,1010040763]','[]','[]','[{0,1002010863,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100803,'项链','8阶神装项链【通用】',2,'[{lv,260}]',3,'[{0,38280620,2}]','[1003000763,1003000763,1003000763,1003000763]','[]','[]','[{0,1003000863,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100804,'衣服','8阶神装衣服【魔剑士】',2,'[{lv,260}]',3,'[{0,38280620,2}]','[1002010763,1004010763,1006010763,1008010763,1010010763,1002020763,1004020763,1006020763,1008020763,1010020763,1002030763,1004030763,1006030763,1008030763,1010030763,1002040763,1004040763,1006040763,1008040763,1010040763]','[]','[]','[{0,1004010863,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100805,'刻痕','8阶神装刻痕【通用】',2,'[{lv,260}]',3,'[{0,38280620,2}]','[1005000763,1009000763,1005000763,1009000763,1005000763,1009000763,1005000763,1009000763]','[]','[]','[{0,1005000863,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100806,'裤子','8阶神装裤子【魔剑士】',2,'[{lv,260}]',3,'[{0,38280620,2}]','[1002010763,1004010763,1006010763,1008010763,1010010763,1002020763,1004020763,1006020763,1008020763,1010020763,1002030763,1004030763,1006030763,1008030763,1010030763,1002040763,1004040763,1006040763,1008040763,1010040763]','[]','[]','[{0,1006010863,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100807,'副手','8阶神装副手【魔剑士】',2,'[{lv,260}]',3,'[{0,38280620,2}]','[1001010763,1007010763,1001020763,1007020763,1001030763,1007030763,1001040763,1007040763]','[]','[]','[{0,1007010863,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100808,'护腕','8阶神装护腕【魔剑士】',2,'[{lv,260}]',3,'[{0,38280620,2}]','[1002010763,1004010763,1006010763,1008010763,1010010763,1002020763,1004020763,1006020763,1008020763,1010020763,1002030763,1004030763,1006030763,1008030763,1010030763,1002040763,1004040763,1006040763,1008040763,1010040763]','[]','[]','[{0,1008010863,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100809,'戒指','8阶神装戒指【通用】',2,'[{lv,260}]',3,'[{0,38280620,2}]','[1005000763,1009000763,1005000763,1009000763,1005000763,1009000763,1005000763,1009000763]','[]','[]','[{0,1009000863,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100810,'鞋子','8阶神装鞋子【魔剑士】',2,'[{lv,260}]',3,'[{0,38280620,2}]','[1002010763,1004010763,1006010763,1008010763,1010010763,1002020763,1004020763,1006020763,1008020763,1010020763,1002030763,1004030763,1006030763,1008030763,1010030763,1002040763,1004040763,1006040763,1008040763,1010040763]','[]','[]','[{0,1010010863,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100901,'武器','9阶神装武器【魔剑士】',2,'[{lv,300}]',3,'[{0,38280620,2}]','[1001010863,1007010863,1001020863,1007020863,1001030863,1007030863,1001040863,1007040863]','[]','[]','[{0,1001010963,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100902,'头盔','9阶神装头盔【魔剑士】',2,'[{lv,300}]',3,'[{0,38280620,2}]','[1002010863,1004010863,1006010863,1008010863,1010010863,1002020863,1004020863,1006020863,1008020863,1010020863,1002030863,1004030863,1006030863,1008030863,1010030863,1002040863,1004040863,1006040863,1008040863,1010040863]','[]','[]','[{0,1002010963,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100903,'项链','9阶神装项链【通用】',2,'[{lv,300}]',3,'[{0,38280620,2}]','[1003000863,1003000863,1003000863,1003000863]','[]','[]','[{0,1003000963,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100904,'衣服','9阶神装衣服【魔剑士】',2,'[{lv,300}]',3,'[{0,38280620,2}]','[1002010863,1004010863,1006010863,1008010863,1010010863,1002020863,1004020863,1006020863,1008020863,1010020863,1002030863,1004030863,1006030863,1008030863,1010030863,1002040863,1004040863,1006040863,1008040863,1010040863]','[]','[]','[{0,1004010963,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100905,'刻痕','9阶神装刻痕【通用】',2,'[{lv,300}]',3,'[{0,38280620,2}]','[1005000863,1009000863,1005000863,1009000863,1005000863,1009000863,1005000863,1009000863]','[]','[]','[{0,1005000963,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100906,'裤子','9阶神装裤子【魔剑士】',2,'[{lv,300}]',3,'[{0,38280620,2}]','[1002010863,1004010863,1006010863,1008010863,1010010863,1002020863,1004020863,1006020863,1008020863,1010020863,1002030863,1004030863,1006030863,1008030863,1010030863,1002040863,1004040863,1006040863,1008040863,1010040863]','[]','[]','[{0,1006010963,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100907,'副手','9阶神装副手【魔剑士】',2,'[{lv,300}]',3,'[{0,38280620,2}]','[1001010863,1007010863,1001020863,1007020863,1001030863,1007030863,1001040863,1007040863]','[]','[]','[{0,1007010963,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100908,'护腕','9阶神装护腕【魔剑士】',2,'[{lv,300}]',3,'[{0,38280620,2}]','[1002010863,1004010863,1006010863,1008010863,1010010863,1002020863,1004020863,1006020863,1008020863,1010020863,1002030863,1004030863,1006030863,1008030863,1010030863,1002040863,1004040863,1006040863,1008040863,1010040863]','[]','[]','[{0,1008010963,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100909,'戒指','9阶神装戒指【通用】',2,'[{lv,300}]',3,'[{0,38280620,2}]','[1005000863,1009000863,1005000863,1009000863,1005000863,1009000863,1005000863,1009000863]','[]','[]','[{0,1009000963,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31100910,'鞋子','9阶神装鞋子【魔剑士】',2,'[{lv,300}]',3,'[{0,38280620,2}]','[1002010863,1004010863,1006010863,1008010863,1010010863,1002020863,1004020863,1006020863,1008020863,1010020863,1002030863,1004030863,1006030863,1008030863,1010030863,1002040863,1004040863,1006040863,1008040863,1010040863]','[]','[]','[{0,1010010963,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101001,'武器','10阶神装武器【魔剑士】',2,'[{lv,355}]',3,'[{0,38280620,2}]','[1001010963,1007010963,1001020963,1007020963,1001030963,1007030963,1001040963,1007040963]','[]','[]','[{0,1001011063,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101002,'头盔','10阶神装头盔【魔剑士】',2,'[{lv,355}]',3,'[{0,38280620,2}]','[1002010963,1004010963,1006010963,1008010963,1010010963,1002020963,1004020963,1006020963,1008020963,1010020963,1002030963,1004030963,1006030963,1008030963,1010030963,1002040963,1004040963,1006040963,1008040963,1010040963]','[]','[]','[{0,1002011063,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101003,'项链','10阶神装项链【通用】',2,'[{lv,355}]',3,'[{0,38280620,2}]','[1003000963,1003000963,1003000963,1003000963]','[]','[]','[{0,1003001063,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101004,'衣服','10阶神装衣服【魔剑士】',2,'[{lv,355}]',3,'[{0,38280620,2}]','[1002010963,1004010963,1006010963,1008010963,1010010963,1002020963,1004020963,1006020963,1008020963,1010020963,1002030963,1004030963,1006030963,1008030963,1010030963,1002040963,1004040963,1006040963,1008040963,1010040963]','[]','[]','[{0,1004011063,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101005,'刻痕','10阶神装刻痕【通用】',2,'[{lv,355}]',3,'[{0,38280620,2}]','[1005000963,1009000963,1005000963,1009000963,1005000963,1009000963,1005000963,1009000963]','[]','[]','[{0,1005001063,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101006,'裤子','10阶神装裤子【魔剑士】',2,'[{lv,355}]',3,'[{0,38280620,2}]','[1002010963,1004010963,1006010963,1008010963,1010010963,1002020963,1004020963,1006020963,1008020963,1010020963,1002030963,1004030963,1006030963,1008030963,1010030963,1002040963,1004040963,1006040963,1008040963,1010040963]','[]','[]','[{0,1006011063,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101007,'副手','10阶神装副手【魔剑士】',2,'[{lv,355}]',3,'[{0,38280620,2}]','[1001010963,1007010963,1001020963,1007020963,1001030963,1007030963,1001040963,1007040963]','[]','[]','[{0,1007011063,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101008,'护腕','10阶神装护腕【魔剑士】',2,'[{lv,355}]',3,'[{0,38280620,2}]','[1002010963,1004010963,1006010963,1008010963,1010010963,1002020963,1004020963,1006020963,1008020963,1010020963,1002030963,1004030963,1006030963,1008030963,1010030963,1002040963,1004040963,1006040963,1008040963,1010040963]','[]','[]','[{0,1008011063,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101009,'戒指','10阶神装戒指【通用】',2,'[{lv,355}]',3,'[{0,38280620,2}]','[1005000963,1009000963,1005000963,1009000963,1005000963,1009000963,1005000963,1009000963]','[]','[]','[{0,1009001063,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101010,'鞋子','10阶神装鞋子【魔剑士】',2,'[{lv,355}]',3,'[{0,38280620,2}]','[1002010963,1004010963,1006010963,1008010963,1010010963,1002020963,1004020963,1006020963,1008020963,1010020963,1002030963,1004030963,1006030963,1008030963,1010030963,1002040963,1004040963,1006040963,1008040963,1010040963]','[]','[]','[{0,1010011063,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101101,'武器','11阶神装武器【魔剑士】',2,'[{lv,400}]',3,'[{0,38280620,2}]','[1001011063,1007011063,1001021063,1007021063,1001031063,1007031063,1001041063,1007041063]','[]','[]','[{0,1001011163,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101102,'头盔','11阶神装头盔【魔剑士】',2,'[{lv,400}]',3,'[{0,38280620,2}]','[1002011063,1004011063,1006011063,1008011063,1010011063,1002021063,1004021063,1006021063,1008021063,1010021063,1002031063,1004031063,1006031063,1008031063,1010031063,1002041063,1004041063,1006041063,1008041063,1010041063]','[]','[]','[{0,1002011163,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101103,'项链','11阶神装项链【通用】',2,'[{lv,400}]',3,'[{0,38280620,2}]','[1003001063,1003001063,1003001063,1003001063]','[]','[]','[{0,1003001163,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101104,'衣服','11阶神装衣服【魔剑士】',2,'[{lv,400}]',3,'[{0,38280620,2}]','[1002011063,1004011063,1006011063,1008011063,1010011063,1002021063,1004021063,1006021063,1008021063,1010021063,1002031063,1004031063,1006031063,1008031063,1010031063,1002041063,1004041063,1006041063,1008041063,1010041063]','[]','[]','[{0,1004011163,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101105,'刻痕','11阶神装刻痕【通用】',2,'[{lv,400}]',3,'[{0,38280620,2}]','[1005001063,1009001063,1005001063,1009001063,1005001063,1009001063,1005001063,1009001063]','[]','[]','[{0,1005001163,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101106,'裤子','11阶神装裤子【魔剑士】',2,'[{lv,400}]',3,'[{0,38280620,2}]','[1002011063,1004011063,1006011063,1008011063,1010011063,1002021063,1004021063,1006021063,1008021063,1010021063,1002031063,1004031063,1006031063,1008031063,1010031063,1002041063,1004041063,1006041063,1008041063,1010041063]','[]','[]','[{0,1006011163,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101107,'副手','11阶神装副手【魔剑士】',2,'[{lv,400}]',3,'[{0,38280620,2}]','[1001011063,1007011063,1001021063,1007021063,1001031063,1007031063,1001041063,1007041063]','[]','[]','[{0,1007011163,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101108,'护腕','11阶神装护腕【魔剑士】',2,'[{lv,400}]',3,'[{0,38280620,2}]','[1002011063,1004011063,1006011063,1008011063,1010011063,1002021063,1004021063,1006021063,1008021063,1010021063,1002031063,1004031063,1006031063,1008031063,1010031063,1002041063,1004041063,1006041063,1008041063,1010041063]','[]','[]','[{0,1008011163,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101109,'戒指','11阶神装戒指【通用】',2,'[{lv,400}]',3,'[{0,38280620,2}]','[1005001063,1009001063,1005001063,1009001063,1005001063,1009001063,1005001063,1009001063]','[]','[]','[{0,1009001163,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101110,'鞋子','11阶神装鞋子【魔剑士】',2,'[{lv,400}]',3,'[{0,38280620,2}]','[1002011063,1004011063,1006011063,1008011063,1010011063,1002021063,1004021063,1006021063,1008021063,1010021063,1002031063,1004031063,1006031063,1008031063,1010031063,1002041063,1004041063,1006041063,1008041063,1010041063]','[]','[]','[{0,1010011163,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101201,'武器','12阶神装武器【魔剑士】',2,'[{lv,500}]',3,'[{0,38280620,2}]','[1001011163,1007011163,1001021163,1007021163,1001031163,1007031163,1001041163,1007041163]','[]','[]','[{0,1001011263,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101202,'头盔','12阶神装头盔【魔剑士】',2,'[{lv,500}]',3,'[{0,38280620,2}]','[1002011163,1004011163,1006011163,1008011163,1010011163,1002021163,1004021163,1006021163,1008021163,1010021163,1002031163,1004031163,1006031163,1008031163,1010031163,1002041163,1004041163,1006041163,1008041163,1010041163]','[]','[]','[{0,1002011263,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101203,'项链','12阶神装项链【通用】',2,'[{lv,500}]',3,'[{0,38280620,2}]','[1003001163,1003001163,1003001163,1003001163]','[]','[]','[{0,1003001263,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101204,'衣服','12阶神装衣服【魔剑士】',2,'[{lv,500}]',3,'[{0,38280620,2}]','[1002011163,1004011163,1006011163,1008011163,1010011163,1002021163,1004021163,1006021163,1008021163,1010021163,1002031163,1004031163,1006031163,1008031163,1010031163,1002041163,1004041163,1006041163,1008041163,1010041163]','[]','[]','[{0,1004011263,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101205,'刻痕','12阶神装刻痕【通用】',2,'[{lv,500}]',3,'[{0,38280620,2}]','[1005001163,1009001163,1005001163,1009001163,1005001163,1009001163,1005001163,1009001163]','[]','[]','[{0,1005001263,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101206,'裤子','12阶神装裤子【魔剑士】',2,'[{lv,500}]',3,'[{0,38280620,2}]','[1002011163,1004011163,1006011163,1008011163,1010011163,1002021163,1004021163,1006021163,1008021163,1010021163,1002031163,1004031163,1006031163,1008031163,1010031163,1002041163,1004041163,1006041163,1008041163,1010041163]','[]','[]','[{0,1006011263,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101207,'副手','12阶神装副手【魔剑士】',2,'[{lv,500}]',3,'[{0,38280620,2}]','[1001011163,1007011163,1001021163,1007021163,1001031163,1007031163,1001041163,1007041163]','[]','[]','[{0,1007011263,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101208,'护腕','12阶神装护腕【魔剑士】',2,'[{lv,500}]',3,'[{0,38280620,2}]','[1002011163,1004011163,1006011163,1008011163,1010011163,1002021163,1004021163,1006021163,1008021163,1010021163,1002031163,1004031163,1006031163,1008031163,1010031163,1002041163,1004041163,1006041163,1008041163,1010041163]','[]','[]','[{0,1008011263,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101209,'戒指','12阶神装戒指【通用】',2,'[{lv,500}]',3,'[{0,38280620,2}]','[1005001163,1009001163,1005001163,1009001163,1005001163,1009001163,1005001163,1009001163]','[]','[]','[{0,1009001263,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101210,'鞋子','12阶神装鞋子【魔剑士】',2,'[{lv,500}]',3,'[{0,38280620,2}]','[1002011163,1004011163,1006011163,1008011163,1010011163,1002021163,1004021163,1006021163,1008021163,1010021163,1002031163,1004031163,1006031163,1008031163,1010031163,1002041163,1004041163,1006041163,1008041163,1010041163]','[]','[]','[{0,1010011263,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101301,'武器','13阶神装武器【魔剑士】',2,'[{lv,520}]',3,'[{0,38280620,2}]','[1001011263,1007011263,1001021263,1007021263,1001031263,1007031263,1001041263,1007041263]','[]','[]','[{0,1001011363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101302,'头盔','13阶神装头盔【魔剑士】',2,'[{lv,520}]',3,'[{0,38280620,2}]','[1002011263,1004011263,1006011263,1008011263,1010011263,1002021263,1004021263,1006021263,1008021263,1010021263,1002031263,1004031263,1006031263,1008031263,1010031263,1002041263,1004041263,1006041263,1008041263,1010041263]','[]','[]','[{0,1002011363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101303,'项链','13阶神装项链【通用】',2,'[{lv,520}]',3,'[{0,38280620,2}]','[1003001263,1003001263,1003001263,1003001263]','[]','[]','[{0,1003001363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101304,'衣服','13阶神装衣服【魔剑士】',2,'[{lv,520}]',3,'[{0,38280620,2}]','[1002011263,1004011263,1006011263,1008011263,1010011263,1002021263,1004021263,1006021263,1008021263,1010021263,1002031263,1004031263,1006031263,1008031263,1010031263,1002041263,1004041263,1006041263,1008041263,1010041263]','[]','[]','[{0,1004011363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101305,'刻痕','13阶神装刻痕【通用】',2,'[{lv,520}]',3,'[{0,38280620,2}]','[1005001263,1009001263,1005001263,1009001263,1005001263,1009001263,1005001263,1009001263]','[]','[]','[{0,1005001363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101306,'裤子','13阶神装裤子【魔剑士】',2,'[{lv,520}]',3,'[{0,38280620,2}]','[1002011263,1004011263,1006011263,1008011263,1010011263,1002021263,1004021263,1006021263,1008021263,1010021263,1002031263,1004031263,1006031263,1008031263,1010031263,1002041263,1004041263,1006041263,1008041263,1010041263]','[]','[]','[{0,1006011363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101307,'副手','13阶神装副手【魔剑士】',2,'[{lv,520}]',3,'[{0,38280620,2}]','[1001011263,1007011263,1001021263,1007021263,1001031263,1007031263,1001041263,1007041263]','[]','[]','[{0,1007011363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101308,'护腕','13阶神装护腕【魔剑士】',2,'[{lv,520}]',3,'[{0,38280620,2}]','[1002011263,1004011263,1006011263,1008011263,1010011263,1002021263,1004021263,1006021263,1008021263,1010021263,1002031263,1004031263,1006031263,1008031263,1010031263,1002041263,1004041263,1006041263,1008041263,1010041263]','[]','[]','[{0,1008011363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101309,'戒指','13阶神装戒指【通用】',2,'[{lv,520}]',3,'[{0,38280620,2}]','[1005001263,1009001263,1005001263,1009001263,1005001263,1009001263,1005001263,1009001263]','[]','[]','[{0,1009001363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101310,'鞋子','13阶神装鞋子【魔剑士】',2,'[{lv,520}]',3,'[{0,38280620,2}]','[1002011263,1004011263,1006011263,1008011263,1010011263,1002021263,1004021263,1006021263,1008021263,1010021263,1002031263,1004031263,1006031263,1008031263,1010031263,1002041263,1004041263,1006041263,1008041263,1010041263]','[]','[]','[{0,1010011363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101401,'武器','14阶神装武器【魔剑士】',2,'[{lv,620}]',3,'[{0,38280620,2}]','[1001011363,1007011363,1001021363,1007021363,1001031363,1007031363,1001041363,1007041363]','[]','[]','[{0,1001011463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101402,'头盔','14阶神装头盔【魔剑士】',2,'[{lv,620}]',3,'[{0,38280620,2}]','[1002011363,1004011363,1006011363,1008011363,1010011363,1002021363,1004021363,1006021363,1008021363,1010021363,1002031363,1004031363,1006031363,1008031363,1010031363,1002041363,1004041363,1006041363,1008041363,1010041363]','[]','[]','[{0,1002011463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101403,'项链','14阶神装项链【通用】',2,'[{lv,620}]',3,'[{0,38280620,2}]','[1003001363,1003001363,1003001363,1003001363]','[]','[]','[{0,1003001463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101404,'衣服','14阶神装衣服【魔剑士】',2,'[{lv,620}]',3,'[{0,38280620,2}]','[1002011363,1004011363,1006011363,1008011363,1010011363,1002021363,1004021363,1006021363,1008021363,1010021363,1002031363,1004031363,1006031363,1008031363,1010031363,1002041363,1004041363,1006041363,1008041363,1010041363]','[]','[]','[{0,1004011463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101405,'刻痕','14阶神装刻痕【通用】',2,'[{lv,620}]',3,'[{0,38280620,2}]','[1005001363,1009001363,1005001363,1009001363,1005001363,1009001363,1005001363,1009001363]','[]','[]','[{0,1005001463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101406,'裤子','14阶神装裤子【魔剑士】',2,'[{lv,620}]',3,'[{0,38280620,2}]','[1002011363,1004011363,1006011363,1008011363,1010011363,1002021363,1004021363,1006021363,1008021363,1010021363,1002031363,1004031363,1006031363,1008031363,1010031363,1002041363,1004041363,1006041363,1008041363,1010041363]','[]','[]','[{0,1006011463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101407,'副手','14阶神装副手【魔剑士】',2,'[{lv,620}]',3,'[{0,38280620,2}]','[1001011363,1007011363,1001021363,1007021363,1001031363,1007031363,1001041363,1007041363]','[]','[]','[{0,1007011463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101408,'护腕','14阶神装护腕【魔剑士】',2,'[{lv,620}]',3,'[{0,38280620,2}]','[1002011363,1004011363,1006011363,1008011363,1010011363,1002021363,1004021363,1006021363,1008021363,1010021363,1002031363,1004031363,1006031363,1008031363,1010031363,1002041363,1004041363,1006041363,1008041363,1010041363]','[]','[]','[{0,1008011463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101409,'戒指','14阶神装戒指【通用】',2,'[{lv,620}]',3,'[{0,38280620,2}]','[1005001363,1009001363,1005001363,1009001363,1005001363,1009001363,1005001363,1009001363]','[]','[]','[{0,1009001463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101410,'鞋子','14阶神装鞋子【魔剑士】',2,'[{lv,620}]',3,'[{0,38280620,2}]','[1002011363,1004011363,1006011363,1008011363,1010011363,1002021363,1004021363,1006021363,1008021363,1010021363,1002031363,1004031363,1006031363,1008031363,1010031363,1002041363,1004041363,1006041363,1008041363,1010041363]','[]','[]','[{0,1010011463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101501,'武器','15阶神装武器【魔剑士】',2,'[{lv,650}]',3,'[{0,38280620,2}]','[1001011463,1007011463,1001021463,1007021463,1001031463,1007031463,1001041463,1007041463]','[]','[]','[{0,1001011563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101502,'头盔','15阶神装头盔【魔剑士】',2,'[{lv,650}]',3,'[{0,38280620,2}]','[1002011463,1004011463,1006011463,1008011463,1010011463,1002021463,1004021463,1006021463,1008021463,1010021463,1002031463,1004031463,1006031463,1008031463,1010031463,1002041463,1004041463,1006041463,1008041463,1010041463]','[]','[]','[{0,1002011563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101503,'项链','15阶神装项链【通用】',2,'[{lv,650}]',3,'[{0,38280620,2}]','[1003001463,1003001463,1003001463,1003001463]','[]','[]','[{0,1003001563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101504,'衣服','15阶神装衣服【魔剑士】',2,'[{lv,650}]',3,'[{0,38280620,2}]','[1002011463,1004011463,1006011463,1008011463,1010011463,1002021463,1004021463,1006021463,1008021463,1010021463,1002031463,1004031463,1006031463,1008031463,1010031463,1002041463,1004041463,1006041463,1008041463,1010041463]','[]','[]','[{0,1004011563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101505,'刻痕','15阶神装刻痕【通用】',2,'[{lv,650}]',3,'[{0,38280620,2}]','[1005001463,1009001463,1005001463,1009001463,1005001463,1009001463,1005001463,1009001463]','[]','[]','[{0,1005001563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101506,'裤子','15阶神装裤子【魔剑士】',2,'[{lv,650}]',3,'[{0,38280620,2}]','[1002011463,1004011463,1006011463,1008011463,1010011463,1002021463,1004021463,1006021463,1008021463,1010021463,1002031463,1004031463,1006031463,1008031463,1010031463,1002041463,1004041463,1006041463,1008041463,1010041463]','[]','[]','[{0,1006011563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101507,'副手','15阶神装副手【魔剑士】',2,'[{lv,650}]',3,'[{0,38280620,2}]','[1001011463,1007011463,1001021463,1007021463,1001031463,1007031463,1001041463,1007041463]','[]','[]','[{0,1007011563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101508,'护腕','15阶神装护腕【魔剑士】',2,'[{lv,650}]',3,'[{0,38280620,2}]','[1002011463,1004011463,1006011463,1008011463,1010011463,1002021463,1004021463,1006021463,1008021463,1010021463,1002031463,1004031463,1006031463,1008031463,1010031463,1002041463,1004041463,1006041463,1008041463,1010041463]','[]','[]','[{0,1008011563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101509,'戒指','15阶神装戒指【通用】',2,'[{lv,650}]',3,'[{0,38280620,2}]','[1005001463,1009001463,1005001463,1009001463,1005001463,1009001463,1005001463,1009001463]','[]','[]','[{0,1009001563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101510,'鞋子','15阶神装鞋子【魔剑士】',2,'[{lv,650}]',3,'[{0,38280620,2}]','[1002011463,1004011463,1006011463,1008011463,1010011463,1002021463,1004021463,1006021463,1008021463,1010021463,1002031463,1004031463,1006031463,1008031463,1010031463,1002041463,1004041463,1006041463,1008041463,1010041463]','[]','[]','[{0,1010011563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101601,'武器','16阶神装武器【魔剑士】',2,'[{lv,700}]',3,'[{0,38280620,2}]','[1001011563,1007011563,1001021563,1007021563,1001031563,1007031563,1001041563,1007041563]','[]','[]','[{0,1001011663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101602,'头盔','16阶神装头盔【魔剑士】',2,'[{lv,700}]',3,'[{0,38280620,2}]','[1002011563,1004011563,1006011563,1008011563,1010011563,1002021563,1004021563,1006021563,1008021563,1010021563,1002031563,1004031563,1006031563,1008031563,1010031563,1002041563,1004041563,1006041563,1008041563,1010041563]','[]','[]','[{0,1002011663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101603,'项链','16阶神装项链【通用】',2,'[{lv,700}]',3,'[{0,38280620,2}]','[1003001563,1003001563,1003001563,1003001563]','[]','[]','[{0,1003001663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101604,'衣服','16阶神装衣服【魔剑士】',2,'[{lv,700}]',3,'[{0,38280620,2}]','[1002011563,1004011563,1006011563,1008011563,1010011563,1002021563,1004021563,1006021563,1008021563,1010021563,1002031563,1004031563,1006031563,1008031563,1010031563,1002041563,1004041563,1006041563,1008041563,1010041563]','[]','[]','[{0,1004011663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101605,'刻痕','16阶神装刻痕【通用】',2,'[{lv,700}]',3,'[{0,38280620,2}]','[1005001563,1009001563,1005001563,1009001563,1005001563,1009001563,1005001563,1009001563]','[]','[]','[{0,1005001663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101606,'裤子','16阶神装裤子【魔剑士】',2,'[{lv,700}]',3,'[{0,38280620,2}]','[1002011563,1004011563,1006011563,1008011563,1010011563,1002021563,1004021563,1006021563,1008021563,1010021563,1002031563,1004031563,1006031563,1008031563,1010031563,1002041563,1004041563,1006041563,1008041563,1010041563]','[]','[]','[{0,1006011663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101607,'副手','16阶神装副手【魔剑士】',2,'[{lv,700}]',3,'[{0,38280620,2}]','[1001011563,1007011563,1001021563,1007021563,1001031563,1007031563,1001041563,1007041563]','[]','[]','[{0,1007011663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101608,'护腕','16阶神装护腕【魔剑士】',2,'[{lv,700}]',3,'[{0,38280620,2}]','[1002011563,1004011563,1006011563,1008011563,1010011563,1002021563,1004021563,1006021563,1008021563,1010021563,1002031563,1004031563,1006031563,1008031563,1010031563,1002041563,1004041563,1006041563,1008041563,1010041563]','[]','[]','[{0,1008011663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101609,'戒指','16阶神装戒指【通用】',2,'[{lv,700}]',3,'[{0,38280620,2}]','[1005001563,1009001563,1005001563,1009001563,1005001563,1009001563,1005001563,1009001563]','[]','[]','[{0,1009001663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(31101610,'鞋子','16阶神装鞋子【魔剑士】',2,'[{lv,700}]',3,'[{0,38280620,2}]','[1002011563,1004011563,1006011563,1008011563,1010011563,1002021563,1004021563,1006021563,1008021563,1010021563,1002031563,1004031563,1006031563,1008031563,1010031563,1002041563,1004041563,1006041563,1008041563,1010041563]','[]','[]','[{0,1010011663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32070301,'武器','3阶红2星武器【龙骑士】',2,'[{lv,9999}]',2,'[]','[1001010332,1007010332,1001020332,1007020332,1001030332,1007030332,1001040332,1007040332]','[]','[]','[{0,1001020342,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(32070302,'头盔','3阶红2星头盔【龙骑士】',2,'[{lv,9999}]',2,'[]','[1002010332,1004010332,1006010332,1008010332,1010010332,1002020332,1004020332,1006020332,1008020332,1010020332,1002030332,1004030332,1006030332,1008030332,1010030332,1002040332,1004040332,1006040332,1008040332,1010040332]','[]','[]','[{0,1002020342,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(32070303,'项链','3阶红2星项链【通用】',2,'[{lv,9999}]',2,'[]','[1003000332,1003000332,1003000332,1003000332]','[]','[]','[{0,1003000342,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(32070304,'衣服','3阶红2星衣服【龙骑士】',2,'[{lv,9999}]',2,'[]','[1002010332,1004010332,1006010332,1008010332,1010010332,1002020332,1004020332,1006020332,1008020332,1010020332,1002030332,1004030332,1006030332,1008030332,1010030332,1002040332,1004040332,1006040332,1008040332,1010040332]','[]','[]','[{0,1004020342,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(32070305,'刻痕','3阶红2星刻痕【通用】',2,'[{lv,9999}]',2,'[]','[1005000332,1009000332,1005000332,1009000332,1005000332,1009000332,1005000332,1009000332]','[]','[]','[{0,1005000342,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(32070306,'裤子','3阶红2星裤子【龙骑士】',2,'[{lv,9999}]',2,'[]','[1002010332,1004010332,1006010332,1008010332,1010010332,1002020332,1004020332,1006020332,1008020332,1010020332,1002030332,1004030332,1006030332,1008030332,1010030332,1002040332,1004040332,1006040332,1008040332,1010040332]','[]','[]','[{0,1006020342,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(32070307,'副手','3阶红2星副手【龙骑士】',2,'[{lv,9999}]',2,'[]','[1001010332,1007010332,1001020332,1007020332,1001030332,1007030332,1001040332,1007040332]','[]','[]','[{0,1007020342,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(32070308,'护腕','3阶红2星护腕【龙骑士】',2,'[{lv,9999}]',2,'[]','[1002010332,1004010332,1006010332,1008010332,1010010332,1002020332,1004020332,1006020332,1008020332,1010020332,1002030332,1004030332,1006030332,1008030332,1010030332,1002040332,1004040332,1006040332,1008040332,1010040332]','[]','[]','[{0,1008020342,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(32070309,'戒指','3阶红2星戒指【通用】',2,'[{lv,9999}]',2,'[]','[1005000332,1009000332,1005000332,1009000332,1005000332,1009000332,1005000332,1009000332]','[]','[]','[{0,1009000342,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(32070310,'鞋子','3阶红2星鞋子【龙骑士】',2,'[{lv,9999}]',2,'[]','[1002010332,1004010332,1006010332,1008010332,1010010332,1002020332,1004020332,1006020332,1008020332,1010020332,1002030332,1004030332,1006030332,1008030332,1010030332,1002040332,1004040332,1006040332,1008040332,1010040332]','[]','[]','[{0,1010020342,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(32070401,'武器','4阶红2星武器【龙骑士】',2,'[{lv,160}]',2,'[]','[1001010432,1007010432,1001020432,1007020432,1001030432,1007030432,1001040432,1007040432]','[]','[]','[{0,1001020442,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(32070402,'头盔','4阶红2星头盔【龙骑士】',2,'[{lv,160}]',2,'[]','[1002010432,1004010432,1006010432,1008010432,1010010432,1002020432,1004020432,1006020432,1008020432,1010020432,1002030432,1004030432,1006030432,1008030432,1010030432,1002040432,1004040432,1006040432,1008040432,1010040432]','[]','[]','[{0,1002020442,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(32070403,'项链','4阶红2星项链【通用】',2,'[{lv,160}]',2,'[]','[1003000432,1003000432,1003000432,1003000432]','[]','[]','[{0,1003000442,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(32070404,'衣服','4阶红2星衣服【龙骑士】',2,'[{lv,160}]',2,'[]','[1002010432,1004010432,1006010432,1008010432,1010010432,1002020432,1004020432,1006020432,1008020432,1010020432,1002030432,1004030432,1006030432,1008030432,1010030432,1002040432,1004040432,1006040432,1008040432,1010040432]','[]','[]','[{0,1004020442,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(32070405,'刻痕','4阶红2星刻痕【通用】',2,'[{lv,160}]',2,'[]','[1005000432,1009000432,1005000432,1009000432,1005000432,1009000432,1005000432,1009000432]','[]','[]','[{0,1005000442,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(32070406,'裤子','4阶红2星裤子【龙骑士】',2,'[{lv,160}]',2,'[]','[1002010432,1004010432,1006010432,1008010432,1010010432,1002020432,1004020432,1006020432,1008020432,1010020432,1002030432,1004030432,1006030432,1008030432,1010030432,1002040432,1004040432,1006040432,1008040432,1010040432]','[]','[]','[{0,1006020442,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(32070407,'副手','4阶红2星副手【龙骑士】',2,'[{lv,160}]',2,'[]','[1001010432,1007010432,1001020432,1007020432,1001030432,1007030432,1001040432,1007040432]','[]','[]','[{0,1007020442,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(32070408,'护腕','4阶红2星护腕【龙骑士】',2,'[{lv,160}]',2,'[]','[1002010432,1004010432,1006010432,1008010432,1010010432,1002020432,1004020432,1006020432,1008020432,1010020432,1002030432,1004030432,1006030432,1008030432,1010030432,1002040432,1004040432,1006040432,1008040432,1010040432]','[]','[]','[{0,1008020442,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(32070409,'戒指','4阶红2星戒指【通用】',2,'[{lv,160}]',2,'[]','[1005000432,1009000432,1005000432,1009000432,1005000432,1009000432,1005000432,1009000432]','[]','[]','[{0,1009000442,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(32070410,'鞋子','4阶红2星鞋子【龙骑士】',2,'[{lv,160}]',2,'[]','[1002010432,1004010432,1006010432,1008010432,1010010432,1002020432,1004020432,1006020432,1008020432,1010020432,1002030432,1004030432,1006030432,1008030432,1010030432,1002040432,1004040432,1006040432,1008040432,1010040432]','[]','[]','[{0,1010020442,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(32070501,'武器','5阶红2星武器【龙骑士】',2,'[{lv,160}]',2,'[]','[1001010532,1007010532,1001020532,1007020532,1001030532,1007030532,1001040532,1007040532,1101010532,1107010532,1101020532,1107020532,1101030532,1107030532,1101040532,1107040532]','[]','[]','[{0,1001020542,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(32070502,'头盔','5阶红2星头盔【龙骑士】',2,'[{lv,160}]',2,'[]','[1002010532,1004010532,1006010532,1008010532,1010010532,1002020532,1004020532,1006020532,1008020532,1010020532,1002030532,1004030532,1006030532,1008030532,1010030532,1002040532,1004040532,1006040532,1008040532,1010040532,1102010532,1104010532,1106010532,1108010532,1110010532,1102020532,1104020532,1106020532,1108020532,1110020532,1102030532,1104030532,1106030532,1108030532,1110030532,1102040532,1104040532,1106040532,1108040532,1110040532]','[]','[]','[{0,1002020542,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(32070503,'项链','5阶红2星项链【通用】',2,'[{lv,160}]',2,'[]','[1003000532,1003000532,1003000532,1003000532,1103000532,1103000532,1103000532,1103000532]','[]','[]','[{0,1003000542,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(32070504,'衣服','5阶红2星衣服【龙骑士】',2,'[{lv,160}]',2,'[]','[1002010532,1004010532,1006010532,1008010532,1010010532,1002020532,1004020532,1006020532,1008020532,1010020532,1002030532,1004030532,1006030532,1008030532,1010030532,1002040532,1004040532,1006040532,1008040532,1010040532,1102010532,1104010532,1106010532,1108010532,1110010532,1102020532,1104020532,1106020532,1108020532,1110020532,1102030532,1104030532,1106030532,1108030532,1110030532,1102040532,1104040532,1106040532,1108040532,1110040532]','[]','[]','[{0,1004020542,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(32070505,'刻痕','5阶红2星刻痕【通用】',2,'[{lv,160}]',2,'[]','[1005000532,1009000532,1005000532,1009000532,1005000532,1009000532,1005000532,1009000532,1105000532,1109000532,1105000532,1109000532,1105000532,1109000532,1105000532,1109000532]','[]','[]','[{0,1005000542,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(32070506,'裤子','5阶红2星裤子【龙骑士】',2,'[{lv,160}]',2,'[]','[1002010532,1004010532,1006010532,1008010532,1010010532,1002020532,1004020532,1006020532,1008020532,1010020532,1002030532,1004030532,1006030532,1008030532,1010030532,1002040532,1004040532,1006040532,1008040532,1010040532,1102010532,1104010532,1106010532,1108010532,1110010532,1102020532,1104020532,1106020532,1108020532,1110020532,1102030532,1104030532,1106030532,1108030532,1110030532,1102040532,1104040532,1106040532,1108040532,1110040532]','[]','[]','[{0,1006020542,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(32070507,'副手','5阶红2星副手【龙骑士】',2,'[{lv,160}]',2,'[]','[1001010532,1007010532,1001020532,1007020532,1001030532,1007030532,1001040532,1007040532,1101010532,1107010532,1101020532,1107020532,1101030532,1107030532,1101040532,1107040532]','[]','[]','[{0,1007020542,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(32070508,'护腕','5阶红2星护腕【龙骑士】',2,'[{lv,160}]',2,'[]','[1002010532,1004010532,1006010532,1008010532,1010010532,1002020532,1004020532,1006020532,1008020532,1010020532,1002030532,1004030532,1006030532,1008030532,1010030532,1002040532,1004040532,1006040532,1008040532,1010040532,1102010532,1104010532,1106010532,1108010532,1110010532,1102020532,1104020532,1106020532,1108020532,1110020532,1102030532,1104030532,1106030532,1108030532,1110030532,1102040532,1104040532,1106040532,1108040532,1110040532]','[]','[]','[{0,1008020542,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(32070509,'戒指','5阶红2星戒指【通用】',2,'[{lv,160}]',2,'[]','[1005000532,1009000532,1005000532,1009000532,1005000532,1009000532,1005000532,1009000532,1105000532,1109000532,1105000532,1109000532,1105000532,1109000532,1105000532,1109000532]','[]','[]','[{0,1009000542,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(32070510,'鞋子','5阶红2星鞋子【龙骑士】',2,'[{lv,160}]',2,'[]','[1002010532,1004010532,1006010532,1008010532,1010010532,1002020532,1004020532,1006020532,1008020532,1010020532,1002030532,1004030532,1006030532,1008030532,1010030532,1002040532,1004040532,1006040532,1008040532,1010040532,1102010532,1104010532,1106010532,1108010532,1110010532,1102020532,1104020532,1106020532,1108020532,1110020532,1102030532,1104030532,1106030532,1108030532,1110030532,1102040532,1104040532,1106040532,1108040532,1110040532]','[]','[]','[{0,1010020542,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(32070601,'武器','6阶红2星武器【龙骑士】',2,'[{lv,180}]',2,'[]','[1001010632,1007010632,1001020632,1007020632,1001030632,1007030632,1001040632,1007040632]','[]','[]','[{0,1001020642,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(32070602,'头盔','6阶红2星头盔【龙骑士】',2,'[{lv,180}]',2,'[]','[1002010632,1004010632,1006010632,1008010632,1010010632,1002020632,1004020632,1006020632,1008020632,1010020632,1002030632,1004030632,1006030632,1008030632,1010030632,1002040632,1004040632,1006040632,1008040632,1010040632]','[]','[]','[{0,1002020642,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(32070603,'项链','6阶红2星项链【通用】',2,'[{lv,180}]',2,'[]','[1003000632,1003000632,1003000632,1003000632]','[]','[]','[{0,1003000642,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(32070604,'衣服','6阶红2星衣服【龙骑士】',2,'[{lv,180}]',2,'[]','[1002010632,1004010632,1006010632,1008010632,1010010632,1002020632,1004020632,1006020632,1008020632,1010020632,1002030632,1004030632,1006030632,1008030632,1010030632,1002040632,1004040632,1006040632,1008040632,1010040632]','[]','[]','[{0,1004020642,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(32070605,'刻痕','6阶红2星刻痕【通用】',2,'[{lv,180}]',2,'[]','[1005000632,1009000632,1005000632,1009000632,1005000632,1009000632,1005000632,1009000632]','[]','[]','[{0,1005000642,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(32070606,'裤子','6阶红2星裤子【龙骑士】',2,'[{lv,180}]',2,'[]','[1002010632,1004010632,1006010632,1008010632,1010010632,1002020632,1004020632,1006020632,1008020632,1010020632,1002030632,1004030632,1006030632,1008030632,1010030632,1002040632,1004040632,1006040632,1008040632,1010040632]','[]','[]','[{0,1006020642,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(32070607,'副手','6阶红2星副手【龙骑士】',2,'[{lv,180}]',2,'[]','[1001010632,1007010632,1001020632,1007020632,1001030632,1007030632,1001040632,1007040632]','[]','[]','[{0,1007020642,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(32070608,'护腕','6阶红2星护腕【龙骑士】',2,'[{lv,180}]',2,'[]','[1002010632,1004010632,1006010632,1008010632,1010010632,1002020632,1004020632,1006020632,1008020632,1010020632,1002030632,1004030632,1006030632,1008030632,1010030632,1002040632,1004040632,1006040632,1008040632,1010040632]','[]','[]','[{0,1008020642,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(32070609,'戒指','6阶红2星戒指【通用】',2,'[{lv,180}]',2,'[]','[1005000632,1009000632,1005000632,1009000632,1005000632,1009000632,1005000632,1009000632]','[]','[]','[{0,1009000642,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(32070610,'鞋子','6阶红2星鞋子【龙骑士】',2,'[{lv,180}]',2,'[]','[1002010632,1004010632,1006010632,1008010632,1010010632,1002020632,1004020632,1006020632,1008020632,1010020632,1002030632,1004030632,1006030632,1008030632,1010030632,1002040632,1004040632,1006040632,1008040632,1010040632]','[]','[]','[{0,1010020642,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(32070701,'武器','7阶红2星武器【龙骑士】',2,'[{lv,220}]',2,'[]','[1001010732,1007010732,1001020732,1007020732,1001030732,1007030732,1001040732,1007040732,1101010732,1107010732,1101020732,1107020732,1101030732,1107030732,1101040732,1107040732]','[]','[]','[{0,1001020742,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32070702,'头盔','7阶红2星头盔【龙骑士】',2,'[{lv,220}]',2,'[]','[1002010732,1004010732,1006010732,1008010732,1010010732,1002020732,1004020732,1006020732,1008020732,1010020732,1002030732,1004030732,1006030732,1008030732,1010030732,1002040732,1004040732,1006040732,1008040732,1010040732,1102010732,1104010732,1106010732,1108010732,1110010732,1102020732,1104020732,1106020732,1108020732,1110020732,1102030732,1104030732,1106030732,1108030732,1110030732,1102040732,1104040732,1106040732,1108040732,1110040732]','[]','[]','[{0,1002020742,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32070703,'项链','7阶红2星项链【通用】',2,'[{lv,220}]',2,'[]','[1003000732,1003000732,1003000732,1003000732,1103000732,1103000732,1103000732,1103000732]','[]','[]','[{0,1003000742,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32070704,'衣服','7阶红2星衣服【龙骑士】',2,'[{lv,220}]',2,'[]','[1002010732,1004010732,1006010732,1008010732,1010010732,1002020732,1004020732,1006020732,1008020732,1010020732,1002030732,1004030732,1006030732,1008030732,1010030732,1002040732,1004040732,1006040732,1008040732,1010040732,1102010732,1104010732,1106010732,1108010732,1110010732,1102020732,1104020732,1106020732,1108020732,1110020732,1102030732,1104030732,1106030732,1108030732,1110030732,1102040732,1104040732,1106040732,1108040732,1110040732]','[]','[]','[{0,1004020742,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32070705,'刻痕','7阶红2星刻痕【通用】',2,'[{lv,220}]',2,'[]','[1005000732,1009000732,1005000732,1009000732,1005000732,1009000732,1005000732,1009000732,1105000732,1109000732,1105000732,1109000732,1105000732,1109000732,1105000732,1109000732]','[]','[]','[{0,1005000742,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32070706,'裤子','7阶红2星裤子【龙骑士】',2,'[{lv,220}]',2,'[]','[1002010732,1004010732,1006010732,1008010732,1010010732,1002020732,1004020732,1006020732,1008020732,1010020732,1002030732,1004030732,1006030732,1008030732,1010030732,1002040732,1004040732,1006040732,1008040732,1010040732,1102010732,1104010732,1106010732,1108010732,1110010732,1102020732,1104020732,1106020732,1108020732,1110020732,1102030732,1104030732,1106030732,1108030732,1110030732,1102040732,1104040732,1106040732,1108040732,1110040732]','[]','[]','[{0,1006020742,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32070707,'副手','7阶红2星副手【龙骑士】',2,'[{lv,220}]',2,'[]','[1001010732,1007010732,1001020732,1007020732,1001030732,1007030732,1001040732,1007040732,1101010732,1107010732,1101020732,1107020732,1101030732,1107030732,1101040732,1107040732]','[]','[]','[{0,1007020742,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32070708,'护腕','7阶红2星护腕【龙骑士】',2,'[{lv,220}]',2,'[]','[1002010732,1004010732,1006010732,1008010732,1010010732,1002020732,1004020732,1006020732,1008020732,1010020732,1002030732,1004030732,1006030732,1008030732,1010030732,1002040732,1004040732,1006040732,1008040732,1010040732,1102010732,1104010732,1106010732,1108010732,1110010732,1102020732,1104020732,1106020732,1108020732,1110020732,1102030732,1104030732,1106030732,1108030732,1110030732,1102040732,1104040732,1106040732,1108040732,1110040732]','[]','[]','[{0,1008020742,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32070709,'戒指','7阶红2星戒指【通用】',2,'[{lv,220}]',2,'[]','[1005000732,1009000732,1005000732,1009000732,1005000732,1009000732,1005000732,1009000732,1105000732,1109000732,1105000732,1109000732,1105000732,1109000732,1105000732,1109000732]','[]','[]','[{0,1009000742,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32070710,'鞋子','7阶红2星鞋子【龙骑士】',2,'[{lv,220}]',2,'[]','[1002010732,1004010732,1006010732,1008010732,1010010732,1002020732,1004020732,1006020732,1008020732,1010020732,1002030732,1004030732,1006030732,1008030732,1010030732,1002040732,1004040732,1006040732,1008040732,1010040732,1102010732,1104010732,1106010732,1108010732,1110010732,1102020732,1104020732,1106020732,1108020732,1110020732,1102030732,1104030732,1106030732,1108030732,1110030732,1102040732,1104040732,1106040732,1108040732,1110040732]','[]','[]','[{0,1010020742,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32070801,'武器','8阶红2星武器【龙骑士】',2,'[{lv,260}]',2,'[]','[1001010832,1007010832,1001020832,1007020832,1001030832,1007030832,1001040832,1007040832]','[]','[]','[{0,1001020842,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32070802,'头盔','8阶红2星头盔【龙骑士】',2,'[{lv,260}]',2,'[]','[1002010832,1004010832,1006010832,1008010832,1010010832,1002020832,1004020832,1006020832,1008020832,1010020832,1002030832,1004030832,1006030832,1008030832,1010030832,1002040832,1004040832,1006040832,1008040832,1010040832]','[]','[]','[{0,1002020842,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32070803,'项链','8阶红2星项链【通用】',2,'[{lv,260}]',2,'[]','[1003000832,1003000832,1003000832,1003000832]','[]','[]','[{0,1003000842,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32070804,'衣服','8阶红2星衣服【龙骑士】',2,'[{lv,260}]',2,'[]','[1002010832,1004010832,1006010832,1008010832,1010010832,1002020832,1004020832,1006020832,1008020832,1010020832,1002030832,1004030832,1006030832,1008030832,1010030832,1002040832,1004040832,1006040832,1008040832,1010040832]','[]','[]','[{0,1004020842,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32070805,'刻痕','8阶红2星刻痕【通用】',2,'[{lv,260}]',2,'[]','[1005000832,1009000832,1005000832,1009000832,1005000832,1009000832,1005000832,1009000832]','[]','[]','[{0,1005000842,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32070806,'裤子','8阶红2星裤子【龙骑士】',2,'[{lv,260}]',2,'[]','[1002010832,1004010832,1006010832,1008010832,1010010832,1002020832,1004020832,1006020832,1008020832,1010020832,1002030832,1004030832,1006030832,1008030832,1010030832,1002040832,1004040832,1006040832,1008040832,1010040832]','[]','[]','[{0,1006020842,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32070807,'副手','8阶红2星副手【龙骑士】',2,'[{lv,260}]',2,'[]','[1001010832,1007010832,1001020832,1007020832,1001030832,1007030832,1001040832,1007040832]','[]','[]','[{0,1007020842,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32070808,'护腕','8阶红2星护腕【龙骑士】',2,'[{lv,260}]',2,'[]','[1002010832,1004010832,1006010832,1008010832,1010010832,1002020832,1004020832,1006020832,1008020832,1010020832,1002030832,1004030832,1006030832,1008030832,1010030832,1002040832,1004040832,1006040832,1008040832,1010040832]','[]','[]','[{0,1008020842,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32070809,'戒指','8阶红2星戒指【通用】',2,'[{lv,260}]',2,'[]','[1005000832,1009000832,1005000832,1009000832,1005000832,1009000832,1005000832,1009000832]','[]','[]','[{0,1009000842,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32070810,'鞋子','8阶红2星鞋子【龙骑士】',2,'[{lv,260}]',2,'[]','[1002010832,1004010832,1006010832,1008010832,1010010832,1002020832,1004020832,1006020832,1008020832,1010020832,1002030832,1004030832,1006030832,1008030832,1010030832,1002040832,1004040832,1006040832,1008040832,1010040832]','[]','[]','[{0,1010020842,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32070901,'武器','9阶红2星武器【龙骑士】',2,'[{lv,300}]',2,'[]','[1001010932,1007010932,1001020932,1007020932,1001030932,1007030932,1001040932,1007040932]','[]','[]','[{0,1001020942,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32070902,'头盔','9阶红2星头盔【龙骑士】',2,'[{lv,300}]',2,'[]','[1002010932,1004010932,1006010932,1008010932,1010010932,1002020932,1004020932,1006020932,1008020932,1010020932,1002030932,1004030932,1006030932,1008030932,1010030932,1002040932,1004040932,1006040932,1008040932,1010040932]','[]','[]','[{0,1002020942,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32070903,'项链','9阶红2星项链【通用】',2,'[{lv,300}]',2,'[]','[1003000932,1003000932,1003000932,1003000932]','[]','[]','[{0,1003000942,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32070904,'衣服','9阶红2星衣服【龙骑士】',2,'[{lv,300}]',2,'[]','[1002010932,1004010932,1006010932,1008010932,1010010932,1002020932,1004020932,1006020932,1008020932,1010020932,1002030932,1004030932,1006030932,1008030932,1010030932,1002040932,1004040932,1006040932,1008040932,1010040932]','[]','[]','[{0,1004020942,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32070905,'刻痕','9阶红2星刻痕【通用】',2,'[{lv,300}]',2,'[]','[1005000932,1009000932,1005000932,1009000932,1005000932,1009000932,1005000932,1009000932]','[]','[]','[{0,1005000942,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32070906,'裤子','9阶红2星裤子【龙骑士】',2,'[{lv,300}]',2,'[]','[1002010932,1004010932,1006010932,1008010932,1010010932,1002020932,1004020932,1006020932,1008020932,1010020932,1002030932,1004030932,1006030932,1008030932,1010030932,1002040932,1004040932,1006040932,1008040932,1010040932]','[]','[]','[{0,1006020942,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32070907,'副手','9阶红2星副手【龙骑士】',2,'[{lv,300}]',2,'[]','[1001010932,1007010932,1001020932,1007020932,1001030932,1007030932,1001040932,1007040932]','[]','[]','[{0,1007020942,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32070908,'护腕','9阶红2星护腕【龙骑士】',2,'[{lv,300}]',2,'[]','[1002010932,1004010932,1006010932,1008010932,1010010932,1002020932,1004020932,1006020932,1008020932,1010020932,1002030932,1004030932,1006030932,1008030932,1010030932,1002040932,1004040932,1006040932,1008040932,1010040932]','[]','[]','[{0,1008020942,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32070909,'戒指','9阶红2星戒指【通用】',2,'[{lv,300}]',2,'[]','[1005000932,1009000932,1005000932,1009000932,1005000932,1009000932,1005000932,1009000932]','[]','[]','[{0,1009000942,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32070910,'鞋子','9阶红2星鞋子【龙骑士】',2,'[{lv,300}]',2,'[]','[1002010932,1004010932,1006010932,1008010932,1010010932,1002020932,1004020932,1006020932,1008020932,1010020932,1002030932,1004030932,1006030932,1008030932,1010030932,1002040932,1004040932,1006040932,1008040932,1010040932]','[]','[]','[{0,1010020942,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071001,'武器','10阶红2星武器【龙骑士】',2,'[{lv,355}]',2,'[]','[1001011032,1007011032,1001021032,1007021032,1001031032,1007031032,1001041032,1007041032]','[]','[]','[{0,1001021042,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071002,'头盔','10阶红2星头盔【龙骑士】',2,'[{lv,355}]',2,'[]','[1002011032,1004011032,1006011032,1008011032,1010011032,1002021032,1004021032,1006021032,1008021032,1010021032,1002031032,1004031032,1006031032,1008031032,1010031032,1002041032,1004041032,1006041032,1008041032,1010041032]','[]','[]','[{0,1002021042,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071003,'项链','10阶红2星项链【通用】',2,'[{lv,355}]',2,'[]','[1003001032,1003001032,1003001032,1003001032]','[]','[]','[{0,1003001042,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071004,'衣服','10阶红2星衣服【龙骑士】',2,'[{lv,355}]',2,'[]','[1002011032,1004011032,1006011032,1008011032,1010011032,1002021032,1004021032,1006021032,1008021032,1010021032,1002031032,1004031032,1006031032,1008031032,1010031032,1002041032,1004041032,1006041032,1008041032,1010041032]','[]','[]','[{0,1004021042,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071005,'刻痕','10阶红2星刻痕【通用】',2,'[{lv,355}]',2,'[]','[1005001032,1009001032,1005001032,1009001032,1005001032,1009001032,1005001032,1009001032]','[]','[]','[{0,1005001042,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071006,'裤子','10阶红2星裤子【龙骑士】',2,'[{lv,355}]',2,'[]','[1002011032,1004011032,1006011032,1008011032,1010011032,1002021032,1004021032,1006021032,1008021032,1010021032,1002031032,1004031032,1006031032,1008031032,1010031032,1002041032,1004041032,1006041032,1008041032,1010041032]','[]','[]','[{0,1006021042,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071007,'副手','10阶红2星副手【龙骑士】',2,'[{lv,355}]',2,'[]','[1001011032,1007011032,1001021032,1007021032,1001031032,1007031032,1001041032,1007041032]','[]','[]','[{0,1007021042,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071008,'护腕','10阶红2星护腕【龙骑士】',2,'[{lv,355}]',2,'[]','[1002011032,1004011032,1006011032,1008011032,1010011032,1002021032,1004021032,1006021032,1008021032,1010021032,1002031032,1004031032,1006031032,1008031032,1010031032,1002041032,1004041032,1006041032,1008041032,1010041032]','[]','[]','[{0,1008021042,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071009,'戒指','10阶红2星戒指【通用】',2,'[{lv,355}]',2,'[]','[1005001032,1009001032,1005001032,1009001032,1005001032,1009001032,1005001032,1009001032]','[]','[]','[{0,1009001042,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071010,'鞋子','10阶红2星鞋子【龙骑士】',2,'[{lv,355}]',2,'[]','[1002011032,1004011032,1006011032,1008011032,1010011032,1002021032,1004021032,1006021032,1008021032,1010021032,1002031032,1004031032,1006031032,1008031032,1010031032,1002041032,1004041032,1006041032,1008041032,1010041032]','[]','[]','[{0,1010021042,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071101,'武器','11阶红2星武器【龙骑士】',2,'[{lv,400}]',2,'[]','[1001011132,1007011132,1001021132,1007021132,1001031132,1007031132,1001041132,1007041132]','[]','[]','[{0,1001021142,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071102,'头盔','11阶红2星头盔【龙骑士】',2,'[{lv,400}]',2,'[]','[1002011132,1004011132,1006011132,1008011132,1010011132,1002021132,1004021132,1006021132,1008021132,1010021132,1002031132,1004031132,1006031132,1008031132,1010031132,1002041132,1004041132,1006041132,1008041132,1010041132]','[]','[]','[{0,1002021142,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071103,'项链','11阶红2星项链【通用】',2,'[{lv,400}]',2,'[]','[1003001132,1003001132,1003001132,1003001132]','[]','[]','[{0,1003001142,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071104,'衣服','11阶红2星衣服【龙骑士】',2,'[{lv,400}]',2,'[]','[1002011132,1004011132,1006011132,1008011132,1010011132,1002021132,1004021132,1006021132,1008021132,1010021132,1002031132,1004031132,1006031132,1008031132,1010031132,1002041132,1004041132,1006041132,1008041132,1010041132]','[]','[]','[{0,1004021142,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071105,'刻痕','11阶红2星刻痕【通用】',2,'[{lv,400}]',2,'[]','[1005001132,1009001132,1005001132,1009001132,1005001132,1009001132,1005001132,1009001132]','[]','[]','[{0,1005001142,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071106,'裤子','11阶红2星裤子【龙骑士】',2,'[{lv,400}]',2,'[]','[1002011132,1004011132,1006011132,1008011132,1010011132,1002021132,1004021132,1006021132,1008021132,1010021132,1002031132,1004031132,1006031132,1008031132,1010031132,1002041132,1004041132,1006041132,1008041132,1010041132]','[]','[]','[{0,1006021142,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071107,'副手','11阶红2星副手【龙骑士】',2,'[{lv,400}]',2,'[]','[1001011132,1007011132,1001021132,1007021132,1001031132,1007031132,1001041132,1007041132]','[]','[]','[{0,1007021142,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071108,'护腕','11阶红2星护腕【龙骑士】',2,'[{lv,400}]',2,'[]','[1002011132,1004011132,1006011132,1008011132,1010011132,1002021132,1004021132,1006021132,1008021132,1010021132,1002031132,1004031132,1006031132,1008031132,1010031132,1002041132,1004041132,1006041132,1008041132,1010041132]','[]','[]','[{0,1008021142,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071109,'戒指','11阶红2星戒指【通用】',2,'[{lv,400}]',2,'[]','[1005001132,1009001132,1005001132,1009001132,1005001132,1009001132,1005001132,1009001132]','[]','[]','[{0,1009001142,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071110,'鞋子','11阶红2星鞋子【龙骑士】',2,'[{lv,400}]',2,'[]','[1002011132,1004011132,1006011132,1008011132,1010011132,1002021132,1004021132,1006021132,1008021132,1010021132,1002031132,1004031132,1006031132,1008031132,1010031132,1002041132,1004041132,1006041132,1008041132,1010041132]','[]','[]','[{0,1010021142,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071201,'武器','12阶红2星武器【龙骑士】',2,'[{lv,500}]',2,'[]','[1001011232,1007011232,1001021232,1007021232,1001031232,1007031232,1001041232,1007041232]','[]','[]','[{0,1001021242,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071202,'头盔','12阶红2星头盔【龙骑士】',2,'[{lv,500}]',2,'[]','[1002011232,1004011232,1006011232,1008011232,1010011232,1002021232,1004021232,1006021232,1008021232,1010021232,1002031232,1004031232,1006031232,1008031232,1010031232,1002041232,1004041232,1006041232,1008041232,1010041232]','[]','[]','[{0,1002021242,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071203,'项链','12阶红2星项链【通用】',2,'[{lv,500}]',2,'[]','[1003001232,1003001232,1003001232,1003001232]','[]','[]','[{0,1003001242,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071204,'衣服','12阶红2星衣服【龙骑士】',2,'[{lv,500}]',2,'[]','[1002011232,1004011232,1006011232,1008011232,1010011232,1002021232,1004021232,1006021232,1008021232,1010021232,1002031232,1004031232,1006031232,1008031232,1010031232,1002041232,1004041232,1006041232,1008041232,1010041232]','[]','[]','[{0,1004021242,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071205,'刻痕','12阶红2星刻痕【通用】',2,'[{lv,500}]',2,'[]','[1005001232,1009001232,1005001232,1009001232,1005001232,1009001232,1005001232,1009001232]','[]','[]','[{0,1005001242,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071206,'裤子','12阶红2星裤子【龙骑士】',2,'[{lv,500}]',2,'[]','[1002011232,1004011232,1006011232,1008011232,1010011232,1002021232,1004021232,1006021232,1008021232,1010021232,1002031232,1004031232,1006031232,1008031232,1010031232,1002041232,1004041232,1006041232,1008041232,1010041232]','[]','[]','[{0,1006021242,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071207,'副手','12阶红2星副手【龙骑士】',2,'[{lv,500}]',2,'[]','[1001011232,1007011232,1001021232,1007021232,1001031232,1007031232,1001041232,1007041232]','[]','[]','[{0,1007021242,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071208,'护腕','12阶红2星护腕【龙骑士】',2,'[{lv,500}]',2,'[]','[1002011232,1004011232,1006011232,1008011232,1010011232,1002021232,1004021232,1006021232,1008021232,1010021232,1002031232,1004031232,1006031232,1008031232,1010031232,1002041232,1004041232,1006041232,1008041232,1010041232]','[]','[]','[{0,1008021242,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071209,'戒指','12阶红2星戒指【通用】',2,'[{lv,500}]',2,'[]','[1005001232,1009001232,1005001232,1009001232,1005001232,1009001232,1005001232,1009001232]','[]','[]','[{0,1009001242,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071210,'鞋子','12阶红2星鞋子【龙骑士】',2,'[{lv,500}]',2,'[]','[1002011232,1004011232,1006011232,1008011232,1010011232,1002021232,1004021232,1006021232,1008021232,1010021232,1002031232,1004031232,1006031232,1008031232,1010031232,1002041232,1004041232,1006041232,1008041232,1010041232]','[]','[]','[{0,1010021242,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071301,'武器','13阶红2星武器【龙骑士】',2,'[{lv,520}]',2,'[]','[1001011332,1007011332,1001021332,1007021332,1001031332,1007031332,1001041332,1007041332]','[]','[]','[{0,1001021342,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071302,'头盔','13阶红2星头盔【龙骑士】',2,'[{lv,520}]',2,'[]','[1002011332,1004011332,1006011332,1008011332,1010011332,1002021332,1004021332,1006021332,1008021332,1010021332,1002031332,1004031332,1006031332,1008031332,1010031332,1002041332,1004041332,1006041332,1008041332,1010041332]','[]','[]','[{0,1002021342,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071303,'项链','13阶红2星项链【通用】',2,'[{lv,520}]',2,'[]','[1003001332,1003001332,1003001332,1003001332]','[]','[]','[{0,1003001342,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071304,'衣服','13阶红2星衣服【龙骑士】',2,'[{lv,520}]',2,'[]','[1002011332,1004011332,1006011332,1008011332,1010011332,1002021332,1004021332,1006021332,1008021332,1010021332,1002031332,1004031332,1006031332,1008031332,1010031332,1002041332,1004041332,1006041332,1008041332,1010041332]','[]','[]','[{0,1004021342,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071305,'刻痕','13阶红2星刻痕【通用】',2,'[{lv,520}]',2,'[]','[1005001332,1009001332,1005001332,1009001332,1005001332,1009001332,1005001332,1009001332]','[]','[]','[{0,1005001342,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071306,'裤子','13阶红2星裤子【龙骑士】',2,'[{lv,520}]',2,'[]','[1002011332,1004011332,1006011332,1008011332,1010011332,1002021332,1004021332,1006021332,1008021332,1010021332,1002031332,1004031332,1006031332,1008031332,1010031332,1002041332,1004041332,1006041332,1008041332,1010041332]','[]','[]','[{0,1006021342,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071307,'副手','13阶红2星副手【龙骑士】',2,'[{lv,520}]',2,'[]','[1001011332,1007011332,1001021332,1007021332,1001031332,1007031332,1001041332,1007041332]','[]','[]','[{0,1007021342,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071308,'护腕','13阶红2星护腕【龙骑士】',2,'[{lv,520}]',2,'[]','[1002011332,1004011332,1006011332,1008011332,1010011332,1002021332,1004021332,1006021332,1008021332,1010021332,1002031332,1004031332,1006031332,1008031332,1010031332,1002041332,1004041332,1006041332,1008041332,1010041332]','[]','[]','[{0,1008021342,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071309,'戒指','13阶红2星戒指【通用】',2,'[{lv,520}]',2,'[]','[1005001332,1009001332,1005001332,1009001332,1005001332,1009001332,1005001332,1009001332]','[]','[]','[{0,1009001342,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071310,'鞋子','13阶红2星鞋子【龙骑士】',2,'[{lv,520}]',2,'[]','[1002011332,1004011332,1006011332,1008011332,1010011332,1002021332,1004021332,1006021332,1008021332,1010021332,1002031332,1004031332,1006031332,1008031332,1010031332,1002041332,1004041332,1006041332,1008041332,1010041332]','[]','[]','[{0,1010021342,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071401,'武器','14阶红2星武器【龙骑士】',2,'[{lv,620}]',2,'[]','[1001011432,1007011432,1001021432,1007021432,1001031432,1007031432,1001041432,1007041432]','[]','[]','[{0,1001021442,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071402,'头盔','14阶红2星头盔【龙骑士】',2,'[{lv,620}]',2,'[]','[1002011432,1004011432,1006011432,1008011432,1010011432,1002021432,1004021432,1006021432,1008021432,1010021432,1002031432,1004031432,1006031432,1008031432,1010031432,1002041432,1004041432,1006041432,1008041432,1010041432]','[]','[]','[{0,1002021442,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071403,'项链','14阶红2星项链【通用】',2,'[{lv,620}]',2,'[]','[1003001432,1003001432,1003001432,1003001432]','[]','[]','[{0,1003001442,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071404,'衣服','14阶红2星衣服【龙骑士】',2,'[{lv,620}]',2,'[]','[1002011432,1004011432,1006011432,1008011432,1010011432,1002021432,1004021432,1006021432,1008021432,1010021432,1002031432,1004031432,1006031432,1008031432,1010031432,1002041432,1004041432,1006041432,1008041432,1010041432]','[]','[]','[{0,1004021442,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071405,'刻痕','14阶红2星刻痕【通用】',2,'[{lv,620}]',2,'[]','[1005001432,1009001432,1005001432,1009001432,1005001432,1009001432,1005001432,1009001432]','[]','[]','[{0,1005001442,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071406,'裤子','14阶红2星裤子【龙骑士】',2,'[{lv,620}]',2,'[]','[1002011432,1004011432,1006011432,1008011432,1010011432,1002021432,1004021432,1006021432,1008021432,1010021432,1002031432,1004031432,1006031432,1008031432,1010031432,1002041432,1004041432,1006041432,1008041432,1010041432]','[]','[]','[{0,1006021442,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071407,'副手','14阶红2星副手【龙骑士】',2,'[{lv,620}]',2,'[]','[1001011432,1007011432,1001021432,1007021432,1001031432,1007031432,1001041432,1007041432]','[]','[]','[{0,1007021442,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071408,'护腕','14阶红2星护腕【龙骑士】',2,'[{lv,620}]',2,'[]','[1002011432,1004011432,1006011432,1008011432,1010011432,1002021432,1004021432,1006021432,1008021432,1010021432,1002031432,1004031432,1006031432,1008031432,1010031432,1002041432,1004041432,1006041432,1008041432,1010041432]','[]','[]','[{0,1008021442,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071409,'戒指','14阶红2星戒指【通用】',2,'[{lv,620}]',2,'[]','[1005001432,1009001432,1005001432,1009001432,1005001432,1009001432,1005001432,1009001432]','[]','[]','[{0,1009001442,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071410,'鞋子','14阶红2星鞋子【龙骑士】',2,'[{lv,620}]',2,'[]','[1002011432,1004011432,1006011432,1008011432,1010011432,1002021432,1004021432,1006021432,1008021432,1010021432,1002031432,1004031432,1006031432,1008031432,1010031432,1002041432,1004041432,1006041432,1008041432,1010041432]','[]','[]','[{0,1010021442,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071501,'武器','15阶红2星武器【龙骑士】',2,'[{lv,650}]',2,'[]','[1001011532,1007011532,1001021532,1007021532,1001031532,1007031532,1001041532,1007041532]','[]','[]','[{0,1001021542,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071502,'头盔','15阶红2星头盔【龙骑士】',2,'[{lv,650}]',2,'[]','[1002011532,1004011532,1006011532,1008011532,1010011532,1002021532,1004021532,1006021532,1008021532,1010021532,1002031532,1004031532,1006031532,1008031532,1010031532,1002041532,1004041532,1006041532,1008041532,1010041532]','[]','[]','[{0,1002021542,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071503,'项链','15阶红2星项链【通用】',2,'[{lv,650}]',2,'[]','[1003001532,1003001532,1003001532,1003001532]','[]','[]','[{0,1003001542,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071504,'衣服','15阶红2星衣服【龙骑士】',2,'[{lv,650}]',2,'[]','[1002011532,1004011532,1006011532,1008011532,1010011532,1002021532,1004021532,1006021532,1008021532,1010021532,1002031532,1004031532,1006031532,1008031532,1010031532,1002041532,1004041532,1006041532,1008041532,1010041532]','[]','[]','[{0,1004021542,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071505,'刻痕','15阶红2星刻痕【通用】',2,'[{lv,650}]',2,'[]','[1005001532,1009001532,1005001532,1009001532,1005001532,1009001532,1005001532,1009001532]','[]','[]','[{0,1005001542,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071506,'裤子','15阶红2星裤子【龙骑士】',2,'[{lv,650}]',2,'[]','[1002011532,1004011532,1006011532,1008011532,1010011532,1002021532,1004021532,1006021532,1008021532,1010021532,1002031532,1004031532,1006031532,1008031532,1010031532,1002041532,1004041532,1006041532,1008041532,1010041532]','[]','[]','[{0,1006021542,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071507,'副手','15阶红2星副手【龙骑士】',2,'[{lv,650}]',2,'[]','[1001011532,1007011532,1001021532,1007021532,1001031532,1007031532,1001041532,1007041532]','[]','[]','[{0,1007021542,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071508,'护腕','15阶红2星护腕【龙骑士】',2,'[{lv,650}]',2,'[]','[1002011532,1004011532,1006011532,1008011532,1010011532,1002021532,1004021532,1006021532,1008021532,1010021532,1002031532,1004031532,1006031532,1008031532,1010031532,1002041532,1004041532,1006041532,1008041532,1010041532]','[]','[]','[{0,1008021542,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071509,'戒指','15阶红2星戒指【通用】',2,'[{lv,650}]',2,'[]','[1005001532,1009001532,1005001532,1009001532,1005001532,1009001532,1005001532,1009001532]','[]','[]','[{0,1009001542,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071510,'鞋子','15阶红2星鞋子【龙骑士】',2,'[{lv,650}]',2,'[]','[1002011532,1004011532,1006011532,1008011532,1010011532,1002021532,1004021532,1006021532,1008021532,1010021532,1002031532,1004031532,1006031532,1008031532,1010031532,1002041532,1004041532,1006041532,1008041532,1010041532]','[]','[]','[{0,1010021542,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071601,'武器','16阶红2星武器【龙骑士】',2,'[{lv,700}]',2,'[]','[1001011632,1007011632,1001021632,1007021632,1001031632,1007031632,1001041632,1007041632]','[]','[]','[{0,1001021642,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071602,'头盔','16阶红2星头盔【龙骑士】',2,'[{lv,700}]',2,'[]','[1002011632,1004011632,1006011632,1008011632,1010011632,1002021632,1004021632,1006021632,1008021632,1010021632,1002031632,1004031632,1006031632,1008031632,1010031632,1002041632,1004041632,1006041632,1008041632,1010041632]','[]','[]','[{0,1002021642,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071603,'项链','16阶红2星项链【通用】',2,'[{lv,700}]',2,'[]','[1003001632,1003001632,1003001632,1003001632]','[]','[]','[{0,1003001642,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071604,'衣服','16阶红2星衣服【龙骑士】',2,'[{lv,700}]',2,'[]','[1002011632,1004011632,1006011632,1008011632,1010011632,1002021632,1004021632,1006021632,1008021632,1010021632,1002031632,1004031632,1006031632,1008031632,1010031632,1002041632,1004041632,1006041632,1008041632,1010041632]','[]','[]','[{0,1004021642,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071605,'刻痕','16阶红2星刻痕【通用】',2,'[{lv,700}]',2,'[]','[1005001632,1009001632,1005001632,1009001632,1005001632,1009001632,1005001632,1009001632]','[]','[]','[{0,1005001642,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071606,'裤子','16阶红2星裤子【龙骑士】',2,'[{lv,700}]',2,'[]','[1002011632,1004011632,1006011632,1008011632,1010011632,1002021632,1004021632,1006021632,1008021632,1010021632,1002031632,1004031632,1006031632,1008031632,1010031632,1002041632,1004041632,1006041632,1008041632,1010041632]','[]','[]','[{0,1006021642,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071607,'副手','16阶红2星副手【龙骑士】',2,'[{lv,700}]',2,'[]','[1001011632,1007011632,1001021632,1007021632,1001031632,1007031632,1001041632,1007041632]','[]','[]','[{0,1007021642,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071608,'护腕','16阶红2星护腕【龙骑士】',2,'[{lv,700}]',2,'[]','[1002011632,1004011632,1006011632,1008011632,1010011632,1002021632,1004021632,1006021632,1008021632,1010021632,1002031632,1004031632,1006031632,1008031632,1010031632,1002041632,1004041632,1006041632,1008041632,1010041632]','[]','[]','[{0,1008021642,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071609,'戒指','16阶红2星戒指【通用】',2,'[{lv,700}]',2,'[]','[1005001632,1009001632,1005001632,1009001632,1005001632,1009001632,1005001632,1009001632]','[]','[]','[{0,1009001642,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32071610,'鞋子','16阶红2星鞋子【龙骑士】',2,'[{lv,700}]',2,'[]','[1002011632,1004011632,1006011632,1008011632,1010011632,1002021632,1004021632,1006021632,1008021632,1010021632,1002031632,1004031632,1006031632,1008031632,1010031632,1002041632,1004041632,1006041632,1008041632,1010041632]','[]','[]','[{0,1010021642,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32080301,'武器','3阶红3星武器【龙骑士】',2,'[{lv,9999}]',2,'[]','[1001010342,1007010342,1001020342,1007020342,1001030342,1007030342,1001040342,1007040342]','[]','[]','[{0,1001020343,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(32080302,'头盔','3阶红3星头盔【龙骑士】',2,'[{lv,9999}]',2,'[]','[1002010342,1004010342,1006010342,1008010342,1010010342,1002020342,1004020342,1006020342,1008020342,1010020342,1002030342,1004030342,1006030342,1008030342,1010030342,1002040342,1004040342,1006040342,1008040342,1010040342]','[]','[]','[{0,1002020343,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(32080303,'项链','3阶红3星项链【通用】',2,'[{lv,9999}]',2,'[]','[1003000342,1003000342,1003000342,1003000342]','[]','[]','[{0,1003000343,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(32080304,'衣服','3阶红3星衣服【龙骑士】',2,'[{lv,9999}]',2,'[]','[1002010342,1004010342,1006010342,1008010342,1010010342,1002020342,1004020342,1006020342,1008020342,1010020342,1002030342,1004030342,1006030342,1008030342,1010030342,1002040342,1004040342,1006040342,1008040342,1010040342]','[]','[]','[{0,1004020343,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(32080305,'刻痕','3阶红3星刻痕【通用】',2,'[{lv,9999}]',2,'[]','[1005000342,1009000342,1005000342,1009000342,1005000342,1009000342,1005000342,1009000342]','[]','[]','[{0,1005000343,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(32080306,'裤子','3阶红3星裤子【龙骑士】',2,'[{lv,9999}]',2,'[]','[1002010342,1004010342,1006010342,1008010342,1010010342,1002020342,1004020342,1006020342,1008020342,1010020342,1002030342,1004030342,1006030342,1008030342,1010030342,1002040342,1004040342,1006040342,1008040342,1010040342]','[]','[]','[{0,1006020343,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(32080307,'副手','3阶红3星副手【龙骑士】',2,'[{lv,9999}]',2,'[]','[1001010342,1007010342,1001020342,1007020342,1001030342,1007030342,1001040342,1007040342]','[]','[]','[{0,1007020343,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(32080308,'护腕','3阶红3星护腕【龙骑士】',2,'[{lv,9999}]',2,'[]','[1002010342,1004010342,1006010342,1008010342,1010010342,1002020342,1004020342,1006020342,1008020342,1010020342,1002030342,1004030342,1006030342,1008030342,1010030342,1002040342,1004040342,1006040342,1008040342,1010040342]','[]','[]','[{0,1008020343,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(32080309,'戒指','3阶红3星戒指【通用】',2,'[{lv,9999}]',2,'[]','[1005000342,1009000342,1005000342,1009000342,1005000342,1009000342,1005000342,1009000342]','[]','[]','[{0,1009000343,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(32080310,'鞋子','3阶红3星鞋子【龙骑士】',2,'[{lv,9999}]',2,'[]','[1002010342,1004010342,1006010342,1008010342,1010010342,1002020342,1004020342,1006020342,1008020342,1010020342,1002030342,1004030342,1006030342,1008030342,1010030342,1002040342,1004040342,1006040342,1008040342,1010040342]','[]','[]','[{0,1010020343,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(32080401,'武器','4阶红3星武器【龙骑士】',2,'[{lv,160}]',2,'[]','[1001010442,1007010442,1001020442,1007020442,1001030442,1007030442,1001040442,1007040442,1101010442,1107010442,1101020442,1107020442,1101030442,1107030442,1101040442,1107040442]','[]','[]','[{0,1001020443,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(32080402,'头盔','4阶红3星头盔【龙骑士】',2,'[{lv,160}]',2,'[]','[1002010442,1004010442,1006010442,1008010442,1010010442,1002020442,1004020442,1006020442,1008020442,1010020442,1002030442,1004030442,1006030442,1008030442,1010030442,1002040442,1004040442,1006040442,1008040442,1010040442,1102010442,1104010442,1106010442,1108010442,1110010442,1102020442,1104020442,1106020442,1108020442,1110020442,1102030442,1104030442,1106030442,1108030442,1110030442,1102040442,1104040442,1106040442,1108040442,1110040442]','[]','[]','[{0,1002020443,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(32080403,'项链','4阶红3星项链【通用】',2,'[{lv,160}]',2,'[]','[1003000442,1003000442,1003000442,1003000442,1103000442,1103000442,1103000442,1103000442]','[]','[]','[{0,1003000443,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(32080404,'衣服','4阶红3星衣服【龙骑士】',2,'[{lv,160}]',2,'[]','[1002010442,1004010442,1006010442,1008010442,1010010442,1002020442,1004020442,1006020442,1008020442,1010020442,1002030442,1004030442,1006030442,1008030442,1010030442,1002040442,1004040442,1006040442,1008040442,1010040442,1102010442,1104010442,1106010442,1108010442,1110010442,1102020442,1104020442,1106020442,1108020442,1110020442,1102030442,1104030442,1106030442,1108030442,1110030442,1102040442,1104040442,1106040442,1108040442,1110040442]','[]','[]','[{0,1004020443,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(32080405,'刻痕','4阶红3星刻痕【通用】',2,'[{lv,160}]',2,'[]','[1005000442,1009000442,1005000442,1009000442,1005000442,1009000442,1005000442,1009000442,1105000442,1109000442,1105000442,1109000442,1105000442,1109000442,1105000442,1109000442]','[]','[]','[{0,1005000443,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(32080406,'裤子','4阶红3星裤子【龙骑士】',2,'[{lv,160}]',2,'[]','[1002010442,1004010442,1006010442,1008010442,1010010442,1002020442,1004020442,1006020442,1008020442,1010020442,1002030442,1004030442,1006030442,1008030442,1010030442,1002040442,1004040442,1006040442,1008040442,1010040442,1102010442,1104010442,1106010442,1108010442,1110010442,1102020442,1104020442,1106020442,1108020442,1110020442,1102030442,1104030442,1106030442,1108030442,1110030442,1102040442,1104040442,1106040442,1108040442,1110040442]','[]','[]','[{0,1006020443,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(32080407,'副手','4阶红3星副手【龙骑士】',2,'[{lv,160}]',2,'[]','[1001010442,1007010442,1001020442,1007020442,1001030442,1007030442,1001040442,1007040442,1101010442,1107010442,1101020442,1107020442,1101030442,1107030442,1101040442,1107040442]','[]','[]','[{0,1007020443,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(32080408,'护腕','4阶红3星护腕【龙骑士】',2,'[{lv,160}]',2,'[]','[1002010442,1004010442,1006010442,1008010442,1010010442,1002020442,1004020442,1006020442,1008020442,1010020442,1002030442,1004030442,1006030442,1008030442,1010030442,1002040442,1004040442,1006040442,1008040442,1010040442,1102010442,1104010442,1106010442,1108010442,1110010442,1102020442,1104020442,1106020442,1108020442,1110020442,1102030442,1104030442,1106030442,1108030442,1110030442,1102040442,1104040442,1106040442,1108040442,1110040442]','[]','[]','[{0,1008020443,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(32080409,'戒指','4阶红3星戒指【通用】',2,'[{lv,160}]',2,'[]','[1005000442,1009000442,1005000442,1009000442,1005000442,1009000442,1005000442,1009000442,1105000442,1109000442,1105000442,1109000442,1105000442,1109000442,1105000442,1109000442]','[]','[]','[{0,1009000443,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(32080410,'鞋子','4阶红3星鞋子【龙骑士】',2,'[{lv,160}]',2,'[]','[1002010442,1004010442,1006010442,1008010442,1010010442,1002020442,1004020442,1006020442,1008020442,1010020442,1002030442,1004030442,1006030442,1008030442,1010030442,1002040442,1004040442,1006040442,1008040442,1010040442,1102010442,1104010442,1106010442,1108010442,1110010442,1102020442,1104020442,1106020442,1108020442,1110020442,1102030442,1104030442,1106030442,1108030442,1110030442,1102040442,1104040442,1106040442,1108040442,1110040442]','[]','[]','[{0,1010020443,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(32080501,'武器','5阶红3星武器【龙骑士】',2,'[{lv,160}]',2,'[]','[1001010542,1007010542,1001020542,1007020542,1001030542,1007030542,1001040542,1007040542,1101010542,1101020542,1101030542,1101040542]','[]','[]','[{0,1001020543,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(32080502,'头盔','5阶红3星头盔【龙骑士】',2,'[{lv,160}]',2,'[]','[1002010542,1004010542,1006010542,1008010542,1010010542,1002020542,1004020542,1006020542,1008020542,1010020542,1002030542,1004030542,1006030542,1008030542,1010030542,1002040542,1004040542,1006040542,1008040542,1010040542,1102010542,1104010542,1106010542,1102020542,1104020542,1106020542,1102030542,1104030542,1106030542,1102040542,1104040542,1106040542]','[]','[]','[{0,1002020543,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(32080503,'项链','5阶红3星项链【通用】',2,'[{lv,160}]',2,'[]','[1003000542,1003000542,1003000542,1003000542,1103000542,1103000542,1103000542,1103000542]','[]','[]','[{0,1003000543,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(32080504,'衣服','5阶红3星衣服【龙骑士】',2,'[{lv,160}]',2,'[]','[1002010542,1004010542,1006010542,1008010542,1010010542,1002020542,1004020542,1006020542,1008020542,1010020542,1002030542,1004030542,1006030542,1008030542,1010030542,1002040542,1004040542,1006040542,1008040542,1010040542,1102010542,1104010542,1106010542,1102020542,1104020542,1106020542,1102030542,1104030542,1106030542,1102040542,1104040542,1106040542]','[]','[]','[{0,1004020543,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(32080505,'刻痕','5阶红3星刻痕【通用】',2,'[{lv,160}]',2,'[]','[1005000542,1009000542,1005000542,1009000542,1005000542,1009000542,1005000542,1009000542,1105000542,1105000542,1105000542,1105000542]','[]','[]','[{0,1005000543,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(32080506,'裤子','5阶红3星裤子【龙骑士】',2,'[{lv,160}]',2,'[]','[1002010542,1004010542,1006010542,1008010542,1010010542,1002020542,1004020542,1006020542,1008020542,1010020542,1002030542,1004030542,1006030542,1008030542,1010030542,1002040542,1004040542,1006040542,1008040542,1010040542,1102010542,1104010542,1106010542,1102020542,1104020542,1106020542,1102030542,1104030542,1106030542,1102040542,1104040542,1106040542]','[]','[]','[{0,1006020543,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(32080507,'副手','5阶红3星副手【龙骑士】',2,'[{lv,160}]',2,'[]','[1001010542,1007010542,1001020542,1007020542,1001030542,1007030542,1001040542,1007040542,1101010542,1101020542,1101030542,1101040542]','[]','[]','[{0,1007020543,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(32080508,'护腕','5阶红3星护腕【龙骑士】',2,'[{lv,160}]',2,'[]','[1002010542,1004010542,1006010542,1008010542,1010010542,1002020542,1004020542,1006020542,1008020542,1010020542,1002030542,1004030542,1006030542,1008030542,1010030542,1002040542,1004040542,1006040542,1008040542,1010040542,1102010542,1104010542,1106010542,1102020542,1104020542,1106020542,1102030542,1104030542,1106030542,1102040542,1104040542,1106040542]','[]','[]','[{0,1008020543,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(32080509,'戒指','5阶红3星戒指【通用】',2,'[{lv,160}]',2,'[]','[1005000542,1009000542,1005000542,1009000542,1005000542,1009000542,1005000542,1009000542,1105000542,1105000542,1105000542,1105000542]','[]','[]','[{0,1009000543,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(32080510,'鞋子','5阶红3星鞋子【龙骑士】',2,'[{lv,160}]',2,'[]','[1002010542,1004010542,1006010542,1008010542,1010010542,1002020542,1004020542,1006020542,1008020542,1010020542,1002030542,1004030542,1006030542,1008030542,1010030542,1002040542,1004040542,1006040542,1008040542,1010040542,1102010542,1104010542,1106010542,1102020542,1104020542,1106020542,1102030542,1104030542,1106030542,1102040542,1104040542,1106040542]','[]','[]','[{0,1010020543,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(32080601,'武器','6阶红3星武器【龙骑士】',2,'[{lv,180}]',2,'[]','[1001010642,1007010642,1001020642,1007020642,1001030642,1007030642,1001040642,1007040642]','[]','[]','[{0,1001020643,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(32080602,'头盔','6阶红3星头盔【龙骑士】',2,'[{lv,180}]',2,'[]','[1002010642,1004010642,1006010642,1008010642,1010010642,1002020642,1004020642,1006020642,1008020642,1010020642,1002030642,1004030642,1006030642,1008030642,1010030642,1002040642,1004040642,1006040642,1008040642,1010040642]','[]','[]','[{0,1002020643,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(32080603,'项链','6阶红3星项链【通用】',2,'[{lv,180}]',2,'[]','[1003000642,1003000642,1003000642,1003000642]','[]','[]','[{0,1003000643,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(32080604,'衣服','6阶红3星衣服【龙骑士】',2,'[{lv,180}]',2,'[]','[1002010642,1004010642,1006010642,1008010642,1010010642,1002020642,1004020642,1006020642,1008020642,1010020642,1002030642,1004030642,1006030642,1008030642,1010030642,1002040642,1004040642,1006040642,1008040642,1010040642]','[]','[]','[{0,1004020643,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(32080605,'刻痕','6阶红3星刻痕【通用】',2,'[{lv,180}]',2,'[]','[1005000642,1009000642,1005000642,1009000642,1005000642,1009000642,1005000642,1009000642]','[]','[]','[{0,1005000643,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(32080606,'裤子','6阶红3星裤子【龙骑士】',2,'[{lv,180}]',2,'[]','[1002010642,1004010642,1006010642,1008010642,1010010642,1002020642,1004020642,1006020642,1008020642,1010020642,1002030642,1004030642,1006030642,1008030642,1010030642,1002040642,1004040642,1006040642,1008040642,1010040642]','[]','[]','[{0,1006020643,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(32080607,'副手','6阶红3星副手【龙骑士】',2,'[{lv,180}]',2,'[]','[1001010642,1007010642,1001020642,1007020642,1001030642,1007030642,1001040642,1007040642]','[]','[]','[{0,1007020643,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(32080608,'护腕','6阶红3星护腕【龙骑士】',2,'[{lv,180}]',2,'[]','[1002010642,1004010642,1006010642,1008010642,1010010642,1002020642,1004020642,1006020642,1008020642,1010020642,1002030642,1004030642,1006030642,1008030642,1010030642,1002040642,1004040642,1006040642,1008040642,1010040642]','[]','[]','[{0,1008020643,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(32080609,'戒指','6阶红3星戒指【通用】',2,'[{lv,180}]',2,'[]','[1005000642,1009000642,1005000642,1009000642,1005000642,1009000642,1005000642,1009000642]','[]','[]','[{0,1009000643,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(32080610,'鞋子','6阶红3星鞋子【龙骑士】',2,'[{lv,180}]',2,'[]','[1002010642,1004010642,1006010642,1008010642,1010010642,1002020642,1004020642,1006020642,1008020642,1010020642,1002030642,1004030642,1006030642,1008030642,1010030642,1002040642,1004040642,1006040642,1008040642,1010040642]','[]','[]','[{0,1010020643,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(32080701,'武器','7阶红3星武器【龙骑士】',2,'[{lv,220}]',2,'[]','[1001010742,1007010742,1001020742,1007020742,1001030742,1007030742,1001040742,1007040742,1101010742,1107010742,1101020742,1107020742,1101030742,1107030742,1101040742,1107040742]','[]','[]','[{0,1001020743,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32080702,'头盔','7阶红3星头盔【龙骑士】',2,'[{lv,220}]',2,'[]','[1002010742,1004010742,1006010742,1008010742,1010010742,1002020742,1004020742,1006020742,1008020742,1010020742,1002030742,1004030742,1006030742,1008030742,1010030742,1002040742,1004040742,1006040742,1008040742,1010040742,1102010742,1104010742,1106010742,1108010742,1110010742,1102020742,1104020742,1106020742,1108020742,1110020742,1102030742,1104030742,1106030742,1108030742,1110030742,1102040742,1104040742,1106040742,1108040742,1110040742]','[]','[]','[{0,1002020743,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32080703,'项链','7阶红3星项链【通用】',2,'[{lv,220}]',2,'[]','[1003000742,1003000742,1003000742,1003000742,1103000742,1103000742,1103000742,1103000742]','[]','[]','[{0,1003000743,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32080704,'衣服','7阶红3星衣服【龙骑士】',2,'[{lv,220}]',2,'[]','[1002010742,1004010742,1006010742,1008010742,1010010742,1002020742,1004020742,1006020742,1008020742,1010020742,1002030742,1004030742,1006030742,1008030742,1010030742,1002040742,1004040742,1006040742,1008040742,1010040742,1102010742,1104010742,1106010742,1108010742,1110010742,1102020742,1104020742,1106020742,1108020742,1110020742,1102030742,1104030742,1106030742,1108030742,1110030742,1102040742,1104040742,1106040742,1108040742,1110040742]','[]','[]','[{0,1004020743,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32080705,'刻痕','7阶红3星刻痕【通用】',2,'[{lv,220}]',2,'[]','[1005000742,1009000742,1005000742,1009000742,1005000742,1009000742,1005000742,1009000742,1105000742,1109000742,1105000742,1109000742,1105000742,1109000742,1105000742,1109000742]','[]','[]','[{0,1005000743,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32080706,'裤子','7阶红3星裤子【龙骑士】',2,'[{lv,220}]',2,'[]','[1002010742,1004010742,1006010742,1008010742,1010010742,1002020742,1004020742,1006020742,1008020742,1010020742,1002030742,1004030742,1006030742,1008030742,1010030742,1002040742,1004040742,1006040742,1008040742,1010040742,1102010742,1104010742,1106010742,1108010742,1110010742,1102020742,1104020742,1106020742,1108020742,1110020742,1102030742,1104030742,1106030742,1108030742,1110030742,1102040742,1104040742,1106040742,1108040742,1110040742]','[]','[]','[{0,1006020743,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32080707,'副手','7阶红3星副手【龙骑士】',2,'[{lv,220}]',2,'[]','[1001010742,1007010742,1001020742,1007020742,1001030742,1007030742,1001040742,1007040742,1101010742,1107010742,1101020742,1107020742,1101030742,1107030742,1101040742,1107040742]','[]','[]','[{0,1007020743,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32080708,'护腕','7阶红3星护腕【龙骑士】',2,'[{lv,220}]',2,'[]','[1002010742,1004010742,1006010742,1008010742,1010010742,1002020742,1004020742,1006020742,1008020742,1010020742,1002030742,1004030742,1006030742,1008030742,1010030742,1002040742,1004040742,1006040742,1008040742,1010040742,1102010742,1104010742,1106010742,1108010742,1110010742,1102020742,1104020742,1106020742,1108020742,1110020742,1102030742,1104030742,1106030742,1108030742,1110030742,1102040742,1104040742,1106040742,1108040742,1110040742]','[]','[]','[{0,1008020743,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32080709,'戒指','7阶红3星戒指【通用】',2,'[{lv,220}]',2,'[]','[1005000742,1009000742,1005000742,1009000742,1005000742,1009000742,1005000742,1009000742,1105000742,1109000742,1105000742,1109000742,1105000742,1109000742,1105000742,1109000742]','[]','[]','[{0,1009000743,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32080710,'鞋子','7阶红3星鞋子【龙骑士】',2,'[{lv,220}]',2,'[]','[1002010742,1004010742,1006010742,1008010742,1010010742,1002020742,1004020742,1006020742,1008020742,1010020742,1002030742,1004030742,1006030742,1008030742,1010030742,1002040742,1004040742,1006040742,1008040742,1010040742,1102010742,1104010742,1106010742,1108010742,1110010742,1102020742,1104020742,1106020742,1108020742,1110020742,1102030742,1104030742,1106030742,1108030742,1110030742,1102040742,1104040742,1106040742,1108040742,1110040742]','[]','[]','[{0,1010020743,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32080801,'武器','8阶红3星武器【龙骑士】',2,'[{lv,260}]',2,'[]','[1001010842,1007010842,1001020842,1007020842,1001030842,1007030842,1001040842,1007040842,1101010842,1107010842,1101020842,1107020842,1101030842,1107030842,1101040842,1107040842]','[]','[]','[{0,1001020843,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32080802,'头盔','8阶红3星头盔【龙骑士】',2,'[{lv,260}]',2,'[]','[1002010842,1004010842,1006010842,1008010842,1010010842,1002020842,1004020842,1006020842,1008020842,1010020842,1002030842,1004030842,1006030842,1008030842,1010030842,1002040842,1004040842,1006040842,1008040842,1010040842,1102010842,1104010842,1106010842,1108010842,1110010842,1102020842,1104020842,1106020842,1108020842,1110020842,1102030842,1104030842,1106030842,1108030842,1110030842,1102040842,1104040842,1106040842,1108040842,1110040842]','[]','[]','[{0,1002020843,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32080803,'项链','8阶红3星项链【通用】',2,'[{lv,260}]',2,'[]','[1003000842,1003000842,1003000842,1003000842,1103000842,1103000842,1103000842,1103000842]','[]','[]','[{0,1003000843,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32080804,'衣服','8阶红3星衣服【龙骑士】',2,'[{lv,260}]',2,'[]','[1002010842,1004010842,1006010842,1008010842,1010010842,1002020842,1004020842,1006020842,1008020842,1010020842,1002030842,1004030842,1006030842,1008030842,1010030842,1002040842,1004040842,1006040842,1008040842,1010040842,1102010842,1104010842,1106010842,1108010842,1110010842,1102020842,1104020842,1106020842,1108020842,1110020842,1102030842,1104030842,1106030842,1108030842,1110030842,1102040842,1104040842,1106040842,1108040842,1110040842]','[]','[]','[{0,1004020843,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32080805,'刻痕','8阶红3星刻痕【通用】',2,'[{lv,260}]',2,'[]','[1005000842,1009000842,1005000842,1009000842,1005000842,1009000842,1005000842,1009000842,1105000842,1109000842,1105000842,1109000842,1105000842,1109000842,1105000842,1109000842]','[]','[]','[{0,1005000843,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32080806,'裤子','8阶红3星裤子【龙骑士】',2,'[{lv,260}]',2,'[]','[1002010842,1004010842,1006010842,1008010842,1010010842,1002020842,1004020842,1006020842,1008020842,1010020842,1002030842,1004030842,1006030842,1008030842,1010030842,1002040842,1004040842,1006040842,1008040842,1010040842,1102010842,1104010842,1106010842,1108010842,1110010842,1102020842,1104020842,1106020842,1108020842,1110020842,1102030842,1104030842,1106030842,1108030842,1110030842,1102040842,1104040842,1106040842,1108040842,1110040842]','[]','[]','[{0,1006020843,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32080807,'副手','8阶红3星副手【龙骑士】',2,'[{lv,260}]',2,'[]','[1001010842,1007010842,1001020842,1007020842,1001030842,1007030842,1001040842,1007040842,1101010842,1107010842,1101020842,1107020842,1101030842,1107030842,1101040842,1107040842]','[]','[]','[{0,1007020843,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32080808,'护腕','8阶红3星护腕【龙骑士】',2,'[{lv,260}]',2,'[]','[1002010842,1004010842,1006010842,1008010842,1010010842,1002020842,1004020842,1006020842,1008020842,1010020842,1002030842,1004030842,1006030842,1008030842,1010030842,1002040842,1004040842,1006040842,1008040842,1010040842,1102010842,1104010842,1106010842,1108010842,1110010842,1102020842,1104020842,1106020842,1108020842,1110020842,1102030842,1104030842,1106030842,1108030842,1110030842,1102040842,1104040842,1106040842,1108040842,1110040842]','[]','[]','[{0,1008020843,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32080809,'戒指','8阶红3星戒指【通用】',2,'[{lv,260}]',2,'[]','[1005000842,1009000842,1005000842,1009000842,1005000842,1009000842,1005000842,1009000842,1105000842,1109000842,1105000842,1109000842,1105000842,1109000842,1105000842,1109000842]','[]','[]','[{0,1009000843,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32080810,'鞋子','8阶红3星鞋子【龙骑士】',2,'[{lv,260}]',2,'[]','[1002010842,1004010842,1006010842,1008010842,1010010842,1002020842,1004020842,1006020842,1008020842,1010020842,1002030842,1004030842,1006030842,1008030842,1010030842,1002040842,1004040842,1006040842,1008040842,1010040842,1102010842,1104010842,1106010842,1108010842,1110010842,1102020842,1104020842,1106020842,1108020842,1110020842,1102030842,1104030842,1106030842,1108030842,1110030842,1102040842,1104040842,1106040842,1108040842,1110040842]','[]','[]','[{0,1010020843,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32080901,'武器','9阶红3星武器【龙骑士】',2,'[{lv,300}]',2,'[]','[1001010942,1007010942,1001020942,1007020942,1001030942,1007030942,1001040942,1007040942]','[]','[]','[{0,1001020943,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32080902,'头盔','9阶红3星头盔【龙骑士】',2,'[{lv,300}]',2,'[]','[1002010942,1004010942,1006010942,1008010942,1010010942,1002020942,1004020942,1006020942,1008020942,1010020942,1002030942,1004030942,1006030942,1008030942,1010030942,1002040942,1004040942,1006040942,1008040942,1010040942]','[]','[]','[{0,1002020943,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32080903,'项链','9阶红3星项链【通用】',2,'[{lv,300}]',2,'[]','[1003000942,1003000942,1003000942,1003000942]','[]','[]','[{0,1003000943,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32080904,'衣服','9阶红3星衣服【龙骑士】',2,'[{lv,300}]',2,'[]','[1002010942,1004010942,1006010942,1008010942,1010010942,1002020942,1004020942,1006020942,1008020942,1010020942,1002030942,1004030942,1006030942,1008030942,1010030942,1002040942,1004040942,1006040942,1008040942,1010040942]','[]','[]','[{0,1004020943,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32080905,'刻痕','9阶红3星刻痕【通用】',2,'[{lv,300}]',2,'[]','[1005000942,1009000942,1005000942,1009000942,1005000942,1009000942,1005000942,1009000942]','[]','[]','[{0,1005000943,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32080906,'裤子','9阶红3星裤子【龙骑士】',2,'[{lv,300}]',2,'[]','[1002010942,1004010942,1006010942,1008010942,1010010942,1002020942,1004020942,1006020942,1008020942,1010020942,1002030942,1004030942,1006030942,1008030942,1010030942,1002040942,1004040942,1006040942,1008040942,1010040942]','[]','[]','[{0,1006020943,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32080907,'副手','9阶红3星副手【龙骑士】',2,'[{lv,300}]',2,'[]','[1001010942,1007010942,1001020942,1007020942,1001030942,1007030942,1001040942,1007040942]','[]','[]','[{0,1007020943,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32080908,'护腕','9阶红3星护腕【龙骑士】',2,'[{lv,300}]',2,'[]','[1002010942,1004010942,1006010942,1008010942,1010010942,1002020942,1004020942,1006020942,1008020942,1010020942,1002030942,1004030942,1006030942,1008030942,1010030942,1002040942,1004040942,1006040942,1008040942,1010040942]','[]','[]','[{0,1008020943,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32080909,'戒指','9阶红3星戒指【通用】',2,'[{lv,300}]',2,'[]','[1005000942,1009000942,1005000942,1009000942,1005000942,1009000942,1005000942,1009000942]','[]','[]','[{0,1009000943,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32080910,'鞋子','9阶红3星鞋子【龙骑士】',2,'[{lv,300}]',2,'[]','[1002010942,1004010942,1006010942,1008010942,1010010942,1002020942,1004020942,1006020942,1008020942,1010020942,1002030942,1004030942,1006030942,1008030942,1010030942,1002040942,1004040942,1006040942,1008040942,1010040942]','[]','[]','[{0,1010020943,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081001,'武器','10阶红3星武器【龙骑士】',2,'[{lv,355}]',2,'[]','[1001011042,1007011042,1001021042,1007021042,1001031042,1007031042,1001041042,1007041042]','[]','[]','[{0,1001021043,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081002,'头盔','10阶红3星头盔【龙骑士】',2,'[{lv,355}]',2,'[]','[1002011042,1004011042,1006011042,1008011042,1010011042,1002021042,1004021042,1006021042,1008021042,1010021042,1002031042,1004031042,1006031042,1008031042,1010031042,1002041042,1004041042,1006041042,1008041042,1010041042]','[]','[]','[{0,1002021043,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081003,'项链','10阶红3星项链【通用】',2,'[{lv,355}]',2,'[]','[1003001042,1003001042,1003001042,1003001042]','[]','[]','[{0,1003001043,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081004,'衣服','10阶红3星衣服【龙骑士】',2,'[{lv,355}]',2,'[]','[1002011042,1004011042,1006011042,1008011042,1010011042,1002021042,1004021042,1006021042,1008021042,1010021042,1002031042,1004031042,1006031042,1008031042,1010031042,1002041042,1004041042,1006041042,1008041042,1010041042]','[]','[]','[{0,1004021043,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081005,'刻痕','10阶红3星刻痕【通用】',2,'[{lv,355}]',2,'[]','[1005001042,1009001042,1005001042,1009001042,1005001042,1009001042,1005001042,1009001042]','[]','[]','[{0,1005001043,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081006,'裤子','10阶红3星裤子【龙骑士】',2,'[{lv,355}]',2,'[]','[1002011042,1004011042,1006011042,1008011042,1010011042,1002021042,1004021042,1006021042,1008021042,1010021042,1002031042,1004031042,1006031042,1008031042,1010031042,1002041042,1004041042,1006041042,1008041042,1010041042]','[]','[]','[{0,1006021043,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081007,'副手','10阶红3星副手【龙骑士】',2,'[{lv,355}]',2,'[]','[1001011042,1007011042,1001021042,1007021042,1001031042,1007031042,1001041042,1007041042]','[]','[]','[{0,1007021043,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081008,'护腕','10阶红3星护腕【龙骑士】',2,'[{lv,355}]',2,'[]','[1002011042,1004011042,1006011042,1008011042,1010011042,1002021042,1004021042,1006021042,1008021042,1010021042,1002031042,1004031042,1006031042,1008031042,1010031042,1002041042,1004041042,1006041042,1008041042,1010041042]','[]','[]','[{0,1008021043,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081009,'戒指','10阶红3星戒指【通用】',2,'[{lv,355}]',2,'[]','[1005001042,1009001042,1005001042,1009001042,1005001042,1009001042,1005001042,1009001042]','[]','[]','[{0,1009001043,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081010,'鞋子','10阶红3星鞋子【龙骑士】',2,'[{lv,355}]',2,'[]','[1002011042,1004011042,1006011042,1008011042,1010011042,1002021042,1004021042,1006021042,1008021042,1010021042,1002031042,1004031042,1006031042,1008031042,1010031042,1002041042,1004041042,1006041042,1008041042,1010041042]','[]','[]','[{0,1010021043,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081101,'武器','11阶红3星武器【龙骑士】',2,'[{lv,400}]',2,'[]','[1001011142,1007011142,1001021142,1007021142,1001031142,1007031142,1001041142,1007041142]','[]','[]','[{0,1001021143,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081102,'头盔','11阶红3星头盔【龙骑士】',2,'[{lv,400}]',2,'[]','[1002011142,1004011142,1006011142,1008011142,1010011142,1002021142,1004021142,1006021142,1008021142,1010021142,1002031142,1004031142,1006031142,1008031142,1010031142,1002041142,1004041142,1006041142,1008041142,1010041142]','[]','[]','[{0,1002021143,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081103,'项链','11阶红3星项链【通用】',2,'[{lv,400}]',2,'[]','[1003001142,1003001142,1003001142,1003001142]','[]','[]','[{0,1003001143,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081104,'衣服','11阶红3星衣服【龙骑士】',2,'[{lv,400}]',2,'[]','[1002011142,1004011142,1006011142,1008011142,1010011142,1002021142,1004021142,1006021142,1008021142,1010021142,1002031142,1004031142,1006031142,1008031142,1010031142,1002041142,1004041142,1006041142,1008041142,1010041142]','[]','[]','[{0,1004021143,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081105,'刻痕','11阶红3星刻痕【通用】',2,'[{lv,400}]',2,'[]','[1005001142,1009001142,1005001142,1009001142,1005001142,1009001142,1005001142,1009001142]','[]','[]','[{0,1005001143,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081106,'裤子','11阶红3星裤子【龙骑士】',2,'[{lv,400}]',2,'[]','[1002011142,1004011142,1006011142,1008011142,1010011142,1002021142,1004021142,1006021142,1008021142,1010021142,1002031142,1004031142,1006031142,1008031142,1010031142,1002041142,1004041142,1006041142,1008041142,1010041142]','[]','[]','[{0,1006021143,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081107,'副手','11阶红3星副手【龙骑士】',2,'[{lv,400}]',2,'[]','[1001011142,1007011142,1001021142,1007021142,1001031142,1007031142,1001041142,1007041142]','[]','[]','[{0,1007021143,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081108,'护腕','11阶红3星护腕【龙骑士】',2,'[{lv,400}]',2,'[]','[1002011142,1004011142,1006011142,1008011142,1010011142,1002021142,1004021142,1006021142,1008021142,1010021142,1002031142,1004031142,1006031142,1008031142,1010031142,1002041142,1004041142,1006041142,1008041142,1010041142]','[]','[]','[{0,1008021143,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081109,'戒指','11阶红3星戒指【通用】',2,'[{lv,400}]',2,'[]','[1005001142,1009001142,1005001142,1009001142,1005001142,1009001142,1005001142,1009001142]','[]','[]','[{0,1009001143,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081110,'鞋子','11阶红3星鞋子【龙骑士】',2,'[{lv,400}]',2,'[]','[1002011142,1004011142,1006011142,1008011142,1010011142,1002021142,1004021142,1006021142,1008021142,1010021142,1002031142,1004031142,1006031142,1008031142,1010031142,1002041142,1004041142,1006041142,1008041142,1010041142]','[]','[]','[{0,1010021143,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081201,'武器','12阶红3星武器【龙骑士】',2,'[{lv,500}]',2,'[]','[1001011242,1007011242,1001021242,1007021242,1001031242,1007031242,1001041242,1007041242]','[]','[]','[{0,1001021243,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081202,'头盔','12阶红3星头盔【龙骑士】',2,'[{lv,500}]',2,'[]','[1002011242,1004011242,1006011242,1008011242,1010011242,1002021242,1004021242,1006021242,1008021242,1010021242,1002031242,1004031242,1006031242,1008031242,1010031242,1002041242,1004041242,1006041242,1008041242,1010041242]','[]','[]','[{0,1002021243,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081203,'项链','12阶红3星项链【通用】',2,'[{lv,500}]',2,'[]','[1003001242,1003001242,1003001242,1003001242]','[]','[]','[{0,1003001243,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081204,'衣服','12阶红3星衣服【龙骑士】',2,'[{lv,500}]',2,'[]','[1002011242,1004011242,1006011242,1008011242,1010011242,1002021242,1004021242,1006021242,1008021242,1010021242,1002031242,1004031242,1006031242,1008031242,1010031242,1002041242,1004041242,1006041242,1008041242,1010041242]','[]','[]','[{0,1004021243,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081205,'刻痕','12阶红3星刻痕【通用】',2,'[{lv,500}]',2,'[]','[1005001242,1009001242,1005001242,1009001242,1005001242,1009001242,1005001242,1009001242]','[]','[]','[{0,1005001243,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081206,'裤子','12阶红3星裤子【龙骑士】',2,'[{lv,500}]',2,'[]','[1002011242,1004011242,1006011242,1008011242,1010011242,1002021242,1004021242,1006021242,1008021242,1010021242,1002031242,1004031242,1006031242,1008031242,1010031242,1002041242,1004041242,1006041242,1008041242,1010041242]','[]','[]','[{0,1006021243,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081207,'副手','12阶红3星副手【龙骑士】',2,'[{lv,500}]',2,'[]','[1001011242,1007011242,1001021242,1007021242,1001031242,1007031242,1001041242,1007041242]','[]','[]','[{0,1007021243,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081208,'护腕','12阶红3星护腕【龙骑士】',2,'[{lv,500}]',2,'[]','[1002011242,1004011242,1006011242,1008011242,1010011242,1002021242,1004021242,1006021242,1008021242,1010021242,1002031242,1004031242,1006031242,1008031242,1010031242,1002041242,1004041242,1006041242,1008041242,1010041242]','[]','[]','[{0,1008021243,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081209,'戒指','12阶红3星戒指【通用】',2,'[{lv,500}]',2,'[]','[1005001242,1009001242,1005001242,1009001242,1005001242,1009001242,1005001242,1009001242]','[]','[]','[{0,1009001243,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081210,'鞋子','12阶红3星鞋子【龙骑士】',2,'[{lv,500}]',2,'[]','[1002011242,1004011242,1006011242,1008011242,1010011242,1002021242,1004021242,1006021242,1008021242,1010021242,1002031242,1004031242,1006031242,1008031242,1010031242,1002041242,1004041242,1006041242,1008041242,1010041242]','[]','[]','[{0,1010021243,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081301,'武器','13阶红3星武器【龙骑士】',2,'[{lv,520}]',2,'[]','[1001011342,1007011342,1001021342,1007021342,1001031342,1007031342,1001041342,1007041342]','[]','[]','[{0,1001021343,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081302,'头盔','13阶红3星头盔【龙骑士】',2,'[{lv,520}]',2,'[]','[1002011342,1004011342,1006011342,1008011342,1010011342,1002021342,1004021342,1006021342,1008021342,1010021342,1002031342,1004031342,1006031342,1008031342,1010031342,1002041342,1004041342,1006041342,1008041342,1010041342]','[]','[]','[{0,1002021343,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081303,'项链','13阶红3星项链【通用】',2,'[{lv,520}]',2,'[]','[1003001342,1003001342,1003001342,1003001342]','[]','[]','[{0,1003001343,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081304,'衣服','13阶红3星衣服【龙骑士】',2,'[{lv,520}]',2,'[]','[1002011342,1004011342,1006011342,1008011342,1010011342,1002021342,1004021342,1006021342,1008021342,1010021342,1002031342,1004031342,1006031342,1008031342,1010031342,1002041342,1004041342,1006041342,1008041342,1010041342]','[]','[]','[{0,1004021343,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081305,'刻痕','13阶红3星刻痕【通用】',2,'[{lv,520}]',2,'[]','[1005001342,1009001342,1005001342,1009001342,1005001342,1009001342,1005001342,1009001342]','[]','[]','[{0,1005001343,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081306,'裤子','13阶红3星裤子【龙骑士】',2,'[{lv,520}]',2,'[]','[1002011342,1004011342,1006011342,1008011342,1010011342,1002021342,1004021342,1006021342,1008021342,1010021342,1002031342,1004031342,1006031342,1008031342,1010031342,1002041342,1004041342,1006041342,1008041342,1010041342]','[]','[]','[{0,1006021343,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081307,'副手','13阶红3星副手【龙骑士】',2,'[{lv,520}]',2,'[]','[1001011342,1007011342,1001021342,1007021342,1001031342,1007031342,1001041342,1007041342]','[]','[]','[{0,1007021343,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081308,'护腕','13阶红3星护腕【龙骑士】',2,'[{lv,520}]',2,'[]','[1002011342,1004011342,1006011342,1008011342,1010011342,1002021342,1004021342,1006021342,1008021342,1010021342,1002031342,1004031342,1006031342,1008031342,1010031342,1002041342,1004041342,1006041342,1008041342,1010041342]','[]','[]','[{0,1008021343,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081309,'戒指','13阶红3星戒指【通用】',2,'[{lv,520}]',2,'[]','[1005001342,1009001342,1005001342,1009001342,1005001342,1009001342,1005001342,1009001342]','[]','[]','[{0,1009001343,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081310,'鞋子','13阶红3星鞋子【龙骑士】',2,'[{lv,520}]',2,'[]','[1002011342,1004011342,1006011342,1008011342,1010011342,1002021342,1004021342,1006021342,1008021342,1010021342,1002031342,1004031342,1006031342,1008031342,1010031342,1002041342,1004041342,1006041342,1008041342,1010041342]','[]','[]','[{0,1010021343,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081401,'武器','14阶红3星武器【龙骑士】',2,'[{lv,620}]',2,'[]','[1001011442,1007011442,1001021442,1007021442,1001031442,1007031442,1001041442,1007041442]','[]','[]','[{0,1001021443,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081402,'头盔','14阶红3星头盔【龙骑士】',2,'[{lv,620}]',2,'[]','[1002011442,1004011442,1006011442,1008011442,1010011442,1002021442,1004021442,1006021442,1008021442,1010021442,1002031442,1004031442,1006031442,1008031442,1010031442,1002041442,1004041442,1006041442,1008041442,1010041442]','[]','[]','[{0,1002021443,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081403,'项链','14阶红3星项链【通用】',2,'[{lv,620}]',2,'[]','[1003001442,1003001442,1003001442,1003001442]','[]','[]','[{0,1003001443,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081404,'衣服','14阶红3星衣服【龙骑士】',2,'[{lv,620}]',2,'[]','[1002011442,1004011442,1006011442,1008011442,1010011442,1002021442,1004021442,1006021442,1008021442,1010021442,1002031442,1004031442,1006031442,1008031442,1010031442,1002041442,1004041442,1006041442,1008041442,1010041442]','[]','[]','[{0,1004021443,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081405,'刻痕','14阶红3星刻痕【通用】',2,'[{lv,620}]',2,'[]','[1005001442,1009001442,1005001442,1009001442,1005001442,1009001442,1005001442,1009001442]','[]','[]','[{0,1005001443,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081406,'裤子','14阶红3星裤子【龙骑士】',2,'[{lv,620}]',2,'[]','[1002011442,1004011442,1006011442,1008011442,1010011442,1002021442,1004021442,1006021442,1008021442,1010021442,1002031442,1004031442,1006031442,1008031442,1010031442,1002041442,1004041442,1006041442,1008041442,1010041442]','[]','[]','[{0,1006021443,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081407,'副手','14阶红3星副手【龙骑士】',2,'[{lv,620}]',2,'[]','[1001011442,1007011442,1001021442,1007021442,1001031442,1007031442,1001041442,1007041442]','[]','[]','[{0,1007021443,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081408,'护腕','14阶红3星护腕【龙骑士】',2,'[{lv,620}]',2,'[]','[1002011442,1004011442,1006011442,1008011442,1010011442,1002021442,1004021442,1006021442,1008021442,1010021442,1002031442,1004031442,1006031442,1008031442,1010031442,1002041442,1004041442,1006041442,1008041442,1010041442]','[]','[]','[{0,1008021443,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081409,'戒指','14阶红3星戒指【通用】',2,'[{lv,620}]',2,'[]','[1005001442,1009001442,1005001442,1009001442,1005001442,1009001442,1005001442,1009001442]','[]','[]','[{0,1009001443,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081410,'鞋子','14阶红3星鞋子【龙骑士】',2,'[{lv,620}]',2,'[]','[1002011442,1004011442,1006011442,1008011442,1010011442,1002021442,1004021442,1006021442,1008021442,1010021442,1002031442,1004031442,1006031442,1008031442,1010031442,1002041442,1004041442,1006041442,1008041442,1010041442]','[]','[]','[{0,1010021443,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081501,'武器','15阶红3星武器【龙骑士】',2,'[{lv,650}]',2,'[]','[1001011542,1007011542,1001021542,1007021542,1001031542,1007031542,1001041542,1007041542]','[]','[]','[{0,1001021543,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081502,'头盔','15阶红3星头盔【龙骑士】',2,'[{lv,650}]',2,'[]','[1002011542,1004011542,1006011542,1008011542,1010011542,1002021542,1004021542,1006021542,1008021542,1010021542,1002031542,1004031542,1006031542,1008031542,1010031542,1002041542,1004041542,1006041542,1008041542,1010041542]','[]','[]','[{0,1002021543,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081503,'项链','15阶红3星项链【通用】',2,'[{lv,650}]',2,'[]','[1003001542,1003001542,1003001542,1003001542]','[]','[]','[{0,1003001543,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081504,'衣服','15阶红3星衣服【龙骑士】',2,'[{lv,650}]',2,'[]','[1002011542,1004011542,1006011542,1008011542,1010011542,1002021542,1004021542,1006021542,1008021542,1010021542,1002031542,1004031542,1006031542,1008031542,1010031542,1002041542,1004041542,1006041542,1008041542,1010041542]','[]','[]','[{0,1004021543,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081505,'刻痕','15阶红3星刻痕【通用】',2,'[{lv,650}]',2,'[]','[1005001542,1009001542,1005001542,1009001542,1005001542,1009001542,1005001542,1009001542]','[]','[]','[{0,1005001543,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081506,'裤子','15阶红3星裤子【龙骑士】',2,'[{lv,650}]',2,'[]','[1002011542,1004011542,1006011542,1008011542,1010011542,1002021542,1004021542,1006021542,1008021542,1010021542,1002031542,1004031542,1006031542,1008031542,1010031542,1002041542,1004041542,1006041542,1008041542,1010041542]','[]','[]','[{0,1006021543,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081507,'副手','15阶红3星副手【龙骑士】',2,'[{lv,650}]',2,'[]','[1001011542,1007011542,1001021542,1007021542,1001031542,1007031542,1001041542,1007041542]','[]','[]','[{0,1007021543,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081508,'护腕','15阶红3星护腕【龙骑士】',2,'[{lv,650}]',2,'[]','[1002011542,1004011542,1006011542,1008011542,1010011542,1002021542,1004021542,1006021542,1008021542,1010021542,1002031542,1004031542,1006031542,1008031542,1010031542,1002041542,1004041542,1006041542,1008041542,1010041542]','[]','[]','[{0,1008021543,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081509,'戒指','15阶红3星戒指【通用】',2,'[{lv,650}]',2,'[]','[1005001542,1009001542,1005001542,1009001542,1005001542,1009001542,1005001542,1009001542]','[]','[]','[{0,1009001543,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081510,'鞋子','15阶红3星鞋子【龙骑士】',2,'[{lv,650}]',2,'[]','[1002011542,1004011542,1006011542,1008011542,1010011542,1002021542,1004021542,1006021542,1008021542,1010021542,1002031542,1004031542,1006031542,1008031542,1010031542,1002041542,1004041542,1006041542,1008041542,1010041542]','[]','[]','[{0,1010021543,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081601,'武器','16阶红3星武器【龙骑士】',2,'[{lv,700}]',2,'[]','[1001011642,1007011642,1001021642,1007021642,1001031642,1007031642,1001041642,1007041642]','[]','[]','[{0,1001021643,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081602,'头盔','16阶红3星头盔【龙骑士】',2,'[{lv,700}]',2,'[]','[1002011642,1004011642,1006011642,1008011642,1010011642,1002021642,1004021642,1006021642,1008021642,1010021642,1002031642,1004031642,1006031642,1008031642,1010031642,1002041642,1004041642,1006041642,1008041642,1010041642]','[]','[]','[{0,1002021643,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081603,'项链','16阶红3星项链【通用】',2,'[{lv,700}]',2,'[]','[1003001642,1003001642,1003001642,1003001642]','[]','[]','[{0,1003001643,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081604,'衣服','16阶红3星衣服【龙骑士】',2,'[{lv,700}]',2,'[]','[1002011642,1004011642,1006011642,1008011642,1010011642,1002021642,1004021642,1006021642,1008021642,1010021642,1002031642,1004031642,1006031642,1008031642,1010031642,1002041642,1004041642,1006041642,1008041642,1010041642]','[]','[]','[{0,1004021643,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081605,'刻痕','16阶红3星刻痕【通用】',2,'[{lv,700}]',2,'[]','[1005001642,1009001642,1005001642,1009001642,1005001642,1009001642,1005001642,1009001642]','[]','[]','[{0,1005001643,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081606,'裤子','16阶红3星裤子【龙骑士】',2,'[{lv,700}]',2,'[]','[1002011642,1004011642,1006011642,1008011642,1010011642,1002021642,1004021642,1006021642,1008021642,1010021642,1002031642,1004031642,1006031642,1008031642,1010031642,1002041642,1004041642,1006041642,1008041642,1010041642]','[]','[]','[{0,1006021643,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081607,'副手','16阶红3星副手【龙骑士】',2,'[{lv,700}]',2,'[]','[1001011642,1007011642,1001021642,1007021642,1001031642,1007031642,1001041642,1007041642]','[]','[]','[{0,1007021643,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081608,'护腕','16阶红3星护腕【龙骑士】',2,'[{lv,700}]',2,'[]','[1002011642,1004011642,1006011642,1008011642,1010011642,1002021642,1004021642,1006021642,1008021642,1010021642,1002031642,1004031642,1006031642,1008031642,1010031642,1002041642,1004041642,1006041642,1008041642,1010041642]','[]','[]','[{0,1008021643,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081609,'戒指','16阶红3星戒指【通用】',2,'[{lv,700}]',2,'[]','[1005001642,1009001642,1005001642,1009001642,1005001642,1009001642,1005001642,1009001642]','[]','[]','[{0,1009001643,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32081610,'鞋子','16阶红3星鞋子【龙骑士】',2,'[{lv,700}]',2,'[]','[1002011642,1004011642,1006011642,1008011642,1010011642,1002021642,1004021642,1006021642,1008021642,1010021642,1002031642,1004031642,1006031642,1008031642,1010031642,1002041642,1004041642,1006041642,1008041642,1010041642]','[]','[]','[{0,1010021643,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(32090301,'武器','3阶粉色武器【龙骑士】',2,'[{lv,9999}]',3,'[{0,38280520,1}]','[1001010343,1007010343,1001020343,1007020343,1001030343,1007030343,1001040343,1007040343]','[]','[]','[{0,1001020353,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(32090302,'头盔','3阶粉色头盔【龙骑士】',2,'[{lv,9999}]',3,'[{0,38280510,1}]','[1002010343,1004010343,1006010343,1008010343,1010010343,1002020343,1004020343,1006020343,1008020343,1010020343,1002030343,1004030343,1006030343,1008030343,1010030343,1002040343,1004040343,1006040343,1008040343,1010040343]','[]','[]','[{0,1002020353,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(32090303,'项链','3阶粉色项链【通用】',2,'[{lv,9999}]',3,'[{0,38280520,1}]','[1003000343,1003000343,1003000343,1003000343]','[]','[]','[{0,1003000353,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(32090304,'衣服','3阶粉色衣服【龙骑士】',2,'[{lv,9999}]',3,'[{0,38280510,1}]','[1002010343,1004010343,1006010343,1008010343,1010010343,1002020343,1004020343,1006020343,1008020343,1010020343,1002030343,1004030343,1006030343,1008030343,1010030343,1002040343,1004040343,1006040343,1008040343,1010040343]','[]','[]','[{0,1004020353,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(32090305,'刻痕','3阶粉色刻痕【通用】',2,'[{lv,9999}]',3,'[{0,38280520,1}]','[1005000343,1009000343,1005000343,1009000343,1005000343,1009000343,1005000343,1009000343]','[]','[]','[{0,1005000353,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(32090306,'裤子','3阶粉色裤子【龙骑士】',2,'[{lv,9999}]',3,'[{0,38280510,1}]','[1002010343,1004010343,1006010343,1008010343,1010010343,1002020343,1004020343,1006020343,1008020343,1010020343,1002030343,1004030343,1006030343,1008030343,1010030343,1002040343,1004040343,1006040343,1008040343,1010040343]','[]','[]','[{0,1006020353,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(32090307,'副手','3阶粉色副手【龙骑士】',2,'[{lv,9999}]',3,'[{0,38280520,1}]','[1001010343,1007010343,1001020343,1007020343,1001030343,1007030343,1001040343,1007040343]','[]','[]','[{0,1007020353,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(32090308,'护腕','3阶粉色护腕【龙骑士】',2,'[{lv,9999}]',3,'[{0,38280510,1}]','[1002010343,1004010343,1006010343,1008010343,1010010343,1002020343,1004020343,1006020343,1008020343,1010020343,1002030343,1004030343,1006030343,1008030343,1010030343,1002040343,1004040343,1006040343,1008040343,1010040343]','[]','[]','[{0,1008020353,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(32090309,'戒指','3阶粉色戒指【通用】',2,'[{lv,9999}]',3,'[{0,38280520,1}]','[1005000343,1009000343,1005000343,1009000343,1005000343,1009000343,1005000343,1009000343]','[]','[]','[{0,1009000353,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(32090310,'鞋子','3阶粉色鞋子【龙骑士】',2,'[{lv,9999}]',3,'[{0,38280510,1}]','[1002010343,1004010343,1006010343,1008010343,1010010343,1002020343,1004020343,1006020343,1008020343,1010020343,1002030343,1004030343,1006030343,1008030343,1010030343,1002040343,1004040343,1006040343,1008040343,1010040343]','[]','[]','[{0,1010020353,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(32090401,'武器','4阶粉色武器【龙骑士】',2,'[{lv,160}]',3,'[{0,38280520,1}]','[1001010443,1007010443,1001020443,1007020443,1001030443,1007030443,1001040443,1007040443]','[]','[]','[{0,1001020453,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(32090402,'头盔','4阶粉色头盔【龙骑士】',2,'[{lv,160}]',3,'[{0,38280510,1}]','[1002010443,1004010443,1006010443,1008010443,1010010443,1002020443,1004020443,1006020443,1008020443,1010020443,1002030443,1004030443,1006030443,1008030443,1010030443,1002040443,1004040443,1006040443,1008040443,1010040443]','[]','[]','[{0,1002020453,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(32090403,'项链','4阶粉色项链【通用】',2,'[{lv,160}]',3,'[{0,38280520,1}]','[1003000443,1003000443,1003000443,1003000443]','[]','[]','[{0,1003000453,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(32090404,'衣服','4阶粉色衣服【龙骑士】',2,'[{lv,160}]',3,'[{0,38280510,1}]','[1002010443,1004010443,1006010443,1008010443,1010010443,1002020443,1004020443,1006020443,1008020443,1010020443,1002030443,1004030443,1006030443,1008030443,1010030443,1002040443,1004040443,1006040443,1008040443,1010040443]','[]','[]','[{0,1004020453,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(32090405,'刻痕','4阶粉色刻痕【通用】',2,'[{lv,160}]',3,'[{0,38280520,1}]','[1005000443,1009000443,1005000443,1009000443,1005000443,1009000443,1005000443,1009000443]','[]','[]','[{0,1005000453,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(32090406,'裤子','4阶粉色裤子【龙骑士】',2,'[{lv,160}]',3,'[{0,38280510,1}]','[1002010443,1004010443,1006010443,1008010443,1010010443,1002020443,1004020443,1006020443,1008020443,1010020443,1002030443,1004030443,1006030443,1008030443,1010030443,1002040443,1004040443,1006040443,1008040443,1010040443]','[]','[]','[{0,1006020453,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(32090407,'副手','4阶粉色副手【龙骑士】',2,'[{lv,160}]',3,'[{0,38280520,1}]','[1001010443,1007010443,1001020443,1007020443,1001030443,1007030443,1001040443,1007040443]','[]','[]','[{0,1007020453,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(32090408,'护腕','4阶粉色护腕【龙骑士】',2,'[{lv,160}]',3,'[{0,38280510,1}]','[1002010443,1004010443,1006010443,1008010443,1010010443,1002020443,1004020443,1006020443,1008020443,1010020443,1002030443,1004030443,1006030443,1008030443,1010030443,1002040443,1004040443,1006040443,1008040443,1010040443]','[]','[]','[{0,1008020453,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(32090409,'戒指','4阶粉色戒指【通用】',2,'[{lv,160}]',3,'[{0,38280520,1}]','[1005000443,1009000443,1005000443,1009000443,1005000443,1009000443,1005000443,1009000443]','[]','[]','[{0,1009000453,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(32090410,'鞋子','4阶粉色鞋子【龙骑士】',2,'[{lv,160}]',3,'[{0,38280510,1}]','[1002010443,1004010443,1006010443,1008010443,1010010443,1002020443,1004020443,1006020443,1008020443,1010020443,1002030443,1004030443,1006030443,1008030443,1010030443,1002040443,1004040443,1006040443,1008040443,1010040443]','[]','[]','[{0,1010020453,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(32090501,'武器','5阶粉色武器【龙骑士】',2,'[{lv,160}]',3,'[{0,38280520,1}]','[1001010543,1007010543,1001020543,1007020543,1001030543,1007030543,1001040543,1007040543,1101010543,1107010543,1101020543,1107020543,1101030543,1107030543,1101040543,1107040543]','[]','[]','[{0,1001020553,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(32090502,'头盔','5阶粉色头盔【龙骑士】',2,'[{lv,160}]',3,'[{0,38280510,1}]','[1002010543,1004010543,1006010543,1008010543,1010010543,1002020543,1004020543,1006020543,1008020543,1010020543,1002030543,1004030543,1006030543,1008030543,1010030543,1002040543,1004040543,1006040543,1008040543,1010040543,1102010543,1104010543,1106010543,1108010543,1110010543,1102020543,1104020543,1106020543,1108020543,1110020543,1102030543,1104030543,1106030543,1108030543,1110030543,1102040543,1104040543,1106040543,1108040543,1110040543]','[]','[]','[{0,1002020553,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(32090503,'项链','5阶粉色项链【通用】',2,'[{lv,160}]',3,'[{0,38280520,1}]','[1003000543,1003000543,1003000543,1003000543,1103000543,1103000543,1103000543,1103000543]','[]','[]','[{0,1003000553,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(32090504,'衣服','5阶粉色衣服【龙骑士】',2,'[{lv,160}]',3,'[{0,38280510,1}]','[1002010543,1004010543,1006010543,1008010543,1010010543,1002020543,1004020543,1006020543,1008020543,1010020543,1002030543,1004030543,1006030543,1008030543,1010030543,1002040543,1004040543,1006040543,1008040543,1010040543,1102010543,1104010543,1106010543,1108010543,1110010543,1102020543,1104020543,1106020543,1108020543,1110020543,1102030543,1104030543,1106030543,1108030543,1110030543,1102040543,1104040543,1106040543,1108040543,1110040543]','[]','[]','[{0,1004020553,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(32090505,'刻痕','5阶粉色刻痕【通用】',2,'[{lv,160}]',3,'[{0,38280520,1}]','[1005000543,1009000543,1005000543,1009000543,1005000543,1009000543,1005000543,1009000543,1105000543,1109000543,1105000543,1109000543,1105000543,1109000543,1105000543,1109000543]','[]','[]','[{0,1005000553,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(32090506,'裤子','5阶粉色裤子【龙骑士】',2,'[{lv,160}]',3,'[{0,38280510,1}]','[1002010543,1004010543,1006010543,1008010543,1010010543,1002020543,1004020543,1006020543,1008020543,1010020543,1002030543,1004030543,1006030543,1008030543,1010030543,1002040543,1004040543,1006040543,1008040543,1010040543,1102010543,1104010543,1106010543,1108010543,1110010543,1102020543,1104020543,1106020543,1108020543,1110020543,1102030543,1104030543,1106030543,1108030543,1110030543,1102040543,1104040543,1106040543,1108040543,1110040543]','[]','[]','[{0,1006020553,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(32090507,'副手','5阶粉色副手【龙骑士】',2,'[{lv,160}]',3,'[{0,38280520,1}]','[1001010543,1007010543,1001020543,1007020543,1001030543,1007030543,1001040543,1007040543,1101010543,1107010543,1101020543,1107020543,1101030543,1107030543,1101040543,1107040543]','[]','[]','[{0,1007020553,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(32090508,'护腕','5阶粉色护腕【龙骑士】',2,'[{lv,160}]',3,'[{0,38280510,1}]','[1002010543,1004010543,1006010543,1008010543,1010010543,1002020543,1004020543,1006020543,1008020543,1010020543,1002030543,1004030543,1006030543,1008030543,1010030543,1002040543,1004040543,1006040543,1008040543,1010040543,1102010543,1104010543,1106010543,1108010543,1110010543,1102020543,1104020543,1106020543,1108020543,1110020543,1102030543,1104030543,1106030543,1108030543,1110030543,1102040543,1104040543,1106040543,1108040543,1110040543]','[]','[]','[{0,1008020553,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(32090509,'戒指','5阶粉色戒指【通用】',2,'[{lv,160}]',3,'[{0,38280520,1}]','[1005000543,1009000543,1005000543,1009000543,1005000543,1009000543,1005000543,1009000543,1105000543,1109000543,1105000543,1109000543,1105000543,1109000543,1105000543,1109000543]','[]','[]','[{0,1009000553,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(32090510,'鞋子','5阶粉色鞋子【龙骑士】',2,'[{lv,160}]',3,'[{0,38280510,1}]','[1002010543,1004010543,1006010543,1008010543,1010010543,1002020543,1004020543,1006020543,1008020543,1010020543,1002030543,1004030543,1006030543,1008030543,1010030543,1002040543,1004040543,1006040543,1008040543,1010040543,1102010543,1104010543,1106010543,1108010543,1110010543,1102020543,1104020543,1106020543,1108020543,1110020543,1102030543,1104030543,1106030543,1108030543,1110030543,1102040543,1104040543,1106040543,1108040543,1110040543]','[]','[]','[{0,1010020553,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(32090601,'武器','6阶粉色武器【龙骑士】',2,'[{lv,180}]',3,'[{0,38280520,2}]','[1001010643,1007010643,1001020643,1007020643,1001030643,1007030643,1001040643,1007040643]','[]','[]','[{0,1001020653,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280520,2}]',150),(32090602,'头盔','6阶粉色头盔【龙骑士】',2,'[{lv,180}]',3,'[{0,38280510,2}]','[1002010643,1004010643,1006010643,1008010643,1010010643,1002020643,1004020643,1006020643,1008020643,1010020643,1002030643,1004030643,1006030643,1008030643,1010030643,1002040643,1004040643,1006040643,1008040643,1010040643]','[]','[]','[{0,1002020653,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280510,2}]',150),(32090603,'项链','6阶粉色项链【通用】',2,'[{lv,180}]',3,'[{0,38280520,2}]','[1003000643,1003000643,1003000643,1003000643]','[]','[]','[{0,1003000653,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280520,2}]',150),(32090604,'衣服','6阶粉色衣服【龙骑士】',2,'[{lv,180}]',3,'[{0,38280510,2}]','[1002010643,1004010643,1006010643,1008010643,1010010643,1002020643,1004020643,1006020643,1008020643,1010020643,1002030643,1004030643,1006030643,1008030643,1010030643,1002040643,1004040643,1006040643,1008040643,1010040643]','[]','[]','[{0,1004020653,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280510,2}]',150),(32090605,'刻痕','6阶粉色刻痕【通用】',2,'[{lv,180}]',3,'[{0,38280520,2}]','[1005000643,1009000643,1005000643,1009000643,1005000643,1009000643,1005000643,1009000643]','[]','[]','[{0,1005000653,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280520,2}]',150),(32090606,'裤子','6阶粉色裤子【龙骑士】',2,'[{lv,180}]',3,'[{0,38280510,2}]','[1002010643,1004010643,1006010643,1008010643,1010010643,1002020643,1004020643,1006020643,1008020643,1010020643,1002030643,1004030643,1006030643,1008030643,1010030643,1002040643,1004040643,1006040643,1008040643,1010040643]','[]','[]','[{0,1006020653,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280510,2}]',150),(32090607,'副手','6阶粉色副手【龙骑士】',2,'[{lv,180}]',3,'[{0,38280520,2}]','[1001010643,1007010643,1001020643,1007020643,1001030643,1007030643,1001040643,1007040643]','[]','[]','[{0,1007020653,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280520,2}]',150),(32090608,'护腕','6阶粉色护腕【龙骑士】',2,'[{lv,180}]',3,'[{0,38280510,2}]','[1002010643,1004010643,1006010643,1008010643,1010010643,1002020643,1004020643,1006020643,1008020643,1010020643,1002030643,1004030643,1006030643,1008030643,1010030643,1002040643,1004040643,1006040643,1008040643,1010040643]','[]','[]','[{0,1008020653,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280510,2}]',150),(32090609,'戒指','6阶粉色戒指【通用】',2,'[{lv,180}]',3,'[{0,38280520,2}]','[1005000643,1009000643,1005000643,1009000643,1005000643,1009000643,1005000643,1009000643]','[]','[]','[{0,1009000653,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280520,2}]',150),(32090610,'鞋子','6阶粉色鞋子【龙骑士】',2,'[{lv,180}]',3,'[{0,38280510,2}]','[1002010643,1004010643,1006010643,1008010643,1010010643,1002020643,1004020643,1006020643,1008020643,1010020643,1002030643,1004030643,1006030643,1008030643,1010030643,1002040643,1004040643,1006040643,1008040643,1010040643]','[]','[]','[{0,1010020653,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280510,2}]',150),(32090701,'武器','7阶粉色武器【龙骑士】',2,'[{lv,220}]',3,'[{0,38280520,3}]','[1001010743,1007010743,1001020743,1007020743,1001030743,1007030743,1001040743,1007040743,1101010743,1107010743,1101020743,1107020743,1101030743,1107030743,1101040743,1107040743]','[]','[]','[{0,1001020753,1}]',2,'[{1,0},{2,100},{3,100}]',3,1,'[{0,38280520,3}]',150),(32090702,'头盔','7阶粉色头盔【龙骑士】',2,'[{lv,220}]',3,'[{0,38280510,3}]','[1002010743,1004010743,1006010743,1008010743,1010010743,1002020743,1004020743,1006020743,1008020743,1010020743,1002030743,1004030743,1006030743,1008030743,1010030743,1002040743,1004040743,1006040743,1008040743,1010040743,1102010743,1104010743,1106010743,1108010743,1110010743,1102020743,1104020743,1106020743,1108020743,1110020743,1102030743,1104030743,1106030743,1108030743,1110030743,1102040743,1104040743,1106040743,1108040743,1110040743]','[]','[]','[{0,1002020753,1}]',2,'[{1,0},{2,100},{3,100}]',3,1,'[{0,38280510,3}]',150),(32090703,'项链','7阶粉色项链【通用】',2,'[{lv,220}]',3,'[{0,38280520,3}]','[1003000743,1003000743,1003000743,1003000743,1103000743,1103000743,1103000743,1103000743]','[]','[]','[{0,1003000753,1}]',2,'[{1,0},{2,100},{3,100}]',3,1,'[{0,38280520,3}]',150),(32090704,'衣服','7阶粉色衣服【龙骑士】',2,'[{lv,220}]',3,'[{0,38280510,3}]','[1002010743,1004010743,1006010743,1008010743,1010010743,1002020743,1004020743,1006020743,1008020743,1010020743,1002030743,1004030743,1006030743,1008030743,1010030743,1002040743,1004040743,1006040743,1008040743,1010040743,1102010743,1104010743,1106010743,1108010743,1110010743,1102020743,1104020743,1106020743,1108020743,1110020743,1102030743,1104030743,1106030743,1108030743,1110030743,1102040743,1104040743,1106040743,1108040743,1110040743]','[]','[]','[{0,1004020753,1}]',2,'[{1,0},{2,100},{3,100}]',3,1,'[{0,38280510,3}]',150),(32090705,'刻痕','7阶粉色刻痕【通用】',2,'[{lv,220}]',3,'[{0,38280520,3}]','[1005000743,1009000743,1005000743,1009000743,1005000743,1009000743,1005000743,1009000743,1105000743,1109000743,1105000743,1109000743,1105000743,1109000743,1105000743,1109000743]','[]','[]','[{0,1005000753,1}]',2,'[{1,0},{2,100},{3,100}]',3,1,'[{0,38280520,3}]',150),(32090706,'裤子','7阶粉色裤子【龙骑士】',2,'[{lv,220}]',3,'[{0,38280510,3}]','[1002010743,1004010743,1006010743,1008010743,1010010743,1002020743,1004020743,1006020743,1008020743,1010020743,1002030743,1004030743,1006030743,1008030743,1010030743,1002040743,1004040743,1006040743,1008040743,1010040743,1102010743,1104010743,1106010743,1108010743,1110010743,1102020743,1104020743,1106020743,1108020743,1110020743,1102030743,1104030743,1106030743,1108030743,1110030743,1102040743,1104040743,1106040743,1108040743,1110040743]','[]','[]','[{0,1006020753,1}]',2,'[{1,0},{2,100},{3,100}]',3,1,'[{0,38280510,3}]',150),(32090707,'副手','7阶粉色副手【龙骑士】',2,'[{lv,220}]',3,'[{0,38280520,3}]','[1001010743,1007010743,1001020743,1007020743,1001030743,1007030743,1001040743,1007040743,1101010743,1107010743,1101020743,1107020743,1101030743,1107030743,1101040743,1107040743]','[]','[]','[{0,1007020753,1}]',2,'[{1,0},{2,100},{3,100}]',3,1,'[{0,38280520,3}]',150),(32090708,'护腕','7阶粉色护腕【龙骑士】',2,'[{lv,220}]',3,'[{0,38280510,3}]','[1002010743,1004010743,1006010743,1008010743,1010010743,1002020743,1004020743,1006020743,1008020743,1010020743,1002030743,1004030743,1006030743,1008030743,1010030743,1002040743,1004040743,1006040743,1008040743,1010040743,1102010743,1104010743,1106010743,1108010743,1110010743,1102020743,1104020743,1106020743,1108020743,1110020743,1102030743,1104030743,1106030743,1108030743,1110030743,1102040743,1104040743,1106040743,1108040743,1110040743]','[]','[]','[{0,1008020753,1}]',2,'[{1,0},{2,100},{3,100}]',3,1,'[{0,38280510,3}]',150),(32090709,'戒指','7阶粉色戒指【通用】',2,'[{lv,220}]',3,'[{0,38280520,3}]','[1005000743,1009000743,1005000743,1009000743,1005000743,1009000743,1005000743,1009000743,1105000743,1109000743,1105000743,1109000743,1105000743,1109000743,1105000743,1109000743]','[]','[]','[{0,1009000753,1}]',2,'[{1,0},{2,100},{3,100}]',3,1,'[{0,38280520,3}]',150),(32090710,'鞋子','7阶粉色鞋子【龙骑士】',2,'[{lv,220}]',3,'[{0,38280510,3}]','[1002010743,1004010743,1006010743,1008010743,1010010743,1002020743,1004020743,1006020743,1008020743,1010020743,1002030743,1004030743,1006030743,1008030743,1010030743,1002040743,1004040743,1006040743,1008040743,1010040743,1102010743,1104010743,1106010743,1108010743,1110010743,1102020743,1104020743,1106020743,1108020743,1110020743,1102030743,1104030743,1106030743,1108030743,1110030743,1102040743,1104040743,1106040743,1108040743,1110040743]','[]','[]','[{0,1010020753,1}]',2,'[{1,0},{2,100},{3,100}]',3,1,'[{0,38280510,3}]',150),(32090801,'武器','8阶粉色武器【龙骑士】',2,'[{lv,260}]',3,'[{0,38280520,4}]','[1001010843,1007010843,1001020843,1007020843,1001030843,1007030843,1001040843,1007040843]','[]','[]','[{0,1001020853,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280520,4}]',150),(32090802,'头盔','8阶粉色头盔【龙骑士】',2,'[{lv,260}]',3,'[{0,38280510,4}]','[1002010843,1004010843,1006010843,1008010843,1010010843,1002020843,1004020843,1006020843,1008020843,1010020843,1002030843,1004030843,1006030843,1008030843,1010030843,1002040843,1004040843,1006040843,1008040843,1010040843]','[]','[]','[{0,1002020853,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280510,4}]',150),(32090803,'项链','8阶粉色项链【通用】',2,'[{lv,260}]',3,'[{0,38280520,4}]','[1003000843,1003000843,1003000843,1003000843]','[]','[]','[{0,1003000853,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280520,4}]',150),(32090804,'衣服','8阶粉色衣服【龙骑士】',2,'[{lv,260}]',3,'[{0,38280510,4}]','[1002010843,1004010843,1006010843,1008010843,1010010843,1002020843,1004020843,1006020843,1008020843,1010020843,1002030843,1004030843,1006030843,1008030843,1010030843,1002040843,1004040843,1006040843,1008040843,1010040843]','[]','[]','[{0,1004020853,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280510,4}]',150),(32090805,'刻痕','8阶粉色刻痕【通用】',2,'[{lv,260}]',3,'[{0,38280520,4}]','[1005000843,1009000843,1005000843,1009000843,1005000843,1009000843,1005000843,1009000843]','[]','[]','[{0,1005000853,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280520,4}]',150),(32090806,'裤子','8阶粉色裤子【龙骑士】',2,'[{lv,260}]',3,'[{0,38280510,4}]','[1002010843,1004010843,1006010843,1008010843,1010010843,1002020843,1004020843,1006020843,1008020843,1010020843,1002030843,1004030843,1006030843,1008030843,1010030843,1002040843,1004040843,1006040843,1008040843,1010040843]','[]','[]','[{0,1006020853,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280510,4}]',150),(32090807,'副手','8阶粉色副手【龙骑士】',2,'[{lv,260}]',3,'[{0,38280520,4}]','[1001010843,1007010843,1001020843,1007020843,1001030843,1007030843,1001040843,1007040843]','[]','[]','[{0,1007020853,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280520,4}]',150),(32090808,'护腕','8阶粉色护腕【龙骑士】',2,'[{lv,260}]',3,'[{0,38280510,4}]','[1002010843,1004010843,1006010843,1008010843,1010010843,1002020843,1004020843,1006020843,1008020843,1010020843,1002030843,1004030843,1006030843,1008030843,1010030843,1002040843,1004040843,1006040843,1008040843,1010040843]','[]','[]','[{0,1008020853,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280510,4}]',150),(32090809,'戒指','8阶粉色戒指【通用】',2,'[{lv,260}]',3,'[{0,38280520,4}]','[1005000843,1009000843,1005000843,1009000843,1005000843,1009000843,1005000843,1009000843]','[]','[]','[{0,1009000853,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280520,4}]',150),(32090810,'鞋子','8阶粉色鞋子【龙骑士】',2,'[{lv,260}]',3,'[{0,38280510,4}]','[1002010843,1004010843,1006010843,1008010843,1010010843,1002020843,1004020843,1006020843,1008020843,1010020843,1002030843,1004030843,1006030843,1008030843,1010030843,1002040843,1004040843,1006040843,1008040843,1010040843]','[]','[]','[{0,1010020853,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280510,4}]',150),(32090901,'武器','9阶粉色武器【龙骑士】',2,'[{lv,300}]',3,'[{0,38280520,6}]','[1001010943,1007010943,1001020943,1007020943,1001030943,1007030943,1001040943,1007040943]','[]','[]','[{0,1001020953,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280520,6}]',150),(32090902,'头盔','9阶粉色头盔【龙骑士】',2,'[{lv,300}]',3,'[{0,38280510,6}]','[1002010943,1004010943,1006010943,1008010943,1010010943,1002020943,1004020943,1006020943,1008020943,1010020943,1002030943,1004030943,1006030943,1008030943,1010030943,1002040943,1004040943,1006040943,1008040943,1010040943]','[]','[]','[{0,1002020953,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280510,6}]',150),(32090903,'项链','9阶粉色项链【通用】',2,'[{lv,300}]',3,'[{0,38280520,6}]','[1003000943,1003000943,1003000943,1003000943]','[]','[]','[{0,1003000953,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280520,6}]',150),(32090904,'衣服','9阶粉色衣服【龙骑士】',2,'[{lv,300}]',3,'[{0,38280510,6}]','[1002010943,1004010943,1006010943,1008010943,1010010943,1002020943,1004020943,1006020943,1008020943,1010020943,1002030943,1004030943,1006030943,1008030943,1010030943,1002040943,1004040943,1006040943,1008040943,1010040943]','[]','[]','[{0,1004020953,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280510,6}]',150),(32090905,'刻痕','9阶粉色刻痕【通用】',2,'[{lv,300}]',3,'[{0,38280520,6}]','[1005000943,1009000943,1005000943,1009000943,1005000943,1009000943,1005000943,1009000943]','[]','[]','[{0,1005000953,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280520,6}]',150),(32090906,'裤子','9阶粉色裤子【龙骑士】',2,'[{lv,300}]',3,'[{0,38280510,6}]','[1002010943,1004010943,1006010943,1008010943,1010010943,1002020943,1004020943,1006020943,1008020943,1010020943,1002030943,1004030943,1006030943,1008030943,1010030943,1002040943,1004040943,1006040943,1008040943,1010040943]','[]','[]','[{0,1006020953,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280510,6}]',150),(32090907,'副手','9阶粉色副手【龙骑士】',2,'[{lv,300}]',3,'[{0,38280520,6}]','[1001010943,1007010943,1001020943,1007020943,1001030943,1007030943,1001040943,1007040943]','[]','[]','[{0,1007020953,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280520,6}]',150),(32090908,'护腕','9阶粉色护腕【龙骑士】',2,'[{lv,300}]',3,'[{0,38280510,6}]','[1002010943,1004010943,1006010943,1008010943,1010010943,1002020943,1004020943,1006020943,1008020943,1010020943,1002030943,1004030943,1006030943,1008030943,1010030943,1002040943,1004040943,1006040943,1008040943,1010040943]','[]','[]','[{0,1008020953,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280510,6}]',150),(32090909,'戒指','9阶粉色戒指【通用】',2,'[{lv,300}]',3,'[{0,38280520,6}]','[1005000943,1009000943,1005000943,1009000943,1005000943,1009000943,1005000943,1009000943]','[]','[]','[{0,1009000953,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280520,6}]',150),(32090910,'鞋子','9阶粉色鞋子【龙骑士】',2,'[{lv,300}]',3,'[{0,38280510,6}]','[1002010943,1004010943,1006010943,1008010943,1010010943,1002020943,1004020943,1006020943,1008020943,1010020943,1002030943,1004030943,1006030943,1008030943,1010030943,1002040943,1004040943,1006040943,1008040943,1010040943]','[]','[]','[{0,1010020953,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280510,6}]',150),(32091001,'武器','10阶粉色武器【龙骑士】',2,'[{lv,355}]',3,'[{0,38280520,8}]','[1001011043,1007011043,1001021043,1007021043,1001031043,1007031043,1001041043,1007041043]','[]','[]','[{0,1001021053,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,8}]',150),(32091002,'头盔','10阶粉色头盔【龙骑士】',2,'[{lv,355}]',3,'[{0,38280510,8}]','[1002011043,1004011043,1006011043,1008011043,1010011043,1002021043,1004021043,1006021043,1008021043,1010021043,1002031043,1004031043,1006031043,1008031043,1010031043,1002041043,1004041043,1006041043,1008041043,1010041043]','[]','[]','[{0,1002021053,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,8}]',150),(32091003,'项链','10阶粉色项链【通用】',2,'[{lv,355}]',3,'[{0,38280520,8}]','[1003001043,1003001043,1003001043,1003001043]','[]','[]','[{0,1003001053,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,8}]',150),(32091004,'衣服','10阶粉色衣服【龙骑士】',2,'[{lv,355}]',3,'[{0,38280510,8}]','[1002011043,1004011043,1006011043,1008011043,1010011043,1002021043,1004021043,1006021043,1008021043,1010021043,1002031043,1004031043,1006031043,1008031043,1010031043,1002041043,1004041043,1006041043,1008041043,1010041043]','[]','[]','[{0,1004021053,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,8}]',150),(32091005,'刻痕','10阶粉色刻痕【通用】',2,'[{lv,355}]',3,'[{0,38280520,8}]','[1005001043,1009001043,1005001043,1009001043,1005001043,1009001043,1005001043,1009001043]','[]','[]','[{0,1005001053,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,8}]',150),(32091006,'裤子','10阶粉色裤子【龙骑士】',2,'[{lv,355}]',3,'[{0,38280510,8}]','[1002011043,1004011043,1006011043,1008011043,1010011043,1002021043,1004021043,1006021043,1008021043,1010021043,1002031043,1004031043,1006031043,1008031043,1010031043,1002041043,1004041043,1006041043,1008041043,1010041043]','[]','[]','[{0,1006021053,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,8}]',150),(32091007,'副手','10阶粉色副手【龙骑士】',2,'[{lv,355}]',3,'[{0,38280520,8}]','[1001011043,1007011043,1001021043,1007021043,1001031043,1007031043,1001041043,1007041043]','[]','[]','[{0,1007021053,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,8}]',150),(32091008,'护腕','10阶粉色护腕【龙骑士】',2,'[{lv,355}]',3,'[{0,38280510,8}]','[1002011043,1004011043,1006011043,1008011043,1010011043,1002021043,1004021043,1006021043,1008021043,1010021043,1002031043,1004031043,1006031043,1008031043,1010031043,1002041043,1004041043,1006041043,1008041043,1010041043]','[]','[]','[{0,1008021053,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,8}]',150),(32091009,'戒指','10阶粉色戒指【通用】',2,'[{lv,355}]',3,'[{0,38280520,8}]','[1005001043,1009001043,1005001043,1009001043,1005001043,1009001043,1005001043,1009001043]','[]','[]','[{0,1009001053,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,8}]',150),(32091010,'鞋子','10阶粉色鞋子【龙骑士】',2,'[{lv,355}]',3,'[{0,38280510,8}]','[1002011043,1004011043,1006011043,1008011043,1010011043,1002021043,1004021043,1006021043,1008021043,1010021043,1002031043,1004031043,1006031043,1008031043,1010031043,1002041043,1004041043,1006041043,1008041043,1010041043]','[]','[]','[{0,1010021053,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,8}]',150),(32091101,'武器','11阶粉色武器【龙骑士】',2,'[{lv,400}]',3,'[{0,38280520,12}]','[1001011143,1007011143,1001021143,1007021143,1001031143,1007031143,1001041143,1007041143]','[]','[]','[{0,1001021153,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,12}]',150),(32091102,'头盔','11阶粉色头盔【龙骑士】',2,'[{lv,400}]',3,'[{0,38280510,12}]','[1002011143,1004011143,1006011143,1008011143,1010011143,1002021143,1004021143,1006021143,1008021143,1010021143,1002031143,1004031143,1006031143,1008031143,1010031143,1002041143,1004041143,1006041143,1008041143,1010041143]','[]','[]','[{0,1002021153,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,12}]',150),(32091103,'项链','11阶粉色项链【通用】',2,'[{lv,400}]',3,'[{0,38280520,12}]','[1003001143,1003001143,1003001143,1003001143]','[]','[]','[{0,1003001153,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,12}]',150),(32091104,'衣服','11阶粉色衣服【龙骑士】',2,'[{lv,400}]',3,'[{0,38280510,12}]','[1002011143,1004011143,1006011143,1008011143,1010011143,1002021143,1004021143,1006021143,1008021143,1010021143,1002031143,1004031143,1006031143,1008031143,1010031143,1002041143,1004041143,1006041143,1008041143,1010041143]','[]','[]','[{0,1004021153,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,12}]',150),(32091105,'刻痕','11阶粉色刻痕【通用】',2,'[{lv,400}]',3,'[{0,38280520,12}]','[1005001143,1009001143,1005001143,1009001143,1005001143,1009001143,1005001143,1009001143]','[]','[]','[{0,1005001153,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,12}]',150),(32091106,'裤子','11阶粉色裤子【龙骑士】',2,'[{lv,400}]',3,'[{0,38280510,12}]','[1002011143,1004011143,1006011143,1008011143,1010011143,1002021143,1004021143,1006021143,1008021143,1010021143,1002031143,1004031143,1006031143,1008031143,1010031143,1002041143,1004041143,1006041143,1008041143,1010041143]','[]','[]','[{0,1006021153,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,12}]',150),(32091107,'副手','11阶粉色副手【龙骑士】',2,'[{lv,400}]',3,'[{0,38280520,12}]','[1001011143,1007011143,1001021143,1007021143,1001031143,1007031143,1001041143,1007041143]','[]','[]','[{0,1007021153,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,12}]',150),(32091108,'护腕','11阶粉色护腕【龙骑士】',2,'[{lv,400}]',3,'[{0,38280510,12}]','[1002011143,1004011143,1006011143,1008011143,1010011143,1002021143,1004021143,1006021143,1008021143,1010021143,1002031143,1004031143,1006031143,1008031143,1010031143,1002041143,1004041143,1006041143,1008041143,1010041143]','[]','[]','[{0,1008021153,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,12}]',150),(32091109,'戒指','11阶粉色戒指【通用】',2,'[{lv,400}]',3,'[{0,38280520,12}]','[1005001143,1009001143,1005001143,1009001143,1005001143,1009001143,1005001143,1009001143]','[]','[]','[{0,1009001153,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,12}]',150),(32091110,'鞋子','11阶粉色鞋子【龙骑士】',2,'[{lv,400}]',3,'[{0,38280510,12}]','[1002011143,1004011143,1006011143,1008011143,1010011143,1002021143,1004021143,1006021143,1008021143,1010021143,1002031143,1004031143,1006031143,1008031143,1010031143,1002041143,1004041143,1006041143,1008041143,1010041143]','[]','[]','[{0,1010021153,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,12}]',150),(32091201,'武器','12阶粉色武器【龙骑士】',2,'[{lv,500}]',3,'[{0,38280520,16}]','[1001011243,1007011243,1001021243,1007021243,1001031243,1007031243,1001041243,1007041243]','[]','[]','[{0,1001021253,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,16}]',150),(32091202,'头盔','12阶粉色头盔【龙骑士】',2,'[{lv,500}]',3,'[{0,38280510,16}]','[1002011243,1004011243,1006011243,1008011243,1010011243,1002021243,1004021243,1006021243,1008021243,1010021243,1002031243,1004031243,1006031243,1008031243,1010031243,1002041243,1004041243,1006041243,1008041243,1010041243]','[]','[]','[{0,1002021253,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,16}]',150),(32091203,'项链','12阶粉色项链【通用】',2,'[{lv,500}]',3,'[{0,38280520,16}]','[1003001243,1003001243,1003001243,1003001243]','[]','[]','[{0,1003001253,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,16}]',150),(32091204,'衣服','12阶粉色衣服【龙骑士】',2,'[{lv,500}]',3,'[{0,38280510,16}]','[1002011243,1004011243,1006011243,1008011243,1010011243,1002021243,1004021243,1006021243,1008021243,1010021243,1002031243,1004031243,1006031243,1008031243,1010031243,1002041243,1004041243,1006041243,1008041243,1010041243]','[]','[]','[{0,1004021253,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,16}]',150),(32091205,'刻痕','12阶粉色刻痕【通用】',2,'[{lv,500}]',3,'[{0,38280520,16}]','[1005001243,1009001243,1005001243,1009001243,1005001243,1009001243,1005001243,1009001243]','[]','[]','[{0,1005001253,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,16}]',150),(32091206,'裤子','12阶粉色裤子【龙骑士】',2,'[{lv,500}]',3,'[{0,38280510,16}]','[1002011243,1004011243,1006011243,1008011243,1010011243,1002021243,1004021243,1006021243,1008021243,1010021243,1002031243,1004031243,1006031243,1008031243,1010031243,1002041243,1004041243,1006041243,1008041243,1010041243]','[]','[]','[{0,1006021253,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,16}]',150),(32091207,'副手','12阶粉色副手【龙骑士】',2,'[{lv,500}]',3,'[{0,38280520,16}]','[1001011243,1007011243,1001021243,1007021243,1001031243,1007031243,1001041243,1007041243]','[]','[]','[{0,1007021253,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,16}]',150),(32091208,'护腕','12阶粉色护腕【龙骑士】',2,'[{lv,500}]',3,'[{0,38280510,16}]','[1002011243,1004011243,1006011243,1008011243,1010011243,1002021243,1004021243,1006021243,1008021243,1010021243,1002031243,1004031243,1006031243,1008031243,1010031243,1002041243,1004041243,1006041243,1008041243,1010041243]','[]','[]','[{0,1008021253,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,16}]',150),(32091209,'戒指','12阶粉色戒指【通用】',2,'[{lv,500}]',3,'[{0,38280520,16}]','[1005001243,1009001243,1005001243,1009001243,1005001243,1009001243,1005001243,1009001243]','[]','[]','[{0,1009001253,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,16}]',150),(32091210,'鞋子','12阶粉色鞋子【龙骑士】',2,'[{lv,500}]',3,'[{0,38280510,16}]','[1002011243,1004011243,1006011243,1008011243,1010011243,1002021243,1004021243,1006021243,1008021243,1010021243,1002031243,1004031243,1006031243,1008031243,1010031243,1002041243,1004041243,1006041243,1008041243,1010041243]','[]','[]','[{0,1010021253,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,16}]',150),(32091301,'武器','13阶粉色武器【龙骑士】',2,'[{lv,520}]',3,'[{0,38280520,20}]','[1001011343,1007011343,1001021343,1007021343,1001031343,1007031343,1001041343,1007041343]','[]','[]','[{0,1001021353,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,20}]',150),(32091302,'头盔','13阶粉色头盔【龙骑士】',2,'[{lv,520}]',3,'[{0,38280510,20}]','[1002011343,1004011343,1006011343,1008011343,1010011343,1002021343,1004021343,1006021343,1008021343,1010021343,1002031343,1004031343,1006031343,1008031343,1010031343,1002041343,1004041343,1006041343,1008041343,1010041343]','[]','[]','[{0,1002021353,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,20}]',150),(32091303,'项链','13阶粉色项链【通用】',2,'[{lv,520}]',3,'[{0,38280520,20}]','[1003001343,1003001343,1003001343,1003001343]','[]','[]','[{0,1003001353,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,20}]',150),(32091304,'衣服','13阶粉色衣服【龙骑士】',2,'[{lv,520}]',3,'[{0,38280510,20}]','[1002011343,1004011343,1006011343,1008011343,1010011343,1002021343,1004021343,1006021343,1008021343,1010021343,1002031343,1004031343,1006031343,1008031343,1010031343,1002041343,1004041343,1006041343,1008041343,1010041343]','[]','[]','[{0,1004021353,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,20}]',150),(32091305,'刻痕','13阶粉色刻痕【通用】',2,'[{lv,520}]',3,'[{0,38280520,20}]','[1005001343,1009001343,1005001343,1009001343,1005001343,1009001343,1005001343,1009001343]','[]','[]','[{0,1005001353,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,20}]',150),(32091306,'裤子','13阶粉色裤子【龙骑士】',2,'[{lv,520}]',3,'[{0,38280510,20}]','[1002011343,1004011343,1006011343,1008011343,1010011343,1002021343,1004021343,1006021343,1008021343,1010021343,1002031343,1004031343,1006031343,1008031343,1010031343,1002041343,1004041343,1006041343,1008041343,1010041343]','[]','[]','[{0,1006021353,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,20}]',150),(32091307,'副手','13阶粉色副手【龙骑士】',2,'[{lv,520}]',3,'[{0,38280520,20}]','[1001011343,1007011343,1001021343,1007021343,1001031343,1007031343,1001041343,1007041343]','[]','[]','[{0,1007021353,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,20}]',150),(32091308,'护腕','13阶粉色护腕【龙骑士】',2,'[{lv,520}]',3,'[{0,38280510,20}]','[1002011343,1004011343,1006011343,1008011343,1010011343,1002021343,1004021343,1006021343,1008021343,1010021343,1002031343,1004031343,1006031343,1008031343,1010031343,1002041343,1004041343,1006041343,1008041343,1010041343]','[]','[]','[{0,1008021353,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,20}]',150),(32091309,'戒指','13阶粉色戒指【通用】',2,'[{lv,520}]',3,'[{0,38280520,20}]','[1005001343,1009001343,1005001343,1009001343,1005001343,1009001343,1005001343,1009001343]','[]','[]','[{0,1009001353,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,20}]',150),(32091310,'鞋子','13阶粉色鞋子【龙骑士】',2,'[{lv,520}]',3,'[{0,38280510,20}]','[1002011343,1004011343,1006011343,1008011343,1010011343,1002021343,1004021343,1006021343,1008021343,1010021343,1002031343,1004031343,1006031343,1008031343,1010031343,1002041343,1004041343,1006041343,1008041343,1010041343]','[]','[]','[{0,1010021353,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,20}]',150),(32091401,'武器','14阶粉色武器【龙骑士】',2,'[{lv,620}]',3,'[{0,38280520,25}]','[1001011443,1007011443,1001021443,1007021443,1001031443,1007031443,1001041443,1007041443]','[]','[]','[{0,1001021453,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,25}]',150),(32091402,'头盔','14阶粉色头盔【龙骑士】',2,'[{lv,620}]',3,'[{0,38280510,25}]','[1002011443,1004011443,1006011443,1008011443,1010011443,1002021443,1004021443,1006021443,1008021443,1010021443,1002031443,1004031443,1006031443,1008031443,1010031443,1002041443,1004041443,1006041443,1008041443,1010041443]','[]','[]','[{0,1002021453,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,25}]',150),(32091403,'项链','14阶粉色项链【通用】',2,'[{lv,620}]',3,'[{0,38280520,25}]','[1003001443,1003001443,1003001443,1003001443]','[]','[]','[{0,1003001453,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,25}]',150),(32091404,'衣服','14阶粉色衣服【龙骑士】',2,'[{lv,620}]',3,'[{0,38280510,25}]','[1002011443,1004011443,1006011443,1008011443,1010011443,1002021443,1004021443,1006021443,1008021443,1010021443,1002031443,1004031443,1006031443,1008031443,1010031443,1002041443,1004041443,1006041443,1008041443,1010041443]','[]','[]','[{0,1004021453,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,25}]',150),(32091405,'刻痕','14阶粉色刻痕【通用】',2,'[{lv,620}]',3,'[{0,38280520,25}]','[1005001443,1009001443,1005001443,1009001443,1005001443,1009001443,1005001443,1009001443]','[]','[]','[{0,1005001453,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,25}]',150),(32091406,'裤子','14阶粉色裤子【龙骑士】',2,'[{lv,620}]',3,'[{0,38280510,25}]','[1002011443,1004011443,1006011443,1008011443,1010011443,1002021443,1004021443,1006021443,1008021443,1010021443,1002031443,1004031443,1006031443,1008031443,1010031443,1002041443,1004041443,1006041443,1008041443,1010041443]','[]','[]','[{0,1006021453,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,25}]',150),(32091407,'副手','14阶粉色副手【龙骑士】',2,'[{lv,620}]',3,'[{0,38280520,25}]','[1001011443,1007011443,1001021443,1007021443,1001031443,1007031443,1001041443,1007041443]','[]','[]','[{0,1007021453,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,25}]',150),(32091408,'护腕','14阶粉色护腕【龙骑士】',2,'[{lv,620}]',3,'[{0,38280510,25}]','[1002011443,1004011443,1006011443,1008011443,1010011443,1002021443,1004021443,1006021443,1008021443,1010021443,1002031443,1004031443,1006031443,1008031443,1010031443,1002041443,1004041443,1006041443,1008041443,1010041443]','[]','[]','[{0,1008021453,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,25}]',150),(32091409,'戒指','14阶粉色戒指【通用】',2,'[{lv,620}]',3,'[{0,38280520,25}]','[1005001443,1009001443,1005001443,1009001443,1005001443,1009001443,1005001443,1009001443]','[]','[]','[{0,1009001453,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,25}]',150),(32091410,'鞋子','14阶粉色鞋子【龙骑士】',2,'[{lv,620}]',3,'[{0,38280510,25}]','[1002011443,1004011443,1006011443,1008011443,1010011443,1002021443,1004021443,1006021443,1008021443,1010021443,1002031443,1004031443,1006031443,1008031443,1010031443,1002041443,1004041443,1006041443,1008041443,1010041443]','[]','[]','[{0,1010021453,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,25}]',150),(32091501,'武器','15阶粉色武器【龙骑士】',2,'[{lv,650}]',3,'[{0,38280520,30}]','[1001011543,1007011543,1001021543,1007021543,1001031543,1007031543,1001041543,1007041543]','[]','[]','[{0,1001021553,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,30}]',150),(32091502,'头盔','15阶粉色头盔【龙骑士】',2,'[{lv,650}]',3,'[{0,38280510,30}]','[1002011543,1004011543,1006011543,1008011543,1010011543,1002021543,1004021543,1006021543,1008021543,1010021543,1002031543,1004031543,1006031543,1008031543,1010031543,1002041543,1004041543,1006041543,1008041543,1010041543]','[]','[]','[{0,1002021553,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,30}]',150),(32091503,'项链','15阶粉色项链【通用】',2,'[{lv,650}]',3,'[{0,38280520,30}]','[1003001543,1003001543,1003001543,1003001543]','[]','[]','[{0,1003001553,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,30}]',150),(32091504,'衣服','15阶粉色衣服【龙骑士】',2,'[{lv,650}]',3,'[{0,38280510,30}]','[1002011543,1004011543,1006011543,1008011543,1010011543,1002021543,1004021543,1006021543,1008021543,1010021543,1002031543,1004031543,1006031543,1008031543,1010031543,1002041543,1004041543,1006041543,1008041543,1010041543]','[]','[]','[{0,1004021553,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,30}]',150),(32091505,'刻痕','15阶粉色刻痕【通用】',2,'[{lv,650}]',3,'[{0,38280520,30}]','[1005001543,1009001543,1005001543,1009001543,1005001543,1009001543,1005001543,1009001543]','[]','[]','[{0,1005001553,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,30}]',150),(32091506,'裤子','15阶粉色裤子【龙骑士】',2,'[{lv,650}]',3,'[{0,38280510,30}]','[1002011543,1004011543,1006011543,1008011543,1010011543,1002021543,1004021543,1006021543,1008021543,1010021543,1002031543,1004031543,1006031543,1008031543,1010031543,1002041543,1004041543,1006041543,1008041543,1010041543]','[]','[]','[{0,1006021553,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,30}]',150),(32091507,'副手','15阶粉色副手【龙骑士】',2,'[{lv,650}]',3,'[{0,38280520,30}]','[1001011543,1007011543,1001021543,1007021543,1001031543,1007031543,1001041543,1007041543]','[]','[]','[{0,1007021553,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,30}]',150),(32091508,'护腕','15阶粉色护腕【龙骑士】',2,'[{lv,650}]',3,'[{0,38280510,30}]','[1002011543,1004011543,1006011543,1008011543,1010011543,1002021543,1004021543,1006021543,1008021543,1010021543,1002031543,1004031543,1006031543,1008031543,1010031543,1002041543,1004041543,1006041543,1008041543,1010041543]','[]','[]','[{0,1008021553,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,30}]',150),(32091509,'戒指','15阶粉色戒指【通用】',2,'[{lv,650}]',3,'[{0,38280520,30}]','[1005001543,1009001543,1005001543,1009001543,1005001543,1009001543,1005001543,1009001543]','[]','[]','[{0,1009001553,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,30}]',150),(32091510,'鞋子','15阶粉色鞋子【龙骑士】',2,'[{lv,650}]',3,'[{0,38280510,30}]','[1002011543,1004011543,1006011543,1008011543,1010011543,1002021543,1004021543,1006021543,1008021543,1010021543,1002031543,1004031543,1006031543,1008031543,1010031543,1002041543,1004041543,1006041543,1008041543,1010041543]','[]','[]','[{0,1010021553,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,30}]',150),(32091601,'武器','16阶粉色武器【龙骑士】',2,'[{lv,700}]',3,'[{0,38280520,35}]','[1001011643,1007011643,1001021643,1007021643,1001031643,1007031643,1001041643,1007041643]','[]','[]','[{0,1001021653,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,35}]',150),(32091602,'头盔','16阶粉色头盔【龙骑士】',2,'[{lv,700}]',3,'[{0,38280510,35}]','[1002011643,1004011643,1006011643,1008011643,1010011643,1002021643,1004021643,1006021643,1008021643,1010021643,1002031643,1004031643,1006031643,1008031643,1010031643,1002041643,1004041643,1006041643,1008041643,1010041643]','[]','[]','[{0,1002021653,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,35}]',150),(32091603,'项链','16阶粉色项链【通用】',2,'[{lv,700}]',3,'[{0,38280520,35}]','[1003001643,1003001643,1003001643,1003001643]','[]','[]','[{0,1003001653,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,35}]',150),(32091604,'衣服','16阶粉色衣服【龙骑士】',2,'[{lv,700}]',3,'[{0,38280510,35}]','[1002011643,1004011643,1006011643,1008011643,1010011643,1002021643,1004021643,1006021643,1008021643,1010021643,1002031643,1004031643,1006031643,1008031643,1010031643,1002041643,1004041643,1006041643,1008041643,1010041643]','[]','[]','[{0,1004021653,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,35}]',150),(32091605,'刻痕','16阶粉色刻痕【通用】',2,'[{lv,700}]',3,'[{0,38280520,35}]','[1005001643,1009001643,1005001643,1009001643,1005001643,1009001643,1005001643,1009001643]','[]','[]','[{0,1005001653,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,35}]',150),(32091606,'裤子','16阶粉色裤子【龙骑士】',2,'[{lv,700}]',3,'[{0,38280510,35}]','[1002011643,1004011643,1006011643,1008011643,1010011643,1002021643,1004021643,1006021643,1008021643,1010021643,1002031643,1004031643,1006031643,1008031643,1010031643,1002041643,1004041643,1006041643,1008041643,1010041643]','[]','[]','[{0,1006021653,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,35}]',150),(32091607,'副手','16阶粉色副手【龙骑士】',2,'[{lv,700}]',3,'[{0,38280520,35}]','[1001011643,1007011643,1001021643,1007021643,1001031643,1007031643,1001041643,1007041643]','[]','[]','[{0,1007021653,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,35}]',150),(32091608,'护腕','16阶粉色护腕【龙骑士】',2,'[{lv,700}]',3,'[{0,38280510,35}]','[1002011643,1004011643,1006011643,1008011643,1010011643,1002021643,1004021643,1006021643,1008021643,1010021643,1002031643,1004031643,1006031643,1008031643,1010031643,1002041643,1004041643,1006041643,1008041643,1010041643]','[]','[]','[{0,1008021653,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,35}]',150),(32091609,'戒指','16阶粉色戒指【通用】',2,'[{lv,700}]',3,'[{0,38280520,35}]','[1005001643,1009001643,1005001643,1009001643,1005001643,1009001643,1005001643,1009001643]','[]','[]','[{0,1009001653,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,35}]',150),(32091610,'鞋子','16阶粉色鞋子【龙骑士】',2,'[{lv,700}]',3,'[{0,38280510,35}]','[1002011643,1004011643,1006011643,1008011643,1010011643,1002021643,1004021643,1006021643,1008021643,1010021643,1002031643,1004031643,1006031643,1008031643,1010031643,1002041643,1004041643,1006041643,1008041643,1010041643]','[]','[]','[{0,1010021653,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,35}]',150),(32100301,'武器','3阶神装武器【龙骑士】',2,'[{lv,9999}]',3,'[{0,38280620,2}]','[1001010263,1007010263,1001020263,1007020263,1001030263,1007030263,1001040263,1007040263]','[]','[]','[{0,1001020363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100302,'头盔','3阶神装头盔【龙骑士】',2,'[{lv,9999}]',3,'[{0,38280620,2}]','[1002010263,1004010263,1006010263,1008010263,1010010263,1002020263,1004020263,1006020263,1008020263,1010020263,1002030263,1004030263,1006030263,1008030263,1010030263,1002040263,1004040263,1006040263,1008040263,1010040263]','[]','[]','[{0,1002020363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100303,'项链','3阶神装项链【通用】',2,'[{lv,9999}]',3,'[{0,38280620,2}]','[1003000263,1003000263,1003000263,1003000263]','[]','[]','[{0,1003000363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100304,'衣服','3阶神装衣服【龙骑士】',2,'[{lv,9999}]',3,'[{0,38280620,2}]','[1002010263,1004010263,1006010263,1008010263,1010010263,1002020263,1004020263,1006020263,1008020263,1010020263,1002030263,1004030263,1006030263,1008030263,1010030263,1002040263,1004040263,1006040263,1008040263,1010040263]','[]','[]','[{0,1004020363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100305,'刻痕','3阶神装刻痕【通用】',2,'[{lv,9999}]',3,'[{0,38280620,2}]','[1005000263,1009000263,1005000263,1009000263,1005000263,1009000263,1005000263,1009000263]','[]','[]','[{0,1005000363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100306,'裤子','3阶神装裤子【龙骑士】',2,'[{lv,9999}]',3,'[{0,38280620,2}]','[1002010263,1004010263,1006010263,1008010263,1010010263,1002020263,1004020263,1006020263,1008020263,1010020263,1002030263,1004030263,1006030263,1008030263,1010030263,1002040263,1004040263,1006040263,1008040263,1010040263]','[]','[]','[{0,1006020363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100307,'副手','3阶神装副手【龙骑士】',2,'[{lv,9999}]',3,'[{0,38280620,2}]','[1001010263,1007010263,1001020263,1007020263,1001030263,1007030263,1001040263,1007040263]','[]','[]','[{0,1007020363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100308,'护腕','3阶神装护腕【龙骑士】',2,'[{lv,9999}]',3,'[{0,38280620,2}]','[1002010263,1004010263,1006010263,1008010263,1010010263,1002020263,1004020263,1006020263,1008020263,1010020263,1002030263,1004030263,1006030263,1008030263,1010030263,1002040263,1004040263,1006040263,1008040263,1010040263]','[]','[]','[{0,1008020363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100309,'戒指','3阶神装戒指【通用】',2,'[{lv,9999}]',3,'[{0,38280620,2}]','[1005000263,1009000263,1005000263,1009000263,1005000263,1009000263,1005000263,1009000263]','[]','[]','[{0,1009000363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100310,'鞋子','3阶神装鞋子【龙骑士】',2,'[{lv,9999}]',3,'[{0,38280620,2}]','[1002010263,1004010263,1006010263,1008010263,1010010263,1002020263,1004020263,1006020263,1008020263,1010020263,1002030263,1004030263,1006030263,1008030263,1010030263,1002040263,1004040263,1006040263,1008040263,1010040263]','[]','[]','[{0,1010020363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100401,'武器','4阶神装武器【龙骑士】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1001010363,1007010363,1001020363,1007020363,1001030363,1007030363,1001040363,1007040363]','[]','[]','[{0,1001020463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100402,'头盔','4阶神装头盔【龙骑士】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1002010363,1004010363,1006010363,1008010363,1010010363,1002020363,1004020363,1006020363,1008020363,1010020363,1002030363,1004030363,1006030363,1008030363,1010030363,1002040363,1004040363,1006040363,1008040363,1010040363]','[]','[]','[{0,1002020463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100403,'项链','4阶神装项链【通用】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1003000363,1003000363,1003000363,1003000363]','[]','[]','[{0,1003000463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100404,'衣服','4阶神装衣服【龙骑士】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1002010363,1004010363,1006010363,1008010363,1010010363,1002020363,1004020363,1006020363,1008020363,1010020363,1002030363,1004030363,1006030363,1008030363,1010030363,1002040363,1004040363,1006040363,1008040363,1010040363]','[]','[]','[{0,1004020463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100405,'刻痕','4阶神装刻痕【通用】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1005000363,1009000363,1005000363,1009000363,1005000363,1009000363,1005000363,1009000363]','[]','[]','[{0,1005000463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100406,'裤子','4阶神装裤子【龙骑士】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1002010363,1004010363,1006010363,1008010363,1010010363,1002020363,1004020363,1006020363,1008020363,1010020363,1002030363,1004030363,1006030363,1008030363,1010030363,1002040363,1004040363,1006040363,1008040363,1010040363]','[]','[]','[{0,1006020463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100407,'副手','4阶神装副手【龙骑士】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1001010363,1007010363,1001020363,1007020363,1001030363,1007030363,1001040363,1007040363]','[]','[]','[{0,1007020463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100408,'护腕','4阶神装护腕【龙骑士】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1002010363,1004010363,1006010363,1008010363,1010010363,1002020363,1004020363,1006020363,1008020363,1010020363,1002030363,1004030363,1006030363,1008030363,1010030363,1002040363,1004040363,1006040363,1008040363,1010040363]','[]','[]','[{0,1008020463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100409,'戒指','4阶神装戒指【通用】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1005000363,1009000363,1005000363,1009000363,1005000363,1009000363,1005000363,1009000363]','[]','[]','[{0,1009000463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100410,'鞋子','4阶神装鞋子【龙骑士】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1002010363,1004010363,1006010363,1008010363,1010010363,1002020363,1004020363,1006020363,1008020363,1010020363,1002030363,1004030363,1006030363,1008030363,1010030363,1002040363,1004040363,1006040363,1008040363,1010040363]','[]','[]','[{0,1010020463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100501,'武器','5阶神装武器【龙骑士】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1001010463,1007010463,1001020463,1007020463,1001030463,1007030463,1001040463,1007040463]','[]','[]','[{0,1001020563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100502,'头盔','5阶神装头盔【龙骑士】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1002010463,1004010463,1006010463,1008010463,1010010463,1002020463,1004020463,1006020463,1008020463,1010020463,1002030463,1004030463,1006030463,1008030463,1010030463,1002040463,1004040463,1006040463,1008040463,1010040463]','[]','[]','[{0,1002020563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100503,'项链','5阶神装项链【通用】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1003000463,1003000463,1003000463,1003000463]','[]','[]','[{0,1003000563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100504,'衣服','5阶神装衣服【龙骑士】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1002010463,1004010463,1006010463,1008010463,1010010463,1002020463,1004020463,1006020463,1008020463,1010020463,1002030463,1004030463,1006030463,1008030463,1010030463,1002040463,1004040463,1006040463,1008040463,1010040463]','[]','[]','[{0,1004020563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100505,'刻痕','5阶神装刻痕【通用】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1005000463,1009000463,1005000463,1009000463,1005000463,1009000463,1005000463,1009000463]','[]','[]','[{0,1005000563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100506,'裤子','5阶神装裤子【龙骑士】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1002010463,1004010463,1006010463,1008010463,1010010463,1002020463,1004020463,1006020463,1008020463,1010020463,1002030463,1004030463,1006030463,1008030463,1010030463,1002040463,1004040463,1006040463,1008040463,1010040463]','[]','[]','[{0,1006020563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100507,'副手','5阶神装副手【龙骑士】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1001010463,1007010463,1001020463,1007020463,1001030463,1007030463,1001040463,1007040463]','[]','[]','[{0,1007020563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100508,'护腕','5阶神装护腕【龙骑士】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1002010463,1004010463,1006010463,1008010463,1010010463,1002020463,1004020463,1006020463,1008020463,1010020463,1002030463,1004030463,1006030463,1008030463,1010030463,1002040463,1004040463,1006040463,1008040463,1010040463]','[]','[]','[{0,1008020563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100509,'戒指','5阶神装戒指【通用】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1005000463,1009000463,1005000463,1009000463,1005000463,1009000463,1005000463,1009000463]','[]','[]','[{0,1009000563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100510,'鞋子','5阶神装鞋子【龙骑士】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1002010463,1004010463,1006010463,1008010463,1010010463,1002020463,1004020463,1006020463,1008020463,1010020463,1002030463,1004030463,1006030463,1008030463,1010030463,1002040463,1004040463,1006040463,1008040463,1010040463]','[]','[]','[{0,1010020563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100601,'武器','6阶神装武器【龙骑士】',2,'[{lv,180}]',3,'[{0,38280620,2}]','[1001010563,1007010563,1001020563,1007020563,1001030563,1007030563,1001040563,1007040563]','[]','[]','[{0,1001020663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100602,'头盔','6阶神装头盔【龙骑士】',2,'[{lv,180}]',3,'[{0,38280620,2}]','[1002010563,1004010563,1006010563,1008010563,1010010563,1002020563,1004020563,1006020563,1008020563,1010020563,1002030563,1004030563,1006030563,1008030563,1010030563,1002040563,1004040563,1006040563,1008040563,1010040563]','[]','[]','[{0,1002020663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100603,'项链','6阶神装项链【通用】',2,'[{lv,180}]',3,'[{0,38280620,2}]','[1003000563,1003000563,1003000563,1003000563]','[]','[]','[{0,1003000663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100604,'衣服','6阶神装衣服【龙骑士】',2,'[{lv,180}]',3,'[{0,38280620,2}]','[1002010563,1004010563,1006010563,1008010563,1010010563,1002020563,1004020563,1006020563,1008020563,1010020563,1002030563,1004030563,1006030563,1008030563,1010030563,1002040563,1004040563,1006040563,1008040563,1010040563]','[]','[]','[{0,1004020663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100605,'刻痕','6阶神装刻痕【通用】',2,'[{lv,180}]',3,'[{0,38280620,2}]','[1005000563,1009000563,1005000563,1009000563,1005000563,1009000563,1005000563,1009000563]','[]','[]','[{0,1005000663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100606,'裤子','6阶神装裤子【龙骑士】',2,'[{lv,180}]',3,'[{0,38280620,2}]','[1002010563,1004010563,1006010563,1008010563,1010010563,1002020563,1004020563,1006020563,1008020563,1010020563,1002030563,1004030563,1006030563,1008030563,1010030563,1002040563,1004040563,1006040563,1008040563,1010040563]','[]','[]','[{0,1006020663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100607,'副手','6阶神装副手【龙骑士】',2,'[{lv,180}]',3,'[{0,38280620,2}]','[1001010563,1007010563,1001020563,1007020563,1001030563,1007030563,1001040563,1007040563]','[]','[]','[{0,1007020663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100608,'护腕','6阶神装护腕【龙骑士】',2,'[{lv,180}]',3,'[{0,38280620,2}]','[1002010563,1004010563,1006010563,1008010563,1010010563,1002020563,1004020563,1006020563,1008020563,1010020563,1002030563,1004030563,1006030563,1008030563,1010030563,1002040563,1004040563,1006040563,1008040563,1010040563]','[]','[]','[{0,1008020663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100609,'戒指','6阶神装戒指【通用】',2,'[{lv,180}]',3,'[{0,38280620,2}]','[1005000563,1009000563,1005000563,1009000563,1005000563,1009000563,1005000563,1009000563]','[]','[]','[{0,1009000663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100610,'鞋子','6阶神装鞋子【龙骑士】',2,'[{lv,180}]',3,'[{0,38280620,2}]','[1002010563,1004010563,1006010563,1008010563,1010010563,1002020563,1004020563,1006020563,1008020563,1010020563,1002030563,1004030563,1006030563,1008030563,1010030563,1002040563,1004040563,1006040563,1008040563,1010040563]','[]','[]','[{0,1010020663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100701,'武器','7阶神装武器【龙骑士】',2,'[{lv,220}]',3,'[{0,38280620,2}]','[1001010663,1007010663,1001020663,1007020663,1001030663,1007030663,1001040663,1007040663]','[]','[]','[{0,1001020763,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100702,'头盔','7阶神装头盔【龙骑士】',2,'[{lv,220}]',3,'[{0,38280620,2}]','[1002010663,1004010663,1006010663,1008010663,1010010663,1002020663,1004020663,1006020663,1008020663,1010020663,1002030663,1004030663,1006030663,1008030663,1010030663,1002040663,1004040663,1006040663,1008040663,1010040663]','[]','[]','[{0,1002020763,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100703,'项链','7阶神装项链【通用】',2,'[{lv,220}]',3,'[{0,38280620,2}]','[1003000663,1003000663,1003000663,1003000663]','[]','[]','[{0,1003000763,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100704,'衣服','7阶神装衣服【龙骑士】',2,'[{lv,220}]',3,'[{0,38280620,2}]','[1002010663,1004010663,1006010663,1008010663,1010010663,1002020663,1004020663,1006020663,1008020663,1010020663,1002030663,1004030663,1006030663,1008030663,1010030663,1002040663,1004040663,1006040663,1008040663,1010040663]','[]','[]','[{0,1004020763,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100705,'刻痕','7阶神装刻痕【通用】',2,'[{lv,220}]',3,'[{0,38280620,2}]','[1005000663,1009000663,1005000663,1009000663,1005000663,1009000663,1005000663,1009000663]','[]','[]','[{0,1005000763,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100706,'裤子','7阶神装裤子【龙骑士】',2,'[{lv,220}]',3,'[{0,38280620,2}]','[1002010663,1004010663,1006010663,1008010663,1010010663,1002020663,1004020663,1006020663,1008020663,1010020663,1002030663,1004030663,1006030663,1008030663,1010030663,1002040663,1004040663,1006040663,1008040663,1010040663]','[]','[]','[{0,1006020763,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100707,'副手','7阶神装副手【龙骑士】',2,'[{lv,220}]',3,'[{0,38280620,2}]','[1001010663,1007010663,1001020663,1007020663,1001030663,1007030663,1001040663,1007040663]','[]','[]','[{0,1007020763,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100708,'护腕','7阶神装护腕【龙骑士】',2,'[{lv,220}]',3,'[{0,38280620,2}]','[1002010663,1004010663,1006010663,1008010663,1010010663,1002020663,1004020663,1006020663,1008020663,1010020663,1002030663,1004030663,1006030663,1008030663,1010030663,1002040663,1004040663,1006040663,1008040663,1010040663]','[]','[]','[{0,1008020763,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100709,'戒指','7阶神装戒指【通用】',2,'[{lv,220}]',3,'[{0,38280620,2}]','[1005000663,1009000663,1005000663,1009000663,1005000663,1009000663,1005000663,1009000663]','[]','[]','[{0,1009000763,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100710,'鞋子','7阶神装鞋子【龙骑士】',2,'[{lv,220}]',3,'[{0,38280620,2}]','[1002010663,1004010663,1006010663,1008010663,1010010663,1002020663,1004020663,1006020663,1008020663,1010020663,1002030663,1004030663,1006030663,1008030663,1010030663,1002040663,1004040663,1006040663,1008040663,1010040663]','[]','[]','[{0,1010020763,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100801,'武器','8阶神装武器【龙骑士】',2,'[{lv,260}]',3,'[{0,38280620,2}]','[1001010763,1007010763,1001020763,1007020763,1001030763,1007030763,1001040763,1007040763]','[]','[]','[{0,1001020863,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100802,'头盔','8阶神装头盔【龙骑士】',2,'[{lv,260}]',3,'[{0,38280620,2}]','[1002010763,1004010763,1006010763,1008010763,1010010763,1002020763,1004020763,1006020763,1008020763,1010020763,1002030763,1004030763,1006030763,1008030763,1010030763,1002040763,1004040763,1006040763,1008040763,1010040763]','[]','[]','[{0,1002020863,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100803,'项链','8阶神装项链【通用】',2,'[{lv,260}]',3,'[{0,38280620,2}]','[1003000763,1003000763,1003000763,1003000763]','[]','[]','[{0,1003000863,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100804,'衣服','8阶神装衣服【龙骑士】',2,'[{lv,260}]',3,'[{0,38280620,2}]','[1002010763,1004010763,1006010763,1008010763,1010010763,1002020763,1004020763,1006020763,1008020763,1010020763,1002030763,1004030763,1006030763,1008030763,1010030763,1002040763,1004040763,1006040763,1008040763,1010040763]','[]','[]','[{0,1004020863,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100805,'刻痕','8阶神装刻痕【通用】',2,'[{lv,260}]',3,'[{0,38280620,2}]','[1005000763,1009000763,1005000763,1009000763,1005000763,1009000763,1005000763,1009000763]','[]','[]','[{0,1005000863,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100806,'裤子','8阶神装裤子【龙骑士】',2,'[{lv,260}]',3,'[{0,38280620,2}]','[1002010763,1004010763,1006010763,1008010763,1010010763,1002020763,1004020763,1006020763,1008020763,1010020763,1002030763,1004030763,1006030763,1008030763,1010030763,1002040763,1004040763,1006040763,1008040763,1010040763]','[]','[]','[{0,1006020863,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100807,'副手','8阶神装副手【龙骑士】',2,'[{lv,260}]',3,'[{0,38280620,2}]','[1001010763,1007010763,1001020763,1007020763,1001030763,1007030763,1001040763,1007040763]','[]','[]','[{0,1007020863,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100808,'护腕','8阶神装护腕【龙骑士】',2,'[{lv,260}]',3,'[{0,38280620,2}]','[1002010763,1004010763,1006010763,1008010763,1010010763,1002020763,1004020763,1006020763,1008020763,1010020763,1002030763,1004030763,1006030763,1008030763,1010030763,1002040763,1004040763,1006040763,1008040763,1010040763]','[]','[]','[{0,1008020863,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100809,'戒指','8阶神装戒指【通用】',2,'[{lv,260}]',3,'[{0,38280620,2}]','[1005000763,1009000763,1005000763,1009000763,1005000763,1009000763,1005000763,1009000763]','[]','[]','[{0,1009000863,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100810,'鞋子','8阶神装鞋子【龙骑士】',2,'[{lv,260}]',3,'[{0,38280620,2}]','[1002010763,1004010763,1006010763,1008010763,1010010763,1002020763,1004020763,1006020763,1008020763,1010020763,1002030763,1004030763,1006030763,1008030763,1010030763,1002040763,1004040763,1006040763,1008040763,1010040763]','[]','[]','[{0,1010020863,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100901,'武器','9阶神装武器【龙骑士】',2,'[{lv,300}]',3,'[{0,38280620,2}]','[1001010863,1007010863,1001020863,1007020863,1001030863,1007030863,1001040863,1007040863]','[]','[]','[{0,1001020963,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100902,'头盔','9阶神装头盔【龙骑士】',2,'[{lv,300}]',3,'[{0,38280620,2}]','[1002010863,1004010863,1006010863,1008010863,1010010863,1002020863,1004020863,1006020863,1008020863,1010020863,1002030863,1004030863,1006030863,1008030863,1010030863,1002040863,1004040863,1006040863,1008040863,1010040863]','[]','[]','[{0,1002020963,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100903,'项链','9阶神装项链【通用】',2,'[{lv,300}]',3,'[{0,38280620,2}]','[1003000863,1003000863,1003000863,1003000863]','[]','[]','[{0,1003000963,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100904,'衣服','9阶神装衣服【龙骑士】',2,'[{lv,300}]',3,'[{0,38280620,2}]','[1002010863,1004010863,1006010863,1008010863,1010010863,1002020863,1004020863,1006020863,1008020863,1010020863,1002030863,1004030863,1006030863,1008030863,1010030863,1002040863,1004040863,1006040863,1008040863,1010040863]','[]','[]','[{0,1004020963,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100905,'刻痕','9阶神装刻痕【通用】',2,'[{lv,300}]',3,'[{0,38280620,2}]','[1005000863,1009000863,1005000863,1009000863,1005000863,1009000863,1005000863,1009000863]','[]','[]','[{0,1005000963,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100906,'裤子','9阶神装裤子【龙骑士】',2,'[{lv,300}]',3,'[{0,38280620,2}]','[1002010863,1004010863,1006010863,1008010863,1010010863,1002020863,1004020863,1006020863,1008020863,1010020863,1002030863,1004030863,1006030863,1008030863,1010030863,1002040863,1004040863,1006040863,1008040863,1010040863]','[]','[]','[{0,1006020963,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100907,'副手','9阶神装副手【龙骑士】',2,'[{lv,300}]',3,'[{0,38280620,2}]','[1001010863,1007010863,1001020863,1007020863,1001030863,1007030863,1001040863,1007040863]','[]','[]','[{0,1007020963,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100908,'护腕','9阶神装护腕【龙骑士】',2,'[{lv,300}]',3,'[{0,38280620,2}]','[1002010863,1004010863,1006010863,1008010863,1010010863,1002020863,1004020863,1006020863,1008020863,1010020863,1002030863,1004030863,1006030863,1008030863,1010030863,1002040863,1004040863,1006040863,1008040863,1010040863]','[]','[]','[{0,1008020963,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100909,'戒指','9阶神装戒指【通用】',2,'[{lv,300}]',3,'[{0,38280620,2}]','[1005000863,1009000863,1005000863,1009000863,1005000863,1009000863,1005000863,1009000863]','[]','[]','[{0,1009000963,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32100910,'鞋子','9阶神装鞋子【龙骑士】',2,'[{lv,300}]',3,'[{0,38280620,2}]','[1002010863,1004010863,1006010863,1008010863,1010010863,1002020863,1004020863,1006020863,1008020863,1010020863,1002030863,1004030863,1006030863,1008030863,1010030863,1002040863,1004040863,1006040863,1008040863,1010040863]','[]','[]','[{0,1010020963,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101001,'武器','10阶神装武器【龙骑士】',2,'[{lv,355}]',3,'[{0,38280620,2}]','[1001010963,1007010963,1001020963,1007020963,1001030963,1007030963,1001040963,1007040963]','[]','[]','[{0,1001021063,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101002,'头盔','10阶神装头盔【龙骑士】',2,'[{lv,355}]',3,'[{0,38280620,2}]','[1002010963,1004010963,1006010963,1008010963,1010010963,1002020963,1004020963,1006020963,1008020963,1010020963,1002030963,1004030963,1006030963,1008030963,1010030963,1002040963,1004040963,1006040963,1008040963,1010040963]','[]','[]','[{0,1002021063,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101003,'项链','10阶神装项链【通用】',2,'[{lv,355}]',3,'[{0,38280620,2}]','[1003000963,1003000963,1003000963,1003000963]','[]','[]','[{0,1003001063,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101004,'衣服','10阶神装衣服【龙骑士】',2,'[{lv,355}]',3,'[{0,38280620,2}]','[1002010963,1004010963,1006010963,1008010963,1010010963,1002020963,1004020963,1006020963,1008020963,1010020963,1002030963,1004030963,1006030963,1008030963,1010030963,1002040963,1004040963,1006040963,1008040963,1010040963]','[]','[]','[{0,1004021063,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101005,'刻痕','10阶神装刻痕【通用】',2,'[{lv,355}]',3,'[{0,38280620,2}]','[1005000963,1009000963,1005000963,1009000963,1005000963,1009000963,1005000963,1009000963]','[]','[]','[{0,1005001063,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101006,'裤子','10阶神装裤子【龙骑士】',2,'[{lv,355}]',3,'[{0,38280620,2}]','[1002010963,1004010963,1006010963,1008010963,1010010963,1002020963,1004020963,1006020963,1008020963,1010020963,1002030963,1004030963,1006030963,1008030963,1010030963,1002040963,1004040963,1006040963,1008040963,1010040963]','[]','[]','[{0,1006021063,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101007,'副手','10阶神装副手【龙骑士】',2,'[{lv,355}]',3,'[{0,38280620,2}]','[1001010963,1007010963,1001020963,1007020963,1001030963,1007030963,1001040963,1007040963]','[]','[]','[{0,1007021063,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101008,'护腕','10阶神装护腕【龙骑士】',2,'[{lv,355}]',3,'[{0,38280620,2}]','[1002010963,1004010963,1006010963,1008010963,1010010963,1002020963,1004020963,1006020963,1008020963,1010020963,1002030963,1004030963,1006030963,1008030963,1010030963,1002040963,1004040963,1006040963,1008040963,1010040963]','[]','[]','[{0,1008021063,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101009,'戒指','10阶神装戒指【通用】',2,'[{lv,355}]',3,'[{0,38280620,2}]','[1005000963,1009000963,1005000963,1009000963,1005000963,1009000963,1005000963,1009000963]','[]','[]','[{0,1009001063,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101010,'鞋子','10阶神装鞋子【龙骑士】',2,'[{lv,355}]',3,'[{0,38280620,2}]','[1002010963,1004010963,1006010963,1008010963,1010010963,1002020963,1004020963,1006020963,1008020963,1010020963,1002030963,1004030963,1006030963,1008030963,1010030963,1002040963,1004040963,1006040963,1008040963,1010040963]','[]','[]','[{0,1010021063,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101101,'武器','11阶神装武器【龙骑士】',2,'[{lv,400}]',3,'[{0,38280620,2}]','[1001011063,1007011063,1001021063,1007021063,1001031063,1007031063,1001041063,1007041063]','[]','[]','[{0,1001021163,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101102,'头盔','11阶神装头盔【龙骑士】',2,'[{lv,400}]',3,'[{0,38280620,2}]','[1002011063,1004011063,1006011063,1008011063,1010011063,1002021063,1004021063,1006021063,1008021063,1010021063,1002031063,1004031063,1006031063,1008031063,1010031063,1002041063,1004041063,1006041063,1008041063,1010041063]','[]','[]','[{0,1002021163,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101103,'项链','11阶神装项链【通用】',2,'[{lv,400}]',3,'[{0,38280620,2}]','[1003001063,1003001063,1003001063,1003001063]','[]','[]','[{0,1003001163,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101104,'衣服','11阶神装衣服【龙骑士】',2,'[{lv,400}]',3,'[{0,38280620,2}]','[1002011063,1004011063,1006011063,1008011063,1010011063,1002021063,1004021063,1006021063,1008021063,1010021063,1002031063,1004031063,1006031063,1008031063,1010031063,1002041063,1004041063,1006041063,1008041063,1010041063]','[]','[]','[{0,1004021163,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101105,'刻痕','11阶神装刻痕【通用】',2,'[{lv,400}]',3,'[{0,38280620,2}]','[1005001063,1009001063,1005001063,1009001063,1005001063,1009001063,1005001063,1009001063]','[]','[]','[{0,1005001163,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101106,'裤子','11阶神装裤子【龙骑士】',2,'[{lv,400}]',3,'[{0,38280620,2}]','[1002011063,1004011063,1006011063,1008011063,1010011063,1002021063,1004021063,1006021063,1008021063,1010021063,1002031063,1004031063,1006031063,1008031063,1010031063,1002041063,1004041063,1006041063,1008041063,1010041063]','[]','[]','[{0,1006021163,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101107,'副手','11阶神装副手【龙骑士】',2,'[{lv,400}]',3,'[{0,38280620,2}]','[1001011063,1007011063,1001021063,1007021063,1001031063,1007031063,1001041063,1007041063]','[]','[]','[{0,1007021163,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101108,'护腕','11阶神装护腕【龙骑士】',2,'[{lv,400}]',3,'[{0,38280620,2}]','[1002011063,1004011063,1006011063,1008011063,1010011063,1002021063,1004021063,1006021063,1008021063,1010021063,1002031063,1004031063,1006031063,1008031063,1010031063,1002041063,1004041063,1006041063,1008041063,1010041063]','[]','[]','[{0,1008021163,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101109,'戒指','11阶神装戒指【通用】',2,'[{lv,400}]',3,'[{0,38280620,2}]','[1005001063,1009001063,1005001063,1009001063,1005001063,1009001063,1005001063,1009001063]','[]','[]','[{0,1009001163,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101110,'鞋子','11阶神装鞋子【龙骑士】',2,'[{lv,400}]',3,'[{0,38280620,2}]','[1002011063,1004011063,1006011063,1008011063,1010011063,1002021063,1004021063,1006021063,1008021063,1010021063,1002031063,1004031063,1006031063,1008031063,1010031063,1002041063,1004041063,1006041063,1008041063,1010041063]','[]','[]','[{0,1010021163,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101201,'武器','12阶神装武器【龙骑士】',2,'[{lv,500}]',3,'[{0,38280620,2}]','[1001011163,1007011163,1001021163,1007021163,1001031163,1007031163,1001041163,1007041163]','[]','[]','[{0,1001021263,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101202,'头盔','12阶神装头盔【龙骑士】',2,'[{lv,500}]',3,'[{0,38280620,2}]','[1002011163,1004011163,1006011163,1008011163,1010011163,1002021163,1004021163,1006021163,1008021163,1010021163,1002031163,1004031163,1006031163,1008031163,1010031163,1002041163,1004041163,1006041163,1008041163,1010041163]','[]','[]','[{0,1002021263,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101203,'项链','12阶神装项链【通用】',2,'[{lv,500}]',3,'[{0,38280620,2}]','[1003001163,1003001163,1003001163,1003001163]','[]','[]','[{0,1003001263,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101204,'衣服','12阶神装衣服【龙骑士】',2,'[{lv,500}]',3,'[{0,38280620,2}]','[1002011163,1004011163,1006011163,1008011163,1010011163,1002021163,1004021163,1006021163,1008021163,1010021163,1002031163,1004031163,1006031163,1008031163,1010031163,1002041163,1004041163,1006041163,1008041163,1010041163]','[]','[]','[{0,1004021263,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101205,'刻痕','12阶神装刻痕【通用】',2,'[{lv,500}]',3,'[{0,38280620,2}]','[1005001163,1009001163,1005001163,1009001163,1005001163,1009001163,1005001163,1009001163]','[]','[]','[{0,1005001263,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101206,'裤子','12阶神装裤子【龙骑士】',2,'[{lv,500}]',3,'[{0,38280620,2}]','[1002011163,1004011163,1006011163,1008011163,1010011163,1002021163,1004021163,1006021163,1008021163,1010021163,1002031163,1004031163,1006031163,1008031163,1010031163,1002041163,1004041163,1006041163,1008041163,1010041163]','[]','[]','[{0,1006021263,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101207,'副手','12阶神装副手【龙骑士】',2,'[{lv,500}]',3,'[{0,38280620,2}]','[1001011163,1007011163,1001021163,1007021163,1001031163,1007031163,1001041163,1007041163]','[]','[]','[{0,1007021263,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101208,'护腕','12阶神装护腕【龙骑士】',2,'[{lv,500}]',3,'[{0,38280620,2}]','[1002011163,1004011163,1006011163,1008011163,1010011163,1002021163,1004021163,1006021163,1008021163,1010021163,1002031163,1004031163,1006031163,1008031163,1010031163,1002041163,1004041163,1006041163,1008041163,1010041163]','[]','[]','[{0,1008021263,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101209,'戒指','12阶神装戒指【通用】',2,'[{lv,500}]',3,'[{0,38280620,2}]','[1005001163,1009001163,1005001163,1009001163,1005001163,1009001163,1005001163,1009001163]','[]','[]','[{0,1009001263,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101210,'鞋子','12阶神装鞋子【龙骑士】',2,'[{lv,500}]',3,'[{0,38280620,2}]','[1002011163,1004011163,1006011163,1008011163,1010011163,1002021163,1004021163,1006021163,1008021163,1010021163,1002031163,1004031163,1006031163,1008031163,1010031163,1002041163,1004041163,1006041163,1008041163,1010041163]','[]','[]','[{0,1010021263,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101301,'武器','13阶神装武器【龙骑士】',2,'[{lv,520}]',3,'[{0,38280620,2}]','[1001011263,1007011263,1001021263,1007021263,1001031263,1007031263,1001041263,1007041263]','[]','[]','[{0,1001021363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101302,'头盔','13阶神装头盔【龙骑士】',2,'[{lv,520}]',3,'[{0,38280620,2}]','[1002011263,1004011263,1006011263,1008011263,1010011263,1002021263,1004021263,1006021263,1008021263,1010021263,1002031263,1004031263,1006031263,1008031263,1010031263,1002041263,1004041263,1006041263,1008041263,1010041263]','[]','[]','[{0,1002021363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101303,'项链','13阶神装项链【通用】',2,'[{lv,520}]',3,'[{0,38280620,2}]','[1003001263,1003001263,1003001263,1003001263]','[]','[]','[{0,1003001363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101304,'衣服','13阶神装衣服【龙骑士】',2,'[{lv,520}]',3,'[{0,38280620,2}]','[1002011263,1004011263,1006011263,1008011263,1010011263,1002021263,1004021263,1006021263,1008021263,1010021263,1002031263,1004031263,1006031263,1008031263,1010031263,1002041263,1004041263,1006041263,1008041263,1010041263]','[]','[]','[{0,1004021363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101305,'刻痕','13阶神装刻痕【通用】',2,'[{lv,520}]',3,'[{0,38280620,2}]','[1005001263,1009001263,1005001263,1009001263,1005001263,1009001263,1005001263,1009001263]','[]','[]','[{0,1005001363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101306,'裤子','13阶神装裤子【龙骑士】',2,'[{lv,520}]',3,'[{0,38280620,2}]','[1002011263,1004011263,1006011263,1008011263,1010011263,1002021263,1004021263,1006021263,1008021263,1010021263,1002031263,1004031263,1006031263,1008031263,1010031263,1002041263,1004041263,1006041263,1008041263,1010041263]','[]','[]','[{0,1006021363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101307,'副手','13阶神装副手【龙骑士】',2,'[{lv,520}]',3,'[{0,38280620,2}]','[1001011263,1007011263,1001021263,1007021263,1001031263,1007031263,1001041263,1007041263]','[]','[]','[{0,1007021363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101308,'护腕','13阶神装护腕【龙骑士】',2,'[{lv,520}]',3,'[{0,38280620,2}]','[1002011263,1004011263,1006011263,1008011263,1010011263,1002021263,1004021263,1006021263,1008021263,1010021263,1002031263,1004031263,1006031263,1008031263,1010031263,1002041263,1004041263,1006041263,1008041263,1010041263]','[]','[]','[{0,1008021363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101309,'戒指','13阶神装戒指【通用】',2,'[{lv,520}]',3,'[{0,38280620,2}]','[1005001263,1009001263,1005001263,1009001263,1005001263,1009001263,1005001263,1009001263]','[]','[]','[{0,1009001363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101310,'鞋子','13阶神装鞋子【龙骑士】',2,'[{lv,520}]',3,'[{0,38280620,2}]','[1002011263,1004011263,1006011263,1008011263,1010011263,1002021263,1004021263,1006021263,1008021263,1010021263,1002031263,1004031263,1006031263,1008031263,1010031263,1002041263,1004041263,1006041263,1008041263,1010041263]','[]','[]','[{0,1010021363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101401,'武器','14阶神装武器【龙骑士】',2,'[{lv,620}]',3,'[{0,38280620,2}]','[1001011363,1007011363,1001021363,1007021363,1001031363,1007031363,1001041363,1007041363]','[]','[]','[{0,1001021463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101402,'头盔','14阶神装头盔【龙骑士】',2,'[{lv,620}]',3,'[{0,38280620,2}]','[1002011363,1004011363,1006011363,1008011363,1010011363,1002021363,1004021363,1006021363,1008021363,1010021363,1002031363,1004031363,1006031363,1008031363,1010031363,1002041363,1004041363,1006041363,1008041363,1010041363]','[]','[]','[{0,1002021463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101403,'项链','14阶神装项链【通用】',2,'[{lv,620}]',3,'[{0,38280620,2}]','[1003001363,1003001363,1003001363,1003001363]','[]','[]','[{0,1003001463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101404,'衣服','14阶神装衣服【龙骑士】',2,'[{lv,620}]',3,'[{0,38280620,2}]','[1002011363,1004011363,1006011363,1008011363,1010011363,1002021363,1004021363,1006021363,1008021363,1010021363,1002031363,1004031363,1006031363,1008031363,1010031363,1002041363,1004041363,1006041363,1008041363,1010041363]','[]','[]','[{0,1004021463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101405,'刻痕','14阶神装刻痕【通用】',2,'[{lv,620}]',3,'[{0,38280620,2}]','[1005001363,1009001363,1005001363,1009001363,1005001363,1009001363,1005001363,1009001363]','[]','[]','[{0,1005001463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101406,'裤子','14阶神装裤子【龙骑士】',2,'[{lv,620}]',3,'[{0,38280620,2}]','[1002011363,1004011363,1006011363,1008011363,1010011363,1002021363,1004021363,1006021363,1008021363,1010021363,1002031363,1004031363,1006031363,1008031363,1010031363,1002041363,1004041363,1006041363,1008041363,1010041363]','[]','[]','[{0,1006021463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101407,'副手','14阶神装副手【龙骑士】',2,'[{lv,620}]',3,'[{0,38280620,2}]','[1001011363,1007011363,1001021363,1007021363,1001031363,1007031363,1001041363,1007041363]','[]','[]','[{0,1007021463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101408,'护腕','14阶神装护腕【龙骑士】',2,'[{lv,620}]',3,'[{0,38280620,2}]','[1002011363,1004011363,1006011363,1008011363,1010011363,1002021363,1004021363,1006021363,1008021363,1010021363,1002031363,1004031363,1006031363,1008031363,1010031363,1002041363,1004041363,1006041363,1008041363,1010041363]','[]','[]','[{0,1008021463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101409,'戒指','14阶神装戒指【通用】',2,'[{lv,620}]',3,'[{0,38280620,2}]','[1005001363,1009001363,1005001363,1009001363,1005001363,1009001363,1005001363,1009001363]','[]','[]','[{0,1009001463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101410,'鞋子','14阶神装鞋子【龙骑士】',2,'[{lv,620}]',3,'[{0,38280620,2}]','[1002011363,1004011363,1006011363,1008011363,1010011363,1002021363,1004021363,1006021363,1008021363,1010021363,1002031363,1004031363,1006031363,1008031363,1010031363,1002041363,1004041363,1006041363,1008041363,1010041363]','[]','[]','[{0,1010021463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101501,'武器','15阶神装武器【龙骑士】',2,'[{lv,650}]',3,'[{0,38280620,2}]','[1001011463,1007011463,1001021463,1007021463,1001031463,1007031463,1001041463,1007041463]','[]','[]','[{0,1001021563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101502,'头盔','15阶神装头盔【龙骑士】',2,'[{lv,650}]',3,'[{0,38280620,2}]','[1002011463,1004011463,1006011463,1008011463,1010011463,1002021463,1004021463,1006021463,1008021463,1010021463,1002031463,1004031463,1006031463,1008031463,1010031463,1002041463,1004041463,1006041463,1008041463,1010041463]','[]','[]','[{0,1002021563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101503,'项链','15阶神装项链【通用】',2,'[{lv,650}]',3,'[{0,38280620,2}]','[1003001463,1003001463,1003001463,1003001463]','[]','[]','[{0,1003001563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101504,'衣服','15阶神装衣服【龙骑士】',2,'[{lv,650}]',3,'[{0,38280620,2}]','[1002011463,1004011463,1006011463,1008011463,1010011463,1002021463,1004021463,1006021463,1008021463,1010021463,1002031463,1004031463,1006031463,1008031463,1010031463,1002041463,1004041463,1006041463,1008041463,1010041463]','[]','[]','[{0,1004021563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101505,'刻痕','15阶神装刻痕【通用】',2,'[{lv,650}]',3,'[{0,38280620,2}]','[1005001463,1009001463,1005001463,1009001463,1005001463,1009001463,1005001463,1009001463]','[]','[]','[{0,1005001563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101506,'裤子','15阶神装裤子【龙骑士】',2,'[{lv,650}]',3,'[{0,38280620,2}]','[1002011463,1004011463,1006011463,1008011463,1010011463,1002021463,1004021463,1006021463,1008021463,1010021463,1002031463,1004031463,1006031463,1008031463,1010031463,1002041463,1004041463,1006041463,1008041463,1010041463]','[]','[]','[{0,1006021563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101507,'副手','15阶神装副手【龙骑士】',2,'[{lv,650}]',3,'[{0,38280620,2}]','[1001011463,1007011463,1001021463,1007021463,1001031463,1007031463,1001041463,1007041463]','[]','[]','[{0,1007021563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101508,'护腕','15阶神装护腕【龙骑士】',2,'[{lv,650}]',3,'[{0,38280620,2}]','[1002011463,1004011463,1006011463,1008011463,1010011463,1002021463,1004021463,1006021463,1008021463,1010021463,1002031463,1004031463,1006031463,1008031463,1010031463,1002041463,1004041463,1006041463,1008041463,1010041463]','[]','[]','[{0,1008021563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101509,'戒指','15阶神装戒指【通用】',2,'[{lv,650}]',3,'[{0,38280620,2}]','[1005001463,1009001463,1005001463,1009001463,1005001463,1009001463,1005001463,1009001463]','[]','[]','[{0,1009001563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101510,'鞋子','15阶神装鞋子【龙骑士】',2,'[{lv,650}]',3,'[{0,38280620,2}]','[1002011463,1004011463,1006011463,1008011463,1010011463,1002021463,1004021463,1006021463,1008021463,1010021463,1002031463,1004031463,1006031463,1008031463,1010031463,1002041463,1004041463,1006041463,1008041463,1010041463]','[]','[]','[{0,1010021563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101601,'武器','16阶神装武器【龙骑士】',2,'[{lv,700}]',3,'[{0,38280620,2}]','[1001011563,1007011563,1001021563,1007021563,1001031563,1007031563,1001041563,1007041563]','[]','[]','[{0,1001021663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101602,'头盔','16阶神装头盔【龙骑士】',2,'[{lv,700}]',3,'[{0,38280620,2}]','[1002011563,1004011563,1006011563,1008011563,1010011563,1002021563,1004021563,1006021563,1008021563,1010021563,1002031563,1004031563,1006031563,1008031563,1010031563,1002041563,1004041563,1006041563,1008041563,1010041563]','[]','[]','[{0,1002021663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101603,'项链','16阶神装项链【通用】',2,'[{lv,700}]',3,'[{0,38280620,2}]','[1003001563,1003001563,1003001563,1003001563]','[]','[]','[{0,1003001663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101604,'衣服','16阶神装衣服【龙骑士】',2,'[{lv,700}]',3,'[{0,38280620,2}]','[1002011563,1004011563,1006011563,1008011563,1010011563,1002021563,1004021563,1006021563,1008021563,1010021563,1002031563,1004031563,1006031563,1008031563,1010031563,1002041563,1004041563,1006041563,1008041563,1010041563]','[]','[]','[{0,1004021663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101605,'刻痕','16阶神装刻痕【通用】',2,'[{lv,700}]',3,'[{0,38280620,2}]','[1005001563,1009001563,1005001563,1009001563,1005001563,1009001563,1005001563,1009001563]','[]','[]','[{0,1005001663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101606,'裤子','16阶神装裤子【龙骑士】',2,'[{lv,700}]',3,'[{0,38280620,2}]','[1002011563,1004011563,1006011563,1008011563,1010011563,1002021563,1004021563,1006021563,1008021563,1010021563,1002031563,1004031563,1006031563,1008031563,1010031563,1002041563,1004041563,1006041563,1008041563,1010041563]','[]','[]','[{0,1006021663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101607,'副手','16阶神装副手【龙骑士】',2,'[{lv,700}]',3,'[{0,38280620,2}]','[1001011563,1007011563,1001021563,1007021563,1001031563,1007031563,1001041563,1007041563]','[]','[]','[{0,1007021663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101608,'护腕','16阶神装护腕【龙骑士】',2,'[{lv,700}]',3,'[{0,38280620,2}]','[1002011563,1004011563,1006011563,1008011563,1010011563,1002021563,1004021563,1006021563,1008021563,1010021563,1002031563,1004031563,1006031563,1008031563,1010031563,1002041563,1004041563,1006041563,1008041563,1010041563]','[]','[]','[{0,1008021663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101609,'戒指','16阶神装戒指【通用】',2,'[{lv,700}]',3,'[{0,38280620,2}]','[1005001563,1009001563,1005001563,1009001563,1005001563,1009001563,1005001563,1009001563]','[]','[]','[{0,1009001663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(32101610,'鞋子','16阶神装鞋子【龙骑士】',2,'[{lv,700}]',3,'[{0,38280620,2}]','[1002011563,1004011563,1006011563,1008011563,1010011563,1002021563,1004021563,1006021563,1008021563,1010021563,1002031563,1004031563,1006031563,1008031563,1010031563,1002041563,1004041563,1006041563,1008041563,1010041563]','[]','[]','[{0,1010021663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33070301,'武器','3阶红2星武器【魔导师】',2,'[{lv,9999}]',2,'[]','[1001010332,1007010332,1001020332,1007020332,1001030332,1007030332,1001040332,1007040332]','[]','[]','[{0,1001030342,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(33070302,'头盔','3阶红2星头盔【魔导师】',2,'[{lv,9999}]',2,'[]','[1002010332,1004010332,1006010332,1008010332,1010010332,1002020332,1004020332,1006020332,1008020332,1010020332,1002030332,1004030332,1006030332,1008030332,1010030332,1002040332,1004040332,1006040332,1008040332,1010040332]','[]','[]','[{0,1002030342,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(33070303,'项链','3阶红2星项链【通用】',2,'[{lv,9999}]',2,'[]','[1003000332,1003000332,1003000332,1003000332]','[]','[]','[{0,1003000342,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(33070304,'衣服','3阶红2星衣服【魔导师】',2,'[{lv,9999}]',2,'[]','[1002010332,1004010332,1006010332,1008010332,1010010332,1002020332,1004020332,1006020332,1008020332,1010020332,1002030332,1004030332,1006030332,1008030332,1010030332,1002040332,1004040332,1006040332,1008040332,1010040332]','[]','[]','[{0,1004030342,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(33070305,'刻痕','3阶红2星刻痕【通用】',2,'[{lv,9999}]',2,'[]','[1005000332,1009000332,1005000332,1009000332,1005000332,1009000332,1005000332,1009000332]','[]','[]','[{0,1005000342,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(33070306,'裤子','3阶红2星裤子【魔导师】',2,'[{lv,9999}]',2,'[]','[1002010332,1004010332,1006010332,1008010332,1010010332,1002020332,1004020332,1006020332,1008020332,1010020332,1002030332,1004030332,1006030332,1008030332,1010030332,1002040332,1004040332,1006040332,1008040332,1010040332]','[]','[]','[{0,1006030342,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(33070307,'副手','3阶红2星副手【魔导师】',2,'[{lv,9999}]',2,'[]','[1001010332,1007010332,1001020332,1007020332,1001030332,1007030332,1001040332,1007040332]','[]','[]','[{0,1007030342,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(33070308,'护腕','3阶红2星护腕【魔导师】',2,'[{lv,9999}]',2,'[]','[1002010332,1004010332,1006010332,1008010332,1010010332,1002020332,1004020332,1006020332,1008020332,1010020332,1002030332,1004030332,1006030332,1008030332,1010030332,1002040332,1004040332,1006040332,1008040332,1010040332]','[]','[]','[{0,1008030342,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(33070309,'戒指','3阶红2星戒指【通用】',2,'[{lv,9999}]',2,'[]','[1005000332,1009000332,1005000332,1009000332,1005000332,1009000332,1005000332,1009000332]','[]','[]','[{0,1009000342,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(33070310,'鞋子','3阶红2星鞋子【魔导师】',2,'[{lv,9999}]',2,'[]','[1002010332,1004010332,1006010332,1008010332,1010010332,1002020332,1004020332,1006020332,1008020332,1010020332,1002030332,1004030332,1006030332,1008030332,1010030332,1002040332,1004040332,1006040332,1008040332,1010040332]','[]','[]','[{0,1010030342,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(33070401,'武器','4阶红2星武器【魔导师】',2,'[{lv,160}]',2,'[]','[1001010432,1007010432,1001020432,1007020432,1001030432,1007030432,1001040432,1007040432]','[]','[]','[{0,1001030442,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(33070402,'头盔','4阶红2星头盔【魔导师】',2,'[{lv,160}]',2,'[]','[1002010432,1004010432,1006010432,1008010432,1010010432,1002020432,1004020432,1006020432,1008020432,1010020432,1002030432,1004030432,1006030432,1008030432,1010030432,1002040432,1004040432,1006040432,1008040432,1010040432]','[]','[]','[{0,1002030442,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(33070403,'项链','4阶红2星项链【通用】',2,'[{lv,160}]',2,'[]','[1003000432,1003000432,1003000432,1003000432]','[]','[]','[{0,1003000442,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(33070404,'衣服','4阶红2星衣服【魔导师】',2,'[{lv,160}]',2,'[]','[1002010432,1004010432,1006010432,1008010432,1010010432,1002020432,1004020432,1006020432,1008020432,1010020432,1002030432,1004030432,1006030432,1008030432,1010030432,1002040432,1004040432,1006040432,1008040432,1010040432]','[]','[]','[{0,1004030442,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(33070405,'刻痕','4阶红2星刻痕【通用】',2,'[{lv,160}]',2,'[]','[1005000432,1009000432,1005000432,1009000432,1005000432,1009000432,1005000432,1009000432]','[]','[]','[{0,1005000442,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(33070406,'裤子','4阶红2星裤子【魔导师】',2,'[{lv,160}]',2,'[]','[1002010432,1004010432,1006010432,1008010432,1010010432,1002020432,1004020432,1006020432,1008020432,1010020432,1002030432,1004030432,1006030432,1008030432,1010030432,1002040432,1004040432,1006040432,1008040432,1010040432]','[]','[]','[{0,1006030442,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(33070407,'副手','4阶红2星副手【魔导师】',2,'[{lv,160}]',2,'[]','[1001010432,1007010432,1001020432,1007020432,1001030432,1007030432,1001040432,1007040432]','[]','[]','[{0,1007030442,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(33070408,'护腕','4阶红2星护腕【魔导师】',2,'[{lv,160}]',2,'[]','[1002010432,1004010432,1006010432,1008010432,1010010432,1002020432,1004020432,1006020432,1008020432,1010020432,1002030432,1004030432,1006030432,1008030432,1010030432,1002040432,1004040432,1006040432,1008040432,1010040432]','[]','[]','[{0,1008030442,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(33070409,'戒指','4阶红2星戒指【通用】',2,'[{lv,160}]',2,'[]','[1005000432,1009000432,1005000432,1009000432,1005000432,1009000432,1005000432,1009000432]','[]','[]','[{0,1009000442,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(33070410,'鞋子','4阶红2星鞋子【魔导师】',2,'[{lv,160}]',2,'[]','[1002010432,1004010432,1006010432,1008010432,1010010432,1002020432,1004020432,1006020432,1008020432,1010020432,1002030432,1004030432,1006030432,1008030432,1010030432,1002040432,1004040432,1006040432,1008040432,1010040432]','[]','[]','[{0,1010030442,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(33070501,'武器','5阶红2星武器【魔导师】',2,'[{lv,160}]',2,'[]','[1001010532,1007010532,1001020532,1007020532,1001030532,1007030532,1001040532,1007040532,1101010532,1107010532,1101020532,1107020532,1101030532,1107030532,1101040532,1107040532]','[]','[]','[{0,1001030542,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(33070502,'头盔','5阶红2星头盔【魔导师】',2,'[{lv,160}]',2,'[]','[1002010532,1004010532,1006010532,1008010532,1010010532,1002020532,1004020532,1006020532,1008020532,1010020532,1002030532,1004030532,1006030532,1008030532,1010030532,1002040532,1004040532,1006040532,1008040532,1010040532,1102010532,1104010532,1106010532,1108010532,1110010532,1102020532,1104020532,1106020532,1108020532,1110020532,1102030532,1104030532,1106030532,1108030532,1110030532,1102040532,1104040532,1106040532,1108040532,1110040532]','[]','[]','[{0,1002030542,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(33070503,'项链','5阶红2星项链【通用】',2,'[{lv,160}]',2,'[]','[1003000532,1003000532,1003000532,1003000532,1103000532,1103000532,1103000532,1103000532]','[]','[]','[{0,1003000542,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(33070504,'衣服','5阶红2星衣服【魔导师】',2,'[{lv,160}]',2,'[]','[1002010532,1004010532,1006010532,1008010532,1010010532,1002020532,1004020532,1006020532,1008020532,1010020532,1002030532,1004030532,1006030532,1008030532,1010030532,1002040532,1004040532,1006040532,1008040532,1010040532,1102010532,1104010532,1106010532,1108010532,1110010532,1102020532,1104020532,1106020532,1108020532,1110020532,1102030532,1104030532,1106030532,1108030532,1110030532,1102040532,1104040532,1106040532,1108040532,1110040532]','[]','[]','[{0,1004030542,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(33070505,'刻痕','5阶红2星刻痕【通用】',2,'[{lv,160}]',2,'[]','[1005000532,1009000532,1005000532,1009000532,1005000532,1009000532,1005000532,1009000532,1105000532,1109000532,1105000532,1109000532,1105000532,1109000532,1105000532,1109000532]','[]','[]','[{0,1005000542,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(33070506,'裤子','5阶红2星裤子【魔导师】',2,'[{lv,160}]',2,'[]','[1002010532,1004010532,1006010532,1008010532,1010010532,1002020532,1004020532,1006020532,1008020532,1010020532,1002030532,1004030532,1006030532,1008030532,1010030532,1002040532,1004040532,1006040532,1008040532,1010040532,1102010532,1104010532,1106010532,1108010532,1110010532,1102020532,1104020532,1106020532,1108020532,1110020532,1102030532,1104030532,1106030532,1108030532,1110030532,1102040532,1104040532,1106040532,1108040532,1110040532]','[]','[]','[{0,1006030542,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(33070507,'副手','5阶红2星副手【魔导师】',2,'[{lv,160}]',2,'[]','[1001010532,1007010532,1001020532,1007020532,1001030532,1007030532,1001040532,1007040532,1101010532,1107010532,1101020532,1107020532,1101030532,1107030532,1101040532,1107040532]','[]','[]','[{0,1007030542,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(33070508,'护腕','5阶红2星护腕【魔导师】',2,'[{lv,160}]',2,'[]','[1002010532,1004010532,1006010532,1008010532,1010010532,1002020532,1004020532,1006020532,1008020532,1010020532,1002030532,1004030532,1006030532,1008030532,1010030532,1002040532,1004040532,1006040532,1008040532,1010040532,1102010532,1104010532,1106010532,1108010532,1110010532,1102020532,1104020532,1106020532,1108020532,1110020532,1102030532,1104030532,1106030532,1108030532,1110030532,1102040532,1104040532,1106040532,1108040532,1110040532]','[]','[]','[{0,1008030542,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(33070509,'戒指','5阶红2星戒指【通用】',2,'[{lv,160}]',2,'[]','[1005000532,1009000532,1005000532,1009000532,1005000532,1009000532,1005000532,1009000532,1105000532,1109000532,1105000532,1109000532,1105000532,1109000532,1105000532,1109000532]','[]','[]','[{0,1009000542,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(33070510,'鞋子','5阶红2星鞋子【魔导师】',2,'[{lv,160}]',2,'[]','[1002010532,1004010532,1006010532,1008010532,1010010532,1002020532,1004020532,1006020532,1008020532,1010020532,1002030532,1004030532,1006030532,1008030532,1010030532,1002040532,1004040532,1006040532,1008040532,1010040532,1102010532,1104010532,1106010532,1108010532,1110010532,1102020532,1104020532,1106020532,1108020532,1110020532,1102030532,1104030532,1106030532,1108030532,1110030532,1102040532,1104040532,1106040532,1108040532,1110040532]','[]','[]','[{0,1010030542,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(33070601,'武器','6阶红2星武器【魔导师】',2,'[{lv,180}]',2,'[]','[1001010632,1007010632,1001020632,1007020632,1001030632,1007030632,1001040632,1007040632]','[]','[]','[{0,1001030642,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(33070602,'头盔','6阶红2星头盔【魔导师】',2,'[{lv,180}]',2,'[]','[1002010632,1004010632,1006010632,1008010632,1010010632,1002020632,1004020632,1006020632,1008020632,1010020632,1002030632,1004030632,1006030632,1008030632,1010030632,1002040632,1004040632,1006040632,1008040632,1010040632]','[]','[]','[{0,1002030642,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(33070603,'项链','6阶红2星项链【通用】',2,'[{lv,180}]',2,'[]','[1003000632,1003000632,1003000632,1003000632]','[]','[]','[{0,1003000642,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(33070604,'衣服','6阶红2星衣服【魔导师】',2,'[{lv,180}]',2,'[]','[1002010632,1004010632,1006010632,1008010632,1010010632,1002020632,1004020632,1006020632,1008020632,1010020632,1002030632,1004030632,1006030632,1008030632,1010030632,1002040632,1004040632,1006040632,1008040632,1010040632]','[]','[]','[{0,1004030642,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(33070605,'刻痕','6阶红2星刻痕【通用】',2,'[{lv,180}]',2,'[]','[1005000632,1009000632,1005000632,1009000632,1005000632,1009000632,1005000632,1009000632]','[]','[]','[{0,1005000642,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(33070606,'裤子','6阶红2星裤子【魔导师】',2,'[{lv,180}]',2,'[]','[1002010632,1004010632,1006010632,1008010632,1010010632,1002020632,1004020632,1006020632,1008020632,1010020632,1002030632,1004030632,1006030632,1008030632,1010030632,1002040632,1004040632,1006040632,1008040632,1010040632]','[]','[]','[{0,1006030642,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(33070607,'副手','6阶红2星副手【魔导师】',2,'[{lv,180}]',2,'[]','[1001010632,1007010632,1001020632,1007020632,1001030632,1007030632,1001040632,1007040632]','[]','[]','[{0,1007030642,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(33070608,'护腕','6阶红2星护腕【魔导师】',2,'[{lv,180}]',2,'[]','[1002010632,1004010632,1006010632,1008010632,1010010632,1002020632,1004020632,1006020632,1008020632,1010020632,1002030632,1004030632,1006030632,1008030632,1010030632,1002040632,1004040632,1006040632,1008040632,1010040632]','[]','[]','[{0,1008030642,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(33070609,'戒指','6阶红2星戒指【通用】',2,'[{lv,180}]',2,'[]','[1005000632,1009000632,1005000632,1009000632,1005000632,1009000632,1005000632,1009000632]','[]','[]','[{0,1009000642,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(33070610,'鞋子','6阶红2星鞋子【魔导师】',2,'[{lv,180}]',2,'[]','[1002010632,1004010632,1006010632,1008010632,1010010632,1002020632,1004020632,1006020632,1008020632,1010020632,1002030632,1004030632,1006030632,1008030632,1010030632,1002040632,1004040632,1006040632,1008040632,1010040632]','[]','[]','[{0,1010030642,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(33070701,'武器','7阶红2星武器【魔导师】',2,'[{lv,220}]',2,'[]','[1001010732,1007010732,1001020732,1007020732,1001030732,1007030732,1001040732,1007040732,1101010732,1107010732,1101020732,1107020732,1101030732,1107030732,1101040732,1107040732]','[]','[]','[{0,1001030742,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33070702,'头盔','7阶红2星头盔【魔导师】',2,'[{lv,220}]',2,'[]','[1002010732,1004010732,1006010732,1008010732,1010010732,1002020732,1004020732,1006020732,1008020732,1010020732,1002030732,1004030732,1006030732,1008030732,1010030732,1002040732,1004040732,1006040732,1008040732,1010040732,1102010732,1104010732,1106010732,1108010732,1110010732,1102020732,1104020732,1106020732,1108020732,1110020732,1102030732,1104030732,1106030732,1108030732,1110030732,1102040732,1104040732,1106040732,1108040732,1110040732]','[]','[]','[{0,1002030742,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33070703,'项链','7阶红2星项链【通用】',2,'[{lv,220}]',2,'[]','[1003000732,1003000732,1003000732,1003000732,1103000732,1103000732,1103000732,1103000732]','[]','[]','[{0,1003000742,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33070704,'衣服','7阶红2星衣服【魔导师】',2,'[{lv,220}]',2,'[]','[1002010732,1004010732,1006010732,1008010732,1010010732,1002020732,1004020732,1006020732,1008020732,1010020732,1002030732,1004030732,1006030732,1008030732,1010030732,1002040732,1004040732,1006040732,1008040732,1010040732,1102010732,1104010732,1106010732,1108010732,1110010732,1102020732,1104020732,1106020732,1108020732,1110020732,1102030732,1104030732,1106030732,1108030732,1110030732,1102040732,1104040732,1106040732,1108040732,1110040732]','[]','[]','[{0,1004030742,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33070705,'刻痕','7阶红2星刻痕【通用】',2,'[{lv,220}]',2,'[]','[1005000732,1009000732,1005000732,1009000732,1005000732,1009000732,1005000732,1009000732,1105000732,1109000732,1105000732,1109000732,1105000732,1109000732,1105000732,1109000732]','[]','[]','[{0,1005000742,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33070706,'裤子','7阶红2星裤子【魔导师】',2,'[{lv,220}]',2,'[]','[1002010732,1004010732,1006010732,1008010732,1010010732,1002020732,1004020732,1006020732,1008020732,1010020732,1002030732,1004030732,1006030732,1008030732,1010030732,1002040732,1004040732,1006040732,1008040732,1010040732,1102010732,1104010732,1106010732,1108010732,1110010732,1102020732,1104020732,1106020732,1108020732,1110020732,1102030732,1104030732,1106030732,1108030732,1110030732,1102040732,1104040732,1106040732,1108040732,1110040732]','[]','[]','[{0,1006030742,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33070707,'副手','7阶红2星副手【魔导师】',2,'[{lv,220}]',2,'[]','[1001010732,1007010732,1001020732,1007020732,1001030732,1007030732,1001040732,1007040732,1101010732,1107010732,1101020732,1107020732,1101030732,1107030732,1101040732,1107040732]','[]','[]','[{0,1007030742,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33070708,'护腕','7阶红2星护腕【魔导师】',2,'[{lv,220}]',2,'[]','[1002010732,1004010732,1006010732,1008010732,1010010732,1002020732,1004020732,1006020732,1008020732,1010020732,1002030732,1004030732,1006030732,1008030732,1010030732,1002040732,1004040732,1006040732,1008040732,1010040732,1102010732,1104010732,1106010732,1108010732,1110010732,1102020732,1104020732,1106020732,1108020732,1110020732,1102030732,1104030732,1106030732,1108030732,1110030732,1102040732,1104040732,1106040732,1108040732,1110040732]','[]','[]','[{0,1008030742,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33070709,'戒指','7阶红2星戒指【通用】',2,'[{lv,220}]',2,'[]','[1005000732,1009000732,1005000732,1009000732,1005000732,1009000732,1005000732,1009000732,1105000732,1109000732,1105000732,1109000732,1105000732,1109000732,1105000732,1109000732]','[]','[]','[{0,1009000742,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33070710,'鞋子','7阶红2星鞋子【魔导师】',2,'[{lv,220}]',2,'[]','[1002010732,1004010732,1006010732,1008010732,1010010732,1002020732,1004020732,1006020732,1008020732,1010020732,1002030732,1004030732,1006030732,1008030732,1010030732,1002040732,1004040732,1006040732,1008040732,1010040732,1102010732,1104010732,1106010732,1108010732,1110010732,1102020732,1104020732,1106020732,1108020732,1110020732,1102030732,1104030732,1106030732,1108030732,1110030732,1102040732,1104040732,1106040732,1108040732,1110040732]','[]','[]','[{0,1010030742,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33070801,'武器','8阶红2星武器【魔导师】',2,'[{lv,260}]',2,'[]','[1001010832,1007010832,1001020832,1007020832,1001030832,1007030832,1001040832,1007040832]','[]','[]','[{0,1001030842,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33070802,'头盔','8阶红2星头盔【魔导师】',2,'[{lv,260}]',2,'[]','[1002010832,1004010832,1006010832,1008010832,1010010832,1002020832,1004020832,1006020832,1008020832,1010020832,1002030832,1004030832,1006030832,1008030832,1010030832,1002040832,1004040832,1006040832,1008040832,1010040832]','[]','[]','[{0,1002030842,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33070803,'项链','8阶红2星项链【通用】',2,'[{lv,260}]',2,'[]','[1003000832,1003000832,1003000832,1003000832]','[]','[]','[{0,1003000842,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33070804,'衣服','8阶红2星衣服【魔导师】',2,'[{lv,260}]',2,'[]','[1002010832,1004010832,1006010832,1008010832,1010010832,1002020832,1004020832,1006020832,1008020832,1010020832,1002030832,1004030832,1006030832,1008030832,1010030832,1002040832,1004040832,1006040832,1008040832,1010040832]','[]','[]','[{0,1004030842,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33070805,'刻痕','8阶红2星刻痕【通用】',2,'[{lv,260}]',2,'[]','[1005000832,1009000832,1005000832,1009000832,1005000832,1009000832,1005000832,1009000832]','[]','[]','[{0,1005000842,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33070806,'裤子','8阶红2星裤子【魔导师】',2,'[{lv,260}]',2,'[]','[1002010832,1004010832,1006010832,1008010832,1010010832,1002020832,1004020832,1006020832,1008020832,1010020832,1002030832,1004030832,1006030832,1008030832,1010030832,1002040832,1004040832,1006040832,1008040832,1010040832]','[]','[]','[{0,1006030842,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33070807,'副手','8阶红2星副手【魔导师】',2,'[{lv,260}]',2,'[]','[1001010832,1007010832,1001020832,1007020832,1001030832,1007030832,1001040832,1007040832]','[]','[]','[{0,1007030842,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33070808,'护腕','8阶红2星护腕【魔导师】',2,'[{lv,260}]',2,'[]','[1002010832,1004010832,1006010832,1008010832,1010010832,1002020832,1004020832,1006020832,1008020832,1010020832,1002030832,1004030832,1006030832,1008030832,1010030832,1002040832,1004040832,1006040832,1008040832,1010040832]','[]','[]','[{0,1008030842,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33070809,'戒指','8阶红2星戒指【通用】',2,'[{lv,260}]',2,'[]','[1005000832,1009000832,1005000832,1009000832,1005000832,1009000832,1005000832,1009000832]','[]','[]','[{0,1009000842,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33070810,'鞋子','8阶红2星鞋子【魔导师】',2,'[{lv,260}]',2,'[]','[1002010832,1004010832,1006010832,1008010832,1010010832,1002020832,1004020832,1006020832,1008020832,1010020832,1002030832,1004030832,1006030832,1008030832,1010030832,1002040832,1004040832,1006040832,1008040832,1010040832]','[]','[]','[{0,1010030842,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33070901,'武器','9阶红2星武器【魔导师】',2,'[{lv,300}]',2,'[]','[1001010932,1007010932,1001020932,1007020932,1001030932,1007030932,1001040932,1007040932]','[]','[]','[{0,1001030942,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33070902,'头盔','9阶红2星头盔【魔导师】',2,'[{lv,300}]',2,'[]','[1002010932,1004010932,1006010932,1008010932,1010010932,1002020932,1004020932,1006020932,1008020932,1010020932,1002030932,1004030932,1006030932,1008030932,1010030932,1002040932,1004040932,1006040932,1008040932,1010040932]','[]','[]','[{0,1002030942,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33070903,'项链','9阶红2星项链【通用】',2,'[{lv,300}]',2,'[]','[1003000932,1003000932,1003000932,1003000932]','[]','[]','[{0,1003000942,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33070904,'衣服','9阶红2星衣服【魔导师】',2,'[{lv,300}]',2,'[]','[1002010932,1004010932,1006010932,1008010932,1010010932,1002020932,1004020932,1006020932,1008020932,1010020932,1002030932,1004030932,1006030932,1008030932,1010030932,1002040932,1004040932,1006040932,1008040932,1010040932]','[]','[]','[{0,1004030942,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33070905,'刻痕','9阶红2星刻痕【通用】',2,'[{lv,300}]',2,'[]','[1005000932,1009000932,1005000932,1009000932,1005000932,1009000932,1005000932,1009000932]','[]','[]','[{0,1005000942,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33070906,'裤子','9阶红2星裤子【魔导师】',2,'[{lv,300}]',2,'[]','[1002010932,1004010932,1006010932,1008010932,1010010932,1002020932,1004020932,1006020932,1008020932,1010020932,1002030932,1004030932,1006030932,1008030932,1010030932,1002040932,1004040932,1006040932,1008040932,1010040932]','[]','[]','[{0,1006030942,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33070907,'副手','9阶红2星副手【魔导师】',2,'[{lv,300}]',2,'[]','[1001010932,1007010932,1001020932,1007020932,1001030932,1007030932,1001040932,1007040932]','[]','[]','[{0,1007030942,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33070908,'护腕','9阶红2星护腕【魔导师】',2,'[{lv,300}]',2,'[]','[1002010932,1004010932,1006010932,1008010932,1010010932,1002020932,1004020932,1006020932,1008020932,1010020932,1002030932,1004030932,1006030932,1008030932,1010030932,1002040932,1004040932,1006040932,1008040932,1010040932]','[]','[]','[{0,1008030942,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33070909,'戒指','9阶红2星戒指【通用】',2,'[{lv,300}]',2,'[]','[1005000932,1009000932,1005000932,1009000932,1005000932,1009000932,1005000932,1009000932]','[]','[]','[{0,1009000942,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33070910,'鞋子','9阶红2星鞋子【魔导师】',2,'[{lv,300}]',2,'[]','[1002010932,1004010932,1006010932,1008010932,1010010932,1002020932,1004020932,1006020932,1008020932,1010020932,1002030932,1004030932,1006030932,1008030932,1010030932,1002040932,1004040932,1006040932,1008040932,1010040932]','[]','[]','[{0,1010030942,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071001,'武器','10阶红2星武器【魔导师】',2,'[{lv,355}]',2,'[]','[1001011032,1007011032,1001021032,1007021032,1001031032,1007031032,1001041032,1007041032]','[]','[]','[{0,1001031042,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071002,'头盔','10阶红2星头盔【魔导师】',2,'[{lv,355}]',2,'[]','[1002011032,1004011032,1006011032,1008011032,1010011032,1002021032,1004021032,1006021032,1008021032,1010021032,1002031032,1004031032,1006031032,1008031032,1010031032,1002041032,1004041032,1006041032,1008041032,1010041032]','[]','[]','[{0,1002031042,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071003,'项链','10阶红2星项链【通用】',2,'[{lv,355}]',2,'[]','[1003001032,1003001032,1003001032,1003001032]','[]','[]','[{0,1003001042,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071004,'衣服','10阶红2星衣服【魔导师】',2,'[{lv,355}]',2,'[]','[1002011032,1004011032,1006011032,1008011032,1010011032,1002021032,1004021032,1006021032,1008021032,1010021032,1002031032,1004031032,1006031032,1008031032,1010031032,1002041032,1004041032,1006041032,1008041032,1010041032]','[]','[]','[{0,1004031042,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071005,'刻痕','10阶红2星刻痕【通用】',2,'[{lv,355}]',2,'[]','[1005001032,1009001032,1005001032,1009001032,1005001032,1009001032,1005001032,1009001032]','[]','[]','[{0,1005001042,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071006,'裤子','10阶红2星裤子【魔导师】',2,'[{lv,355}]',2,'[]','[1002011032,1004011032,1006011032,1008011032,1010011032,1002021032,1004021032,1006021032,1008021032,1010021032,1002031032,1004031032,1006031032,1008031032,1010031032,1002041032,1004041032,1006041032,1008041032,1010041032]','[]','[]','[{0,1006031042,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071007,'副手','10阶红2星副手【魔导师】',2,'[{lv,355}]',2,'[]','[1001011032,1007011032,1001021032,1007021032,1001031032,1007031032,1001041032,1007041032]','[]','[]','[{0,1007031042,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071008,'护腕','10阶红2星护腕【魔导师】',2,'[{lv,355}]',2,'[]','[1002011032,1004011032,1006011032,1008011032,1010011032,1002021032,1004021032,1006021032,1008021032,1010021032,1002031032,1004031032,1006031032,1008031032,1010031032,1002041032,1004041032,1006041032,1008041032,1010041032]','[]','[]','[{0,1008031042,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071009,'戒指','10阶红2星戒指【通用】',2,'[{lv,355}]',2,'[]','[1005001032,1009001032,1005001032,1009001032,1005001032,1009001032,1005001032,1009001032]','[]','[]','[{0,1009001042,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071010,'鞋子','10阶红2星鞋子【魔导师】',2,'[{lv,355}]',2,'[]','[1002011032,1004011032,1006011032,1008011032,1010011032,1002021032,1004021032,1006021032,1008021032,1010021032,1002031032,1004031032,1006031032,1008031032,1010031032,1002041032,1004041032,1006041032,1008041032,1010041032]','[]','[]','[{0,1010031042,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071101,'武器','11阶红2星武器【魔导师】',2,'[{lv,400}]',2,'[]','[1001011132,1007011132,1001021132,1007021132,1001031132,1007031132,1001041132,1007041132]','[]','[]','[{0,1001031142,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071102,'头盔','11阶红2星头盔【魔导师】',2,'[{lv,400}]',2,'[]','[1002011132,1004011132,1006011132,1008011132,1010011132,1002021132,1004021132,1006021132,1008021132,1010021132,1002031132,1004031132,1006031132,1008031132,1010031132,1002041132,1004041132,1006041132,1008041132,1010041132]','[]','[]','[{0,1002031142,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071103,'项链','11阶红2星项链【通用】',2,'[{lv,400}]',2,'[]','[1003001132,1003001132,1003001132,1003001132]','[]','[]','[{0,1003001142,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071104,'衣服','11阶红2星衣服【魔导师】',2,'[{lv,400}]',2,'[]','[1002011132,1004011132,1006011132,1008011132,1010011132,1002021132,1004021132,1006021132,1008021132,1010021132,1002031132,1004031132,1006031132,1008031132,1010031132,1002041132,1004041132,1006041132,1008041132,1010041132]','[]','[]','[{0,1004031142,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071105,'刻痕','11阶红2星刻痕【通用】',2,'[{lv,400}]',2,'[]','[1005001132,1009001132,1005001132,1009001132,1005001132,1009001132,1005001132,1009001132]','[]','[]','[{0,1005001142,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071106,'裤子','11阶红2星裤子【魔导师】',2,'[{lv,400}]',2,'[]','[1002011132,1004011132,1006011132,1008011132,1010011132,1002021132,1004021132,1006021132,1008021132,1010021132,1002031132,1004031132,1006031132,1008031132,1010031132,1002041132,1004041132,1006041132,1008041132,1010041132]','[]','[]','[{0,1006031142,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071107,'副手','11阶红2星副手【魔导师】',2,'[{lv,400}]',2,'[]','[1001011132,1007011132,1001021132,1007021132,1001031132,1007031132,1001041132,1007041132]','[]','[]','[{0,1007031142,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071108,'护腕','11阶红2星护腕【魔导师】',2,'[{lv,400}]',2,'[]','[1002011132,1004011132,1006011132,1008011132,1010011132,1002021132,1004021132,1006021132,1008021132,1010021132,1002031132,1004031132,1006031132,1008031132,1010031132,1002041132,1004041132,1006041132,1008041132,1010041132]','[]','[]','[{0,1008031142,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071109,'戒指','11阶红2星戒指【通用】',2,'[{lv,400}]',2,'[]','[1005001132,1009001132,1005001132,1009001132,1005001132,1009001132,1005001132,1009001132]','[]','[]','[{0,1009001142,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071110,'鞋子','11阶红2星鞋子【魔导师】',2,'[{lv,400}]',2,'[]','[1002011132,1004011132,1006011132,1008011132,1010011132,1002021132,1004021132,1006021132,1008021132,1010021132,1002031132,1004031132,1006031132,1008031132,1010031132,1002041132,1004041132,1006041132,1008041132,1010041132]','[]','[]','[{0,1010031142,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071201,'武器','12阶红2星武器【魔导师】',2,'[{lv,500}]',2,'[]','[1001011232,1007011232,1001021232,1007021232,1001031232,1007031232,1001041232,1007041232]','[]','[]','[{0,1001031242,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071202,'头盔','12阶红2星头盔【魔导师】',2,'[{lv,500}]',2,'[]','[1002011232,1004011232,1006011232,1008011232,1010011232,1002021232,1004021232,1006021232,1008021232,1010021232,1002031232,1004031232,1006031232,1008031232,1010031232,1002041232,1004041232,1006041232,1008041232,1010041232]','[]','[]','[{0,1002031242,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071203,'项链','12阶红2星项链【通用】',2,'[{lv,500}]',2,'[]','[1003001232,1003001232,1003001232,1003001232]','[]','[]','[{0,1003001242,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071204,'衣服','12阶红2星衣服【魔导师】',2,'[{lv,500}]',2,'[]','[1002011232,1004011232,1006011232,1008011232,1010011232,1002021232,1004021232,1006021232,1008021232,1010021232,1002031232,1004031232,1006031232,1008031232,1010031232,1002041232,1004041232,1006041232,1008041232,1010041232]','[]','[]','[{0,1004031242,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071205,'刻痕','12阶红2星刻痕【通用】',2,'[{lv,500}]',2,'[]','[1005001232,1009001232,1005001232,1009001232,1005001232,1009001232,1005001232,1009001232]','[]','[]','[{0,1005001242,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071206,'裤子','12阶红2星裤子【魔导师】',2,'[{lv,500}]',2,'[]','[1002011232,1004011232,1006011232,1008011232,1010011232,1002021232,1004021232,1006021232,1008021232,1010021232,1002031232,1004031232,1006031232,1008031232,1010031232,1002041232,1004041232,1006041232,1008041232,1010041232]','[]','[]','[{0,1006031242,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071207,'副手','12阶红2星副手【魔导师】',2,'[{lv,500}]',2,'[]','[1001011232,1007011232,1001021232,1007021232,1001031232,1007031232,1001041232,1007041232]','[]','[]','[{0,1007031242,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071208,'护腕','12阶红2星护腕【魔导师】',2,'[{lv,500}]',2,'[]','[1002011232,1004011232,1006011232,1008011232,1010011232,1002021232,1004021232,1006021232,1008021232,1010021232,1002031232,1004031232,1006031232,1008031232,1010031232,1002041232,1004041232,1006041232,1008041232,1010041232]','[]','[]','[{0,1008031242,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071209,'戒指','12阶红2星戒指【通用】',2,'[{lv,500}]',2,'[]','[1005001232,1009001232,1005001232,1009001232,1005001232,1009001232,1005001232,1009001232]','[]','[]','[{0,1009001242,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071210,'鞋子','12阶红2星鞋子【魔导师】',2,'[{lv,500}]',2,'[]','[1002011232,1004011232,1006011232,1008011232,1010011232,1002021232,1004021232,1006021232,1008021232,1010021232,1002031232,1004031232,1006031232,1008031232,1010031232,1002041232,1004041232,1006041232,1008041232,1010041232]','[]','[]','[{0,1010031242,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071301,'武器','13阶红2星武器【魔导师】',2,'[{lv,520}]',2,'[]','[1001011332,1007011332,1001021332,1007021332,1001031332,1007031332,1001041332,1007041332]','[]','[]','[{0,1001031342,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071302,'头盔','13阶红2星头盔【魔导师】',2,'[{lv,520}]',2,'[]','[1002011332,1004011332,1006011332,1008011332,1010011332,1002021332,1004021332,1006021332,1008021332,1010021332,1002031332,1004031332,1006031332,1008031332,1010031332,1002041332,1004041332,1006041332,1008041332,1010041332]','[]','[]','[{0,1002031342,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071303,'项链','13阶红2星项链【通用】',2,'[{lv,520}]',2,'[]','[1003001332,1003001332,1003001332,1003001332]','[]','[]','[{0,1003001342,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071304,'衣服','13阶红2星衣服【魔导师】',2,'[{lv,520}]',2,'[]','[1002011332,1004011332,1006011332,1008011332,1010011332,1002021332,1004021332,1006021332,1008021332,1010021332,1002031332,1004031332,1006031332,1008031332,1010031332,1002041332,1004041332,1006041332,1008041332,1010041332]','[]','[]','[{0,1004031342,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071305,'刻痕','13阶红2星刻痕【通用】',2,'[{lv,520}]',2,'[]','[1005001332,1009001332,1005001332,1009001332,1005001332,1009001332,1005001332,1009001332]','[]','[]','[{0,1005001342,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071306,'裤子','13阶红2星裤子【魔导师】',2,'[{lv,520}]',2,'[]','[1002011332,1004011332,1006011332,1008011332,1010011332,1002021332,1004021332,1006021332,1008021332,1010021332,1002031332,1004031332,1006031332,1008031332,1010031332,1002041332,1004041332,1006041332,1008041332,1010041332]','[]','[]','[{0,1006031342,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071307,'副手','13阶红2星副手【魔导师】',2,'[{lv,520}]',2,'[]','[1001011332,1007011332,1001021332,1007021332,1001031332,1007031332,1001041332,1007041332]','[]','[]','[{0,1007031342,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071308,'护腕','13阶红2星护腕【魔导师】',2,'[{lv,520}]',2,'[]','[1002011332,1004011332,1006011332,1008011332,1010011332,1002021332,1004021332,1006021332,1008021332,1010021332,1002031332,1004031332,1006031332,1008031332,1010031332,1002041332,1004041332,1006041332,1008041332,1010041332]','[]','[]','[{0,1008031342,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071309,'戒指','13阶红2星戒指【通用】',2,'[{lv,520}]',2,'[]','[1005001332,1009001332,1005001332,1009001332,1005001332,1009001332,1005001332,1009001332]','[]','[]','[{0,1009001342,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071310,'鞋子','13阶红2星鞋子【魔导师】',2,'[{lv,520}]',2,'[]','[1002011332,1004011332,1006011332,1008011332,1010011332,1002021332,1004021332,1006021332,1008021332,1010021332,1002031332,1004031332,1006031332,1008031332,1010031332,1002041332,1004041332,1006041332,1008041332,1010041332]','[]','[]','[{0,1010031342,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071401,'武器','14阶红2星武器【魔导师】',2,'[{lv,620}]',2,'[]','[1001011432,1007011432,1001021432,1007021432,1001031432,1007031432,1001041432,1007041432]','[]','[]','[{0,1001031442,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071402,'头盔','14阶红2星头盔【魔导师】',2,'[{lv,620}]',2,'[]','[1002011432,1004011432,1006011432,1008011432,1010011432,1002021432,1004021432,1006021432,1008021432,1010021432,1002031432,1004031432,1006031432,1008031432,1010031432,1002041432,1004041432,1006041432,1008041432,1010041432]','[]','[]','[{0,1002031442,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071403,'项链','14阶红2星项链【通用】',2,'[{lv,620}]',2,'[]','[1003001432,1003001432,1003001432,1003001432]','[]','[]','[{0,1003001442,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071404,'衣服','14阶红2星衣服【魔导师】',2,'[{lv,620}]',2,'[]','[1002011432,1004011432,1006011432,1008011432,1010011432,1002021432,1004021432,1006021432,1008021432,1010021432,1002031432,1004031432,1006031432,1008031432,1010031432,1002041432,1004041432,1006041432,1008041432,1010041432]','[]','[]','[{0,1004031442,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071405,'刻痕','14阶红2星刻痕【通用】',2,'[{lv,620}]',2,'[]','[1005001432,1009001432,1005001432,1009001432,1005001432,1009001432,1005001432,1009001432]','[]','[]','[{0,1005001442,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071406,'裤子','14阶红2星裤子【魔导师】',2,'[{lv,620}]',2,'[]','[1002011432,1004011432,1006011432,1008011432,1010011432,1002021432,1004021432,1006021432,1008021432,1010021432,1002031432,1004031432,1006031432,1008031432,1010031432,1002041432,1004041432,1006041432,1008041432,1010041432]','[]','[]','[{0,1006031442,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071407,'副手','14阶红2星副手【魔导师】',2,'[{lv,620}]',2,'[]','[1001011432,1007011432,1001021432,1007021432,1001031432,1007031432,1001041432,1007041432]','[]','[]','[{0,1007031442,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071408,'护腕','14阶红2星护腕【魔导师】',2,'[{lv,620}]',2,'[]','[1002011432,1004011432,1006011432,1008011432,1010011432,1002021432,1004021432,1006021432,1008021432,1010021432,1002031432,1004031432,1006031432,1008031432,1010031432,1002041432,1004041432,1006041432,1008041432,1010041432]','[]','[]','[{0,1008031442,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071409,'戒指','14阶红2星戒指【通用】',2,'[{lv,620}]',2,'[]','[1005001432,1009001432,1005001432,1009001432,1005001432,1009001432,1005001432,1009001432]','[]','[]','[{0,1009001442,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071410,'鞋子','14阶红2星鞋子【魔导师】',2,'[{lv,620}]',2,'[]','[1002011432,1004011432,1006011432,1008011432,1010011432,1002021432,1004021432,1006021432,1008021432,1010021432,1002031432,1004031432,1006031432,1008031432,1010031432,1002041432,1004041432,1006041432,1008041432,1010041432]','[]','[]','[{0,1010031442,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071501,'武器','15阶红2星武器【魔导师】',2,'[{lv,650}]',2,'[]','[1001011532,1007011532,1001021532,1007021532,1001031532,1007031532,1001041532,1007041532]','[]','[]','[{0,1001031542,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071502,'头盔','15阶红2星头盔【魔导师】',2,'[{lv,650}]',2,'[]','[1002011532,1004011532,1006011532,1008011532,1010011532,1002021532,1004021532,1006021532,1008021532,1010021532,1002031532,1004031532,1006031532,1008031532,1010031532,1002041532,1004041532,1006041532,1008041532,1010041532]','[]','[]','[{0,1002031542,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071503,'项链','15阶红2星项链【通用】',2,'[{lv,650}]',2,'[]','[1003001532,1003001532,1003001532,1003001532]','[]','[]','[{0,1003001542,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071504,'衣服','15阶红2星衣服【魔导师】',2,'[{lv,650}]',2,'[]','[1002011532,1004011532,1006011532,1008011532,1010011532,1002021532,1004021532,1006021532,1008021532,1010021532,1002031532,1004031532,1006031532,1008031532,1010031532,1002041532,1004041532,1006041532,1008041532,1010041532]','[]','[]','[{0,1004031542,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071505,'刻痕','15阶红2星刻痕【通用】',2,'[{lv,650}]',2,'[]','[1005001532,1009001532,1005001532,1009001532,1005001532,1009001532,1005001532,1009001532]','[]','[]','[{0,1005001542,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071506,'裤子','15阶红2星裤子【魔导师】',2,'[{lv,650}]',2,'[]','[1002011532,1004011532,1006011532,1008011532,1010011532,1002021532,1004021532,1006021532,1008021532,1010021532,1002031532,1004031532,1006031532,1008031532,1010031532,1002041532,1004041532,1006041532,1008041532,1010041532]','[]','[]','[{0,1006031542,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071507,'副手','15阶红2星副手【魔导师】',2,'[{lv,650}]',2,'[]','[1001011532,1007011532,1001021532,1007021532,1001031532,1007031532,1001041532,1007041532]','[]','[]','[{0,1007031542,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071508,'护腕','15阶红2星护腕【魔导师】',2,'[{lv,650}]',2,'[]','[1002011532,1004011532,1006011532,1008011532,1010011532,1002021532,1004021532,1006021532,1008021532,1010021532,1002031532,1004031532,1006031532,1008031532,1010031532,1002041532,1004041532,1006041532,1008041532,1010041532]','[]','[]','[{0,1008031542,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071509,'戒指','15阶红2星戒指【通用】',2,'[{lv,650}]',2,'[]','[1005001532,1009001532,1005001532,1009001532,1005001532,1009001532,1005001532,1009001532]','[]','[]','[{0,1009001542,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071510,'鞋子','15阶红2星鞋子【魔导师】',2,'[{lv,650}]',2,'[]','[1002011532,1004011532,1006011532,1008011532,1010011532,1002021532,1004021532,1006021532,1008021532,1010021532,1002031532,1004031532,1006031532,1008031532,1010031532,1002041532,1004041532,1006041532,1008041532,1010041532]','[]','[]','[{0,1010031542,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071601,'武器','16阶红2星武器【魔导师】',2,'[{lv,700}]',2,'[]','[1001011632,1007011632,1001021632,1007021632,1001031632,1007031632,1001041632,1007041632]','[]','[]','[{0,1001031642,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071602,'头盔','16阶红2星头盔【魔导师】',2,'[{lv,700}]',2,'[]','[1002011632,1004011632,1006011632,1008011632,1010011632,1002021632,1004021632,1006021632,1008021632,1010021632,1002031632,1004031632,1006031632,1008031632,1010031632,1002041632,1004041632,1006041632,1008041632,1010041632]','[]','[]','[{0,1002031642,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071603,'项链','16阶红2星项链【通用】',2,'[{lv,700}]',2,'[]','[1003001632,1003001632,1003001632,1003001632]','[]','[]','[{0,1003001642,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071604,'衣服','16阶红2星衣服【魔导师】',2,'[{lv,700}]',2,'[]','[1002011632,1004011632,1006011632,1008011632,1010011632,1002021632,1004021632,1006021632,1008021632,1010021632,1002031632,1004031632,1006031632,1008031632,1010031632,1002041632,1004041632,1006041632,1008041632,1010041632]','[]','[]','[{0,1004031642,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071605,'刻痕','16阶红2星刻痕【通用】',2,'[{lv,700}]',2,'[]','[1005001632,1009001632,1005001632,1009001632,1005001632,1009001632,1005001632,1009001632]','[]','[]','[{0,1005001642,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071606,'裤子','16阶红2星裤子【魔导师】',2,'[{lv,700}]',2,'[]','[1002011632,1004011632,1006011632,1008011632,1010011632,1002021632,1004021632,1006021632,1008021632,1010021632,1002031632,1004031632,1006031632,1008031632,1010031632,1002041632,1004041632,1006041632,1008041632,1010041632]','[]','[]','[{0,1006031642,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071607,'副手','16阶红2星副手【魔导师】',2,'[{lv,700}]',2,'[]','[1001011632,1007011632,1001021632,1007021632,1001031632,1007031632,1001041632,1007041632]','[]','[]','[{0,1007031642,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071608,'护腕','16阶红2星护腕【魔导师】',2,'[{lv,700}]',2,'[]','[1002011632,1004011632,1006011632,1008011632,1010011632,1002021632,1004021632,1006021632,1008021632,1010021632,1002031632,1004031632,1006031632,1008031632,1010031632,1002041632,1004041632,1006041632,1008041632,1010041632]','[]','[]','[{0,1008031642,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071609,'戒指','16阶红2星戒指【通用】',2,'[{lv,700}]',2,'[]','[1005001632,1009001632,1005001632,1009001632,1005001632,1009001632,1005001632,1009001632]','[]','[]','[{0,1009001642,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33071610,'鞋子','16阶红2星鞋子【魔导师】',2,'[{lv,700}]',2,'[]','[1002011632,1004011632,1006011632,1008011632,1010011632,1002021632,1004021632,1006021632,1008021632,1010021632,1002031632,1004031632,1006031632,1008031632,1010031632,1002041632,1004041632,1006041632,1008041632,1010041632]','[]','[]','[{0,1010031642,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33080301,'武器','3阶红3星武器【魔导师】',2,'[{lv,9999}]',2,'[]','[1001010342,1007010342,1001020342,1007020342,1001030342,1007030342,1001040342,1007040342]','[]','[]','[{0,1001030343,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(33080302,'头盔','3阶红3星头盔【魔导师】',2,'[{lv,9999}]',2,'[]','[1002010342,1004010342,1006010342,1008010342,1010010342,1002020342,1004020342,1006020342,1008020342,1010020342,1002030342,1004030342,1006030342,1008030342,1010030342,1002040342,1004040342,1006040342,1008040342,1010040342]','[]','[]','[{0,1002030343,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(33080303,'项链','3阶红3星项链【通用】',2,'[{lv,9999}]',2,'[]','[1003000342,1003000342,1003000342,1003000342]','[]','[]','[{0,1003000343,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(33080304,'衣服','3阶红3星衣服【魔导师】',2,'[{lv,9999}]',2,'[]','[1002010342,1004010342,1006010342,1008010342,1010010342,1002020342,1004020342,1006020342,1008020342,1010020342,1002030342,1004030342,1006030342,1008030342,1010030342,1002040342,1004040342,1006040342,1008040342,1010040342]','[]','[]','[{0,1004030343,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(33080305,'刻痕','3阶红3星刻痕【通用】',2,'[{lv,9999}]',2,'[]','[1005000342,1009000342,1005000342,1009000342,1005000342,1009000342,1005000342,1009000342]','[]','[]','[{0,1005000343,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(33080306,'裤子','3阶红3星裤子【魔导师】',2,'[{lv,9999}]',2,'[]','[1002010342,1004010342,1006010342,1008010342,1010010342,1002020342,1004020342,1006020342,1008020342,1010020342,1002030342,1004030342,1006030342,1008030342,1010030342,1002040342,1004040342,1006040342,1008040342,1010040342]','[]','[]','[{0,1006030343,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(33080307,'副手','3阶红3星副手【魔导师】',2,'[{lv,9999}]',2,'[]','[1001010342,1007010342,1001020342,1007020342,1001030342,1007030342,1001040342,1007040342]','[]','[]','[{0,1007030343,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(33080308,'护腕','3阶红3星护腕【魔导师】',2,'[{lv,9999}]',2,'[]','[1002010342,1004010342,1006010342,1008010342,1010010342,1002020342,1004020342,1006020342,1008020342,1010020342,1002030342,1004030342,1006030342,1008030342,1010030342,1002040342,1004040342,1006040342,1008040342,1010040342]','[]','[]','[{0,1008030343,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(33080309,'戒指','3阶红3星戒指【通用】',2,'[{lv,9999}]',2,'[]','[1005000342,1009000342,1005000342,1009000342,1005000342,1009000342,1005000342,1009000342]','[]','[]','[{0,1009000343,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(33080310,'鞋子','3阶红3星鞋子【魔导师】',2,'[{lv,9999}]',2,'[]','[1002010342,1004010342,1006010342,1008010342,1010010342,1002020342,1004020342,1006020342,1008020342,1010020342,1002030342,1004030342,1006030342,1008030342,1010030342,1002040342,1004040342,1006040342,1008040342,1010040342]','[]','[]','[{0,1010030343,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(33080401,'武器','4阶红3星武器【魔导师】',2,'[{lv,160}]',2,'[]','[1001010442,1007010442,1001020442,1007020442,1001030442,1007030442,1001040442,1007040442,1101010442,1107010442,1101020442,1107020442,1101030442,1107030442,1101040442,1107040442]','[]','[]','[{0,1001030443,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(33080402,'头盔','4阶红3星头盔【魔导师】',2,'[{lv,160}]',2,'[]','[1002010442,1004010442,1006010442,1008010442,1010010442,1002020442,1004020442,1006020442,1008020442,1010020442,1002030442,1004030442,1006030442,1008030442,1010030442,1002040442,1004040442,1006040442,1008040442,1010040442,1102010442,1104010442,1106010442,1108010442,1110010442,1102020442,1104020442,1106020442,1108020442,1110020442,1102030442,1104030442,1106030442,1108030442,1110030442,1102040442,1104040442,1106040442,1108040442,1110040442]','[]','[]','[{0,1002030443,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(33080403,'项链','4阶红3星项链【通用】',2,'[{lv,160}]',2,'[]','[1003000442,1003000442,1003000442,1003000442,1103000442,1103000442,1103000442,1103000442]','[]','[]','[{0,1003000443,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(33080404,'衣服','4阶红3星衣服【魔导师】',2,'[{lv,160}]',2,'[]','[1002010442,1004010442,1006010442,1008010442,1010010442,1002020442,1004020442,1006020442,1008020442,1010020442,1002030442,1004030442,1006030442,1008030442,1010030442,1002040442,1004040442,1006040442,1008040442,1010040442,1102010442,1104010442,1106010442,1108010442,1110010442,1102020442,1104020442,1106020442,1108020442,1110020442,1102030442,1104030442,1106030442,1108030442,1110030442,1102040442,1104040442,1106040442,1108040442,1110040442]','[]','[]','[{0,1004030443,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(33080405,'刻痕','4阶红3星刻痕【通用】',2,'[{lv,160}]',2,'[]','[1005000442,1009000442,1005000442,1009000442,1005000442,1009000442,1005000442,1009000442,1105000442,1109000442,1105000442,1109000442,1105000442,1109000442,1105000442,1109000442]','[]','[]','[{0,1005000443,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(33080406,'裤子','4阶红3星裤子【魔导师】',2,'[{lv,160}]',2,'[]','[1002010442,1004010442,1006010442,1008010442,1010010442,1002020442,1004020442,1006020442,1008020442,1010020442,1002030442,1004030442,1006030442,1008030442,1010030442,1002040442,1004040442,1006040442,1008040442,1010040442,1102010442,1104010442,1106010442,1108010442,1110010442,1102020442,1104020442,1106020442,1108020442,1110020442,1102030442,1104030442,1106030442,1108030442,1110030442,1102040442,1104040442,1106040442,1108040442,1110040442]','[]','[]','[{0,1006030443,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(33080407,'副手','4阶红3星副手【魔导师】',2,'[{lv,160}]',2,'[]','[1001010442,1007010442,1001020442,1007020442,1001030442,1007030442,1001040442,1007040442,1101010442,1107010442,1101020442,1107020442,1101030442,1107030442,1101040442,1107040442]','[]','[]','[{0,1007030443,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(33080408,'护腕','4阶红3星护腕【魔导师】',2,'[{lv,160}]',2,'[]','[1002010442,1004010442,1006010442,1008010442,1010010442,1002020442,1004020442,1006020442,1008020442,1010020442,1002030442,1004030442,1006030442,1008030442,1010030442,1002040442,1004040442,1006040442,1008040442,1010040442,1102010442,1104010442,1106010442,1108010442,1110010442,1102020442,1104020442,1106020442,1108020442,1110020442,1102030442,1104030442,1106030442,1108030442,1110030442,1102040442,1104040442,1106040442,1108040442,1110040442]','[]','[]','[{0,1008030443,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(33080409,'戒指','4阶红3星戒指【通用】',2,'[{lv,160}]',2,'[]','[1005000442,1009000442,1005000442,1009000442,1005000442,1009000442,1005000442,1009000442,1105000442,1109000442,1105000442,1109000442,1105000442,1109000442,1105000442,1109000442]','[]','[]','[{0,1009000443,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(33080410,'鞋子','4阶红3星鞋子【魔导师】',2,'[{lv,160}]',2,'[]','[1002010442,1004010442,1006010442,1008010442,1010010442,1002020442,1004020442,1006020442,1008020442,1010020442,1002030442,1004030442,1006030442,1008030442,1010030442,1002040442,1004040442,1006040442,1008040442,1010040442,1102010442,1104010442,1106010442,1108010442,1110010442,1102020442,1104020442,1106020442,1108020442,1110020442,1102030442,1104030442,1106030442,1108030442,1110030442,1102040442,1104040442,1106040442,1108040442,1110040442]','[]','[]','[{0,1010030443,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(33080501,'武器','5阶红3星武器【魔导师】',2,'[{lv,160}]',2,'[]','[1001010542,1007010542,1001020542,1007020542,1001030542,1007030542,1001040542,1007040542,1101010542,1101020542,1101030542,1101040542]','[]','[]','[{0,1001030543,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(33080502,'头盔','5阶红3星头盔【魔导师】',2,'[{lv,160}]',2,'[]','[1002010542,1004010542,1006010542,1008010542,1010010542,1002020542,1004020542,1006020542,1008020542,1010020542,1002030542,1004030542,1006030542,1008030542,1010030542,1002040542,1004040542,1006040542,1008040542,1010040542,1102010542,1104010542,1106010542,1102020542,1104020542,1106020542,1102030542,1104030542,1106030542,1102040542,1104040542,1106040542]','[]','[]','[{0,1002030543,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(33080503,'项链','5阶红3星项链【通用】',2,'[{lv,160}]',2,'[]','[1003000542,1003000542,1003000542,1003000542,1103000542,1103000542,1103000542,1103000542]','[]','[]','[{0,1003000543,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(33080504,'衣服','5阶红3星衣服【魔导师】',2,'[{lv,160}]',2,'[]','[1002010542,1004010542,1006010542,1008010542,1010010542,1002020542,1004020542,1006020542,1008020542,1010020542,1002030542,1004030542,1006030542,1008030542,1010030542,1002040542,1004040542,1006040542,1008040542,1010040542,1102010542,1104010542,1106010542,1102020542,1104020542,1106020542,1102030542,1104030542,1106030542,1102040542,1104040542,1106040542]','[]','[]','[{0,1004030543,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(33080505,'刻痕','5阶红3星刻痕【通用】',2,'[{lv,160}]',2,'[]','[1005000542,1009000542,1005000542,1009000542,1005000542,1009000542,1005000542,1009000542,1105000542,1105000542,1105000542,1105000542]','[]','[]','[{0,1005000543,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(33080506,'裤子','5阶红3星裤子【魔导师】',2,'[{lv,160}]',2,'[]','[1002010542,1004010542,1006010542,1008010542,1010010542,1002020542,1004020542,1006020542,1008020542,1010020542,1002030542,1004030542,1006030542,1008030542,1010030542,1002040542,1004040542,1006040542,1008040542,1010040542,1102010542,1104010542,1106010542,1102020542,1104020542,1106020542,1102030542,1104030542,1106030542,1102040542,1104040542,1106040542]','[]','[]','[{0,1006030543,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(33080507,'副手','5阶红3星副手【魔导师】',2,'[{lv,160}]',2,'[]','[1001010542,1007010542,1001020542,1007020542,1001030542,1007030542,1001040542,1007040542,1101010542,1101020542,1101030542,1101040542]','[]','[]','[{0,1007030543,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(33080508,'护腕','5阶红3星护腕【魔导师】',2,'[{lv,160}]',2,'[]','[1002010542,1004010542,1006010542,1008010542,1010010542,1002020542,1004020542,1006020542,1008020542,1010020542,1002030542,1004030542,1006030542,1008030542,1010030542,1002040542,1004040542,1006040542,1008040542,1010040542,1102010542,1104010542,1106010542,1102020542,1104020542,1106020542,1102030542,1104030542,1106030542,1102040542,1104040542,1106040542]','[]','[]','[{0,1008030543,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(33080509,'戒指','5阶红3星戒指【通用】',2,'[{lv,160}]',2,'[]','[1005000542,1009000542,1005000542,1009000542,1005000542,1009000542,1005000542,1009000542,1105000542,1105000542,1105000542,1105000542]','[]','[]','[{0,1009000543,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(33080510,'鞋子','5阶红3星鞋子【魔导师】',2,'[{lv,160}]',2,'[]','[1002010542,1004010542,1006010542,1008010542,1010010542,1002020542,1004020542,1006020542,1008020542,1010020542,1002030542,1004030542,1006030542,1008030542,1010030542,1002040542,1004040542,1006040542,1008040542,1010040542,1102010542,1104010542,1106010542,1102020542,1104020542,1106020542,1102030542,1104030542,1106030542,1102040542,1104040542,1106040542]','[]','[]','[{0,1010030543,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(33080601,'武器','6阶红3星武器【魔导师】',2,'[{lv,180}]',2,'[]','[1001010642,1007010642,1001020642,1007020642,1001030642,1007030642,1001040642,1007040642]','[]','[]','[{0,1001030643,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(33080602,'头盔','6阶红3星头盔【魔导师】',2,'[{lv,180}]',2,'[]','[1002010642,1004010642,1006010642,1008010642,1010010642,1002020642,1004020642,1006020642,1008020642,1010020642,1002030642,1004030642,1006030642,1008030642,1010030642,1002040642,1004040642,1006040642,1008040642,1010040642]','[]','[]','[{0,1002030643,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(33080603,'项链','6阶红3星项链【通用】',2,'[{lv,180}]',2,'[]','[1003000642,1003000642,1003000642,1003000642]','[]','[]','[{0,1003000643,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(33080604,'衣服','6阶红3星衣服【魔导师】',2,'[{lv,180}]',2,'[]','[1002010642,1004010642,1006010642,1008010642,1010010642,1002020642,1004020642,1006020642,1008020642,1010020642,1002030642,1004030642,1006030642,1008030642,1010030642,1002040642,1004040642,1006040642,1008040642,1010040642]','[]','[]','[{0,1004030643,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(33080605,'刻痕','6阶红3星刻痕【通用】',2,'[{lv,180}]',2,'[]','[1005000642,1009000642,1005000642,1009000642,1005000642,1009000642,1005000642,1009000642]','[]','[]','[{0,1005000643,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(33080606,'裤子','6阶红3星裤子【魔导师】',2,'[{lv,180}]',2,'[]','[1002010642,1004010642,1006010642,1008010642,1010010642,1002020642,1004020642,1006020642,1008020642,1010020642,1002030642,1004030642,1006030642,1008030642,1010030642,1002040642,1004040642,1006040642,1008040642,1010040642]','[]','[]','[{0,1006030643,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(33080607,'副手','6阶红3星副手【魔导师】',2,'[{lv,180}]',2,'[]','[1001010642,1007010642,1001020642,1007020642,1001030642,1007030642,1001040642,1007040642]','[]','[]','[{0,1007030643,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(33080608,'护腕','6阶红3星护腕【魔导师】',2,'[{lv,180}]',2,'[]','[1002010642,1004010642,1006010642,1008010642,1010010642,1002020642,1004020642,1006020642,1008020642,1010020642,1002030642,1004030642,1006030642,1008030642,1010030642,1002040642,1004040642,1006040642,1008040642,1010040642]','[]','[]','[{0,1008030643,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(33080609,'戒指','6阶红3星戒指【通用】',2,'[{lv,180}]',2,'[]','[1005000642,1009000642,1005000642,1009000642,1005000642,1009000642,1005000642,1009000642]','[]','[]','[{0,1009000643,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(33080610,'鞋子','6阶红3星鞋子【魔导师】',2,'[{lv,180}]',2,'[]','[1002010642,1004010642,1006010642,1008010642,1010010642,1002020642,1004020642,1006020642,1008020642,1010020642,1002030642,1004030642,1006030642,1008030642,1010030642,1002040642,1004040642,1006040642,1008040642,1010040642]','[]','[]','[{0,1010030643,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(33080701,'武器','7阶红3星武器【魔导师】',2,'[{lv,220}]',2,'[]','[1001010742,1007010742,1001020742,1007020742,1001030742,1007030742,1001040742,1007040742,1101010742,1107010742,1101020742,1107020742,1101030742,1107030742,1101040742,1107040742]','[]','[]','[{0,1001030743,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33080702,'头盔','7阶红3星头盔【魔导师】',2,'[{lv,220}]',2,'[]','[1002010742,1004010742,1006010742,1008010742,1010010742,1002020742,1004020742,1006020742,1008020742,1010020742,1002030742,1004030742,1006030742,1008030742,1010030742,1002040742,1004040742,1006040742,1008040742,1010040742,1102010742,1104010742,1106010742,1108010742,1110010742,1102020742,1104020742,1106020742,1108020742,1110020742,1102030742,1104030742,1106030742,1108030742,1110030742,1102040742,1104040742,1106040742,1108040742,1110040742]','[]','[]','[{0,1002030743,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33080703,'项链','7阶红3星项链【通用】',2,'[{lv,220}]',2,'[]','[1003000742,1003000742,1003000742,1003000742,1103000742,1103000742,1103000742,1103000742]','[]','[]','[{0,1003000743,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33080704,'衣服','7阶红3星衣服【魔导师】',2,'[{lv,220}]',2,'[]','[1002010742,1004010742,1006010742,1008010742,1010010742,1002020742,1004020742,1006020742,1008020742,1010020742,1002030742,1004030742,1006030742,1008030742,1010030742,1002040742,1004040742,1006040742,1008040742,1010040742,1102010742,1104010742,1106010742,1108010742,1110010742,1102020742,1104020742,1106020742,1108020742,1110020742,1102030742,1104030742,1106030742,1108030742,1110030742,1102040742,1104040742,1106040742,1108040742,1110040742]','[]','[]','[{0,1004030743,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33080705,'刻痕','7阶红3星刻痕【通用】',2,'[{lv,220}]',2,'[]','[1005000742,1009000742,1005000742,1009000742,1005000742,1009000742,1005000742,1009000742,1105000742,1109000742,1105000742,1109000742,1105000742,1109000742,1105000742,1109000742]','[]','[]','[{0,1005000743,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33080706,'裤子','7阶红3星裤子【魔导师】',2,'[{lv,220}]',2,'[]','[1002010742,1004010742,1006010742,1008010742,1010010742,1002020742,1004020742,1006020742,1008020742,1010020742,1002030742,1004030742,1006030742,1008030742,1010030742,1002040742,1004040742,1006040742,1008040742,1010040742,1102010742,1104010742,1106010742,1108010742,1110010742,1102020742,1104020742,1106020742,1108020742,1110020742,1102030742,1104030742,1106030742,1108030742,1110030742,1102040742,1104040742,1106040742,1108040742,1110040742]','[]','[]','[{0,1006030743,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33080707,'副手','7阶红3星副手【魔导师】',2,'[{lv,220}]',2,'[]','[1001010742,1007010742,1001020742,1007020742,1001030742,1007030742,1001040742,1007040742,1101010742,1107010742,1101020742,1107020742,1101030742,1107030742,1101040742,1107040742]','[]','[]','[{0,1007030743,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33080708,'护腕','7阶红3星护腕【魔导师】',2,'[{lv,220}]',2,'[]','[1002010742,1004010742,1006010742,1008010742,1010010742,1002020742,1004020742,1006020742,1008020742,1010020742,1002030742,1004030742,1006030742,1008030742,1010030742,1002040742,1004040742,1006040742,1008040742,1010040742,1102010742,1104010742,1106010742,1108010742,1110010742,1102020742,1104020742,1106020742,1108020742,1110020742,1102030742,1104030742,1106030742,1108030742,1110030742,1102040742,1104040742,1106040742,1108040742,1110040742]','[]','[]','[{0,1008030743,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33080709,'戒指','7阶红3星戒指【通用】',2,'[{lv,220}]',2,'[]','[1005000742,1009000742,1005000742,1009000742,1005000742,1009000742,1005000742,1009000742,1105000742,1109000742,1105000742,1109000742,1105000742,1109000742,1105000742,1109000742]','[]','[]','[{0,1009000743,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33080710,'鞋子','7阶红3星鞋子【魔导师】',2,'[{lv,220}]',2,'[]','[1002010742,1004010742,1006010742,1008010742,1010010742,1002020742,1004020742,1006020742,1008020742,1010020742,1002030742,1004030742,1006030742,1008030742,1010030742,1002040742,1004040742,1006040742,1008040742,1010040742,1102010742,1104010742,1106010742,1108010742,1110010742,1102020742,1104020742,1106020742,1108020742,1110020742,1102030742,1104030742,1106030742,1108030742,1110030742,1102040742,1104040742,1106040742,1108040742,1110040742]','[]','[]','[{0,1010030743,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33080801,'武器','8阶红3星武器【魔导师】',2,'[{lv,260}]',2,'[]','[1001010842,1007010842,1001020842,1007020842,1001030842,1007030842,1001040842,1007040842,1101010842,1107010842,1101020842,1107020842,1101030842,1107030842,1101040842,1107040842]','[]','[]','[{0,1001030843,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33080802,'头盔','8阶红3星头盔【魔导师】',2,'[{lv,260}]',2,'[]','[1002010842,1004010842,1006010842,1008010842,1010010842,1002020842,1004020842,1006020842,1008020842,1010020842,1002030842,1004030842,1006030842,1008030842,1010030842,1002040842,1004040842,1006040842,1008040842,1010040842,1102010842,1104010842,1106010842,1108010842,1110010842,1102020842,1104020842,1106020842,1108020842,1110020842,1102030842,1104030842,1106030842,1108030842,1110030842,1102040842,1104040842,1106040842,1108040842,1110040842]','[]','[]','[{0,1002030843,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33080803,'项链','8阶红3星项链【通用】',2,'[{lv,260}]',2,'[]','[1003000842,1003000842,1003000842,1003000842,1103000842,1103000842,1103000842,1103000842]','[]','[]','[{0,1003000843,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33080804,'衣服','8阶红3星衣服【魔导师】',2,'[{lv,260}]',2,'[]','[1002010842,1004010842,1006010842,1008010842,1010010842,1002020842,1004020842,1006020842,1008020842,1010020842,1002030842,1004030842,1006030842,1008030842,1010030842,1002040842,1004040842,1006040842,1008040842,1010040842,1102010842,1104010842,1106010842,1108010842,1110010842,1102020842,1104020842,1106020842,1108020842,1110020842,1102030842,1104030842,1106030842,1108030842,1110030842,1102040842,1104040842,1106040842,1108040842,1110040842]','[]','[]','[{0,1004030843,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33080805,'刻痕','8阶红3星刻痕【通用】',2,'[{lv,260}]',2,'[]','[1005000842,1009000842,1005000842,1009000842,1005000842,1009000842,1005000842,1009000842,1105000842,1109000842,1105000842,1109000842,1105000842,1109000842,1105000842,1109000842]','[]','[]','[{0,1005000843,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33080806,'裤子','8阶红3星裤子【魔导师】',2,'[{lv,260}]',2,'[]','[1002010842,1004010842,1006010842,1008010842,1010010842,1002020842,1004020842,1006020842,1008020842,1010020842,1002030842,1004030842,1006030842,1008030842,1010030842,1002040842,1004040842,1006040842,1008040842,1010040842,1102010842,1104010842,1106010842,1108010842,1110010842,1102020842,1104020842,1106020842,1108020842,1110020842,1102030842,1104030842,1106030842,1108030842,1110030842,1102040842,1104040842,1106040842,1108040842,1110040842]','[]','[]','[{0,1006030843,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33080807,'副手','8阶红3星副手【魔导师】',2,'[{lv,260}]',2,'[]','[1001010842,1007010842,1001020842,1007020842,1001030842,1007030842,1001040842,1007040842,1101010842,1107010842,1101020842,1107020842,1101030842,1107030842,1101040842,1107040842]','[]','[]','[{0,1007030843,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33080808,'护腕','8阶红3星护腕【魔导师】',2,'[{lv,260}]',2,'[]','[1002010842,1004010842,1006010842,1008010842,1010010842,1002020842,1004020842,1006020842,1008020842,1010020842,1002030842,1004030842,1006030842,1008030842,1010030842,1002040842,1004040842,1006040842,1008040842,1010040842,1102010842,1104010842,1106010842,1108010842,1110010842,1102020842,1104020842,1106020842,1108020842,1110020842,1102030842,1104030842,1106030842,1108030842,1110030842,1102040842,1104040842,1106040842,1108040842,1110040842]','[]','[]','[{0,1008030843,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33080809,'戒指','8阶红3星戒指【通用】',2,'[{lv,260}]',2,'[]','[1005000842,1009000842,1005000842,1009000842,1005000842,1009000842,1005000842,1009000842,1105000842,1109000842,1105000842,1109000842,1105000842,1109000842,1105000842,1109000842]','[]','[]','[{0,1009000843,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33080810,'鞋子','8阶红3星鞋子【魔导师】',2,'[{lv,260}]',2,'[]','[1002010842,1004010842,1006010842,1008010842,1010010842,1002020842,1004020842,1006020842,1008020842,1010020842,1002030842,1004030842,1006030842,1008030842,1010030842,1002040842,1004040842,1006040842,1008040842,1010040842,1102010842,1104010842,1106010842,1108010842,1110010842,1102020842,1104020842,1106020842,1108020842,1110020842,1102030842,1104030842,1106030842,1108030842,1110030842,1102040842,1104040842,1106040842,1108040842,1110040842]','[]','[]','[{0,1010030843,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33080901,'武器','9阶红3星武器【魔导师】',2,'[{lv,300}]',2,'[]','[1001010942,1007010942,1001020942,1007020942,1001030942,1007030942,1001040942,1007040942]','[]','[]','[{0,1001030943,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33080902,'头盔','9阶红3星头盔【魔导师】',2,'[{lv,300}]',2,'[]','[1002010942,1004010942,1006010942,1008010942,1010010942,1002020942,1004020942,1006020942,1008020942,1010020942,1002030942,1004030942,1006030942,1008030942,1010030942,1002040942,1004040942,1006040942,1008040942,1010040942]','[]','[]','[{0,1002030943,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33080903,'项链','9阶红3星项链【通用】',2,'[{lv,300}]',2,'[]','[1003000942,1003000942,1003000942,1003000942]','[]','[]','[{0,1003000943,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33080904,'衣服','9阶红3星衣服【魔导师】',2,'[{lv,300}]',2,'[]','[1002010942,1004010942,1006010942,1008010942,1010010942,1002020942,1004020942,1006020942,1008020942,1010020942,1002030942,1004030942,1006030942,1008030942,1010030942,1002040942,1004040942,1006040942,1008040942,1010040942]','[]','[]','[{0,1004030943,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33080905,'刻痕','9阶红3星刻痕【通用】',2,'[{lv,300}]',2,'[]','[1005000942,1009000942,1005000942,1009000942,1005000942,1009000942,1005000942,1009000942]','[]','[]','[{0,1005000943,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33080906,'裤子','9阶红3星裤子【魔导师】',2,'[{lv,300}]',2,'[]','[1002010942,1004010942,1006010942,1008010942,1010010942,1002020942,1004020942,1006020942,1008020942,1010020942,1002030942,1004030942,1006030942,1008030942,1010030942,1002040942,1004040942,1006040942,1008040942,1010040942]','[]','[]','[{0,1006030943,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33080907,'副手','9阶红3星副手【魔导师】',2,'[{lv,300}]',2,'[]','[1001010942,1007010942,1001020942,1007020942,1001030942,1007030942,1001040942,1007040942]','[]','[]','[{0,1007030943,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33080908,'护腕','9阶红3星护腕【魔导师】',2,'[{lv,300}]',2,'[]','[1002010942,1004010942,1006010942,1008010942,1010010942,1002020942,1004020942,1006020942,1008020942,1010020942,1002030942,1004030942,1006030942,1008030942,1010030942,1002040942,1004040942,1006040942,1008040942,1010040942]','[]','[]','[{0,1008030943,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33080909,'戒指','9阶红3星戒指【通用】',2,'[{lv,300}]',2,'[]','[1005000942,1009000942,1005000942,1009000942,1005000942,1009000942,1005000942,1009000942]','[]','[]','[{0,1009000943,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33080910,'鞋子','9阶红3星鞋子【魔导师】',2,'[{lv,300}]',2,'[]','[1002010942,1004010942,1006010942,1008010942,1010010942,1002020942,1004020942,1006020942,1008020942,1010020942,1002030942,1004030942,1006030942,1008030942,1010030942,1002040942,1004040942,1006040942,1008040942,1010040942]','[]','[]','[{0,1010030943,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081001,'武器','10阶红3星武器【魔导师】',2,'[{lv,355}]',2,'[]','[1001011042,1007011042,1001021042,1007021042,1001031042,1007031042,1001041042,1007041042]','[]','[]','[{0,1001031043,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081002,'头盔','10阶红3星头盔【魔导师】',2,'[{lv,355}]',2,'[]','[1002011042,1004011042,1006011042,1008011042,1010011042,1002021042,1004021042,1006021042,1008021042,1010021042,1002031042,1004031042,1006031042,1008031042,1010031042,1002041042,1004041042,1006041042,1008041042,1010041042]','[]','[]','[{0,1002031043,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081003,'项链','10阶红3星项链【通用】',2,'[{lv,355}]',2,'[]','[1003001042,1003001042,1003001042,1003001042]','[]','[]','[{0,1003001043,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081004,'衣服','10阶红3星衣服【魔导师】',2,'[{lv,355}]',2,'[]','[1002011042,1004011042,1006011042,1008011042,1010011042,1002021042,1004021042,1006021042,1008021042,1010021042,1002031042,1004031042,1006031042,1008031042,1010031042,1002041042,1004041042,1006041042,1008041042,1010041042]','[]','[]','[{0,1004031043,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081005,'刻痕','10阶红3星刻痕【通用】',2,'[{lv,355}]',2,'[]','[1005001042,1009001042,1005001042,1009001042,1005001042,1009001042,1005001042,1009001042]','[]','[]','[{0,1005001043,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081006,'裤子','10阶红3星裤子【魔导师】',2,'[{lv,355}]',2,'[]','[1002011042,1004011042,1006011042,1008011042,1010011042,1002021042,1004021042,1006021042,1008021042,1010021042,1002031042,1004031042,1006031042,1008031042,1010031042,1002041042,1004041042,1006041042,1008041042,1010041042]','[]','[]','[{0,1006031043,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081007,'副手','10阶红3星副手【魔导师】',2,'[{lv,355}]',2,'[]','[1001011042,1007011042,1001021042,1007021042,1001031042,1007031042,1001041042,1007041042]','[]','[]','[{0,1007031043,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081008,'护腕','10阶红3星护腕【魔导师】',2,'[{lv,355}]',2,'[]','[1002011042,1004011042,1006011042,1008011042,1010011042,1002021042,1004021042,1006021042,1008021042,1010021042,1002031042,1004031042,1006031042,1008031042,1010031042,1002041042,1004041042,1006041042,1008041042,1010041042]','[]','[]','[{0,1008031043,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081009,'戒指','10阶红3星戒指【通用】',2,'[{lv,355}]',2,'[]','[1005001042,1009001042,1005001042,1009001042,1005001042,1009001042,1005001042,1009001042]','[]','[]','[{0,1009001043,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081010,'鞋子','10阶红3星鞋子【魔导师】',2,'[{lv,355}]',2,'[]','[1002011042,1004011042,1006011042,1008011042,1010011042,1002021042,1004021042,1006021042,1008021042,1010021042,1002031042,1004031042,1006031042,1008031042,1010031042,1002041042,1004041042,1006041042,1008041042,1010041042]','[]','[]','[{0,1010031043,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081101,'武器','11阶红3星武器【魔导师】',2,'[{lv,400}]',2,'[]','[1001011142,1007011142,1001021142,1007021142,1001031142,1007031142,1001041142,1007041142]','[]','[]','[{0,1001031143,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081102,'头盔','11阶红3星头盔【魔导师】',2,'[{lv,400}]',2,'[]','[1002011142,1004011142,1006011142,1008011142,1010011142,1002021142,1004021142,1006021142,1008021142,1010021142,1002031142,1004031142,1006031142,1008031142,1010031142,1002041142,1004041142,1006041142,1008041142,1010041142]','[]','[]','[{0,1002031143,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081103,'项链','11阶红3星项链【通用】',2,'[{lv,400}]',2,'[]','[1003001142,1003001142,1003001142,1003001142]','[]','[]','[{0,1003001143,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081104,'衣服','11阶红3星衣服【魔导师】',2,'[{lv,400}]',2,'[]','[1002011142,1004011142,1006011142,1008011142,1010011142,1002021142,1004021142,1006021142,1008021142,1010021142,1002031142,1004031142,1006031142,1008031142,1010031142,1002041142,1004041142,1006041142,1008041142,1010041142]','[]','[]','[{0,1004031143,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081105,'刻痕','11阶红3星刻痕【通用】',2,'[{lv,400}]',2,'[]','[1005001142,1009001142,1005001142,1009001142,1005001142,1009001142,1005001142,1009001142]','[]','[]','[{0,1005001143,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081106,'裤子','11阶红3星裤子【魔导师】',2,'[{lv,400}]',2,'[]','[1002011142,1004011142,1006011142,1008011142,1010011142,1002021142,1004021142,1006021142,1008021142,1010021142,1002031142,1004031142,1006031142,1008031142,1010031142,1002041142,1004041142,1006041142,1008041142,1010041142]','[]','[]','[{0,1006031143,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081107,'副手','11阶红3星副手【魔导师】',2,'[{lv,400}]',2,'[]','[1001011142,1007011142,1001021142,1007021142,1001031142,1007031142,1001041142,1007041142]','[]','[]','[{0,1007031143,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081108,'护腕','11阶红3星护腕【魔导师】',2,'[{lv,400}]',2,'[]','[1002011142,1004011142,1006011142,1008011142,1010011142,1002021142,1004021142,1006021142,1008021142,1010021142,1002031142,1004031142,1006031142,1008031142,1010031142,1002041142,1004041142,1006041142,1008041142,1010041142]','[]','[]','[{0,1008031143,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081109,'戒指','11阶红3星戒指【通用】',2,'[{lv,400}]',2,'[]','[1005001142,1009001142,1005001142,1009001142,1005001142,1009001142,1005001142,1009001142]','[]','[]','[{0,1009001143,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081110,'鞋子','11阶红3星鞋子【魔导师】',2,'[{lv,400}]',2,'[]','[1002011142,1004011142,1006011142,1008011142,1010011142,1002021142,1004021142,1006021142,1008021142,1010021142,1002031142,1004031142,1006031142,1008031142,1010031142,1002041142,1004041142,1006041142,1008041142,1010041142]','[]','[]','[{0,1010031143,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081201,'武器','12阶红3星武器【魔导师】',2,'[{lv,500}]',2,'[]','[1001011242,1007011242,1001021242,1007021242,1001031242,1007031242,1001041242,1007041242]','[]','[]','[{0,1001031243,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081202,'头盔','12阶红3星头盔【魔导师】',2,'[{lv,500}]',2,'[]','[1002011242,1004011242,1006011242,1008011242,1010011242,1002021242,1004021242,1006021242,1008021242,1010021242,1002031242,1004031242,1006031242,1008031242,1010031242,1002041242,1004041242,1006041242,1008041242,1010041242]','[]','[]','[{0,1002031243,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081203,'项链','12阶红3星项链【通用】',2,'[{lv,500}]',2,'[]','[1003001242,1003001242,1003001242,1003001242]','[]','[]','[{0,1003001243,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081204,'衣服','12阶红3星衣服【魔导师】',2,'[{lv,500}]',2,'[]','[1002011242,1004011242,1006011242,1008011242,1010011242,1002021242,1004021242,1006021242,1008021242,1010021242,1002031242,1004031242,1006031242,1008031242,1010031242,1002041242,1004041242,1006041242,1008041242,1010041242]','[]','[]','[{0,1004031243,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081205,'刻痕','12阶红3星刻痕【通用】',2,'[{lv,500}]',2,'[]','[1005001242,1009001242,1005001242,1009001242,1005001242,1009001242,1005001242,1009001242]','[]','[]','[{0,1005001243,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081206,'裤子','12阶红3星裤子【魔导师】',2,'[{lv,500}]',2,'[]','[1002011242,1004011242,1006011242,1008011242,1010011242,1002021242,1004021242,1006021242,1008021242,1010021242,1002031242,1004031242,1006031242,1008031242,1010031242,1002041242,1004041242,1006041242,1008041242,1010041242]','[]','[]','[{0,1006031243,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081207,'副手','12阶红3星副手【魔导师】',2,'[{lv,500}]',2,'[]','[1001011242,1007011242,1001021242,1007021242,1001031242,1007031242,1001041242,1007041242]','[]','[]','[{0,1007031243,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081208,'护腕','12阶红3星护腕【魔导师】',2,'[{lv,500}]',2,'[]','[1002011242,1004011242,1006011242,1008011242,1010011242,1002021242,1004021242,1006021242,1008021242,1010021242,1002031242,1004031242,1006031242,1008031242,1010031242,1002041242,1004041242,1006041242,1008041242,1010041242]','[]','[]','[{0,1008031243,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081209,'戒指','12阶红3星戒指【通用】',2,'[{lv,500}]',2,'[]','[1005001242,1009001242,1005001242,1009001242,1005001242,1009001242,1005001242,1009001242]','[]','[]','[{0,1009001243,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081210,'鞋子','12阶红3星鞋子【魔导师】',2,'[{lv,500}]',2,'[]','[1002011242,1004011242,1006011242,1008011242,1010011242,1002021242,1004021242,1006021242,1008021242,1010021242,1002031242,1004031242,1006031242,1008031242,1010031242,1002041242,1004041242,1006041242,1008041242,1010041242]','[]','[]','[{0,1010031243,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081301,'武器','13阶红3星武器【魔导师】',2,'[{lv,520}]',2,'[]','[1001011342,1007011342,1001021342,1007021342,1001031342,1007031342,1001041342,1007041342]','[]','[]','[{0,1001031343,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081302,'头盔','13阶红3星头盔【魔导师】',2,'[{lv,520}]',2,'[]','[1002011342,1004011342,1006011342,1008011342,1010011342,1002021342,1004021342,1006021342,1008021342,1010021342,1002031342,1004031342,1006031342,1008031342,1010031342,1002041342,1004041342,1006041342,1008041342,1010041342]','[]','[]','[{0,1002031343,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081303,'项链','13阶红3星项链【通用】',2,'[{lv,520}]',2,'[]','[1003001342,1003001342,1003001342,1003001342]','[]','[]','[{0,1003001343,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081304,'衣服','13阶红3星衣服【魔导师】',2,'[{lv,520}]',2,'[]','[1002011342,1004011342,1006011342,1008011342,1010011342,1002021342,1004021342,1006021342,1008021342,1010021342,1002031342,1004031342,1006031342,1008031342,1010031342,1002041342,1004041342,1006041342,1008041342,1010041342]','[]','[]','[{0,1004031343,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081305,'刻痕','13阶红3星刻痕【通用】',2,'[{lv,520}]',2,'[]','[1005001342,1009001342,1005001342,1009001342,1005001342,1009001342,1005001342,1009001342]','[]','[]','[{0,1005001343,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081306,'裤子','13阶红3星裤子【魔导师】',2,'[{lv,520}]',2,'[]','[1002011342,1004011342,1006011342,1008011342,1010011342,1002021342,1004021342,1006021342,1008021342,1010021342,1002031342,1004031342,1006031342,1008031342,1010031342,1002041342,1004041342,1006041342,1008041342,1010041342]','[]','[]','[{0,1006031343,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081307,'副手','13阶红3星副手【魔导师】',2,'[{lv,520}]',2,'[]','[1001011342,1007011342,1001021342,1007021342,1001031342,1007031342,1001041342,1007041342]','[]','[]','[{0,1007031343,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081308,'护腕','13阶红3星护腕【魔导师】',2,'[{lv,520}]',2,'[]','[1002011342,1004011342,1006011342,1008011342,1010011342,1002021342,1004021342,1006021342,1008021342,1010021342,1002031342,1004031342,1006031342,1008031342,1010031342,1002041342,1004041342,1006041342,1008041342,1010041342]','[]','[]','[{0,1008031343,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081309,'戒指','13阶红3星戒指【通用】',2,'[{lv,520}]',2,'[]','[1005001342,1009001342,1005001342,1009001342,1005001342,1009001342,1005001342,1009001342]','[]','[]','[{0,1009001343,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081310,'鞋子','13阶红3星鞋子【魔导师】',2,'[{lv,520}]',2,'[]','[1002011342,1004011342,1006011342,1008011342,1010011342,1002021342,1004021342,1006021342,1008021342,1010021342,1002031342,1004031342,1006031342,1008031342,1010031342,1002041342,1004041342,1006041342,1008041342,1010041342]','[]','[]','[{0,1010031343,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081401,'武器','14阶红3星武器【魔导师】',2,'[{lv,620}]',2,'[]','[1001011442,1007011442,1001021442,1007021442,1001031442,1007031442,1001041442,1007041442]','[]','[]','[{0,1001031443,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081402,'头盔','14阶红3星头盔【魔导师】',2,'[{lv,620}]',2,'[]','[1002011442,1004011442,1006011442,1008011442,1010011442,1002021442,1004021442,1006021442,1008021442,1010021442,1002031442,1004031442,1006031442,1008031442,1010031442,1002041442,1004041442,1006041442,1008041442,1010041442]','[]','[]','[{0,1002031443,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081403,'项链','14阶红3星项链【通用】',2,'[{lv,620}]',2,'[]','[1003001442,1003001442,1003001442,1003001442]','[]','[]','[{0,1003001443,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081404,'衣服','14阶红3星衣服【魔导师】',2,'[{lv,620}]',2,'[]','[1002011442,1004011442,1006011442,1008011442,1010011442,1002021442,1004021442,1006021442,1008021442,1010021442,1002031442,1004031442,1006031442,1008031442,1010031442,1002041442,1004041442,1006041442,1008041442,1010041442]','[]','[]','[{0,1004031443,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081405,'刻痕','14阶红3星刻痕【通用】',2,'[{lv,620}]',2,'[]','[1005001442,1009001442,1005001442,1009001442,1005001442,1009001442,1005001442,1009001442]','[]','[]','[{0,1005001443,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081406,'裤子','14阶红3星裤子【魔导师】',2,'[{lv,620}]',2,'[]','[1002011442,1004011442,1006011442,1008011442,1010011442,1002021442,1004021442,1006021442,1008021442,1010021442,1002031442,1004031442,1006031442,1008031442,1010031442,1002041442,1004041442,1006041442,1008041442,1010041442]','[]','[]','[{0,1006031443,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081407,'副手','14阶红3星副手【魔导师】',2,'[{lv,620}]',2,'[]','[1001011442,1007011442,1001021442,1007021442,1001031442,1007031442,1001041442,1007041442]','[]','[]','[{0,1007031443,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081408,'护腕','14阶红3星护腕【魔导师】',2,'[{lv,620}]',2,'[]','[1002011442,1004011442,1006011442,1008011442,1010011442,1002021442,1004021442,1006021442,1008021442,1010021442,1002031442,1004031442,1006031442,1008031442,1010031442,1002041442,1004041442,1006041442,1008041442,1010041442]','[]','[]','[{0,1008031443,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081409,'戒指','14阶红3星戒指【通用】',2,'[{lv,620}]',2,'[]','[1005001442,1009001442,1005001442,1009001442,1005001442,1009001442,1005001442,1009001442]','[]','[]','[{0,1009001443,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081410,'鞋子','14阶红3星鞋子【魔导师】',2,'[{lv,620}]',2,'[]','[1002011442,1004011442,1006011442,1008011442,1010011442,1002021442,1004021442,1006021442,1008021442,1010021442,1002031442,1004031442,1006031442,1008031442,1010031442,1002041442,1004041442,1006041442,1008041442,1010041442]','[]','[]','[{0,1010031443,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081501,'武器','15阶红3星武器【魔导师】',2,'[{lv,650}]',2,'[]','[1001011542,1007011542,1001021542,1007021542,1001031542,1007031542,1001041542,1007041542]','[]','[]','[{0,1001031543,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081502,'头盔','15阶红3星头盔【魔导师】',2,'[{lv,650}]',2,'[]','[1002011542,1004011542,1006011542,1008011542,1010011542,1002021542,1004021542,1006021542,1008021542,1010021542,1002031542,1004031542,1006031542,1008031542,1010031542,1002041542,1004041542,1006041542,1008041542,1010041542]','[]','[]','[{0,1002031543,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081503,'项链','15阶红3星项链【通用】',2,'[{lv,650}]',2,'[]','[1003001542,1003001542,1003001542,1003001542]','[]','[]','[{0,1003001543,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081504,'衣服','15阶红3星衣服【魔导师】',2,'[{lv,650}]',2,'[]','[1002011542,1004011542,1006011542,1008011542,1010011542,1002021542,1004021542,1006021542,1008021542,1010021542,1002031542,1004031542,1006031542,1008031542,1010031542,1002041542,1004041542,1006041542,1008041542,1010041542]','[]','[]','[{0,1004031543,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081505,'刻痕','15阶红3星刻痕【通用】',2,'[{lv,650}]',2,'[]','[1005001542,1009001542,1005001542,1009001542,1005001542,1009001542,1005001542,1009001542]','[]','[]','[{0,1005001543,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081506,'裤子','15阶红3星裤子【魔导师】',2,'[{lv,650}]',2,'[]','[1002011542,1004011542,1006011542,1008011542,1010011542,1002021542,1004021542,1006021542,1008021542,1010021542,1002031542,1004031542,1006031542,1008031542,1010031542,1002041542,1004041542,1006041542,1008041542,1010041542]','[]','[]','[{0,1006031543,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081507,'副手','15阶红3星副手【魔导师】',2,'[{lv,650}]',2,'[]','[1001011542,1007011542,1001021542,1007021542,1001031542,1007031542,1001041542,1007041542]','[]','[]','[{0,1007031543,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081508,'护腕','15阶红3星护腕【魔导师】',2,'[{lv,650}]',2,'[]','[1002011542,1004011542,1006011542,1008011542,1010011542,1002021542,1004021542,1006021542,1008021542,1010021542,1002031542,1004031542,1006031542,1008031542,1010031542,1002041542,1004041542,1006041542,1008041542,1010041542]','[]','[]','[{0,1008031543,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081509,'戒指','15阶红3星戒指【通用】',2,'[{lv,650}]',2,'[]','[1005001542,1009001542,1005001542,1009001542,1005001542,1009001542,1005001542,1009001542]','[]','[]','[{0,1009001543,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081510,'鞋子','15阶红3星鞋子【魔导师】',2,'[{lv,650}]',2,'[]','[1002011542,1004011542,1006011542,1008011542,1010011542,1002021542,1004021542,1006021542,1008021542,1010021542,1002031542,1004031542,1006031542,1008031542,1010031542,1002041542,1004041542,1006041542,1008041542,1010041542]','[]','[]','[{0,1010031543,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081601,'武器','16阶红3星武器【魔导师】',2,'[{lv,700}]',2,'[]','[1001011642,1007011642,1001021642,1007021642,1001031642,1007031642,1001041642,1007041642]','[]','[]','[{0,1001031643,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081602,'头盔','16阶红3星头盔【魔导师】',2,'[{lv,700}]',2,'[]','[1002011642,1004011642,1006011642,1008011642,1010011642,1002021642,1004021642,1006021642,1008021642,1010021642,1002031642,1004031642,1006031642,1008031642,1010031642,1002041642,1004041642,1006041642,1008041642,1010041642]','[]','[]','[{0,1002031643,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081603,'项链','16阶红3星项链【通用】',2,'[{lv,700}]',2,'[]','[1003001642,1003001642,1003001642,1003001642]','[]','[]','[{0,1003001643,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081604,'衣服','16阶红3星衣服【魔导师】',2,'[{lv,700}]',2,'[]','[1002011642,1004011642,1006011642,1008011642,1010011642,1002021642,1004021642,1006021642,1008021642,1010021642,1002031642,1004031642,1006031642,1008031642,1010031642,1002041642,1004041642,1006041642,1008041642,1010041642]','[]','[]','[{0,1004031643,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081605,'刻痕','16阶红3星刻痕【通用】',2,'[{lv,700}]',2,'[]','[1005001642,1009001642,1005001642,1009001642,1005001642,1009001642,1005001642,1009001642]','[]','[]','[{0,1005001643,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081606,'裤子','16阶红3星裤子【魔导师】',2,'[{lv,700}]',2,'[]','[1002011642,1004011642,1006011642,1008011642,1010011642,1002021642,1004021642,1006021642,1008021642,1010021642,1002031642,1004031642,1006031642,1008031642,1010031642,1002041642,1004041642,1006041642,1008041642,1010041642]','[]','[]','[{0,1006031643,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081607,'副手','16阶红3星副手【魔导师】',2,'[{lv,700}]',2,'[]','[1001011642,1007011642,1001021642,1007021642,1001031642,1007031642,1001041642,1007041642]','[]','[]','[{0,1007031643,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081608,'护腕','16阶红3星护腕【魔导师】',2,'[{lv,700}]',2,'[]','[1002011642,1004011642,1006011642,1008011642,1010011642,1002021642,1004021642,1006021642,1008021642,1010021642,1002031642,1004031642,1006031642,1008031642,1010031642,1002041642,1004041642,1006041642,1008041642,1010041642]','[]','[]','[{0,1008031643,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081609,'戒指','16阶红3星戒指【通用】',2,'[{lv,700}]',2,'[]','[1005001642,1009001642,1005001642,1009001642,1005001642,1009001642,1005001642,1009001642]','[]','[]','[{0,1009001643,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33081610,'鞋子','16阶红3星鞋子【魔导师】',2,'[{lv,700}]',2,'[]','[1002011642,1004011642,1006011642,1008011642,1010011642,1002021642,1004021642,1006021642,1008021642,1010021642,1002031642,1004031642,1006031642,1008031642,1010031642,1002041642,1004041642,1006041642,1008041642,1010041642]','[]','[]','[{0,1010031643,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(33090301,'武器','3阶粉色武器【魔导师】',2,'[{lv,9999}]',3,'[{0,38280520,1}]','[1001010343,1007010343,1001020343,1007020343,1001030343,1007030343,1001040343,1007040343]','[]','[]','[{0,1001030353,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(33090302,'头盔','3阶粉色头盔【魔导师】',2,'[{lv,9999}]',3,'[{0,38280510,1}]','[1002010343,1004010343,1006010343,1008010343,1010010343,1002020343,1004020343,1006020343,1008020343,1010020343,1002030343,1004030343,1006030343,1008030343,1010030343,1002040343,1004040343,1006040343,1008040343,1010040343]','[]','[]','[{0,1002030353,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(33090303,'项链','3阶粉色项链【通用】',2,'[{lv,9999}]',3,'[{0,38280520,1}]','[1003000343,1003000343,1003000343,1003000343]','[]','[]','[{0,1003000353,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(33090304,'衣服','3阶粉色衣服【魔导师】',2,'[{lv,9999}]',3,'[{0,38280510,1}]','[1002010343,1004010343,1006010343,1008010343,1010010343,1002020343,1004020343,1006020343,1008020343,1010020343,1002030343,1004030343,1006030343,1008030343,1010030343,1002040343,1004040343,1006040343,1008040343,1010040343]','[]','[]','[{0,1004030353,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(33090305,'刻痕','3阶粉色刻痕【通用】',2,'[{lv,9999}]',3,'[{0,38280520,1}]','[1005000343,1009000343,1005000343,1009000343,1005000343,1009000343,1005000343,1009000343]','[]','[]','[{0,1005000353,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(33090306,'裤子','3阶粉色裤子【魔导师】',2,'[{lv,9999}]',3,'[{0,38280510,1}]','[1002010343,1004010343,1006010343,1008010343,1010010343,1002020343,1004020343,1006020343,1008020343,1010020343,1002030343,1004030343,1006030343,1008030343,1010030343,1002040343,1004040343,1006040343,1008040343,1010040343]','[]','[]','[{0,1006030353,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(33090307,'副手','3阶粉色副手【魔导师】',2,'[{lv,9999}]',3,'[{0,38280520,1}]','[1001010343,1007010343,1001020343,1007020343,1001030343,1007030343,1001040343,1007040343]','[]','[]','[{0,1007030353,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(33090308,'护腕','3阶粉色护腕【魔导师】',2,'[{lv,9999}]',3,'[{0,38280510,1}]','[1002010343,1004010343,1006010343,1008010343,1010010343,1002020343,1004020343,1006020343,1008020343,1010020343,1002030343,1004030343,1006030343,1008030343,1010030343,1002040343,1004040343,1006040343,1008040343,1010040343]','[]','[]','[{0,1008030353,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(33090309,'戒指','3阶粉色戒指【通用】',2,'[{lv,9999}]',3,'[{0,38280520,1}]','[1005000343,1009000343,1005000343,1009000343,1005000343,1009000343,1005000343,1009000343]','[]','[]','[{0,1009000353,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(33090310,'鞋子','3阶粉色鞋子【魔导师】',2,'[{lv,9999}]',3,'[{0,38280510,1}]','[1002010343,1004010343,1006010343,1008010343,1010010343,1002020343,1004020343,1006020343,1008020343,1010020343,1002030343,1004030343,1006030343,1008030343,1010030343,1002040343,1004040343,1006040343,1008040343,1010040343]','[]','[]','[{0,1010030353,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(33090401,'武器','4阶粉色武器【魔导师】',2,'[{lv,160}]',3,'[{0,38280520,1}]','[1001010443,1007010443,1001020443,1007020443,1001030443,1007030443,1001040443,1007040443]','[]','[]','[{0,1001030453,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(33090402,'头盔','4阶粉色头盔【魔导师】',2,'[{lv,160}]',3,'[{0,38280510,1}]','[1002010443,1004010443,1006010443,1008010443,1010010443,1002020443,1004020443,1006020443,1008020443,1010020443,1002030443,1004030443,1006030443,1008030443,1010030443,1002040443,1004040443,1006040443,1008040443,1010040443]','[]','[]','[{0,1002030453,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(33090403,'项链','4阶粉色项链【通用】',2,'[{lv,160}]',3,'[{0,38280520,1}]','[1003000443,1003000443,1003000443,1003000443]','[]','[]','[{0,1003000453,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(33090404,'衣服','4阶粉色衣服【魔导师】',2,'[{lv,160}]',3,'[{0,38280510,1}]','[1002010443,1004010443,1006010443,1008010443,1010010443,1002020443,1004020443,1006020443,1008020443,1010020443,1002030443,1004030443,1006030443,1008030443,1010030443,1002040443,1004040443,1006040443,1008040443,1010040443]','[]','[]','[{0,1004030453,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(33090405,'刻痕','4阶粉色刻痕【通用】',2,'[{lv,160}]',3,'[{0,38280520,1}]','[1005000443,1009000443,1005000443,1009000443,1005000443,1009000443,1005000443,1009000443]','[]','[]','[{0,1005000453,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(33090406,'裤子','4阶粉色裤子【魔导师】',2,'[{lv,160}]',3,'[{0,38280510,1}]','[1002010443,1004010443,1006010443,1008010443,1010010443,1002020443,1004020443,1006020443,1008020443,1010020443,1002030443,1004030443,1006030443,1008030443,1010030443,1002040443,1004040443,1006040443,1008040443,1010040443]','[]','[]','[{0,1006030453,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(33090407,'副手','4阶粉色副手【魔导师】',2,'[{lv,160}]',3,'[{0,38280520,1}]','[1001010443,1007010443,1001020443,1007020443,1001030443,1007030443,1001040443,1007040443]','[]','[]','[{0,1007030453,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(33090408,'护腕','4阶粉色护腕【魔导师】',2,'[{lv,160}]',3,'[{0,38280510,1}]','[1002010443,1004010443,1006010443,1008010443,1010010443,1002020443,1004020443,1006020443,1008020443,1010020443,1002030443,1004030443,1006030443,1008030443,1010030443,1002040443,1004040443,1006040443,1008040443,1010040443]','[]','[]','[{0,1008030453,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(33090409,'戒指','4阶粉色戒指【通用】',2,'[{lv,160}]',3,'[{0,38280520,1}]','[1005000443,1009000443,1005000443,1009000443,1005000443,1009000443,1005000443,1009000443]','[]','[]','[{0,1009000453,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(33090410,'鞋子','4阶粉色鞋子【魔导师】',2,'[{lv,160}]',3,'[{0,38280510,1}]','[1002010443,1004010443,1006010443,1008010443,1010010443,1002020443,1004020443,1006020443,1008020443,1010020443,1002030443,1004030443,1006030443,1008030443,1010030443,1002040443,1004040443,1006040443,1008040443,1010040443]','[]','[]','[{0,1010030453,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(33090501,'武器','5阶粉色武器【魔导师】',2,'[{lv,160}]',3,'[{0,38280520,1}]','[1001010543,1007010543,1001020543,1007020543,1001030543,1007030543,1001040543,1007040543,1101010543,1107010543,1101020543,1107020543,1101030543,1107030543,1101040543,1107040543]','[]','[]','[{0,1001030553,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(33090502,'头盔','5阶粉色头盔【魔导师】',2,'[{lv,160}]',3,'[{0,38280510,1}]','[1002010543,1004010543,1006010543,1008010543,1010010543,1002020543,1004020543,1006020543,1008020543,1010020543,1002030543,1004030543,1006030543,1008030543,1010030543,1002040543,1004040543,1006040543,1008040543,1010040543,1102010543,1104010543,1106010543,1108010543,1110010543,1102020543,1104020543,1106020543,1108020543,1110020543,1102030543,1104030543,1106030543,1108030543,1110030543,1102040543,1104040543,1106040543,1108040543,1110040543]','[]','[]','[{0,1002030553,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(33090503,'项链','5阶粉色项链【通用】',2,'[{lv,160}]',3,'[{0,38280520,1}]','[1003000543,1003000543,1003000543,1003000543,1103000543,1103000543,1103000543,1103000543]','[]','[]','[{0,1003000553,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(33090504,'衣服','5阶粉色衣服【魔导师】',2,'[{lv,160}]',3,'[{0,38280510,1}]','[1002010543,1004010543,1006010543,1008010543,1010010543,1002020543,1004020543,1006020543,1008020543,1010020543,1002030543,1004030543,1006030543,1008030543,1010030543,1002040543,1004040543,1006040543,1008040543,1010040543,1102010543,1104010543,1106010543,1108010543,1110010543,1102020543,1104020543,1106020543,1108020543,1110020543,1102030543,1104030543,1106030543,1108030543,1110030543,1102040543,1104040543,1106040543,1108040543,1110040543]','[]','[]','[{0,1004030553,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(33090505,'刻痕','5阶粉色刻痕【通用】',2,'[{lv,160}]',3,'[{0,38280520,1}]','[1005000543,1009000543,1005000543,1009000543,1005000543,1009000543,1005000543,1009000543,1105000543,1109000543,1105000543,1109000543,1105000543,1109000543,1105000543,1109000543]','[]','[]','[{0,1005000553,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(33090506,'裤子','5阶粉色裤子【魔导师】',2,'[{lv,160}]',3,'[{0,38280510,1}]','[1002010543,1004010543,1006010543,1008010543,1010010543,1002020543,1004020543,1006020543,1008020543,1010020543,1002030543,1004030543,1006030543,1008030543,1010030543,1002040543,1004040543,1006040543,1008040543,1010040543,1102010543,1104010543,1106010543,1108010543,1110010543,1102020543,1104020543,1106020543,1108020543,1110020543,1102030543,1104030543,1106030543,1108030543,1110030543,1102040543,1104040543,1106040543,1108040543,1110040543]','[]','[]','[{0,1006030553,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(33090507,'副手','5阶粉色副手【魔导师】',2,'[{lv,160}]',3,'[{0,38280520,1}]','[1001010543,1007010543,1001020543,1007020543,1001030543,1007030543,1001040543,1007040543,1101010543,1107010543,1101020543,1107020543,1101030543,1107030543,1101040543,1107040543]','[]','[]','[{0,1007030553,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(33090508,'护腕','5阶粉色护腕【魔导师】',2,'[{lv,160}]',3,'[{0,38280510,1}]','[1002010543,1004010543,1006010543,1008010543,1010010543,1002020543,1004020543,1006020543,1008020543,1010020543,1002030543,1004030543,1006030543,1008030543,1010030543,1002040543,1004040543,1006040543,1008040543,1010040543,1102010543,1104010543,1106010543,1108010543,1110010543,1102020543,1104020543,1106020543,1108020543,1110020543,1102030543,1104030543,1106030543,1108030543,1110030543,1102040543,1104040543,1106040543,1108040543,1110040543]','[]','[]','[{0,1008030553,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(33090509,'戒指','5阶粉色戒指【通用】',2,'[{lv,160}]',3,'[{0,38280520,1}]','[1005000543,1009000543,1005000543,1009000543,1005000543,1009000543,1005000543,1009000543,1105000543,1109000543,1105000543,1109000543,1105000543,1109000543,1105000543,1109000543]','[]','[]','[{0,1009000553,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(33090510,'鞋子','5阶粉色鞋子【魔导师】',2,'[{lv,160}]',3,'[{0,38280510,1}]','[1002010543,1004010543,1006010543,1008010543,1010010543,1002020543,1004020543,1006020543,1008020543,1010020543,1002030543,1004030543,1006030543,1008030543,1010030543,1002040543,1004040543,1006040543,1008040543,1010040543,1102010543,1104010543,1106010543,1108010543,1110010543,1102020543,1104020543,1106020543,1108020543,1110020543,1102030543,1104030543,1106030543,1108030543,1110030543,1102040543,1104040543,1106040543,1108040543,1110040543]','[]','[]','[{0,1010030553,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(33090601,'武器','6阶粉色武器【魔导师】',2,'[{lv,180}]',3,'[{0,38280520,2}]','[1001010643,1007010643,1001020643,1007020643,1001030643,1007030643,1001040643,1007040643]','[]','[]','[{0,1001030653,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280520,2}]',150),(33090602,'头盔','6阶粉色头盔【魔导师】',2,'[{lv,180}]',3,'[{0,38280510,2}]','[1002010643,1004010643,1006010643,1008010643,1010010643,1002020643,1004020643,1006020643,1008020643,1010020643,1002030643,1004030643,1006030643,1008030643,1010030643,1002040643,1004040643,1006040643,1008040643,1010040643]','[]','[]','[{0,1002030653,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280510,2}]',150),(33090603,'项链','6阶粉色项链【通用】',2,'[{lv,180}]',3,'[{0,38280520,2}]','[1003000643,1003000643,1003000643,1003000643]','[]','[]','[{0,1003000653,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280520,2}]',150),(33090604,'衣服','6阶粉色衣服【魔导师】',2,'[{lv,180}]',3,'[{0,38280510,2}]','[1002010643,1004010643,1006010643,1008010643,1010010643,1002020643,1004020643,1006020643,1008020643,1010020643,1002030643,1004030643,1006030643,1008030643,1010030643,1002040643,1004040643,1006040643,1008040643,1010040643]','[]','[]','[{0,1004030653,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280510,2}]',150),(33090605,'刻痕','6阶粉色刻痕【通用】',2,'[{lv,180}]',3,'[{0,38280520,2}]','[1005000643,1009000643,1005000643,1009000643,1005000643,1009000643,1005000643,1009000643]','[]','[]','[{0,1005000653,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280520,2}]',150),(33090606,'裤子','6阶粉色裤子【魔导师】',2,'[{lv,180}]',3,'[{0,38280510,2}]','[1002010643,1004010643,1006010643,1008010643,1010010643,1002020643,1004020643,1006020643,1008020643,1010020643,1002030643,1004030643,1006030643,1008030643,1010030643,1002040643,1004040643,1006040643,1008040643,1010040643]','[]','[]','[{0,1006030653,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280510,2}]',150),(33090607,'副手','6阶粉色副手【魔导师】',2,'[{lv,180}]',3,'[{0,38280520,2}]','[1001010643,1007010643,1001020643,1007020643,1001030643,1007030643,1001040643,1007040643]','[]','[]','[{0,1007030653,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280520,2}]',150),(33090608,'护腕','6阶粉色护腕【魔导师】',2,'[{lv,180}]',3,'[{0,38280510,2}]','[1002010643,1004010643,1006010643,1008010643,1010010643,1002020643,1004020643,1006020643,1008020643,1010020643,1002030643,1004030643,1006030643,1008030643,1010030643,1002040643,1004040643,1006040643,1008040643,1010040643]','[]','[]','[{0,1008030653,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280510,2}]',150),(33090609,'戒指','6阶粉色戒指【通用】',2,'[{lv,180}]',3,'[{0,38280520,2}]','[1005000643,1009000643,1005000643,1009000643,1005000643,1009000643,1005000643,1009000643]','[]','[]','[{0,1009000653,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280520,2}]',150),(33090610,'鞋子','6阶粉色鞋子【魔导师】',2,'[{lv,180}]',3,'[{0,38280510,2}]','[1002010643,1004010643,1006010643,1008010643,1010010643,1002020643,1004020643,1006020643,1008020643,1010020643,1002030643,1004030643,1006030643,1008030643,1010030643,1002040643,1004040643,1006040643,1008040643,1010040643]','[]','[]','[{0,1010030653,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280510,2}]',150),(33090701,'武器','7阶粉色武器【魔导师】',2,'[{lv,220}]',3,'[{0,38280520,3}]','[1001010743,1007010743,1001020743,1007020743,1001030743,1007030743,1001040743,1007040743,1101010743,1107010743,1101020743,1107020743,1101030743,1107030743,1101040743,1107040743]','[]','[]','[{0,1001030753,1}]',2,'[{1,0},{2,100},{3,100}]',3,1,'[{0,38280520,3}]',150),(33090702,'头盔','7阶粉色头盔【魔导师】',2,'[{lv,220}]',3,'[{0,38280510,3}]','[1002010743,1004010743,1006010743,1008010743,1010010743,1002020743,1004020743,1006020743,1008020743,1010020743,1002030743,1004030743,1006030743,1008030743,1010030743,1002040743,1004040743,1006040743,1008040743,1010040743,1102010743,1104010743,1106010743,1108010743,1110010743,1102020743,1104020743,1106020743,1108020743,1110020743,1102030743,1104030743,1106030743,1108030743,1110030743,1102040743,1104040743,1106040743,1108040743,1110040743]','[]','[]','[{0,1002030753,1}]',2,'[{1,0},{2,100},{3,100}]',3,1,'[{0,38280510,3}]',150),(33090703,'项链','7阶粉色项链【通用】',2,'[{lv,220}]',3,'[{0,38280520,3}]','[1003000743,1003000743,1003000743,1003000743,1103000743,1103000743,1103000743,1103000743]','[]','[]','[{0,1003000753,1}]',2,'[{1,0},{2,100},{3,100}]',3,1,'[{0,38280520,3}]',150),(33090704,'衣服','7阶粉色衣服【魔导师】',2,'[{lv,220}]',3,'[{0,38280510,3}]','[1002010743,1004010743,1006010743,1008010743,1010010743,1002020743,1004020743,1006020743,1008020743,1010020743,1002030743,1004030743,1006030743,1008030743,1010030743,1002040743,1004040743,1006040743,1008040743,1010040743,1102010743,1104010743,1106010743,1108010743,1110010743,1102020743,1104020743,1106020743,1108020743,1110020743,1102030743,1104030743,1106030743,1108030743,1110030743,1102040743,1104040743,1106040743,1108040743,1110040743]','[]','[]','[{0,1004030753,1}]',2,'[{1,0},{2,100},{3,100}]',3,1,'[{0,38280510,3}]',150),(33090705,'刻痕','7阶粉色刻痕【通用】',2,'[{lv,220}]',3,'[{0,38280520,3}]','[1005000743,1009000743,1005000743,1009000743,1005000743,1009000743,1005000743,1009000743,1105000743,1109000743,1105000743,1109000743,1105000743,1109000743,1105000743,1109000743]','[]','[]','[{0,1005000753,1}]',2,'[{1,0},{2,100},{3,100}]',3,1,'[{0,38280520,3}]',150),(33090706,'裤子','7阶粉色裤子【魔导师】',2,'[{lv,220}]',3,'[{0,38280510,3}]','[1002010743,1004010743,1006010743,1008010743,1010010743,1002020743,1004020743,1006020743,1008020743,1010020743,1002030743,1004030743,1006030743,1008030743,1010030743,1002040743,1004040743,1006040743,1008040743,1010040743,1102010743,1104010743,1106010743,1108010743,1110010743,1102020743,1104020743,1106020743,1108020743,1110020743,1102030743,1104030743,1106030743,1108030743,1110030743,1102040743,1104040743,1106040743,1108040743,1110040743]','[]','[]','[{0,1006030753,1}]',2,'[{1,0},{2,100},{3,100}]',3,1,'[{0,38280510,3}]',150),(33090707,'副手','7阶粉色副手【魔导师】',2,'[{lv,220}]',3,'[{0,38280520,3}]','[1001010743,1007010743,1001020743,1007020743,1001030743,1007030743,1001040743,1007040743,1101010743,1107010743,1101020743,1107020743,1101030743,1107030743,1101040743,1107040743]','[]','[]','[{0,1007030753,1}]',2,'[{1,0},{2,100},{3,100}]',3,1,'[{0,38280520,3}]',150),(33090708,'护腕','7阶粉色护腕【魔导师】',2,'[{lv,220}]',3,'[{0,38280510,3}]','[1002010743,1004010743,1006010743,1008010743,1010010743,1002020743,1004020743,1006020743,1008020743,1010020743,1002030743,1004030743,1006030743,1008030743,1010030743,1002040743,1004040743,1006040743,1008040743,1010040743,1102010743,1104010743,1106010743,1108010743,1110010743,1102020743,1104020743,1106020743,1108020743,1110020743,1102030743,1104030743,1106030743,1108030743,1110030743,1102040743,1104040743,1106040743,1108040743,1110040743]','[]','[]','[{0,1008030753,1}]',2,'[{1,0},{2,100},{3,100}]',3,1,'[{0,38280510,3}]',150),(33090709,'戒指','7阶粉色戒指【通用】',2,'[{lv,220}]',3,'[{0,38280520,3}]','[1005000743,1009000743,1005000743,1009000743,1005000743,1009000743,1005000743,1009000743,1105000743,1109000743,1105000743,1109000743,1105000743,1109000743,1105000743,1109000743]','[]','[]','[{0,1009000753,1}]',2,'[{1,0},{2,100},{3,100}]',3,1,'[{0,38280520,3}]',150),(33090710,'鞋子','7阶粉色鞋子【魔导师】',2,'[{lv,220}]',3,'[{0,38280510,3}]','[1002010743,1004010743,1006010743,1008010743,1010010743,1002020743,1004020743,1006020743,1008020743,1010020743,1002030743,1004030743,1006030743,1008030743,1010030743,1002040743,1004040743,1006040743,1008040743,1010040743,1102010743,1104010743,1106010743,1108010743,1110010743,1102020743,1104020743,1106020743,1108020743,1110020743,1102030743,1104030743,1106030743,1108030743,1110030743,1102040743,1104040743,1106040743,1108040743,1110040743]','[]','[]','[{0,1010030753,1}]',2,'[{1,0},{2,100},{3,100}]',3,1,'[{0,38280510,3}]',150),(33090801,'武器','8阶粉色武器【魔导师】',2,'[{lv,260}]',3,'[{0,38280520,4}]','[1001010843,1007010843,1001020843,1007020843,1001030843,1007030843,1001040843,1007040843]','[]','[]','[{0,1001030853,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280520,4}]',150),(33090802,'头盔','8阶粉色头盔【魔导师】',2,'[{lv,260}]',3,'[{0,38280510,4}]','[1002010843,1004010843,1006010843,1008010843,1010010843,1002020843,1004020843,1006020843,1008020843,1010020843,1002030843,1004030843,1006030843,1008030843,1010030843,1002040843,1004040843,1006040843,1008040843,1010040843]','[]','[]','[{0,1002030853,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280510,4}]',150),(33090803,'项链','8阶粉色项链【通用】',2,'[{lv,260}]',3,'[{0,38280520,4}]','[1003000843,1003000843,1003000843,1003000843]','[]','[]','[{0,1003000853,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280520,4}]',150),(33090804,'衣服','8阶粉色衣服【魔导师】',2,'[{lv,260}]',3,'[{0,38280510,4}]','[1002010843,1004010843,1006010843,1008010843,1010010843,1002020843,1004020843,1006020843,1008020843,1010020843,1002030843,1004030843,1006030843,1008030843,1010030843,1002040843,1004040843,1006040843,1008040843,1010040843]','[]','[]','[{0,1004030853,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280510,4}]',150),(33090805,'刻痕','8阶粉色刻痕【通用】',2,'[{lv,260}]',3,'[{0,38280520,4}]','[1005000843,1009000843,1005000843,1009000843,1005000843,1009000843,1005000843,1009000843]','[]','[]','[{0,1005000853,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280520,4}]',150),(33090806,'裤子','8阶粉色裤子【魔导师】',2,'[{lv,260}]',3,'[{0,38280510,4}]','[1002010843,1004010843,1006010843,1008010843,1010010843,1002020843,1004020843,1006020843,1008020843,1010020843,1002030843,1004030843,1006030843,1008030843,1010030843,1002040843,1004040843,1006040843,1008040843,1010040843]','[]','[]','[{0,1006030853,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280510,4}]',150),(33090807,'副手','8阶粉色副手【魔导师】',2,'[{lv,260}]',3,'[{0,38280520,4}]','[1001010843,1007010843,1001020843,1007020843,1001030843,1007030843,1001040843,1007040843]','[]','[]','[{0,1007030853,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280520,4}]',150),(33090808,'护腕','8阶粉色护腕【魔导师】',2,'[{lv,260}]',3,'[{0,38280510,4}]','[1002010843,1004010843,1006010843,1008010843,1010010843,1002020843,1004020843,1006020843,1008020843,1010020843,1002030843,1004030843,1006030843,1008030843,1010030843,1002040843,1004040843,1006040843,1008040843,1010040843]','[]','[]','[{0,1008030853,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280510,4}]',150),(33090809,'戒指','8阶粉色戒指【通用】',2,'[{lv,260}]',3,'[{0,38280520,4}]','[1005000843,1009000843,1005000843,1009000843,1005000843,1009000843,1005000843,1009000843]','[]','[]','[{0,1009000853,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280520,4}]',150),(33090810,'鞋子','8阶粉色鞋子【魔导师】',2,'[{lv,260}]',3,'[{0,38280510,4}]','[1002010843,1004010843,1006010843,1008010843,1010010843,1002020843,1004020843,1006020843,1008020843,1010020843,1002030843,1004030843,1006030843,1008030843,1010030843,1002040843,1004040843,1006040843,1008040843,1010040843]','[]','[]','[{0,1010030853,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280510,4}]',150),(33090901,'武器','9阶粉色武器【魔导师】',2,'[{lv,300}]',3,'[{0,38280520,6}]','[1001010943,1007010943,1001020943,1007020943,1001030943,1007030943,1001040943,1007040943]','[]','[]','[{0,1001030953,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280520,6}]',150),(33090902,'头盔','9阶粉色头盔【魔导师】',2,'[{lv,300}]',3,'[{0,38280510,6}]','[1002010943,1004010943,1006010943,1008010943,1010010943,1002020943,1004020943,1006020943,1008020943,1010020943,1002030943,1004030943,1006030943,1008030943,1010030943,1002040943,1004040943,1006040943,1008040943,1010040943]','[]','[]','[{0,1002030953,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280510,6}]',150),(33090903,'项链','9阶粉色项链【通用】',2,'[{lv,300}]',3,'[{0,38280520,6}]','[1003000943,1003000943,1003000943,1003000943]','[]','[]','[{0,1003000953,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280520,6}]',150),(33090904,'衣服','9阶粉色衣服【魔导师】',2,'[{lv,300}]',3,'[{0,38280510,6}]','[1002010943,1004010943,1006010943,1008010943,1010010943,1002020943,1004020943,1006020943,1008020943,1010020943,1002030943,1004030943,1006030943,1008030943,1010030943,1002040943,1004040943,1006040943,1008040943,1010040943]','[]','[]','[{0,1004030953,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280510,6}]',150),(33090905,'刻痕','9阶粉色刻痕【通用】',2,'[{lv,300}]',3,'[{0,38280520,6}]','[1005000943,1009000943,1005000943,1009000943,1005000943,1009000943,1005000943,1009000943]','[]','[]','[{0,1005000953,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280520,6}]',150),(33090906,'裤子','9阶粉色裤子【魔导师】',2,'[{lv,300}]',3,'[{0,38280510,6}]','[1002010943,1004010943,1006010943,1008010943,1010010943,1002020943,1004020943,1006020943,1008020943,1010020943,1002030943,1004030943,1006030943,1008030943,1010030943,1002040943,1004040943,1006040943,1008040943,1010040943]','[]','[]','[{0,1006030953,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280510,6}]',150),(33090907,'副手','9阶粉色副手【魔导师】',2,'[{lv,300}]',3,'[{0,38280520,6}]','[1001010943,1007010943,1001020943,1007020943,1001030943,1007030943,1001040943,1007040943]','[]','[]','[{0,1007030953,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280520,6}]',150),(33090908,'护腕','9阶粉色护腕【魔导师】',2,'[{lv,300}]',3,'[{0,38280510,6}]','[1002010943,1004010943,1006010943,1008010943,1010010943,1002020943,1004020943,1006020943,1008020943,1010020943,1002030943,1004030943,1006030943,1008030943,1010030943,1002040943,1004040943,1006040943,1008040943,1010040943]','[]','[]','[{0,1008030953,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280510,6}]',150),(33090909,'戒指','9阶粉色戒指【通用】',2,'[{lv,300}]',3,'[{0,38280520,6}]','[1005000943,1009000943,1005000943,1009000943,1005000943,1009000943,1005000943,1009000943]','[]','[]','[{0,1009000953,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280520,6}]',150),(33090910,'鞋子','9阶粉色鞋子【魔导师】',2,'[{lv,300}]',3,'[{0,38280510,6}]','[1002010943,1004010943,1006010943,1008010943,1010010943,1002020943,1004020943,1006020943,1008020943,1010020943,1002030943,1004030943,1006030943,1008030943,1010030943,1002040943,1004040943,1006040943,1008040943,1010040943]','[]','[]','[{0,1010030953,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280510,6}]',150),(33091001,'武器','10阶粉色武器【魔导师】',2,'[{lv,355}]',3,'[{0,38280520,8}]','[1001011043,1007011043,1001021043,1007021043,1001031043,1007031043,1001041043,1007041043]','[]','[]','[{0,1001031053,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,8}]',150),(33091002,'头盔','10阶粉色头盔【魔导师】',2,'[{lv,355}]',3,'[{0,38280510,8}]','[1002011043,1004011043,1006011043,1008011043,1010011043,1002021043,1004021043,1006021043,1008021043,1010021043,1002031043,1004031043,1006031043,1008031043,1010031043,1002041043,1004041043,1006041043,1008041043,1010041043]','[]','[]','[{0,1002031053,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,8}]',150),(33091003,'项链','10阶粉色项链【通用】',2,'[{lv,355}]',3,'[{0,38280520,8}]','[1003001043,1003001043,1003001043,1003001043]','[]','[]','[{0,1003001053,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,8}]',150),(33091004,'衣服','10阶粉色衣服【魔导师】',2,'[{lv,355}]',3,'[{0,38280510,8}]','[1002011043,1004011043,1006011043,1008011043,1010011043,1002021043,1004021043,1006021043,1008021043,1010021043,1002031043,1004031043,1006031043,1008031043,1010031043,1002041043,1004041043,1006041043,1008041043,1010041043]','[]','[]','[{0,1004031053,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,8}]',150),(33091005,'刻痕','10阶粉色刻痕【通用】',2,'[{lv,355}]',3,'[{0,38280520,8}]','[1005001043,1009001043,1005001043,1009001043,1005001043,1009001043,1005001043,1009001043]','[]','[]','[{0,1005001053,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,8}]',150),(33091006,'裤子','10阶粉色裤子【魔导师】',2,'[{lv,355}]',3,'[{0,38280510,8}]','[1002011043,1004011043,1006011043,1008011043,1010011043,1002021043,1004021043,1006021043,1008021043,1010021043,1002031043,1004031043,1006031043,1008031043,1010031043,1002041043,1004041043,1006041043,1008041043,1010041043]','[]','[]','[{0,1006031053,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,8}]',150),(33091007,'副手','10阶粉色副手【魔导师】',2,'[{lv,355}]',3,'[{0,38280520,8}]','[1001011043,1007011043,1001021043,1007021043,1001031043,1007031043,1001041043,1007041043]','[]','[]','[{0,1007031053,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,8}]',150),(33091008,'护腕','10阶粉色护腕【魔导师】',2,'[{lv,355}]',3,'[{0,38280510,8}]','[1002011043,1004011043,1006011043,1008011043,1010011043,1002021043,1004021043,1006021043,1008021043,1010021043,1002031043,1004031043,1006031043,1008031043,1010031043,1002041043,1004041043,1006041043,1008041043,1010041043]','[]','[]','[{0,1008031053,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,8}]',150),(33091009,'戒指','10阶粉色戒指【通用】',2,'[{lv,355}]',3,'[{0,38280520,8}]','[1005001043,1009001043,1005001043,1009001043,1005001043,1009001043,1005001043,1009001043]','[]','[]','[{0,1009001053,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,8}]',150),(33091010,'鞋子','10阶粉色鞋子【魔导师】',2,'[{lv,355}]',3,'[{0,38280510,8}]','[1002011043,1004011043,1006011043,1008011043,1010011043,1002021043,1004021043,1006021043,1008021043,1010021043,1002031043,1004031043,1006031043,1008031043,1010031043,1002041043,1004041043,1006041043,1008041043,1010041043]','[]','[]','[{0,1010031053,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,8}]',150),(33091101,'武器','11阶粉色武器【魔导师】',2,'[{lv,400}]',3,'[{0,38280520,12}]','[1001011143,1007011143,1001021143,1007021143,1001031143,1007031143,1001041143,1007041143]','[]','[]','[{0,1001031153,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,12}]',150),(33091102,'头盔','11阶粉色头盔【魔导师】',2,'[{lv,400}]',3,'[{0,38280510,12}]','[1002011143,1004011143,1006011143,1008011143,1010011143,1002021143,1004021143,1006021143,1008021143,1010021143,1002031143,1004031143,1006031143,1008031143,1010031143,1002041143,1004041143,1006041143,1008041143,1010041143]','[]','[]','[{0,1002031153,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,12}]',150),(33091103,'项链','11阶粉色项链【通用】',2,'[{lv,400}]',3,'[{0,38280520,12}]','[1003001143,1003001143,1003001143,1003001143]','[]','[]','[{0,1003001153,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,12}]',150),(33091104,'衣服','11阶粉色衣服【魔导师】',2,'[{lv,400}]',3,'[{0,38280510,12}]','[1002011143,1004011143,1006011143,1008011143,1010011143,1002021143,1004021143,1006021143,1008021143,1010021143,1002031143,1004031143,1006031143,1008031143,1010031143,1002041143,1004041143,1006041143,1008041143,1010041143]','[]','[]','[{0,1004031153,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,12}]',150),(33091105,'刻痕','11阶粉色刻痕【通用】',2,'[{lv,400}]',3,'[{0,38280520,12}]','[1005001143,1009001143,1005001143,1009001143,1005001143,1009001143,1005001143,1009001143]','[]','[]','[{0,1005001153,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,12}]',150),(33091106,'裤子','11阶粉色裤子【魔导师】',2,'[{lv,400}]',3,'[{0,38280510,12}]','[1002011143,1004011143,1006011143,1008011143,1010011143,1002021143,1004021143,1006021143,1008021143,1010021143,1002031143,1004031143,1006031143,1008031143,1010031143,1002041143,1004041143,1006041143,1008041143,1010041143]','[]','[]','[{0,1006031153,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,12}]',150),(33091107,'副手','11阶粉色副手【魔导师】',2,'[{lv,400}]',3,'[{0,38280520,12}]','[1001011143,1007011143,1001021143,1007021143,1001031143,1007031143,1001041143,1007041143]','[]','[]','[{0,1007031153,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,12}]',150),(33091108,'护腕','11阶粉色护腕【魔导师】',2,'[{lv,400}]',3,'[{0,38280510,12}]','[1002011143,1004011143,1006011143,1008011143,1010011143,1002021143,1004021143,1006021143,1008021143,1010021143,1002031143,1004031143,1006031143,1008031143,1010031143,1002041143,1004041143,1006041143,1008041143,1010041143]','[]','[]','[{0,1008031153,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,12}]',150),(33091109,'戒指','11阶粉色戒指【通用】',2,'[{lv,400}]',3,'[{0,38280520,12}]','[1005001143,1009001143,1005001143,1009001143,1005001143,1009001143,1005001143,1009001143]','[]','[]','[{0,1009001153,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,12}]',150),(33091110,'鞋子','11阶粉色鞋子【魔导师】',2,'[{lv,400}]',3,'[{0,38280510,12}]','[1002011143,1004011143,1006011143,1008011143,1010011143,1002021143,1004021143,1006021143,1008021143,1010021143,1002031143,1004031143,1006031143,1008031143,1010031143,1002041143,1004041143,1006041143,1008041143,1010041143]','[]','[]','[{0,1010031153,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,12}]',150),(33091201,'武器','12阶粉色武器【魔导师】',2,'[{lv,500}]',3,'[{0,38280520,16}]','[1001011243,1007011243,1001021243,1007021243,1001031243,1007031243,1001041243,1007041243]','[]','[]','[{0,1001031253,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,16}]',150),(33091202,'头盔','12阶粉色头盔【魔导师】',2,'[{lv,500}]',3,'[{0,38280510,16}]','[1002011243,1004011243,1006011243,1008011243,1010011243,1002021243,1004021243,1006021243,1008021243,1010021243,1002031243,1004031243,1006031243,1008031243,1010031243,1002041243,1004041243,1006041243,1008041243,1010041243]','[]','[]','[{0,1002031253,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,16}]',150),(33091203,'项链','12阶粉色项链【通用】',2,'[{lv,500}]',3,'[{0,38280520,16}]','[1003001243,1003001243,1003001243,1003001243]','[]','[]','[{0,1003001253,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,16}]',150),(33091204,'衣服','12阶粉色衣服【魔导师】',2,'[{lv,500}]',3,'[{0,38280510,16}]','[1002011243,1004011243,1006011243,1008011243,1010011243,1002021243,1004021243,1006021243,1008021243,1010021243,1002031243,1004031243,1006031243,1008031243,1010031243,1002041243,1004041243,1006041243,1008041243,1010041243]','[]','[]','[{0,1004031253,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,16}]',150),(33091205,'刻痕','12阶粉色刻痕【通用】',2,'[{lv,500}]',3,'[{0,38280520,16}]','[1005001243,1009001243,1005001243,1009001243,1005001243,1009001243,1005001243,1009001243]','[]','[]','[{0,1005001253,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,16}]',150),(33091206,'裤子','12阶粉色裤子【魔导师】',2,'[{lv,500}]',3,'[{0,38280510,16}]','[1002011243,1004011243,1006011243,1008011243,1010011243,1002021243,1004021243,1006021243,1008021243,1010021243,1002031243,1004031243,1006031243,1008031243,1010031243,1002041243,1004041243,1006041243,1008041243,1010041243]','[]','[]','[{0,1006031253,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,16}]',150),(33091207,'副手','12阶粉色副手【魔导师】',2,'[{lv,500}]',3,'[{0,38280520,16}]','[1001011243,1007011243,1001021243,1007021243,1001031243,1007031243,1001041243,1007041243]','[]','[]','[{0,1007031253,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,16}]',150),(33091208,'护腕','12阶粉色护腕【魔导师】',2,'[{lv,500}]',3,'[{0,38280510,16}]','[1002011243,1004011243,1006011243,1008011243,1010011243,1002021243,1004021243,1006021243,1008021243,1010021243,1002031243,1004031243,1006031243,1008031243,1010031243,1002041243,1004041243,1006041243,1008041243,1010041243]','[]','[]','[{0,1008031253,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,16}]',150),(33091209,'戒指','12阶粉色戒指【通用】',2,'[{lv,500}]',3,'[{0,38280520,16}]','[1005001243,1009001243,1005001243,1009001243,1005001243,1009001243,1005001243,1009001243]','[]','[]','[{0,1009001253,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,16}]',150),(33091210,'鞋子','12阶粉色鞋子【魔导师】',2,'[{lv,500}]',3,'[{0,38280510,16}]','[1002011243,1004011243,1006011243,1008011243,1010011243,1002021243,1004021243,1006021243,1008021243,1010021243,1002031243,1004031243,1006031243,1008031243,1010031243,1002041243,1004041243,1006041243,1008041243,1010041243]','[]','[]','[{0,1010031253,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,16}]',150),(33091301,'武器','13阶粉色武器【魔导师】',2,'[{lv,520}]',3,'[{0,38280520,20}]','[1001011343,1007011343,1001021343,1007021343,1001031343,1007031343,1001041343,1007041343]','[]','[]','[{0,1001031353,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,20}]',150),(33091302,'头盔','13阶粉色头盔【魔导师】',2,'[{lv,520}]',3,'[{0,38280510,20}]','[1002011343,1004011343,1006011343,1008011343,1010011343,1002021343,1004021343,1006021343,1008021343,1010021343,1002031343,1004031343,1006031343,1008031343,1010031343,1002041343,1004041343,1006041343,1008041343,1010041343]','[]','[]','[{0,1002031353,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,20}]',150),(33091303,'项链','13阶粉色项链【通用】',2,'[{lv,520}]',3,'[{0,38280520,20}]','[1003001343,1003001343,1003001343,1003001343]','[]','[]','[{0,1003001353,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,20}]',150),(33091304,'衣服','13阶粉色衣服【魔导师】',2,'[{lv,520}]',3,'[{0,38280510,20}]','[1002011343,1004011343,1006011343,1008011343,1010011343,1002021343,1004021343,1006021343,1008021343,1010021343,1002031343,1004031343,1006031343,1008031343,1010031343,1002041343,1004041343,1006041343,1008041343,1010041343]','[]','[]','[{0,1004031353,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,20}]',150),(33091305,'刻痕','13阶粉色刻痕【通用】',2,'[{lv,520}]',3,'[{0,38280520,20}]','[1005001343,1009001343,1005001343,1009001343,1005001343,1009001343,1005001343,1009001343]','[]','[]','[{0,1005001353,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,20}]',150),(33091306,'裤子','13阶粉色裤子【魔导师】',2,'[{lv,520}]',3,'[{0,38280510,20}]','[1002011343,1004011343,1006011343,1008011343,1010011343,1002021343,1004021343,1006021343,1008021343,1010021343,1002031343,1004031343,1006031343,1008031343,1010031343,1002041343,1004041343,1006041343,1008041343,1010041343]','[]','[]','[{0,1006031353,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,20}]',150),(33091307,'副手','13阶粉色副手【魔导师】',2,'[{lv,520}]',3,'[{0,38280520,20}]','[1001011343,1007011343,1001021343,1007021343,1001031343,1007031343,1001041343,1007041343]','[]','[]','[{0,1007031353,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,20}]',150),(33091308,'护腕','13阶粉色护腕【魔导师】',2,'[{lv,520}]',3,'[{0,38280510,20}]','[1002011343,1004011343,1006011343,1008011343,1010011343,1002021343,1004021343,1006021343,1008021343,1010021343,1002031343,1004031343,1006031343,1008031343,1010031343,1002041343,1004041343,1006041343,1008041343,1010041343]','[]','[]','[{0,1008031353,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,20}]',150),(33091309,'戒指','13阶粉色戒指【通用】',2,'[{lv,520}]',3,'[{0,38280520,20}]','[1005001343,1009001343,1005001343,1009001343,1005001343,1009001343,1005001343,1009001343]','[]','[]','[{0,1009001353,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,20}]',150),(33091310,'鞋子','13阶粉色鞋子【魔导师】',2,'[{lv,520}]',3,'[{0,38280510,20}]','[1002011343,1004011343,1006011343,1008011343,1010011343,1002021343,1004021343,1006021343,1008021343,1010021343,1002031343,1004031343,1006031343,1008031343,1010031343,1002041343,1004041343,1006041343,1008041343,1010041343]','[]','[]','[{0,1010031353,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,20}]',150),(33091401,'武器','14阶粉色武器【魔导师】',2,'[{lv,620}]',3,'[{0,38280520,25}]','[1001011443,1007011443,1001021443,1007021443,1001031443,1007031443,1001041443,1007041443]','[]','[]','[{0,1001031453,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,25}]',150),(33091402,'头盔','14阶粉色头盔【魔导师】',2,'[{lv,620}]',3,'[{0,38280510,25}]','[1002011443,1004011443,1006011443,1008011443,1010011443,1002021443,1004021443,1006021443,1008021443,1010021443,1002031443,1004031443,1006031443,1008031443,1010031443,1002041443,1004041443,1006041443,1008041443,1010041443]','[]','[]','[{0,1002031453,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,25}]',150),(33091403,'项链','14阶粉色项链【通用】',2,'[{lv,620}]',3,'[{0,38280520,25}]','[1003001443,1003001443,1003001443,1003001443]','[]','[]','[{0,1003001453,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,25}]',150),(33091404,'衣服','14阶粉色衣服【魔导师】',2,'[{lv,620}]',3,'[{0,38280510,25}]','[1002011443,1004011443,1006011443,1008011443,1010011443,1002021443,1004021443,1006021443,1008021443,1010021443,1002031443,1004031443,1006031443,1008031443,1010031443,1002041443,1004041443,1006041443,1008041443,1010041443]','[]','[]','[{0,1004031453,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,25}]',150),(33091405,'刻痕','14阶粉色刻痕【通用】',2,'[{lv,620}]',3,'[{0,38280520,25}]','[1005001443,1009001443,1005001443,1009001443,1005001443,1009001443,1005001443,1009001443]','[]','[]','[{0,1005001453,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,25}]',150),(33091406,'裤子','14阶粉色裤子【魔导师】',2,'[{lv,620}]',3,'[{0,38280510,25}]','[1002011443,1004011443,1006011443,1008011443,1010011443,1002021443,1004021443,1006021443,1008021443,1010021443,1002031443,1004031443,1006031443,1008031443,1010031443,1002041443,1004041443,1006041443,1008041443,1010041443]','[]','[]','[{0,1006031453,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,25}]',150),(33091407,'副手','14阶粉色副手【魔导师】',2,'[{lv,620}]',3,'[{0,38280520,25}]','[1001011443,1007011443,1001021443,1007021443,1001031443,1007031443,1001041443,1007041443]','[]','[]','[{0,1007031453,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,25}]',150),(33091408,'护腕','14阶粉色护腕【魔导师】',2,'[{lv,620}]',3,'[{0,38280510,25}]','[1002011443,1004011443,1006011443,1008011443,1010011443,1002021443,1004021443,1006021443,1008021443,1010021443,1002031443,1004031443,1006031443,1008031443,1010031443,1002041443,1004041443,1006041443,1008041443,1010041443]','[]','[]','[{0,1008031453,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,25}]',150),(33091409,'戒指','14阶粉色戒指【通用】',2,'[{lv,620}]',3,'[{0,38280520,25}]','[1005001443,1009001443,1005001443,1009001443,1005001443,1009001443,1005001443,1009001443]','[]','[]','[{0,1009001453,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,25}]',150),(33091410,'鞋子','14阶粉色鞋子【魔导师】',2,'[{lv,620}]',3,'[{0,38280510,25}]','[1002011443,1004011443,1006011443,1008011443,1010011443,1002021443,1004021443,1006021443,1008021443,1010021443,1002031443,1004031443,1006031443,1008031443,1010031443,1002041443,1004041443,1006041443,1008041443,1010041443]','[]','[]','[{0,1010031453,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,25}]',150),(33091501,'武器','15阶粉色武器【魔导师】',2,'[{lv,650}]',3,'[{0,38280520,30}]','[1001011543,1007011543,1001021543,1007021543,1001031543,1007031543,1001041543,1007041543]','[]','[]','[{0,1001031553,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,30}]',150),(33091502,'头盔','15阶粉色头盔【魔导师】',2,'[{lv,650}]',3,'[{0,38280510,30}]','[1002011543,1004011543,1006011543,1008011543,1010011543,1002021543,1004021543,1006021543,1008021543,1010021543,1002031543,1004031543,1006031543,1008031543,1010031543,1002041543,1004041543,1006041543,1008041543,1010041543]','[]','[]','[{0,1002031553,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,30}]',150),(33091503,'项链','15阶粉色项链【通用】',2,'[{lv,650}]',3,'[{0,38280520,30}]','[1003001543,1003001543,1003001543,1003001543]','[]','[]','[{0,1003001553,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,30}]',150),(33091504,'衣服','15阶粉色衣服【魔导师】',2,'[{lv,650}]',3,'[{0,38280510,30}]','[1002011543,1004011543,1006011543,1008011543,1010011543,1002021543,1004021543,1006021543,1008021543,1010021543,1002031543,1004031543,1006031543,1008031543,1010031543,1002041543,1004041543,1006041543,1008041543,1010041543]','[]','[]','[{0,1004031553,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,30}]',150),(33091505,'刻痕','15阶粉色刻痕【通用】',2,'[{lv,650}]',3,'[{0,38280520,30}]','[1005001543,1009001543,1005001543,1009001543,1005001543,1009001543,1005001543,1009001543]','[]','[]','[{0,1005001553,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,30}]',150),(33091506,'裤子','15阶粉色裤子【魔导师】',2,'[{lv,650}]',3,'[{0,38280510,30}]','[1002011543,1004011543,1006011543,1008011543,1010011543,1002021543,1004021543,1006021543,1008021543,1010021543,1002031543,1004031543,1006031543,1008031543,1010031543,1002041543,1004041543,1006041543,1008041543,1010041543]','[]','[]','[{0,1006031553,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,30}]',150),(33091507,'副手','15阶粉色副手【魔导师】',2,'[{lv,650}]',3,'[{0,38280520,30}]','[1001011543,1007011543,1001021543,1007021543,1001031543,1007031543,1001041543,1007041543]','[]','[]','[{0,1007031553,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,30}]',150),(33091508,'护腕','15阶粉色护腕【魔导师】',2,'[{lv,650}]',3,'[{0,38280510,30}]','[1002011543,1004011543,1006011543,1008011543,1010011543,1002021543,1004021543,1006021543,1008021543,1010021543,1002031543,1004031543,1006031543,1008031543,1010031543,1002041543,1004041543,1006041543,1008041543,1010041543]','[]','[]','[{0,1008031553,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,30}]',150),(33091509,'戒指','15阶粉色戒指【通用】',2,'[{lv,650}]',3,'[{0,38280520,30}]','[1005001543,1009001543,1005001543,1009001543,1005001543,1009001543,1005001543,1009001543]','[]','[]','[{0,1009001553,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,30}]',150),(33091510,'鞋子','15阶粉色鞋子【魔导师】',2,'[{lv,650}]',3,'[{0,38280510,30}]','[1002011543,1004011543,1006011543,1008011543,1010011543,1002021543,1004021543,1006021543,1008021543,1010021543,1002031543,1004031543,1006031543,1008031543,1010031543,1002041543,1004041543,1006041543,1008041543,1010041543]','[]','[]','[{0,1010031553,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,30}]',150),(33091601,'武器','16阶粉色武器【魔导师】',2,'[{lv,700}]',3,'[{0,38280520,35}]','[1001011643,1007011643,1001021643,1007021643,1001031643,1007031643,1001041643,1007041643]','[]','[]','[{0,1001031653,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,35}]',150),(33091602,'头盔','16阶粉色头盔【魔导师】',2,'[{lv,700}]',3,'[{0,38280510,35}]','[1002011643,1004011643,1006011643,1008011643,1010011643,1002021643,1004021643,1006021643,1008021643,1010021643,1002031643,1004031643,1006031643,1008031643,1010031643,1002041643,1004041643,1006041643,1008041643,1010041643]','[]','[]','[{0,1002031653,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,35}]',150),(33091603,'项链','16阶粉色项链【通用】',2,'[{lv,700}]',3,'[{0,38280520,35}]','[1003001643,1003001643,1003001643,1003001643]','[]','[]','[{0,1003001653,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,35}]',150),(33091604,'衣服','16阶粉色衣服【魔导师】',2,'[{lv,700}]',3,'[{0,38280510,35}]','[1002011643,1004011643,1006011643,1008011643,1010011643,1002021643,1004021643,1006021643,1008021643,1010021643,1002031643,1004031643,1006031643,1008031643,1010031643,1002041643,1004041643,1006041643,1008041643,1010041643]','[]','[]','[{0,1004031653,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,35}]',150),(33091605,'刻痕','16阶粉色刻痕【通用】',2,'[{lv,700}]',3,'[{0,38280520,35}]','[1005001643,1009001643,1005001643,1009001643,1005001643,1009001643,1005001643,1009001643]','[]','[]','[{0,1005001653,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,35}]',150),(33091606,'裤子','16阶粉色裤子【魔导师】',2,'[{lv,700}]',3,'[{0,38280510,35}]','[1002011643,1004011643,1006011643,1008011643,1010011643,1002021643,1004021643,1006021643,1008021643,1010021643,1002031643,1004031643,1006031643,1008031643,1010031643,1002041643,1004041643,1006041643,1008041643,1010041643]','[]','[]','[{0,1006031653,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,35}]',150),(33091607,'副手','16阶粉色副手【魔导师】',2,'[{lv,700}]',3,'[{0,38280520,35}]','[1001011643,1007011643,1001021643,1007021643,1001031643,1007031643,1001041643,1007041643]','[]','[]','[{0,1007031653,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,35}]',150),(33091608,'护腕','16阶粉色护腕【魔导师】',2,'[{lv,700}]',3,'[{0,38280510,35}]','[1002011643,1004011643,1006011643,1008011643,1010011643,1002021643,1004021643,1006021643,1008021643,1010021643,1002031643,1004031643,1006031643,1008031643,1010031643,1002041643,1004041643,1006041643,1008041643,1010041643]','[]','[]','[{0,1008031653,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,35}]',150),(33091609,'戒指','16阶粉色戒指【通用】',2,'[{lv,700}]',3,'[{0,38280520,35}]','[1005001643,1009001643,1005001643,1009001643,1005001643,1009001643,1005001643,1009001643]','[]','[]','[{0,1009001653,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,35}]',150),(33091610,'鞋子','16阶粉色鞋子【魔导师】',2,'[{lv,700}]',3,'[{0,38280510,35}]','[1002011643,1004011643,1006011643,1008011643,1010011643,1002021643,1004021643,1006021643,1008021643,1010021643,1002031643,1004031643,1006031643,1008031643,1010031643,1002041643,1004041643,1006041643,1008041643,1010041643]','[]','[]','[{0,1010031653,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,35}]',150),(33100301,'武器','3阶神装武器【魔导师】',2,'[{lv,9999}]',3,'[{0,38280620,2}]','[1001010263,1007010263,1001020263,1007020263,1001030263,1007030263,1001040263,1007040263]','[]','[]','[{0,1001030363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100302,'头盔','3阶神装头盔【魔导师】',2,'[{lv,9999}]',3,'[{0,38280620,2}]','[1002010263,1004010263,1006010263,1008010263,1010010263,1002020263,1004020263,1006020263,1008020263,1010020263,1002030263,1004030263,1006030263,1008030263,1010030263,1002040263,1004040263,1006040263,1008040263,1010040263]','[]','[]','[{0,1002030363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100303,'项链','3阶神装项链【通用】',2,'[{lv,9999}]',3,'[{0,38280620,2}]','[1003000263,1003000263,1003000263,1003000263]','[]','[]','[{0,1003000363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100304,'衣服','3阶神装衣服【魔导师】',2,'[{lv,9999}]',3,'[{0,38280620,2}]','[1002010263,1004010263,1006010263,1008010263,1010010263,1002020263,1004020263,1006020263,1008020263,1010020263,1002030263,1004030263,1006030263,1008030263,1010030263,1002040263,1004040263,1006040263,1008040263,1010040263]','[]','[]','[{0,1004030363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100305,'刻痕','3阶神装刻痕【通用】',2,'[{lv,9999}]',3,'[{0,38280620,2}]','[1005000263,1009000263,1005000263,1009000263,1005000263,1009000263,1005000263,1009000263]','[]','[]','[{0,1005000363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100306,'裤子','3阶神装裤子【魔导师】',2,'[{lv,9999}]',3,'[{0,38280620,2}]','[1002010263,1004010263,1006010263,1008010263,1010010263,1002020263,1004020263,1006020263,1008020263,1010020263,1002030263,1004030263,1006030263,1008030263,1010030263,1002040263,1004040263,1006040263,1008040263,1010040263]','[]','[]','[{0,1006030363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100307,'副手','3阶神装副手【魔导师】',2,'[{lv,9999}]',3,'[{0,38280620,2}]','[1001010263,1007010263,1001020263,1007020263,1001030263,1007030263,1001040263,1007040263]','[]','[]','[{0,1007030363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100308,'护腕','3阶神装护腕【魔导师】',2,'[{lv,9999}]',3,'[{0,38280620,2}]','[1002010263,1004010263,1006010263,1008010263,1010010263,1002020263,1004020263,1006020263,1008020263,1010020263,1002030263,1004030263,1006030263,1008030263,1010030263,1002040263,1004040263,1006040263,1008040263,1010040263]','[]','[]','[{0,1008030363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100309,'戒指','3阶神装戒指【通用】',2,'[{lv,9999}]',3,'[{0,38280620,2}]','[1005000263,1009000263,1005000263,1009000263,1005000263,1009000263,1005000263,1009000263]','[]','[]','[{0,1009000363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100310,'鞋子','3阶神装鞋子【魔导师】',2,'[{lv,9999}]',3,'[{0,38280620,2}]','[1002010263,1004010263,1006010263,1008010263,1010010263,1002020263,1004020263,1006020263,1008020263,1010020263,1002030263,1004030263,1006030263,1008030263,1010030263,1002040263,1004040263,1006040263,1008040263,1010040263]','[]','[]','[{0,1010030363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100401,'武器','4阶神装武器【魔导师】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1001010363,1007010363,1001020363,1007020363,1001030363,1007030363,1001040363,1007040363]','[]','[]','[{0,1001030463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100402,'头盔','4阶神装头盔【魔导师】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1002010363,1004010363,1006010363,1008010363,1010010363,1002020363,1004020363,1006020363,1008020363,1010020363,1002030363,1004030363,1006030363,1008030363,1010030363,1002040363,1004040363,1006040363,1008040363,1010040363]','[]','[]','[{0,1002030463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100403,'项链','4阶神装项链【通用】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1003000363,1003000363,1003000363,1003000363]','[]','[]','[{0,1003000463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100404,'衣服','4阶神装衣服【魔导师】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1002010363,1004010363,1006010363,1008010363,1010010363,1002020363,1004020363,1006020363,1008020363,1010020363,1002030363,1004030363,1006030363,1008030363,1010030363,1002040363,1004040363,1006040363,1008040363,1010040363]','[]','[]','[{0,1004030463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100405,'刻痕','4阶神装刻痕【通用】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1005000363,1009000363,1005000363,1009000363,1005000363,1009000363,1005000363,1009000363]','[]','[]','[{0,1005000463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100406,'裤子','4阶神装裤子【魔导师】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1002010363,1004010363,1006010363,1008010363,1010010363,1002020363,1004020363,1006020363,1008020363,1010020363,1002030363,1004030363,1006030363,1008030363,1010030363,1002040363,1004040363,1006040363,1008040363,1010040363]','[]','[]','[{0,1006030463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100407,'副手','4阶神装副手【魔导师】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1001010363,1007010363,1001020363,1007020363,1001030363,1007030363,1001040363,1007040363]','[]','[]','[{0,1007030463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100408,'护腕','4阶神装护腕【魔导师】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1002010363,1004010363,1006010363,1008010363,1010010363,1002020363,1004020363,1006020363,1008020363,1010020363,1002030363,1004030363,1006030363,1008030363,1010030363,1002040363,1004040363,1006040363,1008040363,1010040363]','[]','[]','[{0,1008030463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100409,'戒指','4阶神装戒指【通用】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1005000363,1009000363,1005000363,1009000363,1005000363,1009000363,1005000363,1009000363]','[]','[]','[{0,1009000463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100410,'鞋子','4阶神装鞋子【魔导师】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1002010363,1004010363,1006010363,1008010363,1010010363,1002020363,1004020363,1006020363,1008020363,1010020363,1002030363,1004030363,1006030363,1008030363,1010030363,1002040363,1004040363,1006040363,1008040363,1010040363]','[]','[]','[{0,1010030463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100501,'武器','5阶神装武器【魔导师】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1001010463,1007010463,1001020463,1007020463,1001030463,1007030463,1001040463,1007040463]','[]','[]','[{0,1001030563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100502,'头盔','5阶神装头盔【魔导师】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1002010463,1004010463,1006010463,1008010463,1010010463,1002020463,1004020463,1006020463,1008020463,1010020463,1002030463,1004030463,1006030463,1008030463,1010030463,1002040463,1004040463,1006040463,1008040463,1010040463]','[]','[]','[{0,1002030563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100503,'项链','5阶神装项链【通用】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1003000463,1003000463,1003000463,1003000463]','[]','[]','[{0,1003000563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100504,'衣服','5阶神装衣服【魔导师】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1002010463,1004010463,1006010463,1008010463,1010010463,1002020463,1004020463,1006020463,1008020463,1010020463,1002030463,1004030463,1006030463,1008030463,1010030463,1002040463,1004040463,1006040463,1008040463,1010040463]','[]','[]','[{0,1004030563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100505,'刻痕','5阶神装刻痕【通用】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1005000463,1009000463,1005000463,1009000463,1005000463,1009000463,1005000463,1009000463]','[]','[]','[{0,1005000563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100506,'裤子','5阶神装裤子【魔导师】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1002010463,1004010463,1006010463,1008010463,1010010463,1002020463,1004020463,1006020463,1008020463,1010020463,1002030463,1004030463,1006030463,1008030463,1010030463,1002040463,1004040463,1006040463,1008040463,1010040463]','[]','[]','[{0,1006030563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100507,'副手','5阶神装副手【魔导师】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1001010463,1007010463,1001020463,1007020463,1001030463,1007030463,1001040463,1007040463]','[]','[]','[{0,1007030563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100508,'护腕','5阶神装护腕【魔导师】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1002010463,1004010463,1006010463,1008010463,1010010463,1002020463,1004020463,1006020463,1008020463,1010020463,1002030463,1004030463,1006030463,1008030463,1010030463,1002040463,1004040463,1006040463,1008040463,1010040463]','[]','[]','[{0,1008030563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100509,'戒指','5阶神装戒指【通用】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1005000463,1009000463,1005000463,1009000463,1005000463,1009000463,1005000463,1009000463]','[]','[]','[{0,1009000563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100510,'鞋子','5阶神装鞋子【魔导师】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1002010463,1004010463,1006010463,1008010463,1010010463,1002020463,1004020463,1006020463,1008020463,1010020463,1002030463,1004030463,1006030463,1008030463,1010030463,1002040463,1004040463,1006040463,1008040463,1010040463]','[]','[]','[{0,1010030563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100601,'武器','6阶神装武器【魔导师】',2,'[{lv,180}]',3,'[{0,38280620,2}]','[1001010563,1007010563,1001020563,1007020563,1001030563,1007030563,1001040563,1007040563]','[]','[]','[{0,1001030663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100602,'头盔','6阶神装头盔【魔导师】',2,'[{lv,180}]',3,'[{0,38280620,2}]','[1002010563,1004010563,1006010563,1008010563,1010010563,1002020563,1004020563,1006020563,1008020563,1010020563,1002030563,1004030563,1006030563,1008030563,1010030563,1002040563,1004040563,1006040563,1008040563,1010040563]','[]','[]','[{0,1002030663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100603,'项链','6阶神装项链【通用】',2,'[{lv,180}]',3,'[{0,38280620,2}]','[1003000563,1003000563,1003000563,1003000563]','[]','[]','[{0,1003000663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100604,'衣服','6阶神装衣服【魔导师】',2,'[{lv,180}]',3,'[{0,38280620,2}]','[1002010563,1004010563,1006010563,1008010563,1010010563,1002020563,1004020563,1006020563,1008020563,1010020563,1002030563,1004030563,1006030563,1008030563,1010030563,1002040563,1004040563,1006040563,1008040563,1010040563]','[]','[]','[{0,1004030663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100605,'刻痕','6阶神装刻痕【通用】',2,'[{lv,180}]',3,'[{0,38280620,2}]','[1005000563,1009000563,1005000563,1009000563,1005000563,1009000563,1005000563,1009000563]','[]','[]','[{0,1005000663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100606,'裤子','6阶神装裤子【魔导师】',2,'[{lv,180}]',3,'[{0,38280620,2}]','[1002010563,1004010563,1006010563,1008010563,1010010563,1002020563,1004020563,1006020563,1008020563,1010020563,1002030563,1004030563,1006030563,1008030563,1010030563,1002040563,1004040563,1006040563,1008040563,1010040563]','[]','[]','[{0,1006030663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100607,'副手','6阶神装副手【魔导师】',2,'[{lv,180}]',3,'[{0,38280620,2}]','[1001010563,1007010563,1001020563,1007020563,1001030563,1007030563,1001040563,1007040563]','[]','[]','[{0,1007030663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100608,'护腕','6阶神装护腕【魔导师】',2,'[{lv,180}]',3,'[{0,38280620,2}]','[1002010563,1004010563,1006010563,1008010563,1010010563,1002020563,1004020563,1006020563,1008020563,1010020563,1002030563,1004030563,1006030563,1008030563,1010030563,1002040563,1004040563,1006040563,1008040563,1010040563]','[]','[]','[{0,1008030663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100609,'戒指','6阶神装戒指【通用】',2,'[{lv,180}]',3,'[{0,38280620,2}]','[1005000563,1009000563,1005000563,1009000563,1005000563,1009000563,1005000563,1009000563]','[]','[]','[{0,1009000663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100610,'鞋子','6阶神装鞋子【魔导师】',2,'[{lv,180}]',3,'[{0,38280620,2}]','[1002010563,1004010563,1006010563,1008010563,1010010563,1002020563,1004020563,1006020563,1008020563,1010020563,1002030563,1004030563,1006030563,1008030563,1010030563,1002040563,1004040563,1006040563,1008040563,1010040563]','[]','[]','[{0,1010030663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100701,'武器','7阶神装武器【魔导师】',2,'[{lv,220}]',3,'[{0,38280620,2}]','[1001010663,1007010663,1001020663,1007020663,1001030663,1007030663,1001040663,1007040663]','[]','[]','[{0,1001030763,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100702,'头盔','7阶神装头盔【魔导师】',2,'[{lv,220}]',3,'[{0,38280620,2}]','[1002010663,1004010663,1006010663,1008010663,1010010663,1002020663,1004020663,1006020663,1008020663,1010020663,1002030663,1004030663,1006030663,1008030663,1010030663,1002040663,1004040663,1006040663,1008040663,1010040663]','[]','[]','[{0,1002030763,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100703,'项链','7阶神装项链【通用】',2,'[{lv,220}]',3,'[{0,38280620,2}]','[1003000663,1003000663,1003000663,1003000663]','[]','[]','[{0,1003000763,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100704,'衣服','7阶神装衣服【魔导师】',2,'[{lv,220}]',3,'[{0,38280620,2}]','[1002010663,1004010663,1006010663,1008010663,1010010663,1002020663,1004020663,1006020663,1008020663,1010020663,1002030663,1004030663,1006030663,1008030663,1010030663,1002040663,1004040663,1006040663,1008040663,1010040663]','[]','[]','[{0,1004030763,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100705,'刻痕','7阶神装刻痕【通用】',2,'[{lv,220}]',3,'[{0,38280620,2}]','[1005000663,1009000663,1005000663,1009000663,1005000663,1009000663,1005000663,1009000663]','[]','[]','[{0,1005000763,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100706,'裤子','7阶神装裤子【魔导师】',2,'[{lv,220}]',3,'[{0,38280620,2}]','[1002010663,1004010663,1006010663,1008010663,1010010663,1002020663,1004020663,1006020663,1008020663,1010020663,1002030663,1004030663,1006030663,1008030663,1010030663,1002040663,1004040663,1006040663,1008040663,1010040663]','[]','[]','[{0,1006030763,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100707,'副手','7阶神装副手【魔导师】',2,'[{lv,220}]',3,'[{0,38280620,2}]','[1001010663,1007010663,1001020663,1007020663,1001030663,1007030663,1001040663,1007040663]','[]','[]','[{0,1007030763,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100708,'护腕','7阶神装护腕【魔导师】',2,'[{lv,220}]',3,'[{0,38280620,2}]','[1002010663,1004010663,1006010663,1008010663,1010010663,1002020663,1004020663,1006020663,1008020663,1010020663,1002030663,1004030663,1006030663,1008030663,1010030663,1002040663,1004040663,1006040663,1008040663,1010040663]','[]','[]','[{0,1008030763,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100709,'戒指','7阶神装戒指【通用】',2,'[{lv,220}]',3,'[{0,38280620,2}]','[1005000663,1009000663,1005000663,1009000663,1005000663,1009000663,1005000663,1009000663]','[]','[]','[{0,1009000763,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100710,'鞋子','7阶神装鞋子【魔导师】',2,'[{lv,220}]',3,'[{0,38280620,2}]','[1002010663,1004010663,1006010663,1008010663,1010010663,1002020663,1004020663,1006020663,1008020663,1010020663,1002030663,1004030663,1006030663,1008030663,1010030663,1002040663,1004040663,1006040663,1008040663,1010040663]','[]','[]','[{0,1010030763,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100801,'武器','8阶神装武器【魔导师】',2,'[{lv,260}]',3,'[{0,38280620,2}]','[1001010763,1007010763,1001020763,1007020763,1001030763,1007030763,1001040763,1007040763]','[]','[]','[{0,1001030863,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100802,'头盔','8阶神装头盔【魔导师】',2,'[{lv,260}]',3,'[{0,38280620,2}]','[1002010763,1004010763,1006010763,1008010763,1010010763,1002020763,1004020763,1006020763,1008020763,1010020763,1002030763,1004030763,1006030763,1008030763,1010030763,1002040763,1004040763,1006040763,1008040763,1010040763]','[]','[]','[{0,1002030863,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100803,'项链','8阶神装项链【通用】',2,'[{lv,260}]',3,'[{0,38280620,2}]','[1003000763,1003000763,1003000763,1003000763]','[]','[]','[{0,1003000863,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100804,'衣服','8阶神装衣服【魔导师】',2,'[{lv,260}]',3,'[{0,38280620,2}]','[1002010763,1004010763,1006010763,1008010763,1010010763,1002020763,1004020763,1006020763,1008020763,1010020763,1002030763,1004030763,1006030763,1008030763,1010030763,1002040763,1004040763,1006040763,1008040763,1010040763]','[]','[]','[{0,1004030863,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100805,'刻痕','8阶神装刻痕【通用】',2,'[{lv,260}]',3,'[{0,38280620,2}]','[1005000763,1009000763,1005000763,1009000763,1005000763,1009000763,1005000763,1009000763]','[]','[]','[{0,1005000863,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100806,'裤子','8阶神装裤子【魔导师】',2,'[{lv,260}]',3,'[{0,38280620,2}]','[1002010763,1004010763,1006010763,1008010763,1010010763,1002020763,1004020763,1006020763,1008020763,1010020763,1002030763,1004030763,1006030763,1008030763,1010030763,1002040763,1004040763,1006040763,1008040763,1010040763]','[]','[]','[{0,1006030863,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100807,'副手','8阶神装副手【魔导师】',2,'[{lv,260}]',3,'[{0,38280620,2}]','[1001010763,1007010763,1001020763,1007020763,1001030763,1007030763,1001040763,1007040763]','[]','[]','[{0,1007030863,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100808,'护腕','8阶神装护腕【魔导师】',2,'[{lv,260}]',3,'[{0,38280620,2}]','[1002010763,1004010763,1006010763,1008010763,1010010763,1002020763,1004020763,1006020763,1008020763,1010020763,1002030763,1004030763,1006030763,1008030763,1010030763,1002040763,1004040763,1006040763,1008040763,1010040763]','[]','[]','[{0,1008030863,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100809,'戒指','8阶神装戒指【通用】',2,'[{lv,260}]',3,'[{0,38280620,2}]','[1005000763,1009000763,1005000763,1009000763,1005000763,1009000763,1005000763,1009000763]','[]','[]','[{0,1009000863,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100810,'鞋子','8阶神装鞋子【魔导师】',2,'[{lv,260}]',3,'[{0,38280620,2}]','[1002010763,1004010763,1006010763,1008010763,1010010763,1002020763,1004020763,1006020763,1008020763,1010020763,1002030763,1004030763,1006030763,1008030763,1010030763,1002040763,1004040763,1006040763,1008040763,1010040763]','[]','[]','[{0,1010030863,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100901,'武器','9阶神装武器【魔导师】',2,'[{lv,300}]',3,'[{0,38280620,2}]','[1001010863,1007010863,1001020863,1007020863,1001030863,1007030863,1001040863,1007040863]','[]','[]','[{0,1001030963,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100902,'头盔','9阶神装头盔【魔导师】',2,'[{lv,300}]',3,'[{0,38280620,2}]','[1002010863,1004010863,1006010863,1008010863,1010010863,1002020863,1004020863,1006020863,1008020863,1010020863,1002030863,1004030863,1006030863,1008030863,1010030863,1002040863,1004040863,1006040863,1008040863,1010040863]','[]','[]','[{0,1002030963,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100903,'项链','9阶神装项链【通用】',2,'[{lv,300}]',3,'[{0,38280620,2}]','[1003000863,1003000863,1003000863,1003000863]','[]','[]','[{0,1003000963,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100904,'衣服','9阶神装衣服【魔导师】',2,'[{lv,300}]',3,'[{0,38280620,2}]','[1002010863,1004010863,1006010863,1008010863,1010010863,1002020863,1004020863,1006020863,1008020863,1010020863,1002030863,1004030863,1006030863,1008030863,1010030863,1002040863,1004040863,1006040863,1008040863,1010040863]','[]','[]','[{0,1004030963,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100905,'刻痕','9阶神装刻痕【通用】',2,'[{lv,300}]',3,'[{0,38280620,2}]','[1005000863,1009000863,1005000863,1009000863,1005000863,1009000863,1005000863,1009000863]','[]','[]','[{0,1005000963,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100906,'裤子','9阶神装裤子【魔导师】',2,'[{lv,300}]',3,'[{0,38280620,2}]','[1002010863,1004010863,1006010863,1008010863,1010010863,1002020863,1004020863,1006020863,1008020863,1010020863,1002030863,1004030863,1006030863,1008030863,1010030863,1002040863,1004040863,1006040863,1008040863,1010040863]','[]','[]','[{0,1006030963,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100907,'副手','9阶神装副手【魔导师】',2,'[{lv,300}]',3,'[{0,38280620,2}]','[1001010863,1007010863,1001020863,1007020863,1001030863,1007030863,1001040863,1007040863]','[]','[]','[{0,1007030963,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100908,'护腕','9阶神装护腕【魔导师】',2,'[{lv,300}]',3,'[{0,38280620,2}]','[1002010863,1004010863,1006010863,1008010863,1010010863,1002020863,1004020863,1006020863,1008020863,1010020863,1002030863,1004030863,1006030863,1008030863,1010030863,1002040863,1004040863,1006040863,1008040863,1010040863]','[]','[]','[{0,1008030963,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100909,'戒指','9阶神装戒指【通用】',2,'[{lv,300}]',3,'[{0,38280620,2}]','[1005000863,1009000863,1005000863,1009000863,1005000863,1009000863,1005000863,1009000863]','[]','[]','[{0,1009000963,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33100910,'鞋子','9阶神装鞋子【魔导师】',2,'[{lv,300}]',3,'[{0,38280620,2}]','[1002010863,1004010863,1006010863,1008010863,1010010863,1002020863,1004020863,1006020863,1008020863,1010020863,1002030863,1004030863,1006030863,1008030863,1010030863,1002040863,1004040863,1006040863,1008040863,1010040863]','[]','[]','[{0,1010030963,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101001,'武器','10阶神装武器【魔导师】',2,'[{lv,355}]',3,'[{0,38280620,2}]','[1001010963,1007010963,1001020963,1007020963,1001030963,1007030963,1001040963,1007040963]','[]','[]','[{0,1001031063,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101002,'头盔','10阶神装头盔【魔导师】',2,'[{lv,355}]',3,'[{0,38280620,2}]','[1002010963,1004010963,1006010963,1008010963,1010010963,1002020963,1004020963,1006020963,1008020963,1010020963,1002030963,1004030963,1006030963,1008030963,1010030963,1002040963,1004040963,1006040963,1008040963,1010040963]','[]','[]','[{0,1002031063,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101003,'项链','10阶神装项链【通用】',2,'[{lv,355}]',3,'[{0,38280620,2}]','[1003000963,1003000963,1003000963,1003000963]','[]','[]','[{0,1003001063,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101004,'衣服','10阶神装衣服【魔导师】',2,'[{lv,355}]',3,'[{0,38280620,2}]','[1002010963,1004010963,1006010963,1008010963,1010010963,1002020963,1004020963,1006020963,1008020963,1010020963,1002030963,1004030963,1006030963,1008030963,1010030963,1002040963,1004040963,1006040963,1008040963,1010040963]','[]','[]','[{0,1004031063,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101005,'刻痕','10阶神装刻痕【通用】',2,'[{lv,355}]',3,'[{0,38280620,2}]','[1005000963,1009000963,1005000963,1009000963,1005000963,1009000963,1005000963,1009000963]','[]','[]','[{0,1005001063,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101006,'裤子','10阶神装裤子【魔导师】',2,'[{lv,355}]',3,'[{0,38280620,2}]','[1002010963,1004010963,1006010963,1008010963,1010010963,1002020963,1004020963,1006020963,1008020963,1010020963,1002030963,1004030963,1006030963,1008030963,1010030963,1002040963,1004040963,1006040963,1008040963,1010040963]','[]','[]','[{0,1006031063,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101007,'副手','10阶神装副手【魔导师】',2,'[{lv,355}]',3,'[{0,38280620,2}]','[1001010963,1007010963,1001020963,1007020963,1001030963,1007030963,1001040963,1007040963]','[]','[]','[{0,1007031063,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101008,'护腕','10阶神装护腕【魔导师】',2,'[{lv,355}]',3,'[{0,38280620,2}]','[1002010963,1004010963,1006010963,1008010963,1010010963,1002020963,1004020963,1006020963,1008020963,1010020963,1002030963,1004030963,1006030963,1008030963,1010030963,1002040963,1004040963,1006040963,1008040963,1010040963]','[]','[]','[{0,1008031063,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101009,'戒指','10阶神装戒指【通用】',2,'[{lv,355}]',3,'[{0,38280620,2}]','[1005000963,1009000963,1005000963,1009000963,1005000963,1009000963,1005000963,1009000963]','[]','[]','[{0,1009001063,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101010,'鞋子','10阶神装鞋子【魔导师】',2,'[{lv,355}]',3,'[{0,38280620,2}]','[1002010963,1004010963,1006010963,1008010963,1010010963,1002020963,1004020963,1006020963,1008020963,1010020963,1002030963,1004030963,1006030963,1008030963,1010030963,1002040963,1004040963,1006040963,1008040963,1010040963]','[]','[]','[{0,1010031063,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101101,'武器','11阶神装武器【魔导师】',2,'[{lv,400}]',3,'[{0,38280620,2}]','[1001011063,1007011063,1001021063,1007021063,1001031063,1007031063,1001041063,1007041063]','[]','[]','[{0,1001031163,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101102,'头盔','11阶神装头盔【魔导师】',2,'[{lv,400}]',3,'[{0,38280620,2}]','[1002011063,1004011063,1006011063,1008011063,1010011063,1002021063,1004021063,1006021063,1008021063,1010021063,1002031063,1004031063,1006031063,1008031063,1010031063,1002041063,1004041063,1006041063,1008041063,1010041063]','[]','[]','[{0,1002031163,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101103,'项链','11阶神装项链【通用】',2,'[{lv,400}]',3,'[{0,38280620,2}]','[1003001063,1003001063,1003001063,1003001063]','[]','[]','[{0,1003001163,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101104,'衣服','11阶神装衣服【魔导师】',2,'[{lv,400}]',3,'[{0,38280620,2}]','[1002011063,1004011063,1006011063,1008011063,1010011063,1002021063,1004021063,1006021063,1008021063,1010021063,1002031063,1004031063,1006031063,1008031063,1010031063,1002041063,1004041063,1006041063,1008041063,1010041063]','[]','[]','[{0,1004031163,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101105,'刻痕','11阶神装刻痕【通用】',2,'[{lv,400}]',3,'[{0,38280620,2}]','[1005001063,1009001063,1005001063,1009001063,1005001063,1009001063,1005001063,1009001063]','[]','[]','[{0,1005001163,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101106,'裤子','11阶神装裤子【魔导师】',2,'[{lv,400}]',3,'[{0,38280620,2}]','[1002011063,1004011063,1006011063,1008011063,1010011063,1002021063,1004021063,1006021063,1008021063,1010021063,1002031063,1004031063,1006031063,1008031063,1010031063,1002041063,1004041063,1006041063,1008041063,1010041063]','[]','[]','[{0,1006031163,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101107,'副手','11阶神装副手【魔导师】',2,'[{lv,400}]',3,'[{0,38280620,2}]','[1001011063,1007011063,1001021063,1007021063,1001031063,1007031063,1001041063,1007041063]','[]','[]','[{0,1007031163,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101108,'护腕','11阶神装护腕【魔导师】',2,'[{lv,400}]',3,'[{0,38280620,2}]','[1002011063,1004011063,1006011063,1008011063,1010011063,1002021063,1004021063,1006021063,1008021063,1010021063,1002031063,1004031063,1006031063,1008031063,1010031063,1002041063,1004041063,1006041063,1008041063,1010041063]','[]','[]','[{0,1008031163,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101109,'戒指','11阶神装戒指【通用】',2,'[{lv,400}]',3,'[{0,38280620,2}]','[1005001063,1009001063,1005001063,1009001063,1005001063,1009001063,1005001063,1009001063]','[]','[]','[{0,1009001163,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101110,'鞋子','11阶神装鞋子【魔导师】',2,'[{lv,400}]',3,'[{0,38280620,2}]','[1002011063,1004011063,1006011063,1008011063,1010011063,1002021063,1004021063,1006021063,1008021063,1010021063,1002031063,1004031063,1006031063,1008031063,1010031063,1002041063,1004041063,1006041063,1008041063,1010041063]','[]','[]','[{0,1010031163,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101201,'武器','12阶神装武器【魔导师】',2,'[{lv,500}]',3,'[{0,38280620,2}]','[1001011163,1007011163,1001021163,1007021163,1001031163,1007031163,1001041163,1007041163]','[]','[]','[{0,1001031263,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101202,'头盔','12阶神装头盔【魔导师】',2,'[{lv,500}]',3,'[{0,38280620,2}]','[1002011163,1004011163,1006011163,1008011163,1010011163,1002021163,1004021163,1006021163,1008021163,1010021163,1002031163,1004031163,1006031163,1008031163,1010031163,1002041163,1004041163,1006041163,1008041163,1010041163]','[]','[]','[{0,1002031263,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101203,'项链','12阶神装项链【通用】',2,'[{lv,500}]',3,'[{0,38280620,2}]','[1003001163,1003001163,1003001163,1003001163]','[]','[]','[{0,1003001263,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101204,'衣服','12阶神装衣服【魔导师】',2,'[{lv,500}]',3,'[{0,38280620,2}]','[1002011163,1004011163,1006011163,1008011163,1010011163,1002021163,1004021163,1006021163,1008021163,1010021163,1002031163,1004031163,1006031163,1008031163,1010031163,1002041163,1004041163,1006041163,1008041163,1010041163]','[]','[]','[{0,1004031263,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101205,'刻痕','12阶神装刻痕【通用】',2,'[{lv,500}]',3,'[{0,38280620,2}]','[1005001163,1009001163,1005001163,1009001163,1005001163,1009001163,1005001163,1009001163]','[]','[]','[{0,1005001263,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101206,'裤子','12阶神装裤子【魔导师】',2,'[{lv,500}]',3,'[{0,38280620,2}]','[1002011163,1004011163,1006011163,1008011163,1010011163,1002021163,1004021163,1006021163,1008021163,1010021163,1002031163,1004031163,1006031163,1008031163,1010031163,1002041163,1004041163,1006041163,1008041163,1010041163]','[]','[]','[{0,1006031263,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101207,'副手','12阶神装副手【魔导师】',2,'[{lv,500}]',3,'[{0,38280620,2}]','[1001011163,1007011163,1001021163,1007021163,1001031163,1007031163,1001041163,1007041163]','[]','[]','[{0,1007031263,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101208,'护腕','12阶神装护腕【魔导师】',2,'[{lv,500}]',3,'[{0,38280620,2}]','[1002011163,1004011163,1006011163,1008011163,1010011163,1002021163,1004021163,1006021163,1008021163,1010021163,1002031163,1004031163,1006031163,1008031163,1010031163,1002041163,1004041163,1006041163,1008041163,1010041163]','[]','[]','[{0,1008031263,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101209,'戒指','12阶神装戒指【通用】',2,'[{lv,500}]',3,'[{0,38280620,2}]','[1005001163,1009001163,1005001163,1009001163,1005001163,1009001163,1005001163,1009001163]','[]','[]','[{0,1009001263,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101210,'鞋子','12阶神装鞋子【魔导师】',2,'[{lv,500}]',3,'[{0,38280620,2}]','[1002011163,1004011163,1006011163,1008011163,1010011163,1002021163,1004021163,1006021163,1008021163,1010021163,1002031163,1004031163,1006031163,1008031163,1010031163,1002041163,1004041163,1006041163,1008041163,1010041163]','[]','[]','[{0,1010031263,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101301,'武器','13阶神装武器【魔导师】',2,'[{lv,520}]',3,'[{0,38280620,2}]','[1001011263,1007011263,1001021263,1007021263,1001031263,1007031263,1001041263,1007041263]','[]','[]','[{0,1001031363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101302,'头盔','13阶神装头盔【魔导师】',2,'[{lv,520}]',3,'[{0,38280620,2}]','[1002011263,1004011263,1006011263,1008011263,1010011263,1002021263,1004021263,1006021263,1008021263,1010021263,1002031263,1004031263,1006031263,1008031263,1010031263,1002041263,1004041263,1006041263,1008041263,1010041263]','[]','[]','[{0,1002031363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101303,'项链','13阶神装项链【通用】',2,'[{lv,520}]',3,'[{0,38280620,2}]','[1003001263,1003001263,1003001263,1003001263]','[]','[]','[{0,1003001363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101304,'衣服','13阶神装衣服【魔导师】',2,'[{lv,520}]',3,'[{0,38280620,2}]','[1002011263,1004011263,1006011263,1008011263,1010011263,1002021263,1004021263,1006021263,1008021263,1010021263,1002031263,1004031263,1006031263,1008031263,1010031263,1002041263,1004041263,1006041263,1008041263,1010041263]','[]','[]','[{0,1004031363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101305,'刻痕','13阶神装刻痕【通用】',2,'[{lv,520}]',3,'[{0,38280620,2}]','[1005001263,1009001263,1005001263,1009001263,1005001263,1009001263,1005001263,1009001263]','[]','[]','[{0,1005001363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101306,'裤子','13阶神装裤子【魔导师】',2,'[{lv,520}]',3,'[{0,38280620,2}]','[1002011263,1004011263,1006011263,1008011263,1010011263,1002021263,1004021263,1006021263,1008021263,1010021263,1002031263,1004031263,1006031263,1008031263,1010031263,1002041263,1004041263,1006041263,1008041263,1010041263]','[]','[]','[{0,1006031363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101307,'副手','13阶神装副手【魔导师】',2,'[{lv,520}]',3,'[{0,38280620,2}]','[1001011263,1007011263,1001021263,1007021263,1001031263,1007031263,1001041263,1007041263]','[]','[]','[{0,1007031363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101308,'护腕','13阶神装护腕【魔导师】',2,'[{lv,520}]',3,'[{0,38280620,2}]','[1002011263,1004011263,1006011263,1008011263,1010011263,1002021263,1004021263,1006021263,1008021263,1010021263,1002031263,1004031263,1006031263,1008031263,1010031263,1002041263,1004041263,1006041263,1008041263,1010041263]','[]','[]','[{0,1008031363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101309,'戒指','13阶神装戒指【通用】',2,'[{lv,520}]',3,'[{0,38280620,2}]','[1005001263,1009001263,1005001263,1009001263,1005001263,1009001263,1005001263,1009001263]','[]','[]','[{0,1009001363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101310,'鞋子','13阶神装鞋子【魔导师】',2,'[{lv,520}]',3,'[{0,38280620,2}]','[1002011263,1004011263,1006011263,1008011263,1010011263,1002021263,1004021263,1006021263,1008021263,1010021263,1002031263,1004031263,1006031263,1008031263,1010031263,1002041263,1004041263,1006041263,1008041263,1010041263]','[]','[]','[{0,1010031363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101401,'武器','14阶神装武器【魔导师】',2,'[{lv,620}]',3,'[{0,38280620,2}]','[1001011363,1007011363,1001021363,1007021363,1001031363,1007031363,1001041363,1007041363]','[]','[]','[{0,1001031463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101402,'头盔','14阶神装头盔【魔导师】',2,'[{lv,620}]',3,'[{0,38280620,2}]','[1002011363,1004011363,1006011363,1008011363,1010011363,1002021363,1004021363,1006021363,1008021363,1010021363,1002031363,1004031363,1006031363,1008031363,1010031363,1002041363,1004041363,1006041363,1008041363,1010041363]','[]','[]','[{0,1002031463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101403,'项链','14阶神装项链【通用】',2,'[{lv,620}]',3,'[{0,38280620,2}]','[1003001363,1003001363,1003001363,1003001363]','[]','[]','[{0,1003001463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101404,'衣服','14阶神装衣服【魔导师】',2,'[{lv,620}]',3,'[{0,38280620,2}]','[1002011363,1004011363,1006011363,1008011363,1010011363,1002021363,1004021363,1006021363,1008021363,1010021363,1002031363,1004031363,1006031363,1008031363,1010031363,1002041363,1004041363,1006041363,1008041363,1010041363]','[]','[]','[{0,1004031463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101405,'刻痕','14阶神装刻痕【通用】',2,'[{lv,620}]',3,'[{0,38280620,2}]','[1005001363,1009001363,1005001363,1009001363,1005001363,1009001363,1005001363,1009001363]','[]','[]','[{0,1005001463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101406,'裤子','14阶神装裤子【魔导师】',2,'[{lv,620}]',3,'[{0,38280620,2}]','[1002011363,1004011363,1006011363,1008011363,1010011363,1002021363,1004021363,1006021363,1008021363,1010021363,1002031363,1004031363,1006031363,1008031363,1010031363,1002041363,1004041363,1006041363,1008041363,1010041363]','[]','[]','[{0,1006031463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101407,'副手','14阶神装副手【魔导师】',2,'[{lv,620}]',3,'[{0,38280620,2}]','[1001011363,1007011363,1001021363,1007021363,1001031363,1007031363,1001041363,1007041363]','[]','[]','[{0,1007031463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101408,'护腕','14阶神装护腕【魔导师】',2,'[{lv,620}]',3,'[{0,38280620,2}]','[1002011363,1004011363,1006011363,1008011363,1010011363,1002021363,1004021363,1006021363,1008021363,1010021363,1002031363,1004031363,1006031363,1008031363,1010031363,1002041363,1004041363,1006041363,1008041363,1010041363]','[]','[]','[{0,1008031463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101409,'戒指','14阶神装戒指【通用】',2,'[{lv,620}]',3,'[{0,38280620,2}]','[1005001363,1009001363,1005001363,1009001363,1005001363,1009001363,1005001363,1009001363]','[]','[]','[{0,1009001463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101410,'鞋子','14阶神装鞋子【魔导师】',2,'[{lv,620}]',3,'[{0,38280620,2}]','[1002011363,1004011363,1006011363,1008011363,1010011363,1002021363,1004021363,1006021363,1008021363,1010021363,1002031363,1004031363,1006031363,1008031363,1010031363,1002041363,1004041363,1006041363,1008041363,1010041363]','[]','[]','[{0,1010031463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101501,'武器','15阶神装武器【魔导师】',2,'[{lv,650}]',3,'[{0,38280620,2}]','[1001011463,1007011463,1001021463,1007021463,1001031463,1007031463,1001041463,1007041463]','[]','[]','[{0,1001031563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101502,'头盔','15阶神装头盔【魔导师】',2,'[{lv,650}]',3,'[{0,38280620,2}]','[1002011463,1004011463,1006011463,1008011463,1010011463,1002021463,1004021463,1006021463,1008021463,1010021463,1002031463,1004031463,1006031463,1008031463,1010031463,1002041463,1004041463,1006041463,1008041463,1010041463]','[]','[]','[{0,1002031563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101503,'项链','15阶神装项链【通用】',2,'[{lv,650}]',3,'[{0,38280620,2}]','[1003001463,1003001463,1003001463,1003001463]','[]','[]','[{0,1003001563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101504,'衣服','15阶神装衣服【魔导师】',2,'[{lv,650}]',3,'[{0,38280620,2}]','[1002011463,1004011463,1006011463,1008011463,1010011463,1002021463,1004021463,1006021463,1008021463,1010021463,1002031463,1004031463,1006031463,1008031463,1010031463,1002041463,1004041463,1006041463,1008041463,1010041463]','[]','[]','[{0,1004031563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101505,'刻痕','15阶神装刻痕【通用】',2,'[{lv,650}]',3,'[{0,38280620,2}]','[1005001463,1009001463,1005001463,1009001463,1005001463,1009001463,1005001463,1009001463]','[]','[]','[{0,1005001563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101506,'裤子','15阶神装裤子【魔导师】',2,'[{lv,650}]',3,'[{0,38280620,2}]','[1002011463,1004011463,1006011463,1008011463,1010011463,1002021463,1004021463,1006021463,1008021463,1010021463,1002031463,1004031463,1006031463,1008031463,1010031463,1002041463,1004041463,1006041463,1008041463,1010041463]','[]','[]','[{0,1006031563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101507,'副手','15阶神装副手【魔导师】',2,'[{lv,650}]',3,'[{0,38280620,2}]','[1001011463,1007011463,1001021463,1007021463,1001031463,1007031463,1001041463,1007041463]','[]','[]','[{0,1007031563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101508,'护腕','15阶神装护腕【魔导师】',2,'[{lv,650}]',3,'[{0,38280620,2}]','[1002011463,1004011463,1006011463,1008011463,1010011463,1002021463,1004021463,1006021463,1008021463,1010021463,1002031463,1004031463,1006031463,1008031463,1010031463,1002041463,1004041463,1006041463,1008041463,1010041463]','[]','[]','[{0,1008031563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101509,'戒指','15阶神装戒指【通用】',2,'[{lv,650}]',3,'[{0,38280620,2}]','[1005001463,1009001463,1005001463,1009001463,1005001463,1009001463,1005001463,1009001463]','[]','[]','[{0,1009001563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101510,'鞋子','15阶神装鞋子【魔导师】',2,'[{lv,650}]',3,'[{0,38280620,2}]','[1002011463,1004011463,1006011463,1008011463,1010011463,1002021463,1004021463,1006021463,1008021463,1010021463,1002031463,1004031463,1006031463,1008031463,1010031463,1002041463,1004041463,1006041463,1008041463,1010041463]','[]','[]','[{0,1010031563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101601,'武器','16阶神装武器【魔导师】',2,'[{lv,700}]',3,'[{0,38280620,2}]','[1001011563,1007011563,1001021563,1007021563,1001031563,1007031563,1001041563,1007041563]','[]','[]','[{0,1001031663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101602,'头盔','16阶神装头盔【魔导师】',2,'[{lv,700}]',3,'[{0,38280620,2}]','[1002011563,1004011563,1006011563,1008011563,1010011563,1002021563,1004021563,1006021563,1008021563,1010021563,1002031563,1004031563,1006031563,1008031563,1010031563,1002041563,1004041563,1006041563,1008041563,1010041563]','[]','[]','[{0,1002031663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101603,'项链','16阶神装项链【通用】',2,'[{lv,700}]',3,'[{0,38280620,2}]','[1003001563,1003001563,1003001563,1003001563]','[]','[]','[{0,1003001663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101604,'衣服','16阶神装衣服【魔导师】',2,'[{lv,700}]',3,'[{0,38280620,2}]','[1002011563,1004011563,1006011563,1008011563,1010011563,1002021563,1004021563,1006021563,1008021563,1010021563,1002031563,1004031563,1006031563,1008031563,1010031563,1002041563,1004041563,1006041563,1008041563,1010041563]','[]','[]','[{0,1004031663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101605,'刻痕','16阶神装刻痕【通用】',2,'[{lv,700}]',3,'[{0,38280620,2}]','[1005001563,1009001563,1005001563,1009001563,1005001563,1009001563,1005001563,1009001563]','[]','[]','[{0,1005001663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101606,'裤子','16阶神装裤子【魔导师】',2,'[{lv,700}]',3,'[{0,38280620,2}]','[1002011563,1004011563,1006011563,1008011563,1010011563,1002021563,1004021563,1006021563,1008021563,1010021563,1002031563,1004031563,1006031563,1008031563,1010031563,1002041563,1004041563,1006041563,1008041563,1010041563]','[]','[]','[{0,1006031663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101607,'副手','16阶神装副手【魔导师】',2,'[{lv,700}]',3,'[{0,38280620,2}]','[1001011563,1007011563,1001021563,1007021563,1001031563,1007031563,1001041563,1007041563]','[]','[]','[{0,1007031663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101608,'护腕','16阶神装护腕【魔导师】',2,'[{lv,700}]',3,'[{0,38280620,2}]','[1002011563,1004011563,1006011563,1008011563,1010011563,1002021563,1004021563,1006021563,1008021563,1010021563,1002031563,1004031563,1006031563,1008031563,1010031563,1002041563,1004041563,1006041563,1008041563,1010041563]','[]','[]','[{0,1008031663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101609,'戒指','16阶神装戒指【通用】',2,'[{lv,700}]',3,'[{0,38280620,2}]','[1005001563,1009001563,1005001563,1009001563,1005001563,1009001563,1005001563,1009001563]','[]','[]','[{0,1009001663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(33101610,'鞋子','16阶神装鞋子【魔导师】',2,'[{lv,700}]',3,'[{0,38280620,2}]','[1002011563,1004011563,1006011563,1008011563,1010011563,1002021563,1004021563,1006021563,1008021563,1010021563,1002031563,1004031563,1006031563,1008031563,1010031563,1002041563,1004041563,1006041563,1008041563,1010041563]','[]','[]','[{0,1010031663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34070301,'武器','3阶红2星武器【重炮手】',2,'[{lv,9999}]',2,'[]','[1001010332,1007010332,1001020332,1007020332,1001030332,1007030332,1001040332,1007040332]','[]','[]','[{0,1001040342,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(34070302,'头盔','3阶红2星头盔【重炮手】',2,'[{lv,9999}]',2,'[]','[1002010332,1004010332,1006010332,1008010332,1010010332,1002020332,1004020332,1006020332,1008020332,1010020332,1002030332,1004030332,1006030332,1008030332,1010030332,1002040332,1004040332,1006040332,1008040332,1010040332]','[]','[]','[{0,1002040342,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(34070303,'项链','3阶红2星项链【通用】',2,'[{lv,9999}]',2,'[]','[1003000332,1003000332,1003000332,1003000332]','[]','[]','[{0,1003000342,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(34070304,'衣服','3阶红2星衣服【重炮手】',2,'[{lv,9999}]',2,'[]','[1002010332,1004010332,1006010332,1008010332,1010010332,1002020332,1004020332,1006020332,1008020332,1010020332,1002030332,1004030332,1006030332,1008030332,1010030332,1002040332,1004040332,1006040332,1008040332,1010040332]','[]','[]','[{0,1004040342,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(34070305,'刻痕','3阶红2星刻痕【通用】',2,'[{lv,9999}]',2,'[]','[1005000332,1009000332,1005000332,1009000332,1005000332,1009000332,1005000332,1009000332]','[]','[]','[{0,1005000342,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(34070306,'裤子','3阶红2星裤子【重炮手】',2,'[{lv,9999}]',2,'[]','[1002010332,1004010332,1006010332,1008010332,1010010332,1002020332,1004020332,1006020332,1008020332,1010020332,1002030332,1004030332,1006030332,1008030332,1010030332,1002040332,1004040332,1006040332,1008040332,1010040332]','[]','[]','[{0,1006040342,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(34070307,'副手','3阶红2星副手【重炮手】',2,'[{lv,9999}]',2,'[]','[1001010332,1007010332,1001020332,1007020332,1001030332,1007030332,1001040332,1007040332]','[]','[]','[{0,1007040342,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(34070308,'护腕','3阶红2星护腕【重炮手】',2,'[{lv,9999}]',2,'[]','[1002010332,1004010332,1006010332,1008010332,1010010332,1002020332,1004020332,1006020332,1008020332,1010020332,1002030332,1004030332,1006030332,1008030332,1010030332,1002040332,1004040332,1006040332,1008040332,1010040332]','[]','[]','[{0,1008040342,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(34070309,'戒指','3阶红2星戒指【通用】',2,'[{lv,9999}]',2,'[]','[1005000332,1009000332,1005000332,1009000332,1005000332,1009000332,1005000332,1009000332]','[]','[]','[{0,1009000342,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(34070310,'鞋子','3阶红2星鞋子【重炮手】',2,'[{lv,9999}]',2,'[]','[1002010332,1004010332,1006010332,1008010332,1010010332,1002020332,1004020332,1006020332,1008020332,1010020332,1002030332,1004030332,1006030332,1008030332,1010030332,1002040332,1004040332,1006040332,1008040332,1010040332]','[]','[]','[{0,1010040342,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(34070401,'武器','4阶红2星武器【重炮手】',2,'[{lv,160}]',2,'[]','[1001010432,1007010432,1001020432,1007020432,1001030432,1007030432,1001040432,1007040432]','[]','[]','[{0,1001040442,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(34070402,'头盔','4阶红2星头盔【重炮手】',2,'[{lv,160}]',2,'[]','[1002010432,1004010432,1006010432,1008010432,1010010432,1002020432,1004020432,1006020432,1008020432,1010020432,1002030432,1004030432,1006030432,1008030432,1010030432,1002040432,1004040432,1006040432,1008040432,1010040432]','[]','[]','[{0,1002040442,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(34070403,'项链','4阶红2星项链【通用】',2,'[{lv,160}]',2,'[]','[1003000432,1003000432,1003000432,1003000432]','[]','[]','[{0,1003000442,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(34070404,'衣服','4阶红2星衣服【重炮手】',2,'[{lv,160}]',2,'[]','[1002010432,1004010432,1006010432,1008010432,1010010432,1002020432,1004020432,1006020432,1008020432,1010020432,1002030432,1004030432,1006030432,1008030432,1010030432,1002040432,1004040432,1006040432,1008040432,1010040432]','[]','[]','[{0,1004040442,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(34070405,'刻痕','4阶红2星刻痕【通用】',2,'[{lv,160}]',2,'[]','[1005000432,1009000432,1005000432,1009000432,1005000432,1009000432,1005000432,1009000432]','[]','[]','[{0,1005000442,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(34070406,'裤子','4阶红2星裤子【重炮手】',2,'[{lv,160}]',2,'[]','[1002010432,1004010432,1006010432,1008010432,1010010432,1002020432,1004020432,1006020432,1008020432,1010020432,1002030432,1004030432,1006030432,1008030432,1010030432,1002040432,1004040432,1006040432,1008040432,1010040432]','[]','[]','[{0,1006040442,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(34070407,'副手','4阶红2星副手【重炮手】',2,'[{lv,160}]',2,'[]','[1001010432,1007010432,1001020432,1007020432,1001030432,1007030432,1001040432,1007040432]','[]','[]','[{0,1007040442,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(34070408,'护腕','4阶红2星护腕【重炮手】',2,'[{lv,160}]',2,'[]','[1002010432,1004010432,1006010432,1008010432,1010010432,1002020432,1004020432,1006020432,1008020432,1010020432,1002030432,1004030432,1006030432,1008030432,1010030432,1002040432,1004040432,1006040432,1008040432,1010040432]','[]','[]','[{0,1008040442,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(34070409,'戒指','4阶红2星戒指【通用】',2,'[{lv,160}]',2,'[]','[1005000432,1009000432,1005000432,1009000432,1005000432,1009000432,1005000432,1009000432]','[]','[]','[{0,1009000442,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(34070410,'鞋子','4阶红2星鞋子【重炮手】',2,'[{lv,160}]',2,'[]','[1002010432,1004010432,1006010432,1008010432,1010010432,1002020432,1004020432,1006020432,1008020432,1010020432,1002030432,1004030432,1006030432,1008030432,1010030432,1002040432,1004040432,1006040432,1008040432,1010040432]','[]','[]','[{0,1010040442,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(34070501,'武器','5阶红2星武器【重炮手】',2,'[{lv,160}]',2,'[]','[1001010532,1007010532,1001020532,1007020532,1001030532,1007030532,1001040532,1007040532,1101010532,1107010532,1101020532,1107020532,1101030532,1107030532,1101040532,1107040532]','[]','[]','[{0,1001040542,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(34070502,'头盔','5阶红2星头盔【重炮手】',2,'[{lv,160}]',2,'[]','[1002010532,1004010532,1006010532,1008010532,1010010532,1002020532,1004020532,1006020532,1008020532,1010020532,1002030532,1004030532,1006030532,1008030532,1010030532,1002040532,1004040532,1006040532,1008040532,1010040532,1102010532,1104010532,1106010532,1108010532,1110010532,1102020532,1104020532,1106020532,1108020532,1110020532,1102030532,1104030532,1106030532,1108030532,1110030532,1102040532,1104040532,1106040532,1108040532,1110040532]','[]','[]','[{0,1002040542,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(34070503,'项链','5阶红2星项链【通用】',2,'[{lv,160}]',2,'[]','[1003000532,1003000532,1003000532,1003000532,1103000532,1103000532,1103000532,1103000532]','[]','[]','[{0,1003000542,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(34070504,'衣服','5阶红2星衣服【重炮手】',2,'[{lv,160}]',2,'[]','[1002010532,1004010532,1006010532,1008010532,1010010532,1002020532,1004020532,1006020532,1008020532,1010020532,1002030532,1004030532,1006030532,1008030532,1010030532,1002040532,1004040532,1006040532,1008040532,1010040532,1102010532,1104010532,1106010532,1108010532,1110010532,1102020532,1104020532,1106020532,1108020532,1110020532,1102030532,1104030532,1106030532,1108030532,1110030532,1102040532,1104040532,1106040532,1108040532,1110040532]','[]','[]','[{0,1004040542,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(34070505,'刻痕','5阶红2星刻痕【通用】',2,'[{lv,160}]',2,'[]','[1005000532,1009000532,1005000532,1009000532,1005000532,1009000532,1005000532,1009000532,1105000532,1109000532,1105000532,1109000532,1105000532,1109000532,1105000532,1109000532]','[]','[]','[{0,1005000542,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(34070506,'裤子','5阶红2星裤子【重炮手】',2,'[{lv,160}]',2,'[]','[1002010532,1004010532,1006010532,1008010532,1010010532,1002020532,1004020532,1006020532,1008020532,1010020532,1002030532,1004030532,1006030532,1008030532,1010030532,1002040532,1004040532,1006040532,1008040532,1010040532,1102010532,1104010532,1106010532,1108010532,1110010532,1102020532,1104020532,1106020532,1108020532,1110020532,1102030532,1104030532,1106030532,1108030532,1110030532,1102040532,1104040532,1106040532,1108040532,1110040532]','[]','[]','[{0,1006040542,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(34070507,'副手','5阶红2星副手【重炮手】',2,'[{lv,160}]',2,'[]','[1001010532,1007010532,1001020532,1007020532,1001030532,1007030532,1001040532,1007040532,1101010532,1107010532,1101020532,1107020532,1101030532,1107030532,1101040532,1107040532]','[]','[]','[{0,1007040542,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(34070508,'护腕','5阶红2星护腕【重炮手】',2,'[{lv,160}]',2,'[]','[1002010532,1004010532,1006010532,1008010532,1010010532,1002020532,1004020532,1006020532,1008020532,1010020532,1002030532,1004030532,1006030532,1008030532,1010030532,1002040532,1004040532,1006040532,1008040532,1010040532,1102010532,1104010532,1106010532,1108010532,1110010532,1102020532,1104020532,1106020532,1108020532,1110020532,1102030532,1104030532,1106030532,1108030532,1110030532,1102040532,1104040532,1106040532,1108040532,1110040532]','[]','[]','[{0,1008040542,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(34070509,'戒指','5阶红2星戒指【通用】',2,'[{lv,160}]',2,'[]','[1005000532,1009000532,1005000532,1009000532,1005000532,1009000532,1005000532,1009000532,1105000532,1109000532,1105000532,1109000532,1105000532,1109000532,1105000532,1109000532]','[]','[]','[{0,1009000542,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(34070510,'鞋子','5阶红2星鞋子【重炮手】',2,'[{lv,160}]',2,'[]','[1002010532,1004010532,1006010532,1008010532,1010010532,1002020532,1004020532,1006020532,1008020532,1010020532,1002030532,1004030532,1006030532,1008030532,1010030532,1002040532,1004040532,1006040532,1008040532,1010040532,1102010532,1104010532,1106010532,1108010532,1110010532,1102020532,1104020532,1106020532,1108020532,1110020532,1102030532,1104030532,1106030532,1108030532,1110030532,1102040532,1104040532,1106040532,1108040532,1110040532]','[]','[]','[{0,1010040542,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(34070601,'武器','6阶红2星武器【重炮手】',2,'[{lv,180}]',2,'[]','[1001010632,1007010632,1001020632,1007020632,1001030632,1007030632,1001040632,1007040632]','[]','[]','[{0,1001040642,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(34070602,'头盔','6阶红2星头盔【重炮手】',2,'[{lv,180}]',2,'[]','[1002010632,1004010632,1006010632,1008010632,1010010632,1002020632,1004020632,1006020632,1008020632,1010020632,1002030632,1004030632,1006030632,1008030632,1010030632,1002040632,1004040632,1006040632,1008040632,1010040632]','[]','[]','[{0,1002040642,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(34070603,'项链','6阶红2星项链【通用】',2,'[{lv,180}]',2,'[]','[1003000632,1003000632,1003000632,1003000632]','[]','[]','[{0,1003000642,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(34070604,'衣服','6阶红2星衣服【重炮手】',2,'[{lv,180}]',2,'[]','[1002010632,1004010632,1006010632,1008010632,1010010632,1002020632,1004020632,1006020632,1008020632,1010020632,1002030632,1004030632,1006030632,1008030632,1010030632,1002040632,1004040632,1006040632,1008040632,1010040632]','[]','[]','[{0,1004040642,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(34070605,'刻痕','6阶红2星刻痕【通用】',2,'[{lv,180}]',2,'[]','[1005000632,1009000632,1005000632,1009000632,1005000632,1009000632,1005000632,1009000632]','[]','[]','[{0,1005000642,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(34070606,'裤子','6阶红2星裤子【重炮手】',2,'[{lv,180}]',2,'[]','[1002010632,1004010632,1006010632,1008010632,1010010632,1002020632,1004020632,1006020632,1008020632,1010020632,1002030632,1004030632,1006030632,1008030632,1010030632,1002040632,1004040632,1006040632,1008040632,1010040632]','[]','[]','[{0,1006040642,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(34070607,'副手','6阶红2星副手【重炮手】',2,'[{lv,180}]',2,'[]','[1001010632,1007010632,1001020632,1007020632,1001030632,1007030632,1001040632,1007040632]','[]','[]','[{0,1007040642,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(34070608,'护腕','6阶红2星护腕【重炮手】',2,'[{lv,180}]',2,'[]','[1002010632,1004010632,1006010632,1008010632,1010010632,1002020632,1004020632,1006020632,1008020632,1010020632,1002030632,1004030632,1006030632,1008030632,1010030632,1002040632,1004040632,1006040632,1008040632,1010040632]','[]','[]','[{0,1008040642,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(34070609,'戒指','6阶红2星戒指【通用】',2,'[{lv,180}]',2,'[]','[1005000632,1009000632,1005000632,1009000632,1005000632,1009000632,1005000632,1009000632]','[]','[]','[{0,1009000642,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(34070610,'鞋子','6阶红2星鞋子【重炮手】',2,'[{lv,180}]',2,'[]','[1002010632,1004010632,1006010632,1008010632,1010010632,1002020632,1004020632,1006020632,1008020632,1010020632,1002030632,1004030632,1006030632,1008030632,1010030632,1002040632,1004040632,1006040632,1008040632,1010040632]','[]','[]','[{0,1010040642,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(34070701,'武器','7阶红2星武器【重炮手】',2,'[{lv,220}]',2,'[]','[1001010732,1007010732,1001020732,1007020732,1001030732,1007030732,1001040732,1007040732,1101010732,1107010732,1101020732,1107020732,1101030732,1107030732,1101040732,1107040732]','[]','[]','[{0,1001040742,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34070702,'头盔','7阶红2星头盔【重炮手】',2,'[{lv,220}]',2,'[]','[1002010732,1004010732,1006010732,1008010732,1010010732,1002020732,1004020732,1006020732,1008020732,1010020732,1002030732,1004030732,1006030732,1008030732,1010030732,1002040732,1004040732,1006040732,1008040732,1010040732,1102010732,1104010732,1106010732,1108010732,1110010732,1102020732,1104020732,1106020732,1108020732,1110020732,1102030732,1104030732,1106030732,1108030732,1110030732,1102040732,1104040732,1106040732,1108040732,1110040732]','[]','[]','[{0,1002040742,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34070703,'项链','7阶红2星项链【通用】',2,'[{lv,220}]',2,'[]','[1003000732,1003000732,1003000732,1003000732,1103000732,1103000732,1103000732,1103000732]','[]','[]','[{0,1003000742,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34070704,'衣服','7阶红2星衣服【重炮手】',2,'[{lv,220}]',2,'[]','[1002010732,1004010732,1006010732,1008010732,1010010732,1002020732,1004020732,1006020732,1008020732,1010020732,1002030732,1004030732,1006030732,1008030732,1010030732,1002040732,1004040732,1006040732,1008040732,1010040732,1102010732,1104010732,1106010732,1108010732,1110010732,1102020732,1104020732,1106020732,1108020732,1110020732,1102030732,1104030732,1106030732,1108030732,1110030732,1102040732,1104040732,1106040732,1108040732,1110040732]','[]','[]','[{0,1004040742,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34070705,'刻痕','7阶红2星刻痕【通用】',2,'[{lv,220}]',2,'[]','[1005000732,1009000732,1005000732,1009000732,1005000732,1009000732,1005000732,1009000732,1105000732,1109000732,1105000732,1109000732,1105000732,1109000732,1105000732,1109000732]','[]','[]','[{0,1005000742,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34070706,'裤子','7阶红2星裤子【重炮手】',2,'[{lv,220}]',2,'[]','[1002010732,1004010732,1006010732,1008010732,1010010732,1002020732,1004020732,1006020732,1008020732,1010020732,1002030732,1004030732,1006030732,1008030732,1010030732,1002040732,1004040732,1006040732,1008040732,1010040732,1102010732,1104010732,1106010732,1108010732,1110010732,1102020732,1104020732,1106020732,1108020732,1110020732,1102030732,1104030732,1106030732,1108030732,1110030732,1102040732,1104040732,1106040732,1108040732,1110040732]','[]','[]','[{0,1006040742,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34070707,'副手','7阶红2星副手【重炮手】',2,'[{lv,220}]',2,'[]','[1001010732,1007010732,1001020732,1007020732,1001030732,1007030732,1001040732,1007040732,1101010732,1107010732,1101020732,1107020732,1101030732,1107030732,1101040732,1107040732]','[]','[]','[{0,1007040742,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34070708,'护腕','7阶红2星护腕【重炮手】',2,'[{lv,220}]',2,'[]','[1002010732,1004010732,1006010732,1008010732,1010010732,1002020732,1004020732,1006020732,1008020732,1010020732,1002030732,1004030732,1006030732,1008030732,1010030732,1002040732,1004040732,1006040732,1008040732,1010040732,1102010732,1104010732,1106010732,1108010732,1110010732,1102020732,1104020732,1106020732,1108020732,1110020732,1102030732,1104030732,1106030732,1108030732,1110030732,1102040732,1104040732,1106040732,1108040732,1110040732]','[]','[]','[{0,1008040742,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34070709,'戒指','7阶红2星戒指【通用】',2,'[{lv,220}]',2,'[]','[1005000732,1009000732,1005000732,1009000732,1005000732,1009000732,1005000732,1009000732,1105000732,1109000732,1105000732,1109000732,1105000732,1109000732,1105000732,1109000732]','[]','[]','[{0,1009000742,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34070710,'鞋子','7阶红2星鞋子【重炮手】',2,'[{lv,220}]',2,'[]','[1002010732,1004010732,1006010732,1008010732,1010010732,1002020732,1004020732,1006020732,1008020732,1010020732,1002030732,1004030732,1006030732,1008030732,1010030732,1002040732,1004040732,1006040732,1008040732,1010040732,1102010732,1104010732,1106010732,1108010732,1110010732,1102020732,1104020732,1106020732,1108020732,1110020732,1102030732,1104030732,1106030732,1108030732,1110030732,1102040732,1104040732,1106040732,1108040732,1110040732]','[]','[]','[{0,1010040742,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34070801,'武器','8阶红2星武器【重炮手】',2,'[{lv,260}]',2,'[]','[1001010832,1007010832,1001020832,1007020832,1001030832,1007030832,1001040832,1007040832]','[]','[]','[{0,1001040842,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34070802,'头盔','8阶红2星头盔【重炮手】',2,'[{lv,260}]',2,'[]','[1002010832,1004010832,1006010832,1008010832,1010010832,1002020832,1004020832,1006020832,1008020832,1010020832,1002030832,1004030832,1006030832,1008030832,1010030832,1002040832,1004040832,1006040832,1008040832,1010040832]','[]','[]','[{0,1002040842,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34070803,'项链','8阶红2星项链【通用】',2,'[{lv,260}]',2,'[]','[1003000832,1003000832,1003000832,1003000832]','[]','[]','[{0,1003000842,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34070804,'衣服','8阶红2星衣服【重炮手】',2,'[{lv,260}]',2,'[]','[1002010832,1004010832,1006010832,1008010832,1010010832,1002020832,1004020832,1006020832,1008020832,1010020832,1002030832,1004030832,1006030832,1008030832,1010030832,1002040832,1004040832,1006040832,1008040832,1010040832]','[]','[]','[{0,1004040842,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34070805,'刻痕','8阶红2星刻痕【通用】',2,'[{lv,260}]',2,'[]','[1005000832,1009000832,1005000832,1009000832,1005000832,1009000832,1005000832,1009000832]','[]','[]','[{0,1005000842,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34070806,'裤子','8阶红2星裤子【重炮手】',2,'[{lv,260}]',2,'[]','[1002010832,1004010832,1006010832,1008010832,1010010832,1002020832,1004020832,1006020832,1008020832,1010020832,1002030832,1004030832,1006030832,1008030832,1010030832,1002040832,1004040832,1006040832,1008040832,1010040832]','[]','[]','[{0,1006040842,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34070807,'副手','8阶红2星副手【重炮手】',2,'[{lv,260}]',2,'[]','[1001010832,1007010832,1001020832,1007020832,1001030832,1007030832,1001040832,1007040832]','[]','[]','[{0,1007040842,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34070808,'护腕','8阶红2星护腕【重炮手】',2,'[{lv,260}]',2,'[]','[1002010832,1004010832,1006010832,1008010832,1010010832,1002020832,1004020832,1006020832,1008020832,1010020832,1002030832,1004030832,1006030832,1008030832,1010030832,1002040832,1004040832,1006040832,1008040832,1010040832]','[]','[]','[{0,1008040842,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34070809,'戒指','8阶红2星戒指【通用】',2,'[{lv,260}]',2,'[]','[1005000832,1009000832,1005000832,1009000832,1005000832,1009000832,1005000832,1009000832]','[]','[]','[{0,1009000842,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34070810,'鞋子','8阶红2星鞋子【重炮手】',2,'[{lv,260}]',2,'[]','[1002010832,1004010832,1006010832,1008010832,1010010832,1002020832,1004020832,1006020832,1008020832,1010020832,1002030832,1004030832,1006030832,1008030832,1010030832,1002040832,1004040832,1006040832,1008040832,1010040832]','[]','[]','[{0,1010040842,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34070901,'武器','9阶红2星武器【重炮手】',2,'[{lv,300}]',2,'[]','[1001010932,1007010932,1001020932,1007020932,1001030932,1007030932,1001040932,1007040932]','[]','[]','[{0,1001040942,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34070902,'头盔','9阶红2星头盔【重炮手】',2,'[{lv,300}]',2,'[]','[1002010932,1004010932,1006010932,1008010932,1010010932,1002020932,1004020932,1006020932,1008020932,1010020932,1002030932,1004030932,1006030932,1008030932,1010030932,1002040932,1004040932,1006040932,1008040932,1010040932]','[]','[]','[{0,1002040942,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34070903,'项链','9阶红2星项链【通用】',2,'[{lv,300}]',2,'[]','[1003000932,1003000932,1003000932,1003000932]','[]','[]','[{0,1003000942,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34070904,'衣服','9阶红2星衣服【重炮手】',2,'[{lv,300}]',2,'[]','[1002010932,1004010932,1006010932,1008010932,1010010932,1002020932,1004020932,1006020932,1008020932,1010020932,1002030932,1004030932,1006030932,1008030932,1010030932,1002040932,1004040932,1006040932,1008040932,1010040932]','[]','[]','[{0,1004040942,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34070905,'刻痕','9阶红2星刻痕【通用】',2,'[{lv,300}]',2,'[]','[1005000932,1009000932,1005000932,1009000932,1005000932,1009000932,1005000932,1009000932]','[]','[]','[{0,1005000942,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34070906,'裤子','9阶红2星裤子【重炮手】',2,'[{lv,300}]',2,'[]','[1002010932,1004010932,1006010932,1008010932,1010010932,1002020932,1004020932,1006020932,1008020932,1010020932,1002030932,1004030932,1006030932,1008030932,1010030932,1002040932,1004040932,1006040932,1008040932,1010040932]','[]','[]','[{0,1006040942,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34070907,'副手','9阶红2星副手【重炮手】',2,'[{lv,300}]',2,'[]','[1001010932,1007010932,1001020932,1007020932,1001030932,1007030932,1001040932,1007040932]','[]','[]','[{0,1007040942,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34070908,'护腕','9阶红2星护腕【重炮手】',2,'[{lv,300}]',2,'[]','[1002010932,1004010932,1006010932,1008010932,1010010932,1002020932,1004020932,1006020932,1008020932,1010020932,1002030932,1004030932,1006030932,1008030932,1010030932,1002040932,1004040932,1006040932,1008040932,1010040932]','[]','[]','[{0,1008040942,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34070909,'戒指','9阶红2星戒指【通用】',2,'[{lv,300}]',2,'[]','[1005000932,1009000932,1005000932,1009000932,1005000932,1009000932,1005000932,1009000932]','[]','[]','[{0,1009000942,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34070910,'鞋子','9阶红2星鞋子【重炮手】',2,'[{lv,300}]',2,'[]','[1002010932,1004010932,1006010932,1008010932,1010010932,1002020932,1004020932,1006020932,1008020932,1010020932,1002030932,1004030932,1006030932,1008030932,1010030932,1002040932,1004040932,1006040932,1008040932,1010040932]','[]','[]','[{0,1010040942,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071001,'武器','10阶红2星武器【重炮手】',2,'[{lv,355}]',2,'[]','[1001011032,1007011032,1001021032,1007021032,1001031032,1007031032,1001041032,1007041032]','[]','[]','[{0,1001041042,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071002,'头盔','10阶红2星头盔【重炮手】',2,'[{lv,355}]',2,'[]','[1002011032,1004011032,1006011032,1008011032,1010011032,1002021032,1004021032,1006021032,1008021032,1010021032,1002031032,1004031032,1006031032,1008031032,1010031032,1002041032,1004041032,1006041032,1008041032,1010041032]','[]','[]','[{0,1002041042,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071003,'项链','10阶红2星项链【通用】',2,'[{lv,355}]',2,'[]','[1003001032,1003001032,1003001032,1003001032]','[]','[]','[{0,1003001042,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071004,'衣服','10阶红2星衣服【重炮手】',2,'[{lv,355}]',2,'[]','[1002011032,1004011032,1006011032,1008011032,1010011032,1002021032,1004021032,1006021032,1008021032,1010021032,1002031032,1004031032,1006031032,1008031032,1010031032,1002041032,1004041032,1006041032,1008041032,1010041032]','[]','[]','[{0,1004041042,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071005,'刻痕','10阶红2星刻痕【通用】',2,'[{lv,355}]',2,'[]','[1005001032,1009001032,1005001032,1009001032,1005001032,1009001032,1005001032,1009001032]','[]','[]','[{0,1005001042,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071006,'裤子','10阶红2星裤子【重炮手】',2,'[{lv,355}]',2,'[]','[1002011032,1004011032,1006011032,1008011032,1010011032,1002021032,1004021032,1006021032,1008021032,1010021032,1002031032,1004031032,1006031032,1008031032,1010031032,1002041032,1004041032,1006041032,1008041032,1010041032]','[]','[]','[{0,1006041042,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071007,'副手','10阶红2星副手【重炮手】',2,'[{lv,355}]',2,'[]','[1001011032,1007011032,1001021032,1007021032,1001031032,1007031032,1001041032,1007041032]','[]','[]','[{0,1007041042,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071008,'护腕','10阶红2星护腕【重炮手】',2,'[{lv,355}]',2,'[]','[1002011032,1004011032,1006011032,1008011032,1010011032,1002021032,1004021032,1006021032,1008021032,1010021032,1002031032,1004031032,1006031032,1008031032,1010031032,1002041032,1004041032,1006041032,1008041032,1010041032]','[]','[]','[{0,1008041042,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071009,'戒指','10阶红2星戒指【通用】',2,'[{lv,355}]',2,'[]','[1005001032,1009001032,1005001032,1009001032,1005001032,1009001032,1005001032,1009001032]','[]','[]','[{0,1009001042,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071010,'鞋子','10阶红2星鞋子【重炮手】',2,'[{lv,355}]',2,'[]','[1002011032,1004011032,1006011032,1008011032,1010011032,1002021032,1004021032,1006021032,1008021032,1010021032,1002031032,1004031032,1006031032,1008031032,1010031032,1002041032,1004041032,1006041032,1008041032,1010041032]','[]','[]','[{0,1010041042,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071101,'武器','11阶红2星武器【重炮手】',2,'[{lv,400}]',2,'[]','[1001011132,1007011132,1001021132,1007021132,1001031132,1007031132,1001041132,1007041132]','[]','[]','[{0,1001041142,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071102,'头盔','11阶红2星头盔【重炮手】',2,'[{lv,400}]',2,'[]','[1002011132,1004011132,1006011132,1008011132,1010011132,1002021132,1004021132,1006021132,1008021132,1010021132,1002031132,1004031132,1006031132,1008031132,1010031132,1002041132,1004041132,1006041132,1008041132,1010041132]','[]','[]','[{0,1002041142,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071103,'项链','11阶红2星项链【通用】',2,'[{lv,400}]',2,'[]','[1003001132,1003001132,1003001132,1003001132]','[]','[]','[{0,1003001142,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071104,'衣服','11阶红2星衣服【重炮手】',2,'[{lv,400}]',2,'[]','[1002011132,1004011132,1006011132,1008011132,1010011132,1002021132,1004021132,1006021132,1008021132,1010021132,1002031132,1004031132,1006031132,1008031132,1010031132,1002041132,1004041132,1006041132,1008041132,1010041132]','[]','[]','[{0,1004041142,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071105,'刻痕','11阶红2星刻痕【通用】',2,'[{lv,400}]',2,'[]','[1005001132,1009001132,1005001132,1009001132,1005001132,1009001132,1005001132,1009001132]','[]','[]','[{0,1005001142,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071106,'裤子','11阶红2星裤子【重炮手】',2,'[{lv,400}]',2,'[]','[1002011132,1004011132,1006011132,1008011132,1010011132,1002021132,1004021132,1006021132,1008021132,1010021132,1002031132,1004031132,1006031132,1008031132,1010031132,1002041132,1004041132,1006041132,1008041132,1010041132]','[]','[]','[{0,1006041142,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071107,'副手','11阶红2星副手【重炮手】',2,'[{lv,400}]',2,'[]','[1001011132,1007011132,1001021132,1007021132,1001031132,1007031132,1001041132,1007041132]','[]','[]','[{0,1007041142,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071108,'护腕','11阶红2星护腕【重炮手】',2,'[{lv,400}]',2,'[]','[1002011132,1004011132,1006011132,1008011132,1010011132,1002021132,1004021132,1006021132,1008021132,1010021132,1002031132,1004031132,1006031132,1008031132,1010031132,1002041132,1004041132,1006041132,1008041132,1010041132]','[]','[]','[{0,1008041142,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071109,'戒指','11阶红2星戒指【通用】',2,'[{lv,400}]',2,'[]','[1005001132,1009001132,1005001132,1009001132,1005001132,1009001132,1005001132,1009001132]','[]','[]','[{0,1009001142,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071110,'鞋子','11阶红2星鞋子【重炮手】',2,'[{lv,400}]',2,'[]','[1002011132,1004011132,1006011132,1008011132,1010011132,1002021132,1004021132,1006021132,1008021132,1010021132,1002031132,1004031132,1006031132,1008031132,1010031132,1002041132,1004041132,1006041132,1008041132,1010041132]','[]','[]','[{0,1010041142,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071201,'武器','12阶红2星武器【重炮手】',2,'[{lv,500}]',2,'[]','[1001011232,1007011232,1001021232,1007021232,1001031232,1007031232,1001041232,1007041232]','[]','[]','[{0,1001041242,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071202,'头盔','12阶红2星头盔【重炮手】',2,'[{lv,500}]',2,'[]','[1002011232,1004011232,1006011232,1008011232,1010011232,1002021232,1004021232,1006021232,1008021232,1010021232,1002031232,1004031232,1006031232,1008031232,1010031232,1002041232,1004041232,1006041232,1008041232,1010041232]','[]','[]','[{0,1002041242,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071203,'项链','12阶红2星项链【通用】',2,'[{lv,500}]',2,'[]','[1003001232,1003001232,1003001232,1003001232]','[]','[]','[{0,1003001242,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071204,'衣服','12阶红2星衣服【重炮手】',2,'[{lv,500}]',2,'[]','[1002011232,1004011232,1006011232,1008011232,1010011232,1002021232,1004021232,1006021232,1008021232,1010021232,1002031232,1004031232,1006031232,1008031232,1010031232,1002041232,1004041232,1006041232,1008041232,1010041232]','[]','[]','[{0,1004041242,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071205,'刻痕','12阶红2星刻痕【通用】',2,'[{lv,500}]',2,'[]','[1005001232,1009001232,1005001232,1009001232,1005001232,1009001232,1005001232,1009001232]','[]','[]','[{0,1005001242,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071206,'裤子','12阶红2星裤子【重炮手】',2,'[{lv,500}]',2,'[]','[1002011232,1004011232,1006011232,1008011232,1010011232,1002021232,1004021232,1006021232,1008021232,1010021232,1002031232,1004031232,1006031232,1008031232,1010031232,1002041232,1004041232,1006041232,1008041232,1010041232]','[]','[]','[{0,1006041242,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071207,'副手','12阶红2星副手【重炮手】',2,'[{lv,500}]',2,'[]','[1001011232,1007011232,1001021232,1007021232,1001031232,1007031232,1001041232,1007041232]','[]','[]','[{0,1007041242,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071208,'护腕','12阶红2星护腕【重炮手】',2,'[{lv,500}]',2,'[]','[1002011232,1004011232,1006011232,1008011232,1010011232,1002021232,1004021232,1006021232,1008021232,1010021232,1002031232,1004031232,1006031232,1008031232,1010031232,1002041232,1004041232,1006041232,1008041232,1010041232]','[]','[]','[{0,1008041242,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071209,'戒指','12阶红2星戒指【通用】',2,'[{lv,500}]',2,'[]','[1005001232,1009001232,1005001232,1009001232,1005001232,1009001232,1005001232,1009001232]','[]','[]','[{0,1009001242,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071210,'鞋子','12阶红2星鞋子【重炮手】',2,'[{lv,500}]',2,'[]','[1002011232,1004011232,1006011232,1008011232,1010011232,1002021232,1004021232,1006021232,1008021232,1010021232,1002031232,1004031232,1006031232,1008031232,1010031232,1002041232,1004041232,1006041232,1008041232,1010041232]','[]','[]','[{0,1010041242,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071301,'武器','13阶红2星武器【重炮手】',2,'[{lv,520}]',2,'[]','[1001011332,1007011332,1001021332,1007021332,1001031332,1007031332,1001041332,1007041332]','[]','[]','[{0,1001041342,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071302,'头盔','13阶红2星头盔【重炮手】',2,'[{lv,520}]',2,'[]','[1002011332,1004011332,1006011332,1008011332,1010011332,1002021332,1004021332,1006021332,1008021332,1010021332,1002031332,1004031332,1006031332,1008031332,1010031332,1002041332,1004041332,1006041332,1008041332,1010041332]','[]','[]','[{0,1002041342,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071303,'项链','13阶红2星项链【通用】',2,'[{lv,520}]',2,'[]','[1003001332,1003001332,1003001332,1003001332]','[]','[]','[{0,1003001342,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071304,'衣服','13阶红2星衣服【重炮手】',2,'[{lv,520}]',2,'[]','[1002011332,1004011332,1006011332,1008011332,1010011332,1002021332,1004021332,1006021332,1008021332,1010021332,1002031332,1004031332,1006031332,1008031332,1010031332,1002041332,1004041332,1006041332,1008041332,1010041332]','[]','[]','[{0,1004041342,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071305,'刻痕','13阶红2星刻痕【通用】',2,'[{lv,520}]',2,'[]','[1005001332,1009001332,1005001332,1009001332,1005001332,1009001332,1005001332,1009001332]','[]','[]','[{0,1005001342,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071306,'裤子','13阶红2星裤子【重炮手】',2,'[{lv,520}]',2,'[]','[1002011332,1004011332,1006011332,1008011332,1010011332,1002021332,1004021332,1006021332,1008021332,1010021332,1002031332,1004031332,1006031332,1008031332,1010031332,1002041332,1004041332,1006041332,1008041332,1010041332]','[]','[]','[{0,1006041342,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071307,'副手','13阶红2星副手【重炮手】',2,'[{lv,520}]',2,'[]','[1001011332,1007011332,1001021332,1007021332,1001031332,1007031332,1001041332,1007041332]','[]','[]','[{0,1007041342,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071308,'护腕','13阶红2星护腕【重炮手】',2,'[{lv,520}]',2,'[]','[1002011332,1004011332,1006011332,1008011332,1010011332,1002021332,1004021332,1006021332,1008021332,1010021332,1002031332,1004031332,1006031332,1008031332,1010031332,1002041332,1004041332,1006041332,1008041332,1010041332]','[]','[]','[{0,1008041342,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071309,'戒指','13阶红2星戒指【通用】',2,'[{lv,520}]',2,'[]','[1005001332,1009001332,1005001332,1009001332,1005001332,1009001332,1005001332,1009001332]','[]','[]','[{0,1009001342,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071310,'鞋子','13阶红2星鞋子【重炮手】',2,'[{lv,520}]',2,'[]','[1002011332,1004011332,1006011332,1008011332,1010011332,1002021332,1004021332,1006021332,1008021332,1010021332,1002031332,1004031332,1006031332,1008031332,1010031332,1002041332,1004041332,1006041332,1008041332,1010041332]','[]','[]','[{0,1010041342,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071401,'武器','14阶红2星武器【重炮手】',2,'[{lv,620}]',2,'[]','[1001011432,1007011432,1001021432,1007021432,1001031432,1007031432,1001041432,1007041432]','[]','[]','[{0,1001041442,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071402,'头盔','14阶红2星头盔【重炮手】',2,'[{lv,620}]',2,'[]','[1002011432,1004011432,1006011432,1008011432,1010011432,1002021432,1004021432,1006021432,1008021432,1010021432,1002031432,1004031432,1006031432,1008031432,1010031432,1002041432,1004041432,1006041432,1008041432,1010041432]','[]','[]','[{0,1002041442,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071403,'项链','14阶红2星项链【通用】',2,'[{lv,620}]',2,'[]','[1003001432,1003001432,1003001432,1003001432]','[]','[]','[{0,1003001442,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071404,'衣服','14阶红2星衣服【重炮手】',2,'[{lv,620}]',2,'[]','[1002011432,1004011432,1006011432,1008011432,1010011432,1002021432,1004021432,1006021432,1008021432,1010021432,1002031432,1004031432,1006031432,1008031432,1010031432,1002041432,1004041432,1006041432,1008041432,1010041432]','[]','[]','[{0,1004041442,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071405,'刻痕','14阶红2星刻痕【通用】',2,'[{lv,620}]',2,'[]','[1005001432,1009001432,1005001432,1009001432,1005001432,1009001432,1005001432,1009001432]','[]','[]','[{0,1005001442,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071406,'裤子','14阶红2星裤子【重炮手】',2,'[{lv,620}]',2,'[]','[1002011432,1004011432,1006011432,1008011432,1010011432,1002021432,1004021432,1006021432,1008021432,1010021432,1002031432,1004031432,1006031432,1008031432,1010031432,1002041432,1004041432,1006041432,1008041432,1010041432]','[]','[]','[{0,1006041442,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071407,'副手','14阶红2星副手【重炮手】',2,'[{lv,620}]',2,'[]','[1001011432,1007011432,1001021432,1007021432,1001031432,1007031432,1001041432,1007041432]','[]','[]','[{0,1007041442,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071408,'护腕','14阶红2星护腕【重炮手】',2,'[{lv,620}]',2,'[]','[1002011432,1004011432,1006011432,1008011432,1010011432,1002021432,1004021432,1006021432,1008021432,1010021432,1002031432,1004031432,1006031432,1008031432,1010031432,1002041432,1004041432,1006041432,1008041432,1010041432]','[]','[]','[{0,1008041442,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071409,'戒指','14阶红2星戒指【通用】',2,'[{lv,620}]',2,'[]','[1005001432,1009001432,1005001432,1009001432,1005001432,1009001432,1005001432,1009001432]','[]','[]','[{0,1009001442,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071410,'鞋子','14阶红2星鞋子【重炮手】',2,'[{lv,620}]',2,'[]','[1002011432,1004011432,1006011432,1008011432,1010011432,1002021432,1004021432,1006021432,1008021432,1010021432,1002031432,1004031432,1006031432,1008031432,1010031432,1002041432,1004041432,1006041432,1008041432,1010041432]','[]','[]','[{0,1010041442,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071501,'武器','15阶红2星武器【重炮手】',2,'[{lv,650}]',2,'[]','[1001011532,1007011532,1001021532,1007021532,1001031532,1007031532,1001041532,1007041532]','[]','[]','[{0,1001041542,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071502,'头盔','15阶红2星头盔【重炮手】',2,'[{lv,650}]',2,'[]','[1002011532,1004011532,1006011532,1008011532,1010011532,1002021532,1004021532,1006021532,1008021532,1010021532,1002031532,1004031532,1006031532,1008031532,1010031532,1002041532,1004041532,1006041532,1008041532,1010041532]','[]','[]','[{0,1002041542,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071503,'项链','15阶红2星项链【通用】',2,'[{lv,650}]',2,'[]','[1003001532,1003001532,1003001532,1003001532]','[]','[]','[{0,1003001542,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071504,'衣服','15阶红2星衣服【重炮手】',2,'[{lv,650}]',2,'[]','[1002011532,1004011532,1006011532,1008011532,1010011532,1002021532,1004021532,1006021532,1008021532,1010021532,1002031532,1004031532,1006031532,1008031532,1010031532,1002041532,1004041532,1006041532,1008041532,1010041532]','[]','[]','[{0,1004041542,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071505,'刻痕','15阶红2星刻痕【通用】',2,'[{lv,650}]',2,'[]','[1005001532,1009001532,1005001532,1009001532,1005001532,1009001532,1005001532,1009001532]','[]','[]','[{0,1005001542,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071506,'裤子','15阶红2星裤子【重炮手】',2,'[{lv,650}]',2,'[]','[1002011532,1004011532,1006011532,1008011532,1010011532,1002021532,1004021532,1006021532,1008021532,1010021532,1002031532,1004031532,1006031532,1008031532,1010031532,1002041532,1004041532,1006041532,1008041532,1010041532]','[]','[]','[{0,1006041542,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071507,'副手','15阶红2星副手【重炮手】',2,'[{lv,650}]',2,'[]','[1001011532,1007011532,1001021532,1007021532,1001031532,1007031532,1001041532,1007041532]','[]','[]','[{0,1007041542,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071508,'护腕','15阶红2星护腕【重炮手】',2,'[{lv,650}]',2,'[]','[1002011532,1004011532,1006011532,1008011532,1010011532,1002021532,1004021532,1006021532,1008021532,1010021532,1002031532,1004031532,1006031532,1008031532,1010031532,1002041532,1004041532,1006041532,1008041532,1010041532]','[]','[]','[{0,1008041542,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071509,'戒指','15阶红2星戒指【通用】',2,'[{lv,650}]',2,'[]','[1005001532,1009001532,1005001532,1009001532,1005001532,1009001532,1005001532,1009001532]','[]','[]','[{0,1009001542,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071510,'鞋子','15阶红2星鞋子【重炮手】',2,'[{lv,650}]',2,'[]','[1002011532,1004011532,1006011532,1008011532,1010011532,1002021532,1004021532,1006021532,1008021532,1010021532,1002031532,1004031532,1006031532,1008031532,1010031532,1002041532,1004041532,1006041532,1008041532,1010041532]','[]','[]','[{0,1010041542,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071601,'武器','16阶红2星武器【重炮手】',2,'[{lv,700}]',2,'[]','[1001011632,1007011632,1001021632,1007021632,1001031632,1007031632,1001041632,1007041632]','[]','[]','[{0,1001041642,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071602,'头盔','16阶红2星头盔【重炮手】',2,'[{lv,700}]',2,'[]','[1002011632,1004011632,1006011632,1008011632,1010011632,1002021632,1004021632,1006021632,1008021632,1010021632,1002031632,1004031632,1006031632,1008031632,1010031632,1002041632,1004041632,1006041632,1008041632,1010041632]','[]','[]','[{0,1002041642,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071603,'项链','16阶红2星项链【通用】',2,'[{lv,700}]',2,'[]','[1003001632,1003001632,1003001632,1003001632]','[]','[]','[{0,1003001642,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071604,'衣服','16阶红2星衣服【重炮手】',2,'[{lv,700}]',2,'[]','[1002011632,1004011632,1006011632,1008011632,1010011632,1002021632,1004021632,1006021632,1008021632,1010021632,1002031632,1004031632,1006031632,1008031632,1010031632,1002041632,1004041632,1006041632,1008041632,1010041632]','[]','[]','[{0,1004041642,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071605,'刻痕','16阶红2星刻痕【通用】',2,'[{lv,700}]',2,'[]','[1005001632,1009001632,1005001632,1009001632,1005001632,1009001632,1005001632,1009001632]','[]','[]','[{0,1005001642,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071606,'裤子','16阶红2星裤子【重炮手】',2,'[{lv,700}]',2,'[]','[1002011632,1004011632,1006011632,1008011632,1010011632,1002021632,1004021632,1006021632,1008021632,1010021632,1002031632,1004031632,1006031632,1008031632,1010031632,1002041632,1004041632,1006041632,1008041632,1010041632]','[]','[]','[{0,1006041642,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071607,'副手','16阶红2星副手【重炮手】',2,'[{lv,700}]',2,'[]','[1001011632,1007011632,1001021632,1007021632,1001031632,1007031632,1001041632,1007041632]','[]','[]','[{0,1007041642,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071608,'护腕','16阶红2星护腕【重炮手】',2,'[{lv,700}]',2,'[]','[1002011632,1004011632,1006011632,1008011632,1010011632,1002021632,1004021632,1006021632,1008021632,1010021632,1002031632,1004031632,1006031632,1008031632,1010031632,1002041632,1004041632,1006041632,1008041632,1010041632]','[]','[]','[{0,1008041642,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071609,'戒指','16阶红2星戒指【通用】',2,'[{lv,700}]',2,'[]','[1005001632,1009001632,1005001632,1009001632,1005001632,1009001632,1005001632,1009001632]','[]','[]','[{0,1009001642,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34071610,'鞋子','16阶红2星鞋子【重炮手】',2,'[{lv,700}]',2,'[]','[1002011632,1004011632,1006011632,1008011632,1010011632,1002021632,1004021632,1006021632,1008021632,1010021632,1002031632,1004031632,1006031632,1008031632,1010031632,1002041632,1004041632,1006041632,1008041632,1010041632]','[]','[]','[{0,1010041642,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34080301,'武器','3阶红3星武器【重炮手】',2,'[{lv,9999}]',2,'[]','[1001010342,1007010342,1001020342,1007020342,1001030342,1007030342,1001040342,1007040342]','[]','[]','[{0,1001040343,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(34080302,'头盔','3阶红3星头盔【重炮手】',2,'[{lv,9999}]',2,'[]','[1002010342,1004010342,1006010342,1008010342,1010010342,1002020342,1004020342,1006020342,1008020342,1010020342,1002030342,1004030342,1006030342,1008030342,1010030342,1002040342,1004040342,1006040342,1008040342,1010040342]','[]','[]','[{0,1002040343,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(34080303,'项链','3阶红3星项链【通用】',2,'[{lv,9999}]',2,'[]','[1003000342,1003000342,1003000342,1003000342]','[]','[]','[{0,1003000343,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(34080304,'衣服','3阶红3星衣服【重炮手】',2,'[{lv,9999}]',2,'[]','[1002010342,1004010342,1006010342,1008010342,1010010342,1002020342,1004020342,1006020342,1008020342,1010020342,1002030342,1004030342,1006030342,1008030342,1010030342,1002040342,1004040342,1006040342,1008040342,1010040342]','[]','[]','[{0,1004040343,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(34080305,'刻痕','3阶红3星刻痕【通用】',2,'[{lv,9999}]',2,'[]','[1005000342,1009000342,1005000342,1009000342,1005000342,1009000342,1005000342,1009000342]','[]','[]','[{0,1005000343,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(34080306,'裤子','3阶红3星裤子【重炮手】',2,'[{lv,9999}]',2,'[]','[1002010342,1004010342,1006010342,1008010342,1010010342,1002020342,1004020342,1006020342,1008020342,1010020342,1002030342,1004030342,1006030342,1008030342,1010030342,1002040342,1004040342,1006040342,1008040342,1010040342]','[]','[]','[{0,1006040343,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(34080307,'副手','3阶红3星副手【重炮手】',2,'[{lv,9999}]',2,'[]','[1001010342,1007010342,1001020342,1007020342,1001030342,1007030342,1001040342,1007040342]','[]','[]','[{0,1007040343,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(34080308,'护腕','3阶红3星护腕【重炮手】',2,'[{lv,9999}]',2,'[]','[1002010342,1004010342,1006010342,1008010342,1010010342,1002020342,1004020342,1006020342,1008020342,1010020342,1002030342,1004030342,1006030342,1008030342,1010030342,1002040342,1004040342,1006040342,1008040342,1010040342]','[]','[]','[{0,1008040343,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(34080309,'戒指','3阶红3星戒指【通用】',2,'[{lv,9999}]',2,'[]','[1005000342,1009000342,1005000342,1009000342,1005000342,1009000342,1005000342,1009000342]','[]','[]','[{0,1009000343,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(34080310,'鞋子','3阶红3星鞋子【重炮手】',2,'[{lv,9999}]',2,'[]','[1002010342,1004010342,1006010342,1008010342,1010010342,1002020342,1004020342,1006020342,1008020342,1010020342,1002030342,1004030342,1006030342,1008030342,1010030342,1002040342,1004040342,1006040342,1008040342,1010040342]','[]','[]','[{0,1010040343,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(34080401,'武器','4阶红3星武器【重炮手】',2,'[{lv,160}]',2,'[]','[1001010442,1007010442,1001020442,1007020442,1001030442,1007030442,1001040442,1007040442,1101010442,1107010442,1101020442,1107020442,1101030442,1107030442,1101040442,1107040442]','[]','[]','[{0,1001040443,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(34080402,'头盔','4阶红3星头盔【重炮手】',2,'[{lv,160}]',2,'[]','[1002010442,1004010442,1006010442,1008010442,1010010442,1002020442,1004020442,1006020442,1008020442,1010020442,1002030442,1004030442,1006030442,1008030442,1010030442,1002040442,1004040442,1006040442,1008040442,1010040442,1102010442,1104010442,1106010442,1108010442,1110010442,1102020442,1104020442,1106020442,1108020442,1110020442,1102030442,1104030442,1106030442,1108030442,1110030442,1102040442,1104040442,1106040442,1108040442,1110040442]','[]','[]','[{0,1002040443,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(34080403,'项链','4阶红3星项链【通用】',2,'[{lv,160}]',2,'[]','[1003000442,1003000442,1003000442,1003000442,1103000442,1103000442,1103000442,1103000442]','[]','[]','[{0,1003000443,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(34080404,'衣服','4阶红3星衣服【重炮手】',2,'[{lv,160}]',2,'[]','[1002010442,1004010442,1006010442,1008010442,1010010442,1002020442,1004020442,1006020442,1008020442,1010020442,1002030442,1004030442,1006030442,1008030442,1010030442,1002040442,1004040442,1006040442,1008040442,1010040442,1102010442,1104010442,1106010442,1108010442,1110010442,1102020442,1104020442,1106020442,1108020442,1110020442,1102030442,1104030442,1106030442,1108030442,1110030442,1102040442,1104040442,1106040442,1108040442,1110040442]','[]','[]','[{0,1004040443,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(34080405,'刻痕','4阶红3星刻痕【通用】',2,'[{lv,160}]',2,'[]','[1005000442,1009000442,1005000442,1009000442,1005000442,1009000442,1005000442,1009000442,1105000442,1109000442,1105000442,1109000442,1105000442,1109000442,1105000442,1109000442]','[]','[]','[{0,1005000443,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(34080406,'裤子','4阶红3星裤子【重炮手】',2,'[{lv,160}]',2,'[]','[1002010442,1004010442,1006010442,1008010442,1010010442,1002020442,1004020442,1006020442,1008020442,1010020442,1002030442,1004030442,1006030442,1008030442,1010030442,1002040442,1004040442,1006040442,1008040442,1010040442,1102010442,1104010442,1106010442,1108010442,1110010442,1102020442,1104020442,1106020442,1108020442,1110020442,1102030442,1104030442,1106030442,1108030442,1110030442,1102040442,1104040442,1106040442,1108040442,1110040442]','[]','[]','[{0,1006040443,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(34080407,'副手','4阶红3星副手【重炮手】',2,'[{lv,160}]',2,'[]','[1001010442,1007010442,1001020442,1007020442,1001030442,1007030442,1001040442,1007040442,1101010442,1107010442,1101020442,1107020442,1101030442,1107030442,1101040442,1107040442]','[]','[]','[{0,1007040443,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(34080408,'护腕','4阶红3星护腕【重炮手】',2,'[{lv,160}]',2,'[]','[1002010442,1004010442,1006010442,1008010442,1010010442,1002020442,1004020442,1006020442,1008020442,1010020442,1002030442,1004030442,1006030442,1008030442,1010030442,1002040442,1004040442,1006040442,1008040442,1010040442,1102010442,1104010442,1106010442,1108010442,1110010442,1102020442,1104020442,1106020442,1108020442,1110020442,1102030442,1104030442,1106030442,1108030442,1110030442,1102040442,1104040442,1106040442,1108040442,1110040442]','[]','[]','[{0,1008040443,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(34080409,'戒指','4阶红3星戒指【通用】',2,'[{lv,160}]',2,'[]','[1005000442,1009000442,1005000442,1009000442,1005000442,1009000442,1005000442,1009000442,1105000442,1109000442,1105000442,1109000442,1105000442,1109000442,1105000442,1109000442]','[]','[]','[{0,1009000443,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(34080410,'鞋子','4阶红3星鞋子【重炮手】',2,'[{lv,160}]',2,'[]','[1002010442,1004010442,1006010442,1008010442,1010010442,1002020442,1004020442,1006020442,1008020442,1010020442,1002030442,1004030442,1006030442,1008030442,1010030442,1002040442,1004040442,1006040442,1008040442,1010040442,1102010442,1104010442,1106010442,1108010442,1110010442,1102020442,1104020442,1106020442,1108020442,1110020442,1102030442,1104030442,1106030442,1108030442,1110030442,1102040442,1104040442,1106040442,1108040442,1110040442]','[]','[]','[{0,1010040443,1}]',2,'[{1,0},{2,0},{3,100}]',3,1,'[]',150),(34080501,'武器','5阶红3星武器【重炮手】',2,'[{lv,160}]',2,'[]','[1001010542,1007010542,1001020542,1007020542,1001030542,1007030542,1001040542,1007040542,1101010542,1101020542,1101030542,1101040542]','[]','[]','[{0,1001040543,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(34080502,'头盔','5阶红3星头盔【重炮手】',2,'[{lv,160}]',2,'[]','[1002010542,1004010542,1006010542,1008010542,1010010542,1002020542,1004020542,1006020542,1008020542,1010020542,1002030542,1004030542,1006030542,1008030542,1010030542,1002040542,1004040542,1006040542,1008040542,1010040542,1102010542,1104010542,1106010542,1102020542,1104020542,1106020542,1102030542,1104030542,1106030542,1102040542,1104040542,1106040542]','[]','[]','[{0,1002040543,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(34080503,'项链','5阶红3星项链【通用】',2,'[{lv,160}]',2,'[]','[1003000542,1003000542,1003000542,1003000542,1103000542,1103000542,1103000542,1103000542]','[]','[]','[{0,1003000543,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(34080504,'衣服','5阶红3星衣服【重炮手】',2,'[{lv,160}]',2,'[]','[1002010542,1004010542,1006010542,1008010542,1010010542,1002020542,1004020542,1006020542,1008020542,1010020542,1002030542,1004030542,1006030542,1008030542,1010030542,1002040542,1004040542,1006040542,1008040542,1010040542,1102010542,1104010542,1106010542,1102020542,1104020542,1106020542,1102030542,1104030542,1106030542,1102040542,1104040542,1106040542]','[]','[]','[{0,1004040543,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(34080505,'刻痕','5阶红3星刻痕【通用】',2,'[{lv,160}]',2,'[]','[1005000542,1009000542,1005000542,1009000542,1005000542,1009000542,1005000542,1009000542,1105000542,1105000542,1105000542,1105000542]','[]','[]','[{0,1005000543,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(34080506,'裤子','5阶红3星裤子【重炮手】',2,'[{lv,160}]',2,'[]','[1002010542,1004010542,1006010542,1008010542,1010010542,1002020542,1004020542,1006020542,1008020542,1010020542,1002030542,1004030542,1006030542,1008030542,1010030542,1002040542,1004040542,1006040542,1008040542,1010040542,1102010542,1104010542,1106010542,1102020542,1104020542,1106020542,1102030542,1104030542,1106030542,1102040542,1104040542,1106040542]','[]','[]','[{0,1006040543,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(34080507,'副手','5阶红3星副手【重炮手】',2,'[{lv,160}]',2,'[]','[1001010542,1007010542,1001020542,1007020542,1001030542,1007030542,1001040542,1007040542,1101010542,1101020542,1101030542,1101040542]','[]','[]','[{0,1007040543,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(34080508,'护腕','5阶红3星护腕【重炮手】',2,'[{lv,160}]',2,'[]','[1002010542,1004010542,1006010542,1008010542,1010010542,1002020542,1004020542,1006020542,1008020542,1010020542,1002030542,1004030542,1006030542,1008030542,1010030542,1002040542,1004040542,1006040542,1008040542,1010040542,1102010542,1104010542,1106010542,1102020542,1104020542,1106020542,1102030542,1104030542,1106030542,1102040542,1104040542,1106040542]','[]','[]','[{0,1008040543,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(34080509,'戒指','5阶红3星戒指【通用】',2,'[{lv,160}]',2,'[]','[1005000542,1009000542,1005000542,1009000542,1005000542,1009000542,1005000542,1009000542,1105000542,1105000542,1105000542,1105000542]','[]','[]','[{0,1009000543,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(34080510,'鞋子','5阶红3星鞋子【重炮手】',2,'[{lv,160}]',2,'[]','[1002010542,1004010542,1006010542,1008010542,1010010542,1002020542,1004020542,1006020542,1008020542,1010020542,1002030542,1004030542,1006030542,1008030542,1010030542,1002040542,1004040542,1006040542,1008040542,1010040542,1102010542,1104010542,1106010542,1102020542,1104020542,1106020542,1102030542,1104030542,1106030542,1102040542,1104040542,1106040542]','[]','[]','[{0,1010040543,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(34080601,'武器','6阶红3星武器【重炮手】',2,'[{lv,180}]',2,'[]','[1001010642,1007010642,1001020642,1007020642,1001030642,1007030642,1001040642,1007040642]','[]','[]','[{0,1001040643,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(34080602,'头盔','6阶红3星头盔【重炮手】',2,'[{lv,180}]',2,'[]','[1002010642,1004010642,1006010642,1008010642,1010010642,1002020642,1004020642,1006020642,1008020642,1010020642,1002030642,1004030642,1006030642,1008030642,1010030642,1002040642,1004040642,1006040642,1008040642,1010040642]','[]','[]','[{0,1002040643,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(34080603,'项链','6阶红3星项链【通用】',2,'[{lv,180}]',2,'[]','[1003000642,1003000642,1003000642,1003000642]','[]','[]','[{0,1003000643,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(34080604,'衣服','6阶红3星衣服【重炮手】',2,'[{lv,180}]',2,'[]','[1002010642,1004010642,1006010642,1008010642,1010010642,1002020642,1004020642,1006020642,1008020642,1010020642,1002030642,1004030642,1006030642,1008030642,1010030642,1002040642,1004040642,1006040642,1008040642,1010040642]','[]','[]','[{0,1004040643,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(34080605,'刻痕','6阶红3星刻痕【通用】',2,'[{lv,180}]',2,'[]','[1005000642,1009000642,1005000642,1009000642,1005000642,1009000642,1005000642,1009000642]','[]','[]','[{0,1005000643,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(34080606,'裤子','6阶红3星裤子【重炮手】',2,'[{lv,180}]',2,'[]','[1002010642,1004010642,1006010642,1008010642,1010010642,1002020642,1004020642,1006020642,1008020642,1010020642,1002030642,1004030642,1006030642,1008030642,1010030642,1002040642,1004040642,1006040642,1008040642,1010040642]','[]','[]','[{0,1006040643,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(34080607,'副手','6阶红3星副手【重炮手】',2,'[{lv,180}]',2,'[]','[1001010642,1007010642,1001020642,1007020642,1001030642,1007030642,1001040642,1007040642]','[]','[]','[{0,1007040643,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(34080608,'护腕','6阶红3星护腕【重炮手】',2,'[{lv,180}]',2,'[]','[1002010642,1004010642,1006010642,1008010642,1010010642,1002020642,1004020642,1006020642,1008020642,1010020642,1002030642,1004030642,1006030642,1008030642,1010030642,1002040642,1004040642,1006040642,1008040642,1010040642]','[]','[]','[{0,1008040643,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(34080609,'戒指','6阶红3星戒指【通用】',2,'[{lv,180}]',2,'[]','[1005000642,1009000642,1005000642,1009000642,1005000642,1009000642,1005000642,1009000642]','[]','[]','[{0,1009000643,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(34080610,'鞋子','6阶红3星鞋子【重炮手】',2,'[{lv,180}]',2,'[]','[1002010642,1004010642,1006010642,1008010642,1010010642,1002020642,1004020642,1006020642,1008020642,1010020642,1002030642,1004030642,1006030642,1008030642,1010030642,1002040642,1004040642,1006040642,1008040642,1010040642]','[]','[]','[{0,1010040643,1}]',2,'[{1,0},{2,0},{3,80},{4,100}]',3,1,'[]',150),(34080701,'武器','7阶红3星武器【重炮手】',2,'[{lv,220}]',2,'[]','[1001010742,1007010742,1001020742,1007020742,1001030742,1007030742,1001040742,1007040742,1101010742,1107010742,1101020742,1107020742,1101030742,1107030742,1101040742,1107040742]','[]','[]','[{0,1001040743,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34080702,'头盔','7阶红3星头盔【重炮手】',2,'[{lv,220}]',2,'[]','[1002010742,1004010742,1006010742,1008010742,1010010742,1002020742,1004020742,1006020742,1008020742,1010020742,1002030742,1004030742,1006030742,1008030742,1010030742,1002040742,1004040742,1006040742,1008040742,1010040742,1102010742,1104010742,1106010742,1108010742,1110010742,1102020742,1104020742,1106020742,1108020742,1110020742,1102030742,1104030742,1106030742,1108030742,1110030742,1102040742,1104040742,1106040742,1108040742,1110040742]','[]','[]','[{0,1002040743,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34080703,'项链','7阶红3星项链【通用】',2,'[{lv,220}]',2,'[]','[1003000742,1003000742,1003000742,1003000742,1103000742,1103000742,1103000742,1103000742]','[]','[]','[{0,1003000743,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34080704,'衣服','7阶红3星衣服【重炮手】',2,'[{lv,220}]',2,'[]','[1002010742,1004010742,1006010742,1008010742,1010010742,1002020742,1004020742,1006020742,1008020742,1010020742,1002030742,1004030742,1006030742,1008030742,1010030742,1002040742,1004040742,1006040742,1008040742,1010040742,1102010742,1104010742,1106010742,1108010742,1110010742,1102020742,1104020742,1106020742,1108020742,1110020742,1102030742,1104030742,1106030742,1108030742,1110030742,1102040742,1104040742,1106040742,1108040742,1110040742]','[]','[]','[{0,1004040743,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34080705,'刻痕','7阶红3星刻痕【通用】',2,'[{lv,220}]',2,'[]','[1005000742,1009000742,1005000742,1009000742,1005000742,1009000742,1005000742,1009000742,1105000742,1109000742,1105000742,1109000742,1105000742,1109000742,1105000742,1109000742]','[]','[]','[{0,1005000743,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34080706,'裤子','7阶红3星裤子【重炮手】',2,'[{lv,220}]',2,'[]','[1002010742,1004010742,1006010742,1008010742,1010010742,1002020742,1004020742,1006020742,1008020742,1010020742,1002030742,1004030742,1006030742,1008030742,1010030742,1002040742,1004040742,1006040742,1008040742,1010040742,1102010742,1104010742,1106010742,1108010742,1110010742,1102020742,1104020742,1106020742,1108020742,1110020742,1102030742,1104030742,1106030742,1108030742,1110030742,1102040742,1104040742,1106040742,1108040742,1110040742]','[]','[]','[{0,1006040743,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34080707,'副手','7阶红3星副手【重炮手】',2,'[{lv,220}]',2,'[]','[1001010742,1007010742,1001020742,1007020742,1001030742,1007030742,1001040742,1007040742,1101010742,1107010742,1101020742,1107020742,1101030742,1107030742,1101040742,1107040742]','[]','[]','[{0,1007040743,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34080708,'护腕','7阶红3星护腕【重炮手】',2,'[{lv,220}]',2,'[]','[1002010742,1004010742,1006010742,1008010742,1010010742,1002020742,1004020742,1006020742,1008020742,1010020742,1002030742,1004030742,1006030742,1008030742,1010030742,1002040742,1004040742,1006040742,1008040742,1010040742,1102010742,1104010742,1106010742,1108010742,1110010742,1102020742,1104020742,1106020742,1108020742,1110020742,1102030742,1104030742,1106030742,1108030742,1110030742,1102040742,1104040742,1106040742,1108040742,1110040742]','[]','[]','[{0,1008040743,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34080709,'戒指','7阶红3星戒指【通用】',2,'[{lv,220}]',2,'[]','[1005000742,1009000742,1005000742,1009000742,1005000742,1009000742,1005000742,1009000742,1105000742,1109000742,1105000742,1109000742,1105000742,1109000742,1105000742,1109000742]','[]','[]','[{0,1009000743,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34080710,'鞋子','7阶红3星鞋子【重炮手】',2,'[{lv,220}]',2,'[]','[1002010742,1004010742,1006010742,1008010742,1010010742,1002020742,1004020742,1006020742,1008020742,1010020742,1002030742,1004030742,1006030742,1008030742,1010030742,1002040742,1004040742,1006040742,1008040742,1010040742,1102010742,1104010742,1106010742,1108010742,1110010742,1102020742,1104020742,1106020742,1108020742,1110020742,1102030742,1104030742,1106030742,1108030742,1110030742,1102040742,1104040742,1106040742,1108040742,1110040742]','[]','[]','[{0,1010040743,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34080801,'武器','8阶红3星武器【重炮手】',2,'[{lv,260}]',2,'[]','[1001010842,1007010842,1001020842,1007020842,1001030842,1007030842,1001040842,1007040842,1101010842,1107010842,1101020842,1107020842,1101030842,1107030842,1101040842,1107040842]','[]','[]','[{0,1001040843,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34080802,'头盔','8阶红3星头盔【重炮手】',2,'[{lv,260}]',2,'[]','[1002010842,1004010842,1006010842,1008010842,1010010842,1002020842,1004020842,1006020842,1008020842,1010020842,1002030842,1004030842,1006030842,1008030842,1010030842,1002040842,1004040842,1006040842,1008040842,1010040842,1102010842,1104010842,1106010842,1108010842,1110010842,1102020842,1104020842,1106020842,1108020842,1110020842,1102030842,1104030842,1106030842,1108030842,1110030842,1102040842,1104040842,1106040842,1108040842,1110040842]','[]','[]','[{0,1002040843,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34080803,'项链','8阶红3星项链【通用】',2,'[{lv,260}]',2,'[]','[1003000842,1003000842,1003000842,1003000842,1103000842,1103000842,1103000842,1103000842]','[]','[]','[{0,1003000843,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34080804,'衣服','8阶红3星衣服【重炮手】',2,'[{lv,260}]',2,'[]','[1002010842,1004010842,1006010842,1008010842,1010010842,1002020842,1004020842,1006020842,1008020842,1010020842,1002030842,1004030842,1006030842,1008030842,1010030842,1002040842,1004040842,1006040842,1008040842,1010040842,1102010842,1104010842,1106010842,1108010842,1110010842,1102020842,1104020842,1106020842,1108020842,1110020842,1102030842,1104030842,1106030842,1108030842,1110030842,1102040842,1104040842,1106040842,1108040842,1110040842]','[]','[]','[{0,1004040843,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34080805,'刻痕','8阶红3星刻痕【通用】',2,'[{lv,260}]',2,'[]','[1005000842,1009000842,1005000842,1009000842,1005000842,1009000842,1005000842,1009000842,1105000842,1109000842,1105000842,1109000842,1105000842,1109000842,1105000842,1109000842]','[]','[]','[{0,1005000843,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34080806,'裤子','8阶红3星裤子【重炮手】',2,'[{lv,260}]',2,'[]','[1002010842,1004010842,1006010842,1008010842,1010010842,1002020842,1004020842,1006020842,1008020842,1010020842,1002030842,1004030842,1006030842,1008030842,1010030842,1002040842,1004040842,1006040842,1008040842,1010040842,1102010842,1104010842,1106010842,1108010842,1110010842,1102020842,1104020842,1106020842,1108020842,1110020842,1102030842,1104030842,1106030842,1108030842,1110030842,1102040842,1104040842,1106040842,1108040842,1110040842]','[]','[]','[{0,1006040843,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34080807,'副手','8阶红3星副手【重炮手】',2,'[{lv,260}]',2,'[]','[1001010842,1007010842,1001020842,1007020842,1001030842,1007030842,1001040842,1007040842,1101010842,1107010842,1101020842,1107020842,1101030842,1107030842,1101040842,1107040842]','[]','[]','[{0,1007040843,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34080808,'护腕','8阶红3星护腕【重炮手】',2,'[{lv,260}]',2,'[]','[1002010842,1004010842,1006010842,1008010842,1010010842,1002020842,1004020842,1006020842,1008020842,1010020842,1002030842,1004030842,1006030842,1008030842,1010030842,1002040842,1004040842,1006040842,1008040842,1010040842,1102010842,1104010842,1106010842,1108010842,1110010842,1102020842,1104020842,1106020842,1108020842,1110020842,1102030842,1104030842,1106030842,1108030842,1110030842,1102040842,1104040842,1106040842,1108040842,1110040842]','[]','[]','[{0,1008040843,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34080809,'戒指','8阶红3星戒指【通用】',2,'[{lv,260}]',2,'[]','[1005000842,1009000842,1005000842,1009000842,1005000842,1009000842,1005000842,1009000842,1105000842,1109000842,1105000842,1109000842,1105000842,1109000842,1105000842,1109000842]','[]','[]','[{0,1009000843,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34080810,'鞋子','8阶红3星鞋子【重炮手】',2,'[{lv,260}]',2,'[]','[1002010842,1004010842,1006010842,1008010842,1010010842,1002020842,1004020842,1006020842,1008020842,1010020842,1002030842,1004030842,1006030842,1008030842,1010030842,1002040842,1004040842,1006040842,1008040842,1010040842,1102010842,1104010842,1106010842,1108010842,1110010842,1102020842,1104020842,1106020842,1108020842,1110020842,1102030842,1104030842,1106030842,1108030842,1110030842,1102040842,1104040842,1106040842,1108040842,1110040842]','[]','[]','[{0,1010040843,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34080901,'武器','9阶红3星武器【重炮手】',2,'[{lv,300}]',2,'[]','[1001010942,1007010942,1001020942,1007020942,1001030942,1007030942,1001040942,1007040942]','[]','[]','[{0,1001040943,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34080902,'头盔','9阶红3星头盔【重炮手】',2,'[{lv,300}]',2,'[]','[1002010942,1004010942,1006010942,1008010942,1010010942,1002020942,1004020942,1006020942,1008020942,1010020942,1002030942,1004030942,1006030942,1008030942,1010030942,1002040942,1004040942,1006040942,1008040942,1010040942]','[]','[]','[{0,1002040943,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34080903,'项链','9阶红3星项链【通用】',2,'[{lv,300}]',2,'[]','[1003000942,1003000942,1003000942,1003000942]','[]','[]','[{0,1003000943,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34080904,'衣服','9阶红3星衣服【重炮手】',2,'[{lv,300}]',2,'[]','[1002010942,1004010942,1006010942,1008010942,1010010942,1002020942,1004020942,1006020942,1008020942,1010020942,1002030942,1004030942,1006030942,1008030942,1010030942,1002040942,1004040942,1006040942,1008040942,1010040942]','[]','[]','[{0,1004040943,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34080905,'刻痕','9阶红3星刻痕【通用】',2,'[{lv,300}]',2,'[]','[1005000942,1009000942,1005000942,1009000942,1005000942,1009000942,1005000942,1009000942]','[]','[]','[{0,1005000943,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34080906,'裤子','9阶红3星裤子【重炮手】',2,'[{lv,300}]',2,'[]','[1002010942,1004010942,1006010942,1008010942,1010010942,1002020942,1004020942,1006020942,1008020942,1010020942,1002030942,1004030942,1006030942,1008030942,1010030942,1002040942,1004040942,1006040942,1008040942,1010040942]','[]','[]','[{0,1006040943,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34080907,'副手','9阶红3星副手【重炮手】',2,'[{lv,300}]',2,'[]','[1001010942,1007010942,1001020942,1007020942,1001030942,1007030942,1001040942,1007040942]','[]','[]','[{0,1007040943,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34080908,'护腕','9阶红3星护腕【重炮手】',2,'[{lv,300}]',2,'[]','[1002010942,1004010942,1006010942,1008010942,1010010942,1002020942,1004020942,1006020942,1008020942,1010020942,1002030942,1004030942,1006030942,1008030942,1010030942,1002040942,1004040942,1006040942,1008040942,1010040942]','[]','[]','[{0,1008040943,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34080909,'戒指','9阶红3星戒指【通用】',2,'[{lv,300}]',2,'[]','[1005000942,1009000942,1005000942,1009000942,1005000942,1009000942,1005000942,1009000942]','[]','[]','[{0,1009000943,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34080910,'鞋子','9阶红3星鞋子【重炮手】',2,'[{lv,300}]',2,'[]','[1002010942,1004010942,1006010942,1008010942,1010010942,1002020942,1004020942,1006020942,1008020942,1010020942,1002030942,1004030942,1006030942,1008030942,1010030942,1002040942,1004040942,1006040942,1008040942,1010040942]','[]','[]','[{0,1010040943,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081001,'武器','10阶红3星武器【重炮手】',2,'[{lv,355}]',2,'[]','[1001011042,1007011042,1001021042,1007021042,1001031042,1007031042,1001041042,1007041042]','[]','[]','[{0,1001041043,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081002,'头盔','10阶红3星头盔【重炮手】',2,'[{lv,355}]',2,'[]','[1002011042,1004011042,1006011042,1008011042,1010011042,1002021042,1004021042,1006021042,1008021042,1010021042,1002031042,1004031042,1006031042,1008031042,1010031042,1002041042,1004041042,1006041042,1008041042,1010041042]','[]','[]','[{0,1002041043,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081003,'项链','10阶红3星项链【通用】',2,'[{lv,355}]',2,'[]','[1003001042,1003001042,1003001042,1003001042]','[]','[]','[{0,1003001043,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081004,'衣服','10阶红3星衣服【重炮手】',2,'[{lv,355}]',2,'[]','[1002011042,1004011042,1006011042,1008011042,1010011042,1002021042,1004021042,1006021042,1008021042,1010021042,1002031042,1004031042,1006031042,1008031042,1010031042,1002041042,1004041042,1006041042,1008041042,1010041042]','[]','[]','[{0,1004041043,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081005,'刻痕','10阶红3星刻痕【通用】',2,'[{lv,355}]',2,'[]','[1005001042,1009001042,1005001042,1009001042,1005001042,1009001042,1005001042,1009001042]','[]','[]','[{0,1005001043,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081006,'裤子','10阶红3星裤子【重炮手】',2,'[{lv,355}]',2,'[]','[1002011042,1004011042,1006011042,1008011042,1010011042,1002021042,1004021042,1006021042,1008021042,1010021042,1002031042,1004031042,1006031042,1008031042,1010031042,1002041042,1004041042,1006041042,1008041042,1010041042]','[]','[]','[{0,1006041043,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081007,'副手','10阶红3星副手【重炮手】',2,'[{lv,355}]',2,'[]','[1001011042,1007011042,1001021042,1007021042,1001031042,1007031042,1001041042,1007041042]','[]','[]','[{0,1007041043,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081008,'护腕','10阶红3星护腕【重炮手】',2,'[{lv,355}]',2,'[]','[1002011042,1004011042,1006011042,1008011042,1010011042,1002021042,1004021042,1006021042,1008021042,1010021042,1002031042,1004031042,1006031042,1008031042,1010031042,1002041042,1004041042,1006041042,1008041042,1010041042]','[]','[]','[{0,1008041043,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081009,'戒指','10阶红3星戒指【通用】',2,'[{lv,355}]',2,'[]','[1005001042,1009001042,1005001042,1009001042,1005001042,1009001042,1005001042,1009001042]','[]','[]','[{0,1009001043,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081010,'鞋子','10阶红3星鞋子【重炮手】',2,'[{lv,355}]',2,'[]','[1002011042,1004011042,1006011042,1008011042,1010011042,1002021042,1004021042,1006021042,1008021042,1010021042,1002031042,1004031042,1006031042,1008031042,1010031042,1002041042,1004041042,1006041042,1008041042,1010041042]','[]','[]','[{0,1010041043,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081101,'武器','11阶红3星武器【重炮手】',2,'[{lv,400}]',2,'[]','[1001011142,1007011142,1001021142,1007021142,1001031142,1007031142,1001041142,1007041142]','[]','[]','[{0,1001041143,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081102,'头盔','11阶红3星头盔【重炮手】',2,'[{lv,400}]',2,'[]','[1002011142,1004011142,1006011142,1008011142,1010011142,1002021142,1004021142,1006021142,1008021142,1010021142,1002031142,1004031142,1006031142,1008031142,1010031142,1002041142,1004041142,1006041142,1008041142,1010041142]','[]','[]','[{0,1002041143,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081103,'项链','11阶红3星项链【通用】',2,'[{lv,400}]',2,'[]','[1003001142,1003001142,1003001142,1003001142]','[]','[]','[{0,1003001143,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081104,'衣服','11阶红3星衣服【重炮手】',2,'[{lv,400}]',2,'[]','[1002011142,1004011142,1006011142,1008011142,1010011142,1002021142,1004021142,1006021142,1008021142,1010021142,1002031142,1004031142,1006031142,1008031142,1010031142,1002041142,1004041142,1006041142,1008041142,1010041142]','[]','[]','[{0,1004041143,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081105,'刻痕','11阶红3星刻痕【通用】',2,'[{lv,400}]',2,'[]','[1005001142,1009001142,1005001142,1009001142,1005001142,1009001142,1005001142,1009001142]','[]','[]','[{0,1005001143,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081106,'裤子','11阶红3星裤子【重炮手】',2,'[{lv,400}]',2,'[]','[1002011142,1004011142,1006011142,1008011142,1010011142,1002021142,1004021142,1006021142,1008021142,1010021142,1002031142,1004031142,1006031142,1008031142,1010031142,1002041142,1004041142,1006041142,1008041142,1010041142]','[]','[]','[{0,1006041143,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081107,'副手','11阶红3星副手【重炮手】',2,'[{lv,400}]',2,'[]','[1001011142,1007011142,1001021142,1007021142,1001031142,1007031142,1001041142,1007041142]','[]','[]','[{0,1007041143,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081108,'护腕','11阶红3星护腕【重炮手】',2,'[{lv,400}]',2,'[]','[1002011142,1004011142,1006011142,1008011142,1010011142,1002021142,1004021142,1006021142,1008021142,1010021142,1002031142,1004031142,1006031142,1008031142,1010031142,1002041142,1004041142,1006041142,1008041142,1010041142]','[]','[]','[{0,1008041143,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081109,'戒指','11阶红3星戒指【通用】',2,'[{lv,400}]',2,'[]','[1005001142,1009001142,1005001142,1009001142,1005001142,1009001142,1005001142,1009001142]','[]','[]','[{0,1009001143,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081110,'鞋子','11阶红3星鞋子【重炮手】',2,'[{lv,400}]',2,'[]','[1002011142,1004011142,1006011142,1008011142,1010011142,1002021142,1004021142,1006021142,1008021142,1010021142,1002031142,1004031142,1006031142,1008031142,1010031142,1002041142,1004041142,1006041142,1008041142,1010041142]','[]','[]','[{0,1010041143,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081201,'武器','12阶红3星武器【重炮手】',2,'[{lv,500}]',2,'[]','[1001011242,1007011242,1001021242,1007021242,1001031242,1007031242,1001041242,1007041242]','[]','[]','[{0,1001041243,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081202,'头盔','12阶红3星头盔【重炮手】',2,'[{lv,500}]',2,'[]','[1002011242,1004011242,1006011242,1008011242,1010011242,1002021242,1004021242,1006021242,1008021242,1010021242,1002031242,1004031242,1006031242,1008031242,1010031242,1002041242,1004041242,1006041242,1008041242,1010041242]','[]','[]','[{0,1002041243,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081203,'项链','12阶红3星项链【通用】',2,'[{lv,500}]',2,'[]','[1003001242,1003001242,1003001242,1003001242]','[]','[]','[{0,1003001243,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081204,'衣服','12阶红3星衣服【重炮手】',2,'[{lv,500}]',2,'[]','[1002011242,1004011242,1006011242,1008011242,1010011242,1002021242,1004021242,1006021242,1008021242,1010021242,1002031242,1004031242,1006031242,1008031242,1010031242,1002041242,1004041242,1006041242,1008041242,1010041242]','[]','[]','[{0,1004041243,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081205,'刻痕','12阶红3星刻痕【通用】',2,'[{lv,500}]',2,'[]','[1005001242,1009001242,1005001242,1009001242,1005001242,1009001242,1005001242,1009001242]','[]','[]','[{0,1005001243,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081206,'裤子','12阶红3星裤子【重炮手】',2,'[{lv,500}]',2,'[]','[1002011242,1004011242,1006011242,1008011242,1010011242,1002021242,1004021242,1006021242,1008021242,1010021242,1002031242,1004031242,1006031242,1008031242,1010031242,1002041242,1004041242,1006041242,1008041242,1010041242]','[]','[]','[{0,1006041243,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081207,'副手','12阶红3星副手【重炮手】',2,'[{lv,500}]',2,'[]','[1001011242,1007011242,1001021242,1007021242,1001031242,1007031242,1001041242,1007041242]','[]','[]','[{0,1007041243,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081208,'护腕','12阶红3星护腕【重炮手】',2,'[{lv,500}]',2,'[]','[1002011242,1004011242,1006011242,1008011242,1010011242,1002021242,1004021242,1006021242,1008021242,1010021242,1002031242,1004031242,1006031242,1008031242,1010031242,1002041242,1004041242,1006041242,1008041242,1010041242]','[]','[]','[{0,1008041243,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081209,'戒指','12阶红3星戒指【通用】',2,'[{lv,500}]',2,'[]','[1005001242,1009001242,1005001242,1009001242,1005001242,1009001242,1005001242,1009001242]','[]','[]','[{0,1009001243,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081210,'鞋子','12阶红3星鞋子【重炮手】',2,'[{lv,500}]',2,'[]','[1002011242,1004011242,1006011242,1008011242,1010011242,1002021242,1004021242,1006021242,1008021242,1010021242,1002031242,1004031242,1006031242,1008031242,1010031242,1002041242,1004041242,1006041242,1008041242,1010041242]','[]','[]','[{0,1010041243,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081301,'武器','13阶红3星武器【重炮手】',2,'[{lv,520}]',2,'[]','[1001011342,1007011342,1001021342,1007021342,1001031342,1007031342,1001041342,1007041342]','[]','[]','[{0,1001041343,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081302,'头盔','13阶红3星头盔【重炮手】',2,'[{lv,520}]',2,'[]','[1002011342,1004011342,1006011342,1008011342,1010011342,1002021342,1004021342,1006021342,1008021342,1010021342,1002031342,1004031342,1006031342,1008031342,1010031342,1002041342,1004041342,1006041342,1008041342,1010041342]','[]','[]','[{0,1002041343,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081303,'项链','13阶红3星项链【通用】',2,'[{lv,520}]',2,'[]','[1003001342,1003001342,1003001342,1003001342]','[]','[]','[{0,1003001343,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081304,'衣服','13阶红3星衣服【重炮手】',2,'[{lv,520}]',2,'[]','[1002011342,1004011342,1006011342,1008011342,1010011342,1002021342,1004021342,1006021342,1008021342,1010021342,1002031342,1004031342,1006031342,1008031342,1010031342,1002041342,1004041342,1006041342,1008041342,1010041342]','[]','[]','[{0,1004041343,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081305,'刻痕','13阶红3星刻痕【通用】',2,'[{lv,520}]',2,'[]','[1005001342,1009001342,1005001342,1009001342,1005001342,1009001342,1005001342,1009001342]','[]','[]','[{0,1005001343,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081306,'裤子','13阶红3星裤子【重炮手】',2,'[{lv,520}]',2,'[]','[1002011342,1004011342,1006011342,1008011342,1010011342,1002021342,1004021342,1006021342,1008021342,1010021342,1002031342,1004031342,1006031342,1008031342,1010031342,1002041342,1004041342,1006041342,1008041342,1010041342]','[]','[]','[{0,1006041343,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081307,'副手','13阶红3星副手【重炮手】',2,'[{lv,520}]',2,'[]','[1001011342,1007011342,1001021342,1007021342,1001031342,1007031342,1001041342,1007041342]','[]','[]','[{0,1007041343,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081308,'护腕','13阶红3星护腕【重炮手】',2,'[{lv,520}]',2,'[]','[1002011342,1004011342,1006011342,1008011342,1010011342,1002021342,1004021342,1006021342,1008021342,1010021342,1002031342,1004031342,1006031342,1008031342,1010031342,1002041342,1004041342,1006041342,1008041342,1010041342]','[]','[]','[{0,1008041343,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081309,'戒指','13阶红3星戒指【通用】',2,'[{lv,520}]',2,'[]','[1005001342,1009001342,1005001342,1009001342,1005001342,1009001342,1005001342,1009001342]','[]','[]','[{0,1009001343,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081310,'鞋子','13阶红3星鞋子【重炮手】',2,'[{lv,520}]',2,'[]','[1002011342,1004011342,1006011342,1008011342,1010011342,1002021342,1004021342,1006021342,1008021342,1010021342,1002031342,1004031342,1006031342,1008031342,1010031342,1002041342,1004041342,1006041342,1008041342,1010041342]','[]','[]','[{0,1010041343,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081401,'武器','14阶红3星武器【重炮手】',2,'[{lv,620}]',2,'[]','[1001011442,1007011442,1001021442,1007021442,1001031442,1007031442,1001041442,1007041442]','[]','[]','[{0,1001041443,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081402,'头盔','14阶红3星头盔【重炮手】',2,'[{lv,620}]',2,'[]','[1002011442,1004011442,1006011442,1008011442,1010011442,1002021442,1004021442,1006021442,1008021442,1010021442,1002031442,1004031442,1006031442,1008031442,1010031442,1002041442,1004041442,1006041442,1008041442,1010041442]','[]','[]','[{0,1002041443,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081403,'项链','14阶红3星项链【通用】',2,'[{lv,620}]',2,'[]','[1003001442,1003001442,1003001442,1003001442]','[]','[]','[{0,1003001443,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081404,'衣服','14阶红3星衣服【重炮手】',2,'[{lv,620}]',2,'[]','[1002011442,1004011442,1006011442,1008011442,1010011442,1002021442,1004021442,1006021442,1008021442,1010021442,1002031442,1004031442,1006031442,1008031442,1010031442,1002041442,1004041442,1006041442,1008041442,1010041442]','[]','[]','[{0,1004041443,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081405,'刻痕','14阶红3星刻痕【通用】',2,'[{lv,620}]',2,'[]','[1005001442,1009001442,1005001442,1009001442,1005001442,1009001442,1005001442,1009001442]','[]','[]','[{0,1005001443,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081406,'裤子','14阶红3星裤子【重炮手】',2,'[{lv,620}]',2,'[]','[1002011442,1004011442,1006011442,1008011442,1010011442,1002021442,1004021442,1006021442,1008021442,1010021442,1002031442,1004031442,1006031442,1008031442,1010031442,1002041442,1004041442,1006041442,1008041442,1010041442]','[]','[]','[{0,1006041443,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081407,'副手','14阶红3星副手【重炮手】',2,'[{lv,620}]',2,'[]','[1001011442,1007011442,1001021442,1007021442,1001031442,1007031442,1001041442,1007041442]','[]','[]','[{0,1007041443,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081408,'护腕','14阶红3星护腕【重炮手】',2,'[{lv,620}]',2,'[]','[1002011442,1004011442,1006011442,1008011442,1010011442,1002021442,1004021442,1006021442,1008021442,1010021442,1002031442,1004031442,1006031442,1008031442,1010031442,1002041442,1004041442,1006041442,1008041442,1010041442]','[]','[]','[{0,1008041443,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081409,'戒指','14阶红3星戒指【通用】',2,'[{lv,620}]',2,'[]','[1005001442,1009001442,1005001442,1009001442,1005001442,1009001442,1005001442,1009001442]','[]','[]','[{0,1009001443,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081410,'鞋子','14阶红3星鞋子【重炮手】',2,'[{lv,620}]',2,'[]','[1002011442,1004011442,1006011442,1008011442,1010011442,1002021442,1004021442,1006021442,1008021442,1010021442,1002031442,1004031442,1006031442,1008031442,1010031442,1002041442,1004041442,1006041442,1008041442,1010041442]','[]','[]','[{0,1010041443,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081501,'武器','15阶红3星武器【重炮手】',2,'[{lv,650}]',2,'[]','[1001011542,1007011542,1001021542,1007021542,1001031542,1007031542,1001041542,1007041542]','[]','[]','[{0,1001041543,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081502,'头盔','15阶红3星头盔【重炮手】',2,'[{lv,650}]',2,'[]','[1002011542,1004011542,1006011542,1008011542,1010011542,1002021542,1004021542,1006021542,1008021542,1010021542,1002031542,1004031542,1006031542,1008031542,1010031542,1002041542,1004041542,1006041542,1008041542,1010041542]','[]','[]','[{0,1002041543,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081503,'项链','15阶红3星项链【通用】',2,'[{lv,650}]',2,'[]','[1003001542,1003001542,1003001542,1003001542]','[]','[]','[{0,1003001543,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081504,'衣服','15阶红3星衣服【重炮手】',2,'[{lv,650}]',2,'[]','[1002011542,1004011542,1006011542,1008011542,1010011542,1002021542,1004021542,1006021542,1008021542,1010021542,1002031542,1004031542,1006031542,1008031542,1010031542,1002041542,1004041542,1006041542,1008041542,1010041542]','[]','[]','[{0,1004041543,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081505,'刻痕','15阶红3星刻痕【通用】',2,'[{lv,650}]',2,'[]','[1005001542,1009001542,1005001542,1009001542,1005001542,1009001542,1005001542,1009001542]','[]','[]','[{0,1005001543,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081506,'裤子','15阶红3星裤子【重炮手】',2,'[{lv,650}]',2,'[]','[1002011542,1004011542,1006011542,1008011542,1010011542,1002021542,1004021542,1006021542,1008021542,1010021542,1002031542,1004031542,1006031542,1008031542,1010031542,1002041542,1004041542,1006041542,1008041542,1010041542]','[]','[]','[{0,1006041543,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081507,'副手','15阶红3星副手【重炮手】',2,'[{lv,650}]',2,'[]','[1001011542,1007011542,1001021542,1007021542,1001031542,1007031542,1001041542,1007041542]','[]','[]','[{0,1007041543,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081508,'护腕','15阶红3星护腕【重炮手】',2,'[{lv,650}]',2,'[]','[1002011542,1004011542,1006011542,1008011542,1010011542,1002021542,1004021542,1006021542,1008021542,1010021542,1002031542,1004031542,1006031542,1008031542,1010031542,1002041542,1004041542,1006041542,1008041542,1010041542]','[]','[]','[{0,1008041543,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081509,'戒指','15阶红3星戒指【通用】',2,'[{lv,650}]',2,'[]','[1005001542,1009001542,1005001542,1009001542,1005001542,1009001542,1005001542,1009001542]','[]','[]','[{0,1009001543,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081510,'鞋子','15阶红3星鞋子【重炮手】',2,'[{lv,650}]',2,'[]','[1002011542,1004011542,1006011542,1008011542,1010011542,1002021542,1004021542,1006021542,1008021542,1010021542,1002031542,1004031542,1006031542,1008031542,1010031542,1002041542,1004041542,1006041542,1008041542,1010041542]','[]','[]','[{0,1010041543,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081601,'武器','16阶红3星武器【重炮手】',2,'[{lv,700}]',2,'[]','[1001011642,1007011642,1001021642,1007021642,1001031642,1007031642,1001041642,1007041642]','[]','[]','[{0,1001041643,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081602,'头盔','16阶红3星头盔【重炮手】',2,'[{lv,700}]',2,'[]','[1002011642,1004011642,1006011642,1008011642,1010011642,1002021642,1004021642,1006021642,1008021642,1010021642,1002031642,1004031642,1006031642,1008031642,1010031642,1002041642,1004041642,1006041642,1008041642,1010041642]','[]','[]','[{0,1002041643,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081603,'项链','16阶红3星项链【通用】',2,'[{lv,700}]',2,'[]','[1003001642,1003001642,1003001642,1003001642]','[]','[]','[{0,1003001643,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081604,'衣服','16阶红3星衣服【重炮手】',2,'[{lv,700}]',2,'[]','[1002011642,1004011642,1006011642,1008011642,1010011642,1002021642,1004021642,1006021642,1008021642,1010021642,1002031642,1004031642,1006031642,1008031642,1010031642,1002041642,1004041642,1006041642,1008041642,1010041642]','[]','[]','[{0,1004041643,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081605,'刻痕','16阶红3星刻痕【通用】',2,'[{lv,700}]',2,'[]','[1005001642,1009001642,1005001642,1009001642,1005001642,1009001642,1005001642,1009001642]','[]','[]','[{0,1005001643,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081606,'裤子','16阶红3星裤子【重炮手】',2,'[{lv,700}]',2,'[]','[1002011642,1004011642,1006011642,1008011642,1010011642,1002021642,1004021642,1006021642,1008021642,1010021642,1002031642,1004031642,1006031642,1008031642,1010031642,1002041642,1004041642,1006041642,1008041642,1010041642]','[]','[]','[{0,1006041643,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081607,'副手','16阶红3星副手【重炮手】',2,'[{lv,700}]',2,'[]','[1001011642,1007011642,1001021642,1007021642,1001031642,1007031642,1001041642,1007041642]','[]','[]','[{0,1007041643,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081608,'护腕','16阶红3星护腕【重炮手】',2,'[{lv,700}]',2,'[]','[1002011642,1004011642,1006011642,1008011642,1010011642,1002021642,1004021642,1006021642,1008021642,1010021642,1002031642,1004031642,1006031642,1008031642,1010031642,1002041642,1004041642,1006041642,1008041642,1010041642]','[]','[]','[{0,1008041643,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081609,'戒指','16阶红3星戒指【通用】',2,'[{lv,700}]',2,'[]','[1005001642,1009001642,1005001642,1009001642,1005001642,1009001642,1005001642,1009001642]','[]','[]','[{0,1009001643,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34081610,'鞋子','16阶红3星鞋子【重炮手】',2,'[{lv,700}]',2,'[]','[1002011642,1004011642,1006011642,1008011642,1010011642,1002021642,1004021642,1006021642,1008021642,1010021642,1002031642,1004031642,1006031642,1008031642,1010031642,1002041642,1004041642,1006041642,1008041642,1010041642]','[]','[]','[{0,1010041643,1}]',2,'[{1,0},{2,0},{3,70},{4,85},{5,100}]',3,1,'[]',150),(34090301,'武器','3阶粉色武器【重炮手】',2,'[{lv,9999}]',3,'[{0,38280520,1}]','[1001010343,1007010343,1001020343,1007020343,1001030343,1007030343,1001040343,1007040343]','[]','[]','[{0,1001040353,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(34090302,'头盔','3阶粉色头盔【重炮手】',2,'[{lv,9999}]',3,'[{0,38280510,1}]','[1002010343,1004010343,1006010343,1008010343,1010010343,1002020343,1004020343,1006020343,1008020343,1010020343,1002030343,1004030343,1006030343,1008030343,1010030343,1002040343,1004040343,1006040343,1008040343,1010040343]','[]','[]','[{0,1002040353,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(34090303,'项链','3阶粉色项链【通用】',2,'[{lv,9999}]',3,'[{0,38280520,1}]','[1003000343,1003000343,1003000343,1003000343]','[]','[]','[{0,1003000353,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(34090304,'衣服','3阶粉色衣服【重炮手】',2,'[{lv,9999}]',3,'[{0,38280510,1}]','[1002010343,1004010343,1006010343,1008010343,1010010343,1002020343,1004020343,1006020343,1008020343,1010020343,1002030343,1004030343,1006030343,1008030343,1010030343,1002040343,1004040343,1006040343,1008040343,1010040343]','[]','[]','[{0,1004040353,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(34090305,'刻痕','3阶粉色刻痕【通用】',2,'[{lv,9999}]',3,'[{0,38280520,1}]','[1005000343,1009000343,1005000343,1009000343,1005000343,1009000343,1005000343,1009000343]','[]','[]','[{0,1005000353,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(34090306,'裤子','3阶粉色裤子【重炮手】',2,'[{lv,9999}]',3,'[{0,38280510,1}]','[1002010343,1004010343,1006010343,1008010343,1010010343,1002020343,1004020343,1006020343,1008020343,1010020343,1002030343,1004030343,1006030343,1008030343,1010030343,1002040343,1004040343,1006040343,1008040343,1010040343]','[]','[]','[{0,1006040353,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(34090307,'副手','3阶粉色副手【重炮手】',2,'[{lv,9999}]',3,'[{0,38280520,1}]','[1001010343,1007010343,1001020343,1007020343,1001030343,1007030343,1001040343,1007040343]','[]','[]','[{0,1007040353,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(34090308,'护腕','3阶粉色护腕【重炮手】',2,'[{lv,9999}]',3,'[{0,38280510,1}]','[1002010343,1004010343,1006010343,1008010343,1010010343,1002020343,1004020343,1006020343,1008020343,1010020343,1002030343,1004030343,1006030343,1008030343,1010030343,1002040343,1004040343,1006040343,1008040343,1010040343]','[]','[]','[{0,1008040353,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(34090309,'戒指','3阶粉色戒指【通用】',2,'[{lv,9999}]',3,'[{0,38280520,1}]','[1005000343,1009000343,1005000343,1009000343,1005000343,1009000343,1005000343,1009000343]','[]','[]','[{0,1009000353,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(34090310,'鞋子','3阶粉色鞋子【重炮手】',2,'[{lv,9999}]',3,'[{0,38280510,1}]','[1002010343,1004010343,1006010343,1008010343,1010010343,1002020343,1004020343,1006020343,1008020343,1010020343,1002030343,1004030343,1006030343,1008030343,1010030343,1002040343,1004040343,1006040343,1008040343,1010040343]','[]','[]','[{0,1010040353,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(34090401,'武器','4阶粉色武器【重炮手】',2,'[{lv,160}]',3,'[{0,38280520,1}]','[1001010443,1007010443,1001020443,1007020443,1001030443,1007030443,1001040443,1007040443]','[]','[]','[{0,1001040453,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(34090402,'头盔','4阶粉色头盔【重炮手】',2,'[{lv,160}]',3,'[{0,38280510,1}]','[1002010443,1004010443,1006010443,1008010443,1010010443,1002020443,1004020443,1006020443,1008020443,1010020443,1002030443,1004030443,1006030443,1008030443,1010030443,1002040443,1004040443,1006040443,1008040443,1010040443]','[]','[]','[{0,1002040453,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(34090403,'项链','4阶粉色项链【通用】',2,'[{lv,160}]',3,'[{0,38280520,1}]','[1003000443,1003000443,1003000443,1003000443]','[]','[]','[{0,1003000453,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(34090404,'衣服','4阶粉色衣服【重炮手】',2,'[{lv,160}]',3,'[{0,38280510,1}]','[1002010443,1004010443,1006010443,1008010443,1010010443,1002020443,1004020443,1006020443,1008020443,1010020443,1002030443,1004030443,1006030443,1008030443,1010030443,1002040443,1004040443,1006040443,1008040443,1010040443]','[]','[]','[{0,1004040453,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(34090405,'刻痕','4阶粉色刻痕【通用】',2,'[{lv,160}]',3,'[{0,38280520,1}]','[1005000443,1009000443,1005000443,1009000443,1005000443,1009000443,1005000443,1009000443]','[]','[]','[{0,1005000453,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(34090406,'裤子','4阶粉色裤子【重炮手】',2,'[{lv,160}]',3,'[{0,38280510,1}]','[1002010443,1004010443,1006010443,1008010443,1010010443,1002020443,1004020443,1006020443,1008020443,1010020443,1002030443,1004030443,1006030443,1008030443,1010030443,1002040443,1004040443,1006040443,1008040443,1010040443]','[]','[]','[{0,1006040453,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(34090407,'副手','4阶粉色副手【重炮手】',2,'[{lv,160}]',3,'[{0,38280520,1}]','[1001010443,1007010443,1001020443,1007020443,1001030443,1007030443,1001040443,1007040443]','[]','[]','[{0,1007040453,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(34090408,'护腕','4阶粉色护腕【重炮手】',2,'[{lv,160}]',3,'[{0,38280510,1}]','[1002010443,1004010443,1006010443,1008010443,1010010443,1002020443,1004020443,1006020443,1008020443,1010020443,1002030443,1004030443,1006030443,1008030443,1010030443,1002040443,1004040443,1006040443,1008040443,1010040443]','[]','[]','[{0,1008040453,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(34090409,'戒指','4阶粉色戒指【通用】',2,'[{lv,160}]',3,'[{0,38280520,1}]','[1005000443,1009000443,1005000443,1009000443,1005000443,1009000443,1005000443,1009000443]','[]','[]','[{0,1009000453,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(34090410,'鞋子','4阶粉色鞋子【重炮手】',2,'[{lv,160}]',3,'[{0,38280510,1}]','[1002010443,1004010443,1006010443,1008010443,1010010443,1002020443,1004020443,1006020443,1008020443,1010020443,1002030443,1004030443,1006030443,1008030443,1010030443,1002040443,1004040443,1006040443,1008040443,1010040443]','[]','[]','[{0,1010040453,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(34090501,'武器','5阶粉色武器【重炮手】',2,'[{lv,160}]',3,'[{0,38280520,1}]','[1001010543,1007010543,1001020543,1007020543,1001030543,1007030543,1001040543,1007040543,1101010543,1107010543,1101020543,1107020543,1101030543,1107030543,1101040543,1107040543]','[]','[]','[{0,1001040553,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(34090502,'头盔','5阶粉色头盔【重炮手】',2,'[{lv,160}]',3,'[{0,38280510,1}]','[1002010543,1004010543,1006010543,1008010543,1010010543,1002020543,1004020543,1006020543,1008020543,1010020543,1002030543,1004030543,1006030543,1008030543,1010030543,1002040543,1004040543,1006040543,1008040543,1010040543,1102010543,1104010543,1106010543,1108010543,1110010543,1102020543,1104020543,1106020543,1108020543,1110020543,1102030543,1104030543,1106030543,1108030543,1110030543,1102040543,1104040543,1106040543,1108040543,1110040543]','[]','[]','[{0,1002040553,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(34090503,'项链','5阶粉色项链【通用】',2,'[{lv,160}]',3,'[{0,38280520,1}]','[1003000543,1003000543,1003000543,1003000543,1103000543,1103000543,1103000543,1103000543]','[]','[]','[{0,1003000553,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(34090504,'衣服','5阶粉色衣服【重炮手】',2,'[{lv,160}]',3,'[{0,38280510,1}]','[1002010543,1004010543,1006010543,1008010543,1010010543,1002020543,1004020543,1006020543,1008020543,1010020543,1002030543,1004030543,1006030543,1008030543,1010030543,1002040543,1004040543,1006040543,1008040543,1010040543,1102010543,1104010543,1106010543,1108010543,1110010543,1102020543,1104020543,1106020543,1108020543,1110020543,1102030543,1104030543,1106030543,1108030543,1110030543,1102040543,1104040543,1106040543,1108040543,1110040543]','[]','[]','[{0,1004040553,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(34090505,'刻痕','5阶粉色刻痕【通用】',2,'[{lv,160}]',3,'[{0,38280520,1}]','[1005000543,1009000543,1005000543,1009000543,1005000543,1009000543,1005000543,1009000543,1105000543,1109000543,1105000543,1109000543,1105000543,1109000543,1105000543,1109000543]','[]','[]','[{0,1005000553,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(34090506,'裤子','5阶粉色裤子【重炮手】',2,'[{lv,160}]',3,'[{0,38280510,1}]','[1002010543,1004010543,1006010543,1008010543,1010010543,1002020543,1004020543,1006020543,1008020543,1010020543,1002030543,1004030543,1006030543,1008030543,1010030543,1002040543,1004040543,1006040543,1008040543,1010040543,1102010543,1104010543,1106010543,1108010543,1110010543,1102020543,1104020543,1106020543,1108020543,1110020543,1102030543,1104030543,1106030543,1108030543,1110030543,1102040543,1104040543,1106040543,1108040543,1110040543]','[]','[]','[{0,1006040553,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(34090507,'副手','5阶粉色副手【重炮手】',2,'[{lv,160}]',3,'[{0,38280520,1}]','[1001010543,1007010543,1001020543,1007020543,1001030543,1007030543,1001040543,1007040543,1101010543,1107010543,1101020543,1107020543,1101030543,1107030543,1101040543,1107040543]','[]','[]','[{0,1007040553,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(34090508,'护腕','5阶粉色护腕【重炮手】',2,'[{lv,160}]',3,'[{0,38280510,1}]','[1002010543,1004010543,1006010543,1008010543,1010010543,1002020543,1004020543,1006020543,1008020543,1010020543,1002030543,1004030543,1006030543,1008030543,1010030543,1002040543,1004040543,1006040543,1008040543,1010040543,1102010543,1104010543,1106010543,1108010543,1110010543,1102020543,1104020543,1106020543,1108020543,1110020543,1102030543,1104030543,1106030543,1108030543,1110030543,1102040543,1104040543,1106040543,1108040543,1110040543]','[]','[]','[{0,1008040553,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(34090509,'戒指','5阶粉色戒指【通用】',2,'[{lv,160}]',3,'[{0,38280520,1}]','[1005000543,1009000543,1005000543,1009000543,1005000543,1009000543,1005000543,1009000543,1105000543,1109000543,1105000543,1109000543,1105000543,1109000543,1105000543,1109000543]','[]','[]','[{0,1009000553,1}]',2,'[{1,100}]',3,1,'[{0,38280520,1}]',150),(34090510,'鞋子','5阶粉色鞋子【重炮手】',2,'[{lv,160}]',3,'[{0,38280510,1}]','[1002010543,1004010543,1006010543,1008010543,1010010543,1002020543,1004020543,1006020543,1008020543,1010020543,1002030543,1004030543,1006030543,1008030543,1010030543,1002040543,1004040543,1006040543,1008040543,1010040543,1102010543,1104010543,1106010543,1108010543,1110010543,1102020543,1104020543,1106020543,1108020543,1110020543,1102030543,1104030543,1106030543,1108030543,1110030543,1102040543,1104040543,1106040543,1108040543,1110040543]','[]','[]','[{0,1010040553,1}]',2,'[{1,100}]',3,1,'[{0,38280510,1}]',150),(34090601,'武器','6阶粉色武器【重炮手】',2,'[{lv,180}]',3,'[{0,38280520,2}]','[1001010643,1007010643,1001020643,1007020643,1001030643,1007030643,1001040643,1007040643]','[]','[]','[{0,1001040653,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280520,2}]',150),(34090602,'头盔','6阶粉色头盔【重炮手】',2,'[{lv,180}]',3,'[{0,38280510,2}]','[1002010643,1004010643,1006010643,1008010643,1010010643,1002020643,1004020643,1006020643,1008020643,1010020643,1002030643,1004030643,1006030643,1008030643,1010030643,1002040643,1004040643,1006040643,1008040643,1010040643]','[]','[]','[{0,1002040653,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280510,2}]',150),(34090603,'项链','6阶粉色项链【通用】',2,'[{lv,180}]',3,'[{0,38280520,2}]','[1003000643,1003000643,1003000643,1003000643]','[]','[]','[{0,1003000653,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280520,2}]',150),(34090604,'衣服','6阶粉色衣服【重炮手】',2,'[{lv,180}]',3,'[{0,38280510,2}]','[1002010643,1004010643,1006010643,1008010643,1010010643,1002020643,1004020643,1006020643,1008020643,1010020643,1002030643,1004030643,1006030643,1008030643,1010030643,1002040643,1004040643,1006040643,1008040643,1010040643]','[]','[]','[{0,1004040653,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280510,2}]',150),(34090605,'刻痕','6阶粉色刻痕【通用】',2,'[{lv,180}]',3,'[{0,38280520,2}]','[1005000643,1009000643,1005000643,1009000643,1005000643,1009000643,1005000643,1009000643]','[]','[]','[{0,1005000653,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280520,2}]',150),(34090606,'裤子','6阶粉色裤子【重炮手】',2,'[{lv,180}]',3,'[{0,38280510,2}]','[1002010643,1004010643,1006010643,1008010643,1010010643,1002020643,1004020643,1006020643,1008020643,1010020643,1002030643,1004030643,1006030643,1008030643,1010030643,1002040643,1004040643,1006040643,1008040643,1010040643]','[]','[]','[{0,1006040653,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280510,2}]',150),(34090607,'副手','6阶粉色副手【重炮手】',2,'[{lv,180}]',3,'[{0,38280520,2}]','[1001010643,1007010643,1001020643,1007020643,1001030643,1007030643,1001040643,1007040643]','[]','[]','[{0,1007040653,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280520,2}]',150),(34090608,'护腕','6阶粉色护腕【重炮手】',2,'[{lv,180}]',3,'[{0,38280510,2}]','[1002010643,1004010643,1006010643,1008010643,1010010643,1002020643,1004020643,1006020643,1008020643,1010020643,1002030643,1004030643,1006030643,1008030643,1010030643,1002040643,1004040643,1006040643,1008040643,1010040643]','[]','[]','[{0,1008040653,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280510,2}]',150),(34090609,'戒指','6阶粉色戒指【通用】',2,'[{lv,180}]',3,'[{0,38280520,2}]','[1005000643,1009000643,1005000643,1009000643,1005000643,1009000643,1005000643,1009000643]','[]','[]','[{0,1009000653,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280520,2}]',150),(34090610,'鞋子','6阶粉色鞋子【重炮手】',2,'[{lv,180}]',3,'[{0,38280510,2}]','[1002010643,1004010643,1006010643,1008010643,1010010643,1002020643,1004020643,1006020643,1008020643,1010020643,1002030643,1004030643,1006030643,1008030643,1010030643,1002040643,1004040643,1006040643,1008040643,1010040643]','[]','[]','[{0,1010040653,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280510,2}]',150),(34090701,'武器','7阶粉色武器【重炮手】',2,'[{lv,220}]',3,'[{0,38280520,3}]','[1001010743,1007010743,1001020743,1007020743,1001030743,1007030743,1001040743,1007040743,1101010743,1107010743,1101020743,1107020743,1101030743,1107030743,1101040743,1107040743]','[]','[]','[{0,1001040753,1}]',2,'[{1,0},{2,100},{3,100}]',3,1,'[{0,38280520,3}]',150),(34090702,'头盔','7阶粉色头盔【重炮手】',2,'[{lv,220}]',3,'[{0,38280510,3}]','[1002010743,1004010743,1006010743,1008010743,1010010743,1002020743,1004020743,1006020743,1008020743,1010020743,1002030743,1004030743,1006030743,1008030743,1010030743,1002040743,1004040743,1006040743,1008040743,1010040743,1102010743,1104010743,1106010743,1108010743,1110010743,1102020743,1104020743,1106020743,1108020743,1110020743,1102030743,1104030743,1106030743,1108030743,1110030743,1102040743,1104040743,1106040743,1108040743,1110040743]','[]','[]','[{0,1002040753,1}]',2,'[{1,0},{2,100},{3,100}]',3,1,'[{0,38280510,3}]',150),(34090703,'项链','7阶粉色项链【通用】',2,'[{lv,220}]',3,'[{0,38280520,3}]','[1003000743,1003000743,1003000743,1003000743,1103000743,1103000743,1103000743,1103000743]','[]','[]','[{0,1003000753,1}]',2,'[{1,0},{2,100},{3,100}]',3,1,'[{0,38280520,3}]',150),(34090704,'衣服','7阶粉色衣服【重炮手】',2,'[{lv,220}]',3,'[{0,38280510,3}]','[1002010743,1004010743,1006010743,1008010743,1010010743,1002020743,1004020743,1006020743,1008020743,1010020743,1002030743,1004030743,1006030743,1008030743,1010030743,1002040743,1004040743,1006040743,1008040743,1010040743,1102010743,1104010743,1106010743,1108010743,1110010743,1102020743,1104020743,1106020743,1108020743,1110020743,1102030743,1104030743,1106030743,1108030743,1110030743,1102040743,1104040743,1106040743,1108040743,1110040743]','[]','[]','[{0,1004040753,1}]',2,'[{1,0},{2,100},{3,100}]',3,1,'[{0,38280510,3}]',150),(34090705,'刻痕','7阶粉色刻痕【通用】',2,'[{lv,220}]',3,'[{0,38280520,3}]','[1005000743,1009000743,1005000743,1009000743,1005000743,1009000743,1005000743,1009000743,1105000743,1109000743,1105000743,1109000743,1105000743,1109000743,1105000743,1109000743]','[]','[]','[{0,1005000753,1}]',2,'[{1,0},{2,100},{3,100}]',3,1,'[{0,38280520,3}]',150),(34090706,'裤子','7阶粉色裤子【重炮手】',2,'[{lv,220}]',3,'[{0,38280510,3}]','[1002010743,1004010743,1006010743,1008010743,1010010743,1002020743,1004020743,1006020743,1008020743,1010020743,1002030743,1004030743,1006030743,1008030743,1010030743,1002040743,1004040743,1006040743,1008040743,1010040743,1102010743,1104010743,1106010743,1108010743,1110010743,1102020743,1104020743,1106020743,1108020743,1110020743,1102030743,1104030743,1106030743,1108030743,1110030743,1102040743,1104040743,1106040743,1108040743,1110040743]','[]','[]','[{0,1006040753,1}]',2,'[{1,0},{2,100},{3,100}]',3,1,'[{0,38280510,3}]',150),(34090707,'副手','7阶粉色副手【重炮手】',2,'[{lv,220}]',3,'[{0,38280520,3}]','[1001010743,1007010743,1001020743,1007020743,1001030743,1007030743,1001040743,1007040743,1101010743,1107010743,1101020743,1107020743,1101030743,1107030743,1101040743,1107040743]','[]','[]','[{0,1007040753,1}]',2,'[{1,0},{2,100},{3,100}]',3,1,'[{0,38280520,3}]',150),(34090708,'护腕','7阶粉色护腕【重炮手】',2,'[{lv,220}]',3,'[{0,38280510,3}]','[1002010743,1004010743,1006010743,1008010743,1010010743,1002020743,1004020743,1006020743,1008020743,1010020743,1002030743,1004030743,1006030743,1008030743,1010030743,1002040743,1004040743,1006040743,1008040743,1010040743,1102010743,1104010743,1106010743,1108010743,1110010743,1102020743,1104020743,1106020743,1108020743,1110020743,1102030743,1104030743,1106030743,1108030743,1110030743,1102040743,1104040743,1106040743,1108040743,1110040743]','[]','[]','[{0,1008040753,1}]',2,'[{1,0},{2,100},{3,100}]',3,1,'[{0,38280510,3}]',150),(34090709,'戒指','7阶粉色戒指【通用】',2,'[{lv,220}]',3,'[{0,38280520,3}]','[1005000743,1009000743,1005000743,1009000743,1005000743,1009000743,1005000743,1009000743,1105000743,1109000743,1105000743,1109000743,1105000743,1109000743,1105000743,1109000743]','[]','[]','[{0,1009000753,1}]',2,'[{1,0},{2,100},{3,100}]',3,1,'[{0,38280520,3}]',150),(34090710,'鞋子','7阶粉色鞋子【重炮手】',2,'[{lv,220}]',3,'[{0,38280510,3}]','[1002010743,1004010743,1006010743,1008010743,1010010743,1002020743,1004020743,1006020743,1008020743,1010020743,1002030743,1004030743,1006030743,1008030743,1010030743,1002040743,1004040743,1006040743,1008040743,1010040743,1102010743,1104010743,1106010743,1108010743,1110010743,1102020743,1104020743,1106020743,1108020743,1110020743,1102030743,1104030743,1106030743,1108030743,1110030743,1102040743,1104040743,1106040743,1108040743,1110040743]','[]','[]','[{0,1010040753,1}]',2,'[{1,0},{2,100},{3,100}]',3,1,'[{0,38280510,3}]',150),(34090801,'武器','8阶粉色武器【重炮手】',2,'[{lv,260}]',3,'[{0,38280520,4}]','[1001010843,1007010843,1001020843,1007020843,1001030843,1007030843,1001040843,1007040843]','[]','[]','[{0,1001040853,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280520,4}]',150),(34090802,'头盔','8阶粉色头盔【重炮手】',2,'[{lv,260}]',3,'[{0,38280510,4}]','[1002010843,1004010843,1006010843,1008010843,1010010843,1002020843,1004020843,1006020843,1008020843,1010020843,1002030843,1004030843,1006030843,1008030843,1010030843,1002040843,1004040843,1006040843,1008040843,1010040843]','[]','[]','[{0,1002040853,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280510,4}]',150),(34090803,'项链','8阶粉色项链【通用】',2,'[{lv,260}]',3,'[{0,38280520,4}]','[1003000843,1003000843,1003000843,1003000843]','[]','[]','[{0,1003000853,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280520,4}]',150),(34090804,'衣服','8阶粉色衣服【重炮手】',2,'[{lv,260}]',3,'[{0,38280510,4}]','[1002010843,1004010843,1006010843,1008010843,1010010843,1002020843,1004020843,1006020843,1008020843,1010020843,1002030843,1004030843,1006030843,1008030843,1010030843,1002040843,1004040843,1006040843,1008040843,1010040843]','[]','[]','[{0,1004040853,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280510,4}]',150),(34090805,'刻痕','8阶粉色刻痕【通用】',2,'[{lv,260}]',3,'[{0,38280520,4}]','[1005000843,1009000843,1005000843,1009000843,1005000843,1009000843,1005000843,1009000843]','[]','[]','[{0,1005000853,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280520,4}]',150),(34090806,'裤子','8阶粉色裤子【重炮手】',2,'[{lv,260}]',3,'[{0,38280510,4}]','[1002010843,1004010843,1006010843,1008010843,1010010843,1002020843,1004020843,1006020843,1008020843,1010020843,1002030843,1004030843,1006030843,1008030843,1010030843,1002040843,1004040843,1006040843,1008040843,1010040843]','[]','[]','[{0,1006040853,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280510,4}]',150),(34090807,'副手','8阶粉色副手【重炮手】',2,'[{lv,260}]',3,'[{0,38280520,4}]','[1001010843,1007010843,1001020843,1007020843,1001030843,1007030843,1001040843,1007040843]','[]','[]','[{0,1007040853,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280520,4}]',150),(34090808,'护腕','8阶粉色护腕【重炮手】',2,'[{lv,260}]',3,'[{0,38280510,4}]','[1002010843,1004010843,1006010843,1008010843,1010010843,1002020843,1004020843,1006020843,1008020843,1010020843,1002030843,1004030843,1006030843,1008030843,1010030843,1002040843,1004040843,1006040843,1008040843,1010040843]','[]','[]','[{0,1008040853,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280510,4}]',150),(34090809,'戒指','8阶粉色戒指【通用】',2,'[{lv,260}]',3,'[{0,38280520,4}]','[1005000843,1009000843,1005000843,1009000843,1005000843,1009000843,1005000843,1009000843]','[]','[]','[{0,1009000853,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280520,4}]',150),(34090810,'鞋子','8阶粉色鞋子【重炮手】',2,'[{lv,260}]',3,'[{0,38280510,4}]','[1002010843,1004010843,1006010843,1008010843,1010010843,1002020843,1004020843,1006020843,1008020843,1010020843,1002030843,1004030843,1006030843,1008030843,1010030843,1002040843,1004040843,1006040843,1008040843,1010040843]','[]','[]','[{0,1010040853,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280510,4}]',150),(34090901,'武器','9阶粉色武器【重炮手】',2,'[{lv,300}]',3,'[{0,38280520,6}]','[1001010943,1007010943,1001020943,1007020943,1001030943,1007030943,1001040943,1007040943]','[]','[]','[{0,1001040953,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280520,6}]',150),(34090902,'头盔','9阶粉色头盔【重炮手】',2,'[{lv,300}]',3,'[{0,38280510,6}]','[1002010943,1004010943,1006010943,1008010943,1010010943,1002020943,1004020943,1006020943,1008020943,1010020943,1002030943,1004030943,1006030943,1008030943,1010030943,1002040943,1004040943,1006040943,1008040943,1010040943]','[]','[]','[{0,1002040953,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280510,6}]',150),(34090903,'项链','9阶粉色项链【通用】',2,'[{lv,300}]',3,'[{0,38280520,6}]','[1003000943,1003000943,1003000943,1003000943]','[]','[]','[{0,1003000953,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280520,6}]',150),(34090904,'衣服','9阶粉色衣服【重炮手】',2,'[{lv,300}]',3,'[{0,38280510,6}]','[1002010943,1004010943,1006010943,1008010943,1010010943,1002020943,1004020943,1006020943,1008020943,1010020943,1002030943,1004030943,1006030943,1008030943,1010030943,1002040943,1004040943,1006040943,1008040943,1010040943]','[]','[]','[{0,1004040953,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280510,6}]',150),(34090905,'刻痕','9阶粉色刻痕【通用】',2,'[{lv,300}]',3,'[{0,38280520,6}]','[1005000943,1009000943,1005000943,1009000943,1005000943,1009000943,1005000943,1009000943]','[]','[]','[{0,1005000953,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280520,6}]',150),(34090906,'裤子','9阶粉色裤子【重炮手】',2,'[{lv,300}]',3,'[{0,38280510,6}]','[1002010943,1004010943,1006010943,1008010943,1010010943,1002020943,1004020943,1006020943,1008020943,1010020943,1002030943,1004030943,1006030943,1008030943,1010030943,1002040943,1004040943,1006040943,1008040943,1010040943]','[]','[]','[{0,1006040953,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280510,6}]',150),(34090907,'副手','9阶粉色副手【重炮手】',2,'[{lv,300}]',3,'[{0,38280520,6}]','[1001010943,1007010943,1001020943,1007020943,1001030943,1007030943,1001040943,1007040943]','[]','[]','[{0,1007040953,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280520,6}]',150),(34090908,'护腕','9阶粉色护腕【重炮手】',2,'[{lv,300}]',3,'[{0,38280510,6}]','[1002010943,1004010943,1006010943,1008010943,1010010943,1002020943,1004020943,1006020943,1008020943,1010020943,1002030943,1004030943,1006030943,1008030943,1010030943,1002040943,1004040943,1006040943,1008040943,1010040943]','[]','[]','[{0,1008040953,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280510,6}]',150),(34090909,'戒指','9阶粉色戒指【通用】',2,'[{lv,300}]',3,'[{0,38280520,6}]','[1005000943,1009000943,1005000943,1009000943,1005000943,1009000943,1005000943,1009000943]','[]','[]','[{0,1009000953,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280520,6}]',150),(34090910,'鞋子','9阶粉色鞋子【重炮手】',2,'[{lv,300}]',3,'[{0,38280510,6}]','[1002010943,1004010943,1006010943,1008010943,1010010943,1002020943,1004020943,1006020943,1008020943,1010020943,1002030943,1004030943,1006030943,1008030943,1010030943,1002040943,1004040943,1006040943,1008040943,1010040943]','[]','[]','[{0,1010040953,1}]',2,'[{1,0},{2,95},{3,100}]',3,1,'[{0,38280510,6}]',150),(34091001,'武器','10阶粉色武器【重炮手】',2,'[{lv,355}]',3,'[{0,38280520,8}]','[1001011043,1007011043,1001021043,1007021043,1001031043,1007031043,1001041043,1007041043]','[]','[]','[{0,1001041053,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,8}]',150),(34091002,'头盔','10阶粉色头盔【重炮手】',2,'[{lv,355}]',3,'[{0,38280510,8}]','[1002011043,1004011043,1006011043,1008011043,1010011043,1002021043,1004021043,1006021043,1008021043,1010021043,1002031043,1004031043,1006031043,1008031043,1010031043,1002041043,1004041043,1006041043,1008041043,1010041043]','[]','[]','[{0,1002041053,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,8}]',150),(34091003,'项链','10阶粉色项链【通用】',2,'[{lv,355}]',3,'[{0,38280520,8}]','[1003001043,1003001043,1003001043,1003001043]','[]','[]','[{0,1003001053,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,8}]',150),(34091004,'衣服','10阶粉色衣服【重炮手】',2,'[{lv,355}]',3,'[{0,38280510,8}]','[1002011043,1004011043,1006011043,1008011043,1010011043,1002021043,1004021043,1006021043,1008021043,1010021043,1002031043,1004031043,1006031043,1008031043,1010031043,1002041043,1004041043,1006041043,1008041043,1010041043]','[]','[]','[{0,1004041053,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,8}]',150),(34091005,'刻痕','10阶粉色刻痕【通用】',2,'[{lv,355}]',3,'[{0,38280520,8}]','[1005001043,1009001043,1005001043,1009001043,1005001043,1009001043,1005001043,1009001043]','[]','[]','[{0,1005001053,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,8}]',150),(34091006,'裤子','10阶粉色裤子【重炮手】',2,'[{lv,355}]',3,'[{0,38280510,8}]','[1002011043,1004011043,1006011043,1008011043,1010011043,1002021043,1004021043,1006021043,1008021043,1010021043,1002031043,1004031043,1006031043,1008031043,1010031043,1002041043,1004041043,1006041043,1008041043,1010041043]','[]','[]','[{0,1006041053,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,8}]',150),(34091007,'副手','10阶粉色副手【重炮手】',2,'[{lv,355}]',3,'[{0,38280520,8}]','[1001011043,1007011043,1001021043,1007021043,1001031043,1007031043,1001041043,1007041043]','[]','[]','[{0,1007041053,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,8}]',150),(34091008,'护腕','10阶粉色护腕【重炮手】',2,'[{lv,355}]',3,'[{0,38280510,8}]','[1002011043,1004011043,1006011043,1008011043,1010011043,1002021043,1004021043,1006021043,1008021043,1010021043,1002031043,1004031043,1006031043,1008031043,1010031043,1002041043,1004041043,1006041043,1008041043,1010041043]','[]','[]','[{0,1008041053,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,8}]',150),(34091009,'戒指','10阶粉色戒指【通用】',2,'[{lv,355}]',3,'[{0,38280520,8}]','[1005001043,1009001043,1005001043,1009001043,1005001043,1009001043,1005001043,1009001043]','[]','[]','[{0,1009001053,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,8}]',150),(34091010,'鞋子','10阶粉色鞋子【重炮手】',2,'[{lv,355}]',3,'[{0,38280510,8}]','[1002011043,1004011043,1006011043,1008011043,1010011043,1002021043,1004021043,1006021043,1008021043,1010021043,1002031043,1004031043,1006031043,1008031043,1010031043,1002041043,1004041043,1006041043,1008041043,1010041043]','[]','[]','[{0,1010041053,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,8}]',150),(34091101,'武器','11阶粉色武器【重炮手】',2,'[{lv,400}]',3,'[{0,38280520,12}]','[1001011143,1007011143,1001021143,1007021143,1001031143,1007031143,1001041143,1007041143]','[]','[]','[{0,1001041153,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,12}]',150),(34091102,'头盔','11阶粉色头盔【重炮手】',2,'[{lv,400}]',3,'[{0,38280510,12}]','[1002011143,1004011143,1006011143,1008011143,1010011143,1002021143,1004021143,1006021143,1008021143,1010021143,1002031143,1004031143,1006031143,1008031143,1010031143,1002041143,1004041143,1006041143,1008041143,1010041143]','[]','[]','[{0,1002041153,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,12}]',150),(34091103,'项链','11阶粉色项链【通用】',2,'[{lv,400}]',3,'[{0,38280520,12}]','[1003001143,1003001143,1003001143,1003001143]','[]','[]','[{0,1003001153,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,12}]',150),(34091104,'衣服','11阶粉色衣服【重炮手】',2,'[{lv,400}]',3,'[{0,38280510,12}]','[1002011143,1004011143,1006011143,1008011143,1010011143,1002021143,1004021143,1006021143,1008021143,1010021143,1002031143,1004031143,1006031143,1008031143,1010031143,1002041143,1004041143,1006041143,1008041143,1010041143]','[]','[]','[{0,1004041153,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,12}]',150),(34091105,'刻痕','11阶粉色刻痕【通用】',2,'[{lv,400}]',3,'[{0,38280520,12}]','[1005001143,1009001143,1005001143,1009001143,1005001143,1009001143,1005001143,1009001143]','[]','[]','[{0,1005001153,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,12}]',150),(34091106,'裤子','11阶粉色裤子【重炮手】',2,'[{lv,400}]',3,'[{0,38280510,12}]','[1002011143,1004011143,1006011143,1008011143,1010011143,1002021143,1004021143,1006021143,1008021143,1010021143,1002031143,1004031143,1006031143,1008031143,1010031143,1002041143,1004041143,1006041143,1008041143,1010041143]','[]','[]','[{0,1006041153,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,12}]',150),(34091107,'副手','11阶粉色副手【重炮手】',2,'[{lv,400}]',3,'[{0,38280520,12}]','[1001011143,1007011143,1001021143,1007021143,1001031143,1007031143,1001041143,1007041143]','[]','[]','[{0,1007041153,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,12}]',150),(34091108,'护腕','11阶粉色护腕【重炮手】',2,'[{lv,400}]',3,'[{0,38280510,12}]','[1002011143,1004011143,1006011143,1008011143,1010011143,1002021143,1004021143,1006021143,1008021143,1010021143,1002031143,1004031143,1006031143,1008031143,1010031143,1002041143,1004041143,1006041143,1008041143,1010041143]','[]','[]','[{0,1008041153,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,12}]',150),(34091109,'戒指','11阶粉色戒指【通用】',2,'[{lv,400}]',3,'[{0,38280520,12}]','[1005001143,1009001143,1005001143,1009001143,1005001143,1009001143,1005001143,1009001143]','[]','[]','[{0,1009001153,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,12}]',150),(34091110,'鞋子','11阶粉色鞋子【重炮手】',2,'[{lv,400}]',3,'[{0,38280510,12}]','[1002011143,1004011143,1006011143,1008011143,1010011143,1002021143,1004021143,1006021143,1008021143,1010021143,1002031143,1004031143,1006031143,1008031143,1010031143,1002041143,1004041143,1006041143,1008041143,1010041143]','[]','[]','[{0,1010041153,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,12}]',150),(34091201,'武器','12阶粉色武器【重炮手】',2,'[{lv,500}]',3,'[{0,38280520,16}]','[1001011243,1007011243,1001021243,1007021243,1001031243,1007031243,1001041243,1007041243]','[]','[]','[{0,1001041253,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,16}]',150),(34091202,'头盔','12阶粉色头盔【重炮手】',2,'[{lv,500}]',3,'[{0,38280510,16}]','[1002011243,1004011243,1006011243,1008011243,1010011243,1002021243,1004021243,1006021243,1008021243,1010021243,1002031243,1004031243,1006031243,1008031243,1010031243,1002041243,1004041243,1006041243,1008041243,1010041243]','[]','[]','[{0,1002041253,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,16}]',150),(34091203,'项链','12阶粉色项链【通用】',2,'[{lv,500}]',3,'[{0,38280520,16}]','[1003001243,1003001243,1003001243,1003001243]','[]','[]','[{0,1003001253,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,16}]',150),(34091204,'衣服','12阶粉色衣服【重炮手】',2,'[{lv,500}]',3,'[{0,38280510,16}]','[1002011243,1004011243,1006011243,1008011243,1010011243,1002021243,1004021243,1006021243,1008021243,1010021243,1002031243,1004031243,1006031243,1008031243,1010031243,1002041243,1004041243,1006041243,1008041243,1010041243]','[]','[]','[{0,1004041253,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,16}]',150),(34091205,'刻痕','12阶粉色刻痕【通用】',2,'[{lv,500}]',3,'[{0,38280520,16}]','[1005001243,1009001243,1005001243,1009001243,1005001243,1009001243,1005001243,1009001243]','[]','[]','[{0,1005001253,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,16}]',150),(34091206,'裤子','12阶粉色裤子【重炮手】',2,'[{lv,500}]',3,'[{0,38280510,16}]','[1002011243,1004011243,1006011243,1008011243,1010011243,1002021243,1004021243,1006021243,1008021243,1010021243,1002031243,1004031243,1006031243,1008031243,1010031243,1002041243,1004041243,1006041243,1008041243,1010041243]','[]','[]','[{0,1006041253,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,16}]',150),(34091207,'副手','12阶粉色副手【重炮手】',2,'[{lv,500}]',3,'[{0,38280520,16}]','[1001011243,1007011243,1001021243,1007021243,1001031243,1007031243,1001041243,1007041243]','[]','[]','[{0,1007041253,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,16}]',150),(34091208,'护腕','12阶粉色护腕【重炮手】',2,'[{lv,500}]',3,'[{0,38280510,16}]','[1002011243,1004011243,1006011243,1008011243,1010011243,1002021243,1004021243,1006021243,1008021243,1010021243,1002031243,1004031243,1006031243,1008031243,1010031243,1002041243,1004041243,1006041243,1008041243,1010041243]','[]','[]','[{0,1008041253,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,16}]',150),(34091209,'戒指','12阶粉色戒指【通用】',2,'[{lv,500}]',3,'[{0,38280520,16}]','[1005001243,1009001243,1005001243,1009001243,1005001243,1009001243,1005001243,1009001243]','[]','[]','[{0,1009001253,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280520,16}]',150),(34091210,'鞋子','12阶粉色鞋子【重炮手】',2,'[{lv,500}]',3,'[{0,38280510,16}]','[1002011243,1004011243,1006011243,1008011243,1010011243,1002021243,1004021243,1006021243,1008021243,1010021243,1002031243,1004031243,1006031243,1008031243,1010031243,1002041243,1004041243,1006041243,1008041243,1010041243]','[]','[]','[{0,1010041253,1}]',2,'[{1,0},{2,85},{3,100}]',3,1,'[{0,38280510,16}]',150),(34091301,'武器','13阶粉色武器【重炮手】',2,'[{lv,520}]',3,'[{0,38280520,20}]','[1001011343,1007011343,1001021343,1007021343,1001031343,1007031343,1001041343,1007041343]','[]','[]','[{0,1001041353,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,20}]',150),(34091302,'头盔','13阶粉色头盔【重炮手】',2,'[{lv,520}]',3,'[{0,38280510,20}]','[1002011343,1004011343,1006011343,1008011343,1010011343,1002021343,1004021343,1006021343,1008021343,1010021343,1002031343,1004031343,1006031343,1008031343,1010031343,1002041343,1004041343,1006041343,1008041343,1010041343]','[]','[]','[{0,1002041353,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,20}]',150),(34091303,'项链','13阶粉色项链【通用】',2,'[{lv,520}]',3,'[{0,38280520,20}]','[1003001343,1003001343,1003001343,1003001343]','[]','[]','[{0,1003001353,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,20}]',150),(34091304,'衣服','13阶粉色衣服【重炮手】',2,'[{lv,520}]',3,'[{0,38280510,20}]','[1002011343,1004011343,1006011343,1008011343,1010011343,1002021343,1004021343,1006021343,1008021343,1010021343,1002031343,1004031343,1006031343,1008031343,1010031343,1002041343,1004041343,1006041343,1008041343,1010041343]','[]','[]','[{0,1004041353,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,20}]',150),(34091305,'刻痕','13阶粉色刻痕【通用】',2,'[{lv,520}]',3,'[{0,38280520,20}]','[1005001343,1009001343,1005001343,1009001343,1005001343,1009001343,1005001343,1009001343]','[]','[]','[{0,1005001353,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,20}]',150),(34091306,'裤子','13阶粉色裤子【重炮手】',2,'[{lv,520}]',3,'[{0,38280510,20}]','[1002011343,1004011343,1006011343,1008011343,1010011343,1002021343,1004021343,1006021343,1008021343,1010021343,1002031343,1004031343,1006031343,1008031343,1010031343,1002041343,1004041343,1006041343,1008041343,1010041343]','[]','[]','[{0,1006041353,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,20}]',150),(34091307,'副手','13阶粉色副手【重炮手】',2,'[{lv,520}]',3,'[{0,38280520,20}]','[1001011343,1007011343,1001021343,1007021343,1001031343,1007031343,1001041343,1007041343]','[]','[]','[{0,1007041353,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,20}]',150),(34091308,'护腕','13阶粉色护腕【重炮手】',2,'[{lv,520}]',3,'[{0,38280510,20}]','[1002011343,1004011343,1006011343,1008011343,1010011343,1002021343,1004021343,1006021343,1008021343,1010021343,1002031343,1004031343,1006031343,1008031343,1010031343,1002041343,1004041343,1006041343,1008041343,1010041343]','[]','[]','[{0,1008041353,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,20}]',150),(34091309,'戒指','13阶粉色戒指【通用】',2,'[{lv,520}]',3,'[{0,38280520,20}]','[1005001343,1009001343,1005001343,1009001343,1005001343,1009001343,1005001343,1009001343]','[]','[]','[{0,1009001353,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,20}]',150),(34091310,'鞋子','13阶粉色鞋子【重炮手】',2,'[{lv,520}]',3,'[{0,38280510,20}]','[1002011343,1004011343,1006011343,1008011343,1010011343,1002021343,1004021343,1006021343,1008021343,1010021343,1002031343,1004031343,1006031343,1008031343,1010031343,1002041343,1004041343,1006041343,1008041343,1010041343]','[]','[]','[{0,1010041353,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,20}]',150),(34091401,'武器','14阶粉色武器【重炮手】',2,'[{lv,620}]',3,'[{0,38280520,25}]','[1001011443,1007011443,1001021443,1007021443,1001031443,1007031443,1001041443,1007041443]','[]','[]','[{0,1001041453,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,25}]',150),(34091402,'头盔','14阶粉色头盔【重炮手】',2,'[{lv,620}]',3,'[{0,38280510,25}]','[1002011443,1004011443,1006011443,1008011443,1010011443,1002021443,1004021443,1006021443,1008021443,1010021443,1002031443,1004031443,1006031443,1008031443,1010031443,1002041443,1004041443,1006041443,1008041443,1010041443]','[]','[]','[{0,1002041453,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,25}]',150),(34091403,'项链','14阶粉色项链【通用】',2,'[{lv,620}]',3,'[{0,38280520,25}]','[1003001443,1003001443,1003001443,1003001443]','[]','[]','[{0,1003001453,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,25}]',150),(34091404,'衣服','14阶粉色衣服【重炮手】',2,'[{lv,620}]',3,'[{0,38280510,25}]','[1002011443,1004011443,1006011443,1008011443,1010011443,1002021443,1004021443,1006021443,1008021443,1010021443,1002031443,1004031443,1006031443,1008031443,1010031443,1002041443,1004041443,1006041443,1008041443,1010041443]','[]','[]','[{0,1004041453,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,25}]',150),(34091405,'刻痕','14阶粉色刻痕【通用】',2,'[{lv,620}]',3,'[{0,38280520,25}]','[1005001443,1009001443,1005001443,1009001443,1005001443,1009001443,1005001443,1009001443]','[]','[]','[{0,1005001453,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,25}]',150),(34091406,'裤子','14阶粉色裤子【重炮手】',2,'[{lv,620}]',3,'[{0,38280510,25}]','[1002011443,1004011443,1006011443,1008011443,1010011443,1002021443,1004021443,1006021443,1008021443,1010021443,1002031443,1004031443,1006031443,1008031443,1010031443,1002041443,1004041443,1006041443,1008041443,1010041443]','[]','[]','[{0,1006041453,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,25}]',150),(34091407,'副手','14阶粉色副手【重炮手】',2,'[{lv,620}]',3,'[{0,38280520,25}]','[1001011443,1007011443,1001021443,1007021443,1001031443,1007031443,1001041443,1007041443]','[]','[]','[{0,1007041453,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,25}]',150),(34091408,'护腕','14阶粉色护腕【重炮手】',2,'[{lv,620}]',3,'[{0,38280510,25}]','[1002011443,1004011443,1006011443,1008011443,1010011443,1002021443,1004021443,1006021443,1008021443,1010021443,1002031443,1004031443,1006031443,1008031443,1010031443,1002041443,1004041443,1006041443,1008041443,1010041443]','[]','[]','[{0,1008041453,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,25}]',150),(34091409,'戒指','14阶粉色戒指【通用】',2,'[{lv,620}]',3,'[{0,38280520,25}]','[1005001443,1009001443,1005001443,1009001443,1005001443,1009001443,1005001443,1009001443]','[]','[]','[{0,1009001453,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,25}]',150),(34091410,'鞋子','14阶粉色鞋子【重炮手】',2,'[{lv,620}]',3,'[{0,38280510,25}]','[1002011443,1004011443,1006011443,1008011443,1010011443,1002021443,1004021443,1006021443,1008021443,1010021443,1002031443,1004031443,1006031443,1008031443,1010031443,1002041443,1004041443,1006041443,1008041443,1010041443]','[]','[]','[{0,1010041453,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,25}]',150),(34091501,'武器','15阶粉色武器【重炮手】',2,'[{lv,650}]',3,'[{0,38280520,30}]','[1001011543,1007011543,1001021543,1007021543,1001031543,1007031543,1001041543,1007041543]','[]','[]','[{0,1001041553,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,30}]',150),(34091502,'头盔','15阶粉色头盔【重炮手】',2,'[{lv,650}]',3,'[{0,38280510,30}]','[1002011543,1004011543,1006011543,1008011543,1010011543,1002021543,1004021543,1006021543,1008021543,1010021543,1002031543,1004031543,1006031543,1008031543,1010031543,1002041543,1004041543,1006041543,1008041543,1010041543]','[]','[]','[{0,1002041553,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,30}]',150),(34091503,'项链','15阶粉色项链【通用】',2,'[{lv,650}]',3,'[{0,38280520,30}]','[1003001543,1003001543,1003001543,1003001543]','[]','[]','[{0,1003001553,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,30}]',150),(34091504,'衣服','15阶粉色衣服【重炮手】',2,'[{lv,650}]',3,'[{0,38280510,30}]','[1002011543,1004011543,1006011543,1008011543,1010011543,1002021543,1004021543,1006021543,1008021543,1010021543,1002031543,1004031543,1006031543,1008031543,1010031543,1002041543,1004041543,1006041543,1008041543,1010041543]','[]','[]','[{0,1004041553,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,30}]',150),(34091505,'刻痕','15阶粉色刻痕【通用】',2,'[{lv,650}]',3,'[{0,38280520,30}]','[1005001543,1009001543,1005001543,1009001543,1005001543,1009001543,1005001543,1009001543]','[]','[]','[{0,1005001553,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,30}]',150),(34091506,'裤子','15阶粉色裤子【重炮手】',2,'[{lv,650}]',3,'[{0,38280510,30}]','[1002011543,1004011543,1006011543,1008011543,1010011543,1002021543,1004021543,1006021543,1008021543,1010021543,1002031543,1004031543,1006031543,1008031543,1010031543,1002041543,1004041543,1006041543,1008041543,1010041543]','[]','[]','[{0,1006041553,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,30}]',150),(34091507,'副手','15阶粉色副手【重炮手】',2,'[{lv,650}]',3,'[{0,38280520,30}]','[1001011543,1007011543,1001021543,1007021543,1001031543,1007031543,1001041543,1007041543]','[]','[]','[{0,1007041553,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,30}]',150),(34091508,'护腕','15阶粉色护腕【重炮手】',2,'[{lv,650}]',3,'[{0,38280510,30}]','[1002011543,1004011543,1006011543,1008011543,1010011543,1002021543,1004021543,1006021543,1008021543,1010021543,1002031543,1004031543,1006031543,1008031543,1010031543,1002041543,1004041543,1006041543,1008041543,1010041543]','[]','[]','[{0,1008041553,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,30}]',150),(34091509,'戒指','15阶粉色戒指【通用】',2,'[{lv,650}]',3,'[{0,38280520,30}]','[1005001543,1009001543,1005001543,1009001543,1005001543,1009001543,1005001543,1009001543]','[]','[]','[{0,1009001553,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,30}]',150),(34091510,'鞋子','15阶粉色鞋子【重炮手】',2,'[{lv,650}]',3,'[{0,38280510,30}]','[1002011543,1004011543,1006011543,1008011543,1010011543,1002021543,1004021543,1006021543,1008021543,1010021543,1002031543,1004031543,1006031543,1008031543,1010031543,1002041543,1004041543,1006041543,1008041543,1010041543]','[]','[]','[{0,1010041553,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,30}]',150),(34091601,'武器','16阶粉色武器【重炮手】',2,'[{lv,700}]',3,'[{0,38280520,35}]','[1001011643,1007011643,1001021643,1007021643,1001031643,1007031643,1001041643,1007041643]','[]','[]','[{0,1001041653,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,35}]',150),(34091602,'头盔','16阶粉色头盔【重炮手】',2,'[{lv,700}]',3,'[{0,38280510,35}]','[1002011643,1004011643,1006011643,1008011643,1010011643,1002021643,1004021643,1006021643,1008021643,1010021643,1002031643,1004031643,1006031643,1008031643,1010031643,1002041643,1004041643,1006041643,1008041643,1010041643]','[]','[]','[{0,1002041653,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,35}]',150),(34091603,'项链','16阶粉色项链【通用】',2,'[{lv,700}]',3,'[{0,38280520,35}]','[1003001643,1003001643,1003001643,1003001643]','[]','[]','[{0,1003001653,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,35}]',150),(34091604,'衣服','16阶粉色衣服【重炮手】',2,'[{lv,700}]',3,'[{0,38280510,35}]','[1002011643,1004011643,1006011643,1008011643,1010011643,1002021643,1004021643,1006021643,1008021643,1010021643,1002031643,1004031643,1006031643,1008031643,1010031643,1002041643,1004041643,1006041643,1008041643,1010041643]','[]','[]','[{0,1004041653,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,35}]',150),(34091605,'刻痕','16阶粉色刻痕【通用】',2,'[{lv,700}]',3,'[{0,38280520,35}]','[1005001643,1009001643,1005001643,1009001643,1005001643,1009001643,1005001643,1009001643]','[]','[]','[{0,1005001653,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,35}]',150),(34091606,'裤子','16阶粉色裤子【重炮手】',2,'[{lv,700}]',3,'[{0,38280510,35}]','[1002011643,1004011643,1006011643,1008011643,1010011643,1002021643,1004021643,1006021643,1008021643,1010021643,1002031643,1004031643,1006031643,1008031643,1010031643,1002041643,1004041643,1006041643,1008041643,1010041643]','[]','[]','[{0,1006041653,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,35}]',150),(34091607,'副手','16阶粉色副手【重炮手】',2,'[{lv,700}]',3,'[{0,38280520,35}]','[1001011643,1007011643,1001021643,1007021643,1001031643,1007031643,1001041643,1007041643]','[]','[]','[{0,1007041653,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,35}]',150),(34091608,'护腕','16阶粉色护腕【重炮手】',2,'[{lv,700}]',3,'[{0,38280510,35}]','[1002011643,1004011643,1006011643,1008011643,1010011643,1002021643,1004021643,1006021643,1008021643,1010021643,1002031643,1004031643,1006031643,1008031643,1010031643,1002041643,1004041643,1006041643,1008041643,1010041643]','[]','[]','[{0,1008041653,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,35}]',150),(34091609,'戒指','16阶粉色戒指【通用】',2,'[{lv,700}]',3,'[{0,38280520,35}]','[1005001643,1009001643,1005001643,1009001643,1005001643,1009001643,1005001643,1009001643]','[]','[]','[{0,1009001653,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280520,35}]',150),(34091610,'鞋子','16阶粉色鞋子【重炮手】',2,'[{lv,700}]',3,'[{0,38280510,35}]','[1002011643,1004011643,1006011643,1008011643,1010011643,1002021643,1004021643,1006021643,1008021643,1010021643,1002031643,1004031643,1006031643,1008031643,1010031643,1002041643,1004041643,1006041643,1008041643,1010041643]','[]','[]','[{0,1010041653,1}]',2,'[{1,0},{2,80},{3,100}]',3,1,'[{0,38280510,35}]',150),(34100301,'武器','3阶神装武器【重炮手】',2,'[{lv,9999}]',3,'[{0,38280620,2}]','[1001010263,1007010263,1001020263,1007020263,1001030263,1007030263,1001040263,1007040263]','[]','[]','[{0,1001040363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100302,'头盔','3阶神装头盔【重炮手】',2,'[{lv,9999}]',3,'[{0,38280620,2}]','[1002010263,1004010263,1006010263,1008010263,1010010263,1002020263,1004020263,1006020263,1008020263,1010020263,1002030263,1004030263,1006030263,1008030263,1010030263,1002040263,1004040263,1006040263,1008040263,1010040263]','[]','[]','[{0,1002040363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100303,'项链','3阶神装项链【通用】',2,'[{lv,9999}]',3,'[{0,38280620,2}]','[1003000263,1003000263,1003000263,1003000263]','[]','[]','[{0,1003000363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100304,'衣服','3阶神装衣服【重炮手】',2,'[{lv,9999}]',3,'[{0,38280620,2}]','[1002010263,1004010263,1006010263,1008010263,1010010263,1002020263,1004020263,1006020263,1008020263,1010020263,1002030263,1004030263,1006030263,1008030263,1010030263,1002040263,1004040263,1006040263,1008040263,1010040263]','[]','[]','[{0,1004040363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100305,'刻痕','3阶神装刻痕【通用】',2,'[{lv,9999}]',3,'[{0,38280620,2}]','[1005000263,1009000263,1005000263,1009000263,1005000263,1009000263,1005000263,1009000263]','[]','[]','[{0,1005000363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100306,'裤子','3阶神装裤子【重炮手】',2,'[{lv,9999}]',3,'[{0,38280620,2}]','[1002010263,1004010263,1006010263,1008010263,1010010263,1002020263,1004020263,1006020263,1008020263,1010020263,1002030263,1004030263,1006030263,1008030263,1010030263,1002040263,1004040263,1006040263,1008040263,1010040263]','[]','[]','[{0,1006040363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100307,'副手','3阶神装副手【重炮手】',2,'[{lv,9999}]',3,'[{0,38280620,2}]','[1001010263,1007010263,1001020263,1007020263,1001030263,1007030263,1001040263,1007040263]','[]','[]','[{0,1007040363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100308,'护腕','3阶神装护腕【重炮手】',2,'[{lv,9999}]',3,'[{0,38280620,2}]','[1002010263,1004010263,1006010263,1008010263,1010010263,1002020263,1004020263,1006020263,1008020263,1010020263,1002030263,1004030263,1006030263,1008030263,1010030263,1002040263,1004040263,1006040263,1008040263,1010040263]','[]','[]','[{0,1008040363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100309,'戒指','3阶神装戒指【通用】',2,'[{lv,9999}]',3,'[{0,38280620,2}]','[1005000263,1009000263,1005000263,1009000263,1005000263,1009000263,1005000263,1009000263]','[]','[]','[{0,1009000363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100310,'鞋子','3阶神装鞋子【重炮手】',2,'[{lv,9999}]',3,'[{0,38280620,2}]','[1002010263,1004010263,1006010263,1008010263,1010010263,1002020263,1004020263,1006020263,1008020263,1010020263,1002030263,1004030263,1006030263,1008030263,1010030263,1002040263,1004040263,1006040263,1008040263,1010040263]','[]','[]','[{0,1010040363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100401,'武器','4阶神装武器【重炮手】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1001010363,1007010363,1001020363,1007020363,1001030363,1007030363,1001040363,1007040363]','[]','[]','[{0,1001040463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100402,'头盔','4阶神装头盔【重炮手】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1002010363,1004010363,1006010363,1008010363,1010010363,1002020363,1004020363,1006020363,1008020363,1010020363,1002030363,1004030363,1006030363,1008030363,1010030363,1002040363,1004040363,1006040363,1008040363,1010040363]','[]','[]','[{0,1002040463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100403,'项链','4阶神装项链【通用】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1003000363,1003000363,1003000363,1003000363]','[]','[]','[{0,1003000463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100404,'衣服','4阶神装衣服【重炮手】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1002010363,1004010363,1006010363,1008010363,1010010363,1002020363,1004020363,1006020363,1008020363,1010020363,1002030363,1004030363,1006030363,1008030363,1010030363,1002040363,1004040363,1006040363,1008040363,1010040363]','[]','[]','[{0,1004040463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100405,'刻痕','4阶神装刻痕【通用】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1005000363,1009000363,1005000363,1009000363,1005000363,1009000363,1005000363,1009000363]','[]','[]','[{0,1005000463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100406,'裤子','4阶神装裤子【重炮手】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1002010363,1004010363,1006010363,1008010363,1010010363,1002020363,1004020363,1006020363,1008020363,1010020363,1002030363,1004030363,1006030363,1008030363,1010030363,1002040363,1004040363,1006040363,1008040363,1010040363]','[]','[]','[{0,1006040463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100407,'副手','4阶神装副手【重炮手】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1001010363,1007010363,1001020363,1007020363,1001030363,1007030363,1001040363,1007040363]','[]','[]','[{0,1007040463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100408,'护腕','4阶神装护腕【重炮手】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1002010363,1004010363,1006010363,1008010363,1010010363,1002020363,1004020363,1006020363,1008020363,1010020363,1002030363,1004030363,1006030363,1008030363,1010030363,1002040363,1004040363,1006040363,1008040363,1010040363]','[]','[]','[{0,1008040463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100409,'戒指','4阶神装戒指【通用】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1005000363,1009000363,1005000363,1009000363,1005000363,1009000363,1005000363,1009000363]','[]','[]','[{0,1009000463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100410,'鞋子','4阶神装鞋子【重炮手】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1002010363,1004010363,1006010363,1008010363,1010010363,1002020363,1004020363,1006020363,1008020363,1010020363,1002030363,1004030363,1006030363,1008030363,1010030363,1002040363,1004040363,1006040363,1008040363,1010040363]','[]','[]','[{0,1010040463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100501,'武器','5阶神装武器【重炮手】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1001010463,1007010463,1001020463,1007020463,1001030463,1007030463,1001040463,1007040463]','[]','[]','[{0,1001040563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100502,'头盔','5阶神装头盔【重炮手】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1002010463,1004010463,1006010463,1008010463,1010010463,1002020463,1004020463,1006020463,1008020463,1010020463,1002030463,1004030463,1006030463,1008030463,1010030463,1002040463,1004040463,1006040463,1008040463,1010040463]','[]','[]','[{0,1002040563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100503,'项链','5阶神装项链【通用】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1003000463,1003000463,1003000463,1003000463]','[]','[]','[{0,1003000563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100504,'衣服','5阶神装衣服【重炮手】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1002010463,1004010463,1006010463,1008010463,1010010463,1002020463,1004020463,1006020463,1008020463,1010020463,1002030463,1004030463,1006030463,1008030463,1010030463,1002040463,1004040463,1006040463,1008040463,1010040463]','[]','[]','[{0,1004040563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100505,'刻痕','5阶神装刻痕【通用】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1005000463,1009000463,1005000463,1009000463,1005000463,1009000463,1005000463,1009000463]','[]','[]','[{0,1005000563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100506,'裤子','5阶神装裤子【重炮手】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1002010463,1004010463,1006010463,1008010463,1010010463,1002020463,1004020463,1006020463,1008020463,1010020463,1002030463,1004030463,1006030463,1008030463,1010030463,1002040463,1004040463,1006040463,1008040463,1010040463]','[]','[]','[{0,1006040563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100507,'副手','5阶神装副手【重炮手】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1001010463,1007010463,1001020463,1007020463,1001030463,1007030463,1001040463,1007040463]','[]','[]','[{0,1007040563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100508,'护腕','5阶神装护腕【重炮手】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1002010463,1004010463,1006010463,1008010463,1010010463,1002020463,1004020463,1006020463,1008020463,1010020463,1002030463,1004030463,1006030463,1008030463,1010030463,1002040463,1004040463,1006040463,1008040463,1010040463]','[]','[]','[{0,1008040563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100509,'戒指','5阶神装戒指【通用】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1005000463,1009000463,1005000463,1009000463,1005000463,1009000463,1005000463,1009000463]','[]','[]','[{0,1009000563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100510,'鞋子','5阶神装鞋子【重炮手】',2,'[{lv,160}]',3,'[{0,38280620,2}]','[1002010463,1004010463,1006010463,1008010463,1010010463,1002020463,1004020463,1006020463,1008020463,1010020463,1002030463,1004030463,1006030463,1008030463,1010030463,1002040463,1004040463,1006040463,1008040463,1010040463]','[]','[]','[{0,1010040563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100601,'武器','6阶神装武器【重炮手】',2,'[{lv,180}]',3,'[{0,38280620,2}]','[1001010563,1007010563,1001020563,1007020563,1001030563,1007030563,1001040563,1007040563]','[]','[]','[{0,1001040663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100602,'头盔','6阶神装头盔【重炮手】',2,'[{lv,180}]',3,'[{0,38280620,2}]','[1002010563,1004010563,1006010563,1008010563,1010010563,1002020563,1004020563,1006020563,1008020563,1010020563,1002030563,1004030563,1006030563,1008030563,1010030563,1002040563,1004040563,1006040563,1008040563,1010040563]','[]','[]','[{0,1002040663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100603,'项链','6阶神装项链【通用】',2,'[{lv,180}]',3,'[{0,38280620,2}]','[1003000563,1003000563,1003000563,1003000563]','[]','[]','[{0,1003000663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100604,'衣服','6阶神装衣服【重炮手】',2,'[{lv,180}]',3,'[{0,38280620,2}]','[1002010563,1004010563,1006010563,1008010563,1010010563,1002020563,1004020563,1006020563,1008020563,1010020563,1002030563,1004030563,1006030563,1008030563,1010030563,1002040563,1004040563,1006040563,1008040563,1010040563]','[]','[]','[{0,1004040663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100605,'刻痕','6阶神装刻痕【通用】',2,'[{lv,180}]',3,'[{0,38280620,2}]','[1005000563,1009000563,1005000563,1009000563,1005000563,1009000563,1005000563,1009000563]','[]','[]','[{0,1005000663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100606,'裤子','6阶神装裤子【重炮手】',2,'[{lv,180}]',3,'[{0,38280620,2}]','[1002010563,1004010563,1006010563,1008010563,1010010563,1002020563,1004020563,1006020563,1008020563,1010020563,1002030563,1004030563,1006030563,1008030563,1010030563,1002040563,1004040563,1006040563,1008040563,1010040563]','[]','[]','[{0,1006040663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100607,'副手','6阶神装副手【重炮手】',2,'[{lv,180}]',3,'[{0,38280620,2}]','[1001010563,1007010563,1001020563,1007020563,1001030563,1007030563,1001040563,1007040563]','[]','[]','[{0,1007040663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100608,'护腕','6阶神装护腕【重炮手】',2,'[{lv,180}]',3,'[{0,38280620,2}]','[1002010563,1004010563,1006010563,1008010563,1010010563,1002020563,1004020563,1006020563,1008020563,1010020563,1002030563,1004030563,1006030563,1008030563,1010030563,1002040563,1004040563,1006040563,1008040563,1010040563]','[]','[]','[{0,1008040663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100609,'戒指','6阶神装戒指【通用】',2,'[{lv,180}]',3,'[{0,38280620,2}]','[1005000563,1009000563,1005000563,1009000563,1005000563,1009000563,1005000563,1009000563]','[]','[]','[{0,1009000663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100610,'鞋子','6阶神装鞋子【重炮手】',2,'[{lv,180}]',3,'[{0,38280620,2}]','[1002010563,1004010563,1006010563,1008010563,1010010563,1002020563,1004020563,1006020563,1008020563,1010020563,1002030563,1004030563,1006030563,1008030563,1010030563,1002040563,1004040563,1006040563,1008040563,1010040563]','[]','[]','[{0,1010040663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100701,'武器','7阶神装武器【重炮手】',2,'[{lv,220}]',3,'[{0,38280620,2}]','[1001010663,1007010663,1001020663,1007020663,1001030663,1007030663,1001040663,1007040663]','[]','[]','[{0,1001040763,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100702,'头盔','7阶神装头盔【重炮手】',2,'[{lv,220}]',3,'[{0,38280620,2}]','[1002010663,1004010663,1006010663,1008010663,1010010663,1002020663,1004020663,1006020663,1008020663,1010020663,1002030663,1004030663,1006030663,1008030663,1010030663,1002040663,1004040663,1006040663,1008040663,1010040663]','[]','[]','[{0,1002040763,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100703,'项链','7阶神装项链【通用】',2,'[{lv,220}]',3,'[{0,38280620,2}]','[1003000663,1003000663,1003000663,1003000663]','[]','[]','[{0,1003000763,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100704,'衣服','7阶神装衣服【重炮手】',2,'[{lv,220}]',3,'[{0,38280620,2}]','[1002010663,1004010663,1006010663,1008010663,1010010663,1002020663,1004020663,1006020663,1008020663,1010020663,1002030663,1004030663,1006030663,1008030663,1010030663,1002040663,1004040663,1006040663,1008040663,1010040663]','[]','[]','[{0,1004040763,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100705,'刻痕','7阶神装刻痕【通用】',2,'[{lv,220}]',3,'[{0,38280620,2}]','[1005000663,1009000663,1005000663,1009000663,1005000663,1009000663,1005000663,1009000663]','[]','[]','[{0,1005000763,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100706,'裤子','7阶神装裤子【重炮手】',2,'[{lv,220}]',3,'[{0,38280620,2}]','[1002010663,1004010663,1006010663,1008010663,1010010663,1002020663,1004020663,1006020663,1008020663,1010020663,1002030663,1004030663,1006030663,1008030663,1010030663,1002040663,1004040663,1006040663,1008040663,1010040663]','[]','[]','[{0,1006040763,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100707,'副手','7阶神装副手【重炮手】',2,'[{lv,220}]',3,'[{0,38280620,2}]','[1001010663,1007010663,1001020663,1007020663,1001030663,1007030663,1001040663,1007040663]','[]','[]','[{0,1007040763,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100708,'护腕','7阶神装护腕【重炮手】',2,'[{lv,220}]',3,'[{0,38280620,2}]','[1002010663,1004010663,1006010663,1008010663,1010010663,1002020663,1004020663,1006020663,1008020663,1010020663,1002030663,1004030663,1006030663,1008030663,1010030663,1002040663,1004040663,1006040663,1008040663,1010040663]','[]','[]','[{0,1008040763,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100709,'戒指','7阶神装戒指【通用】',2,'[{lv,220}]',3,'[{0,38280620,2}]','[1005000663,1009000663,1005000663,1009000663,1005000663,1009000663,1005000663,1009000663]','[]','[]','[{0,1009000763,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100710,'鞋子','7阶神装鞋子【重炮手】',2,'[{lv,220}]',3,'[{0,38280620,2}]','[1002010663,1004010663,1006010663,1008010663,1010010663,1002020663,1004020663,1006020663,1008020663,1010020663,1002030663,1004030663,1006030663,1008030663,1010030663,1002040663,1004040663,1006040663,1008040663,1010040663]','[]','[]','[{0,1010040763,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100801,'武器','8阶神装武器【重炮手】',2,'[{lv,260}]',3,'[{0,38280620,2}]','[1001010763,1007010763,1001020763,1007020763,1001030763,1007030763,1001040763,1007040763]','[]','[]','[{0,1001040863,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100802,'头盔','8阶神装头盔【重炮手】',2,'[{lv,260}]',3,'[{0,38280620,2}]','[1002010763,1004010763,1006010763,1008010763,1010010763,1002020763,1004020763,1006020763,1008020763,1010020763,1002030763,1004030763,1006030763,1008030763,1010030763,1002040763,1004040763,1006040763,1008040763,1010040763]','[]','[]','[{0,1002040863,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100803,'项链','8阶神装项链【通用】',2,'[{lv,260}]',3,'[{0,38280620,2}]','[1003000763,1003000763,1003000763,1003000763]','[]','[]','[{0,1003000863,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100804,'衣服','8阶神装衣服【重炮手】',2,'[{lv,260}]',3,'[{0,38280620,2}]','[1002010763,1004010763,1006010763,1008010763,1010010763,1002020763,1004020763,1006020763,1008020763,1010020763,1002030763,1004030763,1006030763,1008030763,1010030763,1002040763,1004040763,1006040763,1008040763,1010040763]','[]','[]','[{0,1004040863,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100805,'刻痕','8阶神装刻痕【通用】',2,'[{lv,260}]',3,'[{0,38280620,2}]','[1005000763,1009000763,1005000763,1009000763,1005000763,1009000763,1005000763,1009000763]','[]','[]','[{0,1005000863,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100806,'裤子','8阶神装裤子【重炮手】',2,'[{lv,260}]',3,'[{0,38280620,2}]','[1002010763,1004010763,1006010763,1008010763,1010010763,1002020763,1004020763,1006020763,1008020763,1010020763,1002030763,1004030763,1006030763,1008030763,1010030763,1002040763,1004040763,1006040763,1008040763,1010040763]','[]','[]','[{0,1006040863,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100807,'副手','8阶神装副手【重炮手】',2,'[{lv,260}]',3,'[{0,38280620,2}]','[1001010763,1007010763,1001020763,1007020763,1001030763,1007030763,1001040763,1007040763]','[]','[]','[{0,1007040863,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100808,'护腕','8阶神装护腕【重炮手】',2,'[{lv,260}]',3,'[{0,38280620,2}]','[1002010763,1004010763,1006010763,1008010763,1010010763,1002020763,1004020763,1006020763,1008020763,1010020763,1002030763,1004030763,1006030763,1008030763,1010030763,1002040763,1004040763,1006040763,1008040763,1010040763]','[]','[]','[{0,1008040863,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100809,'戒指','8阶神装戒指【通用】',2,'[{lv,260}]',3,'[{0,38280620,2}]','[1005000763,1009000763,1005000763,1009000763,1005000763,1009000763,1005000763,1009000763]','[]','[]','[{0,1009000863,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100810,'鞋子','8阶神装鞋子【重炮手】',2,'[{lv,260}]',3,'[{0,38280620,2}]','[1002010763,1004010763,1006010763,1008010763,1010010763,1002020763,1004020763,1006020763,1008020763,1010020763,1002030763,1004030763,1006030763,1008030763,1010030763,1002040763,1004040763,1006040763,1008040763,1010040763]','[]','[]','[{0,1010040863,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100901,'武器','9阶神装武器【重炮手】',2,'[{lv,300}]',3,'[{0,38280620,2}]','[1001010863,1007010863,1001020863,1007020863,1001030863,1007030863,1001040863,1007040863]','[]','[]','[{0,1001040963,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100902,'头盔','9阶神装头盔【重炮手】',2,'[{lv,300}]',3,'[{0,38280620,2}]','[1002010863,1004010863,1006010863,1008010863,1010010863,1002020863,1004020863,1006020863,1008020863,1010020863,1002030863,1004030863,1006030863,1008030863,1010030863,1002040863,1004040863,1006040863,1008040863,1010040863]','[]','[]','[{0,1002040963,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100903,'项链','9阶神装项链【通用】',2,'[{lv,300}]',3,'[{0,38280620,2}]','[1003000863,1003000863,1003000863,1003000863]','[]','[]','[{0,1003000963,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100904,'衣服','9阶神装衣服【重炮手】',2,'[{lv,300}]',3,'[{0,38280620,2}]','[1002010863,1004010863,1006010863,1008010863,1010010863,1002020863,1004020863,1006020863,1008020863,1010020863,1002030863,1004030863,1006030863,1008030863,1010030863,1002040863,1004040863,1006040863,1008040863,1010040863]','[]','[]','[{0,1004040963,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100905,'刻痕','9阶神装刻痕【通用】',2,'[{lv,300}]',3,'[{0,38280620,2}]','[1005000863,1009000863,1005000863,1009000863,1005000863,1009000863,1005000863,1009000863]','[]','[]','[{0,1005000963,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100906,'裤子','9阶神装裤子【重炮手】',2,'[{lv,300}]',3,'[{0,38280620,2}]','[1002010863,1004010863,1006010863,1008010863,1010010863,1002020863,1004020863,1006020863,1008020863,1010020863,1002030863,1004030863,1006030863,1008030863,1010030863,1002040863,1004040863,1006040863,1008040863,1010040863]','[]','[]','[{0,1006040963,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100907,'副手','9阶神装副手【重炮手】',2,'[{lv,300}]',3,'[{0,38280620,2}]','[1001010863,1007010863,1001020863,1007020863,1001030863,1007030863,1001040863,1007040863]','[]','[]','[{0,1007040963,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100908,'护腕','9阶神装护腕【重炮手】',2,'[{lv,300}]',3,'[{0,38280620,2}]','[1002010863,1004010863,1006010863,1008010863,1010010863,1002020863,1004020863,1006020863,1008020863,1010020863,1002030863,1004030863,1006030863,1008030863,1010030863,1002040863,1004040863,1006040863,1008040863,1010040863]','[]','[]','[{0,1008040963,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100909,'戒指','9阶神装戒指【通用】',2,'[{lv,300}]',3,'[{0,38280620,2}]','[1005000863,1009000863,1005000863,1009000863,1005000863,1009000863,1005000863,1009000863]','[]','[]','[{0,1009000963,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34100910,'鞋子','9阶神装鞋子【重炮手】',2,'[{lv,300}]',3,'[{0,38280620,2}]','[1002010863,1004010863,1006010863,1008010863,1010010863,1002020863,1004020863,1006020863,1008020863,1010020863,1002030863,1004030863,1006030863,1008030863,1010030863,1002040863,1004040863,1006040863,1008040863,1010040863]','[]','[]','[{0,1010040963,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101001,'武器','10阶神装武器【重炮手】',2,'[{lv,355}]',3,'[{0,38280620,2}]','[1001010963,1007010963,1001020963,1007020963,1001030963,1007030963,1001040963,1007040963]','[]','[]','[{0,1001041063,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101002,'头盔','10阶神装头盔【重炮手】',2,'[{lv,355}]',3,'[{0,38280620,2}]','[1002010963,1004010963,1006010963,1008010963,1010010963,1002020963,1004020963,1006020963,1008020963,1010020963,1002030963,1004030963,1006030963,1008030963,1010030963,1002040963,1004040963,1006040963,1008040963,1010040963]','[]','[]','[{0,1002041063,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101003,'项链','10阶神装项链【通用】',2,'[{lv,355}]',3,'[{0,38280620,2}]','[1003000963,1003000963,1003000963,1003000963]','[]','[]','[{0,1003001063,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101004,'衣服','10阶神装衣服【重炮手】',2,'[{lv,355}]',3,'[{0,38280620,2}]','[1002010963,1004010963,1006010963,1008010963,1010010963,1002020963,1004020963,1006020963,1008020963,1010020963,1002030963,1004030963,1006030963,1008030963,1010030963,1002040963,1004040963,1006040963,1008040963,1010040963]','[]','[]','[{0,1004041063,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101005,'刻痕','10阶神装刻痕【通用】',2,'[{lv,355}]',3,'[{0,38280620,2}]','[1005000963,1009000963,1005000963,1009000963,1005000963,1009000963,1005000963,1009000963]','[]','[]','[{0,1005001063,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101006,'裤子','10阶神装裤子【重炮手】',2,'[{lv,355}]',3,'[{0,38280620,2}]','[1002010963,1004010963,1006010963,1008010963,1010010963,1002020963,1004020963,1006020963,1008020963,1010020963,1002030963,1004030963,1006030963,1008030963,1010030963,1002040963,1004040963,1006040963,1008040963,1010040963]','[]','[]','[{0,1006041063,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101007,'副手','10阶神装副手【重炮手】',2,'[{lv,355}]',3,'[{0,38280620,2}]','[1001010963,1007010963,1001020963,1007020963,1001030963,1007030963,1001040963,1007040963]','[]','[]','[{0,1007041063,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101008,'护腕','10阶神装护腕【重炮手】',2,'[{lv,355}]',3,'[{0,38280620,2}]','[1002010963,1004010963,1006010963,1008010963,1010010963,1002020963,1004020963,1006020963,1008020963,1010020963,1002030963,1004030963,1006030963,1008030963,1010030963,1002040963,1004040963,1006040963,1008040963,1010040963]','[]','[]','[{0,1008041063,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101009,'戒指','10阶神装戒指【通用】',2,'[{lv,355}]',3,'[{0,38280620,2}]','[1005000963,1009000963,1005000963,1009000963,1005000963,1009000963,1005000963,1009000963]','[]','[]','[{0,1009001063,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101010,'鞋子','10阶神装鞋子【重炮手】',2,'[{lv,355}]',3,'[{0,38280620,2}]','[1002010963,1004010963,1006010963,1008010963,1010010963,1002020963,1004020963,1006020963,1008020963,1010020963,1002030963,1004030963,1006030963,1008030963,1010030963,1002040963,1004040963,1006040963,1008040963,1010040963]','[]','[]','[{0,1010041063,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101101,'武器','11阶神装武器【重炮手】',2,'[{lv,400}]',3,'[{0,38280620,2}]','[1001011063,1007011063,1001021063,1007021063,1001031063,1007031063,1001041063,1007041063]','[]','[]','[{0,1001041163,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101102,'头盔','11阶神装头盔【重炮手】',2,'[{lv,400}]',3,'[{0,38280620,2}]','[1002011063,1004011063,1006011063,1008011063,1010011063,1002021063,1004021063,1006021063,1008021063,1010021063,1002031063,1004031063,1006031063,1008031063,1010031063,1002041063,1004041063,1006041063,1008041063,1010041063]','[]','[]','[{0,1002041163,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101103,'项链','11阶神装项链【通用】',2,'[{lv,400}]',3,'[{0,38280620,2}]','[1003001063,1003001063,1003001063,1003001063]','[]','[]','[{0,1003001163,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101104,'衣服','11阶神装衣服【重炮手】',2,'[{lv,400}]',3,'[{0,38280620,2}]','[1002011063,1004011063,1006011063,1008011063,1010011063,1002021063,1004021063,1006021063,1008021063,1010021063,1002031063,1004031063,1006031063,1008031063,1010031063,1002041063,1004041063,1006041063,1008041063,1010041063]','[]','[]','[{0,1004041163,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101105,'刻痕','11阶神装刻痕【通用】',2,'[{lv,400}]',3,'[{0,38280620,2}]','[1005001063,1009001063,1005001063,1009001063,1005001063,1009001063,1005001063,1009001063]','[]','[]','[{0,1005001163,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101106,'裤子','11阶神装裤子【重炮手】',2,'[{lv,400}]',3,'[{0,38280620,2}]','[1002011063,1004011063,1006011063,1008011063,1010011063,1002021063,1004021063,1006021063,1008021063,1010021063,1002031063,1004031063,1006031063,1008031063,1010031063,1002041063,1004041063,1006041063,1008041063,1010041063]','[]','[]','[{0,1006041163,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101107,'副手','11阶神装副手【重炮手】',2,'[{lv,400}]',3,'[{0,38280620,2}]','[1001011063,1007011063,1001021063,1007021063,1001031063,1007031063,1001041063,1007041063]','[]','[]','[{0,1007041163,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101108,'护腕','11阶神装护腕【重炮手】',2,'[{lv,400}]',3,'[{0,38280620,2}]','[1002011063,1004011063,1006011063,1008011063,1010011063,1002021063,1004021063,1006021063,1008021063,1010021063,1002031063,1004031063,1006031063,1008031063,1010031063,1002041063,1004041063,1006041063,1008041063,1010041063]','[]','[]','[{0,1008041163,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101109,'戒指','11阶神装戒指【通用】',2,'[{lv,400}]',3,'[{0,38280620,2}]','[1005001063,1009001063,1005001063,1009001063,1005001063,1009001063,1005001063,1009001063]','[]','[]','[{0,1009001163,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101110,'鞋子','11阶神装鞋子【重炮手】',2,'[{lv,400}]',3,'[{0,38280620,2}]','[1002011063,1004011063,1006011063,1008011063,1010011063,1002021063,1004021063,1006021063,1008021063,1010021063,1002031063,1004031063,1006031063,1008031063,1010031063,1002041063,1004041063,1006041063,1008041063,1010041063]','[]','[]','[{0,1010041163,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101201,'武器','12阶神装武器【重炮手】',2,'[{lv,500}]',3,'[{0,38280620,2}]','[1001011163,1007011163,1001021163,1007021163,1001031163,1007031163,1001041163,1007041163]','[]','[]','[{0,1001041263,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101202,'头盔','12阶神装头盔【重炮手】',2,'[{lv,500}]',3,'[{0,38280620,2}]','[1002011163,1004011163,1006011163,1008011163,1010011163,1002021163,1004021163,1006021163,1008021163,1010021163,1002031163,1004031163,1006031163,1008031163,1010031163,1002041163,1004041163,1006041163,1008041163,1010041163]','[]','[]','[{0,1002041263,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101203,'项链','12阶神装项链【通用】',2,'[{lv,500}]',3,'[{0,38280620,2}]','[1003001163,1003001163,1003001163,1003001163]','[]','[]','[{0,1003001263,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101204,'衣服','12阶神装衣服【重炮手】',2,'[{lv,500}]',3,'[{0,38280620,2}]','[1002011163,1004011163,1006011163,1008011163,1010011163,1002021163,1004021163,1006021163,1008021163,1010021163,1002031163,1004031163,1006031163,1008031163,1010031163,1002041163,1004041163,1006041163,1008041163,1010041163]','[]','[]','[{0,1004041263,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101205,'刻痕','12阶神装刻痕【通用】',2,'[{lv,500}]',3,'[{0,38280620,2}]','[1005001163,1009001163,1005001163,1009001163,1005001163,1009001163,1005001163,1009001163]','[]','[]','[{0,1005001263,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101206,'裤子','12阶神装裤子【重炮手】',2,'[{lv,500}]',3,'[{0,38280620,2}]','[1002011163,1004011163,1006011163,1008011163,1010011163,1002021163,1004021163,1006021163,1008021163,1010021163,1002031163,1004031163,1006031163,1008031163,1010031163,1002041163,1004041163,1006041163,1008041163,1010041163]','[]','[]','[{0,1006041263,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101207,'副手','12阶神装副手【重炮手】',2,'[{lv,500}]',3,'[{0,38280620,2}]','[1001011163,1007011163,1001021163,1007021163,1001031163,1007031163,1001041163,1007041163]','[]','[]','[{0,1007041263,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101208,'护腕','12阶神装护腕【重炮手】',2,'[{lv,500}]',3,'[{0,38280620,2}]','[1002011163,1004011163,1006011163,1008011163,1010011163,1002021163,1004021163,1006021163,1008021163,1010021163,1002031163,1004031163,1006031163,1008031163,1010031163,1002041163,1004041163,1006041163,1008041163,1010041163]','[]','[]','[{0,1008041263,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101209,'戒指','12阶神装戒指【通用】',2,'[{lv,500}]',3,'[{0,38280620,2}]','[1005001163,1009001163,1005001163,1009001163,1005001163,1009001163,1005001163,1009001163]','[]','[]','[{0,1009001263,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101210,'鞋子','12阶神装鞋子【重炮手】',2,'[{lv,500}]',3,'[{0,38280620,2}]','[1002011163,1004011163,1006011163,1008011163,1010011163,1002021163,1004021163,1006021163,1008021163,1010021163,1002031163,1004031163,1006031163,1008031163,1010031163,1002041163,1004041163,1006041163,1008041163,1010041163]','[]','[]','[{0,1010041263,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101301,'武器','13阶神装武器【重炮手】',2,'[{lv,520}]',3,'[{0,38280620,2}]','[1001011263,1007011263,1001021263,1007021263,1001031263,1007031263,1001041263,1007041263]','[]','[]','[{0,1001041363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101302,'头盔','13阶神装头盔【重炮手】',2,'[{lv,520}]',3,'[{0,38280620,2}]','[1002011263,1004011263,1006011263,1008011263,1010011263,1002021263,1004021263,1006021263,1008021263,1010021263,1002031263,1004031263,1006031263,1008031263,1010031263,1002041263,1004041263,1006041263,1008041263,1010041263]','[]','[]','[{0,1002041363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101303,'项链','13阶神装项链【通用】',2,'[{lv,520}]',3,'[{0,38280620,2}]','[1003001263,1003001263,1003001263,1003001263]','[]','[]','[{0,1003001363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101304,'衣服','13阶神装衣服【重炮手】',2,'[{lv,520}]',3,'[{0,38280620,2}]','[1002011263,1004011263,1006011263,1008011263,1010011263,1002021263,1004021263,1006021263,1008021263,1010021263,1002031263,1004031263,1006031263,1008031263,1010031263,1002041263,1004041263,1006041263,1008041263,1010041263]','[]','[]','[{0,1004041363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101305,'刻痕','13阶神装刻痕【通用】',2,'[{lv,520}]',3,'[{0,38280620,2}]','[1005001263,1009001263,1005001263,1009001263,1005001263,1009001263,1005001263,1009001263]','[]','[]','[{0,1005001363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101306,'裤子','13阶神装裤子【重炮手】',2,'[{lv,520}]',3,'[{0,38280620,2}]','[1002011263,1004011263,1006011263,1008011263,1010011263,1002021263,1004021263,1006021263,1008021263,1010021263,1002031263,1004031263,1006031263,1008031263,1010031263,1002041263,1004041263,1006041263,1008041263,1010041263]','[]','[]','[{0,1006041363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101307,'副手','13阶神装副手【重炮手】',2,'[{lv,520}]',3,'[{0,38280620,2}]','[1001011263,1007011263,1001021263,1007021263,1001031263,1007031263,1001041263,1007041263]','[]','[]','[{0,1007041363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101308,'护腕','13阶神装护腕【重炮手】',2,'[{lv,520}]',3,'[{0,38280620,2}]','[1002011263,1004011263,1006011263,1008011263,1010011263,1002021263,1004021263,1006021263,1008021263,1010021263,1002031263,1004031263,1006031263,1008031263,1010031263,1002041263,1004041263,1006041263,1008041263,1010041263]','[]','[]','[{0,1008041363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101309,'戒指','13阶神装戒指【通用】',2,'[{lv,520}]',3,'[{0,38280620,2}]','[1005001263,1009001263,1005001263,1009001263,1005001263,1009001263,1005001263,1009001263]','[]','[]','[{0,1009001363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101310,'鞋子','13阶神装鞋子【重炮手】',2,'[{lv,520}]',3,'[{0,38280620,2}]','[1002011263,1004011263,1006011263,1008011263,1010011263,1002021263,1004021263,1006021263,1008021263,1010021263,1002031263,1004031263,1006031263,1008031263,1010031263,1002041263,1004041263,1006041263,1008041263,1010041263]','[]','[]','[{0,1010041363,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101401,'武器','14阶神装武器【重炮手】',2,'[{lv,620}]',3,'[{0,38280620,2}]','[1001011363,1007011363,1001021363,1007021363,1001031363,1007031363,1001041363,1007041363]','[]','[]','[{0,1001041463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101402,'头盔','14阶神装头盔【重炮手】',2,'[{lv,620}]',3,'[{0,38280620,2}]','[1002011363,1004011363,1006011363,1008011363,1010011363,1002021363,1004021363,1006021363,1008021363,1010021363,1002031363,1004031363,1006031363,1008031363,1010031363,1002041363,1004041363,1006041363,1008041363,1010041363]','[]','[]','[{0,1002041463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101403,'项链','14阶神装项链【通用】',2,'[{lv,620}]',3,'[{0,38280620,2}]','[1003001363,1003001363,1003001363,1003001363]','[]','[]','[{0,1003001463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101404,'衣服','14阶神装衣服【重炮手】',2,'[{lv,620}]',3,'[{0,38280620,2}]','[1002011363,1004011363,1006011363,1008011363,1010011363,1002021363,1004021363,1006021363,1008021363,1010021363,1002031363,1004031363,1006031363,1008031363,1010031363,1002041363,1004041363,1006041363,1008041363,1010041363]','[]','[]','[{0,1004041463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101405,'刻痕','14阶神装刻痕【通用】',2,'[{lv,620}]',3,'[{0,38280620,2}]','[1005001363,1009001363,1005001363,1009001363,1005001363,1009001363,1005001363,1009001363]','[]','[]','[{0,1005001463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101406,'裤子','14阶神装裤子【重炮手】',2,'[{lv,620}]',3,'[{0,38280620,2}]','[1002011363,1004011363,1006011363,1008011363,1010011363,1002021363,1004021363,1006021363,1008021363,1010021363,1002031363,1004031363,1006031363,1008031363,1010031363,1002041363,1004041363,1006041363,1008041363,1010041363]','[]','[]','[{0,1006041463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101407,'副手','14阶神装副手【重炮手】',2,'[{lv,620}]',3,'[{0,38280620,2}]','[1001011363,1007011363,1001021363,1007021363,1001031363,1007031363,1001041363,1007041363]','[]','[]','[{0,1007041463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101408,'护腕','14阶神装护腕【重炮手】',2,'[{lv,620}]',3,'[{0,38280620,2}]','[1002011363,1004011363,1006011363,1008011363,1010011363,1002021363,1004021363,1006021363,1008021363,1010021363,1002031363,1004031363,1006031363,1008031363,1010031363,1002041363,1004041363,1006041363,1008041363,1010041363]','[]','[]','[{0,1008041463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101409,'戒指','14阶神装戒指【通用】',2,'[{lv,620}]',3,'[{0,38280620,2}]','[1005001363,1009001363,1005001363,1009001363,1005001363,1009001363,1005001363,1009001363]','[]','[]','[{0,1009001463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101410,'鞋子','14阶神装鞋子【重炮手】',2,'[{lv,620}]',3,'[{0,38280620,2}]','[1002011363,1004011363,1006011363,1008011363,1010011363,1002021363,1004021363,1006021363,1008021363,1010021363,1002031363,1004031363,1006031363,1008031363,1010031363,1002041363,1004041363,1006041363,1008041363,1010041363]','[]','[]','[{0,1010041463,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101501,'武器','15阶神装武器【重炮手】',2,'[{lv,650}]',3,'[{0,38280620,2}]','[1001011463,1007011463,1001021463,1007021463,1001031463,1007031463,1001041463,1007041463]','[]','[]','[{0,1001041563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101502,'头盔','15阶神装头盔【重炮手】',2,'[{lv,650}]',3,'[{0,38280620,2}]','[1002011463,1004011463,1006011463,1008011463,1010011463,1002021463,1004021463,1006021463,1008021463,1010021463,1002031463,1004031463,1006031463,1008031463,1010031463,1002041463,1004041463,1006041463,1008041463,1010041463]','[]','[]','[{0,1002041563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101503,'项链','15阶神装项链【通用】',2,'[{lv,650}]',3,'[{0,38280620,2}]','[1003001463,1003001463,1003001463,1003001463]','[]','[]','[{0,1003001563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101504,'衣服','15阶神装衣服【重炮手】',2,'[{lv,650}]',3,'[{0,38280620,2}]','[1002011463,1004011463,1006011463,1008011463,1010011463,1002021463,1004021463,1006021463,1008021463,1010021463,1002031463,1004031463,1006031463,1008031463,1010031463,1002041463,1004041463,1006041463,1008041463,1010041463]','[]','[]','[{0,1004041563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101505,'刻痕','15阶神装刻痕【通用】',2,'[{lv,650}]',3,'[{0,38280620,2}]','[1005001463,1009001463,1005001463,1009001463,1005001463,1009001463,1005001463,1009001463]','[]','[]','[{0,1005001563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101506,'裤子','15阶神装裤子【重炮手】',2,'[{lv,650}]',3,'[{0,38280620,2}]','[1002011463,1004011463,1006011463,1008011463,1010011463,1002021463,1004021463,1006021463,1008021463,1010021463,1002031463,1004031463,1006031463,1008031463,1010031463,1002041463,1004041463,1006041463,1008041463,1010041463]','[]','[]','[{0,1006041563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101507,'副手','15阶神装副手【重炮手】',2,'[{lv,650}]',3,'[{0,38280620,2}]','[1001011463,1007011463,1001021463,1007021463,1001031463,1007031463,1001041463,1007041463]','[]','[]','[{0,1007041563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101508,'护腕','15阶神装护腕【重炮手】',2,'[{lv,650}]',3,'[{0,38280620,2}]','[1002011463,1004011463,1006011463,1008011463,1010011463,1002021463,1004021463,1006021463,1008021463,1010021463,1002031463,1004031463,1006031463,1008031463,1010031463,1002041463,1004041463,1006041463,1008041463,1010041463]','[]','[]','[{0,1008041563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101509,'戒指','15阶神装戒指【通用】',2,'[{lv,650}]',3,'[{0,38280620,2}]','[1005001463,1009001463,1005001463,1009001463,1005001463,1009001463,1005001463,1009001463]','[]','[]','[{0,1009001563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101510,'鞋子','15阶神装鞋子【重炮手】',2,'[{lv,650}]',3,'[{0,38280620,2}]','[1002011463,1004011463,1006011463,1008011463,1010011463,1002021463,1004021463,1006021463,1008021463,1010021463,1002031463,1004031463,1006031463,1008031463,1010031463,1002041463,1004041463,1006041463,1008041463,1010041463]','[]','[]','[{0,1010041563,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101601,'武器','16阶神装武器【重炮手】',2,'[{lv,700}]',3,'[{0,38280620,2}]','[1001011563,1007011563,1001021563,1007021563,1001031563,1007031563,1001041563,1007041563]','[]','[]','[{0,1001041663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101602,'头盔','16阶神装头盔【重炮手】',2,'[{lv,700}]',3,'[{0,38280620,2}]','[1002011563,1004011563,1006011563,1008011563,1010011563,1002021563,1004021563,1006021563,1008021563,1010021563,1002031563,1004031563,1006031563,1008031563,1010031563,1002041563,1004041563,1006041563,1008041563,1010041563]','[]','[]','[{0,1002041663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101603,'项链','16阶神装项链【通用】',2,'[{lv,700}]',3,'[{0,38280620,2}]','[1003001563,1003001563,1003001563,1003001563]','[]','[]','[{0,1003001663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101604,'衣服','16阶神装衣服【重炮手】',2,'[{lv,700}]',3,'[{0,38280620,2}]','[1002011563,1004011563,1006011563,1008011563,1010011563,1002021563,1004021563,1006021563,1008021563,1010021563,1002031563,1004031563,1006031563,1008031563,1010031563,1002041563,1004041563,1006041563,1008041563,1010041563]','[]','[]','[{0,1004041663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101605,'刻痕','16阶神装刻痕【通用】',2,'[{lv,700}]',3,'[{0,38280620,2}]','[1005001563,1009001563,1005001563,1009001563,1005001563,1009001563,1005001563,1009001563]','[]','[]','[{0,1005001663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101606,'裤子','16阶神装裤子【重炮手】',2,'[{lv,700}]',3,'[{0,38280620,2}]','[1002011563,1004011563,1006011563,1008011563,1010011563,1002021563,1004021563,1006021563,1008021563,1010021563,1002031563,1004031563,1006031563,1008031563,1010031563,1002041563,1004041563,1006041563,1008041563,1010041563]','[]','[]','[{0,1006041663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101607,'副手','16阶神装副手【重炮手】',2,'[{lv,700}]',3,'[{0,38280620,2}]','[1001011563,1007011563,1001021563,1007021563,1001031563,1007031563,1001041563,1007041563]','[]','[]','[{0,1007041663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101608,'护腕','16阶神装护腕【重炮手】',2,'[{lv,700}]',3,'[{0,38280620,2}]','[1002011563,1004011563,1006011563,1008011563,1010011563,1002021563,1004021563,1006021563,1008021563,1010021563,1002031563,1004031563,1006031563,1008031563,1010031563,1002041563,1004041563,1006041563,1008041563,1010041563]','[]','[]','[{0,1008041663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101609,'戒指','16阶神装戒指【通用】',2,'[{lv,700}]',3,'[{0,38280620,2}]','[1005001563,1009001563,1005001563,1009001563,1005001563,1009001563,1005001563,1009001563]','[]','[]','[{0,1009001663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(34101610,'鞋子','16阶神装鞋子【重炮手】',2,'[{lv,700}]',3,'[{0,38280620,2}]','[1002011563,1004011563,1006011563,1008011563,1010011563,1002021563,1004021563,1006021563,1008021563,1010021563,1002031563,1004031563,1006031563,1008031563,1010031563,1002041563,1004041563,1006041563,1008041563,1010041563]','[]','[]','[{0,1010041663,1}]',2,'[{1,0},{2,100}]',3,1,'[{0,38280620,2}]',150),(41101002,'头盔套装石','普通套装石头盔【魔剑士】',1,'[{lv,240}]',1,'[{0,38270011,10}]','[]','[]','[]','[{0,38230102,1}]',1,'100',3,0,'[]',150),(41101004,'衣服套装石','普通套装石衣服【魔剑士】',1,'[{lv,240}]',1,'[{0,38270011,10}]','[]','[]','[]','[{0,38230104,1}]',1,'100',3,0,'[]',150),(41101006,'裤子套装石','普通套装石裤子【魔剑士】',1,'[{lv,240}]',1,'[{0,38270011,10}]','[]','[]','[]','[{0,38230106,1}]',1,'100',3,0,'[]',150),(41101008,'护腕套装石','普通套装石护腕【魔剑士】',1,'[{lv,240}]',1,'[{0,38270011,10}]','[]','[]','[]','[{0,38230108,1}]',1,'100',3,0,'[]',150),(41101010,'鞋子套装石','普通套装石鞋子【魔剑士】',1,'[{lv,240}]',1,'[{0,38270011,10}]','[]','[]','[]','[{0,38230110,1}]',1,'100',3,0,'[]',150),(41102001,'武器套装石','普通套装石武器【魔剑士】',1,'[{lv,240}]',1,'[{0,38270012,10}]','[]','[]','[]','[{0,38230101,1}]',1,'100',3,0,'[]',150),(41102003,'项链套装石','普通套装石项链【全职业】',1,'[{lv,240}]',1,'[{0,38270013,10}]','[]','[]','[]','[{0,38230003,1}]',1,'100',3,0,'[]',150),(41102005,'刻痕套装石','普通套装石刻痕【全职业】',1,'[{lv,240}]',1,'[{0,38270013,10}]','[]','[]','[]','[{0,38230005,1}]',1,'100',3,0,'[]',150),(41102007,'副手套装石','普通套装石副手【魔剑士】',1,'[{lv,240}]',1,'[{0,38270012,10}]','[]','[]','[]','[{0,38230107,1}]',1,'100',3,0,'[]',150),(41102009,'戒指套装石','普通套装石戒指【全职业】',1,'[{lv,240}]',1,'[{0,38270013,10}]','[]','[]','[]','[{0,38230009,1}]',1,'100',3,0,'[]',150),(41201002,'头盔套装石','完美套装石头盔【全职业】',1,'[{lv,240}]',1,'[{0,38270021,10}]','[]','[]','[]','[{0,38240002,1}]',1,'100',3,0,'[]',150),(41201004,'衣服套装石','完美套装石衣服【全职业】',1,'[{lv,240}]',1,'[{0,38270021,10}]','[]','[]','[]','[{0,38240004,1}]',1,'100',3,0,'[]',150),(41201006,'裤子套装石','完美套装石裤子【全职业】',1,'[{lv,240}]',1,'[{0,38270021,10}]','[]','[]','[]','[{0,38240006,1}]',1,'100',3,0,'[]',150),(41201008,'护腕套装石','完美套装石护腕【全职业】',1,'[{lv,240}]',1,'[{0,38270021,10}]','[]','[]','[]','[{0,38240008,1}]',1,'100',3,0,'[]',150),(41201010,'鞋子套装石','完美套装石鞋子【全职业】',1,'[{lv,240}]',1,'[{0,38270021,10}]','[]','[]','[]','[{0,38240010,1}]',1,'100',3,0,'[]',150),(41202001,'武器套装石','完美套装石武器【全职业】',1,'[{lv,240}]',1,'[{0,38270022,10}]','[]','[]','[]','[{0,38240001,1}]',1,'100',3,0,'[]',150),(41202003,'项链套装石','完美套装石项链【全职业】',1,'[{lv,240}]',1,'[{0,38270023,10}]','[]','[]','[]','[{0,38240003,1}]',1,'100',3,0,'[]',150),(41202005,'刻痕套装石','完美套装石刻痕【全职业】',1,'[{lv,240}]',1,'[{0,38270023,10}]','[]','[]','[]','[{0,38240005,1}]',1,'100',3,0,'[]',150),(41202007,'副手套装石','完美套装石副手【全职业】',1,'[{lv,240}]',1,'[{0,38270022,10}]','[]','[]','[]','[{0,38240007,1}]',1,'100',3,0,'[]',150),(41202009,'戒指套装石','完美套装石戒指【全职业】',1,'[{lv,240}]',1,'[{0,38270023,10}]','[]','[]','[]','[{0,38240009,1}]',1,'100',3,0,'[]',150),(42101002,'头盔套装石','普通套装石头盔【龙骑士】',1,'[{lv,240}]',1,'[{0,38270011,10}]','[]','[]','[]','[{0,38230202,1}]',1,'100',3,0,'[]',150),(42101004,'衣服套装石','普通套装石衣服【龙骑士】',1,'[{lv,240}]',1,'[{0,38270011,10}]','[]','[]','[]','[{0,38230204,1}]',1,'100',3,0,'[]',150),(42101006,'裤子套装石','普通套装石裤子【龙骑士】',1,'[{lv,240}]',1,'[{0,38270011,10}]','[]','[]','[]','[{0,38230206,1}]',1,'100',3,0,'[]',150),(42101008,'护腕套装石','普通套装石护腕【龙骑士】',1,'[{lv,240}]',1,'[{0,38270011,10}]','[]','[]','[]','[{0,38230208,1}]',1,'100',3,0,'[]',150),(42101010,'鞋子套装石','普通套装石鞋子【龙骑士】',1,'[{lv,240}]',1,'[{0,38270011,10}]','[]','[]','[]','[{0,38230210,1}]',1,'100',3,0,'[]',150),(42102001,'武器套装石','普通套装石武器【龙骑士】',1,'[{lv,240}]',1,'[{0,38270012,10}]','[]','[]','[]','[{0,38230201,1}]',1,'100',3,0,'[]',150),(42102003,'项链套装石','普通套装石项链【全职业】',1,'[{lv,240}]',1,'[{0,38270013,10}]','[]','[]','[]','[{0,38230003,1}]',1,'100',3,0,'[]',150),(42102005,'刻痕套装石','普通套装石刻痕【全职业】',1,'[{lv,240}]',1,'[{0,38270013,10}]','[]','[]','[]','[{0,38230005,1}]',1,'100',3,0,'[]',150),(42102007,'副手套装石','普通套装石副手【龙骑士】',1,'[{lv,240}]',1,'[{0,38270012,10}]','[]','[]','[]','[{0,38230207,1}]',1,'100',3,0,'[]',150),(42102009,'戒指套装石','普通套装石戒指【全职业】',1,'[{lv,240}]',1,'[{0,38270013,10}]','[]','[]','[]','[{0,38230009,1}]',1,'100',3,0,'[]',150),(42201002,'头盔套装石','完美套装石头盔【全职业】',1,'[{lv,240}]',1,'[{0,38270021,10}]','[]','[]','[]','[{0,38240002,1}]',1,'100',3,0,'[]',150),(42201004,'衣服套装石','完美套装石衣服【全职业】',1,'[{lv,240}]',1,'[{0,38270021,10}]','[]','[]','[]','[{0,38240004,1}]',1,'100',3,0,'[]',150),(42201006,'裤子套装石','完美套装石裤子【全职业】',1,'[{lv,240}]',1,'[{0,38270021,10}]','[]','[]','[]','[{0,38240006,1}]',1,'100',3,0,'[]',150),(42201008,'护腕套装石','完美套装石护腕【全职业】',1,'[{lv,240}]',1,'[{0,38270021,10}]','[]','[]','[]','[{0,38240008,1}]',1,'100',3,0,'[]',150),(42201010,'鞋子套装石','完美套装石鞋子【全职业】',1,'[{lv,240}]',1,'[{0,38270021,10}]','[]','[]','[]','[{0,38240010,1}]',1,'100',3,0,'[]',150),(42202001,'武器套装石','完美套装石武器【全职业】',1,'[{lv,240}]',1,'[{0,38270022,10}]','[]','[]','[]','[{0,38240001,1}]',1,'100',3,0,'[]',150),(42202003,'项链套装石','完美套装石项链【全职业】',1,'[{lv,240}]',1,'[{0,38270023,10}]','[]','[]','[]','[{0,38240003,1}]',1,'100',3,0,'[]',150),(42202005,'刻痕套装石','完美套装石刻痕【全职业】',1,'[{lv,240}]',1,'[{0,38270023,10}]','[]','[]','[]','[{0,38240005,1}]',1,'100',3,0,'[]',150),(42202007,'副手套装石','完美套装石副手【全职业】',1,'[{lv,240}]',1,'[{0,38270022,10}]','[]','[]','[]','[{0,38240007,1}]',1,'100',3,0,'[]',150),(42202009,'戒指套装石','完美套装石戒指【全职业】',1,'[{lv,240}]',1,'[{0,38270023,10}]','[]','[]','[]','[{0,38240009,1}]',1,'100',3,0,'[]',150),(43101002,'头盔套装石','普通套装石头盔【魔导师】',1,'[{lv,240}]',1,'[{0,38270011,10}]','[]','[]','[]','[{0,38230302,1}]',1,'100',3,0,'[]',150),(43101004,'衣服套装石','普通套装石衣服【魔导师】',1,'[{lv,240}]',1,'[{0,38270011,10}]','[]','[]','[]','[{0,38230304,1}]',1,'100',3,0,'[]',150),(43101006,'裤子套装石','普通套装石裤子【魔导师】',1,'[{lv,240}]',1,'[{0,38270011,10}]','[]','[]','[]','[{0,38230306,1}]',1,'100',3,0,'[]',150),(43101008,'护腕套装石','普通套装石护腕【魔导师】',1,'[{lv,240}]',1,'[{0,38270011,10}]','[]','[]','[]','[{0,38230308,1}]',1,'100',3,0,'[]',150),(43101010,'鞋子套装石','普通套装石鞋子【魔导师】',1,'[{lv,240}]',1,'[{0,38270011,10}]','[]','[]','[]','[{0,38230310,1}]',1,'100',3,0,'[]',150),(43102001,'武器套装石','普通套装石武器【魔导师】',1,'[{lv,240}]',1,'[{0,38270012,10}]','[]','[]','[]','[{0,38230301,1}]',1,'100',3,0,'[]',150),(43102003,'项链套装石','普通套装石项链【全职业】',1,'[{lv,240}]',1,'[{0,38270013,10}]','[]','[]','[]','[{0,38230003,1}]',1,'100',3,0,'[]',150),(43102005,'刻痕套装石','普通套装石刻痕【全职业】',1,'[{lv,240}]',1,'[{0,38270013,10}]','[]','[]','[]','[{0,38230005,1}]',1,'100',3,0,'[]',150),(43102007,'副手套装石','普通套装石副手【魔导师】',1,'[{lv,240}]',1,'[{0,38270012,10}]','[]','[]','[]','[{0,38230307,1}]',1,'100',3,0,'[]',150),(43102009,'戒指套装石','普通套装石戒指【全职业】',1,'[{lv,240}]',1,'[{0,38270013,10}]','[]','[]','[]','[{0,38230009,1}]',1,'100',3,0,'[]',150),(43201002,'头盔套装石','完美套装石头盔【全职业】',1,'[{lv,240}]',1,'[{0,38270021,10}]','[]','[]','[]','[{0,38240002,1}]',1,'100',3,0,'[]',150),(43201004,'衣服套装石','完美套装石衣服【全职业】',1,'[{lv,240}]',1,'[{0,38270021,10}]','[]','[]','[]','[{0,38240004,1}]',1,'100',3,0,'[]',150),(43201006,'裤子套装石','完美套装石裤子【全职业】',1,'[{lv,240}]',1,'[{0,38270021,10}]','[]','[]','[]','[{0,38240006,1}]',1,'100',3,0,'[]',150),(43201008,'护腕套装石','完美套装石护腕【全职业】',1,'[{lv,240}]',1,'[{0,38270021,10}]','[]','[]','[]','[{0,38240008,1}]',1,'100',3,0,'[]',150),(43201010,'鞋子套装石','完美套装石鞋子【全职业】',1,'[{lv,240}]',1,'[{0,38270021,10}]','[]','[]','[]','[{0,38240010,1}]',1,'100',3,0,'[]',150),(43202001,'武器套装石','完美套装石武器【全职业】',1,'[{lv,240}]',1,'[{0,38270022,10}]','[]','[]','[]','[{0,38240001,1}]',1,'100',3,0,'[]',150),(43202003,'项链套装石','完美套装石项链【全职业】',1,'[{lv,240}]',1,'[{0,38270023,10}]','[]','[]','[]','[{0,38240003,1}]',1,'100',3,0,'[]',150),(43202005,'刻痕套装石','完美套装石刻痕【全职业】',1,'[{lv,240}]',1,'[{0,38270023,10}]','[]','[]','[]','[{0,38240005,1}]',1,'100',3,0,'[]',150),(43202007,'副手套装石','完美套装石副手【全职业】',1,'[{lv,240}]',1,'[{0,38270022,10}]','[]','[]','[]','[{0,38240007,1}]',1,'100',3,0,'[]',150),(43202009,'戒指套装石','完美套装石戒指【全职业】',1,'[{lv,240}]',1,'[{0,38270023,10}]','[]','[]','[]','[{0,38240009,1}]',1,'100',3,0,'[]',150),(44101002,'头盔套装石','普通套装石头盔【重炮手】',1,'[{lv,240}]',1,'[{0,38270011,10}]','[]','[]','[]','[{0,38230402,1}]',1,'100',3,0,'[]',150),(44101004,'衣服套装石','普通套装石衣服【重炮手】',1,'[{lv,240}]',1,'[{0,38270011,10}]','[]','[]','[]','[{0,38230404,1}]',1,'100',3,0,'[]',150),(44101006,'裤子套装石','普通套装石裤子【重炮手】',1,'[{lv,240}]',1,'[{0,38270011,10}]','[]','[]','[]','[{0,38230406,1}]',1,'100',3,0,'[]',150),(44101008,'护腕套装石','普通套装石护腕【重炮手】',1,'[{lv,240}]',1,'[{0,38270011,10}]','[]','[]','[]','[{0,38230408,1}]',1,'100',3,0,'[]',150),(44101010,'鞋子套装石','普通套装石鞋子【重炮手】',1,'[{lv,240}]',1,'[{0,38270011,10}]','[]','[]','[]','[{0,38230410,1}]',1,'100',3,0,'[]',150),(44102001,'武器套装石','普通套装石武器【重炮手】',1,'[{lv,240}]',1,'[{0,38270012,10}]','[]','[]','[]','[{0,38230401,1}]',1,'100',3,0,'[]',150),(44102003,'项链套装石','普通套装石项链【全职业】',1,'[{lv,240}]',1,'[{0,38270013,10}]','[]','[]','[]','[{0,38230003,1}]',1,'100',3,0,'[]',150),(44102005,'刻痕套装石','普通套装石刻痕【全职业】',1,'[{lv,240}]',1,'[{0,38270013,10}]','[]','[]','[]','[{0,38230005,1}]',1,'100',3,0,'[]',150),(44102007,'副手套装石','普通套装石副手【重炮手】',1,'[{lv,240}]',1,'[{0,38270012,10}]','[]','[]','[]','[{0,38230407,1}]',1,'100',3,0,'[]',150),(44102009,'戒指套装石','普通套装石戒指【全职业】',1,'[{lv,240}]',1,'[{0,38270013,10}]','[]','[]','[]','[{0,38230009,1}]',1,'100',3,0,'[]',150),(44201002,'头盔套装石','完美套装石头盔【全职业】',1,'[{lv,240}]',1,'[{0,38270021,10}]','[]','[]','[]','[{0,38240002,1}]',1,'100',3,0,'[]',150),(44201004,'衣服套装石','完美套装石衣服【全职业】',1,'[{lv,240}]',1,'[{0,38270021,10}]','[]','[]','[]','[{0,38240004,1}]',1,'100',3,0,'[]',150),(44201006,'裤子套装石','完美套装石裤子【全职业】',1,'[{lv,240}]',1,'[{0,38270021,10}]','[]','[]','[]','[{0,38240006,1}]',1,'100',3,0,'[]',150),(44201008,'护腕套装石','完美套装石护腕【全职业】',1,'[{lv,240}]',1,'[{0,38270021,10}]','[]','[]','[]','[{0,38240008,1}]',1,'100',3,0,'[]',150),(44201010,'鞋子套装石','完美套装石鞋子【全职业】',1,'[{lv,240}]',1,'[{0,38270021,10}]','[]','[]','[]','[{0,38240010,1}]',1,'100',3,0,'[]',150),(44202001,'武器套装石','完美套装石武器【全职业】',1,'[{lv,240}]',1,'[{0,38270022,10}]','[]','[]','[]','[{0,38240001,1}]',1,'100',3,0,'[]',150),(44202003,'项链套装石','完美套装石项链【全职业】',1,'[{lv,240}]',1,'[{0,38270023,10}]','[]','[]','[]','[{0,38240003,1}]',1,'100',3,0,'[]',150),(44202005,'刻痕套装石','完美套装石刻痕【全职业】',1,'[{lv,240}]',1,'[{0,38270023,10}]','[]','[]','[]','[{0,38240005,1}]',1,'100',3,0,'[]',150),(44202007,'副手套装石','完美套装石副手【全职业】',1,'[{lv,240}]',1,'[{0,38270022,10}]','[]','[]','[]','[{0,38240007,1}]',1,'100',3,0,'[]',150),(44202009,'戒指套装石','完美套装石戒指【全职业】',1,'[{lv,240}]',1,'[{0,38270023,10}]','[]','[]','[]','[{0,38240009,1}]',1,'100',3,0,'[]',150),(51000002,'中级神源之火','降神升级材料2',1,'[{lv,25}]',1,'[{0,11020001,2}]','[]','[]','[]','[{0,11020002,1}]',1,'100',3,0,'[]',150),(51000003,'高级神源之火','降神升级材料3',1,'[{lv,25}]',1,'[{0,11020002,2}]','[]','[]','[]','[{0,11020003,1}]',1,'100',3,0,'[]',150),(52000002,'中级坐骑树果','坐骑升级材料2',1,'[{lv,30}]',1,'[{0,16020001,3}]','[]','[]','[]','[{0,16020002,1}]',1,'100',3,0,'[]',150),(52000003,'高级坐骑树果','坐骑升级材料3',1,'[{lv,30}]',1,'[{0,16020002,3}]','[]','[]','[]','[{0,16020003,1}]',1,'100',3,0,'[]',150),(53000002,'精品神格','神格晋升材料2',1,'[{lv,120}]',1,'[{0,17010001,10}]','[]','[]','[]','[{0,17010002,1}]',1,'100',3,0,'[]',150),(53000003,'完美神格','神格晋升材料3',1,'[{lv,120}]',1,'[{0,17010002,10}]','[]','[]','[]','[{0,17010003,1}]',1,'100',3,0,'[]',150),(54000002,'中级星辰之砂','星灵升级材料2',1,'[{lv,80}]',1,'[{0,18020001,3}]','[]','[]','[]','[{0,18020002,1}]',1,'100',3,0,'[]',150),(54000003,'高级星辰之砂','星灵升级材料3',1,'[{lv,80}]',1,'[{0,18020002,3}]','[]','[]','[]','[{0,18020003,1}]',1,'100',3,0,'[]',150),(55000002,'中级宝具强化石','宝具升级材料2',1,'[{lv,90}]',1,'[{0,24010001,3}]','[]','[]','[]','[{0,24010002,1}]',1,'100',3,0,'[]',150),(55000003,'高级宝具强化石','宝具升级材料3',1,'[{lv,90}]',1,'[{0,24010002,3}]','[]','[]','[]','[{0,24010003,1}]',1,'100',3,0,'[]',150),(56000011,'粉装防具石','粉装防具石',1,'[{lv,300}]',1,'[{0,38280511,10}]','[]','[]','[]','[{0,38280510,1}]',1,'100',3,0,'[]',150),(56000012,'粉装武饰石','粉装武饰石',1,'[{lv,300}]',1,'[{0,38280521,10}]','[]','[]','[]','[{0,38280520,1}]',1,'100',3,0,'[]',150),(56000021,'神装武饰石','神装武饰石',1,'[{lv,300}]',1,'[{0,38280621,10}]','[]','[]','[]','[{0,38280620,1}]',1,'100',3,0,'[]',150),(57000001,'轻盈之羽','1代翅膀材料',1,'[{lv,180}]',1,'[{0,20041001,100}]','[]','[]','[]','[{0,20040001,1}]',1,'100',3,0,'[]',150),(57000002,'迅疾之羽','2代翅膀材料',1,'[{lv,180}]',1,'[{0,20041002,100}]','[]','[]','[]','[{0,20040002,1}]',1,'100',3,0,'[]',150),(57000003,'风驰之羽','3代翅膀材料',1,'[{lv,180}]',1,'[{0,20041003,100}]','[]','[]','[]','[{0,20040003,1}]',1,'100',3,0,'[]',150),(57000004,'飞掠之羽','4代翅膀材料',1,'[{lv,500}]',1,'[{0,20041004,100}]','[]','[]','[]','[{0,20040004,1}]',1,'100',3,0,'[]',150),(57000005,'疾闪之羽','5代翅膀材料',1,'[{lv,600}]',1,'[{0,20041005,100}]','[]','[]','[]','[{0,20040005,1}]',1,'100',3,0,'[]',150),(57000006,'翔天之羽','6代翅膀材料',1,'[{lv,700}]',1,'[{0,20041006,100}]','[]','[]','[]','[{0,20040006,1}]',1,'100',3,0,'[]',150),(57010001,'催化神石','翅膀高阶材料',1,'[{lv,180}]',1,'[{0,20041000,100}]','[]','[]','[]','[{0,20040000,1}]',1,'100',3,0,'[]',150),(58000001,'小宇宙星核','小宇宙升级材料',1,'[{lv,50}]',1,'[{0,18030002,10}]','[]','[]','[]','[{0,18030001,1}]',1,'100',3,1,'[]',150),(59000001,'经验副本门票','经验副本门票',1,'[{lv,75}]',1,'[{0,38030006,1},{0,38030007,1}]','[]','[]','[]','[{0,38030001,1}]',1,'100',3,0,'[]',150),(59000002,'混乱魔域门票','混乱魔域门票',1,'[{lv,400}]',1,'[{0,38030004,1},{0,38030005,1}]','[]','[]','[]','[{0,38030003,1}]',1,'100',3,0,'[]',150),(59000003,'9朵鲜花','合成9朵鲜花',1,'[{lv,75}]',1,'[{0,38100001,9}]','[]','[]','[]','[{0,38100009,1}]',1,'100',3,0,'[]',150),(59000004,'99朵鲜花','合成99朵鲜花',1,'[{lv,75}]',1,'[{0,38100009,11}]','[]','[]','[]','[{0,38100010,1}]',1,'100',3,0,'[]',150),(59000005,'蓝色护送卡','蓝色护送卡',1,'[{lv,75}]',1,'[{0,38330001,3}]','[]','[]','[]','[{0,38330002,1}]',1,'100',3,0,'[]',150),(59000006,'紫色护送卡','紫色护送卡',1,'[{lv,75}]',1,'[{0,38330002,3}]','[]','[]','[]','[{0,38330003,1}]',1,'100',3,0,'[]',150),(59000007,'橙色护送卡','橙色护送卡',1,'[{lv,75}]',1,'[{0,38330003,3}]','[]','[]','[]','[{0,38330004,1}]',1,'100',3,0,'[]',150),(59000008,'辉耀馆主','辉耀馆主',1,'[{lv,550}]',1,'[{0,1011000001,1},{0,38040005,1}]','[]','[]','[]','[{0,1011000003,1}]',1,'100',3,0,'[]',150),(59000009,'神圣天使','神圣天使',1,'[{lv,550}]',1,'[{0,1011000002,1},{0,38040006,1}]','[]','[]','[]','[{0,1011000004,1}]',1,'100',3,0,'[]',150),(59100001,'中级学习书','宝宝升级',1,'[{lv,315}]',1,'[{0,54010001,3}]','[]','[]','[]','[{0,54010002,1}]',1,'100',3,0,'[]',150),(59100002,'高级学习书','宝宝升级',1,'[{lv,315}]',1,'[{0,54010002,3}]','[]','[]','[]','[{0,54010003,1}]',1,'100',3,0,'[]',150),(59100003,'中级祝福糖','宝宝升级',1,'[{lv,315}]',1,'[{0,54040001,3}]','[]','[]','[]','[{0,54040002,1}]',1,'100',3,0,'[]',150),(59100004,'高级祝福糖','宝宝升级',1,'[{lv,315}]',1,'[{0,54040002,3}]','[]','[]','[]','[{0,54040003,1}]',1,'100',3,0,'[]',150),(60001002,'雷霆2级','雷霆2级',1,'[{lv,120}]',1,'[{0,17030101,2},{0,17040001,5}]','[]','[]','[]','[{0,17030102,1}]',1,'100',3,0,'[]',150),(60001003,'雷霆3级','雷霆3级',1,'[{lv,120}]',1,'[{0,17030102,2},{0,17040002,2}]','[]','[]','[]','[{0,17030103,1}]',1,'100',3,0,'[]',150),(60001004,'雷霆4级','雷霆4级',1,'[{lv,120}]',1,'[{0,17030103,2},{0,17040002,4}]','[]','[]','[]','[{0,17030104,1}]',1,'100',3,0,'[]',150),(60001005,'雷霆5级','雷霆5级',1,'[{lv,120}]',1,'[{0,17030104,2},{0,17040002,6}]','[]','[]','[]','[{0,17030105,1}]',1,'100',3,0,'[]',150),(60002002,'生命2级','生命2级',1,'[{lv,120}]',1,'[{0,17030201,2},{0,17040001,5}]','[]','[]','[]','[{0,17030202,1}]',1,'100',3,0,'[]',150),(60002003,'生命3级','生命3级',1,'[{lv,120}]',1,'[{0,17030202,2},{0,17040002,2}]','[]','[]','[]','[{0,17030203,1}]',1,'100',3,0,'[]',150),(60002004,'生命4级','生命4级',1,'[{lv,120}]',1,'[{0,17030203,2},{0,17040002,4}]','[]','[]','[]','[{0,17030204,1}]',1,'100',3,0,'[]',150),(60002005,'生命5级','生命5级',1,'[{lv,120}]',1,'[{0,17030204,2},{0,17040002,6}]','[]','[]','[]','[{0,17030205,1}]',1,'100',3,0,'[]',150),(60003002,'光明2级','光明2级',1,'[{lv,120}]',1,'[{0,17030301,2},{0,17040001,5}]','[]','[]','[]','[{0,17030302,1}]',1,'100',3,0,'[]',150),(60003003,'光明3级','光明3级',1,'[{lv,120}]',1,'[{0,17030302,2},{0,17040002,2}]','[]','[]','[]','[{0,17030303,1}]',1,'100',3,0,'[]',150),(60003004,'光明4级','光明4级',1,'[{lv,120}]',1,'[{0,17030303,2},{0,17040002,4}]','[]','[]','[]','[{0,17030304,1}]',1,'100',3,0,'[]',150),(60003005,'光明5级','光明5级',1,'[{lv,120}]',1,'[{0,17030304,2},{0,17040002,6}]','[]','[]','[]','[{0,17030305,1}]',1,'100',3,0,'[]',150),(60004002,'大地2级','大地2级',1,'[{lv,120}]',1,'[{0,17030401,2},{0,17040001,5}]','[]','[]','[]','[{0,17030402,1}]',1,'100',3,0,'[]',150),(60004003,'大地3级','大地3级',1,'[{lv,120}]',1,'[{0,17030402,2},{0,17040002,2}]','[]','[]','[]','[{0,17030403,1}]',1,'100',3,0,'[]',150),(60004004,'大地4级','大地4级',1,'[{lv,120}]',1,'[{0,17030403,2},{0,17040002,4}]','[]','[]','[]','[{0,17030404,1}]',1,'100',3,0,'[]',150),(60004005,'大地5级','大地5级',1,'[{lv,120}]',1,'[{0,17030404,2},{0,17040002,6}]','[]','[]','[]','[{0,17030405,1}]',1,'100',3,0,'[]',150),(71000001,'破甲命中魂珠','经验加成&闪避魂珠',1,'[{stone_dungeon, 40}]',4,'[{0,5204001,400}]','[]','[{[5201143]},{[5201063]}]','[]','[{0,5206363,1}]',1,'100',1,0,'[]',181),(71000002,'攻击命中魂珠','装备生命&生命魂珠',1,'[{stone_dungeon, 45}]',4,'[{0,5204001,600}]','[]','[{[5201173]},{[5201023]}]','[]','[{0,5206323,1}]',1,'100',1,0,'[]',181),(71000003,'攻击破甲魂珠','武器攻击&攻击魂珠',1,'[{stone_dungeon, 50}]',4,'[{0,5204001,800}]','[]','[{[5201153]},{[5201013]}]','[]','[{0,5206313,1}]',1,'100',1,0,'[]',181),(71000004,'攻击固伤魂珠','装备防御&防御魂珠',1,'[{stone_dungeon, 55}]',4,'[{0,5204001,1000}]','[]','[{[5201183]},{[5201043]}]','[]','[{0,5206343,1}]',1,'100',1,0,'[]',181),(71000005,'攻击暴击魂珠','武器破甲&破甲魂珠',1,'[{stone_dungeon, 60}]',4,'[{0,5204001,1200}]','[]','[{[5201163]},{[5201033]}]','[]','[{0,5206333,1}]',1,'100',1,0,'[]',181),(71000006,'破甲暴击魂珠','固定攻击&暴击魂珠',1,'[{stone_dungeon, 65}]',4,'[{0,5204001,1400}]','[]','[{[5201093]},{[5201073]}]','[]','[{0,5206373,1}]',1,'100',1,0,'[]',181),(71000007,'攻击暴伤魂珠','饰品攻击&命中魂珠',1,'[{stone_dungeon, 70}]',4,'[{0,5204001,1500}]','[]','[{[5201053]},{[5201193]}]','[]','[{0,5206353,1}]',1,'100',1,0,'[]',181),(71000008,'破甲固伤魂珠','固定防御&韧性魂珠',1,'[{stone_dungeon, 75}]',4,'[{0,5204001,1600}]','[]','[{[5201103]},{[5201083]}]','[]','[{0,5206383,1}]',1,'100',1,0,'[]',181),(72000001,'破甲命中魂珠','经验加成&闪避魂珠',1,'[{stone_dungeon, 40}]',4,'[{0,5204001,1200}]','[]','[{[5201144]},{[5201064]}]','[]','[{0,5206364,1}]',1,'100',1,0,'[]',181),(72000002,'攻击命中魂珠','装备生命&生命魂珠',1,'[{stone_dungeon, 45}]',4,'[{0,5204001,1800}]','[]','[{[5201174]},{[5201024]}]','[]','[{0,5206324,1}]',1,'100',1,0,'[]',181),(72000003,'攻击破甲魂珠','武器攻击&攻击魂珠',1,'[{stone_dungeon, 50}]',4,'[{0,5204001,2400}]','[]','[{[5201154]},{[5201014]}]','[]','[{0,5206314,1}]',1,'100',1,0,'[]',181),(72000004,'攻击固伤魂珠','装备防御&防御魂珠',1,'[{stone_dungeon, 55}]',4,'[{0,5204001,3000}]','[]','[{[5201184]},{[5201044]}]','[]','[{0,5206344,1}]',1,'100',1,0,'[]',181),(72000005,'攻击暴击魂珠','武器破甲&破甲魂珠',1,'[{stone_dungeon, 60}]',4,'[{0,5204001,3600}]','[]','[{[5201164]},{[5201034]}]','[]','[{0,5206334,1}]',1,'100',1,0,'[]',181),(72000006,'破甲暴击魂珠','固定攻击&暴击魂珠',1,'[{stone_dungeon, 65}]',4,'[{0,5204001,4200}]','[]','[{[5201094]},{[5201074]}]','[]','[{0,5206374,1}]',1,'100',1,0,'[]',181),(72000007,'攻击暴伤魂珠','饰品攻击&命中魂珠',1,'[{stone_dungeon, 70}]',4,'[{0,5204001,4500}]','[]','[{[5201054]},{[5201194]}]','[]','[{0,5206354,1}]',1,'100',1,0,'[]',181),(72000008,'破甲固伤魂珠','固定防御&韧性魂珠',1,'[{stone_dungeon, 75}]',4,'[{0,5204001,4800}]','[]','[{[5201104]},{[5201084]}]','[]','[{0,5206384,1}]',1,'100',1,0,'[]',181);
/*!40000 ALTER TABLE `base_goods_compose` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_goods_compose_index`
--

DROP TABLE IF EXISTS `base_goods_compose_index`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_goods_compose_index` (
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型id',
  `type` tinyint(1) NOT NULL DEFAULT '0' COMMENT '跳转类型',
  `open_condition` varchar(255) NOT NULL DEFAULT '[]' COMMENT '条件',
  `menu_id` varchar(255) NOT NULL DEFAULT '[]' COMMENT '菜单id',
  `target_id` varchar(255) NOT NULL DEFAULT '[]' COMMENT '目标id',
  PRIMARY KEY (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品合成索引';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_goods_compose_index`
--

LOCK TABLES `base_goods_compose_index` WRITE;
/*!40000 ALTER TABLE `base_goods_compose_index` DISABLE KEYS */;
INSERT INTO `base_goods_compose_index` VALUES (11020001,2,'[]','[50000000]','[51000002]'),(11020002,2,'[]','[50000000]','[51000002]'),(11020003,2,'[]','[50000000]','[51000003]'),(11050001,2,'[]','[20000000]','[24000001]'),(11050002,2,'[]','[20000000]','[24000002]'),(11050003,2,'[]','[20000000]','[24000003]'),(11050004,2,'[]','[20000000]','[24000004]'),(11050005,2,'[]','[20000000]','[24000005]'),(11060001,2,'[]','[20000000]','[25000001]'),(11060002,2,'[]','[20000000]','[25000002]'),(11060003,2,'[]','[20000000]','[25000005]'),(11060004,2,'[]','[20000000]','[25000003]'),(11060005,2,'[]','[20000000]','[25000004]'),(14010101,2,'[]','[10000000]','[11000002]'),(14010102,2,'[]','[10000000]','[11000003]'),(14010103,2,'[]','[10000000]','[11000004]'),(14010104,2,'[]','[10000000]','[11000005]'),(14010105,2,'[]','[10000000]','[11000006]'),(14010106,2,'[]','[10000000]','[11000007]'),(14010107,2,'[]','[10000000]','[11000008]'),(14010108,2,'[]','[10000000]','[11000009]'),(14010109,2,'[]','[10000000]','[19000001]'),(14010301,2,'[]','[10000000]','[13000002]'),(14010302,2,'[]','[10000000]','[13000003]'),(14010303,2,'[]','[10000000]','[13000004]'),(14010304,2,'[]','[10000000]','[13000005]'),(14010305,2,'[]','[10000000]','[13000006]'),(14010306,2,'[]','[10000000]','[13000007]'),(14010307,2,'[]','[10000000]','[13000008]'),(14010308,2,'[]','[10000000]','[13000009]'),(14010309,2,'[]','[10000000]','[19000003]'),(14010501,2,'[]','[10000000]','[15000002]'),(14010502,2,'[]','[10000000]','[15000003]'),(14010503,2,'[]','[10000000]','[15000004]'),(14010504,2,'[]','[10000000]','[15000005]'),(14010505,2,'[]','[10000000]','[15000006]'),(14010506,2,'[]','[10000000]','[15000007]'),(14010507,2,'[]','[10000000]','[15000008]'),(14010508,2,'[]','[10000000]','[15000009]'),(14010509,2,'[]','[10000000]','[19000005]'),(14010701,2,'[]','[10000000]','[17000002]'),(14010702,2,'[]','[10000000]','[17000003]'),(14010703,2,'[]','[10000000]','[17000004]'),(14010704,2,'[]','[10000000]','[17000005]'),(14010705,2,'[]','[10000000]','[17000006]'),(14010706,2,'[]','[10000000]','[17000007]'),(14010707,2,'[]','[10000000]','[17000008]'),(14010708,2,'[]','[10000000]','[17000009]'),(14010709,2,'[]','[10000000]','[19000007]'),(14020201,2,'[]','[10000000]','[12000002]'),(14020202,2,'[]','[10000000]','[12000003]'),(14020203,2,'[]','[10000000]','[12000004]'),(14020204,2,'[]','[10000000]','[12000005]'),(14020205,2,'[]','[10000000]','[12000006]'),(14020206,2,'[]','[10000000]','[12000007]'),(14020207,2,'[]','[10000000]','[12000008]'),(14020208,2,'[]','[10000000]','[12000009]'),(14020209,2,'[]','[10000000]','[19000002]'),(14020401,2,'[]','[10000000]','[14000002]'),(14020402,2,'[]','[10000000]','[14000003]'),(14020403,2,'[]','[10000000]','[14000004]'),(14020404,2,'[]','[10000000]','[14000005]'),(14020405,2,'[]','[10000000]','[14000006]'),(14020406,2,'[]','[10000000]','[14000007]'),(14020407,2,'[]','[10000000]','[14000008]'),(14020408,2,'[]','[10000000]','[14000009]'),(14020409,2,'[]','[10000000]','[19000004]'),(14020601,2,'[]','[10000000]','[16000002]'),(14020602,2,'[]','[10000000]','[16000003]'),(14020603,2,'[]','[10000000]','[16000004]'),(14020604,2,'[]','[10000000]','[16000005]'),(14020605,2,'[]','[10000000]','[16000006]'),(14020606,2,'[]','[10000000]','[16000007]'),(14020607,2,'[]','[10000000]','[16000008]'),(14020608,2,'[]','[10000000]','[16000009]'),(14020609,2,'[]','[10000000]','[19000006]'),(14020801,2,'[]','[10000000]','[18000002]'),(14020802,2,'[]','[10000000]','[18000003]'),(14020803,2,'[]','[10000000]','[18000004]'),(14020804,2,'[]','[10000000]','[18000005]'),(14020805,2,'[]','[10000000]','[18000006]'),(14020806,2,'[]','[10000000]','[18000007]'),(14020807,2,'[]','[10000000]','[18000008]'),(14020808,2,'[]','[10000000]','[18000009]'),(14020809,2,'[]','[10000000]','[19000008]'),(14100013,2,'[]','[10000000]','[19000001]'),(14100015,2,'[]','[10000000]','[19000009]'),(14100024,2,'[]','[10000000]','[19000002]'),(14100026,2,'[]','[10000000]','[19000010]'),(14100035,2,'[]','[10000000]','[19000003]'),(14100037,2,'[]','[10000000]','[19000011]'),(14100046,2,'[]','[10000000]','[19000004]'),(14100048,2,'[]','[10000000]','[19000012]'),(14100057,2,'[]','[10000000]','[19000005]'),(14100068,2,'[]','[10000000]','[19000006]'),(14100071,2,'[]','[10000000]','[19000007]'),(14100082,2,'[]','[10000000]','[19000008]'),(16020001,2,'[]','[50000000]','[52000002]'),(16020002,2,'[]','[50000000]','[52000002]'),(16020003,2,'[]','[50000000]','[52000003]'),(16090001,2,'[]','[20000000]','[23000001]'),(16090002,2,'[]','[20000000]','[23000002]'),(16090003,2,'[]','[20000000]','[23000003]'),(16090004,2,'[]','[20000000]','[23000004]'),(16090005,2,'[]','[20000000]','[23000005]'),(16090006,2,'[]','[20000000]','[23000006]'),(16090007,2,'[]','[20000000]','[23000007]'),(16090008,2,'[]','[20000000]','[23000008]'),(16090009,2,'[]','[20000000]','[23000009]'),(16090010,2,'[]','[20000000]','[23000010]'),(17010001,2,'[]','[50000000]','[53000002]'),(17010002,2,'[]','[50000000]','[53000002]'),(17010003,2,'[]','[50000000]','[53000003]'),(18020001,2,'[]','[50000000]','[54000002]'),(18020002,2,'[]','[50000000]','[54000002]'),(18020003,2,'[]','[50000000]','[54000003]'),(18041001,2,'[]','[20000000]','[22000001]'),(18041002,2,'[]','[20000000]','[22000002]'),(18041003,2,'[]','[20000000]','[22000003]'),(18041004,2,'[]','[20000000]','[22000004]'),(18041005,2,'[]','[20000000]','[22000005]'),(18041006,2,'[]','[20000000]','[22000006]'),(18041007,2,'[]','[20000000]','[22000007]'),(18041008,2,'[]','[20000000]','[22002001]'),(18041101,2,'[]','[20000000]','[22001001]'),(18041102,2,'[]','[20000000]','[22001002]'),(18041103,2,'[]','[20000000]','[22001003]'),(18041104,2,'[]','[20000000]','[22001004]'),(18041105,2,'[]','[20000000]','[22001005]'),(20070006,2,'[]','[20000000]','[26000001]'),(20070008,2,'[]','[20000000]','[26000002]'),(20070010,2,'[]','[20000000]','[26000003]'),(20070011,2,'[]','[20000000]','[26000004]'),(20070012,2,'[]','[20000000]','[26000005]'),(20070014,2,'[]','[20000000]','[26000006]'),(20070015,2,'[]','[20000000]','[26000007]'),(20070016,2,'[]','[20000000]','[26000008]'),(20070017,2,'[]','[20000000]','[26000009]'),(20070018,2,'[]','[20000000]','[26000010]'),(24010001,2,'[]','[50000000]','[55000002]'),(24010002,2,'[]','[50000000]','[55000002]'),(24010003,2,'[]','[50000000]','[55000003]'),(24030001,2,'[]','[20000000]','[21000001]'),(24030002,2,'[]','[20000000]','[21000002]'),(24030003,2,'[]','[20000000]','[21000003]'),(24030004,2,'[]','[20000000]','[21000004]'),(24030005,2,'[]','[20000000]','[21000005]'),(24030006,2,'[]','[20000000]','[21000006]'),(24030007,2,'[]','[20000000]','[21000007]'),(24031001,2,'[]','[20000000]','[21000001]'),(24031002,2,'[]','[20000000]','[21000002]'),(24031003,2,'[]','[20000000]','[21000003]'),(24031004,2,'[]','[20000000]','[21000004]'),(24031005,2,'[]','[20000000]','[21000005]'),(24031006,2,'[]','[20000000]','[21000006]'),(24031007,2,'[]','[20000000]','[21000007]'),(38030003,2,'[]','[50000000]','[59000002]'),(38030004,2,'[]','[50000000]','[59000002]'),(38030005,2,'[]','[50000000]','[59000002]'),(38030006,2,'[]','[50000000]','[59000001]'),(38030007,2,'[]','[50000000]','[59000001]'),(38040005,2,'[]','[50000000]','[59000008]'),(38040006,2,'[]','[50000000]','[59000009]'),(38100001,2,'[]','[50000000]','[59000003]'),(38100009,2,'[]','[50000000]','[59000004]'),(38100010,2,'[]','[50000000]','[59000004]'),(38230003,2,'[{career, 0}]','[40000000]','[41102003,42102003,43102003,44102003]'),(38230005,2,'[{career, 0}]','[40000000]','[41102005,42102005,43102005,44102005]'),(38230009,2,'[{career, 0}]','[40000000]','[41102009,42102009,43102009,44102009]'),(38230101,2,'[]','[40000000]','[41102001]'),(38230102,2,'[]','[40000000]','[41101002]'),(38230104,2,'[]','[40000000]','[41101004]'),(38230106,2,'[]','[40000000]','[41101006]'),(38230107,2,'[]','[40000000]','[41102007]'),(38230108,2,'[]','[40000000]','[41101008]'),(38230110,2,'[]','[40000000]','[41101010]'),(38230201,2,'[]','[40000000]','[42102001]'),(38230202,2,'[]','[40000000]','[42101002]'),(38230204,2,'[]','[40000000]','[42101004]'),(38230206,2,'[]','[40000000]','[42101006]'),(38230207,2,'[]','[40000000]','[42102007]'),(38230208,2,'[]','[40000000]','[42101008]'),(38230210,2,'[]','[40000000]','[42101010]'),(38230301,2,'[]','[40000000]','[43102001]'),(38230302,2,'[]','[40000000]','[43101002]'),(38230304,2,'[]','[40000000]','[43101004]'),(38230306,2,'[]','[40000000]','[43101006]'),(38230307,2,'[]','[40000000]','[43102007]'),(38230308,2,'[]','[40000000]','[43101008]'),(38230310,2,'[]','[40000000]','[43101010]'),(38230401,2,'[]','[40000000]','[44102001]'),(38230402,2,'[]','[40000000]','[44101002]'),(38230404,2,'[]','[40000000]','[44101004]'),(38230406,2,'[]','[40000000]','[44101006]'),(38230407,2,'[]','[40000000]','[44102007]'),(38230408,2,'[]','[40000000]','[44101008]'),(38230410,2,'[]','[40000000]','[44101010]'),(38240001,2,'[{career, 0}]','[40000000]','[41202001,42202001,43202001,44202001]'),(38240002,2,'[{career, 0}]','[40000000]','[41201002,42201002,43201002,44201002]'),(38240003,2,'[{career, 0}]','[40000000]','[41202003,42202003,43202003,44202003]'),(38240004,2,'[{career, 0}]','[40000000]','[41201004,42201004,43201004,44201004]'),(38240005,2,'[{career, 0}]','[40000000]','[41202005,42202005,43202005,44202005]'),(38240006,2,'[{career, 0}]','[40000000]','[41201006,42201006,43201006,44201006]'),(38240007,2,'[{career, 0}]','[40000000]','[41202007,42202007,43202007,44202007]'),(38240008,2,'[{career, 0}]','[40000000]','[41201008,42201008,43201008,44201008]'),(38240009,2,'[{career, 0}]','[40000000]','[41202009,42202009,43202009,44202009]'),(38240010,2,'[{career, 0}]','[40000000]','[41201010,42201010,43201010,44201010]'),(38270011,2,'[{career, 0}]','[40000000]','[41101004,42101004,43101004,44101004]'),(38270012,2,'[{career, 0}]','[40000000]','[41102001,42102001,43102001,44102001]'),(38270013,2,'[{career, 0}]','[40000000]','[41102003,42102003,43102003,44102003]'),(38270021,2,'[{career, 0}]','[40000000]','[41201002,42201002,43201002,44201002]'),(38270022,2,'[{career, 0}]','[40000000]','[41202001,42202001,43202001,44202001]'),(38270023,2,'[{career, 0}]','[40000000]','[41202003,42202003,43202003,44202003]'),(38280510,2,'[]','[20000000]','[56000011]'),(38280511,2,'[]','[20000000]','[56000011]'),(38280520,2,'[]','[20000000]','[56000012]'),(38280521,2,'[]','[20000000]','[56000012]'),(38280620,2,'[]','[20000000]','[56000021]'),(38280621,2,'[]','[20000000]','[56000021]'),(38330001,2,'[]','[50000000]','[59000005]'),(38330002,2,'[]','[50000000]','[59000006]'),(38330003,2,'[]','[50000000]','[59000007]'),(38330004,2,'[]','[50000000]','[59000007]'),(53040101,2,'[]','[20000000]','[27000001]'),(53040102,2,'[]','[20000000]','[27000002]'),(53040103,2,'[]','[20000000]','[27000003]'),(53040104,2,'[]','[20000000]','[27000004]'),(53040105,2,'[]','[20000000]','[27000005]'),(53040201,2,'[]','[20000000]','[27000006]'),(53040202,2,'[]','[20000000]','[27000007]'),(53040203,2,'[]','[20000000]','[27000008]'),(53040204,2,'[]','[20000000]','[27000009]'),(53040205,2,'[]','[20000000]','[27000010]'),(53040401,2,'[]','[20000000]','[27000011]'),(53040402,2,'[]','[20000000]','[27000012]'),(53040403,2,'[]','[20000000]','[27000013]'),(53040404,2,'[]','[20000000]','[27000014]'),(53040405,2,'[]','[20000000]','[27000015]'),(1001010332,1,'[]','[31000000]','[31070300]'),(1001010342,1,'[]','[31000000]','[31080300]'),(1001010343,1,'[]','[31000000]','[31090300]'),(1001010363,1,'[]','[31000000]','[31100300]'),(1001010432,1,'[]','[31000000]','[31070400]'),(1001010442,1,'[]','[31000000]','[31080400]'),(1001010443,1,'[]','[31000000]','[31090400]'),(1001010463,1,'[]','[31000000]','[31100400]'),(1001010532,1,'[]','[31000000]','[31070500]'),(1001010542,1,'[]','[31000000]','[31080500]'),(1001010543,1,'[]','[31000000]','[31090500]'),(1001010563,1,'[]','[31000000]','[31100500]'),(1001010632,1,'[]','[31000000]','[31070600]'),(1001010642,1,'[]','[31000000]','[31080600]'),(1001010643,1,'[]','[31000000]','[31090600]'),(1001010663,1,'[]','[31000000]','[31100600]'),(1001010732,1,'[]','[31000000]','[31070700]'),(1001010742,1,'[]','[31000000]','[31080700]'),(1001010743,1,'[]','[31000000]','[31090700]'),(1001010763,1,'[]','[31000000]','[31100700]'),(1001010832,1,'[]','[31000000]','[31070800]'),(1001010842,1,'[]','[31000000]','[31080800]'),(1001010843,1,'[]','[31000000]','[31090800]'),(1001010863,1,'[]','[31000000]','[31100800]'),(1001010932,1,'[]','[31000000]','[31070900]'),(1001010942,1,'[]','[31000000]','[31080900]'),(1001010943,1,'[]','[31000000]','[31090900]'),(1001010963,1,'[]','[31000000]','[31100900]'),(1001011032,1,'[]','[31000000]','[31071000]'),(1001011042,1,'[]','[31000000]','[31081000]'),(1001011043,1,'[]','[31000000]','[31091000]'),(1001011063,1,'[]','[31000000]','[31101000]'),(1001011132,1,'[]','[31000000]','[31071100]'),(1001011142,1,'[]','[31000000]','[31081100]'),(1001011143,1,'[]','[31000000]','[31091100]'),(1001011163,1,'[]','[31000000]','[31101100]'),(1001011232,1,'[]','[31000000]','[31071200]'),(1001011242,1,'[]','[31000000]','[31081200]'),(1001011243,1,'[]','[31000000]','[31091200]'),(1001011263,1,'[]','[31000000]','[31101200]'),(1001011332,1,'[]','[31000000]','[31071300]'),(1001011342,1,'[]','[31000000]','[31081300]'),(1001011343,1,'[]','[31000000]','[31091300]'),(1001011363,1,'[]','[31000000]','[31101300]'),(1001011432,1,'[]','[31000000]','[31071400]'),(1001011442,1,'[]','[31000000]','[31081400]'),(1001011443,1,'[]','[31000000]','[31091400]'),(1001011463,1,'[]','[31000000]','[31101400]'),(1001011532,1,'[]','[31000000]','[31071500]'),(1001011542,1,'[]','[31000000]','[31081500]'),(1001011543,1,'[]','[31000000]','[31091500]'),(1001011563,1,'[]','[31000000]','[31101500]'),(1001020332,1,'[]','[32000000]','[32070300]'),(1001020342,1,'[]','[32000000]','[32080300]'),(1001020343,1,'[]','[32000000]','[32090300]'),(1001020363,1,'[]','[32000000]','[32100300]'),(1001020432,1,'[]','[32000000]','[32070400]'),(1001020442,1,'[]','[32000000]','[32080400]'),(1001020443,1,'[]','[32000000]','[32090400]'),(1001020463,1,'[]','[32000000]','[32100400]'),(1001020532,1,'[]','[32000000]','[32070500]'),(1001020542,1,'[]','[32000000]','[32080500]'),(1001020543,1,'[]','[32000000]','[32090500]'),(1001020563,1,'[]','[32000000]','[32100500]'),(1001020632,1,'[]','[32000000]','[32070600]'),(1001020642,1,'[]','[32000000]','[32080600]'),(1001020643,1,'[]','[32000000]','[32090600]'),(1001020663,1,'[]','[32000000]','[32100600]'),(1001020732,1,'[]','[32000000]','[32070700]'),(1001020742,1,'[]','[32000000]','[32080700]'),(1001020743,1,'[]','[32000000]','[32090700]'),(1001020763,1,'[]','[32000000]','[32100700]'),(1001020832,1,'[]','[32000000]','[32070800]'),(1001020842,1,'[]','[32000000]','[32080800]'),(1001020843,1,'[]','[32000000]','[32090800]'),(1001020863,1,'[]','[32000000]','[32100800]'),(1001020932,1,'[]','[32000000]','[32070900]'),(1001020942,1,'[]','[32000000]','[32080900]'),(1001020943,1,'[]','[32000000]','[32090900]'),(1001020963,1,'[]','[32000000]','[32100900]'),(1001021032,1,'[]','[32000000]','[32071000]'),(1001021042,1,'[]','[32000000]','[32081000]'),(1001021043,1,'[]','[32000000]','[32091000]'),(1001021063,1,'[]','[32000000]','[32101000]'),(1001021132,1,'[]','[32000000]','[32071100]'),(1001021142,1,'[]','[32000000]','[32081100]'),(1001021143,1,'[]','[32000000]','[32091100]'),(1001021163,1,'[]','[32000000]','[32101100]'),(1001021232,1,'[]','[32000000]','[32071200]'),(1001021242,1,'[]','[32000000]','[32081200]'),(1001021243,1,'[]','[32000000]','[32091200]'),(1001021263,1,'[]','[32000000]','[32101200]'),(1001021332,1,'[]','[32000000]','[32071300]'),(1001021342,1,'[]','[32000000]','[32081300]'),(1001021343,1,'[]','[32000000]','[32091300]'),(1001021363,1,'[]','[32000000]','[32101300]'),(1001021432,1,'[]','[32000000]','[32071400]'),(1001021442,1,'[]','[32000000]','[32081400]'),(1001021443,1,'[]','[32000000]','[32091400]'),(1001021463,1,'[]','[32000000]','[32101400]'),(1001021532,1,'[]','[32000000]','[32071500]'),(1001021542,1,'[]','[32000000]','[32081500]'),(1001021543,1,'[]','[32000000]','[32091500]'),(1001021563,1,'[]','[32000000]','[32101500]'),(1001030332,1,'[]','[33000000]','[33070300]'),(1001030342,1,'[]','[33000000]','[33080300]'),(1001030343,1,'[]','[33000000]','[33090300]'),(1001030363,1,'[]','[33000000]','[33100300]'),(1001030432,1,'[]','[33000000]','[33070400]'),(1001030442,1,'[]','[33000000]','[33080400]'),(1001030443,1,'[]','[33000000]','[33090400]'),(1001030463,1,'[]','[33000000]','[33100400]'),(1001030532,1,'[]','[33000000]','[33070500]'),(1001030542,1,'[]','[33000000]','[33080500]'),(1001030543,1,'[]','[33000000]','[33090500]'),(1001030563,1,'[]','[33000000]','[33100500]'),(1001030632,1,'[]','[33000000]','[33070600]'),(1001030642,1,'[]','[33000000]','[33080600]'),(1001030643,1,'[]','[33000000]','[33090600]'),(1001030663,1,'[]','[33000000]','[33100600]'),(1001030732,1,'[]','[33000000]','[33070700]'),(1001030742,1,'[]','[33000000]','[33080700]'),(1001030743,1,'[]','[33000000]','[33090700]'),(1001030763,1,'[]','[33000000]','[33100700]'),(1001030832,1,'[]','[33000000]','[33070800]'),(1001030842,1,'[]','[33000000]','[33080800]'),(1001030843,1,'[]','[33000000]','[33090800]'),(1001030863,1,'[]','[33000000]','[33100800]'),(1001030932,1,'[]','[33000000]','[33070900]'),(1001030942,1,'[]','[33000000]','[33080900]'),(1001030943,1,'[]','[33000000]','[33090900]'),(1001030963,1,'[]','[33000000]','[33100900]'),(1001031032,1,'[]','[33000000]','[33071000]'),(1001031042,1,'[]','[33000000]','[33081000]'),(1001031043,1,'[]','[33000000]','[33091000]'),(1001031063,1,'[]','[33000000]','[33101000]'),(1001031132,1,'[]','[33000000]','[33071100]'),(1001031142,1,'[]','[33000000]','[33081100]'),(1001031143,1,'[]','[33000000]','[33091100]'),(1001031163,1,'[]','[33000000]','[33101100]'),(1001031232,1,'[]','[33000000]','[33071200]'),(1001031242,1,'[]','[33000000]','[33081200]'),(1001031243,1,'[]','[33000000]','[33091200]'),(1001031263,1,'[]','[33000000]','[33101200]'),(1001031332,1,'[]','[33000000]','[33071300]'),(1001031342,1,'[]','[33000000]','[33081300]'),(1001031343,1,'[]','[33000000]','[33091300]'),(1001031363,1,'[]','[33000000]','[33101300]'),(1001031432,1,'[]','[33000000]','[33071400]'),(1001031442,1,'[]','[33000000]','[33081400]'),(1001031443,1,'[]','[33000000]','[33091400]'),(1001031463,1,'[]','[33000000]','[33101400]'),(1001031532,1,'[]','[33000000]','[33071500]'),(1001031542,1,'[]','[33000000]','[33081500]'),(1001031543,1,'[]','[33000000]','[33091500]'),(1001031563,1,'[]','[33000000]','[33101500]'),(1001040332,1,'[]','[34000000]','[34070300]'),(1001040342,1,'[]','[34000000]','[34080300]'),(1001040343,1,'[]','[34000000]','[34090300]'),(1001040363,1,'[]','[34000000]','[34100300]'),(1001040432,1,'[]','[34000000]','[34070400]'),(1001040442,1,'[]','[34000000]','[34080400]'),(1001040443,1,'[]','[34000000]','[34090400]'),(1001040463,1,'[]','[34000000]','[34100400]'),(1001040532,1,'[]','[34000000]','[34070500]'),(1001040542,1,'[]','[34000000]','[34080500]'),(1001040543,1,'[]','[34000000]','[34090500]'),(1001040563,1,'[]','[34000000]','[34100500]'),(1001040632,1,'[]','[34000000]','[34070600]'),(1001040642,1,'[]','[34000000]','[34080600]'),(1001040643,1,'[]','[34000000]','[34090600]'),(1001040663,1,'[]','[34000000]','[34100600]'),(1001040732,1,'[]','[34000000]','[34070700]'),(1001040742,1,'[]','[34000000]','[34080700]'),(1001040743,1,'[]','[34000000]','[34090700]'),(1001040763,1,'[]','[34000000]','[34100700]'),(1001040832,1,'[]','[34000000]','[34070800]'),(1001040842,1,'[]','[34000000]','[34080800]'),(1001040843,1,'[]','[34000000]','[34090800]'),(1001040863,1,'[]','[34000000]','[34100800]'),(1001040932,1,'[]','[34000000]','[34070900]'),(1001040942,1,'[]','[34000000]','[34080900]'),(1001040943,1,'[]','[34000000]','[34090900]'),(1001040963,1,'[]','[34000000]','[34100900]'),(1001041032,1,'[]','[34000000]','[34071000]'),(1001041042,1,'[]','[34000000]','[34081000]'),(1001041043,1,'[]','[34000000]','[34091000]'),(1001041063,1,'[]','[34000000]','[34101000]'),(1001041132,1,'[]','[34000000]','[34071100]'),(1001041142,1,'[]','[34000000]','[34081100]'),(1001041143,1,'[]','[34000000]','[34091100]'),(1001041163,1,'[]','[34000000]','[34101100]'),(1001041232,1,'[]','[34000000]','[34071200]'),(1001041242,1,'[]','[34000000]','[34081200]'),(1001041243,1,'[]','[34000000]','[34091200]'),(1001041263,1,'[]','[34000000]','[34101200]'),(1001041332,1,'[]','[34000000]','[34071300]'),(1001041342,1,'[]','[34000000]','[34081300]'),(1001041343,1,'[]','[34000000]','[34091300]'),(1001041363,1,'[]','[34000000]','[34101300]'),(1001041432,1,'[]','[34000000]','[34071400]'),(1001041442,1,'[]','[34000000]','[34081400]'),(1001041443,1,'[]','[34000000]','[34091400]'),(1001041463,1,'[]','[34000000]','[34101400]'),(1001041532,1,'[]','[34000000]','[34071500]'),(1001041542,1,'[]','[34000000]','[34081500]'),(1001041543,1,'[]','[34000000]','[34091500]'),(1001041563,1,'[]','[34000000]','[34101500]'),(1002010332,1,'[]','[31000000]','[31070300]'),(1002010342,1,'[]','[31000000]','[31080300]'),(1002010343,1,'[]','[31000000]','[31090300]'),(1002010363,1,'[]','[31000000]','[31100300]'),(1002010432,1,'[]','[31000000]','[31070400]'),(1002010442,1,'[]','[31000000]','[31080400]'),(1002010443,1,'[]','[31000000]','[31090400]'),(1002010463,1,'[]','[31000000]','[31100400]'),(1002010532,1,'[]','[31000000]','[31070500]'),(1002010542,1,'[]','[31000000]','[31080500]'),(1002010543,1,'[]','[31000000]','[31090500]'),(1002010563,1,'[]','[31000000]','[31100500]'),(1002010632,1,'[]','[31000000]','[31070600]'),(1002010642,1,'[]','[31000000]','[31080600]'),(1002010643,1,'[]','[31000000]','[31090600]'),(1002010663,1,'[]','[31000000]','[31100600]'),(1002010732,1,'[]','[31000000]','[31070700]'),(1002010742,1,'[]','[31000000]','[31080700]'),(1002010743,1,'[]','[31000000]','[31090700]'),(1002010763,1,'[]','[31000000]','[31100700]'),(1002010832,1,'[]','[31000000]','[31070800]'),(1002010842,1,'[]','[31000000]','[31080800]'),(1002010843,1,'[]','[31000000]','[31090800]'),(1002010863,1,'[]','[31000000]','[31100800]'),(1002010932,1,'[]','[31000000]','[31070900]'),(1002010942,1,'[]','[31000000]','[31080900]'),(1002010943,1,'[]','[31000000]','[31090900]'),(1002010963,1,'[]','[31000000]','[31100900]'),(1002011032,1,'[]','[31000000]','[31071000]'),(1002011042,1,'[]','[31000000]','[31081000]'),(1002011043,1,'[]','[31000000]','[31091000]'),(1002011063,1,'[]','[31000000]','[31101000]'),(1002011132,1,'[]','[31000000]','[31071100]'),(1002011142,1,'[]','[31000000]','[31081100]'),(1002011143,1,'[]','[31000000]','[31091100]'),(1002011163,1,'[]','[31000000]','[31101100]'),(1002011232,1,'[]','[31000000]','[31071200]'),(1002011242,1,'[]','[31000000]','[31081200]'),(1002011243,1,'[]','[31000000]','[31091200]'),(1002011263,1,'[]','[31000000]','[31101200]'),(1002011332,1,'[]','[31000000]','[31071300]'),(1002011342,1,'[]','[31000000]','[31081300]'),(1002011343,1,'[]','[31000000]','[31091300]'),(1002011363,1,'[]','[31000000]','[31101300]'),(1002011432,1,'[]','[31000000]','[31071400]'),(1002011442,1,'[]','[31000000]','[31081400]'),(1002011443,1,'[]','[31000000]','[31091400]'),(1002011463,1,'[]','[31000000]','[31101400]'),(1002011532,1,'[]','[31000000]','[31071500]'),(1002011542,1,'[]','[31000000]','[31081500]'),(1002011543,1,'[]','[31000000]','[31091500]'),(1002011563,1,'[]','[31000000]','[31101500]'),(1002020332,1,'[]','[32000000]','[32070300]'),(1002020342,1,'[]','[32000000]','[32080300]'),(1002020343,1,'[]','[32000000]','[32090300]'),(1002020363,1,'[]','[32000000]','[32100300]'),(1002020432,1,'[]','[32000000]','[32070400]'),(1002020442,1,'[]','[32000000]','[32080400]'),(1002020443,1,'[]','[32000000]','[32090400]'),(1002020463,1,'[]','[32000000]','[32100400]'),(1002020532,1,'[]','[32000000]','[32070500]'),(1002020542,1,'[]','[32000000]','[32080500]'),(1002020543,1,'[]','[32000000]','[32090500]'),(1002020563,1,'[]','[32000000]','[32100500]'),(1002020632,1,'[]','[32000000]','[32070600]'),(1002020642,1,'[]','[32000000]','[32080600]'),(1002020643,1,'[]','[32000000]','[32090600]'),(1002020663,1,'[]','[32000000]','[32100600]'),(1002020732,1,'[]','[32000000]','[32070700]'),(1002020742,1,'[]','[32000000]','[32080700]'),(1002020743,1,'[]','[32000000]','[32090700]'),(1002020763,1,'[]','[32000000]','[32100700]'),(1002020832,1,'[]','[32000000]','[32070800]'),(1002020842,1,'[]','[32000000]','[32080800]'),(1002020843,1,'[]','[32000000]','[32090800]'),(1002020863,1,'[]','[32000000]','[32100800]'),(1002020932,1,'[]','[32000000]','[32070900]'),(1002020942,1,'[]','[32000000]','[32080900]'),(1002020943,1,'[]','[32000000]','[32090900]'),(1002020963,1,'[]','[32000000]','[32100900]'),(1002021032,1,'[]','[32000000]','[32071000]'),(1002021042,1,'[]','[32000000]','[32081000]'),(1002021043,1,'[]','[32000000]','[32091000]'),(1002021063,1,'[]','[32000000]','[32101000]'),(1002021132,1,'[]','[32000000]','[32071100]'),(1002021142,1,'[]','[32000000]','[32081100]'),(1002021143,1,'[]','[32000000]','[32091100]'),(1002021163,1,'[]','[32000000]','[32101100]'),(1002021232,1,'[]','[32000000]','[32071200]'),(1002021242,1,'[]','[32000000]','[32081200]'),(1002021243,1,'[]','[32000000]','[32091200]'),(1002021263,1,'[]','[32000000]','[32101200]'),(1002021332,1,'[]','[32000000]','[32071300]'),(1002021342,1,'[]','[32000000]','[32081300]'),(1002021343,1,'[]','[32000000]','[32091300]'),(1002021363,1,'[]','[32000000]','[32101300]'),(1002021432,1,'[]','[32000000]','[32071400]'),(1002021442,1,'[]','[32000000]','[32081400]'),(1002021443,1,'[]','[32000000]','[32091400]'),(1002021463,1,'[]','[32000000]','[32101400]'),(1002021532,1,'[]','[32000000]','[32071500]'),(1002021542,1,'[]','[32000000]','[32081500]'),(1002021543,1,'[]','[32000000]','[32091500]'),(1002021563,1,'[]','[32000000]','[32101500]'),(1002030332,1,'[]','[33000000]','[33070300]'),(1002030342,1,'[]','[33000000]','[33080300]'),(1002030343,1,'[]','[33000000]','[33090300]'),(1002030363,1,'[]','[33000000]','[33100300]'),(1002030432,1,'[]','[33000000]','[33070400]'),(1002030442,1,'[]','[33000000]','[33080400]'),(1002030443,1,'[]','[33000000]','[33090400]'),(1002030463,1,'[]','[33000000]','[33100400]'),(1002030532,1,'[]','[33000000]','[33070500]'),(1002030542,1,'[]','[33000000]','[33080500]'),(1002030543,1,'[]','[33000000]','[33090500]'),(1002030563,1,'[]','[33000000]','[33100500]'),(1002030632,1,'[]','[33000000]','[33070600]'),(1002030642,1,'[]','[33000000]','[33080600]'),(1002030643,1,'[]','[33000000]','[33090600]'),(1002030663,1,'[]','[33000000]','[33100600]'),(1002030732,1,'[]','[33000000]','[33070700]'),(1002030742,1,'[]','[33000000]','[33080700]'),(1002030743,1,'[]','[33000000]','[33090700]'),(1002030763,1,'[]','[33000000]','[33100700]'),(1002030832,1,'[]','[33000000]','[33070800]'),(1002030842,1,'[]','[33000000]','[33080800]'),(1002030843,1,'[]','[33000000]','[33090800]'),(1002030863,1,'[]','[33000000]','[33100800]'),(1002030932,1,'[]','[33000000]','[33070900]'),(1002030942,1,'[]','[33000000]','[33080900]'),(1002030943,1,'[]','[33000000]','[33090900]'),(1002030963,1,'[]','[33000000]','[33100900]'),(1002031032,1,'[]','[33000000]','[33071000]'),(1002031042,1,'[]','[33000000]','[33081000]'),(1002031043,1,'[]','[33000000]','[33091000]'),(1002031063,1,'[]','[33000000]','[33101000]'),(1002031132,1,'[]','[33000000]','[33071100]'),(1002031142,1,'[]','[33000000]','[33081100]'),(1002031143,1,'[]','[33000000]','[33091100]'),(1002031163,1,'[]','[33000000]','[33101100]'),(1002031232,1,'[]','[33000000]','[33071200]'),(1002031242,1,'[]','[33000000]','[33081200]'),(1002031243,1,'[]','[33000000]','[33091200]'),(1002031263,1,'[]','[33000000]','[33101200]'),(1002031332,1,'[]','[33000000]','[33071300]'),(1002031342,1,'[]','[33000000]','[33081300]'),(1002031343,1,'[]','[33000000]','[33091300]'),(1002031363,1,'[]','[33000000]','[33101300]'),(1002031432,1,'[]','[33000000]','[33071400]'),(1002031442,1,'[]','[33000000]','[33081400]'),(1002031443,1,'[]','[33000000]','[33091400]'),(1002031463,1,'[]','[33000000]','[33101400]'),(1002031532,1,'[]','[33000000]','[33071500]'),(1002031542,1,'[]','[33000000]','[33081500]'),(1002031543,1,'[]','[33000000]','[33091500]'),(1002031563,1,'[]','[33000000]','[33101500]'),(1002040332,1,'[]','[34000000]','[34070300]'),(1002040342,1,'[]','[34000000]','[34080300]'),(1002040343,1,'[]','[34000000]','[34090300]'),(1002040363,1,'[]','[34000000]','[34100300]'),(1002040432,1,'[]','[34000000]','[34070400]'),(1002040442,1,'[]','[34000000]','[34080400]'),(1002040443,1,'[]','[34000000]','[34090400]'),(1002040463,1,'[]','[34000000]','[34100400]'),(1002040532,1,'[]','[34000000]','[34070500]'),(1002040542,1,'[]','[34000000]','[34080500]'),(1002040543,1,'[]','[34000000]','[34090500]'),(1002040563,1,'[]','[34000000]','[34100500]'),(1002040632,1,'[]','[34000000]','[34070600]'),(1002040642,1,'[]','[34000000]','[34080600]'),(1002040643,1,'[]','[34000000]','[34090600]'),(1002040663,1,'[]','[34000000]','[34100600]'),(1002040732,1,'[]','[34000000]','[34070700]'),(1002040742,1,'[]','[34000000]','[34080700]'),(1002040743,1,'[]','[34000000]','[34090700]'),(1002040763,1,'[]','[34000000]','[34100700]'),(1002040832,1,'[]','[34000000]','[34070800]'),(1002040842,1,'[]','[34000000]','[34080800]'),(1002040843,1,'[]','[34000000]','[34090800]'),(1002040863,1,'[]','[34000000]','[34100800]'),(1002040932,1,'[]','[34000000]','[34070900]'),(1002040942,1,'[]','[34000000]','[34080900]'),(1002040943,1,'[]','[34000000]','[34090900]'),(1002040963,1,'[]','[34000000]','[34100900]'),(1002041032,1,'[]','[34000000]','[34071000]'),(1002041042,1,'[]','[34000000]','[34081000]'),(1002041043,1,'[]','[34000000]','[34091000]'),(1002041063,1,'[]','[34000000]','[34101000]'),(1002041132,1,'[]','[34000000]','[34071100]'),(1002041142,1,'[]','[34000000]','[34081100]'),(1002041143,1,'[]','[34000000]','[34091100]'),(1002041163,1,'[]','[34000000]','[34101100]'),(1002041232,1,'[]','[34000000]','[34071200]'),(1002041242,1,'[]','[34000000]','[34081200]'),(1002041243,1,'[]','[34000000]','[34091200]'),(1002041263,1,'[]','[34000000]','[34101200]'),(1002041332,1,'[]','[34000000]','[34071300]'),(1002041342,1,'[]','[34000000]','[34081300]'),(1002041343,1,'[]','[34000000]','[34091300]'),(1002041363,1,'[]','[34000000]','[34101300]'),(1002041432,1,'[]','[34000000]','[34071400]'),(1002041442,1,'[]','[34000000]','[34081400]'),(1002041443,1,'[]','[34000000]','[34091400]'),(1002041463,1,'[]','[34000000]','[34101400]'),(1002041532,1,'[]','[34000000]','[34071500]'),(1002041542,1,'[]','[34000000]','[34081500]'),(1002041543,1,'[]','[34000000]','[34091500]'),(1002041563,1,'[]','[34000000]','[34101500]'),(1003000332,1,'[]','[31000000]','[31070300]'),(1003000342,1,'[]','[31000000]','[31080300]'),(1003000343,1,'[]','[31000000]','[31090300]'),(1003000363,1,'[]','[31000000]','[31100300]'),(1003000432,1,'[]','[31000000]','[31070400]'),(1003000442,1,'[]','[31000000]','[31080400]'),(1003000443,1,'[]','[31000000]','[31090400]'),(1003000463,1,'[]','[31000000]','[31100400]'),(1003000532,1,'[]','[31000000]','[31070500]'),(1003000542,1,'[]','[31000000]','[31080500]'),(1003000543,1,'[]','[31000000]','[31090500]'),(1003000563,1,'[]','[31000000]','[31100500]'),(1003000632,1,'[]','[31000000]','[31070600]'),(1003000642,1,'[]','[31000000]','[31080600]'),(1003000643,1,'[]','[31000000]','[31090600]'),(1003000663,1,'[]','[31000000]','[31100600]'),(1003000732,1,'[]','[31000000]','[31070700]'),(1003000742,1,'[]','[31000000]','[31080700]'),(1003000743,1,'[]','[31000000]','[31090700]'),(1003000763,1,'[]','[31000000]','[31100700]'),(1003000832,1,'[]','[31000000]','[31070800]'),(1003000842,1,'[]','[31000000]','[31080800]'),(1003000843,1,'[]','[31000000]','[31090800]'),(1003000863,1,'[]','[31000000]','[31100800]'),(1003000932,1,'[]','[31000000]','[31070900]'),(1003000942,1,'[]','[31000000]','[31080900]'),(1003000943,1,'[]','[31000000]','[31090900]'),(1003000963,1,'[]','[31000000]','[31100900]'),(1003001032,1,'[]','[31000000]','[31071000]'),(1003001042,1,'[]','[31000000]','[31081000]'),(1003001043,1,'[]','[31000000]','[31091000]'),(1003001063,1,'[]','[31000000]','[31101000]'),(1003001132,1,'[]','[31000000]','[31071100]'),(1003001142,1,'[]','[31000000]','[31081100]'),(1003001143,1,'[]','[31000000]','[31091100]'),(1003001163,1,'[]','[31000000]','[31101100]'),(1003001232,1,'[]','[31000000]','[31071200]'),(1003001242,1,'[]','[31000000]','[31081200]'),(1003001243,1,'[]','[31000000]','[31091200]'),(1003001263,1,'[]','[31000000]','[31101200]'),(1003001332,1,'[]','[31000000]','[31071300]'),(1003001342,1,'[]','[31000000]','[31081300]'),(1003001343,1,'[]','[31000000]','[31091300]'),(1003001363,1,'[]','[31000000]','[31101300]'),(1003001432,1,'[]','[31000000]','[31071400]'),(1003001442,1,'[]','[31000000]','[31081400]'),(1003001443,1,'[]','[31000000]','[31091400]'),(1003001463,1,'[]','[31000000]','[31101400]'),(1003001532,1,'[]','[31000000]','[31071500]'),(1003001542,1,'[]','[31000000]','[31081500]'),(1003001543,1,'[]','[31000000]','[31091500]'),(1003001563,1,'[]','[31000000]','[31101500]'),(1004010332,1,'[]','[31000000]','[31070300]'),(1004010342,1,'[]','[31000000]','[31080300]'),(1004010343,1,'[]','[31000000]','[31090300]'),(1004010363,1,'[]','[31000000]','[31100300]'),(1004010432,1,'[]','[31000000]','[31070400]'),(1004010442,1,'[]','[31000000]','[31080400]'),(1004010443,1,'[]','[31000000]','[31090400]'),(1004010463,1,'[]','[31000000]','[31100400]'),(1004010532,1,'[]','[31000000]','[31070500]'),(1004010542,1,'[]','[31000000]','[31080500]'),(1004010543,1,'[]','[31000000]','[31090500]'),(1004010563,1,'[]','[31000000]','[31100500]'),(1004010632,1,'[]','[31000000]','[31070600]'),(1004010642,1,'[]','[31000000]','[31080600]'),(1004010643,1,'[]','[31000000]','[31090600]'),(1004010663,1,'[]','[31000000]','[31100600]'),(1004010732,1,'[]','[31000000]','[31070700]'),(1004010742,1,'[]','[31000000]','[31080700]'),(1004010743,1,'[]','[31000000]','[31090700]'),(1004010763,1,'[]','[31000000]','[31100700]'),(1004010832,1,'[]','[31000000]','[31070800]'),(1004010842,1,'[]','[31000000]','[31080800]'),(1004010843,1,'[]','[31000000]','[31090800]'),(1004010863,1,'[]','[31000000]','[31100800]'),(1004010932,1,'[]','[31000000]','[31070900]'),(1004010942,1,'[]','[31000000]','[31080900]'),(1004010943,1,'[]','[31000000]','[31090900]'),(1004010963,1,'[]','[31000000]','[31100900]'),(1004011032,1,'[]','[31000000]','[31071000]'),(1004011042,1,'[]','[31000000]','[31081000]'),(1004011043,1,'[]','[31000000]','[31091000]'),(1004011063,1,'[]','[31000000]','[31101000]'),(1004011132,1,'[]','[31000000]','[31071100]'),(1004011142,1,'[]','[31000000]','[31081100]'),(1004011143,1,'[]','[31000000]','[31091100]'),(1004011163,1,'[]','[31000000]','[31101100]'),(1004011232,1,'[]','[31000000]','[31071200]'),(1004011242,1,'[]','[31000000]','[31081200]'),(1004011243,1,'[]','[31000000]','[31091200]'),(1004011263,1,'[]','[31000000]','[31101200]'),(1004011332,1,'[]','[31000000]','[31071300]'),(1004011342,1,'[]','[31000000]','[31081300]'),(1004011343,1,'[]','[31000000]','[31091300]'),(1004011363,1,'[]','[31000000]','[31101300]'),(1004011432,1,'[]','[31000000]','[31071400]'),(1004011442,1,'[]','[31000000]','[31081400]'),(1004011443,1,'[]','[31000000]','[31091400]'),(1004011463,1,'[]','[31000000]','[31101400]'),(1004011532,1,'[]','[31000000]','[31071500]'),(1004011542,1,'[]','[31000000]','[31081500]'),(1004011543,1,'[]','[31000000]','[31091500]'),(1004011563,1,'[]','[31000000]','[31101500]'),(1004020332,1,'[]','[32000000]','[32070300]'),(1004020342,1,'[]','[32000000]','[32080300]'),(1004020343,1,'[]','[32000000]','[32090300]'),(1004020363,1,'[]','[32000000]','[32100300]'),(1004020432,1,'[]','[32000000]','[32070400]'),(1004020442,1,'[]','[32000000]','[32080400]'),(1004020443,1,'[]','[32000000]','[32090400]'),(1004020463,1,'[]','[32000000]','[32100400]'),(1004020532,1,'[]','[32000000]','[32070500]'),(1004020542,1,'[]','[32000000]','[32080500]'),(1004020543,1,'[]','[32000000]','[32090500]'),(1004020563,1,'[]','[32000000]','[32100500]'),(1004020632,1,'[]','[32000000]','[32070600]'),(1004020642,1,'[]','[32000000]','[32080600]'),(1004020643,1,'[]','[32000000]','[32090600]'),(1004020663,1,'[]','[32000000]','[32100600]'),(1004020732,1,'[]','[32000000]','[32070700]'),(1004020742,1,'[]','[32000000]','[32080700]'),(1004020743,1,'[]','[32000000]','[32090700]'),(1004020763,1,'[]','[32000000]','[32100700]'),(1004020832,1,'[]','[32000000]','[32070800]'),(1004020842,1,'[]','[32000000]','[32080800]'),(1004020843,1,'[]','[32000000]','[32090800]'),(1004020863,1,'[]','[32000000]','[32100800]'),(1004020932,1,'[]','[32000000]','[32070900]'),(1004020942,1,'[]','[32000000]','[32080900]'),(1004020943,1,'[]','[32000000]','[32090900]'),(1004020963,1,'[]','[32000000]','[32100900]'),(1004021032,1,'[]','[32000000]','[32071000]'),(1004021042,1,'[]','[32000000]','[32081000]'),(1004021043,1,'[]','[32000000]','[32091000]'),(1004021063,1,'[]','[32000000]','[32101000]'),(1004021132,1,'[]','[32000000]','[32071100]'),(1004021142,1,'[]','[32000000]','[32081100]'),(1004021143,1,'[]','[32000000]','[32091100]'),(1004021163,1,'[]','[32000000]','[32101100]'),(1004021232,1,'[]','[32000000]','[32071200]'),(1004021242,1,'[]','[32000000]','[32081200]'),(1004021243,1,'[]','[32000000]','[32091200]'),(1004021263,1,'[]','[32000000]','[32101200]'),(1004021332,1,'[]','[32000000]','[32071300]'),(1004021342,1,'[]','[32000000]','[32081300]'),(1004021343,1,'[]','[32000000]','[32091300]'),(1004021363,1,'[]','[32000000]','[32101300]'),(1004021432,1,'[]','[32000000]','[32071400]'),(1004021442,1,'[]','[32000000]','[32081400]'),(1004021443,1,'[]','[32000000]','[32091400]'),(1004021463,1,'[]','[32000000]','[32101400]'),(1004021532,1,'[]','[32000000]','[32071500]'),(1004021542,1,'[]','[32000000]','[32081500]'),(1004021543,1,'[]','[32000000]','[32091500]'),(1004021563,1,'[]','[32000000]','[32101500]'),(1004030332,1,'[]','[33000000]','[33070300]'),(1004030342,1,'[]','[33000000]','[33080300]'),(1004030343,1,'[]','[33000000]','[33090300]'),(1004030363,1,'[]','[33000000]','[33100300]'),(1004030432,1,'[]','[33000000]','[33070400]'),(1004030442,1,'[]','[33000000]','[33080400]'),(1004030443,1,'[]','[33000000]','[33090400]'),(1004030463,1,'[]','[33000000]','[33100400]'),(1004030532,1,'[]','[33000000]','[33070500]'),(1004030542,1,'[]','[33000000]','[33080500]'),(1004030543,1,'[]','[33000000]','[33090500]'),(1004030563,1,'[]','[33000000]','[33100500]'),(1004030632,1,'[]','[33000000]','[33070600]'),(1004030642,1,'[]','[33000000]','[33080600]'),(1004030643,1,'[]','[33000000]','[33090600]'),(1004030663,1,'[]','[33000000]','[33100600]'),(1004030732,1,'[]','[33000000]','[33070700]'),(1004030742,1,'[]','[33000000]','[33080700]'),(1004030743,1,'[]','[33000000]','[33090700]'),(1004030763,1,'[]','[33000000]','[33100700]'),(1004030832,1,'[]','[33000000]','[33070800]'),(1004030842,1,'[]','[33000000]','[33080800]'),(1004030843,1,'[]','[33000000]','[33090800]'),(1004030863,1,'[]','[33000000]','[33100800]'),(1004030932,1,'[]','[33000000]','[33070900]'),(1004030942,1,'[]','[33000000]','[33080900]'),(1004030943,1,'[]','[33000000]','[33090900]'),(1004030963,1,'[]','[33000000]','[33100900]'),(1004031032,1,'[]','[33000000]','[33071000]'),(1004031042,1,'[]','[33000000]','[33081000]'),(1004031043,1,'[]','[33000000]','[33091000]'),(1004031063,1,'[]','[33000000]','[33101000]'),(1004031132,1,'[]','[33000000]','[33071100]'),(1004031142,1,'[]','[33000000]','[33081100]'),(1004031143,1,'[]','[33000000]','[33091100]'),(1004031163,1,'[]','[33000000]','[33101100]'),(1004031232,1,'[]','[33000000]','[33071200]'),(1004031242,1,'[]','[33000000]','[33081200]'),(1004031243,1,'[]','[33000000]','[33091200]'),(1004031263,1,'[]','[33000000]','[33101200]'),(1004031332,1,'[]','[33000000]','[33071300]'),(1004031342,1,'[]','[33000000]','[33081300]'),(1004031343,1,'[]','[33000000]','[33091300]'),(1004031363,1,'[]','[33000000]','[33101300]'),(1004031432,1,'[]','[33000000]','[33071400]'),(1004031442,1,'[]','[33000000]','[33081400]'),(1004031443,1,'[]','[33000000]','[33091400]'),(1004031463,1,'[]','[33000000]','[33101400]'),(1004031532,1,'[]','[33000000]','[33071500]'),(1004031542,1,'[]','[33000000]','[33081500]'),(1004031543,1,'[]','[33000000]','[33091500]'),(1004031563,1,'[]','[33000000]','[33101500]'),(1004040332,1,'[]','[34000000]','[34070300]'),(1004040342,1,'[]','[34000000]','[34080300]'),(1004040343,1,'[]','[34000000]','[34090300]'),(1004040363,1,'[]','[34000000]','[34100300]'),(1004040432,1,'[]','[34000000]','[34070400]'),(1004040442,1,'[]','[34000000]','[34080400]'),(1004040443,1,'[]','[34000000]','[34090400]'),(1004040463,1,'[]','[34000000]','[34100400]'),(1004040532,1,'[]','[34000000]','[34070500]'),(1004040542,1,'[]','[34000000]','[34080500]'),(1004040543,1,'[]','[34000000]','[34090500]'),(1004040563,1,'[]','[34000000]','[34100500]'),(1004040632,1,'[]','[34000000]','[34070600]'),(1004040642,1,'[]','[34000000]','[34080600]'),(1004040643,1,'[]','[34000000]','[34090600]'),(1004040663,1,'[]','[34000000]','[34100600]'),(1004040732,1,'[]','[34000000]','[34070700]'),(1004040742,1,'[]','[34000000]','[34080700]'),(1004040743,1,'[]','[34000000]','[34090700]'),(1004040763,1,'[]','[34000000]','[34100700]'),(1004040832,1,'[]','[34000000]','[34070800]'),(1004040842,1,'[]','[34000000]','[34080800]'),(1004040843,1,'[]','[34000000]','[34090800]'),(1004040863,1,'[]','[34000000]','[34100800]'),(1004040932,1,'[]','[34000000]','[34070900]'),(1004040942,1,'[]','[34000000]','[34080900]'),(1004040943,1,'[]','[34000000]','[34090900]'),(1004040963,1,'[]','[34000000]','[34100900]'),(1004041032,1,'[]','[34000000]','[34071000]'),(1004041042,1,'[]','[34000000]','[34081000]'),(1004041043,1,'[]','[34000000]','[34091000]'),(1004041063,1,'[]','[34000000]','[34101000]'),(1004041132,1,'[]','[34000000]','[34071100]'),(1004041142,1,'[]','[34000000]','[34081100]'),(1004041143,1,'[]','[34000000]','[34091100]'),(1004041163,1,'[]','[34000000]','[34101100]'),(1004041232,1,'[]','[34000000]','[34071200]'),(1004041242,1,'[]','[34000000]','[34081200]'),(1004041243,1,'[]','[34000000]','[34091200]'),(1004041263,1,'[]','[34000000]','[34101200]'),(1004041332,1,'[]','[34000000]','[34071300]'),(1004041342,1,'[]','[34000000]','[34081300]'),(1004041343,1,'[]','[34000000]','[34091300]'),(1004041363,1,'[]','[34000000]','[34101300]'),(1004041432,1,'[]','[34000000]','[34071400]'),(1004041442,1,'[]','[34000000]','[34081400]'),(1004041443,1,'[]','[34000000]','[34091400]'),(1004041463,1,'[]','[34000000]','[34101400]'),(1004041532,1,'[]','[34000000]','[34071500]'),(1004041542,1,'[]','[34000000]','[34081500]'),(1004041543,1,'[]','[34000000]','[34091500]'),(1004041563,1,'[]','[34000000]','[34101500]'),(1005000332,1,'[]','[31000000]','[31070300]'),(1005000342,1,'[]','[31000000]','[31080300]'),(1005000343,1,'[]','[31000000]','[31090300]'),(1005000363,1,'[]','[31000000]','[31100300]'),(1005000432,1,'[]','[31000000]','[31070400]'),(1005000442,1,'[]','[31000000]','[31080400]'),(1005000443,1,'[]','[31000000]','[31090400]'),(1005000463,1,'[]','[31000000]','[31100400]'),(1005000532,1,'[]','[31000000]','[31070500]'),(1005000542,1,'[]','[31000000]','[31080500]'),(1005000543,1,'[]','[31000000]','[31090500]'),(1005000563,1,'[]','[31000000]','[31100500]'),(1005000632,1,'[]','[31000000]','[31070600]'),(1005000642,1,'[]','[31000000]','[31080600]'),(1005000643,1,'[]','[31000000]','[31090600]'),(1005000663,1,'[]','[31000000]','[31100600]'),(1005000732,1,'[]','[31000000]','[31070700]'),(1005000742,1,'[]','[31000000]','[31080700]'),(1005000743,1,'[]','[31000000]','[31090700]'),(1005000763,1,'[]','[31000000]','[31100700]'),(1005000832,1,'[]','[31000000]','[31070800]'),(1005000842,1,'[]','[31000000]','[31080800]'),(1005000843,1,'[]','[31000000]','[31090800]'),(1005000863,1,'[]','[31000000]','[31100800]'),(1005000932,1,'[]','[31000000]','[31070900]'),(1005000942,1,'[]','[31000000]','[31080900]'),(1005000943,1,'[]','[31000000]','[31090900]'),(1005000963,1,'[]','[31000000]','[31100900]'),(1005001032,1,'[]','[31000000]','[31071000]'),(1005001042,1,'[]','[31000000]','[31081000]'),(1005001043,1,'[]','[31000000]','[31091000]'),(1005001063,1,'[]','[31000000]','[31101000]'),(1005001132,1,'[]','[31000000]','[31071100]'),(1005001142,1,'[]','[31000000]','[31081100]'),(1005001143,1,'[]','[31000000]','[31091100]'),(1005001163,1,'[]','[31000000]','[31101100]'),(1005001232,1,'[]','[31000000]','[31071200]'),(1005001242,1,'[]','[31000000]','[31081200]'),(1005001243,1,'[]','[31000000]','[31091200]'),(1005001263,1,'[]','[31000000]','[31101200]'),(1005001332,1,'[]','[31000000]','[31071300]'),(1005001342,1,'[]','[31000000]','[31081300]'),(1005001343,1,'[]','[31000000]','[31091300]'),(1005001363,1,'[]','[31000000]','[31101300]'),(1005001432,1,'[]','[31000000]','[31071400]'),(1005001442,1,'[]','[31000000]','[31081400]'),(1005001443,1,'[]','[31000000]','[31091400]'),(1005001463,1,'[]','[31000000]','[31101400]'),(1005001532,1,'[]','[31000000]','[31071500]'),(1005001542,1,'[]','[31000000]','[31081500]'),(1005001543,1,'[]','[31000000]','[31091500]'),(1005001563,1,'[]','[31000000]','[31101500]'),(1006010332,1,'[]','[31000000]','[31070300]'),(1006010342,1,'[]','[31000000]','[31080300]'),(1006010343,1,'[]','[31000000]','[31090300]'),(1006010363,1,'[]','[31000000]','[31100300]'),(1006010432,1,'[]','[31000000]','[31070400]'),(1006010442,1,'[]','[31000000]','[31080400]'),(1006010443,1,'[]','[31000000]','[31090400]'),(1006010463,1,'[]','[31000000]','[31100400]'),(1006010532,1,'[]','[31000000]','[31070500]'),(1006010542,1,'[]','[31000000]','[31080500]'),(1006010543,1,'[]','[31000000]','[31090500]'),(1006010563,1,'[]','[31000000]','[31100500]'),(1006010632,1,'[]','[31000000]','[31070600]'),(1006010642,1,'[]','[31000000]','[31080600]'),(1006010643,1,'[]','[31000000]','[31090600]'),(1006010663,1,'[]','[31000000]','[31100600]'),(1006010732,1,'[]','[31000000]','[31070700]'),(1006010742,1,'[]','[31000000]','[31080700]'),(1006010743,1,'[]','[31000000]','[31090700]'),(1006010763,1,'[]','[31000000]','[31100700]'),(1006010832,1,'[]','[31000000]','[31070800]'),(1006010842,1,'[]','[31000000]','[31080800]'),(1006010843,1,'[]','[31000000]','[31090800]'),(1006010863,1,'[]','[31000000]','[31100800]'),(1006010932,1,'[]','[31000000]','[31070900]'),(1006010942,1,'[]','[31000000]','[31080900]'),(1006010943,1,'[]','[31000000]','[31090900]'),(1006010963,1,'[]','[31000000]','[31100900]'),(1006011032,1,'[]','[31000000]','[31071000]'),(1006011042,1,'[]','[31000000]','[31081000]'),(1006011043,1,'[]','[31000000]','[31091000]'),(1006011063,1,'[]','[31000000]','[31101000]'),(1006011132,1,'[]','[31000000]','[31071100]'),(1006011142,1,'[]','[31000000]','[31081100]'),(1006011143,1,'[]','[31000000]','[31091100]'),(1006011163,1,'[]','[31000000]','[31101100]'),(1006011232,1,'[]','[31000000]','[31071200]'),(1006011242,1,'[]','[31000000]','[31081200]'),(1006011243,1,'[]','[31000000]','[31091200]'),(1006011263,1,'[]','[31000000]','[31101200]'),(1006011332,1,'[]','[31000000]','[31071300]'),(1006011342,1,'[]','[31000000]','[31081300]'),(1006011343,1,'[]','[31000000]','[31091300]'),(1006011363,1,'[]','[31000000]','[31101300]'),(1006011432,1,'[]','[31000000]','[31071400]'),(1006011442,1,'[]','[31000000]','[31081400]'),(1006011443,1,'[]','[31000000]','[31091400]'),(1006011463,1,'[]','[31000000]','[31101400]'),(1006011532,1,'[]','[31000000]','[31071500]'),(1006011542,1,'[]','[31000000]','[31081500]'),(1006011543,1,'[]','[31000000]','[31091500]'),(1006011563,1,'[]','[31000000]','[31101500]'),(1006020332,1,'[]','[32000000]','[32070300]'),(1006020342,1,'[]','[32000000]','[32080300]'),(1006020343,1,'[]','[32000000]','[32090300]'),(1006020363,1,'[]','[32000000]','[32100300]'),(1006020432,1,'[]','[32000000]','[32070400]'),(1006020442,1,'[]','[32000000]','[32080400]'),(1006020443,1,'[]','[32000000]','[32090400]'),(1006020463,1,'[]','[32000000]','[32100400]'),(1006020532,1,'[]','[32000000]','[32070500]'),(1006020542,1,'[]','[32000000]','[32080500]'),(1006020543,1,'[]','[32000000]','[32090500]'),(1006020563,1,'[]','[32000000]','[32100500]'),(1006020632,1,'[]','[32000000]','[32070600]'),(1006020642,1,'[]','[32000000]','[32080600]'),(1006020643,1,'[]','[32000000]','[32090600]'),(1006020663,1,'[]','[32000000]','[32100600]'),(1006020732,1,'[]','[32000000]','[32070700]'),(1006020742,1,'[]','[32000000]','[32080700]'),(1006020743,1,'[]','[32000000]','[32090700]'),(1006020763,1,'[]','[32000000]','[32100700]'),(1006020832,1,'[]','[32000000]','[32070800]'),(1006020842,1,'[]','[32000000]','[32080800]'),(1006020843,1,'[]','[32000000]','[32090800]'),(1006020863,1,'[]','[32000000]','[32100800]'),(1006020932,1,'[]','[32000000]','[32070900]'),(1006020942,1,'[]','[32000000]','[32080900]'),(1006020943,1,'[]','[32000000]','[32090900]'),(1006020963,1,'[]','[32000000]','[32100900]'),(1006021032,1,'[]','[32000000]','[32071000]'),(1006021042,1,'[]','[32000000]','[32081000]'),(1006021043,1,'[]','[32000000]','[32091000]'),(1006021063,1,'[]','[32000000]','[32101000]'),(1006021132,1,'[]','[32000000]','[32071100]'),(1006021142,1,'[]','[32000000]','[32081100]'),(1006021143,1,'[]','[32000000]','[32091100]'),(1006021163,1,'[]','[32000000]','[32101100]'),(1006021232,1,'[]','[32000000]','[32071200]'),(1006021242,1,'[]','[32000000]','[32081200]'),(1006021243,1,'[]','[32000000]','[32091200]'),(1006021263,1,'[]','[32000000]','[32101200]'),(1006021332,1,'[]','[32000000]','[32071300]'),(1006021342,1,'[]','[32000000]','[32081300]'),(1006021343,1,'[]','[32000000]','[32091300]'),(1006021363,1,'[]','[32000000]','[32101300]'),(1006021432,1,'[]','[32000000]','[32071400]'),(1006021442,1,'[]','[32000000]','[32081400]'),(1006021443,1,'[]','[32000000]','[32091400]'),(1006021463,1,'[]','[32000000]','[32101400]'),(1006021532,1,'[]','[32000000]','[32071500]'),(1006021542,1,'[]','[32000000]','[32081500]'),(1006021543,1,'[]','[32000000]','[32091500]'),(1006021563,1,'[]','[32000000]','[32101500]'),(1006030332,1,'[]','[33000000]','[33070300]'),(1006030342,1,'[]','[33000000]','[33080300]'),(1006030343,1,'[]','[33000000]','[33090300]'),(1006030363,1,'[]','[33000000]','[33100300]'),(1006030432,1,'[]','[33000000]','[33070400]'),(1006030442,1,'[]','[33000000]','[33080400]'),(1006030443,1,'[]','[33000000]','[33090400]'),(1006030463,1,'[]','[33000000]','[33100400]'),(1006030532,1,'[]','[33000000]','[33070500]'),(1006030542,1,'[]','[33000000]','[33080500]'),(1006030543,1,'[]','[33000000]','[33090500]'),(1006030563,1,'[]','[33000000]','[33100500]'),(1006030632,1,'[]','[33000000]','[33070600]'),(1006030642,1,'[]','[33000000]','[33080600]'),(1006030643,1,'[]','[33000000]','[33090600]'),(1006030663,1,'[]','[33000000]','[33100600]'),(1006030732,1,'[]','[33000000]','[33070700]'),(1006030742,1,'[]','[33000000]','[33080700]'),(1006030743,1,'[]','[33000000]','[33090700]'),(1006030763,1,'[]','[33000000]','[33100700]'),(1006030832,1,'[]','[33000000]','[33070800]'),(1006030842,1,'[]','[33000000]','[33080800]'),(1006030843,1,'[]','[33000000]','[33090800]'),(1006030863,1,'[]','[33000000]','[33100800]'),(1006030932,1,'[]','[33000000]','[33070900]'),(1006030942,1,'[]','[33000000]','[33080900]'),(1006030943,1,'[]','[33000000]','[33090900]'),(1006030963,1,'[]','[33000000]','[33100900]'),(1006031032,1,'[]','[33000000]','[33071000]'),(1006031042,1,'[]','[33000000]','[33081000]'),(1006031043,1,'[]','[33000000]','[33091000]'),(1006031063,1,'[]','[33000000]','[33101000]'),(1006031132,1,'[]','[33000000]','[33071100]'),(1006031142,1,'[]','[33000000]','[33081100]'),(1006031143,1,'[]','[33000000]','[33091100]'),(1006031163,1,'[]','[33000000]','[33101100]'),(1006031232,1,'[]','[33000000]','[33071200]'),(1006031242,1,'[]','[33000000]','[33081200]'),(1006031243,1,'[]','[33000000]','[33091200]'),(1006031263,1,'[]','[33000000]','[33101200]'),(1006031332,1,'[]','[33000000]','[33071300]'),(1006031342,1,'[]','[33000000]','[33081300]'),(1006031343,1,'[]','[33000000]','[33091300]'),(1006031363,1,'[]','[33000000]','[33101300]'),(1006031432,1,'[]','[33000000]','[33071400]'),(1006031442,1,'[]','[33000000]','[33081400]'),(1006031443,1,'[]','[33000000]','[33091400]'),(1006031463,1,'[]','[33000000]','[33101400]'),(1006031532,1,'[]','[33000000]','[33071500]'),(1006031542,1,'[]','[33000000]','[33081500]'),(1006031543,1,'[]','[33000000]','[33091500]'),(1006031563,1,'[]','[33000000]','[33101500]'),(1006040332,1,'[]','[34000000]','[34070300]'),(1006040342,1,'[]','[34000000]','[34080300]'),(1006040343,1,'[]','[34000000]','[34090300]'),(1006040363,1,'[]','[34000000]','[34100300]'),(1006040432,1,'[]','[34000000]','[34070400]'),(1006040442,1,'[]','[34000000]','[34080400]'),(1006040443,1,'[]','[34000000]','[34090400]'),(1006040463,1,'[]','[34000000]','[34100400]'),(1006040532,1,'[]','[34000000]','[34070500]'),(1006040542,1,'[]','[34000000]','[34080500]'),(1006040543,1,'[]','[34000000]','[34090500]'),(1006040563,1,'[]','[34000000]','[34100500]'),(1006040632,1,'[]','[34000000]','[34070600]'),(1006040642,1,'[]','[34000000]','[34080600]'),(1006040643,1,'[]','[34000000]','[34090600]'),(1006040663,1,'[]','[34000000]','[34100600]'),(1006040732,1,'[]','[34000000]','[34070700]'),(1006040742,1,'[]','[34000000]','[34080700]'),(1006040743,1,'[]','[34000000]','[34090700]'),(1006040763,1,'[]','[34000000]','[34100700]'),(1006040832,1,'[]','[34000000]','[34070800]'),(1006040842,1,'[]','[34000000]','[34080800]'),(1006040843,1,'[]','[34000000]','[34090800]'),(1006040863,1,'[]','[34000000]','[34100800]'),(1006040932,1,'[]','[34000000]','[34070900]'),(1006040942,1,'[]','[34000000]','[34080900]'),(1006040943,1,'[]','[34000000]','[34090900]'),(1006040963,1,'[]','[34000000]','[34100900]'),(1006041032,1,'[]','[34000000]','[34071000]'),(1006041042,1,'[]','[34000000]','[34081000]'),(1006041043,1,'[]','[34000000]','[34091000]'),(1006041063,1,'[]','[34000000]','[34101000]'),(1006041132,1,'[]','[34000000]','[34071100]'),(1006041142,1,'[]','[34000000]','[34081100]'),(1006041143,1,'[]','[34000000]','[34091100]'),(1006041163,1,'[]','[34000000]','[34101100]'),(1006041232,1,'[]','[34000000]','[34071200]'),(1006041242,1,'[]','[34000000]','[34081200]'),(1006041243,1,'[]','[34000000]','[34091200]'),(1006041263,1,'[]','[34000000]','[34101200]'),(1006041332,1,'[]','[34000000]','[34071300]'),(1006041342,1,'[]','[34000000]','[34081300]'),(1006041343,1,'[]','[34000000]','[34091300]'),(1006041363,1,'[]','[34000000]','[34101300]'),(1006041432,1,'[]','[34000000]','[34071400]'),(1006041442,1,'[]','[34000000]','[34081400]'),(1006041443,1,'[]','[34000000]','[34091400]'),(1006041463,1,'[]','[34000000]','[34101400]'),(1006041532,1,'[]','[34000000]','[34071500]'),(1006041542,1,'[]','[34000000]','[34081500]'),(1006041543,1,'[]','[34000000]','[34091500]'),(1006041563,1,'[]','[34000000]','[34101500]'),(1007010332,1,'[]','[31000000]','[31070300]'),(1007010342,1,'[]','[31000000]','[31080300]'),(1007010343,1,'[]','[31000000]','[31090300]'),(1007010363,1,'[]','[31000000]','[31100300]'),(1007010432,1,'[]','[31000000]','[31070400]'),(1007010442,1,'[]','[31000000]','[31080400]'),(1007010443,1,'[]','[31000000]','[31090400]'),(1007010463,1,'[]','[31000000]','[31100400]'),(1007010532,1,'[]','[31000000]','[31070500]'),(1007010542,1,'[]','[31000000]','[31080500]'),(1007010543,1,'[]','[31000000]','[31090500]'),(1007010563,1,'[]','[31000000]','[31100500]'),(1007010632,1,'[]','[31000000]','[31070600]'),(1007010642,1,'[]','[31000000]','[31080600]'),(1007010643,1,'[]','[31000000]','[31090600]'),(1007010663,1,'[]','[31000000]','[31100600]'),(1007010732,1,'[]','[31000000]','[31070700]'),(1007010742,1,'[]','[31000000]','[31080700]'),(1007010743,1,'[]','[31000000]','[31090700]'),(1007010763,1,'[]','[31000000]','[31100700]'),(1007010832,1,'[]','[31000000]','[31070800]'),(1007010842,1,'[]','[31000000]','[31080800]'),(1007010843,1,'[]','[31000000]','[31090800]'),(1007010863,1,'[]','[31000000]','[31100800]'),(1007010932,1,'[]','[31000000]','[31070900]'),(1007010942,1,'[]','[31000000]','[31080900]'),(1007010943,1,'[]','[31000000]','[31090900]'),(1007010963,1,'[]','[31000000]','[31100900]'),(1007011032,1,'[]','[31000000]','[31071000]'),(1007011042,1,'[]','[31000000]','[31081000]'),(1007011043,1,'[]','[31000000]','[31091000]'),(1007011063,1,'[]','[31000000]','[31101000]'),(1007011132,1,'[]','[31000000]','[31071100]'),(1007011142,1,'[]','[31000000]','[31081100]'),(1007011143,1,'[]','[31000000]','[31091100]'),(1007011163,1,'[]','[31000000]','[31101100]'),(1007011232,1,'[]','[31000000]','[31071200]'),(1007011242,1,'[]','[31000000]','[31081200]'),(1007011243,1,'[]','[31000000]','[31091200]'),(1007011263,1,'[]','[31000000]','[31101200]'),(1007011332,1,'[]','[31000000]','[31071300]'),(1007011342,1,'[]','[31000000]','[31081300]'),(1007011343,1,'[]','[31000000]','[31091300]'),(1007011363,1,'[]','[31000000]','[31101300]'),(1007011432,1,'[]','[31000000]','[31071400]'),(1007011442,1,'[]','[31000000]','[31081400]'),(1007011443,1,'[]','[31000000]','[31091400]'),(1007011463,1,'[]','[31000000]','[31101400]'),(1007011532,1,'[]','[31000000]','[31071500]'),(1007011542,1,'[]','[31000000]','[31081500]'),(1007011543,1,'[]','[31000000]','[31091500]'),(1007011563,1,'[]','[31000000]','[31101500]'),(1007020332,1,'[]','[32000000]','[32070300]'),(1007020342,1,'[]','[32000000]','[32080300]'),(1007020343,1,'[]','[32000000]','[32090300]'),(1007020363,1,'[]','[32000000]','[32100300]'),(1007020432,1,'[]','[32000000]','[32070400]'),(1007020442,1,'[]','[32000000]','[32080400]'),(1007020443,1,'[]','[32000000]','[32090400]'),(1007020463,1,'[]','[32000000]','[32100400]'),(1007020532,1,'[]','[32000000]','[32070500]'),(1007020542,1,'[]','[32000000]','[32080500]'),(1007020543,1,'[]','[32000000]','[32090500]'),(1007020563,1,'[]','[32000000]','[32100500]'),(1007020632,1,'[]','[32000000]','[32070600]'),(1007020642,1,'[]','[32000000]','[32080600]'),(1007020643,1,'[]','[32000000]','[32090600]'),(1007020663,1,'[]','[32000000]','[32100600]'),(1007020732,1,'[]','[32000000]','[32070700]'),(1007020742,1,'[]','[32000000]','[32080700]'),(1007020743,1,'[]','[32000000]','[32090700]'),(1007020763,1,'[]','[32000000]','[32100700]'),(1007020832,1,'[]','[32000000]','[32070800]'),(1007020842,1,'[]','[32000000]','[32080800]'),(1007020843,1,'[]','[32000000]','[32090800]'),(1007020863,1,'[]','[32000000]','[32100800]'),(1007020932,1,'[]','[32000000]','[32070900]'),(1007020942,1,'[]','[32000000]','[32080900]'),(1007020943,1,'[]','[32000000]','[32090900]'),(1007020963,1,'[]','[32000000]','[32100900]'),(1007021032,1,'[]','[32000000]','[32071000]'),(1007021042,1,'[]','[32000000]','[32081000]'),(1007021043,1,'[]','[32000000]','[32091000]'),(1007021063,1,'[]','[32000000]','[32101000]'),(1007021132,1,'[]','[32000000]','[32071100]'),(1007021142,1,'[]','[32000000]','[32081100]'),(1007021143,1,'[]','[32000000]','[32091100]'),(1007021163,1,'[]','[32000000]','[32101100]'),(1007021232,1,'[]','[32000000]','[32071200]'),(1007021242,1,'[]','[32000000]','[32081200]'),(1007021243,1,'[]','[32000000]','[32091200]'),(1007021263,1,'[]','[32000000]','[32101200]'),(1007021332,1,'[]','[32000000]','[32071300]'),(1007021342,1,'[]','[32000000]','[32081300]'),(1007021343,1,'[]','[32000000]','[32091300]'),(1007021363,1,'[]','[32000000]','[32101300]'),(1007021432,1,'[]','[32000000]','[32071400]'),(1007021442,1,'[]','[32000000]','[32081400]'),(1007021443,1,'[]','[32000000]','[32091400]'),(1007021463,1,'[]','[32000000]','[32101400]'),(1007021532,1,'[]','[32000000]','[32071500]'),(1007021542,1,'[]','[32000000]','[32081500]'),(1007021543,1,'[]','[32000000]','[32091500]'),(1007021563,1,'[]','[32000000]','[32101500]'),(1007030332,1,'[]','[33000000]','[33070300]'),(1007030342,1,'[]','[33000000]','[33080300]'),(1007030343,1,'[]','[33000000]','[33090300]'),(1007030363,1,'[]','[33000000]','[33100300]'),(1007030432,1,'[]','[33000000]','[33070400]'),(1007030442,1,'[]','[33000000]','[33080400]'),(1007030443,1,'[]','[33000000]','[33090400]'),(1007030463,1,'[]','[33000000]','[33100400]'),(1007030532,1,'[]','[33000000]','[33070500]'),(1007030542,1,'[]','[33000000]','[33080500]'),(1007030543,1,'[]','[33000000]','[33090500]'),(1007030563,1,'[]','[33000000]','[33100500]'),(1007030632,1,'[]','[33000000]','[33070600]'),(1007030642,1,'[]','[33000000]','[33080600]'),(1007030643,1,'[]','[33000000]','[33090600]'),(1007030663,1,'[]','[33000000]','[33100600]'),(1007030732,1,'[]','[33000000]','[33070700]'),(1007030742,1,'[]','[33000000]','[33080700]'),(1007030743,1,'[]','[33000000]','[33090700]'),(1007030763,1,'[]','[33000000]','[33100700]'),(1007030832,1,'[]','[33000000]','[33070800]'),(1007030842,1,'[]','[33000000]','[33080800]'),(1007030843,1,'[]','[33000000]','[33090800]'),(1007030863,1,'[]','[33000000]','[33100800]'),(1007030932,1,'[]','[33000000]','[33070900]'),(1007030942,1,'[]','[33000000]','[33080900]'),(1007030943,1,'[]','[33000000]','[33090900]'),(1007030963,1,'[]','[33000000]','[33100900]'),(1007031032,1,'[]','[33000000]','[33071000]'),(1007031042,1,'[]','[33000000]','[33081000]'),(1007031043,1,'[]','[33000000]','[33091000]'),(1007031063,1,'[]','[33000000]','[33101000]'),(1007031132,1,'[]','[33000000]','[33071100]'),(1007031142,1,'[]','[33000000]','[33081100]'),(1007031143,1,'[]','[33000000]','[33091100]'),(1007031163,1,'[]','[33000000]','[33101100]'),(1007031232,1,'[]','[33000000]','[33071200]'),(1007031242,1,'[]','[33000000]','[33081200]'),(1007031243,1,'[]','[33000000]','[33091200]'),(1007031263,1,'[]','[33000000]','[33101200]'),(1007031332,1,'[]','[33000000]','[33071300]'),(1007031342,1,'[]','[33000000]','[33081300]'),(1007031343,1,'[]','[33000000]','[33091300]'),(1007031363,1,'[]','[33000000]','[33101300]'),(1007031432,1,'[]','[33000000]','[33071400]'),(1007031442,1,'[]','[33000000]','[33081400]'),(1007031443,1,'[]','[33000000]','[33091400]'),(1007031463,1,'[]','[33000000]','[33101400]'),(1007031532,1,'[]','[33000000]','[33071500]'),(1007031542,1,'[]','[33000000]','[33081500]'),(1007031543,1,'[]','[33000000]','[33091500]'),(1007031563,1,'[]','[33000000]','[33101500]'),(1007040332,1,'[]','[34000000]','[34070300]'),(1007040342,1,'[]','[34000000]','[34080300]'),(1007040343,1,'[]','[34000000]','[34090300]'),(1007040363,1,'[]','[34000000]','[34100300]'),(1007040432,1,'[]','[34000000]','[34070400]'),(1007040442,1,'[]','[34000000]','[34080400]'),(1007040443,1,'[]','[34000000]','[34090400]'),(1007040463,1,'[]','[34000000]','[34100400]'),(1007040532,1,'[]','[34000000]','[34070500]'),(1007040542,1,'[]','[34000000]','[34080500]'),(1007040543,1,'[]','[34000000]','[34090500]'),(1007040563,1,'[]','[34000000]','[34100500]'),(1007040632,1,'[]','[34000000]','[34070600]'),(1007040642,1,'[]','[34000000]','[34080600]'),(1007040643,1,'[]','[34000000]','[34090600]'),(1007040663,1,'[]','[34000000]','[34100600]'),(1007040732,1,'[]','[34000000]','[34070700]'),(1007040742,1,'[]','[34000000]','[34080700]'),(1007040743,1,'[]','[34000000]','[34090700]'),(1007040763,1,'[]','[34000000]','[34100700]'),(1007040832,1,'[]','[34000000]','[34070800]'),(1007040842,1,'[]','[34000000]','[34080800]'),(1007040843,1,'[]','[34000000]','[34090800]'),(1007040863,1,'[]','[34000000]','[34100800]'),(1007040932,1,'[]','[34000000]','[34070900]'),(1007040942,1,'[]','[34000000]','[34080900]'),(1007040943,1,'[]','[34000000]','[34090900]'),(1007040963,1,'[]','[34000000]','[34100900]'),(1007041032,1,'[]','[34000000]','[34071000]'),(1007041042,1,'[]','[34000000]','[34081000]'),(1007041043,1,'[]','[34000000]','[34091000]'),(1007041063,1,'[]','[34000000]','[34101000]'),(1007041132,1,'[]','[34000000]','[34071100]'),(1007041142,1,'[]','[34000000]','[34081100]'),(1007041143,1,'[]','[34000000]','[34091100]'),(1007041163,1,'[]','[34000000]','[34101100]'),(1007041232,1,'[]','[34000000]','[34071200]'),(1007041242,1,'[]','[34000000]','[34081200]'),(1007041243,1,'[]','[34000000]','[34091200]'),(1007041263,1,'[]','[34000000]','[34101200]'),(1007041332,1,'[]','[34000000]','[34071300]'),(1007041342,1,'[]','[34000000]','[34081300]'),(1007041343,1,'[]','[34000000]','[34091300]'),(1007041363,1,'[]','[34000000]','[34101300]'),(1007041432,1,'[]','[34000000]','[34071400]'),(1007041442,1,'[]','[34000000]','[34081400]'),(1007041443,1,'[]','[34000000]','[34091400]'),(1007041463,1,'[]','[34000000]','[34101400]'),(1007041532,1,'[]','[34000000]','[34071500]'),(1007041542,1,'[]','[34000000]','[34081500]'),(1007041543,1,'[]','[34000000]','[34091500]'),(1007041563,1,'[]','[34000000]','[34101500]'),(1008010332,1,'[]','[31000000]','[31070300]'),(1008010342,1,'[]','[31000000]','[31080300]'),(1008010343,1,'[]','[31000000]','[31090300]'),(1008010363,1,'[]','[31000000]','[31100300]'),(1008010432,1,'[]','[31000000]','[31070400]'),(1008010442,1,'[]','[31000000]','[31080400]'),(1008010443,1,'[]','[31000000]','[31090400]'),(1008010463,1,'[]','[31000000]','[31100400]'),(1008010532,1,'[]','[31000000]','[31070500]'),(1008010542,1,'[]','[31000000]','[31080500]'),(1008010543,1,'[]','[31000000]','[31090500]'),(1008010563,1,'[]','[31000000]','[31100500]'),(1008010632,1,'[]','[31000000]','[31070600]'),(1008010642,1,'[]','[31000000]','[31080600]'),(1008010643,1,'[]','[31000000]','[31090600]'),(1008010663,1,'[]','[31000000]','[31100600]'),(1008010732,1,'[]','[31000000]','[31070700]'),(1008010742,1,'[]','[31000000]','[31080700]'),(1008010743,1,'[]','[31000000]','[31090700]'),(1008010763,1,'[]','[31000000]','[31100700]'),(1008010832,1,'[]','[31000000]','[31070800]'),(1008010842,1,'[]','[31000000]','[31080800]'),(1008010843,1,'[]','[31000000]','[31090800]'),(1008010863,1,'[]','[31000000]','[31100800]'),(1008010932,1,'[]','[31000000]','[31070900]'),(1008010942,1,'[]','[31000000]','[31080900]'),(1008010943,1,'[]','[31000000]','[31090900]'),(1008010963,1,'[]','[31000000]','[31100900]'),(1008011032,1,'[]','[31000000]','[31071000]'),(1008011042,1,'[]','[31000000]','[31081000]'),(1008011043,1,'[]','[31000000]','[31091000]'),(1008011063,1,'[]','[31000000]','[31101000]'),(1008011132,1,'[]','[31000000]','[31071100]'),(1008011142,1,'[]','[31000000]','[31081100]'),(1008011143,1,'[]','[31000000]','[31091100]'),(1008011163,1,'[]','[31000000]','[31101100]'),(1008011232,1,'[]','[31000000]','[31071200]'),(1008011242,1,'[]','[31000000]','[31081200]'),(1008011243,1,'[]','[31000000]','[31091200]'),(1008011263,1,'[]','[31000000]','[31101200]'),(1008011332,1,'[]','[31000000]','[31071300]'),(1008011342,1,'[]','[31000000]','[31081300]'),(1008011343,1,'[]','[31000000]','[31091300]'),(1008011363,1,'[]','[31000000]','[31101300]'),(1008011432,1,'[]','[31000000]','[31071400]'),(1008011442,1,'[]','[31000000]','[31081400]'),(1008011443,1,'[]','[31000000]','[31091400]'),(1008011463,1,'[]','[31000000]','[31101400]'),(1008011532,1,'[]','[31000000]','[31071500]'),(1008011542,1,'[]','[31000000]','[31081500]'),(1008011543,1,'[]','[31000000]','[31091500]'),(1008011563,1,'[]','[31000000]','[31101500]'),(1008020332,1,'[]','[32000000]','[32070300]'),(1008020342,1,'[]','[32000000]','[32080300]'),(1008020343,1,'[]','[32000000]','[32090300]'),(1008020363,1,'[]','[32000000]','[32100300]'),(1008020432,1,'[]','[32000000]','[32070400]'),(1008020442,1,'[]','[32000000]','[32080400]'),(1008020443,1,'[]','[32000000]','[32090400]'),(1008020463,1,'[]','[32000000]','[32100400]'),(1008020532,1,'[]','[32000000]','[32070500]'),(1008020542,1,'[]','[32000000]','[32080500]'),(1008020543,1,'[]','[32000000]','[32090500]'),(1008020563,1,'[]','[32000000]','[32100500]'),(1008020632,1,'[]','[32000000]','[32070600]'),(1008020642,1,'[]','[32000000]','[32080600]'),(1008020643,1,'[]','[32000000]','[32090600]'),(1008020663,1,'[]','[32000000]','[32100600]'),(1008020732,1,'[]','[32000000]','[32070700]'),(1008020742,1,'[]','[32000000]','[32080700]'),(1008020743,1,'[]','[32000000]','[32090700]'),(1008020763,1,'[]','[32000000]','[32100700]'),(1008020832,1,'[]','[32000000]','[32070800]'),(1008020842,1,'[]','[32000000]','[32080800]'),(1008020843,1,'[]','[32000000]','[32090800]'),(1008020863,1,'[]','[32000000]','[32100800]'),(1008020932,1,'[]','[32000000]','[32070900]'),(1008020942,1,'[]','[32000000]','[32080900]'),(1008020943,1,'[]','[32000000]','[32090900]'),(1008020963,1,'[]','[32000000]','[32100900]'),(1008021032,1,'[]','[32000000]','[32071000]'),(1008021042,1,'[]','[32000000]','[32081000]'),(1008021043,1,'[]','[32000000]','[32091000]'),(1008021063,1,'[]','[32000000]','[32101000]'),(1008021132,1,'[]','[32000000]','[32071100]'),(1008021142,1,'[]','[32000000]','[32081100]'),(1008021143,1,'[]','[32000000]','[32091100]'),(1008021163,1,'[]','[32000000]','[32101100]'),(1008021232,1,'[]','[32000000]','[32071200]'),(1008021242,1,'[]','[32000000]','[32081200]'),(1008021243,1,'[]','[32000000]','[32091200]'),(1008021263,1,'[]','[32000000]','[32101200]'),(1008021332,1,'[]','[32000000]','[32071300]'),(1008021342,1,'[]','[32000000]','[32081300]'),(1008021343,1,'[]','[32000000]','[32091300]'),(1008021363,1,'[]','[32000000]','[32101300]'),(1008021432,1,'[]','[32000000]','[32071400]'),(1008021442,1,'[]','[32000000]','[32081400]'),(1008021443,1,'[]','[32000000]','[32091400]'),(1008021463,1,'[]','[32000000]','[32101400]'),(1008021532,1,'[]','[32000000]','[32071500]'),(1008021542,1,'[]','[32000000]','[32081500]'),(1008021543,1,'[]','[32000000]','[32091500]'),(1008021563,1,'[]','[32000000]','[32101500]'),(1008030332,1,'[]','[33000000]','[33070300]'),(1008030342,1,'[]','[33000000]','[33080300]'),(1008030343,1,'[]','[33000000]','[33090300]'),(1008030363,1,'[]','[33000000]','[33100300]'),(1008030432,1,'[]','[33000000]','[33070400]'),(1008030442,1,'[]','[33000000]','[33080400]'),(1008030443,1,'[]','[33000000]','[33090400]'),(1008030463,1,'[]','[33000000]','[33100400]'),(1008030532,1,'[]','[33000000]','[33070500]'),(1008030542,1,'[]','[33000000]','[33080500]'),(1008030543,1,'[]','[33000000]','[33090500]'),(1008030563,1,'[]','[33000000]','[33100500]'),(1008030632,1,'[]','[33000000]','[33070600]'),(1008030642,1,'[]','[33000000]','[33080600]'),(1008030643,1,'[]','[33000000]','[33090600]'),(1008030663,1,'[]','[33000000]','[33100600]'),(1008030732,1,'[]','[33000000]','[33070700]'),(1008030742,1,'[]','[33000000]','[33080700]'),(1008030743,1,'[]','[33000000]','[33090700]'),(1008030763,1,'[]','[33000000]','[33100700]'),(1008030832,1,'[]','[33000000]','[33070800]'),(1008030842,1,'[]','[33000000]','[33080800]'),(1008030843,1,'[]','[33000000]','[33090800]'),(1008030863,1,'[]','[33000000]','[33100800]'),(1008030932,1,'[]','[33000000]','[33070900]'),(1008030942,1,'[]','[33000000]','[33080900]'),(1008030943,1,'[]','[33000000]','[33090900]'),(1008030963,1,'[]','[33000000]','[33100900]'),(1008031032,1,'[]','[33000000]','[33071000]'),(1008031042,1,'[]','[33000000]','[33081000]'),(1008031043,1,'[]','[33000000]','[33091000]'),(1008031063,1,'[]','[33000000]','[33101000]'),(1008031132,1,'[]','[33000000]','[33071100]'),(1008031142,1,'[]','[33000000]','[33081100]'),(1008031143,1,'[]','[33000000]','[33091100]'),(1008031163,1,'[]','[33000000]','[33101100]'),(1008031232,1,'[]','[33000000]','[33071200]'),(1008031242,1,'[]','[33000000]','[33081200]'),(1008031243,1,'[]','[33000000]','[33091200]'),(1008031263,1,'[]','[33000000]','[33101200]'),(1008031332,1,'[]','[33000000]','[33071300]'),(1008031342,1,'[]','[33000000]','[33081300]'),(1008031343,1,'[]','[33000000]','[33091300]'),(1008031363,1,'[]','[33000000]','[33101300]'),(1008031432,1,'[]','[33000000]','[33071400]'),(1008031442,1,'[]','[33000000]','[33081400]'),(1008031443,1,'[]','[33000000]','[33091400]'),(1008031463,1,'[]','[33000000]','[33101400]'),(1008031532,1,'[]','[33000000]','[33071500]'),(1008031542,1,'[]','[33000000]','[33081500]'),(1008031543,1,'[]','[33000000]','[33091500]'),(1008031563,1,'[]','[33000000]','[33101500]'),(1008040332,1,'[]','[34000000]','[34070300]'),(1008040342,1,'[]','[34000000]','[34080300]'),(1008040343,1,'[]','[34000000]','[34090300]'),(1008040363,1,'[]','[34000000]','[34100300]'),(1008040432,1,'[]','[34000000]','[34070400]'),(1008040442,1,'[]','[34000000]','[34080400]'),(1008040443,1,'[]','[34000000]','[34090400]'),(1008040463,1,'[]','[34000000]','[34100400]'),(1008040532,1,'[]','[34000000]','[34070500]'),(1008040542,1,'[]','[34000000]','[34080500]'),(1008040543,1,'[]','[34000000]','[34090500]'),(1008040563,1,'[]','[34000000]','[34100500]'),(1008040632,1,'[]','[34000000]','[34070600]'),(1008040642,1,'[]','[34000000]','[34080600]'),(1008040643,1,'[]','[34000000]','[34090600]'),(1008040663,1,'[]','[34000000]','[34100600]'),(1008040732,1,'[]','[34000000]','[34070700]'),(1008040742,1,'[]','[34000000]','[34080700]'),(1008040743,1,'[]','[34000000]','[34090700]'),(1008040763,1,'[]','[34000000]','[34100700]'),(1008040832,1,'[]','[34000000]','[34070800]'),(1008040842,1,'[]','[34000000]','[34080800]'),(1008040843,1,'[]','[34000000]','[34090800]'),(1008040863,1,'[]','[34000000]','[34100800]'),(1008040932,1,'[]','[34000000]','[34070900]'),(1008040942,1,'[]','[34000000]','[34080900]'),(1008040943,1,'[]','[34000000]','[34090900]'),(1008040963,1,'[]','[34000000]','[34100900]'),(1008041032,1,'[]','[34000000]','[34071000]'),(1008041042,1,'[]','[34000000]','[34081000]'),(1008041043,1,'[]','[34000000]','[34091000]'),(1008041063,1,'[]','[34000000]','[34101000]'),(1008041132,1,'[]','[34000000]','[34071100]'),(1008041142,1,'[]','[34000000]','[34081100]'),(1008041143,1,'[]','[34000000]','[34091100]'),(1008041163,1,'[]','[34000000]','[34101100]'),(1008041232,1,'[]','[34000000]','[34071200]'),(1008041242,1,'[]','[34000000]','[34081200]'),(1008041243,1,'[]','[34000000]','[34091200]'),(1008041263,1,'[]','[34000000]','[34101200]'),(1008041332,1,'[]','[34000000]','[34071300]'),(1008041342,1,'[]','[34000000]','[34081300]'),(1008041343,1,'[]','[34000000]','[34091300]'),(1008041363,1,'[]','[34000000]','[34101300]'),(1008041432,1,'[]','[34000000]','[34071400]'),(1008041442,1,'[]','[34000000]','[34081400]'),(1008041443,1,'[]','[34000000]','[34091400]'),(1008041463,1,'[]','[34000000]','[34101400]'),(1008041532,1,'[]','[34000000]','[34071500]'),(1008041542,1,'[]','[34000000]','[34081500]'),(1008041543,1,'[]','[34000000]','[34091500]'),(1008041563,1,'[]','[34000000]','[34101500]'),(1009000332,1,'[]','[31000000]','[31070300]'),(1009000342,1,'[]','[31000000]','[31080300]'),(1009000343,1,'[]','[31000000]','[31090300]'),(1009000363,1,'[]','[31000000]','[31100300]'),(1009000432,1,'[]','[31000000]','[31070400]'),(1009000442,1,'[]','[31000000]','[31080400]'),(1009000443,1,'[]','[31000000]','[31090400]'),(1009000463,1,'[]','[31000000]','[31100400]'),(1009000532,1,'[]','[31000000]','[31070500]'),(1009000542,1,'[]','[31000000]','[31080500]'),(1009000543,1,'[]','[31000000]','[31090500]'),(1009000563,1,'[]','[31000000]','[31100500]'),(1009000632,1,'[]','[31000000]','[31070600]'),(1009000642,1,'[]','[31000000]','[31080600]'),(1009000643,1,'[]','[31000000]','[31090600]'),(1009000663,1,'[]','[31000000]','[31100600]'),(1009000732,1,'[]','[31000000]','[31070700]'),(1009000742,1,'[]','[31000000]','[31080700]'),(1009000743,1,'[]','[31000000]','[31090700]'),(1009000763,1,'[]','[31000000]','[31100700]'),(1009000832,1,'[]','[31000000]','[31070800]'),(1009000842,1,'[]','[31000000]','[31080800]'),(1009000843,1,'[]','[31000000]','[31090800]'),(1009000863,1,'[]','[31000000]','[31100800]'),(1009000932,1,'[]','[31000000]','[31070900]'),(1009000942,1,'[]','[31000000]','[31080900]'),(1009000943,1,'[]','[31000000]','[31090900]'),(1009000963,1,'[]','[31000000]','[31100900]'),(1009001032,1,'[]','[31000000]','[31071000]'),(1009001042,1,'[]','[31000000]','[31081000]'),(1009001043,1,'[]','[31000000]','[31091000]'),(1009001063,1,'[]','[31000000]','[31101000]'),(1009001132,1,'[]','[31000000]','[31071100]'),(1009001142,1,'[]','[31000000]','[31081100]'),(1009001143,1,'[]','[31000000]','[31091100]'),(1009001163,1,'[]','[31000000]','[31101100]'),(1009001232,1,'[]','[31000000]','[31071200]'),(1009001242,1,'[]','[31000000]','[31081200]'),(1009001243,1,'[]','[31000000]','[31091200]'),(1009001263,1,'[]','[31000000]','[31101200]'),(1009001332,1,'[]','[31000000]','[31071300]'),(1009001342,1,'[]','[31000000]','[31081300]'),(1009001343,1,'[]','[31000000]','[31091300]'),(1009001363,1,'[]','[31000000]','[31101300]'),(1009001432,1,'[]','[31000000]','[31071400]'),(1009001442,1,'[]','[31000000]','[31081400]'),(1009001443,1,'[]','[31000000]','[31091400]'),(1009001463,1,'[]','[31000000]','[31101400]'),(1009001532,1,'[]','[31000000]','[31071500]'),(1009001542,1,'[]','[31000000]','[31081500]'),(1009001543,1,'[]','[31000000]','[31091500]'),(1009001563,1,'[]','[31000000]','[31101500]'),(1010010332,1,'[]','[31000000]','[31070300]'),(1010010342,1,'[]','[31000000]','[31080300]'),(1010010343,1,'[]','[31000000]','[31090300]'),(1010010363,1,'[]','[31000000]','[31100300]'),(1010010432,1,'[]','[31000000]','[31070400]'),(1010010442,1,'[]','[31000000]','[31080400]'),(1010010443,1,'[]','[31000000]','[31090400]'),(1010010463,1,'[]','[31000000]','[31100400]'),(1010010532,1,'[]','[31000000]','[31070500]'),(1010010542,1,'[]','[31000000]','[31080500]'),(1010010543,1,'[]','[31000000]','[31090500]'),(1010010563,1,'[]','[31000000]','[31100500]'),(1010010632,1,'[]','[31000000]','[31070600]'),(1010010642,1,'[]','[31000000]','[31080600]'),(1010010643,1,'[]','[31000000]','[31090600]'),(1010010663,1,'[]','[31000000]','[31100600]'),(1010010732,1,'[]','[31000000]','[31070700]'),(1010010742,1,'[]','[31000000]','[31080700]'),(1010010743,1,'[]','[31000000]','[31090700]'),(1010010763,1,'[]','[31000000]','[31100700]'),(1010010832,1,'[]','[31000000]','[31070800]'),(1010010842,1,'[]','[31000000]','[31080800]'),(1010010843,1,'[]','[31000000]','[31090800]'),(1010010863,1,'[]','[31000000]','[31100800]'),(1010010932,1,'[]','[31000000]','[31070900]'),(1010010942,1,'[]','[31000000]','[31080900]'),(1010010943,1,'[]','[31000000]','[31090900]'),(1010010963,1,'[]','[31000000]','[31100900]'),(1010011032,1,'[]','[31000000]','[31071000]'),(1010011042,1,'[]','[31000000]','[31081000]'),(1010011043,1,'[]','[31000000]','[31091000]'),(1010011063,1,'[]','[31000000]','[31101000]'),(1010011132,1,'[]','[31000000]','[31071100]'),(1010011142,1,'[]','[31000000]','[31081100]'),(1010011143,1,'[]','[31000000]','[31091100]'),(1010011163,1,'[]','[31000000]','[31101100]'),(1010011232,1,'[]','[31000000]','[31071200]'),(1010011242,1,'[]','[31000000]','[31081200]'),(1010011243,1,'[]','[31000000]','[31091200]'),(1010011263,1,'[]','[31000000]','[31101200]'),(1010011332,1,'[]','[31000000]','[31071300]'),(1010011342,1,'[]','[31000000]','[31081300]'),(1010011343,1,'[]','[31000000]','[31091300]'),(1010011363,1,'[]','[31000000]','[31101300]'),(1010011432,1,'[]','[31000000]','[31071400]'),(1010011442,1,'[]','[31000000]','[31081400]'),(1010011443,1,'[]','[31000000]','[31091400]'),(1010011463,1,'[]','[31000000]','[31101400]'),(1010011532,1,'[]','[31000000]','[31071500]'),(1010011542,1,'[]','[31000000]','[31081500]'),(1010011543,1,'[]','[31000000]','[31091500]'),(1010011563,1,'[]','[31000000]','[31101500]'),(1010020332,1,'[]','[32000000]','[32070300]'),(1010020342,1,'[]','[32000000]','[32080300]'),(1010020343,1,'[]','[32000000]','[32090300]'),(1010020363,1,'[]','[32000000]','[32100300]'),(1010020432,1,'[]','[32000000]','[32070400]'),(1010020442,1,'[]','[32000000]','[32080400]'),(1010020443,1,'[]','[32000000]','[32090400]'),(1010020463,1,'[]','[32000000]','[32100400]'),(1010020532,1,'[]','[32000000]','[32070500]'),(1010020542,1,'[]','[32000000]','[32080500]'),(1010020543,1,'[]','[32000000]','[32090500]'),(1010020563,1,'[]','[32000000]','[32100500]'),(1010020632,1,'[]','[32000000]','[32070600]'),(1010020642,1,'[]','[32000000]','[32080600]'),(1010020643,1,'[]','[32000000]','[32090600]'),(1010020663,1,'[]','[32000000]','[32100600]'),(1010020732,1,'[]','[32000000]','[32070700]'),(1010020742,1,'[]','[32000000]','[32080700]'),(1010020743,1,'[]','[32000000]','[32090700]'),(1010020763,1,'[]','[32000000]','[32100700]'),(1010020832,1,'[]','[32000000]','[32070800]'),(1010020842,1,'[]','[32000000]','[32080800]'),(1010020843,1,'[]','[32000000]','[32090800]'),(1010020863,1,'[]','[32000000]','[32100800]'),(1010020932,1,'[]','[32000000]','[32070900]'),(1010020942,1,'[]','[32000000]','[32080900]'),(1010020943,1,'[]','[32000000]','[32090900]'),(1010020963,1,'[]','[32000000]','[32100900]'),(1010021032,1,'[]','[32000000]','[32071000]'),(1010021042,1,'[]','[32000000]','[32081000]'),(1010021043,1,'[]','[32000000]','[32091000]'),(1010021063,1,'[]','[32000000]','[32101000]'),(1010021132,1,'[]','[32000000]','[32071100]'),(1010021142,1,'[]','[32000000]','[32081100]'),(1010021143,1,'[]','[32000000]','[32091100]'),(1010021163,1,'[]','[32000000]','[32101100]'),(1010021232,1,'[]','[32000000]','[32071200]'),(1010021242,1,'[]','[32000000]','[32081200]'),(1010021243,1,'[]','[32000000]','[32091200]'),(1010021263,1,'[]','[32000000]','[32101200]'),(1010021332,1,'[]','[32000000]','[32071300]'),(1010021342,1,'[]','[32000000]','[32081300]'),(1010021343,1,'[]','[32000000]','[32091300]'),(1010021363,1,'[]','[32000000]','[32101300]'),(1010021432,1,'[]','[32000000]','[32071400]'),(1010021442,1,'[]','[32000000]','[32081400]'),(1010021443,1,'[]','[32000000]','[32091400]'),(1010021463,1,'[]','[32000000]','[32101400]'),(1010021532,1,'[]','[32000000]','[32071500]'),(1010021542,1,'[]','[32000000]','[32081500]'),(1010021543,1,'[]','[32000000]','[32091500]'),(1010021563,1,'[]','[32000000]','[32101500]'),(1010030332,1,'[]','[33000000]','[33070300]'),(1010030342,1,'[]','[33000000]','[33080300]'),(1010030343,1,'[]','[33000000]','[33090300]'),(1010030363,1,'[]','[33000000]','[33100300]'),(1010030432,1,'[]','[33000000]','[33070400]'),(1010030442,1,'[]','[33000000]','[33080400]'),(1010030443,1,'[]','[33000000]','[33090400]'),(1010030463,1,'[]','[33000000]','[33100400]'),(1010030532,1,'[]','[33000000]','[33070500]'),(1010030542,1,'[]','[33000000]','[33080500]'),(1010030543,1,'[]','[33000000]','[33090500]'),(1010030563,1,'[]','[33000000]','[33100500]'),(1010030632,1,'[]','[33000000]','[33070600]'),(1010030642,1,'[]','[33000000]','[33080600]'),(1010030643,1,'[]','[33000000]','[33090600]'),(1010030663,1,'[]','[33000000]','[33100600]'),(1010030732,1,'[]','[33000000]','[33070700]'),(1010030742,1,'[]','[33000000]','[33080700]'),(1010030743,1,'[]','[33000000]','[33090700]'),(1010030763,1,'[]','[33000000]','[33100700]'),(1010030832,1,'[]','[33000000]','[33070800]'),(1010030842,1,'[]','[33000000]','[33080800]'),(1010030843,1,'[]','[33000000]','[33090800]'),(1010030863,1,'[]','[33000000]','[33100800]'),(1010030932,1,'[]','[33000000]','[33070900]'),(1010030942,1,'[]','[33000000]','[33080900]'),(1010030943,1,'[]','[33000000]','[33090900]'),(1010030963,1,'[]','[33000000]','[33100900]'),(1010031032,1,'[]','[33000000]','[33071000]'),(1010031042,1,'[]','[33000000]','[33081000]'),(1010031043,1,'[]','[33000000]','[33091000]'),(1010031063,1,'[]','[33000000]','[33101000]'),(1010031132,1,'[]','[33000000]','[33071100]'),(1010031142,1,'[]','[33000000]','[33081100]'),(1010031143,1,'[]','[33000000]','[33091100]'),(1010031163,1,'[]','[33000000]','[33101100]'),(1010031232,1,'[]','[33000000]','[33071200]'),(1010031242,1,'[]','[33000000]','[33081200]'),(1010031243,1,'[]','[33000000]','[33091200]'),(1010031263,1,'[]','[33000000]','[33101200]'),(1010031332,1,'[]','[33000000]','[33071300]'),(1010031342,1,'[]','[33000000]','[33081300]'),(1010031343,1,'[]','[33000000]','[33091300]'),(1010031363,1,'[]','[33000000]','[33101300]'),(1010031432,1,'[]','[33000000]','[33071400]'),(1010031442,1,'[]','[33000000]','[33081400]'),(1010031443,1,'[]','[33000000]','[33091400]'),(1010031463,1,'[]','[33000000]','[33101400]'),(1010031532,1,'[]','[33000000]','[33071500]'),(1010031542,1,'[]','[33000000]','[33081500]'),(1010031543,1,'[]','[33000000]','[33091500]'),(1010031563,1,'[]','[33000000]','[33101500]'),(1010040332,1,'[]','[34000000]','[34070300]'),(1010040342,1,'[]','[34000000]','[34080300]'),(1010040343,1,'[]','[34000000]','[34090300]'),(1010040363,1,'[]','[34000000]','[34100300]'),(1010040432,1,'[]','[34000000]','[34070400]'),(1010040442,1,'[]','[34000000]','[34080400]'),(1010040443,1,'[]','[34000000]','[34090400]'),(1010040463,1,'[]','[34000000]','[34100400]'),(1010040532,1,'[]','[34000000]','[34070500]'),(1010040542,1,'[]','[34000000]','[34080500]'),(1010040543,1,'[]','[34000000]','[34090500]'),(1010040563,1,'[]','[34000000]','[34100500]'),(1010040632,1,'[]','[34000000]','[34070600]'),(1010040642,1,'[]','[34000000]','[34080600]'),(1010040643,1,'[]','[34000000]','[34090600]'),(1010040663,1,'[]','[34000000]','[34100600]'),(1010040732,1,'[]','[34000000]','[34070700]'),(1010040742,1,'[]','[34000000]','[34080700]'),(1010040743,1,'[]','[34000000]','[34090700]'),(1010040763,1,'[]','[34000000]','[34100700]'),(1010040832,1,'[]','[34000000]','[34070800]'),(1010040842,1,'[]','[34000000]','[34080800]'),(1010040843,1,'[]','[34000000]','[34090800]'),(1010040863,1,'[]','[34000000]','[34100800]'),(1010040932,1,'[]','[34000000]','[34070900]'),(1010040942,1,'[]','[34000000]','[34080900]'),(1010040943,1,'[]','[34000000]','[34090900]'),(1010040963,1,'[]','[34000000]','[34100900]'),(1010041032,1,'[]','[34000000]','[34071000]'),(1010041042,1,'[]','[34000000]','[34081000]'),(1010041043,1,'[]','[34000000]','[34091000]'),(1010041063,1,'[]','[34000000]','[34101000]'),(1010041132,1,'[]','[34000000]','[34071100]'),(1010041142,1,'[]','[34000000]','[34081100]'),(1010041143,1,'[]','[34000000]','[34091100]'),(1010041163,1,'[]','[34000000]','[34101100]'),(1010041232,1,'[]','[34000000]','[34071200]'),(1010041242,1,'[]','[34000000]','[34081200]'),(1010041243,1,'[]','[34000000]','[34091200]'),(1010041263,1,'[]','[34000000]','[34101200]'),(1010041332,1,'[]','[34000000]','[34071300]'),(1010041342,1,'[]','[34000000]','[34081300]'),(1010041343,1,'[]','[34000000]','[34091300]'),(1010041363,1,'[]','[34000000]','[34101300]'),(1010041432,1,'[]','[34000000]','[34071400]'),(1010041442,1,'[]','[34000000]','[34081400]'),(1010041443,1,'[]','[34000000]','[34091400]'),(1010041463,1,'[]','[34000000]','[34101400]'),(1010041532,1,'[]','[34000000]','[34071500]'),(1010041542,1,'[]','[34000000]','[34081500]'),(1010041543,1,'[]','[34000000]','[34091500]'),(1010041563,1,'[]','[34000000]','[34101500]'),(1011000001,2,'[]','[50000000]','[59000008]'),(1011000002,2,'[]','[50000000]','[59000009]'),(1011000003,2,'[]','[50000000]','[59000008]'),(1011000004,2,'[]','[50000000]','[59000009]');
/*!40000 ALTER TABLE `base_goods_compose_index` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_goods_decompose`
--

DROP TABLE IF EXISTS `base_goods_decompose`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_goods_decompose` (
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品id',
  `module` smallint(1) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `irregular_num` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '随机材料种类',
  `irregular_mat` varchar(255) NOT NULL DEFAULT '[]' COMMENT '随机材料',
  `regular_num` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '固定材料种类',
  `regular_mat` varchar(255) NOT NULL DEFAULT '[]' COMMENT '固定材料[{goods,id,num}]',
  PRIMARY KEY (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品分解配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_goods_decompose`
--

LOCK TABLES `base_goods_decompose` WRITE;
/*!40000 ALTER TABLE `base_goods_decompose` DISABLE KEYS */;
INSERT INTO `base_goods_decompose` VALUES (5201010,181,0,'[]',1,'[{255,36160007,520}]'),(5201011,181,0,'[]',1,'[{255,36160007,820}]'),(5201012,181,0,'[]',1,'[{255,36160007,1470}]'),(5201013,181,0,'[]',1,'[{255,36160007,2080}]'),(5201014,181,0,'[]',1,'[{255,36160007,3030}]'),(5201020,181,0,'[]',1,'[{255,36160007,520}]'),(5201021,181,0,'[]',1,'[{255,36160007,820}]'),(5201022,181,0,'[]',1,'[{255,36160007,1470}]'),(5201023,181,0,'[]',1,'[{255,36160007,2080}]'),(5201024,181,0,'[]',1,'[{255,36160007,3030}]'),(5201030,181,0,'[]',1,'[{255,36160007,520}]'),(5201031,181,0,'[]',1,'[{255,36160007,820}]'),(5201032,181,0,'[]',1,'[{255,36160007,1470}]'),(5201033,181,0,'[]',1,'[{255,36160007,2080}]'),(5201034,181,0,'[]',1,'[{255,36160007,3030}]'),(5201040,181,0,'[]',1,'[{255,36160007,520}]'),(5201041,181,0,'[]',1,'[{255,36160007,820}]'),(5201042,181,0,'[]',1,'[{255,36160007,1470}]'),(5201043,181,0,'[]',1,'[{255,36160007,2080}]'),(5201044,181,0,'[]',1,'[{255,36160007,3030}]'),(5201050,181,0,'[]',1,'[{255,36160007,520}]'),(5201051,181,0,'[]',1,'[{255,36160007,820}]'),(5201052,181,0,'[]',1,'[{255,36160007,1470}]'),(5201053,181,0,'[]',1,'[{255,36160007,2080}]'),(5201054,181,0,'[]',1,'[{255,36160007,3030}]'),(5201060,181,0,'[]',1,'[{255,36160007,520}]'),(5201061,181,0,'[]',1,'[{255,36160007,820}]'),(5201062,181,0,'[]',1,'[{255,36160007,1470}]'),(5201063,181,0,'[]',1,'[{255,36160007,2080}]'),(5201064,181,0,'[]',1,'[{255,36160007,3030}]'),(5201070,181,0,'[]',1,'[{255,36160007,520}]'),(5201071,181,0,'[]',1,'[{255,36160007,820}]'),(5201072,181,0,'[]',1,'[{255,36160007,1470}]'),(5201073,181,0,'[]',1,'[{255,36160007,2080}]'),(5201074,181,0,'[]',1,'[{255,36160007,3030}]'),(5201080,181,0,'[]',1,'[{255,36160007,520}]'),(5201081,181,0,'[]',1,'[{255,36160007,820}]'),(5201082,181,0,'[]',1,'[{255,36160007,1470}]'),(5201083,181,0,'[]',1,'[{255,36160007,2080}]'),(5201084,181,0,'[]',1,'[{255,36160007,3030}]'),(5201090,181,0,'[]',1,'[{255,36160007,520}]'),(5201091,181,0,'[]',1,'[{255,36160007,820}]'),(5201092,181,0,'[]',1,'[{255,36160007,1470}]'),(5201093,181,0,'[]',1,'[{255,36160007,2080}]'),(5201094,181,0,'[]',1,'[{255,36160007,3030}]'),(5201100,181,0,'[]',1,'[{255,36160007,520}]'),(5201101,181,0,'[]',1,'[{255,36160007,820}]'),(5201102,181,0,'[]',1,'[{255,36160007,1470}]'),(5201103,181,0,'[]',1,'[{255,36160007,2080}]'),(5201104,181,0,'[]',1,'[{255,36160007,3030}]'),(5201140,181,0,'[]',1,'[{255,36160007,520}]'),(5201141,181,0,'[]',1,'[{255,36160007,820}]'),(5201142,181,0,'[]',1,'[{255,36160007,1470}]'),(5201143,181,0,'[]',1,'[{255,36160007,2080}]'),(5201144,181,0,'[]',1,'[{255,36160007,3030}]'),(5201150,181,0,'[]',1,'[{255,36160007,520}]'),(5201151,181,0,'[]',1,'[{255,36160007,820}]'),(5201152,181,0,'[]',1,'[{255,36160007,1470}]'),(5201153,181,0,'[]',1,'[{255,36160007,2080}]'),(5201154,181,0,'[]',1,'[{255,36160007,3030}]'),(5201160,181,0,'[]',1,'[{255,36160007,520}]'),(5201161,181,0,'[]',1,'[{255,36160007,820}]'),(5201162,181,0,'[]',1,'[{255,36160007,1470}]'),(5201163,181,0,'[]',1,'[{255,36160007,2080}]'),(5201164,181,0,'[]',1,'[{255,36160007,3030}]'),(5201170,181,0,'[]',1,'[{255,36160007,520}]'),(5201171,181,0,'[]',1,'[{255,36160007,820}]'),(5201172,181,0,'[]',1,'[{255,36160007,1470}]'),(5201173,181,0,'[]',1,'[{255,36160007,2080}]'),(5201174,181,0,'[]',1,'[{255,36160007,3030}]'),(5201180,181,0,'[]',1,'[{255,36160007,520}]'),(5201181,181,0,'[]',1,'[{255,36160007,820}]'),(5201182,181,0,'[]',1,'[{255,36160007,1470}]'),(5201183,181,0,'[]',1,'[{255,36160007,2080}]'),(5201184,181,0,'[]',1,'[{255,36160007,3030}]'),(5201190,181,0,'[]',1,'[{255,36160007,520}]'),(5201191,181,0,'[]',1,'[{255,36160007,820}]'),(5201192,181,0,'[]',1,'[{255,36160007,1470}]'),(5201193,181,0,'[]',1,'[{255,36160007,2080}]'),(5201194,181,0,'[]',1,'[{255,36160007,3030}]'),(5203001,181,0,'[]',1,'[{255,36160007,500}]'),(5203002,181,0,'[]',1,'[{255,36160007,1000}]'),(5203003,181,0,'[]',1,'[{255,36160007,2000}]'),(5203004,181,0,'[]',1,'[{255,36160007,5000}]'),(5203005,181,0,'[]',1,'[{255,36160007,10000}]'),(5206313,181,0,'[]',3,'[{0,5201153,1},{0,5201013,1},{0,5204001,800}]'),(5206314,181,0,'[]',3,'[{0,5201154,1},{0,5201014,1},{0,5204001,2400}]'),(5206323,181,0,'[]',3,'[{0,5201173,1},{0,5201023,1},{0,5204001,600}]'),(5206324,181,0,'[]',3,'[{0,5201174,1},{0,5201024,1},{0,5204001,1800}]'),(5206333,181,0,'[]',3,'[{0,5201163,1},{0,5201033,1},{0,5204001,1200}]'),(5206334,181,0,'[]',3,'[{0,5201164,1},{0,5201034,1},{0,5204001,3600}]'),(5206343,181,0,'[]',3,'[{0,5201183,1},{0,5201043,1},{0,5204001,1000}]'),(5206344,181,0,'[]',3,'[{0,5201184,1},{0,5201044,1},{0,5204001,3000}]'),(5206353,181,0,'[]',3,'[{0,5201053,1},{0,5201193,1},{0,5204001,1500}]'),(5206354,181,0,'[]',3,'[{0,5201054,1},{0,5201194,1},{0,5204001,4500}]'),(5206363,181,0,'[]',3,'[{0,5201143,1},{0,5201063,1},{0,5204001,400}]'),(5206364,181,0,'[]',3,'[{0,5201144,1},{0,5201064,1},{0,5204001,1200}]'),(5206373,181,0,'[]',3,'[{0,5201093,1},{0,5201073,1},{0,5204001,1400}]'),(5206374,181,0,'[]',3,'[{0,5201094,1},{0,5201074,1},{0,5204001,4200}]'),(5206383,181,0,'[]',3,'[{0,5201103,1},{0,5201083,1},{0,5204001,1600}]'),(5206384,181,0,'[]',3,'[{0,5201104,1},{0,5201084,1},{0,5204001,4800}]'),(12010001,413,0,'[]',1,'[{9,12060001,666}]'),(12010002,413,0,'[]',1,'[{9,12060001,288}]'),(12010003,413,0,'[]',1,'[{9,12060001,300}]'),(12010004,413,0,'[]',1,'[{9,12060001,288}]'),(12010005,413,0,'[]',1,'[{9,12060001,488}]'),(12010006,413,0,'[]',1,'[{9,12060001,388}]'),(12010007,413,0,'[]',1,'[{9,12060001,388}]'),(12010008,413,0,'[]',1,'[{9,12060001,588}]'),(12020001,413,0,'[]',1,'[{9,12060002,666}]'),(12020002,413,0,'[]',1,'[{9,12060002,288}]'),(12020003,413,0,'[]',1,'[{9,12060002,300}]'),(12020004,413,0,'[]',1,'[{9,12060002,288}]'),(12020005,413,0,'[]',1,'[{9,12060002,488}]'),(12020006,413,0,'[]',1,'[{9,12060002,388}]'),(12020007,413,0,'[]',1,'[{9,12060002,388}]'),(12020008,413,0,'[]',1,'[{9,12060002,588}]'),(12030001,413,0,'[]',1,'[{9,12060003,666}]'),(12030002,413,0,'[]',1,'[{9,12060003,288}]'),(12030003,413,0,'[]',1,'[{9,12060003,300}]'),(12030004,413,0,'[]',1,'[{9,12060003,288}]'),(12030005,413,0,'[]',1,'[{9,12060003,488}]'),(12030006,413,0,'[]',1,'[{9,12060003,388}]'),(12030007,413,0,'[]',1,'[{9,12060003,388}]'),(12030008,413,0,'[]',1,'[{9,12060003,588}]'),(12040001,413,0,'[]',1,'[{9,12060004,666}]'),(12040002,413,0,'[]',1,'[{9,12060004,288}]'),(12040003,413,0,'[]',1,'[{9,12060004,300}]'),(12040004,413,0,'[]',1,'[{9,12060004,288}]'),(12040005,413,0,'[]',1,'[{9,12060004,488}]'),(12040006,413,0,'[]',1,'[{9,12060004,388}]'),(12040007,413,0,'[]',1,'[{9,12060004,388}]'),(12040008,413,0,'[]',1,'[{9,12060004,588}]'),(1001010753,152,0,'[]',1,'[{0,38280520,2}]'),(1001010853,152,0,'[]',1,'[{0,38280520,4}]'),(1001010953,152,0,'[]',1,'[{0,38280520,6}]'),(1001011053,152,0,'[]',1,'[{0,38280520,8}]'),(1001011153,152,0,'[]',1,'[{0,38280520,12}]'),(1001011253,152,0,'[]',1,'[{0,38280520,16}]'),(1001011353,152,0,'[]',1,'[{0,38280520,20}]'),(1001011453,152,0,'[]',1,'[{0,38280520,25}]'),(1001011553,152,0,'[]',1,'[{0,38280520,30}]'),(1001011653,152,0,'[]',1,'[{0,38280520,35}]'),(1001020753,152,0,'[]',1,'[{0,38280520,2}]'),(1001020853,152,0,'[]',1,'[{0,38280520,4}]'),(1001020953,152,0,'[]',1,'[{0,38280520,6}]'),(1001021053,152,0,'[]',1,'[{0,38280520,8}]'),(1001021153,152,0,'[]',1,'[{0,38280520,12}]'),(1001021253,152,0,'[]',1,'[{0,38280520,16}]'),(1001021353,152,0,'[]',1,'[{0,38280520,20}]'),(1001021453,152,0,'[]',1,'[{0,38280520,25}]'),(1001021553,152,0,'[]',1,'[{0,38280520,30}]'),(1001021653,152,0,'[]',1,'[{0,38280520,35}]'),(1001030753,152,0,'[]',1,'[{0,38280520,2}]'),(1001030853,152,0,'[]',1,'[{0,38280520,4}]'),(1001030953,152,0,'[]',1,'[{0,38280520,6}]'),(1001031053,152,0,'[]',1,'[{0,38280520,8}]'),(1001031153,152,0,'[]',1,'[{0,38280520,12}]'),(1001031253,152,0,'[]',1,'[{0,38280520,16}]'),(1001031353,152,0,'[]',1,'[{0,38280520,20}]'),(1001031453,152,0,'[]',1,'[{0,38280520,25}]'),(1001031553,152,0,'[]',1,'[{0,38280520,30}]'),(1001031653,152,0,'[]',1,'[{0,38280520,35}]'),(1001040753,152,0,'[]',1,'[{0,38280520,2}]'),(1001040853,152,0,'[]',1,'[{0,38280520,4}]'),(1001040953,152,0,'[]',1,'[{0,38280520,6}]'),(1001041053,152,0,'[]',1,'[{0,38280520,8}]'),(1001041153,152,0,'[]',1,'[{0,38280520,12}]'),(1001041253,152,0,'[]',1,'[{0,38280520,16}]'),(1001041353,152,0,'[]',1,'[{0,38280520,20}]'),(1001041453,152,0,'[]',1,'[{0,38280520,25}]'),(1001041553,152,0,'[]',1,'[{0,38280520,30}]'),(1001041653,152,0,'[]',1,'[{0,38280520,35}]'),(1002010753,152,0,'[]',1,'[{0,38280510,2}]'),(1002010853,152,0,'[]',1,'[{0,38280510,4}]'),(1002010953,152,0,'[]',1,'[{0,38280510,6}]'),(1002011053,152,0,'[]',1,'[{0,38280510,8}]'),(1002011153,152,0,'[]',1,'[{0,38280510,12}]'),(1002011253,152,0,'[]',1,'[{0,38280510,16}]'),(1002011353,152,0,'[]',1,'[{0,38280510,20}]'),(1002011453,152,0,'[]',1,'[{0,38280510,25}]'),(1002011553,152,0,'[]',1,'[{0,38280510,30}]'),(1002011653,152,0,'[]',1,'[{0,38280510,35}]'),(1002020753,152,0,'[]',1,'[{0,38280510,2}]'),(1002020853,152,0,'[]',1,'[{0,38280510,4}]'),(1002020953,152,0,'[]',1,'[{0,38280510,6}]'),(1002021053,152,0,'[]',1,'[{0,38280510,8}]'),(1002021153,152,0,'[]',1,'[{0,38280510,12}]'),(1002021253,152,0,'[]',1,'[{0,38280510,16}]'),(1002021353,152,0,'[]',1,'[{0,38280510,20}]'),(1002021453,152,0,'[]',1,'[{0,38280510,25}]'),(1002021553,152,0,'[]',1,'[{0,38280510,30}]'),(1002021653,152,0,'[]',1,'[{0,38280510,35}]'),(1002030753,152,0,'[]',1,'[{0,38280510,2}]'),(1002030853,152,0,'[]',1,'[{0,38280510,4}]'),(1002030953,152,0,'[]',1,'[{0,38280510,6}]'),(1002031053,152,0,'[]',1,'[{0,38280510,8}]'),(1002031153,152,0,'[]',1,'[{0,38280510,12}]'),(1002031253,152,0,'[]',1,'[{0,38280510,16}]'),(1002031353,152,0,'[]',1,'[{0,38280510,20}]'),(1002031453,152,0,'[]',1,'[{0,38280510,25}]'),(1002031553,152,0,'[]',1,'[{0,38280510,30}]'),(1002031653,152,0,'[]',1,'[{0,38280510,35}]'),(1002040753,152,0,'[]',1,'[{0,38280510,2}]'),(1002040853,152,0,'[]',1,'[{0,38280510,4}]'),(1002040953,152,0,'[]',1,'[{0,38280510,6}]'),(1002041053,152,0,'[]',1,'[{0,38280510,8}]'),(1002041153,152,0,'[]',1,'[{0,38280510,12}]'),(1002041253,152,0,'[]',1,'[{0,38280510,16}]'),(1002041353,152,0,'[]',1,'[{0,38280510,20}]'),(1002041453,152,0,'[]',1,'[{0,38280510,25}]'),(1002041553,152,0,'[]',1,'[{0,38280510,30}]'),(1002041653,152,0,'[]',1,'[{0,38280510,35}]'),(1003000753,152,0,'[]',1,'[{0,38280520,2}]'),(1003000853,152,0,'[]',1,'[{0,38280520,4}]'),(1003000953,152,0,'[]',1,'[{0,38280520,6}]'),(1003001053,152,0,'[]',1,'[{0,38280520,8}]'),(1003001153,152,0,'[]',1,'[{0,38280520,12}]'),(1003001253,152,0,'[]',1,'[{0,38280520,16}]'),(1003001353,152,0,'[]',1,'[{0,38280520,20}]'),(1003001453,152,0,'[]',1,'[{0,38280520,25}]'),(1003001553,152,0,'[]',1,'[{0,38280520,30}]'),(1003001653,152,0,'[]',1,'[{0,38280520,35}]'),(1004010753,152,0,'[]',1,'[{0,38280510,2}]'),(1004010853,152,0,'[]',1,'[{0,38280510,4}]'),(1004010953,152,0,'[]',1,'[{0,38280510,6}]'),(1004011053,152,0,'[]',1,'[{0,38280510,8}]'),(1004011153,152,0,'[]',1,'[{0,38280510,12}]'),(1004011253,152,0,'[]',1,'[{0,38280510,16}]'),(1004011353,152,0,'[]',1,'[{0,38280510,20}]'),(1004011453,152,0,'[]',1,'[{0,38280510,25}]'),(1004011553,152,0,'[]',1,'[{0,38280510,30}]'),(1004011653,152,0,'[]',1,'[{0,38280510,35}]'),(1004020753,152,0,'[]',1,'[{0,38280510,2}]'),(1004020853,152,0,'[]',1,'[{0,38280510,4}]'),(1004020953,152,0,'[]',1,'[{0,38280510,6}]'),(1004021053,152,0,'[]',1,'[{0,38280510,8}]'),(1004021153,152,0,'[]',1,'[{0,38280510,12}]'),(1004021253,152,0,'[]',1,'[{0,38280510,16}]'),(1004021353,152,0,'[]',1,'[{0,38280510,20}]'),(1004021453,152,0,'[]',1,'[{0,38280510,25}]'),(1004021553,152,0,'[]',1,'[{0,38280510,30}]'),(1004021653,152,0,'[]',1,'[{0,38280510,35}]'),(1004030753,152,0,'[]',1,'[{0,38280510,2}]'),(1004030853,152,0,'[]',1,'[{0,38280510,4}]'),(1004030953,152,0,'[]',1,'[{0,38280510,6}]'),(1004031053,152,0,'[]',1,'[{0,38280510,8}]'),(1004031153,152,0,'[]',1,'[{0,38280510,12}]'),(1004031253,152,0,'[]',1,'[{0,38280510,16}]'),(1004031353,152,0,'[]',1,'[{0,38280510,20}]'),(1004031453,152,0,'[]',1,'[{0,38280510,25}]'),(1004031553,152,0,'[]',1,'[{0,38280510,30}]'),(1004031653,152,0,'[]',1,'[{0,38280510,35}]'),(1004040753,152,0,'[]',1,'[{0,38280510,2}]'),(1004040853,152,0,'[]',1,'[{0,38280510,4}]'),(1004040953,152,0,'[]',1,'[{0,38280510,6}]'),(1004041053,152,0,'[]',1,'[{0,38280510,8}]'),(1004041153,152,0,'[]',1,'[{0,38280510,12}]'),(1004041253,152,0,'[]',1,'[{0,38280510,16}]'),(1004041353,152,0,'[]',1,'[{0,38280510,20}]'),(1004041453,152,0,'[]',1,'[{0,38280510,25}]'),(1004041553,152,0,'[]',1,'[{0,38280510,30}]'),(1004041653,152,0,'[]',1,'[{0,38280510,35}]'),(1005000753,152,0,'[]',1,'[{0,38280520,2}]'),(1005000853,152,0,'[]',1,'[{0,38280520,4}]'),(1005000953,152,0,'[]',1,'[{0,38280520,6}]'),(1005001053,152,0,'[]',1,'[{0,38280520,8}]'),(1005001153,152,0,'[]',1,'[{0,38280520,12}]'),(1005001253,152,0,'[]',1,'[{0,38280520,16}]'),(1005001353,152,0,'[]',1,'[{0,38280520,20}]'),(1005001453,152,0,'[]',1,'[{0,38280520,25}]'),(1005001553,152,0,'[]',1,'[{0,38280520,30}]'),(1005001653,152,0,'[]',1,'[{0,38280520,35}]'),(1006010753,152,0,'[]',1,'[{0,38280510,2}]'),(1006010853,152,0,'[]',1,'[{0,38280510,4}]'),(1006010953,152,0,'[]',1,'[{0,38280510,6}]'),(1006011053,152,0,'[]',1,'[{0,38280510,8}]'),(1006011153,152,0,'[]',1,'[{0,38280510,12}]'),(1006011253,152,0,'[]',1,'[{0,38280510,16}]'),(1006011353,152,0,'[]',1,'[{0,38280510,20}]'),(1006011453,152,0,'[]',1,'[{0,38280510,25}]'),(1006011553,152,0,'[]',1,'[{0,38280510,30}]'),(1006011653,152,0,'[]',1,'[{0,38280510,35}]'),(1006020753,152,0,'[]',1,'[{0,38280510,2}]'),(1006020853,152,0,'[]',1,'[{0,38280510,4}]'),(1006020953,152,0,'[]',1,'[{0,38280510,6}]'),(1006021053,152,0,'[]',1,'[{0,38280510,8}]'),(1006021153,152,0,'[]',1,'[{0,38280510,12}]'),(1006021253,152,0,'[]',1,'[{0,38280510,16}]'),(1006021353,152,0,'[]',1,'[{0,38280510,20}]'),(1006021453,152,0,'[]',1,'[{0,38280510,25}]'),(1006021553,152,0,'[]',1,'[{0,38280510,30}]'),(1006021653,152,0,'[]',1,'[{0,38280510,35}]'),(1006030753,152,0,'[]',1,'[{0,38280510,2}]'),(1006030853,152,0,'[]',1,'[{0,38280510,4}]'),(1006030953,152,0,'[]',1,'[{0,38280510,6}]'),(1006031053,152,0,'[]',1,'[{0,38280510,8}]'),(1006031153,152,0,'[]',1,'[{0,38280510,12}]'),(1006031253,152,0,'[]',1,'[{0,38280510,16}]'),(1006031353,152,0,'[]',1,'[{0,38280510,20}]'),(1006031453,152,0,'[]',1,'[{0,38280510,25}]'),(1006031553,152,0,'[]',1,'[{0,38280510,30}]'),(1006031653,152,0,'[]',1,'[{0,38280510,35}]'),(1006040753,152,0,'[]',1,'[{0,38280510,2}]'),(1006040853,152,0,'[]',1,'[{0,38280510,4}]'),(1006040953,152,0,'[]',1,'[{0,38280510,6}]'),(1006041053,152,0,'[]',1,'[{0,38280510,8}]'),(1006041153,152,0,'[]',1,'[{0,38280510,12}]'),(1006041253,152,0,'[]',1,'[{0,38280510,16}]'),(1006041353,152,0,'[]',1,'[{0,38280510,20}]'),(1006041453,152,0,'[]',1,'[{0,38280510,25}]'),(1006041553,152,0,'[]',1,'[{0,38280510,30}]'),(1006041653,152,0,'[]',1,'[{0,38280510,35}]'),(1007010753,152,0,'[]',1,'[{0,38280520,2}]'),(1007010853,152,0,'[]',1,'[{0,38280520,4}]'),(1007010953,152,0,'[]',1,'[{0,38280520,6}]'),(1007011053,152,0,'[]',1,'[{0,38280520,8}]'),(1007011153,152,0,'[]',1,'[{0,38280520,12}]'),(1007011253,152,0,'[]',1,'[{0,38280520,16}]'),(1007011353,152,0,'[]',1,'[{0,38280520,20}]'),(1007011453,152,0,'[]',1,'[{0,38280520,25}]'),(1007011553,152,0,'[]',1,'[{0,38280520,30}]'),(1007011653,152,0,'[]',1,'[{0,38280520,35}]'),(1007020753,152,0,'[]',1,'[{0,38280520,2}]'),(1007020853,152,0,'[]',1,'[{0,38280520,4}]'),(1007020953,152,0,'[]',1,'[{0,38280520,6}]'),(1007021053,152,0,'[]',1,'[{0,38280520,8}]'),(1007021153,152,0,'[]',1,'[{0,38280520,12}]'),(1007021253,152,0,'[]',1,'[{0,38280520,16}]'),(1007021353,152,0,'[]',1,'[{0,38280520,20}]'),(1007021453,152,0,'[]',1,'[{0,38280520,25}]'),(1007021553,152,0,'[]',1,'[{0,38280520,30}]'),(1007021653,152,0,'[]',1,'[{0,38280520,35}]'),(1007030753,152,0,'[]',1,'[{0,38280520,2}]'),(1007030853,152,0,'[]',1,'[{0,38280520,4}]'),(1007030953,152,0,'[]',1,'[{0,38280520,6}]'),(1007031053,152,0,'[]',1,'[{0,38280520,8}]'),(1007031153,152,0,'[]',1,'[{0,38280520,12}]'),(1007031253,152,0,'[]',1,'[{0,38280520,16}]'),(1007031353,152,0,'[]',1,'[{0,38280520,20}]'),(1007031453,152,0,'[]',1,'[{0,38280520,25}]'),(1007031553,152,0,'[]',1,'[{0,38280520,30}]'),(1007031653,152,0,'[]',1,'[{0,38280520,35}]'),(1007040753,152,0,'[]',1,'[{0,38280520,2}]'),(1007040853,152,0,'[]',1,'[{0,38280520,4}]'),(1007040953,152,0,'[]',1,'[{0,38280520,6}]'),(1007041053,152,0,'[]',1,'[{0,38280520,8}]'),(1007041153,152,0,'[]',1,'[{0,38280520,12}]'),(1007041253,152,0,'[]',1,'[{0,38280520,16}]'),(1007041353,152,0,'[]',1,'[{0,38280520,20}]'),(1007041453,152,0,'[]',1,'[{0,38280520,25}]'),(1007041553,152,0,'[]',1,'[{0,38280520,30}]'),(1007041653,152,0,'[]',1,'[{0,38280520,35}]'),(1008010753,152,0,'[]',1,'[{0,38280510,2}]'),(1008010853,152,0,'[]',1,'[{0,38280510,4}]'),(1008010953,152,0,'[]',1,'[{0,38280510,6}]'),(1008011053,152,0,'[]',1,'[{0,38280510,8}]'),(1008011153,152,0,'[]',1,'[{0,38280510,12}]'),(1008011253,152,0,'[]',1,'[{0,38280510,16}]'),(1008011353,152,0,'[]',1,'[{0,38280510,20}]'),(1008011453,152,0,'[]',1,'[{0,38280510,25}]'),(1008011553,152,0,'[]',1,'[{0,38280510,30}]'),(1008011653,152,0,'[]',1,'[{0,38280510,35}]'),(1008020753,152,0,'[]',1,'[{0,38280510,2}]'),(1008020853,152,0,'[]',1,'[{0,38280510,4}]'),(1008020953,152,0,'[]',1,'[{0,38280510,6}]'),(1008021053,152,0,'[]',1,'[{0,38280510,8}]'),(1008021153,152,0,'[]',1,'[{0,38280510,12}]'),(1008021253,152,0,'[]',1,'[{0,38280510,16}]'),(1008021353,152,0,'[]',1,'[{0,38280510,20}]'),(1008021453,152,0,'[]',1,'[{0,38280510,25}]'),(1008021553,152,0,'[]',1,'[{0,38280510,30}]'),(1008021653,152,0,'[]',1,'[{0,38280510,35}]'),(1008030753,152,0,'[]',1,'[{0,38280510,2}]'),(1008030853,152,0,'[]',1,'[{0,38280510,4}]'),(1008030953,152,0,'[]',1,'[{0,38280510,6}]'),(1008031053,152,0,'[]',1,'[{0,38280510,8}]'),(1008031153,152,0,'[]',1,'[{0,38280510,12}]'),(1008031253,152,0,'[]',1,'[{0,38280510,16}]'),(1008031353,152,0,'[]',1,'[{0,38280510,20}]'),(1008031453,152,0,'[]',1,'[{0,38280510,25}]'),(1008031553,152,0,'[]',1,'[{0,38280510,30}]'),(1008031653,152,0,'[]',1,'[{0,38280510,35}]'),(1008040753,152,0,'[]',1,'[{0,38280510,2}]'),(1008040853,152,0,'[]',1,'[{0,38280510,4}]'),(1008040953,152,0,'[]',1,'[{0,38280510,6}]'),(1008041053,152,0,'[]',1,'[{0,38280510,8}]'),(1008041153,152,0,'[]',1,'[{0,38280510,12}]'),(1008041253,152,0,'[]',1,'[{0,38280510,16}]'),(1008041353,152,0,'[]',1,'[{0,38280510,20}]'),(1008041453,152,0,'[]',1,'[{0,38280510,25}]'),(1008041553,152,0,'[]',1,'[{0,38280510,30}]'),(1008041653,152,0,'[]',1,'[{0,38280510,35}]'),(1009000753,152,0,'[]',1,'[{0,38280520,2}]'),(1009000853,152,0,'[]',1,'[{0,38280520,4}]'),(1009000953,152,0,'[]',1,'[{0,38280520,6}]'),(1009001053,152,0,'[]',1,'[{0,38280520,8}]'),(1009001153,152,0,'[]',1,'[{0,38280520,12}]'),(1009001253,152,0,'[]',1,'[{0,38280520,16}]'),(1009001353,152,0,'[]',1,'[{0,38280520,20}]'),(1009001453,152,0,'[]',1,'[{0,38280520,25}]'),(1009001553,152,0,'[]',1,'[{0,38280520,30}]'),(1009001653,152,0,'[]',1,'[{0,38280520,35}]'),(1010010753,152,0,'[]',1,'[{0,38280510,2}]'),(1010010853,152,0,'[]',1,'[{0,38280510,4}]'),(1010010953,152,0,'[]',1,'[{0,38280510,6}]'),(1010011053,152,0,'[]',1,'[{0,38280510,8}]'),(1010011153,152,0,'[]',1,'[{0,38280510,12}]'),(1010011253,152,0,'[]',1,'[{0,38280510,16}]'),(1010011353,152,0,'[]',1,'[{0,38280510,20}]'),(1010011453,152,0,'[]',1,'[{0,38280510,25}]'),(1010011553,152,0,'[]',1,'[{0,38280510,30}]'),(1010011653,152,0,'[]',1,'[{0,38280510,35}]'),(1010020753,152,0,'[]',1,'[{0,38280510,2}]'),(1010020853,152,0,'[]',1,'[{0,38280510,4}]'),(1010020953,152,0,'[]',1,'[{0,38280510,6}]'),(1010021053,152,0,'[]',1,'[{0,38280510,8}]'),(1010021153,152,0,'[]',1,'[{0,38280510,12}]'),(1010021253,152,0,'[]',1,'[{0,38280510,16}]'),(1010021353,152,0,'[]',1,'[{0,38280510,20}]'),(1010021453,152,0,'[]',1,'[{0,38280510,25}]'),(1010021553,152,0,'[]',1,'[{0,38280510,30}]'),(1010021653,152,0,'[]',1,'[{0,38280510,35}]'),(1010030753,152,0,'[]',1,'[{0,38280510,2}]'),(1010030853,152,0,'[]',1,'[{0,38280510,4}]'),(1010030953,152,0,'[]',1,'[{0,38280510,6}]'),(1010031053,152,0,'[]',1,'[{0,38280510,8}]'),(1010031153,152,0,'[]',1,'[{0,38280510,12}]'),(1010031253,152,0,'[]',1,'[{0,38280510,16}]'),(1010031353,152,0,'[]',1,'[{0,38280510,20}]'),(1010031453,152,0,'[]',1,'[{0,38280510,25}]'),(1010031553,152,0,'[]',1,'[{0,38280510,30}]'),(1010031653,152,0,'[]',1,'[{0,38280510,35}]'),(1010040753,152,0,'[]',1,'[{0,38280510,2}]'),(1010040853,152,0,'[]',1,'[{0,38280510,4}]'),(1010040953,152,0,'[]',1,'[{0,38280510,6}]'),(1010041053,152,0,'[]',1,'[{0,38280510,8}]'),(1010041153,152,0,'[]',1,'[{0,38280510,12}]'),(1010041253,152,0,'[]',1,'[{0,38280510,16}]'),(1010041353,152,0,'[]',1,'[{0,38280510,20}]'),(1010041453,152,0,'[]',1,'[{0,38280510,25}]'),(1010041553,152,0,'[]',1,'[{0,38280510,30}]'),(1010041653,152,0,'[]',1,'[{0,38280510,35}]'),(1101010753,152,0,'[]',1,'[{0,38280520,2}]'),(1101020753,152,0,'[]',1,'[{0,38280520,2}]'),(1101030753,152,0,'[]',1,'[{0,38280520,2}]'),(1101040753,152,0,'[]',1,'[{0,38280520,2}]'),(1102010753,152,0,'[]',1,'[{0,38280510,2}]'),(1102020753,152,0,'[]',1,'[{0,38280510,2}]'),(1102030753,152,0,'[]',1,'[{0,38280510,2}]'),(1102040753,152,0,'[]',1,'[{0,38280510,2}]'),(1103000753,152,0,'[]',1,'[{0,38280520,2}]'),(1104010753,152,0,'[]',1,'[{0,38280510,2}]'),(1104020753,152,0,'[]',1,'[{0,38280510,2}]'),(1104030753,152,0,'[]',1,'[{0,38280510,2}]'),(1104040753,152,0,'[]',1,'[{0,38280510,2}]'),(1105000753,152,0,'[]',1,'[{0,38280520,2}]'),(1106010753,152,0,'[]',1,'[{0,38280510,2}]'),(1106020753,152,0,'[]',1,'[{0,38280510,2}]'),(1106030753,152,0,'[]',1,'[{0,38280510,2}]'),(1106040753,152,0,'[]',1,'[{0,38280510,2}]'),(1107010753,152,0,'[]',1,'[{0,38280520,2}]'),(1107020753,152,0,'[]',1,'[{0,38280520,2}]'),(1107030753,152,0,'[]',1,'[{0,38280520,2}]'),(1107040753,152,0,'[]',1,'[{0,38280520,2}]'),(1108010753,152,0,'[]',1,'[{0,38280510,2}]'),(1108020753,152,0,'[]',1,'[{0,38280510,2}]'),(1108030753,152,0,'[]',1,'[{0,38280510,2}]'),(1108040753,152,0,'[]',1,'[{0,38280510,2}]'),(1109000753,152,0,'[]',1,'[{0,38280520,2}]'),(1110010753,152,0,'[]',1,'[{0,38280510,2}]'),(1110020753,152,0,'[]',1,'[{0,38280510,2}]'),(1110030753,152,0,'[]',1,'[{0,38280510,2}]'),(1110040753,152,0,'[]',1,'[{0,38280510,2}]');
/*!40000 ALTER TABLE `base_goods_decompose` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_goods_effect`
--

DROP TABLE IF EXISTS `base_goods_effect`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_goods_effect` (
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型id',
  `goods_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '道具类型',
  `buff_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'BUFF类型ID',
  `effect_list` varchar(1024) NOT NULL COMMENT '效果',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '持续时长(秒)',
  `limit_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '限制类型',
  `counter_module` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '次数模块ID',
  `counter_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '次数ID',
  `limit_scene` varchar(255) NOT NULL COMMENT '生效的场景ID',
  PRIMARY KEY (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品效果配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_goods_effect`
--

LOCK TABLES `base_goods_effect` WRITE;
/*!40000 ALTER TABLE `base_goods_effect` DISABLE KEYS */;
INSERT INTO `base_goods_effect` VALUES (36010001,0,0,'[{gold,1}]',0,0,0,0,'[]'),(36010002,0,0,'[{fgold,1}]',0,0,0,0,'[]'),(36020001,0,0,'[{bgold,1}]',0,0,0,0,'[]'),(36030001,0,0,'[{coin,1}]',0,0,0,0,'[]'),(36210001,0,0,'[{charge_card,1}]',0,0,0,0,'[]'),(36210002,0,0,'[{charge_card,2}]',0,0,0,0,'[]'),(36210003,0,0,'[{charge_card,3}]',0,0,0,0,'[]'),(36210004,0,0,'[{charge_card,4}]',0,0,0,0,'[]'),(36210005,0,0,'[{charge_card,5}]',0,0,0,0,'[]'),(36210006,0,0,'[{charge_card,6}]',0,0,0,0,'[]'),(36210007,0,0,'[{charge_card,7}]',0,0,0,0,'[]'),(36210008,0,0,'[{charge_card,20}]',0,0,0,0,'[]'),(36210009,0,0,'[{charge_card,10}]',0,0,0,0,'[]'),(37020001,1,1,'[{exp_mon,0.5}]',3600,0,0,0,'[]'),(37020002,1,1,'[{exp_mon,1}]',3600,0,0,0,'[]'),(37020003,1,1,'[{exp_mon,1.5}]',3600,0,0,0,'[]'),(37020004,1,1,'[{exp_mon,2}]',3600,0,0,0,'[]'),(37030002,0,0,'[{power_live,1000}]',0,0,0,0,'[]'),(37040001,0,8,'[{attr,[{18,150}]}]',0,0,0,0,'[5171]'),(37050001,0,10,'[{vip_immune, 1}]',600,1,450,15,'[]'),(38040004,1,2,'[{exp_drop,10}]',600,0,0,0,'[]'),(38070001,0,0,'[{onhook_time,2}]',7200,0,0,0,'[]'),(38070002,0,0,'[{onhook_time,5}]',18000,0,0,0,'[]'),(38220001,1,0,'[{attr,[{9,500}]}]',0,0,0,0,'[4401]'),(42030001,1,3,'[{attr,[{19,200},{20,200}]}]',0,0,0,0,'[]'),(42030002,1,4,'[{attr,[{19,1000},{20,1000},{22,1000}]}]',0,0,0,0,'[4061]'),(46020011,0,9,'[{attr,[{1,300}]}]',1800,0,0,0,'[]'),(46020012,0,9,'[{attr,[{1,500}]}]',1800,0,0,0,'[]'),(46020013,0,9,'[{attr,[{1,800}]}]',1800,0,0,0,'[]'),(46020014,0,9,'[{attr,[{1,1200}]}]',1800,0,0,0,'[]'),(46020021,0,9,'[{attr,[{3,300}]}]',1800,0,0,0,'[]'),(46020022,0,9,'[{attr,[{3,500}]}]',1800,0,0,0,'[]'),(46020023,0,9,'[{attr,[{3,800}]}]',1800,0,0,0,'[]'),(46020024,0,9,'[{attr,[{3,1200}]}]',1800,0,0,0,'[]'),(46020031,0,9,'[{attr,[{4,300}]}]',1800,0,0,0,'[]'),(46020032,0,9,'[{attr,[{4,500}]}]',1800,0,0,0,'[]'),(46020033,0,9,'[{attr,[{4,800}]}]',1800,0,0,0,'[]'),(46020034,0,9,'[{attr,[{4,1200}]}]',1800,0,0,0,'[]'),(46020041,0,9,'[{attr,[{5,300}]}]',1800,0,0,0,'[]'),(46020042,0,9,'[{attr,[{5,500}]}]',1800,0,0,0,'[]'),(46020043,0,9,'[{attr,[{5,800}]}]',1800,0,0,0,'[]'),(46020044,0,9,'[{attr,[{5,1200}]}]',1800,0,0,0,'[]'),(46020051,0,9,'[{attr,[{6,300}]}]',1800,0,0,0,'[]'),(46020052,0,9,'[{attr,[{6,500}]}]',1800,0,0,0,'[]'),(46020053,0,9,'[{attr,[{6,800}]}]',1800,0,0,0,'[]'),(46020054,0,9,'[{attr,[{6,1200}]}]',1800,0,0,0,'[]'),(46020061,0,9,'[{attr,[{7,300}]}]',1800,0,0,0,'[]'),(46020062,0,9,'[{attr,[{7,500}]}]',1800,0,0,0,'[]'),(46020063,0,9,'[{attr,[{7,800}]}]',1800,0,0,0,'[]'),(46020064,0,9,'[{attr,[{7,1200}]}]',1800,0,0,0,'[]'),(46020071,0,9,'[{attr,[{8,300}]}]',1800,0,0,0,'[]'),(46020072,0,9,'[{attr,[{8,500}]}]',1800,0,0,0,'[]'),(46020073,0,9,'[{attr,[{8,800}]}]',1800,0,0,0,'[]'),(46020074,0,9,'[{attr,[{8,1200}]}]',1800,0,0,0,'[]'),(46020081,0,9,'[{attr,[{48,300}]}]',1800,0,0,0,'[]'),(46020082,0,9,'[{attr,[{48,500}]}]',1800,0,0,0,'[]'),(46020083,0,9,'[{attr,[{48,800}]}]',1800,0,0,0,'[]'),(46020084,0,9,'[{attr,[{48,1200}]}]',1800,0,0,0,'[]'),(46020091,0,9,'[{attr,[{49,300}]}]',1800,0,0,0,'[]'),(46020092,0,9,'[{attr,[{49,500}]}]',1800,0,0,0,'[]'),(46020093,0,9,'[{attr,[{49,800}]}]',1800,0,0,0,'[]'),(46020094,0,9,'[{attr,[{49,1200}]}]',1800,0,0,0,'[]'),(46020101,0,9,'[{attr,[{300,300},{310,500}]}]',1800,0,0,0,'[]'),(46020102,0,9,'[{attr,[{300,500},{310,600}]}]',1800,0,0,0,'[]'),(46020103,0,9,'[{attr,[{300,800},{310,700}]}]',1800,0,0,0,'[]'),(46020104,0,9,'[{attr,[{300,1200},{310,800}]}]',1800,0,0,0,'[]'),(46020111,0,9,'[{attr,[{301,300},{311,500}]}]',1800,0,0,0,'[]'),(46020112,0,9,'[{attr,[{301,500},{311,600}]}]',1800,0,0,0,'[]'),(46020113,0,9,'[{attr,[{301,800},{311,700}]}]',1800,0,0,0,'[]'),(46020114,0,9,'[{attr,[{301,1200},{311,800}]}]',1800,0,0,0,'[]'),(46020121,0,9,'[{attr,[{302,300},{312,500}]}]',1800,0,0,0,'[]'),(46020122,0,9,'[{attr,[{302,500},{312,600}]}]',1800,0,0,0,'[]'),(46020123,0,9,'[{attr,[{302,800},{312,700}]}]',1800,0,0,0,'[]'),(46020124,0,9,'[{attr,[{302,1200},{312,800}]}]',1800,0,0,0,'[]'),(46020131,0,9,'[{attr,[{303,300},{313,500}]}]',1800,0,0,0,'[]'),(46020132,0,9,'[{attr,[{303,500},{313,600}]}]',1800,0,0,0,'[]'),(46020133,0,9,'[{attr,[{303,800},{313,700}]}]',1800,0,0,0,'[]'),(46020134,0,9,'[{attr,[{303,1200},{313,800}]}]',1800,0,0,0,'[]'),(46020141,0,9,'[{attr,[{304,300},{314,500}]}]',1800,0,0,0,'[]'),(46020142,0,9,'[{attr,[{304,500},{314,600}]}]',1800,0,0,0,'[]'),(46020143,0,9,'[{attr,[{304,800},{314,700}]}]',1800,0,0,0,'[]'),(46020144,0,9,'[{attr,[{304,1200},{314,800}]}]',1800,0,0,0,'[]'),(46020151,0,9,'[{attr,[{305,300},{315,500}]}]',1800,0,0,0,'[]'),(46020152,0,9,'[{attr,[{305,500},{315,600}]}]',1800,0,0,0,'[]'),(46020153,0,9,'[{attr,[{305,800},{315,700}]}]',1800,0,0,0,'[]'),(46020154,0,9,'[{attr,[{305,1200},{315,800}]}]',1800,0,0,0,'[]'),(46020161,0,9,'[{attr,[{306,300},{316,500}]}]',1800,0,0,0,'[]'),(46020162,0,9,'[{attr,[{306,500},{316,600}]}]',1800,0,0,0,'[]'),(46020163,0,9,'[{attr,[{306,800},{316,700}]}]',1800,0,0,0,'[]'),(46020164,0,9,'[{attr,[{306,1200},{316,800}]}]',1800,0,0,0,'[]'),(46020171,0,9,'[{attr,[{307,300},{317,500}]}]',1800,0,0,0,'[]'),(46020172,0,9,'[{attr,[{307,500},{317,600}]}]',1800,0,0,0,'[]'),(46020173,0,9,'[{attr,[{307,800},{317,700}]}]',1800,0,0,0,'[]'),(46020174,0,9,'[{attr,[{307,1200},{317,800}]}]',1800,0,0,0,'[]'),(46020181,0,9,'[{attr,[{54,500}]}]',1800,0,0,0,'[]'),(46020182,0,9,'[{attr,[{54,600}]}]',1800,0,0,0,'[]'),(46020183,0,9,'[{attr,[{54,700}]}]',1800,0,0,0,'[]'),(46020184,0,9,'[{attr,[{54,800}]}]',1800,0,0,0,'[]'),(46020193,0,9,'[{attr,[{202,1500}]}]',3600,0,0,0,'[]'),(46020194,0,9,'[{attr,[{202,2000}]}]',3600,0,0,0,'[]'),(46020203,0,9,'[{attr,[{18,20}]}]',3600,0,0,0,'[]'),(46020204,0,9,'[{attr,[{18,30}]}]',3600,0,0,0,'[]'),(46020213,0,9,'[{attr,[{201,300}]}]',3600,0,0,0,'[]'),(46020214,0,9,'[{attr,[{201,500}]}]',3600,0,0,0,'[]'),(46020223,0,9,'[{attr,[{9,1500}]}]',3600,0,0,0,'[]'),(46020224,0,9,'[{attr,[{9,2000}]}]',3600,0,0,0,'[]'),(46020231,0,9,'[{attr,[{1,150}]}]',1800,0,0,0,'[]'),(46020232,0,9,'[{attr,[{1,250}]}]',1800,0,0,0,'[]'),(46020233,0,9,'[{attr,[{1,400}]}]',1800,0,0,0,'[]'),(46020241,0,9,'[{attr,[{3,150}]}]',1800,0,0,0,'[]'),(46020242,0,9,'[{attr,[{3,250}]}]',1800,0,0,0,'[]'),(46020243,0,9,'[{attr,[{3,400}]}]',1800,0,0,0,'[]'),(46020251,0,9,'[{attr,[{4,150}]}]',1800,0,0,0,'[]'),(46020252,0,9,'[{attr,[{4,250}]}]',1800,0,0,0,'[]'),(46020253,0,9,'[{attr,[{4,400}]}]',1800,0,0,0,'[]'),(1011000001,0,0,'[{renew_day,2592000}]',0,0,0,0,'[]'),(1011000002,0,0,'[{renew_day,2592000}]',0,0,0,0,'[]'),(1011000003,0,0,'[{renew_day,2592000}]',0,0,0,0,'[]'),(1011000004,0,0,'[{renew_day,2592000}]',0,0,0,0,'[]'),(3100000001,1,11,'[{attr,[{9,1500}]}]',90,0,0,0,'[5811,5812]'),(3100000002,1,11,'[{attr,[{10,1500}]}]',90,0,0,0,'[5811,5812]'),(3100000003,1,11,'[{attr,[{121,100}]}]',90,0,0,0,'[5811,5812]'),(3100000004,1,11,'[{attr,[{201,5000}]}]',90,0,0,0,'[5811,5812]'),(3100000005,1,11,'[]',30,0,0,0,'[5811,5812]'),(3100000006,1,11,'[]',0,0,0,0,'[5811,5812]');
/*!40000 ALTER TABLE `base_goods_effect` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_goods_effect_type`
--

DROP TABLE IF EXISTS `base_goods_effect_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_goods_effect_type` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '类型id',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '描述',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品buff类型id';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_goods_effect_type`
--

LOCK TABLES `base_goods_effect_type` WRITE;
/*!40000 ALTER TABLE `base_goods_effect_type` DISABLE KEYS */;
INSERT INTO `base_goods_effect_type` VALUES (0,'无buff类型'),(1,'exp_mon'),(2,'exp_drop'),(3,'主宰公会会长buff'),(4,'公会争霸士气鼓舞buff'),(5,'队伍显示被动buff(荆棘之心)'),(6,'亲密度等级组队BUFF'),(7,'宝藏守护buff'),(8,'中午答题buff'),(9,'家园食物'),(10,'至尊vip无敌buff'),(11,'三英会战BUFF');
/*!40000 ALTER TABLE `base_goods_effect_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_goods_exchange`
--

DROP TABLE IF EXISTS `base_goods_exchange`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_goods_exchange` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `name` varchar(100) NOT NULL DEFAULT '' COMMENT '标题@lang@',
  `npc` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'NPC编号',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '兑换类型，0 物品兑换，1 竞技积分兑换',
  `method` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '兑换方式，0为固定兑换，1为随机兑换',
  `raw_goods` text NOT NULL COMMENT '原物品列表',
  `dst_goods` text NOT NULL COMMENT '兑换物品列表',
  `bind` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '兑换物品的绑定状态',
  `max_overlap` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '兑换物品的最大叠加数',
  `exchange_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '兑换类型，0:单日物品兑换; 1:每周物品的兑换; 2:日和周都要计算的类型（暂时只做0的类型',
  `limit_week_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '限制兑换数的每次次数类型Id(物品兑换每周限制专用区间17001 - 18500)',
  `limit_week_num` int(11) NOT NULL COMMENT '每周兑换的次数',
  `limit_day_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '限制兑换数的日常次数类型Id(物品兑换每日限制专用区间18501 - 20000)',
  `limit_day_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '每天能兑换的次数',
  `start_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开始时间，0为不限',
  `end_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '结束时间，0为不限',
  `condition` varchar(1000) DEFAULT '[]' COMMENT '开启条件',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '状态，1为生效，0为不生效',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品兑换规则表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_goods_exchange`
--

LOCK TABLES `base_goods_exchange` WRITE;
/*!40000 ALTER TABLE `base_goods_exchange` DISABLE KEYS */;
/*!40000 ALTER TABLE `base_goods_exchange` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_goods_exchange_rule`
--

DROP TABLE IF EXISTS `base_goods_exchange_rule`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_goods_exchange_rule` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '兑换规则id',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '兑换类型',
  `role_lv` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '需要玩家等级',
  `max_role_lv` smallint(5) unsigned NOT NULL DEFAULT '1000' COMMENT '最大等级限制',
  `cost_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗物品',
  `obtain_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT '获得物品',
  `lim_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '次数限制类型 0: 不限制 1: 每天限制 2: 每周限制 3: 终身限制',
  `module` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `sub_module` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '模块子功能id 模块id+模块子功能id额外计数器配置找到对应配置',
  `lim_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '限制兑换数量',
  `condition` varchar(255) NOT NULL DEFAULT '[]' COMMENT '兑换条件',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品兑换规则';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_goods_exchange_rule`
--

LOCK TABLES `base_goods_exchange_rule` WRITE;
/*!40000 ALTER TABLE `base_goods_exchange_rule` DISABLE KEYS */;
INSERT INTO `base_goods_exchange_rule` VALUES (2001,2,150,1000,'[{5,36060001,20000000}]','[{0,38110004,1}]',0,0,0,0,'[{role_lv,355},{turn,3}]'),(2002,2,210,1000,'[{5,36060001,60000000}]','[{0,38110005,1}]',0,0,0,0,'[{role_lv,500},{turn,4}]'),(2003,2,280,1000,'[{5,36060001,95000000}]','[{0,38110006,1}]',0,0,0,0,'[{role_lv,500},{turn,4}]'),(2004,2,360,1000,'[{5,36060001,130000000}]','[{0,38110007,1}]',0,0,0,0,'[{role_lv,500},{turn,4}]'),(3033,3,70,1000,'[{255,36160008,1500}]','[{0,5201013,1}]',0,181,1,0,'[]'),(3034,3,70,1000,'[{255,36160008,1500}]','[{0,5201023,1}]',0,181,1,0,'[]'),(3035,3,70,1000,'[{255,36160008,1500}]','[{0,5201033,1}]',0,181,1,0,'[]'),(3036,3,70,1000,'[{255,36160008,1500}]','[{0,5201043,1}]',0,181,1,0,'[]'),(3037,3,70,1000,'[{255,36160008,300}]','[{0,5201143,1}]',0,181,1,0,'[{stone_dungeon,4}]'),(3038,3,70,1000,'[{255,36160008,1500}]','[{0,5201053,1}]',0,181,1,0,'[{stone_dungeon,8}]'),(3039,3,70,1000,'[{255,36160008,1500}]','[{0,5201063,1}]',0,181,1,0,'[{stone_dungeon,12}]'),(3040,3,70,1000,'[{255,36160008,1500}]','[{0,5201083,1}]',0,181,1,0,'[{stone_dungeon,20}]'),(3041,3,70,1000,'[{255,36160008,1500}]','[{0,5201103,1}]',0,181,1,0,'[{stone_dungeon,28}]'),(3042,3,70,1000,'[{255,36160008,1500}]','[{0,5201093,1}]',0,181,1,0,'[{stone_dungeon,24}]'),(3043,3,70,1000,'[{255,36160008,1500}]','[{0,5201073,1}]',0,181,1,0,'[{stone_dungeon,16}]'),(3044,3,70,1000,'[{255,36160008,1500}]','[{0,5201173,1}]',0,181,1,0,'[{stone_dungeon,36}]'),(3045,3,70,1000,'[{255,36160008,1500}]','[{0,5201183,1}]',0,181,1,0,'[{stone_dungeon,50}]'),(3046,3,70,1000,'[{255,36160008,1500}]','[{0,5201153,1}]',0,181,1,0,'[{stone_dungeon,32}]'),(3047,3,70,1000,'[{255,36160008,1500}]','[{0,5201163,1}]',0,181,1,0,'[{stone_dungeon,42}]'),(3048,3,70,1000,'[{255,36160008,1500}]','[{0,5201193,1}]',0,181,1,0,'[{stone_dungeon,60}]'),(3049,3,70,1000,'[{255,36160008,5000}]','[{0,5201014,1}]',0,181,1,0,'[]'),(3050,3,70,1000,'[{255,36160008,5000}]','[{0,5201024,1}]',0,181,1,0,'[]'),(3051,3,70,1000,'[{255,36160008,5000}]','[{0,5201034,1}]',0,181,1,0,'[]'),(3052,3,70,1000,'[{255,36160008,5000}]','[{0,5201044,1}]',0,181,1,0,'[]'),(3053,3,70,1000,'[{255,36160008,1000}]','[{0,5201144,1}]',0,181,1,0,'[{stone_dungeon,4}]'),(3054,3,70,1000,'[{255,36160008,5000}]','[{0,5201054,1}]',0,181,1,0,'[{stone_dungeon,8}]'),(3055,3,70,1000,'[{255,36160008,5000}]','[{0,5201064,1}]',0,181,1,0,'[{stone_dungeon,12}]'),(3056,3,70,1000,'[{255,36160008,5000}]','[{0,5201084,1}]',0,181,1,0,'[{stone_dungeon,20}]'),(3057,3,70,1000,'[{255,36160008,5000}]','[{0,5201104,1}]',0,181,1,0,'[{stone_dungeon,28}]'),(3058,3,70,1000,'[{255,36160008,5000}]','[{0,5201094,1}]',0,181,1,0,'[{stone_dungeon,24}]'),(3059,3,70,1000,'[{255,36160008,5000}]','[{0,5201074,1}]',0,181,1,0,'[{stone_dungeon,16}]'),(3060,3,70,1000,'[{255,36160008,5000}]','[{0,5201174,1}]',0,181,1,0,'[{stone_dungeon,36}]'),(3061,3,70,1000,'[{255,36160008,5000}]','[{0,5201184,1}]',0,181,1,0,'[{stone_dungeon,50}]'),(3062,3,70,1000,'[{255,36160008,5000}]','[{0,5201154,1}]',0,181,1,0,'[{stone_dungeon,32}]'),(3063,3,70,1000,'[{255,36160008,5000}]','[{0,5201164,1}]',0,181,1,0,'[{stone_dungeon,42}]'),(3064,3,70,1000,'[{255,36160008,5000}]','[{0,5201194,1}]',0,181,1,0,'[{stone_dungeon,60}]'),(3067,3,70,1000,'[{255,36160008,80}]','[{0,5203004,1}]',0,181,1,0,'[]'),(3068,3,70,1000,'[{255,36160008,160}]','[{0,5203005,1}]',0,181,1,0,'[]'),(10001,10,9999,9999,'[{255,36180001,10}]','[{0,32080112,1}]',0,0,0,0,'[]'),(10002,10,9999,9999,'[{255,36180001,20}]','[{0,32080212,1}]',0,0,0,0,'[]'),(10003,10,9999,9999,'[{255,36180001,30}]','[{0,32080312,1}]',0,0,0,0,'[]'),(10004,10,9999,9999,'[{255,36180001,50}]','[{0,32080412,1}]',0,0,0,0,'[]'),(10005,10,220,355,'[{255,36180001,100}]','[{0,32080512,1}]',0,0,0,0,'[]'),(10006,10,260,400,'[{255,36180001,150}]','[{0,32080612,1}]',0,0,0,0,'[]'),(10007,10,300,500,'[{255,36180001,200}]','[{0,32080712,1}]',0,0,0,0,'[]'),(10008,10,355,520,'[{255,36180001,300}]','[{0,32080812,1}]',0,0,0,0,'[]'),(10009,10,400,620,'[{255,36180001,500}]','[{0,32080912,1}]',0,0,0,0,'[]'),(10010,10,500,650,'[{255,36180001,700}]','[{0,32081012,1}]',0,0,0,0,'[]'),(10011,10,520,700,'[{255,36180001,800}]','[{0,32081112,1}]',0,0,0,0,'[]'),(10012,10,620,800,'[{255,36180001,900}]','[{0,32081212,1}]',0,0,0,0,'[]'),(10013,10,650,900,'[{255,36180001,1000}]','[{0,32081312,1}]',0,0,0,0,'[]'),(10014,10,700,1000,'[{255,36180001,1100}]','[{0,32081412,1}]',0,0,0,0,'[]'),(10015,10,800,1000,'[{255,36180001,1200}]','[{0,32081512,1}]',0,0,0,0,'[]'),(10016,10,900,1000,'[{255,36180001,1300}]','[{0,32081612,1}]',0,0,0,0,'[]'),(10017,10,1,1000,'[{255,36180001,20}]','[{0,32030201,1}]',0,0,0,0,'[]'),(10018,10,1,1000,'[{255,36180001,60}]','[{0,32030301,1}]',0,0,0,0,'[]'),(10019,10,1,1000,'[{255,36180001,180}]','[{0,32030401,1}]',0,0,0,0,'[]'),(10020,10,1,1000,'[{255,36180001,540}]','[{0,32030501,1}]',0,0,0,0,'[]'),(10021,10,1,1000,'[{255,36180001,1620}]','[{0,32030601,1}]',0,0,0,0,'[]'),(10022,10,9999,9999,'[{255,36180001,5000}]','[{0,32160008,1}]',0,0,0,0,'[]'),(10023,10,9999,9999,'[{255,36180001,8000}]','[{0,32160009,1}]',0,0,0,0,'[]'),(10024,10,9999,9999,'[{255,36180001,10000}]','[{0,32160010,1}]',0,0,0,0,'[]'),(10025,10,1,1000,'[{255,36180001,7}]','[{0,38260001,1}]',0,0,0,0,'[]'),(10026,20,9999,9999,'[{255,36180001,500}]','[{0,32080112,1}]',0,0,0,0,'[]'),(10027,20,9999,9999,'[{255,36180001,500}]','[{0,32080212,1}]',0,0,0,0,'[]'),(10028,20,9999,9999,'[{255,36180001,500}]','[{0,32080312,1}]',0,0,0,0,'[]'),(10029,20,9999,9999,'[{255,36180001,500}]','[{0,32080412,1}]',0,0,0,0,'[]'),(10030,20,220,355,'[{255,36180001,500}]','[{0,32080512,1}]',0,0,0,0,'[]'),(10031,20,260,400,'[{255,36180001,500}]','[{0,32080612,1}]',0,0,0,0,'[]'),(10032,20,300,500,'[{255,36180001,500}]','[{0,32080712,1}]',0,0,0,0,'[]'),(10033,20,355,520,'[{255,36180001,500}]','[{0,32080812,1}]',0,0,0,0,'[]'),(10034,20,400,620,'[{255,36180001,500}]','[{0,32080912,1}]',0,0,0,0,'[]'),(10035,20,500,650,'[{255,36180001,500}]','[{0,32081012,1}]',0,0,0,0,'[]'),(10036,20,520,700,'[{255,36180001,500}]','[{0,32081112,1}]',0,0,0,0,'[]'),(10037,20,620,800,'[{255,36180001,500}]','[{0,32081212,1}]',0,0,0,0,'[]'),(10038,20,650,900,'[{255,36180001,500}]','[{0,32081312,1}]',0,0,0,0,'[]'),(10039,20,700,1000,'[{255,36180001,500}]','[{0,32081412,1}]',0,0,0,0,'[]'),(10040,20,800,1000,'[{255,36180001,500}]','[{0,32081512,1}]',0,0,0,0,'[]'),(10041,20,900,1000,'[{255,36180001,1300}]','[{0,32081612,1}]',0,0,0,0,'[]'),(10042,20,1,1000,'[{255,36180001,20}]','[{0,32030201,1}]',0,0,0,0,'[]'),(10043,20,1,1000,'[{255,36180001,60}]','[{0,32030301,1}]',0,0,0,0,'[]'),(10044,20,1,1000,'[{255,36180001,180}]','[{0,32030401,1}]',0,0,0,0,'[]'),(10045,20,1,1000,'[{255,36180001,540}]','[{0,32030501,1}]',0,0,0,0,'[]'),(10046,20,1,1000,'[{255,36180001,1620}]','[{0,32030601,1}]',0,0,0,0,'[]'),(10047,20,1,9999,'[{255,36180001,5000}]','[{0,32160008,1}]',0,0,0,0,'[]'),(10048,20,9999,9999,'[{255,36180001,8000}]','[{0,32160009,1}]',0,0,0,0,'[]'),(10049,20,9999,9999,'[{255,36180001,10000}]','[{0,32160010,1}]',0,0,0,0,'[]'),(10050,20,1,1000,'[{255,36180001,7}]','[{0,38260001,1}]',0,0,0,0,'[]'),(10051,30,9999,9999,'[{255,36180001,500}]','[{0,32080112,1}]',0,0,0,0,'[]'),(10052,30,9999,9999,'[{255,36180001,500}]','[{0,32080212,1}]',0,0,0,0,'[]'),(10053,30,9999,9999,'[{255,36180001,500}]','[{0,32080312,1}]',0,0,0,0,'[]'),(10054,30,9999,9999,'[{255,36180001,500}]','[{0,32080412,1}]',0,0,0,0,'[]'),(10055,30,220,355,'[{255,36180001,500}]','[{0,32080512,1}]',0,0,0,0,'[]'),(10056,30,260,400,'[{255,36180001,500}]','[{0,32080612,1}]',0,0,0,0,'[]'),(10057,30,300,500,'[{255,36180001,500}]','[{0,32080712,1}]',0,0,0,0,'[]'),(10058,30,355,520,'[{255,36180001,500}]','[{0,32080812,1}]',0,0,0,0,'[]'),(10059,30,400,620,'[{255,36180001,500}]','[{0,32080912,1}]',0,0,0,0,'[]'),(10060,30,500,650,'[{255,36180001,500}]','[{0,32081012,1}]',0,0,0,0,'[]'),(10061,30,520,700,'[{255,36180001,500}]','[{0,32081112,1}]',0,0,0,0,'[]'),(10062,30,620,800,'[{255,36180001,500}]','[{0,32081212,1}]',0,0,0,0,'[]'),(10063,30,650,900,'[{255,36180001,500}]','[{0,32081312,1}]',0,0,0,0,'[]'),(10064,30,700,1000,'[{255,36180001,500}]','[{0,32081412,1}]',0,0,0,0,'[]'),(10065,30,800,1000,'[{255,36180001,500}]','[{0,32081512,1}]',0,0,0,0,'[]'),(10066,30,900,1000,'[{255,36180001,1300}]','[{0,32081612,1}]',0,0,0,0,'[]'),(10067,30,1,1000,'[{255,36180001,20}]','[{0,32030201,1}]',0,0,0,0,'[]'),(10068,30,1,1000,'[{255,36180001,60}]','[{0,32030301,1}]',0,0,0,0,'[]'),(10069,30,1,1000,'[{255,36180001,180}]','[{0,32030401,1}]',0,0,0,0,'[]'),(10070,30,1,1000,'[{255,36180001,540}]','[{0,32030501,1}]',0,0,0,0,'[]'),(10071,30,1,1000,'[{255,36180001,1620}]','[{0,32030601,1}]',0,0,0,0,'[]'),(10072,30,9999,9999,'[{255,36180001,5000}]','[{0,32160008,1}]',0,0,0,0,'[]'),(10073,30,1,9999,'[{255,36180001,8000}]','[{0,32160009,1}]',0,0,0,0,'[]'),(10074,30,9999,9999,'[{255,36180001,10000}]','[{0,32160010,1}]',0,0,0,0,'[]'),(10075,30,1,1000,'[{255,36180001,7}]','[{0,38260001,1}]',0,0,0,0,'[]');
/*!40000 ALTER TABLE `base_goods_exchange_rule` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_goods_exchange_type`
--

DROP TABLE IF EXISTS `base_goods_exchange_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_goods_exchange_type` (
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '兑换类型',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '描述',
  PRIMARY KEY (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='兑换类型';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_goods_exchange_type`
--

LOCK TABLES `base_goods_exchange_type` WRITE;
/*!40000 ALTER TABLE `base_goods_exchange_type` DISABLE KEYS */;
INSERT INTO `base_goods_exchange_type` VALUES (2,'转职兑换'),(3,'魂珠兑换'),(10,'装备兑换'),(20,'巅峰兑换'),(30,'至尊兑换');
/*!40000 ALTER TABLE `base_goods_exchange_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_goods_exp`
--

DROP TABLE IF EXISTS `base_goods_exp`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_goods_exp` (
  `goods_id` int(10) unsigned NOT NULL COMMENT '物品id',
  `min_lv` smallint(5) unsigned NOT NULL COMMENT '等级区间左',
  `max_lv` smallint(5) unsigned NOT NULL COMMENT '等级区间右',
  `exp` int(10) unsigned NOT NULL COMMENT '固定经验',
  `up_lv` int(11) NOT NULL DEFAULT '0' COMMENT '升级数',
  PRIMARY KEY (`goods_id`,`min_lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='经验丹动态经验';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_goods_exp`
--

LOCK TABLES `base_goods_exp` WRITE;
/*!40000 ALTER TABLE `base_goods_exp` DISABLE KEYS */;
INSERT INTO `base_goods_exp` VALUES (37010000,1,300,10,1),(37010000,301,1000,1500000,0),(37010001,1,220,0,1),(37010001,221,1000,12000000,0),(37010002,1,280,0,1),(37010002,281,1000,57000000,0),(37010101,1,1000,155000,0),(37010102,1,1000,620000,0),(37010103,1,1000,750000,0),(37010201,1,1000,1100000,0),(37010202,1,1000,1400000,0),(37010203,1,1000,1400000,0),(37010301,1,1000,1400000,0),(37010302,1,1000,1400000,0),(37010303,1,1000,1400000,0),(37010401,1,1000,1400000,0),(37010402,1,1000,1400000,0),(37010403,1,1000,1400000,0),(37010501,1,1000,1000,0),(37010502,1,1000,2000,0),(37010503,1,1000,5000,0),(37010504,1,1000,10000,0),(37010505,1,1000,20000,0),(37010506,1,1000,50000,0),(37010507,1,1000,100000,0),(37010508,1,1000,200000,0),(37010509,1,1000,500000,0),(37010510,1,1000,1000000,0),(37010511,1,1000,2000000,0),(37010512,1,1000,5000000,0);
/*!40000 ALTER TABLE `base_goods_exp` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_goods_label`
--

DROP TABLE IF EXISTS `base_goods_label`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_goods_label` (
  `label_id` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '标签ID',
  `label_name` varchar(50) NOT NULL DEFAULT '' COMMENT '标签名称@lang@',
  PRIMARY KEY (`label_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品标签表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_goods_label`
--

LOCK TABLES `base_goods_label` WRITE;
/*!40000 ALTER TABLE `base_goods_label` DISABLE KEYS */;
INSERT INTO `base_goods_label` VALUES (1,'常用'),(2,'装备'),(3,'伙伴'),(4,'全部');
/*!40000 ALTER TABLE `base_goods_label` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_goods_location`
--

DROP TABLE IF EXISTS `base_goods_location`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_goods_location` (
  `type` int(11) NOT NULL COMMENT '位置类型',
  `name` varchar(50) NOT NULL COMMENT '名称',
  PRIMARY KEY (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品位置类型';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_goods_location`
--

LOCK TABLES `base_goods_location` WRITE;
/*!40000 ALTER TABLE `base_goods_location` DISABLE KEYS */;
INSERT INTO `base_goods_location` VALUES (0,'地上'),(1,'身上'),(2,'坐骑装备'),(3,'装备二'),(4,'背包'),(5,'仓库');
/*!40000 ALTER TABLE `base_goods_location` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_goods_passoff_type`
--

DROP TABLE IF EXISTS `base_goods_passoff_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_goods_passoff_type` (
  `type` varchar(255) NOT NULL COMMENT '类型',
  `id` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `about` varchar(255) NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品消耗类型配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_goods_passoff_type`
--

LOCK TABLES `base_goods_passoff_type` WRITE;
/*!40000 ALTER TABLE `base_goods_passoff_type` DISABLE KEYS */;
INSERT INTO `base_goods_passoff_type` VALUES ('goods_use',2,'背包使用'),('title_consume',3,'头衔升级，物品消耗'),('chat',4,'聊天'),('act',5,'活动'),('intimacy_present',6,'亲密度物品'),('recruit_partner',7,'招募伙伴'),('partner_callback',8,'召回伙伴'),('partner_wash',9,'洗髓伙伴'),('add_exp',10,'伙伴使用经验药水'),('equip_identify',11,'装备鉴定'),('equip_wash',12,'装备洗练'),('equip_stren',13,'装备强化'),('stren_break',14,'强化突破'),('stone_compose',15,'合成英灵石'),('unequip_stone',16,'卸载英灵石'),('mount_card',17,'坐骑卡使用'),('jjc_challeng_num',18,'竞技场刷新挑战次数'),('partner_promote',19,'伙伴资质提升'),('partner_learn_sk',20,'伙伴学习技能'),('offline_exp',21,'获取离线经验消耗物品'),('fashion_stain',22,'时装染色');
/*!40000 ALTER TABLE `base_goods_passoff_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_goods_price`
--

DROP TABLE IF EXISTS `base_goods_price`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_goods_price` (
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型id',
  `price_type` smallint(6) unsigned DEFAULT '1' COMMENT '价格类型',
  `price` int(11) unsigned DEFAULT '0' COMMENT '购买价格',
  `sell_price_type` smallint(6) unsigned DEFAULT '3' COMMENT '出售价格类型',
  `sell_price` int(11) unsigned DEFAULT '0' COMMENT '出售价格',
  PRIMARY KEY (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_goods_price`
--

LOCK TABLES `base_goods_price` WRITE;
/*!40000 ALTER TABLE `base_goods_price` DISABLE KEYS */;
INSERT INTO `base_goods_price` VALUES (4901001,1,50,3,500),(4901002,1,100,3,1000),(4901003,1,200,3,2000),(4901004,1,300,3,3000),(4901005,1,400,3,4000),(4901006,1,550,3,5500),(4901007,1,750,3,7500),(4901008,1,1000,3,10000),(4901009,1,80,3,800),(4901010,1,150,3,1500),(4901011,1,250,3,2500),(4902001,1,100,3,1000),(4902002,1,150,3,1500),(4902003,1,180,3,1800),(4902004,1,250,3,2500),(4902005,1,200,3,2000),(4902006,1,200,3,2000),(4902007,1,200,3,2000),(4902008,1,200,3,2000),(4902009,1,200,3,2000),(4902010,1,200,3,2000),(4902011,1,200,3,2000),(4902012,1,200,3,2000),(4902013,1,200,3,2000),(4902014,1,200,3,2000),(4902015,1,200,3,2000),(4902016,1,200,3,2000),(4902017,1,200,3,2000),(4903001,1,50,3,500),(4903002,1,100,3,1000),(4903003,1,200,3,2000),(4903004,1,300,3,3000),(4904001,1,40,3,400),(4904002,1,80,3,800),(4904003,1,120,3,1200),(4904004,1,160,3,1600),(4904005,1,180,3,1800),(4905001,1,120,3,1200),(4905002,1,120,3,1200),(4905003,1,120,3,1200),(4905004,1,150,3,1500),(4906001,1,80,3,800),(4906002,1,150,3,1500),(4906003,1,220,3,2200),(4906004,1,300,3,3000),(4907001,1,80,3,800),(4907002,1,80,3,800),(4907003,1,250,3,2500),(4907004,1,250,3,2500),(4907005,1,150,3,1500),(4907006,1,150,3,1500),(4907007,1,80,3,800),(4907008,1,150,3,1500),(4907009,1,240,3,2400),(4907010,1,80,3,800),(4907011,1,150,3,1500),(4907012,1,240,3,2400),(4908001,1,500,3,5000),(4908002,1,300,3,3000),(4908003,1,180,3,1800),(4908004,1,500,3,5000),(4908005,1,300,3,3000),(4908006,1,180,3,1800),(4908007,1,500,3,5000),(4908008,1,300,3,3000),(4908009,1,180,3,1800),(4908010,1,500,3,5000),(4908011,1,300,3,3000),(4908012,1,180,3,1800),(4908013,1,500,3,5000),(4908014,1,300,3,3000),(4908015,1,180,3,1800),(4908016,1,500,3,5000),(4908017,1,300,3,3000),(4908018,1,180,3,1800),(4908019,1,550,3,5500),(4908020,1,100,3,1000),(4908021,1,99999,3,1),(4909001,1,150,3,1500),(4909002,1,250,3,2500),(4910001,1,150,3,1500),(4910002,1,150,3,1500),(4911001,1,30,3,300),(4911002,1,60,3,600),(4911003,1,100,3,1000),(4911004,1,140,3,1400),(4911005,1,180,3,1800),(4911006,1,250,3,2500),(4911007,1,300,3,3000),(4911008,1,350,3,3500),(4911009,1,400,3,4000),(4911010,1,500,3,5000),(4911011,1,650,3,6500),(4912001,1,200,3,2000),(4912002,1,400,3,4000),(4912003,1,600,3,6000),(4912004,1,250,3,2500),(4913001,1,150,3,1500),(4913002,1,250,3,2500),(4913003,1,350,3,3500),(4914001,1,120,3,1200),(4914002,1,200,3,2000),(4914003,1,300,3,3000),(4915001,1,120,3,1200),(4915002,1,200,3,2000),(4915003,1,300,3,3000),(11010001,1,99999,3,1),(11010002,1,99999,3,1),(11010003,1,99999,3,1),(11010004,1,99999,3,1),(11010005,1,99999,3,1),(11020001,1,4,3,40),(11020002,1,8,3,80),(11020003,1,16,3,160),(11030001,1,99999,3,1),(11030002,1,99999,3,1),(11030003,1,99999,3,1),(11030004,1,99999,3,1),(11030005,1,99999,3,1),(11040001,1,30,3,300),(11040002,1,30,3,300),(11040003,1,30,3,300),(11040004,1,30,3,300),(11040005,1,30,3,300),(12010001,1,666,3,6660),(12010002,1,288,3,2880),(12010003,1,300,3,3000),(12010004,1,288,3,2880),(12010005,1,488,3,4880),(12010006,1,388,3,3880),(12010007,1,388,3,3880),(12010008,1,588,3,5880),(12010009,1,99999,3,1),(12011001,1,999999,3,1000),(12012001,1,999999,3,1000),(12013001,1,999999,3,1000),(12020001,1,666,3,6660),(12020002,1,288,3,2880),(12020003,1,300,3,3000),(12020004,1,288,3,2880),(12020005,1,488,3,4880),(12020006,1,388,3,3880),(12020007,1,388,3,3880),(12020008,1,588,3,5880),(12020009,1,99999,3,1),(12021001,1,999999,3,1000),(12022001,1,999999,3,1000),(12023001,1,999999,3,1000),(12030001,1,666,3,6660),(12030002,1,288,3,2880),(12030003,1,300,3,3000),(12030004,1,288,3,2880),(12030005,1,488,3,4880),(12030006,1,388,3,3880),(12030007,1,388,3,3880),(12030008,1,588,3,5880),(12030009,1,99999,3,1),(12031001,1,999999,3,1000),(12032001,1,999999,3,1000),(12033001,1,999999,3,1000),(12040001,1,666,3,6660),(12040002,1,99999,3,1),(12040003,1,300,3,3000),(12040004,1,99999,3,1),(12040005,1,488,3,4880),(12040006,1,388,3,3880),(12040007,1,388,3,3880),(12040008,1,588,3,5880),(12040009,1,99999,3,1),(12041001,1,999999,3,1000),(12042001,1,999999,3,1000),(12043001,1,999999,3,1000),(12060001,1,99999,3,1),(12060002,1,99999,3,1),(12060003,1,99999,3,1),(12060004,1,99999,3,1),(12120001,1,99,3,990),(12120002,1,99,3,990),(12120003,1,99,3,990),(12120004,1,99,3,990),(12120005,1,99,3,990),(12120006,1,99,3,990),(14010101,1,10,3,1),(14010102,1,30,3,1),(14010103,1,90,3,1),(14010104,1,270,3,1),(14010105,1,810,3,1),(14010106,1,2430,3,1),(14010107,1,7290,3,1),(14010108,1,21870,3,1),(14010109,1,65610,3,1),(14010301,1,10,3,1),(14010302,1,30,3,1),(14010303,1,90,3,1),(14010304,1,270,3,1),(14010305,1,810,3,1),(14010306,1,2430,3,1),(14010307,1,7290,3,1),(14010308,1,21870,3,1),(14010309,1,65610,3,1),(14010501,1,10,3,1),(14010502,1,30,3,1),(14010503,1,90,3,1),(14010504,1,270,3,1),(14010505,1,810,3,1),(14010506,1,2430,3,1),(14010507,1,7290,3,1),(14010508,1,21870,3,1),(14010509,1,65610,3,1),(14010701,1,10,3,1),(14010702,1,30,3,1),(14010703,1,90,3,1),(14010704,1,270,3,1),(14010705,1,810,3,1),(14010706,1,2430,3,1),(14010707,1,7290,3,1),(14010708,1,21870,3,1),(14010709,1,65610,3,1),(14020201,1,10,3,1),(14020202,1,30,3,1),(14020203,1,90,3,1),(14020204,1,270,3,1),(14020205,1,810,3,1),(14020206,1,2430,3,1),(14020207,1,7290,3,1),(14020208,1,21870,3,1),(14020209,1,65610,3,1),(14020401,1,10,3,1),(14020402,1,30,3,1),(14020403,1,90,3,1),(14020404,1,270,3,1),(14020405,1,810,3,1),(14020406,1,2430,3,1),(14020407,1,7290,3,1),(14020408,1,21870,3,1),(14020409,1,65610,3,1),(14020601,1,10,3,1),(14020602,1,30,3,1),(14020603,1,90,3,1),(14020604,1,270,3,1),(14020605,1,810,3,1),(14020606,1,2430,3,1),(14020607,1,7290,3,1),(14020608,1,21870,3,1),(14020609,1,65610,3,1),(14020801,1,10,3,1),(14020802,1,30,3,1),(14020803,1,90,3,1),(14020804,1,270,3,1),(14020805,1,810,3,1),(14020806,1,2430,3,1),(14020807,1,7290,3,1),(14020808,1,21870,3,1),(14020809,1,65610,3,1),(14100013,1,1,3,10),(14100015,1,1,3,10),(14100024,1,1,3,10),(14100026,1,1,3,10),(14100035,1,1,3,10),(14100037,1,1,3,10),(14100046,1,1,3,10),(14100048,1,1,3,10),(14100057,1,1,3,10),(14100068,1,1,3,10),(14100071,1,1,3,10),(14100082,1,1,3,10),(14110001,1,50,3,500),(14120001,1,4,3,3),(15020101,1,6,3,60),(15020102,1,20,3,200),(15020103,1,60,3,600),(15020201,1,6,3,60),(15020202,1,20,3,200),(15020203,1,60,3,600),(15020301,1,6,3,60),(15020302,1,20,3,200),(15020303,1,60,3,600),(16010001,1,50,3,500),(16010002,1,50,3,500),(16010003,1,200,3,2000),(16010004,1,600,3,6000),(16020001,1,9,3,90),(16020002,1,27,3,270),(16020003,1,45,3,450),(16040101,1,99999,3,1),(16040102,1,99999,3,1),(16040103,1,99999,3,1),(16040104,1,99999,3,1),(16040105,1,99999,3,1),(16040111,1,99999,3,1),(16040112,1,99999,3,1),(16040113,1,99999,3,1),(16040114,1,99999,3,1),(16040115,1,99999,3,1),(16040121,1,99999,3,1),(16040122,1,99999,3,1),(16040123,1,99999,3,1),(16040124,1,99999,3,1),(16040125,1,99999,3,1),(16040131,1,99999,3,1),(16040132,1,99999,3,1),(16040133,1,99999,3,1),(16040134,1,99999,3,1),(16040135,1,99999,3,1),(16040141,1,99999,3,1),(16040142,1,99999,3,1),(16040143,1,99999,3,1),(16040144,1,99999,3,1),(16040145,1,99999,3,1),(16040201,1,99999,3,1),(16040202,1,99999,3,1),(16040203,1,99999,3,1),(16040204,1,99999,3,1),(16040205,1,99999,3,1),(16040211,1,99999,3,1),(16040212,1,99999,3,1),(16040213,1,99999,3,1),(16040214,1,99999,3,1),(16040215,1,99999,3,1),(16040221,1,99999,3,1),(16040222,1,99999,3,1),(16040223,1,99999,3,1),(16040224,1,99999,3,1),(16040225,1,99999,3,1),(16040231,1,99999,3,1),(16040232,1,99999,3,1),(16040233,1,99999,3,1),(16040234,1,99999,3,1),(16040235,1,99999,3,1),(16040241,1,99999,3,1),(16040242,1,99999,3,1),(16040243,1,99999,3,1),(16040244,1,99999,3,1),(16040245,1,99999,3,1),(16040301,1,99999,3,1),(16040302,1,99999,3,1),(16040303,1,99999,3,1),(16040304,1,99999,3,1),(16040305,1,99999,3,1),(16040311,1,99999,3,1),(16040312,1,99999,3,1),(16040313,1,99999,3,1),(16040314,1,99999,3,1),(16040315,1,99999,3,1),(16040321,1,99999,3,1),(16040322,1,99999,3,1),(16040323,1,99999,3,1),(16040324,1,99999,3,1),(16040325,1,99999,3,1),(16040331,1,99999,3,1),(16040332,1,99999,3,1),(16040333,1,99999,3,1),(16040334,1,99999,3,1),(16040335,1,99999,3,1),(16040341,1,99999,3,1),(16040342,1,99999,3,1),(16040343,1,99999,3,1),(16040344,1,99999,3,1),(16040345,1,99999,3,1),(16040401,1,99999,3,1),(16040402,1,99999,3,1),(16040403,1,99999,3,1),(16040404,1,99999,3,1),(16040405,1,99999,3,1),(16040411,1,99999,3,1),(16040412,1,99999,3,1),(16040413,1,99999,3,1),(16040414,1,99999,3,1),(16040415,1,99999,3,1),(16040421,1,99999,3,1),(16040422,1,99999,3,1),(16040423,1,99999,3,1),(16040424,1,99999,3,1),(16040425,1,99999,3,1),(16040431,1,99999,3,1),(16040432,1,99999,3,1),(16040433,1,99999,3,1),(16040434,1,99999,3,1),(16040435,1,99999,3,1),(16040441,1,99999,3,1),(16040442,1,99999,3,1),(16040443,1,99999,3,1),(16040444,1,99999,3,1),(16040445,1,99999,3,1),(16040501,1,99999,3,1),(16040502,1,99999,3,1),(16040503,1,99999,3,1),(16040504,1,99999,3,1),(16040505,1,99999,3,1),(16040511,1,99999,3,1),(16040512,1,99999,3,1),(16040513,1,99999,3,1),(16040514,1,99999,3,1),(16040515,1,99999,3,1),(16040521,1,99999,3,1),(16040522,1,99999,3,1),(16040523,1,99999,3,1),(16040524,1,99999,3,1),(16040525,1,99999,3,1),(16040531,1,99999,3,1),(16040532,1,99999,3,1),(16040533,1,99999,3,1),(16040534,1,99999,3,1),(16040535,1,99999,3,1),(16040541,1,99999,3,1),(16040542,1,99999,3,1),(16040543,1,99999,3,1),(16040544,1,99999,3,1),(16040545,1,99999,3,1),(16040601,1,99999,3,1),(16040602,1,99999,3,1),(16040603,1,99999,3,1),(16040604,1,99999,3,1),(16040605,1,99999,3,1),(16040611,1,99999,3,1),(16040612,1,99999,3,1),(16040613,1,99999,3,1),(16040614,1,99999,3,1),(16040615,1,99999,3,1),(16040621,1,99999,3,1),(16040622,1,99999,3,1),(16040623,1,99999,3,1),(16040624,1,99999,3,1),(16040625,1,99999,3,1),(16040631,1,99999,3,1),(16040632,1,99999,3,1),(16040633,1,99999,3,1),(16040634,1,99999,3,1),(16040635,1,99999,3,1),(16040641,1,99999,3,1),(16040642,1,99999,3,1),(16040643,1,99999,3,1),(16040644,1,99999,3,1),(16040645,1,99999,3,1),(16050001,1,1,3,10),(16060001,1,20,3,200),(16060002,1,60,3,600),(16070001,1,99999,3,1),(17010001,1,1,3,3),(17010002,1,1,3,10),(17010003,1,4,3,36),(17020001,1,25,3,250),(17020002,1,50,3,500),(17020003,1,80,3,800),(17020004,1,200,3,2000),(17030101,1,4000,3,40000),(17030102,1,99999,3,1),(17030103,1,99999,3,1),(17030104,1,99999,3,1),(17030105,1,99999,3,1),(17030201,1,4000,3,40000),(17030202,1,99999,3,1),(17030203,1,99999,3,1),(17030204,1,99999,3,1),(17030205,1,99999,3,1),(17030301,1,99999,3,1),(17030302,1,99999,3,1),(17030303,1,99999,3,1),(17030304,1,99999,3,1),(17030305,1,99999,3,1),(17030401,1,4000,3,40000),(17030402,1,99999,3,1),(17030403,1,99999,3,1),(17030404,1,99999,3,1),(17030405,1,99999,3,1),(17040001,1,500,3,5000),(17040002,1,2000,3,20000),(18010001,1,200,3,2000),(18020001,1,4,3,40),(18020002,1,12,3,120),(18020003,1,36,3,360),(18030001,1,150,3,1500),(18040001,1,800,3,8000),(18040002,1,99999,3,1),(18040003,1,99999,3,1),(18040004,1,99999,3,1),(18040005,1,99999,3,1),(18040006,1,99999,3,1),(18040007,1,99999,3,1),(18040101,1,99999,3,1),(18040102,1,99999,3,1),(18041001,1,99999,3,1),(18041002,1,99999,3,1),(18041003,1,99999,3,1),(18041004,1,99999,3,1),(18041005,1,99999,3,1),(18041006,1,99999,3,1),(18041007,1,99999,3,1),(18041101,1,99999,3,1),(18041102,1,99999,3,1),(20010011,1,99999,3,1),(20010012,1,99999,3,1),(20010013,1,99999,3,1),(20010014,1,99999,3,1),(20010015,1,99999,3,1),(20010016,1,99999,3,1),(20010021,1,99999,3,1),(20010022,1,99999,3,1),(20010023,1,99999,3,1),(20010024,1,99999,3,1),(20010025,1,99999,3,1),(20010026,1,99999,3,1),(20010031,1,99999,3,1),(20010032,1,99999,3,1),(20010033,1,99999,3,1),(20010034,1,99999,3,1),(20010035,1,99999,3,1),(20010036,1,99999,3,1),(20010041,1,99999,3,1),(20010042,1,99999,3,1),(20010043,1,99999,3,1),(20010044,1,99999,3,1),(20010045,1,99999,3,1),(20010046,1,99999,3,1),(20020001,1,50,3,500),(20020002,1,50,3,500),(20020003,1,200,3,2000),(20020004,1,600,3,6000),(20040000,1,800,3,8000),(20040001,1,200,3,2000),(20040002,1,160,3,1600),(20040003,1,240,3,2400),(20040004,1,300,3,3000),(20040005,1,1000,3,10000),(20040006,1,1500,3,15000),(24010001,1,6,3,60),(24010002,1,20,3,200),(24010003,1,60,3,600),(24020001,1,25,3,250),(24020002,1,50,3,500),(24020003,1,80,3,800),(24020004,1,200,3,2000),(24030001,1,99999,3,1),(24030002,1,99999,3,1),(24030003,1,99999,3,1),(24030004,1,99999,3,1),(24030005,1,99999,3,1),(24030006,1,99999,3,1),(24030007,1,99999,3,1),(24030008,1,99999,3,1),(24030009,1,99999,3,1),(24031001,1,99999,3,1),(24031002,1,99999,3,1),(24031003,1,99999,3,1),(24031004,1,99999,3,1),(24031005,1,99999,3,1),(24031006,1,99999,3,1),(24031007,1,99999,3,1),(24031008,1,99999,3,1),(24031009,1,99999,3,1),(32000000,1,99999,3,1),(32000011,1,99999,3,1),(32000012,1,99999,3,1),(32000013,1,99999,3,1),(32000021,1,99999,3,1),(32000022,1,99999,3,1),(32000023,1,99999,3,1),(32000024,1,99999,3,1),(32000025,1,99999,3,1),(32000026,1,99999,3,1),(32000027,1,99999,3,1),(32000028,1,99999,3,1),(32000029,1,99999,3,1),(32000030,1,99999,3,1),(32000031,1,99999,3,1),(32000032,1,99999,3,1),(32000033,1,99999,3,1),(32000034,1,99999,3,1),(32000035,1,99999,3,1),(32000036,1,99999,3,1),(32000037,1,99999,3,1),(32010001,1,99999,3,1),(32010003,1,99999,3,1),(32010004,1,99999,3,1),(32010006,1,99999,3,1),(32010015,1,99999,3,1),(32010016,1,99999,3,1),(32010031,1,99999,3,1),(32010032,1,99999,3,1),(32010033,1,99999,3,1),(32010034,1,99999,3,1),(32010041,1,99999,3,1),(32010042,1,99999,3,1),(32010043,1,99999,3,1),(32010044,1,99999,3,1),(32010045,1,99999,3,1),(32010046,1,99999,3,1),(32010047,1,99999,3,1),(32010048,1,99999,3,1),(32010052,1,99999,3,1),(32010053,1,99999,3,1),(32010054,1,99999,3,1),(32010057,1,99999,3,1),(32010067,1,99999,3,1),(32020111,1,99999,3,1),(32020112,1,99999,3,1),(32020113,1,99999,3,1),(32020114,1,99999,3,1),(32020121,1,99999,3,1),(32020122,1,99999,3,1),(32020123,1,99999,3,1),(32020124,1,99999,3,1),(32030101,1,99999,3,1),(32030102,1,99999,3,1),(32030103,1,99999,3,1),(32030201,1,99999,3,1),(32030202,1,99999,3,1),(32030203,1,99999,3,1),(32030301,1,99999,3,1),(32030302,1,99999,3,1),(32030303,1,99999,3,1),(32030401,1,99999,3,1),(32030402,1,99999,3,1),(32030403,1,99999,3,1),(32030501,1,99999,3,1),(32030502,1,99999,3,1),(32030503,1,99999,3,1),(32030601,1,99999,3,1),(32030602,1,99999,3,1),(32030603,1,99999,3,1),(32030701,1,99999,3,1),(32030702,1,99999,3,1),(32030703,1,99999,3,1),(32030801,1,99999,3,1),(32030802,1,99999,3,1),(32030803,1,99999,3,1),(32030901,1,99999,3,1),(32030902,1,99999,3,1),(32030903,1,99999,3,1),(32050004,1,18,3,180),(32050005,1,88,3,880),(32050006,1,188,3,1880),(32080111,1,99999,3,1),(32080112,1,99999,3,1),(32080113,1,99999,3,1),(32080114,1,99999,3,1),(32080121,1,99999,3,1),(32080122,1,99999,3,1),(32080123,1,99999,3,1),(32080124,1,99999,3,1),(32080131,1,99999,3,1),(32080132,1,60,3,600),(32080133,1,70,3,700),(32080134,1,110,3,1100),(32080141,1,99999,3,1),(32080142,1,110,3,1100),(32080143,1,140,3,1400),(32080144,1,210,3,2100),(32080151,1,99999,3,1),(32080152,1,99999,3,1),(32080153,1,99999,3,1),(32080154,1,99999,3,1),(32080161,1,99999,3,1),(32080162,1,99999,3,1),(32080163,1,99999,3,1),(32080164,1,99999,3,1),(32080171,1,99999,3,1),(32080172,1,99999,3,1),(32080173,1,99999,3,1),(32080174,1,99999,3,1),(32080181,1,99999,3,1),(32080182,1,99999,3,1),(32080183,1,99999,3,1),(32080184,1,99999,3,1),(32080191,1,99999,3,1),(32080192,1,99999,3,1),(32080193,1,99999,3,1),(32080194,1,99999,3,1),(32080201,1,99999,3,1),(32080202,1,99999,3,1),(32080203,1,99999,3,1),(32080204,1,99999,3,1),(32080211,1,99999,3,1),(32080212,1,99999,3,1),(32080213,1,99999,3,1),(32080214,1,99999,3,1),(32080221,1,99999,3,1),(32080222,1,99999,3,1),(32080223,1,99999,3,1),(32080224,1,99999,3,1),(32080231,1,99999,3,1),(32080232,1,80,3,800),(32080233,1,100,3,1000),(32080234,1,150,3,1500),(32080241,1,99999,3,1),(32080242,1,160,3,1600),(32080243,1,200,3,2000),(32080244,1,300,3,3000),(32080251,1,99999,3,1),(32080252,1,99999,3,1),(32080253,1,99999,3,1),(32080254,1,99999,3,1),(32080261,1,99999,3,1),(32080262,1,99999,3,1),(32080263,1,99999,3,1),(32080264,1,99999,3,1),(32080271,1,99999,3,1),(32080272,1,99999,3,1),(32080273,1,99999,3,1),(32080274,1,99999,3,1),(32080281,1,99999,3,1),(32080282,1,99999,3,1),(32080283,1,99999,3,1),(32080284,1,99999,3,1),(32080291,1,99999,3,1),(32080292,1,99999,3,1),(32080293,1,99999,3,1),(32080294,1,99999,3,1),(32080301,1,99999,3,1),(32080302,1,99999,3,1),(32080303,1,99999,3,1),(32080304,1,99999,3,1),(32080311,1,99999,3,1),(32080312,1,99999,3,1),(32080313,1,99999,3,1),(32080314,1,99999,3,1),(32080321,1,99999,3,1),(32080322,1,99999,3,1),(32080323,1,99999,3,1),(32080324,1,99999,3,1),(32080331,1,99999,3,1),(32080332,1,120,3,1200),(32080333,1,150,3,1500),(32080334,1,210,3,2100),(32080341,1,99999,3,1),(32080342,1,240,3,2400),(32080343,1,300,3,3000),(32080344,1,420,3,4200),(32080351,1,99999,3,1),(32080352,1,99999,3,1),(32080353,1,99999,3,1),(32080354,1,99999,3,1),(32080361,1,99999,3,1),(32080362,1,99999,3,1),(32080363,1,99999,3,1),(32080364,1,99999,3,1),(32080371,1,99999,3,1),(32080372,1,99999,3,1),(32080373,1,99999,3,1),(32080374,1,99999,3,1),(32080381,1,99999,3,1),(32080382,1,99999,3,1),(32080383,1,99999,3,1),(32080384,1,99999,3,1),(32080391,1,99999,3,1),(32080392,1,99999,3,1),(32080393,1,99999,3,1),(32080394,1,99999,3,1),(32080401,1,99999,3,1),(32080402,1,99999,3,1),(32080403,1,99999,3,1),(32080404,1,99999,3,1),(32080411,1,99999,3,1),(32080412,1,99999,3,1),(32080413,1,99999,3,1),(32080414,1,99999,3,1),(32080421,1,99999,3,1),(32080422,1,99999,3,1),(32080423,1,99999,3,1),(32080424,1,99999,3,1),(32080431,1,99999,3,1),(32080432,1,160,3,1600),(32080433,1,200,3,2000),(32080434,1,300,3,3000),(32080441,1,99999,3,1),(32080442,1,320,3,3200),(32080443,1,400,3,4000),(32080444,1,600,3,6000),(32080451,1,99999,3,1),(32080452,1,99999,3,1),(32080453,1,99999,3,1),(32080454,1,99999,3,1),(32080461,1,99999,3,1),(32080462,1,99999,3,1),(32080463,1,99999,3,1),(32080464,1,99999,3,1),(32080471,1,99999,3,1),(32080472,1,99999,3,1),(32080473,1,99999,3,1),(32080474,1,99999,3,1),(32080481,1,99999,3,1),(32080482,1,99999,3,1),(32080483,1,99999,3,1),(32080484,1,99999,3,1),(32080491,1,99999,3,1),(32080492,1,99999,3,1),(32080493,1,99999,3,1),(32080494,1,99999,3,1),(32080501,1,99999,3,1),(32080502,1,99999,3,1),(32080503,1,99999,3,1),(32080504,1,99999,3,1),(32080511,1,99999,3,1),(32080512,1,99999,3,1),(32080513,1,99999,3,1),(32080514,1,99999,3,1),(32080521,1,99999,3,1),(32080522,1,99999,3,1),(32080523,1,99999,3,1),(32080524,1,99999,3,1),(32080531,1,99999,3,1),(32080532,1,200,3,2000),(32080533,1,250,3,2500),(32080534,1,360,3,3600),(32080541,1,99999,3,1),(32080542,1,400,3,4000),(32080543,1,500,3,5000),(32080544,1,720,3,7200),(32080551,1,99999,3,1),(32080552,1,99999,3,1),(32080553,1,99999,3,1),(32080554,1,99999,3,1),(32080561,1,99999,3,1),(32080562,1,99999,3,1),(32080563,1,99999,3,1),(32080564,1,99999,3,1),(32080571,1,99999,3,1),(32080572,1,99999,3,1),(32080573,1,99999,3,1),(32080574,1,99999,3,1),(32080581,1,99999,3,1),(32080582,1,99999,3,1),(32080583,1,99999,3,1),(32080584,1,99999,3,1),(32080591,1,99999,3,1),(32080592,1,99999,3,1),(32080593,1,99999,3,1),(32080594,1,99999,3,1),(32080601,1,99999,3,1),(32080602,1,99999,3,1),(32080603,1,99999,3,1),(32080604,1,99999,3,1),(32080611,1,99999,3,1),(32080612,1,99999,3,1),(32080613,1,99999,3,1),(32080614,1,99999,3,1),(32080621,1,99999,3,1),(32080622,1,99999,3,1),(32080623,1,99999,3,1),(32080624,1,99999,3,1),(32080631,1,99999,3,1),(32080632,1,240,3,2400),(32080633,1,300,3,3000),(32080634,1,450,3,4500),(32080641,1,99999,3,1),(32080642,1,480,3,4800),(32080643,1,600,3,6000),(32080644,1,900,3,9000),(32080651,1,99999,3,1),(32080652,1,99999,3,1),(32080653,1,99999,3,1),(32080654,1,99999,3,1),(32080661,1,99999,3,1),(32080662,1,99999,3,1),(32080663,1,99999,3,1),(32080664,1,99999,3,1),(32080671,1,99999,3,1),(32080672,1,99999,3,1),(32080673,1,99999,3,1),(32080674,1,99999,3,1),(32080681,1,99999,3,1),(32080682,1,99999,3,1),(32080683,1,99999,3,1),(32080684,1,99999,3,1),(32080691,1,99999,3,1),(32080692,1,99999,3,1),(32080693,1,99999,3,1),(32080694,1,99999,3,1),(32080701,1,99999,3,1),(32080702,1,99999,3,1),(32080703,1,99999,3,1),(32080704,1,99999,3,1),(32080711,1,99999,3,1),(32080712,1,99999,3,1),(32080713,1,99999,3,1),(32080714,1,99999,3,1),(32080721,1,99999,3,1),(32080722,1,99999,3,1),(32080723,1,99999,3,1),(32080724,1,99999,3,1),(32080731,1,99999,3,1),(32080732,1,320,3,3200),(32080733,1,400,3,4000),(32080734,1,600,3,6000),(32080741,1,99999,3,1),(32080742,1,640,3,6400),(32080743,1,800,3,8000),(32080744,1,1200,3,12000),(32080751,1,99999,3,1),(32080752,1,99999,3,1),(32080753,1,99999,3,1),(32080754,1,99999,3,1),(32080761,1,99999,3,1),(32080762,1,99999,3,1),(32080763,1,99999,3,1),(32080764,1,99999,3,1),(32080771,1,99999,3,1),(32080772,1,99999,3,1),(32080773,1,99999,3,1),(32080774,1,99999,3,1),(32080781,1,99999,3,1),(32080782,1,99999,3,1),(32080783,1,99999,3,1),(32080784,1,99999,3,1),(32080791,1,99999,3,1),(32080792,1,99999,3,1),(32080793,1,99999,3,1),(32080794,1,99999,3,1),(32080801,1,99999,3,1),(32080802,1,99999,3,1),(32080803,1,99999,3,1),(32080804,1,99999,3,1),(32080811,1,99999,3,1),(32080812,1,99999,3,1),(32080813,1,99999,3,1),(32080814,1,99999,3,1),(32080821,1,99999,3,1),(32080822,1,99999,3,1),(32080823,1,99999,3,1),(32080824,1,99999,3,1),(32080831,1,99999,3,1),(32080832,1,400,3,4000),(32080833,1,500,3,5000),(32080834,1,750,3,7500),(32080841,1,99999,3,1),(32080842,1,800,3,8000),(32080843,1,1000,3,10000),(32080844,1,1500,3,15000),(32080851,1,99999,3,1),(32080852,1,99999,3,1),(32080853,1,99999,3,1),(32080854,1,99999,3,1),(32080861,1,99999,3,1),(32080862,1,99999,3,1),(32080863,1,99999,3,1),(32080864,1,99999,3,1),(32080871,1,99999,3,1),(32080872,1,99999,3,1),(32080873,1,99999,3,1),(32080874,1,99999,3,1),(32080881,1,99999,3,1),(32080882,1,99999,3,1),(32080883,1,99999,3,1),(32080884,1,99999,3,1),(32080891,1,99999,3,1),(32080892,1,99999,3,1),(32080893,1,99999,3,1),(32080894,1,99999,3,1),(32080901,1,99999,3,1),(32080902,1,99999,3,1),(32080903,1,99999,3,1),(32080904,1,99999,3,1),(32080911,1,99999,3,1),(32080912,1,99999,3,1),(32080913,1,99999,3,1),(32080914,1,99999,3,1),(32080921,1,99999,3,1),(32080922,1,99999,3,1),(32080923,1,99999,3,1),(32080924,1,99999,3,1),(32080931,1,99999,3,1),(32080932,1,480,3,4800),(32080933,1,600,3,6000),(32080934,1,900,3,9000),(32080941,1,99999,3,1),(32080942,1,960,3,9600),(32080943,1,1200,3,12000),(32080944,1,1800,3,18000),(32080951,1,99999,3,1),(32080952,1,99999,3,1),(32080953,1,99999,3,1),(32080954,1,99999,3,1),(32080961,1,99999,3,1),(32080962,1,99999,3,1),(32080963,1,99999,3,1),(32080964,1,99999,3,1),(32080971,1,99999,3,1),(32080972,1,99999,3,1),(32080973,1,99999,3,1),(32080974,1,99999,3,1),(32080981,1,99999,3,1),(32080982,1,99999,3,1),(32080983,1,99999,3,1),(32080984,1,99999,3,1),(32080991,1,99999,3,1),(32080992,1,99999,3,1),(32080993,1,99999,3,1),(32080994,1,99999,3,1),(32081001,1,99999,3,1),(32081002,1,99999,3,1),(32081003,1,99999,3,1),(32081004,1,99999,3,1),(32081011,1,99999,3,1),(32081012,1,99999,3,1),(32081013,1,99999,3,1),(32081014,1,99999,3,1),(32081021,1,99999,3,1),(32081022,1,99999,3,1),(32081023,1,99999,3,1),(32081024,1,99999,3,1),(32081031,1,99999,3,1),(32081032,1,560,3,5600),(32081033,1,700,3,7000),(32081034,1,1050,3,10500),(32081041,1,99999,3,1),(32081042,1,1120,3,11200),(32081043,1,1400,3,14000),(32081044,1,2100,3,21000),(32081051,1,99999,3,1),(32081052,1,99999,3,1),(32081053,1,99999,3,1),(32081054,1,99999,3,1),(32081061,1,99999,3,1),(32081062,1,99999,3,1),(32081063,1,99999,3,1),(32081064,1,99999,3,1),(32081071,1,99999,3,1),(32081072,1,99999,3,1),(32081073,1,99999,3,1),(32081074,1,99999,3,1),(32081081,1,99999,3,1),(32081082,1,99999,3,1),(32081083,1,99999,3,1),(32081084,1,99999,3,1),(32081091,1,99999,3,1),(32081092,1,99999,3,1),(32081093,1,99999,3,1),(32081094,1,99999,3,1),(32081101,1,99999,3,1),(32081102,1,99999,3,1),(32081103,1,99999,3,1),(32081104,1,99999,3,1),(32081111,1,99999,3,1),(32081112,1,99999,3,1),(32081113,1,99999,3,1),(32081114,1,99999,3,1),(32081121,1,99999,3,1),(32081122,1,99999,3,1),(32081123,1,99999,3,1),(32081124,1,99999,3,1),(32081131,1,99999,3,1),(32081132,1,640,3,6400),(32081133,1,800,3,8000),(32081134,1,1200,3,12000),(32081141,1,99999,3,1),(32081142,1,1280,3,12800),(32081143,1,1600,3,16000),(32081144,1,2400,3,24000),(32081151,1,99999,3,1),(32081152,1,99999,3,1),(32081153,1,99999,3,1),(32081154,1,99999,3,1),(32081161,1,99999,3,1),(32081162,1,99999,3,1),(32081163,1,99999,3,1),(32081164,1,99999,3,1),(32081171,1,99999,3,1),(32081172,1,99999,3,1),(32081173,1,99999,3,1),(32081174,1,99999,3,1),(32081181,1,99999,3,1),(32081182,1,99999,3,1),(32081183,1,99999,3,1),(32081184,1,99999,3,1),(32081191,1,99999,3,1),(32081192,1,99999,3,1),(32081193,1,99999,3,1),(32081194,1,99999,3,1),(32081201,1,99999,3,1),(32081202,1,99999,3,1),(32081203,1,99999,3,1),(32081204,1,99999,3,1),(32081211,1,99999,3,1),(32081212,1,99999,3,1),(32081213,1,99999,3,1),(32081214,1,99999,3,1),(32081221,1,99999,3,1),(32081222,1,99999,3,1),(32081223,1,99999,3,1),(32081224,1,99999,3,1),(32081231,1,99999,3,1),(32081232,1,720,3,7200),(32081233,1,900,3,9000),(32081234,1,1350,3,13500),(32081241,1,99999,3,1),(32081242,1,1440,3,14400),(32081243,1,1800,3,18000),(32081244,1,2700,3,27000),(32081251,1,99999,3,1),(32081252,1,99999,3,1),(32081253,1,99999,3,1),(32081254,1,99999,3,1),(32081261,1,99999,3,1),(32081262,1,99999,3,1),(32081263,1,99999,3,1),(32081264,1,99999,3,1),(32081271,1,99999,3,1),(32081272,1,99999,3,1),(32081273,1,99999,3,1),(32081274,1,99999,3,1),(32081281,1,99999,3,1),(32081282,1,99999,3,1),(32081283,1,99999,3,1),(32081284,1,99999,3,1),(32081291,1,99999,3,1),(32081292,1,99999,3,1),(32081293,1,99999,3,1),(32081294,1,99999,3,1),(32081301,1,99999,3,1),(32081302,1,99999,3,1),(32081303,1,99999,3,1),(32081304,1,99999,3,1),(32081311,1,99999,3,1),(32081312,1,99999,3,1),(32081313,1,99999,3,1),(32081314,1,99999,3,1),(32081321,1,99999,3,1),(32081322,1,99999,3,1),(32081323,1,99999,3,1),(32081324,1,99999,3,1),(32081331,1,99999,3,1),(32081332,1,800,3,8000),(32081333,1,1000,3,10000),(32081334,1,1500,3,15000),(32081341,1,99999,3,1),(32081342,1,1600,3,16000),(32081343,1,2000,3,20000),(32081344,1,3000,3,30000),(32081351,1,99999,3,1),(32081352,1,99999,3,1),(32081353,1,99999,3,1),(32081354,1,99999,3,1),(32081361,1,99999,3,1),(32081362,1,99999,3,1),(32081363,1,99999,3,1),(32081364,1,99999,3,1),(32081371,1,99999,3,1),(32081372,1,99999,3,1),(32081373,1,99999,3,1),(32081374,1,99999,3,1),(32081381,1,99999,3,1),(32081382,1,99999,3,1),(32081383,1,99999,3,1),(32081384,1,99999,3,1),(32081391,1,99999,3,1),(32081392,1,99999,3,1),(32081393,1,99999,3,1),(32081394,1,99999,3,1),(32081401,1,99999,3,1),(32081402,1,99999,3,1),(32081403,1,99999,3,1),(32081404,1,99999,3,1),(32081411,1,99999,3,1),(32081412,1,99999,3,1),(32081413,1,99999,3,1),(32081414,1,99999,3,1),(32081421,1,99999,3,1),(32081422,1,99999,3,1),(32081423,1,99999,3,1),(32081424,1,99999,3,1),(32081431,1,99999,3,1),(32081432,1,880,3,8800),(32081433,1,1100,3,11000),(32081434,1,1650,3,16500),(32081441,1,99999,3,1),(32081442,1,1760,3,17600),(32081443,1,2200,3,22000),(32081444,1,3300,3,33000),(32081451,1,99999,3,1),(32081452,1,99999,3,1),(32081453,1,99999,3,1),(32081454,1,99999,3,1),(32081461,1,99999,3,1),(32081462,1,99999,3,1),(32081463,1,99999,3,1),(32081464,1,99999,3,1),(32081471,1,99999,3,1),(32081472,1,99999,3,1),(32081473,1,99999,3,1),(32081474,1,99999,3,1),(32081481,1,99999,3,1),(32081482,1,99999,3,1),(32081483,1,99999,3,1),(32081484,1,99999,3,1),(32081491,1,99999,3,1),(32081492,1,99999,3,1),(32081493,1,99999,3,1),(32081494,1,99999,3,1),(32081501,1,99999,3,1),(32081502,1,99999,3,1),(32081503,1,99999,3,1),(32081504,1,99999,3,1),(32081511,1,99999,3,1),(32081512,1,99999,3,1),(32081513,1,99999,3,1),(32081514,1,99999,3,1),(32081521,1,99999,3,1),(32081522,1,99999,3,1),(32081523,1,99999,3,1),(32081524,1,99999,3,1),(32081531,1,99999,3,1),(32081532,1,960,3,9600),(32081533,1,1200,3,12000),(32081534,1,1800,3,18000),(32081541,1,99999,3,1),(32081542,1,1920,3,19200),(32081543,1,2400,3,24000),(32081544,1,3600,3,36000),(32081551,1,99999,3,1),(32081552,1,99999,3,1),(32081553,1,99999,3,1),(32081554,1,99999,3,1),(32081561,1,99999,3,1),(32081562,1,99999,3,1),(32081563,1,99999,3,1),(32081564,1,99999,3,1),(32081571,1,99999,3,1),(32081572,1,99999,3,1),(32081573,1,99999,3,1),(32081574,1,99999,3,1),(32081581,1,99999,3,1),(32081582,1,99999,3,1),(32081583,1,99999,3,1),(32081584,1,99999,3,1),(32081591,1,99999,3,1),(32081592,1,99999,3,1),(32081593,1,99999,3,1),(32081594,1,99999,3,1),(32081601,1,99999,3,1),(32081602,1,99999,3,1),(32081603,1,99999,3,1),(32081604,1,99999,3,1),(34010001,1,1600,3,16000),(34010002,1,2400,3,24000),(34010003,1,99999,3,1),(34010004,1,99999,3,1),(34010005,1,99999,3,1),(34010006,1,99999,3,1),(34010007,1,99999,3,1),(34010008,1,99999,3,1),(34010009,1,99999,3,1),(34010010,1,99999,3,1),(34010011,1,99999,3,1),(34010012,1,99999,3,1),(34010013,1,99999,3,1),(34010014,1,99999,3,1),(34010015,1,99999,3,1),(34010016,1,99999,3,1),(34010017,1,99999,3,1),(34010018,1,99999,3,1),(34010019,1,99999,3,1),(34010020,1,99999,3,1),(36010001,1,99999,3,1),(36020001,1,99999,3,1),(36030001,1,99999,3,1),(36040001,1,288,3,2880),(36040002,1,666,3,6660),(36040003,1,998,3,9980),(36040004,1,99999,3,1),(36040005,1,999,3,9999),(36040008,1,99,3,1000),(36050001,1,99999,3,1),(36050002,1,99999,3,1),(36050003,1,99999,3,1),(36060001,1,99999,3,1),(36070001,1,99999,3,1),(36070002,1,99999,3,1),(36090001,1,99999,3,1),(36160001,1,99999,3,1),(36160002,1,99999,3,1),(36160003,1,99999,3,1),(36180001,1,99999,3,1),(36210001,1,99999,3,1),(36210002,1,99999,3,1),(36210003,1,99999,3,1),(36210004,1,99999,3,1),(36210005,1,99999,3,1),(36210006,1,99999,3,1),(36210007,1,99999,3,1),(36210008,1,99999,3,1),(37010101,1,99999,3,1),(37010102,1,99999,3,1),(37010103,1,99999,3,1),(37010201,1,99999,3,1),(37010202,1,99999,3,1),(37010203,1,99999,3,1),(37010301,1,99999,3,1),(37010302,1,99999,3,1),(37010303,1,99999,3,1),(37010401,1,99999,3,1),(37010402,1,99999,3,1),(37010403,1,99999,3,1),(37020001,1,10,3,100),(37020002,1,50,3,500),(37020003,1,150,3,1500),(37020004,1,99999,3,1),(38030001,1,40,3,800),(38030002,2,100,3,1000),(38030003,1,40,3,200),(38030004,1,10,3,100),(38030005,1,10,3,100),(38030006,1,40,3,400),(38030007,1,40,3,400),(38030008,1,100,3,1000),(38040001,1,10,3,200),(38040005,1,200,3,2000),(38040006,1,300,3,3000),(38040010,1,5,3,50),(38040013,1,5,3,1000),(38040014,1,5,3,1000),(38040015,1,5,3,1000),(38040016,1,5,3,1000),(38040017,1,10,3,2000),(38040101,1,10,3,100),(38040102,1,5000,3,50),(38050001,1,10,3,100),(38050002,1,20,3,200),(38070001,1,4,3,40),(38070002,1,20,3,200),(38080000,1,99999,3,1),(38080030,1,99999,3,1),(38080050,1,99999,3,1),(38080100,1,99999,3,1),(38090001,1,50,3,500),(38100001,1,2,3,20),(38100002,1,128,3,1280),(38100003,1,888,3,8880),(38100004,1,198,3,1980),(38100005,1,388,3,3880),(38100006,1,288,3,2880),(38100007,1,68,3,680),(38100008,1,8,3,80),(38100009,1,18,3,180),(38100010,1,198,3,1980),(38100011,1,1,3,1),(38100012,1,18,3,180),(38100013,1,1,3,1),(38100014,1,1,3,1),(38100015,1,1,3,1),(38110001,1,99999,3,1),(38110002,1,99999,3,1),(38110003,1,99999,3,1),(38110004,1,99999,3,1),(38110005,1,99999,3,1),(38110006,1,99999,3,1),(38110007,1,99999,3,1),(38120001,1,100,3,5000),(38130001,1,5,3,50),(38160001,1,100,3,1000),(38180001,1,20,3,500),(38180002,1,40,3,500),(38180003,1,50,3,500),(38180005,1,50,3,100),(38180006,1,30,3,3000),(38180007,1,50,3,1000),(38180008,1,50,3,100),(38180009,1,50,3,100),(38180010,1,50,3,5000),(38180012,1,88,3,500),(38180013,1,30,3,1000),(38180014,1,50,3,500),(38180015,1,1,3,500),(38210001,1,468,3,4680),(38210002,1,998,3,9980),(38220001,1,99999,3,1),(38220002,1,99999,3,1),(38230003,1,30,3,300),(38230005,1,30,3,300),(38230009,1,30,3,300),(38230101,1,6,3,60),(38230102,1,3,3,30),(38230104,1,3,3,30),(38230106,1,3,3,30),(38230107,1,6,3,60),(38230108,1,3,3,30),(38230110,1,3,3,30),(38230201,1,6,3,60),(38230202,1,3,3,30),(38230204,1,3,3,30),(38230206,1,3,3,30),(38230207,1,6,3,60),(38230208,1,3,3,30),(38230210,1,3,3,30),(38230301,1,6,3,60),(38230302,1,3,3,30),(38230304,1,3,3,30),(38230306,1,3,3,30),(38230307,1,6,3,60),(38230308,1,3,3,30),(38230310,1,3,3,30),(38230401,1,6,3,60),(38230402,1,3,3,30),(38230404,1,3,3,30),(38230406,1,3,3,30),(38230407,1,6,3,60),(38230408,1,3,3,30),(38230410,1,3,3,30),(38240001,1,24,3,240),(38240002,1,12,3,120),(38240003,1,120,3,1200),(38240004,1,12,3,120),(38240005,1,120,3,1200),(38240006,1,12,3,120),(38240007,1,24,3,240),(38240008,1,12,3,120),(38240009,1,120,3,1200),(38240010,1,12,3,120),(38250001,2,50,3,500),(38260001,2,10,3,50),(38270011,1,99999,3,1),(38270012,1,99999,3,1),(38270013,1,99999,3,1),(38270021,1,99999,3,1),(38270022,1,99999,3,1),(38270023,1,99999,3,1),(38280510,1,99999,3,1),(38280511,1,99999,3,1),(38280520,1,99999,3,1),(38280521,1,99999,3,1),(38280620,1,400,3,4000),(38280621,1,99999,3,1),(38300002,1,288,3,2880),(38300003,1,388,3,3880),(38300004,1,588,3,5880),(38330001,1,10,3,30),(38330002,1,15,3,70),(38330003,1,30,3,200),(38330004,1,60,3,600),(40010001,1,40,3,400),(40010002,1,80,3,800),(40010003,1,250,3,2500),(40010011,1,3,3,30),(40010012,1,18,3,180),(40020001,1,99999,3,1),(40020002,1,99999,3,1),(40020003,1,99999,3,1),(40020004,1,99999,3,1),(40020005,1,99999,3,1),(40020006,1,99999,3,1),(40030101,1,99999,3,1),(40030201,1,99999,3,1),(40030301,1,99999,3,1),(40040001,1,99999,3,1),(40040101,1,99999,3,1),(40040102,1,99999,3,1),(40040103,1,99999,3,1),(40040104,1,99999,3,1),(40050001,1,99999,3,1),(40050101,1,99999,3,1),(50010101,1,99999,3,2000),(50010102,1,99999,3,5000),(50010103,1,99999,3,10000),(50010201,1,99999,3,1000),(50010202,1,99999,3,2000),(50020101,1,99999,3,500),(50020102,1,99999,3,500),(50020103,1,99999,3,500),(50020104,1,99999,3,1000),(50020105,1,99999,3,1000),(50020106,1,99999,3,2000),(50020107,1,99999,3,2000),(50020108,1,99999,3,5000),(50020109,1,99999,3,5000),(50020110,1,99999,3,5000),(50020111,1,99999,3,5000),(50030101,1,99999,3,500),(50030102,1,99999,3,500),(50030103,1,99999,3,1000),(50030104,1,99999,3,1000),(50030105,1,99999,3,2000),(50030106,1,99999,3,2000),(50030107,1,99999,3,5000),(50030108,1,99999,3,5000),(50040101,1,99999,3,500),(50040102,1,99999,3,1000),(50040103,1,99999,3,2000),(50040104,1,99999,3,5000),(1001010100,1,1,3,210),(1001010110,1,4,3,210),(1001010120,1,7,3,210),(1001010131,1,14,3,210),(1001010132,1,21,3,210),(1001010141,1,49,3,210),(1001010142,1,70,3,210),(1001010143,1,140,3,210),(1001010153,1,245,3,210),(1001010163,1,350,3,210),(1001010200,1,2,3,549),(1001010210,1,5,3,549),(1001010220,1,10,3,549),(1001010231,1,20,3,549),(1001010232,1,30,3,549),(1001010241,1,70,3,549),(1001010242,1,100,3,549),(1001010243,1,200,3,549),(1001010253,1,350,3,549),(1001010263,1,500,3,549),(1001010300,1,3,3,1447),(1001010310,1,8,3,1447),(1001010320,1,15,3,1447),(1001010331,1,30,3,1447),(1001010332,1,45,3,1447),(1001010341,1,105,3,1447),(1001010342,1,150,3,1447),(1001010343,1,300,3,1447),(1001010353,1,525,3,1447),(1001010363,1,750,3,1447),(1001010400,1,4,3,2774),(1001010410,1,10,3,2774),(1001010420,1,20,3,2774),(1001010431,1,40,3,2774),(1001010432,1,60,3,2774),(1001010441,1,140,3,2774),(1001010442,1,200,3,2774),(1001010443,1,400,3,2774),(1001010453,1,700,3,2774),(1001010463,1,1000,3,2774),(1001010500,1,5,3,4393),(1001010510,1,13,3,4393),(1001010520,1,25,3,4393),(1001010531,1,50,3,4393),(1001010532,1,75,3,4393),(1001010541,1,175,3,4393),(1001010542,1,250,3,4393),(1001010543,1,500,3,4393),(1001010553,1,875,3,4393),(1001010563,1,1250,3,4393),(1001010600,1,6,3,5462),(1001010610,1,15,3,5462),(1001010620,1,30,3,5462),(1001010631,1,60,3,5462),(1001010632,1,90,3,5462),(1001010641,1,210,3,5462),(1001010642,1,300,3,5462),(1001010643,1,600,3,5462),(1001010653,1,1050,3,5462),(1001010663,1,1500,3,5462),(1001010700,1,8,3,5803),(1001010710,1,20,3,5803),(1001010720,1,40,3,5803),(1001010731,1,80,3,5803),(1001010732,1,120,3,5803),(1001010741,1,280,3,5803),(1001010742,1,400,3,5803),(1001010743,1,800,3,5803),(1001010753,1,1400,3,5803),(1001010763,1,2000,3,5803),(1001010800,1,10,3,6406),(1001010810,1,25,3,6406),(1001010820,1,50,3,6406),(1001010831,1,100,3,6406),(1001010832,1,150,3,6406),(1001010841,1,350,3,6406),(1001010842,1,500,3,6406),(1001010843,1,1000,3,6406),(1001010853,1,1750,3,6406),(1001010863,1,2500,3,6406),(1001010900,1,12,3,7662),(1001010910,1,30,3,7662),(1001010920,1,60,3,7662),(1001010931,1,120,3,7662),(1001010932,1,180,3,7662),(1001010941,1,420,3,7662),(1001010942,1,600,3,7662),(1001010943,1,1200,3,7662),(1001010953,1,2100,3,7662),(1001010963,1,3000,3,7662),(1001011000,1,14,3,10963),(1001011010,1,35,3,10963),(1001011020,1,70,3,10963),(1001011031,1,140,3,10963),(1001011032,1,210,3,10963),(1001011041,1,490,3,10963),(1001011042,1,700,3,10963),(1001011043,1,1400,3,10963),(1001011053,1,2450,3,10963),(1001011063,1,3500,3,10963),(1001011100,1,16,3,15691),(1001011110,1,40,3,15691),(1001011120,1,80,3,15691),(1001011131,1,160,3,15691),(1001011132,1,240,3,15691),(1001011141,1,560,3,15691),(1001011142,1,800,3,15691),(1001011143,1,1600,3,15691),(1001011153,1,2800,3,15691),(1001011163,1,4000,3,15691),(1001011200,1,18,3,21452),(1001011210,1,45,3,21452),(1001011220,1,90,3,21452),(1001011231,1,180,3,21452),(1001011232,1,270,3,21452),(1001011241,1,630,3,21452),(1001011242,1,900,3,21452),(1001011243,1,1800,3,21452),(1001011253,1,3150,3,21452),(1001011263,1,4500,3,21452),(1001011300,1,20,3,30327),(1001011310,1,50,3,30327),(1001011320,1,100,3,30327),(1001011331,1,200,3,30327),(1001011332,1,300,3,30327),(1001011341,1,700,3,30327),(1001011342,1,1000,3,30327),(1001011343,1,2000,3,30327),(1001011353,1,3500,3,30327),(1001011363,1,5000,3,30327),(1001011400,1,22,3,44741),(1001011410,1,55,3,44741),(1001011420,1,110,3,44741),(1001011431,1,220,3,44741),(1001011432,1,330,3,44741),(1001011441,1,770,3,44741),(1001011442,1,1100,3,44741),(1001011443,1,2200,3,44741),(1001011453,1,3850,3,44741),(1001011463,1,5500,3,44741),(1001011500,1,24,3,53486),(1001011510,1,60,3,53486),(1001011520,1,120,3,53486),(1001011531,1,240,3,53486),(1001011532,1,360,3,53486),(1001011541,1,840,3,53486),(1001011542,1,1200,3,53486),(1001011543,1,2400,3,53486),(1001011553,1,4200,3,53486),(1001011563,1,6000,3,53486),(1001020100,1,1,3,210),(1001020110,1,4,3,210),(1001020120,1,7,3,210),(1001020131,1,14,3,210),(1001020132,1,21,3,210),(1001020141,1,49,3,210),(1001020142,1,70,3,210),(1001020143,1,140,3,210),(1001020153,1,245,3,210),(1001020163,1,350,3,210),(1001020200,1,2,3,549),(1001020210,1,5,3,549),(1001020220,1,10,3,549),(1001020231,1,20,3,549),(1001020232,1,30,3,549),(1001020241,1,70,3,549),(1001020242,1,100,3,549),(1001020243,1,200,3,549),(1001020253,1,350,3,549),(1001020263,1,500,3,549),(1001020300,1,3,3,1447),(1001020310,1,8,3,1447),(1001020320,1,15,3,1447),(1001020331,1,30,3,1447),(1001020332,1,45,3,1447),(1001020341,1,105,3,1447),(1001020342,1,150,3,1447),(1001020343,1,300,3,1447),(1001020353,1,525,3,1447),(1001020363,1,750,3,1447),(1001020400,1,4,3,2774),(1001020410,1,10,3,2774),(1001020420,1,20,3,2774),(1001020431,1,40,3,2774),(1001020432,1,60,3,2774),(1001020441,1,140,3,2774),(1001020442,1,200,3,2774),(1001020443,1,400,3,2774),(1001020453,1,700,3,2774),(1001020463,1,1000,3,2774),(1001020500,1,5,3,4393),(1001020510,1,13,3,4393),(1001020520,1,25,3,4393),(1001020531,1,50,3,4393),(1001020532,1,75,3,4393),(1001020541,1,175,3,4393),(1001020542,1,250,3,4393),(1001020543,1,500,3,4393),(1001020553,1,875,3,4393),(1001020563,1,1250,3,4393),(1001020600,1,6,3,5462),(1001020610,1,15,3,5462),(1001020620,1,30,3,5462),(1001020631,1,60,3,5462),(1001020632,1,90,3,5462),(1001020641,1,210,3,5462),(1001020642,1,300,3,5462),(1001020643,1,600,3,5462),(1001020653,1,1050,3,5462),(1001020663,1,1500,3,5462),(1001020700,1,8,3,5803),(1001020710,1,20,3,5803),(1001020720,1,40,3,5803),(1001020731,1,80,3,5803),(1001020732,1,120,3,5803),(1001020741,1,280,3,5803),(1001020742,1,400,3,5803),(1001020743,1,800,3,5803),(1001020753,1,1400,3,5803),(1001020763,1,2000,3,5803),(1001020800,1,10,3,6406),(1001020810,1,25,3,6406),(1001020820,1,50,3,6406),(1001020831,1,100,3,6406),(1001020832,1,150,3,6406),(1001020841,1,350,3,6406),(1001020842,1,500,3,6406),(1001020843,1,1000,3,6406),(1001020853,1,1750,3,6406),(1001020863,1,2500,3,6406),(1001020900,1,12,3,7662),(1001020910,1,30,3,7662),(1001020920,1,60,3,7662),(1001020931,1,120,3,7662),(1001020932,1,180,3,7662),(1001020941,1,420,3,7662),(1001020942,1,600,3,7662),(1001020943,1,1200,3,7662),(1001020953,1,2100,3,7662),(1001020963,1,3000,3,7662),(1001021000,1,14,3,10963),(1001021010,1,35,3,10963),(1001021020,1,70,3,10963),(1001021031,1,140,3,10963),(1001021032,1,210,3,10963),(1001021041,1,490,3,10963),(1001021042,1,700,3,10963),(1001021043,1,1400,3,10963),(1001021053,1,2450,3,10963),(1001021063,1,3500,3,10963),(1001021100,1,16,3,15691),(1001021110,1,40,3,15691),(1001021120,1,80,3,15691),(1001021131,1,160,3,15691),(1001021132,1,240,3,15691),(1001021141,1,560,3,15691),(1001021142,1,800,3,15691),(1001021143,1,1600,3,15691),(1001021153,1,2800,3,15691),(1001021163,1,4000,3,15691),(1001021200,1,18,3,21452),(1001021210,1,45,3,21452),(1001021220,1,90,3,21452),(1001021231,1,180,3,21452),(1001021232,1,270,3,21452),(1001021241,1,630,3,21452),(1001021242,1,900,3,21452),(1001021243,1,1800,3,21452),(1001021253,1,3150,3,21452),(1001021263,1,4500,3,21452),(1001021300,1,20,3,30327),(1001021310,1,50,3,30327),(1001021320,1,100,3,30327),(1001021331,1,200,3,30327),(1001021332,1,300,3,30327),(1001021341,1,700,3,30327),(1001021342,1,1000,3,30327),(1001021343,1,2000,3,30327),(1001021353,1,3500,3,30327),(1001021363,1,5000,3,30327),(1001021400,1,22,3,44741),(1001021410,1,55,3,44741),(1001021420,1,110,3,44741),(1001021431,1,220,3,44741),(1001021432,1,330,3,44741),(1001021441,1,770,3,44741),(1001021442,1,1100,3,44741),(1001021443,1,2200,3,44741),(1001021453,1,3850,3,44741),(1001021463,1,5500,3,44741),(1001021500,1,24,3,53486),(1001021510,1,60,3,53486),(1001021520,1,120,3,53486),(1001021531,1,240,3,53486),(1001021532,1,360,3,53486),(1001021541,1,840,3,53486),(1001021542,1,1200,3,53486),(1001021543,1,2400,3,53486),(1001021553,1,4200,3,53486),(1001021563,1,6000,3,53486),(1001030100,1,1,3,210),(1001030110,1,4,3,210),(1001030120,1,7,3,210),(1001030131,1,14,3,210),(1001030132,1,21,3,210),(1001030141,1,49,3,210),(1001030142,1,70,3,210),(1001030143,1,140,3,210),(1001030153,1,245,3,210),(1001030163,1,350,3,210),(1001030200,1,2,3,549),(1001030210,1,5,3,549),(1001030220,1,10,3,549),(1001030231,1,20,3,549),(1001030232,1,30,3,549),(1001030241,1,70,3,549),(1001030242,1,100,3,549),(1001030243,1,200,3,549),(1001030253,1,350,3,549),(1001030263,1,500,3,549),(1001030300,1,3,3,1447),(1001030310,1,8,3,1447),(1001030320,1,15,3,1447),(1001030331,1,30,3,1447),(1001030332,1,45,3,1447),(1001030341,1,105,3,1447),(1001030342,1,150,3,1447),(1001030343,1,300,3,1447),(1001030353,1,525,3,1447),(1001030363,1,750,3,1447),(1001030400,1,4,3,2774),(1001030410,1,10,3,2774),(1001030420,1,20,3,2774),(1001030431,1,40,3,2774),(1001030432,1,60,3,2774),(1001030441,1,140,3,2774),(1001030442,1,200,3,2774),(1001030443,1,400,3,2774),(1001030453,1,700,3,2774),(1001030463,1,1000,3,2774),(1001030500,1,5,3,4393),(1001030510,1,13,3,4393),(1001030520,1,25,3,4393),(1001030531,1,50,3,4393),(1001030532,1,75,3,4393),(1001030541,1,175,3,4393),(1001030542,1,250,3,4393),(1001030543,1,500,3,4393),(1001030553,1,875,3,4393),(1001030563,1,1250,3,4393),(1001030600,1,6,3,5462),(1001030610,1,15,3,5462),(1001030620,1,30,3,5462),(1001030631,1,60,3,5462),(1001030632,1,90,3,5462),(1001030641,1,210,3,5462),(1001030642,1,300,3,5462),(1001030643,1,600,3,5462),(1001030653,1,1050,3,5462),(1001030663,1,1500,3,5462),(1001030700,1,8,3,5803),(1001030710,1,20,3,5803),(1001030720,1,40,3,5803),(1001030731,1,80,3,5803),(1001030732,1,120,3,5803),(1001030741,1,280,3,5803),(1001030742,1,400,3,5803),(1001030743,1,800,3,5803),(1001030753,1,1400,3,5803),(1001030763,1,2000,3,5803),(1001030800,1,10,3,6406),(1001030810,1,25,3,6406),(1001030820,1,50,3,6406),(1001030831,1,100,3,6406),(1001030832,1,150,3,6406),(1001030841,1,350,3,6406),(1001030842,1,500,3,6406),(1001030843,1,1000,3,6406),(1001030853,1,1750,3,6406),(1001030863,1,2500,3,6406),(1001030900,1,12,3,7662),(1001030910,1,30,3,7662),(1001030920,1,60,3,7662),(1001030931,1,120,3,7662),(1001030932,1,180,3,7662),(1001030941,1,420,3,7662),(1001030942,1,600,3,7662),(1001030943,1,1200,3,7662),(1001030953,1,2100,3,7662),(1001030963,1,3000,3,7662),(1001031000,1,14,3,10963),(1001031010,1,35,3,10963),(1001031020,1,70,3,10963),(1001031031,1,140,3,10963),(1001031032,1,210,3,10963),(1001031041,1,490,3,10963),(1001031042,1,700,3,10963),(1001031043,1,1400,3,10963),(1001031053,1,2450,3,10963),(1001031063,1,3500,3,10963),(1001031100,1,16,3,15691),(1001031110,1,40,3,15691),(1001031120,1,80,3,15691),(1001031131,1,160,3,15691),(1001031132,1,240,3,15691),(1001031141,1,560,3,15691),(1001031142,1,800,3,15691),(1001031143,1,1600,3,15691),(1001031153,1,2800,3,15691),(1001031163,1,4000,3,15691),(1001031200,1,18,3,21452),(1001031210,1,45,3,21452),(1001031220,1,90,3,21452),(1001031231,1,180,3,21452),(1001031232,1,270,3,21452),(1001031241,1,630,3,21452),(1001031242,1,900,3,21452),(1001031243,1,1800,3,21452),(1001031253,1,3150,3,21452),(1001031263,1,4500,3,21452),(1001031300,1,20,3,30327),(1001031310,1,50,3,30327),(1001031320,1,100,3,30327),(1001031331,1,200,3,30327),(1001031332,1,300,3,30327),(1001031341,1,700,3,30327),(1001031342,1,1000,3,30327),(1001031343,1,2000,3,30327),(1001031353,1,3500,3,30327),(1001031363,1,5000,3,30327),(1001031400,1,22,3,44741),(1001031410,1,55,3,44741),(1001031420,1,110,3,44741),(1001031431,1,220,3,44741),(1001031432,1,330,3,44741),(1001031441,1,770,3,44741),(1001031442,1,1100,3,44741),(1001031443,1,2200,3,44741),(1001031453,1,3850,3,44741),(1001031463,1,5500,3,44741),(1001031500,1,24,3,53486),(1001031510,1,60,3,53486),(1001031520,1,120,3,53486),(1001031531,1,240,3,53486),(1001031532,1,360,3,53486),(1001031541,1,840,3,53486),(1001031542,1,1200,3,53486),(1001031543,1,2400,3,53486),(1001031553,1,4200,3,53486),(1001031563,1,6000,3,53486),(1001040100,1,1,3,210),(1001040110,1,4,3,210),(1001040120,1,7,3,210),(1001040131,1,14,3,210),(1001040132,1,21,3,210),(1001040141,1,49,3,210),(1001040142,1,70,3,210),(1001040143,1,140,3,210),(1001040153,1,245,3,210),(1001040163,1,350,3,210),(1001040200,1,2,3,549),(1001040210,1,5,3,549),(1001040220,1,10,3,549),(1001040231,1,20,3,549),(1001040232,1,30,3,549),(1001040241,1,70,3,549),(1001040242,1,100,3,549),(1001040243,1,200,3,549),(1001040253,1,350,3,549),(1001040263,1,500,3,549),(1001040300,1,3,3,1447),(1001040310,1,8,3,1447),(1001040320,1,15,3,1447),(1001040331,1,30,3,1447),(1001040332,1,45,3,1447),(1001040341,1,105,3,1447),(1001040342,1,150,3,1447),(1001040343,1,300,3,1447),(1001040353,1,525,3,1447),(1001040363,1,750,3,1447),(1001040400,1,4,3,2774),(1001040410,1,10,3,2774),(1001040420,1,20,3,2774),(1001040431,1,40,3,2774),(1001040432,1,60,3,2774),(1001040441,1,140,3,2774),(1001040442,1,200,3,2774),(1001040443,1,400,3,2774),(1001040453,1,700,3,2774),(1001040463,1,1000,3,2774),(1001040500,1,5,3,4393),(1001040510,1,13,3,4393),(1001040520,1,25,3,4393),(1001040531,1,50,3,4393),(1001040532,1,75,3,4393),(1001040541,1,175,3,4393),(1001040542,1,250,3,4393),(1001040543,1,500,3,4393),(1001040553,1,875,3,4393),(1001040563,1,1250,3,4393),(1001040600,1,6,3,5462),(1001040610,1,15,3,5462),(1001040620,1,30,3,5462),(1001040631,1,60,3,5462),(1001040632,1,90,3,5462),(1001040641,1,210,3,5462),(1001040642,1,300,3,5462),(1001040643,1,600,3,5462),(1001040653,1,1050,3,5462),(1001040663,1,1500,3,5462),(1001040700,1,8,3,5803),(1001040710,1,20,3,5803),(1001040720,1,40,3,5803),(1001040731,1,80,3,5803),(1001040732,1,120,3,5803),(1001040741,1,280,3,5803),(1001040742,1,400,3,5803),(1001040743,1,800,3,5803),(1001040753,1,1400,3,5803),(1001040763,1,2000,3,5803),(1001040800,1,10,3,6406),(1001040810,1,25,3,6406),(1001040820,1,50,3,6406),(1001040831,1,100,3,6406),(1001040832,1,150,3,6406),(1001040841,1,350,3,6406),(1001040842,1,500,3,6406),(1001040843,1,1000,3,6406),(1001040853,1,1750,3,6406),(1001040863,1,2500,3,6406),(1001040900,1,12,3,7662),(1001040910,1,30,3,7662),(1001040920,1,60,3,7662),(1001040931,1,120,3,7662),(1001040932,1,180,3,7662),(1001040941,1,420,3,7662),(1001040942,1,600,3,7662),(1001040943,1,1200,3,7662),(1001040953,1,2100,3,7662),(1001040963,1,3000,3,7662),(1001041000,1,14,3,10963),(1001041010,1,35,3,10963),(1001041020,1,70,3,10963),(1001041031,1,140,3,10963),(1001041032,1,210,3,10963),(1001041041,1,490,3,10963),(1001041042,1,700,3,10963),(1001041043,1,1400,3,10963),(1001041053,1,2450,3,10963),(1001041063,1,3500,3,10963),(1001041100,1,16,3,15691),(1001041110,1,40,3,15691),(1001041120,1,80,3,15691),(1001041131,1,160,3,15691),(1001041132,1,240,3,15691),(1001041141,1,560,3,15691),(1001041142,1,800,3,15691),(1001041143,1,1600,3,15691),(1001041153,1,2800,3,15691),(1001041163,1,4000,3,15691),(1001041200,1,18,3,21452),(1001041210,1,45,3,21452),(1001041220,1,90,3,21452),(1001041231,1,180,3,21452),(1001041232,1,270,3,21452),(1001041241,1,630,3,21452),(1001041242,1,900,3,21452),(1001041243,1,1800,3,21452),(1001041253,1,3150,3,21452),(1001041263,1,4500,3,21452),(1001041300,1,20,3,30327),(1001041310,1,50,3,30327),(1001041320,1,100,3,30327),(1001041331,1,200,3,30327),(1001041332,1,300,3,30327),(1001041341,1,700,3,30327),(1001041342,1,1000,3,30327),(1001041343,1,2000,3,30327),(1001041353,1,3500,3,30327),(1001041363,1,5000,3,30327),(1001041400,1,22,3,44741),(1001041410,1,55,3,44741),(1001041420,1,110,3,44741),(1001041431,1,220,3,44741),(1001041432,1,330,3,44741),(1001041441,1,770,3,44741),(1001041442,1,1100,3,44741),(1001041443,1,2200,3,44741),(1001041453,1,3850,3,44741),(1001041463,1,5500,3,44741),(1001041500,1,24,3,53486),(1001041510,1,60,3,53486),(1001041520,1,120,3,53486),(1001041531,1,240,3,53486),(1001041532,1,360,3,53486),(1001041541,1,840,3,53486),(1001041542,1,1200,3,53486),(1001041543,1,2400,3,53486),(1001041553,1,4200,3,53486),(1001041563,1,6000,3,53486),(1002010100,1,1,3,210),(1002010110,1,3,3,210),(1002010120,1,6,3,210),(1002010131,1,12,3,210),(1002010132,1,18,3,210),(1002010141,1,42,3,210),(1002010142,1,60,3,210),(1002010143,1,110,3,210),(1002010153,1,210,3,210),(1002010163,1,300,3,210),(1002010200,1,2,3,549),(1002010210,1,4,3,549),(1002010220,1,8,3,549),(1002010231,1,16,3,549),(1002010232,1,24,3,549),(1002010241,1,56,3,549),(1002010242,1,80,3,549),(1002010243,1,160,3,549),(1002010253,1,280,3,549),(1002010263,1,400,3,549),(1002010300,1,2,3,1447),(1002010310,1,6,3,1447),(1002010320,1,12,3,1447),(1002010331,1,24,3,1447),(1002010332,1,36,3,1447),(1002010341,1,84,3,1447),(1002010342,1,120,3,1447),(1002010343,1,240,3,1447),(1002010353,1,420,3,1447),(1002010363,1,600,3,1447),(1002010400,1,3,3,2774),(1002010410,1,8,3,2774),(1002010420,1,16,3,2774),(1002010431,1,32,3,2774),(1002010432,1,48,3,2774),(1002010441,1,112,3,2774),(1002010442,1,160,3,2774),(1002010443,1,320,3,2774),(1002010453,1,560,3,2774),(1002010463,1,800,3,2774),(1002010500,1,4,3,4393),(1002010510,1,10,3,4393),(1002010520,1,20,3,4393),(1002010531,1,40,3,4393),(1002010532,1,60,3,4393),(1002010541,1,140,3,4393),(1002010542,1,200,3,4393),(1002010543,1,400,3,4393),(1002010553,1,700,3,4393),(1002010563,1,1000,3,4393),(1002010600,1,5,3,5462),(1002010610,1,12,3,5462),(1002010620,1,24,3,5462),(1002010631,1,48,3,5462),(1002010632,1,72,3,5462),(1002010641,1,168,3,5462),(1002010642,1,240,3,5462),(1002010643,1,480,3,5462),(1002010653,1,840,3,5462),(1002010663,1,1200,3,5462),(1002010700,1,6,3,5803),(1002010710,1,16,3,5803),(1002010720,1,32,3,5803),(1002010731,1,64,3,5803),(1002010732,1,96,3,5803),(1002010741,1,224,3,5803),(1002010742,1,320,3,5803),(1002010743,1,640,3,5803),(1002010753,1,1120,3,5803),(1002010763,1,1600,3,5803),(1002010800,1,8,3,6406),(1002010810,1,20,3,6406),(1002010820,1,40,3,6406),(1002010831,1,80,3,6406),(1002010832,1,120,3,6406),(1002010841,1,280,3,6406),(1002010842,1,400,3,6406),(1002010843,1,800,3,6406),(1002010853,1,1400,3,6406),(1002010863,1,2000,3,6406),(1002010900,1,10,3,7662),(1002010910,1,24,3,7662),(1002010920,1,48,3,7662),(1002010931,1,96,3,7662),(1002010932,1,144,3,7662),(1002010941,1,336,3,7662),(1002010942,1,480,3,7662),(1002010943,1,960,3,7662),(1002010953,1,1680,3,7662),(1002010963,1,2400,3,7662),(1002011000,1,11,3,10963),(1002011010,1,28,3,10963),(1002011020,1,56,3,10963),(1002011031,1,112,3,10963),(1002011032,1,168,3,10963),(1002011041,1,392,3,10963),(1002011042,1,560,3,10963),(1002011043,1,1120,3,10963),(1002011053,1,1960,3,10963),(1002011063,1,2800,3,10963),(1002011100,1,13,3,15691),(1002011110,1,32,3,15691),(1002011120,1,64,3,15691),(1002011131,1,128,3,15691),(1002011132,1,192,3,15691),(1002011141,1,448,3,15691),(1002011142,1,640,3,15691),(1002011143,1,1280,3,15691),(1002011153,1,2240,3,15691),(1002011163,1,3200,3,15691),(1002011200,1,14,3,21452),(1002011210,1,36,3,21452),(1002011220,1,72,3,21452),(1002011231,1,144,3,21452),(1002011232,1,216,3,21452),(1002011241,1,504,3,21452),(1002011242,1,720,3,21452),(1002011243,1,1440,3,21452),(1002011253,1,2520,3,21452),(1002011263,1,3600,3,21452),(1002011300,1,16,3,30327),(1002011310,1,40,3,30327),(1002011320,1,80,3,30327),(1002011331,1,160,3,30327),(1002011332,1,240,3,30327),(1002011341,1,560,3,30327),(1002011342,1,800,3,30327),(1002011343,1,1600,3,30327),(1002011353,1,2800,3,30327),(1002011363,1,4000,3,30327),(1002011400,1,18,3,44741),(1002011410,1,44,3,44741),(1002011420,1,88,3,44741),(1002011431,1,176,3,44741),(1002011432,1,264,3,44741),(1002011441,1,616,3,44741),(1002011442,1,880,3,44741),(1002011443,1,1760,3,44741),(1002011453,1,3080,3,44741),(1002011463,1,4400,3,44741),(1002011500,1,19,3,53486),(1002011510,1,48,3,53486),(1002011520,1,96,3,53486),(1002011531,1,192,3,53486),(1002011532,1,288,3,53486),(1002011541,1,672,3,53486),(1002011542,1,960,3,53486),(1002011543,1,1920,3,53486),(1002011553,1,3360,3,53486),(1002011563,1,4800,3,53486),(1002020100,1,1,3,210),(1002020110,1,3,3,210),(1002020120,1,6,3,210),(1002020131,1,12,3,210),(1002020132,1,18,3,210),(1002020141,1,42,3,210),(1002020142,1,60,3,210),(1002020143,1,110,3,210),(1002020153,1,210,3,210),(1002020163,1,300,3,210),(1002020200,1,2,3,549),(1002020210,1,4,3,549),(1002020220,1,8,3,549),(1002020231,1,16,3,549),(1002020232,1,24,3,549),(1002020241,1,56,3,549),(1002020242,1,80,3,549),(1002020243,1,160,3,549),(1002020253,1,280,3,549),(1002020263,1,400,3,549),(1002020300,1,2,3,1447),(1002020310,1,6,3,1447),(1002020320,1,12,3,1447),(1002020331,1,24,3,1447),(1002020332,1,36,3,1447),(1002020341,1,84,3,1447),(1002020342,1,120,3,1447),(1002020343,1,240,3,1447),(1002020353,1,420,3,1447),(1002020363,1,600,3,1447),(1002020400,1,3,3,2774),(1002020410,1,8,3,2774),(1002020420,1,16,3,2774),(1002020431,1,32,3,2774),(1002020432,1,48,3,2774),(1002020441,1,112,3,2774),(1002020442,1,160,3,2774),(1002020443,1,320,3,2774),(1002020453,1,560,3,2774),(1002020463,1,800,3,2774),(1002020500,1,4,3,4393),(1002020510,1,10,3,4393),(1002020520,1,20,3,4393),(1002020531,1,40,3,4393),(1002020532,1,60,3,4393),(1002020541,1,140,3,4393),(1002020542,1,200,3,4393),(1002020543,1,400,3,4393),(1002020553,1,700,3,4393),(1002020563,1,1000,3,4393),(1002020600,1,5,3,5462),(1002020610,1,12,3,5462),(1002020620,1,24,3,5462),(1002020631,1,48,3,5462),(1002020632,1,72,3,5462),(1002020641,1,168,3,5462),(1002020642,1,240,3,5462),(1002020643,1,480,3,5462),(1002020653,1,840,3,5462),(1002020663,1,1200,3,5462),(1002020700,1,6,3,5803),(1002020710,1,16,3,5803),(1002020720,1,32,3,5803),(1002020731,1,64,3,5803),(1002020732,1,96,3,5803),(1002020741,1,224,3,5803),(1002020742,1,320,3,5803),(1002020743,1,640,3,5803),(1002020753,1,1120,3,5803),(1002020763,1,1600,3,5803),(1002020800,1,8,3,6406),(1002020810,1,20,3,6406),(1002020820,1,40,3,6406),(1002020831,1,80,3,6406),(1002020832,1,120,3,6406),(1002020841,1,280,3,6406),(1002020842,1,400,3,6406),(1002020843,1,800,3,6406),(1002020853,1,1400,3,6406),(1002020863,1,2000,3,6406),(1002020900,1,10,3,7662),(1002020910,1,24,3,7662),(1002020920,1,48,3,7662),(1002020931,1,96,3,7662),(1002020932,1,144,3,7662),(1002020941,1,336,3,7662),(1002020942,1,480,3,7662),(1002020943,1,960,3,7662),(1002020953,1,1680,3,7662),(1002020963,1,2400,3,7662),(1002021000,1,11,3,10963),(1002021010,1,28,3,10963),(1002021020,1,56,3,10963),(1002021031,1,112,3,10963),(1002021032,1,168,3,10963),(1002021041,1,392,3,10963),(1002021042,1,560,3,10963),(1002021043,1,1120,3,10963),(1002021053,1,1960,3,10963),(1002021063,1,2800,3,10963),(1002021100,1,13,3,15691),(1002021110,1,32,3,15691),(1002021120,1,64,3,15691),(1002021131,1,128,3,15691),(1002021132,1,192,3,15691),(1002021141,1,448,3,15691),(1002021142,1,640,3,15691),(1002021143,1,1280,3,15691),(1002021153,1,2240,3,15691),(1002021163,1,3200,3,15691),(1002021200,1,14,3,21452),(1002021210,1,36,3,21452),(1002021220,1,72,3,21452),(1002021231,1,144,3,21452),(1002021232,1,216,3,21452),(1002021241,1,504,3,21452),(1002021242,1,720,3,21452),(1002021243,1,1440,3,21452),(1002021253,1,2520,3,21452),(1002021263,1,3600,3,21452),(1002021300,1,16,3,30327),(1002021310,1,40,3,30327),(1002021320,1,80,3,30327),(1002021331,1,160,3,30327),(1002021332,1,240,3,30327),(1002021341,1,560,3,30327),(1002021342,1,800,3,30327),(1002021343,1,1600,3,30327),(1002021353,1,2800,3,30327),(1002021363,1,4000,3,30327),(1002021400,1,18,3,44741),(1002021410,1,44,3,44741),(1002021420,1,88,3,44741),(1002021431,1,176,3,44741),(1002021432,1,264,3,44741),(1002021441,1,616,3,44741),(1002021442,1,880,3,44741),(1002021443,1,1760,3,44741),(1002021453,1,3080,3,44741),(1002021463,1,4400,3,44741),(1002021500,1,19,3,53486),(1002021510,1,48,3,53486),(1002021520,1,96,3,53486),(1002021531,1,192,3,53486),(1002021532,1,288,3,53486),(1002021541,1,672,3,53486),(1002021542,1,960,3,53486),(1002021543,1,1920,3,53486),(1002021553,1,3360,3,53486),(1002021563,1,4800,3,53486),(1002030100,1,1,3,210),(1002030110,1,3,3,210),(1002030120,1,6,3,210),(1002030131,1,12,3,210),(1002030132,1,18,3,210),(1002030141,1,42,3,210),(1002030142,1,60,3,210),(1002030143,1,110,3,210),(1002030153,1,210,3,210),(1002030163,1,300,3,210),(1002030200,1,2,3,549),(1002030210,1,4,3,549),(1002030220,1,8,3,549),(1002030231,1,16,3,549),(1002030232,1,24,3,549),(1002030241,1,56,3,549),(1002030242,1,80,3,549),(1002030243,1,160,3,549),(1002030253,1,280,3,549),(1002030263,1,400,3,549),(1002030300,1,2,3,1447),(1002030310,1,6,3,1447),(1002030320,1,12,3,1447),(1002030331,1,24,3,1447),(1002030332,1,36,3,1447),(1002030341,1,84,3,1447),(1002030342,1,120,3,1447),(1002030343,1,240,3,1447),(1002030353,1,420,3,1447),(1002030363,1,600,3,1447),(1002030400,1,3,3,2774),(1002030410,1,8,3,2774),(1002030420,1,16,3,2774),(1002030431,1,32,3,2774),(1002030432,1,48,3,2774),(1002030441,1,112,3,2774),(1002030442,1,160,3,2774),(1002030443,1,320,3,2774),(1002030453,1,560,3,2774),(1002030463,1,800,3,2774),(1002030500,1,4,3,4393),(1002030510,1,10,3,4393),(1002030520,1,20,3,4393),(1002030531,1,40,3,4393),(1002030532,1,60,3,4393),(1002030541,1,140,3,4393),(1002030542,1,200,3,4393),(1002030543,1,400,3,4393),(1002030553,1,700,3,4393),(1002030563,1,1000,3,4393),(1002030600,1,5,3,5462),(1002030610,1,12,3,5462),(1002030620,1,24,3,5462),(1002030631,1,48,3,5462),(1002030632,1,72,3,5462),(1002030641,1,168,3,5462),(1002030642,1,240,3,5462),(1002030643,1,480,3,5462),(1002030653,1,840,3,5462),(1002030663,1,1200,3,5462),(1002030700,1,6,3,5803),(1002030710,1,16,3,5803),(1002030720,1,32,3,5803),(1002030731,1,64,3,5803),(1002030732,1,96,3,5803),(1002030741,1,224,3,5803),(1002030742,1,320,3,5803),(1002030743,1,640,3,5803),(1002030753,1,1120,3,5803),(1002030763,1,1600,3,5803),(1002030800,1,8,3,6406),(1002030810,1,20,3,6406),(1002030820,1,40,3,6406),(1002030831,1,80,3,6406),(1002030832,1,120,3,6406),(1002030841,1,280,3,6406),(1002030842,1,400,3,6406),(1002030843,1,800,3,6406),(1002030853,1,1400,3,6406),(1002030863,1,2000,3,6406),(1002030900,1,10,3,7662),(1002030910,1,24,3,7662),(1002030920,1,48,3,7662),(1002030931,1,96,3,7662),(1002030932,1,144,3,7662),(1002030941,1,336,3,7662),(1002030942,1,480,3,7662),(1002030943,1,960,3,7662),(1002030953,1,1680,3,7662),(1002030963,1,2400,3,7662),(1002031000,1,11,3,10963),(1002031010,1,28,3,10963),(1002031020,1,56,3,10963),(1002031031,1,112,3,10963),(1002031032,1,168,3,10963),(1002031041,1,392,3,10963),(1002031042,1,560,3,10963),(1002031043,1,1120,3,10963),(1002031053,1,1960,3,10963),(1002031063,1,2800,3,10963),(1002031100,1,13,3,15691),(1002031110,1,32,3,15691),(1002031120,1,64,3,15691),(1002031131,1,128,3,15691),(1002031132,1,192,3,15691),(1002031141,1,448,3,15691),(1002031142,1,640,3,15691),(1002031143,1,1280,3,15691),(1002031153,1,2240,3,15691),(1002031163,1,3200,3,15691),(1002031200,1,14,3,21452),(1002031210,1,36,3,21452),(1002031220,1,72,3,21452),(1002031231,1,144,3,21452),(1002031232,1,216,3,21452),(1002031241,1,504,3,21452),(1002031242,1,720,3,21452),(1002031243,1,1440,3,21452),(1002031253,1,2520,3,21452),(1002031263,1,3600,3,21452),(1002031300,1,16,3,30327),(1002031310,1,40,3,30327),(1002031320,1,80,3,30327),(1002031331,1,160,3,30327),(1002031332,1,240,3,30327),(1002031341,1,560,3,30327),(1002031342,1,800,3,30327),(1002031343,1,1600,3,30327),(1002031353,1,2800,3,30327),(1002031363,1,4000,3,30327),(1002031400,1,18,3,44741),(1002031410,1,44,3,44741),(1002031420,1,88,3,44741),(1002031431,1,176,3,44741),(1002031432,1,264,3,44741),(1002031441,1,616,3,44741),(1002031442,1,880,3,44741),(1002031443,1,1760,3,44741),(1002031453,1,3080,3,44741),(1002031463,1,4400,3,44741),(1002031500,1,19,3,53486),(1002031510,1,48,3,53486),(1002031520,1,96,3,53486),(1002031531,1,192,3,53486),(1002031532,1,288,3,53486),(1002031541,1,672,3,53486),(1002031542,1,960,3,53486),(1002031543,1,1920,3,53486),(1002031553,1,3360,3,53486),(1002031563,1,4800,3,53486),(1002040100,1,1,3,210),(1002040110,1,3,3,210),(1002040120,1,6,3,210),(1002040131,1,12,3,210),(1002040132,1,18,3,210),(1002040141,1,42,3,210),(1002040142,1,60,3,210),(1002040143,1,110,3,210),(1002040153,1,210,3,210),(1002040163,1,300,3,210),(1002040200,1,2,3,549),(1002040210,1,4,3,549),(1002040220,1,8,3,549),(1002040231,1,16,3,549),(1002040232,1,24,3,549),(1002040241,1,56,3,549),(1002040242,1,80,3,549),(1002040243,1,160,3,549),(1002040253,1,280,3,549),(1002040263,1,400,3,549),(1002040300,1,2,3,1447),(1002040310,1,6,3,1447),(1002040320,1,12,3,1447),(1002040331,1,24,3,1447),(1002040332,1,36,3,1447),(1002040341,1,84,3,1447),(1002040342,1,120,3,1447),(1002040343,1,240,3,1447),(1002040353,1,420,3,1447),(1002040363,1,600,3,1447),(1002040400,1,3,3,2774),(1002040410,1,8,3,2774),(1002040420,1,16,3,2774),(1002040431,1,32,3,2774),(1002040432,1,48,3,2774),(1002040441,1,112,3,2774),(1002040442,1,160,3,2774),(1002040443,1,320,3,2774),(1002040453,1,560,3,2774),(1002040463,1,800,3,2774),(1002040500,1,4,3,4393),(1002040510,1,10,3,4393),(1002040520,1,20,3,4393),(1002040531,1,40,3,4393),(1002040532,1,60,3,4393),(1002040541,1,140,3,4393),(1002040542,1,200,3,4393),(1002040543,1,400,3,4393),(1002040553,1,700,3,4393),(1002040563,1,1000,3,4393),(1002040600,1,5,3,5462),(1002040610,1,12,3,5462),(1002040620,1,24,3,5462),(1002040631,1,48,3,5462),(1002040632,1,72,3,5462),(1002040641,1,168,3,5462),(1002040642,1,240,3,5462),(1002040643,1,480,3,5462),(1002040653,1,840,3,5462),(1002040663,1,1200,3,5462),(1002040700,1,6,3,5803),(1002040710,1,16,3,5803),(1002040720,1,32,3,5803),(1002040731,1,64,3,5803),(1002040732,1,96,3,5803),(1002040741,1,224,3,5803),(1002040742,1,320,3,5803),(1002040743,1,640,3,5803),(1002040753,1,1120,3,5803),(1002040763,1,1600,3,5803),(1002040800,1,8,3,6406),(1002040810,1,20,3,6406),(1002040820,1,40,3,6406),(1002040831,1,80,3,6406),(1002040832,1,120,3,6406),(1002040841,1,280,3,6406),(1002040842,1,400,3,6406),(1002040843,1,800,3,6406),(1002040853,1,1400,3,6406),(1002040863,1,2000,3,6406),(1002040900,1,10,3,7662),(1002040910,1,24,3,7662),(1002040920,1,48,3,7662),(1002040931,1,96,3,7662),(1002040932,1,144,3,7662),(1002040941,1,336,3,7662),(1002040942,1,480,3,7662),(1002040943,1,960,3,7662),(1002040953,1,1680,3,7662),(1002040963,1,2400,3,7662),(1002041000,1,11,3,10963),(1002041010,1,28,3,10963),(1002041020,1,56,3,10963),(1002041031,1,112,3,10963),(1002041032,1,168,3,10963),(1002041041,1,392,3,10963),(1002041042,1,560,3,10963),(1002041043,1,1120,3,10963),(1002041053,1,1960,3,10963),(1002041063,1,2800,3,10963),(1002041100,1,13,3,15691),(1002041110,1,32,3,15691),(1002041120,1,64,3,15691),(1002041131,1,128,3,15691),(1002041132,1,192,3,15691),(1002041141,1,448,3,15691),(1002041142,1,640,3,15691),(1002041143,1,1280,3,15691),(1002041153,1,2240,3,15691),(1002041163,1,3200,3,15691),(1002041200,1,14,3,21452),(1002041210,1,36,3,21452),(1002041220,1,72,3,21452),(1002041231,1,144,3,21452),(1002041232,1,216,3,21452),(1002041241,1,504,3,21452),(1002041242,1,720,3,21452),(1002041243,1,1440,3,21452),(1002041253,1,2520,3,21452),(1002041263,1,3600,3,21452),(1002041300,1,16,3,30327),(1002041310,1,40,3,30327),(1002041320,1,80,3,30327),(1002041331,1,160,3,30327),(1002041332,1,240,3,30327),(1002041341,1,560,3,30327),(1002041342,1,800,3,30327),(1002041343,1,1600,3,30327),(1002041353,1,2800,3,30327),(1002041363,1,4000,3,30327),(1002041400,1,18,3,44741),(1002041410,1,44,3,44741),(1002041420,1,88,3,44741),(1002041431,1,176,3,44741),(1002041432,1,264,3,44741),(1002041441,1,616,3,44741),(1002041442,1,880,3,44741),(1002041443,1,1760,3,44741),(1002041453,1,3080,3,44741),(1002041463,1,4400,3,44741),(1002041500,1,19,3,53486),(1002041510,1,48,3,53486),(1002041520,1,96,3,53486),(1002041531,1,192,3,53486),(1002041532,1,288,3,53486),(1002041541,1,672,3,53486),(1002041542,1,960,3,53486),(1002041543,1,1920,3,53486),(1002041553,1,3360,3,53486),(1002041563,1,4800,3,53486),(1003000100,1,2,3,210),(1003000110,1,6,3,210),(1003000120,1,11,3,210),(1003000131,1,22,3,210),(1003000132,1,33,3,210),(1003000141,1,77,3,210),(1003000142,1,110,3,210),(1003000143,1,210,3,210),(1003000153,1,385,3,210),(1003000163,1,550,3,210),(1003000200,1,3,3,549),(1003000210,1,8,3,549),(1003000220,1,15,3,549),(1003000231,1,30,3,549),(1003000232,1,45,3,549),(1003000241,1,105,3,549),(1003000242,1,150,3,549),(1003000243,1,300,3,549),(1003000253,1,525,3,549),(1003000263,1,750,3,549),(1003000300,1,4,3,1447),(1003000310,1,11,3,1447),(1003000320,1,21,3,1447),(1003000331,1,42,3,1447),(1003000332,1,63,3,1447),(1003000341,1,147,3,1447),(1003000342,1,210,3,1447),(1003000343,1,420,3,1447),(1003000353,1,735,3,1447),(1003000363,1,1050,3,1447),(1003000400,1,6,3,2774),(1003000410,1,15,3,2774),(1003000420,1,30,3,2774),(1003000431,1,60,3,2774),(1003000432,1,90,3,2774),(1003000441,1,210,3,2774),(1003000442,1,300,3,2774),(1003000443,1,600,3,2774),(1003000453,1,1050,3,2774),(1003000463,1,1500,3,2774),(1003000500,1,7,3,4393),(1003000510,1,18,3,4393),(1003000520,1,36,3,4393),(1003000531,1,72,3,4393),(1003000532,1,108,3,4393),(1003000541,1,252,3,4393),(1003000542,1,360,3,4393),(1003000543,1,720,3,4393),(1003000553,1,1260,3,4393),(1003000563,1,1800,3,4393),(1003000600,1,9,3,5462),(1003000610,1,23,3,5462),(1003000620,1,45,3,5462),(1003000631,1,90,3,5462),(1003000632,1,135,3,5462),(1003000641,1,315,3,5462),(1003000642,1,450,3,5462),(1003000643,1,900,3,5462),(1003000653,1,1575,3,5462),(1003000663,1,2250,3,5462),(1003000700,1,12,3,5803),(1003000710,1,30,3,5803),(1003000720,1,60,3,5803),(1003000731,1,120,3,5803),(1003000732,1,180,3,5803),(1003000741,1,420,3,5803),(1003000742,1,600,3,5803),(1003000743,1,1200,3,5803),(1003000753,1,2100,3,5803),(1003000763,1,3000,3,5803),(1003000800,1,15,3,6406),(1003000810,1,38,3,6406),(1003000820,1,75,3,6406),(1003000831,1,150,3,6406),(1003000832,1,225,3,6406),(1003000841,1,525,3,6406),(1003000842,1,750,3,6406),(1003000843,1,1500,3,6406),(1003000853,1,2625,3,6406),(1003000863,1,3750,3,6406),(1003000900,1,18,3,7662),(1003000910,1,45,3,7662),(1003000920,1,90,3,7662),(1003000931,1,180,3,7662),(1003000932,1,270,3,7662),(1003000941,1,630,3,7662),(1003000942,1,900,3,7662),(1003000943,1,1800,3,7662),(1003000953,1,3150,3,7662),(1003000963,1,4500,3,7662),(1003001000,1,21,3,10963),(1003001010,1,53,3,10963),(1003001020,1,105,3,10963),(1003001031,1,210,3,10963),(1003001032,1,315,3,10963),(1003001041,1,735,3,10963),(1003001042,1,1050,3,10963),(1003001043,1,2100,3,10963),(1003001053,1,3675,3,10963),(1003001063,1,5250,3,10963),(1003001100,1,24,3,15691),(1003001110,1,60,3,15691),(1003001120,1,120,3,15691),(1003001131,1,240,3,15691),(1003001132,1,360,3,15691),(1003001141,1,840,3,15691),(1003001142,1,1200,3,15691),(1003001143,1,2400,3,15691),(1003001153,1,4200,3,15691),(1003001163,1,6000,3,15691),(1003001200,1,27,3,21452),(1003001210,1,68,3,21452),(1003001220,1,135,3,21452),(1003001231,1,270,3,21452),(1003001232,1,405,3,21452),(1003001241,1,945,3,21452),(1003001242,1,1350,3,21452),(1003001243,1,2700,3,21452),(1003001253,1,4725,3,21452),(1003001263,1,6750,3,21452),(1003001300,1,30,3,30327),(1003001310,1,75,3,30327),(1003001320,1,150,3,30327),(1003001331,1,300,3,30327),(1003001332,1,450,3,30327),(1003001341,1,1050,3,30327),(1003001342,1,1500,3,30327),(1003001343,1,3000,3,30327),(1003001353,1,5250,3,30327),(1003001363,1,7500,3,30327),(1003001400,1,33,3,44741),(1003001410,1,83,3,44741),(1003001420,1,165,3,44741),(1003001431,1,330,3,44741),(1003001432,1,495,3,44741),(1003001441,1,1155,3,44741),(1003001442,1,1650,3,44741),(1003001443,1,3300,3,44741),(1003001453,1,5775,3,44741),(1003001463,1,8250,3,44741),(1003001500,1,36,3,53486),(1003001510,1,90,3,53486),(1003001520,1,180,3,53486),(1003001531,1,360,3,53486),(1003001532,1,540,3,53486),(1003001541,1,1260,3,53486),(1003001542,1,1800,3,53486),(1003001543,1,3600,3,53486),(1003001553,1,6300,3,53486),(1003001563,1,9000,3,53486),(1004010100,1,1,3,210),(1004010110,1,3,3,210),(1004010120,1,6,3,210),(1004010131,1,12,3,210),(1004010132,1,18,3,210),(1004010141,1,42,3,210),(1004010142,1,60,3,210),(1004010143,1,110,3,210),(1004010153,1,210,3,210),(1004010163,1,300,3,210),(1004010200,1,2,3,549),(1004010210,1,4,3,549),(1004010220,1,8,3,549),(1004010231,1,16,3,549),(1004010232,1,24,3,549),(1004010241,1,56,3,549),(1004010242,1,80,3,549),(1004010243,1,160,3,549),(1004010253,1,280,3,549),(1004010263,1,400,3,549),(1004010300,1,2,3,1447),(1004010310,1,6,3,1447),(1004010320,1,12,3,1447),(1004010331,1,24,3,1447),(1004010332,1,36,3,1447),(1004010341,1,84,3,1447),(1004010342,1,120,3,1447),(1004010343,1,240,3,1447),(1004010353,1,420,3,1447),(1004010363,1,600,3,1447),(1004010400,1,3,3,2774),(1004010410,1,8,3,2774),(1004010420,1,16,3,2774),(1004010431,1,32,3,2774),(1004010432,1,48,3,2774),(1004010441,1,112,3,2774),(1004010442,1,160,3,2774),(1004010443,1,320,3,2774),(1004010453,1,560,3,2774),(1004010463,1,800,3,2774),(1004010500,1,4,3,4393),(1004010510,1,10,3,4393),(1004010520,1,20,3,4393),(1004010531,1,40,3,4393),(1004010532,1,60,3,4393),(1004010541,1,140,3,4393),(1004010542,1,200,3,4393),(1004010543,1,400,3,4393),(1004010553,1,700,3,4393),(1004010563,1,1000,3,4393),(1004010600,1,5,3,5462),(1004010610,1,12,3,5462),(1004010620,1,24,3,5462),(1004010631,1,48,3,5462),(1004010632,1,72,3,5462),(1004010641,1,168,3,5462),(1004010642,1,240,3,5462),(1004010643,1,480,3,5462),(1004010653,1,840,3,5462),(1004010663,1,1200,3,5462),(1004010700,1,6,3,5803),(1004010710,1,16,3,5803),(1004010720,1,32,3,5803),(1004010731,1,64,3,5803),(1004010732,1,96,3,5803),(1004010741,1,224,3,5803),(1004010742,1,320,3,5803),(1004010743,1,640,3,5803),(1004010753,1,1120,3,5803),(1004010763,1,1600,3,5803),(1004010800,1,8,3,6406),(1004010810,1,20,3,6406),(1004010820,1,40,3,6406),(1004010831,1,80,3,6406),(1004010832,1,120,3,6406),(1004010841,1,280,3,6406),(1004010842,1,400,3,6406),(1004010843,1,800,3,6406),(1004010853,1,1400,3,6406),(1004010863,1,2000,3,6406),(1004010900,1,10,3,7662),(1004010910,1,24,3,7662),(1004010920,1,48,3,7662),(1004010931,1,96,3,7662),(1004010932,1,144,3,7662),(1004010941,1,336,3,7662),(1004010942,1,480,3,7662),(1004010943,1,960,3,7662),(1004010953,1,1680,3,7662),(1004010963,1,2400,3,7662),(1004011000,1,11,3,10963),(1004011010,1,28,3,10963),(1004011020,1,56,3,10963),(1004011031,1,112,3,10963),(1004011032,1,168,3,10963),(1004011041,1,392,3,10963),(1004011042,1,560,3,10963),(1004011043,1,1120,3,10963),(1004011053,1,1960,3,10963),(1004011063,1,2800,3,10963),(1004011100,1,13,3,15691),(1004011110,1,32,3,15691),(1004011120,1,64,3,15691),(1004011131,1,128,3,15691),(1004011132,1,192,3,15691),(1004011141,1,448,3,15691),(1004011142,1,640,3,15691),(1004011143,1,1280,3,15691),(1004011153,1,2240,3,15691),(1004011163,1,3200,3,15691),(1004011200,1,14,3,21452),(1004011210,1,36,3,21452),(1004011220,1,72,3,21452),(1004011231,1,144,3,21452),(1004011232,1,216,3,21452),(1004011241,1,504,3,21452),(1004011242,1,720,3,21452),(1004011243,1,1440,3,21452),(1004011253,1,2520,3,21452),(1004011263,1,3600,3,21452),(1004011300,1,16,3,30327),(1004011310,1,40,3,30327),(1004011320,1,80,3,30327),(1004011331,1,160,3,30327),(1004011332,1,240,3,30327),(1004011341,1,560,3,30327),(1004011342,1,800,3,30327),(1004011343,1,1600,3,30327),(1004011353,1,2800,3,30327),(1004011363,1,4000,3,30327),(1004011400,1,18,3,44741),(1004011410,1,44,3,44741),(1004011420,1,88,3,44741),(1004011431,1,176,3,44741),(1004011432,1,264,3,44741),(1004011441,1,616,3,44741),(1004011442,1,880,3,44741),(1004011443,1,1760,3,44741),(1004011453,1,3080,3,44741),(1004011463,1,4400,3,44741),(1004011500,1,19,3,53486),(1004011510,1,48,3,53486),(1004011520,1,96,3,53486),(1004011531,1,192,3,53486),(1004011532,1,288,3,53486),(1004011541,1,672,3,53486),(1004011542,1,960,3,53486),(1004011543,1,1920,3,53486),(1004011553,1,3360,3,53486),(1004011563,1,4800,3,53486),(1004020100,1,1,3,210),(1004020110,1,3,3,210),(1004020120,1,6,3,210),(1004020131,1,12,3,210),(1004020132,1,18,3,210),(1004020141,1,42,3,210),(1004020142,1,60,3,210),(1004020143,1,110,3,210),(1004020153,1,210,3,210),(1004020163,1,300,3,210),(1004020200,1,2,3,549),(1004020210,1,4,3,549),(1004020220,1,8,3,549),(1004020231,1,16,3,549),(1004020232,1,24,3,549),(1004020241,1,56,3,549),(1004020242,1,80,3,549),(1004020243,1,160,3,549),(1004020253,1,280,3,549),(1004020263,1,400,3,549),(1004020300,1,2,3,1447),(1004020310,1,6,3,1447),(1004020320,1,12,3,1447),(1004020331,1,24,3,1447),(1004020332,1,36,3,1447),(1004020341,1,84,3,1447),(1004020342,1,120,3,1447),(1004020343,1,240,3,1447),(1004020353,1,420,3,1447),(1004020363,1,600,3,1447),(1004020400,1,3,3,2774),(1004020410,1,8,3,2774),(1004020420,1,16,3,2774),(1004020431,1,32,3,2774),(1004020432,1,48,3,2774),(1004020441,1,112,3,2774),(1004020442,1,160,3,2774),(1004020443,1,320,3,2774),(1004020453,1,560,3,2774),(1004020463,1,800,3,2774),(1004020500,1,4,3,4393),(1004020510,1,10,3,4393),(1004020520,1,20,3,4393),(1004020531,1,40,3,4393),(1004020532,1,60,3,4393),(1004020541,1,140,3,4393),(1004020542,1,200,3,4393),(1004020543,1,400,3,4393),(1004020553,1,700,3,4393),(1004020563,1,1000,3,4393),(1004020600,1,5,3,5462),(1004020610,1,12,3,5462),(1004020620,1,24,3,5462),(1004020631,1,48,3,5462),(1004020632,1,72,3,5462),(1004020641,1,168,3,5462),(1004020642,1,240,3,5462),(1004020643,1,480,3,5462),(1004020653,1,840,3,5462),(1004020663,1,1200,3,5462),(1004020700,1,6,3,5803),(1004020710,1,16,3,5803),(1004020720,1,32,3,5803),(1004020731,1,64,3,5803),(1004020732,1,96,3,5803),(1004020741,1,224,3,5803),(1004020742,1,320,3,5803),(1004020743,1,640,3,5803),(1004020753,1,1120,3,5803),(1004020763,1,1600,3,5803),(1004020800,1,8,3,6406),(1004020810,1,20,3,6406),(1004020820,1,40,3,6406),(1004020831,1,80,3,6406),(1004020832,1,120,3,6406),(1004020841,1,280,3,6406),(1004020842,1,400,3,6406),(1004020843,1,800,3,6406),(1004020853,1,1400,3,6406),(1004020863,1,2000,3,6406),(1004020900,1,10,3,7662),(1004020910,1,24,3,7662),(1004020920,1,48,3,7662),(1004020931,1,96,3,7662),(1004020932,1,144,3,7662),(1004020941,1,336,3,7662),(1004020942,1,480,3,7662),(1004020943,1,960,3,7662),(1004020953,1,1680,3,7662),(1004020963,1,2400,3,7662),(1004021000,1,11,3,10963),(1004021010,1,28,3,10963),(1004021020,1,56,3,10963),(1004021031,1,112,3,10963),(1004021032,1,168,3,10963),(1004021041,1,392,3,10963),(1004021042,1,560,3,10963),(1004021043,1,1120,3,10963),(1004021053,1,1960,3,10963),(1004021063,1,2800,3,10963),(1004021100,1,13,3,15691),(1004021110,1,32,3,15691),(1004021120,1,64,3,15691),(1004021131,1,128,3,15691),(1004021132,1,192,3,15691),(1004021141,1,448,3,15691),(1004021142,1,640,3,15691),(1004021143,1,1280,3,15691),(1004021153,1,2240,3,15691),(1004021163,1,3200,3,15691),(1004021200,1,14,3,21452),(1004021210,1,36,3,21452),(1004021220,1,72,3,21452),(1004021231,1,144,3,21452),(1004021232,1,216,3,21452),(1004021241,1,504,3,21452),(1004021242,1,720,3,21452),(1004021243,1,1440,3,21452),(1004021253,1,2520,3,21452),(1004021263,1,3600,3,21452),(1004021300,1,16,3,30327),(1004021310,1,40,3,30327),(1004021320,1,80,3,30327),(1004021331,1,160,3,30327),(1004021332,1,240,3,30327),(1004021341,1,560,3,30327),(1004021342,1,800,3,30327),(1004021343,1,1600,3,30327),(1004021353,1,2800,3,30327),(1004021363,1,4000,3,30327),(1004021400,1,18,3,44741),(1004021410,1,44,3,44741),(1004021420,1,88,3,44741),(1004021431,1,176,3,44741),(1004021432,1,264,3,44741),(1004021441,1,616,3,44741),(1004021442,1,880,3,44741),(1004021443,1,1760,3,44741),(1004021453,1,3080,3,44741),(1004021463,1,4400,3,44741),(1004021500,1,19,3,53486),(1004021510,1,48,3,53486),(1004021520,1,96,3,53486),(1004021531,1,192,3,53486),(1004021532,1,288,3,53486),(1004021541,1,672,3,53486),(1004021542,1,960,3,53486),(1004021543,1,1920,3,53486),(1004021553,1,3360,3,53486),(1004021563,1,4800,3,53486),(1004030100,1,1,3,210),(1004030110,1,3,3,210),(1004030120,1,6,3,210),(1004030131,1,12,3,210),(1004030132,1,18,3,210),(1004030141,1,42,3,210),(1004030142,1,60,3,210),(1004030143,1,110,3,210),(1004030153,1,210,3,210),(1004030163,1,300,3,210),(1004030200,1,2,3,549),(1004030210,1,4,3,549),(1004030220,1,8,3,549),(1004030231,1,16,3,549),(1004030232,1,24,3,549),(1004030241,1,56,3,549),(1004030242,1,80,3,549),(1004030243,1,160,3,549),(1004030253,1,280,3,549),(1004030263,1,400,3,549),(1004030300,1,2,3,1447),(1004030310,1,6,3,1447),(1004030320,1,12,3,1447),(1004030331,1,24,3,1447),(1004030332,1,36,3,1447),(1004030341,1,84,3,1447),(1004030342,1,120,3,1447),(1004030343,1,240,3,1447),(1004030353,1,420,3,1447),(1004030363,1,600,3,1447),(1004030400,1,3,3,2774),(1004030410,1,8,3,2774),(1004030420,1,16,3,2774),(1004030431,1,32,3,2774),(1004030432,1,48,3,2774),(1004030441,1,112,3,2774),(1004030442,1,160,3,2774),(1004030443,1,320,3,2774),(1004030453,1,560,3,2774),(1004030463,1,800,3,2774),(1004030500,1,4,3,4393),(1004030510,1,10,3,4393),(1004030520,1,20,3,4393),(1004030531,1,40,3,4393),(1004030532,1,60,3,4393),(1004030541,1,140,3,4393),(1004030542,1,200,3,4393),(1004030543,1,400,3,4393),(1004030553,1,700,3,4393),(1004030563,1,1000,3,4393),(1004030600,1,5,3,5462),(1004030610,1,12,3,5462),(1004030620,1,24,3,5462),(1004030631,1,48,3,5462),(1004030632,1,72,3,5462),(1004030641,1,168,3,5462),(1004030642,1,240,3,5462),(1004030643,1,480,3,5462),(1004030653,1,840,3,5462),(1004030663,1,1200,3,5462),(1004030700,1,6,3,5803),(1004030710,1,16,3,5803),(1004030720,1,32,3,5803),(1004030731,1,64,3,5803),(1004030732,1,96,3,5803),(1004030741,1,224,3,5803),(1004030742,1,320,3,5803),(1004030743,1,640,3,5803),(1004030753,1,1120,3,5803),(1004030763,1,1600,3,5803),(1004030800,1,8,3,6406),(1004030810,1,20,3,6406),(1004030820,1,40,3,6406),(1004030831,1,80,3,6406),(1004030832,1,120,3,6406),(1004030841,1,280,3,6406),(1004030842,1,400,3,6406),(1004030843,1,800,3,6406),(1004030853,1,1400,3,6406),(1004030863,1,2000,3,6406),(1004030900,1,10,3,7662),(1004030910,1,24,3,7662),(1004030920,1,48,3,7662),(1004030931,1,96,3,7662),(1004030932,1,144,3,7662),(1004030941,1,336,3,7662),(1004030942,1,480,3,7662),(1004030943,1,960,3,7662),(1004030953,1,1680,3,7662),(1004030963,1,2400,3,7662),(1004031000,1,11,3,10963),(1004031010,1,28,3,10963),(1004031020,1,56,3,10963),(1004031031,1,112,3,10963),(1004031032,1,168,3,10963),(1004031041,1,392,3,10963),(1004031042,1,560,3,10963),(1004031043,1,1120,3,10963),(1004031053,1,1960,3,10963),(1004031063,1,2800,3,10963),(1004031100,1,13,3,15691),(1004031110,1,32,3,15691),(1004031120,1,64,3,15691),(1004031131,1,128,3,15691),(1004031132,1,192,3,15691),(1004031141,1,448,3,15691),(1004031142,1,640,3,15691),(1004031143,1,1280,3,15691),(1004031153,1,2240,3,15691),(1004031163,1,3200,3,15691),(1004031200,1,14,3,21452),(1004031210,1,36,3,21452),(1004031220,1,72,3,21452),(1004031231,1,144,3,21452),(1004031232,1,216,3,21452),(1004031241,1,504,3,21452),(1004031242,1,720,3,21452),(1004031243,1,1440,3,21452),(1004031253,1,2520,3,21452),(1004031263,1,3600,3,21452),(1004031300,1,16,3,30327),(1004031310,1,40,3,30327),(1004031320,1,80,3,30327),(1004031331,1,160,3,30327),(1004031332,1,240,3,30327),(1004031341,1,560,3,30327),(1004031342,1,800,3,30327),(1004031343,1,1600,3,30327),(1004031353,1,2800,3,30327),(1004031363,1,4000,3,30327),(1004031400,1,18,3,44741),(1004031410,1,44,3,44741),(1004031420,1,88,3,44741),(1004031431,1,176,3,44741),(1004031432,1,264,3,44741),(1004031441,1,616,3,44741),(1004031442,1,880,3,44741),(1004031443,1,1760,3,44741),(1004031453,1,3080,3,44741),(1004031463,1,4400,3,44741),(1004031500,1,19,3,53486),(1004031510,1,48,3,53486),(1004031520,1,96,3,53486),(1004031531,1,192,3,53486),(1004031532,1,288,3,53486),(1004031541,1,672,3,53486),(1004031542,1,960,3,53486),(1004031543,1,1920,3,53486),(1004031553,1,3360,3,53486),(1004031563,1,4800,3,53486),(1004040100,1,1,3,210),(1004040110,1,3,3,210),(1004040120,1,6,3,210),(1004040131,1,12,3,210),(1004040132,1,18,3,210),(1004040141,1,42,3,210),(1004040142,1,60,3,210),(1004040143,1,110,3,210),(1004040153,1,210,3,210),(1004040163,1,300,3,210),(1004040200,1,2,3,549),(1004040210,1,4,3,549),(1004040220,1,8,3,549),(1004040231,1,16,3,549),(1004040232,1,24,3,549),(1004040241,1,56,3,549),(1004040242,1,80,3,549),(1004040243,1,160,3,549),(1004040253,1,280,3,549),(1004040263,1,400,3,549),(1004040300,1,2,3,1447),(1004040310,1,6,3,1447),(1004040320,1,12,3,1447),(1004040331,1,24,3,1447),(1004040332,1,36,3,1447),(1004040341,1,84,3,1447),(1004040342,1,120,3,1447),(1004040343,1,240,3,1447),(1004040353,1,420,3,1447),(1004040363,1,600,3,1447),(1004040400,1,3,3,2774),(1004040410,1,8,3,2774),(1004040420,1,16,3,2774),(1004040431,1,32,3,2774),(1004040432,1,48,3,2774),(1004040441,1,112,3,2774),(1004040442,1,160,3,2774),(1004040443,1,320,3,2774),(1004040453,1,560,3,2774),(1004040463,1,800,3,2774),(1004040500,1,4,3,4393),(1004040510,1,10,3,4393),(1004040520,1,20,3,4393),(1004040531,1,40,3,4393),(1004040532,1,60,3,4393),(1004040541,1,140,3,4393),(1004040542,1,200,3,4393),(1004040543,1,400,3,4393),(1004040553,1,700,3,4393),(1004040563,1,1000,3,4393),(1004040600,1,5,3,5462),(1004040610,1,12,3,5462),(1004040620,1,24,3,5462),(1004040631,1,48,3,5462),(1004040632,1,72,3,5462),(1004040641,1,168,3,5462),(1004040642,1,240,3,5462),(1004040643,1,480,3,5462),(1004040653,1,840,3,5462),(1004040663,1,1200,3,5462),(1004040700,1,6,3,5803),(1004040710,1,16,3,5803),(1004040720,1,32,3,5803),(1004040731,1,64,3,5803),(1004040732,1,96,3,5803),(1004040741,1,224,3,5803),(1004040742,1,320,3,5803),(1004040743,1,640,3,5803),(1004040753,1,1120,3,5803),(1004040763,1,1600,3,5803),(1004040800,1,8,3,6406),(1004040810,1,20,3,6406),(1004040820,1,40,3,6406),(1004040831,1,80,3,6406),(1004040832,1,120,3,6406),(1004040841,1,280,3,6406),(1004040842,1,400,3,6406),(1004040843,1,800,3,6406),(1004040853,1,1400,3,6406),(1004040863,1,2000,3,6406),(1004040900,1,10,3,7662),(1004040910,1,24,3,7662),(1004040920,1,48,3,7662),(1004040931,1,96,3,7662),(1004040932,1,144,3,7662),(1004040941,1,336,3,7662),(1004040942,1,480,3,7662),(1004040943,1,960,3,7662),(1004040953,1,1680,3,7662),(1004040963,1,2400,3,7662),(1004041000,1,11,3,10963),(1004041010,1,28,3,10963),(1004041020,1,56,3,10963),(1004041031,1,112,3,10963),(1004041032,1,168,3,10963),(1004041041,1,392,3,10963),(1004041042,1,560,3,10963),(1004041043,1,1120,3,10963),(1004041053,1,1960,3,10963),(1004041063,1,2800,3,10963),(1004041100,1,13,3,15691),(1004041110,1,32,3,15691),(1004041120,1,64,3,15691),(1004041131,1,128,3,15691),(1004041132,1,192,3,15691),(1004041141,1,448,3,15691),(1004041142,1,640,3,15691),(1004041143,1,1280,3,15691),(1004041153,1,2240,3,15691),(1004041163,1,3200,3,15691),(1004041200,1,14,3,21452),(1004041210,1,36,3,21452),(1004041220,1,72,3,21452),(1004041231,1,144,3,21452),(1004041232,1,216,3,21452),(1004041241,1,504,3,21452),(1004041242,1,720,3,21452),(1004041243,1,1440,3,21452),(1004041253,1,2520,3,21452),(1004041263,1,3600,3,21452),(1004041300,1,16,3,30327),(1004041310,1,40,3,30327),(1004041320,1,80,3,30327),(1004041331,1,160,3,30327),(1004041332,1,240,3,30327),(1004041341,1,560,3,30327),(1004041342,1,800,3,30327),(1004041343,1,1600,3,30327),(1004041353,1,2800,3,30327),(1004041363,1,4000,3,30327),(1004041400,1,18,3,44741),(1004041410,1,44,3,44741),(1004041420,1,88,3,44741),(1004041431,1,176,3,44741),(1004041432,1,264,3,44741),(1004041441,1,616,3,44741),(1004041442,1,880,3,44741),(1004041443,1,1760,3,44741),(1004041453,1,3080,3,44741),(1004041463,1,4400,3,44741),(1004041500,1,19,3,53486),(1004041510,1,48,3,53486),(1004041520,1,96,3,53486),(1004041531,1,192,3,53486),(1004041532,1,288,3,53486),(1004041541,1,672,3,53486),(1004041542,1,960,3,53486),(1004041543,1,1920,3,53486),(1004041553,1,3360,3,53486),(1004041563,1,4800,3,53486),(1005000100,1,2,3,210),(1005000110,1,6,3,210),(1005000120,1,11,3,210),(1005000131,1,22,3,210),(1005000132,1,33,3,210),(1005000141,1,77,3,210),(1005000142,1,110,3,210),(1005000143,1,210,3,210),(1005000153,1,385,3,210),(1005000163,1,550,3,210),(1005000200,1,3,3,549),(1005000210,1,8,3,549),(1005000220,1,15,3,549),(1005000231,1,30,3,549),(1005000232,1,45,3,549),(1005000241,1,105,3,549),(1005000242,1,150,3,549),(1005000243,1,300,3,549),(1005000253,1,525,3,549),(1005000263,1,750,3,549),(1005000300,1,4,3,1447),(1005000310,1,11,3,1447),(1005000320,1,21,3,1447),(1005000331,1,42,3,1447),(1005000332,1,63,3,1447),(1005000341,1,147,3,1447),(1005000342,1,210,3,1447),(1005000343,1,420,3,1447),(1005000353,1,735,3,1447),(1005000363,1,1050,3,1447),(1005000400,1,6,3,2774),(1005000410,1,15,3,2774),(1005000420,1,30,3,2774),(1005000431,1,60,3,2774),(1005000432,1,90,3,2774),(1005000441,1,210,3,2774),(1005000442,1,300,3,2774),(1005000443,1,600,3,2774),(1005000453,1,1050,3,2774),(1005000463,1,1500,3,2774),(1005000500,1,7,3,4393),(1005000510,1,18,3,4393),(1005000520,1,36,3,4393),(1005000531,1,72,3,4393),(1005000532,1,108,3,4393),(1005000541,1,252,3,4393),(1005000542,1,360,3,4393),(1005000543,1,720,3,4393),(1005000553,1,1260,3,4393),(1005000563,1,1800,3,4393),(1005000600,1,9,3,5462),(1005000610,1,23,3,5462),(1005000620,1,45,3,5462),(1005000631,1,90,3,5462),(1005000632,1,135,3,5462),(1005000641,1,315,3,5462),(1005000642,1,450,3,5462),(1005000643,1,900,3,5462),(1005000653,1,1575,3,5462),(1005000663,1,2250,3,5462),(1005000700,1,12,3,5803),(1005000710,1,30,3,5803),(1005000720,1,60,3,5803),(1005000731,1,120,3,5803),(1005000732,1,180,3,5803),(1005000741,1,420,3,5803),(1005000742,1,600,3,5803),(1005000743,1,1200,3,5803),(1005000753,1,2100,3,5803),(1005000763,1,3000,3,5803),(1005000800,1,15,3,6406),(1005000810,1,38,3,6406),(1005000820,1,75,3,6406),(1005000831,1,150,3,6406),(1005000832,1,225,3,6406),(1005000841,1,525,3,6406),(1005000842,1,750,3,6406),(1005000843,1,1500,3,6406),(1005000853,1,2625,3,6406),(1005000863,1,3750,3,6406),(1005000900,1,18,3,7662),(1005000910,1,45,3,7662),(1005000920,1,90,3,7662),(1005000931,1,180,3,7662),(1005000932,1,270,3,7662),(1005000941,1,630,3,7662),(1005000942,1,900,3,7662),(1005000943,1,1800,3,7662),(1005000953,1,3150,3,7662),(1005000963,1,4500,3,7662),(1005001000,1,21,3,10963),(1005001010,1,53,3,10963),(1005001020,1,105,3,10963),(1005001031,1,210,3,10963),(1005001032,1,315,3,10963),(1005001041,1,735,3,10963),(1005001042,1,1050,3,10963),(1005001043,1,2100,3,10963),(1005001053,1,3675,3,10963),(1005001063,1,5250,3,10963),(1005001100,1,24,3,15691),(1005001110,1,60,3,15691),(1005001120,1,120,3,15691),(1005001131,1,240,3,15691),(1005001132,1,360,3,15691),(1005001141,1,840,3,15691),(1005001142,1,1200,3,15691),(1005001143,1,2400,3,15691),(1005001153,1,4200,3,15691),(1005001163,1,6000,3,15691),(1005001200,1,27,3,21452),(1005001210,1,68,3,21452),(1005001220,1,135,3,21452),(1005001231,1,270,3,21452),(1005001232,1,405,3,21452),(1005001241,1,945,3,21452),(1005001242,1,1350,3,21452),(1005001243,1,2700,3,21452),(1005001253,1,4725,3,21452),(1005001263,1,6750,3,21452),(1005001300,1,30,3,30327),(1005001310,1,75,3,30327),(1005001320,1,150,3,30327),(1005001331,1,300,3,30327),(1005001332,1,450,3,30327),(1005001341,1,1050,3,30327),(1005001342,1,1500,3,30327),(1005001343,1,3000,3,30327),(1005001353,1,5250,3,30327),(1005001363,1,7500,3,30327),(1005001400,1,33,3,44741),(1005001410,1,83,3,44741),(1005001420,1,165,3,44741),(1005001431,1,330,3,44741),(1005001432,1,495,3,44741),(1005001441,1,1155,3,44741),(1005001442,1,1650,3,44741),(1005001443,1,3300,3,44741),(1005001453,1,5775,3,44741),(1005001463,1,8250,3,44741),(1005001500,1,36,3,53486),(1005001510,1,90,3,53486),(1005001520,1,180,3,53486),(1005001531,1,360,3,53486),(1005001532,1,540,3,53486),(1005001541,1,1260,3,53486),(1005001542,1,1800,3,53486),(1005001543,1,3600,3,53486),(1005001553,1,6300,3,53486),(1005001563,1,9000,3,53486),(1006010100,1,1,3,210),(1006010110,1,3,3,210),(1006010120,1,6,3,210),(1006010131,1,12,3,210),(1006010132,1,18,3,210),(1006010141,1,42,3,210),(1006010142,1,60,3,210),(1006010143,1,110,3,210),(1006010153,1,210,3,210),(1006010163,1,300,3,210),(1006010200,1,2,3,549),(1006010210,1,4,3,549),(1006010220,1,8,3,549),(1006010231,1,16,3,549),(1006010232,1,24,3,549),(1006010241,1,56,3,549),(1006010242,1,80,3,549),(1006010243,1,160,3,549),(1006010253,1,280,3,549),(1006010263,1,400,3,549),(1006010300,1,2,3,1447),(1006010310,1,6,3,1447),(1006010320,1,12,3,1447),(1006010331,1,24,3,1447),(1006010332,1,36,3,1447),(1006010341,1,84,3,1447),(1006010342,1,120,3,1447),(1006010343,1,240,3,1447),(1006010353,1,420,3,1447),(1006010363,1,600,3,1447),(1006010400,1,3,3,2774),(1006010410,1,8,3,2774),(1006010420,1,16,3,2774),(1006010431,1,32,3,2774),(1006010432,1,48,3,2774),(1006010441,1,112,3,2774),(1006010442,1,160,3,2774),(1006010443,1,320,3,2774),(1006010453,1,560,3,2774),(1006010463,1,800,3,2774),(1006010500,1,4,3,4393),(1006010510,1,10,3,4393),(1006010520,1,20,3,4393),(1006010531,1,40,3,4393),(1006010532,1,60,3,4393),(1006010541,1,140,3,4393),(1006010542,1,200,3,4393),(1006010543,1,400,3,4393),(1006010553,1,700,3,4393),(1006010563,1,1000,3,4393),(1006010600,1,5,3,5462),(1006010610,1,12,3,5462),(1006010620,1,24,3,5462),(1006010631,1,48,3,5462),(1006010632,1,72,3,5462),(1006010641,1,168,3,5462),(1006010642,1,240,3,5462),(1006010643,1,480,3,5462),(1006010653,1,840,3,5462),(1006010663,1,1200,3,5462),(1006010700,1,6,3,5803),(1006010710,1,16,3,5803),(1006010720,1,32,3,5803),(1006010731,1,64,3,5803),(1006010732,1,96,3,5803),(1006010741,1,224,3,5803),(1006010742,1,320,3,5803),(1006010743,1,640,3,5803),(1006010753,1,1120,3,5803),(1006010763,1,1600,3,5803),(1006010800,1,8,3,6406),(1006010810,1,20,3,6406),(1006010820,1,40,3,6406),(1006010831,1,80,3,6406),(1006010832,1,120,3,6406),(1006010841,1,280,3,6406),(1006010842,1,400,3,6406),(1006010843,1,800,3,6406),(1006010853,1,1400,3,6406),(1006010863,1,2000,3,6406),(1006010900,1,10,3,7662),(1006010910,1,24,3,7662),(1006010920,1,48,3,7662),(1006010931,1,96,3,7662),(1006010932,1,144,3,7662),(1006010941,1,336,3,7662),(1006010942,1,480,3,7662),(1006010943,1,960,3,7662),(1006010953,1,1680,3,7662),(1006010963,1,2400,3,7662),(1006011000,1,11,3,10963),(1006011010,1,28,3,10963),(1006011020,1,56,3,10963),(1006011031,1,112,3,10963),(1006011032,1,168,3,10963),(1006011041,1,392,3,10963),(1006011042,1,560,3,10963),(1006011043,1,1120,3,10963),(1006011053,1,1960,3,10963),(1006011063,1,2800,3,10963),(1006011100,1,13,3,15691),(1006011110,1,32,3,15691),(1006011120,1,64,3,15691),(1006011131,1,128,3,15691),(1006011132,1,192,3,15691),(1006011141,1,448,3,15691),(1006011142,1,640,3,15691),(1006011143,1,1280,3,15691),(1006011153,1,2240,3,15691),(1006011163,1,3200,3,15691),(1006011200,1,14,3,21452),(1006011210,1,36,3,21452),(1006011220,1,72,3,21452),(1006011231,1,144,3,21452),(1006011232,1,216,3,21452),(1006011241,1,504,3,21452),(1006011242,1,720,3,21452),(1006011243,1,1440,3,21452),(1006011253,1,2520,3,21452),(1006011263,1,3600,3,21452),(1006011300,1,16,3,30327),(1006011310,1,40,3,30327),(1006011320,1,80,3,30327),(1006011331,1,160,3,30327),(1006011332,1,240,3,30327),(1006011341,1,560,3,30327),(1006011342,1,800,3,30327),(1006011343,1,1600,3,30327),(1006011353,1,2800,3,30327),(1006011363,1,4000,3,30327),(1006011400,1,18,3,44741),(1006011410,1,44,3,44741),(1006011420,1,88,3,44741),(1006011431,1,176,3,44741),(1006011432,1,264,3,44741),(1006011441,1,616,3,44741),(1006011442,1,880,3,44741),(1006011443,1,1760,3,44741),(1006011453,1,3080,3,44741),(1006011463,1,4400,3,44741),(1006011500,1,19,3,53486),(1006011510,1,48,3,53486),(1006011520,1,96,3,53486),(1006011531,1,192,3,53486),(1006011532,1,288,3,53486),(1006011541,1,672,3,53486),(1006011542,1,960,3,53486),(1006011543,1,1920,3,53486),(1006011553,1,3360,3,53486),(1006011563,1,4800,3,53486),(1006020100,1,1,3,210),(1006020110,1,3,3,210),(1006020120,1,6,3,210),(1006020131,1,12,3,210),(1006020132,1,18,3,210),(1006020141,1,42,3,210),(1006020142,1,60,3,210),(1006020143,1,110,3,210),(1006020153,1,210,3,210),(1006020163,1,300,3,210),(1006020200,1,2,3,549),(1006020210,1,4,3,549),(1006020220,1,8,3,549),(1006020231,1,16,3,549),(1006020232,1,24,3,549),(1006020241,1,56,3,549),(1006020242,1,80,3,549),(1006020243,1,160,3,549),(1006020253,1,280,3,549),(1006020263,1,400,3,549),(1006020300,1,2,3,1447),(1006020310,1,6,3,1447),(1006020320,1,12,3,1447),(1006020331,1,24,3,1447),(1006020332,1,36,3,1447),(1006020341,1,84,3,1447),(1006020342,1,120,3,1447),(1006020343,1,240,3,1447),(1006020353,1,420,3,1447),(1006020363,1,600,3,1447),(1006020400,1,3,3,2774),(1006020410,1,8,3,2774),(1006020420,1,16,3,2774),(1006020431,1,32,3,2774),(1006020432,1,48,3,2774),(1006020441,1,112,3,2774),(1006020442,1,160,3,2774),(1006020443,1,320,3,2774),(1006020453,1,560,3,2774),(1006020463,1,800,3,2774),(1006020500,1,4,3,4393),(1006020510,1,10,3,4393),(1006020520,1,20,3,4393),(1006020531,1,40,3,4393),(1006020532,1,60,3,4393),(1006020541,1,140,3,4393),(1006020542,1,200,3,4393),(1006020543,1,400,3,4393),(1006020553,1,700,3,4393),(1006020563,1,1000,3,4393),(1006020600,1,5,3,5462),(1006020610,1,12,3,5462),(1006020620,1,24,3,5462),(1006020631,1,48,3,5462),(1006020632,1,72,3,5462),(1006020641,1,168,3,5462),(1006020642,1,240,3,5462),(1006020643,1,480,3,5462),(1006020653,1,840,3,5462),(1006020663,1,1200,3,5462),(1006020700,1,6,3,5803),(1006020710,1,16,3,5803),(1006020720,1,32,3,5803),(1006020731,1,64,3,5803),(1006020732,1,96,3,5803),(1006020741,1,224,3,5803),(1006020742,1,320,3,5803),(1006020743,1,640,3,5803),(1006020753,1,1120,3,5803),(1006020763,1,1600,3,5803),(1006020800,1,8,3,6406),(1006020810,1,20,3,6406),(1006020820,1,40,3,6406),(1006020831,1,80,3,6406),(1006020832,1,120,3,6406),(1006020841,1,280,3,6406),(1006020842,1,400,3,6406),(1006020843,1,800,3,6406),(1006020853,1,1400,3,6406),(1006020863,1,2000,3,6406),(1006020900,1,10,3,7662),(1006020910,1,24,3,7662),(1006020920,1,48,3,7662),(1006020931,1,96,3,7662),(1006020932,1,144,3,7662),(1006020941,1,336,3,7662),(1006020942,1,480,3,7662),(1006020943,1,960,3,7662),(1006020953,1,1680,3,7662),(1006020963,1,2400,3,7662),(1006021000,1,11,3,10963),(1006021010,1,28,3,10963),(1006021020,1,56,3,10963),(1006021031,1,112,3,10963),(1006021032,1,168,3,10963),(1006021041,1,392,3,10963),(1006021042,1,560,3,10963),(1006021043,1,1120,3,10963),(1006021053,1,1960,3,10963),(1006021063,1,2800,3,10963),(1006021100,1,13,3,15691),(1006021110,1,32,3,15691),(1006021120,1,64,3,15691),(1006021131,1,128,3,15691),(1006021132,1,192,3,15691),(1006021141,1,448,3,15691),(1006021142,1,640,3,15691),(1006021143,1,1280,3,15691),(1006021153,1,2240,3,15691),(1006021163,1,3200,3,15691),(1006021200,1,14,3,21452),(1006021210,1,36,3,21452),(1006021220,1,72,3,21452),(1006021231,1,144,3,21452),(1006021232,1,216,3,21452),(1006021241,1,504,3,21452),(1006021242,1,720,3,21452),(1006021243,1,1440,3,21452),(1006021253,1,2520,3,21452),(1006021263,1,3600,3,21452),(1006021300,1,16,3,30327),(1006021310,1,40,3,30327),(1006021320,1,80,3,30327),(1006021331,1,160,3,30327),(1006021332,1,240,3,30327),(1006021341,1,560,3,30327),(1006021342,1,800,3,30327),(1006021343,1,1600,3,30327),(1006021353,1,2800,3,30327),(1006021363,1,4000,3,30327),(1006021400,1,18,3,44741),(1006021410,1,44,3,44741),(1006021420,1,88,3,44741),(1006021431,1,176,3,44741),(1006021432,1,264,3,44741),(1006021441,1,616,3,44741),(1006021442,1,880,3,44741),(1006021443,1,1760,3,44741),(1006021453,1,3080,3,44741),(1006021463,1,4400,3,44741),(1006021500,1,19,3,53486),(1006021510,1,48,3,53486),(1006021520,1,96,3,53486),(1006021531,1,192,3,53486),(1006021532,1,288,3,53486),(1006021541,1,672,3,53486),(1006021542,1,960,3,53486),(1006021543,1,1920,3,53486),(1006021553,1,3360,3,53486),(1006021563,1,4800,3,53486),(1006030100,1,1,3,210),(1006030110,1,3,3,210),(1006030120,1,6,3,210),(1006030131,1,12,3,210),(1006030132,1,18,3,210),(1006030141,1,42,3,210),(1006030142,1,60,3,210),(1006030143,1,110,3,210),(1006030153,1,210,3,210),(1006030163,1,300,3,210),(1006030200,1,2,3,549),(1006030210,1,4,3,549),(1006030220,1,8,3,549),(1006030231,1,16,3,549),(1006030232,1,24,3,549),(1006030241,1,56,3,549),(1006030242,1,80,3,549),(1006030243,1,160,3,549),(1006030253,1,280,3,549),(1006030263,1,400,3,549),(1006030300,1,2,3,1447),(1006030310,1,6,3,1447),(1006030320,1,12,3,1447),(1006030331,1,24,3,1447),(1006030332,1,36,3,1447),(1006030341,1,84,3,1447),(1006030342,1,120,3,1447),(1006030343,1,240,3,1447),(1006030353,1,420,3,1447),(1006030363,1,600,3,1447),(1006030400,1,3,3,2774),(1006030410,1,8,3,2774),(1006030420,1,16,3,2774),(1006030431,1,32,3,2774),(1006030432,1,48,3,2774),(1006030441,1,112,3,2774),(1006030442,1,160,3,2774),(1006030443,1,320,3,2774),(1006030453,1,560,3,2774),(1006030463,1,800,3,2774),(1006030500,1,4,3,4393),(1006030510,1,10,3,4393),(1006030520,1,20,3,4393),(1006030531,1,40,3,4393),(1006030532,1,60,3,4393),(1006030541,1,140,3,4393),(1006030542,1,200,3,4393),(1006030543,1,400,3,4393),(1006030553,1,700,3,4393),(1006030563,1,1000,3,4393),(1006030600,1,5,3,5462),(1006030610,1,12,3,5462),(1006030620,1,24,3,5462),(1006030631,1,48,3,5462),(1006030632,1,72,3,5462),(1006030641,1,168,3,5462),(1006030642,1,240,3,5462),(1006030643,1,480,3,5462),(1006030653,1,840,3,5462),(1006030663,1,1200,3,5462),(1006030700,1,6,3,5803),(1006030710,1,16,3,5803),(1006030720,1,32,3,5803),(1006030731,1,64,3,5803),(1006030732,1,96,3,5803),(1006030741,1,224,3,5803),(1006030742,1,320,3,5803),(1006030743,1,640,3,5803),(1006030753,1,1120,3,5803),(1006030763,1,1600,3,5803),(1006030800,1,8,3,6406),(1006030810,1,20,3,6406),(1006030820,1,40,3,6406),(1006030831,1,80,3,6406),(1006030832,1,120,3,6406),(1006030841,1,280,3,6406),(1006030842,1,400,3,6406),(1006030843,1,800,3,6406),(1006030853,1,1400,3,6406),(1006030863,1,2000,3,6406),(1006030900,1,10,3,7662),(1006030910,1,24,3,7662),(1006030920,1,48,3,7662),(1006030931,1,96,3,7662),(1006030932,1,144,3,7662),(1006030941,1,336,3,7662),(1006030942,1,480,3,7662),(1006030943,1,960,3,7662),(1006030953,1,1680,3,7662),(1006030963,1,2400,3,7662),(1006031000,1,11,3,10963),(1006031010,1,28,3,10963),(1006031020,1,56,3,10963),(1006031031,1,112,3,10963),(1006031032,1,168,3,10963),(1006031041,1,392,3,10963),(1006031042,1,560,3,10963),(1006031043,1,1120,3,10963),(1006031053,1,1960,3,10963),(1006031063,1,2800,3,10963),(1006031100,1,13,3,15691),(1006031110,1,32,3,15691),(1006031120,1,64,3,15691),(1006031131,1,128,3,15691),(1006031132,1,192,3,15691),(1006031141,1,448,3,15691),(1006031142,1,640,3,15691),(1006031143,1,1280,3,15691),(1006031153,1,2240,3,15691),(1006031163,1,3200,3,15691),(1006031200,1,14,3,21452),(1006031210,1,36,3,21452),(1006031220,1,72,3,21452),(1006031231,1,144,3,21452),(1006031232,1,216,3,21452),(1006031241,1,504,3,21452),(1006031242,1,720,3,21452),(1006031243,1,1440,3,21452),(1006031253,1,2520,3,21452),(1006031263,1,3600,3,21452),(1006031300,1,16,3,30327),(1006031310,1,40,3,30327),(1006031320,1,80,3,30327),(1006031331,1,160,3,30327),(1006031332,1,240,3,30327),(1006031341,1,560,3,30327),(1006031342,1,800,3,30327),(1006031343,1,1600,3,30327),(1006031353,1,2800,3,30327),(1006031363,1,4000,3,30327),(1006031400,1,18,3,44741),(1006031410,1,44,3,44741),(1006031420,1,88,3,44741),(1006031431,1,176,3,44741),(1006031432,1,264,3,44741),(1006031441,1,616,3,44741),(1006031442,1,880,3,44741),(1006031443,1,1760,3,44741),(1006031453,1,3080,3,44741),(1006031463,1,4400,3,44741),(1006031500,1,19,3,53486),(1006031510,1,48,3,53486),(1006031520,1,96,3,53486),(1006031531,1,192,3,53486),(1006031532,1,288,3,53486),(1006031541,1,672,3,53486),(1006031542,1,960,3,53486),(1006031543,1,1920,3,53486),(1006031553,1,3360,3,53486),(1006031563,1,4800,3,53486),(1006040100,1,1,3,210),(1006040110,1,3,3,210),(1006040120,1,6,3,210),(1006040131,1,12,3,210),(1006040132,1,18,3,210),(1006040141,1,42,3,210),(1006040142,1,60,3,210),(1006040143,1,110,3,210),(1006040153,1,210,3,210),(1006040163,1,300,3,210),(1006040200,1,2,3,549),(1006040210,1,4,3,549),(1006040220,1,8,3,549),(1006040231,1,16,3,549),(1006040232,1,24,3,549),(1006040241,1,56,3,549),(1006040242,1,80,3,549),(1006040243,1,160,3,549),(1006040253,1,280,3,549),(1006040263,1,400,3,549),(1006040300,1,2,3,1447),(1006040310,1,6,3,1447),(1006040320,1,12,3,1447),(1006040331,1,24,3,1447),(1006040332,1,36,3,1447),(1006040341,1,84,3,1447),(1006040342,1,120,3,1447),(1006040343,1,240,3,1447),(1006040353,1,420,3,1447),(1006040363,1,600,3,1447),(1006040400,1,3,3,2774),(1006040410,1,8,3,2774),(1006040420,1,16,3,2774),(1006040431,1,32,3,2774),(1006040432,1,48,3,2774),(1006040441,1,112,3,2774),(1006040442,1,160,3,2774),(1006040443,1,320,3,2774),(1006040453,1,560,3,2774),(1006040463,1,800,3,2774),(1006040500,1,4,3,4393),(1006040510,1,10,3,4393),(1006040520,1,20,3,4393),(1006040531,1,40,3,4393),(1006040532,1,60,3,4393),(1006040541,1,140,3,4393),(1006040542,1,200,3,4393),(1006040543,1,400,3,4393),(1006040553,1,700,3,4393),(1006040563,1,1000,3,4393),(1006040600,1,5,3,5462),(1006040610,1,12,3,5462),(1006040620,1,24,3,5462),(1006040631,1,48,3,5462),(1006040632,1,72,3,5462),(1006040641,1,168,3,5462),(1006040642,1,240,3,5462),(1006040643,1,480,3,5462),(1006040653,1,840,3,5462),(1006040663,1,1200,3,5462),(1006040700,1,6,3,5803),(1006040710,1,16,3,5803),(1006040720,1,32,3,5803),(1006040731,1,64,3,5803),(1006040732,1,96,3,5803),(1006040741,1,224,3,5803),(1006040742,1,320,3,5803),(1006040743,1,640,3,5803),(1006040753,1,1120,3,5803),(1006040763,1,1600,3,5803),(1006040800,1,8,3,6406),(1006040810,1,20,3,6406),(1006040820,1,40,3,6406),(1006040831,1,80,3,6406),(1006040832,1,120,3,6406),(1006040841,1,280,3,6406),(1006040842,1,400,3,6406),(1006040843,1,800,3,6406),(1006040853,1,1400,3,6406),(1006040863,1,2000,3,6406),(1006040900,1,10,3,7662),(1006040910,1,24,3,7662),(1006040920,1,48,3,7662),(1006040931,1,96,3,7662),(1006040932,1,144,3,7662),(1006040941,1,336,3,7662),(1006040942,1,480,3,7662),(1006040943,1,960,3,7662),(1006040953,1,1680,3,7662),(1006040963,1,2400,3,7662),(1006041000,1,11,3,10963),(1006041010,1,28,3,10963),(1006041020,1,56,3,10963),(1006041031,1,112,3,10963),(1006041032,1,168,3,10963),(1006041041,1,392,3,10963),(1006041042,1,560,3,10963),(1006041043,1,1120,3,10963),(1006041053,1,1960,3,10963),(1006041063,1,2800,3,10963),(1006041100,1,13,3,15691),(1006041110,1,32,3,15691),(1006041120,1,64,3,15691),(1006041131,1,128,3,15691),(1006041132,1,192,3,15691),(1006041141,1,448,3,15691),(1006041142,1,640,3,15691),(1006041143,1,1280,3,15691),(1006041153,1,2240,3,15691),(1006041163,1,3200,3,15691),(1006041200,1,14,3,21452),(1006041210,1,36,3,21452),(1006041220,1,72,3,21452),(1006041231,1,144,3,21452),(1006041232,1,216,3,21452),(1006041241,1,504,3,21452),(1006041242,1,720,3,21452),(1006041243,1,1440,3,21452),(1006041253,1,2520,3,21452),(1006041263,1,3600,3,21452),(1006041300,1,16,3,30327),(1006041310,1,40,3,30327),(1006041320,1,80,3,30327),(1006041331,1,160,3,30327),(1006041332,1,240,3,30327),(1006041341,1,560,3,30327),(1006041342,1,800,3,30327),(1006041343,1,1600,3,30327),(1006041353,1,2800,3,30327),(1006041363,1,4000,3,30327),(1006041400,1,18,3,44741),(1006041410,1,44,3,44741),(1006041420,1,88,3,44741),(1006041431,1,176,3,44741),(1006041432,1,264,3,44741),(1006041441,1,616,3,44741),(1006041442,1,880,3,44741),(1006041443,1,1760,3,44741),(1006041453,1,3080,3,44741),(1006041463,1,4400,3,44741),(1006041500,1,19,3,53486),(1006041510,1,48,3,53486),(1006041520,1,96,3,53486),(1006041531,1,192,3,53486),(1006041532,1,288,3,53486),(1006041541,1,672,3,53486),(1006041542,1,960,3,53486),(1006041543,1,1920,3,53486),(1006041553,1,3360,3,53486),(1006041563,1,4800,3,53486),(1007010100,1,1,3,210),(1007010110,1,4,3,210),(1007010120,1,7,3,210),(1007010131,1,14,3,210),(1007010132,1,21,3,210),(1007010141,1,49,3,210),(1007010142,1,70,3,210),(1007010143,1,140,3,210),(1007010153,1,245,3,210),(1007010163,1,350,3,210),(1007010200,1,2,3,549),(1007010210,1,5,3,549),(1007010220,1,10,3,549),(1007010231,1,20,3,549),(1007010232,1,30,3,549),(1007010241,1,70,3,549),(1007010242,1,100,3,549),(1007010243,1,200,3,549),(1007010253,1,350,3,549),(1007010263,1,500,3,549),(1007010300,1,3,3,1447),(1007010310,1,8,3,1447),(1007010320,1,15,3,1447),(1007010331,1,30,3,1447),(1007010332,1,45,3,1447),(1007010341,1,105,3,1447),(1007010342,1,150,3,1447),(1007010343,1,300,3,1447),(1007010353,1,525,3,1447),(1007010363,1,750,3,1447),(1007010400,1,4,3,2774),(1007010410,1,10,3,2774),(1007010420,1,20,3,2774),(1007010431,1,40,3,2774),(1007010432,1,60,3,2774),(1007010441,1,140,3,2774),(1007010442,1,200,3,2774),(1007010443,1,400,3,2774),(1007010453,1,700,3,2774),(1007010463,1,1000,3,2774),(1007010500,1,5,3,4393),(1007010510,1,13,3,4393),(1007010520,1,25,3,4393),(1007010531,1,50,3,4393),(1007010532,1,75,3,4393),(1007010541,1,175,3,4393),(1007010542,1,250,3,4393),(1007010543,1,500,3,4393),(1007010553,1,875,3,4393),(1007010563,1,1250,3,4393),(1007010600,1,6,3,5462),(1007010610,1,15,3,5462),(1007010620,1,30,3,5462),(1007010631,1,60,3,5462),(1007010632,1,90,3,5462),(1007010641,1,210,3,5462),(1007010642,1,300,3,5462),(1007010643,1,600,3,5462),(1007010653,1,1050,3,5462),(1007010663,1,1500,3,5462),(1007010700,1,8,3,5803),(1007010710,1,20,3,5803),(1007010720,1,40,3,5803),(1007010731,1,80,3,5803),(1007010732,1,120,3,5803),(1007010741,1,280,3,5803),(1007010742,1,400,3,5803),(1007010743,1,800,3,5803),(1007010753,1,1400,3,5803),(1007010763,1,2000,3,5803),(1007010800,1,10,3,6406),(1007010810,1,25,3,6406),(1007010820,1,50,3,6406),(1007010831,1,100,3,6406),(1007010832,1,150,3,6406),(1007010841,1,350,3,6406),(1007010842,1,500,3,6406),(1007010843,1,1000,3,6406),(1007010853,1,1750,3,6406),(1007010863,1,2500,3,6406),(1007010900,1,12,3,7662),(1007010910,1,30,3,7662),(1007010920,1,60,3,7662),(1007010931,1,120,3,7662),(1007010932,1,180,3,7662),(1007010941,1,420,3,7662),(1007010942,1,600,3,7662),(1007010943,1,1200,3,7662),(1007010953,1,2100,3,7662),(1007010963,1,3000,3,7662),(1007011000,1,14,3,10963),(1007011010,1,35,3,10963),(1007011020,1,70,3,10963),(1007011031,1,140,3,10963),(1007011032,1,210,3,10963),(1007011041,1,490,3,10963),(1007011042,1,700,3,10963),(1007011043,1,1400,3,10963),(1007011053,1,2450,3,10963),(1007011063,1,3500,3,10963),(1007011100,1,16,3,15691),(1007011110,1,40,3,15691),(1007011120,1,80,3,15691),(1007011131,1,160,3,15691),(1007011132,1,240,3,15691),(1007011141,1,560,3,15691),(1007011142,1,800,3,15691),(1007011143,1,1600,3,15691),(1007011153,1,2800,3,15691),(1007011163,1,4000,3,15691),(1007011200,1,18,3,21452),(1007011210,1,45,3,21452),(1007011220,1,90,3,21452),(1007011231,1,180,3,21452),(1007011232,1,270,3,21452),(1007011241,1,630,3,21452),(1007011242,1,900,3,21452),(1007011243,1,1800,3,21452),(1007011253,1,3150,3,21452),(1007011263,1,4500,3,21452),(1007011300,1,20,3,30327),(1007011310,1,50,3,30327),(1007011320,1,100,3,30327),(1007011331,1,200,3,30327),(1007011332,1,300,3,30327),(1007011341,1,700,3,30327),(1007011342,1,1000,3,30327),(1007011343,1,2000,3,30327),(1007011353,1,3500,3,30327),(1007011363,1,5000,3,30327),(1007011400,1,22,3,44741),(1007011410,1,55,3,44741),(1007011420,1,110,3,44741),(1007011431,1,220,3,44741),(1007011432,1,330,3,44741),(1007011441,1,770,3,44741),(1007011442,1,1100,3,44741),(1007011443,1,2200,3,44741),(1007011453,1,3850,3,44741),(1007011463,1,5500,3,44741),(1007011500,1,24,3,53486),(1007011510,1,60,3,53486),(1007011520,1,120,3,53486),(1007011531,1,240,3,53486),(1007011532,1,360,3,53486),(1007011541,1,840,3,53486),(1007011542,1,1200,3,53486),(1007011543,1,2400,3,53486),(1007011553,1,4200,3,53486),(1007011563,1,6000,3,53486),(1007020100,1,1,3,210),(1007020110,1,4,3,210),(1007020120,1,7,3,210),(1007020131,1,14,3,210),(1007020132,1,21,3,210),(1007020141,1,49,3,210),(1007020142,1,70,3,210),(1007020143,1,140,3,210),(1007020153,1,245,3,210),(1007020163,1,350,3,210),(1007020200,1,2,3,549),(1007020210,1,5,3,549),(1007020220,1,10,3,549),(1007020231,1,20,3,549),(1007020232,1,30,3,549),(1007020241,1,70,3,549),(1007020242,1,100,3,549),(1007020243,1,200,3,549),(1007020253,1,350,3,549),(1007020263,1,500,3,549),(1007020300,1,3,3,1447),(1007020310,1,8,3,1447),(1007020320,1,15,3,1447),(1007020331,1,30,3,1447),(1007020332,1,45,3,1447),(1007020341,1,105,3,1447),(1007020342,1,150,3,1447),(1007020343,1,300,3,1447),(1007020353,1,525,3,1447),(1007020363,1,750,3,1447),(1007020400,1,4,3,2774),(1007020410,1,10,3,2774),(1007020420,1,20,3,2774),(1007020431,1,40,3,2774),(1007020432,1,60,3,2774),(1007020441,1,140,3,2774),(1007020442,1,200,3,2774),(1007020443,1,400,3,2774),(1007020453,1,700,3,2774),(1007020463,1,1000,3,2774),(1007020500,1,5,3,4393),(1007020510,1,13,3,4393),(1007020520,1,25,3,4393),(1007020531,1,50,3,4393),(1007020532,1,75,3,4393),(1007020541,1,175,3,4393),(1007020542,1,250,3,4393),(1007020543,1,500,3,4393),(1007020553,1,875,3,4393),(1007020563,1,1250,3,4393),(1007020600,1,6,3,5462),(1007020610,1,15,3,5462),(1007020620,1,30,3,5462),(1007020631,1,60,3,5462),(1007020632,1,90,3,5462),(1007020641,1,210,3,5462),(1007020642,1,300,3,5462),(1007020643,1,600,3,5462),(1007020653,1,1050,3,5462),(1007020663,1,1500,3,5462),(1007020700,1,8,3,5803),(1007020710,1,20,3,5803),(1007020720,1,40,3,5803),(1007020731,1,80,3,5803),(1007020732,1,120,3,5803),(1007020741,1,280,3,5803),(1007020742,1,400,3,5803),(1007020743,1,800,3,5803),(1007020753,1,1400,3,5803),(1007020763,1,2000,3,5803),(1007020800,1,10,3,6406),(1007020810,1,25,3,6406),(1007020820,1,50,3,6406),(1007020831,1,100,3,6406),(1007020832,1,150,3,6406),(1007020841,1,350,3,6406),(1007020842,1,500,3,6406),(1007020843,1,1000,3,6406),(1007020853,1,1750,3,6406),(1007020863,1,2500,3,6406),(1007020900,1,12,3,7662),(1007020910,1,30,3,7662),(1007020920,1,60,3,7662),(1007020931,1,120,3,7662),(1007020932,1,180,3,7662),(1007020941,1,420,3,7662),(1007020942,1,600,3,7662),(1007020943,1,1200,3,7662),(1007020953,1,2100,3,7662),(1007020963,1,3000,3,7662),(1007021000,1,14,3,10963),(1007021010,1,35,3,10963),(1007021020,1,70,3,10963),(1007021031,1,140,3,10963),(1007021032,1,210,3,10963),(1007021041,1,490,3,10963),(1007021042,1,700,3,10963),(1007021043,1,1400,3,10963),(1007021053,1,2450,3,10963),(1007021063,1,3500,3,10963),(1007021100,1,16,3,15691),(1007021110,1,40,3,15691),(1007021120,1,80,3,15691),(1007021131,1,160,3,15691),(1007021132,1,240,3,15691),(1007021141,1,560,3,15691),(1007021142,1,800,3,15691),(1007021143,1,1600,3,15691),(1007021153,1,2800,3,15691),(1007021163,1,4000,3,15691),(1007021200,1,18,3,21452),(1007021210,1,45,3,21452),(1007021220,1,90,3,21452),(1007021231,1,180,3,21452),(1007021232,1,270,3,21452),(1007021241,1,630,3,21452),(1007021242,1,900,3,21452),(1007021243,1,1800,3,21452),(1007021253,1,3150,3,21452),(1007021263,1,4500,3,21452),(1007021300,1,20,3,30327),(1007021310,1,50,3,30327),(1007021320,1,100,3,30327),(1007021331,1,200,3,30327),(1007021332,1,300,3,30327),(1007021341,1,700,3,30327),(1007021342,1,1000,3,30327),(1007021343,1,2000,3,30327),(1007021353,1,3500,3,30327),(1007021363,1,5000,3,30327),(1007021400,1,22,3,44741),(1007021410,1,55,3,44741),(1007021420,1,110,3,44741),(1007021431,1,220,3,44741),(1007021432,1,330,3,44741),(1007021441,1,770,3,44741),(1007021442,1,1100,3,44741),(1007021443,1,2200,3,44741),(1007021453,1,3850,3,44741),(1007021463,1,5500,3,44741),(1007021500,1,24,3,53486),(1007021510,1,60,3,53486),(1007021520,1,120,3,53486),(1007021531,1,240,3,53486),(1007021532,1,360,3,53486),(1007021541,1,840,3,53486),(1007021542,1,1200,3,53486),(1007021543,1,2400,3,53486),(1007021553,1,4200,3,53486),(1007021563,1,6000,3,53486),(1007030100,1,1,3,210),(1007030110,1,4,3,210),(1007030120,1,7,3,210),(1007030131,1,14,3,210),(1007030132,1,21,3,210),(1007030141,1,49,3,210),(1007030142,1,70,3,210),(1007030143,1,140,3,210),(1007030153,1,245,3,210),(1007030163,1,350,3,210),(1007030200,1,2,3,549),(1007030210,1,5,3,549),(1007030220,1,10,3,549),(1007030231,1,20,3,549),(1007030232,1,30,3,549),(1007030241,1,70,3,549),(1007030242,1,100,3,549),(1007030243,1,200,3,549),(1007030253,1,350,3,549),(1007030263,1,500,3,549),(1007030300,1,3,3,1447),(1007030310,1,8,3,1447),(1007030320,1,15,3,1447),(1007030331,1,30,3,1447),(1007030332,1,45,3,1447),(1007030341,1,105,3,1447),(1007030342,1,150,3,1447),(1007030343,1,300,3,1447),(1007030353,1,525,3,1447),(1007030363,1,750,3,1447),(1007030400,1,4,3,2774),(1007030410,1,10,3,2774),(1007030420,1,20,3,2774),(1007030431,1,40,3,2774),(1007030432,1,60,3,2774),(1007030441,1,140,3,2774),(1007030442,1,200,3,2774),(1007030443,1,400,3,2774),(1007030453,1,700,3,2774),(1007030463,1,1000,3,2774),(1007030500,1,5,3,4393),(1007030510,1,13,3,4393),(1007030520,1,25,3,4393),(1007030531,1,50,3,4393),(1007030532,1,75,3,4393),(1007030541,1,175,3,4393),(1007030542,1,250,3,4393),(1007030543,1,500,3,4393),(1007030553,1,875,3,4393),(1007030563,1,1250,3,4393),(1007030600,1,6,3,5462),(1007030610,1,15,3,5462),(1007030620,1,30,3,5462),(1007030631,1,60,3,5462),(1007030632,1,90,3,5462),(1007030641,1,210,3,5462),(1007030642,1,300,3,5462),(1007030643,1,600,3,5462),(1007030653,1,1050,3,5462),(1007030663,1,1500,3,5462),(1007030700,1,8,3,5803),(1007030710,1,20,3,5803),(1007030720,1,40,3,5803),(1007030731,1,80,3,5803),(1007030732,1,120,3,5803),(1007030741,1,280,3,5803),(1007030742,1,400,3,5803),(1007030743,1,800,3,5803),(1007030753,1,1400,3,5803),(1007030763,1,2000,3,5803),(1007030800,1,10,3,6406),(1007030810,1,25,3,6406),(1007030820,1,50,3,6406),(1007030831,1,100,3,6406),(1007030832,1,150,3,6406),(1007030841,1,350,3,6406),(1007030842,1,500,3,6406),(1007030843,1,1000,3,6406),(1007030853,1,1750,3,6406),(1007030863,1,2500,3,6406),(1007030900,1,12,3,7662),(1007030910,1,30,3,7662),(1007030920,1,60,3,7662),(1007030931,1,120,3,7662),(1007030932,1,180,3,7662),(1007030941,1,420,3,7662),(1007030942,1,600,3,7662),(1007030943,1,1200,3,7662),(1007030953,1,2100,3,7662),(1007030963,1,3000,3,7662),(1007031000,1,14,3,10963),(1007031010,1,35,3,10963),(1007031020,1,70,3,10963),(1007031031,1,140,3,10963),(1007031032,1,210,3,10963),(1007031041,1,490,3,10963),(1007031042,1,700,3,10963),(1007031043,1,1400,3,10963),(1007031053,1,2450,3,10963),(1007031063,1,3500,3,10963),(1007031100,1,16,3,15691),(1007031110,1,40,3,15691),(1007031120,1,80,3,15691),(1007031131,1,160,3,15691),(1007031132,1,240,3,15691),(1007031141,1,560,3,15691),(1007031142,1,800,3,15691),(1007031143,1,1600,3,15691),(1007031153,1,2800,3,15691),(1007031163,1,4000,3,15691),(1007031200,1,18,3,21452),(1007031210,1,45,3,21452),(1007031220,1,90,3,21452),(1007031231,1,180,3,21452),(1007031232,1,270,3,21452),(1007031241,1,630,3,21452),(1007031242,1,900,3,21452),(1007031243,1,1800,3,21452),(1007031253,1,3150,3,21452),(1007031263,1,4500,3,21452),(1007031300,1,20,3,30327),(1007031310,1,50,3,30327),(1007031320,1,100,3,30327),(1007031331,1,200,3,30327),(1007031332,1,300,3,30327),(1007031341,1,700,3,30327),(1007031342,1,1000,3,30327),(1007031343,1,2000,3,30327),(1007031353,1,3500,3,30327),(1007031363,1,5000,3,30327),(1007031400,1,22,3,44741),(1007031410,1,55,3,44741),(1007031420,1,110,3,44741),(1007031431,1,220,3,44741),(1007031432,1,330,3,44741),(1007031441,1,770,3,44741),(1007031442,1,1100,3,44741),(1007031443,1,2200,3,44741),(1007031453,1,3850,3,44741),(1007031463,1,5500,3,44741),(1007031500,1,24,3,53486),(1007031510,1,60,3,53486),(1007031520,1,120,3,53486),(1007031531,1,240,3,53486),(1007031532,1,360,3,53486),(1007031541,1,840,3,53486),(1007031542,1,1200,3,53486),(1007031543,1,2400,3,53486),(1007031553,1,4200,3,53486),(1007031563,1,6000,3,53486),(1007040100,1,1,3,210),(1007040110,1,4,3,210),(1007040120,1,7,3,210),(1007040131,1,14,3,210),(1007040132,1,21,3,210),(1007040141,1,49,3,210),(1007040142,1,70,3,210),(1007040143,1,140,3,210),(1007040153,1,245,3,210),(1007040163,1,350,3,210),(1007040200,1,2,3,549),(1007040210,1,5,3,549),(1007040220,1,10,3,549),(1007040231,1,20,3,549),(1007040232,1,30,3,549),(1007040241,1,70,3,549),(1007040242,1,100,3,549),(1007040243,1,200,3,549),(1007040253,1,350,3,549),(1007040263,1,500,3,549),(1007040300,1,3,3,1447),(1007040310,1,8,3,1447),(1007040320,1,15,3,1447),(1007040331,1,30,3,1447),(1007040332,1,45,3,1447),(1007040341,1,105,3,1447),(1007040342,1,150,3,1447),(1007040343,1,300,3,1447),(1007040353,1,525,3,1447),(1007040363,1,750,3,1447),(1007040400,1,4,3,2774),(1007040410,1,10,3,2774),(1007040420,1,20,3,2774),(1007040431,1,40,3,2774),(1007040432,1,60,3,2774),(1007040441,1,140,3,2774),(1007040442,1,200,3,2774),(1007040443,1,400,3,2774),(1007040453,1,700,3,2774),(1007040463,1,1000,3,2774),(1007040500,1,5,3,4393),(1007040510,1,13,3,4393),(1007040520,1,25,3,4393),(1007040531,1,50,3,4393),(1007040532,1,75,3,4393),(1007040541,1,175,3,4393),(1007040542,1,250,3,4393),(1007040543,1,500,3,4393),(1007040553,1,875,3,4393),(1007040563,1,1250,3,4393),(1007040600,1,6,3,5462),(1007040610,1,15,3,5462),(1007040620,1,30,3,5462),(1007040631,1,60,3,5462),(1007040632,1,90,3,5462),(1007040641,1,210,3,5462),(1007040642,1,300,3,5462),(1007040643,1,600,3,5462),(1007040653,1,1050,3,5462),(1007040663,1,1500,3,5462),(1007040700,1,8,3,5803),(1007040710,1,20,3,5803),(1007040720,1,40,3,5803),(1007040731,1,80,3,5803),(1007040732,1,120,3,5803),(1007040741,1,280,3,5803),(1007040742,1,400,3,5803),(1007040743,1,800,3,5803),(1007040753,1,1400,3,5803),(1007040763,1,2000,3,5803),(1007040800,1,10,3,6406),(1007040810,1,25,3,6406),(1007040820,1,50,3,6406),(1007040831,1,100,3,6406),(1007040832,1,150,3,6406),(1007040841,1,350,3,6406),(1007040842,1,500,3,6406),(1007040843,1,1000,3,6406),(1007040853,1,1750,3,6406),(1007040863,1,2500,3,6406),(1007040900,1,12,3,7662),(1007040910,1,30,3,7662),(1007040920,1,60,3,7662),(1007040931,1,120,3,7662),(1007040932,1,180,3,7662),(1007040941,1,420,3,7662),(1007040942,1,600,3,7662),(1007040943,1,1200,3,7662),(1007040953,1,2100,3,7662),(1007040963,1,3000,3,7662),(1007041000,1,14,3,10963),(1007041010,1,35,3,10963),(1007041020,1,70,3,10963),(1007041031,1,140,3,10963),(1007041032,1,210,3,10963),(1007041041,1,490,3,10963),(1007041042,1,700,3,10963),(1007041043,1,1400,3,10963),(1007041053,1,2450,3,10963),(1007041063,1,3500,3,10963),(1007041100,1,16,3,15691),(1007041110,1,40,3,15691),(1007041120,1,80,3,15691),(1007041131,1,160,3,15691),(1007041132,1,240,3,15691),(1007041141,1,560,3,15691),(1007041142,1,800,3,15691),(1007041143,1,1600,3,15691),(1007041153,1,2800,3,15691),(1007041163,1,4000,3,15691),(1007041200,1,18,3,21452),(1007041210,1,45,3,21452),(1007041220,1,90,3,21452),(1007041231,1,180,3,21452),(1007041232,1,270,3,21452),(1007041241,1,630,3,21452),(1007041242,1,900,3,21452),(1007041243,1,1800,3,21452),(1007041253,1,3150,3,21452),(1007041263,1,4500,3,21452),(1007041300,1,20,3,30327),(1007041310,1,50,3,30327),(1007041320,1,100,3,30327),(1007041331,1,200,3,30327),(1007041332,1,300,3,30327),(1007041341,1,700,3,30327),(1007041342,1,1000,3,30327),(1007041343,1,2000,3,30327),(1007041353,1,3500,3,30327),(1007041363,1,5000,3,30327),(1007041400,1,22,3,44741),(1007041410,1,55,3,44741),(1007041420,1,110,3,44741),(1007041431,1,220,3,44741),(1007041432,1,330,3,44741),(1007041441,1,770,3,44741),(1007041442,1,1100,3,44741),(1007041443,1,2200,3,44741),(1007041453,1,3850,3,44741),(1007041463,1,5500,3,44741),(1007041500,1,24,3,53486),(1007041510,1,60,3,53486),(1007041520,1,120,3,53486),(1007041531,1,240,3,53486),(1007041532,1,360,3,53486),(1007041541,1,840,3,53486),(1007041542,1,1200,3,53486),(1007041543,1,2400,3,53486),(1007041553,1,4200,3,53486),(1007041563,1,6000,3,53486),(1008010100,1,1,3,210),(1008010110,1,3,3,210),(1008010120,1,6,3,210),(1008010131,1,12,3,210),(1008010132,1,18,3,210),(1008010141,1,42,3,210),(1008010142,1,60,3,210),(1008010143,1,110,3,210),(1008010153,1,210,3,210),(1008010163,1,300,3,210),(1008010200,1,2,3,549),(1008010210,1,4,3,549),(1008010220,1,8,3,549),(1008010231,1,16,3,549),(1008010232,1,24,3,549),(1008010241,1,56,3,549),(1008010242,1,80,3,549),(1008010243,1,160,3,549),(1008010253,1,280,3,549),(1008010263,1,400,3,549),(1008010300,1,2,3,1447),(1008010310,1,6,3,1447),(1008010320,1,12,3,1447),(1008010331,1,24,3,1447),(1008010332,1,36,3,1447),(1008010341,1,84,3,1447),(1008010342,1,120,3,1447),(1008010343,1,240,3,1447),(1008010353,1,420,3,1447),(1008010363,1,600,3,1447),(1008010400,1,3,3,2774),(1008010410,1,8,3,2774),(1008010420,1,16,3,2774),(1008010431,1,32,3,2774),(1008010432,1,48,3,2774),(1008010441,1,112,3,2774),(1008010442,1,160,3,2774),(1008010443,1,320,3,2774),(1008010453,1,560,3,2774),(1008010463,1,800,3,2774),(1008010500,1,4,3,4393),(1008010510,1,10,3,4393),(1008010520,1,20,3,4393),(1008010531,1,40,3,4393),(1008010532,1,60,3,4393),(1008010541,1,140,3,4393),(1008010542,1,200,3,4393),(1008010543,1,400,3,4393),(1008010553,1,700,3,4393),(1008010563,1,1000,3,4393),(1008010600,1,5,3,5462),(1008010610,1,12,3,5462),(1008010620,1,24,3,5462),(1008010631,1,48,3,5462),(1008010632,1,72,3,5462),(1008010641,1,168,3,5462),(1008010642,1,240,3,5462),(1008010643,1,480,3,5462),(1008010653,1,840,3,5462),(1008010663,1,1200,3,5462),(1008010700,1,6,3,5803),(1008010710,1,16,3,5803),(1008010720,1,32,3,5803),(1008010731,1,64,3,5803),(1008010732,1,96,3,5803),(1008010741,1,224,3,5803),(1008010742,1,320,3,5803),(1008010743,1,640,3,5803),(1008010753,1,1120,3,5803),(1008010763,1,1600,3,5803),(1008010800,1,8,3,6406),(1008010810,1,20,3,6406),(1008010820,1,40,3,6406),(1008010831,1,80,3,6406),(1008010832,1,120,3,6406),(1008010841,1,280,3,6406),(1008010842,1,400,3,6406),(1008010843,1,800,3,6406),(1008010853,1,1400,3,6406),(1008010863,1,2000,3,6406),(1008010900,1,10,3,7662),(1008010910,1,24,3,7662),(1008010920,1,48,3,7662),(1008010931,1,96,3,7662),(1008010932,1,144,3,7662),(1008010941,1,336,3,7662),(1008010942,1,480,3,7662),(1008010943,1,960,3,7662),(1008010953,1,1680,3,7662),(1008010963,1,2400,3,7662),(1008011000,1,11,3,10963),(1008011010,1,28,3,10963),(1008011020,1,56,3,10963),(1008011031,1,112,3,10963),(1008011032,1,168,3,10963),(1008011041,1,392,3,10963),(1008011042,1,560,3,10963),(1008011043,1,1120,3,10963),(1008011053,1,1960,3,10963),(1008011063,1,2800,3,10963),(1008011100,1,13,3,15691),(1008011110,1,32,3,15691),(1008011120,1,64,3,15691),(1008011131,1,128,3,15691),(1008011132,1,192,3,15691),(1008011141,1,448,3,15691),(1008011142,1,640,3,15691),(1008011143,1,1280,3,15691),(1008011153,1,2240,3,15691),(1008011163,1,3200,3,15691),(1008011200,1,14,3,21452),(1008011210,1,36,3,21452),(1008011220,1,72,3,21452),(1008011231,1,144,3,21452),(1008011232,1,216,3,21452),(1008011241,1,504,3,21452),(1008011242,1,720,3,21452),(1008011243,1,1440,3,21452),(1008011253,1,2520,3,21452),(1008011263,1,3600,3,21452),(1008011300,1,16,3,30327),(1008011310,1,40,3,30327),(1008011320,1,80,3,30327),(1008011331,1,160,3,30327),(1008011332,1,240,3,30327),(1008011341,1,560,3,30327),(1008011342,1,800,3,30327),(1008011343,1,1600,3,30327),(1008011353,1,2800,3,30327),(1008011363,1,4000,3,30327),(1008011400,1,18,3,44741),(1008011410,1,44,3,44741),(1008011420,1,88,3,44741),(1008011431,1,176,3,44741),(1008011432,1,264,3,44741),(1008011441,1,616,3,44741),(1008011442,1,880,3,44741),(1008011443,1,1760,3,44741),(1008011453,1,3080,3,44741),(1008011463,1,4400,3,44741),(1008011500,1,19,3,53486),(1008011510,1,48,3,53486),(1008011520,1,96,3,53486),(1008011531,1,192,3,53486),(1008011532,1,288,3,53486),(1008011541,1,672,3,53486),(1008011542,1,960,3,53486),(1008011543,1,1920,3,53486),(1008011553,1,3360,3,53486),(1008011563,1,4800,3,53486),(1008020100,1,1,3,210),(1008020110,1,3,3,210),(1008020120,1,6,3,210),(1008020131,1,12,3,210),(1008020132,1,18,3,210),(1008020141,1,42,3,210),(1008020142,1,60,3,210),(1008020143,1,110,3,210),(1008020153,1,210,3,210),(1008020163,1,300,3,210),(1008020200,1,2,3,549),(1008020210,1,4,3,549),(1008020220,1,8,3,549),(1008020231,1,16,3,549),(1008020232,1,24,3,549),(1008020241,1,56,3,549),(1008020242,1,80,3,549),(1008020243,1,160,3,549),(1008020253,1,280,3,549),(1008020263,1,400,3,549),(1008020300,1,2,3,1447),(1008020310,1,6,3,1447),(1008020320,1,12,3,1447),(1008020331,1,24,3,1447),(1008020332,1,36,3,1447),(1008020341,1,84,3,1447),(1008020342,1,120,3,1447),(1008020343,1,240,3,1447),(1008020353,1,420,3,1447),(1008020363,1,600,3,1447),(1008020400,1,3,3,2774),(1008020410,1,8,3,2774),(1008020420,1,16,3,2774),(1008020431,1,32,3,2774),(1008020432,1,48,3,2774),(1008020441,1,112,3,2774),(1008020442,1,160,3,2774),(1008020443,1,320,3,2774),(1008020453,1,560,3,2774),(1008020463,1,800,3,2774),(1008020500,1,4,3,4393),(1008020510,1,10,3,4393),(1008020520,1,20,3,4393),(1008020531,1,40,3,4393),(1008020532,1,60,3,4393),(1008020541,1,140,3,4393),(1008020542,1,200,3,4393),(1008020543,1,400,3,4393),(1008020553,1,700,3,4393),(1008020563,1,1000,3,4393),(1008020600,1,5,3,5462),(1008020610,1,12,3,5462),(1008020620,1,24,3,5462),(1008020631,1,48,3,5462),(1008020632,1,72,3,5462),(1008020641,1,168,3,5462),(1008020642,1,240,3,5462),(1008020643,1,480,3,5462),(1008020653,1,840,3,5462),(1008020663,1,1200,3,5462),(1008020700,1,6,3,5803),(1008020710,1,16,3,5803),(1008020720,1,32,3,5803),(1008020731,1,64,3,5803),(1008020732,1,96,3,5803),(1008020741,1,224,3,5803),(1008020742,1,320,3,5803),(1008020743,1,640,3,5803),(1008020753,1,1120,3,5803),(1008020763,1,1600,3,5803),(1008020800,1,8,3,6406),(1008020810,1,20,3,6406),(1008020820,1,40,3,6406),(1008020831,1,80,3,6406),(1008020832,1,120,3,6406),(1008020841,1,280,3,6406),(1008020842,1,400,3,6406),(1008020843,1,800,3,6406),(1008020853,1,1400,3,6406),(1008020863,1,2000,3,6406),(1008020900,1,10,3,7662),(1008020910,1,24,3,7662),(1008020920,1,48,3,7662),(1008020931,1,96,3,7662),(1008020932,1,144,3,7662),(1008020941,1,336,3,7662),(1008020942,1,480,3,7662),(1008020943,1,960,3,7662),(1008020953,1,1680,3,7662),(1008020963,1,2400,3,7662),(1008021000,1,11,3,10963),(1008021010,1,28,3,10963),(1008021020,1,56,3,10963),(1008021031,1,112,3,10963),(1008021032,1,168,3,10963),(1008021041,1,392,3,10963),(1008021042,1,560,3,10963),(1008021043,1,1120,3,10963),(1008021053,1,1960,3,10963),(1008021063,1,2800,3,10963),(1008021100,1,13,3,15691),(1008021110,1,32,3,15691),(1008021120,1,64,3,15691),(1008021131,1,128,3,15691),(1008021132,1,192,3,15691),(1008021141,1,448,3,15691),(1008021142,1,640,3,15691),(1008021143,1,1280,3,15691),(1008021153,1,2240,3,15691),(1008021163,1,3200,3,15691),(1008021200,1,14,3,21452),(1008021210,1,36,3,21452),(1008021220,1,72,3,21452),(1008021231,1,144,3,21452),(1008021232,1,216,3,21452),(1008021241,1,504,3,21452),(1008021242,1,720,3,21452),(1008021243,1,1440,3,21452),(1008021253,1,2520,3,21452),(1008021263,1,3600,3,21452),(1008021300,1,16,3,30327),(1008021310,1,40,3,30327),(1008021320,1,80,3,30327),(1008021331,1,160,3,30327),(1008021332,1,240,3,30327),(1008021341,1,560,3,30327),(1008021342,1,800,3,30327),(1008021343,1,1600,3,30327),(1008021353,1,2800,3,30327),(1008021363,1,4000,3,30327),(1008021400,1,18,3,44741),(1008021410,1,44,3,44741),(1008021420,1,88,3,44741),(1008021431,1,176,3,44741),(1008021432,1,264,3,44741),(1008021441,1,616,3,44741),(1008021442,1,880,3,44741),(1008021443,1,1760,3,44741),(1008021453,1,3080,3,44741),(1008021463,1,4400,3,44741),(1008021500,1,19,3,53486),(1008021510,1,48,3,53486),(1008021520,1,96,3,53486),(1008021531,1,192,3,53486),(1008021532,1,288,3,53486),(1008021541,1,672,3,53486),(1008021542,1,960,3,53486),(1008021543,1,1920,3,53486),(1008021553,1,3360,3,53486),(1008021563,1,4800,3,53486),(1008030100,1,1,3,210),(1008030110,1,3,3,210),(1008030120,1,6,3,210),(1008030131,1,12,3,210),(1008030132,1,18,3,210),(1008030141,1,42,3,210),(1008030142,1,60,3,210),(1008030143,1,110,3,210),(1008030153,1,210,3,210),(1008030163,1,300,3,210),(1008030200,1,2,3,549),(1008030210,1,4,3,549),(1008030220,1,8,3,549),(1008030231,1,16,3,549),(1008030232,1,24,3,549),(1008030241,1,56,3,549),(1008030242,1,80,3,549),(1008030243,1,160,3,549),(1008030253,1,280,3,549),(1008030263,1,400,3,549),(1008030300,1,2,3,1447),(1008030310,1,6,3,1447),(1008030320,1,12,3,1447),(1008030331,1,24,3,1447),(1008030332,1,36,3,1447),(1008030341,1,84,3,1447),(1008030342,1,120,3,1447),(1008030343,1,240,3,1447),(1008030353,1,420,3,1447),(1008030363,1,600,3,1447),(1008030400,1,3,3,2774),(1008030410,1,8,3,2774),(1008030420,1,16,3,2774),(1008030431,1,32,3,2774),(1008030432,1,48,3,2774),(1008030441,1,112,3,2774),(1008030442,1,160,3,2774),(1008030443,1,320,3,2774),(1008030453,1,560,3,2774),(1008030463,1,800,3,2774),(1008030500,1,4,3,4393),(1008030510,1,10,3,4393),(1008030520,1,20,3,4393),(1008030531,1,40,3,4393),(1008030532,1,60,3,4393),(1008030541,1,140,3,4393),(1008030542,1,200,3,4393),(1008030543,1,400,3,4393),(1008030553,1,700,3,4393),(1008030563,1,1000,3,4393),(1008030600,1,5,3,5462),(1008030610,1,12,3,5462),(1008030620,1,24,3,5462),(1008030631,1,48,3,5462),(1008030632,1,72,3,5462),(1008030641,1,168,3,5462),(1008030642,1,240,3,5462),(1008030643,1,480,3,5462),(1008030653,1,840,3,5462),(1008030663,1,1200,3,5462),(1008030700,1,6,3,5803),(1008030710,1,16,3,5803),(1008030720,1,32,3,5803),(1008030731,1,64,3,5803),(1008030732,1,96,3,5803),(1008030741,1,224,3,5803),(1008030742,1,320,3,5803),(1008030743,1,640,3,5803),(1008030753,1,1120,3,5803),(1008030763,1,1600,3,5803),(1008030800,1,8,3,6406),(1008030810,1,20,3,6406),(1008030820,1,40,3,6406),(1008030831,1,80,3,6406),(1008030832,1,120,3,6406),(1008030841,1,280,3,6406),(1008030842,1,400,3,6406),(1008030843,1,800,3,6406),(1008030853,1,1400,3,6406),(1008030863,1,2000,3,6406),(1008030900,1,10,3,7662),(1008030910,1,24,3,7662),(1008030920,1,48,3,7662),(1008030931,1,96,3,7662),(1008030932,1,144,3,7662),(1008030941,1,336,3,7662),(1008030942,1,480,3,7662),(1008030943,1,960,3,7662),(1008030953,1,1680,3,7662),(1008030963,1,2400,3,7662),(1008031000,1,11,3,10963),(1008031010,1,28,3,10963),(1008031020,1,56,3,10963),(1008031031,1,112,3,10963),(1008031032,1,168,3,10963),(1008031041,1,392,3,10963),(1008031042,1,560,3,10963),(1008031043,1,1120,3,10963),(1008031053,1,1960,3,10963),(1008031063,1,2800,3,10963),(1008031100,1,13,3,15691),(1008031110,1,32,3,15691),(1008031120,1,64,3,15691),(1008031131,1,128,3,15691),(1008031132,1,192,3,15691),(1008031141,1,448,3,15691),(1008031142,1,640,3,15691),(1008031143,1,1280,3,15691),(1008031153,1,2240,3,15691),(1008031163,1,3200,3,15691),(1008031200,1,14,3,21452),(1008031210,1,36,3,21452),(1008031220,1,72,3,21452),(1008031231,1,144,3,21452),(1008031232,1,216,3,21452),(1008031241,1,504,3,21452),(1008031242,1,720,3,21452),(1008031243,1,1440,3,21452),(1008031253,1,2520,3,21452),(1008031263,1,3600,3,21452),(1008031300,1,16,3,30327),(1008031310,1,40,3,30327),(1008031320,1,80,3,30327),(1008031331,1,160,3,30327),(1008031332,1,240,3,30327),(1008031341,1,560,3,30327),(1008031342,1,800,3,30327),(1008031343,1,1600,3,30327),(1008031353,1,2800,3,30327),(1008031363,1,4000,3,30327),(1008031400,1,18,3,44741),(1008031410,1,44,3,44741),(1008031420,1,88,3,44741),(1008031431,1,176,3,44741),(1008031432,1,264,3,44741),(1008031441,1,616,3,44741),(1008031442,1,880,3,44741),(1008031443,1,1760,3,44741),(1008031453,1,3080,3,44741),(1008031463,1,4400,3,44741),(1008031500,1,19,3,53486),(1008031510,1,48,3,53486),(1008031520,1,96,3,53486),(1008031531,1,192,3,53486),(1008031532,1,288,3,53486),(1008031541,1,672,3,53486),(1008031542,1,960,3,53486),(1008031543,1,1920,3,53486),(1008031553,1,3360,3,53486),(1008031563,1,4800,3,53486),(1008040100,1,1,3,210),(1008040110,1,3,3,210),(1008040120,1,6,3,210),(1008040131,1,12,3,210),(1008040132,1,18,3,210),(1008040141,1,42,3,210),(1008040142,1,60,3,210),(1008040143,1,110,3,210),(1008040153,1,210,3,210),(1008040163,1,300,3,210),(1008040200,1,2,3,549),(1008040210,1,4,3,549),(1008040220,1,8,3,549),(1008040231,1,16,3,549),(1008040232,1,24,3,549),(1008040241,1,56,3,549),(1008040242,1,80,3,549),(1008040243,1,160,3,549),(1008040253,1,280,3,549),(1008040263,1,400,3,549),(1008040300,1,2,3,1447),(1008040310,1,6,3,1447),(1008040320,1,12,3,1447),(1008040331,1,24,3,1447),(1008040332,1,36,3,1447),(1008040341,1,84,3,1447),(1008040342,1,120,3,1447),(1008040343,1,240,3,1447),(1008040353,1,420,3,1447),(1008040363,1,600,3,1447),(1008040400,1,3,3,2774),(1008040410,1,8,3,2774),(1008040420,1,16,3,2774),(1008040431,1,32,3,2774),(1008040432,1,48,3,2774),(1008040441,1,112,3,2774),(1008040442,1,160,3,2774),(1008040443,1,320,3,2774),(1008040453,1,560,3,2774),(1008040463,1,800,3,2774),(1008040500,1,4,3,4393),(1008040510,1,10,3,4393),(1008040520,1,20,3,4393),(1008040531,1,40,3,4393),(1008040532,1,60,3,4393),(1008040541,1,140,3,4393),(1008040542,1,200,3,4393),(1008040543,1,400,3,4393),(1008040553,1,700,3,4393),(1008040563,1,1000,3,4393),(1008040600,1,5,3,5462),(1008040610,1,12,3,5462),(1008040620,1,24,3,5462),(1008040631,1,48,3,5462),(1008040632,1,72,3,5462),(1008040641,1,168,3,5462),(1008040642,1,240,3,5462),(1008040643,1,480,3,5462),(1008040653,1,840,3,5462),(1008040663,1,1200,3,5462),(1008040700,1,6,3,5803),(1008040710,1,16,3,5803),(1008040720,1,32,3,5803),(1008040731,1,64,3,5803),(1008040732,1,96,3,5803),(1008040741,1,224,3,5803),(1008040742,1,320,3,5803),(1008040743,1,640,3,5803),(1008040753,1,1120,3,5803),(1008040763,1,1600,3,5803),(1008040800,1,8,3,6406),(1008040810,1,20,3,6406),(1008040820,1,40,3,6406),(1008040831,1,80,3,6406),(1008040832,1,120,3,6406),(1008040841,1,280,3,6406),(1008040842,1,400,3,6406),(1008040843,1,800,3,6406),(1008040853,1,1400,3,6406),(1008040863,1,2000,3,6406),(1008040900,1,10,3,7662),(1008040910,1,24,3,7662),(1008040920,1,48,3,7662),(1008040931,1,96,3,7662),(1008040932,1,144,3,7662),(1008040941,1,336,3,7662),(1008040942,1,480,3,7662),(1008040943,1,960,3,7662),(1008040953,1,1680,3,7662),(1008040963,1,2400,3,7662),(1008041000,1,11,3,10963),(1008041010,1,28,3,10963),(1008041020,1,56,3,10963),(1008041031,1,112,3,10963),(1008041032,1,168,3,10963),(1008041041,1,392,3,10963),(1008041042,1,560,3,10963),(1008041043,1,1120,3,10963),(1008041053,1,1960,3,10963),(1008041063,1,2800,3,10963),(1008041100,1,13,3,15691),(1008041110,1,32,3,15691),(1008041120,1,64,3,15691),(1008041131,1,128,3,15691),(1008041132,1,192,3,15691),(1008041141,1,448,3,15691),(1008041142,1,640,3,15691),(1008041143,1,1280,3,15691),(1008041153,1,2240,3,15691),(1008041163,1,3200,3,15691),(1008041200,1,14,3,21452),(1008041210,1,36,3,21452),(1008041220,1,72,3,21452),(1008041231,1,144,3,21452),(1008041232,1,216,3,21452),(1008041241,1,504,3,21452),(1008041242,1,720,3,21452),(1008041243,1,1440,3,21452),(1008041253,1,2520,3,21452),(1008041263,1,3600,3,21452),(1008041300,1,16,3,30327),(1008041310,1,40,3,30327),(1008041320,1,80,3,30327),(1008041331,1,160,3,30327),(1008041332,1,240,3,30327),(1008041341,1,560,3,30327),(1008041342,1,800,3,30327),(1008041343,1,1600,3,30327),(1008041353,1,2800,3,30327),(1008041363,1,4000,3,30327),(1008041400,1,18,3,44741),(1008041410,1,44,3,44741),(1008041420,1,88,3,44741),(1008041431,1,176,3,44741),(1008041432,1,264,3,44741),(1008041441,1,616,3,44741),(1008041442,1,880,3,44741),(1008041443,1,1760,3,44741),(1008041453,1,3080,3,44741),(1008041463,1,4400,3,44741),(1008041500,1,19,3,53486),(1008041510,1,48,3,53486),(1008041520,1,96,3,53486),(1008041531,1,192,3,53486),(1008041532,1,288,3,53486),(1008041541,1,672,3,53486),(1008041542,1,960,3,53486),(1008041543,1,1920,3,53486),(1008041553,1,3360,3,53486),(1008041563,1,4800,3,53486),(1009000100,1,2,3,210),(1009000110,1,6,3,210),(1009000120,1,11,3,210),(1009000131,1,22,3,210),(1009000132,1,33,3,210),(1009000141,1,77,3,210),(1009000142,1,110,3,210),(1009000143,1,210,3,210),(1009000153,1,385,3,210),(1009000163,1,550,3,210),(1009000200,1,3,3,549),(1009000210,1,8,3,549),(1009000220,1,15,3,549),(1009000231,1,30,3,549),(1009000232,1,45,3,549),(1009000241,1,105,3,549),(1009000242,1,150,3,549),(1009000243,1,300,3,549),(1009000253,1,525,3,549),(1009000263,1,750,3,549),(1009000300,1,4,3,1447),(1009000310,1,11,3,1447),(1009000320,1,21,3,1447),(1009000331,1,42,3,1447),(1009000332,1,63,3,1447),(1009000341,1,147,3,1447),(1009000342,1,210,3,1447),(1009000343,1,420,3,1447),(1009000353,1,735,3,1447),(1009000363,1,1050,3,1447),(1009000400,1,6,3,2774),(1009000410,1,15,3,2774),(1009000420,1,30,3,2774),(1009000431,1,60,3,2774),(1009000432,1,90,3,2774),(1009000441,1,210,3,2774),(1009000442,1,300,3,2774),(1009000443,1,600,3,2774),(1009000453,1,1050,3,2774),(1009000463,1,1500,3,2774),(1009000500,1,7,3,4393),(1009000510,1,18,3,4393),(1009000520,1,36,3,4393),(1009000531,1,72,3,4393),(1009000532,1,108,3,4393),(1009000541,1,252,3,4393),(1009000542,1,360,3,4393),(1009000543,1,720,3,4393),(1009000553,1,1260,3,4393),(1009000563,1,1800,3,4393),(1009000600,1,9,3,5462),(1009000610,1,23,3,5462),(1009000620,1,45,3,5462),(1009000631,1,90,3,5462),(1009000632,1,135,3,5462),(1009000641,1,315,3,5462),(1009000642,1,450,3,5462),(1009000643,1,900,3,5462),(1009000653,1,1575,3,5462),(1009000663,1,2250,3,5462),(1009000700,1,12,3,5803),(1009000710,1,30,3,5803),(1009000720,1,60,3,5803),(1009000731,1,120,3,5803),(1009000732,1,180,3,5803),(1009000741,1,420,3,5803),(1009000742,1,600,3,5803),(1009000743,1,1200,3,5803),(1009000753,1,2100,3,5803),(1009000763,1,3000,3,5803),(1009000800,1,15,3,6406),(1009000810,1,38,3,6406),(1009000820,1,75,3,6406),(1009000831,1,150,3,6406),(1009000832,1,225,3,6406),(1009000841,1,525,3,6406),(1009000842,1,750,3,6406),(1009000843,1,1500,3,6406),(1009000853,1,2625,3,6406),(1009000863,1,3750,3,6406),(1009000900,1,18,3,7662),(1009000910,1,45,3,7662),(1009000920,1,90,3,7662),(1009000931,1,180,3,7662),(1009000932,1,270,3,7662),(1009000941,1,630,3,7662),(1009000942,1,900,3,7662),(1009000943,1,1800,3,7662),(1009000953,1,3150,3,7662),(1009000963,1,4500,3,7662),(1009001000,1,21,3,10963),(1009001010,1,53,3,10963),(1009001020,1,105,3,10963),(1009001031,1,210,3,10963),(1009001032,1,315,3,10963),(1009001041,1,735,3,10963),(1009001042,1,1050,3,10963),(1009001043,1,2100,3,10963),(1009001053,1,3675,3,10963),(1009001063,1,5250,3,10963),(1009001100,1,24,3,15691),(1009001110,1,60,3,15691),(1009001120,1,120,3,15691),(1009001131,1,240,3,15691),(1009001132,1,360,3,15691),(1009001141,1,840,3,15691),(1009001142,1,1200,3,15691),(1009001143,1,2400,3,15691),(1009001153,1,4200,3,15691),(1009001163,1,6000,3,15691),(1009001200,1,27,3,21452),(1009001210,1,68,3,21452),(1009001220,1,135,3,21452),(1009001231,1,270,3,21452),(1009001232,1,405,3,21452),(1009001241,1,945,3,21452),(1009001242,1,1350,3,21452),(1009001243,1,2700,3,21452),(1009001253,1,4725,3,21452),(1009001263,1,6750,3,21452),(1009001300,1,30,3,30327),(1009001310,1,75,3,30327),(1009001320,1,150,3,30327),(1009001331,1,300,3,30327),(1009001332,1,450,3,30327),(1009001341,1,1050,3,30327),(1009001342,1,1500,3,30327),(1009001343,1,3000,3,30327),(1009001353,1,5250,3,30327),(1009001363,1,7500,3,30327),(1009001400,1,33,3,44741),(1009001410,1,83,3,44741),(1009001420,1,165,3,44741),(1009001431,1,330,3,44741),(1009001432,1,495,3,44741),(1009001441,1,1155,3,44741),(1009001442,1,1650,3,44741),(1009001443,1,3300,3,44741),(1009001453,1,5775,3,44741),(1009001463,1,8250,3,44741),(1009001500,1,36,3,53486),(1009001510,1,90,3,53486),(1009001520,1,180,3,53486),(1009001531,1,360,3,53486),(1009001532,1,540,3,53486),(1009001541,1,1260,3,53486),(1009001542,1,1800,3,53486),(1009001543,1,3600,3,53486),(1009001553,1,6300,3,53486),(1009001563,1,9000,3,53486),(1010010100,1,1,3,210),(1010010110,1,3,3,210),(1010010120,1,6,3,210),(1010010131,1,12,3,210),(1010010132,1,18,3,210),(1010010141,1,42,3,210),(1010010142,1,60,3,210),(1010010143,1,110,3,210),(1010010153,1,210,3,210),(1010010163,1,300,3,210),(1010010200,1,2,3,549),(1010010210,1,4,3,549),(1010010220,1,8,3,549),(1010010231,1,16,3,549),(1010010232,1,24,3,549),(1010010241,1,56,3,549),(1010010242,1,80,3,549),(1010010243,1,160,3,549),(1010010253,1,280,3,549),(1010010263,1,400,3,549),(1010010300,1,2,3,1447),(1010010310,1,6,3,1447),(1010010320,1,12,3,1447),(1010010331,1,24,3,1447),(1010010332,1,36,3,1447),(1010010341,1,84,3,1447),(1010010342,1,120,3,1447),(1010010343,1,240,3,1447),(1010010353,1,420,3,1447),(1010010363,1,600,3,1447),(1010010400,1,3,3,2774),(1010010410,1,8,3,2774),(1010010420,1,16,3,2774),(1010010431,1,32,3,2774),(1010010432,1,48,3,2774),(1010010441,1,112,3,2774),(1010010442,1,160,3,2774),(1010010443,1,320,3,2774),(1010010453,1,560,3,2774),(1010010463,1,800,3,2774),(1010010500,1,4,3,4393),(1010010510,1,10,3,4393),(1010010520,1,20,3,4393),(1010010531,1,40,3,4393),(1010010532,1,60,3,4393),(1010010541,1,140,3,4393),(1010010542,1,200,3,4393),(1010010543,1,400,3,4393),(1010010553,1,700,3,4393),(1010010563,1,1000,3,4393),(1010010600,1,5,3,5462),(1010010610,1,12,3,5462),(1010010620,1,24,3,5462),(1010010631,1,48,3,5462),(1010010632,1,72,3,5462),(1010010641,1,168,3,5462),(1010010642,1,240,3,5462),(1010010643,1,480,3,5462),(1010010653,1,840,3,5462),(1010010663,1,1200,3,5462),(1010010700,1,6,3,5803),(1010010710,1,16,3,5803),(1010010720,1,32,3,5803),(1010010731,1,64,3,5803),(1010010732,1,96,3,5803),(1010010741,1,224,3,5803),(1010010742,1,320,3,5803),(1010010743,1,640,3,5803),(1010010753,1,1120,3,5803),(1010010763,1,1600,3,5803),(1010010800,1,8,3,6406),(1010010810,1,20,3,6406),(1010010820,1,40,3,6406),(1010010831,1,80,3,6406),(1010010832,1,120,3,6406),(1010010841,1,280,3,6406),(1010010842,1,400,3,6406),(1010010843,1,800,3,6406),(1010010853,1,1400,3,6406),(1010010863,1,2000,3,6406),(1010010900,1,10,3,7662),(1010010910,1,24,3,7662),(1010010920,1,48,3,7662),(1010010931,1,96,3,7662),(1010010932,1,144,3,7662),(1010010941,1,336,3,7662),(1010010942,1,480,3,7662),(1010010943,1,960,3,7662),(1010010953,1,1680,3,7662),(1010010963,1,2400,3,7662),(1010011000,1,11,3,10963),(1010011010,1,28,3,10963),(1010011020,1,56,3,10963),(1010011031,1,112,3,10963),(1010011032,1,168,3,10963),(1010011041,1,392,3,10963),(1010011042,1,560,3,10963),(1010011043,1,1120,3,10963),(1010011053,1,1960,3,10963),(1010011063,1,2800,3,10963),(1010011100,1,13,3,15691),(1010011110,1,32,3,15691),(1010011120,1,64,3,15691),(1010011131,1,128,3,15691),(1010011132,1,192,3,15691),(1010011141,1,448,3,15691),(1010011142,1,640,3,15691),(1010011143,1,1280,3,15691),(1010011153,1,2240,3,15691),(1010011163,1,3200,3,15691),(1010011200,1,14,3,21452),(1010011210,1,36,3,21452),(1010011220,1,72,3,21452),(1010011231,1,144,3,21452),(1010011232,1,216,3,21452),(1010011241,1,504,3,21452),(1010011242,1,720,3,21452),(1010011243,1,1440,3,21452),(1010011253,1,2520,3,21452),(1010011263,1,3600,3,21452),(1010011300,1,16,3,30327),(1010011310,1,40,3,30327),(1010011320,1,80,3,30327),(1010011331,1,160,3,30327),(1010011332,1,240,3,30327),(1010011341,1,560,3,30327),(1010011342,1,800,3,30327),(1010011343,1,1600,3,30327),(1010011353,1,2800,3,30327),(1010011363,1,4000,3,30327),(1010011400,1,18,3,44741),(1010011410,1,44,3,44741),(1010011420,1,88,3,44741),(1010011431,1,176,3,44741),(1010011432,1,264,3,44741),(1010011441,1,616,3,44741),(1010011442,1,880,3,44741),(1010011443,1,1760,3,44741),(1010011453,1,3080,3,44741),(1010011463,1,4400,3,44741),(1010011500,1,19,3,53486),(1010011510,1,48,3,53486),(1010011520,1,96,3,53486),(1010011531,1,192,3,53486),(1010011532,1,288,3,53486),(1010011541,1,672,3,53486),(1010011542,1,960,3,53486),(1010011543,1,1920,3,53486),(1010011553,1,3360,3,53486),(1010011563,1,4800,3,53486),(1010020100,1,1,3,210),(1010020110,1,3,3,210),(1010020120,1,6,3,210),(1010020131,1,12,3,210),(1010020132,1,18,3,210),(1010020141,1,42,3,210),(1010020142,1,60,3,210),(1010020143,1,110,3,210),(1010020153,1,210,3,210),(1010020163,1,300,3,210),(1010020200,1,2,3,549),(1010020210,1,4,3,549),(1010020220,1,8,3,549),(1010020231,1,16,3,549),(1010020232,1,24,3,549),(1010020241,1,56,3,549),(1010020242,1,80,3,549),(1010020243,1,160,3,549),(1010020253,1,280,3,549),(1010020263,1,400,3,549),(1010020300,1,2,3,1447),(1010020310,1,6,3,1447),(1010020320,1,12,3,1447),(1010020331,1,24,3,1447),(1010020332,1,36,3,1447),(1010020341,1,84,3,1447),(1010020342,1,120,3,1447),(1010020343,1,240,3,1447),(1010020353,1,420,3,1447),(1010020363,1,600,3,1447),(1010020400,1,3,3,2774),(1010020410,1,8,3,2774),(1010020420,1,16,3,2774),(1010020431,1,32,3,2774),(1010020432,1,48,3,2774),(1010020441,1,112,3,2774),(1010020442,1,160,3,2774),(1010020443,1,320,3,2774),(1010020453,1,560,3,2774),(1010020463,1,800,3,2774),(1010020500,1,4,3,4393),(1010020510,1,10,3,4393),(1010020520,1,20,3,4393),(1010020531,1,40,3,4393),(1010020532,1,60,3,4393),(1010020541,1,140,3,4393),(1010020542,1,200,3,4393),(1010020543,1,400,3,4393),(1010020553,1,700,3,4393),(1010020563,1,1000,3,4393),(1010020600,1,5,3,5462),(1010020610,1,12,3,5462),(1010020620,1,24,3,5462),(1010020631,1,48,3,5462),(1010020632,1,72,3,5462),(1010020641,1,168,3,5462),(1010020642,1,240,3,5462),(1010020643,1,480,3,5462),(1010020653,1,840,3,5462),(1010020663,1,1200,3,5462),(1010020700,1,6,3,5803),(1010020710,1,16,3,5803),(1010020720,1,32,3,5803),(1010020731,1,64,3,5803),(1010020732,1,96,3,5803),(1010020741,1,224,3,5803),(1010020742,1,320,3,5803),(1010020743,1,640,3,5803),(1010020753,1,1120,3,5803),(1010020763,1,1600,3,5803),(1010020800,1,8,3,6406),(1010020810,1,20,3,6406),(1010020820,1,40,3,6406),(1010020831,1,80,3,6406),(1010020832,1,120,3,6406),(1010020841,1,280,3,6406),(1010020842,1,400,3,6406),(1010020843,1,800,3,6406),(1010020853,1,1400,3,6406),(1010020863,1,2000,3,6406),(1010020900,1,10,3,7662),(1010020910,1,24,3,7662),(1010020920,1,48,3,7662),(1010020931,1,96,3,7662),(1010020932,1,144,3,7662),(1010020941,1,336,3,7662),(1010020942,1,480,3,7662),(1010020943,1,960,3,7662),(1010020953,1,1680,3,7662),(1010020963,1,2400,3,7662),(1010021000,1,11,3,10963),(1010021010,1,28,3,10963),(1010021020,1,56,3,10963),(1010021031,1,112,3,10963),(1010021032,1,168,3,10963),(1010021041,1,392,3,10963),(1010021042,1,560,3,10963),(1010021043,1,1120,3,10963),(1010021053,1,1960,3,10963),(1010021063,1,2800,3,10963),(1010021100,1,13,3,15691),(1010021110,1,32,3,15691),(1010021120,1,64,3,15691),(1010021131,1,128,3,15691),(1010021132,1,192,3,15691),(1010021141,1,448,3,15691),(1010021142,1,640,3,15691),(1010021143,1,1280,3,15691),(1010021153,1,2240,3,15691),(1010021163,1,3200,3,15691),(1010021200,1,14,3,21452),(1010021210,1,36,3,21452),(1010021220,1,72,3,21452),(1010021231,1,144,3,21452),(1010021232,1,216,3,21452),(1010021241,1,504,3,21452),(1010021242,1,720,3,21452),(1010021243,1,1440,3,21452),(1010021253,1,2520,3,21452),(1010021263,1,3600,3,21452),(1010021300,1,16,3,30327),(1010021310,1,40,3,30327),(1010021320,1,80,3,30327),(1010021331,1,160,3,30327),(1010021332,1,240,3,30327),(1010021341,1,560,3,30327),(1010021342,1,800,3,30327),(1010021343,1,1600,3,30327),(1010021353,1,2800,3,30327),(1010021363,1,4000,3,30327),(1010021400,1,18,3,44741),(1010021410,1,44,3,44741),(1010021420,1,88,3,44741),(1010021431,1,176,3,44741),(1010021432,1,264,3,44741),(1010021441,1,616,3,44741),(1010021442,1,880,3,44741),(1010021443,1,1760,3,44741),(1010021453,1,3080,3,44741),(1010021463,1,4400,3,44741),(1010021500,1,19,3,53486),(1010021510,1,48,3,53486),(1010021520,1,96,3,53486),(1010021531,1,192,3,53486),(1010021532,1,288,3,53486),(1010021541,1,672,3,53486),(1010021542,1,960,3,53486),(1010021543,1,1920,3,53486),(1010021553,1,3360,3,53486),(1010021563,1,4800,3,53486),(1010030100,1,1,3,210),(1010030110,1,3,3,210),(1010030120,1,6,3,210),(1010030131,1,12,3,210),(1010030132,1,18,3,210),(1010030141,1,42,3,210),(1010030142,1,60,3,210),(1010030143,1,110,3,210),(1010030153,1,210,3,210),(1010030163,1,300,3,210),(1010030200,1,2,3,549),(1010030210,1,4,3,549),(1010030220,1,8,3,549),(1010030231,1,16,3,549),(1010030232,1,24,3,549),(1010030241,1,56,3,549),(1010030242,1,80,3,549),(1010030243,1,160,3,549),(1010030253,1,280,3,549),(1010030263,1,400,3,549),(1010030300,1,2,3,1447),(1010030310,1,6,3,1447),(1010030320,1,12,3,1447),(1010030331,1,24,3,1447),(1010030332,1,36,3,1447),(1010030341,1,84,3,1447),(1010030342,1,120,3,1447),(1010030343,1,240,3,1447),(1010030353,1,420,3,1447),(1010030363,1,600,3,1447),(1010030400,1,3,3,2774),(1010030410,1,8,3,2774),(1010030420,1,16,3,2774),(1010030431,1,32,3,2774),(1010030432,1,48,3,2774),(1010030441,1,112,3,2774),(1010030442,1,160,3,2774),(1010030443,1,320,3,2774),(1010030453,1,560,3,2774),(1010030463,1,800,3,2774),(1010030500,1,4,3,4393),(1010030510,1,10,3,4393),(1010030520,1,20,3,4393),(1010030531,1,40,3,4393),(1010030532,1,60,3,4393),(1010030541,1,140,3,4393),(1010030542,1,200,3,4393),(1010030543,1,400,3,4393),(1010030553,1,700,3,4393),(1010030563,1,1000,3,4393),(1010030600,1,5,3,5462),(1010030610,1,12,3,5462),(1010030620,1,24,3,5462),(1010030631,1,48,3,5462),(1010030632,1,72,3,5462),(1010030641,1,168,3,5462),(1010030642,1,240,3,5462),(1010030643,1,480,3,5462),(1010030653,1,840,3,5462),(1010030663,1,1200,3,5462),(1010030700,1,6,3,5803),(1010030710,1,16,3,5803),(1010030720,1,32,3,5803),(1010030731,1,64,3,5803),(1010030732,1,96,3,5803),(1010030741,1,224,3,5803),(1010030742,1,320,3,5803),(1010030743,1,640,3,5803),(1010030753,1,1120,3,5803),(1010030763,1,1600,3,5803),(1010030800,1,8,3,6406),(1010030810,1,20,3,6406),(1010030820,1,40,3,6406),(1010030831,1,80,3,6406),(1010030832,1,120,3,6406),(1010030841,1,280,3,6406),(1010030842,1,400,3,6406),(1010030843,1,800,3,6406),(1010030853,1,1400,3,6406),(1010030863,1,2000,3,6406),(1010030900,1,10,3,7662),(1010030910,1,24,3,7662),(1010030920,1,48,3,7662),(1010030931,1,96,3,7662),(1010030932,1,144,3,7662),(1010030941,1,336,3,7662),(1010030942,1,480,3,7662),(1010030943,1,960,3,7662),(1010030953,1,1680,3,7662),(1010030963,1,2400,3,7662),(1010031000,1,11,3,10963),(1010031010,1,28,3,10963),(1010031020,1,56,3,10963),(1010031031,1,112,3,10963),(1010031032,1,168,3,10963),(1010031041,1,392,3,10963),(1010031042,1,560,3,10963),(1010031043,1,1120,3,10963),(1010031053,1,1960,3,10963),(1010031063,1,2800,3,10963),(1010031100,1,13,3,15691),(1010031110,1,32,3,15691),(1010031120,1,64,3,15691),(1010031131,1,128,3,15691),(1010031132,1,192,3,15691),(1010031141,1,448,3,15691),(1010031142,1,640,3,15691),(1010031143,1,1280,3,15691),(1010031153,1,2240,3,15691),(1010031163,1,3200,3,15691),(1010031200,1,14,3,21452),(1010031210,1,36,3,21452),(1010031220,1,72,3,21452),(1010031231,1,144,3,21452),(1010031232,1,216,3,21452),(1010031241,1,504,3,21452),(1010031242,1,720,3,21452),(1010031243,1,1440,3,21452),(1010031253,1,2520,3,21452),(1010031263,1,3600,3,21452),(1010031300,1,16,3,30327),(1010031310,1,40,3,30327),(1010031320,1,80,3,30327),(1010031331,1,160,3,30327),(1010031332,1,240,3,30327),(1010031341,1,560,3,30327),(1010031342,1,800,3,30327),(1010031343,1,1600,3,30327),(1010031353,1,2800,3,30327),(1010031363,1,4000,3,30327),(1010031400,1,18,3,44741),(1010031410,1,44,3,44741),(1010031420,1,88,3,44741),(1010031431,1,176,3,44741),(1010031432,1,264,3,44741),(1010031441,1,616,3,44741),(1010031442,1,880,3,44741),(1010031443,1,1760,3,44741),(1010031453,1,3080,3,44741),(1010031463,1,4400,3,44741),(1010031500,1,19,3,53486),(1010031510,1,48,3,53486),(1010031520,1,96,3,53486),(1010031531,1,192,3,53486),(1010031532,1,288,3,53486),(1010031541,1,672,3,53486),(1010031542,1,960,3,53486),(1010031543,1,1920,3,53486),(1010031553,1,3360,3,53486),(1010031563,1,4800,3,53486),(1010040100,1,1,3,210),(1010040110,1,3,3,210),(1010040120,1,6,3,210),(1010040131,1,12,3,210),(1010040132,1,18,3,210),(1010040141,1,42,3,210),(1010040142,1,60,3,210),(1010040143,1,110,3,210),(1010040153,1,210,3,210),(1010040163,1,300,3,210),(1010040200,1,2,3,549),(1010040210,1,4,3,549),(1010040220,1,8,3,549),(1010040231,1,16,3,549),(1010040232,1,24,3,549),(1010040241,1,56,3,549),(1010040242,1,80,3,549),(1010040243,1,160,3,549),(1010040253,1,280,3,549),(1010040263,1,400,3,549),(1010040300,1,2,3,1447),(1010040310,1,6,3,1447),(1010040320,1,12,3,1447),(1010040331,1,24,3,1447),(1010040332,1,36,3,1447),(1010040341,1,84,3,1447),(1010040342,1,120,3,1447),(1010040343,1,240,3,1447),(1010040353,1,420,3,1447),(1010040363,1,600,3,1447),(1010040400,1,3,3,2774),(1010040410,1,8,3,2774),(1010040420,1,16,3,2774),(1010040431,1,32,3,2774),(1010040432,1,48,3,2774),(1010040441,1,112,3,2774),(1010040442,1,160,3,2774),(1010040443,1,320,3,2774),(1010040453,1,560,3,2774),(1010040463,1,800,3,2774),(1010040500,1,4,3,4393),(1010040510,1,10,3,4393),(1010040520,1,20,3,4393),(1010040531,1,40,3,4393),(1010040532,1,60,3,4393),(1010040541,1,140,3,4393),(1010040542,1,200,3,4393),(1010040543,1,400,3,4393),(1010040553,1,700,3,4393),(1010040563,1,1000,3,4393),(1010040600,1,5,3,5462),(1010040610,1,12,3,5462),(1010040620,1,24,3,5462),(1010040631,1,48,3,5462),(1010040632,1,72,3,5462),(1010040641,1,168,3,5462),(1010040642,1,240,3,5462),(1010040643,1,480,3,5462),(1010040653,1,840,3,5462),(1010040663,1,1200,3,5462),(1010040700,1,6,3,5803),(1010040710,1,16,3,5803),(1010040720,1,32,3,5803),(1010040731,1,64,3,5803),(1010040732,1,96,3,5803),(1010040741,1,224,3,5803),(1010040742,1,320,3,5803),(1010040743,1,640,3,5803),(1010040753,1,1120,3,5803),(1010040763,1,1600,3,5803),(1010040800,1,8,3,6406),(1010040810,1,20,3,6406),(1010040820,1,40,3,6406),(1010040831,1,80,3,6406),(1010040832,1,120,3,6406),(1010040841,1,280,3,6406),(1010040842,1,400,3,6406),(1010040843,1,800,3,6406),(1010040853,1,1400,3,6406),(1010040863,1,2000,3,6406),(1010040900,1,10,3,7662),(1010040910,1,24,3,7662),(1010040920,1,48,3,7662),(1010040931,1,96,3,7662),(1010040932,1,144,3,7662),(1010040941,1,336,3,7662),(1010040942,1,480,3,7662),(1010040943,1,960,3,7662),(1010040953,1,1680,3,7662),(1010040963,1,2400,3,7662),(1010041000,1,11,3,10963),(1010041010,1,28,3,10963),(1010041020,1,56,3,10963),(1010041031,1,112,3,10963),(1010041032,1,168,3,10963),(1010041041,1,392,3,10963),(1010041042,1,560,3,10963),(1010041043,1,1120,3,10963),(1010041053,1,1960,3,10963),(1010041063,1,2800,3,10963),(1010041100,1,13,3,15691),(1010041110,1,32,3,15691),(1010041120,1,64,3,15691),(1010041131,1,128,3,15691),(1010041132,1,192,3,15691),(1010041141,1,448,3,15691),(1010041142,1,640,3,15691),(1010041143,1,1280,3,15691),(1010041153,1,2240,3,15691),(1010041163,1,3200,3,15691),(1010041200,1,14,3,21452),(1010041210,1,36,3,21452),(1010041220,1,72,3,21452),(1010041231,1,144,3,21452),(1010041232,1,216,3,21452),(1010041241,1,504,3,21452),(1010041242,1,720,3,21452),(1010041243,1,1440,3,21452),(1010041253,1,2520,3,21452),(1010041263,1,3600,3,21452),(1010041300,1,16,3,30327),(1010041310,1,40,3,30327),(1010041320,1,80,3,30327),(1010041331,1,160,3,30327),(1010041332,1,240,3,30327),(1010041341,1,560,3,30327),(1010041342,1,800,3,30327),(1010041343,1,1600,3,30327),(1010041353,1,2800,3,30327),(1010041363,1,4000,3,30327),(1010041400,1,18,3,44741),(1010041410,1,44,3,44741),(1010041420,1,88,3,44741),(1010041431,1,176,3,44741),(1010041432,1,264,3,44741),(1010041441,1,616,3,44741),(1010041442,1,880,3,44741),(1010041443,1,1760,3,44741),(1010041453,1,3080,3,44741),(1010041463,1,4400,3,44741),(1010041500,1,19,3,53486),(1010041510,1,48,3,53486),(1010041520,1,96,3,53486),(1010041531,1,192,3,53486),(1010041532,1,288,3,53486),(1010041541,1,672,3,53486),(1010041542,1,960,3,53486),(1010041543,1,1920,3,53486),(1010041553,1,3360,3,53486),(1010041563,1,4800,3,53486),(1011000001,1,288,3,2880),(1011000002,1,388,3,3880),(1011000003,1,488,3,4880),(1011000004,1,688,3,6880),(1011000005,1,99999,3,1);
/*!40000 ALTER TABLE `base_goods_price` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_goods_produce_type`
--

DROP TABLE IF EXISTS `base_goods_produce_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_goods_produce_type` (
  `type` varchar(255) NOT NULL COMMENT '类型',
  `id` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `about` varchar(255) NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品产出类型配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_goods_produce_type`
--

LOCK TABLES `base_goods_produce_type` WRITE;
/*!40000 ALTER TABLE `base_goods_produce_type` DISABLE KEYS */;
INSERT INTO `base_goods_produce_type` VALUES ('mon_drop',1,'怪物掉落'),('mail_attachment',2,'邮件附件'),('shop_sale',3,'商城出售'),('recruit_partner',4,'招募伙伴'),('wash_replace',5,'洗髓替换'),('partner_disband',6,'伙伴遣散'),('achievement',7,'达成成就'),('gm',8,'秘籍获取'),('pay_sell',9,'购买交易商品'),('sell_down',10,'下架交易商品'),('task',11,'任务奖励'),('activity_live_reward',12,'活动活跃度奖励'),('vip_present',13,'vip礼包'),('share_fruit',14,'果实分享'),('share_fruit_return',15,'果实回礼'),('eat_fruit',16,'咬果实'),('jjc_reward',17,'竞技场奖励'),('walfare_reward',18,'福利卡奖励'),('mon_check_in',19,'月签到'),('seven_login',20,'7天登陆'),('recharge_gift_award',21,'首充奖励');
/*!40000 ALTER TABLE `base_goods_produce_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_goods_renew`
--

DROP TABLE IF EXISTS `base_goods_renew`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_goods_renew` (
  `goods_id` int(11) unsigned NOT NULL COMMENT '物品id',
  `price_type` tinyint(3) unsigned NOT NULL COMMENT '价格类型',
  `price` int(11) unsigned NOT NULL COMMENT '价格',
  `renew_time` int(11) unsigned NOT NULL COMMENT '续费时长',
  PRIMARY KEY (`goods_id`,`price_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品续费配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_goods_renew`
--

LOCK TABLES `base_goods_renew` WRITE;
/*!40000 ALTER TABLE `base_goods_renew` DISABLE KEYS */;
INSERT INTO `base_goods_renew` VALUES (38300002,1,188,2592000),(38300002,2,328,2592000),(38300003,1,288,2592000),(38300003,2,568,2592000),(38300004,1,128,2592000),(38300004,2,218,2592000),(1011000001,1,288,2592000),(1011000001,2,568,2592000),(1011000002,1,268,2592000),(1011000002,2,488,2592000),(1011000003,1,488,2592000),(1011000004,1,468,2592000),(1011000005,1,288,2592000),(1011000005,2,568,2592000);
/*!40000 ALTER TABLE `base_goods_renew` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_goods_sell`
--

DROP TABLE IF EXISTS `base_goods_sell`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_goods_sell` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `key` varchar(255) NOT NULL DEFAULT '' COMMENT 'key',
  `value` varchar(255) NOT NULL DEFAULT '0' COMMENT '值',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '描述',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='市场配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_goods_sell`
--

LOCK TABLES `base_goods_sell` WRITE;
/*!40000 ALTER TABLE `base_goods_sell` DISABLE KEYS */;
INSERT INTO `base_goods_sell` VALUES (1,'specify_sell_times_limit','15','单个玩家指定交易每日次数限制'),(2,'transaction_times_limit','30','玩家每天交易次数上限'),(3,'open_lv','90','交易开启等级'),(4,'market_max_sell_num','10','市场最大上架数量'),(5,'p2p_max_sell_num','3','指定交易最大上架数量'),(6,'sell_expired_time_p2p','86400','指定交易上架出售过期时间，单位：秒'),(7,'sell_expired_time_market','86400','市场上架出售过期时间，单位：秒'),(8,'sell_record_expired_time','604800','交易记录多久过期，单位：秒'),(9,'specify_sell_need_vip_lv','4','指定出售需要玩家Vip等级');
/*!40000 ALTER TABLE `base_goods_sell` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_goods_sell_subtype`
--

DROP TABLE IF EXISTS `base_goods_sell_subtype`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_goods_sell_subtype` (
  `type` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '类型ID',
  `subtype` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '子类型ID',
  `subtype_name` varchar(50) NOT NULL DEFAULT '' COMMENT '子类型名称@lang@',
  `icon` varchar(255) NOT NULL DEFAULT '' COMMENT '商品分类图标',
  PRIMARY KEY (`type`,`subtype`),
  UNIQUE KEY `type_id` (`type`,`subtype`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品出售子类型表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_goods_sell_subtype`
--

LOCK TABLES `base_goods_sell_subtype` WRITE;
/*!40000 ALTER TABLE `base_goods_sell_subtype` DISABLE KEYS */;
INSERT INTO `base_goods_sell_subtype` VALUES (1,0,'全部','1001010300'),(1,1,'武器','1001010300'),(1,2,'防具','1004021500'),(1,3,'首饰','1003001500'),(2,0,'全部','20010011'),(2,1,'翅膀','20010021'),(2,2,'羽毛','20040001'),(3,0,'全部','1007040200'),(3,1,'魔剑士套装石','38230101'),(3,2,'龙骑士套装石','38230201'),(3,3,'重炮手套装石','38230401'),(3,4,'首饰套装石','38230005'),(3,5,'完美套装石','38240001'),(3,6,'套装石碎片','38270011'),(4,0,'全部','38041000'),(4,1,'副本门票','38030001'),(4,2,'神格道具','17010001'),(4,3,'转职道具','38110001'),(4,4,'染色药剂','12120001'),(4,5,'宝具幻化','38041018'),(4,6,'杂物','38041000'),(4,7,'活动道具','38041000'),(5,0,'全部','20030001'),(5,1,'绿色图鉴','20030001'),(5,2,'蓝色图鉴','22030001'),(5,3,'紫色图鉴','24030001'),(5,4,'橙色图鉴','38030001'),(5,5,'红色图鉴','38040003');
/*!40000 ALTER TABLE `base_goods_sell_subtype` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_goods_sell_type`
--

DROP TABLE IF EXISTS `base_goods_sell_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_goods_sell_type` (
  `type` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '类型ID',
  `type_name` varchar(50) NOT NULL DEFAULT '' COMMENT '类型名称@lang@',
  PRIMARY KEY (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品出售类型表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_goods_sell_type`
--

LOCK TABLES `base_goods_sell_type` WRITE;
/*!40000 ALTER TABLE `base_goods_sell_type` DISABLE KEYS */;
INSERT INTO `base_goods_sell_type` VALUES (1,'装备'),(2,'翅膀'),(3,'材料'),(4,'其他'),(5,'图鉴');
/*!40000 ALTER TABLE `base_goods_sell_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_goods_subtype`
--

DROP TABLE IF EXISTS `base_goods_subtype`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_goods_subtype` (
  `type` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '类型ID',
  `subtype` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '子类型ID',
  `subtype_name` varchar(50) NOT NULL DEFAULT '' COMMENT '子类型名称@lang@',
  `keyword` varchar(255) NOT NULL DEFAULT '' COMMENT '关键字符串标识，例如礼包需要使用gift_grow表示成长礼包',
  `sublabel_id` int(11) NOT NULL COMMENT '标签ID',
  `bag_location` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '背包位置',
  UNIQUE KEY `type_id` (`type`,`subtype`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品子类型表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_goods_subtype`
--

LOCK TABLES `base_goods_subtype` WRITE;
/*!40000 ALTER TABLE `base_goods_subtype` DISABLE KEYS */;
INSERT INTO `base_goods_subtype` VALUES (10,1,'武器','',1,0),(10,2,'头盔','',1,0),(10,3,'项链','',1,0),(10,4,'衣服','',1,0),(10,5,'刻痕','',1,0),(10,6,'裤子','',1,0),(10,7,'副武器','',1,0),(10,8,'护腕','',1,0),(10,9,'戒指','',1,0),(10,10,'鞋子','',1,0),(10,11,'守护','',1,0),(11,1,'降神激活','',1,0),(11,2,'降神升阶','',1,0),(11,3,'神器激活','',1,0),(11,4,'神器升级','',1,0),(11,5,'降神碎片','',1,4),(11,6,'神器碎片','',1,0),(11,7,'符文材料','',1,4),(12,1,'衣服','',1,0),(12,2,'武器','',1,0),(12,3,'头饰','',1,0),(12,4,'足迹','',1,0),(12,5,'染色剂','',1,0),(12,6,'时装精华','',1,0),(12,7,'升星材料','',1,0),(13,1,'武器','',1,0),(13,2,'头部','',1,0),(13,3,'项链','',1,0),(13,4,'衣服','',1,0),(13,5,'护符','',1,0),(13,6,'裤子','',1,0),(13,7,'手镯','',1,0),(13,8,'护腕','',1,0),(13,9,'戒指','',1,0),(13,10,'鞋子','',1,0),(13,11,'本源','',1,0),(13,12,'分解专用','',1,0),(14,1,'攻击类','',1,0),(14,2,'生命类','',1,0),(14,3,'破甲类','',1,0),(14,4,'防御类','',1,0),(14,5,'命中类','',1,0),(14,6,'闪避类','',1,0),(14,7,'暴击类','',1,0),(14,8,'韧性类','',1,0),(14,9,'双属性攻击宝石','',1,4),(14,10,'双属性防御宝石','',1,4),(14,11,'双属性精粹','',1,4),(14,12,'宝石碎片','',1,4),(14,13,'VIP攻击类宝石','',1,4),(14,14,'VIP防御类宝石','',1,4),(14,99,'测试类','',1,0),(15,1,'激活道具','',1,0),(15,2,'升阶道具','',1,0),(16,1,'兽魂','',1,0),(16,2,'升星进阶','',1,0),(16,3,'幻形道具','',1,0),(16,4,'坐骑装备','',2,21),(16,5,'坐骑装备升级材料','',1,0),(16,6,'坐骑装备打造材料','',1,0),(16,7,'限时幻形道具','',1,4),(16,8,'祭品装备','',1,21),(16,9,'幻化坐骑碎片','',1,4),(17,1,'晋升道具','',1,0),(17,2,'神格神魂','',1,0),(17,3,'神格法则','',1,0),(17,4,'法则特戒材料','',1,4),(18,1,'吞噬类','',1,0),(18,2,'升星进阶','',1,0),(18,3,'突破','',1,0),(18,4,'激活道具','',1,0),(18,5,'技能书','',1,0),(18,6,'技能升级材料','',1,0),(18,7,'星灵装备','',1,26),(18,19,'进阶道具','',4,26),(18,20,'激活碎片','',1,4),(19,1,'铭文','',1,0),(20,1,'翅膀装备','',2,0),(20,2,'培养道具','',1,0),(20,3,'幻化道具','',2,0),(20,4,'合成材料','',1,0),(20,5,'限时幻化','',1,4),(20,6,'翅膀精炼材料','',1,4),(20,7,'翅膀碎片','',1,4),(21,1,'星痕装备','',1,24),(21,2,'星痕强化','',1,24),(21,3,'星痕铸魂','',1,24),(22,1,'经验道具','',1,0),(22,2,'培养道具','',1,0),(22,3,'幻形道具','',1,0),(22,4,'公会币','',1,0),(22,5,'经验','',1,0),(22,6,'鲜花数','',1,0),(22,7,'花香值','',1,0),(22,8,'公会资金','',1,0),(22,9,'公会贡献度','',1,0),(22,10,'更名卡','',1,0),(22,88,'活动道具','',1,0),(22,99,'钻石卡','',1,0),(23,1,'打怪经验符','',1,0),(23,2,'篝火经验符','',1,0),(24,1,'经验道具','',4,0),(24,2,'培养道具','',4,0),(24,3,'幻化道具','',1,4),(24,4,'宝具幻化碎片','',1,4),(25,1,'任务道具','',1,0),(26,1,'攻击','',1,0),(26,2,'气血','',1,0),(26,3,'破甲','',1,0),(26,4,'防御','',1,0),(26,5,'命中','',1,0),(26,6,'闪避','',1,0),(26,7,'暴击','',1,0),(26,8,'坚韧','',1,0),(26,9,'绝对攻击','',1,0),(26,10,'绝对防御','',1,0),(26,11,'武器攻击','',1,0),(26,12,'武器破甲','',1,0),(26,13,'防具气血','',1,0),(26,14,'防具防御','',1,0),(26,15,'仙器攻击','',1,0),(26,16,'仙器破甲','',1,0),(26,17,'攻击、武器攻击','',1,0),(26,18,'气血、防具气血','',1,0),(26,19,'破甲、武器破甲','',1,0),(26,20,'防御、防具防御','',1,0),(26,21,'命中、闪避','',1,0),(26,22,'暴击、坚韧','',1,0),(26,23,'绝对攻击、绝对防御','',1,0),(26,24,'仙器攻击、仙器防御','',1,0),(26,25,'杀怪经验','',1,0),(26,99,'经验符文','',1,0),(32,1,'礼包','',1,0),(32,2,'套装石礼包','',1,4),(32,3,'宝石礼包','',1,4),(32,4,'星痕礼包','',1,0),(32,5,'结婚道具礼包','',1,4),(32,6,'星灵技能书','',1,4),(32,7,'星灵碎片','',1,4),(32,8,'装备礼包','',1,4),(32,9,'神格礼包','',1,0),(32,10,'资源找回装备包','',1,4),(32,11,'星灵装备箱','',1,4),(32,12,'星痕装备箱（跨服boss）','',1,0),(32,13,'坐骑装备（跨服入侵）','',1,4),(32,14,'1VN活动宝石包','',1,4),(32,15,'运营活动包1','',1,4),(32,16,'运营活动包2','',1,4),(32,17,'坐骑装备包','',1,4),(36,1,'钻石','',1,0),(36,2,'绑钻','',1,0),(36,3,'金币','',1,0),(36,4,'VIP','',1,0),(36,5,'公会货币','',1,0),(36,6,'经验','',1,0),(36,7,'鲜花','',1,0),(36,8,'时装精华','',1,0),(36,9,'海神币','',1,0),(36,10,'粉钻','',1,4),(36,16,'竞技荣誉值','',1,0),(36,17,'圣印积分','',1,0),(36,20,'星力','',1,0),(36,21,'钻石卡','',1,0),(36,22,'至尊币','',1,4),(36,255,'特殊货币','',1,0),(37,1,'经验丹','',1,0),(37,2,'经验药水','',1,0),(37,3,'活力','',1,0),(37,4,'中午答题','',1,0),(37,5,'VIP专属','',1,4),(38,1,'任务','',1,0),(38,3,'通行证','',1,0),(38,4,'材料类','',1,0),(38,5,'喇叭','',1,0),(38,6,'称号（弃用）','',1,0),(38,7,'离线卡','',1,0),(38,8,'红包','',1,0),(38,9,'红名相关','',1,0),(38,10,'好友社交','',1,0),(38,11,'转生任务道具','',1,0),(38,12,'技能','',1,0),(38,13,'飞鞋','',1,0),(38,14,'泡泡','',1,0),(38,15,'相框','',1,0),(38,16,'BOSS疲劳药水','',1,0),(38,17,'幻兽BOSS疲劳药水','',1,0),(38,18,'抽奖道具','',1,0),(38,19,'公会道具','',1,0),(38,21,'公会改名卡','',1,0),(38,22,'活动道具','',1,0),(38,23,'普通套装石','',1,4),(38,24,'完美套装石','',1,4),(38,25,'洗练消耗','',1,4),(38,26,'精炼消耗','',1,4),(38,27,'套装石碎片','',1,4),(38,28,'粉装神装锻造石','',1,4),(38,30,'宝藏守护','',1,0),(38,31,'渔具类型','',1,4),(38,32,'金币矿工','',1,4),(38,33,'飞艇劵','',1,4),(38,34,'副本增加次数道具','',1,4),(38,35,'副本增加特殊扫荡次数','',1,4),(39,1,'兽角','',1,0),(39,2,'獠牙','',1,0),(39,3,'鳞甲','',1,0),(39,4,'兽爪','',1,0),(39,5,'项圈','',1,0),(39,51,'强化材料','',1,0),(40,1,'钻戒','',1,0),(40,2,'预约卡','',1,0),(40,3,'宝宝升级','',1,0),(40,4,'宝宝天赋学习','',1,0),(40,5,'宝宝天赋重置','',1,4),(40,6,'宝宝天赋提升','',1,4),(40,7,'宝宝激活','',1,0),(41,1,'等级宝箱','',1,0),(42,1,'魔粉','',1,0),(42,2,'帮贡道具','',1,0),(42,3,'增益','',1,0),(44,1,'神器','',1,0),(44,2,'神器强化石','',1,0),(44,3,'神器附灵石','',1,0),(45,1,'图鉴升级材料','',1,0),(46,1,'食谱','',1,4),(46,2,'普通料理','',1,0),(46,3,'高级料理','',1,0),(46,4,'顶级料理','',1,0),(46,5,'珍品料理','',1,0),(46,6,'厨神料理','',1,0),(47,1,'打造纸','',1,0),(47,2,'材料','',1,4),(47,3,'床柜类','',1,0),(47,4,'桌椅类','',1,0),(47,5,'摆设类','',1,0),(47,6,'墙饰类','',1,0),(47,7,'地面类','',1,0),(48,1,'木材','',1,0),(48,2,'铁矿','',1,0),(48,3,'石矿','',1,0),(48,4,'家园币','',1,0),(48,5,'家园激活','',1,0),(48,6,'升级加速卡','',1,4),(48,7,'升级队列卡','',1,4),(48,8,'许愿币','',1,4),(49,1,'称号道具','',1,0),(50,1,'渔具','',1,4),(50,2,'鱼类','',1,4),(50,3,'奇珍类','',1,4),(50,4,'贝壳','',1,4),(51,1,'VIP认证礼包','',1,0),(52,1,'属性魂珠','',1,29),(52,2,'技能魂珠','',1,29),(52,3,'材料魂珠','',1,29),(52,4,'魂珠合成材料','',1,4),(52,5,'魂珠提升材料','',1,4),(52,6,'双属性魂珠','',1,29),(53,1,'光武幻化升星','',1,4),(53,2,'专武升级材料','',1,4),(53,3,'专武强化材料','',1,4),(53,4,'光武碎片','',1,4),(54,1,'宝宝升阶','',1,4),(54,2,'宝宝培养','',1,4),(54,3,'宝宝坐骑激活','',1,4),(54,4,'宝宝坐骑升阶','',1,4),(54,5,'宝宝时装激活','',1,4),(54,6,'宝宝外观碎片','',1,4),(54,7,'宝宝翅膀激活','',1,4),(55,1,'印记装备','',1,32),(56,1,'三英会战宝箱BUFF','',1,4);
/*!40000 ALTER TABLE `base_goods_subtype` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_goods_type`
--

DROP TABLE IF EXISTS `base_goods_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_goods_type` (
  `type` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '类型ID',
  `type_name` varchar(50) NOT NULL DEFAULT '' COMMENT '类型名称@lang@',
  `label_id` int(11) NOT NULL COMMENT '标签ID',
  `bag_location` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '背包位置',
  PRIMARY KEY (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品类型表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_goods_type`
--

LOCK TABLES `base_goods_type` WRITE;
/*!40000 ALTER TABLE `base_goods_type` DISABLE KEYS */;
INSERT INTO `base_goods_type` VALUES (10,'装备类',2,0),(11,'降神类',1,0),(12,'时装类',1,0),(14,'宝石类',1,0),(15,'圣灵类',1,0),(16,'坐骑类',1,0),(17,'神格类',1,0),(18,'星灵类',1,0),(19,'技能类',1,4),(20,'翅膀类',1,0),(21,'星痕类',2,4),(24,'宝具类',1,0),(32,'礼包类',1,0),(33,'等级礼包类',1,0),(34,'自选礼包类',1,0),(36,'特殊类',1,0),(37,'增益类',1,0),(38,'道具类',1,0),(40,'姻缘类',1,0),(42,'公会类',1,0),(45,'图鉴类',1,20),(46,'食物类',1,4),(47,'家具类',1,4),(48,'家园类',1,4),(49,'称号',1,0),(50,'钓鱼',1,4),(51,'神秘礼包',1,4),(52,'魂珠类',1,29),(53,'光武类',1,4),(54,'宝宝类',1,4),(55,'降神印记类',1,4),(56,'三英会战BUFF',1,4);
/*!40000 ALTER TABLE `base_goods_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_guild_guard_box_num`
--

DROP TABLE IF EXISTS `base_guild_guard_box_num`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_guild_guard_box_num` (
  `min_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '人数下限',
  `max_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '人数上限',
  `box_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT '宝箱个数',
  PRIMARY KEY (`min_num`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_guild_guard_box_num`
--

LOCK TABLES `base_guild_guard_box_num` WRITE;
/*!40000 ALTER TABLE `base_guild_guard_box_num` DISABLE KEYS */;
INSERT INTO `base_guild_guard_box_num` VALUES (0,5,'[{42010010,5},{42010011,5},{42010012,3}]'),(6,10,'[{42010010,10},{42010011,10},{42010012,5}]'),(11,15,'[{42010010,15},{42010011,15},{42010012,8}]'),(16,20,'[{42010010,20},{42010011,20},{42010012,10}]'),(21,25,'[{42010010,25},{42010011,25},{42010012,12}]'),(26,99,'[{42010010,30},{42010011,30},{42010012,15}]');
/*!40000 ALTER TABLE `base_guild_guard_box_num` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_guild_guard_box_reward`
--

DROP TABLE IF EXISTS `base_guild_guard_box_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_guild_guard_box_reward` (
  `box_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '宝箱id',
  `min_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级下限',
  `max_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级上限',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励内容',
  PRIMARY KEY (`box_id`,`min_lv`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_guild_guard_box_reward`
--

LOCK TABLES `base_guild_guard_box_reward` WRITE;
/*!40000 ALTER TABLE `base_guild_guard_box_reward` DISABLE KEYS */;
INSERT INTO `base_guild_guard_box_reward` VALUES (42010010,1,1000,'[{0,11020001,15}]'),(42010011,1,1000,'[{0,18020001,15}]'),(42010012,1,1000,'[{0,11020001,10},{0,18020001,10}]');
/*!40000 ALTER TABLE `base_guild_guard_box_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_guild_guard_event_reward`
--

DROP TABLE IF EXISTS `base_guild_guard_event_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_guild_guard_event_reward` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `min_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小世界等级',
  `max_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大世界等级',
  `event_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '波数',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '评分',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励内容',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=417 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_guild_guard_event_reward`
--

LOCK TABLES `base_guild_guard_event_reward` WRITE;
/*!40000 ALTER TABLE `base_guild_guard_event_reward` DISABLE KEYS */;
INSERT INTO `base_guild_guard_event_reward` VALUES (1,1,200,1,1,'[{0,11020001,4},{5,36060001,2936996}]'),(2,201,260,1,1,'[{0,11020001,5},{5,36060001,2936996}]'),(3,261,320,1,1,'[{0,11020001,6},{5,36060001,4744662}]'),(4,321,350,1,1,'[{0,11020001,7},{5,36060001,5605803}]'),(5,351,370,1,1,'[{0,11020001,8},{5,36060001,6410766}]'),(6,371,390,1,1,'[{0,11020001,9},{5,36060001,10358805}]'),(7,391,430,1,1,'[{0,11020002,6},{5,36060001,14459705}]'),(8,431,500,1,1,'[{0,11020002,8},{5,36060001,20159705}]'),(9,501,560,1,1,'[{0,11020002,8},{5,36060001,33181654}]'),(10,561,610,1,1,'[{0,11020002,10},{5,36060001,60916727}]'),(11,611,660,1,1,'[{0,11020002,10},{5,36060001,75166727}]'),(12,661,750,1,1,'[{0,11020003,6},{5,36060001,89416727}]'),(13,751,1000,1,1,'[{0,11020003,8},{5,36060001,115066727}]'),(14,1,200,2,1,'[{0,18020001,5},{5,36060001,2936996}]'),(15,201,260,2,1,'[{0,18020001,6},{5,36060001,2936996}]'),(16,261,320,2,1,'[{0,18020001,8},{5,36060001,4744662}]'),(17,321,350,2,1,'[{0,18020001,10},{5,36060001,5605803}]'),(18,351,370,2,1,'[{0,18020001,10},{5,36060001,6410766}]'),(19,371,390,2,1,'[{0,18020001,12},{5,36060001,10358805}]'),(20,391,430,2,1,'[{0,18020002,5},{5,36060001,14459705}]'),(21,431,500,2,1,'[{0,18020002,6},{5,36060001,20159705}]'),(22,501,560,2,1,'[{0,18020002,6},{5,36060001,33181654}]'),(23,561,610,2,1,'[{0,18020002,6},{5,36060001,60916727}]'),(24,611,660,2,1,'[{0,18020002,7},{5,36060001,75166727}]'),(25,661,750,2,1,'[{0,18020003,3},{5,36060001,89416727}]'),(26,751,1000,2,1,'[{0,18020003,4},{5,36060001,115066727}]'),(27,1,200,3,1,'[{0,11020001,4},{5,36060001,2936996}]'),(28,201,260,3,1,'[{0,11020001,5},{5,36060001,2936996}]'),(29,261,320,3,1,'[{0,11020001,6},{5,36060001,4744662}]'),(30,321,350,3,1,'[{0,11020001,7},{5,36060001,5605803}]'),(31,351,370,3,1,'[{0,11020001,8},{5,36060001,6410766}]'),(32,371,390,3,1,'[{0,11020001,9},{5,36060001,10358805}]'),(33,391,430,3,1,'[{0,11020002,6},{5,36060001,14459705}]'),(34,431,500,3,1,'[{0,11020002,8},{5,36060001,20159705}]'),(35,501,560,3,1,'[{0,11020002,8},{5,36060001,33181654}]'),(36,561,610,3,1,'[{0,11020002,10},{5,36060001,60916727}]'),(37,611,660,3,1,'[{0,11020002,10},{5,36060001,75166727}]'),(38,661,750,3,1,'[{0,11020003,6},{5,36060001,89416727}]'),(39,751,1000,3,1,'[{0,11020003,8},{5,36060001,115066727}]'),(40,1,200,4,1,'[{0,18020001,5},{5,36060001,2936996}]'),(41,201,260,4,1,'[{0,18020001,6},{5,36060001,2936996}]'),(42,261,320,4,1,'[{0,18020001,8},{5,36060001,4744662}]'),(43,321,350,4,1,'[{0,18020001,10},{5,36060001,5605803}]'),(44,351,370,4,1,'[{0,18020001,10},{5,36060001,6410766}]'),(45,371,390,4,1,'[{0,18020001,12},{5,36060001,10358805}]'),(46,391,430,4,1,'[{0,18020002,5},{5,36060001,14459705}]'),(47,431,500,4,1,'[{0,18020002,6},{5,36060001,20159705}]'),(48,501,560,4,1,'[{0,18020002,6},{5,36060001,33181654}]'),(49,561,610,4,1,'[{0,18020002,6},{5,36060001,60916727}]'),(50,611,660,4,1,'[{0,18020002,7},{5,36060001,75166727}]'),(51,661,750,4,1,'[{0,18020003,3},{5,36060001,89416727}]'),(52,751,1000,4,1,'[{0,18020003,4},{5,36060001,115066727}]'),(53,1,200,5,1,'[{0,11020001,4},{5,36060001,2936996}]'),(54,201,260,5,1,'[{0,11020001,5},{5,36060001,2936996}]'),(55,261,320,5,1,'[{0,11020001,6},{5,36060001,4744662}]'),(56,321,350,5,1,'[{0,11020001,7},{5,36060001,5605803}]'),(57,351,370,5,1,'[{0,11020001,8},{5,36060001,6410766}]'),(58,371,390,5,1,'[{0,11020001,9},{5,36060001,10358805}]'),(59,391,430,5,1,'[{0,11020002,6},{5,36060001,14459705}]'),(60,431,500,5,1,'[{0,11020002,8},{5,36060001,20159705}]'),(61,501,560,5,1,'[{0,11020002,8},{5,36060001,33181654}]'),(62,561,610,5,1,'[{0,11020002,10},{5,36060001,60916727}]'),(63,611,660,5,1,'[{0,11020002,10},{5,36060001,75166727}]'),(64,661,750,5,1,'[{0,11020003,6},{5,36060001,89416727}]'),(65,751,1000,5,1,'[{0,11020003,8},{5,36060001,115066727}]'),(66,1,200,6,1,'[{0,18020001,5},{5,36060001,2936996}]'),(67,201,260,6,1,'[{0,18020001,6},{5,36060001,2936996}]'),(68,261,320,6,1,'[{0,18020001,8},{5,36060001,4744662}]'),(69,321,350,6,1,'[{0,18020001,10},{5,36060001,5605803}]'),(70,351,370,6,1,'[{0,18020001,10},{5,36060001,6410766}]'),(71,371,390,6,1,'[{0,18020001,12},{5,36060001,10358805}]'),(72,391,430,6,1,'[{0,18020002,5},{5,36060001,14459705}]'),(73,431,500,6,1,'[{0,18020002,6},{5,36060001,20159705}]'),(74,501,560,6,1,'[{0,18020002,6},{5,36060001,33181654}]'),(75,561,610,6,1,'[{0,18020002,6},{5,36060001,60916727}]'),(76,611,660,6,1,'[{0,18020002,7},{5,36060001,75166727}]'),(77,661,750,6,1,'[{0,18020003,3},{5,36060001,89416727}]'),(78,751,1000,6,1,'[{0,18020003,4},{5,36060001,115066727}]'),(79,1,200,7,1,'[{0,11020001,4},{5,36060001,2936996}]'),(80,201,260,7,1,'[{0,11020001,5},{5,36060001,2936996}]'),(81,261,320,7,1,'[{0,11020001,6},{5,36060001,4744662}]'),(82,321,350,7,1,'[{0,11020001,7},{5,36060001,5605803}]'),(83,351,370,7,1,'[{0,11020001,8},{5,36060001,6410766}]'),(84,371,390,7,1,'[{0,11020001,9},{5,36060001,10358805}]'),(85,391,430,7,1,'[{0,11020002,6},{5,36060001,14459705}]'),(86,431,500,7,1,'[{0,11020002,8},{5,36060001,20159705}]'),(87,501,560,7,1,'[{0,11020002,8},{5,36060001,33181654}]'),(88,561,610,7,1,'[{0,11020002,10},{5,36060001,60916727}]'),(89,611,660,7,1,'[{0,11020002,10},{5,36060001,75166727}]'),(90,661,750,7,1,'[{0,11020003,6},{5,36060001,89416727}]'),(91,751,1000,7,1,'[{0,11020003,8},{5,36060001,115066727}]'),(92,1,200,8,1,'[{0,18020001,5},{5,36060001,2936996}]'),(93,201,260,8,1,'[{0,18020001,6},{5,36060001,2936996}]'),(94,261,320,8,1,'[{0,18020001,8},{5,36060001,4744662}]'),(95,321,350,8,1,'[{0,18020001,10},{5,36060001,5605803}]'),(96,351,370,8,1,'[{0,18020001,10},{5,36060001,6410766}]'),(97,371,390,8,1,'[{0,18020001,12},{5,36060001,10358805}]'),(98,391,430,8,1,'[{0,18020002,5},{5,36060001,14459705}]'),(99,431,500,8,1,'[{0,18020002,6},{5,36060001,20159705}]'),(100,501,560,8,1,'[{0,18020002,6},{5,36060001,33181654}]'),(101,561,610,8,1,'[{0,18020002,6},{5,36060001,60916727}]'),(102,611,660,8,1,'[{0,18020002,7},{5,36060001,75166727}]'),(103,661,750,8,1,'[{0,18020003,3},{5,36060001,89416727}]'),(104,751,1000,8,1,'[{0,18020003,4},{5,36060001,115066727}]'),(105,1,200,1,2,'[{0,11020001,4},{5,36060001,2349597}]'),(106,201,260,1,2,'[{0,11020001,5},{5,36060001,2349597}]'),(107,261,320,1,2,'[{0,11020001,6},{5,36060001,3795729}]'),(108,321,350,1,2,'[{0,11020001,7},{5,36060001,4484642}]'),(109,351,370,1,2,'[{0,11020001,8},{5,36060001,5128613}]'),(110,371,390,1,2,'[{0,11020001,9},{5,36060001,8287044}]'),(111,391,430,1,2,'[{0,11020002,6},{5,36060001,11567764}]'),(112,431,500,1,2,'[{0,11020002,8},{5,36060001,16127764}]'),(113,501,560,1,2,'[{0,11020002,8},{5,36060001,26545323}]'),(114,561,610,1,2,'[{0,11020002,10},{5,36060001,48733382}]'),(115,611,660,1,2,'[{0,11020002,10},{5,36060001,60133382}]'),(116,661,750,1,2,'[{0,11020003,6},{5,36060001,71533382}]'),(117,751,1000,1,2,'[{0,11020003,8},{5,36060001,92053382}]'),(118,1,200,2,2,'[{0,18020001,5},{5,36060001,2349597}]'),(119,201,260,2,2,'[{0,18020001,6},{5,36060001,2349597}]'),(120,261,320,2,2,'[{0,18020001,8},{5,36060001,3795729}]'),(121,321,350,2,2,'[{0,18020001,10},{5,36060001,4484642}]'),(122,351,370,2,2,'[{0,18020001,10},{5,36060001,5128613}]'),(123,371,390,2,2,'[{0,18020001,12},{5,36060001,8287044}]'),(124,391,430,2,2,'[{0,18020002,5},{5,36060001,11567764}]'),(125,431,500,2,2,'[{0,18020002,6},{5,36060001,16127764}]'),(126,501,560,2,2,'[{0,18020002,6},{5,36060001,26545323}]'),(127,561,610,2,2,'[{0,18020002,6},{5,36060001,48733382}]'),(128,611,660,2,2,'[{0,18020002,7},{5,36060001,60133382}]'),(129,661,750,2,2,'[{0,18020003,3},{5,36060001,71533382}]'),(130,751,1000,2,2,'[{0,18020003,4},{5,36060001,92053382}]'),(131,1,200,3,2,'[{0,11020001,4},{5,36060001,2349597}]'),(132,201,260,3,2,'[{0,11020001,5},{5,36060001,2349597}]'),(133,261,320,3,2,'[{0,11020001,6},{5,36060001,3795729}]'),(134,321,350,3,2,'[{0,11020001,7},{5,36060001,4484642}]'),(135,351,370,3,2,'[{0,11020001,8},{5,36060001,5128613}]'),(136,371,390,3,2,'[{0,11020001,9},{5,36060001,8287044}]'),(137,391,430,3,2,'[{0,11020002,6},{5,36060001,11567764}]'),(138,431,500,3,2,'[{0,11020002,8},{5,36060001,16127764}]'),(139,501,560,3,2,'[{0,11020002,8},{5,36060001,26545323}]'),(140,561,610,3,2,'[{0,11020002,10},{5,36060001,48733382}]'),(141,611,660,3,2,'[{0,11020002,10},{5,36060001,60133382}]'),(142,661,750,3,2,'[{0,11020003,6},{5,36060001,71533382}]'),(143,751,1000,3,2,'[{0,11020003,8},{5,36060001,92053382}]'),(144,1,200,4,2,'[{0,18020001,5},{5,36060001,2349597}]'),(145,201,260,4,2,'[{0,18020001,6},{5,36060001,2349597}]'),(146,261,320,4,2,'[{0,18020001,8},{5,36060001,3795729}]'),(147,321,350,4,2,'[{0,18020001,10},{5,36060001,4484642}]'),(148,351,370,4,2,'[{0,18020001,10},{5,36060001,5128613}]'),(149,371,390,4,2,'[{0,18020001,12},{5,36060001,8287044}]'),(150,391,430,4,2,'[{0,18020002,5},{5,36060001,11567764}]'),(151,431,500,4,2,'[{0,18020002,6},{5,36060001,16127764}]'),(152,501,560,4,2,'[{0,18020002,6},{5,36060001,26545323}]'),(153,561,610,4,2,'[{0,18020002,6},{5,36060001,48733382}]'),(154,611,660,4,2,'[{0,18020002,7},{5,36060001,60133382}]'),(155,661,750,4,2,'[{0,18020003,3},{5,36060001,71533382}]'),(156,751,1000,4,2,'[{0,18020003,4},{5,36060001,92053382}]'),(157,1,200,5,2,'[{0,11020001,4},{5,36060001,2349597}]'),(158,201,260,5,2,'[{0,11020001,5},{5,36060001,2349597}]'),(159,261,320,5,2,'[{0,11020001,6},{5,36060001,3795729}]'),(160,321,350,5,2,'[{0,11020001,7},{5,36060001,4484642}]'),(161,351,370,5,2,'[{0,11020001,8},{5,36060001,5128613}]'),(162,371,390,5,2,'[{0,11020001,9},{5,36060001,8287044}]'),(163,391,430,5,2,'[{0,11020002,6},{5,36060001,11567764}]'),(164,431,500,5,2,'[{0,11020002,8},{5,36060001,16127764}]'),(165,501,560,5,2,'[{0,11020002,8},{5,36060001,26545323}]'),(166,561,610,5,2,'[{0,11020002,10},{5,36060001,48733382}]'),(167,611,660,5,2,'[{0,11020002,10},{5,36060001,60133382}]'),(168,661,750,5,2,'[{0,11020003,6},{5,36060001,71533382}]'),(169,751,1000,5,2,'[{0,11020003,8},{5,36060001,92053382}]'),(170,1,200,6,2,'[{0,18020001,5},{5,36060001,2349597}]'),(171,201,260,6,2,'[{0,18020001,6},{5,36060001,2349597}]'),(172,261,320,6,2,'[{0,18020001,8},{5,36060001,3795729}]'),(173,321,350,6,2,'[{0,18020001,10},{5,36060001,4484642}]'),(174,351,370,6,2,'[{0,18020001,10},{5,36060001,5128613}]'),(175,371,390,6,2,'[{0,18020001,12},{5,36060001,8287044}]'),(176,391,430,6,2,'[{0,18020002,5},{5,36060001,11567764}]'),(177,431,500,6,2,'[{0,18020002,6},{5,36060001,16127764}]'),(178,501,560,6,2,'[{0,18020002,6},{5,36060001,26545323}]'),(179,561,610,6,2,'[{0,18020002,6},{5,36060001,48733382}]'),(180,611,660,6,2,'[{0,18020002,7},{5,36060001,60133382}]'),(181,661,750,6,2,'[{0,18020003,3},{5,36060001,71533382}]'),(182,751,1000,6,2,'[{0,18020003,4},{5,36060001,92053382}]'),(183,1,200,7,2,'[{0,11020001,4},{5,36060001,2349597}]'),(184,201,260,7,2,'[{0,11020001,5},{5,36060001,2349597}]'),(185,261,320,7,2,'[{0,11020001,6},{5,36060001,3795729}]'),(186,321,350,7,2,'[{0,11020001,7},{5,36060001,4484642}]'),(187,351,370,7,2,'[{0,11020001,8},{5,36060001,5128613}]'),(188,371,390,7,2,'[{0,11020001,9},{5,36060001,8287044}]'),(189,391,430,7,2,'[{0,11020002,6},{5,36060001,11567764}]'),(190,431,500,7,2,'[{0,11020002,8},{5,36060001,16127764}]'),(191,501,560,7,2,'[{0,11020002,8},{5,36060001,26545323}]'),(192,561,610,7,2,'[{0,11020002,10},{5,36060001,48733382}]'),(193,611,660,7,2,'[{0,11020002,10},{5,36060001,60133382}]'),(194,661,750,7,2,'[{0,11020003,6},{5,36060001,71533382}]'),(195,751,1000,7,2,'[{0,11020003,8},{5,36060001,92053382}]'),(196,1,200,8,2,'[{0,18020001,5},{5,36060001,2349597}]'),(197,201,260,8,2,'[{0,18020001,6},{5,36060001,2349597}]'),(198,261,320,8,2,'[{0,18020001,8},{5,36060001,3795729}]'),(199,321,350,8,2,'[{0,18020001,10},{5,36060001,4484642}]'),(200,351,370,8,2,'[{0,18020001,10},{5,36060001,5128613}]'),(201,371,390,8,2,'[{0,18020001,12},{5,36060001,8287044}]'),(202,391,430,8,2,'[{0,18020002,5},{5,36060001,11567764}]'),(203,431,500,8,2,'[{0,18020002,6},{5,36060001,16127764}]'),(204,501,560,8,2,'[{0,18020002,6},{5,36060001,26545323}]'),(205,561,610,8,2,'[{0,18020002,6},{5,36060001,48733382}]'),(206,611,660,8,2,'[{0,18020002,7},{5,36060001,60133382}]'),(207,661,750,8,2,'[{0,18020003,3},{5,36060001,71533382}]'),(208,751,1000,8,2,'[{0,18020003,4},{5,36060001,92053382}]'),(209,1,200,1,3,'[{0,11020001,5},{5,36060001,1762198}]'),(210,201,260,1,3,'[{0,11020001,6},{5,36060001,1762198}]'),(211,261,320,1,3,'[{0,11020001,7},{5,36060001,2846797}]'),(212,321,350,1,3,'[{0,11020001,8},{5,36060001,3363482}]'),(213,351,370,1,3,'[{0,11020001,10},{5,36060001,3846460}]'),(214,371,390,1,3,'[{0,11020001,12},{5,36060001,6215283}]'),(215,391,430,1,3,'[{0,11020002,7},{5,36060001,8675823}]'),(216,431,500,1,3,'[{0,11020002,9},{5,36060001,12095823}]'),(217,501,560,1,3,'[{0,11020002,9},{5,36060001,19908992}]'),(218,561,610,1,3,'[{0,11020002,12},{5,36060001,36550036}]'),(219,611,660,1,3,'[{0,11020002,12},{5,36060001,45100036}]'),(220,661,750,1,3,'[{0,11020003,8},{5,36060001,53650036}]'),(221,751,1000,1,3,'[{0,11020003,10},{5,36060001,69040036}]'),(222,1,200,2,3,'[{0,18020001,6},{5,36060001,1762198}]'),(223,201,260,2,3,'[{0,18020001,8},{5,36060001,1762198}]'),(224,261,320,2,3,'[{0,18020001,10},{5,36060001,2846797}]'),(225,321,350,2,3,'[{0,18020001,13},{5,36060001,3363482}]'),(226,351,370,2,3,'[{0,18020001,13},{5,36060001,3846460}]'),(227,371,390,2,3,'[{0,18020001,15},{5,36060001,6215283}]'),(228,391,430,2,3,'[{0,18020002,6},{5,36060001,8675823}]'),(229,431,500,2,3,'[{0,18020002,7},{5,36060001,12095823}]'),(230,501,560,2,3,'[{0,18020002,8},{5,36060001,19908992}]'),(231,561,610,2,3,'[{0,18020002,8},{5,36060001,36550036}]'),(232,611,660,2,3,'[{0,18020002,9},{5,36060001,45100036}]'),(233,661,750,2,3,'[{0,18020003,4},{5,36060001,53650036}]'),(234,751,1000,2,3,'[{0,18020003,5},{5,36060001,69040036}]'),(235,1,200,3,3,'[{0,11020001,5},{5,36060001,1762198}]'),(236,201,260,3,3,'[{0,11020001,6},{5,36060001,1762198}]'),(237,261,320,3,3,'[{0,11020001,7},{5,36060001,2846797}]'),(238,321,350,3,3,'[{0,11020001,8},{5,36060001,3363482}]'),(239,351,370,3,3,'[{0,11020001,10},{5,36060001,3846460}]'),(240,371,390,3,3,'[{0,11020001,12},{5,36060001,6215283}]'),(241,391,430,3,3,'[{0,11020002,7},{5,36060001,8675823}]'),(242,431,500,3,3,'[{0,11020002,9},{5,36060001,12095823}]'),(243,501,560,3,3,'[{0,11020002,9},{5,36060001,19908992}]'),(244,561,610,3,3,'[{0,11020002,12},{5,36060001,36550036}]'),(245,611,660,3,3,'[{0,11020002,12},{5,36060001,45100036}]'),(246,661,750,3,3,'[{0,11020003,8},{5,36060001,53650036}]'),(247,751,1000,3,3,'[{0,11020003,10},{5,36060001,69040036}]'),(248,1,200,4,3,'[{0,18020001,6},{5,36060001,1762198}]'),(249,201,260,4,3,'[{0,18020001,8},{5,36060001,1762198}]'),(250,261,320,4,3,'[{0,18020001,10},{5,36060001,2846797}]'),(251,321,350,4,3,'[{0,18020001,13},{5,36060001,3363482}]'),(252,351,370,4,3,'[{0,18020001,13},{5,36060001,3846460}]'),(253,371,390,4,3,'[{0,18020001,15},{5,36060001,6215283}]'),(254,391,430,4,3,'[{0,18020002,6},{5,36060001,8675823}]'),(255,431,500,4,3,'[{0,18020002,7},{5,36060001,12095823}]'),(256,501,560,4,3,'[{0,18020002,8},{5,36060001,19908992}]'),(257,561,610,4,3,'[{0,18020002,8},{5,36060001,36550036}]'),(258,611,660,4,3,'[{0,18020002,9},{5,36060001,45100036}]'),(259,661,750,4,3,'[{0,18020003,4},{5,36060001,53650036}]'),(260,751,1000,4,3,'[{0,18020003,5},{5,36060001,69040036}]'),(261,1,200,5,3,'[{0,11020001,5},{5,36060001,1762198}]'),(262,201,260,5,3,'[{0,11020001,6},{5,36060001,1762198}]'),(263,261,320,5,3,'[{0,11020001,7},{5,36060001,2846797}]'),(264,321,350,5,3,'[{0,11020001,8},{5,36060001,3363482}]'),(265,351,370,5,3,'[{0,11020001,10},{5,36060001,3846460}]'),(266,371,390,5,3,'[{0,11020001,12},{5,36060001,6215283}]'),(267,391,430,5,3,'[{0,11020002,7},{5,36060001,8675823}]'),(268,431,500,5,3,'[{0,11020002,9},{5,36060001,12095823}]'),(269,501,560,5,3,'[{0,11020002,9},{5,36060001,19908992}]'),(270,561,610,5,3,'[{0,11020002,12},{5,36060001,36550036}]'),(271,611,660,5,3,'[{0,11020002,12},{5,36060001,45100036}]'),(272,661,750,5,3,'[{0,11020003,8},{5,36060001,53650036}]'),(273,751,1000,5,3,'[{0,11020003,10},{5,36060001,69040036}]'),(274,1,200,6,3,'[{0,18020001,6},{5,36060001,1762198}]'),(275,201,260,6,3,'[{0,18020001,8},{5,36060001,1762198}]'),(276,261,320,6,3,'[{0,18020001,10},{5,36060001,2846797}]'),(277,321,350,6,3,'[{0,18020001,13},{5,36060001,3363482}]'),(278,351,370,6,3,'[{0,18020001,13},{5,36060001,3846460}]'),(279,371,390,6,3,'[{0,18020001,15},{5,36060001,6215283}]'),(280,391,430,6,3,'[{0,18020002,6},{5,36060001,8675823}]'),(281,431,500,6,3,'[{0,18020002,7},{5,36060001,12095823}]'),(282,501,560,6,3,'[{0,18020002,8},{5,36060001,19908992}]'),(283,561,610,6,3,'[{0,18020002,8},{5,36060001,36550036}]'),(284,611,660,6,3,'[{0,18020002,9},{5,36060001,45100036}]'),(285,661,750,6,3,'[{0,18020003,4},{5,36060001,53650036}]'),(286,751,1000,6,3,'[{0,18020003,5},{5,36060001,69040036}]'),(287,1,200,7,3,'[{0,11020001,5},{5,36060001,1762198}]'),(288,201,260,7,3,'[{0,11020001,6},{5,36060001,1762198}]'),(289,261,320,7,3,'[{0,11020001,7},{5,36060001,2846797}]'),(290,321,350,7,3,'[{0,11020001,8},{5,36060001,3363482}]'),(291,351,370,7,3,'[{0,11020001,10},{5,36060001,3846460}]'),(292,371,390,7,3,'[{0,11020001,12},{5,36060001,6215283}]'),(293,391,430,7,3,'[{0,11020002,7},{5,36060001,8675823}]'),(294,431,500,7,3,'[{0,11020002,9},{5,36060001,12095823}]'),(295,501,560,7,3,'[{0,11020002,9},{5,36060001,19908992}]'),(296,561,610,7,3,'[{0,11020002,12},{5,36060001,36550036}]'),(297,611,660,7,3,'[{0,11020002,12},{5,36060001,45100036}]'),(298,661,750,7,3,'[{0,11020003,8},{5,36060001,53650036}]'),(299,751,1000,7,3,'[{0,11020003,10},{5,36060001,69040036}]'),(300,1,200,8,3,'[{0,18020001,6},{5,36060001,1762198}]'),(301,201,260,8,3,'[{0,18020001,8},{5,36060001,1762198}]'),(302,261,320,8,3,'[{0,18020001,10},{5,36060001,2846797}]'),(303,321,350,8,3,'[{0,18020001,13},{5,36060001,3363482}]'),(304,351,370,8,3,'[{0,18020001,13},{5,36060001,3846460}]'),(305,371,390,8,3,'[{0,18020001,15},{5,36060001,6215283}]'),(306,391,430,8,3,'[{0,18020002,6},{5,36060001,8675823}]'),(307,431,500,8,3,'[{0,18020002,7},{5,36060001,12095823}]'),(308,501,560,8,3,'[{0,18020002,8},{5,36060001,19908992}]'),(309,561,610,8,3,'[{0,18020002,8},{5,36060001,36550036}]'),(310,611,660,8,3,'[{0,18020002,9},{5,36060001,45100036}]'),(311,661,750,8,3,'[{0,18020003,4},{5,36060001,53650036}]'),(312,751,1000,8,3,'[{0,18020003,5},{5,36060001,69040036}]'),(313,1,200,1,4,'[{0,11020001,6},{5,36060001,1468498}]'),(314,201,260,1,4,'[{0,11020001,7},{5,36060001,1468498}]'),(315,261,320,1,4,'[{0,11020001,8},{5,36060001,2372331}]'),(316,321,350,1,4,'[{0,11020001,10},{5,36060001,2802902}]'),(317,351,370,1,4,'[{0,11020001,12},{5,36060001,3205383}]'),(318,371,390,1,4,'[{0,11020001,15},{5,36060001,5179403}]'),(319,391,430,1,4,'[{0,11020002,9},{5,36060001,7229852}]'),(320,431,500,1,4,'[{0,11020002,12},{5,36060001,10079852}]'),(321,501,560,1,4,'[{0,11020002,12},{5,36060001,16590827}]'),(322,561,610,1,4,'[{0,11020002,15},{5,36060001,30458364}]'),(323,611,660,1,4,'[{0,11020002,15},{5,36060001,37583364}]'),(324,661,750,1,4,'[{0,11020003,10},{5,36060001,44708364}]'),(325,751,1000,1,4,'[{0,11020003,12},{5,36060001,57533364}]'),(326,1,200,2,4,'[{0,18020001,8},{5,36060001,1468498}]'),(327,201,260,2,4,'[{0,18020001,10},{5,36060001,1468498}]'),(328,261,320,2,4,'[{0,18020001,12},{5,36060001,2372331}]'),(329,321,350,2,4,'[{0,18020001,15},{5,36060001,2802902}]'),(330,351,370,2,4,'[{0,18020001,15},{5,36060001,3205383}]'),(331,371,390,2,4,'[{0,18020001,18},{5,36060001,5179403}]'),(332,391,430,2,4,'[{0,18020002,7},{5,36060001,7229852}]'),(333,431,500,2,4,'[{0,18020002,8},{5,36060001,10079852}]'),(334,501,560,2,4,'[{0,18020002,10},{5,36060001,16590827}]'),(335,561,610,2,4,'[{0,18020002,10},{5,36060001,30458364}]'),(336,611,660,2,4,'[{0,18020002,11},{5,36060001,37583364}]'),(337,661,750,2,4,'[{0,18020003,5},{5,36060001,44708364}]'),(338,751,1000,2,4,'[{0,18020003,5},{5,36060001,57533364}]'),(339,1,200,3,4,'[{0,11020001,6},{5,36060001,1468498}]'),(340,201,260,3,4,'[{0,11020001,7},{5,36060001,1468498}]'),(341,261,320,3,4,'[{0,11020001,8},{5,36060001,2372331}]'),(342,321,350,3,4,'[{0,11020001,10},{5,36060001,2802902}]'),(343,351,370,3,4,'[{0,11020001,12},{5,36060001,3205383}]'),(344,371,390,3,4,'[{0,11020001,15},{5,36060001,5179403}]'),(345,391,430,3,4,'[{0,11020002,9},{5,36060001,7229852}]'),(346,431,500,3,4,'[{0,11020002,12},{5,36060001,10079852}]'),(347,501,560,3,4,'[{0,11020002,12},{5,36060001,16590827}]'),(348,561,610,3,4,'[{0,11020002,15},{5,36060001,30458364}]'),(349,611,660,3,4,'[{0,11020002,15},{5,36060001,37583364}]'),(350,661,750,3,4,'[{0,11020003,10},{5,36060001,44708364}]'),(351,751,1000,3,4,'[{0,11020003,12},{5,36060001,57533364}]'),(352,1,200,4,4,'[{0,18020001,8},{5,36060001,1468498}]'),(353,201,260,4,4,'[{0,18020001,10},{5,36060001,1468498}]'),(354,261,320,4,4,'[{0,18020001,12},{5,36060001,2372331}]'),(355,321,350,4,4,'[{0,18020001,15},{5,36060001,2802902}]'),(356,351,370,4,4,'[{0,18020001,15},{5,36060001,3205383}]'),(357,371,390,4,4,'[{0,18020001,18},{5,36060001,5179403}]'),(358,391,430,4,4,'[{0,18020002,7},{5,36060001,7229852}]'),(359,431,500,4,4,'[{0,18020002,8},{5,36060001,10079852}]'),(360,501,560,4,4,'[{0,18020002,10},{5,36060001,16590827}]'),(361,561,610,4,4,'[{0,18020002,10},{5,36060001,30458364}]'),(362,611,660,4,4,'[{0,18020002,11},{5,36060001,37583364}]'),(363,661,750,4,4,'[{0,18020003,5},{5,36060001,44708364}]'),(364,751,1000,4,4,'[{0,18020003,5},{5,36060001,57533364}]'),(365,1,200,5,4,'[{0,11020001,6},{5,36060001,1468498}]'),(366,201,260,5,4,'[{0,11020001,7},{5,36060001,1468498}]'),(367,261,320,5,4,'[{0,11020001,8},{5,36060001,2372331}]'),(368,321,350,5,4,'[{0,11020001,10},{5,36060001,2802902}]'),(369,351,370,5,4,'[{0,11020001,12},{5,36060001,3205383}]'),(370,371,390,5,4,'[{0,11020001,15},{5,36060001,5179403}]'),(371,391,430,5,4,'[{0,11020002,9},{5,36060001,7229852}]'),(372,431,500,5,4,'[{0,11020002,12},{5,36060001,10079852}]'),(373,501,560,5,4,'[{0,11020002,12},{5,36060001,16590827}]'),(374,561,610,5,4,'[{0,11020002,15},{5,36060001,30458364}]'),(375,611,660,5,4,'[{0,11020002,15},{5,36060001,37583364}]'),(376,661,750,5,4,'[{0,11020003,10},{5,36060001,44708364}]'),(377,751,1000,5,4,'[{0,11020003,12},{5,36060001,57533364}]'),(378,1,200,6,4,'[{0,18020001,8},{5,36060001,1468498}]'),(379,201,260,6,4,'[{0,18020001,10},{5,36060001,1468498}]'),(380,261,320,6,4,'[{0,18020001,12},{5,36060001,2372331}]'),(381,321,350,6,4,'[{0,18020001,15},{5,36060001,2802902}]'),(382,351,370,6,4,'[{0,18020001,15},{5,36060001,3205383}]'),(383,371,390,6,4,'[{0,18020001,18},{5,36060001,5179403}]'),(384,391,430,6,4,'[{0,18020002,7},{5,36060001,7229852}]'),(385,431,500,6,4,'[{0,18020002,8},{5,36060001,10079852}]'),(386,501,560,6,4,'[{0,18020002,10},{5,36060001,16590827}]'),(387,561,610,6,4,'[{0,18020002,10},{5,36060001,30458364}]'),(388,611,660,6,4,'[{0,18020002,11},{5,36060001,37583364}]'),(389,661,750,6,4,'[{0,18020003,5},{5,36060001,44708364}]'),(390,751,1000,6,4,'[{0,18020003,5},{5,36060001,57533364}]'),(391,1,200,7,4,'[{0,11020001,6},{5,36060001,1468498}]'),(392,201,260,7,4,'[{0,11020001,7},{5,36060001,1468498}]'),(393,261,320,7,4,'[{0,11020001,8},{5,36060001,2372331}]'),(394,321,350,7,4,'[{0,11020001,10},{5,36060001,2802902}]'),(395,351,370,7,4,'[{0,11020001,12},{5,36060001,3205383}]'),(396,371,390,7,4,'[{0,11020001,15},{5,36060001,5179403}]'),(397,391,430,7,4,'[{0,11020002,9},{5,36060001,7229852}]'),(398,431,500,7,4,'[{0,11020002,12},{5,36060001,10079852}]'),(399,501,560,7,4,'[{0,11020002,12},{5,36060001,16590827}]'),(400,561,610,7,4,'[{0,11020002,15},{5,36060001,30458364}]'),(401,611,660,7,4,'[{0,11020002,15},{5,36060001,37583364}]'),(402,661,750,7,4,'[{0,11020003,10},{5,36060001,44708364}]'),(403,751,1000,7,4,'[{0,11020003,12},{5,36060001,57533364}]'),(404,1,200,8,4,'[{0,18020001,8},{5,36060001,1468498}]'),(405,201,260,8,4,'[{0,18020001,10},{5,36060001,1468498}]'),(406,261,320,8,4,'[{0,18020001,12},{5,36060001,2372331}]'),(407,321,350,8,4,'[{0,18020001,15},{5,36060001,2802902}]'),(408,351,370,8,4,'[{0,18020001,15},{5,36060001,3205383}]'),(409,371,390,8,4,'[{0,18020001,18},{5,36060001,5179403}]'),(410,391,430,8,4,'[{0,18020002,7},{5,36060001,7229852}]'),(411,431,500,8,4,'[{0,18020002,8},{5,36060001,10079852}]'),(412,501,560,8,4,'[{0,18020002,10},{5,36060001,16590827}]'),(413,561,610,8,4,'[{0,18020002,10},{5,36060001,30458364}]'),(414,611,660,8,4,'[{0,18020002,11},{5,36060001,37583364}]'),(415,661,750,8,4,'[{0,18020003,5},{5,36060001,44708364}]'),(416,751,1000,8,4,'[{0,18020003,5},{5,36060001,57533364}]');
/*!40000 ALTER TABLE `base_guild_guard_event_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_guild_guard_kv`
--

DROP TABLE IF EXISTS `base_guild_guard_kv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_guild_guard_kv` (
  `key` int(11) unsigned NOT NULL DEFAULT '0',
  `val` text NOT NULL COMMENT '值',
  `description` varchar(50) NOT NULL DEFAULT '' COMMENT '描述',
  PRIMARY KEY (`key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_guild_guard_kv`
--

LOCK TABLES `base_guild_guard_kv` WRITE;
/*!40000 ALTER TABLE `base_guild_guard_kv` DISABLE KEYS */;
INSERT INTO `base_guild_guard_kv` VALUES (1,'[{1,36010001,200}]','召唤boss消耗,格式[{类型,物品id,数量}]'),(2,'4201090','召唤bossid'),(3,'[{2,36020001,200},{0,38180010,2},{0,11020001,15},{0,18020001,15}]','召唤boss奖励,格式[{类型,物品id,数量}]'),(4,'4201','副本id'),(5,'600','击杀boss的时间上限(秒/s)'),(6,'[{4,36050001,10000}]','【客户端显示用】击杀boss奖励,格式[{类型,物品id,数量}]'),(7,'\"活动期间可以花费钻石召唤BOSS，BOSS将在8波守卫战成功之后出现，公会全体成员可以前去击杀，获得丰厚奖励！\"','客户端显示读取描述内容'),(8,'[42010010,42010011,42010012]','宝箱id,格式[宝箱id]'),(9,'[{4255,3869},{4759,3847},{5176,3838},{5648,3842},{4359,4211},{4777,4404},{5316,4291},{5814,4413},{5266,4647},{4592,4741},{4264,4813},{6450,3422},{6720,3152},{6464,2824},{6958,2573},{6859,2154},{7367,2257},{7515,2545},{7982,2635},{7960,2383},{8526,2698},{8207,2909},{7780,3129},{7259,3251},{7232,2927},{7600,3642},{8332,3633},{8386,3385},{8840,3417},{9244,3660},{9472,3269},{9773,3099},{10006,3409},{9885,3795},{9562,3948},{8192,4183},{7604,4084},{7060,3981},{7145,4349},{7559,4493},{8021,4614},{7738,4897},{7343,4790},{6979,4673},{6699,4511},{6317,4705},{6029,4745},{6151,5096},{6744,5163},{6685,4893},{7328,5257},{7557,5195},{8020,5347},{7808,5550},{7013,5527},{6532,5618},{5970,5600},{5777,5442},{5516,5177},{4698,5288},{5089,5810},{5386,6138},{5696,6439},{5503,6556},{5405,7765},{5733,7765},{6106,7814},{6106,7499},{5783,7432},{5437,7315},{5635,7054},{5940,6983},{6061,6713},{6270,6126},{6638,5960},{7663,5894},{8032,6195},{8458,6541},{8710,6775},{9056,6604},{9384,6586},{8971,6163},{8674,6343},{8387,6011},{8602,5786},{8306,5570},{5733,3318},{6052,3233},{5065,5143},{5483,5669},{9650,3537},{9223,2968},{10176,3914},{10181,2965},{6797,3701},{6061,3602},{8846,7105},{9070,7330},{9960,7091},{9731,6822},{5307,8123},{6232,8215},{5420,8558},{6204,8621},{9478,7633},{9858,7500},{10721,3865},{10978,3505},{10783,3043}]','宝箱位置:[{X,Y}]'),(10,'3','宝箱采集上限次数'),(11,'[{0,3,6},{4,8,10},{9,12,15}]',''),(12,'[4201101,4201102,4201103]','防御塔ID'),(13,'150','初始经验倍率,百分比%'),(14,'[{4201100,20},{4201101,10},{4201102,10},{4201103,10}]','塔怪死亡掉经验倍率,格式:[{怪物id,掉率(百分比)}]'),(15,'1','玩家可召唤次数上限'),(16,'3','公会召唤次数上限'),(17,'{7570,5255}','boss出生坐标'),(18,'[{4,36050001,10000}]','boss击杀奖励'),(19,'[{42010012,402,53}]','需要传闻的宝箱id：[{宝箱id,模块id,语言配置id}]'),(20,'150','玩家参加等级');
/*!40000 ALTER TABLE `base_guild_guard_kv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_guild_skill`
--

DROP TABLE IF EXISTS `base_guild_skill`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_guild_skill` (
  `skill_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能id',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '类型 1: 基础技能 2: 高级技能',
  `unlock_lv` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '解锁所需公会等级',
  PRIMARY KEY (`skill_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会技能';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_guild_skill`
--

LOCK TABLES `base_guild_skill` WRITE;
/*!40000 ALTER TABLE `base_guild_skill` DISABLE KEYS */;
INSERT INTO `base_guild_skill` VALUES (41000001,1,1),(41000002,1,1),(41000003,1,2),(41000004,1,2),(41000005,1,3),(41000006,1,3),(41000007,1,4),(41000008,1,4),(41000009,1,5),(41000010,1,5);
/*!40000 ALTER TABLE `base_guild_skill` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_guild_skill_research`
--

DROP TABLE IF EXISTS `base_guild_skill_research`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_guild_skill_research` (
  `skill_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能id',
  `lv` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '技能等级',
  `research_cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '研究消耗',
  `learn_cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '学习消耗',
  PRIMARY KEY (`skill_id`,`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会技能研究';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_guild_skill_research`
--

LOCK TABLES `base_guild_skill_research` WRITE;
/*!40000 ALTER TABLE `base_guild_skill_research` DISABLE KEYS */;
INSERT INTO `base_guild_skill_research` VALUES (41000001,1,'[{funds,0}]','[{guild_donate,1000}]'),(41000001,2,'[{funds,0}]','[{guild_donate,1000}]'),(41000001,3,'[{funds,0}]','[{guild_donate,1000}]'),(41000001,4,'[{funds,100}]','[{guild_donate,1110}]'),(41000001,5,'[{funds,135}]','[{guild_donate,1221}]'),(41000001,6,'[{funds,170}]','[{guild_donate,1333}]'),(41000001,7,'[{funds,205}]','[{guild_donate,1446}]'),(41000001,8,'[{funds,240}]','[{guild_donate,1560}]'),(41000001,9,'[{funds,275}]','[{guild_donate,1676}]'),(41000001,10,'[{funds,310}]','[{guild_donate,1793}]'),(41000001,11,'[{funds,345}]','[{guild_donate,1911}]'),(41000001,12,'[{funds,380}]','[{guild_donate,2030}]'),(41000001,13,'[{funds,415}]','[{guild_donate,2150}]'),(41000001,14,'[{funds,450}]','[{guild_donate,2272}]'),(41000001,15,'[{funds,485}]','[{guild_donate,2395}]'),(41000001,16,'[{funds,520}]','[{guild_donate,2519}]'),(41000001,17,'[{funds,555}]','[{guild_donate,2644}]'),(41000001,18,'[{funds,590}]','[{guild_donate,2770}]'),(41000001,19,'[{funds,625}]','[{guild_donate,2898}]'),(41000001,20,'[{funds,660}]','[{guild_donate,3027}]'),(41000001,21,'[{funds,695}]','[{guild_donate,3157}]'),(41000001,22,'[{funds,730}]','[{guild_donate,3289}]'),(41000001,23,'[{funds,765}]','[{guild_donate,3422}]'),(41000001,24,'[{funds,800}]','[{guild_donate,3556}]'),(41000001,25,'[{funds,835}]','[{guild_donate,3692}]'),(41000001,26,'[{funds,870}]','[{guild_donate,3829}]'),(41000001,27,'[{funds,905}]','[{guild_donate,3967}]'),(41000001,28,'[{funds,940}]','[{guild_donate,4107}]'),(41000001,29,'[{funds,975}]','[{guild_donate,4248}]'),(41000001,30,'[{funds,1010}]','[{guild_donate,4390}]'),(41000001,31,'[{funds,1045}]','[{guild_donate,4534}]'),(41000001,32,'[{funds,1080}]','[{guild_donate,4679}]'),(41000001,33,'[{funds,1115}]','[{guild_donate,4826}]'),(41000001,34,'[{funds,1150}]','[{guild_donate,4974}]'),(41000001,35,'[{funds,1185}]','[{guild_donate,5124}]'),(41000001,36,'[{funds,1220}]','[{guild_donate,5275}]'),(41000001,37,'[{funds,1255}]','[{guild_donate,5428}]'),(41000001,38,'[{funds,1290}]','[{guild_donate,5582}]'),(41000001,39,'[{funds,1325}]','[{guild_donate,5738}]'),(41000001,40,'[{funds,1360}]','[{guild_donate,5895}]'),(41000001,41,'[{funds,1395}]','[{guild_donate,6054}]'),(41000001,42,'[{funds,1430}]','[{guild_donate,6215}]'),(41000001,43,'[{funds,1465}]','[{guild_donate,6377}]'),(41000001,44,'[{funds,1500}]','[{guild_donate,6541}]'),(41000001,45,'[{funds,1535}]','[{guild_donate,6706}]'),(41000001,46,'[{funds,1570}]','[{guild_donate,6873}]'),(41000001,47,'[{funds,1605}]','[{guild_donate,7042}]'),(41000001,48,'[{funds,1640}]','[{guild_donate,7212}]'),(41000001,49,'[{funds,1675}]','[{guild_donate,7384}]'),(41000001,50,'[{funds,1710}]','[{guild_donate,7558}]'),(41000001,51,'[{funds,1745}]','[{guild_donate,7734}]'),(41000001,52,'[{funds,1780}]','[{guild_donate,7911}]'),(41000001,53,'[{funds,1815}]','[{guild_donate,8090}]'),(41000001,54,'[{funds,1850}]','[{guild_donate,8271}]'),(41000001,55,'[{funds,1885}]','[{guild_donate,8454}]'),(41000001,56,'[{funds,1920}]','[{guild_donate,8639}]'),(41000001,57,'[{funds,1955}]','[{guild_donate,8825}]'),(41000001,58,'[{funds,1990}]','[{guild_donate,9013}]'),(41000001,59,'[{funds,2025}]','[{guild_donate,9203}]'),(41000001,60,'[{funds,2060}]','[{guild_donate,9395}]'),(41000001,61,'[{funds,2095}]','[{guild_donate,9589}]'),(41000001,62,'[{funds,2130}]','[{guild_donate,9785}]'),(41000001,63,'[{funds,2165}]','[{guild_donate,9983}]'),(41000001,64,'[{funds,2200}]','[{guild_donate,10183}]'),(41000001,65,'[{funds,2235}]','[{guild_donate,10385}]'),(41000001,66,'[{funds,2270}]','[{guild_donate,10589}]'),(41000001,67,'[{funds,2305}]','[{guild_donate,10795}]'),(41000001,68,'[{funds,2340}]','[{guild_donate,11003}]'),(41000001,69,'[{funds,2375}]','[{guild_donate,11213}]'),(41000001,70,'[{funds,2410}]','[{guild_donate,11425}]'),(41000001,71,'[{funds,2445}]','[{guild_donate,11639}]'),(41000001,72,'[{funds,2480}]','[{guild_donate,11855}]'),(41000001,73,'[{funds,2515}]','[{guild_donate,12074}]'),(41000001,74,'[{funds,2550}]','[{guild_donate,12295}]'),(41000001,75,'[{funds,2585}]','[{guild_donate,12518}]'),(41000001,76,'[{funds,2620}]','[{guild_donate,12743}]'),(41000001,77,'[{funds,2655}]','[{guild_donate,12970}]'),(41000001,78,'[{funds,2690}]','[{guild_donate,13200}]'),(41000001,79,'[{funds,2725}]','[{guild_donate,13432}]'),(41000001,80,'[{funds,2760}]','[{guild_donate,13666}]'),(41000001,81,'[{funds,2795}]','[{guild_donate,13903}]'),(41000001,82,'[{funds,2830}]','[{guild_donate,14142}]'),(41000001,83,'[{funds,2865}]','[{guild_donate,14383}]'),(41000001,84,'[{funds,2900}]','[{guild_donate,14627}]'),(41000001,85,'[{funds,2935}]','[{guild_donate,14873}]'),(41000001,86,'[{funds,2970}]','[{guild_donate,15122}]'),(41000001,87,'[{funds,3005}]','[{guild_donate,15373}]'),(41000001,88,'[{funds,3040}]','[{guild_donate,15627}]'),(41000001,89,'[{funds,3075}]','[{guild_donate,15883}]'),(41000001,90,'[{funds,3110}]','[{guild_donate,16142}]'),(41000001,91,'[{funds,3145}]','[{guild_donate,16403}]'),(41000001,92,'[{funds,3180}]','[{guild_donate,16667}]'),(41000001,93,'[{funds,3215}]','[{guild_donate,16934}]'),(41000001,94,'[{funds,3250}]','[{guild_donate,17203}]'),(41000001,95,'[{funds,3285}]','[{guild_donate,17475}]'),(41000001,96,'[{funds,3320}]','[{guild_donate,17750}]'),(41000001,97,'[{funds,3355}]','[{guild_donate,18028}]'),(41000001,98,'[{funds,3390}]','[{guild_donate,18308}]'),(41000001,99,'[{funds,3425}]','[{guild_donate,18591}]'),(41000001,100,'[{funds,3460}]','[{guild_donate,18877}]'),(41000002,1,'[{funds,0}]','[{guild_donate,1000}]'),(41000002,2,'[{funds,0}]','[{guild_donate,1000}]'),(41000002,3,'[{funds,0}]','[{guild_donate,1000}]'),(41000002,4,'[{funds,100}]','[{guild_donate,1110}]'),(41000002,5,'[{funds,135}]','[{guild_donate,1221}]'),(41000002,6,'[{funds,170}]','[{guild_donate,1333}]'),(41000002,7,'[{funds,205}]','[{guild_donate,1446}]'),(41000002,8,'[{funds,240}]','[{guild_donate,1560}]'),(41000002,9,'[{funds,275}]','[{guild_donate,1676}]'),(41000002,10,'[{funds,310}]','[{guild_donate,1793}]'),(41000002,11,'[{funds,345}]','[{guild_donate,1911}]'),(41000002,12,'[{funds,380}]','[{guild_donate,2030}]'),(41000002,13,'[{funds,415}]','[{guild_donate,2150}]'),(41000002,14,'[{funds,450}]','[{guild_donate,2272}]'),(41000002,15,'[{funds,485}]','[{guild_donate,2395}]'),(41000002,16,'[{funds,520}]','[{guild_donate,2519}]'),(41000002,17,'[{funds,555}]','[{guild_donate,2644}]'),(41000002,18,'[{funds,590}]','[{guild_donate,2770}]'),(41000002,19,'[{funds,625}]','[{guild_donate,2898}]'),(41000002,20,'[{funds,660}]','[{guild_donate,3027}]'),(41000002,21,'[{funds,695}]','[{guild_donate,3157}]'),(41000002,22,'[{funds,730}]','[{guild_donate,3289}]'),(41000002,23,'[{funds,765}]','[{guild_donate,3422}]'),(41000002,24,'[{funds,800}]','[{guild_donate,3556}]'),(41000002,25,'[{funds,835}]','[{guild_donate,3692}]'),(41000002,26,'[{funds,870}]','[{guild_donate,3829}]'),(41000002,27,'[{funds,905}]','[{guild_donate,3967}]'),(41000002,28,'[{funds,940}]','[{guild_donate,4107}]'),(41000002,29,'[{funds,975}]','[{guild_donate,4248}]'),(41000002,30,'[{funds,1010}]','[{guild_donate,4390}]'),(41000002,31,'[{funds,1045}]','[{guild_donate,4534}]'),(41000002,32,'[{funds,1080}]','[{guild_donate,4679}]'),(41000002,33,'[{funds,1115}]','[{guild_donate,4826}]'),(41000002,34,'[{funds,1150}]','[{guild_donate,4974}]'),(41000002,35,'[{funds,1185}]','[{guild_donate,5124}]'),(41000002,36,'[{funds,1220}]','[{guild_donate,5275}]'),(41000002,37,'[{funds,1255}]','[{guild_donate,5428}]'),(41000002,38,'[{funds,1290}]','[{guild_donate,5582}]'),(41000002,39,'[{funds,1325}]','[{guild_donate,5738}]'),(41000002,40,'[{funds,1360}]','[{guild_donate,5895}]'),(41000002,41,'[{funds,1395}]','[{guild_donate,6054}]'),(41000002,42,'[{funds,1430}]','[{guild_donate,6215}]'),(41000002,43,'[{funds,1465}]','[{guild_donate,6377}]'),(41000002,44,'[{funds,1500}]','[{guild_donate,6541}]'),(41000002,45,'[{funds,1535}]','[{guild_donate,6706}]'),(41000002,46,'[{funds,1570}]','[{guild_donate,6873}]'),(41000002,47,'[{funds,1605}]','[{guild_donate,7042}]'),(41000002,48,'[{funds,1640}]','[{guild_donate,7212}]'),(41000002,49,'[{funds,1675}]','[{guild_donate,7384}]'),(41000002,50,'[{funds,1710}]','[{guild_donate,7558}]'),(41000002,51,'[{funds,1745}]','[{guild_donate,7734}]'),(41000002,52,'[{funds,1780}]','[{guild_donate,7911}]'),(41000002,53,'[{funds,1815}]','[{guild_donate,8090}]'),(41000002,54,'[{funds,1850}]','[{guild_donate,8271}]'),(41000002,55,'[{funds,1885}]','[{guild_donate,8454}]'),(41000002,56,'[{funds,1920}]','[{guild_donate,8639}]'),(41000002,57,'[{funds,1955}]','[{guild_donate,8825}]'),(41000002,58,'[{funds,1990}]','[{guild_donate,9013}]'),(41000002,59,'[{funds,2025}]','[{guild_donate,9203}]'),(41000002,60,'[{funds,2060}]','[{guild_donate,9395}]'),(41000002,61,'[{funds,2095}]','[{guild_donate,9589}]'),(41000002,62,'[{funds,2130}]','[{guild_donate,9785}]'),(41000002,63,'[{funds,2165}]','[{guild_donate,9983}]'),(41000002,64,'[{funds,2200}]','[{guild_donate,10183}]'),(41000002,65,'[{funds,2235}]','[{guild_donate,10385}]'),(41000002,66,'[{funds,2270}]','[{guild_donate,10589}]'),(41000002,67,'[{funds,2305}]','[{guild_donate,10795}]'),(41000002,68,'[{funds,2340}]','[{guild_donate,11003}]'),(41000002,69,'[{funds,2375}]','[{guild_donate,11213}]'),(41000002,70,'[{funds,2410}]','[{guild_donate,11425}]'),(41000002,71,'[{funds,2445}]','[{guild_donate,11639}]'),(41000002,72,'[{funds,2480}]','[{guild_donate,11855}]'),(41000002,73,'[{funds,2515}]','[{guild_donate,12074}]'),(41000002,74,'[{funds,2550}]','[{guild_donate,12295}]'),(41000002,75,'[{funds,2585}]','[{guild_donate,12518}]'),(41000002,76,'[{funds,2620}]','[{guild_donate,12743}]'),(41000002,77,'[{funds,2655}]','[{guild_donate,12970}]'),(41000002,78,'[{funds,2690}]','[{guild_donate,13200}]'),(41000002,79,'[{funds,2725}]','[{guild_donate,13432}]'),(41000002,80,'[{funds,2760}]','[{guild_donate,13666}]'),(41000002,81,'[{funds,2795}]','[{guild_donate,13903}]'),(41000002,82,'[{funds,2830}]','[{guild_donate,14142}]'),(41000002,83,'[{funds,2865}]','[{guild_donate,14383}]'),(41000002,84,'[{funds,2900}]','[{guild_donate,14627}]'),(41000002,85,'[{funds,2935}]','[{guild_donate,14873}]'),(41000002,86,'[{funds,2970}]','[{guild_donate,15122}]'),(41000002,87,'[{funds,3005}]','[{guild_donate,15373}]'),(41000002,88,'[{funds,3040}]','[{guild_donate,15627}]'),(41000002,89,'[{funds,3075}]','[{guild_donate,15883}]'),(41000002,90,'[{funds,3110}]','[{guild_donate,16142}]'),(41000002,91,'[{funds,3145}]','[{guild_donate,16403}]'),(41000002,92,'[{funds,3180}]','[{guild_donate,16667}]'),(41000002,93,'[{funds,3215}]','[{guild_donate,16934}]'),(41000002,94,'[{funds,3250}]','[{guild_donate,17203}]'),(41000002,95,'[{funds,3285}]','[{guild_donate,17475}]'),(41000002,96,'[{funds,3320}]','[{guild_donate,17750}]'),(41000002,97,'[{funds,3355}]','[{guild_donate,18028}]'),(41000002,98,'[{funds,3390}]','[{guild_donate,18308}]'),(41000002,99,'[{funds,3425}]','[{guild_donate,18591}]'),(41000002,100,'[{funds,3460}]','[{guild_donate,18877}]'),(41000003,1,'[{funds,0}]','[{guild_donate,1000}]'),(41000003,2,'[{funds,0}]','[{guild_donate,1000}]'),(41000003,3,'[{funds,0}]','[{guild_donate,1000}]'),(41000003,4,'[{funds,100}]','[{guild_donate,1110}]'),(41000003,5,'[{funds,135}]','[{guild_donate,1221}]'),(41000003,6,'[{funds,170}]','[{guild_donate,1333}]'),(41000003,7,'[{funds,205}]','[{guild_donate,1446}]'),(41000003,8,'[{funds,240}]','[{guild_donate,1560}]'),(41000003,9,'[{funds,275}]','[{guild_donate,1676}]'),(41000003,10,'[{funds,310}]','[{guild_donate,1793}]'),(41000003,11,'[{funds,345}]','[{guild_donate,1911}]'),(41000003,12,'[{funds,380}]','[{guild_donate,2030}]'),(41000003,13,'[{funds,415}]','[{guild_donate,2150}]'),(41000003,14,'[{funds,450}]','[{guild_donate,2272}]'),(41000003,15,'[{funds,485}]','[{guild_donate,2395}]'),(41000003,16,'[{funds,520}]','[{guild_donate,2519}]'),(41000003,17,'[{funds,555}]','[{guild_donate,2644}]'),(41000003,18,'[{funds,590}]','[{guild_donate,2770}]'),(41000003,19,'[{funds,625}]','[{guild_donate,2898}]'),(41000003,20,'[{funds,660}]','[{guild_donate,3027}]'),(41000003,21,'[{funds,695}]','[{guild_donate,3157}]'),(41000003,22,'[{funds,730}]','[{guild_donate,3289}]'),(41000003,23,'[{funds,765}]','[{guild_donate,3422}]'),(41000003,24,'[{funds,800}]','[{guild_donate,3556}]'),(41000003,25,'[{funds,835}]','[{guild_donate,3692}]'),(41000003,26,'[{funds,870}]','[{guild_donate,3829}]'),(41000003,27,'[{funds,905}]','[{guild_donate,3967}]'),(41000003,28,'[{funds,940}]','[{guild_donate,4107}]'),(41000003,29,'[{funds,975}]','[{guild_donate,4248}]'),(41000003,30,'[{funds,1010}]','[{guild_donate,4390}]'),(41000003,31,'[{funds,1045}]','[{guild_donate,4534}]'),(41000003,32,'[{funds,1080}]','[{guild_donate,4679}]'),(41000003,33,'[{funds,1115}]','[{guild_donate,4826}]'),(41000003,34,'[{funds,1150}]','[{guild_donate,4974}]'),(41000003,35,'[{funds,1185}]','[{guild_donate,5124}]'),(41000003,36,'[{funds,1220}]','[{guild_donate,5275}]'),(41000003,37,'[{funds,1255}]','[{guild_donate,5428}]'),(41000003,38,'[{funds,1290}]','[{guild_donate,5582}]'),(41000003,39,'[{funds,1325}]','[{guild_donate,5738}]'),(41000003,40,'[{funds,1360}]','[{guild_donate,5895}]'),(41000003,41,'[{funds,1395}]','[{guild_donate,6054}]'),(41000003,42,'[{funds,1430}]','[{guild_donate,6215}]'),(41000003,43,'[{funds,1465}]','[{guild_donate,6377}]'),(41000003,44,'[{funds,1500}]','[{guild_donate,6541}]'),(41000003,45,'[{funds,1535}]','[{guild_donate,6706}]'),(41000003,46,'[{funds,1570}]','[{guild_donate,6873}]'),(41000003,47,'[{funds,1605}]','[{guild_donate,7042}]'),(41000003,48,'[{funds,1640}]','[{guild_donate,7212}]'),(41000003,49,'[{funds,1675}]','[{guild_donate,7384}]'),(41000003,50,'[{funds,1710}]','[{guild_donate,7558}]'),(41000003,51,'[{funds,1745}]','[{guild_donate,7734}]'),(41000003,52,'[{funds,1780}]','[{guild_donate,7911}]'),(41000003,53,'[{funds,1815}]','[{guild_donate,8090}]'),(41000003,54,'[{funds,1850}]','[{guild_donate,8271}]'),(41000003,55,'[{funds,1885}]','[{guild_donate,8454}]'),(41000003,56,'[{funds,1920}]','[{guild_donate,8639}]'),(41000003,57,'[{funds,1955}]','[{guild_donate,8825}]'),(41000003,58,'[{funds,1990}]','[{guild_donate,9013}]'),(41000003,59,'[{funds,2025}]','[{guild_donate,9203}]'),(41000003,60,'[{funds,2060}]','[{guild_donate,9395}]'),(41000003,61,'[{funds,2095}]','[{guild_donate,9589}]'),(41000003,62,'[{funds,2130}]','[{guild_donate,9785}]'),(41000003,63,'[{funds,2165}]','[{guild_donate,9983}]'),(41000003,64,'[{funds,2200}]','[{guild_donate,10183}]'),(41000003,65,'[{funds,2235}]','[{guild_donate,10385}]'),(41000003,66,'[{funds,2270}]','[{guild_donate,10589}]'),(41000003,67,'[{funds,2305}]','[{guild_donate,10795}]'),(41000003,68,'[{funds,2340}]','[{guild_donate,11003}]'),(41000003,69,'[{funds,2375}]','[{guild_donate,11213}]'),(41000003,70,'[{funds,2410}]','[{guild_donate,11425}]'),(41000003,71,'[{funds,2445}]','[{guild_donate,11639}]'),(41000003,72,'[{funds,2480}]','[{guild_donate,11855}]'),(41000003,73,'[{funds,2515}]','[{guild_donate,12074}]'),(41000003,74,'[{funds,2550}]','[{guild_donate,12295}]'),(41000003,75,'[{funds,2585}]','[{guild_donate,12518}]'),(41000003,76,'[{funds,2620}]','[{guild_donate,12743}]'),(41000003,77,'[{funds,2655}]','[{guild_donate,12970}]'),(41000003,78,'[{funds,2690}]','[{guild_donate,13200}]'),(41000003,79,'[{funds,2725}]','[{guild_donate,13432}]'),(41000003,80,'[{funds,2760}]','[{guild_donate,13666}]'),(41000003,81,'[{funds,2795}]','[{guild_donate,13903}]'),(41000003,82,'[{funds,2830}]','[{guild_donate,14142}]'),(41000003,83,'[{funds,2865}]','[{guild_donate,14383}]'),(41000003,84,'[{funds,2900}]','[{guild_donate,14627}]'),(41000003,85,'[{funds,2935}]','[{guild_donate,14873}]'),(41000003,86,'[{funds,2970}]','[{guild_donate,15122}]'),(41000003,87,'[{funds,3005}]','[{guild_donate,15373}]'),(41000003,88,'[{funds,3040}]','[{guild_donate,15627}]'),(41000003,89,'[{funds,3075}]','[{guild_donate,15883}]'),(41000003,90,'[{funds,3110}]','[{guild_donate,16142}]'),(41000003,91,'[{funds,3145}]','[{guild_donate,16403}]'),(41000003,92,'[{funds,3180}]','[{guild_donate,16667}]'),(41000003,93,'[{funds,3215}]','[{guild_donate,16934}]'),(41000003,94,'[{funds,3250}]','[{guild_donate,17203}]'),(41000003,95,'[{funds,3285}]','[{guild_donate,17475}]'),(41000003,96,'[{funds,3320}]','[{guild_donate,17750}]'),(41000003,97,'[{funds,3355}]','[{guild_donate,18028}]'),(41000003,98,'[{funds,3390}]','[{guild_donate,18308}]'),(41000003,99,'[{funds,3425}]','[{guild_donate,18591}]'),(41000003,100,'[{funds,3460}]','[{guild_donate,18877}]'),(41000004,1,'[{funds,0}]','[{guild_donate,1000}]'),(41000004,2,'[{funds,0}]','[{guild_donate,1000}]'),(41000004,3,'[{funds,0}]','[{guild_donate,1000}]'),(41000004,4,'[{funds,100}]','[{guild_donate,1110}]'),(41000004,5,'[{funds,135}]','[{guild_donate,1221}]'),(41000004,6,'[{funds,170}]','[{guild_donate,1333}]'),(41000004,7,'[{funds,205}]','[{guild_donate,1446}]'),(41000004,8,'[{funds,240}]','[{guild_donate,1560}]'),(41000004,9,'[{funds,275}]','[{guild_donate,1676}]'),(41000004,10,'[{funds,310}]','[{guild_donate,1793}]'),(41000004,11,'[{funds,345}]','[{guild_donate,1911}]'),(41000004,12,'[{funds,380}]','[{guild_donate,2030}]'),(41000004,13,'[{funds,415}]','[{guild_donate,2150}]'),(41000004,14,'[{funds,450}]','[{guild_donate,2272}]'),(41000004,15,'[{funds,485}]','[{guild_donate,2395}]'),(41000004,16,'[{funds,520}]','[{guild_donate,2519}]'),(41000004,17,'[{funds,555}]','[{guild_donate,2644}]'),(41000004,18,'[{funds,590}]','[{guild_donate,2770}]'),(41000004,19,'[{funds,625}]','[{guild_donate,2898}]'),(41000004,20,'[{funds,660}]','[{guild_donate,3027}]'),(41000004,21,'[{funds,695}]','[{guild_donate,3157}]'),(41000004,22,'[{funds,730}]','[{guild_donate,3289}]'),(41000004,23,'[{funds,765}]','[{guild_donate,3422}]'),(41000004,24,'[{funds,800}]','[{guild_donate,3556}]'),(41000004,25,'[{funds,835}]','[{guild_donate,3692}]'),(41000004,26,'[{funds,870}]','[{guild_donate,3829}]'),(41000004,27,'[{funds,905}]','[{guild_donate,3967}]'),(41000004,28,'[{funds,940}]','[{guild_donate,4107}]'),(41000004,29,'[{funds,975}]','[{guild_donate,4248}]'),(41000004,30,'[{funds,1010}]','[{guild_donate,4390}]'),(41000004,31,'[{funds,1045}]','[{guild_donate,4534}]'),(41000004,32,'[{funds,1080}]','[{guild_donate,4679}]'),(41000004,33,'[{funds,1115}]','[{guild_donate,4826}]'),(41000004,34,'[{funds,1150}]','[{guild_donate,4974}]'),(41000004,35,'[{funds,1185}]','[{guild_donate,5124}]'),(41000004,36,'[{funds,1220}]','[{guild_donate,5275}]'),(41000004,37,'[{funds,1255}]','[{guild_donate,5428}]'),(41000004,38,'[{funds,1290}]','[{guild_donate,5582}]'),(41000004,39,'[{funds,1325}]','[{guild_donate,5738}]'),(41000004,40,'[{funds,1360}]','[{guild_donate,5895}]'),(41000004,41,'[{funds,1395}]','[{guild_donate,6054}]'),(41000004,42,'[{funds,1430}]','[{guild_donate,6215}]'),(41000004,43,'[{funds,1465}]','[{guild_donate,6377}]'),(41000004,44,'[{funds,1500}]','[{guild_donate,6541}]'),(41000004,45,'[{funds,1535}]','[{guild_donate,6706}]'),(41000004,46,'[{funds,1570}]','[{guild_donate,6873}]'),(41000004,47,'[{funds,1605}]','[{guild_donate,7042}]'),(41000004,48,'[{funds,1640}]','[{guild_donate,7212}]'),(41000004,49,'[{funds,1675}]','[{guild_donate,7384}]'),(41000004,50,'[{funds,1710}]','[{guild_donate,7558}]'),(41000004,51,'[{funds,1745}]','[{guild_donate,7734}]'),(41000004,52,'[{funds,1780}]','[{guild_donate,7911}]'),(41000004,53,'[{funds,1815}]','[{guild_donate,8090}]'),(41000004,54,'[{funds,1850}]','[{guild_donate,8271}]'),(41000004,55,'[{funds,1885}]','[{guild_donate,8454}]'),(41000004,56,'[{funds,1920}]','[{guild_donate,8639}]'),(41000004,57,'[{funds,1955}]','[{guild_donate,8825}]'),(41000004,58,'[{funds,1990}]','[{guild_donate,9013}]'),(41000004,59,'[{funds,2025}]','[{guild_donate,9203}]'),(41000004,60,'[{funds,2060}]','[{guild_donate,9395}]'),(41000004,61,'[{funds,2095}]','[{guild_donate,9589}]'),(41000004,62,'[{funds,2130}]','[{guild_donate,9785}]'),(41000004,63,'[{funds,2165}]','[{guild_donate,9983}]'),(41000004,64,'[{funds,2200}]','[{guild_donate,10183}]'),(41000004,65,'[{funds,2235}]','[{guild_donate,10385}]'),(41000004,66,'[{funds,2270}]','[{guild_donate,10589}]'),(41000004,67,'[{funds,2305}]','[{guild_donate,10795}]'),(41000004,68,'[{funds,2340}]','[{guild_donate,11003}]'),(41000004,69,'[{funds,2375}]','[{guild_donate,11213}]'),(41000004,70,'[{funds,2410}]','[{guild_donate,11425}]'),(41000004,71,'[{funds,2445}]','[{guild_donate,11639}]'),(41000004,72,'[{funds,2480}]','[{guild_donate,11855}]'),(41000004,73,'[{funds,2515}]','[{guild_donate,12074}]'),(41000004,74,'[{funds,2550}]','[{guild_donate,12295}]'),(41000004,75,'[{funds,2585}]','[{guild_donate,12518}]'),(41000004,76,'[{funds,2620}]','[{guild_donate,12743}]'),(41000004,77,'[{funds,2655}]','[{guild_donate,12970}]'),(41000004,78,'[{funds,2690}]','[{guild_donate,13200}]'),(41000004,79,'[{funds,2725}]','[{guild_donate,13432}]'),(41000004,80,'[{funds,2760}]','[{guild_donate,13666}]'),(41000004,81,'[{funds,2795}]','[{guild_donate,13903}]'),(41000004,82,'[{funds,2830}]','[{guild_donate,14142}]'),(41000004,83,'[{funds,2865}]','[{guild_donate,14383}]'),(41000004,84,'[{funds,2900}]','[{guild_donate,14627}]'),(41000004,85,'[{funds,2935}]','[{guild_donate,14873}]'),(41000004,86,'[{funds,2970}]','[{guild_donate,15122}]'),(41000004,87,'[{funds,3005}]','[{guild_donate,15373}]'),(41000004,88,'[{funds,3040}]','[{guild_donate,15627}]'),(41000004,89,'[{funds,3075}]','[{guild_donate,15883}]'),(41000004,90,'[{funds,3110}]','[{guild_donate,16142}]'),(41000004,91,'[{funds,3145}]','[{guild_donate,16403}]'),(41000004,92,'[{funds,3180}]','[{guild_donate,16667}]'),(41000004,93,'[{funds,3215}]','[{guild_donate,16934}]'),(41000004,94,'[{funds,3250}]','[{guild_donate,17203}]'),(41000004,95,'[{funds,3285}]','[{guild_donate,17475}]'),(41000004,96,'[{funds,3320}]','[{guild_donate,17750}]'),(41000004,97,'[{funds,3355}]','[{guild_donate,18028}]'),(41000004,98,'[{funds,3390}]','[{guild_donate,18308}]'),(41000004,99,'[{funds,3425}]','[{guild_donate,18591}]'),(41000004,100,'[{funds,3460}]','[{guild_donate,18877}]'),(41000005,1,'[{funds,0}]','[{guild_donate,1000}]'),(41000005,2,'[{funds,0}]','[{guild_donate,1000}]'),(41000005,3,'[{funds,0}]','[{guild_donate,1000}]'),(41000005,4,'[{funds,100}]','[{guild_donate,1110}]'),(41000005,5,'[{funds,135}]','[{guild_donate,1221}]'),(41000005,6,'[{funds,170}]','[{guild_donate,1333}]'),(41000005,7,'[{funds,205}]','[{guild_donate,1446}]'),(41000005,8,'[{funds,240}]','[{guild_donate,1560}]'),(41000005,9,'[{funds,275}]','[{guild_donate,1676}]'),(41000005,10,'[{funds,310}]','[{guild_donate,1793}]'),(41000005,11,'[{funds,345}]','[{guild_donate,1911}]'),(41000005,12,'[{funds,380}]','[{guild_donate,2030}]'),(41000005,13,'[{funds,415}]','[{guild_donate,2150}]'),(41000005,14,'[{funds,450}]','[{guild_donate,2272}]'),(41000005,15,'[{funds,485}]','[{guild_donate,2395}]'),(41000005,16,'[{funds,520}]','[{guild_donate,2519}]'),(41000005,17,'[{funds,555}]','[{guild_donate,2644}]'),(41000005,18,'[{funds,590}]','[{guild_donate,2770}]'),(41000005,19,'[{funds,625}]','[{guild_donate,2898}]'),(41000005,20,'[{funds,660}]','[{guild_donate,3027}]'),(41000005,21,'[{funds,695}]','[{guild_donate,3157}]'),(41000005,22,'[{funds,730}]','[{guild_donate,3289}]'),(41000005,23,'[{funds,765}]','[{guild_donate,3422}]'),(41000005,24,'[{funds,800}]','[{guild_donate,3556}]'),(41000005,25,'[{funds,835}]','[{guild_donate,3692}]'),(41000005,26,'[{funds,870}]','[{guild_donate,3829}]'),(41000005,27,'[{funds,905}]','[{guild_donate,3967}]'),(41000005,28,'[{funds,940}]','[{guild_donate,4107}]'),(41000005,29,'[{funds,975}]','[{guild_donate,4248}]'),(41000005,30,'[{funds,1010}]','[{guild_donate,4390}]'),(41000005,31,'[{funds,1045}]','[{guild_donate,4534}]'),(41000005,32,'[{funds,1080}]','[{guild_donate,4679}]'),(41000005,33,'[{funds,1115}]','[{guild_donate,4826}]'),(41000005,34,'[{funds,1150}]','[{guild_donate,4974}]'),(41000005,35,'[{funds,1185}]','[{guild_donate,5124}]'),(41000005,36,'[{funds,1220}]','[{guild_donate,5275}]'),(41000005,37,'[{funds,1255}]','[{guild_donate,5428}]'),(41000005,38,'[{funds,1290}]','[{guild_donate,5582}]'),(41000005,39,'[{funds,1325}]','[{guild_donate,5738}]'),(41000005,40,'[{funds,1360}]','[{guild_donate,5895}]'),(41000005,41,'[{funds,1395}]','[{guild_donate,6054}]'),(41000005,42,'[{funds,1430}]','[{guild_donate,6215}]'),(41000005,43,'[{funds,1465}]','[{guild_donate,6377}]'),(41000005,44,'[{funds,1500}]','[{guild_donate,6541}]'),(41000005,45,'[{funds,1535}]','[{guild_donate,6706}]'),(41000005,46,'[{funds,1570}]','[{guild_donate,6873}]'),(41000005,47,'[{funds,1605}]','[{guild_donate,7042}]'),(41000005,48,'[{funds,1640}]','[{guild_donate,7212}]'),(41000005,49,'[{funds,1675}]','[{guild_donate,7384}]'),(41000005,50,'[{funds,1710}]','[{guild_donate,7558}]'),(41000005,51,'[{funds,1745}]','[{guild_donate,7734}]'),(41000005,52,'[{funds,1780}]','[{guild_donate,7911}]'),(41000005,53,'[{funds,1815}]','[{guild_donate,8090}]'),(41000005,54,'[{funds,1850}]','[{guild_donate,8271}]'),(41000005,55,'[{funds,1885}]','[{guild_donate,8454}]'),(41000005,56,'[{funds,1920}]','[{guild_donate,8639}]'),(41000005,57,'[{funds,1955}]','[{guild_donate,8825}]'),(41000005,58,'[{funds,1990}]','[{guild_donate,9013}]'),(41000005,59,'[{funds,2025}]','[{guild_donate,9203}]'),(41000005,60,'[{funds,2060}]','[{guild_donate,9395}]'),(41000005,61,'[{funds,2095}]','[{guild_donate,9589}]'),(41000005,62,'[{funds,2130}]','[{guild_donate,9785}]'),(41000005,63,'[{funds,2165}]','[{guild_donate,9983}]'),(41000005,64,'[{funds,2200}]','[{guild_donate,10183}]'),(41000005,65,'[{funds,2235}]','[{guild_donate,10385}]'),(41000005,66,'[{funds,2270}]','[{guild_donate,10589}]'),(41000005,67,'[{funds,2305}]','[{guild_donate,10795}]'),(41000005,68,'[{funds,2340}]','[{guild_donate,11003}]'),(41000005,69,'[{funds,2375}]','[{guild_donate,11213}]'),(41000005,70,'[{funds,2410}]','[{guild_donate,11425}]'),(41000005,71,'[{funds,2445}]','[{guild_donate,11639}]'),(41000005,72,'[{funds,2480}]','[{guild_donate,11855}]'),(41000005,73,'[{funds,2515}]','[{guild_donate,12074}]'),(41000005,74,'[{funds,2550}]','[{guild_donate,12295}]'),(41000005,75,'[{funds,2585}]','[{guild_donate,12518}]'),(41000005,76,'[{funds,2620}]','[{guild_donate,12743}]'),(41000005,77,'[{funds,2655}]','[{guild_donate,12970}]'),(41000005,78,'[{funds,2690}]','[{guild_donate,13200}]'),(41000005,79,'[{funds,2725}]','[{guild_donate,13432}]'),(41000005,80,'[{funds,2760}]','[{guild_donate,13666}]'),(41000005,81,'[{funds,2795}]','[{guild_donate,13903}]'),(41000005,82,'[{funds,2830}]','[{guild_donate,14142}]'),(41000005,83,'[{funds,2865}]','[{guild_donate,14383}]'),(41000005,84,'[{funds,2900}]','[{guild_donate,14627}]'),(41000005,85,'[{funds,2935}]','[{guild_donate,14873}]'),(41000005,86,'[{funds,2970}]','[{guild_donate,15122}]'),(41000005,87,'[{funds,3005}]','[{guild_donate,15373}]'),(41000005,88,'[{funds,3040}]','[{guild_donate,15627}]'),(41000005,89,'[{funds,3075}]','[{guild_donate,15883}]'),(41000005,90,'[{funds,3110}]','[{guild_donate,16142}]'),(41000005,91,'[{funds,3145}]','[{guild_donate,16403}]'),(41000005,92,'[{funds,3180}]','[{guild_donate,16667}]'),(41000005,93,'[{funds,3215}]','[{guild_donate,16934}]'),(41000005,94,'[{funds,3250}]','[{guild_donate,17203}]'),(41000005,95,'[{funds,3285}]','[{guild_donate,17475}]'),(41000005,96,'[{funds,3320}]','[{guild_donate,17750}]'),(41000005,97,'[{funds,3355}]','[{guild_donate,18028}]'),(41000005,98,'[{funds,3390}]','[{guild_donate,18308}]'),(41000005,99,'[{funds,3425}]','[{guild_donate,18591}]'),(41000005,100,'[{funds,3460}]','[{guild_donate,18877}]'),(41000006,1,'[{funds,0}]','[{guild_donate,1000}]'),(41000006,2,'[{funds,0}]','[{guild_donate,1000}]'),(41000006,3,'[{funds,0}]','[{guild_donate,1000}]'),(41000006,4,'[{funds,100}]','[{guild_donate,1110}]'),(41000006,5,'[{funds,135}]','[{guild_donate,1221}]'),(41000006,6,'[{funds,170}]','[{guild_donate,1333}]'),(41000006,7,'[{funds,205}]','[{guild_donate,1446}]'),(41000006,8,'[{funds,240}]','[{guild_donate,1560}]'),(41000006,9,'[{funds,275}]','[{guild_donate,1676}]'),(41000006,10,'[{funds,310}]','[{guild_donate,1793}]'),(41000006,11,'[{funds,345}]','[{guild_donate,1911}]'),(41000006,12,'[{funds,380}]','[{guild_donate,2030}]'),(41000006,13,'[{funds,415}]','[{guild_donate,2150}]'),(41000006,14,'[{funds,450}]','[{guild_donate,2272}]'),(41000006,15,'[{funds,485}]','[{guild_donate,2395}]'),(41000006,16,'[{funds,520}]','[{guild_donate,2519}]'),(41000006,17,'[{funds,555}]','[{guild_donate,2644}]'),(41000006,18,'[{funds,590}]','[{guild_donate,2770}]'),(41000006,19,'[{funds,625}]','[{guild_donate,2898}]'),(41000006,20,'[{funds,660}]','[{guild_donate,3027}]'),(41000006,21,'[{funds,695}]','[{guild_donate,3157}]'),(41000006,22,'[{funds,730}]','[{guild_donate,3289}]'),(41000006,23,'[{funds,765}]','[{guild_donate,3422}]'),(41000006,24,'[{funds,800}]','[{guild_donate,3556}]'),(41000006,25,'[{funds,835}]','[{guild_donate,3692}]'),(41000006,26,'[{funds,870}]','[{guild_donate,3829}]'),(41000006,27,'[{funds,905}]','[{guild_donate,3967}]'),(41000006,28,'[{funds,940}]','[{guild_donate,4107}]'),(41000006,29,'[{funds,975}]','[{guild_donate,4248}]'),(41000006,30,'[{funds,1010}]','[{guild_donate,4390}]'),(41000006,31,'[{funds,1045}]','[{guild_donate,4534}]'),(41000006,32,'[{funds,1080}]','[{guild_donate,4679}]'),(41000006,33,'[{funds,1115}]','[{guild_donate,4826}]'),(41000006,34,'[{funds,1150}]','[{guild_donate,4974}]'),(41000006,35,'[{funds,1185}]','[{guild_donate,5124}]'),(41000006,36,'[{funds,1220}]','[{guild_donate,5275}]'),(41000006,37,'[{funds,1255}]','[{guild_donate,5428}]'),(41000006,38,'[{funds,1290}]','[{guild_donate,5582}]'),(41000006,39,'[{funds,1325}]','[{guild_donate,5738}]'),(41000006,40,'[{funds,1360}]','[{guild_donate,5895}]'),(41000006,41,'[{funds,1395}]','[{guild_donate,6054}]'),(41000006,42,'[{funds,1430}]','[{guild_donate,6215}]'),(41000006,43,'[{funds,1465}]','[{guild_donate,6377}]'),(41000006,44,'[{funds,1500}]','[{guild_donate,6541}]'),(41000006,45,'[{funds,1535}]','[{guild_donate,6706}]'),(41000006,46,'[{funds,1570}]','[{guild_donate,6873}]'),(41000006,47,'[{funds,1605}]','[{guild_donate,7042}]'),(41000006,48,'[{funds,1640}]','[{guild_donate,7212}]'),(41000006,49,'[{funds,1675}]','[{guild_donate,7384}]'),(41000006,50,'[{funds,1710}]','[{guild_donate,7558}]'),(41000006,51,'[{funds,1745}]','[{guild_donate,7734}]'),(41000006,52,'[{funds,1780}]','[{guild_donate,7911}]'),(41000006,53,'[{funds,1815}]','[{guild_donate,8090}]'),(41000006,54,'[{funds,1850}]','[{guild_donate,8271}]'),(41000006,55,'[{funds,1885}]','[{guild_donate,8454}]'),(41000006,56,'[{funds,1920}]','[{guild_donate,8639}]'),(41000006,57,'[{funds,1955}]','[{guild_donate,8825}]'),(41000006,58,'[{funds,1990}]','[{guild_donate,9013}]'),(41000006,59,'[{funds,2025}]','[{guild_donate,9203}]'),(41000006,60,'[{funds,2060}]','[{guild_donate,9395}]'),(41000006,61,'[{funds,2095}]','[{guild_donate,9589}]'),(41000006,62,'[{funds,2130}]','[{guild_donate,9785}]'),(41000006,63,'[{funds,2165}]','[{guild_donate,9983}]'),(41000006,64,'[{funds,2200}]','[{guild_donate,10183}]'),(41000006,65,'[{funds,2235}]','[{guild_donate,10385}]'),(41000006,66,'[{funds,2270}]','[{guild_donate,10589}]'),(41000006,67,'[{funds,2305}]','[{guild_donate,10795}]'),(41000006,68,'[{funds,2340}]','[{guild_donate,11003}]'),(41000006,69,'[{funds,2375}]','[{guild_donate,11213}]'),(41000006,70,'[{funds,2410}]','[{guild_donate,11425}]'),(41000006,71,'[{funds,2445}]','[{guild_donate,11639}]'),(41000006,72,'[{funds,2480}]','[{guild_donate,11855}]'),(41000006,73,'[{funds,2515}]','[{guild_donate,12074}]'),(41000006,74,'[{funds,2550}]','[{guild_donate,12295}]'),(41000006,75,'[{funds,2585}]','[{guild_donate,12518}]'),(41000006,76,'[{funds,2620}]','[{guild_donate,12743}]'),(41000006,77,'[{funds,2655}]','[{guild_donate,12970}]'),(41000006,78,'[{funds,2690}]','[{guild_donate,13200}]'),(41000006,79,'[{funds,2725}]','[{guild_donate,13432}]'),(41000006,80,'[{funds,2760}]','[{guild_donate,13666}]'),(41000006,81,'[{funds,2795}]','[{guild_donate,13903}]'),(41000006,82,'[{funds,2830}]','[{guild_donate,14142}]'),(41000006,83,'[{funds,2865}]','[{guild_donate,14383}]'),(41000006,84,'[{funds,2900}]','[{guild_donate,14627}]'),(41000006,85,'[{funds,2935}]','[{guild_donate,14873}]'),(41000006,86,'[{funds,2970}]','[{guild_donate,15122}]'),(41000006,87,'[{funds,3005}]','[{guild_donate,15373}]'),(41000006,88,'[{funds,3040}]','[{guild_donate,15627}]'),(41000006,89,'[{funds,3075}]','[{guild_donate,15883}]'),(41000006,90,'[{funds,3110}]','[{guild_donate,16142}]'),(41000006,91,'[{funds,3145}]','[{guild_donate,16403}]'),(41000006,92,'[{funds,3180}]','[{guild_donate,16667}]'),(41000006,93,'[{funds,3215}]','[{guild_donate,16934}]'),(41000006,94,'[{funds,3250}]','[{guild_donate,17203}]'),(41000006,95,'[{funds,3285}]','[{guild_donate,17475}]'),(41000006,96,'[{funds,3320}]','[{guild_donate,17750}]'),(41000006,97,'[{funds,3355}]','[{guild_donate,18028}]'),(41000006,98,'[{funds,3390}]','[{guild_donate,18308}]'),(41000006,99,'[{funds,3425}]','[{guild_donate,18591}]'),(41000006,100,'[{funds,3460}]','[{guild_donate,18877}]'),(41000007,1,'[{funds,0}]','[{guild_donate,1000}]'),(41000007,2,'[{funds,0}]','[{guild_donate,1000}]'),(41000007,3,'[{funds,0}]','[{guild_donate,1000}]'),(41000007,4,'[{funds,100}]','[{guild_donate,1110}]'),(41000007,5,'[{funds,135}]','[{guild_donate,1221}]'),(41000007,6,'[{funds,170}]','[{guild_donate,1333}]'),(41000007,7,'[{funds,205}]','[{guild_donate,1446}]'),(41000007,8,'[{funds,240}]','[{guild_donate,1560}]'),(41000007,9,'[{funds,275}]','[{guild_donate,1676}]'),(41000007,10,'[{funds,310}]','[{guild_donate,1793}]'),(41000007,11,'[{funds,345}]','[{guild_donate,1911}]'),(41000007,12,'[{funds,380}]','[{guild_donate,2030}]'),(41000007,13,'[{funds,415}]','[{guild_donate,2150}]'),(41000007,14,'[{funds,450}]','[{guild_donate,2272}]'),(41000007,15,'[{funds,485}]','[{guild_donate,2395}]'),(41000007,16,'[{funds,520}]','[{guild_donate,2519}]'),(41000007,17,'[{funds,555}]','[{guild_donate,2644}]'),(41000007,18,'[{funds,590}]','[{guild_donate,2770}]'),(41000007,19,'[{funds,625}]','[{guild_donate,2898}]'),(41000007,20,'[{funds,660}]','[{guild_donate,3027}]'),(41000007,21,'[{funds,695}]','[{guild_donate,3157}]'),(41000007,22,'[{funds,730}]','[{guild_donate,3289}]'),(41000007,23,'[{funds,765}]','[{guild_donate,3422}]'),(41000007,24,'[{funds,800}]','[{guild_donate,3556}]'),(41000007,25,'[{funds,835}]','[{guild_donate,3692}]'),(41000007,26,'[{funds,870}]','[{guild_donate,3829}]'),(41000007,27,'[{funds,905}]','[{guild_donate,3967}]'),(41000007,28,'[{funds,940}]','[{guild_donate,4107}]'),(41000007,29,'[{funds,975}]','[{guild_donate,4248}]'),(41000007,30,'[{funds,1010}]','[{guild_donate,4390}]'),(41000007,31,'[{funds,1045}]','[{guild_donate,4534}]'),(41000007,32,'[{funds,1080}]','[{guild_donate,4679}]'),(41000007,33,'[{funds,1115}]','[{guild_donate,4826}]'),(41000007,34,'[{funds,1150}]','[{guild_donate,4974}]'),(41000007,35,'[{funds,1185}]','[{guild_donate,5124}]'),(41000007,36,'[{funds,1220}]','[{guild_donate,5275}]'),(41000007,37,'[{funds,1255}]','[{guild_donate,5428}]'),(41000007,38,'[{funds,1290}]','[{guild_donate,5582}]'),(41000007,39,'[{funds,1325}]','[{guild_donate,5738}]'),(41000007,40,'[{funds,1360}]','[{guild_donate,5895}]'),(41000007,41,'[{funds,1395}]','[{guild_donate,6054}]'),(41000007,42,'[{funds,1430}]','[{guild_donate,6215}]'),(41000007,43,'[{funds,1465}]','[{guild_donate,6377}]'),(41000007,44,'[{funds,1500}]','[{guild_donate,6541}]'),(41000007,45,'[{funds,1535}]','[{guild_donate,6706}]'),(41000007,46,'[{funds,1570}]','[{guild_donate,6873}]'),(41000007,47,'[{funds,1605}]','[{guild_donate,7042}]'),(41000007,48,'[{funds,1640}]','[{guild_donate,7212}]'),(41000007,49,'[{funds,1675}]','[{guild_donate,7384}]'),(41000007,50,'[{funds,1710}]','[{guild_donate,7558}]'),(41000007,51,'[{funds,1745}]','[{guild_donate,7734}]'),(41000007,52,'[{funds,1780}]','[{guild_donate,7911}]'),(41000007,53,'[{funds,1815}]','[{guild_donate,8090}]'),(41000007,54,'[{funds,1850}]','[{guild_donate,8271}]'),(41000007,55,'[{funds,1885}]','[{guild_donate,8454}]'),(41000007,56,'[{funds,1920}]','[{guild_donate,8639}]'),(41000007,57,'[{funds,1955}]','[{guild_donate,8825}]'),(41000007,58,'[{funds,1990}]','[{guild_donate,9013}]'),(41000007,59,'[{funds,2025}]','[{guild_donate,9203}]'),(41000007,60,'[{funds,2060}]','[{guild_donate,9395}]'),(41000007,61,'[{funds,2095}]','[{guild_donate,9589}]'),(41000007,62,'[{funds,2130}]','[{guild_donate,9785}]'),(41000007,63,'[{funds,2165}]','[{guild_donate,9983}]'),(41000007,64,'[{funds,2200}]','[{guild_donate,10183}]'),(41000007,65,'[{funds,2235}]','[{guild_donate,10385}]'),(41000007,66,'[{funds,2270}]','[{guild_donate,10589}]'),(41000007,67,'[{funds,2305}]','[{guild_donate,10795}]'),(41000007,68,'[{funds,2340}]','[{guild_donate,11003}]'),(41000007,69,'[{funds,2375}]','[{guild_donate,11213}]'),(41000007,70,'[{funds,2410}]','[{guild_donate,11425}]'),(41000007,71,'[{funds,2445}]','[{guild_donate,11639}]'),(41000007,72,'[{funds,2480}]','[{guild_donate,11855}]'),(41000007,73,'[{funds,2515}]','[{guild_donate,12074}]'),(41000007,74,'[{funds,2550}]','[{guild_donate,12295}]'),(41000007,75,'[{funds,2585}]','[{guild_donate,12518}]'),(41000007,76,'[{funds,2620}]','[{guild_donate,12743}]'),(41000007,77,'[{funds,2655}]','[{guild_donate,12970}]'),(41000007,78,'[{funds,2690}]','[{guild_donate,13200}]'),(41000007,79,'[{funds,2725}]','[{guild_donate,13432}]'),(41000007,80,'[{funds,2760}]','[{guild_donate,13666}]'),(41000007,81,'[{funds,2795}]','[{guild_donate,13903}]'),(41000007,82,'[{funds,2830}]','[{guild_donate,14142}]'),(41000007,83,'[{funds,2865}]','[{guild_donate,14383}]'),(41000007,84,'[{funds,2900}]','[{guild_donate,14627}]'),(41000007,85,'[{funds,2935}]','[{guild_donate,14873}]'),(41000007,86,'[{funds,2970}]','[{guild_donate,15122}]'),(41000007,87,'[{funds,3005}]','[{guild_donate,15373}]'),(41000007,88,'[{funds,3040}]','[{guild_donate,15627}]'),(41000007,89,'[{funds,3075}]','[{guild_donate,15883}]'),(41000007,90,'[{funds,3110}]','[{guild_donate,16142}]'),(41000007,91,'[{funds,3145}]','[{guild_donate,16403}]'),(41000007,92,'[{funds,3180}]','[{guild_donate,16667}]'),(41000007,93,'[{funds,3215}]','[{guild_donate,16934}]'),(41000007,94,'[{funds,3250}]','[{guild_donate,17203}]'),(41000007,95,'[{funds,3285}]','[{guild_donate,17475}]'),(41000007,96,'[{funds,3320}]','[{guild_donate,17750}]'),(41000007,97,'[{funds,3355}]','[{guild_donate,18028}]'),(41000007,98,'[{funds,3390}]','[{guild_donate,18308}]'),(41000007,99,'[{funds,3425}]','[{guild_donate,18591}]'),(41000007,100,'[{funds,3460}]','[{guild_donate,18877}]'),(41000008,1,'[{funds,0}]','[{guild_donate,1000}]'),(41000008,2,'[{funds,0}]','[{guild_donate,1000}]'),(41000008,3,'[{funds,0}]','[{guild_donate,1000}]'),(41000008,4,'[{funds,100}]','[{guild_donate,1110}]'),(41000008,5,'[{funds,135}]','[{guild_donate,1221}]'),(41000008,6,'[{funds,170}]','[{guild_donate,1333}]'),(41000008,7,'[{funds,205}]','[{guild_donate,1446}]'),(41000008,8,'[{funds,240}]','[{guild_donate,1560}]'),(41000008,9,'[{funds,275}]','[{guild_donate,1676}]'),(41000008,10,'[{funds,310}]','[{guild_donate,1793}]'),(41000008,11,'[{funds,345}]','[{guild_donate,1911}]'),(41000008,12,'[{funds,380}]','[{guild_donate,2030}]'),(41000008,13,'[{funds,415}]','[{guild_donate,2150}]'),(41000008,14,'[{funds,450}]','[{guild_donate,2272}]'),(41000008,15,'[{funds,485}]','[{guild_donate,2395}]'),(41000008,16,'[{funds,520}]','[{guild_donate,2519}]'),(41000008,17,'[{funds,555}]','[{guild_donate,2644}]'),(41000008,18,'[{funds,590}]','[{guild_donate,2770}]'),(41000008,19,'[{funds,625}]','[{guild_donate,2898}]'),(41000008,20,'[{funds,660}]','[{guild_donate,3027}]'),(41000008,21,'[{funds,695}]','[{guild_donate,3157}]'),(41000008,22,'[{funds,730}]','[{guild_donate,3289}]'),(41000008,23,'[{funds,765}]','[{guild_donate,3422}]'),(41000008,24,'[{funds,800}]','[{guild_donate,3556}]'),(41000008,25,'[{funds,835}]','[{guild_donate,3692}]'),(41000008,26,'[{funds,870}]','[{guild_donate,3829}]'),(41000008,27,'[{funds,905}]','[{guild_donate,3967}]'),(41000008,28,'[{funds,940}]','[{guild_donate,4107}]'),(41000008,29,'[{funds,975}]','[{guild_donate,4248}]'),(41000008,30,'[{funds,1010}]','[{guild_donate,4390}]'),(41000008,31,'[{funds,1045}]','[{guild_donate,4534}]'),(41000008,32,'[{funds,1080}]','[{guild_donate,4679}]'),(41000008,33,'[{funds,1115}]','[{guild_donate,4826}]'),(41000008,34,'[{funds,1150}]','[{guild_donate,4974}]'),(41000008,35,'[{funds,1185}]','[{guild_donate,5124}]'),(41000008,36,'[{funds,1220}]','[{guild_donate,5275}]'),(41000008,37,'[{funds,1255}]','[{guild_donate,5428}]'),(41000008,38,'[{funds,1290}]','[{guild_donate,5582}]'),(41000008,39,'[{funds,1325}]','[{guild_donate,5738}]'),(41000008,40,'[{funds,1360}]','[{guild_donate,5895}]'),(41000008,41,'[{funds,1395}]','[{guild_donate,6054}]'),(41000008,42,'[{funds,1430}]','[{guild_donate,6215}]'),(41000008,43,'[{funds,1465}]','[{guild_donate,6377}]'),(41000008,44,'[{funds,1500}]','[{guild_donate,6541}]'),(41000008,45,'[{funds,1535}]','[{guild_donate,6706}]'),(41000008,46,'[{funds,1570}]','[{guild_donate,6873}]'),(41000008,47,'[{funds,1605}]','[{guild_donate,7042}]'),(41000008,48,'[{funds,1640}]','[{guild_donate,7212}]'),(41000008,49,'[{funds,1675}]','[{guild_donate,7384}]'),(41000008,50,'[{funds,1710}]','[{guild_donate,7558}]'),(41000008,51,'[{funds,1745}]','[{guild_donate,7734}]'),(41000008,52,'[{funds,1780}]','[{guild_donate,7911}]'),(41000008,53,'[{funds,1815}]','[{guild_donate,8090}]'),(41000008,54,'[{funds,1850}]','[{guild_donate,8271}]'),(41000008,55,'[{funds,1885}]','[{guild_donate,8454}]'),(41000008,56,'[{funds,1920}]','[{guild_donate,8639}]'),(41000008,57,'[{funds,1955}]','[{guild_donate,8825}]'),(41000008,58,'[{funds,1990}]','[{guild_donate,9013}]'),(41000008,59,'[{funds,2025}]','[{guild_donate,9203}]'),(41000008,60,'[{funds,2060}]','[{guild_donate,9395}]'),(41000008,61,'[{funds,2095}]','[{guild_donate,9589}]'),(41000008,62,'[{funds,2130}]','[{guild_donate,9785}]'),(41000008,63,'[{funds,2165}]','[{guild_donate,9983}]'),(41000008,64,'[{funds,2200}]','[{guild_donate,10183}]'),(41000008,65,'[{funds,2235}]','[{guild_donate,10385}]'),(41000008,66,'[{funds,2270}]','[{guild_donate,10589}]'),(41000008,67,'[{funds,2305}]','[{guild_donate,10795}]'),(41000008,68,'[{funds,2340}]','[{guild_donate,11003}]'),(41000008,69,'[{funds,2375}]','[{guild_donate,11213}]'),(41000008,70,'[{funds,2410}]','[{guild_donate,11425}]'),(41000008,71,'[{funds,2445}]','[{guild_donate,11639}]'),(41000008,72,'[{funds,2480}]','[{guild_donate,11855}]'),(41000008,73,'[{funds,2515}]','[{guild_donate,12074}]'),(41000008,74,'[{funds,2550}]','[{guild_donate,12295}]'),(41000008,75,'[{funds,2585}]','[{guild_donate,12518}]'),(41000008,76,'[{funds,2620}]','[{guild_donate,12743}]'),(41000008,77,'[{funds,2655}]','[{guild_donate,12970}]'),(41000008,78,'[{funds,2690}]','[{guild_donate,13200}]'),(41000008,79,'[{funds,2725}]','[{guild_donate,13432}]'),(41000008,80,'[{funds,2760}]','[{guild_donate,13666}]'),(41000008,81,'[{funds,2795}]','[{guild_donate,13903}]'),(41000008,82,'[{funds,2830}]','[{guild_donate,14142}]'),(41000008,83,'[{funds,2865}]','[{guild_donate,14383}]'),(41000008,84,'[{funds,2900}]','[{guild_donate,14627}]'),(41000008,85,'[{funds,2935}]','[{guild_donate,14873}]'),(41000008,86,'[{funds,2970}]','[{guild_donate,15122}]'),(41000008,87,'[{funds,3005}]','[{guild_donate,15373}]'),(41000008,88,'[{funds,3040}]','[{guild_donate,15627}]'),(41000008,89,'[{funds,3075}]','[{guild_donate,15883}]'),(41000008,90,'[{funds,3110}]','[{guild_donate,16142}]'),(41000008,91,'[{funds,3145}]','[{guild_donate,16403}]'),(41000008,92,'[{funds,3180}]','[{guild_donate,16667}]'),(41000008,93,'[{funds,3215}]','[{guild_donate,16934}]'),(41000008,94,'[{funds,3250}]','[{guild_donate,17203}]'),(41000008,95,'[{funds,3285}]','[{guild_donate,17475}]'),(41000008,96,'[{funds,3320}]','[{guild_donate,17750}]'),(41000008,97,'[{funds,3355}]','[{guild_donate,18028}]'),(41000008,98,'[{funds,3390}]','[{guild_donate,18308}]'),(41000008,99,'[{funds,3425}]','[{guild_donate,18591}]'),(41000008,100,'[{funds,3460}]','[{guild_donate,18877}]'),(41000009,1,'[{funds,0}]','[{guild_donate,1000}]'),(41000009,2,'[{funds,0}]','[{guild_donate,1000}]'),(41000009,3,'[{funds,0}]','[{guild_donate,1000}]'),(41000009,4,'[{funds,100}]','[{guild_donate,1110}]'),(41000009,5,'[{funds,135}]','[{guild_donate,1221}]'),(41000009,6,'[{funds,170}]','[{guild_donate,1333}]'),(41000009,7,'[{funds,205}]','[{guild_donate,1446}]'),(41000009,8,'[{funds,240}]','[{guild_donate,1560}]'),(41000009,9,'[{funds,275}]','[{guild_donate,1676}]'),(41000009,10,'[{funds,310}]','[{guild_donate,1793}]'),(41000009,11,'[{funds,345}]','[{guild_donate,1911}]'),(41000009,12,'[{funds,380}]','[{guild_donate,2030}]'),(41000009,13,'[{funds,415}]','[{guild_donate,2150}]'),(41000009,14,'[{funds,450}]','[{guild_donate,2272}]'),(41000009,15,'[{funds,485}]','[{guild_donate,2395}]'),(41000009,16,'[{funds,520}]','[{guild_donate,2519}]'),(41000009,17,'[{funds,555}]','[{guild_donate,2644}]'),(41000009,18,'[{funds,590}]','[{guild_donate,2770}]'),(41000009,19,'[{funds,625}]','[{guild_donate,2898}]'),(41000009,20,'[{funds,660}]','[{guild_donate,3027}]'),(41000009,21,'[{funds,695}]','[{guild_donate,3157}]'),(41000009,22,'[{funds,730}]','[{guild_donate,3289}]'),(41000009,23,'[{funds,765}]','[{guild_donate,3422}]'),(41000009,24,'[{funds,800}]','[{guild_donate,3556}]'),(41000009,25,'[{funds,835}]','[{guild_donate,3692}]'),(41000009,26,'[{funds,870}]','[{guild_donate,3829}]'),(41000009,27,'[{funds,905}]','[{guild_donate,3967}]'),(41000009,28,'[{funds,940}]','[{guild_donate,4107}]'),(41000009,29,'[{funds,975}]','[{guild_donate,4248}]'),(41000009,30,'[{funds,1010}]','[{guild_donate,4390}]'),(41000009,31,'[{funds,1045}]','[{guild_donate,4534}]'),(41000009,32,'[{funds,1080}]','[{guild_donate,4679}]'),(41000009,33,'[{funds,1115}]','[{guild_donate,4826}]'),(41000009,34,'[{funds,1150}]','[{guild_donate,4974}]'),(41000009,35,'[{funds,1185}]','[{guild_donate,5124}]'),(41000009,36,'[{funds,1220}]','[{guild_donate,5275}]'),(41000009,37,'[{funds,1255}]','[{guild_donate,5428}]'),(41000009,38,'[{funds,1290}]','[{guild_donate,5582}]'),(41000009,39,'[{funds,1325}]','[{guild_donate,5738}]'),(41000009,40,'[{funds,1360}]','[{guild_donate,5895}]'),(41000009,41,'[{funds,1395}]','[{guild_donate,6054}]'),(41000009,42,'[{funds,1430}]','[{guild_donate,6215}]'),(41000009,43,'[{funds,1465}]','[{guild_donate,6377}]'),(41000009,44,'[{funds,1500}]','[{guild_donate,6541}]'),(41000009,45,'[{funds,1535}]','[{guild_donate,6706}]'),(41000009,46,'[{funds,1570}]','[{guild_donate,6873}]'),(41000009,47,'[{funds,1605}]','[{guild_donate,7042}]'),(41000009,48,'[{funds,1640}]','[{guild_donate,7212}]'),(41000009,49,'[{funds,1675}]','[{guild_donate,7384}]'),(41000009,50,'[{funds,1710}]','[{guild_donate,7558}]'),(41000009,51,'[{funds,1745}]','[{guild_donate,7734}]'),(41000009,52,'[{funds,1780}]','[{guild_donate,7911}]'),(41000009,53,'[{funds,1815}]','[{guild_donate,8090}]'),(41000009,54,'[{funds,1850}]','[{guild_donate,8271}]'),(41000009,55,'[{funds,1885}]','[{guild_donate,8454}]'),(41000009,56,'[{funds,1920}]','[{guild_donate,8639}]'),(41000009,57,'[{funds,1955}]','[{guild_donate,8825}]'),(41000009,58,'[{funds,1990}]','[{guild_donate,9013}]'),(41000009,59,'[{funds,2025}]','[{guild_donate,9203}]'),(41000009,60,'[{funds,2060}]','[{guild_donate,9395}]'),(41000009,61,'[{funds,2095}]','[{guild_donate,9589}]'),(41000009,62,'[{funds,2130}]','[{guild_donate,9785}]'),(41000009,63,'[{funds,2165}]','[{guild_donate,9983}]'),(41000009,64,'[{funds,2200}]','[{guild_donate,10183}]'),(41000009,65,'[{funds,2235}]','[{guild_donate,10385}]'),(41000009,66,'[{funds,2270}]','[{guild_donate,10589}]'),(41000009,67,'[{funds,2305}]','[{guild_donate,10795}]'),(41000009,68,'[{funds,2340}]','[{guild_donate,11003}]'),(41000009,69,'[{funds,2375}]','[{guild_donate,11213}]'),(41000009,70,'[{funds,2410}]','[{guild_donate,11425}]'),(41000009,71,'[{funds,2445}]','[{guild_donate,11639}]'),(41000009,72,'[{funds,2480}]','[{guild_donate,11855}]'),(41000009,73,'[{funds,2515}]','[{guild_donate,12074}]'),(41000009,74,'[{funds,2550}]','[{guild_donate,12295}]'),(41000009,75,'[{funds,2585}]','[{guild_donate,12518}]'),(41000009,76,'[{funds,2620}]','[{guild_donate,12743}]'),(41000009,77,'[{funds,2655}]','[{guild_donate,12970}]'),(41000009,78,'[{funds,2690}]','[{guild_donate,13200}]'),(41000009,79,'[{funds,2725}]','[{guild_donate,13432}]'),(41000009,80,'[{funds,2760}]','[{guild_donate,13666}]'),(41000009,81,'[{funds,2795}]','[{guild_donate,13903}]'),(41000009,82,'[{funds,2830}]','[{guild_donate,14142}]'),(41000009,83,'[{funds,2865}]','[{guild_donate,14383}]'),(41000009,84,'[{funds,2900}]','[{guild_donate,14627}]'),(41000009,85,'[{funds,2935}]','[{guild_donate,14873}]'),(41000009,86,'[{funds,2970}]','[{guild_donate,15122}]'),(41000009,87,'[{funds,3005}]','[{guild_donate,15373}]'),(41000009,88,'[{funds,3040}]','[{guild_donate,15627}]'),(41000009,89,'[{funds,3075}]','[{guild_donate,15883}]'),(41000009,90,'[{funds,3110}]','[{guild_donate,16142}]'),(41000009,91,'[{funds,3145}]','[{guild_donate,16403}]'),(41000009,92,'[{funds,3180}]','[{guild_donate,16667}]'),(41000009,93,'[{funds,3215}]','[{guild_donate,16934}]'),(41000009,94,'[{funds,3250}]','[{guild_donate,17203}]'),(41000009,95,'[{funds,3285}]','[{guild_donate,17475}]'),(41000009,96,'[{funds,3320}]','[{guild_donate,17750}]'),(41000009,97,'[{funds,3355}]','[{guild_donate,18028}]'),(41000009,98,'[{funds,3390}]','[{guild_donate,18308}]'),(41000009,99,'[{funds,3425}]','[{guild_donate,18591}]'),(41000009,100,'[{funds,3460}]','[{guild_donate,18877}]'),(41000010,1,'[{funds,0}]','[{guild_donate,1000}]'),(41000010,2,'[{funds,0}]','[{guild_donate,1000}]'),(41000010,3,'[{funds,0}]','[{guild_donate,1000}]'),(41000010,4,'[{funds,100}]','[{guild_donate,1110}]'),(41000010,5,'[{funds,135}]','[{guild_donate,1221}]'),(41000010,6,'[{funds,170}]','[{guild_donate,1333}]'),(41000010,7,'[{funds,205}]','[{guild_donate,1446}]'),(41000010,8,'[{funds,240}]','[{guild_donate,1560}]'),(41000010,9,'[{funds,275}]','[{guild_donate,1676}]'),(41000010,10,'[{funds,310}]','[{guild_donate,1793}]'),(41000010,11,'[{funds,345}]','[{guild_donate,1911}]'),(41000010,12,'[{funds,380}]','[{guild_donate,2030}]'),(41000010,13,'[{funds,415}]','[{guild_donate,2150}]'),(41000010,14,'[{funds,450}]','[{guild_donate,2272}]'),(41000010,15,'[{funds,485}]','[{guild_donate,2395}]'),(41000010,16,'[{funds,520}]','[{guild_donate,2519}]'),(41000010,17,'[{funds,555}]','[{guild_donate,2644}]'),(41000010,18,'[{funds,590}]','[{guild_donate,2770}]'),(41000010,19,'[{funds,625}]','[{guild_donate,2898}]'),(41000010,20,'[{funds,660}]','[{guild_donate,3027}]'),(41000010,21,'[{funds,695}]','[{guild_donate,3157}]'),(41000010,22,'[{funds,730}]','[{guild_donate,3289}]'),(41000010,23,'[{funds,765}]','[{guild_donate,3422}]'),(41000010,24,'[{funds,800}]','[{guild_donate,3556}]'),(41000010,25,'[{funds,835}]','[{guild_donate,3692}]'),(41000010,26,'[{funds,870}]','[{guild_donate,3829}]'),(41000010,27,'[{funds,905}]','[{guild_donate,3967}]'),(41000010,28,'[{funds,940}]','[{guild_donate,4107}]'),(41000010,29,'[{funds,975}]','[{guild_donate,4248}]'),(41000010,30,'[{funds,1010}]','[{guild_donate,4390}]'),(41000010,31,'[{funds,1045}]','[{guild_donate,4534}]'),(41000010,32,'[{funds,1080}]','[{guild_donate,4679}]'),(41000010,33,'[{funds,1115}]','[{guild_donate,4826}]'),(41000010,34,'[{funds,1150}]','[{guild_donate,4974}]'),(41000010,35,'[{funds,1185}]','[{guild_donate,5124}]'),(41000010,36,'[{funds,1220}]','[{guild_donate,5275}]'),(41000010,37,'[{funds,1255}]','[{guild_donate,5428}]'),(41000010,38,'[{funds,1290}]','[{guild_donate,5582}]'),(41000010,39,'[{funds,1325}]','[{guild_donate,5738}]'),(41000010,40,'[{funds,1360}]','[{guild_donate,5895}]'),(41000010,41,'[{funds,1395}]','[{guild_donate,6054}]'),(41000010,42,'[{funds,1430}]','[{guild_donate,6215}]'),(41000010,43,'[{funds,1465}]','[{guild_donate,6377}]'),(41000010,44,'[{funds,1500}]','[{guild_donate,6541}]'),(41000010,45,'[{funds,1535}]','[{guild_donate,6706}]'),(41000010,46,'[{funds,1570}]','[{guild_donate,6873}]'),(41000010,47,'[{funds,1605}]','[{guild_donate,7042}]'),(41000010,48,'[{funds,1640}]','[{guild_donate,7212}]'),(41000010,49,'[{funds,1675}]','[{guild_donate,7384}]'),(41000010,50,'[{funds,1710}]','[{guild_donate,7558}]'),(41000010,51,'[{funds,1745}]','[{guild_donate,7734}]'),(41000010,52,'[{funds,1780}]','[{guild_donate,7911}]'),(41000010,53,'[{funds,1815}]','[{guild_donate,8090}]'),(41000010,54,'[{funds,1850}]','[{guild_donate,8271}]'),(41000010,55,'[{funds,1885}]','[{guild_donate,8454}]'),(41000010,56,'[{funds,1920}]','[{guild_donate,8639}]'),(41000010,57,'[{funds,1955}]','[{guild_donate,8825}]'),(41000010,58,'[{funds,1990}]','[{guild_donate,9013}]'),(41000010,59,'[{funds,2025}]','[{guild_donate,9203}]'),(41000010,60,'[{funds,2060}]','[{guild_donate,9395}]'),(41000010,61,'[{funds,2095}]','[{guild_donate,9589}]'),(41000010,62,'[{funds,2130}]','[{guild_donate,9785}]'),(41000010,63,'[{funds,2165}]','[{guild_donate,9983}]'),(41000010,64,'[{funds,2200}]','[{guild_donate,10183}]'),(41000010,65,'[{funds,2235}]','[{guild_donate,10385}]'),(41000010,66,'[{funds,2270}]','[{guild_donate,10589}]'),(41000010,67,'[{funds,2305}]','[{guild_donate,10795}]'),(41000010,68,'[{funds,2340}]','[{guild_donate,11003}]'),(41000010,69,'[{funds,2375}]','[{guild_donate,11213}]'),(41000010,70,'[{funds,2410}]','[{guild_donate,11425}]'),(41000010,71,'[{funds,2445}]','[{guild_donate,11639}]'),(41000010,72,'[{funds,2480}]','[{guild_donate,11855}]'),(41000010,73,'[{funds,2515}]','[{guild_donate,12074}]'),(41000010,74,'[{funds,2550}]','[{guild_donate,12295}]'),(41000010,75,'[{funds,2585}]','[{guild_donate,12518}]'),(41000010,76,'[{funds,2620}]','[{guild_donate,12743}]'),(41000010,77,'[{funds,2655}]','[{guild_donate,12970}]'),(41000010,78,'[{funds,2690}]','[{guild_donate,13200}]'),(41000010,79,'[{funds,2725}]','[{guild_donate,13432}]'),(41000010,80,'[{funds,2760}]','[{guild_donate,13666}]'),(41000010,81,'[{funds,2795}]','[{guild_donate,13903}]'),(41000010,82,'[{funds,2830}]','[{guild_donate,14142}]'),(41000010,83,'[{funds,2865}]','[{guild_donate,14383}]'),(41000010,84,'[{funds,2900}]','[{guild_donate,14627}]'),(41000010,85,'[{funds,2935}]','[{guild_donate,14873}]'),(41000010,86,'[{funds,2970}]','[{guild_donate,15122}]'),(41000010,87,'[{funds,3005}]','[{guild_donate,15373}]'),(41000010,88,'[{funds,3040}]','[{guild_donate,15627}]'),(41000010,89,'[{funds,3075}]','[{guild_donate,15883}]'),(41000010,90,'[{funds,3110}]','[{guild_donate,16142}]'),(41000010,91,'[{funds,3145}]','[{guild_donate,16403}]'),(41000010,92,'[{funds,3180}]','[{guild_donate,16667}]'),(41000010,93,'[{funds,3215}]','[{guild_donate,16934}]'),(41000010,94,'[{funds,3250}]','[{guild_donate,17203}]'),(41000010,95,'[{funds,3285}]','[{guild_donate,17475}]'),(41000010,96,'[{funds,3320}]','[{guild_donate,17750}]'),(41000010,97,'[{funds,3355}]','[{guild_donate,18028}]'),(41000010,98,'[{funds,3390}]','[{guild_donate,18308}]'),(41000010,99,'[{funds,3425}]','[{guild_donate,18591}]'),(41000010,100,'[{funds,3460}]','[{guild_donate,18877}]');
/*!40000 ALTER TABLE `base_guild_skill_research` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_guild_war`
--

DROP TABLE IF EXISTS `base_guild_war`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_guild_war` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `key` varchar(255) NOT NULL DEFAULT '' COMMENT 'key',
  `value` varchar(255) NOT NULL DEFAULT '0' COMMENT '值',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '描述@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会争霸常量配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_guild_war`
--

LOCK TABLES `base_guild_war` WRITE;
/*!40000 ALTER TABLE `base_guild_war` DISABLE KEYS */;
INSERT INTO `base_guild_war` VALUES (1,'opday_lim','8','开服天数限制'),(2,'merge_day_lim','6','合服天数限制，合服之后需要多少天之后活动才会正常开启'),(3,'open_time','{20,30,0}','开始时间，格式：{时,分,秒}'),(5,'confirm_time','{0,0,0}','各赛区信息确认时间，格式：{时,分,秒}'),(6,'battle_time','1200','每场战斗时间，单位：秒'),(7,'total_rounds','1','每次活动打几场战斗'),(8,'rest_time','5','中场休息时间，单位：秒'),(9,'scene_id','4063','公会争霸场景id'),(10,'need_role_lv','150','需要玩家等级'),(11,'forbid_pk_time','10','每场战斗开始后多少秒内玩家禁止攻击'),(12,'revive_max_time','5','复活价格最大叠加次数'),(13,'max_rank_list','30','排行榜最大显示数量'),(14,'timing_refresh','10','定时刷新分数时间，单位：秒'),(15,'revive_cost','5','单次复活所需绑钻'),(16,'boss_revive_time','60','boss刷新时间'),(17,'score_to_dominate','2','1积分等于多少贡献'),(18,'min_join_guild_time','3600','参加活动需要加入公会大于多少时间，单位：秒'),(19,'gwar_salary_paul','[{0,37020001,1},{4,0,8000}]','公会争霸主宰公会俸禄'),(20,'min_create_guild_time','0','参加活动需要创建公会大于多少时间，单位：秒'),(21,'dominator_buff','42030001','主宰公会会长buff，填物品ID'),(22,'dominator_designation','4906004','主宰公会会长称号，填称号id'),(23,'gwar_morale_buff','42030002','公会争霸士气buff'),(25,'resources_plus_by_kill_player','0','击杀玩家增加的资源'),(26,'special_open_day','[3,7]','特殊开启时间,开服第几天开启'),(27,'role_num_lim','30','公会争霸单阵营人数限制'),(28,'type_mon_out_build','40610001','防御外塔怪物id'),(29,'type_mon_inner_build','40610002','防御内塔怪物id'),(30,'type_mon_base_build','40610003','基地怪物id'),(31,'type_mon_boss','40610004','boss怪物id'),(32,'first_designation','4906003','公会争霸第一名成员称号'),(33,'second_designation','4906002','第二名成员称号'),(34,'third_designation','4906001','第三名成员称号'),(35,'out_build_buff','800','外塔提供的免伤buff（万分值）'),(36,'inner_build_buff','1200','内塔提供的免伤buff(万分值)'),(37,'blunt_att_build_hurt','0.0075','冲车攻击塔血量百分比'),(39,'blunt_be_hurt','0.004','冲车每次被攻击受伤百分比'),(40,'camion_be_hurt','0.008','炮车每次受伤百分比'),(41,'camion_hurt_other_car','0.2','炮车打其他车的伤害'),(42,'out_build_hurt_player','0.08','外塔攻击玩家百分比伤害'),(43,'inner_build_hurt_player','0.1','内塔攻击玩家百分比伤害'),(44,'base_build_hurt_player','0.12','基地攻击玩家百分比伤害'),(45,'do_not_re_hp_buff_id','2100006','禁止血量回复的buff_id'),(46,'open_day','[{{8,13},[3,7]},{{14,99999}, [7]}]','[{{8,13},[3,7]}]开服8到18天，每周3和周日开启'),(47,'merge_day','[{{8,13},[3,7]},{{14,99999}, [7]}]','[{{8,13},[3,7]}]合服8到18天，每周3和周日开启');
/*!40000 ALTER TABLE `base_guild_war` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_guild_war_break_reward`
--

DROP TABLE IF EXISTS `base_guild_war_break_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_guild_war_break_reward` (
  `min_wlv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '世界等级下限',
  `max_wlv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '世界等级上限',
  `streak_times` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '连胜次数',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`min_wlv`,`max_wlv`,`streak_times`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会争霸终结连胜奖励配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_guild_war_break_reward`
--

LOCK TABLES `base_guild_war_break_reward` WRITE;
/*!40000 ALTER TABLE `base_guild_war_break_reward` DISABLE KEYS */;
INSERT INTO `base_guild_war_break_reward` VALUES (1,200,1,'[{0,32080542,1}]'),(1,200,2,'[{0,32080542,1}]'),(1,200,3,'[{0,32080542,1}]'),(1,200,4,'[{0,32080542,1}]'),(1,200,5,'[{0,32080542,1}]'),(1,200,6,'[{0,32080542,1}]'),(1,200,7,'[{0,32080542,1}]'),(1,200,8,'[{0,32080542,1}]'),(1,200,9,'[{0,32080542,1}]'),(1,200,10,'[{0,32080542,1}]'),(1,200,11,'[{0,32080542,1}]'),(1,200,12,'[{0,32080542,1}]'),(1,200,13,'[{0,32080542,1}]'),(1,200,14,'[{0,32080542,1}]'),(1,200,15,'[{0,32080542,1}]'),(1,200,16,'[{0,32080542,1}]'),(1,200,17,'[{0,32080542,1}]'),(1,200,18,'[{0,32080542,1}]'),(1,200,19,'[{0,32080542,1}]'),(1,200,20,'[{0,32080542,1}]'),(1,200,21,'[{0,32080542,2}]'),(1,200,22,'[{0,32080542,2}]'),(1,200,23,'[{0,32080542,2}]'),(1,200,24,'[{0,32080542,2}]'),(1,200,25,'[{0,32080542,2}]'),(1,200,26,'[{0,32080542,2}]'),(1,200,27,'[{0,32080542,2}]'),(1,200,28,'[{0,32080542,2}]'),(1,200,29,'[{0,32080542,2}]'),(1,200,30,'[{0,32080542,2}]'),(1,200,31,'[{0,32080542,2}]'),(1,200,32,'[{0,32080542,2}]'),(1,200,33,'[{0,32080542,2}]'),(1,200,34,'[{0,32080542,2}]'),(1,200,35,'[{0,32080542,2}]'),(1,200,36,'[{0,32080542,2}]'),(1,200,37,'[{0,32080542,2}]'),(1,200,38,'[{0,32080542,2}]'),(1,200,39,'[{0,32080542,2}]'),(1,200,40,'[{0,32080542,2}]'),(1,200,41,'[{0,32080542,2}]'),(1,200,42,'[{0,32080542,2}]'),(1,200,43,'[{0,32080542,2}]'),(1,200,44,'[{0,32080542,2}]'),(1,200,45,'[{0,32080542,2}]'),(1,200,46,'[{0,32080542,2}]'),(1,200,47,'[{0,32080542,2}]'),(1,200,48,'[{0,32080542,2}]'),(1,200,49,'[{0,32080542,2}]'),(1,200,50,'[{0,32080542,2}]'),(1,200,51,'[{0,32080542,2}]'),(1,200,52,'[{0,32080542,2}]'),(1,200,53,'[{0,32080542,2}]'),(1,200,54,'[{0,32080542,2}]'),(1,200,55,'[{0,32080542,2}]'),(1,200,56,'[{0,32080542,2}]'),(1,200,57,'[{0,32080542,2}]'),(1,200,58,'[{0,32080542,2}]'),(1,200,59,'[{0,32080542,2}]'),(1,200,60,'[{0,32080542,2}]'),(1,200,61,'[{0,32080542,2}]'),(1,200,62,'[{0,32080542,2}]'),(1,200,63,'[{0,32080542,2}]'),(1,200,64,'[{0,32080542,2}]'),(1,200,65,'[{0,32080542,2}]'),(1,200,66,'[{0,32080542,2}]'),(1,200,67,'[{0,32080542,2}]'),(1,200,68,'[{0,32080542,2}]'),(1,200,69,'[{0,32080542,2}]'),(1,200,70,'[{0,32080542,2}]'),(1,200,71,'[{0,32080542,2}]'),(1,200,72,'[{0,32080542,2}]'),(1,200,73,'[{0,32080542,2}]'),(1,200,74,'[{0,32080542,2}]'),(1,200,75,'[{0,32080542,2}]'),(1,200,76,'[{0,32080542,2}]'),(1,200,77,'[{0,32080542,2}]'),(1,200,78,'[{0,32080542,2}]'),(1,200,79,'[{0,32080542,2}]'),(1,200,80,'[{0,32080542,2}]'),(1,200,81,'[{0,32080542,2}]'),(1,200,82,'[{0,32080542,2}]'),(1,200,83,'[{0,32080542,2}]'),(1,200,84,'[{0,32080542,2}]'),(1,200,85,'[{0,32080542,2}]'),(1,200,86,'[{0,32080542,2}]'),(1,200,87,'[{0,32080542,2}]'),(1,200,88,'[{0,32080542,2}]'),(1,200,89,'[{0,32080542,2}]'),(1,200,90,'[{0,32080542,2}]'),(1,200,91,'[{0,32080542,2}]'),(1,200,92,'[{0,32080542,2}]'),(1,200,93,'[{0,32080542,2}]'),(1,200,94,'[{0,32080542,2}]'),(1,200,95,'[{0,32080542,2}]'),(1,200,96,'[{0,32080542,2}]'),(1,200,97,'[{0,32080542,2}]'),(1,200,98,'[{0,32080542,2}]'),(1,200,99,'[{0,32080542,2}]'),(1,200,100,'[{0,32080542,2}]'),(1,200,101,'[{0,32080542,2}]'),(1,200,102,'[{0,32080542,2}]'),(1,200,103,'[{0,32080542,2}]'),(1,200,104,'[{0,32080542,2}]'),(1,200,105,'[{0,32080542,2}]'),(1,200,106,'[{0,32080542,2}]'),(1,200,107,'[{0,32080542,2}]'),(1,200,108,'[{0,32080542,2}]'),(1,200,109,'[{0,32080542,2}]'),(1,200,110,'[{0,32080542,2}]'),(1,200,111,'[{0,32080542,2}]'),(1,200,112,'[{0,32080542,2}]'),(1,200,113,'[{0,32080542,2}]'),(1,200,114,'[{0,32080542,2}]'),(1,200,115,'[{0,32080542,2}]'),(1,200,116,'[{0,32080542,2}]'),(1,200,117,'[{0,32080542,2}]'),(1,200,118,'[{0,32080542,2}]'),(1,200,119,'[{0,32080542,2}]'),(1,200,120,'[{0,32080542,2}]'),(1,200,121,'[{0,32080542,2}]'),(1,200,122,'[{0,32080542,2}]'),(1,200,123,'[{0,32080542,2}]'),(1,200,124,'[{0,32080542,2}]'),(1,200,125,'[{0,32080542,2}]'),(1,200,126,'[{0,32080542,2}]'),(1,200,127,'[{0,32080542,2}]'),(1,200,128,'[{0,32080542,2}]'),(1,200,129,'[{0,32080542,2}]'),(1,200,130,'[{0,32080542,2}]'),(1,200,131,'[{0,32080542,2}]'),(1,200,132,'[{0,32080542,2}]'),(1,200,133,'[{0,32080542,2}]'),(1,200,134,'[{0,32080542,2}]'),(1,200,135,'[{0,32080542,2}]'),(1,200,136,'[{0,32080542,2}]'),(1,200,137,'[{0,32080542,2}]'),(1,200,138,'[{0,32080542,2}]'),(1,200,139,'[{0,32080542,2}]'),(1,200,140,'[{0,32080542,2}]'),(1,200,141,'[{0,32080542,2}]'),(1,200,142,'[{0,32080542,2}]'),(1,200,143,'[{0,32080542,2}]'),(1,200,144,'[{0,32080542,2}]'),(1,200,145,'[{0,32080542,2}]'),(1,200,146,'[{0,32080542,2}]'),(1,200,147,'[{0,32080542,2}]'),(1,200,148,'[{0,32080542,2}]'),(1,200,149,'[{0,32080542,2}]'),(1,200,150,'[{0,32080542,2}]'),(1,200,151,'[{0,32080542,2}]'),(1,200,152,'[{0,32080542,2}]'),(1,200,153,'[{0,32080542,2}]'),(1,200,154,'[{0,32080542,2}]'),(1,200,155,'[{0,32080542,2}]'),(1,200,156,'[{0,32080542,2}]'),(1,200,157,'[{0,32080542,2}]'),(1,200,158,'[{0,32080542,2}]'),(1,200,159,'[{0,32080542,2}]'),(1,200,160,'[{0,32080542,2}]'),(1,200,161,'[{0,32080542,2}]'),(1,200,162,'[{0,32080542,2}]'),(1,200,163,'[{0,32080542,2}]'),(1,200,164,'[{0,32080542,2}]'),(1,200,165,'[{0,32080542,2}]'),(1,200,166,'[{0,32080542,2}]'),(1,200,167,'[{0,32080542,2}]'),(1,200,168,'[{0,32080542,2}]'),(1,200,169,'[{0,32080542,2}]'),(1,200,170,'[{0,32080542,2}]'),(1,200,171,'[{0,32080542,2}]'),(1,200,172,'[{0,32080542,2}]'),(1,200,173,'[{0,32080542,2}]'),(1,200,174,'[{0,32080542,2}]'),(1,200,175,'[{0,32080542,2}]'),(1,200,176,'[{0,32080542,2}]'),(1,200,177,'[{0,32080542,2}]'),(1,200,178,'[{0,32080542,2}]'),(1,200,179,'[{0,32080542,2}]'),(1,200,180,'[{0,32080542,2}]'),(1,200,181,'[{0,32080542,2}]'),(1,200,182,'[{0,32080542,2}]'),(1,200,183,'[{0,32080542,2}]'),(1,200,184,'[{0,32080542,2}]'),(1,200,185,'[{0,32080542,2}]'),(1,200,186,'[{0,32080542,2}]'),(1,200,187,'[{0,32080542,2}]'),(1,200,188,'[{0,32080542,2}]'),(1,200,189,'[{0,32080542,2}]'),(1,200,190,'[{0,32080542,2}]'),(1,200,191,'[{0,32080542,2}]'),(1,200,192,'[{0,32080542,2}]'),(1,200,193,'[{0,32080542,2}]'),(1,200,194,'[{0,32080542,2}]'),(1,200,195,'[{0,32080542,2}]'),(1,200,196,'[{0,32080542,2}]'),(1,200,197,'[{0,32080542,2}]'),(1,200,198,'[{0,32080542,2}]'),(1,200,199,'[{0,32080542,2}]'),(1,200,200,'[{0,32080542,2}]'),(1,200,201,'[{0,32080542,2}]'),(1,200,202,'[{0,32080542,2}]'),(1,200,203,'[{0,32080542,2}]'),(1,200,204,'[{0,32080542,2}]'),(1,200,205,'[{0,32080542,2}]'),(1,200,206,'[{0,32080542,2}]'),(1,200,207,'[{0,32080542,2}]'),(1,200,208,'[{0,32080542,2}]'),(1,200,209,'[{0,32080542,2}]'),(1,200,210,'[{0,32080542,2}]'),(1,200,211,'[{0,32080542,2}]'),(1,200,212,'[{0,32080542,2}]'),(1,200,213,'[{0,32080542,2}]'),(1,200,214,'[{0,32080542,2}]'),(1,200,215,'[{0,32080542,2}]'),(1,200,216,'[{0,32080542,2}]'),(1,200,217,'[{0,32080542,2}]'),(1,200,218,'[{0,32080542,2}]'),(201,260,1,'[{0,32080642,1}]'),(201,260,2,'[{0,32080642,1}]'),(201,260,3,'[{0,32080642,1}]'),(201,260,4,'[{0,32080642,1}]'),(201,260,5,'[{0,32080642,1}]'),(201,260,6,'[{0,32080642,1}]'),(201,260,7,'[{0,32080642,1}]'),(201,260,8,'[{0,32080642,1}]'),(201,260,9,'[{0,32080642,1}]'),(201,260,10,'[{0,32080642,1}]'),(201,260,11,'[{0,32080642,1}]'),(201,260,12,'[{0,32080642,1}]'),(201,260,13,'[{0,32080642,1}]'),(201,260,14,'[{0,32080642,1}]'),(201,260,15,'[{0,32080642,1}]'),(201,260,16,'[{0,32080642,1}]'),(201,260,17,'[{0,32080642,1}]'),(201,260,18,'[{0,32080642,1}]'),(201,260,19,'[{0,32080642,1}]'),(201,260,20,'[{0,32080642,1}]'),(201,260,21,'[{0,32080642,2}]'),(201,260,22,'[{0,32080642,2}]'),(201,260,23,'[{0,32080642,2}]'),(201,260,24,'[{0,32080642,2}]'),(201,260,25,'[{0,32080642,2}]'),(201,260,26,'[{0,32080642,2}]'),(201,260,27,'[{0,32080642,2}]'),(201,260,28,'[{0,32080642,2}]'),(201,260,29,'[{0,32080642,2}]'),(201,260,30,'[{0,32080642,2}]'),(201,260,31,'[{0,32080642,2}]'),(201,260,32,'[{0,32080642,2}]'),(201,260,33,'[{0,32080642,2}]'),(201,260,34,'[{0,32080642,2}]'),(201,260,35,'[{0,32080642,2}]'),(201,260,36,'[{0,32080642,2}]'),(201,260,37,'[{0,32080642,2}]'),(201,260,38,'[{0,32080642,2}]'),(201,260,39,'[{0,32080642,2}]'),(201,260,40,'[{0,32080642,2}]'),(201,260,41,'[{0,32080642,2}]'),(201,260,42,'[{0,32080642,2}]'),(201,260,43,'[{0,32080642,2}]'),(201,260,44,'[{0,32080642,2}]'),(201,260,45,'[{0,32080642,2}]'),(201,260,46,'[{0,32080642,2}]'),(201,260,47,'[{0,32080642,2}]'),(201,260,48,'[{0,32080642,2}]'),(201,260,49,'[{0,32080642,2}]'),(201,260,50,'[{0,32080642,2}]'),(201,260,51,'[{0,32080642,2}]'),(201,260,52,'[{0,32080642,2}]'),(201,260,53,'[{0,32080642,2}]'),(201,260,54,'[{0,32080642,2}]'),(201,260,55,'[{0,32080642,2}]'),(201,260,56,'[{0,32080642,2}]'),(201,260,57,'[{0,32080642,2}]'),(201,260,58,'[{0,32080642,2}]'),(201,260,59,'[{0,32080642,2}]'),(201,260,60,'[{0,32080642,2}]'),(201,260,61,'[{0,32080642,2}]'),(201,260,62,'[{0,32080642,2}]'),(201,260,63,'[{0,32080642,2}]'),(201,260,64,'[{0,32080642,2}]'),(201,260,65,'[{0,32080642,2}]'),(201,260,66,'[{0,32080642,2}]'),(201,260,67,'[{0,32080642,2}]'),(201,260,68,'[{0,32080642,2}]'),(201,260,69,'[{0,32080642,2}]'),(201,260,70,'[{0,32080642,2}]'),(201,260,71,'[{0,32080642,2}]'),(201,260,72,'[{0,32080642,2}]'),(201,260,73,'[{0,32080642,2}]'),(201,260,74,'[{0,32080642,2}]'),(201,260,75,'[{0,32080642,2}]'),(201,260,76,'[{0,32080642,2}]'),(201,260,77,'[{0,32080642,2}]'),(201,260,78,'[{0,32080642,2}]'),(201,260,79,'[{0,32080642,2}]'),(201,260,80,'[{0,32080642,2}]'),(201,260,81,'[{0,32080642,2}]'),(201,260,82,'[{0,32080642,2}]'),(201,260,83,'[{0,32080642,2}]'),(201,260,84,'[{0,32080642,2}]'),(201,260,85,'[{0,32080642,2}]'),(201,260,86,'[{0,32080642,2}]'),(201,260,87,'[{0,32080642,2}]'),(201,260,88,'[{0,32080642,2}]'),(201,260,89,'[{0,32080642,2}]'),(201,260,90,'[{0,32080642,2}]'),(201,260,91,'[{0,32080642,2}]'),(201,260,92,'[{0,32080642,2}]'),(201,260,93,'[{0,32080642,2}]'),(201,260,94,'[{0,32080642,2}]'),(201,260,95,'[{0,32080642,2}]'),(201,260,96,'[{0,32080642,2}]'),(201,260,97,'[{0,32080642,2}]'),(201,260,98,'[{0,32080642,2}]'),(201,260,99,'[{0,32080642,2}]'),(201,260,100,'[{0,32080642,2}]'),(201,260,101,'[{0,32080642,2}]'),(201,260,102,'[{0,32080642,2}]'),(201,260,103,'[{0,32080642,2}]'),(201,260,104,'[{0,32080642,2}]'),(201,260,105,'[{0,32080642,2}]'),(201,260,106,'[{0,32080642,2}]'),(201,260,107,'[{0,32080642,2}]'),(201,260,108,'[{0,32080642,2}]'),(201,260,109,'[{0,32080642,2}]'),(201,260,110,'[{0,32080642,2}]'),(201,260,111,'[{0,32080642,2}]'),(201,260,112,'[{0,32080642,2}]'),(201,260,113,'[{0,32080642,2}]'),(201,260,114,'[{0,32080642,2}]'),(201,260,115,'[{0,32080642,2}]'),(201,260,116,'[{0,32080642,2}]'),(201,260,117,'[{0,32080642,2}]'),(201,260,118,'[{0,32080642,2}]'),(201,260,119,'[{0,32080642,2}]'),(201,260,120,'[{0,32080642,2}]'),(201,260,121,'[{0,32080642,2}]'),(201,260,122,'[{0,32080642,2}]'),(201,260,123,'[{0,32080642,2}]'),(201,260,124,'[{0,32080642,2}]'),(201,260,125,'[{0,32080642,2}]'),(201,260,126,'[{0,32080642,2}]'),(201,260,127,'[{0,32080642,2}]'),(201,260,128,'[{0,32080642,2}]'),(201,260,129,'[{0,32080642,2}]'),(201,260,130,'[{0,32080642,2}]'),(201,260,131,'[{0,32080642,2}]'),(201,260,132,'[{0,32080642,2}]'),(201,260,133,'[{0,32080642,2}]'),(201,260,134,'[{0,32080642,2}]'),(201,260,135,'[{0,32080642,2}]'),(201,260,136,'[{0,32080642,2}]'),(201,260,137,'[{0,32080642,2}]'),(201,260,138,'[{0,32080642,2}]'),(201,260,139,'[{0,32080642,2}]'),(201,260,140,'[{0,32080642,2}]'),(201,260,141,'[{0,32080642,2}]'),(201,260,142,'[{0,32080642,2}]'),(201,260,143,'[{0,32080642,2}]'),(201,260,144,'[{0,32080642,2}]'),(201,260,145,'[{0,32080642,2}]'),(201,260,146,'[{0,32080642,2}]'),(201,260,147,'[{0,32080642,2}]'),(201,260,148,'[{0,32080642,2}]'),(201,260,149,'[{0,32080642,2}]'),(201,260,150,'[{0,32080642,2}]'),(201,260,151,'[{0,32080642,2}]'),(201,260,152,'[{0,32080642,2}]'),(201,260,153,'[{0,32080642,2}]'),(201,260,154,'[{0,32080642,2}]'),(201,260,155,'[{0,32080642,2}]'),(201,260,156,'[{0,32080642,2}]'),(201,260,157,'[{0,32080642,2}]'),(201,260,158,'[{0,32080642,2}]'),(201,260,159,'[{0,32080642,2}]'),(201,260,160,'[{0,32080642,2}]'),(201,260,161,'[{0,32080642,2}]'),(201,260,162,'[{0,32080642,2}]'),(201,260,163,'[{0,32080642,2}]'),(201,260,164,'[{0,32080642,2}]'),(201,260,165,'[{0,32080642,2}]'),(201,260,166,'[{0,32080642,2}]'),(201,260,167,'[{0,32080642,2}]'),(201,260,168,'[{0,32080642,2}]'),(201,260,169,'[{0,32080642,2}]'),(201,260,170,'[{0,32080642,2}]'),(201,260,171,'[{0,32080642,2}]'),(201,260,172,'[{0,32080642,2}]'),(201,260,173,'[{0,32080642,2}]'),(201,260,174,'[{0,32080642,2}]'),(201,260,175,'[{0,32080642,2}]'),(201,260,176,'[{0,32080642,2}]'),(201,260,177,'[{0,32080642,2}]'),(201,260,178,'[{0,32080642,2}]'),(201,260,179,'[{0,32080642,2}]'),(201,260,180,'[{0,32080642,2}]'),(201,260,181,'[{0,32080642,2}]'),(201,260,182,'[{0,32080642,2}]'),(201,260,183,'[{0,32080642,2}]'),(201,260,184,'[{0,32080642,2}]'),(201,260,185,'[{0,32080642,2}]'),(201,260,186,'[{0,32080642,2}]'),(201,260,187,'[{0,32080642,2}]'),(201,260,188,'[{0,32080642,2}]'),(201,260,189,'[{0,32080642,2}]'),(201,260,190,'[{0,32080642,2}]'),(201,260,191,'[{0,32080642,2}]'),(201,260,192,'[{0,32080642,2}]'),(201,260,193,'[{0,32080642,2}]'),(201,260,194,'[{0,32080642,2}]'),(201,260,195,'[{0,32080642,2}]'),(201,260,196,'[{0,32080642,2}]'),(201,260,197,'[{0,32080642,2}]'),(201,260,198,'[{0,32080642,2}]'),(201,260,199,'[{0,32080642,2}]'),(201,260,200,'[{0,32080642,2}]'),(201,260,201,'[{0,32080642,2}]'),(201,260,202,'[{0,32080642,2}]'),(201,260,203,'[{0,32080642,2}]'),(201,260,204,'[{0,32080642,2}]'),(201,260,205,'[{0,32080642,2}]'),(201,260,206,'[{0,32080642,2}]'),(201,260,207,'[{0,32080642,2}]'),(201,260,208,'[{0,32080642,2}]'),(201,260,209,'[{0,32080642,2}]'),(201,260,210,'[{0,32080642,2}]'),(201,260,211,'[{0,32080642,2}]'),(201,260,212,'[{0,32080642,2}]'),(201,260,213,'[{0,32080642,2}]'),(201,260,214,'[{0,32080642,2}]'),(201,260,215,'[{0,32080642,2}]'),(201,260,216,'[{0,32080642,2}]'),(201,260,217,'[{0,32080642,2}]'),(201,260,218,'[{0,32080642,2}]'),(261,320,1,'[{0,32080742,1}]'),(261,320,2,'[{0,32080742,1}]'),(261,320,3,'[{0,32080742,1}]'),(261,320,4,'[{0,32080742,1}]'),(261,320,5,'[{0,32080742,1}]'),(261,320,6,'[{0,32080742,1}]'),(261,320,7,'[{0,32080742,1}]'),(261,320,8,'[{0,32080742,1}]'),(261,320,9,'[{0,32080742,1}]'),(261,320,10,'[{0,32080742,1}]'),(261,320,11,'[{0,32080742,1}]'),(261,320,12,'[{0,32080742,1}]'),(261,320,13,'[{0,32080742,1}]'),(261,320,14,'[{0,32080742,1}]'),(261,320,15,'[{0,32080742,1}]'),(261,320,16,'[{0,32080742,1}]'),(261,320,17,'[{0,32080742,1}]'),(261,320,18,'[{0,32080742,1}]'),(261,320,19,'[{0,32080742,1}]'),(261,320,20,'[{0,32080742,1}]'),(261,320,21,'[{0,32080742,2}]'),(261,320,22,'[{0,32080742,2}]'),(261,320,23,'[{0,32080742,2}]'),(261,320,24,'[{0,32080742,2}]'),(261,320,25,'[{0,32080742,2}]'),(261,320,26,'[{0,32080742,2}]'),(261,320,27,'[{0,32080742,2}]'),(261,320,28,'[{0,32080742,2}]'),(261,320,29,'[{0,32080742,2}]'),(261,320,30,'[{0,32080742,2}]'),(261,320,31,'[{0,32080742,2}]'),(261,320,32,'[{0,32080742,2}]'),(261,320,33,'[{0,32080742,2}]'),(261,320,34,'[{0,32080742,2}]'),(261,320,35,'[{0,32080742,2}]'),(261,320,36,'[{0,32080742,2}]'),(261,320,37,'[{0,32080742,2}]'),(261,320,38,'[{0,32080742,2}]'),(261,320,39,'[{0,32080742,2}]'),(261,320,40,'[{0,32080742,2}]'),(261,320,41,'[{0,32080742,2}]'),(261,320,42,'[{0,32080742,2}]'),(261,320,43,'[{0,32080742,2}]'),(261,320,44,'[{0,32080742,2}]'),(261,320,45,'[{0,32080742,2}]'),(261,320,46,'[{0,32080742,2}]'),(261,320,47,'[{0,32080742,2}]'),(261,320,48,'[{0,32080742,2}]'),(261,320,49,'[{0,32080742,2}]'),(261,320,50,'[{0,32080742,2}]'),(261,320,51,'[{0,32080742,2}]'),(261,320,52,'[{0,32080742,2}]'),(261,320,53,'[{0,32080742,2}]'),(261,320,54,'[{0,32080742,2}]'),(261,320,55,'[{0,32080742,2}]'),(261,320,56,'[{0,32080742,2}]'),(261,320,57,'[{0,32080742,2}]'),(261,320,58,'[{0,32080742,2}]'),(261,320,59,'[{0,32080742,2}]'),(261,320,60,'[{0,32080742,2}]'),(261,320,61,'[{0,32080742,2}]'),(261,320,62,'[{0,32080742,2}]'),(261,320,63,'[{0,32080742,2}]'),(261,320,64,'[{0,32080742,2}]'),(261,320,65,'[{0,32080742,2}]'),(261,320,66,'[{0,32080742,2}]'),(261,320,67,'[{0,32080742,2}]'),(261,320,68,'[{0,32080742,2}]'),(261,320,69,'[{0,32080742,2}]'),(261,320,70,'[{0,32080742,2}]'),(261,320,71,'[{0,32080742,2}]'),(261,320,72,'[{0,32080742,2}]'),(261,320,73,'[{0,32080742,2}]'),(261,320,74,'[{0,32080742,2}]'),(261,320,75,'[{0,32080742,2}]'),(261,320,76,'[{0,32080742,2}]'),(261,320,77,'[{0,32080742,2}]'),(261,320,78,'[{0,32080742,2}]'),(261,320,79,'[{0,32080742,2}]'),(261,320,80,'[{0,32080742,2}]'),(261,320,81,'[{0,32080742,2}]'),(261,320,82,'[{0,32080742,2}]'),(261,320,83,'[{0,32080742,2}]'),(261,320,84,'[{0,32080742,2}]'),(261,320,85,'[{0,32080742,2}]'),(261,320,86,'[{0,32080742,2}]'),(261,320,87,'[{0,32080742,2}]'),(261,320,88,'[{0,32080742,2}]'),(261,320,89,'[{0,32080742,2}]'),(261,320,90,'[{0,32080742,2}]'),(261,320,91,'[{0,32080742,2}]'),(261,320,92,'[{0,32080742,2}]'),(261,320,93,'[{0,32080742,2}]'),(261,320,94,'[{0,32080742,2}]'),(261,320,95,'[{0,32080742,2}]'),(261,320,96,'[{0,32080742,2}]'),(261,320,97,'[{0,32080742,2}]'),(261,320,98,'[{0,32080742,2}]'),(261,320,99,'[{0,32080742,2}]'),(261,320,100,'[{0,32080742,2}]'),(261,320,101,'[{0,32080742,2}]'),(261,320,102,'[{0,32080742,2}]'),(261,320,103,'[{0,32080742,2}]'),(261,320,104,'[{0,32080742,2}]'),(261,320,105,'[{0,32080742,2}]'),(261,320,106,'[{0,32080742,2}]'),(261,320,107,'[{0,32080742,2}]'),(261,320,108,'[{0,32080742,2}]'),(261,320,109,'[{0,32080742,2}]'),(261,320,110,'[{0,32080742,2}]'),(261,320,111,'[{0,32080742,2}]'),(261,320,112,'[{0,32080742,2}]'),(261,320,113,'[{0,32080742,2}]'),(261,320,114,'[{0,32080742,2}]'),(261,320,115,'[{0,32080742,2}]'),(261,320,116,'[{0,32080742,2}]'),(261,320,117,'[{0,32080742,2}]'),(261,320,118,'[{0,32080742,2}]'),(261,320,119,'[{0,32080742,2}]'),(261,320,120,'[{0,32080742,2}]'),(261,320,121,'[{0,32080742,2}]'),(261,320,122,'[{0,32080742,2}]'),(261,320,123,'[{0,32080742,2}]'),(261,320,124,'[{0,32080742,2}]'),(261,320,125,'[{0,32080742,2}]'),(261,320,126,'[{0,32080742,2}]'),(261,320,127,'[{0,32080742,2}]'),(261,320,128,'[{0,32080742,2}]'),(261,320,129,'[{0,32080742,2}]'),(261,320,130,'[{0,32080742,2}]'),(261,320,131,'[{0,32080742,2}]'),(261,320,132,'[{0,32080742,2}]'),(261,320,133,'[{0,32080742,2}]'),(261,320,134,'[{0,32080742,2}]'),(261,320,135,'[{0,32080742,2}]'),(261,320,136,'[{0,32080742,2}]'),(261,320,137,'[{0,32080742,2}]'),(261,320,138,'[{0,32080742,2}]'),(261,320,139,'[{0,32080742,2}]'),(261,320,140,'[{0,32080742,2}]'),(261,320,141,'[{0,32080742,2}]'),(261,320,142,'[{0,32080742,2}]'),(261,320,143,'[{0,32080742,2}]'),(261,320,144,'[{0,32080742,2}]'),(261,320,145,'[{0,32080742,2}]'),(261,320,146,'[{0,32080742,2}]'),(261,320,147,'[{0,32080742,2}]'),(261,320,148,'[{0,32080742,2}]'),(261,320,149,'[{0,32080742,2}]'),(261,320,150,'[{0,32080742,2}]'),(261,320,151,'[{0,32080742,2}]'),(261,320,152,'[{0,32080742,2}]'),(261,320,153,'[{0,32080742,2}]'),(261,320,154,'[{0,32080742,2}]'),(261,320,155,'[{0,32080742,2}]'),(261,320,156,'[{0,32080742,2}]'),(261,320,157,'[{0,32080742,2}]'),(261,320,158,'[{0,32080742,2}]'),(261,320,159,'[{0,32080742,2}]'),(261,320,160,'[{0,32080742,2}]'),(261,320,161,'[{0,32080742,2}]'),(261,320,162,'[{0,32080742,2}]'),(261,320,163,'[{0,32080742,2}]'),(261,320,164,'[{0,32080742,2}]'),(261,320,165,'[{0,32080742,2}]'),(261,320,166,'[{0,32080742,2}]'),(261,320,167,'[{0,32080742,2}]'),(261,320,168,'[{0,32080742,2}]'),(261,320,169,'[{0,32080742,2}]'),(261,320,170,'[{0,32080742,2}]'),(261,320,171,'[{0,32080742,2}]'),(261,320,172,'[{0,32080742,2}]'),(261,320,173,'[{0,32080742,2}]'),(261,320,174,'[{0,32080742,2}]'),(261,320,175,'[{0,32080742,2}]'),(261,320,176,'[{0,32080742,2}]'),(261,320,177,'[{0,32080742,2}]'),(261,320,178,'[{0,32080742,2}]'),(261,320,179,'[{0,32080742,2}]'),(261,320,180,'[{0,32080742,2}]'),(261,320,181,'[{0,32080742,2}]'),(261,320,182,'[{0,32080742,2}]'),(261,320,183,'[{0,32080742,2}]'),(261,320,184,'[{0,32080742,2}]'),(261,320,185,'[{0,32080742,2}]'),(261,320,186,'[{0,32080742,2}]'),(261,320,187,'[{0,32080742,2}]'),(261,320,188,'[{0,32080742,2}]'),(261,320,189,'[{0,32080742,2}]'),(261,320,190,'[{0,32080742,2}]'),(261,320,191,'[{0,32080742,2}]'),(261,320,192,'[{0,32080742,2}]'),(261,320,193,'[{0,32080742,2}]'),(261,320,194,'[{0,32080742,2}]'),(261,320,195,'[{0,32080742,2}]'),(261,320,196,'[{0,32080742,2}]'),(261,320,197,'[{0,32080742,2}]'),(261,320,198,'[{0,32080742,2}]'),(261,320,199,'[{0,32080742,2}]'),(261,320,200,'[{0,32080742,2}]'),(261,320,201,'[{0,32080742,2}]'),(261,320,202,'[{0,32080742,2}]'),(261,320,203,'[{0,32080742,2}]'),(261,320,204,'[{0,32080742,2}]'),(261,320,205,'[{0,32080742,2}]'),(261,320,206,'[{0,32080742,2}]'),(261,320,207,'[{0,32080742,2}]'),(261,320,208,'[{0,32080742,2}]'),(261,320,209,'[{0,32080742,2}]'),(261,320,210,'[{0,32080742,2}]'),(261,320,211,'[{0,32080742,2}]'),(261,320,212,'[{0,32080742,2}]'),(261,320,213,'[{0,32080742,2}]'),(261,320,214,'[{0,32080742,2}]'),(261,320,215,'[{0,32080742,2}]'),(261,320,216,'[{0,32080742,2}]'),(261,320,217,'[{0,32080742,2}]'),(261,320,218,'[{0,32080742,2}]'),(321,350,1,'[{0,32080842,1}]'),(321,350,2,'[{0,32080842,1}]'),(321,350,3,'[{0,32080842,1}]'),(321,350,4,'[{0,32080842,1}]'),(321,350,5,'[{0,32080842,1}]'),(321,350,6,'[{0,32080842,1}]'),(321,350,7,'[{0,32080842,1}]'),(321,350,8,'[{0,32080842,1}]'),(321,350,9,'[{0,32080842,1}]'),(321,350,10,'[{0,32080842,1}]'),(321,350,11,'[{0,32080842,1}]'),(321,350,12,'[{0,32080842,1}]'),(321,350,13,'[{0,32080842,1}]'),(321,350,14,'[{0,32080842,1}]'),(321,350,15,'[{0,32080842,1}]'),(321,350,16,'[{0,32080842,1}]'),(321,350,17,'[{0,32080842,1}]'),(321,350,18,'[{0,32080842,1}]'),(321,350,19,'[{0,32080842,1}]'),(321,350,20,'[{0,32080842,1}]'),(321,350,21,'[{0,32080842,2}]'),(321,350,22,'[{0,32080842,2}]'),(321,350,23,'[{0,32080842,2}]'),(321,350,24,'[{0,32080842,2}]'),(321,350,25,'[{0,32080842,2}]'),(321,350,26,'[{0,32080842,2}]'),(321,350,27,'[{0,32080842,2}]'),(321,350,28,'[{0,32080842,2}]'),(321,350,29,'[{0,32080842,2}]'),(321,350,30,'[{0,32080842,2}]'),(321,350,31,'[{0,32080842,2}]'),(321,350,32,'[{0,32080842,2}]'),(321,350,33,'[{0,32080842,2}]'),(321,350,34,'[{0,32080842,2}]'),(321,350,35,'[{0,32080842,2}]'),(321,350,36,'[{0,32080842,2}]'),(321,350,37,'[{0,32080842,2}]'),(321,350,38,'[{0,32080842,2}]'),(321,350,39,'[{0,32080842,2}]'),(321,350,40,'[{0,32080842,2}]'),(321,350,41,'[{0,32080842,2}]'),(321,350,42,'[{0,32080842,2}]'),(321,350,43,'[{0,32080842,2}]'),(321,350,44,'[{0,32080842,2}]'),(321,350,45,'[{0,32080842,2}]'),(321,350,46,'[{0,32080842,2}]'),(321,350,47,'[{0,32080842,2}]'),(321,350,48,'[{0,32080842,2}]'),(321,350,49,'[{0,32080842,2}]'),(321,350,50,'[{0,32080842,2}]'),(321,350,51,'[{0,32080842,2}]'),(321,350,52,'[{0,32080842,2}]'),(321,350,53,'[{0,32080842,2}]'),(321,350,54,'[{0,32080842,2}]'),(321,350,55,'[{0,32080842,2}]'),(321,350,56,'[{0,32080842,2}]'),(321,350,57,'[{0,32080842,2}]'),(321,350,58,'[{0,32080842,2}]'),(321,350,59,'[{0,32080842,2}]'),(321,350,60,'[{0,32080842,2}]'),(321,350,61,'[{0,32080842,2}]'),(321,350,62,'[{0,32080842,2}]'),(321,350,63,'[{0,32080842,2}]'),(321,350,64,'[{0,32080842,2}]'),(321,350,65,'[{0,32080842,2}]'),(321,350,66,'[{0,32080842,2}]'),(321,350,67,'[{0,32080842,2}]'),(321,350,68,'[{0,32080842,2}]'),(321,350,69,'[{0,32080842,2}]'),(321,350,70,'[{0,32080842,2}]'),(321,350,71,'[{0,32080842,2}]'),(321,350,72,'[{0,32080842,2}]'),(321,350,73,'[{0,32080842,2}]'),(321,350,74,'[{0,32080842,2}]'),(321,350,75,'[{0,32080842,2}]'),(321,350,76,'[{0,32080842,2}]'),(321,350,77,'[{0,32080842,2}]'),(321,350,78,'[{0,32080842,2}]'),(321,350,79,'[{0,32080842,2}]'),(321,350,80,'[{0,32080842,2}]'),(321,350,81,'[{0,32080842,2}]'),(321,350,82,'[{0,32080842,2}]'),(321,350,83,'[{0,32080842,2}]'),(321,350,84,'[{0,32080842,2}]'),(321,350,85,'[{0,32080842,2}]'),(321,350,86,'[{0,32080842,2}]'),(321,350,87,'[{0,32080842,2}]'),(321,350,88,'[{0,32080842,2}]'),(321,350,89,'[{0,32080842,2}]'),(321,350,90,'[{0,32080842,2}]'),(321,350,91,'[{0,32080842,2}]'),(321,350,92,'[{0,32080842,2}]'),(321,350,93,'[{0,32080842,2}]'),(321,350,94,'[{0,32080842,2}]'),(321,350,95,'[{0,32080842,2}]'),(321,350,96,'[{0,32080842,2}]'),(321,350,97,'[{0,32080842,2}]'),(321,350,98,'[{0,32080842,2}]'),(321,350,99,'[{0,32080842,2}]'),(321,350,100,'[{0,32080842,2}]'),(321,350,101,'[{0,32080842,2}]'),(321,350,102,'[{0,32080842,2}]'),(321,350,103,'[{0,32080842,2}]'),(321,350,104,'[{0,32080842,2}]'),(321,350,105,'[{0,32080842,2}]'),(321,350,106,'[{0,32080842,2}]'),(321,350,107,'[{0,32080842,2}]'),(321,350,108,'[{0,32080842,2}]'),(321,350,109,'[{0,32080842,2}]'),(321,350,110,'[{0,32080842,2}]'),(321,350,111,'[{0,32080842,2}]'),(321,350,112,'[{0,32080842,2}]'),(321,350,113,'[{0,32080842,2}]'),(321,350,114,'[{0,32080842,2}]'),(321,350,115,'[{0,32080842,2}]'),(321,350,116,'[{0,32080842,2}]'),(321,350,117,'[{0,32080842,2}]'),(321,350,118,'[{0,32080842,2}]'),(321,350,119,'[{0,32080842,2}]'),(321,350,120,'[{0,32080842,2}]'),(321,350,121,'[{0,32080842,2}]'),(321,350,122,'[{0,32080842,2}]'),(321,350,123,'[{0,32080842,2}]'),(321,350,124,'[{0,32080842,2}]'),(321,350,125,'[{0,32080842,2}]'),(321,350,126,'[{0,32080842,2}]'),(321,350,127,'[{0,32080842,2}]'),(321,350,128,'[{0,32080842,2}]'),(321,350,129,'[{0,32080842,2}]'),(321,350,130,'[{0,32080842,2}]'),(321,350,131,'[{0,32080842,2}]'),(321,350,132,'[{0,32080842,2}]'),(321,350,133,'[{0,32080842,2}]'),(321,350,134,'[{0,32080842,2}]'),(321,350,135,'[{0,32080842,2}]'),(321,350,136,'[{0,32080842,2}]'),(321,350,137,'[{0,32080842,2}]'),(321,350,138,'[{0,32080842,2}]'),(321,350,139,'[{0,32080842,2}]'),(321,350,140,'[{0,32080842,2}]'),(321,350,141,'[{0,32080842,2}]'),(321,350,142,'[{0,32080842,2}]'),(321,350,143,'[{0,32080842,2}]'),(321,350,144,'[{0,32080842,2}]'),(321,350,145,'[{0,32080842,2}]'),(321,350,146,'[{0,32080842,2}]'),(321,350,147,'[{0,32080842,2}]'),(321,350,148,'[{0,32080842,2}]'),(321,350,149,'[{0,32080842,2}]'),(321,350,150,'[{0,32080842,2}]'),(321,350,151,'[{0,32080842,2}]'),(321,350,152,'[{0,32080842,2}]'),(321,350,153,'[{0,32080842,2}]'),(321,350,154,'[{0,32080842,2}]'),(321,350,155,'[{0,32080842,2}]'),(321,350,156,'[{0,32080842,2}]'),(321,350,157,'[{0,32080842,2}]'),(321,350,158,'[{0,32080842,2}]'),(321,350,159,'[{0,32080842,2}]'),(321,350,160,'[{0,32080842,2}]'),(321,350,161,'[{0,32080842,2}]'),(321,350,162,'[{0,32080842,2}]'),(321,350,163,'[{0,32080842,2}]'),(321,350,164,'[{0,32080842,2}]'),(321,350,165,'[{0,32080842,2}]'),(321,350,166,'[{0,32080842,2}]'),(321,350,167,'[{0,32080842,2}]'),(321,350,168,'[{0,32080842,2}]'),(321,350,169,'[{0,32080842,2}]'),(321,350,170,'[{0,32080842,2}]'),(321,350,171,'[{0,32080842,2}]'),(321,350,172,'[{0,32080842,2}]'),(321,350,173,'[{0,32080842,2}]'),(321,350,174,'[{0,32080842,2}]'),(321,350,175,'[{0,32080842,2}]'),(321,350,176,'[{0,32080842,2}]'),(321,350,177,'[{0,32080842,2}]'),(321,350,178,'[{0,32080842,2}]'),(321,350,179,'[{0,32080842,2}]'),(321,350,180,'[{0,32080842,2}]'),(321,350,181,'[{0,32080842,2}]'),(321,350,182,'[{0,32080842,2}]'),(321,350,183,'[{0,32080842,2}]'),(321,350,184,'[{0,32080842,2}]'),(321,350,185,'[{0,32080842,2}]'),(321,350,186,'[{0,32080842,2}]'),(321,350,187,'[{0,32080842,2}]'),(321,350,188,'[{0,32080842,2}]'),(321,350,189,'[{0,32080842,2}]'),(321,350,190,'[{0,32080842,2}]'),(321,350,191,'[{0,32080842,2}]'),(321,350,192,'[{0,32080842,2}]'),(321,350,193,'[{0,32080842,2}]'),(321,350,194,'[{0,32080842,2}]'),(321,350,195,'[{0,32080842,2}]'),(321,350,196,'[{0,32080842,2}]'),(321,350,197,'[{0,32080842,2}]'),(321,350,198,'[{0,32080842,2}]'),(321,350,199,'[{0,32080842,2}]'),(321,350,200,'[{0,32080842,2}]'),(321,350,201,'[{0,32080842,2}]'),(321,350,202,'[{0,32080842,2}]'),(321,350,203,'[{0,32080842,2}]'),(321,350,204,'[{0,32080842,2}]'),(321,350,205,'[{0,32080842,2}]'),(321,350,206,'[{0,32080842,2}]'),(321,350,207,'[{0,32080842,2}]'),(321,350,208,'[{0,32080842,2}]'),(321,350,209,'[{0,32080842,2}]'),(321,350,210,'[{0,32080842,2}]'),(321,350,211,'[{0,32080842,2}]'),(321,350,212,'[{0,32080842,2}]'),(321,350,213,'[{0,32080842,2}]'),(321,350,214,'[{0,32080842,2}]'),(321,350,215,'[{0,32080842,2}]'),(321,350,216,'[{0,32080842,2}]'),(321,350,217,'[{0,32080842,2}]'),(321,350,218,'[{0,32080842,2}]'),(351,370,1,'[{0,32080842,1}]'),(351,370,2,'[{0,32080842,1}]'),(351,370,3,'[{0,32080842,1}]'),(351,370,4,'[{0,32080842,1}]'),(351,370,5,'[{0,32080842,1}]'),(351,370,6,'[{0,32080842,1}]'),(351,370,7,'[{0,32080842,1}]'),(351,370,8,'[{0,32080842,1}]'),(351,370,9,'[{0,32080842,1}]'),(351,370,10,'[{0,32080842,1}]'),(351,370,11,'[{0,32080842,1}]'),(351,370,12,'[{0,32080842,1}]'),(351,370,13,'[{0,32080842,1}]'),(351,370,14,'[{0,32080842,1}]'),(351,370,15,'[{0,32080842,1}]'),(351,370,16,'[{0,32080842,1}]'),(351,370,17,'[{0,32080842,1}]'),(351,370,18,'[{0,32080842,1}]'),(351,370,19,'[{0,32080842,1}]'),(351,370,20,'[{0,32080842,1}]'),(351,370,21,'[{0,32080842,2}]'),(351,370,22,'[{0,32080842,2}]'),(351,370,23,'[{0,32080842,2}]'),(351,370,24,'[{0,32080842,2}]'),(351,370,25,'[{0,32080842,2}]'),(351,370,26,'[{0,32080842,2}]'),(351,370,27,'[{0,32080842,2}]'),(351,370,28,'[{0,32080842,2}]'),(351,370,29,'[{0,32080842,2}]'),(351,370,30,'[{0,32080842,2}]'),(351,370,31,'[{0,32080842,2}]'),(351,370,32,'[{0,32080842,2}]'),(351,370,33,'[{0,32080842,2}]'),(351,370,34,'[{0,32080842,2}]'),(351,370,35,'[{0,32080842,2}]'),(351,370,36,'[{0,32080842,2}]'),(351,370,37,'[{0,32080842,2}]'),(351,370,38,'[{0,32080842,2}]'),(351,370,39,'[{0,32080842,2}]'),(351,370,40,'[{0,32080842,2}]'),(351,370,41,'[{0,32080842,2}]'),(351,370,42,'[{0,32080842,2}]'),(351,370,43,'[{0,32080842,2}]'),(351,370,44,'[{0,32080842,2}]'),(351,370,45,'[{0,32080842,2}]'),(351,370,46,'[{0,32080842,2}]'),(351,370,47,'[{0,32080842,2}]'),(351,370,48,'[{0,32080842,2}]'),(351,370,49,'[{0,32080842,2}]'),(351,370,50,'[{0,32080842,2}]'),(351,370,51,'[{0,32080842,2}]'),(351,370,52,'[{0,32080842,2}]'),(351,370,53,'[{0,32080842,2}]'),(351,370,54,'[{0,32080842,2}]'),(351,370,55,'[{0,32080842,2}]'),(351,370,56,'[{0,32080842,2}]'),(351,370,57,'[{0,32080842,2}]'),(351,370,58,'[{0,32080842,2}]'),(351,370,59,'[{0,32080842,2}]'),(351,370,60,'[{0,32080842,2}]'),(351,370,61,'[{0,32080842,2}]'),(351,370,62,'[{0,32080842,2}]'),(351,370,63,'[{0,32080842,2}]'),(351,370,64,'[{0,32080842,2}]'),(351,370,65,'[{0,32080842,2}]'),(351,370,66,'[{0,32080842,2}]'),(351,370,67,'[{0,32080842,2}]'),(351,370,68,'[{0,32080842,2}]'),(351,370,69,'[{0,32080842,2}]'),(351,370,70,'[{0,32080842,2}]'),(351,370,71,'[{0,32080842,2}]'),(351,370,72,'[{0,32080842,2}]'),(351,370,73,'[{0,32080842,2}]'),(351,370,74,'[{0,32080842,2}]'),(351,370,75,'[{0,32080842,2}]'),(351,370,76,'[{0,32080842,2}]'),(351,370,77,'[{0,32080842,2}]'),(351,370,78,'[{0,32080842,2}]'),(351,370,79,'[{0,32080842,2}]'),(351,370,80,'[{0,32080842,2}]'),(351,370,81,'[{0,32080842,2}]'),(351,370,82,'[{0,32080842,2}]'),(351,370,83,'[{0,32080842,2}]'),(351,370,84,'[{0,32080842,2}]'),(351,370,85,'[{0,32080842,2}]'),(351,370,86,'[{0,32080842,2}]'),(351,370,87,'[{0,32080842,2}]'),(351,370,88,'[{0,32080842,2}]'),(351,370,89,'[{0,32080842,2}]'),(351,370,90,'[{0,32080842,2}]'),(351,370,91,'[{0,32080842,2}]'),(351,370,92,'[{0,32080842,2}]'),(351,370,93,'[{0,32080842,2}]'),(351,370,94,'[{0,32080842,2}]'),(351,370,95,'[{0,32080842,2}]'),(351,370,96,'[{0,32080842,2}]'),(351,370,97,'[{0,32080842,2}]'),(351,370,98,'[{0,32080842,2}]'),(351,370,99,'[{0,32080842,2}]'),(351,370,100,'[{0,32080842,2}]'),(351,370,101,'[{0,32080842,2}]'),(351,370,102,'[{0,32080842,2}]'),(351,370,103,'[{0,32080842,2}]'),(351,370,104,'[{0,32080842,2}]'),(351,370,105,'[{0,32080842,2}]'),(351,370,106,'[{0,32080842,2}]'),(351,370,107,'[{0,32080842,2}]'),(351,370,108,'[{0,32080842,2}]'),(351,370,109,'[{0,32080842,2}]'),(351,370,110,'[{0,32080842,2}]'),(351,370,111,'[{0,32080842,2}]'),(351,370,112,'[{0,32080842,2}]'),(351,370,113,'[{0,32080842,2}]'),(351,370,114,'[{0,32080842,2}]'),(351,370,115,'[{0,32080842,2}]'),(351,370,116,'[{0,32080842,2}]'),(351,370,117,'[{0,32080842,2}]'),(351,370,118,'[{0,32080842,2}]'),(351,370,119,'[{0,32080842,2}]'),(351,370,120,'[{0,32080842,2}]'),(351,370,121,'[{0,32080842,2}]'),(351,370,122,'[{0,32080842,2}]'),(351,370,123,'[{0,32080842,2}]'),(351,370,124,'[{0,32080842,2}]'),(351,370,125,'[{0,32080842,2}]'),(351,370,126,'[{0,32080842,2}]'),(351,370,127,'[{0,32080842,2}]'),(351,370,128,'[{0,32080842,2}]'),(351,370,129,'[{0,32080842,2}]'),(351,370,130,'[{0,32080842,2}]'),(351,370,131,'[{0,32080842,2}]'),(351,370,132,'[{0,32080842,2}]'),(351,370,133,'[{0,32080842,2}]'),(351,370,134,'[{0,32080842,2}]'),(351,370,135,'[{0,32080842,2}]'),(351,370,136,'[{0,32080842,2}]'),(351,370,137,'[{0,32080842,2}]'),(351,370,138,'[{0,32080842,2}]'),(351,370,139,'[{0,32080842,2}]'),(351,370,140,'[{0,32080842,2}]'),(351,370,141,'[{0,32080842,2}]'),(351,370,142,'[{0,32080842,2}]'),(351,370,143,'[{0,32080842,2}]'),(351,370,144,'[{0,32080842,2}]'),(351,370,145,'[{0,32080842,2}]'),(351,370,146,'[{0,32080842,2}]'),(351,370,147,'[{0,32080842,2}]'),(351,370,148,'[{0,32080842,2}]'),(351,370,149,'[{0,32080842,2}]'),(351,370,150,'[{0,32080842,2}]'),(351,370,151,'[{0,32080842,2}]'),(351,370,152,'[{0,32080842,2}]'),(351,370,153,'[{0,32080842,2}]'),(351,370,154,'[{0,32080842,2}]'),(351,370,155,'[{0,32080842,2}]'),(351,370,156,'[{0,32080842,2}]'),(351,370,157,'[{0,32080842,2}]'),(351,370,158,'[{0,32080842,2}]'),(351,370,159,'[{0,32080842,2}]'),(351,370,160,'[{0,32080842,2}]'),(351,370,161,'[{0,32080842,2}]'),(351,370,162,'[{0,32080842,2}]'),(351,370,163,'[{0,32080842,2}]'),(351,370,164,'[{0,32080842,2}]'),(351,370,165,'[{0,32080842,2}]'),(351,370,166,'[{0,32080842,2}]'),(351,370,167,'[{0,32080842,2}]'),(351,370,168,'[{0,32080842,2}]'),(351,370,169,'[{0,32080842,2}]'),(351,370,170,'[{0,32080842,2}]'),(351,370,171,'[{0,32080842,2}]'),(351,370,172,'[{0,32080842,2}]'),(351,370,173,'[{0,32080842,2}]'),(351,370,174,'[{0,32080842,2}]'),(351,370,175,'[{0,32080842,2}]'),(351,370,176,'[{0,32080842,2}]'),(351,370,177,'[{0,32080842,2}]'),(351,370,178,'[{0,32080842,2}]'),(351,370,179,'[{0,32080842,2}]'),(351,370,180,'[{0,32080842,2}]'),(351,370,181,'[{0,32080842,2}]'),(351,370,182,'[{0,32080842,2}]'),(351,370,183,'[{0,32080842,2}]'),(351,370,184,'[{0,32080842,2}]'),(351,370,185,'[{0,32080842,2}]'),(351,370,186,'[{0,32080842,2}]'),(351,370,187,'[{0,32080842,2}]'),(351,370,188,'[{0,32080842,2}]'),(351,370,189,'[{0,32080842,2}]'),(351,370,190,'[{0,32080842,2}]'),(351,370,191,'[{0,32080842,2}]'),(351,370,192,'[{0,32080842,2}]'),(351,370,193,'[{0,32080842,2}]'),(351,370,194,'[{0,32080842,2}]'),(351,370,195,'[{0,32080842,2}]'),(351,370,196,'[{0,32080842,2}]'),(351,370,197,'[{0,32080842,2}]'),(351,370,198,'[{0,32080842,2}]'),(351,370,199,'[{0,32080842,2}]'),(351,370,200,'[{0,32080842,2}]'),(351,370,201,'[{0,32080842,2}]'),(351,370,202,'[{0,32080842,2}]'),(351,370,203,'[{0,32080842,2}]'),(351,370,204,'[{0,32080842,2}]'),(351,370,205,'[{0,32080842,2}]'),(351,370,206,'[{0,32080842,2}]'),(351,370,207,'[{0,32080842,2}]'),(351,370,208,'[{0,32080842,2}]'),(351,370,209,'[{0,32080842,2}]'),(351,370,210,'[{0,32080842,2}]'),(351,370,211,'[{0,32080842,2}]'),(351,370,212,'[{0,32080842,2}]'),(351,370,213,'[{0,32080842,2}]'),(351,370,214,'[{0,32080842,2}]'),(351,370,215,'[{0,32080842,2}]'),(351,370,216,'[{0,32080842,2}]'),(351,370,217,'[{0,32080842,2}]'),(351,370,218,'[{0,32080842,2}]'),(371,390,1,'[{0,32080942,1}]'),(371,390,2,'[{0,32080942,1}]'),(371,390,3,'[{0,32080942,1}]'),(371,390,4,'[{0,32080942,1}]'),(371,390,5,'[{0,32080942,1},{0,34010001,1}]'),(371,390,6,'[{0,32080942,1},{0,34010001,1}]'),(371,390,7,'[{0,32080942,1},{0,34010001,1}]'),(371,390,8,'[{0,32080942,1},{0,34010001,1}]'),(371,390,9,'[{0,32080942,1},{0,34010001,1}]'),(371,390,10,'[{0,32080942,1},{0,34010001,1}]'),(371,390,11,'[{0,32080942,1},{0,34010001,1}]'),(371,390,12,'[{0,32080942,1},{0,34010001,1}]'),(371,390,13,'[{0,32080942,1},{0,34010001,1}]'),(371,390,14,'[{0,32080942,1},{0,34010001,1}]'),(371,390,15,'[{0,32080942,1},{0,34010001,1}]'),(371,390,16,'[{0,32080942,1},{0,34010001,1}]'),(371,390,17,'[{0,32080942,1},{0,34010001,1}]'),(371,390,18,'[{0,32080942,1},{0,34010001,1}]'),(371,390,19,'[{0,32080942,1},{0,34010001,1}]'),(371,390,20,'[{0,32080942,1},{0,34010001,1}]'),(371,390,21,'[{0,32080942,2},{0,34010001,2}]'),(371,390,22,'[{0,32080942,2},{0,34010001,2}]'),(371,390,23,'[{0,32080942,2},{0,34010001,2}]'),(371,390,24,'[{0,32080942,2},{0,34010001,2}]'),(371,390,25,'[{0,32080942,2},{0,34010001,2}]'),(371,390,26,'[{0,32080942,2},{0,34010001,2}]'),(371,390,27,'[{0,32080942,2},{0,34010001,2}]'),(371,390,28,'[{0,32080942,2},{0,34010001,2}]'),(371,390,29,'[{0,32080942,2},{0,34010001,2}]'),(371,390,30,'[{0,32080942,2},{0,34010001,2}]'),(371,390,31,'[{0,32080942,2},{0,34010001,2}]'),(371,390,32,'[{0,32080942,2},{0,34010001,2}]'),(371,390,33,'[{0,32080942,2},{0,34010001,2}]'),(371,390,34,'[{0,32080942,2},{0,34010001,2}]'),(371,390,35,'[{0,32080942,2},{0,34010001,2}]'),(371,390,36,'[{0,32080942,2},{0,34010001,2}]'),(371,390,37,'[{0,32080942,2},{0,34010001,2}]'),(371,390,38,'[{0,32080942,2},{0,34010001,2}]'),(371,390,39,'[{0,32080942,2},{0,34010001,2}]'),(371,390,40,'[{0,32080942,2},{0,34010001,2}]'),(371,390,41,'[{0,32080942,2},{0,34010001,2}]'),(371,390,42,'[{0,32080942,2},{0,34010001,2}]'),(371,390,43,'[{0,32080942,2},{0,34010001,2}]'),(371,390,44,'[{0,32080942,2},{0,34010001,2}]'),(371,390,45,'[{0,32080942,2},{0,34010001,2}]'),(371,390,46,'[{0,32080942,2},{0,34010001,2}]'),(371,390,47,'[{0,32080942,2},{0,34010001,2}]'),(371,390,48,'[{0,32080942,2},{0,34010001,2}]'),(371,390,49,'[{0,32080942,2},{0,34010001,2}]'),(371,390,50,'[{0,32080942,2},{0,34010001,2}]'),(371,390,51,'[{0,32080942,2},{0,34010001,2}]'),(371,390,52,'[{0,32080942,2},{0,34010001,2}]'),(371,390,53,'[{0,32080942,2},{0,34010001,2}]'),(371,390,54,'[{0,32080942,2},{0,34010001,2}]'),(371,390,55,'[{0,32080942,2},{0,34010001,2}]'),(371,390,56,'[{0,32080942,2},{0,34010001,2}]'),(371,390,57,'[{0,32080942,2},{0,34010001,2}]'),(371,390,58,'[{0,32080942,2},{0,34010001,2}]'),(371,390,59,'[{0,32080942,2},{0,34010001,2}]'),(371,390,60,'[{0,32080942,2},{0,34010001,2}]'),(371,390,61,'[{0,32080942,2},{0,34010001,2}]'),(371,390,62,'[{0,32080942,2},{0,34010001,2}]'),(371,390,63,'[{0,32080942,2},{0,34010001,2}]'),(371,390,64,'[{0,32080942,2},{0,34010001,2}]'),(371,390,65,'[{0,32080942,2},{0,34010001,2}]'),(371,390,66,'[{0,32080942,2},{0,34010001,2}]'),(371,390,67,'[{0,32080942,2},{0,34010001,2}]'),(371,390,68,'[{0,32080942,2},{0,34010001,2}]'),(371,390,69,'[{0,32080942,2},{0,34010001,2}]'),(371,390,70,'[{0,32080942,2},{0,34010001,2}]'),(371,390,71,'[{0,32080942,2},{0,34010001,2}]'),(371,390,72,'[{0,32080942,2},{0,34010001,2}]'),(371,390,73,'[{0,32080942,2},{0,34010001,2}]'),(371,390,74,'[{0,32080942,2},{0,34010001,2}]'),(371,390,75,'[{0,32080942,2},{0,34010001,2}]'),(371,390,76,'[{0,32080942,2},{0,34010001,2}]'),(371,390,77,'[{0,32080942,2},{0,34010001,2}]'),(371,390,78,'[{0,32080942,2},{0,34010001,2}]'),(371,390,79,'[{0,32080942,2},{0,34010001,2}]'),(371,390,80,'[{0,32080942,2},{0,34010001,2}]'),(371,390,81,'[{0,32080942,2},{0,34010001,2}]'),(371,390,82,'[{0,32080942,2},{0,34010001,2}]'),(371,390,83,'[{0,32080942,2},{0,34010001,2}]'),(371,390,84,'[{0,32080942,2},{0,34010001,2}]'),(371,390,85,'[{0,32080942,2},{0,34010001,2}]'),(371,390,86,'[{0,32080942,2},{0,34010001,2}]'),(371,390,87,'[{0,32080942,2},{0,34010001,2}]'),(371,390,88,'[{0,32080942,2},{0,34010001,2}]'),(371,390,89,'[{0,32080942,2},{0,34010001,2}]'),(371,390,90,'[{0,32080942,2},{0,34010001,2}]'),(371,390,91,'[{0,32080942,2},{0,34010001,2}]'),(371,390,92,'[{0,32080942,2},{0,34010001,2}]'),(371,390,93,'[{0,32080942,2},{0,34010001,2}]'),(371,390,94,'[{0,32080942,2},{0,34010001,2}]'),(371,390,95,'[{0,32080942,2},{0,34010001,2}]'),(371,390,96,'[{0,32080942,2},{0,34010001,2}]'),(371,390,97,'[{0,32080942,2},{0,34010001,2}]'),(371,390,98,'[{0,32080942,2},{0,34010001,2}]'),(371,390,99,'[{0,32080942,2},{0,34010001,2}]'),(371,390,100,'[{0,32080942,2},{0,34010001,2}]'),(371,390,101,'[{0,32080942,2},{0,34010001,2}]'),(371,390,102,'[{0,32080942,2},{0,34010001,2}]'),(371,390,103,'[{0,32080942,2},{0,34010001,2}]'),(371,390,104,'[{0,32080942,2},{0,34010001,2}]'),(371,390,105,'[{0,32080942,2},{0,34010001,2}]'),(371,390,106,'[{0,32080942,2},{0,34010001,2}]'),(371,390,107,'[{0,32080942,2},{0,34010001,2}]'),(371,390,108,'[{0,32080942,2},{0,34010001,2}]'),(371,390,109,'[{0,32080942,2},{0,34010001,2}]'),(371,390,110,'[{0,32080942,2},{0,34010001,2}]'),(371,390,111,'[{0,32080942,2},{0,34010001,2}]'),(371,390,112,'[{0,32080942,2},{0,34010001,2}]'),(371,390,113,'[{0,32080942,2},{0,34010001,2}]'),(371,390,114,'[{0,32080942,2},{0,34010001,2}]'),(371,390,115,'[{0,32080942,2},{0,34010001,2}]'),(371,390,116,'[{0,32080942,2},{0,34010001,2}]'),(371,390,117,'[{0,32080942,2},{0,34010001,2}]'),(371,390,118,'[{0,32080942,2},{0,34010001,2}]'),(371,390,119,'[{0,32080942,2},{0,34010001,2}]'),(371,390,120,'[{0,32080942,2},{0,34010001,2}]'),(371,390,121,'[{0,32080942,2},{0,34010001,2}]'),(371,390,122,'[{0,32080942,2},{0,34010001,2}]'),(371,390,123,'[{0,32080942,2},{0,34010001,2}]'),(371,390,124,'[{0,32080942,2},{0,34010001,2}]'),(371,390,125,'[{0,32080942,2},{0,34010001,2}]'),(371,390,126,'[{0,32080942,2},{0,34010001,2}]'),(371,390,127,'[{0,32080942,2},{0,34010001,2}]'),(371,390,128,'[{0,32080942,2},{0,34010001,2}]'),(371,390,129,'[{0,32080942,2},{0,34010001,2}]'),(371,390,130,'[{0,32080942,2},{0,34010001,2}]'),(371,390,131,'[{0,32080942,2},{0,34010001,2}]'),(371,390,132,'[{0,32080942,2},{0,34010001,2}]'),(371,390,133,'[{0,32080942,2},{0,34010001,2}]'),(371,390,134,'[{0,32080942,2},{0,34010001,2}]'),(371,390,135,'[{0,32080942,2},{0,34010001,2}]'),(371,390,136,'[{0,32080942,2},{0,34010001,2}]'),(371,390,137,'[{0,32080942,2},{0,34010001,2}]'),(371,390,138,'[{0,32080942,2},{0,34010001,2}]'),(371,390,139,'[{0,32080942,2},{0,34010001,2}]'),(371,390,140,'[{0,32080942,2},{0,34010001,2}]'),(371,390,141,'[{0,32080942,2},{0,34010001,2}]'),(371,390,142,'[{0,32080942,2},{0,34010001,2}]'),(371,390,143,'[{0,32080942,2},{0,34010001,2}]'),(371,390,144,'[{0,32080942,2},{0,34010001,2}]'),(371,390,145,'[{0,32080942,2},{0,34010001,2}]'),(371,390,146,'[{0,32080942,2},{0,34010001,2}]'),(371,390,147,'[{0,32080942,2},{0,34010001,2}]'),(371,390,148,'[{0,32080942,2},{0,34010001,2}]'),(371,390,149,'[{0,32080942,2},{0,34010001,2}]'),(371,390,150,'[{0,32080942,2},{0,34010001,2}]'),(371,390,151,'[{0,32080942,2},{0,34010001,2}]'),(371,390,152,'[{0,32080942,2},{0,34010001,2}]'),(371,390,153,'[{0,32080942,2},{0,34010001,2}]'),(371,390,154,'[{0,32080942,2},{0,34010001,2}]'),(371,390,155,'[{0,32080942,2},{0,34010001,2}]'),(371,390,156,'[{0,32080942,2},{0,34010001,2}]'),(371,390,157,'[{0,32080942,2},{0,34010001,2}]'),(371,390,158,'[{0,32080942,2},{0,34010001,2}]'),(371,390,159,'[{0,32080942,2},{0,34010001,2}]'),(371,390,160,'[{0,32080942,2},{0,34010001,2}]'),(371,390,161,'[{0,32080942,2},{0,34010001,2}]'),(371,390,162,'[{0,32080942,2},{0,34010001,2}]'),(371,390,163,'[{0,32080942,2},{0,34010001,2}]'),(371,390,164,'[{0,32080942,2},{0,34010001,2}]'),(371,390,165,'[{0,32080942,2},{0,34010001,2}]'),(371,390,166,'[{0,32080942,2},{0,34010001,2}]'),(371,390,167,'[{0,32080942,2},{0,34010001,2}]'),(371,390,168,'[{0,32080942,2},{0,34010001,2}]'),(371,390,169,'[{0,32080942,2},{0,34010001,2}]'),(371,390,170,'[{0,32080942,2},{0,34010001,2}]'),(371,390,171,'[{0,32080942,2},{0,34010001,2}]'),(371,390,172,'[{0,32080942,2},{0,34010001,2}]'),(371,390,173,'[{0,32080942,2},{0,34010001,2}]'),(371,390,174,'[{0,32080942,2},{0,34010001,2}]'),(371,390,175,'[{0,32080942,2},{0,34010001,2}]'),(371,390,176,'[{0,32080942,2},{0,34010001,2}]'),(371,390,177,'[{0,32080942,2},{0,34010001,2}]'),(371,390,178,'[{0,32080942,2},{0,34010001,2}]'),(371,390,179,'[{0,32080942,2},{0,34010001,2}]'),(371,390,180,'[{0,32080942,2},{0,34010001,2}]'),(371,390,181,'[{0,32080942,2},{0,34010001,2}]'),(371,390,182,'[{0,32080942,2},{0,34010001,2}]'),(371,390,183,'[{0,32080942,2},{0,34010001,2}]'),(371,390,184,'[{0,32080942,2},{0,34010001,2}]'),(371,390,185,'[{0,32080942,2},{0,34010001,2}]'),(371,390,186,'[{0,32080942,2},{0,34010001,2}]'),(371,390,187,'[{0,32080942,2},{0,34010001,2}]'),(371,390,188,'[{0,32080942,2},{0,34010001,2}]'),(371,390,189,'[{0,32080942,2},{0,34010001,2}]'),(371,390,190,'[{0,32080942,2},{0,34010001,2}]'),(371,390,191,'[{0,32080942,2},{0,34010001,2}]'),(371,390,192,'[{0,32080942,2},{0,34010001,2}]'),(371,390,193,'[{0,32080942,2},{0,34010001,2}]'),(371,390,194,'[{0,32080942,2},{0,34010001,2}]'),(371,390,195,'[{0,32080942,2},{0,34010001,2}]'),(371,390,196,'[{0,32080942,2},{0,34010001,2}]'),(371,390,197,'[{0,32080942,2},{0,34010001,2}]'),(371,390,198,'[{0,32080942,2},{0,34010001,2}]'),(371,390,199,'[{0,32080942,2},{0,34010001,2}]'),(371,390,200,'[{0,32080942,2},{0,34010001,2}]'),(371,390,201,'[{0,32080942,2},{0,34010001,2}]'),(371,390,202,'[{0,32080942,2},{0,34010001,2}]'),(371,390,203,'[{0,32080942,2},{0,34010001,2}]'),(371,390,204,'[{0,32080942,2},{0,34010001,2}]'),(371,390,205,'[{0,32080942,2},{0,34010001,2}]'),(371,390,206,'[{0,32080942,2},{0,34010001,2}]'),(371,390,207,'[{0,32080942,2},{0,34010001,2}]'),(371,390,208,'[{0,32080942,2},{0,34010001,2}]'),(371,390,209,'[{0,32080942,2},{0,34010001,2}]'),(371,390,210,'[{0,32080942,2},{0,34010001,2}]'),(371,390,211,'[{0,32080942,2},{0,34010001,2}]'),(371,390,212,'[{0,32080942,2},{0,34010001,2}]'),(371,390,213,'[{0,32080942,2},{0,34010001,2}]'),(371,390,214,'[{0,32080942,2},{0,34010001,2}]'),(371,390,215,'[{0,32080942,2},{0,34010001,2}]'),(371,390,216,'[{0,32080942,2},{0,34010001,2}]'),(371,390,217,'[{0,32080942,2},{0,34010001,2}]'),(371,390,218,'[{0,32080942,2},{0,34010001,2}]'),(391,430,1,'[{0,32081042,1}]'),(391,430,2,'[{0,32081042,1}]'),(391,430,3,'[{0,32081042,1}]'),(391,430,4,'[{0,32081042,1}]'),(391,430,5,'[{0,32081042,1},{0,34010001,1}]'),(391,430,6,'[{0,32081042,1},{0,34010001,1}]'),(391,430,7,'[{0,32081042,1},{0,34010001,1}]'),(391,430,8,'[{0,32081042,1},{0,34010001,1}]'),(391,430,9,'[{0,32081042,1},{0,34010001,1}]'),(391,430,10,'[{0,32081042,1},{0,34010001,1}]'),(391,430,11,'[{0,32081042,1},{0,34010001,1}]'),(391,430,12,'[{0,32081042,1},{0,34010001,1}]'),(391,430,13,'[{0,32081042,1},{0,34010001,1}]'),(391,430,14,'[{0,32081042,1},{0,34010001,1}]'),(391,430,15,'[{0,32081042,1},{0,34010001,1}]'),(391,430,16,'[{0,32081042,1},{0,34010001,1}]'),(391,430,17,'[{0,32081042,1},{0,34010001,1}]'),(391,430,18,'[{0,32081042,1},{0,34010001,1}]'),(391,430,19,'[{0,32081042,1},{0,34010001,1}]'),(391,430,20,'[{0,32081042,1},{0,34010001,1}]'),(391,430,21,'[{0,32081042,2},{0,34010001,2}]'),(391,430,22,'[{0,32081042,2},{0,34010001,2}]'),(391,430,23,'[{0,32081042,2},{0,34010001,2}]'),(391,430,24,'[{0,32081042,2},{0,34010001,2}]'),(391,430,25,'[{0,32081042,2},{0,34010001,2}]'),(391,430,26,'[{0,32081042,2},{0,34010001,2}]'),(391,430,27,'[{0,32081042,2},{0,34010001,2}]'),(391,430,28,'[{0,32081042,2},{0,34010001,2}]'),(391,430,29,'[{0,32081042,2},{0,34010001,2}]'),(391,430,30,'[{0,32081042,2},{0,34010001,2}]'),(391,430,31,'[{0,32081042,2},{0,34010001,2}]'),(391,430,32,'[{0,32081042,2},{0,34010001,2}]'),(391,430,33,'[{0,32081042,2},{0,34010001,2}]'),(391,430,34,'[{0,32081042,2},{0,34010001,2}]'),(391,430,35,'[{0,32081042,2},{0,34010001,2}]'),(391,430,36,'[{0,32081042,2},{0,34010001,2}]'),(391,430,37,'[{0,32081042,2},{0,34010001,2}]'),(391,430,38,'[{0,32081042,2},{0,34010001,2}]'),(391,430,39,'[{0,32081042,2},{0,34010001,2}]'),(391,430,40,'[{0,32081042,2},{0,34010001,2}]'),(391,430,41,'[{0,32081042,2},{0,34010001,2}]'),(391,430,42,'[{0,32081042,2},{0,34010001,2}]'),(391,430,43,'[{0,32081042,2},{0,34010001,2}]'),(391,430,44,'[{0,32081042,2},{0,34010001,2}]'),(391,430,45,'[{0,32081042,2},{0,34010001,2}]'),(391,430,46,'[{0,32081042,2},{0,34010001,2}]'),(391,430,47,'[{0,32081042,2},{0,34010001,2}]'),(391,430,48,'[{0,32081042,2},{0,34010001,2}]'),(391,430,49,'[{0,32081042,2},{0,34010001,2}]'),(391,430,50,'[{0,32081042,2},{0,34010001,2}]'),(391,430,51,'[{0,32081042,2},{0,34010001,2}]'),(391,430,52,'[{0,32081042,2},{0,34010001,2}]'),(391,430,53,'[{0,32081042,2},{0,34010001,2}]'),(391,430,54,'[{0,32081042,2},{0,34010001,2}]'),(391,430,55,'[{0,32081042,2},{0,34010001,2}]'),(391,430,56,'[{0,32081042,2},{0,34010001,2}]'),(391,430,57,'[{0,32081042,2},{0,34010001,2}]'),(391,430,58,'[{0,32081042,2},{0,34010001,2}]'),(391,430,59,'[{0,32081042,2},{0,34010001,2}]'),(391,430,60,'[{0,32081042,2},{0,34010001,2}]'),(391,430,61,'[{0,32081042,2},{0,34010001,2}]'),(391,430,62,'[{0,32081042,2},{0,34010001,2}]'),(391,430,63,'[{0,32081042,2},{0,34010001,2}]'),(391,430,64,'[{0,32081042,2},{0,34010001,2}]'),(391,430,65,'[{0,32081042,2},{0,34010001,2}]'),(391,430,66,'[{0,32081042,2},{0,34010001,2}]'),(391,430,67,'[{0,32081042,2},{0,34010001,2}]'),(391,430,68,'[{0,32081042,2},{0,34010001,2}]'),(391,430,69,'[{0,32081042,2},{0,34010001,2}]'),(391,430,70,'[{0,32081042,2},{0,34010001,2}]'),(391,430,71,'[{0,32081042,2},{0,34010001,2}]'),(391,430,72,'[{0,32081042,2},{0,34010001,2}]'),(391,430,73,'[{0,32081042,2},{0,34010001,2}]'),(391,430,74,'[{0,32081042,2},{0,34010001,2}]'),(391,430,75,'[{0,32081042,2},{0,34010001,2}]'),(391,430,76,'[{0,32081042,2},{0,34010001,2}]'),(391,430,77,'[{0,32081042,2},{0,34010001,2}]'),(391,430,78,'[{0,32081042,2},{0,34010001,2}]'),(391,430,79,'[{0,32081042,2},{0,34010001,2}]'),(391,430,80,'[{0,32081042,2},{0,34010001,2}]'),(391,430,81,'[{0,32081042,2},{0,34010001,2}]'),(391,430,82,'[{0,32081042,2},{0,34010001,2}]'),(391,430,83,'[{0,32081042,2},{0,34010001,2}]'),(391,430,84,'[{0,32081042,2},{0,34010001,2}]'),(391,430,85,'[{0,32081042,2},{0,34010001,2}]'),(391,430,86,'[{0,32081042,2},{0,34010001,2}]'),(391,430,87,'[{0,32081042,2},{0,34010001,2}]'),(391,430,88,'[{0,32081042,2},{0,34010001,2}]'),(391,430,89,'[{0,32081042,2},{0,34010001,2}]'),(391,430,90,'[{0,32081042,2},{0,34010001,2}]'),(391,430,91,'[{0,32081042,2},{0,34010001,2}]'),(391,430,92,'[{0,32081042,2},{0,34010001,2}]'),(391,430,93,'[{0,32081042,2},{0,34010001,2}]'),(391,430,94,'[{0,32081042,2},{0,34010001,2}]'),(391,430,95,'[{0,32081042,2},{0,34010001,2}]'),(391,430,96,'[{0,32081042,2},{0,34010001,2}]'),(391,430,97,'[{0,32081042,2},{0,34010001,2}]'),(391,430,98,'[{0,32081042,2},{0,34010001,2}]'),(391,430,99,'[{0,32081042,2},{0,34010001,2}]'),(391,430,100,'[{0,32081042,2},{0,34010001,2}]'),(391,430,101,'[{0,32081042,2},{0,34010001,2}]'),(391,430,102,'[{0,32081042,2},{0,34010001,2}]'),(391,430,103,'[{0,32081042,2},{0,34010001,2}]'),(391,430,104,'[{0,32081042,2},{0,34010001,2}]'),(391,430,105,'[{0,32081042,2},{0,34010001,2}]'),(391,430,106,'[{0,32081042,2},{0,34010001,2}]'),(391,430,107,'[{0,32081042,2},{0,34010001,2}]'),(391,430,108,'[{0,32081042,2},{0,34010001,2}]'),(391,430,109,'[{0,32081042,2},{0,34010001,2}]'),(391,430,110,'[{0,32081042,2},{0,34010001,2}]'),(391,430,111,'[{0,32081042,2},{0,34010001,2}]'),(391,430,112,'[{0,32081042,2},{0,34010001,2}]'),(391,430,113,'[{0,32081042,2},{0,34010001,2}]'),(391,430,114,'[{0,32081042,2},{0,34010001,2}]'),(391,430,115,'[{0,32081042,2},{0,34010001,2}]'),(391,430,116,'[{0,32081042,2},{0,34010001,2}]'),(391,430,117,'[{0,32081042,2},{0,34010001,2}]'),(391,430,118,'[{0,32081042,2},{0,34010001,2}]'),(391,430,119,'[{0,32081042,2},{0,34010001,2}]'),(391,430,120,'[{0,32081042,2},{0,34010001,2}]'),(391,430,121,'[{0,32081042,2},{0,34010001,2}]'),(391,430,122,'[{0,32081042,2},{0,34010001,2}]'),(391,430,123,'[{0,32081042,2},{0,34010001,2}]'),(391,430,124,'[{0,32081042,2},{0,34010001,2}]'),(391,430,125,'[{0,32081042,2},{0,34010001,2}]'),(391,430,126,'[{0,32081042,2},{0,34010001,2}]'),(391,430,127,'[{0,32081042,2},{0,34010001,2}]'),(391,430,128,'[{0,32081042,2},{0,34010001,2}]'),(391,430,129,'[{0,32081042,2},{0,34010001,2}]'),(391,430,130,'[{0,32081042,2},{0,34010001,2}]'),(391,430,131,'[{0,32081042,2},{0,34010001,2}]'),(391,430,132,'[{0,32081042,2},{0,34010001,2}]'),(391,430,133,'[{0,32081042,2},{0,34010001,2}]'),(391,430,134,'[{0,32081042,2},{0,34010001,2}]'),(391,430,135,'[{0,32081042,2},{0,34010001,2}]'),(391,430,136,'[{0,32081042,2},{0,34010001,2}]'),(391,430,137,'[{0,32081042,2},{0,34010001,2}]'),(391,430,138,'[{0,32081042,2},{0,34010001,2}]'),(391,430,139,'[{0,32081042,2},{0,34010001,2}]'),(391,430,140,'[{0,32081042,2},{0,34010001,2}]'),(391,430,141,'[{0,32081042,2},{0,34010001,2}]'),(391,430,142,'[{0,32081042,2},{0,34010001,2}]'),(391,430,143,'[{0,32081042,2},{0,34010001,2}]'),(391,430,144,'[{0,32081042,2},{0,34010001,2}]'),(391,430,145,'[{0,32081042,2},{0,34010001,2}]'),(391,430,146,'[{0,32081042,2},{0,34010001,2}]'),(391,430,147,'[{0,32081042,2},{0,34010001,2}]'),(391,430,148,'[{0,32081042,2},{0,34010001,2}]'),(391,430,149,'[{0,32081042,2},{0,34010001,2}]'),(391,430,150,'[{0,32081042,2},{0,34010001,2}]'),(391,430,151,'[{0,32081042,2},{0,34010001,2}]'),(391,430,152,'[{0,32081042,2},{0,34010001,2}]'),(391,430,153,'[{0,32081042,2},{0,34010001,2}]'),(391,430,154,'[{0,32081042,2},{0,34010001,2}]'),(391,430,155,'[{0,32081042,2},{0,34010001,2}]'),(391,430,156,'[{0,32081042,2},{0,34010001,2}]'),(391,430,157,'[{0,32081042,2},{0,34010001,2}]'),(391,430,158,'[{0,32081042,2},{0,34010001,2}]'),(391,430,159,'[{0,32081042,2},{0,34010001,2}]'),(391,430,160,'[{0,32081042,2},{0,34010001,2}]'),(391,430,161,'[{0,32081042,2},{0,34010001,2}]'),(391,430,162,'[{0,32081042,2},{0,34010001,2}]'),(391,430,163,'[{0,32081042,2},{0,34010001,2}]'),(391,430,164,'[{0,32081042,2},{0,34010001,2}]'),(391,430,165,'[{0,32081042,2},{0,34010001,2}]'),(391,430,166,'[{0,32081042,2},{0,34010001,2}]'),(391,430,167,'[{0,32081042,2},{0,34010001,2}]'),(391,430,168,'[{0,32081042,2},{0,34010001,2}]'),(391,430,169,'[{0,32081042,2},{0,34010001,2}]'),(391,430,170,'[{0,32081042,2},{0,34010001,2}]'),(391,430,171,'[{0,32081042,2},{0,34010001,2}]'),(391,430,172,'[{0,32081042,2},{0,34010001,2}]'),(391,430,173,'[{0,32081042,2},{0,34010001,2}]'),(391,430,174,'[{0,32081042,2},{0,34010001,2}]'),(391,430,175,'[{0,32081042,2},{0,34010001,2}]'),(391,430,176,'[{0,32081042,2},{0,34010001,2}]'),(391,430,177,'[{0,32081042,2},{0,34010001,2}]'),(391,430,178,'[{0,32081042,2},{0,34010001,2}]'),(391,430,179,'[{0,32081042,2},{0,34010001,2}]'),(391,430,180,'[{0,32081042,2},{0,34010001,2}]'),(391,430,181,'[{0,32081042,2},{0,34010001,2}]'),(391,430,182,'[{0,32081042,2},{0,34010001,2}]'),(391,430,183,'[{0,32081042,2},{0,34010001,2}]'),(391,430,184,'[{0,32081042,2},{0,34010001,2}]'),(391,430,185,'[{0,32081042,2},{0,34010001,2}]'),(391,430,186,'[{0,32081042,2},{0,34010001,2}]'),(391,430,187,'[{0,32081042,2},{0,34010001,2}]'),(391,430,188,'[{0,32081042,2},{0,34010001,2}]'),(391,430,189,'[{0,32081042,2},{0,34010001,2}]'),(391,430,190,'[{0,32081042,2},{0,34010001,2}]'),(391,430,191,'[{0,32081042,2},{0,34010001,2}]'),(391,430,192,'[{0,32081042,2},{0,34010001,2}]'),(391,430,193,'[{0,32081042,2},{0,34010001,2}]'),(391,430,194,'[{0,32081042,2},{0,34010001,2}]'),(391,430,195,'[{0,32081042,2},{0,34010001,2}]'),(391,430,196,'[{0,32081042,2},{0,34010001,2}]'),(391,430,197,'[{0,32081042,2},{0,34010001,2}]'),(391,430,198,'[{0,32081042,2},{0,34010001,2}]'),(391,430,199,'[{0,32081042,2},{0,34010001,2}]'),(391,430,200,'[{0,32081042,2},{0,34010001,2}]'),(391,430,201,'[{0,32081042,2},{0,34010001,2}]'),(391,430,202,'[{0,32081042,2},{0,34010001,2}]'),(391,430,203,'[{0,32081042,2},{0,34010001,2}]'),(391,430,204,'[{0,32081042,2},{0,34010001,2}]'),(391,430,205,'[{0,32081042,2},{0,34010001,2}]'),(391,430,206,'[{0,32081042,2},{0,34010001,2}]'),(391,430,207,'[{0,32081042,2},{0,34010001,2}]'),(391,430,208,'[{0,32081042,2},{0,34010001,2}]'),(391,430,209,'[{0,32081042,2},{0,34010001,2}]'),(391,430,210,'[{0,32081042,2},{0,34010001,2}]'),(391,430,211,'[{0,32081042,2},{0,34010001,2}]'),(391,430,212,'[{0,32081042,2},{0,34010001,2}]'),(391,430,213,'[{0,32081042,2},{0,34010001,2}]'),(391,430,214,'[{0,32081042,2},{0,34010001,2}]'),(391,430,215,'[{0,32081042,2},{0,34010001,2}]'),(391,430,216,'[{0,32081042,2},{0,34010001,2}]'),(391,430,217,'[{0,32081042,2},{0,34010001,2}]'),(391,430,218,'[{0,32081042,2},{0,34010001,2}]'),(431,500,1,'[{0,32081142,1}]'),(431,500,2,'[{0,32081142,1}]'),(431,500,3,'[{0,32081142,1}]'),(431,500,4,'[{0,32081142,1}]'),(431,500,5,'[{0,32081142,1},{0,34010001,1}]'),(431,500,6,'[{0,32081142,1},{0,34010001,1}]'),(431,500,7,'[{0,32081142,1},{0,34010001,1}]'),(431,500,8,'[{0,32081142,1},{0,34010001,1}]'),(431,500,9,'[{0,32081142,1},{0,34010001,1}]'),(431,500,10,'[{0,32081142,1},{0,34010001,1}]'),(431,500,11,'[{0,32081142,1},{0,34010001,1}]'),(431,500,12,'[{0,32081142,1},{0,34010001,1}]'),(431,500,13,'[{0,32081142,1},{0,34010001,1}]'),(431,500,14,'[{0,32081142,1},{0,34010001,1}]'),(431,500,15,'[{0,32081142,1},{0,34010001,1}]'),(431,500,16,'[{0,32081142,1},{0,34010001,1}]'),(431,500,17,'[{0,32081142,1},{0,34010001,1}]'),(431,500,18,'[{0,32081142,1},{0,34010001,1}]'),(431,500,19,'[{0,32081142,1},{0,34010001,1}]'),(431,500,20,'[{0,32081142,1},{0,34010001,1}]'),(431,500,21,'[{0,32081142,2},{0,34010001,2}]'),(431,500,22,'[{0,32081142,2},{0,34010001,2}]'),(431,500,23,'[{0,32081142,2},{0,34010001,2}]'),(431,500,24,'[{0,32081142,2},{0,34010001,2}]'),(431,500,25,'[{0,32081142,2},{0,34010001,2}]'),(431,500,26,'[{0,32081142,2},{0,34010001,2}]'),(431,500,27,'[{0,32081142,2},{0,34010001,2}]'),(431,500,28,'[{0,32081142,2},{0,34010001,2}]'),(431,500,29,'[{0,32081142,2},{0,34010001,2}]'),(431,500,30,'[{0,32081142,2},{0,34010001,2}]'),(431,500,31,'[{0,32081142,2},{0,34010001,2}]'),(431,500,32,'[{0,32081142,2},{0,34010001,2}]'),(431,500,33,'[{0,32081142,2},{0,34010001,2}]'),(431,500,34,'[{0,32081142,2},{0,34010001,2}]'),(431,500,35,'[{0,32081142,2},{0,34010001,2}]'),(431,500,36,'[{0,32081142,2},{0,34010001,2}]'),(431,500,37,'[{0,32081142,2},{0,34010001,2}]'),(431,500,38,'[{0,32081142,2},{0,34010001,2}]'),(431,500,39,'[{0,32081142,2},{0,34010001,2}]'),(431,500,40,'[{0,32081142,2},{0,34010001,2}]'),(431,500,41,'[{0,32081142,2},{0,34010001,2}]'),(431,500,42,'[{0,32081142,2},{0,34010001,2}]'),(431,500,43,'[{0,32081142,2},{0,34010001,2}]'),(431,500,44,'[{0,32081142,2},{0,34010001,2}]'),(431,500,45,'[{0,32081142,2},{0,34010001,2}]'),(431,500,46,'[{0,32081142,2},{0,34010001,2}]'),(431,500,47,'[{0,32081142,2},{0,34010001,2}]'),(431,500,48,'[{0,32081142,2},{0,34010001,2}]'),(431,500,49,'[{0,32081142,2},{0,34010001,2}]'),(431,500,50,'[{0,32081142,2},{0,34010001,2}]'),(431,500,51,'[{0,32081142,2},{0,34010001,2}]'),(431,500,52,'[{0,32081142,2},{0,34010001,2}]'),(431,500,53,'[{0,32081142,2},{0,34010001,2}]'),(431,500,54,'[{0,32081142,2},{0,34010001,2}]'),(431,500,55,'[{0,32081142,2},{0,34010001,2}]'),(431,500,56,'[{0,32081142,2},{0,34010001,2}]'),(431,500,57,'[{0,32081142,2},{0,34010001,2}]'),(431,500,58,'[{0,32081142,2},{0,34010001,2}]'),(431,500,59,'[{0,32081142,2},{0,34010001,2}]'),(431,500,60,'[{0,32081142,2},{0,34010001,2}]'),(431,500,61,'[{0,32081142,2},{0,34010001,2}]'),(431,500,62,'[{0,32081142,2},{0,34010001,2}]'),(431,500,63,'[{0,32081142,2},{0,34010001,2}]'),(431,500,64,'[{0,32081142,2},{0,34010001,2}]'),(431,500,65,'[{0,32081142,2},{0,34010001,2}]'),(431,500,66,'[{0,32081142,2},{0,34010001,2}]'),(431,500,67,'[{0,32081142,2},{0,34010001,2}]'),(431,500,68,'[{0,32081142,2},{0,34010001,2}]'),(431,500,69,'[{0,32081142,2},{0,34010001,2}]'),(431,500,70,'[{0,32081142,2},{0,34010001,2}]'),(431,500,71,'[{0,32081142,2},{0,34010001,2}]'),(431,500,72,'[{0,32081142,2},{0,34010001,2}]'),(431,500,73,'[{0,32081142,2},{0,34010001,2}]'),(431,500,74,'[{0,32081142,2},{0,34010001,2}]'),(431,500,75,'[{0,32081142,2},{0,34010001,2}]'),(431,500,76,'[{0,32081142,2},{0,34010001,2}]'),(431,500,77,'[{0,32081142,2},{0,34010001,2}]'),(431,500,78,'[{0,32081142,2},{0,34010001,2}]'),(431,500,79,'[{0,32081142,2},{0,34010001,2}]'),(431,500,80,'[{0,32081142,2},{0,34010001,2}]'),(431,500,81,'[{0,32081142,2},{0,34010001,2}]'),(431,500,82,'[{0,32081142,2},{0,34010001,2}]'),(431,500,83,'[{0,32081142,2},{0,34010001,2}]'),(431,500,84,'[{0,32081142,2},{0,34010001,2}]'),(431,500,85,'[{0,32081142,2},{0,34010001,2}]'),(431,500,86,'[{0,32081142,2},{0,34010001,2}]'),(431,500,87,'[{0,32081142,2},{0,34010001,2}]'),(431,500,88,'[{0,32081142,2},{0,34010001,2}]'),(431,500,89,'[{0,32081142,2},{0,34010001,2}]'),(431,500,90,'[{0,32081142,2},{0,34010001,2}]'),(431,500,91,'[{0,32081142,2},{0,34010001,2}]'),(431,500,92,'[{0,32081142,2},{0,34010001,2}]'),(431,500,93,'[{0,32081142,2},{0,34010001,2}]'),(431,500,94,'[{0,32081142,2},{0,34010001,2}]'),(431,500,95,'[{0,32081142,2},{0,34010001,2}]'),(431,500,96,'[{0,32081142,2},{0,34010001,2}]'),(431,500,97,'[{0,32081142,2},{0,34010001,2}]'),(431,500,98,'[{0,32081142,2},{0,34010001,2}]'),(431,500,99,'[{0,32081142,2},{0,34010001,2}]'),(431,500,100,'[{0,32081142,2},{0,34010001,2}]'),(431,500,101,'[{0,32081142,2},{0,34010001,2}]'),(431,500,102,'[{0,32081142,2},{0,34010001,2}]'),(431,500,103,'[{0,32081142,2},{0,34010001,2}]'),(431,500,104,'[{0,32081142,2},{0,34010001,2}]'),(431,500,105,'[{0,32081142,2},{0,34010001,2}]'),(431,500,106,'[{0,32081142,2},{0,34010001,2}]'),(431,500,107,'[{0,32081142,2},{0,34010001,2}]'),(431,500,108,'[{0,32081142,2},{0,34010001,2}]'),(431,500,109,'[{0,32081142,2},{0,34010001,2}]'),(431,500,110,'[{0,32081142,2},{0,34010001,2}]'),(431,500,111,'[{0,32081142,2},{0,34010001,2}]'),(431,500,112,'[{0,32081142,2},{0,34010001,2}]'),(431,500,113,'[{0,32081142,2},{0,34010001,2}]'),(431,500,114,'[{0,32081142,2},{0,34010001,2}]'),(431,500,115,'[{0,32081142,2},{0,34010001,2}]'),(431,500,116,'[{0,32081142,2},{0,34010001,2}]'),(431,500,117,'[{0,32081142,2},{0,34010001,2}]'),(431,500,118,'[{0,32081142,2},{0,34010001,2}]'),(431,500,119,'[{0,32081142,2},{0,34010001,2}]'),(431,500,120,'[{0,32081142,2},{0,34010001,2}]'),(431,500,121,'[{0,32081142,2},{0,34010001,2}]'),(431,500,122,'[{0,32081142,2},{0,34010001,2}]'),(431,500,123,'[{0,32081142,2},{0,34010001,2}]'),(431,500,124,'[{0,32081142,2},{0,34010001,2}]'),(431,500,125,'[{0,32081142,2},{0,34010001,2}]'),(431,500,126,'[{0,32081142,2},{0,34010001,2}]'),(431,500,127,'[{0,32081142,2},{0,34010001,2}]'),(431,500,128,'[{0,32081142,2},{0,34010001,2}]'),(431,500,129,'[{0,32081142,2},{0,34010001,2}]'),(431,500,130,'[{0,32081142,2},{0,34010001,2}]'),(431,500,131,'[{0,32081142,2},{0,34010001,2}]'),(431,500,132,'[{0,32081142,2},{0,34010001,2}]'),(431,500,133,'[{0,32081142,2},{0,34010001,2}]'),(431,500,134,'[{0,32081142,2},{0,34010001,2}]'),(431,500,135,'[{0,32081142,2},{0,34010001,2}]'),(431,500,136,'[{0,32081142,2},{0,34010001,2}]'),(431,500,137,'[{0,32081142,2},{0,34010001,2}]'),(431,500,138,'[{0,32081142,2},{0,34010001,2}]'),(431,500,139,'[{0,32081142,2},{0,34010001,2}]'),(431,500,140,'[{0,32081142,2},{0,34010001,2}]'),(431,500,141,'[{0,32081142,2},{0,34010001,2}]'),(431,500,142,'[{0,32081142,2},{0,34010001,2}]'),(431,500,143,'[{0,32081142,2},{0,34010001,2}]'),(431,500,144,'[{0,32081142,2},{0,34010001,2}]'),(431,500,145,'[{0,32081142,2},{0,34010001,2}]'),(431,500,146,'[{0,32081142,2},{0,34010001,2}]'),(431,500,147,'[{0,32081142,2},{0,34010001,2}]'),(431,500,148,'[{0,32081142,2},{0,34010001,2}]'),(431,500,149,'[{0,32081142,2},{0,34010001,2}]'),(431,500,150,'[{0,32081142,2},{0,34010001,2}]'),(431,500,151,'[{0,32081142,2},{0,34010001,2}]'),(431,500,152,'[{0,32081142,2},{0,34010001,2}]'),(431,500,153,'[{0,32081142,2},{0,34010001,2}]'),(431,500,154,'[{0,32081142,2},{0,34010001,2}]'),(431,500,155,'[{0,32081142,2},{0,34010001,2}]'),(431,500,156,'[{0,32081142,2},{0,34010001,2}]'),(431,500,157,'[{0,32081142,2},{0,34010001,2}]'),(431,500,158,'[{0,32081142,2},{0,34010001,2}]'),(431,500,159,'[{0,32081142,2},{0,34010001,2}]'),(431,500,160,'[{0,32081142,2},{0,34010001,2}]'),(431,500,161,'[{0,32081142,2},{0,34010001,2}]'),(431,500,162,'[{0,32081142,2},{0,34010001,2}]'),(431,500,163,'[{0,32081142,2},{0,34010001,2}]'),(431,500,164,'[{0,32081142,2},{0,34010001,2}]'),(431,500,165,'[{0,32081142,2},{0,34010001,2}]'),(431,500,166,'[{0,32081142,2},{0,34010001,2}]'),(431,500,167,'[{0,32081142,2},{0,34010001,2}]'),(431,500,168,'[{0,32081142,2},{0,34010001,2}]'),(431,500,169,'[{0,32081142,2},{0,34010001,2}]'),(431,500,170,'[{0,32081142,2},{0,34010001,2}]'),(431,500,171,'[{0,32081142,2},{0,34010001,2}]'),(431,500,172,'[{0,32081142,2},{0,34010001,2}]'),(431,500,173,'[{0,32081142,2},{0,34010001,2}]'),(431,500,174,'[{0,32081142,2},{0,34010001,2}]'),(431,500,175,'[{0,32081142,2},{0,34010001,2}]'),(431,500,176,'[{0,32081142,2},{0,34010001,2}]'),(431,500,177,'[{0,32081142,2},{0,34010001,2}]'),(431,500,178,'[{0,32081142,2},{0,34010001,2}]'),(431,500,179,'[{0,32081142,2},{0,34010001,2}]'),(431,500,180,'[{0,32081142,2},{0,34010001,2}]'),(431,500,181,'[{0,32081142,2},{0,34010001,2}]'),(431,500,182,'[{0,32081142,2},{0,34010001,2}]'),(431,500,183,'[{0,32081142,2},{0,34010001,2}]'),(431,500,184,'[{0,32081142,2},{0,34010001,2}]'),(431,500,185,'[{0,32081142,2},{0,34010001,2}]'),(431,500,186,'[{0,32081142,2},{0,34010001,2}]'),(431,500,187,'[{0,32081142,2},{0,34010001,2}]'),(431,500,188,'[{0,32081142,2},{0,34010001,2}]'),(431,500,189,'[{0,32081142,2},{0,34010001,2}]'),(431,500,190,'[{0,32081142,2},{0,34010001,2}]'),(431,500,191,'[{0,32081142,2},{0,34010001,2}]'),(431,500,192,'[{0,32081142,2},{0,34010001,2}]'),(431,500,193,'[{0,32081142,2},{0,34010001,2}]'),(431,500,194,'[{0,32081142,2},{0,34010001,2}]'),(431,500,195,'[{0,32081142,2},{0,34010001,2}]'),(431,500,196,'[{0,32081142,2},{0,34010001,2}]'),(431,500,197,'[{0,32081142,2},{0,34010001,2}]'),(431,500,198,'[{0,32081142,2},{0,34010001,2}]'),(431,500,199,'[{0,32081142,2},{0,34010001,2}]'),(431,500,200,'[{0,32081142,2},{0,34010001,2}]'),(431,500,201,'[{0,32081142,2},{0,34010001,2}]'),(431,500,202,'[{0,32081142,2},{0,34010001,2}]'),(431,500,203,'[{0,32081142,2},{0,34010001,2}]'),(431,500,204,'[{0,32081142,2},{0,34010001,2}]'),(431,500,205,'[{0,32081142,2},{0,34010001,2}]'),(431,500,206,'[{0,32081142,2},{0,34010001,2}]'),(431,500,207,'[{0,32081142,2},{0,34010001,2}]'),(431,500,208,'[{0,32081142,2},{0,34010001,2}]'),(431,500,209,'[{0,32081142,2},{0,34010001,2}]'),(431,500,210,'[{0,32081142,2},{0,34010001,2}]'),(431,500,211,'[{0,32081142,2},{0,34010001,2}]'),(431,500,212,'[{0,32081142,2},{0,34010001,2}]'),(431,500,213,'[{0,32081142,2},{0,34010001,2}]'),(431,500,214,'[{0,32081142,2},{0,34010001,2}]'),(431,500,215,'[{0,32081142,2},{0,34010001,2}]'),(431,500,216,'[{0,32081142,2},{0,34010001,2}]'),(431,500,217,'[{0,32081142,2},{0,34010001,2}]'),(431,500,218,'[{0,32081142,2},{0,34010001,2}]'),(501,560,1,'[{0,32081242,1}]'),(501,560,2,'[{0,32081242,1}]'),(501,560,3,'[{0,32081242,1}]'),(501,560,4,'[{0,32081242,1}]'),(501,560,5,'[{0,32081242,1},{0,34010001,1}]'),(501,560,6,'[{0,32081242,1},{0,34010001,1}]'),(501,560,7,'[{0,32081242,1},{0,34010001,1}]'),(501,560,8,'[{0,32081242,1},{0,34010001,1}]'),(501,560,9,'[{0,32081242,1},{0,34010001,1}]'),(501,560,10,'[{0,32081242,1},{0,34010001,1}]'),(501,560,11,'[{0,32081242,1},{0,34010001,1}]'),(501,560,12,'[{0,32081242,1},{0,34010001,1}]'),(501,560,13,'[{0,32081242,1},{0,34010001,1}]'),(501,560,14,'[{0,32081242,1},{0,34010001,1}]'),(501,560,15,'[{0,32081242,1},{0,34010001,1}]'),(501,560,16,'[{0,32081242,1},{0,34010001,1}]'),(501,560,17,'[{0,32081242,1},{0,34010001,1}]'),(501,560,18,'[{0,32081242,1},{0,34010001,1}]'),(501,560,19,'[{0,32081242,1},{0,34010001,1}]'),(501,560,20,'[{0,32081242,1},{0,34010001,1}]'),(501,560,21,'[{0,32081242,2},{0,34010001,2}]'),(501,560,22,'[{0,32081242,2},{0,34010001,2}]'),(501,560,23,'[{0,32081242,2},{0,34010001,2}]'),(501,560,24,'[{0,32081242,2},{0,34010001,2}]'),(501,560,25,'[{0,32081242,2},{0,34010001,2}]'),(501,560,26,'[{0,32081242,2},{0,34010001,2}]'),(501,560,27,'[{0,32081242,2},{0,34010001,2}]'),(501,560,28,'[{0,32081242,2},{0,34010001,2}]'),(501,560,29,'[{0,32081242,2},{0,34010001,2}]'),(501,560,30,'[{0,32081242,2},{0,34010001,2}]'),(501,560,31,'[{0,32081242,2},{0,34010001,2}]'),(501,560,32,'[{0,32081242,2},{0,34010001,2}]'),(501,560,33,'[{0,32081242,2},{0,34010001,2}]'),(501,560,34,'[{0,32081242,2},{0,34010001,2}]'),(501,560,35,'[{0,32081242,2},{0,34010001,2}]'),(501,560,36,'[{0,32081242,2},{0,34010001,2}]'),(501,560,37,'[{0,32081242,2},{0,34010001,2}]'),(501,560,38,'[{0,32081242,2},{0,34010001,2}]'),(501,560,39,'[{0,32081242,2},{0,34010001,2}]'),(501,560,40,'[{0,32081242,2},{0,34010001,2}]'),(501,560,41,'[{0,32081242,2},{0,34010001,2}]'),(501,560,42,'[{0,32081242,2},{0,34010001,2}]'),(501,560,43,'[{0,32081242,2},{0,34010001,2}]'),(501,560,44,'[{0,32081242,2},{0,34010001,2}]'),(501,560,45,'[{0,32081242,2},{0,34010001,2}]'),(501,560,46,'[{0,32081242,2},{0,34010001,2}]'),(501,560,47,'[{0,32081242,2},{0,34010001,2}]'),(501,560,48,'[{0,32081242,2},{0,34010001,2}]'),(501,560,49,'[{0,32081242,2},{0,34010001,2}]'),(501,560,50,'[{0,32081242,2},{0,34010001,2}]'),(501,560,51,'[{0,32081242,2},{0,34010001,2}]'),(501,560,52,'[{0,32081242,2},{0,34010001,2}]'),(501,560,53,'[{0,32081242,2},{0,34010001,2}]'),(501,560,54,'[{0,32081242,2},{0,34010001,2}]'),(501,560,55,'[{0,32081242,2},{0,34010001,2}]'),(501,560,56,'[{0,32081242,2},{0,34010001,2}]'),(501,560,57,'[{0,32081242,2},{0,34010001,2}]'),(501,560,58,'[{0,32081242,2},{0,34010001,2}]'),(501,560,59,'[{0,32081242,2},{0,34010001,2}]'),(501,560,60,'[{0,32081242,2},{0,34010001,2}]'),(501,560,61,'[{0,32081242,2},{0,34010001,2}]'),(501,560,62,'[{0,32081242,2},{0,34010001,2}]'),(501,560,63,'[{0,32081242,2},{0,34010001,2}]'),(501,560,64,'[{0,32081242,2},{0,34010001,2}]'),(501,560,65,'[{0,32081242,2},{0,34010001,2}]'),(501,560,66,'[{0,32081242,2},{0,34010001,2}]'),(501,560,67,'[{0,32081242,2},{0,34010001,2}]'),(501,560,68,'[{0,32081242,2},{0,34010001,2}]'),(501,560,69,'[{0,32081242,2},{0,34010001,2}]'),(501,560,70,'[{0,32081242,2},{0,34010001,2}]'),(501,560,71,'[{0,32081242,2},{0,34010001,2}]'),(501,560,72,'[{0,32081242,2},{0,34010001,2}]'),(501,560,73,'[{0,32081242,2},{0,34010001,2}]'),(501,560,74,'[{0,32081242,2},{0,34010001,2}]'),(501,560,75,'[{0,32081242,2},{0,34010001,2}]'),(501,560,76,'[{0,32081242,2},{0,34010001,2}]'),(501,560,77,'[{0,32081242,2},{0,34010001,2}]'),(501,560,78,'[{0,32081242,2},{0,34010001,2}]'),(501,560,79,'[{0,32081242,2},{0,34010001,2}]'),(501,560,80,'[{0,32081242,2},{0,34010001,2}]'),(501,560,81,'[{0,32081242,2},{0,34010001,2}]'),(501,560,82,'[{0,32081242,2},{0,34010001,2}]'),(501,560,83,'[{0,32081242,2},{0,34010001,2}]'),(501,560,84,'[{0,32081242,2},{0,34010001,2}]'),(501,560,85,'[{0,32081242,2},{0,34010001,2}]'),(501,560,86,'[{0,32081242,2},{0,34010001,2}]'),(501,560,87,'[{0,32081242,2},{0,34010001,2}]'),(501,560,88,'[{0,32081242,2},{0,34010001,2}]'),(501,560,89,'[{0,32081242,2},{0,34010001,2}]'),(501,560,90,'[{0,32081242,2},{0,34010001,2}]'),(501,560,91,'[{0,32081242,2},{0,34010001,2}]'),(501,560,92,'[{0,32081242,2},{0,34010001,2}]'),(501,560,93,'[{0,32081242,2},{0,34010001,2}]'),(501,560,94,'[{0,32081242,2},{0,34010001,2}]'),(501,560,95,'[{0,32081242,2},{0,34010001,2}]'),(501,560,96,'[{0,32081242,2},{0,34010001,2}]'),(501,560,97,'[{0,32081242,2},{0,34010001,2}]'),(501,560,98,'[{0,32081242,2},{0,34010001,2}]'),(501,560,99,'[{0,32081242,2},{0,34010001,2}]'),(501,560,100,'[{0,32081242,2},{0,34010001,2}]'),(501,560,101,'[{0,32081242,2},{0,34010001,2}]'),(501,560,102,'[{0,32081242,2},{0,34010001,2}]'),(501,560,103,'[{0,32081242,2},{0,34010001,2}]'),(501,560,104,'[{0,32081242,2},{0,34010001,2}]'),(501,560,105,'[{0,32081242,2},{0,34010001,2}]'),(501,560,106,'[{0,32081242,2},{0,34010001,2}]'),(501,560,107,'[{0,32081242,2},{0,34010001,2}]'),(501,560,108,'[{0,32081242,2},{0,34010001,2}]'),(501,560,109,'[{0,32081242,2},{0,34010001,2}]'),(501,560,110,'[{0,32081242,2},{0,34010001,2}]'),(501,560,111,'[{0,32081242,2},{0,34010001,2}]'),(501,560,112,'[{0,32081242,2},{0,34010001,2}]'),(501,560,113,'[{0,32081242,2},{0,34010001,2}]'),(501,560,114,'[{0,32081242,2},{0,34010001,2}]'),(501,560,115,'[{0,32081242,2},{0,34010001,2}]'),(501,560,116,'[{0,32081242,2},{0,34010001,2}]'),(501,560,117,'[{0,32081242,2},{0,34010001,2}]'),(501,560,118,'[{0,32081242,2},{0,34010001,2}]'),(501,560,119,'[{0,32081242,2},{0,34010001,2}]'),(501,560,120,'[{0,32081242,2},{0,34010001,2}]'),(501,560,121,'[{0,32081242,2},{0,34010001,2}]'),(501,560,122,'[{0,32081242,2},{0,34010001,2}]'),(501,560,123,'[{0,32081242,2},{0,34010001,2}]'),(501,560,124,'[{0,32081242,2},{0,34010001,2}]'),(501,560,125,'[{0,32081242,2},{0,34010001,2}]'),(501,560,126,'[{0,32081242,2},{0,34010001,2}]'),(501,560,127,'[{0,32081242,2},{0,34010001,2}]'),(501,560,128,'[{0,32081242,2},{0,34010001,2}]'),(501,560,129,'[{0,32081242,2},{0,34010001,2}]'),(501,560,130,'[{0,32081242,2},{0,34010001,2}]'),(501,560,131,'[{0,32081242,2},{0,34010001,2}]'),(501,560,132,'[{0,32081242,2},{0,34010001,2}]'),(501,560,133,'[{0,32081242,2},{0,34010001,2}]'),(501,560,134,'[{0,32081242,2},{0,34010001,2}]'),(501,560,135,'[{0,32081242,2},{0,34010001,2}]'),(501,560,136,'[{0,32081242,2},{0,34010001,2}]'),(501,560,137,'[{0,32081242,2},{0,34010001,2}]'),(501,560,138,'[{0,32081242,2},{0,34010001,2}]'),(501,560,139,'[{0,32081242,2},{0,34010001,2}]'),(501,560,140,'[{0,32081242,2},{0,34010001,2}]'),(501,560,141,'[{0,32081242,2},{0,34010001,2}]'),(501,560,142,'[{0,32081242,2},{0,34010001,2}]'),(501,560,143,'[{0,32081242,2},{0,34010001,2}]'),(501,560,144,'[{0,32081242,2},{0,34010001,2}]'),(501,560,145,'[{0,32081242,2},{0,34010001,2}]'),(501,560,146,'[{0,32081242,2},{0,34010001,2}]'),(501,560,147,'[{0,32081242,2},{0,34010001,2}]'),(501,560,148,'[{0,32081242,2},{0,34010001,2}]'),(501,560,149,'[{0,32081242,2},{0,34010001,2}]'),(501,560,150,'[{0,32081242,2},{0,34010001,2}]'),(501,560,151,'[{0,32081242,2},{0,34010001,2}]'),(501,560,152,'[{0,32081242,2},{0,34010001,2}]'),(501,560,153,'[{0,32081242,2},{0,34010001,2}]'),(501,560,154,'[{0,32081242,2},{0,34010001,2}]'),(501,560,155,'[{0,32081242,2},{0,34010001,2}]'),(501,560,156,'[{0,32081242,2},{0,34010001,2}]'),(501,560,157,'[{0,32081242,2},{0,34010001,2}]'),(501,560,158,'[{0,32081242,2},{0,34010001,2}]'),(501,560,159,'[{0,32081242,2},{0,34010001,2}]'),(501,560,160,'[{0,32081242,2},{0,34010001,2}]'),(501,560,161,'[{0,32081242,2},{0,34010001,2}]'),(501,560,162,'[{0,32081242,2},{0,34010001,2}]'),(501,560,163,'[{0,32081242,2},{0,34010001,2}]'),(501,560,164,'[{0,32081242,2},{0,34010001,2}]'),(501,560,165,'[{0,32081242,2},{0,34010001,2}]'),(501,560,166,'[{0,32081242,2},{0,34010001,2}]'),(501,560,167,'[{0,32081242,2},{0,34010001,2}]'),(501,560,168,'[{0,32081242,2},{0,34010001,2}]'),(501,560,169,'[{0,32081242,2},{0,34010001,2}]'),(501,560,170,'[{0,32081242,2},{0,34010001,2}]'),(501,560,171,'[{0,32081242,2},{0,34010001,2}]'),(501,560,172,'[{0,32081242,2},{0,34010001,2}]'),(501,560,173,'[{0,32081242,2},{0,34010001,2}]'),(501,560,174,'[{0,32081242,2},{0,34010001,2}]'),(501,560,175,'[{0,32081242,2},{0,34010001,2}]'),(501,560,176,'[{0,32081242,2},{0,34010001,2}]'),(501,560,177,'[{0,32081242,2},{0,34010001,2}]'),(501,560,178,'[{0,32081242,2},{0,34010001,2}]'),(501,560,179,'[{0,32081242,2},{0,34010001,2}]'),(501,560,180,'[{0,32081242,2},{0,34010001,2}]'),(501,560,181,'[{0,32081242,2},{0,34010001,2}]'),(501,560,182,'[{0,32081242,2},{0,34010001,2}]'),(501,560,183,'[{0,32081242,2},{0,34010001,2}]'),(501,560,184,'[{0,32081242,2},{0,34010001,2}]'),(501,560,185,'[{0,32081242,2},{0,34010001,2}]'),(501,560,186,'[{0,32081242,2},{0,34010001,2}]'),(501,560,187,'[{0,32081242,2},{0,34010001,2}]'),(501,560,188,'[{0,32081242,2},{0,34010001,2}]'),(501,560,189,'[{0,32081242,2},{0,34010001,2}]'),(501,560,190,'[{0,32081242,2},{0,34010001,2}]'),(501,560,191,'[{0,32081242,2},{0,34010001,2}]'),(501,560,192,'[{0,32081242,2},{0,34010001,2}]'),(501,560,193,'[{0,32081242,2},{0,34010001,2}]'),(501,560,194,'[{0,32081242,2},{0,34010001,2}]'),(501,560,195,'[{0,32081242,2},{0,34010001,2}]'),(501,560,196,'[{0,32081242,2},{0,34010001,2}]'),(501,560,197,'[{0,32081242,2},{0,34010001,2}]'),(501,560,198,'[{0,32081242,2},{0,34010001,2}]'),(501,560,199,'[{0,32081242,2},{0,34010001,2}]'),(501,560,200,'[{0,32081242,2},{0,34010001,2}]'),(501,560,201,'[{0,32081242,2},{0,34010001,2}]'),(501,560,202,'[{0,32081242,2},{0,34010001,2}]'),(501,560,203,'[{0,32081242,2},{0,34010001,2}]'),(501,560,204,'[{0,32081242,2},{0,34010001,2}]'),(501,560,205,'[{0,32081242,2},{0,34010001,2}]'),(501,560,206,'[{0,32081242,2},{0,34010001,2}]'),(501,560,207,'[{0,32081242,2},{0,34010001,2}]'),(501,560,208,'[{0,32081242,2},{0,34010001,2}]'),(501,560,209,'[{0,32081242,2},{0,34010001,2}]'),(501,560,210,'[{0,32081242,2},{0,34010001,2}]'),(501,560,211,'[{0,32081242,2},{0,34010001,2}]'),(501,560,212,'[{0,32081242,2},{0,34010001,2}]'),(501,560,213,'[{0,32081242,2},{0,34010001,2}]'),(501,560,214,'[{0,32081242,2},{0,34010001,2}]'),(501,560,215,'[{0,32081242,2},{0,34010001,2}]'),(501,560,216,'[{0,32081242,2},{0,34010001,2}]'),(501,560,217,'[{0,32081242,2},{0,34010001,2}]'),(501,560,218,'[{0,32081242,2},{0,34010001,2}]'),(561,610,1,'[{0,32081342,1}]'),(561,610,2,'[{0,32081342,1}]'),(561,610,3,'[{0,32081342,1}]'),(561,610,4,'[{0,32081342,1}]'),(561,610,5,'[{0,32081342,1},{0,34010001,1}]'),(561,610,6,'[{0,32081342,1},{0,34010001,1}]'),(561,610,7,'[{0,32081342,1},{0,34010001,1}]'),(561,610,8,'[{0,32081342,1},{0,34010001,1}]'),(561,610,9,'[{0,32081342,1},{0,34010001,1}]'),(561,610,10,'[{0,32081342,1},{0,34010001,1}]'),(561,610,11,'[{0,32081342,1},{0,34010001,1}]'),(561,610,12,'[{0,32081342,1},{0,34010001,1}]'),(561,610,13,'[{0,32081342,1},{0,34010001,1}]'),(561,610,14,'[{0,32081342,1},{0,34010001,1}]'),(561,610,15,'[{0,32081342,1},{0,34010001,1}]'),(561,610,16,'[{0,32081342,1},{0,34010001,1}]'),(561,610,17,'[{0,32081342,1},{0,34010001,1}]'),(561,610,18,'[{0,32081342,1},{0,34010001,1}]'),(561,610,19,'[{0,32081342,1},{0,34010001,1}]'),(561,610,20,'[{0,32081342,1},{0,34010001,1}]'),(561,610,21,'[{0,32081342,2},{0,34010001,2}]'),(561,610,22,'[{0,32081342,2},{0,34010001,2}]'),(561,610,23,'[{0,32081342,2},{0,34010001,2}]'),(561,610,24,'[{0,32081342,2},{0,34010001,2}]'),(561,610,25,'[{0,32081342,2},{0,34010001,2}]'),(561,610,26,'[{0,32081342,2},{0,34010001,2}]'),(561,610,27,'[{0,32081342,2},{0,34010001,2}]'),(561,610,28,'[{0,32081342,2},{0,34010001,2}]'),(561,610,29,'[{0,32081342,2},{0,34010001,2}]'),(561,610,30,'[{0,32081342,2},{0,34010001,2}]'),(561,610,31,'[{0,32081342,2},{0,34010001,2}]'),(561,610,32,'[{0,32081342,2},{0,34010001,2}]'),(561,610,33,'[{0,32081342,2},{0,34010001,2}]'),(561,610,34,'[{0,32081342,2},{0,34010001,2}]'),(561,610,35,'[{0,32081342,2},{0,34010001,2}]'),(561,610,36,'[{0,32081342,2},{0,34010001,2}]'),(561,610,37,'[{0,32081342,2},{0,34010001,2}]'),(561,610,38,'[{0,32081342,2},{0,34010001,2}]'),(561,610,39,'[{0,32081342,2},{0,34010001,2}]'),(561,610,40,'[{0,32081342,2},{0,34010001,2}]'),(561,610,41,'[{0,32081342,2},{0,34010001,2}]'),(561,610,42,'[{0,32081342,2},{0,34010001,2}]'),(561,610,43,'[{0,32081342,2},{0,34010001,2}]'),(561,610,44,'[{0,32081342,2},{0,34010001,2}]'),(561,610,45,'[{0,32081342,2},{0,34010001,2}]'),(561,610,46,'[{0,32081342,2},{0,34010001,2}]'),(561,610,47,'[{0,32081342,2},{0,34010001,2}]'),(561,610,48,'[{0,32081342,2},{0,34010001,2}]'),(561,610,49,'[{0,32081342,2},{0,34010001,2}]'),(561,610,50,'[{0,32081342,2},{0,34010001,2}]'),(561,610,51,'[{0,32081342,2},{0,34010001,2}]'),(561,610,52,'[{0,32081342,2},{0,34010001,2}]'),(561,610,53,'[{0,32081342,2},{0,34010001,2}]'),(561,610,54,'[{0,32081342,2},{0,34010001,2}]'),(561,610,55,'[{0,32081342,2},{0,34010001,2}]'),(561,610,56,'[{0,32081342,2},{0,34010001,2}]'),(561,610,57,'[{0,32081342,2},{0,34010001,2}]'),(561,610,58,'[{0,32081342,2},{0,34010001,2}]'),(561,610,59,'[{0,32081342,2},{0,34010001,2}]'),(561,610,60,'[{0,32081342,2},{0,34010001,2}]'),(561,610,61,'[{0,32081342,2},{0,34010001,2}]'),(561,610,62,'[{0,32081342,2},{0,34010001,2}]'),(561,610,63,'[{0,32081342,2},{0,34010001,2}]'),(561,610,64,'[{0,32081342,2},{0,34010001,2}]'),(561,610,65,'[{0,32081342,2},{0,34010001,2}]'),(561,610,66,'[{0,32081342,2},{0,34010001,2}]'),(561,610,67,'[{0,32081342,2},{0,34010001,2}]'),(561,610,68,'[{0,32081342,2},{0,34010001,2}]'),(561,610,69,'[{0,32081342,2},{0,34010001,2}]'),(561,610,70,'[{0,32081342,2},{0,34010001,2}]'),(561,610,71,'[{0,32081342,2},{0,34010001,2}]'),(561,610,72,'[{0,32081342,2},{0,34010001,2}]'),(561,610,73,'[{0,32081342,2},{0,34010001,2}]'),(561,610,74,'[{0,32081342,2},{0,34010001,2}]'),(561,610,75,'[{0,32081342,2},{0,34010001,2}]'),(561,610,76,'[{0,32081342,2},{0,34010001,2}]'),(561,610,77,'[{0,32081342,2},{0,34010001,2}]'),(561,610,78,'[{0,32081342,2},{0,34010001,2}]'),(561,610,79,'[{0,32081342,2},{0,34010001,2}]'),(561,610,80,'[{0,32081342,2},{0,34010001,2}]'),(561,610,81,'[{0,32081342,2},{0,34010001,2}]'),(561,610,82,'[{0,32081342,2},{0,34010001,2}]'),(561,610,83,'[{0,32081342,2},{0,34010001,2}]'),(561,610,84,'[{0,32081342,2},{0,34010001,2}]'),(561,610,85,'[{0,32081342,2},{0,34010001,2}]'),(561,610,86,'[{0,32081342,2},{0,34010001,2}]'),(561,610,87,'[{0,32081342,2},{0,34010001,2}]'),(561,610,88,'[{0,32081342,2},{0,34010001,2}]'),(561,610,89,'[{0,32081342,2},{0,34010001,2}]'),(561,610,90,'[{0,32081342,2},{0,34010001,2}]'),(561,610,91,'[{0,32081342,2},{0,34010001,2}]'),(561,610,92,'[{0,32081342,2},{0,34010001,2}]'),(561,610,93,'[{0,32081342,2},{0,34010001,2}]'),(561,610,94,'[{0,32081342,2},{0,34010001,2}]'),(561,610,95,'[{0,32081342,2},{0,34010001,2}]'),(561,610,96,'[{0,32081342,2},{0,34010001,2}]'),(561,610,97,'[{0,32081342,2},{0,34010001,2}]'),(561,610,98,'[{0,32081342,2},{0,34010001,2}]'),(561,610,99,'[{0,32081342,2},{0,34010001,2}]'),(561,610,100,'[{0,32081342,2},{0,34010001,2}]'),(561,610,101,'[{0,32081342,2},{0,34010001,2}]'),(561,610,102,'[{0,32081342,2},{0,34010001,2}]'),(561,610,103,'[{0,32081342,2},{0,34010001,2}]'),(561,610,104,'[{0,32081342,2},{0,34010001,2}]'),(561,610,105,'[{0,32081342,2},{0,34010001,2}]'),(561,610,106,'[{0,32081342,2},{0,34010001,2}]'),(561,610,107,'[{0,32081342,2},{0,34010001,2}]'),(561,610,108,'[{0,32081342,2},{0,34010001,2}]'),(561,610,109,'[{0,32081342,2},{0,34010001,2}]'),(561,610,110,'[{0,32081342,2},{0,34010001,2}]'),(561,610,111,'[{0,32081342,2},{0,34010001,2}]'),(561,610,112,'[{0,32081342,2},{0,34010001,2}]'),(561,610,113,'[{0,32081342,2},{0,34010001,2}]'),(561,610,114,'[{0,32081342,2},{0,34010001,2}]'),(561,610,115,'[{0,32081342,2},{0,34010001,2}]'),(561,610,116,'[{0,32081342,2},{0,34010001,2}]'),(561,610,117,'[{0,32081342,2},{0,34010001,2}]'),(561,610,118,'[{0,32081342,2},{0,34010001,2}]'),(561,610,119,'[{0,32081342,2},{0,34010001,2}]'),(561,610,120,'[{0,32081342,2},{0,34010001,2}]'),(561,610,121,'[{0,32081342,2},{0,34010001,2}]'),(561,610,122,'[{0,32081342,2},{0,34010001,2}]'),(561,610,123,'[{0,32081342,2},{0,34010001,2}]'),(561,610,124,'[{0,32081342,2},{0,34010001,2}]'),(561,610,125,'[{0,32081342,2},{0,34010001,2}]'),(561,610,126,'[{0,32081342,2},{0,34010001,2}]'),(561,610,127,'[{0,32081342,2},{0,34010001,2}]'),(561,610,128,'[{0,32081342,2},{0,34010001,2}]'),(561,610,129,'[{0,32081342,2},{0,34010001,2}]'),(561,610,130,'[{0,32081342,2},{0,34010001,2}]'),(561,610,131,'[{0,32081342,2},{0,34010001,2}]'),(561,610,132,'[{0,32081342,2},{0,34010001,2}]'),(561,610,133,'[{0,32081342,2},{0,34010001,2}]'),(561,610,134,'[{0,32081342,2},{0,34010001,2}]'),(561,610,135,'[{0,32081342,2},{0,34010001,2}]'),(561,610,136,'[{0,32081342,2},{0,34010001,2}]'),(561,610,137,'[{0,32081342,2},{0,34010001,2}]'),(561,610,138,'[{0,32081342,2},{0,34010001,2}]'),(561,610,139,'[{0,32081342,2},{0,34010001,2}]'),(561,610,140,'[{0,32081342,2},{0,34010001,2}]'),(561,610,141,'[{0,32081342,2},{0,34010001,2}]'),(561,610,142,'[{0,32081342,2},{0,34010001,2}]'),(561,610,143,'[{0,32081342,2},{0,34010001,2}]'),(561,610,144,'[{0,32081342,2},{0,34010001,2}]'),(561,610,145,'[{0,32081342,2},{0,34010001,2}]'),(561,610,146,'[{0,32081342,2},{0,34010001,2}]'),(561,610,147,'[{0,32081342,2},{0,34010001,2}]'),(561,610,148,'[{0,32081342,2},{0,34010001,2}]'),(561,610,149,'[{0,32081342,2},{0,34010001,2}]'),(561,610,150,'[{0,32081342,2},{0,34010001,2}]'),(561,610,151,'[{0,32081342,2},{0,34010001,2}]'),(561,610,152,'[{0,32081342,2},{0,34010001,2}]'),(561,610,153,'[{0,32081342,2},{0,34010001,2}]'),(561,610,154,'[{0,32081342,2},{0,34010001,2}]'),(561,610,155,'[{0,32081342,2},{0,34010001,2}]'),(561,610,156,'[{0,32081342,2},{0,34010001,2}]'),(561,610,157,'[{0,32081342,2},{0,34010001,2}]'),(561,610,158,'[{0,32081342,2},{0,34010001,2}]'),(561,610,159,'[{0,32081342,2},{0,34010001,2}]'),(561,610,160,'[{0,32081342,2},{0,34010001,2}]'),(561,610,161,'[{0,32081342,2},{0,34010001,2}]'),(561,610,162,'[{0,32081342,2},{0,34010001,2}]'),(561,610,163,'[{0,32081342,2},{0,34010001,2}]'),(561,610,164,'[{0,32081342,2},{0,34010001,2}]'),(561,610,165,'[{0,32081342,2},{0,34010001,2}]'),(561,610,166,'[{0,32081342,2},{0,34010001,2}]'),(561,610,167,'[{0,32081342,2},{0,34010001,2}]'),(561,610,168,'[{0,32081342,2},{0,34010001,2}]'),(561,610,169,'[{0,32081342,2},{0,34010001,2}]'),(561,610,170,'[{0,32081342,2},{0,34010001,2}]'),(561,610,171,'[{0,32081342,2},{0,34010001,2}]'),(561,610,172,'[{0,32081342,2},{0,34010001,2}]'),(561,610,173,'[{0,32081342,2},{0,34010001,2}]'),(561,610,174,'[{0,32081342,2},{0,34010001,2}]'),(561,610,175,'[{0,32081342,2},{0,34010001,2}]'),(561,610,176,'[{0,32081342,2},{0,34010001,2}]'),(561,610,177,'[{0,32081342,2},{0,34010001,2}]'),(561,610,178,'[{0,32081342,2},{0,34010001,2}]'),(561,610,179,'[{0,32081342,2},{0,34010001,2}]'),(561,610,180,'[{0,32081342,2},{0,34010001,2}]'),(561,610,181,'[{0,32081342,2},{0,34010001,2}]'),(561,610,182,'[{0,32081342,2},{0,34010001,2}]'),(561,610,183,'[{0,32081342,2},{0,34010001,2}]'),(561,610,184,'[{0,32081342,2},{0,34010001,2}]'),(561,610,185,'[{0,32081342,2},{0,34010001,2}]'),(561,610,186,'[{0,32081342,2},{0,34010001,2}]'),(561,610,187,'[{0,32081342,2},{0,34010001,2}]'),(561,610,188,'[{0,32081342,2},{0,34010001,2}]'),(561,610,189,'[{0,32081342,2},{0,34010001,2}]'),(561,610,190,'[{0,32081342,2},{0,34010001,2}]'),(561,610,191,'[{0,32081342,2},{0,34010001,2}]'),(561,610,192,'[{0,32081342,2},{0,34010001,2}]'),(561,610,193,'[{0,32081342,2},{0,34010001,2}]'),(561,610,194,'[{0,32081342,2},{0,34010001,2}]'),(561,610,195,'[{0,32081342,2},{0,34010001,2}]'),(561,610,196,'[{0,32081342,2},{0,34010001,2}]'),(561,610,197,'[{0,32081342,2},{0,34010001,2}]'),(561,610,198,'[{0,32081342,2},{0,34010001,2}]'),(561,610,199,'[{0,32081342,2},{0,34010001,2}]'),(561,610,200,'[{0,32081342,2},{0,34010001,2}]'),(561,610,201,'[{0,32081342,2},{0,34010001,2}]'),(561,610,202,'[{0,32081342,2},{0,34010001,2}]'),(561,610,203,'[{0,32081342,2},{0,34010001,2}]'),(561,610,204,'[{0,32081342,2},{0,34010001,2}]'),(561,610,205,'[{0,32081342,2},{0,34010001,2}]'),(561,610,206,'[{0,32081342,2},{0,34010001,2}]'),(561,610,207,'[{0,32081342,2},{0,34010001,2}]'),(561,610,208,'[{0,32081342,2},{0,34010001,2}]'),(561,610,209,'[{0,32081342,2},{0,34010001,2}]'),(561,610,210,'[{0,32081342,2},{0,34010001,2}]'),(561,610,211,'[{0,32081342,2},{0,34010001,2}]'),(561,610,212,'[{0,32081342,2},{0,34010001,2}]'),(561,610,213,'[{0,32081342,2},{0,34010001,2}]'),(561,610,214,'[{0,32081342,2},{0,34010001,2}]'),(561,610,215,'[{0,32081342,2},{0,34010001,2}]'),(561,610,216,'[{0,32081342,2},{0,34010001,2}]'),(561,610,217,'[{0,32081342,2},{0,34010001,2}]'),(561,610,218,'[{0,32081342,2},{0,34010001,2}]'),(611,660,1,'[{0,32081442,1}]'),(611,660,2,'[{0,32081442,1}]'),(611,660,3,'[{0,32081442,1}]'),(611,660,4,'[{0,32081442,1}]'),(611,660,5,'[{0,32081442,1},{0,34010001,1}]'),(611,660,6,'[{0,32081442,1},{0,34010001,1}]'),(611,660,7,'[{0,32081442,1},{0,34010001,1}]'),(611,660,8,'[{0,32081442,1},{0,34010001,1}]'),(611,660,9,'[{0,32081442,1},{0,34010001,1}]'),(611,660,10,'[{0,32081442,1},{0,34010001,1}]'),(611,660,11,'[{0,32081442,1},{0,34010001,1}]'),(611,660,12,'[{0,32081442,1},{0,34010001,1}]'),(611,660,13,'[{0,32081442,1},{0,34010001,1}]'),(611,660,14,'[{0,32081442,1},{0,34010001,1}]'),(611,660,15,'[{0,32081442,1},{0,34010001,1}]'),(611,660,16,'[{0,32081442,1},{0,34010001,1}]'),(611,660,17,'[{0,32081442,1},{0,34010001,1}]'),(611,660,18,'[{0,32081442,1},{0,34010001,1}]'),(611,660,19,'[{0,32081442,1},{0,34010001,1}]'),(611,660,20,'[{0,32081442,1},{0,34010001,1}]'),(611,660,21,'[{0,32081442,2},{0,34010001,2}]'),(611,660,22,'[{0,32081442,2},{0,34010001,2}]'),(611,660,23,'[{0,32081442,2},{0,34010001,2}]'),(611,660,24,'[{0,32081442,2},{0,34010001,2}]'),(611,660,25,'[{0,32081442,2},{0,34010001,2}]'),(611,660,26,'[{0,32081442,2},{0,34010001,2}]'),(611,660,27,'[{0,32081442,2},{0,34010001,2}]'),(611,660,28,'[{0,32081442,2},{0,34010001,2}]'),(611,660,29,'[{0,32081442,2},{0,34010001,2}]'),(611,660,30,'[{0,32081442,2},{0,34010001,2}]'),(611,660,31,'[{0,32081442,2},{0,34010001,2}]'),(611,660,32,'[{0,32081442,2},{0,34010001,2}]'),(611,660,33,'[{0,32081442,2},{0,34010001,2}]'),(611,660,34,'[{0,32081442,2},{0,34010001,2}]'),(611,660,35,'[{0,32081442,2},{0,34010001,2}]'),(611,660,36,'[{0,32081442,2},{0,34010001,2}]'),(611,660,37,'[{0,32081442,2},{0,34010001,2}]'),(611,660,38,'[{0,32081442,2},{0,34010001,2}]'),(611,660,39,'[{0,32081442,2},{0,34010001,2}]'),(611,660,40,'[{0,32081442,2},{0,34010001,2}]'),(611,660,41,'[{0,32081442,2},{0,34010001,2}]'),(611,660,42,'[{0,32081442,2},{0,34010001,2}]'),(611,660,43,'[{0,32081442,2},{0,34010001,2}]'),(611,660,44,'[{0,32081442,2},{0,34010001,2}]'),(611,660,45,'[{0,32081442,2},{0,34010001,2}]'),(611,660,46,'[{0,32081442,2},{0,34010001,2}]'),(611,660,47,'[{0,32081442,2},{0,34010001,2}]'),(611,660,48,'[{0,32081442,2},{0,34010001,2}]'),(611,660,49,'[{0,32081442,2},{0,34010001,2}]'),(611,660,50,'[{0,32081442,2},{0,34010001,2}]'),(611,660,51,'[{0,32081442,2},{0,34010001,2}]'),(611,660,52,'[{0,32081442,2},{0,34010001,2}]'),(611,660,53,'[{0,32081442,2},{0,34010001,2}]'),(611,660,54,'[{0,32081442,2},{0,34010001,2}]'),(611,660,55,'[{0,32081442,2},{0,34010001,2}]'),(611,660,56,'[{0,32081442,2},{0,34010001,2}]'),(611,660,57,'[{0,32081442,2},{0,34010001,2}]'),(611,660,58,'[{0,32081442,2},{0,34010001,2}]'),(611,660,59,'[{0,32081442,2},{0,34010001,2}]'),(611,660,60,'[{0,32081442,2},{0,34010001,2}]'),(611,660,61,'[{0,32081442,2},{0,34010001,2}]'),(611,660,62,'[{0,32081442,2},{0,34010001,2}]'),(611,660,63,'[{0,32081442,2},{0,34010001,2}]'),(611,660,64,'[{0,32081442,2},{0,34010001,2}]'),(611,660,65,'[{0,32081442,2},{0,34010001,2}]'),(611,660,66,'[{0,32081442,2},{0,34010001,2}]'),(611,660,67,'[{0,32081442,2},{0,34010001,2}]'),(611,660,68,'[{0,32081442,2},{0,34010001,2}]'),(611,660,69,'[{0,32081442,2},{0,34010001,2}]'),(611,660,70,'[{0,32081442,2},{0,34010001,2}]'),(611,660,71,'[{0,32081442,2},{0,34010001,2}]'),(611,660,72,'[{0,32081442,2},{0,34010001,2}]'),(611,660,73,'[{0,32081442,2},{0,34010001,2}]'),(611,660,74,'[{0,32081442,2},{0,34010001,2}]'),(611,660,75,'[{0,32081442,2},{0,34010001,2}]'),(611,660,76,'[{0,32081442,2},{0,34010001,2}]'),(611,660,77,'[{0,32081442,2},{0,34010001,2}]'),(611,660,78,'[{0,32081442,2},{0,34010001,2}]'),(611,660,79,'[{0,32081442,2},{0,34010001,2}]'),(611,660,80,'[{0,32081442,2},{0,34010001,2}]'),(611,660,81,'[{0,32081442,2},{0,34010001,2}]'),(611,660,82,'[{0,32081442,2},{0,34010001,2}]'),(611,660,83,'[{0,32081442,2},{0,34010001,2}]'),(611,660,84,'[{0,32081442,2},{0,34010001,2}]'),(611,660,85,'[{0,32081442,2},{0,34010001,2}]'),(611,660,86,'[{0,32081442,2},{0,34010001,2}]'),(611,660,87,'[{0,32081442,2},{0,34010001,2}]'),(611,660,88,'[{0,32081442,2},{0,34010001,2}]'),(611,660,89,'[{0,32081442,2},{0,34010001,2}]'),(611,660,90,'[{0,32081442,2},{0,34010001,2}]'),(611,660,91,'[{0,32081442,2},{0,34010001,2}]'),(611,660,92,'[{0,32081442,2},{0,34010001,2}]'),(611,660,93,'[{0,32081442,2},{0,34010001,2}]'),(611,660,94,'[{0,32081442,2},{0,34010001,2}]'),(611,660,95,'[{0,32081442,2},{0,34010001,2}]'),(611,660,96,'[{0,32081442,2},{0,34010001,2}]'),(611,660,97,'[{0,32081442,2},{0,34010001,2}]'),(611,660,98,'[{0,32081442,2},{0,34010001,2}]'),(611,660,99,'[{0,32081442,2},{0,34010001,2}]'),(611,660,100,'[{0,32081442,2},{0,34010001,2}]'),(611,660,101,'[{0,32081442,2},{0,34010001,2}]'),(611,660,102,'[{0,32081442,2},{0,34010001,2}]'),(611,660,103,'[{0,32081442,2},{0,34010001,2}]'),(611,660,104,'[{0,32081442,2},{0,34010001,2}]'),(611,660,105,'[{0,32081442,2},{0,34010001,2}]'),(611,660,106,'[{0,32081442,2},{0,34010001,2}]'),(611,660,107,'[{0,32081442,2},{0,34010001,2}]'),(611,660,108,'[{0,32081442,2},{0,34010001,2}]'),(611,660,109,'[{0,32081442,2},{0,34010001,2}]'),(611,660,110,'[{0,32081442,2},{0,34010001,2}]'),(611,660,111,'[{0,32081442,2},{0,34010001,2}]'),(611,660,112,'[{0,32081442,2},{0,34010001,2}]'),(611,660,113,'[{0,32081442,2},{0,34010001,2}]'),(611,660,114,'[{0,32081442,2},{0,34010001,2}]'),(611,660,115,'[{0,32081442,2},{0,34010001,2}]'),(611,660,116,'[{0,32081442,2},{0,34010001,2}]'),(611,660,117,'[{0,32081442,2},{0,34010001,2}]'),(611,660,118,'[{0,32081442,2},{0,34010001,2}]'),(611,660,119,'[{0,32081442,2},{0,34010001,2}]'),(611,660,120,'[{0,32081442,2},{0,34010001,2}]'),(611,660,121,'[{0,32081442,2},{0,34010001,2}]'),(611,660,122,'[{0,32081442,2},{0,34010001,2}]'),(611,660,123,'[{0,32081442,2},{0,34010001,2}]'),(611,660,124,'[{0,32081442,2},{0,34010001,2}]'),(611,660,125,'[{0,32081442,2},{0,34010001,2}]'),(611,660,126,'[{0,32081442,2},{0,34010001,2}]'),(611,660,127,'[{0,32081442,2},{0,34010001,2}]'),(611,660,128,'[{0,32081442,2},{0,34010001,2}]'),(611,660,129,'[{0,32081442,2},{0,34010001,2}]'),(611,660,130,'[{0,32081442,2},{0,34010001,2}]'),(611,660,131,'[{0,32081442,2},{0,34010001,2}]'),(611,660,132,'[{0,32081442,2},{0,34010001,2}]'),(611,660,133,'[{0,32081442,2},{0,34010001,2}]'),(611,660,134,'[{0,32081442,2},{0,34010001,2}]'),(611,660,135,'[{0,32081442,2},{0,34010001,2}]'),(611,660,136,'[{0,32081442,2},{0,34010001,2}]'),(611,660,137,'[{0,32081442,2},{0,34010001,2}]'),(611,660,138,'[{0,32081442,2},{0,34010001,2}]'),(611,660,139,'[{0,32081442,2},{0,34010001,2}]'),(611,660,140,'[{0,32081442,2},{0,34010001,2}]'),(611,660,141,'[{0,32081442,2},{0,34010001,2}]'),(611,660,142,'[{0,32081442,2},{0,34010001,2}]'),(611,660,143,'[{0,32081442,2},{0,34010001,2}]'),(611,660,144,'[{0,32081442,2},{0,34010001,2}]'),(611,660,145,'[{0,32081442,2},{0,34010001,2}]'),(611,660,146,'[{0,32081442,2},{0,34010001,2}]'),(611,660,147,'[{0,32081442,2},{0,34010001,2}]'),(611,660,148,'[{0,32081442,2},{0,34010001,2}]'),(611,660,149,'[{0,32081442,2},{0,34010001,2}]'),(611,660,150,'[{0,32081442,2},{0,34010001,2}]'),(611,660,151,'[{0,32081442,2},{0,34010001,2}]'),(611,660,152,'[{0,32081442,2},{0,34010001,2}]'),(611,660,153,'[{0,32081442,2},{0,34010001,2}]'),(611,660,154,'[{0,32081442,2},{0,34010001,2}]'),(611,660,155,'[{0,32081442,2},{0,34010001,2}]'),(611,660,156,'[{0,32081442,2},{0,34010001,2}]'),(611,660,157,'[{0,32081442,2},{0,34010001,2}]'),(611,660,158,'[{0,32081442,2},{0,34010001,2}]'),(611,660,159,'[{0,32081442,2},{0,34010001,2}]'),(611,660,160,'[{0,32081442,2},{0,34010001,2}]'),(611,660,161,'[{0,32081442,2},{0,34010001,2}]'),(611,660,162,'[{0,32081442,2},{0,34010001,2}]'),(611,660,163,'[{0,32081442,2},{0,34010001,2}]'),(611,660,164,'[{0,32081442,2},{0,34010001,2}]'),(611,660,165,'[{0,32081442,2},{0,34010001,2}]'),(611,660,166,'[{0,32081442,2},{0,34010001,2}]'),(611,660,167,'[{0,32081442,2},{0,34010001,2}]'),(611,660,168,'[{0,32081442,2},{0,34010001,2}]'),(611,660,169,'[{0,32081442,2},{0,34010001,2}]'),(611,660,170,'[{0,32081442,2},{0,34010001,2}]'),(611,660,171,'[{0,32081442,2},{0,34010001,2}]'),(611,660,172,'[{0,32081442,2},{0,34010001,2}]'),(611,660,173,'[{0,32081442,2},{0,34010001,2}]'),(611,660,174,'[{0,32081442,2},{0,34010001,2}]'),(611,660,175,'[{0,32081442,2},{0,34010001,2}]'),(611,660,176,'[{0,32081442,2},{0,34010001,2}]'),(611,660,177,'[{0,32081442,2},{0,34010001,2}]'),(611,660,178,'[{0,32081442,2},{0,34010001,2}]'),(611,660,179,'[{0,32081442,2},{0,34010001,2}]'),(611,660,180,'[{0,32081442,2},{0,34010001,2}]'),(611,660,181,'[{0,32081442,2},{0,34010001,2}]'),(611,660,182,'[{0,32081442,2},{0,34010001,2}]'),(611,660,183,'[{0,32081442,2},{0,34010001,2}]'),(611,660,184,'[{0,32081442,2},{0,34010001,2}]'),(611,660,185,'[{0,32081442,2},{0,34010001,2}]'),(611,660,186,'[{0,32081442,2},{0,34010001,2}]'),(611,660,187,'[{0,32081442,2},{0,34010001,2}]'),(611,660,188,'[{0,32081442,2},{0,34010001,2}]'),(611,660,189,'[{0,32081442,2},{0,34010001,2}]'),(611,660,190,'[{0,32081442,2},{0,34010001,2}]'),(611,660,191,'[{0,32081442,2},{0,34010001,2}]'),(611,660,192,'[{0,32081442,2},{0,34010001,2}]'),(611,660,193,'[{0,32081442,2},{0,34010001,2}]'),(611,660,194,'[{0,32081442,2},{0,34010001,2}]'),(611,660,195,'[{0,32081442,2},{0,34010001,2}]'),(611,660,196,'[{0,32081442,2},{0,34010001,2}]'),(611,660,197,'[{0,32081442,2},{0,34010001,2}]'),(611,660,198,'[{0,32081442,2},{0,34010001,2}]'),(611,660,199,'[{0,32081442,2},{0,34010001,2}]'),(611,660,200,'[{0,32081442,2},{0,34010001,2}]'),(611,660,201,'[{0,32081442,2},{0,34010001,2}]'),(611,660,202,'[{0,32081442,2},{0,34010001,2}]'),(611,660,203,'[{0,32081442,2},{0,34010001,2}]'),(611,660,204,'[{0,32081442,2},{0,34010001,2}]'),(611,660,205,'[{0,32081442,2},{0,34010001,2}]'),(611,660,206,'[{0,32081442,2},{0,34010001,2}]'),(611,660,207,'[{0,32081442,2},{0,34010001,2}]'),(611,660,208,'[{0,32081442,2},{0,34010001,2}]'),(611,660,209,'[{0,32081442,2},{0,34010001,2}]'),(611,660,210,'[{0,32081442,2},{0,34010001,2}]'),(611,660,211,'[{0,32081442,2},{0,34010001,2}]'),(611,660,212,'[{0,32081442,2},{0,34010001,2}]'),(611,660,213,'[{0,32081442,2},{0,34010001,2}]'),(611,660,214,'[{0,32081442,2},{0,34010001,2}]'),(611,660,215,'[{0,32081442,2},{0,34010001,2}]'),(611,660,216,'[{0,32081442,2},{0,34010001,2}]'),(611,660,217,'[{0,32081442,2},{0,34010001,2}]'),(611,660,218,'[{0,32081442,2},{0,34010001,2}]'),(661,750,1,'[{0,32081542,1}]'),(661,750,2,'[{0,32081542,1}]'),(661,750,3,'[{0,32081542,1}]'),(661,750,4,'[{0,32081542,1}]'),(661,750,5,'[{0,32081542,1},{0,34010001,1}]'),(661,750,6,'[{0,32081542,1},{0,34010001,1}]'),(661,750,7,'[{0,32081542,1},{0,34010001,1}]'),(661,750,8,'[{0,32081542,1},{0,34010001,1}]'),(661,750,9,'[{0,32081542,1},{0,34010001,1}]'),(661,750,10,'[{0,32081542,1},{0,34010001,1}]'),(661,750,11,'[{0,32081542,1},{0,34010001,1}]'),(661,750,12,'[{0,32081542,1},{0,34010001,1}]'),(661,750,13,'[{0,32081542,1},{0,34010001,1}]'),(661,750,14,'[{0,32081542,1},{0,34010001,1}]'),(661,750,15,'[{0,32081542,1},{0,34010001,1}]'),(661,750,16,'[{0,32081542,1},{0,34010001,1}]'),(661,750,17,'[{0,32081542,1},{0,34010001,1}]'),(661,750,18,'[{0,32081542,1},{0,34010001,1}]'),(661,750,19,'[{0,32081542,1},{0,34010001,1}]'),(661,750,20,'[{0,32081542,1},{0,34010001,1}]'),(661,750,21,'[{0,32081542,2},{0,34010001,2}]'),(661,750,22,'[{0,32081542,2},{0,34010001,2}]'),(661,750,23,'[{0,32081542,2},{0,34010001,2}]'),(661,750,24,'[{0,32081542,2},{0,34010001,2}]'),(661,750,25,'[{0,32081542,2},{0,34010001,2}]'),(661,750,26,'[{0,32081542,2},{0,34010001,2}]'),(661,750,27,'[{0,32081542,2},{0,34010001,2}]'),(661,750,28,'[{0,32081542,2},{0,34010001,2}]'),(661,750,29,'[{0,32081542,2},{0,34010001,2}]'),(661,750,30,'[{0,32081542,2},{0,34010001,2}]'),(661,750,31,'[{0,32081542,2},{0,34010001,2}]'),(661,750,32,'[{0,32081542,2},{0,34010001,2}]'),(661,750,33,'[{0,32081542,2},{0,34010001,2}]'),(661,750,34,'[{0,32081542,2},{0,34010001,2}]'),(661,750,35,'[{0,32081542,2},{0,34010001,2}]'),(661,750,36,'[{0,32081542,2},{0,34010001,2}]'),(661,750,37,'[{0,32081542,2},{0,34010001,2}]'),(661,750,38,'[{0,32081542,2},{0,34010001,2}]'),(661,750,39,'[{0,32081542,2},{0,34010001,2}]'),(661,750,40,'[{0,32081542,2},{0,34010001,2}]'),(661,750,41,'[{0,32081542,2},{0,34010001,2}]'),(661,750,42,'[{0,32081542,2},{0,34010001,2}]'),(661,750,43,'[{0,32081542,2},{0,34010001,2}]'),(661,750,44,'[{0,32081542,2},{0,34010001,2}]'),(661,750,45,'[{0,32081542,2},{0,34010001,2}]'),(661,750,46,'[{0,32081542,2},{0,34010001,2}]'),(661,750,47,'[{0,32081542,2},{0,34010001,2}]'),(661,750,48,'[{0,32081542,2},{0,34010001,2}]'),(661,750,49,'[{0,32081542,2},{0,34010001,2}]'),(661,750,50,'[{0,32081542,2},{0,34010001,2}]'),(661,750,51,'[{0,32081542,2},{0,34010001,2}]'),(661,750,52,'[{0,32081542,2},{0,34010001,2}]'),(661,750,53,'[{0,32081542,2},{0,34010001,2}]'),(661,750,54,'[{0,32081542,2},{0,34010001,2}]'),(661,750,55,'[{0,32081542,2},{0,34010001,2}]'),(661,750,56,'[{0,32081542,2},{0,34010001,2}]'),(661,750,57,'[{0,32081542,2},{0,34010001,2}]'),(661,750,58,'[{0,32081542,2},{0,34010001,2}]'),(661,750,59,'[{0,32081542,2},{0,34010001,2}]'),(661,750,60,'[{0,32081542,2},{0,34010001,2}]'),(661,750,61,'[{0,32081542,2},{0,34010001,2}]'),(661,750,62,'[{0,32081542,2},{0,34010001,2}]'),(661,750,63,'[{0,32081542,2},{0,34010001,2}]'),(661,750,64,'[{0,32081542,2},{0,34010001,2}]'),(661,750,65,'[{0,32081542,2},{0,34010001,2}]'),(661,750,66,'[{0,32081542,2},{0,34010001,2}]'),(661,750,67,'[{0,32081542,2},{0,34010001,2}]'),(661,750,68,'[{0,32081542,2},{0,34010001,2}]'),(661,750,69,'[{0,32081542,2},{0,34010001,2}]'),(661,750,70,'[{0,32081542,2},{0,34010001,2}]'),(661,750,71,'[{0,32081542,2},{0,34010001,2}]'),(661,750,72,'[{0,32081542,2},{0,34010001,2}]'),(661,750,73,'[{0,32081542,2},{0,34010001,2}]'),(661,750,74,'[{0,32081542,2},{0,34010001,2}]'),(661,750,75,'[{0,32081542,2},{0,34010001,2}]'),(661,750,76,'[{0,32081542,2},{0,34010001,2}]'),(661,750,77,'[{0,32081542,2},{0,34010001,2}]'),(661,750,78,'[{0,32081542,2},{0,34010001,2}]'),(661,750,79,'[{0,32081542,2},{0,34010001,2}]'),(661,750,80,'[{0,32081542,2},{0,34010001,2}]'),(661,750,81,'[{0,32081542,2},{0,34010001,2}]'),(661,750,82,'[{0,32081542,2},{0,34010001,2}]'),(661,750,83,'[{0,32081542,2},{0,34010001,2}]'),(661,750,84,'[{0,32081542,2},{0,34010001,2}]'),(661,750,85,'[{0,32081542,2},{0,34010001,2}]'),(661,750,86,'[{0,32081542,2},{0,34010001,2}]'),(661,750,87,'[{0,32081542,2},{0,34010001,2}]'),(661,750,88,'[{0,32081542,2},{0,34010001,2}]'),(661,750,89,'[{0,32081542,2},{0,34010001,2}]'),(661,750,90,'[{0,32081542,2},{0,34010001,2}]'),(661,750,91,'[{0,32081542,2},{0,34010001,2}]'),(661,750,92,'[{0,32081542,2},{0,34010001,2}]'),(661,750,93,'[{0,32081542,2},{0,34010001,2}]'),(661,750,94,'[{0,32081542,2},{0,34010001,2}]'),(661,750,95,'[{0,32081542,2},{0,34010001,2}]'),(661,750,96,'[{0,32081542,2},{0,34010001,2}]'),(661,750,97,'[{0,32081542,2},{0,34010001,2}]'),(661,750,98,'[{0,32081542,2},{0,34010001,2}]'),(661,750,99,'[{0,32081542,2},{0,34010001,2}]'),(661,750,100,'[{0,32081542,2},{0,34010001,2}]'),(661,750,101,'[{0,32081542,2},{0,34010001,2}]'),(661,750,102,'[{0,32081542,2},{0,34010001,2}]'),(661,750,103,'[{0,32081542,2},{0,34010001,2}]'),(661,750,104,'[{0,32081542,2},{0,34010001,2}]'),(661,750,105,'[{0,32081542,2},{0,34010001,2}]'),(661,750,106,'[{0,32081542,2},{0,34010001,2}]'),(661,750,107,'[{0,32081542,2},{0,34010001,2}]'),(661,750,108,'[{0,32081542,2},{0,34010001,2}]'),(661,750,109,'[{0,32081542,2},{0,34010001,2}]'),(661,750,110,'[{0,32081542,2},{0,34010001,2}]'),(661,750,111,'[{0,32081542,2},{0,34010001,2}]'),(661,750,112,'[{0,32081542,2},{0,34010001,2}]'),(661,750,113,'[{0,32081542,2},{0,34010001,2}]'),(661,750,114,'[{0,32081542,2},{0,34010001,2}]'),(661,750,115,'[{0,32081542,2},{0,34010001,2}]'),(661,750,116,'[{0,32081542,2},{0,34010001,2}]'),(661,750,117,'[{0,32081542,2},{0,34010001,2}]'),(661,750,118,'[{0,32081542,2},{0,34010001,2}]'),(661,750,119,'[{0,32081542,2},{0,34010001,2}]'),(661,750,120,'[{0,32081542,2},{0,34010001,2}]'),(661,750,121,'[{0,32081542,2},{0,34010001,2}]'),(661,750,122,'[{0,32081542,2},{0,34010001,2}]'),(661,750,123,'[{0,32081542,2},{0,34010001,2}]'),(661,750,124,'[{0,32081542,2},{0,34010001,2}]'),(661,750,125,'[{0,32081542,2},{0,34010001,2}]'),(661,750,126,'[{0,32081542,2},{0,34010001,2}]'),(661,750,127,'[{0,32081542,2},{0,34010001,2}]'),(661,750,128,'[{0,32081542,2},{0,34010001,2}]'),(661,750,129,'[{0,32081542,2},{0,34010001,2}]'),(661,750,130,'[{0,32081542,2},{0,34010001,2}]'),(661,750,131,'[{0,32081542,2},{0,34010001,2}]'),(661,750,132,'[{0,32081542,2},{0,34010001,2}]'),(661,750,133,'[{0,32081542,2},{0,34010001,2}]'),(661,750,134,'[{0,32081542,2},{0,34010001,2}]'),(661,750,135,'[{0,32081542,2},{0,34010001,2}]'),(661,750,136,'[{0,32081542,2},{0,34010001,2}]'),(661,750,137,'[{0,32081542,2},{0,34010001,2}]'),(661,750,138,'[{0,32081542,2},{0,34010001,2}]'),(661,750,139,'[{0,32081542,2},{0,34010001,2}]'),(661,750,140,'[{0,32081542,2},{0,34010001,2}]'),(661,750,141,'[{0,32081542,2},{0,34010001,2}]'),(661,750,142,'[{0,32081542,2},{0,34010001,2}]'),(661,750,143,'[{0,32081542,2},{0,34010001,2}]'),(661,750,144,'[{0,32081542,2},{0,34010001,2}]'),(661,750,145,'[{0,32081542,2},{0,34010001,2}]'),(661,750,146,'[{0,32081542,2},{0,34010001,2}]'),(661,750,147,'[{0,32081542,2},{0,34010001,2}]'),(661,750,148,'[{0,32081542,2},{0,34010001,2}]'),(661,750,149,'[{0,32081542,2},{0,34010001,2}]'),(661,750,150,'[{0,32081542,2},{0,34010001,2}]'),(661,750,151,'[{0,32081542,2},{0,34010001,2}]'),(661,750,152,'[{0,32081542,2},{0,34010001,2}]'),(661,750,153,'[{0,32081542,2},{0,34010001,2}]'),(661,750,154,'[{0,32081542,2},{0,34010001,2}]'),(661,750,155,'[{0,32081542,2},{0,34010001,2}]'),(661,750,156,'[{0,32081542,2},{0,34010001,2}]'),(661,750,157,'[{0,32081542,2},{0,34010001,2}]'),(661,750,158,'[{0,32081542,2},{0,34010001,2}]'),(661,750,159,'[{0,32081542,2},{0,34010001,2}]'),(661,750,160,'[{0,32081542,2},{0,34010001,2}]'),(661,750,161,'[{0,32081542,2},{0,34010001,2}]'),(661,750,162,'[{0,32081542,2},{0,34010001,2}]'),(661,750,163,'[{0,32081542,2},{0,34010001,2}]'),(661,750,164,'[{0,32081542,2},{0,34010001,2}]'),(661,750,165,'[{0,32081542,2},{0,34010001,2}]'),(661,750,166,'[{0,32081542,2},{0,34010001,2}]'),(661,750,167,'[{0,32081542,2},{0,34010001,2}]'),(661,750,168,'[{0,32081542,2},{0,34010001,2}]'),(661,750,169,'[{0,32081542,2},{0,34010001,2}]'),(661,750,170,'[{0,32081542,2},{0,34010001,2}]'),(661,750,171,'[{0,32081542,2},{0,34010001,2}]'),(661,750,172,'[{0,32081542,2},{0,34010001,2}]'),(661,750,173,'[{0,32081542,2},{0,34010001,2}]'),(661,750,174,'[{0,32081542,2},{0,34010001,2}]'),(661,750,175,'[{0,32081542,2},{0,34010001,2}]'),(661,750,176,'[{0,32081542,2},{0,34010001,2}]'),(661,750,177,'[{0,32081542,2},{0,34010001,2}]'),(661,750,178,'[{0,32081542,2},{0,34010001,2}]'),(661,750,179,'[{0,32081542,2},{0,34010001,2}]'),(661,750,180,'[{0,32081542,2},{0,34010001,2}]'),(661,750,181,'[{0,32081542,2},{0,34010001,2}]'),(661,750,182,'[{0,32081542,2},{0,34010001,2}]'),(661,750,183,'[{0,32081542,2},{0,34010001,2}]'),(661,750,184,'[{0,32081542,2},{0,34010001,2}]'),(661,750,185,'[{0,32081542,2},{0,34010001,2}]'),(661,750,186,'[{0,32081542,2},{0,34010001,2}]'),(661,750,187,'[{0,32081542,2},{0,34010001,2}]'),(661,750,188,'[{0,32081542,2},{0,34010001,2}]'),(661,750,189,'[{0,32081542,2},{0,34010001,2}]'),(661,750,190,'[{0,32081542,2},{0,34010001,2}]'),(661,750,191,'[{0,32081542,2},{0,34010001,2}]'),(661,750,192,'[{0,32081542,2},{0,34010001,2}]'),(661,750,193,'[{0,32081542,2},{0,34010001,2}]'),(661,750,194,'[{0,32081542,2},{0,34010001,2}]'),(661,750,195,'[{0,32081542,2},{0,34010001,2}]'),(661,750,196,'[{0,32081542,2},{0,34010001,2}]'),(661,750,197,'[{0,32081542,2},{0,34010001,2}]'),(661,750,198,'[{0,32081542,2},{0,34010001,2}]'),(661,750,199,'[{0,32081542,2},{0,34010001,2}]'),(661,750,200,'[{0,32081542,2},{0,34010001,2}]'),(661,750,201,'[{0,32081542,2},{0,34010001,2}]'),(661,750,202,'[{0,32081542,2},{0,34010001,2}]'),(661,750,203,'[{0,32081542,2},{0,34010001,2}]'),(661,750,204,'[{0,32081542,2},{0,34010001,2}]'),(661,750,205,'[{0,32081542,2},{0,34010001,2}]'),(661,750,206,'[{0,32081542,2},{0,34010001,2}]'),(661,750,207,'[{0,32081542,2},{0,34010001,2}]'),(661,750,208,'[{0,32081542,2},{0,34010001,2}]'),(661,750,209,'[{0,32081542,2},{0,34010001,2}]'),(661,750,210,'[{0,32081542,2},{0,34010001,2}]'),(661,750,211,'[{0,32081542,2},{0,34010001,2}]'),(661,750,212,'[{0,32081542,2},{0,34010001,2}]'),(661,750,213,'[{0,32081542,2},{0,34010001,2}]'),(661,750,214,'[{0,32081542,2},{0,34010001,2}]'),(661,750,215,'[{0,32081542,2},{0,34010001,2}]'),(661,750,216,'[{0,32081542,2},{0,34010001,2}]'),(661,750,217,'[{0,32081542,2},{0,34010001,2}]'),(661,750,218,'[{0,32081542,2},{0,34010001,2}]'),(751,1000,1,'[{0,32081642,1}]'),(751,1000,2,'[{0,32081642,1}]'),(751,1000,3,'[{0,32081642,1}]'),(751,1000,4,'[{0,32081642,1}]'),(751,1000,5,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,6,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,7,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,8,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,9,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,10,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,11,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,12,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,13,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,14,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,15,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,16,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,17,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,18,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,19,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,20,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,21,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,22,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,23,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,24,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,25,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,26,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,27,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,28,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,29,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,30,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,31,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,32,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,33,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,34,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,35,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,36,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,37,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,38,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,39,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,40,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,41,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,42,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,43,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,44,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,45,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,46,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,47,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,48,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,49,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,50,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,51,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,52,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,53,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,54,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,55,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,56,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,57,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,58,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,59,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,60,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,61,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,62,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,63,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,64,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,65,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,66,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,67,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,68,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,69,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,70,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,71,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,72,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,73,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,74,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,75,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,76,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,77,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,78,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,79,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,80,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,81,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,82,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,83,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,84,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,85,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,86,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,87,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,88,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,89,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,90,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,91,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,92,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,93,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,94,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,95,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,96,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,97,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,98,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,99,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,100,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,101,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,102,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,103,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,104,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,105,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,106,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,107,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,108,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,109,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,110,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,111,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,112,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,113,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,114,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,115,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,116,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,117,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,118,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,119,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,120,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,121,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,122,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,123,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,124,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,125,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,126,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,127,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,128,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,129,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,130,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,131,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,132,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,133,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,134,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,135,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,136,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,137,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,138,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,139,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,140,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,141,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,142,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,143,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,144,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,145,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,146,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,147,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,148,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,149,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,150,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,151,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,152,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,153,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,154,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,155,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,156,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,157,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,158,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,159,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,160,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,161,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,162,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,163,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,164,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,165,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,166,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,167,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,168,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,169,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,170,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,171,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,172,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,173,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,174,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,175,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,176,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,177,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,178,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,179,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,180,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,181,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,182,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,183,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,184,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,185,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,186,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,187,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,188,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,189,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,190,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,191,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,192,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,193,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,194,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,195,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,196,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,197,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,198,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,199,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,200,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,201,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,202,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,203,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,204,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,205,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,206,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,207,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,208,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,209,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,210,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,211,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,212,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,213,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,214,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,215,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,216,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,217,'[{0,32081642,2},{0,34010001,2}]'),(751,1000,218,'[{0,32081642,2},{0,34010001,2}]');
/*!40000 ALTER TABLE `base_guild_war_break_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_guild_war_equip`
--

DROP TABLE IF EXISTS `base_guild_war_equip`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_guild_war_equip` (
  `id` tinyint(3) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `equip_id` tinyint(2) unsigned NOT NULL COMMENT '攻城器械类型',
  `min_world_lv` smallint(5) unsigned NOT NULL COMMENT '最小世界等级',
  `max_world_lv` smallint(5) unsigned NOT NULL COMMENT '最大世界等级',
  `name` varchar(255) NOT NULL COMMENT '攻城器械名字@lang@',
  `cost` int(11) unsigned NOT NULL COMMENT '花费',
  `max_times` smallint(5) unsigned NOT NULL COMMENT '最大次数',
  `note` varchar(1024) NOT NULL COMMENT '描述@lang@',
  `icon_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '图标id',
  `skills` varchar(255) NOT NULL DEFAULT '[]' COMMENT '技能列表',
  `mon_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '怪物id',
  `model_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '模型id',
  `attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '属性列表',
  `module_size` float unsigned NOT NULL DEFAULT '1' COMMENT '模型大小比例',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=29 DEFAULT CHARSET=utf8 COMMENT='公会争霸攻城器械配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_guild_war_equip`
--

LOCK TABLES `base_guild_war_equip` WRITE;
/*!40000 ALTER TABLE `base_guild_war_equip` DISABLE KEYS */;
INSERT INTO `base_guild_war_equip` VALUES (1,1,150,200,'冲车',50000,10,'公会争霸Lv150冲车',38030006,'[20002001,20002002]',40610015,41020001,'[{2,250000},{1,4647},{4,1529},{5,344},{6,344},{7,341},{8,341},{3,1812},{18,300}]',1.3),(2,2,150,200,'炮车',50000,10,'公会争霸Lv150炮车',38030007,'[20002003,20002004]',40610016,41020002,'[{2,125000},{1,11153},{4,1529},{5,344},{6,344},{7,341},{8,341},{3,1812},{18,400}]',1.3),(3,1,201,260,'冲车',50000,10,'公会争霸Lv200冲车',38030006,'[20002001,20002002]',40610025,41020001,'[{2,250000},{1,7168},{4,2351},{5,528},{6,528},{7,523},{8,523},{3,2786},{18,300}]',1.3),(4,2,201,260,'炮车',50000,10,'公会争霸Lv200炮车',38030007,'[20002003,20002004]',40610026,41020002,'[{2,125000},{1,17204},{4,2351},{5,528},{6,528},{7,523},{8,523},{3,2786},{18,400}]',1.3),(5,1,261,320,'冲车',50000,10,'公会争霸Lv300冲车',38030006,'[20002001,20002002]',40610035,41020001,'[{2,250000},{1,11452},{4,3762},{5,846},{6,846},{7,838},{8,838},{3,4459},{18,300}]',1.3),(6,2,261,320,'炮车',50000,10,'公会争霸Lv300炮车',38030007,'[20002003,20002004]',40610036,41020002,'[{2,125000},{1,27484},{4,3762},{5,846},{6,846},{7,838},{8,838},{3,4459},{18,400}]',1.3),(7,1,321,350,'冲车',50000,10,'公会争霸Lv400冲车',38030006,'[20002001,20002002]',40610045,41020001,'[{2,250000},{1,17991},{4,5597},{5,1530},{6,1530},{7,1215},{8,1215},{3,6580},{18,300}]',1.3),(8,2,321,350,'炮车',50000,10,'公会争霸Lv400炮车',38030007,'[20002003,20002004]',40610046,41020002,'[{2,125000},{1,43178},{4,5597},{5,1530},{6,1530},{7,1215},{8,1215},{3,6580},{18,400}]',1.3),(9,1,351,370,'冲车',50000,10,'公会争霸Lv500冲车',38030006,'[20002001,20002002]',40610055,41020001,'[{2,250000},{1,29886},{4,10203},{5,3438},{6,3438},{7,2184},{8,2184},{3,11536},{18,300}]',1.3),(10,2,351,370,'炮车',50000,10,'公会争霸Lv500炮车',38030007,'[20002003,20002004]',40610056,41020002,'[{2,125000},{1,71725},{4,10203},{5,3438},{6,3438},{7,2184},{8,2184},{3,11536},{18,400}]',1.3),(11,1,371,430,'冲车',50000,10,'公会争霸Lv550冲车',38030006,'[20002001,20002002]',40610065,41020001,'[{2,250000},{1,41565},{4,13343},{5,4731},{6,4731},{7,2744},{8,2744},{3,14851},{18,300}]',1.3),(12,2,371,430,'炮车',50000,10,'公会争霸Lv550炮车',38030007,'[20002003,20002004]',40610066,41020002,'[{2,125000},{1,99755},{4,13343},{5,4731},{6,4731},{7,2744},{8,2744},{3,14851},{18,400}]',1.3),(13,1,431,500,'冲车',50000,10,'公会争霸Lv600冲车',38030006,'[20002001,20002002]',40610075,41020001,'[{2,250000},{1,61953},{4,20426},{5,7033},{6,7033},{7,3941},{8,3941},{3,22843},{18,300}]',1.3),(14,2,431,500,'炮车',50000,10,'公会争霸Lv600炮车',38030007,'[20002003,20002004]',40610076,41020002,'[{2,125000},{1,148687},{4,20426},{5,7033},{6,7033},{7,3941},{8,3941},{3,22843},{18,400}]',1.3),(15,1,501,560,'冲车',50000,10,'公会争霸Lv650冲车',38030006,'[20002001,20002002]',40610085,41020001,'[{2,250000},{1,89351},{4,28816},{5,10931},{6,10931},{7,5676},{8,5676},{3,32093},{18,300}]',1.3),(16,2,501,560,'炮车',50000,10,'公会争霸Lv650炮车',38030007,'[20002003,20002004]',40610086,41020002,'[{2,125000},{1,214443},{4,28816},{5,10931},{6,10931},{7,5676},{8,5676},{3,32093},{18,400}]',1.3),(17,1,561,610,'冲车',50000,10,'公会争霸Lv700冲车',38030006,'[20002001,20002002]',40610095,41020001,'[{2,250000},{1,129381},{4,38312},{5,20094},{6,20094},{7,9632},{8,9632},{3,42719},{18,300}]',1.3),(18,2,561,610,'炮车',50000,10,'公会争霸Lv700炮车',38030007,'[20002003,20002004]',40610096,41020002,'[{2,125000},{1,310514},{4,38312},{5,20094},{6,20094},{7,9632},{8,9632},{3,42719},{18,400}]',1.3),(19,1,611,660,'冲车',50000,10,'公会争霸Lv750冲车',38030006,'[20002001,20002002]',40610105,41020001,'[{2,250000},{1,178167},{4,54519},{5,28275},{6,28275},{7,14240},{8,14240},{3,60399},{18,300}]',1.3),(20,2,611,660,'炮车',50000,10,'公会争霸Lv750炮车',38030007,'[20002003,20002004]',40610106,41020002,'[{2,125000},{1,427602},{4,54519},{5,28275},{6,28275},{7,14240},{8,14240},{3,60399},{18,400}]',1.3),(21,1,661,750,'冲车',50000,10,'公会争霸Lv800冲车',38030006,'[20002001,20002002]',40610115,41020001,'[{2,250000},{1,227094},{4,71324},{5,34910},{6,34910},{7,17712},{8,17712},{3,79103},{18,300}]',1.3),(22,2,661,750,'炮车',50000,10,'公会争霸Lv800炮车',38030007,'[20002003,20002004]',40610116,41020002,'[{2,125000},{1,545026},{4,71324},{5,34910},{6,34910},{7,17712},{8,17712},{3,79103},{18,400}]',1.3),(23,1,751,800,'冲车',50000,10,'公会争霸Lv850冲车',38030006,'[20002001,20002002]',40610125,41020001,'[{2,250000},{1,277617},{4,89658},{5,44738},{6,44738},{7,25755},{8,25755},{3,99864},{18,300}]',1.3),(24,2,751,800,'炮车',50000,10,'公会争霸Lv850炮车',38030007,'[20002003,20002004]',40610126,41020002,'[{2,125000},{1,666281},{4,89658},{5,44738},{6,44738},{7,25755},{8,25755},{3,99864},{18,400}]',1.3),(25,1,801,900,'冲车',50000,10,'公会争霸Lv900冲车',38030006,'[20002001,20002002]',40610135,41020001,'[{2,250000},{1,362025},{4,115198},{5,55007},{6,55007},{7,31117},{8,31117},{3,128479},{18,300}]',1.3),(26,2,801,900,'炮车',50000,10,'公会争霸Lv900炮车',38030007,'[20002003,20002004]',40610136,41020002,'[{2,125000},{1,868860},{4,115198},{5,55007},{6,55007},{7,31117},{8,31117},{3,128479},{18,400}]',1.3),(27,1,901,1000,'冲车',50000,10,'公会争霸Lv950冲车',38030006,'[20002001,20002002]',40610145,41020001,'[{2,250000},{1,443802},{4,142510},{5,65214},{6,65214},{7,36807},{8,36807},{3,159637},{18,300}]',1.3),(28,2,901,1000,'炮车',50000,10,'公会争霸Lv950炮车',38030007,'[20002003,20002004]',40610146,41020002,'[{2,125000},{1,1065126},{4,142510},{5,65214},{6,65214},{7,36807},{8,36807},{3,159637},{18,400}]',1.3);
/*!40000 ALTER TABLE `base_guild_war_equip` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_guild_war_inspire`
--

DROP TABLE IF EXISTS `base_guild_war_inspire`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_guild_war_inspire` (
  `type` tinyint(2) unsigned NOT NULL COMMENT '建筑类型',
  `buff` varchar(255) NOT NULL COMMENT '鼓舞加成',
  `cost` int(11) unsigned NOT NULL COMMENT '消耗公会贡献',
  `times` smallint(5) unsigned NOT NULL COMMENT '鼓舞次数',
  PRIMARY KEY (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会争霸鼓舞配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_guild_war_inspire`
--

LOCK TABLES `base_guild_war_inspire` WRITE;
/*!40000 ALTER TABLE `base_guild_war_inspire` DISABLE KEYS */;
INSERT INTO `base_guild_war_inspire` VALUES (1,'[{10,300}]',10000,15),(2,'[{10,300}]',10000,15),(3,'[{10,300}]',10000,15);
/*!40000 ALTER TABLE `base_guild_war_inspire` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_guild_war_join_reward`
--

DROP TABLE IF EXISTS `base_guild_war_join_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_guild_war_join_reward` (
  `id` tinyint(3) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `result` tinyint(2) unsigned NOT NULL COMMENT '胜负',
  `min_world_lv` smallint(5) unsigned NOT NULL COMMENT '最小世界等级',
  `max_world_lv` smallint(5) unsigned NOT NULL COMMENT '最大世界等级',
  `reward` varchar(255) NOT NULL COMMENT '奖励内容',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=29 DEFAULT CHARSET=utf8 COMMENT='公会争霸参与奖';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_guild_war_join_reward`
--

LOCK TABLES `base_guild_war_join_reward` WRITE;
/*!40000 ALTER TABLE `base_guild_war_join_reward` DISABLE KEYS */;
INSERT INTO `base_guild_war_join_reward` VALUES (1,1,1,200,'[{2,36020001,100},{4,36050001,10000}]'),(2,1,201,260,'[{2,36020001,100},{4,36050001,12000}]'),(3,1,261,320,'[{2,36020001,100},{4,36050001,14000}]'),(4,1,321,350,'[{2,36020001,100},{4,36050001,16000}]'),(5,1,351,370,'[{2,36020001,100},{4,36050001,18000}]'),(6,1,371,390,'[{2,36020001,100},{4,36050001,20000}]'),(7,1,391,430,'[{2,36020001,100},{4,36050001,22000}]'),(8,1,431,500,'[{2,36020001,100},{4,36050001,24000}]'),(9,1,501,560,'[{2,36020001,100},{4,36050001,26000}]'),(10,1,561,610,'[{2,36020001,100},{4,36050001,28000}]'),(11,1,611,660,'[{2,36020001,100},{4,36050001,30000}]'),(12,1,661,750,'[{2,36020001,100},{4,36050001,32000}]'),(13,1,751,800,'[{2,36020001,100},{4,36050001,34000}]'),(14,1,801,1000,'[{2,36020001,100},{4,36050001,36000}]'),(15,2,1,200,'[{2,36020001,50},{4,36050001,5000}]'),(16,2,201,260,'[{2,36020001,50},{4,36050001,6000}]'),(17,2,261,320,'[{2,36020001,50},{4,36050001,7000}]'),(18,2,321,350,'[{2,36020001,50},{4,36050001,8000}]'),(19,2,351,370,'[{2,36020001,50},{4,36050001,9000}]'),(20,2,371,390,'[{2,36020001,50},{4,36050001,10000}]'),(21,2,391,430,'[{2,36020001,50},{4,36050001,11000}]'),(22,2,431,500,'[{2,36020001,50},{4,36050001,12000}]'),(23,2,501,560,'[{2,36020001,50},{4,36050001,13000}]'),(24,2,561,610,'[{2,36020001,50},{4,36050001,14000}]'),(25,2,611,660,'[{2,36020001,50},{4,36050001,15000}]'),(26,2,661,750,'[{2,36020001,50},{4,36050001,16000}]'),(27,2,751,800,'[{2,36020001,50},{4,36050001,17000}]'),(28,2,801,1000,'[{2,36020001,50},{4,36050001,18000}]');
/*!40000 ALTER TABLE `base_guild_war_join_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_guild_war_loc`
--

DROP TABLE IF EXISTS `base_guild_war_loc`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_guild_war_loc` (
  `type` tinyint(2) unsigned NOT NULL COMMENT '坐标类型',
  `group_id` tinyint(2) unsigned NOT NULL COMMENT '队伍id',
  `loc_list` varchar(255) NOT NULL COMMENT '坐标列表',
  PRIMARY KEY (`type`,`group_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会争霸坐标配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_guild_war_loc`
--

LOCK TABLES `base_guild_war_loc` WRITE;
/*!40000 ALTER TABLE `base_guild_war_loc` DISABLE KEYS */;
INSERT INTO `base_guild_war_loc` VALUES (0,0,'[{11402,10248}]'),(1,1,'[{6812,7625},{8831,8578}]'),(1,2,'[{11271,15578},{11223,13406}]'),(1,3,'[{16022,7488},{14057,8523}]'),(2,1,'[{5819,5769},{4785,7511}]'),(2,2,'[{10334,17148},{12351,17233}]'),(2,3,'[{18063,7496},{17043,5751}]'),(3,1,'[{4441,6221}]'),(3,2,'[{11370,18233}]'),(3,3,'[{18484,6009}]'),(4,1,'[{1920,4708}]'),(4,2,'[{11453,21065}]'),(4,3,'[{20970,4579}]'),(5,1,'[{3665,5205},{3997,5018}]'),(5,2,'[{10171,17941},{10178,18353}]'),(5,3,'[{18664,7161},{19082,6892}]'),(6,1,'[{3164,6082},{3194,6435}]'),(6,2,'[{12398,17919},{12466,18314}]'),(6,3,'[{17481,5327},{17717,5124}]');
/*!40000 ALTER TABLE `base_guild_war_loc` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_guild_war_mon_cfg`
--

DROP TABLE IF EXISTS `base_guild_war_mon_cfg`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_guild_war_mon_cfg` (
  `id` tinyint(3) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `min_world_lv` smallint(5) unsigned NOT NULL COMMENT '世界等级下限',
  `max_world_lv` smallint(5) unsigned NOT NULL COMMENT '世界等级上限',
  `mon_type` tinyint(3) unsigned NOT NULL COMMENT '怪物类型',
  `mon_id` int(11) unsigned NOT NULL COMMENT '怪物id',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=57 DEFAULT CHARSET=utf8 COMMENT='公会争霸怪物配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_guild_war_mon_cfg`
--

LOCK TABLES `base_guild_war_mon_cfg` WRITE;
/*!40000 ALTER TABLE `base_guild_war_mon_cfg` DISABLE KEYS */;
INSERT INTO `base_guild_war_mon_cfg` VALUES (1,150,200,1,40610011),(2,150,200,2,40610012),(3,150,200,3,40610013),(4,150,200,0,40610014),(5,201,260,1,40610021),(6,201,260,2,40610022),(7,201,260,3,40610023),(8,201,260,0,40610024),(9,261,320,1,40610031),(10,261,320,2,40610032),(11,261,320,3,40610033),(12,261,320,0,40610034),(13,321,350,1,40610041),(14,321,350,2,40610042),(15,321,350,3,40610043),(16,321,350,0,40610044),(17,351,370,1,40610051),(18,351,370,2,40610052),(19,351,370,3,40610053),(20,351,370,0,40610054),(21,371,390,1,40610061),(22,371,390,2,40610062),(23,371,390,3,40610063),(24,371,390,0,40610064),(25,391,430,1,40610071),(26,391,430,2,40610072),(27,391,430,3,40610073),(28,391,430,0,40610074),(29,431,500,1,40610081),(30,431,500,2,40610082),(31,431,500,3,40610083),(32,431,500,0,40610084),(33,501,560,1,40610091),(34,501,560,2,40610092),(35,501,560,3,40610093),(36,501,560,0,40610094),(37,561,610,1,40610101),(38,561,610,2,40610102),(39,561,610,3,40610103),(40,561,610,0,40610104),(41,611,660,1,40610111),(42,611,660,2,40610112),(43,611,660,3,40610113),(44,611,660,0,40610114),(45,661,750,1,40610121),(46,661,750,2,40610122),(47,661,750,3,40610123),(48,661,750,0,40610124),(49,751,800,1,40610131),(50,751,800,2,40610132),(51,751,800,3,40610133),(52,751,800,0,40610134),(53,801,1000,1,40610141),(54,801,1000,2,40610142),(55,801,1000,3,40610143),(56,801,1000,0,40610144);
/*!40000 ALTER TABLE `base_guild_war_mon_cfg` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_guild_war_reward`
--

DROP TABLE IF EXISTS `base_guild_war_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_guild_war_reward` (
  `min_wlv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '世界等级下限',
  `max_wlv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '世界等级上限',
  `division` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '赛区',
  `round` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '比赛轮次',
  `victory_reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '胜方奖励',
  `failure_reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '负方奖励',
  `exp_reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '经验奖励',
  PRIMARY KEY (`min_wlv`,`max_wlv`,`division`,`round`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会争霸战斗奖励配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_guild_war_reward`
--

LOCK TABLES `base_guild_war_reward` WRITE;
/*!40000 ALTER TABLE `base_guild_war_reward` DISABLE KEYS */;
INSERT INTO `base_guild_war_reward` VALUES (1,200,1,1,'[{4,36050001,60000},{8,36050002,60000},{0,32000012,6}]','[{4,36050001,42000},{8,36050002,42000},{0,32000012,4}]','[]'),(1,200,2,1,'[{4,36050001,42000},{8,36050002,42000},{0,32000012,4}]','[{4,36050001,29000},{8,36050002,29000},{0,32000012,2}]','[]'),(1,200,3,1,'[{4,36050001,29000},{8,36050002,29000},{0,32000011,4}]','[{4,36050001,20000},{8,36050002,20000},{0,32000011,2}]','[]'),(1,200,4,1,'[{4,36050001,20000},{8,36050002,20000},{0,32000011,2}]','[{4,36050001,14000},{8,36050002,14000},{0,32000011,1}]','[]'),(201,260,1,1,'[{4,36050001,60000},{8,36050002,60000},{0,32000012,6}]','[{4,36050001,42000},{8,36050002,42000},{0,32000012,4}]','[]'),(201,260,2,1,'[{4,36050001,42000},{8,36050002,42000},{0,32000012,4}]','[{4,36050001,29000},{8,36050002,29000},{0,32000012,2}]','[]'),(201,260,3,1,'[{4,36050001,29000},{8,36050002,29000},{0,32000011,4}]','[{4,36050001,20000},{8,36050002,20000},{0,32000011,2}]','[]'),(201,260,4,1,'[{4,36050001,20000},{8,36050002,20000},{0,32000011,2}]','[{4,36050001,14000},{8,36050002,14000},{0,32000011,1}]','[]'),(261,320,1,1,'[{4,36050001,70000},{8,36050002,70000},{0,32000012,6}]','[{4,36050001,49000},{8,36050002,49000},{0,32000012,4}]','[]'),(261,320,2,1,'[{4,36050001,49000},{8,36050002,49000},{0,32000012,4}]','[{4,36050001,34000},{8,36050002,34000},{0,32000012,2}]','[]'),(261,320,3,1,'[{4,36050001,34000},{8,36050002,34000},{0,32000011,4}]','[{4,36050001,24000},{8,36050002,24000},{0,32000011,2}]','[]'),(261,320,4,1,'[{4,36050001,24000},{8,36050002,24000},{0,32000011,2}]','[{4,36050001,17000},{8,36050002,17000},{0,32000011,1}]','[]'),(321,350,1,1,'[{4,36050001,70000},{8,36050002,70000},{0,32000012,6}]','[{4,36050001,49000},{8,36050002,49000},{0,32000012,4}]','[]'),(321,350,2,1,'[{4,36050001,49000},{8,36050002,49000},{0,32000012,4}]','[{4,36050001,34000},{8,36050002,34000},{0,32000012,2}]','[]'),(321,350,3,1,'[{4,36050001,34000},{8,36050002,34000},{0,32000011,4}]','[{4,36050001,24000},{8,36050002,24000},{0,32000011,2}]','[]'),(321,350,4,1,'[{4,36050001,24000},{8,36050002,24000},{0,32000011,2}]','[{4,36050001,17000},{8,36050002,17000},{0,32000011,1}]','[]'),(351,370,1,1,'[{4,36050001,80000},{8,36050002,80000},{0,32000012,6}]','[{4,36050001,56000},{8,36050002,56000},{0,32000012,4}]','[]'),(351,370,2,1,'[{4,36050001,56000},{8,36050002,56000},{0,32000012,4}]','[{4,36050001,39000},{8,36050002,39000},{0,32000012,2}]','[]'),(351,370,3,1,'[{4,36050001,39000},{8,36050002,39000},{0,32000011,4}]','[{4,36050001,27000},{8,36050002,27000},{0,32000011,2}]','[]'),(351,370,4,1,'[{4,36050001,27000},{8,36050002,27000},{0,32000011,2}]','[{4,36050001,19000},{8,36050002,19000},{0,32000011,1}]','[]'),(371,390,1,1,'[{4,36050001,80000},{8,36050002,80000},{0,32000012,6}]','[{4,36050001,56000},{8,36050002,56000},{0,32000012,4}]','[]'),(371,390,2,1,'[{4,36050001,56000},{8,36050002,56000},{0,32000012,4}]','[{4,36050001,39000},{8,36050002,39000},{0,32000012,2}]','[]'),(371,390,3,1,'[{4,36050001,39000},{8,36050002,39000},{0,32000011,4}]','[{4,36050001,27000},{8,36050002,27000},{0,32000011,2}]','[]'),(371,390,4,1,'[{4,36050001,27000},{8,36050002,27000},{0,32000011,2}]','[{4,36050001,19000},{8,36050002,19000},{0,32000011,1}]','[]'),(391,430,1,1,'[{4,36050001,90000},{8,36050002,90000},{0,32000012,6}]','[{4,36050001,63000},{8,36050002,63000},{0,32000012,4}]','[]'),(391,430,2,1,'[{4,36050001,63000},{8,36050002,63000},{0,32000012,4}]','[{4,36050001,44000},{8,36050002,44000},{0,32000012,2}]','[]'),(391,430,3,1,'[{4,36050001,44000},{8,36050002,44000},{0,32000011,4}]','[{4,36050001,31000},{8,36050002,31000},{0,32000011,2}]','[]'),(391,430,4,1,'[{4,36050001,31000},{8,36050002,31000},{0,32000011,2}]','[{4,36050001,22000},{8,36050002,22000},{0,32000011,1}]','[]'),(431,500,1,1,'[{4,36050001,90000},{8,36050002,90000},{0,32000012,6}]','[{4,36050001,63000},{8,36050002,63000},{0,32000012,4}]','[]'),(431,500,2,1,'[{4,36050001,63000},{8,36050002,63000},{0,32000012,4}]','[{4,36050001,44000},{8,36050002,44000},{0,32000012,2}]','[]'),(431,500,3,1,'[{4,36050001,44000},{8,36050002,44000},{0,32000011,4}]','[{4,36050001,31000},{8,36050002,31000},{0,32000011,2}]','[]'),(431,500,4,1,'[{4,36050001,31000},{8,36050002,31000},{0,32000011,2}]','[{4,36050001,22000},{8,36050002,22000},{0,32000011,1}]','[]'),(501,560,1,1,'[{4,36050001,100000},{8,36050002,100000},{0,32000012,6}]','[{4,36050001,70000},{8,36050002,70000},{0,32000012,4}]','[]'),(501,560,2,1,'[{4,36050001,70000},{8,36050002,70000},{0,32000012,4}]','[{4,36050001,49000},{8,36050002,49000},{0,32000012,2}]','[]'),(501,560,3,1,'[{4,36050001,49000},{8,36050002,49000},{0,32000011,4}]','[{4,36050001,34000},{8,36050002,34000},{0,32000011,2}]','[]'),(501,560,4,1,'[{4,36050001,34000},{8,36050002,34000},{0,32000011,2}]','[{4,36050001,24000},{8,36050002,24000},{0,32000011,1}]','[]'),(561,610,1,1,'[{4,36050001,100000},{8,36050002,100000},{0,32000012,6}]','[{4,36050001,70000},{8,36050002,70000},{0,32000012,4}]','[]'),(561,610,2,1,'[{4,36050001,70000},{8,36050002,70000},{0,32000012,4}]','[{4,36050001,49000},{8,36050002,49000},{0,32000012,2}]','[]'),(561,610,3,1,'[{4,36050001,49000},{8,36050002,49000},{0,32000011,4}]','[{4,36050001,34000},{8,36050002,34000},{0,32000011,2}]','[]'),(561,610,4,1,'[{4,36050001,34000},{8,36050002,34000},{0,32000011,2}]','[{4,36050001,24000},{8,36050002,24000},{0,32000011,1}]','[]'),(611,660,1,1,'[{4,36050001,110000},{8,36050002,110000},{0,32000012,6}]','[{4,36050001,77000},{8,36050002,77000},{0,32000012,4}]','[]'),(611,660,2,1,'[{4,36050001,77000},{8,36050002,77000},{0,32000012,4}]','[{4,36050001,54000},{8,36050002,54000},{0,32000012,2}]','[]'),(611,660,3,1,'[{4,36050001,54000},{8,36050002,54000},{0,32000011,4}]','[{4,36050001,38000},{8,36050002,38000},{0,32000011,2}]','[]'),(611,660,4,1,'[{4,36050001,38000},{8,36050002,38000},{0,32000011,2}]','[{4,36050001,27000},{8,36050002,27000},{0,32000011,1}]','[]'),(661,750,1,1,'[{4,36050001,110000},{8,36050002,110000},{0,32000012,6}]','[{4,36050001,77000},{8,36050002,77000},{0,32000012,4}]','[]'),(661,750,2,1,'[{4,36050001,77000},{8,36050002,77000},{0,32000012,4}]','[{4,36050001,54000},{8,36050002,54000},{0,32000012,2}]','[]'),(661,750,3,1,'[{4,36050001,54000},{8,36050002,54000},{0,32000011,4}]','[{4,36050001,38000},{8,36050002,38000},{0,32000011,2}]','[]'),(661,750,4,1,'[{4,36050001,38000},{8,36050002,38000},{0,32000011,2}]','[{4,36050001,27000},{8,36050002,27000},{0,32000011,1}]','[]'),(751,1000,1,1,'[{4,36050001,120000},{8,36050002,120000},{0,32000012,6}]','[{4,36050001,84000},{8,36050002,84000},{0,32000012,4}]','[]'),(751,1000,2,1,'[{4,36050001,84000},{8,36050002,84000},{0,32000012,4}]','[{4,36050001,59000},{8,36050002,59000},{0,32000012,2}]','[]'),(751,1000,3,1,'[{4,36050001,59000},{8,36050002,59000},{0,32000011,4}]','[{4,36050001,41000},{8,36050002,41000},{0,32000011,2}]','[]'),(751,1000,4,1,'[{4,36050001,41000},{8,36050002,41000},{0,32000011,2}]','[{4,36050001,29000},{8,36050002,29000},{0,32000011,1}]','[]');
/*!40000 ALTER TABLE `base_guild_war_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_guild_war_score`
--

DROP TABLE IF EXISTS `base_guild_war_score`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_guild_war_score` (
  `type` tinyint(2) unsigned NOT NULL COMMENT '建筑类型',
  `person_score` int(11) unsigned NOT NULL COMMENT '个人得分',
  `guild_score` int(11) unsigned NOT NULL COMMENT '公会得分',
  PRIMARY KEY (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会争霸积分配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_guild_war_score`
--

LOCK TABLES `base_guild_war_score` WRITE;
/*!40000 ALTER TABLE `base_guild_war_score` DISABLE KEYS */;
INSERT INTO `base_guild_war_score` VALUES (1,100,50),(2,200,80),(3,400,150),(4,5,0),(5,10,10);
/*!40000 ALTER TABLE `base_guild_war_score` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_guild_war_score_reward`
--

DROP TABLE IF EXISTS `base_guild_war_score_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_guild_war_score_reward` (
  `id` smallint(5) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `min_world_lv` smallint(5) unsigned NOT NULL COMMENT '最小世界等级',
  `max_world_lv` smallint(5) unsigned NOT NULL COMMENT '最大世界等级',
  `score` int(11) unsigned NOT NULL COMMENT '目标分数',
  `next_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '下一个阶段分数',
  `reward` varchar(255) NOT NULL COMMENT '目标奖励',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=113 DEFAULT CHARSET=utf8 COMMENT='公会争霸目标奖励配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_guild_war_score_reward`
--

LOCK TABLES `base_guild_war_score_reward` WRITE;
/*!40000 ALTER TABLE `base_guild_war_score_reward` DISABLE KEYS */;
INSERT INTO `base_guild_war_score_reward` VALUES (1,1,200,100,200,'[{5,0,2114637},{4,36050001,4500}]'),(2,201,260,100,200,'[{5,0,2114637},{4,36050001,5000}]'),(3,261,320,100,200,'[{5,0,3823844},{4,36050001,5400}]'),(4,321,350,100,200,'[{5,0,11436987},{4,36050001,5900}]'),(5,351,370,100,200,'[{5,0,23890791},{4,36050001,6300}]'),(6,371,390,100,200,'[{5,0,39717642},{4,36050001,6800}]'),(7,391,430,100,200,'[{5,0,52068044},{4,36050001,7200}]'),(8,431,500,100,200,'[{5,0,62328044},{4,36050001,7700}]'),(9,501,560,100,200,'[{5,0,72588044},{4,36050001,8100}]'),(10,561,610,100,200,'[{5,0,82848044},{4,36050001,8600}]'),(11,611,660,100,200,'[{5,0,91056044},{4,36050001,9000}]'),(12,661,750,100,200,'[{5,0,91056044},{4,36050001,9500}]'),(13,751,800,100,200,'[{5,0,91056044},{4,36050001,9900}]'),(14,801,1000,100,200,'[{5,0,91056044},{4,36050001,10400}]'),(15,1,200,200,300,'[{5,0,2349597},{4,36050001,5000},{0,32000011,1}]'),(16,201,260,200,300,'[{5,0,2349597},{4,36050001,5500},{0,32000011,1}]'),(17,261,320,200,300,'[{5,0,4248716},{4,36050001,6000},{0,32000011,1}]'),(18,321,350,200,300,'[{5,0,12707764},{4,36050001,6500},{0,32000011,1}]'),(19,351,370,200,300,'[{5,0,26545323},{4,36050001,7000},{0,32000011,1}]'),(20,371,390,200,300,'[{5,0,44130713},{4,36050001,7500},{0,32000011,1}]'),(21,391,430,200,300,'[{5,0,57853382},{4,36050001,8000},{0,32000011,1}]'),(22,431,500,200,300,'[{5,0,69253382},{4,36050001,8500},{0,32000011,1}]'),(23,501,560,200,300,'[{5,0,80653382},{4,36050001,9000},{0,32000011,1}]'),(24,561,610,200,300,'[{5,0,92053382},{4,36050001,9500},{0,32000011,1}]'),(25,611,660,200,300,'[{5,0,101173382},{4,36050001,10000},{0,32000011,1}]'),(26,661,750,200,300,'[{5,0,101173382},{4,36050001,10500},{0,32000011,1}]'),(27,751,800,200,300,'[{5,0,101173382},{4,36050001,11000},{0,32000011,1}]'),(28,801,1000,200,300,'[{5,0,101173382},{4,36050001,11500},{0,32000011,1}]'),(29,1,200,300,400,'[{5,0,2584557},{4,36050001,5500}]'),(30,201,260,300,400,'[{5,0,2584557},{4,36050001,6100}]'),(31,261,320,300,400,'[{5,0,4673587},{4,36050001,6600}]'),(32,321,350,300,400,'[{5,0,13978540},{4,36050001,7200}]'),(33,351,370,300,400,'[{5,0,29199855},{4,36050001,7700}]'),(34,371,390,300,400,'[{5,0,48543784},{4,36050001,8300}]'),(35,391,430,300,400,'[{5,0,63638720},{4,36050001,8800}]'),(36,431,500,300,400,'[{5,0,76178720},{4,36050001,9400}]'),(37,501,560,300,400,'[{5,0,88718720},{4,36050001,9900}]'),(38,561,610,300,400,'[{5,0,101258720},{4,36050001,10500}]'),(39,611,660,300,400,'[{5,0,111290720},{4,36050001,11000}]'),(40,661,750,300,400,'[{5,0,111290720},{4,36050001,11600}]'),(41,751,800,300,400,'[{5,0,111290720},{4,36050001,12100}]'),(42,801,1000,300,400,'[{5,0,111290720},{4,36050001,12700}]'),(43,1,200,400,600,'[{5,0,2819516},{4,36050001,6000}]'),(44,201,260,400,600,'[{5,0,2819516},{4,36050001,6600}]'),(45,261,320,400,600,'[{5,0,5098459},{4,36050001,7200}]'),(46,321,350,400,600,'[{5,0,15249317},{4,36050001,7800}]'),(47,351,370,400,600,'[{5,0,31854387},{4,36050001,8400}]'),(48,371,390,400,600,'[{5,0,52956855},{4,36050001,9000}]'),(49,391,430,400,600,'[{5,0,69424058},{4,36050001,9600}]'),(50,431,500,400,600,'[{5,0,83104058},{4,36050001,10200}]'),(51,501,560,400,600,'[{5,0,96784058},{4,36050001,10800}]'),(52,561,610,400,600,'[{5,0,110464058},{4,36050001,11400}]'),(53,611,660,400,600,'[{5,0,121408058},{4,36050001,12000}]'),(54,661,750,400,600,'[{5,0,121408058},{4,36050001,12600}]'),(55,751,800,400,600,'[{5,0,121408058},{4,36050001,13200}]'),(56,801,1000,400,600,'[{5,0,121408058},{4,36050001,13800}]'),(57,1,200,600,900,'[{5,0,3054476},{4,36050001,6500},{0,32000011,1}]'),(58,201,260,600,900,'[{5,0,3054476},{4,36050001,7200},{0,32000011,1}]'),(59,261,320,600,900,'[{5,0,5523330},{4,36050001,7800},{0,32000011,1}]'),(60,321,350,600,900,'[{5,0,16520093},{4,36050001,8500},{0,32000011,1}]'),(61,351,370,600,900,'[{5,0,34508920},{4,36050001,9100},{0,32000011,1}]'),(62,371,390,600,900,'[{5,0,57369927},{4,36050001,9800},{0,32000011,1}]'),(63,391,430,600,900,'[{5,0,75209396},{4,36050001,10400},{0,32000011,1}]'),(64,431,500,600,900,'[{5,0,90029396},{4,36050001,11100},{0,32000011,1}]'),(65,501,560,600,900,'[{5,0,104849396},{4,36050001,11700},{0,32000011,1}]'),(66,561,610,600,900,'[{5,0,119669396},{4,36050001,12400},{0,32000011,1}]'),(67,611,660,600,900,'[{5,0,131525396},{4,36050001,13000},{0,32000011,1}]'),(68,661,750,600,900,'[{5,0,131525396},{4,36050001,13700},{0,32000011,1}]'),(69,751,800,600,900,'[{5,0,131525396},{4,36050001,14300},{0,32000011,1}]'),(70,801,1000,600,900,'[{5,0,131525396},{4,36050001,15000},{0,32000011,1}]'),(71,1,200,900,1200,'[{5,0,3289436},{4,36050001,7000}]'),(72,201,260,900,1200,'[{5,0,3289436},{4,36050001,7700}]'),(73,261,320,900,1200,'[{5,0,5948202},{4,36050001,8400}]'),(74,321,350,900,1200,'[{5,0,17790869},{4,36050001,9100}]'),(75,351,370,900,1200,'[{5,0,37163452},{4,36050001,9800}]'),(76,371,390,900,1200,'[{5,0,61782998},{4,36050001,10500}]'),(77,391,430,900,1200,'[{5,0,80994735},{4,36050001,11200}]'),(78,431,500,900,1200,'[{5,0,96954735},{4,36050001,11900}]'),(79,501,560,900,1200,'[{5,0,112914735},{4,36050001,12600}]'),(80,561,610,900,1200,'[{5,0,128874735},{4,36050001,13300}]'),(81,611,660,900,1200,'[{5,0,141642735},{4,36050001,14000}]'),(82,661,750,900,1200,'[{5,0,141642735},{4,36050001,14700}]'),(83,751,800,900,1200,'[{5,0,141642735},{4,36050001,15400}]'),(84,801,1000,900,1200,'[{5,0,141642735},{4,36050001,16100}]'),(85,1,200,1200,1500,'[{5,0,3524396},{4,36050001,7500}]'),(86,201,260,1200,1500,'[{5,0,3524396},{4,36050001,8300}]'),(87,261,320,1200,1500,'[{5,0,6373074},{4,36050001,9000}]'),(88,321,350,1200,1500,'[{5,0,19061646},{4,36050001,9800}]'),(89,351,370,1200,1500,'[{5,0,39817984},{4,36050001,10500}]'),(90,371,390,1200,1500,'[{5,0,66196069},{4,36050001,11300}]'),(91,391,430,1200,1500,'[{5,0,86780073},{4,36050001,12000}]'),(92,431,500,1200,1500,'[{5,0,103880073},{4,36050001,12800}]'),(93,501,560,1200,1500,'[{5,0,120980073},{4,36050001,13500}]'),(94,561,610,1200,1500,'[{5,0,138080073},{4,36050001,14300}]'),(95,611,660,1200,1500,'[{5,0,151760073},{4,36050001,15000}]'),(96,661,750,1200,1500,'[{5,0,151760073},{4,36050001,15800}]'),(97,751,800,1200,1500,'[{5,0,151760073},{4,36050001,16500}]'),(98,801,1000,1200,1500,'[{5,0,151760073},{4,36050001,17300}]'),(99,1,200,1500,9999,'[{5,0,3759355},{4,36050001,8000},{0,32000011,2}]'),(100,201,260,1500,9999,'[{5,0,3759355},{4,36050001,8800},{0,32000011,2}]'),(101,261,320,1500,9999,'[{5,0,6797945},{4,36050001,9600},{0,32000011,2}]'),(102,321,350,1500,9999,'[{5,0,20332422},{4,36050001,10400},{0,32000011,2}]'),(103,351,370,1500,9999,'[{5,0,42472516},{4,36050001,11200},{0,32000011,2}]'),(104,371,390,1500,9999,'[{5,0,70609140},{4,36050001,12000},{0,32000011,2}]'),(105,391,430,1500,9999,'[{5,0,92565411},{4,36050001,12800},{0,32000011,2}]'),(106,431,500,1500,9999,'[{5,0,110805411},{4,36050001,13600},{0,32000011,2}]'),(107,501,560,1500,9999,'[{5,0,129045411},{4,36050001,14400},{0,32000011,2}]'),(108,561,610,1500,9999,'[{5,0,147285411},{4,36050001,15200},{0,32000011,2}]'),(109,611,660,1500,9999,'[{5,0,161877411},{4,36050001,16000},{0,32000011,2}]'),(110,661,750,1500,9999,'[{5,0,161877411},{4,36050001,16800},{0,32000011,2}]'),(111,751,800,1500,9999,'[{5,0,161877411},{4,36050001,17600},{0,32000011,2}]'),(112,801,1000,1500,9999,'[{5,0,161877411},{4,36050001,18400},{0,32000011,2}]');
/*!40000 ALTER TABLE `base_guild_war_score_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_guild_war_streak_reward`
--

DROP TABLE IF EXISTS `base_guild_war_streak_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_guild_war_streak_reward` (
  `min_wlv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '世界等级下限',
  `max_wlv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '世界等级上限',
  `streak_times` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '连胜次数',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`min_wlv`,`max_wlv`,`streak_times`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会争霸连胜奖励配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_guild_war_streak_reward`
--

LOCK TABLES `base_guild_war_streak_reward` WRITE;
/*!40000 ALTER TABLE `base_guild_war_streak_reward` DISABLE KEYS */;
INSERT INTO `base_guild_war_streak_reward` VALUES (1,200,1,'[{0,32080542,1}]'),(1,200,2,'[{0,32080542,1}]'),(1,200,3,'[{0,32080542,1}]'),(1,200,4,'[{0,32080542,1}]'),(1,200,5,'[{0,32080542,1}]'),(1,200,6,'[{0,32080542,1}]'),(1,200,7,'[{0,32080542,1}]'),(1,200,8,'[{0,32080542,1}]'),(1,200,9,'[{0,32080542,1}]'),(1,200,10,'[{0,32080542,1}]'),(1,200,11,'[{0,32080542,1}]'),(1,200,12,'[{0,32080542,1}]'),(1,200,13,'[{0,32080542,1}]'),(1,200,14,'[{0,32080542,1}]'),(1,200,15,'[{0,32080542,1}]'),(1,200,16,'[{0,32080542,1}]'),(1,200,17,'[{0,32080542,1}]'),(1,200,18,'[{0,32080542,1}]'),(1,200,19,'[{0,32080542,1}]'),(1,200,20,'[{0,32080542,1}]'),(1,200,21,'[{0,32080542,1}]'),(1,200,22,'[{0,32080542,1}]'),(1,200,23,'[{0,32080542,1}]'),(1,200,24,'[{0,32080542,1}]'),(1,200,25,'[{0,32080542,1}]'),(1,200,26,'[{0,32080542,1}]'),(1,200,27,'[{0,32080542,1}]'),(1,200,28,'[{0,32080542,1}]'),(1,200,29,'[{0,32080542,1}]'),(1,200,30,'[{0,32080542,1}]'),(1,200,31,'[{0,32080542,1}]'),(1,200,32,'[{0,32080542,1}]'),(1,200,33,'[{0,32080542,1}]'),(1,200,34,'[{0,32080542,1}]'),(1,200,35,'[{0,32080542,1}]'),(1,200,36,'[{0,32080542,1}]'),(1,200,37,'[{0,32080542,1}]'),(1,200,38,'[{0,32080542,1}]'),(1,200,39,'[{0,32080542,1}]'),(1,200,40,'[{0,32080542,1}]'),(1,200,41,'[{0,32080542,1}]'),(1,200,42,'[{0,32080542,1}]'),(1,200,43,'[{0,32080542,1}]'),(1,200,44,'[{0,32080542,1}]'),(1,200,45,'[{0,32080542,1}]'),(1,200,46,'[{0,32080542,1}]'),(1,200,47,'[{0,32080542,1}]'),(1,200,48,'[{0,32080542,1}]'),(1,200,49,'[{0,32080542,1}]'),(1,200,50,'[{0,32080542,1}]'),(1,200,51,'[{0,32080542,1}]'),(1,200,52,'[{0,32080542,1}]'),(1,200,53,'[{0,32080542,1}]'),(1,200,54,'[{0,32080542,1}]'),(1,200,55,'[{0,32080542,1}]'),(1,200,56,'[{0,32080542,1}]'),(1,200,57,'[{0,32080542,1}]'),(1,200,58,'[{0,32080542,1}]'),(1,200,59,'[{0,32080542,1}]'),(1,200,60,'[{0,32080542,1}]'),(1,200,61,'[{0,32080542,1}]'),(1,200,62,'[{0,32080542,1}]'),(1,200,63,'[{0,32080542,1}]'),(1,200,64,'[{0,32080542,1}]'),(1,200,65,'[{0,32080542,1}]'),(1,200,66,'[{0,32080542,1}]'),(1,200,67,'[{0,32080542,1}]'),(1,200,68,'[{0,32080542,1}]'),(1,200,69,'[{0,32080542,1}]'),(1,200,70,'[{0,32080542,1}]'),(1,200,71,'[{0,32080542,1}]'),(1,200,72,'[{0,32080542,1}]'),(1,200,73,'[{0,32080542,1}]'),(1,200,74,'[{0,32080542,1}]'),(1,200,75,'[{0,32080542,1}]'),(1,200,76,'[{0,32080542,1}]'),(1,200,77,'[{0,32080542,1}]'),(1,200,78,'[{0,32080542,1}]'),(1,200,79,'[{0,32080542,1}]'),(1,200,80,'[{0,32080542,1}]'),(1,200,81,'[{0,32080542,1}]'),(1,200,82,'[{0,32080542,1}]'),(1,200,83,'[{0,32080542,1}]'),(1,200,84,'[{0,32080542,1}]'),(1,200,85,'[{0,32080542,1}]'),(1,200,86,'[{0,32080542,1}]'),(1,200,87,'[{0,32080542,1}]'),(1,200,88,'[{0,32080542,1}]'),(1,200,89,'[{0,32080542,1}]'),(1,200,90,'[{0,32080542,1}]'),(1,200,91,'[{0,32080542,1}]'),(1,200,92,'[{0,32080542,1}]'),(1,200,93,'[{0,32080542,1}]'),(1,200,94,'[{0,32080542,1}]'),(1,200,95,'[{0,32080542,1}]'),(1,200,96,'[{0,32080542,1}]'),(1,200,97,'[{0,32080542,1}]'),(1,200,98,'[{0,32080542,1}]'),(1,200,99,'[{0,32080542,1}]'),(1,200,100,'[{0,32080542,1}]'),(1,200,101,'[{0,32080542,1}]'),(1,200,102,'[{0,32080542,1}]'),(1,200,103,'[{0,32080542,1}]'),(1,200,104,'[{0,32080542,1}]'),(1,200,105,'[{0,32080542,1}]'),(1,200,106,'[{0,32080542,1}]'),(1,200,107,'[{0,32080542,1}]'),(1,200,108,'[{0,32080542,1}]'),(1,200,109,'[{0,32080542,1}]'),(1,200,110,'[{0,32080542,1}]'),(1,200,111,'[{0,32080542,1}]'),(1,200,112,'[{0,32080542,1}]'),(1,200,113,'[{0,32080542,1}]'),(1,200,114,'[{0,32080542,1}]'),(1,200,115,'[{0,32080542,1}]'),(1,200,116,'[{0,32080542,1}]'),(1,200,117,'[{0,32080542,1}]'),(1,200,118,'[{0,32080542,1}]'),(1,200,119,'[{0,32080542,1}]'),(1,200,120,'[{0,32080542,1}]'),(1,200,121,'[{0,32080542,1}]'),(1,200,122,'[{0,32080542,1}]'),(1,200,123,'[{0,32080542,1}]'),(1,200,124,'[{0,32080542,1}]'),(1,200,125,'[{0,32080542,1}]'),(1,200,126,'[{0,32080542,1}]'),(1,200,127,'[{0,32080542,1}]'),(1,200,128,'[{0,32080542,1}]'),(1,200,129,'[{0,32080542,1}]'),(1,200,130,'[{0,32080542,1}]'),(1,200,131,'[{0,32080542,1}]'),(1,200,132,'[{0,32080542,1}]'),(1,200,133,'[{0,32080542,1}]'),(1,200,134,'[{0,32080542,1}]'),(1,200,135,'[{0,32080542,1}]'),(1,200,136,'[{0,32080542,1}]'),(1,200,137,'[{0,32080542,1}]'),(1,200,138,'[{0,32080542,1}]'),(1,200,139,'[{0,32080542,1}]'),(1,200,140,'[{0,32080542,1}]'),(1,200,141,'[{0,32080542,1}]'),(1,200,142,'[{0,32080542,1}]'),(1,200,143,'[{0,32080542,1}]'),(1,200,144,'[{0,32080542,1}]'),(1,200,145,'[{0,32080542,1}]'),(1,200,146,'[{0,32080542,1}]'),(1,200,147,'[{0,32080542,1}]'),(1,200,148,'[{0,32080542,1}]'),(1,200,149,'[{0,32080542,1}]'),(1,200,150,'[{0,32080542,1}]'),(1,200,151,'[{0,32080542,1}]'),(1,200,152,'[{0,32080542,1}]'),(1,200,153,'[{0,32080542,1}]'),(1,200,154,'[{0,32080542,1}]'),(1,200,155,'[{0,32080542,1}]'),(1,200,156,'[{0,32080542,1}]'),(1,200,157,'[{0,32080542,1}]'),(1,200,158,'[{0,32080542,1}]'),(1,200,159,'[{0,32080542,1}]'),(1,200,160,'[{0,32080542,1}]'),(1,200,161,'[{0,32080542,1}]'),(1,200,162,'[{0,32080542,1}]'),(1,200,163,'[{0,32080542,1}]'),(1,200,164,'[{0,32080542,1}]'),(1,200,165,'[{0,32080542,1}]'),(1,200,166,'[{0,32080542,1}]'),(1,200,167,'[{0,32080542,1}]'),(1,200,168,'[{0,32080542,1}]'),(1,200,169,'[{0,32080542,1}]'),(1,200,170,'[{0,32080542,1}]'),(1,200,171,'[{0,32080542,1}]'),(1,200,172,'[{0,32080542,1}]'),(1,200,173,'[{0,32080542,1}]'),(1,200,174,'[{0,32080542,1}]'),(1,200,175,'[{0,32080542,1}]'),(1,200,176,'[{0,32080542,1}]'),(1,200,177,'[{0,32080542,1}]'),(1,200,178,'[{0,32080542,1}]'),(1,200,179,'[{0,32080542,1}]'),(1,200,180,'[{0,32080542,1}]'),(1,200,181,'[{0,32080542,1}]'),(1,200,182,'[{0,32080542,1}]'),(1,200,183,'[{0,32080542,1}]'),(1,200,184,'[{0,32080542,1}]'),(1,200,185,'[{0,32080542,1}]'),(1,200,186,'[{0,32080542,1}]'),(1,200,187,'[{0,32080542,1}]'),(1,200,188,'[{0,32080542,1}]'),(1,200,189,'[{0,32080542,1}]'),(1,200,190,'[{0,32080542,1}]'),(1,200,191,'[{0,32080542,1}]'),(1,200,192,'[{0,32080542,1}]'),(1,200,193,'[{0,32080542,1}]'),(1,200,194,'[{0,32080542,1}]'),(1,200,195,'[{0,32080542,1}]'),(1,200,196,'[{0,32080542,1}]'),(1,200,197,'[{0,32080542,1}]'),(1,200,198,'[{0,32080542,1}]'),(1,200,199,'[{0,32080542,1}]'),(1,200,200,'[{0,32080542,1}]'),(1,200,201,'[{0,32080542,1}]'),(1,200,202,'[{0,32080542,1}]'),(1,200,203,'[{0,32080542,1}]'),(1,200,204,'[{0,32080542,1}]'),(1,200,205,'[{0,32080542,1}]'),(1,200,206,'[{0,32080542,1}]'),(1,200,207,'[{0,32080542,1}]'),(1,200,208,'[{0,32080542,1}]'),(1,200,209,'[{0,32080542,1}]'),(1,200,210,'[{0,32080542,1}]'),(1,200,211,'[{0,32080542,1}]'),(1,200,212,'[{0,32080542,1}]'),(1,200,213,'[{0,32080542,1}]'),(1,200,214,'[{0,32080542,1}]'),(1,200,215,'[{0,32080542,1}]'),(1,200,216,'[{0,32080542,1}]'),(1,200,217,'[{0,32080542,1}]'),(1,200,218,'[{0,32080542,1}]'),(201,260,1,'[{0,32080642,1}]'),(201,260,2,'[{0,32080642,1}]'),(201,260,3,'[{0,32080642,1}]'),(201,260,4,'[{0,32080642,1}]'),(201,260,5,'[{0,32080642,1}]'),(201,260,6,'[{0,32080642,1}]'),(201,260,7,'[{0,32080642,1}]'),(201,260,8,'[{0,32080642,1}]'),(201,260,9,'[{0,32080642,1}]'),(201,260,10,'[{0,32080642,1}]'),(201,260,11,'[{0,32080642,1}]'),(201,260,12,'[{0,32080642,1}]'),(201,260,13,'[{0,32080642,1}]'),(201,260,14,'[{0,32080642,1}]'),(201,260,15,'[{0,32080642,1}]'),(201,260,16,'[{0,32080642,1}]'),(201,260,17,'[{0,32080642,1}]'),(201,260,18,'[{0,32080642,1}]'),(201,260,19,'[{0,32080642,1}]'),(201,260,20,'[{0,32080642,1}]'),(201,260,21,'[{0,32080642,1}]'),(201,260,22,'[{0,32080642,1}]'),(201,260,23,'[{0,32080642,1}]'),(201,260,24,'[{0,32080642,1}]'),(201,260,25,'[{0,32080642,1}]'),(201,260,26,'[{0,32080642,1}]'),(201,260,27,'[{0,32080642,1}]'),(201,260,28,'[{0,32080642,1}]'),(201,260,29,'[{0,32080642,1}]'),(201,260,30,'[{0,32080642,1}]'),(201,260,31,'[{0,32080642,1}]'),(201,260,32,'[{0,32080642,1}]'),(201,260,33,'[{0,32080642,1}]'),(201,260,34,'[{0,32080642,1}]'),(201,260,35,'[{0,32080642,1}]'),(201,260,36,'[{0,32080642,1}]'),(201,260,37,'[{0,32080642,1}]'),(201,260,38,'[{0,32080642,1}]'),(201,260,39,'[{0,32080642,1}]'),(201,260,40,'[{0,32080642,1}]'),(201,260,41,'[{0,32080642,1}]'),(201,260,42,'[{0,32080642,1}]'),(201,260,43,'[{0,32080642,1}]'),(201,260,44,'[{0,32080642,1}]'),(201,260,45,'[{0,32080642,1}]'),(201,260,46,'[{0,32080642,1}]'),(201,260,47,'[{0,32080642,1}]'),(201,260,48,'[{0,32080642,1}]'),(201,260,49,'[{0,32080642,1}]'),(201,260,50,'[{0,32080642,1}]'),(201,260,51,'[{0,32080642,1}]'),(201,260,52,'[{0,32080642,1}]'),(201,260,53,'[{0,32080642,1}]'),(201,260,54,'[{0,32080642,1}]'),(201,260,55,'[{0,32080642,1}]'),(201,260,56,'[{0,32080642,1}]'),(201,260,57,'[{0,32080642,1}]'),(201,260,58,'[{0,32080642,1}]'),(201,260,59,'[{0,32080642,1}]'),(201,260,60,'[{0,32080642,1}]'),(201,260,61,'[{0,32080642,1}]'),(201,260,62,'[{0,32080642,1}]'),(201,260,63,'[{0,32080642,1}]'),(201,260,64,'[{0,32080642,1}]'),(201,260,65,'[{0,32080642,1}]'),(201,260,66,'[{0,32080642,1}]'),(201,260,67,'[{0,32080642,1}]'),(201,260,68,'[{0,32080642,1}]'),(201,260,69,'[{0,32080642,1}]'),(201,260,70,'[{0,32080642,1}]'),(201,260,71,'[{0,32080642,1}]'),(201,260,72,'[{0,32080642,1}]'),(201,260,73,'[{0,32080642,1}]'),(201,260,74,'[{0,32080642,1}]'),(201,260,75,'[{0,32080642,1}]'),(201,260,76,'[{0,32080642,1}]'),(201,260,77,'[{0,32080642,1}]'),(201,260,78,'[{0,32080642,1}]'),(201,260,79,'[{0,32080642,1}]'),(201,260,80,'[{0,32080642,1}]'),(201,260,81,'[{0,32080642,1}]'),(201,260,82,'[{0,32080642,1}]'),(201,260,83,'[{0,32080642,1}]'),(201,260,84,'[{0,32080642,1}]'),(201,260,85,'[{0,32080642,1}]'),(201,260,86,'[{0,32080642,1}]'),(201,260,87,'[{0,32080642,1}]'),(201,260,88,'[{0,32080642,1}]'),(201,260,89,'[{0,32080642,1}]'),(201,260,90,'[{0,32080642,1}]'),(201,260,91,'[{0,32080642,1}]'),(201,260,92,'[{0,32080642,1}]'),(201,260,93,'[{0,32080642,1}]'),(201,260,94,'[{0,32080642,1}]'),(201,260,95,'[{0,32080642,1}]'),(201,260,96,'[{0,32080642,1}]'),(201,260,97,'[{0,32080642,1}]'),(201,260,98,'[{0,32080642,1}]'),(201,260,99,'[{0,32080642,1}]'),(201,260,100,'[{0,32080642,1}]'),(201,260,101,'[{0,32080642,1}]'),(201,260,102,'[{0,32080642,1}]'),(201,260,103,'[{0,32080642,1}]'),(201,260,104,'[{0,32080642,1}]'),(201,260,105,'[{0,32080642,1}]'),(201,260,106,'[{0,32080642,1}]'),(201,260,107,'[{0,32080642,1}]'),(201,260,108,'[{0,32080642,1}]'),(201,260,109,'[{0,32080642,1}]'),(201,260,110,'[{0,32080642,1}]'),(201,260,111,'[{0,32080642,1}]'),(201,260,112,'[{0,32080642,1}]'),(201,260,113,'[{0,32080642,1}]'),(201,260,114,'[{0,32080642,1}]'),(201,260,115,'[{0,32080642,1}]'),(201,260,116,'[{0,32080642,1}]'),(201,260,117,'[{0,32080642,1}]'),(201,260,118,'[{0,32080642,1}]'),(201,260,119,'[{0,32080642,1}]'),(201,260,120,'[{0,32080642,1}]'),(201,260,121,'[{0,32080642,1}]'),(201,260,122,'[{0,32080642,1}]'),(201,260,123,'[{0,32080642,1}]'),(201,260,124,'[{0,32080642,1}]'),(201,260,125,'[{0,32080642,1}]'),(201,260,126,'[{0,32080642,1}]'),(201,260,127,'[{0,32080642,1}]'),(201,260,128,'[{0,32080642,1}]'),(201,260,129,'[{0,32080642,1}]'),(201,260,130,'[{0,32080642,1}]'),(201,260,131,'[{0,32080642,1}]'),(201,260,132,'[{0,32080642,1}]'),(201,260,133,'[{0,32080642,1}]'),(201,260,134,'[{0,32080642,1}]'),(201,260,135,'[{0,32080642,1}]'),(201,260,136,'[{0,32080642,1}]'),(201,260,137,'[{0,32080642,1}]'),(201,260,138,'[{0,32080642,1}]'),(201,260,139,'[{0,32080642,1}]'),(201,260,140,'[{0,32080642,1}]'),(201,260,141,'[{0,32080642,1}]'),(201,260,142,'[{0,32080642,1}]'),(201,260,143,'[{0,32080642,1}]'),(201,260,144,'[{0,32080642,1}]'),(201,260,145,'[{0,32080642,1}]'),(201,260,146,'[{0,32080642,1}]'),(201,260,147,'[{0,32080642,1}]'),(201,260,148,'[{0,32080642,1}]'),(201,260,149,'[{0,32080642,1}]'),(201,260,150,'[{0,32080642,1}]'),(201,260,151,'[{0,32080642,1}]'),(201,260,152,'[{0,32080642,1}]'),(201,260,153,'[{0,32080642,1}]'),(201,260,154,'[{0,32080642,1}]'),(201,260,155,'[{0,32080642,1}]'),(201,260,156,'[{0,32080642,1}]'),(201,260,157,'[{0,32080642,1}]'),(201,260,158,'[{0,32080642,1}]'),(201,260,159,'[{0,32080642,1}]'),(201,260,160,'[{0,32080642,1}]'),(201,260,161,'[{0,32080642,1}]'),(201,260,162,'[{0,32080642,1}]'),(201,260,163,'[{0,32080642,1}]'),(201,260,164,'[{0,32080642,1}]'),(201,260,165,'[{0,32080642,1}]'),(201,260,166,'[{0,32080642,1}]'),(201,260,167,'[{0,32080642,1}]'),(201,260,168,'[{0,32080642,1}]'),(201,260,169,'[{0,32080642,1}]'),(201,260,170,'[{0,32080642,1}]'),(201,260,171,'[{0,32080642,1}]'),(201,260,172,'[{0,32080642,1}]'),(201,260,173,'[{0,32080642,1}]'),(201,260,174,'[{0,32080642,1}]'),(201,260,175,'[{0,32080642,1}]'),(201,260,176,'[{0,32080642,1}]'),(201,260,177,'[{0,32080642,1}]'),(201,260,178,'[{0,32080642,1}]'),(201,260,179,'[{0,32080642,1}]'),(201,260,180,'[{0,32080642,1}]'),(201,260,181,'[{0,32080642,1}]'),(201,260,182,'[{0,32080642,1}]'),(201,260,183,'[{0,32080642,1}]'),(201,260,184,'[{0,32080642,1}]'),(201,260,185,'[{0,32080642,1}]'),(201,260,186,'[{0,32080642,1}]'),(201,260,187,'[{0,32080642,1}]'),(201,260,188,'[{0,32080642,1}]'),(201,260,189,'[{0,32080642,1}]'),(201,260,190,'[{0,32080642,1}]'),(201,260,191,'[{0,32080642,1}]'),(201,260,192,'[{0,32080642,1}]'),(201,260,193,'[{0,32080642,1}]'),(201,260,194,'[{0,32080642,1}]'),(201,260,195,'[{0,32080642,1}]'),(201,260,196,'[{0,32080642,1}]'),(201,260,197,'[{0,32080642,1}]'),(201,260,198,'[{0,32080642,1}]'),(201,260,199,'[{0,32080642,1}]'),(201,260,200,'[{0,32080642,1}]'),(201,260,201,'[{0,32080642,1}]'),(201,260,202,'[{0,32080642,1}]'),(201,260,203,'[{0,32080642,1}]'),(201,260,204,'[{0,32080642,1}]'),(201,260,205,'[{0,32080642,1}]'),(201,260,206,'[{0,32080642,1}]'),(201,260,207,'[{0,32080642,1}]'),(201,260,208,'[{0,32080642,1}]'),(201,260,209,'[{0,32080642,1}]'),(201,260,210,'[{0,32080642,1}]'),(201,260,211,'[{0,32080642,1}]'),(201,260,212,'[{0,32080642,1}]'),(201,260,213,'[{0,32080642,1}]'),(201,260,214,'[{0,32080642,1}]'),(201,260,215,'[{0,32080642,1}]'),(201,260,216,'[{0,32080642,1}]'),(201,260,217,'[{0,32080642,1}]'),(201,260,218,'[{0,32080642,1}]'),(261,320,1,'[{0,32080742,1}]'),(261,320,2,'[{0,32080742,1}]'),(261,320,3,'[{0,32080742,1}]'),(261,320,4,'[{0,32080742,1}]'),(261,320,5,'[{0,32080742,1}]'),(261,320,6,'[{0,32080742,1}]'),(261,320,7,'[{0,32080742,1}]'),(261,320,8,'[{0,32080742,1}]'),(261,320,9,'[{0,32080742,1}]'),(261,320,10,'[{0,32080742,1}]'),(261,320,11,'[{0,32080742,1}]'),(261,320,12,'[{0,32080742,1}]'),(261,320,13,'[{0,32080742,1}]'),(261,320,14,'[{0,32080742,1}]'),(261,320,15,'[{0,32080742,1}]'),(261,320,16,'[{0,32080742,1}]'),(261,320,17,'[{0,32080742,1}]'),(261,320,18,'[{0,32080742,1}]'),(261,320,19,'[{0,32080742,1}]'),(261,320,20,'[{0,32080742,1}]'),(261,320,21,'[{0,32080742,1}]'),(261,320,22,'[{0,32080742,1}]'),(261,320,23,'[{0,32080742,1}]'),(261,320,24,'[{0,32080742,1}]'),(261,320,25,'[{0,32080742,1}]'),(261,320,26,'[{0,32080742,1}]'),(261,320,27,'[{0,32080742,1}]'),(261,320,28,'[{0,32080742,1}]'),(261,320,29,'[{0,32080742,1}]'),(261,320,30,'[{0,32080742,1}]'),(261,320,31,'[{0,32080742,1}]'),(261,320,32,'[{0,32080742,1}]'),(261,320,33,'[{0,32080742,1}]'),(261,320,34,'[{0,32080742,1}]'),(261,320,35,'[{0,32080742,1}]'),(261,320,36,'[{0,32080742,1}]'),(261,320,37,'[{0,32080742,1}]'),(261,320,38,'[{0,32080742,1}]'),(261,320,39,'[{0,32080742,1}]'),(261,320,40,'[{0,32080742,1}]'),(261,320,41,'[{0,32080742,1}]'),(261,320,42,'[{0,32080742,1}]'),(261,320,43,'[{0,32080742,1}]'),(261,320,44,'[{0,32080742,1}]'),(261,320,45,'[{0,32080742,1}]'),(261,320,46,'[{0,32080742,1}]'),(261,320,47,'[{0,32080742,1}]'),(261,320,48,'[{0,32080742,1}]'),(261,320,49,'[{0,32080742,1}]'),(261,320,50,'[{0,32080742,1}]'),(261,320,51,'[{0,32080742,1}]'),(261,320,52,'[{0,32080742,1}]'),(261,320,53,'[{0,32080742,1}]'),(261,320,54,'[{0,32080742,1}]'),(261,320,55,'[{0,32080742,1}]'),(261,320,56,'[{0,32080742,1}]'),(261,320,57,'[{0,32080742,1}]'),(261,320,58,'[{0,32080742,1}]'),(261,320,59,'[{0,32080742,1}]'),(261,320,60,'[{0,32080742,1}]'),(261,320,61,'[{0,32080742,1}]'),(261,320,62,'[{0,32080742,1}]'),(261,320,63,'[{0,32080742,1}]'),(261,320,64,'[{0,32080742,1}]'),(261,320,65,'[{0,32080742,1}]'),(261,320,66,'[{0,32080742,1}]'),(261,320,67,'[{0,32080742,1}]'),(261,320,68,'[{0,32080742,1}]'),(261,320,69,'[{0,32080742,1}]'),(261,320,70,'[{0,32080742,1}]'),(261,320,71,'[{0,32080742,1}]'),(261,320,72,'[{0,32080742,1}]'),(261,320,73,'[{0,32080742,1}]'),(261,320,74,'[{0,32080742,1}]'),(261,320,75,'[{0,32080742,1}]'),(261,320,76,'[{0,32080742,1}]'),(261,320,77,'[{0,32080742,1}]'),(261,320,78,'[{0,32080742,1}]'),(261,320,79,'[{0,32080742,1}]'),(261,320,80,'[{0,32080742,1}]'),(261,320,81,'[{0,32080742,1}]'),(261,320,82,'[{0,32080742,1}]'),(261,320,83,'[{0,32080742,1}]'),(261,320,84,'[{0,32080742,1}]'),(261,320,85,'[{0,32080742,1}]'),(261,320,86,'[{0,32080742,1}]'),(261,320,87,'[{0,32080742,1}]'),(261,320,88,'[{0,32080742,1}]'),(261,320,89,'[{0,32080742,1}]'),(261,320,90,'[{0,32080742,1}]'),(261,320,91,'[{0,32080742,1}]'),(261,320,92,'[{0,32080742,1}]'),(261,320,93,'[{0,32080742,1}]'),(261,320,94,'[{0,32080742,1}]'),(261,320,95,'[{0,32080742,1}]'),(261,320,96,'[{0,32080742,1}]'),(261,320,97,'[{0,32080742,1}]'),(261,320,98,'[{0,32080742,1}]'),(261,320,99,'[{0,32080742,1}]'),(261,320,100,'[{0,32080742,1}]'),(261,320,101,'[{0,32080742,1}]'),(261,320,102,'[{0,32080742,1}]'),(261,320,103,'[{0,32080742,1}]'),(261,320,104,'[{0,32080742,1}]'),(261,320,105,'[{0,32080742,1}]'),(261,320,106,'[{0,32080742,1}]'),(261,320,107,'[{0,32080742,1}]'),(261,320,108,'[{0,32080742,1}]'),(261,320,109,'[{0,32080742,1}]'),(261,320,110,'[{0,32080742,1}]'),(261,320,111,'[{0,32080742,1}]'),(261,320,112,'[{0,32080742,1}]'),(261,320,113,'[{0,32080742,1}]'),(261,320,114,'[{0,32080742,1}]'),(261,320,115,'[{0,32080742,1}]'),(261,320,116,'[{0,32080742,1}]'),(261,320,117,'[{0,32080742,1}]'),(261,320,118,'[{0,32080742,1}]'),(261,320,119,'[{0,32080742,1}]'),(261,320,120,'[{0,32080742,1}]'),(261,320,121,'[{0,32080742,1}]'),(261,320,122,'[{0,32080742,1}]'),(261,320,123,'[{0,32080742,1}]'),(261,320,124,'[{0,32080742,1}]'),(261,320,125,'[{0,32080742,1}]'),(261,320,126,'[{0,32080742,1}]'),(261,320,127,'[{0,32080742,1}]'),(261,320,128,'[{0,32080742,1}]'),(261,320,129,'[{0,32080742,1}]'),(261,320,130,'[{0,32080742,1}]'),(261,320,131,'[{0,32080742,1}]'),(261,320,132,'[{0,32080742,1}]'),(261,320,133,'[{0,32080742,1}]'),(261,320,134,'[{0,32080742,1}]'),(261,320,135,'[{0,32080742,1}]'),(261,320,136,'[{0,32080742,1}]'),(261,320,137,'[{0,32080742,1}]'),(261,320,138,'[{0,32080742,1}]'),(261,320,139,'[{0,32080742,1}]'),(261,320,140,'[{0,32080742,1}]'),(261,320,141,'[{0,32080742,1}]'),(261,320,142,'[{0,32080742,1}]'),(261,320,143,'[{0,32080742,1}]'),(261,320,144,'[{0,32080742,1}]'),(261,320,145,'[{0,32080742,1}]'),(261,320,146,'[{0,32080742,1}]'),(261,320,147,'[{0,32080742,1}]'),(261,320,148,'[{0,32080742,1}]'),(261,320,149,'[{0,32080742,1}]'),(261,320,150,'[{0,32080742,1}]'),(261,320,151,'[{0,32080742,1}]'),(261,320,152,'[{0,32080742,1}]'),(261,320,153,'[{0,32080742,1}]'),(261,320,154,'[{0,32080742,1}]'),(261,320,155,'[{0,32080742,1}]'),(261,320,156,'[{0,32080742,1}]'),(261,320,157,'[{0,32080742,1}]'),(261,320,158,'[{0,32080742,1}]'),(261,320,159,'[{0,32080742,1}]'),(261,320,160,'[{0,32080742,1}]'),(261,320,161,'[{0,32080742,1}]'),(261,320,162,'[{0,32080742,1}]'),(261,320,163,'[{0,32080742,1}]'),(261,320,164,'[{0,32080742,1}]'),(261,320,165,'[{0,32080742,1}]'),(261,320,166,'[{0,32080742,1}]'),(261,320,167,'[{0,32080742,1}]'),(261,320,168,'[{0,32080742,1}]'),(261,320,169,'[{0,32080742,1}]'),(261,320,170,'[{0,32080742,1}]'),(261,320,171,'[{0,32080742,1}]'),(261,320,172,'[{0,32080742,1}]'),(261,320,173,'[{0,32080742,1}]'),(261,320,174,'[{0,32080742,1}]'),(261,320,175,'[{0,32080742,1}]'),(261,320,176,'[{0,32080742,1}]'),(261,320,177,'[{0,32080742,1}]'),(261,320,178,'[{0,32080742,1}]'),(261,320,179,'[{0,32080742,1}]'),(261,320,180,'[{0,32080742,1}]'),(261,320,181,'[{0,32080742,1}]'),(261,320,182,'[{0,32080742,1}]'),(261,320,183,'[{0,32080742,1}]'),(261,320,184,'[{0,32080742,1}]'),(261,320,185,'[{0,32080742,1}]'),(261,320,186,'[{0,32080742,1}]'),(261,320,187,'[{0,32080742,1}]'),(261,320,188,'[{0,32080742,1}]'),(261,320,189,'[{0,32080742,1}]'),(261,320,190,'[{0,32080742,1}]'),(261,320,191,'[{0,32080742,1}]'),(261,320,192,'[{0,32080742,1}]'),(261,320,193,'[{0,32080742,1}]'),(261,320,194,'[{0,32080742,1}]'),(261,320,195,'[{0,32080742,1}]'),(261,320,196,'[{0,32080742,1}]'),(261,320,197,'[{0,32080742,1}]'),(261,320,198,'[{0,32080742,1}]'),(261,320,199,'[{0,32080742,1}]'),(261,320,200,'[{0,32080742,1}]'),(261,320,201,'[{0,32080742,1}]'),(261,320,202,'[{0,32080742,1}]'),(261,320,203,'[{0,32080742,1}]'),(261,320,204,'[{0,32080742,1}]'),(261,320,205,'[{0,32080742,1}]'),(261,320,206,'[{0,32080742,1}]'),(261,320,207,'[{0,32080742,1}]'),(261,320,208,'[{0,32080742,1}]'),(261,320,209,'[{0,32080742,1}]'),(261,320,210,'[{0,32080742,1}]'),(261,320,211,'[{0,32080742,1}]'),(261,320,212,'[{0,32080742,1}]'),(261,320,213,'[{0,32080742,1}]'),(261,320,214,'[{0,32080742,1}]'),(261,320,215,'[{0,32080742,1}]'),(261,320,216,'[{0,32080742,1}]'),(261,320,217,'[{0,32080742,1}]'),(261,320,218,'[{0,32080742,1}]'),(321,350,1,'[{0,32080842,1}]'),(321,350,2,'[{0,32080842,1}]'),(321,350,3,'[{0,32080842,1}]'),(321,350,4,'[{0,32080842,1}]'),(321,350,5,'[{0,32080842,1}]'),(321,350,6,'[{0,32080842,1}]'),(321,350,7,'[{0,32080842,1}]'),(321,350,8,'[{0,32080842,1}]'),(321,350,9,'[{0,32080842,1}]'),(321,350,10,'[{0,32080842,1}]'),(321,350,11,'[{0,32080842,1}]'),(321,350,12,'[{0,32080842,1}]'),(321,350,13,'[{0,32080842,1}]'),(321,350,14,'[{0,32080842,1}]'),(321,350,15,'[{0,32080842,1}]'),(321,350,16,'[{0,32080842,1}]'),(321,350,17,'[{0,32080842,1}]'),(321,350,18,'[{0,32080842,1}]'),(321,350,19,'[{0,32080842,1}]'),(321,350,20,'[{0,32080842,1}]'),(321,350,21,'[{0,32080842,1}]'),(321,350,22,'[{0,32080842,1}]'),(321,350,23,'[{0,32080842,1}]'),(321,350,24,'[{0,32080842,1}]'),(321,350,25,'[{0,32080842,1}]'),(321,350,26,'[{0,32080842,1}]'),(321,350,27,'[{0,32080842,1}]'),(321,350,28,'[{0,32080842,1}]'),(321,350,29,'[{0,32080842,1}]'),(321,350,30,'[{0,32080842,1}]'),(321,350,31,'[{0,32080842,1}]'),(321,350,32,'[{0,32080842,1}]'),(321,350,33,'[{0,32080842,1}]'),(321,350,34,'[{0,32080842,1}]'),(321,350,35,'[{0,32080842,1}]'),(321,350,36,'[{0,32080842,1}]'),(321,350,37,'[{0,32080842,1}]'),(321,350,38,'[{0,32080842,1}]'),(321,350,39,'[{0,32080842,1}]'),(321,350,40,'[{0,32080842,1}]'),(321,350,41,'[{0,32080842,1}]'),(321,350,42,'[{0,32080842,1}]'),(321,350,43,'[{0,32080842,1}]'),(321,350,44,'[{0,32080842,1}]'),(321,350,45,'[{0,32080842,1}]'),(321,350,46,'[{0,32080842,1}]'),(321,350,47,'[{0,32080842,1}]'),(321,350,48,'[{0,32080842,1}]'),(321,350,49,'[{0,32080842,1}]'),(321,350,50,'[{0,32080842,1}]'),(321,350,51,'[{0,32080842,1}]'),(321,350,52,'[{0,32080842,1}]'),(321,350,53,'[{0,32080842,1}]'),(321,350,54,'[{0,32080842,1}]'),(321,350,55,'[{0,32080842,1}]'),(321,350,56,'[{0,32080842,1}]'),(321,350,57,'[{0,32080842,1}]'),(321,350,58,'[{0,32080842,1}]'),(321,350,59,'[{0,32080842,1}]'),(321,350,60,'[{0,32080842,1}]'),(321,350,61,'[{0,32080842,1}]'),(321,350,62,'[{0,32080842,1}]'),(321,350,63,'[{0,32080842,1}]'),(321,350,64,'[{0,32080842,1}]'),(321,350,65,'[{0,32080842,1}]'),(321,350,66,'[{0,32080842,1}]'),(321,350,67,'[{0,32080842,1}]'),(321,350,68,'[{0,32080842,1}]'),(321,350,69,'[{0,32080842,1}]'),(321,350,70,'[{0,32080842,1}]'),(321,350,71,'[{0,32080842,1}]'),(321,350,72,'[{0,32080842,1}]'),(321,350,73,'[{0,32080842,1}]'),(321,350,74,'[{0,32080842,1}]'),(321,350,75,'[{0,32080842,1}]'),(321,350,76,'[{0,32080842,1}]'),(321,350,77,'[{0,32080842,1}]'),(321,350,78,'[{0,32080842,1}]'),(321,350,79,'[{0,32080842,1}]'),(321,350,80,'[{0,32080842,1}]'),(321,350,81,'[{0,32080842,1}]'),(321,350,82,'[{0,32080842,1}]'),(321,350,83,'[{0,32080842,1}]'),(321,350,84,'[{0,32080842,1}]'),(321,350,85,'[{0,32080842,1}]'),(321,350,86,'[{0,32080842,1}]'),(321,350,87,'[{0,32080842,1}]'),(321,350,88,'[{0,32080842,1}]'),(321,350,89,'[{0,32080842,1}]'),(321,350,90,'[{0,32080842,1}]'),(321,350,91,'[{0,32080842,1}]'),(321,350,92,'[{0,32080842,1}]'),(321,350,93,'[{0,32080842,1}]'),(321,350,94,'[{0,32080842,1}]'),(321,350,95,'[{0,32080842,1}]'),(321,350,96,'[{0,32080842,1}]'),(321,350,97,'[{0,32080842,1}]'),(321,350,98,'[{0,32080842,1}]'),(321,350,99,'[{0,32080842,1}]'),(321,350,100,'[{0,32080842,1}]'),(321,350,101,'[{0,32080842,1}]'),(321,350,102,'[{0,32080842,1}]'),(321,350,103,'[{0,32080842,1}]'),(321,350,104,'[{0,32080842,1}]'),(321,350,105,'[{0,32080842,1}]'),(321,350,106,'[{0,32080842,1}]'),(321,350,107,'[{0,32080842,1}]'),(321,350,108,'[{0,32080842,1}]'),(321,350,109,'[{0,32080842,1}]'),(321,350,110,'[{0,32080842,1}]'),(321,350,111,'[{0,32080842,1}]'),(321,350,112,'[{0,32080842,1}]'),(321,350,113,'[{0,32080842,1}]'),(321,350,114,'[{0,32080842,1}]'),(321,350,115,'[{0,32080842,1}]'),(321,350,116,'[{0,32080842,1}]'),(321,350,117,'[{0,32080842,1}]'),(321,350,118,'[{0,32080842,1}]'),(321,350,119,'[{0,32080842,1}]'),(321,350,120,'[{0,32080842,1}]'),(321,350,121,'[{0,32080842,1}]'),(321,350,122,'[{0,32080842,1}]'),(321,350,123,'[{0,32080842,1}]'),(321,350,124,'[{0,32080842,1}]'),(321,350,125,'[{0,32080842,1}]'),(321,350,126,'[{0,32080842,1}]'),(321,350,127,'[{0,32080842,1}]'),(321,350,128,'[{0,32080842,1}]'),(321,350,129,'[{0,32080842,1}]'),(321,350,130,'[{0,32080842,1}]'),(321,350,131,'[{0,32080842,1}]'),(321,350,132,'[{0,32080842,1}]'),(321,350,133,'[{0,32080842,1}]'),(321,350,134,'[{0,32080842,1}]'),(321,350,135,'[{0,32080842,1}]'),(321,350,136,'[{0,32080842,1}]'),(321,350,137,'[{0,32080842,1}]'),(321,350,138,'[{0,32080842,1}]'),(321,350,139,'[{0,32080842,1}]'),(321,350,140,'[{0,32080842,1}]'),(321,350,141,'[{0,32080842,1}]'),(321,350,142,'[{0,32080842,1}]'),(321,350,143,'[{0,32080842,1}]'),(321,350,144,'[{0,32080842,1}]'),(321,350,145,'[{0,32080842,1}]'),(321,350,146,'[{0,32080842,1}]'),(321,350,147,'[{0,32080842,1}]'),(321,350,148,'[{0,32080842,1}]'),(321,350,149,'[{0,32080842,1}]'),(321,350,150,'[{0,32080842,1}]'),(321,350,151,'[{0,32080842,1}]'),(321,350,152,'[{0,32080842,1}]'),(321,350,153,'[{0,32080842,1}]'),(321,350,154,'[{0,32080842,1}]'),(321,350,155,'[{0,32080842,1}]'),(321,350,156,'[{0,32080842,1}]'),(321,350,157,'[{0,32080842,1}]'),(321,350,158,'[{0,32080842,1}]'),(321,350,159,'[{0,32080842,1}]'),(321,350,160,'[{0,32080842,1}]'),(321,350,161,'[{0,32080842,1}]'),(321,350,162,'[{0,32080842,1}]'),(321,350,163,'[{0,32080842,1}]'),(321,350,164,'[{0,32080842,1}]'),(321,350,165,'[{0,32080842,1}]'),(321,350,166,'[{0,32080842,1}]'),(321,350,167,'[{0,32080842,1}]'),(321,350,168,'[{0,32080842,1}]'),(321,350,169,'[{0,32080842,1}]'),(321,350,170,'[{0,32080842,1}]'),(321,350,171,'[{0,32080842,1}]'),(321,350,172,'[{0,32080842,1}]'),(321,350,173,'[{0,32080842,1}]'),(321,350,174,'[{0,32080842,1}]'),(321,350,175,'[{0,32080842,1}]'),(321,350,176,'[{0,32080842,1}]'),(321,350,177,'[{0,32080842,1}]'),(321,350,178,'[{0,32080842,1}]'),(321,350,179,'[{0,32080842,1}]'),(321,350,180,'[{0,32080842,1}]'),(321,350,181,'[{0,32080842,1}]'),(321,350,182,'[{0,32080842,1}]'),(321,350,183,'[{0,32080842,1}]'),(321,350,184,'[{0,32080842,1}]'),(321,350,185,'[{0,32080842,1}]'),(321,350,186,'[{0,32080842,1}]'),(321,350,187,'[{0,32080842,1}]'),(321,350,188,'[{0,32080842,1}]'),(321,350,189,'[{0,32080842,1}]'),(321,350,190,'[{0,32080842,1}]'),(321,350,191,'[{0,32080842,1}]'),(321,350,192,'[{0,32080842,1}]'),(321,350,193,'[{0,32080842,1}]'),(321,350,194,'[{0,32080842,1}]'),(321,350,195,'[{0,32080842,1}]'),(321,350,196,'[{0,32080842,1}]'),(321,350,197,'[{0,32080842,1}]'),(321,350,198,'[{0,32080842,1}]'),(321,350,199,'[{0,32080842,1}]'),(321,350,200,'[{0,32080842,1}]'),(321,350,201,'[{0,32080842,1}]'),(321,350,202,'[{0,32080842,1}]'),(321,350,203,'[{0,32080842,1}]'),(321,350,204,'[{0,32080842,1}]'),(321,350,205,'[{0,32080842,1}]'),(321,350,206,'[{0,32080842,1}]'),(321,350,207,'[{0,32080842,1}]'),(321,350,208,'[{0,32080842,1}]'),(321,350,209,'[{0,32080842,1}]'),(321,350,210,'[{0,32080842,1}]'),(321,350,211,'[{0,32080842,1}]'),(321,350,212,'[{0,32080842,1}]'),(321,350,213,'[{0,32080842,1}]'),(321,350,214,'[{0,32080842,1}]'),(321,350,215,'[{0,32080842,1}]'),(321,350,216,'[{0,32080842,1}]'),(321,350,217,'[{0,32080842,1}]'),(321,350,218,'[{0,32080842,1}]'),(351,370,1,'[{0,32080842,1}]'),(351,370,2,'[{0,32080842,1}]'),(351,370,3,'[{0,32080842,1}]'),(351,370,4,'[{0,32080842,1}]'),(351,370,5,'[{0,32080842,1}]'),(351,370,6,'[{0,32080842,1}]'),(351,370,7,'[{0,32080842,1}]'),(351,370,8,'[{0,32080842,1}]'),(351,370,9,'[{0,32080842,1}]'),(351,370,10,'[{0,32080842,1}]'),(351,370,11,'[{0,32080842,1}]'),(351,370,12,'[{0,32080842,1}]'),(351,370,13,'[{0,32080842,1}]'),(351,370,14,'[{0,32080842,1}]'),(351,370,15,'[{0,32080842,1}]'),(351,370,16,'[{0,32080842,1}]'),(351,370,17,'[{0,32080842,1}]'),(351,370,18,'[{0,32080842,1}]'),(351,370,19,'[{0,32080842,1}]'),(351,370,20,'[{0,32080842,1}]'),(351,370,21,'[{0,32080842,1}]'),(351,370,22,'[{0,32080842,1}]'),(351,370,23,'[{0,32080842,1}]'),(351,370,24,'[{0,32080842,1}]'),(351,370,25,'[{0,32080842,1}]'),(351,370,26,'[{0,32080842,1}]'),(351,370,27,'[{0,32080842,1}]'),(351,370,28,'[{0,32080842,1}]'),(351,370,29,'[{0,32080842,1}]'),(351,370,30,'[{0,32080842,1}]'),(351,370,31,'[{0,32080842,1}]'),(351,370,32,'[{0,32080842,1}]'),(351,370,33,'[{0,32080842,1}]'),(351,370,34,'[{0,32080842,1}]'),(351,370,35,'[{0,32080842,1}]'),(351,370,36,'[{0,32080842,1}]'),(351,370,37,'[{0,32080842,1}]'),(351,370,38,'[{0,32080842,1}]'),(351,370,39,'[{0,32080842,1}]'),(351,370,40,'[{0,32080842,1}]'),(351,370,41,'[{0,32080842,1}]'),(351,370,42,'[{0,32080842,1}]'),(351,370,43,'[{0,32080842,1}]'),(351,370,44,'[{0,32080842,1}]'),(351,370,45,'[{0,32080842,1}]'),(351,370,46,'[{0,32080842,1}]'),(351,370,47,'[{0,32080842,1}]'),(351,370,48,'[{0,32080842,1}]'),(351,370,49,'[{0,32080842,1}]'),(351,370,50,'[{0,32080842,1}]'),(351,370,51,'[{0,32080842,1}]'),(351,370,52,'[{0,32080842,1}]'),(351,370,53,'[{0,32080842,1}]'),(351,370,54,'[{0,32080842,1}]'),(351,370,55,'[{0,32080842,1}]'),(351,370,56,'[{0,32080842,1}]'),(351,370,57,'[{0,32080842,1}]'),(351,370,58,'[{0,32080842,1}]'),(351,370,59,'[{0,32080842,1}]'),(351,370,60,'[{0,32080842,1}]'),(351,370,61,'[{0,32080842,1}]'),(351,370,62,'[{0,32080842,1}]'),(351,370,63,'[{0,32080842,1}]'),(351,370,64,'[{0,32080842,1}]'),(351,370,65,'[{0,32080842,1}]'),(351,370,66,'[{0,32080842,1}]'),(351,370,67,'[{0,32080842,1}]'),(351,370,68,'[{0,32080842,1}]'),(351,370,69,'[{0,32080842,1}]'),(351,370,70,'[{0,32080842,1}]'),(351,370,71,'[{0,32080842,1}]'),(351,370,72,'[{0,32080842,1}]'),(351,370,73,'[{0,32080842,1}]'),(351,370,74,'[{0,32080842,1}]'),(351,370,75,'[{0,32080842,1}]'),(351,370,76,'[{0,32080842,1}]'),(351,370,77,'[{0,32080842,1}]'),(351,370,78,'[{0,32080842,1}]'),(351,370,79,'[{0,32080842,1}]'),(351,370,80,'[{0,32080842,1}]'),(351,370,81,'[{0,32080842,1}]'),(351,370,82,'[{0,32080842,1}]'),(351,370,83,'[{0,32080842,1}]'),(351,370,84,'[{0,32080842,1}]'),(351,370,85,'[{0,32080842,1}]'),(351,370,86,'[{0,32080842,1}]'),(351,370,87,'[{0,32080842,1}]'),(351,370,88,'[{0,32080842,1}]'),(351,370,89,'[{0,32080842,1}]'),(351,370,90,'[{0,32080842,1}]'),(351,370,91,'[{0,32080842,1}]'),(351,370,92,'[{0,32080842,1}]'),(351,370,93,'[{0,32080842,1}]'),(351,370,94,'[{0,32080842,1}]'),(351,370,95,'[{0,32080842,1}]'),(351,370,96,'[{0,32080842,1}]'),(351,370,97,'[{0,32080842,1}]'),(351,370,98,'[{0,32080842,1}]'),(351,370,99,'[{0,32080842,1}]'),(351,370,100,'[{0,32080842,1}]'),(351,370,101,'[{0,32080842,1}]'),(351,370,102,'[{0,32080842,1}]'),(351,370,103,'[{0,32080842,1}]'),(351,370,104,'[{0,32080842,1}]'),(351,370,105,'[{0,32080842,1}]'),(351,370,106,'[{0,32080842,1}]'),(351,370,107,'[{0,32080842,1}]'),(351,370,108,'[{0,32080842,1}]'),(351,370,109,'[{0,32080842,1}]'),(351,370,110,'[{0,32080842,1}]'),(351,370,111,'[{0,32080842,1}]'),(351,370,112,'[{0,32080842,1}]'),(351,370,113,'[{0,32080842,1}]'),(351,370,114,'[{0,32080842,1}]'),(351,370,115,'[{0,32080842,1}]'),(351,370,116,'[{0,32080842,1}]'),(351,370,117,'[{0,32080842,1}]'),(351,370,118,'[{0,32080842,1}]'),(351,370,119,'[{0,32080842,1}]'),(351,370,120,'[{0,32080842,1}]'),(351,370,121,'[{0,32080842,1}]'),(351,370,122,'[{0,32080842,1}]'),(351,370,123,'[{0,32080842,1}]'),(351,370,124,'[{0,32080842,1}]'),(351,370,125,'[{0,32080842,1}]'),(351,370,126,'[{0,32080842,1}]'),(351,370,127,'[{0,32080842,1}]'),(351,370,128,'[{0,32080842,1}]'),(351,370,129,'[{0,32080842,1}]'),(351,370,130,'[{0,32080842,1}]'),(351,370,131,'[{0,32080842,1}]'),(351,370,132,'[{0,32080842,1}]'),(351,370,133,'[{0,32080842,1}]'),(351,370,134,'[{0,32080842,1}]'),(351,370,135,'[{0,32080842,1}]'),(351,370,136,'[{0,32080842,1}]'),(351,370,137,'[{0,32080842,1}]'),(351,370,138,'[{0,32080842,1}]'),(351,370,139,'[{0,32080842,1}]'),(351,370,140,'[{0,32080842,1}]'),(351,370,141,'[{0,32080842,1}]'),(351,370,142,'[{0,32080842,1}]'),(351,370,143,'[{0,32080842,1}]'),(351,370,144,'[{0,32080842,1}]'),(351,370,145,'[{0,32080842,1}]'),(351,370,146,'[{0,32080842,1}]'),(351,370,147,'[{0,32080842,1}]'),(351,370,148,'[{0,32080842,1}]'),(351,370,149,'[{0,32080842,1}]'),(351,370,150,'[{0,32080842,1}]'),(351,370,151,'[{0,32080842,1}]'),(351,370,152,'[{0,32080842,1}]'),(351,370,153,'[{0,32080842,1}]'),(351,370,154,'[{0,32080842,1}]'),(351,370,155,'[{0,32080842,1}]'),(351,370,156,'[{0,32080842,1}]'),(351,370,157,'[{0,32080842,1}]'),(351,370,158,'[{0,32080842,1}]'),(351,370,159,'[{0,32080842,1}]'),(351,370,160,'[{0,32080842,1}]'),(351,370,161,'[{0,32080842,1}]'),(351,370,162,'[{0,32080842,1}]'),(351,370,163,'[{0,32080842,1}]'),(351,370,164,'[{0,32080842,1}]'),(351,370,165,'[{0,32080842,1}]'),(351,370,166,'[{0,32080842,1}]'),(351,370,167,'[{0,32080842,1}]'),(351,370,168,'[{0,32080842,1}]'),(351,370,169,'[{0,32080842,1}]'),(351,370,170,'[{0,32080842,1}]'),(351,370,171,'[{0,32080842,1}]'),(351,370,172,'[{0,32080842,1}]'),(351,370,173,'[{0,32080842,1}]'),(351,370,174,'[{0,32080842,1}]'),(351,370,175,'[{0,32080842,1}]'),(351,370,176,'[{0,32080842,1}]'),(351,370,177,'[{0,32080842,1}]'),(351,370,178,'[{0,32080842,1}]'),(351,370,179,'[{0,32080842,1}]'),(351,370,180,'[{0,32080842,1}]'),(351,370,181,'[{0,32080842,1}]'),(351,370,182,'[{0,32080842,1}]'),(351,370,183,'[{0,32080842,1}]'),(351,370,184,'[{0,32080842,1}]'),(351,370,185,'[{0,32080842,1}]'),(351,370,186,'[{0,32080842,1}]'),(351,370,187,'[{0,32080842,1}]'),(351,370,188,'[{0,32080842,1}]'),(351,370,189,'[{0,32080842,1}]'),(351,370,190,'[{0,32080842,1}]'),(351,370,191,'[{0,32080842,1}]'),(351,370,192,'[{0,32080842,1}]'),(351,370,193,'[{0,32080842,1}]'),(351,370,194,'[{0,32080842,1}]'),(351,370,195,'[{0,32080842,1}]'),(351,370,196,'[{0,32080842,1}]'),(351,370,197,'[{0,32080842,1}]'),(351,370,198,'[{0,32080842,1}]'),(351,370,199,'[{0,32080842,1}]'),(351,370,200,'[{0,32080842,1}]'),(351,370,201,'[{0,32080842,1}]'),(351,370,202,'[{0,32080842,1}]'),(351,370,203,'[{0,32080842,1}]'),(351,370,204,'[{0,32080842,1}]'),(351,370,205,'[{0,32080842,1}]'),(351,370,206,'[{0,32080842,1}]'),(351,370,207,'[{0,32080842,1}]'),(351,370,208,'[{0,32080842,1}]'),(351,370,209,'[{0,32080842,1}]'),(351,370,210,'[{0,32080842,1}]'),(351,370,211,'[{0,32080842,1}]'),(351,370,212,'[{0,32080842,1}]'),(351,370,213,'[{0,32080842,1}]'),(351,370,214,'[{0,32080842,1}]'),(351,370,215,'[{0,32080842,1}]'),(351,370,216,'[{0,32080842,1}]'),(351,370,217,'[{0,32080842,1}]'),(351,370,218,'[{0,32080842,1}]'),(371,390,1,'[{0,32080942,1}]'),(371,390,2,'[{0,32080942,1},{0,34010001,1}]'),(371,390,3,'[{0,32080942,1}]'),(371,390,4,'[{0,32080942,1}]'),(371,390,5,'[{0,32080942,1},{0,34010001,1}]'),(371,390,6,'[{0,32080942,1}]'),(371,390,7,'[{0,32080942,1}]'),(371,390,8,'[{0,32080942,1},{0,34010001,1}]'),(371,390,9,'[{0,32080942,1}]'),(371,390,10,'[{0,32080942,1}]'),(371,390,11,'[{0,32080942,1},{0,34010001,1}]'),(371,390,12,'[{0,32080942,1}]'),(371,390,13,'[{0,32080942,1}]'),(371,390,14,'[{0,32080942,1},{0,34010001,1}]'),(371,390,15,'[{0,32080942,1}]'),(371,390,16,'[{0,32080942,1}]'),(371,390,17,'[{0,32080942,1},{0,34010001,1}]'),(371,390,18,'[{0,32080942,1}]'),(371,390,19,'[{0,32080942,1}]'),(371,390,20,'[{0,32080942,1},{0,34010001,1}]'),(371,390,21,'[{0,32080942,1}]'),(371,390,22,'[{0,32080942,1}]'),(371,390,23,'[{0,32080942,1},{0,34010001,1}]'),(371,390,24,'[{0,32080942,1}]'),(371,390,25,'[{0,32080942,1}]'),(371,390,26,'[{0,32080942,1},{0,34010001,1}]'),(371,390,27,'[{0,32080942,1}]'),(371,390,28,'[{0,32080942,1}]'),(371,390,29,'[{0,32080942,1},{0,34010001,1}]'),(371,390,30,'[{0,32080942,1}]'),(371,390,31,'[{0,32080942,1}]'),(371,390,32,'[{0,32080942,1},{0,34010001,1}]'),(371,390,33,'[{0,32080942,1}]'),(371,390,34,'[{0,32080942,1}]'),(371,390,35,'[{0,32080942,1},{0,34010001,1}]'),(371,390,36,'[{0,32080942,1}]'),(371,390,37,'[{0,32080942,1}]'),(371,390,38,'[{0,32080942,1},{0,34010001,1}]'),(371,390,39,'[{0,32080942,1}]'),(371,390,40,'[{0,32080942,1}]'),(371,390,41,'[{0,32080942,1}]'),(371,390,42,'[{0,32080942,1},{0,34010001,1}]'),(371,390,43,'[{0,32080942,1}]'),(371,390,44,'[{0,32080942,1}]'),(371,390,45,'[{0,32080942,1}]'),(371,390,46,'[{0,32080942,1},{0,34010001,1}]'),(371,390,47,'[{0,32080942,1}]'),(371,390,48,'[{0,32080942,1}]'),(371,390,49,'[{0,32080942,1}]'),(371,390,50,'[{0,32080942,1},{0,34010001,1}]'),(371,390,51,'[{0,32080942,1}]'),(371,390,52,'[{0,32080942,1}]'),(371,390,53,'[{0,32080942,1}]'),(371,390,54,'[{0,32080942,1},{0,34010001,1}]'),(371,390,55,'[{0,32080942,1}]'),(371,390,56,'[{0,32080942,1}]'),(371,390,57,'[{0,32080942,1}]'),(371,390,58,'[{0,32080942,1},{0,34010001,1}]'),(371,390,59,'[{0,32080942,1}]'),(371,390,60,'[{0,32080942,1}]'),(371,390,61,'[{0,32080942,1}]'),(371,390,62,'[{0,32080942,1},{0,34010001,1}]'),(371,390,63,'[{0,32080942,1}]'),(371,390,64,'[{0,32080942,1}]'),(371,390,65,'[{0,32080942,1}]'),(371,390,66,'[{0,32080942,1},{0,34010001,1}]'),(371,390,67,'[{0,32080942,1}]'),(371,390,68,'[{0,32080942,1}]'),(371,390,69,'[{0,32080942,1}]'),(371,390,70,'[{0,32080942,1},{0,34010001,1}]'),(371,390,71,'[{0,32080942,1}]'),(371,390,72,'[{0,32080942,1}]'),(371,390,73,'[{0,32080942,1}]'),(371,390,74,'[{0,32080942,1},{0,34010001,1}]'),(371,390,75,'[{0,32080942,1}]'),(371,390,76,'[{0,32080942,1}]'),(371,390,77,'[{0,32080942,1}]'),(371,390,78,'[{0,32080942,1},{0,34010001,1}]'),(371,390,79,'[{0,32080942,1}]'),(371,390,80,'[{0,32080942,1}]'),(371,390,81,'[{0,32080942,1}]'),(371,390,82,'[{0,32080942,1},{0,34010001,1}]'),(371,390,83,'[{0,32080942,1}]'),(371,390,84,'[{0,32080942,1}]'),(371,390,85,'[{0,32080942,1}]'),(371,390,86,'[{0,32080942,1},{0,34010001,1}]'),(371,390,87,'[{0,32080942,1}]'),(371,390,88,'[{0,32080942,1}]'),(371,390,89,'[{0,32080942,1}]'),(371,390,90,'[{0,32080942,1},{0,34010001,1}]'),(371,390,91,'[{0,32080942,1}]'),(371,390,92,'[{0,32080942,1}]'),(371,390,93,'[{0,32080942,1}]'),(371,390,94,'[{0,32080942,1},{0,34010001,1}]'),(371,390,95,'[{0,32080942,1}]'),(371,390,96,'[{0,32080942,1}]'),(371,390,97,'[{0,32080942,1}]'),(371,390,98,'[{0,32080942,1},{0,34010001,1}]'),(371,390,99,'[{0,32080942,1}]'),(371,390,100,'[{0,32080942,1}]'),(371,390,101,'[{0,32080942,1}]'),(371,390,102,'[{0,32080942,1},{0,34010001,1}]'),(371,390,103,'[{0,32080942,1}]'),(371,390,104,'[{0,32080942,1}]'),(371,390,105,'[{0,32080942,1}]'),(371,390,106,'[{0,32080942,1},{0,34010001,1}]'),(371,390,107,'[{0,32080942,1}]'),(371,390,108,'[{0,32080942,1}]'),(371,390,109,'[{0,32080942,1}]'),(371,390,110,'[{0,32080942,1},{0,34010001,1}]'),(371,390,111,'[{0,32080942,1}]'),(371,390,112,'[{0,32080942,1}]'),(371,390,113,'[{0,32080942,1}]'),(371,390,114,'[{0,32080942,1},{0,34010001,1}]'),(371,390,115,'[{0,32080942,1}]'),(371,390,116,'[{0,32080942,1}]'),(371,390,117,'[{0,32080942,1}]'),(371,390,118,'[{0,32080942,1},{0,34010001,1}]'),(371,390,119,'[{0,32080942,1}]'),(371,390,120,'[{0,32080942,1}]'),(371,390,121,'[{0,32080942,1}]'),(371,390,122,'[{0,32080942,1},{0,34010001,1}]'),(371,390,123,'[{0,32080942,1}]'),(371,390,124,'[{0,32080942,1}]'),(371,390,125,'[{0,32080942,1}]'),(371,390,126,'[{0,32080942,1},{0,34010001,1}]'),(371,390,127,'[{0,32080942,1}]'),(371,390,128,'[{0,32080942,1}]'),(371,390,129,'[{0,32080942,1}]'),(371,390,130,'[{0,32080942,1},{0,34010001,1}]'),(371,390,131,'[{0,32080942,1}]'),(371,390,132,'[{0,32080942,1}]'),(371,390,133,'[{0,32080942,1}]'),(371,390,134,'[{0,32080942,1},{0,34010001,1}]'),(371,390,135,'[{0,32080942,1}]'),(371,390,136,'[{0,32080942,1}]'),(371,390,137,'[{0,32080942,1}]'),(371,390,138,'[{0,32080942,1},{0,34010001,1}]'),(371,390,139,'[{0,32080942,1}]'),(371,390,140,'[{0,32080942,1}]'),(371,390,141,'[{0,32080942,1}]'),(371,390,142,'[{0,32080942,1},{0,34010001,1}]'),(371,390,143,'[{0,32080942,1}]'),(371,390,144,'[{0,32080942,1}]'),(371,390,145,'[{0,32080942,1}]'),(371,390,146,'[{0,32080942,1},{0,34010001,1}]'),(371,390,147,'[{0,32080942,1}]'),(371,390,148,'[{0,32080942,1}]'),(371,390,149,'[{0,32080942,1}]'),(371,390,150,'[{0,32080942,1},{0,34010001,1}]'),(371,390,151,'[{0,32080942,1}]'),(371,390,152,'[{0,32080942,1}]'),(371,390,153,'[{0,32080942,1}]'),(371,390,154,'[{0,32080942,1},{0,34010001,1}]'),(371,390,155,'[{0,32080942,1}]'),(371,390,156,'[{0,32080942,1}]'),(371,390,157,'[{0,32080942,1}]'),(371,390,158,'[{0,32080942,1},{0,34010001,1}]'),(371,390,159,'[{0,32080942,1}]'),(371,390,160,'[{0,32080942,1}]'),(371,390,161,'[{0,32080942,1}]'),(371,390,162,'[{0,32080942,1},{0,34010001,1}]'),(371,390,163,'[{0,32080942,1}]'),(371,390,164,'[{0,32080942,1}]'),(371,390,165,'[{0,32080942,1}]'),(371,390,166,'[{0,32080942,1},{0,34010001,1}]'),(371,390,167,'[{0,32080942,1}]'),(371,390,168,'[{0,32080942,1}]'),(371,390,169,'[{0,32080942,1}]'),(371,390,170,'[{0,32080942,1},{0,34010001,1}]'),(371,390,171,'[{0,32080942,1}]'),(371,390,172,'[{0,32080942,1}]'),(371,390,173,'[{0,32080942,1}]'),(371,390,174,'[{0,32080942,1},{0,34010001,1}]'),(371,390,175,'[{0,32080942,1}]'),(371,390,176,'[{0,32080942,1}]'),(371,390,177,'[{0,32080942,1}]'),(371,390,178,'[{0,32080942,1},{0,34010001,1}]'),(371,390,179,'[{0,32080942,1}]'),(371,390,180,'[{0,32080942,1}]'),(371,390,181,'[{0,32080942,1}]'),(371,390,182,'[{0,32080942,1},{0,34010001,1}]'),(371,390,183,'[{0,32080942,1}]'),(371,390,184,'[{0,32080942,1}]'),(371,390,185,'[{0,32080942,1}]'),(371,390,186,'[{0,32080942,1},{0,34010001,1}]'),(371,390,187,'[{0,32080942,1}]'),(371,390,188,'[{0,32080942,1}]'),(371,390,189,'[{0,32080942,1}]'),(371,390,190,'[{0,32080942,1},{0,34010001,1}]'),(371,390,191,'[{0,32080942,1}]'),(371,390,192,'[{0,32080942,1}]'),(371,390,193,'[{0,32080942,1}]'),(371,390,194,'[{0,32080942,1},{0,34010001,1}]'),(371,390,195,'[{0,32080942,1}]'),(371,390,196,'[{0,32080942,1}]'),(371,390,197,'[{0,32080942,1}]'),(371,390,198,'[{0,32080942,1},{0,34010001,1}]'),(371,390,199,'[{0,32080942,1}]'),(371,390,200,'[{0,32080942,1}]'),(371,390,201,'[{0,32080942,1}]'),(371,390,202,'[{0,32080942,1},{0,34010001,1}]'),(371,390,203,'[{0,32080942,1}]'),(371,390,204,'[{0,32080942,1}]'),(371,390,205,'[{0,32080942,1}]'),(371,390,206,'[{0,32080942,1},{0,34010001,1}]'),(371,390,207,'[{0,32080942,1}]'),(371,390,208,'[{0,32080942,1}]'),(371,390,209,'[{0,32080942,1}]'),(371,390,210,'[{0,32080942,1},{0,34010001,1}]'),(371,390,211,'[{0,32080942,1}]'),(371,390,212,'[{0,32080942,1}]'),(371,390,213,'[{0,32080942,1}]'),(371,390,214,'[{0,32080942,1},{0,34010001,1}]'),(371,390,215,'[{0,32080942,1}]'),(371,390,216,'[{0,32080942,1}]'),(371,390,217,'[{0,32080942,1}]'),(371,390,218,'[{0,32080942,1},{0,34010001,1}]'),(391,430,1,'[{0,32081042,1}]'),(391,430,2,'[{0,32081042,1},{0,34010001,1}]'),(391,430,3,'[{0,32081042,1}]'),(391,430,4,'[{0,32081042,1}]'),(391,430,5,'[{0,32081042,1},{0,34010001,1}]'),(391,430,6,'[{0,32081042,1}]'),(391,430,7,'[{0,32081042,1}]'),(391,430,8,'[{0,32081042,1},{0,34010001,1}]'),(391,430,9,'[{0,32081042,1}]'),(391,430,10,'[{0,32081042,1}]'),(391,430,11,'[{0,32081042,1},{0,34010001,1}]'),(391,430,12,'[{0,32081042,1}]'),(391,430,13,'[{0,32081042,1}]'),(391,430,14,'[{0,32081042,1},{0,34010001,1}]'),(391,430,15,'[{0,32081042,1}]'),(391,430,16,'[{0,32081042,1}]'),(391,430,17,'[{0,32081042,1},{0,34010001,1}]'),(391,430,18,'[{0,32081042,1}]'),(391,430,19,'[{0,32081042,1}]'),(391,430,20,'[{0,32081042,1},{0,34010001,1}]'),(391,430,21,'[{0,32081042,1}]'),(391,430,22,'[{0,32081042,1}]'),(391,430,23,'[{0,32081042,1},{0,34010001,1}]'),(391,430,24,'[{0,32081042,1}]'),(391,430,25,'[{0,32081042,1}]'),(391,430,26,'[{0,32081042,1},{0,34010001,1}]'),(391,430,27,'[{0,32081042,1}]'),(391,430,28,'[{0,32081042,1}]'),(391,430,29,'[{0,32081042,1},{0,34010001,1}]'),(391,430,30,'[{0,32081042,1}]'),(391,430,31,'[{0,32081042,1}]'),(391,430,32,'[{0,32081042,1},{0,34010001,1}]'),(391,430,33,'[{0,32081042,1}]'),(391,430,34,'[{0,32081042,1}]'),(391,430,35,'[{0,32081042,1},{0,34010001,1}]'),(391,430,36,'[{0,32081042,1}]'),(391,430,37,'[{0,32081042,1}]'),(391,430,38,'[{0,32081042,1},{0,34010001,1}]'),(391,430,39,'[{0,32081042,1}]'),(391,430,40,'[{0,32081042,1}]'),(391,430,41,'[{0,32081042,1}]'),(391,430,42,'[{0,32081042,1},{0,34010001,1}]'),(391,430,43,'[{0,32081042,1}]'),(391,430,44,'[{0,32081042,1}]'),(391,430,45,'[{0,32081042,1}]'),(391,430,46,'[{0,32081042,1},{0,34010001,1}]'),(391,430,47,'[{0,32081042,1}]'),(391,430,48,'[{0,32081042,1}]'),(391,430,49,'[{0,32081042,1}]'),(391,430,50,'[{0,32081042,1},{0,34010001,1}]'),(391,430,51,'[{0,32081042,1}]'),(391,430,52,'[{0,32081042,1}]'),(391,430,53,'[{0,32081042,1}]'),(391,430,54,'[{0,32081042,1},{0,34010001,1}]'),(391,430,55,'[{0,32081042,1}]'),(391,430,56,'[{0,32081042,1}]'),(391,430,57,'[{0,32081042,1}]'),(391,430,58,'[{0,32081042,1},{0,34010001,1}]'),(391,430,59,'[{0,32081042,1}]'),(391,430,60,'[{0,32081042,1}]'),(391,430,61,'[{0,32081042,1}]'),(391,430,62,'[{0,32081042,1},{0,34010001,1}]'),(391,430,63,'[{0,32081042,1}]'),(391,430,64,'[{0,32081042,1}]'),(391,430,65,'[{0,32081042,1}]'),(391,430,66,'[{0,32081042,1},{0,34010001,1}]'),(391,430,67,'[{0,32081042,1}]'),(391,430,68,'[{0,32081042,1}]'),(391,430,69,'[{0,32081042,1}]'),(391,430,70,'[{0,32081042,1},{0,34010001,1}]'),(391,430,71,'[{0,32081042,1}]'),(391,430,72,'[{0,32081042,1}]'),(391,430,73,'[{0,32081042,1}]'),(391,430,74,'[{0,32081042,1},{0,34010001,1}]'),(391,430,75,'[{0,32081042,1}]'),(391,430,76,'[{0,32081042,1}]'),(391,430,77,'[{0,32081042,1}]'),(391,430,78,'[{0,32081042,1},{0,34010001,1}]'),(391,430,79,'[{0,32081042,1}]'),(391,430,80,'[{0,32081042,1}]'),(391,430,81,'[{0,32081042,1}]'),(391,430,82,'[{0,32081042,1},{0,34010001,1}]'),(391,430,83,'[{0,32081042,1}]'),(391,430,84,'[{0,32081042,1}]'),(391,430,85,'[{0,32081042,1}]'),(391,430,86,'[{0,32081042,1},{0,34010001,1}]'),(391,430,87,'[{0,32081042,1}]'),(391,430,88,'[{0,32081042,1}]'),(391,430,89,'[{0,32081042,1}]'),(391,430,90,'[{0,32081042,1},{0,34010001,1}]'),(391,430,91,'[{0,32081042,1}]'),(391,430,92,'[{0,32081042,1}]'),(391,430,93,'[{0,32081042,1}]'),(391,430,94,'[{0,32081042,1},{0,34010001,1}]'),(391,430,95,'[{0,32081042,1}]'),(391,430,96,'[{0,32081042,1}]'),(391,430,97,'[{0,32081042,1}]'),(391,430,98,'[{0,32081042,1},{0,34010001,1}]'),(391,430,99,'[{0,32081042,1}]'),(391,430,100,'[{0,32081042,1}]'),(391,430,101,'[{0,32081042,1}]'),(391,430,102,'[{0,32081042,1},{0,34010001,1}]'),(391,430,103,'[{0,32081042,1}]'),(391,430,104,'[{0,32081042,1}]'),(391,430,105,'[{0,32081042,1}]'),(391,430,106,'[{0,32081042,1},{0,34010001,1}]'),(391,430,107,'[{0,32081042,1}]'),(391,430,108,'[{0,32081042,1}]'),(391,430,109,'[{0,32081042,1}]'),(391,430,110,'[{0,32081042,1},{0,34010001,1}]'),(391,430,111,'[{0,32081042,1}]'),(391,430,112,'[{0,32081042,1}]'),(391,430,113,'[{0,32081042,1}]'),(391,430,114,'[{0,32081042,1},{0,34010001,1}]'),(391,430,115,'[{0,32081042,1}]'),(391,430,116,'[{0,32081042,1}]'),(391,430,117,'[{0,32081042,1}]'),(391,430,118,'[{0,32081042,1},{0,34010001,1}]'),(391,430,119,'[{0,32081042,1}]'),(391,430,120,'[{0,32081042,1}]'),(391,430,121,'[{0,32081042,1}]'),(391,430,122,'[{0,32081042,1},{0,34010001,1}]'),(391,430,123,'[{0,32081042,1}]'),(391,430,124,'[{0,32081042,1}]'),(391,430,125,'[{0,32081042,1}]'),(391,430,126,'[{0,32081042,1},{0,34010001,1}]'),(391,430,127,'[{0,32081042,1}]'),(391,430,128,'[{0,32081042,1}]'),(391,430,129,'[{0,32081042,1}]'),(391,430,130,'[{0,32081042,1},{0,34010001,1}]'),(391,430,131,'[{0,32081042,1}]'),(391,430,132,'[{0,32081042,1}]'),(391,430,133,'[{0,32081042,1}]'),(391,430,134,'[{0,32081042,1},{0,34010001,1}]'),(391,430,135,'[{0,32081042,1}]'),(391,430,136,'[{0,32081042,1}]'),(391,430,137,'[{0,32081042,1}]'),(391,430,138,'[{0,32081042,1},{0,34010001,1}]'),(391,430,139,'[{0,32081042,1}]'),(391,430,140,'[{0,32081042,1}]'),(391,430,141,'[{0,32081042,1}]'),(391,430,142,'[{0,32081042,1},{0,34010001,1}]'),(391,430,143,'[{0,32081042,1}]'),(391,430,144,'[{0,32081042,1}]'),(391,430,145,'[{0,32081042,1}]'),(391,430,146,'[{0,32081042,1},{0,34010001,1}]'),(391,430,147,'[{0,32081042,1}]'),(391,430,148,'[{0,32081042,1}]'),(391,430,149,'[{0,32081042,1}]'),(391,430,150,'[{0,32081042,1},{0,34010001,1}]'),(391,430,151,'[{0,32081042,1}]'),(391,430,152,'[{0,32081042,1}]'),(391,430,153,'[{0,32081042,1}]'),(391,430,154,'[{0,32081042,1},{0,34010001,1}]'),(391,430,155,'[{0,32081042,1}]'),(391,430,156,'[{0,32081042,1}]'),(391,430,157,'[{0,32081042,1}]'),(391,430,158,'[{0,32081042,1},{0,34010001,1}]'),(391,430,159,'[{0,32081042,1}]'),(391,430,160,'[{0,32081042,1}]'),(391,430,161,'[{0,32081042,1}]'),(391,430,162,'[{0,32081042,1},{0,34010001,1}]'),(391,430,163,'[{0,32081042,1}]'),(391,430,164,'[{0,32081042,1}]'),(391,430,165,'[{0,32081042,1}]'),(391,430,166,'[{0,32081042,1},{0,34010001,1}]'),(391,430,167,'[{0,32081042,1}]'),(391,430,168,'[{0,32081042,1}]'),(391,430,169,'[{0,32081042,1}]'),(391,430,170,'[{0,32081042,1},{0,34010001,1}]'),(391,430,171,'[{0,32081042,1}]'),(391,430,172,'[{0,32081042,1}]'),(391,430,173,'[{0,32081042,1}]'),(391,430,174,'[{0,32081042,1},{0,34010001,1}]'),(391,430,175,'[{0,32081042,1}]'),(391,430,176,'[{0,32081042,1}]'),(391,430,177,'[{0,32081042,1}]'),(391,430,178,'[{0,32081042,1},{0,34010001,1}]'),(391,430,179,'[{0,32081042,1}]'),(391,430,180,'[{0,32081042,1}]'),(391,430,181,'[{0,32081042,1}]'),(391,430,182,'[{0,32081042,1},{0,34010001,1}]'),(391,430,183,'[{0,32081042,1}]'),(391,430,184,'[{0,32081042,1}]'),(391,430,185,'[{0,32081042,1}]'),(391,430,186,'[{0,32081042,1},{0,34010001,1}]'),(391,430,187,'[{0,32081042,1}]'),(391,430,188,'[{0,32081042,1}]'),(391,430,189,'[{0,32081042,1}]'),(391,430,190,'[{0,32081042,1},{0,34010001,1}]'),(391,430,191,'[{0,32081042,1}]'),(391,430,192,'[{0,32081042,1}]'),(391,430,193,'[{0,32081042,1}]'),(391,430,194,'[{0,32081042,1},{0,34010001,1}]'),(391,430,195,'[{0,32081042,1}]'),(391,430,196,'[{0,32081042,1}]'),(391,430,197,'[{0,32081042,1}]'),(391,430,198,'[{0,32081042,1},{0,34010001,1}]'),(391,430,199,'[{0,32081042,1}]'),(391,430,200,'[{0,32081042,1}]'),(391,430,201,'[{0,32081042,1}]'),(391,430,202,'[{0,32081042,1},{0,34010001,1}]'),(391,430,203,'[{0,32081042,1}]'),(391,430,204,'[{0,32081042,1}]'),(391,430,205,'[{0,32081042,1}]'),(391,430,206,'[{0,32081042,1},{0,34010001,1}]'),(391,430,207,'[{0,32081042,1}]'),(391,430,208,'[{0,32081042,1}]'),(391,430,209,'[{0,32081042,1}]'),(391,430,210,'[{0,32081042,1},{0,34010001,1}]'),(391,430,211,'[{0,32081042,1}]'),(391,430,212,'[{0,32081042,1}]'),(391,430,213,'[{0,32081042,1}]'),(391,430,214,'[{0,32081042,1},{0,34010001,1}]'),(391,430,215,'[{0,32081042,1}]'),(391,430,216,'[{0,32081042,1}]'),(391,430,217,'[{0,32081042,1}]'),(391,430,218,'[{0,32081042,1},{0,34010001,1}]'),(431,500,1,'[{0,32081142,1}]'),(431,500,2,'[{0,32081142,1},{0,34010001,1}]'),(431,500,3,'[{0,32081142,1}]'),(431,500,4,'[{0,32081142,1}]'),(431,500,5,'[{0,32081142,1},{0,34010001,1}]'),(431,500,6,'[{0,32081142,1}]'),(431,500,7,'[{0,32081142,1}]'),(431,500,8,'[{0,32081142,1},{0,34010001,1}]'),(431,500,9,'[{0,32081142,1}]'),(431,500,10,'[{0,32081142,1}]'),(431,500,11,'[{0,32081142,1},{0,34010001,1}]'),(431,500,12,'[{0,32081142,1}]'),(431,500,13,'[{0,32081142,1}]'),(431,500,14,'[{0,32081142,1},{0,34010001,1}]'),(431,500,15,'[{0,32081142,1}]'),(431,500,16,'[{0,32081142,1}]'),(431,500,17,'[{0,32081142,1},{0,34010001,1}]'),(431,500,18,'[{0,32081142,1}]'),(431,500,19,'[{0,32081142,1}]'),(431,500,20,'[{0,32081142,1},{0,34010001,1}]'),(431,500,21,'[{0,32081142,1}]'),(431,500,22,'[{0,32081142,1}]'),(431,500,23,'[{0,32081142,1},{0,34010001,1}]'),(431,500,24,'[{0,32081142,1}]'),(431,500,25,'[{0,32081142,1}]'),(431,500,26,'[{0,32081142,1},{0,34010001,1}]'),(431,500,27,'[{0,32081142,1}]'),(431,500,28,'[{0,32081142,1}]'),(431,500,29,'[{0,32081142,1},{0,34010001,1}]'),(431,500,30,'[{0,32081142,1}]'),(431,500,31,'[{0,32081142,1}]'),(431,500,32,'[{0,32081142,1},{0,34010001,1}]'),(431,500,33,'[{0,32081142,1}]'),(431,500,34,'[{0,32081142,1}]'),(431,500,35,'[{0,32081142,1},{0,34010001,1}]'),(431,500,36,'[{0,32081142,1}]'),(431,500,37,'[{0,32081142,1}]'),(431,500,38,'[{0,32081142,1},{0,34010001,1}]'),(431,500,39,'[{0,32081142,1}]'),(431,500,40,'[{0,32081142,1}]'),(431,500,41,'[{0,32081142,1}]'),(431,500,42,'[{0,32081142,1},{0,34010001,1}]'),(431,500,43,'[{0,32081142,1}]'),(431,500,44,'[{0,32081142,1}]'),(431,500,45,'[{0,32081142,1}]'),(431,500,46,'[{0,32081142,1},{0,34010001,1}]'),(431,500,47,'[{0,32081142,1}]'),(431,500,48,'[{0,32081142,1}]'),(431,500,49,'[{0,32081142,1}]'),(431,500,50,'[{0,32081142,1},{0,34010001,1}]'),(431,500,51,'[{0,32081142,1}]'),(431,500,52,'[{0,32081142,1}]'),(431,500,53,'[{0,32081142,1}]'),(431,500,54,'[{0,32081142,1},{0,34010001,1}]'),(431,500,55,'[{0,32081142,1}]'),(431,500,56,'[{0,32081142,1}]'),(431,500,57,'[{0,32081142,1}]'),(431,500,58,'[{0,32081142,1},{0,34010001,1}]'),(431,500,59,'[{0,32081142,1}]'),(431,500,60,'[{0,32081142,1}]'),(431,500,61,'[{0,32081142,1}]'),(431,500,62,'[{0,32081142,1},{0,34010001,1}]'),(431,500,63,'[{0,32081142,1}]'),(431,500,64,'[{0,32081142,1}]'),(431,500,65,'[{0,32081142,1}]'),(431,500,66,'[{0,32081142,1},{0,34010001,1}]'),(431,500,67,'[{0,32081142,1}]'),(431,500,68,'[{0,32081142,1}]'),(431,500,69,'[{0,32081142,1}]'),(431,500,70,'[{0,32081142,1},{0,34010001,1}]'),(431,500,71,'[{0,32081142,1}]'),(431,500,72,'[{0,32081142,1}]'),(431,500,73,'[{0,32081142,1}]'),(431,500,74,'[{0,32081142,1},{0,34010001,1}]'),(431,500,75,'[{0,32081142,1}]'),(431,500,76,'[{0,32081142,1}]'),(431,500,77,'[{0,32081142,1}]'),(431,500,78,'[{0,32081142,1},{0,34010001,1}]'),(431,500,79,'[{0,32081142,1}]'),(431,500,80,'[{0,32081142,1}]'),(431,500,81,'[{0,32081142,1}]'),(431,500,82,'[{0,32081142,1},{0,34010001,1}]'),(431,500,83,'[{0,32081142,1}]'),(431,500,84,'[{0,32081142,1}]'),(431,500,85,'[{0,32081142,1}]'),(431,500,86,'[{0,32081142,1},{0,34010001,1}]'),(431,500,87,'[{0,32081142,1}]'),(431,500,88,'[{0,32081142,1}]'),(431,500,89,'[{0,32081142,1}]'),(431,500,90,'[{0,32081142,1},{0,34010001,1}]'),(431,500,91,'[{0,32081142,1}]'),(431,500,92,'[{0,32081142,1}]'),(431,500,93,'[{0,32081142,1}]'),(431,500,94,'[{0,32081142,1},{0,34010001,1}]'),(431,500,95,'[{0,32081142,1}]'),(431,500,96,'[{0,32081142,1}]'),(431,500,97,'[{0,32081142,1}]'),(431,500,98,'[{0,32081142,1},{0,34010001,1}]'),(431,500,99,'[{0,32081142,1}]'),(431,500,100,'[{0,32081142,1}]'),(431,500,101,'[{0,32081142,1}]'),(431,500,102,'[{0,32081142,1},{0,34010001,1}]'),(431,500,103,'[{0,32081142,1}]'),(431,500,104,'[{0,32081142,1}]'),(431,500,105,'[{0,32081142,1}]'),(431,500,106,'[{0,32081142,1},{0,34010001,1}]'),(431,500,107,'[{0,32081142,1}]'),(431,500,108,'[{0,32081142,1}]'),(431,500,109,'[{0,32081142,1}]'),(431,500,110,'[{0,32081142,1},{0,34010001,1}]'),(431,500,111,'[{0,32081142,1}]'),(431,500,112,'[{0,32081142,1}]'),(431,500,113,'[{0,32081142,1}]'),(431,500,114,'[{0,32081142,1},{0,34010001,1}]'),(431,500,115,'[{0,32081142,1}]'),(431,500,116,'[{0,32081142,1}]'),(431,500,117,'[{0,32081142,1}]'),(431,500,118,'[{0,32081142,1},{0,34010001,1}]'),(431,500,119,'[{0,32081142,1}]'),(431,500,120,'[{0,32081142,1}]'),(431,500,121,'[{0,32081142,1}]'),(431,500,122,'[{0,32081142,1},{0,34010001,1}]'),(431,500,123,'[{0,32081142,1}]'),(431,500,124,'[{0,32081142,1}]'),(431,500,125,'[{0,32081142,1}]'),(431,500,126,'[{0,32081142,1},{0,34010001,1}]'),(431,500,127,'[{0,32081142,1}]'),(431,500,128,'[{0,32081142,1}]'),(431,500,129,'[{0,32081142,1}]'),(431,500,130,'[{0,32081142,1},{0,34010001,1}]'),(431,500,131,'[{0,32081142,1}]'),(431,500,132,'[{0,32081142,1}]'),(431,500,133,'[{0,32081142,1}]'),(431,500,134,'[{0,32081142,1},{0,34010001,1}]'),(431,500,135,'[{0,32081142,1}]'),(431,500,136,'[{0,32081142,1}]'),(431,500,137,'[{0,32081142,1}]'),(431,500,138,'[{0,32081142,1},{0,34010001,1}]'),(431,500,139,'[{0,32081142,1}]'),(431,500,140,'[{0,32081142,1}]'),(431,500,141,'[{0,32081142,1}]'),(431,500,142,'[{0,32081142,1},{0,34010001,1}]'),(431,500,143,'[{0,32081142,1}]'),(431,500,144,'[{0,32081142,1}]'),(431,500,145,'[{0,32081142,1}]'),(431,500,146,'[{0,32081142,1},{0,34010001,1}]'),(431,500,147,'[{0,32081142,1}]'),(431,500,148,'[{0,32081142,1}]'),(431,500,149,'[{0,32081142,1}]'),(431,500,150,'[{0,32081142,1},{0,34010001,1}]'),(431,500,151,'[{0,32081142,1}]'),(431,500,152,'[{0,32081142,1}]'),(431,500,153,'[{0,32081142,1}]'),(431,500,154,'[{0,32081142,1},{0,34010001,1}]'),(431,500,155,'[{0,32081142,1}]'),(431,500,156,'[{0,32081142,1}]'),(431,500,157,'[{0,32081142,1}]'),(431,500,158,'[{0,32081142,1},{0,34010001,1}]'),(431,500,159,'[{0,32081142,1}]'),(431,500,160,'[{0,32081142,1}]'),(431,500,161,'[{0,32081142,1}]'),(431,500,162,'[{0,32081142,1},{0,34010001,1}]'),(431,500,163,'[{0,32081142,1}]'),(431,500,164,'[{0,32081142,1}]'),(431,500,165,'[{0,32081142,1}]'),(431,500,166,'[{0,32081142,1},{0,34010001,1}]'),(431,500,167,'[{0,32081142,1}]'),(431,500,168,'[{0,32081142,1}]'),(431,500,169,'[{0,32081142,1}]'),(431,500,170,'[{0,32081142,1},{0,34010001,1}]'),(431,500,171,'[{0,32081142,1}]'),(431,500,172,'[{0,32081142,1}]'),(431,500,173,'[{0,32081142,1}]'),(431,500,174,'[{0,32081142,1},{0,34010001,1}]'),(431,500,175,'[{0,32081142,1}]'),(431,500,176,'[{0,32081142,1}]'),(431,500,177,'[{0,32081142,1}]'),(431,500,178,'[{0,32081142,1},{0,34010001,1}]'),(431,500,179,'[{0,32081142,1}]'),(431,500,180,'[{0,32081142,1}]'),(431,500,181,'[{0,32081142,1}]'),(431,500,182,'[{0,32081142,1},{0,34010001,1}]'),(431,500,183,'[{0,32081142,1}]'),(431,500,184,'[{0,32081142,1}]'),(431,500,185,'[{0,32081142,1}]'),(431,500,186,'[{0,32081142,1},{0,34010001,1}]'),(431,500,187,'[{0,32081142,1}]'),(431,500,188,'[{0,32081142,1}]'),(431,500,189,'[{0,32081142,1}]'),(431,500,190,'[{0,32081142,1},{0,34010001,1}]'),(431,500,191,'[{0,32081142,1}]'),(431,500,192,'[{0,32081142,1}]'),(431,500,193,'[{0,32081142,1}]'),(431,500,194,'[{0,32081142,1},{0,34010001,1}]'),(431,500,195,'[{0,32081142,1}]'),(431,500,196,'[{0,32081142,1}]'),(431,500,197,'[{0,32081142,1}]'),(431,500,198,'[{0,32081142,1},{0,34010001,1}]'),(431,500,199,'[{0,32081142,1}]'),(431,500,200,'[{0,32081142,1}]'),(431,500,201,'[{0,32081142,1}]'),(431,500,202,'[{0,32081142,1},{0,34010001,1}]'),(431,500,203,'[{0,32081142,1}]'),(431,500,204,'[{0,32081142,1}]'),(431,500,205,'[{0,32081142,1}]'),(431,500,206,'[{0,32081142,1},{0,34010001,1}]'),(431,500,207,'[{0,32081142,1}]'),(431,500,208,'[{0,32081142,1}]'),(431,500,209,'[{0,32081142,1}]'),(431,500,210,'[{0,32081142,1},{0,34010001,1}]'),(431,500,211,'[{0,32081142,1}]'),(431,500,212,'[{0,32081142,1}]'),(431,500,213,'[{0,32081142,1}]'),(431,500,214,'[{0,32081142,1},{0,34010001,1}]'),(431,500,215,'[{0,32081142,1}]'),(431,500,216,'[{0,32081142,1}]'),(431,500,217,'[{0,32081142,1}]'),(431,500,218,'[{0,32081142,1},{0,34010001,1}]'),(501,560,1,'[{0,32081242,1}]'),(501,560,2,'[{0,32081242,1},{0,34010001,1}]'),(501,560,3,'[{0,32081242,1}]'),(501,560,4,'[{0,32081242,1}]'),(501,560,5,'[{0,32081242,1},{0,34010001,1}]'),(501,560,6,'[{0,32081242,1}]'),(501,560,7,'[{0,32081242,1}]'),(501,560,8,'[{0,32081242,1},{0,34010001,1}]'),(501,560,9,'[{0,32081242,1}]'),(501,560,10,'[{0,32081242,1}]'),(501,560,11,'[{0,32081242,1},{0,34010001,1}]'),(501,560,12,'[{0,32081242,1}]'),(501,560,13,'[{0,32081242,1}]'),(501,560,14,'[{0,32081242,1},{0,34010001,1}]'),(501,560,15,'[{0,32081242,1}]'),(501,560,16,'[{0,32081242,1}]'),(501,560,17,'[{0,32081242,1},{0,34010001,1}]'),(501,560,18,'[{0,32081242,1}]'),(501,560,19,'[{0,32081242,1}]'),(501,560,20,'[{0,32081242,1},{0,34010001,1}]'),(501,560,21,'[{0,32081242,1}]'),(501,560,22,'[{0,32081242,1}]'),(501,560,23,'[{0,32081242,1},{0,34010001,1}]'),(501,560,24,'[{0,32081242,1}]'),(501,560,25,'[{0,32081242,1}]'),(501,560,26,'[{0,32081242,1},{0,34010001,1}]'),(501,560,27,'[{0,32081242,1}]'),(501,560,28,'[{0,32081242,1}]'),(501,560,29,'[{0,32081242,1},{0,34010001,1}]'),(501,560,30,'[{0,32081242,1}]'),(501,560,31,'[{0,32081242,1}]'),(501,560,32,'[{0,32081242,1},{0,34010001,1}]'),(501,560,33,'[{0,32081242,1}]'),(501,560,34,'[{0,32081242,1}]'),(501,560,35,'[{0,32081242,1},{0,34010001,1}]'),(501,560,36,'[{0,32081242,1}]'),(501,560,37,'[{0,32081242,1}]'),(501,560,38,'[{0,32081242,1},{0,34010001,1}]'),(501,560,39,'[{0,32081242,1}]'),(501,560,40,'[{0,32081242,1}]'),(501,560,41,'[{0,32081242,1}]'),(501,560,42,'[{0,32081242,1},{0,34010001,1}]'),(501,560,43,'[{0,32081242,1}]'),(501,560,44,'[{0,32081242,1}]'),(501,560,45,'[{0,32081242,1}]'),(501,560,46,'[{0,32081242,1},{0,34010001,1}]'),(501,560,47,'[{0,32081242,1}]'),(501,560,48,'[{0,32081242,1}]'),(501,560,49,'[{0,32081242,1}]'),(501,560,50,'[{0,32081242,1},{0,34010001,1}]'),(501,560,51,'[{0,32081242,1}]'),(501,560,52,'[{0,32081242,1}]'),(501,560,53,'[{0,32081242,1}]'),(501,560,54,'[{0,32081242,1},{0,34010001,1}]'),(501,560,55,'[{0,32081242,1}]'),(501,560,56,'[{0,32081242,1}]'),(501,560,57,'[{0,32081242,1}]'),(501,560,58,'[{0,32081242,1},{0,34010001,1}]'),(501,560,59,'[{0,32081242,1}]'),(501,560,60,'[{0,32081242,1}]'),(501,560,61,'[{0,32081242,1}]'),(501,560,62,'[{0,32081242,1},{0,34010001,1}]'),(501,560,63,'[{0,32081242,1}]'),(501,560,64,'[{0,32081242,1}]'),(501,560,65,'[{0,32081242,1}]'),(501,560,66,'[{0,32081242,1},{0,34010001,1}]'),(501,560,67,'[{0,32081242,1}]'),(501,560,68,'[{0,32081242,1}]'),(501,560,69,'[{0,32081242,1}]'),(501,560,70,'[{0,32081242,1},{0,34010001,1}]'),(501,560,71,'[{0,32081242,1}]'),(501,560,72,'[{0,32081242,1}]'),(501,560,73,'[{0,32081242,1}]'),(501,560,74,'[{0,32081242,1},{0,34010001,1}]'),(501,560,75,'[{0,32081242,1}]'),(501,560,76,'[{0,32081242,1}]'),(501,560,77,'[{0,32081242,1}]'),(501,560,78,'[{0,32081242,1},{0,34010001,1}]'),(501,560,79,'[{0,32081242,1}]'),(501,560,80,'[{0,32081242,1}]'),(501,560,81,'[{0,32081242,1}]'),(501,560,82,'[{0,32081242,1},{0,34010001,1}]'),(501,560,83,'[{0,32081242,1}]'),(501,560,84,'[{0,32081242,1}]'),(501,560,85,'[{0,32081242,1}]'),(501,560,86,'[{0,32081242,1},{0,34010001,1}]'),(501,560,87,'[{0,32081242,1}]'),(501,560,88,'[{0,32081242,1}]'),(501,560,89,'[{0,32081242,1}]'),(501,560,90,'[{0,32081242,1},{0,34010001,1}]'),(501,560,91,'[{0,32081242,1}]'),(501,560,92,'[{0,32081242,1}]'),(501,560,93,'[{0,32081242,1}]'),(501,560,94,'[{0,32081242,1},{0,34010001,1}]'),(501,560,95,'[{0,32081242,1}]'),(501,560,96,'[{0,32081242,1}]'),(501,560,97,'[{0,32081242,1}]'),(501,560,98,'[{0,32081242,1},{0,34010001,1}]'),(501,560,99,'[{0,32081242,1}]'),(501,560,100,'[{0,32081242,1}]'),(501,560,101,'[{0,32081242,1}]'),(501,560,102,'[{0,32081242,1},{0,34010001,1}]'),(501,560,103,'[{0,32081242,1}]'),(501,560,104,'[{0,32081242,1}]'),(501,560,105,'[{0,32081242,1}]'),(501,560,106,'[{0,32081242,1},{0,34010001,1}]'),(501,560,107,'[{0,32081242,1}]'),(501,560,108,'[{0,32081242,1}]'),(501,560,109,'[{0,32081242,1}]'),(501,560,110,'[{0,32081242,1},{0,34010001,1}]'),(501,560,111,'[{0,32081242,1}]'),(501,560,112,'[{0,32081242,1}]'),(501,560,113,'[{0,32081242,1}]'),(501,560,114,'[{0,32081242,1},{0,34010001,1}]'),(501,560,115,'[{0,32081242,1}]'),(501,560,116,'[{0,32081242,1}]'),(501,560,117,'[{0,32081242,1}]'),(501,560,118,'[{0,32081242,1},{0,34010001,1}]'),(501,560,119,'[{0,32081242,1}]'),(501,560,120,'[{0,32081242,1}]'),(501,560,121,'[{0,32081242,1}]'),(501,560,122,'[{0,32081242,1},{0,34010001,1}]'),(501,560,123,'[{0,32081242,1}]'),(501,560,124,'[{0,32081242,1}]'),(501,560,125,'[{0,32081242,1}]'),(501,560,126,'[{0,32081242,1},{0,34010001,1}]'),(501,560,127,'[{0,32081242,1}]'),(501,560,128,'[{0,32081242,1}]'),(501,560,129,'[{0,32081242,1}]'),(501,560,130,'[{0,32081242,1},{0,34010001,1}]'),(501,560,131,'[{0,32081242,1}]'),(501,560,132,'[{0,32081242,1}]'),(501,560,133,'[{0,32081242,1}]'),(501,560,134,'[{0,32081242,1},{0,34010001,1}]'),(501,560,135,'[{0,32081242,1}]'),(501,560,136,'[{0,32081242,1}]'),(501,560,137,'[{0,32081242,1}]'),(501,560,138,'[{0,32081242,1},{0,34010001,1}]'),(501,560,139,'[{0,32081242,1}]'),(501,560,140,'[{0,32081242,1}]'),(501,560,141,'[{0,32081242,1}]'),(501,560,142,'[{0,32081242,1},{0,34010001,1}]'),(501,560,143,'[{0,32081242,1}]'),(501,560,144,'[{0,32081242,1}]'),(501,560,145,'[{0,32081242,1}]'),(501,560,146,'[{0,32081242,1},{0,34010001,1}]'),(501,560,147,'[{0,32081242,1}]'),(501,560,148,'[{0,32081242,1}]'),(501,560,149,'[{0,32081242,1}]'),(501,560,150,'[{0,32081242,1},{0,34010001,1}]'),(501,560,151,'[{0,32081242,1}]'),(501,560,152,'[{0,32081242,1}]'),(501,560,153,'[{0,32081242,1}]'),(501,560,154,'[{0,32081242,1},{0,34010001,1}]'),(501,560,155,'[{0,32081242,1}]'),(501,560,156,'[{0,32081242,1}]'),(501,560,157,'[{0,32081242,1}]'),(501,560,158,'[{0,32081242,1},{0,34010001,1}]'),(501,560,159,'[{0,32081242,1}]'),(501,560,160,'[{0,32081242,1}]'),(501,560,161,'[{0,32081242,1}]'),(501,560,162,'[{0,32081242,1},{0,34010001,1}]'),(501,560,163,'[{0,32081242,1}]'),(501,560,164,'[{0,32081242,1}]'),(501,560,165,'[{0,32081242,1}]'),(501,560,166,'[{0,32081242,1},{0,34010001,1}]'),(501,560,167,'[{0,32081242,1}]'),(501,560,168,'[{0,32081242,1}]'),(501,560,169,'[{0,32081242,1}]'),(501,560,170,'[{0,32081242,1},{0,34010001,1}]'),(501,560,171,'[{0,32081242,1}]'),(501,560,172,'[{0,32081242,1}]'),(501,560,173,'[{0,32081242,1}]'),(501,560,174,'[{0,32081242,1},{0,34010001,1}]'),(501,560,175,'[{0,32081242,1}]'),(501,560,176,'[{0,32081242,1}]'),(501,560,177,'[{0,32081242,1}]'),(501,560,178,'[{0,32081242,1},{0,34010001,1}]'),(501,560,179,'[{0,32081242,1}]'),(501,560,180,'[{0,32081242,1}]'),(501,560,181,'[{0,32081242,1}]'),(501,560,182,'[{0,32081242,1},{0,34010001,1}]'),(501,560,183,'[{0,32081242,1}]'),(501,560,184,'[{0,32081242,1}]'),(501,560,185,'[{0,32081242,1}]'),(501,560,186,'[{0,32081242,1},{0,34010001,1}]'),(501,560,187,'[{0,32081242,1}]'),(501,560,188,'[{0,32081242,1}]'),(501,560,189,'[{0,32081242,1}]'),(501,560,190,'[{0,32081242,1},{0,34010001,1}]'),(501,560,191,'[{0,32081242,1}]'),(501,560,192,'[{0,32081242,1}]'),(501,560,193,'[{0,32081242,1}]'),(501,560,194,'[{0,32081242,1},{0,34010001,1}]'),(501,560,195,'[{0,32081242,1}]'),(501,560,196,'[{0,32081242,1}]'),(501,560,197,'[{0,32081242,1}]'),(501,560,198,'[{0,32081242,1},{0,34010001,1}]'),(501,560,199,'[{0,32081242,1}]'),(501,560,200,'[{0,32081242,1}]'),(501,560,201,'[{0,32081242,1}]'),(501,560,202,'[{0,32081242,1},{0,34010001,1}]'),(501,560,203,'[{0,32081242,1}]'),(501,560,204,'[{0,32081242,1}]'),(501,560,205,'[{0,32081242,1}]'),(501,560,206,'[{0,32081242,1},{0,34010001,1}]'),(501,560,207,'[{0,32081242,1}]'),(501,560,208,'[{0,32081242,1}]'),(501,560,209,'[{0,32081242,1}]'),(501,560,210,'[{0,32081242,1},{0,34010001,1}]'),(501,560,211,'[{0,32081242,1}]'),(501,560,212,'[{0,32081242,1}]'),(501,560,213,'[{0,32081242,1}]'),(501,560,214,'[{0,32081242,1},{0,34010001,1}]'),(501,560,215,'[{0,32081242,1}]'),(501,560,216,'[{0,32081242,1}]'),(501,560,217,'[{0,32081242,1}]'),(501,560,218,'[{0,32081242,1},{0,34010001,1}]'),(561,610,1,'[{0,32081342,1}]'),(561,610,2,'[{0,32081342,1},{0,34010001,1}]'),(561,610,3,'[{0,32081342,1}]'),(561,610,4,'[{0,32081342,1}]'),(561,610,5,'[{0,32081342,1},{0,34010001,1}]'),(561,610,6,'[{0,32081342,1}]'),(561,610,7,'[{0,32081342,1}]'),(561,610,8,'[{0,32081342,1},{0,34010001,1}]'),(561,610,9,'[{0,32081342,1}]'),(561,610,10,'[{0,32081342,1}]'),(561,610,11,'[{0,32081342,1},{0,34010001,1}]'),(561,610,12,'[{0,32081342,1}]'),(561,610,13,'[{0,32081342,1}]'),(561,610,14,'[{0,32081342,1},{0,34010001,1}]'),(561,610,15,'[{0,32081342,1}]'),(561,610,16,'[{0,32081342,1}]'),(561,610,17,'[{0,32081342,1},{0,34010001,1}]'),(561,610,18,'[{0,32081342,1}]'),(561,610,19,'[{0,32081342,1}]'),(561,610,20,'[{0,32081342,1},{0,34010001,1}]'),(561,610,21,'[{0,32081342,1}]'),(561,610,22,'[{0,32081342,1}]'),(561,610,23,'[{0,32081342,1},{0,34010001,1}]'),(561,610,24,'[{0,32081342,1}]'),(561,610,25,'[{0,32081342,1}]'),(561,610,26,'[{0,32081342,1},{0,34010001,1}]'),(561,610,27,'[{0,32081342,1}]'),(561,610,28,'[{0,32081342,1}]'),(561,610,29,'[{0,32081342,1},{0,34010001,1}]'),(561,610,30,'[{0,32081342,1}]'),(561,610,31,'[{0,32081342,1}]'),(561,610,32,'[{0,32081342,1},{0,34010001,1}]'),(561,610,33,'[{0,32081342,1}]'),(561,610,34,'[{0,32081342,1}]'),(561,610,35,'[{0,32081342,1},{0,34010001,1}]'),(561,610,36,'[{0,32081342,1}]'),(561,610,37,'[{0,32081342,1}]'),(561,610,38,'[{0,32081342,1},{0,34010001,1}]'),(561,610,39,'[{0,32081342,1}]'),(561,610,40,'[{0,32081342,1}]'),(561,610,41,'[{0,32081342,1}]'),(561,610,42,'[{0,32081342,1},{0,34010001,1}]'),(561,610,43,'[{0,32081342,1}]'),(561,610,44,'[{0,32081342,1}]'),(561,610,45,'[{0,32081342,1}]'),(561,610,46,'[{0,32081342,1},{0,34010001,1}]'),(561,610,47,'[{0,32081342,1}]'),(561,610,48,'[{0,32081342,1}]'),(561,610,49,'[{0,32081342,1}]'),(561,610,50,'[{0,32081342,1},{0,34010001,1}]'),(561,610,51,'[{0,32081342,1}]'),(561,610,52,'[{0,32081342,1}]'),(561,610,53,'[{0,32081342,1}]'),(561,610,54,'[{0,32081342,1},{0,34010001,1}]'),(561,610,55,'[{0,32081342,1}]'),(561,610,56,'[{0,32081342,1}]'),(561,610,57,'[{0,32081342,1}]'),(561,610,58,'[{0,32081342,1},{0,34010001,1}]'),(561,610,59,'[{0,32081342,1}]'),(561,610,60,'[{0,32081342,1}]'),(561,610,61,'[{0,32081342,1}]'),(561,610,62,'[{0,32081342,1},{0,34010001,1}]'),(561,610,63,'[{0,32081342,1}]'),(561,610,64,'[{0,32081342,1}]'),(561,610,65,'[{0,32081342,1}]'),(561,610,66,'[{0,32081342,1},{0,34010001,1}]'),(561,610,67,'[{0,32081342,1}]'),(561,610,68,'[{0,32081342,1}]'),(561,610,69,'[{0,32081342,1}]'),(561,610,70,'[{0,32081342,1},{0,34010001,1}]'),(561,610,71,'[{0,32081342,1}]'),(561,610,72,'[{0,32081342,1}]'),(561,610,73,'[{0,32081342,1}]'),(561,610,74,'[{0,32081342,1},{0,34010001,1}]'),(561,610,75,'[{0,32081342,1}]'),(561,610,76,'[{0,32081342,1}]'),(561,610,77,'[{0,32081342,1}]'),(561,610,78,'[{0,32081342,1},{0,34010001,1}]'),(561,610,79,'[{0,32081342,1}]'),(561,610,80,'[{0,32081342,1}]'),(561,610,81,'[{0,32081342,1}]'),(561,610,82,'[{0,32081342,1},{0,34010001,1}]'),(561,610,83,'[{0,32081342,1}]'),(561,610,84,'[{0,32081342,1}]'),(561,610,85,'[{0,32081342,1}]'),(561,610,86,'[{0,32081342,1},{0,34010001,1}]'),(561,610,87,'[{0,32081342,1}]'),(561,610,88,'[{0,32081342,1}]'),(561,610,89,'[{0,32081342,1}]'),(561,610,90,'[{0,32081342,1},{0,34010001,1}]'),(561,610,91,'[{0,32081342,1}]'),(561,610,92,'[{0,32081342,1}]'),(561,610,93,'[{0,32081342,1}]'),(561,610,94,'[{0,32081342,1},{0,34010001,1}]'),(561,610,95,'[{0,32081342,1}]'),(561,610,96,'[{0,32081342,1}]'),(561,610,97,'[{0,32081342,1}]'),(561,610,98,'[{0,32081342,1},{0,34010001,1}]'),(561,610,99,'[{0,32081342,1}]'),(561,610,100,'[{0,32081342,1}]'),(561,610,101,'[{0,32081342,1}]'),(561,610,102,'[{0,32081342,1},{0,34010001,1}]'),(561,610,103,'[{0,32081342,1}]'),(561,610,104,'[{0,32081342,1}]'),(561,610,105,'[{0,32081342,1}]'),(561,610,106,'[{0,32081342,1},{0,34010001,1}]'),(561,610,107,'[{0,32081342,1}]'),(561,610,108,'[{0,32081342,1}]'),(561,610,109,'[{0,32081342,1}]'),(561,610,110,'[{0,32081342,1},{0,34010001,1}]'),(561,610,111,'[{0,32081342,1}]'),(561,610,112,'[{0,32081342,1}]'),(561,610,113,'[{0,32081342,1}]'),(561,610,114,'[{0,32081342,1},{0,34010001,1}]'),(561,610,115,'[{0,32081342,1}]'),(561,610,116,'[{0,32081342,1}]'),(561,610,117,'[{0,32081342,1}]'),(561,610,118,'[{0,32081342,1},{0,34010001,1}]'),(561,610,119,'[{0,32081342,1}]'),(561,610,120,'[{0,32081342,1}]'),(561,610,121,'[{0,32081342,1}]'),(561,610,122,'[{0,32081342,1},{0,34010001,1}]'),(561,610,123,'[{0,32081342,1}]'),(561,610,124,'[{0,32081342,1}]'),(561,610,125,'[{0,32081342,1}]'),(561,610,126,'[{0,32081342,1},{0,34010001,1}]'),(561,610,127,'[{0,32081342,1}]'),(561,610,128,'[{0,32081342,1}]'),(561,610,129,'[{0,32081342,1}]'),(561,610,130,'[{0,32081342,1},{0,34010001,1}]'),(561,610,131,'[{0,32081342,1}]'),(561,610,132,'[{0,32081342,1}]'),(561,610,133,'[{0,32081342,1}]'),(561,610,134,'[{0,32081342,1},{0,34010001,1}]'),(561,610,135,'[{0,32081342,1}]'),(561,610,136,'[{0,32081342,1}]'),(561,610,137,'[{0,32081342,1}]'),(561,610,138,'[{0,32081342,1},{0,34010001,1}]'),(561,610,139,'[{0,32081342,1}]'),(561,610,140,'[{0,32081342,1}]'),(561,610,141,'[{0,32081342,1}]'),(561,610,142,'[{0,32081342,1},{0,34010001,1}]'),(561,610,143,'[{0,32081342,1}]'),(561,610,144,'[{0,32081342,1}]'),(561,610,145,'[{0,32081342,1}]'),(561,610,146,'[{0,32081342,1},{0,34010001,1}]'),(561,610,147,'[{0,32081342,1}]'),(561,610,148,'[{0,32081342,1}]'),(561,610,149,'[{0,32081342,1}]'),(561,610,150,'[{0,32081342,1},{0,34010001,1}]'),(561,610,151,'[{0,32081342,1}]'),(561,610,152,'[{0,32081342,1}]'),(561,610,153,'[{0,32081342,1}]'),(561,610,154,'[{0,32081342,1},{0,34010001,1}]'),(561,610,155,'[{0,32081342,1}]'),(561,610,156,'[{0,32081342,1}]'),(561,610,157,'[{0,32081342,1}]'),(561,610,158,'[{0,32081342,1},{0,34010001,1}]'),(561,610,159,'[{0,32081342,1}]'),(561,610,160,'[{0,32081342,1}]'),(561,610,161,'[{0,32081342,1}]'),(561,610,162,'[{0,32081342,1},{0,34010001,1}]'),(561,610,163,'[{0,32081342,1}]'),(561,610,164,'[{0,32081342,1}]'),(561,610,165,'[{0,32081342,1}]'),(561,610,166,'[{0,32081342,1},{0,34010001,1}]'),(561,610,167,'[{0,32081342,1}]'),(561,610,168,'[{0,32081342,1}]'),(561,610,169,'[{0,32081342,1}]'),(561,610,170,'[{0,32081342,1},{0,34010001,1}]'),(561,610,171,'[{0,32081342,1}]'),(561,610,172,'[{0,32081342,1}]'),(561,610,173,'[{0,32081342,1}]'),(561,610,174,'[{0,32081342,1},{0,34010001,1}]'),(561,610,175,'[{0,32081342,1}]'),(561,610,176,'[{0,32081342,1}]'),(561,610,177,'[{0,32081342,1}]'),(561,610,178,'[{0,32081342,1},{0,34010001,1}]'),(561,610,179,'[{0,32081342,1}]'),(561,610,180,'[{0,32081342,1}]'),(561,610,181,'[{0,32081342,1}]'),(561,610,182,'[{0,32081342,1},{0,34010001,1}]'),(561,610,183,'[{0,32081342,1}]'),(561,610,184,'[{0,32081342,1}]'),(561,610,185,'[{0,32081342,1}]'),(561,610,186,'[{0,32081342,1},{0,34010001,1}]'),(561,610,187,'[{0,32081342,1}]'),(561,610,188,'[{0,32081342,1}]'),(561,610,189,'[{0,32081342,1}]'),(561,610,190,'[{0,32081342,1},{0,34010001,1}]'),(561,610,191,'[{0,32081342,1}]'),(561,610,192,'[{0,32081342,1}]'),(561,610,193,'[{0,32081342,1}]'),(561,610,194,'[{0,32081342,1},{0,34010001,1}]'),(561,610,195,'[{0,32081342,1}]'),(561,610,196,'[{0,32081342,1}]'),(561,610,197,'[{0,32081342,1}]'),(561,610,198,'[{0,32081342,1},{0,34010001,1}]'),(561,610,199,'[{0,32081342,1}]'),(561,610,200,'[{0,32081342,1}]'),(561,610,201,'[{0,32081342,1}]'),(561,610,202,'[{0,32081342,1},{0,34010001,1}]'),(561,610,203,'[{0,32081342,1}]'),(561,610,204,'[{0,32081342,1}]'),(561,610,205,'[{0,32081342,1}]'),(561,610,206,'[{0,32081342,1},{0,34010001,1}]'),(561,610,207,'[{0,32081342,1}]'),(561,610,208,'[{0,32081342,1}]'),(561,610,209,'[{0,32081342,1}]'),(561,610,210,'[{0,32081342,1},{0,34010001,1}]'),(561,610,211,'[{0,32081342,1}]'),(561,610,212,'[{0,32081342,1}]'),(561,610,213,'[{0,32081342,1}]'),(561,610,214,'[{0,32081342,1},{0,34010001,1}]'),(561,610,215,'[{0,32081342,1}]'),(561,610,216,'[{0,32081342,1}]'),(561,610,217,'[{0,32081342,1}]'),(561,610,218,'[{0,32081342,1},{0,34010001,1}]'),(611,660,1,'[{0,32081442,1}]'),(611,660,2,'[{0,32081442,1},{0,34010001,1}]'),(611,660,3,'[{0,32081442,1}]'),(611,660,4,'[{0,32081442,1}]'),(611,660,5,'[{0,32081442,1},{0,34010001,1}]'),(611,660,6,'[{0,32081442,1}]'),(611,660,7,'[{0,32081442,1}]'),(611,660,8,'[{0,32081442,1},{0,34010001,1}]'),(611,660,9,'[{0,32081442,1}]'),(611,660,10,'[{0,32081442,1}]'),(611,660,11,'[{0,32081442,1},{0,34010001,1}]'),(611,660,12,'[{0,32081442,1}]'),(611,660,13,'[{0,32081442,1}]'),(611,660,14,'[{0,32081442,1},{0,34010001,1}]'),(611,660,15,'[{0,32081442,1}]'),(611,660,16,'[{0,32081442,1}]'),(611,660,17,'[{0,32081442,1},{0,34010001,1}]'),(611,660,18,'[{0,32081442,1}]'),(611,660,19,'[{0,32081442,1}]'),(611,660,20,'[{0,32081442,1},{0,34010001,1}]'),(611,660,21,'[{0,32081442,1}]'),(611,660,22,'[{0,32081442,1}]'),(611,660,23,'[{0,32081442,1},{0,34010001,1}]'),(611,660,24,'[{0,32081442,1}]'),(611,660,25,'[{0,32081442,1}]'),(611,660,26,'[{0,32081442,1},{0,34010001,1}]'),(611,660,27,'[{0,32081442,1}]'),(611,660,28,'[{0,32081442,1}]'),(611,660,29,'[{0,32081442,1},{0,34010001,1}]'),(611,660,30,'[{0,32081442,1}]'),(611,660,31,'[{0,32081442,1}]'),(611,660,32,'[{0,32081442,1},{0,34010001,1}]'),(611,660,33,'[{0,32081442,1}]'),(611,660,34,'[{0,32081442,1}]'),(611,660,35,'[{0,32081442,1},{0,34010001,1}]'),(611,660,36,'[{0,32081442,1}]'),(611,660,37,'[{0,32081442,1}]'),(611,660,38,'[{0,32081442,1},{0,34010001,1}]'),(611,660,39,'[{0,32081442,1}]'),(611,660,40,'[{0,32081442,1}]'),(611,660,41,'[{0,32081442,1}]'),(611,660,42,'[{0,32081442,1},{0,34010001,1}]'),(611,660,43,'[{0,32081442,1}]'),(611,660,44,'[{0,32081442,1}]'),(611,660,45,'[{0,32081442,1}]'),(611,660,46,'[{0,32081442,1},{0,34010001,1}]'),(611,660,47,'[{0,32081442,1}]'),(611,660,48,'[{0,32081442,1}]'),(611,660,49,'[{0,32081442,1}]'),(611,660,50,'[{0,32081442,1},{0,34010001,1}]'),(611,660,51,'[{0,32081442,1}]'),(611,660,52,'[{0,32081442,1}]'),(611,660,53,'[{0,32081442,1}]'),(611,660,54,'[{0,32081442,1},{0,34010001,1}]'),(611,660,55,'[{0,32081442,1}]'),(611,660,56,'[{0,32081442,1}]'),(611,660,57,'[{0,32081442,1}]'),(611,660,58,'[{0,32081442,1},{0,34010001,1}]'),(611,660,59,'[{0,32081442,1}]'),(611,660,60,'[{0,32081442,1}]'),(611,660,61,'[{0,32081442,1}]'),(611,660,62,'[{0,32081442,1},{0,34010001,1}]'),(611,660,63,'[{0,32081442,1}]'),(611,660,64,'[{0,32081442,1}]'),(611,660,65,'[{0,32081442,1}]'),(611,660,66,'[{0,32081442,1},{0,34010001,1}]'),(611,660,67,'[{0,32081442,1}]'),(611,660,68,'[{0,32081442,1}]'),(611,660,69,'[{0,32081442,1}]'),(611,660,70,'[{0,32081442,1},{0,34010001,1}]'),(611,660,71,'[{0,32081442,1}]'),(611,660,72,'[{0,32081442,1}]'),(611,660,73,'[{0,32081442,1}]'),(611,660,74,'[{0,32081442,1},{0,34010001,1}]'),(611,660,75,'[{0,32081442,1}]'),(611,660,76,'[{0,32081442,1}]'),(611,660,77,'[{0,32081442,1}]'),(611,660,78,'[{0,32081442,1},{0,34010001,1}]'),(611,660,79,'[{0,32081442,1}]'),(611,660,80,'[{0,32081442,1}]'),(611,660,81,'[{0,32081442,1}]'),(611,660,82,'[{0,32081442,1},{0,34010001,1}]'),(611,660,83,'[{0,32081442,1}]'),(611,660,84,'[{0,32081442,1}]'),(611,660,85,'[{0,32081442,1}]'),(611,660,86,'[{0,32081442,1},{0,34010001,1}]'),(611,660,87,'[{0,32081442,1}]'),(611,660,88,'[{0,32081442,1}]'),(611,660,89,'[{0,32081442,1}]'),(611,660,90,'[{0,32081442,1},{0,34010001,1}]'),(611,660,91,'[{0,32081442,1}]'),(611,660,92,'[{0,32081442,1}]'),(611,660,93,'[{0,32081442,1}]'),(611,660,94,'[{0,32081442,1},{0,34010001,1}]'),(611,660,95,'[{0,32081442,1}]'),(611,660,96,'[{0,32081442,1}]'),(611,660,97,'[{0,32081442,1}]'),(611,660,98,'[{0,32081442,1},{0,34010001,1}]'),(611,660,99,'[{0,32081442,1}]'),(611,660,100,'[{0,32081442,1}]'),(611,660,101,'[{0,32081442,1}]'),(611,660,102,'[{0,32081442,1},{0,34010001,1}]'),(611,660,103,'[{0,32081442,1}]'),(611,660,104,'[{0,32081442,1}]'),(611,660,105,'[{0,32081442,1}]'),(611,660,106,'[{0,32081442,1},{0,34010001,1}]'),(611,660,107,'[{0,32081442,1}]'),(611,660,108,'[{0,32081442,1}]'),(611,660,109,'[{0,32081442,1}]'),(611,660,110,'[{0,32081442,1},{0,34010001,1}]'),(611,660,111,'[{0,32081442,1}]'),(611,660,112,'[{0,32081442,1}]'),(611,660,113,'[{0,32081442,1}]'),(611,660,114,'[{0,32081442,1},{0,34010001,1}]'),(611,660,115,'[{0,32081442,1}]'),(611,660,116,'[{0,32081442,1}]'),(611,660,117,'[{0,32081442,1}]'),(611,660,118,'[{0,32081442,1},{0,34010001,1}]'),(611,660,119,'[{0,32081442,1}]'),(611,660,120,'[{0,32081442,1}]'),(611,660,121,'[{0,32081442,1}]'),(611,660,122,'[{0,32081442,1},{0,34010001,1}]'),(611,660,123,'[{0,32081442,1}]'),(611,660,124,'[{0,32081442,1}]'),(611,660,125,'[{0,32081442,1}]'),(611,660,126,'[{0,32081442,1},{0,34010001,1}]'),(611,660,127,'[{0,32081442,1}]'),(611,660,128,'[{0,32081442,1}]'),(611,660,129,'[{0,32081442,1}]'),(611,660,130,'[{0,32081442,1},{0,34010001,1}]'),(611,660,131,'[{0,32081442,1}]'),(611,660,132,'[{0,32081442,1}]'),(611,660,133,'[{0,32081442,1}]'),(611,660,134,'[{0,32081442,1},{0,34010001,1}]'),(611,660,135,'[{0,32081442,1}]'),(611,660,136,'[{0,32081442,1}]'),(611,660,137,'[{0,32081442,1}]'),(611,660,138,'[{0,32081442,1},{0,34010001,1}]'),(611,660,139,'[{0,32081442,1}]'),(611,660,140,'[{0,32081442,1}]'),(611,660,141,'[{0,32081442,1}]'),(611,660,142,'[{0,32081442,1},{0,34010001,1}]'),(611,660,143,'[{0,32081442,1}]'),(611,660,144,'[{0,32081442,1}]'),(611,660,145,'[{0,32081442,1}]'),(611,660,146,'[{0,32081442,1},{0,34010001,1}]'),(611,660,147,'[{0,32081442,1}]'),(611,660,148,'[{0,32081442,1}]'),(611,660,149,'[{0,32081442,1}]'),(611,660,150,'[{0,32081442,1},{0,34010001,1}]'),(611,660,151,'[{0,32081442,1}]'),(611,660,152,'[{0,32081442,1}]'),(611,660,153,'[{0,32081442,1}]'),(611,660,154,'[{0,32081442,1},{0,34010001,1}]'),(611,660,155,'[{0,32081442,1}]'),(611,660,156,'[{0,32081442,1}]'),(611,660,157,'[{0,32081442,1}]'),(611,660,158,'[{0,32081442,1},{0,34010001,1}]'),(611,660,159,'[{0,32081442,1}]'),(611,660,160,'[{0,32081442,1}]'),(611,660,161,'[{0,32081442,1}]'),(611,660,162,'[{0,32081442,1},{0,34010001,1}]'),(611,660,163,'[{0,32081442,1}]'),(611,660,164,'[{0,32081442,1}]'),(611,660,165,'[{0,32081442,1}]'),(611,660,166,'[{0,32081442,1},{0,34010001,1}]'),(611,660,167,'[{0,32081442,1}]'),(611,660,168,'[{0,32081442,1}]'),(611,660,169,'[{0,32081442,1}]'),(611,660,170,'[{0,32081442,1},{0,34010001,1}]'),(611,660,171,'[{0,32081442,1}]'),(611,660,172,'[{0,32081442,1}]'),(611,660,173,'[{0,32081442,1}]'),(611,660,174,'[{0,32081442,1},{0,34010001,1}]'),(611,660,175,'[{0,32081442,1}]'),(611,660,176,'[{0,32081442,1}]'),(611,660,177,'[{0,32081442,1}]'),(611,660,178,'[{0,32081442,1},{0,34010001,1}]'),(611,660,179,'[{0,32081442,1}]'),(611,660,180,'[{0,32081442,1}]'),(611,660,181,'[{0,32081442,1}]'),(611,660,182,'[{0,32081442,1},{0,34010001,1}]'),(611,660,183,'[{0,32081442,1}]'),(611,660,184,'[{0,32081442,1}]'),(611,660,185,'[{0,32081442,1}]'),(611,660,186,'[{0,32081442,1},{0,34010001,1}]'),(611,660,187,'[{0,32081442,1}]'),(611,660,188,'[{0,32081442,1}]'),(611,660,189,'[{0,32081442,1}]'),(611,660,190,'[{0,32081442,1},{0,34010001,1}]'),(611,660,191,'[{0,32081442,1}]'),(611,660,192,'[{0,32081442,1}]'),(611,660,193,'[{0,32081442,1}]'),(611,660,194,'[{0,32081442,1},{0,34010001,1}]'),(611,660,195,'[{0,32081442,1}]'),(611,660,196,'[{0,32081442,1}]'),(611,660,197,'[{0,32081442,1}]'),(611,660,198,'[{0,32081442,1},{0,34010001,1}]'),(611,660,199,'[{0,32081442,1}]'),(611,660,200,'[{0,32081442,1}]'),(611,660,201,'[{0,32081442,1}]'),(611,660,202,'[{0,32081442,1},{0,34010001,1}]'),(611,660,203,'[{0,32081442,1}]'),(611,660,204,'[{0,32081442,1}]'),(611,660,205,'[{0,32081442,1}]'),(611,660,206,'[{0,32081442,1},{0,34010001,1}]'),(611,660,207,'[{0,32081442,1}]'),(611,660,208,'[{0,32081442,1}]'),(611,660,209,'[{0,32081442,1}]'),(611,660,210,'[{0,32081442,1},{0,34010001,1}]'),(611,660,211,'[{0,32081442,1}]'),(611,660,212,'[{0,32081442,1}]'),(611,660,213,'[{0,32081442,1}]'),(611,660,214,'[{0,32081442,1},{0,34010001,1}]'),(611,660,215,'[{0,32081442,1}]'),(611,660,216,'[{0,32081442,1}]'),(611,660,217,'[{0,32081442,1}]'),(611,660,218,'[{0,32081442,1},{0,34010001,1}]'),(661,750,1,'[{0,32081542,1}]'),(661,750,2,'[{0,32081542,1},{0,34010001,1}]'),(661,750,3,'[{0,32081542,1}]'),(661,750,4,'[{0,32081542,1}]'),(661,750,5,'[{0,32081542,1},{0,34010001,1}]'),(661,750,6,'[{0,32081542,1}]'),(661,750,7,'[{0,32081542,1}]'),(661,750,8,'[{0,32081542,1},{0,34010001,1}]'),(661,750,9,'[{0,32081542,1}]'),(661,750,10,'[{0,32081542,1}]'),(661,750,11,'[{0,32081542,1},{0,34010001,1}]'),(661,750,12,'[{0,32081542,1}]'),(661,750,13,'[{0,32081542,1}]'),(661,750,14,'[{0,32081542,1},{0,34010001,1}]'),(661,750,15,'[{0,32081542,1}]'),(661,750,16,'[{0,32081542,1}]'),(661,750,17,'[{0,32081542,1},{0,34010001,1}]'),(661,750,18,'[{0,32081542,1}]'),(661,750,19,'[{0,32081542,1}]'),(661,750,20,'[{0,32081542,1},{0,34010001,1}]'),(661,750,21,'[{0,32081542,1}]'),(661,750,22,'[{0,32081542,1}]'),(661,750,23,'[{0,32081542,1},{0,34010001,1}]'),(661,750,24,'[{0,32081542,1}]'),(661,750,25,'[{0,32081542,1}]'),(661,750,26,'[{0,32081542,1},{0,34010001,1}]'),(661,750,27,'[{0,32081542,1}]'),(661,750,28,'[{0,32081542,1}]'),(661,750,29,'[{0,32081542,1},{0,34010001,1}]'),(661,750,30,'[{0,32081542,1}]'),(661,750,31,'[{0,32081542,1}]'),(661,750,32,'[{0,32081542,1},{0,34010001,1}]'),(661,750,33,'[{0,32081542,1}]'),(661,750,34,'[{0,32081542,1}]'),(661,750,35,'[{0,32081542,1},{0,34010001,1}]'),(661,750,36,'[{0,32081542,1}]'),(661,750,37,'[{0,32081542,1}]'),(661,750,38,'[{0,32081542,1},{0,34010001,1}]'),(661,750,39,'[{0,32081542,1}]'),(661,750,40,'[{0,32081542,1}]'),(661,750,41,'[{0,32081542,1}]'),(661,750,42,'[{0,32081542,1},{0,34010001,1}]'),(661,750,43,'[{0,32081542,1}]'),(661,750,44,'[{0,32081542,1}]'),(661,750,45,'[{0,32081542,1}]'),(661,750,46,'[{0,32081542,1},{0,34010001,1}]'),(661,750,47,'[{0,32081542,1}]'),(661,750,48,'[{0,32081542,1}]'),(661,750,49,'[{0,32081542,1}]'),(661,750,50,'[{0,32081542,1},{0,34010001,1}]'),(661,750,51,'[{0,32081542,1}]'),(661,750,52,'[{0,32081542,1}]'),(661,750,53,'[{0,32081542,1}]'),(661,750,54,'[{0,32081542,1},{0,34010001,1}]'),(661,750,55,'[{0,32081542,1}]'),(661,750,56,'[{0,32081542,1}]'),(661,750,57,'[{0,32081542,1}]'),(661,750,58,'[{0,32081542,1},{0,34010001,1}]'),(661,750,59,'[{0,32081542,1}]'),(661,750,60,'[{0,32081542,1}]'),(661,750,61,'[{0,32081542,1}]'),(661,750,62,'[{0,32081542,1},{0,34010001,1}]'),(661,750,63,'[{0,32081542,1}]'),(661,750,64,'[{0,32081542,1}]'),(661,750,65,'[{0,32081542,1}]'),(661,750,66,'[{0,32081542,1},{0,34010001,1}]'),(661,750,67,'[{0,32081542,1}]'),(661,750,68,'[{0,32081542,1}]'),(661,750,69,'[{0,32081542,1}]'),(661,750,70,'[{0,32081542,1},{0,34010001,1}]'),(661,750,71,'[{0,32081542,1}]'),(661,750,72,'[{0,32081542,1}]'),(661,750,73,'[{0,32081542,1}]'),(661,750,74,'[{0,32081542,1},{0,34010001,1}]'),(661,750,75,'[{0,32081542,1}]'),(661,750,76,'[{0,32081542,1}]'),(661,750,77,'[{0,32081542,1}]'),(661,750,78,'[{0,32081542,1},{0,34010001,1}]'),(661,750,79,'[{0,32081542,1}]'),(661,750,80,'[{0,32081542,1}]'),(661,750,81,'[{0,32081542,1}]'),(661,750,82,'[{0,32081542,1},{0,34010001,1}]'),(661,750,83,'[{0,32081542,1}]'),(661,750,84,'[{0,32081542,1}]'),(661,750,85,'[{0,32081542,1}]'),(661,750,86,'[{0,32081542,1},{0,34010001,1}]'),(661,750,87,'[{0,32081542,1}]'),(661,750,88,'[{0,32081542,1}]'),(661,750,89,'[{0,32081542,1}]'),(661,750,90,'[{0,32081542,1},{0,34010001,1}]'),(661,750,91,'[{0,32081542,1}]'),(661,750,92,'[{0,32081542,1}]'),(661,750,93,'[{0,32081542,1}]'),(661,750,94,'[{0,32081542,1},{0,34010001,1}]'),(661,750,95,'[{0,32081542,1}]'),(661,750,96,'[{0,32081542,1}]'),(661,750,97,'[{0,32081542,1}]'),(661,750,98,'[{0,32081542,1},{0,34010001,1}]'),(661,750,99,'[{0,32081542,1}]'),(661,750,100,'[{0,32081542,1}]'),(661,750,101,'[{0,32081542,1}]'),(661,750,102,'[{0,32081542,1},{0,34010001,1}]'),(661,750,103,'[{0,32081542,1}]'),(661,750,104,'[{0,32081542,1}]'),(661,750,105,'[{0,32081542,1}]'),(661,750,106,'[{0,32081542,1},{0,34010001,1}]'),(661,750,107,'[{0,32081542,1}]'),(661,750,108,'[{0,32081542,1}]'),(661,750,109,'[{0,32081542,1}]'),(661,750,110,'[{0,32081542,1},{0,34010001,1}]'),(661,750,111,'[{0,32081542,1}]'),(661,750,112,'[{0,32081542,1}]'),(661,750,113,'[{0,32081542,1}]'),(661,750,114,'[{0,32081542,1},{0,34010001,1}]'),(661,750,115,'[{0,32081542,1}]'),(661,750,116,'[{0,32081542,1}]'),(661,750,117,'[{0,32081542,1}]'),(661,750,118,'[{0,32081542,1},{0,34010001,1}]'),(661,750,119,'[{0,32081542,1}]'),(661,750,120,'[{0,32081542,1}]'),(661,750,121,'[{0,32081542,1}]'),(661,750,122,'[{0,32081542,1},{0,34010001,1}]'),(661,750,123,'[{0,32081542,1}]'),(661,750,124,'[{0,32081542,1}]'),(661,750,125,'[{0,32081542,1}]'),(661,750,126,'[{0,32081542,1},{0,34010001,1}]'),(661,750,127,'[{0,32081542,1}]'),(661,750,128,'[{0,32081542,1}]'),(661,750,129,'[{0,32081542,1}]'),(661,750,130,'[{0,32081542,1},{0,34010001,1}]'),(661,750,131,'[{0,32081542,1}]'),(661,750,132,'[{0,32081542,1}]'),(661,750,133,'[{0,32081542,1}]'),(661,750,134,'[{0,32081542,1},{0,34010001,1}]'),(661,750,135,'[{0,32081542,1}]'),(661,750,136,'[{0,32081542,1}]'),(661,750,137,'[{0,32081542,1}]'),(661,750,138,'[{0,32081542,1},{0,34010001,1}]'),(661,750,139,'[{0,32081542,1}]'),(661,750,140,'[{0,32081542,1}]'),(661,750,141,'[{0,32081542,1}]'),(661,750,142,'[{0,32081542,1},{0,34010001,1}]'),(661,750,143,'[{0,32081542,1}]'),(661,750,144,'[{0,32081542,1}]'),(661,750,145,'[{0,32081542,1}]'),(661,750,146,'[{0,32081542,1},{0,34010001,1}]'),(661,750,147,'[{0,32081542,1}]'),(661,750,148,'[{0,32081542,1}]'),(661,750,149,'[{0,32081542,1}]'),(661,750,150,'[{0,32081542,1},{0,34010001,1}]'),(661,750,151,'[{0,32081542,1}]'),(661,750,152,'[{0,32081542,1}]'),(661,750,153,'[{0,32081542,1}]'),(661,750,154,'[{0,32081542,1},{0,34010001,1}]'),(661,750,155,'[{0,32081542,1}]'),(661,750,156,'[{0,32081542,1}]'),(661,750,157,'[{0,32081542,1}]'),(661,750,158,'[{0,32081542,1},{0,34010001,1}]'),(661,750,159,'[{0,32081542,1}]'),(661,750,160,'[{0,32081542,1}]'),(661,750,161,'[{0,32081542,1}]'),(661,750,162,'[{0,32081542,1},{0,34010001,1}]'),(661,750,163,'[{0,32081542,1}]'),(661,750,164,'[{0,32081542,1}]'),(661,750,165,'[{0,32081542,1}]'),(661,750,166,'[{0,32081542,1},{0,34010001,1}]'),(661,750,167,'[{0,32081542,1}]'),(661,750,168,'[{0,32081542,1}]'),(661,750,169,'[{0,32081542,1}]'),(661,750,170,'[{0,32081542,1},{0,34010001,1}]'),(661,750,171,'[{0,32081542,1}]'),(661,750,172,'[{0,32081542,1}]'),(661,750,173,'[{0,32081542,1}]'),(661,750,174,'[{0,32081542,1},{0,34010001,1}]'),(661,750,175,'[{0,32081542,1}]'),(661,750,176,'[{0,32081542,1}]'),(661,750,177,'[{0,32081542,1}]'),(661,750,178,'[{0,32081542,1},{0,34010001,1}]'),(661,750,179,'[{0,32081542,1}]'),(661,750,180,'[{0,32081542,1}]'),(661,750,181,'[{0,32081542,1}]'),(661,750,182,'[{0,32081542,1},{0,34010001,1}]'),(661,750,183,'[{0,32081542,1}]'),(661,750,184,'[{0,32081542,1}]'),(661,750,185,'[{0,32081542,1}]'),(661,750,186,'[{0,32081542,1},{0,34010001,1}]'),(661,750,187,'[{0,32081542,1}]'),(661,750,188,'[{0,32081542,1}]'),(661,750,189,'[{0,32081542,1}]'),(661,750,190,'[{0,32081542,1},{0,34010001,1}]'),(661,750,191,'[{0,32081542,1}]'),(661,750,192,'[{0,32081542,1}]'),(661,750,193,'[{0,32081542,1}]'),(661,750,194,'[{0,32081542,1},{0,34010001,1}]'),(661,750,195,'[{0,32081542,1}]'),(661,750,196,'[{0,32081542,1}]'),(661,750,197,'[{0,32081542,1}]'),(661,750,198,'[{0,32081542,1},{0,34010001,1}]'),(661,750,199,'[{0,32081542,1}]'),(661,750,200,'[{0,32081542,1}]'),(661,750,201,'[{0,32081542,1}]'),(661,750,202,'[{0,32081542,1},{0,34010001,1}]'),(661,750,203,'[{0,32081542,1}]'),(661,750,204,'[{0,32081542,1}]'),(661,750,205,'[{0,32081542,1}]'),(661,750,206,'[{0,32081542,1},{0,34010001,1}]'),(661,750,207,'[{0,32081542,1}]'),(661,750,208,'[{0,32081542,1}]'),(661,750,209,'[{0,32081542,1}]'),(661,750,210,'[{0,32081542,1},{0,34010001,1}]'),(661,750,211,'[{0,32081542,1}]'),(661,750,212,'[{0,32081542,1}]'),(661,750,213,'[{0,32081542,1}]'),(661,750,214,'[{0,32081542,1},{0,34010001,1}]'),(661,750,215,'[{0,32081542,1}]'),(661,750,216,'[{0,32081542,1}]'),(661,750,217,'[{0,32081542,1}]'),(661,750,218,'[{0,32081542,1},{0,34010001,1}]'),(751,1000,1,'[{0,32081642,1}]'),(751,1000,2,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,3,'[{0,32081642,1}]'),(751,1000,4,'[{0,32081642,1}]'),(751,1000,5,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,6,'[{0,32081642,1}]'),(751,1000,7,'[{0,32081642,1}]'),(751,1000,8,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,9,'[{0,32081642,1}]'),(751,1000,10,'[{0,32081642,1}]'),(751,1000,11,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,12,'[{0,32081642,1}]'),(751,1000,13,'[{0,32081642,1}]'),(751,1000,14,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,15,'[{0,32081642,1}]'),(751,1000,16,'[{0,32081642,1}]'),(751,1000,17,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,18,'[{0,32081642,1}]'),(751,1000,19,'[{0,32081642,1}]'),(751,1000,20,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,21,'[{0,32081642,1}]'),(751,1000,22,'[{0,32081642,1}]'),(751,1000,23,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,24,'[{0,32081642,1}]'),(751,1000,25,'[{0,32081642,1}]'),(751,1000,26,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,27,'[{0,32081642,1}]'),(751,1000,28,'[{0,32081642,1}]'),(751,1000,29,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,30,'[{0,32081642,1}]'),(751,1000,31,'[{0,32081642,1}]'),(751,1000,32,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,33,'[{0,32081642,1}]'),(751,1000,34,'[{0,32081642,1}]'),(751,1000,35,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,36,'[{0,32081642,1}]'),(751,1000,37,'[{0,32081642,1}]'),(751,1000,38,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,39,'[{0,32081642,1}]'),(751,1000,40,'[{0,32081642,1}]'),(751,1000,41,'[{0,32081642,1}]'),(751,1000,42,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,43,'[{0,32081642,1}]'),(751,1000,44,'[{0,32081642,1}]'),(751,1000,45,'[{0,32081642,1}]'),(751,1000,46,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,47,'[{0,32081642,1}]'),(751,1000,48,'[{0,32081642,1}]'),(751,1000,49,'[{0,32081642,1}]'),(751,1000,50,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,51,'[{0,32081642,1}]'),(751,1000,52,'[{0,32081642,1}]'),(751,1000,53,'[{0,32081642,1}]'),(751,1000,54,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,55,'[{0,32081642,1}]'),(751,1000,56,'[{0,32081642,1}]'),(751,1000,57,'[{0,32081642,1}]'),(751,1000,58,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,59,'[{0,32081642,1}]'),(751,1000,60,'[{0,32081642,1}]'),(751,1000,61,'[{0,32081642,1}]'),(751,1000,62,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,63,'[{0,32081642,1}]'),(751,1000,64,'[{0,32081642,1}]'),(751,1000,65,'[{0,32081642,1}]'),(751,1000,66,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,67,'[{0,32081642,1}]'),(751,1000,68,'[{0,32081642,1}]'),(751,1000,69,'[{0,32081642,1}]'),(751,1000,70,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,71,'[{0,32081642,1}]'),(751,1000,72,'[{0,32081642,1}]'),(751,1000,73,'[{0,32081642,1}]'),(751,1000,74,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,75,'[{0,32081642,1}]'),(751,1000,76,'[{0,32081642,1}]'),(751,1000,77,'[{0,32081642,1}]'),(751,1000,78,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,79,'[{0,32081642,1}]'),(751,1000,80,'[{0,32081642,1}]'),(751,1000,81,'[{0,32081642,1}]'),(751,1000,82,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,83,'[{0,32081642,1}]'),(751,1000,84,'[{0,32081642,1}]'),(751,1000,85,'[{0,32081642,1}]'),(751,1000,86,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,87,'[{0,32081642,1}]'),(751,1000,88,'[{0,32081642,1}]'),(751,1000,89,'[{0,32081642,1}]'),(751,1000,90,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,91,'[{0,32081642,1}]'),(751,1000,92,'[{0,32081642,1}]'),(751,1000,93,'[{0,32081642,1}]'),(751,1000,94,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,95,'[{0,32081642,1}]'),(751,1000,96,'[{0,32081642,1}]'),(751,1000,97,'[{0,32081642,1}]'),(751,1000,98,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,99,'[{0,32081642,1}]'),(751,1000,100,'[{0,32081642,1}]'),(751,1000,101,'[{0,32081642,1}]'),(751,1000,102,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,103,'[{0,32081642,1}]'),(751,1000,104,'[{0,32081642,1}]'),(751,1000,105,'[{0,32081642,1}]'),(751,1000,106,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,107,'[{0,32081642,1}]'),(751,1000,108,'[{0,32081642,1}]'),(751,1000,109,'[{0,32081642,1}]'),(751,1000,110,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,111,'[{0,32081642,1}]'),(751,1000,112,'[{0,32081642,1}]'),(751,1000,113,'[{0,32081642,1}]'),(751,1000,114,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,115,'[{0,32081642,1}]'),(751,1000,116,'[{0,32081642,1}]'),(751,1000,117,'[{0,32081642,1}]'),(751,1000,118,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,119,'[{0,32081642,1}]'),(751,1000,120,'[{0,32081642,1}]'),(751,1000,121,'[{0,32081642,1}]'),(751,1000,122,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,123,'[{0,32081642,1}]'),(751,1000,124,'[{0,32081642,1}]'),(751,1000,125,'[{0,32081642,1}]'),(751,1000,126,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,127,'[{0,32081642,1}]'),(751,1000,128,'[{0,32081642,1}]'),(751,1000,129,'[{0,32081642,1}]'),(751,1000,130,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,131,'[{0,32081642,1}]'),(751,1000,132,'[{0,32081642,1}]'),(751,1000,133,'[{0,32081642,1}]'),(751,1000,134,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,135,'[{0,32081642,1}]'),(751,1000,136,'[{0,32081642,1}]'),(751,1000,137,'[{0,32081642,1}]'),(751,1000,138,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,139,'[{0,32081642,1}]'),(751,1000,140,'[{0,32081642,1}]'),(751,1000,141,'[{0,32081642,1}]'),(751,1000,142,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,143,'[{0,32081642,1}]'),(751,1000,144,'[{0,32081642,1}]'),(751,1000,145,'[{0,32081642,1}]'),(751,1000,146,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,147,'[{0,32081642,1}]'),(751,1000,148,'[{0,32081642,1}]'),(751,1000,149,'[{0,32081642,1}]'),(751,1000,150,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,151,'[{0,32081642,1}]'),(751,1000,152,'[{0,32081642,1}]'),(751,1000,153,'[{0,32081642,1}]'),(751,1000,154,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,155,'[{0,32081642,1}]'),(751,1000,156,'[{0,32081642,1}]'),(751,1000,157,'[{0,32081642,1}]'),(751,1000,158,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,159,'[{0,32081642,1}]'),(751,1000,160,'[{0,32081642,1}]'),(751,1000,161,'[{0,32081642,1}]'),(751,1000,162,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,163,'[{0,32081642,1}]'),(751,1000,164,'[{0,32081642,1}]'),(751,1000,165,'[{0,32081642,1}]'),(751,1000,166,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,167,'[{0,32081642,1}]'),(751,1000,168,'[{0,32081642,1}]'),(751,1000,169,'[{0,32081642,1}]'),(751,1000,170,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,171,'[{0,32081642,1}]'),(751,1000,172,'[{0,32081642,1}]'),(751,1000,173,'[{0,32081642,1}]'),(751,1000,174,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,175,'[{0,32081642,1}]'),(751,1000,176,'[{0,32081642,1}]'),(751,1000,177,'[{0,32081642,1}]'),(751,1000,178,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,179,'[{0,32081642,1}]'),(751,1000,180,'[{0,32081642,1}]'),(751,1000,181,'[{0,32081642,1}]'),(751,1000,182,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,183,'[{0,32081642,1}]'),(751,1000,184,'[{0,32081642,1}]'),(751,1000,185,'[{0,32081642,1}]'),(751,1000,186,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,187,'[{0,32081642,1}]'),(751,1000,188,'[{0,32081642,1}]'),(751,1000,189,'[{0,32081642,1}]'),(751,1000,190,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,191,'[{0,32081642,1}]'),(751,1000,192,'[{0,32081642,1}]'),(751,1000,193,'[{0,32081642,1}]'),(751,1000,194,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,195,'[{0,32081642,1}]'),(751,1000,196,'[{0,32081642,1}]'),(751,1000,197,'[{0,32081642,1}]'),(751,1000,198,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,199,'[{0,32081642,1}]'),(751,1000,200,'[{0,32081642,1}]'),(751,1000,201,'[{0,32081642,1}]'),(751,1000,202,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,203,'[{0,32081642,1}]'),(751,1000,204,'[{0,32081642,1}]'),(751,1000,205,'[{0,32081642,1}]'),(751,1000,206,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,207,'[{0,32081642,1}]'),(751,1000,208,'[{0,32081642,1}]'),(751,1000,209,'[{0,32081642,1}]'),(751,1000,210,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,211,'[{0,32081642,1}]'),(751,1000,212,'[{0,32081642,1}]'),(751,1000,213,'[{0,32081642,1}]'),(751,1000,214,'[{0,32081642,1},{0,34010001,1}]'),(751,1000,215,'[{0,32081642,1}]'),(751,1000,216,'[{0,32081642,1}]'),(751,1000,217,'[{0,32081642,1}]'),(751,1000,218,'[{0,32081642,1},{0,34010001,1}]');
/*!40000 ALTER TABLE `base_guild_war_streak_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_guild_war_time_score`
--

DROP TABLE IF EXISTS `base_guild_war_time_score`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_guild_war_time_score` (
  `id` tinyint(3) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `min_time` int(11) unsigned NOT NULL COMMENT '时间下限',
  `max_time` int(11) unsigned NOT NULL COMMENT '时间上限',
  `score` int(11) unsigned NOT NULL COMMENT '应得积分',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8 COMMENT='公会争霸定时积分配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_guild_war_time_score`
--

LOCK TABLES `base_guild_war_time_score` WRITE;
/*!40000 ALTER TABLE `base_guild_war_time_score` DISABLE KEYS */;
INSERT INTO `base_guild_war_time_score` VALUES (1,0,300,30),(2,301,600,20),(3,601,1200,10);
/*!40000 ALTER TABLE `base_guild_war_time_score` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_hi_point`
--

DROP TABLE IF EXISTS `base_hi_point`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_hi_point` (
  `mod_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '模块Id',
  `sub_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '子id',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '功能名称',
  `one_points` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '单次可得狂欢值',
  `max_points` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '狂欢值上限',
  `min_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最低等级',
  `max_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最高等级',
  `order_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排序id',
  `jump_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '跳转id',
  `about` varchar(1024) NOT NULL DEFAULT '' COMMENT '备注',
  PRIMARY KEY (`mod_id`,`sub_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='嗨点活动配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_hi_point`
--

LOCK TABLES `base_hi_point` WRITE;
/*!40000 ALTER TABLE `base_hi_point` DISABLE KEYS */;
INSERT INTO `base_hi_point` VALUES (159,180,'累计充值180钻',50,50,1,9999,1,1,''),(159,1000,'累计充值1000钻',100,100,1,9999,2,1,''),(159,6000,'累计充值6000钻',150,150,1,9999,19,1,''),(181,0,'魂珠寻宝',4,160,1,9999,16,5,''),(280,0,'排位赛',2,120,115,9999,9,0,''),(281,0,'巅峰竞技',5,10,115,9999,18,0,''),(300,7,'日常任务',1,80,55,9999,3,2,''),(416,0,'装备寻宝',2,160,30,9999,4,0,''),(423,3,'经验书馆',3,60,1,9999,15,2,''),(460,3,'首领会所',10,70,120,9999,13,4,''),(460,4,'混乱魔域',10,80,240,9999,14,8,''),(460,5,'首领遗迹',10,70,90,9999,11,1,''),(500,0,'飞艇护送',3,36,130,9999,10,1,''),(604,0,'三英会战',10,10,246,9999,17,0,''),(610,4,'经验副本',5,60,290,9999,5,31,'经验宝库'),(610,5,'装备副本',4,32,105,9999,8,32,''),(610,10,'首领狩猎',10,80,120,9999,12,2,'个人boss属于副本模块'),(610,18,'星灵副本',4,48,1,9999,7,35,''),(610,19,'降神副本',4,48,1,9999,6,36,'');
/*!40000 ALTER TABLE `base_hi_point` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_holy_spirit`
--

DROP TABLE IF EXISTS `base_holy_spirit`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_holy_spirit` (
  `spirit_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '圣灵id',
  `pyx_list` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '专属圣器',
  `prop_list` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '道具经验',
  `open_lv` int(11) unsigned NOT NULL DEFAULT '1' COMMENT '开放等级',
  `figure_id` int(11) NOT NULL DEFAULT '0' COMMENT '圣灵形象',
  `spirit_name` varchar(255) CHARACTER SET utf32 NOT NULL COMMENT '圣灵名字',
  PRIMARY KEY (`spirit_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_holy_spirit`
--

LOCK TABLES `base_holy_spirit` WRITE;
/*!40000 ALTER TABLE `base_holy_spirit` DISABLE KEYS */;
INSERT INTO `base_holy_spirit` VALUES (1,'[1,2,3,4]','[{15020101,30},{15020102,100},{15020103,300}]',85,608001,'暴怒之火'),(2,'[5,6,7,8]','[{15020201,30},{15020202,100},{15020203,300}]',88,608002,'温润之水'),(3,'[9,10,11,12]','[{15020301,30},{15020302,100},{15020303,300}]',90,608003,'摄魂行者');
/*!40000 ALTER TABLE `base_holy_spirit` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_husong_airship`
--

DROP TABLE IF EXISTS `base_husong_airship`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_husong_airship` (
  `airship_id` bigint(20) unsigned NOT NULL COMMENT '飞艇ID',
  `module_id` bigint(20) NOT NULL COMMENT '飞艇模型ID',
  `airship_name` varchar(255) NOT NULL COMMENT '飞艇名字@lang@',
  `airship_hp` smallint(5) unsigned NOT NULL COMMENT '飞艇血量',
  `cost` varchar(255) NOT NULL COMMENT '飞艇租用消耗',
  `other_reward_list` varchar(255) NOT NULL COMMENT '其他奖励列表',
  PRIMARY KEY (`airship_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='护送飞艇配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_husong_airship`
--

LOCK TABLES `base_husong_airship` WRITE;
/*!40000 ALTER TABLE `base_husong_airship` DISABLE KEYS */;
INSERT INTO `base_husong_airship` VALUES (1,6000001,'萨拉托加',8,'[{0,38330001,1}]','[]'),(2,6000002,'企业号',12,'[{0,38330002,1}]','[]'),(3,6000003,'列克星敦',16,'[{0,38330003,1}]','[]'),(4,6000004,'皇家方舟',20,'[{0,38330004,1}]','[{2,0,10}]');
/*!40000 ALTER TABLE `base_husong_airship` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_husong_constant`
--

DROP TABLE IF EXISTS `base_husong_constant`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_husong_constant` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `value` varchar(255) NOT NULL COMMENT '常量值',
  `describe` varchar(500) DEFAULT NULL COMMENT '描述',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=15 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_husong_constant`
--

LOCK TABLES `base_husong_constant` WRITE;
/*!40000 ALTER TABLE `base_husong_constant` DISABLE KEYS */;
INSERT INTO `base_husong_constant` VALUES (1,'300','护送时长（秒）'),(2,'20','请求协助CD（秒）'),(3,'60','劫字图标显示时长（秒）'),(4,'1006','护送一阶段场景ID（弃用）'),(5,'5181','护送二阶段场景ID（弃用）'),(6,'1','飞艇技能最大使用次数'),(7,'24000001','飞艇技能ID'),(8,'800','飞艇检测距离'),(9,'10','护送协助玩家上限'),(10,'[{0,4905003,1}]','护送称号'),(11,' [1004]','新护送阶段一场景ID'),(12,' [1003]','新护送阶段二场景'),(13,'40','护送一阶段失败奖励百分比'),(14,'60','护送二阶段失败奖励百分比');
/*!40000 ALTER TABLE `base_husong_constant` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_husong_npc`
--

DROP TABLE IF EXISTS `base_husong_npc`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_husong_npc` (
  `id` int(10) unsigned NOT NULL COMMENT 'id',
  `npc_id` bigint(20) unsigned NOT NULL COMMENT 'NPC ID',
  `stage` int(10) unsigned NOT NULL COMMENT '护送阶段',
  `scene_id` int(10) unsigned NOT NULL COMMENT '场景ID',
  `name` varchar(50) NOT NULL COMMENT 'NPC名字@lang@',
  `x` int(10) unsigned NOT NULL COMMENT 'X坐标',
  `y` int(10) unsigned NOT NULL COMMENT 'Y坐标',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='护送NPC信息表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_husong_npc`
--

LOCK TABLES `base_husong_npc` WRITE;
/*!40000 ALTER TABLE `base_husong_npc` DISABLE KEYS */;
INSERT INTO `base_husong_npc` VALUES (0,51819001,1,1004,'护送-起点',23015,16134),(1,51819002,1,1003,'护送-中点',4205,10260),(2,51819003,2,1003,'护送-结束',6205,15883),(3,51819003,3,1004,'玩家出生点',23015,16134);
/*!40000 ALTER TABLE `base_husong_npc` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_husong_path`
--

DROP TABLE IF EXISTS `base_husong_path`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_husong_path` (
  `id` tinyint(4) unsigned NOT NULL COMMENT '路径ID',
  `stage` tinyint(4) unsigned NOT NULL COMMENT '护送阶段',
  `path` varchar(4096) NOT NULL COMMENT '路径列表',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='护送寻路路径表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_husong_path`
--

LOCK TABLES `base_husong_path` WRITE;
/*!40000 ALTER TABLE `base_husong_path` DISABLE KEYS */;
INSERT INTO `base_husong_path` VALUES (1,1,'[{1004,23006,16154},{1004,22885,16104},{1004,22821,16040},{1004,22757,15976},{1004,22692,15911},{1004,22628,15847},{1004,22564,15783},{1004,22499,15718},{1004,22435,15654},{1004,22371,15590},{1004,22342,15521},{1004,22342,15460},{1004,22342,15399},{1004,22342,15339},{1004,22342,15278},{1004,22342,15218},{1004,22342,15157},{1004,22342,15096},{1004,22221,15096},{1004,22100,15096},{1004,21995,15032},{1004,21931,14968},{1004,21866,14903},{1004,21823,14840},{1004,21823,14780},{1004,21823,14719},{1004,21823,14658},{1004,21823,14598},{1004,21823,14537},{1004,21823,14476},{1004,21823,14416},{1004,21823,14355},{1004,21823,14295},{1004,21823,14234},{1004,21823,14173},{1004,21823,14113},{1004,21795,14048},{1004,21747,13983},{1004,21698,13919},{1004,21651,13853},{1004,21606,13786},{1004,21563,13718},{1004,21526,13657},{1004,21489,13597},{1004,21453,13536},{1004,21416,13476},{1004,21380,13415},{1004,21343,13354},{1004,21309,13292},{1004,21276,13230},{1004,21243,13167},{1004,21211,13104},{1004,21179,13041},{1004,21148,12978},{1004,21117,12914},{1004,21086,12851},{1004,21056,12786},{1004,21029,12721},{1004,20998,12657},{1004,20965,12595},{1004,20933,12532},{1004,20901,12469},{1004,20869,12406},{1004,20836,12343},{1004,20804,12280},{1004,20772,12217},{1004,20741,12153},{1004,20711,12089},{1004,20680,12026},{1004,20649,11962},{1004,20617,11899},{1004,20585,11836},{1004,20555,11772},{1004,20526,11707},{1004,20497,11642},{1004,20471,11577},{1004,20450,11509},{1004,20436,11440},{1004,20431,11380},{1004,20428,11319},{1004,20424,11259},{1004,20420,11198},{1004,20416,11138},{1004,20412,11077},{1004,20410,11017},{1004,20409,10956},{1004,20408,10895},{1004,20408,10835},{1004,20409,10774},{1004,20409,10713},{1004,20410,10653},{1004,20411,10592},{1004,20412,10532},{1004,20413,10471},{1004,20414,10410},{1004,20415,10350},{1004,20416,10289},{1004,20417,10228},{1004,20418,10168},{1004,20419,10107},{1004,20420,10047},{1004,20421,9986},{1004,20422,9925},{1004,20423,9865},{1004,20424,9804},{1004,20425,9743},{1004,20426,9683},{1004,20427,9622},{1004,20427,9562},{1004,20428,9501},{1004,20431,9440},{1004,20435,9380},{1004,20441,9319},{1004,20455,9250},{1004,20479,9184},{1004,20503,9117},{1004,20527,9051},{1004,20551,8984},{1004,20574,8917},{1004,20593,8849},{1004,20614,8781},{1004,20634,8714},{1004,20654,8646},{1004,20674,8578},{1004,20694,8510},{1004,20710,8441},{1004,20726,8372},{1004,20741,8303},{1004,20755,8234},{1004,20767,8164},{1004,20772,8104},{1004,20776,8043},{1004,20780,7983},{1004,20785,7922},{1004,20791,7862},{1004,20796,7801},{1004,20802,7741},{1004,20807,7681},{1004,20813,7620},{1004,20818,7560},{1004,20824,7500},{1004,20830,7439},{1004,20836,7379},{1004,20843,7319},{1004,20849,7258},{1004,20855,7198},{1004,20861,7138},{1004,20867,7077},{1004,20873,7017},{1004,20879,6957},{1004,20886,6896},{1004,20892,6836},{1004,20898,6776},{1004,20904,6715},{1004,20910,6655},{1004,20916,6595},{1004,20922,6534},{1004,20928,6474},{1004,20934,6414},{1004,20938,6353},{1004,20943,6293},{1004,20948,6232},{1004,20952,6172},{1004,20957,6111},{1004,20961,6051},{1004,20966,5990},{1004,20973,5930},{1004,20988,5861},{1004,21005,5793},{1004,21022,5724},{1004,21039,5655},{1004,21056,5587},{1004,21073,5518},{1004,21084,5448},{1004,21095,5378},{1004,21106,5308},{1004,21117,5238},{1004,21127,5168},{1004,21127,5168}]'),(2,2,'[{1003,4234,10219},{1003,4356,10219},{1003,4477,10219},{1003,4599,10219},{1003,4721,10219},{1003,4842,10219},{1003,4964,10219},{1003,5088,10262},{1003,5152,10327},{1003,5217,10391},{1003,5281,10455},{1003,5345,10520},{1003,5345,10580},{1003,5345,10641},{1003,5345,10701},{1003,5345,10763},{1003,5345,10825},{1003,5345,10885},{1003,5345,10946},{1003,5345,11006},{1003,5345,11067},{1003,5345,11128},{1003,5345,11188},{1003,5345,11249},{1003,5345,11309},{1003,5345,11370},{1003,5345,11431},{1003,5345,11491},{1003,5345,11552},{1003,5345,11613},{1003,5345,11673},{1003,5345,11734},{1003,5345,11795},{1003,5345,11855},{1003,5345,11916},{1003,5345,11978},{1003,5345,12039},{1003,5345,12100},{1003,5345,12161},{1003,5345,12221},{1003,5345,12282},{1003,5345,12343},{1003,5345,12403},{1003,5345,12464},{1003,5345,12524},{1003,5345,12585},{1003,5345,12646},{1003,5345,12706},{1003,5345,12767},{1003,5345,12828},{1003,5345,12888},{1003,5345,12949},{1003,5345,13011},{1003,5345,13072},{1003,5345,13132},{1003,5345,13193},{1003,5345,13254},{1003,5345,13314},{1003,5345,13375},{1003,5345,13436},{1003,5345,13496},{1003,5467,13496},{1003,5590,13539},{1003,5655,13603},{1003,5719,13668},{1003,5783,13732},{1003,5848,13796},{1003,5912,13861},{1003,5977,13926},{1003,6041,13990},{1003,6106,14054},{1003,6170,14119},{1003,6234,14183},{1003,6299,14247},{1003,6363,14312},{1003,6427,14376},{1003,6427,14437},{1003,6427,14497},{1003,6427,14558},{1003,6427,14618},{1003,6427,14679},{1003,6427,14740},{1003,6427,14800},{1003,6427,14861},{1003,6427,14922},{1003,6427,14982},{1003,6427,15043},{1003,6427,15104},{1003,6427,15165},{1003,6427,15226},{1003,6427,15286},{1003,6427,15347},{1003,6427,15408},{1003,6427,15468},{1003,6427,15529},{1003,6427,15590},{1003,6427,15650},{1003,6427,15711},{1003,6427,15771},{1003,6427,15832},{1003,6306,15883},{1003,6205,15883}]'),(3,3,'[{1003,2992,10170},{1003,3114,10170},{1003,3235,10170},{1003,3356,10170},{1003,3477,10170},{1003,3599,10170},{1003,3720,10170},{1003,3841,10170},{1003,3963,10170},{1003,4084,10170},{1003,4205,10170},{1003,4326,10170},{1003,4347,10170}]');
/*!40000 ALTER TABLE `base_husong_path` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_husong_reward`
--

DROP TABLE IF EXISTS `base_husong_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_husong_reward` (
  `id` int(10) unsigned NOT NULL COMMENT '编号',
  `lv_min` int(10) unsigned NOT NULL COMMENT '等级下限',
  `lv_max` int(10) unsigned NOT NULL COMMENT '等级上限',
  `airship_id` int(10) unsigned NOT NULL COMMENT '飞艇id',
  `first_reward` varchar(215) NOT NULL COMMENT '一阶段奖励',
  `second_reward` varchar(215) NOT NULL COMMENT '二阶段奖励',
  `take_reward` varchar(215) NOT NULL COMMENT '抢夺奖励',
  `help_reward` varchar(215) NOT NULL COMMENT '协助奖励',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='护送奖励表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_husong_reward`
--

LOCK TABLES `base_husong_reward` WRITE;
/*!40000 ALTER TABLE `base_husong_reward` DISABLE KEYS */;
INSERT INTO `base_husong_reward` VALUES (1,1,190,1,'[{5,36060001,2202539},{3,36030001,13311}]','[{5,36060001,943945},{3,36030001,5705}]','[{5,36060001,471973},{3,36030001,2852}]','[{5,36060001,283184},{3,36030001,1711}]'),(2,191,200,1,'[{5,36060001,2202539},{3,36030001,13933}]','[{5,36060001,943945},{3,36030001,5971}]','[{5,36060001,471973},{3,36030001,2986}]','[{5,36060001,283184},{3,36030001,1791}]'),(3,201,220,1,'[{5,36060001,2436619},{3,36030001,15178}]','[{5,36060001,1044265},{3,36030001,6505}]','[{5,36060001,522133},{3,36030001,3252}]','[{5,36060001,313280},{3,36030001,1951}]'),(4,221,240,1,'[{5,36060001,2940246},{3,36030001,16422}]','[{5,36060001,1260105},{3,36030001,7038}]','[{5,36060001,630053},{3,36030001,3519}]','[{5,36060001,378032},{3,36030001,2111}]'),(5,241,260,1,'[{5,36060001,3637210},{3,36030001,17667}]','[{5,36060001,1558804},{3,36030001,7571}]','[{5,36060001,779402},{3,36030001,3786}]','[{5,36060001,467641},{3,36030001,2271}]'),(6,261,280,1,'[{5,36060001,3936312},{3,36030001,27667}]','[{5,36060001,1686991},{3,36030001,11857}]','[{5,36060001,843495},{3,36030001,5929}]','[{5,36060001,506097},{3,36030001,3557}]'),(7,281,300,1,'[{5,36060001,4096604},{3,36030001,37800}]','[{5,36060001,1755687},{3,36030001,16200}]','[{5,36060001,877844},{3,36030001,8100}]','[{5,36060001,526706},{3,36030001,4860}]'),(8,301,320,1,'[{5,36060001,4406076},{3,36030001,42933}]','[{5,36060001,1888318},{3,36030001,18400}]','[{5,36060001,944159},{3,36030001,9200}]','[{5,36060001,566495},{3,36030001,5520}]'),(9,321,340,1,'[{5,36060001,4650740},{3,36030001,45978}]','[{5,36060001,1993174},{3,36030001,19705}]','[{5,36060001,996587},{3,36030001,9853}]','[{5,36060001,597952},{3,36030001,5912}]'),(10,341,360,1,'[{5,36060001,4950989},{3,36030001,49093}]','[{5,36060001,2121852},{3,36030001,21040}]','[{5,36060001,1060926},{3,36030001,10520}]','[{5,36060001,636556},{3,36030001,6312}]'),(11,361,380,1,'[{5,36060001,5671870},{3,36030001,57521}]','[{5,36060001,2430801},{3,36030001,24652}]','[{5,36060001,1215401},{3,36030001,12326}]','[{5,36060001,729240},{3,36030001,7396}]'),(12,381,400,1,'[{5,36060001,10813977},{3,36030001,65201}]','[{5,36060001,4634562},{3,36030001,27943}]','[{5,36060001,2317281},{3,36030001,13972}]','[{5,36060001,1390369},{3,36030001,8383}]'),(13,401,420,1,'[{5,36060001,13178422},{3,36030001,74048}]','[{5,36060001,5647895},{3,36030001,31735}]','[{5,36060001,2823948},{3,36030001,15868}]','[{5,36060001,1694369},{3,36030001,9521}]'),(14,421,440,1,'[{5,36060001,15542866},{3,36030001,84062}]','[{5,36060001,6661228},{3,36030001,36027}]','[{5,36060001,3330614},{3,36030001,18013}]','[{5,36060001,1998369},{3,36030001,10808}]'),(15,441,460,1,'[{5,36060001,17819483},{3,36030001,99027}]','[{5,36060001,7636921},{3,36030001,42440}]','[{5,36060001,3818461},{3,36030001,21220}]','[{5,36060001,2291076},{3,36030001,12732}]'),(16,461,480,1,'[{5,36060001,22782725},{3,36030001,116468}]','[{5,36060001,9764025},{3,36030001,49915}]','[{5,36060001,4882013},{3,36030001,24958}]','[{5,36060001,2929208},{3,36030001,14975}]'),(17,481,500,1,'[{5,36060001,25755150},{3,36030001,136803}]','[{5,36060001,11037921},{3,36030001,58630}]','[{5,36060001,5518961},{3,36030001,29315}]','[{5,36060001,3311376},{3,36030001,17589}]'),(18,501,520,1,'[{5,36060001,27528483},{3,36030001,158579}]','[{5,36060001,11797921},{3,36030001,67963}]','[{5,36060001,5898961},{3,36030001,33981}]','[{5,36060001,3539376},{3,36030001,20389}]'),(19,521,540,1,'[{5,36060001,31604807},{3,36030001,188084}]','[{5,36060001,13544917},{3,36030001,80607}]','[{5,36060001,6772459},{3,36030001,40304}]','[{5,36060001,4063475},{3,36030001,24182}]'),(20,541,560,1,'[{5,36060001,41228490},{3,36030001,229157}]','[{5,36060001,17669353},{3,36030001,98210}]','[{5,36060001,8834676},{3,36030001,49105}]','[{5,36060001,5300806},{3,36030001,29463}]'),(21,561,580,1,'[{5,36060001,50538322},{3,36030001,273957}]','[{5,36060001,21659281},{3,36030001,117410}]','[{5,36060001,10829640},{3,36030001,58705}]','[{5,36060001,6497784},{3,36030001,35223}]'),(22,581,600,1,'[{5,36060001,55267211},{3,36030001,323423}]','[{5,36060001,23685948},{3,36030001,138610}]','[{5,36060001,11842974},{3,36030001,69305}]','[{5,36060001,7105784},{3,36030001,41583}]'),(23,601,620,1,'[{5,36060001,59996100},{3,36030001,377557}]','[{5,36060001,25712614},{3,36030001,161810}]','[{5,36060001,12856307},{3,36030001,80905}]','[{5,36060001,7713784},{3,36030001,48543}]'),(24,621,640,1,'[{5,36060001,64724989},{3,36030001,436357}]','[{5,36060001,27739281},{3,36030001,187010}]','[{5,36060001,13869640},{3,36030001,93505}]','[{5,36060001,8321784},{3,36030001,56103}]'),(25,641,660,1,'[{5,36060001,69453878},{3,36030001,499823}]','[{5,36060001,29765948},{3,36030001,214210}]','[{5,36060001,14882974},{3,36030001,107105}]','[{5,36060001,8929784},{3,36030001,64263}]'),(26,661,680,1,'[{5,36060001,74182766},{3,36030001,567957}]','[{5,36060001,31792614},{3,36030001,243410}]','[{5,36060001,15896307},{3,36030001,121705}]','[{5,36060001,9537784},{3,36030001,73023}]'),(27,681,700,1,'[{5,36060001,78911655},{3,36030001,640757}]','[{5,36060001,33819281},{3,36030001,274610}]','[{5,36060001,16909640},{3,36030001,137305}]','[{5,36060001,10145784},{3,36030001,82383}]'),(28,701,720,1,'[{5,36060001,83640544},{3,36030001,718223}]','[{5,36060001,35845948},{3,36030001,307810}]','[{5,36060001,17922974},{3,36030001,153905}]','[{5,36060001,10753784},{3,36030001,92343}]'),(29,721,740,1,'[{5,36060001,88369433},{3,36030001,800357}]','[{5,36060001,37872614},{3,36030001,343010}]','[{5,36060001,18936307},{3,36030001,171505}]','[{5,36060001,11361784},{3,36030001,102903}]'),(30,741,760,1,'[{5,36060001,93098322},{3,36030001,887157}]','[{5,36060001,39899281},{3,36030001,380210}]','[{5,36060001,19949640},{3,36030001,190105}]','[{5,36060001,11969784},{3,36030001,114063}]'),(31,761,780,1,'[{5,36060001,97827211},{3,36030001,978623}]','[{5,36060001,41925948},{3,36030001,419410}]','[{5,36060001,20962974},{3,36030001,209705}]','[{5,36060001,12577784},{3,36030001,125823}]'),(32,781,800,1,'[{5,36060001,102556100},{3,36030001,1026107}]','[{5,36060001,43952614},{3,36030001,439760}]','[{5,36060001,21976307},{3,36030001,219880}]','[{5,36060001,13185784},{3,36030001,131928}]'),(33,801,820,1,'[{5,36060001,104920544},{3,36030001,1026107}]','[{5,36060001,44965948},{3,36030001,439760}]','[{5,36060001,22482974},{3,36030001,219880}]','[{5,36060001,13489784},{3,36030001,131928}]'),(34,821,840,1,'[{5,36060001,104920544},{3,36030001,1026107}]','[{5,36060001,44965948},{3,36030001,439760}]','[{5,36060001,22482974},{3,36030001,219880}]','[{5,36060001,13489784},{3,36030001,131928}]'),(35,841,860,1,'[{5,36060001,104920544},{3,36030001,1026107}]','[{5,36060001,44965948},{3,36030001,439760}]','[{5,36060001,22482974},{3,36030001,219880}]','[{5,36060001,13489784},{3,36030001,131928}]'),(36,861,880,1,'[{5,36060001,104920544},{3,36030001,1026107}]','[{5,36060001,44965948},{3,36030001,439760}]','[{5,36060001,22482974},{3,36030001,219880}]','[{5,36060001,13489784},{3,36030001,131928}]'),(37,881,900,1,'[{5,36060001,104920544},{3,36030001,1026107}]','[{5,36060001,44965948},{3,36030001,439760}]','[{5,36060001,22482974},{3,36030001,219880}]','[{5,36060001,13489784},{3,36030001,131928}]'),(38,901,920,1,'[{5,36060001,104920544},{3,36030001,1026107}]','[{5,36060001,44965948},{3,36030001,439760}]','[{5,36060001,22482974},{3,36030001,219880}]','[{5,36060001,13489784},{3,36030001,131928}]'),(39,921,940,1,'[{5,36060001,104920544},{3,36030001,1026107}]','[{5,36060001,44965948},{3,36030001,439760}]','[{5,36060001,22482974},{3,36030001,219880}]','[{5,36060001,13489784},{3,36030001,131928}]'),(40,941,960,1,'[{5,36060001,104920544},{3,36030001,1026107}]','[{5,36060001,44965948},{3,36030001,439760}]','[{5,36060001,22482974},{3,36030001,219880}]','[{5,36060001,13489784},{3,36030001,131928}]'),(41,961,980,1,'[{5,36060001,104920544},{3,36030001,1026107}]','[{5,36060001,44965948},{3,36030001,439760}]','[{5,36060001,22482974},{3,36030001,219880}]','[{5,36060001,13489784},{3,36030001,131928}]'),(42,981,1000,1,'[{5,36060001,104920544},{3,36030001,1026107}]','[{5,36060001,44965948},{3,36030001,439760}]','[{5,36060001,22482974},{3,36030001,219880}]','[{5,36060001,13489784},{3,36030001,131928}]'),(43,1,190,2,'[{5,36060001,2753174},{3,36030001,16639}]','[{5,36060001,1179932},{3,36030001,7131}]','[{5,36060001,589966},{3,36030001,3565}]','[{5,36060001,353980},{3,36030001,2139}]'),(44,191,200,2,'[{5,36060001,2753174},{3,36030001,17417}]','[{5,36060001,1179932},{3,36030001,7464}]','[{5,36060001,589966},{3,36030001,3732}]','[{5,36060001,353980},{3,36030001,2239}]'),(45,201,220,2,'[{5,36060001,3045774},{3,36030001,18972}]','[{5,36060001,1305332},{3,36030001,8131}]','[{5,36060001,652666},{3,36030001,4065}]','[{5,36060001,391600},{3,36030001,2439}]'),(46,221,240,2,'[{5,36060001,3675307},{3,36030001,20528}]','[{5,36060001,1575132},{3,36030001,8798}]','[{5,36060001,787566},{3,36030001,4399}]','[{5,36060001,472540},{3,36030001,2639}]'),(47,241,260,2,'[{5,36060001,4546512},{3,36030001,22083}]','[{5,36060001,1948505},{3,36030001,9464}]','[{5,36060001,974253},{3,36030001,4732}]','[{5,36060001,584552},{3,36030001,2839}]'),(48,261,280,2,'[{5,36060001,4920390},{3,36030001,34583}]','[{5,36060001,2108739},{3,36030001,14821}]','[{5,36060001,1054369},{3,36030001,7411}]','[{5,36060001,632622},{3,36030001,4446}]'),(49,281,300,2,'[{5,36060001,5120755},{3,36030001,47250}]','[{5,36060001,2194609},{3,36030001,20250}]','[{5,36060001,1097305},{3,36030001,10125}]','[{5,36060001,658383},{3,36030001,6075}]'),(50,301,320,2,'[{5,36060001,5507594},{3,36030001,53667}]','[{5,36060001,2360398},{3,36030001,23000}]','[{5,36060001,1180199},{3,36030001,11500}]','[{5,36060001,708119},{3,36030001,6900}]'),(51,321,340,2,'[{5,36060001,5813425},{3,36030001,57473}]','[{5,36060001,2491468},{3,36030001,24631}]','[{5,36060001,1245734},{3,36030001,12316}]','[{5,36060001,747440},{3,36030001,7389}]'),(52,341,360,2,'[{5,36060001,6188736},{3,36030001,61367}]','[{5,36060001,2652315},{3,36030001,26300}]','[{5,36060001,1326158},{3,36030001,13150}]','[{5,36060001,795695},{3,36030001,7890}]'),(53,361,380,2,'[{5,36060001,7089837},{3,36030001,71901}]','[{5,36060001,3038502},{3,36030001,30815}]','[{5,36060001,1519251},{3,36030001,15407}]','[{5,36060001,911551},{3,36030001,9244}]'),(54,381,400,2,'[{5,36060001,13517472},{3,36030001,81501}]','[{5,36060001,5793202},{3,36030001,34929}]','[{5,36060001,2896601},{3,36030001,17465}]','[{5,36060001,1737961},{3,36030001,10479}]'),(55,401,420,2,'[{5,36060001,16473027},{3,36030001,92560}]','[{5,36060001,7059869},{3,36030001,39669}]','[{5,36060001,3529934},{3,36030001,19834}]','[{5,36060001,2117961},{3,36030001,11901}]'),(56,421,440,2,'[{5,36060001,19428583},{3,36030001,105078}]','[{5,36060001,8326535},{3,36030001,45033}]','[{5,36060001,4163268},{3,36030001,22517}]','[{5,36060001,2497961},{3,36030001,13510}]'),(57,441,460,2,'[{5,36060001,22274354},{3,36030001,123783}]','[{5,36060001,9546152},{3,36030001,53050}]','[{5,36060001,4773076},{3,36030001,26525}]','[{5,36060001,2863845},{3,36030001,15915}]'),(58,461,480,2,'[{5,36060001,28478407},{3,36030001,145585}]','[{5,36060001,12205032},{3,36030001,62394}]','[{5,36060001,6102516},{3,36030001,31197}]','[{5,36060001,3661509},{3,36030001,18718}]'),(59,481,500,2,'[{5,36060001,32193937},{3,36030001,171004}]','[{5,36060001,13797402},{3,36030001,73288}]','[{5,36060001,6898701},{3,36030001,36644}]','[{5,36060001,4139220},{3,36030001,21986}]'),(60,501,520,2,'[{5,36060001,34410604},{3,36030001,198224}]','[{5,36060001,14747402},{3,36030001,84953}]','[{5,36060001,7373701},{3,36030001,42477}]','[{5,36060001,4424220},{3,36030001,25486}]'),(61,521,540,2,'[{5,36060001,39506009},{3,36030001,235105}]','[{5,36060001,16931147},{3,36030001,100759}]','[{5,36060001,8465573},{3,36030001,50380}]','[{5,36060001,5079344},{3,36030001,30228}]'),(62,541,560,2,'[{5,36060001,51535612},{3,36030001,286446}]','[{5,36060001,22086691},{3,36030001,122763}]','[{5,36060001,11043345},{3,36030001,61381}]','[{5,36060001,6626007},{3,36030001,36829}]'),(63,561,580,2,'[{5,36060001,63172902},{3,36030001,342446}]','[{5,36060001,27074101},{3,36030001,146763}]','[{5,36060001,13537051},{3,36030001,73381}]','[{5,36060001,8122230},{3,36030001,44029}]'),(64,581,600,2,'[{5,36060001,69084014},{3,36030001,404279}]','[{5,36060001,29607434},{3,36030001,173263}]','[{5,36060001,14803717},{3,36030001,86631}]','[{5,36060001,8882230},{3,36030001,51979}]'),(65,601,620,2,'[{5,36060001,74995125},{3,36030001,471946}]','[{5,36060001,32140768},{3,36030001,202263}]','[{5,36060001,16070384},{3,36030001,101131}]','[{5,36060001,9642230},{3,36030001,60679}]'),(66,621,640,2,'[{5,36060001,80906236},{3,36030001,545446}]','[{5,36060001,34674101},{3,36030001,233763}]','[{5,36060001,17337051},{3,36030001,116881}]','[{5,36060001,10402230},{3,36030001,70129}]'),(67,641,660,2,'[{5,36060001,86817347},{3,36030001,624779}]','[{5,36060001,37207434},{3,36030001,267763}]','[{5,36060001,18603717},{3,36030001,133881}]','[{5,36060001,11162230},{3,36030001,80329}]'),(68,661,680,2,'[{5,36060001,92728458},{3,36030001,709946}]','[{5,36060001,39740768},{3,36030001,304263}]','[{5,36060001,19870384},{3,36030001,152131}]','[{5,36060001,11922230},{3,36030001,91279}]'),(69,681,700,2,'[{5,36060001,98639569},{3,36030001,800946}]','[{5,36060001,42274101},{3,36030001,343263}]','[{5,36060001,21137051},{3,36030001,171631}]','[{5,36060001,12682230},{3,36030001,102979}]'),(70,701,720,2,'[{5,36060001,104550680},{3,36030001,897779}]','[{5,36060001,44807434},{3,36030001,384763}]','[{5,36060001,22403717},{3,36030001,192381}]','[{5,36060001,13442230},{3,36030001,115429}]'),(71,721,740,2,'[{5,36060001,110461791},{3,36030001,1000446}]','[{5,36060001,47340768},{3,36030001,428763}]','[{5,36060001,23670384},{3,36030001,214381}]','[{5,36060001,14202230},{3,36030001,128629}]'),(72,741,760,2,'[{5,36060001,116372902},{3,36030001,1108946}]','[{5,36060001,49874101},{3,36030001,475263}]','[{5,36060001,24937051},{3,36030001,237631}]','[{5,36060001,14962230},{3,36030001,142579}]'),(73,761,780,2,'[{5,36060001,122284014},{3,36030001,1223279}]','[{5,36060001,52407434},{3,36030001,524263}]','[{5,36060001,26203717},{3,36030001,262131}]','[{5,36060001,15722230},{3,36030001,157279}]'),(74,781,800,2,'[{5,36060001,128195125},{3,36030001,1282633}]','[{5,36060001,54940768},{3,36030001,549700}]','[{5,36060001,27470384},{3,36030001,274850}]','[{5,36060001,16482230},{3,36030001,164910}]'),(75,801,820,2,'[{5,36060001,131150680},{3,36030001,1282633}]','[{5,36060001,56207434},{3,36030001,549700}]','[{5,36060001,28103717},{3,36030001,274850}]','[{5,36060001,16862230},{3,36030001,164910}]'),(76,821,840,2,'[{5,36060001,131150680},{3,36030001,1282633}]','[{5,36060001,56207434},{3,36030001,549700}]','[{5,36060001,28103717},{3,36030001,274850}]','[{5,36060001,16862230},{3,36030001,164910}]'),(77,841,860,2,'[{5,36060001,131150680},{3,36030001,1282633}]','[{5,36060001,56207434},{3,36030001,549700}]','[{5,36060001,28103717},{3,36030001,274850}]','[{5,36060001,16862230},{3,36030001,164910}]'),(78,861,880,2,'[{5,36060001,131150680},{3,36030001,1282633}]','[{5,36060001,56207434},{3,36030001,549700}]','[{5,36060001,28103717},{3,36030001,274850}]','[{5,36060001,16862230},{3,36030001,164910}]'),(79,881,900,2,'[{5,36060001,131150680},{3,36030001,1282633}]','[{5,36060001,56207434},{3,36030001,549700}]','[{5,36060001,28103717},{3,36030001,274850}]','[{5,36060001,16862230},{3,36030001,164910}]'),(80,901,920,2,'[{5,36060001,131150680},{3,36030001,1282633}]','[{5,36060001,56207434},{3,36030001,549700}]','[{5,36060001,28103717},{3,36030001,274850}]','[{5,36060001,16862230},{3,36030001,164910}]'),(81,921,940,2,'[{5,36060001,131150680},{3,36030001,1282633}]','[{5,36060001,56207434},{3,36030001,549700}]','[{5,36060001,28103717},{3,36030001,274850}]','[{5,36060001,16862230},{3,36030001,164910}]'),(82,941,960,2,'[{5,36060001,131150680},{3,36030001,1282633}]','[{5,36060001,56207434},{3,36030001,549700}]','[{5,36060001,28103717},{3,36030001,274850}]','[{5,36060001,16862230},{3,36030001,164910}]'),(83,961,980,2,'[{5,36060001,131150680},{3,36030001,1282633}]','[{5,36060001,56207434},{3,36030001,549700}]','[{5,36060001,28103717},{3,36030001,274850}]','[{5,36060001,16862230},{3,36030001,164910}]'),(84,981,1000,2,'[{5,36060001,131150680},{3,36030001,1282633}]','[{5,36060001,56207434},{3,36030001,549700}]','[{5,36060001,28103717},{3,36030001,274850}]','[{5,36060001,16862230},{3,36030001,164910}]'),(85,1,190,3,'[{5,36060001,3441467},{3,36030001,20799}]','[{5,36060001,1474915},{3,36030001,8914}]','[{5,36060001,737457},{3,36030001,4457}]','[{5,36060001,442474},{3,36030001,2674}]'),(86,191,200,3,'[{5,36060001,3441467},{3,36030001,21771}]','[{5,36060001,1474915},{3,36030001,9330}]','[{5,36060001,737457},{3,36030001,4665}]','[{5,36060001,442474},{3,36030001,2799}]'),(87,201,220,3,'[{5,36060001,3807217},{3,36030001,23715}]','[{5,36060001,1631665},{3,36030001,10164}]','[{5,36060001,815832},{3,36030001,5082}]','[{5,36060001,489499},{3,36030001,3049}]'),(88,221,240,3,'[{5,36060001,4594134},{3,36030001,25660}]','[{5,36060001,1968915},{3,36030001,10997}]','[{5,36060001,984457},{3,36030001,5499}]','[{5,36060001,590674},{3,36030001,3299}]'),(89,241,260,3,'[{5,36060001,5683140},{3,36030001,27604}]','[{5,36060001,2435632},{3,36030001,11830}]','[{5,36060001,1217816},{3,36030001,5915}]','[{5,36060001,730689},{3,36030001,3549}]'),(90,261,280,3,'[{5,36060001,6150488},{3,36030001,43229}]','[{5,36060001,2635923},{3,36030001,18527}]','[{5,36060001,1317962},{3,36030001,9263}]','[{5,36060001,790777},{3,36030001,5558}]'),(91,281,300,3,'[{5,36060001,6400943},{3,36030001,59063}]','[{5,36060001,2743261},{3,36030001,25313}]','[{5,36060001,1371631},{3,36030001,12656}]','[{5,36060001,822978},{3,36030001,7594}]'),(92,301,320,3,'[{5,36060001,6884493},{3,36030001,67083}]','[{5,36060001,2950497},{3,36030001,28750}]','[{5,36060001,1475249},{3,36030001,14375}]','[{5,36060001,885149},{3,36030001,8625}]'),(93,321,340,3,'[{5,36060001,7266782},{3,36030001,71841}]','[{5,36060001,3114335},{3,36030001,30789}]','[{5,36060001,1557167},{3,36030001,15395}]','[{5,36060001,934300},{3,36030001,9237}]'),(94,341,360,3,'[{5,36060001,7735920},{3,36030001,76708}]','[{5,36060001,3315394},{3,36030001,32875}]','[{5,36060001,1657697},{3,36030001,16438}]','[{5,36060001,994618},{3,36030001,9863}]'),(95,361,380,3,'[{5,36060001,8862297},{3,36030001,89876}]','[{5,36060001,3798127},{3,36030001,38518}]','[{5,36060001,1899064},{3,36030001,19259}]','[{5,36060001,1139438},{3,36030001,11555}]'),(96,381,400,3,'[{5,36060001,16896839},{3,36030001,101877}]','[{5,36060001,7241503},{3,36030001,43661}]','[{5,36060001,3620751},{3,36030001,21831}]','[{5,36060001,2172451},{3,36030001,13098}]'),(97,401,420,3,'[{5,36060001,20591284},{3,36030001,115701}]','[{5,36060001,8824836},{3,36030001,49586}]','[{5,36060001,4412418},{3,36030001,24793}]','[{5,36060001,2647451},{3,36030001,14876}]'),(98,421,440,3,'[{5,36060001,24285728},{3,36030001,131347}]','[{5,36060001,10408169},{3,36030001,56292}]','[{5,36060001,5204085},{3,36030001,28146}]','[{5,36060001,3122451},{3,36030001,16888}]'),(99,441,460,3,'[{5,36060001,27842942},{3,36030001,154729}]','[{5,36060001,11932689},{3,36030001,66313}]','[{5,36060001,5966345},{3,36030001,33156}]','[{5,36060001,3579807},{3,36030001,19894}]'),(100,461,480,3,'[{5,36060001,35598009},{3,36030001,181982}]','[{5,36060001,15256289},{3,36030001,77992}]','[{5,36060001,7628145},{3,36030001,38996}]','[{5,36060001,4576887},{3,36030001,23398}]'),(101,481,500,3,'[{5,36060001,40242421},{3,36030001,213755}]','[{5,36060001,17246752},{3,36030001,91609}]','[{5,36060001,8623376},{3,36030001,45805}]','[{5,36060001,5174026},{3,36030001,27483}]'),(102,501,520,3,'[{5,36060001,43013255},{3,36030001,247780}]','[{5,36060001,18434252},{3,36030001,106191}]','[{5,36060001,9217126},{3,36030001,53096}]','[{5,36060001,5530276},{3,36030001,31857}]'),(103,521,540,3,'[{5,36060001,49382511},{3,36030001,293881}]','[{5,36060001,21163933},{3,36030001,125949}]','[{5,36060001,10581967},{3,36030001,62975}]','[{5,36060001,6349180},{3,36030001,37785}]'),(104,541,560,3,'[{5,36060001,64419515},{3,36030001,358057}]','[{5,36060001,27608364},{3,36030001,153453}]','[{5,36060001,13804182},{3,36030001,76727}]','[{5,36060001,8282509},{3,36030001,46036}]'),(105,561,580,3,'[{5,36060001,78966128},{3,36030001,428057}]','[{5,36060001,33842626},{3,36030001,183453}]','[{5,36060001,16921313},{3,36030001,91727}]','[{5,36060001,10152788},{3,36030001,55036}]'),(106,581,600,3,'[{5,36060001,86355017},{3,36030001,505349}]','[{5,36060001,37009293},{3,36030001,216578}]','[{5,36060001,18504647},{3,36030001,108289}]','[{5,36060001,11102788},{3,36030001,64973}]'),(107,601,620,3,'[{5,36060001,93743906},{3,36030001,589932}]','[{5,36060001,40175960},{3,36030001,252828}]','[{5,36060001,20087980},{3,36030001,126414}]','[{5,36060001,12052788},{3,36030001,75848}]'),(108,621,640,3,'[{5,36060001,101132795},{3,36030001,681807}]','[{5,36060001,43342626},{3,36030001,292203}]','[{5,36060001,21671313},{3,36030001,146102}]','[{5,36060001,13002788},{3,36030001,87661}]'),(109,641,660,3,'[{5,36060001,108521684},{3,36030001,780974}]','[{5,36060001,46509293},{3,36030001,334703}]','[{5,36060001,23254647},{3,36030001,167352}]','[{5,36060001,13952788},{3,36030001,100411}]'),(110,661,680,3,'[{5,36060001,115910573},{3,36030001,887432}]','[{5,36060001,49675960},{3,36030001,380328}]','[{5,36060001,24837980},{3,36030001,190164}]','[{5,36060001,14902788},{3,36030001,114098}]'),(111,681,700,3,'[{5,36060001,123299461},{3,36030001,1001182}]','[{5,36060001,52842626},{3,36030001,429078}]','[{5,36060001,26421313},{3,36030001,214539}]','[{5,36060001,15852788},{3,36030001,128723}]'),(112,701,720,3,'[{5,36060001,130688350},{3,36030001,1122224}]','[{5,36060001,56009293},{3,36030001,480953}]','[{5,36060001,28004647},{3,36030001,240477}]','[{5,36060001,16802788},{3,36030001,144286}]'),(113,721,740,3,'[{5,36060001,138077239},{3,36030001,1250557}]','[{5,36060001,59175960},{3,36030001,535953}]','[{5,36060001,29587980},{3,36030001,267977}]','[{5,36060001,17752788},{3,36030001,160786}]'),(114,741,760,3,'[{5,36060001,145466128},{3,36030001,1386182}]','[{5,36060001,62342626},{3,36030001,594078}]','[{5,36060001,31171313},{3,36030001,297039}]','[{5,36060001,18702788},{3,36030001,178223}]'),(115,761,780,3,'[{5,36060001,152855017},{3,36030001,1529099}]','[{5,36060001,65509293},{3,36030001,655328}]','[{5,36060001,32754647},{3,36030001,327664}]','[{5,36060001,19652788},{3,36030001,196598}]'),(116,781,800,3,'[{5,36060001,160243906},{3,36030001,1603292}]','[{5,36060001,68675960},{3,36030001,687125}]','[{5,36060001,34337980},{3,36030001,343563}]','[{5,36060001,20602788},{3,36030001,206138}]'),(117,801,820,3,'[{5,36060001,163938350},{3,36030001,1603292}]','[{5,36060001,70259293},{3,36030001,687125}]','[{5,36060001,35129647},{3,36030001,343563}]','[{5,36060001,21077788},{3,36030001,206138}]'),(118,821,840,3,'[{5,36060001,163938350},{3,36030001,1603292}]','[{5,36060001,70259293},{3,36030001,687125}]','[{5,36060001,35129647},{3,36030001,343563}]','[{5,36060001,21077788},{3,36030001,206138}]'),(119,841,860,3,'[{5,36060001,163938350},{3,36030001,1603292}]','[{5,36060001,70259293},{3,36030001,687125}]','[{5,36060001,35129647},{3,36030001,343563}]','[{5,36060001,21077788},{3,36030001,206138}]'),(120,861,880,3,'[{5,36060001,163938350},{3,36030001,1603292}]','[{5,36060001,70259293},{3,36030001,687125}]','[{5,36060001,35129647},{3,36030001,343563}]','[{5,36060001,21077788},{3,36030001,206138}]'),(121,881,900,3,'[{5,36060001,163938350},{3,36030001,1603292}]','[{5,36060001,70259293},{3,36030001,687125}]','[{5,36060001,35129647},{3,36030001,343563}]','[{5,36060001,21077788},{3,36030001,206138}]'),(122,901,920,3,'[{5,36060001,163938350},{3,36030001,1603292}]','[{5,36060001,70259293},{3,36030001,687125}]','[{5,36060001,35129647},{3,36030001,343563}]','[{5,36060001,21077788},{3,36030001,206138}]'),(123,921,940,3,'[{5,36060001,163938350},{3,36030001,1603292}]','[{5,36060001,70259293},{3,36030001,687125}]','[{5,36060001,35129647},{3,36030001,343563}]','[{5,36060001,21077788},{3,36030001,206138}]'),(124,941,960,3,'[{5,36060001,163938350},{3,36030001,1603292}]','[{5,36060001,70259293},{3,36030001,687125}]','[{5,36060001,35129647},{3,36030001,343563}]','[{5,36060001,21077788},{3,36030001,206138}]'),(125,961,980,3,'[{5,36060001,163938350},{3,36030001,1603292}]','[{5,36060001,70259293},{3,36030001,687125}]','[{5,36060001,35129647},{3,36030001,343563}]','[{5,36060001,21077788},{3,36030001,206138}]'),(126,981,1000,3,'[{5,36060001,163938350},{3,36030001,1603292}]','[{5,36060001,70259293},{3,36030001,687125}]','[{5,36060001,35129647},{3,36030001,343563}]','[{5,36060001,21077788},{3,36030001,206138}]'),(127,1,190,4,'[{5,36060001,4129761},{3,36030001,24958}]','[{5,36060001,1769898},{3,36030001,10696}]','[{5,36060001,884949},{3,36030001,5348}]','[{5,36060001,530969},{3,36030001,3209}]'),(128,191,200,4,'[{5,36060001,4129761},{3,36030001,26125}]','[{5,36060001,1769898},{3,36030001,11196}]','[{5,36060001,884949},{3,36030001,5598}]','[{5,36060001,530969},{3,36030001,3359}]'),(129,201,220,4,'[{5,36060001,4568661},{3,36030001,28458}]','[{5,36060001,1957998},{3,36030001,12196}]','[{5,36060001,978999},{3,36030001,6098}]','[{5,36060001,587399},{3,36030001,3659}]'),(130,221,240,4,'[{5,36060001,5512961},{3,36030001,30792}]','[{5,36060001,2362698},{3,36030001,13196}]','[{5,36060001,1181349},{3,36030001,6598}]','[{5,36060001,708809},{3,36030001,3959}]'),(131,241,260,4,'[{5,36060001,6819768},{3,36030001,33125}]','[{5,36060001,2922758},{3,36030001,14196}]','[{5,36060001,1461379},{3,36030001,7098}]','[{5,36060001,876827},{3,36030001,4259}]'),(132,261,280,4,'[{5,36060001,7380585},{3,36030001,51875}]','[{5,36060001,3163108},{3,36030001,22232}]','[{5,36060001,1581554},{3,36030001,11116}]','[{5,36060001,948932},{3,36030001,6670}]'),(133,281,300,4,'[{5,36060001,7681132},{3,36030001,70875}]','[{5,36060001,3291914},{3,36030001,30375}]','[{5,36060001,1645957},{3,36030001,15188}]','[{5,36060001,987574},{3,36030001,9113}]'),(134,301,320,4,'[{5,36060001,8261392},{3,36030001,80500}]','[{5,36060001,3540596},{3,36030001,34500}]','[{5,36060001,1770298},{3,36030001,17250}]','[{5,36060001,1062179},{3,36030001,10350}]'),(135,321,340,4,'[{5,36060001,8720138},{3,36030001,86209}]','[{5,36060001,3737202},{3,36030001,36947}]','[{5,36060001,1868601},{3,36030001,18473}]','[{5,36060001,1121161},{3,36030001,11084}]'),(136,341,360,4,'[{5,36060001,9283104},{3,36030001,92050}]','[{5,36060001,3978473},{3,36030001,39450}]','[{5,36060001,1989237},{3,36030001,19725}]','[{5,36060001,1193542},{3,36030001,11835}]'),(137,361,380,4,'[{5,36060001,10634756},{3,36030001,107851}]','[{5,36060001,4557753},{3,36030001,46222}]','[{5,36060001,2278876},{3,36030001,23111}]','[{5,36060001,1367326},{3,36030001,13867}]'),(138,381,400,4,'[{5,36060001,20276207},{3,36030001,122252}]','[{5,36060001,8689803},{3,36030001,52394}]','[{5,36060001,4344902},{3,36030001,26197}]','[{5,36060001,2606941},{3,36030001,15718}]'),(139,401,420,4,'[{5,36060001,24709541},{3,36030001,138841}]','[{5,36060001,10589803},{3,36030001,59503}]','[{5,36060001,5294902},{3,36030001,29752}]','[{5,36060001,3176941},{3,36030001,17851}]'),(140,421,440,4,'[{5,36060001,29142874},{3,36030001,157617}]','[{5,36060001,12489803},{3,36030001,67550}]','[{5,36060001,6244902},{3,36030001,33775}]','[{5,36060001,3746941},{3,36030001,20265}]'),(141,441,460,4,'[{5,36060001,33411530},{3,36030001,185675}]','[{5,36060001,14319227},{3,36030001,79575}]','[{5,36060001,7159614},{3,36030001,39788}]','[{5,36060001,4295768},{3,36030001,23873}]'),(142,461,480,4,'[{5,36060001,42717610},{3,36030001,218378}]','[{5,36060001,18307547},{3,36030001,93591}]','[{5,36060001,9153774},{3,36030001,46795}]','[{5,36060001,5492264},{3,36030001,28077}]'),(143,481,500,4,'[{5,36060001,48290905},{3,36030001,256506}]','[{5,36060001,20696102},{3,36030001,109931}]','[{5,36060001,10348051},{3,36030001,54966}]','[{5,36060001,6208831},{3,36030001,32979}]'),(144,501,520,4,'[{5,36060001,51615905},{3,36030001,297336}]','[{5,36060001,22121102},{3,36030001,127430}]','[{5,36060001,11060551},{3,36030001,63715}]','[{5,36060001,6636331},{3,36030001,38229}]'),(145,521,540,4,'[{5,36060001,59259013},{3,36030001,352658}]','[{5,36060001,25396720},{3,36030001,151139}]','[{5,36060001,12698360},{3,36030001,75570}]','[{5,36060001,7619016},{3,36030001,45342}]'),(146,541,560,4,'[{5,36060001,77303418},{3,36030001,429669}]','[{5,36060001,33130036},{3,36030001,184144}]','[{5,36060001,16565018},{3,36030001,92072}]','[{5,36060001,9939011},{3,36030001,55243}]'),(147,561,580,4,'[{5,36060001,94759354},{3,36030001,513669}]','[{5,36060001,40611152},{3,36030001,220144}]','[{5,36060001,20305576},{3,36030001,110072}]','[{5,36060001,12183345},{3,36030001,66043}]'),(148,581,600,4,'[{5,36060001,103626020},{3,36030001,606419}]','[{5,36060001,44411152},{3,36030001,259894}]','[{5,36060001,22205576},{3,36030001,129947}]','[{5,36060001,13323345},{3,36030001,77968}]'),(149,601,620,4,'[{5,36060001,112492687},{3,36030001,707919}]','[{5,36060001,48211152},{3,36030001,303394}]','[{5,36060001,24105576},{3,36030001,151697}]','[{5,36060001,14463345},{3,36030001,91018}]'),(150,621,640,4,'[{5,36060001,121359354},{3,36030001,818169}]','[{5,36060001,52011152},{3,36030001,350644}]','[{5,36060001,26005576},{3,36030001,175322}]','[{5,36060001,15603345},{3,36030001,105193}]'),(151,641,660,4,'[{5,36060001,130226020},{3,36030001,937169}]','[{5,36060001,55811152},{3,36030001,401644}]','[{5,36060001,27905576},{3,36030001,200822}]','[{5,36060001,16743345},{3,36030001,120493}]'),(152,661,680,4,'[{5,36060001,139092687},{3,36030001,1064919}]','[{5,36060001,59611152},{3,36030001,456394}]','[{5,36060001,29805576},{3,36030001,228197}]','[{5,36060001,17883345},{3,36030001,136918}]'),(153,681,700,4,'[{5,36060001,147959354},{3,36030001,1201419}]','[{5,36060001,63411152},{3,36030001,514894}]','[{5,36060001,31705576},{3,36030001,257447}]','[{5,36060001,19023345},{3,36030001,154468}]'),(154,701,720,4,'[{5,36060001,156826020},{3,36030001,1346669}]','[{5,36060001,67211152},{3,36030001,577144}]','[{5,36060001,33605576},{3,36030001,288572}]','[{5,36060001,20163345},{3,36030001,173143}]'),(155,721,740,4,'[{5,36060001,165692687},{3,36030001,1500669}]','[{5,36060001,71011152},{3,36030001,643144}]','[{5,36060001,35505576},{3,36030001,321572}]','[{5,36060001,21303345},{3,36030001,192943}]'),(156,741,760,4,'[{5,36060001,174559354},{3,36030001,1663419}]','[{5,36060001,74811152},{3,36030001,712894}]','[{5,36060001,37405576},{3,36030001,356447}]','[{5,36060001,22443345},{3,36030001,213868}]'),(157,761,780,4,'[{5,36060001,183426020},{3,36030001,1834919}]','[{5,36060001,78611152},{3,36030001,786394}]','[{5,36060001,39305576},{3,36030001,393197}]','[{5,36060001,23583345},{3,36030001,235918}]'),(158,781,800,4,'[{5,36060001,192292687},{3,36030001,1923950}]','[{5,36060001,82411152},{3,36030001,824550}]','[{5,36060001,41205576},{3,36030001,412275}]','[{5,36060001,24723345},{3,36030001,247365}]'),(159,801,820,4,'[{5,36060001,196726020},{3,36030001,1923950}]','[{5,36060001,84311152},{3,36030001,824550}]','[{5,36060001,42155576},{3,36030001,412275}]','[{5,36060001,25293345},{3,36030001,247365}]'),(160,821,840,4,'[{5,36060001,196726020},{3,36030001,1923950}]','[{5,36060001,84311152},{3,36030001,824550}]','[{5,36060001,42155576},{3,36030001,412275}]','[{5,36060001,25293345},{3,36030001,247365}]'),(161,841,860,4,'[{5,36060001,196726020},{3,36030001,1923950}]','[{5,36060001,84311152},{3,36030001,824550}]','[{5,36060001,42155576},{3,36030001,412275}]','[{5,36060001,25293345},{3,36030001,247365}]'),(162,861,880,4,'[{5,36060001,196726020},{3,36030001,1923950}]','[{5,36060001,84311152},{3,36030001,824550}]','[{5,36060001,42155576},{3,36030001,412275}]','[{5,36060001,25293345},{3,36030001,247365}]'),(163,881,900,4,'[{5,36060001,196726020},{3,36030001,1923950}]','[{5,36060001,84311152},{3,36030001,824550}]','[{5,36060001,42155576},{3,36030001,412275}]','[{5,36060001,25293345},{3,36030001,247365}]'),(164,901,920,4,'[{5,36060001,196726020},{3,36030001,1923950}]','[{5,36060001,84311152},{3,36030001,824550}]','[{5,36060001,42155576},{3,36030001,412275}]','[{5,36060001,25293345},{3,36030001,247365}]'),(165,921,940,4,'[{5,36060001,196726020},{3,36030001,1923950}]','[{5,36060001,84311152},{3,36030001,824550}]','[{5,36060001,42155576},{3,36030001,412275}]','[{5,36060001,25293345},{3,36030001,247365}]'),(166,941,960,4,'[{5,36060001,196726020},{3,36030001,1923950}]','[{5,36060001,84311152},{3,36030001,824550}]','[{5,36060001,42155576},{3,36030001,412275}]','[{5,36060001,25293345},{3,36030001,247365}]'),(167,961,980,4,'[{5,36060001,196726020},{3,36030001,1923950}]','[{5,36060001,84311152},{3,36030001,824550}]','[{5,36060001,42155576},{3,36030001,412275}]','[{5,36060001,25293345},{3,36030001,247365}]'),(168,981,1000,4,'[{5,36060001,196726020},{3,36030001,1923950}]','[{5,36060001,84311152},{3,36030001,824550}]','[{5,36060001,42155576},{3,36030001,412275}]','[{5,36060001,25293345},{3,36030001,247365}]');
/*!40000 ALTER TABLE `base_husong_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_improve_activityhall`
--

DROP TABLE IF EXISTS `base_improve_activityhall`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_improve_activityhall` (
  `adate` varchar(25) NOT NULL COMMENT '开放日期',
  `atime` varchar(25) NOT NULL COMMENT '开放时间',
  `asort` tinyint(3) unsigned NOT NULL COMMENT '排序值',
  `str_id` varchar(100) NOT NULL COMMENT '功能ID',
  PRIMARY KEY (`asort`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='我要变强活动时间表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_improve_activityhall`
--

LOCK TABLES `base_improve_activityhall` WRITE;
/*!40000 ALTER TABLE `base_improve_activityhall` DISABLE KEYS */;
INSERT INTO `base_improve_activityhall` VALUES ('{1,2,3,4,5,6,7}','[{12,00,00},{12,08,00}]',1,'quiz'),('{1,3,5,7}','[{20,00,00},{20,30,00}]',2,'guildfire'),('{1,2,3,4,5,6,7}','[{15,00,00},{15,30,00}]',3,'angel');
/*!40000 ALTER TABLE `base_improve_activityhall` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_improve_constant`
--

DROP TABLE IF EXISTS `base_improve_constant`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_improve_constant` (
  `id` int(10) unsigned NOT NULL COMMENT '编号',
  `key` varchar(215) NOT NULL COMMENT '键',
  `value` varchar(512) NOT NULL COMMENT '值',
  `note` varchar(512) NOT NULL COMMENT '备注@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='我要变强-常量表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_improve_constant`
--

LOCK TABLES `base_improve_constant` WRITE;
/*!40000 ALTER TABLE `base_improve_constant` DISABLE KEYS */;
INSERT INTO `base_improve_constant` VALUES (1,'score_percent','[{1,60},{2,75},{3,90},{4,100}]','变强途径评级百分比');
/*!40000 ALTER TABLE `base_improve_constant` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_improve_fight_condition`
--

DROP TABLE IF EXISTS `base_improve_fight_condition`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_improve_fight_condition` (
  `id` tinyint(3) unsigned NOT NULL COMMENT '评级ID',
  `condition` tinyint(3) unsigned NOT NULL COMMENT '评级标准',
  `icon` tinyint(3) unsigned NOT NULL COMMENT '评级',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='我要变强评级表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_improve_fight_condition`
--

LOCK TABLES `base_improve_fight_condition` WRITE;
/*!40000 ALTER TABLE `base_improve_fight_condition` DISABLE KEYS */;
INSERT INTO `base_improve_fight_condition` VALUES (1,200,1),(2,180,2),(3,160,3),(4,140,4),(5,120,5),(6,100,6),(7,80,7);
/*!40000 ALTER TABLE `base_improve_fight_condition` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_improve_fight_num`
--

DROP TABLE IF EXISTS `base_improve_fight_num`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_improve_fight_num` (
  `lv_min` smallint(5) unsigned NOT NULL COMMENT '最低等级',
  `lv_max` smallint(5) unsigned NOT NULL COMMENT '最高等级',
  `fight_num` mediumint(8) unsigned NOT NULL COMMENT '推荐战斗力',
  PRIMARY KEY (`lv_min`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='我要变强推荐战斗力表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_improve_fight_num`
--

LOCK TABLES `base_improve_fight_num` WRITE;
/*!40000 ALTER TABLE `base_improve_fight_num` DISABLE KEYS */;
INSERT INTO `base_improve_fight_num` VALUES (0,49,51408),(50,99,126980),(100,149,165377),(150,199,315808),(200,249,608008),(250,299,898764),(300,349,1149059),(350,399,1398529),(400,449,1963245),(450,499,2534395),(500,519,2902585),(520,539,3278129),(540,559,3785428),(560,579,4453761),(580,599,5122095),(600,619,5977604),(620,639,6842965),(640,659,7991865),(660,679,9487313),(680,699,10982762),(700,719,12704641),(720,739,14438438),(740,759,16116226),(760,779,16777215),(780,799,16777215),(800,819,16777215),(820,839,16777215),(840,859,16777215),(860,879,16777215),(880,899,16777215),(900,919,16777215),(920,939,16777215),(940,959,16777215),(960,979,16777215),(980,1000,16777215);
/*!40000 ALTER TABLE `base_improve_fight_num` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_improve_fight_task`
--

DROP TABLE IF EXISTS `base_improve_fight_task`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_improve_fight_task` (
  `id` smallint(5) unsigned NOT NULL COMMENT 'ID',
  `page_id` smallint(5) unsigned NOT NULL COMMENT '页码ID',
  `sort_id` smallint(5) unsigned NOT NULL COMMENT '排序ID',
  `lv_min` smallint(5) unsigned NOT NULL COMMENT '最低等级',
  `lv_max` smallint(5) unsigned NOT NULL COMMENT '最高等级',
  `max_num` int(15) unsigned NOT NULL COMMENT '进度条最大值',
  `task_name` varchar(255) NOT NULL COMMENT '任务名称@lang@',
  `task_des` varchar(255) NOT NULL COMMENT '任务描述@lang@',
  `task_nonopen` varchar(255) NOT NULL COMMENT '任务未开启描述@lang@',
  `task_lv` smallint(5) unsigned NOT NULL COMMENT '任务等级',
  `tagplace` smallint(5) unsigned NOT NULL COMMENT '标签位置',
  `sub_tag` smallint(5) unsigned NOT NULL COMMENT '跳转标记',
  `icon` varchar(255) NOT NULL COMMENT '图标资源',
  `condition` varchar(255) NOT NULL COMMENT '触发条件',
  `process_des` varchar(1024) NOT NULL COMMENT '进度描述@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='我要变强标签表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_improve_fight_task`
--

LOCK TABLES `base_improve_fight_task` WRITE;
/*!40000 ALTER TABLE `base_improve_fight_task` DISABLE KEYS */;
INSERT INTO `base_improve_fight_task` VALUES (1,1,1,1,99,46880,'装备替换','装备评分提升','该功能尚未开启',0,152,6,'icon_29_bb','level_1','目标:全身1阶橙1星'),(2,1,1,100,199,63350,'装备替换','装备评分提升','该功能尚未开启',0,152,6,'icon_29_bb','level_1','目标:全身2阶红1星'),(3,1,1,200,299,125258,'装备替换','装备评分提升','该功能尚未开启',0,152,6,'icon_29_bb','level_1','目标:全身3阶红3星'),(4,1,1,300,399,235690,'装备替换','装备评分提升','该功能尚未开启',0,152,6,'icon_29_bb','level_1','目标:全身4阶红3星'),(5,1,1,400,499,522420,'装备替换','装备评分提升','该功能尚未开启',0,152,6,'icon_29_bb','level_1','目标:全身5阶红3星'),(6,1,1,500,549,732680,'装备替换','装备评分提升','该功能尚未开启',0,152,6,'icon_29_bb','level_1','目标:全身6阶红3星'),(7,1,1,550,599,1035520,'装备替换','装备评分提升','该功能尚未开启',0,152,6,'icon_29_bb','level_1','目标:全身7阶红3星'),(8,1,1,600,649,1465970,'装备替换','装备评分提升','该功能尚未开启',0,152,6,'icon_29_bb','level_1','目标:全身8阶红3星'),(9,1,1,650,699,2049200,'装备替换','装备评分提升','该功能尚未开启',0,152,6,'icon_29_bb','level_1','目标:全身9阶红3星'),(10,1,1,700,749,2837890,'装备替换','装备评分提升','该功能尚未开启',0,152,6,'icon_29_bb','level_1','目标:全身10阶红3星'),(11,1,1,750,799,3898310,'装备替换','装备评分提升','该功能尚未开启',0,152,6,'icon_29_bb','level_1','目标:全身11阶红3星'),(12,1,1,800,849,5311300,'装备替换','装备评分提升','该功能尚未开启',0,152,6,'icon_29_bb','level_1','目标:全身12阶红3星'),(13,1,1,850,899,7289810,'装备替换','装备评分提升','该功能尚未开启',0,152,6,'icon_29_bb','level_1','目标:全身13阶红3星'),(14,1,1,900,949,9899300,'装备替换','装备评分提升','该功能尚未开启',0,152,6,'icon_29_bb','level_1','目标:全身14阶红3星'),(15,1,1,950,1000,13344400,'装备替换','装备评分提升','该功能尚未开启',0,152,6,'icon_29_bb','level_1','目标:全身15阶红3星'),(16,1,2,1,99,10,'装备强化','主角装备提升','该功能尚未开启',0,152,1,'icon_20_dz','level_65','10级'),(17,1,2,100,199,15,'装备强化','主角装备提升','该功能尚未开启',0,152,1,'icon_20_dz','level_65','15级'),(18,1,2,200,299,35,'装备强化','主角装备提升','该功能尚未开启',0,152,1,'icon_20_dz','level_100','35级'),(19,1,2,300,399,55,'装备强化','主角装备提升','该功能尚未开启',0,152,1,'icon_20_dz','level_100','55级'),(20,1,2,400,499,75,'装备强化','主角装备提升','该功能尚未开启',0,152,1,'icon_20_dz','level_100','75级'),(21,1,2,500,549,95,'装备强化','主角装备提升','该功能尚未开启',0,152,1,'icon_20_dz','level_100','95级'),(22,1,2,550,599,115,'装备强化','主角装备提升','该功能尚未开启',0,152,1,'icon_20_dz','level_100','115级'),(23,1,2,600,649,140,'装备强化','主角装备提升','该功能尚未开启',0,152,1,'icon_20_dz','level_100','140级'),(24,1,2,650,699,175,'装备强化','主角装备提升','该功能尚未开启',0,152,1,'icon_20_dz','level_100','175级'),(25,1,2,700,749,225,'装备强化','主角装备提升','该功能尚未开启',0,152,1,'icon_20_dz','level_100','225级'),(26,1,2,750,799,275,'装备强化','主角装备提升','该功能尚未开启',0,152,1,'icon_20_dz','level_100','275级'),(27,1,2,800,849,330,'装备强化','主角装备提升','该功能尚未开启',0,152,1,'icon_20_dz','level_100','330级'),(28,1,2,850,899,380,'装备强化','主角装备提升','该功能尚未开启',0,152,1,'icon_20_dz','level_100','380级'),(29,1,2,900,949,440,'装备强化','主角装备提升','该功能尚未开启',0,152,1,'icon_20_dz','level_100','440级'),(30,1,2,950,1000,500,'装备强化','主角装备提升','该功能尚未开启',0,152,1,'icon_20_dz','level_100','500级'),(31,1,3,1,99,2,'坐骑升阶','坐骑等阶提升','该功能尚未开启',0,160,1,'icon_27_zq','level_30','1阶2星'),(32,1,3,100,199,4,'坐骑升阶','坐骑等阶提升','该功能尚未开启',0,160,1,'icon_27_zq','level_30','1阶4星'),(33,1,3,200,299,10,'坐骑升阶','坐骑等阶提升','该功能尚未开启',0,160,1,'icon_27_zq','level_30','1阶10星'),(34,1,3,300,399,16,'坐骑升阶','坐骑等阶提升','该功能尚未开启',0,160,1,'icon_27_zq','level_30','2阶6星'),(35,1,3,400,499,21,'坐骑升阶','坐骑等阶提升','该功能尚未开启',0,160,1,'icon_27_zq','level_30','3阶1星'),(36,1,3,500,549,26,'坐骑升阶','坐骑等阶提升','该功能尚未开启',0,160,1,'icon_27_zq','level_30','3阶6星'),(37,1,3,550,599,32,'坐骑升阶','坐骑等阶提升','该功能尚未开启',0,160,1,'icon_27_zq','level_30','4阶2星'),(38,1,3,600,649,38,'坐骑升阶','坐骑等阶提升','该功能尚未开启',0,160,1,'icon_27_zq','level_30','4阶8星'),(39,1,3,650,699,44,'坐骑升阶','坐骑等阶提升','该功能尚未开启',0,160,1,'icon_27_zq','level_30','5阶4星'),(40,1,3,700,749,48,'坐骑升阶','坐骑等阶提升','该功能尚未开启',0,160,1,'icon_27_zq','level_30','5阶8星'),(41,1,3,750,799,51,'坐骑升阶','坐骑等阶提升','该功能尚未开启',0,160,1,'icon_27_zq','level_30','6阶1星'),(42,1,3,800,849,54,'坐骑升阶','坐骑等阶提升','该功能尚未开启',0,160,1,'icon_27_zq','level_30','6阶4星'),(43,1,3,850,899,57,'坐骑升阶','坐骑等阶提升','该功能尚未开启',0,160,1,'icon_27_zq','level_30','6阶7星'),(44,1,3,900,949,60,'坐骑升阶','坐骑等阶提升','该功能尚未开启',0,160,1,'icon_27_zq','level_30','6阶10星'),(45,1,3,950,1000,62,'坐骑升阶','坐骑等阶提升','该功能尚未开启',0,160,1,'icon_27_zq','level_30','7阶2星'),(46,1,4,1,99,10,'套装合成','强力套装合成','该功能尚未开启',0,152,7,'icon_98_zbhc','level_400','无'),(47,1,4,100,199,20,'套装合成','强力套装合成','该功能尚未开启',0,152,7,'icon_98_zbhc','level_400','无'),(48,1,4,200,299,30,'套装合成','强力套装合成','该功能尚未开启',0,152,7,'icon_98_zbhc','level_400','无'),(49,1,4,300,399,40,'套装合成','强力套装合成','该功能尚未开启',0,152,7,'icon_98_zbhc','level_400','无'),(50,1,4,400,499,50,'套装合成','强力套装合成','该功能尚未开启',0,152,7,'icon_98_zbhc','level_400','目标:全套5阶霸者套装'),(51,1,4,500,549,60,'套装合成','强力套装合成','该功能尚未开启',0,152,7,'icon_98_zbhc','level_400','目标:全套6阶霸者套装'),(52,1,4,550,599,70,'套装合成','强力套装合成','该功能尚未开启',0,152,7,'icon_98_zbhc','level_400','目标:全套7阶霸者套装'),(53,1,4,600,649,80,'套装合成','强力套装合成','该功能尚未开启',0,152,7,'icon_98_zbhc','level_400','目标:全套8阶霸者套装'),(54,1,4,650,699,90,'套装合成','强力套装合成','该功能尚未开启',0,152,7,'icon_98_zbhc','level_400','目标:全套9阶霸者套装'),(55,1,4,700,749,100,'套装合成','强力套装合成','该功能尚未开启',0,152,7,'icon_98_zbhc','level_400','目标:全套10阶霸者套装'),(56,1,4,750,799,110,'套装合成','强力套装合成','该功能尚未开启',0,152,7,'icon_98_zbhc','level_400','目标:全套11阶霸者套装'),(57,1,4,800,849,120,'套装合成','强力套装合成','该功能尚未开启',0,152,7,'icon_98_zbhc','level_400','目标:全套12阶霸者套装'),(58,1,4,850,899,130,'套装合成','强力套装合成','该功能尚未开启',0,152,7,'icon_98_zbhc','level_400','目标:全套13阶霸者套装'),(59,1,4,900,949,140,'套装合成','强力套装合成','该功能尚未开启',0,152,7,'icon_98_zbhc','level_400','目标:全套14阶霸者套装'),(60,1,4,950,1000,150,'套装合成','强力套装合成','该功能尚未开启',0,152,7,'icon_98_zbhc','level_400','目标:全套15阶霸者套装'),(61,1,5,1,99,2,'星灵提升','星灵战力提升','该功能尚未开启',0,430,1,'icon_26_xl','level_80','1阶2星'),(62,1,5,100,199,5,'星灵提升','星灵战力提升','该功能尚未开启',0,430,1,'icon_26_xl','level_80','2阶1星'),(63,1,5,200,299,13,'星灵提升','星灵战力提升','该功能尚未开启',0,430,1,'icon_26_xl','level_80','4阶1星'),(64,1,5,300,399,20,'星灵提升','星灵战力提升','该功能尚未开启',0,430,1,'icon_26_xl','level_80','6阶0星'),(65,1,5,400,499,27,'星灵提升','星灵战力提升','该功能尚未开启',0,430,1,'icon_26_xl','level_80','7阶3星'),(66,1,5,500,549,32,'星灵提升','星灵战力提升','该功能尚未开启',0,430,1,'icon_26_xl','level_80','9阶0星'),(67,1,5,550,599,39,'星灵提升','星灵战力提升','该功能尚未开启',0,430,1,'icon_26_xl','level_80','10阶3星'),(68,1,5,600,649,49,'星灵提升','星灵战力提升','该功能尚未开启',0,430,1,'icon_26_xl','level_80','13阶1星'),(69,1,5,650,699,62,'星灵提升','星灵战力提升','该功能尚未开启',0,430,1,'icon_26_xl','level_80','16阶2星'),(70,1,5,700,749,74,'星灵提升','星灵战力提升','该功能尚未开启',0,430,1,'icon_26_xl','level_80','19阶2星'),(71,1,5,750,799,83,'星灵提升','星灵战力提升','该功能尚未开启',0,430,1,'icon_26_xl','level_80','21阶3星'),(72,1,5,800,849,90,'星灵提升','星灵战力提升','该功能尚未开启',0,430,1,'icon_26_xl','level_80','23阶2星'),(73,1,5,850,899,101,'星灵提升','星灵战力提升','该功能尚未开启',0,430,1,'icon_26_xl','level_80','26阶1星'),(74,1,5,900,949,111,'星灵提升','星灵战力提升','该功能尚未开启',0,430,1,'icon_26_xl','level_80','28阶3星'),(75,1,5,950,1000,119,'星灵提升','星灵战力提升','该功能尚未开启',0,430,1,'icon_26_xl','level_80','30阶3星'),(76,1,6,1,99,3,'圣灵强化','星灵战力提升','该功能尚未开启',0,428,1,'icon_31_sl','level_50','3级'),(77,1,6,100,199,8,'圣灵强化','星灵战力提升','该功能尚未开启',0,428,1,'icon_31_sl','level_50','8级'),(78,1,6,200,299,16,'圣灵强化','星灵战力提升','该功能尚未开启',0,428,1,'icon_31_sl','level_50','16级'),(79,1,6,300,399,24,'圣灵强化','星灵战力提升','该功能尚未开启',0,428,1,'icon_31_sl','level_50','24级'),(80,1,6,400,499,33,'圣灵强化','星灵战力提升','该功能尚未开启',0,428,1,'icon_31_sl','level_50','33级'),(81,1,6,500,549,39,'圣灵强化','星灵战力提升','该功能尚未开启',0,428,1,'icon_31_sl','level_50','39级'),(82,1,6,550,599,48,'圣灵强化','星灵战力提升','该功能尚未开启',0,428,1,'icon_31_sl','level_50','48级'),(83,1,6,600,649,60,'圣灵强化','星灵战力提升','该功能尚未开启',0,428,1,'icon_31_sl','level_50','60级'),(84,1,6,650,699,77,'圣灵强化','星灵战力提升','该功能尚未开启',0,428,1,'icon_31_sl','level_50','77级'),(85,1,6,700,749,90,'圣灵强化','星灵战力提升','该功能尚未开启',0,428,1,'icon_31_sl','level_50','90级'),(86,1,6,750,799,100,'圣灵强化','星灵战力提升','该功能尚未开启',0,428,1,'icon_31_sl','level_50','100级'),(87,1,6,800,849,108,'圣灵强化','星灵战力提升','该功能尚未开启',0,428,1,'icon_31_sl','level_50','108级'),(88,1,6,850,899,120,'圣灵强化','星灵战力提升','该功能尚未开启',0,428,1,'icon_31_sl','level_50','120级'),(89,1,6,900,949,131,'圣灵强化','星灵战力提升','该功能尚未开启',0,428,1,'icon_31_sl','level_50','131级'),(90,1,6,950,1000,140,'圣灵强化','星灵战力提升','该功能尚未开启',0,428,1,'icon_31_sl','level_50','140级'),(91,1,7,1,99,1,'降神进阶','降神战力提升','该功能尚未开启',0,440,1,'icon_38_sj','level_25','1阶1星'),(92,1,7,100,199,7,'降神进阶','降神战力提升','该功能尚未开启',0,440,1,'icon_38_sj','level_25','2阶1星'),(93,1,7,200,299,15,'降神进阶','降神战力提升','该功能尚未开启',0,440,1,'icon_38_sj','level_25','3阶3星'),(94,1,7,300,399,26,'降神进阶','降神战力提升','该功能尚未开启',0,440,1,'icon_38_sj','level_25','5阶2星'),(95,1,7,400,499,38,'降神进阶','降神战力提升','该功能尚未开启',0,440,1,'icon_38_sj','level_25','7阶2星'),(96,1,7,500,549,46,'降神进阶','降神战力提升','该功能尚未开启',0,440,1,'icon_38_sj','level_25','8阶4星'),(97,1,7,550,599,56,'降神进阶','降神战力提升','该功能尚未开启',0,440,1,'icon_38_sj','level_25','10阶2星'),(98,1,7,600,649,69,'降神进阶','降神战力提升','该功能尚未开启',0,440,1,'icon_38_sj','level_25','12阶3星'),(99,1,7,650,699,85,'降神进阶','降神战力提升','该功能尚未开启',0,440,1,'icon_38_sj','level_25','15阶1星'),(100,1,7,700,749,99,'降神进阶','降神战力提升','该功能尚未开启',0,440,1,'icon_38_sj','level_25','17阶3星'),(101,1,7,750,799,108,'降神进阶','降神战力提升','该功能尚未开启',0,440,1,'icon_38_sj','level_25','19阶0星'),(102,1,7,800,849,116,'降神进阶','降神战力提升','该功能尚未开启',0,440,1,'icon_38_sj','level_25','20阶2星'),(103,1,7,850,899,127,'降神进阶','降神战力提升','该功能尚未开启',0,440,1,'icon_38_sj','level_25','22阶1星'),(104,1,7,900,949,138,'降神进阶','降神战力提升','该功能尚未开启',0,440,1,'icon_38_sj','level_25','24阶0星'),(105,1,7,950,1000,147,'降神进阶','降神战力提升','该功能尚未开启',0,440,1,'icon_38_sj','level_25','25阶3星'),(106,1,8,1,99,5,'宝石镶嵌','宝石镶嵌提升','该功能尚未开启',0,152,4,'icon_24_bs','level_110','5级'),(107,1,8,100,199,10,'宝石镶嵌','宝石镶嵌提升','该功能尚未开启',0,152,4,'icon_24_bs','level_110','10级'),(108,1,8,200,299,30,'宝石镶嵌','宝石镶嵌提升','该功能尚未开启',0,152,4,'icon_24_bs','level_110','30级'),(109,1,8,300,399,60,'宝石镶嵌','宝石镶嵌提升','该功能尚未开启',0,152,4,'icon_24_bs','level_110','60级'),(110,1,8,400,499,120,'宝石镶嵌','宝石镶嵌提升','该功能尚未开启',0,152,4,'icon_24_bs','level_110','120级'),(111,1,8,500,549,140,'宝石镶嵌','宝石镶嵌提升','该功能尚未开启',0,152,4,'icon_24_bs','level_110','140级'),(112,1,8,550,599,160,'宝石镶嵌','宝石镶嵌提升','该功能尚未开启',0,152,4,'icon_24_bs','level_110','160级'),(113,1,8,600,649,192,'宝石镶嵌','宝石镶嵌提升','该功能尚未开启',0,152,4,'icon_24_bs','level_110','192级'),(114,1,8,650,699,200,'宝石镶嵌','宝石镶嵌提升','该功能尚未开启',0,152,4,'icon_24_bs','level_110','200级'),(115,1,8,700,749,220,'宝石镶嵌','宝石镶嵌提升','该功能尚未开启',0,152,4,'icon_24_bs','level_110','220级'),(116,1,8,750,799,240,'宝石镶嵌','宝石镶嵌提升','该功能尚未开启',0,152,4,'icon_24_bs','level_110','240级'),(117,1,8,800,849,240,'宝石镶嵌','宝石镶嵌提升','该功能尚未开启',0,152,4,'icon_24_bs','level_110','240级'),(118,1,8,850,899,252,'宝石镶嵌','宝石镶嵌提升','该功能尚未开启',0,152,4,'icon_24_bs','level_110','252级'),(119,1,8,900,949,264,'宝石镶嵌','宝石镶嵌提升','该功能尚未开启',0,152,4,'icon_24_bs','level_110','264级'),(120,1,8,950,1000,280,'宝石镶嵌','宝石镶嵌提升','该功能尚未开启',0,152,4,'icon_24_bs','level_110','280级'),(121,1,9,1,99,4,'宝具升级','宝具战力提升','该功能尚未开启',0,168,1,'icon_34_bj','level_90','4级'),(122,1,9,100,199,8,'宝具升级','宝具战力提升','该功能尚未开启',0,168,1,'icon_34_bj','level_90','8级'),(123,1,9,200,299,16,'宝具升级','宝具战力提升','该功能尚未开启',0,168,1,'icon_34_bj','level_90','16级'),(124,1,9,300,399,27,'宝具升级','宝具战力提升','该功能尚未开启',0,168,1,'icon_34_bj','level_90','27级'),(125,1,9,400,499,40,'宝具升级','宝具战力提升','该功能尚未开启',0,168,1,'icon_34_bj','level_90','40级'),(126,1,9,500,549,53,'宝具升级','宝具战力提升','该功能尚未开启',0,168,1,'icon_34_bj','level_90','53级'),(127,1,9,550,599,66,'宝具升级','宝具战力提升','该功能尚未开启',0,168,1,'icon_34_bj','level_90','66级'),(128,1,9,600,649,86,'宝具升级','宝具战力提升','该功能尚未开启',0,168,1,'icon_34_bj','level_90','86级'),(129,1,9,650,699,109,'宝具升级','宝具战力提升','该功能尚未开启',0,168,1,'icon_34_bj','level_90','109级'),(130,1,9,700,749,128,'宝具升级','宝具战力提升','该功能尚未开启',0,168,1,'icon_34_bj','level_90','128级'),(131,1,9,750,799,144,'宝具升级','宝具战力提升','该功能尚未开启',0,168,1,'icon_34_bj','level_90','144级'),(132,1,9,800,849,156,'宝具升级','宝具战力提升','该功能尚未开启',0,168,1,'icon_34_bj','level_90','156级'),(133,1,9,850,899,174,'宝具升级','宝具战力提升','该功能尚未开启',0,168,1,'icon_34_bj','level_90','174级'),(134,1,9,900,949,190,'宝具升级','宝具战力提升','该功能尚未开启',0,168,1,'icon_34_bj','level_90','190级'),(135,1,9,950,1000,203,'宝具升级','宝具战力提升','该功能尚未开启',0,168,1,'icon_34_bj','level_90','203级'),(136,1,10,1,99,0,'坐骑装备','坐骑装备穿戴','该功能尚未开启',0,160,4,'icon_27_zq','level_520','无'),(137,1,10,100,199,0,'坐骑装备','坐骑装备穿戴','该功能尚未开启',0,160,4,'icon_27_zq','level_520','无'),(138,1,10,200,299,0,'坐骑装备','坐骑装备穿戴','该功能尚未开启',0,160,4,'icon_27_zq','level_520','无'),(139,1,10,300,399,0,'坐骑装备','坐骑装备穿戴','该功能尚未开启',0,160,4,'icon_27_zq','level_520','无'),(140,1,10,400,499,0,'坐骑装备','坐骑装备穿戴','该功能尚未开启',0,160,4,'icon_27_zq','level_520','无'),(141,1,10,500,549,0,'坐骑装备','坐骑装备穿戴','该功能尚未开启',0,160,4,'icon_27_zq','level_520','目标:全部绿5星装备'),(142,1,10,550,599,6793,'坐骑装备','坐骑装备穿戴','该功能尚未开启',0,160,4,'icon_27_zq','level_520','目标:全部蓝3星装备'),(143,1,10,600,649,18730,'坐骑装备','坐骑装备穿戴','该功能尚未开启',0,160,4,'icon_27_zq','level_520','目标:全部紫2星装备'),(144,1,10,650,699,65535,'坐骑装备','坐骑装备穿戴','该功能尚未开启',0,160,4,'icon_27_zq','level_520','目标:全部紫4星装备'),(145,1,10,700,749,65535,'坐骑装备','坐骑装备穿戴','该功能尚未开启',0,160,4,'icon_27_zq','level_520','目标:全部橙1星装备'),(146,1,10,750,799,65535,'坐骑装备','坐骑装备穿戴','该功能尚未开启',0,160,4,'icon_27_zq','level_520','目标:全部橙2星装备'),(147,1,10,800,849,65535,'坐骑装备','坐骑装备穿戴','该功能尚未开启',0,160,4,'icon_27_zq','level_520','目标:全部橙3星装备'),(148,1,10,850,899,65535,'坐骑装备','坐骑装备穿戴','该功能尚未开启',0,160,4,'icon_27_zq','level_520','目标:全部橙4星装备'),(149,1,10,900,949,65535,'坐骑装备','坐骑装备穿戴','该功能尚未开启',0,160,4,'icon_27_zq','level_520','目标:全部橙5星装备'),(150,1,10,950,1000,65535,'坐骑装备','坐骑装备穿戴','该功能尚未开启',0,160,4,'icon_27_zq','level_520','目标:全部红1星装备'),(151,1,11,1,99,1,'神格提升','神格称谓提升','该功能尚未开启',0,166,1,'icon_33_sg','level_120','凡人1'),(152,1,11,100,199,2,'神格提升','神格称谓提升','该功能尚未开启',0,166,1,'icon_33_sg','level_120','凡人2'),(153,1,11,200,299,5,'神格提升','神格称谓提升','该功能尚未开启',0,166,1,'icon_33_sg','level_120','凡人5'),(154,1,11,300,399,10,'神格提升','神格称谓提升','该功能尚未开启',0,166,1,'icon_33_sg','level_120','凡人10'),(155,1,11,400,499,18,'神格提升','神格称谓提升','该功能尚未开启',0,166,1,'icon_33_sg','level_120','先知8'),(156,1,11,500,549,24,'神格提升','神格称谓提升','该功能尚未开启',0,166,1,'icon_33_sg','level_120','圣人4'),(157,1,11,550,599,30,'神格提升','神格称谓提升','该功能尚未开启',0,166,1,'icon_33_sg','level_120','圣人10'),(158,1,11,600,649,38,'神格提升','神格称谓提升','该功能尚未开启',0,166,1,'icon_33_sg','level_120','主宰8'),(159,1,11,650,699,45,'神格提升','神格称谓提升','该功能尚未开启',0,166,1,'icon_33_sg','level_120','天启5'),(160,1,11,700,749,55,'神格提升','神格称谓提升','该功能尚未开启',0,166,1,'icon_33_sg','level_120','圣灵5'),(161,1,11,750,799,63,'神格提升','神格称谓提升','该功能尚未开启',0,166,1,'icon_33_sg','level_120','神子3'),(162,1,11,800,849,70,'神格提升','神格称谓提升','该功能尚未开启',0,166,1,'icon_33_sg','level_120','神子10'),(163,1,11,850,899,78,'神格提升','神格称谓提升','该功能尚未开启',0,166,1,'icon_33_sg','level_120','半神8'),(164,1,11,900,949,84,'神格提升','神格称谓提升','该功能尚未开启',0,166,1,'icon_33_sg','level_120','真神4'),(165,1,11,950,1000,90,'神格提升','神格称谓提升','该功能尚未开启',0,166,1,'icon_33_sg','level_120','真神10'),(166,2,1,105,1000,0,'装备副本','通关装备副本，获取大量装备','该功能尚未开启',3,610,11,'icon_55_zbfb','level_105',''),(167,2,2,180,1000,0,'世界首领','击败世界首领，获取大量装备','该功能尚未开启',5,460,0,'icon_86_sjsl','level_180',''),(168,2,3,95,1000,0,'原罪祭坛','击败原罪首领，获取大量装备','该功能尚未开启',5,460,1,'icon_59_yzjt','level_95',''),(169,2,4,180,1000,0,'首领狩猎','前往首领狩猎，获取大量装备','该功能尚未开启',4,460,2,'icon_59_yzjt','level_180',''),(170,2,5,125,1000,0,'秘境远征','进行秘境远征可以获得少量装备','该功能尚未开启',1,90,4,'icon_73_mjyz','level_180',''),(171,3,1,70,1000,0,'经验副本','参与经验副本，获取海量经验','该功能尚未开启',5,610,31,'icon_54_jjfb','level_70',''),(172,3,2,130,1000,0,'飞艇护送','参与飞艇护送，获取大量经验','该功能尚未开启',4,500,0,'icon_48_fths','level_130',''),(173,3,3,100,1000,0,'经验书馆','找到经验馆主，获取大量经验','该功能尚未开启',2,90,2,'icon_37_bz','level_100',''),(174,3,4,55,1000,0,'日常任务','完成每天日常任务，获取大量经验','该功能尚未开启',3,300,2,'icon_53_mrll','level_55',''),(175,3,5,155,1000,0,'公会任务','完成每天公会任务，获取大量经验','该功能尚未开启',3,300,3,'icon_49_ghrw','level_155',''),(176,4,1,55,1000,0,'日常任务','完成日常任务，获取大量金币','该功能尚未开启',4,300,2,'icon_53_mrll','level_55',''),(177,4,2,130,1000,0,'飞艇护送','参与飞艇护送，获取大量金币','该功能尚未开启',3,500,0,'icon_48_fths','level_130',''),(178,4,3,100,1000,0,'金币矿洞','监督金币旷工，获取大量金币','该功能尚未开启',5,90,3,'icon_37_bz','level_100',''),(179,4,4,1,1000,0,'装备出售','出售低战力装备，获得少量金币','该功能尚未开启',2,150,1,'icon_29_bb','level_1',''),(180,5,1,1,1000,0,'月卡投资','参与月卡投资，每日可领取大量绑钻哦','该功能尚未开启',5,159,5,'icon_62_cz','level_1',''),(181,5,2,1,1000,0,'投资计划','参与投资计划，达到对应等级可领取大量绑钻哦','该功能尚未开启',4,159,6,'icon_62_cz','level_1',''),(182,5,3,50,1000,0,'每日签到','每天进行签到，达到对应天数可获得绑钻奖励','该功能尚未开启',3,417,1,'icon_08_fl','level_50',''),(183,5,4,120,1000,0,'成就奖励','达成指定成就，可以获得少量绑钻','该功能尚未开启',2,409,0,'icon_01_cj','level_120','');
/*!40000 ALTER TABLE `base_improve_fight_task` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_improve_suit`
--

DROP TABLE IF EXISTS `base_improve_suit`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_improve_suit` (
  `suit_type` int(10) unsigned NOT NULL COMMENT '套装类型',
  `suit_lv` int(10) unsigned NOT NULL COMMENT '套装等级',
  `suit_stage` int(10) unsigned NOT NULL COMMENT '套装阶数',
  `point` int(10) unsigned NOT NULL COMMENT '积分转换',
  PRIMARY KEY (`suit_type`,`suit_lv`,`suit_stage`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='我要变强-套装积分转换表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_improve_suit`
--

LOCK TABLES `base_improve_suit` WRITE;
/*!40000 ALTER TABLE `base_improve_suit` DISABLE KEYS */;
INSERT INTO `base_improve_suit` VALUES (1,1,1,2),(1,1,2,5),(1,1,3,7),(1,1,4,11),(1,1,5,14),(1,1,6,17),(1,1,7,21),(1,1,8,24),(1,1,9,28),(1,1,10,32),(1,1,11,36),(1,1,12,39),(1,1,13,43),(1,1,14,47),(1,1,15,52),(1,2,1,4),(1,2,2,9),(1,2,3,15),(1,2,4,21),(1,2,5,28),(1,2,6,34),(1,2,7,41),(1,2,8,49),(1,2,9,56),(1,2,10,63),(1,2,11,71),(1,2,12,79),(1,2,13,87),(1,2,14,95),(1,2,15,103),(2,1,1,3),(2,1,2,7),(2,1,3,11),(2,1,4,16),(2,1,5,21),(2,1,6,26),(2,1,7,31),(2,1,8,36),(2,1,9,42),(2,1,10,48),(2,1,11,53),(2,1,12,59),(2,1,13,65),(2,1,14,71),(2,1,15,77),(2,2,1,6),(2,2,2,14),(2,2,3,22),(2,2,4,32),(2,2,5,41),(2,2,6,52),(2,2,7,62),(2,2,8,73),(2,2,9,84),(2,2,10,95),(2,2,11,107),(2,2,12,118),(2,2,13,130),(2,2,14,142),(2,2,15,155);
/*!40000 ALTER TABLE `base_improve_suit` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_intimacy`
--

DROP TABLE IF EXISTS `base_intimacy`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_intimacy` (
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `id` int(11) unsigned NOT NULL DEFAULT '0',
  `intimacy` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '亲密度',
  UNIQUE KEY `type` (`type`,`id`),
  KEY `intimacy` (`intimacy`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品亲密度';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_intimacy`
--

LOCK TABLES `base_intimacy` WRITE;
/*!40000 ALTER TABLE `base_intimacy` DISABLE KEYS */;
INSERT INTO `base_intimacy` VALUES (11,3001,5),(22,0,5),(23,0,5),(12,3001,10),(40,0,20),(50,0,20),(21,0,30),(100,0,30),(110,0,30),(20,0,36),(0,240101,50),(70,0,100),(111,0,111);
/*!40000 ALTER TABLE `base_intimacy` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_intimacy_lv`
--

DROP TABLE IF EXISTS `base_intimacy_lv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_intimacy_lv` (
  `lv` int(11) unsigned NOT NULL COMMENT '亲密度等级',
  `color` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '颜色',
  `name` varchar(255) NOT NULL COMMENT '亲密度名字',
  `intimacy` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '所需亲密度',
  `attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '属性加成',
  PRIMARY KEY (`lv`),
  KEY `name` (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='亲密度等级配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_intimacy_lv`
--

LOCK TABLES `base_intimacy_lv` WRITE;
/*!40000 ALTER TABLE `base_intimacy_lv` DISABLE KEYS */;
INSERT INTO `base_intimacy_lv` VALUES (1,0,'萍水相逢',0,'[]'),(2,1,'相见恨晚',999,'[{2,3000},{1,150}]'),(3,1,'志同道合',1999,'[{2,6000},{1,300}]'),(4,2,'患难与共',3344,'[{2,10000},{1,500}]'),(5,2,'义结金兰',5200,'[{2,15000},{1,750}]'),(6,2,'情深似海',9999,'[{2,20000},{1,1000}]'),(7,3,'肝胆相照',16920,'[{2,27000},{1,1350}]'),(8,3,'亲密无间',28920,'[{2,36000},{1,1800}]'),(9,3,'心有灵犀',49999,'[{2,50000},{1,2500}]'),(10,4,'心心相印',99999,'[{2,70000},{1,3500}]'),(11,4,'白首同归',199999,'[{2,100000},{1,5000}]');
/*!40000 ALTER TABLE `base_intimacy_lv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_intimacy_obtain`
--

DROP TABLE IF EXISTS `base_intimacy_obtain`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_intimacy_obtain` (
  `type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `trigger_obj` varchar(255) NOT NULL DEFAULT '0' COMMENT '触发对象',
  `intimacy` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '亲密度',
  `times` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '次数上限',
  PRIMARY KEY (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='亲密度获取途径配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_intimacy_obtain`
--

LOCK TABLES `base_intimacy_obtain` WRITE;
/*!40000 ALTER TABLE `base_intimacy_obtain` DISABLE KEYS */;
INSERT INTO `base_intimacy_obtain` VALUES (1,'[3110,3111,3112,3113,3114,3115,3116,3117,3118,3119,3120,3121,3122,3300,3301,3302,3303,3304,5200,5201,5202,60000,60001,60002,60003,60004]',5,10),(2,'[{0,3}]',5,3);
/*!40000 ALTER TABLE `base_intimacy_obtain` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_investment_item`
--

DROP TABLE IF EXISTS `base_investment_item`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_investment_item` (
  `type` tinyint(4) NOT NULL COMMENT '投资类型',
  `name` varchar(255) NOT NULL COMMENT '名字@lang@',
  `open_lv` smallint(5) unsigned NOT NULL COMMENT '开放等级',
  `reset_type` tinyint(3) unsigned NOT NULL COMMENT '重置类型',
  PRIMARY KEY (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='投资类型';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_investment_item`
--

LOCK TABLES `base_investment_item` WRITE;
/*!40000 ALTER TABLE `base_investment_item` DISABLE KEYS */;
INSERT INTO `base_investment_item` VALUES (1,'传奇计划',40,0),(2,'月卡',1,1),(3,'巅峰计划',560,0);
/*!40000 ALTER TABLE `base_investment_item` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_investment_rewards`
--

DROP TABLE IF EXISTS `base_investment_rewards`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_investment_rewards` (
  `type` int(10) unsigned NOT NULL COMMENT '投资类型',
  `level` smallint(5) unsigned NOT NULL COMMENT '档次',
  `id` int(10) unsigned NOT NULL COMMENT '奖励id',
  `rewards` varchar(1000) NOT NULL COMMENT '奖励内容',
  `condition` varchar(1000) NOT NULL COMMENT '领取条件',
  `desc` varchar(1000) NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`type`,`level`,`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='投资回报配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_investment_rewards`
--

LOCK TABLES `base_investment_rewards` WRITE;
/*!40000 ALTER TABLE `base_investment_rewards` DISABLE KEYS */;
INSERT INTO `base_investment_rewards` VALUES (1,1,1,'[{2,0,680},{0,4901009,1}]','[]','立即回本+称号：发家致富'),(1,1,2,'[{2,0,340}]','[{lv,160}]',''),(1,1,3,'[{2,0,340}]','[{lv,200}]',''),(1,1,4,'[{2,0,340}]','[{lv,240}]',''),(1,1,5,'[{2,0,340}]','[{lv,270}]',''),(1,1,6,'[{2,0,340}]','[{lv,300}]',''),(1,1,7,'[{2,0,340}]','[{lv,320}]',''),(1,1,8,'[{2,0,340}]','[{lv,340}]',''),(1,1,9,'[{2,0,340}]','[{lv,360}]',''),(1,1,10,'[{2,0,340}]','[{lv,380}]',''),(1,1,11,'[{2,0,340}]','[{lv,400}]',''),(1,1,12,'[{2,0,340}]','[{lv,420}]',''),(1,1,13,'[{2,0,340}]','[{lv,440}]',''),(1,1,14,'[{2,0,340}]','[{lv,460}]',''),(1,1,15,'[{2,0,340}]','[{lv,480}]',''),(1,1,16,'[{2,0,340}]','[{lv,500}]',''),(1,1,17,'[{2,0,340}]','[{lv,520}]',''),(1,1,18,'[{2,0,340}]','[{lv,540}]',''),(1,1,19,'[{2,0,340}]','[{lv,560}]',''),(1,2,1,'[{2,0,1280}]','[]','立即回本'),(1,2,2,'[{2,0,640}]','[{lv,160}]',''),(1,2,3,'[{2,0,640}]','[{lv,200}]',''),(1,2,4,'[{2,0,640}]','[{lv,240}]',''),(1,2,5,'[{2,0,640}]','[{lv,270}]',''),(1,2,6,'[{2,0,640}]','[{lv,300}]',''),(1,2,7,'[{2,0,640}]','[{lv,320}]',''),(1,2,8,'[{2,0,640}]','[{lv,340}]',''),(1,2,9,'[{2,0,640}]','[{lv,360}]',''),(1,2,10,'[{2,0,640}]','[{lv,380}]',''),(1,2,11,'[{2,0,640}]','[{lv,400}]',''),(1,2,12,'[{2,0,640}]','[{lv,420}]',''),(1,2,13,'[{2,0,640}]','[{lv,440}]',''),(1,2,14,'[{2,0,640}]','[{lv,460}]',''),(1,2,15,'[{2,0,640}]','[{lv,480}]',''),(1,2,16,'[{2,0,640}]','[{lv,500}]',''),(1,2,17,'[{2,0,640}]','[{lv,520}]',''),(1,2,18,'[{2,0,640}]','[{lv,540}]',''),(1,2,19,'[{2,0,640}]','[{lv,560}]',''),(1,3,1,'[{2,0,1880}]','[]','立即回本'),(1,3,2,'[{2,0,940},{0,4901010,1}]','[{lv,160}]','称号：富可敌国'),(1,3,3,'[{2,0,940}]','[{lv,200}]',''),(1,3,4,'[{2,0,940}]','[{lv,240}]',''),(1,3,5,'[{2,0,940}]','[{lv,270}]',''),(1,3,6,'[{2,0,940}]','[{lv,300}]',''),(1,3,7,'[{2,0,940}]','[{lv,320}]',''),(1,3,8,'[{2,0,940}]','[{lv,340}]',''),(1,3,9,'[{2,0,940}]','[{lv,360}]',''),(1,3,10,'[{2,0,940}]','[{lv,380}]',''),(1,3,11,'[{2,0,940}]','[{lv,400}]',''),(1,3,12,'[{2,0,940}]','[{lv,420}]',''),(1,3,13,'[{2,0,940}]','[{lv,440}]',''),(1,3,14,'[{2,0,940}]','[{lv,460}]',''),(1,3,15,'[{2,0,940}]','[{lv,480}]',''),(1,3,16,'[{2,0,940}]','[{lv,500}]',''),(1,3,17,'[{2,0,940}]','[{lv,520}]',''),(1,3,18,'[{2,0,940}]','[{lv,540}]',''),(1,3,19,'[{2,0,940}]','[{lv,560}]',''),(2,1,1,'[{2,0,300}]','[]','立即回本'),(2,1,2,'[{2,0,90}]','[{day,1}]',''),(2,1,3,'[{2,0,90}]','[{day,2}]',''),(2,1,4,'[{2,0,90}]','[{day,3}]',''),(2,1,5,'[{2,0,90}]','[{day,4}]',''),(2,1,6,'[{2,0,90}]','[{day,5}]',''),(2,1,7,'[{2,0,90}]','[{day,6}]',''),(2,1,8,'[{2,0,90}]','[{day,7}]',''),(2,1,9,'[{2,0,90}]','[{day,8}]',''),(2,1,10,'[{2,0,90}]','[{day,9}]',''),(2,1,11,'[{2,0,90}]','[{day,10}]',''),(2,1,12,'[{2,0,90}]','[{day,11}]',''),(2,1,13,'[{2,0,90}]','[{day,12}]',''),(2,1,14,'[{2,0,90}]','[{day,13}]',''),(2,1,15,'[{2,0,90}]','[{day,14}]',''),(2,1,16,'[{2,0,90}]','[{day,15}]',''),(2,1,17,'[{2,0,90}]','[{day,16}]',''),(2,1,18,'[{2,0,90}]','[{day,17}]',''),(2,1,19,'[{2,0,90}]','[{day,18}]',''),(2,1,20,'[{2,0,90}]','[{day,19}]',''),(2,1,21,'[{2,0,90}]','[{day,20}]',''),(2,1,22,'[{2,0,90}]','[{day,21}]',''),(2,1,23,'[{2,0,90}]','[{day,22}]',''),(2,1,24,'[{2,0,90}]','[{day,23}]',''),(2,1,25,'[{2,0,90}]','[{day,24}]',''),(2,1,26,'[{2,0,90}]','[{day,25}]',''),(2,1,27,'[{2,0,90}]','[{day,26}]',''),(2,1,28,'[{2,0,90}]','[{day,27}]',''),(2,1,29,'[{2,0,90}]','[{day,28}]',''),(2,1,30,'[{2,0,90}]','[{day,29}]',''),(2,1,31,'[{2,0,90}]','[{day,30}]',''),(3,1,1,'[{2,0,980}]','[]',''),(3,1,2,'[{2,0,490}]','[{lv,570}]',''),(3,1,3,'[{2,0,490}]','[{lv,590}]',''),(3,1,4,'[{2,0,490}]','[{lv,610}]',''),(3,1,5,'[{2,0,490}]','[{lv,620}]',''),(3,1,6,'[{2,0,490}]','[{lv,630}]',''),(3,1,7,'[{2,0,490}]','[{lv,640}]',''),(3,1,8,'[{2,0,490}]','[{lv,650}]',''),(3,1,9,'[{2,0,490}]','[{lv,660}]',''),(3,1,10,'[{2,0,490}]','[{lv,670}]',''),(3,1,11,'[{2,0,490}]','[{lv,680}]',''),(3,1,12,'[{2,0,490}]','[{lv,690}]',''),(3,1,13,'[{2,0,490}]','[{lv,700}]',''),(3,1,14,'[{2,0,490}]','[{lv,710}]',''),(3,1,15,'[{2,0,490}]','[{lv,720}]',''),(3,1,16,'[{2,0,490}]','[{lv,730}]',''),(3,1,17,'[{2,0,490}]','[{lv,740}]',''),(3,1,18,'[{2,0,490}]','[{lv,750}]',''),(3,1,19,'[{2,0,490}]','[{lv,760}]',''),(3,2,1,'[{2,0,1680}]','[]',''),(3,2,2,'[{2,0,840}]','[{lv,570}]',''),(3,2,3,'[{2,0,840}]','[{lv,590}]',''),(3,2,4,'[{2,0,840}]','[{lv,610}]',''),(3,2,5,'[{2,0,840}]','[{lv,620}]',''),(3,2,6,'[{2,0,840}]','[{lv,630}]',''),(3,2,7,'[{2,0,840}]','[{lv,640}]',''),(3,2,8,'[{2,0,840}]','[{lv,650}]',''),(3,2,9,'[{2,0,840}]','[{lv,660}]',''),(3,2,10,'[{2,0,840}]','[{lv,670}]',''),(3,2,11,'[{2,0,840}]','[{lv,680}]',''),(3,2,12,'[{2,0,840}]','[{lv,690}]',''),(3,2,13,'[{2,0,840}]','[{lv,700}]',''),(3,2,14,'[{2,0,840}]','[{lv,710}]',''),(3,2,15,'[{2,0,840}]','[{lv,720}]',''),(3,2,16,'[{2,0,840}]','[{lv,730}]',''),(3,2,17,'[{2,0,840}]','[{lv,740}]',''),(3,2,18,'[{2,0,840}]','[{lv,750}]',''),(3,2,19,'[{2,0,840}]','[{lv,760}]',''),(3,3,1,'[{2,0,2880},{0,4901011,1}]','[]','立即回本+称号：富甲天下'),(3,3,2,'[{2,0,1440}]','[{lv,570}]',''),(3,3,3,'[{2,0,1440}]','[{lv,590}]',''),(3,3,4,'[{2,0,1440}]','[{lv,610}]',''),(3,3,5,'[{2,0,1440}]','[{lv,620}]',''),(3,3,6,'[{2,0,1440}]','[{lv,630}]',''),(3,3,7,'[{2,0,1440}]','[{lv,640}]',''),(3,3,8,'[{2,0,1440}]','[{lv,650}]',''),(3,3,9,'[{2,0,1440}]','[{lv,660}]',''),(3,3,10,'[{2,0,1440}]','[{lv,670}]',''),(3,3,11,'[{2,0,1440}]','[{lv,680}]',''),(3,3,12,'[{2,0,1440}]','[{lv,690}]',''),(3,3,13,'[{2,0,1440}]','[{lv,700}]',''),(3,3,14,'[{2,0,1440}]','[{lv,710}]',''),(3,3,15,'[{2,0,1440}]','[{lv,720}]',''),(3,3,16,'[{2,0,1440}]','[{lv,730}]',''),(3,3,17,'[{2,0,1440}]','[{lv,740}]',''),(3,3,18,'[{2,0,1440}]','[{lv,750}]',''),(3,3,19,'[{2,0,1440}]','[{lv,760}]','');
/*!40000 ALTER TABLE `base_investment_rewards` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_investment_types`
--

DROP TABLE IF EXISTS `base_investment_types`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_investment_types` (
  `type` int(10) unsigned NOT NULL COMMENT '投资类型',
  `level` smallint(5) unsigned NOT NULL COMMENT '档次',
  `price` int(11) unsigned NOT NULL COMMENT '价格',
  `price_type` int(10) unsigned NOT NULL COMMENT '价格类型',
  `condition` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '条件（预留）',
  PRIMARY KEY (`type`,`level`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='投资类型配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_investment_types`
--

LOCK TABLES `base_investment_types` WRITE;
/*!40000 ALTER TABLE `base_investment_types` DISABLE KEYS */;
INSERT INTO `base_investment_types` VALUES (1,1,680,1,'[]'),(1,2,1280,1,'[]'),(1,3,1880,1,'[{dsgn_id, 400013}]'),(2,1,300,1,'[]'),(3,1,980,1,'[]'),(3,2,1680,1,'[]'),(3,3,2880,1,'[{dsgn_id, 400014}]');
/*!40000 ALTER TABLE `base_investment_types` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_jjc_battle_reward`
--

DROP TABLE IF EXISTS `base_jjc_battle_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_jjc_battle_reward` (
  `id` tinyint(3) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `max_rank` smallint(5) unsigned NOT NULL COMMENT '被挑战者最高排名',
  `min_rank` smallint(5) unsigned NOT NULL COMMENT '被挑战者最低排名',
  `win_reward` varchar(255) NOT NULL COMMENT '获胜奖励',
  `lose_reward` varchar(255) NOT NULL COMMENT '失败奖励',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=8 DEFAULT CHARSET=utf8 COMMENT='竞技场战斗奖励配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_jjc_battle_reward`
--

LOCK TABLES `base_jjc_battle_reward` WRITE;
/*!40000 ALTER TABLE `base_jjc_battle_reward` DISABLE KEYS */;
INSERT INTO `base_jjc_battle_reward` VALUES (1,2000,9999,'[{16, 0, 150}]','[{16, 0, 120}]'),(2,1001,1999,'[{16, 0, 175}]','[{16, 0, 140}]'),(3,500,1000,'[{16, 0, 200}]','[{16, 0, 160}]'),(4,101,499,'[{16, 0, 225}]','[{16, 0, 180}]'),(5,51,100,'[{16, 0, 250}]','[{16, 0, 200}]'),(6,21,50,'[{16, 0, 275}]','[{16, 0, 220}]'),(7,1,20,'[{16, 0, 320}]','[{16, 0, 256}]');
/*!40000 ALTER TABLE `base_jjc_battle_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_jjc_bgold_reward`
--

DROP TABLE IF EXISTS `base_jjc_bgold_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_jjc_bgold_reward` (
  `id` smallint(5) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `min_rank` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '最小排名',
  `max_rank` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '最大排名',
  `bgold_coefficient` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '绑钻系数',
  `max_receive` mediumint(7) unsigned NOT NULL DEFAULT '0' COMMENT '累计领取',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=15 DEFAULT CHARSET=utf8 COMMENT='竞技场绑钻奖励配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_jjc_bgold_reward`
--

LOCK TABLES `base_jjc_bgold_reward` WRITE;
/*!40000 ALTER TABLE `base_jjc_bgold_reward` DISABLE KEYS */;
INSERT INTO `base_jjc_bgold_reward` VALUES (1,1,2,20000,2060),(2,2,3,15000,1860),(3,3,4,8000,1710),(4,4,10,2000,1630),(5,10,20,1000,1510),(6,20,40,700,1410),(7,40,80,500,1270),(8,80,150,400,1070),(9,150,250,150,790),(10,250,400,120,640),(11,400,600,60,460),(12,600,900,25,340),(13,900,2000,15,265),(14,2000,3000,10,100);
/*!40000 ALTER TABLE `base_jjc_bgold_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_jjc_buy_num`
--

DROP TABLE IF EXISTS `base_jjc_buy_num`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_jjc_buy_num` (
  `num` int(5) unsigned NOT NULL DEFAULT '0' COMMENT '购买次数',
  `type` smallint(4) unsigned NOT NULL DEFAULT '0' COMMENT '货币类型',
  `price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '价格',
  PRIMARY KEY (`num`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='购买次数配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_jjc_buy_num`
--

LOCK TABLES `base_jjc_buy_num` WRITE;
/*!40000 ALTER TABLE `base_jjc_buy_num` DISABLE KEYS */;
INSERT INTO `base_jjc_buy_num` VALUES (1,2,8),(2,2,8),(3,2,8),(4,2,8),(5,2,8),(6,2,10),(7,2,10),(8,2,10),(9,2,10),(10,2,10),(11,2,10),(12,2,10),(13,2,10),(14,2,10),(15,2,10),(16,2,10),(17,2,10),(18,2,10),(19,2,10),(20,2,10),(21,2,10),(22,2,10),(23,2,10),(24,2,10),(25,2,10);
/*!40000 ALTER TABLE `base_jjc_buy_num` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_jjc_config`
--

DROP TABLE IF EXISTS `base_jjc_config`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_jjc_config` (
  `key` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'ID',
  `value` varchar(1024) NOT NULL DEFAULT '0' COMMENT '值',
  `about` varchar(1024) NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='竞技场配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_jjc_config`
--

LOCK TABLES `base_jjc_config` WRITE;
/*!40000 ALTER TABLE `base_jjc_config` DISABLE KEYS */;
INSERT INTO `base_jjc_config` VALUES (1,'10','最大挑战次数'),(2,'10','最大鼓舞次数'),(3,'115','竞技场开放等级'),(4,'3000','jjc最低排名'),(5,'20','假人等级'),(6,'[1,2,4]','假人职业'),(7,'[{1,1010100},{2,1010100}]','假人衣服Id,[{职业Id, 衣服Id}]'),(8,'[{1,102010100},{2,102010100}]','假人武器Id,[{职业Id, 武器Id}]'),(10,'10','被挑战记录数量'),(11,'5191','竞技场景id'),(12,'[{4219,4443},{5523,4458}]','出生坐标列表'),(13,'3','战斗开始前准备时间'),(14,'30','战斗持续时间'),(15,'[{4880,4500}]','真人坐标'),(16,'10','结算界面持续时间'),(17,'[{4218,4263},{3931,4467},{4178,4658}]','左下方星灵出生点'),(18,'[{5550,4232},{5738,4417},{5551,4668}]','右上方星灵出生点');
/*!40000 ALTER TABLE `base_jjc_config` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_jjc_exp_reward`
--

DROP TABLE IF EXISTS `base_jjc_exp_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_jjc_exp_reward` (
  `id` smallint(5) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `min_lv` smallint(5) unsigned NOT NULL COMMENT '等级下限',
  `max_lv` smallint(5) unsigned NOT NULL COMMENT '等级上限',
  `win_exp` int(11) unsigned NOT NULL COMMENT '胜利经验',
  `lose_exp` int(11) unsigned NOT NULL COMMENT '失败经验',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=42 DEFAULT CHARSET=utf8 COMMENT='竞技场战斗经验奖励配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_jjc_exp_reward`
--

LOCK TABLES `base_jjc_exp_reward` WRITE;
/*!40000 ALTER TABLE `base_jjc_exp_reward` DISABLE KEYS */;
INSERT INTO `base_jjc_exp_reward` VALUES (1,1,200,1566398,1174799),(2,201,220,1566398,1174799),(3,221,240,1890158,1417619),(4,241,260,2338206,1753655),(5,261,280,2530486,1897865),(6,281,300,2633531,1975148),(7,301,320,2832477,2124358),(8,321,340,2989762,2242321),(9,341,360,3182778,2387084),(10,361,380,3646202,2734652),(11,381,400,6951843,5213882),(12,401,420,8471843,6353882),(13,421,440,9991843,7493882),(14,441,460,11455382,8591536),(15,461,480,14646038,10984528),(16,481,500,16556882,12417661),(17,501,520,17696882,13272661),(18,521,540,20317376,15238032),(19,541,560,26504029,19878022),(20,561,580,32488921,24366691),(21,581,600,35528921,26646691),(22,601,620,38568921,28926691),(23,621,640,41608921,31206691),(24,641,660,44648921,33486691),(25,661,680,47688921,35766691),(26,681,700,50728921,38046691),(27,701,720,53768921,40326691),(28,721,740,56808921,42606691),(29,741,760,59848921,44886691),(30,761,780,62888921,47166691),(31,781,800,65928921,49446691),(32,801,820,67448921,50586691),(33,821,840,67448921,50586691),(34,841,860,67448921,50586691),(35,861,880,67448921,50586691),(36,881,900,67448921,50586691),(37,901,920,67448921,50586691),(38,921,940,67448921,50586691),(39,941,960,67448921,50586691),(40,961,980,67448921,50586691),(41,981,1000,67448921,50586691);
/*!40000 ALTER TABLE `base_jjc_exp_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_jjc_fake_attr`
--

DROP TABLE IF EXISTS `base_jjc_fake_attr`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_jjc_fake_attr` (
  `id` smallint(5) unsigned NOT NULL COMMENT '区域排名id',
  `min_rank` smallint(5) unsigned NOT NULL COMMENT '最低排名',
  `max_rank` smallint(5) unsigned NOT NULL COMMENT '最高排名',
  `fake_star_soul_stage_star` varchar(255) NOT NULL DEFAULT '{1,1}' COMMENT '假星灵阶数{stage, star}',
  `fake_star_soul_ids` varchar(255) NOT NULL COMMENT '假星灵id列表',
  `fake_star_soul_num` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '假星灵数量',
  `fake_role_lv` smallint(5) unsigned NOT NULL DEFAULT '1' COMMENT '假人等级',
  `combat` varchar(255) NOT NULL COMMENT '假人战力范围',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='竞技场假人配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_jjc_fake_attr`
--

LOCK TABLES `base_jjc_fake_attr` WRITE;
/*!40000 ALTER TABLE `base_jjc_fake_attr` DISABLE KEYS */;
INSERT INTO `base_jjc_fake_attr` VALUES (1,1,1,'{3,3}','[1001, 1002, 1003]',2,330,'{3019064,3073198}'),(2,2,2,'{3,3}','[1001, 1002, 1004]',2,328,'{2964979,3019063}'),(3,3,3,'{3,3}','[1001, 1002, 1005]',2,326,'{2910744,2964978}'),(4,4,4,'{3,3}','[1001, 1002, 1006]',2,324,'{2802524,2910743}'),(5,5,5,'{3,3}','[1001, 1002, 1007]',2,320,'{2721341,2802523}'),(6,6,6,'{3,2}','[1001, 1002, 1008]',2,317,'{2613071,2721340}'),(7,7,7,'{3,2}','[1001, 1002, 1009]',2,313,'{2504826,2613070}'),(8,8,8,'{3,2}','[1001, 1002, 1010]',2,309,'{2396526,2504825}'),(9,9,9,'{3,2}','[1001, 1002, 1011]',2,305,'{2261238,2396525}'),(10,10,10,'{3,1}','[1001, 1002, 1012]',2,300,'{2139973,2261237}'),(11,11,11,'{3,1}','[1001, 1002, 1013]',2,294,'{2018883,2139972}'),(12,12,12,'{3,1}','[1001, 1002, 1014]',2,288,'{1897598,2018882}'),(13,13,13,'{3,0}','[1001, 1002, 1015]',2,282,'{1776458,1897597}'),(14,14,14,'{3,0}','[1001, 1002, 1016]',2,276,'{1655242,1776457}'),(15,15,15,'{2,3}','[1001, 1002, 1017]',2,270,'{1635015,1655241}'),(16,16,16,'{2,3}','[1001, 1002, 1018]',2,269,'{1614862,1635014}'),(17,17,17,'{2,3}','[1001, 1002, 1019]',2,268,'{1614861,1614861}'),(18,18,18,'{2,3}','[1001, 1002, 1020]',2,268,'{1594610,1614861}'),(19,19,19,'{2,3}','[1001, 1002, 1021]',2,267,'{1574457,1594609}'),(20,20,20,'{2,3}','[1001, 1002, 1022]',2,266,'{1554280,1574456}'),(21,21,21,'{2,3}','[1001, 1002, 1023]',2,265,'{1533977,1554279}'),(22,22,22,'{2,3}','[1001, 1002, 1024]',2,264,'{1533976,1533976}'),(23,23,23,'{2,3}','[1001, 1002, 1025]',2,264,'{1513875,1533976}'),(24,24,24,'{2,3}','[1001, 1002, 1026]',2,263,'{1493577,1513874}'),(25,25,25,'{2,3}','[1001, 1002, 1027]',2,262,'{1473525,1493576}'),(26,26,26,'{2,3}','[1001, 1002, 1028]',2,261,'{1473524,1473524}'),(27,27,27,'{2,3}','[1001, 1002, 1029]',2,261,'{1453222,1473524}'),(28,28,28,'{2,2}','[1001, 1002, 1030]',2,260,'{1432995,1453221}'),(29,29,29,'{2,2}','[1001, 1002, 1031]',2,259,'{1412842,1432994}'),(30,30,30,'{2,2}','[1001, 1002, 1032]',2,258,'{1392590,1412841}'),(31,31,31,'{2,2}','[1001, 1002, 1033]',2,257,'{1392589,1392589}'),(32,32,32,'{2,2}','[1001, 1002, 1034]',2,257,'{1372487,1392589}'),(33,33,33,'{2,2}','[1001, 1002, 1035]',2,256,'{1352260,1372486}'),(34,34,34,'{2,2}','[1001, 1002, 1036]',2,255,'{1331957,1352259}'),(35,35,35,'{2,2}','[1001, 1002, 1037]',2,254,'{1311855,1331956}'),(36,36,36,'{2,2}','[1001, 1002, 1038]',2,253,'{1311854,1311854}'),(37,37,37,'{2,2}','[1001, 1002, 1039]',2,253,'{1291627,1311854}'),(38,38,38,'{2,2}','[1001, 1002, 1040]',2,252,'{1271500,1291626}'),(39,39,39,'{2,2}','[1001, 1002, 1041]',2,251,'{1251222,1271499}'),(40,40,40,'{2,2}','[1001, 1002, 1042]',2,250,'{1227440,1251221}'),(41,41,41,'{2,1}','[1001, 1002, 1043]',2,249,'{1227439,1227439}'),(42,42,42,'{2,1}','[1001, 1002, 1044]',2,249,'{1203802,1227439}'),(43,43,43,'{2,1}','[1001, 1002, 1045]',2,248,'{1180020,1203801}'),(44,44,44,'{2,1}','[1001, 1002, 1046]',2,247,'{1156362,1180019}'),(45,45,45,'{2,1}','[1001, 1002, 1047]',2,246,'{1156361,1156361}'),(46,46,46,'{2,1}','[1001, 1002, 1048]',2,246,'{1132650,1156361}'),(47,47,47,'{2,1}','[1001, 1002, 1049]',2,245,'{1108892,1132649}'),(48,48,48,'{2,1}','[1001, 1002, 1050]',2,244,'{1085210,1108891}'),(49,49,49,'{2,1}','[1001, 1002, 1051]',2,243,'{1061452,1085209}'),(50,50,50,'{2,1}','[1001, 1002, 1052]',2,242,'{1061451,1061451}'),(51,51,60,'{2,1}','[1001, 1002, 1053]',2,242,'{1037790,1061451}'),(52,61,70,'{2,1}','[1001, 1002, 1054]',2,241,'{1014032,1037789}'),(53,71,80,'{2,1}','[1001, 1002, 1055]',2,240,'{990225,1014031}'),(54,81,90,'{2,1}','[1001, 1002, 1056]',1,239,'{966537,990224}'),(55,91,100,'{2,1}','[1001, 1002, 1057]',1,238,'{942805,966536}'),(56,101,110,'{2,0}','[1001, 1002, 1058]',1,237,'{919097,942804}'),(57,111,120,'{2,0}','[1001, 1002, 1059]',1,236,'{895435,919096}'),(58,121,130,'{2,0}','[1001, 1002, 1060]',1,235,'{895434,895434}'),(59,131,140,'{2,0}','[1001, 1002, 1061]',1,235,'{871627,895434}'),(60,141,150,'{2,0}','[1001, 1002, 1062]',1,234,'{847995,871626}'),(61,151,160,'{2,0}','[1001, 1002, 1063]',1,233,'{824187,847994}'),(62,161,170,'{2,0}','[1001, 1002, 1064]',1,232,'{800575,824186}'),(63,171,180,'{2,0}','[1001, 1002, 1065]',1,231,'{776767,800574}'),(64,181,190,'{2,0}','[1001, 1002, 1066]',1,230,'{742252,776766}'),(65,191,200,'{1,3}','[1001, 1002, 1067]',1,226,'{699082,742251}'),(66,201,240,'{1,3}','[1001, 1002, 1068]',1,221,'{664547,699081}'),(67,241,280,'{1,3}','[1001, 1002, 1069]',1,217,'{621428,664546}'),(68,281,320,'{1,2}','[1001, 1002, 1070]',1,212,'{586862,621427}'),(69,321,360,'{1,2}','[1001, 1002, 1071]',1,208,'{543743,586861}'),(70,361,400,'{1,1}','[1001, 1002, 1072]',1,203,'{509208,543742}'),(71,401,440,'{1,1}','[1001, 1002, 1073]',1,199,'{466038,509207}'),(72,441,480,'{1,0}','[1001, 1002, 1074]',1,194,'{431523,466037}'),(73,481,520,'{1,0}','[1001, 1002, 1075]',1,190,'{414841,431522}'),(74,521,560,'{1,0}','[1001, 1002, 1076]',1,188,'{398179,414840}'),(75,561,600,'{1,0}','[1001, 1002, 1077]',1,186,'{372992,398178}'),(76,601,640,'{1,0}','[1001, 1002, 1078]',1,183,'{356360,372991}'),(77,641,680,'{1,0}','[1001, 1002, 1079]',1,181,'{339648,356359}'),(78,681,720,'{1,0}','[1001, 1002, 1080]',1,179,'{322841,339647}'),(79,721,760,'{1,0}','[1001, 1002, 1081]',1,177,'{306129,322840}'),(80,761,800,'{1,0}','[1001, 1002, 1082]',1,175,'{289497,306128}'),(81,801,840,'{1,0}','[1001, 1002, 1083]',1,173,'{264435,289496}'),(82,841,880,'{1,0}','[1001, 1002, 1084]',1,170,'{247723,264434}'),(83,881,920,'{1,0}','[1001, 1002, 1085]',1,168,'{230966,247722}'),(84,921,960,'{1,0}','[1001, 1002, 1086]',1,166,'{230702,230965}'),(85,961,1000,'{1,0}','[1001, 1002, 1087]',1,164,'{230418,230701}'),(86,1001,1100,'{1,0}','[1001, 1002, 1088]',1,162,'{230022,230417}'),(87,1101,1200,'{1,0}','[1001, 1002, 1089]',1,159,'{229758,230021}'),(88,1201,1300,'{1,0}','[1001, 1002, 1090]',1,157,'{229495,229757}'),(89,1301,1400,'{1,0}','[1001, 1002, 1091]',1,155,'{229206,229494}'),(90,1401,1500,'{1,0}','[1001, 1002, 1092]',1,153,'{228942,229205}'),(91,1501,1600,'{1,0}','[1001, 1002, 1093]',1,151,'{210912,228941}'),(92,1601,1700,'{1,0}','[1001, 1002, 1094]',1,148,'{209275,210911}'),(93,1701,1800,'{1,0}','[1001, 1002, 1095]',1,146,'{207687,209274}'),(94,1801,1900,'{1,0}','[1001, 1002, 1096]',1,144,'{206019,207686}'),(95,1901,2000,'{1,0}','[1001, 1002, 1097]',1,142,'{204431,206018}'),(96,2001,2100,'{1,0}','[1001, 1002, 1098]',1,140,'{202894,204430}'),(97,2101,2200,'{1,0}','[1001, 1002, 1099]',1,138,'{200552,202893}'),(98,2201,2300,'{1,0}','[1001, 1002, 1100]',1,135,'{198884,200551}'),(99,2301,2400,'{1,0}','[1001, 1002, 1101]',1,133,'{197296,198883}'),(100,2401,2500,'{1,0}','[1001, 1002, 1102]',1,131,'{195659,197295}'),(101,2501,2600,'{1,0}','[1001, 1002, 1103]',1,129,'{194071,195658}'),(102,2601,2700,'{1,0}','[1001, 1002, 1104]',1,127,'{193260,194070}'),(103,2701,2800,'{1,0}','[1001, 1002, 1105]',1,124,'{192736,193259}'),(104,2801,2900,'{1,0}','[1001, 1002, 1106]',1,122,'{192212,192735}'),(105,2901,3000,'{1,0}','[1001, 1002, 1107]',1,120,'{191616,192211}');
/*!40000 ALTER TABLE `base_jjc_fake_attr` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_jjc_inspire`
--

DROP TABLE IF EXISTS `base_jjc_inspire`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_jjc_inspire` (
  `num` int(5) unsigned NOT NULL DEFAULT '0' COMMENT '鼓舞次数',
  `type` smallint(4) unsigned NOT NULL DEFAULT '0' COMMENT '货币类型',
  `price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '价格',
  `percent` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '增加百分比',
  PRIMARY KEY (`num`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='战力鼓舞配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_jjc_inspire`
--

LOCK TABLES `base_jjc_inspire` WRITE;
/*!40000 ALTER TABLE `base_jjc_inspire` DISABLE KEYS */;
INSERT INTO `base_jjc_inspire` VALUES (1,2,5,5),(2,2,10,10),(3,2,15,15),(4,2,20,20),(5,2,25,25),(6,2,30,30),(7,2,35,35),(8,2,40,40),(9,2,45,45),(10,2,50,50);
/*!40000 ALTER TABLE `base_jjc_inspire` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_jjc_rank_reward`
--

DROP TABLE IF EXISTS `base_jjc_rank_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_jjc_rank_reward` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '区域Id',
  `min` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名下限',
  `max` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名上限',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `about` varchar(1024) NOT NULL COMMENT '描述',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='排名奖励配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_jjc_rank_reward`
--

LOCK TABLES `base_jjc_rank_reward` WRITE;
/*!40000 ALTER TABLE `base_jjc_rank_reward` DISABLE KEYS */;
INSERT INTO `base_jjc_rank_reward` VALUES (1,1,1,'[{16,0,5000}]','第1名'),(2,2,2,'[{16,0,4750}]','第2名'),(3,3,3,'[{16,0,4500}]','第3名'),(4,4,5,'[{16,0,4250}]','第4-5名'),(5,6,10,'[{16,0,4125}]','第6-10名'),(6,11,50,'[{16,0,3750}]','第11-50名'),(7,51,100,'[{16,0,3000}]','第51-100名'),(8,101,500,'[{16,0,2750}]','第101-500名'),(9,501,1000,'[{16,0,2500}]','第501-1000名'),(10,1001,2000,'[{16,0,2250}]','第1001-2000名'),(11,2001,3000,'[{16,0,2000}]','第2001~3000名');
/*!40000 ALTER TABLE `base_jjc_rank_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_jjc_reward_break`
--

DROP TABLE IF EXISTS `base_jjc_reward_break`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_jjc_reward_break` (
  `id` tinyint(3) unsigned NOT NULL AUTO_INCREMENT COMMENT '礼包id',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=11 DEFAULT CHARSET=utf8 COMMENT='排名突破奖励配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_jjc_reward_break`
--

LOCK TABLES `base_jjc_reward_break` WRITE;
/*!40000 ALTER TABLE `base_jjc_reward_break` DISABLE KEYS */;
INSERT INTO `base_jjc_reward_break` VALUES (1,1,'[{2,0,400}]'),(2,2,'[{2,0,350}]'),(3,3,'[{2,0,300}]'),(4,10,'[{2,0,250}]'),(5,50,'[{2,0,200}]'),(6,100,'[{2,0,150}]'),(7,500,'[{2,0,100}]'),(8,1000,'[{2,0,80}]'),(9,2000,'[{2,0,60}]'),(10,2999,'[{2,0,40}]');
/*!40000 ALTER TABLE `base_jjc_reward_break` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_jjc_search`
--

DROP TABLE IF EXISTS `base_jjc_search`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_jjc_search` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名区域',
  `min` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名下限',
  `max` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名上限',
  `max_range` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大搜索范围',
  `min_range` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小搜索范围',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='对手搜索配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_jjc_search`
--

LOCK TABLES `base_jjc_search` WRITE;
/*!40000 ALTER TABLE `base_jjc_search` DISABLE KEYS */;
INSERT INTO `base_jjc_search` VALUES (1,1,1,1,1),(2,2,2,1,1),(3,3,3,1,1),(4,4,10,1,1),(5,11,20,2,1),(6,21,40,3,1),(7,41,80,4,1),(8,81,150,5,2),(9,151,250,15,8),(10,251,400,20,10),(11,401,600,40,20),(12,601,900,100,50),(13,901,1500,140,70),(14,1501,2000,170,80),(15,2001,2500,210,100),(16,2501,99999,250,120);
/*!40000 ALTER TABLE `base_jjc_search` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_key_value`
--

DROP TABLE IF EXISTS `base_key_value`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_key_value` (
  `key` int(10) unsigned NOT NULL COMMENT '键id',
  `name` varchar(50) NOT NULL COMMENT '名称',
  `value` varchar(1000) NOT NULL COMMENT '数据',
  `desc` tinytext NOT NULL COMMENT '备注@lang@',
  PRIMARY KEY (`key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='杂项配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_key_value`
--

LOCK TABLES `base_key_value` WRITE;
/*!40000 ALTER TABLE `base_key_value` DISABLE KEYS */;
INSERT INTO `base_key_value` VALUES (3310001,'五星评价开放等级','70','五星评价开放等级');
/*!40000 ALTER TABLE `base_key_value` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_key_value_config`
--

DROP TABLE IF EXISTS `base_key_value_config`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_key_value_config` (
  `type` varchar(25) NOT NULL,
  `key` int(11) NOT NULL,
  `value` varchar(50) NOT NULL,
  `ext` text NOT NULL,
  `desc` varchar(50) NOT NULL,
  `time` int(11) NOT NULL,
  PRIMARY KEY (`type`,`key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_key_value_config`
--

LOCK TABLES `base_key_value_config` WRITE;
/*!40000 ALTER TABLE `base_key_value_config` DISABLE KEYS */;
INSERT INTO `base_key_value_config` VALUES ('bag_location',0,'','','背包位置',1524560031),('bag_location',4,'物品背包','','背包位置',1524552591),('bag_location',9,'符文背包','','背包位置',1524552748),('bag_location',11,'聚魂背包','','背包位置',1524552763),('bag_location',13,'幻兽背包','','背包位置',1524552790),('bag_location',16,'寻宝背包','','背包位置',1524552809),('bag_location',17,'圣印背包','','背包位置',1524552826),('bag_location',20,'图鉴背包','','背包位置',1533711225),('bag_location',21,'坐骑背包','','背包位置',1537263219),('equip_type',0,'无','','装备类型',0),('equip_type',1,'武器','','装备类型',0),('equip_type',2,'头盔','','装备类型',1531310475),('equip_type',3,'项链','','装备类型',0),('equip_type',4,'衣服','','装备类型',1504059987),('equip_type',5,'刻痕','','装备类型',1531310491),('equip_type',6,'裤子','','装备类型',1504059951),('equip_type',7,'副武器','','装备类型',1531310506),('equip_type',8,'护腕','','装备类型',1504059944),('equip_type',9,'戒指','','装备类型',1504059918),('equip_type',10,'鞋子','','装备类型',1485262086),('equip_type',11,'守护','','装备类型',1531310520),('goods_location',1,'装备位置','','物品位置',1524542764),('goods_location',4,'物品背包','','物品位置',1524542595),('goods_location',5,'仓库位置','','物品位置',1524542963),('goods_location',6,'帮派仓库','','物品位置',1524542963),('goods_location',8,'时装衣橱','','物品位置',1524542963),('goods_location',9,'符文背包','','物品位置',1524542595),('goods_location',11,'聚魂背包','','物品位置',1524542595),('goods_location',13,'幻兽装备背包','','物品位置',1524542595),('goods_location',16,'寻宝背包','','物品位置',1524542595),('goods_location',17,'圣印背包','','物品位置',1524542595),('price_type',0,'物品','','价格类型（个人）',1504060936),('price_type',1,'钻石','','价格类型（个人）',1504060944),('price_type',2,'绑定钻石','','价格类型（个人）',1504060951),('price_type',3,'金币','','价格类型（个人）',1504060964),('price_type',4,'公会贡献','','价格类型（个人）',1504061015),('price_type',5,'经验','','价格类型（个人）',1509693244),('price_type',6,'魅力','','价格类型（个人）',1509693270),('price_type',7,'名誉','','价格类型（个人）',1510127550),('price_type',8,'公会资金','','价格类型（个人）',1510127616),('price_type',9,'时装精华','','价格类型（个人）',1510648204),('price_type',10,'符文经验','','价格类型（个人）',1510728029),('price_type',11,'聚魂经验','','价格类型（个人）',1510728029),('price_type',12,'蓝神器强化积分','','价格类型（个人）',1510901203),('price_type',13,'紫神器强化积分','','价格类型（个人）',1510901192),('price_type',14,'橙神器强化积分','','价格类型（个人）',1510901225),('price_type',16,'竞技荣耀值','','价格类型（个人）',1512051249),('price_type',17,'公会成长值','','价格类型（个人）',1513655399),('price_type',19,'跨服服战积分','','价格类型（个人）',1514358688),('price_type',100,'绑定物品','','价格类型（个人）',1520498804),('price_type',255,'特殊货币','','货币类型由物品类型id决定',1515037552);
/*!40000 ALTER TABLE `base_key_value_config` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf3v3_act_list`
--

DROP TABLE IF EXISTS `base_kf3v3_act_list`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf3v3_act_list` (
  `id` int(11) NOT NULL COMMENT '活动ID',
  `week` varchar(1000) COLLATE utf8_unicode_ci NOT NULL COMMENT '开启日期',
  `time` varchar(1000) COLLATE utf8_unicode_ci NOT NULL COMMENT '开启时间',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf3v3_act_list`
--

LOCK TABLES `base_kf3v3_act_list` WRITE;
/*!40000 ALTER TABLE `base_kf3v3_act_list` DISABLE KEYS */;
INSERT INTO `base_kf3v3_act_list` VALUES (1,'[2,4]','[{21, 00, 00},{21, 20, 00}]');
/*!40000 ALTER TABLE `base_kf3v3_act_list` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf3v3_act_rewards`
--

DROP TABLE IF EXISTS `base_kf3v3_act_rewards`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf3v3_act_rewards` (
  `win_num` int(11) NOT NULL COMMENT '胜利场次',
  `rewards` varchar(1000) COLLATE utf8_unicode_ci NOT NULL COMMENT '奖励',
  PRIMARY KEY (`win_num`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf3v3_act_rewards`
--

LOCK TABLES `base_kf3v3_act_rewards` WRITE;
/*!40000 ALTER TABLE `base_kf3v3_act_rewards` DISABLE KEYS */;
INSERT INTO `base_kf3v3_act_rewards` VALUES (1,'[{255,36160002,200}]'),(3,'[{255,36160002,400}]'),(6,'[{255,36160002,700}]'),(0,'[{255,36160002,400}]');
/*!40000 ALTER TABLE `base_kf3v3_act_rewards` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf3v3_inherit_tier`
--

DROP TABLE IF EXISTS `base_kf3v3_inherit_tier`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf3v3_inherit_tier` (
  `old_tier` int(11) NOT NULL COMMENT '原段位',
  `new_tier` int(11) NOT NULL COMMENT '继承段位',
  PRIMARY KEY (`old_tier`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf3v3_inherit_tier`
--

LOCK TABLES `base_kf3v3_inherit_tier` WRITE;
/*!40000 ALTER TABLE `base_kf3v3_inherit_tier` DISABLE KEYS */;
INSERT INTO `base_kf3v3_inherit_tier` VALUES (1,1),(2,1),(3,1),(4,1),(5,1),(6,1),(7,1),(8,2),(9,2),(10,3),(11,3),(12,4),(13,4),(14,5),(15,5),(16,6),(17,6),(18,7),(19,7),(20,8),(21,8),(22,9),(23,10),(24,11),(25,12),(26,13),(27,14),(28,15),(29,16);
/*!40000 ALTER TABLE `base_kf3v3_inherit_tier` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf3v3_rank_rewards`
--

DROP TABLE IF EXISTS `base_kf3v3_rank_rewards`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf3v3_rank_rewards` (
  `rank_max` int(11) NOT NULL COMMENT '排名上限',
  `rank_min` int(11) NOT NULL COMMENT '排名下限',
  `rewards` varchar(1000) COLLATE utf8_unicode_ci NOT NULL COMMENT '奖励',
  PRIMARY KEY (`rank_max`,`rank_min`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf3v3_rank_rewards`
--

LOCK TABLES `base_kf3v3_rank_rewards` WRITE;
/*!40000 ALTER TABLE `base_kf3v3_rank_rewards` DISABLE KEYS */;
INSERT INTO `base_kf3v3_rank_rewards` VALUES (1,1,'[{2,36020001,600},{0,4911011,1}]'),(2,2,'[{2,36020001,450},{0,4911010,1}]'),(3,5,'[{2,36020001,350},{0,4911009,1}]'),(6,20,'[{2,36020001,280}]'),(21,50,'[{2,36020001,240}]'),(51,100,'[{2,36020001,200}]'),(101,99999,'[{2,36020001,150}]');
/*!40000 ALTER TABLE `base_kf3v3_rank_rewards` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf3v3_tier_info`
--

DROP TABLE IF EXISTS `base_kf3v3_tier_info`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf3v3_tier_info` (
  `tier` int(11) NOT NULL COMMENT '段位等级',
  `stage` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '段位',
  `star` int(11) NOT NULL COMMENT '升级星数',
  `daily_reward` int(11) NOT NULL COMMENT '每日段位奖励',
  `win_star` int(11) NOT NULL COMMENT '单场胜利星数',
  `lose_star` int(11) NOT NULL COMMENT '单场失败星数',
  `win_reward` int(11) NOT NULL COMMENT '单场胜利荣耀',
  `lose_reward` int(11) NOT NULL COMMENT '单场失败荣耀',
  `tier_name` varchar(1000) COLLATE utf8_unicode_ci NOT NULL COMMENT '段位名称',
  `big_tier` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '大段位',
  PRIMARY KEY (`tier`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf3v3_tier_info`
--

LOCK TABLES `base_kf3v3_tier_info` WRITE;
/*!40000 ALTER TABLE `base_kf3v3_tier_info` DISABLE KEYS */;
INSERT INTO `base_kf3v3_tier_info` VALUES (1,3,0,100,8,4,40,20,'青铜Ⅲ',1),(2,2,16,120,8,4,48,24,'青铜Ⅱ',1),(3,1,32,140,8,4,56,28,'青铜Ⅰ',1),(4,3,48,160,10,4,64,32,'白银Ⅲ',2),(5,2,78,180,10,4,72,36,'白银Ⅱ',2),(6,1,108,200,10,4,80,40,'白银Ⅰ',2),(7,3,138,230,12,5,92,46,'黄金Ⅲ',3),(8,2,174,260,12,5,104,52,'黄金Ⅱ',3),(9,1,210,290,12,5,116,58,'黄金Ⅰ',3),(10,4,246,320,15,6,128,64,'铂金Ⅳ',4),(11,3,291,350,15,6,140,70,'铂金Ⅲ',4),(12,2,336,380,15,6,152,76,'铂金Ⅱ',4),(13,1,381,410,15,6,164,82,'铂金Ⅰ',4),(14,4,426,440,18,7,176,88,'钻石Ⅳ',5),(15,3,498,480,18,7,192,96,'钻石Ⅲ',5),(16,2,570,520,18,7,208,104,'钻石Ⅱ',5),(17,1,642,560,18,7,224,112,'钻石Ⅰ',5),(18,5,714,600,20,8,240,120,'王者Ⅴ',6),(19,4,794,640,20,8,256,128,'王者Ⅳ',6),(20,3,874,680,20,8,272,136,'王者Ⅲ',6),(21,2,954,720,20,8,288,144,'王者Ⅱ',6),(22,1,1034,760,25,8,304,152,'王者Ⅰ',6),(23,1,1134,800,25,8,320,160,'史诗',7);
/*!40000 ALTER TABLE `base_kf3v3_tier_info` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf3v3_win_row`
--

DROP TABLE IF EXISTS `base_kf3v3_win_row`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf3v3_win_row` (
  `win_row` int(11) NOT NULL COMMENT '连胜次数',
  `extra_star` int(11) NOT NULL COMMENT '额外星数奖励',
  PRIMARY KEY (`win_row`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf3v3_win_row`
--

LOCK TABLES `base_kf3v3_win_row` WRITE;
/*!40000 ALTER TABLE `base_kf3v3_win_row` DISABLE KEYS */;
INSERT INTO `base_kf3v3_win_row` VALUES (1,0),(2,1),(3,2),(4,3),(5,3),(6,4),(7,4),(8,4),(9,4),(10,5);
/*!40000 ALTER TABLE `base_kf3v3_win_row` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf_1vn_area`
--

DROP TABLE IF EXISTS `base_kf_1vn_area`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf_1vn_area` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战区id',
  `min_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最低等级（包含）',
  `max_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最高等级（包含）',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='区域配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf_1vn_area`
--

LOCK TABLES `base_kf_1vn_area` WRITE;
/*!40000 ALTER TABLE `base_kf_1vn_area` DISABLE KEYS */;
INSERT INTO `base_kf_1vn_area` VALUES (1,360,1000);
/*!40000 ALTER TABLE `base_kf_1vn_area` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf_1vn_auction`
--

DROP TABLE IF EXISTS `base_kf_1vn_auction`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf_1vn_auction` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `area` tinyint(3) unsigned NOT NULL COMMENT '赛区',
  `goods` varchar(500) NOT NULL DEFAULT '[]' COMMENT '道具列表',
  `goods_model` text COMMENT '道具资源id列表',
  `cost` varchar(500) NOT NULL DEFAULT '[]' COMMENT '消耗列表',
  `ser_award` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '全服奖励',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='1vn拍卖';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf_1vn_auction`
--

LOCK TABLES `base_kf_1vn_auction` WRITE;
/*!40000 ALTER TABLE `base_kf_1vn_auction` DISABLE KEYS */;
INSERT INTO `base_kf_1vn_auction` VALUES (1,1,'[{0,32140001,1}]','[{2,chest2}]','[{1,0,16000}]','[{2,36020001,30}]'),(2,1,'[{0,32140002,1}]','[{2,chest1}]','[{1,0,16000}]','[{2,36020001,30}]'),(3,1,'[{0,16030004,1}]','[{1,302004 }]','[{1,0,12000}]','[{2,36020001,20}]');
/*!40000 ALTER TABLE `base_kf_1vn_auction` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf_1vn_bet`
--

DROP TABLE IF EXISTS `base_kf_1vn_bet`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf_1vn_bet` (
  `turn` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '轮次',
  `ratio` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '赔率',
  PRIMARY KEY (`turn`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服1vn擂台赔率配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf_1vn_bet`
--

LOCK TABLES `base_kf_1vn_bet` WRITE;
/*!40000 ALTER TABLE `base_kf_1vn_bet` DISABLE KEYS */;
INSERT INTO `base_kf_1vn_bet` VALUES (1,150),(2,200),(3,200),(4,200),(5,300),(6,300),(7,300);
/*!40000 ALTER TABLE `base_kf_1vn_bet` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf_1vn_def`
--

DROP TABLE IF EXISTS `base_kf_1vn_def`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf_1vn_def` (
  `sign_min` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '报名人数下限（包含）',
  `sign_max` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '报名人数上限（包含）',
  `def_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '擂主数量',
  `seed_num` smallint(6) unsigned NOT NULL DEFAULT '0' COMMENT '种子选手数量',
  PRIMARY KEY (`sign_min`,`sign_max`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='擂主数量';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf_1vn_def`
--

LOCK TABLES `base_kf_1vn_def` WRITE;
/*!40000 ALTER TABLE `base_kf_1vn_def` DISABLE KEYS */;
INSERT INTO `base_kf_1vn_def` VALUES (1,29,4,3),(30,39,6,4),(40,47,7,5),(48,55,8,6),(56,63,9,6),(64,71,11,7),(72,79,12,8),(80,87,13,9),(88,95,14,10),(96,103,15,10),(104,111,17,11),(112,119,18,12),(120,127,19,13),(128,135,20,14),(136,143,21,14),(144,151,23,15),(152,159,24,16),(160,167,25,17),(168,175,26,18),(176,183,27,18),(184,191,29,19),(192,199,30,20),(200,207,31,21),(208,215,32,22),(216,223,33,22),(224,231,35,23),(232,239,36,24),(240,247,37,25),(248,255,38,26),(256,263,39,26),(264,271,41,27),(272,279,42,28),(280,287,43,29),(288,295,44,30),(296,303,45,30),(304,311,47,31),(312,319,48,32),(320,327,49,33),(328,335,50,34),(336,343,51,34),(344,351,53,35),(352,359,54,36),(360,367,55,37),(368,375,56,38),(376,383,57,38),(384,391,59,39),(392,399,60,40),(400,407,61,41),(408,415,62,42),(416,423,63,42),(424,431,65,43),(432,439,66,44),(440,447,67,45),(448,455,68,46),(456,463,69,46),(464,471,71,47),(472,479,72,48),(480,487,73,49),(488,495,74,50),(496,503,75,50),(504,511,77,51),(512,519,78,52),(520,527,79,53),(528,535,80,54),(536,543,81,54),(544,551,83,55),(552,559,84,56),(560,567,85,57),(568,575,86,58),(576,583,87,58),(584,591,89,59),(592,599,90,60),(600,607,91,61),(608,615,92,62),(616,623,93,62),(624,631,95,63),(632,639,96,64),(640,647,97,65),(648,655,98,66),(656,663,99,66),(664,671,101,67),(672,679,102,68),(680,687,103,69),(688,695,104,70),(696,703,105,70),(704,711,107,71),(712,719,108,72),(720,727,109,73),(728,735,110,74),(736,743,111,74),(744,751,113,75),(752,759,114,76),(760,767,115,77),(768,775,116,78),(776,783,117,78),(784,791,119,79),(792,799,120,80),(800,807,121,81),(808,815,122,82),(816,823,123,82),(824,831,125,83),(832,839,126,84),(840,847,127,85),(848,855,128,86),(856,863,129,86),(864,871,131,87),(872,879,132,88),(880,887,133,89),(888,895,134,90),(896,903,135,90),(904,911,137,91),(912,919,138,92),(920,927,139,93),(928,935,140,94),(936,943,141,94),(944,951,143,95),(952,959,144,96),(960,967,145,97),(968,975,146,98),(976,983,147,98),(984,991,149,99),(992,999,150,100),(1000,1007,151,101),(1008,1015,152,102),(1016,1023,153,102),(1024,1031,155,103),(1032,1039,156,104),(1040,1047,157,105),(1048,1055,158,106),(1056,1063,159,106),(1064,1071,161,107),(1072,1079,162,108),(1080,1087,163,109),(1088,1095,164,110),(1096,1103,165,110),(1104,1111,167,111),(1112,1119,168,112),(1120,1127,169,113),(1128,1135,170,114),(1136,1143,171,114),(1144,1151,173,115),(1152,1159,174,116),(1160,1167,175,117),(1168,1175,176,118),(1176,1183,177,118),(1184,1191,179,119),(1192,1199,180,120),(1200,1207,181,121),(1208,1215,182,122),(1216,1223,183,122),(1224,1231,185,123),(1232,1239,186,124),(1240,1247,187,125),(1248,1255,188,126),(1256,1263,189,126),(1264,1271,191,127),(1272,1279,192,128),(1280,1287,193,129),(1288,1295,194,130),(1296,1303,195,130),(1304,1311,197,131),(1312,1319,198,132),(1320,1327,199,133),(1328,1335,200,134),(1336,1343,201,134),(1344,1351,203,135),(1352,1359,204,136),(1360,1367,205,137),(1368,1375,206,138),(1376,1383,207,138),(1384,1391,209,139),(1392,1399,210,140),(1400,1407,211,141),(1408,1415,212,142),(1416,1423,213,142),(1424,1431,215,143),(1432,1439,216,144),(1440,1447,217,145),(1448,1455,218,146),(1456,1463,219,146),(1464,1471,221,147),(1472,1479,222,148),(1480,1487,223,149),(1488,1495,224,150),(1496,1503,225,150),(1504,1511,227,151),(1512,1519,228,152),(1520,1527,229,153),(1528,1535,230,154),(1536,1543,231,154),(1544,1551,233,155),(1552,1559,234,156),(1560,1567,235,157),(1568,1575,236,158),(1576,1583,237,158),(1584,1591,239,159),(1592,1599,240,160),(1600,1607,241,161),(1608,1615,242,162),(1616,1623,243,162),(1624,1631,245,163),(1632,1639,246,164),(1640,1647,247,165),(1648,1655,248,166),(1656,1663,249,166),(1664,1671,251,167),(1672,1679,252,168),(1680,1687,253,169),(1688,1695,254,170),(1696,1703,255,170),(1704,1711,257,171),(1712,1719,258,172),(1720,1727,259,173),(1728,1735,260,174),(1736,1743,261,174),(1744,1751,263,175),(1752,1759,264,176),(1760,1767,265,177),(1768,1775,266,178),(1776,1783,267,178),(1784,1791,269,179),(1792,1799,270,180),(1800,1807,271,181),(1808,1815,272,182),(1816,1823,273,182),(1824,1831,275,183),(1832,1839,276,184),(1840,1847,277,185),(1848,1855,278,186),(1856,1863,279,186),(1864,1871,281,187),(1872,1879,282,188),(1880,1887,283,189),(1888,1895,284,190),(1896,1903,285,190),(1904,1911,287,191),(1912,1919,288,192),(1920,1927,289,193),(1928,1935,290,194),(1936,1943,291,194),(1944,1951,293,195),(1952,1959,294,196),(1960,1967,295,197),(1968,1975,296,198),(1976,1983,297,198),(1984,1991,299,199),(1992,1999,300,200),(2000,2007,301,201),(2008,2015,302,202),(2016,2023,303,202),(2024,2031,305,203),(2032,2039,306,204),(2040,2047,307,205),(2048,2055,308,206),(2056,2063,309,206),(2064,2071,311,207),(2072,2079,312,208),(2080,2087,313,209),(2088,2095,314,210),(2096,2103,315,210),(2104,2111,317,211),(2112,2119,318,212),(2120,2127,319,213),(2128,2135,320,214),(2136,2143,321,214),(2144,2151,323,215),(2152,2159,324,216),(2160,2167,325,217),(2168,2175,326,218),(2176,2183,327,218),(2184,2191,329,219),(2192,2199,330,220),(2200,2207,331,221),(2208,2215,332,222),(2216,2223,333,222),(2224,2231,335,223),(2232,2239,336,224),(2240,2247,337,225),(2248,2255,338,226),(2256,2263,339,226),(2264,2271,341,227),(2272,2279,342,228),(2280,2287,343,229),(2288,2295,344,230),(2296,2303,345,230),(2304,2311,347,231),(2312,2319,348,232),(2320,2327,349,233),(2328,2335,350,234),(2336,2343,351,234),(2344,2351,353,235),(2352,2359,354,236),(2360,2367,355,237),(2368,2375,356,238),(2376,2383,357,238),(2384,2391,359,239),(2392,2399,360,240),(2400,2407,361,241),(2408,2415,362,242),(2416,2423,363,242),(2424,2431,365,243),(2432,2439,366,244),(2440,2447,367,245),(2448,2455,368,246),(2456,2463,369,246),(2464,2471,371,247),(2472,2479,372,248),(2480,2487,373,249),(2488,2495,374,250),(2496,2503,375,250),(2504,2511,377,251),(2512,2519,378,252),(2520,2527,379,253),(2528,2535,380,254),(2536,2543,381,254),(2544,2551,383,255),(2552,2559,384,256),(2560,2567,385,257),(2568,2575,386,258),(2576,2583,387,258),(2584,2591,389,259),(2592,2599,390,260),(2600,2607,391,261),(2608,2615,392,262),(2616,2623,393,262),(2624,2631,395,263),(2632,2639,396,264),(2640,2647,397,265),(2648,2655,398,266),(2656,2663,399,266),(2664,2671,401,267),(2672,2679,402,268),(2680,2687,403,269),(2688,2695,404,270),(2696,2703,405,270),(2704,2711,407,271),(2712,2719,408,272),(2720,2727,409,273),(2728,2735,410,274),(2736,2743,411,274),(2744,2751,413,275),(2752,2759,414,276),(2760,2767,415,277),(2768,2775,416,278),(2776,2783,417,278),(2784,2791,419,279),(2792,2799,420,280),(2800,2807,421,281),(2808,2815,422,282),(2816,2823,423,282),(2824,2831,425,283),(2832,2839,426,284),(2840,2847,427,285),(2848,2855,428,286),(2856,2863,429,286),(2864,2871,431,287),(2872,2879,432,288),(2880,2887,433,289),(2888,2895,434,290),(2896,2903,435,290),(2904,2911,437,291),(2912,2919,438,292),(2920,2927,439,293),(2928,2935,440,294),(2936,2943,441,294),(2944,2951,443,295),(2952,2959,444,296),(2960,2967,445,297),(2968,2975,446,298),(2976,2983,447,298),(2984,2991,449,299),(2992,2999,450,300),(3000,3007,451,301),(3008,3015,452,302),(3016,3023,453,302),(3024,3031,455,303),(3032,3039,456,304),(3040,3047,457,305),(3048,3055,458,306),(3056,3063,459,306),(3064,3071,461,307),(3072,3079,462,308),(3080,3087,463,309),(3088,3095,464,310),(3096,3103,465,310),(3104,3111,467,311),(3112,3119,468,312),(3120,3127,469,313),(3128,3135,470,314),(3136,3143,471,314),(3144,3151,473,315),(3152,3159,474,316),(3160,3167,475,317),(3168,3175,476,318),(3176,3183,477,318),(3184,3191,479,319),(3192,3199,480,320),(3200,3207,481,321),(3208,3215,482,322),(3216,3223,483,322),(3224,3231,485,323),(3232,3239,486,324),(3240,3247,487,325),(3248,3255,488,326),(3256,3263,489,326),(3264,3271,491,327),(3272,3279,492,328),(3280,3287,493,329),(3288,3295,494,330),(3296,3303,495,330),(3304,3311,497,331),(3312,3319,498,332),(3320,3327,499,333),(3328,3335,500,334),(3336,3343,501,334),(3344,3351,503,335),(3352,3359,504,336),(3360,3367,505,337),(3368,3375,506,338),(3376,3383,507,338),(3384,3391,509,339),(3392,3399,510,340),(3400,3407,511,341),(3408,3415,512,342),(3416,3423,513,342),(3424,3431,515,343),(3432,3439,516,344),(3440,3447,517,345),(3448,3455,518,346),(3456,3463,519,346),(3464,3471,521,347),(3472,3479,522,348),(3480,3487,523,349),(3488,3495,524,350),(3496,3503,525,350),(3504,3511,527,351),(3512,3519,528,352),(3520,3527,529,353),(3528,3535,530,354),(3536,3543,531,354),(3544,3551,533,355),(3552,3559,534,356),(3560,3567,535,357),(3568,3575,536,358),(3576,3583,537,358),(3584,3591,539,359),(3592,3599,540,360),(3600,3607,541,361),(3608,3615,542,362),(3616,3623,543,362),(3624,3631,545,363),(3632,3639,546,364),(3640,3647,547,365),(3648,3655,548,366),(3656,3663,549,366),(3664,3671,551,367),(3672,3679,552,368),(3680,3687,553,369),(3688,3695,554,370),(3696,3703,555,370),(3704,3711,557,371),(3712,3719,558,372),(3720,3727,559,373),(3728,3735,560,374),(3736,3743,561,374),(3744,3751,563,375),(3752,3759,564,376),(3760,3767,565,377),(3768,3775,566,378),(3776,3783,567,378),(3784,3791,569,379),(3792,3799,570,380),(3800,3807,571,381),(3808,3815,572,382),(3816,3823,573,382),(3824,3831,575,383),(3832,3839,576,384),(3840,3847,577,385),(3848,3855,578,386),(3856,3863,579,386),(3864,3871,581,387),(3872,3879,582,388),(3880,3887,583,389),(3888,3895,584,390),(3896,3903,585,390),(3904,3911,587,391),(3912,3919,588,392),(3920,3927,589,393),(3928,3935,590,394),(3936,3943,591,394),(3944,3951,593,395),(3952,3959,594,396),(3960,3967,595,397),(3968,3975,596,398),(3976,3983,597,398),(3984,3991,599,399),(3992,3999,600,400),(4000,4007,601,401),(4008,4015,602,402),(4016,4023,603,402),(4024,4031,605,403),(4032,4039,606,404),(4040,4047,607,405),(4048,4055,608,406),(4056,4063,609,406),(4064,4071,611,407),(4072,4079,612,408),(4080,4087,613,409),(4088,4095,614,410),(4096,4103,615,410),(4104,4111,617,411),(4112,4119,618,412),(4120,4127,619,413),(4128,4135,620,414),(4136,4143,621,414),(4144,4151,623,415),(4152,4159,624,416),(4160,4167,625,417),(4168,4175,626,418),(4176,4183,627,418),(4184,4191,629,419),(4192,4199,630,420),(4200,4207,631,421),(4208,4215,632,422),(4216,4223,633,422),(4224,4231,635,423),(4232,4239,636,424),(4240,4247,637,425),(4248,4255,638,426),(4256,4263,639,426),(4264,4271,641,427),(4272,4279,642,428),(4280,4287,643,429),(4288,4295,644,430),(4296,4303,645,430),(4304,4311,647,431),(4312,4319,648,432),(4320,4327,649,433),(4328,4335,650,434),(4336,4343,651,434),(4344,4351,653,435),(4352,4359,654,436),(4360,4367,655,437),(4368,4375,656,438),(4376,4383,657,438),(4384,4391,659,439),(4392,4399,660,440),(4400,4407,661,441),(4408,4415,662,442),(4416,4423,663,442),(4424,4431,665,443),(4432,4439,666,444),(4440,4447,667,445),(4448,4455,668,446),(4456,4463,669,446),(4464,4471,671,447),(4472,4479,672,448),(4480,4487,673,449),(4488,4495,674,450),(4496,4503,675,450),(4504,4511,677,451),(4512,4519,678,452),(4520,4527,679,453),(4528,4535,680,454),(4536,4543,681,454),(4544,4551,683,455),(4552,4559,684,456),(4560,4567,685,457),(4568,4575,686,458),(4576,4583,687,458),(4584,4591,689,459),(4592,4599,690,460),(4600,4607,691,461),(4608,4615,692,462),(4616,4623,693,462),(4624,4631,695,463),(4632,4639,696,464),(4640,4647,697,465),(4648,4655,698,466),(4656,4663,699,466),(4664,4671,701,467),(4672,4679,702,468),(4680,4687,703,469),(4688,4695,704,470),(4696,4703,705,470),(4704,4711,707,471),(4712,4719,708,472),(4720,4727,709,473),(4728,4735,710,474),(4736,4743,711,474),(4744,4751,713,475),(4752,4759,714,476),(4760,4767,715,477),(4768,4775,716,478),(4776,4783,717,478),(4784,4791,719,479),(4792,4799,720,480),(4800,4807,721,481),(4808,4815,722,482),(4816,4823,723,482),(4824,4831,725,483),(4832,4839,726,484),(4840,4847,727,485),(4848,4855,728,486),(4856,4863,729,486),(4864,4871,731,487),(4872,4879,732,488),(4880,4887,733,489),(4888,4895,734,490),(4896,4903,735,490),(4904,4911,737,491),(4912,4919,738,492),(4920,4927,739,493),(4928,4935,740,494),(4936,4943,741,494),(4944,4951,743,495),(4952,4959,744,496),(4960,4967,745,497),(4968,4975,746,498),(4976,4983,747,498),(4984,4991,749,499),(4992,4999,750,500),(5000,5007,751,501),(5008,5015,752,502),(5016,5023,753,502),(5024,5031,755,503),(5032,5039,756,504),(5040,5047,757,505),(5048,5055,758,506),(5056,5063,759,506),(5064,5071,761,507),(5072,5079,762,508),(5080,5087,763,509),(5088,5095,764,510),(5096,5103,765,510),(5104,5111,767,511),(5112,5119,768,512),(5120,5127,769,513),(5128,5135,770,514),(5136,5143,771,514),(5144,5151,773,515),(5152,5159,774,516),(5160,5167,775,517),(5168,5175,776,518),(5176,5183,777,518),(5184,5191,779,519),(5192,5199,780,520),(5200,5207,781,521),(5208,5215,782,522),(5216,5223,783,522),(5224,5231,785,523),(5232,5239,786,524),(5240,5247,787,525),(5248,5255,788,526),(5256,5263,789,526),(5264,5271,791,527),(5272,5279,792,528),(5280,5287,793,529),(5288,5295,794,530),(5296,5303,795,530),(5304,5311,797,531),(5312,5319,798,532),(5320,5327,799,533),(5328,5335,800,534),(5336,5343,801,534),(5344,5351,803,535),(5352,5359,804,536),(5360,5367,805,537),(5368,5375,806,538),(5376,5383,807,538),(5384,5391,809,539),(5392,5399,810,540),(5400,5407,811,541);
/*!40000 ALTER TABLE `base_kf_1vn_def` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf_1vn_exp`
--

DROP TABLE IF EXISTS `base_kf_1vn_exp`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf_1vn_exp` (
  `min_lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '等级下限',
  `max_lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '等级上限',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '基础经验',
  PRIMARY KEY (`min_lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='1vn经验配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf_1vn_exp`
--

LOCK TABLES `base_kf_1vn_exp` WRITE;
/*!40000 ALTER TABLE `base_kf_1vn_exp` DISABLE KEYS */;
INSERT INTO `base_kf_1vn_exp` VALUES (1,190,24582),(191,200,27194),(201,210,29939),(211,220,32815),(221,230,34597),(231,240,40594),(241,250,42230),(251,260,43932),(261,270,46017),(271,280,45721),(281,290,48192),(291,300,49175),(301,310,48786),(311,320,51906),(321,330,55031),(331,340,55257),(341,350,59359),(351,360,63302),(361,370,95915),(371,380,120692),(381,390,133886),(391,400,147081),(401,410,160275),(411,420,173469),(421,430,186664),(431,440,198878),(441,450,231983),(451,460,254271),(461,470,277550),(471,480,287446),(481,490,297342),(491,500,307238),(501,510,317133),(511,520,352732),(521,530,378002),(531,540,460139),(541,550,510772),(551,560,564044),(561,570,590433),(571,580,616822),(581,590,643210),(591,600,669599),(601,610,695988),(611,620,722377),(621,630,748766),(631,640,775155),(641,650,801544),(651,660,827933),(661,670,854322),(671,680,880710),(681,690,907099),(691,700,933488),(701,710,959877),(711,720,986266),(721,730,1012655),(731,740,1039044),(741,750,1065433),(751,760,1091822),(761,770,1118210),(771,780,1144599),(781,1000,1170988);
/*!40000 ALTER TABLE `base_kf_1vn_exp` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf_1vn_extra_score`
--

DROP TABLE IF EXISTS `base_kf_1vn_extra_score`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf_1vn_extra_score` (
  `id` tinyint(3) unsigned NOT NULL COMMENT '自增id',
  `min_combat` int(11) unsigned NOT NULL COMMENT '最低战力',
  `max_combat` int(11) unsigned NOT NULL COMMENT '最高战力',
  `extra_score` smallint(5) unsigned NOT NULL COMMENT '额外积分',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服1vn额外积分配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf_1vn_extra_score`
--

LOCK TABLES `base_kf_1vn_extra_score` WRITE;
/*!40000 ALTER TABLE `base_kf_1vn_extra_score` DISABLE KEYS */;
INSERT INTO `base_kf_1vn_extra_score` VALUES (1,1,6000000,5),(2,6000001,12000000,10),(3,12000001,20000000,15),(4,20000001,32000000,20),(5,32000001,1000000000,30);
/*!40000 ALTER TABLE `base_kf_1vn_extra_score` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf_1vn_fake_role`
--

DROP TABLE IF EXISTS `base_kf_1vn_fake_role`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf_1vn_fake_role` (
  `id` smallint(5) unsigned NOT NULL COMMENT '自增id',
  `type` tinyint(2) unsigned NOT NULL COMMENT '比赛阶段1资格赛2挑战赛',
  `area` tinyint(2) unsigned NOT NULL COMMENT '战区',
  `hard` smallint(5) unsigned NOT NULL COMMENT '难度评级',
  `fake_role_lv` smallint(5) unsigned NOT NULL COMMENT '假人等级',
  `fake_role_combat` varchar(255) NOT NULL COMMENT '假人战力',
  `ratio` tinyint(3) unsigned NOT NULL COMMENT '假人悉数（百分比）',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服1vn假人配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf_1vn_fake_role`
--

LOCK TABLES `base_kf_1vn_fake_role` WRITE;
/*!40000 ALTER TABLE `base_kf_1vn_fake_role` DISABLE KEYS */;
INSERT INTO `base_kf_1vn_fake_role` VALUES (1,1,1,1,186,'{396900,413100}',100),(2,1,1,2,230,'{793800,826200}',100),(3,1,1,3,247,'{1190700,1239300}',100),(4,1,1,4,265,'{1587600,1652400}',100),(5,1,1,5,285,'{1984500,2065500}',100),(6,1,1,6,303,'{2381400,2478600}',100),(7,1,1,7,318,'{2778300,2891700}',100),(8,1,1,8,333,'{3175200,3304800}',100),(9,1,1,9,348,'{3572100,3717900}',100),(10,1,1,10,358,'{3969000,4131000}',100),(11,1,1,11,368,'{4365900,4544100}',100),(12,1,1,12,378,'{4762800,4957200}',100),(13,1,1,13,389,'{5159700,5370300}',100),(14,1,1,14,399,'{5556600,5783400}',100),(15,1,1,15,410,'{5953500,6196500}',100),(16,1,1,16,422,'{6350400,6609600}',100),(17,1,1,17,434,'{6747300,7022700}',100),(18,1,1,18,445,'{7144200,7435800}',100),(19,1,1,19,454,'{7541100,7848900}',100),(20,1,1,20,462,'{7938000,8262000}',100),(21,1,1,21,470,'{8334900,8675100}',100),(22,1,1,22,477,'{8731800,9088200}',100),(23,1,1,23,485,'{9128700,9501300}',100),(24,1,1,24,493,'{9525600,9914400}',100),(25,1,1,25,500,'{9922500,10327500}',100),(26,1,1,26,506,'{10319400,10740600}',100),(27,1,1,27,512,'{10716300,11153700}',100),(28,1,1,28,519,'{11113200,11566800}',100),(29,1,1,29,525,'{11510100,11979900}',100),(30,1,1,30,531,'{11907000,12393000}',100),(31,1,1,31,537,'{12303900,12806100}',100),(32,1,1,32,543,'{12700800,13219200}',100),(33,1,1,33,549,'{13097700,13632300}',100),(34,1,1,34,555,'{13494600,14045400}',100),(35,1,1,35,562,'{13891500,14458500}',100),(36,1,1,36,568,'{14288400,14871600}',100),(37,1,1,37,574,'{14685300,15284700}',100),(38,1,1,38,580,'{15082200,15697800}',100),(39,1,1,39,587,'{15479100,16110900}',100),(40,1,1,40,593,'{15876000,16524000}',100),(41,1,1,41,599,'{16272900,16937100}',100),(42,1,1,42,605,'{16669800,17350200}',100),(43,1,1,43,610,'{17066700,17763300}',100),(44,1,1,44,615,'{17463600,18176400}',100),(45,1,1,45,621,'{17860500,18589500}',100),(46,1,1,46,626,'{18257400,19002600}',100),(47,1,1,47,631,'{18654300,19415700}',100),(48,1,1,48,637,'{19051200,19828800}',100),(49,1,1,49,642,'{19448100,20241900}',100),(50,1,1,50,647,'{19845000,20655000}',100),(51,1,1,51,652,'{20241900,21068100}',100),(52,1,1,52,657,'{20638800,21481200}',100),(53,1,1,53,662,'{21035700,21894300}',100),(54,1,1,54,667,'{21432600,22307400}',100),(55,1,1,55,672,'{21829500,22720500}',100),(56,1,1,56,676,'{22226400,23133600}',100),(57,1,1,57,681,'{22623300,23546700}',100),(58,1,1,58,686,'{23020200,23959800}',100),(59,1,1,59,691,'{23417100,24372900}',100),(60,1,1,60,695,'{23814000,24786000}',100),(61,1,1,61,700,'{24210900,25199100}',100),(62,1,1,62,706,'{24607800,25612200}',100),(63,1,1,63,711,'{25004700,26025300}',100),(64,1,1,64,716,'{25401600,26438400}',100),(65,1,1,65,721,'{25798500,26851500}',100),(66,1,1,66,727,'{26195400,27264600}',100),(67,1,1,67,732,'{26592300,27677700}',100),(68,1,1,68,737,'{26989200,28090800}',100),(69,1,1,69,742,'{27386100,28503900}',100),(70,1,1,70,748,'{27783000,28917000}',100),(71,1,1,71,753,'{28179900,29330100}',100),(72,1,1,72,757,'{28576800,29743200}',100),(73,1,1,73,762,'{28973700,30156300}',100),(74,1,1,74,766,'{29370600,30569400}',100),(75,1,1,75,771,'{29767500,30982500}',100),(76,1,1,76,776,'{30164400,31395600}',100),(77,1,1,77,780,'{30561300,31808700}',100),(78,1,1,78,785,'{30958200,32221800}',100),(79,1,1,79,789,'{31355100,32634900}',100),(80,1,1,80,794,'{31752000,33048000}',100),(81,1,1,81,799,'{32148900,33461100}',100),(82,1,1,82,800,'{32545800,33874200}',100),(83,1,1,83,800,'{32942700,34287300}',100),(84,1,1,84,800,'{33339600,34700400}',100),(85,1,1,85,800,'{33736500,35113500}',100),(86,1,1,86,800,'{34133400,35526600}',100),(87,1,1,87,800,'{34530300,35939700}',100),(88,1,1,88,800,'{34927200,36352800}',100),(89,1,1,89,800,'{35324100,36765900}',100),(90,1,1,90,800,'{35721000,37179000}',100),(91,1,2,1,191,'{441000,459000}',100),(92,1,2,2,233,'{882000,918000}',100),(93,1,2,3,253,'{1323000,1377000}',100),(94,1,2,4,274,'{1764000,1836000}',100),(95,1,2,5,296,'{2205000,2295000}',100),(96,1,2,6,313,'{2646000,2754000}',100),(97,1,2,7,329,'{3087000,3213000}',100),(98,1,2,8,346,'{3528000,3672000}',100),(99,1,2,9,358,'{3969000,4131000}',100),(100,1,2,10,370,'{4410000,4590000}',100),(101,1,2,11,381,'{4851000,5049000}',100),(102,1,2,12,392,'{5292000,5508000}',100),(103,1,2,13,404,'{5733000,5967000}',100),(104,1,2,14,417,'{6174000,6426000}',100),(105,1,2,15,430,'{6615000,6885000}',100),(106,1,2,16,443,'{7056000,7344000}',100),(107,1,2,17,454,'{7497000,7803000}',100),(108,1,2,18,462,'{7938000,8262000}',100),(109,1,2,19,471,'{8379000,8721000}',100),(110,1,2,20,479,'{8820000,9180000}',100),(111,1,2,21,488,'{9261000,9639000}',100),(112,1,2,22,496,'{9702000,10098000}',100),(113,1,2,23,504,'{10143000,10557000}',100),(114,1,2,24,510,'{10584000,11016000}',100),(115,1,2,25,517,'{11025000,11475000}',100),(116,1,2,26,524,'{11466000,11934000}',100),(117,1,2,27,531,'{11907000,12393000}',100),(118,1,2,28,537,'{12348000,12852000}',100),(119,1,2,29,544,'{12789000,13311000}',100),(120,1,2,30,551,'{13230000,13770000}',100),(121,1,2,31,558,'{13671000,14229000}',100),(122,1,2,32,565,'{14112000,14688000}',100),(123,1,2,33,572,'{14553000,15147000}',100),(124,1,2,34,579,'{14994000,15606000}',100),(125,1,2,35,586,'{15435000,16065000}',100),(126,1,2,36,593,'{15876000,16524000}',100),(127,1,2,37,600,'{16317000,16983000}',100),(128,1,2,38,606,'{16758000,17442000}',100),(129,1,2,39,612,'{17199000,17901000}',100),(130,1,2,40,618,'{17640000,18360000}',100),(131,1,2,41,624,'{18081000,18819000}',100),(132,1,2,42,630,'{18522000,19278000}',100),(133,1,2,43,636,'{18963000,19737000}',100),(134,1,2,44,642,'{19404000,20196000}',100),(135,1,2,45,647,'{19845000,20655000}',100),(136,1,2,46,653,'{20286000,21114000}',100),(137,1,2,47,658,'{20727000,21573000}',100),(138,1,2,48,664,'{21168000,22032000}',100),(139,1,2,49,669,'{21609000,22491000}',100),(140,1,2,50,674,'{22050000,22950000}',100),(141,1,2,51,680,'{22491000,23409000}',100),(142,1,2,52,685,'{22932000,23868000}',100),(143,1,2,53,690,'{23373000,24327000}',100),(144,1,2,54,695,'{23814000,24786000}',100),(145,1,2,55,701,'{24255000,25245000}',100),(146,1,2,56,707,'{24696000,25704000}',100),(147,1,2,57,713,'{25137000,26163000}',100),(148,1,2,58,718,'{25578000,26622000}',100),(149,1,2,59,724,'{26019000,27081000}',100),(150,1,2,60,730,'{26460000,27540000}',100),(151,1,2,61,736,'{26901000,27999000}',100),(152,1,2,62,742,'{27342000,28458000}',100),(153,1,2,63,748,'{27783000,28917000}',100),(154,1,2,64,753,'{28224000,29376000}',100),(155,1,2,65,758,'{28665000,29835000}',100),(156,1,2,66,763,'{29106000,30294000}',100),(157,1,2,67,768,'{29547000,30753000}',100),(158,1,2,68,774,'{29988000,31212000}',100),(159,1,2,69,779,'{30429000,31671000}',100),(160,1,2,70,784,'{30870000,32130000}',100),(161,1,2,71,789,'{31311000,32589000}',100),(162,1,2,72,794,'{31752000,33048000}',100),(163,1,2,73,799,'{32193000,33507000}',100),(164,1,2,74,800,'{32634000,33966000}',100),(165,1,2,75,800,'{33075000,34425000}',100),(166,1,2,76,800,'{33516000,34884000}',100),(167,1,2,77,800,'{33957000,35343000}',100),(168,1,2,78,800,'{34398000,35802000}',100),(169,1,2,79,800,'{34839000,36261000}',100),(170,1,2,80,800,'{35280000,36720000}',100),(171,1,2,81,800,'{35721000,37179000}',100),(172,1,2,82,800,'{36162000,37638000}',100),(173,1,2,83,800,'{36603000,38097000}',100),(174,1,2,84,800,'{37044000,38556000}',100),(175,1,2,85,800,'{37485000,39015000}',100),(176,1,2,86,800,'{37926000,39474000}',100),(177,1,2,87,800,'{38367000,39933000}',100),(178,1,2,88,800,'{38808000,40392000}',100),(179,1,2,89,800,'{39249000,40851000}',100),(180,1,2,90,800,'{39690000,41310000}',100),(181,2,1,1,186,'{396900,413100}',100),(182,2,1,2,230,'{793800,826200}',100),(183,2,1,3,247,'{1190700,1239300}',100),(184,2,1,4,265,'{1587600,1652400}',100),(185,2,1,5,285,'{1984500,2065500}',100),(186,2,1,6,303,'{2381400,2478600}',100),(187,2,1,7,318,'{2778300,2891700}',100),(188,2,1,8,333,'{3175200,3304800}',100),(189,2,1,9,348,'{3572100,3717900}',100),(190,2,1,10,358,'{3969000,4131000}',100),(191,2,1,11,368,'{4365900,4544100}',100),(192,2,1,12,378,'{4762800,4957200}',100),(193,2,1,13,389,'{5159700,5370300}',100),(194,2,1,14,399,'{5556600,5783400}',100),(195,2,1,15,410,'{5953500,6196500}',100),(196,2,1,16,422,'{6350400,6609600}',100),(197,2,1,17,434,'{6747300,7022700}',100),(198,2,1,18,445,'{7144200,7435800}',100),(199,2,1,19,454,'{7541100,7848900}',100),(200,2,1,20,462,'{7938000,8262000}',100),(201,2,1,21,470,'{8334900,8675100}',100),(202,2,1,22,477,'{8731800,9088200}',100),(203,2,1,23,485,'{9128700,9501300}',100),(204,2,1,24,493,'{9525600,9914400}',100),(205,2,1,25,500,'{9922500,10327500}',100),(206,2,1,26,506,'{10319400,10740600}',100),(207,2,1,27,512,'{10716300,11153700}',100),(208,2,1,28,519,'{11113200,11566800}',100),(209,2,1,29,525,'{11510100,11979900}',100),(210,2,1,30,531,'{11907000,12393000}',100),(211,2,1,31,537,'{12303900,12806100}',100),(212,2,1,32,543,'{12700800,13219200}',100),(213,2,1,33,549,'{13097700,13632300}',100),(214,2,1,34,555,'{13494600,14045400}',100),(215,2,1,35,562,'{13891500,14458500}',100),(216,2,1,36,568,'{14288400,14871600}',100),(217,2,1,37,574,'{14685300,15284700}',100),(218,2,1,38,580,'{15082200,15697800}',100),(219,2,1,39,587,'{15479100,16110900}',100),(220,2,1,40,593,'{15876000,16524000}',100),(221,2,1,41,599,'{16272900,16937100}',100),(222,2,1,42,605,'{16669800,17350200}',100),(223,2,1,43,610,'{17066700,17763300}',100),(224,2,1,44,615,'{17463600,18176400}',100),(225,2,1,45,621,'{17860500,18589500}',100),(226,2,1,46,626,'{18257400,19002600}',100),(227,2,1,47,631,'{18654300,19415700}',100),(228,2,1,48,637,'{19051200,19828800}',100),(229,2,1,49,642,'{19448100,20241900}',100),(230,2,1,50,647,'{19845000,20655000}',100),(231,2,1,51,652,'{20241900,21068100}',100),(232,2,1,52,657,'{20638800,21481200}',100),(233,2,1,53,662,'{21035700,21894300}',100),(234,2,1,54,667,'{21432600,22307400}',100),(235,2,1,55,672,'{21829500,22720500}',100),(236,2,1,56,676,'{22226400,23133600}',100),(237,2,1,57,681,'{22623300,23546700}',100),(238,2,1,58,686,'{23020200,23959800}',100),(239,2,1,59,691,'{23417100,24372900}',100),(240,2,1,60,695,'{23814000,24786000}',100),(241,2,1,61,700,'{24210900,25199100}',100),(242,2,1,62,706,'{24607800,25612200}',100),(243,2,1,63,711,'{25004700,26025300}',100),(244,2,1,64,716,'{25401600,26438400}',100),(245,2,1,65,721,'{25798500,26851500}',100),(246,2,1,66,727,'{26195400,27264600}',100),(247,2,1,67,732,'{26592300,27677700}',100),(248,2,1,68,737,'{26989200,28090800}',100),(249,2,1,69,742,'{27386100,28503900}',100),(250,2,1,70,748,'{27783000,28917000}',100),(251,2,1,71,753,'{28179900,29330100}',100),(252,2,1,72,757,'{28576800,29743200}',100),(253,2,1,73,762,'{28973700,30156300}',100),(254,2,1,74,766,'{29370600,30569400}',100),(255,2,1,75,771,'{29767500,30982500}',100),(256,2,1,76,776,'{30164400,31395600}',100),(257,2,1,77,780,'{30561300,31808700}',100),(258,2,1,78,785,'{30958200,32221800}',100),(259,2,1,79,789,'{31355100,32634900}',100),(260,2,1,80,794,'{31752000,33048000}',100),(261,2,1,81,799,'{32148900,33461100}',100),(262,2,1,82,800,'{32545800,33874200}',100),(263,2,1,83,800,'{32942700,34287300}',100),(264,2,1,84,800,'{33339600,34700400}',100),(265,2,1,85,800,'{33736500,35113500}',100),(266,2,1,86,800,'{34133400,35526600}',100),(267,2,1,87,800,'{34530300,35939700}',100),(268,2,1,88,800,'{34927200,36352800}',100),(269,2,1,89,800,'{35324100,36765900}',100),(270,2,1,90,800,'{35721000,37179000}',100),(271,2,2,1,191,'{441000,459000}',100),(272,2,2,2,233,'{882000,918000}',100),(273,2,2,3,253,'{1323000,1377000}',100),(274,2,2,4,274,'{1764000,1836000}',100),(275,2,2,5,296,'{2205000,2295000}',100),(276,2,2,6,313,'{2646000,2754000}',100),(277,2,2,7,329,'{3087000,3213000}',100),(278,2,2,8,346,'{3528000,3672000}',100),(279,2,2,9,358,'{3969000,4131000}',100),(280,2,2,10,370,'{4410000,4590000}',100),(281,2,2,11,381,'{4851000,5049000}',100),(282,2,2,12,392,'{5292000,5508000}',100),(283,2,2,13,404,'{5733000,5967000}',100),(284,2,2,14,417,'{6174000,6426000}',100),(285,2,2,15,430,'{6615000,6885000}',100),(286,2,2,16,443,'{7056000,7344000}',100),(287,2,2,17,454,'{7497000,7803000}',100),(288,2,2,18,462,'{7938000,8262000}',100),(289,2,2,19,471,'{8379000,8721000}',100),(290,2,2,20,479,'{8820000,9180000}',100),(291,2,2,21,488,'{9261000,9639000}',100),(292,2,2,22,496,'{9702000,10098000}',100),(293,2,2,23,504,'{10143000,10557000}',100),(294,2,2,24,510,'{10584000,11016000}',100),(295,2,2,25,517,'{11025000,11475000}',100),(296,2,2,26,524,'{11466000,11934000}',100),(297,2,2,27,531,'{11907000,12393000}',100),(298,2,2,28,537,'{12348000,12852000}',100),(299,2,2,29,544,'{12789000,13311000}',100),(300,2,2,30,551,'{13230000,13770000}',100),(301,2,2,31,558,'{13671000,14229000}',100),(302,2,2,32,565,'{14112000,14688000}',100),(303,2,2,33,572,'{14553000,15147000}',100),(304,2,2,34,579,'{14994000,15606000}',100),(305,2,2,35,586,'{15435000,16065000}',100),(306,2,2,36,593,'{15876000,16524000}',100),(307,2,2,37,600,'{16317000,16983000}',100),(308,2,2,38,606,'{16758000,17442000}',100),(309,2,2,39,612,'{17199000,17901000}',100),(310,2,2,40,618,'{17640000,18360000}',100),(311,2,2,41,624,'{18081000,18819000}',100),(312,2,2,42,630,'{18522000,19278000}',100),(313,2,2,43,636,'{18963000,19737000}',100),(314,2,2,44,642,'{19404000,20196000}',100),(315,2,2,45,647,'{19845000,20655000}',100),(316,2,2,46,653,'{20286000,21114000}',100),(317,2,2,47,658,'{20727000,21573000}',100),(318,2,2,48,664,'{21168000,22032000}',100),(319,2,2,49,669,'{21609000,22491000}',100),(320,2,2,50,674,'{22050000,22950000}',100),(321,2,2,51,680,'{22491000,23409000}',100),(322,2,2,52,685,'{22932000,23868000}',100),(323,2,2,53,690,'{23373000,24327000}',100),(324,2,2,54,695,'{23814000,24786000}',100),(325,2,2,55,701,'{24255000,25245000}',100),(326,2,2,56,707,'{24696000,25704000}',100),(327,2,2,57,713,'{25137000,26163000}',100),(328,2,2,58,718,'{25578000,26622000}',100),(329,2,2,59,724,'{26019000,27081000}',100),(330,2,2,60,730,'{26460000,27540000}',100),(331,2,2,61,736,'{26901000,27999000}',100),(332,2,2,62,742,'{27342000,28458000}',100),(333,2,2,63,748,'{27783000,28917000}',100),(334,2,2,64,753,'{28224000,29376000}',100),(335,2,2,65,758,'{28665000,29835000}',100),(336,2,2,66,763,'{29106000,30294000}',100),(337,2,2,67,768,'{29547000,30753000}',100),(338,2,2,68,774,'{29988000,31212000}',100),(339,2,2,69,779,'{30429000,31671000}',100),(340,2,2,70,784,'{30870000,32130000}',100),(341,2,2,71,789,'{31311000,32589000}',100),(342,2,2,72,794,'{31752000,33048000}',100),(343,2,2,73,799,'{32193000,33507000}',100),(344,2,2,74,800,'{32634000,33966000}',100),(345,2,2,75,800,'{33075000,34425000}',100),(346,2,2,76,800,'{33516000,34884000}',100),(347,2,2,77,800,'{33957000,35343000}',100),(348,2,2,78,800,'{34398000,35802000}',100),(349,2,2,79,800,'{34839000,36261000}',100),(350,2,2,80,800,'{35280000,36720000}',100),(351,2,2,81,800,'{35721000,37179000}',100),(352,2,2,82,800,'{36162000,37638000}',100),(353,2,2,83,800,'{36603000,38097000}',100),(354,2,2,84,800,'{37044000,38556000}',100),(355,2,2,85,800,'{37485000,39015000}',100),(356,2,2,86,800,'{37926000,39474000}',100),(357,2,2,87,800,'{38367000,39933000}',100),(358,2,2,88,800,'{38808000,40392000}',100),(359,2,2,89,800,'{39249000,40851000}',100),(360,2,2,90,800,'{39690000,41310000}',100);
/*!40000 ALTER TABLE `base_kf_1vn_fake_role` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf_1vn_group`
--

DROP TABLE IF EXISTS `base_kf_1vn_group`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf_1vn_group` (
  `hard` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '难度系数',
  `robot_args` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '机器人系数(百分比)',
  `height` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '人数权重',
  PRIMARY KEY (`hard`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='分组配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf_1vn_group`
--

LOCK TABLES `base_kf_1vn_group` WRITE;
/*!40000 ALTER TABLE `base_kf_1vn_group` DISABLE KEYS */;
INSERT INTO `base_kf_1vn_group` VALUES (1,51,100),(2,52,100),(3,53,100),(4,54,100),(5,55,100),(6,56,100),(7,57,100),(8,58,100),(9,59,100),(10,60,100),(11,61,100),(12,62,100),(13,63,100),(14,64,100),(15,65,100),(16,66,100),(17,67,100),(18,68,100),(19,69,100),(20,70,100),(21,71,100),(22,72,100),(23,73,100),(24,74,100),(25,75,100),(26,76,100),(27,77,100),(28,78,100),(29,79,100),(30,80,100),(31,81,100),(32,82,100),(33,83,100),(34,84,100),(35,85,100),(36,86,100),(37,87,100),(38,88,100),(39,89,100),(40,90,100),(41,91,100),(42,92,100),(43,93,100),(44,94,100),(45,95,100),(46,96,100),(47,97,100),(48,98,100),(49,99,100),(50,100,100),(51,101,100),(52,102,100),(53,103,100),(54,104,100),(55,105,100),(56,106,100),(57,107,100),(58,108,100),(59,109,100),(60,110,100);
/*!40000 ALTER TABLE `base_kf_1vn_group` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf_1vn_hard`
--

DROP TABLE IF EXISTS `base_kf_1vn_hard`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf_1vn_hard` (
  `id` tinyint(3) unsigned NOT NULL COMMENT '自增id',
  `min_combat` int(11) unsigned NOT NULL COMMENT '战力下限',
  `max_combat` int(11) unsigned NOT NULL COMMENT '战力上限',
  `hard` tinyint(3) unsigned NOT NULL COMMENT '难度评级',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服1vn难度评级配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf_1vn_hard`
--

LOCK TABLES `base_kf_1vn_hard` WRITE;
/*!40000 ALTER TABLE `base_kf_1vn_hard` DISABLE KEYS */;
INSERT INTO `base_kf_1vn_hard` VALUES (1,0,500000,1),(2,500001,1000000,2),(3,1000001,1500000,3),(4,1500001,2000000,4),(5,2000001,2500000,5),(6,2500001,3000000,6),(7,3000001,3500000,7),(8,3500001,4000000,8),(9,4000001,4500000,9),(10,4500001,5000000,10),(11,5000001,5500000,11),(12,5500001,6000000,12),(13,6000001,6500000,13),(14,6500001,7000000,14),(15,7000001,7500000,15),(16,7500001,8000000,16),(17,8000001,8500000,17),(18,8500001,9000000,18),(19,9000001,9500000,19),(20,9500001,10000000,20),(21,10000001,10500000,21),(22,10500001,11000000,22),(23,11000001,11500000,23),(24,11500001,12000000,24),(25,12000001,12500000,25),(26,12500001,13000000,26),(27,13000001,13500000,27),(28,13500001,14000000,28),(29,14000001,14500000,29),(30,14500001,15000000,30),(31,15000001,15500000,31),(32,15500001,16000000,32),(33,16000001,16500000,33),(34,16500001,17000000,34),(35,17000001,17500000,35),(36,17500001,18000000,36),(37,18000001,18500000,37),(38,18500001,19000000,38),(39,19000001,19500000,39),(40,19500001,20000000,40),(41,20000001,20500000,41),(42,20500001,21000000,42),(43,21000001,21500000,43),(44,21500001,22000000,44),(45,22000001,22500000,45),(46,22500001,23000000,46),(47,23000001,23500000,47),(48,23500001,24000000,48),(49,24000001,24500000,49),(50,24500001,25000000,50),(51,25000001,25500000,51),(52,25500001,26000000,52),(53,26000001,26500000,53),(54,26500001,27000000,54),(55,27000001,27500000,55),(56,27500001,28000000,56),(57,28000001,28500000,57),(58,28500001,29000000,58),(59,29000001,29500000,59),(60,29500001,30000000,60),(61,30000001,30500000,61),(62,30500001,31000000,62),(63,31000001,31500000,63),(64,31500001,32000000,64),(65,32000001,32500000,65),(66,32500001,33000000,66),(67,33000001,33500000,67),(68,33500001,34000000,68),(69,34000001,34500000,69),(70,34500001,35000000,70),(71,35000001,35500000,71),(72,35500001,36000000,72),(73,36000001,36500000,73),(74,36500001,37000000,74),(75,37000001,37500000,75),(76,37500001,38000000,76),(77,38000001,38500000,77),(78,38500001,39000000,78),(79,39000001,39500000,79),(80,39500001,40000000,80),(81,40000001,40500000,81),(82,40500001,41000000,82),(83,41000001,41500000,83),(84,41500001,42000000,84),(85,42000001,42500000,85),(86,42500001,43000000,86),(87,43000001,43500000,87),(88,43500001,44000000,88),(89,44000001,44500000,89),(90,44500001,999000000,90);
/*!40000 ALTER TABLE `base_kf_1vn_hard` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf_1vn_kv`
--

DROP TABLE IF EXISTS `base_kf_1vn_kv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf_1vn_kv` (
  `key` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '键',
  `value` text NOT NULL COMMENT '值',
  `desc` varchar(200) NOT NULL DEFAULT '[]' COMMENT '备注',
  PRIMARY KEY (`key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='1vn键值配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf_1vn_kv`
--

LOCK TABLES `base_kf_1vn_kv` WRITE;
/*!40000 ALTER TABLE `base_kf_1vn_kv` DISABLE KEYS */;
INSERT INTO `base_kf_1vn_kv` VALUES (1,'360','开启等级'),(2,'[{4461,4524}, {5304,4524}]','资格赛战斗坐标'),(3,'[{3783,4636}]','挑战赛擂主出生点'),(4,'[{5621,5240},{6146,5223},{6635,5249},{5699,4584},{6478,4619},{7117,4680},{5883,4260},{6557,4278},{7204,4243},{5822,3902},{6443,3989},{7099,3989},{5586,5467},{5901,5922},{6417,6272},{5276,3727},{6329,3184},{6242,4286},{5866,3333},{5358,5844},{6067,5118},{6329,4610},{6355,4855},{6452,4286},{6819,5091},{6041,5494},{5883,3980},{5577,5669},{6583,4094},{6215,4531},{6487,4899},{6294,4488}]','挑战赛挑战者出生点,随机选取一个'),(5,'[{2887,6604,300},{4844,6478,300},{3488,5766,300},{2293,3369,300},{3902,3540,300},{4592,3184,300},{1704,2077,300},{4914,1335,300}]','准备场景出生点,格式:[{圆心坐标X,圆心坐标Y,圆半径}]'),(6,'40','竞赛时间'),(7,'200','开活动的最低人数'),(8,'200','每个战区的最低人数'),(9,'60','拍卖全服邮件最低等级（发送包含）'),(10,'7110','资格赛战斗场景'),(11,'7112','资格赛备战场景'),(12,'7111','守擂赛战斗场景'),(13,'7113','守擂赛备战场景'),(14,'38220004','代金券'),(15,'20','资格赛战败积分'),(16,'50','资格赛获胜积分'),(17,'10','资格赛最多打几场'),(18,'[{1,10},{2,20},{3,30},{4,40},{5,60},{6,80},{7,100}]','擂主经验加成，格式：[{轮次，加成（百分制）}]'),(19,'[{1,[{0,4912004,1}]},{2,[{0,4912004,1}]}]','守擂赛全胜奖励，格式[{战区ID,[{类型，id，数量}]}]'),(20,'48','1VN竞拍、商店持续时间（小时）'),(21,'[20,30,50]','竞猜金额种类（绑钻）'),(22,'15','资格赛少于多少秒不匹配'),(23,'15','开服多少天以后才开启'),(24,'500000','单位难度评分战力');
/*!40000 ALTER TABLE `base_kf_1vn_kv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf_1vn_match`
--

DROP TABLE IF EXISTS `base_kf_1vn_match`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf_1vn_match` (
  `stage` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '阶段',
  `area` tinyint(3) unsigned NOT NULL COMMENT '战区',
  `hard_list` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '难度评分列表',
  `c_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '挑战者人数',
  `all_hard` varchar(255) NOT NULL DEFAULT '[]' COMMENT '难度上下限',
  PRIMARY KEY (`stage`,`area`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='擂台赛匹配规则';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf_1vn_match`
--

LOCK TABLES `base_kf_1vn_match` WRITE;
/*!40000 ALTER TABLE `base_kf_1vn_match` DISABLE KEYS */;
INSERT INTO `base_kf_1vn_match` VALUES (1,1,'[4,6]',2,'[8,12]'),(2,1,'[5,8]',4,'[24,28]'),(3,1,'[6,10]',6,'[42,54]'),(4,1,'[6,10]',9,'[61,81]'),(5,1,'[8,12]',12,'[108,132]'),(6,1,'[10,14]',15,'[165,195]'),(7,1,'[12,16]',18,'[234,270]');
/*!40000 ALTER TABLE `base_kf_1vn_match` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf_1vn_race_2_award`
--

DROP TABLE IF EXISTS `base_kf_1vn_race_2_award`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf_1vn_race_2_award` (
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '奖励类型(1擂主|2挑战者)',
  `turn` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '轮次',
  `win_award` varchar(500) NOT NULL DEFAULT '[]' COMMENT '胜利奖励',
  `lose_award` varchar(500) NOT NULL DEFAULT '[]' COMMENT '失败奖励',
  PRIMARY KEY (`type`,`turn`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服1vn擂台奖励表）';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf_1vn_race_2_award`
--

LOCK TABLES `base_kf_1vn_race_2_award` WRITE;
/*!40000 ALTER TABLE `base_kf_1vn_race_2_award` DISABLE KEYS */;
INSERT INTO `base_kf_1vn_race_2_award` VALUES (1,1,'[{0,14120001,40}]','[{0,14120001,25}]'),(1,2,'[{0,14120001,60}]','[{0,14120001,35}]'),(1,3,'[{0,14120001,80}]','[{0,14120001,45}]'),(1,4,'[{0,14120001,100}]','[{0,14120001,60}]'),(1,5,'[{0,14120001,120}]','[{0,14120001,75}]'),(1,6,'[{0,14120001,140}]','[{0,14120001,90}]'),(1,7,'[{0,14120001,160}]','[{0,14120001,105}]'),(2,1,'[{0,14120001,30}]','[{0,14120001,15}]'),(2,2,'[{0,14120001,40}]','[{0,14120001,20}]'),(2,3,'[{0,14120001,50}]','[{0,14120001,25}]'),(2,4,'[{0,14120001,65}]','[{0,14120001,30}]'),(2,5,'[{0,14120001,80}]','[{0,14120001,40}]'),(2,6,'[{0,14120001,95}]','[{0,14120001,50}]'),(2,7,'[{0,14120001,110}]','[{0,14120001,60}]');
/*!40000 ALTER TABLE `base_kf_1vn_race_2_award` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf_1vn_score_reward`
--

DROP TABLE IF EXISTS `base_kf_1vn_score_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf_1vn_score_reward` (
  `race_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '排名类型',
  `rank_min` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名下限（包含）',
  `rank_max` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名上限（包含）',
  `rewards` varchar(200) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`race_type`,`rank_min`,`rank_max`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='积分奖励';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf_1vn_score_reward`
--

LOCK TABLES `base_kf_1vn_score_reward` WRITE;
/*!40000 ALTER TABLE `base_kf_1vn_score_reward` DISABLE KEYS */;
INSERT INTO `base_kf_1vn_score_reward` VALUES (1,1,1,'[{0,14120001,300}]'),(1,2,2,'[{0,14120001,250}]'),(1,3,3,'[{0,14120001,220}]'),(1,4,5,'[{0,14120001,200}]'),(1,6,20,'[{0,14120001,180}]'),(1,21,50,'[{0,14120001,150}]'),(1,51,200,'[{0,14120001,120}]'),(1,201,500,'[{0,14120001,90}]'),(1,501,10000,'[{0,14120001,60}]'),(2,1,1,'[{0,14120001,450},{0,14110001,20},{0,4912003,1},{0,38220004,1000}]'),(2,2,2,'[{0,14120001,380},{0,14110001,16},{0,4912002,1},{0,38220004,850}]'),(2,3,3,'[{0,14120001,320},{0,14110001,12},{0,4912001,1},{0,38220004,700}]'),(2,4,5,'[{0,14120001,270},{0,14110001,10},{0,38220004,600}]'),(2,6,20,'[{0,14120001,220},{0,14110001,8},{0,38220004,500}]'),(2,21,50,'[{0,14120001,180},{0,14110001,6},{0,38220004,400}]'),(2,51,200,'[{0,14120001,150},{0,14110001,4},{0,38220004,300}]'),(2,201,500,'[{0,14120001,120},{0,14110001,4},{0,38220004,200}]'),(2,501,10000,'[{0,14120001,100},{0,14110001,4}]');
/*!40000 ALTER TABLE `base_kf_1vn_score_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf_1vn_time`
--

DROP TABLE IF EXISTS `base_kf_1vn_time`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf_1vn_time` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动id',
  `open_week` varchar(50) NOT NULL DEFAULT '[]' COMMENT '星期几开启[1,2...7]',
  `signtime` varchar(50) NOT NULL DEFAULT '[]' COMMENT '报名开启{时，分}',
  `optime` varchar(200) NOT NULL DEFAULT '[]' COMMENT '开启时间{时，分}',
  `race_1_pre` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '资格赛准备时间(s)',
  `race_1` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '资格赛时间(s)',
  `race_1_m_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '资格赛匹配时间(s)',
  `race_1_b_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '资格赛战斗时间(s)',
  `race_2_pre` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '挑战赛准备时间(s)',
  `race_2` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '挑战赛时间(s)',
  `race_2_m_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '挑战赛匹配时间(s)',
  `race_2_b_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '挑战赛战斗时间(s)',
  `bet_time` smallint(5) unsigned DEFAULT '0' COMMENT '竞猜时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='1vn时间配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf_1vn_time`
--

LOCK TABLES `base_kf_1vn_time` WRITE;
/*!40000 ALTER TABLE `base_kf_1vn_time` DISABLE KEYS */;
INSERT INTO `base_kf_1vn_time` VALUES (1,'[7]','{0,1}','{20,58}',120,700,30,40,60,980,10,90,40);
/*!40000 ALTER TABLE `base_kf_1vn_time` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf_boss_collect_cfg`
--

DROP TABLE IF EXISTS `base_kf_boss_collect_cfg`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf_boss_collect_cfg` (
  `collect_mon_id` int(11) unsigned NOT NULL COMMENT '采集怪id',
  `scene_id` int(11) unsigned NOT NULL COMMENT '场景id',
  `floor` tinyint(3) unsigned NOT NULL COMMENT '层数',
  `max_time` tinyint(3) unsigned NOT NULL COMMENT '采集上限次数',
  `born_loc` varchar(255) NOT NULL COMMENT '刷新坐标',
  PRIMARY KEY (`collect_mon_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服boss采集配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf_boss_collect_cfg`
--

LOCK TABLES `base_kf_boss_collect_cfg` WRITE;
/*!40000 ALTER TABLE `base_kf_boss_collect_cfg` DISABLE KEYS */;
/*!40000 ALTER TABLE `base_kf_boss_collect_cfg` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf_boss_kv_cfg`
--

DROP TABLE IF EXISTS `base_kf_boss_kv_cfg`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf_boss_kv_cfg` (
  `id` tinyint(3) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `value` varchar(255) NOT NULL COMMENT '常量值',
  `tips` varchar(255) NOT NULL COMMENT '描述',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=10 DEFAULT CHARSET=utf8 COMMENT='跨服boss常量配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf_boss_kv_cfg`
--

LOCK TABLES `base_kf_boss_kv_cfg` WRITE;
/*!40000 ALTER TABLE `base_kf_boss_kv_cfg` DISABLE KEYS */;
INSERT INTO `base_kf_boss_kv_cfg` VALUES (1,'60','关注boss复活前多少秒提示（s）'),(2,'5','同步排行榜的时间间隔（s）'),(3,'100','排行榜最大长度'),(4,'3','第N次复活后只能使用钻石（包括第N次）'),(5,'10','伤害清空时间'),(6,'335','开启等级'),(7,'5','每日采集次数上限'),(8,'3','跨服boss疲劳值'),(9,'12','开服天数限制');
/*!40000 ALTER TABLE `base_kf_boss_kv_cfg` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf_boss_monster_cfg`
--

DROP TABLE IF EXISTS `base_kf_boss_monster_cfg`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf_boss_monster_cfg` (
  `boss_id` int(11) unsigned NOT NULL COMMENT 'boss_id',
  `scene_id` int(11) unsigned NOT NULL COMMENT '出生场景id',
  `born_x` int(11) unsigned NOT NULL COMMENT '出生坐标X',
  `born_y` int(11) unsigned NOT NULL COMMENT '出生坐标Y',
  `layer` tinyint(3) unsigned NOT NULL COMMENT '层数',
  `revive` int(11) unsigned NOT NULL COMMENT '重生时间（s）',
  `fix_reward` varchar(255) NOT NULL COMMENT '固定掉落',
  `random_reward` varchar(2048) NOT NULL COMMENT '随机掉落',
  `reward_lv_limit` smallint(5) unsigned NOT NULL COMMENT '掉落等级限制',
  `enter_limit` varchar(255) NOT NULL COMMENT '进入条件',
  `icon_id` varchar(255) NOT NULL COMMENT '图标id',
  `crush_attr` varchar(512) NOT NULL DEFAULT '[]' COMMENT '碾压属性',
  `recommend_attr` varchar(512) NOT NULL DEFAULT '[]' COMMENT '推荐属性',
  `stage` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '阶数',
  `recommon_lv` varchar(255) NOT NULL DEFAULT '[]' COMMENT '推荐等级',
  `drop_lv` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '掉率级别',
  PRIMARY KEY (`boss_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服boss怪物配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf_boss_monster_cfg`
--

LOCK TABLES `base_kf_boss_monster_cfg` WRITE;
/*!40000 ALTER TABLE `base_kf_boss_monster_cfg` DISABLE KEYS */;
INSERT INTO `base_kf_boss_monster_cfg` VALUES (6301001,6301,10200,8500,1,1800,'[]','[{0,21040004,1},{0,21040003,1},{0,21040002,1},{0,21010202,1},{0,21010105,1},{0,21010107,1},{0,21010103,1},{0,21010106,1},{0,21010104,1}]',100,'[{min_lv,335}, {star_shadow_combat,0}]','1203011','[]','[{2,1635798},{4,27375}]',8,'[{330,350}]',1),(6301002,6301,3700,9800,1,1800,'[]','[{0,21040004,1},{0,21040003,1},{0,21040001,1},{0,21010202,1},{0,21010201,1},{0,21010105,1},{0,21010103,1},{0,21010102,1},{0,21010106,1}]',100,'[{min_lv,335}, {star_shadow_combat,0}]','1201006','[]','[{2,1907768},{4,31771}]',8,'[{340,360}]',2),(6301003,6301,12800,3700,1,1800,'[]','[{0,21040004,1},{0,21040003,1},{0,21040002,1},{0,21010201,1},{0,21010202,1},{0,21010106,1},{0,21010107,1},{0,21010104,1},{0,21010103,1}]',100,'[{min_lv,335}, {star_shadow_combat,0}]','1203002','[]','[{2,2274509},{4,37740}]',8,'[{350,370}]',3),(6301004,6301,10900,14900,1,2400,'[]','[{0,21040004,1},{0,21040003,1},{0,21040001,1},{0,21010203,1},{0,21010107,1},{0,21010101,1},{0,21010102,1},{0,21010103,1},{0,21010108,1}]',100,'[{min_lv,335}, {star_shadow_combat,200000}]','1201002','[]','[{2,2416407},{4,40033}]',9,'[{365,385}]',1),(6301005,6301,17300,8300,1,2400,'[]','[{0,21040004,1},{0,21040003,1},{0,21040002,1},{0,21010204,1},{0,21010205,1},{0,21010203,1},{0,21010101,1},{0,21010110,1},{0,21010107,1}]',100,'[{min_lv,335}, {star_shadow_combat,200000}]','1201003','[]','[{2,2964177},{4,47115}]',9,'[{385,405}]',2),(6301006,6301,21500,11400,1,2400,'[]','[{0,21040004,1},{0,21040003,1},{0,21040001,1},{0,21010205,1},{0,21010206,1},{0,21010207,1},{0,21010110,1},{0,21010103,1},{0,21010102,1}]',100,'[{min_lv,335}, {star_shadow_combat,300000}]','1203006','[]','[{2,3411264},{4,52528}]',9,'[{405,425}]',3),(6302001,6302,10200,8500,2,3000,'[]','[{0,21040004,1},{0,21040003,1},{0,21040002,1},{0,21010505,1},{0,21010506,1},{0,21010502,1},{0,21010207,1},{0,21010205,1},{0,21010204,1}]',100,'[{min_lv,380}, {star_shadow_combat,360000}]','1201007','[]','[{2,3634808},{4,55234}]',10,'[{425,445}]',1),(6302002,6302,3700,9800,2,3000,'[]','[{0,21040004,1},{0,21040003,1},{0,21040001,1},{0,21010507,1},{0,21010502,1},{0,21010207,1},{0,21010209,1},{0,21010109,1},{0,21010102,1}]',100,'[{min_lv,380}, {star_shadow_combat,520000}]','1203001','[]','[{2,4165129},{4,64540}]',10,'[{445,465}]',2),(6302003,6302,12800,3700,2,3000,'[]','[{0,21040004,1},{0,21040003,1},{0,21040002,1},{0,21010510,1},{0,21010505,1},{0,21010302,1},{0,21010209,1},{0,21010103,1},{0,21010102,1}]',100,'[{min_lv,380}, {star_shadow_combat,620000}]','1202001','[]','[{2,4695450},{4,73845}]',10,'[{465,485}]',3),(6302004,6302,10900,14900,2,3600,'[]','[{0,21040004,1},{0,21040003,1},{0,21040001,1},{0,21010510,1},{0,21010508,1},{0,21010301,1},{0,21010302,1},{0,21010110,1},{0,21010104,1}]',100,'[{min_lv,380}, {star_shadow_combat,750000}]','1203007','[]','[{2,4960611},{4,78497}]',11,'[{485,505}]',1),(6302005,6302,17300,8300,2,3600,'[]','[{0,21040004,1},{0,21040003,1},{0,21040002,1},{0,21010511,1},{0,21010504,1},{0,21010301,1},{0,21010304,1},{0,21010103,1},{0,21010104,1}]',100,'[{min_lv,380}, {star_shadow_combat,850000}]','1203003','[]','[{2,5481225},{4,88088}]',11,'[{505,525}]',2),(6302006,6302,21500,11400,2,3600,'[]','[{0,21040004,1},{0,21040003,1},{0,21040001,1},{0,21010512,1},{0,21010504,1},{0,21010305,1},{0,21010309,1},{0,21010102,1},{0,21010104,1}]',100,'[{min_lv,380}, {star_shadow_combat,950000}]','1202005','[]','[{2,6001840},{4,97678}]',11,'[{525,545}]',3),(6303001,6303,10200,8500,3,4500,'[]','[{0,21040004,1},{0,21040003,1},{0,21040002,1},{0,21010902,1},{0,21010906,1},{0,21010511,1},{0,21010602,1},{0,21010401,1},{0,21010402,1}]',100,'[{min_lv,420}, {star_shadow_combat,950000}]','1203011','[]','[{2,6512633},{4,106572}]',12,'[{545,565}]',1),(6303002,6303,3700,9800,3,4500,'[]','[{0,21040004,1},{0,21040003,1},{0,21040001,1},{0,21010910,1},{0,21010908,1},{0,21010902,1},{0,21010601,1},{0,21010602,1},{0,21010406,1}]',100,'[{min_lv,420}, {star_shadow_combat,1700000}]','1201002','[]','[{2,7050925},{4,117386}]',12,'[{565,585}]',2),(6303003,6303,12800,3700,3,4500,'[]','[{0,21040004,1},{0,21040003,1},{0,21040002,1},{0,21010909,1},{0,21010908,1},{0,21010903,1},{0,21010603,1},{0,21010605,1},{0,21010303,1}]',100,'[{min_lv,420}, {star_shadow_combat,2100000}]','1202005','[]','[{2,7589217},{4,128200}]',12,'[{585,605}]',3),(6303004,6303,10900,14900,3,5400,'[]','[{0,21040004,1},{0,21040003,1},{0,21040001,1},{0,21010901,1},{0,21010908,1},{0,21010911,1},{0,21010607,1},{0,21010609,1},{0,21010209,1}]',100,'[{min_lv,420}, {star_shadow_combat,2500000}]','1203006','[]','[{2,7858363},{4,133607}]',13,'[{605,625}]',1),(6303005,6303,17300,8300,3,5400,'[]','[{0,21040004,1},{0,21040003,1},{0,21040002,1},{0,21010912,1},{0,21010904,1},{0,21010911,1},{0,21010606,1},{0,21010705,1},{0,21010411,1}]',100,'[{min_lv,420}, {star_shadow_combat,3200000}]','1203002','[]','[{2,8764879},{4,148951}]',13,'[{625,645}]',2),(6303006,6303,21500,11400,3,5400,'[]','[{0,21040004,1},{0,21040003,1},{0,21040001,1},{0,21010701,1},{0,21010707,1},{0,21010402,1},{0,21010401,1},{0,21010107,1},{0,21010108,1}]',100,'[{min_lv,420}, {star_shadow_combat,3500000}]','1201007','[]','[{2,9671395},{4,164295}]',13,'[{645,665}]',3),(6304001,6304,10200,8500,4,6300,'[]','[{0,21040004,1},{0,21040003,1},{0,21040002,1},{0,21030001,1},{0,21011001,1},{0,21011003,1},{0,21010508,1},{0,21010503,1},{0,21010208,1}]',100,'[{min_lv,480}, {star_shadow_combat,3500000}]','1202003','[]','[{2,10124652},{4,171967}]',14,'[{665,685}]',1),(6304002,6304,3700,9800,4,6300,'[]','[{0,21040004,1},{0,21040003,1},{0,21040001,1},{0,21030001,1},{0,21011010,1},{0,21010605,1},{0,21010802,1},{0,21010308,1},{0,21010401,1}]',100,'[{min_lv,480}, {star_shadow_combat,4800000}]','1201004','[]','[{2,10993108},{4,188368}]',14,'[{685,705}]',2),(6304003,6304,12800,3700,4,6300,'[]','[{0,21040004,1},{0,21040003,1},{0,21040002,1},{0,21030001,1},{0,21011106,1},{0,21011105,1},{0,21010608,1},{0,21010505,1},{0,21010204,1}]',100,'[{min_lv,480}, {star_shadow_combat,5500000}]','1201007','[]','[{2,11861564},{4,204768}]',14,'[{705,725}]',3),(6304004,6304,10900,14900,4,7200,'[]','[{0,21040004,1},{0,21040003,1},{0,21040001,1},{0,21030001,1},{0,21011109,1},{0,21011103,1},{0,21010705,1},{0,21010707,1},{0,21010411,1}]',100,'[{min_lv,480}, {star_shadow_combat,6400000}]','1203011','[]','[{2,12295792},{4,212968}]',15,'[{725,745}]',1),(6304005,6304,17300,8300,4,7200,'[]','[{0,21040004,1},{0,21040003,1},{0,21040002,1},{0,21030001,1},{0,21011203,1},{0,21011211,1},{0,21010806,1},{0,21010604,1},{0,21010203,1}]',100,'[{min_lv,480}, {star_shadow_combat,7500000}]','1201002','[]','[{2,13229230},{4,232630}]',15,'[{745,765}]',2),(6304006,6304,21500,11400,4,7200,'[]','[{0,21040004,1},{0,21040003,1},{0,21040001,1},{0,21030001,1},{0,21011208,1},{0,21011207,1},{0,21010510,1},{0,21010802,1},{0,21010410,1}]',100,'[{min_lv,480}, {star_shadow_combat,9000000}]','1202005','[]','[{2,14162667},{4,252292}]',15,'[{765,785}]',3);
/*!40000 ALTER TABLE `base_kf_boss_monster_cfg` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf_boss_rank_cfg`
--

DROP TABLE IF EXISTS `base_kf_boss_rank_cfg`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf_boss_rank_cfg` (
  `boss_id` int(11) unsigned NOT NULL COMMENT 'boss_id',
  `min_rank` smallint(5) unsigned NOT NULL COMMENT '最小排名',
  `max_rank` smallint(5) unsigned NOT NULL COMMENT '最大排名',
  `reward` varchar(1024) NOT NULL COMMENT '奖励列表',
  PRIMARY KEY (`boss_id`,`min_rank`,`max_rank`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服boss排名配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf_boss_rank_cfg`
--

LOCK TABLES `base_kf_boss_rank_cfg` WRITE;
/*!40000 ALTER TABLE `base_kf_boss_rank_cfg` DISABLE KEYS */;
INSERT INTO `base_kf_boss_rank_cfg` VALUES (6301001,1,1,'1|2080301:1=2340;1|2080501:1=176;1|2080601:1=47;1|2080302:1=336;1|2080502:1=27;1|2080602:1=6;1|1080303:1=336;1|1080503:1=27;0|1080603:1=6;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;1|1080401:1=1384,1080402:1=934,1070403:1=319,1080201:1=2074,1080202:1=1401,1070203:1=479,1080201:1=3409'),(6301001,2,2,'1|2080301:1=2106;1|2080501:1=140;1|2080601:1=47;1|2080302:1=316;1|2080502:1=25;1|2080602:1=6;1|1080303:1=316;1|1080503:1=25;0|1080603:1=6;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;1|1080401:1=1384,1080402:1=934,1070403:1=319,1080201:1=2074,1080202:1=1401,1070203:1=479,1080201:1=3409'),(6301001,3,3,'1|2080301:1=1755;1|2080501:1=152;1|2080601:1=47;1|2080302:1=293;1|2080502:1=23;1|2080602:1=6;1|1080303:1=293;1|1080503:1=23;0|1080603:1=6;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;1|1080401:1=1384,1080402:1=934,1070403:1=319,1080201:1=2074,1080202:1=1401,1070203:1=479,1080201:1=3409'),(6301001,4,5,'1|2080301:1=1404;1|2080501:1=140;1|2080601:1=47;1|2080302:1=249;1|2080502:1=20;1|2080602:1=6;1|1080303:1=249;1|1080503:1=20;0|1080603:1=6;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;1|1080401:1=1384,1080402:1=934,1070403:1=319,1080201:1=2074,1080202:1=1401,1070203:1=479,1080201:1=3409'),(6301001,6,10,'1|2080301:1=1170;1|2080501:1=117;1|2080601:1=47;1|2080302:1=234;1|2080502:1=19;1|2080602:1=6;1|1080303:1=234;1|1080503:1=19;0|1080603:1=6;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;1|1080401:1=1384,1080402:1=934,1070403:1=319,1080201:1=2074,1080202:1=1401,1070203:1=479,1080201:1=3409'),(6301002,1,1,'1|2080301:1=2548;1|2080501:1=191;1|2080601:1=51;1|2080302:1=366;1|2080502:1=29;1|2080602:1=6;1|1080303:1=366;1|1080503:1=29;0|1080603:1=6;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;1|1080401:1=1384,1080402:1=934,1070403:1=319,1080201:1=2074,1080202:1=1401,1070203:1=479,1080201:1=3409'),(6301002,2,2,'1|2080301:1=2293;1|2080501:1=153;1|2080601:1=51;1|2080302:1=344;1|2080502:1=28;1|2080602:1=6;1|1080303:1=344;1|1080503:1=28;0|1080603:1=6;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;1|1080401:1=1384,1080402:1=934,1070403:1=319,1080201:1=2074,1080202:1=1401,1070203:1=479,1080201:1=3409'),(6301002,3,3,'1|2080301:1=1911;1|2080501:1=166;1|2080601:1=51;1|2080302:1=319;1|2080502:1=25;1|2080602:1=6;1|1080303:1=319;1|1080503:1=25;0|1080603:1=6;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;1|1080401:1=1384,1080402:1=934,1070403:1=319,1080201:1=2074,1080202:1=1401,1070203:1=479,1080201:1=3409'),(6301002,4,5,'1|2080301:1=1529;1|2080501:1=153;1|2080601:1=51;1|2080302:1=271;1|2080502:1=22;1|2080602:1=6;1|1080303:1=271;1|1080503:1=22;0|1080603:1=6;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;1|1080401:1=1384,1080402:1=934,1070403:1=319,1080201:1=2074,1080202:1=1401,1070203:1=479,1080201:1=3409'),(6301002,6,10,'1|2080301:1=1274;1|2080501:1=127;1|2080601:1=51;1|2080302:1=255;1|2080502:1=20;1|2080602:1=6;1|1080303:1=255;1|1080503:1=20;0|1080603:1=6;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;1|1080401:1=1384,1080402:1=934,1070403:1=319,1080201:1=2074,1080202:1=1401,1070203:1=479,1080201:1=3409'),(6301003,1,1,'1|2080301:1=2756;1|2080501:1=207;1|2080601:1=55;1|2080302:1=396;1|2080502:1=32;1|2080602:1=7;1|1080303:1=396;1|1080503:1=32;0|1080603:1=7;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;1|1080401:1=1384,1080402:1=934,1070403:1=319,1080201:1=2074,1080202:1=1401,1070203:1=479,1080201:1=3409'),(6301003,2,2,'1|2080301:1=2480;1|2080501:1=165;1|2080601:1=55;1|2080302:1=372;1|2080502:1=30;1|2080602:1=7;1|1080303:1=372;1|1080503:1=30;0|1080603:1=7;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;1|1080401:1=1384,1080402:1=934,1070403:1=319,1080201:1=2074,1080202:1=1401,1070203:1=479,1080201:1=3409'),(6301003,3,3,'1|2080301:1=2067;1|2080501:1=179;1|2080601:1=55;1|2080302:1=345;1|2080502:1=28;1|2080602:1=7;1|1080303:1=345;1|1080503:1=28;0|1080603:1=7;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;1|1080401:1=1384,1080402:1=934,1070403:1=319,1080201:1=2074,1080202:1=1401,1070203:1=479,1080201:1=3409'),(6301003,4,5,'1|2080301:1=1654;1|2080501:1=165;1|2080601:1=55;1|2080302:1=293;1|2080502:1=23;1|2080602:1=7;1|1080303:1=293;1|1080503:1=23;0|1080603:1=7;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;1|1080401:1=1384,1080402:1=934,1070403:1=319,1080201:1=2074,1080202:1=1401,1070203:1=479,1080201:1=3409'),(6301003,6,10,'1|2080301:1=1378;1|2080501:1=138;1|2080601:1=55;1|2080302:1=276;1|2080502:1=22;1|2080602:1=7;1|1080303:1=276;1|1080503:1=22;0|1080603:1=7;4|1080101:1=6000,1080102:1=1500,1080103:1=2500;1|1080401:1=1384,1080402:1=934,1070403:1=319,1080201:1=2074,1080202:1=1401,1070203:1=479,1080201:1=3409'),(6301004,1,1,'1|2090301:1=2223;1|2090501:1=178;1|2090601:1=30;1|2090302:1=511;1|2090502:1=26;1|2090602:1=7;1|1090303:1=682;1|1090503:1=26;0|1090603:1=7;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;1|1090401:1=1464,1090402:1=885,1080403:1=301,1090201:1=2196,1090202:1=1328,1080203:1=451,1090201:1=3375'),(6301004,2,2,'1|2090301:1=1778;1|2090501:1=148;1|2090601:1=30;1|2090302:1=480;1|2090502:1=24;1|2090602:1=7;1|1090303:1=640;1|1090503:1=24;0|1090603:1=7;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;1|1090401:1=1464,1090402:1=885,1080403:1=301,1090201:1=2196,1090202:1=1328,1080203:1=451,1090201:1=3375'),(6301004,3,3,'1|2090301:1=1482;1|2090501:1=133;1|2090601:1=30;1|2090302:1=445;1|2090502:1=22;1|2090602:1=7;1|1090303:1=593;1|1090503:1=22;0|1090603:1=7;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;1|1090401:1=1464,1090402:1=885,1080403:1=301,1090201:1=2196,1090202:1=1328,1080203:1=451,1090201:1=3375'),(6301004,4,5,'1|1090301:1=1186;1|1090501:1=104;1|1090601:1=30;1|1090302:1=378;1|1090502:1=19;1|1090602:1=7;1|1090303:1=504;1|1090503:1=19;0|1090603:1=7;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;1|1090401:1=1464,1090402:1=885,1080403:1=301,1090201:1=2196,1090202:1=1328,1080203:1=451,1090201:1=3375'),(6301004,6,10,'1|1090301:1=1186;1|1090501:1=89;1|1090601:1=30;1|1090302:1=356;1|1090502:1=18;1|1090602:1=7;1|1090303:1=474;1|1090503:1=18;0|1090603:1=7;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;1|1090401:1=1464,1090402:1=885,1080403:1=301,1090201:1=2196,1090202:1=1328,1080203:1=451,1090201:1=3375'),(6301005,1,1,'1|1090301:1=2379;1|1090501:1=190;1|1090601:1=32;1|1090302:1=547;1|1090502:1=27;1|1090602:1=8;1|1090303:1=730;1|1090503:1=27;0|1090603:1=8;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;1|1090401:1=1464,1090402:1=885,1080403:1=301,1090201:1=2196,1090202:1=1328,1080203:1=451,1090201:1=3375'),(6301005,2,2,'1|1090301:1=1903;1|1090501:1=159;1|1090601:1=32;1|1090302:1=514;1|1090502:1=26;1|1090602:1=8;1|1090303:1=685;1|1090503:1=26;0|1090603:1=8;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;1|1090401:1=1464,1090402:1=885,1080403:1=301,1090201:1=2196,1090202:1=1328,1080203:1=451,1090201:1=3375'),(6301005,3,3,'1|1090301:1=1586;1|1090501:1=143;1|1090601:1=32;1|1090302:1=476;1|1090502:1=24;1|1090602:1=8;1|1090303:1=634;1|1090503:1=24;0|1090603:1=8;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;1|1090401:1=1464,1090402:1=885,1080403:1=301,1090201:1=2196,1090202:1=1328,1080203:1=451,1090201:1=3375'),(6301005,4,5,'1|1090301:1=1269;1|1090501:1=111;1|1090601:1=32;1|1090302:1=404;1|1090502:1=20;1|1090602:1=8;1|1090303:1=539;1|1090503:1=20;0|1090603:1=8;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;1|1090401:1=1464,1090402:1=885,1080403:1=301,1090201:1=2196,1090202:1=1328,1080203:1=451,1090201:1=3375'),(6301005,6,10,'1|2090301:1=1269;1|2090501:1=95;1|2090601:1=32;1|2090302:1=381;1|2090502:1=19;1|2090602:1=8;1|1090303:1=508;1|1090503:1=19;0|1090603:1=8;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;1|1090401:1=1464,1090402:1=885,1080403:1=301,1090201:1=2196,1090202:1=1328,1080203:1=451,1090201:1=3375'),(6301006,1,1,'1|2090301:1=2535;1|2090501:1=203;1|2090601:1=34;1|2090302:1=583;1|2090502:1=29;1|2090602:1=8;1|1090303:1=777;1|1090503:1=29;0|1090603:1=8;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;1|1090401:1=1464,1090402:1=885,1080403:1=301,1090201:1=2196,1090202:1=1328,1080203:1=451,1090201:1=3375'),(6301006,2,2,'1|2090301:1=2028;1|2090501:1=169;1|2090601:1=34;1|2090302:1=548;1|2090502:1=27;1|2090602:1=8;1|1090303:1=730;1|1090503:1=27;0|1090603:1=8;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;1|1090401:1=1464,1090402:1=885,1080403:1=301,1090201:1=2196,1090202:1=1328,1080203:1=451,1090201:1=3375'),(6301006,3,3,'1|2090301:1=1690;1|2090501:1=152;1|2090601:1=34;1|2090302:1=507;1|2090502:1=25;1|2090602:1=8;1|1090303:1=676;1|1090503:1=25;0|1090603:1=8;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;1|1090401:1=1464,1090402:1=885,1080403:1=301,1090201:1=2196,1090202:1=1328,1080203:1=451,1090201:1=3375'),(6301006,4,5,'1|2090301:1=1352;1|2090501:1=118;1|2090601:1=34;1|2090302:1=431;1|2090502:1=22;1|2090602:1=8;1|1090303:1=575;1|1090503:1=22;0|1090603:1=8;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;1|1090401:1=1464,1090402:1=885,1080403:1=301,1090201:1=2196,1090202:1=1328,1080203:1=451,1090201:1=3375'),(6301006,6,10,'1|2090301:1=1352;1|2090501:1=101;1|2090601:1=34;1|2090302:1=406;1|2090502:1=20;1|2090602:1=8;1|1090303:1=541;1|1090503:1=20;0|1090603:1=8;4|1090101:1=6000,1090102:1=1500,1090103:1=2500;1|1090401:1=1464,1090402:1=885,1080403:1=301,1090201:1=2196,1090202:1=1328,1080203:1=451,1090201:1=3375'),(6302001,1,1,'1|2100301:1=1170;1|2100501:1=117;1|2100601:1=23;1|2100302:1=404;1|2100502:1=20;1|2100602:1=6;1|1100303:1=538;1|1100503:1=20;0|1100603:1=6;4|1100101:1=6000,1100102:1=1500,1100103:1=2500;1|1100401:1=1544,1100402:1=836,1090403:1=283,1100201:1=2315,1100202:1=1255,1090203:1=425,1100201:1=3342'),(6302001,2,2,'1|2100301:1=1170;1|2100501:1=105;1|2100601:1=23;1|2100302:1=379;1|2100502:1=19;1|2100602:1=6;1|1100303:1=505;1|1100503:1=19;0|1100603:1=6;4|1100101:1=6000,1100102:1=1500,1100103:1=2500;1|1100401:1=1544,1100402:1=836,1090403:1=283,1100201:1=2315,1100202:1=1255,1090203:1=425,1100201:1=3342'),(6302001,3,3,'1|2100301:1=1053;1|2100501:1=94;1|2100601:1=23;1|2100302:1=351;1|2100502:1=18;1|2100602:1=6;1|1100303:1=468;1|1100503:1=18;0|1100603:1=6;4|1100101:1=6000,1100102:1=1500,1100103:1=2500;1|1100401:1=1544,1100402:1=836,1090403:1=283,1100201:1=2315,1100202:1=1255,1090203:1=425,1100201:1=3342'),(6302001,4,5,'1|2100301:1=936;1|2100501:1=82;1|2100601:1=23;1|2100302:1=298;1|2100502:1=15;1|2100602:1=6;1|1100303:1=398;1|1100503:1=15;0|1100603:1=6;4|1100101:1=6000,1100102:1=1500,1100103:1=2500;1|1100401:1=1544,1100402:1=836,1090403:1=283,1100201:1=2315,1100202:1=1255,1090203:1=425,1100201:1=3342'),(6302001,6,10,'1|2100301:1=819;1|2100501:1=70;1|2100601:1=23;1|2100302:1=281;1|2100502:1=14;1|2100602:1=6;1|1100303:1=374;1|1100503:1=14;0|1100603:1=6;4|1100101:1=6000,1100102:1=1500,1100103:1=2500;1|1100401:1=1544,1100402:1=836,1090403:1=283,1100201:1=2315,1100202:1=1255,1090203:1=425,1100201:1=3342'),(6302002,1,1,'1|2100301:1=1274;1|2100501:1=127;1|2100601:1=25;1|2100302:1=440;1|2100502:1=22;1|2100602:1=6;1|1100303:1=586;1|1100503:1=22;0|1100603:1=6;4|1100101:1=6000,1100102:1=1500,1100103:1=2500;1|1100401:1=1544,1100402:1=836,1090403:1=283,1100201:1=2315,1100202:1=1255,1090203:1=425,1100201:1=3342'),(6302002,2,2,'1|2100301:1=1274;1|2100501:1=115;1|2100601:1=25;1|2100302:1=413;1|2100502:1=21;1|2100602:1=6;1|1100303:1=550;1|1100503:1=21;0|1100603:1=6;4|1100101:1=6000,1100102:1=1500,1100103:1=2500;1|1100401:1=1544,1100402:1=836,1090403:1=283,1100201:1=2315,1100202:1=1255,1090203:1=425,1100201:1=3342'),(6302002,3,3,'1|2100301:1=1147;1|2100501:1=102;1|2100601:1=25;1|2100302:1=382;1|2100502:1=19;1|2100602:1=6;1|1100303:1=510;1|1100503:1=19;0|1100603:1=6;4|1100101:1=6000,1100102:1=1500,1100103:1=2500;1|1100401:1=1544,1100402:1=836,1090403:1=283,1100201:1=2315,1100202:1=1255,1090203:1=425,1100201:1=3342'),(6302002,4,5,'1|2100301:1=1019;1|2100501:1=89;1|2100601:1=25;1|2100302:1=325;1|2100502:1=16;1|2100602:1=6;1|1100303:1=433;1|1100503:1=16;0|1100603:1=6;4|1100101:1=6000,1100102:1=1500,1100103:1=2500;1|1100401:1=1544,1100402:1=836,1090403:1=283,1100201:1=2315,1100202:1=1255,1090203:1=425,1100201:1=3342'),(6302002,6,10,'1|2100301:1=892;1|2100501:1=76;1|2100601:1=25;1|2100302:1=306;1|2100502:1=15;1|2100602:1=6;1|1100303:1=408;1|1100503:1=15;0|1100603:1=6;4|1100101:1=6000,1100102:1=1500,1100103:1=2500;1|1100401:1=1544,1100402:1=836,1090403:1=283,1100201:1=2315,1100202:1=1255,1090203:1=425,1100201:1=3342'),(6302003,1,1,'1|2100301:1=1378;1|2100501:1=138;1|2100601:1=28;1|2100302:1=475;1|2100502:1=24;1|2100602:1=7;1|1100303:1=634;1|1100503:1=24;0|1100603:1=7;4|1100101:1=6000,1100102:1=1500,1100103:1=2500;1|1100401:1=1544,1100402:1=836,1090403:1=283,1100201:1=2315,1100202:1=1255,1090203:1=425,1100201:1=3342'),(6302003,2,2,'1|2100301:1=1378;1|2100501:1=124;1|2100601:1=28;1|2100302:1=446;1|2100502:1=22;1|2100602:1=7;1|1100303:1=595;1|1100503:1=22;0|1100603:1=7;4|1100101:1=6000,1100102:1=1500,1100103:1=2500;1|1100401:1=1544,1100402:1=836,1090403:1=283,1100201:1=2315,1100202:1=1255,1090203:1=425,1100201:1=3342'),(6302003,3,3,'1|1100301:1=1240;1|1100501:1=110;1|1100601:1=28;1|1100302:1=413;1|1100502:1=21;1|1100602:1=7;1|1100303:1=551;1|1100503:1=21;0|1100603:1=7;4|1100101:1=6000,1100102:1=1500,1100103:1=2500;1|1100401:1=1544,1100402:1=836,1090403:1=283,1100201:1=2315,1100202:1=1255,1090203:1=425,1100201:1=3342'),(6302003,4,5,'1|1100301:1=1102;1|1100501:1=96;1|1100601:1=28;1|1100302:1=351;1|1100502:1=18;1|1100602:1=7;1|1100303:1=469;1|1100503:1=18;0|1100603:1=7;4|1100101:1=6000,1100102:1=1500,1100103:1=2500;1|1100401:1=1544,1100402:1=836,1090403:1=283,1100201:1=2315,1100202:1=1255,1090203:1=425,1100201:1=3342'),(6302003,6,10,'1|1100301:1=965;1|1100501:1=83;1|1100601:1=28;1|1100302:1=331;1|1100502:1=17;1|1100602:1=7;1|1100303:1=441;1|1100503:1=17;0|1100603:1=7;4|1100101:1=6000,1100102:1=1500,1100103:1=2500;1|1100401:1=1544,1100402:1=836,1090403:1=283,1100201:1=2315,1100202:1=1255,1090203:1=425,1100201:1=3342'),(6302004,1,1,'1|1110301:1=1482;1|1110501:1=148;1|1110601:1=30;1|1110302:1=511;1|1110502:1=26;1|1110602:1=7;1|1110303:1=341;1|1110503:1=17;0|1110603:1=7;4|1110101:1=6000,1110102:1=1500,1110103:1=2500;1|1110401:1=1624,1110402:1=788,1100403:1=266,1110201:1=2436,1110202:1=1182,1100203:1=399,1110201:1=3305'),(6302004,2,2,'1|1110301:1=1482;1|1110501:1=133;1|1110601:1=30;1|1110302:1=480;1|1110502:1=24;1|1110602:1=7;1|1110303:1=320;1|1110503:1=16;0|1110603:1=7;4|1110101:1=6000,1110102:1=1500,1110103:1=2500;1|1110401:1=1624,1110402:1=788,1100403:1=266,1110201:1=2436,1110202:1=1182,1100203:1=399,1110201:1=3305'),(6302004,3,3,'1|1110301:1=1334;1|1110501:1=119;1|1110601:1=30;1|1110302:1=445;1|1110502:1=22;1|1110602:1=7;1|1110303:1=296;1|1110503:1=15;0|1110603:1=7;4|1110101:1=6000,1110102:1=1500,1110103:1=2500;1|1110401:1=1624,1110402:1=788,1100403:1=266,1110201:1=2436,1110202:1=1182,1100203:1=399,1110201:1=3305'),(6302004,4,5,'1|2110301:1=1186;1|2110501:1=104;1|2110601:1=30;1|2110302:1=378;1|2110502:1=19;1|2110602:1=7;1|1110303:1=252;1|1110503:1=13;0|1110603:1=7;4|1110101:1=6000,1110102:1=1500,1110103:1=2500;1|1110401:1=1624,1110402:1=788,1100403:1=266,1110201:1=2436,1110202:1=1182,1100203:1=399,1110201:1=3305'),(6302004,6,10,'1|2110301:1=1037;1|2110501:1=89;1|2110601:1=30;1|2110302:1=356;1|2110502:1=18;1|2110602:1=7;1|1110303:1=237;1|1110503:1=12;0|1110603:1=7;4|1110101:1=6000,1110102:1=1500,1110103:1=2500;1|1110401:1=1624,1110402:1=788,1100403:1=266,1110201:1=2436,1110202:1=1182,1100203:1=399,1110201:1=3305'),(6302005,1,1,'1|2110301:1=1586;1|2110501:1=159;1|2110601:1=32;1|2110302:1=547;1|2110502:1=27;1|2110602:1=8;1|1110303:1=365;1|1110503:1=18;0|1110603:1=8;4|1110101:1=6000,1110102:1=1500,1110103:1=2500;1|1110401:1=1624,1110402:1=788,1100403:1=266,1110201:1=2436,1110202:1=1182,1100203:1=399,1110201:1=3305'),(6302005,2,2,'1|2110301:1=1586;1|2110501:1=143;1|2110601:1=32;1|2110302:1=514;1|2110502:1=26;1|2110602:1=8;1|1110303:1=343;1|1110503:1=17;0|1110603:1=8;4|1110101:1=6000,1110102:1=1500,1110103:1=2500;1|1110401:1=1624,1110402:1=788,1100403:1=266,1110201:1=2436,1110202:1=1182,1100203:1=399,1110201:1=3305'),(6302005,3,3,'1|2110301:1=1427;1|2110501:1=127;1|2110601:1=32;1|2110302:1=476;1|2110502:1=24;1|2110602:1=8;1|1110303:1=317;1|1110503:1=16;0|1110603:1=8;4|1110101:1=6000,1110102:1=1500,1110103:1=2500;1|1110401:1=1624,1110402:1=788,1100403:1=266,1110201:1=2436,1110202:1=1182,1100203:1=399,1110201:1=3305'),(6302005,4,5,'1|2110301:1=1269;1|2110501:1=111;1|2110601:1=32;1|2110302:1=404;1|2110502:1=20;1|2110602:1=8;1|1110303:1=270;1|1110503:1=13;0|1110603:1=8;4|1110101:1=6000,1110102:1=1500,1110103:1=2500;1|1110401:1=1624,1110402:1=788,1100403:1=266,1110201:1=2436,1110202:1=1182,1100203:1=399,1110201:1=3305'),(6302005,6,10,'1|2110301:1=1110;1|2110501:1=95;1|2110601:1=32;1|2110302:1=381;1|2110502:1=19;1|2110602:1=8;1|1110303:1=254;1|1110503:1=13;0|1110603:1=8;4|1110101:1=6000,1110102:1=1500,1110103:1=2500;1|1110401:1=1624,1110402:1=788,1100403:1=266,1110201:1=2436,1110202:1=1182,1100203:1=399,1110201:1=3305'),(6302006,1,1,'1|2110301:1=1690;1|2110501:1=169;1|2110601:1=34;1|2110302:1=583;1|2110502:1=29;1|2110602:1=8;1|1110303:1=389;1|1110503:1=19;0|1110603:1=8;4|1110101:1=6000,1110102:1=1500,1110103:1=2500;1|1110401:1=1624,1110402:1=788,1100403:1=266,1110201:1=2436,1110202:1=1182,1100203:1=399,1110201:1=3305'),(6302006,2,2,'1|2110301:1=1690;1|2110501:1=152;1|2110601:1=34;1|2110302:1=548;1|2110502:1=27;1|2110602:1=8;1|1110303:1=365;1|1110503:1=18;0|1110603:1=8;4|1110101:1=6000,1110102:1=1500,1110103:1=2500;1|1110401:1=1624,1110402:1=788,1100403:1=266,1110201:1=2436,1110202:1=1182,1100203:1=399,1110201:1=3305'),(6302006,3,3,'1|2110301:1=1521;1|2110501:1=135;1|2110601:1=34;1|2110302:1=507;1|2110502:1=25;1|2110602:1=8;1|1110303:1=338;1|1110503:1=17;0|1110603:1=8;4|1110101:1=6000,1110102:1=1500,1110103:1=2500;1|1110401:1=1624,1110402:1=788,1100403:1=266,1110201:1=2436,1110202:1=1182,1100203:1=399,1110201:1=3305'),(6302006,4,5,'1|2110301:1=1352;1|2110501:1=118;1|2110601:1=34;1|2110302:1=431;1|2110502:1=22;1|2110602:1=8;1|1110303:1=287;1|1110503:1=14;0|1110603:1=8;4|1110101:1=6000,1110102:1=1500,1110103:1=2500;1|1110401:1=1624,1110402:1=788,1100403:1=266,1110201:1=2436,1110202:1=1182,1100203:1=399,1110201:1=3305'),(6302006,6,10,'1|2110301:1=1183;1|2110501:1=101;1|2110601:1=34;1|2110302:1=406;1|2110502:1=20;1|2110602:1=8;1|1110303:1=270;1|1110503:1=14;0|1110603:1=8;4|1110101:1=6000,1110102:1=1500,1110103:1=2500;1|1110401:1=1624,1110402:1=788,1100403:1=266,1110201:1=2436,1110202:1=1182,1100203:1=399,1110201:1=3305'),(6303001,1,1,'1|2120301:1=1170;1|2120501:1=117;1|2120601:1=23;1|2120302:1=269;1|2120502:1=13;1|2120602:1=6;1|1120303:1=269;1|1120503:1=13;0|1120603:1=6;4|1120101:1=6000,1120102:1=1500,1120103:1=2500;1|1120401:1=1703,1120402:1=740,1110403:1=248,1120201:1=2556,1120202:1=1109,1110203:1=372,1120201:1=3272'),(6303001,2,2,'1|2120301:1=1170;1|2120501:1=105;1|2120601:1=23;1|2120302:1=253;1|2120502:1=13;1|2120602:1=6;1|1120303:1=253;1|1120503:1=13;0|1120603:1=6;4|1120101:1=6000,1120102:1=1500,1120103:1=2500;1|1120401:1=1703,1120402:1=740,1110403:1=248,1120201:1=2556,1120202:1=1109,1110203:1=372,1120201:1=3272'),(6303001,3,3,'1|2120301:1=1053;1|2120501:1=94;1|2120601:1=23;1|2120302:1=234;1|2120502:1=12;1|2120602:1=6;1|1120303:1=234;1|1120503:1=12;0|1120603:1=6;4|1120101:1=6000,1120102:1=1500,1120103:1=2500;1|1120401:1=1703,1120402:1=740,1110403:1=248,1120201:1=2556,1120202:1=1109,1110203:1=372,1120201:1=3272'),(6303001,4,5,'1|2120301:1=936;1|2120501:1=82;1|2120601:1=23;1|2120302:1=199;1|2120502:1=10;1|2120602:1=6;1|1120303:1=199;1|1120503:1=10;0|1120603:1=6;4|1120101:1=6000,1120102:1=1500,1120103:1=2500;1|1120401:1=1703,1120402:1=740,1110403:1=248,1120201:1=2556,1120202:1=1109,1110203:1=372,1120201:1=3272'),(6303001,6,10,'1|2120301:1=819;1|2120501:1=70;1|2120601:1=23;1|2120302:1=187;1|2120502:1=9;1|2120602:1=6;1|1120303:1=187;1|1120503:1=9;0|1120603:1=6;4|1120101:1=6000,1120102:1=1500,1120103:1=2500;1|1120401:1=1703,1120402:1=740,1110403:1=248,1120201:1=2556,1120202:1=1109,1110203:1=372,1120201:1=3272'),(6303002,1,1,'1|2120301:1=1274;1|2120501:1=127;1|2120601:1=25;1|2120302:1=293;1|2120502:1=15;1|2120602:1=6;1|1120303:1=293;1|1120503:1=15;0|1120603:1=6;4|1120101:1=6000,1120102:1=1500,1120103:1=2500;1|1120401:1=1703,1120402:1=740,1110403:1=248,1120201:1=2556,1120202:1=1109,1110203:1=372,1120201:1=3272'),(6303002,2,2,'1|1120301:1=1274;1|1120501:1=115;1|1120601:1=25;1|1120302:1=275;1|1120502:1=14;1|1120602:1=6;1|1120303:1=275;1|1120503:1=14;0|1120603:1=6;4|1120101:1=6000,1120102:1=1500,1120103:1=2500;1|1120401:1=1703,1120402:1=740,1110403:1=248,1120201:1=2556,1120202:1=1109,1110203:1=372,1120201:1=3272'),(6303002,3,3,'1|1120301:1=1147;1|1120501:1=102;1|1120601:1=25;1|1120302:1=255;1|1120502:1=13;1|1120602:1=6;1|1120303:1=255;1|1120503:1=13;0|1120603:1=6;4|1120101:1=6000,1120102:1=1500,1120103:1=2500;1|1120401:1=1703,1120402:1=740,1110403:1=248,1120201:1=2556,1120202:1=1109,1110203:1=372,1120201:1=3272'),(6303002,4,5,'1|1120301:1=1019;1|1120501:1=89;1|1120601:1=25;1|1120302:1=217;1|1120502:1=11;1|1120602:1=6;1|1120303:1=217;1|1120503:1=11;0|1120603:1=6;4|1120101:1=6000,1120102:1=1500,1120103:1=2500;1|1120401:1=1703,1120402:1=740,1110403:1=248,1120201:1=2556,1120202:1=1109,1110203:1=372,1120201:1=3272'),(6303002,6,10,'1|1120301:1=892;1|1120501:1=76;1|1120601:1=25;1|1120302:1=204;1|1120502:1=10;1|1120602:1=6;1|1120303:1=204;1|1120503:1=10;0|1120603:1=6;4|1120101:1=6000,1120102:1=1500,1120103:1=2500;1|1120401:1=1703,1120402:1=740,1110403:1=248,1120201:1=2556,1120202:1=1109,1110203:1=372,1120201:1=3272'),(6303003,1,1,'1|1120301:1=1378;1|1120501:1=138;1|1120601:1=28;1|1120302:1=317;1|1120502:1=16;1|1120602:1=7;1|1120303:1=317;1|1120503:1=16;0|1120603:1=7;4|1120101:1=6000,1120102:1=1500,1120103:1=2500;1|1120401:1=1703,1120402:1=740,1110403:1=248,1120201:1=2556,1120202:1=1109,1110203:1=372,1120201:1=3272'),(6303003,2,2,'1|1120301:1=1378;1|1120501:1=124;1|1120601:1=28;1|1120302:1=298;1|1120502:1=15;1|1120602:1=7;1|1120303:1=298;1|1120503:1=15;0|1120603:1=7;4|1120101:1=6000,1120102:1=1500,1120103:1=2500;1|1120401:1=1703,1120402:1=740,1110403:1=248,1120201:1=2556,1120202:1=1109,1110203:1=372,1120201:1=3272'),(6303003,3,3,'1|2120301:1=1240;1|2120501:1=110;1|2120601:1=28;1|2120302:1=276;1|2120502:1=14;1|2120602:1=7;1|1120303:1=276;1|1120503:1=14;0|1120603:1=7;4|1120101:1=6000,1120102:1=1500,1120103:1=2500;1|1120401:1=1703,1120402:1=740,1110403:1=248,1120201:1=2556,1120202:1=1109,1110203:1=372,1120201:1=3272'),(6303003,4,5,'1|2120301:1=1102;1|2120501:1=96;1|2120601:1=28;1|2120302:1=234;1|2120502:1=12;1|2120602:1=7;1|1120303:1=234;1|1120503:1=12;0|1120603:1=7;4|1120101:1=6000,1120102:1=1500,1120103:1=2500;1|1120401:1=1703,1120402:1=740,1110403:1=248,1120201:1=2556,1120202:1=1109,1110203:1=372,1120201:1=3272'),(6303003,6,10,'1|2120301:1=965;1|2120501:1=83;1|2120601:1=28;1|2120302:1=220;1|2120502:1=11;1|2120602:1=7;1|1120303:1=220;1|1120503:1=11;0|1120603:1=7;4|1120101:1=6000,1120102:1=1500,1120103:1=2500;1|1120401:1=1703,1120402:1=740,1110403:1=248,1120201:1=2556,1120202:1=1109,1110203:1=372,1120201:1=3272'),(6303004,1,1,'1|2130301:1=1778;1|2130501:1=148;1|2130601:1=15;1|2130302:1=341;1|2130502:1=17;1|2130602:1=7;1|1130303:1=511;1|1130503:1=17;0|1130603:1=7;4|1130101:1=6000,1130102:1=1500,1130103:1=2500;1|1130401:1=1784,1130402:1=691,1120403:1=231,1130201:1=2677,1130202:1=1036,1120203:1=347,1130201:1=3234'),(6303004,2,2,'1|2130301:1=1482;1|2130501:1=133;1|2130601:1=15;1|2130302:1=320;1|2130502:1=16;1|2130602:1=7;1|1130303:1=480;1|1130503:1=16;0|1130603:1=7;4|1130101:1=6000,1130102:1=1500,1130103:1=2500;1|1130401:1=1784,1130402:1=691,1120403:1=231,1130201:1=2677,1130202:1=1036,1120203:1=347,1130201:1=3234'),(6303004,3,3,'1|2130301:1=1334;1|2130501:1=104;1|2130601:1=15;1|2130302:1=296;1|2130502:1=15;1|2130602:1=7;1|1130303:1=445;1|1130503:1=15;0|1130603:1=7;4|1130101:1=6000,1130102:1=1500,1130103:1=2500;1|1130401:1=1784,1130402:1=691,1120403:1=231,1130201:1=2677,1130202:1=1036,1120203:1=347,1130201:1=3234'),(6303004,4,5,'1|2130301:1=1186;1|2130501:1=89;1|2130601:1=15;1|2130302:1=252;1|2130502:1=13;1|2130602:1=7;1|1130303:1=378;1|1130503:1=13;0|1130603:1=7;4|1130101:1=6000,1130102:1=1500,1130103:1=2500;1|1130401:1=1784,1130402:1=691,1120403:1=231,1130201:1=2677,1130202:1=1036,1120203:1=347,1130201:1=3234'),(6303004,6,10,'1|2130301:1=1037;1|2130501:1=59;1|2130601:1=15;1|2130302:1=237;1|2130502:1=12;1|2130602:1=7;1|1130303:1=356;1|1130503:1=12;0|1130603:1=7;4|1130101:1=6000,1130102:1=1500,1130103:1=2500;1|1130401:1=1784,1130402:1=691,1120403:1=231,1130201:1=2677,1130202:1=1036,1120203:1=347,1130201:1=3234'),(6303005,1,1,'1|2130301:1=1903;1|2130501:1=159;1|2130601:1=16;1|2130302:1=365;1|2130502:1=18;1|2130602:1=8;1|1130303:1=547;1|1130503:1=18;0|1130603:1=8;4|1130101:1=6000,1130102:1=1500,1130103:1=2500;1|1130401:1=1784,1130402:1=691,1120403:1=231,1130201:1=2677,1130202:1=1036,1120203:1=347,1130201:1=3234'),(6303005,2,2,'1|2130301:1=1586;1|2130501:1=143;1|2130601:1=16;1|2130302:1=343;1|2130502:1=17;1|2130602:1=8;1|1130303:1=514;1|1130503:1=17;0|1130603:1=8;4|1130101:1=6000,1130102:1=1500,1130103:1=2500;1|1130401:1=1784,1130402:1=691,1120403:1=231,1130201:1=2677,1130202:1=1036,1120203:1=347,1130201:1=3234'),(6303005,3,3,'1|2130301:1=1427;1|2130501:1=111;1|2130601:1=16;1|2130302:1=317;1|2130502:1=16;1|2130602:1=8;1|1130303:1=476;1|1130503:1=16;0|1130603:1=8;4|1130101:1=6000,1130102:1=1500,1130103:1=2500;1|1130401:1=1784,1130402:1=691,1120403:1=231,1130201:1=2677,1130202:1=1036,1120203:1=347,1130201:1=3234'),(6303005,4,5,'1|2130301:1=1269;1|2130501:1=95;1|2130601:1=16;1|2130302:1=270;1|2130502:1=13;1|2130602:1=8;1|1130303:1=404;1|1130503:1=13;0|1130603:1=8;4|1130101:1=6000,1130102:1=1500,1130103:1=2500;1|1130401:1=1784,1130402:1=691,1120403:1=231,1130201:1=2677,1130202:1=1036,1120203:1=347,1130201:1=3234'),(6303005,6,10,'1|2130301:1=1110;1|2130501:1=63;1|2130601:1=16;1|2130302:1=254;1|2130502:1=13;1|2130602:1=8;1|1130303:1=381;1|1130503:1=13;0|1130603:1=8;4|1130101:1=6000,1130102:1=1500,1130103:1=2500;1|1130401:1=1784,1130402:1=691,1120403:1=231,1130201:1=2677,1130202:1=1036,1120203:1=347,1130201:1=3234'),(6303006,1,1,'1|2130301:1=2028;1|2130501:1=169;1|2130601:1=17;1|2130302:1=389;1|2130502:1=19;1|2130602:1=8;1|1130303:1=583;1|1130503:1=19;0|1130603:1=8;4|1130101:1=6000,1130102:1=1500,1130103:1=2500;1|1130401:1=1784,1130402:1=691,1120403:1=231,1130201:1=2677,1130202:1=1036,1120203:1=347,1130201:1=3234'),(6303006,2,2,'1|2130301:1=1690;1|2130501:1=152;1|2130601:1=17;1|2130302:1=365;1|2130502:1=18;1|2130602:1=8;1|1130303:1=548;1|1130503:1=18;0|1130603:1=8;4|1130101:1=6000,1130102:1=1500,1130103:1=2500;1|1130401:1=1784,1130402:1=691,1120403:1=231,1130201:1=2677,1130202:1=1036,1120203:1=347,1130201:1=3234'),(6303006,3,3,'1|2130301:1=1521;1|2130501:1=118;1|2130601:1=17;1|2130302:1=338;1|2130502:1=17;1|2130602:1=8;1|1130303:1=507;1|1130503:1=17;0|1130603:1=8;4|1130101:1=6000,1130102:1=1500,1130103:1=2500;1|1130401:1=1784,1130402:1=691,1120403:1=231,1130201:1=2677,1130202:1=1036,1120203:1=347,1130201:1=3234'),(6303006,4,5,'1|2130301:1=1352;1|2130501:1=101;1|2130601:1=17;1|2130302:1=287;1|2130502:1=14;1|2130602:1=8;1|1130303:1=431;1|1130503:1=14;0|1130603:1=8;4|1130101:1=6000,1130102:1=1500,1130103:1=2500;1|1130401:1=1784,1130402:1=691,1120403:1=231,1130201:1=2677,1130202:1=1036,1120203:1=347,1130201:1=3234'),(6303006,6,10,'1|2130301:1=1183;1|2130501:1=68;1|2130601:1=17;1|2130302:1=270;1|2130502:1=14;1|2130602:1=8;1|1130303:1=406;1|1130503:1=14;0|1130603:1=8;4|1130101:1=6000,1130102:1=1500,1130103:1=2500;1|1130401:1=1784,1130402:1=691,1120403:1=231,1130201:1=2677,1130202:1=1036,1120203:1=347,1130201:1=3234'),(6304001,1,1,'1|1140301:1=1170;1|1140501:1=117;1|1140601:1=12;1|1140302:1=269;1|1140502:1=13;1|1140602:1=6;1|1140303:1=404;1|1140503:1=13;0|1140603:1=6;4|1140101:1=6000,1140102:1=1500,1140103:1=2500;1|1140401:1=1864,1140402:1=643,1130403:1=213,1140201:1=2794,1140202:1=964,1130203:1=319,1140201:1=3203'),(6304001,2,2,'1|1140301:1=1053;1|1140501:1=105;1|1140601:1=12;1|1140302:1=253;1|1140502:1=13;1|1140602:1=6;1|1140303:1=379;1|1140503:1=13;0|1140603:1=6;4|1140101:1=6000,1140102:1=1500,1140103:1=2500;1|1140401:1=1864,1140402:1=643,1130403:1=213,1140201:1=2794,1140202:1=964,1130203:1=319,1140201:1=3203'),(6304001,3,3,'1|1140301:1=936;1|1140501:1=82;1|1140601:1=12;1|1140302:1=234;1|1140502:1=12;1|1140602:1=6;1|1140303:1=351;1|1140503:1=12;0|1140603:1=6;4|1140101:1=6000,1140102:1=1500,1140103:1=2500;1|1140401:1=1864,1140402:1=643,1130403:1=213,1140201:1=2794,1140202:1=964,1130203:1=319,1140201:1=3203'),(6304001,4,5,'1|1140301:1=819;1|1140501:1=70;1|1140601:1=12;1|1140302:1=199;1|1140502:1=10;1|1140602:1=6;1|1140303:1=298;1|1140503:1=10;0|1140603:1=6;4|1140101:1=6000,1140102:1=1500,1140103:1=2500;1|1140401:1=1864,1140402:1=643,1130403:1=213,1140201:1=2794,1140202:1=964,1130203:1=319,1140201:1=3203'),(6304001,6,10,'1|1140301:1=702;1|1140501:1=47;1|1140601:1=12;1|1140302:1=187;1|1140502:1=9;1|1140602:1=6;1|1140303:1=281;1|1140503:1=9;0|1140603:1=6;4|1140101:1=6000,1140102:1=1500,1140103:1=2500;1|1140401:1=1864,1140402:1=643,1130403:1=213,1140201:1=2794,1140202:1=964,1130203:1=319,1140201:1=3203'),(6304002,1,1,'1|1140301:1=1274;1|1140501:1=127;1|1140601:1=13;1|1140302:1=293;1|1140502:1=15;1|1140602:1=6;1|1140303:1=440;1|1140503:1=15;0|1140603:1=6;4|1140101:1=6000,1140102:1=1500,1140103:1=2500;1|1140401:1=1864,1140402:1=643,1130403:1=213,1140201:1=2794,1140202:1=964,1130203:1=319,1140201:1=3203'),(6304002,2,2,'1|2140301:1=1147;1|2140501:1=115;1|2140601:1=13;1|2140302:1=275;1|2140502:1=14;1|2140602:1=6;1|1140303:1=413;1|1140503:1=14;0|1140603:1=6;4|1140101:1=6000,1140102:1=1500,1140103:1=2500;1|1140401:1=1864,1140402:1=643,1130403:1=213,1140201:1=2794,1140202:1=964,1130203:1=319,1140201:1=3203'),(6304002,3,3,'1|2140301:1=1019;1|2140501:1=89;1|2140601:1=13;1|2140302:1=255;1|2140502:1=13;1|2140602:1=6;1|1140303:1=382;1|1140503:1=13;0|1140603:1=6;4|1140101:1=6000,1140102:1=1500,1140103:1=2500;1|1140401:1=1864,1140402:1=643,1130403:1=213,1140201:1=2794,1140202:1=964,1130203:1=319,1140201:1=3203'),(6304002,4,5,'1|2140301:1=892;1|2140501:1=76;1|2140601:1=13;1|2140302:1=217;1|2140502:1=11;1|2140602:1=6;1|1140303:1=325;1|1140503:1=11;0|1140603:1=6;4|1140101:1=6000,1140102:1=1500,1140103:1=2500;1|1140401:1=1864,1140402:1=643,1130403:1=213,1140201:1=2794,1140202:1=964,1130203:1=319,1140201:1=3203'),(6304002,6,10,'1|2140301:1=764;1|2140501:1=51;1|2140601:1=13;1|2140302:1=204;1|2140502:1=10;1|2140602:1=6;1|1140303:1=306;1|1140503:1=10;0|1140603:1=6;4|1140101:1=6000,1140102:1=1500,1140103:1=2500;1|1140401:1=1864,1140402:1=643,1130403:1=213,1140201:1=2794,1140202:1=964,1130203:1=319,1140201:1=3203'),(6304003,1,1,'1|2140301:1=1378;1|2140501:1=138;1|2140601:1=14;1|2140302:1=317;1|2140502:1=16;1|2140602:1=7;1|1140303:1=475;1|1140503:1=16;0|1140603:1=7;4|1140101:1=6000,1140102:1=1500,1140103:1=2500;1|1140401:1=1864,1140402:1=643,1130403:1=213,1140201:1=2794,1140202:1=964,1130203:1=319,1140201:1=3203'),(6304003,2,2,'1|2140301:1=1240;1|2140501:1=124;1|2140601:1=14;1|2140302:1=298;1|2140502:1=15;1|2140602:1=7;1|1140303:1=446;1|1140503:1=15;0|1140603:1=7;4|1140101:1=6000,1140102:1=1500,1140103:1=2500;1|1140401:1=1864,1140402:1=643,1130403:1=213,1140201:1=2794,1140202:1=964,1130203:1=319,1140201:1=3203'),(6304003,3,3,'1|2140301:1=1102;1|2140501:1=96;1|2140601:1=14;1|2140302:1=276;1|2140502:1=14;1|2140602:1=7;1|1140303:1=413;1|1140503:1=14;0|1140603:1=7;4|1140101:1=6000,1140102:1=1500,1140103:1=2500;1|1140401:1=1864,1140402:1=643,1130403:1=213,1140201:1=2794,1140202:1=964,1130203:1=319,1140201:1=3203'),(6304003,4,5,'1|2140301:1=965;1|2140501:1=83;1|2140601:1=14;1|2140302:1=234;1|2140502:1=12;1|2140602:1=7;1|1140303:1=351;1|1140503:1=12;0|1140603:1=7;4|1140101:1=6000,1140102:1=1500,1140103:1=2500;1|1140401:1=1864,1140402:1=643,1130403:1=213,1140201:1=2794,1140202:1=964,1130203:1=319,1140201:1=3203'),(6304003,6,10,'1|2140301:1=827;1|2140501:1=55;1|2140601:1=14;1|2140302:1=220;1|2140502:1=11;1|2140602:1=7;1|1140303:1=331;1|1140503:1=11;0|1140603:1=7;4|1140101:1=6000,1140102:1=1500,1140103:1=2500;1|1140401:1=1864,1140402:1=643,1130403:1=213,1140201:1=2794,1140202:1=964,1130203:1=319,1140201:1=3203'),(6304004,1,1,'1|2150301:1=1482;1|2150501:1=148;1|2150601:1=15;1|2150302:1=341;1|2150502:1=17;1|2150602:1=7;1|1150303:1=511;1|1150503:1=17;0|1150603:1=7;4|1150101:1=6000,1150102:1=1500,1150103:1=2500;1|1150401:1=1944,1150402:1=594,1140403:1=196,1150201:1=2916,1150202:1=891,1140203:1=294,1150201:1=3165'),(6304004,2,2,'1|2150301:1=1334;1|2150501:1=133;1|2150601:1=15;1|2150302:1=320;1|2150502:1=16;1|2150602:1=7;1|1150303:1=480;1|1150503:1=16;0|1150603:1=7;4|1150101:1=6000,1150102:1=1500,1150103:1=2500;1|1150401:1=1944,1150402:1=594,1140403:1=196,1150201:1=2916,1150202:1=891,1140203:1=294,1150201:1=3165'),(6304004,3,3,'1|2150301:1=1186;1|2150501:1=104;1|2150601:1=15;1|2150302:1=296;1|2150502:1=15;1|2150602:1=7;1|1150303:1=445;1|1150503:1=15;0|1150603:1=7;4|1150101:1=6000,1150102:1=1500,1150103:1=2500;1|1150401:1=1944,1150402:1=594,1140403:1=196,1150201:1=2916,1150202:1=891,1140203:1=294,1150201:1=3165'),(6304004,4,5,'1|2150301:1=1037;1|2150501:1=89;1|2150601:1=15;1|2150302:1=252;1|2150502:1=13;1|2150602:1=7;1|1150303:1=378;1|1150503:1=13;0|1150603:1=7;4|1150101:1=6000,1150102:1=1500,1150103:1=2500;1|1150401:1=1944,1150402:1=594,1140403:1=196,1150201:1=2916,1150202:1=891,1140203:1=294,1150201:1=3165'),(6304004,6,10,'1|2150301:1=889;1|2150501:1=59;1|2150601:1=15;1|2150302:1=237;1|2150502:1=12;1|2150602:1=7;1|1150303:1=356;1|1150503:1=12;0|1150603:1=7;4|1150101:1=6000,1150102:1=1500,1150103:1=2500;1|1150401:1=1944,1150402:1=594,1140403:1=196,1150201:1=2916,1150202:1=891,1140203:1=294,1150201:1=3165'),(6304005,1,1,'1|2150301:1=1586;1|2150501:1=159;1|2150601:1=16;1|2150302:1=365;1|2150502:1=18;1|2150602:1=8;1|1150303:1=547;1|1150503:1=18;0|1150603:1=8;4|1150101:1=6000,1150102:1=1500,1150103:1=2500;1|1150401:1=1944,1150402:1=594,1140403:1=196,1150201:1=2916,1150202:1=891,1140203:1=294,1150201:1=3165'),(6304005,2,2,'1|2150301:1=1427;1|2150501:1=143;1|2150601:1=16;1|2150302:1=343;1|2150502:1=17;1|2150602:1=8;1|1150303:1=514;1|1150503:1=17;0|1150603:1=8;4|1150101:1=6000,1150102:1=1500,1150103:1=2500;1|1150401:1=1944,1150402:1=594,1140403:1=196,1150201:1=2916,1150202:1=891,1140203:1=294,1150201:1=3165'),(6304005,3,3,'1|2150301:1=1269;1|2150501:1=111;1|2150601:1=16;1|2150302:1=317;1|2150502:1=16;1|2150602:1=8;1|1150303:1=476;1|1150503:1=16;0|1150603:1=8;4|1150101:1=6000,1150102:1=1500,1150103:1=2500;1|1150401:1=1944,1150402:1=594,1140403:1=196,1150201:1=2916,1150202:1=891,1140203:1=294,1150201:1=3165'),(6304005,4,5,'1|2150301:1=1110;1|2150501:1=95;1|2150601:1=16;1|2150302:1=270;1|2150502:1=13;1|2150602:1=8;1|1150303:1=404;1|1150503:1=13;0|1150603:1=8;4|1150101:1=6000,1150102:1=1500,1150103:1=2500;1|1150401:1=1944,1150402:1=594,1140403:1=196,1150201:1=2916,1150202:1=891,1140203:1=294,1150201:1=3165'),(6304005,6,10,'1|1150301:1=952;1|1150501:1=63;1|1150601:1=16;1|1150302:1=254;1|1150502:1=13;1|1150602:1=8;1|1150303:1=381;1|1150503:1=13;0|1150603:1=8;4|1150101:1=6000,1150102:1=1500,1150103:1=2500;1|1150401:1=1944,1150402:1=594,1140403:1=196,1150201:1=2916,1150202:1=891,1140203:1=294,1150201:1=3165'),(6304006,1,1,'1|1150301:1=1690;1|1150501:1=169;1|1150601:1=17;1|1150302:1=389;1|1150502:1=19;1|1150602:1=8;1|1150303:1=583;1|1150503:1=19;0|1150603:1=8;4|1150101:1=6000,1150102:1=1500,1150103:1=2500;1|1150401:1=1944,1150402:1=594,1140403:1=196,1150201:1=2916,1150202:1=891,1140203:1=294,1150201:1=3165'),(6304006,2,2,'1|1150301:1=1521;1|1150501:1=152;1|1150601:1=17;1|1150302:1=365;1|1150502:1=18;1|1150602:1=8;1|1150303:1=548;1|1150503:1=18;0|1150603:1=8;4|1150101:1=6000,1150102:1=1500,1150103:1=2500;1|1150401:1=1944,1150402:1=594,1140403:1=196,1150201:1=2916,1150202:1=891,1140203:1=294,1150201:1=3165'),(6304006,3,3,'1|1150301:1=1352;1|1150501:1=118;1|1150601:1=17;1|1150302:1=338;1|1150502:1=17;1|1150602:1=8;1|1150303:1=507;1|1150503:1=17;0|1150603:1=8;4|1150101:1=6000,1150102:1=1500,1150103:1=2500;1|1150401:1=1944,1150402:1=594,1140403:1=196,1150201:1=2916,1150202:1=891,1140203:1=294,1150201:1=3165'),(6304006,4,5,'1|1150301:1=1183;1|1150501:1=101;1|1150601:1=17;1|1150302:1=287;1|1150502:1=14;1|1150602:1=8;1|1150303:1=431;1|1150503:1=14;0|1150603:1=8;4|1150101:1=6000,1150102:1=1500,1150103:1=2500;1|1150401:1=1944,1150402:1=594,1140403:1=196,1150201:1=2916,1150202:1=891,1140203:1=294,1150201:1=3165'),(6304006,6,10,'1|1150301:1=1014;1|1150501:1=68;1|1150601:1=17;1|1150302:1=270;1|1150502:1=14;1|1150602:1=8;1|1150303:1=406;1|1150503:1=14;0|1150603:1=8;4|1150101:1=6000,1150102:1=1500,1150103:1=2500;1|1150401:1=1944,1150402:1=594,1140403:1=196,1150201:1=2916,1150202:1=891,1140203:1=294,1150201:1=3165');
/*!40000 ALTER TABLE `base_kf_boss_rank_cfg` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf_boss_revive_cost_cfg`
--

DROP TABLE IF EXISTS `base_kf_boss_revive_cost_cfg`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf_boss_revive_cost_cfg` (
  `revive_times` tinyint(3) unsigned NOT NULL COMMENT '复活次数',
  `cost` tinyint(3) unsigned NOT NULL COMMENT '消耗的绑钻或钻石',
  PRIMARY KEY (`revive_times`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服boss复活配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf_boss_revive_cost_cfg`
--

LOCK TABLES `base_kf_boss_revive_cost_cfg` WRITE;
/*!40000 ALTER TABLE `base_kf_boss_revive_cost_cfg` DISABLE KEYS */;
INSERT INTO `base_kf_boss_revive_cost_cfg` VALUES (1,5),(2,10),(3,15),(4,20),(5,25),(6,30),(7,35),(8,40),(9,45),(10,50),(11,55),(12,60);
/*!40000 ALTER TABLE `base_kf_boss_revive_cost_cfg` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf_cloud_buy_rand_reward`
--

DROP TABLE IF EXISTS `base_kf_cloud_buy_rand_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf_cloud_buy_rand_reward` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励id',
  `type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动类型',
  `min_wlv` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '世界等级下限',
  `max_wlv` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '世界等级上限',
  `weights` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '权重',
  `reward_type` tinyint(2) unsigned NOT NULL COMMENT '奖励类型',
  `gtype_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型id',
  `num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '数量',
  `bind` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否绑定',
  `is_rare` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否稀有',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服云购随机奖励';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf_cloud_buy_rand_reward`
--

LOCK TABLES `base_kf_cloud_buy_rand_reward` WRITE;
/*!40000 ALTER TABLE `base_kf_cloud_buy_rand_reward` DISABLE KEYS */;
INSERT INTO `base_kf_cloud_buy_rand_reward` VALUES (1,37,0,9999,20,1,32160005,1,0,1),(2,37,0,9999,15,1,32160006,1,0,1),(3,37,0,9999,22,1,16010001,1,0,1),(4,37,0,9999,8,1,14020203,1,0,1),(5,37,0,9999,8,1,14010103,1,0,1),(6,37,0,9999,8,1,14010303,1,0,0),(7,37,0,9999,8,1,14020403,1,0,1),(8,37,0,9999,20,1,17020001,1,0,1),(9,37,0,9999,20,1,24020001,1,0,0),(10,37,0,9999,40,1,16020001,2,0,0),(11,37,0,9999,40,1,11020001,4,0,0),(12,37,0,9999,40,1,17010001,60,0,0),(13,37,0,9999,40,1,15020101,2,0,0),(14,38,0,9999,40,1,15020201,2,0,1);
/*!40000 ALTER TABLE `base_kf_cloud_buy_rand_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf_hegemony`
--

DROP TABLE IF EXISTS `base_kf_hegemony`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf_hegemony` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `value` varchar(255) NOT NULL DEFAULT '0' COMMENT '值',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '描述',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服服战常量配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf_hegemony`
--

LOCK TABLES `base_kf_hegemony` WRITE;
/*!40000 ALTER TABLE `base_kf_hegemony` DISABLE KEYS */;
INSERT INTO `base_kf_hegemony` VALUES (1,'30','开服多少天后开跨服服战'),(2,'6','每周几开启服战'),(3,'[{0,0,0},{0,0,0}]','约战时间[开始时间,结束时间]{时,分,秒}'),(4,'[{0,0,0},{0,0,0}]','确认时间[开始时间,结束时间]{时,分,秒}，确认时间的开始时间必须是约战时间的结束时间'),(5,'[{0,0,0},{0,0,0}]','第一轮时间[开始时间,结束时间]{时,分,秒}，第一轮的开始时间必须是确认时间的结束时间'),(6,'[{0,0,0},{0,0,0}]','第二轮时间[开始时间,结束时间]{时,分,秒}'),(7,'[{0,0,0}]','报名消耗[{type,id,num}]'),(8,'10','战力前几名可以参赛'),(9,'10','赛季初始积分'),(10,'10','战场场景id'),(11,'10','核心怪物id'),(12,'{0,0}','核心怪物出生坐标{x,y}'),(13,'10','城门怪物id'),(14,'{0,0}','城门怪物坐标{x,y}'),(15,'{0,0}','攻方出生点坐标{x,y}'),(16,'{0,0}','守方出生点坐标{x,y}'),(17,'[{0,0,0}]','基础奖励[{type,id,num}]'),(18,'60','需要玩家等级'),(19,'60','PVE场景id'),(20,'1','约战冷却时间，单位：分钟');
/*!40000 ALTER TABLE `base_kf_hegemony` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf_hegemony_ranking_reward`
--

DROP TABLE IF EXISTS `base_kf_hegemony_ranking_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf_hegemony_ranking_reward` (
  `min_ranking` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '排名下限',
  `max_ranking` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '排名上限',
  `att_victory_reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '攻方胜利奖励',
  `att_failure_reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '攻方失败奖励',
  `def_victory_reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '守方胜利奖励',
  `def_failure_reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '守方失败奖励',
  `season_reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '赛季奖励',
  PRIMARY KEY (`min_ranking`,`max_ranking`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服服战排名奖励';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf_hegemony_ranking_reward`
--

LOCK TABLES `base_kf_hegemony_ranking_reward` WRITE;
/*!40000 ALTER TABLE `base_kf_hegemony_ranking_reward` DISABLE KEYS */;
/*!40000 ALTER TABLE `base_kf_hegemony_ranking_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf_hegemony_round_reward`
--

DROP TABLE IF EXISTS `base_kf_hegemony_round_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf_hegemony_round_reward` (
  `min_ranking` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '排名下限',
  `max_ranking` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '排名上限',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`min_ranking`,`max_ranking`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服服战轮次奖励';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf_hegemony_round_reward`
--

LOCK TABLES `base_kf_hegemony_round_reward` WRITE;
/*!40000 ALTER TABLE `base_kf_hegemony_round_reward` DISABLE KEYS */;
/*!40000 ALTER TABLE `base_kf_hegemony_round_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf_invade_act_score`
--

DROP TABLE IF EXISTS `base_kf_invade_act_score`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf_invade_act_score` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '编号',
  `type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '行为类型',
  `add_score` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '获得积分',
  `minus_score` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '减少他服积分',
  `add_score_limit` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '个人得分上限',
  `minus_score_limit` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '个人扣分上限',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服入侵行为积分配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf_invade_act_score`
--

LOCK TABLES `base_kf_invade_act_score` WRITE;
/*!40000 ALTER TABLE `base_kf_invade_act_score` DISABLE KEYS */;
INSERT INTO `base_kf_invade_act_score` VALUES (1,3,50,0,500,0),(2,2,100,20,2000,400),(3,1,100,0,1000,0),(4,4,3,1,900,300),(5,5,20,5,1000,250);
/*!40000 ALTER TABLE `base_kf_invade_act_score` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf_invade_boss_person_reward`
--

DROP TABLE IF EXISTS `base_kf_invade_boss_person_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf_invade_boss_person_reward` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励ID',
  `boss_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'BOSS_ID',
  `min_world_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小世界等级',
  `max_world_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大世界等级',
  `min_rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小排名',
  `max_rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大排名',
  `reward_list` varchar(512) NOT NULL COMMENT '奖励列表',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服入侵限时BOSS个人排行奖励';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf_invade_boss_person_reward`
--

LOCK TABLES `base_kf_invade_boss_person_reward` WRITE;
/*!40000 ALTER TABLE `base_kf_invade_boss_person_reward` DISABLE KEYS */;
INSERT INTO `base_kf_invade_boss_person_reward` VALUES (1,6200000,0,599,1,1,'[{255,36160006,5}]'),(2,6200000,0,599,2,2,'[{255,36160006,4}]'),(3,6200000,0,599,3,5,'[{255,36160006,3}]'),(4,6200000,0,599,6,10,'[{255,36160006,3}]'),(5,6200000,600,649,1,1,'[{255,36160006,8}]'),(6,6200000,600,649,2,2,'[{255,36160006,6}]'),(7,6200000,600,649,3,5,'[{255,36160006,5}]'),(8,6200000,600,649,6,10,'[{255,36160006,4}]'),(9,6200000,650,699,1,1,'[{255,36160006,13}]'),(10,6200000,650,699,2,2,'[{255,36160006,10}]'),(11,6200000,650,699,3,5,'[{255,36160006,8}]'),(12,6200000,650,699,6,10,'[{255,36160006,6}]'),(13,6200000,700,749,1,1,'[{255,36160006,20}]'),(14,6200000,700,749,2,2,'[{255,36160006,16}]'),(15,6200000,700,749,3,5,'[{255,36160006,12}]'),(16,6200000,700,749,6,10,'[{255,36160006,10}]'),(17,6200000,750,799,1,1,'[{255,36160006,30}]'),(18,6200000,750,799,2,2,'[{255,36160006,24}]'),(19,6200000,750,799,3,5,'[{255,36160006,18}]'),(20,6200000,750,799,6,10,'[{255,36160006,15}]'),(21,6200000,800,849,1,1,'[{255,36160006,50}]'),(22,6200000,800,849,2,2,'[{255,36160006,40}]'),(23,6200000,800,849,3,5,'[{255,36160006,30}]'),(24,6200000,800,849,6,10,'[{255,36160006,25}]'),(25,6200000,850,899,1,1,'[{255,36160006,65}]'),(26,6200000,850,899,2,2,'[{255,36160006,52}]'),(27,6200000,850,899,3,5,'[{255,36160006,39}]'),(28,6200000,850,899,6,10,'[{255,36160006,33}]'),(29,6200000,900,1000,1,1,'[{255,36160006,80}]'),(30,6200000,900,1000,2,2,'[{255,36160006,64}]'),(31,6200000,900,1000,3,5,'[{255,36160006,48}]'),(32,6200000,900,1000,6,10,'[{255,36160006,40}]'),(33,6200001,0,599,1,1,'[{255,36160006,5}]'),(34,6200001,0,599,2,2,'[{255,36160006,4}]'),(35,6200001,0,599,3,5,'[{255,36160006,3}]'),(36,6200001,0,599,6,10,'[{255,36160006,3}]'),(37,6200001,600,649,1,1,'[{255,36160006,8}]'),(38,6200001,600,649,2,2,'[{255,36160006,6}]'),(39,6200001,600,649,3,5,'[{255,36160006,5}]'),(40,6200001,600,649,6,10,'[{255,36160006,4}]'),(41,6200001,650,699,1,1,'[{255,36160006,13}]'),(42,6200001,650,699,2,2,'[{255,36160006,10}]'),(43,6200001,650,699,3,5,'[{255,36160006,8}]'),(44,6200001,650,699,6,10,'[{255,36160006,6}]'),(45,6200001,700,749,1,1,'[{255,36160006,20}]'),(46,6200001,700,749,2,2,'[{255,36160006,16}]'),(47,6200001,700,749,3,5,'[{255,36160006,12}]'),(48,6200001,700,749,6,10,'[{255,36160006,10}]'),(49,6200001,750,799,1,1,'[{255,36160006,30}]'),(50,6200001,750,799,2,2,'[{255,36160006,24}]'),(51,6200001,750,799,3,5,'[{255,36160006,18}]'),(52,6200001,750,799,6,10,'[{255,36160006,15}]'),(53,6200001,800,849,1,1,'[{255,36160006,50}]'),(54,6200001,800,849,2,2,'[{255,36160006,40}]'),(55,6200001,800,849,3,5,'[{255,36160006,30}]'),(56,6200001,800,849,6,10,'[{255,36160006,25}]'),(57,6200001,850,899,1,1,'[{255,36160006,65}]'),(58,6200001,850,899,2,2,'[{255,36160006,52}]'),(59,6200001,850,899,3,5,'[{255,36160006,39}]'),(60,6200001,850,899,6,10,'[{255,36160006,33}]'),(61,6200001,900,1000,1,1,'[{255,36160006,80}]'),(62,6200001,900,1000,2,2,'[{255,36160006,64}]'),(63,6200001,900,1000,3,5,'[{255,36160006,48}]'),(64,6200001,900,1000,6,10,'[{255,36160006,40}]'),(65,6200002,0,599,1,1,'[{255,36160006,5}]'),(66,6200002,0,599,2,2,'[{255,36160006,4}]'),(67,6200002,0,599,3,5,'[{255,36160006,3}]'),(68,6200002,0,599,6,10,'[{255,36160006,3}]'),(69,6200002,600,649,1,1,'[{255,36160006,8}]'),(70,6200002,600,649,2,2,'[{255,36160006,6}]'),(71,6200002,600,649,3,5,'[{255,36160006,5}]'),(72,6200002,600,649,6,10,'[{255,36160006,4}]'),(73,6200002,650,699,1,1,'[{255,36160006,13}]'),(74,6200002,650,699,2,2,'[{255,36160006,10}]'),(75,6200002,650,699,3,5,'[{255,36160006,8}]'),(76,6200002,650,699,6,10,'[{255,36160006,6}]'),(77,6200002,700,749,1,1,'[{255,36160006,20}]'),(78,6200002,700,749,2,2,'[{255,36160006,16}]'),(79,6200002,700,749,3,5,'[{255,36160006,12}]'),(80,6200002,700,749,6,10,'[{255,36160006,10}]'),(81,6200002,750,799,1,1,'[{255,36160006,30}]'),(82,6200002,750,799,2,2,'[{255,36160006,24}]'),(83,6200002,750,799,3,5,'[{255,36160006,18}]'),(84,6200002,750,799,6,10,'[{255,36160006,15}]'),(85,6200002,800,849,1,1,'[{255,36160006,50}]'),(86,6200002,800,849,2,2,'[{255,36160006,40}]'),(87,6200002,800,849,3,5,'[{255,36160006,30}]'),(88,6200002,800,849,6,10,'[{255,36160006,25}]'),(89,6200002,850,899,1,1,'[{255,36160006,65}]'),(90,6200002,850,899,2,2,'[{255,36160006,52}]'),(91,6200002,850,899,3,5,'[{255,36160006,39}]'),(92,6200002,850,899,6,10,'[{255,36160006,33}]'),(93,6200002,900,1000,1,1,'[{255,36160006,80}]'),(94,6200002,900,1000,2,2,'[{255,36160006,64}]'),(95,6200002,900,1000,3,5,'[{255,36160006,48}]'),(96,6200002,900,1000,6,10,'[{255,36160006,40}]'),(97,6200003,0,599,1,1,'[{255,36160006,5}]'),(98,6200003,0,599,2,2,'[{255,36160006,4}]'),(99,6200003,0,599,3,5,'[{255,36160006,3}]'),(100,6200003,0,599,6,10,'[{255,36160006,3}]'),(101,6200003,600,649,1,1,'[{255,36160006,8}]'),(102,6200003,600,649,2,2,'[{255,36160006,6}]'),(103,6200003,600,649,3,5,'[{255,36160006,5}]'),(104,6200003,600,649,6,10,'[{255,36160006,4}]'),(105,6200003,650,699,1,1,'[{255,36160006,13}]'),(106,6200003,650,699,2,2,'[{255,36160006,10}]'),(107,6200003,650,699,3,5,'[{255,36160006,8}]'),(108,6200003,650,699,6,10,'[{255,36160006,6}]'),(109,6200003,700,749,1,1,'[{255,36160006,20}]'),(110,6200003,700,749,2,2,'[{255,36160006,16}]'),(111,6200003,700,749,3,5,'[{255,36160006,12}]'),(112,6200003,700,749,6,10,'[{255,36160006,10}]'),(113,6200003,750,799,1,1,'[{255,36160006,30}]'),(114,6200003,750,799,2,2,'[{255,36160006,24}]'),(115,6200003,750,799,3,5,'[{255,36160006,18}]'),(116,6200003,750,799,6,10,'[{255,36160006,15}]'),(117,6200003,800,849,1,1,'[{255,36160006,50}]'),(118,6200003,800,849,2,2,'[{255,36160006,40}]'),(119,6200003,800,849,3,5,'[{255,36160006,30}]'),(120,6200003,800,849,6,10,'[{255,36160006,25}]'),(121,6200003,850,899,1,1,'[{255,36160006,65}]'),(122,6200003,850,899,2,2,'[{255,36160006,52}]'),(123,6200003,850,899,3,5,'[{255,36160006,39}]'),(124,6200003,850,899,6,10,'[{255,36160006,33}]'),(125,6200003,900,1000,1,1,'[{255,36160006,80}]'),(126,6200003,900,1000,2,2,'[{255,36160006,64}]'),(127,6200003,900,1000,3,5,'[{255,36160006,48}]'),(128,6200003,900,1000,6,10,'[{255,36160006,40}]'),(129,6200004,0,599,1,1,'[{255,36160006,5}]'),(130,6200004,0,599,2,2,'[{255,36160006,4}]'),(131,6200004,0,599,3,5,'[{255,36160006,3}]'),(132,6200004,0,599,6,10,'[{255,36160006,3}]'),(133,6200004,600,649,1,1,'[{255,36160006,8}]'),(134,6200004,600,649,2,2,'[{255,36160006,6}]'),(135,6200004,600,649,3,5,'[{255,36160006,5}]'),(136,6200004,600,649,6,10,'[{255,36160006,4}]'),(137,6200004,650,699,1,1,'[{255,36160006,13}]'),(138,6200004,650,699,2,2,'[{255,36160006,10}]'),(139,6200004,650,699,3,5,'[{255,36160006,8}]'),(140,6200004,650,699,6,10,'[{255,36160006,6}]'),(141,6200004,700,749,1,1,'[{255,36160006,20}]'),(142,6200004,700,749,2,2,'[{255,36160006,16}]'),(143,6200004,700,749,3,5,'[{255,36160006,12}]'),(144,6200004,700,749,6,10,'[{255,36160006,10}]'),(145,6200004,750,799,1,1,'[{255,36160006,30}]'),(146,6200004,750,799,2,2,'[{255,36160006,24}]'),(147,6200004,750,799,3,5,'[{255,36160006,18}]'),(148,6200004,750,799,6,10,'[{255,36160006,15}]'),(149,6200004,800,849,1,1,'[{255,36160006,50}]'),(150,6200004,800,849,2,2,'[{255,36160006,40}]'),(151,6200004,800,849,3,5,'[{255,36160006,30}]'),(152,6200004,800,849,6,10,'[{255,36160006,25}]'),(153,6200004,850,899,1,1,'[{255,36160006,65}]'),(154,6200004,850,899,2,2,'[{255,36160006,52}]'),(155,6200004,850,899,3,5,'[{255,36160006,39}]'),(156,6200004,850,899,6,10,'[{255,36160006,33}]'),(157,6200004,900,1000,1,1,'[{255,36160006,80}]'),(158,6200004,900,1000,2,2,'[{255,36160006,64}]'),(159,6200004,900,1000,3,5,'[{255,36160006,48}]'),(160,6200004,900,1000,6,10,'[{255,36160006,40}]'),(161,6200005,0,599,1,1,'[{255,36160006,5}]'),(162,6200005,0,599,2,2,'[{255,36160006,4}]'),(163,6200005,0,599,3,5,'[{255,36160006,3}]'),(164,6200005,0,599,6,10,'[{255,36160006,3}]'),(165,6200005,600,649,1,1,'[{255,36160006,8}]'),(166,6200005,600,649,2,2,'[{255,36160006,6}]'),(167,6200005,600,649,3,5,'[{255,36160006,5}]'),(168,6200005,600,649,6,10,'[{255,36160006,4}]'),(169,6200005,650,699,1,1,'[{255,36160006,13}]'),(170,6200005,650,699,2,2,'[{255,36160006,10}]'),(171,6200005,650,699,3,5,'[{255,36160006,8}]'),(172,6200005,650,699,6,10,'[{255,36160006,6}]'),(173,6200005,700,749,1,1,'[{255,36160006,20}]'),(174,6200005,700,749,2,2,'[{255,36160006,16}]'),(175,6200005,700,749,3,5,'[{255,36160006,12}]'),(176,6200005,700,749,6,10,'[{255,36160006,10}]'),(177,6200005,750,799,1,1,'[{255,36160006,30}]'),(178,6200005,750,799,2,2,'[{255,36160006,24}]'),(179,6200005,750,799,3,5,'[{255,36160006,18}]'),(180,6200005,750,799,6,10,'[{255,36160006,15}]'),(181,6200005,800,849,1,1,'[{255,36160006,50}]'),(182,6200005,800,849,2,2,'[{255,36160006,40}]'),(183,6200005,800,849,3,5,'[{255,36160006,30}]'),(184,6200005,800,849,6,10,'[{255,36160006,25}]'),(185,6200005,850,899,1,1,'[{255,36160006,65}]'),(186,6200005,850,899,2,2,'[{255,36160006,52}]'),(187,6200005,850,899,3,5,'[{255,36160006,39}]'),(188,6200005,850,899,6,10,'[{255,36160006,33}]'),(189,6200005,900,1000,1,1,'[{255,36160006,80}]'),(190,6200005,900,1000,2,2,'[{255,36160006,64}]'),(191,6200005,900,1000,3,5,'[{255,36160006,48}]'),(192,6200005,900,1000,6,10,'[{255,36160006,40}]'),(193,6200020,0,599,1,1,'[{255,36160006,50}]'),(194,6200020,0,599,2,2,'[{255,36160006,40}]'),(195,6200020,0,599,3,5,'[{255,36160006,30}]'),(196,6200020,0,599,6,10,'[{255,36160006,25}]'),(197,6200020,600,649,1,1,'[{255,36160006,75}]'),(198,6200020,600,649,2,2,'[{255,36160006,60}]'),(199,6200020,600,649,3,5,'[{255,36160006,45}]'),(200,6200020,600,649,6,10,'[{255,36160006,38}]'),(201,6200020,650,699,1,1,'[{255,36160006,125}]'),(202,6200020,650,699,2,2,'[{255,36160006,100}]'),(203,6200020,650,699,3,5,'[{255,36160006,75}]'),(204,6200020,650,699,6,10,'[{255,36160006,63}]'),(205,6200020,700,749,1,1,'[{255,36160006,200}]'),(206,6200020,700,749,2,2,'[{255,36160006,160}]'),(207,6200020,700,749,3,5,'[{255,36160006,120}]'),(208,6200020,700,749,6,10,'[{255,36160006,100}]'),(209,6200020,750,799,1,1,'[{255,36160006,300}]'),(210,6200020,750,799,2,2,'[{255,36160006,240}]'),(211,6200020,750,799,3,5,'[{255,36160006,180}]'),(212,6200020,750,799,6,10,'[{255,36160006,150}]'),(213,6200020,800,849,1,1,'[{255,36160006,500}]'),(214,6200020,800,849,2,2,'[{255,36160006,400}]'),(215,6200020,800,849,3,5,'[{255,36160006,300}]'),(216,6200020,800,849,6,10,'[{255,36160006,250}]'),(217,6200020,850,899,1,1,'[{255,36160006,650}]'),(218,6200020,850,899,2,2,'[{255,36160006,520}]'),(219,6200020,850,899,3,5,'[{255,36160006,390}]'),(220,6200020,850,899,6,10,'[{255,36160006,325}]'),(221,6200020,900,1000,1,1,'[{255,36160006,800}]'),(222,6200020,900,1000,2,2,'[{255,36160006,640}]'),(223,6200020,900,1000,3,5,'[{255,36160006,480}]'),(224,6200020,900,1000,6,10,'[{255,36160006,400}]');
/*!40000 ALTER TABLE `base_kf_invade_boss_person_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf_invade_boss_ranking_reward`
--

DROP TABLE IF EXISTS `base_kf_invade_boss_ranking_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf_invade_boss_ranking_reward` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励ID',
  `min_world_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小世界等级',
  `max_world_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大世界等级',
  `min_rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小排名',
  `max_rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大排名',
  `reward_list` varchar(512) NOT NULL COMMENT '奖励列表',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励积分',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服入侵限时BOSS排行奖励';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf_invade_boss_ranking_reward`
--

LOCK TABLES `base_kf_invade_boss_ranking_reward` WRITE;
/*!40000 ALTER TABLE `base_kf_invade_boss_ranking_reward` DISABLE KEYS */;
INSERT INTO `base_kf_invade_boss_ranking_reward` VALUES (1,0,599,1,1,'[{255,36160006,35},{0,32130001,5}]',0),(2,0,599,2,2,'[{255,36160006,35},{0,32130001,4}]',0),(3,0,599,3,3,'[{255,36160006,35},{0,32130001,3}]',0),(4,0,599,4,4,'[{255,36160006,30},{0,32130001,2}]',0),(5,0,599,5,5,'[{255,36160006,30},{0,32130001,2}]',0),(6,0,599,6,6,'[{255,36160006,25},{0,32130001,2}]',0),(7,0,599,7,7,'[{255,36160006,25},{0,32130001,1}]',0),(8,0,599,8,8,'[{255,36160006,25},{0,32130001,1}]',0),(9,0,599,9,9,'[{255,36160006,20},{0,32130001,1}]',0),(10,0,599,10,10,'[{255,36160006,20},{0,32130001,1}]',0),(11,600,649,1,1,'[{255,36160006,55},{0,32130001,5}]',0),(12,600,649,2,2,'[{255,36160006,50},{0,32130001,4}]',0),(13,600,649,3,3,'[{255,36160006,50},{0,32130001,3}]',0),(14,600,649,4,4,'[{255,36160006,45},{0,32130001,2}]',0),(15,600,649,5,5,'[{255,36160006,40},{0,32130001,2}]',0),(16,600,649,6,6,'[{255,36160006,40},{0,32130001,2}]',0),(17,600,649,7,7,'[{255,36160006,35},{0,32130001,1}]',0),(18,600,649,8,8,'[{255,36160006,35},{0,32130001,1}]',0),(19,600,649,9,9,'[{255,36160006,30},{0,32130001,1}]',0),(20,600,649,10,10,'[{255,36160006,30},{0,32130001,1}]',0),(21,650,699,1,1,'[{255,36160006,70},{0,32130001,5}]',0),(22,650,699,2,2,'[{255,36160006,65},{0,32130001,4}]',0),(23,650,699,3,3,'[{255,36160006,65},{0,32130001,3}]',0),(24,650,699,4,4,'[{255,36160006,60},{0,32130001,2}]',0),(25,650,699,5,5,'[{255,36160006,55},{0,32130001,2}]',0),(26,650,699,6,6,'[{255,36160006,50},{0,32130001,2}]',0),(27,650,699,7,7,'[{255,36160006,50},{0,32130001,1}]',0),(28,650,699,8,8,'[{255,36160006,45},{0,32130001,1}]',0),(29,650,699,9,9,'[{255,36160006,40},{0,32130001,1}]',0),(30,650,699,10,10,'[{255,36160006,35},{0,32130001,1}]',0),(31,700,749,1,1,'[{255,36160006,90},{0,32130001,5}]',0),(32,700,749,2,2,'[{255,36160006,80},{0,32130001,4}]',0),(33,700,749,3,3,'[{255,36160006,80},{0,32130001,3}]',0),(34,700,749,4,4,'[{255,36160006,75},{0,32130001,2}]',0),(35,700,749,5,5,'[{255,36160006,70},{0,32130001,2}]',0),(36,700,749,6,6,'[{255,36160006,65},{0,32130001,2}]',0),(37,700,749,7,7,'[{255,36160006,60},{0,32130001,1}]',0),(38,700,749,8,8,'[{255,36160006,55},{0,32130001,1}]',0),(39,700,749,9,9,'[{255,36160006,50},{0,32130001,1}]',0),(40,700,749,10,10,'[{255,36160006,45},{0,32130001,1}]',0),(41,750,799,1,1,'[{255,36160006,100},{0,32130002,5}]',0),(42,750,799,2,2,'[{255,36160006,90},{0,32130002,4}]',0),(43,750,799,3,3,'[{255,36160006,85},{0,32130002,3}]',0),(44,750,799,4,4,'[{255,36160006,80},{0,32130002,2}]',0),(45,750,799,5,5,'[{255,36160006,75},{0,32130002,2}]',0),(46,750,799,6,6,'[{255,36160006,70},{0,32130002,2}]',0),(47,750,799,7,7,'[{255,36160006,65},{0,32130002,1}]',0),(48,750,799,8,8,'[{255,36160006,60},{0,32130002,1}]',0),(49,750,799,9,9,'[{255,36160006,55},{0,32130002,1}]',0),(50,750,799,10,10,'[{255,36160006,50},{0,32130002,1}]',0),(51,800,849,1,1,'[{255,36160006,105},{0,32130003,5}]',0),(52,800,849,2,2,'[{255,36160006,95},{0,32130003,4}]',0),(53,800,849,3,3,'[{255,36160006,95},{0,32130003,3}]',0),(54,800,849,4,4,'[{255,36160006,90},{0,32130003,2}]',0),(55,800,849,5,5,'[{255,36160006,85},{0,32130003,2}]',0),(56,800,849,6,6,'[{255,36160006,75},{0,32130003,2}]',0),(57,800,849,7,7,'[{255,36160006,70},{0,32130003,1}]',0),(58,800,849,8,8,'[{255,36160006,65},{0,32130003,1}]',0),(59,800,849,9,9,'[{255,36160006,60},{0,32130003,1}]',0),(60,800,849,10,10,'[{255,36160006,55},{0,32130003,1}]',0),(61,850,899,1,1,'[{255,36160006,115},{0,32130003,5}]',0),(62,850,899,2,2,'[{255,36160006,105},{0,32130003,4}]',0),(63,850,899,3,3,'[{255,36160006,100},{0,32130003,3}]',0),(64,850,899,4,4,'[{255,36160006,95},{0,32130003,2}]',0),(65,850,899,5,5,'[{255,36160006,90},{0,32130003,2}]',0),(66,850,899,6,6,'[{255,36160006,85},{0,32130003,2}]',0),(67,850,899,7,7,'[{255,36160006,75},{0,32130003,1}]',0),(68,850,899,8,8,'[{255,36160006,70},{0,32130003,1}]',0),(69,850,899,9,9,'[{255,36160006,65},{0,32130003,1}]',0),(70,850,899,10,10,'[{255,36160006,60},{0,32130003,1}]',0),(71,900,1000,1,1,'[{255,36160006,125},{0,32130003,5}]',0),(72,900,1000,2,2,'[{255,36160006,110},{0,32130003,4}]',0),(73,900,1000,3,3,'[{255,36160006,110},{0,32130003,3}]',0),(74,900,1000,4,4,'[{255,36160006,105},{0,32130003,2}]',0),(75,900,1000,5,5,'[{255,36160006,95},{0,32130003,2}]',0),(76,900,1000,6,6,'[{255,36160006,90},{0,32130003,2}]',0),(77,900,1000,7,7,'[{255,36160006,85},{0,32130003,1}]',0),(78,900,1000,8,8,'[{255,36160006,75},{0,32130003,1}]',0),(79,900,1000,9,9,'[{255,36160006,70},{0,32130003,1}]',0),(80,900,1000,10,10,'[{255,36160006,60},{0,32130003,1}]',0);
/*!40000 ALTER TABLE `base_kf_invade_boss_ranking_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf_invade_boss_takepart_reward`
--

DROP TABLE IF EXISTS `base_kf_invade_boss_takepart_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf_invade_boss_takepart_reward` (
  `boss_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'BOSS_ID',
  `min_world_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小世界等级',
  `max_world_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大世界等级',
  `reward_list` varchar(1024) NOT NULL COMMENT '奖励列表',
  PRIMARY KEY (`boss_id`,`min_world_lv`,`max_world_lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服入侵限时BOSS参与奖励';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf_invade_boss_takepart_reward`
--

LOCK TABLES `base_kf_invade_boss_takepart_reward` WRITE;
/*!40000 ALTER TABLE `base_kf_invade_boss_takepart_reward` DISABLE KEYS */;
INSERT INTO `base_kf_invade_boss_takepart_reward` VALUES (6200000,0,599,'[{0,32130001,1},{0,16050001,2}]'),(6200000,600,649,'[{0,32130001,1},{0,16050001,3}]'),(6200000,650,699,'[{0,32130001,1},{0,16050001,4}]'),(6200000,700,749,'[{0,32130001,1},{0,16050001,5}]'),(6200000,750,799,'[{0,32130002,1},{0,16050001,6}]'),(6200000,800,849,'[{0,32130003,1},{0,16050001,7}]'),(6200000,850,899,'[{0,32130003,1},{0,16050001,8}]'),(6200000,900,1000,'[{0,32130003,1},{0,16050001,9}]'),(6200001,0,599,'[{0,32130001,1},{0,16050001,2}]'),(6200001,600,649,'[{0,32130001,1},{0,16050001,3}]'),(6200001,650,699,'[{0,32130001,1},{0,16050001,4}]'),(6200001,700,749,'[{0,32130001,1},{0,16050001,5}]'),(6200001,750,799,'[{0,32130002,1},{0,16050001,6}]'),(6200001,800,849,'[{0,32130003,1},{0,16050001,7}]'),(6200001,850,899,'[{0,32130003,1},{0,16050001,8}]'),(6200001,900,1000,'[{0,32130003,1},{0,16050001,9}]'),(6200002,0,599,'[{0,32130001,1},{0,16050001,2}]'),(6200002,600,649,'[{0,32130001,1},{0,16050001,3}]'),(6200002,650,699,'[{0,32130001,1},{0,16050001,4}]'),(6200002,700,749,'[{0,32130001,1},{0,16050001,5}]'),(6200002,750,799,'[{0,32130002,1},{0,16050001,6}]'),(6200002,800,849,'[{0,32130003,1},{0,16050001,7}]'),(6200002,850,899,'[{0,32130003,1},{0,16050001,8}]'),(6200002,900,1000,'[{0,32130003,1},{0,16050001,9}]'),(6200003,0,599,'[{0,32130001,1},{0,16050001,2}]'),(6200003,600,649,'[{0,32130001,1},{0,16050001,3}]'),(6200003,650,699,'[{0,32130001,1},{0,16050001,4}]'),(6200003,700,749,'[{0,32130001,1},{0,16050001,5}]'),(6200003,750,799,'[{0,32130002,1},{0,16050001,6}]'),(6200003,800,849,'[{0,32130003,1},{0,16050001,7}]'),(6200003,850,899,'[{0,32130003,1},{0,16050001,8}]'),(6200003,900,1000,'[{0,32130003,1},{0,16050001,9}]'),(6200004,0,599,'[{0,32130001,1},{0,16050001,2}]'),(6200004,600,649,'[{0,32130001,1},{0,16050001,3}]'),(6200004,650,699,'[{0,32130001,1},{0,16050001,4}]'),(6200004,700,749,'[{0,32130001,1},{0,16050001,5}]'),(6200004,750,799,'[{0,32130002,1},{0,16050001,6}]'),(6200004,800,849,'[{0,32130003,1},{0,16050001,7}]'),(6200004,850,899,'[{0,32130003,1},{0,16050001,8}]'),(6200004,900,1000,'[{0,32130003,1},{0,16050001,9}]'),(6200005,0,599,'[{0,32130001,1},{0,16050001,2}]'),(6200005,600,649,'[{0,32130001,1},{0,16050001,3}]'),(6200005,650,699,'[{0,32130001,1},{0,16050001,4}]'),(6200005,700,749,'[{0,32130001,1},{0,16050001,5}]'),(6200005,750,799,'[{0,32130002,1},{0,16050001,6}]'),(6200005,800,849,'[{0,32130003,1},{0,16050001,7}]'),(6200005,850,899,'[{0,32130003,1},{0,16050001,8}]'),(6200005,900,1000,'[{0,32130003,1},{0,16050001,9}]'),(6200020,0,599,'[{0,32130001,1},{0,16050001,2}]'),(6200020,600,649,'[{0,32130001,1},{0,16050001,3}]'),(6200020,650,699,'[{0,32130001,1},{0,16050001,4}]'),(6200020,700,749,'[{0,32130001,1},{0,16050001,5}]'),(6200020,750,799,'[{0,32130002,1},{0,16050001,6}]'),(6200020,800,849,'[{0,32130003,1},{0,16050001,7}]'),(6200020,850,899,'[{0,32130003,1},{0,16050001,8}]'),(6200020,900,1000,'[{0,32130003,1},{0,16050001,9}]');
/*!40000 ALTER TABLE `base_kf_invade_boss_takepart_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf_invade_keyvalues`
--

DROP TABLE IF EXISTS `base_kf_invade_keyvalues`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf_invade_keyvalues` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '常量Id',
  `value` varchar(512) NOT NULL COMMENT '常量值',
  `about` varchar(512) NOT NULL COMMENT '常量描述@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服入侵常量配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf_invade_keyvalues`
--

LOCK TABLES `base_kf_invade_keyvalues` WRITE;
/*!40000 ALTER TABLE `base_kf_invade_keyvalues` DISABLE KEYS */;
INSERT INTO `base_kf_invade_keyvalues` VALUES (1,'999','开启跨服需要的开服天数'),(2,'999','开启跨服需要的世界等级'),(3,'999','功能开启等级'),(4,'6201','服务器场景id'),(5,'50','服务器场景人数上限'),(6,'5','非限时采集奖励次数'),(7,'5','击杀BOSS奖励次数'),(8,'[{0,16040101,1},{0,16040111,1},{0,16040121,1},{0,16050001,1}]','BOSS参与奖奖励展示'),(9,'4*3600','限时资源场次刷新时间(s)'),(10,'[{1,30},{2,60},{3,90}]','限时资源波数时间[{波数,活动开始后多久刷出(s)}]'),(11,'100','限时BOSS服务器扣分上限'),(12,'10000','真BOSS出现概率(万分比)'),(13,'10','限时BOSS排行榜最大长度'),(14,'3600','限时资源超时清理时间(s)'),(15,'120','资源采集怪重生时间(s) 注：废弃'),(16,'5','限时采集奖励次数'),(17,'[{0,16040101,1},{0,16040111,1}]','普通采集奖励展示'),(18,'[{0,16040103,1},{0,16040113,1},{0,16040123,1}]','限时采集展示'),(19,'30','真BOSS出现延迟时间(s)');
/*!40000 ALTER TABLE `base_kf_invade_keyvalues` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf_invade_ranking_reward`
--

DROP TABLE IF EXISTS `base_kf_invade_ranking_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf_invade_ranking_reward` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励ID',
  `min_world_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小世界等级',
  `max_world_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大世界等级',
  `min_rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小排名',
  `max_rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大排名',
  `reward_list` varchar(512) NOT NULL COMMENT '奖励列表',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服入侵积分排行奖励';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf_invade_ranking_reward`
--

LOCK TABLES `base_kf_invade_ranking_reward` WRITE;
/*!40000 ALTER TABLE `base_kf_invade_ranking_reward` DISABLE KEYS */;
INSERT INTO `base_kf_invade_ranking_reward` VALUES (1,0,599,1,1,'[{255,36160006,105},{0,32130001,5}]'),(2,0,599,2,2,'[{255,36160006,95},{0,32130001,4}]'),(3,0,599,3,3,'[{255,36160006,95},{0,32130001,3}]'),(4,0,599,4,4,'[{255,36160006,90},{0,32130001,2}]'),(5,0,599,5,5,'[{255,36160006,85},{0,32130001,2}]'),(6,0,599,6,6,'[{255,36160006,75},{0,32130001,2}]'),(7,0,599,7,7,'[{255,36160006,70},{0,32130001,1}]'),(8,0,599,8,8,'[{255,36160006,65},{0,32130001,1}]'),(9,0,599,9,9,'[{255,36160006,60},{0,32130001,1}]'),(10,0,599,10,10,'[{255,36160006,55},{0,32130001,1}]'),(11,600,649,1,1,'[{255,36160006,160},{0,32130001,5}]'),(12,600,649,2,2,'[{255,36160006,145},{0,32130001,4}]'),(13,600,649,3,3,'[{255,36160006,140},{0,32130001,3}]'),(14,600,649,4,4,'[{255,36160006,130},{0,32130001,2}]'),(15,600,649,5,5,'[{255,36160006,125},{0,32130001,2}]'),(16,600,649,6,6,'[{255,36160006,115},{0,32130001,2}]'),(17,600,649,7,7,'[{255,36160006,105},{0,32130001,1}]'),(18,600,649,8,8,'[{255,36160006,95},{0,32130001,1}]'),(19,600,649,9,9,'[{255,36160006,90},{0,32130001,1}]'),(20,600,649,10,10,'[{255,36160006,80},{0,32130001,1}]'),(21,650,699,1,1,'[{255,36160006,210},{0,32130001,5}]'),(22,650,699,2,2,'[{255,36160006,190},{0,32130001,4}]'),(23,650,699,3,3,'[{255,36160006,185},{0,32130001,3}]'),(24,650,699,4,4,'[{255,36160006,175},{0,32130001,2}]'),(25,650,699,5,5,'[{255,36160006,165},{0,32130001,2}]'),(26,650,699,6,6,'[{255,36160006,150},{0,32130001,2}]'),(27,650,699,7,7,'[{255,36160006,140},{0,32130001,1}]'),(28,650,699,8,8,'[{255,36160006,130},{0,32130001,1}]'),(29,650,699,9,9,'[{255,36160006,115},{0,32130001,1}]'),(30,650,699,10,10,'[{255,36160006,105},{0,32130001,1}]'),(31,700,749,1,1,'[{255,36160006,265},{0,32130001,5}]'),(32,700,749,2,2,'[{255,36160006,240},{0,32130001,4}]'),(33,700,749,3,3,'[{255,36160006,235},{0,32130001,3}]'),(34,700,749,4,4,'[{255,36160006,220},{0,32130001,2}]'),(35,700,749,5,5,'[{255,36160006,205},{0,32130001,2}]'),(36,700,749,6,6,'[{255,36160006,190},{0,32130001,2}]'),(37,700,749,7,7,'[{255,36160006,175},{0,32130001,1}]'),(38,700,749,8,8,'[{255,36160006,160},{0,32130001,1}]'),(39,700,749,9,9,'[{255,36160006,145},{0,32130001,1}]'),(40,700,749,10,10,'[{255,36160006,130},{0,32130001,1}]'),(41,750,799,1,1,'[{255,36160006,290},{0,32130002,5}]'),(42,750,799,2,2,'[{255,36160006,260},{0,32130002,4}]'),(43,750,799,3,3,'[{255,36160006,255},{0,32130002,3}]'),(44,750,799,4,4,'[{255,36160006,240},{0,32130002,2}]'),(45,750,799,5,5,'[{255,36160006,225},{0,32130002,2}]'),(46,750,799,6,6,'[{255,36160006,210},{0,32130002,2}]'),(47,750,799,7,7,'[{255,36160006,190},{0,32130002,1}]'),(48,750,799,8,8,'[{255,36160006,175},{0,32130002,1}]'),(49,750,799,9,9,'[{255,36160006,160},{0,32130002,1}]'),(50,750,799,10,10,'[{255,36160006,145},{0,32130002,1}]'),(51,800,849,1,1,'[{255,36160006,315},{0,32130003,5}]'),(52,800,849,2,2,'[{255,36160006,285},{0,32130003,4}]'),(53,800,849,3,3,'[{255,36160006,280},{0,32130003,3}]'),(54,800,849,4,4,'[{255,36160006,260},{0,32130003,2}]'),(55,800,849,5,5,'[{255,36160006,245},{0,32130003,2}]'),(56,800,849,6,6,'[{255,36160006,225},{0,32130003,2}]'),(57,800,849,7,7,'[{255,36160006,210},{0,32130003,1}]'),(58,800,849,8,8,'[{255,36160006,190},{0,32130003,1}]'),(59,800,849,9,9,'[{255,36160006,175},{0,32130003,1}]'),(60,800,849,10,10,'[{255,36160006,155},{0,32130003,1}]'),(61,850,899,1,1,'[{255,36160006,345},{0,32130003,5}]'),(62,850,899,2,2,'[{255,36160006,310},{0,32130003,4}]'),(63,850,899,3,3,'[{255,36160006,300},{0,32130003,3}]'),(64,850,899,4,4,'[{255,36160006,285},{0,32130003,2}]'),(65,850,899,5,5,'[{255,36160006,265},{0,32130003,2}]'),(66,850,899,6,6,'[{255,36160006,245},{0,32130003,2}]'),(67,850,899,7,7,'[{255,36160006,225},{0,32130003,1}]'),(68,850,899,8,8,'[{255,36160006,210},{0,32130003,1}]'),(69,850,899,9,9,'[{255,36160006,190},{0,32130003,1}]'),(70,850,899,10,10,'[{255,36160006,170},{0,32130003,1}]'),(71,900,1000,1,1,'[{255,36160006,370},{0,32130003,5}]'),(72,900,1000,2,2,'[{255,36160006,335},{0,32130003,4}]'),(73,900,1000,3,3,'[{255,36160006,325},{0,32130003,3}]'),(74,900,1000,4,4,'[{255,36160006,305},{0,32130003,2}]'),(75,900,1000,5,5,'[{255,36160006,285},{0,32130003,2}]'),(76,900,1000,6,6,'[{255,36160006,265},{0,32130003,2}]'),(77,900,1000,7,7,'[{255,36160006,245},{0,32130003,1}]'),(78,900,1000,8,8,'[{255,36160006,225},{0,32130003,1}]'),(79,900,1000,9,9,'[{255,36160006,205},{0,32130003,1}]'),(80,900,1000,10,10,'[{255,36160006,180},{0,32130003,1}]');
/*!40000 ALTER TABLE `base_kf_invade_ranking_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf_invade_scene_mon`
--

DROP TABLE IF EXISTS `base_kf_invade_scene_mon`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf_invade_scene_mon` (
  `mon_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '怪物ID',
  `type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '怪物类型',
  `center_x` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '中心X坐标',
  `center_y` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '中心Y坐标',
  `revive_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '复活时间(s)',
  `reward_icon` varchar(128) NOT NULL COMMENT '奖励图标',
  PRIMARY KEY (`mon_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服入侵场景怪物';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf_invade_scene_mon`
--

LOCK TABLES `base_kf_invade_scene_mon` WRITE;
/*!40000 ALTER TABLE `base_kf_invade_scene_mon` DISABLE KEYS */;
INSERT INTO `base_kf_invade_scene_mon` VALUES (6200100,0,9570,2881,0,'10001'),(6200101,0,4768,5116,0,'10001'),(6200105,0,8298,12689,0,'10001'),(6200106,0,11227,12628,0,'10001'),(6200109,0,14238,4918,0,'10001'),(620020001,1,15200,6100,300,'16040100'),(620020002,1,15700,9600,300,'16040200'),(620020003,1,14400,12800,300,'16040300'),(620020004,1,10000,13500,300,'16040400'),(620020005,1,3500,9600,300,'16040500'),(620020006,1,4100,5900,300,'16040600'),(620020007,1,9600,1800,7200,'32080003'),(620020008,1,4800,12800,14400,'32080004');
/*!40000 ALTER TABLE `base_kf_invade_scene_mon` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf_invade_stage_reward`
--

DROP TABLE IF EXISTS `base_kf_invade_stage_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf_invade_stage_reward` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励ID',
  `stage_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '阶段ID',
  `min_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家最小等级',
  `max_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家最大等级',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励积分',
  `reward_list` varchar(512) NOT NULL COMMENT '奖励列表',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服入侵积分阶段奖励';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf_invade_stage_reward`
--

LOCK TABLES `base_kf_invade_stage_reward` WRITE;
/*!40000 ALTER TABLE `base_kf_invade_stage_reward` DISABLE KEYS */;
INSERT INTO `base_kf_invade_stage_reward` VALUES (1,1,0,599,800,'[{0,16050001,2}]'),(2,2,0,599,1600,'[{0,16050001,4}]'),(3,3,0,599,2400,'[{0,16050001,6}]'),(4,4,0,599,3200,'[{0,16050001,8},{0,32130001,1}]'),(5,5,0,599,4000,'[{0,16050001,10}]'),(6,6,0,599,4800,'[{0,16050001,12},{0,32130001,1}]'),(7,1,600,649,800,'[{0,16050001,2}]'),(8,2,600,649,1600,'[{0,16050001,5}]'),(9,3,600,649,2400,'[{0,16050001,8}]'),(10,4,600,649,3200,'[{0,16050001,11},{0,32130001,1}]'),(11,5,600,649,4000,'[{0,16050001,14}]'),(12,6,600,649,4800,'[{0,16050001,18},{0,32130001,1}]'),(13,1,650,699,800,'[{0,16050001,3}]'),(14,2,650,699,1600,'[{0,16050001,7}]'),(15,3,650,699,2400,'[{0,16050001,11}]'),(16,4,650,699,3200,'[{0,16050001,15},{0,32130001,1}]'),(17,5,650,699,4000,'[{0,16050001,19}]'),(18,6,650,699,4800,'[{0,16050001,24},{0,32130001,1}]'),(19,1,700,749,800,'[{0,16050001,4}]'),(20,2,700,749,1600,'[{0,16050001,9}]'),(21,3,700,749,2400,'[{0,16050001,14}]'),(22,4,700,749,3200,'[{0,16050001,19},{0,32130001,1}]'),(23,5,700,749,4000,'[{0,16050001,24}]'),(24,6,700,749,4800,'[{0,16050001,30},{0,32130001,1}]'),(25,1,750,799,800,'[{0,16050001,4}]'),(26,2,750,799,1600,'[{0,16050001,10}]'),(27,3,750,799,2400,'[{0,16050001,15}]'),(28,4,750,799,3200,'[{0,16050001,21},{0,32130002,1}]'),(29,5,750,799,4000,'[{0,16050001,26}]'),(30,6,750,799,4800,'[{0,16050001,33},{0,32130002,1}]'),(31,1,800,849,800,'[{0,16050001,5}]'),(32,2,800,849,1600,'[{0,16050001,11}]'),(33,3,800,849,2400,'[{0,16050001,17}]'),(34,4,800,849,3200,'[{0,16050001,23},{0,32130003,1}]'),(35,5,800,849,4000,'[{0,16050001,29}]'),(36,6,800,849,4800,'[{0,16050001,36},{0,32130003,1}]'),(37,1,850,899,800,'[{0,16050001,5}]'),(38,2,850,899,1600,'[{0,16050001,12}]'),(39,3,850,899,2400,'[{0,16050001,18}]'),(40,4,850,899,3200,'[{0,16050001,25},{0,32130003,1}]'),(41,5,850,899,4000,'[{0,16050001,31}]'),(42,6,850,899,4800,'[{0,16050001,39},{0,32130003,1}]'),(43,1,900,1000,800,'[{0,16050001,6}]'),(44,2,900,1000,1600,'[{0,16050001,13}]'),(45,3,900,1000,2400,'[{0,16050001,20}]'),(46,4,900,1000,3200,'[{0,16050001,27},{0,32130003,1}]'),(47,5,900,1000,4000,'[{0,16050001,34}]'),(48,6,900,1000,4800,'[{0,16050001,42},{0,32130003,1}]');
/*!40000 ALTER TABLE `base_kf_invade_stage_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf_invade_task`
--

DROP TABLE IF EXISTS `base_kf_invade_task`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf_invade_task` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '任务ID',
  `name` varchar(255) NOT NULL COMMENT '任务名字@lang@',
  `type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '任务类型',
  `num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '数量',
  `about` varchar(512) NOT NULL COMMENT '任务描述@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服入侵任务配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf_invade_task`
--

LOCK TABLES `base_kf_invade_task` WRITE;
/*!40000 ALTER TABLE `base_kf_invade_task` DISABLE KEYS */;
INSERT INTO `base_kf_invade_task` VALUES (1,'[日]击杀怪物Ⅰ',1,100,'<color=#d83f3f>他服</color>击杀<color=#00FF00>小怪</color>{0}/{1}'),(2,'[日]击杀怪物Ⅱ',1,200,'<color=#d83f3f>他服</color>击杀<color=#00FF00>小怪</color>{0}/{1}'),(3,'[日]击杀怪物Ⅲ',1,300,'<color=#d83f3f>他服</color>击杀<color=#00FF00>小怪</color>{0}/{1}'),(4,'[日]每日采集',2,3,'在<color=#d83f3f>他服</color>兽灵岛采集资源{0}/{1}');
/*!40000 ALTER TABLE `base_kf_invade_task` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf_invade_task_reward`
--

DROP TABLE IF EXISTS `base_kf_invade_task_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf_invade_task_reward` (
  `task_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '任务ID',
  `min_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小玩家等级',
  `max_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大玩家等级',
  `reward_list` varchar(512) NOT NULL COMMENT '奖励列表',
  PRIMARY KEY (`task_id`,`min_lv`,`max_lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服入侵任务奖励配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf_invade_task_reward`
--

LOCK TABLES `base_kf_invade_task_reward` WRITE;
/*!40000 ALTER TABLE `base_kf_invade_task_reward` DISABLE KEYS */;
INSERT INTO `base_kf_invade_task_reward` VALUES (1,0,599,'[{0,16050001,5}]'),(1,600,649,'[{0,16050001,7}]'),(1,650,699,'[{0,16050001,9}]'),(1,700,749,'[{0,16050001,12}]'),(1,750,799,'[{0,16050001,13}]'),(1,800,849,'[{0,16050001,14}]'),(1,850,899,'[{0,16050001,15}]'),(1,900,1000,'[{0,16050001,16}]'),(2,0,599,'[{0,16050001,9}]'),(2,600,649,'[{0,16050001,14}]'),(2,650,699,'[{0,16050001,18}]'),(2,700,749,'[{0,16050001,23}]'),(2,750,799,'[{0,16050001,25}]'),(2,800,849,'[{0,16050001,28}]'),(2,850,899,'[{0,16050001,30}]'),(2,900,1000,'[{0,16050001,32}]'),(3,0,599,'[{0,16050001,18},{0,32130001,1}]'),(3,600,649,'[{0,16050001,28},{0,32130001,1}]'),(3,650,699,'[{0,16050001,37},{0,32130001,1}]'),(3,700,749,'[{0,16050001,46},{0,32130001,1}]'),(3,750,799,'[{0,16050001,51},{0,32130002,1}]'),(3,800,849,'[{0,16050001,55},{0,32130003,1}]'),(3,850,899,'[{0,16050001,60},{0,32130003,1}]'),(3,900,1000,'[{0,16050001,64},{0,32130003,1}]'),(4,0,599,'[{0,16050001,14}]'),(4,600,649,'[{0,16050001,21}]'),(4,650,699,'[{0,16050001,28}]'),(4,700,749,'[{0,16050001,35}]'),(4,750,799,'[{0,16050001,38}]'),(4,800,849,'[{0,16050001,41}]'),(4,850,899,'[{0,16050001,45}]'),(4,900,1000,'[{0,16050001,48}]');
/*!40000 ALTER TABLE `base_kf_invade_task_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf_invade_timelim_boss`
--

DROP TABLE IF EXISTS `base_kf_invade_timelim_boss`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf_invade_timelim_boss` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'BOSS_ID',
  `type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT 'BOSS类型',
  `born_x` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '出生X坐标',
  `born_y` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '出生Y坐标',
  `area_radius` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'BOSS区域半径',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励积分',
  `call_timelim_res` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否召唤限时资源',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服入侵限时BOSS配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf_invade_timelim_boss`
--

LOCK TABLES `base_kf_invade_timelim_boss` WRITE;
/*!40000 ALTER TABLE `base_kf_invade_timelim_boss` DISABLE KEYS */;
INSERT INTO `base_kf_invade_timelim_boss` VALUES (6200000,1,5100,11400,1000,1000,0),(6200001,1,14000,11200,1000,1000,0),(6200002,1,15000,8400,1000,1000,0),(6200003,1,4100,8200,1000,1000,0),(6200004,1,13100,2800,1000,1000,0),(6200005,1,6100,2800,2000,1000,0),(6200020,2,9565,9295,1000,8000,1);
/*!40000 ALTER TABLE `base_kf_invade_timelim_boss` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf_invade_timelim_res`
--

DROP TABLE IF EXISTS `base_kf_invade_timelim_res`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf_invade_timelim_res` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '波数ID',
  `type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `mon_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '怪物ID',
  `num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '数量',
  `coord_list` varchar(512) NOT NULL COMMENT '坐标列表',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励积分',
  PRIMARY KEY (`id`,`type`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服入侵限时资源配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf_invade_timelim_res`
--

LOCK TABLES `base_kf_invade_timelim_res` WRITE;
/*!40000 ALTER TABLE `base_kf_invade_timelim_res` DISABLE KEYS */;
INSERT INTO `base_kf_invade_timelim_res` VALUES (1,2,620030001,2,'[{12906,6624},{6449,6468},{9698,4779},{15916,9680},{3643,9461}]',20),(2,2,620030001,2,'[{12906,6624},{6449,6468},{9698,4779},{15916,9680},{3643,9461}]',10),(3,1,620030001,2,'[{12686,7378},{6420,5945}]',20);
/*!40000 ALTER TABLE `base_kf_invade_timelim_res` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf_rank_kv`
--

DROP TABLE IF EXISTS `base_kf_rank_kv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf_rank_kv` (
  `id` int(11) unsigned NOT NULL COMMENT 'ID',
  `value` varchar(512) NOT NULL COMMENT '值',
  `desc` varchar(512) NOT NULL COMMENT '@lang@描述',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服榜单-榜单常量表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf_rank_kv`
--

LOCK TABLES `base_kf_rank_kv` WRITE;
/*!40000 ALTER TABLE `base_kf_rank_kv` DISABLE KEYS */;
INSERT INTO `base_kf_rank_kv` VALUES (1,'8','跨服榜单开启天数（开服天数）'),(2,'[{0,38100001,1},{0,38100008,1}]','榜单点赞反馈奖励');
/*!40000 ALTER TABLE `base_kf_rank_kv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf_rank_type`
--

DROP TABLE IF EXISTS `base_kf_rank_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf_rank_type` (
  `type` smallint(5) unsigned NOT NULL COMMENT '榜单类型',
  `rank_name` varchar(255) NOT NULL COMMENT '@lang@榜单名称',
  `rank_max` int(11) unsigned NOT NULL COMMENT '最大长度',
  `rank_limit` int(11) unsigned NOT NULL COMMENT '上榜条件',
  `title_id` int(11) unsigned NOT NULL COMMENT '首位称号',
  `about` varchar(512) NOT NULL COMMENT '说明',
  PRIMARY KEY (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服榜单-榜单配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf_rank_type`
--

LOCK TABLES `base_kf_rank_type` WRITE;
/*!40000 ALTER TABLE `base_kf_rank_type` DISABLE KEYS */;
INSERT INTO `base_kf_rank_type` VALUES (100,'战力榜',60,300000,4902021,'战力达到300000'),(200,'等级榜',100,120,4902020,'等级达到120'),(300,'装备榜',100,100000,4902022,'装备战斗力达到100000'),(400,'魂珠榜',100,10000,0,'魂珠战斗力达到10000'),(601,'坐骑榜',60,20000,0,'坐骑战力达到20000'),(602,'翅膀榜',60,20000,0,'翅膀战力达到20000'),(603,'宝具榜',60,20000,0,'翅膀战力达到20000'),(604,'降神榜',60,20000,0,'降神战力达到20000'),(605,'圣灵榜',60,20000,0,'圣灵战力达到20000'),(606,'星灵榜',60,20000,0,'星灵战力达到20000');
/*!40000 ALTER TABLE `base_kf_rank_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf_town_war_birth`
--

DROP TABLE IF EXISTS `base_kf_town_war_birth`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf_town_war_birth` (
  `area_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '区域id',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `location` varchar(50) NOT NULL DEFAULT '[]' COMMENT '坐标',
  PRIMARY KEY (`area_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf_town_war_birth`
--

LOCK TABLES `base_kf_town_war_birth` WRITE;
/*!40000 ALTER TABLE `base_kf_town_war_birth` DISABLE KEYS */;
INSERT INTO `base_kf_town_war_birth` VALUES (1,1,'[{7261,7780},{10583,11108}] '),(2,1,'[{13288,13928},{8170,8798}] '),(3,1,'[{20444,21084},{6938,7528}] '),(4,2,'[{17084,17768},{19512,20258}] ');
/*!40000 ALTER TABLE `base_kf_town_war_birth` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf_town_war_buding_reward`
--

DROP TABLE IF EXISTS `base_kf_town_war_buding_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf_town_war_buding_reward` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '序号',
  `building_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '领地类型',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '奖励类型',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励内容',
  `description` varchar(50) NOT NULL COMMENT '描述',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf_town_war_buding_reward`
--

LOCK TABLES `base_kf_town_war_buding_reward` WRITE;
/*!40000 ALTER TABLE `base_kf_town_war_buding_reward` DISABLE KEYS */;
INSERT INTO `base_kf_town_war_buding_reward` VALUES (1,2,1,'[{255,36090001,1600},{0,32020113,6}]','重镇战胜利奖励'),(2,2,2,'[{255,36090001,1200},{0,32020113,4}]','重镇战失败奖励'),(3,3,1,'[{255,36090001,2000},{0,32020114,2}]','神迹战胜利奖励'),(4,3,2,'[{255,36090001,1500},{0,32020114,1}]','神迹战失败奖励');
/*!40000 ALTER TABLE `base_kf_town_war_buding_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf_town_war_building`
--

DROP TABLE IF EXISTS `base_kf_town_war_building`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf_town_war_building` (
  `building_id` int(11) unsigned NOT NULL,
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '领地类型',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '领地名',
  `next_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '下层领地id',
  `icon` varchar(50) NOT NULL DEFAULT '0' COMMENT '领地图标id',
  PRIMARY KEY (`building_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf_town_war_building`
--

LOCK TABLES `base_kf_town_war_building` WRITE;
/*!40000 ALTER TABLE `base_kf_town_war_building` DISABLE KEYS */;
INSERT INTO `base_kf_town_war_building` VALUES (101,1,'要塞1',201,'icon_czjz_3'),(102,1,'要塞2',201,'icon_czjz_3'),(103,1,'要塞3',202,'icon_czjz_3'),(104,1,'要塞4',202,'icon_czjz_3'),(105,1,'要塞5',203,'icon_czjz_3'),(106,1,'要塞6',203,'icon_czjz_3'),(201,2,'重镇1',301,'icon_czjz_2'),(202,2,'重镇2',301,'icon_czjz_2'),(203,2,'重镇3',301,'icon_czjz_2'),(301,3,'神迹',0,'icon_czjz_1');
/*!40000 ALTER TABLE `base_kf_town_war_building` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf_town_war_guild_rank`
--

DROP TABLE IF EXISTS `base_kf_town_war_guild_rank`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf_town_war_guild_rank` (
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '公会排名',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励列表',
  `description` varchar(50) NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`rank`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf_town_war_guild_rank`
--

LOCK TABLES `base_kf_town_war_guild_rank` WRITE;
/*!40000 ALTER TABLE `base_kf_town_war_guild_rank` DISABLE KEYS */;
INSERT INTO `base_kf_town_war_guild_rank` VALUES (1,'[{255,36090001,1200},{0,32020112,12}]','公会积分第1名'),(2,'[{255,36090001,900},{0,32020112,9}]','公会积分第2名'),(3,'[{255,36090001,600},{0,32020112,6}]','公会积分第3名'),(4,'[{255,36090001,400},{0,32020112,4}]','公会积分第4名');
/*!40000 ALTER TABLE `base_kf_town_war_guild_rank` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf_town_war_kill_reward`
--

DROP TABLE IF EXISTS `base_kf_town_war_kill_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf_town_war_kill_reward` (
  `kill_rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '击杀数排名',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励内容',
  PRIMARY KEY (`kill_rank`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf_town_war_kill_reward`
--

LOCK TABLES `base_kf_town_war_kill_reward` WRITE;
/*!40000 ALTER TABLE `base_kf_town_war_kill_reward` DISABLE KEYS */;
INSERT INTO `base_kf_town_war_kill_reward` VALUES (1,'[{0,4916003,1}] '),(2,'[{0,4916002,1}] '),(3,'[{0,4916001,1}] ');
/*!40000 ALTER TABLE `base_kf_town_war_kill_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf_town_war_kv`
--

DROP TABLE IF EXISTS `base_kf_town_war_kv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf_town_war_kv` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '键',
  `val` varchar(255) NOT NULL DEFAULT '0' COMMENT '值',
  `description` varchar(255) NOT NULL DEFAULT '' COMMENT '描述@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf_town_war_kv`
--

LOCK TABLES `base_kf_town_war_kv` WRITE;
/*!40000 ALTER TABLE `base_kf_town_war_kv` DISABLE KEYS */;
INSERT INTO `base_kf_town_war_kv` VALUES (1,'14','开服天数>才开启'),(2,'28','赛季天数'),(3,'3','宣战公会上限'),(4,'4601','场景id'),(5,'300','海盗船刷新间隔(秒/s)'),(6,'[{4061025,[{12598,16201},{18587,13634}]}]','海盗船坐标:格式[{怪物Id,[{X1,Y1},{X2,Y2}]}]'),(7,'1000','公会宣战所需公会活跃度'),(8,'5','定时场景传闻间隔(秒/s)'),(9,'350','参加活动等级'),(10,'5','攻击一次复活点积分'),(11,'10','攻击一次海神像积分'),(12,'3','击杀普通怪物积分'),(13,'5','击杀玩家积分'),(14,'100','击杀海盗船积分'),(15,'10','活动人物参与积分'),(16,'5','活动公会参与积分'),(17,'10','参与积分增加间隔(秒/s)'),(18,'10','占领据点增加积分间隔(秒/s)'),(19,'[{0,4916004,1}]','被击杀数最多的个人奖励:格式[{类型,物品id,数量}]'),(20,'10001','默认船舰id'),(21,'10','商店显示商品个数'),(22,'20','每个公会参加人数上限'),(23,'10','应援最多次数'),(24,'[{2,0,10}]','应援消耗：格式[{类型,物品id,数量}]'),(25,'{460100001,120}','{海盗船buff技能id,buff时间}');
/*!40000 ALTER TABLE `base_kf_town_war_kv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf_town_war_open`
--

DROP TABLE IF EXISTS `base_kf_town_war_open`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf_town_war_open` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '序号',
  `open` varchar(50) NOT NULL DEFAULT '[]' COMMENT '开启日期',
  `signtime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '报名时间',
  `fighttime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战斗时间',
  `description` varchar(50) NOT NULL DEFAULT '' COMMENT '描述@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf_town_war_open`
--

LOCK TABLES `base_kf_town_war_open` WRITE;
/*!40000 ALTER TABLE `base_kf_town_war_open` DISABLE KEYS */;
INSERT INTO `base_kf_town_war_open` VALUES (1,'[{3,3,0,0}]',63000,1200,'周三3点至20:30宣战,20:30-20:50进行比赛');
/*!40000 ALTER TABLE `base_kf_town_war_open` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf_town_war_own`
--

DROP TABLE IF EXISTS `base_kf_town_war_own`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf_town_war_own` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '据点id',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '据点类型',
  `sub_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '据点子类型',
  `location` varchar(50) NOT NULL DEFAULT '[]' COMMENT '坐标',
  `first_role_score` int(11) NOT NULL DEFAULT '0' COMMENT '首次占领玩家分数',
  `first_guild_score` int(11) NOT NULL DEFAULT '0' COMMENT '首次占领公会分数',
  `add_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '占领玩家持续增加的分数',
  `add_guild_score` int(11) NOT NULL DEFAULT '0' COMMENT '占领公会持续增加积分',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf_town_war_own`
--

LOCK TABLES `base_kf_town_war_own` WRITE;
/*!40000 ALTER TABLE `base_kf_town_war_own` DISABLE KEYS */;
INSERT INTO `base_kf_town_war_own` VALUES (4061021,1,1,'[{11757,12239}]',500,1000,5,10),(4061022,1,2,'[{17033,10952}]',500,1000,5,10),(4061023,2,0,'[{15472,15008}]',800,1500,10,15);
/*!40000 ALTER TABLE `base_kf_town_war_own` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf_town_war_own_reward`
--

DROP TABLE IF EXISTS `base_kf_town_war_own_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf_town_war_own_reward` (
  `building_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '领地类型',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '领取类型',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '占领每日奖励',
  `description` varchar(50) NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`building_type`,`type`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf_town_war_own_reward`
--

LOCK TABLES `base_kf_town_war_own_reward` WRITE;
/*!40000 ALTER TABLE `base_kf_town_war_own_reward` DISABLE KEYS */;
INSERT INTO `base_kf_town_war_own_reward` VALUES (1,1,'[{255,36090001,250},{0,32020112,3}]','要塞占领会长'),(1,2,'[{255,36090001,200},{0,32020112,2}]','要塞占领会员'),(2,1,'[{255,36090001,320},{0,32020112,4}]','重镇占领会长'),(2,2,'[{255,36090001,250},{0,32020112,3}]','重镇占领会员'),(3,1,'[{255,36090001,400},{0,32020112,6}]','神迹占领会长'),(3,2,'[{255,36090001,320},{0,32020112,5}]','神迹占领会员');
/*!40000 ALTER TABLE `base_kf_town_war_own_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf_town_war_score_reward`
--

DROP TABLE IF EXISTS `base_kf_town_war_score_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf_town_war_score_reward` (
  `reward_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励id',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励列表',
  `description` varchar(50) NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`reward_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf_town_war_score_reward`
--

LOCK TABLES `base_kf_town_war_score_reward` WRITE;
/*!40000 ALTER TABLE `base_kf_town_war_score_reward` DISABLE KEYS */;
INSERT INTO `base_kf_town_war_score_reward` VALUES (1,600,'[{255,36090001,80},{0,24010001,2}]','个人积分达到600'),(2,1000,'[{255,36090001,90},{0,24010001,2}]','个人积分达到1000'),(3,1500,'[{255,36090001,100},{0,24010001,2}]','个人积分达到1500'),(4,2500,'[{255,36090001,110},{0,24010001,2}]','个人积分达到2500'),(5,3500,'[{255,36090001,120},{0,24010001,3}]','个人积分达到3500'),(6,4500,'[{255,36090001,130},{0,24010001,3}]','个人积分达到4500'),(7,5600,'[{255,36090001,140},{0,24010001,3}]','个人积分达到5600'),(8,7000,'[{255,36090001,150},{0,24010001,3}]','个人积分达到7000');
/*!40000 ALTER TABLE `base_kf_town_war_score_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf_town_war_ship`
--

DROP TABLE IF EXISTS `base_kf_town_war_ship`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf_town_war_ship` (
  `ship_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '船舰id',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '名称',
  `skill_list` varchar(50) NOT NULL DEFAULT '[]' COMMENT '技能列表',
  `need_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '兑换积分',
  `source_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '模型id',
  `model` double unsigned NOT NULL DEFAULT '0' COMMENT '船模型大小',
  PRIMARY KEY (`ship_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf_town_war_ship`
--

LOCK TABLES `base_kf_town_war_ship` WRITE;
/*!40000 ALTER TABLE `base_kf_town_war_ship` DISABLE KEYS */;
INSERT INTO `base_kf_town_war_ship` VALUES (1001,'冲锋舰','[17000011,17000012,17000013,17000014]',1000,460102,1),(1002,'疾行舰','[17000021,17000022,17000023,17000024]',2000,460103,1),(1003,'海王舰','[17000031,17000032,17000033,17000034]',3500,460104,1),(10001,'普通舰','[17000001,17000002,17000003,17000004] ',0,460101,1);
/*!40000 ALTER TABLE `base_kf_town_war_ship` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_kf_town_war_shop`
--

DROP TABLE IF EXISTS `base_kf_town_war_shop`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_kf_town_war_shop` (
  `auto_id` int(11) NOT NULL DEFAULT '0' COMMENT '唯一id',
  `good_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商品id',
  `need_lv` int(11) NOT NULL DEFAULT '0' COMMENT '所需等级',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `limit_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '限购数量',
  `weight` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '权重',
  `building_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '领地类型',
  PRIMARY KEY (`auto_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_kf_town_war_shop`
--

LOCK TABLES `base_kf_town_war_shop` WRITE;
/*!40000 ALTER TABLE `base_kf_town_war_shop` DISABLE KEYS */;
INSERT INTO `base_kf_town_war_shop` VALUES (1,32080932,350,'[{255,36090001,2400}]',20,0,1),(2,32080933,350,'[{255,36090001,3000}]',20,0,1),(3,32081032,350,'[{255,36090001,2700}]',20,0,1),(4,32081033,350,'[{255,36090001,3400}]',20,0,2),(5,38280510,360,'[{255,36090001,4500}]',1,0,2),(6,38280520,360,'[{255,36090001,5000}]',1,0,2),(7,38280620,360,'[{255,36090001,5500}]',1,0,3),(8,32081132,380,'[{255,36090001,3000}]',20,0,2),(9,32081133,380,'[{255,36090001,3800}]',20,0,2),(10,32081232,450,'[{255,36090001,3300}]',20,0,2),(11,32081233,450,'[{255,36090001,4200}]',20,0,2),(12,32081332,500,'[{255,36090001,3600}]',20,0,2),(13,32081333,500,'[{255,36090001,4600}]',20,0,3);
/*!40000 ALTER TABLE `base_kf_town_war_shop` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_language`
--

DROP TABLE IF EXISTS `base_language`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_language` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `module_id` int(11) NOT NULL COMMENT '功能id',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '语言类型',
  `changed` tinyint(1) NOT NULL DEFAULT '1' COMMENT '是否变更##内容如果更新，此值置为1。初始也为1',
  `content` text NOT NULL COMMENT '内容@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=51510008 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_language`
--

LOCK TABLES `base_language` WRITE;
/*!40000 ALTER TABLE `base_language` DISABLE KEYS */;
INSERT INTO `base_language` VALUES (2,151,1,1,'道具自动下架'),(3,151,2,1,'您寄售的道具<color@{1}>[{2}]</color>已上架{3}小时未售出，系统将其自动下架，请查收。'),(4,151,1,1,'物品寄售成功'),(5,151,2,1,'您成功出售<color@{1}>[{2}]</color>x{3}，获得{4}粉钻，剩余{5}次交易次数，请在邮件附件中领取粉钻。'),(35,0,1,0,'充值成功'),(36,0,2,0,'恭喜您，您于{1}年{2}月{3}日{4}时{5}分充值的{6}钻石已成功注入。'),(37,150,1,0,'恭喜您，获得物品掉落'),(38,150,2,1,'恭喜您，参与击杀{1},获得物品掉落{2}*{3}，由于您背包空间不足，现邮件发放给您！'),(43,418,1,1,'魅力海滩'),(44,418,2,1,'恭喜您！您在魅力海滩活动中魅力值排第<color@0>{1}</color>名，获得以下奖励！'),(52,159,1,0,'购买{1}'),(53,159,2,1,'恭喜您成功购买{1}，除充值钻石外还一次性额外赠送您{2}绑钻。祝您游戏愉快！'),(89,610,1,1,'{1}奖励'),(90,610,2,1,'在掉线期间，您通过了{1}，获得以下奖励，请接收！'),(91,610,2,1,'亲爱的骑士：在掉线期间，你所在的队伍通过了{1}，获得以下奖励，请接收！'),(92,610,2,1,'亲爱的骑士：由于您的背包空间不足，您在{1}获得以下奖励暂时以邮件形式保存，请尽快清理背包！'),(131,130,1,1,'改名通知'),(132,130,0,1,'亲爱的玩家，您的好友{1}现已更名为{2}，请继续保持联系哦！'),(133,130,0,1,'亲爱的玩家，您的仇人{1}现已更名为{2}，请继续保持追寻其下落！'),(134,130,1,1,'罪恶值提醒'),(135,130,2,1,'亲爱的玩家，由于您在野外场景不小心击杀了{1}，增加了1点罪恶值，红名状态下野外挂机被击杀将损失20绑钻。您可以在人物战斗模式旁边的buff列表中查看当前红名值信息。'),(145,300,1,1,'任务奖励'),(146,300,2,1,'亲爱的冒险家，你的背包满了，现在我们将任务的奖励通过邮件发送给你，请及时查收。'),(147,159,1,1,'充值活动'),(148,159,2,1,'你的背包不足。'),(151,110,0,1,'被gm或指导员禁言!禁言时长为{1}分钟'),(152,110,0,1,'违反规则,40级下与非好友私聊次数超过30条!禁言时长为{1}分钟'),(153,110,0,1,'违反规则,40级下私聊好友超过20个!禁言时长为{1}分钟'),(154,110,0,1,'被举报超过10次!禁言时长为{1}分钟'),(155,110,0,1,'gm或指导员手动解除禁言!'),(156,110,0,1,'自动解除禁言!'),(157,110,0,1,'管理员或新手指导员'),(158,110,0,1,'自动'),(179,223,0,1,'神秘人'),(180,0,0,1,'系统'),(184,132,1,1,'离线挂机自动买活'),(185,132,2,1,'您在本次挂机过程中被击败了{1}次，最近一次击败您的为{2}！通过自动买活功能消耗了{3}绑钻和{4}钻石，保证了您的挂机收益！'),(186,411,1,1,'称号移除通知'),(187,411,2,1,'亲爱的玩家，您的称号《{1}》因为被玩家替代等原因被系统移除了，请您据悉！'),(201,132,1,1,'被击败通知'),(202,132,2,1,'您在野外被<color@5>[{1}]</color>所击败,自动买活消耗了<color@1>{2}绑钻和{3}钻石</color>，此仇不共戴天，日后遇上定要叫其付出代价！（可在【设置】—【挂机设置】中关闭自动买活）'),(203,150,1,1,'背包空间不足'),(204,150,2,1,'由于您的背包空间不足，无法放入背包的物品以邮件的形式发送给您，请尽快领取附件并整理背包！'),(205,152,1,1,'套装材料返还'),(206,152,2,1,'由于更换装备导致原套装解散，现返还您全部打造材料'),(207,610,1,1,'副本掉落自动拾取'),(208,610,2,1,'您的副本掉落由于背包空间不足，现由邮件发送与您：'),(209,152,1,1,'贵族过期，宝石卸下'),(210,152,2,1,'亲爱的玩家，您的贵族特权已过期，通过贵族特权解锁的宝石孔已重新锁住。由于您背包已满，现通过附件归还您已镶嵌的宝石，请在附件查收。'),(211,280,1,1,'排位赛排名突破奖励'),(212,280,2,1,'恭喜您获得排位赛排名突破奖励，由于您背包空间不足，现邮件发放物品附件！'),(219,402,0,1,'距离下一波怪物突袭还有{1}秒'),(234,281,1,1,'巅峰竞技赛季奖励发放'),(235,281,2,0,'亲爱的{1}玩家，您上赛季达到{2}段位{3}星，现发放赛季奖励如下：'),(238,402,1,1,'连胜奖励'),(239,402,2,1,'会长将本公会的连胜奖励分配给了您，请继续为公会荣耀而战！'),(240,402,1,1,'终结奖励'),(241,402,2,1,'会长将本公会的终结奖励分配给了您，请继续为公会荣耀而战！'),(242,610,1,1,'魂珠副本{1}层奖励'),(243,610,2,1,'尊敬的冒险者，以下是您的魂珠副本每日奖励，您的最高通关层数为{1}层，查收对应奖励！（温馨提示：通关层数越高，奖励越好哦！）'),(244,281,1,0,'巅峰竞技奖励'),(245,402,1,1,'公会争霸奖励'),(246,402,2,1,'由于您的背包已满，故特将您应得的公会争霸战斗奖励奉上，请及时清理背包'),(247,281,2,1,'由于您的背包已满，故特将您应得的挑战奖励奉上，请及时清理背包'),(248,174,1,1,'智慧达人经验'),(249,174,2,1,'亲爱玩家，您在答题结束后，有经验未领取哦！要记得及时领取哦！'),(250,174,1,1,'智慧达人排名奖励'),(251,174,2,1,'亲爱玩家，恭喜您在智慧达人活动中积分排名第<color@0>{1}</color>，这是您的奖励，请查收!'),(252,416,0,1,'装备寻宝'),(253,416,0,1,'传奇寻宝'),(254,416,0,1,'至尊寻宝'),(255,419,1,1,'资源找回奖励'),(256,419,2,1,'由于您的背包已满，故特将您应得的资源找回奖励奉上，请及时清理背包'),(257,402,1,1,'未发放的连胜奖励'),(258,402,2,1,'您的公会之前有未发放的公会争霸连胜奖励，特发此邮件奉上。'),(259,402,1,1,'未发放的终结奖励'),(260,402,2,1,'您的公会之前有未发放的终结奖励，特发此邮件奉上。'),(263,601,1,1,'跨服服战约战通知'),(264,601,2,1,'您已被选为本服的约战人，有资格代表本服去和其他服约战，不要辜负这份荣耀，带着你的盟友去闹个天翻地覆吧！'),(265,601,1,1,'跨服服战入选通知'),(266,601,2,1,'您已成功入选本次跨服服战，服战第一轮于21:00举行，第二轮于21:30举行，请准时入场！'),(267,601,1,1,'跨服服战落选通知'),(268,601,2,1,'由于参赛名额有限，您遗憾落选本届服战，请继续努力伸战，期待下次服战有你的身影！'),(269,601,1,1,'跨服服战战斗奖励'),(270,601,2,1,'基于您在跨服服战中骁勇的表现，帝国特颁发如下奖励，以资鼓励'),(271,601,1,1,'跨服服战赛季奖励'),(272,601,2,1,'您所在的服务器在本赛季服战中威名远播，作为服内的的一份子，特颁发赛季奖励以资鼓励'),(273,240,1,1,'投票中断返还'),(274,240,0,1,'由于队伍投票的中断，现返还您投票时的消耗'),(275,500,1,1,'天使护送失败奖励'),(276,500,2,1,'亲爱的玩家，您的本次护送由于超时导致失败，请查收护送奖励。'),(277,500,1,1,'护送拦截奖励'),(278,500,2,1,'亲爱的玩家，恭喜您成功完成了第<color@0>{1}</color>次护送拦截，这是您的奖励，请注意查收哦。<color@3>（天使护送每天共可获得{2}次拦截奖励，当前剩余<color@0>{3}</color>次）</color>'),(279,225,1,1,'{1}冲榜奖励'),(280,225,2,1,'恭喜你在<color@3>{1}</color>冲榜活动中获得第<color@0>{2}</color>名，这是您的奖励！'),(281,225,1,1,'冲榜目标奖励'),(282,225,2,1,'冲榜目标奖励'),(283,0,0,1,'{1}月{2}日'),(284,610,1,1,'魂珠副本{1}层扫荡奖励'),(285,610,2,1,'您未主动扫荡的魂珠副本第{1}层奖励，特在此将奖励补发给您，下次记得去扫荡哦！'),(286,224,1,1,'魅力榜奖励'),(287,224,2,1,'恭喜您在本次魅力榜活动中获得第<color@0>{1}</color>名，这是您的奖励！'),(288,224,1,1,'婚礼榜奖励'),(289,224,2,1,'恭喜您在本次婚礼榜活动中获得第<color@0>{1}</color>名，这是您的奖励！'),(290,159,1,1,'每日累充{1}钻石礼包'),(291,159,2,1,'亲爱的友友，您{1}有一份每日累充{2}钻石的礼包忘记领取了，请查收！'),(292,159,1,1,'累计{1}天充值{2}钻石奖励'),(293,159,2,1,'亲爱的友友，您有一份累计{1}天充值{2}钻石的奖励忘记领取了，请查收！'),(294,280,1,1,'排位赛排名奖励'),(295,280,2,1,'恭喜您获得排位赛排名奖励，由于您背包空间不足，现邮件发放物品附件！'),(296,280,1,1,'排位赛战斗奖励'),(297,280,2,1,'恭喜您获得排位赛战斗奖励，由于您背包空间不足，现邮件发放物品附件！'),(298,402,1,1,'称号移除通知'),(299,402,2,1,'亲爱的骑士，因为合并服务器的原因重置了公会争霸赛事，您的称号《{1}》被系统移除，请您据悉！'),(302,224,1,1,'跨服魅力榜奖励'),(303,224,2,1,'恭喜您在跨服魅力榜活动中获得第<color@0>{1}</color>名，这是您的奖励！'),(304,416,0,1,'魂珠寻宝'),(308,411,1,1,'称号回收通知'),(309,411,2,1,'亲爱的玩家，您的称号《{1}》因为离婚被系统回收了，请您据悉！'),(310,411,1,1,'称号重复获得通知'),(311,411,2,1,'亲爱的玩家，由于《{1}》称号您已激活，重复获得改称号返回您{2}金币，请查收！'),(400,411,1,1,'永久称号补偿'),(401,411,2,1,'由于您之前已激活永久称号《{1}》,现返还一些激活奖励'),(402,500,1,1,'协助成功奖励'),(403,500,1,1,'护送成功奖励补发'),(404,500,2,1,'您因为离线而未能领取的护送奖励，通过邮件补发了哦！'),(405,500,1,1,'护送超时返还'),(406,500,2,1,'由于您护送飞艇时超时，现通过邮件返还您的失败返还奖励。'),(407,500,1,1,'护送失败补偿'),(408,500,2,1,'很遗憾，在您离线期间，您的飞艇已被击毁。现通过邮件返还您护送失败的补偿。'),(409,500,1,1,'抢夺成功奖励'),(410,500,2,1,'恭喜您抢夺成功，以下是您的抢夺所获得的奖励！'),(411,500,1,1,'协助成功'),(412,500,2,1,'恭喜您协助成功，以下是您协助的奖励。每天最多可以获得{1}次协助奖励哦！'),(1020001,102,1,1,'删档充值返还'),(1020002,102,2,1,'感谢您对我们游戏的支持和喜爱,由于您是我们删档封测元老用户,我们准备了丰厚的返还大礼回馈!\n您在删档测试期间充<color@0>{1}钻石</color>,现给予您<color@0>200%</color>钻石返还,请查收!'),(1020005,102,1,1,'礼包卡兑换成功'),(1020006,102,2,1,'我们非常高兴能为您奉上我们特别准备的游戏大礼包！希望您在我们的游戏中体验快乐，感受激情，挥洒热血！'),(1300006,130,1,1,'称号转换'),(1300007,130,2,1,'亲爱的玩家，您的称号《{1}》由于变性变更为《{2}》，请您据悉'),(1320001,132,1,1,'秘境远征奖励'),(1320002,132,2,1,'亲爱的冒险者，你的背包已经塞不下了，现将剩余的秘境远征奖励通过邮件发放给你，请查收~'),(1370001,137,1,1,'钻石大战参赛资格取消'),(1370002,137,2,1,'亲爱的玩家，很抱歉地通知您，由于在钻石擂台开赛前期，您的战力跌出全战区前4096名，故此丧失比赛资格，现将门票退还给您，期待您日后有机会参赛！'),(1370003,137,1,1,'钻石大战取消'),(1370004,137,2,1,'亲爱的勇士，我们很遗憾的通知您，由于本战区的报名人数未能达到钻石大战的最低要求本次钻石大战被迫取消。祝您游戏愉快！'),(1370005,137,1,1,'钻石大战竞猜'),(1370006,137,2,1,'很遗憾，您在钻石大战竞猜中差了一点运气并没有猜中'),(1370007,137,2,1,'真是好运啊，您在钻石大战竞猜中运气爆棚竞猜成功！获得了绑钻奖励'),(1370008,137,1,1,'钻石大战排名奖励'),(1370009,137,2,1,'亲爱的玩家，您在钻石大战中骁勇善战，势不可挡，成功夺得 跨服战区第{1}名！本宝宝特意奉上排名奖励，敬请查收哦'),(1370010,137,2,1,'亲爱的玩家，您在钻石大战中骁勇善战，势不可挡，成功夺得 跨服传奇151~300级战区第{1}名！本宝宝特意奉上排名奖励，敬请查收哦'),(1370011,137,2,1,'亲爱的玩家，您在钻石大战中骁勇善战，势不可挡，成功夺得 跨服传奇301~400级战区第{1}名！本宝宝特意奉上排名奖励，敬请查收哦'),(1370012,137,2,1,'亲爱的玩家，您在钻石大战中骁勇善战，势不可挡，成功夺得 跨服传奇401级以上战区第{1}名！本宝宝特意奉上排名奖励，敬请查收哦'),(1370013,137,1,1,'钻石大战结果'),(1370014,137,2,1,'您在钻石大战第{1}场中获得胜利，请查收奖励！'),(1370015,137,2,1,'您在钻石大战第{1}场中战败，失败也有奖励哟，请注意查收！'),(1370016,137,1,1,'钻石大战幸运奖励'),(1370017,137,2,1,'恭喜您获得钻石大战的幸运奖励，请注意查收！！'),(1500001,150,1,1,'活动奖励'),(1500002,150,2,1,'亲爱的玩家：因为特殊原因导致无法及时发送奖励，现以通过邮件的形式补发。'),(1520001,152,1,1,'重铸材料返还'),(1520002,152,2,1,'由于更换装备导致重铸上限变化，现返还您变化的提升材料'),(1520005,152,1,1,'宝石卸下'),(1520006,152,2,1,'亲爱的玩家，您的背包空间不足，请清理后领取已卸下的宝石。'),(1540001,154,1,1,'拍卖结算'),(1540002,154,2,1,'亲爱的冒险家：恭喜您，成功获得拍卖物品{1}！'),(1540003,154,1,1,'竞拍失败'),(1540004,154,2,1,'亲爱的冒险家：您参与竞拍物品{1}（{2}）失败，其它人比你出价高，现将资金返还！'),(1540005,154,1,1,'拍卖分红'),(1540006,154,2,0,'亲爱的冒险家：恭喜您，在{1}活动中获得拍卖物品分红!'),(1540007,154,2,1,'亲爱的冒险家：您参与竞拍物品{1}（{2}）失败，其它人比你出价高，竞拍资金已返还到您的背包！'),(1540008,154,1,1,'个人拍卖'),(1540009,154,2,1,'亲爱的冒险家：您的拍卖物{1}（{2}）在本次拍卖中并没人看中，现将您的宝物归还给你，请查收！'),(1540010,154,2,1,'亲爱的冒险家：您的拍卖物{1}在拍卖会中被人购买了，现将您的所得给您，同时扣除了手续费哟！'),(1540011,154,1,1,'归还拍卖物品'),(1590001,159,1,1,'每日礼包'),(1590002,159,2,1,'您购买的每日礼包未手动领取，现将奖励物品通过邮件发送，请查收~'),(1590003,159,0,1,'12元每日礼包'),(1590004,159,1,1,'开服累充补偿'),(1590005,159,2,1,'亲爱的骑士大人，公主阁下决定提高开服累充的奖励力度，经查阅资料确认，可以给您补发以下奖励，敬请查收！'),(1600001,160,1,1,'幻化形象到期'),(1600002,160,2,1,'亲爱的勇士，您的幻化形象于{1}日{2}时{3}分过期了，系统已自动帮你回收了该形象，请悉知'),(1720001,172,1,1,'求婚未成功通知'),(1720002,172,2,1,'亲爱的玩家，很遗憾，对方希望再考虑一下。这是您的求婚费用，请查收！'),(1720003,172,1,1,'求婚超时通知'),(1720004,172,2,1,'亲爱的玩家，很遗憾，您的求婚对象在指定时间内没有做出回复。这是您的求婚费用，请查收！'),(1720005,172,1,1,'婚礼返还通知'),(1720006,172,2,1,'亲爱的玩家，您和{1}的{2}由于游戏更新的原因无法正常完成，现补偿您一张婚礼卡。请查收！'),(1720007,172,1,1,'婚礼未成功通知'),(1720008,172,2,1,'亲爱的玩家，很遗憾，您的伴侣{1}长时间内未回应婚礼请求，这是您的婚礼费用'),(1720009,172,1,1,'婚礼未成功通知'),(1720010,172,2,1,'亲爱的玩家，很遗憾，您的伴侣{1}暂时还不想举办婚礼，这是您的婚礼费用'),(1720011,172,1,1,'婚礼奖励'),(1720012,172,2,1,'亲爱的玩家，恭喜您踏入婚姻的殿堂，开始新的人生旅程！特奉上一份结婚礼物作为对您的祝福，请查收附件！'),(1720013,172,1,1,'离婚失败通知'),(1720014,172,2,1,'亲爱的玩家，很遗憾因为某些特殊原因，您暂时无法离婚，请与游戏管理员联系。'),(1720015,172,1,1,'伴侣专属礼物'),(1720016,172,2,1,'时间在变，容颜在变，只有我对你的情不变，<color@1>{1}</color>给你送上一份<color@3>{2}</color>，真是太甜蜜了！  <color@0><a@showlove>我也要送</a></color>'),(1720017,172,1,1,'婚礼预订失败通知'),(1720018,172,2,1,'亲爱的玩家，很遗憾因为某些特殊原因，您无法预定该场婚礼，这是您消耗的钻石或物品，请查收。'),(1720019,172,1,1,'购买邀请函失败通知'),(1720020,172,2,1,'亲爱的玩家，很遗憾因为某些特殊原因，您无法购买邀请函，这是您消耗的钻石，请查收。'),(1720021,172,1,1,'婚礼气氛值奖励'),(1720022,172,2,1,'亲爱的玩家，这是<color@1>{1}</color>和<color@1>{2}</color>的婚礼气氛值奖励，由于您的背包已满，现通过邮件发放给您，请查收！'),(1720023,172,1,1,'婚礼取消通知'),(1720024,172,2,1,'很抱歉，由于结婚双方未能及时入场，<color@1>{1}</color>和<color@1>{2}</color>的婚礼取消了。祝您游戏愉快！'),(1720025,172,1,1,'平分费用婚礼失败返还'),(1720026,172,2,1,'由于您和{1}的婚礼未如期举行，我们将返还您的花费，请您查收'),(1720027,172,1,1,'背包空间不足'),(1720028,172,2,1,'对不起，您的背包空间不足，答题奖励将以邮件的形式发放'),(1720029,172,1,1,'巡游未成功通知'),(1720030,172,2,1,'亲爱的玩家，很遗憾，您的伴侣{1}长时间内未回应巡游请求，这是您的巡游费用'),(1720031,172,1,1,'巡游未成功通知'),(1720032,172,2,1,'亲爱的玩家，很遗憾，您的伴侣{1}暂时还不想举办巡游，这是您的巡游费用'),(1720033,172,1,1,'巡游取消通知'),(1720034,172,2,1,'很抱歉，由于巡游双方未能及时入场，<color@1>{1}</color>和<color@1>{2}</color>的巡游取消了。祝您游戏愉快！'),(1720035,172,1,1,'巡游返还通知'),(1720036,172,2,1,'亲爱的玩家，由于您和{1}的{2}未成功举行，我们将返还您的花费，请您查收'),(1720037,172,1,1,'平分费用巡游失败返还'),(1720038,172,2,1,'由于您和{1}的巡游未如期举行，我们将返还您的花费，请您查收'),(1720039,172,1,1,'巡游奖励'),(1720040,172,2,1,'亲爱的玩家，恭喜您和{1}完成浪漫的爱意巡游，开始新的人生旅程！特奉上一份结巡游礼物作为对您的祝福，请查收附件！'),(1720041,172,1,1,'巡游预订失败通知'),(1720042,172,2,1,'亲爱的玩家，很遗憾因为某些特殊原因，您无法预定该场巡游，这是您消耗的钻石或物品，请查收。'),(1720043,172,1,1,'巡游返还通知'),(1720044,172,2,1,'亲爱的玩家，您和{1}的{2}由于游戏更新的原因无法正常完成，现补偿您一张巡游卡。请查收！'),(1720045,172,1,1,'巡游掉落奖励'),(1720046,172,2,1,'亲爱的玩家，由于您的背包不足，在巡游过程中击杀怪物的掉落奖励将以邮件的形式发放，请您查收'),(1720047,172,0,1,'新郎'),(1720048,172,0,1,'新娘'),(1720049,172,1,0,'婚礼发糖果奖励'),(1720050,172,2,1,'亲爱的玩家，由于您的背包已满，您在婚礼中发糖果的奖励将以邮件形式发放'),(1720051,172,1,1,'巡游撒花奖励'),(1720052,172,2,1,'亲爱的玩家，由于您的背包已满，您在巡游中撒鲜花的奖励将以邮件形式发放'),(1720053,172,1,1,'婚礼采集奖励'),(1720054,172,2,1,'亲爱的玩家，由于您的背包空间不足，婚礼糖果奖励将以邮件发放'),(1720055,172,2,1,'亲爱的玩家，由于您的背包空间不足，婚礼宴席的奖励将以邮件的形式发放'),(1720056,172,1,1,'巡游采集奖励'),(1720057,172,2,1,'亲爱的玩家，由于您的背包空间不足，巡游过程中采集的奖励将以邮件形式发放'),(1720058,172,1,1,'巡游掉落奖励'),(1720059,172,2,1,'亲爱的玩家，由于您的背包空间不足，您在巡游过程中击杀破坏者的奖励将以邮件形式发放'),(1720060,172,1,1,'婚礼放烟花奖励'),(1720061,172,2,1,'亲爱的玩家，由于您的背包空间不足，您在婚礼中释放烟花的奖励将以邮件的形式发放'),(1720062,172,1,1,'狗粮奖励'),(1720063,172,2,1,'亲爱的玩家，由于您的背包空间不足，狗粮奖励将以邮件的形式发放'),(1720064,172,1,1,'婚礼宾客数量超出'),(1720065,172,2,1,'亲爱的玩家，您和{1}的婚礼可邀请宾客数量已达上限，不可再购买邀请函邀请其余玩家了'),(1720066,172,1,1,'巡游婚车气氛奖励'),(1720067,172,2,1,'亲爱的玩家，由于您的背包空间不足，在本次巡游中累计气氛值达到{1}的奖励将以邮件的形式发放'),(1720068,172,1,1,'巡游放烟花奖励'),(1720069,172,2,1,'亲爱的玩家，由于您的背包空间不足，您在巡游中释放烟花的奖励将以邮件的形式发放'),(1720070,172,1,1,'婚礼祝福奖励'),(1720071,172,2,1,'亲爱的玩家，您和{1}的婚礼气氛值在结束时达到{2}，爱神丘比特特为你们送上祝福的奖励'),(1720072,172,1,1,'巡游祝福奖励'),(1720073,172,2,1,'亲爱的玩家，您和{1}的巡游气氛值在结束时达到{2}，爱神丘比特特为你们送上祝福的奖励'),(1720074,172,1,1,'巡游结束阶段奖励'),(1720075,172,2,1,'亲爱的玩家，您和{1}的巡游即将结束，爱神丘比特将为你们送上祝福，请您查收'),(1720076,172,1,1,'婚礼邀请'),(1720077,172,2,1,'{1}和{2}的婚礼将于{3}年{4}月{5}日{6}:{7}开启，特别邀请你来参与哦，记得要来哦！'),(1720078,172,1,1,'婚礼改期通知'),(1720079,172,2,1,'{1}和{2}的婚礼将改期于{3}年{4}月{5}日{6}:{7}开启，特别邀请你来参与哦，记得要来哦！'),(1720080,172,1,1,'婚礼邀请'),(1720081,172,2,1,'{1}和{2}的婚礼新人已经同意你来参加婚礼哟，赶快来凑热闹吧！'),(1720082,172,1,1,'婚姻宝盒激活通知'),(1720083,172,2,1,'您的伴侣<color@1>{1}</color>已为您购买了<color@2>婚姻宝盒</color>。您可以在婚姻宝盒界面每天领取日常奖励，时限为：<color@2>30日</color>（即日起开始计算）'),(1720084,172,2,1,'您已为您的伴侣<color@1>{1}</color>购买了<color@2>婚姻宝盒</color>，您可以在婚姻宝盒界面内领取购买立得奖励，并且您的伴侣也可以领取宝盒日常奖励，时限为：<color@2>30日</color>（即日起开始计算）'),(1770001,177,1,1,'钓鱼收获'),(1770002,177,2,1,'您的背包已满，您捕获的鱼已通过邮件向你发放，请你注意查收'),(1810001,181,1,1,'背包已满'),(1810002,181,2,1,'您的背包已满，魂珠寻宝进度奖励将以邮件形式发放，请查收'),(1820001,182,1,1,'功能预告奖励发放邮件'),(1820002,182,2,1,'由于您领取功能预告开发奖励时背包空间不足，现通过邮件发放，敬请查收！'),(2210001,221,1,1,'魅力周榜奖励'),(2210002,221,2,1,'亲爱的玩家，您在<color@3>排行榜—魅力周榜</color>中的名次达到<color@0>{1}</color>名，这是您的奖励，请查收！'),(2210003,221,1,1,'魅力女榜奖励'),(2210004,221,2,1,'亲爱的玩家，您在<color@3>排行榜—魅力女榜</color>中的名次达到<color@0>{1}</color>名，这是您的奖励，请查收！'),(2210005,221,1,1,'魅力周榜奖励'),(2210006,221,2,1,'亲爱的玩家，<color@1>{1}</color>魅力周榜中拿下第<color@0>1</color>名，这是其所属公会成员的奖励，请查收！'),(2210007,221,1,1,'排行榜点赞奖励'),(2210008,221,2,1,'由于您的背包空间不足，您的排行榜点赞奖励将以邮件形式发放'),(2250001,225,2,1,'各位冒险者你们好，本次的开服冲榜-{1}榜已经圆满结束啦。\n在本次冲榜活动中，冒险者大人实力超群，在榜单上留下了自己名字。现在王国委员会将冲榜奖励通过邮件发放给你~\n\n以下是本次开服冲榜-{1}榜的排名：\n第1名：{2}\n第2~3名：{3}\n第4~10名：{4}\n第11~30名：{5}\n第31~50名：{6}\n各位的冒险者实在是66哒~'),(2250002,225,0,1,'空缺'),(2260001,226,1,1,'排行榜点赞奖励'),(2260002,226,2,1,'由于您的背包空间不足，您的排行榜点赞奖励将以邮件形式发放'),(2800001,280,0,1,'守关人'),(2800002,280,1,1,'竞技场挑战成功'),(2800003,280,2,1,'恭喜您在竞技场挑战成功，由于您背包空间不足，现将{1}绑钻奖励发放在邮件附件！'),(2800004,280,1,1,'竞技场排名下降'),(2800005,280,2,1,'您的竞技场排名从<color@{1}>[{1}]</color>名降至<color@{1}>[{2}]</color>名，挑战者是<color@{1}>[{3}]</color>！！！'),(2800006,280,2,1,'您的竞技场排名已经被 <color@{1}>[{1}]</color> 占据。'),(2810001,281,1,1,'巅峰竞技排名奖励'),(2810002,281,2,1,'亲爱的玩家，您在上赛季巅峰竞技达到{1}段位，排行第{2}名，现发放赛季排名奖励如下：'),(2810003,281,1,0,'跨服巅峰竞技排名奖励'),(2810004,281,2,1,'亲爱的玩家，您在上赛季跨服巅峰竞技达到{1}段位，排行第{2}名，现发放赛季排名奖励如下：'),(3310001,331,0,1,'{1}{2}服的{3}'),(3310002,331,1,1,'幸运云购开奖通知'),(3310003,331,1,1,'幸运云购中奖通知'),(3310004,331,2,1,'本期幸运云购的中奖者是{1}， 恭喜您获得幸运女神的眷顾拿下大奖，爆棚的运气真是羡煞旁人！'),(3310005,331,2,1,'本期幸运云购的中奖者是{1}， 很遗憾您没有中奖，请再接再厉，也许下一位幸运之子就是您！'),(3310006,331,1,1,'砸蛋累计奖励'),(3310007,331,2,1,'亲您有一份砸蛋快递未领取，请点击查收，下次请记得哦'),(3310008,331,1,1,'砸蛋奖励'),(3310009,331,1,1,'{1}活动奖励'),(3310010,331,2,1,'由于您的背包空间不足，现将{1}活动的奖励以邮件方式发送给您。'),(3310011,331,2,1,'您获得{1}的奖励如下：'),(3310012,331,1,1,'情定三世，完美恋人！'),(3310013,331,2,1,'你与<color@1>{1}</color>的爱情感动天地，特在此奖励你们俩<color@3>“三世恋人”称号</color>，在上苍的见证下继续幸福吧！'),(3310014,331,1,1,'BOSS首杀奖励'),(3310015,331,2,1,'您的{1}首杀奖励忘记领取啦，请在附件查收。'),(3310016,331,1,1,'狂欢活动奖励送还'),(3310017,331,2,1,'你在狂欢活动中积极活跃的身姿成功引起了我的注意，但你浪完之后竟然忘记领取你的狂欢奖励，我只好派我的私家信使把它们给你送回来了，别再忘记领奖了，我的私家信使可不会每次都为你服务'),(3310018,331,1,1,'{1}全服礼包'),(3310019,331,0,1,'全服提交<a@goods@{1}></a>数量达到<color@0>{2}</color>，触发全服礼包，请在附件中查收奖励。'),(3310020,331,1,1,'充值榜奖励'),(3310021,331,2,1,'恭喜您在充值榜活动中获得<color@0>{1}</color>名，这是您的奖励！'),(3310022,331,1,1,'0元豪礼'),(3310023,331,2,1,'亲爱的骑士，您有一份钻石豪礼未领取，现通过邮件发放，请查收。'),(3310024,331,2,1,'亲爱的骑士，由于您排行榜活动参与奖励没有及时领取，现通过邮件将这部分奖励发送给您，敬请查收。'),(3310025,331,1,1,'跨服云购购买失败'),(3310026,331,2,1,'亲爱的骑士，由于抢购的人数过多，您在跨服云购抢购的商品失败，现将本次抢购消耗的道具返还给您。'),(3310027,331,1,1,'消费榜奖励'),(3310028,331,2,1,'恭喜您在消费榜活动中获得<color@0>{1}</color>名，这是您的奖励！'),(3310030,331,1,1,'许愿神树奖励'),(3310031,331,2,1,'亲爱的玩家，由于您的背包已满，现将您在许愿神树中获得的奖励通过邮件发送给您，请查收！'),(3310034,331,1,1,'跨服云购中奖通知'),(3310035,331,2,1,'恭喜您的跨服云购中幸运得获得了{1}，领取附件即可获得，幸运女神在护佑着你~'),(3310036,331,1,1,'合服提前结算跨服云购活动'),(3310037,331,2,1,'亲爱的玩家，因合服原因提前结算跨服云购活动的奖励，请您查收。'),(3310038,331,1,1,'累积在线奖励'),(3310039,331,2,1,'亲爱的玩家，由于您部分累积在线的奖励没有及时领取，现通过邮件将这部分奖励发送给您，敬请查收。'),(3310040,331,2,1,'亲爱的冒险者，本次的幸运云购没有达到开奖进度，因此本服没有玩家获得幸运女神的奖励。'),(3310041,331,1,1,'超级扭蛋奖励'),(3310042,331,2,1,'亲爱的骑士，由于您的背包已满，现将您在超级扭蛋中获得的奖励通过邮件发送给您，请查收！'),(3310043,331,1,1,'充值领奖奖励'),(3310044,331,2,1,'亲爱的骑士，由于您的背包已满，现将您在充值领奖中获得的奖励通过邮件发送给您，请查收！'),(3310045,331,1,1,'充值转盘奖励'),(3310046,331,2,1,'亲爱的骑士，由于您的背包已满，现将您在充值转盘中获得的奖励通过邮件发送给您，请查收！'),(3310047,331,1,1,'{1}未领奖励'),(3310048,331,2,1,'亲爱的玩家，由于您{1}的奖励没有及时领取，现通过邮件将这部分奖励发送给您，敬请查收。'),(3310049,331,1,1,'{1}购买失败'),(3310050,331,2,1,'亲爱的玩家，由于抢购的人数过多，您在{1}抢购的商品失败，现将本次抢购消耗的道具返还给您'),(3310051,331,1,1,'许愿神树累计奖励'),(3310052,331,2,1,'亲爱的玩家，由于您在许愿神树的累计奖励没有及时领取，现通过邮件将奖励发送给您，请查收！'),(3380001,338,1,1,'限时冲榜排行奖励'),(3380002,338,1,1,'限时冲榜排行奖励'),(3380003,338,1,1,'限时冲榜排行奖励'),(3380031,338,2,1,'亲爱的勇士：恭喜您在限时冲榜活动中获得第{1}名,以下为您奉上排行奖励，请查收~'),(3380032,338,2,1,'亲爱的勇士：恭喜您在限时冲榜活动中获得第{1}名,以下为您奉上排行奖励，请查收~'),(3380033,338,2,1,'亲爱的勇士：恭喜您在限时冲榜活动中获得第{1}名,以下为您奉上排行奖励，请查收'),(4000001,400,1,1,'职位变动'),(4000002,400,2,1,'最新消息，您在公会的职位变成了{1}，祝您游戏愉快。'),(4000003,400,0,1,'亲爱的战友们：\n1、保持充足的离线挂机时间，升级不停息！\n2、经验宝库和守卫公会可获得海量经验奖励，不要忘记参加！\n3、在公会仓库捐献装备可与战友们轻松互通有无！\n4、时刻关注首领怪物的刷新情况，顶级装备不可错过！\n5、开服第2、4天以及之后的每周六会开启公会争霸，让我们一起争夺全服第一！'),(4000004,400,0,1,'公会管家'),(4000005,400,1,1,'最新公会公告'),(4000006,400,1,1,'欢迎加入公会家庭'),(4000007,400,2,1,'欢迎来到{1}这个大家庭，今后的日子大家一同为公会的未来奋斗吧！'),(4000008,400,1,1,'公会职位任命通知'),(4000009,400,2,1,'您已被帝国公会管理处任命为公会{1}的会长，希望你能带领所有成员共创公会辉煌'),(4000010,400,2,1,'{1}将公会{2}的会长之职转让于你希望你能带领所有成员共创公会辉煌'),(4000011,400,1,1,'公会升级了'),(4000012,400,2,1,'可喜可贺！在公会所有成员的努力下，公会已经达到{1}级！公会成员上限达到{2}个，解锁公会技能{3}！'),(4000013,400,1,1,'您被踢出公会了'),(4000014,400,2,1,'很抱歉，您被踢出公会了，您的公会技能依旧保留现有等级，祝您早日找到更好的归属！'),(4000015,400,1,1,'公会解散了'),(4000016,400,2,1,'很抱歉，由于公会活所有成员均离线超过48小时，被帝国公会管理处强制解散了，祝您早日找到更好的归属！'),(4000017,400,2,1,'很抱歉，由于公会人数少于5人，被帝国公会管理处强制解散了，祝您早日找到更好的归属！'),(4000018,400,1,1,'公会改名通知'),(4000019,400,0,1,'您的公会已经改名为{1}'),(4000020,400,1,1,'公会公告修改'),(4000021,400,2,1,'很抱歉，因本公会的公告内容不符合相关规定，已被帝国公会管理处强制修改，请勿发布违规内容，祝您游戏愉快'),(4000022,400,2,1,'很抱歉，由于本公会涉嫌进行违规行为，被帝国公会管理处强制解散了，祝您早日找到更好的归属！'),(4000023,400,1,1,'解散公会'),(4000024,400,2,1,'对不起，由于您的公会成员人数只有1人，为了您可以有更好的体验，系统将于24小时后强制解散公会，请尽快招募成员！'),(4000025,400,1,1,'取消解散公会'),(4000026,400,2,1,'您好，鉴于您的公会成员人数已大于1人，系统将取消强制解散公会操作，对您造成的不变，我们深表歉意！'),(4000027,400,2,1,'很抱歉，因本公会的名字不符合相关规定，已被帝国公会管理处强制修改，请勿起违规名称，和谐游戏'),(4000028,400,2,1,'对不起，由于您的公会成员人数小于等于1人，为了您可以有更好的体验，会长已解散公会，对您造成的不便，我们深表歉意！'),(4020001,402,0,1,'红方'),(4020002,402,0,1,'黄方'),(4020003,402,0,1,'蓝方'),(4020004,402,0,1,'边防守卫'),(4020005,402,0,1,'内殿守卫'),(4020006,402,0,1,'基地守护'),(4020007,402,1,1,'公会守卫召唤BOSS奖励'),(4020008,402,2,1,'您在公会守卫活动中慷慨解囊，成功召唤出了BOSS，获得了召唤BOSS的奖励，敬请查收！'),(4020009,402,1,1,'公会争霸全员奖励'),(4020010,402,2,1,'勇敢的冒险家，您所属的公会在本届公会争霸{1}赛区中获得{2}名，将向参与全员发放一份奖励，请您查收'),(4020011,402,0,1,'S赛区'),(4020012,402,0,1,'A赛区'),(4020013,402,0,1,'B赛区'),(4020014,402,0,1,'C赛区'),(4020015,402,1,1,'公会争霸称号奖励'),(4020016,402,2,1,'您的公会在本次公会争霸S赛区中获得{1}名，所有成员可获得<color@1>{2}</color>限时称号，请您查收'),(4020017,402,2,1,'您的公会在本次公会争霸S赛区中获得{1}名，您作为会长将获得<color@1>{2}</color>限时称号，称号已激活，请在称号界面进行查看'),(4020018,402,1,1,'公会争霸轮空奖励'),(4020019,402,2,1,'尊敬的公会成员，在本次公会争霸赛中，贵公会在{1}赛区轮空，将为您发放轮空奖励，请您查收'),(4020020,402,0,1,'第一名为'),(4020021,402,0,1,'，第二名为'),(4020022,402,0,1,'，第三名为'),(4020023,402,1,1,'公会守卫击杀boss奖励'),(4020024,402,2,1,'参与击杀召唤boss，请领取以下奖励！！'),(4110001,411,1,1,'永久称号没返还时候的邮件标题'),(4110002,411,2,1,'由于您之前已激活永久称号《{1}》,但是策划没有配置返还，所以没东西给你'),(4140001,414,1,1,'呜海遗珠累积采集{1}次奖励'),(4140002,414,2,1,'恭喜您在呜海遗珠中达成了累积采集{1}次奖励，请查收！'),(4170001,417,1,1,'回归充值返利'),(4170002,417,2,1,'尊敬的冒险者：\\n欢迎您再次参与本次游戏不删档测试，作为已经参与过游戏删档付费测试的老朋友，与您相约的充值返利在此为您奉上啦，敬请查收！'),(4170003,417,1,1,'在线奖励'),(4170004,417,2,1,'亲爱的冒险家，你的背包满了，现在我们将在线奖励通过邮件发送给你，请及时查收。'),(4270001,427,0,0,'暂无'),(4290001,429,1,1,'捕蝶活动排名奖励'),(4290002,429,2,1,'恭喜您在捕蝶活动中达到<color@{1}>{1}</color>的高分，甩开了大批玩家，获得了第<color@{1}>{2}</color>名。蝴蝶仙子将为你送上以下奖励。希望您再接再厉，再取高分哦!'),(4290003,429,1,1,'捕蝶活动积分奖励'),(4290004,429,2,1,'由于您的背包不足，捕蝶活动第{1}阶段积分奖励将以邮件的形式发放'),(4290005,429,1,1,'背包已满'),(4290006,429,2,1,'您的背包已满，获得的转盘奖励将以邮件方式发放，请您查收'),(4310001,431,1,1,'送你点东西'),(4310002,431,2,1,'送点星痕'),(4310003,431,1,1,'星痕合成'),(4310004,431,2,1,'背包满了，合成的东西邮件给你'),(4310005,431,1,1,'星痕分解'),(4310006,431,2,1,'背包满了，你就不知道清一清吗！'),(4340001,434,1,1,'家园扩建'),(4340002,434,2,1,'家园扩建,系统自动帮你回收以下家具：{1}'),(4340003,434,1,1,'伴侣关系解除'),(4340004,434,2,1,'由于您的伴侣关系已被解除（分手或离婚）,系统自动帮您回收以下家具（回收家具默认放回家具背包中）：{1}'),(4340005,434,1,1,'伴侣使用家具'),(4340006,434,2,1,'你的伴侣使用了你的家具{1}进行了房屋装饰'),(4340007,434,1,1,'规格组合奖励'),(4340008,434,2,1,'这是您和伴侣之间的房屋组合奖励，请查收！'),(4340009,434,1,1,'房屋共享'),(4340010,434,2,1,'您和伴侣之间共享房屋,系统自动帮你回收以下家具：{1}'),(4340011,434,2,1,'您原本的家园规格为{1}，伴侣原本的的家园规格为{2}，共享房屋后，将会以高规格的{3}作为共享家园，房屋的规格和繁荣度是共享的！！'),(4340012,434,2,1,'伴侣关系解除时不在线，房屋降级为单身房屋，赠送家具如下！请及时领取'),(4360001,436,1,1,'星灵争霸参赛资格取消'),(4360002,436,2,1,'亲爱的玩家，很抱歉地通知您，由于在星灵争霸开赛前期，您的战力跌出全战区前4096名，故此丧失比赛资格，期待您日后有机会参赛！'),(4360003,436,1,0,'星灵争霸取消'),(4360004,436,2,1,'亲爱的勇士，我们很遗憾的通知您，由于本战区的报名人数未能达到星灵争霸的最低要求，本次星灵争霸被迫取消。祝您游戏愉快！'),(4360005,436,1,1,'星灵争霸竞猜'),(4360006,436,2,1,'很遗憾，您在星灵争霸竞猜中差了一点运气并没有猜中'),(4360007,436,2,1,'真是好运啊，您在星灵争霸竞猜中运气爆棚竞猜成功！获得了绑钻奖励'),(4360008,436,1,1,'星灵争霸排名奖励'),(4360009,436,2,1,'亲爱的玩家，您在星灵争霸中骁勇善战，势不可挡，成功夺得 跨服传奇1~150级战区 第{1}名！本宝宝特意奉上排名奖励，敬请查收哦'),(4360010,436,2,0,'亲爱的玩家，您在星灵争霸中骁勇善战，势不可挡，成功夺得 跨服传奇151~300级战区 第{1}名！本宝宝特意奉上排名奖励，敬请查收哦'),(4360011,436,2,1,'亲爱的玩家，您在星灵争霸中骁勇善战，势不可挡，成功夺得 跨服传奇301~400级战区 第{1}名！本宝宝特意奉上排名奖励，敬请查收哦'),(4360012,436,2,1,'亲爱的玩家，您在星灵争霸中骁勇善战，势不可挡，成功夺得 跨服传奇401级以上战区 第{1}名！本宝宝特意奉上排名奖励，敬请查收哦'),(4360013,436,1,1,'星灵争霸结果'),(4360014,436,2,0,'您在星灵争霸第{1}场中获得胜利，请查找奖励！'),(4360015,436,2,1,'您在星灵争霸第{1}场中战败，失败也有奖励哟，请注意查找！'),(4500001,450,1,1,'VIP调整补偿'),(4500002,450,2,1,'为了达到更好的游戏体验，给予玩家更多权益，我们对vip进行了调整，以下为根据调整为您发放的永久白银v1，差额经验也已为您加上，请查收！'),(4500003,450,1,1,'至尊VIP体验过期'),(4500004,450,2,1,'您的至尊VIP体验已结束！升级为永久至尊贵族，可终生享受6大特权，每日领取豪华礼包哦！'),(4600001,460,1,0,'原罪祭坛参与击杀奖'),(4600002,460,2,1,'尊敬的勇者，您在保卫世界，击杀{1}领主的战斗中，伤害排名第{2}名，我们为你装备了丰厚的奖励，请收下'),(4600003,460,1,1,'世界首领参与击杀奖'),(4600004,460,1,1,'首领会所参与击杀奖'),(4610001,461,1,1,'跨服首领参与击杀奖'),(4610002,461,2,1,'尊敬的勇者，您在保卫世界，击杀{1}领主的战斗中，伤害排名第{2}名，我们为你装备了丰厚的奖励，请收下'),(4610003,461,1,1,'跨服首领奖励补发'),(4610004,461,2,1,'尊敬的勇者，您在保卫世界，击杀{1}领主的战斗中，获得了掉落归属，由于您的背包已满，现通过邮件补发给您。'),(6040001,604,1,1,'星钻联赛参赛资格取消'),(6040002,604,2,1,'亲爱的勇者，我们很遗憾的通知您，在星钻联赛报名结束时，您的战力不小心跌出了跨服前512名，丧失了参赛资格，现将门票退还给您，期待您的下次参与'),(6040003,604,1,1,'星钻联赛取消'),(6040004,604,2,1,'亲爱的勇士，我们很遗憾的通知您，由于本届的报名人数未能达到星钻联赛的最低要求，联赛被迫取消，现将门票退还给您。祝您游戏愉快！'),(6040005,604,1,1,'“星钻联赛”淘汰奖励'),(6040006,604,2,1,'您在【{1}】因未入场而被淘汰，特将奖励发放给你，下次千万不要擅自离场啊！'),(6040007,604,1,1,'“星钻联赛”竞猜奖励发放'),(6040008,604,2,1,'我们的工作人员在打扫场地的时候发现了您在“星钻联赛”中斩获但未带走的竞猜奖励，将其送回，大侠下次记得领取奖励'),(6040009,604,1,1,'三英会战目标奖励'),(6040010,604,2,1,'您的背包已满，故特将三英会战目标奖励发送给您，请查收！'),(6040011,604,1,1,'三英会战排名奖励'),(6040012,604,2,1,'恭喜您在三英会战中获得第{1}名，以下是您的奖励！'),(6040013,604,1,1,'三英会战竞技排名奖励'),(6040014,604,2,1,'恭喜您在三英会战带领团队获胜并且在己方阵营中排名第{1}名，以下是您的奖励！'),(6040015,604,2,1,'恭喜您在三英会战中个人积分在己方阵营排名第{1}名，以下是您的奖励！'),(6040016,604,1,1,'三英会战团队获胜奖励'),(6040017,604,2,1,'恭喜您，在三英会战中带领团队获得胜利，以下是您的团队获胜奖励！'),(6050001,605,1,1,'荣耀战神目标奖励'),(6050002,605,2,1,'您本次参加荣耀战神达到伤害目标特此发放以下奖励！'),(6060001,606,1,1,'丛林突围目标奖励'),(6060002,606,2,1,'您的背包已满，故特将丛林突围目标奖励发送给您，请查收！'),(6060003,606,1,1,'丛林突围宝箱奖励'),(6060004,606,2,1,'您的背包已满，故特将丛林突围宝箱奖励发送给您，请查收！'),(6060005,606,1,1,'丛林突围排名奖励'),(6060006,606,2,1,'恭喜您在丛林突围中获得第{1}名，以下是您的奖励！'),(6070001,607,1,1,'跨服海战勇士奖励'),(6070002,607,2,1,'~(≧3≦)ﾉ⌒☆，尊敬的勇士，您在跨服海战中乘风破浪，最终击杀了{1}个敌人，排名第{2}，您的英勇让人敬佩，请收下我为您准备的礼物'),(6070003,607,1,1,'跨服海战英灵奖励'),(6070004,607,2,1,'o(╯□╰)o，您在本届跨服海战中发挥失常，成为牺牲次数最多的勇者。您的屡败屡战让人敬佩，请收下我为您准备的礼物'),(6070005,607,1,1,'取消宣战'),(6070006,607,2,1,'尊敬的勇士，您所在的公会取消了对领地{1}的宣战，参与应援的会员将返还给您80%的费用，请查收'),(6070007,607,1,0,'宣战失败'),(6070008,607,2,1,'尊敬的勇士，您所在的公会没有宣战到领地{1}的进攻权，参与应援的会员将返还给您80%的费用，请查收'),(6070009,607,1,1,'公会宣战'),(6070010,607,2,1,'尊敬的勇士，您的公会宣战了{1}领地。您可以前在世界服-跨服海战-应援界面进行应援哦'),(6090001,609,1,1,'限时BOSS奖励'),(6090002,609,2,1,'恭喜您，参与击杀s{1}.{2},个人伤害排行第{3}名，您所在服务器伤害排行第{4}名,现将奖励发放，请查收！'),(6090003,609,1,1,'限时BOSS服务器奖励'),(6090004,609,2,1,'恭喜您，您所在服务器限时BOSS活动期间伤害排行第{1}名,现将奖励发放，请查收！'),(6090005,609,1,1,'跨服入侵阶段奖励'),(6090006,609,2,1,'恭喜您，今日积分达到{1},获得如下阶段奖励，请查收！'),(6090007,609,1,1,'跨服入侵排行奖励'),(6090008,609,2,1,'恭喜您，您所在服务器今日积分排行第{1}名,现将奖励发放，请查收！'),(6090010,609,2,1,'跨服入侵目标奖励'),(6090011,609,2,1,'恭喜您，完成跨服入侵目标{1}，由于您背包空间不足，现邮件发放给您，请查收！'),(6090012,609,1,1,'跨服入侵boss伤害奖励'),(6090013,609,2,1,'恭喜您，参与击杀限时boss，获得伤害奖励，剩余伤害奖励次数{1}，现将奖励发放，请查收！'),(6100001,610,2,1,'亲爱的骑士：您在{1}获得以下物品尚未拾取，暂时以邮件形式保存！'),(6105600,120,0,0,'感受冰雪的力量吧！'),(6105601,610,0,1,'出现吧，冰雪的护卫！'),(6105602,610,0,1,'想伤害女王，先从我身上踏过！'),(6210001,621,1,1,'跨服1VN资格赛排名'),(6210002,621,2,1,'恭喜您在本届跨服1VN{1}战场资格赛中获得第{2}名，我们将奉上排名奖励'),(6210003,621,1,1,'跨服1VN守擂赛排名'),(6210004,621,2,1,'恭喜您在本届跨服1VN{1}战场守擂赛中获得第{2}名，我们将奉上排名奖励'),(6210005,621,1,1,'跨服1VN守擂赛胜负'),(6210006,621,2,1,'恭喜您在本届跨服1VN{1}战场守擂赛第{2}轮中获得了胜利，我们将奉上胜利奖励，请再接再厉'),(6210007,621,2,1,'很遗憾，您在本届跨服1VN{1}战场守擂赛第{2}轮中未能取得胜利，但不要气馁，还有机会，我们将为您打气'),(6210008,621,1,1,'跨服1VN竞猜奖励'),(6210009,621,2,1,'恭喜您在本届跨服1VN{1}战场守擂赛第{2}轮中竞猜成功，我们将奉上竞猜奖励'),(6210010,621,2,1,'很遗憾，您在本届跨服1VN{1}战场守擂赛第{2}轮中竞猜失败'),(6210011,621,1,1,'跨服1VN竞品发放'),(6210012,621,2,1,'尊敬的玩家，您好，您在本届本届跨服1VN活动中以{1}的价格竞拍成功，获得{2}，请您继续关注我们的活动'),(6210013,621,0,1,'360-1000等级'),(6210014,621,0,1,'传奇201—传奇500等级'),(6210015,621,1,1,'跨服1VN活动开启'),(6210016,621,2,1,'尊敬的玩家，实在抱歉，由于本届跨服1VN报名人数不足，本次活动暂不开启，对您造成的不便，我们深表歉意'),(6210017,621,1,1,'跨服1VN赛区变动'),(6210018,621,2,1,'尊敬的玩家，实在抱歉，由于本届跨服1VN报名人数略有欠缺，将把{1}赛区和{2}赛区合并进行竞技，活动开启时间不变'),(6210019,621,1,1,'跨服1VN竞拍结果'),(6210020,621,2,1,'尊敬的玩家：您参与竞拍物品{1}失败，其他人比您出价高，现将竞拍资金返还'),(6210021,621,1,1,'跨服1VN竞拍'),(6210022,621,2,1,'尊敬的玩家，恭喜您所在的服务器玩家{1}成功竞拍{2}，特送来全服奖励，记得注意查收哟'),(6210023,621,2,1,'您在跨服1VN竞拍中的竞价被他人超过，快去加价反超吧！'),(6210024,621,1,1,'跨服1VN守擂赛全胜奖励'),(6210025,621,2,1,'恭喜您在本届跨服1VN{1}战场守擂赛上获得全胜，我们将为您奉上额外的奖励，请您查收'),(6500001,650,1,1,'跨服3V3赛季奖励'),(6500002,650,2,1,'恭喜您在跨服3V3赛季排行中获得第<color@0>{1}</color>名，请在附件中查收奖励。'),(6500003,650,1,1,'跨服3V3结算奖励'),(6500004,650,2,1,'您在3V3比赛结算时不在线，您的队伍在这局比赛中<color@0>胜利</color>了，请在附件中查收奖励。'),(6500005,650,1,1,'跨服3V3结算奖励'),(6500006,650,2,1,'您在3V3比赛结算时不在线，您的队伍在这局比赛中<color@4>失败</color>了，请在附件中查收奖励。'),(6500008,650,2,1,'您在的3V3比赛场次不足20场，无法获得赛季奖励'),(31010020,120,0,1,'哈！活着的傻瓜，乖乖当我的午餐吧'),(31010021,120,0,1,'仆人们，来我身边！'),(31010022,120,0,1,'让你们看看在极寒中存活的我有多强！'),(31010023,120,0,1,'雪爪顺劈！'),(31010024,120,0,1,'啊~新鲜的燃料~！'),(31010025,120,0,1,'让火焰吞噬你！'),(31010026,120,0,1,'我的利刃饥渴难耐！'),(31010027,120,0,1,'看来今天又可以举行一场盛大的祭典了！'),(31010028,120,0,1,'仆人们，协助我完成祭典吧！'),(31010029,120,0,1,'滚出我的森林！'),(31010030,120,0,1,'感受森林的怒火！'),(31070020,120,0,1,'在这冰天雪地中，只有保持怒火才能战胜严寒！'),(31070021,120,0,1,'我的怒火无法平息！'),(31080020,120,0,1,'让火焰净化一切！'),(31080021,120,0,1,'死吧，虫子！'),(31090020,120,0,1,'肉饼才是最美味的食物！'),(31090021,120,0,1,'碾碎你们！'),(51510001,120,0,1,'我要<color=\'#ff8a3c\'>糖</color>，我要吃<color=\'#ff8a3c\'>糖</color>！！！'),(51510002,120,0,1,'给我<color=\'#ff8a3c\'>饼干</color>我就溜！！！'),(51510003,120,0,1,'有<color=\'#ff8a3c\'>香蕉</color>就什么都好说！！！'),(51510004,120,0,1,'我们的感情，<color=\'#ff8a3c\'>天长地久</color>！'),(51510005,120,0,1,'执子之手，<color=\'#ff8a3c\'>相濡以沫</color>！'),(51510006,120,0,1,'只想与你<color=\'#ff8a3c\'>如胶似漆</color>！'),(51510007,120,0,1,'小哥哥，小姐姐，你们只有<color=\'#ff8a3c\'>其中一个人</color>能够对我造成伤害喔！');
/*!40000 ALTER TABLE `base_language` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_language_extra`
--

DROP TABLE IF EXISTS `base_language_extra`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_language_extra` (
  `module_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '模块id',
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `subtype` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '子类型',
  `tip` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '附加提示',
  `content` text NOT NULL COMMENT '内容@lang@',
  `example` varchar(1000) NOT NULL DEFAULT '' COMMENT '例子',
  `desc` varchar(1000) NOT NULL DEFAULT '' COMMENT '描述',
  PRIMARY KEY (`module_id`,`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='语言额外配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_language_extra`
--

LOCK TABLES `base_language_extra` WRITE;
/*!40000 ALTER TABLE `base_language_extra` DISABLE KEYS */;
INSERT INTO `base_language_extra` VALUES (0,2,2,10,1,'获得 <a@goods5@{1}></a> x {2}','获得物品名字x数量',''),(0,3,3,0,0,'链接跨服中心成功！','',''),(0,4,3,10,0,'<color@0>链接跨服中心成功！</color>','',''),(0,5,3,10,0,'<color@4>与跨服中心断开链接！</color>','',''),(130,1,1,1,0,'玩家<color@3>{1}</color>改名为<color@0><a@player@{2}@{3}></a></color>','',''),(130,2,1,10,0,'<color@0>{1}</color>完成<color@2>{2}转</color>试炼，如愿转生成为<color@3>{3}</color>，让我们一起仰慕他！','xx（玩家）完成xx转试炼，如愿转生成为xx（新职业名称），让我们一起仰慕他！','xx（玩家）完成xx转试炼，如愿转生成为xx（新职业名称），让我们一起仰慕他！'),(137,1,1,10,0,'各位勇者，钻石大战已经开启！海量钻石等你来拿！不论胜负，拿到手软！老铁，嗨起来！<color@1><a@drumwar>查看活动</a></color>','各位勇者，钻石大战已经开启！海量钻石等你来拿！不论胜负，拿到手软！老铁，嗨起来！查看活动','各位勇者，钻石大战已经开启！海量钻石等你来拿！不论胜负，拿到手软！老铁，嗨起来！查看活动'),(137,2,1,10,0,'号外号外！钻石大战海选赛第<color@1>{1}</color>场已经结束了,总共<color@1>{2}</color>人晋级，共获<color@3>{3}</color>钻石！','海选赛第M场已经结束了,总共N人晋级，共获N钻石！','海选赛第M场已经结束了,总共N人晋级，共获N钻石！'),(137,3,1,10,0,'号外号外！钻石大战跨服战区的登顶战结束啦，冠军是人见人爱，花见花开的<color@1>{1}</color>','100~370级战区的钻石战冠军是XX','100~370级战区的钻石战冠军是XX'),(137,4,1,10,0,'各位勇者，钻石大战将于5分钟后开启！一大波钻石即将来袭，请各位做好准备，还没报名的速速报名啦！<color@1><a@drumwar>查看活动</a></color>','各位勇者，钻石大战将于5分钟后开启！一大波钻石即将来袭，请各位做好准备，还没报名的速速报名啦！查看活动','各位勇者，钻石大战将于5分钟后开启！一大波钻石即将来袭，请各位做好准备，还没报名的速速报名啦！查看活动'),(137,5,1,10,0,'号外号外！钻石大战传奇151~300级战区的登顶战结束啦，冠军是人见人爱，花见花开的<color@1>{1}</color>','传奇1~传奇100级战区的钻石战冠军是XX','传奇1~传奇100级战区的钻石战冠军是XX'),(137,6,1,10,0,'号外号外！钻石大战传奇301~400级战区的登顶战结束啦，冠军是人见人爱，花见花开的<color@1>{1}</color>','传奇101~传奇200级战区的钻石战冠军是XX','传奇101~传奇200级战区的钻石战冠军是XX'),(137,7,1,10,0,'号外号外！钻石大战传奇401~500级战区的登顶战结束啦，冠军是人见人爱，花见花开的<color@1>{1}</color>','传奇201~传奇300级战区的钻石战冠军是XX','传奇201~传奇300级战区的钻石战冠军是XX'),(137,8,1,10,0,'各位尊敬的勇士，由于人数不足，本次钻石大战活动取消！','各位尊敬的勇士，由于人数不足，本次钻石大战活动取消！','各位尊敬的勇士，由于人数不足，本次钻石大战活动取消！'),(140,1,3,10,0,'{1}接受了你的好友申请','玩家接受了你的好友申请','同意好友申请'),(140,2,3,10,0,'{1}拒绝了你的好友申请','玩家拒绝了你的好友申请','拒绝好友申请'),(150,1,1,10,0,'<color@1><a@player@{1}@{2}></a></color>参与击杀<color@2>{3}</color>的过程中，意外获得<a@goods3@{4}@{5}@{6}></a>，幸运女神果然眷顾欧洲人啊！','','【弃用】怪物掉落传闻'),(150,2,1,5,0,'<color@1><a@player@{1}@{2}></a></color>参与击杀<color@2>{3}</color>的过程中，意外获得<a@goods3@{4}@{5}@{6}></a>，幸运女神果然眷顾欧洲人啊！','','【弃用】怪物掉落传闻'),(150,5,1,10,0,'<color@3>{1}</color>打开<a@goods2@{2}></a>获得<a@goods3@{3}@{4}@{5}></a>。','[玩家名]打开[宝箱名字]获得[道具名]。',''),(150,6,1,10,1,'你捡到了一个好装备','',''),(150,7,1,10,0,'<color@1><a@player@{1}@{2}></a></color>成功合成了<a@goods3@{3}@{4}@{5}></a>，战力暴增！','玩家名成功合成了道具名，战力暴增！','合成道具传闻'),(150,8,1,10,0,'<color@1><a@player@{1}@{2}></a></color>成功合成了<color@4>{3}</color>阶<color@4>{4}</color>星装备<a@goods3@{5}@{6}@{7}></a>，实力大增！','玩家名成功合成了几阶几星装备，实力大增！','合成装备传闻'),(150,9,3,10,0,'亲，物品{1}过期了，已被系统回收！','',''),(150,10,1,10,0,'<color@1><a@player@{1}@{2}></a></color>参与击杀<color@2>{3}</color>的过程中，意外获得<a@goods3@{4}@{5}@{6}></a>，幸运女神果然眷顾欧洲人啊！','',''),(150,11,1,10,0,'<color@1><a@player@{1}@{2}></a></color>参与击杀<color@2>{3}</color>的过程中，意外获得<color@3>{4}</color>阶<color@3>{5}</color>星装备<a@goods3@{6}@{7}@{8}></a>，幸运女神果然眷顾欧洲人啊！','',''),(150,12,1,10,0,'<color@1><a@player@{1}@{2}></a></color>竟然用3件装备合成了<color@4>{3}</color>阶<color@4>{4}</color>星装备<a@goods3@{5}@{6}@{7}></a>，这果然是个看脸的游戏！','XXX竟然用3件装备合成了N阶N星装备名字，这果然是个看脸的游戏！',''),(150,13,1,10,0,'<color@1><a@player@{1}@{2}></a></color>有钱任性，竟然用<color@4>3</color>件装备进行合成，结果一不小心就翻车，合成失败~','XXX有钱任性，竟然用3件装备进行合成，结果果断翻车，合成失败~',''),(151,1,3,0,0,'购买成功！剩余交易次数：{1}','购买成功！剩余交易次数：5','购买成功！剩余交易次数：5'),(152,1,1,10,0,'<color@1><a@player@{1}@{2}></a></color>通过洗练获得了一条<color@{3}>{4}</color>极品属性，获得成吨战力！','玩家名通过洗练获得了一条红色极品属性，获得成吨战力！','玩家名通过洗练获得了一条红色极品属性，获得成吨战力！'),(152,2,1,10,0,'<color@1><a@player@{1}@{2}></a></color>将一件装备上的所有洗练属性洗到<color@2>紫色</color>以上品质，神挡杀神！','玩家名将一件装备上的所有洗练属性洗到紫色以上品质，神挡杀神！','玩家名将一件装备上的所有洗练属性洗到紫色以上品质，神挡杀神！'),(152,3,1,10,0,'<color@1><a@player@{1}@{2}></a></color>成功将<a@goods4@{3}@{4}@{5}></a>强化到<color@4>{6}</color>级，战力突飞猛进！','玩家成功将装备名字强化到多少级，获得战力突飞猛进！','玩家成功将装备名字强化到多少级，获得战力突飞猛进！'),(152,4,1,10,0,'<color@1><a@player@{1}@{2}></a></color>成功将<a@goods4@{3}@{4}@{5}></a>激活了<color@3><{7}件></color><color@4>{6}套装</color>，获得了成吨的战力','',''),(152,5,1,10,0,'<color@1><a@player@{1}@{2}></a></color>将<a@goods4@{3}@{4}@{5}></a>觉醒至<color@4>{6}</color>级，战力突飞猛进！','玩家将装备名字觉醒至多少级，获得战力突飞猛进！','玩家将装备名字觉醒至多少级，获得战力突飞猛进！'),(152,6,1,10,0,'<color@1><a@player@{1}@{2}></a></color>为<a@goods4@{3}@{4}@{5}></a>附加了<color@0><{6}级></color><color@4>【{7}】</color>，实力愈发强大！','玩家为装备名字附加了XX级的技能名字，实力愈发强大！','玩家为装备名字附加了XX级的技能名字，实力愈发强大！'),(153,1,1,10,0,'恭喜<color@1>{1}</color>获得了<color@2>经验馆主</color>的青睐,获得<color@3>经验提升50%</color>,还能<color@3>{2}自动拾取</color>,挂机必备啊!','恭喜玩家获得了经验馆主的青睐,获得经验提升50%,还能自动拾取,居家挂机必备啊!','商城够买经验馆主传闻'),(153,2,1,10,0,'恭喜<color@1>{1}</color>获得了<color@3>白羊馆主</color>的加护,<color@3>吸收大量伤害</color>,打怪战斗好帮手!','恭喜玩家获得了白羊天使的加护,抵御大量伤害,打怪战斗好帮手!','商城购买白羊天使传闻'),(154,1,2,4,0,'本轮<color@1>{1}</color>活动的拍卖会将在{2}分钟后开始，即将拍卖的物品有：{3}','',''),(154,2,2,4,0,'本轮<color@1>{1}</color>活动的拍卖会开始啦，大佬们快来竞拍买买买！','',''),(154,3,1,10,0,'新一轮世界拍卖会将在{1}分钟后开始，即将拍卖的物品有：{2}','',''),(154,4,1,10,0,'新一轮世界拍卖会开始了，大佬们快来竞拍买买买！','',''),(154,5,2,4,0,'本公会在<color@1>{1}</color>活动中没有获得拍卖物，希望各位冒险家再接再厉！','',''),(155,1,1,10,0,'<color@1>{1}</color>队伍豪取<color@2>{2}</color>连胜','xxx队伍搭上高速列车，豪取x连胜',''),(155,2,1,10,0,'<color@1>{1}</color>队伍被<color@6>{2}</color>队伍终结<color@2>{3}</color>连胜','XXX队伍遇见流星雨，被XXX队伍终结x连胜',''),(155,3,1,10,0,'夺旗战场开始啦！叫上小伙伴来一局！','夺旗战场开始啦！叫上小伙伴来一局！','夺旗战场开始啦！叫上小伙伴来一局！'),(155,4,3,5,0,'队伍发起夺旗战场报名投票','队伍发起夺旗战场报名投票','队伍发起夺旗战场报名投票'),(155,5,1,10,0,'余晖落日，战旗飞扬，战场结束的号角声响起了','余晖落日，战旗飞扬，战场结束的号角声响起了','余晖落日，战旗飞扬，战场结束的号角声响起了'),(158,1,1,10,1,'恭喜<color@0><a@player@{1}@{2}></a></color>成功领取首充礼包，获得<a@goods3@{3}@{4}@{5}></a><a@firstrecharge><color@0><我要首充></color></a>','首充加个传闻，：恭喜[玩家名称]成功领取首充礼包，获得传说武器[武器名称]','首充加个传闻，：恭喜[玩家名称]成功领取首充礼包，获得传说武器[武器名称]'),(159,1,2,10,0,'成功领取钻石大礼: {1}','成功领取钻石大礼xxx',''),(160,1,1,10,1,'<color@2><color@2>{1}</color></color>成功将坐骑提升至<color@2>{2}</color>阶，实力大增！','玩家名成功将坐骑提升至X阶，实力大增！','玩家名成功将坐骑提升至X阶，实力大增！'),(160,2,1,10,0,'<color@2><color@2>{1}</color></color>成功将<color@2>{2}</color>提升至<color@2>{3}</color>阶，实力大增！','玩家名成功将“外观名称”提升至X阶，实力大增！','玩家名成功将“外观名称”提升至X阶，实力大增！'),(160,3,1,10,0,'恭喜<color@1>{1}</color>成功激活坐骑幻化形象·<color@2>{2}</color>，又帅又厉害！','恭喜<color@2>玩家名字</color>成功激活坐骑幻化形象·<color@2>坐骑幻化名字（旋翼飞空艇）</color>，又帅又厉害！',''),(161,1,1,10,1,'幸运之神再次降临，<color@1>{1}</color>成功合成翅膀<a@goods5@{2}></a>,战力飙升蹭蹭蹭！<color@1><a@wing>前往合成</a></color>','幸运之神再次降临，XXX成功合成翅膀XXX,战力飙升蹭蹭蹭！前往合成','幸运之神再次降临，XXX成功合成翅膀XXX,战力飙升蹭蹭蹭！前往合成'),(165,1,1,10,1,'<color@2>{1}</color>成功将吃货羊提升至<color@2>{2}</color>阶，实力大增！','玩家名成功将精灵提升至X阶，实力大增！','玩家名成功将精灵提升至X阶，实力大增！'),(165,2,1,10,1,'<color@2>{1}</color>成功将吃货羊提升至<color@1>{2}</color>级，战斗力爆表！','玩家名成功将精灵提升至X级，战斗力爆表！','玩家名成功将精灵提升至X级，战斗力爆表！'),(165,3,1,10,1,'<color@2>{1}</color>成功将“<color@2>{2}</color>”提升至<color@2>{3}</color>阶，实力大增！','玩家名成功将“外观名称”提升至X阶，实力大增！','玩家名成功将“外观名称”提升至X阶，实力大增！'),(166,1,1,10,0,'<color@1>{1}</color>成功将爵位晋升至<color@{2}>{3}</color>，实力大增！','玩家名字成功将爵位晋升至【公爵】，实力大增！','爵位进阶传闻'),(168,1,1,10,1,'<color@2>{1}</color>成功将圣物提升至<color@2>{2}</color>级，获得了成吨的战斗力！','玩家名成功将圣物提升至X级，获得了成吨的战斗力！','玩家名成功将圣物提升至X级，获得了成吨的战斗力！'),(169,1,1,10,1,'<color@2>{1}</color>成功将神兵提升至<color@2>{2}</color>级，获得了成吨的战斗力！','玩家名成功将神兵提升至X级，获得了成吨的战斗力！','玩家名成功将神兵提升至X级，获得了成吨的战斗力！'),(172,1,1,1,0,'赠人玫瑰，手留余香，我不在乎天长地久，只求能送玫瑰九十九！','','求送花默认传闻'),(172,2,1,1,0,'愿得一人心，白手不相离，点个关注，你我就会有故事！','','求关注默认传闻'),(172,3,1,1,0,'<color@1><a@player@{1}@{2}></a></color>:{3}  <color@0><a@flower@{4}>送Ta鲜花</a></color>','','求送花传闻（玩家输入）'),(172,4,1,1,0,'<color@1><a@player@{1}@{2}></a></color>:{3}  <color@0><a@focus@{4}>关注Ta</a></color>','','求关注传闻（玩家输入）'),(172,5,1,1,0,'爱情就是要勇敢表达，恭喜<color@1><a@player@{1}@{2}></a></color>向<color@1><a@player@{3}@{4}></a></color>告白成功，甜蜜牵手！','','表白成功世界传闻'),(172,6,1,1,0,'执子之手，与子偕老，<color@1><a@player@{1}@{2}></a></color>与<color@1><a@player@{3}@{4}></a></color>在今天喜结良缘！恭祝两位新人恩爱美满！百年好合！','','求婚成功世界传闻'),(172,7,1,1,0,'与你在一起，每日如这巧克力般甜蜜，<color@1><a@player@{1}@{2}></a></color>亲手喂<color@1><a@player@{3}@{4}></a></color>吃<color@3>浓情巧克力</color>，好浪漫哦！<color@0><a@dogfood@{5}@{6}@{7}>领取狗粮</a></color>','','伴侣礼物1传闻'),(172,8,1,1,0,'相遇相守，你是我最深的爱恋！<color@1><a@player@{1}@{2}></a></color>温柔地给<color@1><a@player@{3}@{4}></a></color>围上<color@3>暖心围脖</color>，一万点暴击啊！<color@0><a@dogfood@{5}@{6}@{7}>领取狗粮</a></color>','','伴侣礼物2传闻'),(172,9,1,1,0,'我负责赚钱养家，你负责貌美如花，<color@1><a@player@{1}@{2}></a></color>向<color@1><a@player@{3}@{4}></a></color>送上一套<color@3>蜜意香水</color>，真是羡煞旁人！<color@0><a@dogfood@{5}@{6}@{7}>领取狗粮</a></color>','','伴侣礼物3传闻'),(172,10,1,1,0,'<color@1><a@player@{1}@{2}></a></color>与<color@1><a@player@{3}@{4}></a></color>的<color@{5}>{6}</color>正式开始了，让我们一起祝福两位新人幸福美满！','','婚礼开始传闻'),(172,11,1,3,0,'一大波小捣蛋在婚礼四处捣乱，大家可选择<color@0>正确的礼物</color>哄好小捣蛋，安抚小捣蛋能获得<color@0>道具奖励</color>和<color@0>气氛值</color>哦！','','捣蛋鬼刷出传闻'),(172,12,2,3,0,'礼花飘香，独留芬芳，<color@1><a@player@{1}@{2}></a></color>点燃了<color@3>{3}</color>！现场弥漫在幸福的氛围！婚礼气氛值增加<color@0>{4}</color>','','放烟花传闻'),(172,13,2,3,0,'<color@1><a@player@{1}@{2}></a></color>正在为出席婚礼的贵宾们分发<color@3>{3}</color>！婚礼气氛值增加<color@0>{4}</color>','','撒喜糖传闻'),(172,14,1,3,0,'为了感谢来宾们的到来，婚礼主人为各位准备了丰盛的宴席，请尽情享用！','','婚礼第三阶段开始传闻'),(172,15,1,3,0,'现场玩家热情不减，反响热烈，婚礼气氛值突破<color@0>{1}</color>点！感谢热情的各位！','','气氛值达成传闻'),(172,16,1,3,0,'婚礼即将在<color@0>30</color>秒后进入<color@0>婚礼活跃</color>阶段，答对骚气的题目就可以获得奖励哦','','活跃阶段预告'),(172,17,1,3,0,'婚礼即将在<color@0>30</color>秒后进入<color@0>婚礼仪式</color>阶段，让我们一起祝福两位新人吧！','','婚礼进第二阶段前提示传闻'),(172,18,1,3,0,'<color@0>婚礼宴席</color>将在<color@0>30</color>秒后准备完成，大家准备好敞开肚子，大快朵颐吧！','','婚礼进第三阶段前提示传闻'),(172,19,1,1,0,'千里有缘一线牵，<color@0>{1}</color>发布了一条征友信息，大家快去看看吧！<color@1><a@befriend>点击查看</a></color>','千里有缘一线牵，XXX发布了一条征友信息，大家快去看看吧！点击查看','千里有缘一线牵，XXX发布了一条征友信息，大家快去看看吧！点击查看'),(172,20,1,1,0,'<color@1><a@player@{1}@{2}></a></color>与<color@1><a@player@{3}@{4}></a></color>的<color@{5}>{6}</color>正式开始了，让我们一起祝福两位新人幸福美满！','','巡游开启传闻'),(172,21,2,3,0,'礼花飘香，独留芬芳，<color@1><a@player@{1}@{2}></a></color>点燃了<color@3>{3}</color>！现场弥漫在幸福的氛围！巡游气氛值增加<color@0>{4}</color>','','放烟花传闻'),(172,22,1,3,0,'<color@1><a@player@{1}@{2}></a></color>正在巡游婚车附近分发<color@3>{3}</color>！巡游气氛值增加<color@0>{4}</color>','','撒喜糖传闻'),(172,23,1,3,0,'<color@1><a@player@{1}@{2}></a></color>与<color@1><a@player@{3}@{4}></a></color>的爱意巡游进入福利阶段，巡游婚车周围将刷出大量宝箱','','刷宝箱传闻'),(172,33,2,10,0,'我干了<color@1>{1}</color>和<color@1>{2}</color>的狗粮，默默地收下了<color@2>{3}X{4}</color>','我干了玩家名字和玩家名字的狗粮，默默地收下了道具名称、道具名称',''),(172,34,1,1,0,'<color@0>{1}</color>为TA的伴侣<color@0>{2}</color>激活了<color@1>婚姻宝盒</color>，每天可以领取大量宝盒奖励哦！还在等什么，快为你的TA也来一个吧<color@1><a@lovebox>点击查看</a></color>','',''),(174,1,1,10,1,'<color@1>{1}</color>才智过人，成为本次智慧达人活动的<color@3>智慧之星</color>!','','答题活动结算传闻'),(174,2,2,10,1,'<color@1>智慧达人</color>活动开始啦，大家快去展现自己的聪明才智吧！','','中午答题活动开始'),(174,3,2,10,0,'<color@1>智慧达人</color>活动即将在<color@0>5</color>分钟后开始！','',''),(178,1,1,10,0,'<color@1>{1}</color>成功将自己的吃货羊提升至<color@2>{2}</color>级，吃吃吃，不吃怎么能变强！','{玩家名}成功将自己的吃货羊提升至{N}级，吃吃吃，不吃怎么能变强！','装备吞噬传闻'),(179,1,1,1,0,'恭喜<color@1>{1}</color>成功激活宝宝坐骑幻化形象·<color@2>{2}</color>，又帅又厉害！','恭喜<color@2>玩家名字</color>成功激活宝宝坐骑幻化形象·<color@2>坐骑幻化名字（旋翼飞空艇）</color>，又帅又厉害！',''),(179,2,1,10,0,'<color@2><color@2>{1}</color></color>成功将宝宝提升至<color@2>{2}</color>阶，实力大增！','玩家名成功将宝宝提升至X阶，实力大增！',''),(179,3,1,10,0,'<color@2><color@2>{1}</color></color>成功将<color@2>宝宝坐骑·{2}</color>提升至<color@2>{3}</color>阶，实力大增！','玩家名成功将宝宝坐骑·\"坐骑名称\"提升至X阶，实力大增！',''),(179,4,1,1,0,'恭喜<color@1>{1}</color>成功激活宝宝时装外形·<color@2>{2}</color>，又帅又厉害！','恭喜<color@2>玩家名字</color>成功激活宝宝时装外形·<color@2>时装幻化名字</color>，又帅又厉害！',''),(210,1,2,10,0,'<color@1><a@player@{1}@{2}></a></color>通关{3}级<color@3>{4}</color>,掌握了<a@skill@{5}></a>','渣渣辉通关85级勇者试炼Ⅰ，掌握了行如疾风，移动速度增加20%','[玩家名称]通关[副本等级][副本名称]，掌握了[技能名称]，[技能描述]'),(215,1,2,4,0,'<color@1>{1}</color>正在进行<color@1>{2}（{3}等级）</color>,一起加入队伍吧！<color@1><a@multidungeon@{4}@{5}>加入队伍</a></color>','##正在进行装备副本（240级难度）,一起加入队伍吧！<a@multidungeon@{4}@{5}>加入队伍</a>','##正在进行装备副本（240级难度）,一起加入队伍吧！<a@multidungeon@{4}@{5}>加入队伍</a>'),(215,2,2,11,0,'<color@1>{1}</color>正在进行<color@1>{2}（{3}等级）</color>,一起加入队伍吧！<color@1><a@multidungeon@{4}@{5}>加入队伍</a></color>','##正在进行装备副本（240级难度）,一起加入队伍吧！<a@multidungeon@{4}@{5}>加入队伍</a>','##正在进行装备副本（240级难度）,一起加入队伍吧！<a@multidungeon@{4}@{5}>加入队伍</a>'),(215,3,2,5,0,'<color@0>{1}</color>加入了队伍','#玩家名#加入了队伍','#玩家名#加入了队伍'),(215,4,2,5,0,'<color@0>{1}</color>退出了队伍','#玩家名#退出了队伍','#玩家名#退出了队伍'),(221,1,1,10,0,'恭喜<color@1>{1}</color>在<color@3>排行榜—{2}</color>中荣登榜首，获得<color@3>{3}</color>称号！','恭喜玩家名字在战力榜中荣登榜首，获得最强王者称号！','排行榜个人榜单结算传闻'),(221,2,1,10,0,'恭喜<color@1>{1}</color>公会荣登<color@3>排行榜—公会榜</color>榜首，全体成员获得<color@3>地表最强</color>称号！','恭喜公会名字公会荣登公会榜榜首，全体成员获得地表最强称号！','排行榜公会榜结算传闻'),(222,1,2,4,0,'恭喜{1}将头衔晋升到<color@{2}>「{3}」</color>，公会实力愈加强大了！','恭喜xx将头衔晋升到xx，家族实力愈加强大了',''),(223,1,2,10,1,'花香+{1}，与[{2}]亲密度+{3}，[{4}]鲜花数+{5}','花香+xxx，与[玩家名]亲密度+xxx，[玩家名]鲜花数+xxx','花香+xxx，与[玩家名]亲密度+xxx，[玩家名]鲜花数+xxx'),(223,2,2,10,1,'[{1}]鲜花数-{2}','【玩家名】鲜花数-xxx','【玩家名】鲜花数-xxx'),(223,4,2,10,1,'[{1}]玩家向你赠送了[{2}]，鲜花数+{3}','【XXX】玩家向你赠送了【XXX】，鲜花数+XX','【XXX】玩家向你赠送了【XXX】，鲜花数+XX'),(223,5,2,10,1,'[{1}]玩家向你砸了[{2}]，鲜花数-{3}','【XXX】玩家向你砸了【XXX】，鲜花数-XX','【XXX】玩家向你砸了【XXX】，鲜花数-XX'),(223,6,1,10,1,'礼轻情义重，<color@2>{2}</color>向<color@2>{1}</color>赠送了<color@1>{3}</color>,真让人羡慕啊！','玩家名收到玩家名赠送的道具名，真幸福啊！','玩家名收到玩家名赠送的道具名，真幸福啊！'),(223,7,1,10,1,'<color@2>{1}</color>收到神秘人赠送的<color@2>{2}</color>，真幸福啊！','玩家名收到神秘人赠送的道具名，真幸福啊！','玩家名收到神秘人赠送的道具名，真幸福啊！'),(223,8,3,0,0,'赠送成功，名誉值增加{1}点！','赠送成功，双方魅力值增加5点！','赠送鲜花礼物'),(223,9,3,0,0,'赠送成功，名誉值增加{1}点，双方亲密度增加{2}点！','赠送成功，双方魅力值增加5点，双方亲密度增加5点！','赠送鲜花礼物'),(223,15,2,10,0,'{1}向您砸了{2}，您的魅力值减少{3}点','玩家向您砸了一枚鸡蛋，您的魅力值减少1点','砸蛋操作'),(223,16,2,10,0,'{1}向您砸了{2}，您的魅力值减少{3}点','玩家向您砸了一筐鸡蛋，您的魅力值减少100点','砸蛋操作'),(224,1,1,10,0,'恭喜<color@1>{1}</color>夺下魅力榜男榜的第一名，<color@3>风流倜傥</color>，实至名归！','','魅力榜男榜结算传闻'),(224,2,1,10,0,'恭喜<color@1>{1}</color>夺下魅力榜女榜的第一名，<color@3>倾国倾城</color>，闭月羞花！','','魅力榜女榜结算传闻'),(225,1,1,10,0,'<color@1>{1}</color>在<color@3>{2}</color>中表现出色，夺下第一名，获得<color@4>强力红装</color>和丰厚奖励！','玩家名字在战力比拼中表现出色，夺下第一名，获得丰厚奖励！','开服冲榜结算传闻'),(226,1,1,10,0,'恭喜<color@1>S{1}·{2}</color>在<color@3>排行榜—{3}</color>中荣登榜首，获得<color@3>{4}</color>称号！','恭喜S1·玩家名字在战力榜中荣登榜首，获得最强王者称号！','排行榜个人榜单结算传闻'),(240,1,2,5,1,'{1}食用了一块神秘烤肉，当前队伍篝火经验加成比例为 {2}%','',''),(240,2,2,5,1,'当前队伍篝火经验加成比例为 {1}%','',''),(240,3,3,5,0,'<color@0>{1}</color>拒绝参加','XXX玩家拒绝参加',''),(240,4,2,5,0,'<color@0>{1}</color>加入了队伍','玩家名加入了队伍',''),(240,5,2,5,0,'<color@0>{1}</color>退出了队伍','玩家名退出了队伍',''),(240,6,2,5,0,'<color@0>{1}</color>被请出了队伍','玩家名被请出了队伍',''),(240,7,2,5,0,'更改目标：<color@0>{1}</color>','更改目标：XXX','更改目标：XXX'),(280,1,1,10,0,'<color@1>{1}</color>成功击败<color@1>{2}</color>，夺得排位赛第<color@3>{3}</color>名的宝座','玩家名字1成功击败玩家名字2，夺得排位赛第1名的宝座','排位赛挑战前10成功传闻'),(281,1,1,10,1,'战鼓已响，谁能问鼎巅峰竞技！！！','','巅峰竞技开始'),(281,2,1,10,1,'战鼓息，来日再战巅峰竞技！！！','','巅峰竞技结束'),(281,3,1,10,0,'巅峰竞技将于{1}分钟后开启，请各位勇士做好准备！','',''),(281,4,1,10,0,'跨服排位战将于{1}分钟后开启，请各位勇士做好准备！','',''),(281,5,1,10,0,'<color@1>{1}</color>已经达到{2}连胜，大杀特杀了！','',''),(281,6,1,10,0,'<color@1>{1}</color>已经达到{2}连胜，无人能挡了！','',''),(281,7,1,10,0,'<color@1>{1}</color>已经达到{2}连胜，超越神了！','',''),(281,8,1,10,0,'<color@1>{1}</color>大杀四方，达到<color@2>白银</color>段位！','',''),(281,9,1,10,0,'<color@1>{1}</color>连战连胜，达到<color@2>黄金</color>段位！','',''),(281,10,1,10,0,'<color@1>{1}</color>无人能挡，达到<color@2>铂金</color>段位！','',''),(281,11,1,10,0,'<color@1>{1}</color>望尘莫及，达到<color@2>钻石</color>段位！','',''),(281,12,1,10,0,'<color@1>{1}</color>独占鳌头，达到<color@2>王者</color>段位！','',''),(281,13,1,10,0,'战鼓已响，谁能问鼎跨服巅峰竞技！！！','',''),(281,14,1,10,0,'战鼓息，来日再跨服战巅峰竞技！！！','',''),(331,1,1,10,0,'霹雳啪啦哐当一声巨响，<color@0>{1}</color>人品爆表，居然砸出了<color@{2}><a@goods@{3}></a>x{4}</color>！','霹雳啪啦哐当一声巨响，玩家名字六字人品爆表，居然砸出了xx！我也要砸蛋！','霹雳啪啦哐当一声巨响，玩家名字六字人品爆表，居然砸出了xx！我也要砸蛋！'),(331,2,1,10,0,'震惊！<color@0>{1}</color>臂力过人，竟然在砸蛋活动中砸出了<color@{2}><a@goods@{3}></a>x{4}</color>！','震惊！玩家名字六字臂力过人，竟然在砸蛋活动中砸出了xx，我也要砸蛋！','震惊！玩家名字六字臂力过人，竟然在砸蛋活动中砸出了xx，我也要砸蛋！'),(331,3,1,0,0,'很可惜，今天幸运女神没有带来礼物，本日的幸运云购奖励丢失~','很可惜，今天幸运女神没有带来礼物，本日的幸运云购奖励丢失~','很可惜，今天幸运女神没有带来礼物，本日的幸运云购奖励丢失~'),(331,4,1,0,0,'<color@0>{1}</color>获得幸运女神的眷顾，喜中大奖羡煞旁人～～～','xx获得幸运女神的眷顾，喜中大奖羡煞旁人～～～','Oh_My_God，xx获得幸运女神的眷顾，喜中大奖羡煞旁人～～～'),(331,5,1,10,1,'<color@1>【{1}】</color>活动已开启，快去野外场景击杀BOSS，<color@4>稀有翅膀</color>和<color@4>珍贵戒指</color>等你来拿！','活动Boss开启传闻','活动Boss开启传闻'),(331,6,1,10,1,'<color@1>【{1}】</color>活动暂时结束，请大家关注下一次活动开启时间！','活动Boss结束传闻','活动Boss结束传闻'),(331,7,1,10,1,'<color@1><a@player@{1}@{2}></a></color>在<color@0>{3}</color>给予<color@4>{4}</color>最后一击，目前一共还剩<color@4>{5}只</color>BOSS！','活动Boss击杀传闻','活动Boss击杀传闻'),(331,8,1,10,1,'<color@1><a@player@{1}@{2}></a></color>在<color@0>{3}</color>拾取了<color@4>{4}</color>掉落的<a@goods3@{5}@{6}@{7}></a>，真是羡煞众人！','活动Boss拾取传闻','活动Boss拾取传闻'),(331,9,1,10,1,'恭喜<color@3>{1}</color>在<color@1>{2}</color>拿下<color@4>{3}</color>首杀','Boss首杀传闻','Boss首杀传闻'),(331,10,1,10,0,'<color@1><a@player@{1}@{2}></a></color>人品爆发，在幸运鉴宝活动中鉴定出<color@{3}><a@goods@{4}></a>x{5}</color>！<color@0><a@lucky_acc>我要鉴宝</a></color>','','幸运鉴宝中大奖传闻'),(331,11,1,10,0,'<a@goods1@{1}></a>全服提交数量达到<color@0>{2}</color>，<color@3>经验双倍</color>开启啦，打怪获得的经验将增加<color@0>100%</color>。','[物品名称]全服提交数量达到1000，经验双倍开启啦，打怪获得的经验将增加100%。','心动值达到1000，经验双倍开启啦，打怪获得的经验将增加100%。'),(331,12,1,10,0,'<a@goods1@{1}></a>全服提交数量达到<color@0>{2}</color>，<color@3>掉落双倍</color>开启啦，藏宝洞窟、精灵秘境掉落将<color@0>翻倍</color>。<color@0><a@elf_area>立即前往</a></color>','[物品名称]全服提交数量达到1000，副本双倍开启啦，藏宝洞窟、精灵秘境掉落将翻倍。','心动值达到1000，副本双倍开启啦，藏宝洞窟、精灵秘境掉落将翻倍。立即前往'),(331,13,1,10,0,'<a@goods1@{1}></a>全服提交数量达到<color@0>{2}</color>，触发<color@3>首领重置</color>，所有的本服首领已刷新，勇士们赶快前往挑战吧！。','[物品名称]全服提交数量达到1000，经验双倍开启啦，打怪获得的经验将增加100%。','心动值达到1000，触发首领重置，所有的本服首领已刷新，勇士们赶快前往挑战吧！'),(331,14,1,10,0,'<a@goods1@{1}></a>全服提交数量达到<color@0>{2}</color>，触发<color@3>全服礼包</color>，快前往领取吧！<color@0><a@mail>立即前往</a></color>','[物品名称]全服提交数量达到1000，触发全服礼包，快前往领取吧！立即前往','心动值达到1000，触发全服奖励，快前往领取吧！立即前往'),(331,15,1,10,0,'<color@2><a@player@{1}@{2}></a></color>成功获得<color@4>{3}</color>，将<color@3>{4}</color>揽入怀中！更多钻石等你免费来拿！','xx（玩家名称）成功获得0元豪礼，将xx（档次名字）揽入怀中！更多钻石等你免费来拿！','xx（玩家名称）成功获得0元豪礼，将xx（档次名字）揽入怀中！更多钻石等你免费来拿！'),(331,16,1,10,0,'恭喜S{1}.<color@1>{2}</color>人品爆发在周一祈愿抽中{3}获得{4}','','恭喜sXXXX.XXXX人品爆发在周一祈愿抽中X等奖：XXXX'),(331,17,1,10,0,'<color@3>{1}</color>人品爆发，在超级扭蛋活动中获得<color@{2}>{3}</color>*<color@0>{4}</color>！<color@0><a@capsule_toys>立即前往</a></color>','[角色名]人品爆发，在超级扭蛋活动中获得[道具名称]！立即前往','[角色名]人品爆发，在超级扭蛋活动中获得[道具名称]！立即前往'),(331,18,1,0,0,'<color@1><a@player@{1}@{2}></a></color>人品爆发，在{3}活动中获得<color@2><a@goods@{4}></a>x{5}</color>！<color@0><a@repeat_recharge_turntable>立即前往</a></color>','',''),(331,19,1,0,0,'<color@1>S{1}.<a@player@{2}@{3}></a></color>人品爆发，在{4}活动中获得<color@2><a@goods@{5}></a>x{6}</color>！','','跨服云购购买传闻'),(331,20,1,0,0,'跨服云购活动<color@1>【{1}】</color>已开启','','跨服云购开启传闻'),(331,21,1,0,0,'跨服云购活动<color@1>【{1}】</color>已开奖','','跨服云购开奖传闻'),(331,22,1,0,0,'跨服云购活动<color@1>【{1}】</color>开启不限购','','跨服云购不限购阶段传闻'),(331,23,1,10,0,'欧气满满！<color@2>{1}</color>在<color@3>{2}</color>活动中，获得珍稀道具<color@{3}><a@goods@{4}></a>x{5}</color>！','欧气满满！玩家名字六字在许愿神树活动中，获得珍稀道具xxxx！','欧气满满！玩家名字六字在许愿神树活动中，获得珍稀道具xxxx！'),(331,24,1,10,0,'恭喜<color@0>{1}</color>在本服充值排行榜活动中获得第{2}名！','恭喜玩家名字六个字在本服充值排行榜活动中获得第x名！',''),(331,25,1,10,0,'恭喜<color@0>{1}</color>在本服消费排行榜活动中获得第{2}名！','恭喜玩家名字六个字在本服消费排行榜活动中获得第x名！',''),(331,26,1,10,0,'<color@3>{1}</color>人品爆发，在许愿活动中获得<color@{2}>{3}</color>*<color@0>{4}</color>！<color@0><a@joy_wish>立即前往</a></color>','[角色名]人品爆发，在许愿活动中获得[道具名称]！立即前往',''),(338,1,2,10,0,'天空一声巨响，原来是{1}在限时狂欢中召唤出了<color@4>{2}×{4}</color>！<color@1><a@race_act@{3}>我要召唤</a></color>','天空一声巨响，原来是#玩家姓名#在限时狂欢中召唤出了#道具名字#！我要召唤','天空一声巨响，原来是#玩家姓名#在限时狂欢中召唤出了#道具名字#！我要召唤'),(338,2,2,10,0,'天空一声巨响，原来是{1}在限时狂欢中召唤出了<color@4>{2}×{4}</color>！<color@1><a@race_act@{3}>我要召唤</a></color>','天空一声巨响，原来是#玩家姓名#在限时狂欢中召唤出了#道具名字#！我要召唤','天空一声巨响，原来是#玩家姓名#在限时狂欢中召唤出了#道具名字#！我要召唤'),(338,3,2,10,0,'天空一声巨响，原来是{1}在限时狂欢中召唤出了<color@4>{2}×{4}</color>！<color@1><a@race_act@{3}>我要召唤</a></color>','天空一声巨响，原来是#玩家姓名#在限时狂欢中召唤出了#道具名字#！我要召唤','天空一声巨响，原来是#玩家姓名#在限时狂欢中召唤出了#道具名字#！我要召唤'),(339,1,2,4,0,'{1}发起了一个<color@1>{2}</color>，大家来抢吧<a@redenvelopes><color@1><抢红包></color></a>','#玩家名#发起了一个红包，大家来抢吧<抢红包>',''),(339,2,2,1,0,'我发起了一个<color@1>{2}</color>，大家来抢吧<a@actredenvelopes><color@1><抢红包></color></a>','我发起了一个红包，大家来抢吧<抢红包>',''),(339,3,2,4,0,'<color@1>{1}</color>凭借单身多年的手速，抢到最多<color@2>{2}</color>绑钻的奖励，真是幸运啊','##玩家名##凭借单身多年的手速，抢到最多XX绑钻的奖励，真是幸运啊','##玩家名##凭借单身多年的手速，抢到最多XX绑钻的奖励，真是幸运啊'),(400,1,2,4,0,'「{1}」成为公会领袖！真是一位具有领袖气质的成员呢！','',''),(400,2,2,4,0,'「{1}」成为公会会长！希望你能让公会变的更加强大！','',''),(400,3,2,4,0,'「{1}」成为公会副会长！协助会长的重任就交给你了！','',''),(400,4,2,4,0,'「{1}」成为公会理事！真是个明智的选择！','',''),(400,5,2,4,0,'欢迎「<color@0>{1}</color>」成为公会一员，大家热烈欢迎！鼓掌，啪啪啪！啪啪啪！','',''),(400,7,1,1,0,'哇哦，<color@0>{1}</color>创建了公会<color@2>{2}</color>。精彩活动，强力技能，每日工资等你来拿！<color@1><a@guild><我要加入></a></color>','哇哦，XXX创建了公会XXX,精彩活动，拍卖分红，每周工资等你来拿！<我要加入>',''),(400,8,3,0,0,'获得公会贡献：<color@0>{1}</color>','获得公会贡献：XX','获得公会贡献：XX'),(400,9,3,0,0,'获得公会资金：<color@0>{1}</color>','获得公会资金：XX','获得公会资金：XX'),(400,10,1,10,0,'公会<color@2>{1}</color>改名为<color@0>{2}</color>，开辟了一片新天地','',''),(400,11,3,0,0,'获得公会成长值：<color@0>{1}</color>','获得公会成长值：XX','获得公会成长值：XX'),(401,1,2,4,0,'公会的{1}建筑升级到{2}级了，赶紧去看看吧！<a@enterguildbuilding@{3}><前去查看></a>','公会的XX建筑升级到X级了，赶紧去看看吧！<前去查看>',''),(401,2,2,4,0,'{1}在公会仓库中捐献了<a@goods9@{2}@{3}@{4}></a>','玩家名字在公会仓库中捐献了装备名字',''),(401,3,2,4,0,'{1}在公会仓库中兑换了<a@goods3@{2}@{3}@{4}></a>','玩家名字在公会仓库中兑换了装备名字',''),(402,6,1,10,1,'<color@0>守卫公会</color>已开启，<color@0>{1}</color>以上的勇士们可即刻进入副本，参与防守，可获得海量经验！','',''),(402,7,1,10,1,'<color@0>守卫公会</color>活动入口将在2分钟后关闭，请各公会勇士们抓紧时间进入副本！','',''),(402,8,2,4,0,'<color@0>守卫公会</color>副本已开启，请各公会勇士们抓紧时间进入副本！','',''),(402,9,2,4,1,'<color@2>公会争霸战</color>已经打响，赶快进入战场，为公会荣耀而战！','',''),(402,10,2,4,1,'<color@2>公会争霸战</color>已全部落下帷幕，请勇士们下次再来！','',''),(402,11,2,10,1,'<color@0>公会争霸</color>即将开启，加入公会为荣誉而战吧！并可赢取海量<color@4>经验</color>和<color@4>公会贡献</color>！','公会争霸即将开启，加入公会为荣誉而战吧！并可赢取海量经验和贡献奖励！','公会争霸即将开启，加入公会为荣誉而战吧！并可赢取海量经验和贡献奖励！'),(402,12,1,10,1,'恭喜公会<color@2>{1}</color>夺得本次公会争霸冠军，获得了神殿的主宰权！','恭喜公会名字夺得本次公会争霸冠军，获得了神殿的主宰权！','恭喜公会名字夺得本次公会争霸冠军，获得了神殿的主宰权！'),(402,13,1,10,1,'<color@2>{1}</color>已连续击败10名对手，大杀四方，无人能敌！','XXX已连续击败10名对手，大杀四方，无人能敌！','XXX已连续击败10名对手，大杀四方，无人能敌！'),(402,14,1,10,1,'<color@2>{1}</color>已连续击败20名对手，犹如战神降临，逆天弑神！','XXX已连续击败20名对手，犹如战神降临，逆天弑神！','XXX已连续击败20名对手，犹如战神降临，逆天弑神！'),(402,15,1,10,1,'<color@2>{1}</color>超神手速，一举拿下<color@1>{2}</color>！','XXX超神手速，一举拿下据点名！','XXX超神手速，一举拿下据点名！'),(402,16,1,10,1,'<color@1>{1}</color>正在被敌方攻击，速速前去援救！','据点名正在被敌方攻击，速速前去援救！','据点名正在被敌方攻击，速速前去援救！'),(402,17,1,10,1,'<color@1>{1}</color>公会累计资源已超过2500，正向胜利迈进！','公会名累计资源点已超过2500，正向胜利迈进！','公会名累计资源点已超过2500，正向胜利迈进！'),(402,18,1,10,1,'本次公会争霸赛事全部落下帷幕，请持续关注下次赛事开启！','本次公会争霸赛事全部落下帷幕，请持续关注下次赛事开启！','本次公会争霸赛事全部落下帷幕，请持续关注下次赛事开启！'),(402,19,1,10,1,'守卫公会将在5分钟后开启','守卫公会将在5分钟后开启','守卫公会将在5分钟后开启'),(402,20,2,10,1,'我方<color@2>{1}</color>正在被攻击，请我方成员立即前往守护<color@1><a@guildwar@{2}>立即前往</a></color>','我方边防守卫/内殿守卫/基地守护正在被攻击，请我方成员立即前往守护',''),(402,21,2,10,0,'{1}成员势如破竹，击破了{2}的{3}','红方/蓝方/黄方阵营成员势如破竹，击破了红方/蓝方/黄方阵营的边防守卫/内殿守卫/基地守护',''),(402,22,2,10,1,'我方<color@2>{1}</color>被击破，请我成员立即前往支援<color@1><a@guildwar@{2}>立即前往</a></color>','我方边防守卫/内殿守卫被击破，请我成员立即前往支援',''),(402,23,2,10,1,'距离公会争霸结束还有<color@2>{1}</color>，请各个公会把握最后的时刻，勇夺胜利！','距离公会争霸结束还有30s，请各个公会把握最后的时刻，勇夺胜利！',''),(402,25,2,10,1,'<color@2>{1}</color>成员万夫莫敌，攻破了其余两方的所有单位，取得了本场胜利！','红方/蓝方/黄方阵营成员万夫莫敌，攻破了其余两方的所有单位，取得了本场胜利！',''),(402,26,2,4,1,'恭喜我方攻破了其余两方的单位，取得了本场的胜利！','恭喜我方攻破了其余两方的单位，取得了本场的胜利！',''),(402,27,2,4,1,'我方只剩余一个基地守护了，请我方成员快速回防<color@1><a@guildwar@{1}>立即前往</a></color>','我方只剩余一个基地守护了，请我方成员快速回防',''),(402,28,2,10,1,'中立BOSS已在场景中央刷新，请各方成员立即前往争夺，获取复活点特权<color@1><a@guildwar@{1}>立即前往</a></color>','中立BOSS已在场景中央刷新，请各方成员立即前往争夺，获取复活点特权',''),(402,29,2,10,1,'中立BOSS已被{1}成员击杀，{2}获得复活点特权，离胜利又进了一步','中立BOSS已被红方阵营成员击杀，红方阵营获得复活点特效，离胜利又进了一步',''),(402,30,1,10,0,'{1}边防守卫已被击破，其内殿守卫和基地攻击力已减弱','红方/黄方/蓝方边防守卫已被击破，其内殿守卫和基地攻击力已减弱',''),(402,31,1,10,0,'{1}内殿守卫已被击破，其基地攻击已减弱','红方/黄方/蓝方内殿守卫已被击破，其基地攻击力已减弱',''),(402,32,1,10,0,'{1}基地已被击破，{2}成为当前战场的第三名，请其余两方继续努力，勇夺第一','红方阵营基地已被击破，红方阵营成为当前战场的第三名，请其余两方继续努力，勇夺第一',''),(402,33,2,10,0,'公会争霸赛已结束，<color@5>{1}</color>{2}<color@4>{3}</color>{4}<color@3>{5}</color>{6}<color@2>{7}</color>{8}','公会争霸赛已结束，S赛区第一名为XXX公会，第二名为XXX公会，第三名为XXX公会；A赛区第一名为XXX公会，第二名为XXX公会，第三名为XXX公会；B赛区第一名为XXX公会，第二名为XXX公会，第三名为XXX公会；C赛区第一名为XXX公会，第二名为XXX公会，第三名为XXX公会',''),(402,34,2,10,0,'<color@2>{1}公会争霸战</color>已结束，第一名为{2}，第二名{3}','S赛区公会争霸战已结束，第一名为XXX公会，第二名为XXX公会',''),(402,35,2,10,0,'<color@2>{1}公会争霸战</color>已结束，第一名为{2}','S赛区公会争霸战已结束，第一名为XXX公会',''),(402,36,2,3,0,'请全体成员一起进攻{1}外塔，加速击破','',''),(402,37,2,3,0,'请全体成员一起进攻{1}内塔，加速击破','',''),(402,38,2,3,0,'请全体成员一起进攻{1}基地，胜利就在眼前','',''),(402,39,2,3,0,'注意周围的敌人，先杀人！！','',''),(402,40,2,3,0,'击破目标：{1}基地，来人快和我从小路偷家！','',''),(402,41,2,3,0,'请全体成员一起防御我方外塔，抵御外塔','',''),(402,42,2,3,0,'请全体成员一起防御我方内塔，抵御内塔','',''),(402,43,2,3,0,'请全体成员一起火速回防基地，敌人要破家了！！！','',''),(402,44,2,3,0,'小心敌方公会集中堵门，快分散！！','',''),(402,45,2,3,0,'全体成员注意，小心敌方偷家，注意封锁两边小路','',''),(402,46,1,3,0,'场景<color@2>中心位置每隔60秒</color>将刷出一只中立BOSS，击杀BOSS的一方将获得<color@2>中心点复活权</color>，更快速的进行战斗！','',''),(402,47,1,3,0,'<color@2>公会争霸胜负条件：</color>活动结束后，存留基地守卫的一方胜利，如有多方同时存留，则以公会积分多少进行判定','',''),(402,48,1,0,0,'公会争霸将在5分钟后开启','公会争霸将在5分钟后开启','公会争霸将在5分钟后开启'),(402,49,1,3,0,'公会已购买{1}，在基地附近点击采集即可变身为最强攻城器械，快快上车，坐好扶稳','',''),(402,50,2,4,0,'在大家的努力下，<color@1>公会守卫成功抵御了第{1}波怪物！</color>每位成员都获得了丰厚奖励！','在大家的努力下，公会守卫成功抵御了第XX波怪物，每位成员都获得了丰厚奖励！','在大家的努力下，公会守卫成功抵御了第XX波怪物，每位成员都获得了丰厚奖励！'),(402,51,2,4,0,'<color@2>{1}</color><color@2>已被击破！</color>各成员火速回防水晶！','XX已被击破！各成员火速回防水晶！','XX已被击破！各成员火速回防水晶！'),(402,52,2,4,0,'<color@1>{1}</color>花费了<color@2>{2}钻石</color>召唤出了<color@2>公会boss</color>,各成员速度前往击杀，领取丰厚奖励！<a@guildguard><color@1>前往击杀</color></a>','#玩家名#花费了#N#钻石召唤出了公会boss,各成员速度千万击杀，领取丰厚奖励！前往击杀','#玩家名#花费了#N#钻石召唤出了公会boss,各成员速度千万击杀，领取丰厚奖励！前往击杀'),(402,53,2,4,0,'哇！金色传说！恭喜<color@1>{1}</color>采集到了稀有的<color@3>{2}</color>,只剩<color@0>{3}</color>个，大家抓紧时间采集宝箱！','哇！铂金传说！恭喜玩家XX采集到了稀有的XX,只剩XX个，先到先得！','哇！铂金传说！恭喜玩家XX}采集到了稀有的XX,只剩XX个，先到先得！'),(403,1,2,14,0,'正确答案为<color@1>{1}.{2}</color>，回答最快的玩家为：<color@1>{3}</color>','正确答案为{1}.{2}，回答最快的玩家为：{3}','正确答案为{1}.{2}，回答最快的玩家为：{3}'),(403,2,2,14,0,'正确答案为<color@1>{1}.{2}</color>，回答最快的玩家为：<color@1>{3}，{4}</color>','正确答案为{1}.{2}，回答最快的玩家为：{3}，{4}','正确答案为{1}.{2}，回答最快的玩家为：{3}，{4}'),(403,3,2,14,0,'正确答案为<color@1>{1}.{2}</color>，回答最快的玩家为：<color@1>{3}，{4}，{5}</color>','正确答案为{1}.{2}，回答最快的玩家为：{3}，{4}，{5}','正确答案为{1}.{2}，回答最快的玩家为：{3}，{4}，{5}'),(403,4,2,14,0,'正确答案为<color@1>{1}.{2}</color>，回答最快的玩家为：<color@1>{3}，{4}，{5}，{6}</color>','正确答案为{1}.{2}，回答最快的玩家为：{3}，{4}，{5}，{6}','正确答案为{1}.{2}，回答最快的玩家为：{3}，{4}，{5}，{6}'),(403,5,2,14,0,'正确答案为<color@1>{1}.{2}</color>，回答最快的玩家为：<color@1>{3}，{4}，{5}，{6}，{7}</color>','正确答案为{1}.{2}，回答最快的玩家为：{3}，{4}，{5}，{6}，{7}','正确答案为{1}.{2}，回答最快的玩家为：{3}，{4}，{5}，{6}，{7}'),(403,6,2,14,0,'正确答案为<color@1>{1}.{2}</color>，很遗憾无人答对','正确答案为{1}.{2}，很遗憾无人答对','正确答案为{1}.{2}，很遗憾无人答对'),(403,7,1,10,0,'公会篝火答题开启咯！绑钻红包拿不停！不要错过哦~<color@1><a@call2>查看活动</a></color>','公会篝火答题开启咯！绑钻红包拿不停！不要错过哦~查看活动','公会篝火答题开启咯！绑钻红包拿不停！不要错过哦~查看活动'),(403,8,1,10,0,'公会篝火开启咯！答题拼智商，绑钻红包拿不停！不要错过哦~<color@1><a@call2>查看活动</a></color>','公会篝火开启咯！答题拼智商，绑钻红包拿不停！不要错过哦~查看活动','公会篝火开启咯！答题拼智商，绑钻红包拿不停！不要错过哦~查看活动'),(403,9,1,4,0,'<color@1>{1}</color>豪气冲天，购买了<color@3>至尊晚宴</color>，大家一起嗨起来!','#玩家名#豪气冲天，购买了至尊晚宴，大家一起嗨起来','#玩家名#豪气冲天，购买了至尊晚宴，大家一起嗨起来'),(403,10,1,4,0,'<color@1>{1}</color>豪气冲天，购买了<color@2>豪华晚宴</color>，大家一起嗨起来','#玩家名#豪气冲天，购买了豪华晚宴，大家一起嗨起来','#玩家名#豪气冲天，购买了豪华晚宴，大家一起嗨起来'),(403,11,1,4,0,'<color@1>{1}</color>豪气冲天，购买了<color@1>普通晚宴</color>，大家一起嗨起来','#玩家名#豪气冲天，购买了豪华晚宴，大家一起嗨起来','#玩家名#豪气冲天，购买了豪华晚宴，大家一起嗨起来'),(403,12,1,14,0,'本次篝火答题结束了，<color@1>{1}</color>智力碾压获得了第1名！可喜可贺！','本次篝火答题结束了，#玩家名#智力碾压获得了第1名！可喜可贺！','本次篝火答题结束了，#玩家名#智力碾压获得了第1名！可喜可贺！'),(403,13,2,4,0,'<color@1>{1}</color>使用了<a@goods5@{2}></a>召唤出了{3}答题神兽，大家快点前去击杀，获得丰厚红包奖励哦！<a@callboss><color@1>前往目标</color></a>','#玩家名#使用了#物品名#召唤除了#boss名称#答题神兽，大家快点前去击杀，获得丰厚红包奖励哦！前往目标','#玩家名#使用了#物品名#召唤除了#boss名称#答题神兽，大家快点前去击杀，获得丰厚红包奖励哦！前往目标'),(403,14,2,4,0,'本次篝火答题结束了，<color@1>{1}</color>智力碾压获得了第1名！可喜可贺！','本次篝火答题结束了，<color@1>{1}</color>智力碾压获得了第1名！可喜可贺！','本次篝火答题结束了，<color@1>{1}</color>智力碾压获得了第1名！可喜可贺！'),(403,15,2,14,0,'本次篝火答题结束了，<color@1>{1}</color>技惊四座获得了第2名！可喜可贺！','本次篝火答题结束了，<color@1>{1}</color>技惊四座获得了第2名！可喜可贺！','本次篝火答题结束了，<color@1>{1}</color>技惊四座获得了第2名！可喜可贺！'),(403,16,2,4,0,'本次篝火答题结束了，<color@1>{1}</color>技惊四座获得了第2名！可喜可贺！','本次篝火答题结束了，<color@1>{1}</color>技惊四座获得了第2名！可喜可贺！','本次篝火答题结束了，<color@1>{1}</color>技惊四座获得了第2名！可喜可贺！'),(403,17,2,14,0,'本次篝火答题结束了，<color@1>{1}</color>才思敏捷获得了第3名！可喜可贺！','本次篝火答题结束了，<color@1>{1}</color>才思敏捷获得了第3名！可喜可贺！','本次篝火答题结束了，<color@1>{1}</color>才思敏捷获得了第3名！可喜可贺！'),(403,18,2,4,0,'本次篝火答题结束了，<color@1>{1}</color>才思敏捷获得了第3名！可喜可贺！','本次篝火答题结束了，<color@1>{1}</color>才思敏捷获得了第3名！可喜可贺！','本次篝火答题结束了，<color@1>{1}</color>才思敏捷获得了第3名！可喜可贺！'),(403,19,2,14,0,'{1}.{2}','##选项##.##答案##','##选项##.##答案##'),(403,20,1,4,0,'玩家{1}居然烹饪出了 <a@goods5@{2}></a>×{3}!这香气已经快让人魂不守舍了！','玩家##居然烹饪出了##×##！这香气已经快让人魂不守舍了！','玩家##居然烹饪出了##×##！这香气已经快让人魂不守舍了！'),(403,21,1,4,0,'玩家{1}居然烹饪出了<a@goods5@{2}></a>×{3}!仿佛整个公会都被烧焦的味道！','玩家##居然烹饪出了##×##！仿佛整个公会都被烧焦的味道！','玩家##居然烹饪出了##×##！仿佛整个公会都被烧焦的味道！'),(412,1,1,10,0,'<color@1>{1}</color>通过卢币招募竟然获得了<color@{2}>{3}</color>级伙伴<a@partner@{4}></a>,大家快来吸吸欧气吧！','xxx通过卢币招募获得了s级伙伴xxx,真是鸿运当头',''),(412,2,1,10,0,'<color@1>{1}</color>通过招募卡获得了<color@{2}>{3}</color>级伙伴<a@partner@{4}></a>,真是令人羡慕啊！','',''),(412,3,1,10,0,'<color@1>{1}</color>通过钻石招募竟然获得了<color@{2}>{3}</color>级伙伴<a@partner@{4}></a>,大家快来吸吸欧气吧','',''),(414,1,3,0,0,'本次活动中已采集{1}/{2}个珍珠','本次活动中已采集1/20个珍珠','本次活动中已采集1/20个珍珠'),(414,2,1,10,1,'<color@4>呜海遗珠</color>活动再过5分钟就要开始啦，请大家做好准备!','呜海遗珠活动再过5分钟就要开始啦，请大家做好准备!','呜海遗珠活动再过5分钟就要开始啦，请大家做好准备!'),(414,3,1,10,1,'<color@4>呜海遗珠</color>活动开始啦，大家快前往呜坦之城参加吧！<color@1><a@snatch>立即前往</a></color>','呜海遗珠活动开始啦，大家快前往呜坦之城参加吧！立即前往（点击立即前往寻路至活动区域）','呜海遗珠活动开始啦，大家快前往呜坦之城参加吧！立即前往（点击立即前往寻路至活动区域）'),(414,4,1,10,1,'<color@4>呜海遗珠</color>活动结束咯，珍珠没采满的朋友下次再接再厉哦！','呜海遗珠活动结束咯，珍珠没采满的朋友下次再接再厉哦！','呜海遗珠活动结束咯，珍珠没采满的朋友下次再接再厉哦！'),(416,1,1,10,1,'<color@1>{1}</color>人品爆发在<color@3>{2}</color>中获得<color@{3}><a@goods3@{4}@{5}@{6}></a></color>','[玩家名称]人品爆发在[xxxx]中获得[物品名称]','[玩家名称]人品爆发在龙王秘宝中获得[物品名称]'),(418,1,2,10,0,'<color@1>魅力海滩</color>活动即将在<color@0>5</color>分钟后开始！','魅力海滩活动即将在12秒后开始啦！',''),(418,2,2,10,0,'<color@1>魅力海滩</color>活动开始啦，大家可尽情享受欢乐时光！','',''),(418,3,1,10,0,'<color@1>{1}</color>魅力四射，成为本次魅力海滩活动中的<color@3>海滩万人迷</color>！','恭喜玩家名字成为本次魅力海滩活动中的海滩万人迷！','海滩活动结算传闻'),(418,4,2,3,0,'温馨提示：活动期间，进行<color@0>约会</color>经验奖励更丰厚。还可以给其他玩家<color@0>送礼</color>，助Ta成为<color@1>海滩万人迷</color>！','',''),(418,101,2,3,0,'<color@1>{1}</color>童心未泯，给<color@1>{2}</color>送了一个造型可爱的小黄鸭！','玩家 xxx 赠送玩家 xxx 一个 鸭子',''),(418,102,2,3,0,'美味至极，<color@1>{1}</color>邀请<color@1>{2}</color>品尝新鲜出炉的温泉咸蛋！','',''),(418,103,2,3,0,'<color@1>{1}</color>搓搓手，把冬日里的温暖--麻辣烫端到了<color@1>{2}</color>的面前！','',''),(418,104,2,3,0,'<color@1>{1}</color>掏出了一个香喷喷的肥皂，装作不小心的扔向了<color@1>{2}</color>！','',''),(418,105,1,10,0,'欲带皇冠，必承其重，更离不开大家的支持！<color@1>{1}</color>想要获得大家的投票！<color@2><a@beachvote>我要投票</a></color>','',''),(420,1,2,10,0,'独具慧眼！<color@1><a@player@{1}@{2}></a></color>在<color=#f0b30e>传奇计划</color>中投资了最高档次，获得了海岸旅业的<color=#cf5afb>18800绑钻</color>的10倍回报，从此绑钻多到数不完！<color@0><a@open_fun@999@6>我要投资</a></color>','',''),(420,2,2,10,0,'<color@1><a@player@{1}@{2}></a></color>花了一笔小钱成功参与了<color@3>月卡投资</color>，<color@0>高倍</color>回报无风险，每日绑钻不用愁！<color@0><a@open_fun@999@9>我要投资</a></color>','',''),(420,3,2,10,0,'独具慧眼！<color@1><a@player@{1}@{2}></a></color>在<color=#f0b30e>巅峰计划</color>中投资了最高档次，获得了海岸商会的<color=#cf5afb>18800绑钻</color>的10倍回报，从此绑钻多到数不完！<color@0><a@open_fun@999@6>我要投资</a></color>','',''),(420,4,1,10,0,'<color@1>{1}</color>在<color=#f0b30e>{2}</color>中投资了<color=#fba65a>{3}钻石</color>，从此绑钻多到数不完！','玩家在传奇计划投资了680钻石，从此绑钻多到数不完！','玩家在传奇计划投资了680钻石，从此绑钻多到数不完！'),(421,1,3,5,0,'跟随罗盘指示找到宝藏<a@treasure@{1}@{2}@{3}@{4}@{5}></a>','跟随罗盘指示找到宝藏<宝藏地图名(x,y)>','跟随罗盘指示找到宝藏<宝藏地图名(x,y)>'),(421,2,3,5,0,'全员集合，发现宝藏位置<a@treasure3@{1}@{2}@{3}@{4}@{5}></a>','全员集合，发现宝藏位置<宝藏地图名(123,123)>','全员集合，发现宝藏位置<宝藏地图名(123,123)>'),(421,3,2,4,0,'公会的战友们！请协助我寻找<color@3><a@treasure2@{1}@{2}><神秘藏宝图></a></color>','热爱探宝的公会朋友帮忙寻找<神秘藏宝图>','热爱探宝的公会朋友帮忙寻找<神秘藏宝图>'),(421,4,2,4,0,'{1}似乎嗅到了宝藏的气息！并且成功发掘了{2}的神秘宝藏线索。','玩家名XXX 摸金符，搬山卸岭，发掘了玩家名字XX的神秘宝藏线索。','玩家名XXX 摸金符，搬山卸岭，发掘了玩家名字XX的神秘宝藏线索。'),(421,5,2,4,0,'{1}的神秘宝藏集齐了所有线索！下面就是见证奇迹的时候啦！','玩家名XXX的神秘宝藏集齐了所有线索，准备召唤神龙','玩家名XXX的神秘宝藏集齐了所有线索，准备召唤神龙'),(421,6,3,0,0,'{1}不在附近，无法挖宝。','XXX玩家名不在附近，无法挖宝','XXX玩家名不在附近，无法挖宝'),(421,7,2,4,0,'{1}祝贺你发掘到神秘宝藏！享受探宝的喜悦吧！协力者也将{2}获得分享奖励哦！','{1}不愧为探宝大神，发掘了神秘宝藏，帮助者{2}获得分享奖励','{1}不愧为探宝大神，发掘了神秘宝藏，帮助者{2}获得分享奖励'),(421,8,2,4,0,'{1}太不可思议了！竟然单凭一己之力就发掘了神秘宝藏。难道你就是传说中的探宝猎人吗！？','{1}不愧为探宝大神，单凭一己之力发掘了神秘宝藏','{1}不愧为探宝大神，单凭一己之力发掘了神秘宝藏'),(421,9,3,5,0,'糟糕！惊动了宝物守护者！击败可获得奖励！','挖宝惊动了守护者，击败可获得奖励','挖宝惊动了守护者，击败可获得奖励'),(422,1,1,10,0,'英灵殿领主即将苏醒，殿堂的大门已经开启，请冒险家们进入备战！','',''),(422,2,1,10,0,'英灵殿领主已经苏醒，等待着冒险家们的挑战！','',''),(422,3,1,10,0,'{1}击败{2}（本体），简直不可思议！竟然能洞察到本体所在！','玩家XXX击败怪物名字XXX（真身），这下可牛比了',''),(422,4,1,10,0,'恭喜{1}公会挑战{2}（本体），获得{3}！','恭喜公会名XXX挑战怪物名字XXX（真身），获得物品XXX*数量，物品XXX*数量！','击杀的时候提示'),(422,5,1,10,0,'恭喜{1}公会挑战{2}（暗影），获得{3}！','恭喜公会名XXX挑战怪物名字XXX（影子），获得获得物品XXX*数量，物品XXX*数量！','击杀的时候提示'),(422,6,1,10,0,'英灵殿领主已经被全部击败！本次活动结束！期待下一次的苏醒有更多冒险家前来挑战！','',''),(422,7,1,10,0,'英灵殿活动时间结束，十分可惜依然有未被击杀的怪物，期待冒险家们下一次的挑战！','',''),(422,8,1,10,0,'恭喜{1}公会挑战{2}（本体），获得{3}！','恭喜公会名XXX挑战怪物名字XXX（真身），获得获得物品XXX*数量，物品XXX*数量！','强制结算通知'),(422,9,1,10,0,'恭喜{1}公会挑战{2}（暗影），获得{3}！','恭喜公会名XXX挑战怪物名字XXX（影子），获得物品XXX*数量，物品XXX*数量！','强制结算通知'),(422,10,3,10,1,'今日首次攻击英灵殿领主，获得奖励{1}!','',''),(422,11,2,4,0,'公会威望提升{1}','公会威望提升XX',''),(422,12,1,10,0,'{1}公会参加英灵殿威望提升{2}','雄图霸业公会威望提示1000',''),(424,1,2,10,0,'<color@1>{1}</color>成功激活了<color@3>荆棘石碑</color>，获得了<color@3>勇者无畏</color>技能，绝对攻击、绝对防御提升<color@0>10%</color>','',''),(424,2,2,10,0,'<color@1>{1}</color>成功激活了<color@3>生命石碑</color>，获得了<color@3>虔信誓语</color>技能，每10秒回复<color@0>5%</color>生命值','',''),(424,3,2,10,0,'<color@1>{1}</color>成功激活了<color@3>智者石碑</color>，获得了<color@3>智者顿悟</color>技能，人物经验增加<color@0>30%</color>','',''),(424,4,2,10,0,'<color@1>{1}</color>成功激活了<color@3>强者石碑</color>，获得了<color@3>强者之殇</color>技能，对野外首领伤害提升<color@0>10%</color>','',''),(424,5,2,10,0,'<color@1>{1}</color>成功激活了<color@3>固守石碑</color>，获得了<color@3>不灭希望</color>技能，<color@0>10%</color>几率免除眩晕','',''),(425,1,1,10,0,'准备进入下一层!','',''),(425,2,1,10,0,'请进入下一层!','',''),(425,3,2,10,0,'<color@1>{1}</color>公会的<color@1>{2}</color>成功击杀了抢滩登陆的领主{3}，获得公会声望{4}','',''),(425,4,2,10,1,'你被击败了，只能遗憾的退出了抢滩登陆活动。期待你的下次参与!','',''),(427,1,1,10,0,'<color@1>{1}</color>通过神之试炼,神格进阶为<color@2>{2}</color>！星界再添一位强者！','玩家名通过神之试炼，实力更近一步，神格进阶为XX，星界再添一位强者！',''),(428,1,2,10,1,'<color@1>{1}</color>经过一番努力，获得了<color@1>{2}</color>的认可，从此以后纵横大陆，无所畏惧！<color@0><a@pyx>我要激活</a></color>','',''),(428,2,2,10,1,'经过悉心调教，<color@1>{1}</color>的<color@1>{2}</color>提升到<color@1>{3}</color>级，实力更进一步！<color@0><a@pyx>圣灵升级</a></color>','',''),(428,3,2,10,1,'喜大普奔，<color@1>{1}</color>得到圣器<color@1>{2}</color>，激活了强力技能<color@1>{3}</color>。一技在手，天下我有！<color@0><a@pyx>我要激活</a></color>','',''),(429,1,2,10,0,'<color@1>捕蝶</color>活动即将在<color@0>{1}</color>分钟后开始！','',''),(429,2,1,0,0,'<color@1>捕蝶</color>活动即将在<color@0>{1}</color>分钟后开始！','',''),(429,3,2,10,0,'恭喜<color@1>{1}</color>玩家捕获红蝴蝶，获得蝴蝶仙子效果加持，捕蝶积分收益翻倍','',''),(429,4,2,3,0,'恭喜<color@1>{1}</color>玩家捕获红蝴蝶，获得蝴蝶仙子效果加持，捕蝶积分收益翻倍','',''),(429,5,2,10,0,'<color@1>红蝴蝶</color>已在场景中心刷出，请各位玩家前往捕获，获得收益双倍特权！','红蝴蝶已在场景中心刷出，请各位玩家前往捕获，获得收益双倍特权！',''),(429,6,2,10,0,'<color@1>捕蝶</color>活动将在<color@0>{1}</color>秒后结束，请各位玩家把握最后的机会','捕蝶活动将在30s后结束，请各位玩家把握最后的机会',''),(429,7,1,10,0,'<color@1>捕蝶</color>活动已结束，本次活动积分第一名为{1},第二名为{2}，第三名为{3}','捕蝶活动已结束，本次活动积分第一名为XXX，第二名为XXX，第三名为XXX',''),(429,8,1,10,0,'<color@1>捕蝶</color>活动已结束，本次活动积分第一名为{1},第二名为{2}','捕蝶活动已结束，本次活动积分第一名为XXX，第二名为XXX',''),(429,9,1,10,0,'<color@1>捕蝶</color>活动已结束，本次活动积分第一名为{1}','捕蝶活动已结束，本次活动积分第一名为XXX',''),(429,10,1,10,0,'本次捕蝶活动已结束，请期待下一次活动开启！','',''),(430,1,1,10,0,'<color@3>{1}</color>经过不懈努力，获得<color@3>{2}</color>的认可。从此结伴同游，闯荡大陆！<color@0><a@starsoul>我要激活</a></color>','XXX经过不懈努力，获得XXX的认可。从此结伴同游，闯荡大陆！我要激活','激活星灵'),(430,2,1,10,0,'经过悉心调教，<color@3>{1}</color>的星灵<color@3>{2}</color>成功进阶到<color@3>{3}</color>阶，战力直线飙升！<color@0><a@starsoul>我要进阶</a></color>','经过悉心调教，玩家名的星灵xxx成功进阶到N阶，战力直线飙升！我要进阶','进阶成功'),(430,3,1,10,0,'<color@3>{1}</color>的星灵<color@3>{2}</color>成功达到<color@3>{3}</color>星，实力更进一步！<color@0><a@starsoul>星灵升星</a></color>','玩家名的星灵XXX成功达到XX星，实力更进一步！星灵升星','星灵升星成功'),(430,4,1,10,0,'<color@3>{1}</color>的小宇宙爆发，成功进阶到<color@3>{2}</color>小宇宙，整个大陆都黯然失色！','XXX的小宇宙爆发，成功进阶到XX小宇宙，整个大陆都黯然失色！','星灵小宇宙突破成功'),(430,5,1,10,0,'欧皇降临，<color@3>{1}</color>在星空之门成功召唤了<color@{2}>{3}</color>*<color@0>{4}</color>，真是令人羡慕！<color@0><a@starsoultreasure>前往召唤</a></color>','欧皇降临！玩家名在星空之门成功召唤了XXX，真是令人羡慕！前往召唤','星空召唤'),(430,6,1,10,0,'我滴个神啊，<color@2>{1}</color>的星灵小宇宙进阶到<color@3>{2}</color>啦，真是历害死了！','我滴个神啊，XXX的星灵小宇宙进阶到XXX啦，真是历害死了！',''),(431,1,1,10,0,'我滴个神啊，<color@0>{1}</color>竟然合成了<a@goods@{2}></a>，真是太让人羡慕了！','我滴个神啊，XXX竟然合成了星痕名，真是太让人羡慕了！','我滴个神啊，XXX竟然合成了星痕名，真是太让人羡慕了！'),(435,1,1,10,0,'<color@0>{1}</color>经过不懈的努力，成功将<color@2>{2}</color>提升到{3}级，晋升为<color@3>{4}</color>，66哒！','#玩家名字# 经过不懈的努力，成功将 #技能名称#提升到#X#级，晋升为#称号#，66哒！','#玩家名字# 经过不懈的努力，成功将 #技能名称#提升到#X#级，晋升为#称号#，66哒！'),(436,1,1,10,0,'各位勇者，星灵争霸已经开启！老铁，嗨起来！<color@1><a@stardrum>查看活动</a></color>','各位勇者，星灵争霸已经开启！老铁，嗨起来！查看活动','各位勇者，星灵争霸已经开启！老铁，嗨起来！查看活动'),(436,2,1,10,0,'号外号外！星灵争霸海选赛第<color@1>{1}</color>场已经结束了,总共<color@1>{2}</color>人晋级，获得海量<color@2>极品星灵装备</color>！','海选赛第M场已经结束了,总共N人晋级，共获N钻石！','海选赛第M场已经结束了,总共N人晋级，共获N钻石！'),(436,3,1,10,0,'号外号外！星灵争霸传奇1~150级战区的登顶战结束啦，冠军是人见人爱，花见花开的<color@1>{1}</color>','号外号外！星灵争霸传奇1~150级战区的登顶战结束啦，冠军是人见人爱，花见花开的#玩家名#','号外号外！星灵争霸传奇1~150级战区的登顶战结束啦，冠军是人见人爱，花见花开的#玩家名#'),(436,4,1,10,0,'各位勇者，星灵争霸将于5分钟后开启！请各位做好准备，还没报名的速速报名啦！<color@1><a@drumwar>查看活动</a></color>','各位勇者，星灵争霸将于5分钟后开启！请各位做好准备，还没报名的速速报名啦！查看活动','各位勇者，星灵争霸将于5分钟后开启！请各位做好准备，还没报名的速速报名啦！查看活动'),(436,5,1,10,0,'号外号外！星灵争霸传奇151~300级战区的登顶战结束啦，冠军是人见人爱，花见花开的<color@1>{1}</color>','号外号外！星灵争霸传奇151~300级战区的登顶战结束啦，冠军是人见人爱，花见花开的#玩家名#','号外号外！星灵争霸传奇151~300级战区的登顶战结束啦，冠军是人见人爱，花见花开的#玩家名#'),(436,6,1,10,0,'号外号外！星灵争霸传奇301~400级战区的登顶战结束啦，冠军是人见人爱，花见花开的<color@1>{1}</color>','号外号外！星灵争霸传奇301~400级战区的登顶战结束啦，冠军是人见人爱，花见花开的#玩家名#','号外号外！星灵争霸传奇301~400级战区的登顶战结束啦，冠军是人见人爱，花见花开的#玩家名#'),(436,7,1,10,0,'号外号外！星灵争霸传奇401~500级战区的登顶战结束啦，冠军是人见人爱，花见花开的<color@1>{1}</color>','号外号外！星灵争霸传奇401~500级战区的登顶战结束啦，冠军是人见人爱，花见花开的#玩家名#','号外号外！星灵争霸传奇401~500级战区的登顶战结束啦，冠军是人见人爱，花见花开的#玩家名#'),(436,8,1,10,0,'各位尊敬的勇士，由于人数不足，本次星灵争霸活动取消！','各位尊敬的勇士，由于人数不足，本次星灵争霸活动取消！','各位尊敬的勇士，由于人数不足，本次星灵争霸活动取消！'),(440,1,1,10,0,'经过悉心调教，<color@0>{1}</color>的降神<color@2>{2}</color>成功进阶到{3}阶，战力直线飙升！<color@0><a@god>我要进阶</a></color>','经过悉心调教，玩家名的降神xxx成功进阶到N阶，战力直线飙升！我要进阶','经过悉心调教，玩家名的降神xxx成功进阶到N阶，战力直线飙升！我要进阶'),(450,1,2,10,0,'恭喜<color@0><a@player@{1}@{2}></a></color>激活<color@1>永久白银贵族</color>，可获得<color@0>10%</color>经验加成，<color@0>免费使用</color>小飞鞋传送','恭喜[玩家名称]激活体验贵族特权，获得10%经验加成，免费使用小飞鞋传送','恭喜[玩家名称]激活体验VIP，获得10%经验加成，免费使用小飞鞋传送'),(450,2,2,10,0,'恭喜<color@0><a@player@{1}@{2}></a></color>激活<color@1>VIP1贵族卡</color>，可永久获得<color@0>10%</color>经验加成，<color@0>无限使用</color>小飞鞋传送等特权','恭喜[玩家名称]激活VIP1贵族卡，可永久获得10%经验加成，无限使用小飞鞋传送等特权','恭喜[玩家名称]激活VIP1贵族卡，可永久获得10%经验加成，无限使用小飞鞋传送等特权'),(450,3,2,10,0,'恭喜<color@0><a@player@{1}@{2}></a></color>激活<color@1>VIP2贵族卡</color>，可永久获得<color@0>10%</color>经验加成，双倍签到奖励等特权','恭喜[玩家名称]激活VIP2贵族卡，可永久获得10%经验加成，双倍签到奖励等特权','恭喜[玩家名称]激活VIP2贵族卡，可永久获得10%经验加成，双倍签到奖励等特权'),(450,4,2,10,0,'恭喜<color@0><a@player@{1}@{2}></a></color>激活<color@1>VIP4贵族卡</color>，可永久获得<color@0>20%</color>经验加成，开启个人首领狩猎等特权','恭喜[玩家名称]激活VIP4贵族卡，可永久获得20%经验加成，开启个人首领狩猎等特权','恭喜[玩家名称]激活VIP4贵族卡，可永久获得20%经验加成，开启个人首领狩猎等特权'),(450,5,2,10,0,'恭喜<color@0><a@player@{1}@{2}></a></color>激活<color@1>贵族月度卡</color>，贵族<color@0>10%</color>经验加成，<color@0>无限使用</color>小飞鞋传送等特权时间增加30天！','恭喜[玩家名称]激活了贵族月度卡，贵族10%经验加成，无限使用小飞鞋传送等特权时间增加30天！','恭喜[玩家名称]激活了贵族月度卡，贵族10%经验加成，无限使用小飞鞋传送等特权时间增加30天！'),(450,6,2,10,0,'恭喜<color@0><a@player@{1}@{2}></a></color>激活<color@1>贵族季度卡</color>，贵族<color@0>10%</color>经验加成，双倍签到奖励等特权时间增加90天！','恭喜[玩家名称]激活了贵族季度卡，贵族10%经验加成，双倍签到奖励传送等特权时间增加90天！','恭喜[玩家名称]激活了贵族季度卡，贵族10%经验加成，双倍签到奖励传送等特权时间增加90天！'),(450,7,2,10,0,'恭喜<color@0><a@player@{1}@{2}></a></color>激活<color@1>贵族半年卡</color>，贵族<color@0>20%</color>经验加成，开启个人首领狩猎等特权时间增加180天！','恭喜[玩家名称]激活了贵族半年卡，贵族20%经验加成，开启个人首领狩猎等特权时间增加180天！','恭喜[玩家名称]激活了贵族半年卡，贵族20%经验加成，开启个人首领狩猎等特权时间增加180天！'),(450,8,1,10,0,'<color@1>{1}</color>开通了<color=#f0b30e>贵族4·半年卡</color>，成功晋升为华丽的<color=#fba65a>星界贵族</color>，真是羡煞旁人！','玩家开通了贵族4·半年卡，成功晋升为华丽的星界贵族，真是羡煞旁人！','玩家开通了贵族4·半年卡，成功晋升为华丽的星界贵族，真是羡煞旁人！'),(450,9,1,10,0,'BlingBling，恭喜<color@0><a@player@{1}@{2}></a></color>，激活了<color@1>白银贵族卡</color>，即刻享受<color=#f18310>经验加成</color>，<color=#f18310>免费传送</color>等众多特权，从此升级路上快人一步~','BlingBling，恭喜玩家XXXXXX，激活了贵族体验卡，即可享受获得经验加成，免费使用小飞鞋传送等众多特权，从此升级路上快人一步~','BlingBling，恭喜玩家XXXXXX，激活了贵族体验卡，即可享受获得经验加成，免费使用小飞鞋传送等众多特权，从此升级路上快人一步~'),(450,10,1,10,0,'哇呜，<color@0><a@player@{1}@{2}></a></color>成功激活了黄金VIP{3}！享受更高级的特权：<color=#f14041>增加经验副本购买次数</color>、<color=#f14041>VIP每周礼包</color>等~<a@vip><color=#f18310>前往开通</color></a>','哇呜，玩家XXXXXX在充值中成功激活了黄金VIP2！更高级的VIP，享受更高级的特权：经验副本、每周VIP福利礼包等~前往开通','哇呜，玩家XXXXXX在充值中成功激活了黄金VIP2！更高级的VIP，享受更高级的特权：经验副本、每周VIP福利礼包等~前往开通'),(450,11,1,10,0,'至尊之光再次闪耀，恭喜<color@0><a@player@{1}@{2}></a></color>成功晋升为<color@4>至尊VIP</color>！可永久享受<color@3>至尊专属商店</color>，<color@3>打BOSS免伤</color>等50+种实用特权！','至尊之光再次闪耀，恭喜XXXXX成功晋升为荣耀VIP！可永久享受每日粉钻兑换为钻石，免伤打BOSS等50+种实用特权！','至尊之光再次闪耀，恭喜XXXXX成功晋升为荣耀VIP！可永久享受每日绑钻兑换为钻石，免伤打BOSS等50+种实用特权！'),(450,12,1,10,0,'哇呜，<color@0><a@player@{1}@{2}></a></color>成功激活了<color@4>黄金VIP{3}</color>！享受更高级的特权：<color@3>增加经验副本购买次数</color>、<color@3>VIP每周礼包</color>等~<a@vip><color=#f18310>前往开通</color></a>','哇呜，玩家XXXXXX在充值中成功激活了黄金VIP3！更高级的VIP，享受更高级的特权：经验副本、每周VIP福利礼包等~前往开通','哇呜，玩家XXXXXX在充值中成功激活了黄金VIP3！更高级的VIP，享受更高级的特权：经验副本、每周VIP福利礼包等~前往开通'),(450,13,1,10,0,'哇呜，<color@0><a@player@{1}@{2}></a></color>成功激活了<color@4>黄金VIP{3}</color>！享受更高级的特权：<color@3>增加经验副本购买次数</color>、<color@3>VIP每周礼包</color>等~<a@vip><color=#f18310>前往开通</color></a>','哇呜，玩家XXXXXX在充值中成功激活了黄金VIP4！更高级的VIP，享受更高级的特权：经验副本、每周VIP福利礼包等~前往开通','哇呜，玩家XXXXXX在充值中成功激活了黄金VIP4！更高级的VIP，享受更高级的特权：经验副本、每周VIP福利礼包等~前往开通'),(460,1,1,10,0,'<color@2><a@player@{1}@{2}></a></color>在{3}与<color@2>{4}</color>大战三百回合，获得极品<color@3>{5}</color>阶<color@3>{6}</color>星装备<a@goods3@{7}@{8}@{9}></a>！','[玩家名称]在[场景名称]与[BOSS名称]大战三百回合，获得极品[物品名称]！','击杀BOSS掉落传闻\n<a@goods3@{4}@{5}@{6}></a>！goods3\n装备类型id，装备评分，极品属性，有超链接'),(460,2,1,10,0,'世界首领<color@2>{1}</color>已经苏醒，勇敢的冒险家们赶紧去讨伐吧！<a@scene3@{2}@{3}@{4}@{5}@{6}></a>','[BOSS名称]刷新啦，赶紧前往[场景名称]击杀BOSS吧。立即前往','BOSS刷新提示'),(460,3,1,10,0,'首领会所的领主<color@5>{1}</color>已经苏醒，勇敢的冒险家们赶紧去讨伐吧！<a@scene3@{2}@{3}@{4}@{5}@{6}></a>','[BOSS名称]刷新啦，赶紧前往[场景名称]击杀BOSS吧。立即前往','BOSS刷新提示'),(460,4,2,10,0,'混乱魔域的领主<color@2>{1}</color>已经苏醒，勇敢的冒险家们赶紧去讨伐吧！<a@scene3@{2}@{3}@{4}@{5}@{6}></a>','[BOSS名称]刷新啦，赶紧前往[场景名称]击杀BOSS吧。立即前往','BOSS刷新提示'),(460,5,2,10,0,'玩家<color@2><a@player@{1}@{2}></a></color>在{3}一言不合就出手，轻易斩杀<color@2>{4}</color>，真是个可怕的家伙！','玩家XXX在地名一言不合就出手，轻易斩杀XXX，真是个可怕的家伙！','玩家XXX在地名一言不合就出手，轻易斩杀XXX，真是个可怕的家伙！'),(460,6,1,10,0,'首领遗迹的领主<color@2>{1}</color>已经苏醒，勇敢的冒险家们赶紧去讨伐吧！<a@scene3@{2}@{3}@{4}@{5}@{6}></a>','[BOSS名称]刷新啦，赶紧前往[场景名称]击杀BOSS吧。立即前往','BOSS刷新提示'),(460,7,2,4,0,'<color@1><a@player@{1}@{2}></a></color>在{3}被<color@4><a@player@{4}@{5}></a></color>击杀，小伙伴们快来帮忙呀！<a@scene3@{6}@{7}@{8}@{9}></a>','[玩家名称]在[场景名称]被[玩家名称]击杀，小伙伴们快来帮忙呀！点击前往','BOSS公会求助'),(460,8,2,10,0,'哦豁，<color@1>{1}</color>参与击杀<color@2>{2}</color>的过程中，幸运的获得了<a@goods@{3}></a>，真是令人羡慕！','哦豁，XXX参与击杀BOSSS名的过程中，幸运获得了装备名，真是令人羡慕！','哦豁，XXX参与击杀BOSSS名的过程中，幸运获得了装备名，真是令人羡慕！'),(460,9,2,10,0,'<color@2><a@player@{1}@{2}></a></color>在{3}与<color@2>{4}</color>大战三百回合，获得了极品<a@goods3@{5}@{6}@{7}></a></a>！','[玩家名称]在[场景名称]与[BOSS名称]大战三百回合，获得极品[物品名称]！','[玩家名称]在[场景名称]与[BOSS名称]大战三百回合，获得极品[物品名称]！'),(461,1,1,10,0,'<color@2><a@player@{1}@{2}></a></color>在{3}与<color@2>{4}</color>大战三百回合，获得极品<a@goods3@{5}@{6}@{7}></a>！','[玩家名称]在[场景名称]与[BOSS名称]大战三百回合，获得极品[物品名称]！','击杀BOSS掉落传闻\n<a@goods3@{4}@{5}@{6}></a>！goods3\n装备类型id，装备评分，极品属性，有超链接'),(461,2,2,10,0,'跨服首领<color@2>{1}</color>已经苏醒，勇敢的冒险家们赶紧去讨伐吧！<a@scene3@{2}@{3}@{4}@{5}></a>','[BOSS名称]刷新啦，赶紧前往[场景名称]击杀BOSS吧。立即前往','BOSS刷新提示'),(461,3,1,10,0,'跨服首领<color@2>{1}</color>已经苏醒，勇敢的冒险家们赶紧去讨伐吧！<a@scene3@{2}@{3}@{4}@{5}></a>','[BOSS名称]刷新啦，赶紧前往[场景名称]击杀BOSS吧。立即前往','BOSS刷新提示'),(500,1,2,10,0,'<color@0>双倍护送</color>活动开始啦，现在护送可得<color@0>双倍</color>奖励，机不可失！','','双倍活动开始传闻'),(500,2,2,4,0,'<color@1><a@player@{1}@{2}></a></color>正在护送<color@{3}>{4}</color>，遭遇拦截，请求协助！<a@angel@{5}></a>','','护送求助传闻'),(500,3,2,10,0,'<color@1>{1}</color>在护送飞艇活动中接受了<color@3>皇家方舟</color>级飞空艇的护送任务！<a@husong@1004@1@23015@16134><color@0>我要护送</color></a>','','接取护送最高品质飞艇传闻'),(500,4,2,10,0,'<color@0>双倍护送</color>活动即将在<color@0>5</color>分钟后开始，请大家做好准备！','','双倍活动开始传闻'),(500,5,2,6,0,'<color@1><a@player@{1}@{2}></a></color>正在护送<color@{3}>{4}</color>，遭遇拦截，请求协助！<a@angel@{5}></a>','','护送求助'),(501,1,1,10,0,'荣耀战神活动已经开启啦！欢迎各位冒险家踊跃参与挑战！','',''),(501,2,2,4,0,'本公会在荣耀战神活动中位列{1}名，获得公会声望{2}','',''),(501,3,1,10,0,'<color@1>{1}</color>轻松完成<color@2>限时任务</color>，激活了<color@4>{2}</color>，战力蹭蹭往上涨！<a@limittarget><color@0>我也要激活！</color></a>','',''),(502,1,1,10,0,'<color@1>{1}</color>成功激活了专武<color@2>{2}</color>，犹如神力附体，战力狂飙停不下来！<color@1>{3}</color>级开启光武系统！','','激活专武传闻'),(502,2,1,10,0,'<color@1>{1}</color>激活了光武<color@2>{2}</color>，犹如天神下凡，跟他抢BOSS的人全都被打的不要不要的！<color@1><a@light_weapon>我也要激活！</a></color>','','激活任意光武传闻'),(502,3,1,10,0,'<color@1>{1}</color>成功将光武<color@2>{2}</color>提升到<color@1>{3}</color>星，打个响指，敌人灰飞烟灭！<color@1><a@light_weapon>我也要这么强！</a></color>','','提升任意光武星级传闻'),(503,1,1,10,0,'{1}英雄战场中连胜{2}人，主宰战场！谁与争锋！','',''),(601,1,1,10,1,'跨服服战正式打响，参赛选手们速速进场争夺为本服而战吧！','跨服服战正式打响，参赛选手们速速进场争夺为本服而战吧！','跨服服战正式打响，参赛选手们速速进场争夺为本服而战吧！'),(601,2,1,10,1,'本轮跨服服战已结束，请参赛选手们稍事休息，21：30分准时开启下一轮服战','本轮跨服服战已结束，请参赛选手们稍事休息，21：30分准时开启下一轮服战','本轮跨服服战已结束，请参赛选手们稍事休息，21：30分准时开启下一轮服战'),(601,3,1,10,1,'本届跨服服战正式结束，让大家为勇士们的英勇作战喝彩！','本届跨服服战正式结束，让大家为勇士们的英勇作战喝彩！','本届跨服服战正式结束，让大家为勇士们的英勇作战喝彩！'),(601,4,1,10,1,'{1}城已被攻方攻陷，胜不骄败不馁，勇士们继续奋战！','XX城已被攻方攻陷，胜不骄败不馁，勇士们继续奋战！','XX城已被攻方攻陷，胜不骄败不馁，勇士们继续奋战！'),(601,5,1,10,1,'{1}城已由守方牢牢控制，胜不骄败不馁，勇士们继续奋战！','XX城已由守方牢牢控制，胜不骄败不馁，勇士们继续奋战！','XX城已由守方牢牢控制，胜不骄败不馁，勇士们继续奋战！'),(601,6,1,10,1,'本服勇士们力克对手，获得本轮服战胜利，威名远播！','本服勇士们力克对手，获得本轮服战胜利，威名远播！','本服勇士们力克对手，获得本轮服战胜利，威名远播！'),(603,1,1,10,1,'幻兽入侵<color@1>5</color>分钟后即将开启，<color@1>{1}</color>级以上的勇士们均可加入战斗，赢取海量稀有极品奖励！','幻兽入侵5分钟后即将开启，100级以上的勇士们均可加入战斗，赢取海量稀有极品奖励！',''),(603,2,1,10,1,'幻兽入侵已开启，<color@1>{1}</color>级以上的勇士们均可加入战斗，赢取海量稀有极品奖励！','',''),(603,3,1,10,1,'古遗址_{1}  中的入侵幻兽已被勇士们成功击杀，<color@1><a@player@{2}@{3}></a></color>给予了幻兽最后一击，获得了<a@goods2@{4}></a>！','场景名_房间号  的入侵幻兽已被勇士们成功击杀，AAA在给予了幻兽最后一击，获得了XXX（最后一击奖励物品）！',''),(603,4,1,10,1,'恭喜<color@1><a@player@{1}@{2}></a></color>夺得本场战斗的伤害第一名，赢得了海量极品奖励！','恭喜BBB夺得本场战斗的伤害第一名，赢得了海量极品奖励！',''),(604,1,1,10,0,'三英会战<color@1>{1}</color>分钟后即将开启，<color@1>{2}</color>级以上的勇士们可参与战斗，<color@1>海量奖励</color>等你拿！','',''),(604,2,1,10,0,'跨服三英会战<color@1>{1}</color>分钟后即将开启，<color@1>{2}</color>级以上的勇士们可参与战斗，<color@1>海量奖励</color>等你拿！','',''),(604,3,1,10,0,'三英会战已开启，<color@1>{1}</color>级以上的勇士们可参与战斗，<color@1>海量奖励</color>等你拿！','',''),(604,4,1,10,0,'跨服三英会战已开启，<color@1>{1}</color>级以上的勇士们可参与战斗，<color@1>海量奖励</color>等你拿！','',''),(604,5,1,10,0,'三英会战已结束，敬请关注下次活动！','',''),(604,6,1,10,0,'跨服三英会战已结束，敬请关注下次活动！','',''),(604,7,1,3,0,'三英会战中,<color@1>{1}</color>勇冠星界，大杀四方，完成<color@3>{2}</color>连杀！','',''),(604,8,1,3,0,'三英会战中,<color@1>{1}</color>势不可挡，完成<color@3>{2}</color>连杀！','',''),(604,9,1,3,0,'三英会战中,<color@1>{1}</color>横空出世，终结了 <color@1>{2}</color>的<color@3>{3}</color>连杀！','',''),(604,10,2,3,0,'<color@1>{1}</color>已被<color@2>{2}</color>占领！','中路塔已被XXX玩家占领！',''),(604,11,2,3,0,'<color@2>{2}</color> 已被<color@2>{1}</color> 击杀！','XXX玩家已被 XXX玩家击杀！',''),(604,12,2,3,0,'<color@1>{1}</color>已被<color@2>{2}</color>拾取！','加速buff已被XXX玩家拾取！',''),(604,13,2,3,0,'请注意！！！强大的宝箱buff已刷出！快快前往拾取，获得强力提升！！！','',''),(604,14,2,3,0,'反击的号角已经吹响，落后阵营的全体玩家，获得反击buff提升，开始全力反击吧！！！','',''),(605,1,1,10,0,'荣耀战神将于5分钟后开始，各位勇士请做好准备，大量珍稀资源等你拿！','荣耀战神将于5分钟后开始，各位勇士请做好准备，大量珍稀资源等你拿！','荣耀战神将于5分钟后开始，各位勇士请做好准备，大量珍稀资源等你拿！'),(605,2,1,10,0,'荣耀战神活动正式开始，勇士们可前往参与战斗，争取海量奖励！~<color@1><a@war_god>前往活动</a></color>','荣耀战神活动正式开始，勇士们可前往参与战斗，争取海量奖励！','荣耀战神活动正式开始，勇士们可前往参与战斗，争取海量奖励！'),(605,3,1,10,0,'本次荣耀战神活动已结束，敬请期待下次活动！','本次荣耀战神活动已结束，敬请期待下次活动！','本次荣耀战神活动已结束，敬请期待下次活动！'),(605,4,2,10,0,'本次荣耀战神，{1}勇冠三界，获得总伤害第1名！','本次荣耀战神，#公会名称#勇冠三界，获得总伤害第1名！','本次荣耀战神，#公会名称#勇冠三界，获得总伤害第1名！'),(605,5,2,10,0,'本次荣耀战神，{1}神勇无敌，获得总伤害第2名！','本次荣耀战神，#公会名称#神勇无敌，获得总伤害第2名！','本次荣耀战神，#公会名称#神勇无敌，获得总伤害第2名！'),(605,6,2,10,0,'本次荣耀战神，{1}众志成城，获得总伤害第3名！','本次荣耀战神，#公会名称#众志成城，获得总伤害第3名！','本次荣耀战神，#公会名称#众志成城，获得总伤害第3名！'),(605,7,2,10,0,'本次荣耀战神，{1}傲世寰宇，无人能匹！获得个人伤害排名第1名！活动珍惜称号<a@goods5@{2}></a>！','本次荣耀战神，#玩家名称#傲世寰宇，无人能匹！获得个人伤害排名第1名！活动珍惜称号#屠龙勇士#！','本次荣耀战神，#玩家名称#傲世寰宇，无人能匹！获得个人伤害排名第1名！活动珍惜称号#屠龙勇士#！'),(605,8,2,4,0,'全军出击！荣耀战神活动开启了，公会的成员们快来抢伤害！<color@1><a@war_god>前往活动</a></color>','全军出击！荣耀战神活动开启了，公会的成员们快来抢伤害！前往参与','全军出击！荣耀战神活动开启了，公会的成员们快来抢伤害！前往参与'),(606,1,1,10,0,'丛林突围<color@1>{1}</color>分钟后即将开启，<color@1>{2}</color>级以上的勇士们可参与战斗，<color@1>海量奖励</color>等你拿！','',''),(606,2,1,10,0,'跨服丛林突围<color@1>{1}</color>分钟后即将开启，<color@1>{2}</color>级以上的勇士们可参与战斗，<color@1>海量奖励</color>等你拿！','',''),(606,3,1,10,0,'丛林突围已开启，<color@1>{1}</color>级以上的勇士们可参与战斗，<color@1>海量奖励</color>等你拿！','',''),(606,4,1,10,0,'跨服丛林突围已开启，<color@1>{1}</color>级以上的勇士们可参与战斗，<color@1>海量奖励</color>等你拿！','',''),(606,5,1,10,0,'丛林突围已结束，敬请关注下次活动！','',''),(606,6,1,10,0,'跨服丛林突围已结束，敬请关注下次活动！','',''),(606,7,1,3,0,'丛林突围中,<color@1>{1}</color>勇冠星界，大杀四方，完成<color@3>{2}</color>连杀！','',''),(606,8,1,3,0,'丛林突围中,<color@1>{1}</color>势不可挡，完成<color@3>{2}</color>连杀！','',''),(606,9,1,3,0,'丛林突围中,<color@1>{1}</color>横空出世，终结了 <color@1>{2}</color>的<color@3>{3}</color>连杀！','',''),(607,1,2,3,0,'攻击据点雕像，可以获得高额积分','攻击复活点和海神雕像，可以获得高额积分','攻击复活点和海神雕像，可以获得高额积分'),(607,2,2,3,0,'活动结束时，占领两个以上据点的公会，将获最终胜利！','占领中央海神雕像的公会，将获最终胜利！','占领中央海神雕像的公会，将获最终胜利！'),(607,3,2,3,0,'占领左右据点，可以更快速前往王者据点战斗！','占领复活点，可以更快速前往海神像战斗！','占领复活点，可以更快速前往海神像战斗！'),(607,4,2,3,0,'在刷怪点殴打小怪，可以获得积分哦！','在刷怪点殴打小怪，有积分和资源点哦！','在刷怪点殴打小怪，有积分和资源点哦！'),(607,5,2,3,0,'<color@1>{1}</color>在战场上所向披靡，已经达到{2}人斩！','#玩家名#在战场上所向披靡，已经达到xx人斩！','#玩家名#在战场上所向披靡，已经达到xx人斩！'),(607,6,2,3,0,'<color@1>{1}</color>在战场上所向披靡，已经无人能挡了','#玩家名#在战场上所向披靡，已经无人能挡了','#玩家名#在战场上所向披靡，已经无人能挡了'),(607,7,2,3,0,'<color@2>{1}</color>公会势如破竹，占领了<color@1>{2}</color>，谁敢争锋？','XX公会势如破竹，占领了XXX，谁敢争锋？','XX公会势如破竹，占领了XXX，谁敢争锋？'),(607,8,1,10,0,'<color@2>{1}</color>服的公会<color@2>{2}</color>势不可挡，所向披靡，最终占领了<color@1>{3}</color>，大家一起膜拜吧！','XX服的公会xx势不可挡，所向披靡，最终占领了领地名，大家一起膜拜吧！','XX服的公会xx势不可挡，所向披靡，最终占领了领地名，大家一起膜拜吧！'),(607,9,1,10,0,'<color@2>无尽海域</color>已经开始宣战了，各位大佬赶紧宣战领地吧！<color@0><a@kftown>前往宣战</a></color>','跨服城战已经开始宣战了，各位大佬赶紧宣战领地吧！','跨服城战已经开始宣战了，各位大佬赶紧宣战领地吧！'),(607,10,2,4,0,'<color@2>无尽海域</color>已经开始宣战了，各位大佬赶紧宣战领地吧！<color@0><a@kftown>前往宣战</a></color>','跨服城战已经开始宣战了，各位大佬赶紧宣战领地吧！','跨服城战已经开始宣战了，各位大佬赶紧宣战领地吧！'),(607,11,1,10,0,'<color@2>无尽海域</color>已经开始,各位勇士赶紧前往战场,抢钱，抢地,抢抢抢吧！<color@0><a@kftown>前往战场</a></color>','跨服城战已经开始,各位勇士赶紧前往战场,抢钱，抢地,抢抢抢吧！','跨服城战已经开始,各位勇士赶紧前往战场,抢钱，抢地,抢抢抢吧！'),(607,12,2,4,0,'<color@2>无尽海域</color>已经开始,各位勇士赶紧前往战场,抢钱，抢地,抢抢抢吧！<color@0><a@kftown>前往战场</a></color>','跨服城战已经开始,各位勇士赶紧前往战场,抢钱，抢地,抢抢抢吧！','跨服城战已经开始,各位勇士赶紧前往战场,抢钱，抢地,抢抢抢吧！'),(607,13,2,4,0,'本公会成功宣战了领地<color@2>{1}</color> ,大家一起去应援吧！<color@0><a@kftownassist@{2}>前往应援</a></color>','本公会成功宣战了领地XX,大家一起去应援吧！','本公会成功宣战了领地XX,大家一起去应援吧！'),(607,14,2,3,0,'<color@1>海盗船</color>已在战场中刷新，击沉海盗船可以获得强力buff','海盗船已在战场中刷新，击沉海盗船可以获得强力buff','海盗船已在战场中刷新，击沉海盗船可以获得强力buff'),(607,15,2,3,0,'<color@1>{1}</color>公会的<color@1>{2}</color>击杀了海盗领主，全体公会成员获得强力buff：<color@2>伤害＋20%</color>！','#公会名#的#玩家名#击杀了海盗领主，全体公会成员获得强力buff：伤害＋20%！','#公会名#的#玩家名#击杀了海盗领主，全体公会成员获得强力buff：伤害＋20%！'),(609,1,1,10,0,'跨服入侵已开启，<color@1>{1}</color>级以上的冒险者们可参与为服务器而战，<color@1>海量服务器积分</color>等你拿！ <color@0><a@kfinvade@{2}@{3}>立即前往</a></color>','',''),(609,2,1,10,0,'惊不惊喜，<color@0>s{1}服务器</color>的魔王真身被击败，掉落了大量<color@2>魔王宝箱</color>，海量奖励等你去抢！ <color@0><a@kfinvade@{2}@{3}>立即前往</a></color>','',''),(609,3,1,10,0,'警报!魔王军团来袭!击败魔王军团,将会为冒险者所在服务器赢取<color@1>海量奖励</color>! <color@0><a@kfinvade@{1}@{2}>立即前往</a></color>','',''),(609,4,1,10,0,'<color@1>【跨服入侵】</color>魔王真身降临在<color@0>s{1}服务器</color> ，击杀魔王真身可获得巨额服务器积分奖励，伤害越高，积分越多哦。为了服务器而战吧！<color@0><a@kfinvade@{2}@{3}>立即前往</a></color>','',''),(609,5,1,10,0,'<color@0>s{1}服</color>的<color@1>{2}</color>在<color@0>跨服入侵s{3}服</color>中勇冠三界，大杀四方，完成<color@3>{4}</color>连杀！ <color@0><a@kfinvade@{5}@{6}>立即前往</a></color>','',''),(609,6,1,10,0,'<color@0>s{1}服</color>的<color@1>{2}</color>在<color@0>跨服入侵s{3}服</color>中逆天弑神，傲视寰宇，完成<color@3>{4}</color>连杀！ <color@0><a@kfinvade@{5}@{6}>立即前往</a></color>','',''),(609,7,1,10,0,'<color@1>【跨服入侵】</color>可喜可贺，<color@0>s{1}服</color>在上一个小时<color@0>跨服入侵</color>活动中服务器积分榜位列第一名！<color@0><a@kfinvade@{2}@{3}>立即前往</a></color>','',''),(609,8,1,10,0,'今日<color@0>跨服入侵</color>已结束，<color@0>s{1}服</color>获得服务器积分榜第一名，大家掌声响起来，啪啪啪！','',''),(609,9,1,10,0,'<color@1>【跨服入侵】</color>魔王军团<color@1>{1}</color>分钟后即将开启，<color@1>{2}</color>级以上的冒险者可参与战斗，<color@1>海量奖励</color>等你拿！','',''),(609,10,1,10,0,'<color@1>【跨服入侵】</color>魔王真身{1}秒降临在<color@0>s{2}服务器</color> ，击杀魔王真身可获得巨额服务器积分奖励，为了服务器而战吧！<color@0><a@kfinvade@{3}@{4}>立即前往</a></color>','',''),(610,1,1,10,0,'<color@1><a@player@{1}@{2}></a></color>在{3}副本中获得极品装备<a@goods3@{4}@{5}@{6}></a>，缘分到了一切都是这么简单~','小敏熊在诛邪战场副本中获得极品装备大刀，缘分到了一切都是这么简单~',''),(621,1,1,10,0,'各位勇者，跨服1VN已经开启！多重奖励等你来拿！老铁，嗨起来！<color@1><a@kf1vnbet>查看活动</a></color>','各位勇者，跨服1VN已经开启！多重奖励等你来拿！老铁，嗨起来！查看活动','各位勇者，跨服1VN已经开启！多重奖励等你来拿！老铁，嗨起来！查看活动'),(621,2,2,10,0,'本届跨服1VN守擂赛未出现最终获胜擂主，请各位继续努力','本届跨服1VN守擂赛未出现最终获胜擂主，请各位继续努力','本届跨服1VN守擂赛未出现最终获胜擂主，请各位继续努力'),(621,3,1,10,0,'号外号外！<color@2>跨服1VN</color>的资格赛结束啦，共有<color@1>{1}</color>人成为擂主','号外号外！跨服1VN的资格赛结束啦，共有N人成为擂主','号外号外！跨服1VN的资格赛结束啦，共有N人成为擂主'),(621,4,1,10,0,'号外号外！<color@2>跨服1VN</color>的资格赛结束啦，共有<color@1>{1}</color>人成为擂主','号外号外！跨服1VN的资格赛结束啦，共有N人成为擂主','号外号外！跨服1VN的资格赛结束啦，共有N人成为擂主'),(621,5,1,10,0,'各位勇者，跨服1VN将于5分钟后开启！一大波奖励即将来袭，请各位做好准备，还没报名的速速报名啦！<color@1><a@kf1vnbet>查看活动</a></color>','各位勇者，跨服1VN将于5分钟后开启！一大波奖励即将来袭，请各位做好准备，还没报名的速速报名啦！查看活动','各位勇者，跨服1VN将于5分钟后开启！一大波奖励即将来袭，请各位做好准备，还没报名的速速报名啦！查看活动'),(621,6,1,10,0,'号外号外！<color@2>跨服1VN</color>的守擂赛结束啦，最终的擂主为<color@1>{1}</color>','号外号外！跨服1VN的守擂赛结束啦，最终的擂主为XXX、XXX','号外号外！跨服1VN的守擂赛结束啦，最终的擂主为XXX、XXX'),(621,7,1,10,0,'号外号外！<color@2>跨服1VN</color>的守擂赛结束啦，最终的擂主为<color@1>{1}</color>','号外号外！跨服1VN的守擂赛结束啦，最终的擂主为XXX、XXX','号外号外！跨服1VN的守擂赛结束啦，最终的擂主为XXX、XXX'),(621,8,2,10,0,'本届跨服1VN守擂赛未出现最终获胜擂主，请各位继续努力','本届跨服1VN守擂赛未出现最终获胜擂主，请各位继续努力','本届跨服1VN守擂赛未出现最终获胜擂主，请各位继续努力'),(621,9,1,10,0,'由于报名人数不足，本届跨服1VN活动暂不开启，敬请期待下一次活动！','',''),(621,10,1,10,0,'跨服1VN合区通告：由于传奇1-200级战区报名人数较少，将合并至传奇201-500级战区！！','',''),(621,11,1,3,0,'<color@2>跨服1VN</color>守擂赛即将开启，请各位认准大腿，迅速进行竞猜下注！<color@1><a@kf1vnguess>点击竞猜</a></color>','',''),(621,12,1,3,0,'<color@2>跨服1VN</color>守擂赛即将开启，请各位认准大腿，迅速进行竞猜下注！<color@1><a@kf1vnguess>点击竞猜</a></color>','',''),(621,13,1,3,0,'擂主<color@1>{1}</color>在守擂赛<color@2>第5轮</color>中大杀四方，赢得了胜利','擂主<color@1>玩家名字</color>在守擂赛<color@2>第5轮</color>中大杀四方，赢得了胜利',''),(621,14,1,3,0,'擂主<color@1>{1}</color>在守擂赛<color@2>第6轮</color>中大杀四方，赢得了胜利，距离最终胜利更近了一步','',''),(621,15,1,3,0,'擂主<color@1>{1}</color>在守擂赛<color@2>第7轮</color>中所向披靡，赢得了最终胜利！！！','',''),(646,1,1,10,0,'野外首领活动已经结束！','',''),(646,2,1,10,0,'{1}的野外首领已经全部被击杀！','XX场景的野外首领已经全部被击杀！',''),(646,3,1,10,0,'野外领主已经现身，冒险家们狩猎的时间开始！','',''),(647,1,1,4,0,'公会试炼活动将在5分钟后开启，各位成员做好准备！','',''),(647,2,1,4,0,'公会试炼活动已开启！请各位成员积极参与试炼挑战！','',''),(647,3,2,10,0,'{1}已降临到{2}区域，各位成员请注意！总攻击时间！','Boss名XX已降临到XX区域，全体进攻！','Boss名XX已降临到XX区域，全体进攻！'),(647,4,2,4,0,'{1}已到达战场，大家一起围殴他吧！','BOSS名XXX已到达战场，全体进攻！','BOSS名XXX已到达战场，全体进攻！'),(647,5,2,4,0,'本公会在试炼活动中击杀了<color@1>{1}</color>，获得公会声望<color@1>{2}</color>','本公会在试炼活动中击杀了XXX（BOSS名），获得公会声望XXX','本公会在试炼活动中击杀了XXX（BOSS名），获得公会声望XXX'),(647,6,2,4,0,'公会试炼活动已结束，辛苦大家了。我们下一次在一起战斗吧！','公会试炼活动已结束，辛苦大家了。我们下一次在一起战斗吧！','公会试炼活动已结束，辛苦大家了。我们下一次在一起战斗吧！'),(647,7,2,10,0,'{1}已降临到{2}区域，各位成员请注意！总攻击时间！','Boss名XX已降临到XX区域，各位成员请注意！总攻击时间！','Boss名XX已降临到XX区域，各位成员请注意！总攻击时间！'),(650,1,2,3,0,'<color@1>{1}</color>已被<color@2>{2}</color>占领！','中路塔已被XXX玩家占领！',''),(650,2,2,3,0,'<color@2>{2}</color> 已被<color@2>{1}</color> 击杀！','XXX玩家已被 XXX玩家击杀！',''),(650,3,1,11,0,'<color@1>{1}</color>正在招募队友，快来参加跨服3V3吧！<color@3><a@kf3v3@{2}@{3}>点我加入</a></color>','正在招募队友，快来参加跨服3V3吧！点我加入',''),(650,4,1,4,0,'<color@1>{1}</color>正在招募队友，快来参加跨服3V3吧！<color@3><a@kf3v3@{2}@{3}>点我加入</a></color>','正在招募队友，快来参加跨服3V3吧！点我加入',''),(650,5,2,3,0,'<color@1>{1}</color>已被<color@2>{2}</color>拾取！','加速buff已被XXX玩家拾取！',''),(650,6,1,3,0,'请注意！！！流弊buff<color@1>{1}</color>、<color@1>{2}</color>已刷出！先到先得哦','',''),(650,7,2,3,0,'<color@2>{1}</color>完成<color@2>{2}</color>连杀！','','');
/*!40000 ALTER TABLE `base_language_extra` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_language_format`
--

DROP TABLE IF EXISTS `base_language_format`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_language_format` (
  `key` varchar(50) NOT NULL DEFAULT '' COMMENT 'key',
  `format` varchar(255) NOT NULL DEFAULT '' COMMENT '格式',
  `remark` varchar(255) NOT NULL DEFAULT '' COMMENT '备注',
  PRIMARY KEY (`key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='传闻格式';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_language_format`
--

LOCK TABLES `base_language_format` WRITE;
/*!40000 ALTER TABLE `base_language_format` DISABLE KEYS */;
INSERT INTO `base_language_format` VALUES ('goods','<a@goods@物品类型id></a>','');
/*!40000 ALTER TABLE `base_language_format` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_league_war`
--

DROP TABLE IF EXISTS `base_league_war`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_league_war` (
  `league_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '阵营id',
  `birth_coordinate` varchar(255) NOT NULL DEFAULT '[]' COMMENT '出生坐标',
  PRIMARY KEY (`league_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='阵营配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_league_war`
--

LOCK TABLES `base_league_war` WRITE;
/*!40000 ALTER TABLE `base_league_war` DISABLE KEYS */;
INSERT INTO `base_league_war` VALUES (1,'[{3300,3700,600}]'),(2,'[{5300,18400,600}]'),(3,'[{17500,9300,600}]');
/*!40000 ALTER TABLE `base_league_war` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_league_war_beat_back_buff`
--

DROP TABLE IF EXISTS `base_league_war_beat_back_buff`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_league_war_beat_back_buff` (
  `refresh_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '刷新id',
  `next_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '下一个波刷新id',
  `interval_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '间隔时间',
  `duration` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'buff持续时间',
  `skill_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能id',
  `skill_lv` varchar(255) NOT NULL DEFAULT '[]' COMMENT '技能等级',
  PRIMARY KEY (`refresh_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='反击buff配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_league_war_beat_back_buff`
--

LOCK TABLES `base_league_war_beat_back_buff` WRITE;
/*!40000 ALTER TABLE `base_league_war_beat_back_buff` DISABLE KEYS */;
INSERT INTO `base_league_war_beat_back_buff` VALUES (1,2,60,30,3100000005,'[{0,2},{1,1}]'),(2,3,120,30,3100000005,'[{0,2},{1,1}]'),(3,4,180,30,3100000005,'[{0,2},{1,1}]'),(4,5,240,30,3100000005,'[{0,2},{1,1}]'),(5,6,300,30,3100000005,'[{0,2},{1,1}]'),(6,7,360,30,3100000005,'[{0,2},{1,1}]'),(7,8,420,30,3100000005,'[{0,2},{1,1}]'),(8,9,480,30,3100000005,'[{0,2},{1,1}]'),(9,10,540,30,3100000005,'[{0,2},{1,1}]'),(10,11,600,30,3100000005,'[{0,2},{1,1}]'),(11,12,660,30,3100000005,'[{0,2},{1,1}]'),(12,13,720,30,3100000005,'[{0,2},{1,1}]'),(13,14,780,30,3100000005,'[{0,2},{1,1}]'),(14,15,840,30,3100000005,'[{0,2},{1,1}]'),(15,16,900,30,3100000005,'[{0,2},{1,1}]'),(16,17,960,30,3100000005,'[{0,2},{1,1}]'),(17,18,1020,30,3100000005,'[{0,2},{1,1}]'),(18,19,1080,30,3100000005,'[{0,2},{1,1}]'),(19,20,1140,30,3100000005,'[{0,2},{1,1}]'),(20,21,1200,30,3100000005,'[{0,2},{1,1}]'),(21,22,1260,30,3100000005,'[{0,2},{1,1}]'),(22,23,1320,30,3100000005,'[{0,2},{1,1}]'),(23,24,1380,30,3100000005,'[{0,2},{1,1}]'),(24,0,1440,30,3100000005,'[{0,2},{1,1}]');
/*!40000 ALTER TABLE `base_league_war_beat_back_buff` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_league_war_buff_skill`
--

DROP TABLE IF EXISTS `base_league_war_buff_skill`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_league_war_buff_skill` (
  `mon_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '宝箱id',
  `skill_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能id',
  PRIMARY KEY (`mon_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='buff技能配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_league_war_buff_skill`
--

LOCK TABLES `base_league_war_buff_skill` WRITE;
/*!40000 ALTER TABLE `base_league_war_buff_skill` DISABLE KEYS */;
INSERT INTO `base_league_war_buff_skill` VALUES (58110017,3100000001),(58110018,3100000002),(58110019,3100000003);
/*!40000 ALTER TABLE `base_league_war_buff_skill` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_league_war_buff_treasure`
--

DROP TABLE IF EXISTS `base_league_war_buff_treasure`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_league_war_buff_treasure` (
  `refresh_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '刷新id',
  `next_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '下一个波刷新id',
  `interval_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '间隔时间',
  `buff_skill` varchar(255) NOT NULL DEFAULT '[]' COMMENT '技能',
  `coordinate` varchar(255) NOT NULL DEFAULT '[]' COMMENT '生成坐标',
  PRIMARY KEY (`refresh_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='buff宝箱配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_league_war_buff_treasure`
--

LOCK TABLES `base_league_war_buff_treasure` WRITE;
/*!40000 ALTER TABLE `base_league_war_buff_treasure` DISABLE KEYS */;
INSERT INTO `base_league_war_buff_treasure` VALUES (1,2,180,'[{3500,58110017},{3500,58110018},{3000,58110019}]','[{4800,10800},{11600,13300},{10000,6800}]'),(2,3,360,'[{3500,58110017},{3500,58110018},{3000,58110019}]','[{4800,10800},{11600,13300},{10000,6800}]'),(3,4,540,'[{3500,58110017},{3500,58110018},{3000,58110019}]','[{4800,10800},{11600,13300},{10000,6800}]'),(4,5,720,'[{3500,58110017},{3500,58110018},{3000,58110019}]','[{4800,10800},{11600,13300},{10000,6800}]'),(5,6,900,'[{3500,58110017},{3500,58110018},{3000,58110019}]','[{4800,10800},{11600,13300},{10000,6800}]'),(6,7,1080,'[{3500,58110017},{3500,58110018},{3000,58110019}]','[{4800,10800},{11600,13300},{10000,6800}]'),(7,8,1260,'[{3500,58110017},{3500,58110018},{3000,58110019}]','[{4800,10800},{11600,13300},{10000,6800}]'),(8,0,1440,'[{3500,58110017},{3500,58110018},{3000,58110019}]','[{4800,10800},{11600,13300},{10000,6800}]');
/*!40000 ALTER TABLE `base_league_war_buff_treasure` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_league_war_const_cfg`
--

DROP TABLE IF EXISTS `base_league_war_const_cfg`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_league_war_const_cfg` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号ID',
  `key` varchar(50) NOT NULL DEFAULT '' COMMENT '键',
  `value` varchar(256) NOT NULL DEFAULT '[]' COMMENT '值',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '描述@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=33 DEFAULT CHARSET=utf8 COMMENT='键值对常量配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_league_war_const_cfg`
--

LOCK TABLES `base_league_war_const_cfg` WRITE;
/*!40000 ALTER TABLE `base_league_war_const_cfg` DISABLE KEYS */;
INSERT INTO `base_league_war_const_cfg` VALUES (1,'anger_limit','10','怒气值上限'),(2,'anger_percentage_gain','1','每点怒气值提供百分比属性加成'),(3,'die_add_anger','1','每次死亡增加的怒气值'),(4,'fight_ready_time','30','战斗准备时间(秒)'),(5,'free_rebirth_time','10','免费复活时间(秒)'),(6,'kf_scene','5812','跨服场景'),(7,'protect_time','3','复活保护时间(秒)'),(8,'end_clear_time','20','结算时间(秒)'),(11,'local_scene','5811','本服场景'),(12,'occupy_own_num','2','占领据点数量，用于判断触发反击buff'),(13,'open_day_to_kf','10','开服多少天后进入跨服'),(14,'open_kf_need_wlv','310','开启跨服需要的世界等级'),(15,'open_lv','140','玩家进入活动的等级要求'),(16,'rank_score_limit','50','个人积分榜阈值'),(17,'rebirth_cost','5','复活需要的钻石'),(18,'ref_in_own_time','5','据点增加占领积分的时间间隔(秒)'),(19,'ref_own_time','5','据点列表定时器间隔(秒)'),(20,'ref_role_rank_time','1','个人积分排行榜定时器间隔(秒)'),(21,'rooms_pool_id','5','多少房间一个pool_id'),(22,'room_people_limit','30','房间人数上限'),(23,'score_rank_len','10','个人积分排行榜长度'),(24,'buff_disappear_time','60','BUFF宝箱自动消失时间（秒）'),(25,'anger_buff_id','3100000006','怒气buff技能ID'),(26,'kill_news_number_1','[5,10]','连杀传闻杀人数（势不可挡）'),(27,'kill_news_number_2','[15,20,50]','连杀传闻杀人数（勇冠星界）'),(28,'end_kill_number','5','终结传闻'),(29,'ref_online_score_time','5','挂机积分增加时间间隔'),(30,'reset_hp_rate','50','据点重置血量回复百分比'),(31,'client_reward_display','[{0,24010001,1},{0,24010002,1},{0,24010003,1},{0,17010001,1}]','参与奖励展示'),(32,'client_team_reward_display','[{0,17010001,1},{0,38260001,1},{0,24020001,1},{0,17020001,1}]','团队奖励展示');
/*!40000 ALTER TABLE `base_league_war_const_cfg` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_league_war_inner_rank_reward`
--

DROP TABLE IF EXISTS `base_league_war_inner_rank_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_league_war_inner_rank_reward` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励id',
  `min_wlv` smallint(4) unsigned NOT NULL DEFAULT '0' COMMENT '最小世界等级',
  `max_wlv` smallint(4) unsigned NOT NULL DEFAULT '0' COMMENT '最大世界等级',
  `is_win` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否为获胜阵营',
  `min_rank` smallint(4) unsigned NOT NULL DEFAULT '0' COMMENT '奖励最小排名',
  `max_rank` smallint(4) unsigned NOT NULL DEFAULT '0' COMMENT '奖励最大排名',
  `rewards` varchar(128) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='阵营内排名奖励配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_league_war_inner_rank_reward`
--

LOCK TABLES `base_league_war_inner_rank_reward` WRITE;
/*!40000 ALTER TABLE `base_league_war_inner_rank_reward` DISABLE KEYS */;
INSERT INTO `base_league_war_inner_rank_reward` VALUES (1,1,200,1,1,1,'[{0,4918003,1},{0,38260001,20},{0,38260002,2}]'),(2,201,260,1,1,1,'[{0,4918003,1},{0,38260001,20},{0,38260002,2}]'),(3,261,320,1,1,1,'[{0,4918003,1},{0,38260001,30},{0,38260002,2}]'),(4,321,350,1,1,1,'[{0,4918003,1},{0,38260001,30},{0,38260002,2}]'),(5,351,370,1,1,1,'[{0,4918003,1},{0,38260001,40},{0,38260002,2}]'),(6,371,390,1,1,1,'[{0,4918003,1},{0,38260001,40},{0,38260002,2}]'),(7,391,430,1,1,1,'[{0,4918003,1},{0,38260001,50},{0,38260002,2}]'),(8,431,500,1,1,1,'[{0,4918003,1},{0,38260001,50},{0,38260002,2}]'),(9,501,560,1,1,1,'[{0,4918003,1},{0,38260001,60},{0,38260002,2}]'),(10,561,610,1,1,1,'[{0,4918003,1},{0,38260001,60},{0,38260002,2}]'),(11,611,660,1,1,1,'[{0,4918003,1},{0,38260001,60},{0,38260002,2}]'),(12,661,750,1,1,1,'[{0,4918003,1},{0,38260001,60},{0,38260002,2}]'),(13,751,1000,1,1,1,'[{0,4918003,1},{0,38260001,60},{0,38260002,2}]'),(14,1,200,1,2,3,'[{0,4918002,1},{0,38260001,16},{0,38260002,1}]'),(15,201,260,1,2,3,'[{0,4918002,1},{0,38260001,16},{0,38260002,1}]'),(16,261,320,1,2,3,'[{0,4918002,1},{0,38260001,24},{0,38260002,1}]'),(17,321,350,1,2,3,'[{0,4918002,1},{0,38260001,24},{0,38260002,1}]'),(18,351,370,1,2,3,'[{0,4918002,1},{0,38260001,32},{0,38260002,1}]'),(19,371,390,1,2,3,'[{0,4918002,1},{0,38260001,32},{0,38260002,1}]'),(20,391,430,1,2,3,'[{0,4918002,1},{0,38260001,40},{0,38260002,1}]'),(21,431,500,1,2,3,'[{0,4918002,1},{0,38260001,40},{0,38260002,1}]'),(22,501,560,1,2,3,'[{0,4918002,1},{0,38260001,48},{0,38260002,1}]'),(23,561,610,1,2,3,'[{0,4918002,1},{0,38260001,48},{0,38260002,1}]'),(24,611,660,1,2,3,'[{0,4918002,1},{0,38260001,48},{0,38260002,1}]'),(25,661,750,1,2,3,'[{0,4918002,1},{0,38260001,48},{0,38260002,1}]'),(26,751,1000,1,2,3,'[{0,4918002,1},{0,38260001,48},{0,38260002,1}]'),(27,1,200,0,1,3,'[{0,4918001,1},{0,38260001,14},{0,38260002,1}]'),(28,201,260,0,1,3,'[{0,4918001,1},{0,38260001,14},{0,38260002,1}]'),(29,261,320,0,1,3,'[{0,4918001,1},{0,38260001,21},{0,38260002,1}]'),(30,321,350,0,1,3,'[{0,4918001,1},{0,38260001,21},{0,38260002,1}]'),(31,351,370,0,1,3,'[{0,4918001,1},{0,38260001,28},{0,38260002,1}]'),(32,371,390,0,1,3,'[{0,4918001,1},{0,38260001,28},{0,38260002,1}]'),(33,391,430,0,1,3,'[{0,4918001,1},{0,38260001,35},{0,38260002,1}]'),(34,431,500,0,1,3,'[{0,4918001,1},{0,38260001,35},{0,38260002,1}]'),(35,501,560,0,1,3,'[{0,4918001,1},{0,38260001,42},{0,38260002,1}]'),(36,561,610,0,1,3,'[{0,4918001,1},{0,38260001,42},{0,38260002,1}]'),(37,611,660,0,1,3,'[{0,4918001,1},{0,38260001,42},{0,38260002,1}]'),(38,661,750,0,1,3,'[{0,4918001,1},{0,38260001,42},{0,38260002,1}]'),(39,751,1000,0,1,3,'[{0,4918001,1},{0,38260001,42},{0,38260002,1}]');
/*!40000 ALTER TABLE `base_league_war_inner_rank_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_league_war_own`
--

DROP TABLE IF EXISTS `base_league_war_own`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_league_war_own` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '据点id',
  `mon_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '怪物id',
  `type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '据点类型',
  `coordinate` varchar(255) NOT NULL DEFAULT '[]' COMMENT '坐标点',
  `desc` varchar(500) NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='据点配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_league_war_own`
--

LOCK TABLES `base_league_war_own` WRITE;
/*!40000 ALTER TABLE `base_league_war_own` DISABLE KEYS */;
INSERT INTO `base_league_war_own` VALUES (1,58110001,1,'[{8700,10600}]','中央据点 中'),(2,58110002,2,'[{7306,13950}]','边防据点 上'),(3,58110003,2,'[{12334,9971}]','边防据点 右'),(4,58110004,2,'[{6500,7790}]','边防据点 左');
/*!40000 ALTER TABLE `base_league_war_own` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_league_war_rank_reward`
--

DROP TABLE IF EXISTS `base_league_war_rank_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_league_war_rank_reward` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励id',
  `min_wlv` smallint(4) unsigned NOT NULL DEFAULT '0' COMMENT '最小世界等级',
  `max_wlv` smallint(4) unsigned NOT NULL DEFAULT '0' COMMENT '最大世界等级',
  `min_rank` smallint(4) unsigned NOT NULL DEFAULT '0' COMMENT '最小排名',
  `max_rank` smallint(4) unsigned NOT NULL DEFAULT '0' COMMENT '最大排名',
  `rewards` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='个人排名奖励配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_league_war_rank_reward`
--

LOCK TABLES `base_league_war_rank_reward` WRITE;
/*!40000 ALTER TABLE `base_league_war_rank_reward` DISABLE KEYS */;
INSERT INTO `base_league_war_rank_reward` VALUES (1,1,320,1,1,'[{0,4918003,1},{0,20060001,12}]'),(2,321,370,1,1,'[{0,4918003,1},{0,20060001,16}]'),(3,371,500,1,1,'[{0,4918003,1},{0,20060002,12}]'),(4,501,610,1,1,'[{0,4918003,1},{0,20060002,16}]'),(5,611,1000,1,1,'[{0,4918003,1},{0,20060003,10}]'),(6,1,320,2,3,'[{0,4918002,1},{0,20060001,10}]'),(7,321,370,2,3,'[{0,4918002,1},{0,20060001,12}]'),(8,371,500,2,3,'[{0,4918002,1},{0,20060002,10}]'),(9,501,610,2,3,'[{0,4918002,1},{0,20060002,12}]'),(10,611,1000,2,3,'[{0,4918002,1},{0,20060003,8}]'),(11,1,320,4,10,'[{0,4918001,1},{0,20060001,8}]'),(12,321,370,4,10,'[{0,4918001,1},{0,20060001,10}]'),(13,371,500,4,10,'[{0,4918001,1},{0,20060002,8}]'),(14,501,610,4,10,'[{0,4918001,1},{0,20060002,10}]'),(15,611,1000,4,10,'[{0,4918001,1},{0,20060003,6}]');
/*!40000 ALTER TABLE `base_league_war_rank_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_league_war_score`
--

DROP TABLE IF EXISTS `base_league_war_score`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_league_war_score` (
  `type` smallint(4) unsigned NOT NULL DEFAULT '0' COMMENT '积分类型',
  `own_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '据点类型',
  `add_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '增加积分',
  `desc` varchar(512) NOT NULL DEFAULT '' COMMENT '描述',
  PRIMARY KEY (`type`,`own_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='积分配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_league_war_score`
--

LOCK TABLES `base_league_war_score` WRITE;
/*!40000 ALTER TABLE `base_league_war_score` DISABLE KEYS */;
INSERT INTO `base_league_war_score` VALUES (1,0,5,'击杀一名敌人'),(2,1,2,'攻击一次中央据点'),(2,2,1,'攻击一次边防据点'),(3,1,50,'占领中央据点'),(3,2,30,'占领边防据点'),(4,1,8,'中央据点每5秒提供积分'),(4,2,5,'边防据点每5秒提供积分'),(5,0,5,'挂机积分，每5秒提供积分');
/*!40000 ALTER TABLE `base_league_war_score` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_league_war_score_cfg`
--

DROP TABLE IF EXISTS `base_league_war_score_cfg`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_league_war_score_cfg` (
  `score_type` smallint(3) unsigned NOT NULL DEFAULT '0' COMMENT '积分类型',
  `add_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分增加值',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '积分描述@lang@',
  PRIMARY KEY (`score_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='积分配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_league_war_score_cfg`
--

LOCK TABLES `base_league_war_score_cfg` WRITE;
/*!40000 ALTER TABLE `base_league_war_score_cfg` DISABLE KEYS */;
INSERT INTO `base_league_war_score_cfg` VALUES (1,2,'怪物'),(2,5,'普通据点'),(3,10,'王者据点'),(4,4,'玩家'),(5,2,'砍普通据点'),(6,4,'砍王者据点');
/*!40000 ALTER TABLE `base_league_war_score_cfg` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_league_war_stage_reward`
--

DROP TABLE IF EXISTS `base_league_war_stage_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_league_war_stage_reward` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励id',
  `stage_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '阶段id',
  `min_wlv` smallint(4) unsigned NOT NULL DEFAULT '0' COMMENT '最小世界等级',
  `max_wlv` smallint(4) unsigned NOT NULL DEFAULT '0' COMMENT '最大世界等级',
  `need_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '需要积分',
  `rewards` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='个人阶段奖励配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_league_war_stage_reward`
--

LOCK TABLES `base_league_war_stage_reward` WRITE;
/*!40000 ALTER TABLE `base_league_war_stage_reward` DISABLE KEYS */;
INSERT INTO `base_league_war_stage_reward` VALUES (1,1,1,200,300,'[{0,24010001,2},{0,17010001,4}]'),(2,1,201,260,300,'[{0,24010001,3},{0,17010001,5}]'),(3,1,261,320,300,'[{0,24010001,3},{0,17010001,6}]'),(4,1,321,350,300,'[{0,24010001,4},{0,17010001,7}]'),(5,1,351,370,300,'[{0,24010001,4},{0,17010001,8}]'),(6,1,371,390,300,'[{0,24010002,2},{0,17010001,9}]'),(7,1,391,430,300,'[{0,24010002,2},{0,17010001,10}]'),(8,1,431,500,300,'[{0,24010002,3},{0,17010001,12}]'),(9,1,501,560,300,'[{0,24010002,3},{0,17010001,1}]'),(10,1,561,610,300,'[{0,24010002,4},{0,17010001,1}]'),(11,1,611,660,300,'[{0,24010003,1},{0,17010001,2}]'),(12,1,661,750,300,'[{0,24010003,1},{0,17010001,3}]'),(13,1,751,1000,300,'[{0,24010003,2},{0,17010001,4}]'),(14,2,1,200,500,'[{0,24010001,2},{0,17010001,4}]'),(15,2,201,260,500,'[{0,24010001,3},{0,17010001,5}]'),(16,2,261,320,500,'[{0,24010001,3},{0,17010001,6}]'),(17,2,321,350,500,'[{0,24010001,4},{0,17010001,7}]'),(18,2,351,370,500,'[{0,24010001,4},{0,17010001,8}]'),(19,2,371,390,500,'[{0,24010002,2},{0,17010001,9}]'),(20,2,391,430,500,'[{0,24010002,2},{0,17010001,10}]'),(21,2,431,500,500,'[{0,24010002,3},{0,17010001,12}]'),(22,2,501,560,500,'[{0,24010002,3},{0,17010001,1}]'),(23,2,561,610,500,'[{0,24010002,4},{0,17010001,1}]'),(24,2,611,660,500,'[{0,24010003,1},{0,17010001,2}]'),(25,2,661,750,500,'[{0,24010003,2},{0,17010001,3}]'),(26,2,751,1000,500,'[{0,24010003,2},{0,17010001,4}]'),(27,3,1,200,800,'[{0,24010001,2},{0,17010001,4}]'),(28,3,201,260,800,'[{0,24010001,3},{0,17010001,5}]'),(29,3,261,320,800,'[{0,24010001,3},{0,17010001,6}]'),(30,3,321,350,800,'[{0,24010001,4},{0,17010001,7}]'),(31,3,351,370,800,'[{0,24010001,4},{0,17010001,8}]'),(32,3,371,390,800,'[{0,24010002,2},{0,17010001,9}]'),(33,3,391,430,800,'[{0,24010002,2},{0,17010001,10}]'),(34,3,431,500,800,'[{0,24010002,3},{0,17010001,12}]'),(35,3,501,560,800,'[{0,24010002,3},{0,17010001,1}]'),(36,3,561,610,800,'[{0,24010002,4},{0,17010001,2}]'),(37,3,611,660,800,'[{0,24010003,2},{0,17010001,2}]'),(38,3,661,750,800,'[{0,24010003,2},{0,17010001,3}]'),(39,3,751,1000,800,'[{0,24010003,2},{0,17010001,4}]'),(40,4,1,200,1200,'[{0,24010001,3},{0,17010001,4}]'),(41,4,201,260,1200,'[{0,24010001,3},{0,17010001,5}]'),(42,4,261,320,1200,'[{0,24010001,4},{0,17010001,6}]'),(43,4,321,350,1200,'[{0,24010001,4},{0,17010001,7}]'),(44,4,351,370,1200,'[{0,24010001,5},{0,17010001,8}]'),(45,4,371,390,1200,'[{0,24010002,2},{0,17010001,9}]'),(46,4,391,430,1200,'[{0,24010002,3},{0,17010001,10}]'),(47,4,431,500,1200,'[{0,24010002,3},{0,17010001,12}]'),(48,4,501,560,1200,'[{0,24010002,4},{0,17010001,1}]'),(49,4,561,610,1200,'[{0,24010002,4},{0,17010001,2}]'),(50,4,611,660,1200,'[{0,24010003,2},{0,17010001,2}]'),(51,4,661,750,1200,'[{0,24010003,2},{0,17010001,3}]'),(52,4,751,1000,1200,'[{0,24010003,2},{0,17010001,4}]'),(53,5,1,200,1600,'[{0,24010001,3},{0,17010001,4}]'),(54,5,201,260,1600,'[{0,24010001,3},{0,17010001,5}]'),(55,5,261,320,1600,'[{0,24010001,4},{0,17010001,6}]'),(56,5,321,350,1600,'[{0,24010001,4},{0,17010001,7}]'),(57,5,351,370,1600,'[{0,24010001,5},{0,17010001,8}]'),(58,5,371,390,1600,'[{0,24010002,2},{0,17010001,9}]'),(59,5,391,430,1600,'[{0,24010002,3},{0,17010001,10}]'),(60,5,431,500,1600,'[{0,24010002,3},{0,17010001,12}]'),(61,5,501,560,1600,'[{0,24010002,4},{0,17010001,2}]'),(62,5,561,610,1600,'[{0,24010002,4},{0,17010001,2}]'),(63,5,611,660,1600,'[{0,24010003,2},{0,17010001,2}]'),(64,5,661,750,1600,'[{0,24010003,2},{0,17010001,3}]'),(65,5,751,1000,1600,'[{0,24010003,2},{0,17010001,4}]'),(66,6,1,200,2000,'[{0,24010001,3},{0,17010001,4}]'),(67,6,201,260,2000,'[{0,24010001,3},{0,17010001,5}]'),(68,6,261,320,2000,'[{0,24010001,4},{0,17010001,6}]'),(69,6,321,350,2000,'[{0,24010001,4},{0,17010001,7}]'),(70,6,351,370,2000,'[{0,24010001,5},{0,17010001,8}]'),(71,6,371,390,2000,'[{0,24010002,2},{0,17010001,9}]'),(72,6,391,430,2000,'[{0,24010002,3},{0,17010001,10}]'),(73,6,431,500,2000,'[{0,24010002,3},{0,17010001,12}]'),(74,6,501,560,2000,'[{0,24010002,4},{0,17010001,2}]'),(75,6,561,610,2000,'[{0,24010002,4},{0,17010001,2}]'),(76,6,611,660,2000,'[{0,24010003,2},{0,17010001,2}]'),(77,6,661,750,2000,'[{0,24010003,2},{0,17010001,3}]'),(78,6,751,1000,2000,'[{0,24010003,2},{0,17010001,4}]');
/*!40000 ALTER TABLE `base_league_war_stage_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_league_war_win_reward`
--

DROP TABLE IF EXISTS `base_league_war_win_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_league_war_win_reward` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励id',
  `min_wlv` smallint(4) unsigned NOT NULL DEFAULT '0' COMMENT '最小世界等级',
  `max_wlv` smallint(4) unsigned NOT NULL DEFAULT '0' COMMENT '最大世界等级',
  `rewards` varchar(128) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='获胜阵营奖励配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_league_war_win_reward`
--

LOCK TABLES `base_league_war_win_reward` WRITE;
/*!40000 ALTER TABLE `base_league_war_win_reward` DISABLE KEYS */;
INSERT INTO `base_league_war_win_reward` VALUES (1,1,320,'[{0,17010001,30},{0,38260001,10},{0,24020001,1},{0,17020001,1}]'),(2,321,370,'[{0,17010001,45},{0,38260001,15},{0,24020001,1},{0,17020001,1}]'),(3,371,450,'[{0,17010001,60},{0,38260001,20},{0,24020001,1},{0,17020001,1}]'),(4,451,1000,'[{0,17010001,75},{0,38260001,25},{0,24020002,1},{0,17020002,1}]');
/*!40000 ALTER TABLE `base_league_war_win_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_light_weapon_activate`
--

DROP TABLE IF EXISTS `base_light_weapon_activate`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_light_weapon_activate` (
  `id` smallint(10) unsigned NOT NULL COMMENT '专武id',
  `career` tinyint(1) unsigned NOT NULL COMMENT '武器职业',
  `name` varchar(255) NOT NULL COMMENT '专武名称@lang@',
  `name_source` varchar(255) NOT NULL COMMENT '名称资源',
  `type` tinyint(1) unsigned NOT NULL COMMENT '激活类型',
  `cost` varchar(255) NOT NULL COMMENT '激活消耗',
  `figure_id` int(11) unsigned NOT NULL COMMENT '形象资源id',
  `picture_id` int(11) unsigned NOT NULL COMMENT '贴图id',
  `effect` varchar(255) NOT NULL COMMENT '特效资源',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='光武-专武激活表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_light_weapon_activate`
--

LOCK TABLES `base_light_weapon_activate` WRITE;
/*!40000 ALTER TABLE `base_light_weapon_activate` DISABLE KEYS */;
INSERT INTO `base_light_weapon_activate` VALUES (1,1,'斩罪大剑','uigw_zi_010',1,'130',1101000,0,'weapon_1101000fx'),(2,2,'仲裁圣枪','uigw_zi_013',1,'130',1102000,0,'weapon_1102000fx'),(3,4,'镇魂火炮','uigw_zi_016',1,'130',1104000,0,'weapon_1104000fx');
/*!40000 ALTER TABLE `base_light_weapon_activate` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_light_weapon_figure`
--

DROP TABLE IF EXISTS `base_light_weapon_figure`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_light_weapon_figure` (
  `id` smallint(5) unsigned NOT NULL COMMENT '幻化id',
  `star` smallint(5) unsigned NOT NULL COMMENT '星级数',
  `career` tinyint(1) unsigned NOT NULL COMMENT '职业类型',
  `name` varchar(255) NOT NULL COMMENT '幻化名称@lang@',
  `name_source` varchar(255) NOT NULL COMMENT '名称资源',
  `cost` varchar(512) NOT NULL COMMENT '升星消耗',
  `attr` varchar(512) NOT NULL COMMENT '属性',
  `combat_power` int(11) unsigned NOT NULL COMMENT '战力（展示用）',
  `figure_id` int(11) unsigned NOT NULL COMMENT '形象资源id',
  `picture_id` int(11) unsigned NOT NULL COMMENT '贴图id',
  `effect` varchar(255) NOT NULL COMMENT '特效资源',
  PRIMARY KEY (`id`,`star`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='光武-光武升星（激活）表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_light_weapon_figure`
--

LOCK TABLES `base_light_weapon_figure` WRITE;
/*!40000 ALTER TABLE `base_light_weapon_figure` DISABLE KEYS */;
INSERT INTO `base_light_weapon_figure` VALUES (1011,0,1,'寒霜大剑','uigw_zi_006','[{0,53010101,1}]','[{1,774},{3,619},{5,495},{11,100}]',55705,1101001,0,''),(1011,1,1,'寒霜大剑','uigw_zi_006','[{0,53010101,1}]','[{1,1394},{3,1115},{5,892},{11,200}]',100355,1101001,0,''),(1011,2,1,'寒霜大剑','uigw_zi_006','[{0,53010101,2}]','[{1,2230},{3,1784},{5,1427},{11,300}]',160550,1101001,0,''),(1011,3,1,'寒霜大剑','uigw_zi_006','[{0,53010101,4}]','[{1,3268},{3,2614},{5,2091},{11,400}]',235260,11010011,0,''),(1011,4,1,'寒霜大剑','uigw_zi_006','[{0,53010101,6}]','[{1,4523},{3,3618},{5,2894},{11,550}]',325610,11010011,0,''),(1011,5,1,'寒霜大剑','uigw_zi_006','[{0,53010101,8}]','[{1,6010},{3,4808},{5,3846},{11,700}]',432700,11010012,0,''),(1012,0,1,'龙焰斩剑','uigw_zi_002','[{0,53010102,1}]','[{1,1200},{3,960},{5,768},{27,100}]',86400,1101002,0,''),(1012,1,1,'龙焰斩剑','uigw_zi_002','[{0,53010102,1}]','[{1,2153},{3,1722},{5,1378},{27,200}]',155010,1101002,0,''),(1012,2,1,'龙焰斩剑','uigw_zi_002','[{0,53010102,2}]','[{1,3439},{3,2751},{5,2201},{27,300}]',247605,1101002,0,''),(1012,3,1,'龙焰斩剑','uigw_zi_002','[{0,53010102,4}]','[{1,5035},{3,4028},{5,3223},{27,400}]',362550,11010021,0,''),(1012,4,1,'龙焰斩剑','uigw_zi_002','[{0,53010102,6}]','[{1,6965},{3,5572},{5,4458},{27,550}]',501500,11010021,0,''),(1012,5,1,'龙焰斩剑','uigw_zi_002','[{0,53010102,8}]','[{1,9252},{3,7402},{5,5922},{27,700}]',666190,11010022,0,''),(1013,0,1,'强袭军刀','uigw_zi_009','[{0,53010103,1}]','[{1,800},{3,640},{5,512},{51,100}]',57600,1101003,0,''),(1013,1,1,'强袭军刀','uigw_zi_009','[{0,53010103,1}]','[{1,1442},{3,1154},{5,923},{51,200}]',103840,1101003,0,''),(1013,2,1,'强袭军刀','uigw_zi_009','[{0,53010103,2}]','[{1,2308},{3,1847},{5,1477},{51,300}]',166185,1101003,0,''),(1013,3,1,'强袭军刀','uigw_zi_009','[{0,53010103,4}]','[{1,3383},{3,2707},{5,2165},{51,400}]',243585,11010031,0,''),(1013,4,1,'强袭军刀','uigw_zi_009','[{0,53010103,6}]','[{1,4683},{3,3747},{5,2997},{51,550}]',337185,11010031,0,''),(1013,5,1,'强袭军刀','uigw_zi_009','[{0,53010103,8}]','[{1,6223},{3,4979},{5,3983},{51,700}]',448085,11010032,0,''),(1014,0,1,'裁决圣剑','uigw_zi_011','[{0,53010104,1}]','[{1,858},{3,686},{5,549},{13,80}]',61760,1101004,0,''),(1014,1,1,'裁决圣剑','uigw_zi_011','[{0,53010104,1}]','[{1,1544},{3,1235},{5,988},{13,160}]',111155,1101004,0,''),(1014,2,1,'裁决圣剑','uigw_zi_011','[{0,53010104,2}]','[{1,2470},{3,1976},{5,1581},{13,240}]',177850,1101004,0,''),(1014,3,1,'裁决圣剑','uigw_zi_011','[{0,53010104,4}]','[{1,3619},{3,2895},{5,2316},{13,320}]',260555,11010041,0,''),(1014,4,1,'裁决圣剑','uigw_zi_011','[{0,53010104,6}]','[{1,5009},{3,4007},{5,3206},{13,440}]',360655,11010041,0,''),(1014,5,1,'裁决圣剑','uigw_zi_011','[{0,53010104,8}]','[{1,6656},{3,5325},{5,4260},{13,560}]',479245,11010042,0,''),(1015,0,1,'灾厄魔剑','uigw_zi_012','[{0,53010105,1}]','[{1,1650},{3,1320},{5,1056},{9,100}]',118800,1101005,0,''),(1015,1,1,'灾厄魔剑','uigw_zi_012','[{0,53010105,1}]','[{1,2958},{3,2366},{5,1893},{9,200}]',212960,1101005,0,''),(1015,2,1,'灾厄魔剑','uigw_zi_012','[{0,53010105,2}]','[{1,4724},{3,3779},{5,3023},{9,300}]',340105,1101005,0,''),(1015,3,1,'灾厄魔剑','uigw_zi_012','[{0,53010105,4}]','[{1,6916},{3,5533},{5,4426},{9,400}]',497945,11010051,0,''),(1015,4,1,'灾厄魔剑','uigw_zi_012','[{0,53010105,6}]','[{1,9566},{3,7653},{5,6122},{9,550}]',688745,11010051,0,''),(1015,5,1,'灾厄魔剑','uigw_zi_012','[{0,53010105,8}]','[{1,12706},{3,10165},{5,8132},{9,700}]',914845,11010052,0,''),(2011,0,2,'冰晶长枪','uigw_zi_005','[{0,53010201,1}]','[{1,774},{3,619},{5,495},{11,100}]',55705,1102001,0,''),(2011,1,2,'冰晶长枪','uigw_zi_005','[{0,53010201,1}]','[{1,1394},{3,1115},{5,892},{11,200}]',100355,1102001,0,''),(2011,2,2,'冰晶长枪','uigw_zi_005','[{0,53010201,2}]','[{1,2230},{3,1784},{5,1427},{11,300}]',160550,1102001,0,''),(2011,3,2,'冰晶长枪','uigw_zi_005','[{0,53010201,4}]','[{1,3268},{3,2614},{5,2091},{11,400}]',235260,11020011,0,''),(2011,4,2,'冰晶长枪','uigw_zi_005','[{0,53010201,6}]','[{1,4523},{3,3618},{5,2894},{11,550}]',325610,11020011,0,''),(2011,5,2,'冰晶长枪','uigw_zi_005','[{0,53010201,8}]','[{1,6010},{3,4808},{5,3846},{11,700}]',432700,11020012,0,''),(2012,0,2,'屠龙炎枪','uigw_zi_003','[{0,53010202,1}]','[{1,1200},{3,960},{5,768},{27,100}]',86400,1102002,0,''),(2012,1,2,'屠龙炎枪','uigw_zi_003','[{0,53010202,1}]','[{1,2153},{3,1722},{5,1378},{27,200}]',155010,1102002,0,''),(2012,2,2,'屠龙炎枪','uigw_zi_003','[{0,53010202,2}]','[{1,3439},{3,2751},{5,2201},{27,300}]',247605,1102002,0,''),(2012,3,2,'屠龙炎枪','uigw_zi_003','[{0,53010202,4}]','[{1,5035},{3,4028},{5,3223},{27,400}]',362550,11020021,0,''),(2012,4,2,'屠龙炎枪','uigw_zi_003','[{0,53010202,6}]','[{1,6965},{3,5572},{5,4458},{27,550}]',501500,11020021,0,''),(2012,5,2,'屠龙炎枪','uigw_zi_003','[{0,53010202,8}]','[{1,9252},{3,7402},{5,5922},{27,700}]',666190,11020022,0,''),(2013,0,2,'突击枪刃','uigw_zi_008','[{0,53010203,1}]','[{1,800},{3,640},{5,512},{51,100}]',57600,1102003,0,''),(2013,1,2,'突击枪刃','uigw_zi_008','[{0,53010203,1}]','[{1,1442},{3,1154},{5,923},{51,200}]',103840,1102003,0,''),(2013,2,2,'突击枪刃','uigw_zi_008','[{0,53010203,2}]','[{1,2308},{3,1847},{5,1477},{51,300}]',166185,1102003,0,''),(2013,3,2,'突击枪刃','uigw_zi_008','[{0,53010203,4}]','[{1,3383},{3,2707},{5,2165},{51,400}]',243585,11020031,0,''),(2013,4,2,'突击枪刃','uigw_zi_008','[{0,53010203,6}]','[{1,4683},{3,3747},{5,2997},{51,550}]',337185,11020031,0,''),(2013,5,2,'突击枪刃','uigw_zi_008','[{0,53010203,8}]','[{1,6223},{3,4979},{5,3983},{51,700}]',448085,11020032,0,''),(2014,0,2,'断罪圣枪','uigw_zi_014','[{0,53010204,1}]','[{1,858},{3,686},{5,549},{13,80}]',61760,1102004,0,''),(2014,1,2,'断罪圣枪','uigw_zi_014','[{0,53010204,1}]','[{1,1544},{3,1235},{5,988},{13,160}]',111155,1102004,0,''),(2014,2,2,'断罪圣枪','uigw_zi_014','[{0,53010204,2}]','[{1,2470},{3,1976},{5,1581},{13,240}]',177850,1102004,0,''),(2014,3,2,'断罪圣枪','uigw_zi_014','[{0,53010204,4}]','[{1,3619},{3,2895},{5,2316},{13,320}]',260555,11020041,0,''),(2014,4,2,'断罪圣枪','uigw_zi_014','[{0,53010204,6}]','[{1,5009},{3,4007},{5,3206},{13,440}]',360655,11020041,0,''),(2014,5,2,'断罪圣枪','uigw_zi_014','[{0,53010204,8}]','[{1,6656},{3,5325},{5,4260},{13,560}]',479245,11020042,0,''),(2015,0,2,'屠戮魔枪','uigw_zi_015','[{0,53010205,1}]','[{1,1650},{3,1320},{5,1056},{9,100}]',118800,1102005,0,''),(2015,1,2,'屠戮魔枪','uigw_zi_015','[{0,53010205,1}]','[{1,2958},{3,2366},{5,1893},{9,200}]',212960,1102005,0,''),(2015,2,2,'屠戮魔枪','uigw_zi_015','[{0,53010205,2}]','[{1,4724},{3,3779},{5,3023},{9,300}]',340105,1102005,0,''),(2015,3,2,'屠戮魔枪','uigw_zi_015','[{0,53010205,4}]','[{1,6916},{3,5533},{5,4426},{9,400}]',497945,11020051,0,''),(2015,4,2,'屠戮魔枪','uigw_zi_015','[{0,53010205,6}]','[{1,9566},{3,7653},{5,6122},{9,550}]',688745,11020051,0,''),(2015,5,2,'屠戮魔枪','uigw_zi_015','[{0,53010205,8}]','[{1,12706},{3,10165},{5,8132},{9,700}]',914845,11020052,0,''),(4011,0,4,'凛冬重炮','uigw_zi_007','[{0,53010401,1}]','[{1,774},{3,619},{5,495},{11,100}]',55705,1104001,0,''),(4011,1,4,'凛冬重炮','uigw_zi_007','[{0,53010401,1}]','[{1,1394},{3,1115},{5,892},{11,200}]',100355,1104001,0,''),(4011,2,4,'凛冬重炮','uigw_zi_007','[{0,53010401,2}]','[{1,2230},{3,1784},{5,1427},{11,300}]',160550,1104001,0,''),(4011,3,4,'凛冬重炮','uigw_zi_007','[{0,53010401,4}]','[{1,3268},{3,2614},{5,2091},{11,400}]',235260,11040011,0,''),(4011,4,4,'凛冬重炮','uigw_zi_007','[{0,53010401,6}]','[{1,4523},{3,3618},{5,2894},{11,550}]',325610,11040011,0,''),(4011,5,4,'凛冬重炮','uigw_zi_007','[{0,53010401,8}]','[{1,6010},{3,4808},{5,3846},{11,700}]',432700,11040012,0,''),(4012,0,4,'龙神火炮','uigw_zi_001','[{0,53010402,1}]','[{1,1200},{3,960},{5,768},{27,100}]',86400,1104002,0,''),(4012,1,4,'龙神火炮','uigw_zi_001','[{0,53010402,1}]','[{1,2153},{3,1722},{5,1378},{27,200}]',155010,1104002,0,''),(4012,2,4,'龙神火炮','uigw_zi_001','[{0,53010402,2}]','[{1,3439},{3,2751},{5,2201},{27,300}]',247605,1104002,0,''),(4012,3,4,'龙神火炮','uigw_zi_001','[{0,53010402,4}]','[{1,5035},{3,4028},{5,3223},{27,400}]',362550,11040021,0,''),(4012,4,4,'龙神火炮','uigw_zi_001','[{0,53010402,6}]','[{1,6965},{3,5572},{5,4458},{27,550}]',501500,11040021,0,''),(4012,5,4,'龙神火炮','uigw_zi_001','[{0,53010402,8}]','[{1,9252},{3,7402},{5,5922},{27,700}]',666190,11040022,0,''),(4013,0,4,'离子火炮','uigw_zi_004','[{0,53010403,1}]','[{1,800},{3,640},{5,512},{51,100}]',57600,1104003,0,''),(4013,1,4,'离子火炮','uigw_zi_004','[{0,53010403,1}]','[{1,1442},{3,1154},{5,923},{51,200}]',103840,1104003,0,''),(4013,2,4,'离子火炮','uigw_zi_004','[{0,53010403,2}]','[{1,2308},{3,1847},{5,1477},{51,300}]',166185,1104003,0,''),(4013,3,4,'离子火炮','uigw_zi_004','[{0,53010403,4}]','[{1,3383},{3,2707},{5,2165},{51,400}]',243585,11040031,0,''),(4013,4,4,'离子火炮','uigw_zi_004','[{0,53010403,6}]','[{1,4683},{3,3747},{5,2997},{51,550}]',337185,11040031,0,''),(4013,5,4,'离子火炮','uigw_zi_004','[{0,53010403,8}]','[{1,6223},{3,4979},{5,3983},{51,700}]',448085,11040032,0,''),(4014,0,4,'真理火炮','uigw_zi_017','[{0,53010404,1}]','[{1,858},{3,686},{5,549},{13,80}]',61760,1104004,0,''),(4014,1,4,'真理火炮','uigw_zi_017','[{0,53010404,1}]','[{1,1544},{3,1235},{5,988},{13,160}]',111155,1104004,0,''),(4014,2,4,'真理火炮','uigw_zi_017','[{0,53010404,2}]','[{1,2470},{3,1976},{5,1581},{13,240}]',177850,1104004,0,''),(4014,3,4,'真理火炮','uigw_zi_017','[{0,53010404,4}]','[{1,3619},{3,2895},{5,2316},{13,320}]',260555,11040041,0,''),(4014,4,4,'真理火炮','uigw_zi_017','[{0,53010404,6}]','[{1,5009},{3,4007},{5,3206},{13,440}]',360655,11040041,0,''),(4014,5,4,'真理火炮','uigw_zi_017','[{0,53010404,8}]','[{1,6656},{3,5325},{5,4260},{13,560}]',479245,11040042,0,''),(4015,0,4,'死亡魔炮','uigw_zi_018','[{0,53010405,1}]','[{1,1650},{3,1320},{5,1056},{9,100}]',118800,1104005,0,''),(4015,1,4,'死亡魔炮','uigw_zi_018','[{0,53010405,1}]','[{1,2958},{3,2366},{5,1893},{9,200}]',212960,1104005,0,''),(4015,2,4,'死亡魔炮','uigw_zi_018','[{0,53010405,2}]','[{1,4724},{3,3779},{5,3023},{9,300}]',340105,1104005,0,''),(4015,3,4,'死亡魔炮','uigw_zi_018','[{0,53010405,4}]','[{1,6916},{3,5533},{5,4426},{9,400}]',497945,11040051,0,''),(4015,4,4,'死亡魔炮','uigw_zi_018','[{0,53010405,6}]','[{1,9566},{3,7653},{5,6122},{9,550}]',688745,11040051,0,''),(4015,5,4,'死亡魔炮','uigw_zi_018','[{0,53010405,8}]','[{1,12706},{3,10165},{5,8132},{9,700}]',914845,11040052,0,'');
/*!40000 ALTER TABLE `base_light_weapon_figure` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_light_weapon_lv_attr`
--

DROP TABLE IF EXISTS `base_light_weapon_lv_attr`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_light_weapon_lv_attr` (
  `lv` smallint(5) unsigned NOT NULL COMMENT '等级',
  `next_exp` int(11) unsigned NOT NULL COMMENT '升级所需经验',
  `attr` varchar(512) NOT NULL COMMENT '属性加成',
  `combat_power` int(11) unsigned NOT NULL COMMENT '战力（展示用）',
  PRIMARY KEY (`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='光武-专武等级属性表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_light_weapon_lv_attr`
--

LOCK TABLES `base_light_weapon_lv_attr` WRITE;
/*!40000 ALTER TABLE `base_light_weapon_lv_attr` DISABLE KEYS */;
INSERT INTO `base_light_weapon_lv_attr` VALUES (1,30,'[{1,40},{3,32},{5,16},{13,150}]',2400),(2,60,'[{1,49},{3,40},{5,20},{13,160}]',2980),(3,80,'[{1,59},{3,48},{5,24},{13,170}]',3580),(4,100,'[{1,70},{3,57},{5,28},{13,180}]',4225),(5,110,'[{1,82},{3,67},{5,33},{13,190}]',4965),(6,120,'[{1,95},{3,77},{5,38},{13,200}]',5725),(7,130,'[{1,109},{3,88},{5,44},{13,210}]',6580),(8,140,'[{1,124},{3,100},{5,50},{13,220}]',7480),(9,150,'[{1,140},{3,112},{5,56},{13,230}]',8400),(10,160,'[{1,156},{3,125},{5,63},{13,240}]',9395),(11,170,'[{1,173},{3,139},{5,70},{13,250}]',10435),(12,180,'[{1,191},{3,154},{5,77},{13,260}]',11520),(13,190,'[{1,210},{3,169},{5,85},{13,270}]',12675),(14,200,'[{1,230},{3,185},{5,93},{13,280}]',13875),(15,210,'[{1,251},{3,202},{5,101},{13,290}]',15120),(16,220,'[{1,273},{3,219},{5,110},{13,300}]',16435),(17,230,'[{1,295},{3,237},{5,119},{13,310}]',17775),(18,240,'[{1,318},{3,256},{5,128},{13,320}]',19160),(19,250,'[{1,342},{3,275},{5,138},{13,330}]',20615),(20,260,'[{1,367},{3,295},{5,148},{13,340}]',22115),(21,270,'[{1,393},{3,316},{5,159},{13,350}]',23710),(22,280,'[{1,421},{3,338},{5,170},{13,360}]',25370),(23,290,'[{1,450},{3,361},{5,182},{13,370}]',27125),(24,300,'[{1,481},{3,386},{5,194},{13,380}]',28970),(25,310,'[{1,513},{3,412},{5,207},{13,390}]',30910),(26,325,'[{1,546},{3,439},{5,220},{13,400}]',32895),(27,345,'[{1,581},{3,467},{5,234},{13,410}]',34995),(28,365,'[{1,617},{3,496},{5,248},{13,420}]',37140),(29,385,'[{1,655},{3,526},{5,263},{13,430}]',39400),(30,405,'[{1,694},{3,557},{5,279},{13,440}]',41755),(31,425,'[{1,734},{3,589},{5,295},{13,450}]',44155),(32,445,'[{1,776},{3,622},{5,312},{13,460}]',46670),(33,465,'[{1,819},{3,657},{5,329},{13,470}]',49255),(34,485,'[{1,864},{3,693},{5,347},{13,480}]',51955),(35,505,'[{1,910},{3,730},{5,365},{13,490}]',54700),(36,525,'[{1,957},{3,768},{5,384},{13,500}]',57540),(37,545,'[{1,1006},{3,807},{5,403},{13,510}]',60445),(38,565,'[{1,1056},{3,847},{5,423},{13,520}]',63445),(39,585,'[{1,1107},{3,888},{5,444},{13,530}]',66540),(40,610,'[{1,1160},{3,930},{5,465},{13,540}]',69700),(41,635,'[{1,1215},{3,974},{5,487},{13,550}]',73000),(42,660,'[{1,1272},{3,1019},{5,510},{13,560}]',76415),(43,685,'[{1,1331},{3,1066},{5,533},{13,570}]',79920),(44,710,'[{1,1391},{3,1114},{5,557},{13,580}]',83520),(45,735,'[{1,1453},{3,1164},{5,582},{13,590}]',87260),(46,760,'[{1,1517},{3,1215},{5,608},{13,600}]',91115),(47,785,'[{1,1583},{3,1268},{5,634},{13,610}]',95060),(48,810,'[{1,1651},{3,1322},{5,661},{13,620}]',99120),(49,835,'[{1,1721},{3,1378},{5,689},{13,630}]',103320),(50,860,'[{1,1793},{3,1436},{5,718},{13,640}]',107660),(51,885,'[{1,1867},{3,1495},{5,748},{13,650}]',112115),(52,910,'[{1,1943},{3,1556},{5,778},{13,660}]',116660),(53,935,'[{1,2021},{3,1618},{5,809},{13,670}]',121320),(54,960,'[{1,2101},{3,1682},{5,841},{13,680}]',126120),(55,985,'[{1,2182},{3,1747},{5,874},{13,690}]',131015),(56,1010,'[{1,2265},{3,1814},{5,907},{13,700}]',136000),(57,1035,'[{1,2350},{3,1882},{5,941},{13,710}]',141100),(58,1060,'[{1,2437},{3,1952},{5,976},{13,720}]',146340),(59,1085,'[{1,2526},{3,2023},{5,1012},{13,730}]',151695),(60,1115,'[{1,2617},{3,2096},{5,1048},{13,740}]',157140),(61,1145,'[{1,2710},{3,2171},{5,1085},{13,750}]',162725),(62,1175,'[{1,2806},{3,2248},{5,1123},{13,760}]',168470),(63,1205,'[{1,2904},{3,2327},{5,1162},{13,770}]',174355),(64,1235,'[{1,3005},{3,2408},{5,1202},{13,780}]',180400),(65,1265,'[{1,3108},{3,2491},{5,1243},{13,790}]',186585),(66,1295,'[{1,3214},{3,2575},{5,1285},{13,800}]',192905),(67,1325,'[{1,3322},{3,2661},{5,1328},{13,810}]',199365),(68,1355,'[{1,3432},{3,2749},{5,1372},{13,820}]',205965),(69,1385,'[{1,3545},{3,2839},{5,1417},{13,830}]',212725),(70,1415,'[{1,3660},{3,2931},{5,1463},{13,840}]',219625),(71,1445,'[{1,3778},{3,3025},{5,1510},{13,850}]',226685),(72,1475,'[{1,3898},{3,3121},{5,1558},{13,860}]',233885),(73,1505,'[{1,4021},{3,3219},{5,1607},{13,870}]',241245),(74,1535,'[{1,4146},{3,3319},{5,1657},{13,880}]',248745),(75,1565,'[{1,4273},{3,3421},{5,1708},{13,890}]',256385),(76,1595,'[{1,4403},{3,3525},{5,1760},{13,900}]',264185),(77,1625,'[{1,4535},{3,3631},{5,1813},{13,910}]',272125),(78,1655,'[{1,4670},{3,3739},{5,1867},{13,920}]',280225),(79,1685,'[{1,4807},{3,3849},{5,1922},{13,930}]',288465),(80,1725,'[{1,4947},{3,3961},{5,1978},{13,940}]',296865),(81,1765,'[{1,5090},{3,4075},{5,2035},{13,950}]',305425),(82,1805,'[{1,5236},{3,4191},{5,2093},{13,960}]',314145),(83,1845,'[{1,5384},{3,4310},{5,2152},{13,970}]',323030),(84,1885,'[{1,5535},{3,4431},{5,2213},{13,980}]',332125),(85,1925,'[{1,5689},{3,4554},{5,2275},{13,990}]',341380),(86,1965,'[{1,5846},{3,4680},{5,2338},{13,1000}]',350820),(87,2005,'[{1,6006},{3,4808},{5,2402},{13,1010}]',360420),(88,2045,'[{1,6169},{3,4939},{5,2467},{13,1020}]',370205),(89,2085,'[{1,6335},{3,5072},{5,2533},{13,1030}]',380150),(90,2125,'[{1,6504},{3,5207},{5,2601},{13,1040}]',390305),(91,2165,'[{1,6676},{3,5345},{5,2670},{13,1050}]',400645),(92,2205,'[{1,6851},{3,5485},{5,2740},{13,1060}]',411145),(93,2245,'[{1,7029},{3,5627},{5,2811},{13,1070}]',421805),(94,2285,'[{1,7210},{3,5772},{5,2883},{13,1080}]',432650),(95,2325,'[{1,7394},{3,5919},{5,2957},{13,1090}]',443705),(96,2365,'[{1,7581},{3,6068},{5,3032},{13,1100}]',454920),(97,2405,'[{1,7771},{3,6220},{5,3108},{13,1110}]',466320),(98,2445,'[{1,7964},{3,6374},{5,3185},{13,1120}]',477880),(99,2485,'[{1,8160},{3,6531},{5,3263},{13,1130}]',489625),(100,2535,'[{1,8359},{3,6690},{5,3342},{13,1140}]',501530),(101,2585,'[{1,8561},{3,6852},{5,3423},{13,1150}]',513670),(102,2635,'[{1,8767},{3,7016},{5,3505},{13,1160}]',525990),(103,2685,'[{1,8976},{3,7183},{5,3589},{13,1170}]',538545),(104,2735,'[{1,9189},{3,7353},{5,3674},{13,1180}]',551305),(105,2785,'[{1,9405},{3,7526},{5,3760},{13,1190}]',564250),(106,2835,'[{1,9624},{3,7702},{5,3848},{13,1200}]',577430),(107,2885,'[{1,9847},{3,7880},{5,3937},{13,1210}]',590790),(108,2935,'[{1,10073},{3,8061},{5,4028},{13,1220}]',604385),(109,2985,'[{1,10303},{3,8245},{5,4120},{13,1230}]',618185),(110,3035,'[{1,10536},{3,8432},{5,4213},{13,1240}]',632170),(111,3085,'[{1,10773},{3,8621},{5,4308},{13,1250}]',646385),(112,3135,'[{1,11013},{3,8813},{5,4404},{13,1260}]',660785),(113,3185,'[{1,11257},{3,9008},{5,4501},{13,1270}]',675390),(114,3235,'[{1,11504},{3,9206},{5,4600},{13,1280}]',690230),(115,3285,'[{1,11755},{3,9407},{5,4700},{13,1290}]',705275),(116,3335,'[{1,12009},{3,9610},{5,4802},{13,1300}]',720530),(117,3385,'[{1,12267},{3,9816},{5,4905},{13,1310}]',735990),(118,3435,'[{1,12528},{3,10025},{5,5009},{13,1320}]',751635),(119,3485,'[{1,12793},{3,10237},{5,5115},{13,1330}]',767535),(120,3550,'[{1,13061},{3,10451},{5,5222},{13,1340}]',783595),(121,3615,'[{1,13333},{3,10669},{5,5331},{13,1350}]',799935),(122,3680,'[{1,13609},{3,10890},{5,5441},{13,1360}]',816480),(123,3745,'[{1,13889},{3,11114},{5,5553},{13,1370}]',833280),(124,3810,'[{1,14173},{3,11341},{5,5667},{13,1380}]',850335),(125,3875,'[{1,14461},{3,11571},{5,5782},{13,1390}]',867595),(126,3940,'[{1,14753},{3,11805},{5,5899},{13,1400}]',885135),(127,4005,'[{1,15049},{3,12042},{5,6017},{13,1410}]',902880),(128,4070,'[{1,15349},{3,12282},{5,6137},{13,1420}]',920880),(129,4135,'[{1,15653},{3,12525},{5,6259},{13,1430}]',939135),(130,4200,'[{1,15961},{3,12771},{5,6382},{13,1440}]',957595),(131,4265,'[{1,16273},{3,13021},{5,6507},{13,1450}]',976335),(132,4330,'[{1,16589},{3,13274},{5,6633},{13,1460}]',995280),(133,4395,'[{1,16909},{3,13530},{5,6761},{13,1470}]',1014480),(134,4460,'[{1,17233},{3,13789},{5,6891},{13,1480}]',1033935),(135,4540,'[{1,17561},{3,14051},{5,7022},{13,1490}]',1053595),(136,4620,'[{1,17893},{3,14317},{5,7155},{13,1500}]',1073535),(137,4700,'[{1,18229},{3,14586},{5,7289},{13,1510}]',1093680),(138,4780,'[{1,18569},{3,14858},{5,7425},{13,1520}]',1114080),(139,4860,'[{1,18913},{3,15133},{5,7563},{13,1530}]',1134735),(140,4940,'[{1,19261},{3,15411},{5,7702},{13,1540}]',1155595),(141,5020,'[{1,19613},{3,15693},{5,7843},{13,1550}]',1176735),(142,5100,'[{1,19970},{3,15979},{5,7986},{13,1560}]',1198175),(143,5180,'[{1,20331},{3,16268},{5,8131},{13,1570}]',1219870),(144,5260,'[{1,20697},{3,16561},{5,8277},{13,1580}]',1241815),(145,5340,'[{1,21067},{3,16857},{5,8425},{13,1590}]',1264015),(146,5420,'[{1,21442},{3,17157},{5,8575},{13,1600}]',1286515),(147,5500,'[{1,21821},{3,17461},{5,8727},{13,1610}]',1309295),(148,5580,'[{1,22205},{3,17768},{5,8881},{13,1620}]',1332350),(149,5660,'[{1,22593},{3,18079},{5,9036},{13,1630}]',1355635),(150,5740,'[{1,22986},{3,18393},{5,9193},{13,1640}]',1379195),(151,5820,'[{1,23384},{3,18711},{5,9352},{13,1650}]',1403055),(152,5900,'[{1,23786},{3,19033},{5,9513},{13,1660}]',1427195),(153,5980,'[{1,24193},{3,19358},{5,9676},{13,1670}]',1451610),(154,6060,'[{1,24604},{3,19687},{5,9840},{13,1680}]',1476255),(155,6140,'[{1,25020},{3,20019},{5,10006},{13,1690}]',1501175),(156,6220,'[{1,25440},{3,20355},{5,10174},{13,1700}]',1526375),(157,6300,'[{1,25865},{3,20695},{5,10344},{13,1710}]',1551875),(158,6380,'[{1,26294},{3,21038},{5,10516},{13,1720}]',1577630),(159,6460,'[{1,26728},{3,21385},{5,10689},{13,1730}]',1603635),(160,6555,'[{1,27166},{3,21735},{5,10864},{13,1740}]',1629895),(161,6650,'[{1,27609},{3,22090},{5,11041},{13,1750}]',1656480),(162,6745,'[{1,28057},{3,22449},{5,11220},{13,1760}]',1683365),(163,6840,'[{1,28510},{3,22812},{5,11401},{13,1770}]',1710550),(164,6935,'[{1,28968},{3,23179},{5,11584},{13,1780}]',1738035),(165,7030,'[{1,29431},{3,23550},{5,11769},{13,1790}]',1765820),(166,7125,'[{1,29899},{3,23925},{5,11956},{13,1800}]',1793905),(167,7220,'[{1,30372},{3,24304},{5,12145},{13,1810}]',1822290),(168,7315,'[{1,30850},{3,24687},{5,12336},{13,1820}]',1850975),(169,7410,'[{1,31333},{3,25074},{5,12529},{13,1830}]',1879960),(170,7505,'[{1,31821},{3,25465},{5,12724},{13,1840}]',1909245),(171,7600,'[{1,32314},{3,25860},{5,12921},{13,1850}]',1938830),(172,7695,'[{1,32813},{3,26259},{5,13120},{13,1860}]',1968735),(173,7790,'[{1,33317},{3,26662},{5,13321},{13,1870}]',1998940),(174,7885,'[{1,33826},{3,27069},{5,13524},{13,1880}]',2029445),(175,7980,'[{1,34340},{3,27480},{5,13729},{13,1890}]',2060250),(176,8075,'[{1,34859},{3,27895},{5,13936},{13,1900}]',2091355),(177,8170,'[{1,35383},{3,28314},{5,14145},{13,1910}]',2122760),(178,8265,'[{1,35912},{3,28737},{5,14356},{13,1920}]',2154465),(179,8360,'[{1,36446},{3,29164},{5,14569},{13,1930}]',2186470),(180,8470,'[{1,36985},{3,29595},{5,14785},{13,1940}]',2218825),(181,8580,'[{1,37529},{3,30030},{5,15003},{13,1950}]',2251480),(182,8690,'[{1,38079},{3,30470},{5,15223},{13,1960}]',2284480),(183,8800,'[{1,38634},{3,30914},{5,15445},{13,1970}]',2317780),(184,8910,'[{1,39195},{3,31363},{5,15669},{13,1980}]',2351425),(185,9020,'[{1,39762},{3,31816},{5,15896},{13,1990}]',2385440),(186,9130,'[{1,40334},{3,32274},{5,16125},{13,2000}]',2419780),(187,9240,'[{1,40912},{3,32736},{5,16356},{13,2010}]',2454440),(188,9350,'[{1,41495},{3,33203},{5,16589},{13,2020}]',2489425),(189,9460,'[{1,42084},{3,33674},{5,16825},{13,2030}]',2524780),(190,9570,'[{1,42678},{3,34149},{5,17063},{13,2040}]',2560435),(191,9680,'[{1,43278},{3,34629},{5,17303},{13,2050}]',2596435),(192,9790,'[{1,43883},{3,35113},{5,17545},{13,2060}]',2632735),(193,9900,'[{1,44494},{3,35602},{5,17789},{13,2070}]',2669380),(194,10010,'[{1,45111},{3,36095},{5,18036},{13,2080}]',2706395),(195,10120,'[{1,45733},{3,36593},{5,18285},{13,2090}]',2743735),(196,10230,'[{1,46361},{3,37095},{5,18536},{13,2100}]',2781395),(197,10340,'[{1,46994},{3,37602},{5,18789},{13,2110}]',2819380),(198,10450,'[{1,47633},{3,38113},{5,19044},{13,2120}]',2857685),(199,10560,'[{1,48277},{3,38628},{5,19302},{13,2130}]',2896340),(200,10670,'[{1,48927},{3,39148},{5,19562},{13,2140}]',2935340),(201,10780,'[{1,49583},{3,39673},{5,19824},{13,2150}]',2974685),(202,10890,'[{1,50245},{3,40203},{5,20089},{13,2160}]',3014425),(203,11000,'[{1,50913},{3,40737},{5,20356},{13,2170}]',3054485),(204,11110,'[{1,51587},{3,41276},{5,20626},{13,2180}]',3094940),(205,11220,'[{1,52267},{3,41820},{5,20898},{13,2190}]',3135740),(206,11330,'[{1,52953},{3,42369},{5,21173},{13,2200}]',3176935),(207,11440,'[{1,53645},{3,42923},{5,21450},{13,2210}]',3218475),(208,11550,'[{1,54343},{3,43482},{5,21729},{13,2220}]',3260360),(209,11660,'[{1,55048},{3,44046},{5,22011},{13,2230}]',3302660),(210,11770,'[{1,55759},{3,44614},{5,22295},{13,2240}]',3345280),(211,11880,'[{1,56476},{3,45187},{5,22582},{13,2250}]',3388295),(212,11990,'[{1,57199},{3,45765},{5,22871},{13,2260}]',3431655),(213,12100,'[{1,57928},{3,46348},{5,23163},{13,2270}]',3475410),(214,12210,'[{1,58663},{3,46936},{5,23457},{13,2280}]',3519510),(215,12320,'[{1,59404},{3,47529},{5,23753},{13,2290}]',3563955),(216,12430,'[{1,60151},{3,48127},{5,24052},{13,2300}]',3608795),(217,12540,'[{1,60904},{3,48729},{5,24353},{13,2310}]',3653955),(218,12650,'[{1,61663},{3,49336},{5,24657},{13,2320}]',3699510),(219,12760,'[{1,62428},{3,49948},{5,24963},{13,2330}]',3745410),(220,12870,'[{1,63199},{3,50565},{5,25272},{13,2340}]',3791705),(221,12980,'[{1,63977},{3,51187},{5,25583},{13,2350}]',3838365),(222,13090,'[{1,64762},{3,51815},{5,25897},{13,2360}]',3885465),(223,13200,'[{1,65553},{3,52448},{5,26213},{13,2370}]',3932910),(224,13310,'[{1,66351},{3,53086},{5,26532},{13,2380}]',3980770),(225,13420,'[{1,67155},{3,53729},{5,26854},{13,2390}]',4029025),(226,13530,'[{1,67966},{3,54378},{5,27178},{13,2400}]',4077670),(227,13640,'[{1,68783},{3,55032},{5,27505},{13,2410}]',4126710),(228,13750,'[{1,69607},{3,55691},{5,27835},{13,2420}]',4176165),(229,13860,'[{1,70438},{3,56356},{5,28167},{13,2430}]',4226010),(230,13970,'[{1,71275},{3,57026},{5,28502},{13,2440}]',4276250),(231,14080,'[{1,72119},{3,57701},{5,28840},{13,2450}]',4326905),(232,14190,'[{1,72969},{3,58381},{5,29180},{13,2460}]',4377905),(233,14300,'[{1,73826},{3,59067},{5,29523},{13,2470}]',4429345),(234,14410,'[{1,74690},{3,59758},{5,29868},{13,2480}]',4481150),(235,14520,'[{1,75560},{3,60454},{5,30216},{13,2490}]',4533350),(236,14630,'[{1,76437},{3,61155},{5,30567},{13,2500}]',4585965),(237,14740,'[{1,77320},{3,61862},{5,30920},{13,2510}]',4638950),(238,14850,'[{1,78210},{3,62574},{5,31276},{13,2520}]',4692350),(239,14960,'[{1,79107},{3,63291},{5,31635},{13,2530}]',4746165),(240,15070,'[{1,80010},{3,64014},{5,31996},{13,2540}]',4800350);
/*!40000 ALTER TABLE `base_light_weapon_lv_attr` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_light_weapon_skill`
--

DROP TABLE IF EXISTS `base_light_weapon_skill`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_light_weapon_skill` (
  `id` int(11) unsigned NOT NULL COMMENT 'id',
  `skill_id` bigint(20) unsigned NOT NULL COMMENT '技能id',
  `unlock_lv` smallint(5) unsigned NOT NULL COMMENT '解锁等级',
  PRIMARY KEY (`id`),
  UNIQUE KEY `skill_id` (`skill_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='光武-专武技能表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_light_weapon_skill`
--

LOCK TABLES `base_light_weapon_skill` WRITE;
/*!40000 ALTER TABLE `base_light_weapon_skill` DISABLE KEYS */;
INSERT INTO `base_light_weapon_skill` VALUES (1,50210010,1),(2,50210020,50),(3,50210030,100),(4,50210040,160);
/*!40000 ALTER TABLE `base_light_weapon_skill` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_light_weapon_upgrade`
--

DROP TABLE IF EXISTS `base_light_weapon_upgrade`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_light_weapon_upgrade` (
  `goods_id` bigint(20) unsigned NOT NULL COMMENT '物品id',
  `attr` varchar(512) NOT NULL COMMENT '提升属性',
  `combat_power` int(11) unsigned NOT NULL COMMENT '提升战力（展示用）',
  `max_times` smallint(5) unsigned NOT NULL COMMENT '最大使用次数',
  PRIMARY KEY (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='光武-专武属性表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_light_weapon_upgrade`
--

LOCK TABLES `base_light_weapon_upgrade` WRITE;
/*!40000 ALTER TABLE `base_light_weapon_upgrade` DISABLE KEYS */;
INSERT INTO `base_light_weapon_upgrade` VALUES (53030010,'[{3,80}]',2000,500),(53030020,'[{5,40}]',2000,500),(53030030,'[{3,80},{5,40},{68,100}]',5000,150);
/*!40000 ALTER TABLE `base_light_weapon_upgrade` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_light_weapon_uplv`
--

DROP TABLE IF EXISTS `base_light_weapon_uplv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_light_weapon_uplv` (
  `id` int(11) unsigned NOT NULL COMMENT 'id',
  `goods_id` bigint(20) unsigned NOT NULL COMMENT '物品id',
  `add_exp` int(11) unsigned NOT NULL COMMENT '增加经验值',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='光武-专武升级表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_light_weapon_uplv`
--

LOCK TABLES `base_light_weapon_uplv` WRITE;
/*!40000 ALTER TABLE `base_light_weapon_uplv` DISABLE KEYS */;
INSERT INTO `base_light_weapon_uplv` VALUES (1,53020010,30),(2,53020020,100),(3,53020030,200);
/*!40000 ALTER TABLE `base_light_weapon_uplv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_limit_goal_main`
--

DROP TABLE IF EXISTS `base_limit_goal_main`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_limit_goal_main` (
  `goal_id` int(10) unsigned NOT NULL COMMENT '目标id',
  `model_name` varchar(255) NOT NULL COMMENT '目标模型名称@lang@',
  `model_id` int(10) unsigned NOT NULL COMMENT '目标模型展示ID',
  `jump_cfg` varchar(255) NOT NULL COMMENT '激活跳转配置',
  `skill_id` bigint(10) unsigned NOT NULL COMMENT '技能ID',
  `skill_desc` varchar(512) NOT NULL COMMENT '技能描述@lang@',
  `precondition` varchar(512) NOT NULL COMMENT '目标解锁条件',
  `activate` varchar(255) NOT NULL DEFAULT '[]' COMMENT '激活功能',
  `countdown` int(10) unsigned NOT NULL COMMENT '目标倒计时（秒）',
  PRIMARY KEY (`goal_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='限时目标-目标配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_limit_goal_main`
--

LOCK TABLES `base_limit_goal_main` WRITE;
/*!40000 ALTER TABLE `base_limit_goal_main` DISABLE KEYS */;
INSERT INTO `base_limit_goal_main` VALUES (1,'冰雪女王',203017,'[440,1002]',16000230,'对目标区域4个玩家（8个怪物）造成545%的伤害，提升自身PVE伤害20%，持续3秒','[]','[{god,1002}]',216000),(2,'霜之哀伤',203017,'[440,11030002]',30000002,'攻击时有10%的概率提升自身减伤10%，持续5s','[1]','[{god_pyx,11030002}]',345600);
/*!40000 ALTER TABLE `base_limit_goal_main` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_limit_goal_soul`
--

DROP TABLE IF EXISTS `base_limit_goal_soul`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_limit_goal_soul` (
  `goal_id` int(10) unsigned NOT NULL COMMENT '目标id',
  `soul_id` int(10) unsigned NOT NULL COMMENT '星魂id',
  `soul_name` varchar(255) NOT NULL COMMENT '星魂名字@lang@',
  `need_finish` int(10) unsigned NOT NULL COMMENT '所需完成任务数量',
  `attr` varchar(512) NOT NULL COMMENT '星魂属性',
  PRIMARY KEY (`goal_id`,`soul_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='限时目标-星魂属性表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_limit_goal_soul`
--

LOCK TABLES `base_limit_goal_soul` WRITE;
/*!40000 ALTER TABLE `base_limit_goal_soul` DISABLE KEYS */;
INSERT INTO `base_limit_goal_soul` VALUES (1,1,'冰雪星魂1',1,'[{1,100}]'),(1,2,'冰雪星魂2',2,'[{2,2000}]'),(1,3,'冰雪星魂3',3,'[{5,40}]'),(1,4,'冰雪星魂4',4,'[{6,40}]'),(1,5,'冰雪星魂5',5,'[{1,100}]'),(1,6,'冰雪星魂6',6,'[{2,2000}]'),(1,7,'冰雪星魂7',7,'[{5,40}]'),(1,8,'冰雪星魂8',8,'[{6,40}]'),(2,1,'霜之星魂1',1,'[{1,250}]'),(2,2,'霜之星魂2',2,'[{2,5000}]'),(2,3,'霜之星魂3',3,'[{5,100}]'),(2,4,'霜之星魂4',4,'[{6,100}]'),(2,5,'霜之星魂5',5,'[{1,250}]'),(2,6,'霜之星魂6',6,'[{2,5000}]'),(2,7,'霜之星魂7',7,'[{5,100}]'),(2,8,'霜之星魂8',8,'[{6,100}]');
/*!40000 ALTER TABLE `base_limit_goal_soul` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_limit_goal_task`
--

DROP TABLE IF EXISTS `base_limit_goal_task`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_limit_goal_task` (
  `goal_id` int(10) unsigned NOT NULL COMMENT '目标id',
  `task_id` int(10) unsigned NOT NULL COMMENT '目标任务id',
  `task_desc` varchar(512) NOT NULL COMMENT '目标任务描述@lang@',
  `finish_condition` varchar(512) NOT NULL COMMENT '任务完成条件',
  `reward` varchar(512) NOT NULL COMMENT '任务奖励',
  `click_jump` varchar(255) NOT NULL COMMENT '任务前往跳转',
  PRIMARY KEY (`goal_id`,`task_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='限时目标-任务配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_limit_goal_task`
--

LOCK TABLES `base_limit_goal_task` WRITE;
/*!40000 ALTER TABLE `base_limit_goal_task` DISABLE KEYS */;
INSERT INTO `base_limit_goal_task` VALUES (1,1,'魂珠副本通关第3层','[{dungeon_level,20,3}]','[{0,11010004,1}]','[610,5]'),(1,2,'累计进入经验副本2次','[{dungeon_times,4,2}]','[{0,11010004,1}]','[610,31]'),(1,3,'完成1转','[{turn,1}]','[{0,11010004,1}]','[2,1]'),(1,4,'获得150级以上首领遗迹BOSS的归属4次','[{local_boss,5,150,4}]','[{0,11010004,1}]','[460,1]'),(1,5,'累计登陆2天','[{login_days,2}]','[{0,11010004,1}]','[417,1]'),(1,6,'降神-光辉神培养到达5阶','[{god_upgrade,1001,5}]','[{0,11010004,1}]','[440,1]'),(1,7,'坐骑升星到达2阶','[{mount_upgrade,2}]','[{0,11010004,1}]','[160,1]'),(1,8,'宝具等级到达8级','[{talisman_lv, 8}]','[{0,11010004,1}]','[168,1]'),(2,1,'累计进入经验副本8次','[{dungeon_times,4,8}]','[{0,11030004,1}]','[610,31]'),(2,2,'完成2转','[{turn,2}]','[{0,11030004,1}]','[2,1]'),(2,3,'获得250级以上首领遗迹BOSS的归属6次','[{local_boss,5,250,6}]','[{0,11030004,1}]','[460,1]'),(2,4,'魂珠副本通关第24层','[{dungeon_level,20,24}]','[{0,11030004,1}]','[610,5]'),(2,5,'累计登陆5天','[{login_days,5}]','[{0,11030004,1}]','[417,1]'),(2,6,'降神-冰雪女王培养到达5阶','[{god_upgrade,1002,5}]','[{0,11030004,1}]','[440,1]'),(2,7,'坐骑升星到达3阶','[{mount_upgrade,3}]','[{0,11030004,1}]','[160,1]'),(2,8,'宝具等级到达20级','[{talisman_lv,20}]','[{0,11030004,1}]','[168,1]');
/*!40000 ALTER TABLE `base_limit_goal_task` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_limit_shop_sell`
--

DROP TABLE IF EXISTS `base_limit_shop_sell`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_limit_shop_sell` (
  `sell_id` int(10) unsigned NOT NULL COMMENT '商品id',
  `goods_list` varchar(500) NOT NULL COMMENT '物品列表',
  `cost_list` varchar(500) NOT NULL COMMENT '消耗列表',
  `discount` int(10) unsigned NOT NULL COMMENT '折扣（70为七折）',
  `limit_num` int(10) unsigned NOT NULL COMMENT '限购份数',
  `limit_time` int(10) unsigned NOT NULL COMMENT '限购时间',
  `start_lv` int(10) unsigned NOT NULL COMMENT '开始等级',
  PRIMARY KEY (`sell_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='神秘限购商品配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_limit_shop_sell`
--

LOCK TABLES `base_limit_shop_sell` WRITE;
/*!40000 ALTER TABLE `base_limit_shop_sell` DISABLE KEYS */;
INSERT INTO `base_limit_shop_sell` VALUES (1,'[{3,36030001,880000}]','[{1,0,100}]',1,1,86400,60),(2,'[{100,16020001,5}]','[{1,0,100}]',1,1,86400,60),(3,'[{100,32030201,1}]','[{1,0,60}]',10,1,86400,85),(4,'[{255,36160007,12000}]','[{1,0,100}]',20,1,86400,120),(5,'[{100,32160006,5}]','[{1,0,250}]',20,1,86400,120),(6,'[{100,4908021,1}]','[{1,0,1600}]',5,1,86400,170);
/*!40000 ALTER TABLE `base_limit_shop_sell` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_live_skill_food`
--

DROP TABLE IF EXISTS `base_live_skill_food`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_live_skill_food` (
  `food_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '食物id',
  `type_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '类型id',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '名称',
  `need_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '所需技能等级',
  `weight` varchar(255) NOT NULL DEFAULT '[]' COMMENT '权重',
  PRIMARY KEY (`food_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_live_skill_food`
--

LOCK TABLES `base_live_skill_food` WRITE;
/*!40000 ALTER TABLE `base_live_skill_food` DISABLE KEYS */;
INSERT INTO `base_live_skill_food` VALUES (46020011,4,'可口',1,'[{1,120},{2,100},{3,90},{4,80},{5,70}]'),(46020012,4,'美味',1,'[{1,90},{2,100},{3,100},{4,110},{5,110}]'),(46020013,4,'佳肴',1,'[{1,50},{2,60},{3,70},{4,80},{5,90}]'),(46020014,4,'珍品',1,'[{1,30},{2,40},{3,50},{4,60},{5,70}]'),(46020021,5,'可口',1,'[{1,120},{2,100},{3,90},{4,80},{5,70}]'),(46020022,5,'美味',1,'[{1,90},{2,100},{3,100},{4,110},{5,110}]'),(46020023,5,'佳肴',1,'[{1,50},{2,60},{3,70},{4,80},{5,90}]'),(46020024,5,'珍品',1,'[{1,30},{2,40},{3,50},{4,60},{5,70}]'),(46020031,6,'可口',1,'[{1,120},{2,100},{3,90},{4,80},{5,70}]'),(46020032,6,'美味',1,'[{1,90},{2,100},{3,100},{4,110},{5,110}]'),(46020033,6,'佳肴',1,'[{1,50},{2,60},{3,70},{4,80},{5,90}]'),(46020034,6,'珍品',1,'[{1,30},{2,40},{3,50},{4,60},{5,70}]'),(46020041,7,'可口',1,'[{1,120},{2,100},{3,90},{4,80},{5,70}]'),(46020042,7,'美味',1,'[{1,90},{2,100},{3,100},{4,110},{5,110}]'),(46020043,7,'佳肴',1,'[{1,50},{2,60},{3,70},{4,80},{5,90}]'),(46020044,7,'珍品',1,'[{1,30},{2,40},{3,50},{4,60},{5,70}]'),(46020051,8,'可口',1,'[{1,120},{2,100},{3,90},{4,80},{5,70}]'),(46020052,8,'美味',1,'[{1,90},{2,100},{3,100},{4,110},{5,110}]'),(46020053,8,'佳肴',1,'[{1,50},{2,60},{3,70},{4,80},{5,90}]'),(46020054,8,'珍品',1,'[{1,30},{2,40},{3,50},{4,60},{5,70}]'),(46020061,9,'可口',1,'[{1,120},{2,100},{3,90},{4,80},{5,70}]'),(46020062,9,'美味',1,'[{1,90},{2,100},{3,100},{4,110},{5,110}]'),(46020063,9,'佳肴',1,'[{1,50},{2,60},{3,70},{4,80},{5,90}]'),(46020064,9,'珍品',1,'[{1,30},{2,40},{3,50},{4,60},{5,70}]'),(46020071,10,'可口',1,'[{1,120},{2,100},{3,90},{4,80},{5,70}]'),(46020072,10,'美味',1,'[{1,90},{2,100},{3,100},{4,110},{5,110}]'),(46020073,10,'佳肴',1,'[{1,50},{2,60},{3,70},{4,80},{5,90}]'),(46020074,10,'珍品',1,'[{1,30},{2,40},{3,50},{4,60},{5,70}]'),(46020081,11,'可口',1,'[{1,120},{2,100},{3,90},{4,80},{5,70}]'),(46020082,11,'美味',1,'[{1,90},{2,100},{3,100},{4,110},{5,110}]'),(46020083,11,'佳肴',1,'[{1,50},{2,60},{3,70},{4,80},{5,90}]'),(46020084,11,'珍品',1,'[{1,30},{2,40},{3,50},{4,60},{5,70}]'),(46020091,12,'可口',1,'[{1,120},{2,100},{3,90},{4,80},{5,70}]'),(46020092,12,'美味',1,'[{1,90},{2,100},{3,100},{4,110},{5,110}]'),(46020093,12,'佳肴',1,'[{1,50},{2,60},{3,70},{4,80},{5,90}]'),(46020094,12,'珍品',1,'[{1,30},{2,40},{3,50},{4,60},{5,70}]'),(46020101,13,'可口',1,'[{1,120},{2,100},{3,90},{4,80},{5,70}]'),(46020102,13,'美味',1,'[{1,90},{2,100},{3,100},{4,110},{5,110}]'),(46020103,13,'佳肴',1,'[{1,50},{2,60},{3,70},{4,80},{5,90}]'),(46020104,13,'珍品',1,'[{1,30},{2,40},{3,50},{4,60},{5,70}]'),(46020111,14,'可口',1,'[{1,120},{2,100},{3,90},{4,80},{5,70}]'),(46020112,14,'美味',1,'[{1,90},{2,100},{3,100},{4,110},{5,110}]'),(46020113,14,'佳肴',1,'[{1,50},{2,60},{3,70},{4,80},{5,90}]'),(46020114,14,'珍品',1,'[{1,30},{2,40},{3,50},{4,60},{5,70}]'),(46020121,15,'可口',1,'[{1,120},{2,100},{3,90},{4,80},{5,70}]'),(46020122,15,'美味',1,'[{1,90},{2,100},{3,100},{4,110},{5,110}]'),(46020123,15,'佳肴',1,'[{1,50},{2,60},{3,70},{4,80},{5,90}]'),(46020124,15,'珍品',1,'[{1,30},{2,40},{3,50},{4,60},{5,70}]'),(46020131,16,'可口',1,'[{1,120},{2,100},{3,90},{4,80},{5,70}]'),(46020132,16,'美味',1,'[{1,90},{2,100},{3,100},{4,110},{5,110}]'),(46020133,16,'佳肴',1,'[{1,50},{2,60},{3,70},{4,80},{5,90}]'),(46020134,16,'珍品',1,'[{1,30},{2,40},{3,50},{4,60},{5,70}]'),(46020141,17,'可口',1,'[{1,120},{2,100},{3,90},{4,80},{5,70}]'),(46020142,17,'美味',1,'[{1,90},{2,100},{3,100},{4,110},{5,110}]'),(46020143,17,'佳肴',1,'[{1,50},{2,60},{3,70},{4,80},{5,90}]'),(46020144,17,'珍品',1,'[{1,30},{2,40},{3,50},{4,60},{5,70}]'),(46020151,18,'可口',1,'[{1,120},{2,100},{3,90},{4,80},{5,70}]'),(46020152,18,'美味',1,'[{1,90},{2,100},{3,100},{4,110},{5,110}]'),(46020153,18,'佳肴',1,'[{1,50},{2,60},{3,70},{4,80},{5,90}]'),(46020154,18,'珍品',1,'[{1,30},{2,40},{3,50},{4,60},{5,70}]'),(46020161,19,'可口',1,'[{1,120},{2,100},{3,90},{4,80},{5,70}]'),(46020162,19,'美味',1,'[{1,90},{2,100},{3,100},{4,110},{5,110}]'),(46020163,19,'佳肴',1,'[{1,50},{2,60},{3,70},{4,80},{5,90}]'),(46020164,19,'珍品',1,'[{1,30},{2,40},{3,50},{4,60},{5,70}]'),(46020171,20,'可口',1,'[{1,120},{2,100},{3,90},{4,80},{5,70}]'),(46020172,20,'美味',1,'[{1,90},{2,100},{3,100},{4,110},{5,110}]'),(46020173,20,'佳肴',1,'[{1,50},{2,60},{3,70},{4,80},{5,90}]'),(46020174,20,'珍品',1,'[{1,30},{2,40},{3,50},{4,60},{5,70}]'),(46020181,21,'可口',1,'[{1,120},{2,100},{3,90},{4,80},{5,70}]'),(46020182,21,'美味',1,'[{1,90},{2,100},{3,100},{4,110},{5,110}]'),(46020183,21,'佳肴',1,'[{1,50},{2,60},{3,70},{4,80},{5,90}]'),(46020184,21,'珍品',1,'[{1,30},{2,40},{3,50},{4,60},{5,70}]'),(46020193,22,'佳肴',1,'[{1,50},{2,60},{3,70},{4,80},{5,90}]'),(46020194,22,'珍品',1,'[{1,30},{2,40},{3,50},{4,60},{5,70}]'),(46020203,23,'佳肴',1,'[{1,50},{2,60},{3,70},{4,80},{5,90}]'),(46020204,23,'珍品',1,'[{1,30},{2,40},{3,50},{4,60},{5,70}]'),(46020213,24,'佳肴',1,'[{1,50},{2,60},{3,70},{4,80},{5,90}]'),(46020214,24,'珍品',1,'[{1,30},{2,40},{3,50},{4,60},{5,70}]'),(46020223,25,'佳肴',1,'[{1,50},{2,60},{3,70},{4,80},{5,90}]'),(46020224,25,'珍品',1,'[{1,30},{2,40},{3,50},{4,60},{5,70}]'),(46020231,1,'可口',1,'[{1,120},{2,100},{3,90},{4,80},{5,70}]'),(46020232,1,'美味',1,'[{1,90},{2,100},{3,100},{4,110},{5,110}]'),(46020233,1,'佳肴',1,'[{1,50},{2,60},{3,70},{4,80},{5,90}]'),(46020241,2,'可口',1,'[{1,120},{2,100},{3,90},{4,80},{5,70}]'),(46020242,2,'美味',1,'[{1,90},{2,100},{3,100},{4,110},{5,110}]'),(46020243,2,'佳肴',1,'[{1,50},{2,60},{3,70},{4,80},{5,90}]'),(46020251,3,'可口',1,'[{1,120},{2,100},{3,90},{4,80},{5,70}]'),(46020252,3,'美味',1,'[{1,90},{2,100},{3,100},{4,110},{5,110}]'),(46020253,3,'佳肴',1,'[{1,50},{2,60},{3,70},{4,80},{5,90}]');
/*!40000 ALTER TABLE `base_live_skill_food` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_live_skill_food_type`
--

DROP TABLE IF EXISTS `base_live_skill_food_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_live_skill_food_type` (
  `type_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '类型id',
  `kind` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '种类id',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '名称',
  `need_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '建筑所需等级',
  `good_id` int(11) NOT NULL DEFAULT '0' COMMENT '食谱id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '制作时间',
  `add_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '加熟练度',
  `cost_live` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '所需活力',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗材料',
  `icon` varchar(50) NOT NULL DEFAULT '0' COMMENT '图标',
  `eat_effect` varchar(50) NOT NULL COMMENT '食用效果@lang@',
  PRIMARY KEY (`type_id`,`kind`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_live_skill_food_type`
--

LOCK TABLES `base_live_skill_food_type` WRITE;
/*!40000 ALTER TABLE `base_live_skill_food_type` DISABLE KEYS */;
INSERT INTO `base_live_skill_food_type` VALUES (1,1,'炸虾',0,0,1,50,40,'[]','46020231','增加攻击'),(2,1,'芝士块',0,0,1,50,40,'[]','46020241','增加破甲'),(3,1,'紫菜寿司',0,0,1,50,40,'[]','46020251','增加防御'),(4,2,'烤鸡',1,0,1,50,50,'[{0,46010001,1}]','46020011','增加攻击'),(5,2,'烤鱼',3,0,2,100,50,'[{0,46010002,1}]','46020021','增加破甲'),(6,2,'汉堡',6,0,4,200,50,'[{0,46010003,1}]','46020031','增加防御'),(7,2,'三明治',9,0,7,300,50,'[{0,46010004,1}]','46020041','增加命中'),(8,2,'巧克力',12,0,10,400,50,'[{0,46010005,1}]','46020051','增加闪避'),(9,2,'牛排',15,0,15,460,50,'[{0,46010006,1}]','46020061','增加暴击'),(10,2,'面包',18,0,2,135,50,'[{0,46010007,1}]','46020071','增加韧性'),(11,2,'奶茶',21,0,4,235,50,'[{0,46010008,1}]','46020081','增加暴伤值'),(12,2,'蔬菜卷',24,0,7,335,50,'[{0,46010009,1}]','46020091','增加抗暴值'),(13,3,'鱼排',27,0,10,435,50,'[{0,46010010,1}]','46020101','增加冰系伤害、冰系伤害加成'),(14,3,'蘑菇汤',27,0,15,480,50,'[{0,46010011,1}]','46020111','增加冰系防御、冰系防御加成'),(15,3,'蛋糕',30,0,7,215,50,'[{0,46010012,1}]','46020121','增加雷系伤害、雷系伤害加成'),(16,3,'布丁',30,0,10,315,50,'[{0,46010013,1}]','46020131','增加雷系防御、雷系防御加成'),(17,3,'烤蝎',33,0,15,415,50,'[{0,46010014,1}]','46020141','增加火系伤害、火系伤害加成'),(18,3,'团子',33,0,7,250,50,'[{0,46010015,1}]','46020151','增加火系防御、火系防御加成'),(19,3,'果冻',36,0,10,350,50,'[{0,46010016,1}]','46020161','增加风系伤害、风系伤害加成'),(20,3,'蛋卷',36,0,15,445,50,'[{0,46010017,1}]','46020171','增加风系防御、风系防御加成'),(21,3,'雪糕',40,0,20,500,50,'[{0,46010018,1}]','46020181','增加会心一击'),(22,4,'奇迹小脆饼',1,0,25,500,50,'[{0,46010019,1}]','46020193','增加经验加成'),(23,4,'王者沙拉',10,0,25,500,50,'[{0,46010020,1}]','46020203','增加移动速度'),(24,4,'龙王雪花糕',15,0,25,500,50,'[{0,46010021,1}]','46020213','增加生命回复'),(25,4,'海灵鲜果茶',25,0,25,500,50,'[{0,46010022,1}]','46020223','增加伤害加深');
/*!40000 ALTER TABLE `base_live_skill_food_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_live_skill_furniture`
--

DROP TABLE IF EXISTS `base_live_skill_furniture`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_live_skill_furniture` (
  `furniture_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '家具id',
  `type_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '类型id',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '名称',
  `need_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '所需技能等级',
  `prosperity` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '繁荣度',
  `area` varchar(50) NOT NULL DEFAULT '[]' COMMENT '规格',
  `weight` varchar(255) NOT NULL DEFAULT '[]' COMMENT '权重',
  `map_id` int(11) NOT NULL DEFAULT '0' COMMENT '放置面',
  `offset_x` varchar(50) NOT NULL DEFAULT '[]' COMMENT 'x偏移量',
  `offset_y` varchar(50) NOT NULL DEFAULT '[]' COMMENT 'y偏移量',
  `offset_h` varchar(50) NOT NULL DEFAULT '0' COMMENT '高度偏移',
  `res_icon` varchar(50) NOT NULL COMMENT '资源',
  `rotate` varchar(255) NOT NULL DEFAULT '[]' COMMENT '旋转角度',
  `location` varchar(255) NOT NULL DEFAULT '[]' COMMENT '位置',
  PRIMARY KEY (`furniture_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_live_skill_furniture`
--

LOCK TABLES `base_live_skill_furniture` WRITE;
/*!40000 ALTER TABLE `base_live_skill_furniture` DISABLE KEYS */;
INSERT INTO `base_live_skill_furniture` VALUES (47030011,4,'[良好]朴素小床',1,10,'[{662,269,740}]','[{1,80},{2,60},{3,60},{4,30},{5,10}]',0,'[]','[]','0','74051000','[{1,135},{2,45}]','[]'),(47030012,4,'[精致]朴素小床',3,15,'[{662,269,740}]','[{1,80},{2,60},{3,60},{4,30},{5,10}]',0,'[]','[]','0','74051000','[{1,135},{2,45}]','[]'),(47030013,4,'[华丽]朴素小床',6,24,'[{662,269,740}]','[{1,80},{2,60},{3,60},{4,30},{5,10}]',0,'[]','[]','0','74051000','[{1,135},{2,45}]','[]'),(47030014,4,'[完美]朴素小床',9,36,'[{662,269,740}]','[{1,80},{2,60},{3,60},{4,30},{5,10}]',0,'[]','[]','0','74051000','[{1,135},{2,45}]','[]'),(47030021,5,'[良好]褐色书柜',1,10,'[{310,470,137}]','[{1,80},{2,60},{3,60},{4,30},{5,10}]',0,'[]','[]','0','74051004','[{1,225},{2,135}]','[]'),(47030022,5,'[精致]褐色书柜',3,15,'[{310,470,137}]','[{1,80},{2,60},{3,60},{4,30},{5,10}]',0,'[]','[]','0','74051004','[{1,225},{2,135}]','[]'),(47030023,5,'[华丽]褐色书柜',6,24,'[{310,470,137}]','[{1,80},{2,60},{3,60},{4,30},{5,10}]',0,'[]','[]','0','74051004','[{1,225},{2,135}]','[]'),(47030024,5,'[完美]褐色书柜',9,36,'[{310,470,137}]','[{1,80},{2,60},{3,60},{4,30},{5,10}]',0,'[]','[]','0','74051004','[{1,225},{2,135}]','[]'),(47030031,6,'[良好]白色衣柜',1,10,'[{454,522,141}]','[{1,80},{2,60},{3,60},{4,30},{5,10}]',0,'[]','[]','0','74051006','[{1,225},{2,135}]','[]'),(47030032,6,'[精致]白色衣柜',4,15,'[{454,522,141}]','[{1,80},{2,60},{3,60},{4,30},{5,10}]',0,'[]','[]','0','74051006','[{1,225},{2,135}]','[]'),(47030033,6,'[华丽]白色衣柜',7,24,'[{466,549,154}]','[{1,80},{2,60},{3,60},{4,30},{5,10}]',0,'[]','[]','0','74051006','[{1,225},{2,135}]','[]'),(47030034,6,'[完美]白色衣柜',10,36,'[{466,549,154}]','[{1,80},{2,60},{3,60},{4,30},{5,10}]',0,'[]','[]','0','74051006','[{1,225},{2,135}]','[]'),(47030041,7,'[完美]蜜语圆床',1,50,'[{550,453,580}]','[{1,80},{2,60},{3,60},{4,30},{5,10}]',0,'[]','[]','0','74051002','[{1,135},{2,45}]','[]'),(47040011,8,'[良好]红色圆凳',4,10,'[{146,117,146}]','[{1,80},{2,80},{3,60},{4,20},{5,20}]',0,'[]','[]','0','74052001','[{1,135},{2,45}]','[]'),(47040012,8,'[精致]红色圆凳',8,15,'[{146,117,146}]','[{1,80},{2,80},{3,60},{4,20},{5,20}]',0,'[]','[]','0','74052001','[{1,135},{2,45}]','[]'),(47040013,8,'[华丽]红色圆凳',12,24,'[{146,117,146}]','[{1,80},{2,80},{3,60},{4,20},{5,20}]',0,'[]','[]','0','74052001','[{1,135},{2,45}]','[]'),(47040014,8,'[完美]红色圆凳',18,36,'[{146,117,146}]','[{1,80},{2,80},{3,60},{4,20},{5,20}]',0,'[]','[]','0','74052001','[{1,135},{2,45}]','[]'),(47040021,9,'[良好]红色椅子',8,10,'[{192,276,176}]','[{1,80},{2,80},{3,60},{4,20},{5,20}]',0,'[]','[]','0','74052002','[{1,225},{2,135}]','[]'),(47040022,9,'[精致]红色椅子',12,15,'[{192,276,176}]','[{1,80},{2,80},{3,60},{4,20},{5,20}]',0,'[]','[]','0','74052002','[{1,225},{2,135}]','[]'),(47040023,9,'[华丽]红色椅子',17,24,'[{192,276,176}]','[{1,80},{2,80},{3,60},{4,20},{5,20}]',0,'[]','[]','0','74052002','[{1,225},{2,135}]','[]'),(47040024,9,'[完美]红色椅子',21,36,'[{192,276,176}]','[{1,80},{2,80},{3,60},{4,20},{5,20}]',0,'[]','[]','0','74052002','[{1,225},{2,135}]','[]'),(47040031,10,'[良好]简易圆桌',12,10,'[{299,251,292}]','[{1,80},{2,80},{3,60},{4,20},{5,20}]',0,'[]','[]','0','74052005','[{1,225},{2,135}]','[]'),(47040032,10,'[精致]简易圆桌',17,15,'[{299,251,292}]','[{1,80},{2,80},{3,60},{4,20},{5,20}]',0,'[]','[]','0','74052005','[{1,225},{2,135}]','[]'),(47040033,10,'[华丽]简易圆桌',21,24,'[{299,251,292}]','[{1,80},{2,80},{3,60},{4,20},{5,20}]',0,'[]','[]','0','74052005','[{1,225},{2,135}]','[]'),(47040034,10,'[完美]简易圆桌',24,36,'[{299,251,292}]','[{1,80},{2,80},{3,60},{4,20},{5,20}]',0,'[]','[]','0','74052005','[{1,225},{2,135}]','[]'),(47040041,11,'[良好]方形书桌',16,10,'[{226,139,226}]','[{1,80},{2,80},{3,60},{4,20},{5,20}]',0,'[]','[]','0','74052007','[{1,225},{2,135}]','[]'),(47040042,11,'[精致]方形书桌',21,15,'[{226,139,226}]','[{1,80},{2,80},{3,60},{4,20},{5,20}]',0,'[]','[]','0','74052007','[{1,225},{2,135}]','[]'),(47040043,11,'[华丽]方形书桌',24,24,'[{226,139,226}]','[{1,80},{2,80},{3,60},{4,20},{5,20}]',0,'[]','[]','0','74052007','[{1,225},{2,135}]','[]'),(47040044,11,'[完美]方形书桌',27,36,'[{226,139,226}]','[{1,80},{2,80},{3,60},{4,20},{5,20}]',0,'[]','[]','0','74052007','[{1,225},{2,135}]','[]'),(47040051,12,'[良好]简约茶几',22,10,'[{248,156,167}]','[{1,80},{2,80},{3,60},{4,20},{5,20}]',0,'[]','[]','0','74052008','[{1,225},{2,135}]','[]'),(47040052,12,'[精致]简约茶几',24,15,'[{248,156,167}]','[{1,80},{2,80},{3,60},{4,20},{5,20}]',0,'[]','[]','0','74052008','[{1,225},{2,135}]','[]'),(47040053,12,'[华丽]简约茶几',27,24,'[{248,156,167}]','[{1,80},{2,80},{3,60},{4,20},{5,20}]',0,'[]','[]','0','74052008','[{1,225},{2,135}]','[]'),(47040054,12,'[完美]简约茶几',30,36,'[{248,156,167}]','[{1,80},{2,80},{3,60},{4,20},{5,20}]',0,'[]','[]','0','74052008','[{1,225},{2,135}]','[]'),(47040061,13,'[完美]温馨沙发',1,60,'[{197,275,199}]','[{1,80},{2,80},{3,60},{4,20},{5,20}]',0,'[]','[]','0','74052003','[{1,225},{2,135}]','[]'),(47040071,14,'[完美]典雅茶几',1,60,'[{248,151,167}]','[{1,80},{2,80},{3,60},{4,20},{5,20}]',0,'[]','[]','0','74052009','[{1,225},{2,135}]','[]'),(47050011,15,'[良好]小伞台灯',25,10,'[{82,297,87}]','[{1,100},{2,80},{3,80},{4,40},{5,20}]',0,'[]','[]','0','74053000','[{1,135},{2,45}]','[]'),(47050012,15,'[精致]小伞台灯',27,15,'[{82,297,87}]','[{1,100},{2,80},{3,80},{4,40},{5,20}]',0,'[]','[]','0','74053000','[{1,135},{2,45}]','[]'),(47050013,15,'[华丽]小伞台灯',30,24,'[{82,297,87}]','[{1,100},{2,80},{3,80},{4,40},{5,20}]',0,'[]','[]','0','74053000','[{1,135},{2,45}]','[]'),(47050014,15,'[完美]小伞台灯',33,36,'[{82,297,87}]','[{1,100},{2,80},{3,80},{4,40},{5,20}]',0,'[]','[]','0','74053000','[{1,135},{2,45}]','[]'),(47050021,16,'[良好]风景屏风',28,10,'[{233,312,12}]','[{1,100},{2,80},{3,80},{4,40},{5,20}]',1,'[]','[]','0','74053004','[{1,225},{2,135}]','[{1,{{1,300},{2,300}}},{2,{{1,510},{2,510},{3,510},{4,510}}},{3,{{1,359},{2,359},{3,359},{4,359},{5,1087},{6,1087}}},{4,{{1,364},{2,364},{3,1078},{4,1078},{5,364},{6,364},{7,364},{8,364}}}]'),(47050022,16,'[精致]风景屏风',30,15,'[{233,312,12}]','[{1,100},{2,80},{3,80},{4,40},{5,20}]',1,'[]','[]','0','74053004','[{1,225},{2,135}]','[{1,{{1,300},{2,300}}},{2,{{1,510},{2,510},{3,510},{4,510}}},{3,{{1,359},{2,359},{3,359},{4,359},{5,1087},{6,1087}}},{4,{{1,364},{2,364},{3,1078},{4,1078},{5,364},{6,364},{7,364},{8,364}}}]'),(47050023,16,'[华丽]风景屏风',33,24,'[{233,312,12}]','[{1,100},{2,80},{3,80},{4,40},{5,20}]',1,'[]','[]','0','74053004','[{1,225},{2,135}]','[{1,{{1,300},{2,300}}},{2,{{1,510},{2,510},{3,510},{4,510}}},{3,{{1,359},{2,359},{3,359},{4,359},{5,1087},{6,1087}}},{4,{{1,364},{2,364},{3,1078},{4,1078},{5,364},{6,364},{7,364},{8,364}}}]'),(47050024,16,'[完美]风景屏风',36,36,'[{233,312,12}]','[{1,100},{2,80},{3,80},{4,40},{5,20}]',1,'[]','[]','0','74053004','[{1,225},{2,135}]','[{1,{{1,300},{2,300}}},{2,{{1,510},{2,510},{3,510},{4,510}}},{3,{{1,359},{2,359},{3,359},{4,359},{5,1087},{6,1087}}},{4,{{1,364},{2,364},{3,1078},{4,1078},{5,364},{6,364},{7,364},{8,364}}}]'),(47050031,17,'[良好]小树盆栽',31,10,'[{101,214,101}]','[{1,100},{2,80},{3,80},{4,40},{5,20}]',0,'[]','[]','0','74053005','[{1,135},{2,45}]','[]'),(47050032,17,'[精致]小树盆栽',33,15,'[{101,214,101}]','[{1,100},{2,80},{3,80},{4,40},{5,20}]',0,'[]','[]','0','74053005','[{1,135},{2,45}]','[]'),(47050033,17,'[华丽]小树盆栽',36,24,'[{101,214,101}]','[{1,100},{2,80},{3,80},{4,40},{5,20}]',0,'[]','[]','0','74053005','[{1,135},{2,45}]','[]'),(47050034,17,'[完美]小树盆栽',39,36,'[{101,214,101}]','[{1,100},{2,80},{3,80},{4,40},{5,20}]',0,'[]','[]','0','74053005','[{1,135},{2,45}]','[]'),(47050041,18,'[完美]复古台灯',1,70,'[{92,289,88}]','[{1,100},{2,80},{3,80},{4,40},{5,20}]',0,'[]','[]','0','74053001','[{1,135},{2,45}]','[]'),(47050051,19,'[完美]花语吊篮',1,70,'[{307,343,216}]','[{1,100},{2,80},{3,80},{4,40},{5,20}]',0,'[]','[]','0','74053002','[{1,225},{2,135}]','[]'),(47050061,20,'[完美]丰收屏风',1,70,'[{246,343,13}]','[{1,100},{2,80},{3,80},{4,40},{5,20}]',1,'[]','[]','0','74053003','[{1,225},{2,135}]','[{1,{{1,300},{2,300}}},{2,{{1,476},{2,476},{3,476},{4,476}}},{3,{{1,321},{2,321},{3,321},{4,321},{5,1044},{6,1044}}},{4,{{1,323},{2,323},{3,1046},{4,1046},{5,323},{6,323},{7,323},{8,323}}}]'),(47060011,21,'[良好]圆顶窗户',34,10,'[{278,346,44}]','[{1,100},{2,60},{3,50},{4,40},{5,82}]',1,'[]','[]','0','74054000','[{1,225},{2,135}]','[{1,{{1,300},{2,300}}},{2,{{1,476},{2,476},{3,476},{4,476}}},{3,{{1,332},{2,332},{3,332},{4,332},{5,1062},{6,1062}}},{4,{{1,326},{2,326},{3,1067},{4,1067},{5,326},{6,326},{7,326},{8,326}}}]'),(47060012,21,'[精致]圆顶窗户',36,15,'[{278,346,44}]','[{1,100},{2,60},{3,50},{4,40},{5,82}]',1,'[]','[]','0','74054000','[{1,225},{2,135}]','[{1,{{1,300},{2,300}}},{2,{{1,476},{2,476},{3,476},{4,476}}},{3,{{1,332},{2,332},{3,332},{4,332},{5,1062},{6,1062}}},{4,{{1,326},{2,326},{3,1067},{4,1067},{5,326},{6,326},{7,326},{8,326}}}]'),(47060013,21,'[华丽]圆顶窗户',39,24,'[{278,346,44}]','[{1,100},{2,60},{3,50},{4,40},{5,82}]',1,'[]','[]','0','74054000','[{1,225},{2,135}]','[{1,{{1,300},{2,300}}},{2,{{1,476},{2,476},{3,476},{4,476}}},{3,{{1,332},{2,332},{3,332},{4,332},{5,1062},{6,1062}}},{4,{{1,326},{2,326},{3,1067},{4,1067},{5,326},{6,326},{7,326},{8,326}}}]'),(47060014,21,'[完美]圆顶窗户',42,36,'[{278,346,44}]','[{1,100},{2,60},{3,50},{4,40},{5,82}]',1,'[]','[]','0','74054000','[{1,225},{2,135}]','[{1,{{1,300},{2,300}}},{2,{{1,476},{2,476},{3,476},{4,476}}},{3,{{1,332},{2,332},{3,332},{4,332},{5,1062},{6,1062}}},{4,{{1,326},{2,326},{3,1067},{4,1067},{5,326},{6,326},{7,326},{8,326}}}]'),(47060021,22,'[良好]纯净纱窗',37,10,'[{524,525,61}]','[{1,80},{2,60},{3,60},{4,30},{5,10}]',1,'[]','[]','100','74054001','[{1,225},{2,135}]','[{1,{{1,185},{2,185}}},{2,{{1,476},{2,476},{3,476},{4,476}}},{3,{{1,262},{2,262},{3,262},{4,262},{5,962},{6,962}}},{4,{{1,262},{2,262},{3,883},{4,883},{5,962},{6,962},{7,962},{8,962}}}]'),(47060022,22,'[精致]纯净纱窗',39,15,'[{524,525,61}]','[{1,80},{2,60},{3,60},{4,30},{5,10}]',1,'[]','[]','100','74054001','[{1,225},{2,135}]','[{1,{{1,185},{2,185}}},{2,{{1,476},{2,476},{3,476},{4,476}}},{3,{{1,262},{2,262},{3,262},{4,262},{5,962},{6,962}}},{4,{{1,262},{2,262},{3,883},{4,883},{5,962},{6,962},{7,962},{8,962}}}]'),(47060023,22,'[华丽]纯净纱窗',42,24,'[{524,525,61}]','[{1,80},{2,60},{3,60},{4,30},{5,10}]',1,'[]','[]','100','74054001','[{1,225},{2,135}]','[{1,{{1,185},{2,185}}},{2,{{1,476},{2,476},{3,476},{4,476}}},{3,{{1,262},{2,262},{3,262},{4,262},{5,962},{6,962}}},{4,{{1,262},{2,262},{3,883},{4,883},{5,962},{6,962},{7,962},{8,962}}}]'),(47060024,22,'[完美]纯净纱窗',45,36,'[{524,525,61}]','[{1,80},{2,60},{3,60},{4,30},{5,10}]',1,'[]','[]','100','74054001','[{1,225},{2,135}]','[{1,{{1,185},{2,185}}},{2,{{1,476},{2,476},{3,476},{4,476}}},{3,{{1,262},{2,262},{3,262},{4,262},{5,962},{6,962}}},{4,{{1,262},{2,262},{3,883},{4,883},{5,962},{6,962},{7,962},{8,962}}}]'),(47060031,24,'[良好]灰色墙纸',40,10,'[{0,0,0}]','[{1,100},{2,60},{3,50},{4,40},{5,80}]',4,'[]','[]','0','74054005','[]','[1,{2711,7,2694}]'),(47060032,24,'[精致]灰色墙纸',42,15,'[{0,0,0}]','[{1,100},{2,60},{3,50},{4,40},{5,80}]',4,'[]','[]','0','74054005','[]','[1,{2711,7,2694}]'),(47060033,24,'[华丽]灰色墙纸',45,24,'[{0,0,0}]','[{1,100},{2,60},{3,50},{4,40},{5,80}]',4,'[]','[]','0','74054005','[]','[1,{2711,7,2694}]'),(47060034,24,'[完美]灰色墙纸',48,36,'[{0,0,0}]','[{1,100},{2,60},{3,50},{4,40},{5,80}]',4,'[]','[]','0','74054005','[]','[1,{2711,7,2694}]'),(47060035,24,'[一层]灰色墙纸',40,1,'[{0,0,0}]','[{1,100},{2,60},{3,50},{4,40},{5,80}]',4,'[]','[]','0','74054043','[]','[1,{2365,7,2355}]'),(47060036,24,'[二层]灰色墙纸',40,1,'[{0,0,0}]','[{1,100},{2,60},{3,50},{4,40},{5,80}]',4,'[]','[]','0','74054046','[]','[2,{2365,7,2318}]'),(47060037,24,'[中级]灰色墙纸',40,1,'[{0,0,0}]','[{1,100},{2,60},{3,50},{4,40},{5,80}]',4,'[]','[]','0','74054033','[]','[1,{2230,7,2213}]'),(47060038,24,'[一层]灰色墙纸',40,1,'[{0,0,0}]','[{1,100},{2,60},{3,50},{4,40},{5,80}]',4,'[]','[]','0','74054006','[]','[1,{2996,7,3000}]'),(47060039,24,'[二层]灰色墙纸',40,1,'[{0,0,0}]','[{1,100},{2,60},{3,50},{4,40},{5,80}]',4,'[]','[]','0','74054008','[]','[2,{3017,7,3060}]'),(47060041,23,'[完美]爱意纱窗',1,80,'[{408,621,50}]','[{1,80},{2,80},{3,60},{4,20},{5,20}]',1,'[]','[]','100','74054003','[{1,225},{2,135}]','[{1,{{1,95},{2,95}}},{2,{{1,329},{2,329},{3,245},{4,245}}},{3,{{1,145},{2,145},{3,145},{4,145},{5,872},{6,872}}},{4,{{1,162},{2,162},{3,883},{4,883},{5,162},{6,162},{7,162},{8,162}}}]'),(47070011,25,'[良好]圆形地毯',43,10,'[{892,390,892}]','[{1,100},{2,80},{3,60},{4,30},{5,90}]',3,'[]','[]','0','74055000','[{1,135},{2,45}]','[]'),(47070012,25,'[精致]圆形地毯',45,15,'[{892,390,892}]','[{1,100},{2,80},{3,60},{4,30},{5,90}]',3,'[]','[]','0','74055000','[{1,135},{2,45}]','[]'),(47070013,25,'[华丽]圆形地毯',48,24,'[{892,390,892}]','[{1,100},{2,80},{3,60},{4,30},{5,90}]',3,'[]','[]','0','74055000','[{1,135},{2,45}]','[]'),(47070014,25,'[完美]圆形地毯',51,36,'[{892,390,892}]','[{1,100},{2,80},{3,60},{4,30},{5,90}]',3,'[]','[]','0','74055000','[{1,135},{2,45}]','[]');
/*!40000 ALTER TABLE `base_live_skill_furniture` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_live_skill_furniture_type`
--

DROP TABLE IF EXISTS `base_live_skill_furniture_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_live_skill_furniture_type` (
  `type_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '类型id',
  `kind` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '种类id',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '名称',
  `need_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '建筑所需等级',
  `good_id` int(11) NOT NULL DEFAULT '0' COMMENT '打造纸id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '制作时间',
  `add_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '加熟练度',
  `cost_live` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '所需活力',
  `cost_res` varchar(50) NOT NULL DEFAULT '[]' COMMENT '消耗资源',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗材料',
  `icon` varchar(50) NOT NULL DEFAULT '0' COMMENT '图标',
  `eat_effect` varchar(50) NOT NULL COMMENT '使用效果',
  PRIMARY KEY (`type_id`,`kind`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_live_skill_furniture_type`
--

LOCK TABLES `base_live_skill_furniture_type` WRITE;
/*!40000 ALTER TABLE `base_live_skill_furniture_type` DISABLE KEYS */;
INSERT INTO `base_live_skill_furniture_type` VALUES (4,1,'朴素小床',1,0,1,50,30,'[]','[]','47030011','打造成功后可放置在家园房屋增加繁荣度'),(5,1,'褐色书柜',1,0,1,50,30,'[]','[]','47030021','打造成功后可放置在家园房屋增加繁荣度'),(6,1,'白色衣柜',1,0,1,50,30,'[]','[]','47030031','打造成功后可放置在家园房屋增加繁荣度'),(7,1,'蜜语圆床',5,0,1,50,30,'[]','[{0,47010001,1}]','47030041','打造成功后可放置在家园房屋增加繁荣度'),(8,2,'红色圆凳',4,0,1,50,30,'[]','[]','47040011','打造成功后可放置在家园房屋增加繁荣度'),(9,2,'红色扶手椅',8,0,1,50,30,'[]','[]','47040021','打造成功后可放置在家园房屋增加繁荣度'),(10,2,'简易圆桌',12,0,1,50,30,'[]','[]','47040031','打造成功后可放置在家园房屋增加繁荣度'),(11,2,'方形书桌',18,0,1,50,30,'[]','[]','47040041','打造成功后可放置在家园房屋增加繁荣度'),(12,2,'简约茶几',24,0,1,50,30,'[]','[]','47040051','打造成功后可放置在家园房屋增加繁荣度'),(13,2,'温馨沙发',5,0,1,50,30,'[]','[{0,47010002,1}]','47040061','打造成功后可放置在家园房屋增加繁荣度'),(14,2,'典雅茶几',5,0,1,50,30,'[]','[{0,47010003,1}]','47040071','打造成功后可放置在家园房屋增加繁荣度'),(15,3,'小伞台灯',30,0,1,50,30,'[]','[]','47050011','打造成功后可放置在家园房屋增加繁荣度'),(16,3,'风景屏风',36,0,1,50,30,'[]','[]','47050021','打造成功后可放置在家园房屋增加繁荣度'),(17,3,'小树盆栽',40,0,1,50,30,'[]','[]','47050031','打造成功后可放置在家园房屋增加繁荣度'),(18,3,'复古台灯',5,0,1,50,30,'[]','[{0,47010004,1}]','47050041','打造成功后可放置在家园房屋增加繁荣度'),(19,3,'花语吊篮',5,0,1,50,30,'[]','[{0,47010005,1}]','47050051','打造成功后可放置在家园房屋增加繁荣度'),(20,3,'丰收屏风',5,0,1,50,30,'[]','[{0,47010006,1}]','47050061','打造成功后可放置在家园房屋增加繁荣度'),(21,4,'圆顶窗户',44,0,1,50,30,'[]','[]','47060011','打造成功后可放置在家园房屋增加繁荣度'),(22,4,'纯净纱窗',48,0,1,50,30,'[]','[]','47060021','打造成功后可放置在家园房屋增加繁荣度'),(23,4,'爱意纱窗',5,0,1,50,30,'[]','[{0,47010007,1}]','47060041','打造成功后可放置在家园房屋增加繁荣度'),(24,4,'灰色墙纸',52,0,1,50,30,'[]','[]','47060031','打造成功后可放置在家园房屋增加繁荣度'),(25,5,'圆形地毯',56,0,1,50,30,'[]','[]','47070011','打造成功后可放置在家园房屋增加繁荣度');
/*!40000 ALTER TABLE `base_live_skill_furniture_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_live_skill_kind`
--

DROP TABLE IF EXISTS `base_live_skill_kind`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_live_skill_kind` (
  `skill_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能类型',
  `kind` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '种类id',
  `kind_name` varchar(50) NOT NULL DEFAULT '' COMMENT '名称',
  PRIMARY KEY (`skill_type`,`kind`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_live_skill_kind`
--

LOCK TABLES `base_live_skill_kind` WRITE;
/*!40000 ALTER TABLE `base_live_skill_kind` DISABLE KEYS */;
INSERT INTO `base_live_skill_kind` VALUES (5,1,'日常料理'),(5,2,'初级料理'),(5,3,'高级料理'),(5,4,'顶级料理'),(6,1,'床柜'),(6,2,'桌椅'),(6,3,'摆设'),(6,4,'墙饰'),(6,5,'地面');
/*!40000 ALTER TABLE `base_live_skill_kind` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_live_skill_lv`
--

DROP TABLE IF EXISTS `base_live_skill_lv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_live_skill_lv` (
  `skill_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能类型',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `need_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '升级经验',
  `lv_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级称号类型',
  `lv_type_name` varchar(50) NOT NULL DEFAULT '' COMMENT '等级称号',
  PRIMARY KEY (`skill_type`,`lv`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_live_skill_lv`
--

LOCK TABLES `base_live_skill_lv` WRITE;
/*!40000 ALTER TABLE `base_live_skill_lv` DISABLE KEYS */;
INSERT INTO `base_live_skill_lv` VALUES (1,1,10,1,'钓鱼学徒'),(1,2,30,1,'钓鱼学徒'),(1,3,50,1,'钓鱼学徒'),(1,4,70,1,'钓鱼学徒'),(1,5,90,1,'钓鱼学徒'),(1,6,110,1,'钓鱼学徒'),(1,7,130,1,'钓鱼学徒'),(1,8,150,1,'钓鱼学徒'),(1,9,170,1,'钓鱼学徒'),(1,10,190,2,'钓鱼达人'),(1,11,210,2,'钓鱼达人'),(1,12,230,2,'钓鱼达人'),(1,13,250,2,'钓鱼达人'),(1,14,270,2,'钓鱼达人'),(1,15,290,2,'钓鱼达人'),(1,16,310,2,'钓鱼达人'),(1,17,330,2,'钓鱼达人'),(1,18,350,2,'钓鱼达人'),(1,19,370,2,'钓鱼达人'),(1,20,390,2,'钓鱼达人'),(1,21,410,2,'钓鱼达人'),(1,22,430,2,'钓鱼达人'),(1,23,450,2,'钓鱼达人'),(1,24,470,2,'钓鱼达人'),(1,25,490,3,'钓鱼专家'),(1,26,510,3,'钓鱼专家'),(1,27,530,3,'钓鱼专家'),(1,28,550,3,'钓鱼专家'),(1,29,570,3,'钓鱼专家'),(1,30,590,3,'钓鱼专家'),(1,31,610,3,'钓鱼专家'),(1,32,630,3,'钓鱼专家'),(1,33,650,3,'钓鱼专家'),(1,34,670,3,'钓鱼专家'),(1,35,690,3,'钓鱼专家'),(1,36,710,3,'钓鱼专家'),(1,37,730,3,'钓鱼专家'),(1,38,750,3,'钓鱼专家'),(1,39,770,3,'钓鱼专家'),(1,40,790,4,'钓鱼大师'),(1,41,810,4,'钓鱼大师'),(1,42,830,4,'钓鱼大师'),(1,43,850,4,'钓鱼大师'),(1,44,870,4,'钓鱼大师'),(1,45,890,4,'钓鱼大师'),(1,46,910,4,'钓鱼大师'),(1,47,930,4,'钓鱼大师'),(1,48,950,4,'钓鱼大师'),(1,49,970,4,'钓鱼大师'),(1,50,990,4,'钓鱼大师'),(1,51,1010,4,'钓鱼大师'),(1,52,1030,4,'钓鱼大师'),(1,53,1050,4,'钓鱼大师'),(1,54,1070,4,'钓鱼大师'),(1,55,1090,4,'钓鱼大师'),(1,56,1110,4,'钓鱼大师'),(1,57,1130,4,'钓鱼大师'),(1,58,1150,4,'钓鱼大师'),(1,59,1170,4,'钓鱼大师'),(1,60,1190,5,'钓鱼宗师'),(5,1,50,1,'烹饪学徒'),(5,2,100,1,'烹饪学徒'),(5,3,200,1,'烹饪学徒'),(5,4,300,1,'烹饪学徒'),(5,5,400,1,'烹饪学徒'),(5,6,500,1,'烹饪学徒'),(5,7,600,1,'烹饪学徒'),(5,8,800,1,'烹饪学徒'),(5,9,1200,1,'烹饪学徒'),(5,10,1800,2,'烹饪达人'),(5,11,2600,2,'烹饪达人'),(5,12,3400,2,'烹饪达人'),(5,13,4200,2,'烹饪达人'),(5,14,5000,2,'烹饪达人'),(5,15,5800,2,'烹饪达人'),(5,16,6600,2,'烹饪达人'),(5,17,7400,2,'烹饪达人'),(5,18,8200,2,'烹饪达人'),(5,19,9000,2,'烹饪达人'),(5,20,9800,2,'烹饪达人'),(5,21,10600,2,'烹饪达人'),(5,22,11400,2,'烹饪达人'),(5,23,12200,2,'烹饪达人'),(5,24,13000,2,'烹饪达人'),(5,25,14500,3,'烹饪专家'),(5,26,16000,3,'烹饪专家'),(5,27,17500,3,'烹饪专家'),(5,28,19000,3,'烹饪专家'),(5,29,21500,3,'烹饪专家'),(5,30,24000,3,'烹饪专家'),(5,31,26500,3,'烹饪专家'),(5,32,29000,3,'烹饪专家'),(5,33,31500,3,'烹饪专家'),(5,34,34000,3,'烹饪专家'),(5,35,36500,3,'烹饪专家'),(5,36,39000,3,'烹饪专家'),(5,37,41000,3,'烹饪专家'),(5,38,43000,3,'烹饪专家'),(5,39,45000,3,'烹饪专家'),(5,40,47000,4,'烹饪大师'),(5,41,49000,4,'烹饪大师'),(5,42,51000,4,'烹饪大师'),(5,43,53000,4,'烹饪大师'),(5,44,55000,4,'烹饪大师'),(5,45,57000,4,'烹饪大师'),(5,46,59000,4,'烹饪大师'),(5,47,61000,4,'烹饪大师'),(5,48,63000,4,'烹饪大师'),(5,49,65000,4,'烹饪大师'),(5,50,67000,4,'烹饪大师'),(5,51,69000,4,'烹饪大师'),(5,52,71500,4,'烹饪大师'),(5,53,74000,4,'烹饪大师'),(5,54,76500,4,'烹饪大师'),(5,55,80000,4,'烹饪大师'),(5,56,83500,4,'烹饪大师'),(5,57,87000,4,'烹饪大师'),(5,58,91000,4,'烹饪大师'),(5,59,95000,4,'烹饪大师'),(5,60,100000,5,'烹饪宗师'),(6,1,50,1,'打造学徒'),(6,2,100,1,'打造学徒'),(6,3,200,1,'打造学徒'),(6,4,300,1,'打造学徒'),(6,5,400,1,'打造学徒'),(6,6,500,1,'打造学徒'),(6,7,600,1,'打造学徒'),(6,8,800,1,'打造学徒'),(6,9,1200,1,'打造学徒'),(6,10,1800,2,'打造达人'),(6,11,2600,2,'打造达人'),(6,12,3400,2,'打造达人'),(6,13,4200,2,'打造达人'),(6,14,5000,2,'打造达人'),(6,15,5800,2,'打造达人'),(6,16,6600,2,'打造达人'),(6,17,7400,2,'打造达人'),(6,18,8200,2,'打造达人'),(6,19,9000,2,'打造达人'),(6,20,9800,2,'打造达人'),(6,21,10600,2,'打造达人'),(6,22,11400,2,'打造达人'),(6,23,12200,2,'打造达人'),(6,24,13000,2,'打造达人'),(6,25,14500,3,'打造专家'),(6,26,16000,3,'打造专家'),(6,27,17500,3,'打造专家'),(6,28,19000,3,'打造专家'),(6,29,21500,3,'打造专家'),(6,30,24000,3,'打造专家'),(6,31,26500,3,'打造专家'),(6,32,29000,3,'打造专家'),(6,33,31500,3,'打造专家'),(6,34,34000,3,'打造专家'),(6,35,36500,3,'打造专家'),(6,36,39000,3,'打造专家'),(6,37,41000,3,'打造专家'),(6,38,43000,3,'打造专家'),(6,39,45000,3,'打造专家'),(6,40,47000,4,'打造大师'),(6,41,49000,4,'打造大师'),(6,42,51000,4,'打造大师'),(6,43,53000,4,'打造大师'),(6,44,55000,4,'打造大师'),(6,45,57000,4,'打造大师'),(6,46,59000,4,'打造大师'),(6,47,61000,4,'打造大师'),(6,48,63000,4,'打造大师'),(6,49,65000,4,'打造大师'),(6,50,67000,4,'打造大师'),(6,51,69000,4,'打造大师'),(6,52,71500,4,'打造大师'),(6,53,74000,4,'打造大师'),(6,54,76500,4,'打造大师'),(6,55,80000,4,'打造大师'),(6,56,83500,4,'打造大师'),(6,57,87000,4,'打造大师'),(6,58,91000,4,'打造大师'),(6,59,95000,4,'打造大师'),(6,60,100000,5,'打造宗师');
/*!40000 ALTER TABLE `base_live_skill_lv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_live_skill_name`
--

DROP TABLE IF EXISTS `base_live_skill_name`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_live_skill_name` (
  `skill_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能类型',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '技能名称',
  PRIMARY KEY (`skill_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_live_skill_name`
--

LOCK TABLES `base_live_skill_name` WRITE;
/*!40000 ALTER TABLE `base_live_skill_name` DISABLE KEYS */;
INSERT INTO `base_live_skill_name` VALUES (5,'烹饪'),(6,'打造');
/*!40000 ALTER TABLE `base_live_skill_name` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_liveness_active`
--

DROP TABLE IF EXISTS `base_liveness_active`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_liveness_active` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活跃度外形Id',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '外形名称',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '激活等级',
  `figure_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '资源Id',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='活跃度外形激活配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_liveness_active`
--

LOCK TABLES `base_liveness_active` WRITE;
/*!40000 ALTER TABLE `base_liveness_active` DISABLE KEYS */;
INSERT INTO `base_liveness_active` VALUES (1,'炽星白光',1,1),(2,'星萤之火',4,1),(3,'绿野仙息',9,2),(4,'守护之光',15,2),(5,'魔力源泉',22,3),(6,'紫气星光',42,3),(7,'蔚蓝之泪',60,4),(8,'金光璀璨',76,4),(9,'跳动花火',90,5),(10,'闪耀虹光',103,5),(11,'炽星白光',116,6),(12,'星萤之火',126,6),(13,'绿野仙息',136,7),(14,'守护之光',146,7),(15,'魔力源泉',156,8),(16,'紫气星光',166,8),(17,'蔚蓝之泪',176,9),(18,'金光璀璨',186,9),(19,'跳动花火',196,10),(20,'闪耀虹光',206,10),(21,'炽星白光',216,10);
/*!40000 ALTER TABLE `base_liveness_active` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_liveness_lv`
--

DROP TABLE IF EXISTS `base_liveness_lv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_liveness_lv` (
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活跃度外形等级',
  `liveness` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活跃度',
  `attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '属性',
  PRIMARY KEY (`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='活跃度外形升级配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_liveness_lv`
--

LOCK TABLES `base_liveness_lv` WRITE;
/*!40000 ALTER TABLE `base_liveness_lv` DISABLE KEYS */;
INSERT INTO `base_liveness_lv` VALUES (0,20,'[{1,3},{2,60}]'),(1,21,'[{1,6},{2,120}]'),(2,22,'[{1,9},{2,180}]'),(3,23,'[{1,12},{2,240}]'),(4,24,'[{1,15},{2,300}]'),(5,25,'[{1,18},{2,360}]'),(6,26,'[{1,21},{2,420}]'),(7,27,'[{1,24},{2,480}]'),(8,28,'[{1,27},{2,540}]'),(9,29,'[{1,30},{2,600}]'),(10,30,'[{1,33},{2,660}]'),(11,31,'[{1,36},{2,720}]'),(12,32,'[{1,39},{2,780}]'),(13,33,'[{1,42},{2,840}]'),(14,34,'[{1,45},{2,900}]'),(15,35,'[{1,48},{2,960}]'),(16,36,'[{1,51},{2,1020}]'),(17,37,'[{1,54},{2,1080}]'),(18,38,'[{1,57},{2,1140}]'),(19,39,'[{1,60},{2,1200}]'),(20,40,'[{1,63},{2,1260}]'),(21,41,'[{1,66},{2,1320}]'),(22,42,'[{1,69},{2,1380}]'),(23,43,'[{1,72},{2,1440}]'),(24,44,'[{1,75},{2,1500}]'),(25,45,'[{1,78},{2,1560}]'),(26,46,'[{1,81},{2,1620}]'),(27,47,'[{1,84},{2,1680}]'),(28,48,'[{1,87},{2,1740}]'),(29,49,'[{1,90},{2,1800}]'),(30,50,'[{1,93},{2,1863}]'),(31,51,'[{1,96},{2,1926}]'),(32,52,'[{1,99},{2,1989}]'),(33,53,'[{1,102},{2,2052}]'),(34,54,'[{1,105},{2,2115}]'),(35,55,'[{1,108},{2,2178}]'),(36,56,'[{1,111},{2,2241}]'),(37,57,'[{1,114},{2,2304}]'),(38,58,'[{1,117},{2,2367}]'),(39,59,'[{1,120},{2,2430}]'),(40,60,'[{1,123},{2,2493}]'),(41,61,'[{1,126},{2,2556}]'),(42,62,'[{1,129},{2,2619}]'),(43,63,'[{1,132},{2,2682}]'),(44,64,'[{1,135},{2,2745}]'),(45,65,'[{1,138},{2,2808}]'),(46,66,'[{1,141},{2,2871}]'),(47,67,'[{1,144},{2,2934}]'),(48,68,'[{1,147},{2,2997}]'),(49,69,'[{1,150},{2,3060}]'),(50,80,'[{1,155},{2,3161}]'),(51,81,'[{1,160},{2,3262}]'),(52,82,'[{1,165},{2,3363}]'),(53,83,'[{1,170},{2,3464}]'),(54,84,'[{1,175},{2,3565}]'),(55,85,'[{1,180},{2,3666}]'),(56,86,'[{1,185},{2,3767}]'),(57,87,'[{1,190},{2,3868}]'),(58,88,'[{1,195},{2,3969}]'),(59,89,'[{1,200},{2,4070}]'),(60,90,'[{1,205},{2,4171}]'),(61,91,'[{1,210},{2,4272}]'),(62,92,'[{1,215},{2,4373}]'),(63,93,'[{1,220},{2,4474}]'),(64,94,'[{1,225},{2,4575}]'),(65,95,'[{1,230},{2,4676}]'),(66,96,'[{1,235},{2,4777}]'),(67,97,'[{1,240},{2,4878}]'),(68,98,'[{1,245},{2,4979}]'),(69,99,'[{1,250},{2,5080}]'),(70,110,'[{1,257},{2,5219}]'),(71,111,'[{1,264},{2,5358}]'),(72,112,'[{1,271},{2,5497}]'),(73,113,'[{1,278},{2,5636}]'),(74,114,'[{1,285},{2,5775}]'),(75,115,'[{1,292},{2,5914}]'),(76,116,'[{1,299},{2,6053}]'),(77,117,'[{1,306},{2,6192}]'),(78,118,'[{1,313},{2,6331}]'),(79,119,'[{1,320},{2,6470}]'),(80,120,'[{1,327},{2,6609}]'),(81,121,'[{1,334},{2,6748}]'),(82,122,'[{1,341},{2,6887}]'),(83,123,'[{1,348},{2,7026}]'),(84,124,'[{1,355},{2,7165}]'),(85,125,'[{1,362},{2,7304}]'),(86,126,'[{1,369},{2,7443}]'),(87,127,'[{1,376},{2,7582}]'),(88,128,'[{1,383},{2,7721}]'),(89,129,'[{1,390},{2,7860}]'),(90,140,'[{1,399},{2,8037}]'),(91,141,'[{1,408},{2,8214}]'),(92,142,'[{1,417},{2,8391}]'),(93,143,'[{1,426},{2,8568}]'),(94,144,'[{1,435},{2,8745}]'),(95,145,'[{1,444},{2,8922}]'),(96,146,'[{1,453},{2,9099}]'),(97,147,'[{1,462},{2,9276}]'),(98,148,'[{1,471},{2,9453}]'),(99,149,'[{1,480},{2,9630}]'),(100,150,'[{1,489},{2,9807}]'),(101,151,'[{1,498},{2,9984}]'),(102,152,'[{1,507},{2,10161}]'),(103,153,'[{1,516},{2,10338}]'),(104,154,'[{1,525},{2,10515}]'),(105,155,'[{1,534},{2,10692}]'),(106,156,'[{1,543},{2,10869}]'),(107,157,'[{1,552},{2,11046}]'),(108,158,'[{1,561},{2,11223}]'),(109,159,'[{1,570},{2,11400}]'),(110,160,'[{1,579},{2,11577}]'),(111,161,'[{1,588},{2,11754}]'),(112,162,'[{1,597},{2,11931}]'),(113,163,'[{1,606},{2,12108}]'),(114,164,'[{1,615},{2,12285}]'),(115,165,'[{1,624},{2,12462}]'),(116,166,'[{1,633},{2,12639}]'),(117,167,'[{1,642},{2,12816}]'),(118,168,'[{1,651},{2,12993}]'),(119,169,'[{1,660},{2,13170}]'),(120,185,'[{1,672},{2,13404}]'),(121,186,'[{1,684},{2,13638}]'),(122,187,'[{1,696},{2,13872}]'),(123,188,'[{1,708},{2,14106}]'),(124,189,'[{1,720},{2,14340}]'),(125,190,'[{1,732},{2,14574}]'),(126,191,'[{1,744},{2,14808}]'),(127,192,'[{1,756},{2,15042}]'),(128,193,'[{1,768},{2,15276}]'),(129,194,'[{1,780},{2,15510}]'),(130,225,'[{1,794},{2,15794}]'),(131,226,'[{1,808},{2,16078}]'),(132,227,'[{1,822},{2,16362}]'),(133,228,'[{1,836},{2,16646}]'),(134,229,'[{1,850},{2,16930}]'),(135,230,'[{1,864},{2,17214}]'),(136,231,'[{1,878},{2,17498}]'),(137,232,'[{1,892},{2,17782}]'),(138,233,'[{1,906},{2,18066}]'),(139,234,'[{1,920},{2,18350}]'),(140,235,'[{1,934},{2,18634}]'),(141,236,'[{1,948},{2,18918}]'),(142,237,'[{1,962},{2,19202}]'),(143,238,'[{1,976},{2,19486}]'),(144,239,'[{1,990},{2,19770}]'),(145,240,'[{1,1004},{2,20054}]'),(146,241,'[{1,1018},{2,20338}]'),(147,242,'[{1,1032},{2,20622}]'),(148,243,'[{1,1046},{2,20906}]'),(149,244,'[{1,1060},{2,21190}]'),(150,245,'[{1,1074},{2,21474}]'),(151,246,'[{1,1088},{2,21758}]'),(152,247,'[{1,1102},{2,22042}]'),(153,248,'[{1,1116},{2,22326}]'),(154,249,'[{1,1130},{2,22610}]'),(155,250,'[{1,1144},{2,22894}]'),(156,251,'[{1,1158},{2,23178}]'),(157,252,'[{1,1172},{2,23462}]'),(158,253,'[{1,1186},{2,23746}]'),(159,254,'[{1,1200},{2,24030}]'),(160,255,'[{1,1214},{2,24314}]'),(161,256,'[{1,1228},{2,24598}]'),(162,257,'[{1,1242},{2,24882}]'),(163,258,'[{1,1256},{2,25166}]'),(164,259,'[{1,1270},{2,25450}]'),(165,260,'[{1,1284},{2,25734}]'),(166,261,'[{1,1298},{2,26018}]'),(167,262,'[{1,1312},{2,26302}]'),(168,263,'[{1,1326},{2,26586}]'),(169,264,'[{1,1340},{2,26870}]'),(170,265,'[{1,1354},{2,27154}]'),(171,266,'[{1,1368},{2,27438}]'),(172,267,'[{1,1382},{2,27722}]'),(173,268,'[{1,1396},{2,28006}]'),(174,269,'[{1,1410},{2,28290}]'),(175,270,'[{1,1424},{2,28574}]'),(176,271,'[{1,1438},{2,28858}]'),(177,272,'[{1,1452},{2,29142}]'),(178,273,'[{1,1466},{2,29426}]'),(179,274,'[{1,1480},{2,29710}]'),(180,275,'[{1,1494},{2,29994}]'),(181,276,'[{1,1508},{2,30278}]'),(182,277,'[{1,1522},{2,30562}]'),(183,278,'[{1,1536},{2,30846}]'),(184,279,'[{1,1550},{2,31130}]'),(185,280,'[{1,1564},{2,31414}]'),(186,281,'[{1,1578},{2,31698}]'),(187,282,'[{1,1592},{2,31982}]'),(188,283,'[{1,1606},{2,32266}]'),(189,284,'[{1,1620},{2,32550}]'),(190,285,'[{1,1634},{2,32834}]'),(191,286,'[{1,1648},{2,33118}]'),(192,287,'[{1,1662},{2,33402}]'),(193,288,'[{1,1676},{2,33686}]'),(194,289,'[{1,1690},{2,33970}]'),(195,290,'[{1,1704},{2,34254}]'),(196,291,'[{1,1718},{2,34538}]'),(197,292,'[{1,1732},{2,34822}]'),(198,293,'[{1,1746},{2,35106}]'),(199,294,'[{1,1760},{2,35390}]'),(200,295,'[{1,1774},{2,35674}]'),(201,296,'[{1,1788},{2,35958}]'),(202,297,'[{1,1802},{2,36242}]'),(203,298,'[{1,1816},{2,36526}]'),(204,299,'[{1,1830},{2,36810}]'),(205,300,'[{1,1844},{2,37094}]'),(206,301,'[{1,1858},{2,37378}]'),(207,302,'[{1,1872},{2,37662}]'),(208,303,'[{1,1886},{2,37946}]'),(209,304,'[{1,1900},{2,38230}]'),(210,305,'[{1,1914},{2,38514}]'),(211,306,'[{1,1928},{2,38798}]'),(212,307,'[{1,1942},{2,39082}]'),(213,308,'[{1,1956},{2,39366}]'),(214,309,'[{1,1970},{2,39650}]'),(215,310,'[{1,1984},{2,39934}]'),(216,311,'[{1,1998},{2,40218}]'),(217,312,'[{1,2012},{2,40502}]'),(218,313,'[{1,2026},{2,40786}]'),(219,314,'[{1,2040},{2,41070}]'),(220,315,'[{1,2054},{2,41354}]'),(221,316,'[{1,2068},{2,41638}]'),(222,317,'[{1,2082},{2,41922}]'),(223,318,'[{1,2096},{2,42206}]'),(224,319,'[{1,2110},{2,42490}]'),(225,320,'[{1,2124},{2,42774}]'),(226,321,'[{1,2138},{2,43058}]'),(227,322,'[{1,2152},{2,43342}]'),(228,323,'[{1,2166},{2,43626}]'),(229,324,'[{1,2180},{2,43910}]'),(230,325,'[{1,2194},{2,44194}]'),(231,326,'[{1,2208},{2,44478}]'),(232,327,'[{1,2222},{2,44762}]'),(233,328,'[{1,2236},{2,45046}]'),(234,329,'[{1,2250},{2,45330}]'),(235,330,'[{1,2264},{2,45614}]'),(236,331,'[{1,2278},{2,45898}]'),(237,332,'[{1,2292},{2,46182}]'),(238,333,'[{1,2306},{2,46466}]'),(239,334,'[{1,2320},{2,46750}]'),(240,335,'[{1,2334},{2,47034}]'),(241,336,'[{1,2348},{2,47318}]'),(242,337,'[{1,2362},{2,47602}]'),(243,338,'[{1,2376},{2,47886}]'),(244,339,'[{1,2390},{2,48170}]'),(245,340,'[{1,2404},{2,48454}]'),(246,341,'[{1,2418},{2,48738}]'),(247,342,'[{1,2432},{2,49022}]'),(248,343,'[{1,2446},{2,49306}]'),(249,344,'[{1,2460},{2,49590}]'),(250,345,'[{1,2474},{2,49874}]'),(251,346,'[{1,2488},{2,50158}]'),(252,347,'[{1,2502},{2,50442}]'),(253,348,'[{1,2516},{2,50726}]'),(254,349,'[{1,2530},{2,51010}]'),(255,350,'[{1,2544},{2,51294}]'),(256,351,'[{1,2558},{2,51578}]'),(257,352,'[{1,2572},{2,51862}]'),(258,353,'[{1,2586},{2,52146}]'),(259,354,'[{1,2600},{2,52430}]'),(260,355,'[{1,2614},{2,52714}]'),(261,356,'[{1,2628},{2,52998}]'),(262,357,'[{1,2642},{2,53282}]'),(263,358,'[{1,2656},{2,53566}]'),(264,359,'[{1,2670},{2,53850}]'),(265,360,'[{1,2684},{2,54134}]'),(266,361,'[{1,2698},{2,54418}]'),(267,362,'[{1,2712},{2,54702}]'),(268,363,'[{1,2726},{2,54986}]'),(269,364,'[{1,2740},{2,55270}]'),(270,365,'[{1,2754},{2,55554}]'),(271,366,'[{1,2768},{2,55838}]'),(272,367,'[{1,2782},{2,56122}]'),(273,368,'[{1,2796},{2,56406}]'),(274,369,'[{1,2810},{2,56690}]'),(275,370,'[{1,2824},{2,56974}]'),(276,371,'[{1,2838},{2,57258}]'),(277,372,'[{1,2852},{2,57542}]'),(278,373,'[{1,2866},{2,57826}]'),(279,374,'[{1,2880},{2,58110}]'),(280,375,'[{1,2894},{2,58394}]'),(281,376,'[{1,2908},{2,58678}]'),(282,377,'[{1,2922},{2,58962}]'),(283,378,'[{1,2936},{2,59246}]'),(284,379,'[{1,2950},{2,59530}]'),(285,380,'[{1,2964},{2,59814}]'),(286,381,'[{1,2978},{2,60098}]'),(287,382,'[{1,2992},{2,60382}]'),(288,383,'[{1,3006},{2,60666}]'),(289,384,'[{1,3020},{2,60950}]'),(290,385,'[{1,3034},{2,61234}]'),(291,386,'[{1,3048},{2,61518}]'),(292,387,'[{1,3062},{2,61802}]'),(293,388,'[{1,3076},{2,62086}]'),(294,389,'[{1,3090},{2,62370}]'),(295,390,'[{1,3104},{2,62654}]'),(296,391,'[{1,3118},{2,62938}]'),(297,392,'[{1,3132},{2,63222}]'),(298,393,'[{1,3146},{2,63506}]'),(299,394,'[{1,3160},{2,63790}]'),(300,395,'[{1,3174},{2,64074}]'),(301,396,'[{1,3188},{2,64358}]'),(302,397,'[{1,3202},{2,64642}]'),(303,398,'[{1,3216},{2,64926}]'),(304,399,'[{1,3230},{2,65210}]'),(305,400,'[{1,3244},{2,65494}]'),(306,401,'[{1,3258},{2,65778}]'),(307,402,'[{1,3272},{2,66062}]'),(308,403,'[{1,3286},{2,66346}]'),(309,404,'[{1,3300},{2,66630}]'),(310,405,'[{1,3314},{2,66914}]'),(311,406,'[{1,3328},{2,67198}]'),(312,407,'[{1,3342},{2,67482}]'),(313,408,'[{1,3356},{2,67766}]'),(314,409,'[{1,3370},{2,68050}]'),(315,410,'[{1,3384},{2,68334}]'),(316,411,'[{1,3398},{2,68618}]'),(317,412,'[{1,3412},{2,68902}]'),(318,413,'[{1,3426},{2,69186}]'),(319,414,'[{1,3440},{2,69470}]'),(320,415,'[{1,3454},{2,69754}]'),(321,416,'[{1,3468},{2,70038}]'),(322,417,'[{1,3482},{2,70322}]'),(323,418,'[{1,3496},{2,70606}]'),(324,419,'[{1,3510},{2,70890}]'),(325,420,'[{1,3524},{2,71174}]'),(326,421,'[{1,3538},{2,71458}]'),(327,422,'[{1,3552},{2,71742}]'),(328,423,'[{1,3566},{2,72026}]'),(329,424,'[{1,3580},{2,72310}]'),(330,425,'[{1,3594},{2,72594}]'),(331,426,'[{1,3608},{2,72878}]'),(332,427,'[{1,3622},{2,73162}]'),(333,428,'[{1,3636},{2,73446}]'),(334,429,'[{1,3650},{2,73730}]'),(335,430,'[{1,3664},{2,74014}]'),(336,431,'[{1,3678},{2,74298}]'),(337,432,'[{1,3692},{2,74582}]'),(338,433,'[{1,3706},{2,74866}]'),(339,434,'[{1,3720},{2,75150}]'),(340,435,'[{1,3734},{2,75434}]'),(341,436,'[{1,3748},{2,75718}]'),(342,437,'[{1,3762},{2,76002}]'),(343,438,'[{1,3776},{2,76286}]'),(344,439,'[{1,3790},{2,76570}]'),(345,440,'[{1,3804},{2,76854}]'),(346,441,'[{1,3818},{2,77138}]'),(347,442,'[{1,3832},{2,77422}]'),(348,443,'[{1,3846},{2,77706}]'),(349,444,'[{1,3860},{2,77990}]'),(350,445,'[{1,3874},{2,78274}]'),(351,446,'[{1,3888},{2,78558}]'),(352,447,'[{1,3902},{2,78842}]'),(353,448,'[{1,3916},{2,79126}]'),(354,449,'[{1,3930},{2,79410}]'),(355,450,'[{1,3944},{2,79694}]'),(356,451,'[{1,3958},{2,79978}]'),(357,452,'[{1,3972},{2,80262}]'),(358,453,'[{1,3986},{2,80546}]'),(359,454,'[{1,4000},{2,80830}]'),(360,455,'[{1,4014},{2,81114}]'),(361,456,'[{1,4028},{2,81398}]'),(362,457,'[{1,4042},{2,81682}]'),(363,458,'[{1,4056},{2,81966}]'),(364,459,'[{1,4070},{2,82250}]'),(365,460,'[{1,4084},{2,82534}]'),(366,461,'[{1,4098},{2,82818}]'),(367,462,'[{1,4112},{2,83102}]'),(368,463,'[{1,4126},{2,83386}]'),(369,464,'[{1,4140},{2,83670}]'),(370,465,'[{1,4154},{2,83954}]'),(371,466,'[{1,4168},{2,84238}]'),(372,467,'[{1,4182},{2,84522}]'),(373,468,'[{1,4196},{2,84806}]'),(374,469,'[{1,4210},{2,85090}]'),(375,470,'[{1,4224},{2,85374}]'),(376,471,'[{1,4238},{2,85658}]'),(377,472,'[{1,4252},{2,85942}]'),(378,473,'[{1,4266},{2,86226}]'),(379,474,'[{1,4280},{2,86510}]'),(380,475,'[{1,4294},{2,86794}]'),(381,476,'[{1,4308},{2,87078}]'),(382,477,'[{1,4322},{2,87362}]'),(383,478,'[{1,4336},{2,87646}]'),(384,479,'[{1,4350},{2,87930}]'),(385,480,'[{1,4364},{2,88214}]'),(386,481,'[{1,4378},{2,88498}]'),(387,482,'[{1,4392},{2,88782}]'),(388,483,'[{1,4406},{2,89066}]'),(389,484,'[{1,4420},{2,89350}]'),(390,485,'[{1,4434},{2,89634}]'),(391,486,'[{1,4448},{2,89918}]'),(392,487,'[{1,4462},{2,90202}]'),(393,488,'[{1,4476},{2,90486}]'),(394,489,'[{1,4490},{2,90770}]'),(395,490,'[{1,4504},{2,91054}]'),(396,491,'[{1,4518},{2,91338}]'),(397,492,'[{1,4532},{2,91622}]'),(398,493,'[{1,4546},{2,91906}]'),(399,494,'[{1,4560},{2,92190}]'),(400,495,'[{1,4574},{2,92474}]'),(401,496,'[{1,4588},{2,92758}]'),(402,497,'[{1,4602},{2,93042}]'),(403,498,'[{1,4616},{2,93326}]'),(404,499,'[{1,4630},{2,93610}]'),(405,500,'[{1,4644},{2,93894}]'),(406,501,'[{1,4658},{2,94178}]'),(407,502,'[{1,4672},{2,94462}]'),(408,503,'[{1,4686},{2,94746}]'),(409,504,'[{1,4700},{2,95030}]'),(410,505,'[{1,4714},{2,95314}]'),(411,506,'[{1,4728},{2,95598}]'),(412,507,'[{1,4742},{2,95882}]'),(413,508,'[{1,4756},{2,96166}]'),(414,509,'[{1,4770},{2,96450}]'),(415,510,'[{1,4784},{2,96734}]'),(416,511,'[{1,4798},{2,97018}]'),(417,512,'[{1,4812},{2,97302}]'),(418,513,'[{1,4826},{2,97586}]'),(419,514,'[{1,4840},{2,97870}]'),(420,515,'[{1,4854},{2,98154}]'),(421,516,'[{1,4868},{2,98438}]'),(422,517,'[{1,4882},{2,98722}]'),(423,518,'[{1,4896},{2,99006}]'),(424,519,'[{1,4910},{2,99290}]'),(425,520,'[{1,4924},{2,99574}]'),(426,521,'[{1,4938},{2,99858}]'),(427,522,'[{1,4952},{2,100142}]'),(428,523,'[{1,4966},{2,100426}]'),(429,524,'[{1,4980},{2,100710}]'),(430,525,'[{1,4994},{2,100994}]'),(431,526,'[{1,5008},{2,101278}]'),(432,527,'[{1,5022},{2,101562}]'),(433,528,'[{1,5036},{2,101846}]'),(434,529,'[{1,5050},{2,102130}]'),(435,530,'[{1,5064},{2,102414}]'),(436,531,'[{1,5078},{2,102698}]'),(437,532,'[{1,5092},{2,102982}]'),(438,533,'[{1,5106},{2,103266}]'),(439,534,'[{1,5120},{2,103550}]'),(440,535,'[{1,5134},{2,103834}]'),(441,536,'[{1,5148},{2,104118}]'),(442,537,'[{1,5162},{2,104402}]'),(443,538,'[{1,5176},{2,104686}]'),(444,539,'[{1,5190},{2,104970}]'),(445,540,'[{1,5204},{2,105254}]'),(446,541,'[{1,5218},{2,105538}]'),(447,542,'[{1,5232},{2,105822}]'),(448,543,'[{1,5246},{2,106106}]'),(449,544,'[{1,5260},{2,106390}]'),(450,545,'[{1,5274},{2,106674}]'),(451,546,'[{1,5288},{2,106958}]'),(452,547,'[{1,5302},{2,107242}]'),(453,548,'[{1,5316},{2,107526}]'),(454,549,'[{1,5330},{2,107810}]'),(455,550,'[{1,5344},{2,108094}]'),(456,551,'[{1,5358},{2,108378}]'),(457,552,'[{1,5372},{2,108662}]'),(458,553,'[{1,5386},{2,108946}]'),(459,554,'[{1,5400},{2,109230}]'),(460,555,'[{1,5414},{2,109514}]'),(461,556,'[{1,5428},{2,109798}]'),(462,557,'[{1,5442},{2,110082}]'),(463,558,'[{1,5456},{2,110366}]'),(464,559,'[{1,5470},{2,110650}]'),(465,560,'[{1,5484},{2,110934}]'),(466,561,'[{1,5498},{2,111218}]'),(467,562,'[{1,5512},{2,111502}]'),(468,563,'[{1,5526},{2,111786}]'),(469,564,'[{1,5540},{2,112070}]'),(470,565,'[{1,5554},{2,112354}]'),(471,566,'[{1,5568},{2,112638}]'),(472,567,'[{1,5582},{2,112922}]'),(473,568,'[{1,5596},{2,113206}]'),(474,569,'[{1,5610},{2,113490}]'),(475,570,'[{1,5624},{2,113774}]'),(476,571,'[{1,5638},{2,114058}]'),(477,572,'[{1,5652},{2,114342}]'),(478,573,'[{1,5666},{2,114626}]'),(479,574,'[{1,5680},{2,114910}]'),(480,575,'[{1,5694},{2,115194}]'),(481,576,'[{1,5708},{2,115478}]'),(482,577,'[{1,5722},{2,115762}]'),(483,578,'[{1,5736},{2,116046}]'),(484,579,'[{1,5750},{2,116330}]'),(485,580,'[{1,5764},{2,116614}]'),(486,581,'[{1,5778},{2,116898}]'),(487,582,'[{1,5792},{2,117182}]'),(488,583,'[{1,5806},{2,117466}]'),(489,584,'[{1,5820},{2,117750}]'),(490,585,'[{1,5834},{2,118034}]'),(491,586,'[{1,5848},{2,118318}]'),(492,587,'[{1,5862},{2,118602}]'),(493,588,'[{1,5876},{2,118886}]'),(494,589,'[{1,5890},{2,119170}]'),(495,590,'[{1,5904},{2,119454}]'),(496,591,'[{1,5918},{2,119738}]'),(497,592,'[{1,5932},{2,120022}]'),(498,593,'[{1,5946},{2,120306}]'),(499,594,'[{1,5960},{2,120590}]'),(500,0,'[{1,5974},{2,120874}]');
/*!40000 ALTER TABLE `base_liveness_lv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_loading_pic`
--

DROP TABLE IF EXISTS `base_loading_pic`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_loading_pic` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '加载图id',
  `level_list` varchar(50) NOT NULL DEFAULT '[]' COMMENT '等级区间',
  `open_day` varchar(50) NOT NULL DEFAULT '[]' COMMENT '开服时间',
  `career` tinyint(1) NOT NULL DEFAULT '0' COMMENT '职业',
  `reg_day` varchar(50) NOT NULL DEFAULT '[]' COMMENT '创角天数',
  `st_time` varchar(255) NOT NULL DEFAULT '0' COMMENT '开始时间',
  `ed_time` varchar(255) NOT NULL DEFAULT '0' COMMENT '结束时间',
  `weight` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '权重',
  `week_list` varchar(50) NOT NULL DEFAULT '[]' COMMENT '星期',
  `remark` varchar(512) NOT NULL DEFAULT '[]' COMMENT '备注信息@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=19 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_loading_pic`
--

LOCK TABLES `base_loading_pic` WRITE;
/*!40000 ALTER TABLE `base_loading_pic` DISABLE KEYS */;
INSERT INTO `base_loading_pic` VALUES (1,'{501,1000} ','',0,'','','',30,'','纯加载图-弹吉他'),(2,'{301,500}','',0,'','','',30,'','纯加载图-对战'),(3,'','',0,'{2,6}','','',100,'','登录7天送金牛座'),(7,'','',0,'{1,1}','','',100,'','登录2天送呆萌兔'),(9,'{200,280}','',0,'','','',50,'','家园'),(10,'{200,280}','',0,'','','',50,'','装备套装'),(11,'','',0,'{1,1}','','',100,'','首日引导'),(12,'{100,160}','',2,'','','',100,'','一转-龙骑士'),(13,'{100,160}','',4,'','','',100,'','一转-重炮手'),(14,'{100,160}','',1,'','','',100,'','一转-魔剑士'),(15,'{270,320}','',0,'','','',50,'','星灵试炼'),(16,'{250,350}','',0,'','','',50,'','星灵小宇宙'),(17,'{140,230}','',0,'','','',100,'','结婚'),(18,'{60,300}','',0,'','','',80,'','打boss');
/*!40000 ALTER TABLE `base_loading_pic` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_login_reward_day`
--

DROP TABLE IF EXISTS `base_login_reward_day`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_login_reward_day` (
  `day_id` int(10) unsigned NOT NULL COMMENT '天数id',
  `name` varchar(255) NOT NULL COMMENT '名字@lang@',
  `reward_list` varchar(512) NOT NULL COMMENT '奖励列表',
  `extra_reward_type` tinyint(2) unsigned NOT NULL COMMENT '额外奖励格式',
  `extra_reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '额外奖励',
  `resource_id` varchar(512) NOT NULL COMMENT '资源id',
  `show_type` int(10) unsigned NOT NULL COMMENT '展示类型(1图片 2模型)',
  PRIMARY KEY (`day_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='七天登录天数配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_login_reward_day`
--

LOCK TABLES `base_login_reward_day` WRITE;
/*!40000 ALTER TABLE `base_login_reward_day` DISABLE KEYS */;
INSERT INTO `base_login_reward_day` VALUES (1,'冲级礼包','[{1,[{0,37020002,1},{0,16020001,2},{0,38030001,1},{0,38070002,1}]},{2,[{0,37020002,1},{0,16020001,2},{0,38030001,1},{0,38070002,1}]},{3,[{0,37020002,1},{0,16020001,2},{0,38030001,1},{0,38070002,1}]},{4,[{0,37020002,1},{0,16020001,2},{0,38030001,1},{0,38070002,1}]}]',1,'[]','[{1,1},{2,1},{3,1},{4,1}]',1),(2,'呆萌兔','[{1,[{0,16030003,1},{0,38030002,1},{0,37020001,1},{0,38030001,1}]},{2,[{0,16030003,1},{0,38030002,1},{0,37020001,1},{0,38030001,1}]},{3,[{0,16030003,1},{0,38030002,1},{0,37020001,1},{0,38030001,1}]},{4,[{0,16030003,1},{0,38030002,1},{0,37020001,1},{0,38030001,1}]}]',2,'[]','[{1,301002},{2,301002},{3,301002},{4,301002}]',2),(3,'偶像礼服','[{1,[{0,12010004,1},{0,11020001,6},{0,37020001,2},{0,38030001,1}]},{2,[{0,12010004,1},{0,11020001,6},{0,37020001,2},{0,38030001,1}]},{3,[{0,12010004,1},{0,11020001,6},{0,37020001,2},{0,38030001,1}]},{4,[{0,12010004,1},{0,11020001,6},{0,37020001,2},{0,38030001,1}]}]',1,'[]','[{1,12010004},{2,12010004},{4,12010004}]',3),(4,'专属称号','[{1,[{0,4908022,1},{0,16020001,5},{0,37020001,2},{0,38030001,1}]},{2,[{0,4908022,1},{0,16020001,5},{0,37020001,2},{0,38030001,1}]},{3,[{0,4908022,1},{0,16020001,5},{0,37020001,2},{0,38030001,1}]},{4,[{0,4908022,1},{0,16020001,5},{0,37020001,2},{0,38030001,1}]}]',2,'[]','[{1,3},{2,3},{3,3},{4,3}]',1),(5,'偶像造型','[{1,[{0,12030004,1},{0,14010101,1},{0,37020001,2},{0,38030001,1}]},{2,[{0,12030004,1},{0,14010101,1},{0,37020001,2},{0,38030001,1}]},{3,[{0,12030004,1},{0,14010101,1},{0,37020001,2},{0,38030001,1}]},{4,[{0,12030004,1},{0,14010101,1},{0,37020001,2},{0,38030001,1}]}]',3,'[]','[{1,12030004},{2,12030004},{4,12030004}]',3),(6,'高级宝石','[{1,[{0,14010103,1},{0,14020203,1},{0,37020001,2},{0,38030001,1}]},{2,[{0,14010103,1},{0,14020203,1},{0,37020001,2},{0,38030001,1}]},{3,[{0,14010103,1},{0,14020203,1},{0,37020001,2},{0,38030001,1}]},{4,[{0,14010103,1},{0,14020203,1},{0,37020001,2},{0,38030001,1}]}]',3,'[]','[{1,5},{2,5},{3,5},{4,5}]',1),(7,'白羊星灵','[{1,[{0,18040003,1},{0,38260001,50},{0,37020001,2},{0,38030001,1}]},{2,[{0,18040003,1},{0,38260001,50},{0,37020001,2},{0,38030001,1}]},{3,[{0,18040003,1},{0,38260001,50},{0,37020001,2},{0,38030001,1}]},{4,[{0,18040003,1},{0,38260001,50},{0,37020001,2},{0,38030001,1}]}]',3,'[]','[{1,501004},{2,501004},{3,501004},{4,501004}]',2),(8,'瑟银宝具石','[{1,[{0,24020003,1},{0,20020001,1},{3,36030001,400000},{0,15020101,20}]},{2,[{0,24020003,1},{0,20020001,1},{3,36030001,400000},{0,15020101,20}]},{3,[{0,24020003,1},{0,20020001,1},{3,36030001,400000},{0,15020101,20}]},{4,[{0,24020003,1},{0,20020001,1},{3,36030001,400000},{0,15020101,20}]}]',3,'[]','[{1,8},{2,8},{4,8}]',1),(9,'海盗船长','[{1,[{0,12010006,1},{2,36020001,50},{3,36030001,500000},{0,11020001,20}]},{2,[{0,12010006,1},{2,36020001,50},{3,36030001,500000},{0,11020001,20}]},{3,[{0,12010006,1},{2,36020001,50},{3,36030001,500000},{0,11020001,20}]},{4,[{0,12010006,1},{2,36020001,50},{3,36030001,500000},{0,11020001,20}]}]',3,'[]','[{1,12010006},{2,12010006},{4,12010006}]',3),(10,'星界旅行者','[{1,[{0,4908023,1},{0,17010001,15},{3,36030001,600000},{0,18020001,20}]},{2,[{0,4908023,1},{0,17010001,15},{3,36030001,600000},{0,18020001,20}]},{3,[{0,4908023,1},{0,17010001,15},{3,36030001,600000},{0,18020001,20}]},{4,[{0,4908023,1},{0,17010001,15},{3,36030001,600000},{0,18020001,20}]}]',3,'[]','[{1,10},{2,10},{4,10}]',1),(11,'船长之帽','[{1,[{0,12030006,1},{2,36020001,50},{3,36030001,700000},{0,24010001,20}]},{2,[{0,12030006,1},{2,36020001,50},{3,36030001,700000},{0,24010001,20}]},{3,[{0,12030006,1},{2,36020001,50},{3,36030001,700000},{0,24010001,20}]},{4,[{0,12030006,1},{2,36020001,50},{3,36030001,700000},{0,24010001,20}]}]',3,'[]','[{1,12030006},{2,12030006},{4,12030006}]',3),(12,'星灵技能书','[{1,[{0,32060003,1},{0,16010002,1},{3,36030001,800000},{0,18060002,15}]},{2,[{0,32060003,1},{0,16010002,1},{3,36030001,800000},{0,18060002,15}]},{3,[{0,32060003,1},{0,16010002,1},{3,36030001,800000},{0,18060002,15}]},{4,[{0,32060003,1},{0,16010002,1},{3,36030001,800000},{0,18060002,15}]}]',3,'[]','[{1,12},{2,12},{4,12}]',1),(13,'秩序神晶','[{1,[{0,17020003,1},{2,36020001,50},{3,36030001,900000},{0,17010001,30}]},{2,[{0,17020003,1},{2,36020001,50},{3,36030001,900000},{0,17010001,30}]},{3,[{0,17020003,1},{2,36020001,50},{3,36030001,900000},{0,17010001,30}]},{4,[{0,17020003,1},{2,36020001,50},{3,36030001,900000},{0,17010001,30}]}]',3,'[]','[{1,13},{2,13},{4,13}]',1),(14,'海盗之力','[{1,[{0,12020006,1},{0,20020002,1},{3,36030001,1000000},{0,16020001,15}]},{2,[{0,12020006,1},{0,20020002,1},{3,36030001,1000000},{0,16020001,15}]},{3,[{0,12020006,1},{0,20020002,1},{3,36030001,1000000},{0,16020001,15}]},{4,[{0,12020006,1},{0,20020002,1},{3,36030001,1000000},{0,16020001,15}]}]',3,'[]','[{1,12020006},{2,12020006},{4,12020006}]',3),(15,'圣羽源石','[{1,[{0,20020003,1},{2,36020001,50},{3,36030001,1100000},{0,15020101,40}]},{2,[{0,20020003,1},{2,36020001,50},{3,36030001,1100000},{0,15020101,40}]},{3,[{0,20020003,1},{2,36020001,50},{3,36030001,1100000},{0,15020101,40}]},{4,[{0,20020003,1},{2,36020001,50},{3,36030001,1100000},{0,15020101,40}]}]',3,'[]','[{1,15},{2,15},{4,15}]',1),(16,'5级宝石袋','[{1,[{0,32030501,1},{0,24020002,1},{3,36030001,1200000},{0,11020001,40}]},{2,[{0,32030501,1},{0,24020002,1},{3,36030001,1200000},{0,11020001,40}]},{3,[{0,32030501,1},{0,24020002,1},{3,36030001,1200000},{0,11020001,40}]},{4,[{0,32030501,1},{0,24020002,1},{3,36030001,1200000},{0,11020001,40}]}]',3,'[]','[{1,16},{2,16},{4,16}]',1),(17,'混沌神晶','[{1,[{0,17020004,1},{2,36020001,50},{3,36030001,1300000},{0,15020201,40}]},{2,[{0,17020004,1},{2,36020001,50},{3,36030001,1300000},{0,15020201,40}]},{3,[{0,17020004,1},{2,36020001,50},{3,36030001,1300000},{0,15020201,40}]},{4,[{0,17020004,1},{2,36020001,50},{3,36030001,1300000},{0,15020201,40}]}]',3,'[]','[{1,17},{2,17},{4,17}]',1),(18,'龙魂宝珠碎片','[{1,[{0,24031001,5},{2,36020001,50},{3,36030001,1500000},{0,18020001,40}]},{2,[{0,24031001,5},{2,36020001,50},{3,36030001,1500000},{0,18020001,40}]},{3,[{0,24031001,5},{2,36020001,50},{3,36030001,1500000},{0,18020001,40}]},{4,[{0,24031001,5},{2,36020001,50},{3,36030001,1500000},{0,18020001,40}]}]',3,'[]','[{1,607002},{2,607002},{4,607002}]',2),(19,'生命魂珠','[{1,[{0,24020004,1},{2,36020001,50},{3,36030001,1700000},{0,24010001,40}]},{2,[{0,24020004,1},{2,36020001,50},{3,36030001,1700000},{0,24010001,40}]},{3,[{0,24020004,1},{2,36020001,50},{3,36030001,1700000},{0,24010001,40}]},{4,[{0,24020004,1},{2,36020001,50},{3,36030001,1700000},{0,24010001,40}]}]',3,'[]','[{1,19},{2,19},{4,19}]',1),(20,'精金宝具石','[{1,[{0,4908024,1},{2,36020001,50},{3,36030001,1900000},{0,15020301,40}]},{2,[{0,4908024,1},{2,36020001,50},{3,36030001,1900000},{0,15020301,40}]},{3,[{0,4908024,1},{2,36020001,50},{3,36030001,1900000},{0,15020301,40}]},{4,[{0,4908024,1},{2,36020001,50},{3,36030001,1900000},{0,15020301,40}]}]',3,'[]','[{1,20},{2,20},{4,20}]',1),(21,'龙魂宝珠碎片','[{1,[{0,24031001,5},{2,36020001,50},{3,36030001,2100000},{0,16020001,30}]},{2,[{0,24031001,5},{2,36020001,50},{3,36030001,2100000},{0,16020001,30}]},{3,[{0,24031001,5},{2,36020001,50},{3,36030001,2100000},{0,16020001,30}]},{4,[{0,24031001,5},{2,36020001,50},{3,36030001,2100000},{0,16020001,30}]}]',3,'[]','[{1,607002},{2,607002},{4,607002}]',2),(22,'坐骑装备','[{1,[{0,32130004,1},{2,36020001,70},{3,36030001,2300000},{0,16050001,50}]},{2,[{0,32130004,1},{2,36020001,70},{3,36030001,2300000},{0,16050001,50}]},{3,[{0,32130004,1},{2,36020001,70},{3,36030001,2300000},{0,16050001,50}]},{4,[{0,32130004,1},{2,36020001,70},{3,36030001,2300000},{0,16050001,50}]}]',3,'[]','[{1,22},{2,22},{4,22}]',1),(23,'洗练石','[{1,[{0,38260001,10},{2,36020001,70},{3,36030001,2500000},{0,32020112,40}]},{2,[{0,38260001,10},{2,36020001,70},{3,36030001,2500000},{0,32020112,40}]},{3,[{0,38260001,10},{2,36020001,70},{3,36030001,2500000},{0,32020112,40}]},{4,[{0,38260001,10},{2,36020001,70},{3,36030001,2500000},{0,32020112,40}]}]',3,'[]','[{1,23},{2,23},{4,23}]',1),(24,'生命魂珠','[{1,[{0,5201024,1},{2,36020001,70},{3,36030001,2700000},{0,5203002,10}]},{2,[{0,5201024,1},{2,36020001,70},{3,36030001,2700000},{0,5203002,10}]},{3,[{0,5201024,1},{2,36020001,70},{3,36030001,2700000},{0,5203002,10}]},{4,[{0,5201024,1},{2,36020001,70},{3,36030001,2700000},{0,5203002,10}]}]',3,'[]','[{1,24},{2,24},{4,24}]',1),(25,'利刃精粹','[{1,[{0,14110001,4},{2,36020001,70},{3,36030001,2900000},{0,14120001,30}]},{2,[{0,14110001,4},{2,36020001,70},{3,36030001,2900000},{0,14120001,30}]},{3,[{0,14110001,4},{2,36020001,70},{3,36030001,2900000},{0,14120001,30}]},{4,[{0,14110001,4},{2,36020001,70},{3,36030001,2900000},{0,14120001,30}]}]',3,'[]','[{1,25},{2,25},{4,25}]',1),(26,'坚盾精粹','[{1,[{0,14110002,4},{2,36020001,70},{3,36030001,3100000},{0,14120001,30}]},{2,[{0,14110002,4},{2,36020001,70},{3,36030001,3100000},{0,14120001,30}]},{3,[{0,14110002,4},{2,36020001,70},{3,36030001,3100000},{0,14120001,30}]},{4,[{0,14110002,4},{2,36020001,70},{3,36030001,3100000},{0,14120001,30}]}]',3,'[]','[{1,26},{2,26},{4,26}]',1),(27,'星灵装备','[{1,[{0,32110061,1},{2,36020001,70},{3,36030001,3300000},{0,18190001,4}]},{2,[{0,32110061,1},{2,36020001,70},{3,36030001,3300000},{0,18190001,4}]},{3,[{0,32110061,1},{2,36020001,70},{3,36030001,3300000},{0,18190001,4}]},{4,[{0,32110061,1},{2,36020001,70},{3,36030001,3300000},{0,18190001,4}]}]',3,'[]','[{1,27},{2,27},{4,27}]',1),(28,'时间守护者','[{1,[{0,4908025,1},{2,36020001,70},{3,36030001,3500000},{0,20020003,1}]},{2,[{0,4908025,1},{2,36020001,70},{3,36030001,3500000},{0,20020003,1}]},{3,[{0,4908025,1},{2,36020001,70},{3,36030001,3500000},{0,20020003,1}]},{4,[{0,4908025,1},{2,36020001,70},{3,36030001,3500000},{0,20020003,1}]}]',3,'[]','[{1,28},{2,28},{4,28}]',1);
/*!40000 ALTER TABLE `base_login_reward_day` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_login_tips`
--

DROP TABLE IF EXISTS `base_login_tips`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_login_tips` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `display` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '1:显示 0:隐藏',
  `keyword` varchar(100) NOT NULL DEFAULT '' COMMENT '关键字',
  `platform` varchar(255) NOT NULL DEFAULT '' COMMENT '平台',
  `link_info` varchar(255) NOT NULL DEFAULT '' COMMENT '联系方式',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='登录报错信息配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_login_tips`
--

LOCK TABLES `base_login_tips` WRITE;
/*!40000 ALTER TABLE `base_login_tips` DISABLE KEYS */;
INSERT INTO `base_login_tips` VALUES (1,1,'ml','bf_ml','客服微信公众号：mlgame'),(2,1,'ml','bf_suyou','客服QQ：3257596149'),(3,1,'ml','bf_ml_1340040','客服微信公众号：mlgame'),(4,1,'ml','bf_ml_1340137','客服微信公众号：mlgame'),(5,1,'ml','bf_ml_1340140','客服微信公众号：mlgame'),(6,1,'ml','bf_ml_1340237','客服微信公众号：mlgame'),(7,1,'ml','bf_ml_1340240','客服微信公众号：mlgame'),(8,1,'ml','bf_ml_ios','客服微信公众号：mlgame'),(9,1,'ml','bf_ml_ios_1340940','客服微信公众号：mlgame'),(10,1,'suyou','bf_suyou_wzqst','客服微信公众号：zisugame');
/*!40000 ALTER TABLE `base_login_tips` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_lv_power`
--

DROP TABLE IF EXISTS `base_lv_power`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_lv_power` (
  `lv` int(11) NOT NULL COMMENT '等级',
  `lv_attr` varchar(200) NOT NULL DEFAULT '[]' COMMENT '等级属性',
  PRIMARY KEY (`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='等级战斗力表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_lv_power`
--

LOCK TABLES `base_lv_power` WRITE;
/*!40000 ALTER TABLE `base_lv_power` DISABLE KEYS */;
INSERT INTO `base_lv_power` VALUES (1,'[{1,16},{2,320},{3,8},{4,8}]'),(2,'[{1,18},{2,360},{3,9},{4,9}]'),(3,'[{1,20},{2,400},{3,10},{4,10}]'),(4,'[{1,22},{2,440},{3,11},{4,11}]'),(5,'[{1,24},{2,480},{3,12},{4,12}]'),(6,'[{1,26},{2,520},{3,13},{4,13}]'),(7,'[{1,28},{2,560},{3,14},{4,14}]'),(8,'[{1,30},{2,600},{3,15},{4,15}]'),(9,'[{1,32},{2,640},{3,16},{4,16}]'),(10,'[{1,34},{2,680},{3,17},{4,17}]'),(11,'[{1,36},{2,720},{3,18},{4,18}]'),(12,'[{1,38},{2,760},{3,19},{4,19}]'),(13,'[{1,40},{2,800},{3,20},{4,20}]'),(14,'[{1,42},{2,840},{3,21},{4,21}]'),(15,'[{1,44},{2,880},{3,22},{4,22}]'),(16,'[{1,46},{2,920},{3,23},{4,23}]'),(17,'[{1,48},{2,960},{3,24},{4,24}]'),(18,'[{1,50},{2,1000},{3,25},{4,25}]'),(19,'[{1,52},{2,1040},{3,26},{4,26}]'),(20,'[{1,54},{2,1080},{3,27},{4,27}]'),(21,'[{1,56},{2,1120},{3,28},{4,28}]'),(22,'[{1,58},{2,1160},{3,29},{4,29}]'),(23,'[{1,60},{2,1200},{3,30},{4,30}]'),(24,'[{1,62},{2,1240},{3,31},{4,31}]'),(25,'[{1,64},{2,1280},{3,32},{4,32}]'),(26,'[{1,66},{2,1320},{3,33},{4,33}]'),(27,'[{1,68},{2,1360},{3,34},{4,34}]'),(28,'[{1,70},{2,1400},{3,35},{4,35}]'),(29,'[{1,72},{2,1440},{3,36},{4,36}]'),(30,'[{1,74},{2,1480},{3,37},{4,37}]'),(31,'[{1,76},{2,1520},{3,38},{4,38}]'),(32,'[{1,78},{2,1560},{3,39},{4,39}]'),(33,'[{1,80},{2,1600},{3,40},{4,40}]'),(34,'[{1,82},{2,1640},{3,41},{4,41}]'),(35,'[{1,84},{2,1680},{3,42},{4,42}]'),(36,'[{1,86},{2,1720},{3,43},{4,43}]'),(37,'[{1,88},{2,1760},{3,44},{4,44}]'),(38,'[{1,90},{2,1800},{3,45},{4,45}]'),(39,'[{1,92},{2,1840},{3,46},{4,46}]'),(40,'[{1,94},{2,1880},{3,47},{4,47}]'),(41,'[{1,96},{2,1920},{3,48},{4,48}]'),(42,'[{1,98},{2,1960},{3,49},{4,49}]'),(43,'[{1,100},{2,2000},{3,50},{4,50}]'),(44,'[{1,102},{2,2040},{3,51},{4,51}]'),(45,'[{1,104},{2,2080},{3,52},{4,52}]'),(46,'[{1,106},{2,2120},{3,53},{4,53}]'),(47,'[{1,108},{2,2160},{3,54},{4,54}]'),(48,'[{1,110},{2,2200},{3,55},{4,55}]'),(49,'[{1,112},{2,2240},{3,56},{4,56}]'),(50,'[{1,114},{2,2280},{3,57},{4,57}]'),(51,'[{1,116},{2,2320},{3,58},{4,58}]'),(52,'[{1,118},{2,2360},{3,59},{4,59}]'),(53,'[{1,120},{2,2400},{3,60},{4,60}]'),(54,'[{1,122},{2,2440},{3,61},{4,61}]'),(55,'[{1,124},{2,2480},{3,62},{4,62}]'),(56,'[{1,126},{2,2520},{3,63},{4,63}]'),(57,'[{1,128},{2,2560},{3,64},{4,64}]'),(58,'[{1,130},{2,2600},{3,65},{4,65}]'),(59,'[{1,132},{2,2640},{3,66},{4,66}]'),(60,'[{1,134},{2,2680},{3,67},{4,67}]'),(61,'[{1,136},{2,2720},{3,68},{4,68}]'),(62,'[{1,138},{2,2760},{3,69},{4,69}]'),(63,'[{1,140},{2,2800},{3,70},{4,70}]'),(64,'[{1,142},{2,2840},{3,71},{4,71}]'),(65,'[{1,144},{2,2880},{3,72},{4,72}]'),(66,'[{1,146},{2,2920},{3,73},{4,73}]'),(67,'[{1,148},{2,2960},{3,74},{4,74}]'),(68,'[{1,150},{2,3000},{3,75},{4,75}]'),(69,'[{1,152},{2,3040},{3,76},{4,76}]'),(70,'[{1,154},{2,3080},{3,77},{4,77}]'),(71,'[{1,156},{2,3120},{3,78},{4,78}]'),(72,'[{1,158},{2,3160},{3,79},{4,79}]'),(73,'[{1,160},{2,3200},{3,80},{4,80}]'),(74,'[{1,162},{2,3240},{3,81},{4,81}]'),(75,'[{1,164},{2,3280},{3,82},{4,82}]'),(76,'[{1,166},{2,3320},{3,83},{4,83}]'),(77,'[{1,168},{2,3360},{3,84},{4,84}]'),(78,'[{1,170},{2,3400},{3,85},{4,85}]'),(79,'[{1,172},{2,3440},{3,86},{4,86}]'),(80,'[{1,174},{2,3480},{3,87},{4,87}]'),(81,'[{1,176},{2,3520},{3,88},{4,88}]'),(82,'[{1,178},{2,3560},{3,89},{4,89}]'),(83,'[{1,180},{2,3600},{3,90},{4,90}]'),(84,'[{1,182},{2,3640},{3,91},{4,91}]'),(85,'[{1,184},{2,3680},{3,92},{4,92}]'),(86,'[{1,186},{2,3720},{3,93},{4,93}]'),(87,'[{1,188},{2,3760},{3,94},{4,94}]'),(88,'[{1,190},{2,3800},{3,95},{4,95}]'),(89,'[{1,192},{2,3840},{3,96},{4,96}]'),(90,'[{1,194},{2,3880},{3,97},{4,97}]'),(91,'[{1,196},{2,3920},{3,98},{4,98}]'),(92,'[{1,198},{2,3960},{3,99},{4,99}]'),(93,'[{1,200},{2,4000},{3,100},{4,100}]'),(94,'[{1,202},{2,4040},{3,101},{4,101}]'),(95,'[{1,204},{2,4080},{3,102},{4,102}]'),(96,'[{1,206},{2,4120},{3,103},{4,103}]'),(97,'[{1,208},{2,4160},{3,104},{4,104}]'),(98,'[{1,210},{2,4200},{3,105},{4,105}]'),(99,'[{1,212},{2,4240},{3,106},{4,106}]'),(100,'[{1,214},{2,4280},{3,107},{4,107}]'),(101,'[{1,216},{2,4320},{3,108},{4,108}]'),(102,'[{1,218},{2,4360},{3,109},{4,109}]'),(103,'[{1,220},{2,4400},{3,110},{4,110}]'),(104,'[{1,222},{2,4440},{3,111},{4,111}]'),(105,'[{1,224},{2,4480},{3,112},{4,112}]'),(106,'[{1,226},{2,4520},{3,113},{4,113}]'),(107,'[{1,228},{2,4560},{3,114},{4,114}]'),(108,'[{1,230},{2,4600},{3,115},{4,115}]'),(109,'[{1,232},{2,4640},{3,116},{4,116}]'),(110,'[{1,234},{2,4680},{3,117},{4,117}]'),(111,'[{1,236},{2,4720},{3,118},{4,118}]'),(112,'[{1,238},{2,4760},{3,119},{4,119}]'),(113,'[{1,240},{2,4800},{3,120},{4,120}]'),(114,'[{1,242},{2,4840},{3,121},{4,121}]'),(115,'[{1,244},{2,4880},{3,122},{4,122}]'),(116,'[{1,246},{2,4920},{3,123},{4,123}]'),(117,'[{1,248},{2,4960},{3,124},{4,124}]'),(118,'[{1,250},{2,5000},{3,125},{4,125}]'),(119,'[{1,252},{2,5040},{3,126},{4,126}]'),(120,'[{1,254},{2,5080},{3,127},{4,127}]'),(121,'[{1,256},{2,5120},{3,128},{4,128}]'),(122,'[{1,258},{2,5160},{3,129},{4,129}]'),(123,'[{1,260},{2,5200},{3,130},{4,130}]'),(124,'[{1,262},{2,5240},{3,131},{4,131}]'),(125,'[{1,264},{2,5280},{3,132},{4,132}]'),(126,'[{1,266},{2,5320},{3,133},{4,133}]'),(127,'[{1,268},{2,5360},{3,134},{4,134}]'),(128,'[{1,270},{2,5400},{3,135},{4,135}]'),(129,'[{1,272},{2,5440},{3,136},{4,136}]'),(130,'[{1,274},{2,5480},{3,137},{4,137}]'),(131,'[{1,276},{2,5520},{3,138},{4,138}]'),(132,'[{1,278},{2,5560},{3,139},{4,139}]'),(133,'[{1,280},{2,5600},{3,140},{4,140}]'),(134,'[{1,282},{2,5640},{3,141},{4,141}]'),(135,'[{1,284},{2,5680},{3,142},{4,142}]'),(136,'[{1,286},{2,5720},{3,143},{4,143}]'),(137,'[{1,288},{2,5760},{3,144},{4,144}]'),(138,'[{1,290},{2,5800},{3,145},{4,145}]'),(139,'[{1,292},{2,5840},{3,146},{4,146}]'),(140,'[{1,294},{2,5880},{3,147},{4,147}]'),(141,'[{1,296},{2,5920},{3,148},{4,148}]'),(142,'[{1,298},{2,5960},{3,149},{4,149}]'),(143,'[{1,300},{2,6000},{3,150},{4,150}]'),(144,'[{1,302},{2,6040},{3,151},{4,151}]'),(145,'[{1,304},{2,6080},{3,152},{4,152}]'),(146,'[{1,306},{2,6120},{3,153},{4,153}]'),(147,'[{1,308},{2,6160},{3,154},{4,154}]'),(148,'[{1,310},{2,6200},{3,155},{4,155}]'),(149,'[{1,312},{2,6240},{3,156},{4,156}]'),(150,'[{1,314},{2,6280},{3,157},{4,157}]'),(151,'[{1,316},{2,6320},{3,158},{4,158}]'),(152,'[{1,318},{2,6360},{3,159},{4,159}]'),(153,'[{1,320},{2,6400},{3,160},{4,160}]'),(154,'[{1,322},{2,6440},{3,161},{4,161}]'),(155,'[{1,324},{2,6480},{3,162},{4,162}]'),(156,'[{1,326},{2,6520},{3,163},{4,163}]'),(157,'[{1,328},{2,6560},{3,164},{4,164}]'),(158,'[{1,330},{2,6600},{3,165},{4,165}]'),(159,'[{1,332},{2,6640},{3,166},{4,166}]'),(160,'[{1,334},{2,6680},{3,167},{4,167}]'),(161,'[{1,336},{2,6720},{3,168},{4,168}]'),(162,'[{1,338},{2,6760},{3,169},{4,169}]'),(163,'[{1,340},{2,6800},{3,170},{4,170}]'),(164,'[{1,342},{2,6840},{3,171},{4,171}]'),(165,'[{1,344},{2,6880},{3,172},{4,172}]'),(166,'[{1,346},{2,6920},{3,173},{4,173}]'),(167,'[{1,348},{2,6960},{3,174},{4,174}]'),(168,'[{1,350},{2,7000},{3,175},{4,175}]'),(169,'[{1,352},{2,7040},{3,176},{4,176}]'),(170,'[{1,354},{2,7080},{3,177},{4,177}]'),(171,'[{1,356},{2,7120},{3,178},{4,178}]'),(172,'[{1,358},{2,7160},{3,179},{4,179}]'),(173,'[{1,360},{2,7200},{3,180},{4,180}]'),(174,'[{1,362},{2,7240},{3,181},{4,181}]'),(175,'[{1,364},{2,7280},{3,182},{4,182}]'),(176,'[{1,366},{2,7320},{3,183},{4,183}]'),(177,'[{1,368},{2,7360},{3,184},{4,184}]'),(178,'[{1,370},{2,7400},{3,185},{4,185}]'),(179,'[{1,372},{2,7440},{3,186},{4,186}]'),(180,'[{1,374},{2,7480},{3,187},{4,187}]'),(181,'[{1,376},{2,7520},{3,188},{4,188}]'),(182,'[{1,378},{2,7560},{3,189},{4,189}]'),(183,'[{1,380},{2,7600},{3,190},{4,190}]'),(184,'[{1,382},{2,7640},{3,191},{4,191}]'),(185,'[{1,384},{2,7680},{3,192},{4,192}]'),(186,'[{1,386},{2,7720},{3,193},{4,193}]'),(187,'[{1,388},{2,7760},{3,194},{4,194}]'),(188,'[{1,390},{2,7800},{3,195},{4,195}]'),(189,'[{1,392},{2,7840},{3,196},{4,196}]'),(190,'[{1,394},{2,7880},{3,197},{4,197}]'),(191,'[{1,396},{2,7920},{3,198},{4,198}]'),(192,'[{1,398},{2,7960},{3,199},{4,199}]'),(193,'[{1,400},{2,8000},{3,200},{4,200}]'),(194,'[{1,402},{2,8040},{3,201},{4,201}]'),(195,'[{1,404},{2,8080},{3,202},{4,202}]'),(196,'[{1,406},{2,8120},{3,203},{4,203}]'),(197,'[{1,408},{2,8160},{3,204},{4,204}]'),(198,'[{1,410},{2,8200},{3,205},{4,205}]'),(199,'[{1,412},{2,8240},{3,206},{4,206}]'),(200,'[{1,414},{2,8280},{3,207},{4,207}]'),(201,'[{1,416},{2,8320},{3,208},{4,208}]'),(202,'[{1,418},{2,8360},{3,209},{4,209}]'),(203,'[{1,420},{2,8400},{3,210},{4,210}]'),(204,'[{1,422},{2,8440},{3,211},{4,211}]'),(205,'[{1,424},{2,8480},{3,212},{4,212}]'),(206,'[{1,426},{2,8520},{3,213},{4,213}]'),(207,'[{1,428},{2,8560},{3,214},{4,214}]'),(208,'[{1,430},{2,8600},{3,215},{4,215}]'),(209,'[{1,432},{2,8640},{3,216},{4,216}]'),(210,'[{1,434},{2,8680},{3,217},{4,217}]'),(211,'[{1,436},{2,8720},{3,218},{4,218}]'),(212,'[{1,438},{2,8760},{3,219},{4,219}]'),(213,'[{1,440},{2,8800},{3,220},{4,220}]'),(214,'[{1,442},{2,8840},{3,221},{4,221}]'),(215,'[{1,444},{2,8880},{3,222},{4,222}]'),(216,'[{1,446},{2,8920},{3,223},{4,223}]'),(217,'[{1,448},{2,8960},{3,224},{4,224}]'),(218,'[{1,450},{2,9000},{3,225},{4,225}]'),(219,'[{1,452},{2,9040},{3,226},{4,226}]'),(220,'[{1,454},{2,9080},{3,227},{4,227}]'),(221,'[{1,456},{2,9120},{3,228},{4,228}]'),(222,'[{1,458},{2,9160},{3,229},{4,229}]'),(223,'[{1,460},{2,9200},{3,230},{4,230}]'),(224,'[{1,462},{2,9240},{3,231},{4,231}]'),(225,'[{1,464},{2,9280},{3,232},{4,232}]'),(226,'[{1,466},{2,9320},{3,233},{4,233}]'),(227,'[{1,468},{2,9360},{3,234},{4,234}]'),(228,'[{1,470},{2,9400},{3,235},{4,235}]'),(229,'[{1,472},{2,9440},{3,236},{4,236}]'),(230,'[{1,474},{2,9480},{3,237},{4,237}]'),(231,'[{1,476},{2,9520},{3,238},{4,238}]'),(232,'[{1,478},{2,9560},{3,239},{4,239}]'),(233,'[{1,480},{2,9600},{3,240},{4,240}]'),(234,'[{1,482},{2,9640},{3,241},{4,241}]'),(235,'[{1,484},{2,9680},{3,242},{4,242}]'),(236,'[{1,486},{2,9720},{3,243},{4,243}]'),(237,'[{1,488},{2,9760},{3,244},{4,244}]'),(238,'[{1,490},{2,9800},{3,245},{4,245}]'),(239,'[{1,492},{2,9840},{3,246},{4,246}]'),(240,'[{1,494},{2,9880},{3,247},{4,247}]'),(241,'[{1,496},{2,9920},{3,248},{4,248}]'),(242,'[{1,498},{2,9960},{3,249},{4,249}]'),(243,'[{1,500},{2,10000},{3,250},{4,250}]'),(244,'[{1,502},{2,10040},{3,251},{4,251}]'),(245,'[{1,504},{2,10080},{3,252},{4,252}]'),(246,'[{1,506},{2,10120},{3,253},{4,253}]'),(247,'[{1,508},{2,10160},{3,254},{4,254}]'),(248,'[{1,510},{2,10200},{3,255},{4,255}]'),(249,'[{1,512},{2,10240},{3,256},{4,256}]'),(250,'[{1,514},{2,10280},{3,257},{4,257}]'),(251,'[{1,516},{2,10320},{3,258},{4,258}]'),(252,'[{1,518},{2,10360},{3,259},{4,259}]'),(253,'[{1,520},{2,10400},{3,260},{4,260}]'),(254,'[{1,522},{2,10440},{3,261},{4,261}]'),(255,'[{1,524},{2,10480},{3,262},{4,262}]'),(256,'[{1,526},{2,10520},{3,263},{4,263}]'),(257,'[{1,528},{2,10560},{3,264},{4,264}]'),(258,'[{1,530},{2,10600},{3,265},{4,265}]'),(259,'[{1,532},{2,10640},{3,266},{4,266}]'),(260,'[{1,534},{2,10680},{3,267},{4,267}]'),(261,'[{1,536},{2,10720},{3,268},{4,268}]'),(262,'[{1,538},{2,10760},{3,269},{4,269}]'),(263,'[{1,540},{2,10800},{3,270},{4,270}]'),(264,'[{1,542},{2,10840},{3,271},{4,271}]'),(265,'[{1,544},{2,10880},{3,272},{4,272}]'),(266,'[{1,546},{2,10920},{3,273},{4,273}]'),(267,'[{1,548},{2,10960},{3,274},{4,274}]'),(268,'[{1,550},{2,11000},{3,275},{4,275}]'),(269,'[{1,552},{2,11040},{3,276},{4,276}]'),(270,'[{1,554},{2,11080},{3,277},{4,277}]'),(271,'[{1,556},{2,11120},{3,278},{4,278}]'),(272,'[{1,558},{2,11160},{3,279},{4,279}]'),(273,'[{1,560},{2,11200},{3,280},{4,280}]'),(274,'[{1,562},{2,11240},{3,281},{4,281}]'),(275,'[{1,564},{2,11280},{3,282},{4,282}]'),(276,'[{1,566},{2,11320},{3,283},{4,283}]'),(277,'[{1,568},{2,11360},{3,284},{4,284}]'),(278,'[{1,570},{2,11400},{3,285},{4,285}]'),(279,'[{1,572},{2,11440},{3,286},{4,286}]'),(280,'[{1,574},{2,11480},{3,287},{4,287}]'),(281,'[{1,576},{2,11520},{3,288},{4,288}]'),(282,'[{1,578},{2,11560},{3,289},{4,289}]'),(283,'[{1,580},{2,11600},{3,290},{4,290}]'),(284,'[{1,582},{2,11640},{3,291},{4,291}]'),(285,'[{1,584},{2,11680},{3,292},{4,292}]'),(286,'[{1,586},{2,11720},{3,293},{4,293}]'),(287,'[{1,588},{2,11760},{3,294},{4,294}]'),(288,'[{1,590},{2,11800},{3,295},{4,295}]'),(289,'[{1,592},{2,11840},{3,296},{4,296}]'),(290,'[{1,594},{2,11880},{3,297},{4,297}]'),(291,'[{1,596},{2,11920},{3,298},{4,298}]'),(292,'[{1,598},{2,11960},{3,299},{4,299}]'),(293,'[{1,600},{2,12000},{3,300},{4,300}]'),(294,'[{1,602},{2,12040},{3,301},{4,301}]'),(295,'[{1,604},{2,12080},{3,302},{4,302}]'),(296,'[{1,606},{2,12120},{3,303},{4,303}]'),(297,'[{1,608},{2,12160},{3,304},{4,304}]'),(298,'[{1,610},{2,12200},{3,305},{4,305}]'),(299,'[{1,612},{2,12240},{3,306},{4,306}]'),(300,'[{1,614},{2,12280},{3,307},{4,307}]'),(301,'[{1,616},{2,12320},{3,308},{4,308}]'),(302,'[{1,618},{2,12360},{3,309},{4,309}]'),(303,'[{1,620},{2,12400},{3,310},{4,310}]'),(304,'[{1,622},{2,12440},{3,311},{4,311}]'),(305,'[{1,624},{2,12480},{3,312},{4,312}]'),(306,'[{1,626},{2,12520},{3,313},{4,313}]'),(307,'[{1,628},{2,12560},{3,314},{4,314}]'),(308,'[{1,630},{2,12600},{3,315},{4,315}]'),(309,'[{1,632},{2,12640},{3,316},{4,316}]'),(310,'[{1,634},{2,12680},{3,317},{4,317}]'),(311,'[{1,636},{2,12720},{3,318},{4,318}]'),(312,'[{1,638},{2,12760},{3,319},{4,319}]'),(313,'[{1,640},{2,12800},{3,320},{4,320}]'),(314,'[{1,642},{2,12840},{3,321},{4,321}]'),(315,'[{1,644},{2,12880},{3,322},{4,322}]'),(316,'[{1,646},{2,12920},{3,323},{4,323}]'),(317,'[{1,648},{2,12960},{3,324},{4,324}]'),(318,'[{1,650},{2,13000},{3,325},{4,325}]'),(319,'[{1,652},{2,13040},{3,326},{4,326}]'),(320,'[{1,654},{2,13080},{3,327},{4,327}]'),(321,'[{1,656},{2,13120},{3,328},{4,328}]'),(322,'[{1,658},{2,13160},{3,329},{4,329}]'),(323,'[{1,660},{2,13200},{3,330},{4,330}]'),(324,'[{1,662},{2,13240},{3,331},{4,331}]'),(325,'[{1,664},{2,13280},{3,332},{4,332}]'),(326,'[{1,666},{2,13320},{3,333},{4,333}]'),(327,'[{1,668},{2,13360},{3,334},{4,334}]'),(328,'[{1,670},{2,13400},{3,335},{4,335}]'),(329,'[{1,672},{2,13440},{3,336},{4,336}]'),(330,'[{1,674},{2,13480},{3,337},{4,337}]'),(331,'[{1,676},{2,13520},{3,338},{4,338}]'),(332,'[{1,678},{2,13560},{3,339},{4,339}]'),(333,'[{1,680},{2,13600},{3,340},{4,340}]'),(334,'[{1,682},{2,13640},{3,341},{4,341}]'),(335,'[{1,684},{2,13680},{3,342},{4,342}]'),(336,'[{1,686},{2,13720},{3,343},{4,343}]'),(337,'[{1,688},{2,13760},{3,344},{4,344}]'),(338,'[{1,690},{2,13800},{3,345},{4,345}]'),(339,'[{1,692},{2,13840},{3,346},{4,346}]'),(340,'[{1,694},{2,13880},{3,347},{4,347}]'),(341,'[{1,696},{2,13920},{3,348},{4,348}]'),(342,'[{1,698},{2,13960},{3,349},{4,349}]'),(343,'[{1,700},{2,14000},{3,350},{4,350}]'),(344,'[{1,702},{2,14040},{3,351},{4,351}]'),(345,'[{1,704},{2,14080},{3,352},{4,352}]'),(346,'[{1,706},{2,14120},{3,353},{4,353}]'),(347,'[{1,708},{2,14160},{3,354},{4,354}]'),(348,'[{1,710},{2,14200},{3,355},{4,355}]'),(349,'[{1,712},{2,14240},{3,356},{4,356}]'),(350,'[{1,714},{2,14280},{3,357},{4,357}]'),(351,'[{1,716},{2,14320},{3,358},{4,358}]'),(352,'[{1,718},{2,14360},{3,359},{4,359}]'),(353,'[{1,720},{2,14400},{3,360},{4,360}]'),(354,'[{1,722},{2,14440},{3,361},{4,361}]'),(355,'[{1,724},{2,14480},{3,362},{4,362}]'),(356,'[{1,726},{2,14520},{3,363},{4,363}]'),(357,'[{1,728},{2,14560},{3,364},{4,364}]'),(358,'[{1,730},{2,14600},{3,365},{4,365}]'),(359,'[{1,732},{2,14640},{3,366},{4,366}]'),(360,'[{1,734},{2,14680},{3,367},{4,367}]'),(361,'[{1,736},{2,14720},{3,368},{4,368}]'),(362,'[{1,738},{2,14760},{3,369},{4,369}]'),(363,'[{1,740},{2,14800},{3,370},{4,370}]'),(364,'[{1,742},{2,14840},{3,371},{4,371}]'),(365,'[{1,744},{2,14880},{3,372},{4,372}]'),(366,'[{1,746},{2,14920},{3,373},{4,373}]'),(367,'[{1,748},{2,14960},{3,374},{4,374}]'),(368,'[{1,750},{2,15000},{3,375},{4,375}]'),(369,'[{1,752},{2,15040},{3,376},{4,376}]'),(370,'[{1,754},{2,15080},{3,377},{4,377}]'),(371,'[{1,756},{2,15120},{3,378},{4,378}]'),(372,'[{1,758},{2,15160},{3,379},{4,379}]'),(373,'[{1,760},{2,15200},{3,380},{4,380}]'),(374,'[{1,762},{2,15240},{3,381},{4,381}]'),(375,'[{1,764},{2,15280},{3,382},{4,382}]'),(376,'[{1,766},{2,15320},{3,383},{4,383}]'),(377,'[{1,768},{2,15360},{3,384},{4,384}]'),(378,'[{1,770},{2,15400},{3,385},{4,385}]'),(379,'[{1,772},{2,15440},{3,386},{4,386}]'),(380,'[{1,774},{2,15480},{3,387},{4,387}]'),(381,'[{1,776},{2,15520},{3,388},{4,388}]'),(382,'[{1,778},{2,15560},{3,389},{4,389}]'),(383,'[{1,780},{2,15600},{3,390},{4,390}]'),(384,'[{1,782},{2,15640},{3,391},{4,391}]'),(385,'[{1,784},{2,15680},{3,392},{4,392}]'),(386,'[{1,786},{2,15720},{3,393},{4,393}]'),(387,'[{1,788},{2,15760},{3,394},{4,394}]'),(388,'[{1,790},{2,15800},{3,395},{4,395}]'),(389,'[{1,792},{2,15840},{3,396},{4,396}]'),(390,'[{1,794},{2,15880},{3,397},{4,397}]'),(391,'[{1,796},{2,15920},{3,398},{4,398}]'),(392,'[{1,798},{2,15960},{3,399},{4,399}]'),(393,'[{1,800},{2,16000},{3,400},{4,400}]'),(394,'[{1,802},{2,16040},{3,401},{4,401}]'),(395,'[{1,804},{2,16080},{3,402},{4,402}]'),(396,'[{1,806},{2,16120},{3,403},{4,403}]'),(397,'[{1,808},{2,16160},{3,404},{4,404}]'),(398,'[{1,810},{2,16200},{3,405},{4,405}]'),(399,'[{1,812},{2,16240},{3,406},{4,406}]'),(400,'[{1,814},{2,16280},{3,407},{4,407}]'),(401,'[{1,816},{2,16320},{3,408},{4,408}]'),(402,'[{1,818},{2,16360},{3,409},{4,409}]'),(403,'[{1,820},{2,16400},{3,410},{4,410}]'),(404,'[{1,822},{2,16440},{3,411},{4,411}]'),(405,'[{1,824},{2,16480},{3,412},{4,412}]'),(406,'[{1,826},{2,16520},{3,413},{4,413}]'),(407,'[{1,828},{2,16560},{3,414},{4,414}]'),(408,'[{1,830},{2,16600},{3,415},{4,415}]'),(409,'[{1,832},{2,16640},{3,416},{4,416}]'),(410,'[{1,834},{2,16680},{3,417},{4,417}]'),(411,'[{1,836},{2,16720},{3,418},{4,418}]'),(412,'[{1,838},{2,16760},{3,419},{4,419}]'),(413,'[{1,840},{2,16800},{3,420},{4,420}]'),(414,'[{1,842},{2,16840},{3,421},{4,421}]'),(415,'[{1,844},{2,16880},{3,422},{4,422}]'),(416,'[{1,846},{2,16920},{3,423},{4,423}]'),(417,'[{1,848},{2,16960},{3,424},{4,424}]'),(418,'[{1,850},{2,17000},{3,425},{4,425}]'),(419,'[{1,852},{2,17040},{3,426},{4,426}]'),(420,'[{1,854},{2,17080},{3,427},{4,427}]'),(421,'[{1,856},{2,17120},{3,428},{4,428}]'),(422,'[{1,858},{2,17160},{3,429},{4,429}]'),(423,'[{1,860},{2,17200},{3,430},{4,430}]'),(424,'[{1,862},{2,17240},{3,431},{4,431}]'),(425,'[{1,864},{2,17280},{3,432},{4,432}]'),(426,'[{1,866},{2,17320},{3,433},{4,433}]'),(427,'[{1,868},{2,17360},{3,434},{4,434}]'),(428,'[{1,870},{2,17400},{3,435},{4,435}]'),(429,'[{1,872},{2,17440},{3,436},{4,436}]'),(430,'[{1,874},{2,17480},{3,437},{4,437}]'),(431,'[{1,876},{2,17520},{3,438},{4,438}]'),(432,'[{1,878},{2,17560},{3,439},{4,439}]'),(433,'[{1,880},{2,17600},{3,440},{4,440}]'),(434,'[{1,882},{2,17640},{3,441},{4,441}]'),(435,'[{1,884},{2,17680},{3,442},{4,442}]'),(436,'[{1,886},{2,17720},{3,443},{4,443}]'),(437,'[{1,888},{2,17760},{3,444},{4,444}]'),(438,'[{1,890},{2,17800},{3,445},{4,445}]'),(439,'[{1,892},{2,17840},{3,446},{4,446}]'),(440,'[{1,894},{2,17880},{3,447},{4,447}]'),(441,'[{1,896},{2,17920},{3,448},{4,448}]'),(442,'[{1,898},{2,17960},{3,449},{4,449}]'),(443,'[{1,900},{2,18000},{3,450},{4,450}]'),(444,'[{1,902},{2,18040},{3,451},{4,451}]'),(445,'[{1,904},{2,18080},{3,452},{4,452}]'),(446,'[{1,906},{2,18120},{3,453},{4,453}]'),(447,'[{1,908},{2,18160},{3,454},{4,454}]'),(448,'[{1,910},{2,18200},{3,455},{4,455}]'),(449,'[{1,912},{2,18240},{3,456},{4,456}]'),(450,'[{1,914},{2,18280},{3,457},{4,457}]'),(451,'[{1,916},{2,18320},{3,458},{4,458}]'),(452,'[{1,918},{2,18360},{3,459},{4,459}]'),(453,'[{1,920},{2,18400},{3,460},{4,460}]'),(454,'[{1,922},{2,18440},{3,461},{4,461}]'),(455,'[{1,924},{2,18480},{3,462},{4,462}]'),(456,'[{1,926},{2,18520},{3,463},{4,463}]'),(457,'[{1,928},{2,18560},{3,464},{4,464}]'),(458,'[{1,930},{2,18600},{3,465},{4,465}]'),(459,'[{1,932},{2,18640},{3,466},{4,466}]'),(460,'[{1,934},{2,18680},{3,467},{4,467}]'),(461,'[{1,936},{2,18720},{3,468},{4,468}]'),(462,'[{1,938},{2,18760},{3,469},{4,469}]'),(463,'[{1,940},{2,18800},{3,470},{4,470}]'),(464,'[{1,942},{2,18840},{3,471},{4,471}]'),(465,'[{1,944},{2,18880},{3,472},{4,472}]'),(466,'[{1,946},{2,18920},{3,473},{4,473}]'),(467,'[{1,948},{2,18960},{3,474},{4,474}]'),(468,'[{1,950},{2,19000},{3,475},{4,475}]'),(469,'[{1,952},{2,19040},{3,476},{4,476}]'),(470,'[{1,954},{2,19080},{3,477},{4,477}]'),(471,'[{1,956},{2,19120},{3,478},{4,478}]'),(472,'[{1,958},{2,19160},{3,479},{4,479}]'),(473,'[{1,960},{2,19200},{3,480},{4,480}]'),(474,'[{1,962},{2,19240},{3,481},{4,481}]'),(475,'[{1,964},{2,19280},{3,482},{4,482}]'),(476,'[{1,966},{2,19320},{3,483},{4,483}]'),(477,'[{1,968},{2,19360},{3,484},{4,484}]'),(478,'[{1,970},{2,19400},{3,485},{4,485}]'),(479,'[{1,972},{2,19440},{3,486},{4,486}]'),(480,'[{1,974},{2,19480},{3,487},{4,487}]'),(481,'[{1,976},{2,19520},{3,488},{4,488}]'),(482,'[{1,978},{2,19560},{3,489},{4,489}]'),(483,'[{1,980},{2,19600},{3,490},{4,490}]'),(484,'[{1,982},{2,19640},{3,491},{4,491}]'),(485,'[{1,984},{2,19680},{3,492},{4,492}]'),(486,'[{1,986},{2,19720},{3,493},{4,493}]'),(487,'[{1,988},{2,19760},{3,494},{4,494}]'),(488,'[{1,990},{2,19800},{3,495},{4,495}]'),(489,'[{1,992},{2,19840},{3,496},{4,496}]'),(490,'[{1,994},{2,19880},{3,497},{4,497}]'),(491,'[{1,996},{2,19920},{3,498},{4,498}]'),(492,'[{1,998},{2,19960},{3,499},{4,499}]'),(493,'[{1,1000},{2,20000},{3,500},{4,500}]'),(494,'[{1,1002},{2,20040},{3,501},{4,501}]'),(495,'[{1,1004},{2,20080},{3,502},{4,502}]'),(496,'[{1,1006},{2,20120},{3,503},{4,503}]'),(497,'[{1,1008},{2,20160},{3,504},{4,504}]'),(498,'[{1,1010},{2,20200},{3,505},{4,505}]'),(499,'[{1,1012},{2,20240},{3,506},{4,506}]'),(500,'[{1,1014},{2,20280},{3,507},{4,507}]'),(501,'[{1,1016},{2,20320},{3,508},{4,508}]'),(502,'[{1,1018},{2,20360},{3,509},{4,509}]'),(503,'[{1,1020},{2,20400},{3,510},{4,510}]'),(504,'[{1,1022},{2,20440},{3,511},{4,511}]'),(505,'[{1,1024},{2,20480},{3,512},{4,512}]'),(506,'[{1,1026},{2,20520},{3,513},{4,513}]'),(507,'[{1,1028},{2,20560},{3,514},{4,514}]'),(508,'[{1,1030},{2,20600},{3,515},{4,515}]'),(509,'[{1,1032},{2,20640},{3,516},{4,516}]'),(510,'[{1,1034},{2,20680},{3,517},{4,517}]'),(511,'[{1,1036},{2,20720},{3,518},{4,518}]'),(512,'[{1,1038},{2,20760},{3,519},{4,519}]'),(513,'[{1,1040},{2,20800},{3,520},{4,520}]'),(514,'[{1,1042},{2,20840},{3,521},{4,521}]'),(515,'[{1,1044},{2,20880},{3,522},{4,522}]'),(516,'[{1,1046},{2,20920},{3,523},{4,523}]'),(517,'[{1,1048},{2,20960},{3,524},{4,524}]'),(518,'[{1,1050},{2,21000},{3,525},{4,525}]'),(519,'[{1,1052},{2,21040},{3,526},{4,526}]'),(520,'[{1,1054},{2,21080},{3,527},{4,527}]'),(521,'[{1,1056},{2,21120},{3,528},{4,528}]'),(522,'[{1,1058},{2,21160},{3,529},{4,529}]'),(523,'[{1,1060},{2,21200},{3,530},{4,530}]'),(524,'[{1,1062},{2,21240},{3,531},{4,531}]'),(525,'[{1,1064},{2,21280},{3,532},{4,532}]'),(526,'[{1,1066},{2,21320},{3,533},{4,533}]'),(527,'[{1,1068},{2,21360},{3,534},{4,534}]'),(528,'[{1,1070},{2,21400},{3,535},{4,535}]'),(529,'[{1,1072},{2,21440},{3,536},{4,536}]'),(530,'[{1,1074},{2,21480},{3,537},{4,537}]'),(531,'[{1,1076},{2,21520},{3,538},{4,538}]'),(532,'[{1,1078},{2,21560},{3,539},{4,539}]'),(533,'[{1,1080},{2,21600},{3,540},{4,540}]'),(534,'[{1,1082},{2,21640},{3,541},{4,541}]'),(535,'[{1,1084},{2,21680},{3,542},{4,542}]'),(536,'[{1,1086},{2,21720},{3,543},{4,543}]'),(537,'[{1,1088},{2,21760},{3,544},{4,544}]'),(538,'[{1,1090},{2,21800},{3,545},{4,545}]'),(539,'[{1,1092},{2,21840},{3,546},{4,546}]'),(540,'[{1,1094},{2,21880},{3,547},{4,547}]'),(541,'[{1,1096},{2,21920},{3,548},{4,548}]'),(542,'[{1,1098},{2,21960},{3,549},{4,549}]'),(543,'[{1,1100},{2,22000},{3,550},{4,550}]'),(544,'[{1,1102},{2,22040},{3,551},{4,551}]'),(545,'[{1,1104},{2,22080},{3,552},{4,552}]'),(546,'[{1,1106},{2,22120},{3,553},{4,553}]'),(547,'[{1,1108},{2,22160},{3,554},{4,554}]'),(548,'[{1,1110},{2,22200},{3,555},{4,555}]'),(549,'[{1,1112},{2,22240},{3,556},{4,556}]'),(550,'[{1,1114},{2,22280},{3,557},{4,557}]'),(551,'[{1,1116},{2,22320},{3,558},{4,558}]'),(552,'[{1,1118},{2,22360},{3,559},{4,559}]'),(553,'[{1,1120},{2,22400},{3,560},{4,560}]'),(554,'[{1,1122},{2,22440},{3,561},{4,561}]'),(555,'[{1,1124},{2,22480},{3,562},{4,562}]'),(556,'[{1,1126},{2,22520},{3,563},{4,563}]'),(557,'[{1,1128},{2,22560},{3,564},{4,564}]'),(558,'[{1,1130},{2,22600},{3,565},{4,565}]'),(559,'[{1,1132},{2,22640},{3,566},{4,566}]'),(560,'[{1,1134},{2,22680},{3,567},{4,567}]'),(561,'[{1,1136},{2,22720},{3,568},{4,568}]'),(562,'[{1,1138},{2,22760},{3,569},{4,569}]'),(563,'[{1,1140},{2,22800},{3,570},{4,570}]'),(564,'[{1,1142},{2,22840},{3,571},{4,571}]'),(565,'[{1,1144},{2,22880},{3,572},{4,572}]'),(566,'[{1,1146},{2,22920},{3,573},{4,573}]'),(567,'[{1,1148},{2,22960},{3,574},{4,574}]'),(568,'[{1,1150},{2,23000},{3,575},{4,575}]'),(569,'[{1,1152},{2,23040},{3,576},{4,576}]'),(570,'[{1,1154},{2,23080},{3,577},{4,577}]'),(571,'[{1,1156},{2,23120},{3,578},{4,578}]'),(572,'[{1,1158},{2,23160},{3,579},{4,579}]'),(573,'[{1,1160},{2,23200},{3,580},{4,580}]'),(574,'[{1,1162},{2,23240},{3,581},{4,581}]'),(575,'[{1,1164},{2,23280},{3,582},{4,582}]'),(576,'[{1,1166},{2,23320},{3,583},{4,583}]'),(577,'[{1,1168},{2,23360},{3,584},{4,584}]'),(578,'[{1,1170},{2,23400},{3,585},{4,585}]'),(579,'[{1,1172},{2,23440},{3,586},{4,586}]'),(580,'[{1,1174},{2,23480},{3,587},{4,587}]'),(581,'[{1,1176},{2,23520},{3,588},{4,588}]'),(582,'[{1,1178},{2,23560},{3,589},{4,589}]'),(583,'[{1,1180},{2,23600},{3,590},{4,590}]'),(584,'[{1,1182},{2,23640},{3,591},{4,591}]'),(585,'[{1,1184},{2,23680},{3,592},{4,592}]'),(586,'[{1,1186},{2,23720},{3,593},{4,593}]'),(587,'[{1,1188},{2,23760},{3,594},{4,594}]'),(588,'[{1,1190},{2,23800},{3,595},{4,595}]'),(589,'[{1,1192},{2,23840},{3,596},{4,596}]'),(590,'[{1,1194},{2,23880},{3,597},{4,597}]'),(591,'[{1,1196},{2,23920},{3,598},{4,598}]'),(592,'[{1,1198},{2,23960},{3,599},{4,599}]'),(593,'[{1,1200},{2,24000},{3,600},{4,600}]'),(594,'[{1,1202},{2,24040},{3,601},{4,601}]'),(595,'[{1,1204},{2,24080},{3,602},{4,602}]'),(596,'[{1,1206},{2,24120},{3,603},{4,603}]'),(597,'[{1,1208},{2,24160},{3,604},{4,604}]'),(598,'[{1,1210},{2,24200},{3,605},{4,605}]'),(599,'[{1,1212},{2,24240},{3,606},{4,606}]'),(600,'[{1,1214},{2,24280},{3,607},{4,607}]'),(601,'[{1,1216},{2,24320},{3,608},{4,608}]'),(602,'[{1,1218},{2,24360},{3,609},{4,609}]'),(603,'[{1,1220},{2,24400},{3,610},{4,610}]'),(604,'[{1,1222},{2,24440},{3,611},{4,611}]'),(605,'[{1,1224},{2,24480},{3,612},{4,612}]'),(606,'[{1,1226},{2,24520},{3,613},{4,613}]'),(607,'[{1,1228},{2,24560},{3,614},{4,614}]'),(608,'[{1,1230},{2,24600},{3,615},{4,615}]'),(609,'[{1,1232},{2,24640},{3,616},{4,616}]'),(610,'[{1,1234},{2,24680},{3,617},{4,617}]'),(611,'[{1,1236},{2,24720},{3,618},{4,618}]'),(612,'[{1,1238},{2,24760},{3,619},{4,619}]'),(613,'[{1,1240},{2,24800},{3,620},{4,620}]'),(614,'[{1,1242},{2,24840},{3,621},{4,621}]'),(615,'[{1,1244},{2,24880},{3,622},{4,622}]'),(616,'[{1,1246},{2,24920},{3,623},{4,623}]'),(617,'[{1,1248},{2,24960},{3,624},{4,624}]'),(618,'[{1,1250},{2,25000},{3,625},{4,625}]'),(619,'[{1,1252},{2,25040},{3,626},{4,626}]'),(620,'[{1,1254},{2,25080},{3,627},{4,627}]'),(621,'[{1,1256},{2,25120},{3,628},{4,628}]'),(622,'[{1,1258},{2,25160},{3,629},{4,629}]'),(623,'[{1,1260},{2,25200},{3,630},{4,630}]'),(624,'[{1,1262},{2,25240},{3,631},{4,631}]'),(625,'[{1,1264},{2,25280},{3,632},{4,632}]'),(626,'[{1,1266},{2,25320},{3,633},{4,633}]'),(627,'[{1,1268},{2,25360},{3,634},{4,634}]'),(628,'[{1,1270},{2,25400},{3,635},{4,635}]'),(629,'[{1,1272},{2,25440},{3,636},{4,636}]'),(630,'[{1,1274},{2,25480},{3,637},{4,637}]'),(631,'[{1,1276},{2,25520},{3,638},{4,638}]'),(632,'[{1,1278},{2,25560},{3,639},{4,639}]'),(633,'[{1,1280},{2,25600},{3,640},{4,640}]'),(634,'[{1,1282},{2,25640},{3,641},{4,641}]'),(635,'[{1,1284},{2,25680},{3,642},{4,642}]'),(636,'[{1,1286},{2,25720},{3,643},{4,643}]'),(637,'[{1,1288},{2,25760},{3,644},{4,644}]'),(638,'[{1,1290},{2,25800},{3,645},{4,645}]'),(639,'[{1,1292},{2,25840},{3,646},{4,646}]'),(640,'[{1,1294},{2,25880},{3,647},{4,647}]'),(641,'[{1,1296},{2,25920},{3,648},{4,648}]'),(642,'[{1,1298},{2,25960},{3,649},{4,649}]'),(643,'[{1,1300},{2,26000},{3,650},{4,650}]'),(644,'[{1,1302},{2,26040},{3,651},{4,651}]'),(645,'[{1,1304},{2,26080},{3,652},{4,652}]'),(646,'[{1,1306},{2,26120},{3,653},{4,653}]'),(647,'[{1,1308},{2,26160},{3,654},{4,654}]'),(648,'[{1,1310},{2,26200},{3,655},{4,655}]'),(649,'[{1,1312},{2,26240},{3,656},{4,656}]'),(650,'[{1,1314},{2,26280},{3,657},{4,657}]'),(651,'[{1,1316},{2,26320},{3,658},{4,658}]'),(652,'[{1,1318},{2,26360},{3,659},{4,659}]'),(653,'[{1,1320},{2,26400},{3,660},{4,660}]'),(654,'[{1,1322},{2,26440},{3,661},{4,661}]'),(655,'[{1,1324},{2,26480},{3,662},{4,662}]'),(656,'[{1,1326},{2,26520},{3,663},{4,663}]'),(657,'[{1,1328},{2,26560},{3,664},{4,664}]'),(658,'[{1,1330},{2,26600},{3,665},{4,665}]'),(659,'[{1,1332},{2,26640},{3,666},{4,666}]'),(660,'[{1,1334},{2,26680},{3,667},{4,667}]'),(661,'[{1,1336},{2,26720},{3,668},{4,668}]'),(662,'[{1,1338},{2,26760},{3,669},{4,669}]'),(663,'[{1,1340},{2,26800},{3,670},{4,670}]'),(664,'[{1,1342},{2,26840},{3,671},{4,671}]'),(665,'[{1,1344},{2,26880},{3,672},{4,672}]'),(666,'[{1,1346},{2,26920},{3,673},{4,673}]'),(667,'[{1,1348},{2,26960},{3,674},{4,674}]'),(668,'[{1,1350},{2,27000},{3,675},{4,675}]'),(669,'[{1,1352},{2,27040},{3,676},{4,676}]'),(670,'[{1,1354},{2,27080},{3,677},{4,677}]'),(671,'[{1,1356},{2,27120},{3,678},{4,678}]'),(672,'[{1,1358},{2,27160},{3,679},{4,679}]'),(673,'[{1,1360},{2,27200},{3,680},{4,680}]'),(674,'[{1,1362},{2,27240},{3,681},{4,681}]'),(675,'[{1,1364},{2,27280},{3,682},{4,682}]'),(676,'[{1,1366},{2,27320},{3,683},{4,683}]'),(677,'[{1,1368},{2,27360},{3,684},{4,684}]'),(678,'[{1,1370},{2,27400},{3,685},{4,685}]'),(679,'[{1,1372},{2,27440},{3,686},{4,686}]'),(680,'[{1,1374},{2,27480},{3,687},{4,687}]'),(681,'[{1,1376},{2,27520},{3,688},{4,688}]'),(682,'[{1,1378},{2,27560},{3,689},{4,689}]'),(683,'[{1,1380},{2,27600},{3,690},{4,690}]'),(684,'[{1,1382},{2,27640},{3,691},{4,691}]'),(685,'[{1,1384},{2,27680},{3,692},{4,692}]'),(686,'[{1,1386},{2,27720},{3,693},{4,693}]'),(687,'[{1,1388},{2,27760},{3,694},{4,694}]'),(688,'[{1,1390},{2,27800},{3,695},{4,695}]'),(689,'[{1,1392},{2,27840},{3,696},{4,696}]'),(690,'[{1,1394},{2,27880},{3,697},{4,697}]'),(691,'[{1,1396},{2,27920},{3,698},{4,698}]'),(692,'[{1,1398},{2,27960},{3,699},{4,699}]'),(693,'[{1,1400},{2,28000},{3,700},{4,700}]'),(694,'[{1,1402},{2,28040},{3,701},{4,701}]'),(695,'[{1,1404},{2,28080},{3,702},{4,702}]'),(696,'[{1,1406},{2,28120},{3,703},{4,703}]'),(697,'[{1,1408},{2,28160},{3,704},{4,704}]'),(698,'[{1,1410},{2,28200},{3,705},{4,705}]'),(699,'[{1,1412},{2,28240},{3,706},{4,706}]'),(700,'[{1,1414},{2,28280},{3,707},{4,707}]'),(701,'[{1,1416},{2,28320},{3,708},{4,708}]'),(702,'[{1,1418},{2,28360},{3,709},{4,709}]'),(703,'[{1,1420},{2,28400},{3,710},{4,710}]'),(704,'[{1,1422},{2,28440},{3,711},{4,711}]'),(705,'[{1,1424},{2,28480},{3,712},{4,712}]'),(706,'[{1,1426},{2,28520},{3,713},{4,713}]'),(707,'[{1,1428},{2,28560},{3,714},{4,714}]'),(708,'[{1,1430},{2,28600},{3,715},{4,715}]'),(709,'[{1,1432},{2,28640},{3,716},{4,716}]'),(710,'[{1,1434},{2,28680},{3,717},{4,717}]'),(711,'[{1,1436},{2,28720},{3,718},{4,718}]'),(712,'[{1,1438},{2,28760},{3,719},{4,719}]'),(713,'[{1,1440},{2,28800},{3,720},{4,720}]'),(714,'[{1,1442},{2,28840},{3,721},{4,721}]'),(715,'[{1,1444},{2,28880},{3,722},{4,722}]'),(716,'[{1,1446},{2,28920},{3,723},{4,723}]'),(717,'[{1,1448},{2,28960},{3,724},{4,724}]'),(718,'[{1,1450},{2,29000},{3,725},{4,725}]'),(719,'[{1,1452},{2,29040},{3,726},{4,726}]'),(720,'[{1,1454},{2,29080},{3,727},{4,727}]'),(721,'[{1,1456},{2,29120},{3,728},{4,728}]'),(722,'[{1,1458},{2,29160},{3,729},{4,729}]'),(723,'[{1,1460},{2,29200},{3,730},{4,730}]'),(724,'[{1,1462},{2,29240},{3,731},{4,731}]'),(725,'[{1,1464},{2,29280},{3,732},{4,732}]'),(726,'[{1,1466},{2,29320},{3,733},{4,733}]'),(727,'[{1,1468},{2,29360},{3,734},{4,734}]'),(728,'[{1,1470},{2,29400},{3,735},{4,735}]'),(729,'[{1,1472},{2,29440},{3,736},{4,736}]'),(730,'[{1,1474},{2,29480},{3,737},{4,737}]'),(731,'[{1,1476},{2,29520},{3,738},{4,738}]'),(732,'[{1,1478},{2,29560},{3,739},{4,739}]'),(733,'[{1,1480},{2,29600},{3,740},{4,740}]'),(734,'[{1,1482},{2,29640},{3,741},{4,741}]'),(735,'[{1,1484},{2,29680},{3,742},{4,742}]'),(736,'[{1,1486},{2,29720},{3,743},{4,743}]'),(737,'[{1,1488},{2,29760},{3,744},{4,744}]'),(738,'[{1,1490},{2,29800},{3,745},{4,745}]'),(739,'[{1,1492},{2,29840},{3,746},{4,746}]'),(740,'[{1,1494},{2,29880},{3,747},{4,747}]'),(741,'[{1,1496},{2,29920},{3,748},{4,748}]'),(742,'[{1,1498},{2,29960},{3,749},{4,749}]'),(743,'[{1,1500},{2,30000},{3,750},{4,750}]'),(744,'[{1,1502},{2,30040},{3,751},{4,751}]'),(745,'[{1,1504},{2,30080},{3,752},{4,752}]'),(746,'[{1,1506},{2,30120},{3,753},{4,753}]'),(747,'[{1,1508},{2,30160},{3,754},{4,754}]'),(748,'[{1,1510},{2,30200},{3,755},{4,755}]'),(749,'[{1,1512},{2,30240},{3,756},{4,756}]'),(750,'[{1,1514},{2,30280},{3,757},{4,757}]'),(751,'[{1,1516},{2,30320},{3,758},{4,758}]'),(752,'[{1,1518},{2,30360},{3,759},{4,759}]'),(753,'[{1,1520},{2,30400},{3,760},{4,760}]'),(754,'[{1,1522},{2,30440},{3,761},{4,761}]'),(755,'[{1,1524},{2,30480},{3,762},{4,762}]'),(756,'[{1,1526},{2,30520},{3,763},{4,763}]'),(757,'[{1,1528},{2,30560},{3,764},{4,764}]'),(758,'[{1,1530},{2,30600},{3,765},{4,765}]'),(759,'[{1,1532},{2,30640},{3,766},{4,766}]'),(760,'[{1,1534},{2,30680},{3,767},{4,767}]'),(761,'[{1,1536},{2,30720},{3,768},{4,768}]'),(762,'[{1,1538},{2,30760},{3,769},{4,769}]'),(763,'[{1,1540},{2,30800},{3,770},{4,770}]'),(764,'[{1,1542},{2,30840},{3,771},{4,771}]'),(765,'[{1,1544},{2,30880},{3,772},{4,772}]'),(766,'[{1,1546},{2,30920},{3,773},{4,773}]'),(767,'[{1,1548},{2,30960},{3,774},{4,774}]'),(768,'[{1,1550},{2,31000},{3,775},{4,775}]'),(769,'[{1,1552},{2,31040},{3,776},{4,776}]'),(770,'[{1,1554},{2,31080},{3,777},{4,777}]'),(771,'[{1,1556},{2,31120},{3,778},{4,778}]'),(772,'[{1,1558},{2,31160},{3,779},{4,779}]'),(773,'[{1,1560},{2,31200},{3,780},{4,780}]'),(774,'[{1,1562},{2,31240},{3,781},{4,781}]'),(775,'[{1,1564},{2,31280},{3,782},{4,782}]'),(776,'[{1,1566},{2,31320},{3,783},{4,783}]'),(777,'[{1,1568},{2,31360},{3,784},{4,784}]'),(778,'[{1,1570},{2,31400},{3,785},{4,785}]'),(779,'[{1,1572},{2,31440},{3,786},{4,786}]'),(780,'[{1,1574},{2,31480},{3,787},{4,787}]'),(781,'[{1,1576},{2,31520},{3,788},{4,788}]'),(782,'[{1,1578},{2,31560},{3,789},{4,789}]'),(783,'[{1,1580},{2,31600},{3,790},{4,790}]'),(784,'[{1,1582},{2,31640},{3,791},{4,791}]'),(785,'[{1,1584},{2,31680},{3,792},{4,792}]'),(786,'[{1,1586},{2,31720},{3,793},{4,793}]'),(787,'[{1,1588},{2,31760},{3,794},{4,794}]'),(788,'[{1,1590},{2,31800},{3,795},{4,795}]'),(789,'[{1,1592},{2,31840},{3,796},{4,796}]'),(790,'[{1,1594},{2,31880},{3,797},{4,797}]'),(791,'[{1,1596},{2,31920},{3,798},{4,798}]'),(792,'[{1,1598},{2,31960},{3,799},{4,799}]'),(793,'[{1,1600},{2,32000},{3,800},{4,800}]'),(794,'[{1,1602},{2,32040},{3,801},{4,801}]'),(795,'[{1,1604},{2,32080},{3,802},{4,802}]'),(796,'[{1,1606},{2,32120},{3,803},{4,803}]'),(797,'[{1,1608},{2,32160},{3,804},{4,804}]'),(798,'[{1,1610},{2,32200},{3,805},{4,805}]'),(799,'[{1,1612},{2,32240},{3,806},{4,806}]'),(800,'[{1,1614},{2,32280},{3,807},{4,807}]'),(801,'[{1,1616},{2,32320},{3,808},{4,808}]'),(802,'[{1,1618},{2,32360},{3,809},{4,809}]'),(803,'[{1,1620},{2,32400},{3,810},{4,810}]'),(804,'[{1,1622},{2,32440},{3,811},{4,811}]'),(805,'[{1,1624},{2,32480},{3,812},{4,812}]'),(806,'[{1,1626},{2,32520},{3,813},{4,813}]'),(807,'[{1,1628},{2,32560},{3,814},{4,814}]'),(808,'[{1,1630},{2,32600},{3,815},{4,815}]'),(809,'[{1,1632},{2,32640},{3,816},{4,816}]'),(810,'[{1,1634},{2,32680},{3,817},{4,817}]'),(811,'[{1,1636},{2,32720},{3,818},{4,818}]'),(812,'[{1,1638},{2,32760},{3,819},{4,819}]'),(813,'[{1,1640},{2,32800},{3,820},{4,820}]'),(814,'[{1,1642},{2,32840},{3,821},{4,821}]'),(815,'[{1,1644},{2,32880},{3,822},{4,822}]'),(816,'[{1,1646},{2,32920},{3,823},{4,823}]'),(817,'[{1,1648},{2,32960},{3,824},{4,824}]'),(818,'[{1,1650},{2,33000},{3,825},{4,825}]'),(819,'[{1,1652},{2,33040},{3,826},{4,826}]'),(820,'[{1,1654},{2,33080},{3,827},{4,827}]'),(821,'[{1,1656},{2,33120},{3,828},{4,828}]'),(822,'[{1,1658},{2,33160},{3,829},{4,829}]'),(823,'[{1,1660},{2,33200},{3,830},{4,830}]'),(824,'[{1,1662},{2,33240},{3,831},{4,831}]'),(825,'[{1,1664},{2,33280},{3,832},{4,832}]'),(826,'[{1,1666},{2,33320},{3,833},{4,833}]'),(827,'[{1,1668},{2,33360},{3,834},{4,834}]'),(828,'[{1,1670},{2,33400},{3,835},{4,835}]'),(829,'[{1,1672},{2,33440},{3,836},{4,836}]'),(830,'[{1,1674},{2,33480},{3,837},{4,837}]'),(831,'[{1,1676},{2,33520},{3,838},{4,838}]'),(832,'[{1,1678},{2,33560},{3,839},{4,839}]'),(833,'[{1,1680},{2,33600},{3,840},{4,840}]'),(834,'[{1,1682},{2,33640},{3,841},{4,841}]'),(835,'[{1,1684},{2,33680},{3,842},{4,842}]'),(836,'[{1,1686},{2,33720},{3,843},{4,843}]'),(837,'[{1,1688},{2,33760},{3,844},{4,844}]'),(838,'[{1,1690},{2,33800},{3,845},{4,845}]'),(839,'[{1,1692},{2,33840},{3,846},{4,846}]'),(840,'[{1,1694},{2,33880},{3,847},{4,847}]'),(841,'[{1,1696},{2,33920},{3,848},{4,848}]'),(842,'[{1,1698},{2,33960},{3,849},{4,849}]'),(843,'[{1,1700},{2,34000},{3,850},{4,850}]'),(844,'[{1,1702},{2,34040},{3,851},{4,851}]'),(845,'[{1,1704},{2,34080},{3,852},{4,852}]'),(846,'[{1,1706},{2,34120},{3,853},{4,853}]'),(847,'[{1,1708},{2,34160},{3,854},{4,854}]'),(848,'[{1,1710},{2,34200},{3,855},{4,855}]'),(849,'[{1,1712},{2,34240},{3,856},{4,856}]'),(850,'[{1,1714},{2,34280},{3,857},{4,857}]'),(851,'[{1,1716},{2,34320},{3,858},{4,858}]'),(852,'[{1,1718},{2,34360},{3,859},{4,859}]'),(853,'[{1,1720},{2,34400},{3,860},{4,860}]'),(854,'[{1,1722},{2,34440},{3,861},{4,861}]'),(855,'[{1,1724},{2,34480},{3,862},{4,862}]'),(856,'[{1,1726},{2,34520},{3,863},{4,863}]'),(857,'[{1,1728},{2,34560},{3,864},{4,864}]'),(858,'[{1,1730},{2,34600},{3,865},{4,865}]'),(859,'[{1,1732},{2,34640},{3,866},{4,866}]'),(860,'[{1,1734},{2,34680},{3,867},{4,867}]'),(861,'[{1,1736},{2,34720},{3,868},{4,868}]'),(862,'[{1,1738},{2,34760},{3,869},{4,869}]'),(863,'[{1,1740},{2,34800},{3,870},{4,870}]'),(864,'[{1,1742},{2,34840},{3,871},{4,871}]'),(865,'[{1,1744},{2,34880},{3,872},{4,872}]'),(866,'[{1,1746},{2,34920},{3,873},{4,873}]'),(867,'[{1,1748},{2,34960},{3,874},{4,874}]'),(868,'[{1,1750},{2,35000},{3,875},{4,875}]'),(869,'[{1,1752},{2,35040},{3,876},{4,876}]'),(870,'[{1,1754},{2,35080},{3,877},{4,877}]'),(871,'[{1,1756},{2,35120},{3,878},{4,878}]'),(872,'[{1,1758},{2,35160},{3,879},{4,879}]'),(873,'[{1,1760},{2,35200},{3,880},{4,880}]'),(874,'[{1,1762},{2,35240},{3,881},{4,881}]'),(875,'[{1,1764},{2,35280},{3,882},{4,882}]'),(876,'[{1,1766},{2,35320},{3,883},{4,883}]'),(877,'[{1,1768},{2,35360},{3,884},{4,884}]'),(878,'[{1,1770},{2,35400},{3,885},{4,885}]'),(879,'[{1,1772},{2,35440},{3,886},{4,886}]'),(880,'[{1,1774},{2,35480},{3,887},{4,887}]'),(881,'[{1,1776},{2,35520},{3,888},{4,888}]'),(882,'[{1,1778},{2,35560},{3,889},{4,889}]'),(883,'[{1,1780},{2,35600},{3,890},{4,890}]'),(884,'[{1,1782},{2,35640},{3,891},{4,891}]'),(885,'[{1,1784},{2,35680},{3,892},{4,892}]'),(886,'[{1,1786},{2,35720},{3,893},{4,893}]'),(887,'[{1,1788},{2,35760},{3,894},{4,894}]'),(888,'[{1,1790},{2,35800},{3,895},{4,895}]'),(889,'[{1,1792},{2,35840},{3,896},{4,896}]'),(890,'[{1,1794},{2,35880},{3,897},{4,897}]'),(891,'[{1,1796},{2,35920},{3,898},{4,898}]'),(892,'[{1,1798},{2,35960},{3,899},{4,899}]'),(893,'[{1,1800},{2,36000},{3,900},{4,900}]'),(894,'[{1,1802},{2,36040},{3,901},{4,901}]'),(895,'[{1,1804},{2,36080},{3,902},{4,902}]'),(896,'[{1,1806},{2,36120},{3,903},{4,903}]'),(897,'[{1,1808},{2,36160},{3,904},{4,904}]'),(898,'[{1,1810},{2,36200},{3,905},{4,905}]'),(899,'[{1,1812},{2,36240},{3,906},{4,906}]'),(900,'[{1,1814},{2,36280},{3,907},{4,907}]'),(901,'[{1,1816},{2,36320},{3,908},{4,908}]'),(902,'[{1,1818},{2,36360},{3,909},{4,909}]'),(903,'[{1,1820},{2,36400},{3,910},{4,910}]'),(904,'[{1,1822},{2,36440},{3,911},{4,911}]'),(905,'[{1,1824},{2,36480},{3,912},{4,912}]'),(906,'[{1,1826},{2,36520},{3,913},{4,913}]'),(907,'[{1,1828},{2,36560},{3,914},{4,914}]'),(908,'[{1,1830},{2,36600},{3,915},{4,915}]'),(909,'[{1,1832},{2,36640},{3,916},{4,916}]'),(910,'[{1,1834},{2,36680},{3,917},{4,917}]'),(911,'[{1,1836},{2,36720},{3,918},{4,918}]'),(912,'[{1,1838},{2,36760},{3,919},{4,919}]'),(913,'[{1,1840},{2,36800},{3,920},{4,920}]'),(914,'[{1,1842},{2,36840},{3,921},{4,921}]'),(915,'[{1,1844},{2,36880},{3,922},{4,922}]'),(916,'[{1,1846},{2,36920},{3,923},{4,923}]'),(917,'[{1,1848},{2,36960},{3,924},{4,924}]'),(918,'[{1,1850},{2,37000},{3,925},{4,925}]'),(919,'[{1,1852},{2,37040},{3,926},{4,926}]'),(920,'[{1,1854},{2,37080},{3,927},{4,927}]'),(921,'[{1,1856},{2,37120},{3,928},{4,928}]'),(922,'[{1,1858},{2,37160},{3,929},{4,929}]'),(923,'[{1,1860},{2,37200},{3,930},{4,930}]'),(924,'[{1,1862},{2,37240},{3,931},{4,931}]'),(925,'[{1,1864},{2,37280},{3,932},{4,932}]'),(926,'[{1,1866},{2,37320},{3,933},{4,933}]'),(927,'[{1,1868},{2,37360},{3,934},{4,934}]'),(928,'[{1,1870},{2,37400},{3,935},{4,935}]'),(929,'[{1,1872},{2,37440},{3,936},{4,936}]'),(930,'[{1,1874},{2,37480},{3,937},{4,937}]'),(931,'[{1,1876},{2,37520},{3,938},{4,938}]'),(932,'[{1,1878},{2,37560},{3,939},{4,939}]'),(933,'[{1,1880},{2,37600},{3,940},{4,940}]'),(934,'[{1,1882},{2,37640},{3,941},{4,941}]'),(935,'[{1,1884},{2,37680},{3,942},{4,942}]'),(936,'[{1,1886},{2,37720},{3,943},{4,943}]'),(937,'[{1,1888},{2,37760},{3,944},{4,944}]'),(938,'[{1,1890},{2,37800},{3,945},{4,945}]'),(939,'[{1,1892},{2,37840},{3,946},{4,946}]'),(940,'[{1,1894},{2,37880},{3,947},{4,947}]'),(941,'[{1,1896},{2,37920},{3,948},{4,948}]'),(942,'[{1,1898},{2,37960},{3,949},{4,949}]'),(943,'[{1,1900},{2,38000},{3,950},{4,950}]'),(944,'[{1,1902},{2,38040},{3,951},{4,951}]'),(945,'[{1,1904},{2,38080},{3,952},{4,952}]'),(946,'[{1,1906},{2,38120},{3,953},{4,953}]'),(947,'[{1,1908},{2,38160},{3,954},{4,954}]'),(948,'[{1,1910},{2,38200},{3,955},{4,955}]'),(949,'[{1,1912},{2,38240},{3,956},{4,956}]'),(950,'[{1,1914},{2,38280},{3,957},{4,957}]'),(951,'[{1,1916},{2,38320},{3,958},{4,958}]'),(952,'[{1,1918},{2,38360},{3,959},{4,959}]'),(953,'[{1,1920},{2,38400},{3,960},{4,960}]'),(954,'[{1,1922},{2,38440},{3,961},{4,961}]'),(955,'[{1,1924},{2,38480},{3,962},{4,962}]'),(956,'[{1,1926},{2,38520},{3,963},{4,963}]'),(957,'[{1,1928},{2,38560},{3,964},{4,964}]'),(958,'[{1,1930},{2,38600},{3,965},{4,965}]'),(959,'[{1,1932},{2,38640},{3,966},{4,966}]'),(960,'[{1,1934},{2,38680},{3,967},{4,967}]'),(961,'[{1,1936},{2,38720},{3,968},{4,968}]'),(962,'[{1,1938},{2,38760},{3,969},{4,969}]'),(963,'[{1,1940},{2,38800},{3,970},{4,970}]'),(964,'[{1,1942},{2,38840},{3,971},{4,971}]'),(965,'[{1,1944},{2,38880},{3,972},{4,972}]'),(966,'[{1,1946},{2,38920},{3,973},{4,973}]'),(967,'[{1,1948},{2,38960},{3,974},{4,974}]'),(968,'[{1,1950},{2,39000},{3,975},{4,975}]'),(969,'[{1,1952},{2,39040},{3,976},{4,976}]'),(970,'[{1,1954},{2,39080},{3,977},{4,977}]'),(971,'[{1,1956},{2,39120},{3,978},{4,978}]'),(972,'[{1,1958},{2,39160},{3,979},{4,979}]'),(973,'[{1,1960},{2,39200},{3,980},{4,980}]'),(974,'[{1,1962},{2,39240},{3,981},{4,981}]'),(975,'[{1,1964},{2,39280},{3,982},{4,982}]'),(976,'[{1,1966},{2,39320},{3,983},{4,983}]'),(977,'[{1,1968},{2,39360},{3,984},{4,984}]'),(978,'[{1,1970},{2,39400},{3,985},{4,985}]'),(979,'[{1,1972},{2,39440},{3,986},{4,986}]'),(980,'[{1,1974},{2,39480},{3,987},{4,987}]'),(981,'[{1,1976},{2,39520},{3,988},{4,988}]'),(982,'[{1,1978},{2,39560},{3,989},{4,989}]'),(983,'[{1,1980},{2,39600},{3,990},{4,990}]'),(984,'[{1,1982},{2,39640},{3,991},{4,991}]'),(985,'[{1,1984},{2,39680},{3,992},{4,992}]'),(986,'[{1,1986},{2,39720},{3,993},{4,993}]'),(987,'[{1,1988},{2,39760},{3,994},{4,994}]'),(988,'[{1,1990},{2,39800},{3,995},{4,995}]'),(989,'[{1,1992},{2,39840},{3,996},{4,996}]'),(990,'[{1,1994},{2,39880},{3,997},{4,997}]'),(991,'[{1,1996},{2,39920},{3,998},{4,998}]'),(992,'[{1,1998},{2,39960},{3,999},{4,999}]'),(993,'[{1,2000},{2,40000},{3,1000},{4,1000}]'),(994,'[{1,2002},{2,40040},{3,1001},{4,1001}]'),(995,'[{1,2004},{2,40080},{3,1002},{4,1002}]'),(996,'[{1,2006},{2,40120},{3,1003},{4,1003}]'),(997,'[{1,2008},{2,40160},{3,1004},{4,1004}]'),(998,'[{1,2010},{2,40200},{3,1005},{4,1005}]'),(999,'[{1,2012},{2,40240},{3,1006},{4,1006}]'),(1000,'[{1,2014},{2,40280},{3,1007},{4,1007}]');
/*!40000 ALTER TABLE `base_lv_power` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_marriage_constant`
--

DROP TABLE IF EXISTS `base_marriage_constant`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_marriage_constant` (
  `id` int(10) unsigned NOT NULL COMMENT '序号',
  `constant` varchar(500) NOT NULL COMMENT '内容',
  `annotation` varchar(500) NOT NULL COMMENT '注释',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='婚姻-常量配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_marriage_constant`
--

LOCK TABLES `base_marriage_constant` WRITE;
/*!40000 ALTER TABLE `base_marriage_constant` DISABLE KEYS */;
INSERT INTO `base_marriage_constant` VALUES (1,'180','婚姻开放等级'),(2,'24*60*60','征友大厅发布持续时间'),(3,'[{3, 0, 50000}]','征友大厅普通消耗'),(4,'[{2, 36020001, 20}]','征友大厅置顶消耗'),(5,'60*60','求关注CD'),(6,'60*60','求鲜花CD'),(7,'[{40010011, 25}, {40010012, 150}]','戒指祝福物品与增加祝福值'),(8,'99','表白需要的好友度'),(9,'12*60*60','表白求婚超时(s)'),(10,'[{3,36030001, 200000}]','分手消耗'),(11,'[{2, 36020001, 200}]','离婚消耗'),(12,'5','婚礼预约天数限制(1为今天）'),(13,'1004','婚礼场景id'),(14,'15','购买婚礼宾客上限绑钻消耗'),(15,'{1,5151002}','婚礼普通喜糖id'),(16,'{2,5151003}','婚礼豪华喜糖id'),(17,'{5151001, {2000, 2000}}','婚礼捣蛋鬼采集怪物id与坐标'),(18,'10','婚礼捣蛋鬼怪物数量'),(19,'10','婚礼捣蛋鬼刷新时间'),(20,'1','低级桌子怪物类型'),(21,'2','中级桌子怪物类型'),(22,'3','高级桌子怪物类型'),(23,'180','婚礼开始后多久刷出捣蛋鬼的时间'),(24,'3','刷出捣蛋鬼的波数'),(25,'213','结婚需要的好友度'),(26,'[{40030001, 10}, {40030002, 100}]','宝宝学识祝福物品与增加祝福值'),(27,'100','玩家索要婚礼请柬的等级'),(28,'ui_hunliyanhua02','婚礼普通烟花特效'),(29,'ui_hunliyanhua01','婚礼豪华烟花特效'),(30,'30','自动增加气氛值时间间隔（秒）'),(31,'2','自动增加气氛值每个玩家所加的值'),(32,'5','捣蛋鬼安抚上限'),(33,'[{0,40050001,1}]','求婚消耗ID'),(34,'[{14846,15821}]','婚礼区域新人出生点（切场景过去）'),(35,'[51540001,51540002]','婚礼入口守卫ID'),(36,'[{12366,12629},{11734,13109}]','婚礼NPC的位置坐标'),(37,'{15489,17247}','婚礼区域中心点'),(38,'5290','婚礼区域半径'),(39,'[{\"这对新人可真带劲儿\"}]','婚礼默认弹幕'),(40,'20','婚礼活跃阶段题目刷新间隔（秒）'),(41,'30','婚礼宴席刷新间隔（秒）'),(42,'2','普通餐桌每轮采集上限'),(43,'3','新人餐桌每轮采集上限'),(44,'1','普通餐桌每桌采集上限'),(45,'1','新人餐桌每桌采集上限'),(46,'75','征友大厅开启等级');
/*!40000 ALTER TABLE `base_marriage_constant` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_marriage_guidance`
--

DROP TABLE IF EXISTS `base_marriage_guidance`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_marriage_guidance` (
  `id` tinyint(1) unsigned NOT NULL COMMENT '引导id',
  `condition` varchar(255) NOT NULL COMMENT '完成条件',
  `con_desc` varchar(512) NOT NULL COMMENT '条件描述@lang@',
  `reward` varchar(512) NOT NULL COMMENT '奖励',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_marriage_guidance`
--

LOCK TABLES `base_marriage_guidance` WRITE;
/*!40000 ALTER TABLE `base_marriage_guidance` DISABLE KEYS */;
INSERT INTO `base_marriage_guidance` VALUES (1,'[{add_friend}]','成功添加一名好友','[{0,38100001,1}]'),(2,'[{send_gift}]','成功赠送一个礼物','[{0,38100001,3}]'),(3,'[{be_lover}]','成功表白一名玩家','[{0,38100008,1}]'),(4,'[{be_couple}]','成功求婚一名玩家','[{0,38100008,2}]'),(5,'[{marriage_activity}]','成功举办一场婚礼or巡游','[{0,38100012,2}]');
/*!40000 ALTER TABLE `base_marriage_guidance` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_marriage_guidance_lv`
--

DROP TABLE IF EXISTS `base_marriage_guidance_lv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_marriage_guidance_lv` (
  `id` tinyint(1) unsigned NOT NULL COMMENT '编号',
  `lv` smallint(5) unsigned NOT NULL COMMENT '目标等级',
  `reward` varchar(512) NOT NULL COMMENT '目标奖励',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_marriage_guidance_lv`
--

LOCK TABLES `base_marriage_guidance_lv` WRITE;
/*!40000 ALTER TABLE `base_marriage_guidance_lv` DISABLE KEYS */;
INSERT INTO `base_marriage_guidance_lv` VALUES (1,80,'[{0,38100001,1}]'),(2,100,'[{0,38100001,2}]'),(3,140,'[{0,38100001,3}]'),(4,180,'[{0,38100008,1}]'),(5,200,'[{0,38100008,1}]');
/*!40000 ALTER TABLE `base_marriage_guidance_lv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_marriage_life_heart`
--

DROP TABLE IF EXISTS `base_marriage_life_heart`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_marriage_life_heart` (
  `stage` int(10) unsigned NOT NULL COMMENT '阶数',
  `heart` int(10) unsigned NOT NULL COMMENT '心数',
  `upgrade_love_num` int(10) unsigned NOT NULL COMMENT '升心所需祝福值',
  `attr_list` varchar(255) NOT NULL COMMENT '属性列表',
  `combat` int(10) unsigned NOT NULL COMMENT '战力',
  `other_attr_list` varchar(255) NOT NULL COMMENT '夫妻共享属性加成',
  PRIMARY KEY (`stage`,`heart`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='婚姻-一生一世心数属性配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_marriage_life_heart`
--

LOCK TABLES `base_marriage_life_heart` WRITE;
/*!40000 ALTER TABLE `base_marriage_life_heart` DISABLE KEYS */;
INSERT INTO `base_marriage_life_heart` VALUES (1,0,30,'[{2,215},{1,11},{5,3},{6,3}]',0,'[{2,86},{1,4},{5,1},{6,1}]'),(1,1,60,'[{2,451},{1,23},{5,6},{6,6}]',0,'[{2,180},{1,9},{5,2},{6,2}]'),(1,2,90,'[{2,709},{1,36},{5,9},{6,9}]',0,'[{2,283},{1,14},{5,3},{6,3}]'),(1,3,120,'[{2,988},{1,50},{5,12},{6,12}]',0,'[{2,395},{1,20},{5,4},{6,4}]'),(1,4,150,'[{2,1289},{1,65},{5,16},{6,16}]',0,'[{2,515},{1,26},{5,6},{6,6}]'),(1,5,180,'[{2,1611},{1,81},{5,20},{6,20}]',0,'[{2,644},{1,32},{5,8},{6,8}]'),(1,6,210,'[{2,1955},{1,98},{5,24},{6,24}]',0,'[{2,782},{1,39},{5,9},{6,9}]'),(1,7,240,'[{2,2320},{1,116},{5,29},{6,29}]',0,'[{2,928},{1,46},{5,11},{6,11}]'),(1,8,270,'[{2,2707},{1,135},{5,34},{6,34}]',0,'[{2,1082},{1,54},{5,13},{6,13}]'),(1,9,300,'[{2,3115},{1,155},{5,39},{6,39}]',0,'[{2,1246},{1,62},{5,15},{6,15}]'),(2,0,330,'[{2,3558},{1,177},{5,45},{6,45}]',0,'[{2,1423},{1,70},{5,18},{6,18}]'),(2,1,360,'[{2,4035},{1,201},{5,51},{6,51}]',0,'[{2,1614},{1,80},{5,20},{6,20}]'),(2,2,390,'[{2,4547},{1,227},{5,57},{6,57}]',0,'[{2,1818},{1,90},{5,22},{6,22}]'),(2,3,420,'[{2,5093},{1,254},{5,64},{6,64}]',0,'[{2,2037},{1,101},{5,25},{6,25}]'),(2,4,450,'[{2,5673},{1,283},{5,71},{6,71}]',0,'[{2,2269},{1,113},{5,28},{6,28}]'),(2,5,480,'[{2,6288},{1,314},{5,79},{6,79}]',0,'[{2,2515},{1,125},{5,31},{6,31}]'),(2,6,510,'[{2,6937},{1,346},{5,87},{6,87}]',0,'[{2,2774},{1,138},{5,34},{6,34}]'),(2,7,540,'[{2,7621},{1,380},{5,96},{6,96}]',0,'[{2,3048},{1,152},{5,38},{6,38}]'),(2,8,570,'[{2,8339},{1,416},{5,105},{6,105}]',0,'[{2,3335},{1,166},{5,42},{6,42}]'),(2,9,600,'[{2,9104},{1,454},{5,115},{6,115}]',0,'[{2,3641},{1,181},{5,46},{6,46}]'),(3,0,630,'[{2,9917},{1,495},{5,125},{6,125}]',0,'[{2,3966},{1,198},{5,50},{6,50}]'),(3,1,660,'[{2,10777},{1,538},{5,136},{6,136}]',0,'[{2,4310},{1,215},{5,54},{6,54}]'),(3,2,690,'[{2,11684},{1,583},{5,147},{6,147}]',0,'[{2,4673},{1,233},{5,58},{6,58}]'),(3,3,720,'[{2,12639},{1,631},{5,159},{6,159}]',0,'[{2,5055},{1,252},{5,63},{6,63}]'),(3,4,750,'[{2,13641},{1,681},{5,172},{6,172}]',0,'[{2,5456},{1,272},{5,68},{6,68}]'),(3,5,780,'[{2,14690},{1,733},{5,185},{6,185}]',0,'[{2,5876},{1,293},{5,74},{6,74}]'),(3,6,810,'[{2,15786},{1,788},{5,199},{6,199}]',0,'[{2,6314},{1,315},{5,79},{6,79}]'),(3,7,840,'[{2,16930},{1,845},{5,213},{6,213}]',0,'[{2,6772},{1,338},{5,85},{6,85}]'),(3,8,870,'[{2,18134},{1,905},{5,228},{6,228}]',0,'[{2,7253},{1,362},{5,91},{6,91}]'),(3,9,900,'[{2,19398},{1,968},{5,244},{6,244}]',0,'[{2,7759},{1,387},{5,97},{6,97}]'),(4,0,930,'[{2,20722},{1,1034},{5,261},{6,261}]',0,'[{2,8288},{1,413},{5,104},{6,104}]'),(4,1,960,'[{2,22106},{1,1103},{5,278},{6,278}]',0,'[{2,8842},{1,441},{5,111},{6,111}]'),(4,2,990,'[{2,23551},{1,1175},{5,296},{6,296}]',0,'[{2,9420},{1,470},{5,118},{6,118}]'),(4,3,1020,'[{2,25056},{1,1250},{5,315},{6,315}]',0,'[{2,10022},{1,500},{5,126},{6,126}]'),(4,4,1050,'[{2,26621},{1,1328},{5,335},{6,335}]',0,'[{2,10648},{1,531},{5,134},{6,134}]'),(4,5,1080,'[{2,28246},{1,1409},{5,355},{6,355}]',0,'[{2,11298},{1,563},{5,142},{6,142}]'),(4,6,1110,'[{2,29931},{1,1493},{5,376},{6,376}]',0,'[{2,11972},{1,597},{5,150},{6,150}]'),(4,7,1140,'[{2,31690},{1,1581},{5,398},{6,398}]',0,'[{2,12676},{1,632},{5,159},{6,159}]'),(4,8,1170,'[{2,33522},{1,1673},{5,421},{6,421}]',0,'[{2,13408},{1,669},{5,168},{6,168}]'),(4,9,1200,'[{2,35427},{1,1768},{5,445},{6,445}]',0,'[{2,14170},{1,707},{5,178},{6,178}]'),(5,0,1230,'[{2,37405},{1,1867},{5,470},{6,470}]',0,'[{2,14962},{1,746},{5,188},{6,188}]'),(5,1,1260,'[{2,39456},{1,1970},{5,496},{6,496}]',0,'[{2,15782},{1,788},{5,198},{6,198}]'),(5,2,1290,'[{2,41580},{1,2076},{5,523},{6,523}]',0,'[{2,16632},{1,830},{5,209},{6,209}]'),(5,3,1320,'[{2,43777},{1,2186},{5,550},{6,550}]',0,'[{2,17510},{1,874},{5,220},{6,220}]'),(5,4,1350,'[{2,46047},{1,2300},{5,578},{6,578}]',0,'[{2,18418},{1,920},{5,231},{6,231}]'),(5,5,1380,'[{2,48390},{1,2417},{5,607},{6,607}]',0,'[{2,19356},{1,966},{5,242},{6,242}]'),(5,6,1410,'[{2,50819},{1,2538},{5,637},{6,637}]',0,'[{2,20327},{1,1015},{5,254},{6,254}]'),(5,7,1440,'[{2,53334},{1,2664},{5,668},{6,668}]',0,'[{2,21333},{1,1065},{5,267},{6,267}]'),(5,8,1470,'[{2,55935},{1,2794},{5,701},{6,701}]',0,'[{2,22374},{1,1117},{5,280},{6,280}]'),(5,9,1500,'[{2,58622},{1,2928},{5,735},{6,735}]',0,'[{2,23448},{1,1171},{5,294},{6,294}]'),(6,0,1530,'[{2,61395},{1,3067},{5,770},{6,770}]',0,'[{2,24558},{1,1226},{5,308},{6,308}]'),(6,1,1560,'[{2,64254},{1,3210},{5,806},{6,806}]',0,'[{2,25701},{1,1284},{5,322},{6,322}]'),(6,2,1590,'[{2,67199},{1,3357},{5,843},{6,843}]',0,'[{2,26879},{1,1342},{5,337},{6,337}]'),(6,3,1620,'[{2,70230},{1,3509},{5,881},{6,881}]',0,'[{2,28092},{1,1403},{5,352},{6,352}]'),(6,4,1650,'[{2,73347},{1,3665},{5,920},{6,920}]',0,'[{2,29338},{1,1466},{5,368},{6,368}]'),(6,5,1680,'[{2,76563},{1,3826},{5,960},{6,960}]',0,'[{2,30625},{1,1530},{5,384},{6,384}]'),(6,6,1710,'[{2,79878},{1,3992},{5,1001},{6,1001}]',0,'[{2,31951},{1,1596},{5,400},{6,400}]'),(6,7,1740,'[{2,83292},{1,4163},{5,1044},{6,1044}]',0,'[{2,33316},{1,1665},{5,417},{6,417}]'),(6,8,1770,'[{2,86805},{1,4339},{5,1088},{6,1088}]',0,'[{2,34722},{1,1735},{5,435},{6,435}]'),(6,9,1800,'[{2,90417},{1,4520},{5,1133},{6,1133}]',0,'[{2,36166},{1,1808},{5,453},{6,453}]'),(7,0,1830,'[{2,94128},{1,4706},{5,1179},{6,1179}]',0,'[{2,37651},{1,1882},{5,471},{6,471}]'),(7,1,1860,'[{2,97938},{1,4896},{5,1227},{6,1227}]',0,'[{2,39175},{1,1958},{5,490},{6,490}]'),(7,2,1890,'[{2,101846},{1,5091},{5,1276},{6,1276}]',0,'[{2,40738},{1,2036},{5,510},{6,510}]'),(7,3,1920,'[{2,105853},{1,5291},{5,1326},{6,1326}]',0,'[{2,42341},{1,2116},{5,530},{6,530}]'),(7,4,1950,'[{2,109972},{1,5497},{5,1377},{6,1377}]',0,'[{2,43988},{1,2198},{5,550},{6,550}]'),(7,5,1980,'[{2,114203},{1,5709},{5,1430},{6,1430}]',0,'[{2,45681},{1,2283},{5,572},{6,572}]'),(7,6,2010,'[{2,118546},{1,5926},{5,1484},{6,1484}]',0,'[{2,47418},{1,2370},{5,593},{6,593}]'),(7,7,2040,'[{2,123000},{1,6149},{5,1540},{6,1540}]',0,'[{2,49200},{1,2459},{5,616},{6,616}]'),(7,8,2070,'[{2,127566},{1,6377},{5,1597},{6,1597}]',0,'[{2,51026},{1,2550},{5,638},{6,638}]'),(7,9,2100,'[{2,132244},{1,6611},{5,1655},{6,1655}]',0,'[{2,52897},{1,2644},{5,662},{6,662}]'),(8,0,2130,'[{2,137034},{1,6850},{5,1715},{6,1715}]',0,'[{2,54813},{1,2740},{5,686},{6,686}]'),(8,1,2160,'[{2,141936},{1,7095},{5,1776},{6,1776}]',0,'[{2,56774},{1,2838},{5,710},{6,710}]'),(8,2,2190,'[{2,146949},{1,7346},{5,1839},{6,1839}]',0,'[{2,58779},{1,2938},{5,735},{6,735}]'),(8,3,2220,'[{2,152087},{1,7603},{5,1903},{6,1903}]',0,'[{2,60834},{1,3041},{5,761},{6,761}]'),(8,4,2250,'[{2,157350},{1,7866},{5,1969},{6,1969}]',0,'[{2,62940},{1,3146},{5,787},{6,787}]'),(8,5,2280,'[{2,162738},{1,8135},{5,2036},{6,2036}]',0,'[{2,65095},{1,3254},{5,814},{6,814}]'),(8,6,2310,'[{2,168250},{1,8411},{5,2105},{6,2105}]',0,'[{2,67300},{1,3364},{5,842},{6,842}]'),(8,7,2340,'[{2,173887},{1,8693},{5,2175},{6,2175}]',0,'[{2,69554},{1,3477},{5,870},{6,870}]'),(8,8,2370,'[{2,179649},{1,8981},{5,2247},{6,2247}]',0,'[{2,71859},{1,3592},{5,898},{6,898}]'),(8,9,2410,'[{2,185535},{1,9275},{5,2321},{6,2321}]',0,'[{2,74214},{1,3710},{5,928},{6,928}]'),(9,0,2450,'[{2,191546},{1,9576},{5,2396},{6,2396}]',0,'[{2,76618},{1,3830},{5,958},{6,958}]'),(9,1,2490,'[{2,197682},{1,9883},{5,2473},{6,2473}]',0,'[{2,79072},{1,3953},{5,989},{6,989}]'),(9,2,2530,'[{2,203955},{1,10197},{5,2551},{6,2551}]',0,'[{2,81582},{1,4078},{5,1020},{6,1020}]'),(9,3,2570,'[{2,210366},{1,10518},{5,2631},{6,2631}]',0,'[{2,84146},{1,4207},{5,1052},{6,1052}]'),(9,4,2610,'[{2,216914},{1,10845},{5,2713},{6,2713}]',0,'[{2,86765},{1,4338},{5,1085},{6,1085}]'),(9,5,2650,'[{2,223600},{1,11179},{5,2797},{6,2797}]',0,'[{2,89440},{1,4471},{5,1118},{6,1118}]'),(9,6,2690,'[{2,230424},{1,11520},{5,2882},{6,2882}]',0,'[{2,92169},{1,4608},{5,1152},{6,1152}]'),(9,7,2730,'[{2,237385},{1,11868},{5,2969},{6,2969}]',0,'[{2,94954},{1,4747},{5,1187},{6,1187}]'),(9,8,2770,'[{2,244484},{1,12223},{5,3058},{6,3058}]',0,'[{2,97793},{1,4889},{5,1223},{6,1223}]'),(9,9,2810,'[{2,251720},{1,12585},{5,3148},{6,3148}]',0,'[{2,100688},{1,5034},{5,1259},{6,1259}]'),(10,0,2850,'[{2,259094},{1,12954},{5,3240},{6,3240}]',0,'[{2,103637},{1,5181},{5,1296},{6,1296}]'),(10,1,2890,'[{2,266618},{1,13330},{5,3334},{6,3334}]',0,'[{2,106647},{1,5332},{5,1333},{6,1333}]'),(10,2,2930,'[{2,274293},{1,13714},{5,3430},{6,3430}]',0,'[{2,109717},{1,5485},{5,1372},{6,1372}]'),(10,3,2970,'[{2,282118},{1,14105},{5,3528},{6,3528}]',0,'[{2,112847},{1,5642},{5,1411},{6,1411}]'),(10,4,3010,'[{2,290094},{1,14504},{5,3628},{6,3628}]',0,'[{2,116037},{1,5801},{5,1451},{6,1451}]'),(10,5,3050,'[{2,298220},{1,14910},{5,3730},{6,3730}]',0,'[{2,119288},{1,5964},{5,1492},{6,1492}]'),(10,6,3090,'[{2,306497},{1,15324},{5,3833},{6,3833}]',0,'[{2,122598},{1,6129},{5,1533},{6,1533}]'),(10,7,3130,'[{2,314924},{1,15745},{5,3938},{6,3938}]',0,'[{2,125969},{1,6298},{5,1575},{6,1575}]'),(10,8,3170,'[{2,323502},{1,16174},{5,4045},{6,4045}]',0,'[{2,129400},{1,6469},{5,1618},{6,1618}]'),(10,9,3210,'[{2,332230},{1,16610},{5,4154},{6,4154}]',0,'[{2,132892},{1,6644},{5,1661},{6,1661}]'),(11,0,3250,'[{2,341122},{1,17055},{5,4265},{6,4265}]',0,'[{2,136448},{1,6822},{5,1706},{6,1706}]'),(11,1,3290,'[{2,350177},{1,17508},{5,4378},{6,4378}]',0,'[{2,140070},{1,7003},{5,1751},{6,1751}]'),(11,2,3330,'[{2,359396},{1,17969},{5,4493},{6,4493}]',0,'[{2,143758},{1,7187},{5,1797},{6,1797}]'),(11,3,3370,'[{2,368778},{1,18438},{5,4610},{6,4610}]',0,'[{2,147511},{1,7375},{5,1844},{6,1844}]'),(11,4,3410,'[{2,378323},{1,18915},{5,4729},{6,4729}]',0,'[{2,151329},{1,7566},{5,1891},{6,1891}]'),(11,5,3450,'[{2,388032},{1,19400},{5,4850},{6,4850}]',0,'[{2,155212},{1,7760},{5,1940},{6,1940}]'),(11,6,3490,'[{2,397904},{1,19894},{5,4973},{6,4973}]',0,'[{2,159161},{1,7957},{5,1989},{6,1989}]'),(11,7,3530,'[{2,407939},{1,20396},{5,5098},{6,5098}]',0,'[{2,163175},{1,8158},{5,2039},{6,2039}]'),(11,8,3570,'[{2,418138},{1,20906},{5,5225},{6,5225}]',0,'[{2,167255},{1,8362},{5,2090},{6,2090}]'),(11,9,3620,'[{2,428513},{1,21425},{5,5355},{6,5355}]',0,'[{2,171405},{1,8570},{5,2142},{6,2142}]'),(12,0,3670,'[{2,439064},{1,21953},{5,5487},{6,5487}]',0,'[{2,175625},{1,8781},{5,2194},{6,2194}]'),(12,1,3720,'[{2,449792},{1,22489},{5,5621},{6,5621}]',0,'[{2,179916},{1,8995},{5,2248},{6,2248}]'),(12,2,3770,'[{2,460696},{1,23034},{5,5757},{6,5757}]',0,'[{2,184278},{1,9213},{5,2302},{6,2302}]'),(12,3,3820,'[{2,471776},{1,23588},{5,5896},{6,5896}]',0,'[{2,188710},{1,9435},{5,2358},{6,2358}]'),(12,4,3870,'[{2,483033},{1,24151},{5,6037},{6,6037}]',0,'[{2,193213},{1,9660},{5,2414},{6,2414}]'),(12,5,3920,'[{2,494466},{1,24723},{5,6180},{6,6180}]',0,'[{2,197786},{1,9889},{5,2472},{6,2472}]'),(12,6,3970,'[{2,506075},{1,25303},{5,6325},{6,6325}]',0,'[{2,202430},{1,10121},{5,2530},{6,2530}]'),(12,7,4020,'[{2,517860},{1,25892},{5,6472},{6,6472}]',0,'[{2,207144},{1,10356},{5,2588},{6,2588}]'),(12,8,4070,'[{2,529835},{1,26491},{5,6622},{6,6622}]',0,'[{2,211934},{1,10596},{5,2648},{6,2648}]'),(12,9,4120,'[{2,541999},{1,27099},{5,6774},{6,6774}]',0,'[{2,216799},{1,10839},{5,2709},{6,2709}]'),(13,0,4170,'[{2,554352},{1,27717},{5,6928},{6,6928}]',0,'[{2,221740},{1,11086},{5,2771},{6,2771}]'),(13,1,4220,'[{2,566894},{1,28344},{5,7085},{6,7085}]',0,'[{2,226757},{1,11337},{5,2834},{6,2834}]'),(13,2,4270,'[{2,579625},{1,28981},{5,7244},{6,7244}]',0,'[{2,231850},{1,11592},{5,2897},{6,2897}]'),(13,3,4320,'[{2,592546},{1,29627},{5,7406},{6,7406}]',0,'[{2,237018},{1,11850},{5,2962},{6,2962}]'),(13,4,4370,'[{2,605656},{1,30282},{5,7570},{6,7570}]',0,'[{2,242262},{1,12112},{5,3028},{6,3028}]'),(13,5,4420,'[{2,618955},{1,30947},{5,7736},{6,7736}]',0,'[{2,247582},{1,12378},{5,3094},{6,3094}]'),(13,6,4470,'[{2,632443},{1,31621},{5,7905},{6,7905}]',0,'[{2,252977},{1,12648},{5,3162},{6,3162}]'),(13,7,4520,'[{2,646133},{1,32306},{5,8076},{6,8076}]',0,'[{2,258453},{1,12922},{5,3230},{6,3230}]'),(13,8,4570,'[{2,660025},{1,33001},{5,8250},{6,8250}]',0,'[{2,264010},{1,13200},{5,3300},{6,3300}]'),(13,9,4620,'[{2,674119},{1,33706},{5,8426},{6,8426}]',0,'[{2,269647},{1,13482},{5,3370},{6,3370}]'),(14,0,4670,'[{2,688415},{1,34421},{5,8605},{6,8605}]',0,'[{2,275366},{1,13768},{5,3442},{6,3442}]'),(14,1,4720,'[{2,702914},{1,35146},{5,8786},{6,8786}]',0,'[{2,281165},{1,14058},{5,3514},{6,3514}]'),(14,2,4770,'[{2,717615},{1,35881},{5,8970},{6,8970}]',0,'[{2,287046},{1,14352},{5,3588},{6,3588}]'),(14,3,4820,'[{2,732518},{1,36626},{5,9156},{6,9156}]',0,'[{2,293007},{1,14650},{5,3662},{6,3662}]'),(14,4,4870,'[{2,747623},{1,37381},{5,9345},{6,9345}]',0,'[{2,299049},{1,14952},{5,3738},{6,3738}]'),(14,5,4920,'[{2,762930},{1,38146},{5,9536},{6,9536}]',0,'[{2,305172},{1,15258},{5,3814},{6,3814}]'),(14,6,4970,'[{2,778452},{1,38922},{5,9730},{6,9730}]',0,'[{2,311380},{1,15568},{5,3892},{6,3892}]'),(14,7,5020,'[{2,794189},{1,39709},{5,9927},{6,9927}]',0,'[{2,317675},{1,15883},{5,3970},{6,3970}]'),(14,8,5070,'[{2,810141},{1,40507},{5,10126},{6,10126}]',0,'[{2,324056},{1,16202},{5,4050},{6,4050}]'),(14,9,5130,'[{2,826308},{1,41315},{5,10328},{6,10328}]',0,'[{2,330523},{1,16526},{5,4131},{6,4131}]'),(15,0,5190,'[{2,842690},{1,42134},{5,10533},{6,10533}]',0,'[{2,337076},{1,16853},{5,4213},{6,4213}]'),(15,1,5250,'[{2,859287},{1,42964},{5,10740},{6,10740}]',0,'[{2,343714},{1,17185},{5,4296},{6,4296}]'),(15,2,5310,'[{2,876099},{1,43805},{5,10950},{6,10950}]',0,'[{2,350439},{1,17522},{5,4380},{6,4380}]'),(15,3,5370,'[{2,893126},{1,44656},{5,11163},{6,11163}]',0,'[{2,357250},{1,17862},{5,4465},{6,4465}]'),(15,4,5430,'[{2,910368},{1,45518},{5,11379},{6,11379}]',0,'[{2,364147},{1,18207},{5,4551},{6,4551}]'),(15,5,5490,'[{2,927838},{1,46391},{5,11597},{6,11597}]',0,'[{2,371135},{1,18556},{5,4638},{6,4638}]'),(15,6,5550,'[{2,945536},{1,47276},{5,11818},{6,11818}]',0,'[{2,378214},{1,18910},{5,4727},{6,4727}]'),(15,7,5610,'[{2,963461},{1,48172},{5,12042},{6,12042}]',0,'[{2,385384},{1,19268},{5,4816},{6,4816}]'),(15,8,5670,'[{2,981614},{1,49080},{5,12269},{6,12269}]',0,'[{2,392645},{1,19632},{5,4907},{6,4907}]'),(15,9,5731,'[{2,999995},{1,49999},{5,12499},{6,12499}]',0,'[{2,399998},{1,19999},{5,4999},{6,4999}]'),(15,10,0,'[{2,1018591},{1,50929},{5,12731},{6,12731}]',0,'[{2,407436},{1,20371},{5,5092},{6,5092}]');
/*!40000 ALTER TABLE `base_marriage_life_heart` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_marriage_life_skill`
--

DROP TABLE IF EXISTS `base_marriage_life_skill`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_marriage_life_skill` (
  `id` int(10) unsigned NOT NULL COMMENT '编号',
  `skill_id` int(64) unsigned NOT NULL COMMENT '技能ID',
  `activate_stage` int(10) unsigned NOT NULL COMMENT '激活阶数',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='同心结技能配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_marriage_life_skill`
--

LOCK TABLES `base_marriage_life_skill` WRITE;
/*!40000 ALTER TABLE `base_marriage_life_skill` DISABLE KEYS */;
INSERT INTO `base_marriage_life_skill` VALUES (1,21005155,4),(2,21005156,8),(3,21005157,12),(4,21005158,15);
/*!40000 ALTER TABLE `base_marriage_life_skill` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_marriage_life_stage`
--

DROP TABLE IF EXISTS `base_marriage_life_stage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_marriage_life_stage` (
  `stage` int(10) unsigned NOT NULL COMMENT '阶数',
  `name` varchar(255) NOT NULL COMMENT '名字@lang@',
  `resource_id` int(10) unsigned NOT NULL COMMENT '形象id',
  PRIMARY KEY (`stage`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='婚姻-一生一世阶数配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_marriage_life_stage`
--

LOCK TABLES `base_marriage_life_stage` WRITE;
/*!40000 ALTER TABLE `base_marriage_life_stage` DISABLE KEYS */;
INSERT INTO `base_marriage_life_stage` VALUES (1,'执子之手',0),(2,'永结同心',0),(3,'与子偕老',0),(4,'执子之手',0),(5,'永结同心',0),(6,'与子偕老',0),(7,'执子之手',0),(8,'永结同心',0),(9,'与子偕老',0),(10,'执子之手',0),(11,'执子之手',0),(12,'永结同心',0),(13,'与子偕老',0),(14,'执子之手',0),(15,'永结同心',0);
/*!40000 ALTER TABLE `base_marriage_life_stage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_marriage_love_box`
--

DROP TABLE IF EXISTS `base_marriage_love_box`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_marriage_love_box` (
  `id` int(10) unsigned NOT NULL COMMENT '编号',
  `cost` varchar(215) NOT NULL COMMENT '购买消耗',
  `buy_reward` varchar(512) NOT NULL COMMENT '立得奖励',
  `day_reward` varchar(512) NOT NULL COMMENT '日常奖励',
  `time` int(10) unsigned NOT NULL COMMENT '期限（s）',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='爱情宝盒配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_marriage_love_box`
--

LOCK TABLES `base_marriage_love_box` WRITE;
/*!40000 ALTER TABLE `base_marriage_love_box` DISABLE KEYS */;
INSERT INTO `base_marriage_love_box` VALUES (1,'[{1,0,520}]','[{2,0,520}]','[{0,36020001,99},{255,40040001,88},{0,40010011,5}]',2592000);
/*!40000 ALTER TABLE `base_marriage_love_box` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_marriage_ring_skill`
--

DROP TABLE IF EXISTS `base_marriage_ring_skill`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_marriage_ring_skill` (
  `id` int(10) unsigned NOT NULL COMMENT '编号',
  `skill_id` int(64) unsigned NOT NULL COMMENT '技能ID',
  `activate_stage` int(10) unsigned NOT NULL COMMENT '激活阶数',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='婚戒技能配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_marriage_ring_skill`
--

LOCK TABLES `base_marriage_ring_skill` WRITE;
/*!40000 ALTER TABLE `base_marriage_ring_skill` DISABLE KEYS */;
INSERT INTO `base_marriage_ring_skill` VALUES (1,21005151,4),(2,21005152,8),(3,21005153,12),(4,21005154,15);
/*!40000 ALTER TABLE `base_marriage_ring_skill` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_marriage_show_love`
--

DROP TABLE IF EXISTS `base_marriage_show_love`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_marriage_show_love` (
  `id` int(10) unsigned NOT NULL COMMENT '序号',
  `name` varchar(500) NOT NULL COMMENT '类型名字@lang@',
  `cost_list` varchar(500) NOT NULL COMMENT '消耗列表',
  `add_intimacy` int(10) unsigned NOT NULL COMMENT '亲密度',
  `self_goods_list` varchar(500) NOT NULL COMMENT '自己道具列表',
  `lover_goods_list` varchar(500) NOT NULL COMMENT '伴侣道具列表',
  `dog_food` varchar(500) NOT NULL COMMENT '狗粮奖励',
  `dog_food_num` int(10) unsigned NOT NULL COMMENT '狗粮份数',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='婚姻-秀恩爱数据配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_marriage_show_love`
--

LOCK TABLES `base_marriage_show_love` WRITE;
/*!40000 ALTER TABLE `base_marriage_show_love` DISABLE KEYS */;
INSERT INTO `base_marriage_show_love` VALUES (1,'浓情巧克力','[{2,0,30}]',0,'[{255,40040001,50}]','[{0,32050004,1}]','[{0,38100001,[1,3]}]',4),(2,'暖心围脖','[{2,0,120}]',0,'[{255,40040001,210}]','[{0,32050005,1}]','[{0,38100001,[3,5]}]',6),(3,'蜜意香水','[{2,0,268}]',0,'[{255,40040001,450}]','[{0,32050006,1}]','[{0,38100001,[5,8]}]',8);
/*!40000 ALTER TABLE `base_marriage_show_love` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_melee_pk_area_coords`
--

DROP TABLE IF EXISTS `base_melee_pk_area_coords`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_melee_pk_area_coords` (
  `scene_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '场景Id',
  `area_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '区域Id',
  `left_buttom_coord` varchar(50) NOT NULL COMMENT '左下角像素坐标',
  `right_upper_coord` varchar(50) NOT NULL COMMENT '右上角像素坐标',
  `res_id` varchar(50) NOT NULL COMMENT '区域资源id',
  PRIMARY KEY (`scene_id`,`area_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='大乱斗地图区域坐标';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_melee_pk_area_coords`
--

LOCK TABLES `base_melee_pk_area_coords` WRITE;
/*!40000 ALTER TABLE `base_melee_pk_area_coords` DISABLE KEYS */;
INSERT INTO `base_melee_pk_area_coords` VALUES (5802,1,'{8813,105}','{23250,8591}','5802_1'),(5802,2,'{13570,6566}','{24687,19742}','5802_2'),(5802,3,'{0,4351}','{13447,13725}','5802_3'),(5802,4,'{0,13464}','{17300,23094}','5802_4');
/*!40000 ALTER TABLE `base_melee_pk_area_coords` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_melee_pk_area_info`
--

DROP TABLE IF EXISTS `base_melee_pk_area_info`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_melee_pk_area_info` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '地图区域id',
  `about` varchar(512) NOT NULL COMMENT '区域描述',
  `open_score_min` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小开放积分',
  `open_score_max` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大开放积分',
  `kill_add_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '击杀玩家增加积分',
  `time_add_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '定时增加积分',
  `mon_grade_list` varchar(64) NOT NULL DEFAULT '[]' COMMENT '假人段位列表',
  `born_coord_list` varchar(512) NOT NULL COMMENT '玩家坐标列表',
  `coord_list` varchar(512) NOT NULL COMMENT '假人坐标列表',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='大乱斗地图区域信息';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_melee_pk_area_info`
--

LOCK TABLES `base_melee_pk_area_info` WRITE;
/*!40000 ALTER TABLE `base_melee_pk_area_info` DISABLE KEYS */;
INSERT INTO `base_melee_pk_area_info` VALUES (1,'最底层',0,499,15,4,'[1,2]','[{6586,14439},{12725,12111},{5839,23159},{16356,24212},{6702,14385},{11779,11366},{13560,11829},{6633,22702},{5521,23674},{4800,22400},{16526,23035},{15772,24829}]','[{10554,18202},{12405,20471},{10338,20192},{11657,17321},{11626,19153},{13029,18132},{11416,21244}]'),(2,'第二层',500,999,30,8,'[2,3]','[{23802,25304},{16873,16761},{23827,16982},{24089,24264},{22579,25460},{23238,16087},{24945,17146},{17731,16048},{16001,17067}]','[{22036,20602},{20303,20973},{18476,21573},{21217,22669},{21421,19136},{19490,19688}]'),(3,'第三层',1000,1599,45,12,'[4,5]','[{3710,9690},{4387,2396},{4687,10243},{4016,9202},{2743,9589},{4989,1667},{3136,2328},{3976,1323},{4272,2998}]','[{8867,8843},{9872,5517},{7820,6890},{8270,6243},{9788,6733},{10643,7345},{9592,8218},{8707,7969}]'),(4,'第四层',1600,999999,60,16,'[5,6]','[{15955,8193},{26348,6164},{15215,7950},{16332,7554},{25982,5882},{26926,5588},{14900,8088},{15500,7088},{27800,5000},{26900,4700}]','[{10653,9046},{20074,11071},{21725,12003},{22472,11264},{21782,9953},{20659,10054},{20899,11368}]');
/*!40000 ALTER TABLE `base_melee_pk_area_info` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_melee_pk_box_reward`
--

DROP TABLE IF EXISTS `base_melee_pk_box_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_melee_pk_box_reward` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励ID',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '宝箱类型',
  `mon_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '宝箱怪id',
  `gift_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '宝箱礼包id',
  `view_goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '显示宝箱id',
  `coord_list` varchar(512) NOT NULL COMMENT '坐标列表',
  PRIMARY KEY (`id`,`type`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='大乱斗宝箱奖励';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_melee_pk_box_reward`
--

LOCK TABLES `base_melee_pk_box_reward` WRITE;
/*!40000 ALTER TABLE `base_melee_pk_box_reward` DISABLE KEYS */;
INSERT INTO `base_melee_pk_box_reward` VALUES (1,1,5800005,32010013,5800005,'[{1,12427,21390},{1,11115,21434},{1,10574,20666},{1,9792,19824},{1,9889,18552},{1,10831,17483},{1,12463,17005},{1,13117,17804},{1,13816,18543},{1,13122,19545}]'),(1,2,5800009,32010012,5800006,'[{1,10841,19703},{1,12337,19829},{1,11113,18491},{1,12450,18636}]'),(1,3,5800013,32010051,32010057,'[{1,11656,19144}]'),(2,1,5800006,32010013,5800005,'[{2,21085,22763},{2,19683,22421},{2,18691,21901},{2,18541,20539},{2,19427,19395},{2,20118,18223},{2,21036,18908},{2,21964,19667},{2,22297,20552},{2,21947,21733}]'),(2,2,5800010,32010012,5800006,'[{2,19715,21434},{2,21313,21541},{2,19973,19980},{2,21308,20093}]'),(2,3,5800014,32010051,32010057,'[{2,20585,20781}]'),(3,1,5800007,32010013,5800005,'[{3,10539,9042},{3,9084,9277},{3,8316,8296},{3,8002,7411},{3,7974,6383},{3,9107,5924},{3,9884,5402},{3,10648,6270},{3,11544,8515},{3,11783,7543}]'),(3,2,5800011,32010012,5800006,'[{3,9195,7996},{3,10563,8065},{3,9265,6730},{3,10525,6752}]'),(3,3,5800015,32010051,32010057,'[{3,9883,7358}]'),(4,1,5800008,32010013,5800005,'[{4,22189,12466},{4,21240,12305},{4,20157,12541},{4,20074,11608},{4,19620,10790},{4,20449,10063},{4,21243,9226},{4,22249,9634},{4,22969,10586},{4,22709,11543}]'),(4,2,5800012,32010012,5800006,'[{4,21170,11625},{4,20869,10590},{4,21852,10416},{4,22147,11334}]'),(4,3,5800016,32010051,32010057,'[{4,21524,10947}]');
/*!40000 ALTER TABLE `base_melee_pk_box_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_melee_pk_fake_man`
--

DROP TABLE IF EXISTS `base_melee_pk_fake_man`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_melee_pk_fake_man` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '编号',
  `min_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小世界等级',
  `max_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大世界等级',
  `fake_man_ids` varchar(512) NOT NULL COMMENT '假人ID列表',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='大乱斗假人配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_melee_pk_fake_man`
--

LOCK TABLES `base_melee_pk_fake_man` WRITE;
/*!40000 ALTER TABLE `base_melee_pk_fake_man` DISABLE KEYS */;
INSERT INTO `base_melee_pk_fake_man` VALUES (1,140,160,'[]'),(2,161,180,'[]'),(3,181,200,'[]'),(4,201,220,'[]'),(5,221,240,'[]'),(6,241,260,'[]'),(7,261,280,'[]'),(8,281,300,'[]'),(9,301,310,'[]'),(10,311,320,'[]'),(11,321,330,'[]'),(12,331,340,'[]'),(13,341,350,'[]'),(14,351,360,'[]'),(15,361,370,'[]'),(16,371,380,'[]'),(17,381,390,'[]'),(18,391,400,'[]'),(19,401,410,'[]'),(20,411,420,'[]'),(21,421,430,'[]'),(22,431,440,'[]'),(23,441,450,'[]'),(24,451,460,'[]'),(25,461,470,'[]'),(26,471,480,'[]'),(27,481,490,'[]'),(28,491,500,'[]'),(29,501,510,'[]'),(30,511,520,'[]'),(31,521,530,'[]'),(32,531,540,'[]'),(33,541,550,'[]'),(34,551,560,'[]'),(35,561,570,'[]'),(36,571,580,'[]'),(37,581,590,'[]'),(38,591,600,'[]'),(39,601,610,'[]'),(40,611,620,'[]'),(41,621,630,'[]'),(42,631,640,'[]'),(43,641,650,'[]'),(44,651,660,'[]'),(45,661,670,'[]'),(46,671,680,'[]'),(47,681,690,'[]'),(48,691,700,'[]'),(49,701,710,'[]'),(50,711,720,'[]'),(51,721,730,'[]'),(52,731,740,'[]'),(53,741,750,'[]'),(54,751,760,'[]'),(55,761,770,'[]'),(56,771,780,'[]'),(57,781,790,'[]'),(58,791,800,'[]'),(59,801,810,'[]'),(60,811,820,'[]'),(61,821,830,'[]'),(62,831,840,'[]'),(63,841,850,'[]'),(64,851,860,'[]'),(65,861,870,'[]'),(66,871,880,'[]'),(67,881,890,'[]'),(68,891,900,'[]'),(69,901,910,'[]'),(70,911,920,'[]'),(71,921,930,'[]'),(72,931,940,'[]'),(73,941,950,'[]'),(74,951,960,'[]'),(75,961,970,'[]'),(76,971,980,'[]'),(77,981,990,'[]'),(78,991,1000,'[]');
/*!40000 ALTER TABLE `base_melee_pk_fake_man` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_melee_pk_grade_info`
--

DROP TABLE IF EXISTS `base_melee_pk_grade_info`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_melee_pk_grade_info` (
  `grade_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '段位',
  `min_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小积分',
  `max_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大积分',
  `name` varchar(128) NOT NULL COMMENT '段位名@lang@',
  PRIMARY KEY (`grade_num`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='大乱斗段位信息配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_melee_pk_grade_info`
--

LOCK TABLES `base_melee_pk_grade_info` WRITE;
/*!40000 ALTER TABLE `base_melee_pk_grade_info` DISABLE KEYS */;
INSERT INTO `base_melee_pk_grade_info` VALUES (1,0,250,'青铜'),(2,251,400,'白银'),(3,401,800,'黄金'),(4,801,1600,'白金'),(5,1601,2500,'钻石'),(6,2501,99999,'王者');
/*!40000 ALTER TABLE `base_melee_pk_grade_info` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_melee_pk_keyvalues`
--

DROP TABLE IF EXISTS `base_melee_pk_keyvalues`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_melee_pk_keyvalues` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '常量Id',
  `value` varchar(512) NOT NULL COMMENT '常量值',
  `about` varchar(512) NOT NULL COMMENT '常量描述@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='大乱斗常量配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_melee_pk_keyvalues`
--

LOCK TABLES `base_melee_pk_keyvalues` WRITE;
/*!40000 ALTER TABLE `base_melee_pk_keyvalues` DISABLE KEYS */;
INSERT INTO `base_melee_pk_keyvalues` VALUES (1,'10','开启跨服需要的开服天数'),(2,'310','开启跨服需要的世界等级'),(3,'140','功能开启等级'),(4,'5801','本服场景id'),(5,'5802','跨服场景id'),(6,'{10985,4166}','中心坐标{x,y}'),(7,'35','房间人数上限'),(8,'5','多久加一次积分(s)'),(9,'5','pk保护时间(s)(初始进入活动或者死亡复活赋与)'),(10,'10','排行榜最大长度'),(11,'[5800001,5800002,5800004]','假人怪id列表'),(12,'[{0,24010001,1},{0,24010002,1},{0,24010003,1}]','客户端奖励显示'),(13,'[{1,120},{2,120},{3,120},{4,120}]','宝箱波数刷出时间[{波数,房间开启后多久刷出(s)}]'),(14,'30','活动准备时间(s)'),(15,'[{5800005,2},{5800006,2},{5800007,2},{5800008,2},{5800009,2},{58000010,2},{58000011,2},{58000012,2},{5800013,1},{5800014,1},{5800015,1},{5800016,1}]','宝箱采集上限列表 格式: [{宝箱怪ID, 数量}]'),(16,'[{1,5,3},{6,10,5},{11,20,8},{21,30,8},{31,50,10}]','普通宝箱刷新数量 [{最少人数, 最多人数, 宝箱数量}]'),(17,'[{1,5,2},{6,10,2},{11,20,3},{21,30,4},{31,50,4}]','白银宝箱刷新数量 [{最少人数, 最多人数, 宝箱数量}]'),(18,'[{1,5,1},{6,10,1},{11,20,1},{21,30,1},{31,50,1}]','黄金宝箱刷新数量 [{最少人数, 最多人数, 宝箱数量}]'),(19,'10','连续死亡buff叠加层数上限'),(20,'21001003','连续死亡buff技能ID'),(21,'51630001','跳区域无敌buff技能ID'),(22,'7','处于开服前几天时假人使用固定等级'),(23,'200','假人固定等级');
/*!40000 ALTER TABLE `base_melee_pk_keyvalues` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_melee_pk_ranking_reward`
--

DROP TABLE IF EXISTS `base_melee_pk_ranking_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_melee_pk_ranking_reward` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励ID',
  `min_world_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小世界等级',
  `max_world_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大世界等级',
  `min_rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小排名',
  `max_rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大排名',
  `reward_list` varchar(512) NOT NULL COMMENT '奖励列表',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='大乱斗排名奖励配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_melee_pk_ranking_reward`
--

LOCK TABLES `base_melee_pk_ranking_reward` WRITE;
/*!40000 ALTER TABLE `base_melee_pk_ranking_reward` DISABLE KEYS */;
INSERT INTO `base_melee_pk_ranking_reward` VALUES (1,1,320,1,1,'[{0,4909002,1},{0,24010001,12}]'),(2,321,370,1,1,'[{0,4909002,1},{0,24010001,16}]'),(3,371,500,1,1,'[{0,4909002,1},{0,24010002,12}]'),(4,501,610,1,1,'[{0,4909002,1},{0,24010002,16}]'),(5,611,1000,1,1,'[{0,4909002,1},{0,24010003,10}]'),(6,1,320,2,3,'[{0,4909001,1},{0,24010001,10}]'),(7,321,370,2,3,'[{0,4909001,1},{0,24010001,12}]'),(8,371,500,2,3,'[{0,4909001,1},{0,24010002,10}]'),(9,501,610,2,3,'[{0,4909001,1},{0,24010002,12}]'),(10,611,1000,2,3,'[{0,4909001,1},{0,24010003,8}]'),(11,1,320,4,10,'[{0,4909003,1},{0,24010001,8}]'),(12,321,370,4,10,'[{0,4909003,1},{0,24010001,10}]'),(13,371,500,4,10,'[{0,4909003,1},{0,24010002,8}]'),(14,501,610,4,10,'[{0,4909003,1},{0,24010002,10}]'),(15,611,1000,4,10,'[{0,4909003,1},{0,24010003,6}]');
/*!40000 ALTER TABLE `base_melee_pk_ranking_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_melee_pk_score_ratio`
--

DROP TABLE IF EXISTS `base_melee_pk_score_ratio`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_melee_pk_score_ratio` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '编号',
  `min_mutil` varchar(64) NOT NULL COMMENT '最小差距段位',
  `max_mutil` varchar(64) NOT NULL COMMENT '最大差距段位',
  `ratio` varchar(64) NOT NULL COMMENT '衰减系数',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='大乱斗积分衰减配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_melee_pk_score_ratio`
--

LOCK TABLES `base_melee_pk_score_ratio` WRITE;
/*!40000 ALTER TABLE `base_melee_pk_score_ratio` DISABLE KEYS */;
INSERT INTO `base_melee_pk_score_ratio` VALUES (1,'0','6','1');
/*!40000 ALTER TABLE `base_melee_pk_score_ratio` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_melee_pk_stage_reward`
--

DROP TABLE IF EXISTS `base_melee_pk_stage_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_melee_pk_stage_reward` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励ID',
  `stage_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '目标阶段ID',
  `min_world_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小世界等级',
  `max_world_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大世界等级',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  `reward_list` varchar(512) NOT NULL COMMENT '奖励列表',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='大乱斗阶段奖励配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_melee_pk_stage_reward`
--

LOCK TABLES `base_melee_pk_stage_reward` WRITE;
/*!40000 ALTER TABLE `base_melee_pk_stage_reward` DISABLE KEYS */;
INSERT INTO `base_melee_pk_stage_reward` VALUES (1,1,1,190,200,'[{0,17010001,4},{0,24010001,2}]'),(2,1,191,230,200,'[{0,17010001,4},{0,24010001,2}]'),(3,1,231,260,200,'[{0,17010001,4},{0,24010001,2}]'),(4,1,261,320,200,'[{0,17010001,6},{0,24010001,3}]'),(5,1,321,350,200,'[{0,17010001,8},{0,24010001,3}]'),(6,1,351,370,200,'[{0,17010001,8},{0,24010001,4}]'),(7,1,371,390,200,'[{0,17010001,8},{0,24010002,2}]'),(8,1,391,430,200,'[{0,17010001,10},{0,24010002,2}]'),(9,1,431,500,200,'[{0,17010001,12},{0,24010002,3}]'),(10,1,501,560,200,'[{0,17010002,1},{0,24010002,3}]'),(11,1,561,610,200,'[{0,17010002,1},{0,24010002,4}]'),(12,1,611,660,200,'[{0,17010002,2},{0,24010003,1}]'),(13,1,661,750,200,'[{0,17010002,3},{0,24010003,1}]'),(14,1,751,1000,200,'[{0,17010002,4},{0,24010003,2}]'),(15,2,1,190,400,'[{0,17010001,4},{0,24010001,2}]'),(16,2,191,230,400,'[{0,17010001,4},{0,24010001,2}]'),(17,2,231,260,400,'[{0,17010001,4},{0,24010001,2}]'),(18,2,261,320,400,'[{0,17010001,6},{0,24010001,3}]'),(19,2,321,350,400,'[{0,17010001,8},{0,24010001,3}]'),(20,2,351,370,400,'[{0,17010001,8},{0,24010001,4}]'),(21,2,371,390,400,'[{0,17010001,8},{0,24010002,2}]'),(22,2,391,430,400,'[{0,17010001,10},{0,24010002,2}]'),(23,2,431,500,400,'[{0,17010001,12},{0,24010002,3}]'),(24,2,501,560,400,'[{0,17010002,1},{0,24010002,3}]'),(25,2,561,610,400,'[{0,17010002,1},{0,24010002,4}]'),(26,2,611,660,400,'[{0,17010002,2},{0,24010003,1}]'),(27,2,661,750,400,'[{0,17010002,3},{0,24010003,1}]'),(28,2,751,1000,400,'[{0,17010002,4},{0,24010003,2}]'),(29,3,1,190,700,'[{0,17010001,4},{0,24010001,2}]'),(30,3,191,230,700,'[{0,17010001,4},{0,24010001,2}]'),(31,3,231,260,700,'[{0,17010001,4},{0,24010001,2}]'),(32,3,261,320,700,'[{0,17010001,6},{0,24010001,3}]'),(33,3,321,350,700,'[{0,17010001,8},{0,24010001,3}]'),(34,3,351,370,700,'[{0,17010001,8},{0,24010001,4}]'),(35,3,371,390,700,'[{0,17010001,8},{0,24010002,2}]'),(36,3,391,430,700,'[{0,17010001,10},{0,24010002,2}]'),(37,3,431,500,700,'[{0,17010001,12},{0,24010002,3}]'),(38,3,501,560,700,'[{0,17010002,1},{0,24010002,3}]'),(39,3,561,610,700,'[{0,17010002,2},{0,24010002,4}]'),(40,3,611,660,700,'[{0,17010002,2},{0,24010003,1}]'),(41,3,661,750,700,'[{0,17010002,3},{0,24010003,2}]'),(42,3,751,1000,700,'[{0,17010002,4},{0,24010003,2}]'),(43,4,1,190,1000,'[{0,17010001,4},{0,24010001,2}]'),(44,4,191,230,1000,'[{0,17010001,4},{0,24010001,2}]'),(45,4,231,260,1000,'[{0,17010001,4},{0,24010001,2}]'),(46,4,261,320,1000,'[{0,17010001,6},{0,24010001,3}]'),(47,4,321,350,1000,'[{0,17010001,8},{0,24010001,3}]'),(48,4,351,370,1000,'[{0,17010001,8},{0,24010001,4}]'),(49,4,371,390,1000,'[{0,17010001,8},{0,24010002,2}]'),(50,4,391,430,1000,'[{0,17010001,10},{0,24010002,2}]'),(51,4,431,500,1000,'[{0,17010001,12},{0,24010002,3}]'),(52,4,501,560,1000,'[{0,17010002,1},{0,24010002,3}]'),(53,4,561,610,1000,'[{0,17010002,2},{0,24010002,4}]'),(54,4,611,660,1000,'[{0,17010002,2},{0,24010003,1}]'),(55,4,661,750,1000,'[{0,17010002,3},{0,24010003,2}]'),(56,4,751,1000,1000,'[{0,17010002,4},{0,24010003,2}]'),(57,5,1,190,1350,'[{0,17010001,4},{0,24010001,2}]'),(58,5,191,230,1350,'[{0,17010001,4},{0,24010001,2}]'),(59,5,231,260,1350,'[{0,17010001,4},{0,24010001,3}]'),(60,5,261,320,1350,'[{0,17010001,6},{0,24010001,3}]'),(61,5,321,350,1350,'[{0,17010001,8},{0,24010001,4}]'),(62,5,351,370,1350,'[{0,17010001,8},{0,24010001,4}]'),(63,5,371,390,1350,'[{0,17010001,10},{0,24010002,2}]'),(64,5,391,430,1350,'[{0,17010001,10},{0,24010002,3}]'),(65,5,431,500,1350,'[{0,17010001,12},{0,24010002,3}]'),(66,5,501,560,1350,'[{0,17010002,2},{0,24010002,4}]'),(67,5,561,610,1350,'[{0,17010002,2},{0,24010002,4}]'),(68,5,611,660,1350,'[{0,17010002,2},{0,24010003,2}]'),(69,5,661,750,1350,'[{0,17010002,3},{0,24010003,2}]'),(70,5,751,1000,1350,'[{0,17010002,4},{0,24010003,2}]'),(71,6,1,190,1700,'[{0,17010001,4},{0,24010001,2}]'),(72,6,191,230,1700,'[{0,17010001,4},{0,24010001,2}]'),(73,6,231,260,1700,'[{0,17010001,4},{0,24010001,3}]'),(74,6,261,320,1700,'[{0,17010001,6},{0,24010001,3}]'),(75,6,321,350,1700,'[{0,17010001,8},{0,24010001,4}]'),(76,6,351,370,1700,'[{0,17010001,8},{0,24010001,4}]'),(77,6,371,390,1700,'[{0,17010001,10},{0,24010002,2}]'),(78,6,391,430,1700,'[{0,17010001,10},{0,24010002,3}]'),(79,6,431,500,1700,'[{0,17010001,12},{0,24010002,3}]'),(80,6,501,560,1700,'[{0,17010002,2},{0,24010002,4}]'),(81,6,561,610,1700,'[{0,17010002,2},{0,24010002,4}]'),(82,6,611,660,1700,'[{0,17010002,2},{0,24010003,2}]'),(83,6,661,750,1700,'[{0,17010002,3},{0,24010003,2}]'),(84,6,751,1000,1700,'[{0,17010002,4},{0,24010003,2}]'),(85,7,1,190,2100,'[{0,17010001,4},{0,24010001,2}]'),(86,7,191,230,2100,'[{0,17010001,4},{0,24010001,2}]'),(87,7,231,260,2100,'[{0,17010001,4},{0,24010001,3}]'),(88,7,261,320,2100,'[{0,17010001,6},{0,24010001,3}]'),(89,7,321,350,2100,'[{0,17010001,8},{0,24010001,4}]'),(90,7,351,370,2100,'[{0,17010001,8},{0,24010001,4}]'),(91,7,371,390,2100,'[{0,17010001,10},{0,24010002,2}]'),(92,7,391,430,2100,'[{0,17010001,10},{0,24010002,3}]'),(93,7,431,500,2100,'[{0,17010001,12},{0,24010002,3}]'),(94,7,501,560,2100,'[{0,17010002,2},{0,24010002,4}]'),(95,7,561,610,2100,'[{0,17010002,2},{0,24010002,4}]'),(96,7,611,660,2100,'[{0,17010002,3},{0,24010003,2}]'),(97,7,661,750,2100,'[{0,17010002,3},{0,24010003,2}]'),(98,7,751,1000,2100,'[{0,17010002,4},{0,24010003,2}]'),(99,8,1,190,2400,'[{0,17010001,4},{0,24010001,2}]'),(100,8,191,230,2400,'[{0,17010001,4},{0,24010001,2}]'),(101,8,231,260,2400,'[{0,17010001,4},{0,24010001,3}]'),(102,8,261,320,2400,'[{0,17010001,6},{0,24010001,3}]'),(103,8,321,350,2400,'[{0,17010001,8},{0,24010001,4}]'),(104,8,351,370,2400,'[{0,17010001,8},{0,24010001,4}]'),(105,8,371,390,2400,'[{0,17010001,10},{0,24010002,2}]'),(106,8,391,430,2400,'[{0,17010001,10},{0,24010002,3}]'),(107,8,431,500,2400,'[{0,17010001,12},{0,24010002,3}]'),(108,8,501,560,2400,'[{0,17010002,2},{0,24010002,4}]'),(109,8,561,610,2400,'[{0,17010002,2},{0,24010002,4}]'),(110,8,611,660,2400,'[{0,17010002,3},{0,24010003,2}]'),(111,8,661,750,2400,'[{0,17010002,3},{0,24010003,2}]'),(112,8,751,1000,2400,'[{0,17010002,4},{0,24010003,2}]');
/*!40000 ALTER TABLE `base_melee_pk_stage_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_melee_time_score_ratio`
--

DROP TABLE IF EXISTS `base_melee_time_score_ratio`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_melee_time_score_ratio` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '编号',
  `min_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小积分',
  `max_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大积分',
  `area_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '地图区域id',
  `ratio` varchar(64) NOT NULL COMMENT '衰减系数',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='大乱斗定时积分衰减配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_melee_time_score_ratio`
--

LOCK TABLES `base_melee_time_score_ratio` WRITE;
/*!40000 ALTER TABLE `base_melee_time_score_ratio` DISABLE KEYS */;
INSERT INTO `base_melee_time_score_ratio` VALUES (1,501,1200,1,'0.6'),(2,501,1200,2,'1'),(3,501,1200,3,'1'),(4,501,1200,4,'1'),(5,1201,2100,1,'0.4'),(6,1201,2100,2,'0.6'),(7,1201,2100,3,'1'),(8,1201,2100,4,'1'),(9,2100,100000,1,'0.2'),(10,2100,100000,2,'0.4'),(11,2100,100000,3,'0.6'),(12,2100,100000,4,'1');
/*!40000 ALTER TABLE `base_melee_time_score_ratio` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_module_advance`
--

DROP TABLE IF EXISTS `base_module_advance`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_module_advance` (
  `module_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `sub_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能子id',
  `name` varchar(128) NOT NULL DEFAULT '' COMMENT '功能名称',
  `open_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开放等级',
  `reward` varchar(128) NOT NULL DEFAULT '[]' COMMENT '功能开放奖励',
  PRIMARY KEY (`module_id`,`sub_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='功能预告奖励表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_module_advance`
--

LOCK TABLES `base_module_advance` WRITE;
/*!40000 ALTER TABLE `base_module_advance` DISABLE KEYS */;
INSERT INTO `base_module_advance` VALUES (8,1,'婚姻',180,'[{0,38100001,5}]'),(150,2,'装备合成',160,'[{0,14010101,3}]'),(999,11,'二转',220,'[{0,38160001,1}]'),(999,12,'三转',280,'[{0,38110003,5}]'),(999,13,'四转',355,'[{0,38110004,2}]'),(999,14,'五转',500,'[{0,38110005,2}]');
/*!40000 ALTER TABLE `base_module_advance` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_module_id`
--

DROP TABLE IF EXISTS `base_module_id`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_module_id` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `module_name` varchar(255) NOT NULL COMMENT '功能名称@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='功能id配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_module_id`
--

LOCK TABLES `base_module_id` WRITE;
/*!40000 ALTER TABLE `base_module_id` DISABLE KEYS */;
INSERT INTO `base_module_id` VALUES (0,'无'),(102,'游戏基础'),(105,'设置'),(110,'聊天系统'),(112,'个性装扮'),(120,'场景系统'),(130,'角色系统'),(132,'离线挂机&&设置'),(137,'钻石大战'),(140,'社交系统'),(150,'背包物品'),(151,'交易系统'),(152,'装备系统'),(153,'商城系统'),(154,'拍卖系统'),(156,'邮件推送'),(157,'活动日历'),(158,'充值系统'),(159,'充值活动'),(160,'坐骑系统'),(161,'翅膀'),(164,'天命觉醒'),(168,'宝具'),(172,'婚姻'),(174,'中午答题'),(175,'七天登录'),(176,'神秘限购'),(177,'钓鱼'),(178,'装备吞噬'),(179,'宝宝'),(180,'玩家交互'),(181,'魂珠'),(182,'功能预告'),(190,'邮件系统'),(200,'战斗信息'),(210,'技能系统'),(215,'跨服组队副本'),(221,'排行榜'),(223,'花语鲜花周榜'),(224,'魅力榜活动'),(225,'开服冲榜'),(226,'跨服排行榜'),(240,'组队系统'),(280,'竞技'),(281,'巅峰竞技'),(300,'任务系统'),(331,'定制活动'),(338,'竞榜'),(339,'红包系统'),(400,'公会系统'),(401,'公会仓库'),(402,'公会活动'),(403,'公会篝火'),(409,'成就系统'),(411,'称号系统'),(413,'时装系统'),(416,'寻宝'),(417,'福利(签到,冲级,更新,礼包)'),(418,'魅力海滩'),(419,'奖励找回'),(420,'投资活动'),(423,'宝藏系统'),(424,'永恒碑谷'),(425,'星之轨迹'),(427,'神格系统'),(428,'圣灵'),(429,'捕蝶'),(430,'星灵系统'),(431,'星痕系统'),(432,'星灵试炼'),(433,'星灵装备'),(434,'家园'),(435,'生活技能'),(436,'星灵争霸'),(437,'黑市商店'),(440,'降神'),(441,'图鉴系统'),(450,'vip系统'),(460,'本服BOSS'),(461,'跨服boss'),(500,'飞艇护送'),(501,'限时目标'),(502,'光武'),(600,'虚空秘境'),(604,'三英会战'),(605,'荣耀战神'),(606,'大乱斗'),(607,'跨服城战'),(608,'世界主城'),(609,'跨服入侵'),(610,'副本'),(621,'跨服1vn'),(630,'变强'),(650,'跨服3v3');
/*!40000 ALTER TABLE `base_module_id` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_module_sub`
--

DROP TABLE IF EXISTS `base_module_sub`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_module_sub` (
  `id` int(11) NOT NULL COMMENT '功能大类id(对应base_module_id里的id)',
  `sub_id` int(11) NOT NULL COMMENT '功能子类id',
  `sub_name` varchar(50) NOT NULL COMMENT '功能名@lang@',
  `desc` text NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`id`,`sub_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_module_sub`
--

LOCK TABLES `base_module_sub` WRITE;
/*!40000 ALTER TABLE `base_module_sub` DISABLE KEYS */;
INSERT INTO `base_module_sub` VALUES (140,1,'组队通关副本增加亲密度',''),(140,2,'组队杀怪增加亲密度',''),(150,1,'物品掉落','物品掉落，以物品id为计数器id'),(150,2,'礼包限制次数','礼包每天限制次数'),(150,3,'物品合成','用于道具合成跳转'),(152,1,'装备强化',''),(152,2,'装备洗炼',''),(152,3,'装备进阶',''),(152,4,'宝石镶嵌',''),(152,5,'宝石精炼',''),(152,6,'装备替换',''),(152,7,'套装合成',''),(152,8,'装备铸灵',''),(152,9,'装备觉醒',''),(152,10,'装备附灵',''),(153,1,'每周限购商城',''),(153,2,'常用道具',''),(153,3,'绑钻商城',''),(153,6,'荣耀商城',''),(153,7,'快速购买',''),(155,1,'圣印镶嵌',''),(155,2,'圣印强化',''),(155,3,'圣魂使用','圣魂使用'),(157,1,'活动次数',''),(157,2,'活跃度奖励','活跃度奖励'),(158,1,'领取7日或30日礼包','每天领取7日或30日礼包时触发'),(159,1,'福利卡',''),(159,2,'每日累充',''),(159,5,'首充奖励',''),(159,6,'购买每日礼包','1元、3元、6元包'),(159,7,'领取7日或30日礼包',''),(160,1,'坐骑',''),(161,1,'翅膀升级',''),(161,2,'翅膀化形',''),(161,3,'仙羽强化',''),(165,1,'宠物',''),(165,2,'宠物飞行器',''),(166,1,'爵位提升',''),(167,1,'符文升级',''),(167,2,'符文镶嵌',''),(168,1,'法宝升级',''),(168,2,'法宝化形',''),(168,3,'魂珠强化',''),(169,1,'神兵强化',''),(169,2,'神兵化形',''),(169,3,'剑灵强化',''),(170,1,'聚魂镶嵌',''),(170,2,'聚魂升级',''),(171,1,'神器强化',''),(171,2,'神器附灵',''),(172,1,'节制培养',''),(172,2,'宝宝学识',''),(172,3,'宝宝资质',''),(172,4,'宝宝幻形',''),(172,5,'一生一世',''),(172,6,'秀恩爱',''),(173,1,'幻兽装备',''),(173,2,'幻兽助战',''),(173,3,'幻兽拓展',''),(210,1,'主动技能',''),(210,2,'被动技能',''),(210,3,'天赋技能',''),(300,1,'赏金任务',''),(300,2,'公会周任务',''),(331,4,'开服集字','开服集字—今日已兑'),(331,22,'烟花盛典',''),(331,28,'幸运抽奖',''),(331,31,'幸运鉴宝',''),(331,45,'每日推送',''),(339,1,'触发式红包',''),(339,2,'红包物品',''),(339,3,'活动物品红包',''),(339,4,'Vip红包',''),(400,3,'仓库额外商品兑换','仓库额外商品兑换'),(401,1,'公会淘宝',''),(402,1,'公会boss',''),(402,2,'公会晚宴',''),(402,3,'守卫公会',''),(402,4,'公会争霸',''),(413,1,'时装激活',''),(413,2,'时装升星',''),(416,1,'积分兑换',''),(417,1,'签到','每日正常签到'),(417,2,'每日在线时长',''),(418,1,'赠送礼物','海滩中玩家之间赠送礼物'),(420,1,'冒险之旅','冒险之旅'),(422,1,'激活星图','激活星图的星点'),(423,1,'秘宝远征',''),(423,2,'金币矿洞',''),(423,3,'经验书馆',''),(432,1,'每周免费扫荡次数','每周免费扫荡次数'),(432,2,'每日购买次数','每日购买次数'),(432,3,'每日扫荡消耗次数','每日扫荡消耗次数'),(432,4,'商城购买次数','商城购买次数'),(450,1,'特权礼包',''),(450,2,'每日签到','每日签到日志'),(450,3,'消耗钻石增加经验值','当日累计消耗钻石增加经验值'),(450,4,'登录增加经验','当日登录增加的经验'),(460,1,'世界BOSS',''),(460,2,'BOSS之家',''),(460,3,'个人BOSS',''),(460,4,'蛮荒禁地',''),(460,5,'上古神迹',''),(461,1,'采集怪',''),(470,1,'幻兽之域',''),(500,1,'双倍护送',''),(606,1,'宝箱采集',''),(610,1,'副本进入','用于副本进入次数：副本进入次数根据副本规则来计算增减'),(610,2,'副本助战次数',''),(610,3,'副本挑战胜利','副本挑战胜利'),(610,4,'副本购买次数',''),(610,5,'副本重置',''),(610,6,'副本协助奖励次数',''),(610,7,'副本扫荡购买次数','副本扫荡购买次数'),(610,8,'副本扫荡次数','副本扫荡次数'),(610,9,'副本道具增加次数','副本道具增加次数'),(610,10,'副本道具已使用次数','副本道具已使用次数'),(610,11,'首次进入副本',''),(610,12,'副本使用道具增加扫荡次数','副本使用道具增加扫荡次数'),(610,13,'经验副本',''),(610,14,'金币副本',''),(610,15,'符文副本',''),(610,16,'聚魂副本',''),(610,17,'个人BOSS',''),(610,18,'情侣副本',''),(610,19,'诛邪战场','诛邪战场'),(610,20,'觉醒副本','');
/*!40000 ALTER TABLE `base_module_sub` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_mon`
--

DROP TABLE IF EXISTS `base_mon`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_mon` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '怪物配置id',
  `name` varchar(50) NOT NULL COMMENT '怪物名字@lang@',
  `kind` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '怪物类型 0怪物，1采集怪，2任务采集怪，3护送车队，4拾取型，5赏金怪',
  `boss` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'BOSS类型，0普通怪，1野外BOSS，2英灵殿BOSS',
  `type` tinyint(3) unsigned DEFAULT '1' COMMENT '战斗类型(0被动，1主动)',
  `about` varchar(256) DEFAULT '' COMMENT '怪物描述@lang@',
  `career` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '职业,0没职业',
  `color` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '颜色(1白,2绿,3蓝,4紫,5粉,6橙,7金)',
  `module` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '所属模块id',
  `sub_module` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '所属模块子id',
  `auto` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '0-读怪物表属性，1-服务器等级，2-队伍平均等级，3-队长等级（无组队时默认是队长），需要读怪物动态属性表',
  `icon` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '资源id',
  `icon_scale` varchar(10) DEFAULT '1.0' COMMENT '资源缩放[1.0-]',
  `icon_effect` varchar(100) NOT NULL DEFAULT '[]' COMMENT '怪物资源特效',
  `icon_texture` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '贴图id',
  `headwear_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '头饰id',
  `headwear_texture` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '头饰贴图id',
  `weapon_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '武器模型id',
  `foot_icon` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '脚下资源id',
  `desc` varchar(5000) DEFAULT NULL COMMENT '默认对话##时间,怪物说话:概率,怪物说话:概率,怪物说话:概率 ',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `hp_num` int(11) unsigned DEFAULT '0' COMMENT '血条数量',
  `att` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '攻击',
  `hp_lim` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '血上限',
  `wreck` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '破甲',
  `def` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '防御',
  `hit` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '命中',
  `dodge` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '躲闪',
  `crit` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '暴击',
  `ten` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '坚韧',
  `resist` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '抗性',
  `special_attr` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '特定属性[{AttrType, AttrValue}] = [{属性类型,属性值}]',
  `resum` varchar(200) NOT NULL DEFAULT '[]' COMMENT '回血配置,[回血模式,回复量,时间]回血模式:0不回血;1脱离战斗状态立刻回满血;2战斗中持续回复;3脱离战斗后持续回复',
  `striking_distance` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '攻击距离(像素)',
  `tracing_distance` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '跟踪距离(像素)',
  `warning_range` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '警戒范围(像素)',
  `hate_range` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '仇恨范围(像素)：表示玩家离开某区域后，怪物不追踪，清空伤害列表，不填表示没有仇恨范围',
  `speed` int(3) unsigned NOT NULL DEFAULT '0' COMMENT '速度(每秒移动的像素)',
  `skill` varchar(2000) NOT NULL DEFAULT '[]' COMMENT '技能列表[{技能id,技能等级},...]',
  `retime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '重生时间(毫秒)',
  `att_time` int(11) unsigned NOT NULL DEFAULT '400' COMMENT '攻击间隔(毫秒)',
  `att_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '0近攻，1远程攻击',
  `drop` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '掉落方式',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '经验',
  `out` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '挂机设置 0|1,是否玩家自动挂机可以攻击的目标',
  `collect_kind` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '采集分享类型',
  `collect_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '采集时间(秒)',
  `collect_count` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '可采集次数（每次都会有掉落）',
  `is_fight_back` tinyint(1) unsigned DEFAULT '1' COMMENT '是否会反击 ，默认为1',
  `is_be_atted` tinyint(1) unsigned DEFAULT '1' COMMENT '是否可攻击 ，默认为1',
  `is_be_clicked` tinyint(1) unsigned DEFAULT '1' COMMENT '是否可被点击，默认为1',
  `is_armor` tinyint(1) unsigned DEFAULT '0' COMMENT '是否霸体，默认为0',
  `is_patrol` tinyint(1) unsigned DEFAULT '0' COMMENT '是否可巡逻',
  `del_hp_each_time` varchar(300) NOT NULL DEFAULT '[]' COMMENT '[Min,Max]:怪物受到的每次伤害值区间,整数,小数为百分比：1:默认:[];2:hurt大于等于Min小于等于Max;3怪物Hp的百分比:Hurt大于等于Hp*Min小于等于Hp*Max',
  `figure_visible` tinyint(4) unsigned DEFAULT '1' COMMENT '是否显示形象（默认1，1：显示；0：不显示）',
  `mon_state` varchar(255) NOT NULL COMMENT '怪物出生特殊状态(特效展示),0：代表无特效，客户端使用',
  `is_hide_hp` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否隐藏血条(0|1)',
  `is_hit_ac` tinyint(2) unsigned NOT NULL DEFAULT '1' COMMENT '是否播放受击动作',
  `exp_share_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '经验分享类型##0所有伤害者都获得全部经验 1按伤害比例分配 2场景内共享 ',
  `anger` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '杀怪玩家增加的怒气值',
  `load_immediately` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否立即加载 0:不立即加载 1:立即加载',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='怪物信息';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_mon`
--

LOCK TABLES `base_mon` WRITE;
/*!40000 ALTER TABLE `base_mon` DISABLE KEYS */;
INSERT INTO `base_mon` VALUES (1,'皮卡丘1',0,7,1,'测试怪物',0,7,0,0,0,5010011,'1','0',0,0,0,5010011,0,'2||啦啦啦我是一只小怪:90',500,1,5000,5000,0,0,0,0,0,0,0,'[]','[1]',0,0,0,500,0,'[{20001000,1}]',500,0,0,0,100,0,0,0,0,0,1,1,0,0,'[1,1]',1,'0',0,0,0,0,0),(2,'测试小怪（带晕眩）',0,0,1,'测试怪物',0,1,0,0,0,5010011,'1','0',0,0,0,5010011,0,'0',1,1,1,3000,0,0,0,0,0,0,0,'[]','[]',50,300,200,0,150,'[{1110000003,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3,'木桩怪',0,0,0,'测试怪物',0,1,0,0,0,5010011,'1','0',0,0,0,5010011,0,'0',1,1,0,10000000,0,0,0,0,0,0,0,'[]','[]',0,0,0,0,0,'[{1110000003,1}]',0,0,0,0,100,0,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(4,'测试boss',0,2,1,'测试怪物',0,3,0,0,0,5010011,'1','0',0,0,0,5010011,0,'这是一只测试掉落的小怪',1,100,1,1000,0,0,0,0,0,0,0,'[]','[]',50,300,200,0,150,'[{1110000003,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(5,'测试采集怪',2,0,0,'测试怪物',0,3,0,0,0,5010011,'1','0',0,0,0,5010011,0,'0',1,1,1,10000,0,0,0,0,0,0,0,'[]','[]',0,0,0,0,0,'[{1110000003,1}]',1000,2000,0,1,0,0,0,0,0,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(6,'队伍掉落测试',0,1,1,'测试怪物',0,3,0,0,0,5010011,'1','0',0,0,0,5010011,0,'0',200,1,1000,160000,4000,4000,2000,2000,2000,2000,0,'[]','[]',100,600,600,0,200,'[{1110000003,1}]',5000,2000,0,1,100,0,0,0,0,1,1,1,0,0,'[]',1,'ui_diaoluoguangzhutexiao',0,0,0,0,0),(7,'归属掉落0',0,1,1,'测试怪物',0,3,0,0,0,5010011,'1','0',0,0,0,5010011,0,'0',325,1,1000,256000,6400,6400,3200,3200,3200,3200,0,'[]','[]',100,600,600,0,200,'[{1110000003,1}]',0,2000,0,1,100,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(8,'归属掉落1',0,1,1,'测试怪物',0,3,0,0,0,5010011,'1','0',0,0,0,5010011,0,'0',2,100,5,3000,0,0,0,0,0,0,0,'[]','[]',100,600,600,0,200,'[{1110000003,1}]',0,2000,0,1,100,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(9,'归属掉落2',0,1,1,'测试怪物',0,3,0,0,0,5010011,'1','0',0,0,0,5010011,0,'0',2,100,5,3000,0,0,0,0,0,0,0,'[]','[]',100,600,600,0,200,'[{1110000003,1}]',0,2000,0,1,100,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(10,'归属掉落3',0,1,1,'测试怪物',0,3,0,0,0,5010011,'1','0',0,0,0,5010011,0,'0',2,100,5,3000,0,0,0,0,0,0,0,'[]','[]',100,600,600,0,200,'[{1110000003,1}]',0,2000,0,1,100,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(11,'掉落白装',0,0,1,'跨服争霸Lv500中立野怪',0,3,0,0,0,5010011,'1','0',0,0,0,5010011,0,'0',500,14,43163,720044,59234,51239,28149,7700,5483,14098,0,'[]','[]',100,600,600,0,200,'[{1110000003,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(12,'掉落绿装',0,1,1,'跨服争霸Lv500海盗船',0,3,0,0,0,5010011,'1','0',0,0,0,5010011,0,'0',500,415,34530,20770508,59234,51239,28149,7700,5483,14098,0,'[]','[]',100,600,600,0,200,'[{1110000003,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(13,'掉落蓝装',0,0,1,'跨服争霸Lv500复活点',0,3,0,0,0,5010011,'1','0',0,0,0,5010011,0,'0',500,3323,1439,166164061,59234,51239,28149,7700,5483,14098,0,'[]','[]',100,600,600,0,200,'[{1110000003,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(14,'掉落紫装',0,0,1,'跨服争霸Lv500海神像',0,3,0,0,0,5010011,'1','0',0,0,0,5010011,0,'0',500,5982,959,299095311,59234,51239,28149,7700,5483,14098,0,'[]','[]',100,600,600,0,200,'[{1110000003,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(15,'掉落橙装',0,0,1,'测试怪物',0,3,0,0,0,5010011,'1','0',0,0,0,5010011,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,600,600,0,200,'[{1110000003,1}]',0,2000,0,1,100,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(16,'掉落红装',0,0,1,'测试怪物',0,3,0,0,0,5010011,'1','0',0,0,0,5010011,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,600,600,0,200,'[{1110000003,1}]',0,2000,0,1,100,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(17,'转生任务怪物',0,0,1,'测试怪物',0,1,0,0,0,5010011,'1','0',0,0,0,5010011,0,'0',150,1,5,50,0,0,0,0,0,0,0,'[]','[]',300,300,300,300,150,'[{1110000003,1}]',20000,1000,0,0,10,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(18,'掉落1个',0,0,1,'测试怪物',0,3,0,0,0,5010011,'1','0',0,0,0,5010011,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,600,600,0,200,'[{1110000003,1}]',0,2000,0,1,100,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(19,'掉落5个',0,0,1,'测试怪物',0,3,0,0,0,5010011,'1','0',0,0,0,5010011,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,600,600,0,200,'[{1110000003,1}]',0,2000,0,2,100,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(20,'掉落20个',0,0,1,'测试怪物',0,3,0,0,0,5010011,'1','0',0,0,0,5010011,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,600,600,0,200,'[{1110000003,1}]',0,2000,0,3,100,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(21,'掉落50个',0,0,1,'跨服争霸Lv550中立野怪',0,3,0,0,0,5010011,'1','0',0,0,0,5010011,0,'0',550,20,73358,1125770,59234,51239,28149,7700,5483,14098,0,'[]','[]',100,600,600,0,200,'[{1110000003,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(22,'掉落100个',0,0,1,'跨服争霸Lv550海盗船',0,3,0,0,0,5010011,'1','0',0,0,0,5010011,0,'0',550,590,58686,32474148,59234,51239,28149,7700,5483,14098,0,'[]','[]',100,600,600,0,200,'[{1110000003,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(23,'掉落一大堆',0,0,1,'跨服争霸Lv550复活点',0,3,0,0,0,5010011,'1','0',0,0,0,5010011,0,'0',550,4724,2445,259793182,59234,51239,28149,7700,5483,14098,0,'[]','[]',100,600,600,0,200,'[{1110000003,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(24,'百万经验怪',0,0,1,'跨服争霸Lv550海神像',0,3,0,0,0,5010011,'1','0',0,0,0,5010011,0,'0',550,8502,1630,467627728,59234,51239,28149,7700,5483,14098,0,'[]','[]',100,600,600,0,200,'[{1110000003,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25,'掉落测试大礼包',0,0,1,'测试怪物',0,3,0,0,0,5010011,'1','0',0,0,0,5010011,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,600,600,0,200,'[{1110000003,1}]',0,2000,0,1,100,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(26,'固定归属',0,0,1,'测试怪物',0,3,0,0,0,5010011,'1','0',0,0,0,5010011,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,600,600,0,200,'[{1110000003,1}]',0,2000,0,1,100,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(27,'固定队伍',0,0,1,'测试怪物',0,3,0,0,0,5010011,'1','0',0,0,0,5010011,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,600,600,0,200,'[{1110000003,1}]',0,2000,0,1,100,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(28,'任务归属',0,0,1,'测试怪物',0,3,0,0,0,5010011,'1','0',0,0,0,5010011,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,600,600,0,200,'[{1110000003,1}]',0,2000,0,1,100,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(29,'任务队伍',0,0,1,'测试怪物',0,3,0,0,0,5010011,'1','0',0,0,0,5010011,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,600,600,0,200,'[{1110000003,1}]',0,2000,0,1,100,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(30,'掉落概率队伍',0,0,1,'测试怪物',0,3,0,0,0,5010011,'1','0',0,0,0,5010011,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,600,600,0,200,'[{1110000003,1}]',0,2000,0,1,100,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(31,'掉落概率归属',0,0,1,'跨服争霸Lv600中立野怪',0,3,0,0,0,5010011,'1','0',0,0,0,5010011,0,'0',600,25,101042,1479932,59234,51239,28149,7700,5483,14098,0,'[]','[]',100,600,600,0,200,'[{1110000003,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(32,'掉落概率无归属',0,0,1,'跨服争霸Lv600海盗船',0,3,0,0,0,5010011,'1','0',0,0,0,5010011,0,'0',600,712,80833,42690336,59234,51239,28149,7700,5483,14098,0,'[]','[]',100,600,600,0,200,'[{1110000003,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(33,'冰人皮卡丘',0,3,1,'跨服争霸Lv600复活点',0,3,0,0,0,1202004,'1.1','0',0,0,0,1202004,0,'5||嘿咻，十万伏特!:80',600,5692,3368,341522692,59234,51239,28149,7700,5483,14098,0,'[]','[]',100,600,600,2000,600,'[{1001,1},{16000014,1}]',0,1000,0,1,0,0,0,0,0,1,1,1,0,0,'[1,2]',1,'0',0,0,0,0,0),(34,'冰神',0,3,1,'跨服争霸Lv600海神像',0,3,0,0,0,1202008,'1','0',0,0,0,1202008,0,'0',600,10246,2245,614740845,59234,51239,28149,7700,5483,14098,0,'[]','[]',800,2000,2000,2000,300,'[{20005600,1},{20005601,1},{20005603,1},{20005602,1},{20005605,1},{20005604,1}]',0,2000,1,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(100,'重生怪',0,0,1,'测试怪物',0,2,0,0,0,5010011,'1','0',0,0,0,5010011,0,'0',1,1,1,10000,0,0,0,0,0,0,0,'[]','[]',200,500,200,0,150,'[{1110000003,1}]',2000,2000,0,1,100,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(110,'个人独占伤害最高',0,0,1,'个人独占伤害最高',0,7,0,0,0,5010011,'1','0',0,0,0,5010011,0,'2||啦啦啦我是一只小怪:90',110,100,1,100000,0,0,0,0,0,0,0,'[]','[1]',100,600,600,0,200,'[{20001000,1}]',3000,2000,0,1,110,0,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(111,'个人独占第一击',0,0,1,'个人独占第一击',0,1,0,0,0,5010011,'1','0',0,0,0,5010011,0,'0',111,100,1,100000,0,0,0,0,0,0,0,'[]','[]',100,600,600,0,200,'[{1110000003,1}]',3000,2000,0,1,111,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(112,'个人独占最后一击',0,0,0,'个人独占最后一击',0,1,0,0,0,5010011,'1','0',0,0,0,5010011,0,'0',112,100,1,100000,0,0,0,0,0,0,0,'[]','[]',100,600,600,0,200,'[{1110000003,1}]',3000,2000,0,1,112,0,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(113,'个人独占无归属',0,2,1,'个人独占无归属',0,3,0,0,0,5010011,'1','0',0,0,0,5010011,0,'这是一只测试掉落的小怪',113,100,1,100000,0,0,0,0,0,0,0,'[]','[]',100,600,600,0,200,'[{1110000003,1}]',3000,2000,0,1,113,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(120,'随机分配伤害最高',0,0,0,'随机分配伤害最高',0,3,0,0,0,5010011,'1','0',0,0,0,5010011,0,'0',120,100,1,100000,0,0,0,0,0,0,0,'[]','[]',100,600,600,0,200,'[{1110000003,1}]',3000,2000,0,1,120,0,0,0,0,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(121,'随机分配第一击',0,1,1,'随机分配第一击',0,3,0,0,0,5010011,'1','0',0,0,0,5010011,0,'0',121,100,1,100000,0,0,0,0,0,0,0,'[]','[]',100,600,600,0,200,'[{1110000003,1}]',3000,2000,0,1,121,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(122,'随机分配最后一击',0,1,1,'随机分配最后一击',0,3,0,0,0,5010011,'1','0',0,0,0,5010011,0,'0',122,100,1,100000,0,0,0,0,0,0,0,'[]','[]',100,600,600,0,200,'[{1110000003,1}]',3000,2000,0,1,122,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(123,'随机分配无归属',0,1,1,'随机分配无归属',0,3,0,0,0,5010011,'1','0',0,0,0,5010011,0,'0',123,100,1,100000,0,0,0,0,0,0,0,'[]','[]',100,600,600,0,200,'[{1110000003,1}]',3000,2000,0,1,123,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(130,'均等分配伤害最高',0,1,1,'均等分配伤害最高',0,3,0,0,0,5010011,'1','0',0,0,0,5010011,0,'0',130,100,1,100000,0,0,0,0,0,0,0,'[]','[]',100,600,600,0,200,'[{1110000003,1}]',3000,2000,0,1,130,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(131,'均等分配第一击',0,1,1,'均等分配第一击',0,3,0,0,0,5010011,'1','0',0,0,0,5010011,0,'0',131,100,1,100000,0,0,0,0,0,0,0,'[]','[]',100,600,600,0,200,'[{1110000003,1}]',3000,2000,0,1,131,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(132,'均等分配最后一击',0,0,1,'均等分配最后一击',0,3,0,0,0,5010011,'1','0',0,0,0,5010011,0,'0',132,100,1,100000,0,0,0,0,0,0,0,'[]','[]',100,600,600,0,200,'[{1110000003,1}]',3000,2000,0,1,132,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(133,'均等分配无归属',0,1,1,'均等分配无归属',0,3,0,0,0,5010011,'1','0',0,0,0,5010011,0,'0',133,100,1,100000,0,0,0,0,0,0,0,'[]','[]',100,600,600,0,200,'[{1110000003,1}]',3000,2000,0,1,133,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(140,'先到先得伤害最高',0,0,1,'先到先得伤害最高',0,3,0,0,0,5010011,'1','0',0,0,0,5010011,0,'0',140,100,1,100000,0,0,0,0,0,0,0,'[]','[]',100,600,600,0,200,'[{1110000003,1}]',3000,2000,0,1,140,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(141,'先到先得第一击',0,0,1,'先到先得第一击',0,3,0,0,0,5010011,'1','0',0,0,0,5010011,0,'0',141,100,1,100000,0,0,0,0,0,0,0,'[]','[]',100,600,600,0,200,'[{1110000003,1}]',3000,2000,0,1,141,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(142,'先到先得最后一击',0,0,1,'先到先得最后一击',0,3,0,0,0,5010011,'1','0',0,0,0,5010011,0,'0',142,100,1,100000,0,0,0,0,0,0,0,'[]','[]',100,600,600,0,200,'[{1110000003,1}]',3000,2000,0,1,142,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(143,'先到先得无归属',0,0,1,'先到先得无归属',0,3,0,0,0,5010011,'1','0',0,0,0,5010011,0,'0',143,100,1,100000,0,0,0,0,0,0,0,'[]','[]',100,600,600,0,200,'[{1110000003,1}]',3000,2000,0,1,143,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(600001,'骷髅勇士',6,0,1,'简单重铸副本第1波',0,1,0,0,1,202002,'1.4','0',0,0,0,202002,0,'0',330,1,2998,663609,22942,15097,1265,1265,1188,1208,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600002,'骷髅勇士',6,0,1,'简单重铸副本第1波',0,1,0,0,1,202002,'1.4','0',0,0,0,202002,0,'0',330,1,2998,663609,22942,15097,1265,1265,1188,1208,0,'[]','[]',250,2250,1500,2250,200,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,1,0,'[]',1,'0',0,0,2,0,0),(600003,'骷髅勇士',6,0,1,'简单重铸副本第1波',0,1,0,0,1,202002,'1.4','0',0,0,0,202002,0,'0',330,1,2998,663609,22942,15097,1265,1265,1188,1208,0,'[]','[]',250,2250,1500,2250,200,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,1,0,'[]',1,'0',0,0,2,0,0),(600004,'白袍杀手',6,0,1,'简单重铸副本第2波',0,1,0,0,1,202036,'1.4','0',0,0,0,202036,0,'0',330,1,4328,914971,24672,16752,1413,1413,1250,1271,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600005,'白袍杀手',6,0,1,'简单重铸副本第2波',0,1,0,0,1,202036,'1.4','0',0,0,0,202036,0,'0',330,1,4328,914971,24672,16752,1413,1413,1250,1271,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600006,'白袍杀手',6,0,1,'简单重铸副本第2波',0,1,0,0,1,202036,'1.4','0',0,0,0,202036,0,'0',330,1,4328,914971,24672,16752,1413,1413,1250,1271,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600007,'火鸡骑士',6,0,1,'简单重铸副本第3波',0,1,0,0,1,202034,'1.4','0',0,0,0,202034,0,'0',330,1,5436,1200779,26401,18406,1562,1562,1311,1335,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600008,'火鸡骑士',6,0,1,'简单重铸副本第3波',0,1,0,0,1,202034,'1.4','0',0,0,0,202034,0,'0',330,1,5436,1200779,26401,18406,1562,1562,1311,1335,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600009,'火鸡骑士',6,0,1,'简单重铸副本第3波',0,1,0,0,1,202034,'1.4','0',0,0,0,202034,0,'0',330,1,5436,1200779,26401,18406,1562,1562,1311,1335,0,'[]','[]',250,2250,1500,2250,200,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,1,0,'[]',1,'0',0,0,2,0,0),(600010,'机械魔犬',6,0,1,'简单重铸副本第4波',0,1,0,0,1,202016,'1.4','0',0,0,0,202016,0,'0',330,1,5556,1493971,27396,19549,1745,1745,1449,1475,0,'[]','[]',250,2250,1500,2250,200,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,1,0,'[]',1,'0',0,0,2,0,0),(600011,'机械魔犬',6,0,1,'简单重铸副本第4波',0,1,0,0,1,202016,'1.4','0',0,0,0,202016,0,'0',330,1,5556,1493971,27396,19549,1745,1745,1449,1475,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600012,'机械魔犬',6,0,1,'简单重铸副本第4波',0,1,0,0,1,202016,'1.4','0',0,0,0,202016,0,'0',330,1,5556,1493971,27396,19549,1745,1745,1449,1475,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600013,'金属魔卫',6,0,1,'简单重铸副本第5波',0,1,0,0,1,202035,'1.4','0',0,0,0,202035,0,'0',330,1,5696,1814071,28390,20691,1929,1929,1587,1615,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600014,'金属魔卫',6,0,1,'简单重铸副本第5波',0,1,0,0,1,202035,'1.4','0',0,0,0,202035,0,'0',330,1,5696,1814071,28390,20691,1929,1929,1587,1615,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600015,'金属魔卫',6,0,1,'简单重铸副本第5波',0,1,0,0,1,202035,'1.4','0',0,0,0,202035,0,'0',330,1,5696,1814071,28390,20691,1929,1929,1587,1615,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600016,'机械泰坦',6,0,1,'简单重铸副本第6波',0,1,0,0,1,203008,'1.3','0',0,0,0,203008,0,'0',330,1,30011,3601778,29385,21833,2112,2112,1725,1755,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600017,'机械泰坦',6,0,1,'简单重铸副本第6波',0,1,0,0,1,203008,'1.3','0',0,0,0,203008,0,'0',330,1,30011,3601778,29385,21833,2112,2112,1725,1755,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600018,'机械泰坦',6,0,1,'简单重铸副本第6波',0,1,0,0,1,203008,'1.3','0',0,0,0,203008,0,'0',330,1,30011,3601778,29385,21833,2112,2112,1725,1755,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600019,'雅典娜',0,0,1,'简单重铸副本水晶',0,1,0,0,0,601001,'1.5','0',0,0,0,601001,0,'0',330,1,100,2539890,20741,27916,2006,2006,1667,1639,0,'[]','[]',0,2250,1500,2250,200,'[]',0,1000,0,0,0,0,0,0,0,0,1,1,1,0,'[]',1,'0',0,0,0,0,0),(600021,'骷髅勇士',6,0,1,'普通重铸副本第1波',0,1,0,0,1,202002,'1.4','0',0,0,0,202002,0,'0',375,1,4252,1067557,31374,24118,2479,2479,2002,2036,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600022,'骷髅勇士',6,0,1,'普通重铸副本第1波',0,1,0,0,1,202002,'1.4','0',0,0,0,202002,0,'0',375,1,4252,1067557,31374,24118,2479,2479,2002,2036,0,'[]','[]',250,2250,1500,2250,200,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,1,0,'[]',1,'0',0,0,2,0,0),(600023,'骷髅勇士',6,0,1,'普通重铸副本第1波',0,1,0,0,1,202002,'1.4','0',0,0,0,202002,0,'0',375,1,4252,1067557,31374,24118,2479,2479,2002,2036,0,'[]','[]',250,2250,1500,2250,200,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,1,0,'[]',1,'0',0,0,2,0,0),(600024,'白袍杀手',6,0,1,'普通重铸副本第2波',0,1,0,0,1,202036,'1.4','0',0,0,0,202036,0,'0',375,1,6073,1468716,33363,26402,2845,2845,2278,2316,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600025,'白袍杀手',6,0,1,'普通重铸副本第2波',0,1,0,0,1,202036,'1.4','0',0,0,0,202036,0,'0',375,1,6073,1468716,33363,26402,2845,2845,2278,2316,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600026,'白袍杀手',6,0,1,'普通重铸副本第2波',0,1,0,0,1,202036,'1.4','0',0,0,0,202036,0,'0',375,1,6073,1468716,33363,26402,2845,2845,2278,2316,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600027,'火鸡骑士',6,0,1,'普通重铸副本第3波',0,1,0,0,1,202034,'1.4','0',0,0,0,202034,0,'0',375,1,7557,1923823,35352,28687,3212,3212,2554,2597,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600028,'火鸡骑士',6,0,1,'普通重铸副本第3波',0,1,0,0,1,202034,'1.4','0',0,0,0,202034,0,'0',375,1,7557,1923823,35352,28687,3212,3212,2554,2597,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600029,'火鸡骑士',6,0,1,'普通重铸副本第3波',0,1,0,0,1,202034,'1.4','0',0,0,0,202034,0,'0',375,1,7557,1923823,35352,28687,3212,3212,2554,2597,0,'[]','[]',250,2250,1500,2250,200,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,1,0,'[]',1,'0',0,0,2,0,0),(600030,'机械魔犬',6,0,1,'普通重铸副本第4波',0,1,0,0,1,202016,'1.4','0',0,0,0,202016,0,'0',375,1,7633,2338748,36346,29829,3395,3395,2692,2737,0,'[]','[]',250,2250,1500,2250,200,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,1,0,'[]',1,'0',0,0,2,0,0),(600031,'机械魔犬',6,0,1,'普通重铸副本第4波',0,1,0,0,1,202016,'1.4','0',0,0,0,202016,0,'0',375,1,7633,2338748,36346,29829,3395,3395,2692,2737,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600032,'机械魔犬',6,0,1,'普通重铸副本第4波',0,1,0,0,1,202016,'1.4','0',0,0,0,202016,0,'0',375,1,7633,2338748,36346,29829,3395,3395,2692,2737,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600033,'金属魔卫',6,0,1,'普通重铸副本第5波',0,1,0,0,1,202035,'1.4','0',0,0,0,202035,0,'0',375,1,7956,2842203,38185,31525,3745,3745,2868,2928,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600034,'金属魔卫',6,0,1,'普通重铸副本第5波',0,1,0,0,1,202035,'1.4','0',0,0,0,202035,0,'0',375,1,7956,2842203,38185,31525,3745,3745,2868,2928,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600035,'金属魔卫',6,0,1,'普通重铸副本第5波',0,1,0,0,1,202035,'1.4','0',0,0,0,202035,0,'0',375,1,7956,2842203,38185,31525,3745,3745,2868,2928,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600036,'机械泰坦',6,0,1,'普通重铸副本第6波',0,1,0,0,1,203008,'1.3','0',0,0,0,203008,0,'0',375,1,41425,5488064,39105,32372,3919,3919,2956,3024,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600037,'机械泰坦',6,0,1,'普通重铸副本第6波',0,1,0,0,1,203008,'1.3','0',0,0,0,203008,0,'0',375,1,41425,5488064,39105,32372,3919,3919,2956,3024,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600038,'机械泰坦',6,0,1,'普通重铸副本第6波',0,1,0,0,1,203008,'1.3','0',0,0,0,203008,0,'0',375,1,41425,5488064,39105,32372,3919,3919,2956,3024,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600039,'雅典娜',0,0,1,'普通重铸副本水晶',0,1,0,0,0,601001,'1.5','0',0,0,0,601001,0,'0',375,1,100,4618380,41316,48478,5857,5857,4280,4120,0,'[]','[]',0,2250,1500,2250,200,'[]',0,1000,0,0,0,0,0,0,0,0,1,1,1,0,'[]',1,'0',0,0,0,0,0),(600041,'骷髅勇士',6,0,1,'困难重铸副本第1波',0,1,0,0,1,202002,'1.4','0',0,0,0,202002,0,'0',420,1,5598,1505795,40024,33220,4094,4094,3045,3120,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600042,'骷髅勇士',6,0,1,'困难重铸副本第1波',0,1,0,0,1,202002,'1.4','0',0,0,0,202002,0,'0',420,1,5598,1505795,40024,33220,4094,4094,3045,3120,0,'[]','[]',250,2250,1500,2250,200,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,1,0,'[]',1,'0',0,0,2,0,0),(600043,'骷髅勇士',6,0,1,'困难重铸副本第1波',0,1,0,0,1,202002,'1.4','0',0,0,0,202002,0,'0',420,1,5598,1505795,40024,33220,4094,4094,3045,3120,0,'[]','[]',250,2250,1500,2250,200,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,1,0,'[]',1,'0',0,0,2,0,0),(600044,'白袍杀手',6,0,1,'困难重铸副本第2波',0,1,0,0,1,202036,'1.4','0',0,0,0,202036,0,'0',420,1,7855,1987970,41863,34916,4444,4444,3221,3312,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600045,'白袍杀手',6,0,1,'困难重铸副本第2波',0,1,0,0,1,202036,'1.4','0',0,0,0,202036,0,'0',420,1,7855,1987970,41863,34916,4444,4444,3221,3312,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600046,'白袍杀手',6,0,1,'困难重铸副本第2波',0,1,0,0,1,202036,'1.4','0',0,0,0,202036,0,'0',420,1,7855,1987970,41863,34916,4444,4444,3221,3312,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600047,'火鸡骑士',6,0,1,'困难重铸副本第3波',0,1,0,0,1,202034,'1.4','0',0,0,0,202034,0,'0',420,1,9621,2512430,43702,36611,4793,4793,3397,3503,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600048,'火鸡骑士',6,0,1,'困难重铸副本第3波',0,1,0,0,1,202034,'1.4','0',0,0,0,202034,0,'0',420,1,9621,2512430,43702,36611,4793,4793,3397,3503,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600049,'火鸡骑士',6,0,1,'困难重铸副本第3波',0,1,0,0,1,202034,'1.4','0',0,0,0,202034,0,'0',420,1,9621,2512430,43702,36611,4793,4793,3397,3503,0,'[]','[]',250,2250,1500,2250,200,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,1,0,'[]',1,'0',0,0,2,0,0),(600050,'机械魔犬',6,0,1,'困难重铸副本第4波',0,1,0,0,1,202016,'1.4','0',0,0,0,202016,0,'0',420,1,9870,3078942,45541,38307,5142,5142,3573,3695,0,'[]','[]',250,2250,1500,2250,200,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,1,0,'[]',1,'0',0,0,2,0,0),(600051,'机械魔犬',6,0,1,'困难重铸副本第4波',0,1,0,0,1,202016,'1.4','0',0,0,0,202016,0,'0',420,1,9870,3078942,45541,38307,5142,5142,3573,3695,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600052,'机械魔犬',6,0,1,'困难重铸副本第4波',0,1,0,0,1,202016,'1.4','0',0,0,0,202016,0,'0',420,1,9870,3078942,45541,38307,5142,5142,3573,3695,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600053,'金属魔卫',6,0,1,'困难重铸副本第5波',0,1,0,0,1,202035,'1.4','0',0,0,0,202035,0,'0',420,1,10363,3775266,48285,40898,5654,5654,3955,4100,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600054,'金属魔卫',6,0,1,'困难重铸副本第5波',0,1,0,0,1,202035,'1.4','0',0,0,0,202035,0,'0',420,1,10363,3775266,48285,40898,5654,5654,3955,4100,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600055,'金属魔卫',6,0,1,'困难重铸副本第5波',0,1,0,0,1,202035,'1.4','0',0,0,0,202035,0,'0',420,1,10363,3775266,48285,40898,5654,5654,3955,4100,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600056,'机械泰坦',6,0,1,'困难重铸副本第6波',0,1,0,0,1,203008,'1.3','0',0,0,0,203008,0,'0',420,1,55787,7559587,51029,43490,6165,6165,4337,4505,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600057,'机械泰坦',6,0,1,'困难重铸副本第6波',0,1,0,0,1,203008,'1.3','0',0,0,0,203008,0,'0',420,1,55787,7559587,51029,43490,6165,6165,4337,4505,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600058,'机械泰坦',6,0,1,'困难重铸副本第6波',0,1,0,0,1,203008,'1.3','0',0,0,0,203008,0,'0',420,1,55787,7559587,51029,43490,6165,6165,4337,4505,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600059,'雅典娜',0,0,1,'困难重铸副本水晶',0,1,0,0,0,601001,'1.5','0',0,0,0,601001,0,'0',420,1,100,4618380,41316,48478,5857,5857,4280,4120,0,'[]','[]',0,2250,1500,2250,200,'[]',0,1000,0,0,0,0,0,0,0,0,1,1,1,0,'[]',1,'0',0,0,0,0,0),(600061,'骷髅勇士',6,0,1,'噩梦重铸副本第1波',0,1,0,0,1,202002,'1.4','0',0,0,0,202002,0,'0',540,1,10648,2998502,71735,63120,11857,11857,8023,8308,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600062,'骷髅勇士',6,0,1,'噩梦重铸副本第1波',0,1,0,0,1,202002,'1.4','0',0,0,0,202002,0,'0',540,1,10648,2998502,71735,63120,11857,11857,8023,8308,0,'[]','[]',250,2250,1500,2250,200,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,1,0,'[]',1,'0',0,0,2,0,0),(600063,'骷髅勇士',6,0,1,'噩梦重铸副本第1波',0,1,0,0,1,202002,'1.4','0',0,0,0,202002,0,'0',540,1,10648,2998502,71735,63120,11857,11857,8023,8308,0,'[]','[]',250,2250,1500,2250,200,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,1,0,'[]',1,'0',0,0,2,0,0),(600064,'白袍杀手',6,0,1,'噩梦重铸副本第2波',0,1,0,0,1,202036,'1.4','0',0,0,0,202036,0,'0',540,1,14868,3934780,74853,66084,12896,12896,8658,8955,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600065,'白袍杀手',6,0,1,'噩梦重铸副本第2波',0,1,0,0,1,202036,'1.4','0',0,0,0,202036,0,'0',540,1,14868,3934780,74853,66084,12896,12896,8658,8955,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600066,'白袍杀手',6,0,1,'噩梦重铸副本第2波',0,1,0,0,1,202036,'1.4','0',0,0,0,202036,0,'0',540,1,14868,3934780,74853,66084,12896,12896,8658,8955,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600067,'火鸡骑士',6,0,1,'噩梦重铸副本第3波',0,1,0,0,1,202034,'1.4','0',0,0,0,202034,0,'0',540,1,18185,4961227,78199,69284,13653,13653,9059,9344,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600068,'火鸡骑士',6,0,1,'噩梦重铸副本第3波',0,1,0,0,1,202034,'1.4','0',0,0,0,202034,0,'0',540,1,18185,4961227,78199,69284,13653,13653,9059,9344,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600069,'火鸡骑士',6,0,1,'噩梦重铸副本第3波',0,1,0,0,1,202034,'1.4','0',0,0,0,202034,0,'0',540,1,18185,4961227,78199,69284,13653,13653,9059,9344,0,'[]','[]',250,2250,1500,2250,200,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,1,0,'[]',1,'0',0,0,2,0,0),(600070,'机械魔犬',6,0,1,'噩梦重铸副本第4波',0,1,0,0,1,202016,'1.4','0',0,0,0,202016,0,'0',540,1,18634,6067410,81545,72484,14409,14409,9459,9734,0,'[]','[]',250,2250,1500,2250,200,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,1,0,'[]',1,'0',0,0,2,0,0),(600071,'机械魔犬',6,0,1,'噩梦重铸副本第4波',0,1,0,0,1,202016,'1.4','0',0,0,0,202016,0,'0',540,1,18634,6067410,81545,72484,14409,14409,9459,9734,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600072,'机械魔犬',6,0,1,'噩梦重铸副本第4波',0,1,0,0,1,202016,'1.4','0',0,0,0,202016,0,'0',540,1,18634,6067410,81545,72484,14409,14409,9459,9734,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600073,'金属魔卫',6,0,1,'噩梦重铸副本第5波',0,1,0,0,1,202035,'1.4','0',0,0,0,202035,0,'0',540,1,19150,7253243,84891,75684,15165,15165,9859,10123,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600074,'金属魔卫',6,0,1,'噩梦重铸副本第5波',0,1,0,0,1,202035,'1.4','0',0,0,0,202035,0,'0',540,1,19150,7253243,84891,75684,15165,15165,9859,10123,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600075,'金属魔卫',6,0,1,'噩梦重铸副本第5波',0,1,0,0,1,202035,'1.4','0',0,0,0,202035,0,'0',540,1,19150,7253243,84891,75684,15165,15165,9859,10123,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600076,'机械泰坦',6,0,1,'噩梦重铸副本第6波',0,1,0,0,1,203008,'1.3','0',0,0,0,203008,0,'0',540,1,101112,14197717,88237,78884,15922,15922,10260,10513,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600077,'机械泰坦',6,0,1,'噩梦重铸副本第6波',0,1,0,0,1,203008,'1.3','0',0,0,0,203008,0,'0',540,1,101112,14197717,88237,78884,15922,15922,10260,10513,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600078,'机械泰坦',6,0,1,'噩梦重铸副本第6波',0,1,0,0,1,203008,'1.3','0',0,0,0,203008,0,'0',540,1,101112,14197717,88237,78884,15922,15922,10260,10513,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600079,'雅典娜',0,0,1,'噩梦重铸副本水晶',0,1,0,0,0,601001,'1.5','0',0,0,0,601001,0,'0',540,1,100,8545560,74940,83825,15126,15126,9987,9747,0,'[]','[]',0,2250,1500,2250,200,'[]',0,1000,0,0,0,0,0,0,0,0,1,1,1,0,'[]',1,'0',0,0,0,0,0),(600081,'骷髅勇士',6,0,1,'炼狱重铸副本第1波',0,1,0,0,1,202002,'1.4','0',0,0,0,202002,0,'0',630,1,15631,4474791,103447,93506,19420,19420,12727,12909,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600082,'骷髅勇士',6,0,1,'炼狱重铸副本第1波',0,1,0,0,1,202002,'1.4','0',0,0,0,202002,0,'0',630,1,15631,4474791,103447,93506,19420,19420,12727,12909,0,'[]','[]',250,2250,1500,2250,200,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,1,0,'[]',1,'0',0,0,2,0,0),(600083,'骷髅勇士',6,0,1,'炼狱重铸副本第1波',0,1,0,0,1,202002,'1.4','0',0,0,0,202002,0,'0',630,1,15631,4474791,103447,93506,19420,19420,12727,12909,0,'[]','[]',250,2250,1500,2250,200,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,1,0,'[]',1,'0',0,0,2,0,0),(600084,'白袍杀手',6,0,1,'炼狱重铸副本第2波',0,1,0,0,1,202036,'1.4','0',0,0,0,202036,0,'0',630,1,21635,5813836,107402,97313,20335,20335,13416,13577,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600085,'白袍杀手',6,0,1,'炼狱重铸副本第2波',0,1,0,0,1,202036,'1.4','0',0,0,0,202036,0,'0',630,1,21635,5813836,107402,97313,20335,20335,13416,13577,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600086,'白袍杀手',6,0,1,'炼狱重铸副本第2波',0,1,0,0,1,202036,'1.4','0',0,0,0,202036,0,'0',630,1,21635,5813836,107402,97313,20335,20335,13416,13577,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600087,'火鸡骑士',6,0,1,'炼狱重铸副本第3波',0,1,0,0,1,202034,'1.4','0',0,0,0,202034,0,'0',630,1,26166,7240703,111357,101121,21249,21249,14106,14246,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600088,'火鸡骑士',6,0,1,'炼狱重铸副本第3波',0,1,0,0,1,202034,'1.4','0',0,0,0,202034,0,'0',630,1,26166,7240703,111357,101121,21249,21249,14106,14246,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600089,'火鸡骑士',6,0,1,'炼狱重铸副本第3波',0,1,0,0,1,202034,'1.4','0',0,0,0,202034,0,'0',630,1,26166,7240703,111357,101121,21249,21249,14106,14246,0,'[]','[]',250,2250,1500,2250,200,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,1,0,'[]',1,'0',0,0,2,0,0),(600090,'机械魔犬',6,0,1,'炼狱重铸副本第4波',0,1,0,0,1,202016,'1.4','0',0,0,0,202016,0,'0',630,1,26745,8832600,115457,105085,22081,22081,14501,14645,0,'[]','[]',250,2250,1500,2250,200,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,1,0,'[]',1,'0',0,0,2,0,0),(600091,'机械魔犬',6,0,1,'炼狱重铸副本第4波',0,1,0,0,1,202016,'1.4','0',0,0,0,202016,0,'0',630,1,26745,8832600,115457,105085,22081,22081,14501,14645,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600092,'机械魔犬',6,0,1,'炼狱重铸副本第4波',0,1,0,0,1,202016,'1.4','0',0,0,0,202016,0,'0',630,1,26745,8832600,115457,105085,22081,22081,14501,14645,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600093,'金属魔卫',6,0,1,'炼狱重铸副本第5波',0,1,0,0,1,202035,'1.4','0',0,0,0,202035,0,'0',630,1,27423,10534198,119556,109050,22913,22913,14897,15045,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600094,'金属魔卫',6,0,1,'炼狱重铸副本第5波',0,1,0,0,1,202035,'1.4','0',0,0,0,202035,0,'0',630,1,27423,10534198,119556,109050,22913,22913,14897,15045,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600095,'金属魔卫',6,0,1,'炼狱重铸副本第5波',0,1,0,0,1,202035,'1.4','0',0,0,0,202035,0,'0',630,1,27423,10534198,119556,109050,22913,22913,14897,15045,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600096,'机械泰坦',6,0,1,'炼狱重铸副本第6波',0,1,0,0,1,203008,'1.3','0',0,0,0,203008,0,'0',630,1,144487,20576130,123655,113014,23745,23745,15293,15444,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600097,'机械泰坦',6,0,1,'炼狱重铸副本第6波',0,1,0,0,1,203008,'1.3','0',0,0,0,203008,0,'0',630,1,144487,20576130,123655,113014,23745,23745,15293,15444,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600098,'机械泰坦',6,0,1,'炼狱重铸副本第6波',0,1,0,0,1,203008,'1.3','0',0,0,0,203008,0,'0',630,1,144487,20576130,123655,113014,23745,23745,15293,15444,0,'[]','[]',150,2250,1500,2250,200,'[{1110000001,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(600099,'雅典娜',0,0,1,'炼狱重铸副本水晶',0,1,0,0,0,601001,'1.5','0',0,0,0,601001,0,'0',630,1,100,12251430,107363,117472,22558,22558,14672,14528,0,'[]','[]',0,2250,1500,2250,200,'[]',0,1000,0,0,0,0,0,0,0,0,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1002001,'恶魔化身',0,6,1,'新手主线副本1【新手】Lv41任务id：10410勉为其难BOSS',0,4,0,0,0,203018,'1.3','0',0,0,0,203018,0,'0',41,8,214,17075,219,195,93,1,1,1,16,'[]','[]',600,2250,1500,2250,150,'[{2000201801,1},{20005455,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(1002002,'经验馆主',2,7,0,'1002副本展示怪',0,7,0,0,0,503001,'2','0',0,0,0,503001,0,'3||帅帅的冒险者你会救我吗:50||我会好好报答您的:50',41,1,1,10000000,0,0,0,0,0,0,0,'[]','[1]',0,0,0,500,0,'[{1110000003,1}]',500,0,0,0,100,0,0,0,0,0,0,0,0,0,'[1,1]',1,'0',0,0,0,0,0),(1003000,'色欲',0,6,1,'新手主线副本2【新手】Lv68任务id：10670主线副本2BOSS',0,4,0,0,2,203016,'1.1','0',0,0,0,203016,0,'0',64,13,540,50000,543,760,120,1,1,1,16,'[]','[]',500,2250,1500,2250,150,'[{202030161,1},{202030162,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1003001,'副本原石',10,0,0,'装备副本机关怪',0,3,0,0,0,2040012,'1','0',0,0,0,2040012,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,1,0,0,0,3,1,0,0,1,0,0,'[]',1,'0',1,0,0,0,0),(1200999,'墓碑',0,3,0,'原罪祭坛墓碑模型',0,3,0,0,0,5020021,'1','0',0,0,0,5020021,0,'0',999,1,0,0,0,0,0,0,0,0,0,'[]','[3,0,3000]',250,2250,1500,2250,150,'[{1110000001,1}]',0,2000,0,1,0,0,0,0,0,0,0,0,0,0,'[]',1,'0',0,0,0,0,0),(1201000,'暴走一哥',6,0,1,'新手引导原罪祭坛npc1',1,6,0,0,0,101000,'1','0',101000,101000,0,101000,0,'5||大佬别抢，这只给我吧:50||伤害第一才能拿掉落哦:30',94,1,188,20000,0,320,220,200,0,0,0,'[]','[3]',500,2000,3000,3000,450,'[{10011001,1},{10011002,1},{10011003,1},{10011004,1},{10011011,1},{10011021,1},{10011031,1},{10011041,1}]',5000,0,0,0,0,0,0,0,0,1,1,1,0,0,'[1,30000]',1,'0',0,0,0,0,0),(1201001,'真香警告',6,0,1,'新手引导原罪祭坛npc2',2,6,0,0,0,102000,'1','0',102000,102000,0,102000,0,'5||别抢，再抢我喊公会人帮忙了:50',95,1,166,16000,0,320,300,200,0,0,0,'[]','[3]',350,2000,3000,3000,450,'[{10012001,1},{10012002,1},{10012003,1},{10012004,1},{10012005,1},{10012011,1},{10012021,1},{10012031,1},{10012041,1}]',5000,0,0,0,0,0,0,0,0,1,1,1,0,0,'[1,30000]',1,'0',0,0,0,0,0),(1202000,'半人马艾奏',0,3,1,'原罪祭坛引导',0,3,0,0,0,203002,'1.5','0',0,0,0,203002,0,'',90,18,409,67660,693,877,120,1,1,1,0,'[]','[]',600,2250,1500,2250,300,'[{200022011,1},{200022014,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1202001,'半人马',0,3,0,'原罪祭坛1层1号Lv90掉落3阶装备',0,3,0,0,0,203002,'1.5','0',0,0,0,203002,0,'',94,50,459,357242,693,877,120,125,34,33,0,'[]','[3,459,3000]',600,2250,1500,2250,300,'[{200022011,1},{200022014,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1202002,'半人马',0,3,0,'原罪祭坛1层2号和平Lv90掉落3阶装备',0,3,0,0,0,203002,'1.5','0',0,0,0,203002,0,'',94,50,483,372127,693,877,120,125,34,33,0,'[]','[3,372127,3000]',600,2250,1500,2250,300,'[{200022011,1},{200022014,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1202003,'食人花',0,3,0,'原罪祭坛1层3号Lv135掉落4阶装备',0,3,0,0,0,203001,'1.3','0',0,0,0,203001,0,'0',135,100,525,1228226,864,1151,101,111,37,38,0,'[]','[3,1228226,3000]',600,2250,1500,2250,300,'[{202030011,1},{202030012,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1202004,'食人花',0,3,0,'原罪祭坛1层4号和平Lv135掉落4阶装备',0,3,0,0,0,203001,'1.3','0',0,0,0,203001,0,'0',135,100,501,1473871,864,1151,101,111,37,38,0,'[]','[3,1473871,3000]',600,2250,1500,2250,300,'[{202030011,1},{202030012,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1202005,'冰霜泰坦',0,3,0,'原罪祭坛1层5号Lv150掉落4阶装备',0,3,0,0,0,203003,'1.3','0',0,0,0,203003,0,'0',150,100,485,1765866,1057,1530,58,75,29,33,0,'[]','[3,1765866,3000]',600,2250,1500,2250,300,'[{202030031,1},{202030032,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1202006,'冰霜泰坦',0,3,0,'原罪祭坛1层6号和平Lv150掉落4阶装备',0,3,0,0,0,203003,'1.3','0',0,0,0,203003,0,'0',150,100,464,2018133,1057,1530,58,75,29,33,0,'[]','[3,2018133,3000]',600,2250,1500,2250,300,'[{202030031,1},{202030032,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1202007,'冰霜巨龙',0,3,0,'原罪祭坛1层7号Lv165掉落4阶装备',0,3,0,0,0,203004,'1.3','0',0,0,0,203004,0,'0',165,100,442,2694972,1242,1722,58,75,29,33,0,'[]','[3,2694972,3000]',600,2250,1500,2250,300,'[{202030041,1},{202030043,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1202008,'冰霜巨龙',0,3,0,'原罪祭坛1层8号和平Lv165掉落4阶装备',0,3,0,0,0,203004,'1.3','0',0,0,0,203004,0,'0',165,100,442,2694972,1242,1722,58,75,29,33,0,'[]','[3,2694972,3000]',600,2250,1500,2250,300,'[{202030041,1},{202030043,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1202009,'阿努比斯',0,3,0,'原罪祭坛1层9号Lv190掉落5阶装备',0,3,0,0,0,203005,'1.3','0',0,0,0,203005,0,'0',190,100,904,3423662,3654,2051,106,106,58,69,0,'[]','[3,3423662,3000]',600,2250,1500,2250,300,'[{202030051,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1202010,'阿努比斯',0,3,0,'原罪祭坛1层10号和平Lv190掉落5阶装备',0,3,0,0,0,203005,'1.3','0',0,0,0,203005,0,'0',190,100,744,6847323,3654,2051,106,106,58,69,0,'[]','[3,5135492,3000]',600,2250,1500,2250,300,'[{202030051,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1202011,'美杜莎',0,3,0,'原罪祭坛1层11号Lv195掉落5阶装备',0,3,0,0,0,203006,'1.3','0',0,0,0,203006,0,'0',195,100,1083,7632679,3964,2250,113,113,78,90,0,'[]','[3,5724509,3000]',600,2250,1500,2250,300,'[{2000230101,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1202012,'美杜莎',0,3,0,'原罪祭坛1层12号和平Lv195掉落5阶装备',0,3,0,0,0,203006,'1.3','0',0,0,0,203006,0,'0',195,100,1271,7632679,3964,2250,113,113,78,90,0,'[]','[3,5724509,3000]',600,2250,1500,2250,300,'[{2000230101,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1202013,'暗裔恶魔',0,3,0,'原罪祭坛1层13号Lv200掉落5阶装备',0,3,0,0,0,203007,'1.3','0',0,0,0,203007,0,'0',200,100,1575,8419117,4274,2449,120,120,98,110,0,'[]','[3,6314338,3000]',600,2250,1500,2250,300,'[{2000230301,1},{2000230303,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1202014,'暗裔恶魔',0,3,0,'原罪祭坛1层14号和平Lv200掉落5阶装备',0,3,0,0,0,203007,'1.3','0',0,0,0,203007,0,'0',200,100,1575,8419117,4274,2449,120,120,98,110,0,'[]','[3,7366728,3000]',600,2250,1500,2250,300,'[{2000230301,1},{2000230303,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1202015,'质量检测员',0,3,0,'原罪祭坛1层15号Lv235掉落6阶装备',0,3,0,0,0,203008,'1.3','0',0,0,0,203008,0,'0',235,100,2504,18971667,7030,4272,212,212,275,293,0,'[]','[3,13280167,3000]',600,2250,1500,2250,300,'[{202030081,1},{202030082,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1202016,'质量检测员',0,3,0,'原罪祭坛1层16号和平Lv235掉落6阶装备',0,3,0,0,0,203008,'1.3','0',0,0,0,203008,0,'0',235,100,2504,18971667,7030,4272,212,212,275,293,0,'[]','[3,13280167,3000]',600,2250,1500,2250,300,'[{202030081,1},{202030082,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1203001,'海龙王',0,3,0,'原罪祭坛2层17号Lv240掉落6阶装备',0,3,0,0,0,203009,'1.3','0',0,0,0,203009,0,'0',240,100,2794,21510747,7923,4902,262,262,332,353,0,'[]','[3,15057523,3000]',600,2250,1500,2250,300,'[{202030091,1},{202030092,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1203002,'海龙王',0,3,0,'原罪祭坛2层18号和平Lv240掉落6阶装备',0,3,0,0,0,203009,'1.3','0',0,0,0,203009,0,'0',240,100,2794,21510747,7923,4902,262,262,332,353,0,'[]','[3,15057523,3000]',600,2250,1500,2250,300,'[{202030091,1},{202030092,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1203003,'暗裔猎手',0,3,0,'原罪祭坛2层19号Lv245掉落6阶装备',0,3,0,0,0,203010,'1.3','0',0,0,0,203010,0,'0',245,100,3086,24062983,8816,5531,313,313,388,413,0,'[]','[3,16844088,3000]',600,2250,1500,2250,300,'[{202030101,1},{202030102,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1203004,'暗裔猎手',0,3,0,'原罪祭坛2层20号和平Lv245掉落6阶装备',0,3,0,0,0,203010,'1.3','0',0,0,0,203010,0,'0',245,100,3086,24062983,8816,5531,313,313,388,413,0,'[]','[3,19250387,3000]',600,2250,1500,2250,300,'[{202030101,1},{202030102,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1203005,'蜘蛛女皇',0,3,0,'原罪祭坛2层21号Lv250掉落6阶装备',0,3,0,0,0,203011,'1.3','0',0,0,0,203011,0,'0',250,100,4094,26621983,9710,6161,363,363,445,472,0,'[]','[3,21297586,3000]',600,2250,1500,2250,300,'[{200022021,1},{200022022,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1203006,'蜘蛛女皇',0,3,0,'原罪祭坛2层22号和平Lv250掉落6阶装备',0,3,0,0,0,203011,'1.3','0',0,0,0,203011,0,'0',250,100,4094,26621983,9710,6161,363,363,445,472,0,'[]','[3,21297586,3000]',600,2250,1500,2250,300,'[{200022021,1},{200022022,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1203007,'愤怒',0,3,0,'原罪祭坛2层23号Lv255掉落6阶装备',0,3,0,0,0,203012,'1.3','0',0,0,0,203012,0,'0',255,100,4441,28504904,10514,6558,409,409,501,527,0,'[]','[3,22803923,3000]',600,2250,1500,2250,300,'[{202030121,1},{202030122,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1203008,'愤怒',0,3,0,'原罪祭坛2层24号和平Lv255掉落6阶装备',0,3,0,0,0,203012,'1.3','0',0,0,0,203012,0,'0',255,100,4441,28504904,10514,6558,409,409,501,527,0,'[]','[3,22803923,3000]',600,2250,1500,2250,300,'[{202030121,1},{202030122,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1203009,'怠惰',0,3,0,'原罪祭坛2层25号Lv280掉落7阶装备',0,3,0,0,0,203013,'1.3','0',0,0,0,203013,0,'0',280,100,6102,45531796,14536,8544,637,637,780,800,0,'[]','[3,30354530,3000]',600,2250,1500,2250,300,'[{202030131,1},{202030132,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1203010,'怠惰',0,3,0,'原罪祭坛2层26号和平Lv280掉落7阶装备',0,3,0,0,0,203013,'1.3','0',0,0,0,203013,0,'0',280,100,6102,45531796,14536,8544,637,637,780,800,0,'[]','[3,30354530,3000]',600,2250,1500,2250,300,'[{202030131,1},{202030132,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1203011,'嫉妒',0,3,0,'原罪祭坛2层27号Lv290掉落7阶装备',0,3,0,0,0,203014,'1.3','0',0,0,0,203014,0,'0',290,100,6797,50073386,16145,9338,728,728,892,909,0,'[]','[3,33382257,3000]',600,2250,1500,2250,300,'[{202030141,1},{202030142,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1203012,'嫉妒',0,3,0,'原罪祭坛2层28号和平Lv290掉落7阶装备',0,3,0,0,0,203014,'1.3','0',0,0,0,203014,0,'0',290,100,6797,50073386,16145,9338,728,728,892,909,0,'[]','[3,33382257,3000]',600,2250,1500,2250,300,'[{202030141,1},{202030142,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1203013,'暴食',0,3,0,'原罪祭坛2层29号Lv300掉落7阶装备',0,3,0,0,0,203015,'1.3','0',0,0,0,203015,0,'0',300,100,7493,54613431,17754,10133,819,819,1004,1018,0,'[]','[3,36408954,3000]',600,2250,1500,2250,300,'[{202030151,1},{202030152,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1203014,'色欲',0,3,0,'原罪祭坛2层30号Lv310掉落7阶装备',0,3,0,0,0,203016,'1.3','0',0,0,0,203016,0,'0',310,100,8297,62659612,19483,11787,967,967,1066,1082,0,'[]','[3,52216344,3000]',600,2250,1500,2250,300,'[{202030161,1},{202030162,1}]',0,2000,1,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1204001,'寒冰女神',0,3,0,'原罪祭坛3层31号Lv320掉落7阶装备',0,3,0,0,0,203017,'1.3','0',0,0,0,203017,0,'0',320,100,9102,70735032,21213,13442,1116,1116,1127,1145,0,'[]','[3,58945860,3000]',600,2250,1500,2250,300,'[{2000540201,1},{2000540208,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1204002,'死神',0,3,0,'原罪祭坛3层32号和平Lv320掉落7阶装备',0,3,0,0,0,203018,'1.3','0',0,0,0,203018,0,'0',320,100,9102,70735032,21213,13442,1116,1116,1127,1145,0,'[]','[3,58945860,3000]',600,2250,1500,2250,300,'[{2000201801,1},{20005455,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1204003,'迦楼罗',0,3,0,'原罪祭坛3层33号Lv345掉落8阶装备',0,3,0,0,0,203020,'1.3','0',0,0,0,203020,0,'0',345,100,10999,106200069,25537,17579,1488,1488,1280,1303,0,'[]','[3,75857192,3000]',600,2250,1500,2250,300,'[{202030201,1},{202030202,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1204004,'光明神',0,3,0,'原罪祭坛3层34号和平Lv350掉落8阶装备',0,3,0,0,0,203021,'1.3','0',0,0,0,203021,0,'0',350,100,11398,110952014,26401,18406,1562,1562,1311,1335,0,'[]','[3,79251438,3000]',600,2250,1500,2250,300,'[{2000202101,1},{200054200,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1204005,'月神',0,3,0,'原罪祭坛3层35号Lv355掉落8阶装备',0,3,0,0,0,203022,'1.3','0',0,0,0,203022,0,'0',355,100,11885,118322511,27396,19549,1745,1745,1449,1475,0,'[]','[3,84516079,3000]',600,2250,1500,2250,300,'[{2000540401,1},{2000540402,1},{2000540406,1},{2000540410,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1204006,'八岐大蛇',0,3,0,'原罪祭坛3层36号和平Lv355掉落8阶装备',0,3,0,0,0,203024,'1.3','0',0,0,0,203024,0,'0',355,100,11885,118322511,27396,19549,1745,1745,1449,1475,0,'[]','[3,84516079,3000]',600,2250,1500,2250,300,'[{2000230201,1},{2000230202,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1204007,'熔岩战神',0,3,0,'原罪祭坛3层37号Lv360掉落8阶装备',0,3,0,0,0,203025,'1.3','0',0,0,0,203025,0,'0',360,100,12372,125715134,28390,20691,1929,1929,1587,1615,0,'[]','[3,89796524,3000]',600,2250,1500,2250,300,'[{202030251,1},{202030252,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1204008,'巴哈姆特',0,3,0,'原罪祭坛3层38号和平Lv395掉落9阶装备',0,3,0,0,0,203026,'1.3','0',0,0,0,203026,0,'0',395,100,15651,203155675,35352,28687,3212,3212,2554,2597,0,'[]','[3,126972297,3000]',600,2250,1500,2250,300,'[{202030261,1},{202030262,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1204009,'色欲',0,3,0,'原罪祭坛3层39号Lv400掉落9阶装备',0,3,0,0,0,203016,'1.3','0',0,0,0,203016,0,'0',400,100,16134,211690094,36346,29829,3395,3395,2692,2737,0,'[]','[3,132306309,3000]',600,2250,1500,2250,300,'[{202030161,1},{202030162,1}]',0,2000,1,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1204010,'海龙王',0,3,0,'原罪祭坛3层40号Lv405掉落9阶装备',0,3,0,0,0,203009,'1.3','0',0,0,0,203009,0,'0',405,100,16603,218396950,37266,30677,3570,3570,2780,2833,0,'[]','[3,136498094,3000]',600,2250,1500,2250,300,'[{202030091,1},{202030092,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1204011,'暗裔猎手',0,3,0,'原罪祭坛3层41号Lv410掉落9阶装备',0,3,0,0,0,203010,'1.3','0',0,0,0,203010,0,'0',410,100,17073,225102492,38185,31525,3745,3745,2868,2928,0,'[]','[3,140689058,3000]',600,2250,1500,2250,300,'[{202030101,1},{202030102,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1204012,'蜘蛛女皇',0,3,0,'原罪祭坛3层42号和平Lv415掉落9阶装备',0,3,0,0,0,203011,'1.3','0',0,0,0,203011,0,'0',415,100,17541,231815841,39105,32372,3919,3919,2956,3024,0,'[]','[3,144884901,3000]',600,2250,1500,2250,300,'[{200022021,1},{200022022,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1204013,'愤怒',0,3,0,'原罪祭坛3层43号Lv445掉落10阶装备',0,3,0,0,0,203012,'1.3','0',0,0,0,203012,0,'0',445,100,20348,272001958,44622,37459,4968,4968,3485,3599,0,'[]','[3,170001224,3000]',600,2250,1500,2250,300,'[{202030121,1},{202030122,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1204014,'暗裔恶魔',0,3,0,'原罪祭坛3层44号Lv450掉落10阶装备',0,3,0,0,0,203007,'1.3','0',0,0,0,203007,0,'0',450,100,20815,278688232,45541,38307,5142,5142,3573,3695,0,'[]','[3,174180145,3000]',600,2250,1500,2250,300,'[{2000230301,1},{2000230303,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1205001,'蜘蛛女皇',0,3,0,'原罪祭坛4层45号Lv455掉落10阶装备',0,3,0,0,0,203011,'1.3','0',0,0,0,203011,0,'0',455,100,21502,288837642,46913,39603,5398,5398,3764,3897,0,'[]','[3,180523526,3000]',600,2250,1500,2250,300,'[{200022021,1},{200022022,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1205002,'愤怒',0,3,0,'原罪祭坛4层46号Lv460掉落10阶装备',0,3,0,0,0,203012,'1.3','0',0,0,0,203012,0,'0',460,100,22190,299001059,48285,40898,5654,5654,3955,4100,0,'[]','[3,186875662,3000]',600,2250,1500,2250,300,'[{202030121,1},{202030122,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1205003,'怠惰',0,3,0,'原罪祭坛4层47号Lv500掉落11阶装备',0,3,0,0,0,203013,'1.3','0',0,0,0,203013,0,'0',500,100,27692,380299779,59260,51265,7700,7700,5483,5720,0,'[]','[3,237687362,3000]',600,2250,1500,2250,300,'[{202030131,1},{202030132,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1205004,'嫉妒',0,3,0,'原罪祭坛4层48号Lv505掉落11阶装备',0,3,0,0,0,203014,'1.3','0',0,0,0,203014,0,'0',505,100,28495,392129129,60819,52747,8219,8219,5801,6043,0,'[]','[3,245080706,3000]',600,2250,1500,2250,300,'[{202030141,1},{202030142,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1205005,'暴食',0,3,0,'原罪祭坛4层49号Lv510掉落11阶装备',0,3,0,0,0,203015,'1.3','0',0,0,0,203015,0,'0',510,100,29298,403960329,62379,54229,8739,8739,6118,6367,0,'[]','[3,252475206,3000]',600,2250,1500,2250,300,'[{202030151,1},{202030152,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1205006,'色欲',0,3,0,'原罪祭坛4层50号Lv530掉落11阶装备',0,3,0,0,0,203016,'1.3','0',0,0,0,203016,0,'0',530,100,32508,451301893,68616,60156,10818,10818,7388,7661,0,'[]','[3,282063683,3000]',600,2250,1500,2250,300,'[{202030161,1},{202030162,1}]',0,2000,1,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1205007,'海龙王',0,3,0,'原罪祭坛4层51号Lv545掉落12阶装备',0,3,0,0,0,203009,'1.3','0',0,0,0,203009,0,'0',545,100,34913,486790223,73294,64602,12377,12377,8341,8631,0,'[]','[3,304243890,3000]',600,2250,1500,2250,300,'[{202030091,1},{202030092,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1205008,'暗裔猎手',0,3,0,'原罪祭坛4层52号Lv550掉落12阶装备',0,3,0,0,0,203010,'1.3','0',0,0,0,203010,0,'0',550,100,35715,498615298,74853,66084,12896,12896,8658,8955,0,'[]','[3,311634561,3000]',600,2250,1500,2250,300,'[{202030101,1},{202030102,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1206001,'寒冰女神',0,3,0,'原罪祭坛5层53号Lv560掉落12阶装备',0,3,0,0,0,203017,'1.3','0',0,0,0,203017,0,'0',560,100,37433,523905598,78199,69284,13653,13653,9059,9344,0,'[]','[3,327440999,3000]',600,2250,1500,2250,300,'[{2000540201,1},{2000540208,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1206002,'死神',0,3,0,'原罪祭坛5层54号Lv570掉落12阶装备',0,3,0,0,0,203018,'1.3','0',0,0,0,203018,0,'0',570,100,39150,549187243,81545,72484,14409,14409,9459,9734,0,'[]','[3,343242027,3000]',600,2250,1500,2250,300,'[{2000201801,1},{20005455,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1206003,'迦楼罗',0,3,0,'原罪祭坛5层55号Lv600掉落13阶装备',0,3,0,0,0,203020,'1.3','0',0,0,0,203020,0,'0',600,100,44290,624948786,91583,82084,16678,16678,10660,10902,0,'[]','[3,390592991,3000]',600,2250,1500,2250,300,'[{202030201,1},{202030202,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1206004,'光明神',0,3,0,'原罪祭坛5层56号Lv605掉落13阶装备',0,3,0,0,0,203021,'1.3','0',0,0,0,203021,0,'0',605,100,45242,638929658,93560,83988,17135,17135,11005,11237,0,'[]','[3,399331036,3000]',600,2250,1500,2250,300,'[{2000202101,1},{200054200,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1206005,'月神',0,3,0,'原罪祭坛5层57号Lv610掉落13阶装备',0,3,0,0,0,203022,'1.3','0',0,0,0,203022,0,'0',610,100,46193,652919663,95538,85891,17592,17592,11349,11571,0,'[]','[3,408074789,3000]',600,2250,1500,2250,300,'[{2000540401,1},{2000540402,1},{2000540406,1},{2000540410,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1206006,'八岐大蛇',0,3,0,'原罪祭坛5层58号Lv630掉落13阶装备',0,3,0,0,0,203024,'1.3','0',0,0,0,203024,0,'0',630,100,49996,708806817,103447,93506,19420,19420,12727,12909,0,'[]','[3,443004260,3000]',600,2250,1500,2250,300,'[{2000230201,1},{2000230202,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1206007,'熔岩战神',0,3,0,'原罪祭坛5层59号Lv650掉落14阶装备',0,3,0,0,0,203025,'1.3','0',0,0,0,203025,0,'0',650,100,53789,764618215,111357,101121,21249,21249,14106,14246,0,'[]','[3,477886385,3000]',600,2250,1500,2250,300,'[{202030251,1},{202030252,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1206008,'巴哈姆特',0,3,0,'原罪祭坛5层60号Lv655掉落14阶装备',0,3,0,0,0,203026,'1.3','0',0,0,0,203026,0,'0',655,100,54954,782048818,113407,103103,21665,21665,14303,14446,0,'[]','[3,488780511,3000]',600,2250,1500,2250,300,'[{202030261,1},{202030262,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1207001,'海龙王',0,3,0,'原罪祭坛6层61号Lv700掉落15阶装备',0,3,0,0,0,203009,'1.3','0',0,0,0,203009,0,'0',700,100,65415,938714199,131854,120943,25409,25409,16084,16242,0,'[]','[3,586696374,3000]',600,2250,1500,2250,300,'[{202030091,1},{202030092,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1207002,'暗裔猎手',0,3,0,'原罪祭坛6层62号Lv705掉落15阶装备',0,3,0,0,0,203010,'1.3','0',0,0,0,203010,0,'0',705,100,66474,954184824,134037,123053,25769,25769,16283,16425,0,'[]','[3,596365515,3000]',600,2250,1500,2250,300,'[{202030101,1},{202030102,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1207003,'蜘蛛女皇',0,3,0,'原罪祭坛6层63号Lv710掉落15阶装备',0,3,0,0,0,203011,'1.3','0',0,0,0,203011,0,'0',710,100,67532,969635200,136220,125164,26130,26130,16481,16607,0,'[]','[3,606022000,3000]',600,2250,1500,2250,300,'[{200022021,1},{200022022,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1207004,'愤怒',0,3,0,'原罪祭坛6层64号Lv745掉落16阶装备',0,3,0,0,0,203012,'1.3','0',0,0,0,203012,0,'0',745,100,74917,1077592626,151499,139939,28653,28653,17869,17885,0,'[]','[3,673495391,3000]',600,2250,1500,2250,300,'[{202030121,1},{202030122,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1207005,'怠惰',0,3,0,'原罪祭坛6层65号Lv750掉落16阶装备',0,3,0,0,0,203013,'1.3','0',0,0,0,203013,0,'0',750,100,75969,1092978145,153682,142050,29013,29013,18067,18067,0,'[]','[3,683111340,3000]',600,2250,1500,2250,300,'[{202030131,1},{202030132,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1207006,'嫉妒',0,3,0,'原罪祭坛6层66号Lv755掉落16阶装备',0,3,0,0,0,203014,'1.3','0',0,0,0,203014,0,'0',755,100,77124,1109825112,156206,144505,29378,29378,18441,18441,0,'[]','[3,693640695,3000]',600,2250,1500,2250,300,'[{202030141,1},{202030142,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1251001,'半人马',0,3,1,'首领会所1层Lv150击杀掉落5阶装备',0,3,0,0,0,203002,'1.3','0',0,0,0,203002,0,'0',200,100,909,3630744,4702,2694,132,132,108,121,0,'[]','[3,3157169,3000]',600,2250,1500,2250,300,'[{200022011,1},{200022014,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1251002,'死神',0,3,1,'首领会所1层Lv170击杀掉落5阶装备',0,3,0,0,0,203018,'1.3','0',0,0,0,203018,0,'0',205,100,967,5523902,5272,3045,146,146,136,151,0,'[]','[3,4603252,3000]',600,2250,1500,2250,300,'[{2000201801,1},{20005455,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1251003,'暗裔猎手',0,3,1,'首领会所1层Lv200击杀掉落6阶装备',0,3,0,0,0,203011,'1.3','0',0,0,0,203011,0,'0',250,100,4877,16638739,11652,7393,435,435,534,567,0,'[]','[3,13310991,3000]',600,2250,1500,2250,300,'[{200022021,1},{200022022,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1251004,'愤怒',0,3,1,'首领会所1层Lv250击杀掉落6阶装备',0,3,0,0,0,203012,'1.3','0',0,0,0,203012,0,'0',260,100,5966,19753499,14148,8694,568,568,696,727,0,'[]','[3,15194999,3000]',600,2250,1500,2250,300,'[{202030121,1},{202030122,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1251005,'八岐大蛇',0,3,1,'首领会所1层Lv300击杀掉落7阶装备',0,3,0,0,0,203024,'1.3','0',0,0,0,203024,0,'0',290,100,8945,28166280,20988,12140,946,946,1160,1182,0,'[]','[3,20863911,3000]',600,2250,1500,2250,300,'[{2000230201,1},{2000230202,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1251006,'冰霜巨龙',0,3,1,'首领会所1层Lv350击杀掉落7阶装备',0,3,0,0,0,203004,'1.3','0',0,0,0,203004,0,'0',310,100,11404,43861728,26302,15913,1306,1306,1438,1460,0,'[]','[3,31329806,3000]',600,2250,1500,2250,300,'[{202030041,1},{202030043,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1251007,'寒冰女神',0,3,1,'首领会所1层Lv400击杀掉落8阶装备',0,3,0,0,0,203017,'1.3','0',0,0,0,203017,0,'0',350,100,16469,71326295,36962,25769,2187,2187,1835,1869,0,'[]','[3,47550863,3000]',600,2250,1500,2250,300,'[{2000540201,1},{2000540208,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1252001,'八岐大蛇',0,3,1,'首领会所2层Lv450击杀掉落6阶装备',0,3,0,0,0,203024,'1.3','0',0,0,0,203024,0,'0',250,100,4915,15973189,11652,7393,435,435,534,567,0,'[]','[3,13310991,3000]',600,2250,1500,2250,300,'[{2000230201,1},{2000230202,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1252002,'巴哈姆特',0,3,1,'首领会所2层Lv200击杀掉落6阶装备',0,3,0,0,0,203026,'1.3','0',0,0,0,203026,0,'0',260,100,6013,21272999,14148,8694,568,568,696,727,0,'[]','[3,15194999,3000]',600,2250,1500,2250,300,'[{202030261,1},{202030262,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1252003,'冰霜泰坦',0,3,1,'首领会所2层Lv250击杀掉落7阶装备',0,3,0,0,0,203003,'1.3','0',0,0,0,203003,0,'0',300,100,9909,36408954,23080,13173,1065,1065,1305,1324,0,'[]','[3,22755596,3000]',600,2250,1500,2250,300,'[{202030031,1},{202030032,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1252004,'暗裔恶魔',0,3,1,'首领会所2层Lv300击杀掉落8阶装备',0,3,0,0,0,203007,'1.3','0',0,0,0,203007,0,'0',350,100,15958,90346640,35642,24848,2108,2108,1770,1802,0,'[]','[3,47550863,3000]',600,2250,1500,2250,300,'[{2000230301,1},{2000230303,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1252005,'海龙王',0,3,1,'首领会所2层Lv350击杀掉落9阶装备',0,3,0,0,0,203009,'1.3','0',0,0,0,203009,0,'0',380,100,20697,153183018,45315,35364,3727,3727,2996,3046,0,'[]','[3,66601312,3000]',600,2250,1500,2250,300,'[{202030091,1},{202030092,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1253001,'蜘蛛女皇',0,3,1,'首领会所3层Lv400击杀掉落7阶装备',0,3,0,0,0,203011,'1.3','0',0,0,0,203011,0,'0',310,100,10987,52216344,25328,15324,1258,1258,1385,1406,0,'[]','[3,26108172,3000]',600,2250,1500,2250,300,'[{200022021,1},{200022022,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1253002,'海龙王',0,3,1,'首领会所3层Lv450击杀掉落8阶装备',0,3,0,0,0,203009,'1.3','0',0,0,0,203009,0,'0',360,100,18046,134694788,39747,28967,2700,2700,2222,2261,0,'[]','[3,53877915,3000]',600,2250,1500,2250,300,'[{202030091,1},{202030092,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1253003,'食人花',0,3,1,'首领会所3层Lv500击杀掉落9阶装备',0,3,0,0,0,203001,'1.3','0',0,0,0,203001,0,'0',390,100,24151,218966112,51536,41317,4543,4543,3624,3685,0,'[]','[3,72988704,3000]',600,2250,1500,2250,300,'[{202030011,1},{202030012,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1253004,'暗裔猎手',0,3,1,'首领会所3层Lv550击杀掉落9阶装备',0,3,0,0,0,203011,'1.3','0',0,0,0,203011,0,'0',400,100,27336,238151355,58154,47726,5432,5432,4308,4379,0,'[]','[3,79383785,3000]',600,2250,1500,2250,300,'[{200022021,1},{200022022,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1253005,'美杜莎',0,3,1,'首领会所3层Lv300击杀掉落10阶装备',0,3,0,0,0,203006,'1.3','0',0,0,0,203006,0,'0',440,100,33746,385532337,69923,58578,7669,7669,5435,5605,0,'[]','[3,124365270,3000]',600,2250,1500,2250,300,'[{2000230101,1},{2000230102,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1254001,'食人花',0,3,1,'首领会所4层Lv350击杀掉落9阶装备',0,3,0,0,0,203001,'1.3','0',0,0,0,203001,0,'0',410,100,29263,280397272,61096,50439,5992,5992,4589,4686,0,'[]','[3,63310076,3000]',600,2250,1500,2250,300,'[{202030011,1},{202030012,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1254002,'冰霜巨龙',0,3,1,'首领会所4层Lv400击杀掉落10阶装备',0,3,0,0,0,203004,'1.3','0',0,0,0,203004,0,'0',450,100,35731,347444223,72866,61291,8228,8228,5717,5911,0,'[]','[3,87090073,3000]',600,2250,1500,2250,300,'[{202030041,1},{202030043,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1254003,'光明神',0,3,1,'首领会所4层Lv450击杀掉落10阶装备',0,3,0,0,0,203021,'1.3','0',0,0,0,203021,0,'0',460,100,37714,435142924,77256,65438,9046,9046,6328,6559,0,'[]','[3,93437831,3000]',600,2250,1500,2250,300,'[{2000202101,1},{200054200,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1254004,'暗裔恶魔',0,3,1,'首领会所4层Lv500击杀掉落11阶装备',0,3,0,0,0,203007,'1.3','0',0,0,0,203007,0,'0',500,100,46813,633645699,94816,82024,12320,12320,8773,9152,0,'[]','[3,130728049,3000]',600,2250,1500,2250,300,'[{2000230301,1},{2000230303,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1254005,'迦楼罗',0,3,1,'首领会所4层Lv550击杀掉落12阶装备',0,3,0,0,0,203020,'1.3','0',0,0,0,203020,0,'0',540,100,57816,792568979,114776,100992,18971,18971,12837,13292,0,'[]','[3,178111006,3000]',600,2250,1500,2250,300,'[{202030201,1},{202030202,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1255001,'暗裔恶魔',0,3,1,'首领会所5层Lv600击杀掉落11阶装备',0,3,0,0,0,203007,'1.3','0',0,0,0,203007,0,'0',505,100,47624,816887618,97311,84395,13151,13151,9281,9669,0,'[]','[3,306350882,3000]',600,2250,1500,2250,300,'[{2000230301,1},{2000230303,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1255002,'阿努比斯',0,3,1,'首领会所5层Lv650击杀掉落11阶装备',0,3,0,0,0,203005,'1.3','0',0,0,0,203005,0,'0',510,100,48984,841721572,99806,86766,13982,13982,9789,10187,0,'[]','[3,315594007,3000]',600,2250,1500,2250,300,'[{202030051,1},{202030052,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1255003,'迦楼罗',0,3,1,'首领会所5层Lv400击杀掉落12阶装备',0,3,0,0,0,203020,'1.3','0',0,0,0,203020,0,'0',550,100,59852,1040338032,119765,105734,20634,20634,13853,14328,0,'[]','[3,389543201,3000]',600,2250,1500,2250,300,'[{202030201,1},{202030202,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1255004,'熔岩战神',0,3,1,'首领会所5层Lv450击杀掉落13阶装备',0,3,0,0,0,203025,'1.3','0',0,0,0,203025,0,'0',600,100,74382,1305517843,146533,131334,26685,26685,17056,17444,0,'[]','[3,488241239,3000]',600,2250,1500,2250,300,'[{202030251,1},{202030252,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1255005,'半人马',0,3,1,'首领会所5层Lv500击杀掉落14阶装备',0,3,0,0,0,203002,'1.3','0',0,0,0,203002,0,'0',650,100,90535,1599225141,178171,161793,33998,33998,22569,22794,0,'[]','[3,597357981,3000]',600,2250,1500,2250,300,'[{200022011,1},{200022014,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1256001,'色欲',0,3,1,'首领会所6层Lv550击杀掉落12阶装备',0,3,0,0,0,203016,'1.3','0',0,0,0,203016,0,'0',560,100,62433,1230121852,125119,110854,21844,21844,14494,14951,0,'[]','[3,409301249,3000]',600,2250,1500,2250,300,'[{202030161,1},{202030162,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1256002,'机械巨人',0,3,1,'首领会所6层Lv600击杀掉落13阶装备',0,3,0,0,0,203008,'1.3','0',0,0,0,203008,0,'0',610,100,77212,1534890089,152860,137426,28148,28148,18159,18514,0,'[]','[3,510093487,3000]',600,2250,1500,2250,300,'[{202030081,1},{202030082,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1256003,'冰霜泰坦',0,3,1,'首领会所6层Lv650击杀掉落13阶装备',0,3,0,0,0,203003,'1.3','0',0,0,0,203003,0,'0',620,100,80429,1601028767,159188,143518,29610,29610,19261,19584,0,'[]','[3,531926046,3000]',600,2250,1500,2250,300,'[{202030031,1},{202030032,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1256004,'怠惰',0,3,1,'首领会所6层Lv700击杀掉落14阶装备',0,3,0,0,0,203013,'1.3','0',0,0,0,203013,0,'0',645,100,88455,1766155326,175007,158747,33267,33267,22018,22259,0,'[]','[3,586466089,3000]',600,2250,1500,2250,300,'[{202030131,1},{202030132,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1256005,'月神',0,3,1,'首领会所6层Lv750击杀掉落14阶装备',0,3,0,0,0,203022,'1.3','0',0,0,0,203022,0,'0',650,100,90057,1799128283,178171,161793,33998,33998,22569,22794,0,'[]','[3,597357981,3000]',600,2250,1500,2250,300,'[{2000540401,1},{2000540402,1},{2000540406,1},{2000540410,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1257001,'食人花',0,3,1,'首领会所7层Lv500击杀掉落13阶装备',0,3,0,0,0,203001,'1.3','0',0,0,0,203001,0,'0',625,100,81688,1815643455,162352,146564,30341,30341,19812,20119,0,'[]','[3,542847148,3000]',600,2250,1500,2250,300,'[{202030011,1},{202030012,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1257002,'冰霜巨龙',0,3,1,'首领会所7层Lv550击杀掉落14阶装备',0,3,0,0,0,203004,'1.3','0',0,0,0,203004,0,'0',655,100,91633,2044789511,181451,164965,34663,34663,22886,23113,0,'[]','[3,610975639,3000]',600,2250,1500,2250,300,'[{202030041,1},{202030043,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1257003,'光明神',0,3,1,'首领会所7层Lv600击杀掉落14阶装备',0,3,0,0,0,203021,'1.3','0',0,0,0,203021,0,'0',660,100,93592,2090561674,184730,168136,35329,35329,23202,23433,0,'[]','[3,624590983,3000]',600,2250,1500,2250,300,'[{2000202101,1},{200054200,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1257004,'暗裔恶魔',0,3,1,'首领会所7层Lv650击杀掉落15阶装备',0,3,0,0,0,203007,'1.3','0',0,0,0,203007,0,'0',700,100,109214,2456109758,210967,193508,40654,40654,25735,25987,0,'[]','[3,733370468,3000]',600,2250,1500,2250,300,'[{2000230301,1},{2000230303,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1257005,'迦楼罗',0,3,1,'首领会所7层Lv700击杀掉落16阶装备',0,3,0,0,0,203020,'1.3','0',0,0,0,203020,0,'0',750,100,126970,2861339004,245890,227280,46421,46421,28907,28907,0,'[]','[3,853889176,3000]',600,2250,1500,2250,300,'[{202030201,1},{202030202,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1301001,'质量检测员',0,3,0,'混乱魔域1层Lv260击杀掉落6阶装备',0,3,0,0,0,203008,'1.3','0',0,0,0,203008,0,'0',260,100,1964,16576363,11319,6955,454,454,557,581,0,'[]','[3,16576363,3000]',600,2250,1500,2250,300,'[{202030081,1},{202030082,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,40,0),(1301002,'怠惰',0,3,0,'混乱魔域1层Lv280击杀掉落7阶装备',0,3,0,0,0,203013,'1.3','0',0,0,0,203013,0,'0',280,100,2559,20696271,14536,8544,637,637,780,800,0,'[]','[3,20696271,3000]',600,2250,1500,2250,300,'[{202030131,1},{202030132,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,40,0),(1301003,'阿努比斯',0,3,0,'混乱魔域1层Lv300击杀掉落7阶装备',0,3,0,0,0,203005,'1.3','0',0,0,0,203005,0,'0',300,100,3157,24824287,17754,10133,819,819,1004,1018,0,'[]','[3,24824287,3000]',600,2250,1500,2250,300,'[{202030051,1},{202030052,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,40,0),(1301004,'熔岩战神',0,3,0,'混乱魔域1层Lv320击杀掉落7阶装备',0,3,0,0,0,203025,'1.3','0',0,0,0,203025,0,'0',320,100,3850,42869716,21213,13442,1116,1116,1127,1145,0,'[]','[3,42869716,3000]',600,2250,1500,2250,300,'[{202030251,1},{202030252,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,40,0),(1301005,'暴食',0,3,0,'混乱魔域1层Lv340击杀掉落8阶装备',0,3,0,0,0,203015,'1.3','0',0,0,0,203015,0,'0',340,100,4545,52702342,24672,16752,1413,1413,1250,1271,0,'[]','[3,52702342,3000]',600,2250,1500,2250,300,'[{202030151,1},{202030152,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,40,0),(1301006,'蜘蛛女皇',0,3,0,'混乱魔域1层Lv360击杀掉落8阶装备',0,3,0,0,0,203011,'1.3','0',0,0,0,203011,0,'0',360,100,5316,65306563,28390,20691,1929,1929,1587,1615,0,'[]','[3,65306563,3000]',600,2250,1500,2250,300,'[{200022021,1},{200022022,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,40,0),(1301007,'光明神',0,3,0,'混乱魔域1层Lv380击杀掉落9阶装备',0,3,0,0,0,203021,'1.3','0',0,0,0,203021,0,'0',380,100,6165,80728863,32368,25260,2662,2662,2140,2176,0,'[]','[3,80728863,3000]',600,2250,1500,2250,300,'[{2000202101,1},{200054200,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,40,0),(1301008,'冰雪皇后',0,3,0,'混乱魔域1层Lv400击杀掉落9阶装备',0,3,0,0,0,203017,'1.3','0',0,0,0,203017,0,'0',400,100,7013,96222770,36346,29829,3395,3395,2692,2737,0,'[]','[3,96222770,3000]',600,2250,1500,2250,300,'[{2000540201,1},{2000540208,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,40,0),(1301901,'魔域妖花',0,0,0,'混乱魔域1层Lv260击杀掉落套装石碎片',0,4,0,0,0,202001,'1','0',0,0,0,202001,0,'0',260,5,561,690682,11319,6955,454,454,557,581,0,'[]','[]',250,2250,1500,2250,300,'[{1110000003,1}]',3000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,3,0),(1301902,'魔域地精',0,0,0,'混乱魔域1层Lv280击杀掉落套装石碎片',0,4,0,0,0,202005,'1','0',0,0,0,202005,0,'0',280,5,731,862345,14536,8544,637,637,780,800,0,'[]','[]',250,2250,1500,2250,300,'[{1110000003,1}]',3000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,3,0),(1301903,'暗影魔狼',0,0,0,'混乱魔域1层Lv300击杀掉落套装石碎片',0,4,0,0,0,202006,'1','0',0,0,0,202006,0,'0',300,5,902,1034345,17754,10133,819,819,1004,1018,0,'[]','[]',250,2250,1500,2250,300,'[{1110000003,1}]',3000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,3,0),(1301904,'森林妖精',0,0,0,'混乱魔域1层Lv320击杀掉落套装石碎片',0,4,0,0,0,202008,'1','0',0,0,0,202008,0,'0',320,5,1100,1339679,21213,13442,1116,1116,1127,1145,0,'[]','[]',250,2250,1500,2250,300,'[{1110000001,1}]',3000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,3,0),(1301905,'魔灵侍卫',0,0,0,'混乱魔域1层Lv340击杀掉落套装石碎片',0,4,0,0,0,202004,'1','0',0,0,0,202004,0,'0',340,5,1299,1646948,24672,16752,1413,1413,1250,1271,0,'[]','[]',250,2250,1500,2250,300,'[{1110000003,1}]',3000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,3,0),(1301906,'魔域岩龟',0,0,0,'混乱魔域1层Lv360击杀掉落套装石碎片',0,4,0,0,0,202007,'1','0',0,0,0,202007,0,'0',360,5,1519,2040830,28390,20691,1929,1929,1587,1615,0,'[]','[]',250,2250,1500,2250,300,'[{1110000003,1}]',3000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,3,0),(1301907,'魔石傀儡',0,0,0,'混乱魔域1层Lv380击杀掉落套装石碎片',0,4,0,0,0,5010030,'1','0',0,0,0,202037,0,'0',380,5,1761,2522777,32368,25260,2662,2662,2140,2176,0,'[]','[]',250,2250,1500,2250,300,'[{1110000001,1}]',3000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,3,0),(1302001,'冰雪皇后',0,3,0,'混乱魔域2层Lv425击杀掉落10阶装备',0,3,0,0,0,203017,'1.3','0',0,0,0,203017,0,'0',425,100,8042,83597024,40944,34068,4269,4269,3133,3216,0,'[]','[3,83597024,3000]',600,2250,1500,2250,300,'[{2000540201,1},{2000540208,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,40,0),(1302002,'人马战士',0,3,0,'混乱魔域2层Lv450击杀掉落10阶装备',0,3,0,0,0,203002,'1.3','0',0,0,0,203002,0,'0',450,100,9068,95007352,45541,38307,5142,5142,3573,3695,0,'[]','[3,95007352,3000]',600,2250,1500,2250,300,'[{200022011,1},{200022014,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,40,0),(1302003,'光明神',0,3,0,'混乱魔域2层Lv475击杀掉落11阶装备',0,3,0,0,0,203021,'1.3','0',0,0,0,203021,0,'0',475,100,10579,112322030,52401,44786,6421,6421,4528,4707,0,'[]','[3,112322030,3000]',600,2250,1500,2250,300,'[{2000202101,1},{200054200,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,40,0),(1302004,'熔岩战神',0,3,0,'混乱魔域2层Lv500击杀掉落11阶装备',0,3,0,0,0,203025,'1.3','0',0,0,0,203025,0,'0',500,100,12089,172863536,59260,51265,7700,7700,5483,5720,0,'[]','[3,172863536,3000]',600,2250,1500,2250,300,'[{202030251,1},{202030252,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,40,0),(1302005,'海龙王',0,3,0,'混乱魔域2层Lv525击杀掉落11阶装备',0,3,0,0,0,203009,'1.3','0',0,0,0,203009,0,'0',525,100,13851,199758897,67057,58674,10298,10298,7071,7337,0,'[]','[3,199758897,3000]',600,2250,1500,2250,300,'[{202030091,1},{202030092,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,40,0),(1302006,'冰霜巨龙',0,3,0,'混乱魔域2层Lv550击杀掉落12阶装备',0,3,0,0,0,203004,'1.3','0',0,0,0,203004,0,'0',550,100,15612,226643317,74853,66084,12896,12896,8658,8955,0,'[]','[3,226643317,3000]',600,2250,1500,2250,300,'[{202030041,1},{202030043,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,40,0),(1302007,'嫉妒',0,3,0,'混乱魔域2层Lv575击杀掉落12阶装备',0,3,0,0,0,203014,'1.3','0',0,0,0,203014,0,'0',575,100,17497,255374434,83218,74084,14787,14787,9659,9928,0,'[]','[3,255374434,3000]',600,2250,1500,2250,300,'[{202030141,1},{202030142,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,40,0),(1302008,'冰霜泰坦',0,3,0,'混乱魔域2层Lv600击杀掉落12阶装备',0,3,0,0,0,203003,'1.3','0',0,0,0,203003,0,'0',600,100,19378,284067630,91583,82084,16678,16678,10660,10902,0,'[]','[3,284067630,3000]',600,2250,1500,2250,300,'[{202030031,1},{202030032,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,40,0),(1302901,'魔化机械',0,0,0,'混乱魔域2层Lv425击杀掉落套装石碎片',0,4,0,0,0,202018,'1','0',0,0,0,202018,0,'0',425,5,2298,3483209,40944,34068,4269,4269,3133,3216,0,'[]','[]',250,1300,1300,1500,300,'[{1110000003,1}]',3000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,3,0),(1302902,'魔域影狼',0,0,0,'混乱魔域2层Lv450击杀掉落套装石碎片',0,4,0,0,0,202006,'1','0',0,0,0,202006,0,'0',450,5,2591,3958640,45541,38307,5142,5142,3573,3695,0,'[]','[]',250,1300,1300,1500,300,'[{1110000003,1}]',3000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,3,0),(1302903,'骷髅守卫',0,0,0,'混乱魔域2层Lv475击杀掉落套装石碎片',0,4,0,0,0,202002,'1','0',0,0,0,202002,0,'0',475,5,3022,4680085,52401,44786,6421,6421,4528,4707,0,'[]','[]',250,1300,1300,1500,300,'[{1110000003,1}]',3000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,3,0),(1302904,'魔域莱姆',0,0,0,'混乱魔域2层Lv500击杀掉落套装石碎片',0,4,0,0,0,202003,'1','0',0,0,0,202003,0,'0',500,5,3454,5401985,59260,51265,7700,7700,5483,5720,0,'[]','[]',250,1300,1300,1500,300,'[{1110000003,1}]',3000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,3,0),(1302905,'地精刺客',0,0,0,'混乱魔域2层Lv525击杀掉落套装石碎片',0,4,0,0,0,202005,'1','0',0,0,0,202005,0,'0',525,5,3957,6242466,67057,58674,10298,10298,7071,7337,0,'[]','[]',250,1300,1300,1500,300,'[{1110000003,1}]',3000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,3,0),(1302906,'魔域蝠灵',0,0,0,'混乱魔域2层Lv550击杀掉落套装石碎片',0,4,0,0,0,202008,'1.2','0',0,0,0,202008,0,'0',550,5,4460,7082604,74853,66084,12896,12896,8658,8955,0,'[]','[]',250,1300,1300,1500,300,'[{1110000003,1}]',3000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,3,0),(1302907,'沼泽史莱姆',0,0,0,'混乱魔域2层Lv575击杀掉落套装石碎片',0,4,0,0,0,202003,'1.1','0',0,0,0,202003,0,'0',575,5,4999,7980451,83218,74084,14787,14787,9659,9928,0,'[]','[]',250,1300,1300,1500,300,'[{1110000003,1}]',3000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,3,0),(1302908,'魔域火蜥',0,0,0,'混乱魔域2层Lv600击杀掉落套装石碎片',0,4,0,0,0,202014,'1.1','0',0,0,0,202014,0,'0',600,5,5536,8877113,91583,82084,16678,16678,10660,10902,0,'[]','[]',250,1300,1300,1500,300,'[{1110000003,1}]',3000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,3,0),(1303001,'暗裔猎手',0,3,0,'混乱魔域3层Lv550击杀掉落12阶装备',0,3,0,0,0,203011,'1.3','0',0,0,0,203011,0,'0',550,100,15612,283304146,74853,66084,12896,12896,8658,8955,0,'[]','[3,283304146,3000]',600,2250,1500,2250,300,'[{200022021,1},{200022022,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,40,0),(1303002,'冰霜巨龙',0,3,0,'混乱魔域3层Lv570击杀掉落12阶装备',0,3,0,0,0,203004,'1.3','0',0,0,0,203004,0,'0',570,100,17120,312038206,81545,72484,14409,14409,9459,9734,0,'[]','[3,312038206,3000]',600,2250,1500,2250,300,'[{202030041,1},{202030043,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,40,0),(1303003,'寒冰女神',0,3,0,'混乱魔域3层Lv590击杀掉落12阶装备',0,3,0,0,0,203017,'1.3','0',0,0,0,203017,0,'0',590,100,18626,340745214,88237,78884,15922,15922,10260,10513,0,'[]','[3,340745214,3000]',600,2250,1500,2250,300,'[{2000540201,1},{2000540208,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,40,0),(1303004,'巴哈姆特',0,3,0,'混乱魔域3层Lv610击杀掉落13阶装备',0,3,0,0,0,203026,'1.3','0',0,0,0,203026,0,'0',610,100,20213,370977081,95538,85891,17592,17592,11349,11571,0,'[]','[3,370977081,3000]',600,2250,1500,2250,300,'[{202030261,1},{202030262,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,40,0),(1303005,'迦楼罗',0,3,0,'混乱魔域3层Lv630击杀掉落13阶装备',0,3,0,0,0,203020,'1.3','0',0,0,0,203020,0,'0',630,100,21883,402731146,103447,93506,19420,19420,12727,12909,0,'[]','[3,402731146,3000]',600,2250,1500,2250,300,'[{202030201,1},{202030202,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,40,0),(1303006,'食人花',0,3,0,'混乱魔域3层Lv645击杀掉落13阶装备',0,3,0,0,0,203001,'1.3','0',0,0,0,203001,0,'0',645,100,23133,426520792,109380,99217,20792,20792,13761,13912,0,'[]','[3,426520792,3000]',600,2250,1500,2250,300,'[{202030011,1},{202030012,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,40,0),(1303007,'嫉妒',0,3,0,'混乱魔域3层Lv670击杀掉落14阶装备',0,3,0,0,0,203014,'1.3','0',0,0,0,203014,0,'0',670,100,25594,474038902,119556,109050,22913,22913,14897,15045,0,'[]','[3,474038902,3000]',600,2250,1500,2250,300,'[{202030141,1},{202030142,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,40,0),(1303008,'冰霜泰坦',0,3,0,'混乱魔域3层Lv690击杀掉落14阶装备',0,3,0,0,0,203003,'1.3','0',0,0,0,203003,0,'0',690,100,27636,513603892,127755,116978,24577,24577,15689,15843,0,'[]','[3,513603892,3000]',600,2250,1500,2250,300,'[{202030031,1},{202030032,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,40,0),(1303901,'魔化晶蟹',0,0,0,'混乱魔域3层Lv550击杀掉落套装石碎片',0,2,0,0,0,202022,'0.9','0',0,0,0,202022,0,'0',550,5,4460,7082604,74853,66084,12896,12896,8658,8955,0,'[]','[]',250,1300,1300,1500,300,'[{1110000003,1}]',3000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,3,0),(1303902,'双刃魔卫',0,0,0,'混乱魔域3层Lv570击杀掉落套装石碎片',0,4,0,0,0,202011,'1','0',0,0,0,202011,0,'0',570,5,4891,7800955,81545,72484,14409,14409,9459,9734,0,'[]','[]',250,1300,1300,1500,300,'[{1110000003,1}]',3000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,3,0),(1303903,'魔化傀儡',0,0,0,'混乱魔域3层Lv590击杀掉落套装石碎片',0,4,0,0,0,202015,'1','0',0,0,0,202015,0,'0',590,5,5322,8518630,88237,78884,15922,15922,10260,10513,0,'[]','[]',250,1300,1300,1500,300,'[{1110000003,1}]',3000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,3,0),(1303904,'魔域火蝎',0,0,0,'混乱魔域3层Lv610击杀掉落套装石碎片',0,4,0,0,0,202013,'1.1','0',0,0,0,202013,0,'0',610,5,5775,9274427,95538,85891,17592,17592,11349,11571,0,'[]','[]',250,1300,1300,1500,300,'[{1110000003,1}]',3000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,3,0),(1303905,'魔化机兵',0,0,0,'混乱魔域3层Lv630击杀掉落套装石碎片',0,4,0,0,0,202018,'1','0',0,0,0,202018,0,'0',630,5,6252,10068279,103447,93506,19420,19420,12727,12909,0,'[]','[]',250,1300,1300,1500,300,'[{1110000003,1}]',3000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,3,0),(1303906,'机械魔将',0,0,0,'混乱魔域3层Lv645击杀掉落套装石碎片',0,4,0,0,0,202017,'1.2','0',0,0,0,202017,0,'0',645,5,6609,10663020,109380,99217,20792,20792,13761,13912,0,'[]','[]',250,1300,1300,1500,300,'[{1110000003,1}]',3000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,3,0),(1304001,'暗裔猎手',0,3,0,'混乱魔域4层Lv660击杀掉落14阶装备',0,3,0,0,0,203011,'1.3','0',0,0,0,203011,0,'0',660,100,24572,454247988,115457,105085,22081,22081,14501,14645,0,'[]','[3,454247988,3000]',600,2250,1500,2250,300,'[{200022021,1},{200022022,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,40,0),(1304002,'冰霜巨龙',0,3,0,'混乱魔域4层Lv675击杀掉落14阶装备',0,3,0,0,0,203004,'1.3','0',0,0,0,203004,0,'0',675,100,26105,483934347,121606,111032,23329,23329,15095,15244,0,'[]','[3,483934347,3000]',600,2250,1500,2250,300,'[{202030041,1},{202030043,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,40,0),(1304003,'食人花',0,3,0,'混乱魔域4层Lv690击杀掉落14阶装备',0,3,0,0,0,203001,'1.3','0',0,0,0,203001,0,'0',690,100,27636,513603892,127755,116978,24577,24577,15689,15843,0,'[]','[3,513603892,3000]',600,2250,1500,2250,300,'[{202030011,1},{202030012,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,40,0),(1304004,'月神',0,3,0,'混乱魔域4层Lv700击杀掉落15阶装备',0,3,0,0,0,203022,'1.3','0',0,0,0,203022,0,'0',700,100,28655,533360340,131854,120943,25409,25409,16084,16242,0,'[]','[3,533360340,3000]',600,2250,1500,2250,300,'[{2000540401,1},{2000540402,1},{2000540406,1},{2000540410,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,40,0),(1304005,'美杜莎',0,3,0,'混乱魔域4层Lv710击杀掉落15阶装备',0,3,0,0,0,203006,'1.3','0',0,0,0,203006,0,'0',710,100,29585,550929091,136220,125164,26130,26130,16481,16607,0,'[]','[3,550929091,3000]',600,2250,1500,2250,300,'[{2000230101,1},{2000230102,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,40,0),(1304006,'愤怒',0,3,0,'混乱魔域4层Lv720击杀掉落15阶装备',0,3,0,0,0,203012,'1.3','0',0,0,0,203012,0,'0',720,100,30514,568480656,140585,129385,26850,26850,16878,16972,0,'[]','[3,568480656,3000]',600,2250,1500,2250,300,'[{202030121,1},{202030122,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,40,0),(1304007,'海龙王',0,3,0,'混乱魔域4层Lv740击杀掉落16阶装备',0,3,0,0,0,203009,'1.3','0',0,0,0,203009,0,'0',740,100,32367,603521896,149316,137828,28292,28292,17671,17702,0,'[]','[3,603521896,3000]',600,2250,1500,2250,300,'[{202030091,1},{202030092,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,40,0),(1304008,'死神',0,3,0,'混乱魔域4层Lv750击杀掉落16阶装备',0,3,0,0,0,203018,'1.3','0',0,0,0,203018,0,'0',750,100,33291,621010309,153682,142050,29013,29013,18067,18067,0,'[]','[3,621010309,3000]',600,2250,1500,2250,300,'[{2000201801,1},{20005455,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,40,0),(1304901,'背背钻蟹',0,0,0,'混乱魔域4层Lv660击杀掉落套装石碎片',0,2,0,0,0,202031,'0.9','0',0,0,0,202031,0,'0',660,5,7021,11356200,115457,105085,22081,22081,14501,14645,0,'[]','[]',250,1300,1300,1500,300,'[{1110000001,1}]',3000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,3,0),(1304902,'背背箱蟹',0,0,0,'混乱魔域4层Lv675击杀掉落套装石碎片',0,2,0,0,0,202032,'1','0',0,0,0,202032,0,'0',675,5,7459,12098359,121606,111032,23329,23329,15095,15244,0,'[]','[]',250,1300,1300,1500,300,'[{1110000001,1}]',3000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,3,0),(1304903,'魔域树妖',0,0,0,'混乱魔域4层Lv690击杀掉落套装石碎片',0,4,0,0,0,202033,'1','0',0,0,0,202033,0,'0',690,5,7896,12840097,127755,116978,24577,24577,15689,15843,0,'[]','[]',250,1300,1300,1500,300,'[{1110000001,1}]',3000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,3,0),(1304904,'绿皮地精',0,0,0,'混乱魔域4层Lv700击杀掉落套装石碎片',0,4,0,0,0,202005,'1','0',0,0,0,202005,0,'0',700,5,8187,13334009,131854,120943,25409,25409,16084,16242,0,'[]','[]',250,1300,1300,1500,300,'[{1110000003,1}]',3000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,3,0),(1304905,'魔域刀兵',0,0,0,'混乱魔域4层Lv710击杀掉落套装石碎片',0,4,0,0,0,202011,'1','0',0,0,0,202011,0,'0',710,5,8453,13773227,136220,125164,26130,26130,16481,16607,0,'[]','[]',250,1300,1300,1500,300,'[{1110000003,1}]',3000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,3,0),(1304906,'魔斧树妖',0,0,0,'混乱魔域4层Lv720击杀掉落套装石碎片',0,2,0,0,0,202033,'1.2','0',0,0,0,202033,0,'0',720,5,8718,14212016,140585,129385,26850,26850,16878,16972,0,'[]','[]',250,1300,1300,1500,300,'[{1110000001,1}]',3000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,3,0),(1341002,'半人马',0,3,1,'首领狩猎1号Lv120击杀掉落4阶装备',0,3,0,0,0,203002,'1.3','0',0,0,0,203002,0,'0',120,60,486,785823,748,935,124,130,41,40,0,'[]','[]',600,2250,1500,2250,300,'[{200022011,1},{200022014,1}]',0,2000,0,1,389167,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1341003,'暗裔恶魔',0,3,1,'首领狩猎2号Lv150击杀掉落5阶装备',0,3,0,0,0,203007,'1.3','0',0,0,0,203007,0,'0',150,75,493,825600,1057,1530,58,75,29,33,0,'[]','[]',600,2250,1500,2250,300,'[{2000230301,1},{2000230303,1}]',0,2000,0,1,486459,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1341004,'愤怒',0,3,1,'首领狩猎3号Lv200击杀掉落5-6阶装备',0,3,0,0,0,203012,'1.3','0',0,0,0,203012,0,'0',200,100,1534,1435077,4274,2449,120,120,98,110,0,'[]','[]',600,2250,1500,2250,300,'[{202030121,1},{202030122,1}]',0,2000,0,1,608074,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1341005,'光明神',0,3,1,'首领狩猎4号Lv250击杀掉落6-7阶装备',0,3,0,0,0,203021,'1.3','0',0,0,0,203021,0,'0',250,100,3577,3630270,9710,6161,363,363,445,472,0,'[]','[]',600,2250,1500,2250,300,'[{2000202101,1},{200054200,1}]',0,2000,0,1,944273,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1341006,'熔岩战神',0,3,1,'首领狩猎5号Lv300击杀掉落7-8阶装备',0,3,0,0,0,203025,'1.3','0',0,0,0,203025,0,'0',300,100,6766,6206072,17754,10133,819,819,1004,1018,0,'[]','[]',600,2250,1500,2250,300,'[{202030251,1},{202030252,1}]',0,2000,0,1,1099564,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1341007,'冰霜泰坦',0,3,1,'首领狩猎6号Lv350击杀掉落8-9阶装备',0,3,0,0,0,203003,'1.3','0',0,0,0,203003,0,'0',350,100,10484,10807014,26401,18406,1562,1562,1311,1335,0,'[]','[]',600,2250,1500,2250,300,'[{202030031,1},{202030032,1}]',0,2000,0,1,1327281,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1341008,'色欲',0,3,1,'首领狩猎7号Lv400击杀掉落9-10阶装备',0,3,0,0,0,203016,'1.3','0',0,0,0,203016,0,'0',400,100,15028,18041769,36346,29829,3395,3395,2692,2737,0,'[]','[]',600,2250,1500,2250,300,'[{202030161,1},{202030162,1}]',0,2000,0,1,3288759,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1341009,'暗裔猎手',0,3,1,'首领狩猎8号Lv450击杀掉落10-11阶装备',0,3,0,0,0,203011,'1.3','0',0,0,0,203011,0,'0',450,100,19432,23751838,45541,38307,5142,5142,3573,3695,0,'[]','[]',600,2250,1500,2250,300,'[{200022021,1},{200022022,1}]',0,2000,0,1,5187187,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1341010,'八岐大蛇',0,3,1,'首领狩猎9号Lv500击杀掉落11-12阶装备',0,3,0,0,0,203024,'1.3','0',0,0,0,203024,0,'0',500,100,25904,32411913,59260,51265,7700,7700,5483,5720,0,'[]','[]',600,2250,1500,2250,300,'[{2000230201,1},{2000230202,1}]',0,2000,0,1,6869907,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1341011,'海龙王',0,3,1,'首领狩猎10号Lv550击杀掉落12-13阶装备',0,3,0,0,0,203009,'1.3','0',0,0,0,203009,0,'0',550,100,33454,42495622,74853,66084,12896,12896,8658,8955,0,'[]','[]',600,2250,1500,2250,300,'[{202030091,1},{202030092,1}]',0,2000,0,1,11420992,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1341012,'暗裔恶魔',0,3,1,'首领狩猎11号Lv600击杀掉落13-14阶装备',0,3,0,0,0,203007,'1.3','0',0,0,0,203007,0,'0',600,100,41523,53262681,91583,82084,16678,16678,10660,10902,0,'[]','[]',600,2250,1500,2250,300,'[{2000230301,1},{2000230303,1}]',0,2000,0,1,14972407,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1341013,'八岐大蛇',0,3,1,'首领狩猎12号Lv650击杀掉落14-15阶装备',0,3,0,0,0,203024,'1.3','0',0,0,0,203024,0,'0',650,100,50463,65166325,111357,101121,21249,21249,14106,14246,0,'[]','[]',600,2250,1500,2250,300,'[{2000230201,1},{2000230202,1}]',0,2000,0,1,17922718,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1341014,'暗裔猎手',0,3,1,'首领狩猎13号Lv700击杀掉落14-15阶装备',0,3,0,0,0,203011,'1.3','0',0,0,0,203011,0,'0',700,100,61405,80004051,131854,120943,25409,25409,16084,16242,0,'[]','[]',600,2250,1500,2250,300,'[{200022021,1},{200022022,1}]',0,2000,0,1,20873028,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1341015,'冰霜泰坦',0,3,1,'首领狩猎14号Lv750击杀掉落15-16阶装备',0,3,0,0,0,203003,'1.3','0',0,0,0,203003,0,'0',750,100,71337,93151546,153682,142050,29013,29013,18067,18067,0,'[]','[]',600,2250,1500,2250,300,'[{202030031,1},{202030032,1}]',0,2000,0,1,23823339,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1341016,'熔岩战神',0,3,1,'首领狩猎15号Lv800击杀掉落15-16阶装备',0,3,0,0,0,203025,'1.3','0',0,0,0,203025,0,'0',800,100,82176,107471999,178924,166605,32658,32658,21803,21803,0,'[]','[]',600,2250,1500,2250,300,'[{202030251,1},{202030252,1}]',0,2000,0,1,26183587,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(1790001,'布布小偶',0,0,0,'宝宝驻守家园怪物',0,6,0,0,2,1790001,'1','0',0,0,0,1790001,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',110,300,300,300,200,'[{1110000003,1}]',2000,1000,0,0,0,1,0,0,0,0,0,1,0,0,'[]',1,'0',1,0,0,0,0),(1790002,'卷耳布偶',0,1,0,'宝宝驻守家园怪物',0,6,0,0,0,1790002,'1','0',0,0,0,1790002,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',110,800,800,800,200,'[{1110000003,1}]',1000,2000,0,0,0,0,0,0,0,0,0,1,0,0,'[]',1,'0',1,0,0,0,0),(2101001,'八岐大蛇',0,6,1,'日常副本1boss',0,3,0,0,2,203024,'1.1','0',0,0,0,203024,0,'0',1,15,1,1,1,1,1,1,1,1,0,'[]','[]',600,2250,1500,2250,150,'[{2000230201,1},{2000230202,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(2101002,'暗裔恶魔',0,6,1,'日常副本2boss',0,3,0,0,2,203007,'1.1','0',0,0,0,203007,0,'0',1,15,1,1,0,0,0,0,0,0,0,'[]','[]',600,2250,1500,2250,150,'[{2000230301,1},{2000230303,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(2101011,'魔化蟹',0,0,1,'日常任务1动态小怪',0,3,0,0,2,202022,'1','0',0,0,0,202022,0,'3||八岐大蛇大人快要降临了！:3||八岐大蛇大人即将苏醒！:3',1,1,1,1,0,0,0,0,0,0,0,'[]','[]',600,2250,1500,2250,150,'[{1110000003,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(2101012,'史莱姆',0,0,1,'日常任务2动态小怪',0,3,0,0,2,202003,'1','0',0,0,0,202003,0,'0',1,1,1,1,0,0,0,0,0,0,0,'[]','[]',600,2250,1500,2250,150,'[{1110000003,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(2201001,'熔岩战神',0,6,0,'圣灵圣器副本1  任务id10080',0,3,0,0,0,203025,'1.7','0',0,0,0,203025,0,'0',80,16,660,78655,674,857,120,125,29,28,0,'[]','[]',600,2250,1500,2250,300,'[{202030251,1},{202030252,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(2201002,'食人花',0,6,0,'圣灵圣器副本2  任务id10089',0,3,0,0,0,203001,'1.5','0',0,0,0,203001,0,'0',85,17,633,93260,683,867,120,125,29,33,0,'[]','[]',600,2250,1500,2250,300,'[{202030011,1},{202030012,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(2201003,'质量检测员',0,6,0,'圣灵圣器副本3  任务id2110203',0,3,0,0,0,203008,'1.5','0',0,0,0,203008,0,'0',145,29,1124,159163,993,1403,72,87,32,35,0,'[]','[]',600,2250,1500,2250,300,'[{202030081,1},{202030082,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(2201004,'死神',0,6,0,'圣灵圣器副本4  任务id2110204',0,3,0,0,0,203018,'1.3','0',0,0,0,203018,0,'0',200,40,3799,279043,4274,2449,120,120,98,110,0,'[]','[]',600,2250,1500,2250,300,'[{2000201801,1},{20005455,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(2201005,'恶魔化身',0,6,0,'圣灵圣器副本3',0,3,0,0,0,203018,'0.8','0',0,0,0,203018,0,'0',145,29,1269,221703,1296,1196,257,257,125,125,0,'[]','[]',600,2250,1500,2250,300,'[{2000201801,1},{20005455,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(2301001,'美杜莎',0,6,0,'1转转生副本boss',0,6,0,0,0,203006,'1.3','0',0,0,0,203006,0,'0',150,30,2797,265956,2650,1914,86,93,47,54,0,'[]','[]',600,2250,1500,2250,300,'[{2000230101,1},{2000230102,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(2301002,'八岐大蛇',0,6,0,'2转转生副本boss',0,6,0,0,0,203024,'1.4','0',0,0,0,203024,0,'0',220,44,5377,548047,5515,3244,148,148,178,193,0,'[]','[]',600,2250,1500,2250,300,'[{2000230201,1},{2000230202,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(2301003,'暗裔魔神',0,6,0,'3转转生副本boss',0,6,0,0,0,203007,'1.3','0',0,0,0,203007,0,'0',280,56,13159,1580965,14536,8544,637,637,780,800,0,'[]','[]',600,2250,1500,2250,300,'[{2000230301,1},{2000230303,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(2301004,'蜘蛛女皇',0,6,0,'4转转生副本boss',0,6,0,0,0,203011,'1.3','0',0,0,0,203011,0,'0',370,74,27062,4563011,30379,22975,2295,2295,1864,1896,0,'[]','[]',600,2250,1500,2250,300,'[{200022021,1},{200022022,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(2301005,'巴哈姆特',0,6,0,'5转转生副本boss',0,6,0,0,0,203026,'1.2','0',0,0,0,203026,0,'0',600,120,84325,19233746,91583,82084,16678,16678,10660,10902,0,'[]','[]',600,2250,1500,2250,300,'[{202030261,1},{202030262,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3002001,'暗影魔狼',6,0,1,'新手经验本',0,1,0,0,0,202006,'1.3','0',0,0,0,202006,0,'0',70,14,39,3850,653,835,120,1,1,1,0,'[]','[]',100,2250,1500,2250,300,'[{1110000003,1}]',0,1000,0,0,81000,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(3005001,'绿蝴蝶',0,0,0,'捕蝶活动蝴蝶1',0,0,0,0,0,2050004,'2','[]',0,0,0,2050004,0,'5||我才值1分呢，哼！:100',1,1,0,120,0,0,0,0,0,0,0,'[]','[]',110,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,1,2,0,0,0,0,1,1,1,0,0,'[120,120]',1,'0',0,0,1,0,0),(3005002,'蓝蝴蝶',0,0,0,'捕蝶活动蝴蝶2',0,1,0,0,0,2050005,'2','[]',0,0,0,2050005,0,'5||我值3分呢哦！来抓我啊:100',1,1,0,210,0,0,0,0,0,0,0,'[]','[]',110,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,1,2,0,0,0,0,1,1,1,0,0,'[70,70]',1,'0',0,0,1,0,0),(3005003,'橙蝴蝶',0,0,0,'捕蝶活动蝴蝶3',0,3,0,0,0,2050006,'2','[]',0,0,0,2050006,0,'5||来抓我啊，哈哈哈！我有5分呢:100',1,1,0,550,0,0,0,0,0,0,0,'[]','[]',110,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,1,4,0,0,0,0,1,1,1,0,0,'[110,110]',1,'0',0,0,1,0,0),(3005004,'红蝴蝶',0,0,0,'捕蝶活动蝴蝶4',0,4,0,0,0,2050007,'2','[]',0,0,0,2050007,0,'10||抓住我可以获得收益翻倍效果哦！:100||我有全场最高的分值，10分哦！:100',1,1,0,1000,0,0,0,0,0,0,0,'[]','[]',110,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,1,4,0,0,0,0,1,1,1,0,0,'[100,100]',1,'0',0,0,0,0,0),(3110001,'魔狼',0,0,1,'装备副本1难度一关小怪',0,1,610,5,2,202006,'1.2','0',0,0,0,202006,0,'0',90,1,55,27064,693,877,120,125,34,33,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3110002,'魔蝶',0,0,1,'装备副本1难度二关小boss1',0,2,610,5,2,202008,'1.5','0',0,0,0,202008,0,'0',100,15,593,61461,712,897,124,130,41,40,0,'[]','[]',600,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3110003,'魔蝶',0,0,1,'装备副本1难度二关小boss2',0,3,610,5,2,202008,'1.5','0',0,0,0,202008,0,'0',100,15,522,69842,712,897,124,130,41,40,0,'[]','[]',600,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3110004,'魔之护卫',0,0,1,'装备副本1难度三关精英怪1',0,4,610,5,2,202004,'1.2','0',0,0,0,202004,0,'0',95,5,370,41237,702,887,124,130,41,40,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3110005,'魔之护卫',0,0,1,'装备副本1难度三关精英怪2',0,5,610,5,2,202004,'1.2','0',0,0,0,202004,0,'0',95,5,370,41237,702,887,124,130,41,40,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3110006,'魔之护卫',0,0,1,'装备副本1难度三关精英怪3',0,6,610,5,2,202004,'1.2','0',0,0,0,202004,0,'0',95,5,370,41237,702,887,124,130,41,40,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3110007,'魔之领主',0,6,1,'装备副本1难度四关boss',0,7,610,5,2,203006,'1.2','0',0,0,0,203006,0,'0',105,30,1188,150231,719,905,124,130,41,40,0,'[]','[]',600,2250,500,2250,200,'[{2000230101,1},{2000230102,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3111001,'魔狼',0,0,1,'装备副本2难度一关小怪',0,1,610,5,2,202006,'1.2','0',0,0,0,202006,0,'0',125,1,17,329329,757,945,124,130,41,40,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3111002,'魔蝶',0,0,1,'装备副本2难度二关小boss1',0,2,610,5,2,202008,'1.5','0',0,0,0,202008,0,'0',135,15,97,602947,864,1151,101,111,37,38,0,'[]','[]',600,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3111003,'魔蝶',0,0,1,'装备副本2难度二关小boss2',0,3,610,5,2,202008,'1.5','0',0,0,0,202008,0,'0',135,15,97,602947,864,1151,101,111,37,38,0,'[]','[]',600,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3111004,'魔之护卫',0,0,1,'装备副本2难度三关精英怪1',0,4,610,5,2,202004,'1.2','0',0,0,0,202004,0,'0',130,5,73,398263,800,1025,116,123,39,39,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3111005,'魔之护卫',0,0,1,'装备副本2难度三关精英怪2',0,5,610,5,2,202004,'1.2','0',0,0,0,202004,0,'0',130,5,73,398263,800,1025,116,123,39,39,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3111006,'魔之护卫',0,0,1,'装备副本2难度三关精英怪3',0,6,610,5,2,202004,'1.2','0',0,0,0,202004,0,'0',130,5,73,398263,800,1025,116,123,39,39,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3111007,'魔之领主',0,6,1,'装备副本2难度四关boss',0,7,610,5,2,203006,'1.2','0',0,0,0,203006,0,'0',140,30,259,1081693,928,1277,87,99,34,36,0,'[]','[]',600,2250,500,2250,200,'[{2000230101,1},{2000230102,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3112001,'魔狼',0,0,1,'装备副本3难度一关小怪',0,1,610,5,2,202006,'1.2','0',0,0,0,202006,0,'0',185,1,40,464800,3151,1983,96,100,52,62,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3112002,'魔蝶',0,0,1,'装备副本3难度二关小boss1',0,2,610,5,2,202008,'1.5','0',0,0,0,202008,0,'0',195,15,278,975769,3964,2250,113,113,78,90,0,'[]','[]',600,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3112003,'魔蝶',0,0,1,'装备副本3难度二关小boss2',0,3,610,5,2,202008,'1.5','0',0,0,0,202008,0,'0',195,15,278,975769,3964,2250,113,113,78,90,0,'[]','[]',600,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3112004,'魔之护卫',0,0,1,'装备副本3难度三关精英怪1',0,4,610,5,2,202004,'1.2','0',0,0,0,202004,0,'0',190,5,190,583579,3654,2051,106,106,58,69,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3112005,'魔之护卫',0,0,1,'装备副本3难度三关精英怪2',0,5,610,5,2,202004,'1.2','0',0,0,0,202004,0,'0',190,5,190,583579,3654,2051,106,106,58,69,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3112006,'魔之护卫',0,0,1,'装备副本3难度三关精英怪3',0,6,610,5,2,202004,'1.2','0',0,0,0,202004,0,'0',190,5,190,583579,3654,2051,106,106,58,69,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3112007,'魔之领主',0,6,1,'装备副本3难度四关boss',0,7,610,5,2,203006,'1.2','0',0,0,0,203006,0,'0',200,30,810,1913436,4274,2449,120,120,98,110,0,'[]','[]',600,2250,500,2250,200,'[{2000230101,1},{2000230102,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3113001,'魔狼',0,0,1,'装备副本4难度一关小怪',0,1,610,5,2,202006,'1.2','0',0,0,0,202006,0,'0',225,1,77,878188,5826,3443,155,155,198,213,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3113002,'魔蝶',0,0,1,'装备副本4难度二关小boss1',0,2,610,5,2,202008,'1.5','0',0,0,0,202008,0,'0',235,15,515,1940284,7030,4272,212,212,275,293,0,'[]','[]',600,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3113003,'魔蝶',0,0,1,'装备副本4难度二关小boss2',0,3,610,5,2,202008,'1.5','0',0,0,0,202008,0,'0',235,15,515,1940284,7030,4272,212,212,275,293,0,'[]','[]',600,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3113004,'魔之护卫',0,0,1,'装备副本4难度三关精英怪1',0,4,610,5,2,202004,'1.2','0',0,0,0,202004,0,'0',230,5,339,1121203,6136,3642,162,162,219,234,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3113005,'魔之护卫',0,0,1,'装备副本4难度三关精英怪2',0,5,610,5,2,202004,'1.2','0',0,0,0,202004,0,'0',230,5,339,1121203,6136,3642,162,162,219,234,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3113006,'魔之护卫',0,0,1,'装备副本4难度三关精英怪3',0,6,610,5,2,202004,'1.2','0',0,0,0,202004,0,'0',230,5,339,1121203,6136,3642,162,162,219,234,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3113007,'魔之领主',0,6,1,'装备副本4难度四关boss',0,7,610,5,2,203006,'1.2','0',0,0,0,203006,0,'0',240,30,1546,3911045,7923,4902,262,262,332,353,0,'[]','[]',600,2250,500,2250,200,'[{2000230101,1},{2000230102,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3114001,'魔狼',0,0,1,'装备副本5难度一关小怪',0,1,610,5,2,202006,'1.2','0',0,0,0,202006,0,'0',285,1,206,2263359,15341,8941,682,682,836,855,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3114002,'魔蝶',0,0,1,'装备副本5难度二关小boss1',0,2,610,5,2,202008,'1.5','0',0,0,0,202008,0,'0',295,15,1273,4460882,16949,9736,773,773,948,964,0,'[]','[]',600,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3114003,'魔蝶',0,0,1,'装备副本5难度二关小boss2',0,3,610,5,2,202008,'1.5','0',0,0,0,202008,0,'0',295,15,1273,4460882,16949,9736,773,773,948,964,0,'[]','[]',600,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3114004,'魔之护卫',0,0,1,'装备副本5难度三关精英怪1',0,4,610,5,2,202004,'1.2','0',0,0,0,202004,0,'0',290,5,907,2845079,16145,9338,728,728,892,909,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3114005,'魔之护卫',0,0,1,'装备副本5难度三关精英怪2',0,5,610,5,2,202004,'1.2','0',0,0,0,202004,0,'0',290,5,907,2845079,16145,9338,728,728,892,909,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3114006,'魔之护卫',0,0,1,'装备副本5难度三关精英怪3',0,6,610,5,2,202004,'1.2','0',0,0,0,202004,0,'0',290,5,907,2845079,16145,9338,728,728,892,909,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3114007,'魔之领主',0,6,1,'装备副本5难度四关boss',0,7,610,5,2,203006,'1.2','0',0,0,0,203006,0,'0',300,30,3571,8274762,17754,10133,819,819,1004,1018,0,'[]','[]',600,2250,500,2250,200,'[{2000230101,1},{2000230102,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3115001,'魔狼',0,0,1,'装备副本6难度一关小怪',0,1,610,5,2,202006,'1.2','0',0,0,0,202006,0,'0',335,1,333,3925108,23807,15924,1339,1339,1219,1240,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3115002,'魔蝶',0,0,1,'装备副本6难度二关小boss1',0,2,610,5,2,202008,'1.5','0',0,0,0,202008,0,'0',345,15,1997,7758122,25537,17579,1488,1488,1280,1303,0,'[]','[]',600,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3115003,'魔蝶',0,0,1,'装备副本6难度二关小boss2',0,3,610,5,2,202008,'1.5','0',0,0,0,202008,0,'0',345,15,1997,7758122,25537,17579,1488,1488,1280,1303,0,'[]','[]',600,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3115004,'魔之护卫',0,0,1,'装备副本6难度三关精英怪1',0,4,610,5,2,202004,'1.2','0',0,0,0,202004,0,'0',340,5,1443,4940845,24672,16752,1413,1413,1250,1271,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3115005,'魔之护卫',0,0,1,'装备副本6难度三关精英怪2',0,5,610,5,2,202004,'1.2','0',0,0,0,202004,0,'0',340,5,1443,4940845,24672,16752,1413,1413,1250,1271,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3115006,'魔之护卫',0,0,1,'装备副本6难度三关精英怪3',0,6,610,5,2,202004,'1.2','0',0,0,0,202004,0,'0',340,5,1443,4940845,24672,16752,1413,1413,1250,1271,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3115007,'魔之领主',0,6,1,'装备副本6难度四关boss',0,7,610,5,2,203006,'1.2','0',0,0,0,203006,0,'0',350,30,5533,14409352,26401,18406,1562,1562,1311,1335,0,'[]','[]',600,2250,500,2250,200,'[{2000230101,1},{2000230102,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3116001,'魔狼',0,0,1,'装备副本7难度一关小怪',0,1,610,5,2,202006,'1.2','0',0,0,0,202006,0,'0',385,1,486,6609224,33363,26402,2845,2845,2278,2316,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3116002,'魔蝶',0,0,1,'装备副本7难度二关小boss1',0,2,610,5,2,202008,'1.5','0',0,0,0,202008,0,'0',395,15,2879,12985803,35352,28687,3212,3212,2554,2597,0,'[]','[]',600,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3116003,'魔蝶',0,0,1,'装备副本7难度二关小boss2',0,3,610,5,2,202008,'1.5','0',0,0,0,202008,0,'0',395,15,2879,12985803,35352,28687,3212,3212,2554,2597,0,'[]','[]',600,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3116004,'魔之护卫',0,0,1,'装备副本7难度三关精英怪1',0,4,610,5,2,202004,'1.2','0',0,0,0,202004,0,'0',390,5,2092,8294171,34357,27544,3029,3029,2416,2457,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3116005,'魔之护卫',0,0,1,'装备副本7难度三关精英怪2',0,5,610,5,2,202004,'1.2','0',0,0,0,202004,0,'0',390,5,2092,8294171,34357,27544,3029,3029,2416,2457,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3116006,'魔之护卫',0,0,1,'装备副本7难度三关精英怪3',0,6,610,5,2,202004,'1.2','0',0,0,0,202004,0,'0',390,5,2092,8294171,34357,27544,3029,3029,2416,2457,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3116007,'魔之领主',0,6,1,'装备副本7难度四关boss',0,7,610,5,2,203006,'1.2','0',0,0,0,203006,0,'0',400,30,7931,24055693,36346,29829,3395,3395,2692,2737,0,'[]','[]',600,2250,500,2250,200,'[{2000230101,1},{2000230102,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3117001,'魔狼',0,0,1,'装备副本8难度一关小怪',0,1,610,5,2,202006,'1.2','0',0,0,0,202006,0,'0',435,1,644,9183615,42783,35764,4618,4618,3309,3407,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3117002,'魔蝶',0,0,1,'装备副本8难度二关小boss1',0,2,610,5,2,202008,'1.5','0',0,0,0,202008,0,'0',445,15,3752,17386489,44622,37459,4968,4968,3485,3599,0,'[]','[]',600,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3117003,'魔蝶',0,0,1,'装备副本8难度二关小boss2',0,3,610,5,2,202008,'1.5','0',0,0,0,202008,0,'0',445,15,3752,17386489,44622,37459,4968,4968,3485,3599,0,'[]','[]',600,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3117004,'魔之护卫',0,0,1,'装备副本8难度三关精英怪1',0,4,610,5,2,202004,'1.2','0',0,0,0,202004,0,'0',440,5,2749,11305934,43702,36611,4793,4793,3397,3503,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3117005,'魔之护卫',0,0,1,'装备副本8难度三关精英怪2',0,5,610,5,2,202004,'1.2','0',0,0,0,202004,0,'0',440,5,2749,11305934,43702,36611,4793,4793,3397,3503,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3117006,'魔之护卫',0,0,1,'装备副本8难度三关精英怪3',0,6,610,5,2,202004,'1.2','0',0,0,0,202004,0,'0',440,5,2749,11305934,43702,36611,4793,4793,3397,3503,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3117007,'魔之领主',0,6,1,'装备副本8难度四关boss',0,7,610,5,2,203006,'1.2','0',0,0,0,203006,0,'0',450,30,10256,31669117,45541,38307,5142,5142,3573,3695,0,'[]','[]',600,2250,500,2250,200,'[{2000230101,1},{2000230102,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3118001,'魔狼',0,0,1,'装备副本9难度一关小怪',0,1,610,5,2,202006,'1.2','0',0,0,0,202006,0,'0',485,1,852,12422346,55144,47377,6933,6933,4910,5112,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3118002,'魔蝶',0,0,1,'装备副本9难度二关小boss1',0,2,610,5,2,202008,'1.5','0',0,0,0,202008,0,'0',495,15,4989,23659416,57888,49969,7444,7444,5292,5517,0,'[]','[]',600,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3118003,'魔蝶',0,0,1,'装备副本9难度二关小boss2',0,3,610,5,2,202008,'1.5','0',0,0,0,202008,0,'0',495,15,4989,23659416,57888,49969,7444,7444,5292,5517,0,'[]','[]',600,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3118004,'魔之护卫',0,0,1,'装备副本9难度三关精英怪1',0,4,610,5,2,202004,'1.2','0',0,0,0,202004,0,'0',490,5,3646,15339890,56516,48673,7188,7188,5101,5315,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3118005,'魔之护卫',0,0,1,'装备副本9难度三关精英怪2',0,5,610,5,2,202004,'1.2','0',0,0,0,202004,0,'0',490,5,3646,15339890,56516,48673,7188,7188,5101,5315,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3118006,'魔之护卫',0,0,1,'装备副本9难度三关精英怪3',0,6,610,5,2,202004,'1.2','0',0,0,0,202004,0,'0',490,5,3646,15339890,56516,48673,7188,7188,5101,5315,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3118007,'魔之领主',0,6,1,'装备副本9难度四关boss',0,7,610,5,2,203006,'1.2','0',0,0,0,203006,0,'0',500,30,13672,43215884,59260,51265,7700,7700,5483,5720,0,'[]','[]',600,2250,500,2250,200,'[{2000230101,1},{2000230102,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3119001,'魔狼',0,0,1,'装备副本10难度一关小怪',0,1,610,5,2,202006,'1.2','0',0,0,0,202006,0,'0',565,1,1276,19053541,79872,70884,14031,14031,9259,9539,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3119002,'魔蝶',0,0,1,'装备副本10难度二关小boss1',0,2,610,5,2,202008,'1.5','0',0,0,0,202008,0,'0',575,15,7406,35912030,83218,74084,14787,14787,9659,9928,0,'[]','[]',600,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3119003,'魔蝶',0,0,1,'装备副本10难度二关小boss2',0,3,610,5,2,202008,'1.5','0',0,0,0,202008,0,'0',575,15,7406,35912030,83218,74084,14787,14787,9659,9928,0,'[]','[]',600,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3119004,'魔之护卫',0,0,1,'装备副本10难度三关精英怪1',0,4,610,5,2,202004,'1.2','0',0,0,0,202004,0,'0',570,5,5435,23402865,81545,72484,14409,14409,9459,9734,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3119005,'魔之护卫',0,0,1,'装备副本10难度三关精英怪2',0,5,610,5,2,202004,'1.2','0',0,0,0,202004,0,'0',570,5,5435,23402865,81545,72484,14409,14409,9459,9734,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3119006,'魔之护卫',0,0,1,'装备副本10难度三关精英怪3',0,6,610,5,2,202004,'1.2','0',0,0,0,202004,0,'0',570,5,5435,23402865,81545,72484,14409,14409,9459,9734,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3119007,'魔之领主',0,6,1,'装备副本10难度四关boss',0,7,610,5,2,203006,'1.2','0',0,0,0,203006,0,'0',580,30,20214,65279191,84891,75684,15165,15165,9859,10123,0,'[]','[]',600,2250,500,2250,200,'[{2000230101,1},{2000230102,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3120001,'魔狼',0,0,1,'装备副本11难度一关小怪',0,1,610,5,2,202006,'1.2','0',0,0,0,202006,0,'0',605,1,1508,22689263,93560,83988,17135,17135,11005,11237,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3120002,'魔蝶',0,0,1,'装备副本11难度二关小boss1',0,2,610,5,2,202008,'1.5','0',0,0,0,202008,0,'0',615,15,8733,42628191,97515,87795,18049,18049,11694,11905,0,'[]','[]',600,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3120003,'魔蝶',0,0,1,'装备副本11难度二关小boss2',0,3,610,5,2,202008,'1.5','0',0,0,0,202008,0,'0',615,15,8733,42628191,97515,87795,18049,18049,11694,11905,0,'[]','[]',600,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3120004,'魔之护卫',0,0,1,'装备副本11难度三关精英怪1',0,4,610,5,2,202004,'1.2','0',0,0,0,202004,0,'0',610,5,6417,27823281,95538,85891,17592,17592,11349,11571,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3120005,'魔之护卫',0,0,1,'装备副本11难度三关精英怪2',0,5,610,5,2,202004,'1.2','0',0,0,0,202004,0,'0',610,5,6417,27823281,95538,85891,17592,17592,11349,11571,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3120006,'魔之护卫',0,0,1,'装备副本11难度三关精英怪3',0,6,610,5,2,202004,'1.2','0',0,0,0,202004,0,'0',610,5,6417,27823281,95538,85891,17592,17592,11349,11571,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3120007,'魔之领主',0,6,1,'装备副本11难度四关boss',0,7,610,5,2,203006,'1.2','0',0,0,0,203006,0,'0',620,30,23805,77371061,99493,89699,18506,18506,12038,12240,0,'[]','[]',600,2250,500,2250,200,'[{2000230101,1},{2000230102,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3121001,'魔狼',0,0,1,'装备副本12难度一关小怪',0,1,610,5,2,202006,'1.2','0',0,0,0,202006,0,'0',665,1,1911,29009257,117506,107067,22497,22497,14699,14845,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3121002,'魔蝶',0,0,1,'装备副本12难度二关小boss1',0,2,610,5,2,202008,'1.5','0',0,0,0,202008,0,'0',675,15,11050,54442614,121606,111032,23329,23329,15095,15244,0,'[]','[]',600,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3121003,'魔蝶',0,0,1,'装备副本12难度二关小boss2',0,3,610,5,2,202008,'1.5','0',0,0,0,202008,0,'0',675,15,11050,54442614,121606,111032,23329,23329,15095,15244,0,'[]','[]',600,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3121004,'魔之护卫',0,0,1,'装备副本12难度三关精英怪1',0,4,610,5,2,202004,'1.2','0',0,0,0,202004,0,'0',670,5,8125,35552918,119556,109050,22913,22913,14897,15045,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3121005,'魔之护卫',0,0,1,'装备副本12难度三关精英怪2',0,5,610,5,2,202004,'1.2','0',0,0,0,202004,0,'0',670,5,8125,35552918,119556,109050,22913,22913,14897,15045,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3121006,'魔之护卫',0,0,1,'装备副本12难度三关精英怪3',0,6,610,5,2,202004,'1.2','0',0,0,0,202004,0,'0',670,5,8125,35552918,119556,109050,22913,22913,14897,15045,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3121007,'魔之领主',0,6,1,'装备副本12难度四关boss',0,7,610,5,2,203006,'1.2','0',0,0,0,203006,0,'0',680,30,30101,98765426,123655,113014,23745,23745,15293,15444,0,'[]','[]',600,2250,500,2250,200,'[{2000230101,1},{2000230102,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3122001,'魔狼',0,0,1,'装备副本13难度一关小怪',0,1,610,5,2,202006,'1.2','0',0,0,0,202006,0,'0',735,1,2431,37172694,147133,135718,27932,27932,17472,17520,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3122002,'魔蝶',0,0,1,'装备副本13难度二关小boss1',0,2,610,5,2,202008,'1.5','0',0,0,0,202008,0,'0',745,15,13896,68880210,151499,139939,28653,28653,17869,17885,0,'[]','[]',600,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3122003,'魔蝶',0,0,1,'装备副本13难度二关小boss2',0,3,610,5,2,202008,'1.5','0',0,0,0,202008,0,'0',745,15,13896,68880210,151499,139939,28653,28653,17869,17885,0,'[]','[]',600,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3122004,'魔之护卫',0,0,1,'装备副本13难度三关精英怪1',0,4,610,5,2,202004,'1.2','0',0,0,0,202004,0,'0',740,5,10275,45264142,149316,137828,28292,28292,17671,17702,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3122005,'魔之护卫',0,0,1,'装备副本13难度三关精英怪2',0,5,610,5,2,202004,'1.2','0',0,0,0,202004,0,'0',740,5,10275,45264142,149316,137828,28292,28292,17671,17702,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3122006,'魔之护卫',0,0,1,'装备副本13难度三关精英怪3',0,6,610,5,2,202004,'1.2','0',0,0,0,202004,0,'0',740,5,10275,45264142,149316,137828,28292,28292,17671,17702,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3122007,'魔之领主',0,6,1,'装备副本13难度四关boss',0,7,610,5,2,203006,'1.2','0',0,0,0,203006,0,'0',750,30,37650,124202062,153682,142050,29013,29013,18067,18067,0,'[]','[]',600,2250,500,2250,200,'[{2000230101,1},{2000230102,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3300101,'失控机械怪人',0,0,1,'洗炼副本怪物简单小怪1',0,6,610,22,2,202015,'1','0',0,0,0,202015,0,'0',235,1,1112,898231,7028,4271,212,212,275,293,0,'[]','[]',250,3000,3000,3000,200,'[{1110000003,1}]',0,0,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3300102,'失控机械怪物',0,0,1,'洗炼副本怪物简单小怪2',0,1,610,22,2,202035,'1','0',0,0,0,202019,0,'0',235,1,799,1257524,7028,4271,212,212,275,293,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3300103,'失控机器人',0,0,1,'洗炼副本怪物简单小怪3',0,2,610,22,2,202015,'1','0',0,0,0,202015,0,'0',240,2,697,1833334,7922,4900,262,262,332,353,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3300104,'失控机械主',0,6,1,'洗炼副本怪物简单boss4',0,3,610,22,2,203008,'1','0',0,0,0,203008,0,'0',250,6,127,7562557,9708,6159,363,363,445,472,0,'[]','[]',600,3000,3000,3000,200,'[{202030081,1},{202030082,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3300105,'通关宝箱',0,0,0,'洗炼副本怪物简单宝箱1',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3300106,'通关宝箱',0,0,0,'洗炼副本怪物简单宝箱2',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3300107,'通关宝箱',0,0,0,'洗炼副本怪物简单宝箱3',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3300108,'通关宝箱',0,0,0,'洗炼副本怪物简单宝箱4',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3300201,'失控机械犬',0,0,1,'洗炼副本机关1简单小怪1',0,6,610,22,2,202016,'1','0',0,0,0,202016,0,'0',235,1,901,817390,5622,3758,204,223,220,322,0,'[]','[]',250,3000,3000,3000,200,'[{1110000003,1}]',0,0,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3300202,'失控机器勇士',0,0,1,'洗炼副本机关1简单小怪2',0,1,610,22,2,202017,'1','0',0,0,0,202017,0,'0',235,1,879,1056320,7590,3417,180,225,259,302,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3300203,'失控斧机器人',0,0,1,'洗炼副本机关1简单小怪3',0,2,610,22,2,202018,'1','0',0,0,0,202018,0,'0',240,1,585,1778334,8001,4263,215,265,342,286,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3300204,'失控领主',0,6,1,'洗炼副本机关1简单boss4',0,3,610,22,2,203007,'1','0',0,0,0,203007,0,'0',250,6,132,7638183,9708,5605,348,356,485,477,0,'[]','[]',600,3000,3000,3000,200,'[{2000230301,1},{2000230303,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3300205,'通关宝箱',0,0,0,'洗炼副本机关1简单宝箱1',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3300206,'通关宝箱',0,0,0,'洗炼副本机关1简单宝箱2',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3300207,'通关宝箱',0,0,0,'洗炼副本机关1简单宝箱3',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3300208,'通关宝箱',0,0,0,'洗炼副本机关1简单宝箱4',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3300301,'失控机械犬',0,0,1,'洗炼副本机关2简单小怪1',0,6,610,22,2,202016,'1','0',0,0,0,202016,0,'0',235,1,979,736549,6395,4442,206,195,303,308,0,'[]','[]',250,3000,3000,3000,200,'[{1110000003,1}]',0,0,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3300302,'失控机器勇士',0,0,1,'洗炼副本机关2简单小怪2',0,1,610,22,2,202017,'1','0',0,0,0,202017,0,'0',235,1,815,1006019,5622,3844,233,180,292,261,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3300303,'失控斧机器人',0,0,1,'洗炼副本机关2简单小怪3',0,2,610,22,2,202018,'1','0',0,0,0,202018,0,'0',240,2,746,1925001,7922,4263,210,254,282,289,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3300304,'失控领主',0,6,1,'洗炼副本机关2简单boss4',0,3,610,22,2,203007,'1','0',0,0,0,203007,0,'0',250,5,107,6201297,8834,6775,396,305,467,496,0,'[]','[]',600,3000,3000,3000,200,'[{2000230301,1},{2000230303,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3300305,'通关宝箱',0,0,0,'洗炼副本机关2简单宝箱1',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3300306,'通关宝箱',0,0,0,'洗炼副本机关2简单宝箱2',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3300307,'通关宝箱',0,0,0,'洗炼副本机关2简单宝箱3',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3300308,'通关宝箱',0,0,0,'洗炼副本机关2简单宝箱4',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3300401,'失控机械犬',0,0,1,'洗炼副本机关3简单小怪1',0,6,610,22,2,202016,'1','0',0,0,0,202016,0,'0',235,1,1112,835355,6887,4527,201,214,220,302,0,'[]','[]',250,3000,3000,3000,200,'[{1110000003,1}]',0,0,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3300402,'失控机器勇士',0,0,1,'洗炼副本机关3简单小怪2',0,1,610,22,2,202017,'1','0',0,0,0,202017,0,'0',235,1,799,1018594,6466,4442,223,223,272,267,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3300403,'失控斧机器人',0,0,1,'洗炼副本机关3简单小怪3',0,2,610,22,2,202018,'1','0',0,0,0,202018,0,'0',240,1,641,1668334,8239,5390,223,252,312,388,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3300404,'失控领主',0,6,1,'洗炼副本机关3简单boss4',0,3,610,22,2,203007,'1','0',0,0,0,203007,0,'0',250,6,116,7335680,8737,5789,385,399,356,514,0,'[]','[]',600,3000,3000,3000,200,'[{2000230301,1},{2000230303,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3300405,'通关宝箱',0,0,0,'洗炼副本机关3简单宝箱1',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3300406,'通关宝箱',0,0,0,'洗炼副本机关3简单宝箱2',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3300407,'通关宝箱',0,0,0,'洗炼副本机关3简单宝箱3',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3300408,'通关宝箱',0,0,0,'洗炼副本机关3简单宝箱4',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3300701,'机械星',10,0,0,'洗炼副本采集怪物1',0,2,610,22,0,2040012,'1.5','effect_monster_caijiwuchangzhu02',0,0,0,2040012,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,1,0,0,0,3,1,0,0,1,0,0,'[]',1,'0',1,0,0,0,0),(3300702,'机械元',10,0,0,'洗炼副本采集怪物2',0,3,610,22,0,2040012,'1.5','effect_monster_caijiwuchangzhu02',0,0,0,2040012,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,1,0,0,0,5,1,0,0,1,0,0,'[]',1,'0',1,0,0,0,0),(3301101,'失控机械怪人',0,0,1,'洗炼副本怪物普通小怪1',0,6,610,22,2,202015,'1','0',0,0,0,202015,0,'0',295,1,2750,2065079,16946,9733,773,773,948,964,0,'[]','[]',250,3000,3000,3000,200,'[{1110000003,1}]',0,0,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3301102,'失控机械怪物',0,0,1,'洗炼副本怪物普通小怪2',0,1,610,22,2,202035,'1','0',0,0,0,202019,0,'0',295,2,1975,2891110,16946,9733,773,773,948,964,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3301103,'失控机器人',0,0,1,'洗炼副本怪物普通小怪3',0,2,610,22,2,202015,'1','0',0,0,0,202015,0,'0',300,3,1611,3878488,17751,10130,819,819,1004,1018,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3301104,'失控机械主',0,6,1,'洗炼副本怪物普通boss4',0,3,610,22,2,203008,'1','0',0,0,0,203008,0,'0',310,10,267,14832511,19480,11784,967,967,1066,1082,0,'[]','[]',600,3000,3000,3000,200,'[{202030081,1},{202030082,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3301105,'通关宝箱',0,0,0,'洗炼副本怪物普通宝箱1',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3301106,'通关宝箱',0,0,0,'洗炼副本怪物普通宝箱2',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3301107,'通关宝箱',0,0,0,'洗炼副本怪物普通宝箱3',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3301108,'通关宝箱',0,0,0,'洗炼副本怪物普通宝箱4',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3301201,'失控机械犬',0,0,1,'洗炼副本机关1普通小怪1',0,6,610,22,2,202016,'1','0',0,0,0,202016,0,'0',295,2,2723,2230285,14235,10706,688,781,1043,810,0,'[]','[]',250,3000,3000,3000,200,'[{1110000003,1}]',0,0,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3301202,'失控机器勇士',0,0,1,'洗炼副本机关1普通小怪2',0,1,610,22,2,202017,'1','0',0,0,0,202017,0,'0',295,2,2153,2573088,17454,8662,804,688,853,848,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3301203,'失控斧机器人',0,0,1,'洗炼副本机关1普通小怪3',0,2,610,22,2,202018,'1','0',0,0,0,202018,0,'0',300,3,1579,4266337,19526,10637,753,844,1044,825,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3301204,'失控领主',0,6,1,'洗炼副本机关1普通boss4',0,3,610,22,2,203007,'1','0',0,0,0,203007,0,'0',310,10,256,15425811,20454,12138,948,919,959,1179,0,'[]','[]',600,3000,3000,3000,200,'[{2000230301,1},{2000230303,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3301205,'通关宝箱',0,0,0,'洗炼副本机关1普通宝箱1',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3301206,'通关宝箱',0,0,0,'洗炼副本机关1普通宝箱2',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3301207,'通关宝箱',0,0,0,'洗炼副本机关1普通宝箱3',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3301208,'通关宝箱',0,0,0,'洗炼副本机关1普通宝箱4',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3301301,'失控机械犬',0,0,1,'洗炼副本机关2普通小怪1',0,6,610,22,2,202016,'1','0',0,0,0,202016,0,'0',295,1,2640,1961825,16438,9246,696,788,995,887,0,'[]','[]',250,3000,3000,3000,200,'[{1110000003,1}]',0,0,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3301302,'失控机器勇士',0,0,1,'洗炼副本机关2普通小怪2',0,1,610,22,2,202017,'1','0',0,0,0,202017,0,'0',295,2,2153,2688732,18641,9636,827,742,777,954,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3301303,'失控斧机器人',0,0,1,'洗炼副本机关2普通小怪3',0,2,610,22,2,202018,'1','0',0,0,0,202018,0,'0',300,3,1740,3839703,15266,10940,745,860,1024,875,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3301304,'失控领主',0,6,1,'洗炼副本机关2普通boss4',0,3,610,22,2,203007,'1','0',0,0,0,203007,0,'0',310,10,267,16019112,19090,10606,996,861,927,1093,0,'[]','[]',600,3000,3000,3000,200,'[{2000230301,1},{2000230303,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3301305,'通关宝箱',0,0,0,'洗炼副本机关2普通宝箱1',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3301306,'通关宝箱',0,0,0,'洗炼副本机关2普通宝箱2',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3301307,'通关宝箱',0,0,0,'洗炼副本机关2普通宝箱3',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3301308,'通关宝箱',0,0,0,'洗炼副本机关2普通宝箱4',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3301401,'失控机械犬',0,0,1,'洗炼副本机关3普通小怪1',0,6,610,22,2,202016,'1','0',0,0,0,202016,0,'0',295,1,2228,1796619,14235,10220,727,773,758,945,0,'[]','[]',250,3000,3000,3000,200,'[{1110000003,1}]',0,0,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3301402,'失控机器勇士',0,0,1,'洗炼副本机关3普通小怪2',0,1,610,22,2,202017,'1','0',0,0,0,202017,0,'0',295,2,2034,2717643,15251,8760,835,719,1033,1041,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3301403,'失控斧机器人',0,0,1,'洗炼副本机关3普通小怪3',0,2,610,22,2,202018,'1','0',0,0,0,202018,0,'0',300,2,1514,3219145,19526,8712,655,753,894,1049,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3301404,'失控领主',0,6,1,'洗炼副本机关3普通boss4',0,3,610,22,2,203007,'1','0',0,0,0,203007,0,'0',310,9,270,14535861,19090,10723,803,1064,895,887,0,'[]','[]',600,3000,3000,3000,200,'[{2000230301,1},{2000230303,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3301405,'通关宝箱',0,0,0,'洗炼副本机关3普通宝箱1',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3301406,'通关宝箱',0,0,0,'洗炼副本机关3普通宝箱2',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3301407,'通关宝箱',0,0,0,'洗炼副本机关3普通宝箱3',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3301408,'通关宝箱',0,0,0,'洗炼副本机关3普通宝箱4',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3301701,'机械星',10,0,0,'洗炼副本采集怪物3',0,2,610,22,0,2040012,'1.5','effect_monster_caijiwuchangzhu02',0,0,0,2040012,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,1,0,0,0,3,1,0,0,1,0,0,'[]',1,'0',1,0,0,0,0),(3301702,'机械元',10,0,0,'洗炼副本采集怪物4',0,3,610,22,0,2040012,'1.5','effect_monster_caijiwuchangzhu02',0,0,0,2040012,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,1,0,0,0,5,1,0,0,1,0,0,'[]',1,'0',1,0,0,0,0),(3302101,'失控机械怪人',0,0,1,'洗炼副本怪物困难小怪1',0,6,610,22,2,202015,'1','0',0,0,0,202015,0,'0',335,2,3996,3270546,23803,15920,1339,1339,1219,1240,0,'[]','[]',250,3000,3000,3000,200,'[{1110000003,1}]',0,0,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3302102,'失控机械怪物',0,0,1,'洗炼副本怪物困难小怪2',0,1,610,22,2,202035,'1','0',0,0,0,202019,0,'0',335,3,2871,4578764,23803,15920,1339,1339,1219,1240,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3302103,'失控机器人',0,0,1,'洗炼副本怪物困难小怪3',0,2,610,22,2,202015,'1','0',0,0,0,202015,0,'0',340,4,2319,6175648,24668,16747,1413,1413,1250,1271,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3302104,'失控机械主',0,6,1,'洗炼副本怪物困难boss4',0,3,610,22,2,203008,'1','0',0,0,0,203008,0,'0',350,13,373,22511214,26397,18402,1562,1562,1311,1335,0,'[]','[]',600,3000,3000,3000,200,'[{202030081,1},{202030082,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3302105,'通关宝箱',0,0,0,'洗炼副本怪物困难宝箱1',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3302106,'通关宝箱',0,0,0,'洗炼副本怪物困难宝箱2',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3302107,'通关宝箱',0,0,0,'洗炼副本怪物困难宝箱3',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3302108,'通关宝箱',0,0,0,'洗炼副本怪物困难宝箱4',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3302201,'失控机械犬',0,0,1,'洗炼副本机关1困难小怪1',0,6,610,22,2,202016,'1','0',0,0,0,202016,0,'0',335,2,3357,3401368,20947,15442,1379,1205,1195,1203,0,'[]','[]',250,3000,3000,3000,200,'[{1110000003,1}]',0,0,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3302202,'失控机器勇士',0,0,1,'洗炼副本机关1困难小怪2',0,1,610,22,2,202017,'1','0',0,0,0,202017,0,'0',335,3,2613,4395613,20709,15602,1071,1312,1256,1128,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3302203,'失控斧机器人',0,0,1,'洗炼副本机关1困难小怪3',0,2,610,22,2,202018,'1','0',0,0,0,202018,0,'0',340,4,1971,6731456,25161,18422,1258,1201,1250,1030,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3302204,'失控领主',0,6,1,'洗炼副本机关1困难boss4',0,3,610,22,2,203007,'1','0',0,0,0,203007,0,'0',350,13,358,22286102,21382,20242,1687,1468,1416,1095,0,'[]','[]',600,3000,3000,3000,200,'[{2000230301,1},{2000230303,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3302205,'通关宝箱',0,0,0,'洗炼副本机关1困难宝箱1',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3302206,'通关宝箱',0,0,0,'洗炼副本机关1困难宝箱2',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3302207,'通关宝箱',0,0,0,'洗炼副本机关1困难宝箱3',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3302208,'通关宝箱',0,0,0,'洗炼副本机关1困难宝箱4',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3302301,'失控机械犬',0,0,1,'洗炼副本机关2困难小怪1',0,6,610,22,2,202016,'1','0',0,0,0,202016,0,'0',335,2,4396,3597601,19518,17512,1125,1299,1304,1302,0,'[]','[]',250,3000,3000,3000,200,'[{1110000003,1}]',0,0,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3302302,'失控机器勇士',0,0,1,'洗炼副本机关2困难小怪2',0,1,610,22,2,202017,'1','0',0,0,0,202017,0,'0',335,2,2699,4029312,22613,15602,1406,1232,1012,1314,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3302303,'失控斧机器人',0,0,1,'洗炼副本机关2困难小怪3',0,2,610,22,2,202018,'1','0',0,0,0,202018,0,'0',340,3,2041,5496327,25408,17417,1314,1371,1338,1182,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3302304,'失控领主',0,6,1,'洗炼副本机关2困难boss4',0,3,610,22,2,203007,'1','0',0,0,0,203007,0,'0',350,13,336,22286102,24285,18218,1578,1468,1350,1282,0,'[]','[]',600,3000,3000,3000,200,'[{2000230301,1},{2000230303,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3302305,'通关宝箱',0,0,0,'洗炼副本机关2困难宝箱1',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3302306,'通关宝箱',0,0,0,'洗炼副本机关2困难宝箱2',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3302307,'通关宝箱',0,0,0,'洗炼副本机关2困难宝箱3',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3302308,'通关宝箱',0,0,0,'洗炼副本机关2困难宝箱4',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3302401,'失控机械犬',0,0,1,'洗炼副本机关3困难小怪1',0,6,610,22,2,202016,'1','0',0,0,0,202016,0,'0',335,2,4156,2779964,25707,16398,1299,1125,1329,1079,0,'[]','[]',250,3000,3000,3000,200,'[{1110000003,1}]',0,0,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3302402,'失控机器勇士',0,0,1,'洗炼副本机关3困难小怪2',0,1,610,22,2,202017,'1','0',0,0,0,202017,0,'0',335,3,2756,4578764,26183,14965,1138,1085,987,1128,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3302403,'失控斧机器人',0,0,1,'洗炼副本机关3困难小怪3',0,2,610,22,2,202018,'1','0',0,0,0,202018,0,'0',340,4,2087,6731456,20968,17752,1470,1229,1188,1017,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3302404,'失控领主',0,6,1,'洗炼副本机关3困难boss4',0,3,610,22,2,203007,'1','0',0,0,0,203007,0,'0',350,11,321,19134532,26397,18586,1484,1671,1154,1228,0,'[]','[]',600,3000,3000,3000,200,'[{2000230301,1},{2000230303,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3302405,'通关宝箱',0,0,0,'洗炼副本机关3困难宝箱1',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3302406,'通关宝箱',0,0,0,'洗炼副本机关3困难宝箱2',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3302407,'通关宝箱',0,0,0,'洗炼副本机关3困难宝箱3',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3302408,'通关宝箱',0,0,0,'洗炼副本机关3困难宝箱4',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3302701,'机械星',10,0,0,'洗炼副本采集怪物5',0,2,610,22,0,2040012,'1.5','effect_monster_caijiwuchangzhu02',0,0,0,2040012,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,1,0,0,0,3,1,0,0,1,0,0,'[]',1,'0',1,0,0,0,0),(3302702,'机械元',10,0,0,'洗炼副本采集怪物6',0,3,610,22,0,2040012,'1.5','effect_monster_caijiwuchangzhu02',0,0,0,2040012,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,1,0,0,0,5,1,0,0,1,0,0,'[]',1,'0',1,0,0,0,0),(3303101,'失控机械怪人',0,0,1,'洗炼副本怪物噩梦小怪1',0,6,610,22,2,202015,'1','0',0,0,0,202015,0,'0',385,3,5829,5506635,33355,26395,2845,2845,2278,2316,0,'[]','[]',250,3000,3000,3000,200,'[{1110000003,1}]',0,0,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3303102,'失控机械怪物',0,0,1,'洗炼副本怪物噩梦小怪2',0,1,610,22,2,202035,'1','0',0,0,0,202019,0,'0',385,4,4188,7709289,33355,26395,2845,2845,2278,2316,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3303103,'失控机器人',0,0,1,'洗炼副本怪物噩梦小怪3',0,2,610,22,2,202015,'1','0',0,0,0,202015,0,'0',390,5,3361,10365495,34349,27537,3029,3029,2416,2457,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3303104,'失控机械主',0,6,1,'洗炼副本怪物噩梦boss4',0,3,610,22,2,203008,'1','0',0,0,0,203008,0,'0',400,19,534,37579030,36338,29821,3395,3395,2692,2737,0,'[]','[]',600,3000,3000,3000,200,'[{202030081,1},{202030082,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3303105,'通关宝箱',0,0,0,'洗炼副本怪物噩梦宝箱1',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3303106,'通关宝箱',0,0,0,'洗炼副本怪物噩梦宝箱2',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3303107,'通关宝箱',0,0,0,'洗炼副本怪物噩梦宝箱3',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3303108,'通关宝箱',0,0,0,'洗炼副本怪物噩梦宝箱4',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3303201,'失控机械犬',0,0,1,'洗炼副本机关1噩梦小怪1',0,6,610,22,2,202016,'1','0',0,0,0,202016,0,'0',385,3,6354,5616768,34356,27979,2333,2902,2096,2131,0,'[]','[]',250,3000,3000,3000,200,'[{1110000003,1}]',0,0,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3303202,'失控机器勇士',0,0,1,'洗炼副本机关1噩梦小怪2',0,1,610,22,2,202017,'1','0',0,0,0,202017,0,'0',385,4,4188,8403125,36357,23756,2561,2760,2392,2432,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3303203,'失控斧机器人',0,0,1,'洗炼副本机关1噩梦小怪3',0,2,610,22,2,202018,'1','0',0,0,0,202018,0,'0',390,5,3361,10158185,34349,28363,3302,2635,2440,2015,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3303204,'失控领主',0,6,1,'洗炼副本机关1噩梦boss4',0,3,610,22,2,203007,'1','0',0,0,0,203007,0,'0',400,16,507,31190595,39972,28330,3361,3293,2342,2737,0,'[]','[]',600,3000,3000,3000,200,'[{2000230301,1},{2000230303,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3303205,'通关宝箱',0,0,0,'洗炼副本机关1噩梦宝箱1',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3303206,'通关宝箱',0,0,0,'洗炼副本机关1噩梦宝箱2',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3303207,'通关宝箱',0,0,0,'洗炼副本机关1噩梦宝箱3',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3303208,'通关宝箱',0,0,0,'洗炼副本机关1噩梦宝箱4',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3303301,'失控机械犬',0,0,1,'洗炼副本机关2噩梦小怪1',0,6,610,22,2,202016,'1','0',0,0,0,202016,0,'0',385,3,5771,5121171,36023,25867,2959,2276,2073,2293,0,'[]','[]',250,3000,3000,3000,200,'[{1110000003,1}]',0,0,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3303302,'失控机器勇士',0,0,1,'洗炼副本机关2噩梦小怪2',0,1,610,22,2,202017,'1','0',0,0,0,202017,0,'0',385,4,3476,7786382,31687,24019,2731,2532,1845,2455,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3303303,'失控斧机器人',0,0,1,'洗炼副本机关2噩梦小怪3',0,2,610,22,2,202018,'1','0',0,0,0,202018,0,'0',390,5,3126,10158185,29884,23682,2726,2756,2247,2383,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3303304,'失控领主',0,6,1,'洗炼副本机关2噩梦boss4',0,3,610,22,2,203007,'1','0',0,0,0,203007,0,'0',400,18,438,35700079,39245,24453,3361,3429,2746,2299,0,'[]','[]',600,3000,3000,3000,200,'[{2000230301,1},{2000230303,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3303305,'通关宝箱',0,0,0,'洗炼副本机关2噩梦宝箱1',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3303306,'通关宝箱',0,0,0,'洗炼副本机关2噩梦宝箱2',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3303307,'通关宝箱',0,0,0,'洗炼副本机关2噩梦宝箱3',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3303308,'通关宝箱',0,0,0,'洗炼副本机关2噩梦宝箱4',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3303401,'失控机械犬',0,0,1,'洗炼副本机关3噩梦小怪1',0,6,610,22,2,202016,'1','0',0,0,0,202016,0,'0',385,2,5246,4680640,34022,21908,2674,2333,1868,2293,0,'[]','[]',250,3000,3000,3000,200,'[{1110000003,1}]',0,0,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3303402,'失控机器勇士',0,0,1,'洗炼副本机关3噩梦小怪2',0,1,610,22,2,202017,'1','0',0,0,0,202017,0,'0',385,3,4272,6398710,27351,21116,2873,2873,2324,2061,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3303403,'失控斧机器人',0,0,1,'洗炼副本机关3噩梦小怪3',0,2,610,22,2,202018,'1','0',0,0,0,202018,0,'0',390,6,3159,10987425,36753,23957,2847,3180,2440,2604,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3303404,'失控领主',0,6,1,'洗炼副本机关3噩梦boss4',0,3,610,22,2,203007,'1','0',0,0,0,203007,0,'0',400,15,497,30439014,32704,25050,3327,3531,2530,2819,0,'[]','[]',600,3000,3000,3000,200,'[{2000230301,1},{2000230303,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3303405,'通关宝箱',0,0,0,'洗炼副本机关3噩梦宝箱1',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3303406,'通关宝箱',0,0,0,'洗炼副本机关3噩梦宝箱2',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3303407,'通关宝箱',0,0,0,'洗炼副本机关3噩梦宝箱3',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3303408,'通关宝箱',0,0,0,'洗炼副本机关3噩梦宝箱4',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3303701,'机械星',10,0,0,'洗炼副本采集怪物7',0,2,610,22,0,2040012,'1.5','effect_monster_caijiwuchangzhu02',0,0,0,2040012,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,1,0,0,0,3,1,0,0,1,0,0,'[]',1,'0',1,0,0,0,0),(3303702,'机械元',10,0,0,'洗炼副本采集怪物8',0,3,610,22,0,2040012,'1.5','effect_monster_caijiwuchangzhu02',0,0,0,2040012,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,1,0,0,0,5,1,0,0,1,0,0,'[]',1,'0',1,0,0,0,0),(3304101,'失控机械怪人',0,0,1,'洗炼副本怪物炼狱小怪1',0,6,610,22,2,202015,'1','0',0,0,0,202015,0,'0',505,5,11372,11600452,60792,52720,8219,8219,5801,6043,0,'[]','[]',250,3000,3000,3000,200,'[{1110000003,1}]',0,0,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3304102,'失控机械怪物',0,0,1,'洗炼副本怪物炼狱小怪2',0,1,610,22,2,202035,'1','0',0,0,0,202019,0,'0',505,6,8169,16240633,60792,52720,8219,8219,5801,6043,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3304103,'失控机器人',0,0,1,'洗炼副本怪物炼狱小怪3',0,2,610,22,2,202015,'1','0',0,0,0,202015,0,'0',510,8,6526,21511057,62350,54200,8739,8739,6118,6367,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3304104,'失控机械主',0,6,1,'洗炼副本怪物炼狱boss4',0,3,610,22,2,203008,'1','0',0,0,0,203008,0,'0',520,29,1028,75903746,65466,57161,9778,9778,6753,7014,0,'[]','[]',600,3000,3000,3000,200,'[{202030081,1},{202030082,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3304105,'通关宝箱',0,0,0,'洗炼副本怪物炼狱宝箱1',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3304106,'通关宝箱',0,0,0,'洗炼副本怪物炼狱宝箱2',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3304107,'通关宝箱',0,0,0,'洗炼副本怪物炼狱宝箱3',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3304108,'通关宝箱',0,0,0,'洗炼副本怪物炼狱宝箱4',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3304201,'失控机械犬',0,0,1,'洗炼副本机关1炼狱小怪1',0,6,610,22,2,202016,'1','0',0,0,0,202016,0,'0',505,4,12282,11020429,54105,56938,7808,7233,5337,4834,0,'[]','[]',250,3000,3000,3000,200,'[{1110000003,1}]',0,0,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3304202,'失控机器勇士',0,0,1,'洗炼副本机关1炼狱小怪2',0,1,610,22,2,202017,'1','0',0,0,0,202017,0,'0',505,5,7515,13317319,62616,47448,8712,8877,5569,6285,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3304203,'失控斧机器人',0,0,1,'洗炼副本机关1炼狱小怪3',0,2,610,22,2,202018,'1','0',0,0,0,202018,0,'0',510,8,6526,20220394,67962,55284,9089,7603,4956,5985,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3304204,'失控领主',0,6,1,'洗炼副本机关1炼狱boss4',0,3,610,22,2,203007,'1','0',0,0,0,203007,0,'0',520,29,843,76662783,65466,53160,9289,9582,5943,7575,0,'[]','[]',600,3000,3000,3000,200,'[{2000230301,1},{2000230303,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3304205,'通关宝箱',0,0,0,'洗炼副本机关1炼狱宝箱1',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3304206,'通关宝箱',0,0,0,'洗炼副本机关1炼狱宝箱2',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3304207,'通关宝箱',0,0,0,'洗炼副本机关1炼狱宝箱3',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3304208,'通关宝箱',0,0,0,'洗炼副本机关1炼狱宝箱4',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3304301,'失控机械犬',0,0,1,'洗炼副本机关2炼狱小怪1',0,6,610,22,2,202016,'1','0',0,0,0,202016,0,'0',505,4,10007,9628375,63224,49557,7151,7479,6033,5680,0,'[]','[]',250,3000,3000,3000,200,'[{1110000003,1}]',0,0,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3304302,'失控机器勇士',0,0,1,'洗炼副本机关2炼狱小怪2',0,1,610,22,2,202017,'1','0',0,0,0,202017,0,'0',505,6,6535,16403039,66871,55356,8219,9041,6323,5801,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3304303,'失控斧机器人',0,0,1,'洗炼副本机关2炼狱小怪3',0,2,610,22,2,202018,'1','0',0,0,0,202018,0,'0',510,8,5547,21511057,67962,57452,9526,6991,4894,6431,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3304304,'失控领主',0,6,1,'洗炼副本机关2炼狱boss4',0,3,610,22,2,203007,'1','0',0,0,0,203007,0,'0',520,25,1079,65277222,62193,53731,10462,10365,6821,5962,0,'[]','[]',600,3000,3000,3000,200,'[{2000230301,1},{2000230303,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3304305,'通关宝箱',0,0,0,'洗炼副本机关2炼狱宝箱1',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3304306,'通关宝箱',0,0,0,'洗炼副本机关2炼狱宝箱2',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3304307,'通关宝箱',0,0,0,'洗炼副本机关2炼狱宝箱3',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3304308,'通关宝箱',0,0,0,'洗炼副本机关2炼狱宝箱4',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3304401,'失控机械犬',0,0,1,'洗炼副本机关3炼狱小怪1',0,6,610,22,2,202016,'1','0',0,0,0,202016,0,'0',505,4,12054,9628375,62616,46921,7726,7151,4873,6043,0,'[]','[]',250,3000,3000,3000,200,'[{1110000003,1}]',0,0,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3304402,'失控机器勇士',0,0,1,'洗炼副本机关3炼狱小怪2',0,1,610,22,2,202017,'1','0',0,0,0,202017,0,'0',505,6,7352,16078227,55929,48502,8137,6740,5801,5801,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3304403,'失控斧机器人',0,0,1,'洗炼副本机关3炼狱小怪3',0,2,610,22,2,202018,'1','0',0,0,0,202018,0,'0',510,9,6395,22801720,52374,45528,7253,8826,4894,7004,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3304404,'失控领主',0,6,1,'洗炼副本机关3炼狱boss4',0,3,610,22,2,203007,'1','0',0,0,0,203007,0,'0',520,32,956,82735083,72013,59447,8996,9974,5605,5962,0,'[]','[]',600,3000,3000,3000,200,'[{2000230301,1},{2000230303,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3304405,'通关宝箱',0,0,0,'洗炼副本机关3炼狱宝箱1',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3304406,'通关宝箱',0,0,0,'洗炼副本机关3炼狱宝箱2',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3304407,'通关宝箱',0,0,0,'洗炼副本机关3炼狱宝箱3',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3304408,'通关宝箱',0,0,0,'洗炼副本机关3炼狱宝箱4',0,5,610,22,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(3304701,'机械星',10,0,0,'洗炼副本采集怪物9',0,2,610,22,0,2040012,'1.5','effect_monster_caijiwuchangzhu02',0,0,0,2040012,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,1,0,0,0,3,1,0,0,1,0,0,'[]',1,'0',1,0,0,0,0),(3304702,'机械元',10,0,0,'洗炼副本采集怪物10',0,3,610,22,0,2040012,'1.5','effect_monster_caijiwuchangzhu02',0,0,0,2040012,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,3000,3000,3000,200,'[{1110000003,1}]',0,2000,0,1,0,0,0,5,1,0,0,1,0,0,'[]',1,'0',1,0,0,0,0),(4061021,'左据点',0,6,0,'跨服海战据点1',0,1,0,0,2,4061021,'1','0',0,0,0,4061001,0,'10||攻击雕像可占领据点:80',500,100,297,39325891,11419,10113,28149,3503,2126,14098,0,'[]','[]',0,0,0,0,0,'[]',0,0,0,0,0,0,0,0,0,0,1,1,1,0,'[]',1,'0',1,0,0,0,0),(4061022,'右据点',0,6,0,'跨服海战据点2',0,1,0,0,2,4061022,'1','0',0,0,0,4061001,0,'10||攻击雕像可占领据点:80',500,100,297,39325891,11419,10113,28149,3503,2126,14098,0,'[]','[]',0,0,0,0,0,'[]',0,0,0,0,0,0,0,0,0,0,1,1,1,0,'[]',1,'0',1,0,0,0,0),(4061023,'王者据点',0,6,0,'跨服海战据点3',0,1,0,0,2,4061023,'0.9','0',0,0,0,4061001,0,'10||攻击雕像可占领据点:80',500,100,198,70786603,11419,10113,28149,3503,2126,14098,0,'[]','[]',0,0,0,0,0,'[]',0,0,0,0,0,0,0,0,0,0,1,1,1,0,'[]',1,'0',1,0,0,0,0),(4061024,'史前巨鳄',0,1,1,'跨服海战怪物1',0,3,0,0,2,202023,'1','0',0,0,0,202023,0,'0',500,10,8897,170412,11419,10113,28149,3503,2126,14098,0,'[]','[]',100,600,600,0,200,'[]',5000,2000,0,1,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,1),(4061025,'海盗领主',0,1,1,'跨服海战怪物2',0,4,0,0,2,460105,'3','0',0,0,0,1202004,0,'0',500,50,7118,4915736,11419,10113,28149,3503,2026,14098,0,'[]','[]',100,600,600,0,200,'[{17000001,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,1),(4101001,'熔岩领主',0,6,1,'公会答题召唤boss1',0,6,0,0,0,203025,'1.4','0',0,0,0,203025,0,'0',200,100,5,180000,0,0,0,0,0,0,0,'[]','[]',600,600,600,0,200,'[{202030251,1},{202030252,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,0,0,'[1000,1000]',1,'0',0,0,0,0,1),(4101002,'半人马',0,6,1,'公会答题召唤boss2',0,4,0,0,0,203002,'1.4','0',0,0,0,203002,0,'0',200,100,5,150000,0,0,0,0,0,0,0,'[]','[]',600,600,600,0,200,'[{200022011,1},{200022014,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,0,0,'[1000,1000]',1,'0',0,0,0,0,1),(4101003,'阿努比斯',0,6,1,'公会答题召唤boss3',0,3,0,0,0,203005,'1.4','0',0,0,0,203005,0,'0',200,100,5,120000,0,0,0,0,0,0,0,'[]','[]',600,600,600,0,200,'[{202030051,1},{202030052,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,0,0,'[1000,1000]',1,'0',0,0,0,0,1),(4201090,'帝国机械先锋',6,6,1,'公会守卫bossid',0,1,0,0,1,203008,'1.6','0',0,0,0,203008,0,'0',5,100,1,1,0,0,0,0,0,0,0,'[]','[]',600,2250,1500,2250,150,'[{202030081,1},{202030082,1}]',0,1000,0,0,1,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,2,0,0),(4201100,'水晶',0,0,1,'公会守卫基地id',0,1,0,0,0,41020003,'2.6','0',0,0,0,41020003,0,'0',5,1,1,27000,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,0,'[]',0,1000,0,0,0,0,0,0,0,1,1,1,1,0,'[5,5]',1,'0',0,0,0,0,0),(4201101,'上塔',7,0,1,'公会守卫1号防御塔id',0,1,0,0,0,2050012,'1','0',0,0,0,2050012,0,'0',5,1,1,9000,0,0,0,0,0,0,0,'[]','[]',800,2250,1500,2250,0,'[]',0,1000,0,0,0,0,0,0,0,1,1,1,1,0,'[5,5]',1,'0',0,0,0,0,0),(4201102,'中塔',7,0,1,'公会守卫2号防御塔id',0,1,0,0,0,2050012,'1','0',0,0,0,2050012,0,'0',5,1,1,9000,0,0,0,0,0,0,0,'[]','[]',800,2250,1500,2250,0,'[]',0,1000,0,0,0,0,0,0,0,1,1,1,1,0,'[5,5]',1,'0',0,0,0,0,0),(4201103,'下塔',7,0,1,'公会守卫3号防御塔id',0,1,0,0,0,2050012,'1','0',0,0,0,2050012,0,'0',5,1,1,9000,0,0,0,0,0,0,0,'[]','[]',800,2250,1500,2250,0,'[]',0,1000,0,0,0,0,0,0,0,1,1,1,1,0,'[5,5]',1,'0',0,0,0,0,0),(4201111,'帝国军用机1型',6,0,1,'公会守卫第1波第1轮1号起点小怪',0,1,0,0,1,202018,'1.4','0',0,0,0,202018,0,'0',5,1,1,1,0,0,0,0,0,0,0,'[]','[]',150,2250,1500,2250,100,'[{1110000001,1}]',0,1000,0,0,1,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(4201112,'帝国军用机1型',6,0,1,'公会守卫第1波第2轮1号起点小怪',0,1,0,0,1,202018,'1.4','0',0,0,0,202018,0,'0',5,1,1,1,0,0,0,0,0,0,0,'[]','[]',150,2250,1500,2250,100,'[{1110000001,1}]',0,1000,0,0,1,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(4201121,'帝国军团勇士',6,0,1,'公会守卫第2波第1轮1号起点小怪',0,1,0,0,1,202017,'1.2','0',0,0,0,202017,0,'0',5,1,1,1,0,0,0,0,0,0,0,'[]','[]',250,2250,1500,2250,100,'[{1110000003,1}]',0,1000,0,0,1,1,0,0,0,0,1,1,1,0,'[]',1,'0',0,0,2,0,0),(4201122,'帝国军团勇士',6,0,1,'公会守卫第2波第2轮1号起点小怪',0,1,0,0,1,202017,'1.2','0',0,0,0,202017,0,'0',5,1,1,1,0,0,0,0,0,0,0,'[]','[]',250,2250,1500,2250,100,'[{1110000003,1}]',0,1000,0,0,1,1,0,0,0,0,1,1,1,0,'[]',1,'0',0,0,2,0,0),(4201131,'帝国军团勇士',6,0,1,'公会守卫第3波第1轮1号起点小怪',0,1,0,0,1,202017,'1.2','0',0,0,0,202017,0,'0',5,1,1,1,0,0,0,0,0,0,0,'[]','[]',250,2250,1500,2250,100,'[{1110000003,1}]',0,1000,0,0,1,1,0,0,0,0,1,1,1,0,'[]',1,'0',0,0,2,0,0),(4201132,'帝国杀手机器人',6,0,1,'公会守卫第3波第2轮1号起点小怪',0,1,0,0,1,202015,'1','0',0,0,0,202015,0,'0',5,1,1,1,0,0,0,0,0,0,0,'[]','[]',150,2250,1500,2250,100,'[{1110000001,1}]',0,1000,0,0,1,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(4201141,'帝国杀手机器人',6,0,1,'公会守卫第4波第1轮1号起点小怪',0,1,0,0,1,202015,'1','0',0,0,0,202015,0,'0',5,1,1,1,0,0,0,0,0,0,0,'[]','[]',150,2250,1500,2250,100,'[{1110000001,1}]',0,1000,0,0,1,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(4201142,'帝国杀手机器人',6,0,1,'公会守卫第4波第2轮1号起点小怪',0,1,0,0,1,202015,'1','0',0,0,0,202015,0,'0',5,1,1,1,0,0,0,0,0,0,0,'[]','[]',150,2250,1500,2250,100,'[{1110000001,1}]',0,1000,0,0,1,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(4201151,'帝国军用机4型',6,0,1,'公会守卫第5波第1轮1号起点小怪',0,1,0,0,1,202018,'1.4','0',0,0,0,202018,0,'0',5,1,1,1,0,0,0,0,0,0,0,'[]','[]',150,2250,1500,2250,100,'[{1110000001,1}]',0,1000,0,0,1,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(4201152,'帝国杀手机器人',6,0,1,'公会守卫第5波第2轮1号起点小怪',0,1,0,0,1,202015,'1','0',0,0,0,202015,0,'0',5,1,1,1,0,0,0,0,0,0,0,'[]','[]',150,2250,1500,2250,100,'[{1110000001,1}]',0,1000,0,0,1,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(4201161,'帝国军团勇士',6,0,1,'公会守卫第6波第1轮1号起点小怪',0,1,0,0,1,202017,'1.2','0',0,0,0,202017,0,'0',5,1,1,1,0,0,0,0,0,0,0,'[]','[]',250,2250,1500,2250,100,'[{1110000003,1}]',0,1000,0,0,1,1,0,0,0,0,1,1,1,0,'[]',1,'0',0,0,2,0,0),(4201162,'帝国杀手机器人',6,0,1,'公会守卫第6波第2轮1号起点小怪',0,1,0,0,1,202015,'1','0',0,0,0,202015,0,'0',5,1,1,1,0,0,0,0,0,0,0,'[]','[]',150,2250,1500,2250,100,'[{1110000001,1}]',0,1000,0,0,1,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(4201171,'帝国军用机5型',6,0,1,'公会守卫第7波第1轮1号起点小怪',0,1,0,0,1,202018,'1.4','0',0,0,0,202018,0,'0',5,1,1,1,0,0,0,0,0,0,0,'[]','[]',150,2250,1500,2250,100,'[{1110000001,1}]',0,1000,0,0,1,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(4201172,'帝国杀手机器人',6,0,1,'公会守卫第7波第2轮1号起点小怪',0,1,0,0,1,202015,'1','0',0,0,0,202015,0,'0',5,1,1,1,0,0,0,0,0,0,0,'[]','[]',150,2250,1500,2250,100,'[{1110000001,1}]',0,1000,0,0,1,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(4201181,'帝国军团勇士',6,0,1,'公会守卫第8波第1轮1号起点小怪',0,1,0,0,1,202017,'1.2','0',0,0,0,202017,0,'0',5,1,1,1,0,0,0,0,0,0,0,'[]','[]',250,2250,1500,2250,100,'[{1110000003,1}]',0,1000,0,0,1,1,0,0,0,0,1,1,1,0,'[]',1,'0',0,0,2,0,0),(4201182,'帝国军用机6型',6,0,1,'公会守卫第8波第2轮1号起点小怪',0,1,0,0,1,202018,'1.4','0',0,0,0,202018,0,'0',5,1,1,1,0,0,0,0,0,0,0,'[]','[]',150,2250,1500,2250,100,'[{1110000001,1}]',0,1000,0,0,1,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(4201211,'帝国军团勇士',6,0,1,'公会守卫第1波第2轮2号起点小怪',0,1,0,0,1,202017,'1.2','0',0,0,0,202017,0,'0',5,1,1,1,0,0,0,0,0,0,0,'[]','[]',250,2250,1500,2250,100,'[{1110000003,1}]',0,1000,0,0,1,1,0,0,0,0,1,1,1,0,'[]',1,'0',0,0,2,0,0),(4201212,'帝国军团勇士',6,0,1,'公会守卫第1波第2轮2号起点小怪',0,1,0,0,1,202017,'1.2','0',0,0,0,202017,0,'0',5,1,1,1,0,0,0,0,0,0,0,'[]','[]',250,2250,1500,2250,100,'[{1110000003,1}]',0,1000,0,0,1,1,0,0,0,0,1,1,1,0,'[]',1,'0',0,0,2,0,0),(4201221,'帝国杀手机器人',6,0,1,'公会守卫第2波第1轮2号起点小怪',0,1,0,0,1,202015,'1','0',0,0,0,202015,0,'0',5,1,1,1,0,0,0,0,0,0,0,'[]','[]',150,2250,1500,2250,100,'[{1110000001,1}]',0,1000,0,0,1,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(4201222,'帝国杀手机器人',6,0,1,'公会守卫第2波第2轮2号起点小怪',0,1,0,0,1,202015,'1','0',0,0,0,202015,0,'0',5,1,1,1,0,0,0,0,0,0,0,'[]','[]',150,2250,1500,2250,100,'[{1110000001,1}]',0,1000,0,0,1,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(4201231,'帝国杀手机器人',6,0,1,'公会守卫第3波第1轮2号起点小怪',0,1,0,0,1,202015,'1','0',0,0,0,202015,0,'0',5,1,1,1,0,0,0,0,0,0,0,'[]','[]',150,2250,1500,2250,100,'[{1110000001,1}]',0,1000,0,0,1,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(4201232,'帝国军用机3型',6,0,1,'公会守卫第3波第2轮2号起点小怪',0,1,0,0,1,202018,'1.4','0',0,0,0,202018,0,'0',5,1,1,1,0,0,0,0,0,0,0,'[]','[]',150,2250,1500,2250,100,'[{1110000001,1}]',0,1000,0,0,1,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(4201241,'帝国军用机3型',6,0,1,'公会守卫第4波第1轮2号起点小怪',0,1,0,0,1,202018,'1.4','0',0,0,0,202018,0,'0',5,1,1,1,0,0,0,0,0,0,0,'[]','[]',150,2250,1500,2250,100,'[{1110000001,1}]',0,1000,0,0,1,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(4201242,'帝国军团勇士',6,0,1,'公会守卫第4波第2轮2号起点小怪',0,1,0,0,1,202017,'1.2','0',0,0,0,202017,0,'0',5,1,1,1,0,0,0,0,0,0,0,'[]','[]',250,2250,1500,2250,100,'[{1110000003,1}]',0,1000,0,0,1,1,0,0,0,0,1,1,1,0,'[]',1,'0',0,0,2,0,0),(4201251,'帝国杀手机器人',6,0,1,'公会守卫第5波第1轮2号起点小怪',0,1,0,0,1,202015,'1','0',0,0,0,202015,0,'0',5,1,1,1,0,0,0,0,0,0,0,'[]','[]',150,2250,1500,2250,100,'[{1110000001,1}]',0,1000,0,0,1,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(4201252,'帝国军用机4型',6,0,1,'公会守卫第5波第2轮2号起点小怪',0,1,0,0,1,202018,'1.4','0',0,0,0,202018,0,'0',5,1,1,1,0,0,0,0,0,0,0,'[]','[]',150,2250,1500,2250,100,'[{1110000001,1}]',0,1000,0,0,1,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(4201261,'帝国军团勇士',6,0,1,'公会守卫第6波第1轮2号起点小怪',0,1,0,0,1,202017,'1.2','0',0,0,0,202017,0,'0',5,1,1,1,0,0,0,0,0,0,0,'[]','[]',250,2250,1500,2250,100,'[{1110000003,1}]',0,1000,0,0,1,1,0,0,0,0,1,1,1,0,'[]',1,'0',0,0,2,0,0),(4201262,'帝国军团勇士',6,0,1,'公会守卫第6波第2轮2号起点小怪',0,1,0,0,1,202017,'1.2','0',0,0,0,202017,0,'0',5,1,1,1,0,0,0,0,0,0,0,'[]','[]',250,2250,1500,2250,100,'[{1110000003,1}]',0,1000,0,0,1,1,0,0,0,0,1,1,1,0,'[]',1,'0',0,0,2,0,0),(4201271,'帝国杀手机器人',6,0,1,'公会守卫第7波第1轮2号起点小怪',0,1,0,0,1,202015,'1','0',0,0,0,202015,0,'0',5,1,1,1,0,0,0,0,0,0,0,'[]','[]',150,2250,1500,2250,100,'[{1110000001,1}]',0,1000,0,0,1,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(4201272,'帝国军团勇士',6,0,1,'公会守卫第7波第2轮2号起点小怪',0,1,0,0,1,202017,'1.2','0',0,0,0,202017,0,'0',5,1,1,1,0,0,0,0,0,0,0,'[]','[]',250,2250,1500,2250,100,'[{1110000003,1}]',0,1000,0,0,1,1,0,0,0,0,1,1,1,0,'[]',1,'0',0,0,2,0,0),(4201281,'帝国杀手机器人',6,0,1,'公会守卫第8波第1轮2号起点小怪',0,1,0,0,1,202015,'1','0',0,0,0,202015,0,'0',5,1,1,1,0,0,0,0,0,0,0,'[]','[]',150,2250,1500,2250,100,'[{1110000001,1}]',0,1000,0,0,1,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(4201282,'帝国杀手机器人',6,0,1,'公会守卫第8波第2轮2号起点小怪',0,1,0,0,1,202015,'1','0',0,0,0,202015,0,'0',5,1,1,1,0,0,0,0,0,0,0,'[]','[]',150,2250,1500,2250,100,'[{1110000001,1}]',0,1000,0,0,1,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(4201311,'帝国杀手机器人',6,0,1,'公会守卫第1波第1轮3号起点小怪',0,1,0,0,1,202015,'1','0',0,0,0,202015,0,'0',5,1,1,1,0,0,0,0,0,0,0,'[]','[]',150,2250,1500,2250,100,'[{1110000001,1}]',0,1000,0,0,1,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(4201312,'帝国杀手机器人',6,0,1,'公会守卫第1波第2轮3号起点小怪',0,1,0,0,1,202015,'1','0',0,0,0,202015,0,'0',5,1,1,1,0,0,0,0,0,0,0,'[]','[]',150,2250,1500,2250,100,'[{1110000001,1}]',0,1000,0,0,1,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(4201321,'帝国军用机2型',6,0,1,'公会守卫第2波第1轮3号起点小怪',0,1,0,0,1,202018,'1.4','0',0,0,0,202018,0,'0',5,1,1,1,0,0,0,0,0,0,0,'[]','[]',150,2250,1500,2250,100,'[{1110000001,1}]',0,1000,0,0,1,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(4201322,'帝国军用机2型',6,0,1,'公会守卫第2波第2轮3号起点小怪',0,1,0,0,1,202018,'1.4','0',0,0,0,202018,0,'0',5,1,1,1,0,0,0,0,0,0,0,'[]','[]',150,2250,1500,2250,100,'[{1110000001,1}]',0,1000,0,0,1,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(4201331,'帝国军团勇士',6,0,1,'公会守卫第3波第1轮3号起点小怪',0,1,0,0,1,202017,'1.2','0',0,0,0,202017,0,'0',5,1,1,1,0,0,0,0,0,0,0,'[]','[]',250,2250,1500,2250,100,'[{1110000003,1}]',0,1000,0,0,1,1,0,0,0,0,1,1,1,0,'[]',1,'0',0,0,2,0,0),(4201332,'帝国军团勇士',6,0,1,'公会守卫第3波第2轮3号起点小怪',0,1,0,0,1,202017,'1.2','0',0,0,0,202017,0,'0',5,1,1,1,0,0,0,0,0,0,0,'[]','[]',250,2250,1500,2250,100,'[{1110000003,1}]',0,1000,0,0,1,1,0,0,0,0,1,1,1,0,'[]',1,'0',0,0,2,0,0),(4201341,'帝国军团勇士',6,0,1,'公会守卫第4波第1轮3号起点小怪',0,1,0,0,1,202017,'1.2','0',0,0,0,202017,0,'0',5,1,1,1,0,0,0,0,0,0,0,'[]','[]',250,2250,1500,2250,100,'[{1110000003,1}]',0,1000,0,0,1,1,0,0,0,0,1,1,1,0,'[]',1,'0',0,0,2,0,0),(4201342,'帝国杀手机器人',6,0,1,'公会守卫第4波第2轮3号起点小怪',0,1,0,0,1,202015,'1','0',0,0,0,202015,0,'0',5,1,1,1,0,0,0,0,0,0,0,'[]','[]',150,2250,1500,2250,100,'[{1110000001,1}]',0,1000,0,0,1,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(4201351,'帝国军用机4型',6,0,1,'公会守卫第5波第1轮3号起点小怪',0,1,0,0,1,202018,'1.4','0',0,0,0,202018,0,'0',5,1,1,1,0,0,0,0,0,0,0,'[]','[]',150,2250,1500,2250,100,'[{1110000001,1}]',0,1000,0,0,1,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(4201352,'帝国军团勇士',6,0,1,'公会守卫第5波第2轮3号起点小怪',0,1,0,0,1,202017,'1.2','0',0,0,0,202017,0,'0',5,1,1,1,0,0,0,0,0,0,0,'[]','[]',250,2250,1500,2250,100,'[{1110000003,1}]',0,1000,0,0,1,1,0,0,0,0,1,1,1,0,'[]',1,'0',0,0,2,0,0),(4201361,'帝国军用机4型',6,0,1,'公会守卫第6波第1轮3号起点小怪',0,1,0,0,1,202018,'1.4','0',0,0,0,202018,0,'0',5,1,1,1,0,0,0,0,0,0,0,'[]','[]',150,2250,1500,2250,100,'[{1110000001,1}]',0,1000,0,0,1,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(4201362,'帝国军团勇士',6,0,1,'公会守卫第6波第2轮3号起点小怪',0,1,0,0,1,202017,'1.2','0',0,0,0,202017,0,'0',5,1,1,1,0,0,0,0,0,0,0,'[]','[]',250,2250,1500,2250,100,'[{1110000003,1}]',0,1000,0,0,1,1,0,0,0,0,1,1,1,0,'[]',1,'0',0,0,2,0,0),(4201371,'帝国军团勇士',6,0,1,'公会守卫第7波第1轮3号起点小怪',0,1,0,0,1,202017,'1.2','0',0,0,0,202017,0,'0',5,1,1,1,0,0,0,0,0,0,0,'[]','[]',250,2250,1500,2250,100,'[{1110000003,1}]',0,1000,0,0,1,1,0,0,0,0,1,1,1,0,'[]',1,'0',0,0,2,0,0),(4201372,'帝国杀手机器人',6,0,1,'公会守卫第7波第2轮3号起点小怪',0,1,0,0,1,202015,'1','0',0,0,0,202015,0,'0',5,1,1,1,0,0,0,0,0,0,0,'[]','[]',150,2250,1500,2250,100,'[{1110000001,1}]',0,1000,0,0,1,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(4201381,'帝国军用机6型',6,0,1,'公会守卫第8波第1轮3号起点小怪',0,1,0,0,1,202018,'1.4','0',0,0,0,202018,0,'0',5,1,1,1,0,0,0,0,0,0,0,'[]','[]',150,2250,1500,2250,100,'[{1110000001,1}]',0,1000,0,0,1,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,2,0,0),(4201382,'帝国军团勇士',6,0,1,'公会守卫第8波第2轮3号起点小怪',0,1,0,0,1,202017,'1.2','0',0,0,0,202017,0,'0',5,1,1,1,0,0,0,0,0,0,0,'[]','[]',250,2250,1500,2250,100,'[{1110000003,1}]',0,1000,0,0,1,1,0,0,0,0,1,1,1,0,'[]',1,'0',0,0,2,0,0),(5151002,'普通喜糖',8,0,0,'婚礼喜糖1',0,2,0,0,0,5020026,'1','0',0,0,0,5020026,0,'0',1,1,0,100,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,0,'[]',0,0,0,0,0,0,0,2,0,0,0,1,0,0,'[]',1,'0',1,0,0,0,0),(5151003,'豪华喜糖',8,0,0,'婚礼喜糖2',0,3,0,0,0,5020026,'1','0',3,0,0,5020026,0,'0',1,1,0,100,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,0,'[]',0,0,0,0,0,0,0,2,0,0,0,1,0,0,'[]',1,'0',1,0,0,0,0),(5151004,'只爱香蕉的皮皮蕉',1,0,0,'0',0,6,0,0,0,5151007,'1.5','0',0,0,0,5151007,0,'0',1,1,0,100,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,200,'[]',0,0,0,0,0,0,0,2,0,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(5151005,'爱吃糖的小飞猪',1,0,0,'0',0,6,0,0,0,5151005,'1.5','0',0,0,0,5151005,0,'0',1,1,0,100,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,200,'[]',0,0,0,0,0,0,0,2,0,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(5151006,'爱吃饼干的胖胖鱼',1,0,0,'0',0,6,0,0,0,5151006,'1.5','0',0,0,0,5151006,0,'0',1,1,0,100,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,200,'[]',0,0,0,0,0,0,0,2,0,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(5151007,'婚礼宴桌',8,0,0,'婚礼宴席1',0,6,0,0,0,5020022,'1','0',0,0,0,5020022,0,'0',1,1,0,100,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,0,'[]',0,0,0,0,0,0,0,5,0,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(5151008,'婚礼宴桌',8,0,0,'婚礼宴席2',0,6,0,0,0,5020022,'1','0',0,0,0,5020022,0,'0',1,1,0,100,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,0,'[]',0,0,0,0,0,0,0,5,0,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(5151009,'婚礼宴桌',8,0,0,'婚礼宴席3',0,6,0,0,0,5020022,'1','0',0,0,0,5020022,0,'0',1,1,0,100,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,0,'[]',0,0,0,0,0,0,0,5,0,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(5151010,'婚礼宴桌',8,0,0,'婚礼宴席4',0,6,0,0,0,5020022,'1','0',0,0,0,5020022,0,'0',1,1,0,100,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,0,'[]',0,0,0,0,0,0,0,5,0,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(5151011,'婚礼宴桌',8,0,0,'婚礼宴席5',0,6,0,0,0,5020022,'1','0',0,0,0,5020022,0,'0',1,1,0,100,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,0,'[]',0,0,0,0,0,0,0,5,0,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(5151012,'婚礼宴桌',8,0,0,'婚礼宴席6',0,6,0,0,0,5020022,'1','0',0,0,0,5020022,0,'0',1,1,0,100,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,0,'[]',0,0,0,0,0,0,0,5,0,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(5151013,'婚礼宴桌',8,0,0,'婚礼宴席7',0,6,0,0,0,5020022,'1','0',0,0,0,5020022,0,'0',1,1,0,100,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,0,'[]',0,0,0,0,0,0,0,5,0,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(5151014,'婚礼宴桌',8,0,0,'婚礼宴席8',0,6,0,0,0,5020022,'1','0',0,0,0,5020022,0,'0',1,1,0,100,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,0,'[]',0,0,0,0,0,0,0,5,0,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(5151015,'婚礼宴桌',8,0,0,'婚礼宴席新人1',0,6,0,0,0,5020022,'1','0',0,0,0,5020022,0,'0',1,1,0,100,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,0,'[]',0,0,0,0,0,0,0,5,0,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(5151016,'新人宴桌',8,0,0,'婚礼宴席新人2',0,6,0,0,0,5020022,'1.5','0',0,0,0,5020022,0,'0',1,1,0,100,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,0,'[]',0,0,0,0,0,0,0,5,0,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(5151017,'新人宴桌',8,0,0,'婚礼宴席新人3',0,6,0,0,0,5020022,'1.5','0',0,0,0,5020022,0,'0',1,1,0,100,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,0,'[]',0,0,0,0,0,0,0,5,0,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(5151018,'新人宴桌',8,0,0,'婚礼宴席新人4',0,6,0,0,0,5020022,'1.5','0',0,0,0,5020022,0,'0',1,1,0,100,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,0,'[]',0,0,0,0,0,0,0,5,0,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(5151019,'新人宴桌',8,0,0,'婚礼宴席新人5',0,6,0,0,0,5020022,'1.5','0',0,0,0,5020022,0,'0',1,1,0,100,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,0,'[]',0,0,0,0,0,0,0,5,0,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(5151020,'新人宴桌',8,0,0,'婚礼宴席新人6',0,6,0,0,0,5020022,'1.5','0',0,0,0,5020022,0,'0',1,1,0,100,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,0,'[]',0,0,0,0,0,0,0,5,0,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(5151021,'新人宴桌',8,0,0,'婚礼宴席新人7',0,6,0,0,0,5020022,'1.5','0',0,0,0,5020022,0,'0',1,1,0,100,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,0,'[]',0,0,0,0,0,0,0,5,0,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(5151022,'新人宴桌',8,0,0,'婚礼宴席新人8',0,6,0,0,0,5020022,'1.5','0',0,0,0,5020022,0,'0',1,1,0,100,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,0,'[]',0,0,0,0,0,0,0,5,0,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(5151023,'新人宴桌',8,0,0,'婚礼宴席新人9',0,6,0,0,0,5020022,'1.5','0',0,0,0,5020022,0,'0',1,1,0,100,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,0,'[]',0,0,0,0,0,0,0,5,0,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(5151024,'新人宴桌',8,0,0,'婚礼宴席新人10',0,6,0,0,0,5020022,'1.5','0',0,0,0,5020022,0,'0',1,1,0,100,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,0,'[]',0,0,0,0,0,0,0,5,0,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(5155001,'普通鲜花',1,0,0,'巡游鲜花1',0,2,0,0,0,5020026,'1','0',0,0,0,5020026,0,'0',1,1,0,100,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,0,'[]',0,0,0,0,0,0,1,2,1,0,0,1,0,0,'[]',1,'0',1,0,0,0,0),(5155002,'豪华鲜花',1,0,0,'巡游鲜花2',0,3,0,0,0,5020026,'1','0',3,0,0,5020026,0,'0',1,1,0,100,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,0,'[]',0,0,0,0,0,0,1,2,1,0,0,1,0,0,'[]',1,'0',1,0,0,0,0),(5200001,'妒忌狂魔',0,0,1,'情侣本初级本普通怪',0,2,0,0,2,202014,'1.2','0',0,0,0,202014,0,'0',175,1,132,33739,2147,1846,76,86,40,47,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(5200002,'愤怒狂魔',0,0,1,'情侣本初级本精英怪',0,3,0,0,2,202023,'1.2','0',0,0,0,202023,0,'0',180,2,159,47281,2650,1914,86,93,47,54,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(5200003,'妒忌花妖',0,0,1,'情侣本初级本花朵怪1',0,4,0,0,2,202001,'1','0',0,0,0,202001,0,'0',185,1,373,18592,3151,1983,96,100,52,62,0,'[]','[]',100,600,600,600,200,'[{1110000003,1}]',0,2000,0,0,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(5200004,'愤怒花妖',0,0,1,'情侣本初级本花朵怪2',0,4,0,0,2,202001,'1','0',0,0,0,202001,0,'0',185,1,1119,18592,3151,1983,96,100,52,62,0,'[]','[]',100,600,600,600,200,'[{1110000003,1}]',0,2000,0,0,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(5200005,'怨女',0,6,1,'情侣本初级本boss1',0,5,0,0,2,203011,'1','0',0,0,0,203011,0,'0',185,5,1705,214523,3151,1983,96,100,52,62,0,'[]','[]',600,2250,1500,2250,200,'[{200022021,1},{200022022,1}]',0,2000,0,0,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(5200006,'痴男',0,6,1,'情侣本初级本boss2',0,5,0,0,2,203012,'1','0',0,0,0,203012,0,'0',185,5,1705,214523,3151,1983,96,100,52,62,0,'[]','[]',600,2250,1500,2250,200,'[{202030121,1},{202030122,1}]',0,2000,0,0,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(5201001,'妒忌狂魔',0,0,1,'情侣本中级本普通怪',0,2,0,0,2,202014,'1.2','0',0,0,0,202014,0,'0',275,1,861,218498,13732,8147,591,591,724,745,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(5201002,'愤怒狂魔',0,0,1,'情侣本中级本精英怪',0,3,0,0,2,202023,'1.2','0',0,0,0,202023,0,'0',280,2,731,287448,14536,8544,637,637,780,800,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(5201003,'妒忌花妖',0,0,1,'情侣本中级本花朵怪1',0,4,0,0,2,202001,'1','0',0,0,0,202001,0,'0',285,1,1934,120712,15341,8941,682,682,836,855,0,'[]','[]',100,600,600,600,200,'[{1110000003,1}]',0,2000,0,0,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(5201004,'愤怒花妖',0,0,1,'情侣本中级本花朵怪2',0,4,0,0,2,202001,'1','0',0,0,0,202001,0,'0',285,1,5803,120712,15341,8941,682,682,836,855,0,'[]','[]',100,600,600,600,200,'[{1110000003,1}]',0,2000,0,0,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(5201005,'怨女',0,6,1,'情侣本中级本boss1',0,5,0,0,2,203011,'1','0',0,0,0,203011,0,'0',285,5,19896,1160697,15341,8941,682,682,836,855,0,'[]','[]',600,2250,1500,2250,200,'[{200022021,1},{200022022,1}]',0,2000,0,0,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(5201006,'痴男',0,6,1,'情侣本中级本boss2',0,5,0,0,2,203012,'1','0',0,0,0,203012,0,'0',285,5,19896,1160697,15341,8941,682,682,836,855,0,'[]','[]',600,2250,1500,2250,200,'[{202030121,1},{202030122,1}]',0,2000,0,0,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(5202001,'妒忌狂魔',0,0,1,'情侣本高级本普通怪',0,2,0,0,2,202014,'1.2','0',0,0,0,202014,0,'0',385,1,2277,704984,33363,26402,2845,2845,2278,2316,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(5202002,'愤怒狂魔',0,0,1,'情侣本高级本精英怪',0,3,0,0,2,202023,'1.2','0',0,0,0,202023,0,'0',390,2,1883,921575,34357,27544,3029,3029,2416,2457,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(5202003,'妒忌花妖',0,0,1,'情侣本高级本花朵怪1',0,4,0,0,2,202001,'1','0',0,0,0,202001,0,'0',395,1,4858,384765,35352,28687,3212,3212,2554,2597,0,'[]','[]',100,600,600,600,200,'[{1110000003,1}]',0,2000,0,0,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(5202004,'愤怒花妖',0,0,1,'情侣本高级本花朵怪2',0,4,0,0,2,202001,'1','0',0,0,0,202001,0,'0',395,1,14573,384765,35352,28687,3212,3212,2554,2597,0,'[]','[]',100,600,600,600,200,'[{1110000003,1}]',0,2000,0,0,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(5202005,'怨女',0,6,1,'情侣本高级本boss1',0,5,0,0,2,203011,'1','0',0,0,0,203011,0,'0',395,5,49966,3699659,35352,28687,3212,3212,2554,2597,0,'[]','[]',600,2250,1500,2250,200,'[{200022021,1},{200022022,1}]',0,2000,0,0,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(5202006,'痴男',0,6,1,'情侣本高级本boss2',0,5,0,0,2,203012,'1','0',0,0,0,203012,0,'0',395,5,49966,3699659,35352,28687,3212,3212,2554,2597,0,'[]','[]',600,2250,1500,2250,200,'[{202030121,1},{202030122,1}]',0,2000,0,0,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(5300101,'暗裔小鬼',6,0,1,'星灵副本怪物简单小怪1',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',85,1,2,147,48,40,20,24,22,21,0,'[]','[]',250,1000,1000,1000,250,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(5300102,'拆塔狂魔',6,0,1,'星灵副本怪物简单小怪2',0,2,0,0,0,202002,'1.3','0',0,0,0,202002,0,'3||我的眼里只有水晶，冲冲冲！:3||没有什么能够阻挡，我对拆塔的向往~:3',85,1,2,147,48,40,20,24,22,21,0,'[]','[]',250,1000,1000,1000,300,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(5300103,'爆弹怪',6,0,1,'星灵副本怪物简单小怪3',0,3,0,0,0,202030,'1.3','0',0,0,0,202030,0,'3||爆弹怪的意思，就是爆破！:3||爆炸是一种艺术！:3',85,1,2,147,48,40,20,24,22,21,0,'[]','[]',250,1000,1000,1000,300,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(5300400,'水晶',0,0,1,'星灵副本1水晶',0,1,0,0,0,41020003,'2.6','0',0,0,0,41020003,0,'0',5,1,1,100,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,0,'[]',0,1000,0,0,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5300401,'防御塔',7,0,1,'星灵副本1塔',0,1,0,0,0,2050012,'1','0',0,0,0,2050012,0,'0',5,1,1,10,0,0,0,0,0,0,0,'[]','[]',800,2250,1500,2250,0,'[{420100101,1}]',0,1000,0,0,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5301101,'暗裔小鬼',6,0,1,'星灵副本怪物普通小怪1',0,1,0,0,0,202003,'1.3','0',0,0,0,202003,0,'0',130,1,6,1154,187,159,78,95,88,84,0,'[]','[]',250,1000,1000,1000,300,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(5301102,'拆塔狂魔',6,0,1,'星灵副本怪物普通小怪2',0,2,0,0,0,202017,'1.3','0',0,0,0,202017,0,'3||我的眼里只有水晶，冲冲冲！:3||没有什么能够阻挡，我对拆塔的向往~:3',130,1,6,1154,187,159,78,95,88,84,0,'[]','[]',250,1000,1000,1000,300,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(5301103,'爆弹怪',6,0,1,'星灵副本怪物普通小怪3',0,3,0,0,0,202030,'1.3','0',0,0,0,202030,0,'3||爆弹怪的意思，就是爆破！:3||爆炸是一种艺术！:3',130,1,6,1154,187,159,78,95,88,84,0,'[]','[]',250,1000,1000,1000,300,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(5301400,'水晶',0,0,1,'星灵副本2水晶',0,1,0,0,0,41020003,'2.6','0',0,0,0,41020003,0,'0',5,1,1,360000,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,0,'[]',0,1000,0,0,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5301401,'防御塔',7,0,1,'星灵副本2塔',0,1,0,0,0,2050012,'1','0',0,0,0,2050012,0,'0',5,1,1,90000,0,0,0,0,0,0,0,'[]','[]',800,2250,1500,2250,0,'[{420100101,1}]',0,1000,0,0,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5302101,'暗裔小鬼',6,0,1,'星灵副本怪物困难小怪1',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',210,1,9,3604,352,297,146,179,167,157,0,'[]','[]',250,1000,1000,1000,300,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(5302102,'拆塔狂魔',6,0,1,'星灵副本怪物困难小怪2',0,2,0,0,0,202002,'1.3','0',0,0,0,202002,0,'3||我的眼里只有水晶，冲冲冲！:3||没有什么能够阻挡，我对拆塔的向往~:3',210,1,9,3604,352,297,146,179,167,157,0,'[]','[]',250,1000,1000,1000,300,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(5302103,'爆弹怪',6,0,1,'星灵副本怪物困难小怪3',0,3,0,0,0,202030,'1.3','0',0,0,0,202030,0,'3||爆弹怪的意思，就是爆破！:3||爆炸是一种艺术！:3',210,1,9,3604,352,297,146,179,167,157,0,'[]','[]',250,1000,1000,1000,300,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(5302400,'水晶',0,0,1,'星灵副本3水晶',0,1,0,0,0,41020003,'2.6','0',0,0,0,41020003,0,'0',5,1,1,360000,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,0,'[]',0,1000,0,0,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5302401,'防御塔',7,0,1,'星灵副本3塔',0,1,0,0,0,2050012,'1','0',0,0,0,2050012,0,'0',5,1,1,90000,0,0,0,0,0,0,0,'[]','[]',800,2250,1500,2250,0,'[{420100101,1}]',0,1000,0,0,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5303101,'暗裔小鬼',6,0,1,'星灵副本怪物噩梦小怪1',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',320,1,12,6873,480,406,200,243,228,214,0,'[]','[]',250,1000,1000,1000,300,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(5303102,'拆塔狂魔',6,0,1,'星灵副本怪物噩梦小怪2',0,2,0,0,0,202002,'1.3','0',0,0,0,202002,0,'3||我的眼里只有水晶，冲冲冲！:3||没有什么能够阻挡，我对拆塔的向往~:3',320,1,12,6873,480,406,200,243,228,214,0,'[]','[]',250,1000,1000,1000,300,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(5303103,'爆弹怪',6,0,1,'星灵副本怪物噩梦小怪3',0,3,0,0,0,202030,'1.3','0',0,0,0,202030,0,'3||爆弹怪的意思，就是爆破！:3||爆炸是一种艺术！:3',320,1,12,6873,480,406,200,243,228,214,0,'[]','[]',250,1000,1000,1000,300,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(5303400,'水晶',0,0,1,'星灵副本4水晶',0,1,0,0,0,41020003,'2.6','0',0,0,0,41020003,0,'0',5,1,1,360000,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,0,'[]',0,1000,0,0,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5303401,'防御塔',7,0,1,'星灵副本4塔',0,1,0,0,0,2050012,'1','0',0,0,0,2050012,0,'0',5,1,1,90000,0,0,0,0,0,0,0,'[]','[]',800,2250,1500,2250,0,'[{420100101,1}]',0,1000,0,0,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5304101,'暗裔小鬼',6,0,1,'星灵副本怪物炼狱小怪1',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',450,1,35,28644,1398,1184,580,710,666,623,0,'[]','[]',250,1000,1000,1000,300,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(5304102,'拆塔狂魔',6,0,1,'星灵副本怪物炼狱小怪2',0,2,0,0,0,202002,'1.3','0',0,0,0,202002,0,'3||我的眼里只有水晶，冲冲冲！:3||没有什么能够阻挡，我对拆塔的向往~:3',450,1,35,28644,1398,1184,580,710,666,623,0,'[]','[]',250,1000,1000,1000,300,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(5304103,'爆弹怪',6,0,1,'星灵副本怪物炼狱小怪3',0,3,0,0,0,202030,'1.3','0',0,0,0,202030,0,'3||爆弹怪的意思，就是爆破！:3||爆炸是一种艺术！:3',450,1,35,28644,1398,1184,580,710,666,623,0,'[]','[]',250,1000,1000,1000,300,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(5304400,'水晶',0,0,1,'星灵副本5水晶',0,1,0,0,0,41020003,'2.6','0',0,0,0,41020003,0,'0',5,1,1,360000,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,0,'[]',0,1000,0,0,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5304401,'防御塔',7,0,1,'星灵副本5塔',0,1,0,0,0,2050012,'1','0',0,0,0,2050012,0,'0',5,1,1,90000,0,0,0,0,0,0,0,'[]','[]',800,2250,1500,2250,0,'[{420100101,1}]',0,1000,0,0,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5400000,'波塞冬',0,6,0,'降神副本初级本Lv100',0,3,0,0,0,601003,'1.6','0',0,0,0,601003,0,'0',100,25,435,83810,712,897,124,130,41,40,0,'[]','[]',600,2250,1500,2250,300,'[{20005400,1},{20005401,1},{20005402,1},{20005403,1},{20005405,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5401000,'光明神',0,6,0,'降神副本boss2',0,3,0,0,0,203021,'1.5','0',0,0,0,203021,0,'0',200,50,680,300903,1802,1595,294,294,154,154,0,'[]','[1,346696560,500]',600,2250,1500,2250,300,'[{2000202101,1},{200054200,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5402000,'冰神',0,6,0,'降神副本boss3',0,3,0,0,0,203017,'1.6','0',0,0,0,203017,0,'0',380,95,2002,1346275,6156,5230,1394,1394,1140,1140,0,'[]','[1,346696560,500]',600,2250,1500,2250,300,'[{2000540201,1},{2000540208,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5403000,'女武神',0,6,0,'降神副本boss4',0,3,0,0,0,601001,'1.6','0',0,0,0,601001,0,'0',540,135,4707,3443633,14188,12715,4472,4472,2632,2632,0,'[]','[1,346696560,500]',600,2250,1500,2250,300,'[{20005411,1},{20005412,1},{20005413,1},{20005414,1},{20005416,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5404000,'月神',0,6,0,'降神副本boss5',0,3,0,0,0,203022,'1.6','0',0,0,0,203022,0,'0',680,170,13473,9985992,38221,34267,16125,16125,7987,7987,0,'[]','[1,346696560,500]',600,2250,1500,2250,300,'[{2000540401,1},{2000540402,1},{2000540406,1},{2000540410,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5405000,'光明神',0,6,0,'降神引导副本',0,3,0,0,0,203021,'1.4','0',0,0,0,203021,0,'0',23,5,140,2406,100,104,0,1,1,1,0,'[]','[]',550,2250,1500,2250,300,'[{2000202101,1},{200054200,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5800001,'神秘人',0,0,1,'大乱斗假人1',1,7,0,0,0,101000,'1','0',0,101000,0,101000,0,'0',370,1,9956,153480,0,4218,1060,1060,550,550,0,'[]','[3]',500,1000,1000,1000,450,'[{10011001,1},{10011002,1},{10011003,1},{10011004,1},{10011011,1},{10011021,1},{10011031,1},{10011041,1}]',5000,0,0,0,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(5800002,'神秘人',0,0,1,'大乱斗假人2',2,7,0,0,0,102000,'1','0',0,102000,0,102000,0,'0',370,1,9956,153480,0,4218,1060,1060,550,550,0,'[]','[3]',350,1000,1000,1000,450,'[{10012001,1},{10012002,1},{10012003,1},{10012004,1},{10012005,1},{10012011,1},{10012021,1},{10012031,1},{10012041,1}]',5000,0,0,0,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(5800003,'神秘人',0,0,1,'大乱斗假人3',3,7,0,0,0,103000,'1','0',0,103000,0,103000,0,'0',370,1,9956,153480,0,4218,1060,1060,550,550,0,'[]','[3]',350,1000,1000,1000,450,'[{10013001,1},{10013002,1},{10013003,1},{10013004,1},{10013011,1},{10013021,1},{10013031,1},{10013041,1}]',5000,0,0,0,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(5800004,'神秘人',0,0,1,'大乱斗假人4',4,7,0,0,0,104000,'1','0',0,104000,0,104000,0,'0',370,1,9956,153480,0,4218,1060,1060,550,550,0,'[]','[3]',350,1000,1000,1000,450,'[{10014001,1},{10014002,1},{10014003,1},{10014004,1},{10014011,1},{10014012,1},{10014013,1},{10014021,1},{10014031,1},{10014032,1},{10014033,1},{10014034,1},{10014041,1},{10014042,1},{10014043,1}]',5000,0,0,0,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(5800005,'普通宝箱',1,0,0,'大乱斗1层普通宝箱',0,3,0,0,0,2040010,'1','0',0,0,0,2040010,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,1,0,0,0,3,1,0,0,1,0,0,'[]',1,'0',1,0,0,0,0),(5800006,'普通宝箱',1,0,0,'大乱斗2层普通宝箱',0,3,0,0,0,2040010,'1','0',0,0,0,2040010,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,1,0,0,0,3,1,0,0,1,0,0,'[]',1,'0',1,0,0,0,0),(5800007,'普通宝箱',1,0,0,'大乱斗3层普通宝箱',0,3,0,0,0,2040010,'1','0',0,0,0,2040010,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,1,0,0,0,3,1,0,0,1,0,0,'[]',1,'0',1,0,0,0,0),(5800008,'普通宝箱',1,0,0,'大乱斗4层普通宝箱',0,3,0,0,0,2040010,'1','0',0,0,0,2040010,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,1,0,0,0,3,1,0,0,1,0,0,'[]',1,'0',1,0,0,0,0),(5800009,'白银宝箱',1,0,0,'大乱斗1层白银宝箱',0,4,0,0,0,2040010,'1','0',0,0,0,2040010,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,1,0,0,0,3,1,0,0,1,0,0,'[]',1,'0',1,0,0,0,0),(5800010,'白银宝箱',1,0,0,'大乱斗2层白银宝箱',0,4,0,0,0,2040010,'1','0',0,0,0,2040010,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,1,0,0,0,3,1,0,0,1,0,0,'[]',1,'0',1,0,0,0,0),(5800011,'白银宝箱',1,0,0,'大乱斗3层白银宝箱',0,4,0,0,0,2040010,'1','0',0,0,0,2040010,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,1,0,0,0,3,1,0,0,1,0,0,'[]',1,'0',1,0,0,0,0),(5800012,'白银宝箱',1,0,0,'大乱斗4层白银宝箱',0,4,0,0,0,2040010,'1','0',0,0,0,2040010,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,1,0,0,0,3,1,0,0,1,0,0,'[]',1,'0',1,0,0,0,0),(5800013,'黄金宝箱',1,0,0,'大乱斗1层黄金宝箱',0,5,0,0,0,2040009,'1','0',0,0,0,2040009,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,1,0,0,0,3,1,0,0,1,0,0,'[]',1,'0',1,0,0,0,0),(5800014,'黄金宝箱',1,0,0,'大乱斗2层黄金宝箱',0,5,0,0,0,2040009,'1','0',0,0,0,2040009,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,1,0,0,0,3,1,0,0,1,0,0,'[]',1,'0',1,0,0,0,0),(5800015,'黄金宝箱',1,0,0,'大乱斗3层黄金宝箱',0,5,0,0,0,2040009,'1','0',0,0,0,2040009,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,1,0,0,0,3,1,0,0,1,0,0,'[]',1,'0',1,0,0,0,0),(5800016,'黄金宝箱',1,0,0,'大乱斗4层黄金宝箱',0,5,0,0,0,2040009,'1','0',0,0,0,2040009,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,1,0,0,0,3,1,0,0,1,0,0,'[]',1,'0',1,0,0,0,0),(5900000,'质量检测员',0,6,0,'魂珠副本怪物1',0,3,0,0,0,203008,'1.1','0',0,0,0,203008,0,'0',70,25,771,38884,653,879,120,125,29,28,0,'[]','[]',250,2250,1500,2250,300,'[{202030081,1},{202030082,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900001,'怠惰',0,6,0,'魂珠副本怪物2',0,3,0,0,0,203013,'1.1','0',0,0,0,203013,0,'0',100,25,1566,46701,712,944,124,130,41,40,0,'[]','[]',250,2250,1500,2250,300,'[{202030131,1},{202030132,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900002,'愤怒',0,6,0,'魂珠副本怪物3',0,3,0,0,0,203012,'1.1','0',0,0,0,203012,0,'0',120,25,1814,79742,748,984,124,130,41,40,0,'[]','[]',250,2250,1500,2250,300,'[{202030121,1},{202030122,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900003,'蜘蛛女皇',0,6,0,'魂珠副本怪物4',0,3,0,0,0,203011,'1.1','0',0,0,0,203011,0,'0',150,25,2101,90378,1057,1610,58,75,29,33,0,'[]','[]',250,2250,1500,2250,300,'[{200022021,1},{200022022,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900004,'色欲',0,6,0,'魂珠副本怪物5',0,3,0,0,0,203016,'1.1','0',0,0,0,203016,0,'0',160,25,2382,107948,1237,1808,58,75,29,33,0,'[]','[]',250,2250,1500,2250,300,'[{202030161,1},{202030162,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900005,'美杜莎',0,6,0,'魂珠副本怪物6',0,3,0,0,0,203006,'1.1','0',0,0,0,203006,0,'0',168,25,2850,118669,1444,1843,62,78,32,36,0,'[]','[]',250,2250,1500,2250,300,'[{2000230101,1},{2000230102,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900006,'嫉妒',0,6,0,'魂珠副本怪物7',0,3,0,0,0,203014,'1.1','0',0,0,0,203014,0,'0',176,25,4343,146293,2248,1958,78,88,42,48,0,'[]','[]',250,2250,1500,2250,300,'[{202030141,1},{202030142,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900007,'八岐大蛇',0,6,0,'魂珠副本怪物8',0,3,0,0,0,203024,'1.1','0',0,0,0,203024,0,'0',184,25,5732,176694,3051,2073,94,99,51,61,0,'[]','[]',250,2250,1500,2250,300,'[{2000230201,1},{2000230202,1}]',30000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900008,'死神',0,6,0,'魂珠副本怪物9',0,3,0,0,0,203018,'1.1','0',0,0,0,203018,0,'0',192,25,7045,215596,3778,2243,109,109,66,78,0,'[]','[]',250,2250,1500,2250,300,'[{2000201801,1},{20005455,1}]',30000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900009,'半人马',0,6,0,'魂珠副本怪物10',0,3,0,0,0,203002,'1.1','0',0,0,0,203002,0,'0',200,25,8101,277125,4274,2578,120,120,98,110,0,'[]','[]',250,2250,1500,2250,300,'[{200022011,1},{200022014,1}]',30000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900010,'光明神',0,6,0,'魂珠副本怪物11',0,3,0,0,0,203021,'1.1','0',0,0,0,203021,0,'0',210,25,9425,356910,4895,2997,134,134,138,152,0,'[]','[]',250,2250,1500,2250,300,'[{2000202101,1},{200054200,1}]',30000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900011,'半人马',0,6,0,'魂珠副本怪物12',0,3,0,0,0,203002,'1.1','0',0,0,0,203002,0,'0',220,25,10753,412657,5515,3415,148,148,178,193,0,'[]','[]',250,2250,1500,2250,300,'[{200022011,1},{200022014,1}]',30000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900012,'寒冰女神',0,6,0,'魂珠副本怪物13',0,3,0,0,0,203017,'1.1','0',0,0,0,203017,0,'0',230,25,12082,468344,6136,3834,162,162,219,234,0,'[]','[]',250,2250,1500,2250,300,'[{2000540201,1},{2000540208,1}]',30000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900013,'冰霜泰坦',0,6,0,'魂珠副本怪物14',0,3,0,0,0,203003,'1.1','0',0,0,0,203003,0,'0',240,25,15464,608625,7923,5160,262,262,332,353,0,'[]','[]',250,2250,1500,2250,300,'[{202030031,1},{202030032,1}]',30000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900014,'海龙王',0,6,0,'魂珠副本怪物15',0,3,0,0,0,203009,'1.1','0',0,0,0,203009,0,'0',250,25,18885,748989,9710,6485,363,363,445,472,0,'[]','[]',250,2250,1500,2250,300,'[{202030091,1},{202030092,1}]',30000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900015,'暗裔猎手',0,6,0,'魂珠副本怪物16',0,3,0,0,0,203011,'1.1','0',0,0,0,203011,0,'0',260,25,22221,852871,11319,7321,454,454,557,581,0,'[]','[]',250,2250,1500,2250,300,'[{200022021,1},{200022022,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900016,'月神',0,6,0,'魂珠副本怪物17',0,3,0,0,0,203022,'1.1','0',0,0,0,203022,0,'0',270,25,25579,956756,12927,8157,545,545,668,691,0,'[]','[]',250,2250,1500,2250,300,'[{2000540401,1},{2000540402,1},{2000540406,1},{2000540410,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900017,'怠惰',0,6,0,'魂珠副本怪物18',0,3,0,0,0,203013,'1.1','0',0,0,0,203013,0,'0',280,25,28950,1060526,14536,8994,637,637,780,800,0,'[]','[]',250,2250,1500,2250,300,'[{202030131,1},{202030132,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900018,'冰霜泰坦',0,6,0,'魂珠副本怪物19',0,3,0,0,0,203003,'1.1','0',0,0,0,203003,0,'0',290,25,32333,1164410,16145,9830,728,728,892,909,0,'[]','[]',250,2250,1500,2250,300,'[{202030031,1},{202030032,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900019,'食人花',0,6,0,'魂珠副本怪物20',0,3,0,0,0,203001,'1.1','0',0,0,0,203001,0,'0',300,25,35724,1465771,17754,10666,819,819,1004,1018,0,'[]','[]',250,2250,1500,2250,300,'[{202030011,1},{202030012,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900020,'色欲',0,6,0,'魂珠副本怪物21',0,3,0,0,0,203016,'1.1','0',0,0,0,203016,0,'0',305,25,37683,1569801,18618,11537,893,893,1035,1050,0,'[]','[]',250,2250,1500,2250,300,'[{202030161,1},{202030162,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900021,'暴食',0,6,0,'魂珠副本怪物22',0,3,0,0,0,203015,'1.1','0',0,0,0,203015,0,'0',310,25,39641,1673829,19483,12408,967,967,1066,1082,0,'[]','[]',250,2250,1500,2250,300,'[{202030151,1},{202030152,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900022,'迦楼罗',0,6,0,'魂珠副本怪物23',0,3,0,0,0,203020,'1.1','0',0,0,0,203020,0,'0',315,25,41601,1777855,20348,13279,1042,1042,1096,1113,0,'[]','[]',250,2250,1500,2250,300,'[{202030201,1},{202030202,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900023,'暗裔恶魔',0,6,0,'魂珠副本怪物24',0,3,0,0,0,203007,'1.1','0',0,0,0,203007,0,'0',320,25,43562,1881881,21213,14150,1116,1116,1127,1145,0,'[]','[]',250,2250,1500,2250,300,'[{2000230301,1},{2000230303,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900024,'海龙王',0,6,0,'魂珠副本怪物25',0,3,0,0,0,203009,'1.1','0',0,0,0,203009,0,'0',325,25,45525,1985906,22078,15021,1190,1190,1158,1177,0,'[]','[]',250,2250,1500,2250,300,'[{202030091,1},{202030092,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900025,'冰霜泰坦',0,6,0,'魂珠副本怪物26',0,3,0,0,0,203003,'1.1','0',0,0,0,203003,0,'0',330,25,47492,2090111,22942,15891,1265,1265,1188,1208,0,'[]','[]',250,2250,1500,2250,300,'[{202030031,1},{202030032,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900026,'八岐大蛇',0,6,0,'魂珠副本怪物27',0,3,0,0,0,203024,'1.1','0',0,0,0,203024,0,'0',335,25,49457,2194139,23807,16762,1339,1339,1219,1240,0,'[]','[]',250,2250,1500,2250,300,'[{2000230201,1},{2000230202,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900027,'光明神',0,6,0,'魂珠副本怪物28',0,3,0,0,0,203021,'1.1','0',0,0,0,203021,0,'0',340,25,51422,2298166,24672,17633,1413,1413,1250,1271,0,'[]','[]',250,2250,1500,2250,300,'[{2000202101,1},{200054200,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900028,'冰霜泰坦',0,6,0,'魂珠副本怪物29',0,3,0,0,0,203003,'1.1','0',0,0,0,203003,0,'0',345,25,53387,2402192,25537,18504,1488,1488,1280,1303,0,'[]','[]',250,2250,1500,2250,300,'[{202030031,1},{202030032,1}]',30000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900029,'月神',0,6,0,'魂珠副本怪物30',0,3,0,0,0,203022,'1.1','0',0,0,0,203022,0,'0',350,25,55356,2506217,26401,19375,1562,1562,1311,1335,0,'[]','[]',250,2250,1500,2250,300,'[{2000540401,1},{2000540402,1},{2000540406,1},{2000540410,1}]',30000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900030,'怠惰',0,6,0,'魂珠副本怪物31',0,3,0,0,0,203013,'1.1','0',0,0,0,203013,0,'0',355,25,57751,2666999,27396,20577,1745,1745,1449,1475,0,'[]','[]',250,2250,1500,2250,300,'[{202030131,1},{202030132,1}]',30000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900031,'嫉妒',0,6,0,'魂珠副本怪物32',0,3,0,0,0,203014,'1.1','0',0,0,0,203014,0,'0',360,25,60151,2827571,28390,21780,1929,1929,1587,1615,0,'[]','[]',250,2250,1500,2250,300,'[{202030141,1},{202030142,1}]',30000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900032,'光明神',0,6,0,'魂珠副本怪物33',0,3,0,0,0,203021,'1.1','0',0,0,0,203021,0,'0',365,25,62548,2988357,29385,22982,2112,2112,1725,1755,0,'[]','[]',250,2250,1500,2250,300,'[{2000202101,1},{200054200,1}]',30000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900033,'半人马',0,6,0,'魂珠副本怪物34',0,3,0,0,0,203002,'1.1','0',0,0,0,203002,0,'0',370,25,64950,3148920,30379,24185,2295,2295,1864,1896,0,'[]','[]',250,2250,1500,2250,300,'[{200022011,1},{200022014,1}]',30000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900034,'冰霜巨龙',0,6,0,'魂珠副本怪物35',0,3,0,0,0,203004,'1.1','0',0,0,0,203004,0,'0',375,25,67348,3309710,31374,25387,2479,2479,2002,2036,0,'[]','[]',250,2250,1500,2250,300,'[{202030041,1},{202030043,1}]',30000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900035,'色欲',0,6,0,'魂珠副本怪物36',0,3,0,0,0,203016,'1.1','0',0,0,0,203016,0,'0',380,25,69750,3470506,32368,26589,2662,2662,2140,2176,0,'[]','[]',250,2250,1500,2250,300,'[{202030161,1},{202030162,1}]',30000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900036,'半人马',0,6,0,'魂珠副本怪物37',0,3,0,0,0,203002,'1.1','0',0,0,0,203002,0,'0',385,25,72148,3631058,33363,27792,2845,2845,2278,2316,0,'[]','[]',250,2250,1500,2250,300,'[{200022011,1},{200022014,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900037,'八岐大蛇',0,6,0,'魂珠副本怪物38',0,3,0,0,0,203024,'1.1','0',0,0,0,203024,0,'0',390,25,74550,3791857,34357,28994,3029,3029,2416,2457,0,'[]','[]',250,2250,1500,2250,300,'[{2000230201,1},{2000230202,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900038,'迦楼罗',0,6,0,'魂珠副本怪物39',0,3,0,0,0,203020,'1.1','0',0,0,0,203020,0,'0',395,25,76947,3952401,35352,30197,3212,3212,2554,2597,0,'[]','[]',250,2250,1500,2250,300,'[{202030201,1},{202030202,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900039,'光明神',0,6,0,'魂珠副本怪物40',0,3,0,0,0,203021,'1.1','0',0,0,0,203021,0,'0',400,25,79348,4113203,36346,31399,3395,3395,2692,2737,0,'[]','[]',250,2250,1500,2250,300,'[{2000202101,1},{200054200,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900040,'冰霜泰坦',0,6,0,'魂珠副本怪物41',0,3,0,0,0,203003,'1.1','0',0,0,0,203003,0,'0',405,25,81678,4241314,37266,32291,3570,3570,2780,2833,0,'[]','[]',250,2250,1500,2250,300,'[{202030031,1},{202030032,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900041,'食人花',0,6,0,'魂珠副本怪物42',0,3,0,0,0,203001,'1.1','0',0,0,0,203001,0,'0',410,25,84011,4369156,38185,33184,3745,3745,2868,2928,0,'[]','[]',250,2250,1500,2250,300,'[{202030011,1},{202030012,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900042,'质量检测员',0,6,0,'魂珠副本怪物43',0,3,0,0,0,203008,'1.1','0',0,0,0,203008,0,'0',415,25,86338,4497269,39105,34076,3919,3919,2956,3024,0,'[]','[]',250,2250,1500,2250,300,'[{202030081,1},{202030082,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900043,'八岐大蛇',0,6,0,'魂珠副本怪物44',0,3,0,0,0,203024,'1.1','0',0,0,0,203024,0,'0',420,25,88668,4625107,40024,34969,4094,4094,3045,3120,0,'[]','[]',250,2250,1500,2250,300,'[{2000230201,1},{2000230202,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900044,'熔岩战神',0,6,0,'魂珠副本怪物45',0,3,0,0,0,203025,'1.1','0',0,0,0,203025,0,'0',425,25,90993,4753221,40944,35861,4269,4269,3133,3216,0,'[]','[]',250,2250,1500,2250,300,'[{202030251,1},{202030252,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900045,'熔岩战神',0,6,0,'魂珠副本怪物46',0,3,0,0,0,203025,'1.1','0',0,0,0,203025,0,'0',430,25,93320,4881337,41863,36753,4444,4444,3221,3312,0,'[]','[]',250,2250,1500,2250,300,'[{202030251,1},{202030252,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900046,'冰霜巨龙',0,6,0,'魂珠副本怪物47',0,3,0,0,0,203004,'1.1','0',0,0,0,203004,0,'0',435,25,95641,5009172,42783,37646,4618,4618,3309,3407,0,'[]','[]',250,2250,1500,2250,300,'[{202030041,1},{202030043,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900047,'嫉妒',0,6,0,'魂珠副本怪物48',0,3,0,0,0,203014,'1.1','0',0,0,0,203014,0,'0',440,25,97965,5137289,43702,38538,4793,4793,3397,3503,0,'[]','[]',250,2250,1500,2250,300,'[{202030141,1},{202030142,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900048,'暗裔猎手',0,6,0,'魂珠副本怪物49',0,3,0,0,0,203011,'1.1','0',0,0,0,203011,0,'0',445,25,100283,5265121,44622,39431,4968,4968,3485,3599,0,'[]','[]',250,2250,1500,2250,300,'[{200022021,1},{200022022,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900049,'暴食',0,6,0,'魂珠副本怪物50',0,3,0,0,0,203015,'1.1','0',0,0,0,203015,0,'0',450,25,102603,5393239,45541,40323,5142,5142,3573,3695,0,'[]','[]',250,2250,1500,2250,300,'[{202030151,1},{202030152,1}]',30000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900050,'暗裔恶魔',0,6,0,'魂珠副本怪物51',0,3,0,0,0,203007,'1.1','0',0,0,0,203007,0,'0',460,25,109437,5774322,48285,43051,5654,5654,3955,4100,0,'[]','[]',250,2250,1500,2250,300,'[{2000230301,1},{2000230303,1}]',30000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900051,'暗裔猎手',0,6,0,'魂珠副本怪物52',0,3,0,0,0,203011,'1.1','0',0,0,0,203011,0,'0',470,25,116273,6155405,51029,45779,6165,6165,4337,4505,0,'[]','[]',250,2250,1500,2250,300,'[{200022021,1},{200022022,1}]',30000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900052,'冰霜巨龙',0,6,0,'魂珠副本怪物53',0,3,0,0,0,203004,'1.1','0',0,0,0,203004,0,'0',480,25,123112,6536489,53772,48507,6677,6677,4719,4910,0,'[]','[]',250,2250,1500,2250,300,'[{202030041,1},{202030043,1}]',30000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900053,'蜘蛛女皇',0,6,0,'魂珠副本怪物54',0,3,0,0,0,203011,'1.1','0',0,0,0,203011,0,'0',490,25,129945,6917572,56516,51235,7188,7188,5101,5315,0,'[]','[]',250,2250,1500,2250,300,'[{200022021,1},{200022022,1}]',30000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900054,'寒冰女神',0,6,0,'魂珠副本怪物55',0,3,0,0,0,203017,'1.1','0',0,0,0,203017,0,'0',500,25,136774,7298655,59260,53963,7700,7700,5483,5720,0,'[]','[]',250,2250,1500,2250,300,'[{2000540201,1},{2000540208,1}]',30000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900055,'冰霜泰坦',0,6,0,'魂珠副本怪物56',0,3,0,0,0,203003,'1.1','0',0,0,0,203003,0,'0',510,25,144751,7739612,62379,57083,8739,8739,6118,6367,0,'[]','[]',250,2250,1500,2250,300,'[{202030031,1},{202030032,1}]',30000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900056,'寒冰女神',0,6,0,'魂珠副本怪物57',0,3,0,0,0,203017,'1.1','0',0,0,0,203017,0,'0',520,25,152730,8180567,65497,60203,9778,9778,6753,7014,0,'[]','[]',250,2250,1500,2250,300,'[{2000540201,1},{2000540208,1}]',30000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900057,'月神',0,6,0,'魂珠副本怪物58',0,3,0,0,0,203022,'1.1','0',0,0,0,203022,0,'0',530,25,160702,8621866,68616,63322,10818,10818,7388,7661,0,'[]','[]',250,2250,1500,2250,300,'[{2000540401,1},{2000540402,1},{2000540406,1},{2000540410,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900058,'美杜莎',0,6,0,'魂珠副本怪物59',0,3,0,0,0,203006,'1.1','0',0,0,0,203006,0,'0',540,25,168669,9062822,71735,66442,11857,11857,8023,8308,0,'[]','[]',250,2250,1500,2250,300,'[{2000230101,1},{2000230102,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900059,'八岐大蛇',0,6,0,'魂珠副本怪物60',0,3,0,0,0,203024,'1.1','0',0,0,0,203024,0,'0',550,25,176635,9503776,74853,69562,12896,12896,8658,8955,0,'[]','[]',250,2250,1500,2250,300,'[{2000230201,1},{2000230202,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900060,'暗裔猎手',0,6,0,'魂珠副本怪物61',0,3,0,0,0,203011,'1.1','0',0,0,0,203011,0,'0',560,25,185172,9973571,78199,72930,13653,13653,9059,9344,0,'[]','[]',250,2250,1500,2250,300,'[{200022021,1},{200022022,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900061,'暗裔恶魔',0,6,0,'魂珠副本怪物62',0,3,0,0,0,203007,'1.1','0',0,0,0,203007,0,'0',570,25,193702,10443001,81545,76299,14409,14409,9459,9734,0,'[]','[]',250,2250,1500,2250,300,'[{2000230301,1},{2000230303,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900062,'八岐大蛇',0,6,0,'魂珠副本怪物63',0,3,0,0,0,203024,'1.1','0',0,0,0,203024,0,'0',580,25,202225,10912800,84891,79667,15165,15165,9859,10123,0,'[]','[]',250,2250,1500,2250,300,'[{2000230201,1},{2000230202,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900063,'阿努比斯',0,6,0,'魂珠副本怪物64',0,3,0,0,0,203005,'1.1','0',0,0,0,203005,0,'0',590,25,210739,11382223,88237,83036,15922,15922,10260,10513,0,'[]','[]',250,2250,1500,2250,300,'[{202030051,1},{202030052,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900064,'死神',0,6,0,'魂珠副本怪物65',0,3,0,0,0,203018,'1.1','0',0,0,0,203018,0,'0',600,25,219244,13291360,91583,86404,16678,16678,10660,10902,0,'[]','[]',250,2250,1500,2250,300,'[{2000201801,1},{20005455,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900065,'食人花',0,6,0,'魂珠副本怪物66',0,3,0,0,0,203001,'1.1','0',0,0,0,203001,0,'0',610,25,228700,13868184,95538,90412,17592,17592,11349,11571,0,'[]','[]',250,2250,1500,2250,300,'[{202030011,1},{202030012,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900066,'八岐大蛇',0,6,0,'魂珠副本怪物67',0,3,0,0,0,203024,'1.1','0',0,0,0,203024,0,'0',620,25,238150,14445007,99493,94420,18506,18506,12038,12240,0,'[]','[]',250,2250,1500,2250,300,'[{2000230201,1},{2000230202,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900067,'暗裔猎手',0,6,0,'魂珠副本怪物68',0,3,0,0,0,203011,'1.1','0',0,0,0,203011,0,'0',630,25,247595,15022273,103447,98427,19420,19420,12727,12909,0,'[]','[]',250,2250,1500,2250,300,'[{200022021,1},{200022022,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900068,'色欲',0,6,0,'魂珠副本怪物69',0,3,0,0,0,203016,'1.1','0',0,0,0,203016,0,'0',640,25,257025,15599096,107402,102435,20335,20335,13416,13577,0,'[]','[]',250,2250,1500,2250,300,'[{202030161,1},{202030162,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900069,'海龙王',0,6,0,'魂珠副本怪物70',0,3,0,0,0,203009,'1.1','0',0,0,0,203009,0,'0',650,25,266445,16175918,111357,106443,21249,21249,14106,14246,0,'[]','[]',250,2250,1500,2250,300,'[{202030091,1},{202030092,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900070,'八岐大蛇',0,6,0,'魂珠副本怪物71',0,3,0,0,0,203024,'1.1','0',0,0,0,203024,0,'0',660,25,278016,16898244,115457,110616,22081,22081,14501,14645,0,'[]','[]',250,2250,1500,2250,300,'[{2000230201,1},{2000230202,1}]',30000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900071,'嫉妒',0,6,0,'魂珠副本怪物72',0,3,0,0,0,203014,'1.1','0',0,0,0,203014,0,'0',670,25,289583,17620570,119556,114789,22913,22913,14897,15045,0,'[]','[]',250,2250,1500,2250,300,'[{202030141,1},{202030142,1}]',30000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900072,'美杜莎',0,6,0,'魂珠副本怪物73',0,3,0,0,0,203006,'1.1','0',0,0,0,203006,0,'0',680,25,301141,18342897,123655,118962,23745,23745,15293,15444,0,'[]','[]',250,2250,1500,2250,300,'[{2000230101,1},{2000230102,1}]',30000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900073,'美杜莎',0,6,0,'魂珠副本怪物74',0,3,0,0,0,203006,'1.1','0',0,0,0,203006,0,'0',690,25,312682,19065223,127755,123135,24577,24577,15689,15843,0,'[]','[]',250,2250,1500,2250,300,'[{2000230101,1},{2000230102,1}]',30000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900074,'死神',0,6,0,'魂珠副本怪物75',0,3,0,0,0,203018,'1.1','0',0,0,0,203018,0,'0',700,25,324216,19787549,131854,127308,25409,25409,16084,16242,0,'[]','[]',250,2250,1500,2250,300,'[{2000201801,1},{20005455,1}]',30000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900075,'暗裔恶魔',0,6,0,'魂珠副本怪物76',0,3,0,0,0,203007,'1.1','0',0,0,0,203007,0,'0',710,25,334733,20425129,136220,131752,26130,26130,16481,16607,0,'[]','[]',250,2250,1500,2250,300,'[{2000230301,1},{2000230303,1}]',30000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900076,'冰霜巨龙',0,6,0,'魂珠副本怪物77',0,3,0,0,0,203004,'1.1','0',0,0,0,203004,0,'0',720,25,345240,21063194,140585,136195,26850,26850,16878,16972,0,'[]','[]',250,2250,1500,2250,300,'[{202030041,1},{202030043,1}]',30000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900077,'冰霜巨龙',0,6,0,'魂珠副本怪物78',0,3,0,0,0,203004,'1.1','0',0,0,0,203004,0,'0',730,25,355728,21700773,144951,140639,27571,27571,17274,17337,0,'[]','[]',250,2250,1500,2250,300,'[{202030041,1},{202030043,1}]',30000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900078,'月神',0,6,0,'魂珠副本怪物79',0,3,0,0,0,203022,'1.1','0',0,0,0,203022,0,'0',740,25,366205,22338841,149316,145082,28292,28292,17671,17702,0,'[]','[]',250,2250,1500,2250,300,'[{2000540401,1},{2000540402,1},{2000540406,1},{2000540410,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900079,'嫉妒',0,6,0,'魂珠副本怪物80',0,3,0,0,0,203014,'1.1','0',0,0,0,203014,0,'0',750,25,376660,22976419,153682,149526,29013,29013,18067,18067,0,'[]','[]',250,2250,1500,2250,300,'[{202030141,1},{202030142,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900080,'愤怒',0,6,0,'魂珠副本怪物81',0,3,0,0,0,203012,'1.1','0',0,0,0,203012,0,'0',760,25,388140,23665445,158730,154696,29742,29742,18814,18814,0,'[]','[]',250,2250,1500,2250,300,'[{202030121,1},{202030122,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900081,'寒冰女神',0,6,0,'魂珠副本怪物82',0,3,0,0,0,203017,'1.1','0',0,0,0,203017,0,'0',770,25,399604,24354965,163778,159865,30471,30471,19561,19561,0,'[]','[]',250,2250,1500,2250,300,'[{2000540201,1},{2000540208,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900082,'死神',0,6,0,'魂珠副本怪物83',0,3,0,0,0,203018,'1.1','0',0,0,0,203018,0,'0',780,25,411047,25043989,168827,165035,31200,31200,20308,20308,0,'[]','[]',250,2250,1500,2250,300,'[{2000201801,1},{20005455,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900083,'蜘蛛女皇',0,6,0,'魂珠副本怪物84',0,3,0,0,0,203011,'1.1','0',0,0,0,203011,0,'0',790,25,422479,25733511,173875,170204,31929,31929,21055,21055,0,'[]','[]',250,2250,1500,2250,300,'[{200022021,1},{200022022,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900084,'食人花',0,6,0,'魂珠副本怪物85',0,3,0,0,0,203001,'1.1','0',0,0,0,203001,0,'0',800,25,433889,29552107,178924,175374,32658,32658,21803,21803,0,'[]','[]',250,2250,1500,2250,300,'[{202030011,1},{202030012,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900085,'暗裔恶魔',0,6,0,'魂珠副本怪物86',0,3,0,0,0,203007,'1.1','0',0,0,0,203007,0,'0',800,25,433889,29552107,178924,175374,32658,32658,21803,21803,0,'[]','[]',250,2250,1500,2250,300,'[{2000230301,1},{2000230303,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900086,'暗裔猎手',0,6,0,'魂珠副本怪物87',0,3,0,0,0,203011,'1.1','0',0,0,0,203011,0,'0',800,25,433889,29552107,178924,175374,32658,32658,21803,21803,0,'[]','[]',250,2250,1500,2250,300,'[{200022021,1},{200022022,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900087,'色欲',0,6,0,'魂珠副本怪物88',0,3,0,0,0,203016,'1.1','0',0,0,0,203016,0,'0',800,25,433889,29552107,178924,175374,32658,32658,21803,21803,0,'[]','[]',250,2250,1500,2250,300,'[{202030161,1},{202030162,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900088,'光明神',0,6,0,'魂珠副本怪物89',0,3,0,0,0,203021,'1.1','0',0,0,0,203021,0,'0',800,25,433889,29552107,178924,175374,32658,32658,21803,21803,0,'[]','[]',250,2250,1500,2250,300,'[{2000202101,1},{200054200,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900089,'暗裔恶魔',0,6,0,'魂珠副本怪物90',0,3,0,0,0,203007,'1.1','0',0,0,0,203007,0,'0',800,25,433889,29552107,178924,175374,32658,32658,21803,21803,0,'[]','[]',250,2250,1500,2250,300,'[{2000230301,1},{2000230303,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900090,'寒冰女神',0,6,0,'魂珠副本怪物91',0,3,0,0,0,203017,'1.1','0',0,0,0,203017,0,'0',800,25,433889,29552107,178924,175374,32658,32658,21803,21803,0,'[]','[]',250,2250,1500,2250,300,'[{2000540201,1},{2000540208,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900091,'怠惰',0,6,0,'魂珠副本怪物92',0,3,0,0,0,203013,'1.1','0',0,0,0,203013,0,'0',800,25,433889,29552107,178924,175374,32658,32658,21803,21803,0,'[]','[]',250,2250,1500,2250,300,'[{202030131,1},{202030132,1}]',30000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900092,'愤怒',0,6,0,'魂珠副本怪物93',0,3,0,0,0,203012,'1.1','0',0,0,0,203012,0,'0',800,25,433889,29552107,178924,175374,32658,32658,21803,21803,0,'[]','[]',250,2250,1500,2250,300,'[{202030121,1},{202030122,1}]',30000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900093,'半人马',0,6,0,'魂珠副本怪物94',0,3,0,0,0,203002,'1.1','0',0,0,0,203002,0,'0',800,25,433889,29552107,178924,175374,32658,32658,21803,21803,0,'[]','[]',250,2250,1500,2250,300,'[{200022011,1},{200022014,1}]',30000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900094,'光明神',0,6,0,'魂珠副本怪物95',0,3,0,0,0,203021,'1.1','0',0,0,0,203021,0,'0',800,25,433889,29552107,178924,175374,32658,32658,21803,21803,0,'[]','[]',250,2250,1500,2250,300,'[{2000202101,1},{200054200,1}]',30000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900095,'嫉妒',0,6,0,'魂珠副本怪物96',0,3,0,0,0,203014,'1.1','0',0,0,0,203014,0,'0',800,25,433889,29552107,178924,175374,32658,32658,21803,21803,0,'[]','[]',250,2250,1500,2250,300,'[{202030141,1},{202030142,1}]',30000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900096,'巴哈姆特',0,6,0,'魂珠副本怪物97',0,3,0,0,0,203026,'1.1','0',0,0,0,203026,0,'0',800,25,433889,29552107,178924,175374,32658,32658,21803,21803,0,'[]','[]',250,2250,1500,2250,300,'[{202030261,1},{202030262,1}]',30000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900097,'美杜莎',0,6,0,'魂珠副本怪物98',0,3,0,0,0,203006,'1.1','0',0,0,0,203006,0,'0',800,25,433889,29552107,178924,175374,32658,32658,21803,21803,0,'[]','[]',250,2250,1500,2250,300,'[{2000230101,1},{2000230102,1}]',30000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900098,'寒冰女神',0,6,0,'魂珠副本怪物99',0,3,0,0,0,203017,'1.1','0',0,0,0,203017,0,'0',800,25,433889,29552107,178924,175374,32658,32658,21803,21803,0,'[]','[]',250,2250,1500,2250,300,'[{2000540201,1},{2000540208,1}]',30000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(5900099,'蜘蛛女皇',0,6,0,'魂珠副本怪物100',0,3,0,0,0,203011,'1.1','0',0,0,0,203011,0,'0',800,25,433889,29552107,178924,175374,32658,32658,21803,21803,0,'[]','[]',250,2250,1500,2250,300,'[{200022021,1},{200022022,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(6000001,'萨拉托加',9,0,0,'护送飞艇1',0,1,0,0,0,471001,'1.2','[]',0,0,0,471001,0,'[]',1,1,0,8,0,0,0,0,0,0,0,'[]','[]',110,2250,1500,2250,210,'[{1110000003,1}]',0,2000,0,1,2,0,0,0,0,0,1,1,0,0,'[1,1]',1,'0',0,0,1,0,0),(6000002,'企业号',9,0,0,'护送飞艇2',0,2,0,0,0,471002,'1.2','[]',0,0,0,471002,0,'[]',1,1,0,12,0,0,0,0,0,0,0,'[]','[]',110,2250,1500,2250,210,'[{1110000003,1}]',0,2000,0,1,2,0,0,0,0,0,1,1,0,0,'[1,1]',1,'0',0,0,1,0,0),(6000003,'列克星敦',9,0,0,'护送飞艇3',0,3,0,0,0,471003,'1.2','[]',0,0,0,471003,0,'[]',1,1,0,16,0,0,0,0,0,0,0,'[]','[]',110,2250,1500,2250,210,'[{1110000003,1}]',0,2000,0,1,2,0,0,0,0,0,1,1,0,0,'[1,1]',1,'0',0,0,1,0,0),(6000004,'皇家方舟',9,0,0,'护送飞艇4',0,4,0,0,0,471004,'1.2','[]',0,0,0,471004,0,'[]',1,1,0,20,0,0,0,0,0,0,0,'[]','[]',110,2250,1500,2250,210,'[{1110000003,1}]',0,2000,0,1,2,0,0,0,0,0,1,1,0,0,'[1,1]',1,'0',0,0,1,0,0),(6100001,'右路水晶',1,0,0,'3V3水晶1-1',0,1,0,0,0,5010087,'1','0',5,0,0,5010087,0,'0',1,1,0,300000,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,0,'[{20001000,1}]',0,0,0,0,100,0,1,5,1,0,0,1,1,0,'[700,1300]',1,'0',0,0,0,0,0),(6100002,'中路水晶',1,0,0,'3V3水晶1-2',0,1,0,0,0,5010087,'1','0',5,0,0,5010087,0,'0',1,1,0,300000,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,0,'[{20001000,1}]',0,0,0,0,100,0,1,5,1,0,0,1,1,0,'[700,1300]',1,'0',0,0,0,0,0),(6100003,'左路水晶',1,0,0,'3V3水晶1-3',0,1,0,0,0,5010087,'1','0',5,0,0,5010087,0,'0',1,1,0,300000,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,0,'[{20001000,1}]',0,0,0,0,100,0,1,5,1,0,0,1,1,0,'[700,1300]',1,'0',0,0,0,0,0),(6100004,'右路水晶',1,0,0,'3V3水晶2-1',0,1,0,0,0,5010087,'1','0',3,0,0,5010087,0,'0',1,1,0,300000,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,0,'[{20001000,1}]',0,0,0,0,100,0,1,5,1,0,0,1,1,0,'[700,1300]',1,'0',0,0,0,0,0),(6100005,'中路水晶',1,0,0,'3V3水晶2-2',0,1,0,0,0,5010087,'1','0',3,0,0,5010087,0,'0',1,1,0,300000,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,0,'[{20001000,1}]',0,0,0,0,100,0,1,5,1,0,0,1,1,0,'[700,1300]',1,'0',0,0,0,0,0),(6100006,'左路水晶',1,0,0,'3V3水晶2-3',0,1,0,0,0,5010087,'1','0',3,0,0,5010087,0,'0',1,1,0,300000,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,0,'[{20001000,1}]',0,0,0,0,100,0,1,5,1,0,0,1,1,0,'[700,1300]',1,'0',0,0,0,0,0),(6100007,'右路水晶',1,0,0,'3V3水晶3-1',0,1,0,0,0,5010087,'1','0',0,0,0,5010087,0,'0',1,1,0,300000,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,0,'[{20001000,1}]',0,0,0,0,100,0,1,5,1,0,0,1,1,0,'[700,1300]',1,'0',0,0,0,0,0),(6100008,'中路水晶',1,0,0,'3V3水晶3-2',0,1,0,0,0,5010087,'1','0',0,0,0,5010087,0,'0',1,1,0,300000,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,0,'[{20001000,1}]',0,0,0,0,100,0,1,5,1,0,0,1,1,0,'[700,1300]',1,'0',0,0,0,0,0),(6100009,'左路水晶',1,0,0,'3V3水晶3-3',0,1,0,0,0,5010087,'1','0',0,0,0,5010087,0,'0',1,1,0,300000,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,0,'[{20001000,1}]',0,0,0,0,100,0,1,5,1,0,0,1,1,0,'[700,1300]',1,'0',0,0,0,0,0),(6100010,'红方守卫',0,2,1,'3V3守卫1',0,5,0,0,0,203026,'1.3','0',0,0,0,203026,0,'0',630,100,4294967295,4294967295,4294967295,4294967295,0,0,0,0,0,'[]','[]',200,2000,2000,2000,450,'[{202030261,1},{202030262,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(6100011,'蓝方守卫',7,0,1,'3V3守卫2',0,5,0,0,0,203003,'1.1','0',0,0,0,203003,0,'0',630,100,99999999,4294967295,0,0,0,0,0,0,0,'[]','[]',200,900,900,900,450,'[{202030031,1},{202030032,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(6100012,'攻击buff',1,0,0,'3V3buff1',0,1,0,0,0,2040009,'1','0',0,0,0,5010011,0,'0',1,1,1,10000,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,0,'[{2100003,1}]',0,2000,0,1,0,0,1,5,1,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(6100013,'防御buff',1,0,0,'3V3buff2',0,2,0,0,0,2040009,'1','0',0,0,0,5010011,0,'0',1,1,1,10000,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,0,'[{2100004,1}]',0,2000,0,1,0,0,1,5,1,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(6100014,'速度buff',1,0,0,'3V3buff3',0,3,0,0,0,2040009,'1','0',0,0,0,5010011,0,'0',1,1,1,10000,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,0,'[{2100005,1}]',0,2000,0,1,0,0,1,5,1,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(6200000,'暗裔猎手',0,6,1,'跨服入侵boss1',0,3,0,0,2,203010,'1.4','0',0,0,0,203010,0,'0',200,100,15000,25380000,0,0,0,0,0,0,0,'[]','[1,460606230,500]',600,2250,1500,2250,300,'[{200022021,1},{200022022,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(6200001,'死神',0,6,1,'跨服入侵boss2',0,3,0,0,2,203018,'1.4','0',0,0,0,203018,0,'0',201,100,15001,25380001,0,0,0,0,0,0,0,'[]','[1,546775110,500]',600,2250,1500,2250,300,'[{2000201801,1},{20005455,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(6200002,'冰霜巨龙',0,6,1,'跨服入侵boss3',0,3,0,0,2,203004,'1.4','0',0,0,0,203004,0,'0',202,100,15002,25380002,0,0,0,0,0,0,0,'[]','[1,599766930,500]',600,2250,1500,2250,300,'[{202030041,1},{202030043,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(6200003,'寒冰女神',0,6,1,'跨服入侵boss4',0,3,0,0,2,203017,'1.4','0',0,0,0,203017,0,'0',203,100,15003,25380003,0,0,0,0,0,0,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{2000540201,1},{2000540208,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(6200004,'半人马',0,6,1,'跨服入侵boss5',0,3,0,0,2,203002,'1.4','0',0,0,0,203002,0,'0',204,100,15004,25380004,0,0,0,0,0,0,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{200022011,1},{200022014,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(6200005,'食人花',0,6,1,'跨服入侵boss6',0,3,0,0,2,203001,'1.4','0',0,0,0,203001,0,'0',205,100,15005,25380005,0,0,0,0,0,0,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{202030011,1},{202030012,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(6200020,'巴哈姆特',0,6,1,'跨服入侵大boss',0,3,0,0,2,203026,'1.4','0',0,0,0,203026,0,'0',220,100,15020,25380020,0,0,0,0,0,0,0,'[]','[1,51026220,500]',600,2250,1500,2250,300,'[{202030261,1},{202030262,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(6200100,'食人花',0,1,0,'跨服入侵小怪1',0,1,0,0,0,202001,'1','0',0,0,0,202001,0,'0',500,1,100,60000,0,0,0,0,0,0,0,'[]','[]',110,1200,1200,1200,200,'[{1110000003,1}]',1000,2000,0,1,2,0,0,0,0,1,1,1,0,0,'[10000,13500]',1,'0',0,0,1,0,0),(6200101,'哥布林',0,1,0,'跨服入侵小怪2',0,1,0,0,0,202005,'1','0',0,0,0,202005,0,'0',550,1,100,60000,0,0,0,0,0,0,0,'[]','[]',110,1200,1200,1200,200,'[{1110000003,1}]',1000,2000,0,1,2,0,0,0,0,1,1,1,0,0,'[10000,13500]',1,'0',0,0,1,0,0),(6200102,'藏宝蟹',0,1,0,'跨服入侵小怪3',0,1,0,0,0,202031,'1','0',0,0,0,202031,0,'0',600,1,100,60000,0,0,0,0,0,0,0,'[]','[]',110,1200,1200,1200,200,'[{1110000003,1}]',1000,2000,0,1,2,0,0,0,0,1,1,1,0,0,'[10000,13500]',1,'0',0,0,1,0,0),(6200103,'树桩怪',0,1,0,'跨服入侵小怪4',0,1,0,0,0,202033,'1','0',0,0,0,202033,0,'0',650,1,100,60000,0,0,0,0,0,0,0,'[]','[]',110,1200,1200,1200,200,'[{1110000003,1}]',1000,2000,0,1,2,0,0,0,0,1,1,1,0,0,'[10000,13500]',1,'0',0,0,1,0,0),(6200104,'蜥蜴人',0,1,0,'跨服入侵小怪5',0,1,0,0,0,202014,'1','0',0,0,0,202014,0,'0',700,1,100,60000,0,0,0,0,0,0,0,'[]','[]',110,1200,1200,1200,200,'[{1110000003,1}]',1000,2000,0,1,2,0,0,0,0,1,1,1,0,0,'[10000,13500]',1,'0',0,0,1,0,0),(6200105,'森林妖精',0,1,0,'跨服入侵小怪6',0,1,0,0,0,202008,'1','0',0,0,0,202008,0,'0',750,1,100,60000,0,0,0,0,0,0,0,'[]','[]',110,1200,1200,1200,200,'[{1110000003,1}]',1000,2000,0,1,2,0,0,0,0,1,1,1,0,0,'[10000,13500]',1,'0',0,0,1,0,0),(6200106,'荒原狼',0,1,0,'跨服入侵小怪7',0,1,0,0,0,202006,'1','0',0,0,0,202006,0,'0',800,1,100,60000,0,0,0,0,0,0,0,'[]','[]',110,1200,1200,1200,200,'[{1110000003,1}]',1000,2000,0,1,2,0,0,0,0,1,1,1,0,0,'[10000,13500]',1,'0',0,0,1,0,0),(6200107,'哥布林',0,1,0,'跨服入侵小怪8',0,1,0,0,0,202003,'1','0',0,0,0,202003,0,'0',850,1,100,60000,0,0,0,0,0,0,0,'[]','[]',110,1200,1200,1200,200,'[{1110000003,1}]',1000,2000,0,1,2,0,0,0,0,1,1,1,0,0,'[10000,13500]',1,'0',0,0,1,0,0),(6200108,'岩龟',0,2,1,'跨服入侵小怪9',0,1,0,0,0,202007,'1','0',0,0,0,202007,0,'0',900,100,100,60000,0,0,0,0,0,0,0,'[]','[]',100,1200,1200,1200,200,'[{1110000003,1}]',5000,2000,0,1,0,0,0,0,0,1,1,1,0,0,'[10000,13500]',1,'0',0,0,0,0,1),(6200109,'爆弹仔',0,1,0,'跨服入侵小怪10',0,1,0,0,0,202030,'1','0',0,0,0,202030,0,'0',950,1,100,60000,0,0,0,0,0,0,0,'[]','[]',110,1200,1200,1200,200,'[{1110000003,1}]',1000,2000,0,1,2,0,0,0,0,1,1,1,0,0,'[10000,13500]',1,'0',0,0,1,0,0),(6301001,'巴哈姆特',0,4,0,'跨服boss1层Lv600击杀掉落8阶装备',0,3,0,0,0,203026,'1.1','0',0,0,0,203026,0,'0',335,200,10852,47101294,23807,15924,1339,1339,1219,1240,0,'[]','[]',600,1300,1300,1500,300,'[{202030261,1},{202030262,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(6301002,'机械泰坦',0,4,0,'跨服boss1层Lv620击杀掉落8阶装备',0,3,0,0,0,203008,'1.2','0',0,0,0,203008,0,'0',345,200,11714,51720813,25537,17579,1488,1488,1280,1303,0,'[]','[]',600,1300,1300,1500,300,'[{202030081,1},{202030082,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(6301003,'暗裔猎手',0,4,0,'跨服boss1层Lv640击杀掉落8阶装备',0,3,0,0,0,203010,'1.2','0',0,0,0,203010,0,'0',355,200,13223,57624599,27396,19549,1745,1745,1449,1475,0,'[]','[]',600,1300,1300,1500,300,'[{200022021,1},{200022022,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(6301004,'远古花后',0,4,0,'跨服boss1层Lv650击杀掉落9阶装备',0,3,0,0,0,203001,'1.2','0',0,0,0,203001,0,'0',370,200,14871,68445171,30379,22975,2295,2295,1864,1896,0,'[]','[]',600,1300,1300,1500,300,'[{200022021,1},{200022022,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(6301005,'冰霜巨人',0,4,0,'跨服boss1层Lv670击杀掉落9阶装备',0,3,0,0,0,203003,'1.2','0',0,0,0,203003,0,'0',390,200,17780,82941709,34357,27544,3029,3029,2416,2457,0,'[]','[]',600,1300,1300,1500,300,'[{202030031,1},{202030032,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(6301006,'嫉妒',0,4,0,'跨服boss1层Lv690击杀掉落9阶装备',0,3,0,0,0,203014,'1.2','0',0,0,0,203014,0,'0',410,200,20036,95924357,38185,31525,3745,3745,2868,2928,0,'[]','[]',600,1300,1300,1500,300,'[{200022021,1},{200022022,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(6301101,'普通水晶',1,0,0,'跨服BOSS普通采集1层',0,1,0,0,0,5010064,'0.8','0',0,0,0,5010064,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,1,0,0,1,5,1,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(6301102,'时空宝藏',1,0,0,'跨服BOSS高级采集1层',0,1,0,0,0,2040009,'0.8','0',0,0,0,2040009,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',1200000,2000,0,1,0,0,1,5,1,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(6302001,'冰雪女王',0,4,0,'跨服boss2层Lv700击杀掉落10阶装备',0,3,0,0,0,203017,'1.1','0',0,0,0,203017,0,'0',430,200,22256,107350379,41863,34916,4444,4444,3221,3312,0,'[]','[]',600,1300,1300,1500,300,'[{2000540201,1},{2000540208,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(6302002,'暗裔恶魔',0,4,0,'跨服boss2层Lv720击杀掉落10阶装备',0,3,0,0,0,203007,'1.2','0',0,0,0,203007,0,'0',450,200,24470,118759190,45541,38307,5142,5142,3573,3695,0,'[]','[]',600,1300,1300,1500,300,'[{2000230301,1},{2000230303,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(6302003,'迦楼罗',0,4,0,'跨服boss2层Lv740击杀掉落10阶装备',0,3,0,0,0,203020,'1.2','0',0,0,0,203020,0,'0',470,200,27731,136072573,51029,43490,6165,6165,4337,4505,0,'[]','[]',600,1300,1300,1500,300,'[{202030201,1},{202030202,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(6302004,'暴食',0,4,0,'跨服boss2层Lv750击杀掉落11阶装备',0,3,0,0,0,203015,'1.2','0',0,0,0,203015,0,'0',490,200,30991,153398902,56516,48673,7188,7188,5101,5315,0,'[]','[]',600,1300,1300,1500,300,'[{202030151,1},{202030152,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(6302005,'蜘蛛女皇',0,4,0,'跨服boss2层Lv770击杀掉落11阶装备',0,3,0,0,0,203011,'1.2','0',0,0,0,203011,0,'0',510,200,34522,172142186,62379,54229,8739,8739,6118,6367,0,'[]','[]',600,1300,1300,1500,300,'[{200022021,1},{200022022,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(6302006,'暮光月神',0,4,0,'跨服boss2层Lv790击杀掉落11阶装备',0,3,0,0,0,203022,'1.2','0',0,0,0,203022,0,'0',530,200,38327,192316148,68616,60156,10818,10818,7388,7661,0,'[]','[]',600,1300,1300,1500,300,'[{2000540401,1},{2000540402,1},{2000540406,1},{2000540410,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(6302101,'普通水晶',1,0,0,'跨服BOSS普通采集2层',0,1,0,0,0,5010064,'0.8','0',0,0,0,5010064,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,1,0,0,1,5,1,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(6302102,'时空宝藏',1,0,0,'跨服BOSS高级采集2层',0,1,0,0,0,2040009,'0.8','0',0,0,0,2040009,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',1200000,2000,0,1,0,0,1,5,1,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(6303001,'巴哈姆特',0,4,0,'跨服boss3层Lv800击杀掉落12阶装备',0,3,0,0,0,203026,'1.1','0',0,0,0,203026,0,'0',550,200,43812,212478110,74853,66084,12896,12896,8658,8955,0,'[]','[]',600,1300,1300,1500,300,'[{202030261,1},{202030262,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(6303002,'远古花后',0,4,0,'跨服boss3层Lv820击杀掉落12阶装备',0,3,0,0,0,203001,'1.2','0',0,0,0,203001,0,'0',570,200,48045,234028655,81545,72484,14409,14409,9459,9734,0,'[]','[]',600,1300,1300,1500,300,'[{202030011,1},{202030012,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(6303003,'暮光月神',0,4,0,'跨服boss3层Lv840击杀掉落12阶装备',0,3,0,0,0,203022,'1.2','0',0,0,0,203022,0,'0',590,200,52271,255558911,88237,78884,15922,15922,10260,10513,0,'[]','[]',600,1300,1300,1500,300,'[{2000540401,1},{2000540402,1},{2000540406,1},{2000540410,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(6303004,'嫉妒',0,4,0,'跨服boss3层Lv850击杀掉落13阶装备',0,3,0,0,0,203014,'1.2','0',0,0,0,203014,0,'0',610,200,56726,278232811,95538,85891,17592,17592,11349,11571,0,'[]','[]',600,1300,1300,1500,300,'[{202030141,1},{202030142,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(6303005,'暗裔猎手',0,4,0,'跨服boss3层Lv870击杀掉落13阶装备',0,3,0,0,0,203010,'1.2','0',0,0,0,203010,0,'0',630,200,61412,302048359,103447,93506,19420,19420,12727,12909,0,'[]','[]',600,1300,1300,1500,300,'[{200022021,1},{200022022,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(6303006,'冰雪女王',0,4,0,'跨服boss3层Lv890击杀掉落13阶装备',0,3,0,0,0,203017,'1.2','0',0,0,0,203017,0,'0',650,200,66088,325831626,111357,101121,21249,21249,14106,14246,0,'[]','[]',600,1300,1300,1500,300,'[{2000540201,1},{2000540208,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(6303101,'普通水晶',1,0,0,'跨服BOSS普通采集3层',0,1,0,0,0,5010064,'0.8','0',0,0,0,5010064,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,1,0,0,1,5,1,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(6303102,'时空宝藏',1,0,0,'跨服BOSS高级采集3层',0,1,0,0,0,2040009,'0.8','0',0,0,0,2040009,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',1200000,2000,0,1,0,0,1,5,1,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(6304001,'海龙王',0,4,0,'跨服boss4层Lv900击杀掉落14阶装备',0,3,0,0,0,203009,'1.1','0',0,0,0,203009,0,'0',670,200,71827,355529177,119556,109050,22913,22913,14897,15045,0,'[]','[]',600,1300,1300,1500,300,'[{202030091,1},{202030092,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(6304002,'冰霜巨龙',0,4,0,'跨服boss4层Lv920击杀掉落14阶装备',0,3,0,0,0,203004,'1.2','0',0,0,0,203004,0,'0',690,200,77556,385202919,127755,116978,24577,24577,15689,15843,0,'[]','[]',600,1300,1300,1500,300,'[{202030041,1},{202030043,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(6304003,'寒冰女神',0,4,0,'跨服boss4层Lv940击杀掉落14阶装备',0,3,0,0,0,203017,'1.2','0',0,0,0,203017,0,'0',710,200,83026,413196818,136220,125164,26130,26130,16481,16607,0,'[]','[]',600,1300,1300,1500,300,'[{2000540201,1},{2000540208,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(6304004,'巴哈姆特',0,4,0,'跨服boss4层Lv950击杀掉落15阶装备',0,3,0,0,0,203026,'1.2','0',0,0,0,203026,0,'0',730,200,88233,439505191,144951,133607,27571,27571,17274,17337,0,'[]','[]',600,1300,1300,1500,300,'[{202030261,1},{202030262,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(6304005,'远古花后',0,4,0,'跨服boss4层Lv970击杀掉落15阶装备',0,3,0,0,0,203001,'1.2','0',0,0,0,203001,0,'0',750,200,93425,465757732,153682,142050,29013,29013,18067,18067,0,'[]','[]',600,1300,1300,1500,300,'[{202030011,1},{202030012,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(6304006,'暮光月神',0,4,0,'跨服boss4层Lv990击杀掉落15阶装备',0,3,0,0,0,203022,'1.2','0',0,0,0,203022,0,'0',770,200,99116,494442455,163778,151872,30471,30471,19561,19561,0,'[]','[]',600,1300,1300,1500,300,'[{2000540401,1},{2000540402,1},{2000540406,1},{2000540410,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(6304101,'普通水晶',1,0,0,'跨服BOSS普通采集3层',0,1,0,0,0,5010064,'0.8','0',0,0,0,5010064,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,1,0,0,1,5,1,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(6304102,'时空宝藏',1,0,0,'跨服BOSS高级采集3层',0,1,0,0,0,2040009,'0.8','0',0,0,0,2040009,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',1200000,2000,0,1,0,0,1,5,1,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(10000001,'藏宝蟹',0,0,0,'朔月海岸-挂机点1Lv3',0,1,0,0,0,202031,'1','0',0,0,0,202031,0,'0',3,1,1,15,16,16,0,0,0,0,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,15,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,1,1,0,0),(10000002,'魔化藏宝蟹',0,0,0,'朔月海岸-挂机点2Lv6',0,1,0,0,0,202032,'1','0',0,0,0,202032,0,'0',6,1,1,104,33,43,0,0,0,0,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,31,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,1,1,0,0),(10000003,'树桩怪',0,0,0,'朔月海岸-挂机点3Lv9',0,1,0,0,0,202033,'1','0',0,0,0,202033,0,'0',9,1,2,117,39,48,0,0,0,0,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,48,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,1,1,0,0),(10000004,'火鸡骑士',0,0,0,'朔月海岸-挂机点4Lv11',0,1,0,0,0,202034,'1','0',0,0,0,202034,0,'0',11,1,2,126,54,52,0,0,0,0,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,64,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,1,1,0,0),(10000005,'强盗',0,0,0,'朔月海岸-挂机点5Lv13',0,1,0,0,0,202011,'1','0',0,0,0,202011,0,'0',13,1,2,147,58,56,0,0,0,0,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,81,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,1,1,0,0),(10000006,'树桩怪',0,0,0,'朔月海岸-挂机点6Lv17',0,1,0,0,0,202033,'1','0',0,0,0,202033,0,'0',17,1,4,166,94,64,0,0,0,0,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,98,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,1,1,0,0),(10000007,'叛变佣兵',0,0,0,'朔月海岸-挂机点7Lv19',0,1,0,0,0,202012,'1','0',0,0,0,202012,0,'0',19,1,4,233,98,82,0,0,0,0,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,114,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,1,1,0,0),(10000008,'海盗',0,0,0,'朔月海岸-挂机点8Lv21',0,1,0,0,0,202011,'1','0',0,0,0,202011,0,'0',21,1,4,266,102,86,0,0,0,0,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,131,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,1,1,0,0),(10000009,'暗裔死神',0,1,0,'朔月海岸-挂机点9Lv15【新手】Lv15任务id：10150暗裔来袭BOSS',0,4,0,0,0,203018,'1.3','0',0,0,0,203018,0,'0',15,10,61,10638,103,85,0,0,0,0,0,'[]','[]',600,800,0,600,200,'[{2000201801,1},{20005455,1}]',1000,2000,0,1,6,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10000020,'主角武器',2,0,0,'主线采集怪1',0,1,0,0,0,2040009,'1','0',0,0,0,2040009,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,800,800,800,200,'[{1110000003,1}]',100,2000,0,1,0,0,0,0,0,0,0,0,0,0,'[]',1,'0',0,0,0,0,0),(10000021,'辉星石',2,0,0,'主线采集怪2',0,1,0,0,0,2040012,'1','0',0,0,0,2040012,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,800,800,800,200,'[{1110000003,1}]',100,2000,0,1,0,0,0,0,0,0,0,0,0,0,'[]',1,'0',0,0,0,0,0),(10020001,'魔化藏宝蟹',0,0,0,'抵抗军营-挂机点1Lv25',0,1,0,0,0,202022,'1','0',0,0,0,202022,0,'0',25,1,9,625,143,109,86,86,0,0,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',100,2000,0,1,147,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,1,1,0,0),(10020002,'魔化平民',0,0,0,'抵抗军营-挂机点2Lv30',0,1,0,0,0,202036,'1','0',0,0,0,202036,0,'0',30,1,11,660,170,115,93,93,0,0,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',100,2000,0,1,164,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,1,1,0,0),(10020003,'魔化傀儡',0,0,0,'抵抗军营-挂机点3Lv35',0,1,0,0,0,202037,'1','0',0,0,0,202037,0,'0',35,1,12,902,205,148,93,93,0,0,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',100,2000,0,1,181,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,1,1,0,0),(10020004,'魔化楔形虫',0,0,0,'抵抗军营-挂机点4Lv39',0,1,0,0,0,202038,'1','0',0,0,0,202038,0,'0',39,1,13,1173,213,189,93,93,0,0,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',100,2000,0,1,197,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,1,1,0,0),(10020005,'魔化机兵',0,0,0,'抵抗军营-挂机点5Lv42',0,1,0,0,0,202035,'1','0',0,0,0,202035,0,'0',42,1,13,1238,221,195,93,93,0,0,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',100,2000,0,1,214,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,1,1,0,0),(10020006,'魔化难民',0,0,0,'抵抗军营-挂机点6Lv44',0,1,0,0,0,202036,'1','0',0,0,0,202036,0,'0',44,1,15,739,227,200,93,93,0,0,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',100,2000,0,1,230,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,1,1,0,0),(10020007,'魔化机械',0,0,0,'抵抗军营-挂机点7Lv50',0,1,0,0,0,202035,'1','0',0,0,0,202035,0,'0',50,1,16,1388,255,210,93,93,0,0,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',100,2000,0,1,247,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,1,1,0,0),(10020008,'蜘蛛女皇',0,1,0,'抵抗军营-挂机点8Lv35【新手】Lv35任务id：10350暗裔突袭BOSS',0,4,0,0,0,203011,'1.2','0',0,0,0,203011,0,'0',35,10,169,24034,159,196,107,107,0,0,0,'[]','[]',600,1500,0,600,200,'[{200022021,1},{200022022,1}]',100,2000,0,1,6,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10020020,'木材',2,0,0,'主线采集怪1',0,1,0,0,0,2040014,'1','0',0,0,0,2040014,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,800,800,800,200,'[{1110000003,1}]',100,2000,0,1,0,0,0,0,0,0,0,0,0,0,'[]',1,'0',0,0,0,0,0),(10020021,'辉星石',2,0,0,'主线采集怪2',0,1,0,0,0,2040012,'1','0',0,0,0,2040012,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,800,800,800,200,'[{1110000003,1}]',100,2000,0,1,0,0,0,0,0,0,0,0,0,0,'[]',1,'0',0,0,0,0,0),(10020022,'机械零件',2,0,0,'主线采集怪3',0,1,0,0,0,2040017,'1','0',0,0,0,2040017,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,800,800,800,200,'[{1110000003,1}]',100,2000,0,1,0,0,0,0,0,0,0,0,0,0,'[]',1,'0',0,0,0,0,0),(10020023,'淘气虎',2,0,0,'主线采集怪4',0,1,0,0,0,301022,'1','0',0,0,0,301022,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,800,800,800,200,'[{1110000003,1}]',100,2000,0,1,0,0,0,0,0,0,0,0,0,0,'[]',1,'0',0,0,0,0,0),(10030001,'暗影狼',0,0,0,'迷雾沼泽-挂机点1Lv54',0,1,0,0,0,202006,'2.5','0',0,0,0,202006,0,'0',54,1,26,8703,425,271,120,125,29,28,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',100,2000,0,1,264,0,0,0,0,1,1,1,0,1,'[]',1,'0',0,1,1,0,0),(10030002,'骷髅兵',0,0,0,'迷雾沼泽-挂机点2Lv57',0,1,0,0,0,202002,'1','0',0,0,0,202002,0,'0',57,1,26,2382,430,417,120,125,29,28,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',100,2000,0,1,280,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,1,1,0,0),(10030003,'史莱姆',0,0,0,'迷雾沼泽-挂机点3Lv59',0,1,0,0,0,202003,'1','0',0,0,0,202003,0,'0',59,1,26,2472,434,421,120,125,29,28,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',100,2000,0,1,297,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,1,1,0,0),(10030004,'哥布林',0,0,0,'迷雾沼泽-挂机点4Lv62',0,1,0,0,0,202005,'1','0',0,0,0,202005,0,'0',62,1,31,3469,540,618,120,125,29,28,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',100,2000,0,1,313,0,0,0,0,1,1,1,0,1,'[]',1,'0',0,1,1,0,0),(10030005,'沼泽妖精',0,0,0,'迷雾沼泽-挂机点5Lv66',0,1,0,0,0,202008,'1','0',0,0,0,202008,0,'0',66,1,35,4594,549,829,120,125,29,28,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',100,2000,0,1,330,0,0,0,0,1,1,1,0,1,'[]',1,'0',0,1,1,0,0),(10030006,'沼泽史莱姆',0,0,0,'迷雾沼泽-挂机点6Lv72',0,1,0,0,0,202003,'1','0',0,0,0,202003,0,'0',72,1,35,4766,656,839,120,125,29,28,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',100,2000,0,1,347,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,1,1,0,0),(10030007,'蜥蜴人',0,0,0,'迷雾沼泽-挂机点7Lv78',0,1,0,0,0,202014,'1','0',0,0,0,202014,0,'0',78,1,36,4953,668,851,120,125,29,28,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',100,2000,0,1,363,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,1,1,0,0),(10030008,'荆棘之花',0,1,0,'迷雾沼泽-挂机点8Lv77【新手】Lv77任务id：10740荆棘之花BOSS',0,4,0,0,0,203001,'1.4','0',0,0,0,203001,0,'0',77,10,246,40103,291,333,107,107,0,0,0,'[]','[]',600,800,0,600,200,'[{202030011,1},{202030012,1}]',100,2000,0,1,6,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10030020,'龙鳞',2,0,0,'主线采集怪1',0,1,0,0,0,2040018,'1','0',0,0,0,2040018,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,800,800,800,200,'[{1110000003,1}]',100,2000,0,1,0,0,0,0,0,0,0,0,0,0,'[]',1,'0',0,0,0,0,0),(10030021,'辉星石',2,0,0,'主线采集怪2',0,1,0,0,0,2040012,'1','0',0,0,0,2040012,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,800,800,800,200,'[{1110000003,1}]',100,2000,0,1,0,0,0,0,0,0,0,0,0,0,'[]',1,'0',0,0,0,0,0),(10030022,'蜜果箱',2,0,0,'主线采集怪3',0,1,0,0,0,2040009,'1','0',0,0,0,2040009,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,800,800,800,200,'[{1110000003,1}]',100,2000,0,1,0,0,0,0,0,0,0,0,0,0,'[]',1,'0',0,0,0,0,0),(10040020,'星象仪',2,0,0,'主线采集怪1【主城场景物】',0,1,0,0,0,2050013,'1','0',0,0,0,2050013,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,800,800,800,200,'[{1110000003,1}]',100,2000,0,1,0,0,0,0,0,0,0,0,0,0,'[]',1,'0',0,0,0,0,0),(10050001,'吞噬花',0,1,0,'蘑菇林-挂机点1Lv80',0,1,0,0,0,202001,'1','0',0,0,0,202001,0,'0',80,1,36,5244,674,857,120,125,29,28,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',100,2000,0,1,480,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,1,1,0,0),(10050002,'哥布林',0,1,0,'蘑菇林-挂机点2Lv83',0,1,0,0,0,202005,'1','0',0,0,0,202005,0,'0',83,1,36,5429,677,862,120,125,29,33,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',100,2000,0,1,482,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,1,1,0,0),(10050003,'森林狼',0,1,0,'蘑菇林-挂机点3Lv86',0,1,0,0,0,202006,'1','0',0,0,0,202006,0,'0',86,1,37,5631,683,867,120,125,34,33,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',100,2000,0,1,484,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,1,1,0,0),(10050004,'森林妖精',0,1,0,'蘑菇林-挂机点4Lv90',0,2,0,0,0,202008,'1','0',0,0,0,202008,0,'0',90,1,37,5819,693,877,120,125,34,33,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',100,2000,0,1,486,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,1,1,0,0),(10050005,'精灵侍卫',0,1,0,'蘑菇林-挂机点5Lv93',0,2,0,0,0,202004,'1','0',0,0,0,202004,0,'0',93,1,38,6013,696,881,124,130,41,40,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',100,2000,0,1,488,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,1,1,0,0),(10050006,'岩龟',0,1,0,'蘑菇林-挂机点6Lv96',0,2,0,0,0,202007,'1','0',0,0,0,202007,0,'0',96,1,38,6229,702,887,124,130,41,40,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',100,2000,0,1,491,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,1,1,0,0),(10050007,'木头精',0,1,0,'蘑菇林-挂机点7Lv100',0,3,0,0,0,202033,'1','0',0,0,0,202033,0,'0',100,1,60,6425,712,897,124,130,41,40,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',100,2000,0,1,493,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,1,1,0,0),(10050008,'蜥蜴人',0,1,0,'蘑菇林-挂机点8Lv105',0,3,0,0,0,202014,'1','0',0,0,0,202014,0,'0',105,1,60,10087,719,905,124,130,41,40,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',100,2000,0,1,495,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,1,1,0,0),(10050009,'巨大岩龟',0,2,1,'蘑菇林-挂机点9Lv120',0,4,0,0,0,202007,'3','0',0,0,0,202007,0,'0',120,1,19,6838,381,386,146,146,42,42,0,'[]','[]',100,800,0,600,200,'[{1110000003,1}]',100,2000,0,1,7,0,0,0,0,1,1,1,0,0,'[500,1500]',1,'0',0,1,0,0,1),(10050020,'蜜果',2,0,0,'主线采集怪1',0,1,0,0,0,2040016,'1','0',0,0,0,2040016,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,800,800,800,200,'[{1110000003,1}]',100,2000,0,1,0,0,0,0,0,0,0,0,0,0,'[]',1,'0',0,0,0,0,0),(10050021,'鸟蛋',2,0,0,'主线采集怪2',0,1,0,0,0,2040015,'1','0',0,0,0,2040015,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,800,800,800,200,'[{1110000003,1}]',100,2000,0,1,0,0,0,0,0,0,0,0,0,0,'[]',1,'0',0,0,0,0,0),(10060001,'丛林狼',0,1,0,'森林神殿-挂机点1Lv110',0,1,0,0,0,202006,'1','0',0,0,0,202006,0,'0',110,1,61,10575,729,915,124,130,41,40,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,497,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,1,1,0,0),(10060002,'暗裔妖精',0,1,0,'森林神殿-挂机点2Lv120',0,1,0,0,0,202008,'1','0',0,0,0,202008,0,'0',120,1,60,11132,748,935,124,130,41,40,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,499,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,1,1,0,0),(10060003,'食人花',0,1,0,'森林神殿-挂机点3Lv130',0,1,0,0,0,202001,'1','0',0,0,0,202001,0,'0',130,1,60,11727,800,1025,116,123,39,39,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,502,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,1,1,0,0),(10060004,'神殿守卫',0,1,0,'森林神殿-挂机点4Lv140',0,1,0,0,0,202004,'1','0',0,0,0,202004,0,'0',140,1,61,12394,928,1277,87,99,34,36,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,504,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,1,1,0,0),(10060005,'蜥蜴战士',0,1,0,'森林神殿-挂机点5Lv160',0,1,0,0,0,202014,'1','0',0,0,0,202014,0,'0',160,1,62,14511,1237,1718,58,75,29,33,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,506,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,1,1,0,0),(10060006,'岩背龟',0,1,0,'森林神殿-挂机点6Lv170',0,1,0,0,0,202007,'1','0',0,0,0,202007,0,'0',170,1,79,15741,1644,1778,67,81,34,39,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,508,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,1,1,0,0),(10060007,'森林侍卫',0,1,0,'森林神殿-挂机点7Lv180',0,1,0,0,0,202004,'1','0',0,0,0,202004,0,'0',180,1,125,17749,2641,1908,86,93,46,54,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,510,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,1,1,0,0),(10060008,'葛布林',0,1,0,'森林神殿-挂机点8Lv190',0,1,0,0,0,202005,'1','0',0,0,0,202005,0,'0',190,1,174,19495,3631,2038,106,106,58,69,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,513,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,1,1,0,0),(10060009,'人马战士',0,2,1,'森林神殿-挂机点9Lv195',0,1,0,0,0,203002,'2','0',0,0,0,203002,0,'0',195,1,90,26011,1670,1491,284,284,147,147,0,'[]','[]',100,800,0,600,200,'[{200022011,1},{200022014,1}]',1000,2000,0,1,12,0,0,0,0,1,1,1,0,0,'[500,1500]',1,'0',0,0,0,0,1),(10060020,'木材',2,0,0,'主线采集怪1',0,1,0,0,0,2040014,'1','0',0,0,0,2040014,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,800,800,800,200,'[{1110000003,1}]',1000,2000,0,1,0,0,0,0,0,0,0,0,0,0,'[]',1,'0',0,0,0,0,0),(10060021,'辉星石',2,0,0,'主线采集怪2',0,1,0,0,0,2040012,'1','0',0,0,0,2040012,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,800,800,800,200,'[{1110000003,1}]',1000,2000,0,1,0,0,0,0,0,0,0,0,0,0,'[]',1,'0',0,0,0,0,0),(10060100,'人马战士',0,2,1,'地图4森林神殿-剧情boss',0,1,0,0,0,203002,'1.2','0',0,0,0,203002,0,'0',110,5,27,7285,236,236,0,0,0,0,0,'[]','[]',600,800,800,800,200,'[{200022011,1},{200022014,1}]',1000,2000,0,1,12,0,0,0,0,1,1,1,0,0,'[500,1500]',1,'0',0,0,0,0,1),(10070001,'雪原企鹅',0,1,0,'寒鸦峡谷-挂机点1Lv200',0,1,0,0,0,202009,'1','0',0,0,0,202009,0,'0',200,1,213,24003,4234,2426,119,119,97,109,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,567,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,1,1,0,0),(10070002,'雪岩怪',0,1,0,'寒鸦峡谷-挂机点2Lv210',0,1,0,0,0,202010,'1','0',0,0,0,202010,0,'0',210,1,254,28541,4833,2811,132,132,136,150,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,624,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,1,1,0,0),(10070003,'雪原蟹',0,1,0,'寒鸦峡谷-挂机点3Lv215',0,1,0,0,0,202022,'1','0',0,0,0,202022,0,'0',215,1,277,30844,5123,2997,139,139,156,169,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,624,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,1,1,0,0),(10070004,'雪原狼',0,1,0,'寒鸦峡谷-挂机点4Lv220',0,1,0,0,0,202006,'1','0',0,0,0,202006,0,'0',220,1,300,33152,5411,3183,145,145,175,189,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,684,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,1,1,0,0),(10070005,'冰原企鹅',0,1,0,'寒鸦峡谷-挂机点5Lv225',0,1,0,0,0,202009,'1','0',0,0,0,202009,0,'0',225,1,324,35473,5697,3367,151,151,194,208,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,684,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,1,1,0,0),(10070006,'冰岩怪',0,1,0,'寒鸦峡谷-挂机点6Lv230',0,1,0,0,0,202010,'1','0',0,0,0,202010,0,'0',230,1,348,37804,5981,3550,157,157,213,228,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,722,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,1,1,0,0),(10070007,'冰原狼',0,1,0,'寒鸦峡谷-挂机点7Lv240',0,1,0,0,0,202006,'1','0',0,0,0,202006,0,'0',240,1,469,49668,7698,4762,255,255,322,343,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,847,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,1,1,0,0),(10070008,'冰脉巨龙',0,1,0,'寒鸦峡谷-挂机点8Lv250',0,1,0,0,0,203004,'1.4','0',0,0,0,203004,0,'0',250,1,599,61734,9403,5966,351,351,431,457,0,'[]','[]',110,800,0,600,200,'[{202030041,1},{202030043,1}]',1000,2000,0,1,881,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10070009,'冰霜泰坦',0,2,1,'寒鸦峡谷-挂机点9Lv285',0,1,0,0,0,203003,'1.6','0',0,0,0,203003,0,'0',285,1,273,68145,3932,3328,739,739,712,712,0,'[]','[]',100,800,0,600,200,'[{202030031,1},{202030032,1}]',5000,2000,0,1,21,0,0,0,0,1,1,1,0,0,'[500,1500]',1,'0',0,0,0,0,1),(10070020,'龙鳞',2,0,0,'主线采集怪1',0,1,0,0,0,2040018,'1','0',0,0,0,2040018,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,800,800,800,200,'[{1110000003,1}]',100,2000,0,1,0,0,0,0,0,0,0,0,0,0,'[]',1,'0',0,0,0,0,0),(10070021,'辉星石',2,0,0,'主线采集怪2',0,1,0,0,0,2040012,'1','0',0,0,0,2040012,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,800,800,800,200,'[{1110000003,1}]',100,2000,0,1,0,0,0,0,0,0,0,0,0,0,'[]',1,'0',0,0,0,0,0),(10070100,'冰脉巨龙',0,1,0,'地图5失落之海-剧情boss',0,1,0,0,0,203004,'1.4','0',0,0,0,203004,0,'0',180,1,409,53225,2397,2023,412,0,450,493,0,'[]','[]',600,800,800,800,200,'[{202030041,1},{202030043,1}]',1000,2000,0,1,20,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10080001,'骷髅士兵',0,1,0,'风蚀台地-挂机点1Lv250',0,1,0,0,0,202002,'1','0',0,0,0,202002,0,'0',250,1,603,61849,9373,5947,350,350,429,456,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,881,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10080002,'沙布林',0,1,0,'风蚀台地-挂机点2Lv255',0,1,0,0,0,202005,'1','0',0,0,0,202005,0,'0',255,1,672,66396,10116,6309,393,393,482,507,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,881,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10080003,'沙盗',0,1,0,'风蚀台地-挂机点3Lv260',0,1,0,0,0,202011,'1','0',0,0,0,202011,0,'0',260,1,742,70964,10854,6670,435,435,534,558,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,916,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10080004,'邪恶佣兵',0,1,0,'风蚀台地-挂机点4Lv265',0,1,0,0,0,202012,'1','0',0,0,0,202012,0,'0',265,1,816,75614,11574,7020,477,477,585,607,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,916,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10080005,'沙漠蝎子',0,1,0,'风蚀台地-挂机点5Lv270',0,1,0,0,0,202013,'1','0',0,0,0,202013,0,'0',270,1,894,80355,12274,7358,518,518,635,656,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,960,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10080006,'沙漠蜥蜴',0,1,0,'风蚀台地-挂机点6Lv275',0,1,0,0,0,202014,'1','0',0,0,0,202014,0,'0',275,1,960,84741,13067,7752,562,562,689,709,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,960,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10080007,'骷髅守卫',0,1,0,'风蚀台地-挂机点7Lv280',0,1,0,0,0,202002,'1','0',0,0,0,202002,0,'0',280,1,1025,89111,13863,8148,607,607,744,763,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,954,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10080008,'蜥蜴战士',0,1,0,'风蚀台地-挂机点8Lv290',0,1,0,0,0,202014,'1','0',0,0,0,202014,0,'0',290,1,1161,97954,15431,8925,696,696,853,869,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,1005,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10080020,'机械零件',2,0,0,'主线采集怪1',0,1,0,0,0,2040017,'1','0',0,0,0,2040017,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,800,800,800,200,'[{1110000003,1}]',100,2000,0,1,0,0,0,0,0,0,0,0,0,0,'[]',1,'0',0,0,0,0,0),(10080021,'辉星石',2,0,0,'主线采集怪2',0,1,0,0,0,2040012,'1','0',0,0,0,2040012,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,800,800,800,200,'[{1110000003,1}]',100,2000,0,1,0,0,0,0,0,0,0,0,0,0,'[]',1,'0',0,0,0,0,0),(10080100,'阿努比斯',0,2,1,'剧情BOSS',0,1,0,0,0,203005,'1.8','0',0,0,0,203005,0,'0',385,1,331,173948,6005,5104,1369,1369,1111,1111,0,'[]','[]',100,800,800,800,200,'[{202030051,1},{202030052,1}]',5000,2000,0,1,70,0,0,0,0,1,1,1,0,0,'[500,1500]',1,'0',0,0,0,0,1),(10080200,'美杜莎',0,2,1,'世界boss',0,1,0,0,0,203006,'1.8','0',0,0,0,203006,0,'0',385,1,331,173948,6005,5104,1369,1369,1111,1111,0,'[]','[]',100,800,800,800,200,'[{2000230101,1},{2000230102,1}]',5000,2000,0,1,70,0,0,0,0,1,1,1,0,0,'[500,1500]',1,'0',0,0,0,0,1),(10090001,'废旧机器人',0,1,0,'暗裔秘所-挂机点1Lv300',0,1,0,0,0,202015,'1','0',0,0,0,202015,0,'0',300,1,1296,106685,17025,9717,785,785,963,977,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,1026,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10090002,'机械犬',0,1,0,'暗裔秘所-挂机点2Lv305',0,1,0,0,0,202016,'1','0',0,0,0,202016,0,'0',305,1,1368,114411,17913,10545,859,859,996,1010,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,1026,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10090003,'帝国步兵',0,1,0,'暗裔秘所-挂机点3Lv310',0,1,0,0,0,202017,'1','0',0,0,0,202017,0,'0',310,1,1429,121812,18868,11415,937,937,1032,1048,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,1018,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10090004,'机动巡逻兵',0,1,0,'暗裔秘所-挂机点4Lv315',0,2,0,0,0,202018,'1','0',0,0,0,202018,0,'0',315,1,1490,129212,19812,12283,1014,1014,1067,1084,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,1018,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10090005,'恶魔幼体',0,1,0,'暗裔秘所-挂机点5Lv320',0,1,0,0,0,202019,'1','0',0,0,0,202019,0,'0',320,1,1549,136526,20766,13159,1093,1093,1103,1121,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,1083,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10090006,'破烂机器人',0,1,0,'暗裔秘所-挂机点6Lv330',0,1,0,0,0,202015,'1','0',0,0,0,202015,0,'0',330,1,1685,151590,22580,14858,1245,1245,1169,1189,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,1148,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10090007,'机械狗',0,1,0,'暗裔秘所-挂机点7Lv340',0,1,0,0,0,202016,'1','0',0,0,0,202016,0,'0',340,1,1818,166462,24412,16575,1398,1398,1236,1258,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,1153,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10090008,'帝国士兵',0,1,0,'暗裔秘所-挂机点8Lv350',0,1,0,0,0,202017,'1','0',0,0,0,202017,0,'0',350,1,1974,181912,26151,18232,1547,1547,1299,1322,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,1238,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10090020,'机械零件',2,0,0,'主线采集怪1',0,1,0,0,0,2040017,'1','0',0,0,0,2040017,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,800,800,800,200,'[{1110000003,1}]',100,2000,0,1,0,0,0,0,0,0,0,0,0,0,'[]',1,'0',0,0,0,0,0),(10090021,'辉星石',2,0,0,'主线采集怪2',0,1,0,0,0,2040012,'1','0',0,0,0,2040012,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,800,800,800,200,'[{1110000003,1}]',100,2000,0,1,0,0,0,0,0,0,0,0,0,0,'[]',1,'0',0,0,0,0,0),(10090100,'质检员',0,2,1,'暗裔秘所-挂机点9Lv485',0,2,0,0,0,203008,'2','0',0,0,0,203008,0,'0',485,1,556,308388,10713,9442,3129,3129,2024,2024,0,'[]','[]',100,800,0,600,200,'[{202030081,1},{202030082,1}]',5000,2000,0,1,154,0,0,0,0,1,1,1,0,0,'[500,1500]',1,'0',0,0,0,0,1),(10090200,'恶魔骑士',0,2,1,'暗裔秘所-挂机点9Lv485',0,2,0,0,0,203007,'2','0',0,0,0,203007,0,'0',485,1,556,308388,10713,9442,3129,3129,2024,2024,0,'[]','[]',100,800,0,600,200,'[{2000230301,1},{2000230303,1}]',5000,2000,0,1,154,0,0,0,0,1,1,1,0,0,'[500,1500]',1,'0',0,0,0,0,1),(10100001,'鱼人守卫',0,1,0,'失落之海-挂机点1Lv355',0,1,0,0,0,202020,'1','0',0,0,0,202020,0,'0',355,1,2066,193841,27165,19384,1730,1730,1437,1463,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,1238,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10100002,'海王蟹',0,1,0,'失落之海-挂机点2Lv360',0,1,0,0,0,202022,'1','0',0,0,0,202022,0,'0',360,1,2158,205765,28181,20538,1914,1914,1576,1603,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,1321,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10100003,'巨齿鲨',0,1,0,'失落之海-挂机点3Lv370',0,1,0,0,0,202023,'1','0',0,0,0,202023,0,'0',370,1,2350,229828,30187,22830,2281,2281,1852,1884,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,2001,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10100004,'鱼人刺客',0,1,0,'失落之海-挂机点4Lv375',0,1,0,0,0,202021,'1','0',0,0,0,202021,0,'0',375,1,2441,241705,31209,23991,2466,2466,1991,2025,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,2001,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10100005,'海蜥蜴',0,1,0,'失落之海-挂机点5Lv380',0,1,0,0,0,202024,'1.6','0',0,0,0,202024,0,'0',380,1,2533,253562,32232,25154,2651,2651,2131,2167,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,2518,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10100006,'鱼人护卫',0,1,0,'失落之海-挂机点6Lv385',0,1,0,0,0,202020,'1','0',0,0,0,202020,0,'0',385,1,2624,265396,33257,26319,2836,2836,2271,2309,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,2518,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10100007,'锯齿鲨',0,1,0,'失落之海-挂机点7Lv390',0,1,0,0,0,202023,'1','0',0,0,0,202023,0,'0',390,1,2715,277191,34285,27487,3022,3022,2411,2451,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,2794,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10100008,'深海蟹',0,1,0,'失落之海-挂机点8Lv395',0,1,0,0,0,202022,'1','0',0,0,0,202022,0,'0',395,1,2805,288959,35314,28657,3209,3209,2551,2594,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,2794,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10100009,'地图8暗裔秘所-挂机点9Lv485',0,2,1,'失落之海-挂机点9Lv585',0,1,0,0,0,1201001,'2','0',0,0,0,1201001,0,'0',585,1,1867,401676,20359,18224,6316,6316,3566,3566,0,'[]','[]',100,800,0,600,200,'[]',5000,2000,0,1,236,0,0,0,0,1,1,1,0,0,'[500,1500]',1,'0',0,0,0,0,1),(10100020,'龙鳞',2,0,0,'主线采集怪1',0,1,0,0,0,2040018,'1','0',0,0,0,2040018,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,800,800,800,200,'[{1110000003,1}]',1000,2000,0,1,0,0,0,0,0,0,0,0,0,0,'[]',1,'0',0,0,0,0,0),(10100021,'辉星石',2,0,0,'主线采集怪2',0,1,0,0,0,2040012,'1','0',0,0,0,2040012,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,800,800,800,200,'[{1110000003,1}]',1000,2000,0,1,0,0,0,0,0,0,0,0,0,0,'[]',1,'0',0,0,0,0,0),(10100100,'海龙王',0,2,1,'失落之海世界boss（先摆放到场景）',0,2,0,0,0,203009,'2','0',0,0,0,203009,0,'0',485,1,556,308388,10713,9442,3129,3129,2024,2024,0,'[]','[]',100,800,800,800,200,'[{202030091,1},{202030092,1}]',5000,2000,0,1,154,0,0,0,0,1,1,1,0,0,'[500,1500]',1,'0',0,0,0,0,1),(10110001,'百花妖',0,1,0,'该隐神社-挂机点1Lv450',0,1,0,0,0,202025,'1','0',0,0,0,202025,0,'0',450,1,3772,391278,45925,38629,5186,5186,3603,3726,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,4841,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10110002,'麻将精',0,1,0,'该隐神社-挂机点2Lv500',0,1,0,0,0,202026,'1','0',0,0,0,202026,0,'0',500,1,5228,532591,59821,51751,7773,7773,5535,5774,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,6411,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10110003,'叛忍',0,1,0,'该隐神社-挂机点3Lv550',0,1,0,0,0,202027,'1','0',0,0,0,202027,0,'0',550,1,6963,696529,75641,66780,13032,13032,8749,9049,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,10659,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10110004,'大名熊霸',0,1,0,'该隐神社-挂机点4Lv600',0,1,0,0,0,202028,'1','0',0,0,0,202028,0,'0',600,1,8855,870896,92643,83034,16871,16871,10783,11028,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,13974,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10110005,'白虎丸',0,1,0,'该隐神社-挂机点5Lv650',0,1,0,0,0,202029,'1','0',0,0,0,202029,0,'0',650,1,10980,1062746,112764,102398,21517,21517,14284,14426,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,16727,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10110006,'万花妖',0,1,0,'该隐神社-挂机点6Lv700',0,1,0,0,0,202025,'1','0',0,0,0,202025,0,'0',700,1,13577,1301464,133659,122598,25756,25756,16305,16464,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,19481,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10110007,'自摸怪',0,1,0,'该隐神社-挂机点7Lv750',0,1,0,0,0,202026,'1','0',0,0,0,202026,0,'0',750,1,15985,1511625,155946,144143,29441,29441,18333,18333,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,22235,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10110008,'逃忍',0,1,0,'该隐神社-挂机点8Lv800',0,1,0,0,0,202027,'1','0',0,0,0,202027,0,'0',800,1,18618,1739397,181749,169236,33174,33174,22147,22147,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,24438,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10110009,'地图9失落之海-挂机点9Lv585',0,2,1,'该隐神社-挂机点9Lv785',0,1,0,0,0,203002,'2','0',0,0,0,203002,0,'0',785,1,8382,1505927,72947,66142,33124,33124,16640,16640,0,'[]','[]',100,800,0,600,200,'[{1110000003,1}]',5000,2000,0,1,507,0,0,0,0,1,1,1,0,0,'[500,1500]',1,'0',0,0,0,0,1),(10110020,'龙鳞',2,0,0,'主线采集怪1',0,1,0,0,0,2040018,'1','0',0,0,0,2040018,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,800,800,800,200,'[{1110000003,1}]',1000,2000,0,1,0,0,0,0,0,0,0,0,0,0,'[]',1,'0',0,0,0,0,0),(10110021,'辉星石',2,0,0,'主线采集怪2',0,1,0,0,0,2040012,'1','0',0,0,0,2040012,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,800,800,800,200,'[{1110000003,1}]',1000,2000,0,1,0,0,0,0,0,0,0,0,0,0,'[]',1,'0',0,0,0,0,0),(10110100,'冰雪姬',0,1,0,'该隐神社-主线精英boss怪',0,1,0,0,0,203017,'1','0',0,0,0,203017,0,'0',700,1,4840,554565,41934,37621,19964,19964,9499,9499,0,'[]','[]',110,800,0,600,200,'[{2000540201,1},{2000540208,1}]',1000,2000,0,1,313,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10120001,'灰烬魔蝎',0,1,0,'焚尽火山-挂机点1Lv400',0,1,0,0,0,202013,'1','0',0,0,0,202013,0,'0',400,1,2895,300696,36346,29829,3395,3395,2692,2737,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,3069,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10120002,'熔岩爆弹',0,1,0,'焚尽火山-挂机点2Lv405',0,1,0,0,0,202030,'0.9','0',0,0,0,202030,0,'0',405,1,2982,309800,37305,30709,3574,3574,2783,2836,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,3069,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10120003,'熔化史莱姆',0,1,0,'焚尽火山-挂机点3Lv410',0,1,0,0,0,202003,'1','0',1,0,0,202003,0,'0',410,1,3068,318866,38265,31591,3753,3753,2874,2935,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,3344,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10120004,'能量探测机',0,1,0,'焚尽火山-挂机点4Lv415',0,1,0,0,0,202018,'1','0',0,0,0,202018,0,'0',415,1,3154,327894,39228,32475,3932,3932,2966,3034,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,3344,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10120005,'魔晶炯眼',0,1,0,'焚尽火山-挂机点5Lv420',0,1,0,0,0,202038,'1','0',0,0,0,202038,0,'0',420,1,3239,336896,40193,33360,4111,4111,3057,3133,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,3620,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10120006,'信号机器人',0,1,0,'焚尽火山-挂机点6Lv430',0,1,0,0,0,202015,'1','0',0,0,0,202015,0,'0',430,1,3423,355303,42083,35099,4467,4467,3238,3329,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,3895,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10120007,'帝国特种兵',0,1,0,'焚尽火山-挂机点7Lv440',0,1,0,0,0,202017,'1','0',0,0,0,202017,0,'0',440,1,3607,373610,43978,36843,4823,4823,3418,3525,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,4150,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10120008,'熔岩蜥蜴',0,1,0,'焚尽火山-挂机点8Lv445',0,1,0,0,0,202014,'1','0',0,0,0,202014,0,'0',445,1,3690,382465,44950,37735,5004,5004,3511,3625,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,4150,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10120020,'一箱水果',2,0,0,'主线采集怪1',0,1,0,0,0,2040010,'0.8','0',0,0,0,2040010,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,800,800,800,200,'[{1110000003,1}]',1000,2000,0,1,0,0,0,0,0,0,0,0,0,0,'[]',1,'0',0,0,0,0,0),(10120021,'熔岩流蝶',2,0,0,'主线采集怪2',0,1,0,0,0,2050006,'1.5','0',0,0,0,2050006,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,800,800,800,200,'[{1110000003,1}]',1000,2000,0,1,0,0,0,0,0,0,0,0,0,0,'[]',1,'0',0,0,0,0,0),(10120022,'火焰符文',2,0,0,'主线采集怪3',0,1,0,0,0,2040012,'1','0',0,0,0,2040012,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,800,800,800,200,'[{1110000003,1}]',1000,2000,0,1,0,0,0,0,0,0,0,0,0,0,'[]',1,'0',0,0,0,0,0),(10120023,'祭坛之钥',2,0,0,'主线采集怪4',0,1,0,0,0,2040011,'1','0',0,0,0,2040011,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,800,800,800,200,'[{1110000003,1}]',1000,2000,0,1,0,0,0,0,0,0,0,0,0,0,'[]',1,'0',0,0,0,0,0),(10120024,'祭坛石',2,0,0,'主线采集怪5',0,1,0,0,0,2040011,'1.5','0',0,0,0,2040011,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,800,800,800,200,'[{1110000003,1}]',1000,2000,0,1,0,0,0,0,0,0,0,0,0,0,'[]',1,'0',0,0,0,0,0),(10120100,'焚烬领主',0,2,1,'焚烬火山-挂机点9Lv699',0,1,0,0,0,203025,'1.3','0',0,0,0,203025,0,'0',699,1,4824,919153,41685,37398,19757,19757,9407,9407,0,'[]','[]',100,800,0,600,200,'[{202030251,1},{202030252,1}]',5000,2000,0,1,310,0,0,0,0,1,1,1,0,0,'[500,1500]',1,'0',0,0,0,0,1),(10130001,'地图11焚尽火山-挂机点1Lv700',0,1,0,'该隐神社-挂机点1Lv450',0,1,0,0,0,202009,'1','0',0,0,0,202009,0,'0',450,1,3807,392340,45812,38533,5175,5175,3596,3718,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,519,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10130002,'地图11焚尽火山-挂机点2Lv710',0,1,0,'该隐神社-挂机点2Lv500',0,1,0,0,0,1007006,'1','0',0,0,0,1007006,0,'0',500,1,5273,534157,59671,51617,7756,7756,5524,5762,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,568,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10130003,'地图11焚尽火山-挂机点3Lv720',0,1,0,'该隐神社-挂机点3Lv550',0,1,0,0,0,202010,'1','0',0,0,0,202010,0,'0',550,1,7020,698694,75444,66601,13005,13005,8731,9030,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,617,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10130004,'地图11焚尽火山-挂机点4Lv730',0,1,0,'该隐神社-挂机点4Lv600',0,1,0,0,0,5010084,'1','0',0,0,0,5010084,0,'0',600,1,8922,873695,92394,82805,16836,16836,10761,11005,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,665,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10130005,'地图11焚尽火山-挂机点5Lv740',0,1,0,'该隐神社-挂机点5Lv650',0,1,0,0,0,202009,'1','0',0,0,0,202009,0,'0',650,1,11056,1066304,112452,102108,21472,21472,14254,14396,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,714,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10130006,'地图11焚尽火山-挂机点6Lv750',0,1,0,'该隐神社-挂机点6Lv700',0,1,0,0,0,1007006,'1','0',0,0,0,1007006,0,'0',700,1,13665,1306005,133285,122247,25703,25703,16271,16430,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,762,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10130007,'地图11焚尽火山-挂机点7Lv760',0,1,0,'该隐神社-挂机点7Lv750',0,1,0,0,0,202010,'1','0',0,0,0,202010,0,'0',750,1,16082,1517066,155509,143730,29379,29379,18295,18295,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,811,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10130008,'地图11焚尽火山-挂机点8Lv770',0,1,0,'该隐神社-挂机点8Lv800',0,1,0,0,0,5010084,'1','0',0,0,0,5010084,0,'0',800,1,18724,1745886,181240,168753,33105,33105,22101,22101,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,884,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10130009,'地图11焚尽火山-挂机点9Lv785',0,2,1,'守望之渊-挂机点9Lv1000',0,1,0,0,0,1201001,'2','0',0,0,0,1201001,0,'0',1000,1,22265,2154886,194778,175084,76470,76470,44662,44662,0,'[]','0',100,800,0,600,200,'[]',5000,2000,0,1,1045,0,0,0,0,1,1,1,0,0,'[500,1500]',1,'0',0,0,0,0,1),(10140001,'地图12守望之渊-挂机点1Lv800',0,1,0,'地图12守望之渊-挂机点1Lv800',0,1,0,0,0,202009,'1','0',0,0,0,202009,0,'0',800,1,14098,2065684,79519,71700,21245,0,17805,31653,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,1103,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10140002,'地图12守望之渊-挂机点2Lv810',0,1,0,'地图12守望之渊-挂机点2Lv810',0,1,0,0,0,1007006,'1','0',0,0,0,1007006,0,'0',810,1,14696,2150066,83781,75465,23043,0,19442,33508,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,1187,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10140003,'地图12守望之渊-挂机点3Lv820',0,1,0,'地图12守望之渊-挂机点3Lv820',0,1,0,0,0,202010,'1','0',0,0,0,202010,0,'0',820,1,15290,2234049,88051,79237,24844,0,21083,35366,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,1267,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10140004,'地图12守望之渊-挂机点4Lv830',0,1,0,'地图12守望之渊-挂机点4Lv830',0,1,0,0,0,5010084,'1','0',0,0,0,5010084,0,'0',830,1,15880,2317533,92330,83018,26649,0,22727,37228,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,1343,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10140005,'地图12守望之渊-挂机点5Lv840',0,1,0,'地图12守望之渊-挂机点5Lv840',0,1,0,0,0,202009,'1','0',0,0,0,202009,0,'0',840,1,16466,2400596,96618,86806,28458,0,24375,39094,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,1401,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10140006,'地图12守望之渊-挂机点6Lv850',0,1,0,'地图12守望之渊-挂机点6Lv850',0,1,0,0,0,1007006,'1','0',0,0,0,1007006,0,'0',850,1,17048,2483184,100915,90602,30271,0,26026,40964,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,1466,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10140007,'地图12守望之渊-挂机点7Lv860',0,1,0,'地图12守望之渊-挂机点7Lv860',0,1,0,0,0,202010,'1','0',0,0,0,202010,0,'0',860,1,18041,2626883,106809,95863,31582,0,27138,42889,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,1536,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10140008,'地图12守望之渊-挂机点8Lv870',0,1,0,'地图12守望之渊-挂机点8Lv870',0,1,0,0,0,5010084,'1','0',0,0,0,5010084,0,'0',870,1,19028,2769934,112716,101136,32897,0,28252,44818,0,'[]','[]',110,800,0,600,200,'[{1110000003,1}]',1000,2000,0,1,1685,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(10140009,'地图12守望之渊-挂机点9Lv885',0,2,1,'地图12守望之渊-挂机点9Lv885',0,1,0,0,0,1201001,'2','0',0,0,0,1201001,0,'0',885,5,24629,3732752,121535,109008,34855,0,29912,47694,0,'[]','[]',100,800,0,600,200,'[]',5000,2000,0,1,2275,0,0,0,0,1,1,1,0,0,'[500,1500]',1,'0',0,0,0,0,1),(17010001,'小螃蟹',6,0,1,'主线采集怪1',0,1,0,0,0,5010001,'1','0',0,0,0,5010001,0,'0',5,1,30,5000,0,15,0,0,0,0,0,'[]','[]',100,2250,1500,2250,100,'[]',0,1500,0,0,10000,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,2,0,0),(17020001,'公会BOSS1',0,6,1,'公会答题召唤boss1',0,1,0,0,0,17020001,'1','0',0,0,0,17020001,0,'0',5,100,30,9000,0,15,0,0,0,0,0,'[]','[]',600,2250,1500,2250,100,'[{1110000003,1}]',0,1500,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(17020002,'公会BOSS2',0,6,1,'公会答题召唤boss2',0,1,0,0,0,17020002,'1','0',0,0,0,17020002,0,'0',5,100,300,20000,0,15,0,0,0,0,0,'[]','[]',600,2250,1500,2250,100,'[{1110000003,1}]',0,1500,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(17020003,'公会BOSS3',0,6,1,'公会答题召唤boss3',0,1,0,0,0,17020003,'1','0',0,0,0,17020003,0,'0',5,100,500,50000,0,15,0,0,0,0,0,'[]','[]',600,2250,1500,2250,100,'[{1110000003,1}]',0,1500,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(20100001,'音符魔头',0,5,1,'定制活动，野外首领boss1',0,7,331,20,2,203006,'1.2','0',0,0,0,203006,0,'0',100,19,491,186450,660,704,161,168,39,36,0,'[]','[]',600,2250,500,2250,200,'[{2000230101,1},{2000230102,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(20100002,'音符魔头',0,5,1,'定制活动，野外首领boss2',0,7,331,20,2,203006,'1.2','0',0,0,0,203006,0,'0',100,19,491,186450,660,704,161,168,39,36,0,'[]','[]',600,2250,500,2250,200,'[{2000230101,1},{2000230102,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(20100003,'音符魔头',0,5,1,'定制活动，野外首领boss3',0,7,331,20,2,203006,'1.2','0',0,0,0,203006,0,'0',100,19,491,186450,660,704,161,168,39,36,0,'[]','[]',600,2250,500,2250,200,'[{2000230101,1},{2000230102,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(20100004,'音符魔头',0,5,1,'定制活动，野外首领boss4',0,7,331,20,2,203006,'1.2','0',0,0,0,203006,0,'0',100,19,491,186450,660,704,161,168,39,36,0,'[]','[]',600,2250,500,2250,200,'[{2000230101,1},{2000230102,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(20100005,'音符',1,0,0,'定制活动，野外首领采集怪1',0,2,331,20,0,2040012,'1.5','effect_monster_caijiwuchangzhu02',0,0,0,2040012,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,1,0,0,0,3,1,0,1,1,0,0,'[]',1,'0',1,0,0,0,0),(20100006,'音符',1,0,0,'定制活动，野外首领采集怪2',0,2,331,20,0,2040012,'1.5','effect_monster_caijiwuchangzhu02',0,0,0,2040012,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,1,0,0,0,3,1,0,1,1,0,0,'[]',1,'0',1,0,0,0,0),(20100007,'音符',1,0,0,'定制活动，野外首领采集怪3',0,2,331,20,0,2040012,'1.5','effect_monster_caijiwuchangzhu02',0,0,0,2040012,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,1,0,0,0,3,1,0,1,1,0,0,'[]',1,'0',1,0,0,0,0),(20100008,'音符',1,0,0,'定制活动，野外首领采集怪4',0,2,331,20,0,2040012,'1.5','effect_monster_caijiwuchangzhu02',0,0,0,2040012,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,1,0,0,0,3,1,0,1,1,0,0,'[]',1,'0',1,0,0,0,0),(25010001,'深海岩龟',6,0,1,'星界试炼怪物',0,2,0,0,0,202007,'1','0',0,0,0,202007,0,'0',350,1,921,18399,460,460,230,230,230,230,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,1,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010002,'深海岩龟',6,0,1,'星界试炼怪物',0,2,0,0,0,202007,'1','0',0,0,0,202007,0,'0',350,1,921,18399,460,460,230,230,230,230,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,2,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010003,'暗翼蝶妖',6,0,1,'星界试炼怪物',0,2,0,0,0,202008,'1.5','0',0,0,0,202008,0,'0',350,1,972,19421,486,486,243,243,243,243,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,3,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010004,'暗翼蝶妖',6,0,1,'星界试炼怪物',0,2,0,0,0,202008,'1.5','0',0,0,0,202008,0,'0',350,1,972,19421,486,486,243,243,243,243,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,3,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010005,'骷髅守卫',6,0,1,'星界试炼怪物',0,2,0,0,0,202002,'1','0',0,0,0,202002,0,'0',350,1,696,13901,348,348,174,174,174,174,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,4,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010006,'骷髅守卫',6,0,1,'星界试炼怪物',0,2,0,0,0,202002,'1','0',0,0,0,202002,0,'0',350,1,696,13901,348,348,174,174,174,174,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,5,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010007,'骷髅统领',6,0,1,'星界试炼怪物',0,2,0,0,0,202002,'2','0',0,0,0,202002,0,'0',350,1,696,13901,348,348,174,174,174,174,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,1,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010008,'鹅厂守卫',6,0,1,'星界试炼怪物',0,2,0,0,0,202009,'1','0',0,0,0,202009,0,'0',350,1,737,14719,368,368,184,184,184,184,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,2,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010009,'鹅厂守卫',6,0,1,'星界试炼怪物',0,2,0,0,0,202009,'1','0',0,0,0,202009,0,'0',350,1,737,14719,368,368,184,184,184,184,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,3,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010010,'鹅厂大佬',6,0,1,'星界试炼怪物',0,2,0,0,0,202009,'2','0',0,0,0,202009,0,'0',350,1,737,14719,368,368,184,184,184,184,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,3,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010011,'机械钢犬',6,0,1,'星界试炼怪物',0,2,0,0,0,202016,'1','0',0,0,0,202016,0,'0',350,1,737,14719,368,368,184,184,184,184,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,4,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010012,'机械钢犬',6,0,1,'星界试炼怪物',0,2,0,0,0,202016,'1','0',0,0,0,202016,0,'0',350,1,737,14719,368,368,184,184,184,184,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,5,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010013,'双刀高达',6,0,1,'星界试炼怪物',0,4,0,0,0,202018,'2.5','0',0,0,0,202018,0,'0',360,1,982,19626,491,491,245,245,245,245,0,'[]','[]',110,800,1200,1000,200,'[{202030301,1}]',0,2000,0,1,1,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010014,'深海魔蝎',6,0,1,'星界试炼怪物',0,2,0,0,0,202022,'1','0',0,0,0,202022,0,'0',350,1,785,15673,392,392,196,196,196,196,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,2,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010015,'深海魔蝎',6,0,1,'星界试炼怪物',0,2,0,0,0,202022,'1','0',0,0,0,202022,0,'0',350,1,785,15673,392,392,196,196,196,196,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,3,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010016,'魔蝎统帅',6,0,1,'星界试炼怪物',0,2,0,0,0,202022,'2','0',0,0,0,202022,0,'0',350,1,785,15673,392,392,196,196,196,196,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,3,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010017,'食人魔花',6,0,1,'星界试炼怪物',0,2,0,0,0,202001,'1','0',0,0,0,202001,0,'0',350,1,819,16355,409,409,204,204,204,204,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,4,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010018,'食人魔花',6,0,1,'星界试炼怪物',0,2,0,0,0,202001,'1','0',0,0,0,202001,0,'0',350,1,819,16355,409,409,204,204,204,204,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,5,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010019,'兽人布鲁',6,0,1,'星界试炼怪物',0,2,0,0,0,202005,'2','0',0,0,0,202005,0,'0',350,1,819,16355,409,409,204,204,204,204,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,1,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010020,'骷髅守卫',6,0,1,'星界试炼怪物',0,2,0,0,0,202002,'1','0',0,0,0,202002,0,'0',350,1,640,12777,319,319,160,160,160,160,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,2,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010021,'骷髅守卫',6,0,1,'星界试炼怪物',0,2,0,0,0,202002,'1','0',0,0,0,202002,0,'0',350,1,640,12777,319,319,160,160,160,160,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,3,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010022,'蒙面刀将',6,0,1,'星界试炼怪物',0,2,0,0,0,202011,'1.5','0',0,0,0,202011,0,'0',350,1,640,12777,319,319,160,160,160,160,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,3,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010023,'蒙面刀将',6,0,1,'星界试炼怪物',0,2,0,0,0,202011,'1.5','0',0,0,0,202011,0,'0',350,1,640,12777,319,319,160,160,160,160,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,4,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010024,'寒冰精灵',6,0,1,'星界试炼怪物',0,2,0,0,0,202010,'1.5','0',0,0,0,202010,0,'0',350,1,670,13172,338,338,160,160,160,160,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,5,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010025,'寒冰精灵',6,0,1,'星界试炼怪物',0,2,0,0,0,202010,'1.5','0',0,0,0,202010,0,'0',350,1,670,13172,338,338,160,160,160,160,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,1,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010026,'鹅厂卫士',6,0,1,'星界试炼怪物',0,2,0,0,0,202009,'1.5','0',0,0,0,202009,0,'0',350,1,670,13172,338,338,160,160,160,160,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,2,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010027,'鹅厂卫士',6,0,1,'星界试炼怪物',0,2,0,0,0,202009,'1.5','0',0,0,0,202009,0,'0',350,1,670,13172,338,338,160,160,160,160,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,3,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010028,'机械大嘴',6,0,1,'星界试炼怪物',0,2,0,0,0,202019,'1','0',0,0,0,202019,0,'0',350,1,860,17172,429,429,215,215,215,215,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,3,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010029,'机械大嘴',6,0,1,'星界试炼怪物',0,2,0,0,0,202019,'1','0',0,0,0,202019,0,'0',350,1,860,17172,429,429,215,215,215,215,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,4,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010030,'星界战士',6,0,1,'星界试炼怪物',0,4,0,0,0,202017,'2','0',0,0,0,202017,0,'0',360,1,1146,22897,572,572,286,286,286,286,0,'[]','[]',110,800,1200,1000,200,'[{202030305,1}]',0,2000,0,1,5,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010031,'深海卫士',6,0,1,'星界试炼怪物',0,2,0,0,0,202022,'1','0',0,0,0,202022,0,'0',400,1,921,18399,460,460,230,230,230,230,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,1,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010032,'深海卫士',6,0,1,'星界试炼怪物',0,2,0,0,0,202022,'1','0',0,0,0,202022,0,'0',400,1,921,18399,460,460,230,230,230,230,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,2,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010033,'人鱼统帅',6,0,1,'星界试炼怪物',0,2,0,0,0,202020,'2','0',0,0,0,202020,0,'0',400,1,921,18399,460,460,230,230,230,230,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,3,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010034,'布林杀手',6,0,1,'星界试炼怪物',0,2,0,0,0,202005,'1','0',0,0,0,202005,0,'0',400,1,716,14310,358,358,179,179,179,179,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,3,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010035,'布林杀手',6,0,1,'星界试炼怪物',0,2,0,0,0,202005,'1','0',0,0,0,202005,0,'0',400,1,716,14310,358,358,179,179,179,179,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,4,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010036,'精灵刺客',6,0,1,'星界试炼怪物',0,2,0,0,0,202004,'1.5','0',0,0,0,202004,0,'0',400,1,716,14310,358,358,179,179,179,179,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,5,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010037,'精灵刺客',6,0,1,'星界试炼怪物',0,2,0,0,0,202004,'1.5','0',0,0,0,202004,0,'0',400,1,716,14310,358,358,179,179,179,179,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,1,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010038,'石窟火蝎',6,0,1,'星界试炼怪物',0,2,0,0,0,202013,'1','0',0,0,0,202013,0,'0',400,1,742,14821,371,371,185,185,185,185,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,2,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010039,'石窟火蝎',6,0,1,'星界试炼怪物',0,2,0,0,0,202013,'1','0',0,0,0,202013,0,'0',400,1,742,14821,371,371,185,185,185,185,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,3,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010040,'火蜥蜴兽',6,0,1,'星界试炼怪物',0,2,0,0,0,202014,'1.5','0',0,0,0,202014,0,'0',400,1,742,14821,371,371,185,185,185,185,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,3,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010041,'火蜥蜴兽',6,0,1,'星界试炼怪物',0,2,0,0,0,202014,'1.5','0',0,0,0,202014,0,'0',400,1,742,14821,371,371,185,185,185,185,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,4,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010042,'寒冰怨灵',6,0,1,'星界试炼怪物',0,2,0,0,0,202010,'1.5','0',0,0,0,202010,0,'0',400,1,622,12430,311,311,155,155,155,155,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,5,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010043,'寒冰怨灵',6,0,1,'星界试炼怪物',0,2,0,0,0,202010,'1.5','0',0,0,0,202010,0,'0',400,1,622,12430,311,311,155,155,155,155,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,1,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010044,'冰原大盗',6,0,1,'星界试炼怪物',0,2,0,0,0,202012,'1.5','0',0,0,0,202012,0,'0',400,1,622,12430,311,311,155,155,155,155,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,2,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010045,'冰原大盗',6,0,1,'星界试炼怪物',0,2,0,0,0,202012,'1.6','0',0,0,0,202012,0,'0',400,1,622,12430,311,311,155,155,155,155,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,3,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010046,'冰原大盗',6,0,1,'星界试炼怪物',0,2,0,0,0,202012,'1.6','0',0,0,0,202012,0,'0',400,1,622,12430,311,311,155,155,155,155,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,3,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010047,'机械大嘴',6,0,1,'星界试炼怪物',0,2,0,0,0,202019,'1','0',0,0,0,202019,0,'0',400,1,982,19626,491,491,245,245,245,245,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,4,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010048,'机械大嘴',6,0,1,'星界试炼怪物',0,2,0,0,0,202019,'1','0',0,0,0,202019,0,'0',400,1,982,19626,491,491,245,245,245,245,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,5,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010049,'代号玛德',6,0,1,'星界试炼怪物',0,4,0,0,0,202015,'2','0',0,0,0,202015,0,'0',410,1,1310,26167,654,654,327,327,327,327,0,'[]','[]',110,800,1200,1000,200,'[{202030309,1}]',0,2000,0,1,4,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010050,'深海蝎卫',6,1,1,'星界试炼怪物',0,2,0,0,0,202022,'1','0',0,0,0,202022,0,'0',400,1,1057,21125,528,528,264,264,264,264,0,'[]','[]',600,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,6,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010051,'深海蝎卫',6,0,1,'星界试炼怪物',0,2,0,0,0,202022,'1','0',0,0,0,202022,0,'0',400,1,1057,21125,528,528,264,264,264,264,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,1,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010052,'史前巨鳄',6,0,1,'星界试炼怪物',0,2,0,0,0,202023,'2','0',0,0,0,202023,0,'0',400,1,1057,21125,528,528,264,264,264,264,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,2,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010053,'大嘴花妖',6,0,1,'星界试炼怪物',0,2,0,0,0,202001,'1.5','0',0,0,0,202001,0,'0',400,1,819,16355,409,409,204,204,204,204,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,3,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010054,'大嘴花妖',6,0,1,'星界试炼怪物',0,2,0,0,0,202001,'1.5','0',0,0,0,202001,0,'0',400,1,819,16355,409,409,204,204,204,204,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,3,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010055,'骷髅守护',6,0,1,'星界试炼怪物',0,2,0,0,0,202002,'1.5','0',0,0,0,202002,0,'0',400,1,819,16355,409,409,204,204,204,204,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,4,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010056,'骷髅守护',6,0,1,'星界试炼怪物',0,2,0,0,0,202002,'1.5','0',0,0,0,202002,0,'0',400,1,819,16355,409,409,204,204,204,204,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,5,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010057,'石窟火蝎',6,0,1,'星界试炼怪物',0,2,0,0,0,202013,'1','0',0,0,0,202013,0,'0',400,1,675,13493,337,337,169,169,169,169,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,1,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010058,'石窟火蝎',6,0,1,'星界试炼怪物',0,2,0,0,0,202013,'1','0',0,0,0,202013,0,'0',400,1,675,13493,337,337,169,169,169,169,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,2,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010059,'怒火蜥蜴',6,0,1,'星界试炼怪物',0,2,0,0,0,202014,'1.2','0',0,0,0,202014,0,'0',400,1,675,13493,337,337,169,169,169,169,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,3,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010060,'怒火蜥蜴',6,0,1,'星界试炼怪物',0,2,0,0,0,202014,'1.2','0',0,0,0,202014,0,'0',400,1,675,13493,337,337,169,169,169,169,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,3,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010061,'怒火蜥蜴',6,0,1,'星界试炼怪物',0,2,0,0,0,202014,'1.2','0',0,0,0,202014,0,'0',400,1,675,13493,337,337,169,169,169,169,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,4,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010062,'冰原荒狼',6,0,1,'星界试炼怪物',0,2,0,0,0,202006,'1.5','0',0,0,0,202006,0,'0',400,1,704,14065,352,352,176,176,176,176,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,5,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010063,'冰原荒狼',6,0,1,'星界试炼怪物',0,2,0,0,0,202006,'1.5','0',0,0,0,202006,0,'0',400,1,704,14065,352,352,176,176,176,176,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,1,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010064,'精灵驯兽师',6,0,1,'星界试炼怪物',0,2,0,0,0,202004,'1.6','0',0,0,0,202004,0,'0',400,1,704,14065,352,352,176,176,176,176,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,2,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010065,'精灵驯兽师',6,0,1,'星界试炼怪物',0,2,0,0,0,202004,'1.6','0',0,0,0,202004,0,'0',400,1,704,14065,352,352,176,176,176,176,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,3,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010066,'精灵驯兽师',6,0,1,'星界试炼怪物',0,2,0,0,0,202004,'1.6','0',0,0,0,202004,0,'0',400,1,704,14065,352,352,176,176,176,176,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,3,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010067,'机械护卫',6,0,1,'星界试炼怪物',0,2,0,0,0,202018,'1.5','0',0,0,0,202018,0,'0',400,1,829,16559,414,414,207,207,207,207,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,4,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010068,'机械护卫',6,0,1,'星界试炼怪物',0,2,0,0,0,202018,'1.5','0',0,0,0,202018,0,'0',400,1,829,16559,414,414,207,207,207,207,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,5,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010069,'机械护卫',6,0,1,'星界试炼怪物',0,2,0,0,0,202018,'1.5','0',0,0,0,202018,0,'0',400,1,829,16559,414,414,207,207,207,207,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,1,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010070,'钢铁锤哥',6,0,1,'星界试炼怪物',0,4,0,0,0,203008,'1.5','0',0,0,0,203008,0,'0',410,1,1197,23919,598,598,299,299,299,299,0,'[]','[]',110,800,1200,1000,200,'[{202030081,1},{202030082,1}]',0,2000,0,1,2,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010092,'深海鱼姬',6,0,1,'星界试炼怪物',0,2,0,0,0,202021,'1.5','0',0,0,0,202021,0,'0',450,1,895,17888,447,447,224,224,224,224,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,5,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010093,'深海鱼姬',6,0,1,'星界试炼怪物',0,2,0,0,0,202021,'1.5','0',0,0,0,202021,0,'0',450,1,895,17888,447,447,224,224,224,224,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,1,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010094,'深海魔蜥',6,0,1,'星界试炼怪物',0,2,0,0,0,202024,'1.8','0',0,0,0,202024,0,'0',450,1,895,17888,447,447,224,224,224,224,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,2,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010095,'深海魔蜥',6,0,1,'星界试炼怪物',0,2,0,0,0,202024,'1.8','0',0,0,0,202024,0,'0',450,1,895,17888,447,447,224,224,224,224,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,3,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010096,'绿皮地精',6,0,1,'星界试炼怪物',0,2,0,0,0,202005,'1.5','0',0,0,0,202005,0,'0',450,1,921,18399,460,460,230,230,230,230,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,3,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010097,'绿皮地精',6,0,1,'星界试炼怪物',0,2,0,0,0,202005,'1.5','0',0,0,0,202005,0,'0',450,1,921,18399,460,460,230,230,230,230,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,4,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010098,'紫翼蝶妖',6,0,1,'星界试炼怪物',0,2,0,0,0,202008,'1.6','0',0,0,0,202008,0,'0',450,1,921,18399,460,460,230,230,230,230,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,5,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010099,'紫翼蝶妖',6,0,1,'星界试炼怪物',0,2,0,0,0,202008,'1.6','0',0,0,0,202008,0,'0',450,1,921,18399,460,460,230,230,230,230,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,4,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010100,'蒙面刀卫',6,1,1,'星界试炼怪物',0,2,0,0,0,202011,'1.5','0',0,0,0,202011,0,'0',450,1,757,15128,378,378,189,189,189,189,0,'[]','[]',600,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,6,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010101,'蒙面刀卫',6,0,1,'星界试炼怪物',0,2,0,0,0,202011,'1.5','0',0,0,0,202011,0,'0',450,1,757,15128,378,378,189,189,189,189,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,1,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010102,'红巾大盗',6,0,1,'星界试炼怪物',0,2,0,0,0,202012,'1.6','0',0,0,0,202012,0,'0',450,1,757,15128,378,378,189,189,189,189,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,1,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010103,'红巾大盗',6,0,1,'星界试炼怪物',0,2,0,0,0,202012,'1.6','0',0,0,0,202012,0,'0',450,1,757,15128,378,378,189,189,189,189,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,2,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010104,'红巾大盗',6,0,1,'星界试炼怪物',0,2,0,0,0,202012,'1.6','0',0,0,0,202012,0,'0',450,1,757,15128,378,378,189,189,189,189,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,3,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010105,'鹅厂护卫',6,0,1,'星界试炼怪物',0,2,0,0,0,202009,'1.5','0',0,0,0,202009,0,'0',450,1,786,15700,393,393,196,196,196,196,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,3,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010106,'鹅厂护卫',6,0,1,'星界试炼怪物',0,2,0,0,0,202009,'1.5','0',0,0,0,202009,0,'0',450,1,786,15700,393,393,196,196,196,196,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,4,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010107,'寒冰精灵',6,0,1,'星界试炼怪物',0,2,0,0,0,202010,'1.6','0',0,0,0,202010,0,'0',450,1,786,15700,393,393,196,196,196,196,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,5,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010108,'寒冰精灵',6,0,1,'星界试炼怪物',0,2,0,0,0,202010,'1.8','0',0,0,0,202010,0,'0',450,1,786,15700,393,393,196,196,196,196,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,1,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010109,'寒冰精灵',6,0,1,'星界试炼怪物',0,2,0,0,0,202010,'1.8','0',0,0,0,202010,0,'0',450,1,786,15700,393,393,196,196,196,196,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,2,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010110,'机械护卫',6,0,1,'星界试炼怪物',0,2,0,0,0,202018,'2','0',0,0,0,202018,0,'0',450,1,921,18399,460,460,230,230,230,230,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,3,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010111,'机械护卫',6,0,1,'星界试炼怪物',0,2,0,0,0,202018,'2','0',0,0,0,202018,0,'0',450,1,921,18399,460,460,230,230,230,230,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,3,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010112,'机械护卫',6,0,1,'星界试炼怪物',0,2,0,0,0,202018,'2','0',0,0,0,202018,0,'0',450,1,921,18399,460,460,230,230,230,230,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,4,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010113,'亿磁王',6,0,1,'星界试炼怪物',0,4,0,0,0,203007,'1.6','0',0,0,0,203007,0,'0',460,1,1330,26576,664,664,332,332,332,332,0,'[]','[]',110,800,1200,1000,200,'[{2000230301,1},{2000230303,1}]',0,2000,0,1,5,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010120,'深海鱼姬',6,0,1,'星界试炼怪物',0,2,0,0,0,202021,'1.6','0',0,0,0,202021,0,'0',350,1,737,14719,368,368,184,184,184,184,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,1,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010121,'深海鱼姬',6,0,1,'星界试炼怪物',0,2,0,0,0,202021,'1.6','0',0,0,0,202021,0,'0',350,1,737,14719,368,368,184,184,184,184,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,2,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010122,'美杜莎女王',6,0,1,'星界试炼怪物',0,4,0,0,0,203006,'1.5','0',0,0,0,203006,0,'0',360,1,982,19626,491,491,245,245,245,245,0,'[]','[]',110,800,1200,1000,200,'[{2000230101,1},{2000230102,1}]',0,2000,0,1,3,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010123,'森林蝶妖',6,0,1,'星界试炼怪物',0,2,0,0,0,202008,'1','0',0,0,0,202008,0,'0',350,1,860,17172,429,429,215,215,215,215,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,3,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010124,'森林蝶妖',6,0,1,'星界试炼怪物',0,2,0,0,0,202008,'1','0',0,0,0,202008,0,'0',350,1,860,17172,429,429,215,215,215,215,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,4,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010125,'荆棘女王',6,0,1,'星界试炼怪物',0,4,0,0,0,203001,'1.5','0',0,0,0,203001,0,'0',360,1,1146,22897,572,572,286,286,286,286,0,'[]','[]',110,800,1200,1000,200,'[{202030011,1},{202030012,1}]',0,2000,0,1,5,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010126,'骷髅卫士',6,0,1,'星界试炼怪物',0,2,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',400,1,982,19626,491,491,245,245,245,245,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,1,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010127,'骷髅卫士',6,0,1,'星界试炼怪物',0,2,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',400,1,982,19626,491,491,245,245,245,245,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,2,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010128,'不死之王',6,0,1,'星界试炼怪物',0,4,0,0,0,203012,'1.2','0',0,0,0,203012,0,'0',410,1,1310,26167,654,654,327,327,327,327,0,'[]','[]',110,800,1200,1000,200,'[{202030121,1},{202030122,1}]',0,2000,0,1,3,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010129,'冰原荒狼',6,0,1,'星界试炼怪物',0,2,0,0,0,202006,'1','0',0,0,0,202006,0,'0',400,1,829,16559,414,414,207,207,207,207,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,3,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010130,'冰原荒狼',6,0,1,'星界试炼怪物',0,2,0,0,0,202006,'1','0',0,0,0,202006,0,'0',400,1,829,16559,414,414,207,207,207,207,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,4,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010131,'冰原荒狼',6,0,1,'星界试炼怪物',0,2,0,0,0,202006,'1','0',0,0,0,202006,0,'0',400,1,829,16559,414,414,207,207,207,207,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,5,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010132,'寒冰泰坦',6,0,1,'星界试炼怪物',0,4,0,0,0,203003,'1.5','0',0,0,0,203003,0,'0',410,1,1197,23919,598,598,299,299,299,299,0,'[]','[]',110,800,1200,1000,200,'[{202030031,1},{202030032,1}]',0,2000,0,1,1,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010133,'人鱼卫士',6,0,1,'星界试炼怪物',0,2,0,0,0,202020,'1','0',0,0,0,202020,0,'0',450,1,921,18399,460,460,230,230,230,230,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,2,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010134,'人鱼卫士',6,0,1,'星界试炼怪物',0,2,0,0,0,202020,'1','0',0,0,0,202020,0,'0',450,1,921,18399,460,460,230,230,230,230,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,3,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010135,'人鱼卫士',6,0,1,'星界试炼怪物',0,2,0,0,0,202020,'1','0',0,0,0,202020,0,'0',450,1,921,18399,460,460,230,230,230,230,0,'[]','[]',110,800,1200,1000,200,'[{1110000003,1}]',0,2000,0,1,3,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(25010136,'魅惑女王',6,0,1,'星界试炼怪物',0,4,0,0,0,203016,'1.5','0',0,0,0,203016,0,'0',460,1,1330,26576,664,664,332,332,332,332,0,'[]','[]',110,800,1200,1000,200,'[{202030161,1},{202030162,1}]',0,2000,0,1,4,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(30010101,'哥布林',6,0,1,'经验副本1难度1号怪物',0,1,0,0,2,202005,'1.1','0',0,0,0,202005,0,'3||鼓舞之后伤害翻倍，伤害高才能经验高！:3||佩戴经验馆主可以增加50%经验，刷经验必备！:3',70,1,5,3000,0,0,0,0,0,0,0,'[]','[]',10,6000,6000,2250,250,'[{1110000004,1}]',0,2000,0,0,1000,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(30010102,'哥布林',6,0,1,'经验副本1难度2号怪物',0,1,0,0,2,202005,'1.1','0',0,0,0,202005,0,'3||鼓舞之后伤害翻倍，伤害高才能经验高！:3||佩戴经验馆主可以增加50%经验，刷经验必备！:3',70,1,5,3000,0,0,0,0,0,0,0,'[]','[]',10,6000,6000,2250,250,'[{1110000004,1}]',0,2000,0,0,1000,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(30010103,'哥布林',6,0,1,'经验副本1难度3号怪物',0,1,0,0,2,202005,'1.1','0',0,0,0,202005,0,'3||鼓舞之后伤害翻倍，伤害高才能经验高！:3||佩戴经验馆主可以增加50%经验，刷经验必备！:3',70,1,5,3000,0,0,0,0,0,0,0,'[]','[]',10,6000,6000,2250,250,'[{1110000004,1}]',0,2000,0,0,1000,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(30010104,'哥布林',6,0,1,'经验副本1难度4号怪物',0,1,0,0,2,202005,'1.1','0',0,0,0,202005,0,'3||鼓舞之后伤害翻倍，伤害高才能经验高！:3||佩戴经验馆主可以增加50%经验，刷经验必备！:3',70,1,5,3000,0,0,0,0,0,0,0,'[]','[]',10,6000,6000,2250,250,'[{1110000004,1}]',0,2000,0,0,1000,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(30010105,'哥布林',6,0,1,'经验副本1难度5号怪物',0,1,0,0,2,202005,'1.1','0',0,0,0,202005,0,'3||鼓舞之后伤害翻倍，伤害高才能经验高！:3||佩戴经验馆主可以增加50%经验，刷经验必备！:3',70,1,5,3000,0,0,0,0,0,0,0,'[]','[]',10,6000,6000,2250,250,'[{1110000004,1}]',0,2000,0,0,1000,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(30010106,'哥布林',6,0,1,'经验副本1难度6号怪物',0,1,0,0,2,202005,'1.1','0',0,0,0,202005,0,'3||鼓舞之后伤害翻倍，伤害高才能经验高！:3||佩戴经验馆主可以增加50%经验，刷经验必备！:3',70,1,5,3000,0,0,0,0,0,0,0,'[]','[]',10,6000,6000,2250,250,'[{1110000004,1}]',0,2000,0,0,1000,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(30010107,'哥布林',6,0,1,'经验副本1难度7号怪物',0,1,0,0,2,202005,'1.1','0',0,0,0,202005,0,'3||鼓舞之后伤害翻倍，伤害高才能经验高！:3||佩戴经验馆主可以增加50%经验，刷经验必备！:3',70,1,5,3000,0,0,0,0,0,0,0,'[]','[]',10,6000,6000,2250,250,'[{1110000004,1}]',0,2000,0,0,1000,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(30010108,'哥布林',6,0,1,'经验副本1难度8号怪物',0,1,0,0,2,202005,'1.1','0',0,0,0,202005,0,'3||鼓舞之后伤害翻倍，伤害高才能经验高！:3||佩戴经验馆主可以增加50%经验，刷经验必备！:3',70,1,5,3000,0,0,0,0,0,0,0,'[]','[]',10,6000,6000,2250,250,'[{1110000004,1}]',0,2000,0,0,1000,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(30010109,'哥布林',6,0,0,'经验副本1难度9号怪物',0,1,0,0,2,202005,'1.1','0',0,0,0,202005,0,'3||鼓舞之后伤害翻倍，伤害高才能经验高！:3||佩戴经验馆主可以增加50%经验，刷经验必备！:3',70,1,5,3100,0,0,0,0,0,0,0,'[]','[]',10,6000,6000,2250,250,'[{1110000004,1}]',0,2000,0,0,1000,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,2,0,0),(30010201,'暗影魔狼',6,0,0,'经验副本2难度1号怪物',0,1,0,0,2,202006,'1.3','0',0,0,0,202006,0,'3||鼓舞之后伤害翻倍，伤害高才能经验高！:3||佩戴经验馆主可以增加50%经验，刷经验必备！:3',70,1,5,3100,0,0,0,0,0,0,0,'[]','[]',10,6000,6000,2250,250,'[{1110000004,1}]',0,2000,0,0,1000,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,2,0,0),(30010202,'暗影魔狼',6,0,0,'经验副本2难度2号怪物',0,1,0,0,2,202006,'1.3','0',0,0,0,202006,0,'3||鼓舞之后伤害翻倍，伤害高才能经验高！:3||佩戴经验馆主可以增加50%经验，刷经验必备！:3',70,1,5,3100,0,0,0,0,0,0,0,'[]','[]',10,6000,6000,2250,250,'[{1110000004,1}]',0,2000,0,0,1000,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,2,0,0),(30010203,'暗影魔狼',6,0,0,'经验副本2难度3号怪物',0,1,0,0,2,202006,'1.3','0',0,0,0,202006,0,'3||鼓舞之后伤害翻倍，伤害高才能经验高！:3||佩戴经验馆主可以增加50%经验，刷经验必备！:3',70,1,5,3100,0,0,0,0,0,0,0,'[]','[]',10,6000,6000,2250,250,'[{1110000004,1}]',0,2000,0,0,1000,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,2,0,0),(30010204,'暗影魔狼',6,0,0,'经验副本2难度4号怪物',0,1,0,0,2,202006,'1.3','0',0,0,0,202006,0,'3||鼓舞之后伤害翻倍，伤害高才能经验高！:3||佩戴经验馆主可以增加50%经验，刷经验必备！:3',70,1,5,3100,0,0,0,0,0,0,0,'[]','[]',10,6000,6000,2250,250,'[{1110000004,1}]',0,2000,0,0,1000,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,2,0,0),(30010205,'暗影魔狼',6,0,0,'经验副本2难度5号怪物',0,1,0,0,2,202006,'1.3','0',0,0,0,202006,0,'3||鼓舞之后伤害翻倍，伤害高才能经验高！:3||佩戴经验馆主可以增加50%经验，刷经验必备！:3',70,1,5,3100,0,0,0,0,0,0,0,'[]','[]',10,6000,6000,2250,250,'[{1110000004,1}]',0,2000,0,0,1000,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,2,0,0),(30010206,'暗影魔狼',6,0,0,'经验副本2难度6号怪物',0,1,0,0,2,202006,'1.3','0',0,0,0,202006,0,'3||鼓舞之后伤害翻倍，伤害高才能经验高！:3||佩戴经验馆主可以增加50%经验，刷经验必备！:3',70,1,5,3100,0,0,0,0,0,0,0,'[]','[]',10,6000,6000,2250,250,'[{1110000004,1}]',0,2000,0,0,1000,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,2,0,0),(30010207,'暗影魔狼',6,0,0,'经验副本2难度7号怪物',0,1,0,0,2,202006,'1.3','0',0,0,0,202006,0,'3||鼓舞之后伤害翻倍，伤害高才能经验高！:3||佩戴经验馆主可以增加50%经验，刷经验必备！:3',70,1,5,3100,0,0,0,0,0,0,0,'[]','[]',10,6000,6000,2250,250,'[{1110000004,1}]',0,2000,0,0,1000,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,2,0,0),(30010208,'暗影魔狼',6,0,0,'经验副本2难度8号怪物',0,1,0,0,2,202006,'1.3','0',0,0,0,202006,0,'3||鼓舞之后伤害翻倍，伤害高才能经验高！:3||佩戴经验馆主可以增加50%经验，刷经验必备！:3',70,1,5,3100,0,0,0,0,0,0,0,'[]','[]',10,6000,6000,2250,250,'[{1110000004,1}]',0,2000,0,0,1000,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,2,0,0),(30010209,'暗影魔狼',6,0,0,'经验副本2难度9号怪物',0,1,0,0,2,202006,'1.3','0',0,0,0,202006,0,'3||鼓舞之后伤害翻倍，伤害高才能经验高！:3||佩戴经验馆主可以增加50%经验，刷经验必备！:3',70,1,5,3100,0,0,0,0,0,0,0,'[]','[]',10,6000,6000,2250,250,'[{1110000004,1}]',0,2000,0,0,1000,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,2,0,0),(30010301,'蜥蜴人',6,0,0,'经验副本3难度1号怪物',0,1,0,0,2,202014,'1.3','0',0,0,0,202014,0,'3||鼓舞之后伤害翻倍，伤害高才能经验高！:3||佩戴经验馆主可以增加50%经验，刷经验必备！:3',70,1,5,3100,0,0,0,0,0,0,0,'[]','[]',10,6000,6000,2250,250,'[{1110000004,1}]',0,2000,0,0,1000,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,2,0,0),(30010302,'蜥蜴人',6,0,0,'经验副本3难度2号怪物',0,1,0,0,2,202014,'1.3','0',0,0,0,202014,0,'3||鼓舞之后伤害翻倍，伤害高才能经验高！:3||佩戴经验馆主可以增加50%经验，刷经验必备！:3',70,1,5,3100,0,0,0,0,0,0,0,'[]','[]',10,6000,6000,2250,250,'[{1110000004,1}]',0,2000,0,0,1000,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,2,0,0),(30010303,'蜥蜴人',6,0,0,'经验副本3难度3号怪物',0,1,0,0,2,202014,'1.3','0',0,0,0,202014,0,'3||鼓舞之后伤害翻倍，伤害高才能经验高！:3||佩戴经验馆主可以增加50%经验，刷经验必备！:3',70,1,5,3100,0,0,0,0,0,0,0,'[]','[]',10,6000,6000,2250,250,'[{1110000004,1}]',0,2000,0,0,1000,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,2,0,0),(30010304,'蜥蜴人',6,0,0,'经验副本3难度4号怪物',0,1,0,0,2,202014,'1.3','0',0,0,0,202014,0,'3||鼓舞之后伤害翻倍，伤害高才能经验高！:3||佩戴经验馆主可以增加50%经验，刷经验必备！:3',70,1,5,3100,0,0,0,0,0,0,0,'[]','[]',10,6000,6000,2250,250,'[{1110000004,1}]',0,2000,0,0,1000,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,2,0,0),(30010305,'蜥蜴人',6,0,0,'经验副本3难度5号怪物',0,1,0,0,2,202014,'1.3','0',0,0,0,202014,0,'3||鼓舞之后伤害翻倍，伤害高才能经验高！:3||佩戴经验馆主可以增加50%经验，刷经验必备！:3',70,1,5,3100,0,0,0,0,0,0,0,'[]','[]',10,6000,6000,2250,250,'[{1110000004,1}]',0,2000,0,0,1000,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,2,0,0),(30010306,'蜥蜴人',6,0,0,'经验副本3难度6号怪物',0,1,0,0,2,202014,'1.3','0',0,0,0,202014,0,'3||鼓舞之后伤害翻倍，伤害高才能经验高！:3||佩戴经验馆主可以增加50%经验，刷经验必备！:3',70,1,5,3100,0,0,0,0,0,0,0,'[]','[]',10,6000,6000,2250,250,'[{1110000004,1}]',0,2000,0,0,1000,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,2,0,0),(30010307,'蜥蜴人',6,0,0,'经验副本3难度7号怪物',0,1,0,0,2,202014,'1.3','0',0,0,0,202014,0,'3||鼓舞之后伤害翻倍，伤害高才能经验高！:3||佩戴经验馆主可以增加50%经验，刷经验必备！:3',70,1,5,3100,0,0,0,0,0,0,0,'[]','[]',10,6000,6000,2250,250,'[{1110000004,1}]',0,2000,0,0,1000,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,2,0,0),(30010308,'蜥蜴人',6,0,0,'经验副本3难度8号怪物',0,1,0,0,2,202014,'1.3','0',0,0,0,202014,0,'3||鼓舞之后伤害翻倍，伤害高才能经验高！:3||佩戴经验馆主可以增加50%经验，刷经验必备！:3',70,1,5,3100,0,0,0,0,0,0,0,'[]','[]',10,6000,6000,2250,250,'[{1110000004,1}]',0,2000,0,0,1000,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,2,0,0),(30010309,'蜥蜴人',6,0,0,'经验副本3难度9号怪物',0,1,0,0,2,202014,'1.3','0',0,0,0,202014,0,'3||鼓舞之后伤害翻倍，伤害高才能经验高！:3||佩戴经验馆主可以增加50%经验，刷经验必备！:3',70,1,5,3100,0,0,0,0,0,0,0,'[]','[]',10,6000,6000,2250,250,'[{1110000004,1}]',0,2000,0,0,1000,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,2,0,0),(30010401,'机械三头犬',6,0,0,'经验副本4难度1号怪物',0,1,0,0,2,202016,'1.3','0',0,0,0,202016,0,'3||鼓舞之后伤害翻倍，伤害高才能经验高！:3||佩戴经验馆主可以增加50%经验，刷经验必备！:3',70,1,5,3000,0,0,0,0,0,0,0,'[]','[]',10,6000,6000,2250,250,'[{1110000004,1}]',0,2000,0,0,1000,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,2,0,0),(30010402,'机械三头犬',6,0,0,'经验副本4难度2号怪物',0,1,0,0,2,202016,'1.3','0',0,0,0,202016,0,'3||鼓舞之后伤害翻倍，伤害高才能经验高！:3||佩戴经验馆主可以增加50%经验，刷经验必备！:3',70,1,5,3000,0,0,0,0,0,0,0,'[]','[]',10,6000,6000,2250,250,'[{1110000004,1}]',0,2000,0,0,1000,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,2,0,0),(30010403,'机械三头犬',6,0,0,'经验副本4难度3号怪物',0,1,0,0,2,202016,'1.3','0',0,0,0,202016,0,'3||鼓舞之后伤害翻倍，伤害高才能经验高！:3||佩戴经验馆主可以增加50%经验，刷经验必备！:3',70,1,5,3000,0,0,0,0,0,0,0,'[]','[]',10,6000,6000,2250,250,'[{1110000004,1}]',0,2000,0,0,1000,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,2,0,0),(30010404,'机械三头犬',6,0,0,'经验副本4难度4号怪物',0,1,0,0,2,202016,'1.3','0',0,0,0,202016,0,'3||鼓舞之后伤害翻倍，伤害高才能经验高！:3||佩戴经验馆主可以增加50%经验，刷经验必备！:3',70,1,5,3000,0,0,0,0,0,0,0,'[]','[]',10,6000,6000,2250,250,'[{1110000004,1}]',0,2000,0,0,1000,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,2,0,0),(30010405,'机械三头犬',6,0,0,'经验副本4难度5号怪物',0,1,0,0,2,202016,'1.3','0',0,0,0,202016,0,'3||鼓舞之后伤害翻倍，伤害高才能经验高！:3||佩戴经验馆主可以增加50%经验，刷经验必备！:3',70,1,5,3000,0,0,0,0,0,0,0,'[]','[]',10,6000,6000,2250,250,'[{1110000004,1}]',0,2000,0,0,1000,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,2,0,0),(30010406,'机械三头犬',6,0,0,'经验副本4难度6号怪物',0,1,0,0,2,202016,'1.3','0',0,0,0,202016,0,'3||鼓舞之后伤害翻倍，伤害高才能经验高！:3||佩戴经验馆主可以增加50%经验，刷经验必备！:3',70,1,5,3000,0,0,0,0,0,0,0,'[]','[]',10,6000,6000,2250,250,'[{1110000004,1}]',0,2000,0,0,1000,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,2,0,0),(30010407,'机械三头犬',6,0,0,'经验副本4难度7号怪物',0,1,0,0,2,202016,'1.3','0',0,0,0,202016,0,'3||鼓舞之后伤害翻倍，伤害高才能经验高！:3||佩戴经验馆主可以增加50%经验，刷经验必备！:3',70,1,5,3000,0,0,0,0,0,0,0,'[]','[]',10,6000,6000,2250,250,'[{1110000004,1}]',0,2000,0,0,1000,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,2,0,0),(30010408,'机械三头犬',6,0,0,'经验副本4难度8号怪物',0,1,0,0,2,202016,'1.3','0',0,0,0,202016,0,'3||鼓舞之后伤害翻倍，伤害高才能经验高！:3||佩戴经验馆主可以增加50%经验，刷经验必备！:3',70,1,5,3000,0,0,0,0,0,0,0,'[]','[]',10,6000,6000,2250,250,'[{1110000004,1}]',0,2000,0,0,1000,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,2,0,0),(30010409,'机械三头犬',6,0,0,'经验副本4难度9号怪物',0,1,0,0,2,202016,'1.3','0',0,0,0,202016,0,'3||鼓舞之后伤害翻倍，伤害高才能经验高！:3||佩戴经验馆主可以增加50%经验，刷经验必备！:3',70,1,5,3000,0,0,0,0,0,0,0,'[]','[]',10,6000,6000,2250,250,'[{1110000004,1}]',0,2000,0,0,1000,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,2,0,0),(30010501,'废旧机器人',6,0,0,'经验副本5难度1号怪物',0,1,0,0,2,202015,'1.3','0',0,0,0,202015,0,'3||鼓舞之后伤害翻倍，伤害高才能经验高！:3||佩戴经验馆主可以增加50%经验，刷经验必备！:3',70,1,5,3000,0,0,0,0,0,0,0,'[]','[]',10,6000,6000,2250,250,'[{1110000004,1}]',0,2000,0,0,1000,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,2,0,0),(30010502,'废旧机器人',6,0,0,'经验副本5难度2号怪物',0,1,0,0,2,202015,'1.3','0',0,0,0,202015,0,'3||鼓舞之后伤害翻倍，伤害高才能经验高！:3||佩戴经验馆主可以增加50%经验，刷经验必备！:3',70,1,5,3000,0,0,0,0,0,0,0,'[]','[]',10,6000,6000,2250,250,'[{1110000004,1}]',0,2000,0,0,1000,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,2,0,0),(30010503,'废旧机器人',6,0,0,'经验副本5难度3号怪物',0,1,0,0,2,202015,'1.3','0',0,0,0,202015,0,'3||鼓舞之后伤害翻倍，伤害高才能经验高！:3||佩戴经验馆主可以增加50%经验，刷经验必备！:3',70,1,5,3000,0,0,0,0,0,0,0,'[]','[]',10,6000,6000,2250,250,'[{1110000004,1}]',0,2000,0,0,1000,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,2,0,0),(30010504,'废旧机器人',6,0,0,'经验副本5难度4号怪物',0,1,0,0,2,202015,'1.3','0',0,0,0,202015,0,'3||鼓舞之后伤害翻倍，伤害高才能经验高！:3||佩戴经验馆主可以增加50%经验，刷经验必备！:3',70,1,5,3000,0,0,0,0,0,0,0,'[]','[]',10,6000,6000,2250,250,'[{1110000004,1}]',0,2000,0,0,1000,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,2,0,0),(30010505,'废旧机器人',6,0,0,'经验副本5难度5号怪物',0,1,0,0,2,202015,'1.3','0',0,0,0,202015,0,'3||鼓舞之后伤害翻倍，伤害高才能经验高！:3||佩戴经验馆主可以增加50%经验，刷经验必备！:3',70,1,5,3000,0,0,0,0,0,0,0,'[]','[]',10,6000,6000,2250,250,'[{1110000004,1}]',0,2000,0,0,1000,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,2,0,0),(30010506,'废旧机器人',6,0,0,'经验副本5难度6号怪物',0,1,0,0,2,202015,'1.3','0',0,0,0,202015,0,'3||鼓舞之后伤害翻倍，伤害高才能经验高！:3||佩戴经验馆主可以增加50%经验，刷经验必备！:3',70,1,5,3000,0,0,0,0,0,0,0,'[]','[]',10,6000,6000,2250,250,'[{1110000004,1}]',0,2000,0,0,1000,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,2,0,0),(30010507,'废旧机器人',6,0,0,'经验副本5难度7号怪物',0,1,0,0,2,202015,'1.3','0',0,0,0,202015,0,'3||鼓舞之后伤害翻倍，伤害高才能经验高！:3||佩戴经验馆主可以增加50%经验，刷经验必备！:3',70,1,5,3000,0,0,0,0,0,0,0,'[]','[]',10,6000,6000,2250,250,'[{1110000004,1}]',0,2000,0,0,1000,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,2,0,0),(30010508,'废旧机器人',6,0,0,'经验副本5难度8号怪物',0,1,0,0,2,202015,'1.3','0',0,0,0,202015,0,'3||鼓舞之后伤害翻倍，伤害高才能经验高！:3||佩戴经验馆主可以增加50%经验，刷经验必备！:3',70,1,5,3000,0,0,0,0,0,0,0,'[]','[]',10,6000,6000,2250,250,'[{1110000004,1}]',0,2000,0,0,1000,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,2,0,0),(30010509,'废旧机器人',6,0,0,'经验副本5难度9号怪物',0,1,0,0,2,202015,'1.3','0',0,0,0,202015,0,'3||鼓舞之后伤害翻倍，伤害高才能经验高！:3||佩戴经验馆主可以增加50%经验，刷经验必备！:3',70,1,5,3000,0,0,0,0,0,0,0,'[]','[]',10,6000,6000,2250,250,'[{1110000004,1}]',0,2000,0,0,1000,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,2,0,0),(40610011,'边防守卫',7,4,1,'公会争霸Lv150外塔',0,3,0,0,0,203008,'1.2','0',0,0,0,203008,0,'0',150,18,8756,5503998,1057,1530,58,75,29,33,0,'[]','[]',600,2250,1500,2250,0,'[{202030081,1},{202030082,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610012,'内殿守卫',7,4,1,'公会争霸Lv150内塔',0,3,0,0,0,203025,'1.2','0',0,0,0,203025,0,'0',150,18,8756,5503998,1057,1530,58,75,29,33,0,'[]','[]',600,2250,1500,2250,0,'[{202030251,1},{202030252,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610013,'基地守卫',7,4,1,'公会争霸Lv150基地',0,3,0,0,0,203026,'1.2','0',0,0,0,203026,0,'0',150,55,22,16511994,1057,1530,58,75,29,33,0,'[]','[]',600,2250,1500,2250,0,'[{202030261,1},{202030262,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610014,'中立BOSS',0,4,1,'公会争霸Lv150中立boss',0,3,0,0,0,203010,'1.2','0',0,0,0,203010,0,'0',150,11,700,3302399,1057,1530,58,75,29,33,0,'[]','[]',600,2250,1500,2250,0,'[{202030101,1},{202030102,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610015,'冲车',1,0,0,'公会争霸Lv150冲车',0,3,0,0,0,41020001,'0.8','effect_monster_caijiwuchangzhu02',0,0,0,41020001,0,'0',150,3,2736,825600,1057,1530,58,75,29,33,0,'[]','[]',350,2250,1500,2250,200,'[{1110000001,1}]',0,2000,0,1,0,0,0,5,1,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(40610016,'炮车',1,0,0,'公会争霸Lv150炮车',0,4,0,0,0,41020002,'0.8','effect_monster_caijiwuchangzhu02',0,0,0,41020002,0,'0',150,1,6567,412800,1057,1530,58,75,29,33,0,'[]','[]',400,2250,1500,2250,200,'[{1110000001,1}]',0,2000,0,1,0,0,0,5,1,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(40610021,'边防守卫',7,4,1,'公会争霸Lv200外塔',0,3,0,0,0,203008,'1.2','0',0,0,0,203008,0,'0',200,24,27276,9566807,4274,2449,120,120,98,110,0,'[]','[]',600,2250,1500,2250,0,'[{202030081,1},{202030082,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610022,'内殿守卫',7,4,1,'公会争霸Lv200内塔',0,3,0,0,0,203025,'1.2','0',0,0,0,203025,0,'0',200,24,27276,9566807,4274,2449,120,120,98,110,0,'[]','[]',600,2250,1500,2250,0,'[{202030251,1},{202030252,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610023,'基地守卫',7,4,1,'公会争霸Lv200基地',0,3,0,0,0,203026,'1.2','0',0,0,0,203026,0,'0',200,72,68,28700421,4274,2449,120,120,98,110,0,'[]','[]',600,2250,1500,2250,0,'[{202030261,1},{202030262,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610024,'中立BOSS',0,4,1,'公会争霸Lv200中立boss',0,3,0,0,0,203010,'1.2','0',0,0,0,203010,0,'0',200,14,2182,5740084,4274,2449,120,120,98,110,0,'[]','[]',600,2250,1500,2250,0,'[{202030101,1},{202030102,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610025,'冲车',1,0,0,'公会争霸Lv200冲车',0,3,0,0,0,41020001,'0.8','effect_monster_caijiwuchangzhu02',0,0,0,41020001,0,'0',200,4,8524,1435021,4274,2449,120,120,98,110,0,'[]','[]',350,2250,1500,2250,200,'[{1110000001,1}]',0,2000,0,1,0,0,0,5,1,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(40610026,'炮车',1,0,0,'公会争霸Lv200炮车',0,4,0,0,0,41020002,'0.8','effect_monster_caijiwuchangzhu02',0,0,0,41020002,0,'0',200,2,20457,717511,4274,2449,120,120,98,110,0,'[]','[]',400,2250,1500,2250,200,'[{1110000001,1}]',0,2000,0,1,0,0,0,5,1,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(40610031,'边防守卫',7,4,1,'公会争霸Lv260外塔',0,3,0,0,0,203008,'1.2','0',0,0,0,203008,0,'0',260,53,74811,27624761,11317,6953,454,454,557,581,0,'[]','[]',600,2250,1500,2250,0,'[{202030081,1},{202030082,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610032,'内殿守卫',7,4,1,'公会争霸Lv260内塔',0,3,0,0,0,203025,'1.2','0',0,0,0,203025,0,'0',260,53,74811,27624761,11317,6953,454,454,557,581,0,'[]','[]',600,2250,1500,2250,0,'[{202030251,1},{202030252,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610033,'基地守卫',7,4,1,'公会争霸Lv260基地',0,3,0,0,0,203026,'1.2','0',0,0,0,203026,0,'0',260,159,187,82874282,11317,6953,454,454,557,581,0,'[]','[]',600,2250,1500,2250,0,'[{202030261,1},{202030262,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610034,'中立BOSS',0,4,1,'公会争霸Lv260中立boss',0,3,0,0,0,203010,'1.2','0',0,0,0,203010,0,'0',260,32,5985,16574856,11317,6953,454,454,557,581,0,'[]','[]',600,2250,1500,2250,0,'[{202030101,1},{202030102,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610035,'冲车',1,0,0,'公会争霸Lv260冲车',0,3,0,0,0,41020001,'0.8','effect_monster_caijiwuchangzhu02',0,0,0,41020001,0,'0',260,8,23378,4143714,11317,6953,454,454,557,581,0,'[]','[]',350,2250,1500,2250,200,'[{1110000001,1}]',0,2000,0,1,0,0,0,5,1,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(40610036,'炮车',1,0,0,'公会争霸Lv260炮车',0,4,0,0,0,41020002,'0.8','effect_monster_caijiwuchangzhu02',0,0,0,41020002,0,'0',260,4,56108,2071857,11317,6953,454,454,557,581,0,'[]','[]',400,2250,1500,2250,200,'[{1110000001,1}]',0,2000,0,1,0,0,0,5,1,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(40610041,'边防守卫',7,4,1,'公会争霸Lv320外塔',0,3,0,0,0,203008,'1.2','0',0,0,0,203008,0,'0',320,84,146665,53579518,21209,13439,1116,1116,1127,1145,0,'[]','[]',600,2250,1500,2250,0,'[{202030081,1},{202030082,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610042,'内殿守卫',7,4,1,'公会争霸Lv320内塔',0,3,0,0,0,203025,'1.2','0',0,0,0,203025,0,'0',320,84,146665,53579518,21209,13439,1116,1116,1127,1145,0,'[]','[]',600,2250,1500,2250,0,'[{202030251,1},{202030252,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610043,'基地守卫',7,4,1,'公会争霸Lv320基地',0,3,0,0,0,203026,'1.2','0',0,0,0,203026,0,'0',320,251,367,160738555,21209,13439,1116,1116,1127,1145,0,'[]','[]',600,2250,1500,2250,0,'[{202030261,1},{202030262,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610044,'中立BOSS',0,4,1,'公会争霸Lv320中立boss',0,3,0,0,0,203010,'1.2','0',0,0,0,203010,0,'0',320,50,11733,32147711,21209,13439,1116,1116,1127,1145,0,'[]','[]',600,2250,1500,2250,0,'[{202030101,1},{202030102,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610045,'冲车',1,0,0,'公会争霸Lv320冲车',0,3,0,0,0,41020001,'0.8','effect_monster_caijiwuchangzhu02',0,0,0,41020001,0,'0',320,13,45833,8036928,21209,13439,1116,1116,1127,1145,0,'[]','[]',350,2250,1500,2250,200,'[{1110000001,1}]',0,2000,0,1,0,0,0,5,1,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(40610046,'炮车',1,0,0,'公会争霸Lv320炮车',0,4,0,0,0,41020002,'0.8','effect_monster_caijiwuchangzhu02',0,0,0,41020002,0,'0',320,6,109998,4018464,21209,13439,1116,1116,1127,1145,0,'[]','[]',400,2250,1500,2250,200,'[{1110000001,1}]',0,2000,0,1,0,0,0,5,1,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(40610051,'边防守卫',7,4,1,'公会争霸Lv370外塔',0,3,0,0,0,203008,'1.2','0',0,0,0,203008,0,'0',370,123,218654,91245313,30373,22969,2295,2295,1864,1896,0,'[]','[]',600,2250,1500,2250,0,'[{202030081,1},{202030082,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610052,'内殿守卫',7,4,1,'公会争霸Lv370内塔',0,3,0,0,0,203025,'1.2','0',0,0,0,203025,0,'0',370,123,218654,91245313,30373,22969,2295,2295,1864,1896,0,'[]','[]',600,2250,1500,2250,0,'[{202030251,1},{202030252,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610053,'基地守卫',7,4,1,'公会争霸Lv370基地',0,3,0,0,0,203026,'1.2','0',0,0,0,203026,0,'0',370,370,547,273735938,30373,22969,2295,2295,1864,1896,0,'[]','[]',600,2250,1500,2250,0,'[{202030261,1},{202030262,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610054,'中立BOSS',0,4,1,'公会争霸Lv370中立boss',0,3,0,0,0,203010,'1.2','0',0,0,0,203010,0,'0',370,74,17492,54747188,30373,22969,2295,2295,1864,1896,0,'[]','[]',600,2250,1500,2250,0,'[{202030101,1},{202030102,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610055,'冲车',1,0,0,'公会争霸Lv370冲车',0,3,0,0,0,41020001,'0.8','effect_monster_caijiwuchangzhu02',0,0,0,41020001,0,'0',370,18,68329,13686797,30373,22969,2295,2295,1864,1896,0,'[]','[]',350,2250,1500,2250,200,'[{1110000001,1}]',0,2000,0,1,0,0,0,5,1,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(40610056,'炮车',1,0,0,'公会争霸Lv370炮车',0,4,0,0,0,41020002,'0.8','effect_monster_caijiwuchangzhu02',0,0,0,41020002,0,'0',370,9,163991,6843398,30373,22969,2295,2295,1864,1896,0,'[]','[]',400,2250,1500,2250,200,'[{1110000001,1}]',0,2000,0,1,0,0,0,5,1,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(40610061,'边防守卫',7,4,1,'公会争霸Lv410外塔',0,3,0,0,0,203008,'1.2','0',0,0,0,203008,0,'0',410,156,282815,127872878,38175,31515,3745,3745,2868,2928,0,'[]','[]',600,2250,1500,2250,0,'[{202030081,1},{202030082,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610062,'内殿守卫',7,4,1,'公会争霸Lv410内塔',0,3,0,0,0,203025,'1.2','0',0,0,0,203025,0,'0',410,156,282815,127872878,38175,31515,3745,3745,2868,2928,0,'[]','[]',600,2250,1500,2250,0,'[{202030251,1},{202030252,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610063,'基地守卫',7,4,1,'公会争霸Lv410基地',0,3,0,0,0,203026,'1.2','0',0,0,0,203026,0,'0',410,468,707,383618634,38175,31515,3745,3745,2868,2928,0,'[]','[]',600,2250,1500,2250,0,'[{202030261,1},{202030262,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610064,'中立BOSS',0,4,1,'公会争霸Lv410中立boss',0,3,0,0,0,203010,'1.2','0',0,0,0,203010,0,'0',410,94,22625,76723727,38175,31515,3745,3745,2868,2928,0,'[]','[]',600,2250,1500,2250,0,'[{202030101,1},{202030102,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610065,'冲车',1,0,0,'公会争霸Lv410冲车',0,3,0,0,0,41020001,'0.8','effect_monster_caijiwuchangzhu02',0,0,0,41020001,0,'0',410,23,88380,19180932,38175,31515,3745,3745,2868,2928,0,'[]','[]',350,2250,1500,2250,200,'[{1110000001,1}]',0,2000,0,1,0,0,0,5,1,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(40610066,'炮车',1,0,0,'公会争霸Lv410炮车',0,4,0,0,0,41020002,'0.8','effect_monster_caijiwuchangzhu02',0,0,0,41020002,0,'0',410,12,212111,9590466,38175,31515,3745,3745,2868,2928,0,'[]','[]',400,2250,1500,2250,200,'[{1110000001,1}]',0,2000,0,1,0,0,0,5,1,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(40610071,'边防守卫',7,4,1,'公会争霸Lv450外塔',0,3,0,0,0,203008,'1.2','0',0,0,0,203008,0,'0',450,176,345386,158305988,45525,38291,5142,5142,3573,3695,0,'[]','[]',600,2250,1500,2250,0,'[{202030081,1},{202030082,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610072,'内殿守卫',7,4,1,'公会争霸Lv450内塔',0,3,0,0,0,203025,'1.2','0',0,0,0,203025,0,'0',450,176,345386,158305988,45525,38291,5142,5142,3573,3695,0,'[]','[]',600,2250,1500,2250,0,'[{202030251,1},{202030252,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610073,'基地守卫',7,4,1,'公会争霸Lv450基地',0,3,0,0,0,203026,'1.2','0',0,0,0,203026,0,'0',450,528,863,474917965,45525,38291,5142,5142,3573,3695,0,'[]','[]',600,2250,1500,2250,0,'[{202030261,1},{202030262,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610074,'中立BOSS',0,4,1,'公会争霸Lv450中立boss',0,3,0,0,0,203010,'1.2','0',0,0,0,203010,0,'0',450,106,27631,94983593,45525,38291,5142,5142,3573,3695,0,'[]','[]',600,2250,1500,2250,0,'[{202030101,1},{202030102,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610075,'冲车',1,0,0,'公会争霸Lv450冲车',0,3,0,0,0,41020001,'0.8','effect_monster_caijiwuchangzhu02',0,0,0,41020001,0,'0',450,26,107933,23745898,45525,38291,5142,5142,3573,3695,0,'[]','[]',350,2250,1500,2250,200,'[{1110000001,1}]',0,2000,0,1,0,0,0,5,1,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(40610076,'炮车',1,0,0,'公会争霸Lv450炮车',0,4,0,0,0,41020002,'0.8','effect_monster_caijiwuchangzhu02',0,0,0,41020002,0,'0',450,13,259040,11872949,45525,38291,5142,5142,3573,3695,0,'[]','[]',400,2250,1500,2250,200,'[{1110000001,1}]',0,2000,0,1,0,0,0,5,1,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(40610081,'边防守卫',7,4,1,'公会争霸Lv500外塔',0,3,0,0,0,203008,'1.2','0',0,0,0,203008,0,'0',500,216,460402,216013280,59234,51239,7700,7700,5483,5720,0,'[]','[]',600,2250,1500,2250,0,'[{202030081,1},{202030082,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610082,'内殿守卫',7,4,1,'公会争霸Lv500内塔',0,3,0,0,0,203025,'1.2','0',0,0,0,203025,0,'0',500,216,460402,216013280,59234,51239,7700,7700,5483,5720,0,'[]','[]',600,2250,1500,2250,0,'[{202030251,1},{202030252,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610083,'基地守卫',7,4,1,'公会争霸Lv500基地',0,3,0,0,0,203026,'1.2','0',0,0,0,203026,0,'0',500,648,1151,648039840,59234,51239,7700,7700,5483,5720,0,'[]','[]',600,2250,1500,2250,0,'[{202030261,1},{202030262,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610084,'中立BOSS',0,4,1,'公会争霸Lv500中立boss',0,3,0,0,0,203010,'1.2','0',0,0,0,203010,0,'0',500,130,36832,129607968,59234,51239,7700,7700,5483,5720,0,'[]','[]',600,2250,1500,2250,0,'[{202030101,1},{202030102,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610085,'冲车',1,0,0,'公会争霸Lv500冲车',0,3,0,0,0,41020001,'0.8','effect_monster_caijiwuchangzhu02',0,0,0,41020001,0,'0',500,32,143876,32401992,59234,51239,7700,7700,5483,5720,0,'[]','[]',350,2250,1500,2250,200,'[{1110000001,1}]',0,2000,0,1,0,0,0,5,1,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(40610086,'炮车',1,0,0,'公会争霸Lv500炮车',0,4,0,0,0,41020002,'0.8','effect_monster_caijiwuchangzhu02',0,0,0,41020002,0,'0',500,16,345301,16200996,59234,51239,7700,7700,5483,5720,0,'[]','[]',400,2250,1500,2250,200,'[{1110000001,1}]',0,2000,0,1,0,0,0,5,1,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(40610091,'边防守卫',7,4,1,'公会争霸Lv550外塔',0,3,0,0,0,203008,'1.2','0',0,0,0,203008,0,'0',550,257,594540,283197834,74814,66045,12896,12896,8658,8955,0,'[]','[]',600,2250,1500,2250,0,'[{202030081,1},{202030082,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610092,'内殿守卫',7,4,1,'公会争霸Lv550内塔',0,3,0,0,0,203025,'1.2','0',0,0,0,203025,0,'0',550,257,594540,283197834,74814,66045,12896,12896,8658,8955,0,'[]','[]',600,2250,1500,2250,0,'[{202030251,1},{202030252,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610093,'基地守卫',7,4,1,'公会争霸Lv550基地',0,3,0,0,0,203026,'1.2','0',0,0,0,203026,0,'0',550,772,1486,849593503,74814,66045,12896,12896,8658,8955,0,'[]','[]',600,2250,1500,2250,0,'[{202030261,1},{202030262,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610094,'中立BOSS',0,4,1,'公会争霸Lv550中立boss',0,3,0,0,0,203010,'1.2','0',0,0,0,203010,0,'0',550,154,47563,169918701,74814,66045,12896,12896,8658,8955,0,'[]','[]',600,2250,1500,2250,0,'[{202030101,1},{202030102,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610095,'冲车',1,0,0,'公会争霸Lv550冲车',0,3,0,0,0,41020001,'0.8','effect_monster_caijiwuchangzhu02',0,0,0,41020001,0,'0',550,39,185794,42479675,74814,66045,12896,12896,8658,8955,0,'[]','[]',350,2250,1500,2250,200,'[{1110000001,1}]',0,2000,0,1,0,0,0,5,1,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(40610096,'炮车',1,0,0,'公会争霸Lv550炮车',0,4,0,0,0,41020002,'0.8','effect_monster_caijiwuchangzhu02',0,0,0,41020002,0,'0',550,19,445905,21239838,74814,66045,12896,12896,8658,8955,0,'[]','[]',400,2250,1500,2250,200,'[{1110000001,1}]',0,2000,0,1,0,0,0,5,1,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(40610101,'边防守卫',7,4,1,'公会争霸Lv600外塔',0,3,0,0,0,203008,'1.2','0',0,0,0,203008,0,'0',600,296,737915,354935663,91527,82028,16678,16678,10660,10902,0,'[]','[]',600,2250,1500,2250,0,'[{202030081,1},{202030082,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610102,'内殿守卫',7,4,1,'公会争霸Lv600内塔',0,3,0,0,0,203025,'1.2','0',0,0,0,203025,0,'0',600,296,737915,354935663,91527,82028,16678,16678,10660,10902,0,'[]','[]',600,2250,1500,2250,0,'[{202030251,1},{202030252,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610103,'基地守卫',7,4,1,'公会争霸Lv600基地',0,3,0,0,0,203026,'1.2','0',0,0,0,203026,0,'0',600,887,1845,1064806989,91527,82028,16678,16678,10660,10902,0,'[]','[]',600,2250,1500,2250,0,'[{202030261,1},{202030262,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610104,'中立BOSS',0,4,1,'公会争霸Lv600中立boss',0,3,0,0,0,203010,'1.2','0',0,0,0,203010,0,'0',600,177,59033,212961398,91527,82028,16678,16678,10660,10902,0,'[]','[]',600,2250,1500,2250,0,'[{202030101,1},{202030102,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610105,'冲车',1,0,0,'公会争霸Lv600冲车',0,3,0,0,0,41020001,'0.8','effect_monster_caijiwuchangzhu02',0,0,0,41020001,0,'0',600,44,230598,53240349,91527,82028,16678,16678,10660,10902,0,'[]','[]',350,2250,1500,2250,200,'[{1110000001,1}]',0,2000,0,1,0,0,0,5,1,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(40610106,'炮车',1,0,0,'公会争霸Lv600炮车',0,4,0,0,0,41020002,'0.8','effect_monster_caijiwuchangzhu02',0,0,0,41020002,0,'0',600,22,553436,26620175,91527,82028,16678,16678,10660,10902,0,'[]','[]',400,2250,1500,2250,200,'[{1110000001,1}]',0,2000,0,1,0,0,0,5,1,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(40610111,'边防守卫',7,4,1,'公会争霸Lv650外塔',0,3,0,0,0,203008,'1.2','0',0,0,0,203008,0,'0',650,334,896739,434241449,111280,101044,21249,21249,14106,14246,0,'[]','[]',600,2250,1500,2250,0,'[{202030081,1},{202030082,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610112,'内殿守卫',7,4,1,'公会争霸Lv650内塔',0,3,0,0,0,203025,'1.2','0',0,0,0,203025,0,'0',650,334,896739,434241449,111280,101044,21249,21249,14106,14246,0,'[]','[]',600,2250,1500,2250,0,'[{202030251,1},{202030252,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610113,'基地守卫',7,4,1,'公会争霸Lv650基地',0,3,0,0,0,203026,'1.2','0',0,0,0,203026,0,'0',650,1002,2242,1302724348,111280,101044,21249,21249,14106,14246,0,'[]','[]',600,2250,1500,2250,0,'[{202030261,1},{202030262,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610114,'中立BOSS',0,4,1,'公会争霸Lv650中立boss',0,3,0,0,0,203010,'1.2','0',0,0,0,203010,0,'0',650,200,71739,260544870,111280,101044,21249,21249,14106,14246,0,'[]','[]',600,2250,1500,2250,0,'[{202030101,1},{202030102,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610115,'冲车',1,0,0,'公会争霸Lv650冲车',0,3,0,0,0,41020001,'0.8','effect_monster_caijiwuchangzhu02',0,0,0,41020001,0,'0',650,50,280231,65136217,111280,101044,21249,21249,14106,14246,0,'[]','[]',350,2250,1500,2250,200,'[{1110000001,1}]',0,2000,0,1,0,0,0,5,1,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(40610116,'炮车',1,0,0,'公会争霸Lv650炮车',0,4,0,0,0,41020002,'0.8','effect_monster_caijiwuchangzhu02',0,0,0,41020002,0,'0',650,25,672554,32568109,111280,101044,21249,21249,14106,14246,0,'[]','[]',400,2250,1500,2250,200,'[{1110000001,1}]',0,2000,0,1,0,0,0,5,1,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(40610121,'边防守卫',7,4,1,'公会争霸Lv700外塔',0,3,0,0,0,203008,'1.2','0',0,0,0,203008,0,'0',700,381,1091157,533106531,131759,120848,25409,25409,16084,16242,0,'[]','[]',600,2250,1500,2250,0,'[{202030081,1},{202030082,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610122,'内殿守卫',7,4,1,'公会争霸Lv700内塔',0,3,0,0,0,203025,'1.2','0',0,0,0,203025,0,'0',700,381,1091157,533106531,131759,120848,25409,25409,16084,16242,0,'[]','[]',600,2250,1500,2250,0,'[{202030251,1},{202030252,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610123,'基地守卫',7,4,1,'公会争霸Lv700基地',0,3,0,0,0,203026,'1.2','0',0,0,0,203026,0,'0',700,1142,2728,1599319592,131759,120848,25409,25409,16084,16242,0,'[]','[]',600,2250,1500,2250,0,'[{202030261,1},{202030262,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610124,'中立BOSS',0,4,1,'公会争霸Lv700中立boss',0,3,0,0,0,203010,'1.2','0',0,0,0,203010,0,'0',700,228,87293,319863918,131759,120848,25409,25409,16084,16242,0,'[]','[]',600,2250,1500,2250,0,'[{202030101,1},{202030102,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610125,'冲车',1,0,0,'公会争霸Lv700冲车',0,3,0,0,0,41020001,'0.8','effect_monster_caijiwuchangzhu02',0,0,0,41020001,0,'0',700,57,340987,79965980,131759,120848,25409,25409,16084,16242,0,'[]','[]',350,2250,1500,2250,200,'[{1110000001,1}]',0,2000,0,1,0,0,0,5,1,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(40610126,'炮车',1,0,0,'公会争霸Lv700炮车',0,4,0,0,0,41020002,'0.8','effect_monster_caijiwuchangzhu02',0,0,0,41020002,0,'0',700,29,818368,39982990,131759,120848,25409,25409,16084,16242,0,'[]','[]',400,2250,1500,2250,200,'[{1110000001,1}]',0,2000,0,1,0,0,0,5,1,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(40610131,'边防守卫',7,4,1,'公会争霸Lv750外塔',0,3,0,0,0,203008,'1.2','0',0,0,0,203008,0,'0',750,414,1267662,620707892,153569,141938,29013,29013,18067,18067,0,'[]','[]',600,2250,1500,2250,0,'[{202030081,1},{202030082,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610132,'内殿守卫',7,4,1,'公会争霸Lv750内塔',0,3,0,0,0,203025,'1.2','0',0,0,0,203025,0,'0',750,414,1267662,620707892,153569,141938,29013,29013,18067,18067,0,'[]','[]',600,2250,1500,2250,0,'[{202030251,1},{202030252,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610133,'基地守卫',7,4,1,'公会争霸Lv750基地',0,3,0,0,0,203026,'1.2','0',0,0,0,203026,0,'0',750,1241,3169,1862123675,153569,141938,29013,29013,18067,18067,0,'[]','[]',600,2250,1500,2250,0,'[{202030261,1},{202030262,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610134,'中立BOSS',0,4,1,'公会争霸Lv750中立boss',0,3,0,0,0,203010,'1.2','0',0,0,0,203010,0,'0',750,248,101413,372424735,153569,141938,29013,29013,18067,18067,0,'[]','[]',600,2250,1500,2250,0,'[{202030101,1},{202030102,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610135,'冲车',1,0,0,'公会争霸Lv750冲车',0,3,0,0,0,41020001,'0.8','effect_monster_caijiwuchangzhu02',0,0,0,41020001,0,'0',750,62,396144,93106184,153569,141938,29013,29013,18067,18067,0,'[]','[]',350,2250,1500,2250,200,'[{1110000001,1}]',0,2000,0,1,0,0,0,5,1,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(40610136,'炮车',1,0,0,'公会争霸Lv750炮车',0,4,0,0,0,41020002,'0.8','effect_monster_caijiwuchangzhu02',0,0,0,41020002,0,'0',750,31,950747,46553092,153569,141938,29013,29013,18067,18067,0,'[]','[]',400,2250,1500,2250,200,'[{1110000001,1}]',0,2000,0,1,0,0,0,5,1,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(40610141,'边防守卫',7,4,1,'公会争霸Lv800外塔',0,3,0,0,0,203008,'1.2','0',0,0,0,203008,0,'0',800,448,1460242,716128780,178794,166475,32658,32658,21803,21803,0,'[]','[]',600,2250,1500,2250,0,'[{202030081,1},{202030082,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610142,'内殿守卫',7,4,1,'公会争霸Lv800内塔',0,3,0,0,0,203025,'1.2','0',0,0,0,203025,0,'0',800,448,1460242,716128780,178794,166475,32658,32658,21803,21803,0,'[]','[]',600,2250,1500,2250,0,'[{202030251,1},{202030252,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610143,'基地守卫',7,4,1,'公会争霸Lv800基地',0,3,0,0,0,203026,'1.2','0',0,0,0,203026,0,'0',800,1343,3651,2148386341,178794,166475,32658,32658,21803,21803,0,'[]','[]',600,2250,1500,2250,0,'[{202030261,1},{202030262,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610144,'中立BOSS',0,4,1,'公会争霸Lv800中立boss',0,3,0,0,0,203010,'1.2','0',0,0,0,203010,0,'0',800,269,116819,429677268,178794,166475,32658,32658,21803,21803,0,'[]','[]',600,2250,1500,2250,0,'[{202030101,1},{202030102,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(40610145,'冲车',1,0,0,'公会争霸Lv800冲车',0,3,0,0,0,41020001,'0.8','effect_monster_caijiwuchangzhu02',0,0,0,41020001,0,'0',800,67,456325,107419317,178794,166475,32658,32658,21803,21803,0,'[]','[]',350,2250,1500,2250,200,'[{1110000001,1}]',0,2000,0,1,0,0,0,5,1,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(40610146,'炮车',1,0,0,'公会争霸Lv800炮车',0,4,0,0,0,41020002,'0.8','effect_monster_caijiwuchangzhu02',0,0,0,41020002,0,'0',800,34,1095181,53709659,178794,166475,32658,32658,21803,21803,0,'[]','[]',400,2250,1500,2250,200,'[{1110000001,1}]',0,2000,0,1,0,0,0,5,1,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(42010010,'白银宝箱',1,0,0,'公会守护宝箱1',0,1,0,0,0,2040010,'0.8','0',0,0,0,2040010,0,'0',1,1,0,100,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,0,'[]',0,0,0,1,0,0,0,2,1,0,0,1,0,0,'[]',1,'0',1,0,0,0,0),(42010011,'黄金宝箱',1,0,0,'公会守护宝箱2',0,1,0,0,0,2040009,'1','0',0,0,0,2040009,0,'0',1,1,0,100,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,0,'[]',0,0,0,0,0,0,0,2,1,0,0,1,0,0,'[]',1,'0',1,0,0,0,0),(42010012,'铂金宝箱',1,0,0,'公会守护宝箱3',0,1,0,0,0,2040013,'1.2','0',0,0,0,2040013,0,'0',1,1,0,100,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,0,'[]',0,0,0,0,0,0,0,2,1,0,0,1,0,0,'[]',1,'0',1,0,0,0,0),(51550001,'巡游护卫队员',6,0,1,'巡游护卫NPC1',0,1,0,0,0,501002,'0.5','0',0,0,0,501002,0,'0',500,1,10000,1000000,10000,10000,10000,10000,10000,10000,0,'[]','[]',600,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,0,0,5,1,1,0,0,0,0,'[20000,20000]',1,'0',0,0,0,0,0),(51550002,'巡游护卫队员',6,0,1,'巡游护卫NPC2',0,1,0,0,0,501002,'0.5','0',0,0,0,501002,0,'0',500,1,10000,1000000,10000,10000,10000,10000,10000,10000,0,'[]','[]',600,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,0,0,5,1,1,0,0,0,0,'[20000,20000]',1,'0',0,0,0,0,0),(51550003,'巡游护卫队员',6,0,1,'巡游护卫NPC3',0,1,0,0,0,501002,'0.5','0',0,0,0,501002,0,'0',500,1,10000,1000000,10000,10000,10000,10000,10000,10000,0,'[]','[]',600,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,0,0,5,1,1,0,0,0,0,'[20000,20000]',1,'0',0,0,0,0,0),(51550004,'巡游护卫队员',6,0,1,'巡游护卫NPC4',0,1,0,0,0,501002,'0.5','0',0,0,0,501002,0,'0',500,1,10000,1000000,10000,10000,10000,10000,10000,10000,0,'[]','[]',600,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,0,0,5,1,1,0,0,0,0,'[20000,20000]',1,'0',0,0,0,0,0),(51550005,'简约婚车',9,0,0,'巡游婚车1',0,1,0,0,0,51550005,'1','0',0,0,0,51550005,0,'0',500,100,0,10000000,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,300,'[]',0,0,0,0,0,0,0,5,1,0,0,0,0,0,'[100000,100000]',1,'0',0,0,0,0,0),(51550006,'中级婚车',9,0,0,'巡游婚车2',0,1,0,0,0,51550006,'1','0',0,0,0,51550006,0,'0',500,100,0,10000000,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,300,'[]',0,0,0,0,0,0,0,5,1,0,0,0,0,0,'[100000,100000]',1,'0',0,0,0,0,0),(51550007,'豪华婚车',9,0,0,'巡游婚车3',0,1,0,0,0,51550007,'1','0',0,0,0,51550007,0,'0',500,100,0,10000000,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,300,'[]',0,0,0,0,0,0,0,5,1,0,0,0,0,0,'[100000,100000]',1,'0',0,0,0,0,0),(51550008,'菲菲强盗',0,0,0,'巡游期间刷新怪物',0,6,0,0,0,202015,'1','0',0,0,0,202015,0,'0',1,1,0,100,0,0,0,0,0,0,0,'[]','[]',0,2250,1500,2250,200,'[]',0,0,0,1,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(51550009,'巡游奖励宝箱',1,0,0,'巡游结束奖励宝箱怪',0,5,172,1,2,2040013,'1.5','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,1,8,1,0,0,1,0,0,'[]',1,'0',1,0,0,0,0),(51550010,'巡游新人宝箱',8,0,0,'巡游结束奖励宝箱怪新人',0,5,172,2,2,2040013,'2','0',0,0,0,2040013,0,'0',1,1,1,1,1,1,1,1,1,1,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,1,8,1,0,0,1,0,0,'[]',1,'0',1,0,0,0,0),(53001001,'星灵萌羊座',6,0,1,'星灵假人1',0,7,0,0,0,501002,'1','0',0,0,0,501002,0,'0',200,50,680,195587,1802,1595,294,294,154,154,0,'[]','[]',500,2250,1500,2250,450,'[{13000002,1},{13000003,2},{11000004,3}]',20000,0,0,0,0,0,0,0,0,1,1,1,0,0,'[1,30000]',1,'0',0,0,0,0,0),(53001002,'星灵白羊座',6,0,1,'星灵假人2',0,7,0,0,0,501003,'1','0',0,0,0,501003,0,'0',380,95,2002,875078,6156,5230,1394,1394,1140,1140,0,'[]','[]',500,2250,1500,2250,450,'[{13000006,1},{13000007,2},{13000008,3}]',20000,0,0,0,0,0,0,0,0,1,1,1,0,0,'[1,30000]',1,'0',0,0,0,0,0),(53001003,'星灵金牛座',6,0,1,'星灵假人3',0,7,0,0,0,501004,'1','0',0,0,0,501004,0,'0',540,135,4707,2238362,14188,12715,4472,4472,2632,2632,0,'[]','[]',500,2250,1500,2250,450,'[{13000010,1},{13000011,2},{13000012,3}]',20000,0,0,0,0,0,0,0,0,1,1,1,0,0,'[1,30000]',1,'0',0,0,0,0,0),(53001004,'星灵双子座',6,0,1,'星灵假人4',0,7,0,0,0,501005,'1','0',0,0,0,501005,0,'0',680,170,13473,6490895,38221,34267,16125,16125,7987,7987,0,'[]','[]',500,2250,1500,2250,450,'[{13000014,1},{13000015,2},{13000016,3}]',20000,0,0,0,0,0,0,0,0,1,1,1,0,0,'[1,30000]',1,'0',0,0,0,0,0),(53001005,'星灵巨蟹座',6,0,1,'星灵假人5',0,7,0,0,0,501006,'1','0',0,0,0,501006,0,'0',370,1,9956,153480,0,4218,1060,1060,550,550,0,'[]','[]',500,2250,1500,2250,450,'[{13000018,1},{13000019,2},{13000020,3}]',20000,0,0,0,0,0,0,0,0,1,1,1,0,0,'[1,30000]',1,'0',0,0,0,0,0),(53001006,'星灵狮子座',6,0,1,'星灵假人6',0,7,0,0,0,501007,'1','0',0,0,0,501007,0,'0',370,1,9956,153480,0,4218,1060,1060,550,550,0,'[]','[]',500,2250,1500,2250,450,'[{13000022,1},{13000023,2},{13000024,3}]',20000,0,0,0,0,0,0,0,0,1,1,1,0,0,'[1,30000]',1,'0',0,0,0,0,0),(53001007,'星灵处女座',6,0,1,'星灵假人7',0,7,0,0,0,501008,'1','0',0,0,0,501008,0,'0',370,1,9956,153480,0,4218,1060,1060,550,550,0,'[]','[]',500,2250,1500,2250,450,'[{13000026,1},{13000027,2},{13000028,3}]',20000,0,0,0,0,0,0,0,0,1,1,1,0,0,'[1,30000]',1,'0',0,0,0,0,0),(53002001,'熊霸霸',6,0,1,'星灵假人8',0,7,0,0,0,202028,'1','0',0,0,0,202028,0,'0',370,1,9956,153480,0,4218,1060,1060,550,550,0,'[]','[]',500,2250,1500,2250,450,'[{13000026,1},{13000027,2},{13000028,3}]',20000,0,0,0,0,0,0,0,0,1,1,1,0,0,'[1,30000]',1,'0',0,0,0,0,0),(53002002,'难大师',6,0,1,'星灵假人9',0,7,0,0,0,202003,'1','0',0,0,0,202003,0,'0',370,1,9956,153480,0,4218,1060,1060,550,550,0,'[]','[]',500,2250,1500,2250,450,'[{13000026,1},{13000027,2},{13000028,3}]',20000,0,0,0,0,0,0,0,0,1,1,1,0,0,'[1,30000]',1,'0',0,0,0,0,0),(53002003,'代号09',6,0,1,'星灵假人10',0,7,0,0,0,202015,'1','0',0,0,0,202015,0,'0',370,1,9956,153480,0,4218,1060,1060,550,550,0,'[]','[]',500,2250,1500,2250,450,'[{13000026,1},{13000027,2},{13000028,3}]',20000,0,0,0,0,0,0,0,0,1,1,1,0,0,'[1,30000]',1,'0',0,0,0,0,0),(53002004,'修罗虎',6,0,1,'星灵假人11',0,7,0,0,0,202029,'1','0',0,0,0,202029,0,'0',370,1,9956,153480,0,4218,1060,1060,550,550,0,'[]','[]',500,2250,1500,2250,450,'[{13000026,1},{13000027,2},{13000028,3}]',20000,0,0,0,0,0,0,0,0,1,1,1,0,0,'[1,30000]',1,'0',0,0,0,0,0),(53002005,'暗影忍者',6,0,1,'星灵假人12',0,7,0,0,0,202027,'1','0',0,0,0,202027,0,'0',370,1,9956,153480,0,4218,1060,1060,550,550,0,'[]','[]',500,2250,1500,2250,450,'[{13000026,1},{13000027,2},{13000028,3}]',20000,0,0,0,0,0,0,0,0,1,1,1,0,0,'[1,30000]',1,'0',0,0,0,0,0),(54000002,'冰元素',0,6,1,'0',0,3,0,0,0,1202004,'1','0',0,0,0,1202004,0,'0',200,50,1147,501374,2786,2351,528,528,523,523,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(54000003,'冰脉巨龙',0,6,1,'0',0,3,0,0,0,203004,'1','0',0,0,0,203004,0,'0',380,95,2002,1346275,6156,5230,1394,1394,1140,1140,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{202030041,1},{202030043,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(54000004,'暗黑骑士',0,6,1,'0',0,3,0,0,0,1204007,'1.1','0',0,0,0,1204007,0,'0',540,135,4707,3443633,14188,12715,4472,4472,2632,2632,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(54000005,'长角恶鬼',0,6,1,'0',0,3,0,0,0,1204003,'0.9','0',0,0,0,1204003,0,'0',680,170,13600,10086809,38469,34514,16429,16429,8050,8050,0,'[]','[1,61414164,500]',250,2250,1500,2250,300,'[{1110000001,1}]',30000,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(54000006,'骷髅战士',0,6,1,'0',0,3,0,0,0,1204001,'1','0',0,0,0,1204001,0,'0',200,50,10,2250,0,10,10,0,0,0,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000001,'骷髅战士',0,6,0,'神格副本1关小怪Lv120',0,3,0,0,0,202002,'2','0',0,0,0,202002,0,'0',120,30,1130,35447,748,935,124,130,41,40,0,'[]','[]',600,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000002,'精锐枪兵',0,6,0,'神格副本2关小怪Lv135',0,3,0,0,0,202004,'2','203018',0,0,0,202004,0,'0',135,30,2248,104092,864,1151,101,111,37,38,0,'[]','[]',600,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000003,'大嘴花',0,6,0,'神格副本3关小怪Lv150',0,3,0,0,0,202001,'2','0',0,0,0,202001,0,'0',150,30,2270,131567,1057,1530,58,75,29,33,0,'[]','[]',600,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000004,'鲛人刺客',0,6,0,'神格副本4关小怪Lv165',0,3,0,0,0,202021,'2','0',0,0,0,202021,0,'0',165,30,2308,173861,1242,1722,58,75,29,33,0,'[]','[]',600,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000005,'巴哈姆特',0,6,0,'神格副本5关bossLv180',0,3,0,0,0,203026,'1.5','0',0,0,0,203026,0,'0',180,30,4346,222508,2650,1914,86,93,47,54,0,'[]','[]',600,2250,1500,2250,300,'[{202030261,1},{202030262,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000006,'鲛人刺客',0,6,0,'神格副本6关小怪Lv195',0,3,0,0,0,202021,'2','0',0,0,0,202021,0,'0',195,30,6387,310989,3964,2250,113,113,78,90,0,'[]','[]',600,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000007,'海蜥人',0,6,0,'神格副本7关小怪Lv210',0,3,0,0,0,202024,'2','0',0,0,0,202024,0,'0',210,30,8074,458174,4894,2846,134,134,138,152,0,'[]','[]',600,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000008,'废旧机器人',0,6,0,'神格副本8关小怪Lv220',0,3,0,0,0,202015,'2','0',0,0,0,202015,0,'0',220,30,9206,589460,5515,3244,148,148,178,193,0,'[]','[]',600,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000009,'叛军战士',0,6,0,'神格副本9关小怪Lv230',0,3,0,0,0,202012,'2','0',0,0,0,202012,0,'0',230,30,10326,670026,6135,3641,162,162,219,234,0,'[]','[]',600,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000010,'死神',0,6,0,'神格副本10关bossLv240',0,3,0,0,0,203018,'1.5','0',0,0,0,203018,0,'0',240,30,13173,876475,7922,4900,262,262,332,353,0,'[]','[]',600,2250,1500,2250,300,'[{2000201801,1},{20005455,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000011,'哥布林',0,6,0,'神格副本11关小怪Lv250',0,3,0,0,0,202005,'2','0',0,0,0,202005,0,'0',250,30,16055,1084645,9708,6159,363,363,445,472,0,'[]','[]',600,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000012,'废旧机器人',0,6,0,'神格副本12关小怪Lv260',0,3,0,0,0,202015,'2','0',0,0,0,202015,0,'0',260,30,18863,1238134,11317,6953,454,454,557,581,0,'[]','[]',600,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000013,'树桩怪',0,6,0,'神格副本13关小怪Lv270',0,3,0,0,0,202033,'2','0',0,0,0,202033,0,'0',270,30,21690,1391927,12925,7747,545,545,668,691,0,'[]','[]',600,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000014,'鲛人士兵',0,6,0,'神格副本14关小怪Lv280',0,3,0,0,0,202020,'2','0',0,0,0,202020,0,'0',280,30,24528,1545940,14534,8541,637,637,780,800,0,'[]','[]',600,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000015,'熔岩之魂',0,6,0,'神格副本15关bossLv290',0,3,0,0,0,203025,'1.5','0',0,0,0,203025,0,'0',290,30,27378,1699961,16142,9336,728,728,892,909,0,'[]','[]',600,2250,1500,2250,300,'[{202030251,1},{202030252,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000016,'烈焰蝎',0,6,0,'神格副本16关小怪Lv300',0,3,0,0,0,202013,'2','0',0,0,0,202013,0,'0',300,30,30232,2242562,17751,10130,819,819,1004,1018,0,'[]','[]',250,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000017,'蜥蜴人',0,6,0,'神格副本17关小怪Lv310',0,3,0,0,0,202014,'2','0',0,0,0,202014,0,'0',310,30,33528,2572870,19480,11784,967,967,1066,1082,0,'[]','[]',600,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000018,'哥布林',0,6,0,'神格副本18关小怪Lv320',0,3,0,0,0,202005,'2','0',0,0,0,202005,0,'0',320,30,36830,2904371,21209,13439,1116,1116,1127,1145,0,'[]','[]',250,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000019,'帝国士兵',0,6,0,'神格副本19关小怪Lv330',0,3,0,0,0,202017,'2','0',0,0,0,202017,0,'0',330,30,40137,3237159,22938,15093,1265,1265,1188,1208,0,'[]','[]',600,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000020,'嫉妒',0,6,0,'神格副本20关bossLv340',0,3,0,0,0,203011,'1.5','0',0,0,0,203011,0,'0',340,30,43444,3570791,24668,16747,1413,1413,1250,1271,0,'[]','[]',250,2250,1500,2250,300,'[{200022021,1},{200022022,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000021,'魔化难民',0,6,0,'神格副本21关小怪Lv350',0,3,0,0,0,202010,'2','0',0,0,0,202010,0,'0',350,30,46755,3904830,26397,18402,1562,1562,1311,1335,0,'[]','[]',600,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000022,'火鸡骑士',0,6,0,'神格副本22关小怪Lv360',0,3,0,0,0,202034,'2','0',0,0,0,202034,0,'0',360,30,50791,4424610,28385,20685,1929,1929,1587,1615,0,'[]','[]',250,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000023,'哥布林',0,6,0,'神格副本23关小怪Lv370',0,3,0,0,0,202005,'2','0',0,0,0,202005,0,'0',370,30,54830,4946110,30373,22969,2295,2295,1864,1896,0,'[]','[]',600,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000024,'白虎太郎',0,6,0,'神格副本24关小怪Lv380',0,3,0,0,0,202029,'2','0',0,0,0,202029,0,'0',380,30,58870,5469149,32361,25253,2662,2662,2140,2176,0,'[]','[]',250,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000025,'冰霜泰坦',0,6,0,'神格副本25关bossLv390',0,3,0,0,0,203003,'1.5','0',0,0,0,203003,0,'0',390,30,62911,5993382,34349,27537,3029,3029,2416,2457,0,'[]','[]',600,2250,1500,2250,300,'[{202030031,1},{202030032,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000026,'树桩怪',0,6,0,'神格副本26关小怪Lv400',0,3,0,0,0,202033,'2','0',0,0,0,202033,0,'0',400,30,66946,6518516,36338,29821,3395,3395,2692,2737,0,'[]','[]',250,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000027,'藏宝蟹',0,6,0,'神格副本27关小怪Lv410',0,3,0,0,0,202031,'2','0',0,0,0,202031,0,'0',410,30,70871,6931571,38175,31515,3745,3745,2868,2928,0,'[]','[]',600,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000028,'哥布林',0,6,0,'神格副本28关小怪Lv420',0,3,0,0,0,202005,'2','0',0,0,0,202005,0,'0',420,30,74791,7344431,40012,33209,4094,4094,3045,3120,0,'[]','[]',250,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000029,'岩龟',0,6,0,'神格副本29关小怪Lv430',0,3,0,0,0,202007,'2','0',0,0,0,202007,0,'0',430,30,78704,7757033,41850,34903,4444,4444,3221,3312,0,'[]','[]',600,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000030,'寒冰女神',0,6,0,'神格副本30关bossLv440',0,3,0,0,0,203017,'1.5','0',0,0,0,203017,0,'0',440,30,82614,8169321,43687,36597,4793,4793,3397,3503,0,'[]','[]',250,2250,1500,2250,300,'[{2000540201,1},{2000540208,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000031,'树桩怪',0,6,0,'神格副本31关小怪Lv450',0,3,0,0,0,202033,'2','0',0,0,0,202033,0,'0',450,30,86514,8581250,45525,38291,5142,5142,3573,3695,0,'[]','[]',600,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000032,'火鸡骑士',0,6,0,'神格副本32关小怪Lv460',0,3,0,0,0,202034,'2','0',0,0,0,202034,0,'0',460,30,92265,9206582,48267,40880,5654,5654,3955,4100,0,'[]','[]',250,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000033,'藏宝蟹',0,6,0,'神格副本33关小怪Lv470',0,3,0,0,0,202031,'2','0',0,0,0,202031,0,'0',470,30,98017,9832010,51009,43470,6165,6165,4337,4505,0,'[]','[]',600,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000034,'藏宝蟹',0,6,0,'神格副本34关小怪Lv480',0,3,0,0,0,202031,'2','0',0,0,0,202031,0,'0',480,30,103769,10457660,53751,46060,6677,6677,4719,4910,0,'[]','[]',250,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000035,'八岐大蛇',0,6,0,'神格副本35关bossLv490',0,3,0,0,0,203024,'1.5','0',0,0,0,203024,0,'0',490,30,109519,11083706,56493,48649,7188,7188,5101,5315,0,'[]','[]',600,2250,1500,2250,300,'[{2000230201,1},{2000230202,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000036,'精锐枪兵',0,6,0,'神格副本36关小怪Lv500',0,3,0,0,0,202004,'2','0',0,0,0,202004,0,'0',500,30,115269,11709374,59234,51239,7700,7700,5483,5720,0,'[]','[]',250,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000037,'海蜥人',0,6,0,'神格副本37关小怪Lv510',0,3,0,0,0,202024,'2','0',0,0,0,202024,0,'0',510,30,121982,12437803,62350,54200,8739,8739,6118,6367,0,'[]','[]',600,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000038,'鲛人刺客',0,6,0,'神格副本38关小怪Lv520',0,3,0,0,0,202021,'2','0',0,0,0,202021,0,'0',520,30,128693,13166380,65466,57161,9778,9778,6753,7014,0,'[]','[]',250,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000039,'帝国士兵',0,6,0,'神格副本39关小怪Lv530',0,3,0,0,0,202017,'2','0',0,0,0,202017,0,'0',530,30,135401,13894610,68582,60123,10818,10818,7388,7661,0,'[]','[]',600,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000040,'愤怒',0,6,0,'神格副本40关bossLv540',0,3,0,0,0,203012,'1.5','0',0,0,0,203012,0,'0',540,30,142106,14623044,71698,63084,11857,11857,8023,8308,0,'[]','[]',250,2250,1500,2250,300,'[{202030121,1},{202030122,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000041,'叛军战士',0,6,0,'神格副本41关小怪Lv550',0,3,0,0,0,202012,'2','0',0,0,0,202012,0,'0',550,30,148805,15351229,74814,66045,12896,12896,8658,8955,0,'[]','[]',600,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000042,'岩龟',0,6,0,'神格副本42关小怪Lv560',0,3,0,0,0,202007,'2','0',0,0,0,202007,0,'0',560,30,155985,16129549,78157,69242,13653,13653,9059,9344,0,'[]','[]',250,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000043,'史莱姆',0,6,0,'神格副本43关小怪Lv570',0,3,0,0,0,202003,'2','0',0,0,0,202003,0,'0',570,30,163164,16907959,81499,72438,14409,14409,9459,9734,0,'[]','[]',600,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000044,'叛军战士',0,6,0,'神格副本44关小怪Lv580',0,3,0,0,0,202012,'2','0',0,0,0,202012,0,'0',580,30,170332,17685639,84842,75635,15165,15165,9859,10123,0,'[]','[]',250,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000045,'食人花',0,6,0,'神格副本45关bossLv590',0,3,0,0,0,203001,'1.5','0',0,0,0,203001,0,'0',590,30,177497,18463222,88184,78831,15922,15922,10260,10513,0,'[]','[]',600,2250,1500,2250,300,'[{202030011,1},{202030012,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000046,'白虎太郎',0,6,0,'神格副本46关小怪Lv600',0,3,0,0,0,202029,'2','0',0,0,0,202029,0,'0',600,30,184650,22243204,91527,82028,16678,16678,10660,10902,0,'[]','[]',250,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000047,'荒原狼',0,6,0,'神格副本47关小怪Lv610',0,3,0,0,0,202006,'2','0',0,0,0,202006,0,'0',610,30,192609,23238427,95477,85831,17592,17592,11349,11571,0,'[]','[]',250,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000048,'魔化机械',0,6,0,'神格副本48关小怪Lv620',0,3,0,0,0,202011,'2','0',0,0,0,202011,0,'0',620,30,200557,24233182,99428,89634,18506,18506,12038,12240,0,'[]','[]',600,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000049,'蜥蜴人',0,6,0,'神格副本49关小怪Lv630',0,3,0,0,0,202014,'2','0',0,0,0,202014,0,'0',630,30,208498,25227358,103379,93437,19420,19420,12727,12909,0,'[]','[]',250,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000050,'美杜莎',0,6,0,'神格副本50关bossLv640',0,3,0,0,0,203006,'1.5','0',0,0,0,203006,0,'0',640,30,216434,26220423,107329,97241,20335,20335,13416,13577,0,'[]','[]',250,2250,1500,2250,300,'[{2000230101,1},{2000230102,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000051,'骷髅战士',0,6,0,'神格副本51关小怪Lv650',0,3,0,0,0,202002,'2','0',0,0,0,202002,0,'0',650,30,224357,27213160,111280,101044,21249,21249,14106,14246,0,'[]','[]',600,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000052,'精锐枪兵',0,6,0,'神格副本52关小怪Lv660',0,3,0,0,0,202004,'2','0',0,0,0,202004,0,'0',660,30,234094,28453426,115376,105005,22081,22081,14501,14645,0,'[]','[]',250,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000053,'大嘴花',0,6,0,'神格副本53关小怪Lv670',0,3,0,0,0,202001,'2','0',0,0,0,202001,0,'0',670,30,243824,29693645,119472,108965,22913,22913,14897,15045,0,'[]','[]',250,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000054,'鲛人刺客',0,6,0,'神格副本54关小怪Lv680',0,3,0,0,0,202021,'2','0',0,0,0,202021,0,'0',680,30,253545,30932806,123568,112926,23745,23745,15293,15444,0,'[]','[]',600,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000055,'巴哈姆特',0,6,0,'神格副本55关bossLv690',0,3,0,0,0,203026,'1.5','0',0,0,0,203026,0,'0',690,30,263261,32171244,127663,116887,24577,24577,15689,15843,0,'[]','[]',250,2250,1500,2250,300,'[{202030261,1},{202030262,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000056,'鲛人刺客',0,6,0,'神格副本56关小怪Lv700',0,3,0,0,0,202021,'2','0',0,0,0,202021,0,'0',700,30,272962,33408864,131759,120848,25409,25409,16084,16242,0,'[]','[]',250,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000057,'海蜥人',0,6,0,'神格副本57关小怪Lv705',0,3,0,0,0,202024,'2','0',0,0,0,202024,0,'0',705,30,277389,33959099,133940,122957,25769,25769,16283,16425,0,'[]','[]',600,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000058,'废旧机器人',0,6,0,'神格副本58关小怪Lv710',0,3,0,0,0,202015,'2','0',0,0,0,202015,0,'0',710,30,281813,34509072,136121,125066,26130,26130,16481,16607,0,'[]','[]',250,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000059,'叛军战士',0,6,0,'神格副本59关小怪Lv715',0,3,0,0,0,202012,'2','0',0,0,0,202012,0,'0',715,30,286233,35058776,138302,127175,26490,26490,16679,16790,0,'[]','[]',250,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000060,'死神',0,6,0,'神格副本60关bossLv720',0,3,0,0,0,203018,'1.5','0',0,0,0,203018,0,'0',720,30,290651,35608204,140483,129284,26850,26850,16878,16972,0,'[]','[]',600,2250,1500,2250,300,'[{2000201801,1},{20005455,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000061,'哥布林',0,6,0,'神格副本61关小怪Lv725',0,3,0,0,0,202005,'2','0',0,0,0,202005,0,'0',725,30,295066,36157351,142664,131393,27211,27211,17076,17155,0,'[]','[]',250,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000062,'废旧机器人',0,6,0,'神格副本62关小怪Lv730',0,3,0,0,0,202015,'2','0',0,0,0,202015,0,'0',730,30,299477,36706211,144845,133502,27571,27571,17274,17337,0,'[]','[]',250,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000063,'树桩怪',0,6,0,'神格副本63关小怪Lv735',0,3,0,0,0,202033,'2','0',0,0,0,202033,0,'0',735,30,303885,37254780,147026,135611,27932,27932,17472,17520,0,'[]','[]',600,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000064,'鲛人士兵',0,6,0,'神格副本64关小怪Lv740',0,3,0,0,0,202020,'2','0',0,0,0,202020,0,'0',740,30,308290,37803052,149207,137720,28292,28292,17671,17702,0,'[]','[]',250,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000065,'熔岩之魂',0,6,0,'神格副本65关bossLv745',0,3,0,0,0,203025,'1.5','0',0,0,0,203025,0,'0',745,30,312691,38351023,151388,139829,28653,28653,17869,17885,0,'[]','[]',250,2250,1500,2250,300,'[{202030251,1},{202030252,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000066,'烈焰蝎',0,6,0,'神格副本66关小怪Lv750',0,3,0,0,0,202013,'2','0',0,0,0,202013,0,'0',750,30,317089,38898689,153569,141938,29013,29013,18067,18067,0,'[]','[]',600,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000067,'蜥蜴人',0,6,0,'神格副本67关小怪Lv755',0,3,0,0,0,202014,'2','0',0,0,0,202014,0,'0',755,30,321916,39498344,156092,144391,29378,29378,18441,18441,0,'[]','[]',250,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000068,'哥布林',0,6,0,'神格副本68关小怪Lv760',0,3,0,0,0,202005,'2','0',0,0,0,202005,0,'0',760,30,326745,40097254,158614,146845,29742,29742,18814,18814,0,'[]','[]',250,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000069,'帝国士兵',0,6,0,'神格副本69关小怪Lv765',0,3,0,0,0,202017,'2','0',0,0,0,202017,0,'0',765,30,331565,40695875,161137,149299,30107,30107,19188,19188,0,'[]','[]',600,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000070,'嫉妒',0,6,0,'神格副本70关bossLv770',0,3,0,0,0,203011,'1.5','0',0,0,0,203011,0,'0',770,30,336387,41294200,163659,151753,30471,30471,19561,19561,0,'[]','[]',250,2250,1500,2250,300,'[{200022021,1},{200022022,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000071,'魔化难民',0,6,0,'神格副本71关小怪Lv775',0,3,0,0,0,202010,'2','0',0,0,0,202010,0,'0',775,30,341202,41892684,166182,154206,30836,30836,19935,19935,0,'[]','[]',250,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000072,'火鸡骑士',0,6,0,'神格副本72关小怪Lv780',0,3,0,0,0,202034,'2','0',0,0,0,202034,0,'0',780,30,346017,42490399,168704,156660,31200,31200,20308,20308,0,'[]','[]',600,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000073,'哥布林',0,6,0,'神格副本73关小怪Lv785',0,3,0,0,0,202005,'2','0',0,0,0,202005,0,'0',785,30,350829,43087802,171226,159114,31565,31565,20682,20682,0,'[]','[]',250,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000074,'白虎太郎',0,6,0,'神格副本74关小怪Lv790',0,3,0,0,0,202029,'2','0',0,0,0,202029,0,'0',790,30,355633,43684888,173749,161568,31929,31929,21055,21055,0,'[]','[]',250,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000075,'冰霜泰坦',0,6,0,'神格副本75关bossLv795',0,3,0,0,0,203003,'1.5','0',0,0,0,203003,0,'0',795,30,360438,44282113,176271,164021,32294,32294,21429,21429,0,'[]','[]',600,2250,1500,2250,300,'[{202030031,1},{202030032,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000076,'树桩怪',0,6,0,'神格副本76关小怪Lv800',0,3,0,0,0,202033,'2','0',0,0,0,202033,0,'0',800,30,365234,51506185,178794,166475,32658,32658,21803,21803,0,'[]','[]',250,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000077,'藏宝蟹',0,6,0,'神格副本77关小怪Lv800',0,3,0,0,0,202031,'2','0',0,0,0,202031,0,'0',800,30,377566,53193899,184158,171469,33638,33638,22457,22457,0,'[]','[]',250,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000078,'哥布林',0,6,0,'神格副本78关小怪Lv800',0,3,0,0,0,202005,'2','0',0,0,0,202005,0,'0',800,30,390344,54938514,189683,176614,34647,34647,23131,23131,0,'[]','[]',600,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000079,'岩龟',0,6,0,'神格副本79关小怪Lv800',0,3,0,0,0,202007,'2','0',0,0,0,202007,0,'0',800,30,403586,56742853,195373,181912,35686,35686,23824,23824,0,'[]','[]',250,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000080,'寒冰女神',0,6,0,'神格副本80关bossLv800',0,3,0,0,0,203017,'1.5','0',0,0,0,203017,0,'0',800,30,417303,58608945,201235,187369,36756,36756,24539,24539,0,'[]','[]',250,2250,1500,2250,300,'[{2000540201,1},{2000540208,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000081,'树桩怪',0,6,0,'神格副本81关小怪Lv800',0,3,0,0,0,202033,'2','0',0,0,0,202033,0,'0',800,30,431521,60537688,207272,192991,37859,37859,25275,25275,0,'[]','[]',600,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000082,'火鸡骑士',0,6,0,'神格副本82关小怪Lv800',0,3,0,0,0,202034,'2','0',0,0,0,202034,0,'0',800,30,446254,62532705,213490,198780,38996,38996,26033,26033,0,'[]','[]',250,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000083,'藏宝蟹',0,6,0,'神格副本83关小怪Lv800',0,3,0,0,0,202031,'2','0',0,0,0,202031,0,'0',800,30,461525,64595630,219895,204743,40165,40165,26814,26814,0,'[]','[]',250,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000084,'藏宝蟹',0,6,0,'神格副本84关小怪Lv800',0,3,0,0,0,202031,'2','0',0,0,0,202031,0,'0',800,30,477360,66728676,226491,210886,41370,41370,27618,27618,0,'[]','[]',600,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000085,'八岐大蛇',0,6,0,'神格副本85关bossLv800',0,3,0,0,0,203024,'1.5','0',0,0,0,203024,0,'0',800,30,493765,68934547,233286,217213,42610,42610,28447,28447,0,'[]','[]',250,2250,1500,2250,300,'[{2000230201,1},{2000230202,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000086,'精锐枪兵',0,6,0,'神格副本86关小怪Lv800',0,3,0,0,0,202004,'2','0',0,0,0,202004,0,'0',800,30,510781,71215770,240284,223729,43889,43889,29300,29300,0,'[]','[]',250,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000087,'海蜥人',0,6,0,'神格副本87关小怪Lv800',0,3,0,0,0,202024,'2','0',0,0,0,202024,0,'0',800,30,528416,73574625,247493,230441,45206,45206,30179,30179,0,'[]','[]',600,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000088,'鲛人刺客',0,6,0,'神格副本88关小怪Lv800',0,3,0,0,0,202021,'2','0',0,0,0,202021,0,'0',800,30,546705,76014168,254918,237354,46562,46562,31084,31084,0,'[]','[]',250,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000089,'帝国士兵',0,6,0,'神格副本89关小怪Lv800',0,3,0,0,0,202017,'2','0',0,0,0,202017,0,'0',800,30,565664,78536993,262566,244474,47959,47959,32017,32017,0,'[]','[]',250,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000090,'愤怒',0,6,0,'神格副本90关bossLv800',0,3,0,0,0,203012,'1.5','0',0,0,0,203012,0,'0',800,30,585330,81145839,270443,251808,49397,49397,32977,32977,0,'[]','[]',600,2250,1500,2250,300,'[{202030121,1},{202030122,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000091,'叛军战士',0,6,0,'神格副本91关小怪Lv800',0,3,0,0,0,202012,'2','0',0,0,0,202012,0,'0',800,30,605722,83843988,278556,259362,50879,50879,33966,33966,0,'[]','[]',250,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000092,'岩龟',0,6,0,'神格副本92关小怪Lv800',0,3,0,0,0,202007,'2','0',0,0,0,202007,0,'0',800,30,626873,86633566,286913,267143,52406,52406,34986,34986,0,'[]','[]',250,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000093,'史莱姆',0,6,0,'神格副本93关小怪Lv800',0,3,0,0,0,202003,'2','0',0,0,0,202003,0,'0',800,30,648808,89518702,295520,275157,53978,53978,36035,36035,0,'[]','[]',600,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000094,'叛军战士',0,6,0,'神格副本94关小怪Lv800',0,3,0,0,0,202012,'2','0',0,0,0,202012,0,'0',800,30,671556,92501826,304386,283412,55598,55598,37117,37117,0,'[]','[]',250,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000095,'食人花',0,6,0,'神格副本95关bossLv800',0,3,0,0,0,203001,'1.5','0',0,0,0,203001,0,'0',800,30,695159,95587282,313517,291914,57266,57266,38230,38230,0,'[]','[]',250,2250,1500,2250,300,'[{202030011,1},{202030012,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000096,'白虎太郎',0,6,0,'神格副本96关小怪Lv800',0,3,0,0,0,202029,'2','0',0,0,0,202029,0,'0',800,30,719641,98777670,322923,300671,58984,58984,39377,39377,0,'[]','[]',600,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000097,'荒原狼',0,6,0,'神格副本97关小怪Lv800',0,3,0,0,0,202006,'2','0',0,0,0,202006,0,'0',800,30,745040,102076848,332611,309691,60753,60753,40557,40557,0,'[]','[]',250,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000098,'魔化机械',0,6,0,'神格副本98关小怪Lv800',0,3,0,0,0,202011,'2','0',0,0,0,202011,0,'0',800,30,771388,105488138,342590,318982,62577,62577,41774,41774,0,'[]','[]',250,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000099,'蜥蜴人',0,6,0,'神格副本99关小怪Lv800',0,3,0,0,0,202014,'2','0',0,0,0,202014,0,'0',800,30,798725,109015152,352868,328552,64454,64454,43027,43027,0,'[]','[]',600,2250,1500,2250,300,'[{1110000001,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000100,'美杜莎',0,6,0,'神格副本100关bossLv800',0,3,0,0,0,203006,'1.5','0',0,0,0,203006,0,'0',800,30,827087,112662684,363454,338408,66387,66387,44318,44318,0,'[]','[]',250,2250,1500,2250,300,'[{2000230101,1},{2000230102,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000101,'雪原企鹅',0,6,0,'神格副本废弃101关49层2号小怪',0,3,0,0,0,202009,'1','0',0,0,0,202009,0,'0',586,30,38556,4775380,20605,18442,6388,6388,3605,3605,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000102,'愤怒',0,6,0,'神格副本废弃102关49层3号boss',0,3,0,0,0,203012,'1','0',0,0,0,203012,0,'0',590,30,39676,4917114,21245,19009,6572,6572,3701,3701,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{202030121,1},{202030122,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000103,'岩龟',0,6,0,'神格副本废弃103关50层1号小怪',0,3,0,0,0,202007,'1','0',0,0,0,202007,0,'0',593,30,40518,5023492,21724,19434,6711,6711,3773,3773,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000104,'魔化难民',0,6,0,'神格副本废弃104关50层2号小怪',0,3,0,0,0,202017,'1','0',0,0,0,202017,0,'0',596,30,41359,5129904,22204,19859,6849,6849,3845,3845,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000105,'八岐大蛇',0,6,0,'神格副本废弃105关50层3号boss',0,3,0,0,0,203024,'1','0',0,0,0,203024,0,'0',600,30,42482,6094702,22843,20426,7033,7033,3941,3941,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{2000230201,1},{2000230202,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000106,'岩龟',0,6,0,'神格副本废弃106关51层1号小怪',0,3,0,0,0,202007,'1','0',0,0,0,202007,0,'0',602,30,43206,6199472,23208,20756,7178,7178,4004,4004,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000107,'岩龟',0,6,0,'神格副本废弃107关51层2号小怪',0,3,0,0,0,202007,'1','0',0,0,0,202007,0,'0',604,30,43931,6304276,23572,21086,7323,7323,4067,4067,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000108,'魔化难民',0,6,0,'神格副本废弃108关51层3号小怪',0,3,0,0,0,202017,'1','0',0,0,0,202017,0,'0',607,30,45019,6461545,24119,21581,7540,7540,4162,4162,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000109,'八岐大蛇',0,6,0,'神格副本废弃109关51层4号boss',0,3,0,0,0,203024,'1','0',0,0,0,203024,0,'0',610,30,46107,6618707,24666,22077,7758,7758,4256,4256,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{2000230201,1},{2000230202,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000110,'冰岩怪',0,6,0,'神格副本废弃110关52层1号小怪',0,3,0,0,0,202010,'1','0',0,0,0,202010,0,'0',612,30,46832,6723638,25031,22407,7902,7902,4320,4320,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000111,'雪原企鹅',0,6,0,'神格副本废弃111关52层2号小怪',0,3,0,0,0,202009,'1','0',0,0,0,202009,0,'0',614,30,47559,6828599,25395,22737,8047,8047,4383,4383,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000112,'哥布林',0,6,0,'神格副本废弃112关52层3号小怪',0,3,0,0,0,202005,'1','0',0,0,0,202005,0,'0',617,30,48648,6985911,25942,23233,8265,8265,4477,4477,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000113,'八岐大蛇',0,6,0,'神格副本废弃113关52层4号boss',0,3,0,0,0,203024,'1','0',0,0,0,203024,0,'0',620,30,49738,7143466,26489,23728,8482,8482,4572,4572,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{2000230201,1},{2000230202,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000114,'森林狼',0,6,0,'神格副本废弃114关53层1号小怪',0,3,0,0,0,202006,'1','0',0,0,0,202006,0,'0',622,30,50464,7248536,26854,24058,8627,8627,4635,4635,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000115,'蜥蜴人',0,6,0,'神格副本废弃115关53层2号小怪',0,3,0,0,0,202014,'1','0',0,0,0,202014,0,'0',624,30,51191,7353443,27219,24389,8772,8772,4698,4698,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000116,'雪原企鹅',0,6,0,'神格副本废弃116关53层3号小怪',0,3,0,0,0,202009,'1','0',0,0,0,202009,0,'0',627,30,52281,7511131,27766,24884,8989,8989,4793,4793,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000117,'冰霜巨龙',0,6,0,'神格副本废弃117关53层4号boss',0,3,0,0,0,203004,'1','0',0,0,0,203004,0,'0',630,30,53374,7668872,28312,25379,9207,9207,4888,4888,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{202030041,1},{202030043,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000118,'哥布林',0,6,0,'神格副本废弃118关54层1号小怪',0,3,0,0,0,202005,'1','0',0,0,0,202005,0,'0',632,30,54101,7773868,28677,25710,9352,9352,4951,4951,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000119,'哥布林',0,6,0,'神格副本废弃119关54层2号小怪',0,3,0,0,0,202005,'1','0',0,0,0,202005,0,'0',634,30,54829,7879077,29042,26040,9497,9497,5014,5014,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000120,'雪原企鹅',0,6,0,'神格副本废弃120关54层3号小怪',0,3,0,0,0,202009,'1','0',0,0,0,202009,0,'0',637,30,55921,8036932,29589,26535,9714,9714,5109,5109,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000121,'蜘蛛女皇',0,6,0,'神格副本废弃121关54层4号boss',0,3,0,0,0,203011,'1','0',0,0,0,203011,0,'0',640,30,57013,8194632,30136,27031,9931,9931,5204,5204,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{200022021,1},{200022022,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000122,'冰岩怪',0,6,0,'神格副本废弃122关55层1号小怪',0,3,0,0,0,202010,'1','0',0,0,0,202010,0,'0',642,30,57743,8299921,30500,27361,10076,10076,5267,5267,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000123,'叛变佣兵',0,6,0,'神格副本废弃123关55层2号小怪',0,3,0,0,0,202012,'1','0',0,0,0,202012,0,'0',644,30,58471,8405229,30865,27691,10221,10221,5330,5330,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000124,'蜥蜴人',0,6,0,'神格副本废弃124关55层3号小怪',0,3,0,0,0,202014,'1','0',0,0,0,202014,0,'0',647,30,59564,8563020,31412,28187,10439,10439,5425,5425,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000125,'蜘蛛女皇',0,6,0,'神格副本废弃125关55层4号boss',0,3,0,0,0,203011,'1','0',0,0,0,203011,0,'0',650,30,60658,8721051,31959,28682,10656,10656,5520,5520,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{200022021,1},{200022022,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000126,'魔化难民',0,6,0,'神格副本废弃126关56层1号小怪',0,3,0,0,0,202017,'1','0',0,0,0,202017,0,'0',652,30,61745,8879019,32376,29054,11021,11021,5684,5684,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000127,'魔化藏宝蟹',0,6,0,'神格副本废弃127关56层2号小怪',0,3,0,0,0,202022,'1','0',0,0,0,202022,0,'0',654,30,62831,9036825,32794,29427,11385,11385,5849,5849,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000128,'魔化机械',0,6,0,'神格副本废弃128关56层3号小怪',0,3,0,0,0,202018,'1','0',0,0,0,202018,0,'0',657,30,64462,9273931,33420,29985,11932,11932,6095,6095,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000129,'阿努比斯',0,6,0,'神格副本废弃129关56层4号boss',0,3,0,0,0,203005,'1','0',0,0,0,203005,0,'0',660,30,66094,9510920,34046,30544,12479,12479,6342,6342,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{202030051,1},{202030052,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000130,'岩龟',0,6,0,'神格副本废弃130关57层1号小怪',0,3,0,0,0,202007,'1','0',0,0,0,202007,0,'0',662,30,67181,9669108,34464,30916,12844,12844,6507,6507,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000131,'魔化机械',0,6,0,'神格副本废弃131关57层2号小怪',0,3,0,0,0,202018,'1','0',0,0,0,202018,0,'0',664,30,68271,9827337,34881,31288,13208,13208,6671,6671,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000132,'森林狼',0,6,0,'神格副本废弃132关57层3号小怪',0,3,0,0,0,202006,'1','0',0,0,0,202006,0,'0',667,30,69903,10064532,35508,31847,13755,13755,6918,6918,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000133,'冰霜泰坦',0,6,0,'神格副本废弃133关57层4号boss',0,3,0,0,0,203003,'1','0',0,0,0,203003,0,'0',670,30,71537,10302034,36134,32405,14302,14302,7165,7165,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{202030031,1},{202030032,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000134,'叛变佣兵',0,6,0,'神格副本废弃134关58层1号小怪',0,3,0,0,0,202012,'1','0',0,0,0,202012,0,'0',672,30,72628,10460415,36551,32777,14666,14666,7329,7329,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000135,'魔化机械',0,6,0,'神格副本废弃135关58层2号小怪',0,3,0,0,0,202018,'1','0',0,0,0,202018,0,'0',674,30,73717,10618601,36969,33150,15031,15031,7494,7494,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000136,'冰岩怪',0,6,0,'神格副本废弃136关58层3号小怪',0,3,0,0,0,202010,'1','0',0,0,0,202010,0,'0',677,30,75353,10856288,37595,33708,15578,15578,7740,7740,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000137,'巴哈姆特',0,6,0,'神格副本废弃137关58层4号boss',0,3,0,0,0,203026,'1','0',0,0,0,203026,0,'0',680,30,76990,11093812,38221,34267,16125,16125,7987,7987,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{202030261,1},{202030262,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000138,'魔化傀儡',0,6,0,'神格副本废弃138关59层1号小怪',0,3,0,0,0,202015,'1','0',0,0,0,202015,0,'0',682,30,78080,11252357,38639,34639,16489,16489,8152,8152,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000139,'岩龟',0,6,0,'神格副本废弃139关59层2号小怪',0,3,0,0,0,202007,'1','0',0,0,0,202007,0,'0',684,30,79172,11410933,39056,35011,16854,16854,8316,8316,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000140,'蜥蜴人',0,6,0,'神格副本废弃140关59层3号小怪',0,3,0,0,0,202014,'1','0',0,0,0,202014,0,'0',687,30,80808,11648610,39683,35570,17401,17401,8563,8563,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000141,'冰霜泰坦',0,6,0,'神格副本废弃141关59层4号boss',0,3,0,0,0,203003,'1','0',0,0,0,203003,0,'0',690,30,82447,11886589,40309,36128,17948,17948,8810,8810,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{202030031,1},{202030032,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000142,'魔化机械',0,6,0,'神格副本废弃142关60层1号小怪',0,3,0,0,0,202018,'1','0',0,0,0,202018,0,'0',692,30,83540,12045276,40726,36500,18312,18312,8974,8974,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000143,'魔化难民',0,6,0,'神格副本废弃143关60层2号小怪',0,3,0,0,0,202017,'1','0',0,0,0,202017,0,'0',694,30,84632,12203741,41144,36873,18677,18677,9139,9139,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000144,'森林狼',0,6,0,'神格副本废弃144关60层3号小怪',0,3,0,0,0,202006,'1','0',0,0,0,202006,0,'0',697,30,86271,12441855,41770,37431,19224,19224,9385,9385,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000145,'寒冰女神',0,6,0,'神格副本废弃145关60层4号boss',0,3,0,0,0,203017,'1','0',0,0,0,203017,0,'0',700,30,87912,12680023,42396,37989,19770,19770,9632,9632,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{2000540201,1},{2000540208,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000146,'叛变佣兵',0,6,0,'神格副本废弃146关61层1号小怪',0,3,0,0,0,202012,'1','0',0,0,0,202012,0,'0',702,30,89251,12873289,43117,38651,20095,20095,9816,9816,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000147,'岩龟',0,6,0,'神格副本废弃147关61层2号小怪',0,3,0,0,0,202007,'1','0',0,0,0,202007,0,'0',704,30,90593,13066901,43837,39312,20420,20420,10001,10001,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000148,'冰岩怪',0,6,0,'神格副本废弃148关61层3号小怪',0,3,0,0,0,202010,'1','0',0,0,0,202010,0,'0',707,30,92608,13357361,44917,40304,20908,20908,10277,10277,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000149,'光明神',0,6,0,'神格副本废弃149关61层4号boss',0,3,0,0,0,203021,'1','0',0,0,0,203021,0,'0',710,30,94625,13648279,45997,41295,21395,21395,10554,10554,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{2000202101,1},{200054200,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000150,'冰岩怪',0,6,0,'神格副本废弃150关62层1号小怪',0,3,0,0,0,202010,'1','0',0,0,0,202010,0,'0',712,30,95970,13841981,46717,41957,21720,21720,10738,10738,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000151,'蜥蜴人',0,6,0,'神格副本废弃151关62层2号小怪',0,3,0,0,0,202014,'1','0',0,0,0,202014,0,'0',714,30,97316,14036027,47437,42618,22045,22045,10922,10922,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000152,'哥布林',0,6,0,'神格副本废弃152关62层3号小怪',0,3,0,0,0,202005,'1','0',0,0,0,202005,0,'0',717,30,99336,14327380,48517,43609,22532,22532,11199,11199,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000153,'迦楼罗',0,6,0,'神格副本废弃153关62层4号boss',0,3,0,0,0,203020,'1','0',0,0,0,203020,0,'0',720,30,101358,14618639,49597,44601,23020,23020,11475,11475,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{202030201,1},{202030202,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000154,'魔化藏宝蟹',0,6,0,'神格副本废弃154关63层1号小怪',0,3,0,0,0,202022,'1','0',0,0,0,202022,0,'0',722,30,102704,14812995,50318,45262,23345,23345,11659,11659,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000155,'冰岩怪',0,6,0,'神格副本废弃155关63层2号小怪',0,3,0,0,0,202010,'1','0',0,0,0,202010,0,'0',724,30,104054,15007148,51038,45924,23670,23670,11844,11844,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000156,'叛变佣兵',0,6,0,'神格副本废弃156关63层3号小怪',0,3,0,0,0,202012,'1','0',0,0,0,202012,0,'0',727,30,106079,15299057,52118,46915,24157,24157,12120,12120,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000157,'巴哈姆特',0,6,0,'神格副本废弃157关63层4号boss',0,3,0,0,0,203026,'1','0',0,0,0,203026,0,'0',730,30,108105,15590841,53198,47907,24645,24645,12397,12397,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{202030261,1},{202030262,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000158,'魔化藏宝蟹',0,6,0,'神格副本废弃158关64层1号小怪',0,3,0,0,0,202022,'1','0',0,0,0,202022,0,'0',732,30,109456,15785537,53918,48568,24969,24969,12581,12581,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000159,'叛变佣兵',0,6,0,'神格副本废弃159关64层2号小怪',0,3,0,0,0,202012,'1','0',0,0,0,202012,0,'0',734,30,110809,15980295,54638,49229,25294,25294,12765,12765,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000160,'魔化藏宝蟹',0,6,0,'神格副本废弃160关64层3号小怪',0,3,0,0,0,202022,'1','0',0,0,0,202022,0,'0',737,30,112838,16272406,55718,50221,25782,25782,13042,13042,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000161,'美杜莎',0,6,0,'神格副本废弃161关64层4号boss',0,3,0,0,0,203006,'1','0',0,0,0,203006,0,'0',740,30,114868,16564646,56798,51213,26269,26269,13318,13318,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{2000230101,1},{2000230102,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000162,'雪原企鹅',0,6,0,'神格副本废弃162关65层1号小怪',0,3,0,0,0,202009,'1','0',0,0,0,202009,0,'0',742,30,116220,16759638,57519,51874,26594,26594,13502,13502,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000163,'岩龟',0,6,0,'神格副本废弃163关65层2号小怪',0,3,0,0,0,202007,'1','0',0,0,0,202007,0,'0',744,30,117574,16954684,58239,52535,26919,26919,13687,13687,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000164,'冰岩怪',0,6,0,'神格副本废弃164关65层3号小怪',0,3,0,0,0,202010,'1','0',0,0,0,202010,0,'0',747,30,119607,17247207,59319,53527,27406,27406,13963,13963,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000165,'月神',0,6,0,'神格副本废弃165关65层4号boss',0,3,0,0,0,203022,'1','0',0,0,0,203022,0,'0',750,30,121641,17539841,60399,54519,27894,27894,14240,14240,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{2000540401,1},{2000540402,1},{2000540406,1},{2000540410,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000166,'岩龟',0,6,0,'神格副本废弃166关66层1号小怪',0,3,0,0,0,202007,'1','0',0,0,0,202007,0,'0',752,30,123000,17731551,61147,55191,28175,28175,14378,14378,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000167,'哥布林',0,6,0,'神格副本废弃167关66层2号小怪',0,3,0,0,0,202005,'1','0',0,0,0,202005,0,'0',754,30,124360,17923307,61895,55863,28455,28455,14517,14517,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000168,'雪原企鹅',0,6,0,'神格副本废弃168关66层3号小怪',0,3,0,0,0,202009,'1','0',0,0,0,202009,0,'0',757,30,126398,18210726,63018,56872,28876,28876,14726,14726,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000169,'半人马',0,6,0,'神格副本废弃169关66层4号boss',0,3,0,0,0,203002,'1','0',0,0,0,203002,0,'0',760,30,128440,18498535,64140,57880,29297,29297,14934,14934,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{200022011,1},{200022014,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000170,'魔化机械',0,6,0,'神格副本废弃170关67层1号小怪',0,3,0,0,0,202018,'1','0',0,0,0,202018,0,'0',762,30,129801,18690459,64888,58552,29578,29578,15073,15073,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000171,'叛变佣兵',0,6,0,'神格副本废弃171关67层2号小怪',0,3,0,0,0,202012,'1','0',0,0,0,202012,0,'0',764,30,131163,18882422,65636,59224,29858,29858,15212,15212,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000172,'森林狼',0,6,0,'神格副本废弃172关67层3号小怪',0,3,0,0,0,202006,'1','0',0,0,0,202006,0,'0',767,30,133206,19170134,66758,60233,30279,30279,15420,15420,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000173,'月神',0,6,0,'神格副本废弃173关67层4号boss',0,3,0,0,0,203022,'1','0',0,0,0,203022,0,'0',770,30,135248,19458227,67881,61241,30700,30700,15628,15628,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{2000540401,1},{2000540402,1},{2000540406,1},{2000540410,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000174,'岩龟',0,6,0,'神格副本废弃174关68层1号小怪',0,3,0,0,0,202007,'1','0',0,0,0,202007,0,'0',772,30,136612,19650332,68629,61913,30981,30981,15767,15767,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000175,'岩龟',0,6,0,'神格副本废弃175关68层2号小怪',0,3,0,0,0,202007,'1','0',0,0,0,202007,0,'0',774,30,137975,19842470,69377,62585,31261,31261,15906,15906,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000176,'魔化傀儡',0,6,0,'神格副本废弃176关68层3号小怪',0,3,0,0,0,202015,'1','0',0,0,0,202015,0,'0',777,30,140021,20130428,70499,63594,31682,31682,16115,16115,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000177,'半人马',0,6,0,'神格副本废弃177关68层4号boss',0,3,0,0,0,203002,'1','0',0,0,0,203002,0,'0',780,30,142068,20418759,71621,64602,32103,32103,16323,16323,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{200022011,1},{200022014,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000178,'岩龟',0,6,0,'神格副本废弃178关69层1号小怪',0,3,0,0,0,202007,'1','0',0,0,0,202007,0,'0',782,30,143430,20611016,72370,65274,32384,32384,16462,16462,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000179,'魔化机械',0,6,0,'神格副本废弃179关69层2号小怪',0,3,0,0,0,202018,'1','0',0,0,0,202018,0,'0',784,30,144795,20802988,73118,65947,32665,32665,16601,16601,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000180,'魔化傀儡',0,6,0,'神格副本废弃180关69层3号小怪',0,3,0,0,0,202015,'1','0',0,0,0,202015,0,'0',787,30,146843,21091461,74240,66955,33086,33086,16809,16809,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000181,'怠惰',0,6,0,'神格副本废弃181关69层4号boss',0,3,0,0,0,203013,'1','0',0,0,0,203013,0,'0',790,30,148892,21379988,75362,67963,33507,33507,17017,17017,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{202030131,1},{202030132,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000182,'森林狼',0,6,0,'神格副本废弃182关70层1号小怪',0,3,0,0,0,202006,'1','0',0,0,0,202006,0,'0',792,30,150258,21572369,76110,68635,33787,33787,17156,17156,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000183,'哥布林',0,6,0,'神格副本废弃183关70层2号小怪',0,3,0,0,0,202005,'1','0',0,0,0,202005,0,'0',794,30,151624,21764457,76858,69308,34068,34068,17295,17295,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000184,'哥布林',0,6,0,'神格副本废弃184关70层3号小怪',0,3,0,0,0,202005,'1','0',0,0,0,202005,0,'0',797,30,153671,22053099,77981,70316,34489,34489,17503,17503,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000185,'死神',0,6,0,'神格副本废弃185关70层4号boss',0,3,0,0,0,203018,'1','0',0,0,0,203018,0,'0',800,30,155722,25641205,79103,71324,34910,34910,17712,17712,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{2000201801,1},{20005455,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000186,'蜥蜴人',0,6,0,'神格副本废弃186关71层1号小怪',0,3,0,0,0,202014,'1','0',0,0,0,202014,0,'0',801,30,156400,25747989,79512,71684,35103,35103,17868,17868,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000187,'叛变佣兵',0,6,0,'神格副本废弃187关71层2号小怪',0,3,0,0,0,202012,'1','0',0,0,0,202012,0,'0',802,30,157081,25854779,79920,72044,35296,35296,18023,18023,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000188,'雪原企鹅',0,6,0,'神格副本废弃188关71层3号小怪',0,3,0,0,0,202009,'1','0',0,0,0,202009,0,'0',803,30,157760,25961573,80329,72404,35489,35489,18179,18179,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000189,'暗裔猎手',0,6,0,'神格副本废弃189关71层4号boss',0,3,0,0,0,203011,'1','0',0,0,0,203011,0,'0',804,30,158441,26068373,80737,72764,35683,35683,18335,18335,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{200022021,1},{200022022,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000190,'冰岩怪',0,6,0,'神格副本废弃190关72层1号小怪',0,3,0,0,0,202010,'1','0',0,0,0,202010,0,'0',805,30,159119,26175177,81146,73124,35876,35876,18491,18491,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000191,'雪原企鹅',0,6,0,'神格副本废弃191关72层2号小怪',0,3,0,0,0,202009,'1','0',0,0,0,202009,0,'0',806,30,159800,26281618,81554,73485,36069,36069,18647,18647,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000192,'魔化难民',0,6,0,'神格副本废弃192关72层3号小怪',0,3,0,0,0,202017,'1','0',0,0,0,202017,0,'0',807,30,160479,26388430,81963,73845,36262,36262,18803,18803,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000193,'嫉妒',0,6,0,'神格副本废弃193关72层4号boss',0,3,0,0,0,203014,'1','0',0,0,0,203014,0,'0',808,30,161161,26495247,82371,74205,36456,36456,18958,18958,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{202030141,1},{202030142,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000194,'冰岩怪',0,6,0,'神格副本废弃194关73层1号小怪',0,3,0,0,0,202010,'1','0',0,0,0,202010,0,'0',809,30,161839,26602068,82780,74565,36649,36649,19114,19114,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000195,'魔化傀儡',0,6,0,'神格副本废弃195关73层2号小怪',0,3,0,0,0,202015,'1','0',0,0,0,202015,0,'0',810,30,162518,26708893,83189,74925,36842,36842,19270,19270,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000196,'魔化傀儡',0,6,0,'神格副本废弃196关73层3号小怪',0,3,0,0,0,202015,'1','0',0,0,0,202015,0,'0',811,30,163200,26815722,83597,75285,37035,37035,19426,19426,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000197,'海龙王',0,6,0,'神格副本废弃197关73层4号boss',0,3,0,0,0,203009,'1','0',0,0,0,203009,0,'0',812,30,163879,26922554,84006,75645,37229,37229,19582,19582,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{202030091,1},{202030092,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000198,'哥布林',0,6,0,'神格副本废弃198关74层1号小怪',0,3,0,0,0,202005,'1','0',0,0,0,202005,0,'0',813,30,164560,27029391,84414,76005,37422,37422,19737,19737,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000199,'岩龟',0,6,0,'神格副本废弃199关74层2号小怪',0,3,0,0,0,202007,'1','0',0,0,0,202007,0,'0',814,30,165239,27136230,84823,76365,37615,37615,19893,19893,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000200,'魔化藏宝蟹',0,6,0,'神格副本废弃200关74层3号小怪',0,3,0,0,0,202022,'1','0',0,0,0,202022,0,'0',815,30,165921,27243074,85231,76725,37808,37808,20049,20049,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000201,'半人马',0,6,0,'神格副本废弃201关74层4号boss',0,3,0,0,0,203002,'1','0',0,0,0,203002,0,'0',816,30,166600,27349920,85640,77085,38002,38002,20205,20205,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{200022011,1},{200022014,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000202,'魔化藏宝蟹',0,6,0,'神格副本废弃202关75层1号小怪',0,3,0,0,0,202022,'1','0',0,0,0,202022,0,'0',817,30,167279,27456770,86049,77445,38195,38195,20361,20361,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000203,'魔化机械',0,6,0,'神格副本废弃203关75层2号小怪',0,3,0,0,0,202018,'1','0',0,0,0,202018,0,'0',818,30,167961,27563623,86457,77805,38388,38388,20517,20517,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000204,'魔化藏宝蟹',0,6,0,'神格副本废弃204关75层3号小怪',0,3,0,0,0,202022,'1','0',0,0,0,202022,0,'0',819,30,168640,27670479,86866,78165,38581,38581,20672,20672,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000205,'熔岩战神',0,6,0,'神格副本废弃205关75层4号boss',0,3,0,0,0,203025,'1','0',0,0,0,203025,0,'0',820,30,169322,27777337,87274,78525,38775,38775,20828,20828,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{202030251,1},{202030252,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000206,'蜥蜴人',0,6,0,'神格副本废弃206关76层1号小怪',0,3,0,0,0,202014,'1','0',0,0,0,202014,0,'0',821,30,170002,27884199,87683,78885,38968,38968,20984,20984,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000207,'魔化藏宝蟹',0,6,0,'神格副本废弃207关76层2号小怪',0,3,0,0,0,202022,'1','0',0,0,0,202022,0,'0',822,30,170684,27991063,88091,79245,39161,39161,21140,21140,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000208,'哥布林',0,6,0,'神格副本废弃208关76层3号小怪',0,3,0,0,0,202005,'1','0',0,0,0,202005,0,'0',823,30,171363,28097930,88500,79605,39354,39354,21296,21296,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000209,'蜥蜴人',0,6,0,'神格副本废弃209关76层4号小怪',0,3,0,0,0,202014,'1','0',0,0,0,202014,0,'0',824,30,172043,28204799,88909,79965,39548,39548,21451,21451,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000210,'冰霜泰坦',0,6,0,'神格副本废弃210关76层5号boss',0,3,0,0,0,203003,'1','0',0,0,0,203003,0,'0',825,30,172725,28311670,89317,80325,39741,39741,21607,21607,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{202030031,1},{202030032,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000211,'雪原企鹅',0,6,0,'神格副本废弃211关77层1号小怪',0,3,0,0,0,202009,'1','0',0,0,0,202009,0,'0',826,30,173404,28418544,89726,80685,39934,39934,21763,21763,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000212,'冰岩怪',0,6,0,'神格副本废弃212关77层2号小怪',0,3,0,0,0,202010,'1','0',0,0,0,202010,0,'0',827,30,174086,28525420,90134,81045,40127,40127,21919,21919,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000213,'森林狼',0,6,0,'神格副本废弃213关77层3号小怪',0,3,0,0,0,202006,'1','0',0,0,0,202006,0,'0',828,30,174766,28632297,90543,81405,40321,40321,22075,22075,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000214,'哥布林',0,6,0,'神格副本废弃214关77层4号小怪',0,3,0,0,0,202005,'1','0',0,0,0,202005,0,'0',829,30,175448,28739177,90951,81765,40514,40514,22231,22231,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000215,'美杜莎',0,6,0,'神格副本废弃215关77层5号boss',0,3,0,0,0,203006,'1','0',0,0,0,203006,0,'0',830,30,176128,28846059,91360,82125,40707,40707,22386,22386,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{2000230101,1},{2000230102,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000216,'冰岩怪',0,6,0,'神格副本废弃216关78层1号小怪',0,3,0,0,0,202010,'1','0',0,0,0,202010,0,'0',831,30,176807,28952942,91769,82485,40900,40900,22542,22542,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000217,'岩龟',0,6,0,'神格副本废弃217关78层2号小怪',0,3,0,0,0,202007,'1','0',0,0,0,202007,0,'0',832,30,177490,29059827,92177,82845,41094,41094,22698,22698,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000218,'蜥蜴人',0,6,0,'神格副本废弃218关78层3号小怪',0,3,0,0,0,202014,'1','0',0,0,0,202014,0,'0',833,30,178169,29166714,92586,83205,41287,41287,22854,22854,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000219,'魔化傀儡',0,6,0,'神格副本废弃219关78层4号小怪',0,3,0,0,0,202015,'1','0',0,0,0,202015,0,'0',834,30,178852,29273601,92994,83565,41480,41480,23010,23010,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000220,'熔岩战神',0,6,0,'神格副本废弃220关78层5号boss',0,3,0,0,0,203025,'1','0',0,0,0,203025,0,'0',835,30,179531,29380491,93403,83925,41673,41673,23165,23165,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{202030251,1},{202030252,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000221,'魔化难民',0,6,0,'神格副本废弃221关79层1号小怪',0,3,0,0,0,202017,'1','0',0,0,0,202017,0,'0',836,30,180214,29487381,93811,84285,41867,41867,23321,23321,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000222,'冰岩怪',0,6,0,'神格副本废弃222关79层2号小怪',0,3,0,0,0,202010,'1','0',0,0,0,202010,0,'0',837,30,180893,29594273,94220,84645,42060,42060,23477,23477,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000223,'冰岩怪',0,6,0,'神格副本废弃223关79层3号小怪',0,3,0,0,0,202010,'1','0',0,0,0,202010,0,'0',838,30,181576,29701166,94628,85005,42253,42253,23633,23633,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000224,'魔化机械',0,6,0,'神格副本废弃224关79层4号小怪',0,3,0,0,0,202018,'1','0',0,0,0,202018,0,'0',839,30,182256,29808059,95037,85365,42446,42446,23789,23789,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000225,'色欲',0,6,0,'神格副本废弃225关79层5号boss',0,3,0,0,0,203016,'1','0',0,0,0,203016,0,'0',840,30,182936,29914954,95446,85725,42640,42640,23945,23945,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{202030161,1},{202030162,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000226,'叛变佣兵',0,6,0,'神格副本废弃226关80层1号小怪',0,3,0,0,0,202012,'1','0',0,0,0,202012,0,'0',841,30,183618,30021471,95854,86086,42833,42833,24100,24100,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000227,'魔化机械',0,6,0,'神格副本废弃227关80层2号小怪',0,3,0,0,0,202018,'1','0',0,0,0,202018,0,'0',842,30,184298,30128367,96263,86446,43026,43026,24256,24256,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000228,'蜥蜴人',0,6,0,'神格副本废弃228关80层3号小怪',0,3,0,0,0,202014,'1','0',0,0,0,202014,0,'0',843,30,184981,30235263,96671,86806,43219,43219,24412,24412,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000229,'魔化藏宝蟹',0,6,0,'神格副本废弃229关80层4号小怪',0,3,0,0,0,202022,'1','0',0,0,0,202022,0,'0',844,30,185660,30342160,97080,87166,43413,43413,24568,24568,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000230,'质量检测员',0,6,0,'神格副本废弃230关80层5号boss',0,3,0,0,0,203008,'1','0',0,0,0,203008,0,'0',845,30,186343,30449057,97488,87526,43606,43606,24724,24724,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{202030081,1},{202030082,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000231,'冰岩怪',0,6,0,'神格副本废弃231关81层1号小怪',0,3,0,0,0,202010,'1','0',0,0,0,202010,0,'0',846,30,187023,30555955,97897,87886,43799,43799,24879,24879,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000232,'冰岩怪',0,6,0,'神格副本废弃232关81层2号小怪',0,3,0,0,0,202010,'1','0',0,0,0,202010,0,'0',847,30,187703,30662853,98306,88246,43992,43992,25035,25035,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000233,'魔化藏宝蟹',0,6,0,'神格副本废弃233关81层3号小怪',0,3,0,0,0,202022,'1','0',0,0,0,202022,0,'0',848,30,188386,30769751,98714,88606,44186,44186,25191,25191,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000234,'哥布林',0,6,0,'神格副本废弃234关81层4号小怪',0,3,0,0,0,202005,'1','0',0,0,0,202005,0,'0',849,30,189066,30876649,99123,88966,44379,44379,25347,25347,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000235,'寒冰女神',0,6,0,'神格副本废弃235关81层5号boss',0,3,0,0,0,203017,'1','0',0,0,0,203017,0,'0',850,30,189748,30983547,99531,89326,44572,44572,25503,25503,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{2000540201,1},{2000540208,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000236,'魔化藏宝蟹',0,6,0,'神格副本废弃236关82层1号小怪',0,3,0,0,0,202022,'1','0',0,0,0,202022,0,'0',851,30,190903,31169822,100110,89843,44774,44774,25615,25615,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000237,'雪原企鹅',0,6,0,'神格副本废弃237关82层2号小怪',0,3,0,0,0,202009,'1','0',0,0,0,202009,0,'0',852,30,192058,31355748,100689,90361,44976,44976,25727,25727,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000238,'蜥蜴人',0,6,0,'神格副本废弃238关82层3号小怪',0,3,0,0,0,202014,'1','0',0,0,0,202014,0,'0',853,30,193214,31542089,101268,90878,45177,45177,25840,25840,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000239,'叛变佣兵',0,6,0,'神格副本废弃239关82层4号小怪',0,3,0,0,0,202012,'1','0',0,0,0,202012,0,'0',854,30,194370,31728079,101847,91396,45379,45379,25952,25952,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000240,'暗裔恶魔',0,6,0,'神格副本废弃240关82层5号boss',0,3,0,0,0,203007,'1','0',0,0,0,203007,0,'0',855,30,195526,31914485,102426,91913,45581,45581,26064,26064,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{2000230301,1},{2000230303,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000241,'魔化傀儡',0,6,0,'神格副本废弃241关83层1号小怪',0,3,0,0,0,202015,'1','0',0,0,0,202015,0,'0',856,30,196682,32100924,103005,92430,45783,45783,26176,26176,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000242,'叛变佣兵',0,6,0,'神格副本废弃242关83层2号小怪',0,3,0,0,0,202012,'1','0',0,0,0,202012,0,'0',857,30,197839,32287007,103584,92948,45985,45985,26289,26289,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000243,'魔化藏宝蟹',0,6,0,'神格副本废弃243关83层3号小怪',0,3,0,0,0,202022,'1','0',0,0,0,202022,0,'0',858,30,198996,32473508,104163,93465,46186,46186,26401,26401,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000244,'雪原企鹅',0,6,0,'神格副本废弃244关83层4号小怪',0,3,0,0,0,202009,'1','0',0,0,0,202009,0,'0',859,30,200153,32659651,104742,93983,46388,46388,26513,26513,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000245,'巴哈姆特',0,6,0,'神格副本废弃245关83层5号boss',0,3,0,0,0,203026,'1','0',0,0,0,203026,0,'0',860,30,201310,32846213,105321,94500,46590,46590,26626,26626,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{202030261,1},{202030262,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000246,'蜥蜴人',0,6,0,'神格副本废弃246关84层1号小怪',0,3,0,0,0,202014,'1','0',0,0,0,202014,0,'0',861,30,202468,33032414,105900,95018,46792,46792,26738,26738,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000247,'魔化难民',0,6,0,'神格副本废弃247关84层2号小怪',0,3,0,0,0,202017,'1','0',0,0,0,202017,0,'0',862,30,203626,33219036,106479,95535,46993,46993,26850,26850,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000248,'魔化傀儡',0,6,0,'神格副本废弃248关84层3号小怪',0,3,0,0,0,202015,'1','0',0,0,0,202015,0,'0',863,30,204784,33405687,107058,96052,47195,47195,26963,26963,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000249,'叛变佣兵',0,6,0,'神格副本废弃249关84层4号小怪',0,3,0,0,0,202012,'1','0',0,0,0,202012,0,'0',864,30,205942,33591974,107637,96570,47397,47397,27075,27075,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000250,'冰霜巨龙',0,6,0,'神格副本废弃250关84层5号boss',0,3,0,0,0,203004,'1','0',0,0,0,203004,0,'0',865,30,207101,33778682,108216,97087,47599,47599,27187,27187,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{202030041,1},{202030043,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000251,'森林狼',0,6,0,'神格副本废弃251关85层1号小怪',0,3,0,0,0,202006,'1','0',0,0,0,202006,0,'0',866,30,208259,33965023,108795,97605,47801,47801,27299,27299,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000252,'魔化藏宝蟹',0,6,0,'神格副本废弃252关85层2号小怪',0,3,0,0,0,202022,'1','0',0,0,0,202022,0,'0',867,30,209419,34151788,109374,98122,48002,48002,27412,27412,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000253,'冰岩怪',0,6,0,'神格副本废弃253关85层3号小怪',0,3,0,0,0,202010,'1','0',0,0,0,202010,0,'0',868,30,210581,34338182,109952,98640,48204,48204,27524,27524,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000254,'冰岩怪',0,6,0,'神格副本废弃254关85层4号小怪',0,3,0,0,0,202010,'1','0',0,0,0,202010,0,'0',869,30,211740,34525000,110531,99157,48406,48406,27636,27636,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000255,'海龙王',0,6,0,'神格副本废弃255关85层5号boss',0,3,0,0,0,203009,'1','0',0,0,0,203009,0,'0',870,30,212900,34711446,111110,99675,48608,48608,27749,27749,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{202030091,1},{202030092,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000256,'冰岩怪',0,6,0,'神格副本废弃256关86层1号小怪',0,3,0,0,0,202010,'1','0',0,0,0,202010,0,'0',871,30,214060,34898318,111689,100192,48809,48809,27861,27861,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000257,'魔化机械',0,6,0,'神格副本废弃257关86层2号小怪',0,3,0,0,0,202018,'1','0',0,0,0,202018,0,'0',872,30,215220,35085215,112268,100709,49011,49011,27973,27973,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000258,'魔化难民',0,6,0,'神格副本废弃258关86层3号小怪',0,3,0,0,0,202017,'1','0',0,0,0,202017,0,'0',873,30,216381,35271737,112847,101227,49213,49213,28085,28085,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000259,'魔化傀儡',0,6,0,'神格副本废弃259关86层4号小怪',0,3,0,0,0,202015,'1','0',0,0,0,202015,0,'0',874,30,217541,35458685,113426,101744,49415,49415,28198,28198,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000260,'海龙王',0,6,0,'神格副本废弃260关86层5号boss',0,3,0,0,0,203009,'1','0',0,0,0,203009,0,'0',875,30,218702,35645255,114005,102262,49617,49617,28310,28310,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{202030091,1},{202030092,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000261,'岩龟',0,6,0,'神格副本废弃261关87层1号小怪',0,3,0,0,0,202007,'1','0',0,0,0,202007,0,'0',876,30,219863,35832253,114584,102779,49818,49818,28422,28422,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000262,'雪原企鹅',0,6,0,'神格副本废弃262关87层2号小怪',0,3,0,0,0,202009,'1','0',0,0,0,202009,0,'0',877,30,221024,36018870,115163,103297,50020,50020,28535,28535,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000263,'魔化机械',0,6,0,'神格副本废弃263关87层3号小怪',0,3,0,0,0,202018,'1','0',0,0,0,202018,0,'0',878,30,222186,36205916,115742,103814,50222,50222,28647,28647,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000264,'哥布林',0,6,0,'神格副本废弃264关87层4号小怪',0,3,0,0,0,202005,'1','0',0,0,0,202005,0,'0',879,30,223347,36392578,116321,104332,50424,50424,28759,28759,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000265,'半人马',0,6,0,'神格副本废弃265关87层5号boss',0,3,0,0,0,203002,'1','0',0,0,0,203002,0,'0',880,30,224509,36579671,116900,104849,50626,50626,28871,28871,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{200022011,1},{200022014,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000266,'雪原企鹅',0,6,0,'神格副本废弃266关88层1号小怪',0,3,0,0,0,202009,'1','0',0,0,0,202009,0,'0',881,30,225671,36766787,117479,105366,50827,50827,28984,28984,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000267,'岩龟',0,6,0,'神格副本废弃267关88层2号小怪',0,3,0,0,0,202007,'1','0',0,0,0,202007,0,'0',882,30,226834,36953516,118058,105884,51029,51029,29096,29096,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000268,'叛变佣兵',0,6,0,'神格副本废弃268关88层3号小怪',0,3,0,0,0,202012,'1','0',0,0,0,202012,0,'0',883,30,227996,37140677,118637,106401,51231,51231,29208,29208,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000269,'岩龟',0,6,0,'神格副本废弃269关88层4号小怪',0,3,0,0,0,202007,'1','0',0,0,0,202007,0,'0',884,30,229159,37327449,119216,106919,51433,51433,29321,29321,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000270,'暗裔恶魔',0,6,0,'神格副本废弃270关88层5号boss',0,3,0,0,0,203007,'1','0',0,0,0,203007,0,'0',885,30,230321,37514653,119795,107436,51634,51634,29433,29433,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{2000230301,1},{2000230303,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000271,'森林狼',0,6,0,'神格副本废弃271关89层1号小怪',0,3,0,0,0,202006,'1','0',0,0,0,202006,0,'0',886,30,231484,37701467,120374,107954,51836,51836,29545,29545,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000272,'岩龟',0,6,0,'神格副本废弃272关89层2号小怪',0,3,0,0,0,202007,'1','0',0,0,0,202007,0,'0',887,30,232648,37888713,120953,108471,52038,52038,29657,29657,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000273,'魔化难民',0,6,0,'神格副本废弃273关89层3号小怪',0,3,0,0,0,202017,'1','0',0,0,0,202017,0,'0',888,30,233811,38075567,121532,108989,52240,52240,29770,29770,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000274,'哥布林',0,6,0,'神格副本废弃274关89层4号小怪',0,3,0,0,0,202005,'1','0',0,0,0,202005,0,'0',889,30,234977,38262855,122110,109506,52442,52442,29882,29882,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000275,'美杜莎',0,6,0,'神格副本废弃275关89层5号boss',0,3,0,0,0,203006,'1','0',0,0,0,203006,0,'0',890,30,236141,38450163,122689,110023,52643,52643,29994,29994,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{2000230101,1},{2000230102,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000276,'岩龟',0,6,0,'神格副本废弃276关90层1号小怪',0,3,0,0,0,202007,'1','0',0,0,0,202007,0,'0',891,30,237305,38637075,123268,110541,52845,52845,30107,30107,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000277,'森林狼',0,6,0,'神格副本废弃277关90层2号小怪',0,3,0,0,0,202006,'1','0',0,0,0,202006,0,'0',892,30,238469,38824423,123847,111058,53047,53047,30219,30219,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000278,'魔化藏宝蟹',0,6,0,'神格副本废弃278关90层3号小怪',0,3,0,0,0,202022,'1','0',0,0,0,202022,0,'0',893,30,239633,39011372,124426,111576,53249,53249,30331,30331,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000279,'岩龟',0,6,0,'神格副本废弃279关90层4号小怪',0,3,0,0,0,202007,'1','0',0,0,0,202007,0,'0',894,30,240798,39198758,125005,112093,53450,53450,30444,30444,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000280,'海龙王',0,6,0,'神格副本废弃280关90层5号boss',0,3,0,0,0,203009,'1','0',0,0,0,203009,0,'0',895,30,241962,39385743,125584,112611,53652,53652,30556,30556,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{202030091,1},{202030092,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000281,'冰岩怪',0,6,0,'神格副本废弃281关91层1号小怪',0,3,0,0,0,202010,'1','0',0,0,0,202010,0,'0',896,30,243127,39573166,126163,113128,53854,53854,30668,30668,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000282,'冰岩怪',0,6,0,'神格副本废弃282关91层2号小怪',0,3,0,0,0,202010,'1','0',0,0,0,202010,0,'0',897,30,244292,39760186,126742,113646,54056,54056,30780,30780,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000283,'蜥蜴人',0,6,0,'神格副本废弃283关91层3号小怪',0,3,0,0,0,202014,'1','0',0,0,0,202014,0,'0',898,30,245457,39947645,127321,114163,54258,54258,30893,30893,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000284,'魔化藏宝蟹',0,6,0,'神格副本废弃284关91层4号小怪',0,3,0,0,0,202022,'1','0',0,0,0,202022,0,'0',899,30,246622,40135122,127900,114680,54459,54459,31005,31005,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000285,'怠惰',0,6,0,'神格副本废弃285关91层5号boss',0,3,0,0,0,203013,'1','0',0,0,0,203013,0,'0',900,30,247787,40322193,128479,115198,54661,54661,31117,31117,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{202030131,1},{202030132,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000286,'雪原企鹅',0,6,0,'神格副本废弃286关92层1号小怪',0,3,0,0,0,202009,'1','0',0,0,0,202009,0,'0',901,30,248916,40498309,129102,115744,54872,54872,31231,31231,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000287,'岩龟',0,6,0,'神格副本废弃287关92层2号小怪',0,3,0,0,0,202007,'1','0',0,0,0,202007,0,'0',902,30,250044,40674439,129725,116290,55083,55083,31345,31345,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000288,'雪原企鹅',0,6,0,'神格副本废弃288关92层3号小怪',0,3,0,0,0,202009,'1','0',0,0,0,202009,0,'0',903,30,251172,40850159,130348,116837,55294,55294,31459,31459,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000289,'岩龟',0,6,0,'神格副本废弃289关92层4号小怪',0,3,0,0,0,202007,'1','0',0,0,0,202007,0,'0',904,30,252298,41026319,130972,117383,55505,55505,31572,31572,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000290,'美杜莎',0,6,0,'神格副本废弃290关92层5号boss',0,3,0,0,0,203006,'1','0',0,0,0,203006,0,'0',905,30,253427,41202493,131595,117929,55716,55716,31686,31686,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{2000230101,1},{2000230102,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000291,'雪原企鹅',0,6,0,'神格副本废弃291关93层1号小怪',0,3,0,0,0,202009,'1','0',0,0,0,202009,0,'0',906,30,254556,41378680,132218,118475,55927,55927,31800,31800,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000292,'魔化机械',0,6,0,'神格副本废弃292关93层2号小怪',0,3,0,0,0,202018,'1','0',0,0,0,202018,0,'0',907,30,255685,41554454,132841,119022,56138,56138,31914,31914,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000293,'魔化傀儡',0,6,0,'神格副本废弃293关93层3号小怪',0,3,0,0,0,202015,'1','0',0,0,0,202015,0,'0',908,30,256814,41730669,133464,119568,56350,56350,32028,32028,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000294,'冰岩怪',0,6,0,'神格副本废弃294关93层4号小怪',0,3,0,0,0,202010,'1','0',0,0,0,202010,0,'0',909,30,257943,41906897,134087,120114,56561,56561,32141,32141,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000295,'八岐大蛇',0,6,0,'神格副本废弃295关93层5号boss',0,3,0,0,0,203024,'1','0',0,0,0,203024,0,'0',910,30,259070,42083138,134711,120660,56772,56772,32255,32255,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{2000230201,1},{2000230202,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000296,'岩龟',0,6,0,'神格副本废弃296关94层1号小怪',0,3,0,0,0,202007,'1','0',0,0,0,202007,0,'0',911,30,260199,42258962,135334,121207,56983,56983,32369,32369,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000297,'魔化藏宝蟹',0,6,0,'神格副本废弃297关94层2号小怪',0,3,0,0,0,202022,'1','0',0,0,0,202022,0,'0',912,30,261329,42435227,135957,121753,57194,57194,32483,32483,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000298,'魔化傀儡',0,6,0,'神格副本废弃298关94层3号小怪',0,3,0,0,0,202015,'1','0',0,0,0,202015,0,'0',913,30,262459,42611506,136580,122299,57405,57405,32597,32597,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000299,'森林狼',0,6,0,'神格副本废弃299关94层4号小怪',0,3,0,0,0,202006,'1','0',0,0,0,202006,0,'0',914,30,263589,42787796,137203,122845,57616,57616,32710,32710,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000300,'暗裔恶魔',0,6,0,'神格副本废弃300关94层5号boss',0,3,0,0,0,203007,'1','0',0,0,0,203007,0,'0',915,30,264719,42964098,137826,123391,57827,57827,32824,32824,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{2000230301,1},{2000230303,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000301,'冰岩怪',0,6,0,'神格副本废弃301关95层1号小怪',0,3,0,0,0,202010,'1','0',0,0,0,202010,0,'0',916,30,265846,43139980,138450,123938,58038,58038,32938,32938,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000302,'魔化傀儡',0,6,0,'神格副本废弃302关95层2号小怪',0,3,0,0,0,202015,'1','0',0,0,0,202015,0,'0',917,30,266977,43316304,139073,124484,58249,58249,33052,33052,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000303,'森林狼',0,6,0,'神格副本废弃303关95层3号小怪',0,3,0,0,0,202006,'1','0',0,0,0,202006,0,'0',918,30,268107,43492641,139696,125030,58460,58460,33165,33165,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000304,'森林狼',0,6,0,'神格副本废弃304关95层4号小怪',0,3,0,0,0,202006,'1','0',0,0,0,202006,0,'0',919,30,269238,43668988,140319,125576,58671,58671,33279,33279,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000305,'寒冰女神',0,6,0,'神格副本废弃305关95层5号boss',0,3,0,0,0,203017,'1','0',0,0,0,203017,0,'0',920,30,270369,43844911,140942,126123,58882,58882,33393,33393,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{2000540201,1},{2000540208,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000306,'雪原企鹅',0,6,0,'神格副本废弃306关96层1号小怪',0,3,0,0,0,202009,'1','0',0,0,0,202009,0,'0',921,30,271500,44021279,141565,126669,59093,59093,33507,33507,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000307,'魔化藏宝蟹',0,6,0,'神格副本废弃307关96层2号小怪',0,3,0,0,0,202022,'1','0',0,0,0,202022,0,'0',922,30,272628,44197658,142189,127215,59304,59304,33621,33621,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000308,'叛变佣兵',0,6,0,'神格副本废弃308关96层3号小怪',0,3,0,0,0,202012,'1','0',0,0,0,202012,0,'0',923,30,273759,44374046,142812,127761,59515,59515,33734,33734,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000309,'魔化藏宝蟹',0,6,0,'神格副本废弃309关96层4号小怪',0,3,0,0,0,202022,'1','0',0,0,0,202022,0,'0',924,30,274890,44550008,143435,128308,59726,59726,33848,33848,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000310,'熔岩战神',0,6,0,'神格副本废弃310关96层5号boss',0,3,0,0,0,203025,'1','0',0,0,0,203025,0,'0',925,30,276021,44726416,144058,128854,59937,59937,33962,33962,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{202030251,1},{202030252,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000311,'雪原企鹅',0,6,0,'神格副本废弃311关97层1号小怪',0,3,0,0,0,202009,'1','0',0,0,0,202009,0,'0',926,30,277153,44902833,144681,129400,60148,60148,34076,34076,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000312,'哥布林',0,6,0,'神格副本废弃312关97层2号小怪',0,3,0,0,0,202005,'1','0',0,0,0,202005,0,'0',927,30,278284,45079260,145304,129946,60360,60360,34190,34190,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000313,'魔化难民',0,6,0,'神格副本废弃313关97层3号小怪',0,3,0,0,0,202017,'1','0',0,0,0,202017,0,'0',928,30,279413,45255258,145928,130493,60571,60571,34303,34303,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000314,'蜥蜴人',0,6,0,'神格副本废弃314关97层4号小怪',0,3,0,0,0,202014,'1','0',0,0,0,202014,0,'0',929,30,280544,45431702,146551,131039,60782,60782,34417,34417,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000315,'海龙王',0,6,0,'神格副本废弃315关97层5号boss',0,3,0,0,0,203009,'1','0',0,0,0,203009,0,'0',930,30,281676,45608155,147174,131585,60993,60993,34531,34531,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{202030091,1},{202030092,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000316,'蜥蜴人',0,6,0,'神格副本废弃316关98层1号小怪',0,3,0,0,0,202014,'1','0',0,0,0,202014,0,'0',931,30,282808,45784616,147797,132131,61204,61204,34645,34645,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000317,'哥布林',0,6,0,'神格副本废弃317关98层2号小怪',0,3,0,0,0,202005,'1','0',0,0,0,202005,0,'0',932,30,283940,45960646,148420,132678,61415,61415,34759,34759,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000318,'叛变佣兵',0,6,0,'神格副本废弃318关98层3号小怪',0,3,0,0,0,202012,'1','0',0,0,0,202012,0,'0',933,30,285072,46137124,149043,133224,61626,61626,34872,34872,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000319,'魔化藏宝蟹',0,6,0,'神格副本废弃319关98层4号小怪',0,3,0,0,0,202022,'1','0',0,0,0,202022,0,'0',934,30,286205,46313609,149666,133770,61837,61837,34986,34986,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000320,'愤怒',0,6,0,'神格副本废弃320关98层5号boss',0,3,0,0,0,203012,'1','0',0,0,0,203012,0,'0',935,30,287334,46490103,150290,134316,62048,62048,35100,35100,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{202030121,1},{202030122,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000321,'蜥蜴人',0,6,0,'神格副本废弃321关99层1号小怪',0,3,0,0,0,202014,'1','0',0,0,0,202014,0,'0',936,30,288466,46666162,150913,134863,62259,62259,35214,35214,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000322,'魔化傀儡',0,6,0,'神格副本废弃322关99层2号小怪',0,3,0,0,0,202015,'1','0',0,0,0,202015,0,'0',937,30,289599,46842670,151536,135409,62470,62470,35328,35328,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000323,'魔化机械',0,6,0,'神格副本废弃323关99层3号小怪',0,3,0,0,0,202018,'1','0',0,0,0,202018,0,'0',938,30,290731,47019185,152159,135955,62681,62681,35441,35441,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000324,'魔化傀儡',0,6,0,'神格副本废弃324关99层4号小怪',0,3,0,0,0,202015,'1','0',0,0,0,202015,0,'0',939,30,291864,47195707,152782,136501,62892,62892,35555,35555,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000325,'怠惰',0,6,0,'神格副本废弃325关99层5号boss',0,3,0,0,0,203013,'1','0',0,0,0,203013,0,'0',940,30,292997,47371792,153405,137048,63103,63103,35669,35669,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{202030131,1},{202030132,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000326,'魔化藏宝蟹',0,6,0,'神格副本废弃326关100层1号小怪',0,3,0,0,0,202022,'1','0',0,0,0,202022,0,'0',941,30,294126,47548327,154029,137594,63314,63314,35783,35783,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000327,'森林狼',0,6,0,'神格副本废弃327关100层2号小怪',0,3,0,0,0,202006,'1','0',0,0,0,202006,0,'0',942,30,295259,47724869,154652,138140,63525,63525,35896,35896,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000328,'蜥蜴人',0,6,0,'神格副本废弃328关100层3号小怪',0,3,0,0,0,202014,'1','0',0,0,0,202014,0,'0',943,30,296392,47901417,155275,138686,63736,63736,36010,36010,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000329,'魔化藏宝蟹',0,6,0,'神格副本废弃329关100层4号小怪',0,3,0,0,0,202022,'1','0',0,0,0,202022,0,'0',944,30,297525,48077526,155898,139233,63947,63947,36124,36124,0,'[]','[1,184524248,500]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(56000330,'冰霜巨龙',0,6,0,'神格副本废弃330关100层5号boss',0,3,0,0,0,203004,'1','0',0,0,0,203004,0,'0',945,30,298658,48254085,156521,139779,64158,64158,36238,36238,0,'[]','[1,184524248,500]',600,2250,1500,2250,300,'[{202030041,1},{202030043,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(57000001,'荣耀战神',0,5,0,'荣耀战神Lv200',0,3,0,0,0,1204008,'1','0',0,0,0,1204008,0,'10||公会排名越高，奖励越丰厚！:30||最后一击可获得幸运奖励！:10',200,4000,408,133517797,1786,1578,295,295,156,156,0,'[]','[]',250,2250,1500,2250,300,'[{20005700,1},{20005710,1},{20005722,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(57000002,'荣耀战神',0,5,0,'荣耀战神Lv300',0,3,0,0,0,1204008,'1.1','0',0,0,0,1204008,0,'10||公会排名越高，奖励越丰厚！:30||最后一击可获得幸运奖励！:10',300,6000,1089,315079827,4421,3678,846,846,821,821,0,'[]','[]',250,2250,1500,2250,300,'[{20005700,1},{20005710,1},{20005722,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(57000003,'荣耀战神',0,5,0,'荣耀战神Lv400',0,3,0,0,0,1204008,'1','0',0,0,0,1204008,0,'',400,8000,1702,442331648,6488,5450,1530,1530,1170,1170,0,'[]','[]',250,2250,1500,2250,300,'[{20005700,1},{20005710,1},{20005722,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(57000004,'荣耀战神',0,5,0,'荣耀战神Lv500',0,3,0,0,0,1204008,'1','0',0,0,0,1204008,0,'',500,10000,2847,817978526,11419,10113,3503,3503,2126,2126,0,'[]','[]',250,2250,1500,2250,300,'[{20005700,1},{20005710,1},{20005722,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(57000005,'荣耀战神',0,5,0,'荣耀战神Lv550',0,3,0,0,0,1204008,'0.9','0',0,0,0,1204008,0,'',550,11000,3969,1135893327,14653,13305,4880,4880,2674,2674,0,'[]','[]',250,2250,1500,2250,300,'[{20005700,1},{20005710,1},{20005722,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(57000006,'荣耀战神',0,5,0,'荣耀战神Lv600',0,3,0,0,0,1204008,'1','0',0,0,0,1204008,0,'',600,12000,5903,1703644294,22614,20304,7125,7125,3858,3858,0,'[]','[]',250,2250,1500,2250,300,'[{20005700,1},{20005710,1},{20005722,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(57000007,'荣耀战神',0,5,0,'荣耀战神Lv650',0,3,0,0,0,1204008,'1','0',0,0,0,1204008,0,'',650,13000,8419,2429375146,31693,28453,10656,10656,5420,5420,0,'[]','[]',250,2250,1500,2250,300,'[{20005700,1},{20005710,1},{20005722,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(57000008,'荣耀战神',0,5,0,'荣耀战神Lv700',0,3,0,0,0,1204008,'1.1','0',0,0,0,1204008,0,'',700,14000,12236,3546386814,41978,37661,19985,19985,9509,9509,0,'[]','[]',250,2250,1500,2250,300,'[{20005700,1},{20005710,1},{20005722,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(57000009,'荣耀战神',0,5,0,'荣耀战神Lv750',0,3,0,0,0,1204008,'1','0',0,0,0,1204008,0,'',750,15000,16895,4294967295,59658,54069,28149,28149,14098,14098,0,'[]','[]',250,2250,1500,2250,300,'[{20005700,1},{20005710,1},{20005722,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(57000010,'荣耀战神',0,5,0,'荣耀战神Lv800',0,3,0,0,0,1204008,'1','0',0,0,0,1204008,0,'',800,16000,21517,4294967295,77880,70625,34910,34910,17555,17555,0,'[]','[]',250,2250,1500,2250,300,'[{20005700,1},{20005710,1},{20005722,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(57000011,'荣耀战神',0,5,0,'荣耀战神Lv850',0,3,0,0,0,1204008,'0.9','0',0,0,0,1204008,0,'',850,17000,26158,4294967295,97636,88221,44572,44572,25418,25418,0,'[]','[]',250,2250,1500,2250,300,'[{20005700,1},{20005710,1},{20005722,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(57000012,'荣耀战神',0,5,0,'荣耀战神Lv900',0,3,0,0,0,1204008,'1','0',0,0,0,1204008,0,'',900,18000,34062,4294967295,125668,113561,54661,54661,30930,30930,0,'[]','[]',250,2250,1500,2250,300,'[{20005700,1},{20005710,1},{20005722,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(57000013,'荣耀战神',0,5,0,'荣耀战神Lv950',0,3,0,0,0,1204008,'0.9','0',0,0,0,1204008,0,'',950,19000,41739,4294967295,155631,140231,65214,65214,36704,36704,0,'[]','[]',250,2250,1500,2250,300,'[{20005700,1},{20005710,1},{20005722,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(57000014,'荣耀战神',0,5,0,'荣耀战神Lv1000',0,3,0,0,0,1204008,'0.9','0',0,0,0,1204008,0,'',1000,19000,41739,4294967295,155631,140231,65214,65214,36704,36704,0,'[]','[]',250,2250,1500,2250,300,'[{20005700,1},{20005710,1},{20005722,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(58110001,'中央据点',7,4,0,'三英会战中央据点',0,1,0,0,0,58110001,'1','0',0,0,0,58110001,0,'0',1,100,0,2400000,0,1,1,1,0,1,0,'[]','[]',0,0,0,0,0,'[{3110000001,1}]',0,0,0,0,0,1,0,0,0,0,1,1,0,0,'[1000,1000]',1,'0',0,1,0,0,0),(58110002,'边防据点（上）',7,4,0,'三英会战边防据点 上',0,1,0,0,0,58110009,'0.8','0',0,0,0,58110009,0,'0',1,100,0,1260000,0,1,1,1,0,1,0,'[]','[]',0,0,0,0,0,'[{3110000001,1}]',0,0,0,0,0,1,0,0,0,0,1,1,0,0,'[1000,1000]',1,'0',0,1,0,0,0),(58110003,'边防据点（右）',7,4,0,'三英会战边防据点 右',0,1,0,0,0,58110009,'0.8','0',0,0,0,58110009,0,'0',1,100,0,1260000,0,1,1,1,0,1,0,'[]','[]',0,0,0,0,0,'[{3110000001,1}]',0,0,0,0,0,1,0,0,0,0,1,1,0,0,'[1000,1000]',1,'0',0,1,0,0,0),(58110004,'边防据点（左）',7,4,0,'三英会战边防据点 左',0,1,0,0,0,58110009,'0.8','0',0,0,0,58110009,0,'0',1,100,0,1260000,0,1,1,1,0,1,0,'[]','[]',0,0,0,0,0,'[{3110000001,1}]',0,0,0,0,0,1,0,0,0,0,1,1,0,0,'[1000,1000]',1,'0',0,1,0,0,0),(58110017,'增伤BUFF宝箱',1,0,0,'三英会战增伤BUFF宝箱',0,5,0,0,0,2040013,'1','0',0,0,0,2040013,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,2250,1500,2250,200,'[]',0,2000,0,1,0,0,0,3,1,0,0,1,0,0,'[]',1,'0',1,0,0,0,0),(58110018,'减伤BUFF宝箱',1,0,0,'三英会战减伤BUFF宝箱',0,5,0,0,0,2040013,'1','0',0,0,0,2040013,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,2250,1500,2250,200,'[]',0,2000,0,1,0,0,0,3,1,0,0,1,0,0,'[]',1,'0',1,0,0,0,0),(58110019,'移速BUFF宝箱',1,0,0,'三英会战移速BUFF宝箱',0,5,0,0,0,2040013,'1','0',0,0,0,2040013,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,2250,1500,2250,200,'[]',0,2000,0,1,0,0,0,3,1,0,0,1,0,0,'[]',1,'0',1,0,0,0,0),(58110020,'回复BUFF宝箱',1,0,0,'三英会战回复BUFF宝箱',0,5,0,0,0,2040013,'1','0',0,0,0,2040013,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,2250,1500,2250,200,'[]',0,2000,0,1,0,0,0,3,1,0,0,1,0,0,'[]',1,'0',1,0,0,0,0),(60000001,'婚礼箱子怪1',1,2,0,'婚礼答题箱子1',0,4,0,0,0,2040013,'1.3','effect_monster_caijiwuchangzhu02',0,0,0,2040013,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,2250,1500,2250,200,'[{1110000001,1}]',0,2000,0,1,0,0,1,1,1,0,0,1,0,0,'[]',1,'0',1,0,0,0,0),(60000002,'婚礼箱子怪2',1,2,0,'婚礼答题箱子2',0,4,0,0,0,2040013,'1.3','effect_monster_caijiwuchangzhu02',0,0,0,2040013,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,2250,1500,2250,200,'[{1110000001,1}]',0,2000,0,1,0,0,1,1,1,0,0,1,0,0,'[]',1,'0',1,0,0,0,0),(60000003,'婚礼箱子怪3',1,2,0,'婚礼答题箱子3',0,4,0,0,0,2040013,'1.3','effect_monster_caijiwuchangzhu02',0,0,0,2040013,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,2250,1500,2250,200,'[{1110000001,1}]',0,2000,0,1,0,0,1,1,1,0,0,1,0,0,'[]',1,'0',1,0,0,0,0),(60000004,'婚礼箱子怪4',1,2,0,'婚礼答题箱子4',0,4,0,0,0,2040013,'1.3','effect_monster_caijiwuchangzhu02',0,0,0,2040013,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,2250,1500,2250,200,'[{1110000001,1}]',0,2000,0,1,0,0,1,1,1,0,0,1,0,0,'[]',1,'0',1,0,0,0,0),(60000005,'婚礼箱子怪5',1,2,0,'婚礼答题箱子5',0,4,0,0,0,2040013,'1.3','effect_monster_caijiwuchangzhu02',0,0,0,2040013,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,2250,1500,2250,200,'[{1110000001,1}]',0,2000,0,1,0,0,1,1,1,0,0,1,0,0,'[]',1,'0',1,0,0,0,0),(70101001,'暗裔小鬼',0,0,1,'降神塔I小怪1',0,3,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',345,1,7032,562500,18750,23438,1406,1406,1125,1125,0,'[]','[]',250,2250,1500,2250,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70101002,'骷髅勇士',0,0,1,'降神塔I小怪2',0,3,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',345,1,7313,585000,19500,24375,1463,1463,1170,1170,0,'[]','[]',250,2250,1500,2250,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70101003,'魔焰爆弹',0,0,1,'降神塔I小怪3',0,3,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',345,1,7594,607500,20250,25313,1519,1519,1215,1215,0,'[]','[]',250,2250,1500,2250,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70101004,'魔化傀儡',0,0,1,'降神塔I小怪4',0,3,0,0,0,202015,'1.3','0',0,0,0,202015,0,'0',345,1,7875,630000,21000,26250,1575,1575,1260,1260,0,'[]','[]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70101005,'魔锤将使',0,6,1,'降神塔Iboss5',0,6,0,0,0,203008,'1.1','0',0,0,0,203008,0,'0',360,20,51469,1029375,22875,28594,1716,1716,1373,1373,0,'[]','[]',250,2250,1500,2250,300,'[{202030081,1},{202030082,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70101006,'机械怪人',0,0,1,'降神塔I小怪6',0,3,0,0,0,202018,'1.3','0',0,0,0,202015,0,'0',345,1,8860,708750,23625,29531,1772,1772,1418,1418,0,'[]','[]',250,2250,1500,2250,200,'[{1110000003,1}]',0,0,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70101007,'机械怪物',0,0,1,'降神塔I小怪7',0,3,0,0,0,202035,'1.3','0',0,0,0,202019,0,'0',345,1,9141,731250,24375,30469,1828,1828,1463,1463,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70101008,'机器战士',0,0,1,'降神塔I小怪8',0,3,0,0,0,202017,'1.3','0',0,0,0,202015,0,'0',345,1,9422,753750,25125,31406,1884,1884,1508,1508,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70101009,'机械犬',0,0,1,'降神塔I小怪9',0,3,0,0,0,202016,'1.3','0',0,0,0,202016,0,'0',345,1,9704,776250,25875,32344,1941,1941,1553,1553,0,'[]','[]',250,2250,1500,2250,200,'[{1110000003,1}]',0,0,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70101010,'神降魔使',0,6,1,'降神塔Iboss10',0,6,0,0,0,203026,'1.1','0',0,0,0,203026,0,'0',370,30,64547,1290938,28688,35859,2152,2152,1721,1721,0,'[]','[]',600,2250,1500,2250,300,'[{202030261,1},{202030262,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70201001,'暗裔小鬼',0,0,1,'降神塔II小怪1',0,3,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',345,1,10407,832500,27750,34688,2081,2081,1665,1665,0,'[]','[]',250,2250,1500,2250,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70201002,'骷髅勇士',0,0,1,'降神塔II小怪2',0,3,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',345,1,10969,877500,29250,36563,2194,2194,1755,1755,0,'[]','[]',250,2250,1500,2250,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70201003,'魔焰爆弹',0,0,1,'降神塔II小怪3',0,3,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',345,1,11532,922500,30750,38438,2306,2306,1845,1845,0,'[]','[]',250,2250,1500,2250,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70201004,'魔化傀儡',0,0,1,'降神塔II小怪4',0,3,0,0,0,202015,'1.3','0',0,0,0,202015,0,'0',345,1,12094,967500,32250,40313,2419,2419,1935,1935,0,'[]','[]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70201005,'魔锤将使',0,6,1,'降神塔IIboss5',0,6,0,0,0,203008,'1.1','0',0,0,0,203008,0,'0',360,20,78891,1577813,35063,43828,2630,2630,2104,2104,0,'[]','[]',250,2250,1500,2250,300,'[{202030081,1},{202030082,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70201006,'机械怪人',0,0,1,'降神塔II小怪6',0,3,0,0,0,202018,'1.3','0',0,0,0,202015,0,'0',345,1,13711,1096876,36563,45703,2742,2742,2194,2194,0,'[]','[]',250,2250,1500,2250,200,'[{1110000003,1}]',0,0,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70201007,'机械怪物',0,0,1,'降神塔II小怪7',0,3,0,0,0,202035,'1.3','0',0,0,0,202019,0,'0',345,1,14274,1141876,38063,47578,2855,2855,2284,2284,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70201008,'机器战士',0,0,1,'降神塔II小怪8',0,3,0,0,0,202017,'1.3','0',0,0,0,202015,0,'0',345,1,14836,1186876,39563,49453,2967,2967,2374,2374,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70201009,'机械犬',0,0,1,'降神塔II小怪9',0,3,0,0,0,202016,'1.3','0',0,0,0,202016,0,'0',345,1,15399,1231876,41063,51328,3080,3080,2464,2464,0,'[]','[]',250,2250,1500,2250,200,'[{1110000003,1}]',0,0,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70201010,'神降魔使',0,6,1,'降神塔IIboss10',0,6,0,0,0,203026,'1.1','0',0,0,0,203026,0,'0',370,30,102938,2058750,45750,57188,3431,3431,2745,2745,0,'[]','[]',600,2250,1500,2250,300,'[{202030261,1},{202030262,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70301001,'暗裔小鬼',0,0,1,'降神塔III小怪1',0,3,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',345,1,16524,1321876,44063,55078,3305,3305,2644,2644,0,'[]','[]',250,2250,1500,2250,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70301002,'骷髅勇士',0,0,1,'降神塔III小怪2',0,3,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',345,1,17368,1389376,46313,57891,3473,3473,2779,2779,0,'[]','[]',250,2250,1500,2250,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70301003,'魔焰爆弹',0,0,1,'降神塔III小怪3',0,3,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',345,1,18211,1456876,48563,60703,3642,3642,2914,2914,0,'[]','[]',250,2250,1500,2250,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70301004,'魔化傀儡',0,0,1,'降神塔III小怪4',0,3,0,0,0,202015,'1.3','0',0,0,0,202015,0,'0',345,1,19055,1524376,50813,63516,3811,3811,3049,3049,0,'[]','[]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70301005,'魔锤将使',0,6,1,'降神塔IIIboss5',0,6,0,0,0,203008,'1.1','0',0,0,0,203008,0,'0',360,20,122766,2455313,54563,68203,4092,4092,3274,3274,0,'[]','[]',250,2250,1500,2250,300,'[{202030081,1},{202030082,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70301006,'机械怪人',0,0,1,'降神塔III小怪6',0,3,0,0,0,202018,'1.3','0',0,0,0,202015,0,'0',345,1,21305,1704376,56813,71016,4261,4261,3409,3409,0,'[]','[]',250,2250,1500,2250,200,'[{1110000003,1}]',0,0,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70301007,'机械怪物',0,0,1,'降神塔III小怪7',0,3,0,0,0,202035,'1.3','0',0,0,0,202019,0,'0',345,1,22149,1771876,59063,73828,4430,4430,3544,3544,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70301008,'机器战士',0,0,1,'降神塔III小怪8',0,3,0,0,0,202017,'1.3','0',0,0,0,202015,0,'0',345,1,22993,1839376,61313,76641,4598,4598,3679,3679,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70301009,'机械犬',0,0,1,'降神塔III小怪9',0,3,0,0,0,202016,'1.3','0',0,0,0,202016,0,'0',345,1,23836,1906876,63563,79453,4767,4767,3814,3814,0,'[]','[]',250,2250,1500,2250,200,'[{1110000003,1}]',0,0,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70301010,'神降魔使',0,6,1,'降神塔IIIboss10',0,6,0,0,0,203026,'1.1','0',0,0,0,203026,0,'0',370,30,157781,3155625,70125,87656,5259,5259,4208,4208,0,'[]','[]',600,2250,1500,2250,300,'[{202030261,1},{202030262,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70401001,'暗裔小鬼',0,0,1,'降神塔IV小怪1',0,3,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',345,1,25383,2030626,67688,84609,5077,5077,4061,4061,0,'[]','[]',250,2250,1500,2250,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70401002,'骷髅勇士',0,0,1,'降神塔IV小怪2',0,3,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',345,1,26508,2120626,70688,88359,5302,5302,4241,4241,0,'[]','[]',250,2250,1500,2250,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70401003,'魔焰爆弹',0,0,1,'降神塔IV小怪3',0,3,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',345,1,27633,2210626,73688,92109,5527,5527,4421,4421,0,'[]','[]',250,2250,1500,2250,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70401004,'魔化傀儡',0,0,1,'降神塔IV小怪4',0,3,0,0,0,202015,'1.3','0',0,0,0,202015,0,'0',345,1,28758,2300626,76688,95859,5752,5752,4601,4601,0,'[]','[]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70401005,'魔锤将使',0,6,1,'降神塔IVboss5',0,6,0,0,0,203008,'1.1','0',0,0,0,203008,0,'0',360,20,183094,3661875,81375,101719,6103,6103,4883,4883,0,'[]','[]',250,2250,1500,2250,300,'[{202030081,1},{202030082,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70401006,'机械怪人',0,0,1,'降神塔IV小怪6',0,3,0,0,0,202018,'1.3','0',0,0,0,202015,0,'0',345,1,31641,2531250,84375,105469,6328,6328,5063,5063,0,'[]','[]',250,2250,1500,2250,200,'[{1110000003,1}]',0,0,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70401007,'机械怪物',0,0,1,'降神塔IV小怪7',0,3,0,0,0,202035,'1.3','0',0,0,0,202019,0,'0',345,1,32766,2621250,87375,109219,6553,6553,5243,5243,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70401008,'机器战士',0,0,1,'降神塔IV小怪8',0,3,0,0,0,202017,'1.3','0',0,0,0,202015,0,'0',345,1,33891,2711250,90375,112969,6778,6778,5423,5423,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70401009,'机械犬',0,0,1,'降神塔IV小怪9',0,3,0,0,0,202016,'1.3','0',0,0,0,202016,0,'0',345,1,35016,2801250,93375,116719,7003,7003,5603,5603,0,'[]','[]',250,2250,1500,2250,200,'[{1110000003,1}]',0,0,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70401010,'神降魔使',0,6,1,'降神塔IVboss10',0,6,0,0,0,203026,'1.1','0',0,0,0,203026,0,'0',370,30,229078,4581563,101813,127266,7636,7636,6109,6109,0,'[]','[]',600,2250,1500,2250,300,'[{202030261,1},{202030262,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70501001,'暗裔小鬼',0,0,1,'降神塔V小怪1',0,3,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',345,1,36985,2958750,98625,123281,7397,7397,5918,5918,0,'[]','[]',250,2250,1500,2250,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70501002,'骷髅勇士',0,0,1,'降神塔V小怪2',0,3,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',345,1,38391,3071250,102375,127969,7678,7678,6143,6143,0,'[]','[]',250,2250,1500,2250,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70501003,'魔焰爆弹',0,0,1,'降神塔V小怪3',0,3,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',345,1,39797,3183750,106125,132656,7959,7959,6368,6368,0,'[]','[]',250,2250,1500,2250,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70501004,'魔化傀儡',0,0,1,'降神塔V小怪4',0,3,0,0,0,202015,'1.3','0',0,0,0,202015,0,'0',345,1,41204,3296250,109875,137344,8241,8241,6593,6593,0,'[]','[]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70501005,'魔锤将使',0,6,1,'降神塔Vboss5',0,6,0,0,0,203008,'1.1','0',0,0,0,203008,0,'0',360,20,259875,5197500,115500,144375,8663,8663,6930,6930,0,'[]','[]',250,2250,1500,2250,300,'[{202030081,1},{202030082,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70501006,'机械怪人',0,0,1,'降神塔V小怪6',0,3,0,0,0,202018,'1.3','0',0,0,0,202015,0,'0',345,1,44719,3577500,119250,149063,8944,8944,7155,7155,0,'[]','[]',250,2250,1500,2250,200,'[{1110000003,1}]',0,0,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70501007,'机械怪物',0,0,1,'降神塔V小怪7',0,3,0,0,0,202035,'1.3','0',0,0,0,202019,0,'0',345,1,46125,3690000,123000,153750,9225,9225,7380,7380,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70501008,'机器战士',0,0,1,'降神塔V小怪8',0,3,0,0,0,202017,'1.3','0',0,0,0,202015,0,'0',345,1,47532,3802500,126750,158438,9506,9506,7605,7605,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70501009,'机械犬',0,0,1,'降神塔V小怪9',0,3,0,0,0,202016,'1.3','0',0,0,0,202016,0,'0',345,1,48938,3915000,130500,163125,9788,9788,7830,7830,0,'[]','[]',250,2250,1500,2250,200,'[{1110000003,1}]',0,0,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70501010,'神降魔使',0,6,1,'降神塔Vboss10',0,6,0,0,0,203026,'1.1','0',0,0,0,203026,0,'0',370,30,316828,6336563,140813,176016,10561,10561,8449,8449,0,'[]','[]',600,2250,1500,2250,300,'[{202030261,1},{202030262,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70601001,'暗裔小鬼',0,0,1,'降神塔VI小怪1',0,3,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',345,1,51329,4106250,136875,171094,10266,10266,8213,8213,0,'[]','[]',250,2250,1500,2250,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70601002,'骷髅勇士',0,0,1,'降神塔VI小怪2',0,3,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',345,1,53016,4241250,141375,176719,10603,10603,8483,8483,0,'[]','[]',250,2250,1500,2250,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70601003,'魔焰爆弹',0,0,1,'降神塔VI小怪3',0,3,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',345,1,54704,4376250,145875,182344,10941,10941,8753,8753,0,'[]','[]',250,2250,1500,2250,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70601004,'魔化傀儡',0,0,1,'降神塔VI小怪4',0,3,0,0,0,202015,'1.3','0',0,0,0,202015,0,'0',345,1,56391,4511250,150375,187969,11278,11278,9023,9023,0,'[]','[]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70601005,'魔锤将使',0,6,1,'降神塔VIboss5',0,6,0,0,0,203008,'1.1','0',0,0,0,203008,0,'0',360,20,353109,7062188,156938,196172,11770,11770,9416,9416,0,'[]','[]',250,2250,1500,2250,300,'[{202030081,1},{202030082,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70601006,'机械怪人',0,0,1,'降神塔VI小怪6',0,3,0,0,0,202018,'1.3','0',0,0,0,202015,0,'0',345,1,60539,4843126,161438,201797,12108,12108,9686,9686,0,'[]','[]',250,2250,1500,2250,200,'[{1110000003,1}]',0,0,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70601007,'机械怪物',0,0,1,'降神塔VI小怪7',0,3,0,0,0,202035,'1.3','0',0,0,0,202019,0,'0',345,1,62227,4978126,165938,207422,12445,12445,9956,9956,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70601008,'机器战士',0,0,1,'降神塔VI小怪8',0,3,0,0,0,202017,'1.3','0',0,0,0,202015,0,'0',345,1,63914,5113126,170438,213047,12783,12783,10226,10226,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70601009,'机械犬',0,0,1,'降神塔VI小怪9',0,3,0,0,0,202016,'1.3','0',0,0,0,202016,0,'0',345,1,65602,5248126,174938,218672,13120,13120,10496,10496,0,'[]','[]',250,2250,1500,2250,200,'[{1110000003,1}]',0,0,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70601010,'神降魔使',0,6,1,'降神塔VIboss10',0,6,0,0,0,203026,'1.1','0',0,0,0,203026,0,'0',370,30,421031,8420625,187125,233906,14034,14034,11228,11228,0,'[]','[]',600,2250,1500,2250,300,'[{202030261,1},{202030262,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70701001,'暗裔小鬼',0,0,1,'降神塔VII小怪1',0,3,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',345,1,68414,5473126,182438,228047,13683,13683,10946,10946,0,'[]','[]',250,2250,1500,2250,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70701002,'骷髅勇士',0,0,1,'降神塔VII小怪2',0,3,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',345,1,70383,5630626,187688,234609,14077,14077,11261,11261,0,'[]','[]',250,2250,1500,2250,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70701003,'魔焰爆弹',0,0,1,'降神塔VII小怪3',0,3,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',345,1,72352,5788126,192938,241172,14470,14470,11576,11576,0,'[]','[]',250,2250,1500,2250,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70701004,'魔化傀儡',0,0,1,'降神塔VII小怪4',0,3,0,0,0,202015,'1.3','0',0,0,0,202015,0,'0',345,1,74321,5945626,198188,247734,14864,14864,11891,11891,0,'[]','[]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70701005,'魔锤将使',0,6,1,'降神塔VIIboss5',0,6,0,0,0,203008,'1.1','0',0,0,0,203008,0,'0',360,20,462797,9255938,205688,257109,15427,15427,12341,12341,0,'[]','[]',250,2250,1500,2250,300,'[{202030081,1},{202030082,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70701006,'机械怪人',0,0,1,'降神塔VII小怪6',0,3,0,0,0,202018,'1.3','0',0,0,0,202015,0,'0',345,1,79102,6328126,210938,263672,15820,15820,12656,12656,0,'[]','[]',250,2250,1500,2250,200,'[{1110000003,1}]',0,0,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70701007,'机械怪物',0,0,1,'降神塔VII小怪7',0,3,0,0,0,202035,'1.3','0',0,0,0,202019,0,'0',345,1,81071,6485626,216188,270234,16214,16214,12971,12971,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70701008,'机器战士',0,0,1,'降神塔VII小怪8',0,3,0,0,0,202017,'1.3','0',0,0,0,202015,0,'0',345,1,83039,6643126,221438,276797,16608,16608,13286,13286,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70701009,'机械犬',0,0,1,'降神塔VII小怪9',0,3,0,0,0,202016,'1.3','0',0,0,0,202016,0,'0',345,1,85008,6800626,226688,283359,17002,17002,13601,13601,0,'[]','[]',250,2250,1500,2250,200,'[{1110000003,1}]',0,0,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70701010,'神降魔使',0,6,1,'降神塔VIIboss10',0,6,0,0,0,203026,'1.1','0',0,0,0,203026,0,'0',370,30,541688,10833750,240750,300938,18056,18056,14445,14445,0,'[]','[]',600,2250,1500,2250,300,'[{202030261,1},{202030262,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70801001,'暗裔小鬼',0,0,1,'降神塔VIII小怪1',0,3,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',345,1,88243,7059376,235313,294141,17648,17648,14119,14119,0,'[]','[]',250,2250,1500,2250,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70801002,'骷髅勇士',0,0,1,'降神塔VIII小怪2',0,3,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',345,1,90493,7239376,241313,301641,18098,18098,14479,14479,0,'[]','[]',250,2250,1500,2250,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70801003,'魔焰爆弹',0,0,1,'降神塔VIII小怪3',0,3,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',345,1,92743,7419376,247313,309141,18548,18548,14839,14839,0,'[]','[]',250,2250,1500,2250,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70801004,'魔化傀儡',0,0,1,'降神塔VIII小怪4',0,3,0,0,0,202015,'1.3','0',0,0,0,202015,0,'0',345,1,94993,7599376,253313,316641,18998,18998,15199,15199,0,'[]','[]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70801005,'魔锤将使',0,6,1,'降神塔VIIIboss5',0,6,0,0,0,203008,'1.1','0',0,0,0,203008,0,'0',360,20,588938,11778750,261750,327188,19631,19631,15705,15705,0,'[]','[]',250,2250,1500,2250,300,'[{202030081,1},{202030082,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70801006,'机械怪人',0,0,1,'降神塔VIII小怪6',0,3,0,0,0,202018,'1.3','0',0,0,0,202015,0,'0',345,1,100407,8032500,267750,334688,20081,20081,16065,16065,0,'[]','[]',250,2250,1500,2250,200,'[{1110000003,1}]',0,0,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70801007,'机械怪物',0,0,1,'降神塔VIII小怪7',0,3,0,0,0,202035,'1.3','0',0,0,0,202019,0,'0',345,1,102657,8212500,273750,342188,20531,20531,16425,16425,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70801008,'机器战士',0,0,1,'降神塔VIII小怪8',0,3,0,0,0,202017,'1.3','0',0,0,0,202015,0,'0',345,1,104907,8392500,279750,349688,20981,20981,16785,16785,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70801009,'机械犬',0,0,1,'降神塔VIII小怪9',0,3,0,0,0,202016,'1.3','0',0,0,0,202016,0,'0',345,1,107157,8572500,285750,357188,21431,21431,17145,17145,0,'[]','[]',250,2250,1500,2250,200,'[{1110000003,1}]',0,0,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70801010,'神降魔使',0,6,1,'降神塔VIIIboss10',0,6,0,0,0,203026,'1.1','0',0,0,0,203026,0,'0',370,30,678797,13575938,301688,377109,22627,22627,18101,18101,0,'[]','[]',600,2250,1500,2250,300,'[{202030261,1},{202030262,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70901001,'暗裔小鬼',0,0,1,'降神塔IX小怪1',0,3,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',345,1,110813,8865000,295500,369375,22163,22163,17730,17730,0,'[]','[]',250,2250,1500,2250,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70901002,'骷髅勇士',0,0,1,'降神塔IX小怪2',0,3,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',345,1,113344,9067500,302250,377813,22669,22669,18135,18135,0,'[]','[]',250,2250,1500,2250,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70901003,'魔焰爆弹',0,0,1,'降神塔IX小怪3',0,3,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',345,1,115875,9270000,309000,386250,23175,23175,18540,18540,0,'[]','[]',250,2250,1500,2250,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70901004,'魔化傀儡',0,0,1,'降神塔IX小怪4',0,3,0,0,0,202015,'1.3','0',0,0,0,202015,0,'0',345,1,118407,9472500,315750,394688,23681,23681,18945,18945,0,'[]','[]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70901005,'魔锤将使',0,6,1,'降神塔IXboss5',0,6,0,0,0,203008,'1.1','0',0,0,0,203008,0,'0',360,20,731531,14630625,325125,406406,24384,24384,19508,19508,0,'[]','[]',250,2250,1500,2250,300,'[{202030081,1},{202030082,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70901006,'机械怪人',0,0,1,'降神塔IX小怪6',0,3,0,0,0,202018,'1.3','0',0,0,0,202015,0,'0',345,1,124454,9956250,331875,414844,24891,24891,19913,19913,0,'[]','[]',250,2250,1500,2250,200,'[{1110000003,1}]',0,0,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70901007,'机械怪物',0,0,1,'降神塔IX小怪7',0,3,0,0,0,202035,'1.3','0',0,0,0,202019,0,'0',345,1,126985,10158750,338625,423281,25397,25397,20318,20318,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70901008,'机器战士',0,0,1,'降神塔IX小怪8',0,3,0,0,0,202017,'1.3','0',0,0,0,202015,0,'0',345,1,129516,10361250,345375,431719,25903,25903,20723,20723,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70901009,'机械犬',0,0,1,'降神塔IX小怪9',0,3,0,0,0,202016,'1.3','0',0,0,0,202016,0,'0',345,1,132047,10563750,352125,440156,26409,26409,21128,21128,0,'[]','[]',250,2250,1500,2250,200,'[{1110000003,1}]',0,0,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(70901010,'神降魔使',0,6,1,'降神塔IXboss10',0,6,0,0,0,203026,'1.1','0',0,0,0,203026,0,'0',370,30,832359,16647188,369938,462422,27745,27745,22196,22196,0,'[]','[]',600,2250,1500,2250,300,'[{202030261,1},{202030262,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(71001001,'暗裔小鬼',0,0,1,'降神塔X小怪1',0,3,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',345,1,136125,10890000,363000,453750,27225,27225,21780,21780,0,'[]','[]',250,2250,1500,2250,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(71001002,'骷髅勇士',0,0,1,'降神塔X小怪2',0,3,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',345,1,138938,11115000,370500,463125,27788,27788,22230,22230,0,'[]','[]',250,2250,1500,2250,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(71001003,'魔焰爆弹',0,0,1,'降神塔X小怪3',0,3,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',345,1,141750,11340000,378000,472500,28350,28350,22680,22680,0,'[]','[]',250,2250,1500,2250,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(71001004,'魔化傀儡',0,0,1,'降神塔X小怪4',0,3,0,0,0,202015,'1.3','0',0,0,0,202015,0,'0',345,1,144563,11565000,385500,481875,28913,28913,23130,23130,0,'[]','[]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(71001005,'魔锤将使',0,6,1,'降神塔Xboss5',0,6,0,0,0,203008,'1.1','0',0,0,0,203008,0,'0',360,20,890578,17811563,395813,494766,29686,29686,23749,23749,0,'[]','[]',250,2250,1500,2250,300,'[{202030081,1},{202030082,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(71001006,'机械怪人',0,0,1,'降神塔X小怪6',0,3,0,0,0,202018,'1.3','0',0,0,0,202015,0,'0',345,1,151243,12099376,403313,504141,30248,30248,24199,24199,0,'[]','[]',250,2250,1500,2250,200,'[{1110000003,1}]',0,0,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(71001007,'机械怪物',0,0,1,'降神塔X小怪7',0,3,0,0,0,202035,'1.3','0',0,0,0,202019,0,'0',345,1,154055,12324376,410813,513516,30811,30811,24649,24649,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(71001008,'机器战士',0,0,1,'降神塔X小怪8',0,3,0,0,0,202017,'1.3','0',0,0,0,202015,0,'0',345,1,156868,12549376,418313,522891,31373,31373,25099,25099,0,'[]','[]',100,2250,1500,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(71001009,'机械犬',0,0,1,'降神塔X小怪9',0,3,0,0,0,202016,'1.3','0',0,0,0,202016,0,'0',345,1,159680,12774376,425813,532266,31936,31936,25549,25549,0,'[]','[]',250,2250,1500,3000,200,'[{1110000003,1}]',0,0,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(71001010,'神降魔使',0,6,1,'降神塔Xboss10',0,6,0,0,0,203026,'1.1','0',0,0,0,203026,0,'0',370,30,1002375,20047500,445500,556875,33413,33413,26730,26730,0,'[]','[]',600,2250,1500,2250,300,'[{202030261,1},{202030262,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(71101001,'暗裔小鬼',0,0,1,'降神塔XI小怪1',0,3,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',345,1,164180,13134376,437813,547266,32836,32836,26269,26269,0,'[]','[]',250,2250,1500,2250,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(71101002,'骷髅勇士',0,0,1,'降神塔XI小怪2',0,3,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',345,1,167274,13381876,446063,557578,33455,33455,26764,26764,0,'[]','[]',250,2250,1500,2250,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(71101003,'魔焰爆弹',0,0,1,'降神塔XI小怪3',0,3,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',345,1,170368,13629376,454313,567891,34073,34073,27259,27259,0,'[]','[]',250,2250,1500,2250,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(71101004,'魔化傀儡',0,0,1,'降神塔XI小怪4',0,3,0,0,0,202015,'1.3','0',0,0,0,202015,0,'0',345,1,173461,13876876,462563,578203,34692,34692,27754,27754,0,'[]','[]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(71101005,'魔锤将使',0,6,1,'降神塔XIboss5',0,6,0,0,0,203008,'1.1','0',0,0,0,203008,0,'0',360,20,1066078,21321563,473813,592266,35536,35536,28429,28429,0,'[]','[]',250,2250,1500,2250,300,'[{202030081,1},{202030082,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(71101006,'机械怪人',0,0,1,'降神塔XI小怪6',0,3,0,0,0,202018,'1.3','0',0,0,0,202015,0,'0',345,1,180774,14461876,482063,602578,36155,36155,28924,28924,0,'[]','[]',250,2250,1500,2250,200,'[{1110000003,1}]',0,0,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(71101007,'机械怪物',0,0,1,'降神塔XI小怪7',0,3,0,0,0,202035,'1.3','0',0,0,0,202019,0,'0',345,1,183868,14709376,490313,612891,36773,36773,29419,29419,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(71101008,'机器战士',0,0,1,'降神塔XI小怪8',0,3,0,0,0,202017,'1.3','0',0,0,0,202015,0,'0',345,1,186961,14956876,498563,623203,37392,37392,29914,29914,0,'[]','[]',100,2250,1500,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(71101009,'机械犬',0,0,1,'降神塔XI小怪9',0,3,0,0,0,202016,'1.3','0',0,0,0,202016,0,'0',345,1,190055,15204376,506813,633516,38011,38011,30409,30409,0,'[]','[]',250,2250,1500,3000,200,'[{1110000003,1}]',0,0,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(71101010,'神降魔使',0,6,1,'降神塔XIboss10',0,6,0,0,0,203026,'1.1','0',0,0,0,203026,0,'0',370,30,1188844,23776875,528375,660469,39628,39628,31703,31703,0,'[]','[]',600,2250,1500,2250,300,'[{202030261,1},{202030262,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(71201001,'暗裔小鬼',0,0,1,'降神塔XII小怪1',0,3,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',345,1,194977,15598126,519938,649922,38995,38995,31196,31196,0,'[]','[]',250,2250,1500,2250,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(71201002,'骷髅勇士',0,0,1,'降神塔XII小怪2',0,3,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',345,1,198352,15868126,528938,661172,39670,39670,31736,31736,0,'[]','[]',250,2250,1500,2250,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(71201003,'魔焰爆弹',0,0,1,'降神塔XII小怪3',0,3,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',345,1,201727,16138126,537938,672422,40345,40345,32276,32276,0,'[]','[]',250,2250,1500,2250,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(71201004,'魔化傀儡',0,0,1,'降神塔XII小怪4',0,3,0,0,0,202015,'1.3','0',0,0,0,202015,0,'0',345,1,205102,16408126,546938,683672,41020,41020,32816,32816,0,'[]','[]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(71201005,'魔锤将使',0,6,1,'降神塔XIIboss5',0,6,0,0,0,203008,'1.1','0',0,0,0,203008,0,'0',360,20,1258031,25160625,559125,698906,41934,41934,33548,33548,0,'[]','[]',250,2250,1500,2250,300,'[{202030081,1},{202030082,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(71201006,'机械怪人',0,0,1,'降神塔XII小怪6',0,3,0,0,0,202018,'1.3','0',0,0,0,202015,0,'0',345,1,213047,17043750,568125,710156,42609,42609,34088,34088,0,'[]','[]',250,2250,1500,2250,200,'[{1110000003,1}]',0,0,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(71201007,'机械怪物',0,0,1,'降神塔XII小怪7',0,3,0,0,0,202035,'1.3','0',0,0,0,202019,0,'0',345,1,216422,17313750,577125,721406,43284,43284,34628,34628,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(71201008,'机器战士',0,0,1,'降神塔XII小怪8',0,3,0,0,0,202017,'1.3','0',0,0,0,202015,0,'0',345,1,219797,17583750,586125,732656,43959,43959,35168,35168,0,'[]','[]',100,2250,1500,3000,200,'[{1110000003,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(71201009,'机械犬',0,0,1,'降神塔XII小怪9',0,3,0,0,0,202016,'1.3','0',0,0,0,202016,0,'0',345,1,223172,17853750,595125,743906,44634,44634,35708,35708,0,'[]','[]',250,2250,1500,3000,200,'[{1110000003,1}]',0,0,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(71201010,'神降魔使',0,6,1,'降神塔XIIboss10',0,6,0,0,0,203026,'1.1','0',0,0,0,203026,0,'0',370,30,1391766,27835313,618563,773203,46392,46392,37114,37114,0,'[]','[]',600,2250,1500,2250,300,'[{202030261,1},{202030262,1}]',0,2000,0,0,0,1,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,0,0,0),(100000001,'暗裔死神',0,6,0,'朔月海岸-无缝切换boss【新手】Lv15任务id：10150暗裔来袭BOSS',0,4,0,0,0,203018,'1.2','0',0,0,0,203018,0,'0',15,3,144,1407,73,60,0,1,1,1,0,'[]','[]',600,2250,1500,2250,200,'[{2000201801,1},{20005455,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(100020001,'蜘蛛女皇',0,6,0,'抵抗军营-无缝切换boss【新手】Lv35任务id：10350暗裔突袭BOSS',0,4,0,0,0,203011,'1.5','0',0,0,0,203011,0,'0',33,7,163,2399,201,123,93,1,1,1,0,'[]','[]',600,1500,1500,1500,200,'[{200022021,1},{200022022,1}]',100,2000,0,1,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(100030001,'荆棘之花',0,6,0,'迷雾沼泽-无缝切换boss【新手】Lv77任务id：10740荆棘之花BOSS',0,4,0,0,0,203001,'1.2','0',0,0,0,203001,0,'0',77,15,690,44230,666,849,120,1,1,1,0,'[]','[]',600,800,800,800,200,'[{202030011,1},{202030012,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(100060001,'神殿人马',0,6,0,'森林神殿-无缝切换boss-主线剧情副本3Lv200任务id：12010神殿人马BOSS',0,4,0,0,0,203002,'1.3','0',0,0,0,203002,0,'0',200,40,4092,199316,4274,2449,120,120,98,110,0,'[]','[]',110,800,800,800,200,'[{200022011,1},{200022014,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(100070001,'冰脉巨龙',0,6,0,'寒鸦峡谷-无缝切换boss-主线剧情副本4Lv260任务id：12360冰霜巨龙BOSS',0,4,0,0,0,203004,'1.1','0',0,0,0,203004,0,'0',260,52,11223,575568,11319,6955,454,454,557,581,0,'[]','[]',110,800,800,800,200,'[{202030041,1},{202030043,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(100080001,'阿努比斯',0,6,0,'寒鸦峡谷-无缝切换boss-主线剧情副本5Lv390任务id：12990威严死神BOSS',0,4,0,0,0,203005,'1.3','0',0,0,0,203005,0,'0',300,78,18043,861954,17754,10133,819,819,1004,1018,0,'[]','[]',110,800,800,800,200,'[{202030051,1},{202030052,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(100090001,'恶魔骑士',0,6,0,'风蚀台地-无缝切换boss-主线剧情副本6Lv440任务id：13190恶魔骑士BOSS',0,4,0,0,0,203007,'1.3','0',0,0,0,203007,0,'0',330,88,19988,1493121,22942,15097,1265,1265,1188,1208,0,'[]','[]',110,900,900,900,200,'[{2000230301,1},{2000230303,1}]',0,2000,0,1,0,0,0,0,0,1,1,1,0,0,'[]',1,'0',0,0,1,0,0),(100300001,'森林狼',0,2,1,'星灵试炼引导副本  任务id10500',0,3,0,0,0,202006,'1','0',0,0,0,202006,0,'5||等冰块融了就能吃羊了:3||抓回来的那个羊怎么结冰了:3',50,10,59,2687,255,210,93,93,0,0,0,'[]','[]',250,1000,1000,1000,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(100300002,'怠惰',0,6,0,'星灵试炼引导副本  任务id10500',0,3,0,0,0,203013,'1.1','0',0,0,0,203013,0,'5||没有星灵协助的你太弱小了:3||少了白羊你不是我对手:3',50,10,95,13434,255,210,93,93,0,0,0,'[]','[]',250,2250,1500,2250,300,'[{202030131,1},{202030132,1}]',0,2000,0,1,0,1,0,0,0,1,1,1,1,0,'[]',1,'0',0,0,0,0,0),(100300003,'白羊晶石',0,6,0,'星灵试炼引导副本  任务id10500',0,3,0,0,0,501001,'1.1','0',0,0,0,501001,0,'0',50,10,178,90,255,210,93,93,0,0,0,'[]','[]',250,2250,1500,2250,300,'[{1110000003,1}]',0,2000,0,1,0,1,0,0,0,0,1,1,1,0,'[]',1,'0',0,0,0,0,0),(400010001,'暗裔小鬼',0,0,0,'宝宝副本1关小怪Lv310',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:3',310,1,20021,669531,19483,12408,967,967,1066,1082,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010002,'拆塔狂魔',0,0,0,'宝宝副本2关小怪Lv313',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:4',313,1,24737,763991,20002,12930,1012,1012,1084,1101,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010003,'爆弹怪',0,0,0,'宝宝副本3关小怪Lv316',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:5',316,1,29692,863373,20521,13453,1057,1057,1102,1120,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010004,'暗裔小鬼',0,0,0,'宝宝副本4关小怪Lv319',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:6',319,1,34885,967830,21040,13975,1101,1101,1121,1139,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010005,'拆塔狂魔',0,0,0,'宝宝副本5关小怪Lv322',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:7',322,1,40316,1077194,21559,14498,1146,1146,1139,1158,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010006,'爆弹怪',0,0,0,'宝宝副本6关小怪Lv325',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:8',325,1,43685,1191544,22078,15021,1190,1190,1158,1177,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010007,'暗裔小鬼',0,0,0,'宝宝副本7关小怪Lv328',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:9',328,1,46706,1392931,22596,15543,1235,1235,1176,1196,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010008,'拆塔狂魔',0,0,0,'宝宝副本8关小怪Lv331',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:10',331,1,47885,1604186,23115,16066,1279,1279,1194,1215,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010009,'爆弹怪',0,0,0,'宝宝副本9关小怪Lv334',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',334,1,49064,1825569,23634,16588,1324,1324,1213,1234,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010010,'暗裔小鬼',0,0,0,'宝宝副本10关小怪Lv337',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',337,1,50243,2056786,24153,17111,1369,1369,1231,1252,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010011,'暗裔小鬼',0,0,0,'宝宝副本11关小怪Lv340',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',340,1,51422,2298166,24672,17633,1413,1413,1250,1271,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010012,'拆塔狂魔',0,0,0,'宝宝副本12关小怪Lv344',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',344,1,52994,2381348,25364,18330,1473,1473,1274,1297,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010013,'爆弹怪',0,0,0,'宝宝副本13关小怪Lv348',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',348,1,54567,2464528,26056,19027,1532,1532,1299,1322,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010014,'暗裔小鬼',0,0,0,'宝宝副本14关小怪Lv352',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',352,1,56314,2570488,26799,19856,1635,1635,1366,1391,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010015,'拆塔狂魔',0,0,0,'宝宝副本15关小怪Lv356',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',356,1,58230,2699030,27595,20818,1782,1782,1477,1503,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010016,'爆弹怪',0,0,0,'宝宝副本16关小怪Lv360',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',360,1,60151,2827571,28390,21780,1929,1929,1587,1615,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010017,'暗裔小鬼',0,0,0,'宝宝副本17关小怪Lv364',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',364,1,62069,2956111,29186,22742,2075,2075,1698,1727,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010018,'拆塔狂魔',0,0,0,'宝宝副本18关小怪Lv368',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',368,1,63987,3084650,29982,23704,2222,2222,1808,1840,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010019,'爆弹怪',0,0,0,'宝宝副本19关小怪Lv372',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',372,1,65909,3213189,30777,24666,2369,2369,1919,1952,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010020,'暗裔小鬼',0,0,0,'宝宝副本20关小怪Lv376',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',376,1,67827,3341964,31573,25627,2515,2515,2029,2064,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010021,'暗裔小鬼',0,0,0,'宝宝副本21关小怪Lv380',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',380,1,69750,3470506,32368,26589,2662,2662,2140,2176,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010022,'拆塔狂魔',0,0,0,'宝宝副本22关小怪Lv385',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',385,1,72148,3631058,33363,27792,2845,2845,2278,2316,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010023,'爆弹怪',0,0,0,'宝宝副本23关小怪Lv390',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',390,1,74550,3791857,34357,28994,3029,3029,2416,2457,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010024,'暗裔小鬼',0,0,0,'宝宝副本24关小怪Lv395',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',395,1,76947,3952401,35352,30197,3212,3212,2554,2597,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010025,'拆塔狂魔',0,0,0,'宝宝副本25关小怪Lv400',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',400,1,79348,4113203,36346,31399,3395,3395,2692,2737,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010026,'爆弹怪',0,0,0,'宝宝副本26关小怪Lv405',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',405,1,81678,4241314,37266,32291,3570,3570,2780,2833,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010027,'暗裔小鬼',0,0,0,'宝宝副本27关小怪Lv410',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',410,1,84011,4369156,38185,33184,3745,3745,2868,2928,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010028,'拆塔狂魔',0,0,0,'宝宝副本28关小怪Lv415',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',415,1,86338,4497269,39105,34076,3919,3919,2956,3024,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010029,'爆弹怪',0,0,0,'宝宝副本29关小怪Lv420',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',420,1,88668,4625107,40024,34969,4094,4094,3045,3120,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010030,'暗裔小鬼',0,0,0,'宝宝副本30关小怪Lv425',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',425,1,90993,4753221,40944,35861,4269,4269,3133,3216,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010031,'暗裔小鬼',0,0,0,'宝宝副本31关小怪Lv430',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',430,1,93320,4881337,41863,36753,4444,4444,3221,3312,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010032,'拆塔狂魔',0,0,0,'宝宝副本32关小怪Lv435',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',435,1,95641,5009172,42783,37646,4618,4618,3309,3407,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010033,'爆弹怪',0,0,0,'宝宝副本33关小怪Lv440',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',440,1,97965,5137289,43702,38538,4793,4793,3397,3503,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010034,'暗裔小鬼',0,0,0,'宝宝副本34关小怪Lv445',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',445,1,100283,5265121,44622,39431,4968,4968,3485,3599,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010035,'拆塔狂魔',0,0,0,'宝宝副本35关小怪Lv450',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',450,1,102603,5393239,45541,40323,5142,5142,3573,3695,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010036,'爆弹怪',0,0,0,'宝宝副本36关小怪Lv455',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',455,1,106020,5583781,46913,41687,5398,5398,3764,3897,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010037,'暗裔小鬼',0,0,0,'宝宝副本37关小怪Lv460',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',460,1,109437,5774322,48285,43051,5654,5654,3955,4100,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010038,'拆塔狂魔',0,0,0,'宝宝副本38关小怪Lv465',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',465,1,112855,5964864,49657,44415,5910,5910,4146,4302,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010039,'爆弹怪',0,0,0,'宝宝副本39关小怪Lv470',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',470,1,116273,6155405,51029,45779,6165,6165,4337,4505,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010040,'暗裔小鬼',0,0,0,'宝宝副本40关小怪Lv475',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',475,1,119691,6345947,52401,47143,6421,6421,4528,4707,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010041,'暗裔小鬼',0,0,0,'宝宝副本41关小怪Lv480',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',480,1,123112,6536489,53772,48507,6677,6677,4719,4910,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010042,'拆塔狂魔',0,0,0,'宝宝副本42关小怪Lv485',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',485,1,126529,6727030,55144,49871,6933,6933,4910,5112,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010043,'爆弹怪',0,0,0,'宝宝副本43关小怪Lv490',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',490,1,129945,6917572,56516,51235,7188,7188,5101,5315,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010044,'暗裔小鬼',0,0,0,'宝宝副本44关小怪Lv495',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',495,1,133360,7108113,57888,52599,7444,7444,5292,5517,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010045,'拆塔狂魔',0,0,0,'宝宝副本45关小怪Lv500',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',500,1,136774,7298655,59260,53963,7700,7700,5483,5720,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010046,'爆弹怪',0,0,0,'宝宝副本46关小怪Lv506',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',506,1,141562,7563230,61131,55835,8323,8323,5864,6108,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010047,'暗裔小鬼',0,0,0,'宝宝副本47关小怪Lv512',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',512,1,146349,7827804,63002,57707,8947,8947,6245,6496,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010048,'拆塔狂魔',0,0,0,'宝宝副本48关小怪Lv518',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',518,1,151132,8092376,64874,59579,9570,9570,6626,6884,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010049,'爆弹怪',0,0,0,'宝宝副本49关小怪Lv524',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',524,1,155917,8356948,66745,61451,10194,10194,7007,7273,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010050,'暗裔小鬼',0,0,0,'宝宝副本50关小怪Lv530',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',530,1,160702,8621866,68616,63322,10818,10818,7388,7661,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010051,'暗裔小鬼',0,0,0,'宝宝副本51关小怪Lv536',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',536,1,165485,8886440,70487,65194,11441,11441,7769,8049,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010052,'拆塔狂魔',0,0,0,'宝宝副本52关小怪Lv542',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',542,1,170266,9151013,72358,67066,12065,12065,8150,8437,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010053,'爆弹怪',0,0,0,'宝宝副本53关小怪Lv548',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',548,1,175040,9415585,74230,68938,12688,12688,8531,8825,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010054,'暗裔小鬼',0,0,0,'宝宝副本54关小怪Lv554',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',554,1,180048,9691766,76192,70909,13199,13199,8818,9111,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010055,'拆塔狂魔',0,0,0,'宝宝副本55关小怪Lv560',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',560,1,185172,9973571,78199,72930,13653,13653,9059,9344,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010056,'爆弹怪',0,0,0,'宝宝副本56关小怪Lv566',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',566,1,190289,10255377,80207,74951,14106,14106,9299,9578,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010057,'暗裔小鬼',0,0,0,'宝宝副本57关小怪Lv572',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',572,1,195408,10537183,82214,76972,14560,14560,9539,9812,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010058,'拆塔狂魔',0,0,0,'宝宝副本58关小怪Lv578',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',578,1,200520,10818615,84222,78994,15014,15014,9779,10045,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010059,'爆弹怪',0,0,0,'宝宝副本59关小怪Lv584',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',584,1,205634,11100419,86229,81015,15468,15468,10019,10279,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010060,'暗裔小鬼',0,0,0,'宝宝副本60关小怪Lv590',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',590,1,210739,11382223,88237,83036,15922,15922,10260,10513,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010061,'暗裔小鬼',0,0,0,'宝宝副本61关小怪Lv598',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',598,1,217543,11758217,90914,85730,16527,16527,10580,10824,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010062,'拆塔狂魔',0,0,0,'宝宝副本62关小怪Lv606',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',606,1,224919,13637368,93956,88809,17227,17227,11073,11303,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010063,'爆弹怪',0,0,0,'宝宝副本63关小怪Lv614',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',614,1,232481,14099001,97120,92015,17958,17958,11625,11839,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010064,'暗裔小鬼',0,0,0,'宝宝副本64关小怪Lv622',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',622,1,240038,14560636,100284,95221,18689,18689,12176,12374,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010065,'拆塔狂魔',0,0,0,'宝宝副本65关小怪Lv630',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',630,1,247595,15022273,103447,98427,19420,19420,12727,12909,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010066,'爆弹怪',0,0,0,'宝宝副本66关小怪Lv638',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',638,1,255140,15483463,106611,101634,20152,20152,13279,13444,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010067,'暗裔小鬼',0,0,0,'宝宝副本67关小怪Lv646',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',646,1,262678,15945099,109775,104840,20883,20883,13830,13979,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010068,'拆塔狂魔',0,0,0,'宝宝副本68关小怪Lv654',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',654,1,271074,16464940,112997,108112,21581,21581,14264,14406,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010069,'爆弹怪',0,0,0,'宝宝副本69关小怪Lv662',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',662,1,280334,17042525,116276,111451,22247,22247,14581,14725,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010070,'暗裔小鬼',0,0,0,'宝宝副本70关小怪Lv670',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',670,1,289583,17620570,119556,114789,22913,22913,14897,15045,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010071,'暗裔小鬼',0,0,0,'宝宝副本71关小怪Lv678',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',678,1,298826,18198620,122836,118127,23578,23578,15214,15364,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010072,'拆塔狂魔',0,0,0,'宝宝副本72关小怪Lv686',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',686,1,308067,18776197,126115,121466,24244,24244,15530,15683,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010073,'爆弹怪',0,0,0,'宝宝副本73关小怪Lv694',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',694,1,317295,19354249,129395,124804,24909,24909,15847,16003,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010074,'暗裔小鬼',0,0,0,'宝宝副本74关小怪Lv702',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',702,1,326322,19914968,132727,128197,25553,25553,16164,16315,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010075,'拆塔狂魔',0,0,0,'宝宝副本75关小怪Lv710',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',710,1,334733,20425129,136220,131752,26130,26130,16481,16607,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010076,'爆弹怪',0,0,0,'宝宝副本76关小怪Lv718',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',718,1,343140,20935776,139712,135306,26706,26706,16798,16899,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010077,'暗裔小鬼',0,0,0,'宝宝副本77关小怪Lv726',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',726,1,351538,21445937,143204,138861,27283,27283,17115,17191,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010078,'拆塔狂魔',0,0,0,'宝宝副本78关小怪Lv734',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',734,1,359920,21956098,146697,142416,27860,27860,17433,17483,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010079,'爆弹怪',0,0,0,'宝宝副本79关小怪Lv742',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',742,1,368298,22466259,150189,145971,28436,28436,17750,17775,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010080,'暗裔小鬼',0,0,0,'宝宝副本80关小怪Lv750',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',750,1,376660,22976419,153682,149526,29013,29013,18067,18067,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010081,'暗裔小鬼',0,0,0,'宝宝副本81关小怪Lv758',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',758,1,385847,23527640,157720,153662,29596,29596,18665,18665,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010082,'拆塔狂魔',0,0,0,'宝宝副本82关小怪Lv766',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',766,1,395019,24079354,161759,157797,30179,30179,19262,19262,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010083,'爆弹怪',0,0,0,'宝宝副本83关小怪Lv774',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',774,1,404181,24630574,165798,161933,30763,30763,19860,19860,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010084,'暗裔小鬼',0,0,0,'宝宝副本84关小怪Lv782',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',782,1,413333,25181794,169837,166069,31346,31346,20458,20458,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010085,'拆塔狂魔',0,0,0,'宝宝副本85关小怪Lv790',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',790,1,422479,25733511,173875,170204,31929,31929,21055,21055,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010086,'爆弹怪',0,0,0,'宝宝副本86关小怪Lv798',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',798,1,435700,26505292,179092,175311,32887,32887,21688,21688,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010087,'暗裔小鬼',0,0,0,'宝宝副本87关小怪Lv806',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',806,1,449350,30533983,184465,180570,33874,33874,22338,22338,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010088,'拆塔狂魔',0,0,0,'宝宝副本88关小怪Lv814',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',814,1,463437,31449983,189999,185987,34891,34891,23008,23008,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010089,'爆弹怪',0,0,0,'宝宝副本89关小怪Lv822',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',822,1,477982,32393468,195699,191567,35938,35938,23699,23699,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010090,'暗裔小鬼',0,0,0,'宝宝副本90关小怪Lv830',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',830,1,492996,33365238,201570,197314,37016,37016,24409,24409,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010091,'暗裔小鬼',0,0,0,'宝宝副本91关小怪Lv838',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',838,1,508495,34366163,207617,203233,38126,38126,25142,25142,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010092,'拆塔狂魔',0,0,0,'宝宝副本92关小怪Lv846',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',846,1,524499,35397118,213845,209330,39270,39270,25896,25896,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010093,'爆弹怪',0,0,0,'宝宝副本93关小怪Lv854',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',854,1,541023,36459048,220260,215610,40448,40448,26673,26673,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010094,'暗裔小鬼',0,0,0,'宝宝副本94关小怪Lv862',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',862,1,558076,37552825,226869,222078,41661,41661,27473,27473,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010095,'拆塔狂魔',0,0,0,'宝宝副本95关小怪Lv870',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',870,1,575693,38679393,233674,228740,42912,42912,28298,28298,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010096,'爆弹怪',0,0,0,'宝宝副本96关小怪Lv878',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',878,1,593879,39839772,240684,235602,44199,44199,29147,29147,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010097,'暗裔小鬼',0,0,0,'宝宝副本97关小怪Lv886',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',886,1,612657,41034979,247905,242670,45525,45525,30021,30021,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010098,'拆塔狂魔',0,0,0,'宝宝副本98关小怪Lv894',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',894,1,632044,42266032,255343,249950,46891,46891,30922,30922,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010099,'爆弹怪',0,0,0,'宝宝副本99关小怪Lv902',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',902,1,652066,43534022,263003,257449,48298,48298,31849,31849,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400010100,'暗裔小鬼',0,0,0,'宝宝副本100关小怪Lv910',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',910,1,672741,44840039,270893,265172,49747,49747,32804,32804,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020001,'暗裔小鬼',0,0,0,'宝宝副本1关小怪Lv310',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:3',310,1,20021,669531,19483,12408,967,967,1066,1082,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020002,'拆塔狂魔',0,0,0,'宝宝副本2关小怪Lv313',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:4',313,1,24737,763991,20002,12930,1012,1012,1084,1101,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020003,'爆弹怪',0,0,0,'宝宝副本3关小怪Lv316',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:5',316,1,29692,863373,20521,13453,1057,1057,1102,1120,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020004,'暗裔小鬼',0,0,0,'宝宝副本4关小怪Lv319',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:6',319,1,34885,967830,21040,13975,1101,1101,1121,1139,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020005,'拆塔狂魔',0,0,0,'宝宝副本5关小怪Lv322',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:7',322,1,40316,1077194,21559,14498,1146,1146,1139,1158,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020006,'爆弹怪',0,0,0,'宝宝副本6关小怪Lv325',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:8',325,1,43685,1191544,22078,15021,1190,1190,1158,1177,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020007,'暗裔小鬼',0,0,0,'宝宝副本7关小怪Lv328',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:9',328,1,46706,1392931,22596,15543,1235,1235,1176,1196,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020008,'拆塔狂魔',0,0,0,'宝宝副本8关小怪Lv331',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:10',331,1,47885,1604186,23115,16066,1279,1279,1194,1215,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020009,'爆弹怪',0,0,0,'宝宝副本9关小怪Lv334',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',334,1,49064,1825569,23634,16588,1324,1324,1213,1234,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020010,'暗裔小鬼',0,0,0,'宝宝副本10关小怪Lv337',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',337,1,50243,2056786,24153,17111,1369,1369,1231,1252,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020011,'暗裔小鬼',0,0,0,'宝宝副本11关小怪Lv340',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',340,1,51422,2298166,24672,17633,1413,1413,1250,1271,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020012,'拆塔狂魔',0,0,0,'宝宝副本12关小怪Lv344',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',344,1,52994,2381348,25364,18330,1473,1473,1274,1297,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020013,'爆弹怪',0,0,0,'宝宝副本13关小怪Lv348',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',348,1,54567,2464528,26056,19027,1532,1532,1299,1322,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020014,'暗裔小鬼',0,0,0,'宝宝副本14关小怪Lv352',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',352,1,56314,2570488,26799,19856,1635,1635,1366,1391,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020015,'拆塔狂魔',0,0,0,'宝宝副本15关小怪Lv356',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',356,1,58230,2699030,27595,20818,1782,1782,1477,1503,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020016,'爆弹怪',0,0,0,'宝宝副本16关小怪Lv360',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',360,1,60151,2827571,28390,21780,1929,1929,1587,1615,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020017,'暗裔小鬼',0,0,0,'宝宝副本17关小怪Lv364',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',364,1,62069,2956111,29186,22742,2075,2075,1698,1727,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020018,'拆塔狂魔',0,0,0,'宝宝副本18关小怪Lv368',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',368,1,63987,3084650,29982,23704,2222,2222,1808,1840,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020019,'爆弹怪',0,0,0,'宝宝副本19关小怪Lv372',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',372,1,65909,3213189,30777,24666,2369,2369,1919,1952,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020020,'暗裔小鬼',0,0,0,'宝宝副本20关小怪Lv376',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',376,1,67827,3341964,31573,25627,2515,2515,2029,2064,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020021,'暗裔小鬼',0,0,0,'宝宝副本21关小怪Lv380',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',380,1,69750,3470506,32368,26589,2662,2662,2140,2176,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020022,'拆塔狂魔',0,0,0,'宝宝副本22关小怪Lv385',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',385,1,72148,3631058,33363,27792,2845,2845,2278,2316,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020023,'爆弹怪',0,0,0,'宝宝副本23关小怪Lv390',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',390,1,74550,3791857,34357,28994,3029,3029,2416,2457,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020024,'暗裔小鬼',0,0,0,'宝宝副本24关小怪Lv395',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',395,1,76947,3952401,35352,30197,3212,3212,2554,2597,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020025,'拆塔狂魔',0,0,0,'宝宝副本25关小怪Lv400',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',400,1,79348,4113203,36346,31399,3395,3395,2692,2737,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020026,'爆弹怪',0,0,0,'宝宝副本26关小怪Lv405',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',405,1,81678,4241314,37266,32291,3570,3570,2780,2833,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020027,'暗裔小鬼',0,0,0,'宝宝副本27关小怪Lv410',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',410,1,84011,4369156,38185,33184,3745,3745,2868,2928,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020028,'拆塔狂魔',0,0,0,'宝宝副本28关小怪Lv415',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',415,1,86338,4497269,39105,34076,3919,3919,2956,3024,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020029,'爆弹怪',0,0,0,'宝宝副本29关小怪Lv420',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',420,1,88668,4625107,40024,34969,4094,4094,3045,3120,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020030,'暗裔小鬼',0,0,0,'宝宝副本30关小怪Lv425',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',425,1,90993,4753221,40944,35861,4269,4269,3133,3216,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020031,'暗裔小鬼',0,0,0,'宝宝副本31关小怪Lv430',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',430,1,93320,4881337,41863,36753,4444,4444,3221,3312,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020032,'拆塔狂魔',0,0,0,'宝宝副本32关小怪Lv435',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',435,1,95641,5009172,42783,37646,4618,4618,3309,3407,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020033,'爆弹怪',0,0,0,'宝宝副本33关小怪Lv440',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',440,1,97965,5137289,43702,38538,4793,4793,3397,3503,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020034,'暗裔小鬼',0,0,0,'宝宝副本34关小怪Lv445',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',445,1,100283,5265121,44622,39431,4968,4968,3485,3599,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020035,'拆塔狂魔',0,0,0,'宝宝副本35关小怪Lv450',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',450,1,102603,5393239,45541,40323,5142,5142,3573,3695,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020036,'爆弹怪',0,0,0,'宝宝副本36关小怪Lv455',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',455,1,106020,5583781,46913,41687,5398,5398,3764,3897,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020037,'暗裔小鬼',0,0,0,'宝宝副本37关小怪Lv460',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',460,1,109437,5774322,48285,43051,5654,5654,3955,4100,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020038,'拆塔狂魔',0,0,0,'宝宝副本38关小怪Lv465',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',465,1,112855,5964864,49657,44415,5910,5910,4146,4302,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020039,'爆弹怪',0,0,0,'宝宝副本39关小怪Lv470',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',470,1,116273,6155405,51029,45779,6165,6165,4337,4505,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020040,'暗裔小鬼',0,0,0,'宝宝副本40关小怪Lv475',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',475,1,119691,6345947,52401,47143,6421,6421,4528,4707,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020041,'暗裔小鬼',0,0,0,'宝宝副本41关小怪Lv480',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',480,1,123112,6536489,53772,48507,6677,6677,4719,4910,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020042,'拆塔狂魔',0,0,0,'宝宝副本42关小怪Lv485',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',485,1,126529,6727030,55144,49871,6933,6933,4910,5112,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020043,'爆弹怪',0,0,0,'宝宝副本43关小怪Lv490',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',490,1,129945,6917572,56516,51235,7188,7188,5101,5315,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020044,'暗裔小鬼',0,0,0,'宝宝副本44关小怪Lv495',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',495,1,133360,7108113,57888,52599,7444,7444,5292,5517,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020045,'拆塔狂魔',0,0,0,'宝宝副本45关小怪Lv500',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',500,1,136774,7298655,59260,53963,7700,7700,5483,5720,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020046,'爆弹怪',0,0,0,'宝宝副本46关小怪Lv506',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',506,1,141562,7563230,61131,55835,8323,8323,5864,6108,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020047,'暗裔小鬼',0,0,0,'宝宝副本47关小怪Lv512',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',512,1,146349,7827804,63002,57707,8947,8947,6245,6496,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020048,'拆塔狂魔',0,0,0,'宝宝副本48关小怪Lv518',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',518,1,151132,8092376,64874,59579,9570,9570,6626,6884,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020049,'爆弹怪',0,0,0,'宝宝副本49关小怪Lv524',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',524,1,155917,8356948,66745,61451,10194,10194,7007,7273,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020050,'暗裔小鬼',0,0,0,'宝宝副本50关小怪Lv530',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',530,1,160702,8621866,68616,63322,10818,10818,7388,7661,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020051,'暗裔小鬼',0,0,0,'宝宝副本51关小怪Lv536',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',536,1,165485,8886440,70487,65194,11441,11441,7769,8049,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020052,'拆塔狂魔',0,0,0,'宝宝副本52关小怪Lv542',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',542,1,170266,9151013,72358,67066,12065,12065,8150,8437,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020053,'爆弹怪',0,0,0,'宝宝副本53关小怪Lv548',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',548,1,175040,9415585,74230,68938,12688,12688,8531,8825,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020054,'暗裔小鬼',0,0,0,'宝宝副本54关小怪Lv554',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',554,1,180048,9691766,76192,70909,13199,13199,8818,9111,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020055,'拆塔狂魔',0,0,0,'宝宝副本55关小怪Lv560',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',560,1,185172,9973571,78199,72930,13653,13653,9059,9344,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020056,'爆弹怪',0,0,0,'宝宝副本56关小怪Lv566',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',566,1,190289,10255377,80207,74951,14106,14106,9299,9578,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020057,'暗裔小鬼',0,0,0,'宝宝副本57关小怪Lv572',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',572,1,195408,10537183,82214,76972,14560,14560,9539,9812,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020058,'拆塔狂魔',0,0,0,'宝宝副本58关小怪Lv578',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',578,1,200520,10818615,84222,78994,15014,15014,9779,10045,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020059,'爆弹怪',0,0,0,'宝宝副本59关小怪Lv584',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',584,1,205634,11100419,86229,81015,15468,15468,10019,10279,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020060,'暗裔小鬼',0,0,0,'宝宝副本60关小怪Lv590',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',590,1,210739,11382223,88237,83036,15922,15922,10260,10513,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020061,'暗裔小鬼',0,0,0,'宝宝副本61关小怪Lv598',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',598,1,217543,11758217,90914,85730,16527,16527,10580,10824,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020062,'拆塔狂魔',0,0,0,'宝宝副本62关小怪Lv606',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',606,1,224919,13637368,93956,88809,17227,17227,11073,11303,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020063,'爆弹怪',0,0,0,'宝宝副本63关小怪Lv614',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',614,1,232481,14099001,97120,92015,17958,17958,11625,11839,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020064,'暗裔小鬼',0,0,0,'宝宝副本64关小怪Lv622',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',622,1,240038,14560636,100284,95221,18689,18689,12176,12374,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020065,'拆塔狂魔',0,0,0,'宝宝副本65关小怪Lv630',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',630,1,247595,15022273,103447,98427,19420,19420,12727,12909,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020066,'爆弹怪',0,0,0,'宝宝副本66关小怪Lv638',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',638,1,255140,15483463,106611,101634,20152,20152,13279,13444,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020067,'暗裔小鬼',0,0,0,'宝宝副本67关小怪Lv646',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',646,1,262678,15945099,109775,104840,20883,20883,13830,13979,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020068,'拆塔狂魔',0,0,0,'宝宝副本68关小怪Lv654',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',654,1,271074,16464940,112997,108112,21581,21581,14264,14406,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020069,'爆弹怪',0,0,0,'宝宝副本69关小怪Lv662',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',662,1,280334,17042525,116276,111451,22247,22247,14581,14725,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020070,'暗裔小鬼',0,0,0,'宝宝副本70关小怪Lv670',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',670,1,289583,17620570,119556,114789,22913,22913,14897,15045,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020071,'暗裔小鬼',0,0,0,'宝宝副本71关小怪Lv678',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',678,1,298826,18198620,122836,118127,23578,23578,15214,15364,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020072,'拆塔狂魔',0,0,0,'宝宝副本72关小怪Lv686',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',686,1,308067,18776197,126115,121466,24244,24244,15530,15683,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020073,'爆弹怪',0,0,0,'宝宝副本73关小怪Lv694',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',694,1,317295,19354249,129395,124804,24909,24909,15847,16003,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020074,'暗裔小鬼',0,0,0,'宝宝副本74关小怪Lv702',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',702,1,326322,19914968,132727,128197,25553,25553,16164,16315,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020075,'拆塔狂魔',0,0,0,'宝宝副本75关小怪Lv710',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',710,1,334733,20425129,136220,131752,26130,26130,16481,16607,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020076,'爆弹怪',0,0,0,'宝宝副本76关小怪Lv718',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',718,1,343140,20935776,139712,135306,26706,26706,16798,16899,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020077,'暗裔小鬼',0,0,0,'宝宝副本77关小怪Lv726',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',726,1,351538,21445937,143204,138861,27283,27283,17115,17191,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020078,'拆塔狂魔',0,0,0,'宝宝副本78关小怪Lv734',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',734,1,359920,21956098,146697,142416,27860,27860,17433,17483,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020079,'爆弹怪',0,0,0,'宝宝副本79关小怪Lv742',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',742,1,368298,22466259,150189,145971,28436,28436,17750,17775,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020080,'暗裔小鬼',0,0,0,'宝宝副本80关小怪Lv750',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',750,1,376660,22976419,153682,149526,29013,29013,18067,18067,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020081,'暗裔小鬼',0,0,0,'宝宝副本81关小怪Lv758',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',758,1,385847,23527640,157720,153662,29596,29596,18665,18665,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020082,'拆塔狂魔',0,0,0,'宝宝副本82关小怪Lv766',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',766,1,395019,24079354,161759,157797,30179,30179,19262,19262,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020083,'爆弹怪',0,0,0,'宝宝副本83关小怪Lv774',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',774,1,404181,24630574,165798,161933,30763,30763,19860,19860,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020084,'暗裔小鬼',0,0,0,'宝宝副本84关小怪Lv782',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',782,1,413333,25181794,169837,166069,31346,31346,20458,20458,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020085,'拆塔狂魔',0,0,0,'宝宝副本85关小怪Lv790',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',790,1,422479,25733511,173875,170204,31929,31929,21055,21055,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020086,'爆弹怪',0,0,0,'宝宝副本86关小怪Lv798',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',798,1,435700,26505292,179092,175311,32887,32887,21688,21688,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020087,'暗裔小鬼',0,0,0,'宝宝副本87关小怪Lv806',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',806,1,449350,30533983,184465,180570,33874,33874,22338,22338,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020088,'拆塔狂魔',0,0,0,'宝宝副本88关小怪Lv814',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',814,1,463437,31449983,189999,185987,34891,34891,23008,23008,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020089,'爆弹怪',0,0,0,'宝宝副本89关小怪Lv822',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',822,1,477982,32393468,195699,191567,35938,35938,23699,23699,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020090,'暗裔小鬼',0,0,0,'宝宝副本90关小怪Lv830',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',830,1,492996,33365238,201570,197314,37016,37016,24409,24409,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020091,'暗裔小鬼',0,0,0,'宝宝副本91关小怪Lv838',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',838,1,508495,34366163,207617,203233,38126,38126,25142,25142,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020092,'拆塔狂魔',0,0,0,'宝宝副本92关小怪Lv846',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',846,1,524499,35397118,213845,209330,39270,39270,25896,25896,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020093,'爆弹怪',0,0,0,'宝宝副本93关小怪Lv854',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',854,1,541023,36459048,220260,215610,40448,40448,26673,26673,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020094,'暗裔小鬼',0,0,0,'宝宝副本94关小怪Lv862',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',862,1,558076,37552825,226869,222078,41661,41661,27473,27473,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020095,'拆塔狂魔',0,0,0,'宝宝副本95关小怪Lv870',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',870,1,575693,38679393,233674,228740,42912,42912,28298,28298,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020096,'爆弹怪',0,0,0,'宝宝副本96关小怪Lv878',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',878,1,593879,39839772,240684,235602,44199,44199,29147,29147,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020097,'暗裔小鬼',0,0,0,'宝宝副本97关小怪Lv886',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',886,1,612657,41034979,247905,242670,45525,45525,30021,30021,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020098,'拆塔狂魔',0,0,0,'宝宝副本98关小怪Lv894',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',894,1,632044,42266032,255343,249950,46891,46891,30922,30922,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020099,'爆弹怪',0,0,0,'宝宝副本99关小怪Lv902',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',902,1,652066,43534022,263003,257449,48298,48298,31849,31849,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400020100,'暗裔小鬼',0,0,0,'宝宝副本100关小怪Lv910',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',910,1,672741,44840039,270893,265172,49747,49747,32804,32804,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030001,'暗裔小鬼',0,0,0,'宝宝副本1关小怪Lv310',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:3',310,1,20021,669531,19483,12408,967,967,1066,1082,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030002,'拆塔狂魔',0,0,0,'宝宝副本2关小怪Lv313',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:4',313,1,24737,763991,20002,12930,1012,1012,1084,1101,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030003,'爆弹怪',0,0,0,'宝宝副本3关小怪Lv316',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:5',316,1,29692,863373,20521,13453,1057,1057,1102,1120,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030004,'暗裔小鬼',0,0,0,'宝宝副本4关小怪Lv319',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:6',319,1,34885,967830,21040,13975,1101,1101,1121,1139,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030005,'拆塔狂魔',0,0,0,'宝宝副本5关小怪Lv322',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:7',322,1,40316,1077194,21559,14498,1146,1146,1139,1158,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030006,'爆弹怪',0,0,0,'宝宝副本6关小怪Lv325',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:8',325,1,43685,1191544,22078,15021,1190,1190,1158,1177,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030007,'暗裔小鬼',0,0,0,'宝宝副本7关小怪Lv328',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:9',328,1,46706,1392931,22596,15543,1235,1235,1176,1196,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030008,'拆塔狂魔',0,0,0,'宝宝副本8关小怪Lv331',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:10',331,1,47885,1604186,23115,16066,1279,1279,1194,1215,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030009,'爆弹怪',0,0,0,'宝宝副本9关小怪Lv334',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',334,1,49064,1825569,23634,16588,1324,1324,1213,1234,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030010,'暗裔小鬼',0,0,0,'宝宝副本10关小怪Lv337',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',337,1,50243,2056786,24153,17111,1369,1369,1231,1252,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030011,'暗裔小鬼',0,0,0,'宝宝副本11关小怪Lv340',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',340,1,51422,2298166,24672,17633,1413,1413,1250,1271,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030012,'拆塔狂魔',0,0,0,'宝宝副本12关小怪Lv344',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',344,1,52994,2381348,25364,18330,1473,1473,1274,1297,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030013,'爆弹怪',0,0,0,'宝宝副本13关小怪Lv348',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',348,1,54567,2464528,26056,19027,1532,1532,1299,1322,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030014,'暗裔小鬼',0,0,0,'宝宝副本14关小怪Lv352',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',352,1,56314,2570488,26799,19856,1635,1635,1366,1391,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030015,'拆塔狂魔',0,0,0,'宝宝副本15关小怪Lv356',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',356,1,58230,2699030,27595,20818,1782,1782,1477,1503,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030016,'爆弹怪',0,0,0,'宝宝副本16关小怪Lv360',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',360,1,60151,2827571,28390,21780,1929,1929,1587,1615,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030017,'暗裔小鬼',0,0,0,'宝宝副本17关小怪Lv364',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',364,1,62069,2956111,29186,22742,2075,2075,1698,1727,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030018,'拆塔狂魔',0,0,0,'宝宝副本18关小怪Lv368',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',368,1,63987,3084650,29982,23704,2222,2222,1808,1840,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030019,'爆弹怪',0,0,0,'宝宝副本19关小怪Lv372',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',372,1,65909,3213189,30777,24666,2369,2369,1919,1952,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030020,'暗裔小鬼',0,0,0,'宝宝副本20关小怪Lv376',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',376,1,67827,3341964,31573,25627,2515,2515,2029,2064,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030021,'暗裔小鬼',0,0,0,'宝宝副本21关小怪Lv380',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',380,1,69750,3470506,32368,26589,2662,2662,2140,2176,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030022,'拆塔狂魔',0,0,0,'宝宝副本22关小怪Lv385',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',385,1,72148,3631058,33363,27792,2845,2845,2278,2316,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030023,'爆弹怪',0,0,0,'宝宝副本23关小怪Lv390',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',390,1,74550,3791857,34357,28994,3029,3029,2416,2457,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030024,'暗裔小鬼',0,0,0,'宝宝副本24关小怪Lv395',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',395,1,76947,3952401,35352,30197,3212,3212,2554,2597,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030025,'拆塔狂魔',0,0,0,'宝宝副本25关小怪Lv400',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',400,1,79348,4113203,36346,31399,3395,3395,2692,2737,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030026,'爆弹怪',0,0,0,'宝宝副本26关小怪Lv405',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',405,1,81678,4241314,37266,32291,3570,3570,2780,2833,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030027,'暗裔小鬼',0,0,0,'宝宝副本27关小怪Lv410',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',410,1,84011,4369156,38185,33184,3745,3745,2868,2928,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030028,'拆塔狂魔',0,0,0,'宝宝副本28关小怪Lv415',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',415,1,86338,4497269,39105,34076,3919,3919,2956,3024,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030029,'爆弹怪',0,0,0,'宝宝副本29关小怪Lv420',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',420,1,88668,4625107,40024,34969,4094,4094,3045,3120,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030030,'暗裔小鬼',0,0,0,'宝宝副本30关小怪Lv425',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',425,1,90993,4753221,40944,35861,4269,4269,3133,3216,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030031,'暗裔小鬼',0,0,0,'宝宝副本31关小怪Lv430',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',430,1,93320,4881337,41863,36753,4444,4444,3221,3312,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030032,'拆塔狂魔',0,0,0,'宝宝副本32关小怪Lv435',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',435,1,95641,5009172,42783,37646,4618,4618,3309,3407,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030033,'爆弹怪',0,0,0,'宝宝副本33关小怪Lv440',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',440,1,97965,5137289,43702,38538,4793,4793,3397,3503,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030034,'暗裔小鬼',0,0,0,'宝宝副本34关小怪Lv445',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',445,1,100283,5265121,44622,39431,4968,4968,3485,3599,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030035,'拆塔狂魔',0,0,0,'宝宝副本35关小怪Lv450',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',450,1,102603,5393239,45541,40323,5142,5142,3573,3695,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030036,'爆弹怪',0,0,0,'宝宝副本36关小怪Lv455',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',455,1,106020,5583781,46913,41687,5398,5398,3764,3897,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030037,'暗裔小鬼',0,0,0,'宝宝副本37关小怪Lv460',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',460,1,109437,5774322,48285,43051,5654,5654,3955,4100,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030038,'拆塔狂魔',0,0,0,'宝宝副本38关小怪Lv465',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',465,1,112855,5964864,49657,44415,5910,5910,4146,4302,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030039,'爆弹怪',0,0,0,'宝宝副本39关小怪Lv470',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',470,1,116273,6155405,51029,45779,6165,6165,4337,4505,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030040,'暗裔小鬼',0,0,0,'宝宝副本40关小怪Lv475',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',475,1,119691,6345947,52401,47143,6421,6421,4528,4707,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030041,'暗裔小鬼',0,0,0,'宝宝副本41关小怪Lv480',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',480,1,123112,6536489,53772,48507,6677,6677,4719,4910,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030042,'拆塔狂魔',0,0,0,'宝宝副本42关小怪Lv485',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',485,1,126529,6727030,55144,49871,6933,6933,4910,5112,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030043,'爆弹怪',0,0,0,'宝宝副本43关小怪Lv490',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',490,1,129945,6917572,56516,51235,7188,7188,5101,5315,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030044,'暗裔小鬼',0,0,0,'宝宝副本44关小怪Lv495',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',495,1,133360,7108113,57888,52599,7444,7444,5292,5517,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030045,'拆塔狂魔',0,0,0,'宝宝副本45关小怪Lv500',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',500,1,136774,7298655,59260,53963,7700,7700,5483,5720,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030046,'爆弹怪',0,0,0,'宝宝副本46关小怪Lv506',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',506,1,141562,7563230,61131,55835,8323,8323,5864,6108,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030047,'暗裔小鬼',0,0,0,'宝宝副本47关小怪Lv512',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',512,1,146349,7827804,63002,57707,8947,8947,6245,6496,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030048,'拆塔狂魔',0,0,0,'宝宝副本48关小怪Lv518',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',518,1,151132,8092376,64874,59579,9570,9570,6626,6884,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030049,'爆弹怪',0,0,0,'宝宝副本49关小怪Lv524',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',524,1,155917,8356948,66745,61451,10194,10194,7007,7273,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030050,'暗裔小鬼',0,0,0,'宝宝副本50关小怪Lv530',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',530,1,160702,8621866,68616,63322,10818,10818,7388,7661,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030051,'暗裔小鬼',0,0,0,'宝宝副本51关小怪Lv536',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',536,1,165485,8886440,70487,65194,11441,11441,7769,8049,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030052,'拆塔狂魔',0,0,0,'宝宝副本52关小怪Lv542',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',542,1,170266,9151013,72358,67066,12065,12065,8150,8437,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030053,'爆弹怪',0,0,0,'宝宝副本53关小怪Lv548',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',548,1,175040,9415585,74230,68938,12688,12688,8531,8825,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030054,'暗裔小鬼',0,0,0,'宝宝副本54关小怪Lv554',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',554,1,180048,9691766,76192,70909,13199,13199,8818,9111,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030055,'拆塔狂魔',0,0,0,'宝宝副本55关小怪Lv560',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',560,1,185172,9973571,78199,72930,13653,13653,9059,9344,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030056,'爆弹怪',0,0,0,'宝宝副本56关小怪Lv566',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',566,1,190289,10255377,80207,74951,14106,14106,9299,9578,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030057,'暗裔小鬼',0,0,0,'宝宝副本57关小怪Lv572',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',572,1,195408,10537183,82214,76972,14560,14560,9539,9812,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030058,'拆塔狂魔',0,0,0,'宝宝副本58关小怪Lv578',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',578,1,200520,10818615,84222,78994,15014,15014,9779,10045,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030059,'爆弹怪',0,0,0,'宝宝副本59关小怪Lv584',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',584,1,205634,11100419,86229,81015,15468,15468,10019,10279,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030060,'暗裔小鬼',0,0,0,'宝宝副本60关小怪Lv590',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',590,1,210739,11382223,88237,83036,15922,15922,10260,10513,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030061,'暗裔小鬼',0,0,0,'宝宝副本61关小怪Lv598',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',598,1,217543,11758217,90914,85730,16527,16527,10580,10824,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030062,'拆塔狂魔',0,0,0,'宝宝副本62关小怪Lv606',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',606,1,224919,13637368,93956,88809,17227,17227,11073,11303,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030063,'爆弹怪',0,0,0,'宝宝副本63关小怪Lv614',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',614,1,232481,14099001,97120,92015,17958,17958,11625,11839,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030064,'暗裔小鬼',0,0,0,'宝宝副本64关小怪Lv622',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',622,1,240038,14560636,100284,95221,18689,18689,12176,12374,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030065,'拆塔狂魔',0,0,0,'宝宝副本65关小怪Lv630',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',630,1,247595,15022273,103447,98427,19420,19420,12727,12909,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030066,'爆弹怪',0,0,0,'宝宝副本66关小怪Lv638',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',638,1,255140,15483463,106611,101634,20152,20152,13279,13444,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030067,'暗裔小鬼',0,0,0,'宝宝副本67关小怪Lv646',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',646,1,262678,15945099,109775,104840,20883,20883,13830,13979,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030068,'拆塔狂魔',0,0,0,'宝宝副本68关小怪Lv654',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',654,1,271074,16464940,112997,108112,21581,21581,14264,14406,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030069,'爆弹怪',0,0,0,'宝宝副本69关小怪Lv662',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',662,1,280334,17042525,116276,111451,22247,22247,14581,14725,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030070,'暗裔小鬼',0,0,0,'宝宝副本70关小怪Lv670',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',670,1,289583,17620570,119556,114789,22913,22913,14897,15045,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030071,'暗裔小鬼',0,0,0,'宝宝副本71关小怪Lv678',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',678,1,298826,18198620,122836,118127,23578,23578,15214,15364,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030072,'拆塔狂魔',0,0,0,'宝宝副本72关小怪Lv686',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',686,1,308067,18776197,126115,121466,24244,24244,15530,15683,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030073,'爆弹怪',0,0,0,'宝宝副本73关小怪Lv694',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',694,1,317295,19354249,129395,124804,24909,24909,15847,16003,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030074,'暗裔小鬼',0,0,0,'宝宝副本74关小怪Lv702',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',702,1,326322,19914968,132727,128197,25553,25553,16164,16315,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030075,'拆塔狂魔',0,0,0,'宝宝副本75关小怪Lv710',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',710,1,334733,20425129,136220,131752,26130,26130,16481,16607,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030076,'爆弹怪',0,0,0,'宝宝副本76关小怪Lv718',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',718,1,343140,20935776,139712,135306,26706,26706,16798,16899,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030077,'暗裔小鬼',0,0,0,'宝宝副本77关小怪Lv726',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',726,1,351538,21445937,143204,138861,27283,27283,17115,17191,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030078,'拆塔狂魔',0,0,0,'宝宝副本78关小怪Lv734',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',734,1,359920,21956098,146697,142416,27860,27860,17433,17483,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030079,'爆弹怪',0,0,0,'宝宝副本79关小怪Lv742',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',742,1,368298,22466259,150189,145971,28436,28436,17750,17775,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030080,'暗裔小鬼',0,0,0,'宝宝副本80关小怪Lv750',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',750,1,376660,22976419,153682,149526,29013,29013,18067,18067,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030081,'暗裔小鬼',0,0,0,'宝宝副本81关小怪Lv758',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',758,1,385847,23527640,157720,153662,29596,29596,18665,18665,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030082,'拆塔狂魔',0,0,0,'宝宝副本82关小怪Lv766',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',766,1,395019,24079354,161759,157797,30179,30179,19262,19262,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030083,'爆弹怪',0,0,0,'宝宝副本83关小怪Lv774',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',774,1,404181,24630574,165798,161933,30763,30763,19860,19860,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030084,'暗裔小鬼',0,0,0,'宝宝副本84关小怪Lv782',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',782,1,413333,25181794,169837,166069,31346,31346,20458,20458,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030085,'拆塔狂魔',0,0,0,'宝宝副本85关小怪Lv790',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',790,1,422479,25733511,173875,170204,31929,31929,21055,21055,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030086,'爆弹怪',0,0,0,'宝宝副本86关小怪Lv798',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',798,1,435700,26505292,179092,175311,32887,32887,21688,21688,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030087,'暗裔小鬼',0,0,0,'宝宝副本87关小怪Lv806',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',806,1,449350,30533983,184465,180570,33874,33874,22338,22338,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030088,'拆塔狂魔',0,0,0,'宝宝副本88关小怪Lv814',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',814,1,463437,31449983,189999,185987,34891,34891,23008,23008,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030089,'爆弹怪',0,0,0,'宝宝副本89关小怪Lv822',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',822,1,477982,32393468,195699,191567,35938,35938,23699,23699,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030090,'暗裔小鬼',0,0,0,'宝宝副本90关小怪Lv830',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',830,1,492996,33365238,201570,197314,37016,37016,24409,24409,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030091,'暗裔小鬼',0,0,0,'宝宝副本91关小怪Lv838',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',838,1,508495,34366163,207617,203233,38126,38126,25142,25142,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030092,'拆塔狂魔',0,0,0,'宝宝副本92关小怪Lv846',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',846,1,524499,35397118,213845,209330,39270,39270,25896,25896,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030093,'爆弹怪',0,0,0,'宝宝副本93关小怪Lv854',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',854,1,541023,36459048,220260,215610,40448,40448,26673,26673,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030094,'暗裔小鬼',0,0,0,'宝宝副本94关小怪Lv862',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',862,1,558076,37552825,226869,222078,41661,41661,27473,27473,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030095,'拆塔狂魔',0,0,0,'宝宝副本95关小怪Lv870',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',870,1,575693,38679393,233674,228740,42912,42912,28298,28298,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030096,'爆弹怪',0,0,0,'宝宝副本96关小怪Lv878',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',878,1,593879,39839772,240684,235602,44199,44199,29147,29147,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030097,'暗裔小鬼',0,0,0,'宝宝副本97关小怪Lv886',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',886,1,612657,41034979,247905,242670,45525,45525,30021,30021,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030098,'拆塔狂魔',0,0,0,'宝宝副本98关小怪Lv894',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',894,1,632044,42266032,255343,249950,46891,46891,30922,30922,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030099,'爆弹怪',0,0,0,'宝宝副本99关小怪Lv902',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',902,1,652066,43534022,263003,257449,48298,48298,31849,31849,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400030100,'暗裔小鬼',0,0,0,'宝宝副本100关小怪Lv910',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',910,1,672741,44840039,270893,265172,49747,49747,32804,32804,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040001,'暗裔小鬼',0,0,0,'宝宝副本1关小怪Lv310',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:3',310,1,20021,669531,19483,12408,967,967,1066,1082,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040002,'拆塔狂魔',0,0,0,'宝宝副本2关小怪Lv313',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:4',313,1,24737,763991,20002,12930,1012,1012,1084,1101,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040003,'爆弹怪',0,0,0,'宝宝副本3关小怪Lv316',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:5',316,1,29692,863373,20521,13453,1057,1057,1102,1120,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040004,'暗裔小鬼',0,0,0,'宝宝副本4关小怪Lv319',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:6',319,1,34885,967830,21040,13975,1101,1101,1121,1139,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040005,'拆塔狂魔',0,0,0,'宝宝副本5关小怪Lv322',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:7',322,1,40316,1077194,21559,14498,1146,1146,1139,1158,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040006,'爆弹怪',0,0,0,'宝宝副本6关小怪Lv325',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:8',325,1,43685,1191544,22078,15021,1190,1190,1158,1177,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040007,'暗裔小鬼',0,0,0,'宝宝副本7关小怪Lv328',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:9',328,1,46706,1392931,22596,15543,1235,1235,1176,1196,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040008,'拆塔狂魔',0,0,0,'宝宝副本8关小怪Lv331',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:10',331,1,47885,1604186,23115,16066,1279,1279,1194,1215,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040009,'爆弹怪',0,0,0,'宝宝副本9关小怪Lv334',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',334,1,49064,1825569,23634,16588,1324,1324,1213,1234,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040010,'暗裔小鬼',0,0,0,'宝宝副本10关小怪Lv337',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',337,1,50243,2056786,24153,17111,1369,1369,1231,1252,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040011,'暗裔小鬼',0,0,0,'宝宝副本11关小怪Lv340',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',340,1,51422,2298166,24672,17633,1413,1413,1250,1271,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040012,'拆塔狂魔',0,0,0,'宝宝副本12关小怪Lv344',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',344,1,52994,2381348,25364,18330,1473,1473,1274,1297,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040013,'爆弹怪',0,0,0,'宝宝副本13关小怪Lv348',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',348,1,54567,2464528,26056,19027,1532,1532,1299,1322,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040014,'暗裔小鬼',0,0,0,'宝宝副本14关小怪Lv352',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',352,1,56314,2570488,26799,19856,1635,1635,1366,1391,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040015,'拆塔狂魔',0,0,0,'宝宝副本15关小怪Lv356',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',356,1,58230,2699030,27595,20818,1782,1782,1477,1503,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040016,'爆弹怪',0,0,0,'宝宝副本16关小怪Lv360',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',360,1,60151,2827571,28390,21780,1929,1929,1587,1615,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040017,'暗裔小鬼',0,0,0,'宝宝副本17关小怪Lv364',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',364,1,62069,2956111,29186,22742,2075,2075,1698,1727,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040018,'拆塔狂魔',0,0,0,'宝宝副本18关小怪Lv368',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',368,1,63987,3084650,29982,23704,2222,2222,1808,1840,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040019,'爆弹怪',0,0,0,'宝宝副本19关小怪Lv372',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',372,1,65909,3213189,30777,24666,2369,2369,1919,1952,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040020,'暗裔小鬼',0,0,0,'宝宝副本20关小怪Lv376',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',376,1,67827,3341964,31573,25627,2515,2515,2029,2064,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040021,'暗裔小鬼',0,0,0,'宝宝副本21关小怪Lv380',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',380,1,69750,3470506,32368,26589,2662,2662,2140,2176,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040022,'拆塔狂魔',0,0,0,'宝宝副本22关小怪Lv385',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',385,1,72148,3631058,33363,27792,2845,2845,2278,2316,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040023,'爆弹怪',0,0,0,'宝宝副本23关小怪Lv390',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',390,1,74550,3791857,34357,28994,3029,3029,2416,2457,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040024,'暗裔小鬼',0,0,0,'宝宝副本24关小怪Lv395',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',395,1,76947,3952401,35352,30197,3212,3212,2554,2597,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040025,'拆塔狂魔',0,0,0,'宝宝副本25关小怪Lv400',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',400,1,79348,4113203,36346,31399,3395,3395,2692,2737,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040026,'爆弹怪',0,0,0,'宝宝副本26关小怪Lv405',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',405,1,81678,4241314,37266,32291,3570,3570,2780,2833,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040027,'暗裔小鬼',0,0,0,'宝宝副本27关小怪Lv410',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',410,1,84011,4369156,38185,33184,3745,3745,2868,2928,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040028,'拆塔狂魔',0,0,0,'宝宝副本28关小怪Lv415',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',415,1,86338,4497269,39105,34076,3919,3919,2956,3024,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040029,'爆弹怪',0,0,0,'宝宝副本29关小怪Lv420',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',420,1,88668,4625107,40024,34969,4094,4094,3045,3120,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040030,'暗裔小鬼',0,0,0,'宝宝副本30关小怪Lv425',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',425,1,90993,4753221,40944,35861,4269,4269,3133,3216,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040031,'暗裔小鬼',0,0,0,'宝宝副本31关小怪Lv430',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',430,1,93320,4881337,41863,36753,4444,4444,3221,3312,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040032,'拆塔狂魔',0,0,0,'宝宝副本32关小怪Lv435',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',435,1,95641,5009172,42783,37646,4618,4618,3309,3407,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040033,'爆弹怪',0,0,0,'宝宝副本33关小怪Lv440',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',440,1,97965,5137289,43702,38538,4793,4793,3397,3503,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040034,'暗裔小鬼',0,0,0,'宝宝副本34关小怪Lv445',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',445,1,100283,5265121,44622,39431,4968,4968,3485,3599,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040035,'拆塔狂魔',0,0,0,'宝宝副本35关小怪Lv450',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',450,1,102603,5393239,45541,40323,5142,5142,3573,3695,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040036,'爆弹怪',0,0,0,'宝宝副本36关小怪Lv455',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',455,1,106020,5583781,46913,41687,5398,5398,3764,3897,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040037,'暗裔小鬼',0,0,0,'宝宝副本37关小怪Lv460',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',460,1,109437,5774322,48285,43051,5654,5654,3955,4100,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040038,'拆塔狂魔',0,0,0,'宝宝副本38关小怪Lv465',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',465,1,112855,5964864,49657,44415,5910,5910,4146,4302,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040039,'爆弹怪',0,0,0,'宝宝副本39关小怪Lv470',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',470,1,116273,6155405,51029,45779,6165,6165,4337,4505,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040040,'暗裔小鬼',0,0,0,'宝宝副本40关小怪Lv475',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',475,1,119691,6345947,52401,47143,6421,6421,4528,4707,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040041,'暗裔小鬼',0,0,0,'宝宝副本41关小怪Lv480',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',480,1,123112,6536489,53772,48507,6677,6677,4719,4910,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040042,'拆塔狂魔',0,0,0,'宝宝副本42关小怪Lv485',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',485,1,126529,6727030,55144,49871,6933,6933,4910,5112,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040043,'爆弹怪',0,0,0,'宝宝副本43关小怪Lv490',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',490,1,129945,6917572,56516,51235,7188,7188,5101,5315,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040044,'暗裔小鬼',0,0,0,'宝宝副本44关小怪Lv495',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',495,1,133360,7108113,57888,52599,7444,7444,5292,5517,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040045,'拆塔狂魔',0,0,0,'宝宝副本45关小怪Lv500',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',500,1,136774,7298655,59260,53963,7700,7700,5483,5720,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040046,'爆弹怪',0,0,0,'宝宝副本46关小怪Lv506',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',506,1,141562,7563230,61131,55835,8323,8323,5864,6108,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040047,'暗裔小鬼',0,0,0,'宝宝副本47关小怪Lv512',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',512,1,146349,7827804,63002,57707,8947,8947,6245,6496,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040048,'拆塔狂魔',0,0,0,'宝宝副本48关小怪Lv518',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',518,1,151132,8092376,64874,59579,9570,9570,6626,6884,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040049,'爆弹怪',0,0,0,'宝宝副本49关小怪Lv524',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',524,1,155917,8356948,66745,61451,10194,10194,7007,7273,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040050,'暗裔小鬼',0,0,0,'宝宝副本50关小怪Lv530',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',530,1,160702,8621866,68616,63322,10818,10818,7388,7661,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040051,'暗裔小鬼',0,0,0,'宝宝副本51关小怪Lv536',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',536,1,165485,8886440,70487,65194,11441,11441,7769,8049,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040052,'拆塔狂魔',0,0,0,'宝宝副本52关小怪Lv542',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',542,1,170266,9151013,72358,67066,12065,12065,8150,8437,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040053,'爆弹怪',0,0,0,'宝宝副本53关小怪Lv548',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',548,1,175040,9415585,74230,68938,12688,12688,8531,8825,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040054,'暗裔小鬼',0,0,0,'宝宝副本54关小怪Lv554',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',554,1,180048,9691766,76192,70909,13199,13199,8818,9111,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040055,'拆塔狂魔',0,0,0,'宝宝副本55关小怪Lv560',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',560,1,185172,9973571,78199,72930,13653,13653,9059,9344,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040056,'爆弹怪',0,0,0,'宝宝副本56关小怪Lv566',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',566,1,190289,10255377,80207,74951,14106,14106,9299,9578,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040057,'暗裔小鬼',0,0,0,'宝宝副本57关小怪Lv572',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',572,1,195408,10537183,82214,76972,14560,14560,9539,9812,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040058,'拆塔狂魔',0,0,0,'宝宝副本58关小怪Lv578',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',578,1,200520,10818615,84222,78994,15014,15014,9779,10045,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040059,'爆弹怪',0,0,0,'宝宝副本59关小怪Lv584',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',584,1,205634,11100419,86229,81015,15468,15468,10019,10279,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040060,'暗裔小鬼',0,0,0,'宝宝副本60关小怪Lv590',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',590,1,210739,11382223,88237,83036,15922,15922,10260,10513,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040061,'暗裔小鬼',0,0,0,'宝宝副本61关小怪Lv598',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',598,1,217543,11758217,90914,85730,16527,16527,10580,10824,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040062,'拆塔狂魔',0,0,0,'宝宝副本62关小怪Lv606',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',606,1,224919,13637368,93956,88809,17227,17227,11073,11303,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040063,'爆弹怪',0,0,0,'宝宝副本63关小怪Lv614',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',614,1,232481,14099001,97120,92015,17958,17958,11625,11839,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040064,'暗裔小鬼',0,0,0,'宝宝副本64关小怪Lv622',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',622,1,240038,14560636,100284,95221,18689,18689,12176,12374,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040065,'拆塔狂魔',0,0,0,'宝宝副本65关小怪Lv630',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',630,1,247595,15022273,103447,98427,19420,19420,12727,12909,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040066,'爆弹怪',0,0,0,'宝宝副本66关小怪Lv638',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',638,1,255140,15483463,106611,101634,20152,20152,13279,13444,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040067,'暗裔小鬼',0,0,0,'宝宝副本67关小怪Lv646',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',646,1,262678,15945099,109775,104840,20883,20883,13830,13979,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040068,'拆塔狂魔',0,0,0,'宝宝副本68关小怪Lv654',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',654,1,271074,16464940,112997,108112,21581,21581,14264,14406,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040069,'爆弹怪',0,0,0,'宝宝副本69关小怪Lv662',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',662,1,280334,17042525,116276,111451,22247,22247,14581,14725,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040070,'暗裔小鬼',0,0,0,'宝宝副本70关小怪Lv670',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',670,1,289583,17620570,119556,114789,22913,22913,14897,15045,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040071,'暗裔小鬼',0,0,0,'宝宝副本71关小怪Lv678',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',678,1,298826,18198620,122836,118127,23578,23578,15214,15364,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040072,'拆塔狂魔',0,0,0,'宝宝副本72关小怪Lv686',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',686,1,308067,18776197,126115,121466,24244,24244,15530,15683,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040073,'爆弹怪',0,0,0,'宝宝副本73关小怪Lv694',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',694,1,317295,19354249,129395,124804,24909,24909,15847,16003,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040074,'暗裔小鬼',0,0,0,'宝宝副本74关小怪Lv702',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',702,1,326322,19914968,132727,128197,25553,25553,16164,16315,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040075,'拆塔狂魔',0,0,0,'宝宝副本75关小怪Lv710',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',710,1,334733,20425129,136220,131752,26130,26130,16481,16607,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040076,'爆弹怪',0,0,0,'宝宝副本76关小怪Lv718',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',718,1,343140,20935776,139712,135306,26706,26706,16798,16899,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040077,'暗裔小鬼',0,0,0,'宝宝副本77关小怪Lv726',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',726,1,351538,21445937,143204,138861,27283,27283,17115,17191,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040078,'拆塔狂魔',0,0,0,'宝宝副本78关小怪Lv734',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',734,1,359920,21956098,146697,142416,27860,27860,17433,17483,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040079,'爆弹怪',0,0,0,'宝宝副本79关小怪Lv742',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',742,1,368298,22466259,150189,145971,28436,28436,17750,17775,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040080,'暗裔小鬼',0,0,0,'宝宝副本80关小怪Lv750',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',750,1,376660,22976419,153682,149526,29013,29013,18067,18067,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040081,'暗裔小鬼',0,0,0,'宝宝副本81关小怪Lv758',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',758,1,385847,23527640,157720,153662,29596,29596,18665,18665,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040082,'拆塔狂魔',0,0,0,'宝宝副本82关小怪Lv766',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',766,1,395019,24079354,161759,157797,30179,30179,19262,19262,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040083,'爆弹怪',0,0,0,'宝宝副本83关小怪Lv774',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',774,1,404181,24630574,165798,161933,30763,30763,19860,19860,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040084,'暗裔小鬼',0,0,0,'宝宝副本84关小怪Lv782',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',782,1,413333,25181794,169837,166069,31346,31346,20458,20458,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040085,'拆塔狂魔',0,0,0,'宝宝副本85关小怪Lv790',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',790,1,422479,25733511,173875,170204,31929,31929,21055,21055,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040086,'爆弹怪',0,0,0,'宝宝副本86关小怪Lv798',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',798,1,435700,26505292,179092,175311,32887,32887,21688,21688,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040087,'暗裔小鬼',0,0,0,'宝宝副本87关小怪Lv806',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',806,1,449350,30533983,184465,180570,33874,33874,22338,22338,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040088,'拆塔狂魔',0,0,0,'宝宝副本88关小怪Lv814',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',814,1,463437,31449983,189999,185987,34891,34891,23008,23008,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040089,'爆弹怪',0,0,0,'宝宝副本89关小怪Lv822',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',822,1,477982,32393468,195699,191567,35938,35938,23699,23699,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040090,'暗裔小鬼',0,0,0,'宝宝副本90关小怪Lv830',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',830,1,492996,33365238,201570,197314,37016,37016,24409,24409,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040091,'暗裔小鬼',0,0,0,'宝宝副本91关小怪Lv838',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',838,1,508495,34366163,207617,203233,38126,38126,25142,25142,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040092,'拆塔狂魔',0,0,0,'宝宝副本92关小怪Lv846',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',846,1,524499,35397118,213845,209330,39270,39270,25896,25896,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040093,'爆弹怪',0,0,0,'宝宝副本93关小怪Lv854',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',854,1,541023,36459048,220260,215610,40448,40448,26673,26673,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040094,'暗裔小鬼',0,0,0,'宝宝副本94关小怪Lv862',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',862,1,558076,37552825,226869,222078,41661,41661,27473,27473,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040095,'拆塔狂魔',0,0,0,'宝宝副本95关小怪Lv870',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',870,1,575693,38679393,233674,228740,42912,42912,28298,28298,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040096,'爆弹怪',0,0,0,'宝宝副本96关小怪Lv878',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',878,1,593879,39839772,240684,235602,44199,44199,29147,29147,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040097,'暗裔小鬼',0,0,0,'宝宝副本97关小怪Lv886',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',886,1,612657,41034979,247905,242670,45525,45525,30021,30021,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040098,'拆塔狂魔',0,0,0,'宝宝副本98关小怪Lv894',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',894,1,632044,42266032,255343,249950,46891,46891,30922,30922,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040099,'爆弹怪',0,0,0,'宝宝副本99关小怪Lv902',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',902,1,652066,43534022,263003,257449,48298,48298,31849,31849,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400040100,'暗裔小鬼',0,0,0,'宝宝副本100关小怪Lv910',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',910,1,672741,44840039,270893,265172,49747,49747,32804,32804,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050001,'暗裔小鬼',0,0,0,'宝宝副本1关小怪Lv310',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:3',310,1,20021,669531,19483,12408,967,967,1066,1082,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050002,'拆塔狂魔',0,0,0,'宝宝副本2关小怪Lv313',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:4',313,1,24737,763991,20002,12930,1012,1012,1084,1101,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050003,'爆弹怪',0,0,0,'宝宝副本3关小怪Lv316',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:5',316,1,29692,863373,20521,13453,1057,1057,1102,1120,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050004,'暗裔小鬼',0,0,0,'宝宝副本4关小怪Lv319',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:6',319,1,34885,967830,21040,13975,1101,1101,1121,1139,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050005,'拆塔狂魔',0,0,0,'宝宝副本5关小怪Lv322',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:7',322,1,40316,1077194,21559,14498,1146,1146,1139,1158,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050006,'爆弹怪',0,0,0,'宝宝副本6关小怪Lv325',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:8',325,1,43685,1191544,22078,15021,1190,1190,1158,1177,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050007,'暗裔小鬼',0,0,0,'宝宝副本7关小怪Lv328',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:9',328,1,46706,1392931,22596,15543,1235,1235,1176,1196,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050008,'拆塔狂魔',0,0,0,'宝宝副本8关小怪Lv331',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:10',331,1,47885,1604186,23115,16066,1279,1279,1194,1215,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050009,'爆弹怪',0,0,0,'宝宝副本9关小怪Lv334',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',334,1,49064,1825569,23634,16588,1324,1324,1213,1234,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050010,'暗裔小鬼',0,0,0,'宝宝副本10关小怪Lv337',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',337,1,50243,2056786,24153,17111,1369,1369,1231,1252,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050011,'暗裔小鬼',0,0,0,'宝宝副本11关小怪Lv340',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',340,1,51422,2298166,24672,17633,1413,1413,1250,1271,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050012,'拆塔狂魔',0,0,0,'宝宝副本12关小怪Lv344',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',344,1,52994,2381348,25364,18330,1473,1473,1274,1297,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050013,'爆弹怪',0,0,0,'宝宝副本13关小怪Lv348',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',348,1,54567,2464528,26056,19027,1532,1532,1299,1322,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050014,'暗裔小鬼',0,0,0,'宝宝副本14关小怪Lv352',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',352,1,56314,2570488,26799,19856,1635,1635,1366,1391,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050015,'拆塔狂魔',0,0,0,'宝宝副本15关小怪Lv356',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',356,1,58230,2699030,27595,20818,1782,1782,1477,1503,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050016,'爆弹怪',0,0,0,'宝宝副本16关小怪Lv360',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',360,1,60151,2827571,28390,21780,1929,1929,1587,1615,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050017,'暗裔小鬼',0,0,0,'宝宝副本17关小怪Lv364',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',364,1,62069,2956111,29186,22742,2075,2075,1698,1727,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050018,'拆塔狂魔',0,0,0,'宝宝副本18关小怪Lv368',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',368,1,63987,3084650,29982,23704,2222,2222,1808,1840,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050019,'爆弹怪',0,0,0,'宝宝副本19关小怪Lv372',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',372,1,65909,3213189,30777,24666,2369,2369,1919,1952,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050020,'暗裔小鬼',0,0,0,'宝宝副本20关小怪Lv376',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',376,1,67827,3341964,31573,25627,2515,2515,2029,2064,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050021,'暗裔小鬼',0,0,0,'宝宝副本21关小怪Lv380',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',380,1,69750,3470506,32368,26589,2662,2662,2140,2176,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050022,'拆塔狂魔',0,0,0,'宝宝副本22关小怪Lv385',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',385,1,72148,3631058,33363,27792,2845,2845,2278,2316,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050023,'爆弹怪',0,0,0,'宝宝副本23关小怪Lv390',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',390,1,74550,3791857,34357,28994,3029,3029,2416,2457,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050024,'暗裔小鬼',0,0,0,'宝宝副本24关小怪Lv395',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',395,1,76947,3952401,35352,30197,3212,3212,2554,2597,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050025,'拆塔狂魔',0,0,0,'宝宝副本25关小怪Lv400',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',400,1,79348,4113203,36346,31399,3395,3395,2692,2737,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050026,'爆弹怪',0,0,0,'宝宝副本26关小怪Lv405',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',405,1,81678,4241314,37266,32291,3570,3570,2780,2833,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050027,'暗裔小鬼',0,0,0,'宝宝副本27关小怪Lv410',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',410,1,84011,4369156,38185,33184,3745,3745,2868,2928,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050028,'拆塔狂魔',0,0,0,'宝宝副本28关小怪Lv415',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',415,1,86338,4497269,39105,34076,3919,3919,2956,3024,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050029,'爆弹怪',0,0,0,'宝宝副本29关小怪Lv420',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',420,1,88668,4625107,40024,34969,4094,4094,3045,3120,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050030,'暗裔小鬼',0,0,0,'宝宝副本30关小怪Lv425',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',425,1,90993,4753221,40944,35861,4269,4269,3133,3216,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050031,'暗裔小鬼',0,0,0,'宝宝副本31关小怪Lv430',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',430,1,93320,4881337,41863,36753,4444,4444,3221,3312,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050032,'拆塔狂魔',0,0,0,'宝宝副本32关小怪Lv435',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',435,1,95641,5009172,42783,37646,4618,4618,3309,3407,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050033,'爆弹怪',0,0,0,'宝宝副本33关小怪Lv440',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',440,1,97965,5137289,43702,38538,4793,4793,3397,3503,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050034,'暗裔小鬼',0,0,0,'宝宝副本34关小怪Lv445',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',445,1,100283,5265121,44622,39431,4968,4968,3485,3599,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050035,'拆塔狂魔',0,0,0,'宝宝副本35关小怪Lv450',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',450,1,102603,5393239,45541,40323,5142,5142,3573,3695,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050036,'爆弹怪',0,0,0,'宝宝副本36关小怪Lv455',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',455,1,106020,5583781,46913,41687,5398,5398,3764,3897,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050037,'暗裔小鬼',0,0,0,'宝宝副本37关小怪Lv460',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',460,1,109437,5774322,48285,43051,5654,5654,3955,4100,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050038,'拆塔狂魔',0,0,0,'宝宝副本38关小怪Lv465',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',465,1,112855,5964864,49657,44415,5910,5910,4146,4302,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050039,'爆弹怪',0,0,0,'宝宝副本39关小怪Lv470',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',470,1,116273,6155405,51029,45779,6165,6165,4337,4505,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050040,'暗裔小鬼',0,0,0,'宝宝副本40关小怪Lv475',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',475,1,119691,6345947,52401,47143,6421,6421,4528,4707,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050041,'暗裔小鬼',0,0,0,'宝宝副本41关小怪Lv480',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',480,1,123112,6536489,53772,48507,6677,6677,4719,4910,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050042,'拆塔狂魔',0,0,0,'宝宝副本42关小怪Lv485',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',485,1,126529,6727030,55144,49871,6933,6933,4910,5112,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050043,'爆弹怪',0,0,0,'宝宝副本43关小怪Lv490',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',490,1,129945,6917572,56516,51235,7188,7188,5101,5315,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050044,'暗裔小鬼',0,0,0,'宝宝副本44关小怪Lv495',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',495,1,133360,7108113,57888,52599,7444,7444,5292,5517,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050045,'拆塔狂魔',0,0,0,'宝宝副本45关小怪Lv500',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',500,1,136774,7298655,59260,53963,7700,7700,5483,5720,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050046,'爆弹怪',0,0,0,'宝宝副本46关小怪Lv506',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',506,1,141562,7563230,61131,55835,8323,8323,5864,6108,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050047,'暗裔小鬼',0,0,0,'宝宝副本47关小怪Lv512',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',512,1,146349,7827804,63002,57707,8947,8947,6245,6496,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050048,'拆塔狂魔',0,0,0,'宝宝副本48关小怪Lv518',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',518,1,151132,8092376,64874,59579,9570,9570,6626,6884,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050049,'爆弹怪',0,0,0,'宝宝副本49关小怪Lv524',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',524,1,155917,8356948,66745,61451,10194,10194,7007,7273,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050050,'暗裔小鬼',0,0,0,'宝宝副本50关小怪Lv530',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',530,1,160702,8621866,68616,63322,10818,10818,7388,7661,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050051,'暗裔小鬼',0,0,0,'宝宝副本51关小怪Lv536',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',536,1,165485,8886440,70487,65194,11441,11441,7769,8049,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050052,'拆塔狂魔',0,0,0,'宝宝副本52关小怪Lv542',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',542,1,170266,9151013,72358,67066,12065,12065,8150,8437,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050053,'爆弹怪',0,0,0,'宝宝副本53关小怪Lv548',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',548,1,175040,9415585,74230,68938,12688,12688,8531,8825,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050054,'暗裔小鬼',0,0,0,'宝宝副本54关小怪Lv554',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',554,1,180048,9691766,76192,70909,13199,13199,8818,9111,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050055,'拆塔狂魔',0,0,0,'宝宝副本55关小怪Lv560',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',560,1,185172,9973571,78199,72930,13653,13653,9059,9344,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050056,'爆弹怪',0,0,0,'宝宝副本56关小怪Lv566',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',566,1,190289,10255377,80207,74951,14106,14106,9299,9578,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050057,'暗裔小鬼',0,0,0,'宝宝副本57关小怪Lv572',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',572,1,195408,10537183,82214,76972,14560,14560,9539,9812,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050058,'拆塔狂魔',0,0,0,'宝宝副本58关小怪Lv578',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',578,1,200520,10818615,84222,78994,15014,15014,9779,10045,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050059,'爆弹怪',0,0,0,'宝宝副本59关小怪Lv584',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',584,1,205634,11100419,86229,81015,15468,15468,10019,10279,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050060,'暗裔小鬼',0,0,0,'宝宝副本60关小怪Lv590',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',590,1,210739,11382223,88237,83036,15922,15922,10260,10513,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050061,'暗裔小鬼',0,0,0,'宝宝副本61关小怪Lv598',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',598,1,217543,11758217,90914,85730,16527,16527,10580,10824,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050062,'拆塔狂魔',0,0,0,'宝宝副本62关小怪Lv606',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',606,1,224919,13637368,93956,88809,17227,17227,11073,11303,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050063,'爆弹怪',0,0,0,'宝宝副本63关小怪Lv614',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',614,1,232481,14099001,97120,92015,17958,17958,11625,11839,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050064,'暗裔小鬼',0,0,0,'宝宝副本64关小怪Lv622',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',622,1,240038,14560636,100284,95221,18689,18689,12176,12374,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050065,'拆塔狂魔',0,0,0,'宝宝副本65关小怪Lv630',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',630,1,247595,15022273,103447,98427,19420,19420,12727,12909,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050066,'爆弹怪',0,0,0,'宝宝副本66关小怪Lv638',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',638,1,255140,15483463,106611,101634,20152,20152,13279,13444,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050067,'暗裔小鬼',0,0,0,'宝宝副本67关小怪Lv646',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',646,1,262678,15945099,109775,104840,20883,20883,13830,13979,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050068,'拆塔狂魔',0,0,0,'宝宝副本68关小怪Lv654',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',654,1,271074,16464940,112997,108112,21581,21581,14264,14406,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050069,'爆弹怪',0,0,0,'宝宝副本69关小怪Lv662',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',662,1,280334,17042525,116276,111451,22247,22247,14581,14725,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050070,'暗裔小鬼',0,0,0,'宝宝副本70关小怪Lv670',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',670,1,289583,17620570,119556,114789,22913,22913,14897,15045,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050071,'暗裔小鬼',0,0,0,'宝宝副本71关小怪Lv678',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',678,1,298826,18198620,122836,118127,23578,23578,15214,15364,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050072,'拆塔狂魔',0,0,0,'宝宝副本72关小怪Lv686',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',686,1,308067,18776197,126115,121466,24244,24244,15530,15683,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050073,'爆弹怪',0,0,0,'宝宝副本73关小怪Lv694',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',694,1,317295,19354249,129395,124804,24909,24909,15847,16003,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050074,'暗裔小鬼',0,0,0,'宝宝副本74关小怪Lv702',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',702,1,326322,19914968,132727,128197,25553,25553,16164,16315,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050075,'拆塔狂魔',0,0,0,'宝宝副本75关小怪Lv710',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',710,1,334733,20425129,136220,131752,26130,26130,16481,16607,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050076,'爆弹怪',0,0,0,'宝宝副本76关小怪Lv718',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',718,1,343140,20935776,139712,135306,26706,26706,16798,16899,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050077,'暗裔小鬼',0,0,0,'宝宝副本77关小怪Lv726',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',726,1,351538,21445937,143204,138861,27283,27283,17115,17191,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050078,'拆塔狂魔',0,0,0,'宝宝副本78关小怪Lv734',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',734,1,359920,21956098,146697,142416,27860,27860,17433,17483,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050079,'爆弹怪',0,0,0,'宝宝副本79关小怪Lv742',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',742,1,368298,22466259,150189,145971,28436,28436,17750,17775,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050080,'暗裔小鬼',0,0,0,'宝宝副本80关小怪Lv750',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',750,1,376660,22976419,153682,149526,29013,29013,18067,18067,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050081,'暗裔小鬼',0,0,0,'宝宝副本81关小怪Lv758',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',758,1,385847,23527640,157720,153662,29596,29596,18665,18665,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050082,'拆塔狂魔',0,0,0,'宝宝副本82关小怪Lv766',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',766,1,395019,24079354,161759,157797,30179,30179,19262,19262,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050083,'爆弹怪',0,0,0,'宝宝副本83关小怪Lv774',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',774,1,404181,24630574,165798,161933,30763,30763,19860,19860,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050084,'暗裔小鬼',0,0,0,'宝宝副本84关小怪Lv782',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',782,1,413333,25181794,169837,166069,31346,31346,20458,20458,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050085,'拆塔狂魔',0,0,0,'宝宝副本85关小怪Lv790',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',790,1,422479,25733511,173875,170204,31929,31929,21055,21055,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050086,'爆弹怪',0,0,0,'宝宝副本86关小怪Lv798',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',798,1,435700,26505292,179092,175311,32887,32887,21688,21688,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050087,'暗裔小鬼',0,0,0,'宝宝副本87关小怪Lv806',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',806,1,449350,30533983,184465,180570,33874,33874,22338,22338,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050088,'拆塔狂魔',0,0,0,'宝宝副本88关小怪Lv814',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',814,1,463437,31449983,189999,185987,34891,34891,23008,23008,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050089,'爆弹怪',0,0,0,'宝宝副本89关小怪Lv822',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',822,1,477982,32393468,195699,191567,35938,35938,23699,23699,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050090,'暗裔小鬼',0,0,0,'宝宝副本90关小怪Lv830',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',830,1,492996,33365238,201570,197314,37016,37016,24409,24409,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050091,'暗裔小鬼',0,0,0,'宝宝副本91关小怪Lv838',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',838,1,508495,34366163,207617,203233,38126,38126,25142,25142,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050092,'拆塔狂魔',0,0,0,'宝宝副本92关小怪Lv846',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',846,1,524499,35397118,213845,209330,39270,39270,25896,25896,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050093,'爆弹怪',0,0,0,'宝宝副本93关小怪Lv854',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',854,1,541023,36459048,220260,215610,40448,40448,26673,26673,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050094,'暗裔小鬼',0,0,0,'宝宝副本94关小怪Lv862',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',862,1,558076,37552825,226869,222078,41661,41661,27473,27473,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050095,'拆塔狂魔',0,0,0,'宝宝副本95关小怪Lv870',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',870,1,575693,38679393,233674,228740,42912,42912,28298,28298,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050096,'爆弹怪',0,0,0,'宝宝副本96关小怪Lv878',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',878,1,593879,39839772,240684,235602,44199,44199,29147,29147,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050097,'暗裔小鬼',0,0,0,'宝宝副本97关小怪Lv886',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',886,1,612657,41034979,247905,242670,45525,45525,30021,30021,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050098,'拆塔狂魔',0,0,0,'宝宝副本98关小怪Lv894',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',894,1,632044,42266032,255343,249950,46891,46891,30922,30922,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050099,'爆弹怪',0,0,0,'宝宝副本99关小怪Lv902',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',902,1,652066,43534022,263003,257449,48298,48298,31849,31849,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400050100,'暗裔小鬼',0,0,0,'宝宝副本100关小怪Lv910',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',910,1,672741,44840039,270893,265172,49747,49747,32804,32804,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060001,'暗裔小鬼',0,0,0,'宝宝副本1关小怪Lv310',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:3',310,1,20021,669531,19483,12408,967,967,1066,1082,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060002,'拆塔狂魔',0,0,0,'宝宝副本2关小怪Lv313',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:4',313,1,24737,763991,20002,12930,1012,1012,1084,1101,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060003,'爆弹怪',0,0,0,'宝宝副本3关小怪Lv316',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:5',316,1,29692,863373,20521,13453,1057,1057,1102,1120,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060004,'暗裔小鬼',0,0,0,'宝宝副本4关小怪Lv319',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:6',319,1,34885,967830,21040,13975,1101,1101,1121,1139,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060005,'拆塔狂魔',0,0,0,'宝宝副本5关小怪Lv322',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:7',322,1,40316,1077194,21559,14498,1146,1146,1139,1158,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060006,'爆弹怪',0,0,0,'宝宝副本6关小怪Lv325',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:8',325,1,43685,1191544,22078,15021,1190,1190,1158,1177,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060007,'暗裔小鬼',0,0,0,'宝宝副本7关小怪Lv328',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:9',328,1,46706,1392931,22596,15543,1235,1235,1176,1196,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060008,'拆塔狂魔',0,0,0,'宝宝副本8关小怪Lv331',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:10',331,1,47885,1604186,23115,16066,1279,1279,1194,1215,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060009,'爆弹怪',0,0,0,'宝宝副本9关小怪Lv334',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',334,1,49064,1825569,23634,16588,1324,1324,1213,1234,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060010,'暗裔小鬼',0,0,0,'宝宝副本10关小怪Lv337',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',337,1,50243,2056786,24153,17111,1369,1369,1231,1252,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060011,'暗裔小鬼',0,0,0,'宝宝副本11关小怪Lv340',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',340,1,51422,2298166,24672,17633,1413,1413,1250,1271,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060012,'拆塔狂魔',0,0,0,'宝宝副本12关小怪Lv344',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',344,1,52994,2381348,25364,18330,1473,1473,1274,1297,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060013,'爆弹怪',0,0,0,'宝宝副本13关小怪Lv348',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',348,1,54567,2464528,26056,19027,1532,1532,1299,1322,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060014,'暗裔小鬼',0,0,0,'宝宝副本14关小怪Lv352',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',352,1,56314,2570488,26799,19856,1635,1635,1366,1391,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060015,'拆塔狂魔',0,0,0,'宝宝副本15关小怪Lv356',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',356,1,58230,2699030,27595,20818,1782,1782,1477,1503,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060016,'爆弹怪',0,0,0,'宝宝副本16关小怪Lv360',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',360,1,60151,2827571,28390,21780,1929,1929,1587,1615,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060017,'暗裔小鬼',0,0,0,'宝宝副本17关小怪Lv364',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',364,1,62069,2956111,29186,22742,2075,2075,1698,1727,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060018,'拆塔狂魔',0,0,0,'宝宝副本18关小怪Lv368',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',368,1,63987,3084650,29982,23704,2222,2222,1808,1840,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060019,'爆弹怪',0,0,0,'宝宝副本19关小怪Lv372',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',372,1,65909,3213189,30777,24666,2369,2369,1919,1952,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060020,'暗裔小鬼',0,0,0,'宝宝副本20关小怪Lv376',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',376,1,67827,3341964,31573,25627,2515,2515,2029,2064,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060021,'暗裔小鬼',0,0,0,'宝宝副本21关小怪Lv380',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',380,1,69750,3470506,32368,26589,2662,2662,2140,2176,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060022,'拆塔狂魔',0,0,0,'宝宝副本22关小怪Lv385',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',385,1,72148,3631058,33363,27792,2845,2845,2278,2316,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060023,'爆弹怪',0,0,0,'宝宝副本23关小怪Lv390',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',390,1,74550,3791857,34357,28994,3029,3029,2416,2457,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060024,'暗裔小鬼',0,0,0,'宝宝副本24关小怪Lv395',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',395,1,76947,3952401,35352,30197,3212,3212,2554,2597,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060025,'拆塔狂魔',0,0,0,'宝宝副本25关小怪Lv400',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',400,1,79348,4113203,36346,31399,3395,3395,2692,2737,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060026,'爆弹怪',0,0,0,'宝宝副本26关小怪Lv405',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',405,1,81678,4241314,37266,32291,3570,3570,2780,2833,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060027,'暗裔小鬼',0,0,0,'宝宝副本27关小怪Lv410',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',410,1,84011,4369156,38185,33184,3745,3745,2868,2928,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060028,'拆塔狂魔',0,0,0,'宝宝副本28关小怪Lv415',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',415,1,86338,4497269,39105,34076,3919,3919,2956,3024,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060029,'爆弹怪',0,0,0,'宝宝副本29关小怪Lv420',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',420,1,88668,4625107,40024,34969,4094,4094,3045,3120,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060030,'暗裔小鬼',0,0,0,'宝宝副本30关小怪Lv425',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',425,1,90993,4753221,40944,35861,4269,4269,3133,3216,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060031,'暗裔小鬼',0,0,0,'宝宝副本31关小怪Lv430',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',430,1,93320,4881337,41863,36753,4444,4444,3221,3312,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060032,'拆塔狂魔',0,0,0,'宝宝副本32关小怪Lv435',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',435,1,95641,5009172,42783,37646,4618,4618,3309,3407,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060033,'爆弹怪',0,0,0,'宝宝副本33关小怪Lv440',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',440,1,97965,5137289,43702,38538,4793,4793,3397,3503,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060034,'暗裔小鬼',0,0,0,'宝宝副本34关小怪Lv445',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',445,1,100283,5265121,44622,39431,4968,4968,3485,3599,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060035,'拆塔狂魔',0,0,0,'宝宝副本35关小怪Lv450',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',450,1,102603,5393239,45541,40323,5142,5142,3573,3695,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060036,'爆弹怪',0,0,0,'宝宝副本36关小怪Lv455',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',455,1,106020,5583781,46913,41687,5398,5398,3764,3897,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060037,'暗裔小鬼',0,0,0,'宝宝副本37关小怪Lv460',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',460,1,109437,5774322,48285,43051,5654,5654,3955,4100,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060038,'拆塔狂魔',0,0,0,'宝宝副本38关小怪Lv465',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',465,1,112855,5964864,49657,44415,5910,5910,4146,4302,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060039,'爆弹怪',0,0,0,'宝宝副本39关小怪Lv470',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',470,1,116273,6155405,51029,45779,6165,6165,4337,4505,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060040,'暗裔小鬼',0,0,0,'宝宝副本40关小怪Lv475',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',475,1,119691,6345947,52401,47143,6421,6421,4528,4707,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060041,'暗裔小鬼',0,0,0,'宝宝副本41关小怪Lv480',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',480,1,123112,6536489,53772,48507,6677,6677,4719,4910,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060042,'拆塔狂魔',0,0,0,'宝宝副本42关小怪Lv485',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',485,1,126529,6727030,55144,49871,6933,6933,4910,5112,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060043,'爆弹怪',0,0,0,'宝宝副本43关小怪Lv490',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',490,1,129945,6917572,56516,51235,7188,7188,5101,5315,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060044,'暗裔小鬼',0,0,0,'宝宝副本44关小怪Lv495',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',495,1,133360,7108113,57888,52599,7444,7444,5292,5517,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060045,'拆塔狂魔',0,0,0,'宝宝副本45关小怪Lv500',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',500,1,136774,7298655,59260,53963,7700,7700,5483,5720,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060046,'爆弹怪',0,0,0,'宝宝副本46关小怪Lv506',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',506,1,141562,7563230,61131,55835,8323,8323,5864,6108,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060047,'暗裔小鬼',0,0,0,'宝宝副本47关小怪Lv512',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',512,1,146349,7827804,63002,57707,8947,8947,6245,6496,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060048,'拆塔狂魔',0,0,0,'宝宝副本48关小怪Lv518',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',518,1,151132,8092376,64874,59579,9570,9570,6626,6884,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060049,'爆弹怪',0,0,0,'宝宝副本49关小怪Lv524',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',524,1,155917,8356948,66745,61451,10194,10194,7007,7273,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060050,'暗裔小鬼',0,0,0,'宝宝副本50关小怪Lv530',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',530,1,160702,8621866,68616,63322,10818,10818,7388,7661,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060051,'暗裔小鬼',0,0,0,'宝宝副本51关小怪Lv536',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',536,1,165485,8886440,70487,65194,11441,11441,7769,8049,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060052,'拆塔狂魔',0,0,0,'宝宝副本52关小怪Lv542',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',542,1,170266,9151013,72358,67066,12065,12065,8150,8437,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060053,'爆弹怪',0,0,0,'宝宝副本53关小怪Lv548',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',548,1,175040,9415585,74230,68938,12688,12688,8531,8825,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060054,'暗裔小鬼',0,0,0,'宝宝副本54关小怪Lv554',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',554,1,180048,9691766,76192,70909,13199,13199,8818,9111,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060055,'拆塔狂魔',0,0,0,'宝宝副本55关小怪Lv560',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',560,1,185172,9973571,78199,72930,13653,13653,9059,9344,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060056,'爆弹怪',0,0,0,'宝宝副本56关小怪Lv566',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',566,1,190289,10255377,80207,74951,14106,14106,9299,9578,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060057,'暗裔小鬼',0,0,0,'宝宝副本57关小怪Lv572',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',572,1,195408,10537183,82214,76972,14560,14560,9539,9812,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060058,'拆塔狂魔',0,0,0,'宝宝副本58关小怪Lv578',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',578,1,200520,10818615,84222,78994,15014,15014,9779,10045,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060059,'爆弹怪',0,0,0,'宝宝副本59关小怪Lv584',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',584,1,205634,11100419,86229,81015,15468,15468,10019,10279,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060060,'暗裔小鬼',0,0,0,'宝宝副本60关小怪Lv590',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',590,1,210739,11382223,88237,83036,15922,15922,10260,10513,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060061,'暗裔小鬼',0,0,0,'宝宝副本61关小怪Lv598',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',598,1,217543,11758217,90914,85730,16527,16527,10580,10824,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060062,'拆塔狂魔',0,0,0,'宝宝副本62关小怪Lv606',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',606,1,224919,13637368,93956,88809,17227,17227,11073,11303,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060063,'爆弹怪',0,0,0,'宝宝副本63关小怪Lv614',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',614,1,232481,14099001,97120,92015,17958,17958,11625,11839,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060064,'暗裔小鬼',0,0,0,'宝宝副本64关小怪Lv622',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',622,1,240038,14560636,100284,95221,18689,18689,12176,12374,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060065,'拆塔狂魔',0,0,0,'宝宝副本65关小怪Lv630',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',630,1,247595,15022273,103447,98427,19420,19420,12727,12909,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060066,'爆弹怪',0,0,0,'宝宝副本66关小怪Lv638',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',638,1,255140,15483463,106611,101634,20152,20152,13279,13444,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060067,'暗裔小鬼',0,0,0,'宝宝副本67关小怪Lv646',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',646,1,262678,15945099,109775,104840,20883,20883,13830,13979,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060068,'拆塔狂魔',0,0,0,'宝宝副本68关小怪Lv654',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',654,1,271074,16464940,112997,108112,21581,21581,14264,14406,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060069,'爆弹怪',0,0,0,'宝宝副本69关小怪Lv662',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',662,1,280334,17042525,116276,111451,22247,22247,14581,14725,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060070,'暗裔小鬼',0,0,0,'宝宝副本70关小怪Lv670',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',670,1,289583,17620570,119556,114789,22913,22913,14897,15045,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060071,'暗裔小鬼',0,0,0,'宝宝副本71关小怪Lv678',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',678,1,298826,18198620,122836,118127,23578,23578,15214,15364,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060072,'拆塔狂魔',0,0,0,'宝宝副本72关小怪Lv686',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',686,1,308067,18776197,126115,121466,24244,24244,15530,15683,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060073,'爆弹怪',0,0,0,'宝宝副本73关小怪Lv694',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',694,1,317295,19354249,129395,124804,24909,24909,15847,16003,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060074,'暗裔小鬼',0,0,0,'宝宝副本74关小怪Lv702',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',702,1,326322,19914968,132727,128197,25553,25553,16164,16315,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060075,'拆塔狂魔',0,0,0,'宝宝副本75关小怪Lv710',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',710,1,334733,20425129,136220,131752,26130,26130,16481,16607,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060076,'爆弹怪',0,0,0,'宝宝副本76关小怪Lv718',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',718,1,343140,20935776,139712,135306,26706,26706,16798,16899,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060077,'暗裔小鬼',0,0,0,'宝宝副本77关小怪Lv726',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',726,1,351538,21445937,143204,138861,27283,27283,17115,17191,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060078,'拆塔狂魔',0,0,0,'宝宝副本78关小怪Lv734',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',734,1,359920,21956098,146697,142416,27860,27860,17433,17483,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060079,'爆弹怪',0,0,0,'宝宝副本79关小怪Lv742',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',742,1,368298,22466259,150189,145971,28436,28436,17750,17775,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060080,'暗裔小鬼',0,0,0,'宝宝副本80关小怪Lv750',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',750,1,376660,22976419,153682,149526,29013,29013,18067,18067,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060081,'暗裔小鬼',0,0,0,'宝宝副本81关小怪Lv758',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',758,1,385847,23527640,157720,153662,29596,29596,18665,18665,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060082,'拆塔狂魔',0,0,0,'宝宝副本82关小怪Lv766',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',766,1,395019,24079354,161759,157797,30179,30179,19262,19262,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060083,'爆弹怪',0,0,0,'宝宝副本83关小怪Lv774',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',774,1,404181,24630574,165798,161933,30763,30763,19860,19860,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060084,'暗裔小鬼',0,0,0,'宝宝副本84关小怪Lv782',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',782,1,413333,25181794,169837,166069,31346,31346,20458,20458,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060085,'拆塔狂魔',0,0,0,'宝宝副本85关小怪Lv790',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',790,1,422479,25733511,173875,170204,31929,31929,21055,21055,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060086,'爆弹怪',0,0,0,'宝宝副本86关小怪Lv798',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',798,1,435700,26505292,179092,175311,32887,32887,21688,21688,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060087,'暗裔小鬼',0,0,0,'宝宝副本87关小怪Lv806',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',806,1,449350,30533983,184465,180570,33874,33874,22338,22338,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060088,'拆塔狂魔',0,0,0,'宝宝副本88关小怪Lv814',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',814,1,463437,31449983,189999,185987,34891,34891,23008,23008,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060089,'爆弹怪',0,0,0,'宝宝副本89关小怪Lv822',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',822,1,477982,32393468,195699,191567,35938,35938,23699,23699,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060090,'暗裔小鬼',0,0,0,'宝宝副本90关小怪Lv830',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',830,1,492996,33365238,201570,197314,37016,37016,24409,24409,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060091,'暗裔小鬼',0,0,0,'宝宝副本91关小怪Lv838',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',838,1,508495,34366163,207617,203233,38126,38126,25142,25142,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060092,'拆塔狂魔',0,0,0,'宝宝副本92关小怪Lv846',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',846,1,524499,35397118,213845,209330,39270,39270,25896,25896,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060093,'爆弹怪',0,0,0,'宝宝副本93关小怪Lv854',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',854,1,541023,36459048,220260,215610,40448,40448,26673,26673,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060094,'暗裔小鬼',0,0,0,'宝宝副本94关小怪Lv862',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',862,1,558076,37552825,226869,222078,41661,41661,27473,27473,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060095,'拆塔狂魔',0,0,0,'宝宝副本95关小怪Lv870',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',870,1,575693,38679393,233674,228740,42912,42912,28298,28298,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060096,'爆弹怪',0,0,0,'宝宝副本96关小怪Lv878',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',878,1,593879,39839772,240684,235602,44199,44199,29147,29147,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060097,'暗裔小鬼',0,0,0,'宝宝副本97关小怪Lv886',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',886,1,612657,41034979,247905,242670,45525,45525,30021,30021,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060098,'拆塔狂魔',0,0,0,'宝宝副本98关小怪Lv894',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',894,1,632044,42266032,255343,249950,46891,46891,30922,30922,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060099,'爆弹怪',0,0,0,'宝宝副本99关小怪Lv902',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',902,1,652066,43534022,263003,257449,48298,48298,31849,31849,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400060100,'暗裔小鬼',0,0,0,'宝宝副本100关小怪Lv910',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',910,1,672741,44840039,270893,265172,49747,49747,32804,32804,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070001,'暗裔小鬼',0,0,0,'宝宝副本1关小怪Lv310',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:3',310,1,20021,669531,19483,12408,967,967,1066,1082,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070002,'拆塔狂魔',0,0,0,'宝宝副本2关小怪Lv313',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:4',313,1,24737,763991,20002,12930,1012,1012,1084,1101,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070003,'爆弹怪',0,0,0,'宝宝副本3关小怪Lv316',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:5',316,1,29692,863373,20521,13453,1057,1057,1102,1120,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070004,'暗裔小鬼',0,0,0,'宝宝副本4关小怪Lv319',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:6',319,1,34885,967830,21040,13975,1101,1101,1121,1139,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070005,'拆塔狂魔',0,0,0,'宝宝副本5关小怪Lv322',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:7',322,1,40316,1077194,21559,14498,1146,1146,1139,1158,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070006,'爆弹怪',0,0,0,'宝宝副本6关小怪Lv325',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:8',325,1,43685,1191544,22078,15021,1190,1190,1158,1177,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070007,'暗裔小鬼',0,0,0,'宝宝副本7关小怪Lv328',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:9',328,1,46706,1392931,22596,15543,1235,1235,1176,1196,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070008,'拆塔狂魔',0,0,0,'宝宝副本8关小怪Lv331',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'3||只要三人冲到传送阵，守护方就失败啦！:3||只要三人冲到传送阵，守护方就失败啦！:10',331,1,47885,1604186,23115,16066,1279,1279,1194,1215,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070009,'爆弹怪',0,0,0,'宝宝副本9关小怪Lv334',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',334,1,49064,1825569,23634,16588,1324,1324,1213,1234,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070010,'暗裔小鬼',0,0,0,'宝宝副本10关小怪Lv337',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',337,1,50243,2056786,24153,17111,1369,1369,1231,1252,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070011,'暗裔小鬼',0,0,0,'宝宝副本11关小怪Lv340',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',340,1,51422,2298166,24672,17633,1413,1413,1250,1271,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070012,'拆塔狂魔',0,0,0,'宝宝副本12关小怪Lv344',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',344,1,52994,2381348,25364,18330,1473,1473,1274,1297,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070013,'爆弹怪',0,0,0,'宝宝副本13关小怪Lv348',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',348,1,54567,2464528,26056,19027,1532,1532,1299,1322,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070014,'暗裔小鬼',0,0,0,'宝宝副本14关小怪Lv352',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',352,1,56314,2570488,26799,19856,1635,1635,1366,1391,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070015,'拆塔狂魔',0,0,0,'宝宝副本15关小怪Lv356',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',356,1,58230,2699030,27595,20818,1782,1782,1477,1503,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070016,'爆弹怪',0,0,0,'宝宝副本16关小怪Lv360',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',360,1,60151,2827571,28390,21780,1929,1929,1587,1615,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070017,'暗裔小鬼',0,0,0,'宝宝副本17关小怪Lv364',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',364,1,62069,2956111,29186,22742,2075,2075,1698,1727,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070018,'拆塔狂魔',0,0,0,'宝宝副本18关小怪Lv368',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',368,1,63987,3084650,29982,23704,2222,2222,1808,1840,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070019,'爆弹怪',0,0,0,'宝宝副本19关小怪Lv372',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',372,1,65909,3213189,30777,24666,2369,2369,1919,1952,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070020,'暗裔小鬼',0,0,0,'宝宝副本20关小怪Lv376',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',376,1,67827,3341964,31573,25627,2515,2515,2029,2064,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070021,'暗裔小鬼',0,0,0,'宝宝副本21关小怪Lv380',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',380,1,69750,3470506,32368,26589,2662,2662,2140,2176,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070022,'拆塔狂魔',0,0,0,'宝宝副本22关小怪Lv385',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',385,1,72148,3631058,33363,27792,2845,2845,2278,2316,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070023,'爆弹怪',0,0,0,'宝宝副本23关小怪Lv390',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',390,1,74550,3791857,34357,28994,3029,3029,2416,2457,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070024,'暗裔小鬼',0,0,0,'宝宝副本24关小怪Lv395',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',395,1,76947,3952401,35352,30197,3212,3212,2554,2597,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070025,'拆塔狂魔',0,0,0,'宝宝副本25关小怪Lv400',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',400,1,79348,4113203,36346,31399,3395,3395,2692,2737,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070026,'爆弹怪',0,0,0,'宝宝副本26关小怪Lv405',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',405,1,81678,4241314,37266,32291,3570,3570,2780,2833,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070027,'暗裔小鬼',0,0,0,'宝宝副本27关小怪Lv410',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',410,1,84011,4369156,38185,33184,3745,3745,2868,2928,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070028,'拆塔狂魔',0,0,0,'宝宝副本28关小怪Lv415',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',415,1,86338,4497269,39105,34076,3919,3919,2956,3024,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070029,'爆弹怪',0,0,0,'宝宝副本29关小怪Lv420',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',420,1,88668,4625107,40024,34969,4094,4094,3045,3120,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070030,'暗裔小鬼',0,0,0,'宝宝副本30关小怪Lv425',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',425,1,90993,4753221,40944,35861,4269,4269,3133,3216,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070031,'暗裔小鬼',0,0,0,'宝宝副本31关小怪Lv430',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',430,1,93320,4881337,41863,36753,4444,4444,3221,3312,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070032,'拆塔狂魔',0,0,0,'宝宝副本32关小怪Lv435',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',435,1,95641,5009172,42783,37646,4618,4618,3309,3407,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070033,'爆弹怪',0,0,0,'宝宝副本33关小怪Lv440',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',440,1,97965,5137289,43702,38538,4793,4793,3397,3503,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070034,'暗裔小鬼',0,0,0,'宝宝副本34关小怪Lv445',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',445,1,100283,5265121,44622,39431,4968,4968,3485,3599,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070035,'拆塔狂魔',0,0,0,'宝宝副本35关小怪Lv450',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',450,1,102603,5393239,45541,40323,5142,5142,3573,3695,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070036,'爆弹怪',0,0,0,'宝宝副本36关小怪Lv455',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',455,1,106020,5583781,46913,41687,5398,5398,3764,3897,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070037,'暗裔小鬼',0,0,0,'宝宝副本37关小怪Lv460',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',460,1,109437,5774322,48285,43051,5654,5654,3955,4100,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070038,'拆塔狂魔',0,0,0,'宝宝副本38关小怪Lv465',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',465,1,112855,5964864,49657,44415,5910,5910,4146,4302,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070039,'爆弹怪',0,0,0,'宝宝副本39关小怪Lv470',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',470,1,116273,6155405,51029,45779,6165,6165,4337,4505,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070040,'暗裔小鬼',0,0,0,'宝宝副本40关小怪Lv475',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',475,1,119691,6345947,52401,47143,6421,6421,4528,4707,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070041,'暗裔小鬼',0,0,0,'宝宝副本41关小怪Lv480',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',480,1,123112,6536489,53772,48507,6677,6677,4719,4910,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070042,'拆塔狂魔',0,0,0,'宝宝副本42关小怪Lv485',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',485,1,126529,6727030,55144,49871,6933,6933,4910,5112,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070043,'爆弹怪',0,0,0,'宝宝副本43关小怪Lv490',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',490,1,129945,6917572,56516,51235,7188,7188,5101,5315,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070044,'暗裔小鬼',0,0,0,'宝宝副本44关小怪Lv495',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',495,1,133360,7108113,57888,52599,7444,7444,5292,5517,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070045,'拆塔狂魔',0,0,0,'宝宝副本45关小怪Lv500',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',500,1,136774,7298655,59260,53963,7700,7700,5483,5720,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070046,'爆弹怪',0,0,0,'宝宝副本46关小怪Lv506',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',506,1,141562,7563230,61131,55835,8323,8323,5864,6108,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070047,'暗裔小鬼',0,0,0,'宝宝副本47关小怪Lv512',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',512,1,146349,7827804,63002,57707,8947,8947,6245,6496,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070048,'拆塔狂魔',0,0,0,'宝宝副本48关小怪Lv518',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',518,1,151132,8092376,64874,59579,9570,9570,6626,6884,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070049,'爆弹怪',0,0,0,'宝宝副本49关小怪Lv524',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',524,1,155917,8356948,66745,61451,10194,10194,7007,7273,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070050,'暗裔小鬼',0,0,0,'宝宝副本50关小怪Lv530',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',530,1,160702,8621866,68616,63322,10818,10818,7388,7661,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070051,'暗裔小鬼',0,0,0,'宝宝副本51关小怪Lv536',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',536,1,165485,8886440,70487,65194,11441,11441,7769,8049,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070052,'拆塔狂魔',0,0,0,'宝宝副本52关小怪Lv542',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',542,1,170266,9151013,72358,67066,12065,12065,8150,8437,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070053,'爆弹怪',0,0,0,'宝宝副本53关小怪Lv548',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',548,1,175040,9415585,74230,68938,12688,12688,8531,8825,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070054,'暗裔小鬼',0,0,0,'宝宝副本54关小怪Lv554',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',554,1,180048,9691766,76192,70909,13199,13199,8818,9111,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070055,'拆塔狂魔',0,0,0,'宝宝副本55关小怪Lv560',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',560,1,185172,9973571,78199,72930,13653,13653,9059,9344,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070056,'爆弹怪',0,0,0,'宝宝副本56关小怪Lv566',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',566,1,190289,10255377,80207,74951,14106,14106,9299,9578,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070057,'暗裔小鬼',0,0,0,'宝宝副本57关小怪Lv572',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',572,1,195408,10537183,82214,76972,14560,14560,9539,9812,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070058,'拆塔狂魔',0,0,0,'宝宝副本58关小怪Lv578',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',578,1,200520,10818615,84222,78994,15014,15014,9779,10045,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070059,'爆弹怪',0,0,0,'宝宝副本59关小怪Lv584',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',584,1,205634,11100419,86229,81015,15468,15468,10019,10279,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070060,'暗裔小鬼',0,0,0,'宝宝副本60关小怪Lv590',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',590,1,210739,11382223,88237,83036,15922,15922,10260,10513,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070061,'暗裔小鬼',0,0,0,'宝宝副本61关小怪Lv598',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',598,1,217543,11758217,90914,85730,16527,16527,10580,10824,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070062,'拆塔狂魔',0,0,0,'宝宝副本62关小怪Lv606',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',606,1,224919,13637368,93956,88809,17227,17227,11073,11303,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070063,'爆弹怪',0,0,0,'宝宝副本63关小怪Lv614',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',614,1,232481,14099001,97120,92015,17958,17958,11625,11839,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070064,'暗裔小鬼',0,0,0,'宝宝副本64关小怪Lv622',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',622,1,240038,14560636,100284,95221,18689,18689,12176,12374,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070065,'拆塔狂魔',0,0,0,'宝宝副本65关小怪Lv630',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',630,1,247595,15022273,103447,98427,19420,19420,12727,12909,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070066,'爆弹怪',0,0,0,'宝宝副本66关小怪Lv638',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',638,1,255140,15483463,106611,101634,20152,20152,13279,13444,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070067,'暗裔小鬼',0,0,0,'宝宝副本67关小怪Lv646',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',646,1,262678,15945099,109775,104840,20883,20883,13830,13979,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070068,'拆塔狂魔',0,0,0,'宝宝副本68关小怪Lv654',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',654,1,271074,16464940,112997,108112,21581,21581,14264,14406,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070069,'爆弹怪',0,0,0,'宝宝副本69关小怪Lv662',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',662,1,280334,17042525,116276,111451,22247,22247,14581,14725,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070070,'暗裔小鬼',0,0,0,'宝宝副本70关小怪Lv670',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',670,1,289583,17620570,119556,114789,22913,22913,14897,15045,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070071,'暗裔小鬼',0,0,0,'宝宝副本71关小怪Lv678',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',678,1,298826,18198620,122836,118127,23578,23578,15214,15364,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070072,'拆塔狂魔',0,0,0,'宝宝副本72关小怪Lv686',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',686,1,308067,18776197,126115,121466,24244,24244,15530,15683,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070073,'爆弹怪',0,0,0,'宝宝副本73关小怪Lv694',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',694,1,317295,19354249,129395,124804,24909,24909,15847,16003,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070074,'暗裔小鬼',0,0,0,'宝宝副本74关小怪Lv702',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',702,1,326322,19914968,132727,128197,25553,25553,16164,16315,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070075,'拆塔狂魔',0,0,0,'宝宝副本75关小怪Lv710',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',710,1,334733,20425129,136220,131752,26130,26130,16481,16607,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070076,'爆弹怪',0,0,0,'宝宝副本76关小怪Lv718',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',718,1,343140,20935776,139712,135306,26706,26706,16798,16899,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070077,'暗裔小鬼',0,0,0,'宝宝副本77关小怪Lv726',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',726,1,351538,21445937,143204,138861,27283,27283,17115,17191,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070078,'拆塔狂魔',0,0,0,'宝宝副本78关小怪Lv734',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',734,1,359920,21956098,146697,142416,27860,27860,17433,17483,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070079,'爆弹怪',0,0,0,'宝宝副本79关小怪Lv742',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',742,1,368298,22466259,150189,145971,28436,28436,17750,17775,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070080,'暗裔小鬼',0,0,0,'宝宝副本80关小怪Lv750',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',750,1,376660,22976419,153682,149526,29013,29013,18067,18067,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070081,'暗裔小鬼',0,0,0,'宝宝副本81关小怪Lv758',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',758,1,385847,23527640,157720,153662,29596,29596,18665,18665,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070082,'拆塔狂魔',0,0,0,'宝宝副本82关小怪Lv766',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',766,1,395019,24079354,161759,157797,30179,30179,19262,19262,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070083,'爆弹怪',0,0,0,'宝宝副本83关小怪Lv774',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',774,1,404181,24630574,165798,161933,30763,30763,19860,19860,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070084,'暗裔小鬼',0,0,0,'宝宝副本84关小怪Lv782',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',782,1,413333,25181794,169837,166069,31346,31346,20458,20458,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070085,'拆塔狂魔',0,0,0,'宝宝副本85关小怪Lv790',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',790,1,422479,25733511,173875,170204,31929,31929,21055,21055,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070086,'爆弹怪',0,0,0,'宝宝副本86关小怪Lv798',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',798,1,435700,26505292,179092,175311,32887,32887,21688,21688,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070087,'暗裔小鬼',0,0,0,'宝宝副本87关小怪Lv806',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',806,1,449350,30533983,184465,180570,33874,33874,22338,22338,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070088,'拆塔狂魔',0,0,0,'宝宝副本88关小怪Lv814',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',814,1,463437,31449983,189999,185987,34891,34891,23008,23008,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070089,'爆弹怪',0,0,0,'宝宝副本89关小怪Lv822',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',822,1,477982,32393468,195699,191567,35938,35938,23699,23699,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070090,'暗裔小鬼',0,0,0,'宝宝副本90关小怪Lv830',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',830,1,492996,33365238,201570,197314,37016,37016,24409,24409,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070091,'暗裔小鬼',0,0,0,'宝宝副本91关小怪Lv838',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',838,1,508495,34366163,207617,203233,38126,38126,25142,25142,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070092,'拆塔狂魔',0,0,0,'宝宝副本92关小怪Lv846',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',846,1,524499,35397118,213845,209330,39270,39270,25896,25896,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070093,'爆弹怪',0,0,0,'宝宝副本93关小怪Lv854',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',854,1,541023,36459048,220260,215610,40448,40448,26673,26673,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070094,'暗裔小鬼',0,0,0,'宝宝副本94关小怪Lv862',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',862,1,558076,37552825,226869,222078,41661,41661,27473,27473,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070095,'拆塔狂魔',0,0,0,'宝宝副本95关小怪Lv870',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',870,1,575693,38679393,233674,228740,42912,42912,28298,28298,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070096,'爆弹怪',0,0,0,'宝宝副本96关小怪Lv878',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',878,1,593879,39839772,240684,235602,44199,44199,29147,29147,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070097,'暗裔小鬼',0,0,0,'宝宝副本97关小怪Lv886',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',886,1,612657,41034979,247905,242670,45525,45525,30021,30021,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070098,'拆塔狂魔',0,0,0,'宝宝副本98关小怪Lv894',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',894,1,632044,42266032,255343,249950,46891,46891,30922,30922,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070099,'爆弹怪',0,0,0,'宝宝副本99关小怪Lv902',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',902,1,652066,43534022,263003,257449,48298,48298,31849,31849,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400070100,'暗裔小鬼',0,0,0,'宝宝副本100关小怪Lv910',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',910,1,672741,44840039,270893,265172,49747,49747,32804,32804,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080001,'暗裔小鬼',0,0,0,'宝宝副本1关小怪Lv310',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',310,1,20021,669531,19483,12408,967,967,1066,1082,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080002,'拆塔狂魔',0,0,0,'宝宝副本2关小怪Lv313',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',313,1,24737,763991,20002,12930,1012,1012,1084,1101,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080003,'爆弹怪',0,0,0,'宝宝副本3关小怪Lv316',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',316,1,29692,863373,20521,13453,1057,1057,1102,1120,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080004,'暗裔小鬼',0,0,0,'宝宝副本4关小怪Lv319',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',319,1,34885,967830,21040,13975,1101,1101,1121,1139,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080005,'拆塔狂魔',0,0,0,'宝宝副本5关小怪Lv322',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',322,1,40316,1077194,21559,14498,1146,1146,1139,1158,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080006,'爆弹怪',0,0,0,'宝宝副本6关小怪Lv325',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',325,1,43685,1191544,22078,15021,1190,1190,1158,1177,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080007,'暗裔小鬼',0,0,0,'宝宝副本7关小怪Lv328',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',328,1,46706,1392931,22596,15543,1235,1235,1176,1196,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080008,'拆塔狂魔',0,0,0,'宝宝副本8关小怪Lv331',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',331,1,47885,1604186,23115,16066,1279,1279,1194,1215,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080009,'爆弹怪',0,0,0,'宝宝副本9关小怪Lv334',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',334,1,49064,1825569,23634,16588,1324,1324,1213,1234,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080010,'暗裔小鬼',0,0,0,'宝宝副本10关小怪Lv337',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',337,1,50243,2056786,24153,17111,1369,1369,1231,1252,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080011,'暗裔小鬼',0,0,0,'宝宝副本11关小怪Lv340',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',340,1,51422,2298166,24672,17633,1413,1413,1250,1271,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080012,'拆塔狂魔',0,0,0,'宝宝副本12关小怪Lv344',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',344,1,52994,2381348,25364,18330,1473,1473,1274,1297,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080013,'爆弹怪',0,0,0,'宝宝副本13关小怪Lv348',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',348,1,54567,2464528,26056,19027,1532,1532,1299,1322,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080014,'暗裔小鬼',0,0,0,'宝宝副本14关小怪Lv352',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',352,1,56314,2570488,26799,19856,1635,1635,1366,1391,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080015,'拆塔狂魔',0,0,0,'宝宝副本15关小怪Lv356',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',356,1,58230,2699030,27595,20818,1782,1782,1477,1503,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080016,'爆弹怪',0,0,0,'宝宝副本16关小怪Lv360',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',360,1,60151,2827571,28390,21780,1929,1929,1587,1615,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080017,'暗裔小鬼',0,0,0,'宝宝副本17关小怪Lv364',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',364,1,62069,2956111,29186,22742,2075,2075,1698,1727,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080018,'拆塔狂魔',0,0,0,'宝宝副本18关小怪Lv368',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',368,1,63987,3084650,29982,23704,2222,2222,1808,1840,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080019,'爆弹怪',0,0,0,'宝宝副本19关小怪Lv372',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',372,1,65909,3213189,30777,24666,2369,2369,1919,1952,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080020,'暗裔小鬼',0,0,0,'宝宝副本20关小怪Lv376',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',376,1,67827,3341964,31573,25627,2515,2515,2029,2064,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080021,'暗裔小鬼',0,0,0,'宝宝副本21关小怪Lv380',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',380,1,69750,3470506,32368,26589,2662,2662,2140,2176,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080022,'拆塔狂魔',0,0,0,'宝宝副本22关小怪Lv385',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',385,1,72148,3631058,33363,27792,2845,2845,2278,2316,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080023,'爆弹怪',0,0,0,'宝宝副本23关小怪Lv390',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',390,1,74550,3791857,34357,28994,3029,3029,2416,2457,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080024,'暗裔小鬼',0,0,0,'宝宝副本24关小怪Lv395',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',395,1,76947,3952401,35352,30197,3212,3212,2554,2597,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080025,'拆塔狂魔',0,0,0,'宝宝副本25关小怪Lv400',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',400,1,79348,4113203,36346,31399,3395,3395,2692,2737,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080026,'爆弹怪',0,0,0,'宝宝副本26关小怪Lv405',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',405,1,81678,4241314,37266,32291,3570,3570,2780,2833,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080027,'暗裔小鬼',0,0,0,'宝宝副本27关小怪Lv410',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',410,1,84011,4369156,38185,33184,3745,3745,2868,2928,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080028,'拆塔狂魔',0,0,0,'宝宝副本28关小怪Lv415',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',415,1,86338,4497269,39105,34076,3919,3919,2956,3024,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080029,'爆弹怪',0,0,0,'宝宝副本29关小怪Lv420',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',420,1,88668,4625107,40024,34969,4094,4094,3045,3120,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080030,'暗裔小鬼',0,0,0,'宝宝副本30关小怪Lv425',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',425,1,90993,4753221,40944,35861,4269,4269,3133,3216,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080031,'暗裔小鬼',0,0,0,'宝宝副本31关小怪Lv430',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',430,1,93320,4881337,41863,36753,4444,4444,3221,3312,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080032,'拆塔狂魔',0,0,0,'宝宝副本32关小怪Lv435',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',435,1,95641,5009172,42783,37646,4618,4618,3309,3407,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080033,'爆弹怪',0,0,0,'宝宝副本33关小怪Lv440',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',440,1,97965,5137289,43702,38538,4793,4793,3397,3503,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080034,'暗裔小鬼',0,0,0,'宝宝副本34关小怪Lv445',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',445,1,100283,5265121,44622,39431,4968,4968,3485,3599,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080035,'拆塔狂魔',0,0,0,'宝宝副本35关小怪Lv450',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',450,1,102603,5393239,45541,40323,5142,5142,3573,3695,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080036,'爆弹怪',0,0,0,'宝宝副本36关小怪Lv455',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',455,1,106020,5583781,46913,41687,5398,5398,3764,3897,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080037,'暗裔小鬼',0,0,0,'宝宝副本37关小怪Lv460',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',460,1,109437,5774322,48285,43051,5654,5654,3955,4100,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080038,'拆塔狂魔',0,0,0,'宝宝副本38关小怪Lv465',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',465,1,112855,5964864,49657,44415,5910,5910,4146,4302,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080039,'爆弹怪',0,0,0,'宝宝副本39关小怪Lv470',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',470,1,116273,6155405,51029,45779,6165,6165,4337,4505,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080040,'暗裔小鬼',0,0,0,'宝宝副本40关小怪Lv475',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',475,1,119691,6345947,52401,47143,6421,6421,4528,4707,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080041,'暗裔小鬼',0,0,0,'宝宝副本41关小怪Lv480',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',480,1,123112,6536489,53772,48507,6677,6677,4719,4910,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080042,'拆塔狂魔',0,0,0,'宝宝副本42关小怪Lv485',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',485,1,126529,6727030,55144,49871,6933,6933,4910,5112,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080043,'爆弹怪',0,0,0,'宝宝副本43关小怪Lv490',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',490,1,129945,6917572,56516,51235,7188,7188,5101,5315,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080044,'暗裔小鬼',0,0,0,'宝宝副本44关小怪Lv495',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',495,1,133360,7108113,57888,52599,7444,7444,5292,5517,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080045,'拆塔狂魔',0,0,0,'宝宝副本45关小怪Lv500',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',500,1,136774,7298655,59260,53963,7700,7700,5483,5720,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080046,'爆弹怪',0,0,0,'宝宝副本46关小怪Lv506',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',506,1,141562,7563230,61131,55835,8323,8323,5864,6108,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080047,'暗裔小鬼',0,0,0,'宝宝副本47关小怪Lv512',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',512,1,146349,7827804,63002,57707,8947,8947,6245,6496,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080048,'拆塔狂魔',0,0,0,'宝宝副本48关小怪Lv518',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',518,1,151132,8092376,64874,59579,9570,9570,6626,6884,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080049,'爆弹怪',0,0,0,'宝宝副本49关小怪Lv524',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',524,1,155917,8356948,66745,61451,10194,10194,7007,7273,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080050,'暗裔小鬼',0,0,0,'宝宝副本50关小怪Lv530',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',530,1,160702,8621866,68616,63322,10818,10818,7388,7661,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080051,'暗裔小鬼',0,0,0,'宝宝副本51关小怪Lv536',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',536,1,165485,8886440,70487,65194,11441,11441,7769,8049,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080052,'拆塔狂魔',0,0,0,'宝宝副本52关小怪Lv542',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',542,1,170266,9151013,72358,67066,12065,12065,8150,8437,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080053,'爆弹怪',0,0,0,'宝宝副本53关小怪Lv548',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',548,1,175040,9415585,74230,68938,12688,12688,8531,8825,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080054,'暗裔小鬼',0,0,0,'宝宝副本54关小怪Lv554',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',554,1,180048,9691766,76192,70909,13199,13199,8818,9111,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080055,'拆塔狂魔',0,0,0,'宝宝副本55关小怪Lv560',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',560,1,185172,9973571,78199,72930,13653,13653,9059,9344,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080056,'爆弹怪',0,0,0,'宝宝副本56关小怪Lv566',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',566,1,190289,10255377,80207,74951,14106,14106,9299,9578,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080057,'暗裔小鬼',0,0,0,'宝宝副本57关小怪Lv572',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',572,1,195408,10537183,82214,76972,14560,14560,9539,9812,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080058,'拆塔狂魔',0,0,0,'宝宝副本58关小怪Lv578',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',578,1,200520,10818615,84222,78994,15014,15014,9779,10045,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080059,'爆弹怪',0,0,0,'宝宝副本59关小怪Lv584',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',584,1,205634,11100419,86229,81015,15468,15468,10019,10279,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080060,'暗裔小鬼',0,0,0,'宝宝副本60关小怪Lv590',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',590,1,210739,11382223,88237,83036,15922,15922,10260,10513,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080061,'暗裔小鬼',0,0,0,'宝宝副本61关小怪Lv598',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',598,1,217543,11758217,90914,85730,16527,16527,10580,10824,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080062,'拆塔狂魔',0,0,0,'宝宝副本62关小怪Lv606',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',606,1,224919,13637368,93956,88809,17227,17227,11073,11303,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080063,'爆弹怪',0,0,0,'宝宝副本63关小怪Lv614',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',614,1,232481,14099001,97120,92015,17958,17958,11625,11839,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080064,'暗裔小鬼',0,0,0,'宝宝副本64关小怪Lv622',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',622,1,240038,14560636,100284,95221,18689,18689,12176,12374,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080065,'拆塔狂魔',0,0,0,'宝宝副本65关小怪Lv630',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',630,1,247595,15022273,103447,98427,19420,19420,12727,12909,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080066,'爆弹怪',0,0,0,'宝宝副本66关小怪Lv638',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',638,1,255140,15483463,106611,101634,20152,20152,13279,13444,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080067,'暗裔小鬼',0,0,0,'宝宝副本67关小怪Lv646',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',646,1,262678,15945099,109775,104840,20883,20883,13830,13979,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080068,'拆塔狂魔',0,0,0,'宝宝副本68关小怪Lv654',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',654,1,271074,16464940,112997,108112,21581,21581,14264,14406,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080069,'爆弹怪',0,0,0,'宝宝副本69关小怪Lv662',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',662,1,280334,17042525,116276,111451,22247,22247,14581,14725,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080070,'暗裔小鬼',0,0,0,'宝宝副本70关小怪Lv670',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',670,1,289583,17620570,119556,114789,22913,22913,14897,15045,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080071,'暗裔小鬼',0,0,0,'宝宝副本71关小怪Lv678',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',678,1,298826,18198620,122836,118127,23578,23578,15214,15364,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080072,'拆塔狂魔',0,0,0,'宝宝副本72关小怪Lv686',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',686,1,308067,18776197,126115,121466,24244,24244,15530,15683,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080073,'爆弹怪',0,0,0,'宝宝副本73关小怪Lv694',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',694,1,317295,19354249,129395,124804,24909,24909,15847,16003,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080074,'暗裔小鬼',0,0,0,'宝宝副本74关小怪Lv702',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',702,1,326322,19914968,132727,128197,25553,25553,16164,16315,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080075,'拆塔狂魔',0,0,0,'宝宝副本75关小怪Lv710',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',710,1,334733,20425129,136220,131752,26130,26130,16481,16607,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080076,'爆弹怪',0,0,0,'宝宝副本76关小怪Lv718',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',718,1,343140,20935776,139712,135306,26706,26706,16798,16899,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080077,'暗裔小鬼',0,0,0,'宝宝副本77关小怪Lv726',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',726,1,351538,21445937,143204,138861,27283,27283,17115,17191,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080078,'拆塔狂魔',0,0,0,'宝宝副本78关小怪Lv734',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',734,1,359920,21956098,146697,142416,27860,27860,17433,17483,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080079,'爆弹怪',0,0,0,'宝宝副本79关小怪Lv742',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',742,1,368298,22466259,150189,145971,28436,28436,17750,17775,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080080,'暗裔小鬼',0,0,0,'宝宝副本80关小怪Lv750',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',750,1,376660,22976419,153682,149526,29013,29013,18067,18067,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080081,'暗裔小鬼',0,0,0,'宝宝副本81关小怪Lv758',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',758,1,385847,23527640,157720,153662,29596,29596,18665,18665,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080082,'拆塔狂魔',0,0,0,'宝宝副本82关小怪Lv766',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',766,1,395019,24079354,161759,157797,30179,30179,19262,19262,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080083,'爆弹怪',0,0,0,'宝宝副本83关小怪Lv774',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',774,1,404181,24630574,165798,161933,30763,30763,19860,19860,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080084,'暗裔小鬼',0,0,0,'宝宝副本84关小怪Lv782',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',782,1,413333,25181794,169837,166069,31346,31346,20458,20458,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080085,'拆塔狂魔',0,0,0,'宝宝副本85关小怪Lv790',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',790,1,422479,25733511,173875,170204,31929,31929,21055,21055,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080086,'爆弹怪',0,0,0,'宝宝副本86关小怪Lv798',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',798,1,435700,26505292,179092,175311,32887,32887,21688,21688,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080087,'暗裔小鬼',0,0,0,'宝宝副本87关小怪Lv806',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',806,1,449350,30533983,184465,180570,33874,33874,22338,22338,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080088,'拆塔狂魔',0,0,0,'宝宝副本88关小怪Lv814',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',814,1,463437,31449983,189999,185987,34891,34891,23008,23008,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080089,'爆弹怪',0,0,0,'宝宝副本89关小怪Lv822',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',822,1,477982,32393468,195699,191567,35938,35938,23699,23699,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080090,'暗裔小鬼',0,0,0,'宝宝副本90关小怪Lv830',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',830,1,492996,33365238,201570,197314,37016,37016,24409,24409,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080091,'暗裔小鬼',0,0,0,'宝宝副本91关小怪Lv838',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',838,1,508495,34366163,207617,203233,38126,38126,25142,25142,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080092,'拆塔狂魔',0,0,0,'宝宝副本92关小怪Lv846',0,1,0,0,0,202002,'1.3','0',0,0,0,202002,0,'0',846,1,524499,35397118,213845,209330,39270,39270,25896,25896,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080093,'爆弹怪',0,0,0,'宝宝副本93关小怪Lv854',0,1,0,0,0,202030,'1.3','0',0,0,0,202030,0,'0',854,1,541023,36459048,220260,215610,40448,40448,26673,26673,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080094,'暗裔小鬼',0,0,0,'宝宝副本94关小怪Lv862',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',862,1,558076,37552825,226869,222078,41661,41661,27473,27473,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080095,'拆塔狂魔',0,0,0,'宝宝副本95关小怪Lv870',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',870,1,575693,38679393,233674,228740,42912,42912,28298,28298,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080096,'爆弹怪',0,0,0,'宝宝副本96关小怪Lv878',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',878,1,593879,39839772,240684,235602,44199,44199,29147,29147,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080097,'暗裔小鬼',0,0,0,'宝宝副本97关小怪Lv886',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',886,1,612657,41034979,247905,242670,45525,45525,30021,30021,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080098,'拆塔狂魔',0,0,0,'宝宝副本98关小怪Lv894',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',894,1,632044,42266032,255343,249950,46891,46891,30922,30922,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080099,'爆弹怪',0,0,0,'宝宝副本99关小怪Lv902',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',902,1,652066,43534022,263003,257449,48298,48298,31849,31849,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(400080100,'暗裔小鬼',0,0,0,'宝宝副本100关小怪Lv910',0,1,0,0,0,202005,'1.3','0',0,0,0,202005,0,'0',910,1,672741,44840039,270893,265172,49747,49747,32804,32804,0,'[]','[]',250,500,500,500,60,'[{1110000003,1}]',0,1000,0,0,0,1,0,0,0,0,1,1,0,0,'[]',1,'0',0,0,0,0,0),(620020001,'神圣之锥',1,0,0,'跨服入侵普通采集怪面铠',0,1,0,0,0,2040011,'2','0',0,0,0,22500003,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,1,0,0,1,5,1,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(620020002,'烈火神晶',1,0,0,'跨服入侵普通采集怪刃爪',0,1,0,0,0,2040012,'2','0',0,0,0,22500006,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,1,0,0,1,5,1,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(620020003,'七彩神蛋',1,0,0,'跨服入侵普通采集怪挂饰',0,1,0,0,0,2040015,'2','0',0,0,0,1003010631,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,1,0,0,1,5,1,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(620020004,'潘多齿轮',1,0,0,'跨服入侵普通采集怪刻痕',0,1,0,0,0,2040017,'2','0',0,0,0,1005010631,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,1,0,0,1,5,1,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(620020005,'寒冰龙晶',1,0,0,'跨服入侵普通采集怪符文',0,1,0,0,0,2040018,'2','0',0,0,0,22500001,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,1,0,0,1,5,1,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(620020006,'光辉秘宝',1,0,0,'跨服入侵普通采集怪坐鞍',0,1,0,0,0,2040013,'2','0',0,0,0,22500004,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,1,0,0,1,5,1,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(620020007,'白银宝箱',1,0,0,'跨服入侵普通采集怪通用',0,1,0,0,0,2040010,'2','0',0,0,0,5020016,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,1,0,0,1,5,1,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(620020008,'黄金宝箱',1,0,0,'跨服入侵高级采集怪通用',0,1,0,0,0,2040009,'2','0',0,0,0,2040009,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,1,0,0,1,5,1,0,0,1,0,0,'[]',1,'0',0,0,0,0,0),(620030001,'黄金宝箱',1,0,0,'跨服入侵限时采集怪',0,1,0,0,0,2040009,'1','0',0,0,0,2040009,0,'0',2,1,5,3000,0,0,0,0,0,0,0,'[]','[]',100,2250,1500,2250,200,'[{1110000003,1}]',0,2000,0,1,0,0,1,5,1,0,0,1,0,0,'[]',1,'0',0,0,0,0,0);
/*!40000 ALTER TABLE `base_mon` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_mon_checkin_mutiple`
--

DROP TABLE IF EXISTS `base_mon_checkin_mutiple`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_mon_checkin_mutiple` (
  `lv_node` int(20) NOT NULL COMMENT '等级节点',
  `month_id` int(11) NOT NULL COMMENT '月份',
  `multiple` decimal(20,2) NOT NULL COMMENT '普通用户倍数',
  `vip_lv` int(11) NOT NULL COMMENT '使用vip倍数需要达到的vip等级',
  `vip_multiple` decimal(20,2) NOT NULL COMMENT 'vip奖励倍数',
  PRIMARY KEY (`lv_node`,`month_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='不同等级区间配置不同的奖励倍数和vip倍数';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_mon_checkin_mutiple`
--

LOCK TABLES `base_mon_checkin_mutiple` WRITE;
/*!40000 ALTER TABLE `base_mon_checkin_mutiple` DISABLE KEYS */;
INSERT INTO `base_mon_checkin_mutiple` VALUES (10,11,1.00,1,2.00);
/*!40000 ALTER TABLE `base_mon_checkin_mutiple` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_mon_checkin_reward`
--

DROP TABLE IF EXISTS `base_mon_checkin_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_mon_checkin_reward` (
  `month_id` int(11) NOT NULL COMMENT '月份',
  `day_id` int(11) NOT NULL COMMENT '当月的第几天',
  `rewards` varchar(255) NOT NULL COMMENT '奖励内容',
  PRIMARY KEY (`month_id`,`day_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='通过月份和天设置奖励内容';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_mon_checkin_reward`
--

LOCK TABLES `base_mon_checkin_reward` WRITE;
/*!40000 ALTER TABLE `base_mon_checkin_reward` DISABLE KEYS */;
INSERT INTO `base_mon_checkin_reward` VALUES (1,1,'[{0,14010001,1}]');
/*!40000 ALTER TABLE `base_mon_checkin_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_mon_checkin_total`
--

DROP TABLE IF EXISTS `base_mon_checkin_total`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_mon_checkin_total` (
  `month_id` int(11) NOT NULL COMMENT '月份',
  `total_days` int(11) NOT NULL COMMENT '累计签到达到天数',
  `total_rewards` varchar(255) NOT NULL COMMENT '奖励',
  PRIMARY KEY (`month_id`,`total_days`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='累计签到天数达到一定天数得到的奖励';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_mon_checkin_total`
--

LOCK TABLES `base_mon_checkin_total` WRITE;
/*!40000 ALTER TABLE `base_mon_checkin_total` DISABLE KEYS */;
INSERT INTO `base_mon_checkin_total` VALUES (11,2,'[]');
/*!40000 ALTER TABLE `base_mon_checkin_total` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_mon_drop_rule`
--

DROP TABLE IF EXISTS `base_mon_drop_rule`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_mon_drop_rule` (
  `act_id` smallint(5) unsigned NOT NULL DEFAULT '1' COMMENT '活动主id',
  `sub_id` smallint(5) unsigned NOT NULL DEFAULT '1' COMMENT '主动子id',
  `mon_type` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '怪物类型',
  `slv` int(11) unsigned NOT NULL DEFAULT '1' COMMENT '开始等级',
  `elv` int(11) unsigned NOT NULL DEFAULT '99' COMMENT '结束等级',
  `drop_list` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '掉落列表',
  `drop_rule` varchar(1000) DEFAULT '[]' COMMENT '掉落规则',
  PRIMARY KEY (`act_id`,`sub_id`,`mon_type`,`slv`,`elv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_mon_drop_rule`
--

LOCK TABLES `base_mon_drop_rule` WRITE;
/*!40000 ALTER TABLE `base_mon_drop_rule` DISABLE KEYS */;
INSERT INTO `base_mon_drop_rule` VALUES (4,1,1,80,1000,'[92]','1|92:1=70');
/*!40000 ALTER TABLE `base_mon_drop_rule` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_mon_dynamic`
--

DROP TABLE IF EXISTS `base_mon_dynamic`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_mon_dynamic` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '怪物配置id',
  `min_lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '最小等级',
  `max_lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '最大等级',
  `attr_list` varchar(512) NOT NULL DEFAULT '[]' COMMENT '属性列表',
  `att` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '攻击',
  `hp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '血量',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '经验',
  PRIMARY KEY (`id`,`max_lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='怪物动态属性';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_mon_dynamic`
--

LOCK TABLES `base_mon_dynamic` WRITE;
/*!40000 ALTER TABLE `base_mon_dynamic` DISABLE KEYS */;
INSERT INTO `base_mon_dynamic` VALUES (2101001,1,75,'[{1,303},{2,10981}]',303,10981,0),(2101001,76,105,'[{1,406},{2,14027}]',406,14027,0),(2101001,106,140,'[{1,506},{2,16270}]',506,16270,0),(2101001,141,180,'[{1,1687},{2,46721}]',1687,46721,0),(2101001,181,200,'[{1,2542},{2,65794}]',2542,65794,0),(2101001,201,240,'[{1,4432},{2,111749}]',4432,111749,0),(2101001,241,280,'[{1,6342},{2,157848}]',6342,157848,0),(2101001,281,320,'[{1,8122},{2,202070}]',8122,202070,0),(2101001,321,350,'[{1,9351},{2,233740}]',9351,233740,0),(2101001,351,375,'[{1,10361},{2,259920}]',10361,259920,0),(2101001,376,400,'[{1,11358},{2,285906}]',11358,285906,0),(2101001,401,425,'[{1,13413},{2,347096}]',13413,347096,0),(2101001,426,450,'[{1,15463},{2,408323}]',15463,408323,0),(2101001,451,475,'[{1,17503},{2,469462}]',17503,469462,0),(2101001,476,515,'[{1,21946},{2,593337}]',21946,593337,0),(2101001,516,550,'[{1,27602},{2,740302}]',27602,740302,0),(2101001,551,575,'[{1,35399},{2,940117}]',35399,940117,0),(2101001,576,595,'[{1,41732},{2,1100859}]',41732,1100859,0),(2101001,596,610,'[{1,47435},{2,1244077}]',47435,1244077,0),(2101001,611,630,'[{1,55727},{2,1450610}]',55727,1450610,0),(2101001,631,650,'[{1,64084},{2,1657665}]',64084,1657665,0),(2101001,651,670,'[{1,76502},{2,1967330}]',76502,1967330,0),(2101001,671,690,'[{1,89036},{2,2278141}]',89036,2278141,0),(2101001,691,710,'[{1,103605},{2,2628857}]',103605,2628857,0),(2101001,711,730,'[{1,120250},{2,3019257}]',120250,3019257,0),(2101001,731,750,'[{1,136991},{2,3409859}]',136991,3409859,0),(2101001,751,770,'[{1,153920},{2,3793784}]',153920,3793784,0),(2101001,771,790,'[{1,170874},{2,4177417}]',170874,4177417,0),(2101001,791,810,'[{1,187899},{2,4554953}]',187899,4554953,0),(2101001,811,830,'[{1,204970},{2,4926142}]',204970,4926142,0),(2101001,831,850,'[{1,222004},{2,5296654}]',222004,5296654,0),(2101001,851,870,'[{1,251185},{2,5942670}]',251185,5942670,0),(2101001,871,890,'[{1,280467},{2,6589015}]',280467,6589015,0),(2101001,891,910,'[{1,309470},{2,7216222}]',309470,7216222,0),(2101001,911,930,'[{1,338144},{2,7823817}]',338144,7823817,0),(2101001,931,950,'[{1,366799},{2,8430856}]',366799,8430856,0),(2101001,951,970,'[{1,398666},{2,9083295}]',398666,9083295,0),(2101001,971,1000,'[{1,446366},{2,10060201}]',446366,10060201,0),(2101002,1,75,'[{1,303},{2,10981}]',303,10981,0),(2101002,76,105,'[{1,406},{2,14027}]',406,14027,0),(2101002,106,140,'[{1,506},{2,16270}]',506,16270,0),(2101002,141,180,'[{1,1687},{2,46721}]',1687,46721,0),(2101002,181,200,'[{1,2542},{2,65794}]',2542,65794,0),(2101002,201,240,'[{1,4432},{2,111749}]',4432,111749,0),(2101002,241,280,'[{1,6342},{2,157848}]',6342,157848,0),(2101002,281,320,'[{1,8122},{2,202070}]',8122,202070,0),(2101002,321,350,'[{1,9351},{2,233740}]',9351,233740,0),(2101002,351,375,'[{1,10361},{2,259920}]',10361,259920,0),(2101002,376,400,'[{1,11358},{2,285906}]',11358,285906,0),(2101002,401,425,'[{1,13413},{2,347096}]',13413,347096,0),(2101002,426,450,'[{1,15463},{2,408323}]',15463,408323,0),(2101002,451,475,'[{1,17503},{2,469462}]',17503,469462,0),(2101002,476,515,'[{1,21946},{2,593337}]',21946,593337,0),(2101002,516,550,'[{1,27602},{2,740302}]',27602,740302,0),(2101002,551,575,'[{1,35399},{2,940117}]',35399,940117,0),(2101002,576,595,'[{1,41732},{2,1100859}]',41732,1100859,0),(2101002,596,610,'[{1,47435},{2,1244077}]',47435,1244077,0),(2101002,611,630,'[{1,55727},{2,1450610}]',55727,1450610,0),(2101002,631,650,'[{1,64084},{2,1657665}]',64084,1657665,0),(2101002,651,670,'[{1,76502},{2,1967330}]',76502,1967330,0),(2101002,671,690,'[{1,89036},{2,2278141}]',89036,2278141,0),(2101002,691,710,'[{1,103605},{2,2628857}]',103605,2628857,0),(2101002,711,730,'[{1,120250},{2,3019257}]',120250,3019257,0),(2101002,731,750,'[{1,136991},{2,3409859}]',136991,3409859,0),(2101002,751,770,'[{1,153920},{2,3793784}]',153920,3793784,0),(2101002,771,790,'[{1,170874},{2,4177417}]',170874,4177417,0),(2101002,791,810,'[{1,187899},{2,4554953}]',187899,4554953,0),(2101002,811,830,'[{1,204970},{2,4926142}]',204970,4926142,0),(2101002,831,850,'[{1,222004},{2,5296654}]',222004,5296654,0),(2101002,851,870,'[{1,251185},{2,5942670}]',251185,5942670,0),(2101002,871,890,'[{1,280467},{2,6589015}]',280467,6589015,0),(2101002,891,910,'[{1,309470},{2,7216222}]',309470,7216222,0),(2101002,911,930,'[{1,338144},{2,7823817}]',338144,7823817,0),(2101002,931,950,'[{1,366799},{2,8430856}]',366799,8430856,0),(2101002,951,970,'[{1,398666},{2,9083295}]',398666,9083295,0),(2101002,971,1000,'[{1,446366},{2,10060201}]',446366,10060201,0),(2101011,1,75,'[{1,25},{2,3294}]',25,3294,0),(2101011,76,105,'[{1,34},{2,4208}]',34,4208,0),(2101011,106,140,'[{1,42},{2,4881}]',42,4881,0),(2101011,141,180,'[{1,141},{2,14016}]',141,14016,0),(2101011,181,200,'[{1,212},{2,19738}]',212,19738,0),(2101011,201,240,'[{1,369},{2,33525}]',369,33525,0),(2101011,241,280,'[{1,528},{2,47354}]',528,47354,0),(2101011,281,320,'[{1,677},{2,60621}]',677,60621,0),(2101011,321,350,'[{1,779},{2,70122}]',779,70122,0),(2101011,351,375,'[{1,863},{2,77976}]',863,77976,0),(2101011,376,400,'[{1,946},{2,85772}]',946,85772,0),(2101011,401,425,'[{1,1118},{2,104129}]',1118,104129,0),(2101011,426,450,'[{1,1289},{2,122497}]',1289,122497,0),(2101011,451,475,'[{1,1459},{2,140839}]',1459,140839,0),(2101011,476,515,'[{1,1829},{2,178001}]',1829,178001,0),(2101011,516,550,'[{1,2300},{2,222091}]',2300,222091,0),(2101011,551,575,'[{1,2950},{2,282035}]',2950,282035,0),(2101011,576,595,'[{1,3478},{2,330258}]',3478,330258,0),(2101011,596,610,'[{1,3953},{2,373223}]',3953,373223,0),(2101011,611,630,'[{1,4644},{2,435183}]',4644,435183,0),(2101011,631,650,'[{1,5340},{2,497299}]',5340,497299,0),(2101011,651,670,'[{1,6375},{2,590199}]',6375,590199,0),(2101011,671,690,'[{1,7420},{2,683442}]',7420,683442,0),(2101011,691,710,'[{1,8634},{2,788657}]',8634,788657,0),(2101011,711,730,'[{1,10021},{2,905777}]',10021,905777,0),(2101011,731,750,'[{1,11416},{2,1022958}]',11416,1022958,0),(2101011,751,770,'[{1,12827},{2,1138135}]',12827,1138135,0),(2101011,771,790,'[{1,14240},{2,1253225}]',14240,1253225,0),(2101011,791,810,'[{1,15658},{2,1366486}]',15658,1366486,0),(2101011,811,830,'[{1,17081},{2,1477843}]',17081,1477843,0),(2101011,831,850,'[{1,18500},{2,1588996}]',18500,1588996,0),(2101011,851,870,'[{1,20932},{2,1782801}]',20932,1782801,0),(2101011,871,890,'[{1,23372},{2,1976704}]',23372,1976704,0),(2101011,891,910,'[{1,25789},{2,2164867}]',25789,2164867,0),(2101011,911,930,'[{1,28179},{2,2347145}]',28179,2347145,0),(2101011,931,950,'[{1,30567},{2,2529257}]',30567,2529257,0),(2101011,951,970,'[{1,33222},{2,2724988}]',33222,2724988,0),(2101011,971,1000,'[{1,37197},{2,3018060}]',37197,3018060,0),(2101012,1,75,'[{1,25},{2,3294}]',25,3294,0),(2101012,76,105,'[{1,34},{2,4208}]',34,4208,0),(2101012,106,140,'[{1,42},{2,4881}]',42,4881,0),(2101012,141,180,'[{1,141},{2,14016}]',141,14016,0),(2101012,181,200,'[{1,212},{2,19738}]',212,19738,0),(2101012,201,240,'[{1,369},{2,33525}]',369,33525,0),(2101012,241,280,'[{1,528},{2,47354}]',528,47354,0),(2101012,281,320,'[{1,677},{2,60621}]',677,60621,0),(2101012,321,350,'[{1,779},{2,70122}]',779,70122,0),(2101012,351,375,'[{1,863},{2,77976}]',863,77976,0),(2101012,376,400,'[{1,946},{2,85772}]',946,85772,0),(2101012,401,425,'[{1,1118},{2,104129}]',1118,104129,0),(2101012,426,450,'[{1,1289},{2,122497}]',1289,122497,0),(2101012,451,475,'[{1,1459},{2,140839}]',1459,140839,0),(2101012,476,515,'[{1,1829},{2,178001}]',1829,178001,0),(2101012,516,550,'[{1,2300},{2,222091}]',2300,222091,0),(2101012,551,575,'[{1,2950},{2,282035}]',2950,282035,0),(2101012,576,595,'[{1,3478},{2,330258}]',3478,330258,0),(2101012,596,610,'[{1,3953},{2,373223}]',3953,373223,0),(2101012,611,630,'[{1,4644},{2,435183}]',4644,435183,0),(2101012,631,650,'[{1,5340},{2,497299}]',5340,497299,0),(2101012,651,670,'[{1,6375},{2,590199}]',6375,590199,0),(2101012,671,690,'[{1,7420},{2,683442}]',7420,683442,0),(2101012,691,710,'[{1,8634},{2,788657}]',8634,788657,0),(2101012,711,730,'[{1,10021},{2,905777}]',10021,905777,0),(2101012,731,750,'[{1,11416},{2,1022958}]',11416,1022958,0),(2101012,751,770,'[{1,12827},{2,1138135}]',12827,1138135,0),(2101012,771,790,'[{1,14240},{2,1253225}]',14240,1253225,0),(2101012,791,810,'[{1,15658},{2,1366486}]',15658,1366486,0),(2101012,811,830,'[{1,17081},{2,1477843}]',17081,1477843,0),(2101012,831,850,'[{1,18500},{2,1588996}]',18500,1588996,0),(2101012,851,870,'[{1,20932},{2,1782801}]',20932,1782801,0),(2101012,871,890,'[{1,23372},{2,1976704}]',23372,1976704,0),(2101012,891,910,'[{1,25789},{2,2164867}]',25789,2164867,0),(2101012,911,930,'[{1,28179},{2,2347145}]',28179,2347145,0),(2101012,931,950,'[{1,30567},{2,2529257}]',30567,2529257,0),(2101012,951,970,'[{1,33222},{2,2724988}]',33222,2724988,0),(2101012,971,1000,'[{1,37197},{2,3018060}]',37197,3018060,0),(3002001,1,1,'[{1,14},{2,3677}]',14,3677,559),(3002001,2,1000,'[{1,14},{2,3677}]',14,3677,559),(4061021,1,360,'[{1,633},{2,62794772},{3,28390},{4,20691},{5,40000},{6,1929},{7,1587},{8,40000}]',633,62794772,0),(4061021,361,380,'[{1,734},{2,77623907},{3,32368},{4,25260},{5,40001},{6,2662},{7,2140},{8,40000}]',734,77623907,0),(4061021,381,400,'[{1,835},{2,92521894},{3,36346},{4,29829},{5,40002},{6,3395},{7,2692},{8,40000}]',835,92521894,0),(4061021,401,420,'[{1,933},{2,104247359},{3,40024},{4,33220},{5,40003},{6,4094},{7,3045},{8,40000}]',933,104247359,0),(4061021,421,440,'[{1,1031},{2,115958294},{3,43702},{4,36611},{5,40004},{6,4793},{7,3397},{8,40000}]',1031,115958294,0),(4061021,441,460,'[{1,1151},{2,130682281},{3,48285},{4,40898},{5,40005},{6,5654},{7,3955},{8,40000}]',1151,130682281,0),(4061021,461,480,'[{1,1295},{2,148444097},{3,53772},{4,46082},{5,40006},{6,6677},{7,4719},{8,40000}]',1295,148444097,0),(4061021,481,500,'[{1,1439},{2,166214938},{3,59260},{4,51265},{5,40007},{6,7700},{7,5483},{8,40000}]',1439,166214938,0),(4061021,501,530,'[{1,1691},{2,197247331},{3,68616},{4,60156},{5,40008},{6,10818},{7,7388},{8,40000}]',1691,197247331,0),(4061021,531,560,'[{1,1948},{2,228979720},{3,78199},{4,69284},{5,40009},{6,13653},{7,9059},{8,40000}]',1948,228979720,0),(4061021,561,590,'[{1,2217},{2,262111703},{3,88237},{4,78884},{5,40010},{6,15922},{7,10260},{8,40000}]',2217,262111703,0),(4061021,591,620,'[{1,2506},{2,297581005},{3,99493},{4,89699},{5,40011},{6,18506},{7,12038},{8,40000}]',2506,297581005,0),(4061021,621,650,'[{1,2803},{2,334186283},{3,111357},{4,101121},{5,40012},{6,21249},{7,14106},{8,40000}]',2803,334186283,0),(4061021,651,680,'[{1,3169},{2,379867024},{3,123655},{4,113014},{5,40013},{6,23745},{7,15293},{8,40000}]',3169,379867024,0),(4061021,681,710,'[{1,3522},{2,423791608},{3,136220},{4,125164},{5,40014},{6,26130},{7,16481},{8,40000}]',3522,423791608,0),(4061021,711,740,'[{1,3853},{2,464247612},{3,149316},{4,137828},{5,40015},{6,28292},{7,17671},{8,40000}]',3853,464247612,0),(4061021,741,770,'[{1,4205},{2,507120466},{3,163778},{4,151872},{5,40016},{6,30471},{7,19561},{8,40000}]',4205,507120466,0),(4061021,771,1000,'[{1,4565},{2,551138458},{3,178924},{4,166605},{5,40017},{6,32658},{7,21803},{8,40000}]',4565,551138458,0),(4061022,1,360,'[{1,633},{2,62794772},{3,28390},{4,20691},{5,40000},{6,1929},{7,1587},{8,40000}]',633,62794772,0),(4061022,361,380,'[{1,734},{2,77623907},{3,32368},{4,25260},{5,40001},{6,2662},{7,2140},{8,40000}]',734,77623907,0),(4061022,381,400,'[{1,835},{2,92521894},{3,36346},{4,29829},{5,40002},{6,3395},{7,2692},{8,40000}]',835,92521894,0),(4061022,401,420,'[{1,933},{2,104247359},{3,40024},{4,33220},{5,40003},{6,4094},{7,3045},{8,40000}]',933,104247359,0),(4061022,421,440,'[{1,1031},{2,115958294},{3,43702},{4,36611},{5,40004},{6,4793},{7,3397},{8,40000}]',1031,115958294,0),(4061022,441,460,'[{1,1151},{2,130682281},{3,48285},{4,40898},{5,40005},{6,5654},{7,3955},{8,40000}]',1151,130682281,0),(4061022,461,480,'[{1,1295},{2,148444097},{3,53772},{4,46082},{5,40006},{6,6677},{7,4719},{8,40000}]',1295,148444097,0),(4061022,481,500,'[{1,1439},{2,166214938},{3,59260},{4,51265},{5,40007},{6,7700},{7,5483},{8,40000}]',1439,166214938,0),(4061022,501,530,'[{1,1691},{2,197247331},{3,68616},{4,60156},{5,40008},{6,10818},{7,7388},{8,40000}]',1691,197247331,0),(4061022,531,560,'[{1,1948},{2,228979720},{3,78199},{4,69284},{5,40009},{6,13653},{7,9059},{8,40000}]',1948,228979720,0),(4061022,561,590,'[{1,2217},{2,262111703},{3,88237},{4,78884},{5,40010},{6,15922},{7,10260},{8,40000}]',2217,262111703,0),(4061022,591,620,'[{1,2506},{2,297581005},{3,99493},{4,89699},{5,40011},{6,18506},{7,12038},{8,40000}]',2506,297581005,0),(4061022,621,650,'[{1,2803},{2,334186283},{3,111357},{4,101121},{5,40012},{6,21249},{7,14106},{8,40000}]',2803,334186283,0),(4061022,651,680,'[{1,3169},{2,379867024},{3,123655},{4,113014},{5,40013},{6,23745},{7,15293},{8,40000}]',3169,379867024,0),(4061022,681,710,'[{1,3522},{2,423791608},{3,136220},{4,125164},{5,40014},{6,26130},{7,16481},{8,40000}]',3522,423791608,0),(4061022,711,740,'[{1,3853},{2,464247612},{3,149316},{4,137828},{5,40015},{6,28292},{7,17671},{8,40000}]',3853,464247612,0),(4061022,741,770,'[{1,4205},{2,507120466},{3,163778},{4,151872},{5,40016},{6,30471},{7,19561},{8,40000}]',4205,507120466,0),(4061022,771,1000,'[{1,4565},{2,551138458},{3,178924},{4,166605},{5,40017},{6,32658},{7,21803},{8,40000}]',4565,551138458,0),(4061023,1,360,'[{1,422},{2,113030590},{3,28390},{4,20691},{5,40000},{6,1929},{7,1587},{8,40000}]',422,113030590,0),(4061023,361,380,'[{1,489},{2,139723032},{3,32368},{4,25260},{5,40001},{6,2662},{7,2140},{8,40000}]',489,139723032,0),(4061023,381,400,'[{1,557},{2,166539410},{3,36346},{4,29829},{5,40002},{6,3395},{7,2692},{8,40000}]',557,166539410,0),(4061023,401,420,'[{1,622},{2,187645245},{3,40024},{4,33220},{5,40003},{6,4094},{7,3045},{8,40000}]',622,187645245,0),(4061023,421,440,'[{1,687},{2,208724928},{3,43702},{4,36611},{5,40004},{6,4793},{7,3397},{8,40000}]',687,208724928,0),(4061023,441,460,'[{1,768},{2,235228106},{3,48285},{4,40898},{5,40005},{6,5654},{7,3955},{8,40000}]',768,235228106,0),(4061023,461,480,'[{1,864},{2,267199375},{3,53772},{4,46082},{5,40006},{6,6677},{7,4719},{8,40000}]',864,267199375,0),(4061023,481,500,'[{1,959},{2,299186889},{3,59260},{4,51265},{5,40007},{6,7700},{7,5483},{8,40000}]',959,299186889,0),(4061023,501,530,'[{1,1127},{2,355045196},{3,68616},{4,60156},{5,40008},{6,10818},{7,7388},{8,40000}]',1127,355045196,0),(4061023,531,560,'[{1,1299},{2,412163495},{3,78199},{4,69284},{5,40009},{6,13653},{7,9059},{8,40000}]',1299,412163495,0),(4061023,561,590,'[{1,1478},{2,471801066},{3,88237},{4,78884},{5,40010},{6,15922},{7,10260},{8,40000}]',1478,471801066,0),(4061023,591,620,'[{1,1671},{2,535645809},{3,99493},{4,89699},{5,40011},{6,18506},{7,12038},{8,40000}]',1671,535645809,0),(4061023,621,650,'[{1,1869},{2,601535309},{3,111357},{4,101121},{5,40012},{6,21249},{7,14106},{8,40000}]',1869,601535309,0),(4061023,651,680,'[{1,2112},{2,683760643},{3,123655},{4,113014},{5,40013},{6,23745},{7,15293},{8,40000}]',2112,683760643,0),(4061023,681,710,'[{1,2348},{2,762824895},{3,136220},{4,125164},{5,40014},{6,26130},{7,16481},{8,40000}]',2348,762824895,0),(4061023,711,740,'[{1,2569},{2,835645702},{3,149316},{4,137828},{5,40015},{6,28292},{7,17671},{8,40000}]',2569,835645702,0),(4061023,741,770,'[{1,2803},{2,912816839},{3,163778},{4,151872},{5,40016},{6,30471},{7,19561},{8,40000}]',2803,912816839,0),(4061023,771,1000,'[{1,3044},{2,992049224},{3,178924},{4,166605},{5,40017},{6,32658},{7,21803},{8,40000}]',3044,992049224,0),(4061024,1,360,'[{1,18987},{2,272111},{3,28390},{4,20691},{5,40000},{6,1929},{7,1587},{8,40000}]',18987,272111,0),(4061024,361,380,'[{1,22017},{2,336370},{3,32368},{4,25260},{5,40000},{6,1929},{7,1587},{8,40000}]',22017,336370,0),(4061024,381,400,'[{1,25047},{2,400928},{3,36346},{4,29829},{5,40000},{6,1929},{7,1587},{8,40000}]',25047,400928,0),(4061024,401,420,'[{1,27989},{2,451739},{3,40024},{4,33220},{5,40000},{6,1929},{7,1587},{8,40000}]',27989,451739,0),(4061024,421,440,'[{1,30923},{2,502486},{3,43702},{4,36611},{5,40000},{6,1929},{7,1587},{8,40000}]',30923,502486,0),(4061024,441,460,'[{1,34545},{2,566290},{3,48285},{4,40898},{5,40000},{6,1929},{7,1587},{8,40000}]',34545,566290,0),(4061024,461,480,'[{1,38861},{2,643258},{3,53772},{4,46082},{5,40000},{6,1929},{7,1587},{8,40000}]',38861,643258,0),(4061024,481,500,'[{1,43174},{2,720265},{3,59260},{4,51265},{5,40000},{6,1929},{7,1587},{8,40000}]',43174,720265,0),(4061024,501,530,'[{1,50727},{2,854738},{3,68616},{4,60156},{5,40000},{6,1929},{7,1587},{8,40000}]',50727,854738,0),(4061024,531,560,'[{1,58451},{2,992245},{3,78199},{4,69284},{5,40000},{6,1929},{7,1587},{8,40000}]',58451,992245,0),(4061024,561,590,'[{1,66521},{2,1135817},{3,88237},{4,78884},{5,40000},{6,1929},{7,1587},{8,40000}]',66521,1135817,0),(4061024,591,620,'[{1,75173},{2,1289518},{3,99493},{4,89699},{5,40000},{6,1929},{7,1587},{8,40000}]',75173,1289518,0),(4061024,621,650,'[{1,84105},{2,1448141},{3,111357},{4,101121},{5,40000},{6,1929},{7,1587},{8,40000}]',84105,1448141,0),(4061024,651,680,'[{1,95057},{2,1646090},{3,123655},{4,113014},{5,40000},{6,1929},{7,1587},{8,40000}]',95057,1646090,0),(4061024,681,710,'[{1,105661},{2,1836430},{3,136220},{4,125164},{5,40000},{6,1929},{7,1587},{8,40000}]',105661,1836430,0),(4061024,711,740,'[{1,115595},{2,2011740},{3,149316},{4,137828},{5,40000},{6,1929},{7,1587},{8,40000}]',115595,2011740,0),(4061024,741,770,'[{1,126138},{2,2197522},{3,163778},{4,151872},{5,40000},{6,1929},{7,1587},{8,40000}]',126138,2197522,0),(4061024,771,1000,'[{1,136960},{2,2388267},{3,178924},{4,166605},{5,40000},{6,1929},{7,1587},{8,40000}]',136960,2388267,0),(4061025,1,360,'[{1,15190},{2,7849347},{3,28390},{4,20691},{5,40000},{6,1929},{7,1587},{8,40000}]',15190,7849347,0),(4061025,361,380,'[{1,17614},{2,9702988},{3,32368},{4,25260},{5,40000},{6,1929},{7,1587},{8,40000}]',17614,9702988,0),(4061025,381,400,'[{1,20037},{2,11565237},{3,36346},{4,29829},{5,40001},{6,1929},{7,1587},{8,40000}]',20037,11565237,0),(4061025,401,420,'[{1,22391},{2,13030920},{3,40024},{4,33220},{5,40002},{6,1929},{7,1587},{8,40000}]',22391,13030920,0),(4061025,421,440,'[{1,24739},{2,14494787},{3,43702},{4,36611},{5,40003},{6,1929},{7,1587},{8,40000}]',24739,14494787,0),(4061025,441,460,'[{1,27636},{2,16335285},{3,48285},{4,40898},{5,40004},{6,1929},{7,1587},{8,40000}]',27636,16335285,0),(4061025,461,480,'[{1,31089},{2,18555512},{3,53772},{4,46082},{5,40005},{6,1929},{7,1587},{8,40000}]',31089,18555512,0),(4061025,481,500,'[{1,34539},{2,20776867},{3,59260},{4,51265},{5,40006},{6,1929},{7,1587},{8,40000}]',34539,20776867,0),(4061025,501,530,'[{1,40581},{2,24655916},{3,68616},{4,60156},{5,40007},{6,1929},{7,1587},{8,40000}]',40581,24655916,0),(4061025,531,560,'[{1,46761},{2,28622465},{3,78199},{4,69284},{5,40008},{6,1929},{7,1587},{8,40000}]',46761,28622465,0),(4061025,561,590,'[{1,53217},{2,32763963},{3,88237},{4,78884},{5,40009},{6,1929},{7,1587},{8,40000}]',53217,32763963,0),(4061025,591,620,'[{1,60139},{2,37197626},{3,99493},{4,89699},{5,40010},{6,1929},{7,1587},{8,40000}]',60139,37197626,0),(4061025,621,650,'[{1,67284},{2,41773285},{3,111357},{4,101121},{5,40011},{6,1929},{7,1587},{8,40000}]',67284,41773285,0),(4061025,651,680,'[{1,76046},{2,47483378},{3,123655},{4,113014},{5,40012},{6,1929},{7,1587},{8,40000}]',76046,47483378,0),(4061025,681,710,'[{1,84528},{2,52973951},{3,136220},{4,125164},{5,40013},{6,1929},{7,1587},{8,40000}]',84528,52973951,0),(4061025,711,740,'[{1,92476},{2,58030951},{3,149316},{4,137828},{5,40014},{6,1929},{7,1587},{8,40000}]',92476,58030951,0),(4061025,741,770,'[{1,100910},{2,63390058},{3,163778},{4,151872},{5,40015},{6,1929},{7,1587},{8,40000}]',100910,63390058,0),(4061025,771,1000,'[{1,109568},{2,68892307},{3,178924},{4,166605},{5,40016},{6,1929},{7,1587},{8,40000}]',109568,68892307,0),(4201090,1,200,'[{1,30},{2,21143968}]',30,21143968,0),(4201090,201,260,'[{1,91},{2,64880864}]',91,64880864,0),(4201090,261,320,'[{1,187},{2,128460534}]',187,128460534,0),(4201090,321,350,'[{1,240},{2,173814130}]',240,173814130,0),(4201090,351,370,'[{1,283},{2,220829055}]',283,220829055,0),(4201090,371,390,'[{1,326},{2,267913611}]',326,267913611,0),(4201090,391,430,'[{1,410},{2,346880492}]',410,346880492,0),(4201090,431,470,'[{1,513},{2,439601496}]',513,439601496,0),(4201090,471,500,'[{1,605},{2,523297085}]',605,523297085,0),(4201090,501,530,'[{1,713},{2,620488267}]',713,620488267,0),(4201090,531,560,'[{1,823},{2,719733107}]',823,719733107,0),(4201090,561,590,'[{1,938},{2,823216243}]',938,823216243,0),(4201090,591,610,'[{1,1019},{2,895699564}]',1019,895699564,0),(4201090,611,630,'[{1,1105},{2,971688987}]',1105,971688987,0),(4201090,631,660,'[{1,1242},{2,1094980772}]',1242,1094980772,0),(4201090,661,690,'[{1,1397},{2,1237091159}]',1397,1237091159,0),(4201090,691,720,'[{1,1544},{2,1368297894}]',1544,1368297894,0),(4201090,721,750,'[{1,1685},{2,1493893843}]',1685,1493893843,0),(4201090,751,780,'[{1,1840},{2,1630390275}]',1840,1630390275,0),(4201090,781,800,'[{1,1943},{2,1721222859}]',1943,1721222859,0),(4201111,1,200,'[{1,297},{2,587332}]',297,587332,0),(4201111,201,260,'[{1,912},{2,1802246}]',912,1802246,0),(4201111,261,320,'[{1,1871},{2,3746766}]',1871,3746766,0),(4201111,321,350,'[{1,2400},{2,5310987}]',2400,5310987,0),(4201111,351,370,'[{1,2831},{2,7054261}]',2831,7054261,0),(4201111,371,390,'[{1,3262},{2,8930454}]',3262,8930454,0),(4201111,391,430,'[{1,4097},{2,12044462}]',4097,12044462,0),(4201111,431,470,'[{1,5126},{2,15263941}]',5126,15263941,0),(4201111,471,500,'[{1,6049},{2,18170038}]',6049,18170038,0),(4201111,501,530,'[{1,7129},{2,21544731}]',7129,21544731,0),(4201111,531,560,'[{1,8231},{2,24990733}]',8231,24990733,0),(4201111,561,590,'[{1,9382},{2,28583897}]',9382,28583897,0),(4201111,591,610,'[{1,10192},{2,31100679}]',10192,31100679,0),(4201111,611,630,'[{1,11045},{2,33739201}]',11045,33739201,0),(4201111,631,660,'[{1,12416},{2,38020166}]',12416,38020166,0),(4201111,661,690,'[{1,13975},{2,42954554}]',13975,42954554,0),(4201111,691,720,'[{1,15439},{2,47510344}]',15439,47510344,0),(4201111,721,750,'[{1,16851},{2,51871314}]',16851,51871314,0),(4201111,751,780,'[{1,18401},{2,56610773}]',18401,56610773,0),(4201111,781,800,'[{1,19429},{2,59764683}]',19429,59764683,0),(4201112,1,200,'[{1,297},{2,587332}]',297,587332,0),(4201112,201,260,'[{1,912},{2,1802246}]',912,1802246,0),(4201112,261,320,'[{1,1871},{2,3746766}]',1871,3746766,0),(4201112,321,350,'[{1,2400},{2,5310987}]',2400,5310987,0),(4201112,351,370,'[{1,2831},{2,7054261}]',2831,7054261,0),(4201112,371,390,'[{1,3262},{2,8930454}]',3262,8930454,0),(4201112,391,430,'[{1,4097},{2,12044462}]',4097,12044462,0),(4201112,431,470,'[{1,5126},{2,15263941}]',5126,15263941,0),(4201112,471,500,'[{1,6049},{2,18170038}]',6049,18170038,0),(4201112,501,530,'[{1,7129},{2,21544731}]',7129,21544731,0),(4201112,531,560,'[{1,8231},{2,24990733}]',8231,24990733,0),(4201112,561,590,'[{1,9382},{2,28583897}]',9382,28583897,0),(4201112,591,610,'[{1,10192},{2,31100679}]',10192,31100679,0),(4201112,611,630,'[{1,11045},{2,33739201}]',11045,33739201,0),(4201112,631,660,'[{1,12416},{2,38020166}]',12416,38020166,0),(4201112,661,690,'[{1,13975},{2,42954554}]',13975,42954554,0),(4201112,691,720,'[{1,15439},{2,47510344}]',15439,47510344,0),(4201112,721,750,'[{1,16851},{2,51871314}]',16851,51871314,0),(4201112,751,780,'[{1,18401},{2,56610773}]',18401,56610773,0),(4201112,781,800,'[{1,19429},{2,59764683}]',19429,59764683,0),(4201121,1,200,'[{1,297},{2,587332}]',297,587332,0),(4201121,201,260,'[{1,912},{2,1802246}]',912,1802246,0),(4201121,261,320,'[{1,1871},{2,3746766}]',1871,3746766,0),(4201121,321,350,'[{1,2400},{2,5310987}]',2400,5310987,0),(4201121,351,370,'[{1,2831},{2,7054261}]',2831,7054261,0),(4201121,371,390,'[{1,3262},{2,8930454}]',3262,8930454,0),(4201121,391,430,'[{1,4097},{2,12044462}]',4097,12044462,0),(4201121,431,470,'[{1,5126},{2,15263941}]',5126,15263941,0),(4201121,471,500,'[{1,6049},{2,18170038}]',6049,18170038,0),(4201121,501,530,'[{1,7129},{2,21544731}]',7129,21544731,0),(4201121,531,560,'[{1,8231},{2,24990733}]',8231,24990733,0),(4201121,561,590,'[{1,9382},{2,28583897}]',9382,28583897,0),(4201121,591,610,'[{1,10192},{2,31100679}]',10192,31100679,0),(4201121,611,630,'[{1,11045},{2,33739201}]',11045,33739201,0),(4201121,631,660,'[{1,12416},{2,38020166}]',12416,38020166,0),(4201121,661,690,'[{1,13975},{2,42954554}]',13975,42954554,0),(4201121,691,720,'[{1,15439},{2,47510344}]',15439,47510344,0),(4201121,721,750,'[{1,16851},{2,51871314}]',16851,51871314,0),(4201121,751,780,'[{1,18401},{2,56610773}]',18401,56610773,0),(4201121,781,800,'[{1,19429},{2,59764683}]',19429,59764683,0),(4201122,1,200,'[{1,297},{2,587332}]',297,587332,0),(4201122,201,260,'[{1,912},{2,1802246}]',912,1802246,0),(4201122,261,320,'[{1,1871},{2,3746766}]',1871,3746766,0),(4201122,321,350,'[{1,2400},{2,5310987}]',2400,5310987,0),(4201122,351,370,'[{1,2831},{2,7054261}]',2831,7054261,0),(4201122,371,390,'[{1,3262},{2,8930454}]',3262,8930454,0),(4201122,391,430,'[{1,4097},{2,12044462}]',4097,12044462,0),(4201122,431,470,'[{1,5126},{2,15263941}]',5126,15263941,0),(4201122,471,500,'[{1,6049},{2,18170038}]',6049,18170038,0),(4201122,501,530,'[{1,7129},{2,21544731}]',7129,21544731,0),(4201122,531,560,'[{1,8231},{2,24990733}]',8231,24990733,0),(4201122,561,590,'[{1,9382},{2,28583897}]',9382,28583897,0),(4201122,591,610,'[{1,10192},{2,31100679}]',10192,31100679,0),(4201122,611,630,'[{1,11045},{2,33739201}]',11045,33739201,0),(4201122,631,660,'[{1,12416},{2,38020166}]',12416,38020166,0),(4201122,661,690,'[{1,13975},{2,42954554}]',13975,42954554,0),(4201122,691,720,'[{1,15439},{2,47510344}]',15439,47510344,0),(4201122,721,750,'[{1,16851},{2,51871314}]',16851,51871314,0),(4201122,751,780,'[{1,18401},{2,56610773}]',18401,56610773,0),(4201122,781,800,'[{1,19429},{2,59764683}]',19429,59764683,0),(4201131,1,200,'[{1,297},{2,587332}]',297,587332,0),(4201131,201,260,'[{1,912},{2,1802246}]',912,1802246,0),(4201131,261,320,'[{1,1871},{2,3746766}]',1871,3746766,0),(4201131,321,350,'[{1,2400},{2,5310987}]',2400,5310987,0),(4201131,351,370,'[{1,2831},{2,7054261}]',2831,7054261,0),(4201131,371,390,'[{1,3262},{2,8930454}]',3262,8930454,0),(4201131,391,430,'[{1,4097},{2,12044462}]',4097,12044462,0),(4201131,431,470,'[{1,5126},{2,15263941}]',5126,15263941,0),(4201131,471,500,'[{1,6049},{2,18170038}]',6049,18170038,0),(4201131,501,530,'[{1,7129},{2,21544731}]',7129,21544731,0),(4201131,531,560,'[{1,8231},{2,24990733}]',8231,24990733,0),(4201131,561,590,'[{1,9382},{2,28583897}]',9382,28583897,0),(4201131,591,610,'[{1,10192},{2,31100679}]',10192,31100679,0),(4201131,611,630,'[{1,11045},{2,33739201}]',11045,33739201,0),(4201131,631,660,'[{1,12416},{2,38020166}]',12416,38020166,0),(4201131,661,690,'[{1,13975},{2,42954554}]',13975,42954554,0),(4201131,691,720,'[{1,15439},{2,47510344}]',15439,47510344,0),(4201131,721,750,'[{1,16851},{2,51871314}]',16851,51871314,0),(4201131,751,780,'[{1,18401},{2,56610773}]',18401,56610773,0),(4201131,781,800,'[{1,19429},{2,59764683}]',19429,59764683,0),(4201132,1,200,'[{1,297},{2,587332}]',297,587332,0),(4201132,201,260,'[{1,912},{2,1802246}]',912,1802246,0),(4201132,261,320,'[{1,1871},{2,3746766}]',1871,3746766,0),(4201132,321,350,'[{1,2400},{2,5310987}]',2400,5310987,0),(4201132,351,370,'[{1,2831},{2,7054261}]',2831,7054261,0),(4201132,371,390,'[{1,3262},{2,8930454}]',3262,8930454,0),(4201132,391,430,'[{1,4097},{2,12044462}]',4097,12044462,0),(4201132,431,470,'[{1,5126},{2,15263941}]',5126,15263941,0),(4201132,471,500,'[{1,6049},{2,18170038}]',6049,18170038,0),(4201132,501,530,'[{1,7129},{2,21544731}]',7129,21544731,0),(4201132,531,560,'[{1,8231},{2,24990733}]',8231,24990733,0),(4201132,561,590,'[{1,9382},{2,28583897}]',9382,28583897,0),(4201132,591,610,'[{1,10192},{2,31100679}]',10192,31100679,0),(4201132,611,630,'[{1,11045},{2,33739201}]',11045,33739201,0),(4201132,631,660,'[{1,12416},{2,38020166}]',12416,38020166,0),(4201132,661,690,'[{1,13975},{2,42954554}]',13975,42954554,0),(4201132,691,720,'[{1,15439},{2,47510344}]',15439,47510344,0),(4201132,721,750,'[{1,16851},{2,51871314}]',16851,51871314,0),(4201132,751,780,'[{1,18401},{2,56610773}]',18401,56610773,0),(4201132,781,800,'[{1,19429},{2,59764683}]',19429,59764683,0),(4201141,1,200,'[{1,297},{2,587332}]',297,587332,0),(4201141,201,260,'[{1,912},{2,1802246}]',912,1802246,0),(4201141,261,320,'[{1,1871},{2,3746766}]',1871,3746766,0),(4201141,321,350,'[{1,2400},{2,5310987}]',2400,5310987,0),(4201141,351,370,'[{1,2831},{2,7054261}]',2831,7054261,0),(4201141,371,390,'[{1,3262},{2,8930454}]',3262,8930454,0),(4201141,391,430,'[{1,4097},{2,12044462}]',4097,12044462,0),(4201141,431,470,'[{1,5126},{2,15263941}]',5126,15263941,0),(4201141,471,500,'[{1,6049},{2,18170038}]',6049,18170038,0),(4201141,501,530,'[{1,7129},{2,21544731}]',7129,21544731,0),(4201141,531,560,'[{1,8231},{2,24990733}]',8231,24990733,0),(4201141,561,590,'[{1,9382},{2,28583897}]',9382,28583897,0),(4201141,591,610,'[{1,10192},{2,31100679}]',10192,31100679,0),(4201141,611,630,'[{1,11045},{2,33739201}]',11045,33739201,0),(4201141,631,660,'[{1,12416},{2,38020166}]',12416,38020166,0),(4201141,661,690,'[{1,13975},{2,42954554}]',13975,42954554,0),(4201141,691,720,'[{1,15439},{2,47510344}]',15439,47510344,0),(4201141,721,750,'[{1,16851},{2,51871314}]',16851,51871314,0),(4201141,751,780,'[{1,18401},{2,56610773}]',18401,56610773,0),(4201141,781,800,'[{1,19429},{2,59764683}]',19429,59764683,0),(4201142,1,200,'[{1,297},{2,587332}]',297,587332,0),(4201142,201,260,'[{1,912},{2,1802246}]',912,1802246,0),(4201142,261,320,'[{1,1871},{2,3746766}]',1871,3746766,0),(4201142,321,350,'[{1,2400},{2,5310987}]',2400,5310987,0),(4201142,351,370,'[{1,2831},{2,7054261}]',2831,7054261,0),(4201142,371,390,'[{1,3262},{2,8930454}]',3262,8930454,0),(4201142,391,430,'[{1,4097},{2,12044462}]',4097,12044462,0),(4201142,431,470,'[{1,5126},{2,15263941}]',5126,15263941,0),(4201142,471,500,'[{1,6049},{2,18170038}]',6049,18170038,0),(4201142,501,530,'[{1,7129},{2,21544731}]',7129,21544731,0),(4201142,531,560,'[{1,8231},{2,24990733}]',8231,24990733,0),(4201142,561,590,'[{1,9382},{2,28583897}]',9382,28583897,0),(4201142,591,610,'[{1,10192},{2,31100679}]',10192,31100679,0),(4201142,611,630,'[{1,11045},{2,33739201}]',11045,33739201,0),(4201142,631,660,'[{1,12416},{2,38020166}]',12416,38020166,0),(4201142,661,690,'[{1,13975},{2,42954554}]',13975,42954554,0),(4201142,691,720,'[{1,15439},{2,47510344}]',15439,47510344,0),(4201142,721,750,'[{1,16851},{2,51871314}]',16851,51871314,0),(4201142,751,780,'[{1,18401},{2,56610773}]',18401,56610773,0),(4201142,781,800,'[{1,19429},{2,59764683}]',19429,59764683,0),(4201151,1,200,'[{1,297},{2,587332}]',297,587332,0),(4201151,201,260,'[{1,912},{2,1802246}]',912,1802246,0),(4201151,261,320,'[{1,1871},{2,3746766}]',1871,3746766,0),(4201151,321,350,'[{1,2400},{2,5310987}]',2400,5310987,0),(4201151,351,370,'[{1,2831},{2,7054261}]',2831,7054261,0),(4201151,371,390,'[{1,3262},{2,8930454}]',3262,8930454,0),(4201151,391,430,'[{1,4097},{2,12044462}]',4097,12044462,0),(4201151,431,470,'[{1,5126},{2,15263941}]',5126,15263941,0),(4201151,471,500,'[{1,6049},{2,18170038}]',6049,18170038,0),(4201151,501,530,'[{1,7129},{2,21544731}]',7129,21544731,0),(4201151,531,560,'[{1,8231},{2,24990733}]',8231,24990733,0),(4201151,561,590,'[{1,9382},{2,28583897}]',9382,28583897,0),(4201151,591,610,'[{1,10192},{2,31100679}]',10192,31100679,0),(4201151,611,630,'[{1,11045},{2,33739201}]',11045,33739201,0),(4201151,631,660,'[{1,12416},{2,38020166}]',12416,38020166,0),(4201151,661,690,'[{1,13975},{2,42954554}]',13975,42954554,0),(4201151,691,720,'[{1,15439},{2,47510344}]',15439,47510344,0),(4201151,721,750,'[{1,16851},{2,51871314}]',16851,51871314,0),(4201151,751,780,'[{1,18401},{2,56610773}]',18401,56610773,0),(4201151,781,800,'[{1,19429},{2,59764683}]',19429,59764683,0),(4201152,1,200,'[{1,297},{2,587332}]',297,587332,0),(4201152,201,260,'[{1,912},{2,1802246}]',912,1802246,0),(4201152,261,320,'[{1,1871},{2,3746766}]',1871,3746766,0),(4201152,321,350,'[{1,2400},{2,5310987}]',2400,5310987,0),(4201152,351,370,'[{1,2831},{2,7054261}]',2831,7054261,0),(4201152,371,390,'[{1,3262},{2,8930454}]',3262,8930454,0),(4201152,391,430,'[{1,4097},{2,12044462}]',4097,12044462,0),(4201152,431,470,'[{1,5126},{2,15263941}]',5126,15263941,0),(4201152,471,500,'[{1,6049},{2,18170038}]',6049,18170038,0),(4201152,501,530,'[{1,7129},{2,21544731}]',7129,21544731,0),(4201152,531,560,'[{1,8231},{2,24990733}]',8231,24990733,0),(4201152,561,590,'[{1,9382},{2,28583897}]',9382,28583897,0),(4201152,591,610,'[{1,10192},{2,31100679}]',10192,31100679,0),(4201152,611,630,'[{1,11045},{2,33739201}]',11045,33739201,0),(4201152,631,660,'[{1,12416},{2,38020166}]',12416,38020166,0),(4201152,661,690,'[{1,13975},{2,42954554}]',13975,42954554,0),(4201152,691,720,'[{1,15439},{2,47510344}]',15439,47510344,0),(4201152,721,750,'[{1,16851},{2,51871314}]',16851,51871314,0),(4201152,751,780,'[{1,18401},{2,56610773}]',18401,56610773,0),(4201152,781,800,'[{1,19429},{2,59764683}]',19429,59764683,0),(4201161,1,200,'[{1,297},{2,587332}]',297,587332,0),(4201161,201,260,'[{1,912},{2,1802246}]',912,1802246,0),(4201161,261,320,'[{1,1871},{2,3746766}]',1871,3746766,0),(4201161,321,350,'[{1,2400},{2,5310987}]',2400,5310987,0),(4201161,351,370,'[{1,2831},{2,7054261}]',2831,7054261,0),(4201161,371,390,'[{1,3262},{2,8930454}]',3262,8930454,0),(4201161,391,430,'[{1,4097},{2,12044462}]',4097,12044462,0),(4201161,431,470,'[{1,5126},{2,15263941}]',5126,15263941,0),(4201161,471,500,'[{1,6049},{2,18170038}]',6049,18170038,0),(4201161,501,530,'[{1,7129},{2,21544731}]',7129,21544731,0),(4201161,531,560,'[{1,8231},{2,24990733}]',8231,24990733,0),(4201161,561,590,'[{1,9382},{2,28583897}]',9382,28583897,0),(4201161,591,610,'[{1,10192},{2,31100679}]',10192,31100679,0),(4201161,611,630,'[{1,11045},{2,33739201}]',11045,33739201,0),(4201161,631,660,'[{1,12416},{2,38020166}]',12416,38020166,0),(4201161,661,690,'[{1,13975},{2,42954554}]',13975,42954554,0),(4201161,691,720,'[{1,15439},{2,47510344}]',15439,47510344,0),(4201161,721,750,'[{1,16851},{2,51871314}]',16851,51871314,0),(4201161,751,780,'[{1,18401},{2,56610773}]',18401,56610773,0),(4201161,781,800,'[{1,19429},{2,59764683}]',19429,59764683,0),(4201162,1,200,'[{1,297},{2,587332}]',297,587332,0),(4201162,201,260,'[{1,912},{2,1802246}]',912,1802246,0),(4201162,261,320,'[{1,1871},{2,3746766}]',1871,3746766,0),(4201162,321,350,'[{1,2400},{2,5310987}]',2400,5310987,0),(4201162,351,370,'[{1,2831},{2,7054261}]',2831,7054261,0),(4201162,371,390,'[{1,3262},{2,8930454}]',3262,8930454,0),(4201162,391,430,'[{1,4097},{2,12044462}]',4097,12044462,0),(4201162,431,470,'[{1,5126},{2,15263941}]',5126,15263941,0),(4201162,471,500,'[{1,6049},{2,18170038}]',6049,18170038,0),(4201162,501,530,'[{1,7129},{2,21544731}]',7129,21544731,0),(4201162,531,560,'[{1,8231},{2,24990733}]',8231,24990733,0),(4201162,561,590,'[{1,9382},{2,28583897}]',9382,28583897,0),(4201162,591,610,'[{1,10192},{2,31100679}]',10192,31100679,0),(4201162,611,630,'[{1,11045},{2,33739201}]',11045,33739201,0),(4201162,631,660,'[{1,12416},{2,38020166}]',12416,38020166,0),(4201162,661,690,'[{1,13975},{2,42954554}]',13975,42954554,0),(4201162,691,720,'[{1,15439},{2,47510344}]',15439,47510344,0),(4201162,721,750,'[{1,16851},{2,51871314}]',16851,51871314,0),(4201162,751,780,'[{1,18401},{2,56610773}]',18401,56610773,0),(4201162,781,800,'[{1,19429},{2,59764683}]',19429,59764683,0),(4201171,1,200,'[{1,297},{2,587332}]',297,587332,0),(4201171,201,260,'[{1,912},{2,1802246}]',912,1802246,0),(4201171,261,320,'[{1,1871},{2,3746766}]',1871,3746766,0),(4201171,321,350,'[{1,2400},{2,5310987}]',2400,5310987,0),(4201171,351,370,'[{1,2831},{2,7054261}]',2831,7054261,0),(4201171,371,390,'[{1,3262},{2,8930454}]',3262,8930454,0),(4201171,391,430,'[{1,4097},{2,12044462}]',4097,12044462,0),(4201171,431,470,'[{1,5126},{2,15263941}]',5126,15263941,0),(4201171,471,500,'[{1,6049},{2,18170038}]',6049,18170038,0),(4201171,501,530,'[{1,7129},{2,21544731}]',7129,21544731,0),(4201171,531,560,'[{1,8231},{2,24990733}]',8231,24990733,0),(4201171,561,590,'[{1,9382},{2,28583897}]',9382,28583897,0),(4201171,591,610,'[{1,10192},{2,31100679}]',10192,31100679,0),(4201171,611,630,'[{1,11045},{2,33739201}]',11045,33739201,0),(4201171,631,660,'[{1,12416},{2,38020166}]',12416,38020166,0),(4201171,661,690,'[{1,13975},{2,42954554}]',13975,42954554,0),(4201171,691,720,'[{1,15439},{2,47510344}]',15439,47510344,0),(4201171,721,750,'[{1,16851},{2,51871314}]',16851,51871314,0),(4201171,751,780,'[{1,18401},{2,56610773}]',18401,56610773,0),(4201171,781,800,'[{1,19429},{2,59764683}]',19429,59764683,0),(4201172,1,200,'[{1,297},{2,587332}]',297,587332,0),(4201172,201,260,'[{1,912},{2,1802246}]',912,1802246,0),(4201172,261,320,'[{1,1871},{2,3746766}]',1871,3746766,0),(4201172,321,350,'[{1,2400},{2,5310987}]',2400,5310987,0),(4201172,351,370,'[{1,2831},{2,7054261}]',2831,7054261,0),(4201172,371,390,'[{1,3262},{2,8930454}]',3262,8930454,0),(4201172,391,430,'[{1,4097},{2,12044462}]',4097,12044462,0),(4201172,431,470,'[{1,5126},{2,15263941}]',5126,15263941,0),(4201172,471,500,'[{1,6049},{2,18170038}]',6049,18170038,0),(4201172,501,530,'[{1,7129},{2,21544731}]',7129,21544731,0),(4201172,531,560,'[{1,8231},{2,24990733}]',8231,24990733,0),(4201172,561,590,'[{1,9382},{2,28583897}]',9382,28583897,0),(4201172,591,610,'[{1,10192},{2,31100679}]',10192,31100679,0),(4201172,611,630,'[{1,11045},{2,33739201}]',11045,33739201,0),(4201172,631,660,'[{1,12416},{2,38020166}]',12416,38020166,0),(4201172,661,690,'[{1,13975},{2,42954554}]',13975,42954554,0),(4201172,691,720,'[{1,15439},{2,47510344}]',15439,47510344,0),(4201172,721,750,'[{1,16851},{2,51871314}]',16851,51871314,0),(4201172,751,780,'[{1,18401},{2,56610773}]',18401,56610773,0),(4201172,781,800,'[{1,19429},{2,59764683}]',19429,59764683,0),(4201181,1,200,'[{1,297},{2,587332}]',297,587332,0),(4201181,201,260,'[{1,912},{2,1802246}]',912,1802246,0),(4201181,261,320,'[{1,1871},{2,3746766}]',1871,3746766,0),(4201181,321,350,'[{1,2400},{2,5310987}]',2400,5310987,0),(4201181,351,370,'[{1,2831},{2,7054261}]',2831,7054261,0),(4201181,371,390,'[{1,3262},{2,8930454}]',3262,8930454,0),(4201181,391,430,'[{1,4097},{2,12044462}]',4097,12044462,0),(4201181,431,470,'[{1,5126},{2,15263941}]',5126,15263941,0),(4201181,471,500,'[{1,6049},{2,18170038}]',6049,18170038,0),(4201181,501,530,'[{1,7129},{2,21544731}]',7129,21544731,0),(4201181,531,560,'[{1,8231},{2,24990733}]',8231,24990733,0),(4201181,561,590,'[{1,9382},{2,28583897}]',9382,28583897,0),(4201181,591,610,'[{1,10192},{2,31100679}]',10192,31100679,0),(4201181,611,630,'[{1,11045},{2,33739201}]',11045,33739201,0),(4201181,631,660,'[{1,12416},{2,38020166}]',12416,38020166,0),(4201181,661,690,'[{1,13975},{2,42954554}]',13975,42954554,0),(4201181,691,720,'[{1,15439},{2,47510344}]',15439,47510344,0),(4201181,721,750,'[{1,16851},{2,51871314}]',16851,51871314,0),(4201181,751,780,'[{1,18401},{2,56610773}]',18401,56610773,0),(4201181,781,800,'[{1,19429},{2,59764683}]',19429,59764683,0),(4201182,1,200,'[{1,297},{2,587332}]',297,587332,0),(4201182,201,260,'[{1,912},{2,1802246}]',912,1802246,0),(4201182,261,320,'[{1,1871},{2,3746766}]',1871,3746766,0),(4201182,321,350,'[{1,2400},{2,5310987}]',2400,5310987,0),(4201182,351,370,'[{1,2831},{2,7054261}]',2831,7054261,0),(4201182,371,390,'[{1,3262},{2,8930454}]',3262,8930454,0),(4201182,391,430,'[{1,4097},{2,12044462}]',4097,12044462,0),(4201182,431,470,'[{1,5126},{2,15263941}]',5126,15263941,0),(4201182,471,500,'[{1,6049},{2,18170038}]',6049,18170038,0),(4201182,501,530,'[{1,7129},{2,21544731}]',7129,21544731,0),(4201182,531,560,'[{1,8231},{2,24990733}]',8231,24990733,0),(4201182,561,590,'[{1,9382},{2,28583897}]',9382,28583897,0),(4201182,591,610,'[{1,10192},{2,31100679}]',10192,31100679,0),(4201182,611,630,'[{1,11045},{2,33739201}]',11045,33739201,0),(4201182,631,660,'[{1,12416},{2,38020166}]',12416,38020166,0),(4201182,661,690,'[{1,13975},{2,42954554}]',13975,42954554,0),(4201182,691,720,'[{1,15439},{2,47510344}]',15439,47510344,0),(4201182,721,750,'[{1,16851},{2,51871314}]',16851,51871314,0),(4201182,751,780,'[{1,18401},{2,56610773}]',18401,56610773,0),(4201182,781,800,'[{1,19429},{2,59764683}]',19429,59764683,0),(4201211,1,200,'[{1,297},{2,587332}]',297,587332,0),(4201211,201,260,'[{1,912},{2,1802246}]',912,1802246,0),(4201211,261,320,'[{1,1871},{2,3746766}]',1871,3746766,0),(4201211,321,350,'[{1,2400},{2,5310987}]',2400,5310987,0),(4201211,351,370,'[{1,2831},{2,7054261}]',2831,7054261,0),(4201211,371,390,'[{1,3262},{2,8930454}]',3262,8930454,0),(4201211,391,430,'[{1,4097},{2,12044462}]',4097,12044462,0),(4201211,431,470,'[{1,5126},{2,15263941}]',5126,15263941,0),(4201211,471,500,'[{1,6049},{2,18170038}]',6049,18170038,0),(4201211,501,530,'[{1,7129},{2,21544731}]',7129,21544731,0),(4201211,531,560,'[{1,8231},{2,24990733}]',8231,24990733,0),(4201211,561,590,'[{1,9382},{2,28583897}]',9382,28583897,0),(4201211,591,610,'[{1,10192},{2,31100679}]',10192,31100679,0),(4201211,611,630,'[{1,11045},{2,33739201}]',11045,33739201,0),(4201211,631,660,'[{1,12416},{2,38020166}]',12416,38020166,0),(4201211,661,690,'[{1,13975},{2,42954554}]',13975,42954554,0),(4201211,691,720,'[{1,15439},{2,47510344}]',15439,47510344,0),(4201211,721,750,'[{1,16851},{2,51871314}]',16851,51871314,0),(4201211,751,780,'[{1,18401},{2,56610773}]',18401,56610773,0),(4201211,781,800,'[{1,19429},{2,59764683}]',19429,59764683,0),(4201212,1,200,'[{1,297},{2,587332}]',297,587332,0),(4201212,201,260,'[{1,912},{2,1802246}]',912,1802246,0),(4201212,261,320,'[{1,1871},{2,3746766}]',1871,3746766,0),(4201212,321,350,'[{1,2400},{2,5310987}]',2400,5310987,0),(4201212,351,370,'[{1,2831},{2,7054261}]',2831,7054261,0),(4201212,371,390,'[{1,3262},{2,8930454}]',3262,8930454,0),(4201212,391,430,'[{1,4097},{2,12044462}]',4097,12044462,0),(4201212,431,470,'[{1,5126},{2,15263941}]',5126,15263941,0),(4201212,471,500,'[{1,6049},{2,18170038}]',6049,18170038,0),(4201212,501,530,'[{1,7129},{2,21544731}]',7129,21544731,0),(4201212,531,560,'[{1,8231},{2,24990733}]',8231,24990733,0),(4201212,561,590,'[{1,9382},{2,28583897}]',9382,28583897,0),(4201212,591,610,'[{1,10192},{2,31100679}]',10192,31100679,0),(4201212,611,630,'[{1,11045},{2,33739201}]',11045,33739201,0),(4201212,631,660,'[{1,12416},{2,38020166}]',12416,38020166,0),(4201212,661,690,'[{1,13975},{2,42954554}]',13975,42954554,0),(4201212,691,720,'[{1,15439},{2,47510344}]',15439,47510344,0),(4201212,721,750,'[{1,16851},{2,51871314}]',16851,51871314,0),(4201212,751,780,'[{1,18401},{2,56610773}]',18401,56610773,0),(4201212,781,800,'[{1,19429},{2,59764683}]',19429,59764683,0),(4201221,1,200,'[{1,297},{2,587332}]',297,587332,0),(4201221,201,260,'[{1,912},{2,1802246}]',912,1802246,0),(4201221,261,320,'[{1,1871},{2,3746766}]',1871,3746766,0),(4201221,321,350,'[{1,2400},{2,5310987}]',2400,5310987,0),(4201221,351,370,'[{1,2831},{2,7054261}]',2831,7054261,0),(4201221,371,390,'[{1,3262},{2,8930454}]',3262,8930454,0),(4201221,391,430,'[{1,4097},{2,12044462}]',4097,12044462,0),(4201221,431,470,'[{1,5126},{2,15263941}]',5126,15263941,0),(4201221,471,500,'[{1,6049},{2,18170038}]',6049,18170038,0),(4201221,501,530,'[{1,7129},{2,21544731}]',7129,21544731,0),(4201221,531,560,'[{1,8231},{2,24990733}]',8231,24990733,0),(4201221,561,590,'[{1,9382},{2,28583897}]',9382,28583897,0),(4201221,591,610,'[{1,10192},{2,31100679}]',10192,31100679,0),(4201221,611,630,'[{1,11045},{2,33739201}]',11045,33739201,0),(4201221,631,660,'[{1,12416},{2,38020166}]',12416,38020166,0),(4201221,661,690,'[{1,13975},{2,42954554}]',13975,42954554,0),(4201221,691,720,'[{1,15439},{2,47510344}]',15439,47510344,0),(4201221,721,750,'[{1,16851},{2,51871314}]',16851,51871314,0),(4201221,751,780,'[{1,18401},{2,56610773}]',18401,56610773,0),(4201221,781,800,'[{1,19429},{2,59764683}]',19429,59764683,0),(4201222,1,200,'[{1,297},{2,587332}]',297,587332,0),(4201222,201,260,'[{1,912},{2,1802246}]',912,1802246,0),(4201222,261,320,'[{1,1871},{2,3746766}]',1871,3746766,0),(4201222,321,350,'[{1,2400},{2,5310987}]',2400,5310987,0),(4201222,351,370,'[{1,2831},{2,7054261}]',2831,7054261,0),(4201222,371,390,'[{1,3262},{2,8930454}]',3262,8930454,0),(4201222,391,430,'[{1,4097},{2,12044462}]',4097,12044462,0),(4201222,431,470,'[{1,5126},{2,15263941}]',5126,15263941,0),(4201222,471,500,'[{1,6049},{2,18170038}]',6049,18170038,0),(4201222,501,530,'[{1,7129},{2,21544731}]',7129,21544731,0),(4201222,531,560,'[{1,8231},{2,24990733}]',8231,24990733,0),(4201222,561,590,'[{1,9382},{2,28583897}]',9382,28583897,0),(4201222,591,610,'[{1,10192},{2,31100679}]',10192,31100679,0),(4201222,611,630,'[{1,11045},{2,33739201}]',11045,33739201,0),(4201222,631,660,'[{1,12416},{2,38020166}]',12416,38020166,0),(4201222,661,690,'[{1,13975},{2,42954554}]',13975,42954554,0),(4201222,691,720,'[{1,15439},{2,47510344}]',15439,47510344,0),(4201222,721,750,'[{1,16851},{2,51871314}]',16851,51871314,0),(4201222,751,780,'[{1,18401},{2,56610773}]',18401,56610773,0),(4201222,781,800,'[{1,19429},{2,59764683}]',19429,59764683,0),(4201231,1,200,'[{1,297},{2,587332}]',297,587332,0),(4201231,201,260,'[{1,912},{2,1802246}]',912,1802246,0),(4201231,261,320,'[{1,1871},{2,3746766}]',1871,3746766,0),(4201231,321,350,'[{1,2400},{2,5310987}]',2400,5310987,0),(4201231,351,370,'[{1,2831},{2,7054261}]',2831,7054261,0),(4201231,371,390,'[{1,3262},{2,8930454}]',3262,8930454,0),(4201231,391,430,'[{1,4097},{2,12044462}]',4097,12044462,0),(4201231,431,470,'[{1,5126},{2,15263941}]',5126,15263941,0),(4201231,471,500,'[{1,6049},{2,18170038}]',6049,18170038,0),(4201231,501,530,'[{1,7129},{2,21544731}]',7129,21544731,0),(4201231,531,560,'[{1,8231},{2,24990733}]',8231,24990733,0),(4201231,561,590,'[{1,9382},{2,28583897}]',9382,28583897,0),(4201231,591,610,'[{1,10192},{2,31100679}]',10192,31100679,0),(4201231,611,630,'[{1,11045},{2,33739201}]',11045,33739201,0),(4201231,631,660,'[{1,12416},{2,38020166}]',12416,38020166,0),(4201231,661,690,'[{1,13975},{2,42954554}]',13975,42954554,0),(4201231,691,720,'[{1,15439},{2,47510344}]',15439,47510344,0),(4201231,721,750,'[{1,16851},{2,51871314}]',16851,51871314,0),(4201231,751,780,'[{1,18401},{2,56610773}]',18401,56610773,0),(4201231,781,800,'[{1,19429},{2,59764683}]',19429,59764683,0),(4201232,1,200,'[{1,297},{2,587332}]',297,587332,0),(4201232,201,260,'[{1,912},{2,1802246}]',912,1802246,0),(4201232,261,320,'[{1,1871},{2,3746766}]',1871,3746766,0),(4201232,321,350,'[{1,2400},{2,5310987}]',2400,5310987,0),(4201232,351,370,'[{1,2831},{2,7054261}]',2831,7054261,0),(4201232,371,390,'[{1,3262},{2,8930454}]',3262,8930454,0),(4201232,391,430,'[{1,4097},{2,12044462}]',4097,12044462,0),(4201232,431,470,'[{1,5126},{2,15263941}]',5126,15263941,0),(4201232,471,500,'[{1,6049},{2,18170038}]',6049,18170038,0),(4201232,501,530,'[{1,7129},{2,21544731}]',7129,21544731,0),(4201232,531,560,'[{1,8231},{2,24990733}]',8231,24990733,0),(4201232,561,590,'[{1,9382},{2,28583897}]',9382,28583897,0),(4201232,591,610,'[{1,10192},{2,31100679}]',10192,31100679,0),(4201232,611,630,'[{1,11045},{2,33739201}]',11045,33739201,0),(4201232,631,660,'[{1,12416},{2,38020166}]',12416,38020166,0),(4201232,661,690,'[{1,13975},{2,42954554}]',13975,42954554,0),(4201232,691,720,'[{1,15439},{2,47510344}]',15439,47510344,0),(4201232,721,750,'[{1,16851},{2,51871314}]',16851,51871314,0),(4201232,751,780,'[{1,18401},{2,56610773}]',18401,56610773,0),(4201232,781,800,'[{1,19429},{2,59764683}]',19429,59764683,0),(4201241,1,200,'[{1,297},{2,587332}]',297,587332,0),(4201241,201,260,'[{1,912},{2,1802246}]',912,1802246,0),(4201241,261,320,'[{1,1871},{2,3746766}]',1871,3746766,0),(4201241,321,350,'[{1,2400},{2,5310987}]',2400,5310987,0),(4201241,351,370,'[{1,2831},{2,7054261}]',2831,7054261,0),(4201241,371,390,'[{1,3262},{2,8930454}]',3262,8930454,0),(4201241,391,430,'[{1,4097},{2,12044462}]',4097,12044462,0),(4201241,431,470,'[{1,5126},{2,15263941}]',5126,15263941,0),(4201241,471,500,'[{1,6049},{2,18170038}]',6049,18170038,0),(4201241,501,530,'[{1,7129},{2,21544731}]',7129,21544731,0),(4201241,531,560,'[{1,8231},{2,24990733}]',8231,24990733,0),(4201241,561,590,'[{1,9382},{2,28583897}]',9382,28583897,0),(4201241,591,610,'[{1,10192},{2,31100679}]',10192,31100679,0),(4201241,611,630,'[{1,11045},{2,33739201}]',11045,33739201,0),(4201241,631,660,'[{1,12416},{2,38020166}]',12416,38020166,0),(4201241,661,690,'[{1,13975},{2,42954554}]',13975,42954554,0),(4201241,691,720,'[{1,15439},{2,47510344}]',15439,47510344,0),(4201241,721,750,'[{1,16851},{2,51871314}]',16851,51871314,0),(4201241,751,780,'[{1,18401},{2,56610773}]',18401,56610773,0),(4201241,781,800,'[{1,19429},{2,59764683}]',19429,59764683,0),(4201242,1,200,'[{1,297},{2,587332}]',297,587332,0),(4201242,201,260,'[{1,912},{2,1802246}]',912,1802246,0),(4201242,261,320,'[{1,1871},{2,3746766}]',1871,3746766,0),(4201242,321,350,'[{1,2400},{2,5310987}]',2400,5310987,0),(4201242,351,370,'[{1,2831},{2,7054261}]',2831,7054261,0),(4201242,371,390,'[{1,3262},{2,8930454}]',3262,8930454,0),(4201242,391,430,'[{1,4097},{2,12044462}]',4097,12044462,0),(4201242,431,470,'[{1,5126},{2,15263941}]',5126,15263941,0),(4201242,471,500,'[{1,6049},{2,18170038}]',6049,18170038,0),(4201242,501,530,'[{1,7129},{2,21544731}]',7129,21544731,0),(4201242,531,560,'[{1,8231},{2,24990733}]',8231,24990733,0),(4201242,561,590,'[{1,9382},{2,28583897}]',9382,28583897,0),(4201242,591,610,'[{1,10192},{2,31100679}]',10192,31100679,0),(4201242,611,630,'[{1,11045},{2,33739201}]',11045,33739201,0),(4201242,631,660,'[{1,12416},{2,38020166}]',12416,38020166,0),(4201242,661,690,'[{1,13975},{2,42954554}]',13975,42954554,0),(4201242,691,720,'[{1,15439},{2,47510344}]',15439,47510344,0),(4201242,721,750,'[{1,16851},{2,51871314}]',16851,51871314,0),(4201242,751,780,'[{1,18401},{2,56610773}]',18401,56610773,0),(4201242,781,800,'[{1,19429},{2,59764683}]',19429,59764683,0),(4201251,1,200,'[{1,297},{2,587332}]',297,587332,0),(4201251,201,260,'[{1,912},{2,1802246}]',912,1802246,0),(4201251,261,320,'[{1,1871},{2,3746766}]',1871,3746766,0),(4201251,321,350,'[{1,2400},{2,5310987}]',2400,5310987,0),(4201251,351,370,'[{1,2831},{2,7054261}]',2831,7054261,0),(4201251,371,390,'[{1,3262},{2,8930454}]',3262,8930454,0),(4201251,391,430,'[{1,4097},{2,12044462}]',4097,12044462,0),(4201251,431,470,'[{1,5126},{2,15263941}]',5126,15263941,0),(4201251,471,500,'[{1,6049},{2,18170038}]',6049,18170038,0),(4201251,501,530,'[{1,7129},{2,21544731}]',7129,21544731,0),(4201251,531,560,'[{1,8231},{2,24990733}]',8231,24990733,0),(4201251,561,590,'[{1,9382},{2,28583897}]',9382,28583897,0),(4201251,591,610,'[{1,10192},{2,31100679}]',10192,31100679,0),(4201251,611,630,'[{1,11045},{2,33739201}]',11045,33739201,0),(4201251,631,660,'[{1,12416},{2,38020166}]',12416,38020166,0),(4201251,661,690,'[{1,13975},{2,42954554}]',13975,42954554,0),(4201251,691,720,'[{1,15439},{2,47510344}]',15439,47510344,0),(4201251,721,750,'[{1,16851},{2,51871314}]',16851,51871314,0),(4201251,751,780,'[{1,18401},{2,56610773}]',18401,56610773,0),(4201251,781,800,'[{1,19429},{2,59764683}]',19429,59764683,0),(4201252,1,200,'[{1,297},{2,587332}]',297,587332,0),(4201252,201,260,'[{1,912},{2,1802246}]',912,1802246,0),(4201252,261,320,'[{1,1871},{2,3746766}]',1871,3746766,0),(4201252,321,350,'[{1,2400},{2,5310987}]',2400,5310987,0),(4201252,351,370,'[{1,2831},{2,7054261}]',2831,7054261,0),(4201252,371,390,'[{1,3262},{2,8930454}]',3262,8930454,0),(4201252,391,430,'[{1,4097},{2,12044462}]',4097,12044462,0),(4201252,431,470,'[{1,5126},{2,15263941}]',5126,15263941,0),(4201252,471,500,'[{1,6049},{2,18170038}]',6049,18170038,0),(4201252,501,530,'[{1,7129},{2,21544731}]',7129,21544731,0),(4201252,531,560,'[{1,8231},{2,24990733}]',8231,24990733,0),(4201252,561,590,'[{1,9382},{2,28583897}]',9382,28583897,0),(4201252,591,610,'[{1,10192},{2,31100679}]',10192,31100679,0),(4201252,611,630,'[{1,11045},{2,33739201}]',11045,33739201,0),(4201252,631,660,'[{1,12416},{2,38020166}]',12416,38020166,0),(4201252,661,690,'[{1,13975},{2,42954554}]',13975,42954554,0),(4201252,691,720,'[{1,15439},{2,47510344}]',15439,47510344,0),(4201252,721,750,'[{1,16851},{2,51871314}]',16851,51871314,0),(4201252,751,780,'[{1,18401},{2,56610773}]',18401,56610773,0),(4201252,781,800,'[{1,19429},{2,59764683}]',19429,59764683,0),(4201261,1,200,'[{1,297},{2,587332}]',297,587332,0),(4201261,201,260,'[{1,912},{2,1802246}]',912,1802246,0),(4201261,261,320,'[{1,1871},{2,3746766}]',1871,3746766,0),(4201261,321,350,'[{1,2400},{2,5310987}]',2400,5310987,0),(4201261,351,370,'[{1,2831},{2,7054261}]',2831,7054261,0),(4201261,371,390,'[{1,3262},{2,8930454}]',3262,8930454,0),(4201261,391,430,'[{1,4097},{2,12044462}]',4097,12044462,0),(4201261,431,470,'[{1,5126},{2,15263941}]',5126,15263941,0),(4201261,471,500,'[{1,6049},{2,18170038}]',6049,18170038,0),(4201261,501,530,'[{1,7129},{2,21544731}]',7129,21544731,0),(4201261,531,560,'[{1,8231},{2,24990733}]',8231,24990733,0),(4201261,561,590,'[{1,9382},{2,28583897}]',9382,28583897,0),(4201261,591,610,'[{1,10192},{2,31100679}]',10192,31100679,0),(4201261,611,630,'[{1,11045},{2,33739201}]',11045,33739201,0),(4201261,631,660,'[{1,12416},{2,38020166}]',12416,38020166,0),(4201261,661,690,'[{1,13975},{2,42954554}]',13975,42954554,0),(4201261,691,720,'[{1,15439},{2,47510344}]',15439,47510344,0),(4201261,721,750,'[{1,16851},{2,51871314}]',16851,51871314,0),(4201261,751,780,'[{1,18401},{2,56610773}]',18401,56610773,0),(4201261,781,800,'[{1,19429},{2,59764683}]',19429,59764683,0),(4201262,1,200,'[{1,297},{2,587332}]',297,587332,0),(4201262,201,260,'[{1,912},{2,1802246}]',912,1802246,0),(4201262,261,320,'[{1,1871},{2,3746766}]',1871,3746766,0),(4201262,321,350,'[{1,2400},{2,5310987}]',2400,5310987,0),(4201262,351,370,'[{1,2831},{2,7054261}]',2831,7054261,0),(4201262,371,390,'[{1,3262},{2,8930454}]',3262,8930454,0),(4201262,391,430,'[{1,4097},{2,12044462}]',4097,12044462,0),(4201262,431,470,'[{1,5126},{2,15263941}]',5126,15263941,0),(4201262,471,500,'[{1,6049},{2,18170038}]',6049,18170038,0),(4201262,501,530,'[{1,7129},{2,21544731}]',7129,21544731,0),(4201262,531,560,'[{1,8231},{2,24990733}]',8231,24990733,0),(4201262,561,590,'[{1,9382},{2,28583897}]',9382,28583897,0),(4201262,591,610,'[{1,10192},{2,31100679}]',10192,31100679,0),(4201262,611,630,'[{1,11045},{2,33739201}]',11045,33739201,0),(4201262,631,660,'[{1,12416},{2,38020166}]',12416,38020166,0),(4201262,661,690,'[{1,13975},{2,42954554}]',13975,42954554,0),(4201262,691,720,'[{1,15439},{2,47510344}]',15439,47510344,0),(4201262,721,750,'[{1,16851},{2,51871314}]',16851,51871314,0),(4201262,751,780,'[{1,18401},{2,56610773}]',18401,56610773,0),(4201262,781,800,'[{1,19429},{2,59764683}]',19429,59764683,0),(4201271,1,200,'[{1,297},{2,587332}]',297,587332,0),(4201271,201,260,'[{1,912},{2,1802246}]',912,1802246,0),(4201271,261,320,'[{1,1871},{2,3746766}]',1871,3746766,0),(4201271,321,350,'[{1,2400},{2,5310987}]',2400,5310987,0),(4201271,351,370,'[{1,2831},{2,7054261}]',2831,7054261,0),(4201271,371,390,'[{1,3262},{2,8930454}]',3262,8930454,0),(4201271,391,430,'[{1,4097},{2,12044462}]',4097,12044462,0),(4201271,431,470,'[{1,5126},{2,15263941}]',5126,15263941,0),(4201271,471,500,'[{1,6049},{2,18170038}]',6049,18170038,0),(4201271,501,530,'[{1,7129},{2,21544731}]',7129,21544731,0),(4201271,531,560,'[{1,8231},{2,24990733}]',8231,24990733,0),(4201271,561,590,'[{1,9382},{2,28583897}]',9382,28583897,0),(4201271,591,610,'[{1,10192},{2,31100679}]',10192,31100679,0),(4201271,611,630,'[{1,11045},{2,33739201}]',11045,33739201,0),(4201271,631,660,'[{1,12416},{2,38020166}]',12416,38020166,0),(4201271,661,690,'[{1,13975},{2,42954554}]',13975,42954554,0),(4201271,691,720,'[{1,15439},{2,47510344}]',15439,47510344,0),(4201271,721,750,'[{1,16851},{2,51871314}]',16851,51871314,0),(4201271,751,780,'[{1,18401},{2,56610773}]',18401,56610773,0),(4201271,781,800,'[{1,19429},{2,59764683}]',19429,59764683,0),(4201272,1,200,'[{1,297},{2,587332}]',297,587332,0),(4201272,201,260,'[{1,912},{2,1802246}]',912,1802246,0),(4201272,261,320,'[{1,1871},{2,3746766}]',1871,3746766,0),(4201272,321,350,'[{1,2400},{2,5310987}]',2400,5310987,0),(4201272,351,370,'[{1,2831},{2,7054261}]',2831,7054261,0),(4201272,371,390,'[{1,3262},{2,8930454}]',3262,8930454,0),(4201272,391,430,'[{1,4097},{2,12044462}]',4097,12044462,0),(4201272,431,470,'[{1,5126},{2,15263941}]',5126,15263941,0),(4201272,471,500,'[{1,6049},{2,18170038}]',6049,18170038,0),(4201272,501,530,'[{1,7129},{2,21544731}]',7129,21544731,0),(4201272,531,560,'[{1,8231},{2,24990733}]',8231,24990733,0),(4201272,561,590,'[{1,9382},{2,28583897}]',9382,28583897,0),(4201272,591,610,'[{1,10192},{2,31100679}]',10192,31100679,0),(4201272,611,630,'[{1,11045},{2,33739201}]',11045,33739201,0),(4201272,631,660,'[{1,12416},{2,38020166}]',12416,38020166,0),(4201272,661,690,'[{1,13975},{2,42954554}]',13975,42954554,0),(4201272,691,720,'[{1,15439},{2,47510344}]',15439,47510344,0),(4201272,721,750,'[{1,16851},{2,51871314}]',16851,51871314,0),(4201272,751,780,'[{1,18401},{2,56610773}]',18401,56610773,0),(4201272,781,800,'[{1,19429},{2,59764683}]',19429,59764683,0),(4201281,1,200,'[{1,297},{2,587332}]',297,587332,0),(4201281,201,260,'[{1,912},{2,1802246}]',912,1802246,0),(4201281,261,320,'[{1,1871},{2,3746766}]',1871,3746766,0),(4201281,321,350,'[{1,2400},{2,5310987}]',2400,5310987,0),(4201281,351,370,'[{1,2831},{2,7054261}]',2831,7054261,0),(4201281,371,390,'[{1,3262},{2,8930454}]',3262,8930454,0),(4201281,391,430,'[{1,4097},{2,12044462}]',4097,12044462,0),(4201281,431,470,'[{1,5126},{2,15263941}]',5126,15263941,0),(4201281,471,500,'[{1,6049},{2,18170038}]',6049,18170038,0),(4201281,501,530,'[{1,7129},{2,21544731}]',7129,21544731,0),(4201281,531,560,'[{1,8231},{2,24990733}]',8231,24990733,0),(4201281,561,590,'[{1,9382},{2,28583897}]',9382,28583897,0),(4201281,591,610,'[{1,10192},{2,31100679}]',10192,31100679,0),(4201281,611,630,'[{1,11045},{2,33739201}]',11045,33739201,0),(4201281,631,660,'[{1,12416},{2,38020166}]',12416,38020166,0),(4201281,661,690,'[{1,13975},{2,42954554}]',13975,42954554,0),(4201281,691,720,'[{1,15439},{2,47510344}]',15439,47510344,0),(4201281,721,750,'[{1,16851},{2,51871314}]',16851,51871314,0),(4201281,751,780,'[{1,18401},{2,56610773}]',18401,56610773,0),(4201281,781,800,'[{1,19429},{2,59764683}]',19429,59764683,0),(4201282,1,200,'[{1,297},{2,587332}]',297,587332,0),(4201282,201,260,'[{1,912},{2,1802246}]',912,1802246,0),(4201282,261,320,'[{1,1871},{2,3746766}]',1871,3746766,0),(4201282,321,350,'[{1,2400},{2,5310987}]',2400,5310987,0),(4201282,351,370,'[{1,2831},{2,7054261}]',2831,7054261,0),(4201282,371,390,'[{1,3262},{2,8930454}]',3262,8930454,0),(4201282,391,430,'[{1,4097},{2,12044462}]',4097,12044462,0),(4201282,431,470,'[{1,5126},{2,15263941}]',5126,15263941,0),(4201282,471,500,'[{1,6049},{2,18170038}]',6049,18170038,0),(4201282,501,530,'[{1,7129},{2,21544731}]',7129,21544731,0),(4201282,531,560,'[{1,8231},{2,24990733}]',8231,24990733,0),(4201282,561,590,'[{1,9382},{2,28583897}]',9382,28583897,0),(4201282,591,610,'[{1,10192},{2,31100679}]',10192,31100679,0),(4201282,611,630,'[{1,11045},{2,33739201}]',11045,33739201,0),(4201282,631,660,'[{1,12416},{2,38020166}]',12416,38020166,0),(4201282,661,690,'[{1,13975},{2,42954554}]',13975,42954554,0),(4201282,691,720,'[{1,15439},{2,47510344}]',15439,47510344,0),(4201282,721,750,'[{1,16851},{2,51871314}]',16851,51871314,0),(4201282,751,780,'[{1,18401},{2,56610773}]',18401,56610773,0),(4201282,781,800,'[{1,19429},{2,59764683}]',19429,59764683,0),(4201311,1,200,'[{1,297},{2,587332}]',297,587332,0),(4201311,201,260,'[{1,912},{2,1802246}]',912,1802246,0),(4201311,261,320,'[{1,1871},{2,3746766}]',1871,3746766,0),(4201311,321,350,'[{1,2400},{2,5310987}]',2400,5310987,0),(4201311,351,370,'[{1,2831},{2,7054261}]',2831,7054261,0),(4201311,371,390,'[{1,3262},{2,8930454}]',3262,8930454,0),(4201311,391,430,'[{1,4097},{2,12044462}]',4097,12044462,0),(4201311,431,470,'[{1,5126},{2,15263941}]',5126,15263941,0),(4201311,471,500,'[{1,6049},{2,18170038}]',6049,18170038,0),(4201311,501,530,'[{1,7129},{2,21544731}]',7129,21544731,0),(4201311,531,560,'[{1,8231},{2,24990733}]',8231,24990733,0),(4201311,561,590,'[{1,9382},{2,28583897}]',9382,28583897,0),(4201311,591,610,'[{1,10192},{2,31100679}]',10192,31100679,0),(4201311,611,630,'[{1,11045},{2,33739201}]',11045,33739201,0),(4201311,631,660,'[{1,12416},{2,38020166}]',12416,38020166,0),(4201311,661,690,'[{1,13975},{2,42954554}]',13975,42954554,0),(4201311,691,720,'[{1,15439},{2,47510344}]',15439,47510344,0),(4201311,721,750,'[{1,16851},{2,51871314}]',16851,51871314,0),(4201311,751,780,'[{1,18401},{2,56610773}]',18401,56610773,0),(4201311,781,800,'[{1,19429},{2,59764683}]',19429,59764683,0),(4201312,1,200,'[{1,297},{2,587332}]',297,587332,0),(4201312,201,260,'[{1,912},{2,1802246}]',912,1802246,0),(4201312,261,320,'[{1,1871},{2,3746766}]',1871,3746766,0),(4201312,321,350,'[{1,2400},{2,5310987}]',2400,5310987,0),(4201312,351,370,'[{1,2831},{2,7054261}]',2831,7054261,0),(4201312,371,390,'[{1,3262},{2,8930454}]',3262,8930454,0),(4201312,391,430,'[{1,4097},{2,12044462}]',4097,12044462,0),(4201312,431,470,'[{1,5126},{2,15263941}]',5126,15263941,0),(4201312,471,500,'[{1,6049},{2,18170038}]',6049,18170038,0),(4201312,501,530,'[{1,7129},{2,21544731}]',7129,21544731,0),(4201312,531,560,'[{1,8231},{2,24990733}]',8231,24990733,0),(4201312,561,590,'[{1,9382},{2,28583897}]',9382,28583897,0),(4201312,591,610,'[{1,10192},{2,31100679}]',10192,31100679,0),(4201312,611,630,'[{1,11045},{2,33739201}]',11045,33739201,0),(4201312,631,660,'[{1,12416},{2,38020166}]',12416,38020166,0),(4201312,661,690,'[{1,13975},{2,42954554}]',13975,42954554,0),(4201312,691,720,'[{1,15439},{2,47510344}]',15439,47510344,0),(4201312,721,750,'[{1,16851},{2,51871314}]',16851,51871314,0),(4201312,751,780,'[{1,18401},{2,56610773}]',18401,56610773,0),(4201312,781,800,'[{1,19429},{2,59764683}]',19429,59764683,0),(4201321,1,200,'[{1,297},{2,587332}]',297,587332,0),(4201321,201,260,'[{1,912},{2,1802246}]',912,1802246,0),(4201321,261,320,'[{1,1871},{2,3746766}]',1871,3746766,0),(4201321,321,350,'[{1,2400},{2,5310987}]',2400,5310987,0),(4201321,351,370,'[{1,2831},{2,7054261}]',2831,7054261,0),(4201321,371,390,'[{1,3262},{2,8930454}]',3262,8930454,0),(4201321,391,430,'[{1,4097},{2,12044462}]',4097,12044462,0),(4201321,431,470,'[{1,5126},{2,15263941}]',5126,15263941,0),(4201321,471,500,'[{1,6049},{2,18170038}]',6049,18170038,0),(4201321,501,530,'[{1,7129},{2,21544731}]',7129,21544731,0),(4201321,531,560,'[{1,8231},{2,24990733}]',8231,24990733,0),(4201321,561,590,'[{1,9382},{2,28583897}]',9382,28583897,0),(4201321,591,610,'[{1,10192},{2,31100679}]',10192,31100679,0),(4201321,611,630,'[{1,11045},{2,33739201}]',11045,33739201,0),(4201321,631,660,'[{1,12416},{2,38020166}]',12416,38020166,0),(4201321,661,690,'[{1,13975},{2,42954554}]',13975,42954554,0),(4201321,691,720,'[{1,15439},{2,47510344}]',15439,47510344,0),(4201321,721,750,'[{1,16851},{2,51871314}]',16851,51871314,0),(4201321,751,780,'[{1,18401},{2,56610773}]',18401,56610773,0),(4201321,781,800,'[{1,19429},{2,59764683}]',19429,59764683,0),(4201322,1,200,'[{1,297},{2,587332}]',297,587332,0),(4201322,201,260,'[{1,912},{2,1802246}]',912,1802246,0),(4201322,261,320,'[{1,1871},{2,3746766}]',1871,3746766,0),(4201322,321,350,'[{1,2400},{2,5310987}]',2400,5310987,0),(4201322,351,370,'[{1,2831},{2,7054261}]',2831,7054261,0),(4201322,371,390,'[{1,3262},{2,8930454}]',3262,8930454,0),(4201322,391,430,'[{1,4097},{2,12044462}]',4097,12044462,0),(4201322,431,470,'[{1,5126},{2,15263941}]',5126,15263941,0),(4201322,471,500,'[{1,6049},{2,18170038}]',6049,18170038,0),(4201322,501,530,'[{1,7129},{2,21544731}]',7129,21544731,0),(4201322,531,560,'[{1,8231},{2,24990733}]',8231,24990733,0),(4201322,561,590,'[{1,9382},{2,28583897}]',9382,28583897,0),(4201322,591,610,'[{1,10192},{2,31100679}]',10192,31100679,0),(4201322,611,630,'[{1,11045},{2,33739201}]',11045,33739201,0),(4201322,631,660,'[{1,12416},{2,38020166}]',12416,38020166,0),(4201322,661,690,'[{1,13975},{2,42954554}]',13975,42954554,0),(4201322,691,720,'[{1,15439},{2,47510344}]',15439,47510344,0),(4201322,721,750,'[{1,16851},{2,51871314}]',16851,51871314,0),(4201322,751,780,'[{1,18401},{2,56610773}]',18401,56610773,0),(4201322,781,800,'[{1,19429},{2,59764683}]',19429,59764683,0),(4201331,1,200,'[{1,297},{2,587332}]',297,587332,0),(4201331,201,260,'[{1,912},{2,1802246}]',912,1802246,0),(4201331,261,320,'[{1,1871},{2,3746766}]',1871,3746766,0),(4201331,321,350,'[{1,2400},{2,5310987}]',2400,5310987,0),(4201331,351,370,'[{1,2831},{2,7054261}]',2831,7054261,0),(4201331,371,390,'[{1,3262},{2,8930454}]',3262,8930454,0),(4201331,391,430,'[{1,4097},{2,12044462}]',4097,12044462,0),(4201331,431,470,'[{1,5126},{2,15263941}]',5126,15263941,0),(4201331,471,500,'[{1,6049},{2,18170038}]',6049,18170038,0),(4201331,501,530,'[{1,7129},{2,21544731}]',7129,21544731,0),(4201331,531,560,'[{1,8231},{2,24990733}]',8231,24990733,0),(4201331,561,590,'[{1,9382},{2,28583897}]',9382,28583897,0),(4201331,591,610,'[{1,10192},{2,31100679}]',10192,31100679,0),(4201331,611,630,'[{1,11045},{2,33739201}]',11045,33739201,0),(4201331,631,660,'[{1,12416},{2,38020166}]',12416,38020166,0),(4201331,661,690,'[{1,13975},{2,42954554}]',13975,42954554,0),(4201331,691,720,'[{1,15439},{2,47510344}]',15439,47510344,0),(4201331,721,750,'[{1,16851},{2,51871314}]',16851,51871314,0),(4201331,751,780,'[{1,18401},{2,56610773}]',18401,56610773,0),(4201331,781,800,'[{1,19429},{2,59764683}]',19429,59764683,0),(4201332,1,200,'[{1,297},{2,587332}]',297,587332,0),(4201332,201,260,'[{1,912},{2,1802246}]',912,1802246,0),(4201332,261,320,'[{1,1871},{2,3746766}]',1871,3746766,0),(4201332,321,350,'[{1,2400},{2,5310987}]',2400,5310987,0),(4201332,351,370,'[{1,2831},{2,7054261}]',2831,7054261,0),(4201332,371,390,'[{1,3262},{2,8930454}]',3262,8930454,0),(4201332,391,430,'[{1,4097},{2,12044462}]',4097,12044462,0),(4201332,431,470,'[{1,5126},{2,15263941}]',5126,15263941,0),(4201332,471,500,'[{1,6049},{2,18170038}]',6049,18170038,0),(4201332,501,530,'[{1,7129},{2,21544731}]',7129,21544731,0),(4201332,531,560,'[{1,8231},{2,24990733}]',8231,24990733,0),(4201332,561,590,'[{1,9382},{2,28583897}]',9382,28583897,0),(4201332,591,610,'[{1,10192},{2,31100679}]',10192,31100679,0),(4201332,611,630,'[{1,11045},{2,33739201}]',11045,33739201,0),(4201332,631,660,'[{1,12416},{2,38020166}]',12416,38020166,0),(4201332,661,690,'[{1,13975},{2,42954554}]',13975,42954554,0),(4201332,691,720,'[{1,15439},{2,47510344}]',15439,47510344,0),(4201332,721,750,'[{1,16851},{2,51871314}]',16851,51871314,0),(4201332,751,780,'[{1,18401},{2,56610773}]',18401,56610773,0),(4201332,781,800,'[{1,19429},{2,59764683}]',19429,59764683,0),(4201341,1,200,'[{1,297},{2,587332}]',297,587332,0),(4201341,201,260,'[{1,912},{2,1802246}]',912,1802246,0),(4201341,261,320,'[{1,1871},{2,3746766}]',1871,3746766,0),(4201341,321,350,'[{1,2400},{2,5310987}]',2400,5310987,0),(4201341,351,370,'[{1,2831},{2,7054261}]',2831,7054261,0),(4201341,371,390,'[{1,3262},{2,8930454}]',3262,8930454,0),(4201341,391,430,'[{1,4097},{2,12044462}]',4097,12044462,0),(4201341,431,470,'[{1,5126},{2,15263941}]',5126,15263941,0),(4201341,471,500,'[{1,6049},{2,18170038}]',6049,18170038,0),(4201341,501,530,'[{1,7129},{2,21544731}]',7129,21544731,0),(4201341,531,560,'[{1,8231},{2,24990733}]',8231,24990733,0),(4201341,561,590,'[{1,9382},{2,28583897}]',9382,28583897,0),(4201341,591,610,'[{1,10192},{2,31100679}]',10192,31100679,0),(4201341,611,630,'[{1,11045},{2,33739201}]',11045,33739201,0),(4201341,631,660,'[{1,12416},{2,38020166}]',12416,38020166,0),(4201341,661,690,'[{1,13975},{2,42954554}]',13975,42954554,0),(4201341,691,720,'[{1,15439},{2,47510344}]',15439,47510344,0),(4201341,721,750,'[{1,16851},{2,51871314}]',16851,51871314,0),(4201341,751,780,'[{1,18401},{2,56610773}]',18401,56610773,0),(4201341,781,800,'[{1,19429},{2,59764683}]',19429,59764683,0),(4201342,1,200,'[{1,297},{2,587332}]',297,587332,0),(4201342,201,260,'[{1,912},{2,1802246}]',912,1802246,0),(4201342,261,320,'[{1,1871},{2,3746766}]',1871,3746766,0),(4201342,321,350,'[{1,2400},{2,5310987}]',2400,5310987,0),(4201342,351,370,'[{1,2831},{2,7054261}]',2831,7054261,0),(4201342,371,390,'[{1,3262},{2,8930454}]',3262,8930454,0),(4201342,391,430,'[{1,4097},{2,12044462}]',4097,12044462,0),(4201342,431,470,'[{1,5126},{2,15263941}]',5126,15263941,0),(4201342,471,500,'[{1,6049},{2,18170038}]',6049,18170038,0),(4201342,501,530,'[{1,7129},{2,21544731}]',7129,21544731,0),(4201342,531,560,'[{1,8231},{2,24990733}]',8231,24990733,0),(4201342,561,590,'[{1,9382},{2,28583897}]',9382,28583897,0),(4201342,591,610,'[{1,10192},{2,31100679}]',10192,31100679,0),(4201342,611,630,'[{1,11045},{2,33739201}]',11045,33739201,0),(4201342,631,660,'[{1,12416},{2,38020166}]',12416,38020166,0),(4201342,661,690,'[{1,13975},{2,42954554}]',13975,42954554,0),(4201342,691,720,'[{1,15439},{2,47510344}]',15439,47510344,0),(4201342,721,750,'[{1,16851},{2,51871314}]',16851,51871314,0),(4201342,751,780,'[{1,18401},{2,56610773}]',18401,56610773,0),(4201342,781,800,'[{1,19429},{2,59764683}]',19429,59764683,0),(4201351,1,200,'[{1,297},{2,587332}]',297,587332,0),(4201351,201,260,'[{1,912},{2,1802246}]',912,1802246,0),(4201351,261,320,'[{1,1871},{2,3746766}]',1871,3746766,0),(4201351,321,350,'[{1,2400},{2,5310987}]',2400,5310987,0),(4201351,351,370,'[{1,2831},{2,7054261}]',2831,7054261,0),(4201351,371,390,'[{1,3262},{2,8930454}]',3262,8930454,0),(4201351,391,430,'[{1,4097},{2,12044462}]',4097,12044462,0),(4201351,431,470,'[{1,5126},{2,15263941}]',5126,15263941,0),(4201351,471,500,'[{1,6049},{2,18170038}]',6049,18170038,0),(4201351,501,530,'[{1,7129},{2,21544731}]',7129,21544731,0),(4201351,531,560,'[{1,8231},{2,24990733}]',8231,24990733,0),(4201351,561,590,'[{1,9382},{2,28583897}]',9382,28583897,0),(4201351,591,610,'[{1,10192},{2,31100679}]',10192,31100679,0),(4201351,611,630,'[{1,11045},{2,33739201}]',11045,33739201,0),(4201351,631,660,'[{1,12416},{2,38020166}]',12416,38020166,0),(4201351,661,690,'[{1,13975},{2,42954554}]',13975,42954554,0),(4201351,691,720,'[{1,15439},{2,47510344}]',15439,47510344,0),(4201351,721,750,'[{1,16851},{2,51871314}]',16851,51871314,0),(4201351,751,780,'[{1,18401},{2,56610773}]',18401,56610773,0),(4201351,781,800,'[{1,19429},{2,59764683}]',19429,59764683,0),(4201352,1,200,'[{1,297},{2,587332}]',297,587332,0),(4201352,201,260,'[{1,912},{2,1802246}]',912,1802246,0),(4201352,261,320,'[{1,1871},{2,3746766}]',1871,3746766,0),(4201352,321,350,'[{1,2400},{2,5310987}]',2400,5310987,0),(4201352,351,370,'[{1,2831},{2,7054261}]',2831,7054261,0),(4201352,371,390,'[{1,3262},{2,8930454}]',3262,8930454,0),(4201352,391,430,'[{1,4097},{2,12044462}]',4097,12044462,0),(4201352,431,470,'[{1,5126},{2,15263941}]',5126,15263941,0),(4201352,471,500,'[{1,6049},{2,18170038}]',6049,18170038,0),(4201352,501,530,'[{1,7129},{2,21544731}]',7129,21544731,0),(4201352,531,560,'[{1,8231},{2,24990733}]',8231,24990733,0),(4201352,561,590,'[{1,9382},{2,28583897}]',9382,28583897,0),(4201352,591,610,'[{1,10192},{2,31100679}]',10192,31100679,0),(4201352,611,630,'[{1,11045},{2,33739201}]',11045,33739201,0),(4201352,631,660,'[{1,12416},{2,38020166}]',12416,38020166,0),(4201352,661,690,'[{1,13975},{2,42954554}]',13975,42954554,0),(4201352,691,720,'[{1,15439},{2,47510344}]',15439,47510344,0),(4201352,721,750,'[{1,16851},{2,51871314}]',16851,51871314,0),(4201352,751,780,'[{1,18401},{2,56610773}]',18401,56610773,0),(4201352,781,800,'[{1,19429},{2,59764683}]',19429,59764683,0),(4201361,1,200,'[{1,297},{2,587332}]',297,587332,0),(4201361,201,260,'[{1,912},{2,1802246}]',912,1802246,0),(4201361,261,320,'[{1,1871},{2,3746766}]',1871,3746766,0),(4201361,321,350,'[{1,2400},{2,5310987}]',2400,5310987,0),(4201361,351,370,'[{1,2831},{2,7054261}]',2831,7054261,0),(4201361,371,390,'[{1,3262},{2,8930454}]',3262,8930454,0),(4201361,391,430,'[{1,4097},{2,12044462}]',4097,12044462,0),(4201361,431,470,'[{1,5126},{2,15263941}]',5126,15263941,0),(4201361,471,500,'[{1,6049},{2,18170038}]',6049,18170038,0),(4201361,501,530,'[{1,7129},{2,21544731}]',7129,21544731,0),(4201361,531,560,'[{1,8231},{2,24990733}]',8231,24990733,0),(4201361,561,590,'[{1,9382},{2,28583897}]',9382,28583897,0),(4201361,591,610,'[{1,10192},{2,31100679}]',10192,31100679,0),(4201361,611,630,'[{1,11045},{2,33739201}]',11045,33739201,0),(4201361,631,660,'[{1,12416},{2,38020166}]',12416,38020166,0),(4201361,661,690,'[{1,13975},{2,42954554}]',13975,42954554,0),(4201361,691,720,'[{1,15439},{2,47510344}]',15439,47510344,0),(4201361,721,750,'[{1,16851},{2,51871314}]',16851,51871314,0),(4201361,751,780,'[{1,18401},{2,56610773}]',18401,56610773,0),(4201361,781,800,'[{1,19429},{2,59764683}]',19429,59764683,0),(4201362,1,200,'[{1,297},{2,587332}]',297,587332,0),(4201362,201,260,'[{1,912},{2,1802246}]',912,1802246,0),(4201362,261,320,'[{1,1871},{2,3746766}]',1871,3746766,0),(4201362,321,350,'[{1,2400},{2,5310987}]',2400,5310987,0),(4201362,351,370,'[{1,2831},{2,7054261}]',2831,7054261,0),(4201362,371,390,'[{1,3262},{2,8930454}]',3262,8930454,0),(4201362,391,430,'[{1,4097},{2,12044462}]',4097,12044462,0),(4201362,431,470,'[{1,5126},{2,15263941}]',5126,15263941,0),(4201362,471,500,'[{1,6049},{2,18170038}]',6049,18170038,0),(4201362,501,530,'[{1,7129},{2,21544731}]',7129,21544731,0),(4201362,531,560,'[{1,8231},{2,24990733}]',8231,24990733,0),(4201362,561,590,'[{1,9382},{2,28583897}]',9382,28583897,0),(4201362,591,610,'[{1,10192},{2,31100679}]',10192,31100679,0),(4201362,611,630,'[{1,11045},{2,33739201}]',11045,33739201,0),(4201362,631,660,'[{1,12416},{2,38020166}]',12416,38020166,0),(4201362,661,690,'[{1,13975},{2,42954554}]',13975,42954554,0),(4201362,691,720,'[{1,15439},{2,47510344}]',15439,47510344,0),(4201362,721,750,'[{1,16851},{2,51871314}]',16851,51871314,0),(4201362,751,780,'[{1,18401},{2,56610773}]',18401,56610773,0),(4201362,781,800,'[{1,19429},{2,59764683}]',19429,59764683,0),(4201371,1,200,'[{1,297},{2,587332}]',297,587332,0),(4201371,201,260,'[{1,912},{2,1802246}]',912,1802246,0),(4201371,261,320,'[{1,1871},{2,3746766}]',1871,3746766,0),(4201371,321,350,'[{1,2400},{2,5310987}]',2400,5310987,0),(4201371,351,370,'[{1,2831},{2,7054261}]',2831,7054261,0),(4201371,371,390,'[{1,3262},{2,8930454}]',3262,8930454,0),(4201371,391,430,'[{1,4097},{2,12044462}]',4097,12044462,0),(4201371,431,470,'[{1,5126},{2,15263941}]',5126,15263941,0),(4201371,471,500,'[{1,6049},{2,18170038}]',6049,18170038,0),(4201371,501,530,'[{1,7129},{2,21544731}]',7129,21544731,0),(4201371,531,560,'[{1,8231},{2,24990733}]',8231,24990733,0),(4201371,561,590,'[{1,9382},{2,28583897}]',9382,28583897,0),(4201371,591,610,'[{1,10192},{2,31100679}]',10192,31100679,0),(4201371,611,630,'[{1,11045},{2,33739201}]',11045,33739201,0),(4201371,631,660,'[{1,12416},{2,38020166}]',12416,38020166,0),(4201371,661,690,'[{1,13975},{2,42954554}]',13975,42954554,0),(4201371,691,720,'[{1,15439},{2,47510344}]',15439,47510344,0),(4201371,721,750,'[{1,16851},{2,51871314}]',16851,51871314,0),(4201371,751,780,'[{1,18401},{2,56610773}]',18401,56610773,0),(4201371,781,800,'[{1,19429},{2,59764683}]',19429,59764683,0),(4201372,1,200,'[{1,297},{2,587332}]',297,587332,0),(4201372,201,260,'[{1,912},{2,1802246}]',912,1802246,0),(4201372,261,320,'[{1,1871},{2,3746766}]',1871,3746766,0),(4201372,321,350,'[{1,2400},{2,5310987}]',2400,5310987,0),(4201372,351,370,'[{1,2831},{2,7054261}]',2831,7054261,0),(4201372,371,390,'[{1,3262},{2,8930454}]',3262,8930454,0),(4201372,391,430,'[{1,4097},{2,12044462}]',4097,12044462,0),(4201372,431,470,'[{1,5126},{2,15263941}]',5126,15263941,0),(4201372,471,500,'[{1,6049},{2,18170038}]',6049,18170038,0),(4201372,501,530,'[{1,7129},{2,21544731}]',7129,21544731,0),(4201372,531,560,'[{1,8231},{2,24990733}]',8231,24990733,0),(4201372,561,590,'[{1,9382},{2,28583897}]',9382,28583897,0),(4201372,591,610,'[{1,10192},{2,31100679}]',10192,31100679,0),(4201372,611,630,'[{1,11045},{2,33739201}]',11045,33739201,0),(4201372,631,660,'[{1,12416},{2,38020166}]',12416,38020166,0),(4201372,661,690,'[{1,13975},{2,42954554}]',13975,42954554,0),(4201372,691,720,'[{1,15439},{2,47510344}]',15439,47510344,0),(4201372,721,750,'[{1,16851},{2,51871314}]',16851,51871314,0),(4201372,751,780,'[{1,18401},{2,56610773}]',18401,56610773,0),(4201372,781,800,'[{1,19429},{2,59764683}]',19429,59764683,0),(4201381,1,200,'[{1,297},{2,587332}]',297,587332,0),(4201381,201,260,'[{1,912},{2,1802246}]',912,1802246,0),(4201381,261,320,'[{1,1871},{2,3746766}]',1871,3746766,0),(4201381,321,350,'[{1,2400},{2,5310987}]',2400,5310987,0),(4201381,351,370,'[{1,2831},{2,7054261}]',2831,7054261,0),(4201381,371,390,'[{1,3262},{2,8930454}]',3262,8930454,0),(4201381,391,430,'[{1,4097},{2,12044462}]',4097,12044462,0),(4201381,431,470,'[{1,5126},{2,15263941}]',5126,15263941,0),(4201381,471,500,'[{1,6049},{2,18170038}]',6049,18170038,0),(4201381,501,530,'[{1,7129},{2,21544731}]',7129,21544731,0),(4201381,531,560,'[{1,8231},{2,24990733}]',8231,24990733,0),(4201381,561,590,'[{1,9382},{2,28583897}]',9382,28583897,0),(4201381,591,610,'[{1,10192},{2,31100679}]',10192,31100679,0),(4201381,611,630,'[{1,11045},{2,33739201}]',11045,33739201,0),(4201381,631,660,'[{1,12416},{2,38020166}]',12416,38020166,0),(4201381,661,690,'[{1,13975},{2,42954554}]',13975,42954554,0),(4201381,691,720,'[{1,15439},{2,47510344}]',15439,47510344,0),(4201381,721,750,'[{1,16851},{2,51871314}]',16851,51871314,0),(4201381,751,780,'[{1,18401},{2,56610773}]',18401,56610773,0),(4201381,781,800,'[{1,19429},{2,59764683}]',19429,59764683,0),(4201382,1,200,'[{1,297},{2,587332}]',297,587332,0),(4201382,201,260,'[{1,912},{2,1802246}]',912,1802246,0),(4201382,261,320,'[{1,1871},{2,3746766}]',1871,3746766,0),(4201382,321,350,'[{1,2400},{2,5310987}]',2400,5310987,0),(4201382,351,370,'[{1,2831},{2,7054261}]',2831,7054261,0),(4201382,371,390,'[{1,3262},{2,8930454}]',3262,8930454,0),(4201382,391,430,'[{1,4097},{2,12044462}]',4097,12044462,0),(4201382,431,470,'[{1,5126},{2,15263941}]',5126,15263941,0),(4201382,471,500,'[{1,6049},{2,18170038}]',6049,18170038,0),(4201382,501,530,'[{1,7129},{2,21544731}]',7129,21544731,0),(4201382,531,560,'[{1,8231},{2,24990733}]',8231,24990733,0),(4201382,561,590,'[{1,9382},{2,28583897}]',9382,28583897,0),(4201382,591,610,'[{1,10192},{2,31100679}]',10192,31100679,0),(4201382,611,630,'[{1,11045},{2,33739201}]',11045,33739201,0),(4201382,631,660,'[{1,12416},{2,38020166}]',12416,38020166,0),(4201382,661,690,'[{1,13975},{2,42954554}]',13975,42954554,0),(4201382,691,720,'[{1,15439},{2,47510344}]',15439,47510344,0),(4201382,721,750,'[{1,16851},{2,51871314}]',16851,51871314,0),(4201382,751,780,'[{1,18401},{2,56610773}]',18401,56610773,0),(4201382,781,800,'[{1,19429},{2,59764683}]',19429,59764683,0),(6200000,1,1,'[{1,2373},{2,40898926},{3,11419},{4,10113},{5,3503},{6,3503},{7,2126},{8,2126}]',2373,40898926,0),(6200000,2,500,'[{1,3308},{2,56794666},{3,14653},{4,13305},{5,4880},{6,4880},{7,2674},{8,2674}]',3308,56794666,0),(6200000,501,550,'[{1,4919},{2,85182215},{3,22614},{4,20304},{5,7125},{6,7125},{7,3858},{8,3858}]',4919,85182215,0),(6200000,551,600,'[{1,7016},{2,121468757},{3,31693},{4,28453},{5,10656},{6,10656},{7,5420},{8,5420}]',7016,121468757,0),(6200000,601,650,'[{1,10197},{2,177319341},{3,41978},{4,37661},{5,19985},{6,19985},{7,9509},{8,9509}]',10197,177319341,0),(6200000,651,700,'[{1,14079},{2,245217890},{3,59658},{4,54069},{5,28149},{6,28149},{7,14098},{8,14098}]',14079,245217890,0),(6200000,701,750,'[{1,17931},{2,311045279},{3,77880},{4,70625},{5,34910},{6,34910},{7,17555},{8,17555}]',17931,311045279,0),(6200000,751,800,'[{1,21798},{2,375354797},{3,97636},{4,88221},{5,44572},{6,44572},{7,25418},{8,25418}]',21798,375354797,0),(6200000,801,850,'[{1,28385},{2,487429339},{3,125668},{4,113561},{5,54661},{6,54661},{7,30930},{8,30930}]',28385,487429339,0),(6200000,851,1000,'[{1,34782},{2,593279282},{3,155631},{4,140231},{5,65214},{6,65214},{7,36704},{8,36704}]',34782,593279282,0),(6200001,1,1,'[{1,2373},{2,40898926},{3,11419},{4,10113},{5,3503},{6,3503},{7,2126},{8,2126}]',2373,40898926,0),(6200001,2,500,'[{1,3308},{2,56794666},{3,14653},{4,13305},{5,4880},{6,4880},{7,2674},{8,2674}]',3308,56794666,0),(6200001,501,550,'[{1,4919},{2,85182215},{3,22614},{4,20304},{5,7125},{6,7125},{7,3858},{8,3858}]',4919,85182215,0),(6200001,551,600,'[{1,7016},{2,121468757},{3,31693},{4,28453},{5,10656},{6,10656},{7,5420},{8,5420}]',7016,121468757,0),(6200001,601,650,'[{1,10197},{2,177319341},{3,41978},{4,37661},{5,19985},{6,19985},{7,9509},{8,9509}]',10197,177319341,0),(6200001,651,700,'[{1,14079},{2,245217890},{3,59658},{4,54069},{5,28149},{6,28149},{7,14098},{8,14098}]',14079,245217890,0),(6200001,701,750,'[{1,17931},{2,311045279},{3,77880},{4,70625},{5,34910},{6,34910},{7,17555},{8,17555}]',17931,311045279,0),(6200001,751,800,'[{1,21798},{2,375354797},{3,97636},{4,88221},{5,44572},{6,44572},{7,25418},{8,25418}]',21798,375354797,0),(6200001,801,850,'[{1,28385},{2,487429339},{3,125668},{4,113561},{5,54661},{6,54661},{7,30930},{8,30930}]',28385,487429339,0),(6200001,851,1000,'[{1,34782},{2,593279282},{3,155631},{4,140231},{5,65214},{6,65214},{7,36704},{8,36704}]',34782,593279282,0),(6200002,1,1,'[{1,2373},{2,40898926},{3,11419},{4,10113},{5,3503},{6,3503},{7,2126},{8,2126}]',2373,40898926,0),(6200002,2,500,'[{1,3308},{2,56794666},{3,14653},{4,13305},{5,4880},{6,4880},{7,2674},{8,2674}]',3308,56794666,0),(6200002,501,550,'[{1,4919},{2,85182215},{3,22614},{4,20304},{5,7125},{6,7125},{7,3858},{8,3858}]',4919,85182215,0),(6200002,551,600,'[{1,7016},{2,121468757},{3,31693},{4,28453},{5,10656},{6,10656},{7,5420},{8,5420}]',7016,121468757,0),(6200002,601,650,'[{1,10197},{2,177319341},{3,41978},{4,37661},{5,19985},{6,19985},{7,9509},{8,9509}]',10197,177319341,0),(6200002,651,700,'[{1,14079},{2,245217890},{3,59658},{4,54069},{5,28149},{6,28149},{7,14098},{8,14098}]',14079,245217890,0),(6200002,701,750,'[{1,17931},{2,311045279},{3,77880},{4,70625},{5,34910},{6,34910},{7,17555},{8,17555}]',17931,311045279,0),(6200002,751,800,'[{1,21798},{2,375354797},{3,97636},{4,88221},{5,44572},{6,44572},{7,25418},{8,25418}]',21798,375354797,0),(6200002,801,850,'[{1,28385},{2,487429339},{3,125668},{4,113561},{5,54661},{6,54661},{7,30930},{8,30930}]',28385,487429339,0),(6200002,851,1000,'[{1,34782},{2,593279282},{3,155631},{4,140231},{5,65214},{6,65214},{7,36704},{8,36704}]',34782,593279282,0),(6200003,1,1,'[{1,2373},{2,40898926},{3,11419},{4,10113},{5,3503},{6,3503},{7,2126},{8,2126}]',2373,40898926,0),(6200003,2,500,'[{1,3308},{2,56794666},{3,14653},{4,13305},{5,4880},{6,4880},{7,2674},{8,2674}]',3308,56794666,0),(6200003,501,550,'[{1,4919},{2,85182215},{3,22614},{4,20304},{5,7125},{6,7125},{7,3858},{8,3858}]',4919,85182215,0),(6200003,551,600,'[{1,7016},{2,121468757},{3,31693},{4,28453},{5,10656},{6,10656},{7,5420},{8,5420}]',7016,121468757,0),(6200003,601,650,'[{1,10197},{2,177319341},{3,41978},{4,37661},{5,19985},{6,19985},{7,9509},{8,9509}]',10197,177319341,0),(6200003,651,700,'[{1,14079},{2,245217890},{3,59658},{4,54069},{5,28149},{6,28149},{7,14098},{8,14098}]',14079,245217890,0),(6200003,701,750,'[{1,17931},{2,311045279},{3,77880},{4,70625},{5,34910},{6,34910},{7,17555},{8,17555}]',17931,311045279,0),(6200003,751,800,'[{1,21798},{2,375354797},{3,97636},{4,88221},{5,44572},{6,44572},{7,25418},{8,25418}]',21798,375354797,0),(6200003,801,850,'[{1,28385},{2,487429339},{3,125668},{4,113561},{5,54661},{6,54661},{7,30930},{8,30930}]',28385,487429339,0),(6200003,851,1000,'[{1,34782},{2,593279282},{3,155631},{4,140231},{5,65214},{6,65214},{7,36704},{8,36704}]',34782,593279282,0),(6200004,1,1,'[{1,2373},{2,40898926},{3,11419},{4,10113},{5,3503},{6,3503},{7,2126},{8,2126}]',2373,40898926,0),(6200004,2,500,'[{1,3308},{2,56794666},{3,14653},{4,13305},{5,4880},{6,4880},{7,2674},{8,2674}]',3308,56794666,0),(6200004,501,550,'[{1,4919},{2,85182215},{3,22614},{4,20304},{5,7125},{6,7125},{7,3858},{8,3858}]',4919,85182215,0),(6200004,551,600,'[{1,7016},{2,121468757},{3,31693},{4,28453},{5,10656},{6,10656},{7,5420},{8,5420}]',7016,121468757,0),(6200004,601,650,'[{1,10197},{2,177319341},{3,41978},{4,37661},{5,19985},{6,19985},{7,9509},{8,9509}]',10197,177319341,0),(6200004,651,700,'[{1,14079},{2,245217890},{3,59658},{4,54069},{5,28149},{6,28149},{7,14098},{8,14098}]',14079,245217890,0),(6200004,701,750,'[{1,17931},{2,311045279},{3,77880},{4,70625},{5,34910},{6,34910},{7,17555},{8,17555}]',17931,311045279,0),(6200004,751,800,'[{1,21798},{2,375354797},{3,97636},{4,88221},{5,44572},{6,44572},{7,25418},{8,25418}]',21798,375354797,0),(6200004,801,850,'[{1,28385},{2,487429339},{3,125668},{4,113561},{5,54661},{6,54661},{7,30930},{8,30930}]',28385,487429339,0),(6200004,851,1000,'[{1,34782},{2,593279282},{3,155631},{4,140231},{5,65214},{6,65214},{7,36704},{8,36704}]',34782,593279282,0),(6200005,1,1,'[{1,2373},{2,40898926},{3,11419},{4,10113},{5,3503},{6,3503},{7,2126},{8,2126}]',2373,40898926,0),(6200005,2,500,'[{1,3308},{2,56794666},{3,14653},{4,13305},{5,4880},{6,4880},{7,2674},{8,2674}]',3308,56794666,0),(6200005,501,550,'[{1,4919},{2,85182215},{3,22614},{4,20304},{5,7125},{6,7125},{7,3858},{8,3858}]',4919,85182215,0),(6200005,551,600,'[{1,7016},{2,121468757},{3,31693},{4,28453},{5,10656},{6,10656},{7,5420},{8,5420}]',7016,121468757,0),(6200005,601,650,'[{1,10197},{2,177319341},{3,41978},{4,37661},{5,19985},{6,19985},{7,9509},{8,9509}]',10197,177319341,0),(6200005,651,700,'[{1,14079},{2,245217890},{3,59658},{4,54069},{5,28149},{6,28149},{7,14098},{8,14098}]',14079,245217890,0),(6200005,701,750,'[{1,17931},{2,311045279},{3,77880},{4,70625},{5,34910},{6,34910},{7,17555},{8,17555}]',17931,311045279,0),(6200005,751,800,'[{1,21798},{2,375354797},{3,97636},{4,88221},{5,44572},{6,44572},{7,25418},{8,25418}]',21798,375354797,0),(6200005,801,850,'[{1,28385},{2,487429339},{3,125668},{4,113561},{5,54661},{6,54661},{7,30930},{8,30930}]',28385,487429339,0),(6200005,851,1000,'[{1,34782},{2,593279282},{3,155631},{4,140231},{5,65214},{6,65214},{7,36704},{8,36704}]',34782,593279282,0),(6200020,1,1,'[{1,1186},{2,817978526},{3,11419},{4,10113},{5,3503},{6,3503},{7,2126},{8,2126}]',1186,817978526,0),(6200020,2,500,'[{1,1654},{2,1135893327},{3,14653},{4,13305},{5,4880},{6,4880},{7,2674},{8,2674}]',1654,1135893327,0),(6200020,501,550,'[{1,2460},{2,1703644294},{3,22614},{4,20304},{5,7125},{6,7125},{7,3858},{8,3858}]',2460,1703644294,0),(6200020,551,600,'[{1,3508},{2,2429375146},{3,31693},{4,28453},{5,10656},{6,10656},{7,5420},{8,5420}]',3508,2429375146,0),(6200020,601,650,'[{1,5098},{2,3546386814},{3,41978},{4,37661},{5,19985},{6,19985},{7,9509},{8,9509}]',5098,3546386814,0),(6200020,651,700,'[{1,7040},{2,4904357810},{3,59658},{4,54069},{5,28149},{6,28149},{7,14098},{8,14098}]',7040,4294967295,0),(6200020,701,750,'[{1,8965},{2,6220905589},{3,77880},{4,70625},{5,34910},{6,34910},{7,17555},{8,17555}]',8965,4294967295,0),(6200020,751,800,'[{1,10899},{2,7507095941},{3,97636},{4,88221},{5,44572},{6,44572},{7,25418},{8,25418}]',10899,4294967295,0),(6200020,801,850,'[{1,14193},{2,9748586770},{3,125668},{4,113561},{5,54661},{6,54661},{7,30930},{8,30930}]',14193,4294967295,0),(6200020,851,1000,'[{1,17391},{2,11865585632},{3,155631},{4,140231},{5,65214},{6,65214},{7,36704},{8,36704}]',17391,4294967295,0),(30010101,1,70,'[{1,25},{2,10026}]',25,10026,45821),(30010101,71,119,'[{1,26},{2,10026}]',26,10026,45821),(30010101,120,149,'[{1,27},{2,16548}]',27,16548,50000),(30010101,150,169,'[{1,28},{2,17830}]',28,17830,50000),(30010101,170,190,'[{1,27},{2,25969}]',27,25969,52000),(30010101,191,230,'[{1,27},{2,32463}]',27,32463,72359),(30010101,231,240,'[{1,28},{2,65756}]',28,65756,83934),(30010101,241,250,'[{1,29},{2,87877}]',29,87877,98484),(30010101,251,260,'[{1,30},{2,109904}]',30,109904,102454),(30010101,261,270,'[{1,31},{2,126612}]',31,126612,106583),(30010101,271,280,'[{1,32},{2,143481}]',32,143481,111642),(30010101,281,290,'[{1,33},{2,160479}]',33,160479,110923),(30010101,291,300,'[{1,34},{2,177574}]',34,177574,116918),(30010101,301,310,'[{1,35},{2,196005}]',35,196005,119303),(30010101,311,320,'[{1,36},{2,225864}]',36,225864,118360),(30010101,321,330,'[{1,37},{2,255766}]',37,255766,125927),(30010101,331,340,'[{1,38},{2,285682}]',38,285682,133511),(30010101,341,350,'[{1,39},{2,315590}]',39,315590,134057),(30010101,351,360,'[{1,40},{2,347540}]',40,347540,144010),(30010101,361,370,'[{1,41},{2,398543}]',41,398543,153576),(30010101,371,380,'[{1,42},{2,449961}]',42,449961,232698),(30010101,381,390,'[{1,43},{2,501646}]',43,501646,292809),(30010101,391,400,'[{1,44},{2,553516}]',44,553516,324819),(30010101,401,410,'[{1,45},{2,604284}]',45,604284,356830),(30010101,411,420,'[{1,46},{2,644049}]',46,644049,388841),(30010101,421,430,'[{1,47},{2,683763}]',47,683763,420852),(30010101,431,440,'[{1,48},{2,723414}]',48,723414,452863),(30010101,441,450,'[{1,49},{2,762991}]',49,762991,482496),(30010101,451,460,'[{1,50},{2,804914}]',50,804914,562810),(30010101,461,470,'[{1,51},{2,868651}]',51,868651,616885),(30010101,471,480,'[{1,52},{2,932382}]',52,932382,673361),(30010101,481,490,'[{1,53},{2,996081}]',53,996081,697369),(30010101,491,500,'[{1,54},{2,1059725}]',54,1059725,721377),(30010101,501,510,'[{1,55},{2,1124734}]',55,1124734,745385),(30010101,511,520,'[{1,56},{2,1202527}]',56,1202527,769393),(30010101,521,530,'[{1,57},{2,1280120}]',57,1280120,855759),(30010101,531,540,'[{1,58},{2,1357516}]',58,1357516,917066),(30010101,541,550,'[{1,59},{2,1434718}]',59,1434718,1116338),(30010101,551,560,'[{1,60},{2,1511787}]',60,1511787,1239178),(30010101,561,570,'[{1,61},{2,1589266}]',61,1589266,1368419),(30010101,571,580,'[{1,62},{2,1666644}]',62,1666644,1432441),(30010101,581,590,'[{1,63},{2,1743909}]',63,1743909,1496463),(30010101,591,600,'[{1,64},{2,1821053}]',64,1821053,1560484),(30010101,601,610,'[{1,65},{2,1899339}]',65,1899339,1624506),(30010101,611,620,'[{1,66},{2,1988903}]',66,1988903,1688528),(30010101,621,630,'[{1,67},{2,2078290}]',67,2078290,1752550),(30010101,631,640,'[{1,68},{2,2167498}]',68,2167498,1816571),(30010101,641,650,'[{1,69},{2,2256525}]',69,2256525,1880593),(30010101,651,660,'[{1,70},{2,2347064}]',70,2347064,1944615),(30010101,661,670,'[{1,71},{2,2452693}]',71,2452693,2008637),(30010101,671,680,'[{1,72},{2,2558165}]',72,2558165,2072658),(30010101,681,690,'[{1,73},{2,2663473}]',73,2663473,2136680),(30010101,691,700,'[{1,74},{2,2768609}]',74,2768609,2200702),(30010101,701,710,'[{1,75},{2,2872319}]',75,2872319,2264724),(30010101,711,720,'[{1,76},{2,2964599}]',76,2964599,2328745),(30010101,721,730,'[{1,77},{2,3056676}]',77,3056676,2392767),(30010101,731,740,'[{1,78},{2,3148550}]',78,3148550,2456789),(30010101,741,750,'[{1,79},{2,3240220}]',79,3240220,2520811),(30010101,751,760,'[{1,80},{2,3333195}]',80,3333195,2584832),(30010101,761,770,'[{1,81},{2,3439535}]',81,3439535,2648854),(30010101,771,780,'[{1,82},{2,3545648}]',82,3545648,2712876),(30010101,781,790,'[{1,83},{2,3651536}]',83,3651536,2776897),(30010101,791,800,'[{1,83},{2,3757200}]',83,3757200,2840919),(30010101,801,1000,'[{1,83},{2,3850746}]',83,3850746,2840919),(30010102,1,70,'[{1,25},{2,10026}]',25,10026,45821),(30010102,71,119,'[{1,26},{2,10026}]',26,10026,45821),(30010102,120,149,'[{1,27},{2,16548}]',27,16548,50000),(30010102,150,169,'[{1,28},{2,17830}]',28,17830,50000),(30010102,170,190,'[{1,27},{2,25969}]',27,25969,52000),(30010102,191,230,'[{1,27},{2,32463}]',27,32463,72359),(30010102,231,240,'[{1,28},{2,65756}]',28,65756,83934),(30010102,241,250,'[{1,29},{2,87877}]',29,87877,98484),(30010102,251,260,'[{1,30},{2,109904}]',30,109904,102454),(30010102,261,270,'[{1,31},{2,126612}]',31,126612,106583),(30010102,271,280,'[{1,32},{2,143481}]',32,143481,111642),(30010102,281,290,'[{1,33},{2,160479}]',33,160479,110923),(30010102,291,300,'[{1,34},{2,177574}]',34,177574,116918),(30010102,301,310,'[{1,35},{2,196005}]',35,196005,119303),(30010102,311,320,'[{1,36},{2,225864}]',36,225864,118360),(30010102,321,330,'[{1,37},{2,255766}]',37,255766,125927),(30010102,331,340,'[{1,38},{2,285682}]',38,285682,133511),(30010102,341,350,'[{1,39},{2,315590}]',39,315590,134057),(30010102,351,360,'[{1,40},{2,347540}]',40,347540,144010),(30010102,361,370,'[{1,41},{2,398543}]',41,398543,153576),(30010102,371,380,'[{1,42},{2,449961}]',42,449961,232698),(30010102,381,390,'[{1,43},{2,501646}]',43,501646,292809),(30010102,391,400,'[{1,44},{2,553516}]',44,553516,324819),(30010102,401,410,'[{1,45},{2,604284}]',45,604284,356830),(30010102,411,420,'[{1,46},{2,644049}]',46,644049,388841),(30010102,421,430,'[{1,47},{2,683763}]',47,683763,420852),(30010102,431,440,'[{1,48},{2,723414}]',48,723414,452863),(30010102,441,450,'[{1,49},{2,762991}]',49,762991,482496),(30010102,451,460,'[{1,50},{2,804914}]',50,804914,562810),(30010102,461,470,'[{1,51},{2,868651}]',51,868651,616885),(30010102,471,480,'[{1,52},{2,932382}]',52,932382,673361),(30010102,481,490,'[{1,53},{2,996081}]',53,996081,697369),(30010102,491,500,'[{1,54},{2,1059725}]',54,1059725,721377),(30010102,501,510,'[{1,55},{2,1124734}]',55,1124734,745385),(30010102,511,520,'[{1,56},{2,1202527}]',56,1202527,769393),(30010102,521,530,'[{1,57},{2,1280120}]',57,1280120,855759),(30010102,531,540,'[{1,58},{2,1357516}]',58,1357516,917066),(30010102,541,550,'[{1,59},{2,1434718}]',59,1434718,1116338),(30010102,551,560,'[{1,60},{2,1511787}]',60,1511787,1239178),(30010102,561,570,'[{1,61},{2,1589266}]',61,1589266,1368419),(30010102,571,580,'[{1,62},{2,1666644}]',62,1666644,1432441),(30010102,581,590,'[{1,63},{2,1743909}]',63,1743909,1496463),(30010102,591,600,'[{1,64},{2,1821053}]',64,1821053,1560484),(30010102,601,610,'[{1,65},{2,1899339}]',65,1899339,1624506),(30010102,611,620,'[{1,66},{2,1988903}]',66,1988903,1688528),(30010102,621,630,'[{1,67},{2,2078290}]',67,2078290,1752550),(30010102,631,640,'[{1,68},{2,2167498}]',68,2167498,1816571),(30010102,641,650,'[{1,69},{2,2256525}]',69,2256525,1880593),(30010102,651,660,'[{1,70},{2,2347064}]',70,2347064,1944615),(30010102,661,670,'[{1,71},{2,2452693}]',71,2452693,2008637),(30010102,671,680,'[{1,72},{2,2558165}]',72,2558165,2072658),(30010102,681,690,'[{1,73},{2,2663473}]',73,2663473,2136680),(30010102,691,700,'[{1,74},{2,2768609}]',74,2768609,2200702),(30010102,701,710,'[{1,75},{2,2872319}]',75,2872319,2264724),(30010102,711,720,'[{1,76},{2,2964599}]',76,2964599,2328745),(30010102,721,730,'[{1,77},{2,3056676}]',77,3056676,2392767),(30010102,731,740,'[{1,78},{2,3148550}]',78,3148550,2456789),(30010102,741,750,'[{1,79},{2,3240220}]',79,3240220,2520811),(30010102,751,760,'[{1,80},{2,3333195}]',80,3333195,2584832),(30010102,761,770,'[{1,81},{2,3439535}]',81,3439535,2648854),(30010102,771,780,'[{1,82},{2,3545648}]',82,3545648,2712876),(30010102,781,790,'[{1,83},{2,3651536}]',83,3651536,2776897),(30010102,791,800,'[{1,83},{2,3757200}]',83,3757200,2840919),(30010102,801,1000,'[{1,83},{2,3850746}]',83,3850746,2840919),(30010103,1,70,'[{1,25},{2,10026}]',25,10026,45821),(30010103,71,119,'[{1,26},{2,10026}]',26,10026,45821),(30010103,120,149,'[{1,27},{2,16548}]',27,16548,50000),(30010103,150,169,'[{1,28},{2,17830}]',28,17830,50000),(30010103,170,190,'[{1,27},{2,25969}]',27,25969,52000),(30010103,191,230,'[{1,27},{2,32463}]',27,32463,72359),(30010103,231,240,'[{1,28},{2,65756}]',28,65756,83934),(30010103,241,250,'[{1,29},{2,87877}]',29,87877,98484),(30010103,251,260,'[{1,30},{2,109904}]',30,109904,102454),(30010103,261,270,'[{1,31},{2,126612}]',31,126612,106583),(30010103,271,280,'[{1,32},{2,143481}]',32,143481,111642),(30010103,281,290,'[{1,33},{2,160479}]',33,160479,110923),(30010103,291,300,'[{1,34},{2,177574}]',34,177574,116918),(30010103,301,310,'[{1,35},{2,196005}]',35,196005,119303),(30010103,311,320,'[{1,36},{2,225864}]',36,225864,118360),(30010103,321,330,'[{1,37},{2,255766}]',37,255766,125927),(30010103,331,340,'[{1,38},{2,285682}]',38,285682,133511),(30010103,341,350,'[{1,39},{2,315590}]',39,315590,134057),(30010103,351,360,'[{1,40},{2,347540}]',40,347540,144010),(30010103,361,370,'[{1,41},{2,398543}]',41,398543,153576),(30010103,371,380,'[{1,42},{2,449961}]',42,449961,232698),(30010103,381,390,'[{1,43},{2,501646}]',43,501646,292809),(30010103,391,400,'[{1,44},{2,553516}]',44,553516,324819),(30010103,401,410,'[{1,45},{2,604284}]',45,604284,356830),(30010103,411,420,'[{1,46},{2,644049}]',46,644049,388841),(30010103,421,430,'[{1,47},{2,683763}]',47,683763,420852),(30010103,431,440,'[{1,48},{2,723414}]',48,723414,452863),(30010103,441,450,'[{1,49},{2,762991}]',49,762991,482496),(30010103,451,460,'[{1,50},{2,804914}]',50,804914,562810),(30010103,461,470,'[{1,51},{2,868651}]',51,868651,616885),(30010103,471,480,'[{1,52},{2,932382}]',52,932382,673361),(30010103,481,490,'[{1,53},{2,996081}]',53,996081,697369),(30010103,491,500,'[{1,54},{2,1059725}]',54,1059725,721377),(30010103,501,510,'[{1,55},{2,1124734}]',55,1124734,745385),(30010103,511,520,'[{1,56},{2,1202527}]',56,1202527,769393),(30010103,521,530,'[{1,57},{2,1280120}]',57,1280120,855759),(30010103,531,540,'[{1,58},{2,1357516}]',58,1357516,917066),(30010103,541,550,'[{1,59},{2,1434718}]',59,1434718,1116338),(30010103,551,560,'[{1,60},{2,1511787}]',60,1511787,1239178),(30010103,561,570,'[{1,61},{2,1589266}]',61,1589266,1368419),(30010103,571,580,'[{1,62},{2,1666644}]',62,1666644,1432441),(30010103,581,590,'[{1,63},{2,1743909}]',63,1743909,1496463),(30010103,591,600,'[{1,64},{2,1821053}]',64,1821053,1560484),(30010103,601,610,'[{1,65},{2,1899339}]',65,1899339,1624506),(30010103,611,620,'[{1,66},{2,1988903}]',66,1988903,1688528),(30010103,621,630,'[{1,67},{2,2078290}]',67,2078290,1752550),(30010103,631,640,'[{1,68},{2,2167498}]',68,2167498,1816571),(30010103,641,650,'[{1,69},{2,2256525}]',69,2256525,1880593),(30010103,651,660,'[{1,70},{2,2347064}]',70,2347064,1944615),(30010103,661,670,'[{1,71},{2,2452693}]',71,2452693,2008637),(30010103,671,680,'[{1,72},{2,2558165}]',72,2558165,2072658),(30010103,681,690,'[{1,73},{2,2663473}]',73,2663473,2136680),(30010103,691,700,'[{1,74},{2,2768609}]',74,2768609,2200702),(30010103,701,710,'[{1,75},{2,2872319}]',75,2872319,2264724),(30010103,711,720,'[{1,76},{2,2964599}]',76,2964599,2328745),(30010103,721,730,'[{1,77},{2,3056676}]',77,3056676,2392767),(30010103,731,740,'[{1,78},{2,3148550}]',78,3148550,2456789),(30010103,741,750,'[{1,79},{2,3240220}]',79,3240220,2520811),(30010103,751,760,'[{1,80},{2,3333195}]',80,3333195,2584832),(30010103,761,770,'[{1,81},{2,3439535}]',81,3439535,2648854),(30010103,771,780,'[{1,82},{2,3545648}]',82,3545648,2712876),(30010103,781,790,'[{1,83},{2,3651536}]',83,3651536,2776897),(30010103,791,800,'[{1,83},{2,3757200}]',83,3757200,2840919),(30010103,801,1000,'[{1,83},{2,3850746}]',83,3850746,2840919),(30010104,1,70,'[{1,25},{2,10026}]',25,10026,45821),(30010104,71,119,'[{1,26},{2,10026}]',26,10026,45821),(30010104,120,149,'[{1,27},{2,16548}]',27,16548,50000),(30010104,150,169,'[{1,28},{2,17830}]',28,17830,50000),(30010104,170,190,'[{1,27},{2,25969}]',27,25969,52000),(30010104,191,230,'[{1,27},{2,32463}]',27,32463,72359),(30010104,231,240,'[{1,28},{2,65756}]',28,65756,83934),(30010104,241,250,'[{1,29},{2,87877}]',29,87877,98484),(30010104,251,260,'[{1,30},{2,109904}]',30,109904,102454),(30010104,261,270,'[{1,31},{2,126612}]',31,126612,106583),(30010104,271,280,'[{1,32},{2,143481}]',32,143481,111642),(30010104,281,290,'[{1,33},{2,160479}]',33,160479,110923),(30010104,291,300,'[{1,34},{2,177574}]',34,177574,116918),(30010104,301,310,'[{1,35},{2,196005}]',35,196005,119303),(30010104,311,320,'[{1,36},{2,225864}]',36,225864,118360),(30010104,321,330,'[{1,37},{2,255766}]',37,255766,125927),(30010104,331,340,'[{1,38},{2,285682}]',38,285682,133511),(30010104,341,350,'[{1,39},{2,315590}]',39,315590,134057),(30010104,351,360,'[{1,40},{2,347540}]',40,347540,144010),(30010104,361,370,'[{1,41},{2,398543}]',41,398543,153576),(30010104,371,380,'[{1,42},{2,449961}]',42,449961,232698),(30010104,381,390,'[{1,43},{2,501646}]',43,501646,292809),(30010104,391,400,'[{1,44},{2,553516}]',44,553516,324819),(30010104,401,410,'[{1,45},{2,604284}]',45,604284,356830),(30010104,411,420,'[{1,46},{2,644049}]',46,644049,388841),(30010104,421,430,'[{1,47},{2,683763}]',47,683763,420852),(30010104,431,440,'[{1,48},{2,723414}]',48,723414,452863),(30010104,441,450,'[{1,49},{2,762991}]',49,762991,482496),(30010104,451,460,'[{1,50},{2,804914}]',50,804914,562810),(30010104,461,470,'[{1,51},{2,868651}]',51,868651,616885),(30010104,471,480,'[{1,52},{2,932382}]',52,932382,673361),(30010104,481,490,'[{1,53},{2,996081}]',53,996081,697369),(30010104,491,500,'[{1,54},{2,1059725}]',54,1059725,721377),(30010104,501,510,'[{1,55},{2,1124734}]',55,1124734,745385),(30010104,511,520,'[{1,56},{2,1202527}]',56,1202527,769393),(30010104,521,530,'[{1,57},{2,1280120}]',57,1280120,855759),(30010104,531,540,'[{1,58},{2,1357516}]',58,1357516,917066),(30010104,541,550,'[{1,59},{2,1434718}]',59,1434718,1116338),(30010104,551,560,'[{1,60},{2,1511787}]',60,1511787,1239178),(30010104,561,570,'[{1,61},{2,1589266}]',61,1589266,1368419),(30010104,571,580,'[{1,62},{2,1666644}]',62,1666644,1432441),(30010104,581,590,'[{1,63},{2,1743909}]',63,1743909,1496463),(30010104,591,600,'[{1,64},{2,1821053}]',64,1821053,1560484),(30010104,601,610,'[{1,65},{2,1899339}]',65,1899339,1624506),(30010104,611,620,'[{1,66},{2,1988903}]',66,1988903,1688528),(30010104,621,630,'[{1,67},{2,2078290}]',67,2078290,1752550),(30010104,631,640,'[{1,68},{2,2167498}]',68,2167498,1816571),(30010104,641,650,'[{1,69},{2,2256525}]',69,2256525,1880593),(30010104,651,660,'[{1,70},{2,2347064}]',70,2347064,1944615),(30010104,661,670,'[{1,71},{2,2452693}]',71,2452693,2008637),(30010104,671,680,'[{1,72},{2,2558165}]',72,2558165,2072658),(30010104,681,690,'[{1,73},{2,2663473}]',73,2663473,2136680),(30010104,691,700,'[{1,74},{2,2768609}]',74,2768609,2200702),(30010104,701,710,'[{1,75},{2,2872319}]',75,2872319,2264724),(30010104,711,720,'[{1,76},{2,2964599}]',76,2964599,2328745),(30010104,721,730,'[{1,77},{2,3056676}]',77,3056676,2392767),(30010104,731,740,'[{1,78},{2,3148550}]',78,3148550,2456789),(30010104,741,750,'[{1,79},{2,3240220}]',79,3240220,2520811),(30010104,751,760,'[{1,80},{2,3333195}]',80,3333195,2584832),(30010104,761,770,'[{1,81},{2,3439535}]',81,3439535,2648854),(30010104,771,780,'[{1,82},{2,3545648}]',82,3545648,2712876),(30010104,781,790,'[{1,83},{2,3651536}]',83,3651536,2776897),(30010104,791,800,'[{1,83},{2,3757200}]',83,3757200,2840919),(30010104,801,1000,'[{1,83},{2,3850746}]',83,3850746,2840919),(30010105,1,70,'[{1,25},{2,10026}]',25,10026,45821),(30010105,71,119,'[{1,26},{2,10026}]',26,10026,45821),(30010105,120,149,'[{1,27},{2,16548}]',27,16548,50000),(30010105,150,169,'[{1,28},{2,17830}]',28,17830,50000),(30010105,170,190,'[{1,27},{2,25969}]',27,25969,52000),(30010105,191,230,'[{1,27},{2,32463}]',27,32463,72359),(30010105,231,240,'[{1,28},{2,65756}]',28,65756,83934),(30010105,241,250,'[{1,29},{2,87877}]',29,87877,98484),(30010105,251,260,'[{1,30},{2,109904}]',30,109904,102454),(30010105,261,270,'[{1,31},{2,126612}]',31,126612,106583),(30010105,271,280,'[{1,32},{2,143481}]',32,143481,111642),(30010105,281,290,'[{1,33},{2,160479}]',33,160479,110923),(30010105,291,300,'[{1,34},{2,177574}]',34,177574,116918),(30010105,301,310,'[{1,35},{2,196005}]',35,196005,119303),(30010105,311,320,'[{1,36},{2,225864}]',36,225864,118360),(30010105,321,330,'[{1,37},{2,255766}]',37,255766,125927),(30010105,331,340,'[{1,38},{2,285682}]',38,285682,133511),(30010105,341,350,'[{1,39},{2,315590}]',39,315590,134057),(30010105,351,360,'[{1,40},{2,347540}]',40,347540,144010),(30010105,361,370,'[{1,41},{2,398543}]',41,398543,153576),(30010105,371,380,'[{1,42},{2,449961}]',42,449961,232698),(30010105,381,390,'[{1,43},{2,501646}]',43,501646,292809),(30010105,391,400,'[{1,44},{2,553516}]',44,553516,324819),(30010105,401,410,'[{1,45},{2,604284}]',45,604284,356830),(30010105,411,420,'[{1,46},{2,644049}]',46,644049,388841),(30010105,421,430,'[{1,47},{2,683763}]',47,683763,420852),(30010105,431,440,'[{1,48},{2,723414}]',48,723414,452863),(30010105,441,450,'[{1,49},{2,762991}]',49,762991,482496),(30010105,451,460,'[{1,50},{2,804914}]',50,804914,562810),(30010105,461,470,'[{1,51},{2,868651}]',51,868651,616885),(30010105,471,480,'[{1,52},{2,932382}]',52,932382,673361),(30010105,481,490,'[{1,53},{2,996081}]',53,996081,697369),(30010105,491,500,'[{1,54},{2,1059725}]',54,1059725,721377),(30010105,501,510,'[{1,55},{2,1124734}]',55,1124734,745385),(30010105,511,520,'[{1,56},{2,1202527}]',56,1202527,769393),(30010105,521,530,'[{1,57},{2,1280120}]',57,1280120,855759),(30010105,531,540,'[{1,58},{2,1357516}]',58,1357516,917066),(30010105,541,550,'[{1,59},{2,1434718}]',59,1434718,1116338),(30010105,551,560,'[{1,60},{2,1511787}]',60,1511787,1239178),(30010105,561,570,'[{1,61},{2,1589266}]',61,1589266,1368419),(30010105,571,580,'[{1,62},{2,1666644}]',62,1666644,1432441),(30010105,581,590,'[{1,63},{2,1743909}]',63,1743909,1496463),(30010105,591,600,'[{1,64},{2,1821053}]',64,1821053,1560484),(30010105,601,610,'[{1,65},{2,1899339}]',65,1899339,1624506),(30010105,611,620,'[{1,66},{2,1988903}]',66,1988903,1688528),(30010105,621,630,'[{1,67},{2,2078290}]',67,2078290,1752550),(30010105,631,640,'[{1,68},{2,2167498}]',68,2167498,1816571),(30010105,641,650,'[{1,69},{2,2256525}]',69,2256525,1880593),(30010105,651,660,'[{1,70},{2,2347064}]',70,2347064,1944615),(30010105,661,670,'[{1,71},{2,2452693}]',71,2452693,2008637),(30010105,671,680,'[{1,72},{2,2558165}]',72,2558165,2072658),(30010105,681,690,'[{1,73},{2,2663473}]',73,2663473,2136680),(30010105,691,700,'[{1,74},{2,2768609}]',74,2768609,2200702),(30010105,701,710,'[{1,75},{2,2872319}]',75,2872319,2264724),(30010105,711,720,'[{1,76},{2,2964599}]',76,2964599,2328745),(30010105,721,730,'[{1,77},{2,3056676}]',77,3056676,2392767),(30010105,731,740,'[{1,78},{2,3148550}]',78,3148550,2456789),(30010105,741,750,'[{1,79},{2,3240220}]',79,3240220,2520811),(30010105,751,760,'[{1,80},{2,3333195}]',80,3333195,2584832),(30010105,761,770,'[{1,81},{2,3439535}]',81,3439535,2648854),(30010105,771,780,'[{1,82},{2,3545648}]',82,3545648,2712876),(30010105,781,790,'[{1,83},{2,3651536}]',83,3651536,2776897),(30010105,791,800,'[{1,83},{2,3757200}]',83,3757200,2840919),(30010105,801,1000,'[{1,83},{2,3850746}]',83,3850746,2840919),(30010106,1,70,'[{1,25},{2,10026}]',25,10026,45821),(30010106,71,119,'[{1,26},{2,10026}]',26,10026,45821),(30010106,120,149,'[{1,27},{2,16548}]',27,16548,50000),(30010106,150,169,'[{1,28},{2,17830}]',28,17830,50000),(30010106,170,190,'[{1,27},{2,25969}]',27,25969,52000),(30010106,191,230,'[{1,27},{2,32463}]',27,32463,72359),(30010106,231,240,'[{1,28},{2,65756}]',28,65756,83934),(30010106,241,250,'[{1,29},{2,87877}]',29,87877,98484),(30010106,251,260,'[{1,30},{2,109904}]',30,109904,102454),(30010106,261,270,'[{1,31},{2,126612}]',31,126612,106583),(30010106,271,280,'[{1,32},{2,143481}]',32,143481,111642),(30010106,281,290,'[{1,33},{2,160479}]',33,160479,110923),(30010106,291,300,'[{1,34},{2,177574}]',34,177574,116918),(30010106,301,310,'[{1,35},{2,196005}]',35,196005,119303),(30010106,311,320,'[{1,36},{2,225864}]',36,225864,118360),(30010106,321,330,'[{1,37},{2,255766}]',37,255766,125927),(30010106,331,340,'[{1,38},{2,285682}]',38,285682,133511),(30010106,341,350,'[{1,39},{2,315590}]',39,315590,134057),(30010106,351,360,'[{1,40},{2,347540}]',40,347540,144010),(30010106,361,370,'[{1,41},{2,398543}]',41,398543,153576),(30010106,371,380,'[{1,42},{2,449961}]',42,449961,232698),(30010106,381,390,'[{1,43},{2,501646}]',43,501646,292809),(30010106,391,400,'[{1,44},{2,553516}]',44,553516,324819),(30010106,401,410,'[{1,45},{2,604284}]',45,604284,356830),(30010106,411,420,'[{1,46},{2,644049}]',46,644049,388841),(30010106,421,430,'[{1,47},{2,683763}]',47,683763,420852),(30010106,431,440,'[{1,48},{2,723414}]',48,723414,452863),(30010106,441,450,'[{1,49},{2,762991}]',49,762991,482496),(30010106,451,460,'[{1,50},{2,804914}]',50,804914,562810),(30010106,461,470,'[{1,51},{2,868651}]',51,868651,616885),(30010106,471,480,'[{1,52},{2,932382}]',52,932382,673361),(30010106,481,490,'[{1,53},{2,996081}]',53,996081,697369),(30010106,491,500,'[{1,54},{2,1059725}]',54,1059725,721377),(30010106,501,510,'[{1,55},{2,1124734}]',55,1124734,745385),(30010106,511,520,'[{1,56},{2,1202527}]',56,1202527,769393),(30010106,521,530,'[{1,57},{2,1280120}]',57,1280120,855759),(30010106,531,540,'[{1,58},{2,1357516}]',58,1357516,917066),(30010106,541,550,'[{1,59},{2,1434718}]',59,1434718,1116338),(30010106,551,560,'[{1,60},{2,1511787}]',60,1511787,1239178),(30010106,561,570,'[{1,61},{2,1589266}]',61,1589266,1368419),(30010106,571,580,'[{1,62},{2,1666644}]',62,1666644,1432441),(30010106,581,590,'[{1,63},{2,1743909}]',63,1743909,1496463),(30010106,591,600,'[{1,64},{2,1821053}]',64,1821053,1560484),(30010106,601,610,'[{1,65},{2,1899339}]',65,1899339,1624506),(30010106,611,620,'[{1,66},{2,1988903}]',66,1988903,1688528),(30010106,621,630,'[{1,67},{2,2078290}]',67,2078290,1752550),(30010106,631,640,'[{1,68},{2,2167498}]',68,2167498,1816571),(30010106,641,650,'[{1,69},{2,2256525}]',69,2256525,1880593),(30010106,651,660,'[{1,70},{2,2347064}]',70,2347064,1944615),(30010106,661,670,'[{1,71},{2,2452693}]',71,2452693,2008637),(30010106,671,680,'[{1,72},{2,2558165}]',72,2558165,2072658),(30010106,681,690,'[{1,73},{2,2663473}]',73,2663473,2136680),(30010106,691,700,'[{1,74},{2,2768609}]',74,2768609,2200702),(30010106,701,710,'[{1,75},{2,2872319}]',75,2872319,2264724),(30010106,711,720,'[{1,76},{2,2964599}]',76,2964599,2328745),(30010106,721,730,'[{1,77},{2,3056676}]',77,3056676,2392767),(30010106,731,740,'[{1,78},{2,3148550}]',78,3148550,2456789),(30010106,741,750,'[{1,79},{2,3240220}]',79,3240220,2520811),(30010106,751,760,'[{1,80},{2,3333195}]',80,3333195,2584832),(30010106,761,770,'[{1,81},{2,3439535}]',81,3439535,2648854),(30010106,771,780,'[{1,82},{2,3545648}]',82,3545648,2712876),(30010106,781,790,'[{1,83},{2,3651536}]',83,3651536,2776897),(30010106,791,800,'[{1,83},{2,3757200}]',83,3757200,2840919),(30010106,801,1000,'[{1,83},{2,3850746}]',83,3850746,2840919),(30010107,1,70,'[{1,25},{2,10026}]',25,10026,45821),(30010107,71,119,'[{1,26},{2,10026}]',26,10026,45821),(30010107,120,149,'[{1,27},{2,16548}]',27,16548,50000),(30010107,150,169,'[{1,28},{2,17830}]',28,17830,50000),(30010107,170,190,'[{1,27},{2,25969}]',27,25969,52000),(30010107,191,230,'[{1,27},{2,32463}]',27,32463,72359),(30010107,231,240,'[{1,28},{2,65756}]',28,65756,83934),(30010107,241,250,'[{1,29},{2,87877}]',29,87877,98484),(30010107,251,260,'[{1,30},{2,109904}]',30,109904,102454),(30010107,261,270,'[{1,31},{2,126612}]',31,126612,106583),(30010107,271,280,'[{1,32},{2,143481}]',32,143481,111642),(30010107,281,290,'[{1,33},{2,160479}]',33,160479,110923),(30010107,291,300,'[{1,34},{2,177574}]',34,177574,116918),(30010107,301,310,'[{1,35},{2,196005}]',35,196005,119303),(30010107,311,320,'[{1,36},{2,225864}]',36,225864,118360),(30010107,321,330,'[{1,37},{2,255766}]',37,255766,125927),(30010107,331,340,'[{1,38},{2,285682}]',38,285682,133511),(30010107,341,350,'[{1,39},{2,315590}]',39,315590,134057),(30010107,351,360,'[{1,40},{2,347540}]',40,347540,144010),(30010107,361,370,'[{1,41},{2,398543}]',41,398543,153576),(30010107,371,380,'[{1,42},{2,449961}]',42,449961,232698),(30010107,381,390,'[{1,43},{2,501646}]',43,501646,292809),(30010107,391,400,'[{1,44},{2,553516}]',44,553516,324819),(30010107,401,410,'[{1,45},{2,604284}]',45,604284,356830),(30010107,411,420,'[{1,46},{2,644049}]',46,644049,388841),(30010107,421,430,'[{1,47},{2,683763}]',47,683763,420852),(30010107,431,440,'[{1,48},{2,723414}]',48,723414,452863),(30010107,441,450,'[{1,49},{2,762991}]',49,762991,482496),(30010107,451,460,'[{1,50},{2,804914}]',50,804914,562810),(30010107,461,470,'[{1,51},{2,868651}]',51,868651,616885),(30010107,471,480,'[{1,52},{2,932382}]',52,932382,673361),(30010107,481,490,'[{1,53},{2,996081}]',53,996081,697369),(30010107,491,500,'[{1,54},{2,1059725}]',54,1059725,721377),(30010107,501,510,'[{1,55},{2,1124734}]',55,1124734,745385),(30010107,511,520,'[{1,56},{2,1202527}]',56,1202527,769393),(30010107,521,530,'[{1,57},{2,1280120}]',57,1280120,855759),(30010107,531,540,'[{1,58},{2,1357516}]',58,1357516,917066),(30010107,541,550,'[{1,59},{2,1434718}]',59,1434718,1116338),(30010107,551,560,'[{1,60},{2,1511787}]',60,1511787,1239178),(30010107,561,570,'[{1,61},{2,1589266}]',61,1589266,1368419),(30010107,571,580,'[{1,62},{2,1666644}]',62,1666644,1432441),(30010107,581,590,'[{1,63},{2,1743909}]',63,1743909,1496463),(30010107,591,600,'[{1,64},{2,1821053}]',64,1821053,1560484),(30010107,601,610,'[{1,65},{2,1899339}]',65,1899339,1624506),(30010107,611,620,'[{1,66},{2,1988903}]',66,1988903,1688528),(30010107,621,630,'[{1,67},{2,2078290}]',67,2078290,1752550),(30010107,631,640,'[{1,68},{2,2167498}]',68,2167498,1816571),(30010107,641,650,'[{1,69},{2,2256525}]',69,2256525,1880593),(30010107,651,660,'[{1,70},{2,2347064}]',70,2347064,1944615),(30010107,661,670,'[{1,71},{2,2452693}]',71,2452693,2008637),(30010107,671,680,'[{1,72},{2,2558165}]',72,2558165,2072658),(30010107,681,690,'[{1,73},{2,2663473}]',73,2663473,2136680),(30010107,691,700,'[{1,74},{2,2768609}]',74,2768609,2200702),(30010107,701,710,'[{1,75},{2,2872319}]',75,2872319,2264724),(30010107,711,720,'[{1,76},{2,2964599}]',76,2964599,2328745),(30010107,721,730,'[{1,77},{2,3056676}]',77,3056676,2392767),(30010107,731,740,'[{1,78},{2,3148550}]',78,3148550,2456789),(30010107,741,750,'[{1,79},{2,3240220}]',79,3240220,2520811),(30010107,751,760,'[{1,80},{2,3333195}]',80,3333195,2584832),(30010107,761,770,'[{1,81},{2,3439535}]',81,3439535,2648854),(30010107,771,780,'[{1,82},{2,3545648}]',82,3545648,2712876),(30010107,781,790,'[{1,83},{2,3651536}]',83,3651536,2776897),(30010107,791,800,'[{1,83},{2,3757200}]',83,3757200,2840919),(30010107,801,1000,'[{1,83},{2,3850746}]',83,3850746,2840919),(30010108,1,70,'[{1,25},{2,10026}]',25,10026,45821),(30010108,71,119,'[{1,26},{2,10026}]',26,10026,45821),(30010108,120,149,'[{1,27},{2,16548}]',27,16548,50000),(30010108,150,169,'[{1,28},{2,17830}]',28,17830,50000),(30010108,170,190,'[{1,27},{2,25969}]',27,25969,52000),(30010108,191,230,'[{1,27},{2,32463}]',27,32463,72359),(30010108,231,240,'[{1,28},{2,65756}]',28,65756,83934),(30010108,241,250,'[{1,29},{2,87877}]',29,87877,98484),(30010108,251,260,'[{1,30},{2,109904}]',30,109904,102454),(30010108,261,270,'[{1,31},{2,126612}]',31,126612,106583),(30010108,271,280,'[{1,32},{2,143481}]',32,143481,111642),(30010108,281,290,'[{1,33},{2,160479}]',33,160479,110923),(30010108,291,300,'[{1,34},{2,177574}]',34,177574,116918),(30010108,301,310,'[{1,35},{2,196005}]',35,196005,119303),(30010108,311,320,'[{1,36},{2,225864}]',36,225864,118360),(30010108,321,330,'[{1,37},{2,255766}]',37,255766,125927),(30010108,331,340,'[{1,38},{2,285682}]',38,285682,133511),(30010108,341,350,'[{1,39},{2,315590}]',39,315590,134057),(30010108,351,360,'[{1,40},{2,347540}]',40,347540,144010),(30010108,361,370,'[{1,41},{2,398543}]',41,398543,153576),(30010108,371,380,'[{1,42},{2,449961}]',42,449961,232698),(30010108,381,390,'[{1,43},{2,501646}]',43,501646,292809),(30010108,391,400,'[{1,44},{2,553516}]',44,553516,324819),(30010108,401,410,'[{1,45},{2,604284}]',45,604284,356830),(30010108,411,420,'[{1,46},{2,644049}]',46,644049,388841),(30010108,421,430,'[{1,47},{2,683763}]',47,683763,420852),(30010108,431,440,'[{1,48},{2,723414}]',48,723414,452863),(30010108,441,450,'[{1,49},{2,762991}]',49,762991,482496),(30010108,451,460,'[{1,50},{2,804914}]',50,804914,562810),(30010108,461,470,'[{1,51},{2,868651}]',51,868651,616885),(30010108,471,480,'[{1,52},{2,932382}]',52,932382,673361),(30010108,481,490,'[{1,53},{2,996081}]',53,996081,697369),(30010108,491,500,'[{1,54},{2,1059725}]',54,1059725,721377),(30010108,501,510,'[{1,55},{2,1124734}]',55,1124734,745385),(30010108,511,520,'[{1,56},{2,1202527}]',56,1202527,769393),(30010108,521,530,'[{1,57},{2,1280120}]',57,1280120,855759),(30010108,531,540,'[{1,58},{2,1357516}]',58,1357516,917066),(30010108,541,550,'[{1,59},{2,1434718}]',59,1434718,1116338),(30010108,551,560,'[{1,60},{2,1511787}]',60,1511787,1239178),(30010108,561,570,'[{1,61},{2,1589266}]',61,1589266,1368419),(30010108,571,580,'[{1,62},{2,1666644}]',62,1666644,1432441),(30010108,581,590,'[{1,63},{2,1743909}]',63,1743909,1496463),(30010108,591,600,'[{1,64},{2,1821053}]',64,1821053,1560484),(30010108,601,610,'[{1,65},{2,1899339}]',65,1899339,1624506),(30010108,611,620,'[{1,66},{2,1988903}]',66,1988903,1688528),(30010108,621,630,'[{1,67},{2,2078290}]',67,2078290,1752550),(30010108,631,640,'[{1,68},{2,2167498}]',68,2167498,1816571),(30010108,641,650,'[{1,69},{2,2256525}]',69,2256525,1880593),(30010108,651,660,'[{1,70},{2,2347064}]',70,2347064,1944615),(30010108,661,670,'[{1,71},{2,2452693}]',71,2452693,2008637),(30010108,671,680,'[{1,72},{2,2558165}]',72,2558165,2072658),(30010108,681,690,'[{1,73},{2,2663473}]',73,2663473,2136680),(30010108,691,700,'[{1,74},{2,2768609}]',74,2768609,2200702),(30010108,701,710,'[{1,75},{2,2872319}]',75,2872319,2264724),(30010108,711,720,'[{1,76},{2,2964599}]',76,2964599,2328745),(30010108,721,730,'[{1,77},{2,3056676}]',77,3056676,2392767),(30010108,731,740,'[{1,78},{2,3148550}]',78,3148550,2456789),(30010108,741,750,'[{1,79},{2,3240220}]',79,3240220,2520811),(30010108,751,760,'[{1,80},{2,3333195}]',80,3333195,2584832),(30010108,761,770,'[{1,81},{2,3439535}]',81,3439535,2648854),(30010108,771,780,'[{1,82},{2,3545648}]',82,3545648,2712876),(30010108,781,790,'[{1,83},{2,3651536}]',83,3651536,2776897),(30010108,791,800,'[{1,83},{2,3757200}]',83,3757200,2840919),(30010108,801,1000,'[{1,83},{2,3850746}]',83,3850746,2840919),(30010109,1,70,'[{1,25},{2,10026}]',25,10026,45821),(30010109,71,119,'[{1,26},{2,10026}]',26,10026,45821),(30010109,120,149,'[{1,27},{2,16548}]',27,16548,50000),(30010109,150,169,'[{1,28},{2,17830}]',28,17830,50000),(30010109,170,190,'[{1,27},{2,25969}]',27,25969,52000),(30010109,191,230,'[{1,27},{2,32463}]',27,32463,72359),(30010109,231,240,'[{1,28},{2,65756}]',28,65756,83934),(30010109,241,250,'[{1,29},{2,87877}]',29,87877,98484),(30010109,251,260,'[{1,30},{2,109904}]',30,109904,102454),(30010109,261,270,'[{1,31},{2,126612}]',31,126612,106583),(30010109,271,280,'[{1,32},{2,143481}]',32,143481,111642),(30010109,281,290,'[{1,33},{2,160479}]',33,160479,110923),(30010109,291,300,'[{1,34},{2,177574}]',34,177574,116918),(30010109,301,310,'[{1,35},{2,196005}]',35,196005,119303),(30010109,311,320,'[{1,36},{2,225864}]',36,225864,118360),(30010109,321,330,'[{1,37},{2,255766}]',37,255766,125927),(30010109,331,340,'[{1,38},{2,285682}]',38,285682,133511),(30010109,341,350,'[{1,39},{2,315590}]',39,315590,134057),(30010109,351,360,'[{1,40},{2,347540}]',40,347540,144010),(30010109,361,370,'[{1,41},{2,398543}]',41,398543,153576),(30010109,371,380,'[{1,42},{2,449961}]',42,449961,232698),(30010109,381,390,'[{1,43},{2,501646}]',43,501646,292809),(30010109,391,400,'[{1,44},{2,553516}]',44,553516,324819),(30010109,401,410,'[{1,45},{2,604284}]',45,604284,356830),(30010109,411,420,'[{1,46},{2,644049}]',46,644049,388841),(30010109,421,430,'[{1,47},{2,683763}]',47,683763,420852),(30010109,431,440,'[{1,48},{2,723414}]',48,723414,452863),(30010109,441,450,'[{1,49},{2,762991}]',49,762991,482496),(30010109,451,460,'[{1,50},{2,804914}]',50,804914,562810),(30010109,461,470,'[{1,51},{2,868651}]',51,868651,616885),(30010109,471,480,'[{1,52},{2,932382}]',52,932382,673361),(30010109,481,490,'[{1,53},{2,996081}]',53,996081,697369),(30010109,491,500,'[{1,54},{2,1059725}]',54,1059725,721377),(30010109,501,510,'[{1,55},{2,1124734}]',55,1124734,745385),(30010109,511,520,'[{1,56},{2,1202527}]',56,1202527,769393),(30010109,521,530,'[{1,57},{2,1280120}]',57,1280120,855759),(30010109,531,540,'[{1,58},{2,1357516}]',58,1357516,917066),(30010109,541,550,'[{1,59},{2,1434718}]',59,1434718,1116338),(30010109,551,560,'[{1,60},{2,1511787}]',60,1511787,1239178),(30010109,561,570,'[{1,61},{2,1589266}]',61,1589266,1368419),(30010109,571,580,'[{1,62},{2,1666644}]',62,1666644,1432441),(30010109,581,590,'[{1,63},{2,1743909}]',63,1743909,1496463),(30010109,591,600,'[{1,64},{2,1821053}]',64,1821053,1560484),(30010109,601,610,'[{1,65},{2,1899339}]',65,1899339,1624506),(30010109,611,620,'[{1,66},{2,1988903}]',66,1988903,1688528),(30010109,621,630,'[{1,67},{2,2078290}]',67,2078290,1752550),(30010109,631,640,'[{1,68},{2,2167498}]',68,2167498,1816571),(30010109,641,650,'[{1,69},{2,2256525}]',69,2256525,1880593),(30010109,651,660,'[{1,70},{2,2347064}]',70,2347064,1944615),(30010109,661,670,'[{1,71},{2,2452693}]',71,2452693,2008637),(30010109,671,680,'[{1,72},{2,2558165}]',72,2558165,2072658),(30010109,681,690,'[{1,73},{2,2663473}]',73,2663473,2136680),(30010109,691,700,'[{1,74},{2,2768609}]',74,2768609,2200702),(30010109,701,710,'[{1,75},{2,2872319}]',75,2872319,2264724),(30010109,711,720,'[{1,76},{2,2964599}]',76,2964599,2328745),(30010109,721,730,'[{1,77},{2,3056676}]',77,3056676,2392767),(30010109,731,740,'[{1,78},{2,3148550}]',78,3148550,2456789),(30010109,741,750,'[{1,79},{2,3240220}]',79,3240220,2520811),(30010109,751,760,'[{1,80},{2,3333195}]',80,3333195,2584832),(30010109,761,770,'[{1,81},{2,3439535}]',81,3439535,2648854),(30010109,771,780,'[{1,82},{2,3545648}]',82,3545648,2712876),(30010109,781,790,'[{1,83},{2,3651536}]',83,3651536,2776897),(30010109,791,800,'[{1,83},{2,3757200}]',83,3757200,2840919),(30010109,801,1000,'[{1,83},{2,3850746}]',83,3850746,2840919),(30010201,1,70,'[{1,25},{2,11029}]',25,11029,45821),(30010201,71,119,'[{1,26},{2,11029}]',26,11029,45821),(30010201,120,149,'[{1,27},{2,18203}]',27,18203,50000),(30010201,150,169,'[{1,28},{2,19613}]',28,19613,50000),(30010201,170,190,'[{1,27},{2,28566}]',27,28566,52000),(30010201,191,230,'[{1,27},{2,35709}]',27,35709,72359),(30010201,231,240,'[{1,28},{2,72332}]',28,72332,83934),(30010201,241,250,'[{1,29},{2,96665}]',29,96665,98484),(30010201,251,260,'[{1,30},{2,120894}]',30,120894,102454),(30010201,261,270,'[{1,31},{2,139273}]',31,139273,106583),(30010201,271,280,'[{1,32},{2,157829}]',32,157829,111642),(30010201,281,290,'[{1,33},{2,176527}]',33,176527,110923),(30010201,291,300,'[{1,34},{2,195331}]',34,195331,116918),(30010201,301,310,'[{1,35},{2,215606}]',35,215606,119303),(30010201,311,320,'[{1,36},{2,248450}]',36,248450,118360),(30010201,321,330,'[{1,37},{2,281343}]',37,281343,125927),(30010201,331,340,'[{1,38},{2,314250}]',38,314250,133511),(30010201,341,350,'[{1,39},{2,347149}]',39,347149,134057),(30010201,351,360,'[{1,40},{2,382294}]',40,382294,144010),(30010201,361,370,'[{1,41},{2,438397}]',41,438397,153576),(30010201,371,380,'[{1,42},{2,494957}]',42,494957,232698),(30010201,381,390,'[{1,43},{2,551811}]',43,551811,292809),(30010201,391,400,'[{1,44},{2,608868}]',44,608868,324819),(30010201,401,410,'[{1,45},{2,664712}]',45,664712,356830),(30010201,411,420,'[{1,46},{2,708454}]',46,708454,388841),(30010201,421,430,'[{1,47},{2,752139}]',47,752139,420852),(30010201,431,440,'[{1,48},{2,795755}]',48,795755,452863),(30010201,441,450,'[{1,49},{2,839290}]',49,839290,482496),(30010201,451,460,'[{1,50},{2,885405}]',50,885405,562810),(30010201,461,470,'[{1,51},{2,955516}]',51,955516,616885),(30010201,471,480,'[{1,52},{2,1025620}]',52,1025620,673361),(30010201,481,490,'[{1,53},{2,1095689}]',53,1095689,697369),(30010201,491,500,'[{1,54},{2,1165698}]',54,1165698,721377),(30010201,501,510,'[{1,55},{2,1237207}]',55,1237207,745385),(30010201,511,520,'[{1,56},{2,1322780}]',56,1322780,769393),(30010201,521,530,'[{1,57},{2,1408132}]',57,1408132,855759),(30010201,531,540,'[{1,58},{2,1493268}]',58,1493268,917066),(30010201,541,550,'[{1,59},{2,1578190}]',59,1578190,1116338),(30010201,551,560,'[{1,60},{2,1662966}]',60,1662966,1239178),(30010201,561,570,'[{1,61},{2,1748193}]',61,1748193,1368419),(30010201,571,580,'[{1,62},{2,1833308}]',62,1833308,1432441),(30010201,581,590,'[{1,63},{2,1918300}]',63,1918300,1496463),(30010201,591,600,'[{1,64},{2,2003158}]',64,2003158,1560484),(30010201,601,610,'[{1,65},{2,2089273}]',65,2089273,1624506),(30010201,611,620,'[{1,66},{2,2187793}]',66,2187793,1688528),(30010201,621,630,'[{1,67},{2,2286119}]',67,2286119,1752550),(30010201,631,640,'[{1,68},{2,2384248}]',68,2384248,1816571),(30010201,641,650,'[{1,69},{2,2482178}]',69,2482178,1880593),(30010201,651,660,'[{1,70},{2,2581770}]',70,2581770,1944615),(30010201,661,670,'[{1,71},{2,2697962}]',71,2697962,2008637),(30010201,671,680,'[{1,72},{2,2813982}]',72,2813982,2072658),(30010201,681,690,'[{1,73},{2,2929820}]',73,2929820,2136680),(30010201,691,700,'[{1,74},{2,3045470}]',74,3045470,2200702),(30010201,701,710,'[{1,75},{2,3159551}]',75,3159551,2264724),(30010201,711,720,'[{1,76},{2,3261059}]',76,3261059,2328745),(30010201,721,730,'[{1,77},{2,3362344}]',77,3362344,2392767),(30010201,731,740,'[{1,78},{2,3463405}]',78,3463405,2456789),(30010201,741,750,'[{1,79},{2,3564242}]',79,3564242,2520811),(30010201,751,760,'[{1,80},{2,3666515}]',80,3666515,2584832),(30010201,761,770,'[{1,81},{2,3783489}]',81,3783489,2648854),(30010201,771,780,'[{1,82},{2,3900213}]',82,3900213,2712876),(30010201,781,790,'[{1,83},{2,4016690}]',83,4016690,2776897),(30010201,791,800,'[{1,83},{2,4132920}]',83,4132920,2840919),(30010201,801,1000,'[{1,83},{2,4235821}]',83,4235821,2840919),(30010202,1,70,'[{1,25},{2,11029}]',25,11029,45821),(30010202,71,119,'[{1,26},{2,11029}]',26,11029,45821),(30010202,120,149,'[{1,27},{2,18203}]',27,18203,50000),(30010202,150,169,'[{1,28},{2,19613}]',28,19613,50000),(30010202,170,190,'[{1,27},{2,28566}]',27,28566,52000),(30010202,191,230,'[{1,27},{2,35709}]',27,35709,72359),(30010202,231,240,'[{1,28},{2,72332}]',28,72332,83934),(30010202,241,250,'[{1,29},{2,96665}]',29,96665,98484),(30010202,251,260,'[{1,30},{2,120894}]',30,120894,102454),(30010202,261,270,'[{1,31},{2,139273}]',31,139273,106583),(30010202,271,280,'[{1,32},{2,157829}]',32,157829,111642),(30010202,281,290,'[{1,33},{2,176527}]',33,176527,110923),(30010202,291,300,'[{1,34},{2,195331}]',34,195331,116918),(30010202,301,310,'[{1,35},{2,215606}]',35,215606,119303),(30010202,311,320,'[{1,36},{2,248450}]',36,248450,118360),(30010202,321,330,'[{1,37},{2,281343}]',37,281343,125927),(30010202,331,340,'[{1,38},{2,314250}]',38,314250,133511),(30010202,341,350,'[{1,39},{2,347149}]',39,347149,134057),(30010202,351,360,'[{1,40},{2,382294}]',40,382294,144010),(30010202,361,370,'[{1,41},{2,438397}]',41,438397,153576),(30010202,371,380,'[{1,42},{2,494957}]',42,494957,232698),(30010202,381,390,'[{1,43},{2,551811}]',43,551811,292809),(30010202,391,400,'[{1,44},{2,608868}]',44,608868,324819),(30010202,401,410,'[{1,45},{2,664712}]',45,664712,356830),(30010202,411,420,'[{1,46},{2,708454}]',46,708454,388841),(30010202,421,430,'[{1,47},{2,752139}]',47,752139,420852),(30010202,431,440,'[{1,48},{2,795755}]',48,795755,452863),(30010202,441,450,'[{1,49},{2,839290}]',49,839290,482496),(30010202,451,460,'[{1,50},{2,885405}]',50,885405,562810),(30010202,461,470,'[{1,51},{2,955516}]',51,955516,616885),(30010202,471,480,'[{1,52},{2,1025620}]',52,1025620,673361),(30010202,481,490,'[{1,53},{2,1095689}]',53,1095689,697369),(30010202,491,500,'[{1,54},{2,1165698}]',54,1165698,721377),(30010202,501,510,'[{1,55},{2,1237207}]',55,1237207,745385),(30010202,511,520,'[{1,56},{2,1322780}]',56,1322780,769393),(30010202,521,530,'[{1,57},{2,1408132}]',57,1408132,855759),(30010202,531,540,'[{1,58},{2,1493268}]',58,1493268,917066),(30010202,541,550,'[{1,59},{2,1578190}]',59,1578190,1116338),(30010202,551,560,'[{1,60},{2,1662966}]',60,1662966,1239178),(30010202,561,570,'[{1,61},{2,1748193}]',61,1748193,1368419),(30010202,571,580,'[{1,62},{2,1833308}]',62,1833308,1432441),(30010202,581,590,'[{1,63},{2,1918300}]',63,1918300,1496463),(30010202,591,600,'[{1,64},{2,2003158}]',64,2003158,1560484),(30010202,601,610,'[{1,65},{2,2089273}]',65,2089273,1624506),(30010202,611,620,'[{1,66},{2,2187793}]',66,2187793,1688528),(30010202,621,630,'[{1,67},{2,2286119}]',67,2286119,1752550),(30010202,631,640,'[{1,68},{2,2384248}]',68,2384248,1816571),(30010202,641,650,'[{1,69},{2,2482178}]',69,2482178,1880593),(30010202,651,660,'[{1,70},{2,2581770}]',70,2581770,1944615),(30010202,661,670,'[{1,71},{2,2697962}]',71,2697962,2008637),(30010202,671,680,'[{1,72},{2,2813982}]',72,2813982,2072658),(30010202,681,690,'[{1,73},{2,2929820}]',73,2929820,2136680),(30010202,691,700,'[{1,74},{2,3045470}]',74,3045470,2200702),(30010202,701,710,'[{1,75},{2,3159551}]',75,3159551,2264724),(30010202,711,720,'[{1,76},{2,3261059}]',76,3261059,2328745),(30010202,721,730,'[{1,77},{2,3362344}]',77,3362344,2392767),(30010202,731,740,'[{1,78},{2,3463405}]',78,3463405,2456789),(30010202,741,750,'[{1,79},{2,3564242}]',79,3564242,2520811),(30010202,751,760,'[{1,80},{2,3666515}]',80,3666515,2584832),(30010202,761,770,'[{1,81},{2,3783489}]',81,3783489,2648854),(30010202,771,780,'[{1,82},{2,3900213}]',82,3900213,2712876),(30010202,781,790,'[{1,83},{2,4016690}]',83,4016690,2776897),(30010202,791,800,'[{1,83},{2,4132920}]',83,4132920,2840919),(30010202,801,1000,'[{1,83},{2,4235821}]',83,4235821,2840919),(30010203,1,70,'[{1,25},{2,11029}]',25,11029,45821),(30010203,71,119,'[{1,26},{2,11029}]',26,11029,45821),(30010203,120,149,'[{1,27},{2,18203}]',27,18203,50000),(30010203,150,169,'[{1,28},{2,19613}]',28,19613,50000),(30010203,170,190,'[{1,27},{2,28566}]',27,28566,52000),(30010203,191,230,'[{1,27},{2,35709}]',27,35709,72359),(30010203,231,240,'[{1,28},{2,72332}]',28,72332,83934),(30010203,241,250,'[{1,29},{2,96665}]',29,96665,98484),(30010203,251,260,'[{1,30},{2,120894}]',30,120894,102454),(30010203,261,270,'[{1,31},{2,139273}]',31,139273,106583),(30010203,271,280,'[{1,32},{2,157829}]',32,157829,111642),(30010203,281,290,'[{1,33},{2,176527}]',33,176527,110923),(30010203,291,300,'[{1,34},{2,195331}]',34,195331,116918),(30010203,301,310,'[{1,35},{2,215606}]',35,215606,119303),(30010203,311,320,'[{1,36},{2,248450}]',36,248450,118360),(30010203,321,330,'[{1,37},{2,281343}]',37,281343,125927),(30010203,331,340,'[{1,38},{2,314250}]',38,314250,133511),(30010203,341,350,'[{1,39},{2,347149}]',39,347149,134057),(30010203,351,360,'[{1,40},{2,382294}]',40,382294,144010),(30010203,361,370,'[{1,41},{2,438397}]',41,438397,153576),(30010203,371,380,'[{1,42},{2,494957}]',42,494957,232698),(30010203,381,390,'[{1,43},{2,551811}]',43,551811,292809),(30010203,391,400,'[{1,44},{2,608868}]',44,608868,324819),(30010203,401,410,'[{1,45},{2,664712}]',45,664712,356830),(30010203,411,420,'[{1,46},{2,708454}]',46,708454,388841),(30010203,421,430,'[{1,47},{2,752139}]',47,752139,420852),(30010203,431,440,'[{1,48},{2,795755}]',48,795755,452863),(30010203,441,450,'[{1,49},{2,839290}]',49,839290,482496),(30010203,451,460,'[{1,50},{2,885405}]',50,885405,562810),(30010203,461,470,'[{1,51},{2,955516}]',51,955516,616885),(30010203,471,480,'[{1,52},{2,1025620}]',52,1025620,673361),(30010203,481,490,'[{1,53},{2,1095689}]',53,1095689,697369),(30010203,491,500,'[{1,54},{2,1165698}]',54,1165698,721377),(30010203,501,510,'[{1,55},{2,1237207}]',55,1237207,745385),(30010203,511,520,'[{1,56},{2,1322780}]',56,1322780,769393),(30010203,521,530,'[{1,57},{2,1408132}]',57,1408132,855759),(30010203,531,540,'[{1,58},{2,1493268}]',58,1493268,917066),(30010203,541,550,'[{1,59},{2,1578190}]',59,1578190,1116338),(30010203,551,560,'[{1,60},{2,1662966}]',60,1662966,1239178),(30010203,561,570,'[{1,61},{2,1748193}]',61,1748193,1368419),(30010203,571,580,'[{1,62},{2,1833308}]',62,1833308,1432441),(30010203,581,590,'[{1,63},{2,1918300}]',63,1918300,1496463),(30010203,591,600,'[{1,64},{2,2003158}]',64,2003158,1560484),(30010203,601,610,'[{1,65},{2,2089273}]',65,2089273,1624506),(30010203,611,620,'[{1,66},{2,2187793}]',66,2187793,1688528),(30010203,621,630,'[{1,67},{2,2286119}]',67,2286119,1752550),(30010203,631,640,'[{1,68},{2,2384248}]',68,2384248,1816571),(30010203,641,650,'[{1,69},{2,2482178}]',69,2482178,1880593),(30010203,651,660,'[{1,70},{2,2581770}]',70,2581770,1944615),(30010203,661,670,'[{1,71},{2,2697962}]',71,2697962,2008637),(30010203,671,680,'[{1,72},{2,2813982}]',72,2813982,2072658),(30010203,681,690,'[{1,73},{2,2929820}]',73,2929820,2136680),(30010203,691,700,'[{1,74},{2,3045470}]',74,3045470,2200702),(30010203,701,710,'[{1,75},{2,3159551}]',75,3159551,2264724),(30010203,711,720,'[{1,76},{2,3261059}]',76,3261059,2328745),(30010203,721,730,'[{1,77},{2,3362344}]',77,3362344,2392767),(30010203,731,740,'[{1,78},{2,3463405}]',78,3463405,2456789),(30010203,741,750,'[{1,79},{2,3564242}]',79,3564242,2520811),(30010203,751,760,'[{1,80},{2,3666515}]',80,3666515,2584832),(30010203,761,770,'[{1,81},{2,3783489}]',81,3783489,2648854),(30010203,771,780,'[{1,82},{2,3900213}]',82,3900213,2712876),(30010203,781,790,'[{1,83},{2,4016690}]',83,4016690,2776897),(30010203,791,800,'[{1,83},{2,4132920}]',83,4132920,2840919),(30010203,801,1000,'[{1,83},{2,4235821}]',83,4235821,2840919),(30010204,1,70,'[{1,25},{2,11029}]',25,11029,45821),(30010204,71,119,'[{1,26},{2,11029}]',26,11029,45821),(30010204,120,149,'[{1,27},{2,18203}]',27,18203,50000),(30010204,150,169,'[{1,28},{2,19613}]',28,19613,50000),(30010204,170,190,'[{1,27},{2,28566}]',27,28566,52000),(30010204,191,230,'[{1,27},{2,35709}]',27,35709,72359),(30010204,231,240,'[{1,28},{2,72332}]',28,72332,83934),(30010204,241,250,'[{1,29},{2,96665}]',29,96665,98484),(30010204,251,260,'[{1,30},{2,120894}]',30,120894,102454),(30010204,261,270,'[{1,31},{2,139273}]',31,139273,106583),(30010204,271,280,'[{1,32},{2,157829}]',32,157829,111642),(30010204,281,290,'[{1,33},{2,176527}]',33,176527,110923),(30010204,291,300,'[{1,34},{2,195331}]',34,195331,116918),(30010204,301,310,'[{1,35},{2,215606}]',35,215606,119303),(30010204,311,320,'[{1,36},{2,248450}]',36,248450,118360),(30010204,321,330,'[{1,37},{2,281343}]',37,281343,125927),(30010204,331,340,'[{1,38},{2,314250}]',38,314250,133511),(30010204,341,350,'[{1,39},{2,347149}]',39,347149,134057),(30010204,351,360,'[{1,40},{2,382294}]',40,382294,144010),(30010204,361,370,'[{1,41},{2,438397}]',41,438397,153576),(30010204,371,380,'[{1,42},{2,494957}]',42,494957,232698),(30010204,381,390,'[{1,43},{2,551811}]',43,551811,292809),(30010204,391,400,'[{1,44},{2,608868}]',44,608868,324819),(30010204,401,410,'[{1,45},{2,664712}]',45,664712,356830),(30010204,411,420,'[{1,46},{2,708454}]',46,708454,388841),(30010204,421,430,'[{1,47},{2,752139}]',47,752139,420852),(30010204,431,440,'[{1,48},{2,795755}]',48,795755,452863),(30010204,441,450,'[{1,49},{2,839290}]',49,839290,482496),(30010204,451,460,'[{1,50},{2,885405}]',50,885405,562810),(30010204,461,470,'[{1,51},{2,955516}]',51,955516,616885),(30010204,471,480,'[{1,52},{2,1025620}]',52,1025620,673361),(30010204,481,490,'[{1,53},{2,1095689}]',53,1095689,697369),(30010204,491,500,'[{1,54},{2,1165698}]',54,1165698,721377),(30010204,501,510,'[{1,55},{2,1237207}]',55,1237207,745385),(30010204,511,520,'[{1,56},{2,1322780}]',56,1322780,769393),(30010204,521,530,'[{1,57},{2,1408132}]',57,1408132,855759),(30010204,531,540,'[{1,58},{2,1493268}]',58,1493268,917066),(30010204,541,550,'[{1,59},{2,1578190}]',59,1578190,1116338),(30010204,551,560,'[{1,60},{2,1662966}]',60,1662966,1239178),(30010204,561,570,'[{1,61},{2,1748193}]',61,1748193,1368419),(30010204,571,580,'[{1,62},{2,1833308}]',62,1833308,1432441),(30010204,581,590,'[{1,63},{2,1918300}]',63,1918300,1496463),(30010204,591,600,'[{1,64},{2,2003158}]',64,2003158,1560484),(30010204,601,610,'[{1,65},{2,2089273}]',65,2089273,1624506),(30010204,611,620,'[{1,66},{2,2187793}]',66,2187793,1688528),(30010204,621,630,'[{1,67},{2,2286119}]',67,2286119,1752550),(30010204,631,640,'[{1,68},{2,2384248}]',68,2384248,1816571),(30010204,641,650,'[{1,69},{2,2482178}]',69,2482178,1880593),(30010204,651,660,'[{1,70},{2,2581770}]',70,2581770,1944615),(30010204,661,670,'[{1,71},{2,2697962}]',71,2697962,2008637),(30010204,671,680,'[{1,72},{2,2813982}]',72,2813982,2072658),(30010204,681,690,'[{1,73},{2,2929820}]',73,2929820,2136680),(30010204,691,700,'[{1,74},{2,3045470}]',74,3045470,2200702),(30010204,701,710,'[{1,75},{2,3159551}]',75,3159551,2264724),(30010204,711,720,'[{1,76},{2,3261059}]',76,3261059,2328745),(30010204,721,730,'[{1,77},{2,3362344}]',77,3362344,2392767),(30010204,731,740,'[{1,78},{2,3463405}]',78,3463405,2456789),(30010204,741,750,'[{1,79},{2,3564242}]',79,3564242,2520811),(30010204,751,760,'[{1,80},{2,3666515}]',80,3666515,2584832),(30010204,761,770,'[{1,81},{2,3783489}]',81,3783489,2648854),(30010204,771,780,'[{1,82},{2,3900213}]',82,3900213,2712876),(30010204,781,790,'[{1,83},{2,4016690}]',83,4016690,2776897),(30010204,791,800,'[{1,83},{2,4132920}]',83,4132920,2840919),(30010204,801,1000,'[{1,83},{2,4235821}]',83,4235821,2840919),(30010205,1,70,'[{1,25},{2,11029}]',25,11029,45821),(30010205,71,119,'[{1,26},{2,11029}]',26,11029,45821),(30010205,120,149,'[{1,27},{2,18203}]',27,18203,50000),(30010205,150,169,'[{1,28},{2,19613}]',28,19613,50000),(30010205,170,190,'[{1,27},{2,28566}]',27,28566,52000),(30010205,191,230,'[{1,27},{2,35709}]',27,35709,72359),(30010205,231,240,'[{1,28},{2,72332}]',28,72332,83934),(30010205,241,250,'[{1,29},{2,96665}]',29,96665,98484),(30010205,251,260,'[{1,30},{2,120894}]',30,120894,102454),(30010205,261,270,'[{1,31},{2,139273}]',31,139273,106583),(30010205,271,280,'[{1,32},{2,157829}]',32,157829,111642),(30010205,281,290,'[{1,33},{2,176527}]',33,176527,110923),(30010205,291,300,'[{1,34},{2,195331}]',34,195331,116918),(30010205,301,310,'[{1,35},{2,215606}]',35,215606,119303),(30010205,311,320,'[{1,36},{2,248450}]',36,248450,118360),(30010205,321,330,'[{1,37},{2,281343}]',37,281343,125927),(30010205,331,340,'[{1,38},{2,314250}]',38,314250,133511),(30010205,341,350,'[{1,39},{2,347149}]',39,347149,134057),(30010205,351,360,'[{1,40},{2,382294}]',40,382294,144010),(30010205,361,370,'[{1,41},{2,438397}]',41,438397,153576),(30010205,371,380,'[{1,42},{2,494957}]',42,494957,232698),(30010205,381,390,'[{1,43},{2,551811}]',43,551811,292809),(30010205,391,400,'[{1,44},{2,608868}]',44,608868,324819),(30010205,401,410,'[{1,45},{2,664712}]',45,664712,356830),(30010205,411,420,'[{1,46},{2,708454}]',46,708454,388841),(30010205,421,430,'[{1,47},{2,752139}]',47,752139,420852),(30010205,431,440,'[{1,48},{2,795755}]',48,795755,452863),(30010205,441,450,'[{1,49},{2,839290}]',49,839290,482496),(30010205,451,460,'[{1,50},{2,885405}]',50,885405,562810),(30010205,461,470,'[{1,51},{2,955516}]',51,955516,616885),(30010205,471,480,'[{1,52},{2,1025620}]',52,1025620,673361),(30010205,481,490,'[{1,53},{2,1095689}]',53,1095689,697369),(30010205,491,500,'[{1,54},{2,1165698}]',54,1165698,721377),(30010205,501,510,'[{1,55},{2,1237207}]',55,1237207,745385),(30010205,511,520,'[{1,56},{2,1322780}]',56,1322780,769393),(30010205,521,530,'[{1,57},{2,1408132}]',57,1408132,855759),(30010205,531,540,'[{1,58},{2,1493268}]',58,1493268,917066),(30010205,541,550,'[{1,59},{2,1578190}]',59,1578190,1116338),(30010205,551,560,'[{1,60},{2,1662966}]',60,1662966,1239178),(30010205,561,570,'[{1,61},{2,1748193}]',61,1748193,1368419),(30010205,571,580,'[{1,62},{2,1833308}]',62,1833308,1432441),(30010205,581,590,'[{1,63},{2,1918300}]',63,1918300,1496463),(30010205,591,600,'[{1,64},{2,2003158}]',64,2003158,1560484),(30010205,601,610,'[{1,65},{2,2089273}]',65,2089273,1624506),(30010205,611,620,'[{1,66},{2,2187793}]',66,2187793,1688528),(30010205,621,630,'[{1,67},{2,2286119}]',67,2286119,1752550),(30010205,631,640,'[{1,68},{2,2384248}]',68,2384248,1816571),(30010205,641,650,'[{1,69},{2,2482178}]',69,2482178,1880593),(30010205,651,660,'[{1,70},{2,2581770}]',70,2581770,1944615),(30010205,661,670,'[{1,71},{2,2697962}]',71,2697962,2008637),(30010205,671,680,'[{1,72},{2,2813982}]',72,2813982,2072658),(30010205,681,690,'[{1,73},{2,2929820}]',73,2929820,2136680),(30010205,691,700,'[{1,74},{2,3045470}]',74,3045470,2200702),(30010205,701,710,'[{1,75},{2,3159551}]',75,3159551,2264724),(30010205,711,720,'[{1,76},{2,3261059}]',76,3261059,2328745),(30010205,721,730,'[{1,77},{2,3362344}]',77,3362344,2392767),(30010205,731,740,'[{1,78},{2,3463405}]',78,3463405,2456789),(30010205,741,750,'[{1,79},{2,3564242}]',79,3564242,2520811),(30010205,751,760,'[{1,80},{2,3666515}]',80,3666515,2584832),(30010205,761,770,'[{1,81},{2,3783489}]',81,3783489,2648854),(30010205,771,780,'[{1,82},{2,3900213}]',82,3900213,2712876),(30010205,781,790,'[{1,83},{2,4016690}]',83,4016690,2776897),(30010205,791,800,'[{1,83},{2,4132920}]',83,4132920,2840919),(30010205,801,1000,'[{1,83},{2,4235821}]',83,4235821,2840919),(30010206,1,70,'[{1,25},{2,11029}]',25,11029,45821),(30010206,71,119,'[{1,26},{2,11029}]',26,11029,45821),(30010206,120,149,'[{1,27},{2,18203}]',27,18203,50000),(30010206,150,169,'[{1,28},{2,19613}]',28,19613,50000),(30010206,170,190,'[{1,27},{2,28566}]',27,28566,52000),(30010206,191,230,'[{1,27},{2,35709}]',27,35709,72359),(30010206,231,240,'[{1,28},{2,72332}]',28,72332,83934),(30010206,241,250,'[{1,29},{2,96665}]',29,96665,98484),(30010206,251,260,'[{1,30},{2,120894}]',30,120894,102454),(30010206,261,270,'[{1,31},{2,139273}]',31,139273,106583),(30010206,271,280,'[{1,32},{2,157829}]',32,157829,111642),(30010206,281,290,'[{1,33},{2,176527}]',33,176527,110923),(30010206,291,300,'[{1,34},{2,195331}]',34,195331,116918),(30010206,301,310,'[{1,35},{2,215606}]',35,215606,119303),(30010206,311,320,'[{1,36},{2,248450}]',36,248450,118360),(30010206,321,330,'[{1,37},{2,281343}]',37,281343,125927),(30010206,331,340,'[{1,38},{2,314250}]',38,314250,133511),(30010206,341,350,'[{1,39},{2,347149}]',39,347149,134057),(30010206,351,360,'[{1,40},{2,382294}]',40,382294,144010),(30010206,361,370,'[{1,41},{2,438397}]',41,438397,153576),(30010206,371,380,'[{1,42},{2,494957}]',42,494957,232698),(30010206,381,390,'[{1,43},{2,551811}]',43,551811,292809),(30010206,391,400,'[{1,44},{2,608868}]',44,608868,324819),(30010206,401,410,'[{1,45},{2,664712}]',45,664712,356830),(30010206,411,420,'[{1,46},{2,708454}]',46,708454,388841),(30010206,421,430,'[{1,47},{2,752139}]',47,752139,420852),(30010206,431,440,'[{1,48},{2,795755}]',48,795755,452863),(30010206,441,450,'[{1,49},{2,839290}]',49,839290,482496),(30010206,451,460,'[{1,50},{2,885405}]',50,885405,562810),(30010206,461,470,'[{1,51},{2,955516}]',51,955516,616885),(30010206,471,480,'[{1,52},{2,1025620}]',52,1025620,673361),(30010206,481,490,'[{1,53},{2,1095689}]',53,1095689,697369),(30010206,491,500,'[{1,54},{2,1165698}]',54,1165698,721377),(30010206,501,510,'[{1,55},{2,1237207}]',55,1237207,745385),(30010206,511,520,'[{1,56},{2,1322780}]',56,1322780,769393),(30010206,521,530,'[{1,57},{2,1408132}]',57,1408132,855759),(30010206,531,540,'[{1,58},{2,1493268}]',58,1493268,917066),(30010206,541,550,'[{1,59},{2,1578190}]',59,1578190,1116338),(30010206,551,560,'[{1,60},{2,1662966}]',60,1662966,1239178),(30010206,561,570,'[{1,61},{2,1748193}]',61,1748193,1368419),(30010206,571,580,'[{1,62},{2,1833308}]',62,1833308,1432441),(30010206,581,590,'[{1,63},{2,1918300}]',63,1918300,1496463),(30010206,591,600,'[{1,64},{2,2003158}]',64,2003158,1560484),(30010206,601,610,'[{1,65},{2,2089273}]',65,2089273,1624506),(30010206,611,620,'[{1,66},{2,2187793}]',66,2187793,1688528),(30010206,621,630,'[{1,67},{2,2286119}]',67,2286119,1752550),(30010206,631,640,'[{1,68},{2,2384248}]',68,2384248,1816571),(30010206,641,650,'[{1,69},{2,2482178}]',69,2482178,1880593),(30010206,651,660,'[{1,70},{2,2581770}]',70,2581770,1944615),(30010206,661,670,'[{1,71},{2,2697962}]',71,2697962,2008637),(30010206,671,680,'[{1,72},{2,2813982}]',72,2813982,2072658),(30010206,681,690,'[{1,73},{2,2929820}]',73,2929820,2136680),(30010206,691,700,'[{1,74},{2,3045470}]',74,3045470,2200702),(30010206,701,710,'[{1,75},{2,3159551}]',75,3159551,2264724),(30010206,711,720,'[{1,76},{2,3261059}]',76,3261059,2328745),(30010206,721,730,'[{1,77},{2,3362344}]',77,3362344,2392767),(30010206,731,740,'[{1,78},{2,3463405}]',78,3463405,2456789),(30010206,741,750,'[{1,79},{2,3564242}]',79,3564242,2520811),(30010206,751,760,'[{1,80},{2,3666515}]',80,3666515,2584832),(30010206,761,770,'[{1,81},{2,3783489}]',81,3783489,2648854),(30010206,771,780,'[{1,82},{2,3900213}]',82,3900213,2712876),(30010206,781,790,'[{1,83},{2,4016690}]',83,4016690,2776897),(30010206,791,800,'[{1,83},{2,4132920}]',83,4132920,2840919),(30010206,801,1000,'[{1,83},{2,4235821}]',83,4235821,2840919),(30010207,1,70,'[{1,25},{2,11029}]',25,11029,45821),(30010207,71,119,'[{1,26},{2,11029}]',26,11029,45821),(30010207,120,149,'[{1,27},{2,18203}]',27,18203,50000),(30010207,150,169,'[{1,28},{2,19613}]',28,19613,50000),(30010207,170,190,'[{1,27},{2,28566}]',27,28566,52000),(30010207,191,230,'[{1,27},{2,35709}]',27,35709,72359),(30010207,231,240,'[{1,28},{2,72332}]',28,72332,83934),(30010207,241,250,'[{1,29},{2,96665}]',29,96665,98484),(30010207,251,260,'[{1,30},{2,120894}]',30,120894,102454),(30010207,261,270,'[{1,31},{2,139273}]',31,139273,106583),(30010207,271,280,'[{1,32},{2,157829}]',32,157829,111642),(30010207,281,290,'[{1,33},{2,176527}]',33,176527,110923),(30010207,291,300,'[{1,34},{2,195331}]',34,195331,116918),(30010207,301,310,'[{1,35},{2,215606}]',35,215606,119303),(30010207,311,320,'[{1,36},{2,248450}]',36,248450,118360),(30010207,321,330,'[{1,37},{2,281343}]',37,281343,125927),(30010207,331,340,'[{1,38},{2,314250}]',38,314250,133511),(30010207,341,350,'[{1,39},{2,347149}]',39,347149,134057),(30010207,351,360,'[{1,40},{2,382294}]',40,382294,144010),(30010207,361,370,'[{1,41},{2,438397}]',41,438397,153576),(30010207,371,380,'[{1,42},{2,494957}]',42,494957,232698),(30010207,381,390,'[{1,43},{2,551811}]',43,551811,292809),(30010207,391,400,'[{1,44},{2,608868}]',44,608868,324819),(30010207,401,410,'[{1,45},{2,664712}]',45,664712,356830),(30010207,411,420,'[{1,46},{2,708454}]',46,708454,388841),(30010207,421,430,'[{1,47},{2,752139}]',47,752139,420852),(30010207,431,440,'[{1,48},{2,795755}]',48,795755,452863),(30010207,441,450,'[{1,49},{2,839290}]',49,839290,482496),(30010207,451,460,'[{1,50},{2,885405}]',50,885405,562810),(30010207,461,470,'[{1,51},{2,955516}]',51,955516,616885),(30010207,471,480,'[{1,52},{2,1025620}]',52,1025620,673361),(30010207,481,490,'[{1,53},{2,1095689}]',53,1095689,697369),(30010207,491,500,'[{1,54},{2,1165698}]',54,1165698,721377),(30010207,501,510,'[{1,55},{2,1237207}]',55,1237207,745385),(30010207,511,520,'[{1,56},{2,1322780}]',56,1322780,769393),(30010207,521,530,'[{1,57},{2,1408132}]',57,1408132,855759),(30010207,531,540,'[{1,58},{2,1493268}]',58,1493268,917066),(30010207,541,550,'[{1,59},{2,1578190}]',59,1578190,1116338),(30010207,551,560,'[{1,60},{2,1662966}]',60,1662966,1239178),(30010207,561,570,'[{1,61},{2,1748193}]',61,1748193,1368419),(30010207,571,580,'[{1,62},{2,1833308}]',62,1833308,1432441),(30010207,581,590,'[{1,63},{2,1918300}]',63,1918300,1496463),(30010207,591,600,'[{1,64},{2,2003158}]',64,2003158,1560484),(30010207,601,610,'[{1,65},{2,2089273}]',65,2089273,1624506),(30010207,611,620,'[{1,66},{2,2187793}]',66,2187793,1688528),(30010207,621,630,'[{1,67},{2,2286119}]',67,2286119,1752550),(30010207,631,640,'[{1,68},{2,2384248}]',68,2384248,1816571),(30010207,641,650,'[{1,69},{2,2482178}]',69,2482178,1880593),(30010207,651,660,'[{1,70},{2,2581770}]',70,2581770,1944615),(30010207,661,670,'[{1,71},{2,2697962}]',71,2697962,2008637),(30010207,671,680,'[{1,72},{2,2813982}]',72,2813982,2072658),(30010207,681,690,'[{1,73},{2,2929820}]',73,2929820,2136680),(30010207,691,700,'[{1,74},{2,3045470}]',74,3045470,2200702),(30010207,701,710,'[{1,75},{2,3159551}]',75,3159551,2264724),(30010207,711,720,'[{1,76},{2,3261059}]',76,3261059,2328745),(30010207,721,730,'[{1,77},{2,3362344}]',77,3362344,2392767),(30010207,731,740,'[{1,78},{2,3463405}]',78,3463405,2456789),(30010207,741,750,'[{1,79},{2,3564242}]',79,3564242,2520811),(30010207,751,760,'[{1,80},{2,3666515}]',80,3666515,2584832),(30010207,761,770,'[{1,81},{2,3783489}]',81,3783489,2648854),(30010207,771,780,'[{1,82},{2,3900213}]',82,3900213,2712876),(30010207,781,790,'[{1,83},{2,4016690}]',83,4016690,2776897),(30010207,791,800,'[{1,83},{2,4132920}]',83,4132920,2840919),(30010207,801,1000,'[{1,83},{2,4235821}]',83,4235821,2840919),(30010208,1,70,'[{1,25},{2,11029}]',25,11029,45821),(30010208,71,119,'[{1,26},{2,11029}]',26,11029,45821),(30010208,120,149,'[{1,27},{2,18203}]',27,18203,50000),(30010208,150,169,'[{1,28},{2,19613}]',28,19613,50000),(30010208,170,190,'[{1,27},{2,28566}]',27,28566,52000),(30010208,191,230,'[{1,27},{2,35709}]',27,35709,72359),(30010208,231,240,'[{1,28},{2,72332}]',28,72332,83934),(30010208,241,250,'[{1,29},{2,96665}]',29,96665,98484),(30010208,251,260,'[{1,30},{2,120894}]',30,120894,102454),(30010208,261,270,'[{1,31},{2,139273}]',31,139273,106583),(30010208,271,280,'[{1,32},{2,157829}]',32,157829,111642),(30010208,281,290,'[{1,33},{2,176527}]',33,176527,110923),(30010208,291,300,'[{1,34},{2,195331}]',34,195331,116918),(30010208,301,310,'[{1,35},{2,215606}]',35,215606,119303),(30010208,311,320,'[{1,36},{2,248450}]',36,248450,118360),(30010208,321,330,'[{1,37},{2,281343}]',37,281343,125927),(30010208,331,340,'[{1,38},{2,314250}]',38,314250,133511),(30010208,341,350,'[{1,39},{2,347149}]',39,347149,134057),(30010208,351,360,'[{1,40},{2,382294}]',40,382294,144010),(30010208,361,370,'[{1,41},{2,438397}]',41,438397,153576),(30010208,371,380,'[{1,42},{2,494957}]',42,494957,232698),(30010208,381,390,'[{1,43},{2,551811}]',43,551811,292809),(30010208,391,400,'[{1,44},{2,608868}]',44,608868,324819),(30010208,401,410,'[{1,45},{2,664712}]',45,664712,356830),(30010208,411,420,'[{1,46},{2,708454}]',46,708454,388841),(30010208,421,430,'[{1,47},{2,752139}]',47,752139,420852),(30010208,431,440,'[{1,48},{2,795755}]',48,795755,452863),(30010208,441,450,'[{1,49},{2,839290}]',49,839290,482496),(30010208,451,460,'[{1,50},{2,885405}]',50,885405,562810),(30010208,461,470,'[{1,51},{2,955516}]',51,955516,616885),(30010208,471,480,'[{1,52},{2,1025620}]',52,1025620,673361),(30010208,481,490,'[{1,53},{2,1095689}]',53,1095689,697369),(30010208,491,500,'[{1,54},{2,1165698}]',54,1165698,721377),(30010208,501,510,'[{1,55},{2,1237207}]',55,1237207,745385),(30010208,511,520,'[{1,56},{2,1322780}]',56,1322780,769393),(30010208,521,530,'[{1,57},{2,1408132}]',57,1408132,855759),(30010208,531,540,'[{1,58},{2,1493268}]',58,1493268,917066),(30010208,541,550,'[{1,59},{2,1578190}]',59,1578190,1116338),(30010208,551,560,'[{1,60},{2,1662966}]',60,1662966,1239178),(30010208,561,570,'[{1,61},{2,1748193}]',61,1748193,1368419),(30010208,571,580,'[{1,62},{2,1833308}]',62,1833308,1432441),(30010208,581,590,'[{1,63},{2,1918300}]',63,1918300,1496463),(30010208,591,600,'[{1,64},{2,2003158}]',64,2003158,1560484),(30010208,601,610,'[{1,65},{2,2089273}]',65,2089273,1624506),(30010208,611,620,'[{1,66},{2,2187793}]',66,2187793,1688528),(30010208,621,630,'[{1,67},{2,2286119}]',67,2286119,1752550),(30010208,631,640,'[{1,68},{2,2384248}]',68,2384248,1816571),(30010208,641,650,'[{1,69},{2,2482178}]',69,2482178,1880593),(30010208,651,660,'[{1,70},{2,2581770}]',70,2581770,1944615),(30010208,661,670,'[{1,71},{2,2697962}]',71,2697962,2008637),(30010208,671,680,'[{1,72},{2,2813982}]',72,2813982,2072658),(30010208,681,690,'[{1,73},{2,2929820}]',73,2929820,2136680),(30010208,691,700,'[{1,74},{2,3045470}]',74,3045470,2200702),(30010208,701,710,'[{1,75},{2,3159551}]',75,3159551,2264724),(30010208,711,720,'[{1,76},{2,3261059}]',76,3261059,2328745),(30010208,721,730,'[{1,77},{2,3362344}]',77,3362344,2392767),(30010208,731,740,'[{1,78},{2,3463405}]',78,3463405,2456789),(30010208,741,750,'[{1,79},{2,3564242}]',79,3564242,2520811),(30010208,751,760,'[{1,80},{2,3666515}]',80,3666515,2584832),(30010208,761,770,'[{1,81},{2,3783489}]',81,3783489,2648854),(30010208,771,780,'[{1,82},{2,3900213}]',82,3900213,2712876),(30010208,781,790,'[{1,83},{2,4016690}]',83,4016690,2776897),(30010208,791,800,'[{1,83},{2,4132920}]',83,4132920,2840919),(30010208,801,1000,'[{1,83},{2,4235821}]',83,4235821,2840919),(30010209,1,70,'[{1,25},{2,13786}]',25,13786,45821),(30010209,71,119,'[{1,26},{2,13786}]',26,13786,45821),(30010209,120,149,'[{1,27},{2,22754}]',27,22754,50000),(30010209,150,169,'[{1,28},{2,24516}]',28,24516,50000),(30010209,170,190,'[{1,27},{2,28566}]',27,28566,52000),(30010209,191,230,'[{1,27},{2,35709}]',27,35709,72359),(30010209,231,240,'[{1,28},{2,72332}]',28,72332,83934),(30010209,241,250,'[{1,29},{2,96665}]',29,96665,98484),(30010209,251,260,'[{1,30},{2,120894}]',30,120894,102454),(30010209,261,270,'[{1,31},{2,139273}]',31,139273,106583),(30010209,271,280,'[{1,32},{2,157829}]',32,157829,111642),(30010209,281,290,'[{1,33},{2,176527}]',33,176527,110923),(30010209,291,300,'[{1,34},{2,195331}]',34,195331,116918),(30010209,301,310,'[{1,35},{2,215606}]',35,215606,119303),(30010209,311,320,'[{1,36},{2,248450}]',36,248450,118360),(30010209,321,330,'[{1,37},{2,281343}]',37,281343,125927),(30010209,331,340,'[{1,38},{2,314250}]',38,314250,133511),(30010209,341,350,'[{1,39},{2,347149}]',39,347149,134057),(30010209,351,360,'[{1,40},{2,382294}]',40,382294,144010),(30010209,361,370,'[{1,41},{2,438397}]',41,438397,153576),(30010209,371,380,'[{1,42},{2,494957}]',42,494957,232698),(30010209,381,390,'[{1,43},{2,551811}]',43,551811,292809),(30010209,391,400,'[{1,44},{2,608868}]',44,608868,324819),(30010209,401,410,'[{1,45},{2,664712}]',45,664712,356830),(30010209,411,420,'[{1,46},{2,708454}]',46,708454,388841),(30010209,421,430,'[{1,47},{2,752139}]',47,752139,420852),(30010209,431,440,'[{1,48},{2,795755}]',48,795755,452863),(30010209,441,450,'[{1,49},{2,839290}]',49,839290,482496),(30010209,451,460,'[{1,50},{2,885405}]',50,885405,562810),(30010209,461,470,'[{1,51},{2,955516}]',51,955516,616885),(30010209,471,480,'[{1,52},{2,1025620}]',52,1025620,673361),(30010209,481,490,'[{1,53},{2,1095689}]',53,1095689,697369),(30010209,491,500,'[{1,54},{2,1165698}]',54,1165698,721377),(30010209,501,510,'[{1,55},{2,1237207}]',55,1237207,745385),(30010209,511,520,'[{1,56},{2,1322780}]',56,1322780,769393),(30010209,521,530,'[{1,57},{2,1408132}]',57,1408132,855759),(30010209,531,540,'[{1,58},{2,1493268}]',58,1493268,917066),(30010209,541,550,'[{1,59},{2,1578190}]',59,1578190,1116338),(30010209,551,560,'[{1,60},{2,1662966}]',60,1662966,1239178),(30010209,561,570,'[{1,61},{2,1748193}]',61,1748193,1368419),(30010209,571,580,'[{1,62},{2,1833308}]',62,1833308,1432441),(30010209,581,590,'[{1,63},{2,1918300}]',63,1918300,1496463),(30010209,591,600,'[{1,64},{2,2003158}]',64,2003158,1560484),(30010209,601,610,'[{1,65},{2,2089273}]',65,2089273,1624506),(30010209,611,620,'[{1,66},{2,2187793}]',66,2187793,1688528),(30010209,621,630,'[{1,67},{2,2286119}]',67,2286119,1752550),(30010209,631,640,'[{1,68},{2,2384248}]',68,2384248,1816571),(30010209,641,650,'[{1,69},{2,2482178}]',69,2482178,1880593),(30010209,651,660,'[{1,70},{2,2581770}]',70,2581770,1944615),(30010209,661,670,'[{1,71},{2,2697962}]',71,2697962,2008637),(30010209,671,680,'[{1,72},{2,2813982}]',72,2813982,2072658),(30010209,681,690,'[{1,73},{2,2929820}]',73,2929820,2136680),(30010209,691,700,'[{1,74},{2,3045470}]',74,3045470,2200702),(30010209,701,710,'[{1,75},{2,3159551}]',75,3159551,2264724),(30010209,711,720,'[{1,76},{2,3261059}]',76,3261059,2328745),(30010209,721,730,'[{1,77},{2,3362344}]',77,3362344,2392767),(30010209,731,740,'[{1,78},{2,3463405}]',78,3463405,2456789),(30010209,741,750,'[{1,79},{2,3564242}]',79,3564242,2520811),(30010209,751,760,'[{1,80},{2,3666515}]',80,3666515,2584832),(30010209,761,770,'[{1,81},{2,3783489}]',81,3783489,2648854),(30010209,771,780,'[{1,82},{2,3900213}]',82,3900213,2712876),(30010209,781,790,'[{1,83},{2,4016690}]',83,4016690,2776897),(30010209,791,800,'[{1,83},{2,4132920}]',83,4132920,2840919),(30010209,801,1000,'[{1,83},{2,4235821}]',83,4235821,2840919),(30010301,1,70,'[{1,25},{2,26319}]',25,26319,32075),(30010301,71,119,'[{1,26},{2,26319}]',26,26319,32075),(30010301,120,149,'[{1,27},{2,43439}]',27,43439,35000),(30010301,150,169,'[{1,28},{2,46803}]',28,46803,35000),(30010301,170,190,'[{1,27},{2,54535}]',27,54535,36400),(30010301,191,230,'[{1,27},{2,68172}]',27,68172,50651),(30010301,231,240,'[{1,28},{2,138088}]',28,138088,58754),(30010301,241,250,'[{1,29},{2,123028}]',29,123028,68939),(30010301,251,260,'[{1,30},{2,153866}]',30,153866,71718),(30010301,261,270,'[{1,31},{2,177257}]',31,177257,74608),(30010301,271,280,'[{1,32},{2,200873}]',32,200873,78149),(30010301,281,290,'[{1,33},{2,224671}]',33,224671,77646),(30010301,291,300,'[{1,34},{2,248604}]',34,248604,81843),(30010301,301,310,'[{1,35},{2,274407}]',35,274407,83512),(30010301,311,320,'[{1,36},{2,316210}]',36,316210,82852),(30010301,321,330,'[{1,37},{2,358072}]',37,358072,88149),(30010301,331,340,'[{1,38},{2,399955}]',38,399955,93458),(30010301,341,350,'[{1,39},{2,441826}]',39,441826,93840),(30010301,351,360,'[{1,40},{2,486556}]',40,486556,100807),(30010301,361,370,'[{1,41},{2,557960}]',41,557960,107503),(30010301,371,380,'[{1,42},{2,629945}]',42,629945,162889),(30010301,381,390,'[{1,43},{2,702304}]',43,702304,204966),(30010301,391,400,'[{1,44},{2,774922}]',44,774922,227373),(30010301,401,410,'[{1,45},{2,845998}]',45,845998,249781),(30010301,411,420,'[{1,46},{2,901669}]',46,901669,272189),(30010301,421,430,'[{1,47},{2,957268}]',47,957268,294596),(30010301,431,440,'[{1,48},{2,1012780}]',48,1012780,317004),(30010301,441,450,'[{1,49},{2,1068187}]',49,1068187,337747),(30010301,451,460,'[{1,50},{2,1126880}]',50,1126880,393967),(30010301,461,470,'[{1,51},{2,1216111}]',51,1216111,431820),(30010301,471,480,'[{1,52},{2,1305335}]',52,1305335,471353),(30010301,481,490,'[{1,53},{2,1394513}]',53,1394513,488158),(30010301,491,500,'[{1,54},{2,1483615}]',54,1483615,504964),(30010301,501,510,'[{1,55},{2,1574628}]',55,1574628,521770),(30010301,511,520,'[{1,56},{2,1683538}]',56,1683538,538575),(30010301,521,530,'[{1,57},{2,1792168}]',57,1792168,599031),(30010301,531,540,'[{1,58},{2,1900522}]',58,1900522,641946),(30010301,541,550,'[{1,59},{2,2008605}]',59,2008605,781437),(30010301,551,560,'[{1,60},{2,2116502}]',60,2116502,867425),(30010301,561,570,'[{1,61},{2,2224972}]',61,2224972,957893),(30010301,571,580,'[{1,62},{2,2333302}]',62,2333302,1002709),(30010301,581,590,'[{1,63},{2,2441473}]',63,2441473,1047524),(30010301,591,600,'[{1,64},{2,2549474}]',64,2549474,1092339),(30010301,601,610,'[{1,65},{2,2659075}]',65,2659075,1137154),(30010301,611,620,'[{1,66},{2,2784464}]',66,2784464,1181970),(30010301,621,630,'[{1,67},{2,2909606}]',67,2909606,1226785),(30010301,631,640,'[{1,68},{2,3034497}]',68,3034497,1271600),(30010301,641,650,'[{1,69},{2,3159135}]',69,3159135,1316415),(30010301,651,660,'[{1,70},{2,3285890}]',70,3285890,1361231),(30010301,661,670,'[{1,71},{2,3433770}]',71,3433770,1406046),(30010301,671,680,'[{1,72},{2,3581431}]',72,3581431,1450861),(30010301,681,690,'[{1,73},{2,3728862}]',73,3728862,1495676),(30010301,691,700,'[{1,74},{2,3876053}]',74,3876053,1540491),(30010301,701,710,'[{1,75},{2,4021247}]',75,4021247,1585307),(30010301,711,720,'[{1,76},{2,4150439}]',76,4150439,1630122),(30010301,721,730,'[{1,77},{2,4279346}]',77,4279346,1674937),(30010301,731,740,'[{1,78},{2,4407970}]',78,4407970,1719752),(30010301,741,750,'[{1,79},{2,4536308}]',79,4536308,1764568),(30010301,751,760,'[{1,80},{2,4666473}]',80,4666473,1809382),(30010301,761,770,'[{1,81},{2,4815349}]',81,4815349,1854198),(30010301,771,780,'[{1,82},{2,4963907}]',82,4963907,1899013),(30010301,781,790,'[{1,83},{2,5112150}]',83,5112150,1943828),(30010301,791,800,'[{1,83},{2,5260080}]',83,5260080,1988643),(30010301,801,1000,'[{1,83},{2,5391044}]',83,5391044,1988643),(30010302,1,70,'[{1,25},{2,26319}]',25,26319,32075),(30010302,71,119,'[{1,26},{2,26319}]',26,26319,32075),(30010302,120,149,'[{1,27},{2,43439}]',27,43439,35000),(30010302,150,169,'[{1,28},{2,46803}]',28,46803,35000),(30010302,170,190,'[{1,27},{2,54535}]',27,54535,36400),(30010302,191,230,'[{1,27},{2,68172}]',27,68172,50651),(30010302,231,240,'[{1,28},{2,138088}]',28,138088,58754),(30010302,241,250,'[{1,29},{2,123028}]',29,123028,68939),(30010302,251,260,'[{1,30},{2,153866}]',30,153866,71718),(30010302,261,270,'[{1,31},{2,177257}]',31,177257,74608),(30010302,271,280,'[{1,32},{2,200873}]',32,200873,78149),(30010302,281,290,'[{1,33},{2,224671}]',33,224671,77646),(30010302,291,300,'[{1,34},{2,248604}]',34,248604,81843),(30010302,301,310,'[{1,35},{2,274407}]',35,274407,83512),(30010302,311,320,'[{1,36},{2,316210}]',36,316210,82852),(30010302,321,330,'[{1,37},{2,358072}]',37,358072,88149),(30010302,331,340,'[{1,38},{2,399955}]',38,399955,93458),(30010302,341,350,'[{1,39},{2,441826}]',39,441826,93840),(30010302,351,360,'[{1,40},{2,486556}]',40,486556,100807),(30010302,361,370,'[{1,41},{2,557960}]',41,557960,107503),(30010302,371,380,'[{1,42},{2,629945}]',42,629945,162889),(30010302,381,390,'[{1,43},{2,702304}]',43,702304,204966),(30010302,391,400,'[{1,44},{2,774922}]',44,774922,227373),(30010302,401,410,'[{1,45},{2,845998}]',45,845998,249781),(30010302,411,420,'[{1,46},{2,901669}]',46,901669,272189),(30010302,421,430,'[{1,47},{2,957268}]',47,957268,294596),(30010302,431,440,'[{1,48},{2,1012780}]',48,1012780,317004),(30010302,441,450,'[{1,49},{2,1068187}]',49,1068187,337747),(30010302,451,460,'[{1,50},{2,1126880}]',50,1126880,393967),(30010302,461,470,'[{1,51},{2,1216111}]',51,1216111,431820),(30010302,471,480,'[{1,52},{2,1305335}]',52,1305335,471353),(30010302,481,490,'[{1,53},{2,1394513}]',53,1394513,488158),(30010302,491,500,'[{1,54},{2,1483615}]',54,1483615,504964),(30010302,501,510,'[{1,55},{2,1574628}]',55,1574628,521770),(30010302,511,520,'[{1,56},{2,1683538}]',56,1683538,538575),(30010302,521,530,'[{1,57},{2,1792168}]',57,1792168,599031),(30010302,531,540,'[{1,58},{2,1900522}]',58,1900522,641946),(30010302,541,550,'[{1,59},{2,2008605}]',59,2008605,781437),(30010302,551,560,'[{1,60},{2,2116502}]',60,2116502,867425),(30010302,561,570,'[{1,61},{2,2224972}]',61,2224972,957893),(30010302,571,580,'[{1,62},{2,2333302}]',62,2333302,1002709),(30010302,581,590,'[{1,63},{2,2441473}]',63,2441473,1047524),(30010302,591,600,'[{1,64},{2,2549474}]',64,2549474,1092339),(30010302,601,610,'[{1,65},{2,2659075}]',65,2659075,1137154),(30010302,611,620,'[{1,66},{2,2784464}]',66,2784464,1181970),(30010302,621,630,'[{1,67},{2,2909606}]',67,2909606,1226785),(30010302,631,640,'[{1,68},{2,3034497}]',68,3034497,1271600),(30010302,641,650,'[{1,69},{2,3159135}]',69,3159135,1316415),(30010302,651,660,'[{1,70},{2,3285890}]',70,3285890,1361231),(30010302,661,670,'[{1,71},{2,3433770}]',71,3433770,1406046),(30010302,671,680,'[{1,72},{2,3581431}]',72,3581431,1450861),(30010302,681,690,'[{1,73},{2,3728862}]',73,3728862,1495676),(30010302,691,700,'[{1,74},{2,3876053}]',74,3876053,1540491),(30010302,701,710,'[{1,75},{2,4021247}]',75,4021247,1585307),(30010302,711,720,'[{1,76},{2,4150439}]',76,4150439,1630122),(30010302,721,730,'[{1,77},{2,4279346}]',77,4279346,1674937),(30010302,731,740,'[{1,78},{2,4407970}]',78,4407970,1719752),(30010302,741,750,'[{1,79},{2,4536308}]',79,4536308,1764568),(30010302,751,760,'[{1,80},{2,4666473}]',80,4666473,1809382),(30010302,761,770,'[{1,81},{2,4815349}]',81,4815349,1854198),(30010302,771,780,'[{1,82},{2,4963907}]',82,4963907,1899013),(30010302,781,790,'[{1,83},{2,5112150}]',83,5112150,1943828),(30010302,791,800,'[{1,83},{2,5260080}]',83,5260080,1988643),(30010302,801,1000,'[{1,83},{2,5391044}]',83,5391044,1988643),(30010303,1,70,'[{1,25},{2,26319}]',25,26319,32075),(30010303,71,119,'[{1,26},{2,26319}]',26,26319,32075),(30010303,120,149,'[{1,27},{2,43439}]',27,43439,35000),(30010303,150,169,'[{1,28},{2,46803}]',28,46803,35000),(30010303,170,190,'[{1,27},{2,54535}]',27,54535,36400),(30010303,191,230,'[{1,27},{2,68172}]',27,68172,50651),(30010303,231,240,'[{1,28},{2,138088}]',28,138088,58754),(30010303,241,250,'[{1,29},{2,123028}]',29,123028,68939),(30010303,251,260,'[{1,30},{2,153866}]',30,153866,71718),(30010303,261,270,'[{1,31},{2,177257}]',31,177257,74608),(30010303,271,280,'[{1,32},{2,200873}]',32,200873,78149),(30010303,281,290,'[{1,33},{2,224671}]',33,224671,77646),(30010303,291,300,'[{1,34},{2,248604}]',34,248604,81843),(30010303,301,310,'[{1,35},{2,274407}]',35,274407,83512),(30010303,311,320,'[{1,36},{2,316210}]',36,316210,82852),(30010303,321,330,'[{1,37},{2,358072}]',37,358072,88149),(30010303,331,340,'[{1,38},{2,399955}]',38,399955,93458),(30010303,341,350,'[{1,39},{2,441826}]',39,441826,93840),(30010303,351,360,'[{1,40},{2,486556}]',40,486556,100807),(30010303,361,370,'[{1,41},{2,557960}]',41,557960,107503),(30010303,371,380,'[{1,42},{2,629945}]',42,629945,162889),(30010303,381,390,'[{1,43},{2,702304}]',43,702304,204966),(30010303,391,400,'[{1,44},{2,774922}]',44,774922,227373),(30010303,401,410,'[{1,45},{2,845998}]',45,845998,249781),(30010303,411,420,'[{1,46},{2,901669}]',46,901669,272189),(30010303,421,430,'[{1,47},{2,957268}]',47,957268,294596),(30010303,431,440,'[{1,48},{2,1012780}]',48,1012780,317004),(30010303,441,450,'[{1,49},{2,1068187}]',49,1068187,337747),(30010303,451,460,'[{1,50},{2,1126880}]',50,1126880,393967),(30010303,461,470,'[{1,51},{2,1216111}]',51,1216111,431820),(30010303,471,480,'[{1,52},{2,1305335}]',52,1305335,471353),(30010303,481,490,'[{1,53},{2,1394513}]',53,1394513,488158),(30010303,491,500,'[{1,54},{2,1483615}]',54,1483615,504964),(30010303,501,510,'[{1,55},{2,1574628}]',55,1574628,521770),(30010303,511,520,'[{1,56},{2,1683538}]',56,1683538,538575),(30010303,521,530,'[{1,57},{2,1792168}]',57,1792168,599031),(30010303,531,540,'[{1,58},{2,1900522}]',58,1900522,641946),(30010303,541,550,'[{1,59},{2,2008605}]',59,2008605,781437),(30010303,551,560,'[{1,60},{2,2116502}]',60,2116502,867425),(30010303,561,570,'[{1,61},{2,2224972}]',61,2224972,957893),(30010303,571,580,'[{1,62},{2,2333302}]',62,2333302,1002709),(30010303,581,590,'[{1,63},{2,2441473}]',63,2441473,1047524),(30010303,591,600,'[{1,64},{2,2549474}]',64,2549474,1092339),(30010303,601,610,'[{1,65},{2,2659075}]',65,2659075,1137154),(30010303,611,620,'[{1,66},{2,2784464}]',66,2784464,1181970),(30010303,621,630,'[{1,67},{2,2909606}]',67,2909606,1226785),(30010303,631,640,'[{1,68},{2,3034497}]',68,3034497,1271600),(30010303,641,650,'[{1,69},{2,3159135}]',69,3159135,1316415),(30010303,651,660,'[{1,70},{2,3285890}]',70,3285890,1361231),(30010303,661,670,'[{1,71},{2,3433770}]',71,3433770,1406046),(30010303,671,680,'[{1,72},{2,3581431}]',72,3581431,1450861),(30010303,681,690,'[{1,73},{2,3728862}]',73,3728862,1495676),(30010303,691,700,'[{1,74},{2,3876053}]',74,3876053,1540491),(30010303,701,710,'[{1,75},{2,4021247}]',75,4021247,1585307),(30010303,711,720,'[{1,76},{2,4150439}]',76,4150439,1630122),(30010303,721,730,'[{1,77},{2,4279346}]',77,4279346,1674937),(30010303,731,740,'[{1,78},{2,4407970}]',78,4407970,1719752),(30010303,741,750,'[{1,79},{2,4536308}]',79,4536308,1764568),(30010303,751,760,'[{1,80},{2,4666473}]',80,4666473,1809382),(30010303,761,770,'[{1,81},{2,4815349}]',81,4815349,1854198),(30010303,771,780,'[{1,82},{2,4963907}]',82,4963907,1899013),(30010303,781,790,'[{1,83},{2,5112150}]',83,5112150,1943828),(30010303,791,800,'[{1,83},{2,5260080}]',83,5260080,1988643),(30010303,801,1000,'[{1,83},{2,5391044}]',83,5391044,1988643),(30010304,1,70,'[{1,25},{2,26319}]',25,26319,32075),(30010304,71,119,'[{1,26},{2,26319}]',26,26319,32075),(30010304,120,149,'[{1,27},{2,43439}]',27,43439,35000),(30010304,150,169,'[{1,28},{2,46803}]',28,46803,35000),(30010304,170,190,'[{1,27},{2,54535}]',27,54535,36400),(30010304,191,230,'[{1,27},{2,68172}]',27,68172,50651),(30010304,231,240,'[{1,28},{2,138088}]',28,138088,58754),(30010304,241,250,'[{1,29},{2,123028}]',29,123028,68939),(30010304,251,260,'[{1,30},{2,153866}]',30,153866,71718),(30010304,261,270,'[{1,31},{2,177257}]',31,177257,74608),(30010304,271,280,'[{1,32},{2,200873}]',32,200873,78149),(30010304,281,290,'[{1,33},{2,224671}]',33,224671,77646),(30010304,291,300,'[{1,34},{2,248604}]',34,248604,81843),(30010304,301,310,'[{1,35},{2,274407}]',35,274407,83512),(30010304,311,320,'[{1,36},{2,316210}]',36,316210,82852),(30010304,321,330,'[{1,37},{2,358072}]',37,358072,88149),(30010304,331,340,'[{1,38},{2,399955}]',38,399955,93458),(30010304,341,350,'[{1,39},{2,441826}]',39,441826,93840),(30010304,351,360,'[{1,40},{2,486556}]',40,486556,100807),(30010304,361,370,'[{1,41},{2,557960}]',41,557960,107503),(30010304,371,380,'[{1,42},{2,629945}]',42,629945,162889),(30010304,381,390,'[{1,43},{2,702304}]',43,702304,204966),(30010304,391,400,'[{1,44},{2,774922}]',44,774922,227373),(30010304,401,410,'[{1,45},{2,845998}]',45,845998,249781),(30010304,411,420,'[{1,46},{2,901669}]',46,901669,272189),(30010304,421,430,'[{1,47},{2,957268}]',47,957268,294596),(30010304,431,440,'[{1,48},{2,1012780}]',48,1012780,317004),(30010304,441,450,'[{1,49},{2,1068187}]',49,1068187,337747),(30010304,451,460,'[{1,50},{2,1126880}]',50,1126880,393967),(30010304,461,470,'[{1,51},{2,1216111}]',51,1216111,431820),(30010304,471,480,'[{1,52},{2,1305335}]',52,1305335,471353),(30010304,481,490,'[{1,53},{2,1394513}]',53,1394513,488158),(30010304,491,500,'[{1,54},{2,1483615}]',54,1483615,504964),(30010304,501,510,'[{1,55},{2,1574628}]',55,1574628,521770),(30010304,511,520,'[{1,56},{2,1683538}]',56,1683538,538575),(30010304,521,530,'[{1,57},{2,1792168}]',57,1792168,599031),(30010304,531,540,'[{1,58},{2,1900522}]',58,1900522,641946),(30010304,541,550,'[{1,59},{2,2008605}]',59,2008605,781437),(30010304,551,560,'[{1,60},{2,2116502}]',60,2116502,867425),(30010304,561,570,'[{1,61},{2,2224972}]',61,2224972,957893),(30010304,571,580,'[{1,62},{2,2333302}]',62,2333302,1002709),(30010304,581,590,'[{1,63},{2,2441473}]',63,2441473,1047524),(30010304,591,600,'[{1,64},{2,2549474}]',64,2549474,1092339),(30010304,601,610,'[{1,65},{2,2659075}]',65,2659075,1137154),(30010304,611,620,'[{1,66},{2,2784464}]',66,2784464,1181970),(30010304,621,630,'[{1,67},{2,2909606}]',67,2909606,1226785),(30010304,631,640,'[{1,68},{2,3034497}]',68,3034497,1271600),(30010304,641,650,'[{1,69},{2,3159135}]',69,3159135,1316415),(30010304,651,660,'[{1,70},{2,3285890}]',70,3285890,1361231),(30010304,661,670,'[{1,71},{2,3433770}]',71,3433770,1406046),(30010304,671,680,'[{1,72},{2,3581431}]',72,3581431,1450861),(30010304,681,690,'[{1,73},{2,3728862}]',73,3728862,1495676),(30010304,691,700,'[{1,74},{2,3876053}]',74,3876053,1540491),(30010304,701,710,'[{1,75},{2,4021247}]',75,4021247,1585307),(30010304,711,720,'[{1,76},{2,4150439}]',76,4150439,1630122),(30010304,721,730,'[{1,77},{2,4279346}]',77,4279346,1674937),(30010304,731,740,'[{1,78},{2,4407970}]',78,4407970,1719752),(30010304,741,750,'[{1,79},{2,4536308}]',79,4536308,1764568),(30010304,751,760,'[{1,80},{2,4666473}]',80,4666473,1809382),(30010304,761,770,'[{1,81},{2,4815349}]',81,4815349,1854198),(30010304,771,780,'[{1,82},{2,4963907}]',82,4963907,1899013),(30010304,781,790,'[{1,83},{2,5112150}]',83,5112150,1943828),(30010304,791,800,'[{1,83},{2,5260080}]',83,5260080,1988643),(30010304,801,1000,'[{1,83},{2,5391044}]',83,5391044,1988643),(30010305,1,70,'[{1,25},{2,26319}]',25,26319,32075),(30010305,71,119,'[{1,26},{2,26319}]',26,26319,32075),(30010305,120,149,'[{1,27},{2,43439}]',27,43439,35000),(30010305,150,169,'[{1,28},{2,46803}]',28,46803,35000),(30010305,170,190,'[{1,27},{2,54535}]',27,54535,36400),(30010305,191,230,'[{1,27},{2,68172}]',27,68172,50651),(30010305,231,240,'[{1,28},{2,138088}]',28,138088,58754),(30010305,241,250,'[{1,29},{2,123028}]',29,123028,68939),(30010305,251,260,'[{1,30},{2,153866}]',30,153866,71718),(30010305,261,270,'[{1,31},{2,177257}]',31,177257,74608),(30010305,271,280,'[{1,32},{2,200873}]',32,200873,78149),(30010305,281,290,'[{1,33},{2,224671}]',33,224671,77646),(30010305,291,300,'[{1,34},{2,248604}]',34,248604,81843),(30010305,301,310,'[{1,35},{2,274407}]',35,274407,83512),(30010305,311,320,'[{1,36},{2,316210}]',36,316210,82852),(30010305,321,330,'[{1,37},{2,358072}]',37,358072,88149),(30010305,331,340,'[{1,38},{2,399955}]',38,399955,93458),(30010305,341,350,'[{1,39},{2,441826}]',39,441826,93840),(30010305,351,360,'[{1,40},{2,486556}]',40,486556,100807),(30010305,361,370,'[{1,41},{2,557960}]',41,557960,107503),(30010305,371,380,'[{1,42},{2,629945}]',42,629945,162889),(30010305,381,390,'[{1,43},{2,702304}]',43,702304,204966),(30010305,391,400,'[{1,44},{2,774922}]',44,774922,227373),(30010305,401,410,'[{1,45},{2,845998}]',45,845998,249781),(30010305,411,420,'[{1,46},{2,901669}]',46,901669,272189),(30010305,421,430,'[{1,47},{2,957268}]',47,957268,294596),(30010305,431,440,'[{1,48},{2,1012780}]',48,1012780,317004),(30010305,441,450,'[{1,49},{2,1068187}]',49,1068187,337747),(30010305,451,460,'[{1,50},{2,1126880}]',50,1126880,393967),(30010305,461,470,'[{1,51},{2,1216111}]',51,1216111,431820),(30010305,471,480,'[{1,52},{2,1305335}]',52,1305335,471353),(30010305,481,490,'[{1,53},{2,1394513}]',53,1394513,488158),(30010305,491,500,'[{1,54},{2,1483615}]',54,1483615,504964),(30010305,501,510,'[{1,55},{2,1574628}]',55,1574628,521770),(30010305,511,520,'[{1,56},{2,1683538}]',56,1683538,538575),(30010305,521,530,'[{1,57},{2,1792168}]',57,1792168,599031),(30010305,531,540,'[{1,58},{2,1900522}]',58,1900522,641946),(30010305,541,550,'[{1,59},{2,2008605}]',59,2008605,781437),(30010305,551,560,'[{1,60},{2,2116502}]',60,2116502,867425),(30010305,561,570,'[{1,61},{2,2224972}]',61,2224972,957893),(30010305,571,580,'[{1,62},{2,2333302}]',62,2333302,1002709),(30010305,581,590,'[{1,63},{2,2441473}]',63,2441473,1047524),(30010305,591,600,'[{1,64},{2,2549474}]',64,2549474,1092339),(30010305,601,610,'[{1,65},{2,2659075}]',65,2659075,1137154),(30010305,611,620,'[{1,66},{2,2784464}]',66,2784464,1181970),(30010305,621,630,'[{1,67},{2,2909606}]',67,2909606,1226785),(30010305,631,640,'[{1,68},{2,3034497}]',68,3034497,1271600),(30010305,641,650,'[{1,69},{2,3159135}]',69,3159135,1316415),(30010305,651,660,'[{1,70},{2,3285890}]',70,3285890,1361231),(30010305,661,670,'[{1,71},{2,3433770}]',71,3433770,1406046),(30010305,671,680,'[{1,72},{2,3581431}]',72,3581431,1450861),(30010305,681,690,'[{1,73},{2,3728862}]',73,3728862,1495676),(30010305,691,700,'[{1,74},{2,3876053}]',74,3876053,1540491),(30010305,701,710,'[{1,75},{2,4021247}]',75,4021247,1585307),(30010305,711,720,'[{1,76},{2,4150439}]',76,4150439,1630122),(30010305,721,730,'[{1,77},{2,4279346}]',77,4279346,1674937),(30010305,731,740,'[{1,78},{2,4407970}]',78,4407970,1719752),(30010305,741,750,'[{1,79},{2,4536308}]',79,4536308,1764568),(30010305,751,760,'[{1,80},{2,4666473}]',80,4666473,1809382),(30010305,761,770,'[{1,81},{2,4815349}]',81,4815349,1854198),(30010305,771,780,'[{1,82},{2,4963907}]',82,4963907,1899013),(30010305,781,790,'[{1,83},{2,5112150}]',83,5112150,1943828),(30010305,791,800,'[{1,83},{2,5260080}]',83,5260080,1988643),(30010305,801,1000,'[{1,83},{2,5391044}]',83,5391044,1988643),(30010306,1,70,'[{1,25},{2,26319}]',25,26319,32075),(30010306,71,119,'[{1,26},{2,26319}]',26,26319,32075),(30010306,120,149,'[{1,27},{2,43439}]',27,43439,35000),(30010306,150,169,'[{1,28},{2,46803}]',28,46803,35000),(30010306,170,190,'[{1,27},{2,54535}]',27,54535,36400),(30010306,191,230,'[{1,27},{2,68172}]',27,68172,50651),(30010306,231,240,'[{1,28},{2,138088}]',28,138088,58754),(30010306,241,250,'[{1,29},{2,123028}]',29,123028,68939),(30010306,251,260,'[{1,30},{2,153866}]',30,153866,71718),(30010306,261,270,'[{1,31},{2,177257}]',31,177257,74608),(30010306,271,280,'[{1,32},{2,200873}]',32,200873,78149),(30010306,281,290,'[{1,33},{2,224671}]',33,224671,77646),(30010306,291,300,'[{1,34},{2,248604}]',34,248604,81843),(30010306,301,310,'[{1,35},{2,274407}]',35,274407,83512),(30010306,311,320,'[{1,36},{2,316210}]',36,316210,82852),(30010306,321,330,'[{1,37},{2,358072}]',37,358072,88149),(30010306,331,340,'[{1,38},{2,399955}]',38,399955,93458),(30010306,341,350,'[{1,39},{2,441826}]',39,441826,93840),(30010306,351,360,'[{1,40},{2,486556}]',40,486556,100807),(30010306,361,370,'[{1,41},{2,557960}]',41,557960,107503),(30010306,371,380,'[{1,42},{2,629945}]',42,629945,162889),(30010306,381,390,'[{1,43},{2,702304}]',43,702304,204966),(30010306,391,400,'[{1,44},{2,774922}]',44,774922,227373),(30010306,401,410,'[{1,45},{2,845998}]',45,845998,249781),(30010306,411,420,'[{1,46},{2,901669}]',46,901669,272189),(30010306,421,430,'[{1,47},{2,957268}]',47,957268,294596),(30010306,431,440,'[{1,48},{2,1012780}]',48,1012780,317004),(30010306,441,450,'[{1,49},{2,1068187}]',49,1068187,337747),(30010306,451,460,'[{1,50},{2,1126880}]',50,1126880,393967),(30010306,461,470,'[{1,51},{2,1216111}]',51,1216111,431820),(30010306,471,480,'[{1,52},{2,1305335}]',52,1305335,471353),(30010306,481,490,'[{1,53},{2,1394513}]',53,1394513,488158),(30010306,491,500,'[{1,54},{2,1483615}]',54,1483615,504964),(30010306,501,510,'[{1,55},{2,1574628}]',55,1574628,521770),(30010306,511,520,'[{1,56},{2,1683538}]',56,1683538,538575),(30010306,521,530,'[{1,57},{2,1792168}]',57,1792168,599031),(30010306,531,540,'[{1,58},{2,1900522}]',58,1900522,641946),(30010306,541,550,'[{1,59},{2,2008605}]',59,2008605,781437),(30010306,551,560,'[{1,60},{2,2116502}]',60,2116502,867425),(30010306,561,570,'[{1,61},{2,2224972}]',61,2224972,957893),(30010306,571,580,'[{1,62},{2,2333302}]',62,2333302,1002709),(30010306,581,590,'[{1,63},{2,2441473}]',63,2441473,1047524),(30010306,591,600,'[{1,64},{2,2549474}]',64,2549474,1092339),(30010306,601,610,'[{1,65},{2,2659075}]',65,2659075,1137154),(30010306,611,620,'[{1,66},{2,2784464}]',66,2784464,1181970),(30010306,621,630,'[{1,67},{2,2909606}]',67,2909606,1226785),(30010306,631,640,'[{1,68},{2,3034497}]',68,3034497,1271600),(30010306,641,650,'[{1,69},{2,3159135}]',69,3159135,1316415),(30010306,651,660,'[{1,70},{2,3285890}]',70,3285890,1361231),(30010306,661,670,'[{1,71},{2,3433770}]',71,3433770,1406046),(30010306,671,680,'[{1,72},{2,3581431}]',72,3581431,1450861),(30010306,681,690,'[{1,73},{2,3728862}]',73,3728862,1495676),(30010306,691,700,'[{1,74},{2,3876053}]',74,3876053,1540491),(30010306,701,710,'[{1,75},{2,4021247}]',75,4021247,1585307),(30010306,711,720,'[{1,76},{2,4150439}]',76,4150439,1630122),(30010306,721,730,'[{1,77},{2,4279346}]',77,4279346,1674937),(30010306,731,740,'[{1,78},{2,4407970}]',78,4407970,1719752),(30010306,741,750,'[{1,79},{2,4536308}]',79,4536308,1764568),(30010306,751,760,'[{1,80},{2,4666473}]',80,4666473,1809382),(30010306,761,770,'[{1,81},{2,4815349}]',81,4815349,1854198),(30010306,771,780,'[{1,82},{2,4963907}]',82,4963907,1899013),(30010306,781,790,'[{1,83},{2,5112150}]',83,5112150,1943828),(30010306,791,800,'[{1,83},{2,5260080}]',83,5260080,1988643),(30010306,801,1000,'[{1,83},{2,5391044}]',83,5391044,1988643),(30010307,1,70,'[{1,25},{2,26319}]',25,26319,32075),(30010307,71,119,'[{1,26},{2,26319}]',26,26319,32075),(30010307,120,149,'[{1,27},{2,43439}]',27,43439,35000),(30010307,150,169,'[{1,28},{2,46803}]',28,46803,35000),(30010307,170,190,'[{1,27},{2,54535}]',27,54535,36400),(30010307,191,230,'[{1,27},{2,68172}]',27,68172,50651),(30010307,231,240,'[{1,28},{2,138088}]',28,138088,58754),(30010307,241,250,'[{1,29},{2,123028}]',29,123028,68939),(30010307,251,260,'[{1,30},{2,153866}]',30,153866,71718),(30010307,261,270,'[{1,31},{2,177257}]',31,177257,74608),(30010307,271,280,'[{1,32},{2,200873}]',32,200873,78149),(30010307,281,290,'[{1,33},{2,224671}]',33,224671,77646),(30010307,291,300,'[{1,34},{2,248604}]',34,248604,81843),(30010307,301,310,'[{1,35},{2,274407}]',35,274407,83512),(30010307,311,320,'[{1,36},{2,316210}]',36,316210,82852),(30010307,321,330,'[{1,37},{2,358072}]',37,358072,88149),(30010307,331,340,'[{1,38},{2,399955}]',38,399955,93458),(30010307,341,350,'[{1,39},{2,441826}]',39,441826,93840),(30010307,351,360,'[{1,40},{2,486556}]',40,486556,100807),(30010307,361,370,'[{1,41},{2,557960}]',41,557960,107503),(30010307,371,380,'[{1,42},{2,629945}]',42,629945,162889),(30010307,381,390,'[{1,43},{2,702304}]',43,702304,204966),(30010307,391,400,'[{1,44},{2,774922}]',44,774922,227373),(30010307,401,410,'[{1,45},{2,845998}]',45,845998,249781),(30010307,411,420,'[{1,46},{2,901669}]',46,901669,272189),(30010307,421,430,'[{1,47},{2,957268}]',47,957268,294596),(30010307,431,440,'[{1,48},{2,1012780}]',48,1012780,317004),(30010307,441,450,'[{1,49},{2,1068187}]',49,1068187,337747),(30010307,451,460,'[{1,50},{2,1126880}]',50,1126880,393967),(30010307,461,470,'[{1,51},{2,1216111}]',51,1216111,431820),(30010307,471,480,'[{1,52},{2,1305335}]',52,1305335,471353),(30010307,481,490,'[{1,53},{2,1394513}]',53,1394513,488158),(30010307,491,500,'[{1,54},{2,1483615}]',54,1483615,504964),(30010307,501,510,'[{1,55},{2,1574628}]',55,1574628,521770),(30010307,511,520,'[{1,56},{2,1683538}]',56,1683538,538575),(30010307,521,530,'[{1,57},{2,1792168}]',57,1792168,599031),(30010307,531,540,'[{1,58},{2,1900522}]',58,1900522,641946),(30010307,541,550,'[{1,59},{2,2008605}]',59,2008605,781437),(30010307,551,560,'[{1,60},{2,2116502}]',60,2116502,867425),(30010307,561,570,'[{1,61},{2,2224972}]',61,2224972,957893),(30010307,571,580,'[{1,62},{2,2333302}]',62,2333302,1002709),(30010307,581,590,'[{1,63},{2,2441473}]',63,2441473,1047524),(30010307,591,600,'[{1,64},{2,2549474}]',64,2549474,1092339),(30010307,601,610,'[{1,65},{2,2659075}]',65,2659075,1137154),(30010307,611,620,'[{1,66},{2,2784464}]',66,2784464,1181970),(30010307,621,630,'[{1,67},{2,2909606}]',67,2909606,1226785),(30010307,631,640,'[{1,68},{2,3034497}]',68,3034497,1271600),(30010307,641,650,'[{1,69},{2,3159135}]',69,3159135,1316415),(30010307,651,660,'[{1,70},{2,3285890}]',70,3285890,1361231),(30010307,661,670,'[{1,71},{2,3433770}]',71,3433770,1406046),(30010307,671,680,'[{1,72},{2,3581431}]',72,3581431,1450861),(30010307,681,690,'[{1,73},{2,3728862}]',73,3728862,1495676),(30010307,691,700,'[{1,74},{2,3876053}]',74,3876053,1540491),(30010307,701,710,'[{1,75},{2,4021247}]',75,4021247,1585307),(30010307,711,720,'[{1,76},{2,4150439}]',76,4150439,1630122),(30010307,721,730,'[{1,77},{2,4279346}]',77,4279346,1674937),(30010307,731,740,'[{1,78},{2,4407970}]',78,4407970,1719752),(30010307,741,750,'[{1,79},{2,4536308}]',79,4536308,1764568),(30010307,751,760,'[{1,80},{2,4666473}]',80,4666473,1809382),(30010307,761,770,'[{1,81},{2,4815349}]',81,4815349,1854198),(30010307,771,780,'[{1,82},{2,4963907}]',82,4963907,1899013),(30010307,781,790,'[{1,83},{2,5112150}]',83,5112150,1943828),(30010307,791,800,'[{1,83},{2,5260080}]',83,5260080,1988643),(30010307,801,1000,'[{1,83},{2,5391044}]',83,5391044,1988643),(30010308,1,70,'[{1,25},{2,26319}]',25,26319,32075),(30010308,71,119,'[{1,26},{2,26319}]',26,26319,32075),(30010308,120,149,'[{1,27},{2,43439}]',27,43439,35000),(30010308,150,169,'[{1,28},{2,46803}]',28,46803,35000),(30010308,170,190,'[{1,27},{2,54535}]',27,54535,36400),(30010308,191,230,'[{1,27},{2,68172}]',27,68172,50651),(30010308,231,240,'[{1,28},{2,138088}]',28,138088,58754),(30010308,241,250,'[{1,29},{2,123028}]',29,123028,68939),(30010308,251,260,'[{1,30},{2,153866}]',30,153866,71718),(30010308,261,270,'[{1,31},{2,177257}]',31,177257,74608),(30010308,271,280,'[{1,32},{2,200873}]',32,200873,78149),(30010308,281,290,'[{1,33},{2,224671}]',33,224671,77646),(30010308,291,300,'[{1,34},{2,248604}]',34,248604,81843),(30010308,301,310,'[{1,35},{2,274407}]',35,274407,83512),(30010308,311,320,'[{1,36},{2,316210}]',36,316210,82852),(30010308,321,330,'[{1,37},{2,358072}]',37,358072,88149),(30010308,331,340,'[{1,38},{2,399955}]',38,399955,93458),(30010308,341,350,'[{1,39},{2,441826}]',39,441826,93840),(30010308,351,360,'[{1,40},{2,486556}]',40,486556,100807),(30010308,361,370,'[{1,41},{2,557960}]',41,557960,107503),(30010308,371,380,'[{1,42},{2,629945}]',42,629945,162889),(30010308,381,390,'[{1,43},{2,702304}]',43,702304,204966),(30010308,391,400,'[{1,44},{2,774922}]',44,774922,227373),(30010308,401,410,'[{1,45},{2,845998}]',45,845998,249781),(30010308,411,420,'[{1,46},{2,901669}]',46,901669,272189),(30010308,421,430,'[{1,47},{2,957268}]',47,957268,294596),(30010308,431,440,'[{1,48},{2,1012780}]',48,1012780,317004),(30010308,441,450,'[{1,49},{2,1068187}]',49,1068187,337747),(30010308,451,460,'[{1,50},{2,1126880}]',50,1126880,393967),(30010308,461,470,'[{1,51},{2,1216111}]',51,1216111,431820),(30010308,471,480,'[{1,52},{2,1305335}]',52,1305335,471353),(30010308,481,490,'[{1,53},{2,1394513}]',53,1394513,488158),(30010308,491,500,'[{1,54},{2,1483615}]',54,1483615,504964),(30010308,501,510,'[{1,55},{2,1574628}]',55,1574628,521770),(30010308,511,520,'[{1,56},{2,1683538}]',56,1683538,538575),(30010308,521,530,'[{1,57},{2,1792168}]',57,1792168,599031),(30010308,531,540,'[{1,58},{2,1900522}]',58,1900522,641946),(30010308,541,550,'[{1,59},{2,2008605}]',59,2008605,781437),(30010308,551,560,'[{1,60},{2,2116502}]',60,2116502,867425),(30010308,561,570,'[{1,61},{2,2224972}]',61,2224972,957893),(30010308,571,580,'[{1,62},{2,2333302}]',62,2333302,1002709),(30010308,581,590,'[{1,63},{2,2441473}]',63,2441473,1047524),(30010308,591,600,'[{1,64},{2,2549474}]',64,2549474,1092339),(30010308,601,610,'[{1,65},{2,2659075}]',65,2659075,1137154),(30010308,611,620,'[{1,66},{2,2784464}]',66,2784464,1181970),(30010308,621,630,'[{1,67},{2,2909606}]',67,2909606,1226785),(30010308,631,640,'[{1,68},{2,3034497}]',68,3034497,1271600),(30010308,641,650,'[{1,69},{2,3159135}]',69,3159135,1316415),(30010308,651,660,'[{1,70},{2,3285890}]',70,3285890,1361231),(30010308,661,670,'[{1,71},{2,3433770}]',71,3433770,1406046),(30010308,671,680,'[{1,72},{2,3581431}]',72,3581431,1450861),(30010308,681,690,'[{1,73},{2,3728862}]',73,3728862,1495676),(30010308,691,700,'[{1,74},{2,3876053}]',74,3876053,1540491),(30010308,701,710,'[{1,75},{2,4021247}]',75,4021247,1585307),(30010308,711,720,'[{1,76},{2,4150439}]',76,4150439,1630122),(30010308,721,730,'[{1,77},{2,4279346}]',77,4279346,1674937),(30010308,731,740,'[{1,78},{2,4407970}]',78,4407970,1719752),(30010308,741,750,'[{1,79},{2,4536308}]',79,4536308,1764568),(30010308,751,760,'[{1,80},{2,4666473}]',80,4666473,1809382),(30010308,761,770,'[{1,81},{2,4815349}]',81,4815349,1854198),(30010308,771,780,'[{1,82},{2,4963907}]',82,4963907,1899013),(30010308,781,790,'[{1,83},{2,5112150}]',83,5112150,1943828),(30010308,791,800,'[{1,83},{2,5260080}]',83,5260080,1988643),(30010308,801,1000,'[{1,83},{2,5391044}]',83,5391044,1988643),(30010309,1,70,'[{1,25},{2,26319}]',25,26319,32075),(30010309,71,119,'[{1,26},{2,26319}]',26,26319,32075),(30010309,120,149,'[{1,27},{2,43439}]',27,43439,35000),(30010309,150,169,'[{1,28},{2,46803}]',28,46803,35000),(30010309,170,190,'[{1,27},{2,54535}]',27,54535,36400),(30010309,191,230,'[{1,27},{2,68172}]',27,68172,50651),(30010309,231,240,'[{1,28},{2,138088}]',28,138088,58754),(30010309,241,250,'[{1,29},{2,123028}]',29,123028,68939),(30010309,251,260,'[{1,30},{2,153866}]',30,153866,71718),(30010309,261,270,'[{1,31},{2,177257}]',31,177257,74608),(30010309,271,280,'[{1,32},{2,200873}]',32,200873,78149),(30010309,281,290,'[{1,33},{2,224671}]',33,224671,77646),(30010309,291,300,'[{1,34},{2,248604}]',34,248604,81843),(30010309,301,310,'[{1,35},{2,274407}]',35,274407,83512),(30010309,311,320,'[{1,36},{2,316210}]',36,316210,82852),(30010309,321,330,'[{1,37},{2,358072}]',37,358072,88149),(30010309,331,340,'[{1,38},{2,399955}]',38,399955,93458),(30010309,341,350,'[{1,39},{2,441826}]',39,441826,93840),(30010309,351,360,'[{1,40},{2,486556}]',40,486556,100807),(30010309,361,370,'[{1,41},{2,557960}]',41,557960,107503),(30010309,371,380,'[{1,42},{2,629945}]',42,629945,162889),(30010309,381,390,'[{1,43},{2,702304}]',43,702304,204966),(30010309,391,400,'[{1,44},{2,774922}]',44,774922,227373),(30010309,401,410,'[{1,45},{2,845998}]',45,845998,249781),(30010309,411,420,'[{1,46},{2,901669}]',46,901669,272189),(30010309,421,430,'[{1,47},{2,957268}]',47,957268,294596),(30010309,431,440,'[{1,48},{2,1012780}]',48,1012780,317004),(30010309,441,450,'[{1,49},{2,1068187}]',49,1068187,337747),(30010309,451,460,'[{1,50},{2,1126880}]',50,1126880,393967),(30010309,461,470,'[{1,51},{2,1216111}]',51,1216111,431820),(30010309,471,480,'[{1,52},{2,1305335}]',52,1305335,471353),(30010309,481,490,'[{1,53},{2,1394513}]',53,1394513,488158),(30010309,491,500,'[{1,54},{2,1483615}]',54,1483615,504964),(30010309,501,510,'[{1,55},{2,1574628}]',55,1574628,521770),(30010309,511,520,'[{1,56},{2,1683538}]',56,1683538,538575),(30010309,521,530,'[{1,57},{2,1792168}]',57,1792168,599031),(30010309,531,540,'[{1,58},{2,1900522}]',58,1900522,641946),(30010309,541,550,'[{1,59},{2,2008605}]',59,2008605,781437),(30010309,551,560,'[{1,60},{2,2116502}]',60,2116502,867425),(30010309,561,570,'[{1,61},{2,2224972}]',61,2224972,957893),(30010309,571,580,'[{1,62},{2,2333302}]',62,2333302,1002709),(30010309,581,590,'[{1,63},{2,2441473}]',63,2441473,1047524),(30010309,591,600,'[{1,64},{2,2549474}]',64,2549474,1092339),(30010309,601,610,'[{1,65},{2,2659075}]',65,2659075,1137154),(30010309,611,620,'[{1,66},{2,2784464}]',66,2784464,1181970),(30010309,621,630,'[{1,67},{2,2909606}]',67,2909606,1226785),(30010309,631,640,'[{1,68},{2,3034497}]',68,3034497,1271600),(30010309,641,650,'[{1,69},{2,3159135}]',69,3159135,1316415),(30010309,651,660,'[{1,70},{2,3285890}]',70,3285890,1361231),(30010309,661,670,'[{1,71},{2,3433770}]',71,3433770,1406046),(30010309,671,680,'[{1,72},{2,3581431}]',72,3581431,1450861),(30010309,681,690,'[{1,73},{2,3728862}]',73,3728862,1495676),(30010309,691,700,'[{1,74},{2,3876053}]',74,3876053,1540491),(30010309,701,710,'[{1,75},{2,4021247}]',75,4021247,1585307),(30010309,711,720,'[{1,76},{2,4150439}]',76,4150439,1630122),(30010309,721,730,'[{1,77},{2,4279346}]',77,4279346,1674937),(30010309,731,740,'[{1,78},{2,4407970}]',78,4407970,1719752),(30010309,741,750,'[{1,79},{2,4536308}]',79,4536308,1764568),(30010309,751,760,'[{1,80},{2,4666473}]',80,4666473,1809382),(30010309,761,770,'[{1,81},{2,4815349}]',81,4815349,1854198),(30010309,771,780,'[{1,82},{2,4963907}]',82,4963907,1899013),(30010309,781,790,'[{1,83},{2,5112150}]',83,5112150,1943828),(30010309,791,800,'[{1,83},{2,5260080}]',83,5260080,1988643),(30010309,801,1000,'[{1,83},{2,5391044}]',83,5391044,1988643),(30010401,1,70,'[{1,25},{2,30079}]',25,30079,16037),(30010401,71,119,'[{1,26},{2,30079}]',26,30079,16037),(30010401,120,149,'[{1,27},{2,49644}]',27,49644,17500),(30010401,150,169,'[{1,28},{2,53489}]',28,53489,17500),(30010401,170,190,'[{1,27},{2,62326}]',27,62326,18200),(30010401,191,230,'[{1,27},{2,77911}]',27,77911,25326),(30010401,231,240,'[{1,28},{2,157814}]',28,157814,29377),(30010401,241,250,'[{1,29},{2,140603}]',29,140603,34469),(30010401,251,260,'[{1,30},{2,175846}]',30,175846,35859),(30010401,261,270,'[{1,31},{2,202579}]',31,202579,37304),(30010401,271,280,'[{1,32},{2,229570}]',32,229570,39075),(30010401,281,290,'[{1,33},{2,256766}]',33,256766,38823),(30010401,291,300,'[{1,34},{2,284118}]',34,284118,40921),(30010401,301,310,'[{1,35},{2,313608}]',35,313608,41756),(30010401,311,320,'[{1,36},{2,361382}]',36,361382,41426),(30010401,321,330,'[{1,37},{2,409226}]',37,409226,44074),(30010401,331,340,'[{1,38},{2,457091}]',38,457091,46729),(30010401,341,350,'[{1,39},{2,504944}]',39,504944,46920),(30010401,351,360,'[{1,40},{2,556064}]',40,556064,50404),(30010401,361,370,'[{1,41},{2,637669}]',41,637669,53752),(30010401,371,380,'[{1,42},{2,719938}]',42,719938,81444),(30010401,381,390,'[{1,43},{2,802634}]',43,802634,102483),(30010401,391,400,'[{1,44},{2,885626}]',44,885626,113687),(30010401,401,410,'[{1,45},{2,966854}]',45,966854,124891),(30010401,411,420,'[{1,46},{2,1030478}]',46,1030478,136094),(30010401,421,430,'[{1,47},{2,1094021}]',47,1094021,147298),(30010401,431,440,'[{1,48},{2,1157462}]',48,1157462,158502),(30010401,441,450,'[{1,49},{2,1220786}]',49,1220786,168874),(30010401,451,460,'[{1,50},{2,1287862}]',50,1287862,196984),(30010401,461,470,'[{1,51},{2,1389842}]',51,1389842,215910),(30010401,471,480,'[{1,52},{2,1491811}]',52,1491811,235676),(30010401,481,490,'[{1,53},{2,1593730}]',53,1593730,244079),(30010401,491,500,'[{1,54},{2,1695560}]',54,1695560,252482),(30010401,501,510,'[{1,55},{2,1799574}]',55,1799574,260885),(30010401,511,520,'[{1,56},{2,1924043}]',56,1924043,269288),(30010401,521,530,'[{1,57},{2,2048192}]',57,2048192,299516),(30010401,531,540,'[{1,58},{2,2172026}]',58,2172026,320973),(30010401,541,550,'[{1,59},{2,2295549}]',59,2295549,390718),(30010401,551,560,'[{1,60},{2,2418859}]',60,2418859,433712),(30010401,561,570,'[{1,61},{2,2542826}]',61,2542826,478947),(30010401,571,580,'[{1,62},{2,2666630}]',62,2666630,501354),(30010401,581,590,'[{1,63},{2,2790254}]',63,2790254,523762),(30010401,591,600,'[{1,64},{2,2913685}]',64,2913685,546169),(30010401,601,610,'[{1,65},{2,3038942}]',65,3038942,568577),(30010401,611,620,'[{1,66},{2,3182245}]',66,3182245,590985),(30010401,621,630,'[{1,67},{2,3325264}]',67,3325264,613393),(30010401,631,640,'[{1,68},{2,3467997}]',68,3467997,635800),(30010401,641,650,'[{1,69},{2,3610440}]',69,3610440,658208),(30010401,651,660,'[{1,70},{2,3755302}]',70,3755302,680615),(30010401,661,670,'[{1,71},{2,3924309}]',71,3924309,703023),(30010401,671,680,'[{1,72},{2,4093064}]',72,4093064,725430),(30010401,681,690,'[{1,73},{2,4261557}]',73,4261557,747838),(30010401,691,700,'[{1,74},{2,4429774}]',74,4429774,770246),(30010401,701,710,'[{1,75},{2,4595710}]',75,4595710,792653),(30010401,711,720,'[{1,76},{2,4743358}]',76,4743358,815061),(30010401,721,730,'[{1,77},{2,4890682}]',77,4890682,837468),(30010401,731,740,'[{1,78},{2,5037680}]',78,5037680,859876),(30010401,741,750,'[{1,79},{2,5184352}]',79,5184352,882284),(30010401,751,760,'[{1,80},{2,5333112}]',80,5333112,904691),(30010401,761,770,'[{1,81},{2,5503256}]',81,5503256,927099),(30010401,771,780,'[{1,82},{2,5673037}]',82,5673037,949507),(30010401,781,790,'[{1,83},{2,5842458}]',83,5842458,971914),(30010401,791,800,'[{1,83},{2,6011520}]',83,6011520,994322),(30010401,801,1000,'[{1,83},{2,6161194}]',83,6161194,994322),(30010402,1,70,'[{1,25},{2,30079}]',25,30079,16037),(30010402,71,119,'[{1,26},{2,30079}]',26,30079,16037),(30010402,120,149,'[{1,27},{2,49644}]',27,49644,17500),(30010402,150,169,'[{1,28},{2,53489}]',28,53489,17500),(30010402,170,190,'[{1,27},{2,62326}]',27,62326,18200),(30010402,191,230,'[{1,27},{2,77911}]',27,77911,25326),(30010402,231,240,'[{1,28},{2,157814}]',28,157814,29377),(30010402,241,250,'[{1,29},{2,140603}]',29,140603,34469),(30010402,251,260,'[{1,30},{2,175846}]',30,175846,35859),(30010402,261,270,'[{1,31},{2,202579}]',31,202579,37304),(30010402,271,280,'[{1,32},{2,229570}]',32,229570,39075),(30010402,281,290,'[{1,33},{2,256766}]',33,256766,38823),(30010402,291,300,'[{1,34},{2,284118}]',34,284118,40921),(30010402,301,310,'[{1,35},{2,313608}]',35,313608,41756),(30010402,311,320,'[{1,36},{2,361382}]',36,361382,41426),(30010402,321,330,'[{1,37},{2,409226}]',37,409226,44074),(30010402,331,340,'[{1,38},{2,457091}]',38,457091,46729),(30010402,341,350,'[{1,39},{2,504944}]',39,504944,46920),(30010402,351,360,'[{1,40},{2,556064}]',40,556064,50404),(30010402,361,370,'[{1,41},{2,637669}]',41,637669,53752),(30010402,371,380,'[{1,42},{2,719938}]',42,719938,81444),(30010402,381,390,'[{1,43},{2,802634}]',43,802634,102483),(30010402,391,400,'[{1,44},{2,885626}]',44,885626,113687),(30010402,401,410,'[{1,45},{2,966854}]',45,966854,124891),(30010402,411,420,'[{1,46},{2,1030478}]',46,1030478,136094),(30010402,421,430,'[{1,47},{2,1094021}]',47,1094021,147298),(30010402,431,440,'[{1,48},{2,1157462}]',48,1157462,158502),(30010402,441,450,'[{1,49},{2,1220786}]',49,1220786,168874),(30010402,451,460,'[{1,50},{2,1287862}]',50,1287862,196984),(30010402,461,470,'[{1,51},{2,1389842}]',51,1389842,215910),(30010402,471,480,'[{1,52},{2,1491811}]',52,1491811,235676),(30010402,481,490,'[{1,53},{2,1593730}]',53,1593730,244079),(30010402,491,500,'[{1,54},{2,1695560}]',54,1695560,252482),(30010402,501,510,'[{1,55},{2,1799574}]',55,1799574,260885),(30010402,511,520,'[{1,56},{2,1924043}]',56,1924043,269288),(30010402,521,530,'[{1,57},{2,2048192}]',57,2048192,299516),(30010402,531,540,'[{1,58},{2,2172026}]',58,2172026,320973),(30010402,541,550,'[{1,59},{2,2295549}]',59,2295549,390718),(30010402,551,560,'[{1,60},{2,2418859}]',60,2418859,433712),(30010402,561,570,'[{1,61},{2,2542826}]',61,2542826,478947),(30010402,571,580,'[{1,62},{2,2666630}]',62,2666630,501354),(30010402,581,590,'[{1,63},{2,2790254}]',63,2790254,523762),(30010402,591,600,'[{1,64},{2,2913685}]',64,2913685,546169),(30010402,601,610,'[{1,65},{2,3038942}]',65,3038942,568577),(30010402,611,620,'[{1,66},{2,3182245}]',66,3182245,590985),(30010402,621,630,'[{1,67},{2,3325264}]',67,3325264,613393),(30010402,631,640,'[{1,68},{2,3467997}]',68,3467997,635800),(30010402,641,650,'[{1,69},{2,3610440}]',69,3610440,658208),(30010402,651,660,'[{1,70},{2,3755302}]',70,3755302,680615),(30010402,661,670,'[{1,71},{2,3924309}]',71,3924309,703023),(30010402,671,680,'[{1,72},{2,4093064}]',72,4093064,725430),(30010402,681,690,'[{1,73},{2,4261557}]',73,4261557,747838),(30010402,691,700,'[{1,74},{2,4429774}]',74,4429774,770246),(30010402,701,710,'[{1,75},{2,4595710}]',75,4595710,792653),(30010402,711,720,'[{1,76},{2,4743358}]',76,4743358,815061),(30010402,721,730,'[{1,77},{2,4890682}]',77,4890682,837468),(30010402,731,740,'[{1,78},{2,5037680}]',78,5037680,859876),(30010402,741,750,'[{1,79},{2,5184352}]',79,5184352,882284),(30010402,751,760,'[{1,80},{2,5333112}]',80,5333112,904691),(30010402,761,770,'[{1,81},{2,5503256}]',81,5503256,927099),(30010402,771,780,'[{1,82},{2,5673037}]',82,5673037,949507),(30010402,781,790,'[{1,83},{2,5842458}]',83,5842458,971914),(30010402,791,800,'[{1,83},{2,6011520}]',83,6011520,994322),(30010402,801,1000,'[{1,83},{2,6161194}]',83,6161194,994322),(30010403,1,70,'[{1,25},{2,30079}]',25,30079,16037),(30010403,71,119,'[{1,26},{2,30079}]',26,30079,16037),(30010403,120,149,'[{1,27},{2,49644}]',27,49644,17500),(30010403,150,169,'[{1,28},{2,53489}]',28,53489,17500),(30010403,170,190,'[{1,27},{2,62326}]',27,62326,18200),(30010403,191,230,'[{1,27},{2,77911}]',27,77911,25326),(30010403,231,240,'[{1,28},{2,157814}]',28,157814,29377),(30010403,241,250,'[{1,29},{2,140603}]',29,140603,34469),(30010403,251,260,'[{1,30},{2,175846}]',30,175846,35859),(30010403,261,270,'[{1,31},{2,202579}]',31,202579,37304),(30010403,271,280,'[{1,32},{2,229570}]',32,229570,39075),(30010403,281,290,'[{1,33},{2,256766}]',33,256766,38823),(30010403,291,300,'[{1,34},{2,284118}]',34,284118,40921),(30010403,301,310,'[{1,35},{2,313608}]',35,313608,41756),(30010403,311,320,'[{1,36},{2,361382}]',36,361382,41426),(30010403,321,330,'[{1,37},{2,409226}]',37,409226,44074),(30010403,331,340,'[{1,38},{2,457091}]',38,457091,46729),(30010403,341,350,'[{1,39},{2,504944}]',39,504944,46920),(30010403,351,360,'[{1,40},{2,556064}]',40,556064,50404),(30010403,361,370,'[{1,41},{2,637669}]',41,637669,53752),(30010403,371,380,'[{1,42},{2,719938}]',42,719938,81444),(30010403,381,390,'[{1,43},{2,802634}]',43,802634,102483),(30010403,391,400,'[{1,44},{2,885626}]',44,885626,113687),(30010403,401,410,'[{1,45},{2,966854}]',45,966854,124891),(30010403,411,420,'[{1,46},{2,1030478}]',46,1030478,136094),(30010403,421,430,'[{1,47},{2,1094021}]',47,1094021,147298),(30010403,431,440,'[{1,48},{2,1157462}]',48,1157462,158502),(30010403,441,450,'[{1,49},{2,1220786}]',49,1220786,168874),(30010403,451,460,'[{1,50},{2,1287862}]',50,1287862,196984),(30010403,461,470,'[{1,51},{2,1389842}]',51,1389842,215910),(30010403,471,480,'[{1,52},{2,1491811}]',52,1491811,235676),(30010403,481,490,'[{1,53},{2,1593730}]',53,1593730,244079),(30010403,491,500,'[{1,54},{2,1695560}]',54,1695560,252482),(30010403,501,510,'[{1,55},{2,1799574}]',55,1799574,260885),(30010403,511,520,'[{1,56},{2,1924043}]',56,1924043,269288),(30010403,521,530,'[{1,57},{2,2048192}]',57,2048192,299516),(30010403,531,540,'[{1,58},{2,2172026}]',58,2172026,320973),(30010403,541,550,'[{1,59},{2,2295549}]',59,2295549,390718),(30010403,551,560,'[{1,60},{2,2418859}]',60,2418859,433712),(30010403,561,570,'[{1,61},{2,2542826}]',61,2542826,478947),(30010403,571,580,'[{1,62},{2,2666630}]',62,2666630,501354),(30010403,581,590,'[{1,63},{2,2790254}]',63,2790254,523762),(30010403,591,600,'[{1,64},{2,2913685}]',64,2913685,546169),(30010403,601,610,'[{1,65},{2,3038942}]',65,3038942,568577),(30010403,611,620,'[{1,66},{2,3182245}]',66,3182245,590985),(30010403,621,630,'[{1,67},{2,3325264}]',67,3325264,613393),(30010403,631,640,'[{1,68},{2,3467997}]',68,3467997,635800),(30010403,641,650,'[{1,69},{2,3610440}]',69,3610440,658208),(30010403,651,660,'[{1,70},{2,3755302}]',70,3755302,680615),(30010403,661,670,'[{1,71},{2,3924309}]',71,3924309,703023),(30010403,671,680,'[{1,72},{2,4093064}]',72,4093064,725430),(30010403,681,690,'[{1,73},{2,4261557}]',73,4261557,747838),(30010403,691,700,'[{1,74},{2,4429774}]',74,4429774,770246),(30010403,701,710,'[{1,75},{2,4595710}]',75,4595710,792653),(30010403,711,720,'[{1,76},{2,4743358}]',76,4743358,815061),(30010403,721,730,'[{1,77},{2,4890682}]',77,4890682,837468),(30010403,731,740,'[{1,78},{2,5037680}]',78,5037680,859876),(30010403,741,750,'[{1,79},{2,5184352}]',79,5184352,882284),(30010403,751,760,'[{1,80},{2,5333112}]',80,5333112,904691),(30010403,761,770,'[{1,81},{2,5503256}]',81,5503256,927099),(30010403,771,780,'[{1,82},{2,5673037}]',82,5673037,949507),(30010403,781,790,'[{1,83},{2,5842458}]',83,5842458,971914),(30010403,791,800,'[{1,83},{2,6011520}]',83,6011520,994322),(30010403,801,1000,'[{1,83},{2,6161194}]',83,6161194,994322),(30010404,1,70,'[{1,25},{2,30079}]',25,30079,16037),(30010404,71,119,'[{1,26},{2,30079}]',26,30079,16037),(30010404,120,149,'[{1,27},{2,49644}]',27,49644,17500),(30010404,150,169,'[{1,28},{2,53489}]',28,53489,17500),(30010404,170,190,'[{1,27},{2,62326}]',27,62326,18200),(30010404,191,230,'[{1,27},{2,77911}]',27,77911,25326),(30010404,231,240,'[{1,28},{2,157814}]',28,157814,29377),(30010404,241,250,'[{1,29},{2,140603}]',29,140603,34469),(30010404,251,260,'[{1,30},{2,175846}]',30,175846,35859),(30010404,261,270,'[{1,31},{2,202579}]',31,202579,37304),(30010404,271,280,'[{1,32},{2,229570}]',32,229570,39075),(30010404,281,290,'[{1,33},{2,256766}]',33,256766,38823),(30010404,291,300,'[{1,34},{2,284118}]',34,284118,40921),(30010404,301,310,'[{1,35},{2,313608}]',35,313608,41756),(30010404,311,320,'[{1,36},{2,361382}]',36,361382,41426),(30010404,321,330,'[{1,37},{2,409226}]',37,409226,44074),(30010404,331,340,'[{1,38},{2,457091}]',38,457091,46729),(30010404,341,350,'[{1,39},{2,504944}]',39,504944,46920),(30010404,351,360,'[{1,40},{2,556064}]',40,556064,50404),(30010404,361,370,'[{1,41},{2,637669}]',41,637669,53752),(30010404,371,380,'[{1,42},{2,719938}]',42,719938,81444),(30010404,381,390,'[{1,43},{2,802634}]',43,802634,102483),(30010404,391,400,'[{1,44},{2,885626}]',44,885626,113687),(30010404,401,410,'[{1,45},{2,966854}]',45,966854,124891),(30010404,411,420,'[{1,46},{2,1030478}]',46,1030478,136094),(30010404,421,430,'[{1,47},{2,1094021}]',47,1094021,147298),(30010404,431,440,'[{1,48},{2,1157462}]',48,1157462,158502),(30010404,441,450,'[{1,49},{2,1220786}]',49,1220786,168874),(30010404,451,460,'[{1,50},{2,1287862}]',50,1287862,196984),(30010404,461,470,'[{1,51},{2,1389842}]',51,1389842,215910),(30010404,471,480,'[{1,52},{2,1491811}]',52,1491811,235676),(30010404,481,490,'[{1,53},{2,1593730}]',53,1593730,244079),(30010404,491,500,'[{1,54},{2,1695560}]',54,1695560,252482),(30010404,501,510,'[{1,55},{2,1799574}]',55,1799574,260885),(30010404,511,520,'[{1,56},{2,1924043}]',56,1924043,269288),(30010404,521,530,'[{1,57},{2,2048192}]',57,2048192,299516),(30010404,531,540,'[{1,58},{2,2172026}]',58,2172026,320973),(30010404,541,550,'[{1,59},{2,2295549}]',59,2295549,390718),(30010404,551,560,'[{1,60},{2,2418859}]',60,2418859,433712),(30010404,561,570,'[{1,61},{2,2542826}]',61,2542826,478947),(30010404,571,580,'[{1,62},{2,2666630}]',62,2666630,501354),(30010404,581,590,'[{1,63},{2,2790254}]',63,2790254,523762),(30010404,591,600,'[{1,64},{2,2913685}]',64,2913685,546169),(30010404,601,610,'[{1,65},{2,3038942}]',65,3038942,568577),(30010404,611,620,'[{1,66},{2,3182245}]',66,3182245,590985),(30010404,621,630,'[{1,67},{2,3325264}]',67,3325264,613393),(30010404,631,640,'[{1,68},{2,3467997}]',68,3467997,635800),(30010404,641,650,'[{1,69},{2,3610440}]',69,3610440,658208),(30010404,651,660,'[{1,70},{2,3755302}]',70,3755302,680615),(30010404,661,670,'[{1,71},{2,3924309}]',71,3924309,703023),(30010404,671,680,'[{1,72},{2,4093064}]',72,4093064,725430),(30010404,681,690,'[{1,73},{2,4261557}]',73,4261557,747838),(30010404,691,700,'[{1,74},{2,4429774}]',74,4429774,770246),(30010404,701,710,'[{1,75},{2,4595710}]',75,4595710,792653),(30010404,711,720,'[{1,76},{2,4743358}]',76,4743358,815061),(30010404,721,730,'[{1,77},{2,4890682}]',77,4890682,837468),(30010404,731,740,'[{1,78},{2,5037680}]',78,5037680,859876),(30010404,741,750,'[{1,79},{2,5184352}]',79,5184352,882284),(30010404,751,760,'[{1,80},{2,5333112}]',80,5333112,904691),(30010404,761,770,'[{1,81},{2,5503256}]',81,5503256,927099),(30010404,771,780,'[{1,82},{2,5673037}]',82,5673037,949507),(30010404,781,790,'[{1,83},{2,5842458}]',83,5842458,971914),(30010404,791,800,'[{1,83},{2,6011520}]',83,6011520,994322),(30010404,801,1000,'[{1,83},{2,6161194}]',83,6161194,994322),(30010405,1,70,'[{1,25},{2,30079}]',25,30079,16037),(30010405,71,119,'[{1,26},{2,30079}]',26,30079,16037),(30010405,120,149,'[{1,27},{2,49644}]',27,49644,17500),(30010405,150,169,'[{1,28},{2,53489}]',28,53489,17500),(30010405,170,190,'[{1,27},{2,62326}]',27,62326,18200),(30010405,191,230,'[{1,27},{2,77911}]',27,77911,25326),(30010405,231,240,'[{1,28},{2,157814}]',28,157814,29377),(30010405,241,250,'[{1,29},{2,140603}]',29,140603,34469),(30010405,251,260,'[{1,30},{2,175846}]',30,175846,35859),(30010405,261,270,'[{1,31},{2,202579}]',31,202579,37304),(30010405,271,280,'[{1,32},{2,229570}]',32,229570,39075),(30010405,281,290,'[{1,33},{2,256766}]',33,256766,38823),(30010405,291,300,'[{1,34},{2,284118}]',34,284118,40921),(30010405,301,310,'[{1,35},{2,313608}]',35,313608,41756),(30010405,311,320,'[{1,36},{2,361382}]',36,361382,41426),(30010405,321,330,'[{1,37},{2,409226}]',37,409226,44074),(30010405,331,340,'[{1,38},{2,457091}]',38,457091,46729),(30010405,341,350,'[{1,39},{2,504944}]',39,504944,46920),(30010405,351,360,'[{1,40},{2,556064}]',40,556064,50404),(30010405,361,370,'[{1,41},{2,637669}]',41,637669,53752),(30010405,371,380,'[{1,42},{2,719938}]',42,719938,81444),(30010405,381,390,'[{1,43},{2,802634}]',43,802634,102483),(30010405,391,400,'[{1,44},{2,885626}]',44,885626,113687),(30010405,401,410,'[{1,45},{2,966854}]',45,966854,124891),(30010405,411,420,'[{1,46},{2,1030478}]',46,1030478,136094),(30010405,421,430,'[{1,47},{2,1094021}]',47,1094021,147298),(30010405,431,440,'[{1,48},{2,1157462}]',48,1157462,158502),(30010405,441,450,'[{1,49},{2,1220786}]',49,1220786,168874),(30010405,451,460,'[{1,50},{2,1287862}]',50,1287862,196984),(30010405,461,470,'[{1,51},{2,1389842}]',51,1389842,215910),(30010405,471,480,'[{1,52},{2,1491811}]',52,1491811,235676),(30010405,481,490,'[{1,53},{2,1593730}]',53,1593730,244079),(30010405,491,500,'[{1,54},{2,1695560}]',54,1695560,252482),(30010405,501,510,'[{1,55},{2,1799574}]',55,1799574,260885),(30010405,511,520,'[{1,56},{2,1924043}]',56,1924043,269288),(30010405,521,530,'[{1,57},{2,2048192}]',57,2048192,299516),(30010405,531,540,'[{1,58},{2,2172026}]',58,2172026,320973),(30010405,541,550,'[{1,59},{2,2295549}]',59,2295549,390718),(30010405,551,560,'[{1,60},{2,2418859}]',60,2418859,433712),(30010405,561,570,'[{1,61},{2,2542826}]',61,2542826,478947),(30010405,571,580,'[{1,62},{2,2666630}]',62,2666630,501354),(30010405,581,590,'[{1,63},{2,2790254}]',63,2790254,523762),(30010405,591,600,'[{1,64},{2,2913685}]',64,2913685,546169),(30010405,601,610,'[{1,65},{2,3038942}]',65,3038942,568577),(30010405,611,620,'[{1,66},{2,3182245}]',66,3182245,590985),(30010405,621,630,'[{1,67},{2,3325264}]',67,3325264,613393),(30010405,631,640,'[{1,68},{2,3467997}]',68,3467997,635800),(30010405,641,650,'[{1,69},{2,3610440}]',69,3610440,658208),(30010405,651,660,'[{1,70},{2,3755302}]',70,3755302,680615),(30010405,661,670,'[{1,71},{2,3924309}]',71,3924309,703023),(30010405,671,680,'[{1,72},{2,4093064}]',72,4093064,725430),(30010405,681,690,'[{1,73},{2,4261557}]',73,4261557,747838),(30010405,691,700,'[{1,74},{2,4429774}]',74,4429774,770246),(30010405,701,710,'[{1,75},{2,4595710}]',75,4595710,792653),(30010405,711,720,'[{1,76},{2,4743358}]',76,4743358,815061),(30010405,721,730,'[{1,77},{2,4890682}]',77,4890682,837468),(30010405,731,740,'[{1,78},{2,5037680}]',78,5037680,859876),(30010405,741,750,'[{1,79},{2,5184352}]',79,5184352,882284),(30010405,751,760,'[{1,80},{2,5333112}]',80,5333112,904691),(30010405,761,770,'[{1,81},{2,5503256}]',81,5503256,927099),(30010405,771,780,'[{1,82},{2,5673037}]',82,5673037,949507),(30010405,781,790,'[{1,83},{2,5842458}]',83,5842458,971914),(30010405,791,800,'[{1,83},{2,6011520}]',83,6011520,994322),(30010405,801,1000,'[{1,83},{2,6161194}]',83,6161194,994322),(30010406,1,70,'[{1,25},{2,30079}]',25,30079,16037),(30010406,71,119,'[{1,26},{2,30079}]',26,30079,16037),(30010406,120,149,'[{1,27},{2,49644}]',27,49644,17500),(30010406,150,169,'[{1,28},{2,53489}]',28,53489,17500),(30010406,170,190,'[{1,27},{2,62326}]',27,62326,18200),(30010406,191,230,'[{1,27},{2,77911}]',27,77911,25326),(30010406,231,240,'[{1,28},{2,157814}]',28,157814,29377),(30010406,241,250,'[{1,29},{2,140603}]',29,140603,34469),(30010406,251,260,'[{1,30},{2,175846}]',30,175846,35859),(30010406,261,270,'[{1,31},{2,202579}]',31,202579,37304),(30010406,271,280,'[{1,32},{2,229570}]',32,229570,39075),(30010406,281,290,'[{1,33},{2,256766}]',33,256766,38823),(30010406,291,300,'[{1,34},{2,284118}]',34,284118,40921),(30010406,301,310,'[{1,35},{2,313608}]',35,313608,41756),(30010406,311,320,'[{1,36},{2,361382}]',36,361382,41426),(30010406,321,330,'[{1,37},{2,409226}]',37,409226,44074),(30010406,331,340,'[{1,38},{2,457091}]',38,457091,46729),(30010406,341,350,'[{1,39},{2,504944}]',39,504944,46920),(30010406,351,360,'[{1,40},{2,556064}]',40,556064,50404),(30010406,361,370,'[{1,41},{2,637669}]',41,637669,53752),(30010406,371,380,'[{1,42},{2,719938}]',42,719938,81444),(30010406,381,390,'[{1,43},{2,802634}]',43,802634,102483),(30010406,391,400,'[{1,44},{2,885626}]',44,885626,113687),(30010406,401,410,'[{1,45},{2,966854}]',45,966854,124891),(30010406,411,420,'[{1,46},{2,1030478}]',46,1030478,136094),(30010406,421,430,'[{1,47},{2,1094021}]',47,1094021,147298),(30010406,431,440,'[{1,48},{2,1157462}]',48,1157462,158502),(30010406,441,450,'[{1,49},{2,1220786}]',49,1220786,168874),(30010406,451,460,'[{1,50},{2,1287862}]',50,1287862,196984),(30010406,461,470,'[{1,51},{2,1389842}]',51,1389842,215910),(30010406,471,480,'[{1,52},{2,1491811}]',52,1491811,235676),(30010406,481,490,'[{1,53},{2,1593730}]',53,1593730,244079),(30010406,491,500,'[{1,54},{2,1695560}]',54,1695560,252482),(30010406,501,510,'[{1,55},{2,1799574}]',55,1799574,260885),(30010406,511,520,'[{1,56},{2,1924043}]',56,1924043,269288),(30010406,521,530,'[{1,57},{2,2048192}]',57,2048192,299516),(30010406,531,540,'[{1,58},{2,2172026}]',58,2172026,320973),(30010406,541,550,'[{1,59},{2,2295549}]',59,2295549,390718),(30010406,551,560,'[{1,60},{2,2418859}]',60,2418859,433712),(30010406,561,570,'[{1,61},{2,2542826}]',61,2542826,478947),(30010406,571,580,'[{1,62},{2,2666630}]',62,2666630,501354),(30010406,581,590,'[{1,63},{2,2790254}]',63,2790254,523762),(30010406,591,600,'[{1,64},{2,2913685}]',64,2913685,546169),(30010406,601,610,'[{1,65},{2,3038942}]',65,3038942,568577),(30010406,611,620,'[{1,66},{2,3182245}]',66,3182245,590985),(30010406,621,630,'[{1,67},{2,3325264}]',67,3325264,613393),(30010406,631,640,'[{1,68},{2,3467997}]',68,3467997,635800),(30010406,641,650,'[{1,69},{2,3610440}]',69,3610440,658208),(30010406,651,660,'[{1,70},{2,3755302}]',70,3755302,680615),(30010406,661,670,'[{1,71},{2,3924309}]',71,3924309,703023),(30010406,671,680,'[{1,72},{2,4093064}]',72,4093064,725430),(30010406,681,690,'[{1,73},{2,4261557}]',73,4261557,747838),(30010406,691,700,'[{1,74},{2,4429774}]',74,4429774,770246),(30010406,701,710,'[{1,75},{2,4595710}]',75,4595710,792653),(30010406,711,720,'[{1,76},{2,4743358}]',76,4743358,815061),(30010406,721,730,'[{1,77},{2,4890682}]',77,4890682,837468),(30010406,731,740,'[{1,78},{2,5037680}]',78,5037680,859876),(30010406,741,750,'[{1,79},{2,5184352}]',79,5184352,882284),(30010406,751,760,'[{1,80},{2,5333112}]',80,5333112,904691),(30010406,761,770,'[{1,81},{2,5503256}]',81,5503256,927099),(30010406,771,780,'[{1,82},{2,5673037}]',82,5673037,949507),(30010406,781,790,'[{1,83},{2,5842458}]',83,5842458,971914),(30010406,791,800,'[{1,83},{2,6011520}]',83,6011520,994322),(30010406,801,1000,'[{1,83},{2,6161194}]',83,6161194,994322),(30010407,1,70,'[{1,25},{2,30079}]',25,30079,16037),(30010407,71,119,'[{1,26},{2,30079}]',26,30079,16037),(30010407,120,149,'[{1,27},{2,49644}]',27,49644,17500),(30010407,150,169,'[{1,28},{2,53489}]',28,53489,17500),(30010407,170,190,'[{1,27},{2,62326}]',27,62326,18200),(30010407,191,230,'[{1,27},{2,77911}]',27,77911,25326),(30010407,231,240,'[{1,28},{2,157814}]',28,157814,29377),(30010407,241,250,'[{1,29},{2,140603}]',29,140603,34469),(30010407,251,260,'[{1,30},{2,175846}]',30,175846,35859),(30010407,261,270,'[{1,31},{2,202579}]',31,202579,37304),(30010407,271,280,'[{1,32},{2,229570}]',32,229570,39075),(30010407,281,290,'[{1,33},{2,256766}]',33,256766,38823),(30010407,291,300,'[{1,34},{2,284118}]',34,284118,40921),(30010407,301,310,'[{1,35},{2,313608}]',35,313608,41756),(30010407,311,320,'[{1,36},{2,361382}]',36,361382,41426),(30010407,321,330,'[{1,37},{2,409226}]',37,409226,44074),(30010407,331,340,'[{1,38},{2,457091}]',38,457091,46729),(30010407,341,350,'[{1,39},{2,504944}]',39,504944,46920),(30010407,351,360,'[{1,40},{2,556064}]',40,556064,50404),(30010407,361,370,'[{1,41},{2,637669}]',41,637669,53752),(30010407,371,380,'[{1,42},{2,719938}]',42,719938,81444),(30010407,381,390,'[{1,43},{2,802634}]',43,802634,102483),(30010407,391,400,'[{1,44},{2,885626}]',44,885626,113687),(30010407,401,410,'[{1,45},{2,966854}]',45,966854,124891),(30010407,411,420,'[{1,46},{2,1030478}]',46,1030478,136094),(30010407,421,430,'[{1,47},{2,1094021}]',47,1094021,147298),(30010407,431,440,'[{1,48},{2,1157462}]',48,1157462,158502),(30010407,441,450,'[{1,49},{2,1220786}]',49,1220786,168874),(30010407,451,460,'[{1,50},{2,1287862}]',50,1287862,196984),(30010407,461,470,'[{1,51},{2,1389842}]',51,1389842,215910),(30010407,471,480,'[{1,52},{2,1491811}]',52,1491811,235676),(30010407,481,490,'[{1,53},{2,1593730}]',53,1593730,244079),(30010407,491,500,'[{1,54},{2,1695560}]',54,1695560,252482),(30010407,501,510,'[{1,55},{2,1799574}]',55,1799574,260885),(30010407,511,520,'[{1,56},{2,1924043}]',56,1924043,269288),(30010407,521,530,'[{1,57},{2,2048192}]',57,2048192,299516),(30010407,531,540,'[{1,58},{2,2172026}]',58,2172026,320973),(30010407,541,550,'[{1,59},{2,2295549}]',59,2295549,390718),(30010407,551,560,'[{1,60},{2,2418859}]',60,2418859,433712),(30010407,561,570,'[{1,61},{2,2542826}]',61,2542826,478947),(30010407,571,580,'[{1,62},{2,2666630}]',62,2666630,501354),(30010407,581,590,'[{1,63},{2,2790254}]',63,2790254,523762),(30010407,591,600,'[{1,64},{2,2913685}]',64,2913685,546169),(30010407,601,610,'[{1,65},{2,3038942}]',65,3038942,568577),(30010407,611,620,'[{1,66},{2,3182245}]',66,3182245,590985),(30010407,621,630,'[{1,67},{2,3325264}]',67,3325264,613393),(30010407,631,640,'[{1,68},{2,3467997}]',68,3467997,635800),(30010407,641,650,'[{1,69},{2,3610440}]',69,3610440,658208),(30010407,651,660,'[{1,70},{2,3755302}]',70,3755302,680615),(30010407,661,670,'[{1,71},{2,3924309}]',71,3924309,703023),(30010407,671,680,'[{1,72},{2,4093064}]',72,4093064,725430),(30010407,681,690,'[{1,73},{2,4261557}]',73,4261557,747838),(30010407,691,700,'[{1,74},{2,4429774}]',74,4429774,770246),(30010407,701,710,'[{1,75},{2,4595710}]',75,4595710,792653),(30010407,711,720,'[{1,76},{2,4743358}]',76,4743358,815061),(30010407,721,730,'[{1,77},{2,4890682}]',77,4890682,837468),(30010407,731,740,'[{1,78},{2,5037680}]',78,5037680,859876),(30010407,741,750,'[{1,79},{2,5184352}]',79,5184352,882284),(30010407,751,760,'[{1,80},{2,5333112}]',80,5333112,904691),(30010407,761,770,'[{1,81},{2,5503256}]',81,5503256,927099),(30010407,771,780,'[{1,82},{2,5673037}]',82,5673037,949507),(30010407,781,790,'[{1,83},{2,5842458}]',83,5842458,971914),(30010407,791,800,'[{1,83},{2,6011520}]',83,6011520,994322),(30010407,801,1000,'[{1,83},{2,6161194}]',83,6161194,994322),(30010408,1,70,'[{1,25},{2,30079}]',25,30079,16037),(30010408,71,119,'[{1,26},{2,30079}]',26,30079,16037),(30010408,120,149,'[{1,27},{2,49644}]',27,49644,17500),(30010408,150,169,'[{1,28},{2,53489}]',28,53489,17500),(30010408,170,190,'[{1,27},{2,62326}]',27,62326,18200),(30010408,191,230,'[{1,27},{2,77911}]',27,77911,25326),(30010408,231,240,'[{1,28},{2,157814}]',28,157814,29377),(30010408,241,250,'[{1,29},{2,140603}]',29,140603,34469),(30010408,251,260,'[{1,30},{2,175846}]',30,175846,35859),(30010408,261,270,'[{1,31},{2,202579}]',31,202579,37304),(30010408,271,280,'[{1,32},{2,229570}]',32,229570,39075),(30010408,281,290,'[{1,33},{2,256766}]',33,256766,38823),(30010408,291,300,'[{1,34},{2,284118}]',34,284118,40921),(30010408,301,310,'[{1,35},{2,313608}]',35,313608,41756),(30010408,311,320,'[{1,36},{2,361382}]',36,361382,41426),(30010408,321,330,'[{1,37},{2,409226}]',37,409226,44074),(30010408,331,340,'[{1,38},{2,457091}]',38,457091,46729),(30010408,341,350,'[{1,39},{2,504944}]',39,504944,46920),(30010408,351,360,'[{1,40},{2,556064}]',40,556064,50404),(30010408,361,370,'[{1,41},{2,637669}]',41,637669,53752),(30010408,371,380,'[{1,42},{2,719938}]',42,719938,81444),(30010408,381,390,'[{1,43},{2,802634}]',43,802634,102483),(30010408,391,400,'[{1,44},{2,885626}]',44,885626,113687),(30010408,401,410,'[{1,45},{2,966854}]',45,966854,124891),(30010408,411,420,'[{1,46},{2,1030478}]',46,1030478,136094),(30010408,421,430,'[{1,47},{2,1094021}]',47,1094021,147298),(30010408,431,440,'[{1,48},{2,1157462}]',48,1157462,158502),(30010408,441,450,'[{1,49},{2,1220786}]',49,1220786,168874),(30010408,451,460,'[{1,50},{2,1287862}]',50,1287862,196984),(30010408,461,470,'[{1,51},{2,1389842}]',51,1389842,215910),(30010408,471,480,'[{1,52},{2,1491811}]',52,1491811,235676),(30010408,481,490,'[{1,53},{2,1593730}]',53,1593730,244079),(30010408,491,500,'[{1,54},{2,1695560}]',54,1695560,252482),(30010408,501,510,'[{1,55},{2,1799574}]',55,1799574,260885),(30010408,511,520,'[{1,56},{2,1924043}]',56,1924043,269288),(30010408,521,530,'[{1,57},{2,2048192}]',57,2048192,299516),(30010408,531,540,'[{1,58},{2,2172026}]',58,2172026,320973),(30010408,541,550,'[{1,59},{2,2295549}]',59,2295549,390718),(30010408,551,560,'[{1,60},{2,2418859}]',60,2418859,433712),(30010408,561,570,'[{1,61},{2,2542826}]',61,2542826,478947),(30010408,571,580,'[{1,62},{2,2666630}]',62,2666630,501354),(30010408,581,590,'[{1,63},{2,2790254}]',63,2790254,523762),(30010408,591,600,'[{1,64},{2,2913685}]',64,2913685,546169),(30010408,601,610,'[{1,65},{2,3038942}]',65,3038942,568577),(30010408,611,620,'[{1,66},{2,3182245}]',66,3182245,590985),(30010408,621,630,'[{1,67},{2,3325264}]',67,3325264,613393),(30010408,631,640,'[{1,68},{2,3467997}]',68,3467997,635800),(30010408,641,650,'[{1,69},{2,3610440}]',69,3610440,658208),(30010408,651,660,'[{1,70},{2,3755302}]',70,3755302,680615),(30010408,661,670,'[{1,71},{2,3924309}]',71,3924309,703023),(30010408,671,680,'[{1,72},{2,4093064}]',72,4093064,725430),(30010408,681,690,'[{1,73},{2,4261557}]',73,4261557,747838),(30010408,691,700,'[{1,74},{2,4429774}]',74,4429774,770246),(30010408,701,710,'[{1,75},{2,4595710}]',75,4595710,792653),(30010408,711,720,'[{1,76},{2,4743358}]',76,4743358,815061),(30010408,721,730,'[{1,77},{2,4890682}]',77,4890682,837468),(30010408,731,740,'[{1,78},{2,5037680}]',78,5037680,859876),(30010408,741,750,'[{1,79},{2,5184352}]',79,5184352,882284),(30010408,751,760,'[{1,80},{2,5333112}]',80,5333112,904691),(30010408,761,770,'[{1,81},{2,5503256}]',81,5503256,927099),(30010408,771,780,'[{1,82},{2,5673037}]',82,5673037,949507),(30010408,781,790,'[{1,83},{2,5842458}]',83,5842458,971914),(30010408,791,800,'[{1,83},{2,6011520}]',83,6011520,994322),(30010408,801,1000,'[{1,83},{2,6161194}]',83,6161194,994322),(30010409,1,70,'[{1,25},{2,30079}]',25,30079,16037),(30010409,71,119,'[{1,26},{2,30079}]',26,30079,16037),(30010409,120,149,'[{1,27},{2,49644}]',27,49644,17500),(30010409,150,169,'[{1,28},{2,53489}]',28,53489,17500),(30010409,170,190,'[{1,27},{2,62326}]',27,62326,18200),(30010409,191,230,'[{1,27},{2,77911}]',27,77911,25326),(30010409,231,240,'[{1,28},{2,157814}]',28,157814,29377),(30010409,241,250,'[{1,29},{2,140603}]',29,140603,34469),(30010409,251,260,'[{1,30},{2,175846}]',30,175846,35859),(30010409,261,270,'[{1,31},{2,202579}]',31,202579,37304),(30010409,271,280,'[{1,32},{2,229570}]',32,229570,39075),(30010409,281,290,'[{1,33},{2,256766}]',33,256766,38823),(30010409,291,300,'[{1,34},{2,284118}]',34,284118,40921),(30010409,301,310,'[{1,35},{2,313608}]',35,313608,41756),(30010409,311,320,'[{1,36},{2,361382}]',36,361382,41426),(30010409,321,330,'[{1,37},{2,409226}]',37,409226,44074),(30010409,331,340,'[{1,38},{2,457091}]',38,457091,46729),(30010409,341,350,'[{1,39},{2,504944}]',39,504944,46920),(30010409,351,360,'[{1,40},{2,556064}]',40,556064,50404),(30010409,361,370,'[{1,41},{2,637669}]',41,637669,53752),(30010409,371,380,'[{1,42},{2,719938}]',42,719938,81444),(30010409,381,390,'[{1,43},{2,802634}]',43,802634,102483),(30010409,391,400,'[{1,44},{2,885626}]',44,885626,113687),(30010409,401,410,'[{1,45},{2,966854}]',45,966854,124891),(30010409,411,420,'[{1,46},{2,1030478}]',46,1030478,136094),(30010409,421,430,'[{1,47},{2,1094021}]',47,1094021,147298),(30010409,431,440,'[{1,48},{2,1157462}]',48,1157462,158502),(30010409,441,450,'[{1,49},{2,1220786}]',49,1220786,168874),(30010409,451,460,'[{1,50},{2,1287862}]',50,1287862,196984),(30010409,461,470,'[{1,51},{2,1389842}]',51,1389842,215910),(30010409,471,480,'[{1,52},{2,1491811}]',52,1491811,235676),(30010409,481,490,'[{1,53},{2,1593730}]',53,1593730,244079),(30010409,491,500,'[{1,54},{2,1695560}]',54,1695560,252482),(30010409,501,510,'[{1,55},{2,1799574}]',55,1799574,260885),(30010409,511,520,'[{1,56},{2,1924043}]',56,1924043,269288),(30010409,521,530,'[{1,57},{2,2048192}]',57,2048192,299516),(30010409,531,540,'[{1,58},{2,2172026}]',58,2172026,320973),(30010409,541,550,'[{1,59},{2,2295549}]',59,2295549,390718),(30010409,551,560,'[{1,60},{2,2418859}]',60,2418859,433712),(30010409,561,570,'[{1,61},{2,2542826}]',61,2542826,478947),(30010409,571,580,'[{1,62},{2,2666630}]',62,2666630,501354),(30010409,581,590,'[{1,63},{2,2790254}]',63,2790254,523762),(30010409,591,600,'[{1,64},{2,2913685}]',64,2913685,546169),(30010409,601,610,'[{1,65},{2,3038942}]',65,3038942,568577),(30010409,611,620,'[{1,66},{2,3182245}]',66,3182245,590985),(30010409,621,630,'[{1,67},{2,3325264}]',67,3325264,613393),(30010409,631,640,'[{1,68},{2,3467997}]',68,3467997,635800),(30010409,641,650,'[{1,69},{2,3610440}]',69,3610440,658208),(30010409,651,660,'[{1,70},{2,3755302}]',70,3755302,680615),(30010409,661,670,'[{1,71},{2,3924309}]',71,3924309,703023),(30010409,671,680,'[{1,72},{2,4093064}]',72,4093064,725430),(30010409,681,690,'[{1,73},{2,4261557}]',73,4261557,747838),(30010409,691,700,'[{1,74},{2,4429774}]',74,4429774,770246),(30010409,701,710,'[{1,75},{2,4595710}]',75,4595710,792653),(30010409,711,720,'[{1,76},{2,4743358}]',76,4743358,815061),(30010409,721,730,'[{1,77},{2,4890682}]',77,4890682,837468),(30010409,731,740,'[{1,78},{2,5037680}]',78,5037680,859876),(30010409,741,750,'[{1,79},{2,5184352}]',79,5184352,882284),(30010409,751,760,'[{1,80},{2,5333112}]',80,5333112,904691),(30010409,761,770,'[{1,81},{2,5503256}]',81,5503256,927099),(30010409,771,780,'[{1,82},{2,5673037}]',82,5673037,949507),(30010409,781,790,'[{1,83},{2,5842458}]',83,5842458,971914),(30010409,791,800,'[{1,83},{2,6011520}]',83,6011520,994322),(30010409,801,1000,'[{1,83},{2,6161194}]',83,6161194,994322),(30010501,1,70,'[{1,25},{2,37599}]',25,37599,6873),(30010501,71,119,'[{1,26},{2,37599}]',26,37599,6873),(30010501,120,149,'[{1,27},{2,62055}]',27,62055,7500),(30010501,150,169,'[{1,28},{2,66861}]',28,66861,7500),(30010501,170,190,'[{1,27},{2,77907}]',27,77907,7800),(30010501,191,230,'[{1,27},{2,97389}]',27,97389,10854),(30010501,231,240,'[{1,28},{2,197268}]',28,197268,12590),(30010501,241,250,'[{1,29},{2,175754}]',29,175754,14773),(30010501,251,260,'[{1,30},{2,219808}]',30,219808,15368),(30010501,261,270,'[{1,31},{2,253224}]',31,253224,15987),(30010501,271,280,'[{1,32},{2,286962}]',32,286962,16746),(30010501,281,290,'[{1,33},{2,320958}]',33,320958,16638),(30010501,291,300,'[{1,34},{2,355148}]',34,355148,17538),(30010501,301,310,'[{1,35},{2,392010}]',35,392010,17895),(30010501,311,320,'[{1,36},{2,451728}]',36,451728,17754),(30010501,321,330,'[{1,37},{2,511532}]',37,511532,18889),(30010501,331,340,'[{1,38},{2,571364}]',38,571364,20027),(30010501,341,350,'[{1,39},{2,631180}]',39,631180,20109),(30010501,351,360,'[{1,40},{2,695080}]',40,695080,21602),(30010501,361,370,'[{1,41},{2,797086}]',41,797086,23036),(30010501,371,380,'[{1,42},{2,899922}]',42,899922,34905),(30010501,381,390,'[{1,43},{2,1003292}]',43,1003292,43921),(30010501,391,400,'[{1,44},{2,1107032}]',44,1107032,48723),(30010501,401,410,'[{1,45},{2,1208568}]',45,1208568,53525),(30010501,411,420,'[{1,46},{2,1288098}]',46,1288098,58326),(30010501,421,430,'[{1,47},{2,1367526}]',47,1367526,63128),(30010501,431,440,'[{1,48},{2,1446828}]',48,1446828,67929),(30010501,441,450,'[{1,49},{2,1525982}]',49,1525982,72374),(30010501,451,460,'[{1,50},{2,1609828}]',50,1609828,84422),(30010501,461,470,'[{1,51},{2,1737302}]',51,1737302,92533),(30010501,471,480,'[{1,52},{2,1864764}]',52,1864764,101004),(30010501,481,490,'[{1,53},{2,1992162}]',53,1992162,104605),(30010501,491,500,'[{1,54},{2,2119450}]',54,2119450,108207),(30010501,501,510,'[{1,55},{2,2249468}]',55,2249468,111808),(30010501,511,520,'[{1,56},{2,2405054}]',56,2405054,115409),(30010501,521,530,'[{1,57},{2,2560240}]',57,2560240,128364),(30010501,531,540,'[{1,58},{2,2715032}]',58,2715032,137560),(30010501,541,550,'[{1,59},{2,2869436}]',59,2869436,167451),(30010501,551,560,'[{1,60},{2,3023574}]',60,3023574,185877),(30010501,561,570,'[{1,61},{2,3178532}]',61,3178532,205263),(30010501,571,580,'[{1,62},{2,3333288}]',62,3333288,214866),(30010501,581,590,'[{1,63},{2,3487818}]',63,3487818,224469),(30010501,591,600,'[{1,64},{2,3642106}]',64,3642106,234073),(30010501,601,610,'[{1,65},{2,3798678}]',65,3798678,243676),(30010501,611,620,'[{1,66},{2,3977806}]',66,3977806,253279),(30010501,621,630,'[{1,67},{2,4156580}]',67,4156580,262883),(30010501,631,640,'[{1,68},{2,4334996}]',68,4334996,272486),(30010501,641,650,'[{1,69},{2,4513050}]',69,4513050,282089),(30010501,651,660,'[{1,70},{2,4694128}]',70,4694128,291692),(30010501,661,670,'[{1,71},{2,4905386}]',71,4905386,301296),(30010501,671,680,'[{1,72},{2,5116330}]',72,5116330,310899),(30010501,681,690,'[{1,73},{2,5326946}]',73,5326946,320502),(30010501,691,700,'[{1,74},{2,5537218}]',74,5537218,330105),(30010501,701,710,'[{1,75},{2,5744638}]',75,5744638,339709),(30010501,711,720,'[{1,76},{2,5929198}]',76,5929198,349312),(30010501,721,730,'[{1,77},{2,6113352}]',77,6113352,358915),(30010501,731,740,'[{1,78},{2,6297100}]',78,6297100,368518),(30010501,741,750,'[{1,79},{2,6480440}]',79,6480440,378122),(30010501,751,760,'[{1,80},{2,6666390}]',80,6666390,387725),(30010501,761,770,'[{1,81},{2,6879070}]',81,6879070,397328),(30010501,771,780,'[{1,82},{2,7091296}]',82,7091296,406931),(30010501,781,790,'[{1,83},{2,7303072}]',83,7303072,416535),(30010501,791,800,'[{1,83},{2,7514400}]',83,7514400,426138),(30010501,801,1000,'[{1,83},{2,7701492}]',83,7701492,426138),(30010502,1,70,'[{1,25},{2,37599}]',25,37599,6873),(30010502,71,119,'[{1,26},{2,37599}]',26,37599,6873),(30010502,120,149,'[{1,27},{2,62055}]',27,62055,7500),(30010502,150,169,'[{1,28},{2,66861}]',28,66861,7500),(30010502,170,190,'[{1,27},{2,77907}]',27,77907,7800),(30010502,191,230,'[{1,27},{2,97389}]',27,97389,10854),(30010502,231,240,'[{1,28},{2,197268}]',28,197268,12590),(30010502,241,250,'[{1,29},{2,175754}]',29,175754,14773),(30010502,251,260,'[{1,30},{2,219808}]',30,219808,15368),(30010502,261,270,'[{1,31},{2,253224}]',31,253224,15987),(30010502,271,280,'[{1,32},{2,286962}]',32,286962,16746),(30010502,281,290,'[{1,33},{2,320958}]',33,320958,16638),(30010502,291,300,'[{1,34},{2,355148}]',34,355148,17538),(30010502,301,310,'[{1,35},{2,392010}]',35,392010,17895),(30010502,311,320,'[{1,36},{2,451728}]',36,451728,17754),(30010502,321,330,'[{1,37},{2,511532}]',37,511532,18889),(30010502,331,340,'[{1,38},{2,571364}]',38,571364,20027),(30010502,341,350,'[{1,39},{2,631180}]',39,631180,20109),(30010502,351,360,'[{1,40},{2,695080}]',40,695080,21602),(30010502,361,370,'[{1,41},{2,797086}]',41,797086,23036),(30010502,371,380,'[{1,42},{2,899922}]',42,899922,34905),(30010502,381,390,'[{1,43},{2,1003292}]',43,1003292,43921),(30010502,391,400,'[{1,44},{2,1107032}]',44,1107032,48723),(30010502,401,410,'[{1,45},{2,1208568}]',45,1208568,53525),(30010502,411,420,'[{1,46},{2,1288098}]',46,1288098,58326),(30010502,421,430,'[{1,47},{2,1367526}]',47,1367526,63128),(30010502,431,440,'[{1,48},{2,1446828}]',48,1446828,67929),(30010502,441,450,'[{1,49},{2,1525982}]',49,1525982,72374),(30010502,451,460,'[{1,50},{2,1609828}]',50,1609828,84422),(30010502,461,470,'[{1,51},{2,1737302}]',51,1737302,92533),(30010502,471,480,'[{1,52},{2,1864764}]',52,1864764,101004),(30010502,481,490,'[{1,53},{2,1992162}]',53,1992162,104605),(30010502,491,500,'[{1,54},{2,2119450}]',54,2119450,108207),(30010502,501,510,'[{1,55},{2,2249468}]',55,2249468,111808),(30010502,511,520,'[{1,56},{2,2405054}]',56,2405054,115409),(30010502,521,530,'[{1,57},{2,2560240}]',57,2560240,128364),(30010502,531,540,'[{1,58},{2,2715032}]',58,2715032,137560),(30010502,541,550,'[{1,59},{2,2869436}]',59,2869436,167451),(30010502,551,560,'[{1,60},{2,3023574}]',60,3023574,185877),(30010502,561,570,'[{1,61},{2,3178532}]',61,3178532,205263),(30010502,571,580,'[{1,62},{2,3333288}]',62,3333288,214866),(30010502,581,590,'[{1,63},{2,3487818}]',63,3487818,224469),(30010502,591,600,'[{1,64},{2,3642106}]',64,3642106,234073),(30010502,601,610,'[{1,65},{2,3798678}]',65,3798678,243676),(30010502,611,620,'[{1,66},{2,3977806}]',66,3977806,253279),(30010502,621,630,'[{1,67},{2,4156580}]',67,4156580,262883),(30010502,631,640,'[{1,68},{2,4334996}]',68,4334996,272486),(30010502,641,650,'[{1,69},{2,4513050}]',69,4513050,282089),(30010502,651,660,'[{1,70},{2,4694128}]',70,4694128,291692),(30010502,661,670,'[{1,71},{2,4905386}]',71,4905386,301296),(30010502,671,680,'[{1,72},{2,5116330}]',72,5116330,310899),(30010502,681,690,'[{1,73},{2,5326946}]',73,5326946,320502),(30010502,691,700,'[{1,74},{2,5537218}]',74,5537218,330105),(30010502,701,710,'[{1,75},{2,5744638}]',75,5744638,339709),(30010502,711,720,'[{1,76},{2,5929198}]',76,5929198,349312),(30010502,721,730,'[{1,77},{2,6113352}]',77,6113352,358915),(30010502,731,740,'[{1,78},{2,6297100}]',78,6297100,368518),(30010502,741,750,'[{1,79},{2,6480440}]',79,6480440,378122),(30010502,751,760,'[{1,80},{2,6666390}]',80,6666390,387725),(30010502,761,770,'[{1,81},{2,6879070}]',81,6879070,397328),(30010502,771,780,'[{1,82},{2,7091296}]',82,7091296,406931),(30010502,781,790,'[{1,83},{2,7303072}]',83,7303072,416535),(30010502,791,800,'[{1,83},{2,7514400}]',83,7514400,426138),(30010502,801,1000,'[{1,83},{2,7701492}]',83,7701492,426138),(30010503,1,70,'[{1,25},{2,37599}]',25,37599,6873),(30010503,71,119,'[{1,26},{2,37599}]',26,37599,6873),(30010503,120,149,'[{1,27},{2,62055}]',27,62055,7500),(30010503,150,169,'[{1,28},{2,66861}]',28,66861,7500),(30010503,170,190,'[{1,27},{2,77907}]',27,77907,7800),(30010503,191,230,'[{1,27},{2,97389}]',27,97389,10854),(30010503,231,240,'[{1,28},{2,197268}]',28,197268,12590),(30010503,241,250,'[{1,29},{2,175754}]',29,175754,14773),(30010503,251,260,'[{1,30},{2,219808}]',30,219808,15368),(30010503,261,270,'[{1,31},{2,253224}]',31,253224,15987),(30010503,271,280,'[{1,32},{2,286962}]',32,286962,16746),(30010503,281,290,'[{1,33},{2,320958}]',33,320958,16638),(30010503,291,300,'[{1,34},{2,355148}]',34,355148,17538),(30010503,301,310,'[{1,35},{2,392010}]',35,392010,17895),(30010503,311,320,'[{1,36},{2,451728}]',36,451728,17754),(30010503,321,330,'[{1,37},{2,511532}]',37,511532,18889),(30010503,331,340,'[{1,38},{2,571364}]',38,571364,20027),(30010503,341,350,'[{1,39},{2,631180}]',39,631180,20109),(30010503,351,360,'[{1,40},{2,695080}]',40,695080,21602),(30010503,361,370,'[{1,41},{2,797086}]',41,797086,23036),(30010503,371,380,'[{1,42},{2,899922}]',42,899922,34905),(30010503,381,390,'[{1,43},{2,1003292}]',43,1003292,43921),(30010503,391,400,'[{1,44},{2,1107032}]',44,1107032,48723),(30010503,401,410,'[{1,45},{2,1208568}]',45,1208568,53525),(30010503,411,420,'[{1,46},{2,1288098}]',46,1288098,58326),(30010503,421,430,'[{1,47},{2,1367526}]',47,1367526,63128),(30010503,431,440,'[{1,48},{2,1446828}]',48,1446828,67929),(30010503,441,450,'[{1,49},{2,1525982}]',49,1525982,72374),(30010503,451,460,'[{1,50},{2,1609828}]',50,1609828,84422),(30010503,461,470,'[{1,51},{2,1737302}]',51,1737302,92533),(30010503,471,480,'[{1,52},{2,1864764}]',52,1864764,101004),(30010503,481,490,'[{1,53},{2,1992162}]',53,1992162,104605),(30010503,491,500,'[{1,54},{2,2119450}]',54,2119450,108207),(30010503,501,510,'[{1,55},{2,2249468}]',55,2249468,111808),(30010503,511,520,'[{1,56},{2,2405054}]',56,2405054,115409),(30010503,521,530,'[{1,57},{2,2560240}]',57,2560240,128364),(30010503,531,540,'[{1,58},{2,2715032}]',58,2715032,137560),(30010503,541,550,'[{1,59},{2,2869436}]',59,2869436,167451),(30010503,551,560,'[{1,60},{2,3023574}]',60,3023574,185877),(30010503,561,570,'[{1,61},{2,3178532}]',61,3178532,205263),(30010503,571,580,'[{1,62},{2,3333288}]',62,3333288,214866),(30010503,581,590,'[{1,63},{2,3487818}]',63,3487818,224469),(30010503,591,600,'[{1,64},{2,3642106}]',64,3642106,234073),(30010503,601,610,'[{1,65},{2,3798678}]',65,3798678,243676),(30010503,611,620,'[{1,66},{2,3977806}]',66,3977806,253279),(30010503,621,630,'[{1,67},{2,4156580}]',67,4156580,262883),(30010503,631,640,'[{1,68},{2,4334996}]',68,4334996,272486),(30010503,641,650,'[{1,69},{2,4513050}]',69,4513050,282089),(30010503,651,660,'[{1,70},{2,4694128}]',70,4694128,291692),(30010503,661,670,'[{1,71},{2,4905386}]',71,4905386,301296),(30010503,671,680,'[{1,72},{2,5116330}]',72,5116330,310899),(30010503,681,690,'[{1,73},{2,5326946}]',73,5326946,320502),(30010503,691,700,'[{1,74},{2,5537218}]',74,5537218,330105),(30010503,701,710,'[{1,75},{2,5744638}]',75,5744638,339709),(30010503,711,720,'[{1,76},{2,5929198}]',76,5929198,349312),(30010503,721,730,'[{1,77},{2,6113352}]',77,6113352,358915),(30010503,731,740,'[{1,78},{2,6297100}]',78,6297100,368518),(30010503,741,750,'[{1,79},{2,6480440}]',79,6480440,378122),(30010503,751,760,'[{1,80},{2,6666390}]',80,6666390,387725),(30010503,761,770,'[{1,81},{2,6879070}]',81,6879070,397328),(30010503,771,780,'[{1,82},{2,7091296}]',82,7091296,406931),(30010503,781,790,'[{1,83},{2,7303072}]',83,7303072,416535),(30010503,791,800,'[{1,83},{2,7514400}]',83,7514400,426138),(30010503,801,1000,'[{1,83},{2,7701492}]',83,7701492,426138),(30010504,1,70,'[{1,25},{2,37599}]',25,37599,6873),(30010504,71,119,'[{1,26},{2,37599}]',26,37599,6873),(30010504,120,149,'[{1,27},{2,62055}]',27,62055,7500),(30010504,150,169,'[{1,28},{2,66861}]',28,66861,7500),(30010504,170,190,'[{1,27},{2,77907}]',27,77907,7800),(30010504,191,230,'[{1,27},{2,97389}]',27,97389,10854),(30010504,231,240,'[{1,28},{2,197268}]',28,197268,12590),(30010504,241,250,'[{1,29},{2,175754}]',29,175754,14773),(30010504,251,260,'[{1,30},{2,219808}]',30,219808,15368),(30010504,261,270,'[{1,31},{2,253224}]',31,253224,15987),(30010504,271,280,'[{1,32},{2,286962}]',32,286962,16746),(30010504,281,290,'[{1,33},{2,320958}]',33,320958,16638),(30010504,291,300,'[{1,34},{2,355148}]',34,355148,17538),(30010504,301,310,'[{1,35},{2,392010}]',35,392010,17895),(30010504,311,320,'[{1,36},{2,451728}]',36,451728,17754),(30010504,321,330,'[{1,37},{2,511532}]',37,511532,18889),(30010504,331,340,'[{1,38},{2,571364}]',38,571364,20027),(30010504,341,350,'[{1,39},{2,631180}]',39,631180,20109),(30010504,351,360,'[{1,40},{2,695080}]',40,695080,21602),(30010504,361,370,'[{1,41},{2,797086}]',41,797086,23036),(30010504,371,380,'[{1,42},{2,899922}]',42,899922,34905),(30010504,381,390,'[{1,43},{2,1003292}]',43,1003292,43921),(30010504,391,400,'[{1,44},{2,1107032}]',44,1107032,48723),(30010504,401,410,'[{1,45},{2,1208568}]',45,1208568,53525),(30010504,411,420,'[{1,46},{2,1288098}]',46,1288098,58326),(30010504,421,430,'[{1,47},{2,1367526}]',47,1367526,63128),(30010504,431,440,'[{1,48},{2,1446828}]',48,1446828,67929),(30010504,441,450,'[{1,49},{2,1525982}]',49,1525982,72374),(30010504,451,460,'[{1,50},{2,1609828}]',50,1609828,84422),(30010504,461,470,'[{1,51},{2,1737302}]',51,1737302,92533),(30010504,471,480,'[{1,52},{2,1864764}]',52,1864764,101004),(30010504,481,490,'[{1,53},{2,1992162}]',53,1992162,104605),(30010504,491,500,'[{1,54},{2,2119450}]',54,2119450,108207),(30010504,501,510,'[{1,55},{2,2249468}]',55,2249468,111808),(30010504,511,520,'[{1,56},{2,2405054}]',56,2405054,115409),(30010504,521,530,'[{1,57},{2,2560240}]',57,2560240,128364),(30010504,531,540,'[{1,58},{2,2715032}]',58,2715032,137560),(30010504,541,550,'[{1,59},{2,2869436}]',59,2869436,167451),(30010504,551,560,'[{1,60},{2,3023574}]',60,3023574,185877),(30010504,561,570,'[{1,61},{2,3178532}]',61,3178532,205263),(30010504,571,580,'[{1,62},{2,3333288}]',62,3333288,214866),(30010504,581,590,'[{1,63},{2,3487818}]',63,3487818,224469),(30010504,591,600,'[{1,64},{2,3642106}]',64,3642106,234073),(30010504,601,610,'[{1,65},{2,3798678}]',65,3798678,243676),(30010504,611,620,'[{1,66},{2,3977806}]',66,3977806,253279),(30010504,621,630,'[{1,67},{2,4156580}]',67,4156580,262883),(30010504,631,640,'[{1,68},{2,4334996}]',68,4334996,272486),(30010504,641,650,'[{1,69},{2,4513050}]',69,4513050,282089),(30010504,651,660,'[{1,70},{2,4694128}]',70,4694128,291692),(30010504,661,670,'[{1,71},{2,4905386}]',71,4905386,301296),(30010504,671,680,'[{1,72},{2,5116330}]',72,5116330,310899),(30010504,681,690,'[{1,73},{2,5326946}]',73,5326946,320502),(30010504,691,700,'[{1,74},{2,5537218}]',74,5537218,330105),(30010504,701,710,'[{1,75},{2,5744638}]',75,5744638,339709),(30010504,711,720,'[{1,76},{2,5929198}]',76,5929198,349312),(30010504,721,730,'[{1,77},{2,6113352}]',77,6113352,358915),(30010504,731,740,'[{1,78},{2,6297100}]',78,6297100,368518),(30010504,741,750,'[{1,79},{2,6480440}]',79,6480440,378122),(30010504,751,760,'[{1,80},{2,6666390}]',80,6666390,387725),(30010504,761,770,'[{1,81},{2,6879070}]',81,6879070,397328),(30010504,771,780,'[{1,82},{2,7091296}]',82,7091296,406931),(30010504,781,790,'[{1,83},{2,7303072}]',83,7303072,416535),(30010504,791,800,'[{1,83},{2,7514400}]',83,7514400,426138),(30010504,801,1000,'[{1,83},{2,7701492}]',83,7701492,426138),(30010505,1,70,'[{1,25},{2,37599}]',25,37599,6873),(30010505,71,119,'[{1,26},{2,37599}]',26,37599,6873),(30010505,120,149,'[{1,27},{2,62055}]',27,62055,7500),(30010505,150,169,'[{1,28},{2,66861}]',28,66861,7500),(30010505,170,190,'[{1,27},{2,77907}]',27,77907,7800),(30010505,191,230,'[{1,27},{2,97389}]',27,97389,10854),(30010505,231,240,'[{1,28},{2,197268}]',28,197268,12590),(30010505,241,250,'[{1,29},{2,175754}]',29,175754,14773),(30010505,251,260,'[{1,30},{2,219808}]',30,219808,15368),(30010505,261,270,'[{1,31},{2,253224}]',31,253224,15987),(30010505,271,280,'[{1,32},{2,286962}]',32,286962,16746),(30010505,281,290,'[{1,33},{2,320958}]',33,320958,16638),(30010505,291,300,'[{1,34},{2,355148}]',34,355148,17538),(30010505,301,310,'[{1,35},{2,392010}]',35,392010,17895),(30010505,311,320,'[{1,36},{2,451728}]',36,451728,17754),(30010505,321,330,'[{1,37},{2,511532}]',37,511532,18889),(30010505,331,340,'[{1,38},{2,571364}]',38,571364,20027),(30010505,341,350,'[{1,39},{2,631180}]',39,631180,20109),(30010505,351,360,'[{1,40},{2,695080}]',40,695080,21602),(30010505,361,370,'[{1,41},{2,797086}]',41,797086,23036),(30010505,371,380,'[{1,42},{2,899922}]',42,899922,34905),(30010505,381,390,'[{1,43},{2,1003292}]',43,1003292,43921),(30010505,391,400,'[{1,44},{2,1107032}]',44,1107032,48723),(30010505,401,410,'[{1,45},{2,1208568}]',45,1208568,53525),(30010505,411,420,'[{1,46},{2,1288098}]',46,1288098,58326),(30010505,421,430,'[{1,47},{2,1367526}]',47,1367526,63128),(30010505,431,440,'[{1,48},{2,1446828}]',48,1446828,67929),(30010505,441,450,'[{1,49},{2,1525982}]',49,1525982,72374),(30010505,451,460,'[{1,50},{2,1609828}]',50,1609828,84422),(30010505,461,470,'[{1,51},{2,1737302}]',51,1737302,92533),(30010505,471,480,'[{1,52},{2,1864764}]',52,1864764,101004),(30010505,481,490,'[{1,53},{2,1992162}]',53,1992162,104605),(30010505,491,500,'[{1,54},{2,2119450}]',54,2119450,108207),(30010505,501,510,'[{1,55},{2,2249468}]',55,2249468,111808),(30010505,511,520,'[{1,56},{2,2405054}]',56,2405054,115409),(30010505,521,530,'[{1,57},{2,2560240}]',57,2560240,128364),(30010505,531,540,'[{1,58},{2,2715032}]',58,2715032,137560),(30010505,541,550,'[{1,59},{2,2869436}]',59,2869436,167451),(30010505,551,560,'[{1,60},{2,3023574}]',60,3023574,185877),(30010505,561,570,'[{1,61},{2,3178532}]',61,3178532,205263),(30010505,571,580,'[{1,62},{2,3333288}]',62,3333288,214866),(30010505,581,590,'[{1,63},{2,3487818}]',63,3487818,224469),(30010505,591,600,'[{1,64},{2,3642106}]',64,3642106,234073),(30010505,601,610,'[{1,65},{2,3798678}]',65,3798678,243676),(30010505,611,620,'[{1,66},{2,3977806}]',66,3977806,253279),(30010505,621,630,'[{1,67},{2,4156580}]',67,4156580,262883),(30010505,631,640,'[{1,68},{2,4334996}]',68,4334996,272486),(30010505,641,650,'[{1,69},{2,4513050}]',69,4513050,282089),(30010505,651,660,'[{1,70},{2,4694128}]',70,4694128,291692),(30010505,661,670,'[{1,71},{2,4905386}]',71,4905386,301296),(30010505,671,680,'[{1,72},{2,5116330}]',72,5116330,310899),(30010505,681,690,'[{1,73},{2,5326946}]',73,5326946,320502),(30010505,691,700,'[{1,74},{2,5537218}]',74,5537218,330105),(30010505,701,710,'[{1,75},{2,5744638}]',75,5744638,339709),(30010505,711,720,'[{1,76},{2,5929198}]',76,5929198,349312),(30010505,721,730,'[{1,77},{2,6113352}]',77,6113352,358915),(30010505,731,740,'[{1,78},{2,6297100}]',78,6297100,368518),(30010505,741,750,'[{1,79},{2,6480440}]',79,6480440,378122),(30010505,751,760,'[{1,80},{2,6666390}]',80,6666390,387725),(30010505,761,770,'[{1,81},{2,6879070}]',81,6879070,397328),(30010505,771,780,'[{1,82},{2,7091296}]',82,7091296,406931),(30010505,781,790,'[{1,83},{2,7303072}]',83,7303072,416535),(30010505,791,800,'[{1,83},{2,7514400}]',83,7514400,426138),(30010505,801,1000,'[{1,83},{2,7701492}]',83,7701492,426138),(30010506,1,70,'[{1,25},{2,37599}]',25,37599,6873),(30010506,71,119,'[{1,26},{2,37599}]',26,37599,6873),(30010506,120,149,'[{1,27},{2,62055}]',27,62055,7500),(30010506,150,169,'[{1,28},{2,66861}]',28,66861,7500),(30010506,170,190,'[{1,27},{2,77907}]',27,77907,7800),(30010506,191,230,'[{1,27},{2,97389}]',27,97389,10854),(30010506,231,240,'[{1,28},{2,197268}]',28,197268,12590),(30010506,241,250,'[{1,29},{2,175754}]',29,175754,14773),(30010506,251,260,'[{1,30},{2,219808}]',30,219808,15368),(30010506,261,270,'[{1,31},{2,253224}]',31,253224,15987),(30010506,271,280,'[{1,32},{2,286962}]',32,286962,16746),(30010506,281,290,'[{1,33},{2,320958}]',33,320958,16638),(30010506,291,300,'[{1,34},{2,355148}]',34,355148,17538),(30010506,301,310,'[{1,35},{2,392010}]',35,392010,17895),(30010506,311,320,'[{1,36},{2,451728}]',36,451728,17754),(30010506,321,330,'[{1,37},{2,511532}]',37,511532,18889),(30010506,331,340,'[{1,38},{2,571364}]',38,571364,20027),(30010506,341,350,'[{1,39},{2,631180}]',39,631180,20109),(30010506,351,360,'[{1,40},{2,695080}]',40,695080,21602),(30010506,361,370,'[{1,41},{2,797086}]',41,797086,23036),(30010506,371,380,'[{1,42},{2,899922}]',42,899922,34905),(30010506,381,390,'[{1,43},{2,1003292}]',43,1003292,43921),(30010506,391,400,'[{1,44},{2,1107032}]',44,1107032,48723),(30010506,401,410,'[{1,45},{2,1208568}]',45,1208568,53525),(30010506,411,420,'[{1,46},{2,1288098}]',46,1288098,58326),(30010506,421,430,'[{1,47},{2,1367526}]',47,1367526,63128),(30010506,431,440,'[{1,48},{2,1446828}]',48,1446828,67929),(30010506,441,450,'[{1,49},{2,1525982}]',49,1525982,72374),(30010506,451,460,'[{1,50},{2,1609828}]',50,1609828,84422),(30010506,461,470,'[{1,51},{2,1737302}]',51,1737302,92533),(30010506,471,480,'[{1,52},{2,1864764}]',52,1864764,101004),(30010506,481,490,'[{1,53},{2,1992162}]',53,1992162,104605),(30010506,491,500,'[{1,54},{2,2119450}]',54,2119450,108207),(30010506,501,510,'[{1,55},{2,2249468}]',55,2249468,111808),(30010506,511,520,'[{1,56},{2,2405054}]',56,2405054,115409),(30010506,521,530,'[{1,57},{2,2560240}]',57,2560240,128364),(30010506,531,540,'[{1,58},{2,2715032}]',58,2715032,137560),(30010506,541,550,'[{1,59},{2,2869436}]',59,2869436,167451),(30010506,551,560,'[{1,60},{2,3023574}]',60,3023574,185877),(30010506,561,570,'[{1,61},{2,3178532}]',61,3178532,205263),(30010506,571,580,'[{1,62},{2,3333288}]',62,3333288,214866),(30010506,581,590,'[{1,63},{2,3487818}]',63,3487818,224469),(30010506,591,600,'[{1,64},{2,3642106}]',64,3642106,234073),(30010506,601,610,'[{1,65},{2,3798678}]',65,3798678,243676),(30010506,611,620,'[{1,66},{2,3977806}]',66,3977806,253279),(30010506,621,630,'[{1,67},{2,4156580}]',67,4156580,262883),(30010506,631,640,'[{1,68},{2,4334996}]',68,4334996,272486),(30010506,641,650,'[{1,69},{2,4513050}]',69,4513050,282089),(30010506,651,660,'[{1,70},{2,4694128}]',70,4694128,291692),(30010506,661,670,'[{1,71},{2,4905386}]',71,4905386,301296),(30010506,671,680,'[{1,72},{2,5116330}]',72,5116330,310899),(30010506,681,690,'[{1,73},{2,5326946}]',73,5326946,320502),(30010506,691,700,'[{1,74},{2,5537218}]',74,5537218,330105),(30010506,701,710,'[{1,75},{2,5744638}]',75,5744638,339709),(30010506,711,720,'[{1,76},{2,5929198}]',76,5929198,349312),(30010506,721,730,'[{1,77},{2,6113352}]',77,6113352,358915),(30010506,731,740,'[{1,78},{2,6297100}]',78,6297100,368518),(30010506,741,750,'[{1,79},{2,6480440}]',79,6480440,378122),(30010506,751,760,'[{1,80},{2,6666390}]',80,6666390,387725),(30010506,761,770,'[{1,81},{2,6879070}]',81,6879070,397328),(30010506,771,780,'[{1,82},{2,7091296}]',82,7091296,406931),(30010506,781,790,'[{1,83},{2,7303072}]',83,7303072,416535),(30010506,791,800,'[{1,83},{2,7514400}]',83,7514400,426138),(30010506,801,1000,'[{1,83},{2,7701492}]',83,7701492,426138),(30010507,1,70,'[{1,25},{2,37599}]',25,37599,6873),(30010507,71,119,'[{1,26},{2,37599}]',26,37599,6873),(30010507,120,149,'[{1,27},{2,62055}]',27,62055,7500),(30010507,150,169,'[{1,28},{2,66861}]',28,66861,7500),(30010507,170,190,'[{1,27},{2,77907}]',27,77907,7800),(30010507,191,230,'[{1,27},{2,97389}]',27,97389,10854),(30010507,231,240,'[{1,28},{2,197268}]',28,197268,12590),(30010507,241,250,'[{1,29},{2,175754}]',29,175754,14773),(30010507,251,260,'[{1,30},{2,219808}]',30,219808,15368),(30010507,261,270,'[{1,31},{2,253224}]',31,253224,15987),(30010507,271,280,'[{1,32},{2,286962}]',32,286962,16746),(30010507,281,290,'[{1,33},{2,320958}]',33,320958,16638),(30010507,291,300,'[{1,34},{2,355148}]',34,355148,17538),(30010507,301,310,'[{1,35},{2,392010}]',35,392010,17895),(30010507,311,320,'[{1,36},{2,451728}]',36,451728,17754),(30010507,321,330,'[{1,37},{2,511532}]',37,511532,18889),(30010507,331,340,'[{1,38},{2,571364}]',38,571364,20027),(30010507,341,350,'[{1,39},{2,631180}]',39,631180,20109),(30010507,351,360,'[{1,40},{2,695080}]',40,695080,21602),(30010507,361,370,'[{1,41},{2,797086}]',41,797086,23036),(30010507,371,380,'[{1,42},{2,899922}]',42,899922,34905),(30010507,381,390,'[{1,43},{2,1003292}]',43,1003292,43921),(30010507,391,400,'[{1,44},{2,1107032}]',44,1107032,48723),(30010507,401,410,'[{1,45},{2,1208568}]',45,1208568,53525),(30010507,411,420,'[{1,46},{2,1288098}]',46,1288098,58326),(30010507,421,430,'[{1,47},{2,1367526}]',47,1367526,63128),(30010507,431,440,'[{1,48},{2,1446828}]',48,1446828,67929),(30010507,441,450,'[{1,49},{2,1525982}]',49,1525982,72374),(30010507,451,460,'[{1,50},{2,1609828}]',50,1609828,84422),(30010507,461,470,'[{1,51},{2,1737302}]',51,1737302,92533),(30010507,471,480,'[{1,52},{2,1864764}]',52,1864764,101004),(30010507,481,490,'[{1,53},{2,1992162}]',53,1992162,104605),(30010507,491,500,'[{1,54},{2,2119450}]',54,2119450,108207),(30010507,501,510,'[{1,55},{2,2249468}]',55,2249468,111808),(30010507,511,520,'[{1,56},{2,2405054}]',56,2405054,115409),(30010507,521,530,'[{1,57},{2,2560240}]',57,2560240,128364),(30010507,531,540,'[{1,58},{2,2715032}]',58,2715032,137560),(30010507,541,550,'[{1,59},{2,2869436}]',59,2869436,167451),(30010507,551,560,'[{1,60},{2,3023574}]',60,3023574,185877),(30010507,561,570,'[{1,61},{2,3178532}]',61,3178532,205263),(30010507,571,580,'[{1,62},{2,3333288}]',62,3333288,214866),(30010507,581,590,'[{1,63},{2,3487818}]',63,3487818,224469),(30010507,591,600,'[{1,64},{2,3642106}]',64,3642106,234073),(30010507,601,610,'[{1,65},{2,3798678}]',65,3798678,243676),(30010507,611,620,'[{1,66},{2,3977806}]',66,3977806,253279),(30010507,621,630,'[{1,67},{2,4156580}]',67,4156580,262883),(30010507,631,640,'[{1,68},{2,4334996}]',68,4334996,272486),(30010507,641,650,'[{1,69},{2,4513050}]',69,4513050,282089),(30010507,651,660,'[{1,70},{2,4694128}]',70,4694128,291692),(30010507,661,670,'[{1,71},{2,4905386}]',71,4905386,301296),(30010507,671,680,'[{1,72},{2,5116330}]',72,5116330,310899),(30010507,681,690,'[{1,73},{2,5326946}]',73,5326946,320502),(30010507,691,700,'[{1,74},{2,5537218}]',74,5537218,330105),(30010507,701,710,'[{1,75},{2,5744638}]',75,5744638,339709),(30010507,711,720,'[{1,76},{2,5929198}]',76,5929198,349312),(30010507,721,730,'[{1,77},{2,6113352}]',77,6113352,358915),(30010507,731,740,'[{1,78},{2,6297100}]',78,6297100,368518),(30010507,741,750,'[{1,79},{2,6480440}]',79,6480440,378122),(30010507,751,760,'[{1,80},{2,6666390}]',80,6666390,387725),(30010507,761,770,'[{1,81},{2,6879070}]',81,6879070,397328),(30010507,771,780,'[{1,82},{2,7091296}]',82,7091296,406931),(30010507,781,790,'[{1,83},{2,7303072}]',83,7303072,416535),(30010507,791,800,'[{1,83},{2,7514400}]',83,7514400,426138),(30010507,801,1000,'[{1,83},{2,7701492}]',83,7701492,426138),(30010508,1,70,'[{1,25},{2,37599}]',25,37599,6873),(30010508,71,119,'[{1,26},{2,37599}]',26,37599,6873),(30010508,120,149,'[{1,27},{2,62055}]',27,62055,7500),(30010508,150,169,'[{1,28},{2,66861}]',28,66861,7500),(30010508,170,190,'[{1,27},{2,77907}]',27,77907,7800),(30010508,191,230,'[{1,27},{2,97389}]',27,97389,10854),(30010508,231,240,'[{1,28},{2,197268}]',28,197268,12590),(30010508,241,250,'[{1,29},{2,175754}]',29,175754,14773),(30010508,251,260,'[{1,30},{2,219808}]',30,219808,15368),(30010508,261,270,'[{1,31},{2,253224}]',31,253224,15987),(30010508,271,280,'[{1,32},{2,286962}]',32,286962,16746),(30010508,281,290,'[{1,33},{2,320958}]',33,320958,16638),(30010508,291,300,'[{1,34},{2,355148}]',34,355148,17538),(30010508,301,310,'[{1,35},{2,392010}]',35,392010,17895),(30010508,311,320,'[{1,36},{2,451728}]',36,451728,17754),(30010508,321,330,'[{1,37},{2,511532}]',37,511532,18889),(30010508,331,340,'[{1,38},{2,571364}]',38,571364,20027),(30010508,341,350,'[{1,39},{2,631180}]',39,631180,20109),(30010508,351,360,'[{1,40},{2,695080}]',40,695080,21602),(30010508,361,370,'[{1,41},{2,797086}]',41,797086,23036),(30010508,371,380,'[{1,42},{2,899922}]',42,899922,34905),(30010508,381,390,'[{1,43},{2,1003292}]',43,1003292,43921),(30010508,391,400,'[{1,44},{2,1107032}]',44,1107032,48723),(30010508,401,410,'[{1,45},{2,1208568}]',45,1208568,53525),(30010508,411,420,'[{1,46},{2,1288098}]',46,1288098,58326),(30010508,421,430,'[{1,47},{2,1367526}]',47,1367526,63128),(30010508,431,440,'[{1,48},{2,1446828}]',48,1446828,67929),(30010508,441,450,'[{1,49},{2,1525982}]',49,1525982,72374),(30010508,451,460,'[{1,50},{2,1609828}]',50,1609828,84422),(30010508,461,470,'[{1,51},{2,1737302}]',51,1737302,92533),(30010508,471,480,'[{1,52},{2,1864764}]',52,1864764,101004),(30010508,481,490,'[{1,53},{2,1992162}]',53,1992162,104605),(30010508,491,500,'[{1,54},{2,2119450}]',54,2119450,108207),(30010508,501,510,'[{1,55},{2,2249468}]',55,2249468,111808),(30010508,511,520,'[{1,56},{2,2405054}]',56,2405054,115409),(30010508,521,530,'[{1,57},{2,2560240}]',57,2560240,128364),(30010508,531,540,'[{1,58},{2,2715032}]',58,2715032,137560),(30010508,541,550,'[{1,59},{2,2869436}]',59,2869436,167451),(30010508,551,560,'[{1,60},{2,3023574}]',60,3023574,185877),(30010508,561,570,'[{1,61},{2,3178532}]',61,3178532,205263),(30010508,571,580,'[{1,62},{2,3333288}]',62,3333288,214866),(30010508,581,590,'[{1,63},{2,3487818}]',63,3487818,224469),(30010508,591,600,'[{1,64},{2,3642106}]',64,3642106,234073),(30010508,601,610,'[{1,65},{2,3798678}]',65,3798678,243676),(30010508,611,620,'[{1,66},{2,3977806}]',66,3977806,253279),(30010508,621,630,'[{1,67},{2,4156580}]',67,4156580,262883),(30010508,631,640,'[{1,68},{2,4334996}]',68,4334996,272486),(30010508,641,650,'[{1,69},{2,4513050}]',69,4513050,282089),(30010508,651,660,'[{1,70},{2,4694128}]',70,4694128,291692),(30010508,661,670,'[{1,71},{2,4905386}]',71,4905386,301296),(30010508,671,680,'[{1,72},{2,5116330}]',72,5116330,310899),(30010508,681,690,'[{1,73},{2,5326946}]',73,5326946,320502),(30010508,691,700,'[{1,74},{2,5537218}]',74,5537218,330105),(30010508,701,710,'[{1,75},{2,5744638}]',75,5744638,339709),(30010508,711,720,'[{1,76},{2,5929198}]',76,5929198,349312),(30010508,721,730,'[{1,77},{2,6113352}]',77,6113352,358915),(30010508,731,740,'[{1,78},{2,6297100}]',78,6297100,368518),(30010508,741,750,'[{1,79},{2,6480440}]',79,6480440,378122),(30010508,751,760,'[{1,80},{2,6666390}]',80,6666390,387725),(30010508,761,770,'[{1,81},{2,6879070}]',81,6879070,397328),(30010508,771,780,'[{1,82},{2,7091296}]',82,7091296,406931),(30010508,781,790,'[{1,83},{2,7303072}]',83,7303072,416535),(30010508,791,800,'[{1,83},{2,7514400}]',83,7514400,426138),(30010508,801,1000,'[{1,83},{2,7701492}]',83,7701492,426138),(30010509,1,70,'[{1,25},{2,37599}]',25,37599,6873),(30010509,71,119,'[{1,26},{2,37599}]',26,37599,6873),(30010509,120,149,'[{1,27},{2,62055}]',27,62055,7500),(30010509,150,169,'[{1,28},{2,66861}]',28,66861,7500),(30010509,170,190,'[{1,27},{2,77907}]',27,77907,7800),(30010509,191,230,'[{1,27},{2,97389}]',27,97389,10854),(30010509,231,240,'[{1,28},{2,197268}]',28,197268,12590),(30010509,241,250,'[{1,29},{2,175754}]',29,175754,14773),(30010509,251,260,'[{1,30},{2,219808}]',30,219808,15368),(30010509,261,270,'[{1,31},{2,253224}]',31,253224,15987),(30010509,271,280,'[{1,32},{2,286962}]',32,286962,16746),(30010509,281,290,'[{1,33},{2,320958}]',33,320958,16638),(30010509,291,300,'[{1,34},{2,355148}]',34,355148,17538),(30010509,301,310,'[{1,35},{2,392010}]',35,392010,17895),(30010509,311,320,'[{1,36},{2,451728}]',36,451728,17754),(30010509,321,330,'[{1,37},{2,511532}]',37,511532,18889),(30010509,331,340,'[{1,38},{2,571364}]',38,571364,20027),(30010509,341,350,'[{1,39},{2,631180}]',39,631180,20109),(30010509,351,360,'[{1,40},{2,695080}]',40,695080,21602),(30010509,361,370,'[{1,41},{2,797086}]',41,797086,23036),(30010509,371,380,'[{1,42},{2,899922}]',42,899922,34905),(30010509,381,390,'[{1,43},{2,1003292}]',43,1003292,43921),(30010509,391,400,'[{1,44},{2,1107032}]',44,1107032,48723),(30010509,401,410,'[{1,45},{2,1208568}]',45,1208568,53525),(30010509,411,420,'[{1,46},{2,1288098}]',46,1288098,58326),(30010509,421,430,'[{1,47},{2,1367526}]',47,1367526,63128),(30010509,431,440,'[{1,48},{2,1446828}]',48,1446828,67929),(30010509,441,450,'[{1,49},{2,1525982}]',49,1525982,72374),(30010509,451,460,'[{1,50},{2,1609828}]',50,1609828,84422),(30010509,461,470,'[{1,51},{2,1737302}]',51,1737302,92533),(30010509,471,480,'[{1,52},{2,1864764}]',52,1864764,101004),(30010509,481,490,'[{1,53},{2,1992162}]',53,1992162,104605),(30010509,491,500,'[{1,54},{2,2119450}]',54,2119450,108207),(30010509,501,510,'[{1,55},{2,2249468}]',55,2249468,111808),(30010509,511,520,'[{1,56},{2,2405054}]',56,2405054,115409),(30010509,521,530,'[{1,57},{2,2560240}]',57,2560240,128364),(30010509,531,540,'[{1,58},{2,2715032}]',58,2715032,137560),(30010509,541,550,'[{1,59},{2,2869436}]',59,2869436,167451),(30010509,551,560,'[{1,60},{2,3023574}]',60,3023574,185877),(30010509,561,570,'[{1,61},{2,3178532}]',61,3178532,205263),(30010509,571,580,'[{1,62},{2,3333288}]',62,3333288,214866),(30010509,581,590,'[{1,63},{2,3487818}]',63,3487818,224469),(30010509,591,600,'[{1,64},{2,3642106}]',64,3642106,234073),(30010509,601,610,'[{1,65},{2,3798678}]',65,3798678,243676),(30010509,611,620,'[{1,66},{2,3977806}]',66,3977806,253279),(30010509,621,630,'[{1,67},{2,4156580}]',67,4156580,262883),(30010509,631,640,'[{1,68},{2,4334996}]',68,4334996,272486),(30010509,641,650,'[{1,69},{2,4513050}]',69,4513050,282089),(30010509,651,660,'[{1,70},{2,4694128}]',70,4694128,291692),(30010509,661,670,'[{1,71},{2,4905386}]',71,4905386,301296),(30010509,671,680,'[{1,72},{2,5116330}]',72,5116330,310899),(30010509,681,690,'[{1,73},{2,5326946}]',73,5326946,320502),(30010509,691,700,'[{1,74},{2,5537218}]',74,5537218,330105),(30010509,701,710,'[{1,75},{2,5744638}]',75,5744638,339709),(30010509,711,720,'[{1,76},{2,5929198}]',76,5929198,349312),(30010509,721,730,'[{1,77},{2,6113352}]',77,6113352,358915),(30010509,731,740,'[{1,78},{2,6297100}]',78,6297100,368518),(30010509,741,750,'[{1,79},{2,6480440}]',79,6480440,378122),(30010509,751,760,'[{1,80},{2,6666390}]',80,6666390,387725),(30010509,761,770,'[{1,81},{2,6879070}]',81,6879070,397328),(30010509,771,780,'[{1,82},{2,7091296}]',82,7091296,406931),(30010509,781,790,'[{1,83},{2,7303072}]',83,7303072,416535),(30010509,791,800,'[{1,83},{2,7514400}]',83,7514400,426138),(30010509,801,1000,'[{1,83},{2,7701492}]',83,7701492,426138),(58110001,1,200,'[{1,0},{2,972891}]',0,972891,0),(58110001,201,260,'[{1,0},{2,2754421}]',0,2754421,0),(58110001,261,320,'[{1,0},{2,5259200}]',0,5259200,0),(58110001,321,350,'[{1,0},{2,7003746}]',0,7003746,0),(58110001,351,370,'[{1,0},{2,8800067}]',0,8800067,0),(58110001,371,390,'[{1,0},{2,10596388}]',0,10596388,0),(58110001,391,430,'[{1,0},{2,13640821}]',0,13640821,0),(58110001,431,500,'[{1,0},{2,20396448}]',0,20396448,0),(58110001,501,560,'[{1,0},{2,27871225}]',0,27871225,0),(58110001,561,610,'[{1,0},{2,34558682}]',0,34558682,0),(58110001,611,660,'[{1,0},{2,42109146}]',0,42109146,0),(58110001,661,750,'[{1,0},{2,57255498}]',0,57255498,0),(58110001,751,1000,'[{1,0},{2,65842956}]',0,65842956,0),(58110002,1,200,'[{1,0},{2,972891}]',0,972891,0),(58110002,201,260,'[{1,0},{2,2754421}]',0,2754421,0),(58110002,261,320,'[{1,0},{2,5259200}]',0,5259200,0),(58110002,321,350,'[{1,0},{2,7003746}]',0,7003746,0),(58110002,351,370,'[{1,0},{2,8800067}]',0,8800067,0),(58110002,371,390,'[{1,0},{2,10596388}]',0,10596388,0),(58110002,391,430,'[{1,0},{2,13640821}]',0,13640821,0),(58110002,431,500,'[{1,0},{2,20396448}]',0,20396448,0),(58110002,501,560,'[{1,0},{2,27871225}]',0,27871225,0),(58110002,561,610,'[{1,0},{2,34558682}]',0,34558682,0),(58110002,611,660,'[{1,0},{2,42109146}]',0,42109146,0),(58110002,661,750,'[{1,0},{2,57255498}]',0,57255498,0),(58110002,751,1000,'[{1,0},{2,65842956}]',0,65842956,0),(58110003,1,200,'[{1,0},{2,972891}]',0,972891,0),(58110003,201,260,'[{1,0},{2,2754421}]',0,2754421,0),(58110003,261,320,'[{1,0},{2,5259200}]',0,5259200,0),(58110003,321,350,'[{1,0},{2,7003746}]',0,7003746,0),(58110003,351,370,'[{1,0},{2,8800067}]',0,8800067,0),(58110003,371,390,'[{1,0},{2,10596388}]',0,10596388,0),(58110003,391,430,'[{1,0},{2,13640821}]',0,13640821,0),(58110003,431,500,'[{1,0},{2,20396448}]',0,20396448,0),(58110003,501,560,'[{1,0},{2,27871225}]',0,27871225,0),(58110003,561,610,'[{1,0},{2,34558682}]',0,34558682,0),(58110003,611,660,'[{1,0},{2,42109146}]',0,42109146,0),(58110003,661,750,'[{1,0},{2,57255498}]',0,57255498,0),(58110003,751,1000,'[{1,0},{2,65842956}]',0,65842956,0),(58110004,1,200,'[{1,0},{2,972891}]',0,972891,0),(58110004,201,260,'[{1,0},{2,2754421}]',0,2754421,0),(58110004,261,320,'[{1,0},{2,5259200}]',0,5259200,0),(58110004,321,350,'[{1,0},{2,7003746}]',0,7003746,0),(58110004,351,370,'[{1,0},{2,8800067}]',0,8800067,0),(58110004,371,390,'[{1,0},{2,10596388}]',0,10596388,0),(58110004,391,430,'[{1,0},{2,13640821}]',0,13640821,0),(58110004,431,500,'[{1,0},{2,20396448}]',0,20396448,0),(58110004,501,560,'[{1,0},{2,27871225}]',0,27871225,0),(58110004,561,610,'[{1,0},{2,34558682}]',0,34558682,0),(58110004,611,660,'[{1,0},{2,42109146}]',0,42109146,0),(58110004,661,750,'[{1,0},{2,57255498}]',0,57255498,0),(58110004,751,1000,'[{1,0},{2,65842956}]',0,65842956,0);
/*!40000 ALTER TABLE `base_mon_dynamic` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_mon_type_lv_hurt`
--

DROP TABLE IF EXISTS `base_mon_type_lv_hurt`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_mon_type_lv_hurt` (
  `mon_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '怪物类型',
  `blv` float(11,0) NOT NULL DEFAULT '0' COMMENT '开始等级',
  `elv` float(11,0) NOT NULL DEFAULT '0' COMMENT '结束等级',
  `role_add_hurt` float(11,2) DEFAULT '0.00' COMMENT '玩家伤害加成',
  `mon_add_hurt` float(11,2) DEFAULT '0.00' COMMENT '怪物伤害加成',
  PRIMARY KEY (`mon_type`,`blv`,`elv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_mon_type_lv_hurt`
--

LOCK TABLES `base_mon_type_lv_hurt` WRITE;
/*!40000 ALTER TABLE `base_mon_type_lv_hurt` DISABLE KEYS */;
INSERT INTO `base_mon_type_lv_hurt` VALUES (3,-999,-100,-0.85,3.00),(3,-99,-90,-0.80,2.70),(3,-89,-80,-0.75,2.40),(3,-79,-70,-0.70,2.10),(3,-69,-60,-0.65,1.80),(3,-59,-50,-0.60,1.50),(3,-49,-40,-0.50,1.20),(3,-39,-30,-0.40,0.90),(3,-29,-20,-0.30,0.60),(3,-19,-10,-0.20,0.40),(3,-9,0,-0.10,0.20),(3,1,999,0.00,0.00),(4,-999,-100,-0.80,2.00),(4,-99,-90,-0.70,1.60),(4,-89,-80,-0.60,1.30),(4,-79,-70,-0.50,1.10),(4,-69,-60,-0.40,0.90),(4,-59,-50,-0.35,0.70),(4,-49,-40,-0.30,0.50),(4,-39,-30,-0.25,0.40),(4,-29,-20,-0.20,0.30),(4,-19,-10,-0.15,0.20),(4,-9,0,-0.10,0.10),(4,1,999,0.00,0.00);
/*!40000 ALTER TABLE `base_mon_type_lv_hurt` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_money_passoff_type`
--

DROP TABLE IF EXISTS `base_money_passoff_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_money_passoff_type` (
  `type` varchar(255) NOT NULL COMMENT '类型',
  `id` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `about` varchar(255) NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='金钱消耗类型配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_money_passoff_type`
--

LOCK TABLES `base_money_passoff_type` WRITE;
/*!40000 ALTER TABLE `base_money_passoff_type` DISABLE KEYS */;
INSERT INTO `base_money_passoff_type` VALUES ('wanted_for_arrest',2,'通缉'),('shop',3,'商城'),('equip_identify',4,'装备鉴定'),('equip_wash',5,'装备洗练'),('equip_stren',6,'装备强化'),('stren_break',7,'强化突破'),('stone_compose',8,'合成英灵石'),('unequip_stone',9,'卸载英灵石'),('sell_up',10,'交易上架手续费'),('pay_sell',11,'交易行购买商品'),('refresh_sell',12,'刷新交易行'),('resell',13,'重新上架手续费'),('pay_auction',14,'竞拍'),('goods_compose',15,'物品合成'),('vip_present',16,'vip礼包'),('life_praise_bless',17,'生命赞礼的祝福'),('arrest_cost',18,'被抓捕，损失金钱');
/*!40000 ALTER TABLE `base_money_passoff_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_money_produce_type`
--

DROP TABLE IF EXISTS `base_money_produce_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_money_produce_type` (
  `type` varchar(255) NOT NULL COMMENT '类型',
  `id` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `about` varchar(255) NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='金钱产出类型配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_money_produce_type`
--

LOCK TABLES `base_money_produce_type` WRITE;
/*!40000 ALTER TABLE `base_money_produce_type` DISABLE KEYS */;
INSERT INTO `base_money_produce_type` VALUES ('mail_attachment',1,'邮件附件'),('sell_goods',2,'出售物品'),('auction_fail',3,'竞拍失败，返还竞拍资金'),('recharge',4,'充值'),('recharge_card',5,'充值卡'),('mon_drop',6,'怪物掉落'),('share_fruit',7,'果实分享'),('share_fruit_return',8,'果实回礼'),('eat_fruit',9,'咬果实'),('life_praise_bless',10,'生命礼赞的祝福'),('walfare_reward',11,'福利卡奖励'),('arrest',18,'抓捕成功，获得金钱');
/*!40000 ALTER TABLE `base_money_produce_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_mount_equip_attr`
--

DROP TABLE IF EXISTS `base_mount_equip_attr`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_mount_equip_attr` (
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型id',
  `pos` tinyint(3) unsigned NOT NULL COMMENT '装备位置',
  `quality` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '装备品质',
  `star` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '装备星级',
  `base_rating` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '基础装备评分(预览展示用)',
  `recommend_attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '推荐属性(预览展示用) ',
  `nattr_1` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '蓝属数量',
  `vattr_1` text NOT NULL COMMENT '蓝属',
  `nattr_2` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '紫属数量',
  `vattr_2` text NOT NULL COMMENT '紫属',
  `nattr_3` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '橙属数量',
  `vattr_3` text NOT NULL COMMENT '橙属',
  `nattr_4` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '红属数量',
  `vattr_4` text NOT NULL COMMENT '红属',
  PRIMARY KEY (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备属性';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_mount_equip_attr`
--

LOCK TABLES `base_mount_equip_attr` WRITE;
/*!40000 ALTER TABLE `base_mount_equip_attr` DISABLE KEYS */;
INSERT INTO `base_mount_equip_attr` VALUES (16040101,1,0,1,10005,'[]',0,'[]',0,'[]',0,'[]',0,'[]'),(16040102,1,0,2,15020,'[]',0,'[]',0,'[]',0,'[]',0,'[]'),(16040103,1,0,3,20010,'[]',0,'[]',0,'[]',0,'[]',0,'[]'),(16040104,1,0,4,25025,'[]',0,'[]',0,'[]',0,'[]',0,'[]'),(16040105,1,0,5,30015,'[]',0,'[]',0,'[]',0,'[]',0,'[]'),(16040111,1,1,1,27025,'[{100,{1,1,28}}]',1,'[{100,{1,1,14}},{100,{1,1,17}},{100,{1,1,20}},{100,{1,1,23}},{100,{1,1,26}},{100,{1,1,28}},{100,{1,5,6}},{100,{1,5,7}},{100,{1,5,8}},{100,{1,5,9}},{100,{1,5,11}},{100,{1,5,12}},{100,{1,7,6}},{100,{1,7,7}},{100,{1,7,8}},{100,{1,7,9}},{100,{1,7,11}},{100,{1,7,12}},{100,{1,48,10}},{100,{1,48,12}},{100,{1,48,14}},{100,{1,48,15}},{100,{1,48,17}},{100,{1,48,19}},{100,{1,15,10}},{100,{1,15,12}},{100,{1,15,14}},{100,{1,15,15}},{100,{1,15,17}},{100,{1,15,19}}]',0,'[]',0,'[]',0,'[]'),(16040112,1,1,2,40525,'[{100,{1,1,28}}]',1,'[{100,{1,1,14}},{100,{1,1,17}},{100,{1,1,20}},{100,{1,1,23}},{100,{1,1,26}},{100,{1,1,28}},{100,{1,5,6}},{100,{1,5,7}},{100,{1,5,8}},{100,{1,5,9}},{100,{1,5,11}},{100,{1,5,12}},{100,{1,7,6}},{100,{1,7,7}},{100,{1,7,8}},{100,{1,7,9}},{100,{1,7,11}},{100,{1,7,12}},{100,{1,48,10}},{100,{1,48,12}},{100,{1,48,14}},{100,{1,48,15}},{100,{1,48,17}},{100,{1,48,19}},{100,{1,15,10}},{100,{1,15,12}},{100,{1,15,14}},{100,{1,15,15}},{100,{1,15,17}},{100,{1,15,19}}]',0,'[]',0,'[]',0,'[]'),(16040113,1,1,3,54025,'[{100,{1,1,28}},{100,{1,15,19}}]',2,'[{100,{1,1,14}},{100,{1,1,17}},{100,{1,1,20}},{100,{1,1,23}},{100,{1,1,26}},{100,{1,1,28}},{100,{1,5,6}},{100,{1,5,7}},{100,{1,5,8}},{100,{1,5,9}},{100,{1,5,11}},{100,{1,5,12}},{100,{1,7,6}},{100,{1,7,7}},{100,{1,7,8}},{100,{1,7,9}},{100,{1,7,11}},{100,{1,7,12}},{100,{1,48,10}},{100,{1,48,12}},{100,{1,48,14}},{100,{1,48,15}},{100,{1,48,17}},{100,{1,48,19}},{100,{1,15,10}},{100,{1,15,12}},{100,{1,15,14}},{100,{1,15,15}},{100,{1,15,17}},{100,{1,15,19}}]',0,'[]',0,'[]',0,'[]'),(16040114,1,1,4,67505,'[{100,{1,1,28}},{100,{1,15,19}}]',2,'[{100,{1,1,14}},{100,{1,1,17}},{100,{1,1,20}},{100,{1,1,23}},{100,{1,1,26}},{100,{1,1,28}},{100,{1,5,6}},{100,{1,5,7}},{100,{1,5,8}},{100,{1,5,9}},{100,{1,5,11}},{100,{1,5,12}},{100,{1,7,6}},{100,{1,7,7}},{100,{1,7,8}},{100,{1,7,9}},{100,{1,7,11}},{100,{1,7,12}},{100,{1,48,10}},{100,{1,48,12}},{100,{1,48,14}},{100,{1,48,15}},{100,{1,48,17}},{100,{1,48,19}},{100,{1,15,10}},{100,{1,15,12}},{100,{1,15,14}},{100,{1,15,15}},{100,{1,15,17}},{100,{1,15,19}}]',0,'[]',0,'[]',0,'[]'),(16040115,1,1,5,81030,'[{100,{1,1,28}},{100,{1,15,19}}]',2,'[{100,{1,1,14}},{100,{1,1,17}},{100,{1,1,20}},{100,{1,1,23}},{100,{1,1,26}},{100,{1,1,28}},{100,{1,5,6}},{100,{1,5,7}},{100,{1,5,8}},{100,{1,5,9}},{100,{1,5,11}},{100,{1,5,12}},{100,{1,7,6}},{100,{1,7,7}},{100,{1,7,8}},{100,{1,7,9}},{100,{1,7,11}},{100,{1,7,12}},{100,{1,48,10}},{100,{1,48,12}},{100,{1,48,14}},{100,{1,48,15}},{100,{1,48,17}},{100,{1,48,19}},{100,{1,15,10}},{100,{1,15,12}},{100,{1,15,14}},{100,{1,15,15}},{100,{1,15,17}},{100,{1,15,19}}]',0,'[]',0,'[]',0,'[]'),(16040121,1,2,1,70035,'[{100,{1,1,40}},{100,{2,15,67}}]',1,'[{100,{1,1,20}},{100,{1,1,24}},{100,{1,1,28}},{100,{1,1,32}},{100,{1,1,36}},{100,{1,1,40}},{100,{1,5,8}},{100,{1,5,10}},{100,{1,5,12}},{100,{1,5,13}},{100,{1,5,15}},{100,{1,5,16}},{100,{1,7,8}},{100,{1,7,10}},{100,{1,7,12}},{100,{1,7,13}},{100,{1,7,15}},{100,{1,7,16}},{100,{1,48,14}},{100,{1,48,16}},{100,{1,48,19}},{100,{1,48,22}},{100,{1,48,24}},{100,{1,48,27}},{100,{1,15,14}},{100,{1,15,16}},{100,{1,15,19}},{100,{1,15,22}},{100,{1,15,24}},{100,{1,15,27}}]',1,'[{100,{2,1,80}},{100,{2,1,84}},{100,{2,1,88}},{100,{2,1,92}},{100,{2,1,96}},{100,{2,1,100}},{100,{2,5,32}},{100,{2,5,34}},{100,{2,5,36}},{100,{2,5,37}},{100,{2,5,39}},{100,{2,5,40}},{100,{2,7,32}},{100,{2,7,34}},{100,{2,7,36}},{100,{2,7,37}},{100,{2,7,39}},{100,{2,7,40}},{100,{2,48,54}},{100,{2,48,56}},{100,{2,48,59}},{100,{2,48,62}},{100,{2,48,64}},{100,{2,48,67}},{100,{2,15,54}},{100,{2,15,56}},{100,{2,15,59}},{100,{2,15,62}},{100,{2,15,64}},{100,{2,15,67}}]',0,'[]',0,'[]'),(16040122,1,2,2,105040,'[{100,{1,1,40}},{100,{2,15,67}}]',1,'[{100,{1,1,20}},{100,{1,1,24}},{100,{1,1,28}},{100,{1,1,32}},{100,{1,1,36}},{100,{1,1,40}},{100,{1,5,8}},{100,{1,5,10}},{100,{1,5,12}},{100,{1,5,13}},{100,{1,5,15}},{100,{1,5,16}},{100,{1,7,8}},{100,{1,7,10}},{100,{1,7,12}},{100,{1,7,13}},{100,{1,7,15}},{100,{1,7,16}},{100,{1,48,14}},{100,{1,48,16}},{100,{1,48,19}},{100,{1,48,22}},{100,{1,48,24}},{100,{1,48,27}},{100,{1,15,14}},{100,{1,15,16}},{100,{1,15,19}},{100,{1,15,22}},{100,{1,15,24}},{100,{1,15,27}}]',1,'[{100,{2,1,80}},{100,{2,1,84}},{100,{2,1,88}},{100,{2,1,92}},{100,{2,1,96}},{100,{2,1,100}},{100,{2,5,32}},{100,{2,5,34}},{100,{2,5,36}},{100,{2,5,37}},{100,{2,5,39}},{100,{2,5,40}},{100,{2,7,32}},{100,{2,7,34}},{100,{2,7,36}},{100,{2,7,37}},{100,{2,7,39}},{100,{2,7,40}},{100,{2,48,54}},{100,{2,48,56}},{100,{2,48,59}},{100,{2,48,62}},{100,{2,48,64}},{100,{2,48,67}},{100,{2,15,54}},{100,{2,15,56}},{100,{2,15,59}},{100,{2,15,62}},{100,{2,15,64}},{100,{2,15,67}}]',0,'[]',0,'[]'),(16040123,1,2,3,140025,'[{100,{2,1,100}},{100,{2,15,67}}]',0,'[]',2,'[{100,{2,1,80}},{100,{2,1,84}},{100,{2,1,88}},{100,{2,1,92}},{100,{2,1,96}},{100,{2,1,100}},{100,{2,5,32}},{100,{2,5,34}},{100,{2,5,36}},{100,{2,5,37}},{100,{2,5,39}},{100,{2,5,40}},{100,{2,7,32}},{100,{2,7,34}},{100,{2,7,36}},{100,{2,7,37}},{100,{2,7,39}},{100,{2,7,40}},{100,{2,48,54}},{100,{2,48,56}},{100,{2,48,59}},{100,{2,48,62}},{100,{2,48,64}},{100,{2,48,67}},{100,{2,15,54}},{100,{2,15,56}},{100,{2,15,59}},{100,{2,15,62}},{100,{2,15,64}},{100,{2,15,67}}]',0,'[]',0,'[]'),(16040124,1,2,4,175030,'[{100,{2,1,100}},{100,{2,15,67}}]',0,'[]',2,'[{100,{2,1,80}},{100,{2,1,84}},{100,{2,1,88}},{100,{2,1,92}},{100,{2,1,96}},{100,{2,1,100}},{100,{2,5,32}},{100,{2,5,34}},{100,{2,5,36}},{100,{2,5,37}},{100,{2,5,39}},{100,{2,5,40}},{100,{2,7,32}},{100,{2,7,34}},{100,{2,7,36}},{100,{2,7,37}},{100,{2,7,39}},{100,{2,7,40}},{100,{2,48,54}},{100,{2,48,56}},{100,{2,48,59}},{100,{2,48,62}},{100,{2,48,64}},{100,{2,48,67}},{100,{2,15,54}},{100,{2,15,56}},{100,{2,15,59}},{100,{2,15,62}},{100,{2,15,64}},{100,{2,15,67}}]',0,'[]',0,'[]'),(16040125,1,2,5,210035,'[{100,{2,1,100}},{100,{2,15,67}}]',0,'[]',2,'[{100,{2,1,80}},{100,{2,1,84}},{100,{2,1,88}},{100,{2,1,92}},{100,{2,1,96}},{100,{2,1,100}},{100,{2,5,32}},{100,{2,5,34}},{100,{2,5,36}},{100,{2,5,37}},{100,{2,5,39}},{100,{2,5,40}},{100,{2,7,32}},{100,{2,7,34}},{100,{2,7,36}},{100,{2,7,37}},{100,{2,7,39}},{100,{2,7,40}},{100,{2,48,54}},{100,{2,48,56}},{100,{2,48,59}},{100,{2,48,62}},{100,{2,48,64}},{100,{2,48,67}},{100,{2,15,54}},{100,{2,15,56}},{100,{2,15,59}},{100,{2,15,62}},{100,{2,15,64}},{100,{2,15,67}}]',0,'[]',0,'[]'),(16040131,1,3,1,180020,'[{100,{2,1,200}},{100,{3,15,187}}]',0,'[]',1,'[{100,{2,1,160}},{100,{2,1,168}},{100,{2,1,176}},{100,{2,1,184}},{100,{2,1,192}},{100,{2,1,200}},{100,{2,5,64}},{100,{2,5,68}},{100,{2,5,71}},{100,{2,5,74}},{100,{2,5,77}},{100,{2,5,80}},{100,{2,7,64}},{100,{2,7,68}},{100,{2,7,71}},{100,{2,7,74}},{100,{2,7,77}},{100,{2,7,80}},{100,{2,48,107}},{100,{2,48,112}},{100,{2,48,118}},{100,{2,48,123}},{100,{2,48,128}},{100,{2,48,134}},{100,{2,15,107}},{100,{2,15,112}},{100,{2,15,118}},{100,{2,15,123}},{100,{2,15,128}},{100,{2,15,134}}]',1,'[{100,{3,1,240}},{100,{3,1,248}},{100,{3,1,256}},{100,{3,1,264}},{100,{3,1,272}},{100,{3,1,280}},{100,{3,5,96}},{100,{3,5,100}},{100,{3,5,103}},{100,{3,5,106}},{100,{3,5,109}},{100,{3,5,112}},{100,{3,7,96}},{100,{3,7,100}},{100,{3,7,103}},{100,{3,7,106}},{100,{3,7,109}},{100,{3,7,112}},{100,{3,48,160}},{100,{3,48,166}},{100,{3,48,171}},{100,{3,48,176}},{100,{3,48,182}},{100,{3,48,187}},{100,{3,15,160}},{100,{3,15,166}},{100,{3,15,171}},{100,{3,15,176}},{100,{3,15,182}},{100,{3,15,187}}]',0,'[]'),(16040132,1,3,2,270020,'[{100,{2,1,200}},{100,{3,15,187}}]',0,'[]',1,'[{100,{2,1,160}},{100,{2,1,168}},{100,{2,1,176}},{100,{2,1,184}},{100,{2,1,192}},{100,{2,1,200}},{100,{2,5,64}},{100,{2,5,68}},{100,{2,5,71}},{100,{2,5,74}},{100,{2,5,77}},{100,{2,5,80}},{100,{2,7,64}},{100,{2,7,68}},{100,{2,7,71}},{100,{2,7,74}},{100,{2,7,77}},{100,{2,7,80}},{100,{2,48,107}},{100,{2,48,112}},{100,{2,48,118}},{100,{2,48,123}},{100,{2,48,128}},{100,{2,48,134}},{100,{2,15,107}},{100,{2,15,112}},{100,{2,15,118}},{100,{2,15,123}},{100,{2,15,128}},{100,{2,15,134}}]',1,'[{100,{3,1,240}},{100,{3,1,248}},{100,{3,1,256}},{100,{3,1,264}},{100,{3,1,272}},{100,{3,1,280}},{100,{3,5,96}},{100,{3,5,100}},{100,{3,5,103}},{100,{3,5,106}},{100,{3,5,109}},{100,{3,5,112}},{100,{3,7,96}},{100,{3,7,100}},{100,{3,7,103}},{100,{3,7,106}},{100,{3,7,109}},{100,{3,7,112}},{100,{3,48,160}},{100,{3,48,166}},{100,{3,48,171}},{100,{3,48,176}},{100,{3,48,182}},{100,{3,48,187}},{100,{3,15,160}},{100,{3,15,166}},{100,{3,15,171}},{100,{3,15,176}},{100,{3,15,182}},{100,{3,15,187}}]',0,'[]'),(16040133,1,3,3,360020,'[{100,{3,1,280}},{100,{3,15,187}}]',0,'[]',0,'[]',2,'[{100,{3,1,240}},{100,{3,1,248}},{100,{3,1,256}},{100,{3,1,264}},{100,{3,1,272}},{100,{3,1,280}},{100,{3,5,96}},{100,{3,5,100}},{100,{3,5,103}},{100,{3,5,106}},{100,{3,5,109}},{100,{3,5,112}},{100,{3,7,96}},{100,{3,7,100}},{100,{3,7,103}},{100,{3,7,106}},{100,{3,7,109}},{100,{3,7,112}},{100,{3,48,160}},{100,{3,48,166}},{100,{3,48,171}},{100,{3,48,176}},{100,{3,48,182}},{100,{3,48,187}},{100,{3,15,160}},{100,{3,15,166}},{100,{3,15,171}},{100,{3,15,176}},{100,{3,15,182}},{100,{3,15,187}}]',0,'[]'),(16040134,1,3,4,450040,'[{100,{3,1,280}},{100,{3,15,187}},{100,{2,7,80}}]',0,'[]',1,'[{100,{2,1,160}},{100,{2,1,168}},{100,{2,1,176}},{100,{2,1,184}},{100,{2,1,192}},{100,{2,1,200}},{100,{2,5,64}},{100,{2,5,68}},{100,{2,5,71}},{100,{2,5,74}},{100,{2,5,77}},{100,{2,5,80}},{100,{2,7,64}},{100,{2,7,68}},{100,{2,7,71}},{100,{2,7,74}},{100,{2,7,77}},{100,{2,7,80}},{100,{2,48,107}},{100,{2,48,112}},{100,{2,48,118}},{100,{2,48,123}},{100,{2,48,128}},{100,{2,48,134}},{100,{2,15,107}},{100,{2,15,112}},{100,{2,15,118}},{100,{2,15,123}},{100,{2,15,128}},{100,{2,15,134}}]',2,'[{100,{3,1,240}},{100,{3,1,248}},{100,{3,1,256}},{100,{3,1,264}},{100,{3,1,272}},{100,{3,1,280}},{100,{3,5,96}},{100,{3,5,100}},{100,{3,5,103}},{100,{3,5,106}},{100,{3,5,109}},{100,{3,5,112}},{100,{3,7,96}},{100,{3,7,100}},{100,{3,7,103}},{100,{3,7,106}},{100,{3,7,109}},{100,{3,7,112}},{100,{3,48,160}},{100,{3,48,166}},{100,{3,48,171}},{100,{3,48,176}},{100,{3,48,182}},{100,{3,48,187}},{100,{3,15,160}},{100,{3,15,166}},{100,{3,15,171}},{100,{3,15,176}},{100,{3,15,182}},{100,{3,15,187}}]',0,'[]'),(16040135,1,3,5,540015,'[{100,{3,1,280}},{100,{3,15,187}},{100,{3,7,112}}]',0,'[]',0,'[]',3,'[{100,{3,1,240}},{100,{3,1,248}},{100,{3,1,256}},{100,{3,1,264}},{100,{3,1,272}},{100,{3,1,280}},{100,{3,5,96}},{100,{3,5,100}},{100,{3,5,103}},{100,{3,5,106}},{100,{3,5,109}},{100,{3,5,112}},{100,{3,7,96}},{100,{3,7,100}},{100,{3,7,103}},{100,{3,7,106}},{100,{3,7,109}},{100,{3,7,112}},{100,{3,48,160}},{100,{3,48,166}},{100,{3,48,171}},{100,{3,48,176}},{100,{3,48,182}},{100,{3,48,187}},{100,{3,15,160}},{100,{3,15,166}},{100,{3,15,171}},{100,{3,15,176}},{100,{3,15,182}},{100,{3,15,187}}]',0,'[]'),(16040141,1,4,1,500020,'[{100,{3,1,840}},{100,{3,15,560}},{100,{3,7,336}}]',0,'[]',0,'[]',3,'[{100,{3,1,720}},{100,{3,1,744}},{100,{3,1,768}},{100,{3,1,792}},{100,{3,1,816}},{100,{3,1,840}},{100,{3,5,288}},{100,{3,5,298}},{100,{3,5,308}},{100,{3,5,317}},{100,{3,5,327}},{100,{3,5,336}},{100,{3,7,288}},{100,{3,7,298}},{100,{3,7,308}},{100,{3,7,317}},{100,{3,7,327}},{100,{3,7,336}},{100,{3,48,480}},{100,{3,48,496}},{100,{3,48,512}},{100,{3,48,528}},{100,{3,48,544}},{100,{3,48,560}},{100,{3,15,480}},{100,{3,15,496}},{100,{3,15,512}},{100,{3,15,528}},{100,{3,15,544}},{100,{3,15,560}}]',0,'[]'),(16040142,1,4,2,600025,'[{100,{3,1,840}},{100,{3,15,560}},{100,{4,7,480}}]',0,'[]',0,'[]',2,'[{100,{3,1,720}},{100,{3,1,744}},{100,{3,1,768}},{100,{3,1,792}},{100,{3,1,816}},{100,{3,1,840}},{100,{3,5,288}},{100,{3,5,298}},{100,{3,5,308}},{100,{3,5,317}},{100,{3,5,327}},{100,{3,5,336}},{100,{3,7,288}},{100,{3,7,298}},{100,{3,7,308}},{100,{3,7,317}},{100,{3,7,327}},{100,{3,7,336}},{100,{3,48,480}},{100,{3,48,496}},{100,{3,48,512}},{100,{3,48,528}},{100,{3,48,544}},{100,{3,48,560}},{100,{3,15,480}},{100,{3,15,496}},{100,{3,15,512}},{100,{3,15,528}},{100,{3,15,544}},{100,{3,15,560}}]',1,'[{100,{4,1,1200}},{100,{4,15,800}},{100,{4,7,480}}]'),(16040143,1,4,3,750030,'[{100,{3,1,840}},{100,{3,15,560}},{100,{4,7,480}}]',0,'[]',0,'[]',2,'[{100,{3,1,720}},{100,{3,1,744}},{100,{3,1,768}},{100,{3,1,792}},{100,{3,1,816}},{100,{3,1,840}},{100,{3,5,288}},{100,{3,5,298}},{100,{3,5,308}},{100,{3,5,317}},{100,{3,5,327}},{100,{3,5,336}},{100,{3,7,288}},{100,{3,7,298}},{100,{3,7,308}},{100,{3,7,317}},{100,{3,7,327}},{100,{3,7,336}},{100,{3,48,480}},{100,{3,48,496}},{100,{3,48,512}},{100,{3,48,528}},{100,{3,48,544}},{100,{3,48,560}},{100,{3,15,480}},{100,{3,15,496}},{100,{3,15,512}},{100,{3,15,528}},{100,{3,15,544}},{100,{3,15,560}}]',1,'[{100,{4,1,1200}},{100,{4,15,800}},{100,{4,7,480}}]'),(16040144,1,4,4,900035,'[{100,{3,1,840}},{100,{4,15,800}},{100,{4,7,480}}]',0,'[]',0,'[]',1,'[{100,{3,1,720}},{100,{3,1,744}},{100,{3,1,768}},{100,{3,1,792}},{100,{3,1,816}},{100,{3,1,840}},{100,{3,5,288}},{100,{3,5,298}},{100,{3,5,308}},{100,{3,5,317}},{100,{3,5,327}},{100,{3,5,336}},{100,{3,7,288}},{100,{3,7,298}},{100,{3,7,308}},{100,{3,7,317}},{100,{3,7,327}},{100,{3,7,336}},{100,{3,48,480}},{100,{3,48,496}},{100,{3,48,512}},{100,{3,48,528}},{100,{3,48,544}},{100,{3,48,560}},{100,{3,15,480}},{100,{3,15,496}},{100,{3,15,512}},{100,{3,15,528}},{100,{3,15,544}},{100,{3,15,560}}]',2,'[{100,{4,1,1200}},{100,{4,15,800}},{100,{4,7,480}}]'),(16040145,1,4,5,1100020,'[{100,{3,1,840}},{100,{4,15,800}},{100,{4,7,480}}]',0,'[]',0,'[]',1,'[{100,{3,1,720}},{100,{3,1,744}},{100,{3,1,768}},{100,{3,1,792}},{100,{3,1,816}},{100,{3,1,840}},{100,{3,5,288}},{100,{3,5,298}},{100,{3,5,308}},{100,{3,5,317}},{100,{3,5,327}},{100,{3,5,336}},{100,{3,7,288}},{100,{3,7,298}},{100,{3,7,308}},{100,{3,7,317}},{100,{3,7,327}},{100,{3,7,336}},{100,{3,48,480}},{100,{3,48,496}},{100,{3,48,512}},{100,{3,48,528}},{100,{3,48,544}},{100,{3,48,560}},{100,{3,15,480}},{100,{3,15,496}},{100,{3,15,512}},{100,{3,15,528}},{100,{3,15,544}},{100,{3,15,560}}]',2,'[{100,{4,1,1200}},{100,{4,15,800}},{100,{4,7,480}}]'),(16040151,1,5,1,550020,'[{100,{3,1,1400}},{100,{4,15,1333}},{100,{4,7,800}}]',0,'[]',0,'[]',1,'[{100,{3,1,1200}},{100,{3,1,1240}},{100,{3,1,1280}},{100,{3,1,1320}},{100,{3,1,1360}},{100,{3,1,1400}},{100,{3,5,480}},{100,{3,5,496}},{100,{3,5,512}},{100,{3,5,528}},{100,{3,5,544}},{100,{3,5,560}},{100,{3,7,480}},{100,{3,7,496}},{100,{3,7,512}},{100,{3,7,528}},{100,{3,7,544}},{100,{3,7,560}},{100,{3,48,800}},{100,{3,48,827}},{100,{3,48,854}},{100,{3,48,880}},{100,{3,48,907}},{100,{3,48,934}},{100,{3,15,800}},{100,{3,15,827}},{100,{3,15,854}},{100,{3,15,880}},{100,{3,15,907}},{100,{3,15,934}}]',2,'[{100,{4,1,2000}},{100,{4,15,1333}},{100,{4,7,800}}]'),(16040152,1,5,2,650025,'[{100,{3,1,1400}},{100,{4,15,1333}},{100,{4,7,800}}]',0,'[]',0,'[]',1,'[{100,{3,1,1200}},{100,{3,1,1240}},{100,{3,1,1280}},{100,{3,1,1320}},{100,{3,1,1360}},{100,{3,1,1400}},{100,{3,5,480}},{100,{3,5,496}},{100,{3,5,512}},{100,{3,5,528}},{100,{3,5,544}},{100,{3,5,560}},{100,{3,7,480}},{100,{3,7,496}},{100,{3,7,512}},{100,{3,7,528}},{100,{3,7,544}},{100,{3,7,560}},{100,{3,48,800}},{100,{3,48,827}},{100,{3,48,854}},{100,{3,48,880}},{100,{3,48,907}},{100,{3,48,934}},{100,{3,15,800}},{100,{3,15,827}},{100,{3,15,854}},{100,{3,15,880}},{100,{3,15,907}},{100,{3,15,934}}]',2,'[{100,{4,1,2000}},{100,{4,15,1333}},{100,{4,7,800}}]'),(16040153,1,5,3,800030,'[{100,{3,1,1400}},{100,{4,15,1333}},{100,{4,7,800}}]',0,'[]',0,'[]',1,'[{100,{3,1,1200}},{100,{3,1,1240}},{100,{3,1,1280}},{100,{3,1,1320}},{100,{3,1,1360}},{100,{3,1,1400}},{100,{3,5,480}},{100,{3,5,496}},{100,{3,5,512}},{100,{3,5,528}},{100,{3,5,544}},{100,{3,5,560}},{100,{3,7,480}},{100,{3,7,496}},{100,{3,7,512}},{100,{3,7,528}},{100,{3,7,544}},{100,{3,7,560}},{100,{3,48,800}},{100,{3,48,827}},{100,{3,48,854}},{100,{3,48,880}},{100,{3,48,907}},{100,{3,48,934}},{100,{3,15,800}},{100,{3,15,827}},{100,{3,15,854}},{100,{3,15,880}},{100,{3,15,907}},{100,{3,15,934}}]',2,'[{100,{4,1,2000}},{100,{4,15,1333}},{100,{4,7,800}}]'),(16040154,1,5,4,900035,'[{100,{4,1,2000}},{100,{4,15,1333}},{100,{4,7,800}}]',0,'[]',0,'[]',0,'[]',3,'[{100,{4,1,2000}},{100,{4,15,1333}},{100,{4,7,800}}]'),(16040155,1,5,5,1200025,'[{100,{4,1,2000}},{100,{4,15,1333}},{100,{4,7,800}}]',0,'[]',0,'[]',0,'[]',3,'[{100,{4,1,2000}},{100,{4,15,1333}},{100,{4,7,800}}]'),(16040201,2,0,1,10004,'[]',0,'[]',0,'[]',0,'[]',0,'[]'),(16040202,2,0,2,15018,'[]',0,'[]',0,'[]',0,'[]',0,'[]'),(16040203,2,0,3,20007,'[]',0,'[]',0,'[]',0,'[]',0,'[]'),(16040204,2,0,4,25021,'[]',0,'[]',0,'[]',0,'[]',0,'[]'),(16040205,2,0,5,30010,'[]',0,'[]',0,'[]',0,'[]',0,'[]'),(16040211,2,1,1,27017,'[{100,{1,2,560}}]',1,'[{100,{1,2,280}},{100,{1,2,336}},{100,{1,2,392}},{100,{1,2,448}},{100,{1,2,504}},{100,{1,2,560}},{100,{1,6,6}},{100,{1,6,7}},{100,{1,6,8}},{100,{1,6,9}},{100,{1,6,11}},{100,{1,6,12}},{100,{1,8,6}},{100,{1,8,7}},{100,{1,8,8}},{100,{1,8,9}},{100,{1,8,11}},{100,{1,8,12}},{100,{1,49,10}},{100,{1,49,12}},{100,{1,49,14}},{100,{1,49,15}},{100,{1,49,17}},{100,{1,49,19}},{100,{1,16,10}},{100,{1,16,12}},{100,{1,16,14}},{100,{1,16,15}},{100,{1,16,17}},{100,{1,16,19}}]',0,'[]',0,'[]',0,'[]'),(16040212,2,1,2,40512,'[{100,{1,2,560}}]',1,'[{100,{1,2,280}},{100,{1,2,336}},{100,{1,2,392}},{100,{1,2,448}},{100,{1,2,504}},{100,{1,2,560}},{100,{1,6,6}},{100,{1,6,7}},{100,{1,6,8}},{100,{1,6,9}},{100,{1,6,11}},{100,{1,6,12}},{100,{1,8,6}},{100,{1,8,7}},{100,{1,8,8}},{100,{1,8,9}},{100,{1,8,11}},{100,{1,8,12}},{100,{1,49,10}},{100,{1,49,12}},{100,{1,49,14}},{100,{1,49,15}},{100,{1,49,17}},{100,{1,49,19}},{100,{1,16,10}},{100,{1,16,12}},{100,{1,16,14}},{100,{1,16,15}},{100,{1,16,17}},{100,{1,16,19}}]',0,'[]',0,'[]',0,'[]'),(16040213,2,1,3,54008,'[{100,{1,2,560}},{100,{1,16,19}}]',2,'[{100,{1,2,280}},{100,{1,2,336}},{100,{1,2,392}},{100,{1,2,448}},{100,{1,2,504}},{100,{1,2,560}},{100,{1,6,6}},{100,{1,6,7}},{100,{1,6,8}},{100,{1,6,9}},{100,{1,6,11}},{100,{1,6,12}},{100,{1,8,6}},{100,{1,8,7}},{100,{1,8,8}},{100,{1,8,9}},{100,{1,8,11}},{100,{1,8,12}},{100,{1,49,10}},{100,{1,49,12}},{100,{1,49,14}},{100,{1,49,15}},{100,{1,49,17}},{100,{1,49,19}},{100,{1,16,10}},{100,{1,16,12}},{100,{1,16,14}},{100,{1,16,15}},{100,{1,16,17}},{100,{1,16,19}}]',0,'[]',0,'[]',0,'[]'),(16040214,2,1,4,67504,'[{100,{1,2,560}},{100,{1,16,19}}]',2,'[{100,{1,2,280}},{100,{1,2,336}},{100,{1,2,392}},{100,{1,2,448}},{100,{1,2,504}},{100,{1,2,560}},{100,{1,6,6}},{100,{1,6,7}},{100,{1,6,8}},{100,{1,6,9}},{100,{1,6,11}},{100,{1,6,12}},{100,{1,8,6}},{100,{1,8,7}},{100,{1,8,8}},{100,{1,8,9}},{100,{1,8,11}},{100,{1,8,12}},{100,{1,49,10}},{100,{1,49,12}},{100,{1,49,14}},{100,{1,49,15}},{100,{1,49,17}},{100,{1,49,19}},{100,{1,16,10}},{100,{1,16,12}},{100,{1,16,14}},{100,{1,16,15}},{100,{1,16,17}},{100,{1,16,19}}]',0,'[]',0,'[]',0,'[]'),(16040215,2,1,5,81024,'[{100,{1,2,560}},{100,{1,16,19}}]',2,'[{100,{1,2,280}},{100,{1,2,336}},{100,{1,2,392}},{100,{1,2,448}},{100,{1,2,504}},{100,{1,2,560}},{100,{1,6,6}},{100,{1,6,7}},{100,{1,6,8}},{100,{1,6,9}},{100,{1,6,11}},{100,{1,6,12}},{100,{1,8,6}},{100,{1,8,7}},{100,{1,8,8}},{100,{1,8,9}},{100,{1,8,11}},{100,{1,8,12}},{100,{1,49,10}},{100,{1,49,12}},{100,{1,49,14}},{100,{1,49,15}},{100,{1,49,17}},{100,{1,49,19}},{100,{1,16,10}},{100,{1,16,12}},{100,{1,16,14}},{100,{1,16,15}},{100,{1,16,17}},{100,{1,16,19}}]',0,'[]',0,'[]',0,'[]'),(16040221,2,2,1,70023,'[{100,{1,2,800}},{100,{2,16,67}}]',1,'[{100,{1,2,400}},{100,{1,2,480}},{100,{1,2,560}},{100,{1,2,640}},{100,{1,2,720}},{100,{1,2,800}},{100,{1,6,8}},{100,{1,6,10}},{100,{1,6,12}},{100,{1,6,13}},{100,{1,6,15}},{100,{1,6,16}},{100,{1,8,8}},{100,{1,8,10}},{100,{1,8,12}},{100,{1,8,13}},{100,{1,8,15}},{100,{1,8,16}},{100,{1,49,14}},{100,{1,49,16}},{100,{1,49,19}},{100,{1,49,22}},{100,{1,49,24}},{100,{1,49,27}},{100,{1,16,14}},{100,{1,16,16}},{100,{1,16,19}},{100,{1,16,22}},{100,{1,16,24}},{100,{1,16,27}}]',1,'[{100,{2,2,1600}},{100,{2,2,1680}},{100,{2,2,1760}},{100,{2,2,1840}},{100,{2,2,1920}},{100,{2,2,2000}},{100,{2,6,32}},{100,{2,6,34}},{100,{2,6,36}},{100,{2,6,37}},{100,{2,6,39}},{100,{2,6,40}},{100,{2,8,32}},{100,{2,8,34}},{100,{2,8,36}},{100,{2,8,37}},{100,{2,8,39}},{100,{2,8,40}},{100,{2,49,54}},{100,{2,49,56}},{100,{2,49,59}},{100,{2,49,62}},{100,{2,49,64}},{100,{2,49,67}},{100,{2,16,54}},{100,{2,16,56}},{100,{2,16,59}},{100,{2,16,62}},{100,{2,16,64}},{100,{2,16,67}}]',0,'[]',0,'[]'),(16040222,2,2,2,105022,'[{100,{1,2,800}},{100,{2,16,67}}]',1,'[{100,{1,2,400}},{100,{1,2,480}},{100,{1,2,560}},{100,{1,2,640}},{100,{1,2,720}},{100,{1,2,800}},{100,{1,6,8}},{100,{1,6,10}},{100,{1,6,12}},{100,{1,6,13}},{100,{1,6,15}},{100,{1,6,16}},{100,{1,8,8}},{100,{1,8,10}},{100,{1,8,12}},{100,{1,8,13}},{100,{1,8,15}},{100,{1,8,16}},{100,{1,49,14}},{100,{1,49,16}},{100,{1,49,19}},{100,{1,49,22}},{100,{1,49,24}},{100,{1,49,27}},{100,{1,16,14}},{100,{1,16,16}},{100,{1,16,19}},{100,{1,16,22}},{100,{1,16,24}},{100,{1,16,27}}]',1,'[{100,{2,2,1600}},{100,{2,2,1680}},{100,{2,2,1760}},{100,{2,2,1840}},{100,{2,2,1920}},{100,{2,2,2000}},{100,{2,6,32}},{100,{2,6,34}},{100,{2,6,36}},{100,{2,6,37}},{100,{2,6,39}},{100,{2,6,40}},{100,{2,8,32}},{100,{2,8,34}},{100,{2,8,36}},{100,{2,8,37}},{100,{2,8,39}},{100,{2,8,40}},{100,{2,49,54}},{100,{2,49,56}},{100,{2,49,59}},{100,{2,49,62}},{100,{2,49,64}},{100,{2,49,67}},{100,{2,16,54}},{100,{2,16,56}},{100,{2,16,59}},{100,{2,16,62}},{100,{2,16,64}},{100,{2,16,67}}]',0,'[]',0,'[]'),(16040223,2,2,3,140021,'[{100,{2,2,2000}},{100,{2,16,67}}]',0,'[]',2,'[{100,{2,2,1600}},{100,{2,2,1680}},{100,{2,2,1760}},{100,{2,2,1840}},{100,{2,2,1920}},{100,{2,2,2000}},{100,{2,6,32}},{100,{2,6,34}},{100,{2,6,36}},{100,{2,6,37}},{100,{2,6,39}},{100,{2,6,40}},{100,{2,8,32}},{100,{2,8,34}},{100,{2,8,36}},{100,{2,8,37}},{100,{2,8,39}},{100,{2,8,40}},{100,{2,49,54}},{100,{2,49,56}},{100,{2,49,59}},{100,{2,49,62}},{100,{2,49,64}},{100,{2,49,67}},{100,{2,16,54}},{100,{2,16,56}},{100,{2,16,59}},{100,{2,16,62}},{100,{2,16,64}},{100,{2,16,67}}]',0,'[]',0,'[]'),(16040224,2,2,4,175020,'[{100,{2,2,2000}},{100,{2,16,67}}]',0,'[]',2,'[{100,{2,2,1600}},{100,{2,2,1680}},{100,{2,2,1760}},{100,{2,2,1840}},{100,{2,2,1920}},{100,{2,2,2000}},{100,{2,6,32}},{100,{2,6,34}},{100,{2,6,36}},{100,{2,6,37}},{100,{2,6,39}},{100,{2,6,40}},{100,{2,8,32}},{100,{2,8,34}},{100,{2,8,36}},{100,{2,8,37}},{100,{2,8,39}},{100,{2,8,40}},{100,{2,49,54}},{100,{2,49,56}},{100,{2,49,59}},{100,{2,49,62}},{100,{2,49,64}},{100,{2,49,67}},{100,{2,16,54}},{100,{2,16,56}},{100,{2,16,59}},{100,{2,16,62}},{100,{2,16,64}},{100,{2,16,67}}]',0,'[]',0,'[]'),(16040225,2,2,5,210019,'[{100,{2,2,2000}},{100,{2,16,67}}]',0,'[]',2,'[{100,{2,2,1600}},{100,{2,2,1680}},{100,{2,2,1760}},{100,{2,2,1840}},{100,{2,2,1920}},{100,{2,2,2000}},{100,{2,6,32}},{100,{2,6,34}},{100,{2,6,36}},{100,{2,6,37}},{100,{2,6,39}},{100,{2,6,40}},{100,{2,8,32}},{100,{2,8,34}},{100,{2,8,36}},{100,{2,8,37}},{100,{2,8,39}},{100,{2,8,40}},{100,{2,49,54}},{100,{2,49,56}},{100,{2,49,59}},{100,{2,49,62}},{100,{2,49,64}},{100,{2,49,67}},{100,{2,16,54}},{100,{2,16,56}},{100,{2,16,59}},{100,{2,16,62}},{100,{2,16,64}},{100,{2,16,67}}]',0,'[]',0,'[]'),(16040231,2,3,1,180009,'[{100,{2,2,4000}},{100,{3,16,187}}]',0,'[]',1,'[{100,{2,2,3200}},{100,{2,2,3360}},{100,{2,2,3520}},{100,{2,2,3680}},{100,{2,2,3840}},{100,{2,2,4000}},{100,{2,6,64}},{100,{2,6,68}},{100,{2,6,71}},{100,{2,6,74}},{100,{2,6,77}},{100,{2,6,80}},{100,{2,8,64}},{100,{2,8,68}},{100,{2,8,71}},{100,{2,8,74}},{100,{2,8,77}},{100,{2,8,80}},{100,{2,49,107}},{100,{2,49,112}},{100,{2,49,118}},{100,{2,49,123}},{100,{2,49,128}},{100,{2,49,134}},{100,{2,16,107}},{100,{2,16,112}},{100,{2,16,118}},{100,{2,16,123}},{100,{2,16,128}},{100,{2,16,134}}]',1,'[{100,{3,2,4800}},{100,{3,2,4960}},{100,{3,2,5120}},{100,{3,2,5280}},{100,{3,2,5440}},{100,{3,2,5600}},{100,{3,6,96}},{100,{3,6,100}},{100,{3,6,103}},{100,{3,6,106}},{100,{3,6,109}},{100,{3,6,112}},{100,{3,8,96}},{100,{3,8,100}},{100,{3,8,103}},{100,{3,8,106}},{100,{3,8,109}},{100,{3,8,112}},{100,{3,49,160}},{100,{3,49,166}},{100,{3,49,171}},{100,{3,49,176}},{100,{3,49,182}},{100,{3,49,187}},{100,{3,16,160}},{100,{3,16,166}},{100,{3,16,171}},{100,{3,16,176}},{100,{3,16,182}},{100,{3,16,187}}]',0,'[]'),(16040232,2,3,2,270014,'[{100,{2,2,4000}},{100,{3,16,187}}]',0,'[]',1,'[{100,{2,2,3200}},{100,{2,2,3360}},{100,{2,2,3520}},{100,{2,2,3680}},{100,{2,2,3840}},{100,{2,2,4000}},{100,{2,6,64}},{100,{2,6,68}},{100,{2,6,71}},{100,{2,6,74}},{100,{2,6,77}},{100,{2,6,80}},{100,{2,8,64}},{100,{2,8,68}},{100,{2,8,71}},{100,{2,8,74}},{100,{2,8,77}},{100,{2,8,80}},{100,{2,49,107}},{100,{2,49,112}},{100,{2,49,118}},{100,{2,49,123}},{100,{2,49,128}},{100,{2,49,134}},{100,{2,16,107}},{100,{2,16,112}},{100,{2,16,118}},{100,{2,16,123}},{100,{2,16,128}},{100,{2,16,134}}]',1,'[{100,{3,2,4800}},{100,{3,2,4960}},{100,{3,2,5120}},{100,{3,2,5280}},{100,{3,2,5440}},{100,{3,2,5600}},{100,{3,6,96}},{100,{3,6,100}},{100,{3,6,103}},{100,{3,6,106}},{100,{3,6,109}},{100,{3,6,112}},{100,{3,8,96}},{100,{3,8,100}},{100,{3,8,103}},{100,{3,8,106}},{100,{3,8,109}},{100,{3,8,112}},{100,{3,49,160}},{100,{3,49,166}},{100,{3,49,171}},{100,{3,49,176}},{100,{3,49,182}},{100,{3,49,187}},{100,{3,16,160}},{100,{3,16,166}},{100,{3,16,171}},{100,{3,16,176}},{100,{3,16,182}},{100,{3,16,187}}]',0,'[]'),(16040233,2,3,3,360018,'[{100,{3,2,5600}},{100,{3,16,187}}]',0,'[]',0,'[]',2,'[{100,{3,2,4800}},{100,{3,2,4960}},{100,{3,2,5120}},{100,{3,2,5280}},{100,{3,2,5440}},{100,{3,2,5600}},{100,{3,6,96}},{100,{3,6,100}},{100,{3,6,103}},{100,{3,6,106}},{100,{3,6,109}},{100,{3,6,112}},{100,{3,8,96}},{100,{3,8,100}},{100,{3,8,103}},{100,{3,8,106}},{100,{3,8,109}},{100,{3,8,112}},{100,{3,49,160}},{100,{3,49,166}},{100,{3,49,171}},{100,{3,49,176}},{100,{3,49,182}},{100,{3,49,187}},{100,{3,16,160}},{100,{3,16,166}},{100,{3,16,171}},{100,{3,16,176}},{100,{3,16,182}},{100,{3,16,187}}]',0,'[]'),(16040234,2,3,4,450022,'[{100,{3,2,5600}},{100,{3,16,187}},{100,{2,8,80}}]',0,'[]',1,'[{100,{2,2,3200}},{100,{2,2,3360}},{100,{2,2,3520}},{100,{2,2,3680}},{100,{2,2,3840}},{100,{2,2,4000}},{100,{2,6,64}},{100,{2,6,68}},{100,{2,6,71}},{100,{2,6,74}},{100,{2,6,77}},{100,{2,6,80}},{100,{2,8,64}},{100,{2,8,68}},{100,{2,8,71}},{100,{2,8,74}},{100,{2,8,77}},{100,{2,8,80}},{100,{2,49,107}},{100,{2,49,112}},{100,{2,49,118}},{100,{2,49,123}},{100,{2,49,128}},{100,{2,49,134}},{100,{2,16,107}},{100,{2,16,112}},{100,{2,16,118}},{100,{2,16,123}},{100,{2,16,128}},{100,{2,16,134}}]',2,'[{100,{3,2,4800}},{100,{3,2,4960}},{100,{3,2,5120}},{100,{3,2,5280}},{100,{3,2,5440}},{100,{3,2,5600}},{100,{3,6,96}},{100,{3,6,100}},{100,{3,6,103}},{100,{3,6,106}},{100,{3,6,109}},{100,{3,6,112}},{100,{3,8,96}},{100,{3,8,100}},{100,{3,8,103}},{100,{3,8,106}},{100,{3,8,109}},{100,{3,8,112}},{100,{3,49,160}},{100,{3,49,166}},{100,{3,49,171}},{100,{3,49,176}},{100,{3,49,182}},{100,{3,49,187}},{100,{3,16,160}},{100,{3,16,166}},{100,{3,16,171}},{100,{3,16,176}},{100,{3,16,182}},{100,{3,16,187}}]',0,'[]'),(16040235,2,3,5,540002,'[{100,{3,2,5600}},{100,{3,16,187}},{100,{3,8,112}}]',0,'[]',0,'[]',3,'[{100,{3,2,4800}},{100,{3,2,4960}},{100,{3,2,5120}},{100,{3,2,5280}},{100,{3,2,5440}},{100,{3,2,5600}},{100,{3,6,96}},{100,{3,6,100}},{100,{3,6,103}},{100,{3,6,106}},{100,{3,6,109}},{100,{3,6,112}},{100,{3,8,96}},{100,{3,8,100}},{100,{3,8,103}},{100,{3,8,106}},{100,{3,8,109}},{100,{3,8,112}},{100,{3,49,160}},{100,{3,49,166}},{100,{3,49,171}},{100,{3,49,176}},{100,{3,49,182}},{100,{3,49,187}},{100,{3,16,160}},{100,{3,16,166}},{100,{3,16,171}},{100,{3,16,176}},{100,{3,16,182}},{100,{3,16,187}}]',0,'[]'),(16040241,2,4,1,500013,'[{100,{3,2,16800}},{100,{3,16,560}},{100,{3,8,336}}]',0,'[]',0,'[]',3,'[{100,{3,2,14400}},{100,{3,2,14880}},{100,{3,2,15360}},{100,{3,2,15840}},{100,{3,2,16320}},{100,{3,2,16800}},{100,{3,6,288}},{100,{3,6,298}},{100,{3,6,308}},{100,{3,6,317}},{100,{3,6,327}},{100,{3,6,336}},{100,{3,8,288}},{100,{3,8,298}},{100,{3,8,308}},{100,{3,8,317}},{100,{3,8,327}},{100,{3,8,336}},{100,{3,49,480}},{100,{3,49,496}},{100,{3,49,512}},{100,{3,49,528}},{100,{3,49,544}},{100,{3,49,560}},{100,{3,16,480}},{100,{3,16,496}},{100,{3,16,512}},{100,{3,16,528}},{100,{3,16,544}},{100,{3,16,560}}]',0,'[]'),(16040242,2,4,2,600021,'[{100,{3,2,16800}},{100,{3,16,560}},{100,{4,8,480}}]',0,'[]',0,'[]',2,'[{100,{3,2,14400}},{100,{3,2,14880}},{100,{3,2,15360}},{100,{3,2,15840}},{100,{3,2,16320}},{100,{3,2,16800}},{100,{3,6,288}},{100,{3,6,298}},{100,{3,6,308}},{100,{3,6,317}},{100,{3,6,327}},{100,{3,6,336}},{100,{3,8,288}},{100,{3,8,298}},{100,{3,8,308}},{100,{3,8,317}},{100,{3,8,327}},{100,{3,8,336}},{100,{3,49,480}},{100,{3,49,496}},{100,{3,49,512}},{100,{3,49,528}},{100,{3,49,544}},{100,{3,49,560}},{100,{3,16,480}},{100,{3,16,496}},{100,{3,16,512}},{100,{3,16,528}},{100,{3,16,544}},{100,{3,16,560}}]',1,'[{100,{4,2,24000}},{100,{4,16,800}},{100,{4,8,480}}]'),(16040243,2,4,3,750020,'[{100,{3,2,16800}},{100,{3,16,560}},{100,{4,8,480}}]',0,'[]',0,'[]',2,'[{100,{3,2,14400}},{100,{3,2,14880}},{100,{3,2,15360}},{100,{3,2,15840}},{100,{3,2,16320}},{100,{3,2,16800}},{100,{3,6,288}},{100,{3,6,298}},{100,{3,6,308}},{100,{3,6,317}},{100,{3,6,327}},{100,{3,6,336}},{100,{3,8,288}},{100,{3,8,298}},{100,{3,8,308}},{100,{3,8,317}},{100,{3,8,327}},{100,{3,8,336}},{100,{3,49,480}},{100,{3,49,496}},{100,{3,49,512}},{100,{3,49,528}},{100,{3,49,544}},{100,{3,49,560}},{100,{3,16,480}},{100,{3,16,496}},{100,{3,16,512}},{100,{3,16,528}},{100,{3,16,544}},{100,{3,16,560}}]',1,'[{100,{4,2,24000}},{100,{4,16,800}},{100,{4,8,480}}]'),(16040244,2,4,4,900019,'[{100,{3,2,16800}},{100,{4,16,800}},{100,{4,8,480}}]',0,'[]',0,'[]',1,'[{100,{3,2,14400}},{100,{3,2,14880}},{100,{3,2,15360}},{100,{3,2,15840}},{100,{3,2,16320}},{100,{3,2,16800}},{100,{3,6,288}},{100,{3,6,298}},{100,{3,6,308}},{100,{3,6,317}},{100,{3,6,327}},{100,{3,6,336}},{100,{3,8,288}},{100,{3,8,298}},{100,{3,8,308}},{100,{3,8,317}},{100,{3,8,327}},{100,{3,8,336}},{100,{3,49,480}},{100,{3,49,496}},{100,{3,49,512}},{100,{3,49,528}},{100,{3,49,544}},{100,{3,49,560}},{100,{3,16,480}},{100,{3,16,496}},{100,{3,16,512}},{100,{3,16,528}},{100,{3,16,544}},{100,{3,16,560}}]',2,'[{100,{4,2,24000}},{100,{4,16,800}},{100,{4,8,480}}]'),(16040245,2,4,5,1100009,'[{100,{3,2,16800}},{100,{4,16,800}},{100,{4,8,480}}]',0,'[]',0,'[]',1,'[{100,{3,2,14400}},{100,{3,2,14880}},{100,{3,2,15360}},{100,{3,2,15840}},{100,{3,2,16320}},{100,{3,2,16800}},{100,{3,6,288}},{100,{3,6,298}},{100,{3,6,308}},{100,{3,6,317}},{100,{3,6,327}},{100,{3,6,336}},{100,{3,8,288}},{100,{3,8,298}},{100,{3,8,308}},{100,{3,8,317}},{100,{3,8,327}},{100,{3,8,336}},{100,{3,49,480}},{100,{3,49,496}},{100,{3,49,512}},{100,{3,49,528}},{100,{3,49,544}},{100,{3,49,560}},{100,{3,16,480}},{100,{3,16,496}},{100,{3,16,512}},{100,{3,16,528}},{100,{3,16,544}},{100,{3,16,560}}]',2,'[{100,{4,2,24000}},{100,{4,16,800}},{100,{4,8,480}}]'),(16040251,2,5,1,550005,'[{100,{3,2,28000}},{100,{4,16,1333}},{100,{4,8,800}}]',0,'[]',0,'[]',1,'[{100,{3,2,24000}},{100,{3,2,24800}},{100,{3,2,25600}},{100,{3,2,26400}},{100,{3,2,27200}},{100,{3,2,28000}},{100,{3,6,480}},{100,{3,6,496}},{100,{3,6,512}},{100,{3,6,528}},{100,{3,6,544}},{100,{3,6,560}},{100,{3,8,480}},{100,{3,8,496}},{100,{3,8,512}},{100,{3,8,528}},{100,{3,8,544}},{100,{3,8,560}},{100,{3,49,800}},{100,{3,49,827}},{100,{3,49,854}},{100,{3,49,880}},{100,{3,49,907}},{100,{3,49,934}},{100,{3,16,800}},{100,{3,16,827}},{100,{3,16,854}},{100,{3,16,880}},{100,{3,16,907}},{100,{3,16,934}}]',2,'[{100,{4,2,40000}},{100,{4,16,1333}},{100,{4,8,800}}]'),(16040252,2,5,2,650012,'[{100,{3,2,28000}},{100,{4,16,1333}},{100,{4,8,800}}]',0,'[]',0,'[]',1,'[{100,{3,2,24000}},{100,{3,2,24800}},{100,{3,2,25600}},{100,{3,2,26400}},{100,{3,2,27200}},{100,{3,2,28000}},{100,{3,6,480}},{100,{3,6,496}},{100,{3,6,512}},{100,{3,6,528}},{100,{3,6,544}},{100,{3,6,560}},{100,{3,8,480}},{100,{3,8,496}},{100,{3,8,512}},{100,{3,8,528}},{100,{3,8,544}},{100,{3,8,560}},{100,{3,49,800}},{100,{3,49,827}},{100,{3,49,854}},{100,{3,49,880}},{100,{3,49,907}},{100,{3,49,934}},{100,{3,16,800}},{100,{3,16,827}},{100,{3,16,854}},{100,{3,16,880}},{100,{3,16,907}},{100,{3,16,934}}]',2,'[{100,{4,2,40000}},{100,{4,16,1333}},{100,{4,8,800}}]'),(16040253,2,5,3,800011,'[{100,{3,2,28000}},{100,{4,16,1333}},{100,{4,8,800}}]',0,'[]',0,'[]',1,'[{100,{3,2,24000}},{100,{3,2,24800}},{100,{3,2,25600}},{100,{3,2,26400}},{100,{3,2,27200}},{100,{3,2,28000}},{100,{3,6,480}},{100,{3,6,496}},{100,{3,6,512}},{100,{3,6,528}},{100,{3,6,544}},{100,{3,6,560}},{100,{3,8,480}},{100,{3,8,496}},{100,{3,8,512}},{100,{3,8,528}},{100,{3,8,544}},{100,{3,8,560}},{100,{3,49,800}},{100,{3,49,827}},{100,{3,49,854}},{100,{3,49,880}},{100,{3,49,907}},{100,{3,49,934}},{100,{3,16,800}},{100,{3,16,827}},{100,{3,16,854}},{100,{3,16,880}},{100,{3,16,907}},{100,{3,16,934}}]',2,'[{100,{4,2,40000}},{100,{4,16,1333}},{100,{4,8,800}}]'),(16040254,2,5,4,900019,'[{100,{4,2,40000}},{100,{4,16,1333}},{100,{4,8,800}}]',0,'[]',0,'[]',0,'[]',3,'[{100,{4,2,40000}},{100,{4,16,1333}},{100,{4,8,800}}]'),(16040255,2,5,5,1200017,'[{100,{4,2,40000}},{100,{4,16,1333}},{100,{4,8,800}}]',0,'[]',0,'[]',0,'[]',3,'[{100,{4,2,40000}},{100,{4,16,1333}},{100,{4,8,800}}]'),(16040301,3,0,1,10030,'[]',0,'[]',0,'[]',0,'[]',0,'[]'),(16040302,3,0,2,15020,'[]',0,'[]',0,'[]',0,'[]',0,'[]'),(16040303,3,0,3,20010,'[]',0,'[]',0,'[]',0,'[]',0,'[]'),(16040304,3,0,4,25050,'[]',0,'[]',0,'[]',0,'[]',0,'[]'),(16040305,3,0,5,30040,'[]',0,'[]',0,'[]',0,'[]',0,'[]'),(16040311,3,1,1,27050,'[{100,{1,1,28}}]',1,'[{100,{1,1,14}},{100,{1,1,17}},{100,{1,1,20}},{100,{1,1,23}},{100,{1,1,26}},{100,{1,1,28}},{100,{1,5,6}},{100,{1,5,7}},{100,{1,5,8}},{100,{1,5,9}},{100,{1,5,11}},{100,{1,5,12}},{100,{1,7,6}},{100,{1,7,7}},{100,{1,7,8}},{100,{1,7,9}},{100,{1,7,11}},{100,{1,7,12}},{100,{1,48,10}},{100,{1,48,12}},{100,{1,48,14}},{100,{1,48,15}},{100,{1,48,17}},{100,{1,48,19}},{100,{1,15,10}},{100,{1,15,12}},{100,{1,15,14}},{100,{1,15,15}},{100,{1,15,17}},{100,{1,15,19}}]',0,'[]',0,'[]',0,'[]'),(16040312,3,1,2,40550,'[{100,{1,1,28}}]',1,'[{100,{1,1,14}},{100,{1,1,17}},{100,{1,1,20}},{100,{1,1,23}},{100,{1,1,26}},{100,{1,1,28}},{100,{1,5,6}},{100,{1,5,7}},{100,{1,5,8}},{100,{1,5,9}},{100,{1,5,11}},{100,{1,5,12}},{100,{1,7,6}},{100,{1,7,7}},{100,{1,7,8}},{100,{1,7,9}},{100,{1,7,11}},{100,{1,7,12}},{100,{1,48,10}},{100,{1,48,12}},{100,{1,48,14}},{100,{1,48,15}},{100,{1,48,17}},{100,{1,48,19}},{100,{1,15,10}},{100,{1,15,12}},{100,{1,15,14}},{100,{1,15,15}},{100,{1,15,17}},{100,{1,15,19}}]',0,'[]',0,'[]',0,'[]'),(16040313,3,1,3,54050,'[{100,{1,1,28}},{100,{1,15,19}}]',2,'[{100,{1,1,14}},{100,{1,1,17}},{100,{1,1,20}},{100,{1,1,23}},{100,{1,1,26}},{100,{1,1,28}},{100,{1,5,6}},{100,{1,5,7}},{100,{1,5,8}},{100,{1,5,9}},{100,{1,5,11}},{100,{1,5,12}},{100,{1,7,6}},{100,{1,7,7}},{100,{1,7,8}},{100,{1,7,9}},{100,{1,7,11}},{100,{1,7,12}},{100,{1,48,10}},{100,{1,48,12}},{100,{1,48,14}},{100,{1,48,15}},{100,{1,48,17}},{100,{1,48,19}},{100,{1,15,10}},{100,{1,15,12}},{100,{1,15,14}},{100,{1,15,15}},{100,{1,15,17}},{100,{1,15,19}}]',0,'[]',0,'[]',0,'[]'),(16040314,3,1,4,67530,'[{100,{1,1,28}},{100,{1,15,19}}]',2,'[{100,{1,1,14}},{100,{1,1,17}},{100,{1,1,20}},{100,{1,1,23}},{100,{1,1,26}},{100,{1,1,28}},{100,{1,5,6}},{100,{1,5,7}},{100,{1,5,8}},{100,{1,5,9}},{100,{1,5,11}},{100,{1,5,12}},{100,{1,7,6}},{100,{1,7,7}},{100,{1,7,8}},{100,{1,7,9}},{100,{1,7,11}},{100,{1,7,12}},{100,{1,48,10}},{100,{1,48,12}},{100,{1,48,14}},{100,{1,48,15}},{100,{1,48,17}},{100,{1,48,19}},{100,{1,15,10}},{100,{1,15,12}},{100,{1,15,14}},{100,{1,15,15}},{100,{1,15,17}},{100,{1,15,19}}]',0,'[]',0,'[]',0,'[]'),(16040315,3,1,5,81030,'[{100,{1,1,28}},{100,{1,15,19}}]',2,'[{100,{1,1,14}},{100,{1,1,17}},{100,{1,1,20}},{100,{1,1,23}},{100,{1,1,26}},{100,{1,1,28}},{100,{1,5,6}},{100,{1,5,7}},{100,{1,5,8}},{100,{1,5,9}},{100,{1,5,11}},{100,{1,5,12}},{100,{1,7,6}},{100,{1,7,7}},{100,{1,7,8}},{100,{1,7,9}},{100,{1,7,11}},{100,{1,7,12}},{100,{1,48,10}},{100,{1,48,12}},{100,{1,48,14}},{100,{1,48,15}},{100,{1,48,17}},{100,{1,48,19}},{100,{1,15,10}},{100,{1,15,12}},{100,{1,15,14}},{100,{1,15,15}},{100,{1,15,17}},{100,{1,15,19}}]',0,'[]',0,'[]',0,'[]'),(16040321,3,2,1,70060,'[{100,{1,1,40}},{100,{2,15,67}}]',1,'[{100,{1,1,20}},{100,{1,1,24}},{100,{1,1,28}},{100,{1,1,32}},{100,{1,1,36}},{100,{1,1,40}},{100,{1,5,8}},{100,{1,5,10}},{100,{1,5,12}},{100,{1,5,13}},{100,{1,5,15}},{100,{1,5,16}},{100,{1,7,8}},{100,{1,7,10}},{100,{1,7,12}},{100,{1,7,13}},{100,{1,7,15}},{100,{1,7,16}},{100,{1,48,14}},{100,{1,48,16}},{100,{1,48,19}},{100,{1,48,22}},{100,{1,48,24}},{100,{1,48,27}},{100,{1,15,14}},{100,{1,15,16}},{100,{1,15,19}},{100,{1,15,22}},{100,{1,15,24}},{100,{1,15,27}}]',1,'[{100,{2,1,80}},{100,{2,1,84}},{100,{2,1,88}},{100,{2,1,92}},{100,{2,1,96}},{100,{2,1,100}},{100,{2,5,32}},{100,{2,5,34}},{100,{2,5,36}},{100,{2,5,37}},{100,{2,5,39}},{100,{2,5,40}},{100,{2,7,32}},{100,{2,7,34}},{100,{2,7,36}},{100,{2,7,37}},{100,{2,7,39}},{100,{2,7,40}},{100,{2,48,54}},{100,{2,48,56}},{100,{2,48,59}},{100,{2,48,62}},{100,{2,48,64}},{100,{2,48,67}},{100,{2,15,54}},{100,{2,15,56}},{100,{2,15,59}},{100,{2,15,62}},{100,{2,15,64}},{100,{2,15,67}}]',0,'[]',0,'[]'),(16040322,3,2,2,105040,'[{100,{1,1,40}},{100,{2,15,67}}]',1,'[{100,{1,1,20}},{100,{1,1,24}},{100,{1,1,28}},{100,{1,1,32}},{100,{1,1,36}},{100,{1,1,40}},{100,{1,5,8}},{100,{1,5,10}},{100,{1,5,12}},{100,{1,5,13}},{100,{1,5,15}},{100,{1,5,16}},{100,{1,7,8}},{100,{1,7,10}},{100,{1,7,12}},{100,{1,7,13}},{100,{1,7,15}},{100,{1,7,16}},{100,{1,48,14}},{100,{1,48,16}},{100,{1,48,19}},{100,{1,48,22}},{100,{1,48,24}},{100,{1,48,27}},{100,{1,15,14}},{100,{1,15,16}},{100,{1,15,19}},{100,{1,15,22}},{100,{1,15,24}},{100,{1,15,27}}]',1,'[{100,{2,1,80}},{100,{2,1,84}},{100,{2,1,88}},{100,{2,1,92}},{100,{2,1,96}},{100,{2,1,100}},{100,{2,5,32}},{100,{2,5,34}},{100,{2,5,36}},{100,{2,5,37}},{100,{2,5,39}},{100,{2,5,40}},{100,{2,7,32}},{100,{2,7,34}},{100,{2,7,36}},{100,{2,7,37}},{100,{2,7,39}},{100,{2,7,40}},{100,{2,48,54}},{100,{2,48,56}},{100,{2,48,59}},{100,{2,48,62}},{100,{2,48,64}},{100,{2,48,67}},{100,{2,15,54}},{100,{2,15,56}},{100,{2,15,59}},{100,{2,15,62}},{100,{2,15,64}},{100,{2,15,67}}]',0,'[]',0,'[]'),(16040323,3,2,3,140050,'[{100,{2,1,100}},{100,{2,15,67}}]',0,'[]',2,'[{100,{2,1,80}},{100,{2,1,84}},{100,{2,1,88}},{100,{2,1,92}},{100,{2,1,96}},{100,{2,1,100}},{100,{2,5,32}},{100,{2,5,34}},{100,{2,5,36}},{100,{2,5,37}},{100,{2,5,39}},{100,{2,5,40}},{100,{2,7,32}},{100,{2,7,34}},{100,{2,7,36}},{100,{2,7,37}},{100,{2,7,39}},{100,{2,7,40}},{100,{2,48,54}},{100,{2,48,56}},{100,{2,48,59}},{100,{2,48,62}},{100,{2,48,64}},{100,{2,48,67}},{100,{2,15,54}},{100,{2,15,56}},{100,{2,15,59}},{100,{2,15,62}},{100,{2,15,64}},{100,{2,15,67}}]',0,'[]',0,'[]'),(16040324,3,2,4,175030,'[{100,{2,1,100}},{100,{2,15,67}}]',0,'[]',2,'[{100,{2,1,80}},{100,{2,1,84}},{100,{2,1,88}},{100,{2,1,92}},{100,{2,1,96}},{100,{2,1,100}},{100,{2,5,32}},{100,{2,5,34}},{100,{2,5,36}},{100,{2,5,37}},{100,{2,5,39}},{100,{2,5,40}},{100,{2,7,32}},{100,{2,7,34}},{100,{2,7,36}},{100,{2,7,37}},{100,{2,7,39}},{100,{2,7,40}},{100,{2,48,54}},{100,{2,48,56}},{100,{2,48,59}},{100,{2,48,62}},{100,{2,48,64}},{100,{2,48,67}},{100,{2,15,54}},{100,{2,15,56}},{100,{2,15,59}},{100,{2,15,62}},{100,{2,15,64}},{100,{2,15,67}}]',0,'[]',0,'[]'),(16040325,3,2,5,210060,'[{100,{2,1,100}},{100,{2,15,67}}]',0,'[]',2,'[{100,{2,1,80}},{100,{2,1,84}},{100,{2,1,88}},{100,{2,1,92}},{100,{2,1,96}},{100,{2,1,100}},{100,{2,5,32}},{100,{2,5,34}},{100,{2,5,36}},{100,{2,5,37}},{100,{2,5,39}},{100,{2,5,40}},{100,{2,7,32}},{100,{2,7,34}},{100,{2,7,36}},{100,{2,7,37}},{100,{2,7,39}},{100,{2,7,40}},{100,{2,48,54}},{100,{2,48,56}},{100,{2,48,59}},{100,{2,48,62}},{100,{2,48,64}},{100,{2,48,67}},{100,{2,15,54}},{100,{2,15,56}},{100,{2,15,59}},{100,{2,15,62}},{100,{2,15,64}},{100,{2,15,67}}]',0,'[]',0,'[]'),(16040331,3,3,1,180020,'[{100,{2,1,200}},{100,{3,15,187}}]',0,'[]',1,'[{100,{2,1,160}},{100,{2,1,168}},{100,{2,1,176}},{100,{2,1,184}},{100,{2,1,192}},{100,{2,1,200}},{100,{2,5,64}},{100,{2,5,68}},{100,{2,5,71}},{100,{2,5,74}},{100,{2,5,77}},{100,{2,5,80}},{100,{2,7,64}},{100,{2,7,68}},{100,{2,7,71}},{100,{2,7,74}},{100,{2,7,77}},{100,{2,7,80}},{100,{2,48,107}},{100,{2,48,112}},{100,{2,48,118}},{100,{2,48,123}},{100,{2,48,128}},{100,{2,48,134}},{100,{2,15,107}},{100,{2,15,112}},{100,{2,15,118}},{100,{2,15,123}},{100,{2,15,128}},{100,{2,15,134}}]',1,'[{100,{3,1,240}},{100,{3,1,248}},{100,{3,1,256}},{100,{3,1,264}},{100,{3,1,272}},{100,{3,1,280}},{100,{3,5,96}},{100,{3,5,100}},{100,{3,5,103}},{100,{3,5,106}},{100,{3,5,109}},{100,{3,5,112}},{100,{3,7,96}},{100,{3,7,100}},{100,{3,7,103}},{100,{3,7,106}},{100,{3,7,109}},{100,{3,7,112}},{100,{3,48,160}},{100,{3,48,166}},{100,{3,48,171}},{100,{3,48,176}},{100,{3,48,182}},{100,{3,48,187}},{100,{3,15,160}},{100,{3,15,166}},{100,{3,15,171}},{100,{3,15,176}},{100,{3,15,182}},{100,{3,15,187}}]',0,'[]'),(16040332,3,3,2,270020,'[{100,{2,1,200}},{100,{3,15,187}}]',0,'[]',1,'[{100,{2,1,160}},{100,{2,1,168}},{100,{2,1,176}},{100,{2,1,184}},{100,{2,1,192}},{100,{2,1,200}},{100,{2,5,64}},{100,{2,5,68}},{100,{2,5,71}},{100,{2,5,74}},{100,{2,5,77}},{100,{2,5,80}},{100,{2,7,64}},{100,{2,7,68}},{100,{2,7,71}},{100,{2,7,74}},{100,{2,7,77}},{100,{2,7,80}},{100,{2,48,107}},{100,{2,48,112}},{100,{2,48,118}},{100,{2,48,123}},{100,{2,48,128}},{100,{2,48,134}},{100,{2,15,107}},{100,{2,15,112}},{100,{2,15,118}},{100,{2,15,123}},{100,{2,15,128}},{100,{2,15,134}}]',1,'[{100,{3,1,240}},{100,{3,1,248}},{100,{3,1,256}},{100,{3,1,264}},{100,{3,1,272}},{100,{3,1,280}},{100,{3,5,96}},{100,{3,5,100}},{100,{3,5,103}},{100,{3,5,106}},{100,{3,5,109}},{100,{3,5,112}},{100,{3,7,96}},{100,{3,7,100}},{100,{3,7,103}},{100,{3,7,106}},{100,{3,7,109}},{100,{3,7,112}},{100,{3,48,160}},{100,{3,48,166}},{100,{3,48,171}},{100,{3,48,176}},{100,{3,48,182}},{100,{3,48,187}},{100,{3,15,160}},{100,{3,15,166}},{100,{3,15,171}},{100,{3,15,176}},{100,{3,15,182}},{100,{3,15,187}}]',0,'[]'),(16040333,3,3,3,360020,'[{100,{3,1,280}},{100,{3,15,187}}]',0,'[]',0,'[]',2,'[{100,{3,1,240}},{100,{3,1,248}},{100,{3,1,256}},{100,{3,1,264}},{100,{3,1,272}},{100,{3,1,280}},{100,{3,5,96}},{100,{3,5,100}},{100,{3,5,103}},{100,{3,5,106}},{100,{3,5,109}},{100,{3,5,112}},{100,{3,7,96}},{100,{3,7,100}},{100,{3,7,103}},{100,{3,7,106}},{100,{3,7,109}},{100,{3,7,112}},{100,{3,48,160}},{100,{3,48,166}},{100,{3,48,171}},{100,{3,48,176}},{100,{3,48,182}},{100,{3,48,187}},{100,{3,15,160}},{100,{3,15,166}},{100,{3,15,171}},{100,{3,15,176}},{100,{3,15,182}},{100,{3,15,187}}]',0,'[]'),(16040334,3,3,4,450040,'[{100,{3,1,280}},{100,{3,15,187}},{100,{2,7,80}}]',0,'[]',1,'[{100,{2,1,160}},{100,{2,1,168}},{100,{2,1,176}},{100,{2,1,184}},{100,{2,1,192}},{100,{2,1,200}},{100,{2,5,64}},{100,{2,5,68}},{100,{2,5,71}},{100,{2,5,74}},{100,{2,5,77}},{100,{2,5,80}},{100,{2,7,64}},{100,{2,7,68}},{100,{2,7,71}},{100,{2,7,74}},{100,{2,7,77}},{100,{2,7,80}},{100,{2,48,107}},{100,{2,48,112}},{100,{2,48,118}},{100,{2,48,123}},{100,{2,48,128}},{100,{2,48,134}},{100,{2,15,107}},{100,{2,15,112}},{100,{2,15,118}},{100,{2,15,123}},{100,{2,15,128}},{100,{2,15,134}}]',2,'[{100,{3,1,240}},{100,{3,1,248}},{100,{3,1,256}},{100,{3,1,264}},{100,{3,1,272}},{100,{3,1,280}},{100,{3,5,96}},{100,{3,5,100}},{100,{3,5,103}},{100,{3,5,106}},{100,{3,5,109}},{100,{3,5,112}},{100,{3,7,96}},{100,{3,7,100}},{100,{3,7,103}},{100,{3,7,106}},{100,{3,7,109}},{100,{3,7,112}},{100,{3,48,160}},{100,{3,48,166}},{100,{3,48,171}},{100,{3,48,176}},{100,{3,48,182}},{100,{3,48,187}},{100,{3,15,160}},{100,{3,15,166}},{100,{3,15,171}},{100,{3,15,176}},{100,{3,15,182}},{100,{3,15,187}}]',0,'[]'),(16040335,3,3,5,540040,'[{100,{3,1,280}},{100,{3,15,187}},{100,{3,7,112}}]',0,'[]',0,'[]',3,'[{100,{3,1,240}},{100,{3,1,248}},{100,{3,1,256}},{100,{3,1,264}},{100,{3,1,272}},{100,{3,1,280}},{100,{3,5,96}},{100,{3,5,100}},{100,{3,5,103}},{100,{3,5,106}},{100,{3,5,109}},{100,{3,5,112}},{100,{3,7,96}},{100,{3,7,100}},{100,{3,7,103}},{100,{3,7,106}},{100,{3,7,109}},{100,{3,7,112}},{100,{3,48,160}},{100,{3,48,166}},{100,{3,48,171}},{100,{3,48,176}},{100,{3,48,182}},{100,{3,48,187}},{100,{3,15,160}},{100,{3,15,166}},{100,{3,15,171}},{100,{3,15,176}},{100,{3,15,182}},{100,{3,15,187}}]',0,'[]'),(16040341,3,4,1,500020,'[{100,{3,1,840}},{100,{3,15,560}},{100,{3,7,336}}]',0,'[]',0,'[]',3,'[{100,{3,1,720}},{100,{3,1,744}},{100,{3,1,768}},{100,{3,1,792}},{100,{3,1,816}},{100,{3,1,840}},{100,{3,5,288}},{100,{3,5,298}},{100,{3,5,308}},{100,{3,5,317}},{100,{3,5,327}},{100,{3,5,336}},{100,{3,7,288}},{100,{3,7,298}},{100,{3,7,308}},{100,{3,7,317}},{100,{3,7,327}},{100,{3,7,336}},{100,{3,48,480}},{100,{3,48,496}},{100,{3,48,512}},{100,{3,48,528}},{100,{3,48,544}},{100,{3,48,560}},{100,{3,15,480}},{100,{3,15,496}},{100,{3,15,512}},{100,{3,15,528}},{100,{3,15,544}},{100,{3,15,560}}]',0,'[]'),(16040342,3,4,2,600050,'[{100,{3,1,840}},{100,{3,15,560}},{100,{4,7,480}}]',0,'[]',0,'[]',2,'[{100,{3,1,720}},{100,{3,1,744}},{100,{3,1,768}},{100,{3,1,792}},{100,{3,1,816}},{100,{3,1,840}},{100,{3,5,288}},{100,{3,5,298}},{100,{3,5,308}},{100,{3,5,317}},{100,{3,5,327}},{100,{3,5,336}},{100,{3,7,288}},{100,{3,7,298}},{100,{3,7,308}},{100,{3,7,317}},{100,{3,7,327}},{100,{3,7,336}},{100,{3,48,480}},{100,{3,48,496}},{100,{3,48,512}},{100,{3,48,528}},{100,{3,48,544}},{100,{3,48,560}},{100,{3,15,480}},{100,{3,15,496}},{100,{3,15,512}},{100,{3,15,528}},{100,{3,15,544}},{100,{3,15,560}}]',1,'[{100,{4,1,1200}},{100,{4,15,800}},{100,{4,7,480}}]'),(16040343,3,4,3,750030,'[{100,{3,1,840}},{100,{3,15,560}},{100,{4,7,480}}]',0,'[]',0,'[]',2,'[{100,{3,1,720}},{100,{3,1,744}},{100,{3,1,768}},{100,{3,1,792}},{100,{3,1,816}},{100,{3,1,840}},{100,{3,5,288}},{100,{3,5,298}},{100,{3,5,308}},{100,{3,5,317}},{100,{3,5,327}},{100,{3,5,336}},{100,{3,7,288}},{100,{3,7,298}},{100,{3,7,308}},{100,{3,7,317}},{100,{3,7,327}},{100,{3,7,336}},{100,{3,48,480}},{100,{3,48,496}},{100,{3,48,512}},{100,{3,48,528}},{100,{3,48,544}},{100,{3,48,560}},{100,{3,15,480}},{100,{3,15,496}},{100,{3,15,512}},{100,{3,15,528}},{100,{3,15,544}},{100,{3,15,560}}]',1,'[{100,{4,1,1200}},{100,{4,15,800}},{100,{4,7,480}}]'),(16040344,3,4,4,900060,'[{100,{3,1,840}},{100,{4,15,800}},{100,{4,7,480}}]',0,'[]',0,'[]',1,'[{100,{3,1,720}},{100,{3,1,744}},{100,{3,1,768}},{100,{3,1,792}},{100,{3,1,816}},{100,{3,1,840}},{100,{3,5,288}},{100,{3,5,298}},{100,{3,5,308}},{100,{3,5,317}},{100,{3,5,327}},{100,{3,5,336}},{100,{3,7,288}},{100,{3,7,298}},{100,{3,7,308}},{100,{3,7,317}},{100,{3,7,327}},{100,{3,7,336}},{100,{3,48,480}},{100,{3,48,496}},{100,{3,48,512}},{100,{3,48,528}},{100,{3,48,544}},{100,{3,48,560}},{100,{3,15,480}},{100,{3,15,496}},{100,{3,15,512}},{100,{3,15,528}},{100,{3,15,544}},{100,{3,15,560}}]',2,'[{100,{4,1,1200}},{100,{4,15,800}},{100,{4,7,480}}]'),(16040345,3,4,5,1100020,'[{100,{3,1,840}},{100,{4,15,800}},{100,{4,7,480}}]',0,'[]',0,'[]',1,'[{100,{3,1,720}},{100,{3,1,744}},{100,{3,1,768}},{100,{3,1,792}},{100,{3,1,816}},{100,{3,1,840}},{100,{3,5,288}},{100,{3,5,298}},{100,{3,5,308}},{100,{3,5,317}},{100,{3,5,327}},{100,{3,5,336}},{100,{3,7,288}},{100,{3,7,298}},{100,{3,7,308}},{100,{3,7,317}},{100,{3,7,327}},{100,{3,7,336}},{100,{3,48,480}},{100,{3,48,496}},{100,{3,48,512}},{100,{3,48,528}},{100,{3,48,544}},{100,{3,48,560}},{100,{3,15,480}},{100,{3,15,496}},{100,{3,15,512}},{100,{3,15,528}},{100,{3,15,544}},{100,{3,15,560}}]',2,'[{100,{4,1,1200}},{100,{4,15,800}},{100,{4,7,480}}]'),(16040351,3,5,1,550020,'[{100,{3,1,1400}},{100,{4,15,1333}},{100,{4,7,800}}]',0,'[]',0,'[]',1,'[{100,{3,1,1200}},{100,{3,1,1240}},{100,{3,1,1280}},{100,{3,1,1320}},{100,{3,1,1360}},{100,{3,1,1400}},{100,{3,5,480}},{100,{3,5,496}},{100,{3,5,512}},{100,{3,5,528}},{100,{3,5,544}},{100,{3,5,560}},{100,{3,7,480}},{100,{3,7,496}},{100,{3,7,512}},{100,{3,7,528}},{100,{3,7,544}},{100,{3,7,560}},{100,{3,48,800}},{100,{3,48,827}},{100,{3,48,854}},{100,{3,48,880}},{100,{3,48,907}},{100,{3,48,934}},{100,{3,15,800}},{100,{3,15,827}},{100,{3,15,854}},{100,{3,15,880}},{100,{3,15,907}},{100,{3,15,934}}]',2,'[{100,{4,1,2000}},{100,{4,15,1333}},{100,{4,7,800}}]'),(16040352,3,5,2,650050,'[{100,{3,1,1400}},{100,{4,15,1333}},{100,{4,7,800}}]',0,'[]',0,'[]',1,'[{100,{3,1,1200}},{100,{3,1,1240}},{100,{3,1,1280}},{100,{3,1,1320}},{100,{3,1,1360}},{100,{3,1,1400}},{100,{3,5,480}},{100,{3,5,496}},{100,{3,5,512}},{100,{3,5,528}},{100,{3,5,544}},{100,{3,5,560}},{100,{3,7,480}},{100,{3,7,496}},{100,{3,7,512}},{100,{3,7,528}},{100,{3,7,544}},{100,{3,7,560}},{100,{3,48,800}},{100,{3,48,827}},{100,{3,48,854}},{100,{3,48,880}},{100,{3,48,907}},{100,{3,48,934}},{100,{3,15,800}},{100,{3,15,827}},{100,{3,15,854}},{100,{3,15,880}},{100,{3,15,907}},{100,{3,15,934}}]',2,'[{100,{4,1,2000}},{100,{4,15,1333}},{100,{4,7,800}}]'),(16040353,3,5,3,800030,'[{100,{3,1,1400}},{100,{4,15,1333}},{100,{4,7,800}}]',0,'[]',0,'[]',1,'[{100,{3,1,1200}},{100,{3,1,1240}},{100,{3,1,1280}},{100,{3,1,1320}},{100,{3,1,1360}},{100,{3,1,1400}},{100,{3,5,480}},{100,{3,5,496}},{100,{3,5,512}},{100,{3,5,528}},{100,{3,5,544}},{100,{3,5,560}},{100,{3,7,480}},{100,{3,7,496}},{100,{3,7,512}},{100,{3,7,528}},{100,{3,7,544}},{100,{3,7,560}},{100,{3,48,800}},{100,{3,48,827}},{100,{3,48,854}},{100,{3,48,880}},{100,{3,48,907}},{100,{3,48,934}},{100,{3,15,800}},{100,{3,15,827}},{100,{3,15,854}},{100,{3,15,880}},{100,{3,15,907}},{100,{3,15,934}}]',2,'[{100,{4,1,2000}},{100,{4,15,1333}},{100,{4,7,800}}]'),(16040354,3,5,4,900060,'[{100,{4,1,2000}},{100,{4,15,1333}},{100,{4,7,800}}]',0,'[]',0,'[]',0,'[]',3,'[{100,{4,1,2000}},{100,{4,15,1333}},{100,{4,7,800}}]'),(16040355,3,5,5,1200050,'[{100,{4,1,2000}},{100,{4,15,1333}},{100,{4,7,800}}]',0,'[]',0,'[]',0,'[]',3,'[{100,{4,1,2000}},{100,{4,15,1333}},{100,{4,7,800}}]'),(16040401,4,0,1,10029,'[]',0,'[]',0,'[]',0,'[]',0,'[]'),(16040402,4,0,2,15018,'[]',0,'[]',0,'[]',0,'[]',0,'[]'),(16040403,4,0,3,20007,'[]',0,'[]',0,'[]',0,'[]',0,'[]'),(16040404,4,0,4,25046,'[]',0,'[]',0,'[]',0,'[]',0,'[]'),(16040405,4,0,5,30035,'[]',0,'[]',0,'[]',0,'[]',0,'[]'),(16040411,4,1,1,27042,'[{100,{1,2,560}}]',1,'[{100,{1,2,280}},{100,{1,2,336}},{100,{1,2,392}},{100,{1,2,448}},{100,{1,2,504}},{100,{1,2,560}},{100,{1,6,6}},{100,{1,6,7}},{100,{1,6,8}},{100,{1,6,9}},{100,{1,6,11}},{100,{1,6,12}},{100,{1,8,6}},{100,{1,8,7}},{100,{1,8,8}},{100,{1,8,9}},{100,{1,8,11}},{100,{1,8,12}},{100,{1,49,10}},{100,{1,49,12}},{100,{1,49,14}},{100,{1,49,15}},{100,{1,49,17}},{100,{1,49,19}},{100,{1,16,10}},{100,{1,16,12}},{100,{1,16,14}},{100,{1,16,15}},{100,{1,16,17}},{100,{1,16,19}}]',0,'[]',0,'[]',0,'[]'),(16040412,4,1,2,40537,'[{100,{1,2,560}}]',1,'[{100,{1,2,280}},{100,{1,2,336}},{100,{1,2,392}},{100,{1,2,448}},{100,{1,2,504}},{100,{1,2,560}},{100,{1,6,6}},{100,{1,6,7}},{100,{1,6,8}},{100,{1,6,9}},{100,{1,6,11}},{100,{1,6,12}},{100,{1,8,6}},{100,{1,8,7}},{100,{1,8,8}},{100,{1,8,9}},{100,{1,8,11}},{100,{1,8,12}},{100,{1,49,10}},{100,{1,49,12}},{100,{1,49,14}},{100,{1,49,15}},{100,{1,49,17}},{100,{1,49,19}},{100,{1,16,10}},{100,{1,16,12}},{100,{1,16,14}},{100,{1,16,15}},{100,{1,16,17}},{100,{1,16,19}}]',0,'[]',0,'[]',0,'[]'),(16040413,4,1,3,54033,'[{100,{1,2,560}},{100,{1,16,19}}]',2,'[{100,{1,2,280}},{100,{1,2,336}},{100,{1,2,392}},{100,{1,2,448}},{100,{1,2,504}},{100,{1,2,560}},{100,{1,6,6}},{100,{1,6,7}},{100,{1,6,8}},{100,{1,6,9}},{100,{1,6,11}},{100,{1,6,12}},{100,{1,8,6}},{100,{1,8,7}},{100,{1,8,8}},{100,{1,8,9}},{100,{1,8,11}},{100,{1,8,12}},{100,{1,49,10}},{100,{1,49,12}},{100,{1,49,14}},{100,{1,49,15}},{100,{1,49,17}},{100,{1,49,19}},{100,{1,16,10}},{100,{1,16,12}},{100,{1,16,14}},{100,{1,16,15}},{100,{1,16,17}},{100,{1,16,19}}]',0,'[]',0,'[]',0,'[]'),(16040414,4,1,4,67529,'[{100,{1,2,560}},{100,{1,16,19}}]',2,'[{100,{1,2,280}},{100,{1,2,336}},{100,{1,2,392}},{100,{1,2,448}},{100,{1,2,504}},{100,{1,2,560}},{100,{1,6,6}},{100,{1,6,7}},{100,{1,6,8}},{100,{1,6,9}},{100,{1,6,11}},{100,{1,6,12}},{100,{1,8,6}},{100,{1,8,7}},{100,{1,8,8}},{100,{1,8,9}},{100,{1,8,11}},{100,{1,8,12}},{100,{1,49,10}},{100,{1,49,12}},{100,{1,49,14}},{100,{1,49,15}},{100,{1,49,17}},{100,{1,49,19}},{100,{1,16,10}},{100,{1,16,12}},{100,{1,16,14}},{100,{1,16,15}},{100,{1,16,17}},{100,{1,16,19}}]',0,'[]',0,'[]',0,'[]'),(16040415,4,1,5,81024,'[{100,{1,2,560}},{100,{1,16,19}}]',2,'[{100,{1,2,280}},{100,{1,2,336}},{100,{1,2,392}},{100,{1,2,448}},{100,{1,2,504}},{100,{1,2,560}},{100,{1,6,6}},{100,{1,6,7}},{100,{1,6,8}},{100,{1,6,9}},{100,{1,6,11}},{100,{1,6,12}},{100,{1,8,6}},{100,{1,8,7}},{100,{1,8,8}},{100,{1,8,9}},{100,{1,8,11}},{100,{1,8,12}},{100,{1,49,10}},{100,{1,49,12}},{100,{1,49,14}},{100,{1,49,15}},{100,{1,49,17}},{100,{1,49,19}},{100,{1,16,10}},{100,{1,16,12}},{100,{1,16,14}},{100,{1,16,15}},{100,{1,16,17}},{100,{1,16,19}}]',0,'[]',0,'[]',0,'[]'),(16040421,4,2,1,70048,'[{100,{1,2,800}},{100,{2,16,67}}]',1,'[{100,{1,2,400}},{100,{1,2,480}},{100,{1,2,560}},{100,{1,2,640}},{100,{1,2,720}},{100,{1,2,800}},{100,{1,6,8}},{100,{1,6,10}},{100,{1,6,12}},{100,{1,6,13}},{100,{1,6,15}},{100,{1,6,16}},{100,{1,8,8}},{100,{1,8,10}},{100,{1,8,12}},{100,{1,8,13}},{100,{1,8,15}},{100,{1,8,16}},{100,{1,49,14}},{100,{1,49,16}},{100,{1,49,19}},{100,{1,49,22}},{100,{1,49,24}},{100,{1,49,27}},{100,{1,16,14}},{100,{1,16,16}},{100,{1,16,19}},{100,{1,16,22}},{100,{1,16,24}},{100,{1,16,27}}]',1,'[{100,{2,2,1600}},{100,{2,2,1680}},{100,{2,2,1760}},{100,{2,2,1840}},{100,{2,2,1920}},{100,{2,2,2000}},{100,{2,6,32}},{100,{2,6,34}},{100,{2,6,36}},{100,{2,6,37}},{100,{2,6,39}},{100,{2,6,40}},{100,{2,8,32}},{100,{2,8,34}},{100,{2,8,36}},{100,{2,8,37}},{100,{2,8,39}},{100,{2,8,40}},{100,{2,49,54}},{100,{2,49,56}},{100,{2,49,59}},{100,{2,49,62}},{100,{2,49,64}},{100,{2,49,67}},{100,{2,16,54}},{100,{2,16,56}},{100,{2,16,59}},{100,{2,16,62}},{100,{2,16,64}},{100,{2,16,67}}]',0,'[]',0,'[]'),(16040422,4,2,2,105022,'[{100,{1,2,800}},{100,{2,16,67}}]',1,'[{100,{1,2,400}},{100,{1,2,480}},{100,{1,2,560}},{100,{1,2,640}},{100,{1,2,720}},{100,{1,2,800}},{100,{1,6,8}},{100,{1,6,10}},{100,{1,6,12}},{100,{1,6,13}},{100,{1,6,15}},{100,{1,6,16}},{100,{1,8,8}},{100,{1,8,10}},{100,{1,8,12}},{100,{1,8,13}},{100,{1,8,15}},{100,{1,8,16}},{100,{1,49,14}},{100,{1,49,16}},{100,{1,49,19}},{100,{1,49,22}},{100,{1,49,24}},{100,{1,49,27}},{100,{1,16,14}},{100,{1,16,16}},{100,{1,16,19}},{100,{1,16,22}},{100,{1,16,24}},{100,{1,16,27}}]',1,'[{100,{2,2,1600}},{100,{2,2,1680}},{100,{2,2,1760}},{100,{2,2,1840}},{100,{2,2,1920}},{100,{2,2,2000}},{100,{2,6,32}},{100,{2,6,34}},{100,{2,6,36}},{100,{2,6,37}},{100,{2,6,39}},{100,{2,6,40}},{100,{2,8,32}},{100,{2,8,34}},{100,{2,8,36}},{100,{2,8,37}},{100,{2,8,39}},{100,{2,8,40}},{100,{2,49,54}},{100,{2,49,56}},{100,{2,49,59}},{100,{2,49,62}},{100,{2,49,64}},{100,{2,49,67}},{100,{2,16,54}},{100,{2,16,56}},{100,{2,16,59}},{100,{2,16,62}},{100,{2,16,64}},{100,{2,16,67}}]',0,'[]',0,'[]'),(16040423,4,2,3,140046,'[{100,{2,2,2000}},{100,{2,16,67}}]',0,'[]',2,'[{100,{2,2,1600}},{100,{2,2,1680}},{100,{2,2,1760}},{100,{2,2,1840}},{100,{2,2,1920}},{100,{2,2,2000}},{100,{2,6,32}},{100,{2,6,34}},{100,{2,6,36}},{100,{2,6,37}},{100,{2,6,39}},{100,{2,6,40}},{100,{2,8,32}},{100,{2,8,34}},{100,{2,8,36}},{100,{2,8,37}},{100,{2,8,39}},{100,{2,8,40}},{100,{2,49,54}},{100,{2,49,56}},{100,{2,49,59}},{100,{2,49,62}},{100,{2,49,64}},{100,{2,49,67}},{100,{2,16,54}},{100,{2,16,56}},{100,{2,16,59}},{100,{2,16,62}},{100,{2,16,64}},{100,{2,16,67}}]',0,'[]',0,'[]'),(16040424,4,2,4,175020,'[{100,{2,2,2000}},{100,{2,16,67}}]',0,'[]',2,'[{100,{2,2,1600}},{100,{2,2,1680}},{100,{2,2,1760}},{100,{2,2,1840}},{100,{2,2,1920}},{100,{2,2,2000}},{100,{2,6,32}},{100,{2,6,34}},{100,{2,6,36}},{100,{2,6,37}},{100,{2,6,39}},{100,{2,6,40}},{100,{2,8,32}},{100,{2,8,34}},{100,{2,8,36}},{100,{2,8,37}},{100,{2,8,39}},{100,{2,8,40}},{100,{2,49,54}},{100,{2,49,56}},{100,{2,49,59}},{100,{2,49,62}},{100,{2,49,64}},{100,{2,49,67}},{100,{2,16,54}},{100,{2,16,56}},{100,{2,16,59}},{100,{2,16,62}},{100,{2,16,64}},{100,{2,16,67}}]',0,'[]',0,'[]'),(16040425,4,2,5,210044,'[{100,{2,2,2000}},{100,{2,16,67}}]',0,'[]',2,'[{100,{2,2,1600}},{100,{2,2,1680}},{100,{2,2,1760}},{100,{2,2,1840}},{100,{2,2,1920}},{100,{2,2,2000}},{100,{2,6,32}},{100,{2,6,34}},{100,{2,6,36}},{100,{2,6,37}},{100,{2,6,39}},{100,{2,6,40}},{100,{2,8,32}},{100,{2,8,34}},{100,{2,8,36}},{100,{2,8,37}},{100,{2,8,39}},{100,{2,8,40}},{100,{2,49,54}},{100,{2,49,56}},{100,{2,49,59}},{100,{2,49,62}},{100,{2,49,64}},{100,{2,49,67}},{100,{2,16,54}},{100,{2,16,56}},{100,{2,16,59}},{100,{2,16,62}},{100,{2,16,64}},{100,{2,16,67}}]',0,'[]',0,'[]'),(16040431,4,3,1,180009,'[{100,{2,2,4000}},{100,{3,16,187}}]',0,'[]',1,'[{100,{2,2,3200}},{100,{2,2,3360}},{100,{2,2,3520}},{100,{2,2,3680}},{100,{2,2,3840}},{100,{2,2,4000}},{100,{2,6,64}},{100,{2,6,68}},{100,{2,6,71}},{100,{2,6,74}},{100,{2,6,77}},{100,{2,6,80}},{100,{2,8,64}},{100,{2,8,68}},{100,{2,8,71}},{100,{2,8,74}},{100,{2,8,77}},{100,{2,8,80}},{100,{2,49,107}},{100,{2,49,112}},{100,{2,49,118}},{100,{2,49,123}},{100,{2,49,128}},{100,{2,49,134}},{100,{2,16,107}},{100,{2,16,112}},{100,{2,16,118}},{100,{2,16,123}},{100,{2,16,128}},{100,{2,16,134}}]',1,'[{100,{3,2,4800}},{100,{3,2,4960}},{100,{3,2,5120}},{100,{3,2,5280}},{100,{3,2,5440}},{100,{3,2,5600}},{100,{3,6,96}},{100,{3,6,100}},{100,{3,6,103}},{100,{3,6,106}},{100,{3,6,109}},{100,{3,6,112}},{100,{3,8,96}},{100,{3,8,100}},{100,{3,8,103}},{100,{3,8,106}},{100,{3,8,109}},{100,{3,8,112}},{100,{3,49,160}},{100,{3,49,166}},{100,{3,49,171}},{100,{3,49,176}},{100,{3,49,182}},{100,{3,49,187}},{100,{3,16,160}},{100,{3,16,166}},{100,{3,16,171}},{100,{3,16,176}},{100,{3,16,182}},{100,{3,16,187}}]',0,'[]'),(16040432,4,3,2,270014,'[{100,{2,2,4000}},{100,{3,16,187}}]',0,'[]',1,'[{100,{2,2,3200}},{100,{2,2,3360}},{100,{2,2,3520}},{100,{2,2,3680}},{100,{2,2,3840}},{100,{2,2,4000}},{100,{2,6,64}},{100,{2,6,68}},{100,{2,6,71}},{100,{2,6,74}},{100,{2,6,77}},{100,{2,6,80}},{100,{2,8,64}},{100,{2,8,68}},{100,{2,8,71}},{100,{2,8,74}},{100,{2,8,77}},{100,{2,8,80}},{100,{2,49,107}},{100,{2,49,112}},{100,{2,49,118}},{100,{2,49,123}},{100,{2,49,128}},{100,{2,49,134}},{100,{2,16,107}},{100,{2,16,112}},{100,{2,16,118}},{100,{2,16,123}},{100,{2,16,128}},{100,{2,16,134}}]',1,'[{100,{3,2,4800}},{100,{3,2,4960}},{100,{3,2,5120}},{100,{3,2,5280}},{100,{3,2,5440}},{100,{3,2,5600}},{100,{3,6,96}},{100,{3,6,100}},{100,{3,6,103}},{100,{3,6,106}},{100,{3,6,109}},{100,{3,6,112}},{100,{3,8,96}},{100,{3,8,100}},{100,{3,8,103}},{100,{3,8,106}},{100,{3,8,109}},{100,{3,8,112}},{100,{3,49,160}},{100,{3,49,166}},{100,{3,49,171}},{100,{3,49,176}},{100,{3,49,182}},{100,{3,49,187}},{100,{3,16,160}},{100,{3,16,166}},{100,{3,16,171}},{100,{3,16,176}},{100,{3,16,182}},{100,{3,16,187}}]',0,'[]'),(16040433,4,3,3,360018,'[{100,{3,2,5600}},{100,{3,16,187}}]',0,'[]',0,'[]',2,'[{100,{3,2,4800}},{100,{3,2,4960}},{100,{3,2,5120}},{100,{3,2,5280}},{100,{3,2,5440}},{100,{3,2,5600}},{100,{3,6,96}},{100,{3,6,100}},{100,{3,6,103}},{100,{3,6,106}},{100,{3,6,109}},{100,{3,6,112}},{100,{3,8,96}},{100,{3,8,100}},{100,{3,8,103}},{100,{3,8,106}},{100,{3,8,109}},{100,{3,8,112}},{100,{3,49,160}},{100,{3,49,166}},{100,{3,49,171}},{100,{3,49,176}},{100,{3,49,182}},{100,{3,49,187}},{100,{3,16,160}},{100,{3,16,166}},{100,{3,16,171}},{100,{3,16,176}},{100,{3,16,182}},{100,{3,16,187}}]',0,'[]'),(16040434,4,3,4,450022,'[{100,{3,2,5600}},{100,{3,16,187}},{100,{2,8,80}}]',0,'[]',1,'[{100,{2,2,3200}},{100,{2,2,3360}},{100,{2,2,3520}},{100,{2,2,3680}},{100,{2,2,3840}},{100,{2,2,4000}},{100,{2,6,64}},{100,{2,6,68}},{100,{2,6,71}},{100,{2,6,74}},{100,{2,6,77}},{100,{2,6,80}},{100,{2,8,64}},{100,{2,8,68}},{100,{2,8,71}},{100,{2,8,74}},{100,{2,8,77}},{100,{2,8,80}},{100,{2,49,107}},{100,{2,49,112}},{100,{2,49,118}},{100,{2,49,123}},{100,{2,49,128}},{100,{2,49,134}},{100,{2,16,107}},{100,{2,16,112}},{100,{2,16,118}},{100,{2,16,123}},{100,{2,16,128}},{100,{2,16,134}}]',2,'[{100,{3,2,4800}},{100,{3,2,4960}},{100,{3,2,5120}},{100,{3,2,5280}},{100,{3,2,5440}},{100,{3,2,5600}},{100,{3,6,96}},{100,{3,6,100}},{100,{3,6,103}},{100,{3,6,106}},{100,{3,6,109}},{100,{3,6,112}},{100,{3,8,96}},{100,{3,8,100}},{100,{3,8,103}},{100,{3,8,106}},{100,{3,8,109}},{100,{3,8,112}},{100,{3,49,160}},{100,{3,49,166}},{100,{3,49,171}},{100,{3,49,176}},{100,{3,49,182}},{100,{3,49,187}},{100,{3,16,160}},{100,{3,16,166}},{100,{3,16,171}},{100,{3,16,176}},{100,{3,16,182}},{100,{3,16,187}}]',0,'[]'),(16040435,4,3,5,540027,'[{100,{3,2,5600}},{100,{3,16,187}},{100,{3,8,112}}]',0,'[]',0,'[]',3,'[{100,{3,2,4800}},{100,{3,2,4960}},{100,{3,2,5120}},{100,{3,2,5280}},{100,{3,2,5440}},{100,{3,2,5600}},{100,{3,6,96}},{100,{3,6,100}},{100,{3,6,103}},{100,{3,6,106}},{100,{3,6,109}},{100,{3,6,112}},{100,{3,8,96}},{100,{3,8,100}},{100,{3,8,103}},{100,{3,8,106}},{100,{3,8,109}},{100,{3,8,112}},{100,{3,49,160}},{100,{3,49,166}},{100,{3,49,171}},{100,{3,49,176}},{100,{3,49,182}},{100,{3,49,187}},{100,{3,16,160}},{100,{3,16,166}},{100,{3,16,171}},{100,{3,16,176}},{100,{3,16,182}},{100,{3,16,187}}]',0,'[]'),(16040441,4,4,1,500013,'[{100,{3,2,16800}},{100,{3,16,560}},{100,{3,8,336}}]',0,'[]',0,'[]',3,'[{100,{3,2,14400}},{100,{3,2,14880}},{100,{3,2,15360}},{100,{3,2,15840}},{100,{3,2,16320}},{100,{3,2,16800}},{100,{3,6,288}},{100,{3,6,298}},{100,{3,6,308}},{100,{3,6,317}},{100,{3,6,327}},{100,{3,6,336}},{100,{3,8,288}},{100,{3,8,298}},{100,{3,8,308}},{100,{3,8,317}},{100,{3,8,327}},{100,{3,8,336}},{100,{3,49,480}},{100,{3,49,496}},{100,{3,49,512}},{100,{3,49,528}},{100,{3,49,544}},{100,{3,49,560}},{100,{3,16,480}},{100,{3,16,496}},{100,{3,16,512}},{100,{3,16,528}},{100,{3,16,544}},{100,{3,16,560}}]',0,'[]'),(16040442,4,4,2,600046,'[{100,{3,2,16800}},{100,{3,16,560}},{100,{4,8,480}}]',0,'[]',0,'[]',2,'[{100,{3,2,14400}},{100,{3,2,14880}},{100,{3,2,15360}},{100,{3,2,15840}},{100,{3,2,16320}},{100,{3,2,16800}},{100,{3,6,288}},{100,{3,6,298}},{100,{3,6,308}},{100,{3,6,317}},{100,{3,6,327}},{100,{3,6,336}},{100,{3,8,288}},{100,{3,8,298}},{100,{3,8,308}},{100,{3,8,317}},{100,{3,8,327}},{100,{3,8,336}},{100,{3,49,480}},{100,{3,49,496}},{100,{3,49,512}},{100,{3,49,528}},{100,{3,49,544}},{100,{3,49,560}},{100,{3,16,480}},{100,{3,16,496}},{100,{3,16,512}},{100,{3,16,528}},{100,{3,16,544}},{100,{3,16,560}}]',1,'[{100,{4,2,24000}},{100,{4,16,800}},{100,{4,8,480}}]'),(16040443,4,4,3,750020,'[{100,{3,2,16800}},{100,{3,16,560}},{100,{4,8,480}}]',0,'[]',0,'[]',2,'[{100,{3,2,14400}},{100,{3,2,14880}},{100,{3,2,15360}},{100,{3,2,15840}},{100,{3,2,16320}},{100,{3,2,16800}},{100,{3,6,288}},{100,{3,6,298}},{100,{3,6,308}},{100,{3,6,317}},{100,{3,6,327}},{100,{3,6,336}},{100,{3,8,288}},{100,{3,8,298}},{100,{3,8,308}},{100,{3,8,317}},{100,{3,8,327}},{100,{3,8,336}},{100,{3,49,480}},{100,{3,49,496}},{100,{3,49,512}},{100,{3,49,528}},{100,{3,49,544}},{100,{3,49,560}},{100,{3,16,480}},{100,{3,16,496}},{100,{3,16,512}},{100,{3,16,528}},{100,{3,16,544}},{100,{3,16,560}}]',1,'[{100,{4,2,24000}},{100,{4,16,800}},{100,{4,8,480}}]'),(16040444,4,4,4,900044,'[{100,{3,2,16800}},{100,{4,16,800}},{100,{4,8,480}}]',0,'[]',0,'[]',1,'[{100,{3,2,14400}},{100,{3,2,14880}},{100,{3,2,15360}},{100,{3,2,15840}},{100,{3,2,16320}},{100,{3,2,16800}},{100,{3,6,288}},{100,{3,6,298}},{100,{3,6,308}},{100,{3,6,317}},{100,{3,6,327}},{100,{3,6,336}},{100,{3,8,288}},{100,{3,8,298}},{100,{3,8,308}},{100,{3,8,317}},{100,{3,8,327}},{100,{3,8,336}},{100,{3,49,480}},{100,{3,49,496}},{100,{3,49,512}},{100,{3,49,528}},{100,{3,49,544}},{100,{3,49,560}},{100,{3,16,480}},{100,{3,16,496}},{100,{3,16,512}},{100,{3,16,528}},{100,{3,16,544}},{100,{3,16,560}}]',2,'[{100,{4,2,24000}},{100,{4,16,800}},{100,{4,8,480}}]'),(16040445,4,4,5,1100009,'[{100,{3,2,16800}},{100,{4,16,800}},{100,{4,8,480}}]',0,'[]',0,'[]',1,'[{100,{3,2,14400}},{100,{3,2,14880}},{100,{3,2,15360}},{100,{3,2,15840}},{100,{3,2,16320}},{100,{3,2,16800}},{100,{3,6,288}},{100,{3,6,298}},{100,{3,6,308}},{100,{3,6,317}},{100,{3,6,327}},{100,{3,6,336}},{100,{3,8,288}},{100,{3,8,298}},{100,{3,8,308}},{100,{3,8,317}},{100,{3,8,327}},{100,{3,8,336}},{100,{3,49,480}},{100,{3,49,496}},{100,{3,49,512}},{100,{3,49,528}},{100,{3,49,544}},{100,{3,49,560}},{100,{3,16,480}},{100,{3,16,496}},{100,{3,16,512}},{100,{3,16,528}},{100,{3,16,544}},{100,{3,16,560}}]',2,'[{100,{4,2,24000}},{100,{4,16,800}},{100,{4,8,480}}]'),(16040451,4,5,1,550005,'[{100,{3,2,28000}},{100,{4,16,1333}},{100,{4,8,800}}]',0,'[]',0,'[]',1,'[{100,{3,2,24000}},{100,{3,2,24800}},{100,{3,2,25600}},{100,{3,2,26400}},{100,{3,2,27200}},{100,{3,2,28000}},{100,{3,6,480}},{100,{3,6,496}},{100,{3,6,512}},{100,{3,6,528}},{100,{3,6,544}},{100,{3,6,560}},{100,{3,8,480}},{100,{3,8,496}},{100,{3,8,512}},{100,{3,8,528}},{100,{3,8,544}},{100,{3,8,560}},{100,{3,49,800}},{100,{3,49,827}},{100,{3,49,854}},{100,{3,49,880}},{100,{3,49,907}},{100,{3,49,934}},{100,{3,16,800}},{100,{3,16,827}},{100,{3,16,854}},{100,{3,16,880}},{100,{3,16,907}},{100,{3,16,934}}]',2,'[{100,{4,2,40000}},{100,{4,16,1333}},{100,{4,8,800}}]'),(16040452,4,5,2,650037,'[{100,{3,2,28000}},{100,{4,16,1333}},{100,{4,8,800}}]',0,'[]',0,'[]',1,'[{100,{3,2,24000}},{100,{3,2,24800}},{100,{3,2,25600}},{100,{3,2,26400}},{100,{3,2,27200}},{100,{3,2,28000}},{100,{3,6,480}},{100,{3,6,496}},{100,{3,6,512}},{100,{3,6,528}},{100,{3,6,544}},{100,{3,6,560}},{100,{3,8,480}},{100,{3,8,496}},{100,{3,8,512}},{100,{3,8,528}},{100,{3,8,544}},{100,{3,8,560}},{100,{3,49,800}},{100,{3,49,827}},{100,{3,49,854}},{100,{3,49,880}},{100,{3,49,907}},{100,{3,49,934}},{100,{3,16,800}},{100,{3,16,827}},{100,{3,16,854}},{100,{3,16,880}},{100,{3,16,907}},{100,{3,16,934}}]',2,'[{100,{4,2,40000}},{100,{4,16,1333}},{100,{4,8,800}}]'),(16040453,4,5,3,800011,'[{100,{3,2,28000}},{100,{4,16,1333}},{100,{4,8,800}}]',0,'[]',0,'[]',1,'[{100,{3,2,24000}},{100,{3,2,24800}},{100,{3,2,25600}},{100,{3,2,26400}},{100,{3,2,27200}},{100,{3,2,28000}},{100,{3,6,480}},{100,{3,6,496}},{100,{3,6,512}},{100,{3,6,528}},{100,{3,6,544}},{100,{3,6,560}},{100,{3,8,480}},{100,{3,8,496}},{100,{3,8,512}},{100,{3,8,528}},{100,{3,8,544}},{100,{3,8,560}},{100,{3,49,800}},{100,{3,49,827}},{100,{3,49,854}},{100,{3,49,880}},{100,{3,49,907}},{100,{3,49,934}},{100,{3,16,800}},{100,{3,16,827}},{100,{3,16,854}},{100,{3,16,880}},{100,{3,16,907}},{100,{3,16,934}}]',2,'[{100,{4,2,40000}},{100,{4,16,1333}},{100,{4,8,800}}]'),(16040454,4,5,4,900044,'[{100,{4,2,40000}},{100,{4,16,1333}},{100,{4,8,800}}]',0,'[]',0,'[]',0,'[]',3,'[{100,{4,2,40000}},{100,{4,16,1333}},{100,{4,8,800}}]'),(16040455,4,5,5,1200042,'[{100,{4,2,40000}},{100,{4,16,1333}},{100,{4,8,800}}]',0,'[]',0,'[]',0,'[]',3,'[{100,{4,2,40000}},{100,{4,16,1333}},{100,{4,8,800}}]'),(16040501,5,0,1,10030,'[]',0,'[]',0,'[]',0,'[]',0,'[]'),(16040502,5,0,2,15020,'[]',0,'[]',0,'[]',0,'[]',0,'[]'),(16040503,5,0,3,20010,'[]',0,'[]',0,'[]',0,'[]',0,'[]'),(16040504,5,0,4,25050,'[]',0,'[]',0,'[]',0,'[]',0,'[]'),(16040505,5,0,5,30040,'[]',0,'[]',0,'[]',0,'[]',0,'[]'),(16040511,5,1,1,27050,'[{100,{1,1,28}}]',1,'[{100,{1,1,14}},{100,{1,1,17}},{100,{1,1,20}},{100,{1,1,23}},{100,{1,1,26}},{100,{1,1,28}},{100,{1,5,6}},{100,{1,5,7}},{100,{1,5,8}},{100,{1,5,9}},{100,{1,5,11}},{100,{1,5,12}},{100,{1,7,6}},{100,{1,7,7}},{100,{1,7,8}},{100,{1,7,9}},{100,{1,7,11}},{100,{1,7,12}},{100,{1,48,10}},{100,{1,48,12}},{100,{1,48,14}},{100,{1,48,15}},{100,{1,48,17}},{100,{1,48,19}},{100,{1,15,10}},{100,{1,15,12}},{100,{1,15,14}},{100,{1,15,15}},{100,{1,15,17}},{100,{1,15,19}}]',0,'[]',0,'[]',0,'[]'),(16040512,5,1,2,40550,'[{100,{1,1,28}}]',1,'[{100,{1,1,14}},{100,{1,1,17}},{100,{1,1,20}},{100,{1,1,23}},{100,{1,1,26}},{100,{1,1,28}},{100,{1,5,6}},{100,{1,5,7}},{100,{1,5,8}},{100,{1,5,9}},{100,{1,5,11}},{100,{1,5,12}},{100,{1,7,6}},{100,{1,7,7}},{100,{1,7,8}},{100,{1,7,9}},{100,{1,7,11}},{100,{1,7,12}},{100,{1,48,10}},{100,{1,48,12}},{100,{1,48,14}},{100,{1,48,15}},{100,{1,48,17}},{100,{1,48,19}},{100,{1,15,10}},{100,{1,15,12}},{100,{1,15,14}},{100,{1,15,15}},{100,{1,15,17}},{100,{1,15,19}}]',0,'[]',0,'[]',0,'[]'),(16040513,5,1,3,54050,'[{100,{1,1,28}},{100,{1,15,19}}]',2,'[{100,{1,1,14}},{100,{1,1,17}},{100,{1,1,20}},{100,{1,1,23}},{100,{1,1,26}},{100,{1,1,28}},{100,{1,5,6}},{100,{1,5,7}},{100,{1,5,8}},{100,{1,5,9}},{100,{1,5,11}},{100,{1,5,12}},{100,{1,7,6}},{100,{1,7,7}},{100,{1,7,8}},{100,{1,7,9}},{100,{1,7,11}},{100,{1,7,12}},{100,{1,48,10}},{100,{1,48,12}},{100,{1,48,14}},{100,{1,48,15}},{100,{1,48,17}},{100,{1,48,19}},{100,{1,15,10}},{100,{1,15,12}},{100,{1,15,14}},{100,{1,15,15}},{100,{1,15,17}},{100,{1,15,19}}]',0,'[]',0,'[]',0,'[]'),(16040514,5,1,4,67530,'[{100,{1,1,28}},{100,{1,15,19}}]',2,'[{100,{1,1,14}},{100,{1,1,17}},{100,{1,1,20}},{100,{1,1,23}},{100,{1,1,26}},{100,{1,1,28}},{100,{1,5,6}},{100,{1,5,7}},{100,{1,5,8}},{100,{1,5,9}},{100,{1,5,11}},{100,{1,5,12}},{100,{1,7,6}},{100,{1,7,7}},{100,{1,7,8}},{100,{1,7,9}},{100,{1,7,11}},{100,{1,7,12}},{100,{1,48,10}},{100,{1,48,12}},{100,{1,48,14}},{100,{1,48,15}},{100,{1,48,17}},{100,{1,48,19}},{100,{1,15,10}},{100,{1,15,12}},{100,{1,15,14}},{100,{1,15,15}},{100,{1,15,17}},{100,{1,15,19}}]',0,'[]',0,'[]',0,'[]'),(16040515,5,1,5,81030,'[{100,{1,1,28}},{100,{1,15,19}}]',2,'[{100,{1,1,14}},{100,{1,1,17}},{100,{1,1,20}},{100,{1,1,23}},{100,{1,1,26}},{100,{1,1,28}},{100,{1,5,6}},{100,{1,5,7}},{100,{1,5,8}},{100,{1,5,9}},{100,{1,5,11}},{100,{1,5,12}},{100,{1,7,6}},{100,{1,7,7}},{100,{1,7,8}},{100,{1,7,9}},{100,{1,7,11}},{100,{1,7,12}},{100,{1,48,10}},{100,{1,48,12}},{100,{1,48,14}},{100,{1,48,15}},{100,{1,48,17}},{100,{1,48,19}},{100,{1,15,10}},{100,{1,15,12}},{100,{1,15,14}},{100,{1,15,15}},{100,{1,15,17}},{100,{1,15,19}}]',0,'[]',0,'[]',0,'[]'),(16040521,5,2,1,70060,'[{100,{1,1,40}},{100,{2,15,67}}]',1,'[{100,{1,1,20}},{100,{1,1,24}},{100,{1,1,28}},{100,{1,1,32}},{100,{1,1,36}},{100,{1,1,40}},{100,{1,5,8}},{100,{1,5,10}},{100,{1,5,12}},{100,{1,5,13}},{100,{1,5,15}},{100,{1,5,16}},{100,{1,7,8}},{100,{1,7,10}},{100,{1,7,12}},{100,{1,7,13}},{100,{1,7,15}},{100,{1,7,16}},{100,{1,48,14}},{100,{1,48,16}},{100,{1,48,19}},{100,{1,48,22}},{100,{1,48,24}},{100,{1,48,27}},{100,{1,15,14}},{100,{1,15,16}},{100,{1,15,19}},{100,{1,15,22}},{100,{1,15,24}},{100,{1,15,27}}]',1,'[{100,{2,1,80}},{100,{2,1,84}},{100,{2,1,88}},{100,{2,1,92}},{100,{2,1,96}},{100,{2,1,100}},{100,{2,5,32}},{100,{2,5,34}},{100,{2,5,36}},{100,{2,5,37}},{100,{2,5,39}},{100,{2,5,40}},{100,{2,7,32}},{100,{2,7,34}},{100,{2,7,36}},{100,{2,7,37}},{100,{2,7,39}},{100,{2,7,40}},{100,{2,48,54}},{100,{2,48,56}},{100,{2,48,59}},{100,{2,48,62}},{100,{2,48,64}},{100,{2,48,67}},{100,{2,15,54}},{100,{2,15,56}},{100,{2,15,59}},{100,{2,15,62}},{100,{2,15,64}},{100,{2,15,67}}]',0,'[]',0,'[]'),(16040522,5,2,2,105040,'[{100,{1,1,40}},{100,{2,15,67}}]',1,'[{100,{1,1,20}},{100,{1,1,24}},{100,{1,1,28}},{100,{1,1,32}},{100,{1,1,36}},{100,{1,1,40}},{100,{1,5,8}},{100,{1,5,10}},{100,{1,5,12}},{100,{1,5,13}},{100,{1,5,15}},{100,{1,5,16}},{100,{1,7,8}},{100,{1,7,10}},{100,{1,7,12}},{100,{1,7,13}},{100,{1,7,15}},{100,{1,7,16}},{100,{1,48,14}},{100,{1,48,16}},{100,{1,48,19}},{100,{1,48,22}},{100,{1,48,24}},{100,{1,48,27}},{100,{1,15,14}},{100,{1,15,16}},{100,{1,15,19}},{100,{1,15,22}},{100,{1,15,24}},{100,{1,15,27}}]',1,'[{100,{2,1,80}},{100,{2,1,84}},{100,{2,1,88}},{100,{2,1,92}},{100,{2,1,96}},{100,{2,1,100}},{100,{2,5,32}},{100,{2,5,34}},{100,{2,5,36}},{100,{2,5,37}},{100,{2,5,39}},{100,{2,5,40}},{100,{2,7,32}},{100,{2,7,34}},{100,{2,7,36}},{100,{2,7,37}},{100,{2,7,39}},{100,{2,7,40}},{100,{2,48,54}},{100,{2,48,56}},{100,{2,48,59}},{100,{2,48,62}},{100,{2,48,64}},{100,{2,48,67}},{100,{2,15,54}},{100,{2,15,56}},{100,{2,15,59}},{100,{2,15,62}},{100,{2,15,64}},{100,{2,15,67}}]',0,'[]',0,'[]'),(16040523,5,2,3,140050,'[{100,{2,1,100}},{100,{2,15,67}}]',0,'[]',2,'[{100,{2,1,80}},{100,{2,1,84}},{100,{2,1,88}},{100,{2,1,92}},{100,{2,1,96}},{100,{2,1,100}},{100,{2,5,32}},{100,{2,5,34}},{100,{2,5,36}},{100,{2,5,37}},{100,{2,5,39}},{100,{2,5,40}},{100,{2,7,32}},{100,{2,7,34}},{100,{2,7,36}},{100,{2,7,37}},{100,{2,7,39}},{100,{2,7,40}},{100,{2,48,54}},{100,{2,48,56}},{100,{2,48,59}},{100,{2,48,62}},{100,{2,48,64}},{100,{2,48,67}},{100,{2,15,54}},{100,{2,15,56}},{100,{2,15,59}},{100,{2,15,62}},{100,{2,15,64}},{100,{2,15,67}}]',0,'[]',0,'[]'),(16040524,5,2,4,175030,'[{100,{2,1,100}},{100,{2,15,67}}]',0,'[]',2,'[{100,{2,1,80}},{100,{2,1,84}},{100,{2,1,88}},{100,{2,1,92}},{100,{2,1,96}},{100,{2,1,100}},{100,{2,5,32}},{100,{2,5,34}},{100,{2,5,36}},{100,{2,5,37}},{100,{2,5,39}},{100,{2,5,40}},{100,{2,7,32}},{100,{2,7,34}},{100,{2,7,36}},{100,{2,7,37}},{100,{2,7,39}},{100,{2,7,40}},{100,{2,48,54}},{100,{2,48,56}},{100,{2,48,59}},{100,{2,48,62}},{100,{2,48,64}},{100,{2,48,67}},{100,{2,15,54}},{100,{2,15,56}},{100,{2,15,59}},{100,{2,15,62}},{100,{2,15,64}},{100,{2,15,67}}]',0,'[]',0,'[]'),(16040525,5,2,5,210060,'[{100,{2,1,100}},{100,{2,15,67}}]',0,'[]',2,'[{100,{2,1,80}},{100,{2,1,84}},{100,{2,1,88}},{100,{2,1,92}},{100,{2,1,96}},{100,{2,1,100}},{100,{2,5,32}},{100,{2,5,34}},{100,{2,5,36}},{100,{2,5,37}},{100,{2,5,39}},{100,{2,5,40}},{100,{2,7,32}},{100,{2,7,34}},{100,{2,7,36}},{100,{2,7,37}},{100,{2,7,39}},{100,{2,7,40}},{100,{2,48,54}},{100,{2,48,56}},{100,{2,48,59}},{100,{2,48,62}},{100,{2,48,64}},{100,{2,48,67}},{100,{2,15,54}},{100,{2,15,56}},{100,{2,15,59}},{100,{2,15,62}},{100,{2,15,64}},{100,{2,15,67}}]',0,'[]',0,'[]'),(16040531,5,3,1,180020,'[{100,{2,1,200}},{100,{3,15,187}}]',0,'[]',1,'[{100,{2,1,160}},{100,{2,1,168}},{100,{2,1,176}},{100,{2,1,184}},{100,{2,1,192}},{100,{2,1,200}},{100,{2,5,64}},{100,{2,5,68}},{100,{2,5,71}},{100,{2,5,74}},{100,{2,5,77}},{100,{2,5,80}},{100,{2,7,64}},{100,{2,7,68}},{100,{2,7,71}},{100,{2,7,74}},{100,{2,7,77}},{100,{2,7,80}},{100,{2,48,107}},{100,{2,48,112}},{100,{2,48,118}},{100,{2,48,123}},{100,{2,48,128}},{100,{2,48,134}},{100,{2,15,107}},{100,{2,15,112}},{100,{2,15,118}},{100,{2,15,123}},{100,{2,15,128}},{100,{2,15,134}}]',1,'[{100,{3,1,240}},{100,{3,1,248}},{100,{3,1,256}},{100,{3,1,264}},{100,{3,1,272}},{100,{3,1,280}},{100,{3,5,96}},{100,{3,5,100}},{100,{3,5,103}},{100,{3,5,106}},{100,{3,5,109}},{100,{3,5,112}},{100,{3,7,96}},{100,{3,7,100}},{100,{3,7,103}},{100,{3,7,106}},{100,{3,7,109}},{100,{3,7,112}},{100,{3,48,160}},{100,{3,48,166}},{100,{3,48,171}},{100,{3,48,176}},{100,{3,48,182}},{100,{3,48,187}},{100,{3,15,160}},{100,{3,15,166}},{100,{3,15,171}},{100,{3,15,176}},{100,{3,15,182}},{100,{3,15,187}}]',0,'[]'),(16040532,5,3,2,270020,'[{100,{2,1,200}},{100,{3,15,187}}]',0,'[]',1,'[{100,{2,1,160}},{100,{2,1,168}},{100,{2,1,176}},{100,{2,1,184}},{100,{2,1,192}},{100,{2,1,200}},{100,{2,5,64}},{100,{2,5,68}},{100,{2,5,71}},{100,{2,5,74}},{100,{2,5,77}},{100,{2,5,80}},{100,{2,7,64}},{100,{2,7,68}},{100,{2,7,71}},{100,{2,7,74}},{100,{2,7,77}},{100,{2,7,80}},{100,{2,48,107}},{100,{2,48,112}},{100,{2,48,118}},{100,{2,48,123}},{100,{2,48,128}},{100,{2,48,134}},{100,{2,15,107}},{100,{2,15,112}},{100,{2,15,118}},{100,{2,15,123}},{100,{2,15,128}},{100,{2,15,134}}]',1,'[{100,{3,1,240}},{100,{3,1,248}},{100,{3,1,256}},{100,{3,1,264}},{100,{3,1,272}},{100,{3,1,280}},{100,{3,5,96}},{100,{3,5,100}},{100,{3,5,103}},{100,{3,5,106}},{100,{3,5,109}},{100,{3,5,112}},{100,{3,7,96}},{100,{3,7,100}},{100,{3,7,103}},{100,{3,7,106}},{100,{3,7,109}},{100,{3,7,112}},{100,{3,48,160}},{100,{3,48,166}},{100,{3,48,171}},{100,{3,48,176}},{100,{3,48,182}},{100,{3,48,187}},{100,{3,15,160}},{100,{3,15,166}},{100,{3,15,171}},{100,{3,15,176}},{100,{3,15,182}},{100,{3,15,187}}]',0,'[]'),(16040533,5,3,3,360020,'[{100,{3,1,280}},{100,{3,15,187}}]',0,'[]',0,'[]',2,'[{100,{3,1,240}},{100,{3,1,248}},{100,{3,1,256}},{100,{3,1,264}},{100,{3,1,272}},{100,{3,1,280}},{100,{3,5,96}},{100,{3,5,100}},{100,{3,5,103}},{100,{3,5,106}},{100,{3,5,109}},{100,{3,5,112}},{100,{3,7,96}},{100,{3,7,100}},{100,{3,7,103}},{100,{3,7,106}},{100,{3,7,109}},{100,{3,7,112}},{100,{3,48,160}},{100,{3,48,166}},{100,{3,48,171}},{100,{3,48,176}},{100,{3,48,182}},{100,{3,48,187}},{100,{3,15,160}},{100,{3,15,166}},{100,{3,15,171}},{100,{3,15,176}},{100,{3,15,182}},{100,{3,15,187}}]',0,'[]'),(16040534,5,3,4,450040,'[{100,{3,1,280}},{100,{3,15,187}},{100,{2,7,80}}]',0,'[]',1,'[{100,{2,1,160}},{100,{2,1,168}},{100,{2,1,176}},{100,{2,1,184}},{100,{2,1,192}},{100,{2,1,200}},{100,{2,5,64}},{100,{2,5,68}},{100,{2,5,71}},{100,{2,5,74}},{100,{2,5,77}},{100,{2,5,80}},{100,{2,7,64}},{100,{2,7,68}},{100,{2,7,71}},{100,{2,7,74}},{100,{2,7,77}},{100,{2,7,80}},{100,{2,48,107}},{100,{2,48,112}},{100,{2,48,118}},{100,{2,48,123}},{100,{2,48,128}},{100,{2,48,134}},{100,{2,15,107}},{100,{2,15,112}},{100,{2,15,118}},{100,{2,15,123}},{100,{2,15,128}},{100,{2,15,134}}]',2,'[{100,{3,1,240}},{100,{3,1,248}},{100,{3,1,256}},{100,{3,1,264}},{100,{3,1,272}},{100,{3,1,280}},{100,{3,5,96}},{100,{3,5,100}},{100,{3,5,103}},{100,{3,5,106}},{100,{3,5,109}},{100,{3,5,112}},{100,{3,7,96}},{100,{3,7,100}},{100,{3,7,103}},{100,{3,7,106}},{100,{3,7,109}},{100,{3,7,112}},{100,{3,48,160}},{100,{3,48,166}},{100,{3,48,171}},{100,{3,48,176}},{100,{3,48,182}},{100,{3,48,187}},{100,{3,15,160}},{100,{3,15,166}},{100,{3,15,171}},{100,{3,15,176}},{100,{3,15,182}},{100,{3,15,187}}]',0,'[]'),(16040535,5,3,5,540040,'[{100,{3,1,280}},{100,{3,15,187}},{100,{3,7,112}}]',0,'[]',0,'[]',3,'[{100,{3,1,240}},{100,{3,1,248}},{100,{3,1,256}},{100,{3,1,264}},{100,{3,1,272}},{100,{3,1,280}},{100,{3,5,96}},{100,{3,5,100}},{100,{3,5,103}},{100,{3,5,106}},{100,{3,5,109}},{100,{3,5,112}},{100,{3,7,96}},{100,{3,7,100}},{100,{3,7,103}},{100,{3,7,106}},{100,{3,7,109}},{100,{3,7,112}},{100,{3,48,160}},{100,{3,48,166}},{100,{3,48,171}},{100,{3,48,176}},{100,{3,48,182}},{100,{3,48,187}},{100,{3,15,160}},{100,{3,15,166}},{100,{3,15,171}},{100,{3,15,176}},{100,{3,15,182}},{100,{3,15,187}}]',0,'[]'),(16040541,5,4,1,500020,'[{100,{3,1,840}},{100,{3,15,560}},{100,{3,7,336}}]',0,'[]',0,'[]',3,'[{100,{3,1,720}},{100,{3,1,744}},{100,{3,1,768}},{100,{3,1,792}},{100,{3,1,816}},{100,{3,1,840}},{100,{3,5,288}},{100,{3,5,298}},{100,{3,5,308}},{100,{3,5,317}},{100,{3,5,327}},{100,{3,5,336}},{100,{3,7,288}},{100,{3,7,298}},{100,{3,7,308}},{100,{3,7,317}},{100,{3,7,327}},{100,{3,7,336}},{100,{3,48,480}},{100,{3,48,496}},{100,{3,48,512}},{100,{3,48,528}},{100,{3,48,544}},{100,{3,48,560}},{100,{3,15,480}},{100,{3,15,496}},{100,{3,15,512}},{100,{3,15,528}},{100,{3,15,544}},{100,{3,15,560}}]',0,'[]'),(16040542,5,4,2,600050,'[{100,{3,1,840}},{100,{3,15,560}},{100,{4,7,480}}]',0,'[]',0,'[]',2,'[{100,{3,1,720}},{100,{3,1,744}},{100,{3,1,768}},{100,{3,1,792}},{100,{3,1,816}},{100,{3,1,840}},{100,{3,5,288}},{100,{3,5,298}},{100,{3,5,308}},{100,{3,5,317}},{100,{3,5,327}},{100,{3,5,336}},{100,{3,7,288}},{100,{3,7,298}},{100,{3,7,308}},{100,{3,7,317}},{100,{3,7,327}},{100,{3,7,336}},{100,{3,48,480}},{100,{3,48,496}},{100,{3,48,512}},{100,{3,48,528}},{100,{3,48,544}},{100,{3,48,560}},{100,{3,15,480}},{100,{3,15,496}},{100,{3,15,512}},{100,{3,15,528}},{100,{3,15,544}},{100,{3,15,560}}]',1,'[{100,{4,1,1200}},{100,{4,15,800}},{100,{4,7,480}}]'),(16040543,5,4,3,750030,'[{100,{3,1,840}},{100,{3,15,560}},{100,{4,7,480}}]',0,'[]',0,'[]',2,'[{100,{3,1,720}},{100,{3,1,744}},{100,{3,1,768}},{100,{3,1,792}},{100,{3,1,816}},{100,{3,1,840}},{100,{3,5,288}},{100,{3,5,298}},{100,{3,5,308}},{100,{3,5,317}},{100,{3,5,327}},{100,{3,5,336}},{100,{3,7,288}},{100,{3,7,298}},{100,{3,7,308}},{100,{3,7,317}},{100,{3,7,327}},{100,{3,7,336}},{100,{3,48,480}},{100,{3,48,496}},{100,{3,48,512}},{100,{3,48,528}},{100,{3,48,544}},{100,{3,48,560}},{100,{3,15,480}},{100,{3,15,496}},{100,{3,15,512}},{100,{3,15,528}},{100,{3,15,544}},{100,{3,15,560}}]',1,'[{100,{4,1,1200}},{100,{4,15,800}},{100,{4,7,480}}]'),(16040544,5,4,4,900060,'[{100,{3,1,840}},{100,{4,15,800}},{100,{4,7,480}}]',0,'[]',0,'[]',1,'[{100,{3,1,720}},{100,{3,1,744}},{100,{3,1,768}},{100,{3,1,792}},{100,{3,1,816}},{100,{3,1,840}},{100,{3,5,288}},{100,{3,5,298}},{100,{3,5,308}},{100,{3,5,317}},{100,{3,5,327}},{100,{3,5,336}},{100,{3,7,288}},{100,{3,7,298}},{100,{3,7,308}},{100,{3,7,317}},{100,{3,7,327}},{100,{3,7,336}},{100,{3,48,480}},{100,{3,48,496}},{100,{3,48,512}},{100,{3,48,528}},{100,{3,48,544}},{100,{3,48,560}},{100,{3,15,480}},{100,{3,15,496}},{100,{3,15,512}},{100,{3,15,528}},{100,{3,15,544}},{100,{3,15,560}}]',2,'[{100,{4,1,1200}},{100,{4,15,800}},{100,{4,7,480}}]'),(16040545,5,4,5,1100020,'[{100,{3,1,840}},{100,{4,15,800}},{100,{4,7,480}}]',0,'[]',0,'[]',1,'[{100,{3,1,720}},{100,{3,1,744}},{100,{3,1,768}},{100,{3,1,792}},{100,{3,1,816}},{100,{3,1,840}},{100,{3,5,288}},{100,{3,5,298}},{100,{3,5,308}},{100,{3,5,317}},{100,{3,5,327}},{100,{3,5,336}},{100,{3,7,288}},{100,{3,7,298}},{100,{3,7,308}},{100,{3,7,317}},{100,{3,7,327}},{100,{3,7,336}},{100,{3,48,480}},{100,{3,48,496}},{100,{3,48,512}},{100,{3,48,528}},{100,{3,48,544}},{100,{3,48,560}},{100,{3,15,480}},{100,{3,15,496}},{100,{3,15,512}},{100,{3,15,528}},{100,{3,15,544}},{100,{3,15,560}}]',2,'[{100,{4,1,1200}},{100,{4,15,800}},{100,{4,7,480}}]'),(16040551,5,5,1,550020,'[{100,{3,1,1400}},{100,{4,15,1333}},{100,{4,7,800}}]',0,'[]',0,'[]',1,'[{100,{3,1,1200}},{100,{3,1,1240}},{100,{3,1,1280}},{100,{3,1,1320}},{100,{3,1,1360}},{100,{3,1,1400}},{100,{3,5,480}},{100,{3,5,496}},{100,{3,5,512}},{100,{3,5,528}},{100,{3,5,544}},{100,{3,5,560}},{100,{3,7,480}},{100,{3,7,496}},{100,{3,7,512}},{100,{3,7,528}},{100,{3,7,544}},{100,{3,7,560}},{100,{3,48,800}},{100,{3,48,827}},{100,{3,48,854}},{100,{3,48,880}},{100,{3,48,907}},{100,{3,48,934}},{100,{3,15,800}},{100,{3,15,827}},{100,{3,15,854}},{100,{3,15,880}},{100,{3,15,907}},{100,{3,15,934}}]',2,'[{100,{4,1,2000}},{100,{4,15,1333}},{100,{4,7,800}}]'),(16040552,5,5,2,650050,'[{100,{3,1,1400}},{100,{4,15,1333}},{100,{4,7,800}}]',0,'[]',0,'[]',1,'[{100,{3,1,1200}},{100,{3,1,1240}},{100,{3,1,1280}},{100,{3,1,1320}},{100,{3,1,1360}},{100,{3,1,1400}},{100,{3,5,480}},{100,{3,5,496}},{100,{3,5,512}},{100,{3,5,528}},{100,{3,5,544}},{100,{3,5,560}},{100,{3,7,480}},{100,{3,7,496}},{100,{3,7,512}},{100,{3,7,528}},{100,{3,7,544}},{100,{3,7,560}},{100,{3,48,800}},{100,{3,48,827}},{100,{3,48,854}},{100,{3,48,880}},{100,{3,48,907}},{100,{3,48,934}},{100,{3,15,800}},{100,{3,15,827}},{100,{3,15,854}},{100,{3,15,880}},{100,{3,15,907}},{100,{3,15,934}}]',2,'[{100,{4,1,2000}},{100,{4,15,1333}},{100,{4,7,800}}]'),(16040553,5,5,3,800030,'[{100,{3,1,1400}},{100,{4,15,1333}},{100,{4,7,800}}]',0,'[]',0,'[]',1,'[{100,{3,1,1200}},{100,{3,1,1240}},{100,{3,1,1280}},{100,{3,1,1320}},{100,{3,1,1360}},{100,{3,1,1400}},{100,{3,5,480}},{100,{3,5,496}},{100,{3,5,512}},{100,{3,5,528}},{100,{3,5,544}},{100,{3,5,560}},{100,{3,7,480}},{100,{3,7,496}},{100,{3,7,512}},{100,{3,7,528}},{100,{3,7,544}},{100,{3,7,560}},{100,{3,48,800}},{100,{3,48,827}},{100,{3,48,854}},{100,{3,48,880}},{100,{3,48,907}},{100,{3,48,934}},{100,{3,15,800}},{100,{3,15,827}},{100,{3,15,854}},{100,{3,15,880}},{100,{3,15,907}},{100,{3,15,934}}]',2,'[{100,{4,1,2000}},{100,{4,15,1333}},{100,{4,7,800}}]'),(16040554,5,5,4,900060,'[{100,{4,1,2000}},{100,{4,15,1333}},{100,{4,7,800}}]',0,'[]',0,'[]',0,'[]',3,'[{100,{4,1,2000}},{100,{4,15,1333}},{100,{4,7,800}}]'),(16040555,5,5,5,1200050,'[{100,{4,1,2000}},{100,{4,15,1333}},{100,{4,7,800}}]',0,'[]',0,'[]',0,'[]',3,'[{100,{4,1,2000}},{100,{4,15,1333}},{100,{4,7,800}}]'),(16040601,6,0,1,10029,'[]',0,'[]',0,'[]',0,'[]',0,'[]'),(16040602,6,0,2,15018,'[]',0,'[]',0,'[]',0,'[]',0,'[]'),(16040603,6,0,3,20007,'[]',0,'[]',0,'[]',0,'[]',0,'[]'),(16040604,6,0,4,25046,'[]',0,'[]',0,'[]',0,'[]',0,'[]'),(16040605,6,0,5,30035,'[]',0,'[]',0,'[]',0,'[]',0,'[]'),(16040611,6,1,1,27042,'[{100,{1,2,560}}]',1,'[{100,{1,2,280}},{100,{1,2,336}},{100,{1,2,392}},{100,{1,2,448}},{100,{1,2,504}},{100,{1,2,560}},{100,{1,6,6}},{100,{1,6,7}},{100,{1,6,8}},{100,{1,6,9}},{100,{1,6,11}},{100,{1,6,12}},{100,{1,8,6}},{100,{1,8,7}},{100,{1,8,8}},{100,{1,8,9}},{100,{1,8,11}},{100,{1,8,12}},{100,{1,49,10}},{100,{1,49,12}},{100,{1,49,14}},{100,{1,49,15}},{100,{1,49,17}},{100,{1,49,19}},{100,{1,16,10}},{100,{1,16,12}},{100,{1,16,14}},{100,{1,16,15}},{100,{1,16,17}},{100,{1,16,19}}]',0,'[]',0,'[]',0,'[]'),(16040612,6,1,2,40537,'[{100,{1,2,560}}]',1,'[{100,{1,2,280}},{100,{1,2,336}},{100,{1,2,392}},{100,{1,2,448}},{100,{1,2,504}},{100,{1,2,560}},{100,{1,6,6}},{100,{1,6,7}},{100,{1,6,8}},{100,{1,6,9}},{100,{1,6,11}},{100,{1,6,12}},{100,{1,8,6}},{100,{1,8,7}},{100,{1,8,8}},{100,{1,8,9}},{100,{1,8,11}},{100,{1,8,12}},{100,{1,49,10}},{100,{1,49,12}},{100,{1,49,14}},{100,{1,49,15}},{100,{1,49,17}},{100,{1,49,19}},{100,{1,16,10}},{100,{1,16,12}},{100,{1,16,14}},{100,{1,16,15}},{100,{1,16,17}},{100,{1,16,19}}]',0,'[]',0,'[]',0,'[]'),(16040613,6,1,3,54033,'[{100,{1,2,560}},{100,{1,16,19}}]',2,'[{100,{1,2,280}},{100,{1,2,336}},{100,{1,2,392}},{100,{1,2,448}},{100,{1,2,504}},{100,{1,2,560}},{100,{1,6,6}},{100,{1,6,7}},{100,{1,6,8}},{100,{1,6,9}},{100,{1,6,11}},{100,{1,6,12}},{100,{1,8,6}},{100,{1,8,7}},{100,{1,8,8}},{100,{1,8,9}},{100,{1,8,11}},{100,{1,8,12}},{100,{1,49,10}},{100,{1,49,12}},{100,{1,49,14}},{100,{1,49,15}},{100,{1,49,17}},{100,{1,49,19}},{100,{1,16,10}},{100,{1,16,12}},{100,{1,16,14}},{100,{1,16,15}},{100,{1,16,17}},{100,{1,16,19}}]',0,'[]',0,'[]',0,'[]'),(16040614,6,1,4,67529,'[{100,{1,2,560}},{100,{1,16,19}}]',2,'[{100,{1,2,280}},{100,{1,2,336}},{100,{1,2,392}},{100,{1,2,448}},{100,{1,2,504}},{100,{1,2,560}},{100,{1,6,6}},{100,{1,6,7}},{100,{1,6,8}},{100,{1,6,9}},{100,{1,6,11}},{100,{1,6,12}},{100,{1,8,6}},{100,{1,8,7}},{100,{1,8,8}},{100,{1,8,9}},{100,{1,8,11}},{100,{1,8,12}},{100,{1,49,10}},{100,{1,49,12}},{100,{1,49,14}},{100,{1,49,15}},{100,{1,49,17}},{100,{1,49,19}},{100,{1,16,10}},{100,{1,16,12}},{100,{1,16,14}},{100,{1,16,15}},{100,{1,16,17}},{100,{1,16,19}}]',0,'[]',0,'[]',0,'[]'),(16040615,6,1,5,81024,'[{100,{1,2,560}},{100,{1,16,19}}]',2,'[{100,{1,2,280}},{100,{1,2,336}},{100,{1,2,392}},{100,{1,2,448}},{100,{1,2,504}},{100,{1,2,560}},{100,{1,6,6}},{100,{1,6,7}},{100,{1,6,8}},{100,{1,6,9}},{100,{1,6,11}},{100,{1,6,12}},{100,{1,8,6}},{100,{1,8,7}},{100,{1,8,8}},{100,{1,8,9}},{100,{1,8,11}},{100,{1,8,12}},{100,{1,49,10}},{100,{1,49,12}},{100,{1,49,14}},{100,{1,49,15}},{100,{1,49,17}},{100,{1,49,19}},{100,{1,16,10}},{100,{1,16,12}},{100,{1,16,14}},{100,{1,16,15}},{100,{1,16,17}},{100,{1,16,19}}]',0,'[]',0,'[]',0,'[]'),(16040621,6,2,1,70048,'[{100,{1,2,800}},{100,{2,16,67}}]',1,'[{100,{1,2,400}},{100,{1,2,480}},{100,{1,2,560}},{100,{1,2,640}},{100,{1,2,720}},{100,{1,2,800}},{100,{1,6,8}},{100,{1,6,10}},{100,{1,6,12}},{100,{1,6,13}},{100,{1,6,15}},{100,{1,6,16}},{100,{1,8,8}},{100,{1,8,10}},{100,{1,8,12}},{100,{1,8,13}},{100,{1,8,15}},{100,{1,8,16}},{100,{1,49,14}},{100,{1,49,16}},{100,{1,49,19}},{100,{1,49,22}},{100,{1,49,24}},{100,{1,49,27}},{100,{1,16,14}},{100,{1,16,16}},{100,{1,16,19}},{100,{1,16,22}},{100,{1,16,24}},{100,{1,16,27}}]',1,'[{100,{2,2,1600}},{100,{2,2,1680}},{100,{2,2,1760}},{100,{2,2,1840}},{100,{2,2,1920}},{100,{2,2,2000}},{100,{2,6,32}},{100,{2,6,34}},{100,{2,6,36}},{100,{2,6,37}},{100,{2,6,39}},{100,{2,6,40}},{100,{2,8,32}},{100,{2,8,34}},{100,{2,8,36}},{100,{2,8,37}},{100,{2,8,39}},{100,{2,8,40}},{100,{2,49,54}},{100,{2,49,56}},{100,{2,49,59}},{100,{2,49,62}},{100,{2,49,64}},{100,{2,49,67}},{100,{2,16,54}},{100,{2,16,56}},{100,{2,16,59}},{100,{2,16,62}},{100,{2,16,64}},{100,{2,16,67}}]',0,'[]',0,'[]'),(16040622,6,2,2,105022,'[{100,{1,2,800}},{100,{2,16,67}}]',1,'[{100,{1,2,400}},{100,{1,2,480}},{100,{1,2,560}},{100,{1,2,640}},{100,{1,2,720}},{100,{1,2,800}},{100,{1,6,8}},{100,{1,6,10}},{100,{1,6,12}},{100,{1,6,13}},{100,{1,6,15}},{100,{1,6,16}},{100,{1,8,8}},{100,{1,8,10}},{100,{1,8,12}},{100,{1,8,13}},{100,{1,8,15}},{100,{1,8,16}},{100,{1,49,14}},{100,{1,49,16}},{100,{1,49,19}},{100,{1,49,22}},{100,{1,49,24}},{100,{1,49,27}},{100,{1,16,14}},{100,{1,16,16}},{100,{1,16,19}},{100,{1,16,22}},{100,{1,16,24}},{100,{1,16,27}}]',1,'[{100,{2,2,1600}},{100,{2,2,1680}},{100,{2,2,1760}},{100,{2,2,1840}},{100,{2,2,1920}},{100,{2,2,2000}},{100,{2,6,32}},{100,{2,6,34}},{100,{2,6,36}},{100,{2,6,37}},{100,{2,6,39}},{100,{2,6,40}},{100,{2,8,32}},{100,{2,8,34}},{100,{2,8,36}},{100,{2,8,37}},{100,{2,8,39}},{100,{2,8,40}},{100,{2,49,54}},{100,{2,49,56}},{100,{2,49,59}},{100,{2,49,62}},{100,{2,49,64}},{100,{2,49,67}},{100,{2,16,54}},{100,{2,16,56}},{100,{2,16,59}},{100,{2,16,62}},{100,{2,16,64}},{100,{2,16,67}}]',0,'[]',0,'[]'),(16040623,6,2,3,140046,'[{100,{2,2,2000}},{100,{2,16,67}}]',0,'[]',2,'[{100,{2,2,1600}},{100,{2,2,1680}},{100,{2,2,1760}},{100,{2,2,1840}},{100,{2,2,1920}},{100,{2,2,2000}},{100,{2,6,32}},{100,{2,6,34}},{100,{2,6,36}},{100,{2,6,37}},{100,{2,6,39}},{100,{2,6,40}},{100,{2,8,32}},{100,{2,8,34}},{100,{2,8,36}},{100,{2,8,37}},{100,{2,8,39}},{100,{2,8,40}},{100,{2,49,54}},{100,{2,49,56}},{100,{2,49,59}},{100,{2,49,62}},{100,{2,49,64}},{100,{2,49,67}},{100,{2,16,54}},{100,{2,16,56}},{100,{2,16,59}},{100,{2,16,62}},{100,{2,16,64}},{100,{2,16,67}}]',0,'[]',0,'[]'),(16040624,6,2,4,175020,'[{100,{2,2,2000}},{100,{2,16,67}}]',0,'[]',2,'[{100,{2,2,1600}},{100,{2,2,1680}},{100,{2,2,1760}},{100,{2,2,1840}},{100,{2,2,1920}},{100,{2,2,2000}},{100,{2,6,32}},{100,{2,6,34}},{100,{2,6,36}},{100,{2,6,37}},{100,{2,6,39}},{100,{2,6,40}},{100,{2,8,32}},{100,{2,8,34}},{100,{2,8,36}},{100,{2,8,37}},{100,{2,8,39}},{100,{2,8,40}},{100,{2,49,54}},{100,{2,49,56}},{100,{2,49,59}},{100,{2,49,62}},{100,{2,49,64}},{100,{2,49,67}},{100,{2,16,54}},{100,{2,16,56}},{100,{2,16,59}},{100,{2,16,62}},{100,{2,16,64}},{100,{2,16,67}}]',0,'[]',0,'[]'),(16040625,6,2,5,210044,'[{100,{2,2,2000}},{100,{2,16,67}}]',0,'[]',2,'[{100,{2,2,1600}},{100,{2,2,1680}},{100,{2,2,1760}},{100,{2,2,1840}},{100,{2,2,1920}},{100,{2,2,2000}},{100,{2,6,32}},{100,{2,6,34}},{100,{2,6,36}},{100,{2,6,37}},{100,{2,6,39}},{100,{2,6,40}},{100,{2,8,32}},{100,{2,8,34}},{100,{2,8,36}},{100,{2,8,37}},{100,{2,8,39}},{100,{2,8,40}},{100,{2,49,54}},{100,{2,49,56}},{100,{2,49,59}},{100,{2,49,62}},{100,{2,49,64}},{100,{2,49,67}},{100,{2,16,54}},{100,{2,16,56}},{100,{2,16,59}},{100,{2,16,62}},{100,{2,16,64}},{100,{2,16,67}}]',0,'[]',0,'[]'),(16040631,6,3,1,180009,'[{100,{2,2,4000}},{100,{3,16,187}}]',0,'[]',1,'[{100,{2,2,3200}},{100,{2,2,3360}},{100,{2,2,3520}},{100,{2,2,3680}},{100,{2,2,3840}},{100,{2,2,4000}},{100,{2,6,64}},{100,{2,6,68}},{100,{2,6,71}},{100,{2,6,74}},{100,{2,6,77}},{100,{2,6,80}},{100,{2,8,64}},{100,{2,8,68}},{100,{2,8,71}},{100,{2,8,74}},{100,{2,8,77}},{100,{2,8,80}},{100,{2,49,107}},{100,{2,49,112}},{100,{2,49,118}},{100,{2,49,123}},{100,{2,49,128}},{100,{2,49,134}},{100,{2,16,107}},{100,{2,16,112}},{100,{2,16,118}},{100,{2,16,123}},{100,{2,16,128}},{100,{2,16,134}}]',1,'[{100,{3,2,4800}},{100,{3,2,4960}},{100,{3,2,5120}},{100,{3,2,5280}},{100,{3,2,5440}},{100,{3,2,5600}},{100,{3,6,96}},{100,{3,6,100}},{100,{3,6,103}},{100,{3,6,106}},{100,{3,6,109}},{100,{3,6,112}},{100,{3,8,96}},{100,{3,8,100}},{100,{3,8,103}},{100,{3,8,106}},{100,{3,8,109}},{100,{3,8,112}},{100,{3,49,160}},{100,{3,49,166}},{100,{3,49,171}},{100,{3,49,176}},{100,{3,49,182}},{100,{3,49,187}},{100,{3,16,160}},{100,{3,16,166}},{100,{3,16,171}},{100,{3,16,176}},{100,{3,16,182}},{100,{3,16,187}}]',0,'[]'),(16040632,6,3,2,270014,'[{100,{2,2,4000}},{100,{3,16,187}}]',0,'[]',1,'[{100,{2,2,3200}},{100,{2,2,3360}},{100,{2,2,3520}},{100,{2,2,3680}},{100,{2,2,3840}},{100,{2,2,4000}},{100,{2,6,64}},{100,{2,6,68}},{100,{2,6,71}},{100,{2,6,74}},{100,{2,6,77}},{100,{2,6,80}},{100,{2,8,64}},{100,{2,8,68}},{100,{2,8,71}},{100,{2,8,74}},{100,{2,8,77}},{100,{2,8,80}},{100,{2,49,107}},{100,{2,49,112}},{100,{2,49,118}},{100,{2,49,123}},{100,{2,49,128}},{100,{2,49,134}},{100,{2,16,107}},{100,{2,16,112}},{100,{2,16,118}},{100,{2,16,123}},{100,{2,16,128}},{100,{2,16,134}}]',1,'[{100,{3,2,4800}},{100,{3,2,4960}},{100,{3,2,5120}},{100,{3,2,5280}},{100,{3,2,5440}},{100,{3,2,5600}},{100,{3,6,96}},{100,{3,6,100}},{100,{3,6,103}},{100,{3,6,106}},{100,{3,6,109}},{100,{3,6,112}},{100,{3,8,96}},{100,{3,8,100}},{100,{3,8,103}},{100,{3,8,106}},{100,{3,8,109}},{100,{3,8,112}},{100,{3,49,160}},{100,{3,49,166}},{100,{3,49,171}},{100,{3,49,176}},{100,{3,49,182}},{100,{3,49,187}},{100,{3,16,160}},{100,{3,16,166}},{100,{3,16,171}},{100,{3,16,176}},{100,{3,16,182}},{100,{3,16,187}}]',0,'[]'),(16040633,6,3,3,360018,'[{100,{3,2,5600}},{100,{3,16,187}}]',0,'[]',0,'[]',2,'[{100,{3,2,4800}},{100,{3,2,4960}},{100,{3,2,5120}},{100,{3,2,5280}},{100,{3,2,5440}},{100,{3,2,5600}},{100,{3,6,96}},{100,{3,6,100}},{100,{3,6,103}},{100,{3,6,106}},{100,{3,6,109}},{100,{3,6,112}},{100,{3,8,96}},{100,{3,8,100}},{100,{3,8,103}},{100,{3,8,106}},{100,{3,8,109}},{100,{3,8,112}},{100,{3,49,160}},{100,{3,49,166}},{100,{3,49,171}},{100,{3,49,176}},{100,{3,49,182}},{100,{3,49,187}},{100,{3,16,160}},{100,{3,16,166}},{100,{3,16,171}},{100,{3,16,176}},{100,{3,16,182}},{100,{3,16,187}}]',0,'[]'),(16040634,6,3,4,450022,'[{100,{3,2,5600}},{100,{3,16,187}},{100,{2,8,80}}]',0,'[]',1,'[{100,{2,2,3200}},{100,{2,2,3360}},{100,{2,2,3520}},{100,{2,2,3680}},{100,{2,2,3840}},{100,{2,2,4000}},{100,{2,6,64}},{100,{2,6,68}},{100,{2,6,71}},{100,{2,6,74}},{100,{2,6,77}},{100,{2,6,80}},{100,{2,8,64}},{100,{2,8,68}},{100,{2,8,71}},{100,{2,8,74}},{100,{2,8,77}},{100,{2,8,80}},{100,{2,49,107}},{100,{2,49,112}},{100,{2,49,118}},{100,{2,49,123}},{100,{2,49,128}},{100,{2,49,134}},{100,{2,16,107}},{100,{2,16,112}},{100,{2,16,118}},{100,{2,16,123}},{100,{2,16,128}},{100,{2,16,134}}]',2,'[{100,{3,2,4800}},{100,{3,2,4960}},{100,{3,2,5120}},{100,{3,2,5280}},{100,{3,2,5440}},{100,{3,2,5600}},{100,{3,6,96}},{100,{3,6,100}},{100,{3,6,103}},{100,{3,6,106}},{100,{3,6,109}},{100,{3,6,112}},{100,{3,8,96}},{100,{3,8,100}},{100,{3,8,103}},{100,{3,8,106}},{100,{3,8,109}},{100,{3,8,112}},{100,{3,49,160}},{100,{3,49,166}},{100,{3,49,171}},{100,{3,49,176}},{100,{3,49,182}},{100,{3,49,187}},{100,{3,16,160}},{100,{3,16,166}},{100,{3,16,171}},{100,{3,16,176}},{100,{3,16,182}},{100,{3,16,187}}]',0,'[]'),(16040635,6,3,5,540027,'[{100,{3,2,5600}},{100,{3,16,187}},{100,{3,8,112}}]',0,'[]',0,'[]',3,'[{100,{3,2,4800}},{100,{3,2,4960}},{100,{3,2,5120}},{100,{3,2,5280}},{100,{3,2,5440}},{100,{3,2,5600}},{100,{3,6,96}},{100,{3,6,100}},{100,{3,6,103}},{100,{3,6,106}},{100,{3,6,109}},{100,{3,6,112}},{100,{3,8,96}},{100,{3,8,100}},{100,{3,8,103}},{100,{3,8,106}},{100,{3,8,109}},{100,{3,8,112}},{100,{3,49,160}},{100,{3,49,166}},{100,{3,49,171}},{100,{3,49,176}},{100,{3,49,182}},{100,{3,49,187}},{100,{3,16,160}},{100,{3,16,166}},{100,{3,16,171}},{100,{3,16,176}},{100,{3,16,182}},{100,{3,16,187}}]',0,'[]'),(16040641,6,4,1,500013,'[{100,{3,2,16800}},{100,{3,16,560}},{100,{3,8,336}}]',0,'[]',0,'[]',3,'[{100,{3,2,14400}},{100,{3,2,14880}},{100,{3,2,15360}},{100,{3,2,15840}},{100,{3,2,16320}},{100,{3,2,16800}},{100,{3,6,288}},{100,{3,6,298}},{100,{3,6,308}},{100,{3,6,317}},{100,{3,6,327}},{100,{3,6,336}},{100,{3,8,288}},{100,{3,8,298}},{100,{3,8,308}},{100,{3,8,317}},{100,{3,8,327}},{100,{3,8,336}},{100,{3,49,480}},{100,{3,49,496}},{100,{3,49,512}},{100,{3,49,528}},{100,{3,49,544}},{100,{3,49,560}},{100,{3,16,480}},{100,{3,16,496}},{100,{3,16,512}},{100,{3,16,528}},{100,{3,16,544}},{100,{3,16,560}}]',0,'[]'),(16040642,6,4,2,600046,'[{100,{3,2,16800}},{100,{3,16,560}},{100,{4,8,480}}]',0,'[]',0,'[]',2,'[{100,{3,2,14400}},{100,{3,2,14880}},{100,{3,2,15360}},{100,{3,2,15840}},{100,{3,2,16320}},{100,{3,2,16800}},{100,{3,6,288}},{100,{3,6,298}},{100,{3,6,308}},{100,{3,6,317}},{100,{3,6,327}},{100,{3,6,336}},{100,{3,8,288}},{100,{3,8,298}},{100,{3,8,308}},{100,{3,8,317}},{100,{3,8,327}},{100,{3,8,336}},{100,{3,49,480}},{100,{3,49,496}},{100,{3,49,512}},{100,{3,49,528}},{100,{3,49,544}},{100,{3,49,560}},{100,{3,16,480}},{100,{3,16,496}},{100,{3,16,512}},{100,{3,16,528}},{100,{3,16,544}},{100,{3,16,560}}]',1,'[{100,{4,2,24000}},{100,{4,16,800}},{100,{4,8,480}}]'),(16040643,6,4,3,750020,'[{100,{3,2,16800}},{100,{3,16,560}},{100,{4,8,480}}]',0,'[]',0,'[]',2,'[{100,{3,2,14400}},{100,{3,2,14880}},{100,{3,2,15360}},{100,{3,2,15840}},{100,{3,2,16320}},{100,{3,2,16800}},{100,{3,6,288}},{100,{3,6,298}},{100,{3,6,308}},{100,{3,6,317}},{100,{3,6,327}},{100,{3,6,336}},{100,{3,8,288}},{100,{3,8,298}},{100,{3,8,308}},{100,{3,8,317}},{100,{3,8,327}},{100,{3,8,336}},{100,{3,49,480}},{100,{3,49,496}},{100,{3,49,512}},{100,{3,49,528}},{100,{3,49,544}},{100,{3,49,560}},{100,{3,16,480}},{100,{3,16,496}},{100,{3,16,512}},{100,{3,16,528}},{100,{3,16,544}},{100,{3,16,560}}]',1,'[{100,{4,2,24000}},{100,{4,16,800}},{100,{4,8,480}}]'),(16040644,6,4,4,900044,'[{100,{3,2,16800}},{100,{4,16,800}},{100,{4,8,480}}]',0,'[]',0,'[]',1,'[{100,{3,2,14400}},{100,{3,2,14880}},{100,{3,2,15360}},{100,{3,2,15840}},{100,{3,2,16320}},{100,{3,2,16800}},{100,{3,6,288}},{100,{3,6,298}},{100,{3,6,308}},{100,{3,6,317}},{100,{3,6,327}},{100,{3,6,336}},{100,{3,8,288}},{100,{3,8,298}},{100,{3,8,308}},{100,{3,8,317}},{100,{3,8,327}},{100,{3,8,336}},{100,{3,49,480}},{100,{3,49,496}},{100,{3,49,512}},{100,{3,49,528}},{100,{3,49,544}},{100,{3,49,560}},{100,{3,16,480}},{100,{3,16,496}},{100,{3,16,512}},{100,{3,16,528}},{100,{3,16,544}},{100,{3,16,560}}]',2,'[{100,{4,2,24000}},{100,{4,16,800}},{100,{4,8,480}}]'),(16040645,6,4,5,1100009,'[{100,{3,2,16800}},{100,{4,16,800}},{100,{4,8,480}}]',0,'[]',0,'[]',1,'[{100,{3,2,14400}},{100,{3,2,14880}},{100,{3,2,15360}},{100,{3,2,15840}},{100,{3,2,16320}},{100,{3,2,16800}},{100,{3,6,288}},{100,{3,6,298}},{100,{3,6,308}},{100,{3,6,317}},{100,{3,6,327}},{100,{3,6,336}},{100,{3,8,288}},{100,{3,8,298}},{100,{3,8,308}},{100,{3,8,317}},{100,{3,8,327}},{100,{3,8,336}},{100,{3,49,480}},{100,{3,49,496}},{100,{3,49,512}},{100,{3,49,528}},{100,{3,49,544}},{100,{3,49,560}},{100,{3,16,480}},{100,{3,16,496}},{100,{3,16,512}},{100,{3,16,528}},{100,{3,16,544}},{100,{3,16,560}}]',2,'[{100,{4,2,24000}},{100,{4,16,800}},{100,{4,8,480}}]'),(16040651,6,5,1,550005,'[{100,{3,2,28000}},{100,{4,16,1333}},{100,{4,8,800}}]',0,'[]',0,'[]',1,'[{100,{3,2,24000}},{100,{3,2,24800}},{100,{3,2,25600}},{100,{3,2,26400}},{100,{3,2,27200}},{100,{3,2,28000}},{100,{3,6,480}},{100,{3,6,496}},{100,{3,6,512}},{100,{3,6,528}},{100,{3,6,544}},{100,{3,6,560}},{100,{3,8,480}},{100,{3,8,496}},{100,{3,8,512}},{100,{3,8,528}},{100,{3,8,544}},{100,{3,8,560}},{100,{3,49,800}},{100,{3,49,827}},{100,{3,49,854}},{100,{3,49,880}},{100,{3,49,907}},{100,{3,49,934}},{100,{3,16,800}},{100,{3,16,827}},{100,{3,16,854}},{100,{3,16,880}},{100,{3,16,907}},{100,{3,16,934}}]',2,'[{100,{4,2,40000}},{100,{4,16,1333}},{100,{4,8,800}}]'),(16040652,6,5,2,650037,'[{100,{3,2,28000}},{100,{4,16,1333}},{100,{4,8,800}}]',0,'[]',0,'[]',1,'[{100,{3,2,24000}},{100,{3,2,24800}},{100,{3,2,25600}},{100,{3,2,26400}},{100,{3,2,27200}},{100,{3,2,28000}},{100,{3,6,480}},{100,{3,6,496}},{100,{3,6,512}},{100,{3,6,528}},{100,{3,6,544}},{100,{3,6,560}},{100,{3,8,480}},{100,{3,8,496}},{100,{3,8,512}},{100,{3,8,528}},{100,{3,8,544}},{100,{3,8,560}},{100,{3,49,800}},{100,{3,49,827}},{100,{3,49,854}},{100,{3,49,880}},{100,{3,49,907}},{100,{3,49,934}},{100,{3,16,800}},{100,{3,16,827}},{100,{3,16,854}},{100,{3,16,880}},{100,{3,16,907}},{100,{3,16,934}}]',2,'[{100,{4,2,40000}},{100,{4,16,1333}},{100,{4,8,800}}]'),(16040653,6,5,3,800011,'[{100,{3,2,28000}},{100,{4,16,1333}},{100,{4,8,800}}]',0,'[]',0,'[]',1,'[{100,{3,2,24000}},{100,{3,2,24800}},{100,{3,2,25600}},{100,{3,2,26400}},{100,{3,2,27200}},{100,{3,2,28000}},{100,{3,6,480}},{100,{3,6,496}},{100,{3,6,512}},{100,{3,6,528}},{100,{3,6,544}},{100,{3,6,560}},{100,{3,8,480}},{100,{3,8,496}},{100,{3,8,512}},{100,{3,8,528}},{100,{3,8,544}},{100,{3,8,560}},{100,{3,49,800}},{100,{3,49,827}},{100,{3,49,854}},{100,{3,49,880}},{100,{3,49,907}},{100,{3,49,934}},{100,{3,16,800}},{100,{3,16,827}},{100,{3,16,854}},{100,{3,16,880}},{100,{3,16,907}},{100,{3,16,934}}]',2,'[{100,{4,2,40000}},{100,{4,16,1333}},{100,{4,8,800}}]'),(16040654,6,5,4,900044,'[{100,{4,2,40000}},{100,{4,16,1333}},{100,{4,8,800}}]',0,'[]',0,'[]',0,'[]',3,'[{100,{4,2,40000}},{100,{4,16,1333}},{100,{4,8,800}}]'),(16040655,6,5,5,1200042,'[{100,{4,2,40000}},{100,{4,16,1333}},{100,{4,8,800}}]',0,'[]',0,'[]',0,'[]',3,'[{100,{4,2,40000}},{100,{4,16,1333}},{100,{4,8,800}}]');
/*!40000 ALTER TABLE `base_mount_equip_attr` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_mount_equip_bag`
--

DROP TABLE IF EXISTS `base_mount_equip_bag`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_mount_equip_bag` (
  `equip_type` tinyint(3) unsigned NOT NULL COMMENT '装备类型',
  `stage` tinyint(3) unsigned NOT NULL COMMENT '最小阶数',
  `star` tinyint(3) unsigned NOT NULL COMMENT '最小星数',
  `pos_name` varchar(255) NOT NULL DEFAULT '[]' COMMENT '部位名@lang@',
  PRIMARY KEY (`equip_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='坐骑装备格子配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_mount_equip_bag`
--

LOCK TABLES `base_mount_equip_bag` WRITE;
/*!40000 ALTER TABLE `base_mount_equip_bag` DISABLE KEYS */;
INSERT INTO `base_mount_equip_bag` VALUES (1,1,2,'兽灵面铠'),(2,2,1,'兽灵刃爪'),(3,3,1,'兽灵挂饰'),(4,5,1,'兽灵刻痕'),(5,7,1,'兽灵符文'),(6,8,1,'兽灵坐鞍');
/*!40000 ALTER TABLE `base_mount_equip_bag` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_mount_equip_lv`
--

DROP TABLE IF EXISTS `base_mount_equip_lv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_mount_equip_lv` (
  `pos` tinyint(3) unsigned NOT NULL COMMENT '装备位置',
  `lv` smallint(5) unsigned NOT NULL COMMENT '等级',
  `exp` int(11) unsigned NOT NULL COMMENT '升级需要的经验',
  `attr` varchar(255) NOT NULL COMMENT '属性',
  `combat` int(11) unsigned NOT NULL COMMENT '战力',
  `cost` varchar(255) NOT NULL COMMENT '升级消耗',
  `smelt` varchar(255) NOT NULL COMMENT '熔炼返还',
  PRIMARY KEY (`pos`,`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='坐骑装备等级配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_mount_equip_lv`
--

LOCK TABLES `base_mount_equip_lv` WRITE;
/*!40000 ALTER TABLE `base_mount_equip_lv` DISABLE KEYS */;
INSERT INTO `base_mount_equip_lv` VALUES (1,1,9,'[{1,5},{3,7}]',275,'[{16050001,1,3}]','[{100,[{16050001,0}]}]'),(1,2,9,'[{1,10},{3,14}]',550,'[{16050001,1,3}]','[{100,[{16050001,3}]}]'),(1,3,12,'[{1,15},{3,22}]',850,'[{16050001,1,3}]','[{100,[{16050001,6}]}]'),(1,4,12,'[{1,20},{3,30}]',1150,'[{16050001,1,3}]','[{100,[{16050001,10}]}]'),(1,5,12,'[{1,25},{3,37}]',1425,'[{16050001,1,3}]','[{100,[{16050001,14}]}]'),(1,6,15,'[{1,30},{3,45}]',1725,'[{16050001,1,3}]','[{100,[{16050001,18}]}]'),(1,7,15,'[{1,36},{3,54}]',2070,'[{16050001,1,3}]','[{100,[{16050001,23}]}]'),(1,8,15,'[{1,43},{3,64}]',2460,'[{16050001,1,3}]','[{100,[{16050001,28}]}]'),(1,9,18,'[{1,49},{3,73}]',2805,'[{16050001,1,3}]','[{100,[{16050001,33}]}]'),(1,10,18,'[{1,55},{3,82}]',3150,'[{16050001,1,3}]','[{100,[{16050001,39}]}]'),(1,11,18,'[{1,61},{3,91}]',3495,'[{16050001,1,3}]','[{100,[{16050001,45}]}]'),(1,12,21,'[{1,68},{3,102}]',3910,'[{16050001,1,3}]','[{100,[{16050001,51}]}]'),(1,13,21,'[{1,75},{3,113}]',4325,'[{16050001,1,3}]','[{100,[{16050001,58}]}]'),(1,14,21,'[{1,82},{3,123}]',4715,'[{16050001,1,3}]','[{100,[{16050001,65}]}]'),(1,15,24,'[{1,90},{3,134}]',5150,'[{16050001,1,3}]','[{100,[{16050001,72}]}]'),(1,16,24,'[{1,97},{3,145}]',5565,'[{16050001,2,6}]','[{100,[{16050001,80}]}]'),(1,17,24,'[{1,105},{3,157}]',6025,'[{16050001,2,6}]','[{100,[{16050001,88}]}]'),(1,18,30,'[{1,113},{3,170}]',6510,'[{16050001,2,6}]','[{100,[{16050001,96}]}]'),(1,19,30,'[{1,121},{3,182}]',6970,'[{16050001,2,6}]','[{100,[{16050001,106}]}]'),(1,20,30,'[{1,130},{3,194}]',7450,'[{16050001,2,6}]','[{100,[{16050001,116}]}]'),(1,21,30,'[{1,138},{3,207}]',7935,'[{16050001,2,6}]','[{100,[{16050001,126}]}]'),(1,22,30,'[{1,147},{3,220}]',8440,'[{16050001,2,6}]','[{100,[{16050001,136}]}]'),(1,23,30,'[{1,156},{3,234}]',8970,'[{16050001,2,6}]','[{100,[{16050001,146}]}]'),(1,24,36,'[{1,166},{3,248}]',9520,'[{16050001,2,6}]','[{100,[{16050001,156}]}]'),(1,25,36,'[{1,175},{3,262}]',10050,'[{16050001,2,6}]','[{100,[{16050001,168}]}]'),(1,26,36,'[{1,184},{3,276}]',10580,'[{16050001,2,6}]','[{100,[{16050001,180}]}]'),(1,27,36,'[{1,194},{3,291}]',11155,'[{16050001,2,6}]','[{100,[{16050001,192}]}]'),(1,28,36,'[{1,204},{3,306}]',11730,'[{16050001,2,6}]','[{100,[{16050001,204}]}]'),(1,29,36,'[{1,215},{3,322}]',12350,'[{16050001,2,6}]','[{100,[{16050001,216}]}]'),(1,30,42,'[{1,225},{3,337}]',12925,'[{16050001,2,6}]','[{100,[{16050001,228}]}]'),(1,31,42,'[{1,235},{3,353}]',13525,'[{16050001,2,6}]','[{100,[{16050001,242}]}]'),(1,32,42,'[{1,246},{3,369}]',14145,'[{16050001,2,6}]','[{100,[{16050001,256}]}]'),(1,33,42,'[{1,258},{3,386}]',14810,'[{16050001,2,6}]','[{100,[{16050001,270}]}]'),(1,34,42,'[{1,269},{3,403}]',15455,'[{16050001,2,6}]','[{100,[{16050001,284}]}]'),(1,35,42,'[{1,280},{3,420}]',16100,'[{16050001,2,6}]','[{100,[{16050001,298}]}]'),(1,36,48,'[{1,292},{3,437}]',16765,'[{16050001,2,6}]','[{100,[{16050001,312}]}]'),(1,37,48,'[{1,304},{3,456}]',17480,'[{16050001,2,6}]','[{100,[{16050001,328}]}]'),(1,38,48,'[{1,316},{3,474}]',18170,'[{16050001,2,6}]','[{100,[{16050001,344}]}]'),(1,39,48,'[{1,328},{3,492}]',18860,'[{16050001,2,6}]','[{100,[{16050001,360}]}]'),(1,40,48,'[{1,341},{3,511}]',19595,'[{16050001,2,6}]','[{100,[{16050001,376}]}]'),(1,41,48,'[{1,353},{3,529}]',20285,'[{16050001,2,6}]','[{100,[{16050001,392}]}]'),(1,42,54,'[{1,366},{3,549}]',21045,'[{16050001,2,6}]','[{100,[{16050001,408}]}]'),(1,43,54,'[{1,380},{3,569}]',21825,'[{16050001,2,6}]','[{100,[{16050001,426}]}]'),(1,44,54,'[{1,393},{3,589}]',22585,'[{16050001,2,6}]','[{100,[{16050001,444}]}]'),(1,45,54,'[{1,406},{3,609}]',23345,'[{16050001,2,6}]','[{100,[{16050001,462}]}]'),(1,46,54,'[{1,420},{3,629}]',24125,'[{16050001,2,6}]','[{100,[{16050001,480}]}]'),(1,47,54,'[{1,434},{3,651}]',24955,'[{16050001,2,6}]','[{100,[{16050001,498}]}]'),(1,48,60,'[{1,448},{3,672}]',25760,'[{16050001,2,6}]','[{100,[{16050001,516}]}]'),(1,49,60,'[{1,463},{3,694}]',26610,'[{16050001,2,6}]','[{100,[{16050001,536}]}]'),(1,50,60,'[{1,477},{3,715}]',27415,'[{16050001,2,6}]','[{100,[{16050001,556}]}]'),(1,51,60,'[{1,491},{3,737}]',28245,'[{16050001,2,6}]','[{100,[{16050001,576}]}]'),(1,52,60,'[{1,507},{3,760}]',29140,'[{16050001,2,6}]','[{100,[{16050001,596}]}]'),(1,53,60,'[{1,522},{3,783}]',30015,'[{16050001,2,6}]','[{100,[{16050001,616}]}]'),(1,54,66,'[{1,538},{3,806}]',30910,'[{16050001,2,6}]','[{100,[{16050001,636}]}]'),(1,55,66,'[{1,553},{3,829}]',31785,'[{16050001,2,6}]','[{100,[{16050001,658}]}]'),(1,56,66,'[{1,568},{3,852}]',32660,'[{16050001,2,6}]','[{100,[{16050001,680}]}]'),(1,57,66,'[{1,585},{3,877}]',33625,'[{16050001,2,6}]','[{100,[{16050001,702}]}]'),(1,58,66,'[{1,601},{3,901}]',34545,'[{16050001,2,6}]','[{100,[{16050001,724}]}]'),(1,59,66,'[{1,617},{3,926}]',35490,'[{16050001,2,6}]','[{100,[{16050001,746}]}]'),(1,60,72,'[{1,634},{3,951}]',36455,'[{16050001,2,6}]','[{100,[{16050001,768}]}]'),(1,61,72,'[{1,650},{3,975}]',37375,'[{16050001,2,6}]','[{100,[{16050001,792}]}]'),(1,62,72,'[{1,668},{3,1001}]',38385,'[{16050001,2,6}]','[{100,[{16050001,816}]}]'),(1,63,72,'[{1,685},{3,1027}]',39375,'[{16050001,2,6}]','[{100,[{16050001,840}]}]'),(1,64,72,'[{1,703},{3,1054}]',40410,'[{16050001,2,6}]','[{100,[{16050001,864}]}]'),(1,65,72,'[{1,720},{3,1080}]',41400,'[{16050001,2,6}]','[{100,[{16050001,888}]}]'),(1,66,78,'[{1,737},{3,1106}]',42390,'[{16050001,2,6}]','[{100,[{16050001,912}]}]'),(1,67,78,'[{1,756},{3,1134}]',43470,'[{16050001,2,6}]','[{100,[{16050001,938}]}]'),(1,68,78,'[{1,774},{3,1161}]',44505,'[{16050001,2,6}]','[{100,[{16050001,964}]}]'),(1,69,78,'[{1,793},{3,1189}]',45585,'[{16050001,2,6}]','[{100,[{16050001,990}]}]'),(1,70,78,'[{1,811},{3,1217}]',46645,'[{16050001,2,6}]','[{100,[{16050001,1016}]}]'),(1,71,78,'[{1,830},{3,1244}]',47700,'[{16050001,2,6}]','[{100,[{16050001,1042}]}]'),(1,72,84,'[{1,849},{3,1273}]',48805,'[{16050001,2,6}]','[{100,[{16050001,1068}]}]'),(1,73,84,'[{1,869},{3,1303}]',49955,'[{16050001,2,6}]','[{100,[{16050001,1096}]}]'),(1,74,84,'[{1,888},{3,1332}]',51060,'[{16050001,2,6}]','[{100,[{16050001,1124}]}]'),(1,75,84,'[{1,908},{3,1361}]',52185,'[{16050001,2,6}]','[{100,[{16050001,1152}]}]'),(1,76,84,'[{1,927},{3,1390}]',53290,'[{16050001,2,6}]','[{100,[{16050001,1180}]}]'),(1,77,84,'[{1,948},{3,1421}]',54485,'[{16050001,2,6}]','[{100,[{16050001,1208}]}]'),(1,78,90,'[{1,968},{3,1452}]',55660,'[{16050001,2,6}]','[{100,[{16050001,1236}]}]'),(1,79,90,'[{1,989},{3,1483}]',56855,'[{16050001,2,6}]','[{100,[{16050001,1266}]}]'),(1,80,90,'[{1,1009},{3,1513}]',58005,'[{16050001,2,6}]','[{100,[{16050001,1296}]}]'),(1,81,90,'[{1,1030},{3,1544}]',59200,'[{16050001,2,6}]','[{100,[{16050001,1326}]}]'),(1,82,90,'[{1,1051},{3,1576}]',60420,'[{16050001,2,6}]','[{100,[{16050001,1356}]}]'),(1,83,90,'[{1,1073},{3,1609}]',61685,'[{16050001,2,6}]','[{100,[{16050001,1386}]}]'),(1,84,96,'[{1,1094},{3,1641}]',62905,'[{16050001,2,6}]','[{100,[{16050001,1416}]}]'),(1,85,96,'[{1,1116},{3,1673}]',64145,'[{16050001,2,6}]','[{100,[{16050001,1448}]}]'),(1,86,96,'[{1,1137},{3,1705}]',65365,'[{16050001,2,6}]','[{100,[{16050001,1480}]}]'),(1,87,96,'[{1,1160},{3,1739}]',66675,'[{16050001,2,6}]','[{100,[{16050001,1512}]}]'),(1,88,96,'[{1,1182},{3,1773}]',67965,'[{16050001,2,6}]','[{100,[{16050001,1544}]}]'),(1,89,96,'[{1,1205},{3,1807}]',69275,'[{16050001,2,6}]','[{100,[{16050001,1576}]}]'),(1,90,102,'[{1,1227},{3,1841}]',70565,'[{16050001,2,6}]','[{100,[{16050001,1608}]}]'),(1,91,102,'[{1,1250},{3,1875}]',71875,'[{16050001,2,6}]','[{100,[{16050001,1642}]}]'),(1,92,102,'[{1,1273},{3,1910}]',73210,'[{16050001,2,6}]','[{100,[{16050001,1676}]}]'),(1,93,102,'[{1,1297},{3,1945}]',74565,'[{16050001,2,6}]','[{100,[{16050001,1710}]}]'),(1,94,102,'[{1,1321},{3,1981}]',75945,'[{16050001,2,6}]','[{100,[{16050001,1744}]}]'),(1,95,102,'[{1,1344},{3,2016}]',77280,'[{16050001,2,6}]','[{100,[{16050001,1778}]}]'),(1,96,108,'[{1,1368},{3,2051}]',78635,'[{16050001,2,6}]','[{100,[{16050001,1812}]}]'),(1,97,108,'[{1,1392},{3,2088}]',80040,'[{16050001,2,6}]','[{100,[{16050001,1848}]}]'),(1,98,108,'[{1,1417},{3,2125}]',81465,'[{16050001,2,6}]','[{100,[{16050001,1884}]}]'),(1,99,108,'[{1,1442},{3,2162}]',82890,'[{16050001,2,6}]','[{100,[{16050001,1920}]}]'),(1,100,108,'[{1,1466},{3,2199}]',84295,'[{16050001,2,6}]','[{100,[{16050001,1956}]}]'),(1,101,108,'[{1,1491},{3,2236}]',85720,'[{16050001,3,9}]','[{100,[{16050001,1992}]}]'),(1,102,117,'[{1,1516},{3,2274}]',87170,'[{16050001,3,9}]','[{100,[{16050001,2028}]}]'),(1,103,117,'[{1,1542},{3,2313}]',88665,'[{16050001,3,9}]','[{100,[{16050001,2067}]}]'),(1,104,117,'[{1,1568},{3,2351}]',90135,'[{16050001,3,9}]','[{100,[{16050001,2106}]}]'),(1,105,117,'[{1,1593},{3,2390}]',91610,'[{16050001,3,9}]','[{100,[{16050001,2145}]}]'),(1,106,117,'[{1,1619},{3,2428}]',93080,'[{16050001,3,9}]','[{100,[{16050001,2184}]}]'),(1,107,117,'[{1,1645},{3,2468}]',94600,'[{16050001,3,9}]','[{100,[{16050001,2223}]}]'),(1,108,117,'[{1,1672},{3,2508}]',96140,'[{16050001,3,9}]','[{100,[{16050001,2262}]}]'),(1,109,117,'[{1,1699},{3,2548}]',97680,'[{16050001,3,9}]','[{100,[{16050001,2301}]}]'),(1,110,117,'[{1,1725},{3,2588}]',99200,'[{16050001,3,9}]','[{100,[{16050001,2340}]}]'),(1,111,126,'[{1,1752},{3,2628}]',100740,'[{16050001,3,9}]','[{100,[{16050001,2379}]}]'),(1,112,126,'[{1,1780},{3,2669}]',102325,'[{16050001,3,9}]','[{100,[{16050001,2421}]}]'),(1,113,126,'[{1,1807},{3,2711}]',103915,'[{16050001,3,9}]','[{100,[{16050001,2463}]}]'),(1,114,126,'[{1,1835},{3,2752}]',105500,'[{16050001,3,9}]','[{100,[{16050001,2505}]}]'),(1,115,126,'[{1,1863},{3,2794}]',107110,'[{16050001,3,9}]','[{100,[{16050001,2547}]}]'),(1,116,126,'[{1,1890},{3,2835}]',108675,'[{16050001,3,9}]','[{100,[{16050001,2589}]}]'),(1,117,126,'[{1,1919},{3,2878}]',110330,'[{16050001,3,9}]','[{100,[{16050001,2631}]}]'),(1,118,126,'[{1,1948},{3,2921}]',111985,'[{16050001,3,9}]','[{100,[{16050001,2673}]}]'),(1,119,126,'[{1,1977},{3,2965}]',113665,'[{16050001,3,9}]','[{100,[{16050001,2715}]}]'),(1,120,135,'[{1,2005},{3,3008}]',115300,'[{16050001,3,9}]','[{100,[{16050001,2757}]}]'),(1,121,135,'[{1,2034},{3,3051}]',116955,'[{16050001,3,9}]','[{100,[{16050001,2802}]}]'),(1,122,135,'[{1,2064},{3,3095}]',118655,'[{16050001,3,9}]','[{100,[{16050001,2847}]}]'),(1,123,135,'[{1,2093},{3,3140}]',120360,'[{16050001,3,9}]','[{100,[{16050001,2892}]}]'),(1,124,135,'[{1,2123},{3,3184}]',122060,'[{16050001,3,9}]','[{100,[{16050001,2937}]}]'),(1,125,135,'[{1,2153},{3,3229}]',123785,'[{16050001,3,9}]','[{100,[{16050001,2982}]}]'),(1,126,135,'[{1,2183},{3,3274}]',125510,'[{16050001,3,9}]','[{100,[{16050001,3027}]}]'),(1,127,135,'[{1,2213},{3,3320}]',127260,'[{16050001,3,9}]','[{100,[{16050001,3072}]}]'),(1,128,135,'[{1,2244},{3,3366}]',129030,'[{16050001,3,9}]','[{100,[{16050001,3117}]}]'),(1,129,144,'[{1,2275},{3,3412}]',130800,'[{16050001,3,9}]','[{100,[{16050001,3162}]}]'),(1,130,144,'[{1,2306},{3,3458}]',132570,'[{16050001,3,9}]','[{100,[{16050001,3210}]}]'),(1,131,144,'[{1,2336},{3,3504}]',134320,'[{16050001,3,9}]','[{100,[{16050001,3258}]}]'),(1,132,144,'[{1,2368},{3,3552}]',136160,'[{16050001,3,9}]','[{100,[{16050001,3306}]}]'),(1,133,144,'[{1,2400},{3,3599}]',137975,'[{16050001,3,9}]','[{100,[{16050001,3354}]}]'),(1,134,144,'[{1,2432},{3,3647}]',139815,'[{16050001,3,9}]','[{100,[{16050001,3402}]}]'),(1,135,144,'[{1,2463},{3,3695}]',141635,'[{16050001,3,9}]','[{100,[{16050001,3450}]}]'),(1,136,144,'[{1,2495},{3,3742}]',143450,'[{16050001,3,9}]','[{100,[{16050001,3498}]}]'),(1,137,144,'[{1,2528},{3,3792}]',145360,'[{16050001,3,9}]','[{100,[{16050001,3546}]}]'),(1,138,153,'[{1,2561},{3,3841}]',147245,'[{16050001,3,9}]','[{100,[{16050001,3594}]}]'),(1,139,153,'[{1,2594},{3,3890}]',149130,'[{16050001,3,9}]','[{100,[{16050001,3645}]}]'),(1,140,153,'[{1,2626},{3,3939}]',150995,'[{16050001,3,9}]','[{100,[{16050001,3696}]}]'),(1,141,153,'[{1,2659},{3,3988}]',152880,'[{16050001,3,9}]','[{100,[{16050001,3747}]}]'),(1,142,153,'[{1,2693},{3,4039}]',154835,'[{16050001,3,9}]','[{100,[{16050001,3798}]}]'),(1,143,153,'[{1,2727},{3,4090}]',156790,'[{16050001,3,9}]','[{100,[{16050001,3849}]}]'),(1,144,153,'[{1,2761},{3,4141}]',158745,'[{16050001,3,9}]','[{100,[{16050001,3900}]}]'),(1,145,153,'[{1,2794},{3,4191}]',160655,'[{16050001,3,9}]','[{100,[{16050001,3951}]}]'),(1,146,153,'[{1,2828},{3,4242}]',162610,'[{16050001,3,9}]','[{100,[{16050001,4002}]}]'),(1,147,162,'[{1,2863},{3,4294}]',164610,'[{16050001,3,9}]','[{100,[{16050001,4053}]}]'),(1,148,162,'[{1,2898},{3,4347}]',166635,'[{16050001,3,9}]','[{100,[{16050001,4107}]}]'),(1,149,162,'[{1,2933},{3,4399}]',168635,'[{16050001,3,9}]','[{100,[{16050001,4161}]}]'),(1,150,162,'[{1,2968},{3,4451}]',170635,'[{16050001,3,9}]','[{100,[{16050001,4215}]}]'),(1,151,162,'[{1,3002},{3,4503}]',172615,'[{16050001,3,9}]','[{100,[{16050001,4269}]}]'),(1,152,162,'[{1,3038},{3,4557}]',174685,'[{16050001,3,9}]','[{100,[{16050001,4323}]}]'),(1,153,162,'[{1,3074},{3,4611}]',176755,'[{16050001,3,9}]','[{100,[{16050001,4377}]}]'),(1,154,162,'[{1,3110},{3,4665}]',178825,'[{16050001,3,9}]','[{100,[{16050001,4431}]}]'),(1,155,162,'[{1,3146},{3,4719}]',180895,'[{16050001,3,9}]','[{100,[{16050001,4485}]}]'),(1,156,171,'[{1,3182},{3,4772}]',182940,'[{16050001,3,9}]','[{100,[{16050001,4539}]}]'),(1,157,171,'[{1,3219},{3,4828}]',185080,'[{16050001,3,9}]','[{100,[{16050001,4596}]}]'),(1,158,171,'[{1,3256},{3,4883}]',187195,'[{16050001,3,9}]','[{100,[{16050001,4653}]}]'),(1,159,171,'[{1,3292},{3,4938}]',189290,'[{16050001,3,9}]','[{100,[{16050001,4710}]}]'),(1,160,171,'[{1,3329},{3,4994}]',191430,'[{16050001,3,9}]','[{100,[{16050001,4767}]}]'),(1,161,171,'[{1,3366},{3,5049}]',193545,'[{16050001,3,9}]','[{100,[{16050001,4824}]}]'),(1,162,171,'[{1,3404},{3,5106}]',195730,'[{16050001,3,9}]','[{100,[{16050001,4881}]}]'),(1,163,171,'[{1,3442},{3,5163}]',197915,'[{16050001,3,9}]','[{100,[{16050001,4938}]}]'),(1,164,171,'[{1,3480},{3,5220}]',200100,'[{16050001,3,9}]','[{100,[{16050001,4995}]}]'),(1,165,180,'[{1,3518},{3,5277}]',202285,'[{16050001,3,9}]','[{100,[{16050001,5052}]}]'),(1,166,180,'[{1,3556},{3,5334}]',204470,'[{16050001,3,9}]','[{100,[{16050001,5112}]}]'),(1,167,180,'[{1,3595},{3,5392}]',206700,'[{16050001,3,9}]','[{100,[{16050001,5172}]}]'),(1,168,180,'[{1,3634},{3,5450}]',208930,'[{16050001,3,9}]','[{100,[{16050001,5232}]}]'),(1,169,180,'[{1,3673},{3,5509}]',211185,'[{16050001,3,9}]','[{100,[{16050001,5292}]}]'),(1,170,180,'[{1,3712},{3,5567}]',213415,'[{16050001,3,9}]','[{100,[{16050001,5352}]}]'),(1,171,180,'[{1,3751},{3,5626}]',215670,'[{16050001,3,9}]','[{100,[{16050001,5412}]}]'),(1,172,180,'[{1,3791},{3,5686}]',217970,'[{16050001,3,9}]','[{100,[{16050001,5472}]}]'),(1,173,180,'[{1,3831},{3,5746}]',220270,'[{16050001,3,9}]','[{100,[{16050001,5532}]}]'),(1,174,189,'[{1,3871},{3,5806}]',222570,'[{16050001,3,9}]','[{100,[{16050001,5592}]}]'),(1,175,189,'[{1,3911},{3,5866}]',224870,'[{16050001,3,9}]','[{100,[{16050001,5655}]}]'),(1,176,189,'[{1,3950},{3,5925}]',227125,'[{16050001,3,9}]','[{100,[{16050001,5718}]}]'),(1,177,189,'[{1,3991},{3,5987}]',229495,'[{16050001,3,9}]','[{100,[{16050001,5781}]}]'),(1,178,189,'[{1,4032},{3,6048}]',231840,'[{16050001,3,9}]','[{100,[{16050001,5844}]}]'),(1,179,189,'[{1,4073},{3,6110}]',234210,'[{16050001,3,9}]','[{100,[{16050001,5907}]}]'),(1,180,189,'[{1,4114},{3,6171}]',236555,'[{16050001,3,9}]','[{100,[{16050001,5970}]}]'),(1,181,189,'[{1,4155},{3,6233}]',238925,'[{16050001,3,9}]','[{100,[{16050001,6033}]}]'),(1,182,189,'[{1,4197},{3,6296}]',241340,'[{16050001,3,9}]','[{100,[{16050001,6096}]}]'),(1,183,198,'[{1,4239},{3,6359}]',243755,'[{16050001,3,9}]','[{100,[{16050001,6159}]}]'),(1,184,198,'[{1,4282},{3,6422}]',246190,'[{16050001,3,9}]','[{100,[{16050001,6225}]}]'),(1,185,198,'[{1,4324},{3,6485}]',248605,'[{16050001,3,9}]','[{100,[{16050001,6291}]}]'),(1,186,198,'[{1,4366},{3,6548}]',251020,'[{16050001,3,9}]','[{100,[{16050001,6357}]}]'),(1,187,198,'[{1,4409},{3,6613}]',253505,'[{16050001,3,9}]','[{100,[{16050001,6423}]}]'),(1,188,198,'[{1,4452},{3,6677}]',255965,'[{16050001,3,9}]','[{100,[{16050001,6489}]}]'),(1,189,198,'[{1,4495},{3,6742}]',258450,'[{16050001,3,9}]','[{100,[{16050001,6555}]}]'),(1,190,198,'[{1,4538},{3,6806}]',260910,'[{16050001,3,9}]','[{100,[{16050001,6621}]}]'),(1,191,198,'[{1,4581},{3,6871}]',263395,'[{16050001,3,9}]','[{100,[{16050001,6687}]}]'),(1,192,207,'[{1,4625},{3,6937}]',265925,'[{16050001,3,9}]','[{100,[{16050001,6753}]}]'),(1,193,207,'[{1,4669},{3,7003}]',268455,'[{16050001,3,9}]','[{100,[{16050001,6822}]}]'),(1,194,207,'[{1,4713},{3,7069}]',270985,'[{16050001,3,9}]','[{100,[{16050001,6891}]}]'),(1,195,207,'[{1,4757},{3,7135}]',273515,'[{16050001,3,9}]','[{100,[{16050001,6960}]}]'),(1,196,207,'[{1,4801},{3,7201}]',276045,'[{16050001,3,9}]','[{100,[{16050001,7029}]}]'),(1,197,207,'[{1,4846},{3,7269}]',278645,'[{16050001,3,9}]','[{100,[{16050001,7098}]}]'),(1,198,207,'[{1,4891},{3,7337}]',281245,'[{16050001,3,9}]','[{100,[{16050001,7167}]}]'),(1,199,207,'[{1,4936},{3,7404}]',283820,'[{16050001,3,9}]','[{100,[{16050001,7236}]}]'),(1,200,207,'[{1,4982},{3,7472}]',286440,'[{16050001,3,9}]','[{100,[{16050001,7305}]}]'),(1,201,216,'[{1,5027},{3,7540}]',289040,'[{16050001,4,12}]','[{100,[{16050001,7374}]}]'),(1,202,216,'[{1,5073},{3,7609}]',291685,'[{16050001,4,12}]','[{100,[{16050001,7446}]}]'),(1,203,216,'[{1,5119},{3,7678}]',294330,'[{16050001,4,12}]','[{100,[{16050001,7518}]}]'),(1,204,216,'[{1,5165},{3,7747}]',296975,'[{16050001,4,12}]','[{100,[{16050001,7590}]}]'),(1,205,216,'[{1,5211},{3,7816}]',299620,'[{16050001,4,12}]','[{100,[{16050001,7662}]}]'),(1,206,216,'[{1,5257},{3,7886}]',302290,'[{16050001,4,12}]','[{100,[{16050001,7734}]}]'),(1,207,216,'[{1,5304},{3,7956}]',304980,'[{16050001,4,12}]','[{100,[{16050001,7806}]}]'),(1,208,216,'[{1,5352},{3,8027}]',307715,'[{16050001,4,12}]','[{100,[{16050001,7878}]}]'),(1,209,216,'[{1,5399},{3,8098}]',310430,'[{16050001,4,12}]','[{100,[{16050001,7950}]}]'),(1,210,228,'[{1,5446},{3,8168}]',313120,'[{16050001,4,12}]','[{100,[{16050001,8022}]}]'),(1,211,228,'[{1,5493},{3,8239}]',315835,'[{16050001,4,12}]','[{100,[{16050001,8098}]}]'),(1,212,228,'[{1,5541},{3,8311}]',318595,'[{16050001,4,12}]','[{100,[{16050001,8174}]}]'),(1,213,228,'[{1,5589},{3,8384}]',321380,'[{16050001,4,12}]','[{100,[{16050001,8250}]}]'),(1,214,228,'[{1,5637},{3,8456}]',324140,'[{16050001,4,12}]','[{100,[{16050001,8326}]}]'),(1,215,228,'[{1,5686},{3,8528}]',326920,'[{16050001,4,12}]','[{100,[{16050001,8402}]}]'),(1,216,228,'[{1,5734},{3,8600}]',329680,'[{16050001,4,12}]','[{100,[{16050001,8478}]}]'),(1,217,228,'[{1,5783},{3,8674}]',332510,'[{16050001,4,12}]','[{100,[{16050001,8554}]}]'),(1,218,228,'[{1,5832},{3,8748}]',335340,'[{16050001,4,12}]','[{100,[{16050001,8630}]}]'),(1,219,228,'[{1,5881},{3,8822}]',338170,'[{16050001,4,12}]','[{100,[{16050001,8706}]}]'),(1,220,228,'[{1,5931},{3,8896}]',341020,'[{16050001,4,12}]','[{100,[{16050001,8782}]}]'),(1,221,228,'[{1,5980},{3,8969}]',343825,'[{16050001,4,12}]','[{100,[{16050001,8858}]}]'),(1,222,240,'[{1,6030},{3,9045}]',346725,'[{16050001,4,12}]','[{100,[{16050001,8934}]}]'),(1,223,240,'[{1,6080},{3,9120}]',349600,'[{16050001,4,12}]','[{100,[{16050001,9014}]}]'),(1,224,240,'[{1,6130},{3,9195}]',352475,'[{16050001,4,12}]','[{100,[{16050001,9094}]}]'),(1,225,240,'[{1,6181},{3,9271}]',355395,'[{16050001,4,12}]','[{100,[{16050001,9174}]}]'),(1,226,240,'[{1,6231},{3,9346}]',358270,'[{16050001,4,12}]','[{100,[{16050001,9254}]}]'),(1,227,240,'[{1,6282},{3,9423}]',361215,'[{16050001,4,12}]','[{100,[{16050001,9334}]}]'),(1,228,240,'[{1,6333},{3,9500}]',364160,'[{16050001,4,12}]','[{100,[{16050001,9414}]}]'),(1,229,240,'[{1,6385},{3,9577}]',367125,'[{16050001,4,12}]','[{100,[{16050001,9494}]}]'),(1,230,240,'[{1,6436},{3,9654}]',370070,'[{16050001,4,12}]','[{100,[{16050001,9574}]}]'),(1,231,240,'[{1,6487},{3,9730}]',372990,'[{16050001,4,12}]','[{100,[{16050001,9654}]}]'),(1,232,240,'[{1,6539},{3,9809}]',376005,'[{16050001,4,12}]','[{100,[{16050001,9734}]}]'),(1,233,240,'[{1,6592},{3,9887}]',379015,'[{16050001,4,12}]','[{100,[{16050001,9814}]}]'),(1,234,252,'[{1,6644},{3,9966}]',382030,'[{16050001,4,12}]','[{100,[{16050001,9894}]}]'),(1,235,252,'[{1,6696},{3,10044}]',385020,'[{16050001,4,12}]','[{100,[{16050001,9978}]}]'),(1,236,252,'[{1,6748},{3,10122}]',388010,'[{16050001,4,12}]','[{100,[{16050001,10062}]}]'),(1,237,252,'[{1,6802},{3,10202}]',391090,'[{16050001,4,12}]','[{100,[{16050001,10146}]}]'),(1,238,252,'[{1,6855},{3,10282}]',394150,'[{16050001,4,12}]','[{100,[{16050001,10230}]}]'),(1,239,252,'[{1,6908},{3,10362}]',397210,'[{16050001,4,12}]','[{100,[{16050001,10314}]}]'),(1,240,252,'[{1,6962},{3,10442}]',400290,'[{16050001,4,12}]','[{100,[{16050001,10398}]}]'),(1,241,252,'[{1,7015},{3,10522}]',403350,'[{16050001,4,12}]','[{100,[{16050001,10482}]}]'),(1,242,252,'[{1,7069},{3,10604}]',406480,'[{16050001,4,12}]','[{100,[{16050001,10566}]}]'),(1,243,252,'[{1,7124},{3,10685}]',409605,'[{16050001,4,12}]','[{100,[{16050001,10650}]}]'),(1,244,252,'[{1,7178},{3,10767}]',412735,'[{16050001,4,12}]','[{100,[{16050001,10734}]}]'),(1,245,252,'[{1,7232},{3,10848}]',415840,'[{16050001,4,12}]','[{100,[{16050001,10818}]}]'),(1,246,264,'[{1,7287},{3,10930}]',418990,'[{16050001,4,12}]','[{100,[{16050001,10902}]}]'),(1,247,264,'[{1,7342},{3,11013}]',422165,'[{16050001,4,12}]','[{100,[{16050001,10990}]}]'),(1,248,264,'[{1,7397},{3,11096}]',425340,'[{16050001,4,12}]','[{100,[{16050001,11078}]}]'),(1,249,264,'[{1,7453},{3,11179}]',428535,'[{16050001,4,12}]','[{100,[{16050001,11166}]}]'),(1,250,264,'[{1,7508},{3,11262}]',431710,'[{16050001,4,12}]','[{100,[{16050001,11254}]}]'),(1,251,264,'[{1,7563},{3,11345}]',434885,'[{16050001,4,12}]','[{100,[{16050001,11342}]}]'),(1,252,264,'[{1,7620},{3,11429}]',438125,'[{16050001,4,12}]','[{100,[{16050001,11430}]}]'),(1,253,264,'[{1,7676},{3,11514}]',441370,'[{16050001,4,12}]','[{100,[{16050001,11518}]}]'),(1,254,264,'[{1,7732},{3,11598}]',444590,'[{16050001,4,12}]','[{100,[{16050001,11606}]}]'),(1,255,264,'[{1,7789},{3,11683}]',447855,'[{16050001,4,12}]','[{100,[{16050001,11694}]}]'),(1,256,264,'[{1,7845},{3,11767}]',451075,'[{16050001,4,12}]','[{100,[{16050001,11782}]}]'),(1,257,264,'[{1,7902},{3,11853}]',454365,'[{16050001,4,12}]','[{100,[{16050001,11870}]}]'),(1,258,276,'[{1,7960},{3,11940}]',457700,'[{16050001,4,12}]','[{100,[{16050001,11958}]}]'),(1,259,276,'[{1,8017},{3,12026}]',460990,'[{16050001,4,12}]','[{100,[{16050001,12050}]}]'),(1,260,276,'[{1,8075},{3,12112}]',464300,'[{16050001,4,12}]','[{100,[{16050001,12142}]}]'),(1,261,276,'[{1,8132},{3,12198}]',467590,'[{16050001,4,12}]','[{100,[{16050001,12234}]}]'),(1,262,276,'[{1,8190},{3,12285}]',470925,'[{16050001,4,12}]','[{100,[{16050001,12326}]}]'),(1,263,276,'[{1,8249},{3,12373}]',474305,'[{16050001,4,12}]','[{100,[{16050001,12418}]}]'),(1,264,276,'[{1,8307},{3,12461}]',477665,'[{16050001,4,12}]','[{100,[{16050001,12510}]}]'),(1,265,276,'[{1,8366},{3,12548}]',481020,'[{16050001,4,12}]','[{100,[{16050001,12602}]}]'),(1,266,276,'[{1,8424},{3,12636}]',484380,'[{16050001,4,12}]','[{100,[{16050001,12694}]}]'),(1,267,276,'[{1,8484},{3,12725}]',487805,'[{16050001,4,12}]','[{100,[{16050001,12786}]}]'),(1,268,276,'[{1,8543},{3,12814}]',491210,'[{16050001,4,12}]','[{100,[{16050001,12878}]}]'),(1,269,276,'[{1,8603},{3,12904}]',494660,'[{16050001,4,12}]','[{100,[{16050001,12970}]}]'),(1,270,288,'[{1,8662},{3,12993}]',498065,'[{16050001,4,12}]','[{100,[{16050001,13062}]}]'),(1,271,288,'[{1,8721},{3,13082}]',501470,'[{16050001,4,12}]','[{100,[{16050001,13158}]}]'),(1,272,288,'[{1,8782},{3,13173}]',504965,'[{16050001,4,12}]','[{100,[{16050001,13254}]}]'),(1,273,288,'[{1,8842},{3,13263}]',508415,'[{16050001,4,12}]','[{100,[{16050001,13350}]}]'),(1,274,288,'[{1,8903},{3,13354}]',511910,'[{16050001,4,12}]','[{100,[{16050001,13446}]}]'),(1,275,288,'[{1,8963},{3,13445}]',515385,'[{16050001,4,12}]','[{100,[{16050001,13542}]}]'),(1,276,288,'[{1,9024},{3,13535}]',518855,'[{16050001,4,12}]','[{100,[{16050001,13638}]}]'),(1,277,288,'[{1,9085},{3,13628}]',522400,'[{16050001,4,12}]','[{100,[{16050001,13734}]}]'),(1,278,288,'[{1,9147},{3,13720}]',525940,'[{16050001,4,12}]','[{100,[{16050001,13830}]}]'),(1,279,288,'[{1,9208},{3,13812}]',529460,'[{16050001,4,12}]','[{100,[{16050001,13926}]}]'),(1,280,288,'[{1,9270},{3,13904}]',533000,'[{16050001,4,12}]','[{100,[{16050001,14022}]}]'),(1,281,288,'[{1,9331},{3,13997}]',536545,'[{16050001,4,12}]','[{100,[{16050001,14118}]}]'),(1,282,300,'[{1,9394},{3,14090}]',540130,'[{16050001,4,12}]','[{100,[{16050001,14214}]}]'),(1,283,300,'[{1,9456},{3,14184}]',543720,'[{16050001,4,12}]','[{100,[{16050001,14314}]}]'),(1,284,300,'[{1,9519},{3,14278}]',547330,'[{16050001,4,12}]','[{100,[{16050001,14414}]}]'),(1,285,300,'[{1,9581},{3,14372}]',550920,'[{16050001,4,12}]','[{100,[{16050001,14514}]}]'),(1,286,300,'[{1,9644},{3,14465}]',554505,'[{16050001,4,12}]','[{100,[{16050001,14614}]}]'),(1,287,300,'[{1,9707},{3,14561}]',558165,'[{16050001,4,12}]','[{100,[{16050001,14714}]}]'),(1,288,300,'[{1,9771},{3,14656}]',561820,'[{16050001,4,12}]','[{100,[{16050001,14814}]}]'),(1,289,300,'[{1,9834},{3,14751}]',565455,'[{16050001,4,12}]','[{100,[{16050001,14914}]}]'),(1,290,300,'[{1,9898},{3,14847}]',569135,'[{16050001,4,12}]','[{100,[{16050001,15014}]}]'),(1,291,300,'[{1,9962},{3,14942}]',572790,'[{16050001,4,12}]','[{100,[{16050001,15114}]}]'),(1,292,300,'[{1,10026},{3,15039}]',576495,'[{16050001,4,12}]','[{100,[{16050001,15214}]}]'),(1,293,300,'[{1,10091},{3,15136}]',580220,'[{16050001,4,12}]','[{100,[{16050001,15314}]}]'),(1,294,312,'[{1,10155},{3,15233}]',583925,'[{16050001,4,12}]','[{100,[{16050001,15414}]}]'),(1,295,312,'[{1,10220},{3,15329}]',587625,'[{16050001,4,12}]','[{100,[{16050001,15518}]}]'),(1,296,312,'[{1,10284},{3,15426}]',591330,'[{16050001,4,12}]','[{100,[{16050001,15622}]}]'),(1,297,312,'[{1,10350},{3,15525}]',595125,'[{16050001,4,12}]','[{100,[{16050001,15726}]}]'),(1,298,312,'[{1,10416},{3,15623}]',598895,'[{16050001,4,12}]','[{100,[{16050001,15830}]}]'),(1,299,312,'[{1,10481},{3,15721}]',602645,'[{16050001,4,12}]','[{100,[{16050001,15934}]}]'),(1,300,312,'[{1,10547},{3,15820}]',606440,'[{16050001,4,12}]','[{100,[{16050001,16038}]}]'),(1,301,315,'[{1,10612},{3,15918}]',610190,'[{16050001,5,15}]','[{100,[{16050001,16142}]}]'),(1,302,315,'[{1,10679},{3,16018}]',614030,'[{16050001,5,15}]','[{100,[{16050001,16247}]}]'),(1,303,315,'[{1,10746},{3,16118}]',617870,'[{16050001,5,15}]','[{100,[{16050001,16352}]}]'),(1,304,315,'[{1,10812},{3,16218}]',621690,'[{16050001,5,15}]','[{100,[{16050001,16457}]}]'),(1,305,315,'[{1,10879},{3,16318}]',625530,'[{16050001,5,15}]','[{100,[{16050001,16562}]}]'),(1,306,315,'[{1,10945},{3,16418}]',629350,'[{16050001,5,15}]','[{100,[{16050001,16667}]}]'),(1,307,315,'[{1,11013},{3,16519}]',633235,'[{16050001,5,15}]','[{100,[{16050001,16772}]}]'),(1,308,315,'[{1,11081},{3,16621}]',637145,'[{16050001,5,15}]','[{100,[{16050001,16877}]}]'),(1,309,330,'[{1,11148},{3,16722}]',641010,'[{16050001,5,15}]','[{100,[{16050001,16982}]}]'),(1,310,330,'[{1,11216},{3,16824}]',644920,'[{16050001,5,15}]','[{100,[{16050001,17092}]}]'),(1,311,330,'[{1,11284},{3,16925}]',648805,'[{16050001,5,15}]','[{100,[{16050001,17202}]}]'),(1,312,330,'[{1,11352},{3,17028}]',652740,'[{16050001,5,15}]','[{100,[{16050001,17312}]}]'),(1,313,330,'[{1,11421},{3,17131}]',656695,'[{16050001,5,15}]','[{100,[{16050001,17422}]}]'),(1,314,330,'[{1,11490},{3,17234}]',660650,'[{16050001,5,15}]','[{100,[{16050001,17532}]}]'),(1,315,330,'[{1,11558},{3,17337}]',664585,'[{16050001,5,15}]','[{100,[{16050001,17642}]}]'),(1,316,330,'[{1,11627},{3,17440}]',668540,'[{16050001,5,15}]','[{100,[{16050001,17752}]}]'),(1,317,330,'[{1,11697},{3,17545}]',672565,'[{16050001,5,15}]','[{100,[{16050001,17862}]}]'),(1,318,330,'[{1,11766},{3,17649}]',676545,'[{16050001,5,15}]','[{100,[{16050001,17972}]}]'),(1,319,330,'[{1,11836},{3,17754}]',680570,'[{16050001,5,15}]','[{100,[{16050001,18082}]}]'),(1,320,330,'[{1,11906},{3,17858}]',684570,'[{16050001,5,15}]','[{100,[{16050001,18192}]}]'),(1,321,330,'[{1,11975},{3,17963}]',688575,'[{16050001,5,15}]','[{100,[{16050001,18302}]}]'),(1,322,330,'[{1,12046},{3,18069}]',692645,'[{16050001,5,15}]','[{100,[{16050001,18412}]}]'),(1,323,330,'[{1,12117},{3,18175}]',696715,'[{16050001,5,15}]','[{100,[{16050001,18522}]}]'),(1,324,345,'[{1,12188},{3,18281}]',700785,'[{16050001,5,15}]','[{100,[{16050001,18632}]}]'),(1,325,345,'[{1,12258},{3,18387}]',704835,'[{16050001,5,15}]','[{100,[{16050001,18747}]}]'),(1,326,345,'[{1,12329},{3,18493}]',708905,'[{16050001,5,15}]','[{100,[{16050001,18862}]}]'),(1,327,345,'[{1,12401},{3,18601}]',713045,'[{16050001,5,15}]','[{100,[{16050001,18977}]}]'),(1,328,345,'[{1,12473},{3,18709}]',717185,'[{16050001,5,15}]','[{100,[{16050001,19092}]}]'),(1,329,345,'[{1,12544},{3,18816}]',721280,'[{16050001,5,15}]','[{100,[{16050001,19207}]}]'),(1,330,345,'[{1,12616},{3,18924}]',725420,'[{16050001,5,15}]','[{100,[{16050001,19322}]}]'),(1,331,345,'[{1,12688},{3,19031}]',729535,'[{16050001,5,15}]','[{100,[{16050001,19437}]}]'),(1,332,345,'[{1,12761},{3,19141}]',733745,'[{16050001,5,15}]','[{100,[{16050001,19552}]}]'),(1,333,345,'[{1,12833},{3,19250}]',737910,'[{16050001,5,15}]','[{100,[{16050001,19667}]}]'),(1,334,345,'[{1,12906},{3,19359}]',742095,'[{16050001,5,15}]','[{100,[{16050001,19782}]}]'),(1,335,345,'[{1,12979},{3,19468}]',746280,'[{16050001,5,15}]','[{100,[{16050001,19897}]}]'),(1,336,345,'[{1,13052},{3,19577}]',750465,'[{16050001,5,15}]','[{100,[{16050001,20012}]}]'),(1,337,345,'[{1,13125},{3,19688}]',754700,'[{16050001,5,15}]','[{100,[{16050001,20127}]}]'),(1,338,345,'[{1,13199},{3,19799}]',758955,'[{16050001,5,15}]','[{100,[{16050001,20242}]}]'),(1,339,360,'[{1,13273},{3,19909}]',763185,'[{16050001,5,15}]','[{100,[{16050001,20357}]}]'),(1,340,360,'[{1,13347},{3,20020}]',767440,'[{16050001,5,15}]','[{100,[{16050001,20477}]}]'),(1,341,360,'[{1,13421},{3,20131}]',771695,'[{16050001,5,15}]','[{100,[{16050001,20597}]}]'),(1,342,360,'[{1,13495},{3,20243}]',775975,'[{16050001,5,15}]','[{100,[{16050001,20717}]}]'),(1,343,360,'[{1,13570},{3,20355}]',780275,'[{16050001,5,15}]','[{100,[{16050001,20837}]}]'),(1,344,360,'[{1,13645},{3,20467}]',784575,'[{16050001,5,15}]','[{100,[{16050001,20957}]}]'),(1,345,360,'[{1,13720},{3,20580}]',788900,'[{16050001,5,15}]','[{100,[{16050001,21077}]}]'),(1,346,360,'[{1,13795},{3,20692}]',793200,'[{16050001,5,15}]','[{100,[{16050001,21197}]}]'),(1,347,360,'[{1,13870},{3,20805}]',797525,'[{16050001,5,15}]','[{100,[{16050001,21317}]}]'),(1,348,360,'[{1,13946},{3,20919}]',801895,'[{16050001,5,15}]','[{100,[{16050001,21437}]}]'),(1,349,360,'[{1,14022},{3,21033}]',806265,'[{16050001,5,15}]','[{100,[{16050001,21557}]}]'),(1,350,360,'[{1,14098},{3,21147}]',810635,'[{16050001,5,15}]','[{100,[{16050001,21677}]}]'),(1,351,360,'[{1,14174},{3,21261}]',815005,'[{16050001,5,15}]','[{100,[{16050001,21797}]}]'),(1,352,360,'[{1,14251},{3,21376}]',819420,'[{16050001,5,15}]','[{100,[{16050001,21917}]}]'),(1,353,360,'[{1,14328},{3,21491}]',823835,'[{16050001,5,15}]','[{100,[{16050001,22037}]}]'),(1,354,375,'[{1,14404},{3,21606}]',828230,'[{16050001,5,15}]','[{100,[{16050001,22157}]}]'),(1,355,375,'[{1,14481},{3,21722}]',832670,'[{16050001,5,15}]','[{100,[{16050001,22282}]}]'),(1,356,375,'[{1,14558},{3,21837}]',837085,'[{16050001,5,15}]','[{100,[{16050001,22407}]}]'),(1,357,375,'[{1,14636},{3,21954}]',841570,'[{16050001,5,15}]','[{100,[{16050001,22532}]}]'),(1,358,375,'[{1,14714},{3,22071}]',846055,'[{16050001,5,15}]','[{100,[{16050001,22657}]}]'),(1,359,375,'[{1,14792},{3,22188}]',850540,'[{16050001,5,15}]','[{100,[{16050001,22782}]}]'),(1,360,375,'[{1,14870},{3,22304}]',855000,'[{16050001,5,15}]','[{100,[{16050001,22907}]}]'),(1,361,375,'[{1,14948},{3,22421}]',859485,'[{16050001,5,15}]','[{100,[{16050001,23032}]}]'),(1,362,375,'[{1,15027},{3,22540}]',864040,'[{16050001,5,15}]','[{100,[{16050001,23157}]}]'),(1,363,375,'[{1,15106},{3,22658}]',868570,'[{16050001,5,15}]','[{100,[{16050001,23282}]}]'),(1,364,375,'[{1,15184},{3,22776}]',873080,'[{16050001,5,15}]','[{100,[{16050001,23407}]}]'),(1,365,375,'[{1,15263},{3,22895}]',877635,'[{16050001,5,15}]','[{100,[{16050001,23532}]}]'),(1,366,375,'[{1,15342},{3,23013}]',882165,'[{16050001,5,15}]','[{100,[{16050001,23657}]}]'),(1,367,375,'[{1,15422},{3,23133}]',886765,'[{16050001,5,15}]','[{100,[{16050001,23782}]}]'),(1,368,375,'[{1,15502},{3,23253}]',891365,'[{16050001,5,15}]','[{100,[{16050001,23907}]}]'),(1,369,390,'[{1,15582},{3,23373}]',895965,'[{16050001,5,15}]','[{100,[{16050001,24032}]}]'),(1,370,390,'[{1,15662},{3,23493}]',900565,'[{16050001,5,15}]','[{100,[{16050001,24162}]}]'),(1,371,390,'[{1,15742},{3,23613}]',905165,'[{16050001,5,15}]','[{100,[{16050001,24292}]}]'),(1,372,390,'[{1,15823},{3,23734}]',909810,'[{16050001,5,15}]','[{100,[{16050001,24422}]}]'),(1,373,390,'[{1,15904},{3,23856}]',914480,'[{16050001,5,15}]','[{100,[{16050001,24552}]}]'),(1,374,390,'[{1,15985},{3,23977}]',919125,'[{16050001,5,15}]','[{100,[{16050001,24682}]}]'),(1,375,390,'[{1,16066},{3,24099}]',923795,'[{16050001,5,15}]','[{100,[{16050001,24812}]}]'),(1,376,390,'[{1,16147},{3,24220}]',928440,'[{16050001,5,15}]','[{100,[{16050001,24942}]}]'),(1,377,390,'[{1,16229},{3,24343}]',933155,'[{16050001,5,15}]','[{100,[{16050001,25072}]}]'),(1,378,390,'[{1,16311},{3,24466}]',937870,'[{16050001,5,15}]','[{100,[{16050001,25202}]}]'),(1,379,390,'[{1,16393},{3,24589}]',942585,'[{16050001,5,15}]','[{100,[{16050001,25332}]}]'),(1,380,390,'[{1,16475},{3,24712}]',947300,'[{16050001,5,15}]','[{100,[{16050001,25462}]}]'),(1,381,390,'[{1,16557},{3,24835}]',952015,'[{16050001,5,15}]','[{100,[{16050001,25592}]}]'),(1,382,390,'[{1,16640},{3,24959}]',956775,'[{16050001,5,15}]','[{100,[{16050001,25722}]}]'),(1,383,390,'[{1,16723},{3,25084}]',961560,'[{16050001,5,15}]','[{100,[{16050001,25852}]}]'),(1,384,405,'[{1,16806},{3,25208}]',966320,'[{16050001,5,15}]','[{100,[{16050001,25982}]}]'),(1,385,405,'[{1,16889},{3,25333}]',971105,'[{16050001,5,15}]','[{100,[{16050001,26117}]}]'),(1,386,405,'[{1,16972},{3,25458}]',975890,'[{16050001,5,15}]','[{100,[{16050001,26252}]}]'),(1,387,405,'[{1,17056},{3,25584}]',980720,'[{16050001,5,15}]','[{100,[{16050001,26387}]}]'),(1,388,405,'[{1,17140},{3,25710}]',985550,'[{16050001,5,15}]','[{100,[{16050001,26522}]}]'),(1,389,405,'[{1,17224},{3,25836}]',990380,'[{16050001,5,15}]','[{100,[{16050001,26657}]}]'),(1,390,405,'[{1,17308},{3,25962}]',995210,'[{16050001,5,15}]','[{100,[{16050001,26792}]}]'),(1,391,405,'[{1,17392},{3,26088}]',1000040,'[{16050001,5,15}]','[{100,[{16050001,26927}]}]'),(1,392,405,'[{1,17477},{3,26215}]',1004915,'[{16050001,5,15}]','[{100,[{16050001,27062}]}]'),(1,393,405,'[{1,17562},{3,26343}]',1009815,'[{16050001,5,15}]','[{100,[{16050001,27197}]}]'),(1,394,405,'[{1,17647},{3,26471}]',1014715,'[{16050001,5,15}]','[{100,[{16050001,27332}]}]'),(1,395,405,'[{1,17732},{3,26598}]',1019590,'[{16050001,5,15}]','[{100,[{16050001,27467}]}]'),(1,396,405,'[{1,17817},{3,26726}]',1024490,'[{16050001,5,15}]','[{100,[{16050001,27602}]}]'),(1,397,405,'[{1,17903},{3,26855}]',1029435,'[{16050001,5,15}]','[{100,[{16050001,27737}]}]'),(1,398,405,'[{1,17990},{3,26984}]',1034400,'[{16050001,5,15}]','[{100,[{16050001,27872}]}]'),(1,399,420,'[{1,18076},{3,27113}]',1039345,'[{16050001,5,15}]','[{100,[{16050001,28007}]}]'),(1,400,420,'[{1,18162},{3,27242}]',1044290,'[{16050001,5,15}]','[{100,[{16050001,28147}]}]'),(1,401,414,'[{1,18248},{3,27372}]',1049260,'[{16050001,6,18}]','[{100,[{16050001,28287}]}]'),(1,402,414,'[{1,18335},{3,27502}]',1054250,'[{16050001,6,18}]','[{100,[{16050001,28425}]}]'),(1,403,414,'[{1,18422},{3,27633}]',1059265,'[{16050001,6,18}]','[{100,[{16050001,28563}]}]'),(1,404,414,'[{1,18509},{3,27764}]',1064280,'[{16050001,6,18}]','[{100,[{16050001,28701}]}]'),(1,405,414,'[{1,18596},{3,27894}]',1069270,'[{16050001,6,18}]','[{100,[{16050001,28839}]}]'),(1,406,414,'[{1,18683},{3,28025}]',1074285,'[{16050001,6,18}]','[{100,[{16050001,28977}]}]'),(1,407,414,'[{1,18772},{3,28157}]',1079365,'[{16050001,6,18}]','[{100,[{16050001,29115}]}]'),(1,408,432,'[{1,18860},{3,28289}]',1084425,'[{16050001,6,18}]','[{100,[{16050001,29253}]}]'),(1,409,432,'[{1,18948},{3,28422}]',1089510,'[{16050001,6,18}]','[{100,[{16050001,29397}]}]'),(1,410,432,'[{1,19036},{3,28554}]',1094570,'[{16050001,6,18}]','[{100,[{16050001,29541}]}]'),(1,411,432,'[{1,19124},{3,28686}]',1099630,'[{16050001,6,18}]','[{100,[{16050001,29685}]}]'),(1,412,432,'[{1,19213},{3,28820}]',1104760,'[{16050001,6,18}]','[{100,[{16050001,29829}]}]'),(1,413,432,'[{1,19302},{3,28953}]',1109865,'[{16050001,6,18}]','[{100,[{16050001,29973}]}]'),(1,414,432,'[{1,19392},{3,29087}]',1115015,'[{16050001,6,18}]','[{100,[{16050001,30117}]}]'),(1,415,432,'[{1,19481},{3,29221}]',1120145,'[{16050001,6,18}]','[{100,[{16050001,30261}]}]'),(1,416,432,'[{1,19570},{3,29355}]',1125275,'[{16050001,6,18}]','[{100,[{16050001,30405}]}]'),(1,417,432,'[{1,19660},{3,29490}]',1130450,'[{16050001,6,18}]','[{100,[{16050001,30549}]}]'),(1,418,432,'[{1,19750},{3,29625}]',1135625,'[{16050001,6,18}]','[{100,[{16050001,30693}]}]'),(1,419,432,'[{1,19841},{3,29761}]',1140845,'[{16050001,6,18}]','[{100,[{16050001,30837}]}]'),(1,420,432,'[{1,19931},{3,29896}]',1146020,'[{16050001,6,18}]','[{100,[{16050001,30981}]}]'),(1,421,432,'[{1,20021},{3,30031}]',1151195,'[{16050001,6,18}]','[{100,[{16050001,31125}]}]'),(1,422,432,'[{1,20112},{3,30168}]',1156440,'[{16050001,6,18}]','[{100,[{16050001,31269}]}]'),(1,423,432,'[{1,20203},{3,30305}]',1161685,'[{16050001,6,18}]','[{100,[{16050001,31413}]}]'),(1,424,432,'[{1,20295},{3,30442}]',1166950,'[{16050001,6,18}]','[{100,[{16050001,31557}]}]'),(1,425,432,'[{1,20386},{3,30578}]',1172170,'[{16050001,6,18}]','[{100,[{16050001,31701}]}]'),(1,426,450,'[{1,20477},{3,30715}]',1177415,'[{16050001,6,18}]','[{100,[{16050001,31845}]}]'),(1,427,450,'[{1,20569},{3,30854}]',1182730,'[{16050001,6,18}]','[{100,[{16050001,31995}]}]'),(1,428,450,'[{1,20661},{3,30992}]',1188020,'[{16050001,6,18}]','[{100,[{16050001,32145}]}]'),(1,429,450,'[{1,20754},{3,31130}]',1193330,'[{16050001,6,18}]','[{100,[{16050001,32295}]}]'),(1,430,450,'[{1,20846},{3,31269}]',1198645,'[{16050001,6,18}]','[{100,[{16050001,32445}]}]'),(1,431,450,'[{1,20938},{3,31407}]',1203935,'[{16050001,6,18}]','[{100,[{16050001,32595}]}]'),(1,432,450,'[{1,21031},{3,31547}]',1209295,'[{16050001,6,18}]','[{100,[{16050001,32745}]}]'),(1,433,450,'[{1,21125},{3,31687}]',1214675,'[{16050001,6,18}]','[{100,[{16050001,32895}]}]'),(1,434,450,'[{1,21218},{3,31827}]',1220035,'[{16050001,6,18}]','[{100,[{16050001,33045}]}]'),(1,435,450,'[{1,21311},{3,31967}]',1225395,'[{16050001,6,18}]','[{100,[{16050001,33195}]}]'),(1,436,450,'[{1,21405},{3,32107}]',1230775,'[{16050001,6,18}]','[{100,[{16050001,33345}]}]'),(1,437,450,'[{1,21499},{3,32248}]',1236180,'[{16050001,6,18}]','[{100,[{16050001,33495}]}]'),(1,438,450,'[{1,21593},{3,32389}]',1241585,'[{16050001,6,18}]','[{100,[{16050001,33645}]}]'),(1,439,450,'[{1,21687},{3,32531}]',1247015,'[{16050001,6,18}]','[{100,[{16050001,33795}]}]'),(1,440,450,'[{1,21782},{3,32672}]',1252440,'[{16050001,6,18}]','[{100,[{16050001,33945}]}]'),(1,441,450,'[{1,21876},{3,32814}]',1257870,'[{16050001,6,18}]','[{100,[{16050001,34095}]}]'),(1,442,450,'[{1,21971},{3,32957}]',1263345,'[{16050001,6,18}]','[{100,[{16050001,34245}]}]'),(1,443,450,'[{1,22067},{3,33100}]',1268840,'[{16050001,6,18}]','[{100,[{16050001,34395}]}]'),(1,444,468,'[{1,22162},{3,33243}]',1274315,'[{16050001,6,18}]','[{100,[{16050001,34545}]}]'),(1,445,468,'[{1,22257},{3,33386}]',1279790,'[{16050001,6,18}]','[{100,[{16050001,34701}]}]'),(1,446,468,'[{1,22353},{3,33529}]',1285285,'[{16050001,6,18}]','[{100,[{16050001,34857}]}]'),(1,447,468,'[{1,22449},{3,33673}]',1290805,'[{16050001,6,18}]','[{100,[{16050001,35013}]}]'),(1,448,468,'[{1,22545},{3,33818}]',1296350,'[{16050001,6,18}]','[{100,[{16050001,35169}]}]'),(1,449,468,'[{1,22642},{3,33962}]',1301890,'[{16050001,6,18}]','[{100,[{16050001,35325}]}]'),(1,450,468,'[{1,22738},{3,34107}]',1307435,'[{16050001,6,18}]','[{100,[{16050001,35481}]}]'),(1,451,468,'[{1,22834},{3,34251}]',1312955,'[{16050001,6,18}]','[{100,[{16050001,35637}]}]'),(1,452,468,'[{1,22932},{3,34397}]',1318565,'[{16050001,6,18}]','[{100,[{16050001,35793}]}]'),(1,453,468,'[{1,23029},{3,34543}]',1324155,'[{16050001,6,18}]','[{100,[{16050001,35949}]}]'),(1,454,468,'[{1,23126},{3,34689}]',1329745,'[{16050001,6,18}]','[{100,[{16050001,36105}]}]'),(1,455,468,'[{1,23224},{3,34835}]',1335355,'[{16050001,6,18}]','[{100,[{16050001,36261}]}]'),(1,456,468,'[{1,23321},{3,34981}]',1340945,'[{16050001,6,18}]','[{100,[{16050001,36417}]}]'),(1,457,468,'[{1,23420},{3,35129}]',1346625,'[{16050001,6,18}]','[{100,[{16050001,36573}]}]'),(1,458,468,'[{1,23518},{3,35277}]',1352285,'[{16050001,6,18}]','[{100,[{16050001,36729}]}]'),(1,459,468,'[{1,23616},{3,35424}]',1357920,'[{16050001,6,18}]','[{100,[{16050001,36885}]}]'),(1,460,468,'[{1,23715},{3,35572}]',1363600,'[{16050001,6,18}]','[{100,[{16050001,37041}]}]'),(1,461,468,'[{1,23813},{3,35719}]',1369235,'[{16050001,6,18}]','[{100,[{16050001,37197}]}]'),(1,462,486,'[{1,23912},{3,35868}]',1374940,'[{16050001,6,18}]','[{100,[{16050001,37353}]}]'),(1,463,486,'[{1,24012},{3,36018}]',1380690,'[{16050001,6,18}]','[{100,[{16050001,37515}]}]'),(1,464,486,'[{1,24111},{3,36167}]',1386395,'[{16050001,6,18}]','[{100,[{16050001,37677}]}]'),(1,465,486,'[{1,24211},{3,36316}]',1392120,'[{16050001,6,18}]','[{100,[{16050001,37839}]}]'),(1,466,486,'[{1,24310},{3,36465}]',1397825,'[{16050001,6,18}]','[{100,[{16050001,38001}]}]'),(1,467,486,'[{1,24411},{3,36616}]',1403620,'[{16050001,6,18}]','[{100,[{16050001,38163}]}]'),(1,468,486,'[{1,24511},{3,36766}]',1409370,'[{16050001,6,18}]','[{100,[{16050001,38325}]}]'),(1,469,486,'[{1,24611},{3,36917}]',1415145,'[{16050001,6,18}]','[{100,[{16050001,38487}]}]'),(1,470,486,'[{1,24712},{3,37068}]',1420940,'[{16050001,6,18}]','[{100,[{16050001,38649}]}]'),(1,471,486,'[{1,24812},{3,37218}]',1426690,'[{16050001,6,18}]','[{100,[{16050001,38811}]}]'),(1,472,486,'[{1,24914},{3,37370}]',1432530,'[{16050001,6,18}]','[{100,[{16050001,38973}]}]'),(1,473,486,'[{1,25015},{3,37523}]',1438375,'[{16050001,6,18}]','[{100,[{16050001,39135}]}]'),(1,474,486,'[{1,25117},{3,37675}]',1444215,'[{16050001,6,18}]','[{100,[{16050001,39297}]}]'),(1,475,486,'[{1,25218},{3,37827}]',1450035,'[{16050001,6,18}]','[{100,[{16050001,39459}]}]'),(1,476,486,'[{1,25320},{3,37979}]',1455875,'[{16050001,6,18}]','[{100,[{16050001,39621}]}]'),(1,477,486,'[{1,25422},{3,38133}]',1461765,'[{16050001,6,18}]','[{100,[{16050001,39783}]}]'),(1,478,486,'[{1,25525},{3,38287}]',1467675,'[{16050001,6,18}]','[{100,[{16050001,39945}]}]'),(1,479,486,'[{1,25627},{3,38440}]',1473540,'[{16050001,6,18}]','[{100,[{16050001,40107}]}]'),(1,480,504,'[{1,25730},{3,38594}]',1479450,'[{16050001,6,18}]','[{100,[{16050001,40269}]}]'),(1,481,504,'[{1,25832},{3,38748}]',1485340,'[{16050001,6,18}]','[{100,[{16050001,40437}]}]'),(1,482,504,'[{1,25936},{3,38903}]',1491295,'[{16050001,6,18}]','[{100,[{16050001,40605}]}]'),(1,483,504,'[{1,26039},{3,39058}]',1497230,'[{16050001,6,18}]','[{100,[{16050001,40773}]}]'),(1,484,504,'[{1,26143},{3,39214}]',1503210,'[{16050001,6,18}]','[{100,[{16050001,40941}]}]'),(1,485,504,'[{1,26246},{3,39369}]',1509145,'[{16050001,6,18}]','[{100,[{16050001,41109}]}]'),(1,486,504,'[{1,26350},{3,39524}]',1515100,'[{16050001,6,18}]','[{100,[{16050001,41277}]}]'),(1,487,504,'[{1,26454},{3,39681}]',1521105,'[{16050001,6,18}]','[{100,[{16050001,41445}]}]'),(1,488,504,'[{1,26559},{3,39838}]',1527130,'[{16050001,6,18}]','[{100,[{16050001,41613}]}]'),(1,489,504,'[{1,26663},{3,39995}]',1533135,'[{16050001,6,18}]','[{100,[{16050001,41781}]}]'),(1,490,504,'[{1,26768},{3,40152}]',1539160,'[{16050001,6,18}]','[{100,[{16050001,41949}]}]'),(1,491,504,'[{1,26872},{3,40308}]',1545140,'[{16050001,6,18}]','[{100,[{16050001,42117}]}]'),(1,492,504,'[{1,26978},{3,40467}]',1551235,'[{16050001,6,18}]','[{100,[{16050001,42285}]}]'),(1,493,504,'[{1,27084},{3,40625}]',1557305,'[{16050001,6,18}]','[{100,[{16050001,42453}]}]'),(1,494,504,'[{1,27189},{3,40783}]',1563355,'[{16050001,6,18}]','[{100,[{16050001,42621}]}]'),(1,495,504,'[{1,27295},{3,40942}]',1569450,'[{16050001,6,18}]','[{100,[{16050001,42789}]}]'),(1,496,504,'[{1,27400},{3,41100}]',1575500,'[{16050001,6,18}]','[{100,[{16050001,42957}]}]'),(1,497,504,'[{1,27507},{3,41260}]',1581640,'[{16050001,6,18}]','[{100,[{16050001,43125}]}]'),(1,498,522,'[{1,27613},{3,41420}]',1587760,'[{16050001,6,18}]','[{100,[{16050001,43293}]}]'),(1,499,522,'[{1,27720},{3,41580}]',1593900,'[{16050001,6,18}]','[{100,[{16050001,43467}]}]'),(1,500,522,'[{1,27827},{3,41740}]',1600040,'[]','[{100,[{16050001,43641}]}]'),(2,1,9,'[{2,82},{4,7}]',257,'[{16050001,1,3}]','[{100,[{16050001,43815}]}]'),(2,2,9,'[{2,185},{4,14}]',535,'[{16050001,1,3}]','[{100,[{16050001,43818}]}]'),(2,3,12,'[{2,287},{4,22}]',837,'[{16050001,1,3}]','[{100,[{16050001,43821}]}]'),(2,4,12,'[{2,390},{4,30}]',1140,'[{16050001,1,3}]','[{100,[{16050001,43825}]}]'),(2,5,12,'[{2,492},{4,37}]',1417,'[{16050001,1,3}]','[{100,[{16050001,43829}]}]'),(2,6,15,'[{2,595},{4,45}]',1720,'[{16050001,1,3}]','[{100,[{16050001,43833}]}]'),(2,7,15,'[{2,718},{4,54}]',2068,'[{16050001,1,3}]','[{100,[{16050001,43838}]}]'),(2,8,15,'[{2,841},{4,64}]',2441,'[{16050001,1,3}]','[{100,[{16050001,43843}]}]'),(2,9,18,'[{2,964},{4,73}]',2789,'[{16050001,1,3}]','[{100,[{16050001,43848}]}]'),(2,10,18,'[{2,1087},{4,82}]',3137,'[{16050001,1,3}]','[{100,[{16050001,43854}]}]'),(2,11,18,'[{2,1210},{4,91}]',3485,'[{16050001,1,3}]','[{100,[{16050001,43860}]}]'),(2,12,21,'[{2,1353},{4,102}]',3903,'[{16050001,1,3}]','[{100,[{16050001,43866}]}]'),(2,13,21,'[{2,1497},{4,113}]',4322,'[{16050001,1,3}]','[{100,[{16050001,43873}]}]'),(2,14,21,'[{2,1640},{4,123}]',4715,'[{16050001,1,3}]','[{100,[{16050001,43880}]}]'),(2,15,24,'[{2,1784},{4,134}]',5134,'[{16050001,1,3}]','[{100,[{16050001,43887}]}]'),(2,16,24,'[{2,1927},{4,145}]',5552,'[{16050001,2,6}]','[{100,[{16050001,43895}]}]'),(2,17,24,'[{2,2091},{4,157}]',6016,'[{16050001,2,6}]','[{100,[{16050001,43903}]}]'),(2,18,30,'[{2,2255},{4,170}]',6505,'[{16050001,2,6}]','[{100,[{16050001,43911}]}]'),(2,19,30,'[{2,2419},{4,182}]',6969,'[{16050001,2,6}]','[{100,[{16050001,43921}]}]'),(2,20,30,'[{2,2583},{4,194}]',7433,'[{16050001,2,6}]','[{100,[{16050001,43931}]}]'),(2,21,30,'[{2,2747},{4,207}]',7922,'[{16050001,2,6}]','[{100,[{16050001,43941}]}]'),(2,22,30,'[{2,2932},{4,220}]',8432,'[{16050001,2,6}]','[{100,[{16050001,43951}]}]'),(2,23,30,'[{2,3116},{4,234}]',8966,'[{16050001,2,6}]','[{100,[{16050001,43961}]}]'),(2,24,36,'[{2,3301},{4,248}]',9501,'[{16050001,2,6}]','[{100,[{16050001,43971}]}]'),(2,25,36,'[{2,3485},{4,262}]',10035,'[{16050001,2,6}]','[{100,[{16050001,43983}]}]'),(2,26,36,'[{2,3670},{4,276}]',10570,'[{16050001,2,6}]','[{100,[{16050001,43995}]}]'),(2,27,36,'[{2,3875},{4,291}]',11150,'[{16050001,2,6}]','[{100,[{16050001,44007}]}]'),(2,28,36,'[{2,4080},{4,306}]',11730,'[{16050001,2,6}]','[{100,[{16050001,44019}]}]'),(2,29,36,'[{2,4285},{4,322}]',12335,'[{16050001,2,6}]','[{100,[{16050001,44031}]}]'),(2,30,42,'[{2,4490},{4,337}]',12915,'[{16050001,2,6}]','[{100,[{16050001,44043}]}]'),(2,31,42,'[{2,4695},{4,353}]',13520,'[{16050001,2,6}]','[{100,[{16050001,44057}]}]'),(2,32,42,'[{2,4920},{4,369}]',14145,'[{16050001,2,6}]','[{100,[{16050001,44071}]}]'),(2,33,42,'[{2,5146},{4,386}]',14796,'[{16050001,2,6}]','[{100,[{16050001,44085}]}]'),(2,34,42,'[{2,5371},{4,403}]',15446,'[{16050001,2,6}]','[{100,[{16050001,44099}]}]'),(2,35,42,'[{2,5596},{4,420}]',16096,'[{16050001,2,6}]','[{100,[{16050001,44113}]}]'),(2,36,48,'[{2,5822},{4,437}]',16747,'[{16050001,2,6}]','[{100,[{16050001,44127}]}]'),(2,37,48,'[{2,6068},{4,456}]',17468,'[{16050001,2,6}]','[{100,[{16050001,44143}]}]'),(2,38,48,'[{2,6314},{4,474}]',18164,'[{16050001,2,6}]','[{100,[{16050001,44159}]}]'),(2,39,48,'[{2,6560},{4,492}]',18860,'[{16050001,2,6}]','[{100,[{16050001,44175}]}]'),(2,40,48,'[{2,6806},{4,511}]',19581,'[{16050001,2,6}]','[{100,[{16050001,44191}]}]'),(2,41,48,'[{2,7052},{4,529}]',20277,'[{16050001,2,6}]','[{100,[{16050001,44207}]}]'),(2,42,54,'[{2,7318},{4,549}]',21043,'[{16050001,2,6}]','[{100,[{16050001,44223}]}]'),(2,43,54,'[{2,7585},{4,569}]',21810,'[{16050001,2,6}]','[{100,[{16050001,44241}]}]'),(2,44,54,'[{2,7851},{4,589}]',22576,'[{16050001,2,6}]','[{100,[{16050001,44259}]}]'),(2,45,54,'[{2,8118},{4,609}]',23343,'[{16050001,2,6}]','[{100,[{16050001,44277}]}]'),(2,46,54,'[{2,8384},{4,629}]',24109,'[{16050001,2,6}]','[{100,[{16050001,44295}]}]'),(2,47,54,'[{2,8671},{4,651}]',24946,'[{16050001,2,6}]','[{100,[{16050001,44313}]}]'),(2,48,60,'[{2,8958},{4,672}]',25758,'[{16050001,2,6}]','[{100,[{16050001,44331}]}]'),(2,49,60,'[{2,9245},{4,694}]',26595,'[{16050001,2,6}]','[{100,[{16050001,44351}]}]'),(2,50,60,'[{2,9532},{4,715}]',27407,'[{16050001,2,6}]','[{100,[{16050001,44371}]}]'),(2,51,60,'[{2,9819},{4,737}]',28244,'[{16050001,2,6}]','[{100,[{16050001,44391}]}]'),(2,52,60,'[{2,10127},{4,760}]',29127,'[{16050001,2,6}]','[{100,[{16050001,44411}]}]'),(2,53,60,'[{2,10434},{4,783}]',30009,'[{16050001,2,6}]','[{100,[{16050001,44431}]}]'),(2,54,66,'[{2,10741},{4,806}]',30891,'[{16050001,2,6}]','[{100,[{16050001,44451}]}]'),(2,55,66,'[{2,11049},{4,829}]',31774,'[{16050001,2,6}]','[{100,[{16050001,44473}]}]'),(2,56,66,'[{2,11356},{4,852}]',32656,'[{16050001,2,6}]','[{100,[{16050001,44495}]}]'),(2,57,66,'[{2,11684},{4,877}]',33609,'[{16050001,2,6}]','[{100,[{16050001,44517}]}]'),(2,58,66,'[{2,12012},{4,901}]',34537,'[{16050001,2,6}]','[{100,[{16050001,44539}]}]'),(2,59,66,'[{2,12340},{4,926}]',35490,'[{16050001,2,6}]','[{100,[{16050001,44561}]}]'),(2,60,72,'[{2,12668},{4,951}]',36443,'[{16050001,2,6}]','[{100,[{16050001,44583}]}]'),(2,61,72,'[{2,12996},{4,975}]',37371,'[{16050001,2,6}]','[{100,[{16050001,44607}]}]'),(2,62,72,'[{2,13345},{4,1001}]',38370,'[{16050001,2,6}]','[{100,[{16050001,44631}]}]'),(2,63,72,'[{2,13693},{4,1027}]',39368,'[{16050001,2,6}]','[{100,[{16050001,44655}]}]'),(2,64,72,'[{2,14042},{4,1054}]',40392,'[{16050001,2,6}]','[{100,[{16050001,44679}]}]'),(2,65,72,'[{2,14390},{4,1080}]',41390,'[{16050001,2,6}]','[{100,[{16050001,44703}]}]'),(2,66,78,'[{2,14739},{4,1106}]',42389,'[{16050001,2,6}]','[{100,[{16050001,44727}]}]'),(2,67,78,'[{2,15108},{4,1134}]',43458,'[{16050001,2,6}]','[{100,[{16050001,44753}]}]'),(2,68,78,'[{2,15477},{4,1161}]',44502,'[{16050001,2,6}]','[{100,[{16050001,44779}]}]'),(2,69,78,'[{2,15845},{4,1189}]',45570,'[{16050001,2,6}]','[{100,[{16050001,44805}]}]'),(2,70,78,'[{2,16214},{4,1217}]',46639,'[{16050001,2,6}]','[{100,[{16050001,44831}]}]'),(2,71,78,'[{2,16583},{4,1244}]',47683,'[{16050001,2,6}]','[{100,[{16050001,44857}]}]'),(2,72,84,'[{2,16973},{4,1273}]',48798,'[{16050001,2,6}]','[{100,[{16050001,44883}]}]'),(2,73,84,'[{2,17362},{4,1303}]',49937,'[{16050001,2,6}]','[{100,[{16050001,44911}]}]'),(2,74,84,'[{2,17752},{4,1332}]',51052,'[{16050001,2,6}]','[{100,[{16050001,44939}]}]'),(2,75,84,'[{2,18141},{4,1361}]',52166,'[{16050001,2,6}]','[{100,[{16050001,44967}]}]'),(2,76,84,'[{2,18531},{4,1390}]',53281,'[{16050001,2,6}]','[{100,[{16050001,44995}]}]'),(2,77,84,'[{2,18941},{4,1421}]',54466,'[{16050001,2,6}]','[{100,[{16050001,45023}]}]'),(2,78,90,'[{2,19351},{4,1452}]',55651,'[{16050001,2,6}]','[{100,[{16050001,45051}]}]'),(2,79,90,'[{2,19761},{4,1483}]',56836,'[{16050001,2,6}]','[{100,[{16050001,45081}]}]'),(2,80,90,'[{2,20171},{4,1513}]',57996,'[{16050001,2,6}]','[{100,[{16050001,45111}]}]'),(2,81,90,'[{2,20581},{4,1544}]',59181,'[{16050001,2,6}]','[{100,[{16050001,45141}]}]'),(2,82,90,'[{2,21011},{4,1576}]',60411,'[{16050001,2,6}]','[{100,[{16050001,45171}]}]'),(2,83,90,'[{2,21441},{4,1609}]',61666,'[{16050001,2,6}]','[{100,[{16050001,45201}]}]'),(2,84,96,'[{2,21872},{4,1641}]',62897,'[{16050001,2,6}]','[{100,[{16050001,45231}]}]'),(2,85,96,'[{2,22302},{4,1673}]',64127,'[{16050001,2,6}]','[{100,[{16050001,45263}]}]'),(2,86,96,'[{2,22733},{4,1705}]',65358,'[{16050001,2,6}]','[{100,[{16050001,45295}]}]'),(2,87,96,'[{2,23184},{4,1739}]',66659,'[{16050001,2,6}]','[{100,[{16050001,45327}]}]'),(2,88,96,'[{2,23635},{4,1773}]',67960,'[{16050001,2,6}]','[{100,[{16050001,45359}]}]'),(2,89,96,'[{2,24086},{4,1807}]',69261,'[{16050001,2,6}]','[{100,[{16050001,45391}]}]'),(2,90,102,'[{2,24537},{4,1841}]',70562,'[{16050001,2,6}]','[{100,[{16050001,45423}]}]'),(2,91,102,'[{2,24988},{4,1875}]',71863,'[{16050001,2,6}]','[{100,[{16050001,45457}]}]'),(2,92,102,'[{2,25459},{4,1910}]',73209,'[{16050001,2,6}]','[{100,[{16050001,45491}]}]'),(2,93,102,'[{2,25931},{4,1945}]',74556,'[{16050001,2,6}]','[{100,[{16050001,45525}]}]'),(2,94,102,'[{2,26402},{4,1981}]',75927,'[{16050001,2,6}]','[{100,[{16050001,45559}]}]'),(2,95,102,'[{2,26873},{4,2016}]',77273,'[{16050001,2,6}]','[{100,[{16050001,45593}]}]'),(2,96,108,'[{2,27345},{4,2051}]',78620,'[{16050001,2,6}]','[{100,[{16050001,45627}]}]'),(2,97,108,'[{2,27837},{4,2088}]',80037,'[{16050001,2,6}]','[{100,[{16050001,45663}]}]'),(2,98,108,'[{2,28329},{4,2125}]',81454,'[{16050001,2,6}]','[{100,[{16050001,45699}]}]'),(2,99,108,'[{2,28821},{4,2162}]',82871,'[{16050001,2,6}]','[{100,[{16050001,45735}]}]'),(2,100,108,'[{2,29313},{4,2199}]',84288,'[{16050001,2,6}]','[{100,[{16050001,45771}]}]'),(2,101,108,'[{2,29805},{4,2236}]',85705,'[{16050001,3,9}]','[{100,[{16050001,45807}]}]'),(2,102,117,'[{2,30317},{4,2274}]',87167,'[{16050001,3,9}]','[{100,[{16050001,45843}]}]'),(2,103,117,'[{2,30830},{4,2313}]',88655,'[{16050001,3,9}]','[{100,[{16050001,45882}]}]'),(2,104,117,'[{2,31342},{4,2351}]',90117,'[{16050001,3,9}]','[{100,[{16050001,45921}]}]'),(2,105,117,'[{2,31854},{4,2390}]',91604,'[{16050001,3,9}]','[{100,[{16050001,45960}]}]'),(2,106,117,'[{2,32367},{4,2428}]',93067,'[{16050001,3,9}]','[{100,[{16050001,45999}]}]'),(2,107,117,'[{2,32900},{4,2468}]',94600,'[{16050001,3,9}]','[{100,[{16050001,46038}]}]'),(2,108,117,'[{2,33433},{4,2508}]',96133,'[{16050001,3,9}]','[{100,[{16050001,46077}]}]'),(2,109,117,'[{2,33966},{4,2548}]',97666,'[{16050001,3,9}]','[{100,[{16050001,46116}]}]'),(2,110,117,'[{2,34499},{4,2588}]',99199,'[{16050001,3,9}]','[{100,[{16050001,46155}]}]'),(2,111,126,'[{2,35032},{4,2628}]',100732,'[{16050001,3,9}]','[{100,[{16050001,46194}]}]'),(2,112,126,'[{2,35585},{4,2669}]',102310,'[{16050001,3,9}]','[{100,[{16050001,46236}]}]'),(2,113,126,'[{2,36139},{4,2711}]',103914,'[{16050001,3,9}]','[{100,[{16050001,46278}]}]'),(2,114,126,'[{2,36692},{4,2752}]',105492,'[{16050001,3,9}]','[{100,[{16050001,46320}]}]'),(2,115,126,'[{2,37245},{4,2794}]',107095,'[{16050001,3,9}]','[{100,[{16050001,46362}]}]'),(2,116,126,'[{2,37799},{4,2835}]',108674,'[{16050001,3,9}]','[{100,[{16050001,46404}]}]'),(2,117,126,'[{2,38373},{4,2878}]',110323,'[{16050001,3,9}]','[{100,[{16050001,46446}]}]'),(2,118,126,'[{2,38947},{4,2921}]',111972,'[{16050001,3,9}]','[{100,[{16050001,46488}]}]'),(2,119,126,'[{2,39521},{4,2965}]',113646,'[{16050001,3,9}]','[{100,[{16050001,46530}]}]'),(2,120,135,'[{2,40095},{4,3008}]',115295,'[{16050001,3,9}]','[{100,[{16050001,46572}]}]'),(2,121,135,'[{2,40669},{4,3051}]',116944,'[{16050001,3,9}]','[{100,[{16050001,46617}]}]'),(2,122,135,'[{2,41263},{4,3095}]',118638,'[{16050001,3,9}]','[{100,[{16050001,46662}]}]'),(2,123,135,'[{2,41857},{4,3140}]',120357,'[{16050001,3,9}]','[{100,[{16050001,46707}]}]'),(2,124,135,'[{2,42452},{4,3184}]',122052,'[{16050001,3,9}]','[{100,[{16050001,46752}]}]'),(2,125,135,'[{2,43046},{4,3229}]',123771,'[{16050001,3,9}]','[{100,[{16050001,46797}]}]'),(2,126,135,'[{2,43641},{4,3274}]',125491,'[{16050001,3,9}]','[{100,[{16050001,46842}]}]'),(2,127,135,'[{2,44256},{4,3320}]',127256,'[{16050001,3,9}]','[{100,[{16050001,46887}]}]'),(2,128,135,'[{2,44871},{4,3366}]',129021,'[{16050001,3,9}]','[{100,[{16050001,46932}]}]'),(2,129,144,'[{2,45486},{4,3412}]',130786,'[{16050001,3,9}]','[{100,[{16050001,46977}]}]'),(2,130,144,'[{2,46101},{4,3458}]',132551,'[{16050001,3,9}]','[{100,[{16050001,47025}]}]'),(2,131,144,'[{2,46716},{4,3504}]',134316,'[{16050001,3,9}]','[{100,[{16050001,47073}]}]'),(2,132,144,'[{2,47351},{4,3552}]',136151,'[{16050001,3,9}]','[{100,[{16050001,47121}]}]'),(2,133,144,'[{2,47986},{4,3599}]',137961,'[{16050001,3,9}]','[{100,[{16050001,47169}]}]'),(2,134,144,'[{2,48622},{4,3647}]',139797,'[{16050001,3,9}]','[{100,[{16050001,47217}]}]'),(2,135,144,'[{2,49257},{4,3695}]',141632,'[{16050001,3,9}]','[{100,[{16050001,47265}]}]'),(2,136,144,'[{2,49893},{4,3742}]',143443,'[{16050001,3,9}]','[{100,[{16050001,47313}]}]'),(2,137,144,'[{2,50549},{4,3792}]',145349,'[{16050001,3,9}]','[{100,[{16050001,47361}]}]'),(2,138,153,'[{2,51205},{4,3841}]',147230,'[{16050001,3,9}]','[{100,[{16050001,47409}]}]'),(2,139,153,'[{2,51861},{4,3890}]',149111,'[{16050001,3,9}]','[{100,[{16050001,47460}]}]'),(2,140,153,'[{2,52516},{4,3939}]',150991,'[{16050001,3,9}]','[{100,[{16050001,47511}]}]'),(2,141,153,'[{2,53172},{4,3988}]',152872,'[{16050001,3,9}]','[{100,[{16050001,47562}]}]'),(2,142,153,'[{2,53849},{4,4039}]',154824,'[{16050001,3,9}]','[{100,[{16050001,47613}]}]'),(2,143,153,'[{2,54525},{4,4090}]',156775,'[{16050001,3,9}]','[{100,[{16050001,47664}]}]'),(2,144,153,'[{2,55202},{4,4141}]',158727,'[{16050001,3,9}]','[{100,[{16050001,47715}]}]'),(2,145,153,'[{2,55878},{4,4191}]',160653,'[{16050001,3,9}]','[{100,[{16050001,47766}]}]'),(2,146,153,'[{2,56555},{4,4242}]',162605,'[{16050001,3,9}]','[{100,[{16050001,47817}]}]'),(2,147,162,'[{2,57252},{4,4294}]',164602,'[{16050001,3,9}]','[{100,[{16050001,47868}]}]'),(2,148,162,'[{2,57948},{4,4347}]',166623,'[{16050001,3,9}]','[{100,[{16050001,47922}]}]'),(2,149,162,'[{2,58645},{4,4399}]',168620,'[{16050001,3,9}]','[{100,[{16050001,47976}]}]'),(2,150,162,'[{2,59342},{4,4451}]',170617,'[{16050001,3,9}]','[{100,[{16050001,48030}]}]'),(2,151,162,'[{2,60039},{4,4503}]',172614,'[{16050001,3,9}]','[{100,[{16050001,48084}]}]'),(2,152,162,'[{2,60757},{4,4557}]',174682,'[{16050001,3,9}]','[{100,[{16050001,48138}]}]'),(2,153,162,'[{2,61474},{4,4611}]',176749,'[{16050001,3,9}]','[{100,[{16050001,48192}]}]'),(2,154,162,'[{2,62192},{4,4665}]',178817,'[{16050001,3,9}]','[{100,[{16050001,48246}]}]'),(2,155,162,'[{2,62909},{4,4719}]',180884,'[{16050001,3,9}]','[{100,[{16050001,48300}]}]'),(2,156,171,'[{2,63626},{4,4772}]',182926,'[{16050001,3,9}]','[{100,[{16050001,48354}]}]'),(2,157,171,'[{2,64364},{4,4828}]',185064,'[{16050001,3,9}]','[{100,[{16050001,48411}]}]'),(2,158,171,'[{2,65102},{4,4883}]',187177,'[{16050001,3,9}]','[{100,[{16050001,48468}]}]'),(2,159,171,'[{2,65840},{4,4938}]',189290,'[{16050001,3,9}]','[{100,[{16050001,48525}]}]'),(2,160,171,'[{2,66578},{4,4994}]',191428,'[{16050001,3,9}]','[{100,[{16050001,48582}]}]'),(2,161,171,'[{2,67316},{4,5049}]',193541,'[{16050001,3,9}]','[{100,[{16050001,48639}]}]'),(2,162,171,'[{2,68074},{4,5106}]',195724,'[{16050001,3,9}]','[{100,[{16050001,48696}]}]'),(2,163,171,'[{2,68833},{4,5163}]',197908,'[{16050001,3,9}]','[{100,[{16050001,48753}]}]'),(2,164,171,'[{2,69591},{4,5220}]',200091,'[{16050001,3,9}]','[{100,[{16050001,48810}]}]'),(2,165,180,'[{2,70350},{4,5277}]',202275,'[{16050001,3,9}]','[{100,[{16050001,48867}]}]'),(2,166,180,'[{2,71108},{4,5334}]',204458,'[{16050001,3,9}]','[{100,[{16050001,48927}]}]'),(2,167,180,'[{2,71887},{4,5392}]',206687,'[{16050001,3,9}]','[{100,[{16050001,48987}]}]'),(2,168,180,'[{2,72666},{4,5450}]',208916,'[{16050001,3,9}]','[{100,[{16050001,49047}]}]'),(2,169,180,'[{2,73445},{4,5509}]',211170,'[{16050001,3,9}]','[{100,[{16050001,49107}]}]'),(2,170,180,'[{2,74224},{4,5567}]',213399,'[{16050001,3,9}]','[{100,[{16050001,49167}]}]'),(2,171,180,'[{2,75003},{4,5626}]',215653,'[{16050001,3,9}]','[{100,[{16050001,49227}]}]'),(2,172,180,'[{2,75802},{4,5686}]',217952,'[{16050001,3,9}]','[{100,[{16050001,49287}]}]'),(2,173,180,'[{2,76602},{4,5746}]',220252,'[{16050001,3,9}]','[{100,[{16050001,49347}]}]'),(2,174,189,'[{2,77401},{4,5806}]',222551,'[{16050001,3,9}]','[{100,[{16050001,49407}]}]'),(2,175,189,'[{2,78201},{4,5866}]',224851,'[{16050001,3,9}]','[{100,[{16050001,49470}]}]'),(2,176,189,'[{2,79000},{4,5925}]',227125,'[{16050001,3,9}]','[{100,[{16050001,49533}]}]'),(2,177,189,'[{2,79820},{4,5987}]',229495,'[{16050001,3,9}]','[{100,[{16050001,49596}]}]'),(2,178,189,'[{2,80640},{4,6048}]',231840,'[{16050001,3,9}]','[{100,[{16050001,49659}]}]'),(2,179,189,'[{2,81460},{4,6110}]',234210,'[{16050001,3,9}]','[{100,[{16050001,49722}]}]'),(2,180,189,'[{2,82280},{4,6171}]',236555,'[{16050001,3,9}]','[{100,[{16050001,49785}]}]'),(2,181,189,'[{2,83100},{4,6233}]',238925,'[{16050001,3,9}]','[{100,[{16050001,49848}]}]'),(2,182,189,'[{2,83940},{4,6296}]',241340,'[{16050001,3,9}]','[{100,[{16050001,49911}]}]'),(2,183,198,'[{2,84780},{4,6359}]',243755,'[{16050001,3,9}]','[{100,[{16050001,49974}]}]'),(2,184,198,'[{2,85621},{4,6422}]',246171,'[{16050001,3,9}]','[{100,[{16050001,50040}]}]'),(2,185,198,'[{2,86461},{4,6485}]',248586,'[{16050001,3,9}]','[{100,[{16050001,50106}]}]'),(2,186,198,'[{2,87302},{4,6548}]',251002,'[{16050001,3,9}]','[{100,[{16050001,50172}]}]'),(2,187,198,'[{2,88163},{4,6613}]',253488,'[{16050001,3,9}]','[{100,[{16050001,50238}]}]'),(2,188,198,'[{2,89023},{4,6677}]',255948,'[{16050001,3,9}]','[{100,[{16050001,50304}]}]'),(2,189,198,'[{2,89884},{4,6742}]',258434,'[{16050001,3,9}]','[{100,[{16050001,50370}]}]'),(2,190,198,'[{2,90745},{4,6806}]',260895,'[{16050001,3,9}]','[{100,[{16050001,50436}]}]'),(2,191,198,'[{2,91606},{4,6871}]',263381,'[{16050001,3,9}]','[{100,[{16050001,50502}]}]'),(2,192,207,'[{2,92488},{4,6937}]',265913,'[{16050001,3,9}]','[{100,[{16050001,50568}]}]'),(2,193,207,'[{2,93369},{4,7003}]',268444,'[{16050001,3,9}]','[{100,[{16050001,50637}]}]'),(2,194,207,'[{2,94250},{4,7069}]',270975,'[{16050001,3,9}]','[{100,[{16050001,50706}]}]'),(2,195,207,'[{2,95132},{4,7135}]',273507,'[{16050001,3,9}]','[{100,[{16050001,50775}]}]'),(2,196,207,'[{2,96013},{4,7201}]',276038,'[{16050001,3,9}]','[{100,[{16050001,50844}]}]'),(2,197,207,'[{2,96915},{4,7269}]',278640,'[{16050001,3,9}]','[{100,[{16050001,50913}]}]'),(2,198,207,'[{2,97817},{4,7337}]',281242,'[{16050001,3,9}]','[{100,[{16050001,50982}]}]'),(2,199,207,'[{2,98719},{4,7404}]',283819,'[{16050001,3,9}]','[{100,[{16050001,51051}]}]'),(2,200,207,'[{2,99621},{4,7472}]',286421,'[{16050001,3,9}]','[{100,[{16050001,51120}]}]'),(2,201,216,'[{2,100523},{4,7540}]',289023,'[{16050001,4,12}]','[{100,[{16050001,51189}]}]'),(2,202,216,'[{2,101445},{4,7609}]',291670,'[{16050001,4,12}]','[{100,[{16050001,51261}]}]'),(2,203,216,'[{2,102368},{4,7678}]',294318,'[{16050001,4,12}]','[{100,[{16050001,51333}]}]'),(2,204,216,'[{2,103290},{4,7747}]',296965,'[{16050001,4,12}]','[{100,[{16050001,51405}]}]'),(2,205,216,'[{2,104213},{4,7816}]',299613,'[{16050001,4,12}]','[{100,[{16050001,51477}]}]'),(2,206,216,'[{2,105135},{4,7886}]',302285,'[{16050001,4,12}]','[{100,[{16050001,51549}]}]'),(2,207,216,'[{2,106078},{4,7956}]',304978,'[{16050001,4,12}]','[{100,[{16050001,51621}]}]'),(2,208,216,'[{2,107021},{4,8027}]',307696,'[{16050001,4,12}]','[{100,[{16050001,51693}]}]'),(2,209,216,'[{2,107964},{4,8098}]',310414,'[{16050001,4,12}]','[{100,[{16050001,51765}]}]'),(2,210,228,'[{2,108907},{4,8168}]',313107,'[{16050001,4,12}]','[{100,[{16050001,51837}]}]'),(2,211,228,'[{2,109849},{4,8239}]',315824,'[{16050001,4,12}]','[{100,[{16050001,51913}]}]'),(2,212,228,'[{2,110813},{4,8311}]',318588,'[{16050001,4,12}]','[{100,[{16050001,51989}]}]'),(2,213,228,'[{2,111776},{4,8384}]',321376,'[{16050001,4,12}]','[{100,[{16050001,52065}]}]'),(2,214,228,'[{2,112740},{4,8456}]',324140,'[{16050001,4,12}]','[{100,[{16050001,52141}]}]'),(2,215,228,'[{2,113703},{4,8528}]',326903,'[{16050001,4,12}]','[{100,[{16050001,52217}]}]'),(2,216,228,'[{2,114667},{4,8600}]',329667,'[{16050001,4,12}]','[{100,[{16050001,52293}]}]'),(2,217,228,'[{2,115650},{4,8674}]',332500,'[{16050001,4,12}]','[{100,[{16050001,52369}]}]'),(2,218,228,'[{2,116634},{4,8748}]',335334,'[{16050001,4,12}]','[{100,[{16050001,52445}]}]'),(2,219,228,'[{2,117618},{4,8822}]',338168,'[{16050001,4,12}]','[{100,[{16050001,52521}]}]'),(2,220,228,'[{2,118602},{4,8896}]',341002,'[{16050001,4,12}]','[{100,[{16050001,52597}]}]'),(2,221,228,'[{2,119586},{4,8969}]',343811,'[{16050001,4,12}]','[{100,[{16050001,52673}]}]'),(2,222,240,'[{2,120590},{4,9045}]',346715,'[{16050001,4,12}]','[{100,[{16050001,52749}]}]'),(2,223,240,'[{2,121595},{4,9120}]',349595,'[{16050001,4,12}]','[{100,[{16050001,52829}]}]'),(2,224,240,'[{2,122599},{4,9195}]',352474,'[{16050001,4,12}]','[{100,[{16050001,52909}]}]'),(2,225,240,'[{2,123604},{4,9271}]',355379,'[{16050001,4,12}]','[{100,[{16050001,52989}]}]'),(2,226,240,'[{2,124608},{4,9346}]',358258,'[{16050001,4,12}]','[{100,[{16050001,53069}]}]'),(2,227,240,'[{2,125633},{4,9423}]',361208,'[{16050001,4,12}]','[{100,[{16050001,53149}]}]'),(2,228,240,'[{2,126658},{4,9500}]',364158,'[{16050001,4,12}]','[{100,[{16050001,53229}]}]'),(2,229,240,'[{2,127683},{4,9577}]',367108,'[{16050001,4,12}]','[{100,[{16050001,53309}]}]'),(2,230,240,'[{2,128708},{4,9654}]',370058,'[{16050001,4,12}]','[{100,[{16050001,53389}]}]'),(2,231,240,'[{2,129733},{4,9730}]',372983,'[{16050001,4,12}]','[{100,[{16050001,53469}]}]'),(2,232,240,'[{2,130778},{4,9809}]',376003,'[{16050001,4,12}]','[{100,[{16050001,53549}]}]'),(2,233,240,'[{2,131823},{4,9887}]',378998,'[{16050001,4,12}]','[{100,[{16050001,53629}]}]'),(2,234,252,'[{2,132869},{4,9966}]',382019,'[{16050001,4,12}]','[{100,[{16050001,53709}]}]'),(2,235,252,'[{2,133914},{4,10044}]',385014,'[{16050001,4,12}]','[{100,[{16050001,53793}]}]'),(2,236,252,'[{2,134960},{4,10122}]',388010,'[{16050001,4,12}]','[{100,[{16050001,53877}]}]'),(2,237,252,'[{2,136025},{4,10202}]',391075,'[{16050001,4,12}]','[{100,[{16050001,53961}]}]'),(2,238,252,'[{2,137091},{4,10282}]',394141,'[{16050001,4,12}]','[{100,[{16050001,54045}]}]'),(2,239,252,'[{2,138157},{4,10362}]',397207,'[{16050001,4,12}]','[{100,[{16050001,54129}]}]'),(2,240,252,'[{2,139223},{4,10442}]',400273,'[{16050001,4,12}]','[{100,[{16050001,54213}]}]'),(2,241,252,'[{2,140289},{4,10522}]',403339,'[{16050001,4,12}]','[{100,[{16050001,54297}]}]'),(2,242,252,'[{2,141375},{4,10604}]',406475,'[{16050001,4,12}]','[{100,[{16050001,54381}]}]'),(2,243,252,'[{2,142462},{4,10685}]',409587,'[{16050001,4,12}]','[{100,[{16050001,54465}]}]'),(2,244,252,'[{2,143548},{4,10767}]',412723,'[{16050001,4,12}]','[{100,[{16050001,54549}]}]'),(2,245,252,'[{2,144635},{4,10848}]',415835,'[{16050001,4,12}]','[{100,[{16050001,54633}]}]'),(2,246,264,'[{2,145721},{4,10930}]',418971,'[{16050001,4,12}]','[{100,[{16050001,54717}]}]'),(2,247,264,'[{2,146828},{4,11013}]',422153,'[{16050001,4,12}]','[{100,[{16050001,54805}]}]'),(2,248,264,'[{2,147935},{4,11096}]',425335,'[{16050001,4,12}]','[{100,[{16050001,54893}]}]'),(2,249,264,'[{2,149042},{4,11179}]',428517,'[{16050001,4,12}]','[{100,[{16050001,54981}]}]'),(2,250,264,'[{2,150149},{4,11262}]',431699,'[{16050001,4,12}]','[{100,[{16050001,55069}]}]'),(2,251,264,'[{2,151256},{4,11345}]',434881,'[{16050001,4,12}]','[{100,[{16050001,55157}]}]'),(2,252,264,'[{2,152383},{4,11429}]',438108,'[{16050001,4,12}]','[{100,[{16050001,55245}]}]'),(2,253,264,'[{2,153510},{4,11514}]',441360,'[{16050001,4,12}]','[{100,[{16050001,55333}]}]'),(2,254,264,'[{2,154638},{4,11598}]',444588,'[{16050001,4,12}]','[{100,[{16050001,55421}]}]'),(2,255,264,'[{2,155765},{4,11683}]',447840,'[{16050001,4,12}]','[{100,[{16050001,55509}]}]'),(2,256,264,'[{2,156892},{4,11767}]',451067,'[{16050001,4,12}]','[{100,[{16050001,55597}]}]'),(2,257,264,'[{2,158040},{4,11853}]',454365,'[{16050001,4,12}]','[{100,[{16050001,55685}]}]'),(2,258,276,'[{2,159188},{4,11940}]',457688,'[{16050001,4,12}]','[{100,[{16050001,55773}]}]'),(2,259,276,'[{2,160336},{4,12026}]',460986,'[{16050001,4,12}]','[{100,[{16050001,55865}]}]'),(2,260,276,'[{2,161484},{4,12112}]',464284,'[{16050001,4,12}]','[{100,[{16050001,55957}]}]'),(2,261,276,'[{2,162632},{4,12198}]',467582,'[{16050001,4,12}]','[{100,[{16050001,56049}]}]'),(2,262,276,'[{2,163800},{4,12285}]',470925,'[{16050001,4,12}]','[{100,[{16050001,56141}]}]'),(2,263,276,'[{2,164969},{4,12373}]',474294,'[{16050001,4,12}]','[{100,[{16050001,56233}]}]'),(2,264,276,'[{2,166137},{4,12461}]',477662,'[{16050001,4,12}]','[{100,[{16050001,56325}]}]'),(2,265,276,'[{2,167305},{4,12548}]',481005,'[{16050001,4,12}]','[{100,[{16050001,56417}]}]'),(2,266,276,'[{2,168474},{4,12636}]',484374,'[{16050001,4,12}]','[{100,[{16050001,56509}]}]'),(2,267,276,'[{2,169663},{4,12725}]',487788,'[{16050001,4,12}]','[{100,[{16050001,56601}]}]'),(2,268,276,'[{2,170852},{4,12814}]',491202,'[{16050001,4,12}]','[{100,[{16050001,56693}]}]'),(2,269,276,'[{2,172041},{4,12904}]',494641,'[{16050001,4,12}]','[{100,[{16050001,56785}]}]'),(2,270,288,'[{2,173229},{4,12993}]',498054,'[{16050001,4,12}]','[{100,[{16050001,56877}]}]'),(2,271,288,'[{2,174418},{4,13082}]',501468,'[{16050001,4,12}]','[{100,[{16050001,56973}]}]'),(2,272,288,'[{2,175628},{4,13173}]',504953,'[{16050001,4,12}]','[{100,[{16050001,57069}]}]'),(2,273,288,'[{2,176837},{4,13263}]',508412,'[{16050001,4,12}]','[{100,[{16050001,57165}]}]'),(2,274,288,'[{2,178046},{4,13354}]',511896,'[{16050001,4,12}]','[{100,[{16050001,57261}]}]'),(2,275,288,'[{2,179256},{4,13445}]',515381,'[{16050001,4,12}]','[{100,[{16050001,57357}]}]'),(2,276,288,'[{2,180465},{4,13535}]',518840,'[{16050001,4,12}]','[{100,[{16050001,57453}]}]'),(2,277,288,'[{2,181695},{4,13628}]',522395,'[{16050001,4,12}]','[{100,[{16050001,57549}]}]'),(2,278,288,'[{2,182925},{4,13720}]',525925,'[{16050001,4,12}]','[{100,[{16050001,57645}]}]'),(2,279,288,'[{2,184155},{4,13812}]',529455,'[{16050001,4,12}]','[{100,[{16050001,57741}]}]'),(2,280,288,'[{2,185385},{4,13904}]',532985,'[{16050001,4,12}]','[{100,[{16050001,57837}]}]'),(2,281,288,'[{2,186615},{4,13997}]',536540,'[{16050001,4,12}]','[{100,[{16050001,57933}]}]'),(2,282,300,'[{2,187865},{4,14090}]',540115,'[{16050001,4,12}]','[{100,[{16050001,58029}]}]'),(2,283,300,'[{2,189115},{4,14184}]',543715,'[{16050001,4,12}]','[{100,[{16050001,58129}]}]'),(2,284,300,'[{2,190366},{4,14278}]',547316,'[{16050001,4,12}]','[{100,[{16050001,58229}]}]'),(2,285,300,'[{2,191616},{4,14372}]',550916,'[{16050001,4,12}]','[{100,[{16050001,58329}]}]'),(2,286,300,'[{2,192867},{4,14465}]',554492,'[{16050001,4,12}]','[{100,[{16050001,58429}]}]'),(2,287,300,'[{2,194137},{4,14561}]',558162,'[{16050001,4,12}]','[{100,[{16050001,58529}]}]'),(2,288,300,'[{2,195408},{4,14656}]',561808,'[{16050001,4,12}]','[{100,[{16050001,58629}]}]'),(2,289,300,'[{2,196679},{4,14751}]',565454,'[{16050001,4,12}]','[{100,[{16050001,58729}]}]'),(2,290,300,'[{2,197950},{4,14847}]',569125,'[{16050001,4,12}]','[{100,[{16050001,58829}]}]'),(2,291,300,'[{2,199221},{4,14942}]',572771,'[{16050001,4,12}]','[{100,[{16050001,58929}]}]'),(2,292,300,'[{2,200512},{4,15039}]',576487,'[{16050001,4,12}]','[{100,[{16050001,59029}]}]'),(2,293,300,'[{2,201804},{4,15136}]',580204,'[{16050001,4,12}]','[{100,[{16050001,59129}]}]'),(2,294,312,'[{2,203095},{4,15233}]',583920,'[{16050001,4,12}]','[{100,[{16050001,59229}]}]'),(2,295,312,'[{2,204386},{4,15329}]',587611,'[{16050001,4,12}]','[{100,[{16050001,59333}]}]'),(2,296,312,'[{2,205678},{4,15426}]',591328,'[{16050001,4,12}]','[{100,[{16050001,59437}]}]'),(2,297,312,'[{2,206990},{4,15525}]',595115,'[{16050001,4,12}]','[{100,[{16050001,59541}]}]'),(2,298,312,'[{2,208302},{4,15623}]',598877,'[{16050001,4,12}]','[{100,[{16050001,59645}]}]'),(2,299,312,'[{2,209613},{4,15721}]',602638,'[{16050001,4,12}]','[{100,[{16050001,59749}]}]'),(2,300,312,'[{2,210925},{4,15820}]',606425,'[{16050001,4,12}]','[{100,[{16050001,59853}]}]'),(2,301,315,'[{2,212237},{4,15918}]',610187,'[{16050001,5,15}]','[{100,[{16050001,59957}]}]'),(2,302,315,'[{2,213570},{4,16018}]',614020,'[{16050001,5,15}]','[{100,[{16050001,60062}]}]'),(2,303,315,'[{2,214902},{4,16118}]',617852,'[{16050001,5,15}]','[{100,[{16050001,60167}]}]'),(2,304,315,'[{2,216234},{4,16218}]',621684,'[{16050001,5,15}]','[{100,[{16050001,60272}]}]'),(2,305,315,'[{2,217567},{4,16318}]',625517,'[{16050001,5,15}]','[{100,[{16050001,60377}]}]'),(2,306,315,'[{2,218899},{4,16418}]',629349,'[{16050001,5,15}]','[{100,[{16050001,60482}]}]'),(2,307,315,'[{2,220252},{4,16519}]',633227,'[{16050001,5,15}]','[{100,[{16050001,60587}]}]'),(2,308,315,'[{2,221605},{4,16621}]',637130,'[{16050001,5,15}]','[{100,[{16050001,60692}]}]'),(2,309,330,'[{2,222958},{4,16722}]',641008,'[{16050001,5,15}]','[{100,[{16050001,60797}]}]'),(2,310,330,'[{2,224311},{4,16824}]',644911,'[{16050001,5,15}]','[{100,[{16050001,60907}]}]'),(2,311,330,'[{2,225663},{4,16925}]',648788,'[{16050001,5,15}]','[{100,[{16050001,61017}]}]'),(2,312,330,'[{2,227037},{4,17028}]',652737,'[{16050001,5,15}]','[{100,[{16050001,61127}]}]'),(2,313,330,'[{2,228410},{4,17131}]',656685,'[{16050001,5,15}]','[{100,[{16050001,61237}]}]'),(2,314,330,'[{2,229784},{4,17234}]',660634,'[{16050001,5,15}]','[{100,[{16050001,61347}]}]'),(2,315,330,'[{2,231157},{4,17337}]',664582,'[{16050001,5,15}]','[{100,[{16050001,61457}]}]'),(2,316,330,'[{2,232530},{4,17440}]',668530,'[{16050001,5,15}]','[{100,[{16050001,61567}]}]'),(2,317,330,'[{2,233924},{4,17545}]',672549,'[{16050001,5,15}]','[{100,[{16050001,61677}]}]'),(2,318,330,'[{2,235318},{4,17649}]',676543,'[{16050001,5,15}]','[{100,[{16050001,61787}]}]'),(2,319,330,'[{2,236712},{4,17754}]',680562,'[{16050001,5,15}]','[{100,[{16050001,61897}]}]'),(2,320,330,'[{2,238106},{4,17858}]',684556,'[{16050001,5,15}]','[{100,[{16050001,62007}]}]'),(2,321,330,'[{2,239500},{4,17963}]',688575,'[{16050001,5,15}]','[{100,[{16050001,62117}]}]'),(2,322,330,'[{2,240914},{4,18069}]',692639,'[{16050001,5,15}]','[{100,[{16050001,62227}]}]'),(2,323,330,'[{2,242328},{4,18175}]',696703,'[{16050001,5,15}]','[{100,[{16050001,62337}]}]'),(2,324,345,'[{2,243743},{4,18281}]',700768,'[{16050001,5,15}]','[{100,[{16050001,62447}]}]'),(2,325,345,'[{2,245157},{4,18387}]',704832,'[{16050001,5,15}]','[{100,[{16050001,62562}]}]'),(2,326,345,'[{2,246571},{4,18493}]',708896,'[{16050001,5,15}]','[{100,[{16050001,62677}]}]'),(2,327,345,'[{2,248006},{4,18601}]',713031,'[{16050001,5,15}]','[{100,[{16050001,62792}]}]'),(2,328,345,'[{2,249441},{4,18709}]',717166,'[{16050001,5,15}]','[{100,[{16050001,62907}]}]'),(2,329,345,'[{2,250876},{4,18816}]',721276,'[{16050001,5,15}]','[{100,[{16050001,63022}]}]'),(2,330,345,'[{2,252311},{4,18924}]',725411,'[{16050001,5,15}]','[{100,[{16050001,63137}]}]'),(2,331,345,'[{2,253746},{4,19031}]',729521,'[{16050001,5,15}]','[{100,[{16050001,63252}]}]'),(2,332,345,'[{2,255201},{4,19141}]',733726,'[{16050001,5,15}]','[{100,[{16050001,63367}]}]'),(2,333,345,'[{2,256656},{4,19250}]',737906,'[{16050001,5,15}]','[{100,[{16050001,63482}]}]'),(2,334,345,'[{2,258112},{4,19359}]',742087,'[{16050001,5,15}]','[{100,[{16050001,63597}]}]'),(2,335,345,'[{2,259567},{4,19468}]',746267,'[{16050001,5,15}]','[{100,[{16050001,63712}]}]'),(2,336,345,'[{2,261023},{4,19577}]',750448,'[{16050001,5,15}]','[{100,[{16050001,63827}]}]'),(2,337,345,'[{2,262498},{4,19688}]',754698,'[{16050001,5,15}]','[{100,[{16050001,63942}]}]'),(2,338,345,'[{2,263974},{4,19799}]',758949,'[{16050001,5,15}]','[{100,[{16050001,64057}]}]'),(2,339,360,'[{2,265450},{4,19909}]',763175,'[{16050001,5,15}]','[{100,[{16050001,64172}]}]'),(2,340,360,'[{2,266926},{4,20020}]',767426,'[{16050001,5,15}]','[{100,[{16050001,64292}]}]'),(2,341,360,'[{2,268402},{4,20131}]',771677,'[{16050001,5,15}]','[{100,[{16050001,64412}]}]'),(2,342,360,'[{2,269898},{4,20243}]',775973,'[{16050001,5,15}]','[{100,[{16050001,64532}]}]'),(2,343,360,'[{2,271395},{4,20355}]',780270,'[{16050001,5,15}]','[{100,[{16050001,64652}]}]'),(2,344,360,'[{2,272891},{4,20467}]',784566,'[{16050001,5,15}]','[{100,[{16050001,64772}]}]'),(2,345,360,'[{2,274387},{4,20580}]',788887,'[{16050001,5,15}]','[{100,[{16050001,64892}]}]'),(2,346,360,'[{2,275884},{4,20692}]',793184,'[{16050001,5,15}]','[{100,[{16050001,65012}]}]'),(2,347,360,'[{2,277400},{4,20805}]',797525,'[{16050001,5,15}]','[{100,[{16050001,65132}]}]'),(2,348,360,'[{2,278917},{4,20919}]',801892,'[{16050001,5,15}]','[{100,[{16050001,65252}]}]'),(2,349,360,'[{2,280434},{4,21033}]',806259,'[{16050001,5,15}]','[{100,[{16050001,65372}]}]'),(2,350,360,'[{2,281951},{4,21147}]',810626,'[{16050001,5,15}]','[{100,[{16050001,65492}]}]'),(2,351,360,'[{2,283468},{4,21261}]',814993,'[{16050001,5,15}]','[{100,[{16050001,65612}]}]'),(2,352,360,'[{2,285005},{4,21376}]',819405,'[{16050001,5,15}]','[{100,[{16050001,65732}]}]'),(2,353,360,'[{2,286543},{4,21491}]',823818,'[{16050001,5,15}]','[{100,[{16050001,65852}]}]'),(2,354,375,'[{2,288080},{4,21606}]',828230,'[{16050001,5,15}]','[{100,[{16050001,65972}]}]'),(2,355,375,'[{2,289617},{4,21722}]',832667,'[{16050001,5,15}]','[{100,[{16050001,66097}]}]'),(2,356,375,'[{2,291155},{4,21837}]',837080,'[{16050001,5,15}]','[{100,[{16050001,66222}]}]'),(2,357,375,'[{2,292712},{4,21954}]',841562,'[{16050001,5,15}]','[{100,[{16050001,66347}]}]'),(2,358,375,'[{2,294270},{4,22071}]',846045,'[{16050001,5,15}]','[{100,[{16050001,66472}]}]'),(2,359,375,'[{2,295828},{4,22188}]',850528,'[{16050001,5,15}]','[{100,[{16050001,66597}]}]'),(2,360,375,'[{2,297386},{4,22304}]',854986,'[{16050001,5,15}]','[{100,[{16050001,66722}]}]'),(2,361,375,'[{2,298944},{4,22421}]',859469,'[{16050001,5,15}]','[{100,[{16050001,66847}]}]'),(2,362,375,'[{2,300522},{4,22540}]',864022,'[{16050001,5,15}]','[{100,[{16050001,66972}]}]'),(2,363,375,'[{2,302101},{4,22658}]',868551,'[{16050001,5,15}]','[{100,[{16050001,67097}]}]'),(2,364,375,'[{2,303679},{4,22776}]',873079,'[{16050001,5,15}]','[{100,[{16050001,67222}]}]'),(2,365,375,'[{2,305257},{4,22895}]',877632,'[{16050001,5,15}]','[{100,[{16050001,67347}]}]'),(2,366,375,'[{2,306836},{4,23013}]',882161,'[{16050001,5,15}]','[{100,[{16050001,67472}]}]'),(2,367,375,'[{2,308434},{4,23133}]',886759,'[{16050001,5,15}]','[{100,[{16050001,67597}]}]'),(2,368,375,'[{2,310033},{4,23253}]',891358,'[{16050001,5,15}]','[{100,[{16050001,67722}]}]'),(2,369,390,'[{2,311632},{4,23373}]',895957,'[{16050001,5,15}]','[{100,[{16050001,67847}]}]'),(2,370,390,'[{2,313231},{4,23493}]',900556,'[{16050001,5,15}]','[{100,[{16050001,67977}]}]'),(2,371,390,'[{2,314830},{4,23613}]',905155,'[{16050001,5,15}]','[{100,[{16050001,68107}]}]'),(2,372,390,'[{2,316449},{4,23734}]',909799,'[{16050001,5,15}]','[{100,[{16050001,68237}]}]'),(2,373,390,'[{2,318069},{4,23856}]',914469,'[{16050001,5,15}]','[{100,[{16050001,68367}]}]'),(2,374,390,'[{2,319688},{4,23977}]',919113,'[{16050001,5,15}]','[{100,[{16050001,68497}]}]'),(2,375,390,'[{2,321307},{4,24099}]',923782,'[{16050001,5,15}]','[{100,[{16050001,68627}]}]'),(2,376,390,'[{2,322927},{4,24220}]',928427,'[{16050001,5,15}]','[{100,[{16050001,68757}]}]'),(2,377,390,'[{2,324566},{4,24343}]',933141,'[{16050001,5,15}]','[{100,[{16050001,68887}]}]'),(2,378,390,'[{2,326206},{4,24466}]',937856,'[{16050001,5,15}]','[{100,[{16050001,69017}]}]'),(2,379,390,'[{2,327846},{4,24589}]',942571,'[{16050001,5,15}]','[{100,[{16050001,69147}]}]'),(2,380,390,'[{2,329486},{4,24712}]',947286,'[{16050001,5,15}]','[{100,[{16050001,69277}]}]'),(2,381,390,'[{2,331126},{4,24835}]',952001,'[{16050001,5,15}]','[{100,[{16050001,69407}]}]'),(2,382,390,'[{2,332786},{4,24959}]',956761,'[{16050001,5,15}]','[{100,[{16050001,69537}]}]'),(2,383,390,'[{2,334446},{4,25084}]',961546,'[{16050001,5,15}]','[{100,[{16050001,69667}]}]'),(2,384,405,'[{2,336107},{4,25208}]',966307,'[{16050001,5,15}]','[{100,[{16050001,69797}]}]'),(2,385,405,'[{2,337767},{4,25333}]',971092,'[{16050001,5,15}]','[{100,[{16050001,69932}]}]'),(2,386,405,'[{2,339428},{4,25458}]',975878,'[{16050001,5,15}]','[{100,[{16050001,70067}]}]'),(2,387,405,'[{2,341108},{4,25584}]',980708,'[{16050001,5,15}]','[{100,[{16050001,70202}]}]'),(2,388,405,'[{2,342789},{4,25710}]',985539,'[{16050001,5,15}]','[{100,[{16050001,70337}]}]'),(2,389,405,'[{2,344470},{4,25836}]',990370,'[{16050001,5,15}]','[{100,[{16050001,70472}]}]'),(2,390,405,'[{2,346151},{4,25962}]',995201,'[{16050001,5,15}]','[{100,[{16050001,70607}]}]'),(2,391,405,'[{2,347832},{4,26088}]',1000032,'[{16050001,5,15}]','[{100,[{16050001,70742}]}]'),(2,392,405,'[{2,349533},{4,26215}]',1004908,'[{16050001,5,15}]','[{100,[{16050001,70877}]}]'),(2,393,405,'[{2,351234},{4,26343}]',1009809,'[{16050001,5,15}]','[{100,[{16050001,71012}]}]'),(2,394,405,'[{2,352936},{4,26471}]',1014711,'[{16050001,5,15}]','[{100,[{16050001,71147}]}]'),(2,395,405,'[{2,354637},{4,26598}]',1019587,'[{16050001,5,15}]','[{100,[{16050001,71282}]}]'),(2,396,405,'[{2,356338},{4,26726}]',1024488,'[{16050001,5,15}]','[{100,[{16050001,71417}]}]'),(2,397,405,'[{2,358060},{4,26855}]',1029435,'[{16050001,5,15}]','[{100,[{16050001,71552}]}]'),(2,398,405,'[{2,359782},{4,26984}]',1034382,'[{16050001,5,15}]','[{100,[{16050001,71687}]}]'),(2,399,420,'[{2,361504},{4,27113}]',1039329,'[{16050001,5,15}]','[{100,[{16050001,71822}]}]'),(2,400,420,'[{2,363226},{4,27242}]',1044276,'[{16050001,5,15}]','[{100,[{16050001,71962}]}]'),(2,401,414,'[{2,364948},{4,27372}]',1049248,'[{16050001,6,18}]','[{100,[{16050001,72102}]}]'),(2,402,414,'[{2,366690},{4,27502}]',1054240,'[{16050001,6,18}]','[{100,[{16050001,72240}]}]'),(2,403,414,'[{2,368432},{4,27633}]',1059257,'[{16050001,6,18}]','[{100,[{16050001,72378}]}]'),(2,404,414,'[{2,370175},{4,27764}]',1064275,'[{16050001,6,18}]','[{100,[{16050001,72516}]}]'),(2,405,414,'[{2,371917},{4,27894}]',1069267,'[{16050001,6,18}]','[{100,[{16050001,72654}]}]'),(2,406,414,'[{2,373659},{4,28025}]',1074284,'[{16050001,6,18}]','[{100,[{16050001,72792}]}]'),(2,407,414,'[{2,375422},{4,28157}]',1079347,'[{16050001,6,18}]','[{100,[{16050001,72930}]}]'),(2,408,432,'[{2,377185},{4,28289}]',1084410,'[{16050001,6,18}]','[{100,[{16050001,73068}]}]'),(2,409,432,'[{2,378948},{4,28422}]',1089498,'[{16050001,6,18}]','[{100,[{16050001,73212}]}]'),(2,410,432,'[{2,380711},{4,28554}]',1094561,'[{16050001,6,18}]','[{100,[{16050001,73356}]}]'),(2,411,432,'[{2,382473},{4,28686}]',1099623,'[{16050001,6,18}]','[{100,[{16050001,73500}]}]'),(2,412,432,'[{2,384257},{4,28820}]',1104757,'[{16050001,6,18}]','[{100,[{16050001,73644}]}]'),(2,413,432,'[{2,386040},{4,28953}]',1109865,'[{16050001,6,18}]','[{100,[{16050001,73788}]}]'),(2,414,432,'[{2,387823},{4,29087}]',1114998,'[{16050001,6,18}]','[{100,[{16050001,73932}]}]'),(2,415,432,'[{2,389607},{4,29221}]',1120132,'[{16050001,6,18}]','[{100,[{16050001,74076}]}]'),(2,416,432,'[{2,391390},{4,29355}]',1125265,'[{16050001,6,18}]','[{100,[{16050001,74220}]}]'),(2,417,432,'[{2,393194},{4,29490}]',1130444,'[{16050001,6,18}]','[{100,[{16050001,74364}]}]'),(2,418,432,'[{2,394998},{4,29625}]',1135623,'[{16050001,6,18}]','[{100,[{16050001,74508}]}]'),(2,419,432,'[{2,396802},{4,29761}]',1140827,'[{16050001,6,18}]','[{100,[{16050001,74652}]}]'),(2,420,432,'[{2,398605},{4,29896}]',1146005,'[{16050001,6,18}]','[{100,[{16050001,74796}]}]'),(2,421,432,'[{2,400409},{4,30031}]',1151184,'[{16050001,6,18}]','[{100,[{16050001,74940}]}]'),(2,422,432,'[{2,402234},{4,30168}]',1156434,'[{16050001,6,18}]','[{100,[{16050001,75084}]}]'),(2,423,432,'[{2,404058},{4,30305}]',1161683,'[{16050001,6,18}]','[{100,[{16050001,75228}]}]'),(2,424,432,'[{2,405882},{4,30442}]',1166932,'[{16050001,6,18}]','[{100,[{16050001,75372}]}]'),(2,425,432,'[{2,407706},{4,30578}]',1172156,'[{16050001,6,18}]','[{100,[{16050001,75516}]}]'),(2,426,450,'[{2,409531},{4,30715}]',1177406,'[{16050001,6,18}]','[{100,[{16050001,75660}]}]'),(2,427,450,'[{2,411376},{4,30854}]',1182726,'[{16050001,6,18}]','[{100,[{16050001,75810}]}]'),(2,428,450,'[{2,413220},{4,30992}]',1188020,'[{16050001,6,18}]','[{100,[{16050001,75960}]}]'),(2,429,450,'[{2,415065},{4,31130}]',1193315,'[{16050001,6,18}]','[{100,[{16050001,76110}]}]'),(2,430,450,'[{2,416910},{4,31269}]',1198635,'[{16050001,6,18}]','[{100,[{16050001,76260}]}]'),(2,431,450,'[{2,418755},{4,31407}]',1203930,'[{16050001,6,18}]','[{100,[{16050001,76410}]}]'),(2,432,450,'[{2,420620},{4,31547}]',1209295,'[{16050001,6,18}]','[{100,[{16050001,76560}]}]'),(2,433,450,'[{2,422486},{4,31687}]',1214661,'[{16050001,6,18}]','[{100,[{16050001,76710}]}]'),(2,434,450,'[{2,424351},{4,31827}]',1220026,'[{16050001,6,18}]','[{100,[{16050001,76860}]}]'),(2,435,450,'[{2,426216},{4,31967}]',1225391,'[{16050001,6,18}]','[{100,[{16050001,77010}]}]'),(2,436,450,'[{2,428082},{4,32107}]',1230757,'[{16050001,6,18}]','[{100,[{16050001,77160}]}]'),(2,437,450,'[{2,429967},{4,32248}]',1236167,'[{16050001,6,18}]','[{100,[{16050001,77310}]}]'),(2,438,450,'[{2,431853},{4,32389}]',1241578,'[{16050001,6,18}]','[{100,[{16050001,77460}]}]'),(2,439,450,'[{2,433739},{4,32531}]',1247014,'[{16050001,6,18}]','[{100,[{16050001,77610}]}]'),(2,440,450,'[{2,435625},{4,32672}]',1252425,'[{16050001,6,18}]','[{100,[{16050001,77760}]}]'),(2,441,450,'[{2,437511},{4,32814}]',1257861,'[{16050001,6,18}]','[{100,[{16050001,77910}]}]'),(2,442,450,'[{2,439417},{4,32957}]',1263342,'[{16050001,6,18}]','[{100,[{16050001,78060}]}]'),(2,443,450,'[{2,441323},{4,33100}]',1268823,'[{16050001,6,18}]','[{100,[{16050001,78210}]}]'),(2,444,468,'[{2,443230},{4,33243}]',1274305,'[{16050001,6,18}]','[{100,[{16050001,78360}]}]'),(2,445,468,'[{2,445136},{4,33386}]',1279786,'[{16050001,6,18}]','[{100,[{16050001,78516}]}]'),(2,446,468,'[{2,447042},{4,33529}]',1285267,'[{16050001,6,18}]','[{100,[{16050001,78672}]}]'),(2,447,468,'[{2,448969},{4,33673}]',1290794,'[{16050001,6,18}]','[{100,[{16050001,78828}]}]'),(2,448,468,'[{2,450896},{4,33818}]',1296346,'[{16050001,6,18}]','[{100,[{16050001,78984}]}]'),(2,449,468,'[{2,452823},{4,33962}]',1301873,'[{16050001,6,18}]','[{100,[{16050001,79140}]}]'),(2,450,468,'[{2,454749},{4,34107}]',1307424,'[{16050001,6,18}]','[{100,[{16050001,79296}]}]'),(2,451,468,'[{2,456676},{4,34251}]',1312951,'[{16050001,6,18}]','[{100,[{16050001,79452}]}]'),(2,452,468,'[{2,458624},{4,34397}]',1318549,'[{16050001,6,18}]','[{100,[{16050001,79608}]}]'),(2,453,468,'[{2,460571},{4,34543}]',1324146,'[{16050001,6,18}]','[{100,[{16050001,79764}]}]'),(2,454,468,'[{2,462518},{4,34689}]',1329743,'[{16050001,6,18}]','[{100,[{16050001,79920}]}]'),(2,455,468,'[{2,464466},{4,34835}]',1335341,'[{16050001,6,18}]','[{100,[{16050001,80076}]}]'),(2,456,468,'[{2,466413},{4,34981}]',1340938,'[{16050001,6,18}]','[{100,[{16050001,80232}]}]'),(2,457,468,'[{2,468381},{4,35129}]',1346606,'[{16050001,6,18}]','[{100,[{16050001,80388}]}]'),(2,458,468,'[{2,470348},{4,35277}]',1352273,'[{16050001,6,18}]','[{100,[{16050001,80544}]}]'),(2,459,468,'[{2,472316},{4,35424}]',1357916,'[{16050001,6,18}]','[{100,[{16050001,80700}]}]'),(2,460,468,'[{2,474284},{4,35572}]',1363584,'[{16050001,6,18}]','[{100,[{16050001,80856}]}]'),(2,461,468,'[{2,476252},{4,35719}]',1369227,'[{16050001,6,18}]','[{100,[{16050001,81012}]}]'),(2,462,486,'[{2,478240},{4,35868}]',1374940,'[{16050001,6,18}]','[{100,[{16050001,81168}]}]'),(2,463,486,'[{2,480229},{4,36018}]',1380679,'[{16050001,6,18}]','[{100,[{16050001,81330}]}]'),(2,464,486,'[{2,482217},{4,36167}]',1386392,'[{16050001,6,18}]','[{100,[{16050001,81492}]}]'),(2,465,486,'[{2,484205},{4,36316}]',1392105,'[{16050001,6,18}]','[{100,[{16050001,81654}]}]'),(2,466,486,'[{2,486193},{4,36465}]',1397818,'[{16050001,6,18}]','[{100,[{16050001,81816}]}]'),(2,467,486,'[{2,488202},{4,36616}]',1403602,'[{16050001,6,18}]','[{100,[{16050001,81978}]}]'),(2,468,486,'[{2,490211},{4,36766}]',1409361,'[{16050001,6,18}]','[{100,[{16050001,82140}]}]'),(2,469,486,'[{2,492220},{4,36917}]',1415145,'[{16050001,6,18}]','[{100,[{16050001,82302}]}]'),(2,470,486,'[{2,494229},{4,37068}]',1420929,'[{16050001,6,18}]','[{100,[{16050001,82464}]}]'),(2,471,486,'[{2,496238},{4,37218}]',1426688,'[{16050001,6,18}]','[{100,[{16050001,82626}]}]'),(2,472,486,'[{2,498267},{4,37370}]',1432517,'[{16050001,6,18}]','[{100,[{16050001,82788}]}]'),(2,473,486,'[{2,500296},{4,37523}]',1438371,'[{16050001,6,18}]','[{100,[{16050001,82950}]}]'),(2,474,486,'[{2,502325},{4,37675}]',1444200,'[{16050001,6,18}]','[{100,[{16050001,83112}]}]'),(2,475,486,'[{2,504355},{4,37827}]',1450030,'[{16050001,6,18}]','[{100,[{16050001,83274}]}]'),(2,476,486,'[{2,506384},{4,37979}]',1455859,'[{16050001,6,18}]','[{100,[{16050001,83436}]}]'),(2,477,486,'[{2,508434},{4,38133}]',1461759,'[{16050001,6,18}]','[{100,[{16050001,83598}]}]'),(2,478,486,'[{2,510484},{4,38287}]',1467659,'[{16050001,6,18}]','[{100,[{16050001,83760}]}]'),(2,479,486,'[{2,512533},{4,38440}]',1473533,'[{16050001,6,18}]','[{100,[{16050001,83922}]}]'),(2,480,504,'[{2,514583},{4,38594}]',1479433,'[{16050001,6,18}]','[{100,[{16050001,84084}]}]'),(2,481,504,'[{2,516633},{4,38748}]',1485333,'[{16050001,6,18}]','[{100,[{16050001,84252}]}]'),(2,482,504,'[{2,518703},{4,38903}]',1491278,'[{16050001,6,18}]','[{100,[{16050001,84420}]}]'),(2,483,504,'[{2,520774},{4,39058}]',1497224,'[{16050001,6,18}]','[{100,[{16050001,84588}]}]'),(2,484,504,'[{2,522844},{4,39214}]',1503194,'[{16050001,6,18}]','[{100,[{16050001,84756}]}]'),(2,485,504,'[{2,524914},{4,39369}]',1509139,'[{16050001,6,18}]','[{100,[{16050001,84924}]}]'),(2,486,504,'[{2,526985},{4,39524}]',1515085,'[{16050001,6,18}]','[{100,[{16050001,85092}]}]'),(2,487,504,'[{2,529075},{4,39681}]',1521100,'[{16050001,6,18}]','[{100,[{16050001,85260}]}]'),(2,488,504,'[{2,531166},{4,39838}]',1527116,'[{16050001,6,18}]','[{100,[{16050001,85428}]}]'),(2,489,504,'[{2,533257},{4,39995}]',1533132,'[{16050001,6,18}]','[{100,[{16050001,85596}]}]'),(2,490,504,'[{2,535348},{4,40152}]',1539148,'[{16050001,6,18}]','[{100,[{16050001,85764}]}]'),(2,491,504,'[{2,537439},{4,40308}]',1545139,'[{16050001,6,18}]','[{100,[{16050001,85932}]}]'),(2,492,504,'[{2,539550},{4,40467}]',1551225,'[{16050001,6,18}]','[{100,[{16050001,86100}]}]'),(2,493,504,'[{2,541661},{4,40625}]',1557286,'[{16050001,6,18}]','[{100,[{16050001,86268}]}]'),(2,494,504,'[{2,543772},{4,40783}]',1563347,'[{16050001,6,18}]','[{100,[{16050001,86436}]}]'),(2,495,504,'[{2,545884},{4,40942}]',1569434,'[{16050001,6,18}]','[{100,[{16050001,86604}]}]'),(2,496,504,'[{2,547995},{4,41100}]',1575495,'[{16050001,6,18}]','[{100,[{16050001,86772}]}]'),(2,497,504,'[{2,550127},{4,41260}]',1581627,'[{16050001,6,18}]','[{100,[{16050001,86940}]}]'),(2,498,522,'[{2,552259},{4,41420}]',1587759,'[{16050001,6,18}]','[{100,[{16050001,87108}]}]'),(2,499,522,'[{2,554390},{4,41580}]',1593890,'[{16050001,6,18}]','[{100,[{16050001,87282}]}]'),(2,500,522,'[{2,556522},{4,41740}]',1600022,'[]','[{100,[{16050001,87456}]}]'),(3,1,9,'[{1,5},{5,4}]',300,'[{16050001,1,3}]','[{100,[{16050001,87630}]}]'),(3,2,9,'[{1,10},{5,7}]',550,'[{16050001,1,3}]','[{100,[{16050001,87633}]}]'),(3,3,12,'[{1,15},{5,11}]',850,'[{16050001,1,3}]','[{100,[{16050001,87636}]}]'),(3,4,12,'[{1,20},{5,15}]',1150,'[{16050001,1,3}]','[{100,[{16050001,87640}]}]'),(3,5,12,'[{1,25},{5,19}]',1450,'[{16050001,1,3}]','[{100,[{16050001,87644}]}]'),(3,6,15,'[{1,30},{5,23}]',1750,'[{16050001,1,3}]','[{100,[{16050001,87648}]}]'),(3,7,15,'[{1,36},{5,27}]',2070,'[{16050001,1,3}]','[{100,[{16050001,87653}]}]'),(3,8,15,'[{1,43},{5,32}]',2460,'[{16050001,1,3}]','[{100,[{16050001,87658}]}]'),(3,9,18,'[{1,49},{5,37}]',2830,'[{16050001,1,3}]','[{100,[{16050001,87663}]}]'),(3,10,18,'[{1,55},{5,41}]',3150,'[{16050001,1,3}]','[{100,[{16050001,87669}]}]'),(3,11,18,'[{1,61},{5,46}]',3520,'[{16050001,1,3}]','[{100,[{16050001,87675}]}]'),(3,12,21,'[{1,68},{5,51}]',3910,'[{16050001,1,3}]','[{100,[{16050001,87681}]}]'),(3,13,21,'[{1,75},{5,57}]',4350,'[{16050001,1,3}]','[{100,[{16050001,87688}]}]'),(3,14,21,'[{1,82},{5,62}]',4740,'[{16050001,1,3}]','[{100,[{16050001,87695}]}]'),(3,15,24,'[{1,90},{5,67}]',5150,'[{16050001,1,3}]','[{100,[{16050001,87702}]}]'),(3,16,24,'[{1,97},{5,73}]',5590,'[{16050001,2,6}]','[{100,[{16050001,87710}]}]'),(3,17,24,'[{1,105},{5,79}]',6050,'[{16050001,2,6}]','[{100,[{16050001,87718}]}]'),(3,18,30,'[{1,113},{5,85}]',6510,'[{16050001,2,6}]','[{100,[{16050001,87726}]}]'),(3,19,30,'[{1,121},{5,91}]',6970,'[{16050001,2,6}]','[{100,[{16050001,87736}]}]'),(3,20,30,'[{1,130},{5,97}]',7450,'[{16050001,2,6}]','[{100,[{16050001,87746}]}]'),(3,21,30,'[{1,138},{5,104}]',7960,'[{16050001,2,6}]','[{100,[{16050001,87756}]}]'),(3,22,30,'[{1,147},{5,110}]',8440,'[{16050001,2,6}]','[{100,[{16050001,87766}]}]'),(3,23,30,'[{1,156},{5,117}]',8970,'[{16050001,2,6}]','[{100,[{16050001,87776}]}]'),(3,24,36,'[{1,166},{5,124}]',9520,'[{16050001,2,6}]','[{100,[{16050001,87786}]}]'),(3,25,36,'[{1,175},{5,131}]',10050,'[{16050001,2,6}]','[{100,[{16050001,87798}]}]'),(3,26,36,'[{1,184},{5,138}]',10580,'[{16050001,2,6}]','[{100,[{16050001,87810}]}]'),(3,27,36,'[{1,194},{5,146}]',11180,'[{16050001,2,6}]','[{100,[{16050001,87822}]}]'),(3,28,36,'[{1,204},{5,153}]',11730,'[{16050001,2,6}]','[{100,[{16050001,87834}]}]'),(3,29,36,'[{1,215},{5,161}]',12350,'[{16050001,2,6}]','[{100,[{16050001,87846}]}]'),(3,30,42,'[{1,225},{5,169}]',12950,'[{16050001,2,6}]','[{100,[{16050001,87858}]}]'),(3,31,42,'[{1,235},{5,177}]',13550,'[{16050001,2,6}]','[{100,[{16050001,87872}]}]'),(3,32,42,'[{1,246},{5,185}]',14170,'[{16050001,2,6}]','[{100,[{16050001,87886}]}]'),(3,33,42,'[{1,258},{5,193}]',14810,'[{16050001,2,6}]','[{100,[{16050001,87900}]}]'),(3,34,42,'[{1,269},{5,202}]',15480,'[{16050001,2,6}]','[{100,[{16050001,87914}]}]'),(3,35,42,'[{1,280},{5,210}]',16100,'[{16050001,2,6}]','[{100,[{16050001,87928}]}]'),(3,36,48,'[{1,292},{5,219}]',16790,'[{16050001,2,6}]','[{100,[{16050001,87942}]}]'),(3,37,48,'[{1,304},{5,228}]',17480,'[{16050001,2,6}]','[{100,[{16050001,87958}]}]'),(3,38,48,'[{1,316},{5,237}]',18170,'[{16050001,2,6}]','[{100,[{16050001,87974}]}]'),(3,39,48,'[{1,328},{5,246}]',18860,'[{16050001,2,6}]','[{100,[{16050001,87990}]}]'),(3,40,48,'[{1,341},{5,256}]',19620,'[{16050001,2,6}]','[{100,[{16050001,88006}]}]'),(3,41,48,'[{1,353},{5,265}]',20310,'[{16050001,2,6}]','[{100,[{16050001,88022}]}]'),(3,42,54,'[{1,366},{5,275}]',21070,'[{16050001,2,6}]','[{100,[{16050001,88038}]}]'),(3,43,54,'[{1,380},{5,285}]',21850,'[{16050001,2,6}]','[{100,[{16050001,88056}]}]'),(3,44,54,'[{1,393},{5,295}]',22610,'[{16050001,2,6}]','[{100,[{16050001,88074}]}]'),(3,45,54,'[{1,406},{5,305}]',23370,'[{16050001,2,6}]','[{100,[{16050001,88092}]}]'),(3,46,54,'[{1,420},{5,315}]',24150,'[{16050001,2,6}]','[{100,[{16050001,88110}]}]'),(3,47,54,'[{1,434},{5,326}]',24980,'[{16050001,2,6}]','[{100,[{16050001,88128}]}]'),(3,48,60,'[{1,448},{5,336}]',25760,'[{16050001,2,6}]','[{100,[{16050001,88146}]}]'),(3,49,60,'[{1,463},{5,347}]',26610,'[{16050001,2,6}]','[{100,[{16050001,88166}]}]'),(3,50,60,'[{1,477},{5,358}]',27440,'[{16050001,2,6}]','[{100,[{16050001,88186}]}]'),(3,51,60,'[{1,491},{5,369}]',28270,'[{16050001,2,6}]','[{100,[{16050001,88206}]}]'),(3,52,60,'[{1,507},{5,380}]',29140,'[{16050001,2,6}]','[{100,[{16050001,88226}]}]'),(3,53,60,'[{1,522},{5,392}]',30040,'[{16050001,2,6}]','[{100,[{16050001,88246}]}]'),(3,54,66,'[{1,538},{5,403}]',30910,'[{16050001,2,6}]','[{100,[{16050001,88266}]}]'),(3,55,66,'[{1,553},{5,415}]',31810,'[{16050001,2,6}]','[{100,[{16050001,88288}]}]'),(3,56,66,'[{1,568},{5,426}]',32660,'[{16050001,2,6}]','[{100,[{16050001,88310}]}]'),(3,57,66,'[{1,585},{5,439}]',33650,'[{16050001,2,6}]','[{100,[{16050001,88332}]}]'),(3,58,66,'[{1,601},{5,451}]',34570,'[{16050001,2,6}]','[{100,[{16050001,88354}]}]'),(3,59,66,'[{1,617},{5,463}]',35490,'[{16050001,2,6}]','[{100,[{16050001,88376}]}]'),(3,60,72,'[{1,634},{5,476}]',36480,'[{16050001,2,6}]','[{100,[{16050001,88398}]}]'),(3,61,72,'[{1,650},{5,488}]',37400,'[{16050001,2,6}]','[{100,[{16050001,88422}]}]'),(3,62,72,'[{1,668},{5,501}]',38410,'[{16050001,2,6}]','[{100,[{16050001,88446}]}]'),(3,63,72,'[{1,685},{5,514}]',39400,'[{16050001,2,6}]','[{100,[{16050001,88470}]}]'),(3,64,72,'[{1,703},{5,527}]',40410,'[{16050001,2,6}]','[{100,[{16050001,88494}]}]'),(3,65,72,'[{1,720},{5,540}]',41400,'[{16050001,2,6}]','[{100,[{16050001,88518}]}]'),(3,66,78,'[{1,737},{5,553}]',42390,'[{16050001,2,6}]','[{100,[{16050001,88542}]}]'),(3,67,78,'[{1,756},{5,567}]',43470,'[{16050001,2,6}]','[{100,[{16050001,88568}]}]'),(3,68,78,'[{1,774},{5,581}]',44530,'[{16050001,2,6}]','[{100,[{16050001,88594}]}]'),(3,69,78,'[{1,793},{5,595}]',45610,'[{16050001,2,6}]','[{100,[{16050001,88620}]}]'),(3,70,78,'[{1,811},{5,609}]',46670,'[{16050001,2,6}]','[{100,[{16050001,88646}]}]'),(3,71,78,'[{1,830},{5,622}]',47700,'[{16050001,2,6}]','[{100,[{16050001,88672}]}]'),(3,72,84,'[{1,849},{5,637}]',48830,'[{16050001,2,6}]','[{100,[{16050001,88698}]}]'),(3,73,84,'[{1,869},{5,652}]',49980,'[{16050001,2,6}]','[{100,[{16050001,88726}]}]'),(3,74,84,'[{1,888},{5,666}]',51060,'[{16050001,2,6}]','[{100,[{16050001,88754}]}]'),(3,75,84,'[{1,908},{5,681}]',52210,'[{16050001,2,6}]','[{100,[{16050001,88782}]}]'),(3,76,84,'[{1,927},{5,695}]',53290,'[{16050001,2,6}]','[{100,[{16050001,88810}]}]'),(3,77,84,'[{1,948},{5,711}]',54510,'[{16050001,2,6}]','[{100,[{16050001,88838}]}]'),(3,78,90,'[{1,968},{5,726}]',55660,'[{16050001,2,6}]','[{100,[{16050001,88866}]}]'),(3,79,90,'[{1,989},{5,742}]',56880,'[{16050001,2,6}]','[{100,[{16050001,88896}]}]'),(3,80,90,'[{1,1009},{5,757}]',58030,'[{16050001,2,6}]','[{100,[{16050001,88926}]}]'),(3,81,90,'[{1,1030},{5,772}]',59200,'[{16050001,2,6}]','[{100,[{16050001,88956}]}]'),(3,82,90,'[{1,1051},{5,788}]',60420,'[{16050001,2,6}]','[{100,[{16050001,88986}]}]'),(3,83,90,'[{1,1073},{5,805}]',61710,'[{16050001,2,6}]','[{100,[{16050001,89016}]}]'),(3,84,96,'[{1,1094},{5,821}]',62930,'[{16050001,2,6}]','[{100,[{16050001,89046}]}]'),(3,85,96,'[{1,1116},{5,837}]',64170,'[{16050001,2,6}]','[{100,[{16050001,89078}]}]'),(3,86,96,'[{1,1137},{5,853}]',65390,'[{16050001,2,6}]','[{100,[{16050001,89110}]}]'),(3,87,96,'[{1,1160},{5,870}]',66700,'[{16050001,2,6}]','[{100,[{16050001,89142}]}]'),(3,88,96,'[{1,1182},{5,887}]',67990,'[{16050001,2,6}]','[{100,[{16050001,89174}]}]'),(3,89,96,'[{1,1205},{5,904}]',69300,'[{16050001,2,6}]','[{100,[{16050001,89206}]}]'),(3,90,102,'[{1,1227},{5,921}]',70590,'[{16050001,2,6}]','[{100,[{16050001,89238}]}]'),(3,91,102,'[{1,1250},{5,938}]',71900,'[{16050001,2,6}]','[{100,[{16050001,89272}]}]'),(3,92,102,'[{1,1273},{5,955}]',73210,'[{16050001,2,6}]','[{100,[{16050001,89306}]}]'),(3,93,102,'[{1,1297},{5,973}]',74590,'[{16050001,2,6}]','[{100,[{16050001,89340}]}]'),(3,94,102,'[{1,1321},{5,991}]',75970,'[{16050001,2,6}]','[{100,[{16050001,89374}]}]'),(3,95,102,'[{1,1344},{5,1008}]',77280,'[{16050001,2,6}]','[{100,[{16050001,89408}]}]'),(3,96,108,'[{1,1368},{5,1026}]',78660,'[{16050001,2,6}]','[{100,[{16050001,89442}]}]'),(3,97,108,'[{1,1392},{5,1044}]',80040,'[{16050001,2,6}]','[{100,[{16050001,89478}]}]'),(3,98,108,'[{1,1417},{5,1063}]',81490,'[{16050001,2,6}]','[{100,[{16050001,89514}]}]'),(3,99,108,'[{1,1442},{5,1081}]',82890,'[{16050001,2,6}]','[{100,[{16050001,89550}]}]'),(3,100,108,'[{1,1466},{5,1100}]',84320,'[{16050001,2,6}]','[{100,[{16050001,89586}]}]'),(3,101,108,'[{1,1491},{5,1118}]',85720,'[{16050001,3,9}]','[{100,[{16050001,89622}]}]'),(3,102,117,'[{1,1516},{5,1137}]',87170,'[{16050001,3,9}]','[{100,[{16050001,89658}]}]'),(3,103,117,'[{1,1542},{5,1157}]',88690,'[{16050001,3,9}]','[{100,[{16050001,89697}]}]'),(3,104,117,'[{1,1568},{5,1176}]',90160,'[{16050001,3,9}]','[{100,[{16050001,89736}]}]'),(3,105,117,'[{1,1593},{5,1195}]',91610,'[{16050001,3,9}]','[{100,[{16050001,89775}]}]'),(3,106,117,'[{1,1619},{5,1214}]',93080,'[{16050001,3,9}]','[{100,[{16050001,89814}]}]'),(3,107,117,'[{1,1645},{5,1234}]',94600,'[{16050001,3,9}]','[{100,[{16050001,89853}]}]'),(3,108,117,'[{1,1672},{5,1254}]',96140,'[{16050001,3,9}]','[{100,[{16050001,89892}]}]'),(3,109,117,'[{1,1699},{5,1274}]',97680,'[{16050001,3,9}]','[{100,[{16050001,89931}]}]'),(3,110,117,'[{1,1725},{5,1294}]',99200,'[{16050001,3,9}]','[{100,[{16050001,89970}]}]'),(3,111,126,'[{1,1752},{5,1314}]',100740,'[{16050001,3,9}]','[{100,[{16050001,90009}]}]'),(3,112,126,'[{1,1780},{5,1335}]',102350,'[{16050001,3,9}]','[{100,[{16050001,90051}]}]'),(3,113,126,'[{1,1807},{5,1356}]',103940,'[{16050001,3,9}]','[{100,[{16050001,90093}]}]'),(3,114,126,'[{1,1835},{5,1376}]',105500,'[{16050001,3,9}]','[{100,[{16050001,90135}]}]'),(3,115,126,'[{1,1863},{5,1397}]',107110,'[{16050001,3,9}]','[{100,[{16050001,90177}]}]'),(3,116,126,'[{1,1890},{5,1418}]',108700,'[{16050001,3,9}]','[{100,[{16050001,90219}]}]'),(3,117,126,'[{1,1919},{5,1439}]',110330,'[{16050001,3,9}]','[{100,[{16050001,90261}]}]'),(3,118,126,'[{1,1948},{5,1461}]',112010,'[{16050001,3,9}]','[{100,[{16050001,90303}]}]'),(3,119,126,'[{1,1977},{5,1483}]',113690,'[{16050001,3,9}]','[{100,[{16050001,90345}]}]'),(3,120,135,'[{1,2005},{5,1504}]',115300,'[{16050001,3,9}]','[{100,[{16050001,90387}]}]'),(3,121,135,'[{1,2034},{5,1526}]',116980,'[{16050001,3,9}]','[{100,[{16050001,90432}]}]'),(3,122,135,'[{1,2064},{5,1548}]',118680,'[{16050001,3,9}]','[{100,[{16050001,90477}]}]'),(3,123,135,'[{1,2093},{5,1570}]',120360,'[{16050001,3,9}]','[{100,[{16050001,90522}]}]'),(3,124,135,'[{1,2123},{5,1592}]',122060,'[{16050001,3,9}]','[{100,[{16050001,90567}]}]'),(3,125,135,'[{1,2153},{5,1615}]',123810,'[{16050001,3,9}]','[{100,[{16050001,90612}]}]'),(3,126,135,'[{1,2183},{5,1637}]',125510,'[{16050001,3,9}]','[{100,[{16050001,90657}]}]'),(3,127,135,'[{1,2213},{5,1660}]',127260,'[{16050001,3,9}]','[{100,[{16050001,90702}]}]'),(3,128,135,'[{1,2244},{5,1683}]',129030,'[{16050001,3,9}]','[{100,[{16050001,90747}]}]'),(3,129,144,'[{1,2275},{5,1706}]',130800,'[{16050001,3,9}]','[{100,[{16050001,90792}]}]'),(3,130,144,'[{1,2306},{5,1729}]',132570,'[{16050001,3,9}]','[{100,[{16050001,90840}]}]'),(3,131,144,'[{1,2336},{5,1752}]',134320,'[{16050001,3,9}]','[{100,[{16050001,90888}]}]'),(3,132,144,'[{1,2368},{5,1776}]',136160,'[{16050001,3,9}]','[{100,[{16050001,90936}]}]'),(3,133,144,'[{1,2400},{5,1800}]',138000,'[{16050001,3,9}]','[{100,[{16050001,90984}]}]'),(3,134,144,'[{1,2432},{5,1824}]',139840,'[{16050001,3,9}]','[{100,[{16050001,91032}]}]'),(3,135,144,'[{1,2463},{5,1848}]',141660,'[{16050001,3,9}]','[{100,[{16050001,91080}]}]'),(3,136,144,'[{1,2495},{5,1871}]',143450,'[{16050001,3,9}]','[{100,[{16050001,91128}]}]'),(3,137,144,'[{1,2528},{5,1896}]',145360,'[{16050001,3,9}]','[{100,[{16050001,91176}]}]'),(3,138,153,'[{1,2561},{5,1921}]',147270,'[{16050001,3,9}]','[{100,[{16050001,91224}]}]'),(3,139,153,'[{1,2594},{5,1945}]',149130,'[{16050001,3,9}]','[{100,[{16050001,91275}]}]'),(3,140,153,'[{1,2626},{5,1970}]',151020,'[{16050001,3,9}]','[{100,[{16050001,91326}]}]'),(3,141,153,'[{1,2659},{5,1994}]',152880,'[{16050001,3,9}]','[{100,[{16050001,91377}]}]'),(3,142,153,'[{1,2693},{5,2020}]',154860,'[{16050001,3,9}]','[{100,[{16050001,91428}]}]'),(3,143,153,'[{1,2727},{5,2045}]',156790,'[{16050001,3,9}]','[{100,[{16050001,91479}]}]'),(3,144,153,'[{1,2761},{5,2071}]',158770,'[{16050001,3,9}]','[{100,[{16050001,91530}]}]'),(3,145,153,'[{1,2794},{5,2096}]',160680,'[{16050001,3,9}]','[{100,[{16050001,91581}]}]'),(3,146,153,'[{1,2828},{5,2121}]',162610,'[{16050001,3,9}]','[{100,[{16050001,91632}]}]'),(3,147,162,'[{1,2863},{5,2147}]',164610,'[{16050001,3,9}]','[{100,[{16050001,91683}]}]'),(3,148,162,'[{1,2898},{5,2174}]',166660,'[{16050001,3,9}]','[{100,[{16050001,91737}]}]'),(3,149,162,'[{1,2933},{5,2200}]',168660,'[{16050001,3,9}]','[{100,[{16050001,91791}]}]'),(3,150,162,'[{1,2968},{5,2226}]',170660,'[{16050001,3,9}]','[{100,[{16050001,91845}]}]'),(3,151,162,'[{1,3002},{5,2252}]',172640,'[{16050001,3,9}]','[{100,[{16050001,91899}]}]'),(3,152,162,'[{1,3038},{5,2279}]',174710,'[{16050001,3,9}]','[{100,[{16050001,91953}]}]'),(3,153,162,'[{1,3074},{5,2306}]',176780,'[{16050001,3,9}]','[{100,[{16050001,92007}]}]'),(3,154,162,'[{1,3110},{5,2333}]',178850,'[{16050001,3,9}]','[{100,[{16050001,92061}]}]'),(3,155,162,'[{1,3146},{5,2360}]',180920,'[{16050001,3,9}]','[{100,[{16050001,92115}]}]'),(3,156,171,'[{1,3182},{5,2386}]',182940,'[{16050001,3,9}]','[{100,[{16050001,92169}]}]'),(3,157,171,'[{1,3219},{5,2414}]',185080,'[{16050001,3,9}]','[{100,[{16050001,92226}]}]'),(3,158,171,'[{1,3256},{5,2442}]',187220,'[{16050001,3,9}]','[{100,[{16050001,92283}]}]'),(3,159,171,'[{1,3292},{5,2469}]',189290,'[{16050001,3,9}]','[{100,[{16050001,92340}]}]'),(3,160,171,'[{1,3329},{5,2497}]',191430,'[{16050001,3,9}]','[{100,[{16050001,92397}]}]'),(3,161,171,'[{1,3366},{5,2525}]',193570,'[{16050001,3,9}]','[{100,[{16050001,92454}]}]'),(3,162,171,'[{1,3404},{5,2553}]',195730,'[{16050001,3,9}]','[{100,[{16050001,92511}]}]'),(3,163,171,'[{1,3442},{5,2582}]',197940,'[{16050001,3,9}]','[{100,[{16050001,92568}]}]'),(3,164,171,'[{1,3480},{5,2610}]',200100,'[{16050001,3,9}]','[{100,[{16050001,92625}]}]'),(3,165,180,'[{1,3518},{5,2639}]',202310,'[{16050001,3,9}]','[{100,[{16050001,92682}]}]'),(3,166,180,'[{1,3556},{5,2667}]',204470,'[{16050001,3,9}]','[{100,[{16050001,92742}]}]'),(3,167,180,'[{1,3595},{5,2696}]',206700,'[{16050001,3,9}]','[{100,[{16050001,92802}]}]'),(3,168,180,'[{1,3634},{5,2725}]',208930,'[{16050001,3,9}]','[{100,[{16050001,92862}]}]'),(3,169,180,'[{1,3673},{5,2755}]',211210,'[{16050001,3,9}]','[{100,[{16050001,92922}]}]'),(3,170,180,'[{1,3712},{5,2784}]',213440,'[{16050001,3,9}]','[{100,[{16050001,92982}]}]'),(3,171,180,'[{1,3751},{5,2813}]',215670,'[{16050001,3,9}]','[{100,[{16050001,93042}]}]'),(3,172,180,'[{1,3791},{5,2843}]',217970,'[{16050001,3,9}]','[{100,[{16050001,93102}]}]'),(3,173,180,'[{1,3831},{5,2873}]',220270,'[{16050001,3,9}]','[{100,[{16050001,93162}]}]'),(3,174,189,'[{1,3871},{5,2903}]',222570,'[{16050001,3,9}]','[{100,[{16050001,93222}]}]'),(3,175,189,'[{1,3911},{5,2933}]',224870,'[{16050001,3,9}]','[{100,[{16050001,93285}]}]'),(3,176,189,'[{1,3950},{5,2963}]',227150,'[{16050001,3,9}]','[{100,[{16050001,93348}]}]'),(3,177,189,'[{1,3991},{5,2994}]',229520,'[{16050001,3,9}]','[{100,[{16050001,93411}]}]'),(3,178,189,'[{1,4032},{5,3024}]',231840,'[{16050001,3,9}]','[{100,[{16050001,93474}]}]'),(3,179,189,'[{1,4073},{5,3055}]',234210,'[{16050001,3,9}]','[{100,[{16050001,93537}]}]'),(3,180,189,'[{1,4114},{5,3086}]',236580,'[{16050001,3,9}]','[{100,[{16050001,93600}]}]'),(3,181,189,'[{1,4155},{5,3117}]',238950,'[{16050001,3,9}]','[{100,[{16050001,93663}]}]'),(3,182,189,'[{1,4197},{5,3148}]',241340,'[{16050001,3,9}]','[{100,[{16050001,93726}]}]'),(3,183,198,'[{1,4239},{5,3180}]',243780,'[{16050001,3,9}]','[{100,[{16050001,93789}]}]'),(3,184,198,'[{1,4282},{5,3211}]',246190,'[{16050001,3,9}]','[{100,[{16050001,93855}]}]'),(3,185,198,'[{1,4324},{5,3243}]',248630,'[{16050001,3,9}]','[{100,[{16050001,93921}]}]'),(3,186,198,'[{1,4366},{5,3274}]',251020,'[{16050001,3,9}]','[{100,[{16050001,93987}]}]'),(3,187,198,'[{1,4409},{5,3307}]',253530,'[{16050001,3,9}]','[{100,[{16050001,94053}]}]'),(3,188,198,'[{1,4452},{5,3339}]',255990,'[{16050001,3,9}]','[{100,[{16050001,94119}]}]'),(3,189,198,'[{1,4495},{5,3371}]',258450,'[{16050001,3,9}]','[{100,[{16050001,94185}]}]'),(3,190,198,'[{1,4538},{5,3403}]',260910,'[{16050001,3,9}]','[{100,[{16050001,94251}]}]'),(3,191,198,'[{1,4581},{5,3436}]',263420,'[{16050001,3,9}]','[{100,[{16050001,94317}]}]'),(3,192,207,'[{1,4625},{5,3469}]',265950,'[{16050001,3,9}]','[{100,[{16050001,94383}]}]'),(3,193,207,'[{1,4669},{5,3502}]',268480,'[{16050001,3,9}]','[{100,[{16050001,94452}]}]'),(3,194,207,'[{1,4713},{5,3535}]',271010,'[{16050001,3,9}]','[{100,[{16050001,94521}]}]'),(3,195,207,'[{1,4757},{5,3568}]',273540,'[{16050001,3,9}]','[{100,[{16050001,94590}]}]'),(3,196,207,'[{1,4801},{5,3601}]',276070,'[{16050001,3,9}]','[{100,[{16050001,94659}]}]'),(3,197,207,'[{1,4846},{5,3635}]',278670,'[{16050001,3,9}]','[{100,[{16050001,94728}]}]'),(3,198,207,'[{1,4891},{5,3669}]',281270,'[{16050001,3,9}]','[{100,[{16050001,94797}]}]'),(3,199,207,'[{1,4936},{5,3702}]',283820,'[{16050001,3,9}]','[{100,[{16050001,94866}]}]'),(3,200,207,'[{1,4982},{5,3736}]',286440,'[{16050001,3,9}]','[{100,[{16050001,94935}]}]'),(3,201,216,'[{1,5027},{5,3770}]',289040,'[{16050001,4,12}]','[{100,[{16050001,95004}]}]'),(3,202,216,'[{1,5073},{5,3805}]',291710,'[{16050001,4,12}]','[{100,[{16050001,95076}]}]'),(3,203,216,'[{1,5119},{5,3839}]',294330,'[{16050001,4,12}]','[{100,[{16050001,95148}]}]'),(3,204,216,'[{1,5165},{5,3874}]',297000,'[{16050001,4,12}]','[{100,[{16050001,95220}]}]'),(3,205,216,'[{1,5211},{5,3908}]',299620,'[{16050001,4,12}]','[{100,[{16050001,95292}]}]'),(3,206,216,'[{1,5257},{5,3943}]',302290,'[{16050001,4,12}]','[{100,[{16050001,95364}]}]'),(3,207,216,'[{1,5304},{5,3978}]',304980,'[{16050001,4,12}]','[{100,[{16050001,95436}]}]'),(3,208,216,'[{1,5352},{5,4014}]',307740,'[{16050001,4,12}]','[{100,[{16050001,95508}]}]'),(3,209,216,'[{1,5399},{5,4049}]',310430,'[{16050001,4,12}]','[{100,[{16050001,95580}]}]'),(3,210,228,'[{1,5446},{5,4084}]',313120,'[{16050001,4,12}]','[{100,[{16050001,95652}]}]'),(3,211,228,'[{1,5493},{5,4120}]',315860,'[{16050001,4,12}]','[{100,[{16050001,95728}]}]'),(3,212,228,'[{1,5541},{5,4156}]',318620,'[{16050001,4,12}]','[{100,[{16050001,95804}]}]'),(3,213,228,'[{1,5589},{5,4192}]',321380,'[{16050001,4,12}]','[{100,[{16050001,95880}]}]'),(3,214,228,'[{1,5637},{5,4228}]',324140,'[{16050001,4,12}]','[{100,[{16050001,95956}]}]'),(3,215,228,'[{1,5686},{5,4264}]',326920,'[{16050001,4,12}]','[{100,[{16050001,96032}]}]'),(3,216,228,'[{1,5734},{5,4300}]',329680,'[{16050001,4,12}]','[{100,[{16050001,96108}]}]'),(3,217,228,'[{1,5783},{5,4337}]',332510,'[{16050001,4,12}]','[{100,[{16050001,96184}]}]'),(3,218,228,'[{1,5832},{5,4374}]',335340,'[{16050001,4,12}]','[{100,[{16050001,96260}]}]'),(3,219,228,'[{1,5881},{5,4411}]',338170,'[{16050001,4,12}]','[{100,[{16050001,96336}]}]'),(3,220,228,'[{1,5931},{5,4448}]',341020,'[{16050001,4,12}]','[{100,[{16050001,96412}]}]'),(3,221,228,'[{1,5980},{5,4485}]',343850,'[{16050001,4,12}]','[{100,[{16050001,96488}]}]'),(3,222,240,'[{1,6030},{5,4523}]',346750,'[{16050001,4,12}]','[{100,[{16050001,96564}]}]'),(3,223,240,'[{1,6080},{5,4560}]',349600,'[{16050001,4,12}]','[{100,[{16050001,96644}]}]'),(3,224,240,'[{1,6130},{5,4598}]',352500,'[{16050001,4,12}]','[{100,[{16050001,96724}]}]'),(3,225,240,'[{1,6181},{5,4636}]',355420,'[{16050001,4,12}]','[{100,[{16050001,96804}]}]'),(3,226,240,'[{1,6231},{5,4673}]',358270,'[{16050001,4,12}]','[{100,[{16050001,96884}]}]'),(3,227,240,'[{1,6282},{5,4712}]',361240,'[{16050001,4,12}]','[{100,[{16050001,96964}]}]'),(3,228,240,'[{1,6333},{5,4750}]',364160,'[{16050001,4,12}]','[{100,[{16050001,97044}]}]'),(3,229,240,'[{1,6385},{5,4789}]',367150,'[{16050001,4,12}]','[{100,[{16050001,97124}]}]'),(3,230,240,'[{1,6436},{5,4827}]',370070,'[{16050001,4,12}]','[{100,[{16050001,97204}]}]'),(3,231,240,'[{1,6487},{5,4865}]',372990,'[{16050001,4,12}]','[{100,[{16050001,97284}]}]'),(3,232,240,'[{1,6539},{5,4905}]',376030,'[{16050001,4,12}]','[{100,[{16050001,97364}]}]'),(3,233,240,'[{1,6592},{5,4944}]',379040,'[{16050001,4,12}]','[{100,[{16050001,97444}]}]'),(3,234,252,'[{1,6644},{5,4983}]',382030,'[{16050001,4,12}]','[{100,[{16050001,97524}]}]'),(3,235,252,'[{1,6696},{5,5022}]',385020,'[{16050001,4,12}]','[{100,[{16050001,97608}]}]'),(3,236,252,'[{1,6748},{5,5061}]',388010,'[{16050001,4,12}]','[{100,[{16050001,97692}]}]'),(3,237,252,'[{1,6802},{5,5101}]',391090,'[{16050001,4,12}]','[{100,[{16050001,97776}]}]'),(3,238,252,'[{1,6855},{5,5141}]',394150,'[{16050001,4,12}]','[{100,[{16050001,97860}]}]'),(3,239,252,'[{1,6908},{5,5181}]',397210,'[{16050001,4,12}]','[{100,[{16050001,97944}]}]'),(3,240,252,'[{1,6962},{5,5221}]',400290,'[{16050001,4,12}]','[{100,[{16050001,98028}]}]'),(3,241,252,'[{1,7015},{5,5261}]',403350,'[{16050001,4,12}]','[{100,[{16050001,98112}]}]'),(3,242,252,'[{1,7069},{5,5302}]',406480,'[{16050001,4,12}]','[{100,[{16050001,98196}]}]'),(3,243,252,'[{1,7124},{5,5343}]',409630,'[{16050001,4,12}]','[{100,[{16050001,98280}]}]'),(3,244,252,'[{1,7178},{5,5384}]',412760,'[{16050001,4,12}]','[{100,[{16050001,98364}]}]'),(3,245,252,'[{1,7232},{5,5424}]',415840,'[{16050001,4,12}]','[{100,[{16050001,98448}]}]'),(3,246,264,'[{1,7287},{5,5465}]',418990,'[{16050001,4,12}]','[{100,[{16050001,98532}]}]'),(3,247,264,'[{1,7342},{5,5507}]',422190,'[{16050001,4,12}]','[{100,[{16050001,98620}]}]'),(3,248,264,'[{1,7397},{5,5548}]',425340,'[{16050001,4,12}]','[{100,[{16050001,98708}]}]'),(3,249,264,'[{1,7453},{5,5590}]',428560,'[{16050001,4,12}]','[{100,[{16050001,98796}]}]'),(3,250,264,'[{1,7508},{5,5631}]',431710,'[{16050001,4,12}]','[{100,[{16050001,98884}]}]'),(3,251,264,'[{1,7563},{5,5673}]',434910,'[{16050001,4,12}]','[{100,[{16050001,98972}]}]'),(3,252,264,'[{1,7620},{5,5715}]',438150,'[{16050001,4,12}]','[{100,[{16050001,99060}]}]'),(3,253,264,'[{1,7676},{5,5757}]',441370,'[{16050001,4,12}]','[{100,[{16050001,99148}]}]'),(3,254,264,'[{1,7732},{5,5799}]',444590,'[{16050001,4,12}]','[{100,[{16050001,99236}]}]'),(3,255,264,'[{1,7789},{5,5842}]',447880,'[{16050001,4,12}]','[{100,[{16050001,99324}]}]'),(3,256,264,'[{1,7845},{5,5884}]',451100,'[{16050001,4,12}]','[{100,[{16050001,99412}]}]'),(3,257,264,'[{1,7902},{5,5927}]',454390,'[{16050001,4,12}]','[{100,[{16050001,99500}]}]'),(3,258,276,'[{1,7960},{5,5970}]',457700,'[{16050001,4,12}]','[{100,[{16050001,99588}]}]'),(3,259,276,'[{1,8017},{5,6013}]',460990,'[{16050001,4,12}]','[{100,[{16050001,99680}]}]'),(3,260,276,'[{1,8075},{5,6056}]',464300,'[{16050001,4,12}]','[{100,[{16050001,99772}]}]'),(3,261,276,'[{1,8132},{5,6099}]',467590,'[{16050001,4,12}]','[{100,[{16050001,99864}]}]'),(3,262,276,'[{1,8190},{5,6143}]',470950,'[{16050001,4,12}]','[{100,[{16050001,99956}]}]'),(3,263,276,'[{1,8249},{5,6187}]',474330,'[{16050001,4,12}]','[{100,[{16050001,100048}]}]'),(3,264,276,'[{1,8307},{5,6231}]',477690,'[{16050001,4,12}]','[{100,[{16050001,100140}]}]'),(3,265,276,'[{1,8366},{5,6274}]',481020,'[{16050001,4,12}]','[{100,[{16050001,100232}]}]'),(3,266,276,'[{1,8424},{5,6318}]',484380,'[{16050001,4,12}]','[{100,[{16050001,100324}]}]'),(3,267,276,'[{1,8484},{5,6363}]',487830,'[{16050001,4,12}]','[{100,[{16050001,100416}]}]'),(3,268,276,'[{1,8543},{5,6407}]',491210,'[{16050001,4,12}]','[{100,[{16050001,100508}]}]'),(3,269,276,'[{1,8603},{5,6452}]',494660,'[{16050001,4,12}]','[{100,[{16050001,100600}]}]'),(3,270,288,'[{1,8662},{5,6497}]',498090,'[{16050001,4,12}]','[{100,[{16050001,100692}]}]'),(3,271,288,'[{1,8721},{5,6541}]',501470,'[{16050001,4,12}]','[{100,[{16050001,100788}]}]'),(3,272,288,'[{1,8782},{5,6587}]',504990,'[{16050001,4,12}]','[{100,[{16050001,100884}]}]'),(3,273,288,'[{1,8842},{5,6632}]',508440,'[{16050001,4,12}]','[{100,[{16050001,100980}]}]'),(3,274,288,'[{1,8903},{5,6677}]',511910,'[{16050001,4,12}]','[{100,[{16050001,101076}]}]'),(3,275,288,'[{1,8963},{5,6723}]',515410,'[{16050001,4,12}]','[{100,[{16050001,101172}]}]'),(3,276,288,'[{1,9024},{5,6768}]',518880,'[{16050001,4,12}]','[{100,[{16050001,101268}]}]'),(3,277,288,'[{1,9085},{5,6814}]',522400,'[{16050001,4,12}]','[{100,[{16050001,101364}]}]'),(3,278,288,'[{1,9147},{5,6860}]',525940,'[{16050001,4,12}]','[{100,[{16050001,101460}]}]'),(3,279,288,'[{1,9208},{5,6906}]',529460,'[{16050001,4,12}]','[{100,[{16050001,101556}]}]'),(3,280,288,'[{1,9270},{5,6952}]',533000,'[{16050001,4,12}]','[{100,[{16050001,101652}]}]'),(3,281,288,'[{1,9331},{5,6999}]',536570,'[{16050001,4,12}]','[{100,[{16050001,101748}]}]'),(3,282,300,'[{1,9394},{5,7045}]',540130,'[{16050001,4,12}]','[{100,[{16050001,101844}]}]'),(3,283,300,'[{1,9456},{5,7092}]',543720,'[{16050001,4,12}]','[{100,[{16050001,101944}]}]'),(3,284,300,'[{1,9519},{5,7139}]',547330,'[{16050001,4,12}]','[{100,[{16050001,102044}]}]'),(3,285,300,'[{1,9581},{5,7186}]',550920,'[{16050001,4,12}]','[{100,[{16050001,102144}]}]'),(3,286,300,'[{1,9644},{5,7233}]',554530,'[{16050001,4,12}]','[{100,[{16050001,102244}]}]'),(3,287,300,'[{1,9707},{5,7281}]',558190,'[{16050001,4,12}]','[{100,[{16050001,102344}]}]'),(3,288,300,'[{1,9771},{5,7328}]',561820,'[{16050001,4,12}]','[{100,[{16050001,102444}]}]'),(3,289,300,'[{1,9834},{5,7376}]',565480,'[{16050001,4,12}]','[{100,[{16050001,102544}]}]'),(3,290,300,'[{1,9898},{5,7424}]',569160,'[{16050001,4,12}]','[{100,[{16050001,102644}]}]'),(3,291,300,'[{1,9962},{5,7471}]',572790,'[{16050001,4,12}]','[{100,[{16050001,102744}]}]'),(3,292,300,'[{1,10026},{5,7520}]',576520,'[{16050001,4,12}]','[{100,[{16050001,102844}]}]'),(3,293,300,'[{1,10091},{5,7568}]',580220,'[{16050001,4,12}]','[{100,[{16050001,102944}]}]'),(3,294,312,'[{1,10155},{5,7617}]',583950,'[{16050001,4,12}]','[{100,[{16050001,103044}]}]'),(3,295,312,'[{1,10220},{5,7665}]',587650,'[{16050001,4,12}]','[{100,[{16050001,103148}]}]'),(3,296,312,'[{1,10284},{5,7713}]',591330,'[{16050001,4,12}]','[{100,[{16050001,103252}]}]'),(3,297,312,'[{1,10350},{5,7763}]',595150,'[{16050001,4,12}]','[{100,[{16050001,103356}]}]'),(3,298,312,'[{1,10416},{5,7812}]',598920,'[{16050001,4,12}]','[{100,[{16050001,103460}]}]'),(3,299,312,'[{1,10481},{5,7861}]',602670,'[{16050001,4,12}]','[{100,[{16050001,103564}]}]'),(3,300,312,'[{1,10547},{5,7910}]',606440,'[{16050001,4,12}]','[{100,[{16050001,103668}]}]'),(3,301,315,'[{1,10612},{5,7959}]',610190,'[{16050001,5,15}]','[{100,[{16050001,103772}]}]'),(3,302,315,'[{1,10679},{5,8009}]',614030,'[{16050001,5,15}]','[{100,[{16050001,103877}]}]'),(3,303,315,'[{1,10746},{5,8059}]',617870,'[{16050001,5,15}]','[{100,[{16050001,103982}]}]'),(3,304,315,'[{1,10812},{5,8109}]',621690,'[{16050001,5,15}]','[{100,[{16050001,104087}]}]'),(3,305,315,'[{1,10879},{5,8159}]',625530,'[{16050001,5,15}]','[{100,[{16050001,104192}]}]'),(3,306,315,'[{1,10945},{5,8209}]',629350,'[{16050001,5,15}]','[{100,[{16050001,104297}]}]'),(3,307,315,'[{1,11013},{5,8260}]',633260,'[{16050001,5,15}]','[{100,[{16050001,104402}]}]'),(3,308,315,'[{1,11081},{5,8311}]',637170,'[{16050001,5,15}]','[{100,[{16050001,104507}]}]'),(3,309,330,'[{1,11148},{5,8361}]',641010,'[{16050001,5,15}]','[{100,[{16050001,104612}]}]'),(3,310,330,'[{1,11216},{5,8412}]',644920,'[{16050001,5,15}]','[{100,[{16050001,104722}]}]'),(3,311,330,'[{1,11284},{5,8463}]',648830,'[{16050001,5,15}]','[{100,[{16050001,104832}]}]'),(3,312,330,'[{1,11352},{5,8514}]',652740,'[{16050001,5,15}]','[{100,[{16050001,104942}]}]'),(3,313,330,'[{1,11421},{5,8566}]',656720,'[{16050001,5,15}]','[{100,[{16050001,105052}]}]'),(3,314,330,'[{1,11490},{5,8617}]',660650,'[{16050001,5,15}]','[{100,[{16050001,105162}]}]'),(3,315,330,'[{1,11558},{5,8669}]',664610,'[{16050001,5,15}]','[{100,[{16050001,105272}]}]'),(3,316,330,'[{1,11627},{5,8720}]',668540,'[{16050001,5,15}]','[{100,[{16050001,105382}]}]'),(3,317,330,'[{1,11697},{5,8773}]',672590,'[{16050001,5,15}]','[{100,[{16050001,105492}]}]'),(3,318,330,'[{1,11766},{5,8825}]',676570,'[{16050001,5,15}]','[{100,[{16050001,105602}]}]'),(3,319,330,'[{1,11836},{5,8877}]',680570,'[{16050001,5,15}]','[{100,[{16050001,105712}]}]'),(3,320,330,'[{1,11906},{5,8929}]',684570,'[{16050001,5,15}]','[{100,[{16050001,105822}]}]'),(3,321,330,'[{1,11975},{5,8982}]',688600,'[{16050001,5,15}]','[{100,[{16050001,105932}]}]'),(3,322,330,'[{1,12046},{5,9035}]',692670,'[{16050001,5,15}]','[{100,[{16050001,106042}]}]'),(3,323,330,'[{1,12117},{5,9088}]',696740,'[{16050001,5,15}]','[{100,[{16050001,106152}]}]'),(3,324,345,'[{1,12188},{5,9141}]',700810,'[{16050001,5,15}]','[{100,[{16050001,106262}]}]'),(3,325,345,'[{1,12258},{5,9194}]',704860,'[{16050001,5,15}]','[{100,[{16050001,106377}]}]'),(3,326,345,'[{1,12329},{5,9247}]',708930,'[{16050001,5,15}]','[{100,[{16050001,106492}]}]'),(3,327,345,'[{1,12401},{5,9301}]',713070,'[{16050001,5,15}]','[{100,[{16050001,106607}]}]'),(3,328,345,'[{1,12473},{5,9355}]',717210,'[{16050001,5,15}]','[{100,[{16050001,106722}]}]'),(3,329,345,'[{1,12544},{5,9408}]',721280,'[{16050001,5,15}]','[{100,[{16050001,106837}]}]'),(3,330,345,'[{1,12616},{5,9462}]',725420,'[{16050001,5,15}]','[{100,[{16050001,106952}]}]'),(3,331,345,'[{1,12688},{5,9516}]',729560,'[{16050001,5,15}]','[{100,[{16050001,107067}]}]'),(3,332,345,'[{1,12761},{5,9571}]',733770,'[{16050001,5,15}]','[{100,[{16050001,107182}]}]'),(3,333,345,'[{1,12833},{5,9625}]',737910,'[{16050001,5,15}]','[{100,[{16050001,107297}]}]'),(3,334,345,'[{1,12906},{5,9680}]',742120,'[{16050001,5,15}]','[{100,[{16050001,107412}]}]'),(3,335,345,'[{1,12979},{5,9734}]',746280,'[{16050001,5,15}]','[{100,[{16050001,107527}]}]'),(3,336,345,'[{1,13052},{5,9789}]',750490,'[{16050001,5,15}]','[{100,[{16050001,107642}]}]'),(3,337,345,'[{1,13125},{5,9844}]',754700,'[{16050001,5,15}]','[{100,[{16050001,107757}]}]'),(3,338,345,'[{1,13199},{5,9900}]',758980,'[{16050001,5,15}]','[{100,[{16050001,107872}]}]'),(3,339,360,'[{1,13273},{5,9955}]',763210,'[{16050001,5,15}]','[{100,[{16050001,107987}]}]'),(3,340,360,'[{1,13347},{5,10010}]',767440,'[{16050001,5,15}]','[{100,[{16050001,108107}]}]'),(3,341,360,'[{1,13421},{5,10066}]',771720,'[{16050001,5,15}]','[{100,[{16050001,108227}]}]'),(3,342,360,'[{1,13495},{5,10122}]',776000,'[{16050001,5,15}]','[{100,[{16050001,108347}]}]'),(3,343,360,'[{1,13570},{5,10178}]',780300,'[{16050001,5,15}]','[{100,[{16050001,108467}]}]'),(3,344,360,'[{1,13645},{5,10234}]',784600,'[{16050001,5,15}]','[{100,[{16050001,108587}]}]'),(3,345,360,'[{1,13720},{5,10290}]',788900,'[{16050001,5,15}]','[{100,[{16050001,108707}]}]'),(3,346,360,'[{1,13795},{5,10346}]',793200,'[{16050001,5,15}]','[{100,[{16050001,108827}]}]'),(3,347,360,'[{1,13870},{5,10403}]',797550,'[{16050001,5,15}]','[{100,[{16050001,108947}]}]'),(3,348,360,'[{1,13946},{5,10460}]',801920,'[{16050001,5,15}]','[{100,[{16050001,109067}]}]'),(3,349,360,'[{1,14022},{5,10517}]',806290,'[{16050001,5,15}]','[{100,[{16050001,109187}]}]'),(3,350,360,'[{1,14098},{5,10574}]',810660,'[{16050001,5,15}]','[{100,[{16050001,109307}]}]'),(3,351,360,'[{1,14174},{5,10631}]',815030,'[{16050001,5,15}]','[{100,[{16050001,109427}]}]'),(3,352,360,'[{1,14251},{5,10688}]',819420,'[{16050001,5,15}]','[{100,[{16050001,109547}]}]'),(3,353,360,'[{1,14328},{5,10746}]',823860,'[{16050001,5,15}]','[{100,[{16050001,109667}]}]'),(3,354,375,'[{1,14404},{5,10803}]',828230,'[{16050001,5,15}]','[{100,[{16050001,109787}]}]'),(3,355,375,'[{1,14481},{5,10861}]',832670,'[{16050001,5,15}]','[{100,[{16050001,109912}]}]'),(3,356,375,'[{1,14558},{5,10919}]',837110,'[{16050001,5,15}]','[{100,[{16050001,110037}]}]'),(3,357,375,'[{1,14636},{5,10977}]',841570,'[{16050001,5,15}]','[{100,[{16050001,110162}]}]'),(3,358,375,'[{1,14714},{5,11036}]',846080,'[{16050001,5,15}]','[{100,[{16050001,110287}]}]'),(3,359,375,'[{1,14792},{5,11094}]',850540,'[{16050001,5,15}]','[{100,[{16050001,110412}]}]'),(3,360,375,'[{1,14870},{5,11152}]',855000,'[{16050001,5,15}]','[{100,[{16050001,110537}]}]'),(3,361,375,'[{1,14948},{5,11211}]',859510,'[{16050001,5,15}]','[{100,[{16050001,110662}]}]'),(3,362,375,'[{1,15027},{5,11270}]',864040,'[{16050001,5,15}]','[{100,[{16050001,110787}]}]'),(3,363,375,'[{1,15106},{5,11329}]',868570,'[{16050001,5,15}]','[{100,[{16050001,110912}]}]'),(3,364,375,'[{1,15184},{5,11388}]',873080,'[{16050001,5,15}]','[{100,[{16050001,111037}]}]'),(3,365,375,'[{1,15263},{5,11448}]',877660,'[{16050001,5,15}]','[{100,[{16050001,111162}]}]'),(3,366,375,'[{1,15342},{5,11507}]',882190,'[{16050001,5,15}]','[{100,[{16050001,111287}]}]'),(3,367,375,'[{1,15422},{5,11567}]',886790,'[{16050001,5,15}]','[{100,[{16050001,111412}]}]'),(3,368,375,'[{1,15502},{5,11627}]',891390,'[{16050001,5,15}]','[{100,[{16050001,111537}]}]'),(3,369,390,'[{1,15582},{5,11687}]',895990,'[{16050001,5,15}]','[{100,[{16050001,111662}]}]'),(3,370,390,'[{1,15662},{5,11747}]',900590,'[{16050001,5,15}]','[{100,[{16050001,111792}]}]'),(3,371,390,'[{1,15742},{5,11807}]',905190,'[{16050001,5,15}]','[{100,[{16050001,111922}]}]'),(3,372,390,'[{1,15823},{5,11867}]',909810,'[{16050001,5,15}]','[{100,[{16050001,112052}]}]'),(3,373,390,'[{1,15904},{5,11928}]',914480,'[{16050001,5,15}]','[{100,[{16050001,112182}]}]'),(3,374,390,'[{1,15985},{5,11989}]',919150,'[{16050001,5,15}]','[{100,[{16050001,112312}]}]'),(3,375,390,'[{1,16066},{5,12050}]',923820,'[{16050001,5,15}]','[{100,[{16050001,112442}]}]'),(3,376,390,'[{1,16147},{5,12110}]',928440,'[{16050001,5,15}]','[{100,[{16050001,112572}]}]'),(3,377,390,'[{1,16229},{5,12172}]',933180,'[{16050001,5,15}]','[{100,[{16050001,112702}]}]'),(3,378,390,'[{1,16311},{5,12233}]',937870,'[{16050001,5,15}]','[{100,[{16050001,112832}]}]'),(3,379,390,'[{1,16393},{5,12295}]',942610,'[{16050001,5,15}]','[{100,[{16050001,112962}]}]'),(3,380,390,'[{1,16475},{5,12356}]',947300,'[{16050001,5,15}]','[{100,[{16050001,113092}]}]'),(3,381,390,'[{1,16557},{5,12418}]',952040,'[{16050001,5,15}]','[{100,[{16050001,113222}]}]'),(3,382,390,'[{1,16640},{5,12480}]',956800,'[{16050001,5,15}]','[{100,[{16050001,113352}]}]'),(3,383,390,'[{1,16723},{5,12542}]',961560,'[{16050001,5,15}]','[{100,[{16050001,113482}]}]'),(3,384,405,'[{1,16806},{5,12604}]',966320,'[{16050001,5,15}]','[{100,[{16050001,113612}]}]'),(3,385,405,'[{1,16889},{5,12667}]',971130,'[{16050001,5,15}]','[{100,[{16050001,113747}]}]'),(3,386,405,'[{1,16972},{5,12729}]',975890,'[{16050001,5,15}]','[{100,[{16050001,113882}]}]'),(3,387,405,'[{1,17056},{5,12792}]',980720,'[{16050001,5,15}]','[{100,[{16050001,114017}]}]'),(3,388,405,'[{1,17140},{5,12855}]',985550,'[{16050001,5,15}]','[{100,[{16050001,114152}]}]'),(3,389,405,'[{1,17224},{5,12918}]',990380,'[{16050001,5,15}]','[{100,[{16050001,114287}]}]'),(3,390,405,'[{1,17308},{5,12981}]',995210,'[{16050001,5,15}]','[{100,[{16050001,114422}]}]'),(3,391,405,'[{1,17392},{5,13044}]',1000040,'[{16050001,5,15}]','[{100,[{16050001,114557}]}]'),(3,392,405,'[{1,17477},{5,13108}]',1004940,'[{16050001,5,15}]','[{100,[{16050001,114692}]}]'),(3,393,405,'[{1,17562},{5,13172}]',1009840,'[{16050001,5,15}]','[{100,[{16050001,114827}]}]'),(3,394,405,'[{1,17647},{5,13236}]',1014740,'[{16050001,5,15}]','[{100,[{16050001,114962}]}]'),(3,395,405,'[{1,17732},{5,13299}]',1019590,'[{16050001,5,15}]','[{100,[{16050001,115097}]}]'),(3,396,405,'[{1,17817},{5,13363}]',1024490,'[{16050001,5,15}]','[{100,[{16050001,115232}]}]'),(3,397,405,'[{1,17903},{5,13428}]',1029460,'[{16050001,5,15}]','[{100,[{16050001,115367}]}]'),(3,398,405,'[{1,17990},{5,13492}]',1034400,'[{16050001,5,15}]','[{100,[{16050001,115502}]}]'),(3,399,420,'[{1,18076},{5,13557}]',1039370,'[{16050001,5,15}]','[{100,[{16050001,115637}]}]'),(3,400,420,'[{1,18162},{5,13621}]',1044290,'[{16050001,5,15}]','[{100,[{16050001,115777}]}]'),(3,401,414,'[{1,18248},{5,13686}]',1049260,'[{16050001,6,18}]','[{100,[{16050001,115917}]}]'),(3,402,414,'[{1,18335},{5,13751}]',1054250,'[{16050001,6,18}]','[{100,[{16050001,116055}]}]'),(3,403,414,'[{1,18422},{5,13817}]',1059290,'[{16050001,6,18}]','[{100,[{16050001,116193}]}]'),(3,404,414,'[{1,18509},{5,13882}]',1064280,'[{16050001,6,18}]','[{100,[{16050001,116331}]}]'),(3,405,414,'[{1,18596},{5,13947}]',1069270,'[{16050001,6,18}]','[{100,[{16050001,116469}]}]'),(3,406,414,'[{1,18683},{5,14013}]',1074310,'[{16050001,6,18}]','[{100,[{16050001,116607}]}]'),(3,407,414,'[{1,18772},{5,14079}]',1079390,'[{16050001,6,18}]','[{100,[{16050001,116745}]}]'),(3,408,432,'[{1,18860},{5,14145}]',1084450,'[{16050001,6,18}]','[{100,[{16050001,116883}]}]'),(3,409,432,'[{1,18948},{5,14211}]',1089510,'[{16050001,6,18}]','[{100,[{16050001,117027}]}]'),(3,410,432,'[{1,19036},{5,14277}]',1094570,'[{16050001,6,18}]','[{100,[{16050001,117171}]}]'),(3,411,432,'[{1,19124},{5,14343}]',1099630,'[{16050001,6,18}]','[{100,[{16050001,117315}]}]'),(3,412,432,'[{1,19213},{5,14410}]',1104760,'[{16050001,6,18}]','[{100,[{16050001,117459}]}]'),(3,413,432,'[{1,19302},{5,14477}]',1109890,'[{16050001,6,18}]','[{100,[{16050001,117603}]}]'),(3,414,432,'[{1,19392},{5,14544}]',1115040,'[{16050001,6,18}]','[{100,[{16050001,117747}]}]'),(3,415,432,'[{1,19481},{5,14611}]',1120170,'[{16050001,6,18}]','[{100,[{16050001,117891}]}]'),(3,416,432,'[{1,19570},{5,14678}]',1125300,'[{16050001,6,18}]','[{100,[{16050001,118035}]}]'),(3,417,432,'[{1,19660},{5,14745}]',1130450,'[{16050001,6,18}]','[{100,[{16050001,118179}]}]'),(3,418,432,'[{1,19750},{5,14813}]',1135650,'[{16050001,6,18}]','[{100,[{16050001,118323}]}]'),(3,419,432,'[{1,19841},{5,14881}]',1140870,'[{16050001,6,18}]','[{100,[{16050001,118467}]}]'),(3,420,432,'[{1,19931},{5,14948}]',1146020,'[{16050001,6,18}]','[{100,[{16050001,118611}]}]'),(3,421,432,'[{1,20021},{5,15016}]',1151220,'[{16050001,6,18}]','[{100,[{16050001,118755}]}]'),(3,422,432,'[{1,20112},{5,15084}]',1156440,'[{16050001,6,18}]','[{100,[{16050001,118899}]}]'),(3,423,432,'[{1,20203},{5,15153}]',1161710,'[{16050001,6,18}]','[{100,[{16050001,119043}]}]'),(3,424,432,'[{1,20295},{5,15221}]',1166950,'[{16050001,6,18}]','[{100,[{16050001,119187}]}]'),(3,425,432,'[{1,20386},{5,15289}]',1172170,'[{16050001,6,18}]','[{100,[{16050001,119331}]}]'),(3,426,450,'[{1,20477},{5,15358}]',1177440,'[{16050001,6,18}]','[{100,[{16050001,119475}]}]'),(3,427,450,'[{1,20569},{5,15427}]',1182730,'[{16050001,6,18}]','[{100,[{16050001,119625}]}]'),(3,428,450,'[{1,20661},{5,15496}]',1188020,'[{16050001,6,18}]','[{100,[{16050001,119775}]}]'),(3,429,450,'[{1,20754},{5,15565}]',1193330,'[{16050001,6,18}]','[{100,[{16050001,119925}]}]'),(3,430,450,'[{1,20846},{5,15635}]',1198670,'[{16050001,6,18}]','[{100,[{16050001,120075}]}]'),(3,431,450,'[{1,20938},{5,15704}]',1203960,'[{16050001,6,18}]','[{100,[{16050001,120225}]}]'),(3,432,450,'[{1,21031},{5,15774}]',1209320,'[{16050001,6,18}]','[{100,[{16050001,120375}]}]'),(3,433,450,'[{1,21125},{5,15844}]',1214700,'[{16050001,6,18}]','[{100,[{16050001,120525}]}]'),(3,434,450,'[{1,21218},{5,15914}]',1220060,'[{16050001,6,18}]','[{100,[{16050001,120675}]}]'),(3,435,450,'[{1,21311},{5,15984}]',1225420,'[{16050001,6,18}]','[{100,[{16050001,120825}]}]'),(3,436,450,'[{1,21405},{5,16054}]',1230800,'[{16050001,6,18}]','[{100,[{16050001,120975}]}]'),(3,437,450,'[{1,21499},{5,16124}]',1236180,'[{16050001,6,18}]','[{100,[{16050001,121125}]}]'),(3,438,450,'[{1,21593},{5,16195}]',1241610,'[{16050001,6,18}]','[{100,[{16050001,121275}]}]'),(3,439,450,'[{1,21687},{5,16266}]',1247040,'[{16050001,6,18}]','[{100,[{16050001,121425}]}]'),(3,440,450,'[{1,21782},{5,16336}]',1252440,'[{16050001,6,18}]','[{100,[{16050001,121575}]}]'),(3,441,450,'[{1,21876},{5,16407}]',1257870,'[{16050001,6,18}]','[{100,[{16050001,121725}]}]'),(3,442,450,'[{1,21971},{5,16479}]',1263370,'[{16050001,6,18}]','[{100,[{16050001,121875}]}]'),(3,443,450,'[{1,22067},{5,16550}]',1268840,'[{16050001,6,18}]','[{100,[{16050001,122025}]}]'),(3,444,468,'[{1,22162},{5,16622}]',1274340,'[{16050001,6,18}]','[{100,[{16050001,122175}]}]'),(3,445,468,'[{1,22257},{5,16693}]',1279790,'[{16050001,6,18}]','[{100,[{16050001,122331}]}]'),(3,446,468,'[{1,22353},{5,16765}]',1285310,'[{16050001,6,18}]','[{100,[{16050001,122487}]}]'),(3,447,468,'[{1,22449},{5,16837}]',1290830,'[{16050001,6,18}]','[{100,[{16050001,122643}]}]'),(3,448,468,'[{1,22545},{5,16909}]',1296350,'[{16050001,6,18}]','[{100,[{16050001,122799}]}]'),(3,449,468,'[{1,22642},{5,16981}]',1301890,'[{16050001,6,18}]','[{100,[{16050001,122955}]}]'),(3,450,468,'[{1,22738},{5,17054}]',1307460,'[{16050001,6,18}]','[{100,[{16050001,123111}]}]'),(3,451,468,'[{1,22834},{5,17126}]',1312980,'[{16050001,6,18}]','[{100,[{16050001,123267}]}]'),(3,452,468,'[{1,22932},{5,17199}]',1318590,'[{16050001,6,18}]','[{100,[{16050001,123423}]}]'),(3,453,468,'[{1,23029},{5,17272}]',1324180,'[{16050001,6,18}]','[{100,[{16050001,123579}]}]'),(3,454,468,'[{1,23126},{5,17345}]',1329770,'[{16050001,6,18}]','[{100,[{16050001,123735}]}]'),(3,455,468,'[{1,23224},{5,17418}]',1335380,'[{16050001,6,18}]','[{100,[{16050001,123891}]}]'),(3,456,468,'[{1,23321},{5,17491}]',1340970,'[{16050001,6,18}]','[{100,[{16050001,124047}]}]'),(3,457,468,'[{1,23420},{5,17565}]',1346650,'[{16050001,6,18}]','[{100,[{16050001,124203}]}]'),(3,458,468,'[{1,23518},{5,17639}]',1352310,'[{16050001,6,18}]','[{100,[{16050001,124359}]}]'),(3,459,468,'[{1,23616},{5,17712}]',1357920,'[{16050001,6,18}]','[{100,[{16050001,124515}]}]'),(3,460,468,'[{1,23715},{5,17786}]',1363600,'[{16050001,6,18}]','[{100,[{16050001,124671}]}]'),(3,461,468,'[{1,23813},{5,17860}]',1369260,'[{16050001,6,18}]','[{100,[{16050001,124827}]}]'),(3,462,486,'[{1,23912},{5,17934}]',1374940,'[{16050001,6,18}]','[{100,[{16050001,124983}]}]'),(3,463,486,'[{1,24012},{5,18009}]',1380690,'[{16050001,6,18}]','[{100,[{16050001,125145}]}]'),(3,464,486,'[{1,24111},{5,18084}]',1386420,'[{16050001,6,18}]','[{100,[{16050001,125307}]}]'),(3,465,486,'[{1,24211},{5,18158}]',1392120,'[{16050001,6,18}]','[{100,[{16050001,125469}]}]'),(3,466,486,'[{1,24310},{5,18233}]',1397850,'[{16050001,6,18}]','[{100,[{16050001,125631}]}]'),(3,467,486,'[{1,24411},{5,18308}]',1403620,'[{16050001,6,18}]','[{100,[{16050001,125793}]}]'),(3,468,486,'[{1,24511},{5,18383}]',1409370,'[{16050001,6,18}]','[{100,[{16050001,125955}]}]'),(3,469,486,'[{1,24611},{5,18459}]',1415170,'[{16050001,6,18}]','[{100,[{16050001,126117}]}]'),(3,470,486,'[{1,24712},{5,18534}]',1420940,'[{16050001,6,18}]','[{100,[{16050001,126279}]}]'),(3,471,486,'[{1,24812},{5,18609}]',1426690,'[{16050001,6,18}]','[{100,[{16050001,126441}]}]'),(3,472,486,'[{1,24914},{5,18685}]',1432530,'[{16050001,6,18}]','[{100,[{16050001,126603}]}]'),(3,473,486,'[{1,25015},{5,18762}]',1438400,'[{16050001,6,18}]','[{100,[{16050001,126765}]}]'),(3,474,486,'[{1,25117},{5,18838}]',1444240,'[{16050001,6,18}]','[{100,[{16050001,126927}]}]'),(3,475,486,'[{1,25218},{5,18914}]',1450060,'[{16050001,6,18}]','[{100,[{16050001,127089}]}]'),(3,476,486,'[{1,25320},{5,18990}]',1455900,'[{16050001,6,18}]','[{100,[{16050001,127251}]}]'),(3,477,486,'[{1,25422},{5,19067}]',1461790,'[{16050001,6,18}]','[{100,[{16050001,127413}]}]'),(3,478,486,'[{1,25525},{5,19144}]',1467700,'[{16050001,6,18}]','[{100,[{16050001,127575}]}]'),(3,479,486,'[{1,25627},{5,19220}]',1473540,'[{16050001,6,18}]','[{100,[{16050001,127737}]}]'),(3,480,504,'[{1,25730},{5,19297}]',1479450,'[{16050001,6,18}]','[{100,[{16050001,127899}]}]'),(3,481,504,'[{1,25832},{5,19374}]',1485340,'[{16050001,6,18}]','[{100,[{16050001,128067}]}]'),(3,482,504,'[{1,25936},{5,19452}]',1491320,'[{16050001,6,18}]','[{100,[{16050001,128235}]}]'),(3,483,504,'[{1,26039},{5,19529}]',1497230,'[{16050001,6,18}]','[{100,[{16050001,128403}]}]'),(3,484,504,'[{1,26143},{5,19607}]',1503210,'[{16050001,6,18}]','[{100,[{16050001,128571}]}]'),(3,485,504,'[{1,26246},{5,19685}]',1509170,'[{16050001,6,18}]','[{100,[{16050001,128739}]}]'),(3,486,504,'[{1,26350},{5,19762}]',1515100,'[{16050001,6,18}]','[{100,[{16050001,128907}]}]'),(3,487,504,'[{1,26454},{5,19841}]',1521130,'[{16050001,6,18}]','[{100,[{16050001,129075}]}]'),(3,488,504,'[{1,26559},{5,19919}]',1527130,'[{16050001,6,18}]','[{100,[{16050001,129243}]}]'),(3,489,504,'[{1,26663},{5,19998}]',1533160,'[{16050001,6,18}]','[{100,[{16050001,129411}]}]'),(3,490,504,'[{1,26768},{5,20076}]',1539160,'[{16050001,6,18}]','[{100,[{16050001,129579}]}]'),(3,491,504,'[{1,26872},{5,20154}]',1545140,'[{16050001,6,18}]','[{100,[{16050001,129747}]}]'),(3,492,504,'[{1,26978},{5,20234}]',1551260,'[{16050001,6,18}]','[{100,[{16050001,129915}]}]'),(3,493,504,'[{1,27084},{5,20313}]',1557330,'[{16050001,6,18}]','[{100,[{16050001,130083}]}]'),(3,494,504,'[{1,27189},{5,20392}]',1563380,'[{16050001,6,18}]','[{100,[{16050001,130251}]}]'),(3,495,504,'[{1,27295},{5,20471}]',1569450,'[{16050001,6,18}]','[{100,[{16050001,130419}]}]'),(3,496,504,'[{1,27400},{5,20550}]',1575500,'[{16050001,6,18}]','[{100,[{16050001,130587}]}]'),(3,497,504,'[{1,27507},{5,20630}]',1581640,'[{16050001,6,18}]','[{100,[{16050001,130755}]}]'),(3,498,522,'[{1,27613},{5,20710}]',1587760,'[{16050001,6,18}]','[{100,[{16050001,130923}]}]'),(3,499,522,'[{1,27720},{5,20790}]',1593900,'[{16050001,6,18}]','[{100,[{16050001,131097}]}]'),(3,500,522,'[{1,27827},{5,20870}]',1600040,'[]','[{100,[{16050001,131271}]}]'),(4,1,9,'[{2,82},{6,4}]',282,'[{16050001,1,3}]','[{100,[{16050001,131445}]}]'),(4,2,9,'[{2,185},{6,7}]',535,'[{16050001,1,3}]','[{100,[{16050001,131448}]}]'),(4,3,12,'[{2,287},{6,11}]',837,'[{16050001,1,3}]','[{100,[{16050001,131451}]}]'),(4,4,12,'[{2,390},{6,15}]',1140,'[{16050001,1,3}]','[{100,[{16050001,131455}]}]'),(4,5,12,'[{2,492},{6,19}]',1442,'[{16050001,1,3}]','[{100,[{16050001,131459}]}]'),(4,6,15,'[{2,595},{6,23}]',1745,'[{16050001,1,3}]','[{100,[{16050001,131463}]}]'),(4,7,15,'[{2,718},{6,27}]',2068,'[{16050001,1,3}]','[{100,[{16050001,131468}]}]'),(4,8,15,'[{2,841},{6,32}]',2441,'[{16050001,1,3}]','[{100,[{16050001,131473}]}]'),(4,9,18,'[{2,964},{6,37}]',2814,'[{16050001,1,3}]','[{100,[{16050001,131478}]}]'),(4,10,18,'[{2,1087},{6,41}]',3137,'[{16050001,1,3}]','[{100,[{16050001,131484}]}]'),(4,11,18,'[{2,1210},{6,46}]',3510,'[{16050001,1,3}]','[{100,[{16050001,131490}]}]'),(4,12,21,'[{2,1353},{6,51}]',3903,'[{16050001,1,3}]','[{100,[{16050001,131496}]}]'),(4,13,21,'[{2,1497},{6,57}]',4347,'[{16050001,1,3}]','[{100,[{16050001,131503}]}]'),(4,14,21,'[{2,1640},{6,62}]',4740,'[{16050001,1,3}]','[{100,[{16050001,131510}]}]'),(4,15,24,'[{2,1784},{6,67}]',5134,'[{16050001,1,3}]','[{100,[{16050001,131517}]}]'),(4,16,24,'[{2,1927},{6,73}]',5577,'[{16050001,2,6}]','[{100,[{16050001,131525}]}]'),(4,17,24,'[{2,2091},{6,79}]',6041,'[{16050001,2,6}]','[{100,[{16050001,131533}]}]'),(4,18,30,'[{2,2255},{6,85}]',6505,'[{16050001,2,6}]','[{100,[{16050001,131541}]}]'),(4,19,30,'[{2,2419},{6,91}]',6969,'[{16050001,2,6}]','[{100,[{16050001,131551}]}]'),(4,20,30,'[{2,2583},{6,97}]',7433,'[{16050001,2,6}]','[{100,[{16050001,131561}]}]'),(4,21,30,'[{2,2747},{6,104}]',7947,'[{16050001,2,6}]','[{100,[{16050001,131571}]}]'),(4,22,30,'[{2,2932},{6,110}]',8432,'[{16050001,2,6}]','[{100,[{16050001,131581}]}]'),(4,23,30,'[{2,3116},{6,117}]',8966,'[{16050001,2,6}]','[{100,[{16050001,131591}]}]'),(4,24,36,'[{2,3301},{6,124}]',9501,'[{16050001,2,6}]','[{100,[{16050001,131601}]}]'),(4,25,36,'[{2,3485},{6,131}]',10035,'[{16050001,2,6}]','[{100,[{16050001,131613}]}]'),(4,26,36,'[{2,3670},{6,138}]',10570,'[{16050001,2,6}]','[{100,[{16050001,131625}]}]'),(4,27,36,'[{2,3875},{6,146}]',11175,'[{16050001,2,6}]','[{100,[{16050001,131637}]}]'),(4,28,36,'[{2,4080},{6,153}]',11730,'[{16050001,2,6}]','[{100,[{16050001,131649}]}]'),(4,29,36,'[{2,4285},{6,161}]',12335,'[{16050001,2,6}]','[{100,[{16050001,131661}]}]'),(4,30,42,'[{2,4490},{6,169}]',12940,'[{16050001,2,6}]','[{100,[{16050001,131673}]}]'),(4,31,42,'[{2,4695},{6,177}]',13545,'[{16050001,2,6}]','[{100,[{16050001,131687}]}]'),(4,32,42,'[{2,4920},{6,185}]',14170,'[{16050001,2,6}]','[{100,[{16050001,131701}]}]'),(4,33,42,'[{2,5146},{6,193}]',14796,'[{16050001,2,6}]','[{100,[{16050001,131715}]}]'),(4,34,42,'[{2,5371},{6,202}]',15471,'[{16050001,2,6}]','[{100,[{16050001,131729}]}]'),(4,35,42,'[{2,5596},{6,210}]',16096,'[{16050001,2,6}]','[{100,[{16050001,131743}]}]'),(4,36,48,'[{2,5822},{6,219}]',16772,'[{16050001,2,6}]','[{100,[{16050001,131757}]}]'),(4,37,48,'[{2,6068},{6,228}]',17468,'[{16050001,2,6}]','[{100,[{16050001,131773}]}]'),(4,38,48,'[{2,6314},{6,237}]',18164,'[{16050001,2,6}]','[{100,[{16050001,131789}]}]'),(4,39,48,'[{2,6560},{6,246}]',18860,'[{16050001,2,6}]','[{100,[{16050001,131805}]}]'),(4,40,48,'[{2,6806},{6,256}]',19606,'[{16050001,2,6}]','[{100,[{16050001,131821}]}]'),(4,41,48,'[{2,7052},{6,265}]',20302,'[{16050001,2,6}]','[{100,[{16050001,131837}]}]'),(4,42,54,'[{2,7318},{6,275}]',21068,'[{16050001,2,6}]','[{100,[{16050001,131853}]}]'),(4,43,54,'[{2,7585},{6,285}]',21835,'[{16050001,2,6}]','[{100,[{16050001,131871}]}]'),(4,44,54,'[{2,7851},{6,295}]',22601,'[{16050001,2,6}]','[{100,[{16050001,131889}]}]'),(4,45,54,'[{2,8118},{6,305}]',23368,'[{16050001,2,6}]','[{100,[{16050001,131907}]}]'),(4,46,54,'[{2,8384},{6,315}]',24134,'[{16050001,2,6}]','[{100,[{16050001,131925}]}]'),(4,47,54,'[{2,8671},{6,326}]',24971,'[{16050001,2,6}]','[{100,[{16050001,131943}]}]'),(4,48,60,'[{2,8958},{6,336}]',25758,'[{16050001,2,6}]','[{100,[{16050001,131961}]}]'),(4,49,60,'[{2,9245},{6,347}]',26595,'[{16050001,2,6}]','[{100,[{16050001,131981}]}]'),(4,50,60,'[{2,9532},{6,358}]',27432,'[{16050001,2,6}]','[{100,[{16050001,132001}]}]'),(4,51,60,'[{2,9819},{6,369}]',28269,'[{16050001,2,6}]','[{100,[{16050001,132021}]}]'),(4,52,60,'[{2,10127},{6,380}]',29127,'[{16050001,2,6}]','[{100,[{16050001,132041}]}]'),(4,53,60,'[{2,10434},{6,392}]',30034,'[{16050001,2,6}]','[{100,[{16050001,132061}]}]'),(4,54,66,'[{2,10741},{6,403}]',30891,'[{16050001,2,6}]','[{100,[{16050001,132081}]}]'),(4,55,66,'[{2,11049},{6,415}]',31799,'[{16050001,2,6}]','[{100,[{16050001,132103}]}]'),(4,56,66,'[{2,11356},{6,426}]',32656,'[{16050001,2,6}]','[{100,[{16050001,132125}]}]'),(4,57,66,'[{2,11684},{6,439}]',33634,'[{16050001,2,6}]','[{100,[{16050001,132147}]}]'),(4,58,66,'[{2,12012},{6,451}]',34562,'[{16050001,2,6}]','[{100,[{16050001,132169}]}]'),(4,59,66,'[{2,12340},{6,463}]',35490,'[{16050001,2,6}]','[{100,[{16050001,132191}]}]'),(4,60,72,'[{2,12668},{6,476}]',36468,'[{16050001,2,6}]','[{100,[{16050001,132213}]}]'),(4,61,72,'[{2,12996},{6,488}]',37396,'[{16050001,2,6}]','[{100,[{16050001,132237}]}]'),(4,62,72,'[{2,13345},{6,501}]',38395,'[{16050001,2,6}]','[{100,[{16050001,132261}]}]'),(4,63,72,'[{2,13693},{6,514}]',39393,'[{16050001,2,6}]','[{100,[{16050001,132285}]}]'),(4,64,72,'[{2,14042},{6,527}]',40392,'[{16050001,2,6}]','[{100,[{16050001,132309}]}]'),(4,65,72,'[{2,14390},{6,540}]',41390,'[{16050001,2,6}]','[{100,[{16050001,132333}]}]'),(4,66,78,'[{2,14739},{6,553}]',42389,'[{16050001,2,6}]','[{100,[{16050001,132357}]}]'),(4,67,78,'[{2,15108},{6,567}]',43458,'[{16050001,2,6}]','[{100,[{16050001,132383}]}]'),(4,68,78,'[{2,15477},{6,581}]',44527,'[{16050001,2,6}]','[{100,[{16050001,132409}]}]'),(4,69,78,'[{2,15845},{6,595}]',45595,'[{16050001,2,6}]','[{100,[{16050001,132435}]}]'),(4,70,78,'[{2,16214},{6,609}]',46664,'[{16050001,2,6}]','[{100,[{16050001,132461}]}]'),(4,71,78,'[{2,16583},{6,622}]',47683,'[{16050001,2,6}]','[{100,[{16050001,132487}]}]'),(4,72,84,'[{2,16973},{6,637}]',48823,'[{16050001,2,6}]','[{100,[{16050001,132513}]}]'),(4,73,84,'[{2,17362},{6,652}]',49962,'[{16050001,2,6}]','[{100,[{16050001,132541}]}]'),(4,74,84,'[{2,17752},{6,666}]',51052,'[{16050001,2,6}]','[{100,[{16050001,132569}]}]'),(4,75,84,'[{2,18141},{6,681}]',52191,'[{16050001,2,6}]','[{100,[{16050001,132597}]}]'),(4,76,84,'[{2,18531},{6,695}]',53281,'[{16050001,2,6}]','[{100,[{16050001,132625}]}]'),(4,77,84,'[{2,18941},{6,711}]',54491,'[{16050001,2,6}]','[{100,[{16050001,132653}]}]'),(4,78,90,'[{2,19351},{6,726}]',55651,'[{16050001,2,6}]','[{100,[{16050001,132681}]}]'),(4,79,90,'[{2,19761},{6,742}]',56861,'[{16050001,2,6}]','[{100,[{16050001,132711}]}]'),(4,80,90,'[{2,20171},{6,757}]',58021,'[{16050001,2,6}]','[{100,[{16050001,132741}]}]'),(4,81,90,'[{2,20581},{6,772}]',59181,'[{16050001,2,6}]','[{100,[{16050001,132771}]}]'),(4,82,90,'[{2,21011},{6,788}]',60411,'[{16050001,2,6}]','[{100,[{16050001,132801}]}]'),(4,83,90,'[{2,21441},{6,805}]',61691,'[{16050001,2,6}]','[{100,[{16050001,132831}]}]'),(4,84,96,'[{2,21872},{6,821}]',62922,'[{16050001,2,6}]','[{100,[{16050001,132861}]}]'),(4,85,96,'[{2,22302},{6,837}]',64152,'[{16050001,2,6}]','[{100,[{16050001,132893}]}]'),(4,86,96,'[{2,22733},{6,853}]',65383,'[{16050001,2,6}]','[{100,[{16050001,132925}]}]'),(4,87,96,'[{2,23184},{6,870}]',66684,'[{16050001,2,6}]','[{100,[{16050001,132957}]}]'),(4,88,96,'[{2,23635},{6,887}]',67985,'[{16050001,2,6}]','[{100,[{16050001,132989}]}]'),(4,89,96,'[{2,24086},{6,904}]',69286,'[{16050001,2,6}]','[{100,[{16050001,133021}]}]'),(4,90,102,'[{2,24537},{6,921}]',70587,'[{16050001,2,6}]','[{100,[{16050001,133053}]}]'),(4,91,102,'[{2,24988},{6,938}]',71888,'[{16050001,2,6}]','[{100,[{16050001,133087}]}]'),(4,92,102,'[{2,25459},{6,955}]',73209,'[{16050001,2,6}]','[{100,[{16050001,133121}]}]'),(4,93,102,'[{2,25931},{6,973}]',74581,'[{16050001,2,6}]','[{100,[{16050001,133155}]}]'),(4,94,102,'[{2,26402},{6,991}]',75952,'[{16050001,2,6}]','[{100,[{16050001,133189}]}]'),(4,95,102,'[{2,26873},{6,1008}]',77273,'[{16050001,2,6}]','[{100,[{16050001,133223}]}]'),(4,96,108,'[{2,27345},{6,1026}]',78645,'[{16050001,2,6}]','[{100,[{16050001,133257}]}]'),(4,97,108,'[{2,27837},{6,1044}]',80037,'[{16050001,2,6}]','[{100,[{16050001,133293}]}]'),(4,98,108,'[{2,28329},{6,1063}]',81479,'[{16050001,2,6}]','[{100,[{16050001,133329}]}]'),(4,99,108,'[{2,28821},{6,1081}]',82871,'[{16050001,2,6}]','[{100,[{16050001,133365}]}]'),(4,100,108,'[{2,29313},{6,1100}]',84313,'[{16050001,2,6}]','[{100,[{16050001,133401}]}]'),(4,101,108,'[{2,29805},{6,1118}]',85705,'[{16050001,3,9}]','[{100,[{16050001,133437}]}]'),(4,102,117,'[{2,30317},{6,1137}]',87167,'[{16050001,3,9}]','[{100,[{16050001,133473}]}]'),(4,103,117,'[{2,30830},{6,1157}]',88680,'[{16050001,3,9}]','[{100,[{16050001,133512}]}]'),(4,104,117,'[{2,31342},{6,1176}]',90142,'[{16050001,3,9}]','[{100,[{16050001,133551}]}]'),(4,105,117,'[{2,31854},{6,1195}]',91604,'[{16050001,3,9}]','[{100,[{16050001,133590}]}]'),(4,106,117,'[{2,32367},{6,1214}]',93067,'[{16050001,3,9}]','[{100,[{16050001,133629}]}]'),(4,107,117,'[{2,32900},{6,1234}]',94600,'[{16050001,3,9}]','[{100,[{16050001,133668}]}]'),(4,108,117,'[{2,33433},{6,1254}]',96133,'[{16050001,3,9}]','[{100,[{16050001,133707}]}]'),(4,109,117,'[{2,33966},{6,1274}]',97666,'[{16050001,3,9}]','[{100,[{16050001,133746}]}]'),(4,110,117,'[{2,34499},{6,1294}]',99199,'[{16050001,3,9}]','[{100,[{16050001,133785}]}]'),(4,111,126,'[{2,35032},{6,1314}]',100732,'[{16050001,3,9}]','[{100,[{16050001,133824}]}]'),(4,112,126,'[{2,35585},{6,1335}]',102335,'[{16050001,3,9}]','[{100,[{16050001,133866}]}]'),(4,113,126,'[{2,36139},{6,1356}]',103939,'[{16050001,3,9}]','[{100,[{16050001,133908}]}]'),(4,114,126,'[{2,36692},{6,1376}]',105492,'[{16050001,3,9}]','[{100,[{16050001,133950}]}]'),(4,115,126,'[{2,37245},{6,1397}]',107095,'[{16050001,3,9}]','[{100,[{16050001,133992}]}]'),(4,116,126,'[{2,37799},{6,1418}]',108699,'[{16050001,3,9}]','[{100,[{16050001,134034}]}]'),(4,117,126,'[{2,38373},{6,1439}]',110323,'[{16050001,3,9}]','[{100,[{16050001,134076}]}]'),(4,118,126,'[{2,38947},{6,1461}]',111997,'[{16050001,3,9}]','[{100,[{16050001,134118}]}]'),(4,119,126,'[{2,39521},{6,1483}]',113671,'[{16050001,3,9}]','[{100,[{16050001,134160}]}]'),(4,120,135,'[{2,40095},{6,1504}]',115295,'[{16050001,3,9}]','[{100,[{16050001,134202}]}]'),(4,121,135,'[{2,40669},{6,1526}]',116969,'[{16050001,3,9}]','[{100,[{16050001,134247}]}]'),(4,122,135,'[{2,41263},{6,1548}]',118663,'[{16050001,3,9}]','[{100,[{16050001,134292}]}]'),(4,123,135,'[{2,41857},{6,1570}]',120357,'[{16050001,3,9}]','[{100,[{16050001,134337}]}]'),(4,124,135,'[{2,42452},{6,1592}]',122052,'[{16050001,3,9}]','[{100,[{16050001,134382}]}]'),(4,125,135,'[{2,43046},{6,1615}]',123796,'[{16050001,3,9}]','[{100,[{16050001,134427}]}]'),(4,126,135,'[{2,43641},{6,1637}]',125491,'[{16050001,3,9}]','[{100,[{16050001,134472}]}]'),(4,127,135,'[{2,44256},{6,1660}]',127256,'[{16050001,3,9}]','[{100,[{16050001,134517}]}]'),(4,128,135,'[{2,44871},{6,1683}]',129021,'[{16050001,3,9}]','[{100,[{16050001,134562}]}]'),(4,129,144,'[{2,45486},{6,1706}]',130786,'[{16050001,3,9}]','[{100,[{16050001,134607}]}]'),(4,130,144,'[{2,46101},{6,1729}]',132551,'[{16050001,3,9}]','[{100,[{16050001,134655}]}]'),(4,131,144,'[{2,46716},{6,1752}]',134316,'[{16050001,3,9}]','[{100,[{16050001,134703}]}]'),(4,132,144,'[{2,47351},{6,1776}]',136151,'[{16050001,3,9}]','[{100,[{16050001,134751}]}]'),(4,133,144,'[{2,47986},{6,1800}]',137986,'[{16050001,3,9}]','[{100,[{16050001,134799}]}]'),(4,134,144,'[{2,48622},{6,1824}]',139822,'[{16050001,3,9}]','[{100,[{16050001,134847}]}]'),(4,135,144,'[{2,49257},{6,1848}]',141657,'[{16050001,3,9}]','[{100,[{16050001,134895}]}]'),(4,136,144,'[{2,49893},{6,1871}]',143443,'[{16050001,3,9}]','[{100,[{16050001,134943}]}]'),(4,137,144,'[{2,50549},{6,1896}]',145349,'[{16050001,3,9}]','[{100,[{16050001,134991}]}]'),(4,138,153,'[{2,51205},{6,1921}]',147255,'[{16050001,3,9}]','[{100,[{16050001,135039}]}]'),(4,139,153,'[{2,51861},{6,1945}]',149111,'[{16050001,3,9}]','[{100,[{16050001,135090}]}]'),(4,140,153,'[{2,52516},{6,1970}]',151016,'[{16050001,3,9}]','[{100,[{16050001,135141}]}]'),(4,141,153,'[{2,53172},{6,1994}]',152872,'[{16050001,3,9}]','[{100,[{16050001,135192}]}]'),(4,142,153,'[{2,53849},{6,2020}]',154849,'[{16050001,3,9}]','[{100,[{16050001,135243}]}]'),(4,143,153,'[{2,54525},{6,2045}]',156775,'[{16050001,3,9}]','[{100,[{16050001,135294}]}]'),(4,144,153,'[{2,55202},{6,2071}]',158752,'[{16050001,3,9}]','[{100,[{16050001,135345}]}]'),(4,145,153,'[{2,55878},{6,2096}]',160678,'[{16050001,3,9}]','[{100,[{16050001,135396}]}]'),(4,146,153,'[{2,56555},{6,2121}]',162605,'[{16050001,3,9}]','[{100,[{16050001,135447}]}]'),(4,147,162,'[{2,57252},{6,2147}]',164602,'[{16050001,3,9}]','[{100,[{16050001,135498}]}]'),(4,148,162,'[{2,57948},{6,2174}]',166648,'[{16050001,3,9}]','[{100,[{16050001,135552}]}]'),(4,149,162,'[{2,58645},{6,2200}]',168645,'[{16050001,3,9}]','[{100,[{16050001,135606}]}]'),(4,150,162,'[{2,59342},{6,2226}]',170642,'[{16050001,3,9}]','[{100,[{16050001,135660}]}]'),(4,151,162,'[{2,60039},{6,2252}]',172639,'[{16050001,3,9}]','[{100,[{16050001,135714}]}]'),(4,152,162,'[{2,60757},{6,2279}]',174707,'[{16050001,3,9}]','[{100,[{16050001,135768}]}]'),(4,153,162,'[{2,61474},{6,2306}]',176774,'[{16050001,3,9}]','[{100,[{16050001,135822}]}]'),(4,154,162,'[{2,62192},{6,2333}]',178842,'[{16050001,3,9}]','[{100,[{16050001,135876}]}]'),(4,155,162,'[{2,62909},{6,2360}]',180909,'[{16050001,3,9}]','[{100,[{16050001,135930}]}]'),(4,156,171,'[{2,63626},{6,2386}]',182926,'[{16050001,3,9}]','[{100,[{16050001,135984}]}]'),(4,157,171,'[{2,64364},{6,2414}]',185064,'[{16050001,3,9}]','[{100,[{16050001,136041}]}]'),(4,158,171,'[{2,65102},{6,2442}]',187202,'[{16050001,3,9}]','[{100,[{16050001,136098}]}]'),(4,159,171,'[{2,65840},{6,2469}]',189290,'[{16050001,3,9}]','[{100,[{16050001,136155}]}]'),(4,160,171,'[{2,66578},{6,2497}]',191428,'[{16050001,3,9}]','[{100,[{16050001,136212}]}]'),(4,161,171,'[{2,67316},{6,2525}]',193566,'[{16050001,3,9}]','[{100,[{16050001,136269}]}]'),(4,162,171,'[{2,68074},{6,2553}]',195724,'[{16050001,3,9}]','[{100,[{16050001,136326}]}]'),(4,163,171,'[{2,68833},{6,2582}]',197933,'[{16050001,3,9}]','[{100,[{16050001,136383}]}]'),(4,164,171,'[{2,69591},{6,2610}]',200091,'[{16050001,3,9}]','[{100,[{16050001,136440}]}]'),(4,165,180,'[{2,70350},{6,2639}]',202300,'[{16050001,3,9}]','[{100,[{16050001,136497}]}]'),(4,166,180,'[{2,71108},{6,2667}]',204458,'[{16050001,3,9}]','[{100,[{16050001,136557}]}]'),(4,167,180,'[{2,71887},{6,2696}]',206687,'[{16050001,3,9}]','[{100,[{16050001,136617}]}]'),(4,168,180,'[{2,72666},{6,2725}]',208916,'[{16050001,3,9}]','[{100,[{16050001,136677}]}]'),(4,169,180,'[{2,73445},{6,2755}]',211195,'[{16050001,3,9}]','[{100,[{16050001,136737}]}]'),(4,170,180,'[{2,74224},{6,2784}]',213424,'[{16050001,3,9}]','[{100,[{16050001,136797}]}]'),(4,171,180,'[{2,75003},{6,2813}]',215653,'[{16050001,3,9}]','[{100,[{16050001,136857}]}]'),(4,172,180,'[{2,75802},{6,2843}]',217952,'[{16050001,3,9}]','[{100,[{16050001,136917}]}]'),(4,173,180,'[{2,76602},{6,2873}]',220252,'[{16050001,3,9}]','[{100,[{16050001,136977}]}]'),(4,174,189,'[{2,77401},{6,2903}]',222551,'[{16050001,3,9}]','[{100,[{16050001,137037}]}]'),(4,175,189,'[{2,78201},{6,2933}]',224851,'[{16050001,3,9}]','[{100,[{16050001,137100}]}]'),(4,176,189,'[{2,79000},{6,2963}]',227150,'[{16050001,3,9}]','[{100,[{16050001,137163}]}]'),(4,177,189,'[{2,79820},{6,2994}]',229520,'[{16050001,3,9}]','[{100,[{16050001,137226}]}]'),(4,178,189,'[{2,80640},{6,3024}]',231840,'[{16050001,3,9}]','[{100,[{16050001,137289}]}]'),(4,179,189,'[{2,81460},{6,3055}]',234210,'[{16050001,3,9}]','[{100,[{16050001,137352}]}]'),(4,180,189,'[{2,82280},{6,3086}]',236580,'[{16050001,3,9}]','[{100,[{16050001,137415}]}]'),(4,181,189,'[{2,83100},{6,3117}]',238950,'[{16050001,3,9}]','[{100,[{16050001,137478}]}]'),(4,182,189,'[{2,83940},{6,3148}]',241340,'[{16050001,3,9}]','[{100,[{16050001,137541}]}]'),(4,183,198,'[{2,84780},{6,3180}]',243780,'[{16050001,3,9}]','[{100,[{16050001,137604}]}]'),(4,184,198,'[{2,85621},{6,3211}]',246171,'[{16050001,3,9}]','[{100,[{16050001,137670}]}]'),(4,185,198,'[{2,86461},{6,3243}]',248611,'[{16050001,3,9}]','[{100,[{16050001,137736}]}]'),(4,186,198,'[{2,87302},{6,3274}]',251002,'[{16050001,3,9}]','[{100,[{16050001,137802}]}]'),(4,187,198,'[{2,88163},{6,3307}]',253513,'[{16050001,3,9}]','[{100,[{16050001,137868}]}]'),(4,188,198,'[{2,89023},{6,3339}]',255973,'[{16050001,3,9}]','[{100,[{16050001,137934}]}]'),(4,189,198,'[{2,89884},{6,3371}]',258434,'[{16050001,3,9}]','[{100,[{16050001,138000}]}]'),(4,190,198,'[{2,90745},{6,3403}]',260895,'[{16050001,3,9}]','[{100,[{16050001,138066}]}]'),(4,191,198,'[{2,91606},{6,3436}]',263406,'[{16050001,3,9}]','[{100,[{16050001,138132}]}]'),(4,192,207,'[{2,92488},{6,3469}]',265938,'[{16050001,3,9}]','[{100,[{16050001,138198}]}]'),(4,193,207,'[{2,93369},{6,3502}]',268469,'[{16050001,3,9}]','[{100,[{16050001,138267}]}]'),(4,194,207,'[{2,94250},{6,3535}]',271000,'[{16050001,3,9}]','[{100,[{16050001,138336}]}]'),(4,195,207,'[{2,95132},{6,3568}]',273532,'[{16050001,3,9}]','[{100,[{16050001,138405}]}]'),(4,196,207,'[{2,96013},{6,3601}]',276063,'[{16050001,3,9}]','[{100,[{16050001,138474}]}]'),(4,197,207,'[{2,96915},{6,3635}]',278665,'[{16050001,3,9}]','[{100,[{16050001,138543}]}]'),(4,198,207,'[{2,97817},{6,3669}]',281267,'[{16050001,3,9}]','[{100,[{16050001,138612}]}]'),(4,199,207,'[{2,98719},{6,3702}]',283819,'[{16050001,3,9}]','[{100,[{16050001,138681}]}]'),(4,200,207,'[{2,99621},{6,3736}]',286421,'[{16050001,3,9}]','[{100,[{16050001,138750}]}]'),(4,201,216,'[{2,100523},{6,3770}]',289023,'[{16050001,4,12}]','[{100,[{16050001,138819}]}]'),(4,202,216,'[{2,101445},{6,3805}]',291695,'[{16050001,4,12}]','[{100,[{16050001,138891}]}]'),(4,203,216,'[{2,102368},{6,3839}]',294318,'[{16050001,4,12}]','[{100,[{16050001,138963}]}]'),(4,204,216,'[{2,103290},{6,3874}]',296990,'[{16050001,4,12}]','[{100,[{16050001,139035}]}]'),(4,205,216,'[{2,104213},{6,3908}]',299613,'[{16050001,4,12}]','[{100,[{16050001,139107}]}]'),(4,206,216,'[{2,105135},{6,3943}]',302285,'[{16050001,4,12}]','[{100,[{16050001,139179}]}]'),(4,207,216,'[{2,106078},{6,3978}]',304978,'[{16050001,4,12}]','[{100,[{16050001,139251}]}]'),(4,208,216,'[{2,107021},{6,4014}]',307721,'[{16050001,4,12}]','[{100,[{16050001,139323}]}]'),(4,209,216,'[{2,107964},{6,4049}]',310414,'[{16050001,4,12}]','[{100,[{16050001,139395}]}]'),(4,210,228,'[{2,108907},{6,4084}]',313107,'[{16050001,4,12}]','[{100,[{16050001,139467}]}]'),(4,211,228,'[{2,109849},{6,4120}]',315849,'[{16050001,4,12}]','[{100,[{16050001,139543}]}]'),(4,212,228,'[{2,110813},{6,4156}]',318613,'[{16050001,4,12}]','[{100,[{16050001,139619}]}]'),(4,213,228,'[{2,111776},{6,4192}]',321376,'[{16050001,4,12}]','[{100,[{16050001,139695}]}]'),(4,214,228,'[{2,112740},{6,4228}]',324140,'[{16050001,4,12}]','[{100,[{16050001,139771}]}]'),(4,215,228,'[{2,113703},{6,4264}]',326903,'[{16050001,4,12}]','[{100,[{16050001,139847}]}]'),(4,216,228,'[{2,114667},{6,4300}]',329667,'[{16050001,4,12}]','[{100,[{16050001,139923}]}]'),(4,217,228,'[{2,115650},{6,4337}]',332500,'[{16050001,4,12}]','[{100,[{16050001,139999}]}]'),(4,218,228,'[{2,116634},{6,4374}]',335334,'[{16050001,4,12}]','[{100,[{16050001,140075}]}]'),(4,219,228,'[{2,117618},{6,4411}]',338168,'[{16050001,4,12}]','[{100,[{16050001,140151}]}]'),(4,220,228,'[{2,118602},{6,4448}]',341002,'[{16050001,4,12}]','[{100,[{16050001,140227}]}]'),(4,221,228,'[{2,119586},{6,4485}]',343836,'[{16050001,4,12}]','[{100,[{16050001,140303}]}]'),(4,222,240,'[{2,120590},{6,4523}]',346740,'[{16050001,4,12}]','[{100,[{16050001,140379}]}]'),(4,223,240,'[{2,121595},{6,4560}]',349595,'[{16050001,4,12}]','[{100,[{16050001,140459}]}]'),(4,224,240,'[{2,122599},{6,4598}]',352499,'[{16050001,4,12}]','[{100,[{16050001,140539}]}]'),(4,225,240,'[{2,123604},{6,4636}]',355404,'[{16050001,4,12}]','[{100,[{16050001,140619}]}]'),(4,226,240,'[{2,124608},{6,4673}]',358258,'[{16050001,4,12}]','[{100,[{16050001,140699}]}]'),(4,227,240,'[{2,125633},{6,4712}]',361233,'[{16050001,4,12}]','[{100,[{16050001,140779}]}]'),(4,228,240,'[{2,126658},{6,4750}]',364158,'[{16050001,4,12}]','[{100,[{16050001,140859}]}]'),(4,229,240,'[{2,127683},{6,4789}]',367133,'[{16050001,4,12}]','[{100,[{16050001,140939}]}]'),(4,230,240,'[{2,128708},{6,4827}]',370058,'[{16050001,4,12}]','[{100,[{16050001,141019}]}]'),(4,231,240,'[{2,129733},{6,4865}]',372983,'[{16050001,4,12}]','[{100,[{16050001,141099}]}]'),(4,232,240,'[{2,130778},{6,4905}]',376028,'[{16050001,4,12}]','[{100,[{16050001,141179}]}]'),(4,233,240,'[{2,131823},{6,4944}]',379023,'[{16050001,4,12}]','[{100,[{16050001,141259}]}]'),(4,234,252,'[{2,132869},{6,4983}]',382019,'[{16050001,4,12}]','[{100,[{16050001,141339}]}]'),(4,235,252,'[{2,133914},{6,5022}]',385014,'[{16050001,4,12}]','[{100,[{16050001,141423}]}]'),(4,236,252,'[{2,134960},{6,5061}]',388010,'[{16050001,4,12}]','[{100,[{16050001,141507}]}]'),(4,237,252,'[{2,136025},{6,5101}]',391075,'[{16050001,4,12}]','[{100,[{16050001,141591}]}]'),(4,238,252,'[{2,137091},{6,5141}]',394141,'[{16050001,4,12}]','[{100,[{16050001,141675}]}]'),(4,239,252,'[{2,138157},{6,5181}]',397207,'[{16050001,4,12}]','[{100,[{16050001,141759}]}]'),(4,240,252,'[{2,139223},{6,5221}]',400273,'[{16050001,4,12}]','[{100,[{16050001,141843}]}]'),(4,241,252,'[{2,140289},{6,5261}]',403339,'[{16050001,4,12}]','[{100,[{16050001,141927}]}]'),(4,242,252,'[{2,141375},{6,5302}]',406475,'[{16050001,4,12}]','[{100,[{16050001,142011}]}]'),(4,243,252,'[{2,142462},{6,5343}]',409612,'[{16050001,4,12}]','[{100,[{16050001,142095}]}]'),(4,244,252,'[{2,143548},{6,5384}]',412748,'[{16050001,4,12}]','[{100,[{16050001,142179}]}]'),(4,245,252,'[{2,144635},{6,5424}]',415835,'[{16050001,4,12}]','[{100,[{16050001,142263}]}]'),(4,246,264,'[{2,145721},{6,5465}]',418971,'[{16050001,4,12}]','[{100,[{16050001,142347}]}]'),(4,247,264,'[{2,146828},{6,5507}]',422178,'[{16050001,4,12}]','[{100,[{16050001,142435}]}]'),(4,248,264,'[{2,147935},{6,5548}]',425335,'[{16050001,4,12}]','[{100,[{16050001,142523}]}]'),(4,249,264,'[{2,149042},{6,5590}]',428542,'[{16050001,4,12}]','[{100,[{16050001,142611}]}]'),(4,250,264,'[{2,150149},{6,5631}]',431699,'[{16050001,4,12}]','[{100,[{16050001,142699}]}]'),(4,251,264,'[{2,151256},{6,5673}]',434906,'[{16050001,4,12}]','[{100,[{16050001,142787}]}]'),(4,252,264,'[{2,152383},{6,5715}]',438133,'[{16050001,4,12}]','[{100,[{16050001,142875}]}]'),(4,253,264,'[{2,153510},{6,5757}]',441360,'[{16050001,4,12}]','[{100,[{16050001,142963}]}]'),(4,254,264,'[{2,154638},{6,5799}]',444588,'[{16050001,4,12}]','[{100,[{16050001,143051}]}]'),(4,255,264,'[{2,155765},{6,5842}]',447865,'[{16050001,4,12}]','[{100,[{16050001,143139}]}]'),(4,256,264,'[{2,156892},{6,5884}]',451092,'[{16050001,4,12}]','[{100,[{16050001,143227}]}]'),(4,257,264,'[{2,158040},{6,5927}]',454390,'[{16050001,4,12}]','[{100,[{16050001,143315}]}]'),(4,258,276,'[{2,159188},{6,5970}]',457688,'[{16050001,4,12}]','[{100,[{16050001,143403}]}]'),(4,259,276,'[{2,160336},{6,6013}]',460986,'[{16050001,4,12}]','[{100,[{16050001,143495}]}]'),(4,260,276,'[{2,161484},{6,6056}]',464284,'[{16050001,4,12}]','[{100,[{16050001,143587}]}]'),(4,261,276,'[{2,162632},{6,6099}]',467582,'[{16050001,4,12}]','[{100,[{16050001,143679}]}]'),(4,262,276,'[{2,163800},{6,6143}]',470950,'[{16050001,4,12}]','[{100,[{16050001,143771}]}]'),(4,263,276,'[{2,164969},{6,6187}]',474319,'[{16050001,4,12}]','[{100,[{16050001,143863}]}]'),(4,264,276,'[{2,166137},{6,6231}]',477687,'[{16050001,4,12}]','[{100,[{16050001,143955}]}]'),(4,265,276,'[{2,167305},{6,6274}]',481005,'[{16050001,4,12}]','[{100,[{16050001,144047}]}]'),(4,266,276,'[{2,168474},{6,6318}]',484374,'[{16050001,4,12}]','[{100,[{16050001,144139}]}]'),(4,267,276,'[{2,169663},{6,6363}]',487813,'[{16050001,4,12}]','[{100,[{16050001,144231}]}]'),(4,268,276,'[{2,170852},{6,6407}]',491202,'[{16050001,4,12}]','[{100,[{16050001,144323}]}]'),(4,269,276,'[{2,172041},{6,6452}]',494641,'[{16050001,4,12}]','[{100,[{16050001,144415}]}]'),(4,270,288,'[{2,173229},{6,6497}]',498079,'[{16050001,4,12}]','[{100,[{16050001,144507}]}]'),(4,271,288,'[{2,174418},{6,6541}]',501468,'[{16050001,4,12}]','[{100,[{16050001,144603}]}]'),(4,272,288,'[{2,175628},{6,6587}]',504978,'[{16050001,4,12}]','[{100,[{16050001,144699}]}]'),(4,273,288,'[{2,176837},{6,6632}]',508437,'[{16050001,4,12}]','[{100,[{16050001,144795}]}]'),(4,274,288,'[{2,178046},{6,6677}]',511896,'[{16050001,4,12}]','[{100,[{16050001,144891}]}]'),(4,275,288,'[{2,179256},{6,6723}]',515406,'[{16050001,4,12}]','[{100,[{16050001,144987}]}]'),(4,276,288,'[{2,180465},{6,6768}]',518865,'[{16050001,4,12}]','[{100,[{16050001,145083}]}]'),(4,277,288,'[{2,181695},{6,6814}]',522395,'[{16050001,4,12}]','[{100,[{16050001,145179}]}]'),(4,278,288,'[{2,182925},{6,6860}]',525925,'[{16050001,4,12}]','[{100,[{16050001,145275}]}]'),(4,279,288,'[{2,184155},{6,6906}]',529455,'[{16050001,4,12}]','[{100,[{16050001,145371}]}]'),(4,280,288,'[{2,185385},{6,6952}]',532985,'[{16050001,4,12}]','[{100,[{16050001,145467}]}]'),(4,281,288,'[{2,186615},{6,6999}]',536565,'[{16050001,4,12}]','[{100,[{16050001,145563}]}]'),(4,282,300,'[{2,187865},{6,7045}]',540115,'[{16050001,4,12}]','[{100,[{16050001,145659}]}]'),(4,283,300,'[{2,189115},{6,7092}]',543715,'[{16050001,4,12}]','[{100,[{16050001,145759}]}]'),(4,284,300,'[{2,190366},{6,7139}]',547316,'[{16050001,4,12}]','[{100,[{16050001,145859}]}]'),(4,285,300,'[{2,191616},{6,7186}]',550916,'[{16050001,4,12}]','[{100,[{16050001,145959}]}]'),(4,286,300,'[{2,192867},{6,7233}]',554517,'[{16050001,4,12}]','[{100,[{16050001,146059}]}]'),(4,287,300,'[{2,194137},{6,7281}]',558187,'[{16050001,4,12}]','[{100,[{16050001,146159}]}]'),(4,288,300,'[{2,195408},{6,7328}]',561808,'[{16050001,4,12}]','[{100,[{16050001,146259}]}]'),(4,289,300,'[{2,196679},{6,7376}]',565479,'[{16050001,4,12}]','[{100,[{16050001,146359}]}]'),(4,290,300,'[{2,197950},{6,7424}]',569150,'[{16050001,4,12}]','[{100,[{16050001,146459}]}]'),(4,291,300,'[{2,199221},{6,7471}]',572771,'[{16050001,4,12}]','[{100,[{16050001,146559}]}]'),(4,292,300,'[{2,200512},{6,7520}]',576512,'[{16050001,4,12}]','[{100,[{16050001,146659}]}]'),(4,293,300,'[{2,201804},{6,7568}]',580204,'[{16050001,4,12}]','[{100,[{16050001,146759}]}]'),(4,294,312,'[{2,203095},{6,7617}]',583945,'[{16050001,4,12}]','[{100,[{16050001,146859}]}]'),(4,295,312,'[{2,204386},{6,7665}]',587636,'[{16050001,4,12}]','[{100,[{16050001,146963}]}]'),(4,296,312,'[{2,205678},{6,7713}]',591328,'[{16050001,4,12}]','[{100,[{16050001,147067}]}]'),(4,297,312,'[{2,206990},{6,7763}]',595140,'[{16050001,4,12}]','[{100,[{16050001,147171}]}]'),(4,298,312,'[{2,208302},{6,7812}]',598902,'[{16050001,4,12}]','[{100,[{16050001,147275}]}]'),(4,299,312,'[{2,209613},{6,7861}]',602663,'[{16050001,4,12}]','[{100,[{16050001,147379}]}]'),(4,300,312,'[{2,210925},{6,7910}]',606425,'[{16050001,4,12}]','[{100,[{16050001,147483}]}]'),(4,301,315,'[{2,212237},{6,7959}]',610187,'[{16050001,5,15}]','[{100,[{16050001,147587}]}]'),(4,302,315,'[{2,213570},{6,8009}]',614020,'[{16050001,5,15}]','[{100,[{16050001,147692}]}]'),(4,303,315,'[{2,214902},{6,8059}]',617852,'[{16050001,5,15}]','[{100,[{16050001,147797}]}]'),(4,304,315,'[{2,216234},{6,8109}]',621684,'[{16050001,5,15}]','[{100,[{16050001,147902}]}]'),(4,305,315,'[{2,217567},{6,8159}]',625517,'[{16050001,5,15}]','[{100,[{16050001,148007}]}]'),(4,306,315,'[{2,218899},{6,8209}]',629349,'[{16050001,5,15}]','[{100,[{16050001,148112}]}]'),(4,307,315,'[{2,220252},{6,8260}]',633252,'[{16050001,5,15}]','[{100,[{16050001,148217}]}]'),(4,308,315,'[{2,221605},{6,8311}]',637155,'[{16050001,5,15}]','[{100,[{16050001,148322}]}]'),(4,309,330,'[{2,222958},{6,8361}]',641008,'[{16050001,5,15}]','[{100,[{16050001,148427}]}]'),(4,310,330,'[{2,224311},{6,8412}]',644911,'[{16050001,5,15}]','[{100,[{16050001,148537}]}]'),(4,311,330,'[{2,225663},{6,8463}]',648813,'[{16050001,5,15}]','[{100,[{16050001,148647}]}]'),(4,312,330,'[{2,227037},{6,8514}]',652737,'[{16050001,5,15}]','[{100,[{16050001,148757}]}]'),(4,313,330,'[{2,228410},{6,8566}]',656710,'[{16050001,5,15}]','[{100,[{16050001,148867}]}]'),(4,314,330,'[{2,229784},{6,8617}]',660634,'[{16050001,5,15}]','[{100,[{16050001,148977}]}]'),(4,315,330,'[{2,231157},{6,8669}]',664607,'[{16050001,5,15}]','[{100,[{16050001,149087}]}]'),(4,316,330,'[{2,232530},{6,8720}]',668530,'[{16050001,5,15}]','[{100,[{16050001,149197}]}]'),(4,317,330,'[{2,233924},{6,8773}]',672574,'[{16050001,5,15}]','[{100,[{16050001,149307}]}]'),(4,318,330,'[{2,235318},{6,8825}]',676568,'[{16050001,5,15}]','[{100,[{16050001,149417}]}]'),(4,319,330,'[{2,236712},{6,8877}]',680562,'[{16050001,5,15}]','[{100,[{16050001,149527}]}]'),(4,320,330,'[{2,238106},{6,8929}]',684556,'[{16050001,5,15}]','[{100,[{16050001,149637}]}]'),(4,321,330,'[{2,239500},{6,8982}]',688600,'[{16050001,5,15}]','[{100,[{16050001,149747}]}]'),(4,322,330,'[{2,240914},{6,9035}]',692664,'[{16050001,5,15}]','[{100,[{16050001,149857}]}]'),(4,323,330,'[{2,242328},{6,9088}]',696728,'[{16050001,5,15}]','[{100,[{16050001,149967}]}]'),(4,324,345,'[{2,243743},{6,9141}]',700793,'[{16050001,5,15}]','[{100,[{16050001,150077}]}]'),(4,325,345,'[{2,245157},{6,9194}]',704857,'[{16050001,5,15}]','[{100,[{16050001,150192}]}]'),(4,326,345,'[{2,246571},{6,9247}]',708921,'[{16050001,5,15}]','[{100,[{16050001,150307}]}]'),(4,327,345,'[{2,248006},{6,9301}]',713056,'[{16050001,5,15}]','[{100,[{16050001,150422}]}]'),(4,328,345,'[{2,249441},{6,9355}]',717191,'[{16050001,5,15}]','[{100,[{16050001,150537}]}]'),(4,329,345,'[{2,250876},{6,9408}]',721276,'[{16050001,5,15}]','[{100,[{16050001,150652}]}]'),(4,330,345,'[{2,252311},{6,9462}]',725411,'[{16050001,5,15}]','[{100,[{16050001,150767}]}]'),(4,331,345,'[{2,253746},{6,9516}]',729546,'[{16050001,5,15}]','[{100,[{16050001,150882}]}]'),(4,332,345,'[{2,255201},{6,9571}]',733751,'[{16050001,5,15}]','[{100,[{16050001,150997}]}]'),(4,333,345,'[{2,256656},{6,9625}]',737906,'[{16050001,5,15}]','[{100,[{16050001,151112}]}]'),(4,334,345,'[{2,258112},{6,9680}]',742112,'[{16050001,5,15}]','[{100,[{16050001,151227}]}]'),(4,335,345,'[{2,259567},{6,9734}]',746267,'[{16050001,5,15}]','[{100,[{16050001,151342}]}]'),(4,336,345,'[{2,261023},{6,9789}]',750473,'[{16050001,5,15}]','[{100,[{16050001,151457}]}]'),(4,337,345,'[{2,262498},{6,9844}]',754698,'[{16050001,5,15}]','[{100,[{16050001,151572}]}]'),(4,338,345,'[{2,263974},{6,9900}]',758974,'[{16050001,5,15}]','[{100,[{16050001,151687}]}]'),(4,339,360,'[{2,265450},{6,9955}]',763200,'[{16050001,5,15}]','[{100,[{16050001,151802}]}]'),(4,340,360,'[{2,266926},{6,10010}]',767426,'[{16050001,5,15}]','[{100,[{16050001,151922}]}]'),(4,341,360,'[{2,268402},{6,10066}]',771702,'[{16050001,5,15}]','[{100,[{16050001,152042}]}]'),(4,342,360,'[{2,269898},{6,10122}]',775998,'[{16050001,5,15}]','[{100,[{16050001,152162}]}]'),(4,343,360,'[{2,271395},{6,10178}]',780295,'[{16050001,5,15}]','[{100,[{16050001,152282}]}]'),(4,344,360,'[{2,272891},{6,10234}]',784591,'[{16050001,5,15}]','[{100,[{16050001,152402}]}]'),(4,345,360,'[{2,274387},{6,10290}]',788887,'[{16050001,5,15}]','[{100,[{16050001,152522}]}]'),(4,346,360,'[{2,275884},{6,10346}]',793184,'[{16050001,5,15}]','[{100,[{16050001,152642}]}]'),(4,347,360,'[{2,277400},{6,10403}]',797550,'[{16050001,5,15}]','[{100,[{16050001,152762}]}]'),(4,348,360,'[{2,278917},{6,10460}]',801917,'[{16050001,5,15}]','[{100,[{16050001,152882}]}]'),(4,349,360,'[{2,280434},{6,10517}]',806284,'[{16050001,5,15}]','[{100,[{16050001,153002}]}]'),(4,350,360,'[{2,281951},{6,10574}]',810651,'[{16050001,5,15}]','[{100,[{16050001,153122}]}]'),(4,351,360,'[{2,283468},{6,10631}]',815018,'[{16050001,5,15}]','[{100,[{16050001,153242}]}]'),(4,352,360,'[{2,285005},{6,10688}]',819405,'[{16050001,5,15}]','[{100,[{16050001,153362}]}]'),(4,353,360,'[{2,286543},{6,10746}]',823843,'[{16050001,5,15}]','[{100,[{16050001,153482}]}]'),(4,354,375,'[{2,288080},{6,10803}]',828230,'[{16050001,5,15}]','[{100,[{16050001,153602}]}]'),(4,355,375,'[{2,289617},{6,10861}]',832667,'[{16050001,5,15}]','[{100,[{16050001,153727}]}]'),(4,356,375,'[{2,291155},{6,10919}]',837105,'[{16050001,5,15}]','[{100,[{16050001,153852}]}]'),(4,357,375,'[{2,292712},{6,10977}]',841562,'[{16050001,5,15}]','[{100,[{16050001,153977}]}]'),(4,358,375,'[{2,294270},{6,11036}]',846070,'[{16050001,5,15}]','[{100,[{16050001,154102}]}]'),(4,359,375,'[{2,295828},{6,11094}]',850528,'[{16050001,5,15}]','[{100,[{16050001,154227}]}]'),(4,360,375,'[{2,297386},{6,11152}]',854986,'[{16050001,5,15}]','[{100,[{16050001,154352}]}]'),(4,361,375,'[{2,298944},{6,11211}]',859494,'[{16050001,5,15}]','[{100,[{16050001,154477}]}]'),(4,362,375,'[{2,300522},{6,11270}]',864022,'[{16050001,5,15}]','[{100,[{16050001,154602}]}]'),(4,363,375,'[{2,302101},{6,11329}]',868551,'[{16050001,5,15}]','[{100,[{16050001,154727}]}]'),(4,364,375,'[{2,303679},{6,11388}]',873079,'[{16050001,5,15}]','[{100,[{16050001,154852}]}]'),(4,365,375,'[{2,305257},{6,11448}]',877657,'[{16050001,5,15}]','[{100,[{16050001,154977}]}]'),(4,366,375,'[{2,306836},{6,11507}]',882186,'[{16050001,5,15}]','[{100,[{16050001,155102}]}]'),(4,367,375,'[{2,308434},{6,11567}]',886784,'[{16050001,5,15}]','[{100,[{16050001,155227}]}]'),(4,368,375,'[{2,310033},{6,11627}]',891383,'[{16050001,5,15}]','[{100,[{16050001,155352}]}]'),(4,369,390,'[{2,311632},{6,11687}]',895982,'[{16050001,5,15}]','[{100,[{16050001,155477}]}]'),(4,370,390,'[{2,313231},{6,11747}]',900581,'[{16050001,5,15}]','[{100,[{16050001,155607}]}]'),(4,371,390,'[{2,314830},{6,11807}]',905180,'[{16050001,5,15}]','[{100,[{16050001,155737}]}]'),(4,372,390,'[{2,316449},{6,11867}]',909799,'[{16050001,5,15}]','[{100,[{16050001,155867}]}]'),(4,373,390,'[{2,318069},{6,11928}]',914469,'[{16050001,5,15}]','[{100,[{16050001,155997}]}]'),(4,374,390,'[{2,319688},{6,11989}]',919138,'[{16050001,5,15}]','[{100,[{16050001,156127}]}]'),(4,375,390,'[{2,321307},{6,12050}]',923807,'[{16050001,5,15}]','[{100,[{16050001,156257}]}]'),(4,376,390,'[{2,322927},{6,12110}]',928427,'[{16050001,5,15}]','[{100,[{16050001,156387}]}]'),(4,377,390,'[{2,324566},{6,12172}]',933166,'[{16050001,5,15}]','[{100,[{16050001,156517}]}]'),(4,378,390,'[{2,326206},{6,12233}]',937856,'[{16050001,5,15}]','[{100,[{16050001,156647}]}]'),(4,379,390,'[{2,327846},{6,12295}]',942596,'[{16050001,5,15}]','[{100,[{16050001,156777}]}]'),(4,380,390,'[{2,329486},{6,12356}]',947286,'[{16050001,5,15}]','[{100,[{16050001,156907}]}]'),(4,381,390,'[{2,331126},{6,12418}]',952026,'[{16050001,5,15}]','[{100,[{16050001,157037}]}]'),(4,382,390,'[{2,332786},{6,12480}]',956786,'[{16050001,5,15}]','[{100,[{16050001,157167}]}]'),(4,383,390,'[{2,334446},{6,12542}]',961546,'[{16050001,5,15}]','[{100,[{16050001,157297}]}]'),(4,384,405,'[{2,336107},{6,12604}]',966307,'[{16050001,5,15}]','[{100,[{16050001,157427}]}]'),(4,385,405,'[{2,337767},{6,12667}]',971117,'[{16050001,5,15}]','[{100,[{16050001,157562}]}]'),(4,386,405,'[{2,339428},{6,12729}]',975878,'[{16050001,5,15}]','[{100,[{16050001,157697}]}]'),(4,387,405,'[{2,341108},{6,12792}]',980708,'[{16050001,5,15}]','[{100,[{16050001,157832}]}]'),(4,388,405,'[{2,342789},{6,12855}]',985539,'[{16050001,5,15}]','[{100,[{16050001,157967}]}]'),(4,389,405,'[{2,344470},{6,12918}]',990370,'[{16050001,5,15}]','[{100,[{16050001,158102}]}]'),(4,390,405,'[{2,346151},{6,12981}]',995201,'[{16050001,5,15}]','[{100,[{16050001,158237}]}]'),(4,391,405,'[{2,347832},{6,13044}]',1000032,'[{16050001,5,15}]','[{100,[{16050001,158372}]}]'),(4,392,405,'[{2,349533},{6,13108}]',1004933,'[{16050001,5,15}]','[{100,[{16050001,158507}]}]'),(4,393,405,'[{2,351234},{6,13172}]',1009834,'[{16050001,5,15}]','[{100,[{16050001,158642}]}]'),(4,394,405,'[{2,352936},{6,13236}]',1014736,'[{16050001,5,15}]','[{100,[{16050001,158777}]}]'),(4,395,405,'[{2,354637},{6,13299}]',1019587,'[{16050001,5,15}]','[{100,[{16050001,158912}]}]'),(4,396,405,'[{2,356338},{6,13363}]',1024488,'[{16050001,5,15}]','[{100,[{16050001,159047}]}]'),(4,397,405,'[{2,358060},{6,13428}]',1029460,'[{16050001,5,15}]','[{100,[{16050001,159182}]}]'),(4,398,405,'[{2,359782},{6,13492}]',1034382,'[{16050001,5,15}]','[{100,[{16050001,159317}]}]'),(4,399,420,'[{2,361504},{6,13557}]',1039354,'[{16050001,5,15}]','[{100,[{16050001,159452}]}]'),(4,400,420,'[{2,363226},{6,13621}]',1044276,'[{16050001,5,15}]','[{100,[{16050001,159592}]}]'),(4,401,414,'[{2,364948},{6,13686}]',1049248,'[{16050001,6,18}]','[{100,[{16050001,159732}]}]'),(4,402,414,'[{2,366690},{6,13751}]',1054240,'[{16050001,6,18}]','[{100,[{16050001,159870}]}]'),(4,403,414,'[{2,368432},{6,13817}]',1059282,'[{16050001,6,18}]','[{100,[{16050001,160008}]}]'),(4,404,414,'[{2,370175},{6,13882}]',1064275,'[{16050001,6,18}]','[{100,[{16050001,160146}]}]'),(4,405,414,'[{2,371917},{6,13947}]',1069267,'[{16050001,6,18}]','[{100,[{16050001,160284}]}]'),(4,406,414,'[{2,373659},{6,14013}]',1074309,'[{16050001,6,18}]','[{100,[{16050001,160422}]}]'),(4,407,414,'[{2,375422},{6,14079}]',1079372,'[{16050001,6,18}]','[{100,[{16050001,160560}]}]'),(4,408,432,'[{2,377185},{6,14145}]',1084435,'[{16050001,6,18}]','[{100,[{16050001,160698}]}]'),(4,409,432,'[{2,378948},{6,14211}]',1089498,'[{16050001,6,18}]','[{100,[{16050001,160842}]}]'),(4,410,432,'[{2,380711},{6,14277}]',1094561,'[{16050001,6,18}]','[{100,[{16050001,160986}]}]'),(4,411,432,'[{2,382473},{6,14343}]',1099623,'[{16050001,6,18}]','[{100,[{16050001,161130}]}]'),(4,412,432,'[{2,384257},{6,14410}]',1104757,'[{16050001,6,18}]','[{100,[{16050001,161274}]}]'),(4,413,432,'[{2,386040},{6,14477}]',1109890,'[{16050001,6,18}]','[{100,[{16050001,161418}]}]'),(4,414,432,'[{2,387823},{6,14544}]',1115023,'[{16050001,6,18}]','[{100,[{16050001,161562}]}]'),(4,415,432,'[{2,389607},{6,14611}]',1120157,'[{16050001,6,18}]','[{100,[{16050001,161706}]}]'),(4,416,432,'[{2,391390},{6,14678}]',1125290,'[{16050001,6,18}]','[{100,[{16050001,161850}]}]'),(4,417,432,'[{2,393194},{6,14745}]',1130444,'[{16050001,6,18}]','[{100,[{16050001,161994}]}]'),(4,418,432,'[{2,394998},{6,14813}]',1135648,'[{16050001,6,18}]','[{100,[{16050001,162138}]}]'),(4,419,432,'[{2,396802},{6,14881}]',1140852,'[{16050001,6,18}]','[{100,[{16050001,162282}]}]'),(4,420,432,'[{2,398605},{6,14948}]',1146005,'[{16050001,6,18}]','[{100,[{16050001,162426}]}]'),(4,421,432,'[{2,400409},{6,15016}]',1151209,'[{16050001,6,18}]','[{100,[{16050001,162570}]}]'),(4,422,432,'[{2,402234},{6,15084}]',1156434,'[{16050001,6,18}]','[{100,[{16050001,162714}]}]'),(4,423,432,'[{2,404058},{6,15153}]',1161708,'[{16050001,6,18}]','[{100,[{16050001,162858}]}]'),(4,424,432,'[{2,405882},{6,15221}]',1166932,'[{16050001,6,18}]','[{100,[{16050001,163002}]}]'),(4,425,432,'[{2,407706},{6,15289}]',1172156,'[{16050001,6,18}]','[{100,[{16050001,163146}]}]'),(4,426,450,'[{2,409531},{6,15358}]',1177431,'[{16050001,6,18}]','[{100,[{16050001,163290}]}]'),(4,427,450,'[{2,411376},{6,15427}]',1182726,'[{16050001,6,18}]','[{100,[{16050001,163440}]}]'),(4,428,450,'[{2,413220},{6,15496}]',1188020,'[{16050001,6,18}]','[{100,[{16050001,163590}]}]'),(4,429,450,'[{2,415065},{6,15565}]',1193315,'[{16050001,6,18}]','[{100,[{16050001,163740}]}]'),(4,430,450,'[{2,416910},{6,15635}]',1198660,'[{16050001,6,18}]','[{100,[{16050001,163890}]}]'),(4,431,450,'[{2,418755},{6,15704}]',1203955,'[{16050001,6,18}]','[{100,[{16050001,164040}]}]'),(4,432,450,'[{2,420620},{6,15774}]',1209320,'[{16050001,6,18}]','[{100,[{16050001,164190}]}]'),(4,433,450,'[{2,422486},{6,15844}]',1214686,'[{16050001,6,18}]','[{100,[{16050001,164340}]}]'),(4,434,450,'[{2,424351},{6,15914}]',1220051,'[{16050001,6,18}]','[{100,[{16050001,164490}]}]'),(4,435,450,'[{2,426216},{6,15984}]',1225416,'[{16050001,6,18}]','[{100,[{16050001,164640}]}]'),(4,436,450,'[{2,428082},{6,16054}]',1230782,'[{16050001,6,18}]','[{100,[{16050001,164790}]}]'),(4,437,450,'[{2,429967},{6,16124}]',1236167,'[{16050001,6,18}]','[{100,[{16050001,164940}]}]'),(4,438,450,'[{2,431853},{6,16195}]',1241603,'[{16050001,6,18}]','[{100,[{16050001,165090}]}]'),(4,439,450,'[{2,433739},{6,16266}]',1247039,'[{16050001,6,18}]','[{100,[{16050001,165240}]}]'),(4,440,450,'[{2,435625},{6,16336}]',1252425,'[{16050001,6,18}]','[{100,[{16050001,165390}]}]'),(4,441,450,'[{2,437511},{6,16407}]',1257861,'[{16050001,6,18}]','[{100,[{16050001,165540}]}]'),(4,442,450,'[{2,439417},{6,16479}]',1263367,'[{16050001,6,18}]','[{100,[{16050001,165690}]}]'),(4,443,450,'[{2,441323},{6,16550}]',1268823,'[{16050001,6,18}]','[{100,[{16050001,165840}]}]'),(4,444,468,'[{2,443230},{6,16622}]',1274330,'[{16050001,6,18}]','[{100,[{16050001,165990}]}]'),(4,445,468,'[{2,445136},{6,16693}]',1279786,'[{16050001,6,18}]','[{100,[{16050001,166146}]}]'),(4,446,468,'[{2,447042},{6,16765}]',1285292,'[{16050001,6,18}]','[{100,[{16050001,166302}]}]'),(4,447,468,'[{2,448969},{6,16837}]',1290819,'[{16050001,6,18}]','[{100,[{16050001,166458}]}]'),(4,448,468,'[{2,450896},{6,16909}]',1296346,'[{16050001,6,18}]','[{100,[{16050001,166614}]}]'),(4,449,468,'[{2,452823},{6,16981}]',1301873,'[{16050001,6,18}]','[{100,[{16050001,166770}]}]'),(4,450,468,'[{2,454749},{6,17054}]',1307449,'[{16050001,6,18}]','[{100,[{16050001,166926}]}]'),(4,451,468,'[{2,456676},{6,17126}]',1312976,'[{16050001,6,18}]','[{100,[{16050001,167082}]}]'),(4,452,468,'[{2,458624},{6,17199}]',1318574,'[{16050001,6,18}]','[{100,[{16050001,167238}]}]'),(4,453,468,'[{2,460571},{6,17272}]',1324171,'[{16050001,6,18}]','[{100,[{16050001,167394}]}]'),(4,454,468,'[{2,462518},{6,17345}]',1329768,'[{16050001,6,18}]','[{100,[{16050001,167550}]}]'),(4,455,468,'[{2,464466},{6,17418}]',1335366,'[{16050001,6,18}]','[{100,[{16050001,167706}]}]'),(4,456,468,'[{2,466413},{6,17491}]',1340963,'[{16050001,6,18}]','[{100,[{16050001,167862}]}]'),(4,457,468,'[{2,468381},{6,17565}]',1346631,'[{16050001,6,18}]','[{100,[{16050001,168018}]}]'),(4,458,468,'[{2,470348},{6,17639}]',1352298,'[{16050001,6,18}]','[{100,[{16050001,168174}]}]'),(4,459,468,'[{2,472316},{6,17712}]',1357916,'[{16050001,6,18}]','[{100,[{16050001,168330}]}]'),(4,460,468,'[{2,474284},{6,17786}]',1363584,'[{16050001,6,18}]','[{100,[{16050001,168486}]}]'),(4,461,468,'[{2,476252},{6,17860}]',1369252,'[{16050001,6,18}]','[{100,[{16050001,168642}]}]'),(4,462,486,'[{2,478240},{6,17934}]',1374940,'[{16050001,6,18}]','[{100,[{16050001,168798}]}]'),(4,463,486,'[{2,480229},{6,18009}]',1380679,'[{16050001,6,18}]','[{100,[{16050001,168960}]}]'),(4,464,486,'[{2,482217},{6,18084}]',1386417,'[{16050001,6,18}]','[{100,[{16050001,169122}]}]'),(4,465,486,'[{2,484205},{6,18158}]',1392105,'[{16050001,6,18}]','[{100,[{16050001,169284}]}]'),(4,466,486,'[{2,486193},{6,18233}]',1397843,'[{16050001,6,18}]','[{100,[{16050001,169446}]}]'),(4,467,486,'[{2,488202},{6,18308}]',1403602,'[{16050001,6,18}]','[{100,[{16050001,169608}]}]'),(4,468,486,'[{2,490211},{6,18383}]',1409361,'[{16050001,6,18}]','[{100,[{16050001,169770}]}]'),(4,469,486,'[{2,492220},{6,18459}]',1415170,'[{16050001,6,18}]','[{100,[{16050001,169932}]}]'),(4,470,486,'[{2,494229},{6,18534}]',1420929,'[{16050001,6,18}]','[{100,[{16050001,170094}]}]'),(4,471,486,'[{2,496238},{6,18609}]',1426688,'[{16050001,6,18}]','[{100,[{16050001,170256}]}]'),(4,472,486,'[{2,498267},{6,18685}]',1432517,'[{16050001,6,18}]','[{100,[{16050001,170418}]}]'),(4,473,486,'[{2,500296},{6,18762}]',1438396,'[{16050001,6,18}]','[{100,[{16050001,170580}]}]'),(4,474,486,'[{2,502325},{6,18838}]',1444225,'[{16050001,6,18}]','[{100,[{16050001,170742}]}]'),(4,475,486,'[{2,504355},{6,18914}]',1450055,'[{16050001,6,18}]','[{100,[{16050001,170904}]}]'),(4,476,486,'[{2,506384},{6,18990}]',1455884,'[{16050001,6,18}]','[{100,[{16050001,171066}]}]'),(4,477,486,'[{2,508434},{6,19067}]',1461784,'[{16050001,6,18}]','[{100,[{16050001,171228}]}]'),(4,478,486,'[{2,510484},{6,19144}]',1467684,'[{16050001,6,18}]','[{100,[{16050001,171390}]}]'),(4,479,486,'[{2,512533},{6,19220}]',1473533,'[{16050001,6,18}]','[{100,[{16050001,171552}]}]'),(4,480,504,'[{2,514583},{6,19297}]',1479433,'[{16050001,6,18}]','[{100,[{16050001,171714}]}]'),(4,481,504,'[{2,516633},{6,19374}]',1485333,'[{16050001,6,18}]','[{100,[{16050001,171882}]}]'),(4,482,504,'[{2,518703},{6,19452}]',1491303,'[{16050001,6,18}]','[{100,[{16050001,172050}]}]'),(4,483,504,'[{2,520774},{6,19529}]',1497224,'[{16050001,6,18}]','[{100,[{16050001,172218}]}]'),(4,484,504,'[{2,522844},{6,19607}]',1503194,'[{16050001,6,18}]','[{100,[{16050001,172386}]}]'),(4,485,504,'[{2,524914},{6,19685}]',1509164,'[{16050001,6,18}]','[{100,[{16050001,172554}]}]'),(4,486,504,'[{2,526985},{6,19762}]',1515085,'[{16050001,6,18}]','[{100,[{16050001,172722}]}]'),(4,487,504,'[{2,529075},{6,19841}]',1521125,'[{16050001,6,18}]','[{100,[{16050001,172890}]}]'),(4,488,504,'[{2,531166},{6,19919}]',1527116,'[{16050001,6,18}]','[{100,[{16050001,173058}]}]'),(4,489,504,'[{2,533257},{6,19998}]',1533157,'[{16050001,6,18}]','[{100,[{16050001,173226}]}]'),(4,490,504,'[{2,535348},{6,20076}]',1539148,'[{16050001,6,18}]','[{100,[{16050001,173394}]}]'),(4,491,504,'[{2,537439},{6,20154}]',1545139,'[{16050001,6,18}]','[{100,[{16050001,173562}]}]'),(4,492,504,'[{2,539550},{6,20234}]',1551250,'[{16050001,6,18}]','[{100,[{16050001,173730}]}]'),(4,493,504,'[{2,541661},{6,20313}]',1557311,'[{16050001,6,18}]','[{100,[{16050001,173898}]}]'),(4,494,504,'[{2,543772},{6,20392}]',1563372,'[{16050001,6,18}]','[{100,[{16050001,174066}]}]'),(4,495,504,'[{2,545884},{6,20471}]',1569434,'[{16050001,6,18}]','[{100,[{16050001,174234}]}]'),(4,496,504,'[{2,547995},{6,20550}]',1575495,'[{16050001,6,18}]','[{100,[{16050001,174402}]}]'),(4,497,504,'[{2,550127},{6,20630}]',1581627,'[{16050001,6,18}]','[{100,[{16050001,174570}]}]'),(4,498,522,'[{2,552259},{6,20710}]',1587759,'[{16050001,6,18}]','[{100,[{16050001,174738}]}]'),(4,499,522,'[{2,554390},{6,20790}]',1593890,'[{16050001,6,18}]','[{100,[{16050001,174912}]}]'),(4,500,522,'[{2,556522},{6,20870}]',1600022,'[]','[{100,[{16050001,175086}]}]'),(5,1,9,'[{1,5},{7,4}]',300,'[{16050001,1,3}]','[{100,[{16050001,175260}]}]'),(5,2,9,'[{1,10},{7,7}]',550,'[{16050001,1,3}]','[{100,[{16050001,175263}]}]'),(5,3,12,'[{1,15},{7,11}]',850,'[{16050001,1,3}]','[{100,[{16050001,175266}]}]'),(5,4,12,'[{1,20},{7,15}]',1150,'[{16050001,1,3}]','[{100,[{16050001,175270}]}]'),(5,5,12,'[{1,25},{7,19}]',1450,'[{16050001,1,3}]','[{100,[{16050001,175274}]}]'),(5,6,15,'[{1,30},{7,23}]',1750,'[{16050001,1,3}]','[{100,[{16050001,175278}]}]'),(5,7,15,'[{1,36},{7,27}]',2070,'[{16050001,1,3}]','[{100,[{16050001,175283}]}]'),(5,8,15,'[{1,43},{7,32}]',2460,'[{16050001,1,3}]','[{100,[{16050001,175288}]}]'),(5,9,18,'[{1,49},{7,37}]',2830,'[{16050001,1,3}]','[{100,[{16050001,175293}]}]'),(5,10,18,'[{1,55},{7,41}]',3150,'[{16050001,1,3}]','[{100,[{16050001,175299}]}]'),(5,11,18,'[{1,61},{7,46}]',3520,'[{16050001,1,3}]','[{100,[{16050001,175305}]}]'),(5,12,21,'[{1,68},{7,51}]',3910,'[{16050001,1,3}]','[{100,[{16050001,175311}]}]'),(5,13,21,'[{1,75},{7,57}]',4350,'[{16050001,1,3}]','[{100,[{16050001,175318}]}]'),(5,14,21,'[{1,82},{7,62}]',4740,'[{16050001,1,3}]','[{100,[{16050001,175325}]}]'),(5,15,24,'[{1,90},{7,67}]',5150,'[{16050001,1,3}]','[{100,[{16050001,175332}]}]'),(5,16,24,'[{1,97},{7,73}]',5590,'[{16050001,2,6}]','[{100,[{16050001,175340}]}]'),(5,17,24,'[{1,105},{7,79}]',6050,'[{16050001,2,6}]','[{100,[{16050001,175348}]}]'),(5,18,30,'[{1,113},{7,85}]',6510,'[{16050001,2,6}]','[{100,[{16050001,175356}]}]'),(5,19,30,'[{1,121},{7,91}]',6970,'[{16050001,2,6}]','[{100,[{16050001,175366}]}]'),(5,20,30,'[{1,130},{7,97}]',7450,'[{16050001,2,6}]','[{100,[{16050001,175376}]}]'),(5,21,30,'[{1,138},{7,104}]',7960,'[{16050001,2,6}]','[{100,[{16050001,175386}]}]'),(5,22,30,'[{1,147},{7,110}]',8440,'[{16050001,2,6}]','[{100,[{16050001,175396}]}]'),(5,23,30,'[{1,156},{7,117}]',8970,'[{16050001,2,6}]','[{100,[{16050001,175406}]}]'),(5,24,36,'[{1,166},{7,124}]',9520,'[{16050001,2,6}]','[{100,[{16050001,175416}]}]'),(5,25,36,'[{1,175},{7,131}]',10050,'[{16050001,2,6}]','[{100,[{16050001,175428}]}]'),(5,26,36,'[{1,184},{7,138}]',10580,'[{16050001,2,6}]','[{100,[{16050001,175440}]}]'),(5,27,36,'[{1,194},{7,146}]',11180,'[{16050001,2,6}]','[{100,[{16050001,175452}]}]'),(5,28,36,'[{1,204},{7,153}]',11730,'[{16050001,2,6}]','[{100,[{16050001,175464}]}]'),(5,29,36,'[{1,215},{7,161}]',12350,'[{16050001,2,6}]','[{100,[{16050001,175476}]}]'),(5,30,42,'[{1,225},{7,169}]',12950,'[{16050001,2,6}]','[{100,[{16050001,175488}]}]'),(5,31,42,'[{1,235},{7,177}]',13550,'[{16050001,2,6}]','[{100,[{16050001,175502}]}]'),(5,32,42,'[{1,246},{7,185}]',14170,'[{16050001,2,6}]','[{100,[{16050001,175516}]}]'),(5,33,42,'[{1,258},{7,193}]',14810,'[{16050001,2,6}]','[{100,[{16050001,175530}]}]'),(5,34,42,'[{1,269},{7,202}]',15480,'[{16050001,2,6}]','[{100,[{16050001,175544}]}]'),(5,35,42,'[{1,280},{7,210}]',16100,'[{16050001,2,6}]','[{100,[{16050001,175558}]}]'),(5,36,48,'[{1,292},{7,219}]',16790,'[{16050001,2,6}]','[{100,[{16050001,175572}]}]'),(5,37,48,'[{1,304},{7,228}]',17480,'[{16050001,2,6}]','[{100,[{16050001,175588}]}]'),(5,38,48,'[{1,316},{7,237}]',18170,'[{16050001,2,6}]','[{100,[{16050001,175604}]}]'),(5,39,48,'[{1,328},{7,246}]',18860,'[{16050001,2,6}]','[{100,[{16050001,175620}]}]'),(5,40,48,'[{1,341},{7,256}]',19620,'[{16050001,2,6}]','[{100,[{16050001,175636}]}]'),(5,41,48,'[{1,353},{7,265}]',20310,'[{16050001,2,6}]','[{100,[{16050001,175652}]}]'),(5,42,54,'[{1,366},{7,275}]',21070,'[{16050001,2,6}]','[{100,[{16050001,175668}]}]'),(5,43,54,'[{1,380},{7,285}]',21850,'[{16050001,2,6}]','[{100,[{16050001,175686}]}]'),(5,44,54,'[{1,393},{7,295}]',22610,'[{16050001,2,6}]','[{100,[{16050001,175704}]}]'),(5,45,54,'[{1,406},{7,305}]',23370,'[{16050001,2,6}]','[{100,[{16050001,175722}]}]'),(5,46,54,'[{1,420},{7,315}]',24150,'[{16050001,2,6}]','[{100,[{16050001,175740}]}]'),(5,47,54,'[{1,434},{7,326}]',24980,'[{16050001,2,6}]','[{100,[{16050001,175758}]}]'),(5,48,60,'[{1,448},{7,336}]',25760,'[{16050001,2,6}]','[{100,[{16050001,175776}]}]'),(5,49,60,'[{1,463},{7,347}]',26610,'[{16050001,2,6}]','[{100,[{16050001,175796}]}]'),(5,50,60,'[{1,477},{7,358}]',27440,'[{16050001,2,6}]','[{100,[{16050001,175816}]}]'),(5,51,60,'[{1,491},{7,369}]',28270,'[{16050001,2,6}]','[{100,[{16050001,175836}]}]'),(5,52,60,'[{1,507},{7,380}]',29140,'[{16050001,2,6}]','[{100,[{16050001,175856}]}]'),(5,53,60,'[{1,522},{7,392}]',30040,'[{16050001,2,6}]','[{100,[{16050001,175876}]}]'),(5,54,66,'[{1,538},{7,403}]',30910,'[{16050001,2,6}]','[{100,[{16050001,175896}]}]'),(5,55,66,'[{1,553},{7,415}]',31810,'[{16050001,2,6}]','[{100,[{16050001,175918}]}]'),(5,56,66,'[{1,568},{7,426}]',32660,'[{16050001,2,6}]','[{100,[{16050001,175940}]}]'),(5,57,66,'[{1,585},{7,439}]',33650,'[{16050001,2,6}]','[{100,[{16050001,175962}]}]'),(5,58,66,'[{1,601},{7,451}]',34570,'[{16050001,2,6}]','[{100,[{16050001,175984}]}]'),(5,59,66,'[{1,617},{7,463}]',35490,'[{16050001,2,6}]','[{100,[{16050001,176006}]}]'),(5,60,72,'[{1,634},{7,476}]',36480,'[{16050001,2,6}]','[{100,[{16050001,176028}]}]'),(5,61,72,'[{1,650},{7,488}]',37400,'[{16050001,2,6}]','[{100,[{16050001,176052}]}]'),(5,62,72,'[{1,668},{7,501}]',38410,'[{16050001,2,6}]','[{100,[{16050001,176076}]}]'),(5,63,72,'[{1,685},{7,514}]',39400,'[{16050001,2,6}]','[{100,[{16050001,176100}]}]'),(5,64,72,'[{1,703},{7,527}]',40410,'[{16050001,2,6}]','[{100,[{16050001,176124}]}]'),(5,65,72,'[{1,720},{7,540}]',41400,'[{16050001,2,6}]','[{100,[{16050001,176148}]}]'),(5,66,78,'[{1,737},{7,553}]',42390,'[{16050001,2,6}]','[{100,[{16050001,176172}]}]'),(5,67,78,'[{1,756},{7,567}]',43470,'[{16050001,2,6}]','[{100,[{16050001,176198}]}]'),(5,68,78,'[{1,774},{7,581}]',44530,'[{16050001,2,6}]','[{100,[{16050001,176224}]}]'),(5,69,78,'[{1,793},{7,595}]',45610,'[{16050001,2,6}]','[{100,[{16050001,176250}]}]'),(5,70,78,'[{1,811},{7,609}]',46670,'[{16050001,2,6}]','[{100,[{16050001,176276}]}]'),(5,71,78,'[{1,830},{7,622}]',47700,'[{16050001,2,6}]','[{100,[{16050001,176302}]}]'),(5,72,84,'[{1,849},{7,637}]',48830,'[{16050001,2,6}]','[{100,[{16050001,176328}]}]'),(5,73,84,'[{1,869},{7,652}]',49980,'[{16050001,2,6}]','[{100,[{16050001,176356}]}]'),(5,74,84,'[{1,888},{7,666}]',51060,'[{16050001,2,6}]','[{100,[{16050001,176384}]}]'),(5,75,84,'[{1,908},{7,681}]',52210,'[{16050001,2,6}]','[{100,[{16050001,176412}]}]'),(5,76,84,'[{1,927},{7,695}]',53290,'[{16050001,2,6}]','[{100,[{16050001,176440}]}]'),(5,77,84,'[{1,948},{7,711}]',54510,'[{16050001,2,6}]','[{100,[{16050001,176468}]}]'),(5,78,90,'[{1,968},{7,726}]',55660,'[{16050001,2,6}]','[{100,[{16050001,176496}]}]'),(5,79,90,'[{1,989},{7,742}]',56880,'[{16050001,2,6}]','[{100,[{16050001,176526}]}]'),(5,80,90,'[{1,1009},{7,757}]',58030,'[{16050001,2,6}]','[{100,[{16050001,176556}]}]'),(5,81,90,'[{1,1030},{7,772}]',59200,'[{16050001,2,6}]','[{100,[{16050001,176586}]}]'),(5,82,90,'[{1,1051},{7,788}]',60420,'[{16050001,2,6}]','[{100,[{16050001,176616}]}]'),(5,83,90,'[{1,1073},{7,805}]',61710,'[{16050001,2,6}]','[{100,[{16050001,176646}]}]'),(5,84,96,'[{1,1094},{7,821}]',62930,'[{16050001,2,6}]','[{100,[{16050001,176676}]}]'),(5,85,96,'[{1,1116},{7,837}]',64170,'[{16050001,2,6}]','[{100,[{16050001,176708}]}]'),(5,86,96,'[{1,1137},{7,853}]',65390,'[{16050001,2,6}]','[{100,[{16050001,176740}]}]'),(5,87,96,'[{1,1160},{7,870}]',66700,'[{16050001,2,6}]','[{100,[{16050001,176772}]}]'),(5,88,96,'[{1,1182},{7,887}]',67990,'[{16050001,2,6}]','[{100,[{16050001,176804}]}]'),(5,89,96,'[{1,1205},{7,904}]',69300,'[{16050001,2,6}]','[{100,[{16050001,176836}]}]'),(5,90,102,'[{1,1227},{7,921}]',70590,'[{16050001,2,6}]','[{100,[{16050001,176868}]}]'),(5,91,102,'[{1,1250},{7,938}]',71900,'[{16050001,2,6}]','[{100,[{16050001,176902}]}]'),(5,92,102,'[{1,1273},{7,955}]',73210,'[{16050001,2,6}]','[{100,[{16050001,176936}]}]'),(5,93,102,'[{1,1297},{7,973}]',74590,'[{16050001,2,6}]','[{100,[{16050001,176970}]}]'),(5,94,102,'[{1,1321},{7,991}]',75970,'[{16050001,2,6}]','[{100,[{16050001,177004}]}]'),(5,95,102,'[{1,1344},{7,1008}]',77280,'[{16050001,2,6}]','[{100,[{16050001,177038}]}]'),(5,96,108,'[{1,1368},{7,1026}]',78660,'[{16050001,2,6}]','[{100,[{16050001,177072}]}]'),(5,97,108,'[{1,1392},{7,1044}]',80040,'[{16050001,2,6}]','[{100,[{16050001,177108}]}]'),(5,98,108,'[{1,1417},{7,1063}]',81490,'[{16050001,2,6}]','[{100,[{16050001,177144}]}]'),(5,99,108,'[{1,1442},{7,1081}]',82890,'[{16050001,2,6}]','[{100,[{16050001,177180}]}]'),(5,100,108,'[{1,1466},{7,1100}]',84320,'[{16050001,2,6}]','[{100,[{16050001,177216}]}]'),(5,101,108,'[{1,1491},{7,1118}]',85720,'[{16050001,3,9}]','[{100,[{16050001,177252}]}]'),(5,102,117,'[{1,1516},{7,1137}]',87170,'[{16050001,3,9}]','[{100,[{16050001,177288}]}]'),(5,103,117,'[{1,1542},{7,1157}]',88690,'[{16050001,3,9}]','[{100,[{16050001,177327}]}]'),(5,104,117,'[{1,1568},{7,1176}]',90160,'[{16050001,3,9}]','[{100,[{16050001,177366}]}]'),(5,105,117,'[{1,1593},{7,1195}]',91610,'[{16050001,3,9}]','[{100,[{16050001,177405}]}]'),(5,106,117,'[{1,1619},{7,1214}]',93080,'[{16050001,3,9}]','[{100,[{16050001,177444}]}]'),(5,107,117,'[{1,1645},{7,1234}]',94600,'[{16050001,3,9}]','[{100,[{16050001,177483}]}]'),(5,108,117,'[{1,1672},{7,1254}]',96140,'[{16050001,3,9}]','[{100,[{16050001,177522}]}]'),(5,109,117,'[{1,1699},{7,1274}]',97680,'[{16050001,3,9}]','[{100,[{16050001,177561}]}]'),(5,110,117,'[{1,1725},{7,1294}]',99200,'[{16050001,3,9}]','[{100,[{16050001,177600}]}]'),(5,111,126,'[{1,1752},{7,1314}]',100740,'[{16050001,3,9}]','[{100,[{16050001,177639}]}]'),(5,112,126,'[{1,1780},{7,1335}]',102350,'[{16050001,3,9}]','[{100,[{16050001,177681}]}]'),(5,113,126,'[{1,1807},{7,1356}]',103940,'[{16050001,3,9}]','[{100,[{16050001,177723}]}]'),(5,114,126,'[{1,1835},{7,1376}]',105500,'[{16050001,3,9}]','[{100,[{16050001,177765}]}]'),(5,115,126,'[{1,1863},{7,1397}]',107110,'[{16050001,3,9}]','[{100,[{16050001,177807}]}]'),(5,116,126,'[{1,1890},{7,1418}]',108700,'[{16050001,3,9}]','[{100,[{16050001,177849}]}]'),(5,117,126,'[{1,1919},{7,1439}]',110330,'[{16050001,3,9}]','[{100,[{16050001,177891}]}]'),(5,118,126,'[{1,1948},{7,1461}]',112010,'[{16050001,3,9}]','[{100,[{16050001,177933}]}]'),(5,119,126,'[{1,1977},{7,1483}]',113690,'[{16050001,3,9}]','[{100,[{16050001,177975}]}]'),(5,120,135,'[{1,2005},{7,1504}]',115300,'[{16050001,3,9}]','[{100,[{16050001,178017}]}]'),(5,121,135,'[{1,2034},{7,1526}]',116980,'[{16050001,3,9}]','[{100,[{16050001,178062}]}]'),(5,122,135,'[{1,2064},{7,1548}]',118680,'[{16050001,3,9}]','[{100,[{16050001,178107}]}]'),(5,123,135,'[{1,2093},{7,1570}]',120360,'[{16050001,3,9}]','[{100,[{16050001,178152}]}]'),(5,124,135,'[{1,2123},{7,1592}]',122060,'[{16050001,3,9}]','[{100,[{16050001,178197}]}]'),(5,125,135,'[{1,2153},{7,1615}]',123810,'[{16050001,3,9}]','[{100,[{16050001,178242}]}]'),(5,126,135,'[{1,2183},{7,1637}]',125510,'[{16050001,3,9}]','[{100,[{16050001,178287}]}]'),(5,127,135,'[{1,2213},{7,1660}]',127260,'[{16050001,3,9}]','[{100,[{16050001,178332}]}]'),(5,128,135,'[{1,2244},{7,1683}]',129030,'[{16050001,3,9}]','[{100,[{16050001,178377}]}]'),(5,129,144,'[{1,2275},{7,1706}]',130800,'[{16050001,3,9}]','[{100,[{16050001,178422}]}]'),(5,130,144,'[{1,2306},{7,1729}]',132570,'[{16050001,3,9}]','[{100,[{16050001,178470}]}]'),(5,131,144,'[{1,2336},{7,1752}]',134320,'[{16050001,3,9}]','[{100,[{16050001,178518}]}]'),(5,132,144,'[{1,2368},{7,1776}]',136160,'[{16050001,3,9}]','[{100,[{16050001,178566}]}]'),(5,133,144,'[{1,2400},{7,1800}]',138000,'[{16050001,3,9}]','[{100,[{16050001,178614}]}]'),(5,134,144,'[{1,2432},{7,1824}]',139840,'[{16050001,3,9}]','[{100,[{16050001,178662}]}]'),(5,135,144,'[{1,2463},{7,1848}]',141660,'[{16050001,3,9}]','[{100,[{16050001,178710}]}]'),(5,136,144,'[{1,2495},{7,1871}]',143450,'[{16050001,3,9}]','[{100,[{16050001,178758}]}]'),(5,137,144,'[{1,2528},{7,1896}]',145360,'[{16050001,3,9}]','[{100,[{16050001,178806}]}]'),(5,138,153,'[{1,2561},{7,1921}]',147270,'[{16050001,3,9}]','[{100,[{16050001,178854}]}]'),(5,139,153,'[{1,2594},{7,1945}]',149130,'[{16050001,3,9}]','[{100,[{16050001,178905}]}]'),(5,140,153,'[{1,2626},{7,1970}]',151020,'[{16050001,3,9}]','[{100,[{16050001,178956}]}]'),(5,141,153,'[{1,2659},{7,1994}]',152880,'[{16050001,3,9}]','[{100,[{16050001,179007}]}]'),(5,142,153,'[{1,2693},{7,2020}]',154860,'[{16050001,3,9}]','[{100,[{16050001,179058}]}]'),(5,143,153,'[{1,2727},{7,2045}]',156790,'[{16050001,3,9}]','[{100,[{16050001,179109}]}]'),(5,144,153,'[{1,2761},{7,2071}]',158770,'[{16050001,3,9}]','[{100,[{16050001,179160}]}]'),(5,145,153,'[{1,2794},{7,2096}]',160680,'[{16050001,3,9}]','[{100,[{16050001,179211}]}]'),(5,146,153,'[{1,2828},{7,2121}]',162610,'[{16050001,3,9}]','[{100,[{16050001,179262}]}]'),(5,147,162,'[{1,2863},{7,2147}]',164610,'[{16050001,3,9}]','[{100,[{16050001,179313}]}]'),(5,148,162,'[{1,2898},{7,2174}]',166660,'[{16050001,3,9}]','[{100,[{16050001,179367}]}]'),(5,149,162,'[{1,2933},{7,2200}]',168660,'[{16050001,3,9}]','[{100,[{16050001,179421}]}]'),(5,150,162,'[{1,2968},{7,2226}]',170660,'[{16050001,3,9}]','[{100,[{16050001,179475}]}]'),(5,151,162,'[{1,3002},{7,2252}]',172640,'[{16050001,3,9}]','[{100,[{16050001,179529}]}]'),(5,152,162,'[{1,3038},{7,2279}]',174710,'[{16050001,3,9}]','[{100,[{16050001,179583}]}]'),(5,153,162,'[{1,3074},{7,2306}]',176780,'[{16050001,3,9}]','[{100,[{16050001,179637}]}]'),(5,154,162,'[{1,3110},{7,2333}]',178850,'[{16050001,3,9}]','[{100,[{16050001,179691}]}]'),(5,155,162,'[{1,3146},{7,2360}]',180920,'[{16050001,3,9}]','[{100,[{16050001,179745}]}]'),(5,156,171,'[{1,3182},{7,2386}]',182940,'[{16050001,3,9}]','[{100,[{16050001,179799}]}]'),(5,157,171,'[{1,3219},{7,2414}]',185080,'[{16050001,3,9}]','[{100,[{16050001,179856}]}]'),(5,158,171,'[{1,3256},{7,2442}]',187220,'[{16050001,3,9}]','[{100,[{16050001,179913}]}]'),(5,159,171,'[{1,3292},{7,2469}]',189290,'[{16050001,3,9}]','[{100,[{16050001,179970}]}]'),(5,160,171,'[{1,3329},{7,2497}]',191430,'[{16050001,3,9}]','[{100,[{16050001,180027}]}]'),(5,161,171,'[{1,3366},{7,2525}]',193570,'[{16050001,3,9}]','[{100,[{16050001,180084}]}]'),(5,162,171,'[{1,3404},{7,2553}]',195730,'[{16050001,3,9}]','[{100,[{16050001,180141}]}]'),(5,163,171,'[{1,3442},{7,2582}]',197940,'[{16050001,3,9}]','[{100,[{16050001,180198}]}]'),(5,164,171,'[{1,3480},{7,2610}]',200100,'[{16050001,3,9}]','[{100,[{16050001,180255}]}]'),(5,165,180,'[{1,3518},{7,2639}]',202310,'[{16050001,3,9}]','[{100,[{16050001,180312}]}]'),(5,166,180,'[{1,3556},{7,2667}]',204470,'[{16050001,3,9}]','[{100,[{16050001,180372}]}]'),(5,167,180,'[{1,3595},{7,2696}]',206700,'[{16050001,3,9}]','[{100,[{16050001,180432}]}]'),(5,168,180,'[{1,3634},{7,2725}]',208930,'[{16050001,3,9}]','[{100,[{16050001,180492}]}]'),(5,169,180,'[{1,3673},{7,2755}]',211210,'[{16050001,3,9}]','[{100,[{16050001,180552}]}]'),(5,170,180,'[{1,3712},{7,2784}]',213440,'[{16050001,3,9}]','[{100,[{16050001,180612}]}]'),(5,171,180,'[{1,3751},{7,2813}]',215670,'[{16050001,3,9}]','[{100,[{16050001,180672}]}]'),(5,172,180,'[{1,3791},{7,2843}]',217970,'[{16050001,3,9}]','[{100,[{16050001,180732}]}]'),(5,173,180,'[{1,3831},{7,2873}]',220270,'[{16050001,3,9}]','[{100,[{16050001,180792}]}]'),(5,174,189,'[{1,3871},{7,2903}]',222570,'[{16050001,3,9}]','[{100,[{16050001,180852}]}]'),(5,175,189,'[{1,3911},{7,2933}]',224870,'[{16050001,3,9}]','[{100,[{16050001,180915}]}]'),(5,176,189,'[{1,3950},{7,2963}]',227150,'[{16050001,3,9}]','[{100,[{16050001,180978}]}]'),(5,177,189,'[{1,3991},{7,2994}]',229520,'[{16050001,3,9}]','[{100,[{16050001,181041}]}]'),(5,178,189,'[{1,4032},{7,3024}]',231840,'[{16050001,3,9}]','[{100,[{16050001,181104}]}]'),(5,179,189,'[{1,4073},{7,3055}]',234210,'[{16050001,3,9}]','[{100,[{16050001,181167}]}]'),(5,180,189,'[{1,4114},{7,3086}]',236580,'[{16050001,3,9}]','[{100,[{16050001,181230}]}]'),(5,181,189,'[{1,4155},{7,3117}]',238950,'[{16050001,3,9}]','[{100,[{16050001,181293}]}]'),(5,182,189,'[{1,4197},{7,3148}]',241340,'[{16050001,3,9}]','[{100,[{16050001,181356}]}]'),(5,183,198,'[{1,4239},{7,3180}]',243780,'[{16050001,3,9}]','[{100,[{16050001,181419}]}]'),(5,184,198,'[{1,4282},{7,3211}]',246190,'[{16050001,3,9}]','[{100,[{16050001,181485}]}]'),(5,185,198,'[{1,4324},{7,3243}]',248630,'[{16050001,3,9}]','[{100,[{16050001,181551}]}]'),(5,186,198,'[{1,4366},{7,3274}]',251020,'[{16050001,3,9}]','[{100,[{16050001,181617}]}]'),(5,187,198,'[{1,4409},{7,3307}]',253530,'[{16050001,3,9}]','[{100,[{16050001,181683}]}]'),(5,188,198,'[{1,4452},{7,3339}]',255990,'[{16050001,3,9}]','[{100,[{16050001,181749}]}]'),(5,189,198,'[{1,4495},{7,3371}]',258450,'[{16050001,3,9}]','[{100,[{16050001,181815}]}]'),(5,190,198,'[{1,4538},{7,3403}]',260910,'[{16050001,3,9}]','[{100,[{16050001,181881}]}]'),(5,191,198,'[{1,4581},{7,3436}]',263420,'[{16050001,3,9}]','[{100,[{16050001,181947}]}]'),(5,192,207,'[{1,4625},{7,3469}]',265950,'[{16050001,3,9}]','[{100,[{16050001,182013}]}]'),(5,193,207,'[{1,4669},{7,3502}]',268480,'[{16050001,3,9}]','[{100,[{16050001,182082}]}]'),(5,194,207,'[{1,4713},{7,3535}]',271010,'[{16050001,3,9}]','[{100,[{16050001,182151}]}]'),(5,195,207,'[{1,4757},{7,3568}]',273540,'[{16050001,3,9}]','[{100,[{16050001,182220}]}]'),(5,196,207,'[{1,4801},{7,3601}]',276070,'[{16050001,3,9}]','[{100,[{16050001,182289}]}]'),(5,197,207,'[{1,4846},{7,3635}]',278670,'[{16050001,3,9}]','[{100,[{16050001,182358}]}]'),(5,198,207,'[{1,4891},{7,3669}]',281270,'[{16050001,3,9}]','[{100,[{16050001,182427}]}]'),(5,199,207,'[{1,4936},{7,3702}]',283820,'[{16050001,3,9}]','[{100,[{16050001,182496}]}]'),(5,200,207,'[{1,4982},{7,3736}]',286440,'[{16050001,3,9}]','[{100,[{16050001,182565}]}]'),(5,201,216,'[{1,5027},{7,3770}]',289040,'[{16050001,4,12}]','[{100,[{16050001,182634}]}]'),(5,202,216,'[{1,5073},{7,3805}]',291710,'[{16050001,4,12}]','[{100,[{16050001,182706}]}]'),(5,203,216,'[{1,5119},{7,3839}]',294330,'[{16050001,4,12}]','[{100,[{16050001,182778}]}]'),(5,204,216,'[{1,5165},{7,3874}]',297000,'[{16050001,4,12}]','[{100,[{16050001,182850}]}]'),(5,205,216,'[{1,5211},{7,3908}]',299620,'[{16050001,4,12}]','[{100,[{16050001,182922}]}]'),(5,206,216,'[{1,5257},{7,3943}]',302290,'[{16050001,4,12}]','[{100,[{16050001,182994}]}]'),(5,207,216,'[{1,5304},{7,3978}]',304980,'[{16050001,4,12}]','[{100,[{16050001,183066}]}]'),(5,208,216,'[{1,5352},{7,4014}]',307740,'[{16050001,4,12}]','[{100,[{16050001,183138}]}]'),(5,209,216,'[{1,5399},{7,4049}]',310430,'[{16050001,4,12}]','[{100,[{16050001,183210}]}]'),(5,210,228,'[{1,5446},{7,4084}]',313120,'[{16050001,4,12}]','[{100,[{16050001,183282}]}]'),(5,211,228,'[{1,5493},{7,4120}]',315860,'[{16050001,4,12}]','[{100,[{16050001,183358}]}]'),(5,212,228,'[{1,5541},{7,4156}]',318620,'[{16050001,4,12}]','[{100,[{16050001,183434}]}]'),(5,213,228,'[{1,5589},{7,4192}]',321380,'[{16050001,4,12}]','[{100,[{16050001,183510}]}]'),(5,214,228,'[{1,5637},{7,4228}]',324140,'[{16050001,4,12}]','[{100,[{16050001,183586}]}]'),(5,215,228,'[{1,5686},{7,4264}]',326920,'[{16050001,4,12}]','[{100,[{16050001,183662}]}]'),(5,216,228,'[{1,5734},{7,4300}]',329680,'[{16050001,4,12}]','[{100,[{16050001,183738}]}]'),(5,217,228,'[{1,5783},{7,4337}]',332510,'[{16050001,4,12}]','[{100,[{16050001,183814}]}]'),(5,218,228,'[{1,5832},{7,4374}]',335340,'[{16050001,4,12}]','[{100,[{16050001,183890}]}]'),(5,219,228,'[{1,5881},{7,4411}]',338170,'[{16050001,4,12}]','[{100,[{16050001,183966}]}]'),(5,220,228,'[{1,5931},{7,4448}]',341020,'[{16050001,4,12}]','[{100,[{16050001,184042}]}]'),(5,221,228,'[{1,5980},{7,4485}]',343850,'[{16050001,4,12}]','[{100,[{16050001,184118}]}]'),(5,222,240,'[{1,6030},{7,4523}]',346750,'[{16050001,4,12}]','[{100,[{16050001,184194}]}]'),(5,223,240,'[{1,6080},{7,4560}]',349600,'[{16050001,4,12}]','[{100,[{16050001,184274}]}]'),(5,224,240,'[{1,6130},{7,4598}]',352500,'[{16050001,4,12}]','[{100,[{16050001,184354}]}]'),(5,225,240,'[{1,6181},{7,4636}]',355420,'[{16050001,4,12}]','[{100,[{16050001,184434}]}]'),(5,226,240,'[{1,6231},{7,4673}]',358270,'[{16050001,4,12}]','[{100,[{16050001,184514}]}]'),(5,227,240,'[{1,6282},{7,4712}]',361240,'[{16050001,4,12}]','[{100,[{16050001,184594}]}]'),(5,228,240,'[{1,6333},{7,4750}]',364160,'[{16050001,4,12}]','[{100,[{16050001,184674}]}]'),(5,229,240,'[{1,6385},{7,4789}]',367150,'[{16050001,4,12}]','[{100,[{16050001,184754}]}]'),(5,230,240,'[{1,6436},{7,4827}]',370070,'[{16050001,4,12}]','[{100,[{16050001,184834}]}]'),(5,231,240,'[{1,6487},{7,4865}]',372990,'[{16050001,4,12}]','[{100,[{16050001,184914}]}]'),(5,232,240,'[{1,6539},{7,4905}]',376030,'[{16050001,4,12}]','[{100,[{16050001,184994}]}]'),(5,233,240,'[{1,6592},{7,4944}]',379040,'[{16050001,4,12}]','[{100,[{16050001,185074}]}]'),(5,234,252,'[{1,6644},{7,4983}]',382030,'[{16050001,4,12}]','[{100,[{16050001,185154}]}]'),(5,235,252,'[{1,6696},{7,5022}]',385020,'[{16050001,4,12}]','[{100,[{16050001,185238}]}]'),(5,236,252,'[{1,6748},{7,5061}]',388010,'[{16050001,4,12}]','[{100,[{16050001,185322}]}]'),(5,237,252,'[{1,6802},{7,5101}]',391090,'[{16050001,4,12}]','[{100,[{16050001,185406}]}]'),(5,238,252,'[{1,6855},{7,5141}]',394150,'[{16050001,4,12}]','[{100,[{16050001,185490}]}]'),(5,239,252,'[{1,6908},{7,5181}]',397210,'[{16050001,4,12}]','[{100,[{16050001,185574}]}]'),(5,240,252,'[{1,6962},{7,5221}]',400290,'[{16050001,4,12}]','[{100,[{16050001,185658}]}]'),(5,241,252,'[{1,7015},{7,5261}]',403350,'[{16050001,4,12}]','[{100,[{16050001,185742}]}]'),(5,242,252,'[{1,7069},{7,5302}]',406480,'[{16050001,4,12}]','[{100,[{16050001,185826}]}]'),(5,243,252,'[{1,7124},{7,5343}]',409630,'[{16050001,4,12}]','[{100,[{16050001,185910}]}]'),(5,244,252,'[{1,7178},{7,5384}]',412760,'[{16050001,4,12}]','[{100,[{16050001,185994}]}]'),(5,245,252,'[{1,7232},{7,5424}]',415840,'[{16050001,4,12}]','[{100,[{16050001,186078}]}]'),(5,246,264,'[{1,7287},{7,5465}]',418990,'[{16050001,4,12}]','[{100,[{16050001,186162}]}]'),(5,247,264,'[{1,7342},{7,5507}]',422190,'[{16050001,4,12}]','[{100,[{16050001,186250}]}]'),(5,248,264,'[{1,7397},{7,5548}]',425340,'[{16050001,4,12}]','[{100,[{16050001,186338}]}]'),(5,249,264,'[{1,7453},{7,5590}]',428560,'[{16050001,4,12}]','[{100,[{16050001,186426}]}]'),(5,250,264,'[{1,7508},{7,5631}]',431710,'[{16050001,4,12}]','[{100,[{16050001,186514}]}]'),(5,251,264,'[{1,7563},{7,5673}]',434910,'[{16050001,4,12}]','[{100,[{16050001,186602}]}]'),(5,252,264,'[{1,7620},{7,5715}]',438150,'[{16050001,4,12}]','[{100,[{16050001,186690}]}]'),(5,253,264,'[{1,7676},{7,5757}]',441370,'[{16050001,4,12}]','[{100,[{16050001,186778}]}]'),(5,254,264,'[{1,7732},{7,5799}]',444590,'[{16050001,4,12}]','[{100,[{16050001,186866}]}]'),(5,255,264,'[{1,7789},{7,5842}]',447880,'[{16050001,4,12}]','[{100,[{16050001,186954}]}]'),(5,256,264,'[{1,7845},{7,5884}]',451100,'[{16050001,4,12}]','[{100,[{16050001,187042}]}]'),(5,257,264,'[{1,7902},{7,5927}]',454390,'[{16050001,4,12}]','[{100,[{16050001,187130}]}]'),(5,258,276,'[{1,7960},{7,5970}]',457700,'[{16050001,4,12}]','[{100,[{16050001,187218}]}]'),(5,259,276,'[{1,8017},{7,6013}]',460990,'[{16050001,4,12}]','[{100,[{16050001,187310}]}]'),(5,260,276,'[{1,8075},{7,6056}]',464300,'[{16050001,4,12}]','[{100,[{16050001,187402}]}]'),(5,261,276,'[{1,8132},{7,6099}]',467590,'[{16050001,4,12}]','[{100,[{16050001,187494}]}]'),(5,262,276,'[{1,8190},{7,6143}]',470950,'[{16050001,4,12}]','[{100,[{16050001,187586}]}]'),(5,263,276,'[{1,8249},{7,6187}]',474330,'[{16050001,4,12}]','[{100,[{16050001,187678}]}]'),(5,264,276,'[{1,8307},{7,6231}]',477690,'[{16050001,4,12}]','[{100,[{16050001,187770}]}]'),(5,265,276,'[{1,8366},{7,6274}]',481020,'[{16050001,4,12}]','[{100,[{16050001,187862}]}]'),(5,266,276,'[{1,8424},{7,6318}]',484380,'[{16050001,4,12}]','[{100,[{16050001,187954}]}]'),(5,267,276,'[{1,8484},{7,6363}]',487830,'[{16050001,4,12}]','[{100,[{16050001,188046}]}]'),(5,268,276,'[{1,8543},{7,6407}]',491210,'[{16050001,4,12}]','[{100,[{16050001,188138}]}]'),(5,269,276,'[{1,8603},{7,6452}]',494660,'[{16050001,4,12}]','[{100,[{16050001,188230}]}]'),(5,270,288,'[{1,8662},{7,6497}]',498090,'[{16050001,4,12}]','[{100,[{16050001,188322}]}]'),(5,271,288,'[{1,8721},{7,6541}]',501470,'[{16050001,4,12}]','[{100,[{16050001,188418}]}]'),(5,272,288,'[{1,8782},{7,6587}]',504990,'[{16050001,4,12}]','[{100,[{16050001,188514}]}]'),(5,273,288,'[{1,8842},{7,6632}]',508440,'[{16050001,4,12}]','[{100,[{16050001,188610}]}]'),(5,274,288,'[{1,8903},{7,6677}]',511910,'[{16050001,4,12}]','[{100,[{16050001,188706}]}]'),(5,275,288,'[{1,8963},{7,6723}]',515410,'[{16050001,4,12}]','[{100,[{16050001,188802}]}]'),(5,276,288,'[{1,9024},{7,6768}]',518880,'[{16050001,4,12}]','[{100,[{16050001,188898}]}]'),(5,277,288,'[{1,9085},{7,6814}]',522400,'[{16050001,4,12}]','[{100,[{16050001,188994}]}]'),(5,278,288,'[{1,9147},{7,6860}]',525940,'[{16050001,4,12}]','[{100,[{16050001,189090}]}]'),(5,279,288,'[{1,9208},{7,6906}]',529460,'[{16050001,4,12}]','[{100,[{16050001,189186}]}]'),(5,280,288,'[{1,9270},{7,6952}]',533000,'[{16050001,4,12}]','[{100,[{16050001,189282}]}]'),(5,281,288,'[{1,9331},{7,6999}]',536570,'[{16050001,4,12}]','[{100,[{16050001,189378}]}]'),(5,282,300,'[{1,9394},{7,7045}]',540130,'[{16050001,4,12}]','[{100,[{16050001,189474}]}]'),(5,283,300,'[{1,9456},{7,7092}]',543720,'[{16050001,4,12}]','[{100,[{16050001,189574}]}]'),(5,284,300,'[{1,9519},{7,7139}]',547330,'[{16050001,4,12}]','[{100,[{16050001,189674}]}]'),(5,285,300,'[{1,9581},{7,7186}]',550920,'[{16050001,4,12}]','[{100,[{16050001,189774}]}]'),(5,286,300,'[{1,9644},{7,7233}]',554530,'[{16050001,4,12}]','[{100,[{16050001,189874}]}]'),(5,287,300,'[{1,9707},{7,7281}]',558190,'[{16050001,4,12}]','[{100,[{16050001,189974}]}]'),(5,288,300,'[{1,9771},{7,7328}]',561820,'[{16050001,4,12}]','[{100,[{16050001,190074}]}]'),(5,289,300,'[{1,9834},{7,7376}]',565480,'[{16050001,4,12}]','[{100,[{16050001,190174}]}]'),(5,290,300,'[{1,9898},{7,7424}]',569160,'[{16050001,4,12}]','[{100,[{16050001,190274}]}]'),(5,291,300,'[{1,9962},{7,7471}]',572790,'[{16050001,4,12}]','[{100,[{16050001,190374}]}]'),(5,292,300,'[{1,10026},{7,7520}]',576520,'[{16050001,4,12}]','[{100,[{16050001,190474}]}]'),(5,293,300,'[{1,10091},{7,7568}]',580220,'[{16050001,4,12}]','[{100,[{16050001,190574}]}]'),(5,294,312,'[{1,10155},{7,7617}]',583950,'[{16050001,4,12}]','[{100,[{16050001,190674}]}]'),(5,295,312,'[{1,10220},{7,7665}]',587650,'[{16050001,4,12}]','[{100,[{16050001,190778}]}]'),(5,296,312,'[{1,10284},{7,7713}]',591330,'[{16050001,4,12}]','[{100,[{16050001,190882}]}]'),(5,297,312,'[{1,10350},{7,7763}]',595150,'[{16050001,4,12}]','[{100,[{16050001,190986}]}]'),(5,298,312,'[{1,10416},{7,7812}]',598920,'[{16050001,4,12}]','[{100,[{16050001,191090}]}]'),(5,299,312,'[{1,10481},{7,7861}]',602670,'[{16050001,4,12}]','[{100,[{16050001,191194}]}]'),(5,300,312,'[{1,10547},{7,7910}]',606440,'[{16050001,4,12}]','[{100,[{16050001,191298}]}]'),(5,301,315,'[{1,10612},{7,7959}]',610190,'[{16050001,5,15}]','[{100,[{16050001,191402}]}]'),(5,302,315,'[{1,10679},{7,8009}]',614030,'[{16050001,5,15}]','[{100,[{16050001,191507}]}]'),(5,303,315,'[{1,10746},{7,8059}]',617870,'[{16050001,5,15}]','[{100,[{16050001,191612}]}]'),(5,304,315,'[{1,10812},{7,8109}]',621690,'[{16050001,5,15}]','[{100,[{16050001,191717}]}]'),(5,305,315,'[{1,10879},{7,8159}]',625530,'[{16050001,5,15}]','[{100,[{16050001,191822}]}]'),(5,306,315,'[{1,10945},{7,8209}]',629350,'[{16050001,5,15}]','[{100,[{16050001,191927}]}]'),(5,307,315,'[{1,11013},{7,8260}]',633260,'[{16050001,5,15}]','[{100,[{16050001,192032}]}]'),(5,308,315,'[{1,11081},{7,8311}]',637170,'[{16050001,5,15}]','[{100,[{16050001,192137}]}]'),(5,309,330,'[{1,11148},{7,8361}]',641010,'[{16050001,5,15}]','[{100,[{16050001,192242}]}]'),(5,310,330,'[{1,11216},{7,8412}]',644920,'[{16050001,5,15}]','[{100,[{16050001,192352}]}]'),(5,311,330,'[{1,11284},{7,8463}]',648830,'[{16050001,5,15}]','[{100,[{16050001,192462}]}]'),(5,312,330,'[{1,11352},{7,8514}]',652740,'[{16050001,5,15}]','[{100,[{16050001,192572}]}]'),(5,313,330,'[{1,11421},{7,8566}]',656720,'[{16050001,5,15}]','[{100,[{16050001,192682}]}]'),(5,314,330,'[{1,11490},{7,8617}]',660650,'[{16050001,5,15}]','[{100,[{16050001,192792}]}]'),(5,315,330,'[{1,11558},{7,8669}]',664610,'[{16050001,5,15}]','[{100,[{16050001,192902}]}]'),(5,316,330,'[{1,11627},{7,8720}]',668540,'[{16050001,5,15}]','[{100,[{16050001,193012}]}]'),(5,317,330,'[{1,11697},{7,8773}]',672590,'[{16050001,5,15}]','[{100,[{16050001,193122}]}]'),(5,318,330,'[{1,11766},{7,8825}]',676570,'[{16050001,5,15}]','[{100,[{16050001,193232}]}]'),(5,319,330,'[{1,11836},{7,8877}]',680570,'[{16050001,5,15}]','[{100,[{16050001,193342}]}]'),(5,320,330,'[{1,11906},{7,8929}]',684570,'[{16050001,5,15}]','[{100,[{16050001,193452}]}]'),(5,321,330,'[{1,11975},{7,8982}]',688600,'[{16050001,5,15}]','[{100,[{16050001,193562}]}]'),(5,322,330,'[{1,12046},{7,9035}]',692670,'[{16050001,5,15}]','[{100,[{16050001,193672}]}]'),(5,323,330,'[{1,12117},{7,9088}]',696740,'[{16050001,5,15}]','[{100,[{16050001,193782}]}]'),(5,324,345,'[{1,12188},{7,9141}]',700810,'[{16050001,5,15}]','[{100,[{16050001,193892}]}]'),(5,325,345,'[{1,12258},{7,9194}]',704860,'[{16050001,5,15}]','[{100,[{16050001,194007}]}]'),(5,326,345,'[{1,12329},{7,9247}]',708930,'[{16050001,5,15}]','[{100,[{16050001,194122}]}]'),(5,327,345,'[{1,12401},{7,9301}]',713070,'[{16050001,5,15}]','[{100,[{16050001,194237}]}]'),(5,328,345,'[{1,12473},{7,9355}]',717210,'[{16050001,5,15}]','[{100,[{16050001,194352}]}]'),(5,329,345,'[{1,12544},{7,9408}]',721280,'[{16050001,5,15}]','[{100,[{16050001,194467}]}]'),(5,330,345,'[{1,12616},{7,9462}]',725420,'[{16050001,5,15}]','[{100,[{16050001,194582}]}]'),(5,331,345,'[{1,12688},{7,9516}]',729560,'[{16050001,5,15}]','[{100,[{16050001,194697}]}]'),(5,332,345,'[{1,12761},{7,9571}]',733770,'[{16050001,5,15}]','[{100,[{16050001,194812}]}]'),(5,333,345,'[{1,12833},{7,9625}]',737910,'[{16050001,5,15}]','[{100,[{16050001,194927}]}]'),(5,334,345,'[{1,12906},{7,9680}]',742120,'[{16050001,5,15}]','[{100,[{16050001,195042}]}]'),(5,335,345,'[{1,12979},{7,9734}]',746280,'[{16050001,5,15}]','[{100,[{16050001,195157}]}]'),(5,336,345,'[{1,13052},{7,9789}]',750490,'[{16050001,5,15}]','[{100,[{16050001,195272}]}]'),(5,337,345,'[{1,13125},{7,9844}]',754700,'[{16050001,5,15}]','[{100,[{16050001,195387}]}]'),(5,338,345,'[{1,13199},{7,9900}]',758980,'[{16050001,5,15}]','[{100,[{16050001,195502}]}]'),(5,339,360,'[{1,13273},{7,9955}]',763210,'[{16050001,5,15}]','[{100,[{16050001,195617}]}]'),(5,340,360,'[{1,13347},{7,10010}]',767440,'[{16050001,5,15}]','[{100,[{16050001,195737}]}]'),(5,341,360,'[{1,13421},{7,10066}]',771720,'[{16050001,5,15}]','[{100,[{16050001,195857}]}]'),(5,342,360,'[{1,13495},{7,10122}]',776000,'[{16050001,5,15}]','[{100,[{16050001,195977}]}]'),(5,343,360,'[{1,13570},{7,10178}]',780300,'[{16050001,5,15}]','[{100,[{16050001,196097}]}]'),(5,344,360,'[{1,13645},{7,10234}]',784600,'[{16050001,5,15}]','[{100,[{16050001,196217}]}]'),(5,345,360,'[{1,13720},{7,10290}]',788900,'[{16050001,5,15}]','[{100,[{16050001,196337}]}]'),(5,346,360,'[{1,13795},{7,10346}]',793200,'[{16050001,5,15}]','[{100,[{16050001,196457}]}]'),(5,347,360,'[{1,13870},{7,10403}]',797550,'[{16050001,5,15}]','[{100,[{16050001,196577}]}]'),(5,348,360,'[{1,13946},{7,10460}]',801920,'[{16050001,5,15}]','[{100,[{16050001,196697}]}]'),(5,349,360,'[{1,14022},{7,10517}]',806290,'[{16050001,5,15}]','[{100,[{16050001,196817}]}]'),(5,350,360,'[{1,14098},{7,10574}]',810660,'[{16050001,5,15}]','[{100,[{16050001,196937}]}]'),(5,351,360,'[{1,14174},{7,10631}]',815030,'[{16050001,5,15}]','[{100,[{16050001,197057}]}]'),(5,352,360,'[{1,14251},{7,10688}]',819420,'[{16050001,5,15}]','[{100,[{16050001,197177}]}]'),(5,353,360,'[{1,14328},{7,10746}]',823860,'[{16050001,5,15}]','[{100,[{16050001,197297}]}]'),(5,354,375,'[{1,14404},{7,10803}]',828230,'[{16050001,5,15}]','[{100,[{16050001,197417}]}]'),(5,355,375,'[{1,14481},{7,10861}]',832670,'[{16050001,5,15}]','[{100,[{16050001,197542}]}]'),(5,356,375,'[{1,14558},{7,10919}]',837110,'[{16050001,5,15}]','[{100,[{16050001,197667}]}]'),(5,357,375,'[{1,14636},{7,10977}]',841570,'[{16050001,5,15}]','[{100,[{16050001,197792}]}]'),(5,358,375,'[{1,14714},{7,11036}]',846080,'[{16050001,5,15}]','[{100,[{16050001,197917}]}]'),(5,359,375,'[{1,14792},{7,11094}]',850540,'[{16050001,5,15}]','[{100,[{16050001,198042}]}]'),(5,360,375,'[{1,14870},{7,11152}]',855000,'[{16050001,5,15}]','[{100,[{16050001,198167}]}]'),(5,361,375,'[{1,14948},{7,11211}]',859510,'[{16050001,5,15}]','[{100,[{16050001,198292}]}]'),(5,362,375,'[{1,15027},{7,11270}]',864040,'[{16050001,5,15}]','[{100,[{16050001,198417}]}]'),(5,363,375,'[{1,15106},{7,11329}]',868570,'[{16050001,5,15}]','[{100,[{16050001,198542}]}]'),(5,364,375,'[{1,15184},{7,11388}]',873080,'[{16050001,5,15}]','[{100,[{16050001,198667}]}]'),(5,365,375,'[{1,15263},{7,11448}]',877660,'[{16050001,5,15}]','[{100,[{16050001,198792}]}]'),(5,366,375,'[{1,15342},{7,11507}]',882190,'[{16050001,5,15}]','[{100,[{16050001,198917}]}]'),(5,367,375,'[{1,15422},{7,11567}]',886790,'[{16050001,5,15}]','[{100,[{16050001,199042}]}]'),(5,368,375,'[{1,15502},{7,11627}]',891390,'[{16050001,5,15}]','[{100,[{16050001,199167}]}]'),(5,369,390,'[{1,15582},{7,11687}]',895990,'[{16050001,5,15}]','[{100,[{16050001,199292}]}]'),(5,370,390,'[{1,15662},{7,11747}]',900590,'[{16050001,5,15}]','[{100,[{16050001,199422}]}]'),(5,371,390,'[{1,15742},{7,11807}]',905190,'[{16050001,5,15}]','[{100,[{16050001,199552}]}]'),(5,372,390,'[{1,15823},{7,11867}]',909810,'[{16050001,5,15}]','[{100,[{16050001,199682}]}]'),(5,373,390,'[{1,15904},{7,11928}]',914480,'[{16050001,5,15}]','[{100,[{16050001,199812}]}]'),(5,374,390,'[{1,15985},{7,11989}]',919150,'[{16050001,5,15}]','[{100,[{16050001,199942}]}]'),(5,375,390,'[{1,16066},{7,12050}]',923820,'[{16050001,5,15}]','[{100,[{16050001,200072}]}]'),(5,376,390,'[{1,16147},{7,12110}]',928440,'[{16050001,5,15}]','[{100,[{16050001,200202}]}]'),(5,377,390,'[{1,16229},{7,12172}]',933180,'[{16050001,5,15}]','[{100,[{16050001,200332}]}]'),(5,378,390,'[{1,16311},{7,12233}]',937870,'[{16050001,5,15}]','[{100,[{16050001,200462}]}]'),(5,379,390,'[{1,16393},{7,12295}]',942610,'[{16050001,5,15}]','[{100,[{16050001,200592}]}]'),(5,380,390,'[{1,16475},{7,12356}]',947300,'[{16050001,5,15}]','[{100,[{16050001,200722}]}]'),(5,381,390,'[{1,16557},{7,12418}]',952040,'[{16050001,5,15}]','[{100,[{16050001,200852}]}]'),(5,382,390,'[{1,16640},{7,12480}]',956800,'[{16050001,5,15}]','[{100,[{16050001,200982}]}]'),(5,383,390,'[{1,16723},{7,12542}]',961560,'[{16050001,5,15}]','[{100,[{16050001,201112}]}]'),(5,384,405,'[{1,16806},{7,12604}]',966320,'[{16050001,5,15}]','[{100,[{16050001,201242}]}]'),(5,385,405,'[{1,16889},{7,12667}]',971130,'[{16050001,5,15}]','[{100,[{16050001,201377}]}]'),(5,386,405,'[{1,16972},{7,12729}]',975890,'[{16050001,5,15}]','[{100,[{16050001,201512}]}]'),(5,387,405,'[{1,17056},{7,12792}]',980720,'[{16050001,5,15}]','[{100,[{16050001,201647}]}]'),(5,388,405,'[{1,17140},{7,12855}]',985550,'[{16050001,5,15}]','[{100,[{16050001,201782}]}]'),(5,389,405,'[{1,17224},{7,12918}]',990380,'[{16050001,5,15}]','[{100,[{16050001,201917}]}]'),(5,390,405,'[{1,17308},{7,12981}]',995210,'[{16050001,5,15}]','[{100,[{16050001,202052}]}]'),(5,391,405,'[{1,17392},{7,13044}]',1000040,'[{16050001,5,15}]','[{100,[{16050001,202187}]}]'),(5,392,405,'[{1,17477},{7,13108}]',1004940,'[{16050001,5,15}]','[{100,[{16050001,202322}]}]'),(5,393,405,'[{1,17562},{7,13172}]',1009840,'[{16050001,5,15}]','[{100,[{16050001,202457}]}]'),(5,394,405,'[{1,17647},{7,13236}]',1014740,'[{16050001,5,15}]','[{100,[{16050001,202592}]}]'),(5,395,405,'[{1,17732},{7,13299}]',1019590,'[{16050001,5,15}]','[{100,[{16050001,202727}]}]'),(5,396,405,'[{1,17817},{7,13363}]',1024490,'[{16050001,5,15}]','[{100,[{16050001,202862}]}]'),(5,397,405,'[{1,17903},{7,13428}]',1029460,'[{16050001,5,15}]','[{100,[{16050001,202997}]}]'),(5,398,405,'[{1,17990},{7,13492}]',1034400,'[{16050001,5,15}]','[{100,[{16050001,203132}]}]'),(5,399,420,'[{1,18076},{7,13557}]',1039370,'[{16050001,5,15}]','[{100,[{16050001,203267}]}]'),(5,400,420,'[{1,18162},{7,13621}]',1044290,'[{16050001,5,15}]','[{100,[{16050001,203407}]}]'),(5,401,414,'[{1,18248},{7,13686}]',1049260,'[{16050001,6,18}]','[{100,[{16050001,203547}]}]'),(5,402,414,'[{1,18335},{7,13751}]',1054250,'[{16050001,6,18}]','[{100,[{16050001,203685}]}]'),(5,403,414,'[{1,18422},{7,13817}]',1059290,'[{16050001,6,18}]','[{100,[{16050001,203823}]}]'),(5,404,414,'[{1,18509},{7,13882}]',1064280,'[{16050001,6,18}]','[{100,[{16050001,203961}]}]'),(5,405,414,'[{1,18596},{7,13947}]',1069270,'[{16050001,6,18}]','[{100,[{16050001,204099}]}]'),(5,406,414,'[{1,18683},{7,14013}]',1074310,'[{16050001,6,18}]','[{100,[{16050001,204237}]}]'),(5,407,414,'[{1,18772},{7,14079}]',1079390,'[{16050001,6,18}]','[{100,[{16050001,204375}]}]'),(5,408,432,'[{1,18860},{7,14145}]',1084450,'[{16050001,6,18}]','[{100,[{16050001,204513}]}]'),(5,409,432,'[{1,18948},{7,14211}]',1089510,'[{16050001,6,18}]','[{100,[{16050001,204657}]}]'),(5,410,432,'[{1,19036},{7,14277}]',1094570,'[{16050001,6,18}]','[{100,[{16050001,204801}]}]'),(5,411,432,'[{1,19124},{7,14343}]',1099630,'[{16050001,6,18}]','[{100,[{16050001,204945}]}]'),(5,412,432,'[{1,19213},{7,14410}]',1104760,'[{16050001,6,18}]','[{100,[{16050001,205089}]}]'),(5,413,432,'[{1,19302},{7,14477}]',1109890,'[{16050001,6,18}]','[{100,[{16050001,205233}]}]'),(5,414,432,'[{1,19392},{7,14544}]',1115040,'[{16050001,6,18}]','[{100,[{16050001,205377}]}]'),(5,415,432,'[{1,19481},{7,14611}]',1120170,'[{16050001,6,18}]','[{100,[{16050001,205521}]}]'),(5,416,432,'[{1,19570},{7,14678}]',1125300,'[{16050001,6,18}]','[{100,[{16050001,205665}]}]'),(5,417,432,'[{1,19660},{7,14745}]',1130450,'[{16050001,6,18}]','[{100,[{16050001,205809}]}]'),(5,418,432,'[{1,19750},{7,14813}]',1135650,'[{16050001,6,18}]','[{100,[{16050001,205953}]}]'),(5,419,432,'[{1,19841},{7,14881}]',1140870,'[{16050001,6,18}]','[{100,[{16050001,206097}]}]'),(5,420,432,'[{1,19931},{7,14948}]',1146020,'[{16050001,6,18}]','[{100,[{16050001,206241}]}]'),(5,421,432,'[{1,20021},{7,15016}]',1151220,'[{16050001,6,18}]','[{100,[{16050001,206385}]}]'),(5,422,432,'[{1,20112},{7,15084}]',1156440,'[{16050001,6,18}]','[{100,[{16050001,206529}]}]'),(5,423,432,'[{1,20203},{7,15153}]',1161710,'[{16050001,6,18}]','[{100,[{16050001,206673}]}]'),(5,424,432,'[{1,20295},{7,15221}]',1166950,'[{16050001,6,18}]','[{100,[{16050001,206817}]}]'),(5,425,432,'[{1,20386},{7,15289}]',1172170,'[{16050001,6,18}]','[{100,[{16050001,206961}]}]'),(5,426,450,'[{1,20477},{7,15358}]',1177440,'[{16050001,6,18}]','[{100,[{16050001,207105}]}]'),(5,427,450,'[{1,20569},{7,15427}]',1182730,'[{16050001,6,18}]','[{100,[{16050001,207255}]}]'),(5,428,450,'[{1,20661},{7,15496}]',1188020,'[{16050001,6,18}]','[{100,[{16050001,207405}]}]'),(5,429,450,'[{1,20754},{7,15565}]',1193330,'[{16050001,6,18}]','[{100,[{16050001,207555}]}]'),(5,430,450,'[{1,20846},{7,15635}]',1198670,'[{16050001,6,18}]','[{100,[{16050001,207705}]}]'),(5,431,450,'[{1,20938},{7,15704}]',1203960,'[{16050001,6,18}]','[{100,[{16050001,207855}]}]'),(5,432,450,'[{1,21031},{7,15774}]',1209320,'[{16050001,6,18}]','[{100,[{16050001,208005}]}]'),(5,433,450,'[{1,21125},{7,15844}]',1214700,'[{16050001,6,18}]','[{100,[{16050001,208155}]}]'),(5,434,450,'[{1,21218},{7,15914}]',1220060,'[{16050001,6,18}]','[{100,[{16050001,208305}]}]'),(5,435,450,'[{1,21311},{7,15984}]',1225420,'[{16050001,6,18}]','[{100,[{16050001,208455}]}]'),(5,436,450,'[{1,21405},{7,16054}]',1230800,'[{16050001,6,18}]','[{100,[{16050001,208605}]}]'),(5,437,450,'[{1,21499},{7,16124}]',1236180,'[{16050001,6,18}]','[{100,[{16050001,208755}]}]'),(5,438,450,'[{1,21593},{7,16195}]',1241610,'[{16050001,6,18}]','[{100,[{16050001,208905}]}]'),(5,439,450,'[{1,21687},{7,16266}]',1247040,'[{16050001,6,18}]','[{100,[{16050001,209055}]}]'),(5,440,450,'[{1,21782},{7,16336}]',1252440,'[{16050001,6,18}]','[{100,[{16050001,209205}]}]'),(5,441,450,'[{1,21876},{7,16407}]',1257870,'[{16050001,6,18}]','[{100,[{16050001,209355}]}]'),(5,442,450,'[{1,21971},{7,16479}]',1263370,'[{16050001,6,18}]','[{100,[{16050001,209505}]}]'),(5,443,450,'[{1,22067},{7,16550}]',1268840,'[{16050001,6,18}]','[{100,[{16050001,209655}]}]'),(5,444,468,'[{1,22162},{7,16622}]',1274340,'[{16050001,6,18}]','[{100,[{16050001,209805}]}]'),(5,445,468,'[{1,22257},{7,16693}]',1279790,'[{16050001,6,18}]','[{100,[{16050001,209961}]}]'),(5,446,468,'[{1,22353},{7,16765}]',1285310,'[{16050001,6,18}]','[{100,[{16050001,210117}]}]'),(5,447,468,'[{1,22449},{7,16837}]',1290830,'[{16050001,6,18}]','[{100,[{16050001,210273}]}]'),(5,448,468,'[{1,22545},{7,16909}]',1296350,'[{16050001,6,18}]','[{100,[{16050001,210429}]}]'),(5,449,468,'[{1,22642},{7,16981}]',1301890,'[{16050001,6,18}]','[{100,[{16050001,210585}]}]'),(5,450,468,'[{1,22738},{7,17054}]',1307460,'[{16050001,6,18}]','[{100,[{16050001,210741}]}]'),(5,451,468,'[{1,22834},{7,17126}]',1312980,'[{16050001,6,18}]','[{100,[{16050001,210897}]}]'),(5,452,468,'[{1,22932},{7,17199}]',1318590,'[{16050001,6,18}]','[{100,[{16050001,211053}]}]'),(5,453,468,'[{1,23029},{7,17272}]',1324180,'[{16050001,6,18}]','[{100,[{16050001,211209}]}]'),(5,454,468,'[{1,23126},{7,17345}]',1329770,'[{16050001,6,18}]','[{100,[{16050001,211365}]}]'),(5,455,468,'[{1,23224},{7,17418}]',1335380,'[{16050001,6,18}]','[{100,[{16050001,211521}]}]'),(5,456,468,'[{1,23321},{7,17491}]',1340970,'[{16050001,6,18}]','[{100,[{16050001,211677}]}]'),(5,457,468,'[{1,23420},{7,17565}]',1346650,'[{16050001,6,18}]','[{100,[{16050001,211833}]}]'),(5,458,468,'[{1,23518},{7,17639}]',1352310,'[{16050001,6,18}]','[{100,[{16050001,211989}]}]'),(5,459,468,'[{1,23616},{7,17712}]',1357920,'[{16050001,6,18}]','[{100,[{16050001,212145}]}]'),(5,460,468,'[{1,23715},{7,17786}]',1363600,'[{16050001,6,18}]','[{100,[{16050001,212301}]}]'),(5,461,468,'[{1,23813},{7,17860}]',1369260,'[{16050001,6,18}]','[{100,[{16050001,212457}]}]'),(5,462,486,'[{1,23912},{7,17934}]',1374940,'[{16050001,6,18}]','[{100,[{16050001,212613}]}]'),(5,463,486,'[{1,24012},{7,18009}]',1380690,'[{16050001,6,18}]','[{100,[{16050001,212775}]}]'),(5,464,486,'[{1,24111},{7,18084}]',1386420,'[{16050001,6,18}]','[{100,[{16050001,212937}]}]'),(5,465,486,'[{1,24211},{7,18158}]',1392120,'[{16050001,6,18}]','[{100,[{16050001,213099}]}]'),(5,466,486,'[{1,24310},{7,18233}]',1397850,'[{16050001,6,18}]','[{100,[{16050001,213261}]}]'),(5,467,486,'[{1,24411},{7,18308}]',1403620,'[{16050001,6,18}]','[{100,[{16050001,213423}]}]'),(5,468,486,'[{1,24511},{7,18383}]',1409370,'[{16050001,6,18}]','[{100,[{16050001,213585}]}]'),(5,469,486,'[{1,24611},{7,18459}]',1415170,'[{16050001,6,18}]','[{100,[{16050001,213747}]}]'),(5,470,486,'[{1,24712},{7,18534}]',1420940,'[{16050001,6,18}]','[{100,[{16050001,213909}]}]'),(5,471,486,'[{1,24812},{7,18609}]',1426690,'[{16050001,6,18}]','[{100,[{16050001,214071}]}]'),(5,472,486,'[{1,24914},{7,18685}]',1432530,'[{16050001,6,18}]','[{100,[{16050001,214233}]}]'),(5,473,486,'[{1,25015},{7,18762}]',1438400,'[{16050001,6,18}]','[{100,[{16050001,214395}]}]'),(5,474,486,'[{1,25117},{7,18838}]',1444240,'[{16050001,6,18}]','[{100,[{16050001,214557}]}]'),(5,475,486,'[{1,25218},{7,18914}]',1450060,'[{16050001,6,18}]','[{100,[{16050001,214719}]}]'),(5,476,486,'[{1,25320},{7,18990}]',1455900,'[{16050001,6,18}]','[{100,[{16050001,214881}]}]'),(5,477,486,'[{1,25422},{7,19067}]',1461790,'[{16050001,6,18}]','[{100,[{16050001,215043}]}]'),(5,478,486,'[{1,25525},{7,19144}]',1467700,'[{16050001,6,18}]','[{100,[{16050001,215205}]}]'),(5,479,486,'[{1,25627},{7,19220}]',1473540,'[{16050001,6,18}]','[{100,[{16050001,215367}]}]'),(5,480,504,'[{1,25730},{7,19297}]',1479450,'[{16050001,6,18}]','[{100,[{16050001,215529}]}]'),(5,481,504,'[{1,25832},{7,19374}]',1485340,'[{16050001,6,18}]','[{100,[{16050001,215697}]}]'),(5,482,504,'[{1,25936},{7,19452}]',1491320,'[{16050001,6,18}]','[{100,[{16050001,215865}]}]'),(5,483,504,'[{1,26039},{7,19529}]',1497230,'[{16050001,6,18}]','[{100,[{16050001,216033}]}]'),(5,484,504,'[{1,26143},{7,19607}]',1503210,'[{16050001,6,18}]','[{100,[{16050001,216201}]}]'),(5,485,504,'[{1,26246},{7,19685}]',1509170,'[{16050001,6,18}]','[{100,[{16050001,216369}]}]'),(5,486,504,'[{1,26350},{7,19762}]',1515100,'[{16050001,6,18}]','[{100,[{16050001,216537}]}]'),(5,487,504,'[{1,26454},{7,19841}]',1521130,'[{16050001,6,18}]','[{100,[{16050001,216705}]}]'),(5,488,504,'[{1,26559},{7,19919}]',1527130,'[{16050001,6,18}]','[{100,[{16050001,216873}]}]'),(5,489,504,'[{1,26663},{7,19998}]',1533160,'[{16050001,6,18}]','[{100,[{16050001,217041}]}]'),(5,490,504,'[{1,26768},{7,20076}]',1539160,'[{16050001,6,18}]','[{100,[{16050001,217209}]}]'),(5,491,504,'[{1,26872},{7,20154}]',1545140,'[{16050001,6,18}]','[{100,[{16050001,217377}]}]'),(5,492,504,'[{1,26978},{7,20234}]',1551260,'[{16050001,6,18}]','[{100,[{16050001,217545}]}]'),(5,493,504,'[{1,27084},{7,20313}]',1557330,'[{16050001,6,18}]','[{100,[{16050001,217713}]}]'),(5,494,504,'[{1,27189},{7,20392}]',1563380,'[{16050001,6,18}]','[{100,[{16050001,217881}]}]'),(5,495,504,'[{1,27295},{7,20471}]',1569450,'[{16050001,6,18}]','[{100,[{16050001,218049}]}]'),(5,496,504,'[{1,27400},{7,20550}]',1575500,'[{16050001,6,18}]','[{100,[{16050001,218217}]}]'),(5,497,504,'[{1,27507},{7,20630}]',1581640,'[{16050001,6,18}]','[{100,[{16050001,218385}]}]'),(5,498,522,'[{1,27613},{7,20710}]',1587760,'[{16050001,6,18}]','[{100,[{16050001,218553}]}]'),(5,499,522,'[{1,27720},{7,20790}]',1593900,'[{16050001,6,18}]','[{100,[{16050001,218727}]}]'),(5,500,522,'[{1,27827},{7,20870}]',1600040,'[]','[{100,[{16050001,218901}]}]'),(6,1,9,'[{2,82},{8,4}]',282,'[{16050001,1,3}]','[{100,[{16050001,219075}]}]'),(6,2,9,'[{2,185},{8,7}]',535,'[{16050001,1,3}]','[{100,[{16050001,219078}]}]'),(6,3,12,'[{2,287},{8,11}]',837,'[{16050001,1,3}]','[{100,[{16050001,219081}]}]'),(6,4,12,'[{2,390},{8,15}]',1140,'[{16050001,1,3}]','[{100,[{16050001,219085}]}]'),(6,5,12,'[{2,492},{8,19}]',1442,'[{16050001,1,3}]','[{100,[{16050001,219089}]}]'),(6,6,15,'[{2,595},{8,23}]',1745,'[{16050001,1,3}]','[{100,[{16050001,219093}]}]'),(6,7,15,'[{2,718},{8,27}]',2068,'[{16050001,1,3}]','[{100,[{16050001,219098}]}]'),(6,8,15,'[{2,841},{8,32}]',2441,'[{16050001,1,3}]','[{100,[{16050001,219103}]}]'),(6,9,18,'[{2,964},{8,37}]',2814,'[{16050001,1,3}]','[{100,[{16050001,219108}]}]'),(6,10,18,'[{2,1087},{8,41}]',3137,'[{16050001,1,3}]','[{100,[{16050001,219114}]}]'),(6,11,18,'[{2,1210},{8,46}]',3510,'[{16050001,1,3}]','[{100,[{16050001,219120}]}]'),(6,12,21,'[{2,1353},{8,51}]',3903,'[{16050001,1,3}]','[{100,[{16050001,219126}]}]'),(6,13,21,'[{2,1497},{8,57}]',4347,'[{16050001,1,3}]','[{100,[{16050001,219133}]}]'),(6,14,21,'[{2,1640},{8,62}]',4740,'[{16050001,1,3}]','[{100,[{16050001,219140}]}]'),(6,15,24,'[{2,1784},{8,67}]',5134,'[{16050001,1,3}]','[{100,[{16050001,219147}]}]'),(6,16,24,'[{2,1927},{8,73}]',5577,'[{16050001,2,6}]','[{100,[{16050001,219155}]}]'),(6,17,24,'[{2,2091},{8,79}]',6041,'[{16050001,2,6}]','[{100,[{16050001,219163}]}]'),(6,18,30,'[{2,2255},{8,85}]',6505,'[{16050001,2,6}]','[{100,[{16050001,219171}]}]'),(6,19,30,'[{2,2419},{8,91}]',6969,'[{16050001,2,6}]','[{100,[{16050001,219181}]}]'),(6,20,30,'[{2,2583},{8,97}]',7433,'[{16050001,2,6}]','[{100,[{16050001,219191}]}]'),(6,21,30,'[{2,2747},{8,104}]',7947,'[{16050001,2,6}]','[{100,[{16050001,219201}]}]'),(6,22,30,'[{2,2932},{8,110}]',8432,'[{16050001,2,6}]','[{100,[{16050001,219211}]}]'),(6,23,30,'[{2,3116},{8,117}]',8966,'[{16050001,2,6}]','[{100,[{16050001,219221}]}]'),(6,24,36,'[{2,3301},{8,124}]',9501,'[{16050001,2,6}]','[{100,[{16050001,219231}]}]'),(6,25,36,'[{2,3485},{8,131}]',10035,'[{16050001,2,6}]','[{100,[{16050001,219243}]}]'),(6,26,36,'[{2,3670},{8,138}]',10570,'[{16050001,2,6}]','[{100,[{16050001,219255}]}]'),(6,27,36,'[{2,3875},{8,146}]',11175,'[{16050001,2,6}]','[{100,[{16050001,219267}]}]'),(6,28,36,'[{2,4080},{8,153}]',11730,'[{16050001,2,6}]','[{100,[{16050001,219279}]}]'),(6,29,36,'[{2,4285},{8,161}]',12335,'[{16050001,2,6}]','[{100,[{16050001,219291}]}]'),(6,30,42,'[{2,4490},{8,169}]',12940,'[{16050001,2,6}]','[{100,[{16050001,219303}]}]'),(6,31,42,'[{2,4695},{8,177}]',13545,'[{16050001,2,6}]','[{100,[{16050001,219317}]}]'),(6,32,42,'[{2,4920},{8,185}]',14170,'[{16050001,2,6}]','[{100,[{16050001,219331}]}]'),(6,33,42,'[{2,5146},{8,193}]',14796,'[{16050001,2,6}]','[{100,[{16050001,219345}]}]'),(6,34,42,'[{2,5371},{8,202}]',15471,'[{16050001,2,6}]','[{100,[{16050001,219359}]}]'),(6,35,42,'[{2,5596},{8,210}]',16096,'[{16050001,2,6}]','[{100,[{16050001,219373}]}]'),(6,36,48,'[{2,5822},{8,219}]',16772,'[{16050001,2,6}]','[{100,[{16050001,219387}]}]'),(6,37,48,'[{2,6068},{8,228}]',17468,'[{16050001,2,6}]','[{100,[{16050001,219403}]}]'),(6,38,48,'[{2,6314},{8,237}]',18164,'[{16050001,2,6}]','[{100,[{16050001,219419}]}]'),(6,39,48,'[{2,6560},{8,246}]',18860,'[{16050001,2,6}]','[{100,[{16050001,219435}]}]'),(6,40,48,'[{2,6806},{8,256}]',19606,'[{16050001,2,6}]','[{100,[{16050001,219451}]}]'),(6,41,48,'[{2,7052},{8,265}]',20302,'[{16050001,2,6}]','[{100,[{16050001,219467}]}]'),(6,42,54,'[{2,7318},{8,275}]',21068,'[{16050001,2,6}]','[{100,[{16050001,219483}]}]'),(6,43,54,'[{2,7585},{8,285}]',21835,'[{16050001,2,6}]','[{100,[{16050001,219501}]}]'),(6,44,54,'[{2,7851},{8,295}]',22601,'[{16050001,2,6}]','[{100,[{16050001,219519}]}]'),(6,45,54,'[{2,8118},{8,305}]',23368,'[{16050001,2,6}]','[{100,[{16050001,219537}]}]'),(6,46,54,'[{2,8384},{8,315}]',24134,'[{16050001,2,6}]','[{100,[{16050001,219555}]}]'),(6,47,54,'[{2,8671},{8,326}]',24971,'[{16050001,2,6}]','[{100,[{16050001,219573}]}]'),(6,48,60,'[{2,8958},{8,336}]',25758,'[{16050001,2,6}]','[{100,[{16050001,219591}]}]'),(6,49,60,'[{2,9245},{8,347}]',26595,'[{16050001,2,6}]','[{100,[{16050001,219611}]}]'),(6,50,60,'[{2,9532},{8,358}]',27432,'[{16050001,2,6}]','[{100,[{16050001,219631}]}]'),(6,51,60,'[{2,9819},{8,369}]',28269,'[{16050001,2,6}]','[{100,[{16050001,219651}]}]'),(6,52,60,'[{2,10127},{8,380}]',29127,'[{16050001,2,6}]','[{100,[{16050001,219671}]}]'),(6,53,60,'[{2,10434},{8,392}]',30034,'[{16050001,2,6}]','[{100,[{16050001,219691}]}]'),(6,54,66,'[{2,10741},{8,403}]',30891,'[{16050001,2,6}]','[{100,[{16050001,219711}]}]'),(6,55,66,'[{2,11049},{8,415}]',31799,'[{16050001,2,6}]','[{100,[{16050001,219733}]}]'),(6,56,66,'[{2,11356},{8,426}]',32656,'[{16050001,2,6}]','[{100,[{16050001,219755}]}]'),(6,57,66,'[{2,11684},{8,439}]',33634,'[{16050001,2,6}]','[{100,[{16050001,219777}]}]'),(6,58,66,'[{2,12012},{8,451}]',34562,'[{16050001,2,6}]','[{100,[{16050001,219799}]}]'),(6,59,66,'[{2,12340},{8,463}]',35490,'[{16050001,2,6}]','[{100,[{16050001,219821}]}]'),(6,60,72,'[{2,12668},{8,476}]',36468,'[{16050001,2,6}]','[{100,[{16050001,219843}]}]'),(6,61,72,'[{2,12996},{8,488}]',37396,'[{16050001,2,6}]','[{100,[{16050001,219867}]}]'),(6,62,72,'[{2,13345},{8,501}]',38395,'[{16050001,2,6}]','[{100,[{16050001,219891}]}]'),(6,63,72,'[{2,13693},{8,514}]',39393,'[{16050001,2,6}]','[{100,[{16050001,219915}]}]'),(6,64,72,'[{2,14042},{8,527}]',40392,'[{16050001,2,6}]','[{100,[{16050001,219939}]}]'),(6,65,72,'[{2,14390},{8,540}]',41390,'[{16050001,2,6}]','[{100,[{16050001,219963}]}]'),(6,66,78,'[{2,14739},{8,553}]',42389,'[{16050001,2,6}]','[{100,[{16050001,219987}]}]'),(6,67,78,'[{2,15108},{8,567}]',43458,'[{16050001,2,6}]','[{100,[{16050001,220013}]}]'),(6,68,78,'[{2,15477},{8,581}]',44527,'[{16050001,2,6}]','[{100,[{16050001,220039}]}]'),(6,69,78,'[{2,15845},{8,595}]',45595,'[{16050001,2,6}]','[{100,[{16050001,220065}]}]'),(6,70,78,'[{2,16214},{8,609}]',46664,'[{16050001,2,6}]','[{100,[{16050001,220091}]}]'),(6,71,78,'[{2,16583},{8,622}]',47683,'[{16050001,2,6}]','[{100,[{16050001,220117}]}]'),(6,72,84,'[{2,16973},{8,637}]',48823,'[{16050001,2,6}]','[{100,[{16050001,220143}]}]'),(6,73,84,'[{2,17362},{8,652}]',49962,'[{16050001,2,6}]','[{100,[{16050001,220171}]}]'),(6,74,84,'[{2,17752},{8,666}]',51052,'[{16050001,2,6}]','[{100,[{16050001,220199}]}]'),(6,75,84,'[{2,18141},{8,681}]',52191,'[{16050001,2,6}]','[{100,[{16050001,220227}]}]'),(6,76,84,'[{2,18531},{8,695}]',53281,'[{16050001,2,6}]','[{100,[{16050001,220255}]}]'),(6,77,84,'[{2,18941},{8,711}]',54491,'[{16050001,2,6}]','[{100,[{16050001,220283}]}]'),(6,78,90,'[{2,19351},{8,726}]',55651,'[{16050001,2,6}]','[{100,[{16050001,220311}]}]'),(6,79,90,'[{2,19761},{8,742}]',56861,'[{16050001,2,6}]','[{100,[{16050001,220341}]}]'),(6,80,90,'[{2,20171},{8,757}]',58021,'[{16050001,2,6}]','[{100,[{16050001,220371}]}]'),(6,81,90,'[{2,20581},{8,772}]',59181,'[{16050001,2,6}]','[{100,[{16050001,220401}]}]'),(6,82,90,'[{2,21011},{8,788}]',60411,'[{16050001,2,6}]','[{100,[{16050001,220431}]}]'),(6,83,90,'[{2,21441},{8,805}]',61691,'[{16050001,2,6}]','[{100,[{16050001,220461}]}]'),(6,84,96,'[{2,21872},{8,821}]',62922,'[{16050001,2,6}]','[{100,[{16050001,220491}]}]'),(6,85,96,'[{2,22302},{8,837}]',64152,'[{16050001,2,6}]','[{100,[{16050001,220523}]}]'),(6,86,96,'[{2,22733},{8,853}]',65383,'[{16050001,2,6}]','[{100,[{16050001,220555}]}]'),(6,87,96,'[{2,23184},{8,870}]',66684,'[{16050001,2,6}]','[{100,[{16050001,220587}]}]'),(6,88,96,'[{2,23635},{8,887}]',67985,'[{16050001,2,6}]','[{100,[{16050001,220619}]}]'),(6,89,96,'[{2,24086},{8,904}]',69286,'[{16050001,2,6}]','[{100,[{16050001,220651}]}]'),(6,90,102,'[{2,24537},{8,921}]',70587,'[{16050001,2,6}]','[{100,[{16050001,220683}]}]'),(6,91,102,'[{2,24988},{8,938}]',71888,'[{16050001,2,6}]','[{100,[{16050001,220717}]}]'),(6,92,102,'[{2,25459},{8,955}]',73209,'[{16050001,2,6}]','[{100,[{16050001,220751}]}]'),(6,93,102,'[{2,25931},{8,973}]',74581,'[{16050001,2,6}]','[{100,[{16050001,220785}]}]'),(6,94,102,'[{2,26402},{8,991}]',75952,'[{16050001,2,6}]','[{100,[{16050001,220819}]}]'),(6,95,102,'[{2,26873},{8,1008}]',77273,'[{16050001,2,6}]','[{100,[{16050001,220853}]}]'),(6,96,108,'[{2,27345},{8,1026}]',78645,'[{16050001,2,6}]','[{100,[{16050001,220887}]}]'),(6,97,108,'[{2,27837},{8,1044}]',80037,'[{16050001,2,6}]','[{100,[{16050001,220923}]}]'),(6,98,108,'[{2,28329},{8,1063}]',81479,'[{16050001,2,6}]','[{100,[{16050001,220959}]}]'),(6,99,108,'[{2,28821},{8,1081}]',82871,'[{16050001,2,6}]','[{100,[{16050001,220995}]}]'),(6,100,108,'[{2,29313},{8,1100}]',84313,'[{16050001,2,6}]','[{100,[{16050001,221031}]}]'),(6,101,108,'[{2,29805},{8,1118}]',85705,'[{16050001,3,9}]','[{100,[{16050001,221067}]}]'),(6,102,117,'[{2,30317},{8,1137}]',87167,'[{16050001,3,9}]','[{100,[{16050001,221103}]}]'),(6,103,117,'[{2,30830},{8,1157}]',88680,'[{16050001,3,9}]','[{100,[{16050001,221142}]}]'),(6,104,117,'[{2,31342},{8,1176}]',90142,'[{16050001,3,9}]','[{100,[{16050001,221181}]}]'),(6,105,117,'[{2,31854},{8,1195}]',91604,'[{16050001,3,9}]','[{100,[{16050001,221220}]}]'),(6,106,117,'[{2,32367},{8,1214}]',93067,'[{16050001,3,9}]','[{100,[{16050001,221259}]}]'),(6,107,117,'[{2,32900},{8,1234}]',94600,'[{16050001,3,9}]','[{100,[{16050001,221298}]}]'),(6,108,117,'[{2,33433},{8,1254}]',96133,'[{16050001,3,9}]','[{100,[{16050001,221337}]}]'),(6,109,117,'[{2,33966},{8,1274}]',97666,'[{16050001,3,9}]','[{100,[{16050001,221376}]}]'),(6,110,117,'[{2,34499},{8,1294}]',99199,'[{16050001,3,9}]','[{100,[{16050001,221415}]}]'),(6,111,126,'[{2,35032},{8,1314}]',100732,'[{16050001,3,9}]','[{100,[{16050001,221454}]}]'),(6,112,126,'[{2,35585},{8,1335}]',102335,'[{16050001,3,9}]','[{100,[{16050001,221496}]}]'),(6,113,126,'[{2,36139},{8,1356}]',103939,'[{16050001,3,9}]','[{100,[{16050001,221538}]}]'),(6,114,126,'[{2,36692},{8,1376}]',105492,'[{16050001,3,9}]','[{100,[{16050001,221580}]}]'),(6,115,126,'[{2,37245},{8,1397}]',107095,'[{16050001,3,9}]','[{100,[{16050001,221622}]}]'),(6,116,126,'[{2,37799},{8,1418}]',108699,'[{16050001,3,9}]','[{100,[{16050001,221664}]}]'),(6,117,126,'[{2,38373},{8,1439}]',110323,'[{16050001,3,9}]','[{100,[{16050001,221706}]}]'),(6,118,126,'[{2,38947},{8,1461}]',111997,'[{16050001,3,9}]','[{100,[{16050001,221748}]}]'),(6,119,126,'[{2,39521},{8,1483}]',113671,'[{16050001,3,9}]','[{100,[{16050001,221790}]}]'),(6,120,135,'[{2,40095},{8,1504}]',115295,'[{16050001,3,9}]','[{100,[{16050001,221832}]}]'),(6,121,135,'[{2,40669},{8,1526}]',116969,'[{16050001,3,9}]','[{100,[{16050001,221877}]}]'),(6,122,135,'[{2,41263},{8,1548}]',118663,'[{16050001,3,9}]','[{100,[{16050001,221922}]}]'),(6,123,135,'[{2,41857},{8,1570}]',120357,'[{16050001,3,9}]','[{100,[{16050001,221967}]}]'),(6,124,135,'[{2,42452},{8,1592}]',122052,'[{16050001,3,9}]','[{100,[{16050001,222012}]}]'),(6,125,135,'[{2,43046},{8,1615}]',123796,'[{16050001,3,9}]','[{100,[{16050001,222057}]}]'),(6,126,135,'[{2,43641},{8,1637}]',125491,'[{16050001,3,9}]','[{100,[{16050001,222102}]}]'),(6,127,135,'[{2,44256},{8,1660}]',127256,'[{16050001,3,9}]','[{100,[{16050001,222147}]}]'),(6,128,135,'[{2,44871},{8,1683}]',129021,'[{16050001,3,9}]','[{100,[{16050001,222192}]}]'),(6,129,144,'[{2,45486},{8,1706}]',130786,'[{16050001,3,9}]','[{100,[{16050001,222237}]}]'),(6,130,144,'[{2,46101},{8,1729}]',132551,'[{16050001,3,9}]','[{100,[{16050001,222285}]}]'),(6,131,144,'[{2,46716},{8,1752}]',134316,'[{16050001,3,9}]','[{100,[{16050001,222333}]}]'),(6,132,144,'[{2,47351},{8,1776}]',136151,'[{16050001,3,9}]','[{100,[{16050001,222381}]}]'),(6,133,144,'[{2,47986},{8,1800}]',137986,'[{16050001,3,9}]','[{100,[{16050001,222429}]}]'),(6,134,144,'[{2,48622},{8,1824}]',139822,'[{16050001,3,9}]','[{100,[{16050001,222477}]}]'),(6,135,144,'[{2,49257},{8,1848}]',141657,'[{16050001,3,9}]','[{100,[{16050001,222525}]}]'),(6,136,144,'[{2,49893},{8,1871}]',143443,'[{16050001,3,9}]','[{100,[{16050001,222573}]}]'),(6,137,144,'[{2,50549},{8,1896}]',145349,'[{16050001,3,9}]','[{100,[{16050001,222621}]}]'),(6,138,153,'[{2,51205},{8,1921}]',147255,'[{16050001,3,9}]','[{100,[{16050001,222669}]}]'),(6,139,153,'[{2,51861},{8,1945}]',149111,'[{16050001,3,9}]','[{100,[{16050001,222720}]}]'),(6,140,153,'[{2,52516},{8,1970}]',151016,'[{16050001,3,9}]','[{100,[{16050001,222771}]}]'),(6,141,153,'[{2,53172},{8,1994}]',152872,'[{16050001,3,9}]','[{100,[{16050001,222822}]}]'),(6,142,153,'[{2,53849},{8,2020}]',154849,'[{16050001,3,9}]','[{100,[{16050001,222873}]}]'),(6,143,153,'[{2,54525},{8,2045}]',156775,'[{16050001,3,9}]','[{100,[{16050001,222924}]}]'),(6,144,153,'[{2,55202},{8,2071}]',158752,'[{16050001,3,9}]','[{100,[{16050001,222975}]}]'),(6,145,153,'[{2,55878},{8,2096}]',160678,'[{16050001,3,9}]','[{100,[{16050001,223026}]}]'),(6,146,153,'[{2,56555},{8,2121}]',162605,'[{16050001,3,9}]','[{100,[{16050001,223077}]}]'),(6,147,162,'[{2,57252},{8,2147}]',164602,'[{16050001,3,9}]','[{100,[{16050001,223128}]}]'),(6,148,162,'[{2,57948},{8,2174}]',166648,'[{16050001,3,9}]','[{100,[{16050001,223182}]}]'),(6,149,162,'[{2,58645},{8,2200}]',168645,'[{16050001,3,9}]','[{100,[{16050001,223236}]}]'),(6,150,162,'[{2,59342},{8,2226}]',170642,'[{16050001,3,9}]','[{100,[{16050001,223290}]}]'),(6,151,162,'[{2,60039},{8,2252}]',172639,'[{16050001,3,9}]','[{100,[{16050001,223344}]}]'),(6,152,162,'[{2,60757},{8,2279}]',174707,'[{16050001,3,9}]','[{100,[{16050001,223398}]}]'),(6,153,162,'[{2,61474},{8,2306}]',176774,'[{16050001,3,9}]','[{100,[{16050001,223452}]}]'),(6,154,162,'[{2,62192},{8,2333}]',178842,'[{16050001,3,9}]','[{100,[{16050001,223506}]}]'),(6,155,162,'[{2,62909},{8,2360}]',180909,'[{16050001,3,9}]','[{100,[{16050001,223560}]}]'),(6,156,171,'[{2,63626},{8,2386}]',182926,'[{16050001,3,9}]','[{100,[{16050001,223614}]}]'),(6,157,171,'[{2,64364},{8,2414}]',185064,'[{16050001,3,9}]','[{100,[{16050001,223671}]}]'),(6,158,171,'[{2,65102},{8,2442}]',187202,'[{16050001,3,9}]','[{100,[{16050001,223728}]}]'),(6,159,171,'[{2,65840},{8,2469}]',189290,'[{16050001,3,9}]','[{100,[{16050001,223785}]}]'),(6,160,171,'[{2,66578},{8,2497}]',191428,'[{16050001,3,9}]','[{100,[{16050001,223842}]}]'),(6,161,171,'[{2,67316},{8,2525}]',193566,'[{16050001,3,9}]','[{100,[{16050001,223899}]}]'),(6,162,171,'[{2,68074},{8,2553}]',195724,'[{16050001,3,9}]','[{100,[{16050001,223956}]}]'),(6,163,171,'[{2,68833},{8,2582}]',197933,'[{16050001,3,9}]','[{100,[{16050001,224013}]}]'),(6,164,171,'[{2,69591},{8,2610}]',200091,'[{16050001,3,9}]','[{100,[{16050001,224070}]}]'),(6,165,180,'[{2,70350},{8,2639}]',202300,'[{16050001,3,9}]','[{100,[{16050001,224127}]}]'),(6,166,180,'[{2,71108},{8,2667}]',204458,'[{16050001,3,9}]','[{100,[{16050001,224187}]}]'),(6,167,180,'[{2,71887},{8,2696}]',206687,'[{16050001,3,9}]','[{100,[{16050001,224247}]}]'),(6,168,180,'[{2,72666},{8,2725}]',208916,'[{16050001,3,9}]','[{100,[{16050001,224307}]}]'),(6,169,180,'[{2,73445},{8,2755}]',211195,'[{16050001,3,9}]','[{100,[{16050001,224367}]}]'),(6,170,180,'[{2,74224},{8,2784}]',213424,'[{16050001,3,9}]','[{100,[{16050001,224427}]}]'),(6,171,180,'[{2,75003},{8,2813}]',215653,'[{16050001,3,9}]','[{100,[{16050001,224487}]}]'),(6,172,180,'[{2,75802},{8,2843}]',217952,'[{16050001,3,9}]','[{100,[{16050001,224547}]}]'),(6,173,180,'[{2,76602},{8,2873}]',220252,'[{16050001,3,9}]','[{100,[{16050001,224607}]}]'),(6,174,189,'[{2,77401},{8,2903}]',222551,'[{16050001,3,9}]','[{100,[{16050001,224667}]}]'),(6,175,189,'[{2,78201},{8,2933}]',224851,'[{16050001,3,9}]','[{100,[{16050001,224730}]}]'),(6,176,189,'[{2,79000},{8,2963}]',227150,'[{16050001,3,9}]','[{100,[{16050001,224793}]}]'),(6,177,189,'[{2,79820},{8,2994}]',229520,'[{16050001,3,9}]','[{100,[{16050001,224856}]}]'),(6,178,189,'[{2,80640},{8,3024}]',231840,'[{16050001,3,9}]','[{100,[{16050001,224919}]}]'),(6,179,189,'[{2,81460},{8,3055}]',234210,'[{16050001,3,9}]','[{100,[{16050001,224982}]}]'),(6,180,189,'[{2,82280},{8,3086}]',236580,'[{16050001,3,9}]','[{100,[{16050001,225045}]}]'),(6,181,189,'[{2,83100},{8,3117}]',238950,'[{16050001,3,9}]','[{100,[{16050001,225108}]}]'),(6,182,189,'[{2,83940},{8,3148}]',241340,'[{16050001,3,9}]','[{100,[{16050001,225171}]}]'),(6,183,198,'[{2,84780},{8,3180}]',243780,'[{16050001,3,9}]','[{100,[{16050001,225234}]}]'),(6,184,198,'[{2,85621},{8,3211}]',246171,'[{16050001,3,9}]','[{100,[{16050001,225300}]}]'),(6,185,198,'[{2,86461},{8,3243}]',248611,'[{16050001,3,9}]','[{100,[{16050001,225366}]}]'),(6,186,198,'[{2,87302},{8,3274}]',251002,'[{16050001,3,9}]','[{100,[{16050001,225432}]}]'),(6,187,198,'[{2,88163},{8,3307}]',253513,'[{16050001,3,9}]','[{100,[{16050001,225498}]}]'),(6,188,198,'[{2,89023},{8,3339}]',255973,'[{16050001,3,9}]','[{100,[{16050001,225564}]}]'),(6,189,198,'[{2,89884},{8,3371}]',258434,'[{16050001,3,9}]','[{100,[{16050001,225630}]}]'),(6,190,198,'[{2,90745},{8,3403}]',260895,'[{16050001,3,9}]','[{100,[{16050001,225696}]}]'),(6,191,198,'[{2,91606},{8,3436}]',263406,'[{16050001,3,9}]','[{100,[{16050001,225762}]}]'),(6,192,207,'[{2,92488},{8,3469}]',265938,'[{16050001,3,9}]','[{100,[{16050001,225828}]}]'),(6,193,207,'[{2,93369},{8,3502}]',268469,'[{16050001,3,9}]','[{100,[{16050001,225897}]}]'),(6,194,207,'[{2,94250},{8,3535}]',271000,'[{16050001,3,9}]','[{100,[{16050001,225966}]}]'),(6,195,207,'[{2,95132},{8,3568}]',273532,'[{16050001,3,9}]','[{100,[{16050001,226035}]}]'),(6,196,207,'[{2,96013},{8,3601}]',276063,'[{16050001,3,9}]','[{100,[{16050001,226104}]}]'),(6,197,207,'[{2,96915},{8,3635}]',278665,'[{16050001,3,9}]','[{100,[{16050001,226173}]}]'),(6,198,207,'[{2,97817},{8,3669}]',281267,'[{16050001,3,9}]','[{100,[{16050001,226242}]}]'),(6,199,207,'[{2,98719},{8,3702}]',283819,'[{16050001,3,9}]','[{100,[{16050001,226311}]}]'),(6,200,207,'[{2,99621},{8,3736}]',286421,'[{16050001,3,9}]','[{100,[{16050001,226380}]}]'),(6,201,216,'[{2,100523},{8,3770}]',289023,'[{16050001,4,12}]','[{100,[{16050001,226449}]}]'),(6,202,216,'[{2,101445},{8,3805}]',291695,'[{16050001,4,12}]','[{100,[{16050001,226521}]}]'),(6,203,216,'[{2,102368},{8,3839}]',294318,'[{16050001,4,12}]','[{100,[{16050001,226593}]}]'),(6,204,216,'[{2,103290},{8,3874}]',296990,'[{16050001,4,12}]','[{100,[{16050001,226665}]}]'),(6,205,216,'[{2,104213},{8,3908}]',299613,'[{16050001,4,12}]','[{100,[{16050001,226737}]}]'),(6,206,216,'[{2,105135},{8,3943}]',302285,'[{16050001,4,12}]','[{100,[{16050001,226809}]}]'),(6,207,216,'[{2,106078},{8,3978}]',304978,'[{16050001,4,12}]','[{100,[{16050001,226881}]}]'),(6,208,216,'[{2,107021},{8,4014}]',307721,'[{16050001,4,12}]','[{100,[{16050001,226953}]}]'),(6,209,216,'[{2,107964},{8,4049}]',310414,'[{16050001,4,12}]','[{100,[{16050001,227025}]}]'),(6,210,228,'[{2,108907},{8,4084}]',313107,'[{16050001,4,12}]','[{100,[{16050001,227097}]}]'),(6,211,228,'[{2,109849},{8,4120}]',315849,'[{16050001,4,12}]','[{100,[{16050001,227173}]}]'),(6,212,228,'[{2,110813},{8,4156}]',318613,'[{16050001,4,12}]','[{100,[{16050001,227249}]}]'),(6,213,228,'[{2,111776},{8,4192}]',321376,'[{16050001,4,12}]','[{100,[{16050001,227325}]}]'),(6,214,228,'[{2,112740},{8,4228}]',324140,'[{16050001,4,12}]','[{100,[{16050001,227401}]}]'),(6,215,228,'[{2,113703},{8,4264}]',326903,'[{16050001,4,12}]','[{100,[{16050001,227477}]}]'),(6,216,228,'[{2,114667},{8,4300}]',329667,'[{16050001,4,12}]','[{100,[{16050001,227553}]}]'),(6,217,228,'[{2,115650},{8,4337}]',332500,'[{16050001,4,12}]','[{100,[{16050001,227629}]}]'),(6,218,228,'[{2,116634},{8,4374}]',335334,'[{16050001,4,12}]','[{100,[{16050001,227705}]}]'),(6,219,228,'[{2,117618},{8,4411}]',338168,'[{16050001,4,12}]','[{100,[{16050001,227781}]}]'),(6,220,228,'[{2,118602},{8,4448}]',341002,'[{16050001,4,12}]','[{100,[{16050001,227857}]}]'),(6,221,228,'[{2,119586},{8,4485}]',343836,'[{16050001,4,12}]','[{100,[{16050001,227933}]}]'),(6,222,240,'[{2,120590},{8,4523}]',346740,'[{16050001,4,12}]','[{100,[{16050001,228009}]}]'),(6,223,240,'[{2,121595},{8,4560}]',349595,'[{16050001,4,12}]','[{100,[{16050001,228089}]}]'),(6,224,240,'[{2,122599},{8,4598}]',352499,'[{16050001,4,12}]','[{100,[{16050001,228169}]}]'),(6,225,240,'[{2,123604},{8,4636}]',355404,'[{16050001,4,12}]','[{100,[{16050001,228249}]}]'),(6,226,240,'[{2,124608},{8,4673}]',358258,'[{16050001,4,12}]','[{100,[{16050001,228329}]}]'),(6,227,240,'[{2,125633},{8,4712}]',361233,'[{16050001,4,12}]','[{100,[{16050001,228409}]}]'),(6,228,240,'[{2,126658},{8,4750}]',364158,'[{16050001,4,12}]','[{100,[{16050001,228489}]}]'),(6,229,240,'[{2,127683},{8,4789}]',367133,'[{16050001,4,12}]','[{100,[{16050001,228569}]}]'),(6,230,240,'[{2,128708},{8,4827}]',370058,'[{16050001,4,12}]','[{100,[{16050001,228649}]}]'),(6,231,240,'[{2,129733},{8,4865}]',372983,'[{16050001,4,12}]','[{100,[{16050001,228729}]}]'),(6,232,240,'[{2,130778},{8,4905}]',376028,'[{16050001,4,12}]','[{100,[{16050001,228809}]}]'),(6,233,240,'[{2,131823},{8,4944}]',379023,'[{16050001,4,12}]','[{100,[{16050001,228889}]}]'),(6,234,252,'[{2,132869},{8,4983}]',382019,'[{16050001,4,12}]','[{100,[{16050001,228969}]}]'),(6,235,252,'[{2,133914},{8,5022}]',385014,'[{16050001,4,12}]','[{100,[{16050001,229053}]}]'),(6,236,252,'[{2,134960},{8,5061}]',388010,'[{16050001,4,12}]','[{100,[{16050001,229137}]}]'),(6,237,252,'[{2,136025},{8,5101}]',391075,'[{16050001,4,12}]','[{100,[{16050001,229221}]}]'),(6,238,252,'[{2,137091},{8,5141}]',394141,'[{16050001,4,12}]','[{100,[{16050001,229305}]}]'),(6,239,252,'[{2,138157},{8,5181}]',397207,'[{16050001,4,12}]','[{100,[{16050001,229389}]}]'),(6,240,252,'[{2,139223},{8,5221}]',400273,'[{16050001,4,12}]','[{100,[{16050001,229473}]}]'),(6,241,252,'[{2,140289},{8,5261}]',403339,'[{16050001,4,12}]','[{100,[{16050001,229557}]}]'),(6,242,252,'[{2,141375},{8,5302}]',406475,'[{16050001,4,12}]','[{100,[{16050001,229641}]}]'),(6,243,252,'[{2,142462},{8,5343}]',409612,'[{16050001,4,12}]','[{100,[{16050001,229725}]}]'),(6,244,252,'[{2,143548},{8,5384}]',412748,'[{16050001,4,12}]','[{100,[{16050001,229809}]}]'),(6,245,252,'[{2,144635},{8,5424}]',415835,'[{16050001,4,12}]','[{100,[{16050001,229893}]}]'),(6,246,264,'[{2,145721},{8,5465}]',418971,'[{16050001,4,12}]','[{100,[{16050001,229977}]}]'),(6,247,264,'[{2,146828},{8,5507}]',422178,'[{16050001,4,12}]','[{100,[{16050001,230065}]}]'),(6,248,264,'[{2,147935},{8,5548}]',425335,'[{16050001,4,12}]','[{100,[{16050001,230153}]}]'),(6,249,264,'[{2,149042},{8,5590}]',428542,'[{16050001,4,12}]','[{100,[{16050001,230241}]}]'),(6,250,264,'[{2,150149},{8,5631}]',431699,'[{16050001,4,12}]','[{100,[{16050001,230329}]}]'),(6,251,264,'[{2,151256},{8,5673}]',434906,'[{16050001,4,12}]','[{100,[{16050001,230417}]}]'),(6,252,264,'[{2,152383},{8,5715}]',438133,'[{16050001,4,12}]','[{100,[{16050001,230505}]}]'),(6,253,264,'[{2,153510},{8,5757}]',441360,'[{16050001,4,12}]','[{100,[{16050001,230593}]}]'),(6,254,264,'[{2,154638},{8,5799}]',444588,'[{16050001,4,12}]','[{100,[{16050001,230681}]}]'),(6,255,264,'[{2,155765},{8,5842}]',447865,'[{16050001,4,12}]','[{100,[{16050001,230769}]}]'),(6,256,264,'[{2,156892},{8,5884}]',451092,'[{16050001,4,12}]','[{100,[{16050001,230857}]}]'),(6,257,264,'[{2,158040},{8,5927}]',454390,'[{16050001,4,12}]','[{100,[{16050001,230945}]}]'),(6,258,276,'[{2,159188},{8,5970}]',457688,'[{16050001,4,12}]','[{100,[{16050001,231033}]}]'),(6,259,276,'[{2,160336},{8,6013}]',460986,'[{16050001,4,12}]','[{100,[{16050001,231125}]}]'),(6,260,276,'[{2,161484},{8,6056}]',464284,'[{16050001,4,12}]','[{100,[{16050001,231217}]}]'),(6,261,276,'[{2,162632},{8,6099}]',467582,'[{16050001,4,12}]','[{100,[{16050001,231309}]}]'),(6,262,276,'[{2,163800},{8,6143}]',470950,'[{16050001,4,12}]','[{100,[{16050001,231401}]}]'),(6,263,276,'[{2,164969},{8,6187}]',474319,'[{16050001,4,12}]','[{100,[{16050001,231493}]}]'),(6,264,276,'[{2,166137},{8,6231}]',477687,'[{16050001,4,12}]','[{100,[{16050001,231585}]}]'),(6,265,276,'[{2,167305},{8,6274}]',481005,'[{16050001,4,12}]','[{100,[{16050001,231677}]}]'),(6,266,276,'[{2,168474},{8,6318}]',484374,'[{16050001,4,12}]','[{100,[{16050001,231769}]}]'),(6,267,276,'[{2,169663},{8,6363}]',487813,'[{16050001,4,12}]','[{100,[{16050001,231861}]}]'),(6,268,276,'[{2,170852},{8,6407}]',491202,'[{16050001,4,12}]','[{100,[{16050001,231953}]}]'),(6,269,276,'[{2,172041},{8,6452}]',494641,'[{16050001,4,12}]','[{100,[{16050001,232045}]}]'),(6,270,288,'[{2,173229},{8,6497}]',498079,'[{16050001,4,12}]','[{100,[{16050001,232137}]}]'),(6,271,288,'[{2,174418},{8,6541}]',501468,'[{16050001,4,12}]','[{100,[{16050001,232233}]}]'),(6,272,288,'[{2,175628},{8,6587}]',504978,'[{16050001,4,12}]','[{100,[{16050001,232329}]}]'),(6,273,288,'[{2,176837},{8,6632}]',508437,'[{16050001,4,12}]','[{100,[{16050001,232425}]}]'),(6,274,288,'[{2,178046},{8,6677}]',511896,'[{16050001,4,12}]','[{100,[{16050001,232521}]}]'),(6,275,288,'[{2,179256},{8,6723}]',515406,'[{16050001,4,12}]','[{100,[{16050001,232617}]}]'),(6,276,288,'[{2,180465},{8,6768}]',518865,'[{16050001,4,12}]','[{100,[{16050001,232713}]}]'),(6,277,288,'[{2,181695},{8,6814}]',522395,'[{16050001,4,12}]','[{100,[{16050001,232809}]}]'),(6,278,288,'[{2,182925},{8,6860}]',525925,'[{16050001,4,12}]','[{100,[{16050001,232905}]}]'),(6,279,288,'[{2,184155},{8,6906}]',529455,'[{16050001,4,12}]','[{100,[{16050001,233001}]}]'),(6,280,288,'[{2,185385},{8,6952}]',532985,'[{16050001,4,12}]','[{100,[{16050001,233097}]}]'),(6,281,288,'[{2,186615},{8,6999}]',536565,'[{16050001,4,12}]','[{100,[{16050001,233193}]}]'),(6,282,300,'[{2,187865},{8,7045}]',540115,'[{16050001,4,12}]','[{100,[{16050001,233289}]}]'),(6,283,300,'[{2,189115},{8,7092}]',543715,'[{16050001,4,12}]','[{100,[{16050001,233389}]}]'),(6,284,300,'[{2,190366},{8,7139}]',547316,'[{16050001,4,12}]','[{100,[{16050001,233489}]}]'),(6,285,300,'[{2,191616},{8,7186}]',550916,'[{16050001,4,12}]','[{100,[{16050001,233589}]}]'),(6,286,300,'[{2,192867},{8,7233}]',554517,'[{16050001,4,12}]','[{100,[{16050001,233689}]}]'),(6,287,300,'[{2,194137},{8,7281}]',558187,'[{16050001,4,12}]','[{100,[{16050001,233789}]}]'),(6,288,300,'[{2,195408},{8,7328}]',561808,'[{16050001,4,12}]','[{100,[{16050001,233889}]}]'),(6,289,300,'[{2,196679},{8,7376}]',565479,'[{16050001,4,12}]','[{100,[{16050001,233989}]}]'),(6,290,300,'[{2,197950},{8,7424}]',569150,'[{16050001,4,12}]','[{100,[{16050001,234089}]}]'),(6,291,300,'[{2,199221},{8,7471}]',572771,'[{16050001,4,12}]','[{100,[{16050001,234189}]}]'),(6,292,300,'[{2,200512},{8,7520}]',576512,'[{16050001,4,12}]','[{100,[{16050001,234289}]}]'),(6,293,300,'[{2,201804},{8,7568}]',580204,'[{16050001,4,12}]','[{100,[{16050001,234389}]}]'),(6,294,312,'[{2,203095},{8,7617}]',583945,'[{16050001,4,12}]','[{100,[{16050001,234489}]}]'),(6,295,312,'[{2,204386},{8,7665}]',587636,'[{16050001,4,12}]','[{100,[{16050001,234593}]}]'),(6,296,312,'[{2,205678},{8,7713}]',591328,'[{16050001,4,12}]','[{100,[{16050001,234697}]}]'),(6,297,312,'[{2,206990},{8,7763}]',595140,'[{16050001,4,12}]','[{100,[{16050001,234801}]}]'),(6,298,312,'[{2,208302},{8,7812}]',598902,'[{16050001,4,12}]','[{100,[{16050001,234905}]}]'),(6,299,312,'[{2,209613},{8,7861}]',602663,'[{16050001,4,12}]','[{100,[{16050001,235009}]}]'),(6,300,312,'[{2,210925},{8,7910}]',606425,'[{16050001,4,12}]','[{100,[{16050001,235113}]}]'),(6,301,315,'[{2,212237},{8,7959}]',610187,'[{16050001,5,15}]','[{100,[{16050001,235217}]}]'),(6,302,315,'[{2,213570},{8,8009}]',614020,'[{16050001,5,15}]','[{100,[{16050001,235322}]}]'),(6,303,315,'[{2,214902},{8,8059}]',617852,'[{16050001,5,15}]','[{100,[{16050001,235427}]}]'),(6,304,315,'[{2,216234},{8,8109}]',621684,'[{16050001,5,15}]','[{100,[{16050001,235532}]}]'),(6,305,315,'[{2,217567},{8,8159}]',625517,'[{16050001,5,15}]','[{100,[{16050001,235637}]}]'),(6,306,315,'[{2,218899},{8,8209}]',629349,'[{16050001,5,15}]','[{100,[{16050001,235742}]}]'),(6,307,315,'[{2,220252},{8,8260}]',633252,'[{16050001,5,15}]','[{100,[{16050001,235847}]}]'),(6,308,315,'[{2,221605},{8,8311}]',637155,'[{16050001,5,15}]','[{100,[{16050001,235952}]}]'),(6,309,330,'[{2,222958},{8,8361}]',641008,'[{16050001,5,15}]','[{100,[{16050001,236057}]}]'),(6,310,330,'[{2,224311},{8,8412}]',644911,'[{16050001,5,15}]','[{100,[{16050001,236167}]}]'),(6,311,330,'[{2,225663},{8,8463}]',648813,'[{16050001,5,15}]','[{100,[{16050001,236277}]}]'),(6,312,330,'[{2,227037},{8,8514}]',652737,'[{16050001,5,15}]','[{100,[{16050001,236387}]}]'),(6,313,330,'[{2,228410},{8,8566}]',656710,'[{16050001,5,15}]','[{100,[{16050001,236497}]}]'),(6,314,330,'[{2,229784},{8,8617}]',660634,'[{16050001,5,15}]','[{100,[{16050001,236607}]}]'),(6,315,330,'[{2,231157},{8,8669}]',664607,'[{16050001,5,15}]','[{100,[{16050001,236717}]}]'),(6,316,330,'[{2,232530},{8,8720}]',668530,'[{16050001,5,15}]','[{100,[{16050001,236827}]}]'),(6,317,330,'[{2,233924},{8,8773}]',672574,'[{16050001,5,15}]','[{100,[{16050001,236937}]}]'),(6,318,330,'[{2,235318},{8,8825}]',676568,'[{16050001,5,15}]','[{100,[{16050001,237047}]}]'),(6,319,330,'[{2,236712},{8,8877}]',680562,'[{16050001,5,15}]','[{100,[{16050001,237157}]}]'),(6,320,330,'[{2,238106},{8,8929}]',684556,'[{16050001,5,15}]','[{100,[{16050001,237267}]}]'),(6,321,330,'[{2,239500},{8,8982}]',688600,'[{16050001,5,15}]','[{100,[{16050001,237377}]}]'),(6,322,330,'[{2,240914},{8,9035}]',692664,'[{16050001,5,15}]','[{100,[{16050001,237487}]}]'),(6,323,330,'[{2,242328},{8,9088}]',696728,'[{16050001,5,15}]','[{100,[{16050001,237597}]}]'),(6,324,345,'[{2,243743},{8,9141}]',700793,'[{16050001,5,15}]','[{100,[{16050001,237707}]}]'),(6,325,345,'[{2,245157},{8,9194}]',704857,'[{16050001,5,15}]','[{100,[{16050001,237822}]}]'),(6,326,345,'[{2,246571},{8,9247}]',708921,'[{16050001,5,15}]','[{100,[{16050001,237937}]}]'),(6,327,345,'[{2,248006},{8,9301}]',713056,'[{16050001,5,15}]','[{100,[{16050001,238052}]}]'),(6,328,345,'[{2,249441},{8,9355}]',717191,'[{16050001,5,15}]','[{100,[{16050001,238167}]}]'),(6,329,345,'[{2,250876},{8,9408}]',721276,'[{16050001,5,15}]','[{100,[{16050001,238282}]}]'),(6,330,345,'[{2,252311},{8,9462}]',725411,'[{16050001,5,15}]','[{100,[{16050001,238397}]}]'),(6,331,345,'[{2,253746},{8,9516}]',729546,'[{16050001,5,15}]','[{100,[{16050001,238512}]}]'),(6,332,345,'[{2,255201},{8,9571}]',733751,'[{16050001,5,15}]','[{100,[{16050001,238627}]}]'),(6,333,345,'[{2,256656},{8,9625}]',737906,'[{16050001,5,15}]','[{100,[{16050001,238742}]}]'),(6,334,345,'[{2,258112},{8,9680}]',742112,'[{16050001,5,15}]','[{100,[{16050001,238857}]}]'),(6,335,345,'[{2,259567},{8,9734}]',746267,'[{16050001,5,15}]','[{100,[{16050001,238972}]}]'),(6,336,345,'[{2,261023},{8,9789}]',750473,'[{16050001,5,15}]','[{100,[{16050001,239087}]}]'),(6,337,345,'[{2,262498},{8,9844}]',754698,'[{16050001,5,15}]','[{100,[{16050001,239202}]}]'),(6,338,345,'[{2,263974},{8,9900}]',758974,'[{16050001,5,15}]','[{100,[{16050001,239317}]}]'),(6,339,360,'[{2,265450},{8,9955}]',763200,'[{16050001,5,15}]','[{100,[{16050001,239432}]}]'),(6,340,360,'[{2,266926},{8,10010}]',767426,'[{16050001,5,15}]','[{100,[{16050001,239552}]}]'),(6,341,360,'[{2,268402},{8,10066}]',771702,'[{16050001,5,15}]','[{100,[{16050001,239672}]}]'),(6,342,360,'[{2,269898},{8,10122}]',775998,'[{16050001,5,15}]','[{100,[{16050001,239792}]}]'),(6,343,360,'[{2,271395},{8,10178}]',780295,'[{16050001,5,15}]','[{100,[{16050001,239912}]}]'),(6,344,360,'[{2,272891},{8,10234}]',784591,'[{16050001,5,15}]','[{100,[{16050001,240032}]}]'),(6,345,360,'[{2,274387},{8,10290}]',788887,'[{16050001,5,15}]','[{100,[{16050001,240152}]}]'),(6,346,360,'[{2,275884},{8,10346}]',793184,'[{16050001,5,15}]','[{100,[{16050001,240272}]}]'),(6,347,360,'[{2,277400},{8,10403}]',797550,'[{16050001,5,15}]','[{100,[{16050001,240392}]}]'),(6,348,360,'[{2,278917},{8,10460}]',801917,'[{16050001,5,15}]','[{100,[{16050001,240512}]}]'),(6,349,360,'[{2,280434},{8,10517}]',806284,'[{16050001,5,15}]','[{100,[{16050001,240632}]}]'),(6,350,360,'[{2,281951},{8,10574}]',810651,'[{16050001,5,15}]','[{100,[{16050001,240752}]}]'),(6,351,360,'[{2,283468},{8,10631}]',815018,'[{16050001,5,15}]','[{100,[{16050001,240872}]}]'),(6,352,360,'[{2,285005},{8,10688}]',819405,'[{16050001,5,15}]','[{100,[{16050001,240992}]}]'),(6,353,360,'[{2,286543},{8,10746}]',823843,'[{16050001,5,15}]','[{100,[{16050001,241112}]}]'),(6,354,375,'[{2,288080},{8,10803}]',828230,'[{16050001,5,15}]','[{100,[{16050001,241232}]}]'),(6,355,375,'[{2,289617},{8,10861}]',832667,'[{16050001,5,15}]','[{100,[{16050001,241357}]}]'),(6,356,375,'[{2,291155},{8,10919}]',837105,'[{16050001,5,15}]','[{100,[{16050001,241482}]}]'),(6,357,375,'[{2,292712},{8,10977}]',841562,'[{16050001,5,15}]','[{100,[{16050001,241607}]}]'),(6,358,375,'[{2,294270},{8,11036}]',846070,'[{16050001,5,15}]','[{100,[{16050001,241732}]}]'),(6,359,375,'[{2,295828},{8,11094}]',850528,'[{16050001,5,15}]','[{100,[{16050001,241857}]}]'),(6,360,375,'[{2,297386},{8,11152}]',854986,'[{16050001,5,15}]','[{100,[{16050001,241982}]}]'),(6,361,375,'[{2,298944},{8,11211}]',859494,'[{16050001,5,15}]','[{100,[{16050001,242107}]}]'),(6,362,375,'[{2,300522},{8,11270}]',864022,'[{16050001,5,15}]','[{100,[{16050001,242232}]}]'),(6,363,375,'[{2,302101},{8,11329}]',868551,'[{16050001,5,15}]','[{100,[{16050001,242357}]}]'),(6,364,375,'[{2,303679},{8,11388}]',873079,'[{16050001,5,15}]','[{100,[{16050001,242482}]}]'),(6,365,375,'[{2,305257},{8,11448}]',877657,'[{16050001,5,15}]','[{100,[{16050001,242607}]}]'),(6,366,375,'[{2,306836},{8,11507}]',882186,'[{16050001,5,15}]','[{100,[{16050001,242732}]}]'),(6,367,375,'[{2,308434},{8,11567}]',886784,'[{16050001,5,15}]','[{100,[{16050001,242857}]}]'),(6,368,375,'[{2,310033},{8,11627}]',891383,'[{16050001,5,15}]','[{100,[{16050001,242982}]}]'),(6,369,390,'[{2,311632},{8,11687}]',895982,'[{16050001,5,15}]','[{100,[{16050001,243107}]}]'),(6,370,390,'[{2,313231},{8,11747}]',900581,'[{16050001,5,15}]','[{100,[{16050001,243237}]}]'),(6,371,390,'[{2,314830},{8,11807}]',905180,'[{16050001,5,15}]','[{100,[{16050001,243367}]}]'),(6,372,390,'[{2,316449},{8,11867}]',909799,'[{16050001,5,15}]','[{100,[{16050001,243497}]}]'),(6,373,390,'[{2,318069},{8,11928}]',914469,'[{16050001,5,15}]','[{100,[{16050001,243627}]}]'),(6,374,390,'[{2,319688},{8,11989}]',919138,'[{16050001,5,15}]','[{100,[{16050001,243757}]}]'),(6,375,390,'[{2,321307},{8,12050}]',923807,'[{16050001,5,15}]','[{100,[{16050001,243887}]}]'),(6,376,390,'[{2,322927},{8,12110}]',928427,'[{16050001,5,15}]','[{100,[{16050001,244017}]}]'),(6,377,390,'[{2,324566},{8,12172}]',933166,'[{16050001,5,15}]','[{100,[{16050001,244147}]}]'),(6,378,390,'[{2,326206},{8,12233}]',937856,'[{16050001,5,15}]','[{100,[{16050001,244277}]}]'),(6,379,390,'[{2,327846},{8,12295}]',942596,'[{16050001,5,15}]','[{100,[{16050001,244407}]}]'),(6,380,390,'[{2,329486},{8,12356}]',947286,'[{16050001,5,15}]','[{100,[{16050001,244537}]}]'),(6,381,390,'[{2,331126},{8,12418}]',952026,'[{16050001,5,15}]','[{100,[{16050001,244667}]}]'),(6,382,390,'[{2,332786},{8,12480}]',956786,'[{16050001,5,15}]','[{100,[{16050001,244797}]}]'),(6,383,390,'[{2,334446},{8,12542}]',961546,'[{16050001,5,15}]','[{100,[{16050001,244927}]}]'),(6,384,405,'[{2,336107},{8,12604}]',966307,'[{16050001,5,15}]','[{100,[{16050001,245057}]}]'),(6,385,405,'[{2,337767},{8,12667}]',971117,'[{16050001,5,15}]','[{100,[{16050001,245192}]}]'),(6,386,405,'[{2,339428},{8,12729}]',975878,'[{16050001,5,15}]','[{100,[{16050001,245327}]}]'),(6,387,405,'[{2,341108},{8,12792}]',980708,'[{16050001,5,15}]','[{100,[{16050001,245462}]}]'),(6,388,405,'[{2,342789},{8,12855}]',985539,'[{16050001,5,15}]','[{100,[{16050001,245597}]}]'),(6,389,405,'[{2,344470},{8,12918}]',990370,'[{16050001,5,15}]','[{100,[{16050001,245732}]}]'),(6,390,405,'[{2,346151},{8,12981}]',995201,'[{16050001,5,15}]','[{100,[{16050001,245867}]}]'),(6,391,405,'[{2,347832},{8,13044}]',1000032,'[{16050001,5,15}]','[{100,[{16050001,246002}]}]'),(6,392,405,'[{2,349533},{8,13108}]',1004933,'[{16050001,5,15}]','[{100,[{16050001,246137}]}]'),(6,393,405,'[{2,351234},{8,13172}]',1009834,'[{16050001,5,15}]','[{100,[{16050001,246272}]}]'),(6,394,405,'[{2,352936},{8,13236}]',1014736,'[{16050001,5,15}]','[{100,[{16050001,246407}]}]'),(6,395,405,'[{2,354637},{8,13299}]',1019587,'[{16050001,5,15}]','[{100,[{16050001,246542}]}]'),(6,396,405,'[{2,356338},{8,13363}]',1024488,'[{16050001,5,15}]','[{100,[{16050001,246677}]}]'),(6,397,405,'[{2,358060},{8,13428}]',1029460,'[{16050001,5,15}]','[{100,[{16050001,246812}]}]'),(6,398,405,'[{2,359782},{8,13492}]',1034382,'[{16050001,5,15}]','[{100,[{16050001,246947}]}]'),(6,399,420,'[{2,361504},{8,13557}]',1039354,'[{16050001,5,15}]','[{100,[{16050001,247082}]}]'),(6,400,420,'[{2,363226},{8,13621}]',1044276,'[{16050001,5,15}]','[{100,[{16050001,247222}]}]'),(6,401,414,'[{2,364948},{8,13686}]',1049248,'[{16050001,6,18}]','[{100,[{16050001,247362}]}]'),(6,402,414,'[{2,366690},{8,13751}]',1054240,'[{16050001,6,18}]','[{100,[{16050001,247500}]}]'),(6,403,414,'[{2,368432},{8,13817}]',1059282,'[{16050001,6,18}]','[{100,[{16050001,247638}]}]'),(6,404,414,'[{2,370175},{8,13882}]',1064275,'[{16050001,6,18}]','[{100,[{16050001,247776}]}]'),(6,405,414,'[{2,371917},{8,13947}]',1069267,'[{16050001,6,18}]','[{100,[{16050001,247914}]}]'),(6,406,414,'[{2,373659},{8,14013}]',1074309,'[{16050001,6,18}]','[{100,[{16050001,248052}]}]'),(6,407,414,'[{2,375422},{8,14079}]',1079372,'[{16050001,6,18}]','[{100,[{16050001,248190}]}]'),(6,408,432,'[{2,377185},{8,14145}]',1084435,'[{16050001,6,18}]','[{100,[{16050001,248328}]}]'),(6,409,432,'[{2,378948},{8,14211}]',1089498,'[{16050001,6,18}]','[{100,[{16050001,248472}]}]'),(6,410,432,'[{2,380711},{8,14277}]',1094561,'[{16050001,6,18}]','[{100,[{16050001,248616}]}]'),(6,411,432,'[{2,382473},{8,14343}]',1099623,'[{16050001,6,18}]','[{100,[{16050001,248760}]}]'),(6,412,432,'[{2,384257},{8,14410}]',1104757,'[{16050001,6,18}]','[{100,[{16050001,248904}]}]'),(6,413,432,'[{2,386040},{8,14477}]',1109890,'[{16050001,6,18}]','[{100,[{16050001,249048}]}]'),(6,414,432,'[{2,387823},{8,14544}]',1115023,'[{16050001,6,18}]','[{100,[{16050001,249192}]}]'),(6,415,432,'[{2,389607},{8,14611}]',1120157,'[{16050001,6,18}]','[{100,[{16050001,249336}]}]'),(6,416,432,'[{2,391390},{8,14678}]',1125290,'[{16050001,6,18}]','[{100,[{16050001,249480}]}]'),(6,417,432,'[{2,393194},{8,14745}]',1130444,'[{16050001,6,18}]','[{100,[{16050001,249624}]}]'),(6,418,432,'[{2,394998},{8,14813}]',1135648,'[{16050001,6,18}]','[{100,[{16050001,249768}]}]'),(6,419,432,'[{2,396802},{8,14881}]',1140852,'[{16050001,6,18}]','[{100,[{16050001,249912}]}]'),(6,420,432,'[{2,398605},{8,14948}]',1146005,'[{16050001,6,18}]','[{100,[{16050001,250056}]}]'),(6,421,432,'[{2,400409},{8,15016}]',1151209,'[{16050001,6,18}]','[{100,[{16050001,250200}]}]'),(6,422,432,'[{2,402234},{8,15084}]',1156434,'[{16050001,6,18}]','[{100,[{16050001,250344}]}]'),(6,423,432,'[{2,404058},{8,15153}]',1161708,'[{16050001,6,18}]','[{100,[{16050001,250488}]}]'),(6,424,432,'[{2,405882},{8,15221}]',1166932,'[{16050001,6,18}]','[{100,[{16050001,250632}]}]'),(6,425,432,'[{2,407706},{8,15289}]',1172156,'[{16050001,6,18}]','[{100,[{16050001,250776}]}]'),(6,426,450,'[{2,409531},{8,15358}]',1177431,'[{16050001,6,18}]','[{100,[{16050001,250920}]}]'),(6,427,450,'[{2,411376},{8,15427}]',1182726,'[{16050001,6,18}]','[{100,[{16050001,251070}]}]'),(6,428,450,'[{2,413220},{8,15496}]',1188020,'[{16050001,6,18}]','[{100,[{16050001,251220}]}]'),(6,429,450,'[{2,415065},{8,15565}]',1193315,'[{16050001,6,18}]','[{100,[{16050001,251370}]}]'),(6,430,450,'[{2,416910},{8,15635}]',1198660,'[{16050001,6,18}]','[{100,[{16050001,251520}]}]'),(6,431,450,'[{2,418755},{8,15704}]',1203955,'[{16050001,6,18}]','[{100,[{16050001,251670}]}]'),(6,432,450,'[{2,420620},{8,15774}]',1209320,'[{16050001,6,18}]','[{100,[{16050001,251820}]}]'),(6,433,450,'[{2,422486},{8,15844}]',1214686,'[{16050001,6,18}]','[{100,[{16050001,251970}]}]'),(6,434,450,'[{2,424351},{8,15914}]',1220051,'[{16050001,6,18}]','[{100,[{16050001,252120}]}]'),(6,435,450,'[{2,426216},{8,15984}]',1225416,'[{16050001,6,18}]','[{100,[{16050001,252270}]}]'),(6,436,450,'[{2,428082},{8,16054}]',1230782,'[{16050001,6,18}]','[{100,[{16050001,252420}]}]'),(6,437,450,'[{2,429967},{8,16124}]',1236167,'[{16050001,6,18}]','[{100,[{16050001,252570}]}]'),(6,438,450,'[{2,431853},{8,16195}]',1241603,'[{16050001,6,18}]','[{100,[{16050001,252720}]}]'),(6,439,450,'[{2,433739},{8,16266}]',1247039,'[{16050001,6,18}]','[{100,[{16050001,252870}]}]'),(6,440,450,'[{2,435625},{8,16336}]',1252425,'[{16050001,6,18}]','[{100,[{16050001,253020}]}]'),(6,441,450,'[{2,437511},{8,16407}]',1257861,'[{16050001,6,18}]','[{100,[{16050001,253170}]}]'),(6,442,450,'[{2,439417},{8,16479}]',1263367,'[{16050001,6,18}]','[{100,[{16050001,253320}]}]'),(6,443,450,'[{2,441323},{8,16550}]',1268823,'[{16050001,6,18}]','[{100,[{16050001,253470}]}]'),(6,444,468,'[{2,443230},{8,16622}]',1274330,'[{16050001,6,18}]','[{100,[{16050001,253620}]}]'),(6,445,468,'[{2,445136},{8,16693}]',1279786,'[{16050001,6,18}]','[{100,[{16050001,253776}]}]'),(6,446,468,'[{2,447042},{8,16765}]',1285292,'[{16050001,6,18}]','[{100,[{16050001,253932}]}]'),(6,447,468,'[{2,448969},{8,16837}]',1290819,'[{16050001,6,18}]','[{100,[{16050001,254088}]}]'),(6,448,468,'[{2,450896},{8,16909}]',1296346,'[{16050001,6,18}]','[{100,[{16050001,254244}]}]'),(6,449,468,'[{2,452823},{8,16981}]',1301873,'[{16050001,6,18}]','[{100,[{16050001,254400}]}]'),(6,450,468,'[{2,454749},{8,17054}]',1307449,'[{16050001,6,18}]','[{100,[{16050001,254556}]}]'),(6,451,468,'[{2,456676},{8,17126}]',1312976,'[{16050001,6,18}]','[{100,[{16050001,254712}]}]'),(6,452,468,'[{2,458624},{8,17199}]',1318574,'[{16050001,6,18}]','[{100,[{16050001,254868}]}]'),(6,453,468,'[{2,460571},{8,17272}]',1324171,'[{16050001,6,18}]','[{100,[{16050001,255024}]}]'),(6,454,468,'[{2,462518},{8,17345}]',1329768,'[{16050001,6,18}]','[{100,[{16050001,255180}]}]'),(6,455,468,'[{2,464466},{8,17418}]',1335366,'[{16050001,6,18}]','[{100,[{16050001,255336}]}]'),(6,456,468,'[{2,466413},{8,17491}]',1340963,'[{16050001,6,18}]','[{100,[{16050001,255492}]}]'),(6,457,468,'[{2,468381},{8,17565}]',1346631,'[{16050001,6,18}]','[{100,[{16050001,255648}]}]'),(6,458,468,'[{2,470348},{8,17639}]',1352298,'[{16050001,6,18}]','[{100,[{16050001,255804}]}]'),(6,459,468,'[{2,472316},{8,17712}]',1357916,'[{16050001,6,18}]','[{100,[{16050001,255960}]}]'),(6,460,468,'[{2,474284},{8,17786}]',1363584,'[{16050001,6,18}]','[{100,[{16050001,256116}]}]'),(6,461,468,'[{2,476252},{8,17860}]',1369252,'[{16050001,6,18}]','[{100,[{16050001,256272}]}]'),(6,462,486,'[{2,478240},{8,17934}]',1374940,'[{16050001,6,18}]','[{100,[{16050001,256428}]}]'),(6,463,486,'[{2,480229},{8,18009}]',1380679,'[{16050001,6,18}]','[{100,[{16050001,256590}]}]'),(6,464,486,'[{2,482217},{8,18084}]',1386417,'[{16050001,6,18}]','[{100,[{16050001,256752}]}]'),(6,465,486,'[{2,484205},{8,18158}]',1392105,'[{16050001,6,18}]','[{100,[{16050001,256914}]}]'),(6,466,486,'[{2,486193},{8,18233}]',1397843,'[{16050001,6,18}]','[{100,[{16050001,257076}]}]'),(6,467,486,'[{2,488202},{8,18308}]',1403602,'[{16050001,6,18}]','[{100,[{16050001,257238}]}]'),(6,468,486,'[{2,490211},{8,18383}]',1409361,'[{16050001,6,18}]','[{100,[{16050001,257400}]}]'),(6,469,486,'[{2,492220},{8,18459}]',1415170,'[{16050001,6,18}]','[{100,[{16050001,257562}]}]'),(6,470,486,'[{2,494229},{8,18534}]',1420929,'[{16050001,6,18}]','[{100,[{16050001,257724}]}]'),(6,471,486,'[{2,496238},{8,18609}]',1426688,'[{16050001,6,18}]','[{100,[{16050001,257886}]}]'),(6,472,486,'[{2,498267},{8,18685}]',1432517,'[{16050001,6,18}]','[{100,[{16050001,258048}]}]'),(6,473,486,'[{2,500296},{8,18762}]',1438396,'[{16050001,6,18}]','[{100,[{16050001,258210}]}]'),(6,474,486,'[{2,502325},{8,18838}]',1444225,'[{16050001,6,18}]','[{100,[{16050001,258372}]}]'),(6,475,486,'[{2,504355},{8,18914}]',1450055,'[{16050001,6,18}]','[{100,[{16050001,258534}]}]'),(6,476,486,'[{2,506384},{8,18990}]',1455884,'[{16050001,6,18}]','[{100,[{16050001,258696}]}]'),(6,477,486,'[{2,508434},{8,19067}]',1461784,'[{16050001,6,18}]','[{100,[{16050001,258858}]}]'),(6,478,486,'[{2,510484},{8,19144}]',1467684,'[{16050001,6,18}]','[{100,[{16050001,259020}]}]'),(6,479,486,'[{2,512533},{8,19220}]',1473533,'[{16050001,6,18}]','[{100,[{16050001,259182}]}]'),(6,480,504,'[{2,514583},{8,19297}]',1479433,'[{16050001,6,18}]','[{100,[{16050001,259344}]}]'),(6,481,504,'[{2,516633},{8,19374}]',1485333,'[{16050001,6,18}]','[{100,[{16050001,259512}]}]'),(6,482,504,'[{2,518703},{8,19452}]',1491303,'[{16050001,6,18}]','[{100,[{16050001,259680}]}]'),(6,483,504,'[{2,520774},{8,19529}]',1497224,'[{16050001,6,18}]','[{100,[{16050001,259848}]}]'),(6,484,504,'[{2,522844},{8,19607}]',1503194,'[{16050001,6,18}]','[{100,[{16050001,260016}]}]'),(6,485,504,'[{2,524914},{8,19685}]',1509164,'[{16050001,6,18}]','[{100,[{16050001,260184}]}]'),(6,486,504,'[{2,526985},{8,19762}]',1515085,'[{16050001,6,18}]','[{100,[{16050001,260352}]}]'),(6,487,504,'[{2,529075},{8,19841}]',1521125,'[{16050001,6,18}]','[{100,[{16050001,260520}]}]'),(6,488,504,'[{2,531166},{8,19919}]',1527116,'[{16050001,6,18}]','[{100,[{16050001,260688}]}]'),(6,489,504,'[{2,533257},{8,19998}]',1533157,'[{16050001,6,18}]','[{100,[{16050001,260856}]}]'),(6,490,504,'[{2,535348},{8,20076}]',1539148,'[{16050001,6,18}]','[{100,[{16050001,261024}]}]'),(6,491,504,'[{2,537439},{8,20154}]',1545139,'[{16050001,6,18}]','[{100,[{16050001,261192}]}]'),(6,492,504,'[{2,539550},{8,20234}]',1551250,'[{16050001,6,18}]','[{100,[{16050001,261360}]}]'),(6,493,504,'[{2,541661},{8,20313}]',1557311,'[{16050001,6,18}]','[{100,[{16050001,261528}]}]'),(6,494,504,'[{2,543772},{8,20392}]',1563372,'[{16050001,6,18}]','[{100,[{16050001,261696}]}]'),(6,495,504,'[{2,545884},{8,20471}]',1569434,'[{16050001,6,18}]','[{100,[{16050001,261864}]}]'),(6,496,504,'[{2,547995},{8,20550}]',1575495,'[{16050001,6,18}]','[{100,[{16050001,262032}]}]'),(6,497,504,'[{2,550127},{8,20630}]',1581627,'[{16050001,6,18}]','[{100,[{16050001,262200}]}]'),(6,498,522,'[{2,552259},{8,20710}]',1587759,'[{16050001,6,18}]','[{100,[{16050001,262368}]}]'),(6,499,522,'[{2,554390},{8,20790}]',1593890,'[{16050001,6,18}]','[{100,[{16050001,262542}]}]'),(6,500,522,'[{2,556522},{8,20870}]',1600022,'[]','[{100,[{16050001,262716}]}]');
/*!40000 ALTER TABLE `base_mount_equip_lv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_mount_equip_make`
--

DROP TABLE IF EXISTS `base_mount_equip_make`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_mount_equip_make` (
  `quality` tinyint(3) unsigned NOT NULL COMMENT '品质',
  `star` tinyint(3) unsigned NOT NULL COMMENT '星数',
  `make_type_num` tinyint(3) unsigned NOT NULL COMMENT '打造方法数量',
  `cost` varchar(255) NOT NULL COMMENT '消耗',
  `extra_cost` varchar(255) NOT NULL COMMENT '额外消耗',
  `result` varchar(255) NOT NULL COMMENT '结果',
  `tips` varchar(255) NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`quality`,`star`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='坐骑装备打造配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_mount_equip_make`
--

LOCK TABLES `base_mount_equip_make` WRITE;
/*!40000 ALTER TABLE `base_mount_equip_make` DISABLE KEYS */;
INSERT INTO `base_mount_equip_make` VALUES (0,0,2,'[{1,[{0,16050001,7},{0,16060001,2}]},{2,[{0,16050001,4},{0,16060001,1}]}]','[{1,[]},{2,[{0,16060002,1}]}]','[{1,[{100,{0,0}},{851,{0,1}},{48,{0,2}}]},{2,[{1000,{0,1}}]}]','[{1,[晋升概率85%]},{2,[兽灵萤石打造100%晋级装备]}]'),(0,1,2,'[{1,[{0,16050001,9},{0,16060001,2}]},{2,[{0,16050001,5},{0,16060001,1}]}]','[{1,[]},{2,[{0,16060002,1}]}]','[{1,[{10,{0,0}},{100,{0,1}},{843,{0,2}},{47,{0,3}}]},{2,[{1000,{0,2}}]}]','[{1,[晋升概率84%]},{2,[兽灵萤石打造100%晋级装备]}]'),(0,2,2,'[{1,[{0,16050001,12},{0,16060001,3}]},{2,[{0,16050001,6},{0,16060001,2}]}]','[{1,[]},{2,[{0,16060002,1}]}]','[{1,[{15,{0,1}},{100,{0,2}},{839,{0,3}},{45,{0,4}}]},{2,[{1000,{0,3}}]}]','[{1,[晋升概率84%]},{2,[兽灵萤石打造100%晋级装备]}]'),(0,3,2,'[{1,[{0,16050001,14},{0,16060001,3}]},{2,[{0,16050001,7},{0,16060001,2}]}]','[{1,[]},{2,[{0,16060002,1}]}]','[{1,[{20,{0,2}},{100,{0,3}},{836,{0,4}},{44,{0,5}}]},{2,[{1000,{0,4}}]}]','[{1,[晋升概率84%]},{2,[兽灵萤石打造100%晋级装备]}]'),(0,4,2,'[{1,[{0,16050001,21},{0,16060001,5}]},{2,[{0,16050001,11},{0,16060001,3}]}]','[{1,[]},{2,[{0,16060002,1}]}]','[{1,[{25,{0,3}},{100,{0,4}},{832,{0,5}},{42,{1,0}}]},{2,[{1000,{0,5}}]}]','[{1,[晋升概率83%]},{2,[兽灵萤石打造100%晋级装备]}]'),(0,5,2,'[{1,[{0,16050001,23},{0,16060001,5}]},{2,[{0,16050001,12},{0,16060001,3}]}]','[{1,[]},{2,[{0,16060002,1}]}]','[{1,[{30,{0,4}},{100,{0,5}},{829,{1,0}},{41,{1,1}}]},{2,[{1000,{1,0}}]}]','[{1,[晋升概率83%]},{2,[兽灵萤石打造100%晋级装备]}]'),(1,0,2,'[{1,[{0,16050001,11},{0,16060001,3}]},{2,[{0,16050001,6},{0,16060001,2}]}]','[{1,[]},{2,[{0,16060002,1}]}]','[{1,[{35,{0,5}},{100,{1,0}},{825,{1,1}},{39,{1,2}}]},{2,[{1000,{1,1}}]}]','[{1,[晋升概率83%]},{2,[兽灵萤石打造100%晋级装备]}]'),(1,1,2,'[{1,[{0,16050001,15},{0,16060001,3}]},{2,[{0,16050001,8},{0,16060001,2}]}]','[{1,[]},{2,[{0,16060002,1}]}]','[{1,[{40,{1,0}},{100,{1,1}},{822,{1,2}},{38,{1,3}}]},{2,[{1000,{1,2}}]}]','[{1,[晋升概率82%]},{2,[兽灵萤石打造100%晋级装备]}]'),(1,2,2,'[{1,[{0,16050001,19},{0,16060001,4}]},{2,[{0,16050001,10},{0,16060001,2}]}]','[{1,[]},{2,[{0,16060002,1}]}]','[{1,[{45,{1,1}},{100,{1,2}},{818,{1,3}},{36,{1,4}}]},{2,[{1000,{1,3}}]}]','[{1,[晋升概率82%]},{2,[兽灵萤石打造100%晋级装备]}]'),(1,3,2,'[{1,[{0,16050001,23},{0,16060001,5}]},{2,[{0,16050001,12},{0,16060001,3}]}]','[{1,[]},{2,[{0,16060002,1}]}]','[{1,[{50,{1,2}},{100,{1,3}},{815,{1,4}},{35,{1,5}}]},{2,[{1000,{1,4}}]}]','[{1,[晋升概率82%]},{2,[兽灵萤石打造100%晋级装备]}]'),(1,4,2,'[{1,[{0,16050001,34},{0,16060001,7}]},{2,[{0,16050001,17},{0,16060001,4}]}]','[{1,[]},{2,[{0,16060002,2}]}]','[{1,[{55,{1,3}},{98,{1,4}},{813,{1,5}},{33,{2,0}}]},{2,[{1000,{1,5}}]}]','[{1,[晋升概率81%]},{2,[兽灵萤石打造100%晋级装备]}]'),(1,5,2,'[{1,[{0,16050001,39},{0,16060001,8}]},{2,[{0,16050001,20},{0,16060001,4}]}]','[{1,[]},{2,[{0,16060002,2}]}]','[{1,[{60,{1,4}},{106,{1,5}},{802,{2,0}},{32,{2,1}}]},{2,[{1000,{2,0}}]}]','[{1,[晋升概率80%]},{2,[兽灵萤石打造100%晋级装备]}]'),(2,0,2,'[{1,[{0,16050001,14},{0,16060001,3}]},{2,[{0,16050001,7},{0,16060001,2}]}]','[{1,[]},{2,[{0,16060002,1}]}]','[{1,[{65,{1,5}},{114,{2,0}},{790,{2,1}},{30,{2,2}}]},{2,[{1000,{2,1}}]}]','[{1,[晋升概率79%]},{2,[兽灵萤石打造100%晋级装备]}]'),(2,1,2,'[{1,[{0,16050001,20},{0,16060001,4}]},{2,[{0,16050001,10},{0,16060001,2}]}]','[{1,[]},{2,[{0,16060002,1}]}]','[{1,[{70,{2,0}},{122,{2,1}},{779,{2,2}},{29,{2,3}}]},{2,[{1000,{2,2}}]}]','[{1,[晋升概率78%]},{2,[兽灵萤石打造100%晋级装备]}]'),(2,2,2,'[{1,[{0,16050001,26},{0,16060001,6}]},{2,[{0,16050001,13},{0,16060001,3}]}]','[{1,[]},{2,[{0,16060002,2}]}]','[{1,[{75,{2,1}},{130,{2,2}},{767,{2,3}},{27,{2,4}}]},{2,[{1000,{2,3}}]}]','[{1,[晋升概率77%]},{2,[兽灵萤石打造100%晋级装备]}]'),(2,3,2,'[{1,[{0,16050001,31},{0,16060001,7}]},{2,[{0,16050001,16},{0,16060001,4}]}]','[{1,[]},{2,[{0,16060002,2}]}]','[{1,[{80,{2,2}},{138,{2,3}},{756,{2,4}},{26,{2,5}}]},{2,[{1000,{2,4}}]}]','[{1,[晋升概率76%]},{2,[兽灵萤石打造100%晋级装备]}]'),(2,4,2,'[{1,[{0,16050001,46},{0,16060001,10}]},{2,[{0,16050001,23},{0,16060001,5}]}]','[{1,[]},{2,[{0,16060002,2}]}]','[{1,[{85,{2,3}},{146,{2,4}},{744,{2,5}},{24,{3,0}}]},{2,[{1000,{2,5}}]}]','[{1,[晋升概率74%]},{2,[兽灵萤石打造100%晋级装备]}]'),(2,5,2,'[{1,[{0,16050001,51},{0,16060001,11}]},{2,[{0,16050001,26},{0,16060001,6}]}]','[{1,[]},{2,[{0,16060002,3}]}]','[{1,[{90,{2,4}},{154,{2,5}},{733,{3,0}},{23,{3,1}}]},{2,[{1000,{3,0}}]}]','[{1,[晋升概率73%]},{2,[兽灵萤石打造100%晋级装备]}]'),(3,0,2,'[{1,[{0,16050001,18},{0,16060001,4}]},{2,[{0,16050001,9},{0,16060001,2}]}]','[{1,[]},{2,[{0,16060002,1}]}]','[{1,[{95,{2,5}},{162,{3,0}},{721,{3,1}},{21,{3,2}}]},{2,[{1000,{3,1}}]}]','[{1,[晋升概率72%]},{2,[兽灵萤石打造100%晋级装备]}]'),(3,1,2,'[{1,[{0,16050001,25},{0,16060001,5}]},{2,[{0,16050001,13},{0,16060001,3}]}]','[{1,[]},{2,[{0,16060002,2}]}]','[{1,[{110,{3,0}},{175,{3,1}},{695,{3,2}},{20,{3,3}}]},{2,[{1000,{3,2}}]}]','[{1,[晋升概率70%]},{2,[兽灵萤石打造100%晋级装备]}]'),(3,2,2,'[{1,[{0,16050001,32},{0,16060001,7}]},{2,[{0,16050001,16},{0,16060001,4}]}]','[{1,[]},{2,[{0,16060002,2}]}]','[{1,[{120,{3,1}},{190,{3,2}},{671,{3,3}},{18,{3,4}}]},{2,[{1000,{3,3}}]}]','[{1,[晋升概率67%]},{2,[兽灵萤石打造100%晋级装备]}]'),(3,3,2,'[{1,[{0,16050001,38},{0,16060001,8}]},{2,[{0,16050001,19},{0,16060001,4}]}]','[{1,[]},{2,[{0,16060002,2}]}]','[{1,[{130,{3,2}},{205,{3,3}},{648,{3,4}},{17,{3,5}}]},{2,[{1000,{3,4}}]}]','[{1,[晋升概率65%]},{2,[兽灵萤石打造100%晋级装备]}]'),(3,4,2,'[{1,[{0,16050001,57},{0,16060001,12}]},{2,[{0,16050001,29},{0,16060001,6}]}]','[{1,[]},{2,[{0,16060002,3}]}]','[{1,[{140,{3,3}},{220,{3,4}},{624,{3,5}},{15,{4,0}}]},{2,[{1000,{3,5}}]}]','[{1,[晋升概率62%]},{2,[兽灵萤石打造100%晋级装备]}]'),(3,5,2,'[{1,[{0,16050001,64},{0,16060001,13}]},{2,[{0,16050001,32},{0,16060001,7}]}]','[{1,[]},{2,[{0,16060002,3}]}]','[{1,[{150,{3,4}},{235,{3,5}},{601,{4,0}},{14,{4,1}}]},{2,[{1000,{4,0}}]}]','[{1,[晋升概率60%]},{2,[兽灵萤石打造100%晋级装备]}]'),(4,0,2,'[{1,[{0,16050001,21},{0,16060001,5}]},{2,[{0,16050001,11},{0,16060001,3}]}]','[{1,[]},{2,[{0,16060002,1}]}]','[{1,[{170,{3,5}},{250,{4,0}},{567,{4,1}},{12,{4,2}}]},{2,[{1000,{4,1}}]}]','[{1,[晋升概率57%]},{2,[兽灵萤石打造100%晋级装备]}]'),(4,1,2,'[{1,[{0,16050001,30},{0,16060001,6}]},{2,[{0,16050001,15},{0,16060001,3}]}]','[{1,[]},{2,[{0,16060002,2}]}]','[{1,[{190,{4,0}},{270,{4,1}},{529,{4,2}},{11,{4,3}}]},{2,[{1000,{4,2}}]}]','[{1,[晋升概率53%]},{2,[兽灵萤石打造100%晋级装备]}]'),(4,2,2,'[{1,[{0,16050001,38},{0,16060001,8}]},{2,[{0,16050001,19},{0,16060001,4}]}]','[{1,[]},{2,[{0,16060002,2}]}]','[{1,[{210,{4,1}},{290,{4,2}},{490,{4,3}},{9,{4,4}}]},{2,[{1000,{4,3}}]}]','[{1,[晋升概率49%]},{2,[兽灵萤石打造100%晋级装备]}]'),(4,3,2,'[{1,[{0,16050001,46},{0,16060001,10}]},{2,[{0,16050001,23},{0,16060001,5}]}]','[{1,[]},{2,[{0,16060002,2}]}]','[{1,[{230,{4,2}},{310,{4,3}},{452,{4,4}},{8,{4,5}}]},{2,[{1000,{4,4}}]}]','[{1,[晋升概率45%]},{2,[兽灵萤石打造100%晋级装备]}]'),(4,4,2,'[{1,[{0,16050001,68},{0,16060001,14}]},{2,[{0,16050001,34},{0,16060001,7}]}]','[{1,[]},{2,[{0,16060002,3}]}]','[{1,[{250,{4,3}},{330,{4,4}},{413,{4,5}},{6,{5,0}}]},{2,[{1000,{4,5}}]}]','[{1,[晋升概率41%]},{2,[兽灵萤石打造100%晋级装备]}]'),(4,5,2,'[{1,[{0,16050001,77},{0,16060001,16}]},{2,[{0,16050001,39},{0,16060001,8}]}]','[{1,[]},{2,[{0,16060002,4}]}]','[{1,[{270,{4,4}},{350,{4,5}},{375,{5,0}},{5,{5,1}}]},{2,[{1000,{5,0}}]}]','[{1,[晋升概率38%]},{2,[兽灵萤石打造100%晋级装备]}]'),(5,0,2,'[{1,[{0,16050001,28},{0,16060001,6}]},{2,[{0,16050001,14},{0,16060001,3}]}]','[{1,[]},{2,[{0,16060002,2}]}]','[{1,[{300,{4,5}},{370,{5,0}},{326,{5,1}},{3,{5,2}}]},{2,[{1000,{5,1}}]}]','[{1,[晋升概率33%]},{2,[兽灵萤石打造100%晋级装备]}]'),(5,1,2,'[{1,[{0,16050001,40},{0,16060001,8}]},{2,[{0,16050001,20},{0,16060001,4}]}]','[{1,[]},{2,[{0,16060002,2}]}]','[{1,[{330,{5,0}},{390,{5,1}},{278,{5,2}},{2,{5,3}}]},{2,[{1000,{5,2}}]}]','[{1,[晋升概率28%]},{2,[兽灵萤石打造100%晋级装备]}]'),(5,2,2,'[{1,[{0,16050001,51},{0,16060001,11}]},{2,[{0,16050001,26},{0,16060001,6}]}]','[{1,[]},{2,[{0,16060002,3}]}]','[{1,[{360,{5,1}},{410,{5,2}},{229,{5,3}}]},{2,[{1000,{5,3}}]}]','[{1,[晋升概率23%]},{2,[兽灵萤石打造100%晋级装备]}]'),(5,3,2,'[{1,[{0,16050001,61},{0,16060001,13}]},{2,[{0,16050001,31},{0,16060001,7}]}]','[{1,[]},{2,[{0,16060002,3}]}]','[{1,[{390,{5,2}},{430,{5,3}},{181,{5,4}}]},{2,[{1000,{5,4}}]}]','[{1,[晋升概率18%]},{2,[兽灵萤石打造100%晋级装备]}]'),(5,4,2,'[{1,[{0,16050001,91},{0,16060001,19}]},{2,[{0,16050001,46},{0,16060001,10}]}]','[{1,[]},{2,[{0,16060002,4}]}]','[{1,[{420,{5,3}},{450,{5,4}},{132,{5,5}}]},{2,[{1000,{5,5}}]}]','[{1,[晋升概率13%]},{2,[兽灵萤石打造100%晋级装备]}]'),(5,5,2,'[{1,[{0,16050001,20},{0,16060001,4}]},{2,[{0,16050001,10},{0,16060001,2}]}]','[{1,[]},{2,[{0,16060002,1}]}]','[{1,[{1000,{5,5}}]},{2,[{1000,{5,5}}]}]','[{1,[晋升概率0%]},{2,[兽灵萤石打造100%晋级装备]}]');
/*!40000 ALTER TABLE `base_mount_equip_make` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_mount_equip_make_new`
--

DROP TABLE IF EXISTS `base_mount_equip_make_new`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_mount_equip_make_new` (
  `equip_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '装备id',
  `need_num_1` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '需求狗粮数量',
  `need_equip_1` text NOT NULL COMMENT '狗粮列表',
  `need_num_2` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '需求祭品数量',
  `need_equip_2` varchar(512) NOT NULL DEFAULT '[]' COMMENT '祭品列表',
  `make_tips` varchar(255) NOT NULL DEFAULT '""' COMMENT '注释@lang@',
  `result` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '打造结果',
  PRIMARY KEY (`equip_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='坐骑装备打造（新）';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_mount_equip_make_new`
--

LOCK TABLES `base_mount_equip_make_new` WRITE;
/*!40000 ALTER TABLE `base_mount_equip_make_new` DISABLE KEYS */;
INSERT INTO `base_mount_equip_make_new` VALUES (16040101,1,'[16080000,16040101,16040201,16040301,16040401,16040501,16040601]',0,'[]','需要1件<color=#4eae1a>绿1星</color>兽灵装备\\n','[{100,16040102}]'),(16040102,1,'[16080000,16040101,16040201,16040301,16040401,16040501,16040601]',0,'[]','需要1件<color=#4eae1a>绿1星</color>兽灵装备\\n','[{100,16040103}]'),(16040103,2,'[16080000,16040101,16040201,16040301,16040401,16040501,16040601]',0,'[]','需要2件<color=#4eae1a>绿1星</color>兽灵装备\\n','[{100,16040104}]'),(16040104,2,'[16080000,16040101,16040201,16040301,16040401,16040501,16040601]',1,'[16080000,16040101]','需要2件<color=#4eae1a>绿1星</color>兽灵装备\\n需要1件<color=#4eae1a>绿1星</color>同部位兽灵装备','[{100,16040105}]'),(16040111,1,'[16080100,16040105,16040205,16040305,16040405,16040505,16040605]',0,'[]','需要1件<color=#4eae1a>绿5星</color>兽灵装备\\n','[{100,16040112}]'),(16040112,1,'[16080100,16040105,16040205,16040305,16040405,16040505,16040605]',0,'[]','需要1件<color=#4eae1a>绿5星</color>兽灵装备\\n','[{100,16040113}]'),(16040113,2,'[16080100,16040105,16040205,16040305,16040405,16040505,16040605]',1,'[16080001,16040111]','需要2件<color=#4eae1a>绿5星</color>兽灵装备\\n需要1件<color=#60a0ff>蓝1星</color>同部位兽灵装备','[{100,16040114}]'),(16040114,2,'[16080100,16040105,16040205,16040305,16040405,16040505,16040605]',1,'[16080001,16040111]','需要2件<color=#4eae1a>绿5星</color>兽灵装备\\n需要1件<color=#60a0ff>蓝1星</color>同部位兽灵装备','[{100,16040115}]'),(16040121,1,'[16080101,16040115,16040215,16040315,16040415,16040515,16040615]',0,'[]','需要1件<color=#60a0ff>蓝5星</color>兽灵装备\\n','[{100,16040122}]'),(16040122,1,'[16080101,16040115,16040215,16040315,16040415,16040515,16040615]',0,'[]','需要1件<color=#60a0ff>蓝5星</color>兽灵装备\\n','[{100,16040123}]'),(16040123,2,'[16080101,16040115,16040215,16040315,16040415,16040515,16040615]',1,'[16080002,16040121]','需要2件<color=#60a0ff>蓝5星</color>兽灵装备\\n需要1件<color=#f54bff>紫1星</color>同部位兽灵装备','[{100,16040124}]'),(16040124,2,'[16080101,16040115,16040215,16040315,16040415,16040515,16040615]',1,'[16080002,16040121]','需要2件<color=#60a0ff>蓝5星</color>兽灵装备\\n需要1件<color=#f54bff>紫1星</color>同部位兽灵装备','[{100,16040125}]'),(16040131,1,'[16080102,16040125,16040225,16040325,16040425,16040525,16040625]',0,'[]','需要1件<color=#f54bff>紫5星</color>兽灵装备\\n','[{100,16040132}]'),(16040132,1,'[16080102,16040125,16040225,16040325,16040425,16040525,16040625]',0,'[]','需要1件<color=#f54bff>紫5星</color>兽灵装备\\n','[{100,16040133}]'),(16040133,2,'[16080102,16040125,16040225,16040325,16040425,16040525,16040625]',1,'[16080003,16040131]','需要2件<color=#f54bff>紫5星</color>兽灵装备\\n需要1件<color=#f18310>橙1星</color>同部位兽灵装备','[{100,16040134}]'),(16040134,2,'[16080102,16040125,16040225,16040325,16040425,16040525,16040625]',1,'[16080003,16040131]','需要2件<color=#f54bff>紫5星</color>兽灵装备\\n需要1件<color=#f18310>橙1星</color>同部位兽灵装备','[{100,16040135}]'),(16040141,1,'[16080103,16040135,16040235,16040335,16040435,16040535,16040635]',0,'[]','需要1件<color=#f18310>橙5星</color>兽灵装备\\n','[{100,16040142}]'),(16040142,1,'[16080103,16040135,16040235,16040335,16040435,16040535,16040635]',0,'[]','需要1件<color=#f18310>橙5星</color>兽灵装备\\n','[{100,16040143}]'),(16040143,2,'[16080103,16040135,16040235,16040335,16040435,16040535,16040635]',1,'[16080004,16040141]','需要2件<color=#f18310>橙5星</color>兽灵装备\\n需要1件<color=#f14041>红1星</color>同部位兽灵装备','[{100,16040144}]'),(16040144,2,'[16080103,16040135,16040235,16040335,16040435,16040535,16040635]',1,'[16080004,16040141]','需要2件<color=#f18310>橙5星</color>兽灵装备\\n需要1件<color=#f14041>红1星</color>同部位兽灵装备','[{100,16040145}]'),(16040151,1,'[16080005,16040151,16040251,16040351,16040451,16040551,16040651]',0,'[]','需要1件<color=#9c6cff>粉1星</color>兽灵装备\\n','[{100,16040152}]'),(16040152,2,'[16080005,16040151,16040251,16040351,16040451,16040551,16040651]',0,'[]','需要2件<color=#9c6cff>粉1星</color>兽灵装备\\n','[{100,16040153}]'),(16040153,2,'[16080005,16040151,16040251,16040351,16040451,16040551,16040651]',0,'[]','需要2件<color=#9c6cff>粉1星</color>兽灵装备\\n','[{100,16040154}]'),(16040154,2,'[16080005,16040151,16040251,16040351,16040451,16040551,16040651]',0,'[]','需要2件<color=#9c6cff>粉1星</color>兽灵装备\\n','[{100,16040155}]'),(16040201,1,'[16080000,16040101,16040201,16040301,16040401,16040501,16040601]',0,'[]','需要1件<color=#4eae1a>绿1星</color>兽灵装备\\n','[{100,16040202}]'),(16040202,1,'[16080000,16040101,16040201,16040301,16040401,16040501,16040601]',0,'[]','需要1件<color=#4eae1a>绿1星</color>兽灵装备\\n','[{100,16040203}]'),(16040203,2,'[16080000,16040101,16040201,16040301,16040401,16040501,16040601]',0,'[]','需要2件<color=#4eae1a>绿1星</color>兽灵装备\\n','[{100,16040204}]'),(16040204,2,'[16080000,16040101,16040201,16040301,16040401,16040501,16040601]',1,'[16080000,16040201]','需要2件<color=#4eae1a>绿1星</color>兽灵装备\\n需要1件<color=#4eae1a>绿1星</color>同部位兽灵装备','[{100,16040205}]'),(16040211,1,'[16080100,16040105,16040205,16040305,16040405,16040505,16040605]',0,'[]','需要1件<color=#4eae1a>绿5星</color>兽灵装备\\n','[{100,16040212}]'),(16040212,1,'[16080100,16040105,16040205,16040305,16040405,16040505,16040605]',0,'[]','需要1件<color=#4eae1a>绿5星</color>兽灵装备\\n','[{100,16040213}]'),(16040213,2,'[16080100,16040105,16040205,16040305,16040405,16040505,16040605]',1,'[16080001,16040211]','需要2件<color=#4eae1a>绿5星</color>兽灵装备\\n需要1件<color=#60a0ff>蓝1星</color>同部位兽灵装备','[{100,16040214}]'),(16040214,2,'[16080100,16040105,16040205,16040305,16040405,16040505,16040605]',1,'[16080001,16040211]','需要2件<color=#4eae1a>绿5星</color>兽灵装备\\n需要1件<color=#60a0ff>蓝1星</color>同部位兽灵装备','[{100,16040215}]'),(16040221,1,'[16080101,16040115,16040215,16040315,16040415,16040515,16040615]',0,'[]','需要1件<color=#60a0ff>蓝5星</color>兽灵装备\\n','[{100,16040222}]'),(16040222,1,'[16080101,16040115,16040215,16040315,16040415,16040515,16040615]',0,'[]','需要1件<color=#60a0ff>蓝5星</color>兽灵装备\\n','[{100,16040223}]'),(16040223,2,'[16080101,16040115,16040215,16040315,16040415,16040515,16040615]',1,'[16080002,16040221]','需要2件<color=#60a0ff>蓝5星</color>兽灵装备\\n需要1件<color=#f54bff>紫1星</color>同部位兽灵装备','[{100,16040224}]'),(16040224,2,'[16080101,16040115,16040215,16040315,16040415,16040515,16040615]',1,'[16080002,16040221]','需要2件<color=#60a0ff>蓝5星</color>兽灵装备\\n需要1件<color=#f54bff>紫1星</color>同部位兽灵装备','[{100,16040225}]'),(16040231,1,'[16080102,16040125,16040225,16040325,16040425,16040525,16040625]',0,'[]','需要1件<color=#f54bff>紫5星</color>兽灵装备\\n','[{100,16040232}]'),(16040232,1,'[16080102,16040125,16040225,16040325,16040425,16040525,16040625]',0,'[]','需要1件<color=#f54bff>紫5星</color>兽灵装备\\n','[{100,16040233}]'),(16040233,2,'[16080102,16040125,16040225,16040325,16040425,16040525,16040625]',1,'[16080003,16040231]','需要2件<color=#f54bff>紫5星</color>兽灵装备\\n需要1件<color=#f18310>橙1星</color>同部位兽灵装备','[{100,16040234}]'),(16040234,2,'[16080102,16040125,16040225,16040325,16040425,16040525,16040625]',1,'[16080003,16040231]','需要2件<color=#f54bff>紫5星</color>兽灵装备\\n需要1件<color=#f18310>橙1星</color>同部位兽灵装备','[{100,16040235}]'),(16040241,1,'[16080103,16040135,16040235,16040335,16040435,16040535,16040635]',0,'[]','需要1件<color=#f18310>橙5星</color>兽灵装备\\n','[{100,16040242}]'),(16040242,1,'[16080103,16040135,16040235,16040335,16040435,16040535,16040635]',0,'[]','需要1件<color=#f18310>橙5星</color>兽灵装备\\n','[{100,16040243}]'),(16040243,2,'[16080103,16040135,16040235,16040335,16040435,16040535,16040635]',1,'[16080004,16040241]','需要2件<color=#f18310>橙5星</color>兽灵装备\\n需要1件<color=#f14041>红1星</color>同部位兽灵装备','[{100,16040244}]'),(16040244,2,'[16080103,16040135,16040235,16040335,16040435,16040535,16040635]',1,'[16080004,16040241]','需要2件<color=#f18310>橙5星</color>兽灵装备\\n需要1件<color=#f14041>红1星</color>同部位兽灵装备','[{100,16040245}]'),(16040251,1,'[16080005,16040151,16040251,16040351,16040451,16040551,16040651]',0,'[]','需要1件<color=#9c6cff>粉1星</color>兽灵装备\\n','[{100,16040252}]'),(16040252,2,'[16080005,16040151,16040251,16040351,16040451,16040551,16040651]',0,'[]','需要2件<color=#9c6cff>粉1星</color>兽灵装备\\n','[{100,16040253}]'),(16040253,2,'[16080005,16040151,16040251,16040351,16040451,16040551,16040651]',0,'[]','需要2件<color=#9c6cff>粉1星</color>兽灵装备\\n','[{100,16040254}]'),(16040254,2,'[16080005,16040151,16040251,16040351,16040451,16040551,16040651]',0,'[]','需要2件<color=#9c6cff>粉1星</color>兽灵装备\\n','[{100,16040255}]'),(16040301,1,'[16080000,16040101,16040201,16040301,16040401,16040501,16040601]',0,'[]','需要1件<color=#4eae1a>绿1星</color>兽灵装备\\n','[{100,16040302}]'),(16040302,1,'[16080000,16040101,16040201,16040301,16040401,16040501,16040601]',0,'[]','需要1件<color=#4eae1a>绿1星</color>兽灵装备\\n','[{100,16040303}]'),(16040303,2,'[16080000,16040101,16040201,16040301,16040401,16040501,16040601]',0,'[]','需要2件<color=#4eae1a>绿1星</color>兽灵装备\\n','[{100,16040304}]'),(16040304,2,'[16080000,16040101,16040201,16040301,16040401,16040501,16040601]',1,'[16080000,16040301]','需要2件<color=#4eae1a>绿1星</color>兽灵装备\\n需要1件<color=#4eae1a>绿1星</color>同部位兽灵装备','[{100,16040305}]'),(16040311,1,'[16080100,16040105,16040205,16040305,16040405,16040505,16040605]',0,'[]','需要1件<color=#4eae1a>绿5星</color>兽灵装备\\n','[{100,16040312}]'),(16040312,1,'[16080100,16040105,16040205,16040305,16040405,16040505,16040605]',0,'[]','需要1件<color=#4eae1a>绿5星</color>兽灵装备\\n','[{100,16040313}]'),(16040313,2,'[16080100,16040105,16040205,16040305,16040405,16040505,16040605]',1,'[16080001,16040311]','需要2件<color=#4eae1a>绿5星</color>兽灵装备\\n需要1件<color=#60a0ff>蓝1星</color>同部位兽灵装备','[{100,16040314}]'),(16040314,2,'[16080100,16040105,16040205,16040305,16040405,16040505,16040605]',1,'[16080001,16040311]','需要2件<color=#4eae1a>绿5星</color>兽灵装备\\n需要1件<color=#60a0ff>蓝1星</color>同部位兽灵装备','[{100,16040315}]'),(16040321,1,'[16080101,16040115,16040215,16040315,16040415,16040515,16040615]',0,'[]','需要1件<color=#60a0ff>蓝5星</color>兽灵装备\\n','[{100,16040322}]'),(16040322,1,'[16080101,16040115,16040215,16040315,16040415,16040515,16040615]',0,'[]','需要1件<color=#60a0ff>蓝5星</color>兽灵装备\\n','[{100,16040323}]'),(16040323,2,'[16080101,16040115,16040215,16040315,16040415,16040515,16040615]',1,'[16080002,16040321]','需要2件<color=#60a0ff>蓝5星</color>兽灵装备\\n需要1件<color=#f54bff>紫1星</color>同部位兽灵装备','[{100,16040324}]'),(16040324,2,'[16080101,16040115,16040215,16040315,16040415,16040515,16040615]',1,'[16080002,16040321]','需要2件<color=#60a0ff>蓝5星</color>兽灵装备\\n需要1件<color=#f54bff>紫1星</color>同部位兽灵装备','[{100,16040325}]'),(16040331,1,'[16080102,16040125,16040225,16040325,16040425,16040525,16040625]',0,'[]','需要1件<color=#f54bff>紫5星</color>兽灵装备\\n','[{100,16040332}]'),(16040332,1,'[16080102,16040125,16040225,16040325,16040425,16040525,16040625]',0,'[]','需要1件<color=#f54bff>紫5星</color>兽灵装备\\n','[{100,16040333}]'),(16040333,2,'[16080102,16040125,16040225,16040325,16040425,16040525,16040625]',1,'[16080003,16040331]','需要2件<color=#f54bff>紫5星</color>兽灵装备\\n需要1件<color=#f18310>橙1星</color>同部位兽灵装备','[{100,16040334}]'),(16040334,2,'[16080102,16040125,16040225,16040325,16040425,16040525,16040625]',1,'[16080003,16040331]','需要2件<color=#f54bff>紫5星</color>兽灵装备\\n需要1件<color=#f18310>橙1星</color>同部位兽灵装备','[{100,16040335}]'),(16040341,1,'[16080103,16040135,16040235,16040335,16040435,16040535,16040635]',0,'[]','需要1件<color=#f18310>橙5星</color>兽灵装备\\n','[{100,16040342}]'),(16040342,1,'[16080103,16040135,16040235,16040335,16040435,16040535,16040635]',0,'[]','需要1件<color=#f18310>橙5星</color>兽灵装备\\n','[{100,16040343}]'),(16040343,2,'[16080103,16040135,16040235,16040335,16040435,16040535,16040635]',1,'[16080004,16040341]','需要2件<color=#f18310>橙5星</color>兽灵装备\\n需要1件<color=#f14041>红1星</color>同部位兽灵装备','[{100,16040344}]'),(16040344,2,'[16080103,16040135,16040235,16040335,16040435,16040535,16040635]',1,'[16080004,16040341]','需要2件<color=#f18310>橙5星</color>兽灵装备\\n需要1件<color=#f14041>红1星</color>同部位兽灵装备','[{100,16040345}]'),(16040351,1,'[16080005,16040151,16040251,16040351,16040451,16040551,16040651]',0,'[]','需要1件<color=#9c6cff>粉1星</color>兽灵装备\\n','[{100,16040352}]'),(16040352,2,'[16080005,16040151,16040251,16040351,16040451,16040551,16040651]',0,'[]','需要2件<color=#9c6cff>粉1星</color>兽灵装备\\n','[{100,16040353}]'),(16040353,2,'[16080005,16040151,16040251,16040351,16040451,16040551,16040651]',0,'[]','需要2件<color=#9c6cff>粉1星</color>兽灵装备\\n','[{100,16040354}]'),(16040354,2,'[16080005,16040151,16040251,16040351,16040451,16040551,16040651]',0,'[]','需要2件<color=#9c6cff>粉1星</color>兽灵装备\\n','[{100,16040355}]'),(16040401,1,'[16080000,16040101,16040201,16040301,16040401,16040501,16040601]',0,'[]','需要1件<color=#4eae1a>绿1星</color>兽灵装备\\n','[{100,16040402}]'),(16040402,1,'[16080000,16040101,16040201,16040301,16040401,16040501,16040601]',0,'[]','需要1件<color=#4eae1a>绿1星</color>兽灵装备\\n','[{100,16040403}]'),(16040403,2,'[16080000,16040101,16040201,16040301,16040401,16040501,16040601]',0,'[]','需要2件<color=#4eae1a>绿1星</color>兽灵装备\\n','[{100,16040404}]'),(16040404,2,'[16080000,16040101,16040201,16040301,16040401,16040501,16040601]',1,'[16080000,16040401]','需要2件<color=#4eae1a>绿1星</color>兽灵装备\\n需要1件<color=#4eae1a>绿1星</color>同部位兽灵装备','[{100,16040405}]'),(16040411,1,'[16080100,16040105,16040205,16040305,16040405,16040505,16040605]',0,'[]','需要1件<color=#4eae1a>绿5星</color>兽灵装备\\n','[{100,16040412}]'),(16040412,1,'[16080100,16040105,16040205,16040305,16040405,16040505,16040605]',0,'[]','需要1件<color=#4eae1a>绿5星</color>兽灵装备\\n','[{100,16040413}]'),(16040413,2,'[16080100,16040105,16040205,16040305,16040405,16040505,16040605]',1,'[16080001,16040411]','需要2件<color=#4eae1a>绿5星</color>兽灵装备\\n需要1件<color=#60a0ff>蓝1星</color>同部位兽灵装备','[{100,16040414}]'),(16040414,2,'[16080100,16040105,16040205,16040305,16040405,16040505,16040605]',1,'[16080001,16040411]','需要2件<color=#4eae1a>绿5星</color>兽灵装备\\n需要1件<color=#60a0ff>蓝1星</color>同部位兽灵装备','[{100,16040415}]'),(16040421,1,'[16080101,16040115,16040215,16040315,16040415,16040515,16040615]',0,'[]','需要1件<color=#60a0ff>蓝5星</color>兽灵装备\\n','[{100,16040422}]'),(16040422,1,'[16080101,16040115,16040215,16040315,16040415,16040515,16040615]',0,'[]','需要1件<color=#60a0ff>蓝5星</color>兽灵装备\\n','[{100,16040423}]'),(16040423,2,'[16080101,16040115,16040215,16040315,16040415,16040515,16040615]',1,'[16080002,16040421]','需要2件<color=#60a0ff>蓝5星</color>兽灵装备\\n需要1件<color=#f54bff>紫1星</color>同部位兽灵装备','[{100,16040424}]'),(16040424,2,'[16080101,16040115,16040215,16040315,16040415,16040515,16040615]',1,'[16080002,16040421]','需要2件<color=#60a0ff>蓝5星</color>兽灵装备\\n需要1件<color=#f54bff>紫1星</color>同部位兽灵装备','[{100,16040425}]'),(16040431,1,'[16080102,16040125,16040225,16040325,16040425,16040525,16040625]',0,'[]','需要1件<color=#f54bff>紫5星</color>兽灵装备\\n','[{100,16040432}]'),(16040432,1,'[16080102,16040125,16040225,16040325,16040425,16040525,16040625]',0,'[]','需要1件<color=#f54bff>紫5星</color>兽灵装备\\n','[{100,16040433}]'),(16040433,2,'[16080102,16040125,16040225,16040325,16040425,16040525,16040625]',1,'[16080003,16040431]','需要2件<color=#f54bff>紫5星</color>兽灵装备\\n需要1件<color=#f18310>橙1星</color>同部位兽灵装备','[{100,16040434}]'),(16040434,2,'[16080102,16040125,16040225,16040325,16040425,16040525,16040625]',1,'[16080003,16040431]','需要2件<color=#f54bff>紫5星</color>兽灵装备\\n需要1件<color=#f18310>橙1星</color>同部位兽灵装备','[{100,16040435}]'),(16040441,1,'[16080103,16040135,16040235,16040335,16040435,16040535,16040635]',0,'[]','需要1件<color=#f18310>橙5星</color>兽灵装备\\n','[{100,16040442}]'),(16040442,1,'[16080103,16040135,16040235,16040335,16040435,16040535,16040635]',0,'[]','需要1件<color=#f18310>橙5星</color>兽灵装备\\n','[{100,16040443}]'),(16040443,2,'[16080103,16040135,16040235,16040335,16040435,16040535,16040635]',1,'[16080004,16040441]','需要2件<color=#f18310>橙5星</color>兽灵装备\\n需要1件<color=#f14041>红1星</color>同部位兽灵装备','[{100,16040444}]'),(16040444,2,'[16080103,16040135,16040235,16040335,16040435,16040535,16040635]',1,'[16080004,16040441]','需要2件<color=#f18310>橙5星</color>兽灵装备\\n需要1件<color=#f14041>红1星</color>同部位兽灵装备','[{100,16040445}]'),(16040451,1,'[16080005,16040151,16040251,16040351,16040451,16040551,16040651]',0,'[]','需要1件<color=#9c6cff>粉1星</color>兽灵装备\\n','[{100,16040452}]'),(16040452,2,'[16080005,16040151,16040251,16040351,16040451,16040551,16040651]',0,'[]','需要2件<color=#9c6cff>粉1星</color>兽灵装备\\n','[{100,16040453}]'),(16040453,2,'[16080005,16040151,16040251,16040351,16040451,16040551,16040651]',0,'[]','需要2件<color=#9c6cff>粉1星</color>兽灵装备\\n','[{100,16040454}]'),(16040454,2,'[16080005,16040151,16040251,16040351,16040451,16040551,16040651]',0,'[]','需要2件<color=#9c6cff>粉1星</color>兽灵装备\\n','[{100,16040455}]'),(16040501,1,'[16080000,16040101,16040201,16040301,16040401,16040501,16040601]',0,'[]','需要1件<color=#4eae1a>绿1星</color>兽灵装备\\n','[{100,16040502}]'),(16040502,1,'[16080000,16040101,16040201,16040301,16040401,16040501,16040601]',0,'[]','需要1件<color=#4eae1a>绿1星</color>兽灵装备\\n','[{100,16040503}]'),(16040503,2,'[16080000,16040101,16040201,16040301,16040401,16040501,16040601]',0,'[]','需要2件<color=#4eae1a>绿1星</color>兽灵装备\\n','[{100,16040504}]'),(16040504,2,'[16080000,16040101,16040201,16040301,16040401,16040501,16040601]',1,'[16080000,16040501]','需要2件<color=#4eae1a>绿1星</color>兽灵装备\\n需要1件<color=#4eae1a>绿1星</color>同部位兽灵装备','[{100,16040505}]'),(16040511,1,'[16080100,16040105,16040205,16040305,16040405,16040505,16040605]',0,'[]','需要1件<color=#4eae1a>绿5星</color>兽灵装备\\n','[{100,16040512}]'),(16040512,1,'[16080100,16040105,16040205,16040305,16040405,16040505,16040605]',0,'[]','需要1件<color=#4eae1a>绿5星</color>兽灵装备\\n','[{100,16040513}]'),(16040513,2,'[16080100,16040105,16040205,16040305,16040405,16040505,16040605]',1,'[16080001,16040511]','需要2件<color=#4eae1a>绿5星</color>兽灵装备\\n需要1件<color=#60a0ff>蓝1星</color>同部位兽灵装备','[{100,16040514}]'),(16040514,2,'[16080100,16040105,16040205,16040305,16040405,16040505,16040605]',1,'[16080001,16040511]','需要2件<color=#4eae1a>绿5星</color>兽灵装备\\n需要1件<color=#60a0ff>蓝1星</color>同部位兽灵装备','[{100,16040515}]'),(16040521,1,'[16080101,16040115,16040215,16040315,16040415,16040515,16040615]',0,'[]','需要1件<color=#60a0ff>蓝5星</color>兽灵装备\\n','[{100,16040522}]'),(16040522,1,'[16080101,16040115,16040215,16040315,16040415,16040515,16040615]',0,'[]','需要1件<color=#60a0ff>蓝5星</color>兽灵装备\\n','[{100,16040523}]'),(16040523,2,'[16080101,16040115,16040215,16040315,16040415,16040515,16040615]',1,'[16080002,16040521]','需要2件<color=#60a0ff>蓝5星</color>兽灵装备\\n需要1件<color=#f54bff>紫1星</color>同部位兽灵装备','[{100,16040524}]'),(16040524,2,'[16080101,16040115,16040215,16040315,16040415,16040515,16040615]',1,'[16080002,16040521]','需要2件<color=#60a0ff>蓝5星</color>兽灵装备\\n需要1件<color=#f54bff>紫1星</color>同部位兽灵装备','[{100,16040525}]'),(16040531,1,'[16080102,16040125,16040225,16040325,16040425,16040525,16040625]',0,'[]','需要1件<color=#f54bff>紫5星</color>兽灵装备\\n','[{100,16040532}]'),(16040532,1,'[16080102,16040125,16040225,16040325,16040425,16040525,16040625]',0,'[]','需要1件<color=#f54bff>紫5星</color>兽灵装备\\n','[{100,16040533}]'),(16040533,2,'[16080102,16040125,16040225,16040325,16040425,16040525,16040625]',1,'[16080003,16040531]','需要2件<color=#f54bff>紫5星</color>兽灵装备\\n需要1件<color=#f18310>橙1星</color>同部位兽灵装备','[{100,16040534}]'),(16040534,2,'[16080102,16040125,16040225,16040325,16040425,16040525,16040625]',1,'[16080003,16040531]','需要2件<color=#f54bff>紫5星</color>兽灵装备\\n需要1件<color=#f18310>橙1星</color>同部位兽灵装备','[{100,16040535}]'),(16040541,1,'[16080103,16040135,16040235,16040335,16040435,16040535,16040635]',0,'[]','需要1件<color=#f18310>橙5星</color>兽灵装备\\n','[{100,16040542}]'),(16040542,1,'[16080103,16040135,16040235,16040335,16040435,16040535,16040635]',0,'[]','需要1件<color=#f18310>橙5星</color>兽灵装备\\n','[{100,16040543}]'),(16040543,2,'[16080103,16040135,16040235,16040335,16040435,16040535,16040635]',1,'[16080004,16040541]','需要2件<color=#f18310>橙5星</color>兽灵装备\\n需要1件<color=#f14041>红1星</color>同部位兽灵装备','[{100,16040544}]'),(16040544,2,'[16080103,16040135,16040235,16040335,16040435,16040535,16040635]',1,'[16080004,16040541]','需要2件<color=#f18310>橙5星</color>兽灵装备\\n需要1件<color=#f14041>红1星</color>同部位兽灵装备','[{100,16040545}]'),(16040551,1,'[16080005,16040151,16040251,16040351,16040451,16040551,16040651]',0,'[]','需要1件<color=#9c6cff>粉1星</color>兽灵装备\\n','[{100,16040552}]'),(16040552,2,'[16080005,16040151,16040251,16040351,16040451,16040551,16040651]',0,'[]','需要2件<color=#9c6cff>粉1星</color>兽灵装备\\n','[{100,16040553}]'),(16040553,2,'[16080005,16040151,16040251,16040351,16040451,16040551,16040651]',0,'[]','需要2件<color=#9c6cff>粉1星</color>兽灵装备\\n','[{100,16040554}]'),(16040554,2,'[16080005,16040151,16040251,16040351,16040451,16040551,16040651]',0,'[]','需要2件<color=#9c6cff>粉1星</color>兽灵装备\\n','[{100,16040555}]'),(16040601,1,'[16080000,16040101,16040201,16040301,16040401,16040501,16040601]',0,'[]','需要1件<color=#4eae1a>绿1星</color>兽灵装备\\n','[{100,16040602}]'),(16040602,1,'[16080000,16040101,16040201,16040301,16040401,16040501,16040601]',0,'[]','需要1件<color=#4eae1a>绿1星</color>兽灵装备\\n','[{100,16040603}]'),(16040603,2,'[16080000,16040101,16040201,16040301,16040401,16040501,16040601]',0,'[]','需要2件<color=#4eae1a>绿1星</color>兽灵装备\\n','[{100,16040604}]'),(16040604,2,'[16080000,16040101,16040201,16040301,16040401,16040501,16040601]',1,'[16080000,16040601]','需要2件<color=#4eae1a>绿1星</color>兽灵装备\\n需要1件<color=#4eae1a>绿1星</color>同部位兽灵装备','[{100,16040605}]'),(16040611,1,'[16080100,16040105,16040205,16040305,16040405,16040505,16040605]',0,'[]','需要1件<color=#4eae1a>绿5星</color>兽灵装备\\n','[{100,16040612}]'),(16040612,1,'[16080100,16040105,16040205,16040305,16040405,16040505,16040605]',0,'[]','需要1件<color=#4eae1a>绿5星</color>兽灵装备\\n','[{100,16040613}]'),(16040613,2,'[16080100,16040105,16040205,16040305,16040405,16040505,16040605]',1,'[16080001,16040611]','需要2件<color=#4eae1a>绿5星</color>兽灵装备\\n需要1件<color=#60a0ff>蓝1星</color>同部位兽灵装备','[{100,16040614}]'),(16040614,2,'[16080100,16040105,16040205,16040305,16040405,16040505,16040605]',1,'[16080001,16040611]','需要2件<color=#4eae1a>绿5星</color>兽灵装备\\n需要1件<color=#60a0ff>蓝1星</color>同部位兽灵装备','[{100,16040615}]'),(16040621,1,'[16080101,16040115,16040215,16040315,16040415,16040515,16040615]',0,'[]','需要1件<color=#60a0ff>蓝5星</color>兽灵装备\\n','[{100,16040622}]'),(16040622,1,'[16080101,16040115,16040215,16040315,16040415,16040515,16040615]',0,'[]','需要1件<color=#60a0ff>蓝5星</color>兽灵装备\\n','[{100,16040623}]'),(16040623,2,'[16080101,16040115,16040215,16040315,16040415,16040515,16040615]',1,'[16080002,16040621]','需要2件<color=#60a0ff>蓝5星</color>兽灵装备\\n需要1件<color=#f54bff>紫1星</color>同部位兽灵装备','[{100,16040624}]'),(16040624,2,'[16080101,16040115,16040215,16040315,16040415,16040515,16040615]',1,'[16080002,16040621]','需要2件<color=#60a0ff>蓝5星</color>兽灵装备\\n需要1件<color=#f54bff>紫1星</color>同部位兽灵装备','[{100,16040625}]'),(16040631,1,'[16080102,16040125,16040225,16040325,16040425,16040525,16040625]',0,'[]','需要1件<color=#f54bff>紫5星</color>兽灵装备\\n','[{100,16040632}]'),(16040632,1,'[16080102,16040125,16040225,16040325,16040425,16040525,16040625]',0,'[]','需要1件<color=#f54bff>紫5星</color>兽灵装备\\n','[{100,16040633}]'),(16040633,2,'[16080102,16040125,16040225,16040325,16040425,16040525,16040625]',1,'[16080003,16040631]','需要2件<color=#f54bff>紫5星</color>兽灵装备\\n需要1件<color=#f18310>橙1星</color>同部位兽灵装备','[{100,16040634}]'),(16040634,2,'[16080102,16040125,16040225,16040325,16040425,16040525,16040625]',1,'[16080003,16040631]','需要2件<color=#f54bff>紫5星</color>兽灵装备\\n需要1件<color=#f18310>橙1星</color>同部位兽灵装备','[{100,16040635}]'),(16040641,1,'[16080103,16040135,16040235,16040335,16040435,16040535,16040635]',0,'[]','需要1件<color=#f18310>橙5星</color>兽灵装备\\n','[{100,16040642}]'),(16040642,1,'[16080103,16040135,16040235,16040335,16040435,16040535,16040635]',0,'[]','需要1件<color=#f18310>橙5星</color>兽灵装备\\n','[{100,16040643}]'),(16040643,2,'[16080103,16040135,16040235,16040335,16040435,16040535,16040635]',1,'[16080004,16040641]','需要2件<color=#f18310>橙5星</color>兽灵装备\\n需要1件<color=#f14041>红1星</color>同部位兽灵装备','[{100,16040644}]'),(16040644,2,'[16080103,16040135,16040235,16040335,16040435,16040535,16040635]',1,'[16080004,16040641]','需要2件<color=#f18310>橙5星</color>兽灵装备\\n需要1件<color=#f14041>红1星</color>同部位兽灵装备','[{100,16040645}]'),(16040651,1,'[16080005,16040151,16040251,16040351,16040451,16040551,16040651]',0,'[]','需要1件<color=#9c6cff>粉1星</color>兽灵装备\\n','[{100,16040652}]'),(16040652,2,'[16080005,16040151,16040251,16040351,16040451,16040551,16040651]',0,'[]','需要2件<color=#9c6cff>粉1星</color>兽灵装备\\n','[{100,16040653}]'),(16040653,2,'[16080005,16040151,16040251,16040351,16040451,16040551,16040651]',0,'[]','需要2件<color=#9c6cff>粉1星</color>兽灵装备\\n','[{100,16040654}]'),(16040654,2,'[16080005,16040151,16040251,16040351,16040451,16040551,16040651]',0,'[]','需要2件<color=#9c6cff>粉1星</color>兽灵装备\\n','[{100,16040655}]');
/*!40000 ALTER TABLE `base_mount_equip_make_new` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_mount_equip_quality`
--

DROP TABLE IF EXISTS `base_mount_equip_quality`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_mount_equip_quality` (
  `quality` tinyint(3) unsigned NOT NULL COMMENT '品质',
  `max_lv` smallint(5) unsigned NOT NULL COMMENT '最大等级',
  PRIMARY KEY (`quality`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='坐骑装备品质配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_mount_equip_quality`
--

LOCK TABLES `base_mount_equip_quality` WRITE;
/*!40000 ALTER TABLE `base_mount_equip_quality` DISABLE KEYS */;
INSERT INTO `base_mount_equip_quality` VALUES (0,50),(1,100),(2,200),(3,350),(4,500),(5,500);
/*!40000 ALTER TABLE `base_mount_equip_quality` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_mount_equip_skill`
--

DROP TABLE IF EXISTS `base_mount_equip_skill`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_mount_equip_skill` (
  `id` tinyint(3) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `skill_id` int(11) unsigned NOT NULL COMMENT '技能id',
  `activity_limit` tinyint(3) unsigned NOT NULL COMMENT '最低激活品质',
  `need_num` tinyint(3) unsigned NOT NULL COMMENT '所需数量',
  `combat` int(11) unsigned NOT NULL COMMENT '提供战力',
  `tips` varchar(1024) NOT NULL COMMENT '提示文字@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8 COMMENT='坐骑装备技能';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_mount_equip_skill`
--

LOCK TABLES `base_mount_equip_skill` WRITE;
/*!40000 ALTER TABLE `base_mount_equip_skill` DISABLE KEYS */;
INSERT INTO `base_mount_equip_skill` VALUES (1,21005151,1,1,10000,'穿戴1件蓝色品质坐骑装备可激活'),(2,21005152,3,2,998,'穿戴2件橙色坐骑装备即可激活');
/*!40000 ALTER TABLE `base_mount_equip_skill` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_mount_equip_skill_new`
--

DROP TABLE IF EXISTS `base_mount_equip_skill_new`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_mount_equip_skill_new` (
  `id` tinyint(3) unsigned NOT NULL COMMENT '自增id',
  `quality` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '装备品质',
  `num` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '最低数量',
  `base_attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '基础属性',
  `ratio_attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '加成属性',
  `tips` text NOT NULL COMMENT '描述@lang@',
  `icon` int(11) unsigned NOT NULL COMMENT '图标id',
  `skill_name` varchar(255) NOT NULL COMMENT '技能名称',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='坐骑装备技能配置（新）';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_mount_equip_skill_new`
--

LOCK TABLES `base_mount_equip_skill_new` WRITE;
/*!40000 ALTER TABLE `base_mount_equip_skill_new` DISABLE KEYS */;
INSERT INTO `base_mount_equip_skill_new` VALUES (1,0,6,'[{2,40000}]','[]','<color=#64d129>生命+40000</color>\\n装备6件<color=#64d129>绿色</color>兽灵装备激活',107,'兽灵冲鸭'),(2,1,6,'[{1,5000}]','[]','<color=#64d129>攻击+5000</color>\\n装备6件<color=#60a0ff>蓝色</color>兽灵装备激活',102,'兽灵出击'),(3,2,6,'[]','[{1,200},{2,200}]','<color=#64d129>兽灵面铠和兽灵刃爪属性提升2%</color>\\n装备6件<color=#f54bff>紫色</color>兽灵装备激活',21005155,'兽灵进化'),(4,3,6,'[]','[{3,200},{4,200}]','<color=#64d129>兽灵挂饰和兽灵刻痕属性提升2%</color>\\n装备6件<color=#f18310>橙色</color>兽灵装备激活',21005157,'兽灵超进化'),(5,4,6,'[]','[{5,200},{6,200}]','<color=#64d129>兽灵符文和兽灵坐鞍属性提升2%</color>\\n装备6件<color=#f14041>红色</color>兽灵装备激活',21005158,'兽灵究极进化'),(6,5,6,'[]','[{1,500},{2,500},{3,500},{4,500},{5,500},{6,500}]','<color=#64d129>兽灵装备属性提升5%</color>\\n装备6件<color=#9c6cff>粉色</color>兽灵装备激活',11000003,'兽灵超究极进化');
/*!40000 ALTER TABLE `base_mount_equip_skill_new` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_mount_equip_smelt`
--

DROP TABLE IF EXISTS `base_mount_equip_smelt`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_mount_equip_smelt` (
  `goods_id` int(11) unsigned NOT NULL COMMENT '道具id',
  `type` tinyint(3) unsigned NOT NULL COMMENT '装备类型',
  `return_goods` varchar(255) NOT NULL COMMENT '返还材料',
  PRIMARY KEY (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='坐骑装备熔炼配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_mount_equip_smelt`
--

LOCK TABLES `base_mount_equip_smelt` WRITE;
/*!40000 ALTER TABLE `base_mount_equip_smelt` DISABLE KEYS */;
INSERT INTO `base_mount_equip_smelt` VALUES (16040101,2,'[{100,[{16050001,2}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,1}]}]'),(16040102,2,'[{100,[{16050001,3}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,1}]}]'),(16040103,2,'[{100,[{16050001,4}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,1}]}]'),(16040104,2,'[{100,[{16050001,6}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,1}]}]'),(16040105,2,'[{100,[{16050001,9}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,1}]}]'),(16040111,2,'[{100,[{16050001,8}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,1}]}]'),(16040112,2,'[{100,[{16050001,11}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,4}]}]'),(16040113,2,'[{100,[{16050001,15}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,4}]}]'),(16040114,2,'[{100,[{16050001,26}]},{80,[{16050001,2}]},{20,[{16050001,2}]},{25,[{16050001,4}]}]'),(16040115,2,'[{100,[{16050001,36}]},{80,[{16050001,4}]},{20,[{16050001,4}]},{25,[{16050001,4}]}]'),(16040121,2,'[{100,[{16050001,31}]},{80,[{16050001,3}]},{20,[{16050001,3}]},{25,[{16050001,4}]}]'),(16040122,2,'[{100,[{16050001,45}]},{80,[{16050001,5}]},{20,[{16050001,5}]},{25,[{16050001,4}]}]'),(16040123,2,'[{100,[{16050001,61}]},{80,[{16050001,6}]},{20,[{16050001,6}]},{25,[{16050001,4}]}]'),(16040124,2,'[{100,[{16050001,104}]},{80,[{16050001,11}]},{20,[{16050001,11}]},{25,[{16050001,4}]}]'),(16040125,2,'[{100,[{16050001,148}]},{80,[{16050001,16}]},{20,[{16050001,16}]},{25,[{16050001,4}]}]'),(16040131,2,'[{100,[{16050001,126}]},{80,[{16050001,14}]},{20,[{16050001,14}]},{25,[{16050001,1}]}]'),(16040132,2,'[{100,[{16050001,185}]},{80,[{16050001,20}]},{20,[{16050001,20}]},{25,[{16050001,4}]}]'),(16040133,2,'[{100,[{16050001,244}]},{80,[{16050001,27}]},{20,[{16050001,27}]},{25,[{16050001,4}]}]'),(16040134,2,'[{100,[{16050001,419}]},{80,[{16050001,46}]},{20,[{16050001,46}]},{25,[{16050001,4}]}]'),(16040135,2,'[{100,[{16050001,594}]},{80,[{16050001,66}]},{20,[{16050001,66}]},{25,[{16050001,4}]}]'),(16040141,2,'[{100,[{16050001,507}]},{80,[{16050001,56}]},{20,[{16050001,56}]},{25,[{16050001,4}]}]'),(16040142,2,'[{100,[{16050001,745}]},{80,[{16050001,82}]},{20,[{16050001,82}]},{25,[{16050001,4}]}]'),(16040143,2,'[{100,[{16050001,982}]},{80,[{16050001,109}]},{20,[{16050001,109}]},{25,[{16050001,4}]}]'),(16040144,2,'[{100,[{16050001,1683}]},{80,[{16050001,187}]},{20,[{16050001,187}]},{25,[{16050001,1}]}]'),(16040145,2,'[{100,[{16050001,2383}]},{80,[{16050001,264}]},{20,[{16050001,264}]},{25,[{16050001,4}]}]'),(16040151,2,'[{100,[{16050001,2218}]},{80,[{16050001,246}]},{20,[{16050001,246}]},{25,[{16050001,4}]}]'),(16040152,2,'[{100,[{16050001,3106}]},{80,[{16050001,345}]},{20,[{16050001,345}]},{25,[{16050001,4}]}]'),(16040153,2,'[{100,[{16050001,4770}]},{80,[{16050001,530}]},{20,[{16050001,530}]},{25,[{16050001,4}]}]'),(16040154,2,'[{100,[{16050001,6435}]},{80,[{16050001,715}]},{20,[{16050001,715}]},{25,[{16050001,1}]}]'),(16040155,2,'[{100,[{16050001,8100}]},{80,[{16050001,900}]},{20,[{16050001,900}]},{25,[{16050001,1}]}]'),(16040201,2,'[{100,[{16050001,2}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,1}]}]'),(16040202,2,'[{100,[{16050001,3}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,1}]}]'),(16040203,2,'[{100,[{16050001,4}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,1}]}]'),(16040204,2,'[{100,[{16050001,6}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,1}]}]'),(16040205,2,'[{100,[{16050001,9}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,1}]}]'),(16040211,2,'[{100,[{16050001,8}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,1}]}]'),(16040212,2,'[{100,[{16050001,11}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,4}]}]'),(16040213,2,'[{100,[{16050001,15}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,4}]}]'),(16040214,2,'[{100,[{16050001,26}]},{80,[{16050001,2}]},{20,[{16050001,2}]},{25,[{16050001,4}]}]'),(16040215,2,'[{100,[{16050001,36}]},{80,[{16050001,4}]},{20,[{16050001,4}]},{25,[{16050001,4}]}]'),(16040221,2,'[{100,[{16050001,31}]},{80,[{16050001,3}]},{20,[{16050001,3}]},{25,[{16050001,4}]}]'),(16040222,2,'[{100,[{16050001,45}]},{80,[{16050001,5}]},{20,[{16050001,5}]},{25,[{16050001,4}]}]'),(16040223,2,'[{100,[{16050001,61}]},{80,[{16050001,6}]},{20,[{16050001,6}]},{25,[{16050001,4}]}]'),(16040224,2,'[{100,[{16050001,104}]},{80,[{16050001,11}]},{20,[{16050001,11}]},{25,[{16050001,4}]}]'),(16040225,2,'[{100,[{16050001,148}]},{80,[{16050001,16}]},{20,[{16050001,16}]},{25,[{16050001,4}]}]'),(16040231,2,'[{100,[{16050001,126}]},{80,[{16050001,14}]},{20,[{16050001,14}]},{25,[{16050001,1}]}]'),(16040232,2,'[{100,[{16050001,185}]},{80,[{16050001,20}]},{20,[{16050001,20}]},{25,[{16050001,4}]}]'),(16040233,2,'[{100,[{16050001,244}]},{80,[{16050001,27}]},{20,[{16050001,27}]},{25,[{16050001,4}]}]'),(16040234,2,'[{100,[{16050001,419}]},{80,[{16050001,46}]},{20,[{16050001,46}]},{25,[{16050001,4}]}]'),(16040235,2,'[{100,[{16050001,594}]},{80,[{16050001,66}]},{20,[{16050001,66}]},{25,[{16050001,4}]}]'),(16040241,2,'[{100,[{16050001,507}]},{80,[{16050001,56}]},{20,[{16050001,56}]},{25,[{16050001,4}]}]'),(16040242,2,'[{100,[{16050001,745}]},{80,[{16050001,82}]},{20,[{16050001,82}]},{25,[{16050001,4}]}]'),(16040243,2,'[{100,[{16050001,982}]},{80,[{16050001,109}]},{20,[{16050001,109}]},{25,[{16050001,4}]}]'),(16040244,2,'[{100,[{16050001,1683}]},{80,[{16050001,187}]},{20,[{16050001,187}]},{25,[{16050001,1}]}]'),(16040245,2,'[{100,[{16050001,2383}]},{80,[{16050001,264}]},{20,[{16050001,264}]},{25,[{16050001,4}]}]'),(16040251,2,'[{100,[{16050001,2218}]},{80,[{16050001,246}]},{20,[{16050001,246}]},{25,[{16050001,4}]}]'),(16040252,2,'[{100,[{16050001,3106}]},{80,[{16050001,345}]},{20,[{16050001,345}]},{25,[{16050001,4}]}]'),(16040253,2,'[{100,[{16050001,4770}]},{80,[{16050001,530}]},{20,[{16050001,530}]},{25,[{16050001,4}]}]'),(16040254,2,'[{100,[{16050001,6435}]},{80,[{16050001,715}]},{20,[{16050001,715}]},{25,[{16050001,1}]}]'),(16040255,2,'[{100,[{16050001,8100}]},{80,[{16050001,900}]},{20,[{16050001,900}]},{25,[{16050001,1}]}]'),(16040301,2,'[{100,[{16050001,2}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,1}]}]'),(16040302,2,'[{100,[{16050001,3}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,1}]}]'),(16040303,2,'[{100,[{16050001,4}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,1}]}]'),(16040304,2,'[{100,[{16050001,6}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,1}]}]'),(16040305,2,'[{100,[{16050001,9}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,1}]}]'),(16040311,2,'[{100,[{16050001,8}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,1}]}]'),(16040312,2,'[{100,[{16050001,11}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,4}]}]'),(16040313,2,'[{100,[{16050001,15}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,4}]}]'),(16040314,2,'[{100,[{16050001,26}]},{80,[{16050001,2}]},{20,[{16050001,2}]},{25,[{16050001,4}]}]'),(16040315,2,'[{100,[{16050001,36}]},{80,[{16050001,4}]},{20,[{16050001,4}]},{25,[{16050001,4}]}]'),(16040321,2,'[{100,[{16050001,31}]},{80,[{16050001,3}]},{20,[{16050001,3}]},{25,[{16050001,4}]}]'),(16040322,2,'[{100,[{16050001,45}]},{80,[{16050001,5}]},{20,[{16050001,5}]},{25,[{16050001,4}]}]'),(16040323,2,'[{100,[{16050001,61}]},{80,[{16050001,6}]},{20,[{16050001,6}]},{25,[{16050001,4}]}]'),(16040324,2,'[{100,[{16050001,104}]},{80,[{16050001,11}]},{20,[{16050001,11}]},{25,[{16050001,4}]}]'),(16040325,2,'[{100,[{16050001,148}]},{80,[{16050001,16}]},{20,[{16050001,16}]},{25,[{16050001,4}]}]'),(16040331,2,'[{100,[{16050001,126}]},{80,[{16050001,14}]},{20,[{16050001,14}]},{25,[{16050001,1}]}]'),(16040332,2,'[{100,[{16050001,185}]},{80,[{16050001,20}]},{20,[{16050001,20}]},{25,[{16050001,4}]}]'),(16040333,2,'[{100,[{16050001,244}]},{80,[{16050001,27}]},{20,[{16050001,27}]},{25,[{16050001,4}]}]'),(16040334,2,'[{100,[{16050001,419}]},{80,[{16050001,46}]},{20,[{16050001,46}]},{25,[{16050001,4}]}]'),(16040335,2,'[{100,[{16050001,594}]},{80,[{16050001,66}]},{20,[{16050001,66}]},{25,[{16050001,4}]}]'),(16040341,2,'[{100,[{16050001,507}]},{80,[{16050001,56}]},{20,[{16050001,56}]},{25,[{16050001,4}]}]'),(16040342,2,'[{100,[{16050001,745}]},{80,[{16050001,82}]},{20,[{16050001,82}]},{25,[{16050001,4}]}]'),(16040343,2,'[{100,[{16050001,982}]},{80,[{16050001,109}]},{20,[{16050001,109}]},{25,[{16050001,4}]}]'),(16040344,2,'[{100,[{16050001,1683}]},{80,[{16050001,187}]},{20,[{16050001,187}]},{25,[{16050001,1}]}]'),(16040345,2,'[{100,[{16050001,2383}]},{80,[{16050001,264}]},{20,[{16050001,264}]},{25,[{16050001,4}]}]'),(16040351,2,'[{100,[{16050001,2218}]},{80,[{16050001,246}]},{20,[{16050001,246}]},{25,[{16050001,4}]}]'),(16040352,2,'[{100,[{16050001,3106}]},{80,[{16050001,345}]},{20,[{16050001,345}]},{25,[{16050001,4}]}]'),(16040353,2,'[{100,[{16050001,4770}]},{80,[{16050001,530}]},{20,[{16050001,530}]},{25,[{16050001,4}]}]'),(16040354,2,'[{100,[{16050001,6435}]},{80,[{16050001,715}]},{20,[{16050001,715}]},{25,[{16050001,1}]}]'),(16040355,2,'[{100,[{16050001,8100}]},{80,[{16050001,900}]},{20,[{16050001,900}]},{25,[{16050001,1}]}]'),(16040401,2,'[{100,[{16050001,2}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,1}]}]'),(16040402,2,'[{100,[{16050001,3}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,1}]}]'),(16040403,2,'[{100,[{16050001,4}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,1}]}]'),(16040404,2,'[{100,[{16050001,6}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,1}]}]'),(16040405,2,'[{100,[{16050001,9}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,1}]}]'),(16040411,2,'[{100,[{16050001,8}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,1}]}]'),(16040412,2,'[{100,[{16050001,11}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,4}]}]'),(16040413,2,'[{100,[{16050001,15}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,4}]}]'),(16040414,2,'[{100,[{16050001,26}]},{80,[{16050001,2}]},{20,[{16050001,2}]},{25,[{16050001,4}]}]'),(16040415,2,'[{100,[{16050001,36}]},{80,[{16050001,4}]},{20,[{16050001,4}]},{25,[{16050001,4}]}]'),(16040421,2,'[{100,[{16050001,31}]},{80,[{16050001,3}]},{20,[{16050001,3}]},{25,[{16050001,4}]}]'),(16040422,2,'[{100,[{16050001,45}]},{80,[{16050001,5}]},{20,[{16050001,5}]},{25,[{16050001,4}]}]'),(16040423,2,'[{100,[{16050001,61}]},{80,[{16050001,6}]},{20,[{16050001,6}]},{25,[{16050001,4}]}]'),(16040424,2,'[{100,[{16050001,104}]},{80,[{16050001,11}]},{20,[{16050001,11}]},{25,[{16050001,4}]}]'),(16040425,2,'[{100,[{16050001,148}]},{80,[{16050001,16}]},{20,[{16050001,16}]},{25,[{16050001,4}]}]'),(16040431,2,'[{100,[{16050001,126}]},{80,[{16050001,14}]},{20,[{16050001,14}]},{25,[{16050001,1}]}]'),(16040432,2,'[{100,[{16050001,185}]},{80,[{16050001,20}]},{20,[{16050001,20}]},{25,[{16050001,4}]}]'),(16040433,2,'[{100,[{16050001,244}]},{80,[{16050001,27}]},{20,[{16050001,27}]},{25,[{16050001,4}]}]'),(16040434,2,'[{100,[{16050001,419}]},{80,[{16050001,46}]},{20,[{16050001,46}]},{25,[{16050001,4}]}]'),(16040435,2,'[{100,[{16050001,594}]},{80,[{16050001,66}]},{20,[{16050001,66}]},{25,[{16050001,4}]}]'),(16040441,2,'[{100,[{16050001,507}]},{80,[{16050001,56}]},{20,[{16050001,56}]},{25,[{16050001,4}]}]'),(16040442,2,'[{100,[{16050001,745}]},{80,[{16050001,82}]},{20,[{16050001,82}]},{25,[{16050001,4}]}]'),(16040443,2,'[{100,[{16050001,982}]},{80,[{16050001,109}]},{20,[{16050001,109}]},{25,[{16050001,4}]}]'),(16040444,2,'[{100,[{16050001,1683}]},{80,[{16050001,187}]},{20,[{16050001,187}]},{25,[{16050001,1}]}]'),(16040445,2,'[{100,[{16050001,2383}]},{80,[{16050001,264}]},{20,[{16050001,264}]},{25,[{16050001,4}]}]'),(16040451,2,'[{100,[{16050001,2218}]},{80,[{16050001,246}]},{20,[{16050001,246}]},{25,[{16050001,4}]}]'),(16040452,2,'[{100,[{16050001,3106}]},{80,[{16050001,345}]},{20,[{16050001,345}]},{25,[{16050001,4}]}]'),(16040453,2,'[{100,[{16050001,4770}]},{80,[{16050001,530}]},{20,[{16050001,530}]},{25,[{16050001,4}]}]'),(16040454,2,'[{100,[{16050001,6435}]},{80,[{16050001,715}]},{20,[{16050001,715}]},{25,[{16050001,1}]}]'),(16040455,2,'[{100,[{16050001,8100}]},{80,[{16050001,900}]},{20,[{16050001,900}]},{25,[{16050001,1}]}]'),(16040501,2,'[{100,[{16050001,2}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,1}]}]'),(16040502,2,'[{100,[{16050001,3}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,1}]}]'),(16040503,2,'[{100,[{16050001,4}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,1}]}]'),(16040504,2,'[{100,[{16050001,6}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,1}]}]'),(16040505,2,'[{100,[{16050001,9}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,1}]}]'),(16040511,2,'[{100,[{16050001,8}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,1}]}]'),(16040512,2,'[{100,[{16050001,11}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,4}]}]'),(16040513,2,'[{100,[{16050001,15}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,4}]}]'),(16040514,2,'[{100,[{16050001,26}]},{80,[{16050001,2}]},{20,[{16050001,2}]},{25,[{16050001,4}]}]'),(16040515,2,'[{100,[{16050001,36}]},{80,[{16050001,4}]},{20,[{16050001,4}]},{25,[{16050001,4}]}]'),(16040521,2,'[{100,[{16050001,31}]},{80,[{16050001,3}]},{20,[{16050001,3}]},{25,[{16050001,4}]}]'),(16040522,2,'[{100,[{16050001,45}]},{80,[{16050001,5}]},{20,[{16050001,5}]},{25,[{16050001,4}]}]'),(16040523,2,'[{100,[{16050001,61}]},{80,[{16050001,6}]},{20,[{16050001,6}]},{25,[{16050001,4}]}]'),(16040524,2,'[{100,[{16050001,104}]},{80,[{16050001,11}]},{20,[{16050001,11}]},{25,[{16050001,4}]}]'),(16040525,2,'[{100,[{16050001,148}]},{80,[{16050001,16}]},{20,[{16050001,16}]},{25,[{16050001,4}]}]'),(16040531,2,'[{100,[{16050001,126}]},{80,[{16050001,14}]},{20,[{16050001,14}]},{25,[{16050001,1}]}]'),(16040532,2,'[{100,[{16050001,185}]},{80,[{16050001,20}]},{20,[{16050001,20}]},{25,[{16050001,4}]}]'),(16040533,2,'[{100,[{16050001,244}]},{80,[{16050001,27}]},{20,[{16050001,27}]},{25,[{16050001,4}]}]'),(16040534,2,'[{100,[{16050001,419}]},{80,[{16050001,46}]},{20,[{16050001,46}]},{25,[{16050001,4}]}]'),(16040535,2,'[{100,[{16050001,594}]},{80,[{16050001,66}]},{20,[{16050001,66}]},{25,[{16050001,4}]}]'),(16040541,2,'[{100,[{16050001,507}]},{80,[{16050001,56}]},{20,[{16050001,56}]},{25,[{16050001,4}]}]'),(16040542,2,'[{100,[{16050001,745}]},{80,[{16050001,82}]},{20,[{16050001,82}]},{25,[{16050001,4}]}]'),(16040543,2,'[{100,[{16050001,982}]},{80,[{16050001,109}]},{20,[{16050001,109}]},{25,[{16050001,4}]}]'),(16040544,2,'[{100,[{16050001,1683}]},{80,[{16050001,187}]},{20,[{16050001,187}]},{25,[{16050001,1}]}]'),(16040545,2,'[{100,[{16050001,2383}]},{80,[{16050001,264}]},{20,[{16050001,264}]},{25,[{16050001,4}]}]'),(16040551,2,'[{100,[{16050001,2218}]},{80,[{16050001,246}]},{20,[{16050001,246}]},{25,[{16050001,4}]}]'),(16040552,2,'[{100,[{16050001,3106}]},{80,[{16050001,345}]},{20,[{16050001,345}]},{25,[{16050001,4}]}]'),(16040553,2,'[{100,[{16050001,4770}]},{80,[{16050001,530}]},{20,[{16050001,530}]},{25,[{16050001,4}]}]'),(16040554,2,'[{100,[{16050001,6435}]},{80,[{16050001,715}]},{20,[{16050001,715}]},{25,[{16050001,1}]}]'),(16040555,2,'[{100,[{16050001,8100}]},{80,[{16050001,900}]},{20,[{16050001,900}]},{25,[{16050001,1}]}]'),(16040601,2,'[{100,[{16050001,2}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,1}]}]'),(16040602,2,'[{100,[{16050001,3}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,1}]}]'),(16040603,2,'[{100,[{16050001,4}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,1}]}]'),(16040604,2,'[{100,[{16050001,6}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,1}]}]'),(16040605,2,'[{100,[{16050001,9}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,1}]}]'),(16040611,2,'[{100,[{16050001,8}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,1}]}]'),(16040612,2,'[{100,[{16050001,11}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,4}]}]'),(16040613,2,'[{100,[{16050001,15}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,4}]}]'),(16040614,2,'[{100,[{16050001,26}]},{80,[{16050001,2}]},{20,[{16050001,2}]},{25,[{16050001,4}]}]'),(16040615,2,'[{100,[{16050001,36}]},{80,[{16050001,4}]},{20,[{16050001,4}]},{25,[{16050001,4}]}]'),(16040621,2,'[{100,[{16050001,31}]},{80,[{16050001,3}]},{20,[{16050001,3}]},{25,[{16050001,4}]}]'),(16040622,2,'[{100,[{16050001,45}]},{80,[{16050001,5}]},{20,[{16050001,5}]},{25,[{16050001,4}]}]'),(16040623,2,'[{100,[{16050001,61}]},{80,[{16050001,6}]},{20,[{16050001,6}]},{25,[{16050001,4}]}]'),(16040624,2,'[{100,[{16050001,104}]},{80,[{16050001,11}]},{20,[{16050001,11}]},{25,[{16050001,4}]}]'),(16040625,2,'[{100,[{16050001,148}]},{80,[{16050001,16}]},{20,[{16050001,16}]},{25,[{16050001,4}]}]'),(16040631,2,'[{100,[{16050001,126}]},{80,[{16050001,14}]},{20,[{16050001,14}]},{25,[{16050001,1}]}]'),(16040632,2,'[{100,[{16050001,185}]},{80,[{16050001,20}]},{20,[{16050001,20}]},{25,[{16050001,4}]}]'),(16040633,2,'[{100,[{16050001,244}]},{80,[{16050001,27}]},{20,[{16050001,27}]},{25,[{16050001,4}]}]'),(16040634,2,'[{100,[{16050001,419}]},{80,[{16050001,46}]},{20,[{16050001,46}]},{25,[{16050001,4}]}]'),(16040635,2,'[{100,[{16050001,594}]},{80,[{16050001,66}]},{20,[{16050001,66}]},{25,[{16050001,4}]}]'),(16040641,2,'[{100,[{16050001,507}]},{80,[{16050001,56}]},{20,[{16050001,56}]},{25,[{16050001,4}]}]'),(16040642,2,'[{100,[{16050001,745}]},{80,[{16050001,82}]},{20,[{16050001,82}]},{25,[{16050001,4}]}]'),(16040643,2,'[{100,[{16050001,982}]},{80,[{16050001,109}]},{20,[{16050001,109}]},{25,[{16050001,4}]}]'),(16040644,2,'[{100,[{16050001,1683}]},{80,[{16050001,187}]},{20,[{16050001,187}]},{25,[{16050001,1}]}]'),(16040645,2,'[{100,[{16050001,2383}]},{80,[{16050001,264}]},{20,[{16050001,264}]},{25,[{16050001,4}]}]'),(16040651,2,'[{100,[{16050001,2218}]},{80,[{16050001,246}]},{20,[{16050001,246}]},{25,[{16050001,4}]}]'),(16040652,2,'[{100,[{16050001,3106}]},{80,[{16050001,345}]},{20,[{16050001,345}]},{25,[{16050001,4}]}]'),(16040653,2,'[{100,[{16050001,4770}]},{80,[{16050001,530}]},{20,[{16050001,530}]},{25,[{16050001,4}]}]'),(16040654,2,'[{100,[{16050001,6435}]},{80,[{16050001,715}]},{20,[{16050001,715}]},{25,[{16050001,1}]}]'),(16040655,2,'[{100,[{16050001,8100}]},{80,[{16050001,900}]},{20,[{16050001,900}]},{25,[{16050001,1}]}]'),(16080000,1,'[{100,[{16050001,2}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,1}]}]'),(16080001,1,'[{100,[{16050001,8}]},{80,[{16050001,1}]},{20,[{16050001,1}]},{25,[{16050001,1}]}]'),(16080002,1,'[{100,[{16050001,31}]},{80,[{16050001,3}]},{20,[{16050001,3}]},{25,[{16050001,4}]}]'),(16080003,1,'[{100,[{16050001,126}]},{80,[{16050001,14}]},{20,[{16050001,14}]},{25,[{16050001,1}]}]'),(16080004,1,'[{100,[{16050001,507}]},{80,[{16050001,56}]},{20,[{16050001,56}]},{25,[{16050001,4}]}]'),(16080005,1,'[{100,[{16050001,2218}]},{80,[{16050001,246}]},{20,[{16050001,246}]},{25,[{16050001,4}]}]');
/*!40000 ALTER TABLE `base_mount_equip_smelt` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_mount_figure`
--

DROP TABLE IF EXISTS `base_mount_figure`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_mount_figure` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '名字@lang@',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '描述@lang@',
  `ride_figure` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '骑乘形象',
  `stage_lim` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '阶数限制 需要坐骑达到多少阶才能培养',
  `skill_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT '技能列表',
  `is_tv` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否传闻',
  `activity_goods` varchar(255) NOT NULL DEFAULT '[]' COMMENT '激活道具[{goods_id, time}]',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='幻形形象配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_mount_figure`
--

LOCK TABLES `base_mount_figure` WRITE;
/*!40000 ALTER TABLE `base_mount_figure` DISABLE KEYS */;
INSERT INTO `base_mount_figure` VALUES (1,'呆萌兔','小白兔，粉又粉',301002,0,'[14030001,14030002,14030003,14030004]',1,'[{16030003,0}]'),(2,'猫咪飞椅','萌宠猫咪带领你去冒险~~',302012,0,'[14080001,14080002,14080003,14080004]',1,'[{16030008,0}]'),(3,'旋翼飞空艇','开飞机的舒克同款',302001,0,'[14020001,14020002,14020003,14020004]',1,'[{16030002,0}]'),(4,'旅行蜗牛','和大旅行家牛牛一起展开冒险吧',302008,0,'[14060001,14060002,14060003,14060004]',1,'[{16030006,0}]'),(5,'白熊首领','熊界一霸霸',302009,0,'[14100001,14100002,14100003,14100004]',1,'[{16030010,0}]'),(6,'魔法飞毯','魔法魔法魔法，飞飞飞',302011,0,'[14090001,14090002,14090003,14090004]',1,'[{16030009,0}]'),(7,'机械达人','掌控机械就是掌控未来',302013,0,'[14070001,14070002,14070003,14070004]',1,'[{16030007,0}]'),(8,'赤炎飓风','变身为赤炎飓风',302002,0,'[14010001,14010002,14010003,14010004]',1,'[{16030001,0},{16070001,604800}]'),(9,'利维坦','化身利维坦，掌管龙王宝藏',302006,0,'[14050001,14050002,14050003,14050004]',1,'[{16030005,0}]'),(10,'尸烬龙','变身为尸烬龙，skring',302004,0,'[14040001,14040002,14040003,14040004]',1,'[{16030004,0}]'),(11,'夏日闲鸭','夏天这么热，一起喝饮料啊',302016,0,'[14110001,14110002,14110003,14110004]',1,'[{16030011,0}]'),(12,'科技魔狼','体验科技的快感',302014,0,'[14120001,14120002,14120003,14120004]',1,'[{16030012,0}]'),(13,'大佬座驾','大佬座驾，奢华享受',302015,0,'[14130001,14130002,14130003,14130004]',1,'[{16030013,0}]');
/*!40000 ALTER TABLE `base_mount_figure` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_mount_figure_stage`
--

DROP TABLE IF EXISTS `base_mount_figure_stage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_mount_figure_stage` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `stage` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '阶数',
  `blessing` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '升阶所需祝福值',
  `attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '属性',
  `combat` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战力',
  `is_tv` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否传闻',
  `goods` varchar(255) NOT NULL DEFAULT '[]' COMMENT '升阶道具经验',
  PRIMARY KEY (`id`,`stage`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='坐骑幻化形象阶数配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_mount_figure_stage`
--

LOCK TABLES `base_mount_figure_stage` WRITE;
/*!40000 ALTER TABLE `base_mount_figure_stage` DISABLE KEYS */;
INSERT INTO `base_mount_figure_stage` VALUES (1,0,0,'[{1,0},{2,0},{49,0}]',0,0,'[{16020001,30},{16030003,2300}]'),(1,1,2290,'[{1,290},{2,5800},{49,73}]',0,1,'[{16020001,30},{16030003,2300}]'),(1,2,3440,'[{1,520},{2,10400},{49,131}]',0,0,'[{16020001,30},{16030003,2300}]'),(1,3,4590,'[{1,760},{2,15200},{49,191}]',0,1,'[{16020001,30},{16030003,2300}]'),(1,4,5730,'[{1,1010},{2,20200},{49,254}]',0,0,'[{16020001,30},{16030003,2300}]'),(1,5,6880,'[{1,1280},{2,25600},{49,322}]',0,1,'[{16020002,90},{16030003,2300}]'),(1,6,8030,'[{1,1570},{2,31400},{49,395}]',0,0,'[{16020002,90},{16030003,2300}]'),(1,7,9170,'[{1,1880},{2,37600},{49,473}]',0,1,'[{16020002,90},{16030003,2300}]'),(1,8,11470,'[{1,2210},{2,44200},{49,556}]',0,1,'[{16020002,90},{16030003,2300}]'),(1,9,13760,'[{1,2570},{2,51400},{49,646}]',0,1,'[{16020003,270},{16030003,2300}]'),(1,10,0,'[{1,2970},{2,59400},{49,746}]',0,1,'[{16020003,270},{16030003,2300}]'),(2,0,0,'[{1,0},{2,0},{49,0},{60,0},{20,0}]',0,0,'[{16020001,30},{16030008,12310}]'),(2,1,12290,'[{1,1540},{2,30800},{49,385},{60,80},{20,120}]',0,1,'[{16020001,30},{16030008,12310}]'),(2,2,18440,'[{1,2770},{2,55400},{49,693},{60,160},{20,140}]',0,0,'[{16020001,30},{16030008,12310}]'),(2,3,24590,'[{1,4050},{2,81000},{49,1013},{60,240},{20,160}]',0,1,'[{16020001,30},{16030008,12310}]'),(2,4,30730,'[{1,5400},{2,108000},{49,1351},{60,320},{20,180}]',0,0,'[{16020001,30},{16030008,12310}]'),(2,5,36880,'[{1,6830},{2,136600},{49,1709},{60,400},{20,200}]',0,1,'[{16020002,90},{16030008,12310}]'),(2,6,43030,'[{1,8370},{2,167400},{49,2094},{60,480},{20,220}]',0,0,'[{16020002,90},{16030008,12310}]'),(2,7,49170,'[{1,10040},{2,200800},{49,2512},{60,560},{20,240}]',0,1,'[{16020002,90},{16030008,12310}]'),(2,8,61470,'[{1,11820},{2,236400},{49,2957},{60,640},{20,260}]',0,1,'[{16020002,90},{16030008,12310}]'),(2,9,73760,'[{1,13740},{2,274800},{49,3437},{60,720},{20,280}]',0,1,'[{16020003,270},{16030008,12310}]'),(2,10,0,'[{1,15890},{2,317800},{49,3975},{60,800},{20,300}]',0,1,'[{16020003,270},{16030008,12310}]'),(3,0,0,'[{1,0},{2,0},{49,0},{60,0},{9,0}]',0,0,'[{16020001,30},{16030002,3300}]'),(3,1,3290,'[{1,415},{2,8300},{49,104},{60,40},{9,100}]',0,1,'[{16020001,30},{16030002,3300}]'),(3,2,4940,'[{1,748},{2,14960},{49,187},{60,80},{9,110}]',0,0,'[{16020001,30},{16030002,3300}]'),(3,3,6590,'[{1,1091},{2,21820},{49,273},{60,120},{9,120}]',0,1,'[{16020001,30},{16030002,3300}]'),(3,4,8230,'[{1,1453},{2,29060},{49,364},{60,160},{9,130}]',0,0,'[{16020001,30},{16030002,3300}]'),(3,5,9880,'[{1,1843},{2,36860},{49,462},{60,200},{9,140}]',0,1,'[{16020002,90},{16030002,3300}]'),(3,6,11530,'[{1,2261},{2,45220},{49,567},{60,240},{9,150}]',0,0,'[{16020002,90},{16030002,3300}]'),(3,7,13170,'[{1,2705},{2,54100},{49,678},{60,280},{9,160}]',0,1,'[{16020002,90},{16030002,3300}]'),(3,8,16470,'[{1,3179},{2,63580},{49,797},{60,320},{9,170}]',0,1,'[{16020002,90},{16030002,3300}]'),(3,9,19760,'[{1,3699},{2,73980},{49,927},{60,360},{9,180}]',0,1,'[{16020003,270},{16030002,3300}]'),(3,10,0,'[{1,4273},{2,85460},{49,1071},{60,400},{9,190}]',0,1,'[{16020003,270},{16030002,3300}]'),(4,0,0,'[{1,0},{2,0},{49,0},{60,0},{27,0}]',0,0,'[{16020001,30},{16030006,4300}]'),(4,1,4290,'[{1,540},{2,10800},{49,135},{60,50},{27,150}]',0,1,'[{16020001,30},{16030006,4300}]'),(4,2,6440,'[{1,970},{2,19400},{49,243},{60,100},{27,165}]',0,0,'[{16020001,30},{16030006,4300}]'),(4,3,8590,'[{1,1420},{2,28400},{49,356},{60,150},{27,180}]',0,1,'[{16020001,30},{16030006,4300}]'),(4,4,10730,'[{1,1890},{2,37800},{49,474},{60,200},{27,195}]',0,0,'[{16020001,30},{16030006,4300}]'),(4,5,12880,'[{1,2390},{2,47800},{49,599},{60,250},{27,210}]',0,1,'[{16020002,90},{16030006,4300}]'),(4,6,15030,'[{1,2930},{2,58600},{49,734},{60,300},{27,225}]',0,0,'[{16020002,90},{16030006,4300}]'),(4,7,17170,'[{1,3510},{2,70200},{49,879},{60,350},{27,240}]',0,1,'[{16020002,90},{16030006,4300}]'),(4,8,21470,'[{1,4130},{2,82600},{49,1034},{60,400},{27,255}]',0,1,'[{16020002,90},{16030006,4300}]'),(4,9,25760,'[{1,4800},{2,96000},{49,1202},{60,450},{27,270}]',0,1,'[{16020003,270},{16030006,4300}]'),(4,10,0,'[{1,5550},{2,111000},{49,1390},{60,500},{27,285}]',0,1,'[{16020003,270},{16030006,4300}]'),(5,0,0,'[{1,1620},{2,32400},{49,405},{60,80},{19,120}]',0,0,'[{16020001,30},{16030010,12970}]'),(5,1,12960,'[{1,2910},{2,58200},{49,728},{60,160},{19,140}]',0,1,'[{16020001,30},{16030010,12970}]'),(5,2,19440,'[{1,4250},{2,85000},{49,1063},{60,240},{19,160}]',0,0,'[{16020001,30},{16030010,12970}]'),(5,3,25920,'[{1,5680},{2,113600},{49,1421},{60,320},{19,180}]',0,1,'[{16020001,30},{16030010,12970}]'),(5,4,32400,'[{1,7190},{2,143800},{49,1799},{60,400},{19,200}]',0,0,'[{16020001,30},{16030010,12970}]'),(5,5,38880,'[{1,8810},{2,176200},{49,2204},{60,480},{19,220}]',0,1,'[{16020002,90},{16030010,12970}]'),(5,6,45360,'[{1,10580},{2,211600},{49,2647},{60,560},{19,240}]',0,0,'[{16020002,90},{16030010,12970}]'),(5,7,51840,'[{1,12460},{2,249200},{49,3117},{60,640},{19,260}]',0,1,'[{16020002,90},{16030010,12970}]'),(5,8,64800,'[{1,14480},{2,289600},{49,3622},{60,720},{19,280}]',0,1,'[{16020002,90},{16030010,12970}]'),(5,9,77760,'[{1,16750},{2,335000},{49,4190},{60,800},{19,300}]',0,1,'[{16020003,270},{16030010,12970}]'),(5,10,0,'[{1,16320},{2,326400},{49,4083},{61,0},{52,570}]',0,1,'[{16020003,270},{16030010,12970}]'),(6,0,0,'[{1,0},{2,0},{49,0},{60,0},{54,0}]',0,0,'[{16020001,30},{16030009,12640}]'),(6,1,12630,'[{1,1580},{2,31600},{49,395},{61,0},{52,300}]',0,1,'[{16020001,30},{16030009,12640}]'),(6,2,18940,'[{1,2840},{2,56800},{49,710},{61,0},{52,330}]',0,0,'[{16020001,30},{16030009,12640}]'),(6,3,25250,'[{1,4150},{2,83000},{49,1038},{61,0},{52,360}]',0,1,'[{16020001,30},{16030009,12640}]'),(6,4,31570,'[{1,5540},{2,110800},{49,1386},{61,0},{52,390}]',0,0,'[{16020001,30},{16030009,12640}]'),(6,5,37880,'[{1,7010},{2,140200},{49,1754},{61,0},{52,420}]',0,1,'[{16020002,90},{16030009,12640}]'),(6,6,44190,'[{1,8590},{2,171800},{49,2149},{61,0},{52,450}]',0,0,'[{16020002,90},{16030009,12640}]'),(6,7,50510,'[{1,10310},{2,206200},{49,2579},{61,0},{52,480}]',0,1,'[{16020002,90},{16030009,12640}]'),(6,8,63130,'[{1,12140},{2,242800},{49,3037},{61,0},{52,510}]',0,1,'[{16020002,90},{16030009,12640}]'),(6,9,75760,'[{1,14110},{2,282200},{49,3530},{61,0},{52,540}]',0,1,'[{16020003,270},{16030009,12640}]'),(6,10,0,'[{1,16320},{2,326400},{49,4083},{61,0},{52,570}]',0,1,'[{16020003,270},{16030009,12640}]'),(7,0,0,'[{1,0},{2,0},{49,0},{61,0},{13,0}]',0,0,'[{16020001,30},{16030007,11980}]'),(7,1,11960,'[{1,1500},{2,30000},{49,375},{61,80},{13,150}]',0,1,'[{16020001,30},{16030007,11980}]'),(7,2,17940,'[{1,2700},{2,54000},{49,675},{61,160},{13,165}]',0,0,'[{16020001,30},{16030007,11980}]'),(7,3,23920,'[{1,3950},{2,79000},{49,988},{61,240},{13,180}]',0,1,'[{16020001,30},{16030007,11980}]'),(7,4,29900,'[{1,5260},{2,105200},{49,1316},{61,320},{13,195}]',0,0,'[{16020001,30},{16030007,11980}]'),(7,5,35880,'[{1,6650},{2,133000},{49,1664},{61,400},{13,210}]',0,1,'[{16020002,90},{16030007,11980}]'),(7,6,41860,'[{1,8150},{2,163000},{49,2039},{61,480},{13,225}]',0,0,'[{16020002,90},{16030007,11980}]'),(7,7,47840,'[{1,9770},{2,195400},{49,2444},{61,560},{13,240}]',0,1,'[{16020002,90},{16030007,11980}]'),(7,8,59800,'[{1,11500},{2,230000},{49,2877},{61,640},{13,255}]',0,1,'[{16020002,90},{16030007,11980}]'),(7,9,71760,'[{1,13370},{2,267400},{49,3345},{61,720},{13,270}]',0,1,'[{16020003,270},{16030007,11980}]'),(7,10,0,'[{1,15460},{2,309200},{49,3868},{61,800},{13,285}]',0,1,'[{16020003,270},{16030007,11980}]'),(8,0,0,'[{1,0},{2,0},{49,0},{61,0},{10,0}]',0,0,'[{16020001,30},{16030001,6650}]'),(8,1,6630,'[{1,840},{2,16800},{49,210},{61,60},{10,300}]',0,1,'[{16020001,30},{16030001,6650}]'),(8,2,9940,'[{1,1510},{2,30200},{49,378},{61,120},{10,330}]',0,0,'[{16020001,30},{16030001,6650}]'),(8,3,13250,'[{1,2200},{2,44000},{49,551},{61,180},{10,360}]',0,1,'[{16020001,30},{16030001,6650}]'),(8,4,16570,'[{1,2930},{2,58600},{49,734},{61,240},{10,390}]',0,0,'[{16020001,30},{16030001,6650}]'),(8,5,19880,'[{1,3710},{2,74200},{49,929},{61,300},{10,420}]',0,1,'[{16020002,90},{16030001,6650}]'),(8,6,23190,'[{1,4550},{2,91000},{49,1139},{61,360},{10,450}]',0,0,'[{16020002,90},{16030001,6650}]'),(8,7,26510,'[{1,5440},{2,108800},{49,1362},{61,420},{10,480}]',0,1,'[{16020002,90},{16030001,6650}]'),(8,8,33130,'[{1,6390},{2,127800},{49,1600},{61,480},{10,510}]',0,1,'[{16020002,90},{16030001,6650}]'),(8,9,39760,'[{1,7440},{2,148800},{49,1863},{61,540},{10,540}]',0,1,'[{16020003,270},{16030001,6650}]'),(8,10,0,'[{1,8590},{2,171800},{49,2151},{61,600},{10,570}]',0,1,'[{16020003,270},{16030001,6650}]'),(9,0,0,'[{1,0},{2,0},{49,0},{61,0},{55,0}]',0,0,'[{16020001,30},{16030005,9600}]'),(9,1,9630,'[{1,1220},{2,24400},{49,305},{61,80},{55,200}]',0,1,'[{16020001,30},{16030005,9600}]'),(9,2,14440,'[{1,2190},{2,43800},{49,548},{61,160},{55,220}]',0,0,'[{16020001,30},{16030005,9600}]'),(9,3,19250,'[{1,3200},{2,64000},{49,801},{61,240},{55,240}]',0,1,'[{16020001,30},{16030005,9600}]'),(9,4,24070,'[{1,4250},{2,85000},{49,1064},{61,320},{55,260}]',0,0,'[{16020001,30},{16030005,9600}]'),(9,5,28880,'[{1,5380},{2,107600},{49,1347},{61,400},{55,280}]',0,1,'[{16020002,90},{16030005,9600}]'),(9,6,33690,'[{1,6600},{2,132000},{49,1652},{61,480},{55,300}]',0,0,'[{16020002,90},{16030005,9600}]'),(9,7,38510,'[{1,7900},{2,158000},{49,1977},{61,560},{55,320}]',0,1,'[{16020002,90},{16030005,9600}]'),(9,8,48130,'[{1,9280},{2,185600},{49,2322},{61,640},{55,340}]',0,1,'[{16020002,90},{16030005,9600}]'),(9,9,57760,'[{1,10790},{2,215800},{49,2700},{61,720},{55,360}]',0,1,'[{16020003,270},{16030005,9600}]'),(9,10,0,'[{1,12470},{2,249400},{49,3120},{61,800},{55,380}]',0,1,'[{16020003,270},{16030005,9600}]'),(10,0,0,'[{1,0},{2,0},{49,0},{60,0},{54,0}]',0,0,'[{16020001,30},{16030004,43080}]'),(10,1,42960,'[{1,5430},{2,108600},{49,1358},{60,120},{54,400}]',0,1,'[{16020001,30},{16030004,43080}]'),(10,2,64440,'[{1,9740},{2,194800},{49,2436},{60,240},{54,440}]',0,0,'[{16020001,30},{16030004,43080}]'),(10,3,85920,'[{1,14240},{2,284800},{49,3561},{60,360},{54,480}]',0,1,'[{16020001,30},{16030004,43080}]'),(10,4,107400,'[{1,18920},{2,378400},{49,4731},{60,480},{54,520}]',0,0,'[{16020001,30},{16030004,43080}]'),(10,5,128880,'[{1,23980},{2,479600},{49,5996},{60,600},{54,560}]',0,1,'[{16020002,90},{16030004,43080}]'),(10,6,150360,'[{1,29410},{2,588200},{49,7354},{60,720},{54,600}]',0,0,'[{16020002,90},{16030004,43080}]'),(10,7,171840,'[{1,35220},{2,704400},{49,8807},{60,840},{54,640}]',0,1,'[{16020002,90},{16030004,43080}]'),(10,8,214800,'[{1,41400},{2,828000},{49,10352},{60,960},{54,680}]',0,1,'[{16020002,90},{16030004,43080}]'),(10,9,257760,'[{1,48140},{2,962800},{49,12037},{60,1080},{54,720}]',0,1,'[{16020003,270},{16030004,43080}]'),(10,10,0,'[{1,55630},{2,1112600},{49,13910},{60,1200},{54,760}]',0,1,'[{16020003,270},{16030004,43080}]'),(11,0,0,'[{1,0},{2,0},{49,0},{60,0},{27,0}]',0,0,'[{16020001,30},{16030011,11640}]'),(11,1,68890,'[{1,1450},{2,29000},{49,363},{60,80},{27,200}]',0,1,'[{16020001,30},{16030011,11640}]'),(11,2,55100,'[{1,2610},{2,52200},{49,653},{60,160},{27,220}]',0,0,'[{16020001,30},{16030011,11640}]'),(11,3,57000,'[{1,3810},{2,76200},{49,953},{60,240},{27,240}]',0,1,'[{16020001,30},{16030011,11640}]'),(11,4,60800,'[{1,5090},{2,101800},{49,1273},{60,320},{27,260}]',0,0,'[{16020001,30},{16030011,11640}]'),(11,5,64140,'[{1,6440},{2,128800},{49,1611},{60,400},{27,280}]',0,1,'[{16020002,90},{16030011,11640}]'),(11,6,68890,'[{1,7890},{2,157800},{49,1974},{60,480},{27,300}]',0,0,'[{16020002,90},{16030011,11640}]'),(11,7,75540,'[{1,9480},{2,189600},{49,2372},{60,560},{27,320}]',0,1,'[{16020002,90},{16030011,11640}]'),(11,8,80290,'[{1,11170},{2,223400},{49,2795},{60,640},{27,340}]',0,1,'[{16020002,90},{16030011,11640}]'),(11,9,85990,'[{1,12980},{2,259600},{49,3248},{60,720},{27,360}]',0,1,'[{16020003,270},{16030011,11640}]'),(11,10,96900,'[{1,15020},{2,300400},{49,3758},{60,800},{27,380}]',0,1,'[{16020003,270},{16030011,11640}]'),(12,0,0,'[{1,0},{2,0},{49,0},{61,0},{28,0}]',0,0,'[{16020001,30},{16030011,11640}]'),(12,1,68890,'[{1,1450},{2,29000},{49,363},{61,80},{28,200}]',0,1,'[{16020001,30},{16030011,11640}]'),(12,2,55100,'[{1,2610},{2,52200},{49,653},{61,80},{28,220}]',0,0,'[{16020001,30},{16030011,11640}]'),(12,3,57000,'[{1,3810},{2,76200},{49,953},{61,80},{28,240}]',0,1,'[{16020001,30},{16030011,11640}]'),(12,4,60800,'[{1,5090},{2,101800},{49,1273},{61,80},{28,260}]',0,0,'[{16020001,30},{16030011,11640}]'),(12,5,64140,'[{1,6440},{2,128800},{49,1611},{61,80},{28,280}]',0,1,'[{16020002,90},{16030011,11640}]'),(12,6,68890,'[{1,7890},{2,157800},{49,1974},{61,80},{28,300}]',0,0,'[{16020002,90},{16030011,11640}]'),(12,7,75540,'[{1,9480},{2,189600},{49,2372},{61,80},{28,320}]',0,1,'[{16020002,90},{16030011,11640}]'),(12,8,80290,'[{1,11170},{2,223400},{49,2795},{61,80},{28,340}]',0,1,'[{16020002,90},{16030011,11640}]'),(12,9,85990,'[{1,12980},{2,259600},{49,3248},{61,80},{28,360}]',0,1,'[{16020003,270},{16030011,11640}]'),(12,10,96900,'[{1,15020},{2,300400},{49,3758},{61,80},{28,380}]',0,1,'[{16020003,270},{16030011,11640}]'),(13,0,0,'[{1,0},{2,0},{49,0},{61,0},{51,0}]',0,0,'[{16020001,30},{16030011,11640}]'),(13,1,68890,'[{1,1450},{2,29000},{49,363},{61,80},{51,250}]',0,1,'[{16020001,30},{16030011,11640}]'),(13,2,55100,'[{1,2610},{2,52200},{49,653},{61,80},{51,275}]',0,0,'[{16020001,30},{16030011,11640}]'),(13,3,57000,'[{1,3810},{2,76200},{49,953},{61,80},{51,300}]',0,1,'[{16020001,30},{16030011,11640}]'),(13,4,60800,'[{1,5090},{2,101800},{49,1273},{61,80},{51,325}]',0,0,'[{16020001,30},{16030011,11640}]'),(13,5,64140,'[{1,6440},{2,128800},{49,1611},{61,80},{51,350}]',0,1,'[{16020002,90},{16030011,11640}]'),(13,6,68890,'[{1,7890},{2,157800},{49,1974},{61,80},{51,375}]',0,0,'[{16020002,90},{16030011,11640}]'),(13,7,75540,'[{1,9480},{2,189600},{49,2372},{61,80},{51,400}]',0,1,'[{16020002,90},{16030011,11640}]'),(13,8,80290,'[{1,11170},{2,223400},{49,2795},{61,80},{51,425}]',0,1,'[{16020002,90},{16030011,11640}]'),(13,9,85990,'[{1,12980},{2,259600},{49,3248},{61,80},{51,450}]',0,1,'[{16020003,270},{16030011,11640}]'),(13,10,96900,'[{1,15020},{2,300400},{49,3758},{61,80},{51,475}]',0,1,'[{16020003,270},{16030011,11640}]');
/*!40000 ALTER TABLE `base_mount_figure_stage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_mount_goods`
--

DROP TABLE IF EXISTS `base_mount_goods`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_mount_goods` (
  `goods_id` int(11) unsigned NOT NULL COMMENT '道具id',
  `attr` varchar(255) NOT NULL COMMENT '属性',
  `combat` int(11) unsigned NOT NULL COMMENT '战力提供',
  `max_times` varchar(255) NOT NULL COMMENT '最大次数',
  PRIMARY KEY (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='坐骑培养道具';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_mount_goods`
--

LOCK TABLES `base_mount_goods` WRITE;
/*!40000 ALTER TABLE `base_mount_goods` DISABLE KEYS */;
INSERT INTO `base_mount_goods` VALUES (16010001,'[{2,1200},{49,25}]',1950,'[{1,250,250},{251,400,400},{401,1000,500}]'),(16010002,'[{1,60},{7,16}]',2000,'[{1,250,250},{251,400,400},{401,1000,500}]'),(16010003,'[{7,35},{49,50},{61,50}]',8000,'[{1,250,100},{251,400,150},{401,1000,200}]'),(16010004,'[{2,3600},{1,180},{49,75},{60,100}]',9450,'[{1,250,50},{251,400,80},{401,1000,100}]');
/*!40000 ALTER TABLE `base_mount_goods` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_mount_kv`
--

DROP TABLE IF EXISTS `base_mount_kv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_mount_kv` (
  `id` tinyint(3) unsigned NOT NULL COMMENT '自增id',
  `value` varchar(255) NOT NULL COMMENT '值',
  `tips` varchar(255) NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='坐骑常量配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_mount_kv`
--

LOCK TABLES `base_mount_kv` WRITE;
/*!40000 ALTER TABLE `base_mount_kv` DISABLE KEYS */;
INSERT INTO `base_mount_kv` VALUES (1,'30','坐骑系统开启等级'),(2,'30','坐骑培养页签的开启等级'),(3,'390','坐骑装备的开启等级'),(4,'390','装备打造的开启等级');
/*!40000 ALTER TABLE `base_mount_kv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_mount_skill`
--

DROP TABLE IF EXISTS `base_mount_skill`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_mount_skill` (
  `skill_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能id',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '类型 1:基础技能 2:幻形技能',
  `ownership_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '归属id 幻形技能填所属的幻形id',
  `stage` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '解锁阶段',
  PRIMARY KEY (`skill_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='坐骑技能';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_mount_skill`
--

LOCK TABLES `base_mount_skill` WRITE;
/*!40000 ALTER TABLE `base_mount_skill` DISABLE KEYS */;
INSERT INTO `base_mount_skill` VALUES (11000008,1,0,3),(14000002,1,0,1),(14000004,1,0,5),(14000005,1,0,7),(14000006,1,0,10),(14010001,2,8,3),(14010002,2,8,6),(14010003,2,8,8),(14010004,2,8,10),(14020001,2,3,3),(14020002,2,3,6),(14020003,2,3,8),(14020004,2,3,10),(14030001,2,1,3),(14030002,2,1,6),(14030003,2,1,8),(14030004,2,1,10),(14040001,2,10,3),(14040002,2,10,6),(14040003,2,10,8),(14040004,2,10,10),(14050001,2,9,3),(14050002,2,9,6),(14050003,2,9,8),(14050004,2,9,10),(14060001,2,4,3),(14060002,2,4,6),(14060003,2,4,8),(14060004,2,4,10),(14070001,2,7,3),(14070002,2,7,6),(14070003,2,7,8),(14070004,2,7,10),(14080001,2,2,3),(14080002,2,2,6),(14080003,2,2,8),(14080004,2,2,10),(14090001,2,6,3),(14090002,2,6,6),(14090003,2,6,8),(14090004,2,6,10),(14100001,2,5,3),(14100002,2,5,6),(14100003,2,5,8),(14100004,2,5,10),(14110001,2,11,3),(14110002,2,11,6),(14110003,2,11,8),(14110004,2,11,10),(14120001,2,12,3),(14120002,2,12,6),(14120003,2,12,8),(14120004,2,12,10),(14130001,2,13,3),(14130002,2,13,6),(14130003,2,13,8),(14130004,2,13,10);
/*!40000 ALTER TABLE `base_mount_skill` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_mount_stage`
--

DROP TABLE IF EXISTS `base_mount_stage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_mount_stage` (
  `stage` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '阶数',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '名字@lang@',
  `figure` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '形象id',
  `ride_figure` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '骑乘形象',
  `ride_attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '骑乘属性',
  `max_star` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '总星数',
  `is_tv` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '进阶传闻',
  `goods` varchar(255) NOT NULL DEFAULT '[]' COMMENT '升阶道具经验',
  PRIMARY KEY (`stage`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='坐骑阶级表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_mount_stage`
--

LOCK TABLES `base_mount_stage` WRITE;
/*!40000 ALTER TABLE `base_mount_stage` DISABLE KEYS */;
INSERT INTO `base_mount_stage` VALUES (1,'淘气虎',0,301022,'180',10,0,'{16020001,30}'),(2,'萌宠柯基',0,302010,'185',10,1,'{16020001,30}'),(3,'嘟嘟猪',0,302007,'190',10,1,'{16020001,30}'),(4,'暗夜战狼',0,301004,'195',10,1,'{16020001,30}'),(5,'鹰嘴兽',0,301021,'200',10,1,'{16020002,90}'),(6,'白虎瑞兽',0,301005,'205',10,1,'{16020002,90}'),(7,'披甲天蝎',0,301006,'210',10,1,'{16020002,90}'),(8,'圣金狮鹫',0,301007,'215',10,1,'{16020002,90}'),(9,'独角巨鲸',0,301009,'220',10,1,'{16020003,270}'),(10,'菲尼克斯',0,301010,'230',10,1,'{16020003,270}'),(11,'麒麟圣兽',0,301011,'240',10,1,'{16020003,270}'),(12,'炎魔龙神',0,301013,'250',10,1,'{16020003,270}');
/*!40000 ALTER TABLE `base_mount_stage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_mount_star`
--

DROP TABLE IF EXISTS `base_mount_star`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_mount_star` (
  `stage` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '阶数',
  `star` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '星数',
  `max_blessing` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '升星所需祝福值',
  `attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '属性',
  `combat` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战力',
  PRIMARY KEY (`stage`,`star`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='坐骑星级表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_mount_star`
--

LOCK TABLES `base_mount_star` WRITE;
/*!40000 ALTER TABLE `base_mount_star` DISABLE KEYS */;
INSERT INTO `base_mount_star` VALUES (1,1,20,'[{1,20},{2,400},{49,12}]',1160),(1,2,30,'[{1,41},{2,820},{49,25}]',2390),(1,3,40,'[{1,63},{2,1260},{49,38}]',3660),(1,4,50,'[{1,86},{2,1720},{49,52}]',5000),(1,5,60,'[{1,110},{2,2200},{49,66}]',6380),(1,6,70,'[{1,135},{2,2700},{49,81}]',7830),(1,7,80,'[{1,161},{2,3220},{49,97}]',9350),(1,8,90,'[{1,188},{2,3760},{49,113}]',10910),(1,9,100,'[{1,216},{2,4320},{49,130}]',12540),(1,10,115,'[{1,245},{2,4900},{49,147}]',14210),(2,1,130,'[{1,284},{2,5680},{49,170}]',16460),(2,2,145,'[{1,325},{2,6500},{49,195}]',18850),(2,3,160,'[{1,368},{2,7360},{49,221}]',21350),(2,4,175,'[{1,413},{2,8260},{49,248}]',23960),(2,5,190,'[{1,460},{2,9200},{49,276}]',26680),(2,6,205,'[{1,509},{2,10180},{49,305}]',29510),(2,7,220,'[{1,560},{2,11200},{49,336}]',32480),(2,8,235,'[{1,613},{2,12260},{49,368}]',35560),(2,9,250,'[{1,668},{2,13360},{49,401}]',38750),(2,10,270,'[{1,725},{2,14500},{49,435}]',42050),(3,1,290,'[{1,802},{2,16040},{49,481}]',46510),(3,2,310,'[{1,882},{2,17640},{49,529}]',51150),(3,3,330,'[{1,965},{2,19300},{49,579}]',55970),(3,4,350,'[{1,1051},{2,21020},{49,631}]',60970),(3,5,370,'[{1,1140},{2,22800},{49,684}]',66120),(3,6,390,'[{1,1232},{2,24640},{49,739}]',71450),(3,7,410,'[{1,1327},{2,26540},{49,796}]',76960),(3,8,430,'[{1,1425},{2,28500},{49,855}]',82650),(3,9,450,'[{1,1526},{2,30520},{49,916}]',88520),(3,10,485,'[{1,1630},{2,32600},{49,978}]',94540),(4,1,520,'[{1,1774},{2,35480},{49,1064}]',102880),(4,2,555,'[{1,1923},{2,38460},{49,1153}]',111510),(4,3,590,'[{1,2077},{2,41540},{49,1245}]',120430),(4,4,625,'[{1,2236},{2,44720},{49,1340}]',129640),(4,5,660,'[{1,2400},{2,48000},{49,1438}]',139140),(4,6,695,'[{1,2569},{2,51380},{49,1539}]',148930),(4,7,730,'[{1,2743},{2,54860},{49,1643}]',159010),(4,8,765,'[{1,2922},{2,58440},{49,1750}]',169380),(4,9,800,'[{1,3106},{2,62120},{49,1860}]',180040),(4,10,855,'[{1,3295},{2,65900},{49,1973}]',190990),(5,1,910,'[{1,3544},{2,70880},{49,2122}]',205420),(5,2,965,'[{1,3800},{2,76000},{49,2276}]',220280),(5,3,1020,'[{1,4063},{2,81260},{49,2434}]',235540),(5,4,1075,'[{1,4333},{2,86660},{49,2596}]',251200),(5,5,1130,'[{1,4610},{2,92200},{49,2762}]',267260),(5,6,1185,'[{1,4894},{2,97880},{49,2932}]',283720),(5,7,1240,'[{1,5185},{2,103700},{49,3107}]',300610),(5,8,1295,'[{1,5483},{2,109660},{49,3286}]',317900),(5,9,1350,'[{1,5788},{2,115760},{49,3469}]',335590),(5,10,1425,'[{1,6100},{2,122000},{49,3656}]',353680),(6,1,1500,'[{1,6502},{2,130040},{49,3897}]',376990),(6,2,1575,'[{1,6913},{2,138260},{49,4144}]',400840),(6,3,1650,'[{1,7333},{2,146660},{49,4396}]',425200),(6,4,1725,'[{1,7762},{2,155240},{49,4653}]',450070),(6,5,1800,'[{1,8200},{2,164000},{49,4916}]',475480),(6,6,1875,'[{1,8647},{2,172940},{49,5184}]',501400),(6,7,1950,'[{1,9103},{2,182060},{49,5458}]',527860),(6,8,2025,'[{1,9568},{2,191360},{49,5737}]',554830),(6,9,2100,'[{1,10042},{2,200840},{49,6021}]',582310),(6,10,2210,'[{1,10525},{2,210500},{49,6311}]',610330),(7,1,2320,'[{1,11128},{2,222560},{49,6673}]',645310),(7,2,2430,'[{1,11743},{2,234860},{49,7042}]',680980),(7,3,2540,'[{1,12370},{2,247400},{49,7418}]',717340),(7,4,2650,'[{1,13009},{2,260180},{49,7801}]',754390),(7,5,2760,'[{1,13660},{2,273200},{49,8192}]',792160),(7,6,2870,'[{1,14323},{2,286460},{49,8590}]',830620),(7,7,2980,'[{1,14998},{2,299960},{49,8995}]',869770),(7,8,3090,'[{1,15685},{2,313700},{49,9407}]',909610),(7,9,3200,'[{1,16384},{2,327680},{49,9826}]',950140),(7,10,3360,'[{1,17095},{2,341900},{49,10253}]',991390),(8,1,3520,'[{1,17946},{2,358920},{49,10764}]',1040760),(8,2,3680,'[{1,18812},{2,376240},{49,11284}]',1091000),(8,3,3840,'[{1,19693},{2,393860},{49,11813}]',1142110),(8,4,4000,'[{1,20589},{2,411780},{49,12351}]',1194090),(8,5,4160,'[{1,21500},{2,430000},{49,12898}]',1246940),(8,6,4320,'[{1,22426},{2,448520},{49,13454}]',1300660),(8,7,4480,'[{1,23367},{2,467340},{49,14019}]',1355250),(8,8,4640,'[{1,24323},{2,486460},{49,14593}]',1410710),(8,9,4800,'[{1,25294},{2,505880},{49,15176}]',1467040),(8,10,5010,'[{1,26280},{2,525600},{49,15768}]',1524240),(9,1,5220,'[{1,27426},{2,548520},{49,16456}]',1590720),(9,2,5430,'[{1,28590},{2,571800},{49,17154}]',1658220),(9,3,5640,'[{1,29772},{2,595440},{49,17863}]',1726770),(9,4,5850,'[{1,30972},{2,619440},{49,18583}]',1796370),(9,5,6060,'[{1,32190},{2,643800},{49,19314}]',1867020),(9,6,6270,'[{1,33426},{2,668520},{49,20056}]',1938720),(9,7,6480,'[{1,34680},{2,693600},{49,20808}]',2011440),(9,8,6690,'[{1,35952},{2,719040},{49,21571}]',2085210),(9,9,6900,'[{1,37242},{2,744840},{49,22345}]',2160030),(9,10,7160,'[{1,38550},{2,771000},{49,23130}]',2235900),(10,1,7420,'[{1,40048},{2,800960},{49,24029}]',2322790),(10,2,7680,'[{1,41567},{2,831340},{49,24940}]',2410880),(10,3,7940,'[{1,43107},{2,862140},{49,25864}]',2500200),(10,4,8200,'[{1,44668},{2,893360},{49,26801}]',2590750),(10,5,8460,'[{1,46250},{2,925000},{49,27750}]',2682500),(10,6,8720,'[{1,47853},{2,957060},{49,28712}]',2775480),(10,7,8980,'[{1,49477},{2,989540},{49,29686}]',2869660),(10,8,9240,'[{1,51122},{2,1022440},{49,30673}]',2965070),(10,9,9500,'[{1,52788},{2,1055760},{49,31673}]',3061710),(10,10,9820,'[{1,54475},{2,1089500},{49,32685}]',3159550),(11,1,10140,'[{1,56382},{2,1127640},{49,33829}]',3270150),(11,2,10460,'[{1,58313},{2,1166260},{49,34988}]',3382160),(11,3,10780,'[{1,60268},{2,1205360},{49,36161}]',3495550),(11,4,11100,'[{1,62247},{2,1244940},{49,37348}]',3610320),(11,5,11420,'[{1,64250},{2,1285000},{49,38550}]',3726500),(11,6,11740,'[{1,66277},{2,1325540},{49,39766}]',3844060),(11,7,12060,'[{1,68328},{2,1366560},{49,40997}]',3963030),(11,8,12380,'[{1,70403},{2,1408060},{49,42242}]',4083380),(11,9,12700,'[{1,72502},{2,1450040},{49,43501}]',4205110),(11,10,13100,'[{1,74625},{2,1492500},{49,44775}]',4328250),(12,1,13500,'[{1,76998},{2,1539960},{49,46199}]',4465890),(12,2,13900,'[{1,79398},{2,1587960},{49,47639}]',4605090),(12,3,14300,'[{1,81825},{2,1636500},{49,49095}]',4745850),(12,4,14700,'[{1,84279},{2,1685580},{49,50567}]',4888170),(12,5,15100,'[{1,86760},{2,1735200},{49,52056}]',5032080),(12,6,15500,'[{1,89268},{2,1785360},{49,53561}]',5177550),(12,7,15900,'[{1,91803},{2,1836060},{49,55082}]',5324580),(12,8,16300,'[{1,94365},{2,1887300},{49,56619}]',5473170),(12,9,16700,'[{1,96954},{2,1939080},{49,58172}]',5623320),(12,10,0,'[{1,99570},{2,1991400},{49,59742}]',5775060);
/*!40000 ALTER TABLE `base_mount_star` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_noon_quiz_act`
--

DROP TABLE IF EXISTS `base_noon_quiz_act`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_noon_quiz_act` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动Id',
  `tips_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动前提示时间',
  `ready_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '准备时间',
  `time_points` varchar(255) NOT NULL DEFAULT '[]' COMMENT '开始时间',
  `topic_duration` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '题目时间',
  `topic_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '题目数量',
  `interval` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '题目间隔时间',
  `clear_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '题目清理时间',
  `reward_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '结束倒计时时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='中午答题活动配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_noon_quiz_act`
--

LOCK TABLES `base_noon_quiz_act` WRITE;
/*!40000 ALTER TABLE `base_noon_quiz_act` DISABLE KEYS */;
INSERT INTO `base_noon_quiz_act` VALUES (1,60,30,'[]',15,20,5,600,10);
/*!40000 ALTER TABLE `base_noon_quiz_act` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_noon_quiz_cfg`
--

DROP TABLE IF EXISTS `base_noon_quiz_cfg`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_noon_quiz_cfg` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `key` varchar(255) NOT NULL DEFAULT '' COMMENT 'key',
  `val` varchar(255) NOT NULL DEFAULT '0' COMMENT '值',
  `desc` varchar(1024) NOT NULL DEFAULT '' COMMENT '描述',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='中午答题常量配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_noon_quiz_cfg`
--

LOCK TABLES `base_noon_quiz_cfg` WRITE;
/*!40000 ALTER TABLE `base_noon_quiz_cfg` DISABLE KEYS */;
INSERT INTO `base_noon_quiz_cfg` VALUES (1,'scene_id','5171','场景Id'),(2,'init_coordinate','{5799,1731}','初始坐标,{x,y}'),(3,'init_area_range','540','起始区域范围'),(4,'option_1_coordinate','{2478,1719}','选项1坐标,{x,y}'),(5,'option_2_coordinate','{8909,1727}','选项2坐标,{x,y}'),(6,'answer_area_range','150','答题区域范围'),(7,'need_role_lv','110','开放等级'),(9,'option_1_x','3626','选项1横向坐标'),(10,'option_2_x','7898','选项2横向坐标'),(11,'max_people','26','一个房间内最大人数'),(12,'speed_buff_goods_id','37040001','buff道具的id（物品效果表）'),(13,'rooms_pool_id','3','多少个房间分配一个pool_id');
/*!40000 ALTER TABLE `base_noon_quiz_cfg` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_noon_quiz_exp_cfg`
--

DROP TABLE IF EXISTS `base_noon_quiz_exp_cfg`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_noon_quiz_exp_cfg` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `min_lv` smallint(5) unsigned NOT NULL COMMENT '等级下限',
  `max_lv` smallint(5) unsigned NOT NULL COMMENT '等级上限',
  `right_exp` int(11) unsigned NOT NULL COMMENT '答题正确经验',
  `error_exp` int(11) unsigned NOT NULL COMMENT '答题错误经验',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=33 DEFAULT CHARSET=utf8 COMMENT='中午答题经验配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_noon_quiz_exp_cfg`
--

LOCK TABLES `base_noon_quiz_exp_cfg` WRITE;
/*!40000 ALTER TABLE `base_noon_quiz_exp_cfg` DISABLE KEYS */;
INSERT INTO `base_noon_quiz_exp_cfg` VALUES (1,1,200,835412,626559),(2,201,230,835412,626559),(3,231,250,1062806,797105),(4,251,270,1297305,972979),(5,271,290,1413657,1060243),(6,291,310,1480457,1110343),(7,311,330,1498718,1124039),(8,331,350,1690563,1267922),(9,351,370,1823507,1367630),(10,371,390,2946505,2209878),(11,391,410,4112983,3084737),(12,411,430,4923649,3692737),(13,431,450,5734316,4300737),(14,451,470,7126503,5344877),(15,471,490,8526337,6394753),(16,491,510,9134337,6850753),(17,511,530,9742337,7306753),(18,531,550,11612225,8709169),(19,551,570,15690920,11768190),(20,571,590,18138091,13603569),(21,591,610,19759425,14819569),(22,611,630,21380758,16035569),(23,631,650,23002091,17251569),(24,651,670,24623425,18467569),(25,671,690,26244758,19683569),(26,691,710,27866091,20899569),(27,711,730,29487425,22115569),(28,731,750,31108758,23331569),(29,751,770,32730091,24547569),(30,771,790,34351425,25763569),(31,791,810,35972758,26979569),(32,811,1000,35972758,26979569);
/*!40000 ALTER TABLE `base_noon_quiz_exp_cfg` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_noon_quiz_festival`
--

DROP TABLE IF EXISTS `base_noon_quiz_festival`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_noon_quiz_festival` (
  `festival_id` tinyint(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '节日ID',
  `festival_name` varchar(1024) CHARACTER SET utf8mb4 NOT NULL COMMENT '节日名',
  `festival_data` varchar(1024) NOT NULL COMMENT '节日日期范围',
  `topic_type` tinyint(10) unsigned NOT NULL COMMENT '题目类型',
  PRIMARY KEY (`festival_id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_noon_quiz_festival`
--

LOCK TABLES `base_noon_quiz_festival` WRITE;
/*!40000 ALTER TABLE `base_noon_quiz_festival` DISABLE KEYS */;
INSERT INTO `base_noon_quiz_festival` VALUES (1,'春节','[{2018,2,11},{2018,2,11}]',2);
/*!40000 ALTER TABLE `base_noon_quiz_festival` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_noon_quiz_rank_reward`
--

DROP TABLE IF EXISTS `base_noon_quiz_rank_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_noon_quiz_rank_reward` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名区域id',
  `rank_min` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名上限',
  `rank_max` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名下限',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='中午答题排名奖励配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_noon_quiz_rank_reward`
--

LOCK TABLES `base_noon_quiz_rank_reward` WRITE;
/*!40000 ALTER TABLE `base_noon_quiz_rank_reward` DISABLE KEYS */;
INSERT INTO `base_noon_quiz_rank_reward` VALUES (1,1,1,'[{0,4905001,1}]');
/*!40000 ALTER TABLE `base_noon_quiz_rank_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_noon_quiz_score`
--

DROP TABLE IF EXISTS `base_noon_quiz_score`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_noon_quiz_score` (
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '进入时间',
  `correct_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '答对积分',
  `wrong_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '答错积分',
  PRIMARY KEY (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='中午答题积分配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_noon_quiz_score`
--

LOCK TABLES `base_noon_quiz_score` WRITE;
/*!40000 ALTER TABLE `base_noon_quiz_score` DISABLE KEYS */;
INSERT INTO `base_noon_quiz_score` VALUES (0,10,1),(1,10,1),(2,10,1),(3,10,1),(4,10,1),(5,10,1),(6,9,1),(7,9,1),(8,6,1),(9,6,1),(10,7,1),(11,6,1),(12,5,1),(13,5,1),(14,5,1),(15,5,1);
/*!40000 ALTER TABLE `base_noon_quiz_score` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_noon_quiz_skill`
--

DROP TABLE IF EXISTS `base_noon_quiz_skill`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_noon_quiz_skill` (
  `skill_id` tinyint(2) unsigned NOT NULL AUTO_INCREMENT COMMENT '技能id',
  `skill_name` varchar(1024) NOT NULL COMMENT '技能名称',
  `skill_cd` int(11) unsigned NOT NULL COMMENT '技能cd',
  PRIMARY KEY (`skill_id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8 COMMENT='中午答题技能表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_noon_quiz_skill`
--

LOCK TABLES `base_noon_quiz_skill` WRITE;
/*!40000 ALTER TABLE `base_noon_quiz_skill` DISABLE KEYS */;
INSERT INTO `base_noon_quiz_skill` VALUES (1,'混乱',60),(2,'踢飞',60);
/*!40000 ALTER TABLE `base_noon_quiz_skill` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_noon_quiz_topic`
--

DROP TABLE IF EXISTS `base_noon_quiz_topic`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_noon_quiz_topic` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '题目Id',
  `topic_type` tinyint(10) unsigned NOT NULL DEFAULT '1' COMMENT '题目类型',
  `content` varchar(1024) NOT NULL DEFAULT '' COMMENT '题目内容',
  `option1` varchar(255) NOT NULL DEFAULT '' COMMENT '选项1',
  `option2` varchar(255) NOT NULL DEFAULT '' COMMENT '选项2',
  `correct` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '正确选项（1/2）',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='中午答题题目配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_noon_quiz_topic`
--

LOCK TABLES `base_noon_quiz_topic` WRITE;
/*!40000 ALTER TABLE `base_noon_quiz_topic` DISABLE KEYS */;
INSERT INTO `base_noon_quiz_topic` VALUES (1,1,'五台山是佛教的四大名山之一吗？','是','不是',1),(2,1,'《哪咤闹海》里的龙王，和《西游记》里借给孙悟空“金箍棒”的龙王是同一个吗？','是','不是',1),(3,1,'《诗经》是我国最早的诗歌总集吗？','是','不是',1),(4,1,'板蓝根是一种植物的根吗？','是','不是',1),(5,1,'根据有关规定，个人的金银首饰如要出售，必须卖给银行吗？','是','不是',1),(6,1,'光是电磁波的一种吗','是','不是',1),(7,1,'海豚是用肺呼吸的吗？','是','不是',1),(8,1,'老鼠又叫耗子，是因为它损耗粮食吗？','是','不是',1),(9,1,'酶是蛋白质吗？','全是','不全是',2),(10,1,'蜜蜂蜇人后，蜂刺通常是留在刺伤处的吗？','是','不是',1),(11,1,'目前世界上最长的斜拉桥是上海的杨浦大桥吗？','是','不是',1),(12,1,'狮子是猫科动物吗？','是','不是',1),(13,1,'蔬菜中是否含有矿物质？','是','不是',1),(14,1,'唐三彩是唐代三彩陶器的简称吗？','是','不是',1),(15,1,'体育课是我国全日制学校开设的必修课之一吗？','是','不是',1),(16,1,'新中国设立的最高科学研究机构是是科学院吗？','是','不是',1),(17,1,'只要星球不爆炸，首领会所就不放假吗？','是的','不是',1),(18,1,'中国最早的文字是甲骨文吗？','是','不是',1),(19,1,'罗马数字有0吗','有','没有',2),(20,1,'使用不锈钢炊具对健康有害吗？','有','没有',2),(21,1,'保险中的“受益人”可以是多人吗？','可以','不可以',1),(22,1,'目前，我国大学可以在网上进行学历和学位教育吗？','可以','不可以',1),(23,1,'角色获得的第一只星灵的名字是什么？','萌羊座','蛇夫座',1),(24,1,'蔬菜汁可使皮肤增白吗？','可以','不可以',1),(25,1,'阳光中的紫外线可以杀菌吗？','可以','不可以',1),(26,1,'婴儿可以同时地呼吸和吞咽吗？','可以','不可以',1),(27,1,'在太空中，人可以戴隐形眼睛吗？','可以','不可以',1),(28,1,'当炉火烧得较旺时，朝炉火中添加湿煤，火会烧得更旺吗？','会','不会',1),(29,1,'萌羊座是角色获得的第一只星灵吗？','是','不是',1),(30,1,'噪音会伤害人的视力吗？','会','不会',1),(31,1,'“生命在于运动”是法国作家伏尔泰的名言。','对','错',1),(32,1,'大气污染按来源可分为煤烟型和石油型。','对','错',1),(33,1,'诺亚王城里的国王叫什么名字？','艾斯特洛','鼹鼠迪克',1),(34,1,'蚯蚓能把中性土壤变成酸性土壤。','对','错',1),(35,1,'人口增长速度是几何级增长，对吗？','对','错',1),(36,1,'人民法院是国家的审判机关。','对','错',1),(37,1,'史莱姆会热到变形吗？','会','不会',1),(38,1,'始作俑者原指开始用陶佣殉葬的人。','对','错',1),(39,1,'世界上人口密度最大的洲是亚洲，对吗？','对','错',1),(40,1,'大部分的植物都是先开花后结果的。','对','错',1),(41,1,'我国拍摄的第一部水墨动画片是《小蝌蚪找妈妈》。','对','错',1),(42,1,'小明要去西藏旅游，妈妈让他多带点糖，这种作法对吗？','对','错',1),(43,1,'紫荆花是香港特区的区花。','对','错',1),(44,1,'“学而时习之，不亦乐乎”这一千古名句出自《孟子》。','对','错',2),(45,1,'海洋中最大的鱼是鲸','对','错',2),(46,1,'屈原的《九歌》是由九篇诗组成的,对吗？','对','错',2),(47,1,'星灵·巨蟹座手上拿着的是？','雨伞','拐杖',1),(48,1,'阿拉伯数字是阿拉伯人发明的吗？','是','不是',2),(49,1,'橄榄枝是代表友谊吗？','是','不是',2),(50,1,'金字塔只有埃及才有吗？','是','不是',2),(51,1,'墨鱼和鲍鱼是鱼吗？','是','不是',2),(52,1,'世界上气温最高的地方是不是在赤道上？','是','不是',2),(53,1,'所有的商品都可以作为期货交易市场上交易的商品吗？','是','不是',2),(54,1,'所有的蚊子都吸人血吗？','是','不是',2),(55,1,'现在我们看到的《红楼梦》都是曹雪芹一个人写的吗？','是','不是',2),(56,1,'意大利的比萨斜塔初建成时就是斜的吗？','是','不是',2),(57,1,'国家教育部颁布的新的高考体检标准中，患夜游症的考生能不能被高校录取？','能','不能',2),(58,1,'烧红的磁铁能吸得住铁钉吗？','能','不能',2),(59,1,'下列哪一只是SSR星灵','难大师','蛇夫座',2),(60,1,'我国公民可以具有双重国籍吗？','可以','不可以',2),(61,1,'微波炉加热牛奶会破坏牛奶中的营养物质吗？','会','不会',2),(62,1,'未满周岁的婴儿吃蜂蜜好不好？','好','不好',2),(63,1,'为了卫生，鸡蛋应洗净后再存放，对吗？','对','不对',2),(64,1,'随便选一个碰碰运气','对','错',2),(65,1,'随便选一个碰碰运气','对','错',1),(66,1,'我国流通的硬币材质是金属单质','对','不对',2),(67,1,'所有的不锈钢都只含有金属元素','对','不对',2),(68,1,'镁合金的硬度和强度均高于纯镁','对','不对',1),(69,1,'晚睡的人，没有对象——这句话是鲁迅说的吗？','是','不是',2),(70,1,'中和反应都是放热反应','对','不对',1),(71,1,'原电池是将电能转化为化学能的一种装置','对','不对',2),(72,1,'水力发电是将化学能转化为电能的过程','对','不对',2),(73,1,'提出“知识就是力量”这句世界名言的是英国哲学家弗兰西斯·培根，对吗','对','不对',1),(74,1,'《资治通鉴》成书于','北宋','南宋',1),(75,1,'以出世的精神做入世的事情的思想源自','法家学派','老庄学派',2),(76,1,'第二次世界大战全面爆发的标志性事件是1939年9月1日德国突袭波兰','对','不对',1),(77,1,'水晶和沙子虽然外表差别很大，但它们的主要成分是一样的','对','不对',1),(78,1,'人们经常说的“绿色食品”指以绿色植物为主要原料制作的食品','对','不对',2),(79,1,'中国恢复在联合国大会的席位是在','1971年','1972年',1),(80,1,'我国政府恢复对澳门行使主权的日期是','1999.12.20','1999.12.31',1),(81,1,'人类最早使用的金属是','铜 ','铁',1),(82,1,'中国最早的工艺百科全书是完成于17世纪30年代的《天工开物》。它的作者是','徐霞客 ','宋应星',2),(83,1,'哪一部史书是我国历代王朝编写史书的典范？','《春秋》','《史记》',2),(84,1,'秦在统一战争中最先和最后灭掉的诸侯国是','韩、齐','赵、燕',1),(85,1,'6岁的孩子可以练长跑吗','可以','不可以',2),(86,1,'6岁的小明用石头把人打伤，谁来承担责任？','小明父母','小明',1),(87,1,'<<义勇军进行曲>>是电影《风云儿女》的主题歌','对','不对',1),(88,1,'阿里山是一座山吗？','是','不是',1),(89,1,'“艾叶”燃烧的烟能驱蚊蝇，对吗','对','不对',1),(90,1,'降神·雅典娜是胜利女神，对吗？','对','不对',1),(91,1,'杜鹃鸟不做窝，她把蛋下到其他鸟的鸟巢里对吗？','对','不对',1),(92,1,'多吃酱油皮肤会变黑吗？','会','不会',2),(93,1,'“辅车相依”中的“辅”也是一种车吗？','是','不是',2),(94,1,'钢筋混凝土中可以栽花种草吗？','可以','不可以',1),(95,1,'公元618-907年，是我国古代的哪个朝代？','唐','宋',1),(96,1,'古代丝绸中，罗、缎、绮指的是同一种丝织物吗？','是','不是',2),(97,1,'固体、液体、气体物质中，液体的火灾危险性最大，对吗？','对','不对',2),(98,1,'光脚散步对小儿发育有好处吗？','有','没有',1),(99,1,'酒越陈越佳，对吗？','对','不对',2),(100,1,'空腹跑步有利健康吗？','有利','不利',2),(101,1,'昆虫金龟子是农业害虫吗？','是','不是',1),(102,1,'老年人“禁荤吃素”有利于身体健康，对吗？','对','不对',2),(103,1,'绿色无公害食品中都是绿颜色，对吗','对','不对',2),(104,1,'“绿色衣装”又称为环保服装，对吗？','对','不对',1),(105,1,'“绿色行政”就是对环境友好的行政，对吗？','对','不对',1),(106,1,'每年都会发生月食吗？','是','不是',2),(107,1,'美国的国花是什么花？','玫瑰','牡丹',1),(108,1,'目前人民币可以自由兑换成外币吗？','可以','不可以',2),(109,1,'南海是我国四大海区中珊瑚岛屿最多的海吗？','是','不是',1),(110,1,'男孩具有两条XX染色体吗？','对','不对',2),(111,1,'牵牛星也叫牛郎星对吗？','对','不对',1),(112,1,'鼹鼠迪克的职业是什么？','矿工','国王',1),(113,1,'秦朝的阿房宫遗址在西安市郊，对吗？','对','不对',1),(114,1,'秦桧是不是最早被称为汉奸的人？','是','不是',1),(115,1,'秦始皇把正月改叫端月是为了避讳自己的名字，对吗？','对','不对',1),(116,1,'“琴棋书画”中的“棋”指','围棋','象棋',1),(117,1,'“群山万壑赴荆门，生长明妃尚有村”，“明妃”是指','杨玉环','王昭君',2),(118,1,'人参在中国的主要产地是','新疆','东北',2),(119,1,'人比其他动物聪明，因为人的脑容量格外大','是','不是',2),(120,1,'人参和西洋参是同一科吗？','是','不是',2),(121,1,'人的唾液是舌头分泌的，对吗？','是','不是',2),(122,1,'人的眼睛能出气吗？','能','不能',1),(123,1,'人们常说的瘦西湖是西湖吗？','是','不是',2),(124,1,'人体含水量百分比最高的器官是','眼球','血液',1),(125,1,'人体中最长的细胞有多长','1米','0.5米',1),(126,1,'人眼的角膜有神经吗？','有','没有',1),(127,1,'这个游戏很好玩','对','不对',1),(128,1,'运气也是实力的一种，随便选一个吧','对','不对',2),(129,1,'运气也是实力的一种，随便选一个吧','对','不对',1);
/*!40000 ALTER TABLE `base_noon_quiz_topic` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_npc`
--

DROP TABLE IF EXISTS `base_npc`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_npc` (
  `id` int(11) NOT NULL DEFAULT '0' COMMENT 'NPC编号',
  `title` varchar(50) NOT NULL DEFAULT '' COMMENT '称谓',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '名字@lang@',
  `scene` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '场景',
  `icon` varchar(50) NOT NULL DEFAULT '0' COMMENT '图标',
  `icon_scale` varchar(10) DEFAULT '1.0' COMMENT '资源缩放',
  `image` varchar(50) NOT NULL DEFAULT '0' COMMENT '头像',
  `arm_id` int(11) NOT NULL COMMENT '武器id',
  `x` int(11) NOT NULL DEFAULT '0',
  `y` int(11) NOT NULL DEFAULT '0',
  `talk` int(11) NOT NULL DEFAULT '0' COMMENT '对话',
  `func` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '功能',
  `action` text NOT NULL COMMENT '功能入口',
  `realm` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '所属阵营',
  `show` int(11) DEFAULT '1' COMMENT '默认是否显示 1显示 0不显示(默认显示)',
  `icon_texture` int(11) NOT NULL DEFAULT '0' COMMENT '贴图id',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='NPC信息和属性';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_npc`
--

LOCK TABLES `base_npc` WRITE;
/*!40000 ALTER TABLE `base_npc` DISABLE KEYS */;
INSERT INTO `base_npc` VALUES (10002,'','小镇商人-贝蒂',0,'3010900','1','0',0,0,0,11900,0,'[[[\"1\",\"我要开车\"]]]',0,1,0),(10003,'','看门大叔',0,'3010900','1','0',3010900,0,0,0,0,'[[]]',0,1,0),(10004,'','疼蛋哥',0,'3011300','1','0',3011300,0,0,0,0,'[[]]',0,1,0),(10005,'','迷之少女',0,'3011300','1','0',3011300,0,0,0,0,'[[]]',0,1,0),(10006,'','迷之少女',0,'3011300','1','0',3011300,0,0,0,0,'[[]]',0,1,0),(99999,'','焦急波古多',0,'3010900','1','0',3010900,0,0,20000,0,'[[]]',0,1,0),(100001,'','埃罗恩大法师',0,'201013','1','0',201013,0,0,1908176,0,'[[]]',0,1,0),(100002,'','海岛平民',0,'201026','1','0',201026,0,0,1908177,0,'[[]]',0,1,0),(100003,'[抵抗军干部]','莱克斯',0,'201049','1','0',201049,0,0,1908178,0,'[[]]',0,1,0),(100004,'','水手托鲁玛',0,'201012','1','0',201012,0,0,1908179,0,'[[]]',0,1,0),(100005,'','惊慌的村民',0,'201025','1','0',201025,0,0,1908180,0,'[[]]',0,1,0),(100006,'','村长皮诺',0,'201052','1','0',201052,0,0,1908181,0,'[[]]',0,1,0),(100007,'[钓鱼达人]','狸大郎',0,'201044','1','0',201044,0,0,1908182,0,'[[]]',0,1,0),(100008,'','天真小女孩',0,'201028','1','0',201028,0,0,1908183,0,'[[]]',0,1,0),(100009,'[猫娘秘书]','梅斯菲尔',0,'201005','1','0',201005,0,0,1908184,0,'[[]]',0,1,0),(100010,'','乔治大叔',0,'201030','1','0',201030,0,0,1908185,0,'[[]]',0,1,0),(100011,'','喵队长',0,'201051','1','0',201051,0,0,1908186,0,'[[]]',0,1,0),(100012,'[光辉神]','赫利俄斯',0,'203021','1','0',203021,0,0,1908187,0,'[[]]',0,1,0),(100013,'','劳伦兹',0,'201007','1','0',201007,0,0,1908188,0,'[[]]',0,1,0),(100014,'[搞事的家伙]','火鸡骑士',0,'202034','1.3','0',202034,0,0,1908189,0,'[[]]',0,1,0),(100015,'','霍克船长',0,'201038','1','0',201038,0,0,1908190,0,'[[]]',0,1,0),(100016,'[星灵]','萌羊座',0,'501003','1','0',501003,0,0,1908191,0,'[[]]',0,1,0),(100017,'[暗裔恶魔]','暗裔死神',0,'203018','1','0',203018,0,0,1908192,0,'[[]]',0,1,0),(100020,'[活泼海豚]','豚豚',0,'2050009','1','0',2050009,0,0,0,0,'[[]]',0,1,0),(100030,'','狮鹫',0,'301007','1','0',301007,0,0,0,0,'[[]]',0,1,0),(100040,'','火鸡骑士',0,'202034','1','0',202034,0,0,0,0,'[[]]',0,1,0),(100201,'[抵抗军干部]','莱克斯',0,'201049','1','0',201049,0,0,1908193,0,'[[]]',0,1,0),(100202,'','喵队长',0,'201051','1','0',201051,0,0,1908194,0,'[[]]',0,1,0),(100203,'[技术宅]','机械师安娜',0,'201031','1','0',201031,0,0,1908195,0,'[[]]',0,1,0),(100204,'[抵抗军司令]','劳伦兹',0,'201007','1','0',201007,0,0,1908196,0,'[[]]',0,1,0),(100205,'[哥布林技师]','加德纳',0,'201015','1','0',201015,0,0,1908197,0,'[[]]',0,1,0),(100206,'','乔治大叔',0,'201030','1','0',201030,0,0,1908198,0,'[[]]',0,1,0),(100207,'[抵抗军干部]','莱克斯',0,'201049','1','0',201049,0,0,1908199,0,'[[]]',0,1,0),(100208,'','喵队长',0,'201051','1','0',201051,0,0,1908200,0,'[[]]',0,1,0),(100209,'','小女孩菲尼',0,'201028','1','0',201028,0,0,1908201,0,'[[]]',0,1,0),(100210,'[迷之刺客]','科哈特',0,'201033','1','0',201033,0,0,1908202,0,'[[]]',0,1,0),(100211,'[抵抗军情报员]','露易丝',0,'201050','1','0',201050,0,0,1908203,0,'[[]]',0,1,0),(100212,'','喵队长',0,'201051','1','0',201051,0,0,1908204,0,'[[]]',0,1,0),(100213,'[抵抗军司令]','劳伦兹',0,'201007','1','0',201007,0,0,1908205,0,'[[]]',0,1,0),(100214,'[暗裔恶魔]','蜘蛛女皇',0,'203011','1','0',203011,0,0,1908206,0,'[[]]',0,1,0),(100215,'','铁匠莫里森',0,'201035','1','0',201035,0,0,1908207,0,'[[]]',0,1,0),(100216,'[星灵]','萌羊座',0,'501002','1','0',501002,0,0,1908208,0,'[[]]',0,1,0),(100217,'[机械狂人]','安娜贝尔',0,'201031','1','0',201031,0,0,1908476,0,'[[]]',0,1,0),(100301,'','喵队长',0,'201051','1','0',201051,0,0,1908209,0,'[[]]',0,1,0),(100302,'[挖坑小能手]','鼯鼠迪克',0,'201046','1','0',201046,0,0,1908210,0,'[[]]',0,1,0),(100303,'[抵抗军情报员]','露易丝',0,'201050','1','0',201050,0,0,1908211,0,'[[]]',0,1,0),(100304,'[热到变形]','史莱姆',0,'202003','1.2','0',202003,0,0,1908212,0,'[[]]',0,1,0),(100305,'','煮咒恶灵',0,'201045','1','0',201045,0,0,0,0,'[[]]',0,1,0),(100306,'[狠角色]','埃罗恩大法师',0,'201013','1','0',201013,0,0,1908213,0,'[[]]',0,1,0),(100307,'','水手托鲁玛',0,'201012','1','0',201012,0,0,1908214,0,'[[]]',0,1,0),(100308,'[星灵]','金牛座',0,'501004','1','0',501004,0,0,1908215,0,'[[]]',0,1,0),(100309,'[抵抗军干部]','莱克斯',0,'201049','1','0',201049,0,0,1908216,0,'[[]]',0,1,0),(100310,'[冷酷魅影]','刺客芙蕾',0,'201018','1','0',201018,0,0,1908217,0,'[[]]',0,1,0),(100311,'[卖萌妖怪]','猫又药师',0,'201043','1','0',201043,0,0,1908218,0,'[[]]',0,1,0),(100312,'[暗裔恶魔]','荆棘之花',0,'203001','1','0',203001,0,0,1908219,0,'[[]]',0,1,0),(100320,'','通讯员',0,'201050','1','0',201050,0,0,0,0,'[[]]',0,1,0),(100401,'[猫娘秘书]','梅斯菲尔',0,'201005','1','0',201005,0,0,1908220,0,'[[]]',0,1,0),(100402,'[证婚人]','卡米雅',0,'201006','1','0',201006,0,0,1908221,0,'[[]]',0,1,0),(100403,'[抵抗军司令]','劳伦兹',0,'201007','1','0',201007,0,0,1908222,0,'[[]]',0,1,0),(100404,'[乘务员]','凯特琳',0,'201008','1','0',201008,0,0,1908223,0,'[[]]',0,1,0),(100405,'','艾斯特洛国王',0,'201009','1','0',201009,0,0,1908224,0,'[[]]',0,1,0),(100406,'[多疑参谋]','巴雷特大臣',0,'201010','1','0',201010,0,0,1908225,0,'[[]]',0,1,0),(100407,'','康斯坦将军',0,'201011','1','0',201011,0,0,1908226,0,'[[]]',0,1,0),(100408,'','托鲁玛水手',0,'201012','1','0',201012,0,0,1908227,0,'[[]]',0,1,0),(100409,'[狠角色]','埃罗恩大法师',0,'201013','1','0',201013,0,0,1908228,0,'[[]]',0,1,0),(100410,'[钓鱼达人]','狸太郎',0,'201044','1','0',201044,0,0,1908229,0,'[[]]',0,1,0),(100411,'','铁匠莫里森',0,'201035','1','0',201035,0,0,1908230,0,'[[]]',0,1,0),(100412,'','神秘异国少女',0,'201029','1','0',201029,0,0,1908231,0,'[[]]',0,1,0),(100413,'','城镇商贩',0,'201026','1','0',201026,0,0,1908232,0,'[[]]',0,1,0),(100414,'[精灵祭祀]','朵萝丝',0,'201017','1','0',201017,0,0,1908233,0,'[[]]',0,1,0),(100415,'[迷之刺客]','科哈特',0,'201033','1','0',201033,0,0,1908234,0,'[[]]',0,1,0),(100416,'[抵抗军干部]','莱克斯',0,'201049','1','0',201049,0,0,1908235,0,'[[]]',0,1,0),(100417,'[抵抗军情报员]','露易丝',0,'201050','1','0',201050,0,0,1908236,0,'[[]]',0,1,0),(100418,'','喵队长',0,'201051','1','0',201051,0,0,1908237,0,'[[]]',0,1,0),(100420,'[日常任务]','卡米拉',0,'201006','1','0',201006,0,0,1908238,0,'[[]]',0,1,0),(100430,'[公会任务]','莱恩将军',0,'201023','1','0',201023,0,0,1908239,0,'[[]]',0,1,0),(100501,'','暗精灵妮可',0,'202008','1.5','0',202008,0,0,20027,0,'[[]]',0,1,0),(100502,'','乔治大叔',0,'201030','1','0',201030,0,0,20028,0,'[[]]',0,1,0),(100503,'[哥布林技师]','加德纳',0,'201015','1','0',201015,0,0,20029,0,'[[]]',0,1,0),(100504,'','金牛座',0,'501004','1','0',501004,0,0,20014,0,'[[]]',0,1,0),(100505,'[精灵祭祀]','朵萝丝',0,'201017','1','0',201017,0,0,20107,0,'[[]]',0,1,0),(100506,'','喵队长',0,'201051','1','0',201051,0,0,20108,0,'[[]]',0,1,0),(100507,'[精灵帅哥]','安德鲁',0,'201016','1','0',201016,0,0,20109,0,'[[]]',0,1,0),(100508,'','抵抗军干部',0,'201049','1','0',201049,0,0,20139,0,'[[]]',0,1,0),(100509,'','精灵守卫',0,'202004','1','0',202004,0,0,20140,0,'[[]]',0,1,0),(100510,'[德鲁伊]','豹猫翠西',0,'201024','1','0',201024,0,0,1908240,0,'[[]]',0,1,0),(100511,'[哥布林技师]','加德纳',0,'201015','1','0',201015,0,0,1908241,0,'[[]]',0,1,0),(100512,'[冷酷魅影]','刺客芙蕾',0,'201018','1','0',201018,0,0,1908242,0,'[[]]',0,1,0),(100513,'','神秘刺客',0,'201033','1','0',201033,0,0,1908334,0,'[[]]',0,1,0),(100514,'','露易丝',0,'201050','1','0',201050,0,0,1908335,0,'[[]]',0,1,0),(100515,'','埃罗恩大法师',0,'201013','1','0',201013,0,0,1908336,0,'[[]]',0,1,0),(100601,'','夕树长老',0,'202033','1.6','0',10029003,0,0,1907776,0,'[[]]',0,1,0),(100602,'[星灵]','双子座',0,'501005','1','0',1002006,0,0,1907777,0,'[[]]',0,1,0),(100603,'','暗精灵梅莉',0,'202008','1.5','0',202008,0,0,1907778,0,'[[]]',0,1,0),(100604,'[精灵帅哥]','安德鲁',0,'201016','1','0',201016,0,0,1908243,0,'[[]]',0,1,0),(100605,'[德鲁伊]','豹猫翠西',0,'201024','1','0',1004005,0,0,1907780,0,'[[]]',0,1,0),(100606,'[精灵祭祀]','朵萝丝',0,'201017','1','0',201017,0,0,1907781,0,'[[]]',0,1,0),(100607,'','妖精艾利',0,'202008','1.5','0',1008004,0,0,1907782,0,'[[]]',0,1,0),(100608,'[哥布林技师]','加德纳',0,'201015','1','0',201015,0,0,1907783,0,'[[]]',0,1,0),(100609,'[精灵帅哥]','安德鲁',0,'201016','1','0',1007002,0,0,1907784,0,'[[]]',0,1,0),(100610,'[精灵女王]','露娜莉娅',0,'201014','1','0',201014,0,0,1907785,0,'[[]]',0,1,0),(100611,'[冷酷魅影]','刺客芙蕾',0,'201018','1','0',201018,0,0,1907786,0,'[[]]',0,1,0),(100612,'[搞事的家伙]','火鸡骑士',0,'202034','1.3','0',202034,0,0,1907787,0,'[[]]',0,1,0),(100613,'[兽人猛男]','狼人芬里克',0,'201019','1','0',201019,0,0,1908244,0,'[[]]',0,1,0),(100614,'','朵萝丝',0,'201017','1','0',201017,0,0,0,0,'[[]]',0,1,0),(100615,'[情报员]','露易丝',0,'201050','1','0',201050,0,0,0,0,'[[]]',0,1,0),(100620,'[神殿守护者]','神殿人马',0,'203002','1','0',203002,0,0,1908245,0,'[[]]',0,1,0),(100701,'','雪原村民',0,'201052','1','0',201052,0,0,1907800,0,'[[]]',0,1,0),(100702,'[兽人猛男]','狼人芬里克',0,'201019','1','0',201019,0,0,1907801,0,'[[]]',0,1,0),(100703,'[渔贩子]','企鹅嘭咕',0,'202009','1.4','0',202009,0,0,1907803,0,'[[]]',0,1,0),(100704,'[兽人酋长]','狮王莱恩',0,'201023','1','0',201023,0,0,1907804,0,'[[]]',0,1,0),(100705,'[兽人美女]','雪豹赛丽雅',0,'201024','1','0',201024,0,0,1907805,0,'[[]]',0,1,0),(100706,'[兽人智多星]','松鼠帕吉',0,'201022','1','0',201022,0,0,1907806,0,'[[]]',0,1,0),(100707,'','霜虎泰戈尔',0,'201020','1','0',201020,0,0,1907807,0,'[[]]',0,1,0),(100708,'[狠角色]','埃罗恩大法师',0,'201013','1','0',201013,0,0,1907808,0,'[[]]',0,1,0),(100709,'[兽人美女]','雪豹赛丽雅',0,'201024','1','0',201024,0,0,1907809,0,'[[]]',0,1,0),(100710,'[二天一流]','秋田剑豪',0,'201041','1','0',201041,0,0,1907810,0,'[[]]',0,1,0),(100711,'','乔治大叔',0,'201030','1','0',201030,0,0,1907811,0,'[[]]',0,1,0),(100712,'','狮子座',0,'501007','1','0',501007,0,0,1907812,0,'[[]]',0,1,0),(100713,'','喵队长',0,'201051','1','0',201051,0,0,1908246,0,'[[]]',0,1,0),(100714,'','冰霜巨龙',0,'203004','1','0',203004,0,0,1908247,0,'[[]]',0,1,0),(100801,'','沙盗首领',0,'201033','1','0',201033,0,0,1908013,0,'[[]]',0,1,0),(100802,'[抵抗军干部]','莱克斯',0,'201049','1','0',201049,0,0,1908014,0,'[[]]',0,1,0),(100803,'','康斯坦将军',0,'201011','1','0',201011,0,0,1908015,0,'[[]]',0,1,0),(100804,'','村落男平民',0,'201025','1','0',201025,0,0,1908016,0,'[[]]',0,1,0),(100805,'','村落女平民',0,'201026','1','0',201026,0,0,1908017,0,'[[]]',0,1,0),(100806,'','村落男孩',0,'201027','1','0',201027,0,0,1908018,0,'[[]]',0,1,0),(100807,'','村落女孩',0,'201028','1','0',201028,0,0,1908019,0,'[[]]',0,1,0),(100808,'[少女法老]','尼托克丽丝',0,'201029','1','0',201029,0,0,1908020,0,'[[]]',0,1,0),(100809,'','霍克船长',0,'201038','1','0',201038,0,0,1908021,0,'[[]]',0,1,0),(100810,'[抵抗军干部]','莱克斯',0,'201049','1','0',201049,0,0,1908022,0,'[[]]',0,1,0),(100811,'','喵队长',0,'201051','1','0',201051,0,0,1908023,0,'[[]]',0,1,0),(100812,'[卖萌妖怪]','猫又药师',0,'201043','1','0',201043,0,0,1908024,0,'[[]]',0,1,0),(100813,'[抵抗军情报员]','露易丝',0,'201050','1','0',201050,0,0,1908025,0,'[[]]',0,1,0),(100814,'[冷酷魅影]','刺客芙蕾',0,'201018','1','0',201018,0,0,1908248,0,'[[]]',0,1,0),(100815,'[抵抗军司令]','劳伦兹',0,'201007','1','0',201007,0,0,1908249,0,'[[]]',0,1,0),(100820,'[死神祭祀]','阿努比斯',0,'203005','1','0',203005,0,0,1908250,0,'[[]]',0,1,0),(100901,'[技术宅]','机械师安娜',0,'201031','1','0',201031,0,0,1908251,0,'[[]]',0,1,0),(100902,'[破烂铁罐]','闪亮杰作',0,'201032','1','0',201032,0,0,1908252,0,'[[]]',0,1,0),(100903,'[迷之刺客]','科哈特',0,'201033','1','0',201033,0,0,1908253,0,'[[]]',0,1,0),(100904,'[机械狂人]','比尔德伯爵',0,'201034','1','0',201034,0,0,1908254,0,'[[]]',0,1,0),(100905,'','铁匠莫里森',0,'201035','1','0',201035,0,0,1908255,0,'[[]]',0,1,0),(100906,'[抵抗军干部]','莱克斯',0,'201049','1','0',201049,0,0,1908256,0,'[[]]',0,1,0),(100907,'','懦弱士兵',0,'202017','1.3','0',202017,0,0,1908257,0,'[[]]',0,1,0),(100908,'','废旧机器人',0,'202015','1.2','0',202015,0,0,1908258,0,'[[]]',0,1,0),(100909,'','喵队长',0,'201051','1','0',201051,0,0,1908259,0,'[[]]',0,1,0),(100910,'[抵抗军情报员]','露易丝',0,'201050','1','0',201050,0,0,1908260,0,'[[]]',0,1,0),(100911,'[技术宅]','机械师安娜',0,'201031','1','0',201031,0,0,1908261,0,'[[]]',0,1,0),(100912,'[哥布林技师]','加德纳',0,'201015','1','0',201015,0,0,1908262,0,'[[]]',0,1,0),(100913,'[破烂铁罐]','闪亮杰作',0,'201032','1','0',201032,0,0,1908263,0,'[[]]',0,1,0),(100914,'','康斯坦将军',0,'201011','1','0',201011,0,0,1908264,0,'[[]]',0,1,0),(100920,'[身邪心正]','恶魔骑士',0,'203007','1','0',203007,0,0,1908265,0,'[[]]',0,1,0),(101001,'[社交恐惧症]','人鱼忒缇丝',0,'201036','1','0',201036,0,0,1908266,0,'[[]]',0,1,0),(101002,'','海拉战士',0,'202020','1.5','0',202020,0,0,1908267,0,'[[]]',0,1,0),(101003,'[星灵]','巨蟹座',0,'501006','1','0',501006,0,0,1908268,0,'[[]]',0,1,0),(101004,'','凶恶鲨鱼',0,'202023','1.5','0',202023,0,0,1908269,0,'[[]]',0,1,0),(101005,'','海拉刺客',0,'202021','1.5','0',202021,0,0,1908270,0,'[[]]',0,1,0),(101006,'','水母佩菈',0,'201037','1','0',201037,0,0,1908271,0,'[[]]',0,1,0),(101007,'[抵抗军情报员]','露易丝',0,'201050','1','0',201050,0,0,1908272,0,'[[]]',0,1,0),(101008,'','霍克船长',0,'201038','1','0',201038,0,0,1908273,0,'[[]]',0,1,0),(101009,'','海拉战士',0,'202020','1.5','0',202020,0,0,1908274,0,'[[]]',0,1,0),(101010,'','康斯坦将军',0,'201011','1','0',201011,0,0,1908275,0,'[[]]',0,1,0),(101011,'[海神]','波塞冬',0,'601003','1','0',601003,0,0,1908276,0,'[[]]',0,1,0),(101012,'[社交恐惧症]','人鱼忒缇丝',0,'201036','1','0',201036,0,0,1908277,0,'[[]]',0,1,0),(101013,'','霍克船长',0,'201038','1','0',201038,0,0,1908278,0,'[[]]',0,1,0),(101014,'[抵抗军干部]','莱克斯',0,'201049','1','0',201049,0,0,1908279,0,'[[]]',0,1,0),(101015,'[抵抗军司令]','劳伦兹',0,'201007','1','0',201007,0,0,1908280,0,'[[]]',0,1,0),(101101,'[神社守护者]','巫女铃音',0,'201040','1','0',201040,0,0,1908415,0,'[[]]',0,1,0),(101102,'[卖药的猫]','猫又郎中',0,'201043','1','0',201043,0,0,1908416,0,'[[]]',0,1,0),(101103,'[目前单身]','秋田剑豪',0,'201041','1','0',201041,0,0,1908417,0,'[[]]',0,1,0),(101104,'[人畜无害]','诸天童子',0,'201042','1','0',201042,0,0,1908418,0,'[[]]',0,1,0),(101105,'[神社守护者]','巫女铃音',0,'201040','1','0',201040,0,0,1908419,0,'[[]]',0,1,0),(101106,'[腰间盘突出]','鲨鲨村长',0,'201052','1','0',201052,0,0,1908420,0,'[[]]',0,1,0),(101107,'[知识分子]','松鼠帕吉',0,'201022','1','0',201022,0,0,1908421,0,'[[]]',0,1,0),(101108,'[心智幼稚]','条野太郎',0,'201021','1','0',201021,0,0,1908422,0,'[[]]',0,1,0),(101109,'[钓鱼达人]','狸太郎',0,'201044','1','0',201044,0,0,1908423,0,'[[]]',0,1,0),(101110,'[萌即正义]','祈福猫娘',0,'201005','1','0',201005,0,0,1908424,0,'[[]]',0,1,0),(101111,'[资深姐控]','诸天童子',0,'201042','1','0',201042,0,0,1908425,0,'[[]]',0,1,0),(101112,'[擅长暗杀]','忍者甲贺',0,'201033','1','0',201033,0,0,1908426,0,'[[]]',0,1,0),(101113,'[至今单身]','秋田剑豪',0,'201041','1','0',201041,0,0,1908427,0,'[[]]',0,1,0),(101114,'[资深法师]','埃罗恩大法师',0,'201013','1','0',201013,0,0,1908428,0,'[[]]',0,1,0),(101115,'[神社守护者]','巫女铃音',0,'201040','1','0',201040,0,0,1908429,0,'[[]]',0,1,0),(101116,'[博学多才]','松鼠帕吉',0,'201022','1','0',201022,0,0,1908430,0,'[[]]',0,1,0),(101117,'[通讯员]','露易丝',0,'201050','1','0',201050,0,0,1908431,0,'[[]]',0,1,0),(101201,'','霍克船长',0,'201038','1','0',201038,0,0,1908346,0,'[[]]',0,1,0),(101202,'[亚龙人]','薇薇安',0,'201047','1','0',201047,0,0,1908347,0,'[[]]',0,1,0),(101203,'[虚假领主]','毁灭爆弹',0,'202030','1.5','0',202030,0,0,1908348,0,'[[]]',0,1,0),(101204,'[抵抗军干部]','莱克斯',0,'201049','1','0',201049,0,0,1908349,0,'[[]]',0,1,0),(101205,'[虚假领主]','毁灭爆弹',0,'202030','1.5','0',202030,0,0,0,0,'[[]]',0,1,0),(101206,'[液体生物]','煮咒恶灵',0,'201045','1','0',201045,0,0,1908350,0,'[[]]',0,1,0),(101207,'[吨吨吨]','水手托鲁玛',0,'201012','1','0',201012,0,0,1908351,0,'[[]]',0,1,0),(101208,'[挖坑小能手]','鼯鼠迪克',0,'201046','1','0',201046,0,0,1908352,0,'[[]]',0,1,0),(101209,'[圣火之灵]','暴怒之火',0,'608001','0.7','0',608001,0,0,1908353,0,'[[]]',0,1,0),(101210,'[打铁宗师]','铁匠莫里森',0,'201035','1','0',201035,0,0,1908354,0,'[[]]',0,1,0),(101211,'[技术宅]','机械师安娜',0,'201031','1','0',201031,0,0,1908355,0,'[[]]',0,1,0),(101212,'[龙神意志]','薇薇安',0,'201047','1','0',201047,0,0,1908356,0,'[[]]',0,1,0),(101213,'[圣火之灵]','暴怒之火',0,'608001','0.7','0',608001,0,0,1908357,0,'[[]]',0,1,0),(101214,'[熔岩部落]','蜥蜴首领',0,'202014','1.2','0',202014,0,0,1908358,0,'[[]]',0,1,0),(201044,'[海岛卫士]','狸太郎',0,'201044','1','0',201044,0,0,1908475,0,'[[]]',0,1,0),(1004100,'钓鱼王者','钓鱼姥爷',0,'201052','1','0',201052,0,0,0,0,'[[]]',0,1,0),(1004101,'钓鱼王者','钓鱼姥爷',0,'201052','1','0',201052,0,0,0,0,'[[]]',0,1,0),(1004102,'钓鱼王者','钓鱼姥爷',0,'201052','1','0',201052,0,0,0,0,'[[]]',0,1,0),(1004103,'钓鱼王者','钓鱼姥爷',0,'201052','1','0',201052,0,0,0,0,'[[]]',0,1,0),(10019001,'','惊慌的少女',0,'10019002','1','0',2010300200,0,0,20001,0,'[[]]',0,1,0),(10019002,'','生气的少女',0,'10019002','1','0',2010300200,0,0,20002,0,'[[]]',0,1,0),(10019003,'[首席大副]','匆忙的妮哆',0,'10039003','1','0',2010300200,0,0,20003,0,'[[]]',0,1,0),(10019004,'[打杂水手]','艾琳',0,'10019002','1','0',3011301,0,0,20004,0,'[[]]',0,1,0),(10019005,'[首席大副]','观察的妮哆',0,'10039003','1','0',3011301,0,0,20005,0,'[[]]',0,1,0),(10019006,'','感激的地精',0,'3011301','1','0',3011301,0,0,20006,0,'[[]]',0,1,0),(10019007,'','哭泣的精灵',0,'180004','1.2','0',2010201400,0,0,20007,0,'[[]]',0,1,0),(10019008,'','焦急的大叔',0,'2010201400','1','0',2010201400,0,0,20008,0,'[[]]',0,1,0),(10019009,'[打杂水手]','惊慌的艾琳',0,'10019002','1','0',2010420200,0,0,20009,0,'[[]]',0,1,0),(10019010,'','头疼的波古',0,'3010900','1','0',3010900,0,0,20010,0,'[[]]',0,1,0),(10019011,'','波古',0,'3010900','1','0',3010900,0,0,20011,0,'[[]]',0,1,0),(10019012,'[首席大副]','暴怒的妮哆',0,'10039003','1','0',3010900,0,0,20012,0,'[[]]',0,1,0),(10019013,'[首席大副]','得意的妮哆',0,'10039003','1','0',3010900,0,0,20013,0,'[[]]',0,1,0),(10029000,'','谜之少女',0,'3010100','1','0',3010100,0,0,20014,0,'[[]]',0,1,0),(10029001,'','濒死的波古',0,'3010100','1','0',3010100,0,0,20015,0,'[[]]',0,1,0),(10029002,'[打杂水手]','倒霉的艾琳',0,'10019001','1','0',3010100,0,0,20016,0,'[[]]',0,1,0),(10029003,'','零零哆',0,'3010200','1','0',3010200,0,0,20017,0,'[[]]',0,1,0),(10029004,'[首席大副]','迅捷的妮哆',0,'10039003','1','0',2010201200,0,0,20018,0,'[[]]',0,1,0),(10029005,'','匆忙的艾琳',0,'10019001','1','0',2010201200,0,0,20019,0,'[[]]',0,1,0),(10029006,'','匆忙的艾琳',0,'10019001','1','0',2010201200,0,0,20020,0,'[[]]',0,1,0),(10029007,'[打杂水手]','惊慌的艾琳',0,'10019001','1','0',2010201200,0,0,20021,0,'[[]]',0,1,0),(10029008,'[林地长者]','虚弱的杜鲁树',0,'10029003','1','0',3011000,0,0,20022,0,'[[]]',0,1,0),(10029009,'[林地长者]','喘气的杜鲁树',0,'10029003','1','0',3011000,0,0,20023,0,'[[]]',0,1,0),(10029010,'','累坏的古树',0,'10029003','1','0',3011000,0,0,20024,0,'[[]]',0,1,0),(10029011,'[倒霉蛋]','慌张的艾琳',0,'10019001','1','0',3011300,0,0,20025,0,'[[]]',0,1,0),(10029012,'[倒霉蛋]','警觉的艾琳',0,'10019001','1','0',3011300,0,0,20026,0,'[[]]',0,1,0),(10029013,'[倒霉蛋]','警觉的艾琳',0,'10019001','1','0',3011300,0,0,20027,0,'[[]]',0,1,0),(10029014,'[倒霉蛋]','艾琳',0,'10019001','1','0',3011300,0,0,20028,0,'[[]]',0,1,0),(10029015,'[女汉子]','苏珊大婶',0,'10029002','1','0',3010200,0,0,20029,0,'[[]]',0,1,0),(10029016,'[女汉子]','苏珊大婶',0,'10029002','1','0',3010200,0,0,20030,0,'[[]]',0,1,0),(10029017,'[倒霉蛋]','艾琳',0,'10019002','1','0',3011300,0,0,20031,0,'[[]]',0,1,0),(10029018,'[倒霉蛋]','神气的艾琳',0,'10019002','1','0',3010200,0,0,20032,0,'[[]]',0,1,0),(10029019,'[倒霉蛋]','败退的艾琳',0,'10019002','1','0',3010400,0,0,20033,0,'[[]]',0,1,0),(10029020,'[首席大副]','匆忙的妮哆',0,'10039003','1','0',3011300,0,0,20034,0,'[[]]',0,1,0),(10029021,'[首席大副]','妮哆',0,'10039003','1','0',3010900,0,0,20035,0,'[[]]',0,1,0),(10039001,'[铁卫队长]','壮牛',0,'10039006','1','0',3010400,0,0,20036,0,'[[]]',0,1,0),(10039002,'[联邦护民官]','顽哆',0,'10039005','1','0',3010100,0,0,20037,0,'[[]]',0,1,0),(10039003,'[首席大副]','妮哆',0,'10039003','1','0',3010900,0,0,20038,0,'[[]]',0,1,0),(10039004,'[呜邦调查局]','零零哆',0,'10029001','1','0',3010900,0,0,20039,0,'[[]]',0,1,0),(10039005,'[金呜铁卫]','波斯基',0,'10039006','1','0',3010400,0,0,20040,0,'[[]]',0,1,0),(10039006,'[金呜铁卫]','斌克斯',0,'10039006','1','0',3010400,0,0,20041,0,'[[]]',0,1,0),(10039007,'[财团领袖]','金哆哆',0,'10039001','1','0',3011300,0,0,20042,0,'[[]]',0,1,0),(10039008,'[金呜铁卫]','巍德烈夫',0,'3010400','1','0',3010400,0,0,20043,0,'[[]]',0,1,0),(10039009,'[传送使者]','巍德斯基',0,'3010100','1','0',3010100,0,0,20044,0,'[[]]',0,1,0),(10039010,'[顽哆宠物]','逗逗',0,'1003301','1','0',3010900,0,0,20045,0,'[[]]',0,1,0),(10039011,'','主城NPC',0,'3010400','1','0',3010400,0,0,20046,0,'[[]]',0,1,0),(10039012,'','主城NPC',0,'3010100','1','0',3010100,0,0,20047,0,'[[]]',0,1,0),(10039013,'','主城NPC',0,'3010900','1','0',3010900,0,0,20048,0,'[[]]',0,1,0),(10039014,'','主城NPC',0,'3010900','1','0',3010900,0,0,20049,0,'[[]]',0,1,0),(10039015,'','主城NPC',0,'3010400','1','0',3010400,0,0,20050,0,'[[]]',0,1,0),(10039051,'[传送-开始]','莫名',0,'3010400','1','0',3010400,0,0,20051,0,'[[]]',0,1,0),(10039052,'[传送-中转]','奇妙',0,'3010400','1','0',3010400,0,0,20052,0,'[[]]',0,1,0),(10039098,'[日常司令官]','雅阁布',0,'10039006','1','0',3010900,0,0,10782,0,'[[]]',0,1,0),(10039099,'[公会大代表]','伊万诺夫',0,'10039006','1','0',3010400,0,0,10783,0,'[[]]',0,1,0),(10049001,'[闯祸少女]','慌张的艾琳',0,'10019002','1','0',3011300,0,0,20053,0,'[[]]',0,1,0),(10049002,'','奇怪的熊精',0,'3010100','1','0',3010100,0,0,20054,0,'[[]]',0,1,0),(10049003,'','愤怒的熊精',0,'3010200','1','0',3010200,0,0,20055,0,'[[]]',0,1,0),(10049004,'[闯祸少女]','消停的艾琳',0,'10019002','1','0',3010400,0,0,20056,0,'[[]]',0,1,0),(10049005,'','惊讶的熊精',0,'3010900','1','0',3010900,0,0,20057,0,'[[]]',0,1,0),(10049006,'[伪装少女]','紧张的艾琳',0,'1004002','1.3','0',3011000,0,0,20058,0,'[[]]',0,1,0),(10049007,'[可疑地精]','凄惨的古鲁',0,'10019003','1','0',3011200,0,0,20059,0,'[[]]',0,1,0),(10049008,'[伪装少女]','艾琳',0,'1004002','1.3','0',3011300,0,0,20060,0,'[[]]',0,1,0),(10049009,'','诡异的女巫',0,'3011301','1','0',3011301,0,0,20061,0,'[[]]',0,1,0),(10049010,'[可疑地精]','神秘的古鲁',0,'10019003','1','0',3010100,0,0,20062,0,'[[]]',0,1,0),(10049011,'','恶毒的女巫',0,'3010200','1','0',3010200,0,0,20063,0,'[[]]',0,1,0),(10049012,'[闯祸少女]','疑虑的艾琳',0,'10019002','1','0',3010400,0,0,20064,0,'[[]]',0,1,0),(10049013,'[可疑地精]','邪笑的古鲁',0,'10019003','1','0',3010900,0,0,20065,0,'[[]]',0,1,0),(10049014,'','虚弱的熊婶',0,'3011000','1','0',3011000,0,0,20066,0,'[[]]',0,1,0),(10049015,'[被俘特工]','零零哆',0,'10029001','1','0',3011200,0,0,20067,0,'[[]]',0,1,0),(10049016,'','得救的熊婶',0,'3011300','1','0',3011300,0,0,20068,0,'[[]]',0,1,0),(10049017,'','喜悦的艾琳',0,'10019002','1','0',3011301,0,0,20069,0,'[[]]',0,1,0),(10049018,'','淘气的艾琳',0,'10019002','1','0',3010100,0,0,20070,0,'[[]]',0,1,0),(10049019,'','神秘的艾琳',0,'10019002','1','0',3010200,0,0,20071,0,'[[]]',0,1,0),(10049020,'','歹毒女巫',0,'3010400','1','0',3010400,0,0,20072,0,'[[]]',0,1,0),(10049021,'','坚定的熊婶',0,'3010900','1','0',3010900,0,0,20073,0,'[[]]',0,1,0),(10049022,'','得意的熊婶',0,'3011000','1','0',3011000,0,0,20074,0,'[[]]',0,1,0),(10049023,'','末路的女巫',0,'3011200','1','0',3011200,0,0,20075,0,'[[]]',0,1,0),(10049024,'','自由的熊婶',0,'3011300','1','0',3011300,0,0,20076,0,'[[]]',0,1,0),(10049025,'','活泼的艾琳',0,'10019002','1','0',3011301,0,0,20077,0,'[[]]',0,1,0),(10049026,'','壁垒NPC',0,'3010100','1','0',3010100,0,0,20078,0,'[[]]',0,1,0),(10049027,'','壁垒NPC',0,'3010200','1','0',3010200,0,0,20079,0,'[[]]',0,1,0),(10049028,'','壁垒NPC',0,'3010400','1','0',3010400,0,0,20080,0,'[[]]',0,1,0),(10049029,'','壁垒NPC',0,'3010900','1','0',3010900,0,0,20081,0,'[[]]',0,1,0),(10049030,'','壁垒NPC',0,'3011000','1','0',3011000,0,0,20082,0,'[[]]',0,1,0),(10049031,'','壁垒NPC',0,'3011200','1','0',3011200,0,0,20083,0,'[[]]',0,1,0),(10049032,'','壁垒NPC',0,'3011300','1','0',3011300,0,0,20084,0,'[[]]',0,1,0),(10049033,'','壁垒NPC',0,'3011301','1','0',3011301,0,0,20085,0,'[[]]',0,1,0),(10049034,'','壁垒NPC',0,'3010100','1','0',3010100,0,0,20086,0,'[[]]',0,1,0),(10049035,'','壁垒NPC',0,'3010200','1','0',3010200,0,0,20087,0,'[[]]',0,1,0),(10049036,'','壁垒NPC',0,'3010400','1','0',3010400,0,0,20088,0,'[[]]',0,1,0),(10049037,'','壁垒NPC',0,'3010900','1','0',3010900,0,0,20089,0,'[[]]',0,1,0),(10049038,'','壁垒NPC',0,'3011000','1','0',3011000,0,0,20090,0,'[[]]',0,1,0),(10049039,'','壁垒NPC',0,'3011200','1','0',3011200,0,0,20091,0,'[[]]',0,1,0),(10049040,'','壁垒NPC',0,'3011300','1','0',3011300,0,0,20092,0,'[[]]',0,1,0),(10059001,'[幸存船员]','基里连科',0,'1001003','1.3','0',3011301,0,0,20093,0,'[[]]',0,1,0),(10059002,'[幸存船员]','瓦西里',0,'1001003','1.3','0',3010100,0,0,20094,0,'[[]]',0,1,0),(10059003,'[呜邦安全局]','零零哆',0,'10029001','1','0',3010200,0,0,20095,0,'[[]]',0,1,0),(10059004,'[帝国先锋军]','山姆',0,'1001005','1.5','0',3010400,0,0,20096,0,'[[]]',0,1,0),(10059005,'[机械师]','铁哆',0,'10039002','1','0',3010900,0,0,20097,0,'[[]]',0,1,0),(10059006,'[呜邦安全局]','警觉零零哆',0,'10029001','1','0',3011000,0,0,20098,0,'[[]]',0,1,0),(10059007,'[幸存船员]','艾琳',0,'10019002','1','0',3011200,0,0,20099,0,'[[]]',0,1,0),(10059008,'[幸存船员]','沮丧的艾琳',0,'10019002','1','0',3011300,0,0,20100,0,'[[]]',0,1,0),(10059009,'[呜邦安全局]','警觉的零零哆',0,'10029001','1','0',3011301,0,0,20101,0,'[[]]',0,1,0),(10059010,'[首席大副]','妮哆',0,'10039003','1','0',3010100,0,0,20102,0,'[[]]',0,1,0),(10059011,'','疑虑海妮薇',0,'3010200','1','0',3010200,0,0,20103,0,'[[]]',0,1,0),(10059012,'[幸存船员]','疑惑的艾琳',0,'10019002','1','0',3010400,0,0,20104,0,'[[]]',0,1,0),(10059013,'[呜邦安全局]','眺望的零零哆',0,'10029001','1','0',3010900,0,0,20105,0,'[[]]',0,1,0),(10059014,'','悠闲的大叔',0,'3011000','1','0',3011000,0,0,20106,0,'[[]]',0,1,0),(10059015,'[首席大副]','施法的妮哆',0,'10039003','1','0',3011200,0,0,20107,0,'[[]]',0,1,0),(10059016,'[幸存船员]','坚守的艾琳',0,'10019002','1','0',3011300,0,0,20108,0,'[[]]',0,1,0),(10059017,'','帝国杀手8号',0,'3011301','1','0',3011301,0,0,20109,0,'[[]]',0,1,0),(10059018,'','冰川NPC',0,'3010100','1','0',3010100,0,0,20110,0,'[[]]',0,1,0),(10059019,'','冰川NPC',0,'3010200','1','0',3010200,0,0,20111,0,'[[]]',0,1,0),(10059020,'','杀手8号',0,'3010400','1','0',3010400,0,0,20112,0,'[[]]',0,1,0),(10069001,'[廊桥禁卫军]','重伤的护卫',0,'3010900','1','0',3010900,0,0,20113,0,'[[]]',0,1,0),(10069002,'[廊桥禁卫军]','隐藏的密探',0,'17020003','1','0',3011000,0,0,20114,0,'[[]]',0,1,0),(10069003,'[廊桥军团长]','贞德',0,'17020001','1','0',2010443100,0,0,20115,0,'[[]]',0,1,0),(10069004,'[骑士团斥候]','零零哆',0,'10029001','1','0',2010420200,0,0,20116,0,'[[]]',0,1,0),(10069005,'[骑士团幕僚]','妮哆',0,'10039003','1','0',2010443200,0,0,20117,0,'[[]]',0,1,0),(10069006,'[廊桥军需官]','卡特琳娜',0,'1004001','1.5','0',3010100,0,0,20118,0,'[[]]',0,1,0),(10069007,'[廊桥禁卫军]','前哨密探',0,'17020003','1','0',3010200,0,0,20119,0,'[[]]',0,1,0),(10069008,'[骑士团随从]','艾琳',0,'10019002','1','0',3010400,0,0,20120,0,'[[]]',0,1,0),(10069009,'[先知亲卫]','骄傲的战士',0,'17020002','1.1','0',3010900,0,0,20121,0,'[[]]',0,1,0),(10069010,'[先知亲卫]','忠诚的护卫',0,'17020002','1.1','0',3011000,0,0,20122,0,'[[]]',0,1,0),(10069011,'[永恒先知]','瓦娜斯',0,'1201008','0.8','0',3011200,0,0,20123,0,'[[]]',0,1,0),(10069012,'','树堡NPC',0,'3011300','1','0',3011300,0,0,20124,0,'[[]]',0,1,0),(10069013,'','树堡NPC',0,'3011301','1','0',3011301,0,0,20125,0,'[[]]',0,1,0),(10069014,'','树堡NPC',0,'3010100','1','0',3010100,0,0,20126,0,'[[]]',0,1,0),(10069015,'','树堡NPC',0,'3010200','1','0',3010200,0,0,20127,0,'[[]]',0,1,0),(10069016,'','树堡NPC',0,'3010400','1','0',3010400,0,0,20128,0,'[[]]',0,1,0),(10069017,'','树堡NPC',0,'3010900','1','0',3010900,0,0,20129,0,'[[]]',0,1,0),(10069018,'','树堡NPC',0,'3011000','1','0',3011000,0,0,20130,0,'[[]]',0,1,0),(10069019,'','树堡NPC',0,'3011200','1','0',3011200,0,0,20131,0,'[[]]',0,1,0),(10069020,'','树堡NPC',0,'3011300','1','0',3011300,0,0,20132,0,'[[]]',0,1,0),(10079001,'[骑士团成员]','山姆',0,'1001005','1.5','0',3011301,0,0,20133,0,'[[]]',0,1,0),(10079002,'[摸金者联盟]','阿里耙耙',0,'1001003','1.3','0',3010100,0,0,20134,0,'[[]]',0,1,0),(10079003,'[骑士团卫官]','艾琳',0,'10049004','1','0',3010200,0,0,20135,0,'[[]]',0,1,0),(10079004,'[财团大佬]','金哆哆',0,'10039001','1','0',3010400,0,0,20136,0,'[[]]',0,1,0),(10079005,'[骑士团幕僚]','妮哆',0,'10039003','1','0',3010900,0,0,20137,0,'[[]]',0,1,0),(10079006,'[骑士团斥候]','零零哆',0,'202004','1','0',2020004,0,0,20138,0,'[[]]',0,1,0),(10079007,'[摸金者联盟]','阿里咚咚',0,'1001003','1.3','0',3011200,0,0,20139,0,'[[]]',0,1,0),(10079008,'[利齿黑寨领]','古鲁',0,'10019003','1','0',3011300,0,0,20140,0,'[[]]',0,1,0),(10079009,'[骑士团卫官]','坚定的艾琳',0,'10049004','1','0',3011301,0,0,20141,0,'[[]]',0,1,0),(10079010,'[骑士团幕僚]','镇定的妮哆',0,'10039003','1','0',3010100,0,0,20142,0,'[[]]',0,1,0),(10079011,'[古漠守护者]','阿拉丁',0,'1201022','0.8','0',3010200,0,0,20143,0,'[[]]',0,1,0),(10079012,'','树堡NPC',0,'3010400','1','0',3010400,0,0,20144,0,'[[]]',0,1,0),(10079013,'','树堡NPC',0,'3010900','1','0',3010900,0,0,20145,0,'[[]]',0,1,0),(10079014,'','树堡NPC',0,'3011000','1','0',3011000,0,0,20146,0,'[[]]',0,1,0),(10079015,'','树堡NPC',0,'3011200','1','0',3011200,0,0,20147,0,'[[]]',0,1,0),(10079016,'','树堡NPC',0,'3010100','1','0',3010100,0,0,20148,0,'[[]]',0,1,0),(10079017,'','树堡NPC',0,'3010200','1','0',3010200,0,0,20149,0,'[[]]',0,1,0),(10079018,'','树堡NPC',0,'3010400','1','0',3010400,0,0,20150,0,'[[]]',0,1,0),(10079019,'','树堡NPC',0,'3010900','1','0',3010900,0,0,20151,0,'[[]]',0,1,0),(10079020,'','树堡NPC',0,'3011000','1','0',3011000,0,0,20152,0,'[[]]',0,1,0),(10089001,'[魔塔发条]','锈迹管家',0,'1005001','1','0',3011301,0,0,20156,0,'[[]]',0,1,0),(10089002,'[骑士团幕僚]','妮哆',0,'10039003','1','0',3010100,0,0,20157,0,'[[]]',0,1,0),(10089003,'[骑士团卫官]','艾琳',0,'10049004','1','0',3010200,0,0,20158,0,'[[]]',0,1,0),(10089004,'[骑士团斥候]','零零哆',0,'10029001','1','0',3010400,0,0,20159,0,'[[]]',0,1,0),(10089005,'[骑士团铁匠]','铁哆',0,'10039002','1','0',3010900,0,0,20160,0,'[[]]',0,1,0),(10089006,'[魔塔发条]','小吵闹',0,'1006001','1','0',3011000,0,0,20161,0,'[[]]',0,1,0),(10089007,'[魔塔发条]','奥丽安娜',0,'1005003','1.2','0',3011200,0,0,20162,0,'[[]]',0,1,0),(10089008,'[骑士团斥候]','零零哆',0,'10029001','1','0',3011300,0,0,20163,0,'[[]]',0,1,0),(10089009,'[骑士团铁匠]','虚弱的铁哆',0,'10039002','1','0',3011301,0,0,20164,0,'[[]]',0,1,0),(10089010,'[骑士团卫官]','顽强的艾琳',0,'10049004','1','0',3010100,0,0,20165,0,'[[]]',0,1,0),(10089011,'','10089011',0,'3010200','1','0',3010200,0,0,20166,0,'[[]]',0,1,0),(10089012,'','10089012',0,'3010400','1','0',3010400,0,0,20167,0,'[[]]',0,1,0),(10089013,'','10089013',0,'3010900','1','0',3010900,0,0,20168,0,'[[]]',0,1,0),(10099001,'[骑士团幕僚]','妮哆',0,'10039003','1','0',3011301,0,0,0,0,'[[]]',0,1,0),(10099002,'[溶洞启灵]','阿姆',0,'1007001','1','0',3010100,0,0,0,0,'[[]]',0,1,0),(10099003,'[骑士团卫官]','艾琳',0,'10049004','1','0',3010200,0,0,20158,0,'[[]]',0,1,0),(10099004,'[骑士团斥候]','零零哆',0,'10029001','1','0',3010400,0,0,20159,0,'[[]]',0,1,0),(10099005,'[呜坦禁卫军]','喵勒多',0,'10039002','1','0',3010900,0,0,20160,0,'[[]]',0,1,0),(10099006,'[魔灵之雏]','厄尔托',0,'1501013','1','0',3011000,0,0,20161,0,'[[]]',0,1,0),(10099007,'[地晶前锋]','苏珊娜',0,'1002006','1.2','0',3011200,0,0,20162,0,'[[]]',0,1,0),(10099008,'[骑士团斥候]','濒死零零哆',0,'10029001','1','0',3011300,0,0,20163,0,'[[]]',0,1,0),(10099009,'[地晶守护者]','克雷多斯',0,'1501007','0.8','0',3011301,0,0,0,0,'[[]]',0,1,0),(10099010,'[骑士团卫官]','无畏的艾琳',0,'10049004','1','0',3010100,0,0,20165,0,'[[]]',0,1,0),(41019001,'','公会宴席',0,'41010001','1','0',41010001,0,0,0,0,'[[]]',0,1,0),(51519001,'','波比特',0,'3011300','1','0',3011300,0,0,20154,0,'[[]]',0,1,0),(51540001,'','婚礼守护军',0,'201007','1','0',201007,0,0,0,0,'[[]]',0,1,0),(51540002,'','婚礼守护军',0,'201007','1','0',201007,0,0,0,0,'[[]]',0,1,0),(51540003,'','家园任务主持人',0,'201007','1','0',201007,0,0,0,0,'[[]]',0,1,0),(51540004,'巡游开启引导员','巡游爱神',0,'201007','1','0',201007,0,0,0,0,'[[]]',0,1,0),(51819001,'[诺亚航空]','护送接待员',0,'201008','1','0',201008,0,0,0,0,'[[]]',0,1,0),(51819002,'','护送-中点',0,'201005','1','0',201005,0,0,0,0,'[[]]',0,1,0),(51819003,'[诺亚航空]','迷雾沼泽接机员',0,'201008','1','0',201008,0,0,0,0,'[[]]',0,1,0),(74050001,'','我是房屋',0,'201007','1.2','0',201007,0,0,0,0,'[[]]',0,1,0),(74050002,'','我是伐木场',0,'201007','1.5','0',201007,0,0,0,0,'[[]]',0,1,0),(74050003,'','我是铁矿场',0,'201007','1.5','0',201007,0,0,0,0,'[[]]',0,1,0),(74050004,'','我是石料场',0,'201007','1.5','0',201007,0,0,0,0,'[[]]',0,1,0),(74050005,'','我是鱼塘',0,'201007','1.5','0',201007,0,0,0,0,'[[]]',0,1,0),(74050006,'','我是许愿池',0,'201007','1.2','0',201007,0,0,0,0,'[[]]',0,1,0),(74050007,'','我是任务场',0,'201007','1.2','0',201007,0,0,0,0,'[[]]',0,1,0);
/*!40000 ALTER TABLE `base_npc` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_onhook`
--

DROP TABLE IF EXISTS `base_onhook`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_onhook` (
  `scene_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '挂机场景',
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '挂机点id',
  `name` varchar(200) NOT NULL COMMENT '挂机点名字',
  `equip_stage` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '装备阶数',
  `equip_num_list` varchar(128) NOT NULL DEFAULT '[]' COMMENT '装备数量列表',
  `goods_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '道具数量',
  `turn_goods_num_list` varchar(128) NOT NULL DEFAULT '[]' COMMENT '转职道具数量列表',
  `custom_goods_num_list` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '定制活动道具数量列表',
  `min_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小等级(不包含)',
  `max_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大等级(包含)',
  `xy` varchar(200) NOT NULL DEFAULT '[{0, 0}]' COMMENT '挂机坐标点[{x1,y1}...]',
  `power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '挂机推荐战力',
  `color` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '挂机点颜色',
  `content` varchar(1000) NOT NULL COMMENT '收益说明',
  `onhook_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '挂机点类型',
  `onhook_exp` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '挂机每分钟经验',
  `turn_task_list` varchar(128) NOT NULL DEFAULT '[]' COMMENT '转职任务列表',
  PRIMARY KEY (`min_lv`,`max_lv`,`onhook_type`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='挂机配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_onhook`
--

LOCK TABLES `base_onhook` WRITE;
/*!40000 ALTER TABLE `base_onhook` DISABLE KEYS */;
INSERT INTO `base_onhook` VALUES (1000,1,'藏宝蟹',1,'[{0,51},{1,34},{2,17},{3,9}]',57,'[]','[]',1,6,'[{20946,4446}]',4020,0,'[{0,1,51},{1,1,34},{2,1,17},{3,1,9},{exp,17134,0}]',0,17134,'[]'),(1000,2,'魔化藏宝蟹',1,'[{0,52},{1,35},{2,18},{3,9}]',58,'[]','[]',6,9,'[{17143,6439}]',7630,0,'[{0,1,52},{1,1,35},{2,1,18},{3,1,9},{exp,17236,0}]',0,17236,'[]'),(1000,3,'树桩怪',1,'[{0,53},{1,36},{2,18},{3,9}]',59,'[]','[]',9,11,'[{8145,6438}]',8150,1,'[{0,1,53},{1,1,36},{2,1,18},{3,1,9},{exp,17339,0}]',0,17339,'[]'),(1000,4,'火鸡骑士',1,'[{0,54},{1,36},{2,18},{3,9}]',61,'[]','[]',11,13,'[{5045,9243}]',9950,1,'[{0,1,54},{1,1,36},{2,1,18},{3,1,9},{exp,17442,0}]',0,17442,'[]'),(1000,5,'强盗',1,'[{0,56},{1,37},{2,19},{3,10}]',62,'[]','[]',13,17,'[{8449,11744}]',10730,1,'[{0,1,56},{1,1,37},{2,1,19},{3,1,10},{exp,17544,0}]',0,17544,'[]'),(1000,6,'树桩怪',1,'[{0,57},{1,38},{2,19},{3,10}]',63,'[]','[]',17,19,'[{4849,17434}]',13005,2,'[{0,1,57},{1,1,38},{2,1,19},{3,1,10},{exp,17647,0}]',0,17647,'[]'),(1002,1,'魔化藏宝蟹',1,'[{0,51},{1,34},{2,17},{3,9}]',57,'[]','[]',25,30,'[{14945,5057}]',36836,0,'[{0,1,51},{1,1,34},{2,1,17},{3,1,9},{exp,17749,0}]',0,17749,'[]'),(1002,2,'魔化平民',1,'[{0,52},{1,35},{2,18},{3,9}]',58,'[]','[]',30,35,'[{16453,13341}]',40531,0,'[{0,1,52},{1,1,35},{2,1,18},{3,1,9},{exp,17852,0}]',0,17852,'[]'),(1002,3,'魔化傀儡',1,'[{0,53},{1,36},{2,18},{3,9}]',59,'[]','[]',35,39,'[{8643,10740}]',45606,1,'[{0,1,53},{1,1,36},{2,1,18},{3,1,9},{exp,17955,0}]',0,17955,'[]'),(1002,4,'魔化楔形虫',1,'[{0,54},{1,36},{2,18},{3,9}]',61,'[]','[]',39,42,'[{7046,5446}]',47576,1,'[{0,1,54},{1,1,36},{2,1,18},{3,1,9},{exp,18057,0}]',0,18057,'[]'),(1002,5,'魔化机兵',1,'[{0,56},{1,37},{2,19},{3,10}]',62,'[]','[]',42,44,'[{3748,11040}]',49101,1,'[{0,1,56},{1,1,37},{2,1,19},{3,1,10},{exp,18160,0}]',0,18160,'[]'),(1002,6,'魔化难民',1,'[{0,57},{1,38},{2,19},{3,10}]',63,'[]','[]',44,50,'[{4445,14446}]',53357,2,'[{0,1,57},{1,1,38},{2,1,19},{3,1,10},{exp,18262,0}]',0,18262,'[]'),(1002,7,'魔化机械',2,'[{0,58},{1,39},{2,20},{3,10}]',65,'[]','[]',50,54,'[{11153,16237}]',54137,2,'[{0,2,58},{1,2,39},{2,2,20},{3,2,10},{exp,18365,0}]',0,18365,'[]'),(1003,1,'暗影狼',2,'[{0,51},{1,34},{2,17},{3,9}]',57,'[]','[]',54,57,'[{5701,2946}]',54657,0,'[{0,2,51},{1,2,34},{2,2,17},{3,2,9},{exp,18468,0}]',0,18468,'[]'),(1003,2,'骷髅兵',2,'[{0,52},{1,35},{2,18},{3,9}]',58,'[]','[]',57,59,'[{7848,4942}]',55177,0,'[{0,2,52},{1,2,35},{2,2,18},{3,2,9},{exp,18570,0}]',0,18570,'[]'),(1003,3,'史莱姆',2,'[{0,53},{1,36},{2,18},{3,9}]',59,'[]','[]',59,62,'[{10658,5534}]',55957,1,'[{0,2,53},{1,2,36},{2,2,18},{3,2,9},{exp,18673,0}]',0,18673,'[]'),(1003,4,'哥布林',2,'[{0,54},{1,36},{2,18},{3,9}]',61,'[]','[]',62,66,'[{12540,10245}]',58212,1,'[{0,2,54},{1,2,36},{2,2,18},{3,2,9},{exp,18775,0}]',0,18775,'[]'),(1003,5,'沼泽妖精',2,'[{0,56},{1,37},{2,19},{3,10}]',62,'[]','[]',66,78,'[{10348,11140}]',66484,1,'[{0,2,56},{1,2,37},{2,2,19},{3,2,10},{exp,18878,0}]',0,18878,'[]'),(1003,6,'沼泽史莱姆',2,'[{0,57},{1,38},{2,19},{3,10}]',63,'[]','[]',78,78,'[{6349,8037}]',70709,2,'[{0,2,57},{1,2,38},{2,2,19},{3,2,10},{exp,18981,0}]',0,18981,'[]'),(1003,7,'蜥蜴人',2,'[{0,58},{1,39},{2,20},{3,10}]',65,'[]','[]',78,80,'[{4059,6141}]',99873,2,'[{0,2,58},{1,2,39},{2,2,20},{3,2,10},{exp,19083,0}]',0,19083,'[]'),(1005,1,'吞噬花',2,'[{0,51},{1,34},{2,17},{3,9}]',57,'[]','[{{4,1},70,70}]',80,83,'[{7252,4334}]',115592,0,'[{0,2,51},{1,2,34},{2,2,17},{3,2,9},{exp,19186,0}]',0,19186,'[]'),(1005,2,'哥布林',2,'[{0,52},{1,35},{2,18},{3,9}]',58,'[]','[{{4,1},70,70}]',83,86,'[{4053,8837}]',118777,0,'[{0,2,52},{1,2,35},{2,2,18},{3,2,9},{exp,19288,0}]',0,19288,'[]'),(1005,3,'森林狼',2,'[{0,53},{1,36},{2,18},{3,9}]',59,'[]','[{{4,1},70,70}]',86,90,'[{7744,14842}]',123373,1,'[{0,2,53},{1,2,36},{2,2,18},{3,2,9},{exp,19391,0}]',0,19391,'[]'),(1005,4,'森林妖精',2,'[{0,54},{1,36},{2,18},{3,9}]',99,'[]','[{{4,1},70,70}]',90,93,'[{10543,9748}]',126158,1,'[{0,2,54},{1,2,36},{2,2,18},{3,2,9},{exp,19494,0}]',0,19494,'[]'),(1005,5,'精灵侍卫',2,'[{0,56},{1,37},{2,19},{3,10}]',102,'[]','[{{4,1},70,70}]',93,96,'[{15297,9999}]',128943,1,'[{0,2,56},{1,2,37},{2,2,19},{3,2,10},{exp,19596,0}]',0,19596,'[]'),(1005,6,'岩龟',3,'[{0,57},{1,38},{2,19},{3,10}]',104,'[]','[{{4,1},70,70}]',96,110,'[{18553,5746}]',131728,2,'[{0,3,57},{1,3,38},{2,3,19},{3,3,10},{exp,19699,0}]',0,19699,'[]'),(1251,3,'半人马',1,'[]',10,'[]','[]',100,160,'[{14087,3512}]',1,0,'[{1,9,68}, {2,9,7}, {lv,61002,150}]',1,0,'[]'),(1301,1,'质量检测员',1,'[]',10,'[]','[]',101,102,'[{12461,4496}]',8,0,'[{1,9,68}, {2,9,7}, {lv,61002,300}]',1,0,'[]'),(1301,2,'怠惰',1,'[]',10,'[]','[]',103,104,'[{7003,2938}]',9,0,'[{1,9,68}, {2,9,7}, {lv,61002,330}]',1,0,'[]'),(1301,3,'阿努比斯',1,'[]',10,'[]','[]',105,106,'[{16810,9443}]',10,0,'[{1,9,68}, {2,9,7}, {lv,61002,350}]',1,0,'[]'),(1301,4,'熔岩战神',1,'[]',10,'[]','[]',107,108,'[{10460,8613}]',11,0,'[{1,9,68}, {2,9,7}, {lv,61002,370}]',1,0,'[]'),(1301,5,'暴食',1,'[]',10,'[]','[]',109,110,'[{21993,11578}]',12,0,'[{1,9,68}, {2,9,7}, {lv,61002,400}]',1,0,'[]'),(1006,1,'丛林狼',3,'[{0,51},{1,34},{2,17},{3,9}]',93,'[]','[{{4,1},70,70}]',110,120,'[{5362,11839}]',136535,0,'[{0,3,51},{1,3,34},{2,3,17},{3,3,9},{exp,19801,0}]',0,19801,'[]'),(1301,6,'蜘蛛女皇',1,'[]',10,'[]','[]',111,112,'[{11088,15618}]',13,0,'[{1,9,68}, {2,9,7}, {lv,61002,430}]',1,0,'[]'),(1301,7,'光明神',1,'[]',10,'[]','[]',113,114,'[{3645,9908}]',14,0,'[{1,9,68}, {2,9,7}, {lv,61002,450}]',1,0,'[]'),(1006,2,'暗裔妖精',3,'[{0,52},{1,35},{2,18},{3,9}]',95,'[{0,2400,50}]','[{{4,1},70,70}]',120,130,'[{2145,14553}]',145438,0,'[{0,3,52},{1,3,35},{2,3,18},{3,3,9},{exp,19904,0}]',0,19904,'[4]'),(1006,3,'食人花',3,'[{0,53},{1,36},{2,18},{3,9}]',97,'[{0,2400,50}]','[{{4,1},70,70}]',130,140,'[{5452,16544}]',150538,1,'[{0,3,53},{1,3,36},{2,3,18},{3,3,9},{exp,20007,0}]',0,20007,'[4]'),(1006,4,'神殿守卫',4,'[{0,54},{1,36},{2,18},{3,9}]',99,'[{0,2400,50}]','[{{4,1},70,70}]',140,160,'[{11945,10263}]',156088,1,'[{0,4,54},{1,4,36},{2,4,18},{3,4,9},{exp,20109,0}]',0,20109,'[4]'),(1252,3,'八岐大蛇',1,'[]',10,'[]','[]',150,200,'[{14087,3512}]',1,0,'[{1,9,68}, {2,9,7}, {lv,61002,200}]',1,0,'[]'),(1006,5,'蜥蜴战士',4,'[{0,56},{1,37},{2,19},{3,10}]',102,'[{0,2400,50}]','[{{4,1},70,70}]',160,170,'[{10599,6196}]',161503,1,'[{0,4,56},{1,4,37},{2,4,19},{3,4,10},{exp,20212,0}]',0,20212,'[4]'),(1251,6,'死神',1,'[]',10,'[]','[]',160,170,'[{4015,11856}]',2,0,'[{1,9,68}, {2,9,7}, {lv,61002,170}]',1,0,'[]'),(1006,6,'岩背龟',4,'[{0,57},{1,38},{2,19},{3,10}]',104,'[{0,2400,50}]','[{{4,1},70,70}]',170,180,'[{11906,3306}]',189883,2,'[{0,4,57},{1,4,38},{2,4,19},{3,4,10},{exp,20314,0}]',0,20314,'[4]'),(1251,7,'暗裔猎手',1,'[]',10,'[]','[]',170,200,'[{13505,13391}]',3,0,'[{1,9,68}, {2,9,7}, {lv,61002,200}]',1,0,'[]'),(1006,7,'森林侍卫',5,'[{0,58},{1,39},{2,20},{3,10}]',106,'[{0,2400,50}]','[{{4,1},70,70}]',180,190,'[{13903,7597}]',230421,2,'[{0,5,58},{1,5,39},{2,5,20},{3,5,10},{exp,20520,0}]',0,20520,'[4]'),(1006,8,'葛布林',6,'[{0,59},{1,40},{2,20},{3,10}]',108,'[{0,2400,50}]','[{{4,1},70,70}]',190,200,'[{17002,9998}]',291841,3,'[{0,6,59},{1,6,40},{2,6,20},{3,6,10},{exp,22680,0}]',0,22680,'[4]'),(1007,1,'雪原企鹅',5,'[{0,51},{1,34},{2,17},{3,9}]',108,'[{0,2400,50}]','[{{4,1},70,70}]',200,210,'[{12957,2454}]',375359,0,'[{0,5,51},{1,5,34},{2,5,17},{3,5,9},{exp,24960,0}]',0,24960,'[4]'),(1252,6,'巴哈姆特',1,'[]',10,'[]','[]',200,250,'[{4015,11856}]',2,0,'[{1,9,68}, {2,9,7}, {lv,61002,250}]',1,0,'[]'),(1302,8,'冰雪皇后',1,'[]',10,'[]','[]',201,202,'[{12461,4496}]',8,0,'[{1,9,68}, {2,9,7}, {lv,61002,300}]',1,0,'[]'),(1302,9,'人马战士',1,'[]',10,'[]','[]',203,204,'[{7003,2938}]',9,0,'[{1,9,68}, {2,9,7}, {lv,61002,330}]',1,0,'[]'),(1302,10,'光明神',1,'[]',10,'[]','[]',205,206,'[{16810,9443}]',10,0,'[{1,9,68}, {2,9,7}, {lv,61002,350}]',1,0,'[]'),(1302,11,'熔岩战神',1,'[]',10,'[]','[]',207,208,'[{10460,8613}]',11,0,'[{1,9,68}, {2,9,7}, {lv,61002,370}]',1,0,'[]'),(1302,12,'海龙王',1,'[]',10,'[]','[]',209,210,'[{21993,11578}]',12,0,'[{1,9,68}, {2,9,7}, {lv,61002,400}]',1,0,'[]'),(1007,2,'雪岩怪',5,'[{0,52},{1,35},{2,18},{3,9}]',111,'[{0,2400,50}]','[{{4,1},70,70}]',210,215,'[{10749,1744}]',463575,0,'[{0,5,52},{1,5,35},{2,5,18},{3,5,9},{exp,24960,0}]',0,24960,'[4]'),(1302,13,'冰霜巨龙',1,'[]',10,'[]','[]',211,212,'[{11088,15618}]',13,0,'[{1,9,68}, {2,9,7}, {lv,61002,430}]',1,0,'[]'),(1302,14,'嫉妒',1,'[]',10,'[]','[]',213,214,'[{3645,9908}]',14,0,'[{1,9,68}, {2,9,7}, {lv,61002,450}]',1,0,'[]'),(1302,15,'冰霜泰坦',1,'[]',10,'[]','[]',215,216,'[{5669,16070}]',15,0,'[{1,9,68}, {2,9,7}, {lv,61002,450}]',1,0,'[]'),(1007,3,'雪原蟹',5,'[{0,53},{1,36},{2,18},{3,9}]',113,'[{0,2400,50}]','[{{4,1},70,70}]',215,220,'[{2658,4659}]',551792,1,'[{0,5,53},{1,5,36},{2,5,18},{3,5,9},{exp,27360,0}]',0,27360,'[4]'),(1007,4,'雪原狼',6,'[{0,54},{1,36},{2,18},{3,9}]',116,'[{0,1200,100},{1,1200,100}]','[{{4,1},70,70}]',220,250,'[{2746,8753}]',640008,1,'[{0,6,54},{1,6,36},{2,6,18},{3,6,9},{exp,27360,0}]',0,27360,'[9]'),(1007,5,'冰原企鹅',6,'[{0,56},{1,37},{2,19},{3,10}]',93,'[{0,1200,100},{1,1200,100}]','[{{4,1},70,70}]',225,230,'[{9957,7876}]',728224,1,'[{0,6,56},{1,6,37},{2,6,19},{3,6,10},{exp,28880,0}]',0,28880,'[9]'),(1007,6,'冰岩怪',6,'[{0,57},{1,38},{2,19},{3,10}]',104,'[{0,1200,100},{1,1200,100}]','[{{4,1},70,70}]',230,240,'[{12452,7556}]',816440,2,'[{0,6,57},{1,6,38},{2,6,19},{3,6,10},{exp,33880,0}]',0,33880,'[9]'),(1007,7,'冰原狼',5,'[{0,58},{1,39},{2,20},{3,10}]',106,'[{0,1200,100},{1,1200,100}]','[{{4,1},70,70}]',240,250,'[{5754,11755}]',887013,2,'[{0,6,58},{1,6,39},{2,6,20},{3,6,10},{exp,35240,0}]',0,35240,'[9]'),(1251,8,'愤怒',1,'[]',10,'[]','[]',240,250,'[{7182,17323}]',4,0,'[{1,9,68}, {2,9,7}, {lv,61002,250}]',1,0,'[]'),(1008,1,'骷髅士兵',6,'[{0,51},{1,34},{2,17},{3,9}]',101,'[{0,1200,100},{1,1200,100}]','[{{4,1},70,70}]',250,255,'[{3652,3193}]',957450,0,'[{0,7,58},{1,7,39},{2,7,20},{3,7,10},{exp,35240,0}]',0,35240,'[9]'),(1252,8,'冰霜泰坦',1,'[]',10,'[]','[]',250,300,'[{13505,13391}]',3,0,'[{1,9,68}, {2,9,7}, {lv,61002,300}]',1,0,'[]'),(1008,2,'沙布林',6,'[{0,52},{1,35},{2,18},{3,9}]',108,'[{0,1200,100},{1,1200,100}]','[{{4,1},70,70}]',255,260,'[{7451,6549}]',1034383,0,'[{0,7,59},{1,7,40},{2,7,20},{3,7,10},{exp,36640,0}]',0,36640,'[9]'),(1008,3,'沙盗',7,'[{0,53},{1,36},{2,18},{3,9}]',110,'[{0,1200,100},{1,1200,100}]','[{{4,1},70,70}]',260,265,'[{5048,10249}]',1111317,1,'[{0,6,51},{1,6,34},{2,6,17},{3,6,9},{exp,36640,0}]',0,36640,'[9]'),(1008,4,'邪恶佣兵',7,'[{0,54},{1,36},{2,18},{3,9}]',113,'[{0,1200,100},{1,1200,100}]','[{{4,1},70,70}]',265,270,'[{5558,13849}]',1188250,1,'[{0,6,52},{1,6,35},{2,6,18},{3,6,9},{exp,38400,0}]',0,38400,'[9]'),(1008,5,'沙漠蝎子',7,'[{0,56},{1,37},{2,19},{3,10}]',115,'[{0,600,150},{1,600,150},{2,600,150}]','[{{4,1},70,70}]',270,275,'[{10341,8581}]',1249797,1,'[{0,7,53},{1,7,36},{2,7,18},{3,7,9},{exp,38400,0}]',0,38400,'[14]'),(1008,6,'沙漠蜥蜴',7,'[{0,57},{1,38},{2,19},{3,10}]',118,'[{0,600,150},{1,600,150},{2,600,150}]','[{{4,1},70,70}]',275,280,'[{18949,9762}]',1301086,2,'[{0,7,54},{1,7,36},{2,7,18},{3,7,9},{exp,38160,0}]',0,38160,'[14]'),(1008,7,'骷髅守卫',7,'[{0,58},{1,39},{2,20},{3,10}]',120,'[{0,600,150},{1,600,150},{2,600,150}]','[{{4,1},70,70}]',280,290,'[{13953,9658}]',1352375,2,'[{0,7,56},{1,7,37},{2,7,19},{3,7,10},{exp,40200,0}]',0,40200,'[14]'),(1253,2,'蜘蛛女皇',1,'[]',10,'[]','[]',280,300,'[{14087,3512}]',1,0,'[{1,9,68}, {2,9,7}, {lv,61002,300}]',1,0,'[]'),(1008,8,'蜥蜴战士',7,'[{0,59},{1,40},{2,20},{3,10}]',123,'[{0,600,150},{1,600,150},{2,600,150}]','[{{4,1},70,70}]',290,300,'[{8757,15250}]',1403664,3,'[{0,7,57},{1,7,38},{2,7,19},{3,7,10},{exp,41040,0}]',0,41040,'[14]'),(1251,1,'八岐大蛇',1,'[]',10,'[]','[]',290,300,'[{19789,10574}]',5,0,'[{1,9,68}, {2,9,7}, {lv,61002,300}]',1,0,'[]'),(1009,1,'废旧机器人',8,'[{0,51},{1,34},{2,17},{3,9}]',105,'[{0,300,150},{1,300,150},{2,300,150}]','[{{4,1},70,70}]',300,305,'[{2739,8636}]',1519717,0,'[{0,8,51},{1,8,34},{2,8,17},{3,8,9},{exp,41040,0}]',0,41040,'[14]'),(1252,1,'暗裔恶魔',1,'[]',10,'[]','[]',300,350,'[{7182,17323}]',4,0,'[{1,9,68}, {2,9,7}, {lv,61002,350}]',1,0,'[]'),(1303,1,'暗裔猎手',1,'[]',10,'[]','[]',301,302,'[{12461,4496}]',7,0,'[{1,9,68}, {2,9,7}, {lv,61002,300}]',1,0,'[]'),(1303,2,'冰霜巨龙',1,'[]',10,'[]','[]',303,304,'[{7003,2938}]',8,0,'[{1,9,68}, {2,9,7}, {lv,61002,330}]',1,0,'[]'),(1303,3,'寒冰女神',1,'[]',10,'[]','[]',305,306,'[{16810,9443}]',9,0,'[{1,9,68}, {2,9,7}, {lv,61002,350}]',1,0,'[]'),(1009,2,'机械犬',8,'[{0,52},{1,35},{2,18},{3,9}]',108,'[{0,300,150},{1,300,150},{2,300,150}]','[{{4,1},70,70}]',305,310,'[{2559,11141}]',1689234,0,'[{0,8,52},{1,8,35},{2,8,18},{3,8,9},{exp,40720,0}]',0,40720,'[14]'),(1303,4,'巴哈姆特',1,'[]',10,'[]','[]',307,308,'[{10460,8613}]',10,0,'[{1,9,68}, {2,9,7}, {lv,61002,370}]',1,0,'[]'),(1303,5,'迦楼罗',1,'[]',10,'[]','[]',309,310,'[{21993,11578}]',11,0,'[{1,9,68}, {2,9,7}, {lv,61002,400}]',1,0,'[]'),(1009,3,'帝国步兵',8,'[{0,53},{1,36},{2,18},{3,9}]',110,'[{0,300,150},{1,300,150},{2,300,150}]','[{{4,1},70,70}]',310,315,'[{6862,14639}]',1858751,1,'[{0,8,53},{1,8,36},{2,8,18},{3,8,9},{exp,40720,0}]',0,40720,'[14]'),(1303,6,'食人花',1,'[]',10,'[]','[]',311,312,'[{11088,15618}]',12,0,'[{1,9,68}, {2,9,7}, {lv,61002,430}]',1,0,'[]'),(1009,4,'机动巡逻兵',8,'[{0,54},{1,36},{2,18},{3,9}]',113,'[{0,300,150},{1,300,150},{2,300,150}]','[{{4,1},70,70}]',315,320,'[{11255,10446}]',2028267,1,'[{0,8,54},{1,8,36},{2,8,18},{3,8,9},{exp,43320,0}]',0,43320,'[14]'),(1009,5,'恶魔幼体',8,'[{0,56},{1,37},{2,19},{3,10}]',115,'[{0,300,150},{1,300,150},{2,300,150}]','[{{4,1},70,70}]',320,330,'[{10055,8342}]',2163881,1,'[{0,8,56},{1,8,37},{2,8,19},{3,8,10},{exp,45920,0}]',0,45920,'[14]'),(1009,6,'破烂机器人',8,'[{0,57},{1,38},{2,19},{3,10}]',118,'[{0,300,150},{1,300,150},{2,300,150}]','[{{4,1},70,70}]',330,340,'[{9162,3851}]',2276892,2,'[{0,8,57},{1,8,38},{2,8,19},{3,8,10},{exp,46120,0}]',0,46120,'[14]'),(1253,4,'海龙王',1,'[]',10,'[]','[]',330,350,'[{4015,11856}]',2,0,'[{1,9,68}, {2,9,7}, {lv,61002,350}]',1,0,'[]'),(1009,7,'机械狗',8,'[{0,58},{1,39},{2,20},{3,10}]',120,'[{0,300,150},{1,300,150},{2,300,150}]','[{{4,1},70,70}]',340,350,'[{5750,1652}]',2389903,2,'[{0,8,58},{1,8,39},{2,8,20},{3,8,10},{exp,49520,0}]',0,49520,'[14]'),(1251,2,'冰霜巨龙',1,'[]',10,'[]','[]',340,350,'[{23217,13705}]',6,0,'[{1,9,68}, {2,9,7}, {lv,61002,350}]',1,0,'[]'),(1009,8,'帝国士兵',9,'[{0,59},{1,40},{2,20},{3,10}]',123,'[{0,3,2},{1,3,2},{2,3,2},{3,3,2}]','[{{4,1},70,70}]',350,355,'[{11547,4451}]',2502914,3,'[{0,8,59},{1,8,40},{2,8,20},{3,8,10},{exp,49520,0}]',0,49520,'[16]'),(1252,2,'海龙王',1,'[]',10,'[]','[]',350,400,'[{19789,10574}]',5,0,'[{1,9,68}, {2,9,7}, {lv,61002,400}]',1,0,'[]'),(1010,1,'鱼人守卫',9,'[{0,51},{1,34},{2,17},{3,9}]',121,'[{0,3,2},{1,3,2},{2,3,2},{3,3,2}]','[{{4,1},70,70}]',355,360,'[{6652,1451}]',2708031,0,'[{0,9,51},{1,9,34},{2,9,17},{3,9,9},{exp,52840,0}]',0,49520,'[16]'),(1010,2,'海王蟹',9,'[{0,52},{1,35},{2,18},{3,9}]',105,'[{0,3,2},{1,3,2},{2,3,2},{3,3,2}]','[{{4,1},70,70}]',360,370,'[{8457,4857}]',2986679,0,'[{0,9,52},{1,9,35},{2,9,18},{3,9,9},{exp,80040,0}]',0,52840,'[16]'),(1254,3,'食人花',1,'[]',10,'[]','[]',360,400,'[{14087,3512}]',1,0,'[{1,9,68}, {2,9,7}, {lv,61002,400}]',1,0,'[]'),(1010,3,'巨齿鲨',9,'[{0,53},{1,36},{2,18},{3,9}]',109,'[{0,3,2},{1,3,2},{2,3,2},{3,3,2}]','[{{4,1},70,70}]',370,375,'[{10843,4150}]',3265326,1,'[{0,9,53},{1,9,36},{2,9,18},{3,9,9},{exp,80040,0}]',0,80040,'[16]'),(1010,4,'鱼人刺客',9,'[{0,54},{1,36},{2,18},{3,9}]',111,'[{0,3,2},{1,3,2},{2,3,2},{3,3,2}]','[{{4,1},70,70}]',375,380,'[{12861,6245}]',3589741,1,'[{0,9,54},{1,9,36},{2,9,18},{3,9,9},{exp,100720,0}]',0,80040,'[16]'),(1010,5,'海蜥蜴',9,'[{0,56},{1,37},{2,19},{3,10}]',114,'[{0,3,2},{1,3,2},{2,3,2},{3,3,2}]','[{{4,1},70,70}]',380,385,'[{11564,8838}]',4097228,1,'[{0,9,56},{1,9,37},{2,9,19},{3,9,10},{exp,100720,0}]',0,100720,'[16]'),(1253,6,'食人花',1,'[]',10,'[]','[]',380,400,'[{13505,13391}]',3,0,'[{1,9,68}, {2,9,7}, {lv,61002,400}]',1,0,'[]'),(1010,6,'鱼人护卫',9,'[{0,57},{1,38},{2,19},{3,10}]',116,'[{0,3,2},{1,3,2},{2,3,2},{3,3,2}]','[{{4,1},70,70}]',385,390,'[{14353,13558}]',4604716,2,'[{0,9,57},{1,9,38},{2,9,19},{3,9,10},{exp,111760,0}]',0,100720,'[16]'),(1010,7,'锯齿鲨',8,'[{0,58},{1,39},{2,20},{3,10}]',119,'[{0,3,2},{1,3,2},{2,3,2},{3,3,2}]','[{{4,1},70,70}]',390,400,'[{11849,16142}]',5010705,2,'[{0,9,58},{1,9,39},{2,9,20},{3,9,10},{exp,122760,0}]',0,111760,'[16]'),(1251,4,'寒冰女神',1,'[]',10,'[]','[]',390,400,'[{19155,18011}]',7,0,'[{1,9,68}, {2,9,7}, {lv,61002,400}]',1,0,'[]'),(1012,1,'灰烬魔蝎',10,'[{0,51},{1,34},{2,17},{3,9}]',106,'[{0,3,2},{1,3,2},{2,3,2},{3,3,2},{4,3,2}]','[{{4,1},70,70}]',400,405,'[{7443,13274}]',5399283,0,'[{0,10,51},{1,10,34},{2,10,17},{3,10,9},{exp,977520,0}]',0,122760,'[16]'),(1301,8,'魔域妖花',1,'[]',10,'[]','[]',400,410,'[{15733,5655}]',1,0,'[{1,9,68}, {2,9,7}, {lv,61002,260}]',3,0,'[]'),(1251,5,'色欲',1,'[]',10,'[]','[]',400,450,'[{12852,23975}]',8,0,'[{1,9,68}, {2,9,7}, {lv,61002,450}]',1,0,'[]'),(1301,9,'魔域地精',1,'[]',10,'[]','[]',401,411,'[{8421,5249}]',2,0,'[{1,9,68}, {2,9,7}, {lv,61002,280}]',3,0,'[]'),(1301,10,'暗影魔狼',1,'[]',10,'[]','[]',402,412,'[{15993,14218}]',3,0,'[{1,9,68}, {2,9,7}, {lv,61002,300}]',3,0,'[]'),(1301,11,'森林妖精',1,'[]',10,'[]','[]',403,413,'[{12590,11470}]',4,0,'[{1,9,68}, {2,9,7}, {lv,61002,320}]',3,0,'[]'),(1301,12,'魔灵侍卫',1,'[]',10,'[]','[]',404,414,'[{9093,12203}]',5,0,'[{1,9,68}, {2,9,7}, {lv,61002,340}]',3,0,'[]'),(1012,2,'熔岩爆弹',10,'[{0,52},{1,35},{2,18},{3,9}]',110,'[{0,3,2},{1,3,2},{2,3,2},{3,3,2}]','[{{4,1},70,70}]',405,410,'[{5748,17263}]',5838112,0,'[{0,10,52},{1,10,35},{2,10,18},{3,10,9},{exp,256440,0}]',0,122760,'[16]'),(1301,13,'魔域岩龟',1,'[]',10,'[]','[]',405,415,'[{3925,5742}]',6,0,'[{1,9,68}, {2,9,7}, {lv,61002,360}]',3,0,'[]'),(1301,14,'魔石傀儡',1,'[]',10,'[]','[]',406,416,'[{1710,13363}]',7,0,'[{1,9,68}, {2,9,7}, {lv,61002,380}]',3,0,'[]'),(1302,1,'魔化机械',1,'[]',10,'[]','[]',407,417,'[{15733,5655}]',1,0,'[{1,9,68}, {2,9,7}, {lv,61002,425}]',3,0,'[]'),(1302,2,'魔域影狼',1,'[]',10,'[]','[]',408,418,'[{8421,5249}]',2,0,'[{1,9,68}, {2,9,7}, {lv,61002,450}]',3,0,'[]'),(1302,3,'骷髅守卫',1,'[]',10,'[]','[]',409,419,'[{12463,11533}]',3,0,'[{1,9,68}, {2,9,7}, {lv,61002,475}]',3,0,'[]'),(1012,3,'熔化史莱姆',10,'[{0,53},{1,36},{2,18},{3,9}]',112,'[{0,3,2},{1,3,2},{2,3,2},{3,3,2},{4,3,2}]','[{{4,1},70,70}]',410,415,'[{15544,19571}]',6276942,1,'[{0,10,53},{1,10,36},{2,10,18},{3,10,9},{exp,426360,0}]',0,133760,'[16]'),(1302,4,'魔域莱姆',1,'[]',10,'[]','[]',410,420,'[{16172,14175}]',4,0,'[{1,9,68}, {2,9,7}, {lv,61002,500}]',3,0,'[]'),(1254,5,'冰霜巨龙',1,'[]',10,'[]','[]',410,450,'[{4015,11856}]',2,0,'[{1,9,68}, {2,9,7}, {lv,61002,450}]',1,0,'[]'),(1302,5,'地精刺客',1,'[]',10,'[]','[]',411,421,'[{3838,5733}]',5,0,'[{1,9,68}, {2,9,7}, {lv,61002,525}]',3,0,'[]'),(1302,6,'魔域蝠灵',1,'[]',10,'[]','[]',412,422,'[{8973,12222}]',6,0,'[{1,9,68}, {2,9,7}, {lv,61002,550}]',3,0,'[]'),(1302,7,'魔域火蜥',1,'[]',10,'[]','[]',413,423,'[{1710,13363}]',7,0,'[{1,9,68}, {2,9,7}, {lv,61002,575}]',3,0,'[]'),(1303,7,'魔化晶蟹',1,'[]',10,'[]','[]',414,424,'[{15733,5655}]',1,0,'[{1,9,68}, {2,9,7}, {lv,61002,550}]',3,0,'[]'),(1012,4,'能量探测机',10,'[{0,54},{1,36},{2,18},{3,9}]',115,'[{0,3,2},{1,3,2},{2,3,2},{3,3,2},{4,3,2}]','[{{4,1},70,70}]',415,420,'[{11264,16046}]',6715772,1,'[{0,10,54},{1,10,36},{2,10,18},{3,10,9},{exp,558960,0}]',0,133760,'[16]'),(1301,15,'冰雪女王',1,'[]',10,'[]','[]',415,425,'[{5300,15900}]',13,0,'[{1,9,68}, {2,9,7}, {lv,61002,430}]',1,0,'[]'),(1303,8,'双刃魔卫',1,'[]',10,'[]','[]',415,425,'[{8421,5249}]',2,0,'[{1,9,68}, {2,9,7}, {lv,61002,570}]',3,0,'[]'),(1303,9,'魔化傀儡',1,'[]',10,'[]','[]',416,426,'[{12643,11128}]',3,0,'[{1,9,68}, {2,9,7}, {lv,61002,590}]',3,0,'[]'),(1303,10,'魔域火蝎',1,'[]',10,'[]','[]',417,427,'[{16188,13999}]',4,0,'[{1,9,68}, {2,9,7}, {lv,61002,610}]',3,0,'[]'),(1303,11,'魔化机兵',1,'[]',10,'[]','[]',418,428,'[{4533,6198}]',5,0,'[{1,9,68}, {2,9,7}, {lv,61002,630}]',3,0,'[]'),(1303,12,'机械魔将',1,'[]',10,'[]','[]',419,429,'[{8858,12018}]',6,0,'[{1,9,68}, {2,9,7}, {lv,61002,645}]',3,0,'[]'),(1012,5,'魔晶炯眼',10,'[{0,56},{1,37},{2,19},{3,10}]',117,'[{0,3,2},{1,3,2},{2,3,2},{3,3,2},{4,3,2}]','[{{4,1},70,70}]',420,430,'[{14107,11078}]',7154601,1,'[{0,10,56},{1,10,37},{2,10,19},{3,10,10},{exp,669080,0}]',0,144800,'[16]'),(1304,7,'背背钻蟹',1,'[]',10,'[]','[]',420,430,'[{15733,5655}]',1,0,'[{1,9,68}, {2,9,7}, {lv,61002,660}]',3,0,'[]'),(1304,8,'背背箱蟹',1,'[]',10,'[]','[]',421,431,'[{16253,13958}]',2,0,'[{1,9,68}, {2,9,7}, {lv,61002,675}]',3,0,'[]'),(1304,9,'魔域树妖',1,'[]',10,'[]','[]',422,432,'[{12455,11508}]',3,0,'[{1,9,68}, {2,9,7}, {lv,61002,690}]',3,0,'[]'),(1304,10,'绿皮地精',1,'[]',10,'[]','[]',423,433,'[{8508,5218}]',4,0,'[{1,9,68}, {2,9,7}, {lv,61002,700}]',3,0,'[]'),(1304,11,'魔域刀兵',1,'[]',10,'[]','[]',424,434,'[{3846,5750}]',5,0,'[{1,9,68}, {2,9,7}, {lv,61002,710}]',3,0,'[]'),(1304,12,'魔斧树妖',1,'[]',10,'[]','[]',425,435,'[{8888,12018}]',6,0,'[{1,9,68}, {2,9,7}, {lv,61002,720}]',3,0,'[]'),(1012,6,'信号机器人',10,'[{0,57},{1,38},{2,19},{3,10}]',120,'[{0,3,2},{1,3,2},{2,3,2},{3,3,2},{4,3,2}]','[{{4,1},70,70}]',430,440,'[{17413,8963}]',7745964,2,'[{0,10,57},{1,10,38},{2,10,19},{3,10,10},{exp,779240,0}]',0,155800,'[16]'),(1253,7,'暗裔猎手',1,'[]',10,'[]','[]',430,450,'[{7182,17323}]',4,0,'[{1,9,68}, {2,9,7}, {lv,61002,450}]',1,0,'[]'),(1012,7,'帝国特种兵',10,'[{0,58},{1,39},{2,20},{3,10}]',122,'[{0,3,2},{1,3,2},{2,3,2},{3,3,2},{4,3,2}]','[{{4,1},70,70}]',440,445,'[{11840,3945}]',8489860,2,'[{0,10,58},{1,10,39},{2,10,20},{3,10,10},{exp,889400,0}]',0,166000,'[16]'),(1254,6,'光明神',1,'[]',10,'[]','[]',440,500,'[{13505,13391}]',3,0,'[{1,9,68}, {2,9,7}, {lv,61002,500}]',1,0,'[]'),(1012,8,'熔岩蜥蜴',10,'[{0,59},{1,40},{2,20},{3,10}]',125,'[{0,3,2},{1,3,2},{2,3,2},{3,3,2},{4,3,2}]','[{{4,1},70,70}]',445,450,'[{7747,8581}]',9977651,3,'[{0,10,59},{1,10,40},{2,10,20},{3,10,10},{exp,977520,0}]',0,166000,'[16]'),(1252,4,'嫉妒',1,'[]',10,'[]','[]',445,450,'[{23217,13705}]',6,0,'[{1,9,68}, {2,9,7}, {lv,61002,450}]',1,0,'[]'),(1011,1,'百花妖',10,'[{0,51},{1,34},{2,17},{3,9}]',106,'[{0,3,2},{1,3,2},{2,3,2},{3,3,2}]','[{{4,1},70,70}]',450,500,'[{10410,6208}]',5530932,0,'[{0,15,57},{1,15,38},{2,15,19},{3,15,10},{exp,122760,0}]',0,193640,'[16]'),(1252,5,'寒冰女神',1,'[]',10,'[]','[]',450,500,'[{19155,18011}]',7,0,'[{1,9,68}, {2,9,7}, {lv,61002,500}]',1,0,'[]'),(1255,7,'嫉妒',1,'[]',10,'[]','[]',470,500,'[{14087,3512}]',1,0,'[{1,9,68}, {2,9,7}, {lv,61002,500}]',1,0,'[]'),(1253,8,'美杜莎',1,'[]',10,'[]','[]',480,500,'[{19789,10574}]',5,0,'[{1,9,68}, {2,9,7}, {lv,61002,500}]',1,0,'[]'),(1011,2,'麻将精',12,'[{0,52},{1,35},{2,18},{3,9}]',110,'[{0,3,2},{1,3,2},{2,3,2},{3,3,2}]','[{{4,1},70,70}]',500,550,'[{6865,10345}]',6189176,0,'[{0,15,59},{1,15,40},{2,15,20},{3,15,10},{exp,133760,0}]',0,256440,'[17]'),(1252,7,'光明神',1,'[]',10,'[]','[]',500,550,'[{12852,23975}]',8,0,'[{1,9,68}, {2,9,7}, {lv,61002,550}]',1,0,'[]'),(6000,3,'中路水晶',1,'[]',0,'[]','[]',501,600,'[{7974,6232}]',1,3,'[]',1,0,'[]'),(1254,8,'暗裔恶魔',1,'[]',10,'[]','[]',510,550,'[{7182,17323}]',4,0,'[{1,9,68}, {2,9,7}, {lv,61002,550}]',1,0,'[]'),(6201,1,'食人花',1,'[]',10,'[]','[]',512,522,'[{9570,2881}]',5,0,'[{1,9,68}, {2,9,7}, {lv,61002,700}]',0,0,'[]'),(6201,2,'哥布林',1,'[]',10,'[]','[]',513,523,'[{4768,5116}]',5,0,'[{1,9,68}, {2,9,7}, {lv,61002,700}]',0,0,'[]'),(6201,3,'森林妖精',1,'[]',10,'[]','[]',526,536,'[{8298,12689}]',5,0,'[{1,9,68}, {2,9,7}, {lv,61002,700}]',0,0,'[]'),(6201,4,'荒原狼',1,'[]',10,'[]','[]',527,537,'[{11227,12628}]',5,0,'[{1,9,68}, {2,9,7}, {lv,61002,700}]',0,0,'[]'),(6201,5,'爆弹仔',1,'[]',10,'[]','[]',530,540,'[{14238,4918}]',5,0,'[{1,9,68}, {2,9,7}, {lv,61002,700}]',0,0,'[]'),(1253,1,'月神',1,'[]',10,'[]','[]',530,550,'[{23217,13705}]',6,0,'[{1,9,68}, {2,9,7}, {lv,61002,550}]',1,0,'[]'),(6201,6,'暗裔猎手',1,'[]',10,'[]','[]',533,543,'[{5100,11400}]',5,0,'[{1,9,68}, {2,9,7}, {lv,61002,700}]',1,0,'[]'),(6201,7,'死神',1,'[]',10,'[]','[]',536,546,'[{14000,11200}]',5,0,'[{1,9,68}, {2,9,7}, {lv,61002,700}]',1,0,'[]'),(6201,8,'冰霜巨龙',1,'[]',10,'[]','[]',539,549,'[{15000,8400}]',5,0,'[{1,9,68}, {2,9,7}, {lv,61002,700}]',1,0,'[]'),(1255,2,'阿努比斯',1,'[]',10,'[]','[]',540,550,'[{4015,11856}]',2,0,'[{1,9,68}, {2,9,7}, {lv,61002,550}]',1,0,'[]'),(1254,1,'迦楼罗',1,'[]',10,'[]','[]',540,600,'[{19789,10574}]',5,0,'[{1,9,68}, {2,9,7}, {lv,61002,600}]',1,0,'[]'),(6201,9,'寒冰女神',1,'[]',10,'[]','[]',542,552,'[{4100,8200}]',5,0,'[{1,9,68}, {2,9,7}, {lv,61002,700}]',1,0,'[]'),(6201,10,'半人马',1,'[]',10,'[]','[]',545,555,'[{13100,2800}]',5,0,'[{1,9,68}, {2,9,7}, {lv,61002,700}]',1,0,'[]'),(6201,11,'食人花',1,'[]',10,'[]','[]',548,558,'[{6100,2800}]',5,0,'[{1,9,68}, {2,9,7}, {lv,61002,700}]',1,0,'[]'),(1011,3,'叛忍',12,'[{0,53},{1,36},{2,18},{3,9}]',112,'[{0,3,2},{1,3,2},{2,3,2},{3,3,2}]','[{{4,1},70,70}]',550,600,'[{2855,8443}]',6847421,1,'[{0,12,52},{1,12,35},{2,12,18},{3,12,9},{exp,133760,0}]',0,426360,'[17]'),(6201,12,'巴哈姆特',1,'[]',10,'[]','[]',551,561,'[{9565,9295}]',5,0,'[{1,9,68}, {2,9,7}, {lv,61002,700}]',3,0,'[]'),(1255,3,'迦楼罗',1,'[]',10,'[]','[]',570,600,'[{13505,13391}]',3,0,'[{1,9,68}, {2,9,7}, {lv,61002,600}]',1,0,'[]'),(1256,3,'色欲',1,'[]',10,'[]','[]',575,600,'[{14087,3512}]',1,0,'[{1,9,68}, {2,9,7}, {lv,61002,600}]',1,0,'[]'),(1253,3,'死神',1,'[]',10,'[]','[]',580,600,'[{19155,18011}]',7,0,'[{1,9,68}, {2,9,7}, {lv,61002,600}]',1,0,'[]'),(1011,4,'大名熊霸',13,'[{0,54},{1,36},{2,18},{3,9}]',115,'[{0,3,2},{1,3,2},{2,3,2},{3,3,2}]','[{{4,1},70,70}]',600,650,'[{4639,13003}]',7597185,1,'[{0,12,53},{1,12,36},{2,12,18},{3,12,9},{exp,144800,0}]',0,558960,'[17]'),(6302,1,'冰雪女王',1,'[]',10,'[]','[]',601,600,'[{10200,8500}]',5,0,'[{1,9,68}, {2,9,7}, {lv,61002,700}]',1,0,'[]'),(1304,1,'食人花',1,'[]',10,'[]','[]',601,602,'[{12461,4496}]',7,0,'[{1,9,68}, {2,9,7}, {lv,61002,300}]',1,0,'[]'),(6000,2,'左路水晶',1,'[]',0,'[]','[]',601,700,'[{3292,5402}]',1,3,'[]',1,0,'[]'),(1304,2,'月神',1,'[]',10,'[]','[]',603,604,'[{7003,2938}]',8,0,'[{1,9,68}, {2,9,7}, {lv,61002,330}]',1,0,'[]'),(1304,3,'美杜莎',1,'[]',10,'[]','[]',605,606,'[{16810,9443}]',9,0,'[{1,9,68}, {2,9,7}, {lv,61002,350}]',1,0,'[]'),(1304,4,'愤怒',1,'[]',10,'[]','[]',607,608,'[{10460,8613}]',10,0,'[{1,9,68}, {2,9,7}, {lv,61002,370}]',1,0,'[]'),(1304,5,'海龙王',1,'[]',10,'[]','[]',609,610,'[{21993,11578}]',11,0,'[{1,9,68}, {2,9,7}, {lv,61002,400}]',1,0,'[]'),(1254,2,'熔岩战神',1,'[]',10,'[]','[]',610,650,'[{23217,13705}]',6,0,'[{1,9,68}, {2,9,7}, {lv,61002,650}]',1,0,'[]'),(1304,6,'死神',1,'[]',10,'[]','[]',611,612,'[{11088,15618}]',12,0,'[{1,9,68}, {2,9,7}, {lv,61002,430}]',1,0,'[]'),(6302,2,'暗裔恶魔',1,'[]',10,'[]','[]',621,622,'[{3700,9800}]',5,0,'[{1,9,68}, {2,9,7}, {lv,61002,700}]',1,0,'[]'),(1253,5,'暴食',1,'[]',10,'[]','[]',630,650,'[{12852,23975}]',8,0,'[{1,9,68}, {2,9,7}, {lv,61002,650}]',1,0,'[]'),(1256,5,'机械巨人',1,'[]',10,'[]','[]',635,650,'[{4015,11856}]',2,0,'[{1,9,68}, {2,9,7}, {lv,61002,650}]',1,0,'[]'),(1255,5,'熔岩战神',1,'[]',10,'[]','[]',640,650,'[{7182,17323}]',4,0,'[{1,9,68}, {2,9,7}, {lv,61002,650}]',1,0,'[]'),(1254,4,'暴食',1,'[]',10,'[]','[]',640,700,'[{19155,18011}]',7,0,'[{1,9,68}, {2,9,7}, {lv,61002,700}]',1,0,'[]'),(6302,3,'迦楼罗',1,'[]',10,'[]','[]',641,642,'[{12800,3700}]',5,0,'[{1,9,68}, {2,9,7}, {lv,61002,700}]',1,0,'[]'),(1011,5,'白虎丸',14,'[{0,56},{1,37},{2,19},{3,10}]',117,'[{0,3,2},{1,3,2},{2,3,2},{3,3,2}]','[{{4,1},70,70}]',650,700,'[{13449,8738}]',8489860,1,'[{0,13,54},{1,13,36},{2,13,18},{3,13,9},{exp,155800,0}]',0,669080,'[17]'),(6302,4,'暴食',1,'[]',10,'[]','[]',651,652,'[{10900,14900}]',5,0,'[{1,9,68}, {2,9,7}, {lv,61002,700}]',1,0,'[]'),(1256,6,'冰霜泰坦',1,'[]',10,'[]','[]',655,700,'[{13505,13391}]',3,0,'[{1,9,68}, {2,9,7}, {lv,61002,700}]',1,0,'[]'),(1255,6,'半人马',1,'[]',10,'[]','[]',670,700,'[{19789,10574}]',5,0,'[{1,9,68}, {2,9,7}, {lv,61002,700}]',1,0,'[]'),(6302,5,'蜘蛛女皇',1,'[]',10,'[]','[]',671,672,'[{17300,8300}]',5,0,'[{1,9,68}, {2,9,7}, {lv,61002,700}]',1,0,'[]'),(6302,6,'暮光月神',1,'[]',10,'[]','[]',691,692,'[{21500,11400}]',5,0,'[{1,9,68}, {2,9,7}, {lv,61002,700}]',1,0,'[]'),(1011,6,'万花妖',15,'[{0,57},{1,38},{2,19},{3,10}]',120,'[{0,3,2},{1,3,2},{2,3,2},{3,3,2}]','[{{4,1},70,70}]',700,750,'[{8748,11847}]',9233756,2,'[{0,14,56},{1,14,37},{2,14,19},{3,14,10},{exp,166000,0}]',0,779240,'[17]'),(6303,3,'暮光月神',1,'[]',10,'[]','[]',701,721,'[{12800,3700}]',5,0,'[{1,9,68}, {2,9,7}, {lv,61002,700}]',1,0,'[]'),(1254,7,'巴哈姆特',1,'[]',10,'[]','[]',710,750,'[{12852,23975}]',8,0,'[{1,9,68}, {2,9,7}, {lv,61002,750}]',1,0,'[]'),(6303,4,'嫉妒',1,'[]',10,'[]','[]',721,741,'[{10900,14900}]',5,0,'[{1,9,68}, {2,9,7}, {lv,61002,700}]',1,0,'[]'),(1256,8,'怠惰',1,'[]',10,'[]','[]',735,750,'[{7182,17323}]',4,0,'[{1,9,68}, {2,9,7}, {lv,61002,750}]',1,0,'[]'),(1255,8,'愤怒',1,'[]',10,'[]','[]',740,750,'[{23217,13705}]',6,0,'[{1,9,68}, {2,9,7}, {lv,61002,750}]',1,0,'[]'),(6303,5,'暗裔猎手',1,'[]',10,'[]','[]',741,761,'[{17300,8300}]',5,0,'[{1,9,68}, {2,9,7}, {lv,61002,700}]',1,0,'[]'),(1011,7,'自摸怪',15,'[{0,58},{1,39},{2,20},{3,10}]',122,'[{0,3,2},{1,3,2},{2,3,2},{3,3,2}]','[{{4,1},70,70}]',750,800,'[{15938,5442}]',9977651,2,'[{0,15,58},{1,15,39},{2,15,20},{3,15,10},{exp,166000,0}]',0,889400,'[17]'),(6303,6,'冰雪女王',1,'[]',10,'[]','[]',751,771,'[{21500,11400}]',5,0,'[{1,9,68}, {2,9,7}, {lv,61002,700}]',1,0,'[]'),(1255,1,'质量检测员',1,'[]',10,'[]','[]',770,800,'[{19155,18011}]',7,0,'[{1,9,68}, {2,9,7}, {lv,61002,800}]',1,0,'[]'),(6303,1,'巴哈姆特',1,'[]',10,'[]','[]',771,791,'[{10200,8500}]',5,0,'[{1,9,68}, {2,9,7}, {lv,61002,700}]',1,0,'[]'),(1256,1,'月神',1,'[]',10,'[]','[]',775,800,'[{19789,10574}]',5,0,'[{1,9,68}, {2,9,7}, {lv,61002,800}]',1,0,'[]'),(6303,2,'远古花后',1,'[]',10,'[]','[]',791,811,'[{3700,9800}]',5,0,'[{1,9,68}, {2,9,7}, {lv,61002,700}]',1,0,'[]'),(1011,8,'逃忍',15,'[{0,59},{1,40},{2,20},{3,10}]',125,'[{0,3,2},{1,3,2},{2,3,2},{3,3,2}]','[{{4,1},70,70}]',800,1000,'[{18254,7247}]',10721547,3,'[{0,10,51},{1,10,34},{2,10,17},{3,10,9},{exp,193640,0}]',0,977520,'[17]'),(6301,1,'巴哈姆特',1,'[]',10,'[]','[]',801,821,'[{10200,8500}]',5,0,'[{1,9,68}, {2,9,7}, {lv,61002,700}]',1,0,'[]'),(6301,2,'机械泰坦',1,'[]',10,'[]','[]',821,841,'[{3700,9800}]',5,0,'[{1,9,68}, {2,9,7}, {lv,61002,700}]',1,0,'[]'),(1256,2,'美杜莎',1,'[]',10,'[]','[]',825,850,'[{23217,13705}]',6,0,'[{1,9,68}, {2,9,7}, {lv,61002,850}]',1,0,'[]'),(1255,4,'暗月之神',1,'[]',10,'[]','[]',840,850,'[{12852,23975}]',8,0,'[{1,9,68}, {2,9,7}, {lv,61002,850}]',1,0,'[]'),(6301,3,'暗裔猎手',1,'[]',10,'[]','[]',841,861,'[{12800,3700}]',5,0,'[{1,9,68}, {2,9,7}, {lv,61002,700}]',1,0,'[]'),(6301,4,'远古花后',1,'[]',10,'[]','[]',851,871,'[{10900,14900}]',5,0,'[{1,9,68}, {2,9,7}, {lv,61002,700}]',1,0,'[]'),(6301,5,'冰霜巨人',1,'[]',10,'[]','[]',871,891,'[{17300,8300}]',5,0,'[{1,9,68}, {2,9,7}, {lv,61002,700}]',1,0,'[]'),(1256,4,'死神',1,'[]',10,'[]','[]',885,900,'[{19155,18011}]',7,0,'[{1,9,68}, {2,9,7}, {lv,61002,900}]',1,0,'[]'),(6301,6,'嫉妒',1,'[]',10,'[]','[]',891,911,'[{21500,11400}]',5,0,'[{1,9,68}, {2,9,7}, {lv,61002,700}]',1,0,'[]'),(6304,1,'海龙王',1,'[]',10,'[]','[]',901,921,'[{10200,8500}]',5,0,'[{1,9,68}, {2,9,7}, {lv,61002,700}]',1,0,'[]'),(6304,2,'冰霜巨龙',1,'[]',10,'[]','[]',921,941,'[{3700,9800}]',5,0,'[{1,9,68}, {2,9,7}, {lv,61002,700}]',1,0,'[]'),(1256,7,'暴食',1,'[]',10,'[]','[]',935,950,'[{12852,23975}]',8,0,'[{1,9,68}, {2,9,7}, {lv,61002,950}]',1,0,'[]'),(6304,3,'寒冰女神',1,'[]',10,'[]','[]',941,961,'[{12800,3700}]',5,0,'[{1,9,68}, {2,9,7}, {lv,61002,700}]',1,0,'[]'),(6304,4,'巴哈姆特',1,'[]',10,'[]','[]',951,971,'[{10900,14900}]',5,0,'[{1,9,68}, {2,9,7}, {lv,61002,700}]',1,0,'[]'),(6304,5,'远古花后',1,'[]',10,'[]','[]',971,991,'[{17300,8300}]',5,0,'[{1,9,68}, {2,9,7}, {lv,61002,700}]',1,0,'[]'),(6304,6,'暮光月神',1,'[]',10,'[]','[]',991,1000,'[{21500,11400}]',5,0,'[{1,9,68}, {2,9,7}, {lv,61002,700}]',1,0,'[]');
/*!40000 ALTER TABLE `base_onhook` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_onhook_keyvalues`
--

DROP TABLE IF EXISTS `base_onhook_keyvalues`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_onhook_keyvalues` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '常量Id',
  `value` varchar(256) NOT NULL COMMENT '常量值',
  `about` varchar(512) NOT NULL COMMENT '常量描述@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='离线挂机常量配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_onhook_keyvalues`
--

LOCK TABLES `base_onhook_keyvalues` WRITE;
/*!40000 ALTER TABLE `base_onhook_keyvalues` DISABLE KEYS */;
INSERT INTO `base_onhook_keyvalues` VALUES (1,'20*3600','最大离线挂机时间(s)'),(2,'60','至少需要多少剩余时间才开启挂机(s)'),(3,'600','至少需要进入离线挂机多久后才有收益(s)'),(4,'2','一个挂机点假人最大显示数量'),(5,'10*3600','玩家创角时赠送的挂机时间(s)'),(6,'10','服务器重启后每分钟处理多少个挂机玩家'),(7,'125','离线挂机开启等级');
/*!40000 ALTER TABLE `base_onhook_keyvalues` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_onhook_reward`
--

DROP TABLE IF EXISTS `base_onhook_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_onhook_reward` (
  `scene_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '挂机场景',
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '挂机点id',
  `green_weight_list` varchar(2048) NOT NULL DEFAULT '[]' COMMENT '绿装奖励列表',
  `bule_weight_list` varchar(2048) NOT NULL DEFAULT '[]' COMMENT '蓝装奖励列表',
  `purple_weight_list` varchar(2048) NOT NULL DEFAULT '[]' COMMENT '紫装奖励列表',
  `orange_weight_list` varchar(2048) NOT NULL DEFAULT '[]' COMMENT '橙装奖励列表',
  `goods_weight_list` varchar(2048) NOT NULL DEFAULT '[]' COMMENT '道具奖励列表',
  `turn_goods_weight_list` varchar(2048) NOT NULL DEFAULT '[]' COMMENT '转职道具奖励列表',
  `custom_goods_weight_list` varchar(2048) NOT NULL DEFAULT '[]' COMMENT '定制活动道具奖励列表',
  PRIMARY KEY (`scene_id`,`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='离线挂机奖励配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_onhook_reward`
--

LOCK TABLES `base_onhook_reward` WRITE;
/*!40000 ALTER TABLE `base_onhook_reward` DISABLE KEYS */;
INSERT INTO `base_onhook_reward` VALUES (1000,1,'[{10,{0,1001010100,1}},{10,{0,1001020100,1}},{0,{0,1001030100,1}},{10,{0,1001040100,1}},{10,{0,1002010100,1}},{10,{0,1002020100,1}},{0,{0,1002030100,1}},{10,{0,1002040100,1}},{3,{0,1003000100,1}},{10,{0,1004010100,1}},{10,{0,1004020100,1}},{0,{0,1004030100,1}},{10,{0,1004040100,1}},{0,{0,1005000100,1}},{10,{0,1006010100,1}},{10,{0,1006020100,1}},{0,{0,1006030100,1}},{10,{0,1006040100,1}},{10,{0,1007010100,1}},{10,{0,1007020100,1}},{0,{0,1007030100,1}},{10,{0,1007040100,1}},{10,{0,1008010100,1}},{10,{0,1008020100,1}},{0,{0,1008030100,1}},{10,{0,1008040100,1}},{0,{0,1009000100,1}},{10,{0,1010010100,1}},{10,{0,1010020100,1}},{0,{0,1010030100,1}},{10,{0,1010040100,1}}]','[{10,{0,1001010110,1}},{10,{0,1001020110,1}},{0,{0,1001030110,1}},{10,{0,1001040110,1}},{10,{0,1002010110,1}},{10,{0,1002020110,1}},{0,{0,1002030110,1}},{10,{0,1002040110,1}},{3,{0,1003000110,1}},{10,{0,1004010110,1}},{10,{0,1004020110,1}},{0,{0,1004030110,1}},{10,{0,1004040110,1}},{0,{0,1005000110,1}},{10,{0,1006010110,1}},{10,{0,1006020110,1}},{0,{0,1006030110,1}},{10,{0,1006040110,1}},{10,{0,1007010110,1}},{10,{0,1007020110,1}},{0,{0,1007030110,1}},{10,{0,1007040110,1}},{10,{0,1008010110,1}},{10,{0,1008020110,1}},{0,{0,1008030110,1}},{10,{0,1008040110,1}},{0,{0,1009000110,1}},{10,{0,1010010110,1}},{10,{0,1010020110,1}},{0,{0,1010030110,1}},{10,{0,1010040110,1}}]','[{10,{0,1001010120,1}},{10,{0,1001020120,1}},{0,{0,1001030120,1}},{10,{0,1001040120,1}},{10,{0,1002010120,1}},{10,{0,1002020120,1}},{0,{0,1002030120,1}},{10,{0,1002040120,1}},{3,{0,1003000120,1}},{10,{0,1004010120,1}},{10,{0,1004020120,1}},{0,{0,1004030120,1}},{10,{0,1004040120,1}},{0,{0,1005000120,1}},{10,{0,1006010120,1}},{10,{0,1006020120,1}},{0,{0,1006030120,1}},{10,{0,1006040120,1}},{10,{0,1007010120,1}},{10,{0,1007020120,1}},{0,{0,1007030120,1}},{10,{0,1007040120,1}},{10,{0,1008010120,1}},{10,{0,1008020120,1}},{0,{0,1008030120,1}},{10,{0,1008040120,1}},{0,{0,1009000120,1}},{10,{0,1010010120,1}},{10,{0,1010020120,1}},{0,{0,1010030120,1}},{10,{0,1010040120,1}}]','[{10,{0,1001010131,1}},{10,{0,1001020131,1}},{0,{0,1001030131,1}},{10,{0,1001040131,1}},{10,{0,1002010131,1}},{10,{0,1002020131,1}},{0,{0,1002030131,1}},{10,{0,1002040131,1}},{3,{0,1003000131,1}},{10,{0,1004010131,1}},{10,{0,1004020131,1}},{0,{0,1004030131,1}},{10,{0,1004040131,1}},{0,{0,1005000131,1}},{10,{0,1006010131,1}},{10,{0,1006020131,1}},{0,{0,1006030131,1}},{10,{0,1006040131,1}},{10,{0,1007010131,1}},{10,{0,1007020131,1}},{0,{0,1007030131,1}},{10,{0,1007040131,1}},{10,{0,1008010131,1}},{10,{0,1008020131,1}},{0,{0,1008030131,1}},{10,{0,1008040131,1}},{0,{0,1009000131,1}},{10,{0,1010010131,1}},{10,{0,1010020131,1}},{0,{0,1010030131,1}},{10,{0,1010040131,1}}]','[{224,{0,38130001,1}},{75,{0,11020001,1}},{19,{0,38030006,1}},{19,{0,38030007,1}},{144,{0,38130001,1}},{48,{0,11020001,1}},{288,{0,38040102,1}},{29,{0,38100001,1}},{96,{0,38190001,1}}]','[]','[]'),(1000,2,'[{10,{0,1001010100,1}},{10,{0,1001020100,1}},{0,{0,1001030100,1}},{10,{0,1001040100,1}},{10,{0,1002010100,1}},{10,{0,1002020100,1}},{0,{0,1002030100,1}},{10,{0,1002040100,1}},{3,{0,1003000100,1}},{10,{0,1004010100,1}},{10,{0,1004020100,1}},{0,{0,1004030100,1}},{10,{0,1004040100,1}},{0,{0,1005000100,1}},{10,{0,1006010100,1}},{10,{0,1006020100,1}},{0,{0,1006030100,1}},{10,{0,1006040100,1}},{10,{0,1007010100,1}},{10,{0,1007020100,1}},{0,{0,1007030100,1}},{10,{0,1007040100,1}},{10,{0,1008010100,1}},{10,{0,1008020100,1}},{0,{0,1008030100,1}},{10,{0,1008040100,1}},{0,{0,1009000100,1}},{10,{0,1010010100,1}},{10,{0,1010020100,1}},{0,{0,1010030100,1}},{10,{0,1010040100,1}}]','[{10,{0,1001010110,1}},{10,{0,1001020110,1}},{0,{0,1001030110,1}},{10,{0,1001040110,1}},{10,{0,1002010110,1}},{10,{0,1002020110,1}},{0,{0,1002030110,1}},{10,{0,1002040110,1}},{3,{0,1003000110,1}},{10,{0,1004010110,1}},{10,{0,1004020110,1}},{0,{0,1004030110,1}},{10,{0,1004040110,1}},{0,{0,1005000110,1}},{10,{0,1006010110,1}},{10,{0,1006020110,1}},{0,{0,1006030110,1}},{10,{0,1006040110,1}},{10,{0,1007010110,1}},{10,{0,1007020110,1}},{0,{0,1007030110,1}},{10,{0,1007040110,1}},{10,{0,1008010110,1}},{10,{0,1008020110,1}},{0,{0,1008030110,1}},{10,{0,1008040110,1}},{0,{0,1009000110,1}},{10,{0,1010010110,1}},{10,{0,1010020110,1}},{0,{0,1010030110,1}},{10,{0,1010040110,1}}]','[{10,{0,1001010120,1}},{10,{0,1001020120,1}},{0,{0,1001030120,1}},{10,{0,1001040120,1}},{10,{0,1002010120,1}},{10,{0,1002020120,1}},{0,{0,1002030120,1}},{10,{0,1002040120,1}},{3,{0,1003000120,1}},{10,{0,1004010120,1}},{10,{0,1004020120,1}},{0,{0,1004030120,1}},{10,{0,1004040120,1}},{0,{0,1005000120,1}},{10,{0,1006010120,1}},{10,{0,1006020120,1}},{0,{0,1006030120,1}},{10,{0,1006040120,1}},{10,{0,1007010120,1}},{10,{0,1007020120,1}},{0,{0,1007030120,1}},{10,{0,1007040120,1}},{10,{0,1008010120,1}},{10,{0,1008020120,1}},{0,{0,1008030120,1}},{10,{0,1008040120,1}},{0,{0,1009000120,1}},{10,{0,1010010120,1}},{10,{0,1010020120,1}},{0,{0,1010030120,1}},{10,{0,1010040120,1}}]','[{10,{0,1001010131,1}},{10,{0,1001020131,1}},{0,{0,1001030131,1}},{10,{0,1001040131,1}},{10,{0,1002010131,1}},{10,{0,1002020131,1}},{0,{0,1002030131,1}},{10,{0,1002040131,1}},{3,{0,1003000131,1}},{10,{0,1004010131,1}},{10,{0,1004020131,1}},{0,{0,1004030131,1}},{10,{0,1004040131,1}},{0,{0,1005000131,1}},{10,{0,1006010131,1}},{10,{0,1006020131,1}},{0,{0,1006030131,1}},{10,{0,1006040131,1}},{10,{0,1007010131,1}},{10,{0,1007020131,1}},{0,{0,1007030131,1}},{10,{0,1007040131,1}},{10,{0,1008010131,1}},{10,{0,1008020131,1}},{0,{0,1008030131,1}},{10,{0,1008040131,1}},{0,{0,1009000131,1}},{10,{0,1010010131,1}},{10,{0,1010020131,1}},{0,{0,1010030131,1}},{10,{0,1010040131,1}}]','[{224,{0,38130001,1}},{75,{0,11020001,1}},{19,{0,38030006,1}},{19,{0,38030007,1}},{144,{0,38130001,1}},{48,{0,11020001,1}},{288,{0,38040102,1}},{29,{0,38100001,1}},{96,{0,38190001,1}}]','[]','[]'),(1000,3,'[{10,{0,1001010100,1}},{10,{0,1001020100,1}},{0,{0,1001030100,1}},{10,{0,1001040100,1}},{10,{0,1002010100,1}},{10,{0,1002020100,1}},{0,{0,1002030100,1}},{10,{0,1002040100,1}},{3,{0,1003000100,1}},{10,{0,1004010100,1}},{10,{0,1004020100,1}},{0,{0,1004030100,1}},{10,{0,1004040100,1}},{0,{0,1005000100,1}},{10,{0,1006010100,1}},{10,{0,1006020100,1}},{0,{0,1006030100,1}},{10,{0,1006040100,1}},{10,{0,1007010100,1}},{10,{0,1007020100,1}},{0,{0,1007030100,1}},{10,{0,1007040100,1}},{10,{0,1008010100,1}},{10,{0,1008020100,1}},{0,{0,1008030100,1}},{10,{0,1008040100,1}},{0,{0,1009000100,1}},{10,{0,1010010100,1}},{10,{0,1010020100,1}},{0,{0,1010030100,1}},{10,{0,1010040100,1}}]','[{10,{0,1001010110,1}},{10,{0,1001020110,1}},{0,{0,1001030110,1}},{10,{0,1001040110,1}},{10,{0,1002010110,1}},{10,{0,1002020110,1}},{0,{0,1002030110,1}},{10,{0,1002040110,1}},{3,{0,1003000110,1}},{10,{0,1004010110,1}},{10,{0,1004020110,1}},{0,{0,1004030110,1}},{10,{0,1004040110,1}},{0,{0,1005000110,1}},{10,{0,1006010110,1}},{10,{0,1006020110,1}},{0,{0,1006030110,1}},{10,{0,1006040110,1}},{10,{0,1007010110,1}},{10,{0,1007020110,1}},{0,{0,1007030110,1}},{10,{0,1007040110,1}},{10,{0,1008010110,1}},{10,{0,1008020110,1}},{0,{0,1008030110,1}},{10,{0,1008040110,1}},{0,{0,1009000110,1}},{10,{0,1010010110,1}},{10,{0,1010020110,1}},{0,{0,1010030110,1}},{10,{0,1010040110,1}}]','[{10,{0,1001010120,1}},{10,{0,1001020120,1}},{0,{0,1001030120,1}},{10,{0,1001040120,1}},{10,{0,1002010120,1}},{10,{0,1002020120,1}},{0,{0,1002030120,1}},{10,{0,1002040120,1}},{3,{0,1003000120,1}},{10,{0,1004010120,1}},{10,{0,1004020120,1}},{0,{0,1004030120,1}},{10,{0,1004040120,1}},{0,{0,1005000120,1}},{10,{0,1006010120,1}},{10,{0,1006020120,1}},{0,{0,1006030120,1}},{10,{0,1006040120,1}},{10,{0,1007010120,1}},{10,{0,1007020120,1}},{0,{0,1007030120,1}},{10,{0,1007040120,1}},{10,{0,1008010120,1}},{10,{0,1008020120,1}},{0,{0,1008030120,1}},{10,{0,1008040120,1}},{0,{0,1009000120,1}},{10,{0,1010010120,1}},{10,{0,1010020120,1}},{0,{0,1010030120,1}},{10,{0,1010040120,1}}]','[{10,{0,1001010131,1}},{10,{0,1001020131,1}},{0,{0,1001030131,1}},{10,{0,1001040131,1}},{10,{0,1002010131,1}},{10,{0,1002020131,1}},{0,{0,1002030131,1}},{10,{0,1002040131,1}},{3,{0,1003000131,1}},{10,{0,1004010131,1}},{10,{0,1004020131,1}},{0,{0,1004030131,1}},{10,{0,1004040131,1}},{0,{0,1005000131,1}},{10,{0,1006010131,1}},{10,{0,1006020131,1}},{0,{0,1006030131,1}},{10,{0,1006040131,1}},{10,{0,1007010131,1}},{10,{0,1007020131,1}},{0,{0,1007030131,1}},{10,{0,1007040131,1}},{10,{0,1008010131,1}},{10,{0,1008020131,1}},{0,{0,1008030131,1}},{10,{0,1008040131,1}},{0,{0,1009000131,1}},{10,{0,1010010131,1}},{10,{0,1010020131,1}},{0,{0,1010030131,1}},{10,{0,1010040131,1}}]','[{224,{0,38130001,1}},{75,{0,11020001,1}},{19,{0,38030006,1}},{19,{0,38030007,1}},{144,{0,38130001,1}},{48,{0,11020001,1}},{288,{0,38040102,1}},{29,{0,38100001,1}},{96,{0,38190001,1}}]','[]','[]'),(1000,4,'[{10,{0,1001010100,1}},{10,{0,1001020100,1}},{0,{0,1001030100,1}},{10,{0,1001040100,1}},{10,{0,1002010100,1}},{10,{0,1002020100,1}},{0,{0,1002030100,1}},{10,{0,1002040100,1}},{3,{0,1003000100,1}},{10,{0,1004010100,1}},{10,{0,1004020100,1}},{0,{0,1004030100,1}},{10,{0,1004040100,1}},{0,{0,1005000100,1}},{10,{0,1006010100,1}},{10,{0,1006020100,1}},{0,{0,1006030100,1}},{10,{0,1006040100,1}},{10,{0,1007010100,1}},{10,{0,1007020100,1}},{0,{0,1007030100,1}},{10,{0,1007040100,1}},{10,{0,1008010100,1}},{10,{0,1008020100,1}},{0,{0,1008030100,1}},{10,{0,1008040100,1}},{0,{0,1009000100,1}},{10,{0,1010010100,1}},{10,{0,1010020100,1}},{0,{0,1010030100,1}},{10,{0,1010040100,1}}]','[{10,{0,1001010110,1}},{10,{0,1001020110,1}},{0,{0,1001030110,1}},{10,{0,1001040110,1}},{10,{0,1002010110,1}},{10,{0,1002020110,1}},{0,{0,1002030110,1}},{10,{0,1002040110,1}},{3,{0,1003000110,1}},{10,{0,1004010110,1}},{10,{0,1004020110,1}},{0,{0,1004030110,1}},{10,{0,1004040110,1}},{0,{0,1005000110,1}},{10,{0,1006010110,1}},{10,{0,1006020110,1}},{0,{0,1006030110,1}},{10,{0,1006040110,1}},{10,{0,1007010110,1}},{10,{0,1007020110,1}},{0,{0,1007030110,1}},{10,{0,1007040110,1}},{10,{0,1008010110,1}},{10,{0,1008020110,1}},{0,{0,1008030110,1}},{10,{0,1008040110,1}},{0,{0,1009000110,1}},{10,{0,1010010110,1}},{10,{0,1010020110,1}},{0,{0,1010030110,1}},{10,{0,1010040110,1}}]','[{10,{0,1001010120,1}},{10,{0,1001020120,1}},{0,{0,1001030120,1}},{10,{0,1001040120,1}},{10,{0,1002010120,1}},{10,{0,1002020120,1}},{0,{0,1002030120,1}},{10,{0,1002040120,1}},{3,{0,1003000120,1}},{10,{0,1004010120,1}},{10,{0,1004020120,1}},{0,{0,1004030120,1}},{10,{0,1004040120,1}},{0,{0,1005000120,1}},{10,{0,1006010120,1}},{10,{0,1006020120,1}},{0,{0,1006030120,1}},{10,{0,1006040120,1}},{10,{0,1007010120,1}},{10,{0,1007020120,1}},{0,{0,1007030120,1}},{10,{0,1007040120,1}},{10,{0,1008010120,1}},{10,{0,1008020120,1}},{0,{0,1008030120,1}},{10,{0,1008040120,1}},{0,{0,1009000120,1}},{10,{0,1010010120,1}},{10,{0,1010020120,1}},{0,{0,1010030120,1}},{10,{0,1010040120,1}}]','[{10,{0,1001010131,1}},{10,{0,1001020131,1}},{0,{0,1001030131,1}},{10,{0,1001040131,1}},{10,{0,1002010131,1}},{10,{0,1002020131,1}},{0,{0,1002030131,1}},{10,{0,1002040131,1}},{3,{0,1003000131,1}},{10,{0,1004010131,1}},{10,{0,1004020131,1}},{0,{0,1004030131,1}},{10,{0,1004040131,1}},{0,{0,1005000131,1}},{10,{0,1006010131,1}},{10,{0,1006020131,1}},{0,{0,1006030131,1}},{10,{0,1006040131,1}},{10,{0,1007010131,1}},{10,{0,1007020131,1}},{0,{0,1007030131,1}},{10,{0,1007040131,1}},{10,{0,1008010131,1}},{10,{0,1008020131,1}},{0,{0,1008030131,1}},{10,{0,1008040131,1}},{0,{0,1009000131,1}},{10,{0,1010010131,1}},{10,{0,1010020131,1}},{0,{0,1010030131,1}},{10,{0,1010040131,1}}]','[{224,{0,38130001,1}},{75,{0,11020001,1}},{19,{0,38030006,1}},{19,{0,38030007,1}},{144,{0,38130001,1}},{48,{0,11020001,1}},{288,{0,38040102,1}},{29,{0,38100001,1}},{96,{0,38190001,1}}]','[]','[]'),(1000,5,'[{10,{0,1001010100,1}},{10,{0,1001020100,1}},{0,{0,1001030100,1}},{10,{0,1001040100,1}},{10,{0,1002010100,1}},{10,{0,1002020100,1}},{0,{0,1002030100,1}},{10,{0,1002040100,1}},{3,{0,1003000100,1}},{10,{0,1004010100,1}},{10,{0,1004020100,1}},{0,{0,1004030100,1}},{10,{0,1004040100,1}},{0,{0,1005000100,1}},{10,{0,1006010100,1}},{10,{0,1006020100,1}},{0,{0,1006030100,1}},{10,{0,1006040100,1}},{10,{0,1007010100,1}},{10,{0,1007020100,1}},{0,{0,1007030100,1}},{10,{0,1007040100,1}},{10,{0,1008010100,1}},{10,{0,1008020100,1}},{0,{0,1008030100,1}},{10,{0,1008040100,1}},{0,{0,1009000100,1}},{10,{0,1010010100,1}},{10,{0,1010020100,1}},{0,{0,1010030100,1}},{10,{0,1010040100,1}}]','[{10,{0,1001010110,1}},{10,{0,1001020110,1}},{0,{0,1001030110,1}},{10,{0,1001040110,1}},{10,{0,1002010110,1}},{10,{0,1002020110,1}},{0,{0,1002030110,1}},{10,{0,1002040110,1}},{3,{0,1003000110,1}},{10,{0,1004010110,1}},{10,{0,1004020110,1}},{0,{0,1004030110,1}},{10,{0,1004040110,1}},{0,{0,1005000110,1}},{10,{0,1006010110,1}},{10,{0,1006020110,1}},{0,{0,1006030110,1}},{10,{0,1006040110,1}},{10,{0,1007010110,1}},{10,{0,1007020110,1}},{0,{0,1007030110,1}},{10,{0,1007040110,1}},{10,{0,1008010110,1}},{10,{0,1008020110,1}},{0,{0,1008030110,1}},{10,{0,1008040110,1}},{0,{0,1009000110,1}},{10,{0,1010010110,1}},{10,{0,1010020110,1}},{0,{0,1010030110,1}},{10,{0,1010040110,1}}]','[{10,{0,1001010120,1}},{10,{0,1001020120,1}},{0,{0,1001030120,1}},{10,{0,1001040120,1}},{10,{0,1002010120,1}},{10,{0,1002020120,1}},{0,{0,1002030120,1}},{10,{0,1002040120,1}},{3,{0,1003000120,1}},{10,{0,1004010120,1}},{10,{0,1004020120,1}},{0,{0,1004030120,1}},{10,{0,1004040120,1}},{0,{0,1005000120,1}},{10,{0,1006010120,1}},{10,{0,1006020120,1}},{0,{0,1006030120,1}},{10,{0,1006040120,1}},{10,{0,1007010120,1}},{10,{0,1007020120,1}},{0,{0,1007030120,1}},{10,{0,1007040120,1}},{10,{0,1008010120,1}},{10,{0,1008020120,1}},{0,{0,1008030120,1}},{10,{0,1008040120,1}},{0,{0,1009000120,1}},{10,{0,1010010120,1}},{10,{0,1010020120,1}},{0,{0,1010030120,1}},{10,{0,1010040120,1}}]','[{10,{0,1001010131,1}},{10,{0,1001020131,1}},{0,{0,1001030131,1}},{10,{0,1001040131,1}},{10,{0,1002010131,1}},{10,{0,1002020131,1}},{0,{0,1002030131,1}},{10,{0,1002040131,1}},{3,{0,1003000131,1}},{10,{0,1004010131,1}},{10,{0,1004020131,1}},{0,{0,1004030131,1}},{10,{0,1004040131,1}},{0,{0,1005000131,1}},{10,{0,1006010131,1}},{10,{0,1006020131,1}},{0,{0,1006030131,1}},{10,{0,1006040131,1}},{10,{0,1007010131,1}},{10,{0,1007020131,1}},{0,{0,1007030131,1}},{10,{0,1007040131,1}},{10,{0,1008010131,1}},{10,{0,1008020131,1}},{0,{0,1008030131,1}},{10,{0,1008040131,1}},{0,{0,1009000131,1}},{10,{0,1010010131,1}},{10,{0,1010020131,1}},{0,{0,1010030131,1}},{10,{0,1010040131,1}}]','[{224,{0,38130001,1}},{75,{0,11020001,1}},{19,{0,38030006,1}},{19,{0,38030007,1}},{144,{0,38130001,1}},{48,{0,11020001,1}},{288,{0,38040102,1}},{29,{0,38100001,1}},{96,{0,38190001,1}}]','[]','[]'),(1000,6,'[{10,{0,1001010100,1}},{10,{0,1001020100,1}},{0,{0,1001030100,1}},{10,{0,1001040100,1}},{10,{0,1002010100,1}},{10,{0,1002020100,1}},{0,{0,1002030100,1}},{10,{0,1002040100,1}},{3,{0,1003000100,1}},{10,{0,1004010100,1}},{10,{0,1004020100,1}},{0,{0,1004030100,1}},{10,{0,1004040100,1}},{0,{0,1005000100,1}},{10,{0,1006010100,1}},{10,{0,1006020100,1}},{0,{0,1006030100,1}},{10,{0,1006040100,1}},{10,{0,1007010100,1}},{10,{0,1007020100,1}},{0,{0,1007030100,1}},{10,{0,1007040100,1}},{10,{0,1008010100,1}},{10,{0,1008020100,1}},{0,{0,1008030100,1}},{10,{0,1008040100,1}},{0,{0,1009000100,1}},{10,{0,1010010100,1}},{10,{0,1010020100,1}},{0,{0,1010030100,1}},{10,{0,1010040100,1}}]','[{10,{0,1001010110,1}},{10,{0,1001020110,1}},{0,{0,1001030110,1}},{10,{0,1001040110,1}},{10,{0,1002010110,1}},{10,{0,1002020110,1}},{0,{0,1002030110,1}},{10,{0,1002040110,1}},{3,{0,1003000110,1}},{10,{0,1004010110,1}},{10,{0,1004020110,1}},{0,{0,1004030110,1}},{10,{0,1004040110,1}},{0,{0,1005000110,1}},{10,{0,1006010110,1}},{10,{0,1006020110,1}},{0,{0,1006030110,1}},{10,{0,1006040110,1}},{10,{0,1007010110,1}},{10,{0,1007020110,1}},{0,{0,1007030110,1}},{10,{0,1007040110,1}},{10,{0,1008010110,1}},{10,{0,1008020110,1}},{0,{0,1008030110,1}},{10,{0,1008040110,1}},{0,{0,1009000110,1}},{10,{0,1010010110,1}},{10,{0,1010020110,1}},{0,{0,1010030110,1}},{10,{0,1010040110,1}}]','[{10,{0,1001010120,1}},{10,{0,1001020120,1}},{0,{0,1001030120,1}},{10,{0,1001040120,1}},{10,{0,1002010120,1}},{10,{0,1002020120,1}},{0,{0,1002030120,1}},{10,{0,1002040120,1}},{3,{0,1003000120,1}},{10,{0,1004010120,1}},{10,{0,1004020120,1}},{0,{0,1004030120,1}},{10,{0,1004040120,1}},{0,{0,1005000120,1}},{10,{0,1006010120,1}},{10,{0,1006020120,1}},{0,{0,1006030120,1}},{10,{0,1006040120,1}},{10,{0,1007010120,1}},{10,{0,1007020120,1}},{0,{0,1007030120,1}},{10,{0,1007040120,1}},{10,{0,1008010120,1}},{10,{0,1008020120,1}},{0,{0,1008030120,1}},{10,{0,1008040120,1}},{0,{0,1009000120,1}},{10,{0,1010010120,1}},{10,{0,1010020120,1}},{0,{0,1010030120,1}},{10,{0,1010040120,1}}]','[{10,{0,1001010131,1}},{10,{0,1001020131,1}},{0,{0,1001030131,1}},{10,{0,1001040131,1}},{10,{0,1002010131,1}},{10,{0,1002020131,1}},{0,{0,1002030131,1}},{10,{0,1002040131,1}},{3,{0,1003000131,1}},{10,{0,1004010131,1}},{10,{0,1004020131,1}},{0,{0,1004030131,1}},{10,{0,1004040131,1}},{0,{0,1005000131,1}},{10,{0,1006010131,1}},{10,{0,1006020131,1}},{0,{0,1006030131,1}},{10,{0,1006040131,1}},{10,{0,1007010131,1}},{10,{0,1007020131,1}},{0,{0,1007030131,1}},{10,{0,1007040131,1}},{10,{0,1008010131,1}},{10,{0,1008020131,1}},{0,{0,1008030131,1}},{10,{0,1008040131,1}},{0,{0,1009000131,1}},{10,{0,1010010131,1}},{10,{0,1010020131,1}},{0,{0,1010030131,1}},{10,{0,1010040131,1}}]','[{224,{0,38130001,1}},{75,{0,11020001,1}},{19,{0,38030006,1}},{19,{0,38030007,1}},{144,{0,38130001,1}},{48,{0,11020001,1}},{288,{0,38040102,1}},{29,{0,38100001,1}},{96,{0,38190001,1}}]','[]','[]'),(1002,1,'[{10,{0,1001010100,1}},{10,{0,1001020100,1}},{0,{0,1001030100,1}},{10,{0,1001040100,1}},{10,{0,1002010100,1}},{10,{0,1002020100,1}},{0,{0,1002030100,1}},{10,{0,1002040100,1}},{3,{0,1003000100,1}},{10,{0,1004010100,1}},{10,{0,1004020100,1}},{0,{0,1004030100,1}},{10,{0,1004040100,1}},{0,{0,1005000100,1}},{10,{0,1006010100,1}},{10,{0,1006020100,1}},{0,{0,1006030100,1}},{10,{0,1006040100,1}},{10,{0,1007010100,1}},{10,{0,1007020100,1}},{0,{0,1007030100,1}},{10,{0,1007040100,1}},{10,{0,1008010100,1}},{10,{0,1008020100,1}},{0,{0,1008030100,1}},{10,{0,1008040100,1}},{0,{0,1009000100,1}},{10,{0,1010010100,1}},{10,{0,1010020100,1}},{0,{0,1010030100,1}},{10,{0,1010040100,1}}]','[{10,{0,1001010110,1}},{10,{0,1001020110,1}},{0,{0,1001030110,1}},{10,{0,1001040110,1}},{10,{0,1002010110,1}},{10,{0,1002020110,1}},{0,{0,1002030110,1}},{10,{0,1002040110,1}},{3,{0,1003000110,1}},{10,{0,1004010110,1}},{10,{0,1004020110,1}},{0,{0,1004030110,1}},{10,{0,1004040110,1}},{0,{0,1005000110,1}},{10,{0,1006010110,1}},{10,{0,1006020110,1}},{0,{0,1006030110,1}},{10,{0,1006040110,1}},{10,{0,1007010110,1}},{10,{0,1007020110,1}},{0,{0,1007030110,1}},{10,{0,1007040110,1}},{10,{0,1008010110,1}},{10,{0,1008020110,1}},{0,{0,1008030110,1}},{10,{0,1008040110,1}},{0,{0,1009000110,1}},{10,{0,1010010110,1}},{10,{0,1010020110,1}},{0,{0,1010030110,1}},{10,{0,1010040110,1}}]','[{10,{0,1001010120,1}},{10,{0,1001020120,1}},{0,{0,1001030120,1}},{10,{0,1001040120,1}},{10,{0,1002010120,1}},{10,{0,1002020120,1}},{0,{0,1002030120,1}},{10,{0,1002040120,1}},{3,{0,1003000120,1}},{10,{0,1004010120,1}},{10,{0,1004020120,1}},{0,{0,1004030120,1}},{10,{0,1004040120,1}},{0,{0,1005000120,1}},{10,{0,1006010120,1}},{10,{0,1006020120,1}},{0,{0,1006030120,1}},{10,{0,1006040120,1}},{10,{0,1007010120,1}},{10,{0,1007020120,1}},{0,{0,1007030120,1}},{10,{0,1007040120,1}},{10,{0,1008010120,1}},{10,{0,1008020120,1}},{0,{0,1008030120,1}},{10,{0,1008040120,1}},{0,{0,1009000120,1}},{10,{0,1010010120,1}},{10,{0,1010020120,1}},{0,{0,1010030120,1}},{10,{0,1010040120,1}}]','[{10,{0,1001010131,1}},{10,{0,1001020131,1}},{0,{0,1001030131,1}},{10,{0,1001040131,1}},{10,{0,1002010131,1}},{10,{0,1002020131,1}},{0,{0,1002030131,1}},{10,{0,1002040131,1}},{3,{0,1003000131,1}},{10,{0,1004010131,1}},{10,{0,1004020131,1}},{0,{0,1004030131,1}},{10,{0,1004040131,1}},{0,{0,1005000131,1}},{10,{0,1006010131,1}},{10,{0,1006020131,1}},{0,{0,1006030131,1}},{10,{0,1006040131,1}},{10,{0,1007010131,1}},{10,{0,1007020131,1}},{0,{0,1007030131,1}},{10,{0,1007040131,1}},{10,{0,1008010131,1}},{10,{0,1008020131,1}},{0,{0,1008030131,1}},{10,{0,1008040131,1}},{0,{0,1009000131,1}},{10,{0,1010010131,1}},{10,{0,1010020131,1}},{0,{0,1010030131,1}},{10,{0,1010040131,1}}]','[{224,{0,38130001,1}},{75,{0,11020001,1}},{19,{0,38030006,1}},{19,{0,38030007,1}},{144,{0,38130001,1}},{48,{0,11020001,1}},{288,{0,38040102,1}},{29,{0,38100001,1}},{96,{0,38190001,1}}]','[]','[]'),(1002,2,'[{10,{0,1001010100,1}},{10,{0,1001020100,1}},{0,{0,1001030100,1}},{10,{0,1001040100,1}},{10,{0,1002010100,1}},{10,{0,1002020100,1}},{0,{0,1002030100,1}},{10,{0,1002040100,1}},{3,{0,1003000100,1}},{10,{0,1004010100,1}},{10,{0,1004020100,1}},{0,{0,1004030100,1}},{10,{0,1004040100,1}},{0,{0,1005000100,1}},{10,{0,1006010100,1}},{10,{0,1006020100,1}},{0,{0,1006030100,1}},{10,{0,1006040100,1}},{10,{0,1007010100,1}},{10,{0,1007020100,1}},{0,{0,1007030100,1}},{10,{0,1007040100,1}},{10,{0,1008010100,1}},{10,{0,1008020100,1}},{0,{0,1008030100,1}},{10,{0,1008040100,1}},{0,{0,1009000100,1}},{10,{0,1010010100,1}},{10,{0,1010020100,1}},{0,{0,1010030100,1}},{10,{0,1010040100,1}}]','[{10,{0,1001010110,1}},{10,{0,1001020110,1}},{0,{0,1001030110,1}},{10,{0,1001040110,1}},{10,{0,1002010110,1}},{10,{0,1002020110,1}},{0,{0,1002030110,1}},{10,{0,1002040110,1}},{3,{0,1003000110,1}},{10,{0,1004010110,1}},{10,{0,1004020110,1}},{0,{0,1004030110,1}},{10,{0,1004040110,1}},{0,{0,1005000110,1}},{10,{0,1006010110,1}},{10,{0,1006020110,1}},{0,{0,1006030110,1}},{10,{0,1006040110,1}},{10,{0,1007010110,1}},{10,{0,1007020110,1}},{0,{0,1007030110,1}},{10,{0,1007040110,1}},{10,{0,1008010110,1}},{10,{0,1008020110,1}},{0,{0,1008030110,1}},{10,{0,1008040110,1}},{0,{0,1009000110,1}},{10,{0,1010010110,1}},{10,{0,1010020110,1}},{0,{0,1010030110,1}},{10,{0,1010040110,1}}]','[{10,{0,1001010120,1}},{10,{0,1001020120,1}},{0,{0,1001030120,1}},{10,{0,1001040120,1}},{10,{0,1002010120,1}},{10,{0,1002020120,1}},{0,{0,1002030120,1}},{10,{0,1002040120,1}},{3,{0,1003000120,1}},{10,{0,1004010120,1}},{10,{0,1004020120,1}},{0,{0,1004030120,1}},{10,{0,1004040120,1}},{0,{0,1005000120,1}},{10,{0,1006010120,1}},{10,{0,1006020120,1}},{0,{0,1006030120,1}},{10,{0,1006040120,1}},{10,{0,1007010120,1}},{10,{0,1007020120,1}},{0,{0,1007030120,1}},{10,{0,1007040120,1}},{10,{0,1008010120,1}},{10,{0,1008020120,1}},{0,{0,1008030120,1}},{10,{0,1008040120,1}},{0,{0,1009000120,1}},{10,{0,1010010120,1}},{10,{0,1010020120,1}},{0,{0,1010030120,1}},{10,{0,1010040120,1}}]','[{10,{0,1001010131,1}},{10,{0,1001020131,1}},{0,{0,1001030131,1}},{10,{0,1001040131,1}},{10,{0,1002010131,1}},{10,{0,1002020131,1}},{0,{0,1002030131,1}},{10,{0,1002040131,1}},{3,{0,1003000131,1}},{10,{0,1004010131,1}},{10,{0,1004020131,1}},{0,{0,1004030131,1}},{10,{0,1004040131,1}},{0,{0,1005000131,1}},{10,{0,1006010131,1}},{10,{0,1006020131,1}},{0,{0,1006030131,1}},{10,{0,1006040131,1}},{10,{0,1007010131,1}},{10,{0,1007020131,1}},{0,{0,1007030131,1}},{10,{0,1007040131,1}},{10,{0,1008010131,1}},{10,{0,1008020131,1}},{0,{0,1008030131,1}},{10,{0,1008040131,1}},{0,{0,1009000131,1}},{10,{0,1010010131,1}},{10,{0,1010020131,1}},{0,{0,1010030131,1}},{10,{0,1010040131,1}}]','[{224,{0,38130001,1}},{75,{0,11020001,1}},{19,{0,38030006,1}},{19,{0,38030007,1}},{144,{0,38130001,1}},{48,{0,11020001,1}},{288,{0,38040102,1}},{29,{0,38100001,1}},{96,{0,38190001,1}}]','[]','[]'),(1002,3,'[{10,{0,1001010100,1}},{10,{0,1001020100,1}},{0,{0,1001030100,1}},{10,{0,1001040100,1}},{10,{0,1002010100,1}},{10,{0,1002020100,1}},{0,{0,1002030100,1}},{10,{0,1002040100,1}},{3,{0,1003000100,1}},{10,{0,1004010100,1}},{10,{0,1004020100,1}},{0,{0,1004030100,1}},{10,{0,1004040100,1}},{0,{0,1005000100,1}},{10,{0,1006010100,1}},{10,{0,1006020100,1}},{0,{0,1006030100,1}},{10,{0,1006040100,1}},{10,{0,1007010100,1}},{10,{0,1007020100,1}},{0,{0,1007030100,1}},{10,{0,1007040100,1}},{10,{0,1008010100,1}},{10,{0,1008020100,1}},{0,{0,1008030100,1}},{10,{0,1008040100,1}},{0,{0,1009000100,1}},{10,{0,1010010100,1}},{10,{0,1010020100,1}},{0,{0,1010030100,1}},{10,{0,1010040100,1}}]','[{10,{0,1001010110,1}},{10,{0,1001020110,1}},{0,{0,1001030110,1}},{10,{0,1001040110,1}},{10,{0,1002010110,1}},{10,{0,1002020110,1}},{0,{0,1002030110,1}},{10,{0,1002040110,1}},{3,{0,1003000110,1}},{10,{0,1004010110,1}},{10,{0,1004020110,1}},{0,{0,1004030110,1}},{10,{0,1004040110,1}},{0,{0,1005000110,1}},{10,{0,1006010110,1}},{10,{0,1006020110,1}},{0,{0,1006030110,1}},{10,{0,1006040110,1}},{10,{0,1007010110,1}},{10,{0,1007020110,1}},{0,{0,1007030110,1}},{10,{0,1007040110,1}},{10,{0,1008010110,1}},{10,{0,1008020110,1}},{0,{0,1008030110,1}},{10,{0,1008040110,1}},{0,{0,1009000110,1}},{10,{0,1010010110,1}},{10,{0,1010020110,1}},{0,{0,1010030110,1}},{10,{0,1010040110,1}}]','[{10,{0,1001010120,1}},{10,{0,1001020120,1}},{0,{0,1001030120,1}},{10,{0,1001040120,1}},{10,{0,1002010120,1}},{10,{0,1002020120,1}},{0,{0,1002030120,1}},{10,{0,1002040120,1}},{3,{0,1003000120,1}},{10,{0,1004010120,1}},{10,{0,1004020120,1}},{0,{0,1004030120,1}},{10,{0,1004040120,1}},{0,{0,1005000120,1}},{10,{0,1006010120,1}},{10,{0,1006020120,1}},{0,{0,1006030120,1}},{10,{0,1006040120,1}},{10,{0,1007010120,1}},{10,{0,1007020120,1}},{0,{0,1007030120,1}},{10,{0,1007040120,1}},{10,{0,1008010120,1}},{10,{0,1008020120,1}},{0,{0,1008030120,1}},{10,{0,1008040120,1}},{0,{0,1009000120,1}},{10,{0,1010010120,1}},{10,{0,1010020120,1}},{0,{0,1010030120,1}},{10,{0,1010040120,1}}]','[{10,{0,1001010131,1}},{10,{0,1001020131,1}},{0,{0,1001030131,1}},{10,{0,1001040131,1}},{10,{0,1002010131,1}},{10,{0,1002020131,1}},{0,{0,1002030131,1}},{10,{0,1002040131,1}},{3,{0,1003000131,1}},{10,{0,1004010131,1}},{10,{0,1004020131,1}},{0,{0,1004030131,1}},{10,{0,1004040131,1}},{0,{0,1005000131,1}},{10,{0,1006010131,1}},{10,{0,1006020131,1}},{0,{0,1006030131,1}},{10,{0,1006040131,1}},{10,{0,1007010131,1}},{10,{0,1007020131,1}},{0,{0,1007030131,1}},{10,{0,1007040131,1}},{10,{0,1008010131,1}},{10,{0,1008020131,1}},{0,{0,1008030131,1}},{10,{0,1008040131,1}},{0,{0,1009000131,1}},{10,{0,1010010131,1}},{10,{0,1010020131,1}},{0,{0,1010030131,1}},{10,{0,1010040131,1}}]','[{224,{0,38130001,1}},{75,{0,11020001,1}},{19,{0,38030006,1}},{19,{0,38030007,1}},{144,{0,38130001,1}},{48,{0,11020001,1}},{288,{0,38040102,1}},{29,{0,38100001,1}},{96,{0,38190001,1}}]','[]','[]'),(1002,4,'[{10,{0,1001010100,1}},{10,{0,1001020100,1}},{0,{0,1001030100,1}},{10,{0,1001040100,1}},{10,{0,1002010100,1}},{10,{0,1002020100,1}},{0,{0,1002030100,1}},{10,{0,1002040100,1}},{3,{0,1003000100,1}},{10,{0,1004010100,1}},{10,{0,1004020100,1}},{0,{0,1004030100,1}},{10,{0,1004040100,1}},{0,{0,1005000100,1}},{10,{0,1006010100,1}},{10,{0,1006020100,1}},{0,{0,1006030100,1}},{10,{0,1006040100,1}},{10,{0,1007010100,1}},{10,{0,1007020100,1}},{0,{0,1007030100,1}},{10,{0,1007040100,1}},{10,{0,1008010100,1}},{10,{0,1008020100,1}},{0,{0,1008030100,1}},{10,{0,1008040100,1}},{0,{0,1009000100,1}},{10,{0,1010010100,1}},{10,{0,1010020100,1}},{0,{0,1010030100,1}},{10,{0,1010040100,1}}]','[{10,{0,1001010110,1}},{10,{0,1001020110,1}},{0,{0,1001030110,1}},{10,{0,1001040110,1}},{10,{0,1002010110,1}},{10,{0,1002020110,1}},{0,{0,1002030110,1}},{10,{0,1002040110,1}},{3,{0,1003000110,1}},{10,{0,1004010110,1}},{10,{0,1004020110,1}},{0,{0,1004030110,1}},{10,{0,1004040110,1}},{0,{0,1005000110,1}},{10,{0,1006010110,1}},{10,{0,1006020110,1}},{0,{0,1006030110,1}},{10,{0,1006040110,1}},{10,{0,1007010110,1}},{10,{0,1007020110,1}},{0,{0,1007030110,1}},{10,{0,1007040110,1}},{10,{0,1008010110,1}},{10,{0,1008020110,1}},{0,{0,1008030110,1}},{10,{0,1008040110,1}},{0,{0,1009000110,1}},{10,{0,1010010110,1}},{10,{0,1010020110,1}},{0,{0,1010030110,1}},{10,{0,1010040110,1}}]','[{10,{0,1001010120,1}},{10,{0,1001020120,1}},{0,{0,1001030120,1}},{10,{0,1001040120,1}},{10,{0,1002010120,1}},{10,{0,1002020120,1}},{0,{0,1002030120,1}},{10,{0,1002040120,1}},{3,{0,1003000120,1}},{10,{0,1004010120,1}},{10,{0,1004020120,1}},{0,{0,1004030120,1}},{10,{0,1004040120,1}},{0,{0,1005000120,1}},{10,{0,1006010120,1}},{10,{0,1006020120,1}},{0,{0,1006030120,1}},{10,{0,1006040120,1}},{10,{0,1007010120,1}},{10,{0,1007020120,1}},{0,{0,1007030120,1}},{10,{0,1007040120,1}},{10,{0,1008010120,1}},{10,{0,1008020120,1}},{0,{0,1008030120,1}},{10,{0,1008040120,1}},{0,{0,1009000120,1}},{10,{0,1010010120,1}},{10,{0,1010020120,1}},{0,{0,1010030120,1}},{10,{0,1010040120,1}}]','[{10,{0,1001010131,1}},{10,{0,1001020131,1}},{0,{0,1001030131,1}},{10,{0,1001040131,1}},{10,{0,1002010131,1}},{10,{0,1002020131,1}},{0,{0,1002030131,1}},{10,{0,1002040131,1}},{3,{0,1003000131,1}},{10,{0,1004010131,1}},{10,{0,1004020131,1}},{0,{0,1004030131,1}},{10,{0,1004040131,1}},{0,{0,1005000131,1}},{10,{0,1006010131,1}},{10,{0,1006020131,1}},{0,{0,1006030131,1}},{10,{0,1006040131,1}},{10,{0,1007010131,1}},{10,{0,1007020131,1}},{0,{0,1007030131,1}},{10,{0,1007040131,1}},{10,{0,1008010131,1}},{10,{0,1008020131,1}},{0,{0,1008030131,1}},{10,{0,1008040131,1}},{0,{0,1009000131,1}},{10,{0,1010010131,1}},{10,{0,1010020131,1}},{0,{0,1010030131,1}},{10,{0,1010040131,1}}]','[{224,{0,38130001,1}},{75,{0,11020001,1}},{19,{0,38030006,1}},{19,{0,38030007,1}},{144,{0,38130001,1}},{48,{0,11020001,1}},{288,{0,38040102,1}},{29,{0,38100001,1}},{96,{0,38190001,1}}]','[]','[]'),(1002,5,'[{10,{0,1001010100,1}},{10,{0,1001020100,1}},{0,{0,1001030100,1}},{10,{0,1001040100,1}},{10,{0,1002010100,1}},{10,{0,1002020100,1}},{0,{0,1002030100,1}},{10,{0,1002040100,1}},{3,{0,1003000100,1}},{10,{0,1004010100,1}},{10,{0,1004020100,1}},{0,{0,1004030100,1}},{10,{0,1004040100,1}},{0,{0,1005000100,1}},{10,{0,1006010100,1}},{10,{0,1006020100,1}},{0,{0,1006030100,1}},{10,{0,1006040100,1}},{10,{0,1007010100,1}},{10,{0,1007020100,1}},{0,{0,1007030100,1}},{10,{0,1007040100,1}},{10,{0,1008010100,1}},{10,{0,1008020100,1}},{0,{0,1008030100,1}},{10,{0,1008040100,1}},{0,{0,1009000100,1}},{10,{0,1010010100,1}},{10,{0,1010020100,1}},{0,{0,1010030100,1}},{10,{0,1010040100,1}}]','[{10,{0,1001010110,1}},{10,{0,1001020110,1}},{0,{0,1001030110,1}},{10,{0,1001040110,1}},{10,{0,1002010110,1}},{10,{0,1002020110,1}},{0,{0,1002030110,1}},{10,{0,1002040110,1}},{3,{0,1003000110,1}},{10,{0,1004010110,1}},{10,{0,1004020110,1}},{0,{0,1004030110,1}},{10,{0,1004040110,1}},{0,{0,1005000110,1}},{10,{0,1006010110,1}},{10,{0,1006020110,1}},{0,{0,1006030110,1}},{10,{0,1006040110,1}},{10,{0,1007010110,1}},{10,{0,1007020110,1}},{0,{0,1007030110,1}},{10,{0,1007040110,1}},{10,{0,1008010110,1}},{10,{0,1008020110,1}},{0,{0,1008030110,1}},{10,{0,1008040110,1}},{0,{0,1009000110,1}},{10,{0,1010010110,1}},{10,{0,1010020110,1}},{0,{0,1010030110,1}},{10,{0,1010040110,1}}]','[{10,{0,1001010120,1}},{10,{0,1001020120,1}},{0,{0,1001030120,1}},{10,{0,1001040120,1}},{10,{0,1002010120,1}},{10,{0,1002020120,1}},{0,{0,1002030120,1}},{10,{0,1002040120,1}},{3,{0,1003000120,1}},{10,{0,1004010120,1}},{10,{0,1004020120,1}},{0,{0,1004030120,1}},{10,{0,1004040120,1}},{0,{0,1005000120,1}},{10,{0,1006010120,1}},{10,{0,1006020120,1}},{0,{0,1006030120,1}},{10,{0,1006040120,1}},{10,{0,1007010120,1}},{10,{0,1007020120,1}},{0,{0,1007030120,1}},{10,{0,1007040120,1}},{10,{0,1008010120,1}},{10,{0,1008020120,1}},{0,{0,1008030120,1}},{10,{0,1008040120,1}},{0,{0,1009000120,1}},{10,{0,1010010120,1}},{10,{0,1010020120,1}},{0,{0,1010030120,1}},{10,{0,1010040120,1}}]','[{10,{0,1001010131,1}},{10,{0,1001020131,1}},{0,{0,1001030131,1}},{10,{0,1001040131,1}},{10,{0,1002010131,1}},{10,{0,1002020131,1}},{0,{0,1002030131,1}},{10,{0,1002040131,1}},{3,{0,1003000131,1}},{10,{0,1004010131,1}},{10,{0,1004020131,1}},{0,{0,1004030131,1}},{10,{0,1004040131,1}},{0,{0,1005000131,1}},{10,{0,1006010131,1}},{10,{0,1006020131,1}},{0,{0,1006030131,1}},{10,{0,1006040131,1}},{10,{0,1007010131,1}},{10,{0,1007020131,1}},{0,{0,1007030131,1}},{10,{0,1007040131,1}},{10,{0,1008010131,1}},{10,{0,1008020131,1}},{0,{0,1008030131,1}},{10,{0,1008040131,1}},{0,{0,1009000131,1}},{10,{0,1010010131,1}},{10,{0,1010020131,1}},{0,{0,1010030131,1}},{10,{0,1010040131,1}}]','[{224,{0,38130001,1}},{75,{0,11020001,1}},{19,{0,38030006,1}},{19,{0,38030007,1}},{144,{0,38130001,1}},{48,{0,11020001,1}},{288,{0,38040102,1}},{29,{0,38100001,1}},{96,{0,38190001,1}}]','[]','[]'),(1002,6,'[{10,{0,1001010100,1}},{10,{0,1001020100,1}},{0,{0,1001030100,1}},{10,{0,1001040100,1}},{10,{0,1002010100,1}},{10,{0,1002020100,1}},{0,{0,1002030100,1}},{10,{0,1002040100,1}},{3,{0,1003000100,1}},{10,{0,1004010100,1}},{10,{0,1004020100,1}},{0,{0,1004030100,1}},{10,{0,1004040100,1}},{0,{0,1005000100,1}},{10,{0,1006010100,1}},{10,{0,1006020100,1}},{0,{0,1006030100,1}},{10,{0,1006040100,1}},{10,{0,1007010100,1}},{10,{0,1007020100,1}},{0,{0,1007030100,1}},{10,{0,1007040100,1}},{10,{0,1008010100,1}},{10,{0,1008020100,1}},{0,{0,1008030100,1}},{10,{0,1008040100,1}},{0,{0,1009000100,1}},{10,{0,1010010100,1}},{10,{0,1010020100,1}},{0,{0,1010030100,1}},{10,{0,1010040100,1}}]','[{10,{0,1001010110,1}},{10,{0,1001020110,1}},{0,{0,1001030110,1}},{10,{0,1001040110,1}},{10,{0,1002010110,1}},{10,{0,1002020110,1}},{0,{0,1002030110,1}},{10,{0,1002040110,1}},{3,{0,1003000110,1}},{10,{0,1004010110,1}},{10,{0,1004020110,1}},{0,{0,1004030110,1}},{10,{0,1004040110,1}},{0,{0,1005000110,1}},{10,{0,1006010110,1}},{10,{0,1006020110,1}},{0,{0,1006030110,1}},{10,{0,1006040110,1}},{10,{0,1007010110,1}},{10,{0,1007020110,1}},{0,{0,1007030110,1}},{10,{0,1007040110,1}},{10,{0,1008010110,1}},{10,{0,1008020110,1}},{0,{0,1008030110,1}},{10,{0,1008040110,1}},{0,{0,1009000110,1}},{10,{0,1010010110,1}},{10,{0,1010020110,1}},{0,{0,1010030110,1}},{10,{0,1010040110,1}}]','[{10,{0,1001010120,1}},{10,{0,1001020120,1}},{0,{0,1001030120,1}},{10,{0,1001040120,1}},{10,{0,1002010120,1}},{10,{0,1002020120,1}},{0,{0,1002030120,1}},{10,{0,1002040120,1}},{3,{0,1003000120,1}},{10,{0,1004010120,1}},{10,{0,1004020120,1}},{0,{0,1004030120,1}},{10,{0,1004040120,1}},{0,{0,1005000120,1}},{10,{0,1006010120,1}},{10,{0,1006020120,1}},{0,{0,1006030120,1}},{10,{0,1006040120,1}},{10,{0,1007010120,1}},{10,{0,1007020120,1}},{0,{0,1007030120,1}},{10,{0,1007040120,1}},{10,{0,1008010120,1}},{10,{0,1008020120,1}},{0,{0,1008030120,1}},{10,{0,1008040120,1}},{0,{0,1009000120,1}},{10,{0,1010010120,1}},{10,{0,1010020120,1}},{0,{0,1010030120,1}},{10,{0,1010040120,1}}]','[{10,{0,1001010131,1}},{10,{0,1001020131,1}},{0,{0,1001030131,1}},{10,{0,1001040131,1}},{10,{0,1002010131,1}},{10,{0,1002020131,1}},{0,{0,1002030131,1}},{10,{0,1002040131,1}},{3,{0,1003000131,1}},{10,{0,1004010131,1}},{10,{0,1004020131,1}},{0,{0,1004030131,1}},{10,{0,1004040131,1}},{0,{0,1005000131,1}},{10,{0,1006010131,1}},{10,{0,1006020131,1}},{0,{0,1006030131,1}},{10,{0,1006040131,1}},{10,{0,1007010131,1}},{10,{0,1007020131,1}},{0,{0,1007030131,1}},{10,{0,1007040131,1}},{10,{0,1008010131,1}},{10,{0,1008020131,1}},{0,{0,1008030131,1}},{10,{0,1008040131,1}},{0,{0,1009000131,1}},{10,{0,1010010131,1}},{10,{0,1010020131,1}},{0,{0,1010030131,1}},{10,{0,1010040131,1}}]','[{224,{0,38130001,1}},{75,{0,11020001,1}},{19,{0,38030006,1}},{19,{0,38030007,1}},{144,{0,38130001,1}},{48,{0,11020001,1}},{288,{0,38040102,1}},{29,{0,38100001,1}},{96,{0,38190001,1}}]','[]','[]'),(1002,7,'[{10,{0,1001010200,1}},{10,{0,1001020200,1}},{0,{0,1001030200,1}},{10,{0,1001040200,1}},{10,{0,1002010200,1}},{10,{0,1002020200,1}},{0,{0,1002030200,1}},{10,{0,1002040200,1}},{3,{0,1003000200,1}},{10,{0,1004010200,1}},{10,{0,1004020200,1}},{0,{0,1004030200,1}},{10,{0,1004040200,1}},{0,{0,1005000200,1}},{10,{0,1006010200,1}},{10,{0,1006020200,1}},{0,{0,1006030200,1}},{10,{0,1006040200,1}},{10,{0,1007010200,1}},{10,{0,1007020200,1}},{0,{0,1007030200,1}},{10,{0,1007040200,1}},{10,{0,1008010200,1}},{10,{0,1008020200,1}},{0,{0,1008030200,1}},{10,{0,1008040200,1}},{0,{0,1009000200,1}},{10,{0,1010010200,1}},{10,{0,1010020200,1}},{0,{0,1010030200,1}},{10,{0,1010040200,1}}]','[{10,{0,1001010210,1}},{10,{0,1001020210,1}},{0,{0,1001030210,1}},{10,{0,1001040210,1}},{10,{0,1002010210,1}},{10,{0,1002020210,1}},{0,{0,1002030210,1}},{10,{0,1002040210,1}},{3,{0,1003000210,1}},{10,{0,1004010210,1}},{10,{0,1004020210,1}},{0,{0,1004030210,1}},{10,{0,1004040210,1}},{0,{0,1005000210,1}},{10,{0,1006010210,1}},{10,{0,1006020210,1}},{0,{0,1006030210,1}},{10,{0,1006040210,1}},{10,{0,1007010210,1}},{10,{0,1007020210,1}},{0,{0,1007030210,1}},{10,{0,1007040210,1}},{10,{0,1008010210,1}},{10,{0,1008020210,1}},{0,{0,1008030210,1}},{10,{0,1008040210,1}},{0,{0,1009000210,1}},{10,{0,1010010210,1}},{10,{0,1010020210,1}},{0,{0,1010030210,1}},{10,{0,1010040210,1}}]','[{10,{0,1001010220,1}},{10,{0,1001020220,1}},{0,{0,1001030220,1}},{10,{0,1001040220,1}},{10,{0,1002010220,1}},{10,{0,1002020220,1}},{0,{0,1002030220,1}},{10,{0,1002040220,1}},{3,{0,1003000220,1}},{10,{0,1004010220,1}},{10,{0,1004020220,1}},{0,{0,1004030220,1}},{10,{0,1004040220,1}},{0,{0,1005000220,1}},{10,{0,1006010220,1}},{10,{0,1006020220,1}},{0,{0,1006030220,1}},{10,{0,1006040220,1}},{10,{0,1007010220,1}},{10,{0,1007020220,1}},{0,{0,1007030220,1}},{10,{0,1007040220,1}},{10,{0,1008010220,1}},{10,{0,1008020220,1}},{0,{0,1008030220,1}},{10,{0,1008040220,1}},{0,{0,1009000220,1}},{10,{0,1010010220,1}},{10,{0,1010020220,1}},{0,{0,1010030220,1}},{10,{0,1010040220,1}}]','[{10,{0,1001010231,1}},{10,{0,1001020231,1}},{0,{0,1001030231,1}},{10,{0,1001040231,1}},{10,{0,1002010231,1}},{10,{0,1002020231,1}},{0,{0,1002030231,1}},{10,{0,1002040231,1}},{3,{0,1003000231,1}},{10,{0,1004010231,1}},{10,{0,1004020231,1}},{0,{0,1004030231,1}},{10,{0,1004040231,1}},{0,{0,1005000231,1}},{10,{0,1006010231,1}},{10,{0,1006020231,1}},{0,{0,1006030231,1}},{10,{0,1006040231,1}},{10,{0,1007010231,1}},{10,{0,1007020231,1}},{0,{0,1007030231,1}},{10,{0,1007040231,1}},{10,{0,1008010231,1}},{10,{0,1008020231,1}},{0,{0,1008030231,1}},{10,{0,1008040231,1}},{0,{0,1009000231,1}},{10,{0,1010010231,1}},{10,{0,1010020231,1}},{0,{0,1010030231,1}},{10,{0,1010040231,1}}]','[{224,{0,38130001,1}},{75,{0,11020001,1}},{19,{0,38030006,1}},{19,{0,38030007,1}},{144,{0,38130001,1}},{48,{0,11020001,1}},{288,{0,38040102,1}},{29,{0,38100001,1}},{96,{0,38190001,1}}]','[]','[]'),(1003,1,'[{10,{0,1001010200,1}},{10,{0,1001020200,1}},{0,{0,1001030200,1}},{10,{0,1001040200,1}},{10,{0,1002010200,1}},{10,{0,1002020200,1}},{0,{0,1002030200,1}},{10,{0,1002040200,1}},{3,{0,1003000200,1}},{10,{0,1004010200,1}},{10,{0,1004020200,1}},{0,{0,1004030200,1}},{10,{0,1004040200,1}},{0,{0,1005000200,1}},{10,{0,1006010200,1}},{10,{0,1006020200,1}},{0,{0,1006030200,1}},{10,{0,1006040200,1}},{10,{0,1007010200,1}},{10,{0,1007020200,1}},{0,{0,1007030200,1}},{10,{0,1007040200,1}},{10,{0,1008010200,1}},{10,{0,1008020200,1}},{0,{0,1008030200,1}},{10,{0,1008040200,1}},{0,{0,1009000200,1}},{10,{0,1010010200,1}},{10,{0,1010020200,1}},{0,{0,1010030200,1}},{10,{0,1010040200,1}}]','[{10,{0,1001010210,1}},{10,{0,1001020210,1}},{0,{0,1001030210,1}},{10,{0,1001040210,1}},{10,{0,1002010210,1}},{10,{0,1002020210,1}},{0,{0,1002030210,1}},{10,{0,1002040210,1}},{3,{0,1003000210,1}},{10,{0,1004010210,1}},{10,{0,1004020210,1}},{0,{0,1004030210,1}},{10,{0,1004040210,1}},{0,{0,1005000210,1}},{10,{0,1006010210,1}},{10,{0,1006020210,1}},{0,{0,1006030210,1}},{10,{0,1006040210,1}},{10,{0,1007010210,1}},{10,{0,1007020210,1}},{0,{0,1007030210,1}},{10,{0,1007040210,1}},{10,{0,1008010210,1}},{10,{0,1008020210,1}},{0,{0,1008030210,1}},{10,{0,1008040210,1}},{0,{0,1009000210,1}},{10,{0,1010010210,1}},{10,{0,1010020210,1}},{0,{0,1010030210,1}},{10,{0,1010040210,1}}]','[{10,{0,1001010220,1}},{10,{0,1001020220,1}},{0,{0,1001030220,1}},{10,{0,1001040220,1}},{10,{0,1002010220,1}},{10,{0,1002020220,1}},{0,{0,1002030220,1}},{10,{0,1002040220,1}},{3,{0,1003000220,1}},{10,{0,1004010220,1}},{10,{0,1004020220,1}},{0,{0,1004030220,1}},{10,{0,1004040220,1}},{0,{0,1005000220,1}},{10,{0,1006010220,1}},{10,{0,1006020220,1}},{0,{0,1006030220,1}},{10,{0,1006040220,1}},{10,{0,1007010220,1}},{10,{0,1007020220,1}},{0,{0,1007030220,1}},{10,{0,1007040220,1}},{10,{0,1008010220,1}},{10,{0,1008020220,1}},{0,{0,1008030220,1}},{10,{0,1008040220,1}},{0,{0,1009000220,1}},{10,{0,1010010220,1}},{10,{0,1010020220,1}},{0,{0,1010030220,1}},{10,{0,1010040220,1}}]','[{10,{0,1001010231,1}},{10,{0,1001020231,1}},{0,{0,1001030231,1}},{10,{0,1001040231,1}},{10,{0,1002010231,1}},{10,{0,1002020231,1}},{0,{0,1002030231,1}},{10,{0,1002040231,1}},{3,{0,1003000231,1}},{10,{0,1004010231,1}},{10,{0,1004020231,1}},{0,{0,1004030231,1}},{10,{0,1004040231,1}},{0,{0,1005000231,1}},{10,{0,1006010231,1}},{10,{0,1006020231,1}},{0,{0,1006030231,1}},{10,{0,1006040231,1}},{10,{0,1007010231,1}},{10,{0,1007020231,1}},{0,{0,1007030231,1}},{10,{0,1007040231,1}},{10,{0,1008010231,1}},{10,{0,1008020231,1}},{0,{0,1008030231,1}},{10,{0,1008040231,1}},{0,{0,1009000231,1}},{10,{0,1010010231,1}},{10,{0,1010020231,1}},{0,{0,1010030231,1}},{10,{0,1010040231,1}}]','[{224,{0,38130001,1}},{75,{0,11020001,1}},{19,{0,38030006,1}},{19,{0,38030007,1}},{144,{0,38130001,1}},{48,{0,11020001,1}},{288,{0,38040102,1}},{29,{0,38100001,1}},{96,{0,38190001,1}}]','[]','[]'),(1003,2,'[{10,{0,1001010200,1}},{10,{0,1001020200,1}},{0,{0,1001030200,1}},{10,{0,1001040200,1}},{10,{0,1002010200,1}},{10,{0,1002020200,1}},{0,{0,1002030200,1}},{10,{0,1002040200,1}},{3,{0,1003000200,1}},{10,{0,1004010200,1}},{10,{0,1004020200,1}},{0,{0,1004030200,1}},{10,{0,1004040200,1}},{0,{0,1005000200,1}},{10,{0,1006010200,1}},{10,{0,1006020200,1}},{0,{0,1006030200,1}},{10,{0,1006040200,1}},{10,{0,1007010200,1}},{10,{0,1007020200,1}},{0,{0,1007030200,1}},{10,{0,1007040200,1}},{10,{0,1008010200,1}},{10,{0,1008020200,1}},{0,{0,1008030200,1}},{10,{0,1008040200,1}},{0,{0,1009000200,1}},{10,{0,1010010200,1}},{10,{0,1010020200,1}},{0,{0,1010030200,1}},{10,{0,1010040200,1}}]','[{10,{0,1001010210,1}},{10,{0,1001020210,1}},{0,{0,1001030210,1}},{10,{0,1001040210,1}},{10,{0,1002010210,1}},{10,{0,1002020210,1}},{0,{0,1002030210,1}},{10,{0,1002040210,1}},{3,{0,1003000210,1}},{10,{0,1004010210,1}},{10,{0,1004020210,1}},{0,{0,1004030210,1}},{10,{0,1004040210,1}},{0,{0,1005000210,1}},{10,{0,1006010210,1}},{10,{0,1006020210,1}},{0,{0,1006030210,1}},{10,{0,1006040210,1}},{10,{0,1007010210,1}},{10,{0,1007020210,1}},{0,{0,1007030210,1}},{10,{0,1007040210,1}},{10,{0,1008010210,1}},{10,{0,1008020210,1}},{0,{0,1008030210,1}},{10,{0,1008040210,1}},{0,{0,1009000210,1}},{10,{0,1010010210,1}},{10,{0,1010020210,1}},{0,{0,1010030210,1}},{10,{0,1010040210,1}}]','[{10,{0,1001010220,1}},{10,{0,1001020220,1}},{0,{0,1001030220,1}},{10,{0,1001040220,1}},{10,{0,1002010220,1}},{10,{0,1002020220,1}},{0,{0,1002030220,1}},{10,{0,1002040220,1}},{3,{0,1003000220,1}},{10,{0,1004010220,1}},{10,{0,1004020220,1}},{0,{0,1004030220,1}},{10,{0,1004040220,1}},{0,{0,1005000220,1}},{10,{0,1006010220,1}},{10,{0,1006020220,1}},{0,{0,1006030220,1}},{10,{0,1006040220,1}},{10,{0,1007010220,1}},{10,{0,1007020220,1}},{0,{0,1007030220,1}},{10,{0,1007040220,1}},{10,{0,1008010220,1}},{10,{0,1008020220,1}},{0,{0,1008030220,1}},{10,{0,1008040220,1}},{0,{0,1009000220,1}},{10,{0,1010010220,1}},{10,{0,1010020220,1}},{0,{0,1010030220,1}},{10,{0,1010040220,1}}]','[{10,{0,1001010231,1}},{10,{0,1001020231,1}},{0,{0,1001030231,1}},{10,{0,1001040231,1}},{10,{0,1002010231,1}},{10,{0,1002020231,1}},{0,{0,1002030231,1}},{10,{0,1002040231,1}},{3,{0,1003000231,1}},{10,{0,1004010231,1}},{10,{0,1004020231,1}},{0,{0,1004030231,1}},{10,{0,1004040231,1}},{0,{0,1005000231,1}},{10,{0,1006010231,1}},{10,{0,1006020231,1}},{0,{0,1006030231,1}},{10,{0,1006040231,1}},{10,{0,1007010231,1}},{10,{0,1007020231,1}},{0,{0,1007030231,1}},{10,{0,1007040231,1}},{10,{0,1008010231,1}},{10,{0,1008020231,1}},{0,{0,1008030231,1}},{10,{0,1008040231,1}},{0,{0,1009000231,1}},{10,{0,1010010231,1}},{10,{0,1010020231,1}},{0,{0,1010030231,1}},{10,{0,1010040231,1}}]','[{224,{0,38130001,1}},{75,{0,11020001,1}},{19,{0,38030006,1}},{19,{0,38030007,1}},{144,{0,38130001,1}},{48,{0,11020001,1}},{288,{0,38040102,1}},{29,{0,38100001,1}},{96,{0,38190001,1}}]','[]','[]'),(1003,3,'[{10,{0,1001010200,1}},{10,{0,1001020200,1}},{0,{0,1001030200,1}},{10,{0,1001040200,1}},{10,{0,1002010200,1}},{10,{0,1002020200,1}},{0,{0,1002030200,1}},{10,{0,1002040200,1}},{3,{0,1003000200,1}},{10,{0,1004010200,1}},{10,{0,1004020200,1}},{0,{0,1004030200,1}},{10,{0,1004040200,1}},{0,{0,1005000200,1}},{10,{0,1006010200,1}},{10,{0,1006020200,1}},{0,{0,1006030200,1}},{10,{0,1006040200,1}},{10,{0,1007010200,1}},{10,{0,1007020200,1}},{0,{0,1007030200,1}},{10,{0,1007040200,1}},{10,{0,1008010200,1}},{10,{0,1008020200,1}},{0,{0,1008030200,1}},{10,{0,1008040200,1}},{0,{0,1009000200,1}},{10,{0,1010010200,1}},{10,{0,1010020200,1}},{0,{0,1010030200,1}},{10,{0,1010040200,1}}]','[{10,{0,1001010210,1}},{10,{0,1001020210,1}},{0,{0,1001030210,1}},{10,{0,1001040210,1}},{10,{0,1002010210,1}},{10,{0,1002020210,1}},{0,{0,1002030210,1}},{10,{0,1002040210,1}},{3,{0,1003000210,1}},{10,{0,1004010210,1}},{10,{0,1004020210,1}},{0,{0,1004030210,1}},{10,{0,1004040210,1}},{0,{0,1005000210,1}},{10,{0,1006010210,1}},{10,{0,1006020210,1}},{0,{0,1006030210,1}},{10,{0,1006040210,1}},{10,{0,1007010210,1}},{10,{0,1007020210,1}},{0,{0,1007030210,1}},{10,{0,1007040210,1}},{10,{0,1008010210,1}},{10,{0,1008020210,1}},{0,{0,1008030210,1}},{10,{0,1008040210,1}},{0,{0,1009000210,1}},{10,{0,1010010210,1}},{10,{0,1010020210,1}},{0,{0,1010030210,1}},{10,{0,1010040210,1}}]','[{10,{0,1001010220,1}},{10,{0,1001020220,1}},{0,{0,1001030220,1}},{10,{0,1001040220,1}},{10,{0,1002010220,1}},{10,{0,1002020220,1}},{0,{0,1002030220,1}},{10,{0,1002040220,1}},{3,{0,1003000220,1}},{10,{0,1004010220,1}},{10,{0,1004020220,1}},{0,{0,1004030220,1}},{10,{0,1004040220,1}},{0,{0,1005000220,1}},{10,{0,1006010220,1}},{10,{0,1006020220,1}},{0,{0,1006030220,1}},{10,{0,1006040220,1}},{10,{0,1007010220,1}},{10,{0,1007020220,1}},{0,{0,1007030220,1}},{10,{0,1007040220,1}},{10,{0,1008010220,1}},{10,{0,1008020220,1}},{0,{0,1008030220,1}},{10,{0,1008040220,1}},{0,{0,1009000220,1}},{10,{0,1010010220,1}},{10,{0,1010020220,1}},{0,{0,1010030220,1}},{10,{0,1010040220,1}}]','[{10,{0,1001010231,1}},{10,{0,1001020231,1}},{0,{0,1001030231,1}},{10,{0,1001040231,1}},{10,{0,1002010231,1}},{10,{0,1002020231,1}},{0,{0,1002030231,1}},{10,{0,1002040231,1}},{3,{0,1003000231,1}},{10,{0,1004010231,1}},{10,{0,1004020231,1}},{0,{0,1004030231,1}},{10,{0,1004040231,1}},{0,{0,1005000231,1}},{10,{0,1006010231,1}},{10,{0,1006020231,1}},{0,{0,1006030231,1}},{10,{0,1006040231,1}},{10,{0,1007010231,1}},{10,{0,1007020231,1}},{0,{0,1007030231,1}},{10,{0,1007040231,1}},{10,{0,1008010231,1}},{10,{0,1008020231,1}},{0,{0,1008030231,1}},{10,{0,1008040231,1}},{0,{0,1009000231,1}},{10,{0,1010010231,1}},{10,{0,1010020231,1}},{0,{0,1010030231,1}},{10,{0,1010040231,1}}]','[{224,{0,38130001,1}},{75,{0,11020001,1}},{19,{0,38030006,1}},{19,{0,38030007,1}},{144,{0,38130001,1}},{48,{0,11020001,1}},{288,{0,38040102,1}},{29,{0,38100001,1}},{96,{0,38190001,1}}]','[]','[]'),(1003,4,'[{10,{0,1001010200,1}},{10,{0,1001020200,1}},{0,{0,1001030200,1}},{10,{0,1001040200,1}},{10,{0,1002010200,1}},{10,{0,1002020200,1}},{0,{0,1002030200,1}},{10,{0,1002040200,1}},{3,{0,1003000200,1}},{10,{0,1004010200,1}},{10,{0,1004020200,1}},{0,{0,1004030200,1}},{10,{0,1004040200,1}},{0,{0,1005000200,1}},{10,{0,1006010200,1}},{10,{0,1006020200,1}},{0,{0,1006030200,1}},{10,{0,1006040200,1}},{10,{0,1007010200,1}},{10,{0,1007020200,1}},{0,{0,1007030200,1}},{10,{0,1007040200,1}},{10,{0,1008010200,1}},{10,{0,1008020200,1}},{0,{0,1008030200,1}},{10,{0,1008040200,1}},{0,{0,1009000200,1}},{10,{0,1010010200,1}},{10,{0,1010020200,1}},{0,{0,1010030200,1}},{10,{0,1010040200,1}}]','[{10,{0,1001010210,1}},{10,{0,1001020210,1}},{0,{0,1001030210,1}},{10,{0,1001040210,1}},{10,{0,1002010210,1}},{10,{0,1002020210,1}},{0,{0,1002030210,1}},{10,{0,1002040210,1}},{3,{0,1003000210,1}},{10,{0,1004010210,1}},{10,{0,1004020210,1}},{0,{0,1004030210,1}},{10,{0,1004040210,1}},{0,{0,1005000210,1}},{10,{0,1006010210,1}},{10,{0,1006020210,1}},{0,{0,1006030210,1}},{10,{0,1006040210,1}},{10,{0,1007010210,1}},{10,{0,1007020210,1}},{0,{0,1007030210,1}},{10,{0,1007040210,1}},{10,{0,1008010210,1}},{10,{0,1008020210,1}},{0,{0,1008030210,1}},{10,{0,1008040210,1}},{0,{0,1009000210,1}},{10,{0,1010010210,1}},{10,{0,1010020210,1}},{0,{0,1010030210,1}},{10,{0,1010040210,1}}]','[{10,{0,1001010220,1}},{10,{0,1001020220,1}},{0,{0,1001030220,1}},{10,{0,1001040220,1}},{10,{0,1002010220,1}},{10,{0,1002020220,1}},{0,{0,1002030220,1}},{10,{0,1002040220,1}},{3,{0,1003000220,1}},{10,{0,1004010220,1}},{10,{0,1004020220,1}},{0,{0,1004030220,1}},{10,{0,1004040220,1}},{0,{0,1005000220,1}},{10,{0,1006010220,1}},{10,{0,1006020220,1}},{0,{0,1006030220,1}},{10,{0,1006040220,1}},{10,{0,1007010220,1}},{10,{0,1007020220,1}},{0,{0,1007030220,1}},{10,{0,1007040220,1}},{10,{0,1008010220,1}},{10,{0,1008020220,1}},{0,{0,1008030220,1}},{10,{0,1008040220,1}},{0,{0,1009000220,1}},{10,{0,1010010220,1}},{10,{0,1010020220,1}},{0,{0,1010030220,1}},{10,{0,1010040220,1}}]','[{10,{0,1001010231,1}},{10,{0,1001020231,1}},{0,{0,1001030231,1}},{10,{0,1001040231,1}},{10,{0,1002010231,1}},{10,{0,1002020231,1}},{0,{0,1002030231,1}},{10,{0,1002040231,1}},{3,{0,1003000231,1}},{10,{0,1004010231,1}},{10,{0,1004020231,1}},{0,{0,1004030231,1}},{10,{0,1004040231,1}},{0,{0,1005000231,1}},{10,{0,1006010231,1}},{10,{0,1006020231,1}},{0,{0,1006030231,1}},{10,{0,1006040231,1}},{10,{0,1007010231,1}},{10,{0,1007020231,1}},{0,{0,1007030231,1}},{10,{0,1007040231,1}},{10,{0,1008010231,1}},{10,{0,1008020231,1}},{0,{0,1008030231,1}},{10,{0,1008040231,1}},{0,{0,1009000231,1}},{10,{0,1010010231,1}},{10,{0,1010020231,1}},{0,{0,1010030231,1}},{10,{0,1010040231,1}}]','[{224,{0,38130001,1}},{75,{0,11020001,1}},{19,{0,38030006,1}},{19,{0,38030007,1}},{144,{0,38130001,1}},{48,{0,11020001,1}},{288,{0,38040102,1}},{29,{0,38100001,1}},{96,{0,38190001,1}}]','[]','[]'),(1003,5,'[{10,{0,1001010200,1}},{10,{0,1001020200,1}},{0,{0,1001030200,1}},{10,{0,1001040200,1}},{10,{0,1002010200,1}},{10,{0,1002020200,1}},{0,{0,1002030200,1}},{10,{0,1002040200,1}},{3,{0,1003000200,1}},{10,{0,1004010200,1}},{10,{0,1004020200,1}},{0,{0,1004030200,1}},{10,{0,1004040200,1}},{0,{0,1005000200,1}},{10,{0,1006010200,1}},{10,{0,1006020200,1}},{0,{0,1006030200,1}},{10,{0,1006040200,1}},{10,{0,1007010200,1}},{10,{0,1007020200,1}},{0,{0,1007030200,1}},{10,{0,1007040200,1}},{10,{0,1008010200,1}},{10,{0,1008020200,1}},{0,{0,1008030200,1}},{10,{0,1008040200,1}},{0,{0,1009000200,1}},{10,{0,1010010200,1}},{10,{0,1010020200,1}},{0,{0,1010030200,1}},{10,{0,1010040200,1}}]','[{10,{0,1001010210,1}},{10,{0,1001020210,1}},{0,{0,1001030210,1}},{10,{0,1001040210,1}},{10,{0,1002010210,1}},{10,{0,1002020210,1}},{0,{0,1002030210,1}},{10,{0,1002040210,1}},{3,{0,1003000210,1}},{10,{0,1004010210,1}},{10,{0,1004020210,1}},{0,{0,1004030210,1}},{10,{0,1004040210,1}},{0,{0,1005000210,1}},{10,{0,1006010210,1}},{10,{0,1006020210,1}},{0,{0,1006030210,1}},{10,{0,1006040210,1}},{10,{0,1007010210,1}},{10,{0,1007020210,1}},{0,{0,1007030210,1}},{10,{0,1007040210,1}},{10,{0,1008010210,1}},{10,{0,1008020210,1}},{0,{0,1008030210,1}},{10,{0,1008040210,1}},{0,{0,1009000210,1}},{10,{0,1010010210,1}},{10,{0,1010020210,1}},{0,{0,1010030210,1}},{10,{0,1010040210,1}}]','[{10,{0,1001010220,1}},{10,{0,1001020220,1}},{0,{0,1001030220,1}},{10,{0,1001040220,1}},{10,{0,1002010220,1}},{10,{0,1002020220,1}},{0,{0,1002030220,1}},{10,{0,1002040220,1}},{3,{0,1003000220,1}},{10,{0,1004010220,1}},{10,{0,1004020220,1}},{0,{0,1004030220,1}},{10,{0,1004040220,1}},{0,{0,1005000220,1}},{10,{0,1006010220,1}},{10,{0,1006020220,1}},{0,{0,1006030220,1}},{10,{0,1006040220,1}},{10,{0,1007010220,1}},{10,{0,1007020220,1}},{0,{0,1007030220,1}},{10,{0,1007040220,1}},{10,{0,1008010220,1}},{10,{0,1008020220,1}},{0,{0,1008030220,1}},{10,{0,1008040220,1}},{0,{0,1009000220,1}},{10,{0,1010010220,1}},{10,{0,1010020220,1}},{0,{0,1010030220,1}},{10,{0,1010040220,1}}]','[{10,{0,1001010231,1}},{10,{0,1001020231,1}},{0,{0,1001030231,1}},{10,{0,1001040231,1}},{10,{0,1002010231,1}},{10,{0,1002020231,1}},{0,{0,1002030231,1}},{10,{0,1002040231,1}},{3,{0,1003000231,1}},{10,{0,1004010231,1}},{10,{0,1004020231,1}},{0,{0,1004030231,1}},{10,{0,1004040231,1}},{0,{0,1005000231,1}},{10,{0,1006010231,1}},{10,{0,1006020231,1}},{0,{0,1006030231,1}},{10,{0,1006040231,1}},{10,{0,1007010231,1}},{10,{0,1007020231,1}},{0,{0,1007030231,1}},{10,{0,1007040231,1}},{10,{0,1008010231,1}},{10,{0,1008020231,1}},{0,{0,1008030231,1}},{10,{0,1008040231,1}},{0,{0,1009000231,1}},{10,{0,1010010231,1}},{10,{0,1010020231,1}},{0,{0,1010030231,1}},{10,{0,1010040231,1}}]','[{224,{0,38130001,1}},{75,{0,11020001,1}},{19,{0,38030006,1}},{19,{0,38030007,1}},{144,{0,38130001,1}},{48,{0,11020001,1}},{288,{0,38040102,1}},{29,{0,38100001,1}},{96,{0,38190001,1}}]','[]','[]'),(1003,6,'[{10,{0,1001010200,1}},{10,{0,1001020200,1}},{0,{0,1001030200,1}},{10,{0,1001040200,1}},{10,{0,1002010200,1}},{10,{0,1002020200,1}},{0,{0,1002030200,1}},{10,{0,1002040200,1}},{3,{0,1003000200,1}},{10,{0,1004010200,1}},{10,{0,1004020200,1}},{0,{0,1004030200,1}},{10,{0,1004040200,1}},{0,{0,1005000200,1}},{10,{0,1006010200,1}},{10,{0,1006020200,1}},{0,{0,1006030200,1}},{10,{0,1006040200,1}},{10,{0,1007010200,1}},{10,{0,1007020200,1}},{0,{0,1007030200,1}},{10,{0,1007040200,1}},{10,{0,1008010200,1}},{10,{0,1008020200,1}},{0,{0,1008030200,1}},{10,{0,1008040200,1}},{0,{0,1009000200,1}},{10,{0,1010010200,1}},{10,{0,1010020200,1}},{0,{0,1010030200,1}},{10,{0,1010040200,1}}]','[{10,{0,1001010210,1}},{10,{0,1001020210,1}},{0,{0,1001030210,1}},{10,{0,1001040210,1}},{10,{0,1002010210,1}},{10,{0,1002020210,1}},{0,{0,1002030210,1}},{10,{0,1002040210,1}},{3,{0,1003000210,1}},{10,{0,1004010210,1}},{10,{0,1004020210,1}},{0,{0,1004030210,1}},{10,{0,1004040210,1}},{0,{0,1005000210,1}},{10,{0,1006010210,1}},{10,{0,1006020210,1}},{0,{0,1006030210,1}},{10,{0,1006040210,1}},{10,{0,1007010210,1}},{10,{0,1007020210,1}},{0,{0,1007030210,1}},{10,{0,1007040210,1}},{10,{0,1008010210,1}},{10,{0,1008020210,1}},{0,{0,1008030210,1}},{10,{0,1008040210,1}},{0,{0,1009000210,1}},{10,{0,1010010210,1}},{10,{0,1010020210,1}},{0,{0,1010030210,1}},{10,{0,1010040210,1}}]','[{10,{0,1001010220,1}},{10,{0,1001020220,1}},{0,{0,1001030220,1}},{10,{0,1001040220,1}},{10,{0,1002010220,1}},{10,{0,1002020220,1}},{0,{0,1002030220,1}},{10,{0,1002040220,1}},{3,{0,1003000220,1}},{10,{0,1004010220,1}},{10,{0,1004020220,1}},{0,{0,1004030220,1}},{10,{0,1004040220,1}},{0,{0,1005000220,1}},{10,{0,1006010220,1}},{10,{0,1006020220,1}},{0,{0,1006030220,1}},{10,{0,1006040220,1}},{10,{0,1007010220,1}},{10,{0,1007020220,1}},{0,{0,1007030220,1}},{10,{0,1007040220,1}},{10,{0,1008010220,1}},{10,{0,1008020220,1}},{0,{0,1008030220,1}},{10,{0,1008040220,1}},{0,{0,1009000220,1}},{10,{0,1010010220,1}},{10,{0,1010020220,1}},{0,{0,1010030220,1}},{10,{0,1010040220,1}}]','[{10,{0,1001010231,1}},{10,{0,1001020231,1}},{0,{0,1001030231,1}},{10,{0,1001040231,1}},{10,{0,1002010231,1}},{10,{0,1002020231,1}},{0,{0,1002030231,1}},{10,{0,1002040231,1}},{3,{0,1003000231,1}},{10,{0,1004010231,1}},{10,{0,1004020231,1}},{0,{0,1004030231,1}},{10,{0,1004040231,1}},{0,{0,1005000231,1}},{10,{0,1006010231,1}},{10,{0,1006020231,1}},{0,{0,1006030231,1}},{10,{0,1006040231,1}},{10,{0,1007010231,1}},{10,{0,1007020231,1}},{0,{0,1007030231,1}},{10,{0,1007040231,1}},{10,{0,1008010231,1}},{10,{0,1008020231,1}},{0,{0,1008030231,1}},{10,{0,1008040231,1}},{0,{0,1009000231,1}},{10,{0,1010010231,1}},{10,{0,1010020231,1}},{0,{0,1010030231,1}},{10,{0,1010040231,1}}]','[{224,{0,38130001,1}},{75,{0,11020001,1}},{19,{0,38030006,1}},{19,{0,38030007,1}},{144,{0,38130001,1}},{48,{0,11020001,1}},{288,{0,38040102,1}},{29,{0,38100001,1}},{96,{0,38190001,1}}]','[]','[]'),(1003,7,'[{10,{0,1001010200,1}},{10,{0,1001020200,1}},{0,{0,1001030200,1}},{10,{0,1001040200,1}},{10,{0,1002010200,1}},{10,{0,1002020200,1}},{0,{0,1002030200,1}},{10,{0,1002040200,1}},{3,{0,1003000200,1}},{10,{0,1004010200,1}},{10,{0,1004020200,1}},{0,{0,1004030200,1}},{10,{0,1004040200,1}},{0,{0,1005000200,1}},{10,{0,1006010200,1}},{10,{0,1006020200,1}},{0,{0,1006030200,1}},{10,{0,1006040200,1}},{10,{0,1007010200,1}},{10,{0,1007020200,1}},{0,{0,1007030200,1}},{10,{0,1007040200,1}},{10,{0,1008010200,1}},{10,{0,1008020200,1}},{0,{0,1008030200,1}},{10,{0,1008040200,1}},{0,{0,1009000200,1}},{10,{0,1010010200,1}},{10,{0,1010020200,1}},{0,{0,1010030200,1}},{10,{0,1010040200,1}}]','[{10,{0,1001010210,1}},{10,{0,1001020210,1}},{0,{0,1001030210,1}},{10,{0,1001040210,1}},{10,{0,1002010210,1}},{10,{0,1002020210,1}},{0,{0,1002030210,1}},{10,{0,1002040210,1}},{3,{0,1003000210,1}},{10,{0,1004010210,1}},{10,{0,1004020210,1}},{0,{0,1004030210,1}},{10,{0,1004040210,1}},{0,{0,1005000210,1}},{10,{0,1006010210,1}},{10,{0,1006020210,1}},{0,{0,1006030210,1}},{10,{0,1006040210,1}},{10,{0,1007010210,1}},{10,{0,1007020210,1}},{0,{0,1007030210,1}},{10,{0,1007040210,1}},{10,{0,1008010210,1}},{10,{0,1008020210,1}},{0,{0,1008030210,1}},{10,{0,1008040210,1}},{0,{0,1009000210,1}},{10,{0,1010010210,1}},{10,{0,1010020210,1}},{0,{0,1010030210,1}},{10,{0,1010040210,1}}]','[{10,{0,1001010220,1}},{10,{0,1001020220,1}},{0,{0,1001030220,1}},{10,{0,1001040220,1}},{10,{0,1002010220,1}},{10,{0,1002020220,1}},{0,{0,1002030220,1}},{10,{0,1002040220,1}},{3,{0,1003000220,1}},{10,{0,1004010220,1}},{10,{0,1004020220,1}},{0,{0,1004030220,1}},{10,{0,1004040220,1}},{0,{0,1005000220,1}},{10,{0,1006010220,1}},{10,{0,1006020220,1}},{0,{0,1006030220,1}},{10,{0,1006040220,1}},{10,{0,1007010220,1}},{10,{0,1007020220,1}},{0,{0,1007030220,1}},{10,{0,1007040220,1}},{10,{0,1008010220,1}},{10,{0,1008020220,1}},{0,{0,1008030220,1}},{10,{0,1008040220,1}},{0,{0,1009000220,1}},{10,{0,1010010220,1}},{10,{0,1010020220,1}},{0,{0,1010030220,1}},{10,{0,1010040220,1}}]','[{10,{0,1001010231,1}},{10,{0,1001020231,1}},{0,{0,1001030231,1}},{10,{0,1001040231,1}},{10,{0,1002010231,1}},{10,{0,1002020231,1}},{0,{0,1002030231,1}},{10,{0,1002040231,1}},{3,{0,1003000231,1}},{10,{0,1004010231,1}},{10,{0,1004020231,1}},{0,{0,1004030231,1}},{10,{0,1004040231,1}},{0,{0,1005000231,1}},{10,{0,1006010231,1}},{10,{0,1006020231,1}},{0,{0,1006030231,1}},{10,{0,1006040231,1}},{10,{0,1007010231,1}},{10,{0,1007020231,1}},{0,{0,1007030231,1}},{10,{0,1007040231,1}},{10,{0,1008010231,1}},{10,{0,1008020231,1}},{0,{0,1008030231,1}},{10,{0,1008040231,1}},{0,{0,1009000231,1}},{10,{0,1010010231,1}},{10,{0,1010020231,1}},{0,{0,1010030231,1}},{10,{0,1010040231,1}}]','[{224,{0,38130001,1}},{75,{0,11020001,1}},{19,{0,38030006,1}},{19,{0,38030007,1}},{144,{0,38130001,1}},{48,{0,11020001,1}},{288,{0,38040102,1}},{29,{0,38100001,1}},{96,{0,38190001,1}}]','[]','[]'),(1005,1,'[{10,{0,1001010200,1}},{10,{0,1001020200,1}},{0,{0,1001030200,1}},{10,{0,1001040200,1}},{10,{0,1002010200,1}},{10,{0,1002020200,1}},{0,{0,1002030200,1}},{10,{0,1002040200,1}},{3,{0,1003000200,1}},{10,{0,1004010200,1}},{10,{0,1004020200,1}},{0,{0,1004030200,1}},{10,{0,1004040200,1}},{0,{0,1005000200,1}},{10,{0,1006010200,1}},{10,{0,1006020200,1}},{0,{0,1006030200,1}},{10,{0,1006040200,1}},{10,{0,1007010200,1}},{10,{0,1007020200,1}},{0,{0,1007030200,1}},{10,{0,1007040200,1}},{10,{0,1008010200,1}},{10,{0,1008020200,1}},{0,{0,1008030200,1}},{10,{0,1008040200,1}},{0,{0,1009000200,1}},{10,{0,1010010200,1}},{10,{0,1010020200,1}},{0,{0,1010030200,1}},{10,{0,1010040200,1}}]','[{10,{0,1001010210,1}},{10,{0,1001020210,1}},{0,{0,1001030210,1}},{10,{0,1001040210,1}},{10,{0,1002010210,1}},{10,{0,1002020210,1}},{0,{0,1002030210,1}},{10,{0,1002040210,1}},{3,{0,1003000210,1}},{10,{0,1004010210,1}},{10,{0,1004020210,1}},{0,{0,1004030210,1}},{10,{0,1004040210,1}},{0,{0,1005000210,1}},{10,{0,1006010210,1}},{10,{0,1006020210,1}},{0,{0,1006030210,1}},{10,{0,1006040210,1}},{10,{0,1007010210,1}},{10,{0,1007020210,1}},{0,{0,1007030210,1}},{10,{0,1007040210,1}},{10,{0,1008010210,1}},{10,{0,1008020210,1}},{0,{0,1008030210,1}},{10,{0,1008040210,1}},{0,{0,1009000210,1}},{10,{0,1010010210,1}},{10,{0,1010020210,1}},{0,{0,1010030210,1}},{10,{0,1010040210,1}}]','[{10,{0,1001010220,1}},{10,{0,1001020220,1}},{0,{0,1001030220,1}},{10,{0,1001040220,1}},{10,{0,1002010220,1}},{10,{0,1002020220,1}},{0,{0,1002030220,1}},{10,{0,1002040220,1}},{3,{0,1003000220,1}},{10,{0,1004010220,1}},{10,{0,1004020220,1}},{0,{0,1004030220,1}},{10,{0,1004040220,1}},{0,{0,1005000220,1}},{10,{0,1006010220,1}},{10,{0,1006020220,1}},{0,{0,1006030220,1}},{10,{0,1006040220,1}},{10,{0,1007010220,1}},{10,{0,1007020220,1}},{0,{0,1007030220,1}},{10,{0,1007040220,1}},{10,{0,1008010220,1}},{10,{0,1008020220,1}},{0,{0,1008030220,1}},{10,{0,1008040220,1}},{0,{0,1009000220,1}},{10,{0,1010010220,1}},{10,{0,1010020220,1}},{0,{0,1010030220,1}},{10,{0,1010040220,1}}]','[{10,{0,1001010231,1}},{10,{0,1001020231,1}},{0,{0,1001030231,1}},{10,{0,1001040231,1}},{10,{0,1002010231,1}},{10,{0,1002020231,1}},{0,{0,1002030231,1}},{10,{0,1002040231,1}},{3,{0,1003000231,1}},{10,{0,1004010231,1}},{10,{0,1004020231,1}},{0,{0,1004030231,1}},{10,{0,1004040231,1}},{0,{0,1005000231,1}},{10,{0,1006010231,1}},{10,{0,1006020231,1}},{0,{0,1006030231,1}},{10,{0,1006040231,1}},{10,{0,1007010231,1}},{10,{0,1007020231,1}},{0,{0,1007030231,1}},{10,{0,1007040231,1}},{10,{0,1008010231,1}},{10,{0,1008020231,1}},{0,{0,1008030231,1}},{10,{0,1008040231,1}},{0,{0,1009000231,1}},{10,{0,1010010231,1}},{10,{0,1010020231,1}},{0,{0,1010030231,1}},{10,{0,1010040231,1}}]','[{224,{0,38130001,1}},{75,{0,11020001,1}},{19,{0,38030006,1}},{19,{0,38030007,1}},{144,{0,38130001,1}},{48,{0,11020001,1}},{288,{0,38040102,1}},{29,{0,38100001,1}},{96,{0,38190001,1}}]','[]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1005,2,'[{10,{0,1001010200,1}},{10,{0,1001020200,1}},{0,{0,1001030200,1}},{10,{0,1001040200,1}},{10,{0,1002010200,1}},{10,{0,1002020200,1}},{0,{0,1002030200,1}},{10,{0,1002040200,1}},{3,{0,1003000200,1}},{10,{0,1004010200,1}},{10,{0,1004020200,1}},{0,{0,1004030200,1}},{10,{0,1004040200,1}},{0,{0,1005000200,1}},{10,{0,1006010200,1}},{10,{0,1006020200,1}},{0,{0,1006030200,1}},{10,{0,1006040200,1}},{10,{0,1007010200,1}},{10,{0,1007020200,1}},{0,{0,1007030200,1}},{10,{0,1007040200,1}},{10,{0,1008010200,1}},{10,{0,1008020200,1}},{0,{0,1008030200,1}},{10,{0,1008040200,1}},{0,{0,1009000200,1}},{10,{0,1010010200,1}},{10,{0,1010020200,1}},{0,{0,1010030200,1}},{10,{0,1010040200,1}}]','[{10,{0,1001010210,1}},{10,{0,1001020210,1}},{0,{0,1001030210,1}},{10,{0,1001040210,1}},{10,{0,1002010210,1}},{10,{0,1002020210,1}},{0,{0,1002030210,1}},{10,{0,1002040210,1}},{3,{0,1003000210,1}},{10,{0,1004010210,1}},{10,{0,1004020210,1}},{0,{0,1004030210,1}},{10,{0,1004040210,1}},{0,{0,1005000210,1}},{10,{0,1006010210,1}},{10,{0,1006020210,1}},{0,{0,1006030210,1}},{10,{0,1006040210,1}},{10,{0,1007010210,1}},{10,{0,1007020210,1}},{0,{0,1007030210,1}},{10,{0,1007040210,1}},{10,{0,1008010210,1}},{10,{0,1008020210,1}},{0,{0,1008030210,1}},{10,{0,1008040210,1}},{0,{0,1009000210,1}},{10,{0,1010010210,1}},{10,{0,1010020210,1}},{0,{0,1010030210,1}},{10,{0,1010040210,1}}]','[{10,{0,1001010220,1}},{10,{0,1001020220,1}},{0,{0,1001030220,1}},{10,{0,1001040220,1}},{10,{0,1002010220,1}},{10,{0,1002020220,1}},{0,{0,1002030220,1}},{10,{0,1002040220,1}},{3,{0,1003000220,1}},{10,{0,1004010220,1}},{10,{0,1004020220,1}},{0,{0,1004030220,1}},{10,{0,1004040220,1}},{0,{0,1005000220,1}},{10,{0,1006010220,1}},{10,{0,1006020220,1}},{0,{0,1006030220,1}},{10,{0,1006040220,1}},{10,{0,1007010220,1}},{10,{0,1007020220,1}},{0,{0,1007030220,1}},{10,{0,1007040220,1}},{10,{0,1008010220,1}},{10,{0,1008020220,1}},{0,{0,1008030220,1}},{10,{0,1008040220,1}},{0,{0,1009000220,1}},{10,{0,1010010220,1}},{10,{0,1010020220,1}},{0,{0,1010030220,1}},{10,{0,1010040220,1}}]','[{10,{0,1001010231,1}},{10,{0,1001020231,1}},{0,{0,1001030231,1}},{10,{0,1001040231,1}},{10,{0,1002010231,1}},{10,{0,1002020231,1}},{0,{0,1002030231,1}},{10,{0,1002040231,1}},{3,{0,1003000231,1}},{10,{0,1004010231,1}},{10,{0,1004020231,1}},{0,{0,1004030231,1}},{10,{0,1004040231,1}},{0,{0,1005000231,1}},{10,{0,1006010231,1}},{10,{0,1006020231,1}},{0,{0,1006030231,1}},{10,{0,1006040231,1}},{10,{0,1007010231,1}},{10,{0,1007020231,1}},{0,{0,1007030231,1}},{10,{0,1007040231,1}},{10,{0,1008010231,1}},{10,{0,1008020231,1}},{0,{0,1008030231,1}},{10,{0,1008040231,1}},{0,{0,1009000231,1}},{10,{0,1010010231,1}},{10,{0,1010020231,1}},{0,{0,1010030231,1}},{10,{0,1010040231,1}}]','[{224,{0,38130001,1}},{75,{0,11020001,1}},{19,{0,38030006,1}},{19,{0,38030007,1}},{144,{0,38130001,1}},{48,{0,11020001,1}},{288,{0,38040102,1}},{29,{0,38100001,1}},{96,{0,38190001,1}}]','[]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1005,3,'[{10,{0,1001010200,1}},{10,{0,1001020200,1}},{0,{0,1001030200,1}},{10,{0,1001040200,1}},{10,{0,1002010200,1}},{10,{0,1002020200,1}},{0,{0,1002030200,1}},{10,{0,1002040200,1}},{3,{0,1003000200,1}},{10,{0,1004010200,1}},{10,{0,1004020200,1}},{0,{0,1004030200,1}},{10,{0,1004040200,1}},{0,{0,1005000200,1}},{10,{0,1006010200,1}},{10,{0,1006020200,1}},{0,{0,1006030200,1}},{10,{0,1006040200,1}},{10,{0,1007010200,1}},{10,{0,1007020200,1}},{0,{0,1007030200,1}},{10,{0,1007040200,1}},{10,{0,1008010200,1}},{10,{0,1008020200,1}},{0,{0,1008030200,1}},{10,{0,1008040200,1}},{0,{0,1009000200,1}},{10,{0,1010010200,1}},{10,{0,1010020200,1}},{0,{0,1010030200,1}},{10,{0,1010040200,1}}]','[{10,{0,1001010210,1}},{10,{0,1001020210,1}},{0,{0,1001030210,1}},{10,{0,1001040210,1}},{10,{0,1002010210,1}},{10,{0,1002020210,1}},{0,{0,1002030210,1}},{10,{0,1002040210,1}},{3,{0,1003000210,1}},{10,{0,1004010210,1}},{10,{0,1004020210,1}},{0,{0,1004030210,1}},{10,{0,1004040210,1}},{0,{0,1005000210,1}},{10,{0,1006010210,1}},{10,{0,1006020210,1}},{0,{0,1006030210,1}},{10,{0,1006040210,1}},{10,{0,1007010210,1}},{10,{0,1007020210,1}},{0,{0,1007030210,1}},{10,{0,1007040210,1}},{10,{0,1008010210,1}},{10,{0,1008020210,1}},{0,{0,1008030210,1}},{10,{0,1008040210,1}},{0,{0,1009000210,1}},{10,{0,1010010210,1}},{10,{0,1010020210,1}},{0,{0,1010030210,1}},{10,{0,1010040210,1}}]','[{10,{0,1001010220,1}},{10,{0,1001020220,1}},{0,{0,1001030220,1}},{10,{0,1001040220,1}},{10,{0,1002010220,1}},{10,{0,1002020220,1}},{0,{0,1002030220,1}},{10,{0,1002040220,1}},{3,{0,1003000220,1}},{10,{0,1004010220,1}},{10,{0,1004020220,1}},{0,{0,1004030220,1}},{10,{0,1004040220,1}},{0,{0,1005000220,1}},{10,{0,1006010220,1}},{10,{0,1006020220,1}},{0,{0,1006030220,1}},{10,{0,1006040220,1}},{10,{0,1007010220,1}},{10,{0,1007020220,1}},{0,{0,1007030220,1}},{10,{0,1007040220,1}},{10,{0,1008010220,1}},{10,{0,1008020220,1}},{0,{0,1008030220,1}},{10,{0,1008040220,1}},{0,{0,1009000220,1}},{10,{0,1010010220,1}},{10,{0,1010020220,1}},{0,{0,1010030220,1}},{10,{0,1010040220,1}}]','[{10,{0,1001010231,1}},{10,{0,1001020231,1}},{0,{0,1001030231,1}},{10,{0,1001040231,1}},{10,{0,1002010231,1}},{10,{0,1002020231,1}},{0,{0,1002030231,1}},{10,{0,1002040231,1}},{3,{0,1003000231,1}},{10,{0,1004010231,1}},{10,{0,1004020231,1}},{0,{0,1004030231,1}},{10,{0,1004040231,1}},{0,{0,1005000231,1}},{10,{0,1006010231,1}},{10,{0,1006020231,1}},{0,{0,1006030231,1}},{10,{0,1006040231,1}},{10,{0,1007010231,1}},{10,{0,1007020231,1}},{0,{0,1007030231,1}},{10,{0,1007040231,1}},{10,{0,1008010231,1}},{10,{0,1008020231,1}},{0,{0,1008030231,1}},{10,{0,1008040231,1}},{0,{0,1009000231,1}},{10,{0,1010010231,1}},{10,{0,1010020231,1}},{0,{0,1010030231,1}},{10,{0,1010040231,1}}]','[{224,{0,38130001,1}},{75,{0,11020001,1}},{19,{0,38030006,1}},{19,{0,38030007,1}},{144,{0,38130001,1}},{48,{0,11020001,1}},{288,{0,38040102,1}},{29,{0,38100001,1}},{96,{0,38190001,1}}]','[]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1005,4,'[{10,{0,1001010200,1}},{10,{0,1001020200,1}},{0,{0,1001030200,1}},{10,{0,1001040200,1}},{10,{0,1002010200,1}},{10,{0,1002020200,1}},{0,{0,1002030200,1}},{10,{0,1002040200,1}},{3,{0,1003000200,1}},{10,{0,1004010200,1}},{10,{0,1004020200,1}},{0,{0,1004030200,1}},{10,{0,1004040200,1}},{0,{0,1005000200,1}},{10,{0,1006010200,1}},{10,{0,1006020200,1}},{0,{0,1006030200,1}},{10,{0,1006040200,1}},{10,{0,1007010200,1}},{10,{0,1007020200,1}},{0,{0,1007030200,1}},{10,{0,1007040200,1}},{10,{0,1008010200,1}},{10,{0,1008020200,1}},{0,{0,1008030200,1}},{10,{0,1008040200,1}},{0,{0,1009000200,1}},{10,{0,1010010200,1}},{10,{0,1010020200,1}},{0,{0,1010030200,1}},{10,{0,1010040200,1}}]','[{10,{0,1001010210,1}},{10,{0,1001020210,1}},{0,{0,1001030210,1}},{10,{0,1001040210,1}},{10,{0,1002010210,1}},{10,{0,1002020210,1}},{0,{0,1002030210,1}},{10,{0,1002040210,1}},{3,{0,1003000210,1}},{10,{0,1004010210,1}},{10,{0,1004020210,1}},{0,{0,1004030210,1}},{10,{0,1004040210,1}},{0,{0,1005000210,1}},{10,{0,1006010210,1}},{10,{0,1006020210,1}},{0,{0,1006030210,1}},{10,{0,1006040210,1}},{10,{0,1007010210,1}},{10,{0,1007020210,1}},{0,{0,1007030210,1}},{10,{0,1007040210,1}},{10,{0,1008010210,1}},{10,{0,1008020210,1}},{0,{0,1008030210,1}},{10,{0,1008040210,1}},{0,{0,1009000210,1}},{10,{0,1010010210,1}},{10,{0,1010020210,1}},{0,{0,1010030210,1}},{10,{0,1010040210,1}}]','[{10,{0,1001010220,1}},{10,{0,1001020220,1}},{0,{0,1001030220,1}},{10,{0,1001040220,1}},{10,{0,1002010220,1}},{10,{0,1002020220,1}},{0,{0,1002030220,1}},{10,{0,1002040220,1}},{3,{0,1003000220,1}},{10,{0,1004010220,1}},{10,{0,1004020220,1}},{0,{0,1004030220,1}},{10,{0,1004040220,1}},{0,{0,1005000220,1}},{10,{0,1006010220,1}},{10,{0,1006020220,1}},{0,{0,1006030220,1}},{10,{0,1006040220,1}},{10,{0,1007010220,1}},{10,{0,1007020220,1}},{0,{0,1007030220,1}},{10,{0,1007040220,1}},{10,{0,1008010220,1}},{10,{0,1008020220,1}},{0,{0,1008030220,1}},{10,{0,1008040220,1}},{0,{0,1009000220,1}},{10,{0,1010010220,1}},{10,{0,1010020220,1}},{0,{0,1010030220,1}},{10,{0,1010040220,1}}]','[{10,{0,1001010231,1}},{10,{0,1001020231,1}},{0,{0,1001030231,1}},{10,{0,1001040231,1}},{10,{0,1002010231,1}},{10,{0,1002020231,1}},{0,{0,1002030231,1}},{10,{0,1002040231,1}},{3,{0,1003000231,1}},{10,{0,1004010231,1}},{10,{0,1004020231,1}},{0,{0,1004030231,1}},{10,{0,1004040231,1}},{0,{0,1005000231,1}},{10,{0,1006010231,1}},{10,{0,1006020231,1}},{0,{0,1006030231,1}},{10,{0,1006040231,1}},{10,{0,1007010231,1}},{10,{0,1007020231,1}},{0,{0,1007030231,1}},{10,{0,1007040231,1}},{10,{0,1008010231,1}},{10,{0,1008020231,1}},{0,{0,1008030231,1}},{10,{0,1008040231,1}},{0,{0,1009000231,1}},{10,{0,1010010231,1}},{10,{0,1010020231,1}},{0,{0,1010030231,1}},{10,{0,1010040231,1}}]','[{224,{0,38130001,1}},{75,{0,11020001,1}},{19,{0,38030006,1}},{19,{0,38030007,1}},{144,{0,38130001,1}},{48,{0,11020001,1}},{288,{0,38040102,1}},{29,{0,38100001,1}},{96,{0,38190001,1}}]','[]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1005,5,'[{10,{0,1001010200,1}},{10,{0,1001020200,1}},{0,{0,1001030200,1}},{10,{0,1001040200,1}},{10,{0,1002010200,1}},{10,{0,1002020200,1}},{0,{0,1002030200,1}},{10,{0,1002040200,1}},{3,{0,1003000200,1}},{10,{0,1004010200,1}},{10,{0,1004020200,1}},{0,{0,1004030200,1}},{10,{0,1004040200,1}},{0,{0,1005000200,1}},{10,{0,1006010200,1}},{10,{0,1006020200,1}},{0,{0,1006030200,1}},{10,{0,1006040200,1}},{10,{0,1007010200,1}},{10,{0,1007020200,1}},{0,{0,1007030200,1}},{10,{0,1007040200,1}},{10,{0,1008010200,1}},{10,{0,1008020200,1}},{0,{0,1008030200,1}},{10,{0,1008040200,1}},{0,{0,1009000200,1}},{10,{0,1010010200,1}},{10,{0,1010020200,1}},{0,{0,1010030200,1}},{10,{0,1010040200,1}}]','[{10,{0,1001010210,1}},{10,{0,1001020210,1}},{0,{0,1001030210,1}},{10,{0,1001040210,1}},{10,{0,1002010210,1}},{10,{0,1002020210,1}},{0,{0,1002030210,1}},{10,{0,1002040210,1}},{3,{0,1003000210,1}},{10,{0,1004010210,1}},{10,{0,1004020210,1}},{0,{0,1004030210,1}},{10,{0,1004040210,1}},{0,{0,1005000210,1}},{10,{0,1006010210,1}},{10,{0,1006020210,1}},{0,{0,1006030210,1}},{10,{0,1006040210,1}},{10,{0,1007010210,1}},{10,{0,1007020210,1}},{0,{0,1007030210,1}},{10,{0,1007040210,1}},{10,{0,1008010210,1}},{10,{0,1008020210,1}},{0,{0,1008030210,1}},{10,{0,1008040210,1}},{0,{0,1009000210,1}},{10,{0,1010010210,1}},{10,{0,1010020210,1}},{0,{0,1010030210,1}},{10,{0,1010040210,1}}]','[{10,{0,1001010220,1}},{10,{0,1001020220,1}},{0,{0,1001030220,1}},{10,{0,1001040220,1}},{10,{0,1002010220,1}},{10,{0,1002020220,1}},{0,{0,1002030220,1}},{10,{0,1002040220,1}},{3,{0,1003000220,1}},{10,{0,1004010220,1}},{10,{0,1004020220,1}},{0,{0,1004030220,1}},{10,{0,1004040220,1}},{0,{0,1005000220,1}},{10,{0,1006010220,1}},{10,{0,1006020220,1}},{0,{0,1006030220,1}},{10,{0,1006040220,1}},{10,{0,1007010220,1}},{10,{0,1007020220,1}},{0,{0,1007030220,1}},{10,{0,1007040220,1}},{10,{0,1008010220,1}},{10,{0,1008020220,1}},{0,{0,1008030220,1}},{10,{0,1008040220,1}},{0,{0,1009000220,1}},{10,{0,1010010220,1}},{10,{0,1010020220,1}},{0,{0,1010030220,1}},{10,{0,1010040220,1}}]','[{10,{0,1001010231,1}},{10,{0,1001020231,1}},{0,{0,1001030231,1}},{10,{0,1001040231,1}},{10,{0,1002010231,1}},{10,{0,1002020231,1}},{0,{0,1002030231,1}},{10,{0,1002040231,1}},{3,{0,1003000231,1}},{10,{0,1004010231,1}},{10,{0,1004020231,1}},{0,{0,1004030231,1}},{10,{0,1004040231,1}},{0,{0,1005000231,1}},{10,{0,1006010231,1}},{10,{0,1006020231,1}},{0,{0,1006030231,1}},{10,{0,1006040231,1}},{10,{0,1007010231,1}},{10,{0,1007020231,1}},{0,{0,1007030231,1}},{10,{0,1007040231,1}},{10,{0,1008010231,1}},{10,{0,1008020231,1}},{0,{0,1008030231,1}},{10,{0,1008040231,1}},{0,{0,1009000231,1}},{10,{0,1010010231,1}},{10,{0,1010020231,1}},{0,{0,1010030231,1}},{10,{0,1010040231,1}}]','[{224,{0,38130001,1}},{75,{0,11020001,1}},{19,{0,38030006,1}},{19,{0,38030007,1}},{144,{0,38130001,1}},{48,{0,11020001,1}},{288,{0,38040102,1}},{29,{0,38100001,1}},{96,{0,38190001,1}}]','[]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1005,6,'[{10,{0,1001010300,1}},{10,{0,1001020300,1}},{0,{0,1001030300,1}},{10,{0,1001040300,1}},{10,{0,1002010300,1}},{10,{0,1002020300,1}},{0,{0,1002030300,1}},{10,{0,1002040300,1}},{3,{0,1003000300,1}},{10,{0,1004010300,1}},{10,{0,1004020300,1}},{0,{0,1004030300,1}},{10,{0,1004040300,1}},{0,{0,1005000300,1}},{10,{0,1006010300,1}},{10,{0,1006020300,1}},{0,{0,1006030300,1}},{10,{0,1006040300,1}},{10,{0,1007010300,1}},{10,{0,1007020300,1}},{0,{0,1007030300,1}},{10,{0,1007040300,1}},{10,{0,1008010300,1}},{10,{0,1008020300,1}},{0,{0,1008030300,1}},{10,{0,1008040300,1}},{0,{0,1009000300,1}},{10,{0,1010010300,1}},{10,{0,1010020300,1}},{0,{0,1010030300,1}},{10,{0,1010040300,1}}]','[{10,{0,1001010310,1}},{10,{0,1001020310,1}},{0,{0,1001030310,1}},{10,{0,1001040310,1}},{10,{0,1002010310,1}},{10,{0,1002020310,1}},{0,{0,1002030310,1}},{10,{0,1002040310,1}},{3,{0,1003000310,1}},{10,{0,1004010310,1}},{10,{0,1004020310,1}},{0,{0,1004030310,1}},{10,{0,1004040310,1}},{0,{0,1005000310,1}},{10,{0,1006010310,1}},{10,{0,1006020310,1}},{0,{0,1006030310,1}},{10,{0,1006040310,1}},{10,{0,1007010310,1}},{10,{0,1007020310,1}},{0,{0,1007030310,1}},{10,{0,1007040310,1}},{10,{0,1008010310,1}},{10,{0,1008020310,1}},{0,{0,1008030310,1}},{10,{0,1008040310,1}},{0,{0,1009000310,1}},{10,{0,1010010310,1}},{10,{0,1010020310,1}},{0,{0,1010030310,1}},{10,{0,1010040310,1}}]','[{10,{0,1001010320,1}},{10,{0,1001020320,1}},{0,{0,1001030320,1}},{10,{0,1001040320,1}},{10,{0,1002010320,1}},{10,{0,1002020320,1}},{0,{0,1002030320,1}},{10,{0,1002040320,1}},{3,{0,1003000320,1}},{10,{0,1004010320,1}},{10,{0,1004020320,1}},{0,{0,1004030320,1}},{10,{0,1004040320,1}},{0,{0,1005000320,1}},{10,{0,1006010320,1}},{10,{0,1006020320,1}},{0,{0,1006030320,1}},{10,{0,1006040320,1}},{10,{0,1007010320,1}},{10,{0,1007020320,1}},{0,{0,1007030320,1}},{10,{0,1007040320,1}},{10,{0,1008010320,1}},{10,{0,1008020320,1}},{0,{0,1008030320,1}},{10,{0,1008040320,1}},{0,{0,1009000320,1}},{10,{0,1010010320,1}},{10,{0,1010020320,1}},{0,{0,1010030320,1}},{10,{0,1010040320,1}}]','[{10,{0,1001010331,1}},{10,{0,1001020331,1}},{0,{0,1001030331,1}},{10,{0,1001040331,1}},{10,{0,1002010331,1}},{10,{0,1002020331,1}},{0,{0,1002030331,1}},{10,{0,1002040331,1}},{3,{0,1003000331,1}},{10,{0,1004010331,1}},{10,{0,1004020331,1}},{0,{0,1004030331,1}},{10,{0,1004040331,1}},{0,{0,1005000331,1}},{10,{0,1006010331,1}},{10,{0,1006020331,1}},{0,{0,1006030331,1}},{10,{0,1006040331,1}},{10,{0,1007010331,1}},{10,{0,1007020331,1}},{0,{0,1007030331,1}},{10,{0,1007040331,1}},{10,{0,1008010331,1}},{10,{0,1008020331,1}},{0,{0,1008030331,1}},{10,{0,1008040331,1}},{0,{0,1009000331,1}},{10,{0,1010010331,1}},{10,{0,1010020331,1}},{0,{0,1010030331,1}},{10,{0,1010040331,1}}]','[{252,{0,17010001,1}},{17,{0,38030006,1}},{17,{0,38030007,1}},{126,{0,38130001,1}},{42,{0,11020001,1}},{59,{0,18020001,1}},{252,{0,38040102,1}},{25,{0,38100001,1}},{84,{0,38190001,1}},{244,{0,17010001,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}},{244,{0,17010001,1}},{33,{0,38040010,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}}]','[]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1006,1,'[{10,{0,1001010300,1}},{10,{0,1001020300,1}},{0,{0,1001030300,1}},{10,{0,1001040300,1}},{10,{0,1002010300,1}},{10,{0,1002020300,1}},{0,{0,1002030300,1}},{10,{0,1002040300,1}},{3,{0,1003000300,1}},{10,{0,1004010300,1}},{10,{0,1004020300,1}},{0,{0,1004030300,1}},{10,{0,1004040300,1}},{0,{0,1005000300,1}},{10,{0,1006010300,1}},{10,{0,1006020300,1}},{0,{0,1006030300,1}},{10,{0,1006040300,1}},{10,{0,1007010300,1}},{10,{0,1007020300,1}},{0,{0,1007030300,1}},{10,{0,1007040300,1}},{10,{0,1008010300,1}},{10,{0,1008020300,1}},{0,{0,1008030300,1}},{10,{0,1008040300,1}},{0,{0,1009000300,1}},{10,{0,1010010300,1}},{10,{0,1010020300,1}},{0,{0,1010030300,1}},{10,{0,1010040300,1}}]','[{10,{0,1001010310,1}},{10,{0,1001020310,1}},{0,{0,1001030310,1}},{10,{0,1001040310,1}},{10,{0,1002010310,1}},{10,{0,1002020310,1}},{0,{0,1002030310,1}},{10,{0,1002040310,1}},{3,{0,1003000310,1}},{10,{0,1004010310,1}},{10,{0,1004020310,1}},{0,{0,1004030310,1}},{10,{0,1004040310,1}},{0,{0,1005000310,1}},{10,{0,1006010310,1}},{10,{0,1006020310,1}},{0,{0,1006030310,1}},{10,{0,1006040310,1}},{10,{0,1007010310,1}},{10,{0,1007020310,1}},{0,{0,1007030310,1}},{10,{0,1007040310,1}},{10,{0,1008010310,1}},{10,{0,1008020310,1}},{0,{0,1008030310,1}},{10,{0,1008040310,1}},{0,{0,1009000310,1}},{10,{0,1010010310,1}},{10,{0,1010020310,1}},{0,{0,1010030310,1}},{10,{0,1010040310,1}}]','[{10,{0,1001010320,1}},{10,{0,1001020320,1}},{0,{0,1001030320,1}},{10,{0,1001040320,1}},{10,{0,1002010320,1}},{10,{0,1002020320,1}},{0,{0,1002030320,1}},{10,{0,1002040320,1}},{3,{0,1003000320,1}},{10,{0,1004010320,1}},{10,{0,1004020320,1}},{0,{0,1004030320,1}},{10,{0,1004040320,1}},{0,{0,1005000320,1}},{10,{0,1006010320,1}},{10,{0,1006020320,1}},{0,{0,1006030320,1}},{10,{0,1006040320,1}},{10,{0,1007010320,1}},{10,{0,1007020320,1}},{0,{0,1007030320,1}},{10,{0,1007040320,1}},{10,{0,1008010320,1}},{10,{0,1008020320,1}},{0,{0,1008030320,1}},{10,{0,1008040320,1}},{0,{0,1009000320,1}},{10,{0,1010010320,1}},{10,{0,1010020320,1}},{0,{0,1010030320,1}},{10,{0,1010040320,1}}]','[{10,{0,1001010331,1}},{10,{0,1001020331,1}},{0,{0,1001030331,1}},{10,{0,1001040331,1}},{10,{0,1002010331,1}},{10,{0,1002020331,1}},{0,{0,1002030331,1}},{10,{0,1002040331,1}},{3,{0,1003000331,1}},{10,{0,1004010331,1}},{10,{0,1004020331,1}},{0,{0,1004030331,1}},{10,{0,1004040331,1}},{0,{0,1005000331,1}},{10,{0,1006010331,1}},{10,{0,1006020331,1}},{0,{0,1006030331,1}},{10,{0,1006040331,1}},{10,{0,1007010331,1}},{10,{0,1007020331,1}},{0,{0,1007030331,1}},{10,{0,1007040331,1}},{10,{0,1008010331,1}},{10,{0,1008020331,1}},{0,{0,1008030331,1}},{10,{0,1008040331,1}},{0,{0,1009000331,1}},{10,{0,1010010331,1}},{10,{0,1010020331,1}},{0,{0,1010030331,1}},{10,{0,1010040331,1}}]','[{252,{0,17010001,1}},{17,{0,38030006,1}},{17,{0,38030007,1}},{126,{0,38130001,1}},{42,{0,11020001,1}},{59,{0,18020001,1}},{252,{0,38040102,1}},{25,{0,38100001,1}},{84,{0,38190001,1}},{244,{0,17010001,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}},{244,{0,17010001,1}},{33,{0,38040010,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}}]','[{100,{0,38110001,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1006,2,'[{10,{0,1001010300,1}},{10,{0,1001020300,1}},{0,{0,1001030300,1}},{10,{0,1001040300,1}},{10,{0,1002010300,1}},{10,{0,1002020300,1}},{0,{0,1002030300,1}},{10,{0,1002040300,1}},{3,{0,1003000300,1}},{10,{0,1004010300,1}},{10,{0,1004020300,1}},{0,{0,1004030300,1}},{10,{0,1004040300,1}},{0,{0,1005000300,1}},{10,{0,1006010300,1}},{10,{0,1006020300,1}},{0,{0,1006030300,1}},{10,{0,1006040300,1}},{10,{0,1007010300,1}},{10,{0,1007020300,1}},{0,{0,1007030300,1}},{10,{0,1007040300,1}},{10,{0,1008010300,1}},{10,{0,1008020300,1}},{0,{0,1008030300,1}},{10,{0,1008040300,1}},{0,{0,1009000300,1}},{10,{0,1010010300,1}},{10,{0,1010020300,1}},{0,{0,1010030300,1}},{10,{0,1010040300,1}}]','[{10,{0,1001010310,1}},{10,{0,1001020310,1}},{0,{0,1001030310,1}},{10,{0,1001040310,1}},{10,{0,1002010310,1}},{10,{0,1002020310,1}},{0,{0,1002030310,1}},{10,{0,1002040310,1}},{3,{0,1003000310,1}},{10,{0,1004010310,1}},{10,{0,1004020310,1}},{0,{0,1004030310,1}},{10,{0,1004040310,1}},{0,{0,1005000310,1}},{10,{0,1006010310,1}},{10,{0,1006020310,1}},{0,{0,1006030310,1}},{10,{0,1006040310,1}},{10,{0,1007010310,1}},{10,{0,1007020310,1}},{0,{0,1007030310,1}},{10,{0,1007040310,1}},{10,{0,1008010310,1}},{10,{0,1008020310,1}},{0,{0,1008030310,1}},{10,{0,1008040310,1}},{0,{0,1009000310,1}},{10,{0,1010010310,1}},{10,{0,1010020310,1}},{0,{0,1010030310,1}},{10,{0,1010040310,1}}]','[{10,{0,1001010320,1}},{10,{0,1001020320,1}},{0,{0,1001030320,1}},{10,{0,1001040320,1}},{10,{0,1002010320,1}},{10,{0,1002020320,1}},{0,{0,1002030320,1}},{10,{0,1002040320,1}},{3,{0,1003000320,1}},{10,{0,1004010320,1}},{10,{0,1004020320,1}},{0,{0,1004030320,1}},{10,{0,1004040320,1}},{0,{0,1005000320,1}},{10,{0,1006010320,1}},{10,{0,1006020320,1}},{0,{0,1006030320,1}},{10,{0,1006040320,1}},{10,{0,1007010320,1}},{10,{0,1007020320,1}},{0,{0,1007030320,1}},{10,{0,1007040320,1}},{10,{0,1008010320,1}},{10,{0,1008020320,1}},{0,{0,1008030320,1}},{10,{0,1008040320,1}},{0,{0,1009000320,1}},{10,{0,1010010320,1}},{10,{0,1010020320,1}},{0,{0,1010030320,1}},{10,{0,1010040320,1}}]','[{10,{0,1001010331,1}},{10,{0,1001020331,1}},{0,{0,1001030331,1}},{10,{0,1001040331,1}},{10,{0,1002010331,1}},{10,{0,1002020331,1}},{0,{0,1002030331,1}},{10,{0,1002040331,1}},{3,{0,1003000331,1}},{10,{0,1004010331,1}},{10,{0,1004020331,1}},{0,{0,1004030331,1}},{10,{0,1004040331,1}},{0,{0,1005000331,1}},{10,{0,1006010331,1}},{10,{0,1006020331,1}},{0,{0,1006030331,1}},{10,{0,1006040331,1}},{10,{0,1007010331,1}},{10,{0,1007020331,1}},{0,{0,1007030331,1}},{10,{0,1007040331,1}},{10,{0,1008010331,1}},{10,{0,1008020331,1}},{0,{0,1008030331,1}},{10,{0,1008040331,1}},{0,{0,1009000331,1}},{10,{0,1010010331,1}},{10,{0,1010020331,1}},{0,{0,1010030331,1}},{10,{0,1010040331,1}}]','[{252,{0,17010001,1}},{17,{0,38030006,1}},{17,{0,38030007,1}},{126,{0,38130001,1}},{42,{0,11020001,1}},{59,{0,18020001,1}},{252,{0,38040102,1}},{25,{0,38100001,1}},{84,{0,38190001,1}},{244,{0,17010001,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}},{244,{0,17010001,1}},{33,{0,38040010,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}}]','[{100,{0,38110001,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1006,3,'[{10,{0,1001010300,1}},{10,{0,1001020300,1}},{0,{0,1001030300,1}},{10,{0,1001040300,1}},{10,{0,1002010300,1}},{10,{0,1002020300,1}},{0,{0,1002030300,1}},{10,{0,1002040300,1}},{3,{0,1003000300,1}},{10,{0,1004010300,1}},{10,{0,1004020300,1}},{0,{0,1004030300,1}},{10,{0,1004040300,1}},{0,{0,1005000300,1}},{10,{0,1006010300,1}},{10,{0,1006020300,1}},{0,{0,1006030300,1}},{10,{0,1006040300,1}},{10,{0,1007010300,1}},{10,{0,1007020300,1}},{0,{0,1007030300,1}},{10,{0,1007040300,1}},{10,{0,1008010300,1}},{10,{0,1008020300,1}},{0,{0,1008030300,1}},{10,{0,1008040300,1}},{0,{0,1009000300,1}},{10,{0,1010010300,1}},{10,{0,1010020300,1}},{0,{0,1010030300,1}},{10,{0,1010040300,1}}]','[{10,{0,1001010310,1}},{10,{0,1001020310,1}},{0,{0,1001030310,1}},{10,{0,1001040310,1}},{10,{0,1002010310,1}},{10,{0,1002020310,1}},{0,{0,1002030310,1}},{10,{0,1002040310,1}},{3,{0,1003000310,1}},{10,{0,1004010310,1}},{10,{0,1004020310,1}},{0,{0,1004030310,1}},{10,{0,1004040310,1}},{0,{0,1005000310,1}},{10,{0,1006010310,1}},{10,{0,1006020310,1}},{0,{0,1006030310,1}},{10,{0,1006040310,1}},{10,{0,1007010310,1}},{10,{0,1007020310,1}},{0,{0,1007030310,1}},{10,{0,1007040310,1}},{10,{0,1008010310,1}},{10,{0,1008020310,1}},{0,{0,1008030310,1}},{10,{0,1008040310,1}},{0,{0,1009000310,1}},{10,{0,1010010310,1}},{10,{0,1010020310,1}},{0,{0,1010030310,1}},{10,{0,1010040310,1}}]','[{10,{0,1001010320,1}},{10,{0,1001020320,1}},{0,{0,1001030320,1}},{10,{0,1001040320,1}},{10,{0,1002010320,1}},{10,{0,1002020320,1}},{0,{0,1002030320,1}},{10,{0,1002040320,1}},{3,{0,1003000320,1}},{10,{0,1004010320,1}},{10,{0,1004020320,1}},{0,{0,1004030320,1}},{10,{0,1004040320,1}},{0,{0,1005000320,1}},{10,{0,1006010320,1}},{10,{0,1006020320,1}},{0,{0,1006030320,1}},{10,{0,1006040320,1}},{10,{0,1007010320,1}},{10,{0,1007020320,1}},{0,{0,1007030320,1}},{10,{0,1007040320,1}},{10,{0,1008010320,1}},{10,{0,1008020320,1}},{0,{0,1008030320,1}},{10,{0,1008040320,1}},{0,{0,1009000320,1}},{10,{0,1010010320,1}},{10,{0,1010020320,1}},{0,{0,1010030320,1}},{10,{0,1010040320,1}}]','[{10,{0,1001010331,1}},{10,{0,1001020331,1}},{0,{0,1001030331,1}},{10,{0,1001040331,1}},{10,{0,1002010331,1}},{10,{0,1002020331,1}},{0,{0,1002030331,1}},{10,{0,1002040331,1}},{3,{0,1003000331,1}},{10,{0,1004010331,1}},{10,{0,1004020331,1}},{0,{0,1004030331,1}},{10,{0,1004040331,1}},{0,{0,1005000331,1}},{10,{0,1006010331,1}},{10,{0,1006020331,1}},{0,{0,1006030331,1}},{10,{0,1006040331,1}},{10,{0,1007010331,1}},{10,{0,1007020331,1}},{0,{0,1007030331,1}},{10,{0,1007040331,1}},{10,{0,1008010331,1}},{10,{0,1008020331,1}},{0,{0,1008030331,1}},{10,{0,1008040331,1}},{0,{0,1009000331,1}},{10,{0,1010010331,1}},{10,{0,1010020331,1}},{0,{0,1010030331,1}},{10,{0,1010040331,1}}]','[{252,{0,17010001,1}},{17,{0,38030006,1}},{17,{0,38030007,1}},{126,{0,38130001,1}},{42,{0,11020001,1}},{59,{0,18020001,1}},{252,{0,38040102,1}},{25,{0,38100001,1}},{84,{0,38190001,1}},{244,{0,17010001,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}},{244,{0,17010001,1}},{33,{0,38040010,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}}]','[{100,{0,38110001,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1006,4,'[{10,{0,1001010400,1}},{10,{0,1001020400,1}},{0,{0,1001030400,1}},{10,{0,1001040400,1}},{10,{0,1002010400,1}},{10,{0,1002020400,1}},{0,{0,1002030400,1}},{10,{0,1002040400,1}},{3,{0,1003000400,1}},{10,{0,1004010400,1}},{10,{0,1004020400,1}},{0,{0,1004030400,1}},{10,{0,1004040400,1}},{0,{0,1005000400,1}},{10,{0,1006010400,1}},{10,{0,1006020400,1}},{0,{0,1006030400,1}},{10,{0,1006040400,1}},{10,{0,1007010400,1}},{10,{0,1007020400,1}},{0,{0,1007030400,1}},{10,{0,1007040400,1}},{10,{0,1008010400,1}},{10,{0,1008020400,1}},{0,{0,1008030400,1}},{10,{0,1008040400,1}},{0,{0,1009000400,1}},{10,{0,1010010400,1}},{10,{0,1010020400,1}},{0,{0,1010030400,1}},{10,{0,1010040400,1}}]','[{10,{0,1001010410,1}},{10,{0,1001020410,1}},{0,{0,1001030410,1}},{10,{0,1001040410,1}},{10,{0,1002010410,1}},{10,{0,1002020410,1}},{0,{0,1002030410,1}},{10,{0,1002040410,1}},{3,{0,1003000410,1}},{10,{0,1004010410,1}},{10,{0,1004020410,1}},{0,{0,1004030410,1}},{10,{0,1004040410,1}},{0,{0,1005000410,1}},{10,{0,1006010410,1}},{10,{0,1006020410,1}},{0,{0,1006030410,1}},{10,{0,1006040410,1}},{10,{0,1007010410,1}},{10,{0,1007020410,1}},{0,{0,1007030410,1}},{10,{0,1007040410,1}},{10,{0,1008010410,1}},{10,{0,1008020410,1}},{0,{0,1008030410,1}},{10,{0,1008040410,1}},{0,{0,1009000410,1}},{10,{0,1010010410,1}},{10,{0,1010020410,1}},{0,{0,1010030410,1}},{10,{0,1010040410,1}}]','[{10,{0,1001010420,1}},{10,{0,1001020420,1}},{0,{0,1001030420,1}},{10,{0,1001040420,1}},{10,{0,1002010420,1}},{10,{0,1002020420,1}},{0,{0,1002030420,1}},{10,{0,1002040420,1}},{3,{0,1003000420,1}},{10,{0,1004010420,1}},{10,{0,1004020420,1}},{0,{0,1004030420,1}},{10,{0,1004040420,1}},{0,{0,1005000420,1}},{10,{0,1006010420,1}},{10,{0,1006020420,1}},{0,{0,1006030420,1}},{10,{0,1006040420,1}},{10,{0,1007010420,1}},{10,{0,1007020420,1}},{0,{0,1007030420,1}},{10,{0,1007040420,1}},{10,{0,1008010420,1}},{10,{0,1008020420,1}},{0,{0,1008030420,1}},{10,{0,1008040420,1}},{0,{0,1009000420,1}},{10,{0,1010010420,1}},{10,{0,1010020420,1}},{0,{0,1010030420,1}},{10,{0,1010040420,1}}]','[{10,{0,1001010431,1}},{10,{0,1001020431,1}},{0,{0,1001030431,1}},{10,{0,1001040431,1}},{10,{0,1002010431,1}},{10,{0,1002020431,1}},{0,{0,1002030431,1}},{10,{0,1002040431,1}},{3,{0,1003000431,1}},{10,{0,1004010431,1}},{10,{0,1004020431,1}},{0,{0,1004030431,1}},{10,{0,1004040431,1}},{0,{0,1005000431,1}},{10,{0,1006010431,1}},{10,{0,1006020431,1}},{0,{0,1006030431,1}},{10,{0,1006040431,1}},{10,{0,1007010431,1}},{10,{0,1007020431,1}},{0,{0,1007030431,1}},{10,{0,1007040431,1}},{10,{0,1008010431,1}},{10,{0,1008020431,1}},{0,{0,1008030431,1}},{10,{0,1008040431,1}},{0,{0,1009000431,1}},{10,{0,1010010431,1}},{10,{0,1010020431,1}},{0,{0,1010030431,1}},{10,{0,1010040431,1}}]','[{252,{0,17010001,1}},{17,{0,38030006,1}},{17,{0,38030007,1}},{126,{0,38130001,1}},{42,{0,11020001,1}},{59,{0,18020001,1}},{252,{0,38040102,1}},{25,{0,38100001,1}},{84,{0,38190001,1}},{244,{0,17010001,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}},{244,{0,17010001,1}},{33,{0,38040010,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}}]','[{100,{0,38110001,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1006,5,'[{10,{0,1001010400,1}},{10,{0,1001020400,1}},{0,{0,1001030400,1}},{10,{0,1001040400,1}},{10,{0,1002010400,1}},{10,{0,1002020400,1}},{0,{0,1002030400,1}},{10,{0,1002040400,1}},{3,{0,1003000400,1}},{10,{0,1004010400,1}},{10,{0,1004020400,1}},{0,{0,1004030400,1}},{10,{0,1004040400,1}},{0,{0,1005000400,1}},{10,{0,1006010400,1}},{10,{0,1006020400,1}},{0,{0,1006030400,1}},{10,{0,1006040400,1}},{10,{0,1007010400,1}},{10,{0,1007020400,1}},{0,{0,1007030400,1}},{10,{0,1007040400,1}},{10,{0,1008010400,1}},{10,{0,1008020400,1}},{0,{0,1008030400,1}},{10,{0,1008040400,1}},{0,{0,1009000400,1}},{10,{0,1010010400,1}},{10,{0,1010020400,1}},{0,{0,1010030400,1}},{10,{0,1010040400,1}}]','[{10,{0,1001010410,1}},{10,{0,1001020410,1}},{0,{0,1001030410,1}},{10,{0,1001040410,1}},{10,{0,1002010410,1}},{10,{0,1002020410,1}},{0,{0,1002030410,1}},{10,{0,1002040410,1}},{3,{0,1003000410,1}},{10,{0,1004010410,1}},{10,{0,1004020410,1}},{0,{0,1004030410,1}},{10,{0,1004040410,1}},{0,{0,1005000410,1}},{10,{0,1006010410,1}},{10,{0,1006020410,1}},{0,{0,1006030410,1}},{10,{0,1006040410,1}},{10,{0,1007010410,1}},{10,{0,1007020410,1}},{0,{0,1007030410,1}},{10,{0,1007040410,1}},{10,{0,1008010410,1}},{10,{0,1008020410,1}},{0,{0,1008030410,1}},{10,{0,1008040410,1}},{0,{0,1009000410,1}},{10,{0,1010010410,1}},{10,{0,1010020410,1}},{0,{0,1010030410,1}},{10,{0,1010040410,1}}]','[{10,{0,1001010420,1}},{10,{0,1001020420,1}},{0,{0,1001030420,1}},{10,{0,1001040420,1}},{10,{0,1002010420,1}},{10,{0,1002020420,1}},{0,{0,1002030420,1}},{10,{0,1002040420,1}},{3,{0,1003000420,1}},{10,{0,1004010420,1}},{10,{0,1004020420,1}},{0,{0,1004030420,1}},{10,{0,1004040420,1}},{0,{0,1005000420,1}},{10,{0,1006010420,1}},{10,{0,1006020420,1}},{0,{0,1006030420,1}},{10,{0,1006040420,1}},{10,{0,1007010420,1}},{10,{0,1007020420,1}},{0,{0,1007030420,1}},{10,{0,1007040420,1}},{10,{0,1008010420,1}},{10,{0,1008020420,1}},{0,{0,1008030420,1}},{10,{0,1008040420,1}},{0,{0,1009000420,1}},{10,{0,1010010420,1}},{10,{0,1010020420,1}},{0,{0,1010030420,1}},{10,{0,1010040420,1}}]','[{10,{0,1001010431,1}},{10,{0,1001020431,1}},{0,{0,1001030431,1}},{10,{0,1001040431,1}},{10,{0,1002010431,1}},{10,{0,1002020431,1}},{0,{0,1002030431,1}},{10,{0,1002040431,1}},{3,{0,1003000431,1}},{10,{0,1004010431,1}},{10,{0,1004020431,1}},{0,{0,1004030431,1}},{10,{0,1004040431,1}},{0,{0,1005000431,1}},{10,{0,1006010431,1}},{10,{0,1006020431,1}},{0,{0,1006030431,1}},{10,{0,1006040431,1}},{10,{0,1007010431,1}},{10,{0,1007020431,1}},{0,{0,1007030431,1}},{10,{0,1007040431,1}},{10,{0,1008010431,1}},{10,{0,1008020431,1}},{0,{0,1008030431,1}},{10,{0,1008040431,1}},{0,{0,1009000431,1}},{10,{0,1010010431,1}},{10,{0,1010020431,1}},{0,{0,1010030431,1}},{10,{0,1010040431,1}}]','[{252,{0,17010001,1}},{17,{0,38030006,1}},{17,{0,38030007,1}},{126,{0,38130001,1}},{42,{0,11020001,1}},{59,{0,18020001,1}},{252,{0,38040102,1}},{25,{0,38100001,1}},{84,{0,38190001,1}},{244,{0,17010001,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}},{244,{0,17010001,1}},{33,{0,38040010,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}}]','[{100,{0,38110001,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1006,6,'[{10,{0,1001010400,1}},{10,{0,1001020400,1}},{0,{0,1001030400,1}},{10,{0,1001040400,1}},{10,{0,1002010400,1}},{10,{0,1002020400,1}},{0,{0,1002030400,1}},{10,{0,1002040400,1}},{3,{0,1003000400,1}},{10,{0,1004010400,1}},{10,{0,1004020400,1}},{0,{0,1004030400,1}},{10,{0,1004040400,1}},{0,{0,1005000400,1}},{10,{0,1006010400,1}},{10,{0,1006020400,1}},{0,{0,1006030400,1}},{10,{0,1006040400,1}},{10,{0,1007010400,1}},{10,{0,1007020400,1}},{0,{0,1007030400,1}},{10,{0,1007040400,1}},{10,{0,1008010400,1}},{10,{0,1008020400,1}},{0,{0,1008030400,1}},{10,{0,1008040400,1}},{0,{0,1009000400,1}},{10,{0,1010010400,1}},{10,{0,1010020400,1}},{0,{0,1010030400,1}},{10,{0,1010040400,1}}]','[{10,{0,1001010410,1}},{10,{0,1001020410,1}},{0,{0,1001030410,1}},{10,{0,1001040410,1}},{10,{0,1002010410,1}},{10,{0,1002020410,1}},{0,{0,1002030410,1}},{10,{0,1002040410,1}},{3,{0,1003000410,1}},{10,{0,1004010410,1}},{10,{0,1004020410,1}},{0,{0,1004030410,1}},{10,{0,1004040410,1}},{0,{0,1005000410,1}},{10,{0,1006010410,1}},{10,{0,1006020410,1}},{0,{0,1006030410,1}},{10,{0,1006040410,1}},{10,{0,1007010410,1}},{10,{0,1007020410,1}},{0,{0,1007030410,1}},{10,{0,1007040410,1}},{10,{0,1008010410,1}},{10,{0,1008020410,1}},{0,{0,1008030410,1}},{10,{0,1008040410,1}},{0,{0,1009000410,1}},{10,{0,1010010410,1}},{10,{0,1010020410,1}},{0,{0,1010030410,1}},{10,{0,1010040410,1}}]','[{10,{0,1001010420,1}},{10,{0,1001020420,1}},{0,{0,1001030420,1}},{10,{0,1001040420,1}},{10,{0,1002010420,1}},{10,{0,1002020420,1}},{0,{0,1002030420,1}},{10,{0,1002040420,1}},{3,{0,1003000420,1}},{10,{0,1004010420,1}},{10,{0,1004020420,1}},{0,{0,1004030420,1}},{10,{0,1004040420,1}},{0,{0,1005000420,1}},{10,{0,1006010420,1}},{10,{0,1006020420,1}},{0,{0,1006030420,1}},{10,{0,1006040420,1}},{10,{0,1007010420,1}},{10,{0,1007020420,1}},{0,{0,1007030420,1}},{10,{0,1007040420,1}},{10,{0,1008010420,1}},{10,{0,1008020420,1}},{0,{0,1008030420,1}},{10,{0,1008040420,1}},{0,{0,1009000420,1}},{10,{0,1010010420,1}},{10,{0,1010020420,1}},{0,{0,1010030420,1}},{10,{0,1010040420,1}}]','[{10,{0,1001010431,1}},{10,{0,1001020431,1}},{0,{0,1001030431,1}},{10,{0,1001040431,1}},{10,{0,1002010431,1}},{10,{0,1002020431,1}},{0,{0,1002030431,1}},{10,{0,1002040431,1}},{3,{0,1003000431,1}},{10,{0,1004010431,1}},{10,{0,1004020431,1}},{0,{0,1004030431,1}},{10,{0,1004040431,1}},{0,{0,1005000431,1}},{10,{0,1006010431,1}},{10,{0,1006020431,1}},{0,{0,1006030431,1}},{10,{0,1006040431,1}},{10,{0,1007010431,1}},{10,{0,1007020431,1}},{0,{0,1007030431,1}},{10,{0,1007040431,1}},{10,{0,1008010431,1}},{10,{0,1008020431,1}},{0,{0,1008030431,1}},{10,{0,1008040431,1}},{0,{0,1009000431,1}},{10,{0,1010010431,1}},{10,{0,1010020431,1}},{0,{0,1010030431,1}},{10,{0,1010040431,1}}]','[{252,{0,17010001,1}},{17,{0,38030006,1}},{17,{0,38030007,1}},{126,{0,38130001,1}},{42,{0,11020001,1}},{59,{0,18020001,1}},{252,{0,38040102,1}},{25,{0,38100001,1}},{84,{0,38190001,1}},{244,{0,17010001,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}},{244,{0,17010001,1}},{33,{0,38040010,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}}]','[{100,{0,38110001,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1006,7,'[{10,{0,1001010500,1}},{10,{0,1001020500,1}},{0,{0,1001030500,1}},{10,{0,1001040500,1}},{10,{0,1002010500,1}},{10,{0,1002020500,1}},{0,{0,1002030500,1}},{10,{0,1002040500,1}},{3,{0,1003000500,1}},{10,{0,1004010500,1}},{10,{0,1004020500,1}},{0,{0,1004030500,1}},{10,{0,1004040500,1}},{0,{0,1005000500,1}},{10,{0,1006010500,1}},{10,{0,1006020500,1}},{0,{0,1006030500,1}},{10,{0,1006040500,1}},{10,{0,1007010500,1}},{10,{0,1007020500,1}},{0,{0,1007030500,1}},{10,{0,1007040500,1}},{10,{0,1008010500,1}},{10,{0,1008020500,1}},{0,{0,1008030500,1}},{10,{0,1008040500,1}},{0,{0,1009000500,1}},{10,{0,1010010500,1}},{10,{0,1010020500,1}},{0,{0,1010030500,1}},{10,{0,1010040500,1}}]','[{10,{0,1001010510,1}},{10,{0,1001020510,1}},{0,{0,1001030510,1}},{10,{0,1001040510,1}},{10,{0,1002010510,1}},{10,{0,1002020510,1}},{0,{0,1002030510,1}},{10,{0,1002040510,1}},{3,{0,1003000510,1}},{10,{0,1004010510,1}},{10,{0,1004020510,1}},{0,{0,1004030510,1}},{10,{0,1004040510,1}},{0,{0,1005000510,1}},{10,{0,1006010510,1}},{10,{0,1006020510,1}},{0,{0,1006030510,1}},{10,{0,1006040510,1}},{10,{0,1007010510,1}},{10,{0,1007020510,1}},{0,{0,1007030510,1}},{10,{0,1007040510,1}},{10,{0,1008010510,1}},{10,{0,1008020510,1}},{0,{0,1008030510,1}},{10,{0,1008040510,1}},{0,{0,1009000510,1}},{10,{0,1010010510,1}},{10,{0,1010020510,1}},{0,{0,1010030510,1}},{10,{0,1010040510,1}}]','[{10,{0,1001010520,1}},{10,{0,1001020520,1}},{0,{0,1001030520,1}},{10,{0,1001040520,1}},{10,{0,1002010520,1}},{10,{0,1002020520,1}},{0,{0,1002030520,1}},{10,{0,1002040520,1}},{3,{0,1003000520,1}},{10,{0,1004010520,1}},{10,{0,1004020520,1}},{0,{0,1004030520,1}},{10,{0,1004040520,1}},{0,{0,1005000520,1}},{10,{0,1006010520,1}},{10,{0,1006020520,1}},{0,{0,1006030520,1}},{10,{0,1006040520,1}},{10,{0,1007010520,1}},{10,{0,1007020520,1}},{0,{0,1007030520,1}},{10,{0,1007040520,1}},{10,{0,1008010520,1}},{10,{0,1008020520,1}},{0,{0,1008030520,1}},{10,{0,1008040520,1}},{0,{0,1009000520,1}},{10,{0,1010010520,1}},{10,{0,1010020520,1}},{0,{0,1010030520,1}},{10,{0,1010040520,1}}]','[{10,{0,1001010531,1}},{10,{0,1001020531,1}},{0,{0,1001030531,1}},{10,{0,1001040531,1}},{10,{0,1002010531,1}},{10,{0,1002020531,1}},{0,{0,1002030531,1}},{10,{0,1002040531,1}},{3,{0,1003000531,1}},{10,{0,1004010531,1}},{10,{0,1004020531,1}},{0,{0,1004030531,1}},{10,{0,1004040531,1}},{0,{0,1005000531,1}},{10,{0,1006010531,1}},{10,{0,1006020531,1}},{0,{0,1006030531,1}},{10,{0,1006040531,1}},{10,{0,1007010531,1}},{10,{0,1007020531,1}},{0,{0,1007030531,1}},{10,{0,1007040531,1}},{10,{0,1008010531,1}},{10,{0,1008020531,1}},{0,{0,1008030531,1}},{10,{0,1008040531,1}},{0,{0,1009000531,1}},{10,{0,1010010531,1}},{10,{0,1010020531,1}},{0,{0,1010030531,1}},{10,{0,1010040531,1}}]','[{252,{0,17010001,1}},{17,{0,38030006,1}},{17,{0,38030007,1}},{126,{0,38130001,1}},{42,{0,11020001,1}},{59,{0,18020001,1}},{252,{0,38040102,1}},{25,{0,38100001,1}},{84,{0,38190001,1}},{244,{0,17010001,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}},{244,{0,17010001,1}},{33,{0,38040010,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}}]','[{100,{0,38110001,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1006,8,'[{10,{0,1001010500,1}},{10,{0,1001020500,1}},{0,{0,1001030500,1}},{10,{0,1001040500,1}},{10,{0,1002010500,1}},{10,{0,1002020500,1}},{0,{0,1002030500,1}},{10,{0,1002040500,1}},{3,{0,1003000500,1}},{10,{0,1004010500,1}},{10,{0,1004020500,1}},{0,{0,1004030500,1}},{10,{0,1004040500,1}},{0,{0,1005000500,1}},{10,{0,1006010500,1}},{10,{0,1006020500,1}},{0,{0,1006030500,1}},{10,{0,1006040500,1}},{10,{0,1007010500,1}},{10,{0,1007020500,1}},{0,{0,1007030500,1}},{10,{0,1007040500,1}},{10,{0,1008010500,1}},{10,{0,1008020500,1}},{0,{0,1008030500,1}},{10,{0,1008040500,1}},{0,{0,1009000500,1}},{10,{0,1010010500,1}},{10,{0,1010020500,1}},{0,{0,1010030500,1}},{10,{0,1010040500,1}}]','[{10,{0,1001010510,1}},{10,{0,1001020510,1}},{0,{0,1001030510,1}},{10,{0,1001040510,1}},{10,{0,1002010510,1}},{10,{0,1002020510,1}},{0,{0,1002030510,1}},{10,{0,1002040510,1}},{3,{0,1003000510,1}},{10,{0,1004010510,1}},{10,{0,1004020510,1}},{0,{0,1004030510,1}},{10,{0,1004040510,1}},{0,{0,1005000510,1}},{10,{0,1006010510,1}},{10,{0,1006020510,1}},{0,{0,1006030510,1}},{10,{0,1006040510,1}},{10,{0,1007010510,1}},{10,{0,1007020510,1}},{0,{0,1007030510,1}},{10,{0,1007040510,1}},{10,{0,1008010510,1}},{10,{0,1008020510,1}},{0,{0,1008030510,1}},{10,{0,1008040510,1}},{0,{0,1009000510,1}},{10,{0,1010010510,1}},{10,{0,1010020510,1}},{0,{0,1010030510,1}},{10,{0,1010040510,1}}]','[{10,{0,1001010520,1}},{10,{0,1001020520,1}},{0,{0,1001030520,1}},{10,{0,1001040520,1}},{10,{0,1002010520,1}},{10,{0,1002020520,1}},{0,{0,1002030520,1}},{10,{0,1002040520,1}},{3,{0,1003000520,1}},{10,{0,1004010520,1}},{10,{0,1004020520,1}},{0,{0,1004030520,1}},{10,{0,1004040520,1}},{0,{0,1005000520,1}},{10,{0,1006010520,1}},{10,{0,1006020520,1}},{0,{0,1006030520,1}},{10,{0,1006040520,1}},{10,{0,1007010520,1}},{10,{0,1007020520,1}},{0,{0,1007030520,1}},{10,{0,1007040520,1}},{10,{0,1008010520,1}},{10,{0,1008020520,1}},{0,{0,1008030520,1}},{10,{0,1008040520,1}},{0,{0,1009000520,1}},{10,{0,1010010520,1}},{10,{0,1010020520,1}},{0,{0,1010030520,1}},{10,{0,1010040520,1}}]','[{10,{0,1001010531,1}},{10,{0,1001020531,1}},{0,{0,1001030531,1}},{10,{0,1001040531,1}},{10,{0,1002010531,1}},{10,{0,1002020531,1}},{0,{0,1002030531,1}},{10,{0,1002040531,1}},{3,{0,1003000531,1}},{10,{0,1004010531,1}},{10,{0,1004020531,1}},{0,{0,1004030531,1}},{10,{0,1004040531,1}},{0,{0,1005000531,1}},{10,{0,1006010531,1}},{10,{0,1006020531,1}},{0,{0,1006030531,1}},{10,{0,1006040531,1}},{10,{0,1007010531,1}},{10,{0,1007020531,1}},{0,{0,1007030531,1}},{10,{0,1007040531,1}},{10,{0,1008010531,1}},{10,{0,1008020531,1}},{0,{0,1008030531,1}},{10,{0,1008040531,1}},{0,{0,1009000531,1}},{10,{0,1010010531,1}},{10,{0,1010020531,1}},{0,{0,1010030531,1}},{10,{0,1010040531,1}}]','[{252,{0,17010001,1}},{17,{0,38030006,1}},{17,{0,38030007,1}},{126,{0,38130001,1}},{42,{0,11020001,1}},{59,{0,18020001,1}},{252,{0,38040102,1}},{25,{0,38100001,1}},{84,{0,38190001,1}},{244,{0,17010001,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}},{244,{0,17010001,1}},{33,{0,38040010,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}}]','[{100,{0,38110001,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1007,1,'[{10,{0,1001010500,1}},{10,{0,1001020500,1}},{0,{0,1001030500,1}},{10,{0,1001040500,1}},{10,{0,1002010500,1}},{10,{0,1002020500,1}},{0,{0,1002030500,1}},{10,{0,1002040500,1}},{3,{0,1003000500,1}},{10,{0,1004010500,1}},{10,{0,1004020500,1}},{0,{0,1004030500,1}},{10,{0,1004040500,1}},{0,{0,1005000500,1}},{10,{0,1006010500,1}},{10,{0,1006020500,1}},{0,{0,1006030500,1}},{10,{0,1006040500,1}},{10,{0,1007010500,1}},{10,{0,1007020500,1}},{0,{0,1007030500,1}},{10,{0,1007040500,1}},{10,{0,1008010500,1}},{10,{0,1008020500,1}},{0,{0,1008030500,1}},{10,{0,1008040500,1}},{0,{0,1009000500,1}},{10,{0,1010010500,1}},{10,{0,1010020500,1}},{0,{0,1010030500,1}},{10,{0,1010040500,1}}]','[{10,{0,1001010510,1}},{10,{0,1001020510,1}},{0,{0,1001030510,1}},{10,{0,1001040510,1}},{10,{0,1002010510,1}},{10,{0,1002020510,1}},{0,{0,1002030510,1}},{10,{0,1002040510,1}},{3,{0,1003000510,1}},{10,{0,1004010510,1}},{10,{0,1004020510,1}},{0,{0,1004030510,1}},{10,{0,1004040510,1}},{0,{0,1005000510,1}},{10,{0,1006010510,1}},{10,{0,1006020510,1}},{0,{0,1006030510,1}},{10,{0,1006040510,1}},{10,{0,1007010510,1}},{10,{0,1007020510,1}},{0,{0,1007030510,1}},{10,{0,1007040510,1}},{10,{0,1008010510,1}},{10,{0,1008020510,1}},{0,{0,1008030510,1}},{10,{0,1008040510,1}},{0,{0,1009000510,1}},{10,{0,1010010510,1}},{10,{0,1010020510,1}},{0,{0,1010030510,1}},{10,{0,1010040510,1}}]','[{10,{0,1001010520,1}},{10,{0,1001020520,1}},{0,{0,1001030520,1}},{10,{0,1001040520,1}},{10,{0,1002010520,1}},{10,{0,1002020520,1}},{0,{0,1002030520,1}},{10,{0,1002040520,1}},{3,{0,1003000520,1}},{10,{0,1004010520,1}},{10,{0,1004020520,1}},{0,{0,1004030520,1}},{10,{0,1004040520,1}},{0,{0,1005000520,1}},{10,{0,1006010520,1}},{10,{0,1006020520,1}},{0,{0,1006030520,1}},{10,{0,1006040520,1}},{10,{0,1007010520,1}},{10,{0,1007020520,1}},{0,{0,1007030520,1}},{10,{0,1007040520,1}},{10,{0,1008010520,1}},{10,{0,1008020520,1}},{0,{0,1008030520,1}},{10,{0,1008040520,1}},{0,{0,1009000520,1}},{10,{0,1010010520,1}},{10,{0,1010020520,1}},{0,{0,1010030520,1}},{10,{0,1010040520,1}}]','[{10,{0,1001010531,1}},{10,{0,1001020531,1}},{0,{0,1001030531,1}},{10,{0,1001040531,1}},{10,{0,1002010531,1}},{10,{0,1002020531,1}},{0,{0,1002030531,1}},{10,{0,1002040531,1}},{3,{0,1003000531,1}},{10,{0,1004010531,1}},{10,{0,1004020531,1}},{0,{0,1004030531,1}},{10,{0,1004040531,1}},{0,{0,1005000531,1}},{10,{0,1006010531,1}},{10,{0,1006020531,1}},{0,{0,1006030531,1}},{10,{0,1006040531,1}},{10,{0,1007010531,1}},{10,{0,1007020531,1}},{0,{0,1007030531,1}},{10,{0,1007040531,1}},{10,{0,1008010531,1}},{10,{0,1008020531,1}},{0,{0,1008030531,1}},{10,{0,1008040531,1}},{0,{0,1009000531,1}},{10,{0,1010010531,1}},{10,{0,1010020531,1}},{0,{0,1010030531,1}},{10,{0,1010040531,1}}]','[{252,{0,17010001,1}},{17,{0,38030006,1}},{17,{0,38030007,1}},{126,{0,38130001,1}},{42,{0,11020001,1}},{59,{0,18020001,1}},{252,{0,38040102,1}},{25,{0,38100001,1}},{84,{0,38190001,1}},{244,{0,17010001,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}},{244,{0,17010001,1}},{33,{0,38040010,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}}]','[{100,{0,38110001,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1007,2,'[{10,{0,1001010500,1}},{10,{0,1001020500,1}},{0,{0,1001030500,1}},{10,{0,1001040500,1}},{10,{0,1002010500,1}},{10,{0,1002020500,1}},{0,{0,1002030500,1}},{10,{0,1002040500,1}},{3,{0,1003000500,1}},{10,{0,1004010500,1}},{10,{0,1004020500,1}},{0,{0,1004030500,1}},{10,{0,1004040500,1}},{0,{0,1005000500,1}},{10,{0,1006010500,1}},{10,{0,1006020500,1}},{0,{0,1006030500,1}},{10,{0,1006040500,1}},{10,{0,1007010500,1}},{10,{0,1007020500,1}},{0,{0,1007030500,1}},{10,{0,1007040500,1}},{10,{0,1008010500,1}},{10,{0,1008020500,1}},{0,{0,1008030500,1}},{10,{0,1008040500,1}},{0,{0,1009000500,1}},{10,{0,1010010500,1}},{10,{0,1010020500,1}},{0,{0,1010030500,1}},{10,{0,1010040500,1}}]','[{10,{0,1001010510,1}},{10,{0,1001020510,1}},{0,{0,1001030510,1}},{10,{0,1001040510,1}},{10,{0,1002010510,1}},{10,{0,1002020510,1}},{0,{0,1002030510,1}},{10,{0,1002040510,1}},{3,{0,1003000510,1}},{10,{0,1004010510,1}},{10,{0,1004020510,1}},{0,{0,1004030510,1}},{10,{0,1004040510,1}},{0,{0,1005000510,1}},{10,{0,1006010510,1}},{10,{0,1006020510,1}},{0,{0,1006030510,1}},{10,{0,1006040510,1}},{10,{0,1007010510,1}},{10,{0,1007020510,1}},{0,{0,1007030510,1}},{10,{0,1007040510,1}},{10,{0,1008010510,1}},{10,{0,1008020510,1}},{0,{0,1008030510,1}},{10,{0,1008040510,1}},{0,{0,1009000510,1}},{10,{0,1010010510,1}},{10,{0,1010020510,1}},{0,{0,1010030510,1}},{10,{0,1010040510,1}}]','[{10,{0,1001010520,1}},{10,{0,1001020520,1}},{0,{0,1001030520,1}},{10,{0,1001040520,1}},{10,{0,1002010520,1}},{10,{0,1002020520,1}},{0,{0,1002030520,1}},{10,{0,1002040520,1}},{3,{0,1003000520,1}},{10,{0,1004010520,1}},{10,{0,1004020520,1}},{0,{0,1004030520,1}},{10,{0,1004040520,1}},{0,{0,1005000520,1}},{10,{0,1006010520,1}},{10,{0,1006020520,1}},{0,{0,1006030520,1}},{10,{0,1006040520,1}},{10,{0,1007010520,1}},{10,{0,1007020520,1}},{0,{0,1007030520,1}},{10,{0,1007040520,1}},{10,{0,1008010520,1}},{10,{0,1008020520,1}},{0,{0,1008030520,1}},{10,{0,1008040520,1}},{0,{0,1009000520,1}},{10,{0,1010010520,1}},{10,{0,1010020520,1}},{0,{0,1010030520,1}},{10,{0,1010040520,1}}]','[{10,{0,1001010531,1}},{10,{0,1001020531,1}},{0,{0,1001030531,1}},{10,{0,1001040531,1}},{10,{0,1002010531,1}},{10,{0,1002020531,1}},{0,{0,1002030531,1}},{10,{0,1002040531,1}},{3,{0,1003000531,1}},{10,{0,1004010531,1}},{10,{0,1004020531,1}},{0,{0,1004030531,1}},{10,{0,1004040531,1}},{0,{0,1005000531,1}},{10,{0,1006010531,1}},{10,{0,1006020531,1}},{0,{0,1006030531,1}},{10,{0,1006040531,1}},{10,{0,1007010531,1}},{10,{0,1007020531,1}},{0,{0,1007030531,1}},{10,{0,1007040531,1}},{10,{0,1008010531,1}},{10,{0,1008020531,1}},{0,{0,1008030531,1}},{10,{0,1008040531,1}},{0,{0,1009000531,1}},{10,{0,1010010531,1}},{10,{0,1010020531,1}},{0,{0,1010030531,1}},{10,{0,1010040531,1}}]','[{252,{0,17010001,1}},{17,{0,38030006,1}},{17,{0,38030007,1}},{126,{0,38130001,1}},{42,{0,11020001,1}},{59,{0,18020001,1}},{252,{0,38040102,1}},{25,{0,38100001,1}},{84,{0,38190001,1}},{244,{0,17010001,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}},{244,{0,17010001,1}},{33,{0,38040010,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}}]','[{100,{0,38110001,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1007,3,'[{10,{0,1001010500,1}},{10,{0,1001020500,1}},{0,{0,1001030500,1}},{10,{0,1001040500,1}},{10,{0,1002010500,1}},{10,{0,1002020500,1}},{0,{0,1002030500,1}},{10,{0,1002040500,1}},{3,{0,1003000500,1}},{10,{0,1004010500,1}},{10,{0,1004020500,1}},{0,{0,1004030500,1}},{10,{0,1004040500,1}},{0,{0,1005000500,1}},{10,{0,1006010500,1}},{10,{0,1006020500,1}},{0,{0,1006030500,1}},{10,{0,1006040500,1}},{10,{0,1007010500,1}},{10,{0,1007020500,1}},{0,{0,1007030500,1}},{10,{0,1007040500,1}},{10,{0,1008010500,1}},{10,{0,1008020500,1}},{0,{0,1008030500,1}},{10,{0,1008040500,1}},{0,{0,1009000500,1}},{10,{0,1010010500,1}},{10,{0,1010020500,1}},{0,{0,1010030500,1}},{10,{0,1010040500,1}}]','[{10,{0,1001010510,1}},{10,{0,1001020510,1}},{0,{0,1001030510,1}},{10,{0,1001040510,1}},{10,{0,1002010510,1}},{10,{0,1002020510,1}},{0,{0,1002030510,1}},{10,{0,1002040510,1}},{3,{0,1003000510,1}},{10,{0,1004010510,1}},{10,{0,1004020510,1}},{0,{0,1004030510,1}},{10,{0,1004040510,1}},{0,{0,1005000510,1}},{10,{0,1006010510,1}},{10,{0,1006020510,1}},{0,{0,1006030510,1}},{10,{0,1006040510,1}},{10,{0,1007010510,1}},{10,{0,1007020510,1}},{0,{0,1007030510,1}},{10,{0,1007040510,1}},{10,{0,1008010510,1}},{10,{0,1008020510,1}},{0,{0,1008030510,1}},{10,{0,1008040510,1}},{0,{0,1009000510,1}},{10,{0,1010010510,1}},{10,{0,1010020510,1}},{0,{0,1010030510,1}},{10,{0,1010040510,1}}]','[{10,{0,1001010520,1}},{10,{0,1001020520,1}},{0,{0,1001030520,1}},{10,{0,1001040520,1}},{10,{0,1002010520,1}},{10,{0,1002020520,1}},{0,{0,1002030520,1}},{10,{0,1002040520,1}},{3,{0,1003000520,1}},{10,{0,1004010520,1}},{10,{0,1004020520,1}},{0,{0,1004030520,1}},{10,{0,1004040520,1}},{0,{0,1005000520,1}},{10,{0,1006010520,1}},{10,{0,1006020520,1}},{0,{0,1006030520,1}},{10,{0,1006040520,1}},{10,{0,1007010520,1}},{10,{0,1007020520,1}},{0,{0,1007030520,1}},{10,{0,1007040520,1}},{10,{0,1008010520,1}},{10,{0,1008020520,1}},{0,{0,1008030520,1}},{10,{0,1008040520,1}},{0,{0,1009000520,1}},{10,{0,1010010520,1}},{10,{0,1010020520,1}},{0,{0,1010030520,1}},{10,{0,1010040520,1}}]','[{10,{0,1001010531,1}},{10,{0,1001020531,1}},{0,{0,1001030531,1}},{10,{0,1001040531,1}},{10,{0,1002010531,1}},{10,{0,1002020531,1}},{0,{0,1002030531,1}},{10,{0,1002040531,1}},{3,{0,1003000531,1}},{10,{0,1004010531,1}},{10,{0,1004020531,1}},{0,{0,1004030531,1}},{10,{0,1004040531,1}},{0,{0,1005000531,1}},{10,{0,1006010531,1}},{10,{0,1006020531,1}},{0,{0,1006030531,1}},{10,{0,1006040531,1}},{10,{0,1007010531,1}},{10,{0,1007020531,1}},{0,{0,1007030531,1}},{10,{0,1007040531,1}},{10,{0,1008010531,1}},{10,{0,1008020531,1}},{0,{0,1008030531,1}},{10,{0,1008040531,1}},{0,{0,1009000531,1}},{10,{0,1010010531,1}},{10,{0,1010020531,1}},{0,{0,1010030531,1}},{10,{0,1010040531,1}}]','[{252,{0,17010001,1}},{17,{0,38030006,1}},{17,{0,38030007,1}},{126,{0,38130001,1}},{42,{0,11020001,1}},{59,{0,18020001,1}},{252,{0,38040102,1}},{25,{0,38100001,1}},{84,{0,38190001,1}},{244,{0,17010001,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}},{244,{0,17010001,1}},{33,{0,38040010,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}}]','[{100,{0,38110002,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1007,4,'[{10,{0,1001010600,1}},{10,{0,1001020600,1}},{0,{0,1001030600,1}},{10,{0,1001040600,1}},{10,{0,1002010600,1}},{10,{0,1002020600,1}},{0,{0,1002030600,1}},{10,{0,1002040600,1}},{3,{0,1003000600,1}},{10,{0,1004010600,1}},{10,{0,1004020600,1}},{0,{0,1004030600,1}},{10,{0,1004040600,1}},{0,{0,1005000600,1}},{10,{0,1006010600,1}},{10,{0,1006020600,1}},{0,{0,1006030600,1}},{10,{0,1006040600,1}},{10,{0,1007010600,1}},{10,{0,1007020600,1}},{0,{0,1007030600,1}},{10,{0,1007040600,1}},{10,{0,1008010600,1}},{10,{0,1008020600,1}},{0,{0,1008030600,1}},{10,{0,1008040600,1}},{0,{0,1009000600,1}},{10,{0,1010010600,1}},{10,{0,1010020600,1}},{0,{0,1010030600,1}},{10,{0,1010040600,1}}]','[{10,{0,1001010610,1}},{10,{0,1001020610,1}},{0,{0,1001030610,1}},{10,{0,1001040610,1}},{10,{0,1002010610,1}},{10,{0,1002020610,1}},{0,{0,1002030610,1}},{10,{0,1002040610,1}},{3,{0,1003000610,1}},{10,{0,1004010610,1}},{10,{0,1004020610,1}},{0,{0,1004030610,1}},{10,{0,1004040610,1}},{0,{0,1005000610,1}},{10,{0,1006010610,1}},{10,{0,1006020610,1}},{0,{0,1006030610,1}},{10,{0,1006040610,1}},{10,{0,1007010610,1}},{10,{0,1007020610,1}},{0,{0,1007030610,1}},{10,{0,1007040610,1}},{10,{0,1008010610,1}},{10,{0,1008020610,1}},{0,{0,1008030610,1}},{10,{0,1008040610,1}},{0,{0,1009000610,1}},{10,{0,1010010610,1}},{10,{0,1010020610,1}},{0,{0,1010030610,1}},{10,{0,1010040610,1}}]','[{10,{0,1001010620,1}},{10,{0,1001020620,1}},{0,{0,1001030620,1}},{10,{0,1001040620,1}},{10,{0,1002010620,1}},{10,{0,1002020620,1}},{0,{0,1002030620,1}},{10,{0,1002040620,1}},{3,{0,1003000620,1}},{10,{0,1004010620,1}},{10,{0,1004020620,1}},{0,{0,1004030620,1}},{10,{0,1004040620,1}},{0,{0,1005000620,1}},{10,{0,1006010620,1}},{10,{0,1006020620,1}},{0,{0,1006030620,1}},{10,{0,1006040620,1}},{10,{0,1007010620,1}},{10,{0,1007020620,1}},{0,{0,1007030620,1}},{10,{0,1007040620,1}},{10,{0,1008010620,1}},{10,{0,1008020620,1}},{0,{0,1008030620,1}},{10,{0,1008040620,1}},{0,{0,1009000620,1}},{10,{0,1010010620,1}},{10,{0,1010020620,1}},{0,{0,1010030620,1}},{10,{0,1010040620,1}}]','[{10,{0,1001010631,1}},{10,{0,1001020631,1}},{0,{0,1001030631,1}},{10,{0,1001040631,1}},{10,{0,1002010631,1}},{10,{0,1002020631,1}},{0,{0,1002030631,1}},{10,{0,1002040631,1}},{3,{0,1003000631,1}},{10,{0,1004010631,1}},{10,{0,1004020631,1}},{0,{0,1004030631,1}},{10,{0,1004040631,1}},{0,{0,1005000631,1}},{10,{0,1006010631,1}},{10,{0,1006020631,1}},{0,{0,1006030631,1}},{10,{0,1006040631,1}},{10,{0,1007010631,1}},{10,{0,1007020631,1}},{0,{0,1007030631,1}},{10,{0,1007040631,1}},{10,{0,1008010631,1}},{10,{0,1008020631,1}},{0,{0,1008030631,1}},{10,{0,1008040631,1}},{0,{0,1009000631,1}},{10,{0,1010010631,1}},{10,{0,1010020631,1}},{0,{0,1010030631,1}},{10,{0,1010040631,1}}]','[{252,{0,17010001,1}},{17,{0,38030006,1}},{17,{0,38030007,1}},{126,{0,38130001,1}},{42,{0,11020001,1}},{59,{0,18020001,1}},{252,{0,38040102,1}},{25,{0,38100001,1}},{84,{0,38190001,1}},{244,{0,17010001,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}},{244,{0,17010001,1}},{33,{0,38040010,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}}]','[{100,{0,38110002,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1007,5,'[{10,{0,1001010600,1}},{10,{0,1001020600,1}},{0,{0,1001030600,1}},{10,{0,1001040600,1}},{10,{0,1002010600,1}},{10,{0,1002020600,1}},{0,{0,1002030600,1}},{10,{0,1002040600,1}},{3,{0,1003000600,1}},{10,{0,1004010600,1}},{10,{0,1004020600,1}},{0,{0,1004030600,1}},{10,{0,1004040600,1}},{0,{0,1005000600,1}},{10,{0,1006010600,1}},{10,{0,1006020600,1}},{0,{0,1006030600,1}},{10,{0,1006040600,1}},{10,{0,1007010600,1}},{10,{0,1007020600,1}},{0,{0,1007030600,1}},{10,{0,1007040600,1}},{10,{0,1008010600,1}},{10,{0,1008020600,1}},{0,{0,1008030600,1}},{10,{0,1008040600,1}},{0,{0,1009000600,1}},{10,{0,1010010600,1}},{10,{0,1010020600,1}},{0,{0,1010030600,1}},{10,{0,1010040600,1}}]','[{10,{0,1001010610,1}},{10,{0,1001020610,1}},{0,{0,1001030610,1}},{10,{0,1001040610,1}},{10,{0,1002010610,1}},{10,{0,1002020610,1}},{0,{0,1002030610,1}},{10,{0,1002040610,1}},{3,{0,1003000610,1}},{10,{0,1004010610,1}},{10,{0,1004020610,1}},{0,{0,1004030610,1}},{10,{0,1004040610,1}},{0,{0,1005000610,1}},{10,{0,1006010610,1}},{10,{0,1006020610,1}},{0,{0,1006030610,1}},{10,{0,1006040610,1}},{10,{0,1007010610,1}},{10,{0,1007020610,1}},{0,{0,1007030610,1}},{10,{0,1007040610,1}},{10,{0,1008010610,1}},{10,{0,1008020610,1}},{0,{0,1008030610,1}},{10,{0,1008040610,1}},{0,{0,1009000610,1}},{10,{0,1010010610,1}},{10,{0,1010020610,1}},{0,{0,1010030610,1}},{10,{0,1010040610,1}}]','[{10,{0,1001010620,1}},{10,{0,1001020620,1}},{0,{0,1001030620,1}},{10,{0,1001040620,1}},{10,{0,1002010620,1}},{10,{0,1002020620,1}},{0,{0,1002030620,1}},{10,{0,1002040620,1}},{3,{0,1003000620,1}},{10,{0,1004010620,1}},{10,{0,1004020620,1}},{0,{0,1004030620,1}},{10,{0,1004040620,1}},{0,{0,1005000620,1}},{10,{0,1006010620,1}},{10,{0,1006020620,1}},{0,{0,1006030620,1}},{10,{0,1006040620,1}},{10,{0,1007010620,1}},{10,{0,1007020620,1}},{0,{0,1007030620,1}},{10,{0,1007040620,1}},{10,{0,1008010620,1}},{10,{0,1008020620,1}},{0,{0,1008030620,1}},{10,{0,1008040620,1}},{0,{0,1009000620,1}},{10,{0,1010010620,1}},{10,{0,1010020620,1}},{0,{0,1010030620,1}},{10,{0,1010040620,1}}]','[{10,{0,1001010631,1}},{10,{0,1001020631,1}},{0,{0,1001030631,1}},{10,{0,1001040631,1}},{10,{0,1002010631,1}},{10,{0,1002020631,1}},{0,{0,1002030631,1}},{10,{0,1002040631,1}},{3,{0,1003000631,1}},{10,{0,1004010631,1}},{10,{0,1004020631,1}},{0,{0,1004030631,1}},{10,{0,1004040631,1}},{0,{0,1005000631,1}},{10,{0,1006010631,1}},{10,{0,1006020631,1}},{0,{0,1006030631,1}},{10,{0,1006040631,1}},{10,{0,1007010631,1}},{10,{0,1007020631,1}},{0,{0,1007030631,1}},{10,{0,1007040631,1}},{10,{0,1008010631,1}},{10,{0,1008020631,1}},{0,{0,1008030631,1}},{10,{0,1008040631,1}},{0,{0,1009000631,1}},{10,{0,1010010631,1}},{10,{0,1010020631,1}},{0,{0,1010030631,1}},{10,{0,1010040631,1}}]','[{252,{0,17010001,1}},{17,{0,38030006,1}},{17,{0,38030007,1}},{126,{0,38130001,1}},{42,{0,11020001,1}},{59,{0,18020001,1}},{252,{0,38040102,1}},{25,{0,38100001,1}},{84,{0,38190001,1}},{244,{0,17010001,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}},{244,{0,17010001,1}},{33,{0,38040010,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}}]','[{100,{0,38110002,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1007,6,'[{10,{0,1001010600,1}},{10,{0,1001020600,1}},{0,{0,1001030600,1}},{10,{0,1001040600,1}},{10,{0,1002010600,1}},{10,{0,1002020600,1}},{0,{0,1002030600,1}},{10,{0,1002040600,1}},{3,{0,1003000600,1}},{10,{0,1004010600,1}},{10,{0,1004020600,1}},{0,{0,1004030600,1}},{10,{0,1004040600,1}},{0,{0,1005000600,1}},{10,{0,1006010600,1}},{10,{0,1006020600,1}},{0,{0,1006030600,1}},{10,{0,1006040600,1}},{10,{0,1007010600,1}},{10,{0,1007020600,1}},{0,{0,1007030600,1}},{10,{0,1007040600,1}},{10,{0,1008010600,1}},{10,{0,1008020600,1}},{0,{0,1008030600,1}},{10,{0,1008040600,1}},{0,{0,1009000600,1}},{10,{0,1010010600,1}},{10,{0,1010020600,1}},{0,{0,1010030600,1}},{10,{0,1010040600,1}}]','[{10,{0,1001010610,1}},{10,{0,1001020610,1}},{0,{0,1001030610,1}},{10,{0,1001040610,1}},{10,{0,1002010610,1}},{10,{0,1002020610,1}},{0,{0,1002030610,1}},{10,{0,1002040610,1}},{3,{0,1003000610,1}},{10,{0,1004010610,1}},{10,{0,1004020610,1}},{0,{0,1004030610,1}},{10,{0,1004040610,1}},{0,{0,1005000610,1}},{10,{0,1006010610,1}},{10,{0,1006020610,1}},{0,{0,1006030610,1}},{10,{0,1006040610,1}},{10,{0,1007010610,1}},{10,{0,1007020610,1}},{0,{0,1007030610,1}},{10,{0,1007040610,1}},{10,{0,1008010610,1}},{10,{0,1008020610,1}},{0,{0,1008030610,1}},{10,{0,1008040610,1}},{0,{0,1009000610,1}},{10,{0,1010010610,1}},{10,{0,1010020610,1}},{0,{0,1010030610,1}},{10,{0,1010040610,1}}]','[{10,{0,1001010620,1}},{10,{0,1001020620,1}},{0,{0,1001030620,1}},{10,{0,1001040620,1}},{10,{0,1002010620,1}},{10,{0,1002020620,1}},{0,{0,1002030620,1}},{10,{0,1002040620,1}},{3,{0,1003000620,1}},{10,{0,1004010620,1}},{10,{0,1004020620,1}},{0,{0,1004030620,1}},{10,{0,1004040620,1}},{0,{0,1005000620,1}},{10,{0,1006010620,1}},{10,{0,1006020620,1}},{0,{0,1006030620,1}},{10,{0,1006040620,1}},{10,{0,1007010620,1}},{10,{0,1007020620,1}},{0,{0,1007030620,1}},{10,{0,1007040620,1}},{10,{0,1008010620,1}},{10,{0,1008020620,1}},{0,{0,1008030620,1}},{10,{0,1008040620,1}},{0,{0,1009000620,1}},{10,{0,1010010620,1}},{10,{0,1010020620,1}},{0,{0,1010030620,1}},{10,{0,1010040620,1}}]','[{10,{0,1001010631,1}},{10,{0,1001020631,1}},{0,{0,1001030631,1}},{10,{0,1001040631,1}},{10,{0,1002010631,1}},{10,{0,1002020631,1}},{0,{0,1002030631,1}},{10,{0,1002040631,1}},{3,{0,1003000631,1}},{10,{0,1004010631,1}},{10,{0,1004020631,1}},{0,{0,1004030631,1}},{10,{0,1004040631,1}},{0,{0,1005000631,1}},{10,{0,1006010631,1}},{10,{0,1006020631,1}},{0,{0,1006030631,1}},{10,{0,1006040631,1}},{10,{0,1007010631,1}},{10,{0,1007020631,1}},{0,{0,1007030631,1}},{10,{0,1007040631,1}},{10,{0,1008010631,1}},{10,{0,1008020631,1}},{0,{0,1008030631,1}},{10,{0,1008040631,1}},{0,{0,1009000631,1}},{10,{0,1010010631,1}},{10,{0,1010020631,1}},{0,{0,1010030631,1}},{10,{0,1010040631,1}}]','[{252,{0,17010001,1}},{17,{0,38030006,1}},{17,{0,38030007,1}},{126,{0,38130001,1}},{42,{0,11020001,1}},{59,{0,18020001,1}},{252,{0,38040102,1}},{25,{0,38100001,1}},{84,{0,38190001,1}},{244,{0,17010001,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}},{244,{0,17010001,1}},{33,{0,38040010,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}}]','[{100,{0,38110002,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1007,7,'[{10,{0,1001010600,1}},{10,{0,1001020600,1}},{0,{0,1001030600,1}},{10,{0,1001040600,1}},{10,{0,1002010600,1}},{10,{0,1002020600,1}},{0,{0,1002030600,1}},{10,{0,1002040600,1}},{3,{0,1003000600,1}},{10,{0,1004010600,1}},{10,{0,1004020600,1}},{0,{0,1004030600,1}},{10,{0,1004040600,1}},{0,{0,1005000600,1}},{10,{0,1006010600,1}},{10,{0,1006020600,1}},{0,{0,1006030600,1}},{10,{0,1006040600,1}},{10,{0,1007010600,1}},{10,{0,1007020600,1}},{0,{0,1007030600,1}},{10,{0,1007040600,1}},{10,{0,1008010600,1}},{10,{0,1008020600,1}},{0,{0,1008030600,1}},{10,{0,1008040600,1}},{0,{0,1009000600,1}},{10,{0,1010010600,1}},{10,{0,1010020600,1}},{0,{0,1010030600,1}},{10,{0,1010040600,1}}]','[{10,{0,1001010610,1}},{10,{0,1001020610,1}},{0,{0,1001030610,1}},{10,{0,1001040610,1}},{10,{0,1002010610,1}},{10,{0,1002020610,1}},{0,{0,1002030610,1}},{10,{0,1002040610,1}},{3,{0,1003000610,1}},{10,{0,1004010610,1}},{10,{0,1004020610,1}},{0,{0,1004030610,1}},{10,{0,1004040610,1}},{0,{0,1005000610,1}},{10,{0,1006010610,1}},{10,{0,1006020610,1}},{0,{0,1006030610,1}},{10,{0,1006040610,1}},{10,{0,1007010610,1}},{10,{0,1007020610,1}},{0,{0,1007030610,1}},{10,{0,1007040610,1}},{10,{0,1008010610,1}},{10,{0,1008020610,1}},{0,{0,1008030610,1}},{10,{0,1008040610,1}},{0,{0,1009000610,1}},{10,{0,1010010610,1}},{10,{0,1010020610,1}},{0,{0,1010030610,1}},{10,{0,1010040610,1}}]','[{10,{0,1001010620,1}},{10,{0,1001020620,1}},{0,{0,1001030620,1}},{10,{0,1001040620,1}},{10,{0,1002010620,1}},{10,{0,1002020620,1}},{0,{0,1002030620,1}},{10,{0,1002040620,1}},{3,{0,1003000620,1}},{10,{0,1004010620,1}},{10,{0,1004020620,1}},{0,{0,1004030620,1}},{10,{0,1004040620,1}},{0,{0,1005000620,1}},{10,{0,1006010620,1}},{10,{0,1006020620,1}},{0,{0,1006030620,1}},{10,{0,1006040620,1}},{10,{0,1007010620,1}},{10,{0,1007020620,1}},{0,{0,1007030620,1}},{10,{0,1007040620,1}},{10,{0,1008010620,1}},{10,{0,1008020620,1}},{0,{0,1008030620,1}},{10,{0,1008040620,1}},{0,{0,1009000620,1}},{10,{0,1010010620,1}},{10,{0,1010020620,1}},{0,{0,1010030620,1}},{10,{0,1010040620,1}}]','[{10,{0,1001010631,1}},{10,{0,1001020631,1}},{0,{0,1001030631,1}},{10,{0,1001040631,1}},{10,{0,1002010631,1}},{10,{0,1002020631,1}},{0,{0,1002030631,1}},{10,{0,1002040631,1}},{3,{0,1003000631,1}},{10,{0,1004010631,1}},{10,{0,1004020631,1}},{0,{0,1004030631,1}},{10,{0,1004040631,1}},{0,{0,1005000631,1}},{10,{0,1006010631,1}},{10,{0,1006020631,1}},{0,{0,1006030631,1}},{10,{0,1006040631,1}},{10,{0,1007010631,1}},{10,{0,1007020631,1}},{0,{0,1007030631,1}},{10,{0,1007040631,1}},{10,{0,1008010631,1}},{10,{0,1008020631,1}},{0,{0,1008030631,1}},{10,{0,1008040631,1}},{0,{0,1009000631,1}},{10,{0,1010010631,1}},{10,{0,1010020631,1}},{0,{0,1010030631,1}},{10,{0,1010040631,1}}]','[{252,{0,17010001,1}},{17,{0,38030006,1}},{17,{0,38030007,1}},{126,{0,38130001,1}},{42,{0,11020001,1}},{59,{0,18020001,1}},{252,{0,38040102,1}},{25,{0,38100001,1}},{84,{0,38190001,1}},{244,{0,17010001,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}},{244,{0,17010001,1}},{33,{0,38040010,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}}]','[{100,{0,38110002,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1008,1,'[{10,{0,1001010600,1}},{10,{0,1001020600,1}},{0,{0,1001030600,1}},{10,{0,1001040600,1}},{10,{0,1002010600,1}},{10,{0,1002020600,1}},{0,{0,1002030600,1}},{10,{0,1002040600,1}},{3,{0,1003000600,1}},{10,{0,1004010600,1}},{10,{0,1004020600,1}},{0,{0,1004030600,1}},{10,{0,1004040600,1}},{0,{0,1005000600,1}},{10,{0,1006010600,1}},{10,{0,1006020600,1}},{0,{0,1006030600,1}},{10,{0,1006040600,1}},{10,{0,1007010600,1}},{10,{0,1007020600,1}},{0,{0,1007030600,1}},{10,{0,1007040600,1}},{10,{0,1008010600,1}},{10,{0,1008020600,1}},{0,{0,1008030600,1}},{10,{0,1008040600,1}},{0,{0,1009000600,1}},{10,{0,1010010600,1}},{10,{0,1010020600,1}},{0,{0,1010030600,1}},{10,{0,1010040600,1}}]','[{10,{0,1001010610,1}},{10,{0,1001020610,1}},{0,{0,1001030610,1}},{10,{0,1001040610,1}},{10,{0,1002010610,1}},{10,{0,1002020610,1}},{0,{0,1002030610,1}},{10,{0,1002040610,1}},{3,{0,1003000610,1}},{10,{0,1004010610,1}},{10,{0,1004020610,1}},{0,{0,1004030610,1}},{10,{0,1004040610,1}},{0,{0,1005000610,1}},{10,{0,1006010610,1}},{10,{0,1006020610,1}},{0,{0,1006030610,1}},{10,{0,1006040610,1}},{10,{0,1007010610,1}},{10,{0,1007020610,1}},{0,{0,1007030610,1}},{10,{0,1007040610,1}},{10,{0,1008010610,1}},{10,{0,1008020610,1}},{0,{0,1008030610,1}},{10,{0,1008040610,1}},{0,{0,1009000610,1}},{10,{0,1010010610,1}},{10,{0,1010020610,1}},{0,{0,1010030610,1}},{10,{0,1010040610,1}}]','[{10,{0,1001010620,1}},{10,{0,1001020620,1}},{0,{0,1001030620,1}},{10,{0,1001040620,1}},{10,{0,1002010620,1}},{10,{0,1002020620,1}},{0,{0,1002030620,1}},{10,{0,1002040620,1}},{3,{0,1003000620,1}},{10,{0,1004010620,1}},{10,{0,1004020620,1}},{0,{0,1004030620,1}},{10,{0,1004040620,1}},{0,{0,1005000620,1}},{10,{0,1006010620,1}},{10,{0,1006020620,1}},{0,{0,1006030620,1}},{10,{0,1006040620,1}},{10,{0,1007010620,1}},{10,{0,1007020620,1}},{0,{0,1007030620,1}},{10,{0,1007040620,1}},{10,{0,1008010620,1}},{10,{0,1008020620,1}},{0,{0,1008030620,1}},{10,{0,1008040620,1}},{0,{0,1009000620,1}},{10,{0,1010010620,1}},{10,{0,1010020620,1}},{0,{0,1010030620,1}},{10,{0,1010040620,1}}]','[{10,{0,1001010631,1}},{10,{0,1001020631,1}},{0,{0,1001030631,1}},{10,{0,1001040631,1}},{10,{0,1002010631,1}},{10,{0,1002020631,1}},{0,{0,1002030631,1}},{10,{0,1002040631,1}},{3,{0,1003000631,1}},{10,{0,1004010631,1}},{10,{0,1004020631,1}},{0,{0,1004030631,1}},{10,{0,1004040631,1}},{0,{0,1005000631,1}},{10,{0,1006010631,1}},{10,{0,1006020631,1}},{0,{0,1006030631,1}},{10,{0,1006040631,1}},{10,{0,1007010631,1}},{10,{0,1007020631,1}},{0,{0,1007030631,1}},{10,{0,1007040631,1}},{10,{0,1008010631,1}},{10,{0,1008020631,1}},{0,{0,1008030631,1}},{10,{0,1008040631,1}},{0,{0,1009000631,1}},{10,{0,1010010631,1}},{10,{0,1010020631,1}},{0,{0,1010030631,1}},{10,{0,1010040631,1}}]','[{252,{0,17010001,1}},{17,{0,38030006,1}},{17,{0,38030007,1}},{126,{0,38130001,1}},{42,{0,11020001,1}},{59,{0,18020001,1}},{252,{0,38040102,1}},{25,{0,38100001,1}},{84,{0,38190001,1}},{244,{0,17010001,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}},{244,{0,17010001,1}},{33,{0,38040010,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}}]','[{100,{0,38110002,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1008,2,'[{10,{0,1001010600,1}},{10,{0,1001020600,1}},{0,{0,1001030600,1}},{10,{0,1001040600,1}},{10,{0,1002010600,1}},{10,{0,1002020600,1}},{0,{0,1002030600,1}},{10,{0,1002040600,1}},{3,{0,1003000600,1}},{10,{0,1004010600,1}},{10,{0,1004020600,1}},{0,{0,1004030600,1}},{10,{0,1004040600,1}},{0,{0,1005000600,1}},{10,{0,1006010600,1}},{10,{0,1006020600,1}},{0,{0,1006030600,1}},{10,{0,1006040600,1}},{10,{0,1007010600,1}},{10,{0,1007020600,1}},{0,{0,1007030600,1}},{10,{0,1007040600,1}},{10,{0,1008010600,1}},{10,{0,1008020600,1}},{0,{0,1008030600,1}},{10,{0,1008040600,1}},{0,{0,1009000600,1}},{10,{0,1010010600,1}},{10,{0,1010020600,1}},{0,{0,1010030600,1}},{10,{0,1010040600,1}}]','[{10,{0,1001010610,1}},{10,{0,1001020610,1}},{0,{0,1001030610,1}},{10,{0,1001040610,1}},{10,{0,1002010610,1}},{10,{0,1002020610,1}},{0,{0,1002030610,1}},{10,{0,1002040610,1}},{3,{0,1003000610,1}},{10,{0,1004010610,1}},{10,{0,1004020610,1}},{0,{0,1004030610,1}},{10,{0,1004040610,1}},{0,{0,1005000610,1}},{10,{0,1006010610,1}},{10,{0,1006020610,1}},{0,{0,1006030610,1}},{10,{0,1006040610,1}},{10,{0,1007010610,1}},{10,{0,1007020610,1}},{0,{0,1007030610,1}},{10,{0,1007040610,1}},{10,{0,1008010610,1}},{10,{0,1008020610,1}},{0,{0,1008030610,1}},{10,{0,1008040610,1}},{0,{0,1009000610,1}},{10,{0,1010010610,1}},{10,{0,1010020610,1}},{0,{0,1010030610,1}},{10,{0,1010040610,1}}]','[{10,{0,1001010620,1}},{10,{0,1001020620,1}},{0,{0,1001030620,1}},{10,{0,1001040620,1}},{10,{0,1002010620,1}},{10,{0,1002020620,1}},{0,{0,1002030620,1}},{10,{0,1002040620,1}},{3,{0,1003000620,1}},{10,{0,1004010620,1}},{10,{0,1004020620,1}},{0,{0,1004030620,1}},{10,{0,1004040620,1}},{0,{0,1005000620,1}},{10,{0,1006010620,1}},{10,{0,1006020620,1}},{0,{0,1006030620,1}},{10,{0,1006040620,1}},{10,{0,1007010620,1}},{10,{0,1007020620,1}},{0,{0,1007030620,1}},{10,{0,1007040620,1}},{10,{0,1008010620,1}},{10,{0,1008020620,1}},{0,{0,1008030620,1}},{10,{0,1008040620,1}},{0,{0,1009000620,1}},{10,{0,1010010620,1}},{10,{0,1010020620,1}},{0,{0,1010030620,1}},{10,{0,1010040620,1}}]','[{10,{0,1001010631,1}},{10,{0,1001020631,1}},{0,{0,1001030631,1}},{10,{0,1001040631,1}},{10,{0,1002010631,1}},{10,{0,1002020631,1}},{0,{0,1002030631,1}},{10,{0,1002040631,1}},{3,{0,1003000631,1}},{10,{0,1004010631,1}},{10,{0,1004020631,1}},{0,{0,1004030631,1}},{10,{0,1004040631,1}},{0,{0,1005000631,1}},{10,{0,1006010631,1}},{10,{0,1006020631,1}},{0,{0,1006030631,1}},{10,{0,1006040631,1}},{10,{0,1007010631,1}},{10,{0,1007020631,1}},{0,{0,1007030631,1}},{10,{0,1007040631,1}},{10,{0,1008010631,1}},{10,{0,1008020631,1}},{0,{0,1008030631,1}},{10,{0,1008040631,1}},{0,{0,1009000631,1}},{10,{0,1010010631,1}},{10,{0,1010020631,1}},{0,{0,1010030631,1}},{10,{0,1010040631,1}}]','[{252,{0,17010001,1}},{17,{0,38030006,1}},{17,{0,38030007,1}},{126,{0,38130001,1}},{42,{0,11020001,1}},{59,{0,18020001,1}},{252,{0,38040102,1}},{25,{0,38100001,1}},{84,{0,38190001,1}},{244,{0,17010001,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}},{244,{0,17010001,1}},{33,{0,38040010,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}}]','[{100,{0,38110002,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1008,3,'[{10,{0,1001010700,1}},{10,{0,1001020700,1}},{0,{0,1001030700,1}},{10,{0,1001040700,1}},{10,{0,1002010700,1}},{10,{0,1002020700,1}},{0,{0,1002030700,1}},{10,{0,1002040700,1}},{3,{0,1003000700,1}},{10,{0,1004010700,1}},{10,{0,1004020700,1}},{0,{0,1004030700,1}},{10,{0,1004040700,1}},{0,{0,1005000700,1}},{10,{0,1006010700,1}},{10,{0,1006020700,1}},{0,{0,1006030700,1}},{10,{0,1006040700,1}},{10,{0,1007010700,1}},{10,{0,1007020700,1}},{0,{0,1007030700,1}},{10,{0,1007040700,1}},{10,{0,1008010700,1}},{10,{0,1008020700,1}},{0,{0,1008030700,1}},{10,{0,1008040700,1}},{0,{0,1009000700,1}},{10,{0,1010010700,1}},{10,{0,1010020700,1}},{0,{0,1010030700,1}},{10,{0,1010040700,1}}]','[{10,{0,1001010710,1}},{10,{0,1001020710,1}},{0,{0,1001030710,1}},{10,{0,1001040710,1}},{10,{0,1002010710,1}},{10,{0,1002020710,1}},{0,{0,1002030710,1}},{10,{0,1002040710,1}},{3,{0,1003000710,1}},{10,{0,1004010710,1}},{10,{0,1004020710,1}},{0,{0,1004030710,1}},{10,{0,1004040710,1}},{0,{0,1005000710,1}},{10,{0,1006010710,1}},{10,{0,1006020710,1}},{0,{0,1006030710,1}},{10,{0,1006040710,1}},{10,{0,1007010710,1}},{10,{0,1007020710,1}},{0,{0,1007030710,1}},{10,{0,1007040710,1}},{10,{0,1008010710,1}},{10,{0,1008020710,1}},{0,{0,1008030710,1}},{10,{0,1008040710,1}},{0,{0,1009000710,1}},{10,{0,1010010710,1}},{10,{0,1010020710,1}},{0,{0,1010030710,1}},{10,{0,1010040710,1}}]','[{10,{0,1001010720,1}},{10,{0,1001020720,1}},{0,{0,1001030720,1}},{10,{0,1001040720,1}},{10,{0,1002010720,1}},{10,{0,1002020720,1}},{0,{0,1002030720,1}},{10,{0,1002040720,1}},{3,{0,1003000720,1}},{10,{0,1004010720,1}},{10,{0,1004020720,1}},{0,{0,1004030720,1}},{10,{0,1004040720,1}},{0,{0,1005000720,1}},{10,{0,1006010720,1}},{10,{0,1006020720,1}},{0,{0,1006030720,1}},{10,{0,1006040720,1}},{10,{0,1007010720,1}},{10,{0,1007020720,1}},{0,{0,1007030720,1}},{10,{0,1007040720,1}},{10,{0,1008010720,1}},{10,{0,1008020720,1}},{0,{0,1008030720,1}},{10,{0,1008040720,1}},{0,{0,1009000720,1}},{10,{0,1010010720,1}},{10,{0,1010020720,1}},{0,{0,1010030720,1}},{10,{0,1010040720,1}}]','[{10,{0,1001010731,1}},{10,{0,1001020731,1}},{0,{0,1001030731,1}},{10,{0,1001040731,1}},{10,{0,1002010731,1}},{10,{0,1002020731,1}},{0,{0,1002030731,1}},{10,{0,1002040731,1}},{3,{0,1003000731,1}},{10,{0,1004010731,1}},{10,{0,1004020731,1}},{0,{0,1004030731,1}},{10,{0,1004040731,1}},{0,{0,1005000731,1}},{10,{0,1006010731,1}},{10,{0,1006020731,1}},{0,{0,1006030731,1}},{10,{0,1006040731,1}},{10,{0,1007010731,1}},{10,{0,1007020731,1}},{0,{0,1007030731,1}},{10,{0,1007040731,1}},{10,{0,1008010731,1}},{10,{0,1008020731,1}},{0,{0,1008030731,1}},{10,{0,1008040731,1}},{0,{0,1009000731,1}},{10,{0,1010010731,1}},{10,{0,1010020731,1}},{0,{0,1010030731,1}},{10,{0,1010040731,1}}]','[{252,{0,17010001,1}},{17,{0,38030006,1}},{17,{0,38030007,1}},{126,{0,38130001,1}},{42,{0,11020001,1}},{59,{0,18020001,1}},{252,{0,38040102,1}},{25,{0,38100001,1}},{84,{0,38190001,1}},{244,{0,17010001,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}},{244,{0,17010001,1}},{33,{0,38040010,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}}]','[{100,{0,38110002,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1008,4,'[{10,{0,1001010700,1}},{10,{0,1001020700,1}},{0,{0,1001030700,1}},{10,{0,1001040700,1}},{10,{0,1002010700,1}},{10,{0,1002020700,1}},{0,{0,1002030700,1}},{10,{0,1002040700,1}},{3,{0,1003000700,1}},{10,{0,1004010700,1}},{10,{0,1004020700,1}},{0,{0,1004030700,1}},{10,{0,1004040700,1}},{0,{0,1005000700,1}},{10,{0,1006010700,1}},{10,{0,1006020700,1}},{0,{0,1006030700,1}},{10,{0,1006040700,1}},{10,{0,1007010700,1}},{10,{0,1007020700,1}},{0,{0,1007030700,1}},{10,{0,1007040700,1}},{10,{0,1008010700,1}},{10,{0,1008020700,1}},{0,{0,1008030700,1}},{10,{0,1008040700,1}},{0,{0,1009000700,1}},{10,{0,1010010700,1}},{10,{0,1010020700,1}},{0,{0,1010030700,1}},{10,{0,1010040700,1}}]','[{10,{0,1001010710,1}},{10,{0,1001020710,1}},{0,{0,1001030710,1}},{10,{0,1001040710,1}},{10,{0,1002010710,1}},{10,{0,1002020710,1}},{0,{0,1002030710,1}},{10,{0,1002040710,1}},{3,{0,1003000710,1}},{10,{0,1004010710,1}},{10,{0,1004020710,1}},{0,{0,1004030710,1}},{10,{0,1004040710,1}},{0,{0,1005000710,1}},{10,{0,1006010710,1}},{10,{0,1006020710,1}},{0,{0,1006030710,1}},{10,{0,1006040710,1}},{10,{0,1007010710,1}},{10,{0,1007020710,1}},{0,{0,1007030710,1}},{10,{0,1007040710,1}},{10,{0,1008010710,1}},{10,{0,1008020710,1}},{0,{0,1008030710,1}},{10,{0,1008040710,1}},{0,{0,1009000710,1}},{10,{0,1010010710,1}},{10,{0,1010020710,1}},{0,{0,1010030710,1}},{10,{0,1010040710,1}}]','[{10,{0,1001010720,1}},{10,{0,1001020720,1}},{0,{0,1001030720,1}},{10,{0,1001040720,1}},{10,{0,1002010720,1}},{10,{0,1002020720,1}},{0,{0,1002030720,1}},{10,{0,1002040720,1}},{3,{0,1003000720,1}},{10,{0,1004010720,1}},{10,{0,1004020720,1}},{0,{0,1004030720,1}},{10,{0,1004040720,1}},{0,{0,1005000720,1}},{10,{0,1006010720,1}},{10,{0,1006020720,1}},{0,{0,1006030720,1}},{10,{0,1006040720,1}},{10,{0,1007010720,1}},{10,{0,1007020720,1}},{0,{0,1007030720,1}},{10,{0,1007040720,1}},{10,{0,1008010720,1}},{10,{0,1008020720,1}},{0,{0,1008030720,1}},{10,{0,1008040720,1}},{0,{0,1009000720,1}},{10,{0,1010010720,1}},{10,{0,1010020720,1}},{0,{0,1010030720,1}},{10,{0,1010040720,1}}]','[{10,{0,1001010731,1}},{10,{0,1001020731,1}},{0,{0,1001030731,1}},{10,{0,1001040731,1}},{10,{0,1002010731,1}},{10,{0,1002020731,1}},{0,{0,1002030731,1}},{10,{0,1002040731,1}},{3,{0,1003000731,1}},{10,{0,1004010731,1}},{10,{0,1004020731,1}},{0,{0,1004030731,1}},{10,{0,1004040731,1}},{0,{0,1005000731,1}},{10,{0,1006010731,1}},{10,{0,1006020731,1}},{0,{0,1006030731,1}},{10,{0,1006040731,1}},{10,{0,1007010731,1}},{10,{0,1007020731,1}},{0,{0,1007030731,1}},{10,{0,1007040731,1}},{10,{0,1008010731,1}},{10,{0,1008020731,1}},{0,{0,1008030731,1}},{10,{0,1008040731,1}},{0,{0,1009000731,1}},{10,{0,1010010731,1}},{10,{0,1010020731,1}},{0,{0,1010030731,1}},{10,{0,1010040731,1}}]','[{252,{0,17010001,1}},{17,{0,38030006,1}},{17,{0,38030007,1}},{126,{0,38130001,1}},{42,{0,11020001,1}},{59,{0,18020001,1}},{252,{0,38040102,1}},{25,{0,38100001,1}},{84,{0,38190001,1}},{244,{0,17010001,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}},{244,{0,17010001,1}},{33,{0,38040010,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}}]','[{100,{0,38110003,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1008,5,'[{10,{0,1001010700,1}},{10,{0,1001020700,1}},{0,{0,1001030700,1}},{10,{0,1001040700,1}},{10,{0,1002010700,1}},{10,{0,1002020700,1}},{0,{0,1002030700,1}},{10,{0,1002040700,1}},{3,{0,1003000700,1}},{10,{0,1004010700,1}},{10,{0,1004020700,1}},{0,{0,1004030700,1}},{10,{0,1004040700,1}},{0,{0,1005000700,1}},{10,{0,1006010700,1}},{10,{0,1006020700,1}},{0,{0,1006030700,1}},{10,{0,1006040700,1}},{10,{0,1007010700,1}},{10,{0,1007020700,1}},{0,{0,1007030700,1}},{10,{0,1007040700,1}},{10,{0,1008010700,1}},{10,{0,1008020700,1}},{0,{0,1008030700,1}},{10,{0,1008040700,1}},{0,{0,1009000700,1}},{10,{0,1010010700,1}},{10,{0,1010020700,1}},{0,{0,1010030700,1}},{10,{0,1010040700,1}}]','[{10,{0,1001010710,1}},{10,{0,1001020710,1}},{0,{0,1001030710,1}},{10,{0,1001040710,1}},{10,{0,1002010710,1}},{10,{0,1002020710,1}},{0,{0,1002030710,1}},{10,{0,1002040710,1}},{3,{0,1003000710,1}},{10,{0,1004010710,1}},{10,{0,1004020710,1}},{0,{0,1004030710,1}},{10,{0,1004040710,1}},{0,{0,1005000710,1}},{10,{0,1006010710,1}},{10,{0,1006020710,1}},{0,{0,1006030710,1}},{10,{0,1006040710,1}},{10,{0,1007010710,1}},{10,{0,1007020710,1}},{0,{0,1007030710,1}},{10,{0,1007040710,1}},{10,{0,1008010710,1}},{10,{0,1008020710,1}},{0,{0,1008030710,1}},{10,{0,1008040710,1}},{0,{0,1009000710,1}},{10,{0,1010010710,1}},{10,{0,1010020710,1}},{0,{0,1010030710,1}},{10,{0,1010040710,1}}]','[{10,{0,1001010720,1}},{10,{0,1001020720,1}},{0,{0,1001030720,1}},{10,{0,1001040720,1}},{10,{0,1002010720,1}},{10,{0,1002020720,1}},{0,{0,1002030720,1}},{10,{0,1002040720,1}},{3,{0,1003000720,1}},{10,{0,1004010720,1}},{10,{0,1004020720,1}},{0,{0,1004030720,1}},{10,{0,1004040720,1}},{0,{0,1005000720,1}},{10,{0,1006010720,1}},{10,{0,1006020720,1}},{0,{0,1006030720,1}},{10,{0,1006040720,1}},{10,{0,1007010720,1}},{10,{0,1007020720,1}},{0,{0,1007030720,1}},{10,{0,1007040720,1}},{10,{0,1008010720,1}},{10,{0,1008020720,1}},{0,{0,1008030720,1}},{10,{0,1008040720,1}},{0,{0,1009000720,1}},{10,{0,1010010720,1}},{10,{0,1010020720,1}},{0,{0,1010030720,1}},{10,{0,1010040720,1}}]','[{10,{0,1001010731,1}},{10,{0,1001020731,1}},{0,{0,1001030731,1}},{10,{0,1001040731,1}},{10,{0,1002010731,1}},{10,{0,1002020731,1}},{0,{0,1002030731,1}},{10,{0,1002040731,1}},{3,{0,1003000731,1}},{10,{0,1004010731,1}},{10,{0,1004020731,1}},{0,{0,1004030731,1}},{10,{0,1004040731,1}},{0,{0,1005000731,1}},{10,{0,1006010731,1}},{10,{0,1006020731,1}},{0,{0,1006030731,1}},{10,{0,1006040731,1}},{10,{0,1007010731,1}},{10,{0,1007020731,1}},{0,{0,1007030731,1}},{10,{0,1007040731,1}},{10,{0,1008010731,1}},{10,{0,1008020731,1}},{0,{0,1008030731,1}},{10,{0,1008040731,1}},{0,{0,1009000731,1}},{10,{0,1010010731,1}},{10,{0,1010020731,1}},{0,{0,1010030731,1}},{10,{0,1010040731,1}}]','[{252,{0,17010001,1}},{17,{0,38030006,1}},{17,{0,38030007,1}},{126,{0,38130001,1}},{42,{0,11020001,1}},{59,{0,18020001,1}},{252,{0,38040102,1}},{25,{0,38100001,1}},{84,{0,38190001,1}},{244,{0,17010001,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}},{244,{0,17010001,1}},{33,{0,38040010,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}}]','[{100,{0,38110003,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1008,6,'[{10,{0,1001010700,1}},{10,{0,1001020700,1}},{0,{0,1001030700,1}},{10,{0,1001040700,1}},{10,{0,1002010700,1}},{10,{0,1002020700,1}},{0,{0,1002030700,1}},{10,{0,1002040700,1}},{3,{0,1003000700,1}},{10,{0,1004010700,1}},{10,{0,1004020700,1}},{0,{0,1004030700,1}},{10,{0,1004040700,1}},{0,{0,1005000700,1}},{10,{0,1006010700,1}},{10,{0,1006020700,1}},{0,{0,1006030700,1}},{10,{0,1006040700,1}},{10,{0,1007010700,1}},{10,{0,1007020700,1}},{0,{0,1007030700,1}},{10,{0,1007040700,1}},{10,{0,1008010700,1}},{10,{0,1008020700,1}},{0,{0,1008030700,1}},{10,{0,1008040700,1}},{0,{0,1009000700,1}},{10,{0,1010010700,1}},{10,{0,1010020700,1}},{0,{0,1010030700,1}},{10,{0,1010040700,1}}]','[{10,{0,1001010710,1}},{10,{0,1001020710,1}},{0,{0,1001030710,1}},{10,{0,1001040710,1}},{10,{0,1002010710,1}},{10,{0,1002020710,1}},{0,{0,1002030710,1}},{10,{0,1002040710,1}},{3,{0,1003000710,1}},{10,{0,1004010710,1}},{10,{0,1004020710,1}},{0,{0,1004030710,1}},{10,{0,1004040710,1}},{0,{0,1005000710,1}},{10,{0,1006010710,1}},{10,{0,1006020710,1}},{0,{0,1006030710,1}},{10,{0,1006040710,1}},{10,{0,1007010710,1}},{10,{0,1007020710,1}},{0,{0,1007030710,1}},{10,{0,1007040710,1}},{10,{0,1008010710,1}},{10,{0,1008020710,1}},{0,{0,1008030710,1}},{10,{0,1008040710,1}},{0,{0,1009000710,1}},{10,{0,1010010710,1}},{10,{0,1010020710,1}},{0,{0,1010030710,1}},{10,{0,1010040710,1}}]','[{10,{0,1001010720,1}},{10,{0,1001020720,1}},{0,{0,1001030720,1}},{10,{0,1001040720,1}},{10,{0,1002010720,1}},{10,{0,1002020720,1}},{0,{0,1002030720,1}},{10,{0,1002040720,1}},{3,{0,1003000720,1}},{10,{0,1004010720,1}},{10,{0,1004020720,1}},{0,{0,1004030720,1}},{10,{0,1004040720,1}},{0,{0,1005000720,1}},{10,{0,1006010720,1}},{10,{0,1006020720,1}},{0,{0,1006030720,1}},{10,{0,1006040720,1}},{10,{0,1007010720,1}},{10,{0,1007020720,1}},{0,{0,1007030720,1}},{10,{0,1007040720,1}},{10,{0,1008010720,1}},{10,{0,1008020720,1}},{0,{0,1008030720,1}},{10,{0,1008040720,1}},{0,{0,1009000720,1}},{10,{0,1010010720,1}},{10,{0,1010020720,1}},{0,{0,1010030720,1}},{10,{0,1010040720,1}}]','[{10,{0,1001010731,1}},{10,{0,1001020731,1}},{0,{0,1001030731,1}},{10,{0,1001040731,1}},{10,{0,1002010731,1}},{10,{0,1002020731,1}},{0,{0,1002030731,1}},{10,{0,1002040731,1}},{3,{0,1003000731,1}},{10,{0,1004010731,1}},{10,{0,1004020731,1}},{0,{0,1004030731,1}},{10,{0,1004040731,1}},{0,{0,1005000731,1}},{10,{0,1006010731,1}},{10,{0,1006020731,1}},{0,{0,1006030731,1}},{10,{0,1006040731,1}},{10,{0,1007010731,1}},{10,{0,1007020731,1}},{0,{0,1007030731,1}},{10,{0,1007040731,1}},{10,{0,1008010731,1}},{10,{0,1008020731,1}},{0,{0,1008030731,1}},{10,{0,1008040731,1}},{0,{0,1009000731,1}},{10,{0,1010010731,1}},{10,{0,1010020731,1}},{0,{0,1010030731,1}},{10,{0,1010040731,1}}]','[{252,{0,17010001,1}},{17,{0,38030006,1}},{17,{0,38030007,1}},{126,{0,38130001,1}},{42,{0,11020001,1}},{59,{0,18020001,1}},{252,{0,38040102,1}},{25,{0,38100001,1}},{84,{0,38190001,1}},{244,{0,17010001,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}},{244,{0,17010001,1}},{33,{0,38040010,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}}]','[{100,{0,38110003,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1008,7,'[{10,{0,1001010700,1}},{10,{0,1001020700,1}},{0,{0,1001030700,1}},{10,{0,1001040700,1}},{10,{0,1002010700,1}},{10,{0,1002020700,1}},{0,{0,1002030700,1}},{10,{0,1002040700,1}},{3,{0,1003000700,1}},{10,{0,1004010700,1}},{10,{0,1004020700,1}},{0,{0,1004030700,1}},{10,{0,1004040700,1}},{0,{0,1005000700,1}},{10,{0,1006010700,1}},{10,{0,1006020700,1}},{0,{0,1006030700,1}},{10,{0,1006040700,1}},{10,{0,1007010700,1}},{10,{0,1007020700,1}},{0,{0,1007030700,1}},{10,{0,1007040700,1}},{10,{0,1008010700,1}},{10,{0,1008020700,1}},{0,{0,1008030700,1}},{10,{0,1008040700,1}},{0,{0,1009000700,1}},{10,{0,1010010700,1}},{10,{0,1010020700,1}},{0,{0,1010030700,1}},{10,{0,1010040700,1}}]','[{10,{0,1001010710,1}},{10,{0,1001020710,1}},{0,{0,1001030710,1}},{10,{0,1001040710,1}},{10,{0,1002010710,1}},{10,{0,1002020710,1}},{0,{0,1002030710,1}},{10,{0,1002040710,1}},{3,{0,1003000710,1}},{10,{0,1004010710,1}},{10,{0,1004020710,1}},{0,{0,1004030710,1}},{10,{0,1004040710,1}},{0,{0,1005000710,1}},{10,{0,1006010710,1}},{10,{0,1006020710,1}},{0,{0,1006030710,1}},{10,{0,1006040710,1}},{10,{0,1007010710,1}},{10,{0,1007020710,1}},{0,{0,1007030710,1}},{10,{0,1007040710,1}},{10,{0,1008010710,1}},{10,{0,1008020710,1}},{0,{0,1008030710,1}},{10,{0,1008040710,1}},{0,{0,1009000710,1}},{10,{0,1010010710,1}},{10,{0,1010020710,1}},{0,{0,1010030710,1}},{10,{0,1010040710,1}}]','[{10,{0,1001010720,1}},{10,{0,1001020720,1}},{0,{0,1001030720,1}},{10,{0,1001040720,1}},{10,{0,1002010720,1}},{10,{0,1002020720,1}},{0,{0,1002030720,1}},{10,{0,1002040720,1}},{3,{0,1003000720,1}},{10,{0,1004010720,1}},{10,{0,1004020720,1}},{0,{0,1004030720,1}},{10,{0,1004040720,1}},{0,{0,1005000720,1}},{10,{0,1006010720,1}},{10,{0,1006020720,1}},{0,{0,1006030720,1}},{10,{0,1006040720,1}},{10,{0,1007010720,1}},{10,{0,1007020720,1}},{0,{0,1007030720,1}},{10,{0,1007040720,1}},{10,{0,1008010720,1}},{10,{0,1008020720,1}},{0,{0,1008030720,1}},{10,{0,1008040720,1}},{0,{0,1009000720,1}},{10,{0,1010010720,1}},{10,{0,1010020720,1}},{0,{0,1010030720,1}},{10,{0,1010040720,1}}]','[{10,{0,1001010731,1}},{10,{0,1001020731,1}},{0,{0,1001030731,1}},{10,{0,1001040731,1}},{10,{0,1002010731,1}},{10,{0,1002020731,1}},{0,{0,1002030731,1}},{10,{0,1002040731,1}},{3,{0,1003000731,1}},{10,{0,1004010731,1}},{10,{0,1004020731,1}},{0,{0,1004030731,1}},{10,{0,1004040731,1}},{0,{0,1005000731,1}},{10,{0,1006010731,1}},{10,{0,1006020731,1}},{0,{0,1006030731,1}},{10,{0,1006040731,1}},{10,{0,1007010731,1}},{10,{0,1007020731,1}},{0,{0,1007030731,1}},{10,{0,1007040731,1}},{10,{0,1008010731,1}},{10,{0,1008020731,1}},{0,{0,1008030731,1}},{10,{0,1008040731,1}},{0,{0,1009000731,1}},{10,{0,1010010731,1}},{10,{0,1010020731,1}},{0,{0,1010030731,1}},{10,{0,1010040731,1}}]','[{252,{0,17010001,1}},{17,{0,38030006,1}},{17,{0,38030007,1}},{126,{0,38130001,1}},{42,{0,11020001,1}},{59,{0,18020001,1}},{252,{0,38040102,1}},{25,{0,38100001,1}},{84,{0,38190001,1}},{244,{0,17010001,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}},{244,{0,17010001,1}},{33,{0,38040010,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}}]','[{100,{0,38110003,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1008,8,'[{10,{0,1001010700,1}},{10,{0,1001020700,1}},{0,{0,1001030700,1}},{10,{0,1001040700,1}},{10,{0,1002010700,1}},{10,{0,1002020700,1}},{0,{0,1002030700,1}},{10,{0,1002040700,1}},{3,{0,1003000700,1}},{10,{0,1004010700,1}},{10,{0,1004020700,1}},{0,{0,1004030700,1}},{10,{0,1004040700,1}},{0,{0,1005000700,1}},{10,{0,1006010700,1}},{10,{0,1006020700,1}},{0,{0,1006030700,1}},{10,{0,1006040700,1}},{10,{0,1007010700,1}},{10,{0,1007020700,1}},{0,{0,1007030700,1}},{10,{0,1007040700,1}},{10,{0,1008010700,1}},{10,{0,1008020700,1}},{0,{0,1008030700,1}},{10,{0,1008040700,1}},{0,{0,1009000700,1}},{10,{0,1010010700,1}},{10,{0,1010020700,1}},{0,{0,1010030700,1}},{10,{0,1010040700,1}}]','[{10,{0,1001010710,1}},{10,{0,1001020710,1}},{0,{0,1001030710,1}},{10,{0,1001040710,1}},{10,{0,1002010710,1}},{10,{0,1002020710,1}},{0,{0,1002030710,1}},{10,{0,1002040710,1}},{3,{0,1003000710,1}},{10,{0,1004010710,1}},{10,{0,1004020710,1}},{0,{0,1004030710,1}},{10,{0,1004040710,1}},{0,{0,1005000710,1}},{10,{0,1006010710,1}},{10,{0,1006020710,1}},{0,{0,1006030710,1}},{10,{0,1006040710,1}},{10,{0,1007010710,1}},{10,{0,1007020710,1}},{0,{0,1007030710,1}},{10,{0,1007040710,1}},{10,{0,1008010710,1}},{10,{0,1008020710,1}},{0,{0,1008030710,1}},{10,{0,1008040710,1}},{0,{0,1009000710,1}},{10,{0,1010010710,1}},{10,{0,1010020710,1}},{0,{0,1010030710,1}},{10,{0,1010040710,1}}]','[{10,{0,1001010720,1}},{10,{0,1001020720,1}},{0,{0,1001030720,1}},{10,{0,1001040720,1}},{10,{0,1002010720,1}},{10,{0,1002020720,1}},{0,{0,1002030720,1}},{10,{0,1002040720,1}},{3,{0,1003000720,1}},{10,{0,1004010720,1}},{10,{0,1004020720,1}},{0,{0,1004030720,1}},{10,{0,1004040720,1}},{0,{0,1005000720,1}},{10,{0,1006010720,1}},{10,{0,1006020720,1}},{0,{0,1006030720,1}},{10,{0,1006040720,1}},{10,{0,1007010720,1}},{10,{0,1007020720,1}},{0,{0,1007030720,1}},{10,{0,1007040720,1}},{10,{0,1008010720,1}},{10,{0,1008020720,1}},{0,{0,1008030720,1}},{10,{0,1008040720,1}},{0,{0,1009000720,1}},{10,{0,1010010720,1}},{10,{0,1010020720,1}},{0,{0,1010030720,1}},{10,{0,1010040720,1}}]','[{10,{0,1001010731,1}},{10,{0,1001020731,1}},{0,{0,1001030731,1}},{10,{0,1001040731,1}},{10,{0,1002010731,1}},{10,{0,1002020731,1}},{0,{0,1002030731,1}},{10,{0,1002040731,1}},{3,{0,1003000731,1}},{10,{0,1004010731,1}},{10,{0,1004020731,1}},{0,{0,1004030731,1}},{10,{0,1004040731,1}},{0,{0,1005000731,1}},{10,{0,1006010731,1}},{10,{0,1006020731,1}},{0,{0,1006030731,1}},{10,{0,1006040731,1}},{10,{0,1007010731,1}},{10,{0,1007020731,1}},{0,{0,1007030731,1}},{10,{0,1007040731,1}},{10,{0,1008010731,1}},{10,{0,1008020731,1}},{0,{0,1008030731,1}},{10,{0,1008040731,1}},{0,{0,1009000731,1}},{10,{0,1010010731,1}},{10,{0,1010020731,1}},{0,{0,1010030731,1}},{10,{0,1010040731,1}}]','[{252,{0,17010001,1}},{17,{0,38030006,1}},{17,{0,38030007,1}},{126,{0,38130001,1}},{42,{0,11020001,1}},{59,{0,18020001,1}},{252,{0,38040102,1}},{25,{0,38100001,1}},{84,{0,38190001,1}},{244,{0,17010001,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}},{244,{0,17010001,1}},{33,{0,38040010,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}}]','[{100,{0,38110003,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1009,1,'[{10,{0,1001010800,1}},{10,{0,1001020800,1}},{0,{0,1001030800,1}},{10,{0,1001040800,1}},{10,{0,1002010800,1}},{10,{0,1002020800,1}},{0,{0,1002030800,1}},{10,{0,1002040800,1}},{3,{0,1003000800,1}},{10,{0,1004010800,1}},{10,{0,1004020800,1}},{0,{0,1004030800,1}},{10,{0,1004040800,1}},{0,{0,1005000800,1}},{10,{0,1006010800,1}},{10,{0,1006020800,1}},{0,{0,1006030800,1}},{10,{0,1006040800,1}},{10,{0,1007010800,1}},{10,{0,1007020800,1}},{0,{0,1007030800,1}},{10,{0,1007040800,1}},{10,{0,1008010800,1}},{10,{0,1008020800,1}},{0,{0,1008030800,1}},{10,{0,1008040800,1}},{0,{0,1009000800,1}},{10,{0,1010010800,1}},{10,{0,1010020800,1}},{0,{0,1010030800,1}},{10,{0,1010040800,1}}]','[{10,{0,1001010810,1}},{10,{0,1001020810,1}},{0,{0,1001030810,1}},{10,{0,1001040810,1}},{10,{0,1002010810,1}},{10,{0,1002020810,1}},{0,{0,1002030810,1}},{10,{0,1002040810,1}},{3,{0,1003000810,1}},{10,{0,1004010810,1}},{10,{0,1004020810,1}},{0,{0,1004030810,1}},{10,{0,1004040810,1}},{0,{0,1005000810,1}},{10,{0,1006010810,1}},{10,{0,1006020810,1}},{0,{0,1006030810,1}},{10,{0,1006040810,1}},{10,{0,1007010810,1}},{10,{0,1007020810,1}},{0,{0,1007030810,1}},{10,{0,1007040810,1}},{10,{0,1008010810,1}},{10,{0,1008020810,1}},{0,{0,1008030810,1}},{10,{0,1008040810,1}},{0,{0,1009000810,1}},{10,{0,1010010810,1}},{10,{0,1010020810,1}},{0,{0,1010030810,1}},{10,{0,1010040810,1}}]','[{10,{0,1001010820,1}},{10,{0,1001020820,1}},{0,{0,1001030820,1}},{10,{0,1001040820,1}},{10,{0,1002010820,1}},{10,{0,1002020820,1}},{0,{0,1002030820,1}},{10,{0,1002040820,1}},{3,{0,1003000820,1}},{10,{0,1004010820,1}},{10,{0,1004020820,1}},{0,{0,1004030820,1}},{10,{0,1004040820,1}},{0,{0,1005000820,1}},{10,{0,1006010820,1}},{10,{0,1006020820,1}},{0,{0,1006030820,1}},{10,{0,1006040820,1}},{10,{0,1007010820,1}},{10,{0,1007020820,1}},{0,{0,1007030820,1}},{10,{0,1007040820,1}},{10,{0,1008010820,1}},{10,{0,1008020820,1}},{0,{0,1008030820,1}},{10,{0,1008040820,1}},{0,{0,1009000820,1}},{10,{0,1010010820,1}},{10,{0,1010020820,1}},{0,{0,1010030820,1}},{10,{0,1010040820,1}}]','[{10,{0,1001010831,1}},{10,{0,1001020831,1}},{0,{0,1001030831,1}},{10,{0,1001040831,1}},{10,{0,1002010831,1}},{10,{0,1002020831,1}},{0,{0,1002030831,1}},{10,{0,1002040831,1}},{3,{0,1003000831,1}},{10,{0,1004010831,1}},{10,{0,1004020831,1}},{0,{0,1004030831,1}},{10,{0,1004040831,1}},{0,{0,1005000831,1}},{10,{0,1006010831,1}},{10,{0,1006020831,1}},{0,{0,1006030831,1}},{10,{0,1006040831,1}},{10,{0,1007010831,1}},{10,{0,1007020831,1}},{0,{0,1007030831,1}},{10,{0,1007040831,1}},{10,{0,1008010831,1}},{10,{0,1008020831,1}},{0,{0,1008030831,1}},{10,{0,1008040831,1}},{0,{0,1009000831,1}},{10,{0,1010010831,1}},{10,{0,1010020831,1}},{0,{0,1010030831,1}},{10,{0,1010040831,1}}]','[{252,{0,17010001,1}},{17,{0,38030006,1}},{17,{0,38030007,1}},{126,{0,38130001,1}},{42,{0,11020001,1}},{59,{0,18020001,1}},{252,{0,38040102,1}},{25,{0,38100001,1}},{84,{0,38190001,1}},{244,{0,17010001,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}},{244,{0,17010001,1}},{33,{0,38040010,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}}]','[{100,{0,38110003,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1009,2,'[{10,{0,1001010800,1}},{10,{0,1001020800,1}},{0,{0,1001030800,1}},{10,{0,1001040800,1}},{10,{0,1002010800,1}},{10,{0,1002020800,1}},{0,{0,1002030800,1}},{10,{0,1002040800,1}},{3,{0,1003000800,1}},{10,{0,1004010800,1}},{10,{0,1004020800,1}},{0,{0,1004030800,1}},{10,{0,1004040800,1}},{0,{0,1005000800,1}},{10,{0,1006010800,1}},{10,{0,1006020800,1}},{0,{0,1006030800,1}},{10,{0,1006040800,1}},{10,{0,1007010800,1}},{10,{0,1007020800,1}},{0,{0,1007030800,1}},{10,{0,1007040800,1}},{10,{0,1008010800,1}},{10,{0,1008020800,1}},{0,{0,1008030800,1}},{10,{0,1008040800,1}},{0,{0,1009000800,1}},{10,{0,1010010800,1}},{10,{0,1010020800,1}},{0,{0,1010030800,1}},{10,{0,1010040800,1}}]','[{10,{0,1001010810,1}},{10,{0,1001020810,1}},{0,{0,1001030810,1}},{10,{0,1001040810,1}},{10,{0,1002010810,1}},{10,{0,1002020810,1}},{0,{0,1002030810,1}},{10,{0,1002040810,1}},{3,{0,1003000810,1}},{10,{0,1004010810,1}},{10,{0,1004020810,1}},{0,{0,1004030810,1}},{10,{0,1004040810,1}},{0,{0,1005000810,1}},{10,{0,1006010810,1}},{10,{0,1006020810,1}},{0,{0,1006030810,1}},{10,{0,1006040810,1}},{10,{0,1007010810,1}},{10,{0,1007020810,1}},{0,{0,1007030810,1}},{10,{0,1007040810,1}},{10,{0,1008010810,1}},{10,{0,1008020810,1}},{0,{0,1008030810,1}},{10,{0,1008040810,1}},{0,{0,1009000810,1}},{10,{0,1010010810,1}},{10,{0,1010020810,1}},{0,{0,1010030810,1}},{10,{0,1010040810,1}}]','[{10,{0,1001010820,1}},{10,{0,1001020820,1}},{0,{0,1001030820,1}},{10,{0,1001040820,1}},{10,{0,1002010820,1}},{10,{0,1002020820,1}},{0,{0,1002030820,1}},{10,{0,1002040820,1}},{3,{0,1003000820,1}},{10,{0,1004010820,1}},{10,{0,1004020820,1}},{0,{0,1004030820,1}},{10,{0,1004040820,1}},{0,{0,1005000820,1}},{10,{0,1006010820,1}},{10,{0,1006020820,1}},{0,{0,1006030820,1}},{10,{0,1006040820,1}},{10,{0,1007010820,1}},{10,{0,1007020820,1}},{0,{0,1007030820,1}},{10,{0,1007040820,1}},{10,{0,1008010820,1}},{10,{0,1008020820,1}},{0,{0,1008030820,1}},{10,{0,1008040820,1}},{0,{0,1009000820,1}},{10,{0,1010010820,1}},{10,{0,1010020820,1}},{0,{0,1010030820,1}},{10,{0,1010040820,1}}]','[{10,{0,1001010831,1}},{10,{0,1001020831,1}},{0,{0,1001030831,1}},{10,{0,1001040831,1}},{10,{0,1002010831,1}},{10,{0,1002020831,1}},{0,{0,1002030831,1}},{10,{0,1002040831,1}},{3,{0,1003000831,1}},{10,{0,1004010831,1}},{10,{0,1004020831,1}},{0,{0,1004030831,1}},{10,{0,1004040831,1}},{0,{0,1005000831,1}},{10,{0,1006010831,1}},{10,{0,1006020831,1}},{0,{0,1006030831,1}},{10,{0,1006040831,1}},{10,{0,1007010831,1}},{10,{0,1007020831,1}},{0,{0,1007030831,1}},{10,{0,1007040831,1}},{10,{0,1008010831,1}},{10,{0,1008020831,1}},{0,{0,1008030831,1}},{10,{0,1008040831,1}},{0,{0,1009000831,1}},{10,{0,1010010831,1}},{10,{0,1010020831,1}},{0,{0,1010030831,1}},{10,{0,1010040831,1}}]','[{252,{0,17010001,1}},{17,{0,38030006,1}},{17,{0,38030007,1}},{126,{0,38130001,1}},{42,{0,11020001,1}},{59,{0,18020001,1}},{252,{0,38040102,1}},{25,{0,38100001,1}},{84,{0,38190001,1}},{244,{0,17010001,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}},{244,{0,17010001,1}},{33,{0,38040010,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}}]','[{100,{0,38110003,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1009,3,'[{10,{0,1001010800,1}},{10,{0,1001020800,1}},{0,{0,1001030800,1}},{10,{0,1001040800,1}},{10,{0,1002010800,1}},{10,{0,1002020800,1}},{0,{0,1002030800,1}},{10,{0,1002040800,1}},{3,{0,1003000800,1}},{10,{0,1004010800,1}},{10,{0,1004020800,1}},{0,{0,1004030800,1}},{10,{0,1004040800,1}},{0,{0,1005000800,1}},{10,{0,1006010800,1}},{10,{0,1006020800,1}},{0,{0,1006030800,1}},{10,{0,1006040800,1}},{10,{0,1007010800,1}},{10,{0,1007020800,1}},{0,{0,1007030800,1}},{10,{0,1007040800,1}},{10,{0,1008010800,1}},{10,{0,1008020800,1}},{0,{0,1008030800,1}},{10,{0,1008040800,1}},{0,{0,1009000800,1}},{10,{0,1010010800,1}},{10,{0,1010020800,1}},{0,{0,1010030800,1}},{10,{0,1010040800,1}}]','[{10,{0,1001010810,1}},{10,{0,1001020810,1}},{0,{0,1001030810,1}},{10,{0,1001040810,1}},{10,{0,1002010810,1}},{10,{0,1002020810,1}},{0,{0,1002030810,1}},{10,{0,1002040810,1}},{3,{0,1003000810,1}},{10,{0,1004010810,1}},{10,{0,1004020810,1}},{0,{0,1004030810,1}},{10,{0,1004040810,1}},{0,{0,1005000810,1}},{10,{0,1006010810,1}},{10,{0,1006020810,1}},{0,{0,1006030810,1}},{10,{0,1006040810,1}},{10,{0,1007010810,1}},{10,{0,1007020810,1}},{0,{0,1007030810,1}},{10,{0,1007040810,1}},{10,{0,1008010810,1}},{10,{0,1008020810,1}},{0,{0,1008030810,1}},{10,{0,1008040810,1}},{0,{0,1009000810,1}},{10,{0,1010010810,1}},{10,{0,1010020810,1}},{0,{0,1010030810,1}},{10,{0,1010040810,1}}]','[{10,{0,1001010820,1}},{10,{0,1001020820,1}},{0,{0,1001030820,1}},{10,{0,1001040820,1}},{10,{0,1002010820,1}},{10,{0,1002020820,1}},{0,{0,1002030820,1}},{10,{0,1002040820,1}},{3,{0,1003000820,1}},{10,{0,1004010820,1}},{10,{0,1004020820,1}},{0,{0,1004030820,1}},{10,{0,1004040820,1}},{0,{0,1005000820,1}},{10,{0,1006010820,1}},{10,{0,1006020820,1}},{0,{0,1006030820,1}},{10,{0,1006040820,1}},{10,{0,1007010820,1}},{10,{0,1007020820,1}},{0,{0,1007030820,1}},{10,{0,1007040820,1}},{10,{0,1008010820,1}},{10,{0,1008020820,1}},{0,{0,1008030820,1}},{10,{0,1008040820,1}},{0,{0,1009000820,1}},{10,{0,1010010820,1}},{10,{0,1010020820,1}},{0,{0,1010030820,1}},{10,{0,1010040820,1}}]','[{10,{0,1001010831,1}},{10,{0,1001020831,1}},{0,{0,1001030831,1}},{10,{0,1001040831,1}},{10,{0,1002010831,1}},{10,{0,1002020831,1}},{0,{0,1002030831,1}},{10,{0,1002040831,1}},{3,{0,1003000831,1}},{10,{0,1004010831,1}},{10,{0,1004020831,1}},{0,{0,1004030831,1}},{10,{0,1004040831,1}},{0,{0,1005000831,1}},{10,{0,1006010831,1}},{10,{0,1006020831,1}},{0,{0,1006030831,1}},{10,{0,1006040831,1}},{10,{0,1007010831,1}},{10,{0,1007020831,1}},{0,{0,1007030831,1}},{10,{0,1007040831,1}},{10,{0,1008010831,1}},{10,{0,1008020831,1}},{0,{0,1008030831,1}},{10,{0,1008040831,1}},{0,{0,1009000831,1}},{10,{0,1010010831,1}},{10,{0,1010020831,1}},{0,{0,1010030831,1}},{10,{0,1010040831,1}}]','[{252,{0,17010001,1}},{17,{0,38030006,1}},{17,{0,38030007,1}},{126,{0,38130001,1}},{42,{0,11020001,1}},{59,{0,18020001,1}},{252,{0,38040102,1}},{25,{0,38100001,1}},{84,{0,38190001,1}},{244,{0,17010001,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}},{244,{0,17010001,1}},{33,{0,38040010,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}}]','[{100,{0,38110003,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1009,4,'[{10,{0,1001010800,1}},{10,{0,1001020800,1}},{0,{0,1001030800,1}},{10,{0,1001040800,1}},{10,{0,1002010800,1}},{10,{0,1002020800,1}},{0,{0,1002030800,1}},{10,{0,1002040800,1}},{3,{0,1003000800,1}},{10,{0,1004010800,1}},{10,{0,1004020800,1}},{0,{0,1004030800,1}},{10,{0,1004040800,1}},{0,{0,1005000800,1}},{10,{0,1006010800,1}},{10,{0,1006020800,1}},{0,{0,1006030800,1}},{10,{0,1006040800,1}},{10,{0,1007010800,1}},{10,{0,1007020800,1}},{0,{0,1007030800,1}},{10,{0,1007040800,1}},{10,{0,1008010800,1}},{10,{0,1008020800,1}},{0,{0,1008030800,1}},{10,{0,1008040800,1}},{0,{0,1009000800,1}},{10,{0,1010010800,1}},{10,{0,1010020800,1}},{0,{0,1010030800,1}},{10,{0,1010040800,1}}]','[{10,{0,1001010810,1}},{10,{0,1001020810,1}},{0,{0,1001030810,1}},{10,{0,1001040810,1}},{10,{0,1002010810,1}},{10,{0,1002020810,1}},{0,{0,1002030810,1}},{10,{0,1002040810,1}},{3,{0,1003000810,1}},{10,{0,1004010810,1}},{10,{0,1004020810,1}},{0,{0,1004030810,1}},{10,{0,1004040810,1}},{0,{0,1005000810,1}},{10,{0,1006010810,1}},{10,{0,1006020810,1}},{0,{0,1006030810,1}},{10,{0,1006040810,1}},{10,{0,1007010810,1}},{10,{0,1007020810,1}},{0,{0,1007030810,1}},{10,{0,1007040810,1}},{10,{0,1008010810,1}},{10,{0,1008020810,1}},{0,{0,1008030810,1}},{10,{0,1008040810,1}},{0,{0,1009000810,1}},{10,{0,1010010810,1}},{10,{0,1010020810,1}},{0,{0,1010030810,1}},{10,{0,1010040810,1}}]','[{10,{0,1001010820,1}},{10,{0,1001020820,1}},{0,{0,1001030820,1}},{10,{0,1001040820,1}},{10,{0,1002010820,1}},{10,{0,1002020820,1}},{0,{0,1002030820,1}},{10,{0,1002040820,1}},{3,{0,1003000820,1}},{10,{0,1004010820,1}},{10,{0,1004020820,1}},{0,{0,1004030820,1}},{10,{0,1004040820,1}},{0,{0,1005000820,1}},{10,{0,1006010820,1}},{10,{0,1006020820,1}},{0,{0,1006030820,1}},{10,{0,1006040820,1}},{10,{0,1007010820,1}},{10,{0,1007020820,1}},{0,{0,1007030820,1}},{10,{0,1007040820,1}},{10,{0,1008010820,1}},{10,{0,1008020820,1}},{0,{0,1008030820,1}},{10,{0,1008040820,1}},{0,{0,1009000820,1}},{10,{0,1010010820,1}},{10,{0,1010020820,1}},{0,{0,1010030820,1}},{10,{0,1010040820,1}}]','[{10,{0,1001010831,1}},{10,{0,1001020831,1}},{0,{0,1001030831,1}},{10,{0,1001040831,1}},{10,{0,1002010831,1}},{10,{0,1002020831,1}},{0,{0,1002030831,1}},{10,{0,1002040831,1}},{3,{0,1003000831,1}},{10,{0,1004010831,1}},{10,{0,1004020831,1}},{0,{0,1004030831,1}},{10,{0,1004040831,1}},{0,{0,1005000831,1}},{10,{0,1006010831,1}},{10,{0,1006020831,1}},{0,{0,1006030831,1}},{10,{0,1006040831,1}},{10,{0,1007010831,1}},{10,{0,1007020831,1}},{0,{0,1007030831,1}},{10,{0,1007040831,1}},{10,{0,1008010831,1}},{10,{0,1008020831,1}},{0,{0,1008030831,1}},{10,{0,1008040831,1}},{0,{0,1009000831,1}},{10,{0,1010010831,1}},{10,{0,1010020831,1}},{0,{0,1010030831,1}},{10,{0,1010040831,1}}]','[{252,{0,17010001,1}},{17,{0,38030006,1}},{17,{0,38030007,1}},{126,{0,38130001,1}},{42,{0,11020001,1}},{59,{0,18020001,1}},{252,{0,38040102,1}},{25,{0,38100001,1}},{84,{0,38190001,1}},{244,{0,17010001,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}},{244,{0,17010001,1}},{33,{0,38040010,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}}]','[{100,{0,38110003,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1009,5,'[{10,{0,1001010800,1}},{10,{0,1001020800,1}},{0,{0,1001030800,1}},{10,{0,1001040800,1}},{10,{0,1002010800,1}},{10,{0,1002020800,1}},{0,{0,1002030800,1}},{10,{0,1002040800,1}},{3,{0,1003000800,1}},{10,{0,1004010800,1}},{10,{0,1004020800,1}},{0,{0,1004030800,1}},{10,{0,1004040800,1}},{0,{0,1005000800,1}},{10,{0,1006010800,1}},{10,{0,1006020800,1}},{0,{0,1006030800,1}},{10,{0,1006040800,1}},{10,{0,1007010800,1}},{10,{0,1007020800,1}},{0,{0,1007030800,1}},{10,{0,1007040800,1}},{10,{0,1008010800,1}},{10,{0,1008020800,1}},{0,{0,1008030800,1}},{10,{0,1008040800,1}},{0,{0,1009000800,1}},{10,{0,1010010800,1}},{10,{0,1010020800,1}},{0,{0,1010030800,1}},{10,{0,1010040800,1}}]','[{10,{0,1001010810,1}},{10,{0,1001020810,1}},{0,{0,1001030810,1}},{10,{0,1001040810,1}},{10,{0,1002010810,1}},{10,{0,1002020810,1}},{0,{0,1002030810,1}},{10,{0,1002040810,1}},{3,{0,1003000810,1}},{10,{0,1004010810,1}},{10,{0,1004020810,1}},{0,{0,1004030810,1}},{10,{0,1004040810,1}},{0,{0,1005000810,1}},{10,{0,1006010810,1}},{10,{0,1006020810,1}},{0,{0,1006030810,1}},{10,{0,1006040810,1}},{10,{0,1007010810,1}},{10,{0,1007020810,1}},{0,{0,1007030810,1}},{10,{0,1007040810,1}},{10,{0,1008010810,1}},{10,{0,1008020810,1}},{0,{0,1008030810,1}},{10,{0,1008040810,1}},{0,{0,1009000810,1}},{10,{0,1010010810,1}},{10,{0,1010020810,1}},{0,{0,1010030810,1}},{10,{0,1010040810,1}}]','[{10,{0,1001010820,1}},{10,{0,1001020820,1}},{0,{0,1001030820,1}},{10,{0,1001040820,1}},{10,{0,1002010820,1}},{10,{0,1002020820,1}},{0,{0,1002030820,1}},{10,{0,1002040820,1}},{3,{0,1003000820,1}},{10,{0,1004010820,1}},{10,{0,1004020820,1}},{0,{0,1004030820,1}},{10,{0,1004040820,1}},{0,{0,1005000820,1}},{10,{0,1006010820,1}},{10,{0,1006020820,1}},{0,{0,1006030820,1}},{10,{0,1006040820,1}},{10,{0,1007010820,1}},{10,{0,1007020820,1}},{0,{0,1007030820,1}},{10,{0,1007040820,1}},{10,{0,1008010820,1}},{10,{0,1008020820,1}},{0,{0,1008030820,1}},{10,{0,1008040820,1}},{0,{0,1009000820,1}},{10,{0,1010010820,1}},{10,{0,1010020820,1}},{0,{0,1010030820,1}},{10,{0,1010040820,1}}]','[{10,{0,1001010831,1}},{10,{0,1001020831,1}},{0,{0,1001030831,1}},{10,{0,1001040831,1}},{10,{0,1002010831,1}},{10,{0,1002020831,1}},{0,{0,1002030831,1}},{10,{0,1002040831,1}},{3,{0,1003000831,1}},{10,{0,1004010831,1}},{10,{0,1004020831,1}},{0,{0,1004030831,1}},{10,{0,1004040831,1}},{0,{0,1005000831,1}},{10,{0,1006010831,1}},{10,{0,1006020831,1}},{0,{0,1006030831,1}},{10,{0,1006040831,1}},{10,{0,1007010831,1}},{10,{0,1007020831,1}},{0,{0,1007030831,1}},{10,{0,1007040831,1}},{10,{0,1008010831,1}},{10,{0,1008020831,1}},{0,{0,1008030831,1}},{10,{0,1008040831,1}},{0,{0,1009000831,1}},{10,{0,1010010831,1}},{10,{0,1010020831,1}},{0,{0,1010030831,1}},{10,{0,1010040831,1}}]','[{252,{0,17010001,1}},{17,{0,38030006,1}},{17,{0,38030007,1}},{126,{0,38130001,1}},{42,{0,11020001,1}},{59,{0,18020001,1}},{252,{0,38040102,1}},{25,{0,38100001,1}},{84,{0,38190001,1}},{244,{0,17010001,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}},{244,{0,17010001,1}},{33,{0,38040010,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}}]','[{100,{0,38110003,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1009,6,'[{10,{0,1001010800,1}},{10,{0,1001020800,1}},{0,{0,1001030800,1}},{10,{0,1001040800,1}},{10,{0,1002010800,1}},{10,{0,1002020800,1}},{0,{0,1002030800,1}},{10,{0,1002040800,1}},{3,{0,1003000800,1}},{10,{0,1004010800,1}},{10,{0,1004020800,1}},{0,{0,1004030800,1}},{10,{0,1004040800,1}},{0,{0,1005000800,1}},{10,{0,1006010800,1}},{10,{0,1006020800,1}},{0,{0,1006030800,1}},{10,{0,1006040800,1}},{10,{0,1007010800,1}},{10,{0,1007020800,1}},{0,{0,1007030800,1}},{10,{0,1007040800,1}},{10,{0,1008010800,1}},{10,{0,1008020800,1}},{0,{0,1008030800,1}},{10,{0,1008040800,1}},{0,{0,1009000800,1}},{10,{0,1010010800,1}},{10,{0,1010020800,1}},{0,{0,1010030800,1}},{10,{0,1010040800,1}}]','[{10,{0,1001010810,1}},{10,{0,1001020810,1}},{0,{0,1001030810,1}},{10,{0,1001040810,1}},{10,{0,1002010810,1}},{10,{0,1002020810,1}},{0,{0,1002030810,1}},{10,{0,1002040810,1}},{3,{0,1003000810,1}},{10,{0,1004010810,1}},{10,{0,1004020810,1}},{0,{0,1004030810,1}},{10,{0,1004040810,1}},{0,{0,1005000810,1}},{10,{0,1006010810,1}},{10,{0,1006020810,1}},{0,{0,1006030810,1}},{10,{0,1006040810,1}},{10,{0,1007010810,1}},{10,{0,1007020810,1}},{0,{0,1007030810,1}},{10,{0,1007040810,1}},{10,{0,1008010810,1}},{10,{0,1008020810,1}},{0,{0,1008030810,1}},{10,{0,1008040810,1}},{0,{0,1009000810,1}},{10,{0,1010010810,1}},{10,{0,1010020810,1}},{0,{0,1010030810,1}},{10,{0,1010040810,1}}]','[{10,{0,1001010820,1}},{10,{0,1001020820,1}},{0,{0,1001030820,1}},{10,{0,1001040820,1}},{10,{0,1002010820,1}},{10,{0,1002020820,1}},{0,{0,1002030820,1}},{10,{0,1002040820,1}},{3,{0,1003000820,1}},{10,{0,1004010820,1}},{10,{0,1004020820,1}},{0,{0,1004030820,1}},{10,{0,1004040820,1}},{0,{0,1005000820,1}},{10,{0,1006010820,1}},{10,{0,1006020820,1}},{0,{0,1006030820,1}},{10,{0,1006040820,1}},{10,{0,1007010820,1}},{10,{0,1007020820,1}},{0,{0,1007030820,1}},{10,{0,1007040820,1}},{10,{0,1008010820,1}},{10,{0,1008020820,1}},{0,{0,1008030820,1}},{10,{0,1008040820,1}},{0,{0,1009000820,1}},{10,{0,1010010820,1}},{10,{0,1010020820,1}},{0,{0,1010030820,1}},{10,{0,1010040820,1}}]','[{10,{0,1001010831,1}},{10,{0,1001020831,1}},{0,{0,1001030831,1}},{10,{0,1001040831,1}},{10,{0,1002010831,1}},{10,{0,1002020831,1}},{0,{0,1002030831,1}},{10,{0,1002040831,1}},{3,{0,1003000831,1}},{10,{0,1004010831,1}},{10,{0,1004020831,1}},{0,{0,1004030831,1}},{10,{0,1004040831,1}},{0,{0,1005000831,1}},{10,{0,1006010831,1}},{10,{0,1006020831,1}},{0,{0,1006030831,1}},{10,{0,1006040831,1}},{10,{0,1007010831,1}},{10,{0,1007020831,1}},{0,{0,1007030831,1}},{10,{0,1007040831,1}},{10,{0,1008010831,1}},{10,{0,1008020831,1}},{0,{0,1008030831,1}},{10,{0,1008040831,1}},{0,{0,1009000831,1}},{10,{0,1010010831,1}},{10,{0,1010020831,1}},{0,{0,1010030831,1}},{10,{0,1010040831,1}}]','[{252,{0,17010001,1}},{17,{0,38030006,1}},{17,{0,38030007,1}},{126,{0,38130001,1}},{42,{0,11020001,1}},{59,{0,18020001,1}},{252,{0,38040102,1}},{25,{0,38100001,1}},{84,{0,38190001,1}},{244,{0,17010001,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}},{244,{0,17010001,1}},{33,{0,38040010,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}}]','[{100,{0,38110003,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1009,7,'[{10,{0,1001010800,1}},{10,{0,1001020800,1}},{0,{0,1001030800,1}},{10,{0,1001040800,1}},{10,{0,1002010800,1}},{10,{0,1002020800,1}},{0,{0,1002030800,1}},{10,{0,1002040800,1}},{3,{0,1003000800,1}},{10,{0,1004010800,1}},{10,{0,1004020800,1}},{0,{0,1004030800,1}},{10,{0,1004040800,1}},{0,{0,1005000800,1}},{10,{0,1006010800,1}},{10,{0,1006020800,1}},{0,{0,1006030800,1}},{10,{0,1006040800,1}},{10,{0,1007010800,1}},{10,{0,1007020800,1}},{0,{0,1007030800,1}},{10,{0,1007040800,1}},{10,{0,1008010800,1}},{10,{0,1008020800,1}},{0,{0,1008030800,1}},{10,{0,1008040800,1}},{0,{0,1009000800,1}},{10,{0,1010010800,1}},{10,{0,1010020800,1}},{0,{0,1010030800,1}},{10,{0,1010040800,1}}]','[{10,{0,1001010810,1}},{10,{0,1001020810,1}},{0,{0,1001030810,1}},{10,{0,1001040810,1}},{10,{0,1002010810,1}},{10,{0,1002020810,1}},{0,{0,1002030810,1}},{10,{0,1002040810,1}},{3,{0,1003000810,1}},{10,{0,1004010810,1}},{10,{0,1004020810,1}},{0,{0,1004030810,1}},{10,{0,1004040810,1}},{0,{0,1005000810,1}},{10,{0,1006010810,1}},{10,{0,1006020810,1}},{0,{0,1006030810,1}},{10,{0,1006040810,1}},{10,{0,1007010810,1}},{10,{0,1007020810,1}},{0,{0,1007030810,1}},{10,{0,1007040810,1}},{10,{0,1008010810,1}},{10,{0,1008020810,1}},{0,{0,1008030810,1}},{10,{0,1008040810,1}},{0,{0,1009000810,1}},{10,{0,1010010810,1}},{10,{0,1010020810,1}},{0,{0,1010030810,1}},{10,{0,1010040810,1}}]','[{10,{0,1001010820,1}},{10,{0,1001020820,1}},{0,{0,1001030820,1}},{10,{0,1001040820,1}},{10,{0,1002010820,1}},{10,{0,1002020820,1}},{0,{0,1002030820,1}},{10,{0,1002040820,1}},{3,{0,1003000820,1}},{10,{0,1004010820,1}},{10,{0,1004020820,1}},{0,{0,1004030820,1}},{10,{0,1004040820,1}},{0,{0,1005000820,1}},{10,{0,1006010820,1}},{10,{0,1006020820,1}},{0,{0,1006030820,1}},{10,{0,1006040820,1}},{10,{0,1007010820,1}},{10,{0,1007020820,1}},{0,{0,1007030820,1}},{10,{0,1007040820,1}},{10,{0,1008010820,1}},{10,{0,1008020820,1}},{0,{0,1008030820,1}},{10,{0,1008040820,1}},{0,{0,1009000820,1}},{10,{0,1010010820,1}},{10,{0,1010020820,1}},{0,{0,1010030820,1}},{10,{0,1010040820,1}}]','[{10,{0,1001010831,1}},{10,{0,1001020831,1}},{0,{0,1001030831,1}},{10,{0,1001040831,1}},{10,{0,1002010831,1}},{10,{0,1002020831,1}},{0,{0,1002030831,1}},{10,{0,1002040831,1}},{3,{0,1003000831,1}},{10,{0,1004010831,1}},{10,{0,1004020831,1}},{0,{0,1004030831,1}},{10,{0,1004040831,1}},{0,{0,1005000831,1}},{10,{0,1006010831,1}},{10,{0,1006020831,1}},{0,{0,1006030831,1}},{10,{0,1006040831,1}},{10,{0,1007010831,1}},{10,{0,1007020831,1}},{0,{0,1007030831,1}},{10,{0,1007040831,1}},{10,{0,1008010831,1}},{10,{0,1008020831,1}},{0,{0,1008030831,1}},{10,{0,1008040831,1}},{0,{0,1009000831,1}},{10,{0,1010010831,1}},{10,{0,1010020831,1}},{0,{0,1010030831,1}},{10,{0,1010040831,1}}]','[{252,{0,17010001,1}},{17,{0,38030006,1}},{17,{0,38030007,1}},{126,{0,38130001,1}},{42,{0,11020001,1}},{59,{0,18020001,1}},{252,{0,38040102,1}},{25,{0,38100001,1}},{84,{0,38190001,1}},{244,{0,17010001,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}},{244,{0,17010001,1}},{33,{0,38040010,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}}]','[{100,{0,38110003,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1009,8,'[{10,{0,1001010800,1}},{10,{0,1001020800,1}},{0,{0,1001030800,1}},{10,{0,1001040800,1}},{10,{0,1002010800,1}},{10,{0,1002020800,1}},{0,{0,1002030800,1}},{10,{0,1002040800,1}},{3,{0,1003000800,1}},{10,{0,1004010800,1}},{10,{0,1004020800,1}},{0,{0,1004030800,1}},{10,{0,1004040800,1}},{0,{0,1005000800,1}},{10,{0,1006010800,1}},{10,{0,1006020800,1}},{0,{0,1006030800,1}},{10,{0,1006040800,1}},{10,{0,1007010800,1}},{10,{0,1007020800,1}},{0,{0,1007030800,1}},{10,{0,1007040800,1}},{10,{0,1008010800,1}},{10,{0,1008020800,1}},{0,{0,1008030800,1}},{10,{0,1008040800,1}},{0,{0,1009000800,1}},{10,{0,1010010800,1}},{10,{0,1010020800,1}},{0,{0,1010030800,1}},{10,{0,1010040800,1}}]','[{10,{0,1001010810,1}},{10,{0,1001020810,1}},{0,{0,1001030810,1}},{10,{0,1001040810,1}},{10,{0,1002010810,1}},{10,{0,1002020810,1}},{0,{0,1002030810,1}},{10,{0,1002040810,1}},{3,{0,1003000810,1}},{10,{0,1004010810,1}},{10,{0,1004020810,1}},{0,{0,1004030810,1}},{10,{0,1004040810,1}},{0,{0,1005000810,1}},{10,{0,1006010810,1}},{10,{0,1006020810,1}},{0,{0,1006030810,1}},{10,{0,1006040810,1}},{10,{0,1007010810,1}},{10,{0,1007020810,1}},{0,{0,1007030810,1}},{10,{0,1007040810,1}},{10,{0,1008010810,1}},{10,{0,1008020810,1}},{0,{0,1008030810,1}},{10,{0,1008040810,1}},{0,{0,1009000810,1}},{10,{0,1010010810,1}},{10,{0,1010020810,1}},{0,{0,1010030810,1}},{10,{0,1010040810,1}}]','[{10,{0,1001010820,1}},{10,{0,1001020820,1}},{0,{0,1001030820,1}},{10,{0,1001040820,1}},{10,{0,1002010820,1}},{10,{0,1002020820,1}},{0,{0,1002030820,1}},{10,{0,1002040820,1}},{3,{0,1003000820,1}},{10,{0,1004010820,1}},{10,{0,1004020820,1}},{0,{0,1004030820,1}},{10,{0,1004040820,1}},{0,{0,1005000820,1}},{10,{0,1006010820,1}},{10,{0,1006020820,1}},{0,{0,1006030820,1}},{10,{0,1006040820,1}},{10,{0,1007010820,1}},{10,{0,1007020820,1}},{0,{0,1007030820,1}},{10,{0,1007040820,1}},{10,{0,1008010820,1}},{10,{0,1008020820,1}},{0,{0,1008030820,1}},{10,{0,1008040820,1}},{0,{0,1009000820,1}},{10,{0,1010010820,1}},{10,{0,1010020820,1}},{0,{0,1010030820,1}},{10,{0,1010040820,1}}]','[{10,{0,1001010831,1}},{10,{0,1001020831,1}},{0,{0,1001030831,1}},{10,{0,1001040831,1}},{10,{0,1002010831,1}},{10,{0,1002020831,1}},{0,{0,1002030831,1}},{10,{0,1002040831,1}},{3,{0,1003000831,1}},{10,{0,1004010831,1}},{10,{0,1004020831,1}},{0,{0,1004030831,1}},{10,{0,1004040831,1}},{0,{0,1005000831,1}},{10,{0,1006010831,1}},{10,{0,1006020831,1}},{0,{0,1006030831,1}},{10,{0,1006040831,1}},{10,{0,1007010831,1}},{10,{0,1007020831,1}},{0,{0,1007030831,1}},{10,{0,1007040831,1}},{10,{0,1008010831,1}},{10,{0,1008020831,1}},{0,{0,1008030831,1}},{10,{0,1008040831,1}},{0,{0,1009000831,1}},{10,{0,1010010831,1}},{10,{0,1010020831,1}},{0,{0,1010030831,1}},{10,{0,1010040831,1}}]','[{252,{0,17010001,1}},{17,{0,38030006,1}},{17,{0,38030007,1}},{126,{0,38130001,1}},{42,{0,11020001,1}},{59,{0,18020001,1}},{252,{0,38040102,1}},{25,{0,38100001,1}},{84,{0,38190001,1}},{244,{0,17010001,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}},{244,{0,17010001,1}},{33,{0,38040010,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}}]','[{100,{0,38110004,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1010,1,'[{10,{0,1001010900,1}},{10,{0,1001020900,1}},{0,{0,1001030900,1}},{10,{0,1001040900,1}},{10,{0,1002010900,1}},{10,{0,1002020900,1}},{0,{0,1002030900,1}},{10,{0,1002040900,1}},{3,{0,1003000900,1}},{10,{0,1004010900,1}},{10,{0,1004020900,1}},{0,{0,1004030900,1}},{10,{0,1004040900,1}},{0,{0,1005000900,1}},{10,{0,1006010900,1}},{10,{0,1006020900,1}},{0,{0,1006030900,1}},{10,{0,1006040900,1}},{10,{0,1007010900,1}},{10,{0,1007020900,1}},{0,{0,1007030900,1}},{10,{0,1007040900,1}},{10,{0,1008010900,1}},{10,{0,1008020900,1}},{0,{0,1008030900,1}},{10,{0,1008040900,1}},{0,{0,1009000900,1}},{10,{0,1010010900,1}},{10,{0,1010020900,1}},{0,{0,1010030900,1}},{10,{0,1010040900,1}}]','[{10,{0,1001010910,1}},{10,{0,1001020910,1}},{0,{0,1001030910,1}},{10,{0,1001040910,1}},{10,{0,1002010910,1}},{10,{0,1002020910,1}},{0,{0,1002030910,1}},{10,{0,1002040910,1}},{3,{0,1003000910,1}},{10,{0,1004010910,1}},{10,{0,1004020910,1}},{0,{0,1004030910,1}},{10,{0,1004040910,1}},{0,{0,1005000910,1}},{10,{0,1006010910,1}},{10,{0,1006020910,1}},{0,{0,1006030910,1}},{10,{0,1006040910,1}},{10,{0,1007010910,1}},{10,{0,1007020910,1}},{0,{0,1007030910,1}},{10,{0,1007040910,1}},{10,{0,1008010910,1}},{10,{0,1008020910,1}},{0,{0,1008030910,1}},{10,{0,1008040910,1}},{0,{0,1009000910,1}},{10,{0,1010010910,1}},{10,{0,1010020910,1}},{0,{0,1010030910,1}},{10,{0,1010040910,1}}]','[{10,{0,1001010920,1}},{10,{0,1001020920,1}},{0,{0,1001030920,1}},{10,{0,1001040920,1}},{10,{0,1002010920,1}},{10,{0,1002020920,1}},{0,{0,1002030920,1}},{10,{0,1002040920,1}},{3,{0,1003000920,1}},{10,{0,1004010920,1}},{10,{0,1004020920,1}},{0,{0,1004030920,1}},{10,{0,1004040920,1}},{0,{0,1005000920,1}},{10,{0,1006010920,1}},{10,{0,1006020920,1}},{0,{0,1006030920,1}},{10,{0,1006040920,1}},{10,{0,1007010920,1}},{10,{0,1007020920,1}},{0,{0,1007030920,1}},{10,{0,1007040920,1}},{10,{0,1008010920,1}},{10,{0,1008020920,1}},{0,{0,1008030920,1}},{10,{0,1008040920,1}},{0,{0,1009000920,1}},{10,{0,1010010920,1}},{10,{0,1010020920,1}},{0,{0,1010030920,1}},{10,{0,1010040920,1}}]','[{10,{0,1001010931,1}},{10,{0,1001020931,1}},{0,{0,1001030931,1}},{10,{0,1001040931,1}},{10,{0,1002010931,1}},{10,{0,1002020931,1}},{0,{0,1002030931,1}},{10,{0,1002040931,1}},{3,{0,1003000931,1}},{10,{0,1004010931,1}},{10,{0,1004020931,1}},{0,{0,1004030931,1}},{10,{0,1004040931,1}},{0,{0,1005000931,1}},{10,{0,1006010931,1}},{10,{0,1006020931,1}},{0,{0,1006030931,1}},{10,{0,1006040931,1}},{10,{0,1007010931,1}},{10,{0,1007020931,1}},{0,{0,1007030931,1}},{10,{0,1007040931,1}},{10,{0,1008010931,1}},{10,{0,1008020931,1}},{0,{0,1008030931,1}},{10,{0,1008040931,1}},{0,{0,1009000931,1}},{10,{0,1010010931,1}},{10,{0,1010020931,1}},{0,{0,1010030931,1}},{10,{0,1010040931,1}}]','[{252,{0,17010001,1}},{17,{0,38030006,1}},{17,{0,38030007,1}},{126,{0,38130001,1}},{42,{0,11020001,1}},{59,{0,18020001,1}},{252,{0,38040102,1}},{25,{0,38100001,1}},{84,{0,38190001,1}},{244,{0,17010001,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}},{244,{0,17010001,1}},{33,{0,38040010,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}}]','[{100,{0,38110004,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1010,2,'[{10,{0,1001010900,1}},{10,{0,1001020900,1}},{0,{0,1001030900,1}},{10,{0,1001040900,1}},{10,{0,1002010900,1}},{10,{0,1002020900,1}},{0,{0,1002030900,1}},{10,{0,1002040900,1}},{3,{0,1003000900,1}},{10,{0,1004010900,1}},{10,{0,1004020900,1}},{0,{0,1004030900,1}},{10,{0,1004040900,1}},{0,{0,1005000900,1}},{10,{0,1006010900,1}},{10,{0,1006020900,1}},{0,{0,1006030900,1}},{10,{0,1006040900,1}},{10,{0,1007010900,1}},{10,{0,1007020900,1}},{0,{0,1007030900,1}},{10,{0,1007040900,1}},{10,{0,1008010900,1}},{10,{0,1008020900,1}},{0,{0,1008030900,1}},{10,{0,1008040900,1}},{0,{0,1009000900,1}},{10,{0,1010010900,1}},{10,{0,1010020900,1}},{0,{0,1010030900,1}},{10,{0,1010040900,1}}]','[{10,{0,1001010910,1}},{10,{0,1001020910,1}},{0,{0,1001030910,1}},{10,{0,1001040910,1}},{10,{0,1002010910,1}},{10,{0,1002020910,1}},{0,{0,1002030910,1}},{10,{0,1002040910,1}},{3,{0,1003000910,1}},{10,{0,1004010910,1}},{10,{0,1004020910,1}},{0,{0,1004030910,1}},{10,{0,1004040910,1}},{0,{0,1005000910,1}},{10,{0,1006010910,1}},{10,{0,1006020910,1}},{0,{0,1006030910,1}},{10,{0,1006040910,1}},{10,{0,1007010910,1}},{10,{0,1007020910,1}},{0,{0,1007030910,1}},{10,{0,1007040910,1}},{10,{0,1008010910,1}},{10,{0,1008020910,1}},{0,{0,1008030910,1}},{10,{0,1008040910,1}},{0,{0,1009000910,1}},{10,{0,1010010910,1}},{10,{0,1010020910,1}},{0,{0,1010030910,1}},{10,{0,1010040910,1}}]','[{10,{0,1001010920,1}},{10,{0,1001020920,1}},{0,{0,1001030920,1}},{10,{0,1001040920,1}},{10,{0,1002010920,1}},{10,{0,1002020920,1}},{0,{0,1002030920,1}},{10,{0,1002040920,1}},{3,{0,1003000920,1}},{10,{0,1004010920,1}},{10,{0,1004020920,1}},{0,{0,1004030920,1}},{10,{0,1004040920,1}},{0,{0,1005000920,1}},{10,{0,1006010920,1}},{10,{0,1006020920,1}},{0,{0,1006030920,1}},{10,{0,1006040920,1}},{10,{0,1007010920,1}},{10,{0,1007020920,1}},{0,{0,1007030920,1}},{10,{0,1007040920,1}},{10,{0,1008010920,1}},{10,{0,1008020920,1}},{0,{0,1008030920,1}},{10,{0,1008040920,1}},{0,{0,1009000920,1}},{10,{0,1010010920,1}},{10,{0,1010020920,1}},{0,{0,1010030920,1}},{10,{0,1010040920,1}}]','[{10,{0,1001010931,1}},{10,{0,1001020931,1}},{0,{0,1001030931,1}},{10,{0,1001040931,1}},{10,{0,1002010931,1}},{10,{0,1002020931,1}},{0,{0,1002030931,1}},{10,{0,1002040931,1}},{3,{0,1003000931,1}},{10,{0,1004010931,1}},{10,{0,1004020931,1}},{0,{0,1004030931,1}},{10,{0,1004040931,1}},{0,{0,1005000931,1}},{10,{0,1006010931,1}},{10,{0,1006020931,1}},{0,{0,1006030931,1}},{10,{0,1006040931,1}},{10,{0,1007010931,1}},{10,{0,1007020931,1}},{0,{0,1007030931,1}},{10,{0,1007040931,1}},{10,{0,1008010931,1}},{10,{0,1008020931,1}},{0,{0,1008030931,1}},{10,{0,1008040931,1}},{0,{0,1009000931,1}},{10,{0,1010010931,1}},{10,{0,1010020931,1}},{0,{0,1010030931,1}},{10,{0,1010040931,1}}]','[{252,{0,17010001,1}},{17,{0,38030006,1}},{17,{0,38030007,1}},{126,{0,38130001,1}},{42,{0,11020001,1}},{59,{0,18020001,1}},{252,{0,38040102,1}},{25,{0,38100001,1}},{84,{0,38190001,1}},{244,{0,17010001,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}},{244,{0,17010001,1}},{33,{0,38040010,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}}]','[{100,{0,38110004,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1010,3,'[{10,{0,1001010900,1}},{10,{0,1001020900,1}},{0,{0,1001030900,1}},{10,{0,1001040900,1}},{10,{0,1002010900,1}},{10,{0,1002020900,1}},{0,{0,1002030900,1}},{10,{0,1002040900,1}},{3,{0,1003000900,1}},{10,{0,1004010900,1}},{10,{0,1004020900,1}},{0,{0,1004030900,1}},{10,{0,1004040900,1}},{0,{0,1005000900,1}},{10,{0,1006010900,1}},{10,{0,1006020900,1}},{0,{0,1006030900,1}},{10,{0,1006040900,1}},{10,{0,1007010900,1}},{10,{0,1007020900,1}},{0,{0,1007030900,1}},{10,{0,1007040900,1}},{10,{0,1008010900,1}},{10,{0,1008020900,1}},{0,{0,1008030900,1}},{10,{0,1008040900,1}},{0,{0,1009000900,1}},{10,{0,1010010900,1}},{10,{0,1010020900,1}},{0,{0,1010030900,1}},{10,{0,1010040900,1}}]','[{10,{0,1001010910,1}},{10,{0,1001020910,1}},{0,{0,1001030910,1}},{10,{0,1001040910,1}},{10,{0,1002010910,1}},{10,{0,1002020910,1}},{0,{0,1002030910,1}},{10,{0,1002040910,1}},{3,{0,1003000910,1}},{10,{0,1004010910,1}},{10,{0,1004020910,1}},{0,{0,1004030910,1}},{10,{0,1004040910,1}},{0,{0,1005000910,1}},{10,{0,1006010910,1}},{10,{0,1006020910,1}},{0,{0,1006030910,1}},{10,{0,1006040910,1}},{10,{0,1007010910,1}},{10,{0,1007020910,1}},{0,{0,1007030910,1}},{10,{0,1007040910,1}},{10,{0,1008010910,1}},{10,{0,1008020910,1}},{0,{0,1008030910,1}},{10,{0,1008040910,1}},{0,{0,1009000910,1}},{10,{0,1010010910,1}},{10,{0,1010020910,1}},{0,{0,1010030910,1}},{10,{0,1010040910,1}}]','[{10,{0,1001010920,1}},{10,{0,1001020920,1}},{0,{0,1001030920,1}},{10,{0,1001040920,1}},{10,{0,1002010920,1}},{10,{0,1002020920,1}},{0,{0,1002030920,1}},{10,{0,1002040920,1}},{3,{0,1003000920,1}},{10,{0,1004010920,1}},{10,{0,1004020920,1}},{0,{0,1004030920,1}},{10,{0,1004040920,1}},{0,{0,1005000920,1}},{10,{0,1006010920,1}},{10,{0,1006020920,1}},{0,{0,1006030920,1}},{10,{0,1006040920,1}},{10,{0,1007010920,1}},{10,{0,1007020920,1}},{0,{0,1007030920,1}},{10,{0,1007040920,1}},{10,{0,1008010920,1}},{10,{0,1008020920,1}},{0,{0,1008030920,1}},{10,{0,1008040920,1}},{0,{0,1009000920,1}},{10,{0,1010010920,1}},{10,{0,1010020920,1}},{0,{0,1010030920,1}},{10,{0,1010040920,1}}]','[{10,{0,1001010931,1}},{10,{0,1001020931,1}},{0,{0,1001030931,1}},{10,{0,1001040931,1}},{10,{0,1002010931,1}},{10,{0,1002020931,1}},{0,{0,1002030931,1}},{10,{0,1002040931,1}},{3,{0,1003000931,1}},{10,{0,1004010931,1}},{10,{0,1004020931,1}},{0,{0,1004030931,1}},{10,{0,1004040931,1}},{0,{0,1005000931,1}},{10,{0,1006010931,1}},{10,{0,1006020931,1}},{0,{0,1006030931,1}},{10,{0,1006040931,1}},{10,{0,1007010931,1}},{10,{0,1007020931,1}},{0,{0,1007030931,1}},{10,{0,1007040931,1}},{10,{0,1008010931,1}},{10,{0,1008020931,1}},{0,{0,1008030931,1}},{10,{0,1008040931,1}},{0,{0,1009000931,1}},{10,{0,1010010931,1}},{10,{0,1010020931,1}},{0,{0,1010030931,1}},{10,{0,1010040931,1}}]','[{252,{0,17010001,1}},{17,{0,38030006,1}},{17,{0,38030007,1}},{126,{0,38130001,1}},{42,{0,11020001,1}},{59,{0,18020001,1}},{252,{0,38040102,1}},{25,{0,38100001,1}},{84,{0,38190001,1}},{244,{0,17010001,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}},{244,{0,17010001,1}},{33,{0,38040010,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}}]','[{100,{0,38110004,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1010,4,'[{10,{0,1001010900,1}},{10,{0,1001020900,1}},{0,{0,1001030900,1}},{10,{0,1001040900,1}},{10,{0,1002010900,1}},{10,{0,1002020900,1}},{0,{0,1002030900,1}},{10,{0,1002040900,1}},{3,{0,1003000900,1}},{10,{0,1004010900,1}},{10,{0,1004020900,1}},{0,{0,1004030900,1}},{10,{0,1004040900,1}},{0,{0,1005000900,1}},{10,{0,1006010900,1}},{10,{0,1006020900,1}},{0,{0,1006030900,1}},{10,{0,1006040900,1}},{10,{0,1007010900,1}},{10,{0,1007020900,1}},{0,{0,1007030900,1}},{10,{0,1007040900,1}},{10,{0,1008010900,1}},{10,{0,1008020900,1}},{0,{0,1008030900,1}},{10,{0,1008040900,1}},{0,{0,1009000900,1}},{10,{0,1010010900,1}},{10,{0,1010020900,1}},{0,{0,1010030900,1}},{10,{0,1010040900,1}}]','[{10,{0,1001010910,1}},{10,{0,1001020910,1}},{0,{0,1001030910,1}},{10,{0,1001040910,1}},{10,{0,1002010910,1}},{10,{0,1002020910,1}},{0,{0,1002030910,1}},{10,{0,1002040910,1}},{3,{0,1003000910,1}},{10,{0,1004010910,1}},{10,{0,1004020910,1}},{0,{0,1004030910,1}},{10,{0,1004040910,1}},{0,{0,1005000910,1}},{10,{0,1006010910,1}},{10,{0,1006020910,1}},{0,{0,1006030910,1}},{10,{0,1006040910,1}},{10,{0,1007010910,1}},{10,{0,1007020910,1}},{0,{0,1007030910,1}},{10,{0,1007040910,1}},{10,{0,1008010910,1}},{10,{0,1008020910,1}},{0,{0,1008030910,1}},{10,{0,1008040910,1}},{0,{0,1009000910,1}},{10,{0,1010010910,1}},{10,{0,1010020910,1}},{0,{0,1010030910,1}},{10,{0,1010040910,1}}]','[{10,{0,1001010920,1}},{10,{0,1001020920,1}},{0,{0,1001030920,1}},{10,{0,1001040920,1}},{10,{0,1002010920,1}},{10,{0,1002020920,1}},{0,{0,1002030920,1}},{10,{0,1002040920,1}},{3,{0,1003000920,1}},{10,{0,1004010920,1}},{10,{0,1004020920,1}},{0,{0,1004030920,1}},{10,{0,1004040920,1}},{0,{0,1005000920,1}},{10,{0,1006010920,1}},{10,{0,1006020920,1}},{0,{0,1006030920,1}},{10,{0,1006040920,1}},{10,{0,1007010920,1}},{10,{0,1007020920,1}},{0,{0,1007030920,1}},{10,{0,1007040920,1}},{10,{0,1008010920,1}},{10,{0,1008020920,1}},{0,{0,1008030920,1}},{10,{0,1008040920,1}},{0,{0,1009000920,1}},{10,{0,1010010920,1}},{10,{0,1010020920,1}},{0,{0,1010030920,1}},{10,{0,1010040920,1}}]','[{10,{0,1001010931,1}},{10,{0,1001020931,1}},{0,{0,1001030931,1}},{10,{0,1001040931,1}},{10,{0,1002010931,1}},{10,{0,1002020931,1}},{0,{0,1002030931,1}},{10,{0,1002040931,1}},{3,{0,1003000931,1}},{10,{0,1004010931,1}},{10,{0,1004020931,1}},{0,{0,1004030931,1}},{10,{0,1004040931,1}},{0,{0,1005000931,1}},{10,{0,1006010931,1}},{10,{0,1006020931,1}},{0,{0,1006030931,1}},{10,{0,1006040931,1}},{10,{0,1007010931,1}},{10,{0,1007020931,1}},{0,{0,1007030931,1}},{10,{0,1007040931,1}},{10,{0,1008010931,1}},{10,{0,1008020931,1}},{0,{0,1008030931,1}},{10,{0,1008040931,1}},{0,{0,1009000931,1}},{10,{0,1010010931,1}},{10,{0,1010020931,1}},{0,{0,1010030931,1}},{10,{0,1010040931,1}}]','[{252,{0,17010001,1}},{17,{0,38030006,1}},{17,{0,38030007,1}},{126,{0,38130001,1}},{42,{0,11020001,1}},{59,{0,18020001,1}},{252,{0,38040102,1}},{25,{0,38100001,1}},{84,{0,38190001,1}},{244,{0,17010001,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}},{244,{0,17010001,1}},{33,{0,38040010,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}}]','[{100,{0,38110004,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1010,5,'[{10,{0,1001010900,1}},{10,{0,1001020900,1}},{0,{0,1001030900,1}},{10,{0,1001040900,1}},{10,{0,1002010900,1}},{10,{0,1002020900,1}},{0,{0,1002030900,1}},{10,{0,1002040900,1}},{3,{0,1003000900,1}},{10,{0,1004010900,1}},{10,{0,1004020900,1}},{0,{0,1004030900,1}},{10,{0,1004040900,1}},{0,{0,1005000900,1}},{10,{0,1006010900,1}},{10,{0,1006020900,1}},{0,{0,1006030900,1}},{10,{0,1006040900,1}},{10,{0,1007010900,1}},{10,{0,1007020900,1}},{0,{0,1007030900,1}},{10,{0,1007040900,1}},{10,{0,1008010900,1}},{10,{0,1008020900,1}},{0,{0,1008030900,1}},{10,{0,1008040900,1}},{0,{0,1009000900,1}},{10,{0,1010010900,1}},{10,{0,1010020900,1}},{0,{0,1010030900,1}},{10,{0,1010040900,1}}]','[{10,{0,1001010910,1}},{10,{0,1001020910,1}},{0,{0,1001030910,1}},{10,{0,1001040910,1}},{10,{0,1002010910,1}},{10,{0,1002020910,1}},{0,{0,1002030910,1}},{10,{0,1002040910,1}},{3,{0,1003000910,1}},{10,{0,1004010910,1}},{10,{0,1004020910,1}},{0,{0,1004030910,1}},{10,{0,1004040910,1}},{0,{0,1005000910,1}},{10,{0,1006010910,1}},{10,{0,1006020910,1}},{0,{0,1006030910,1}},{10,{0,1006040910,1}},{10,{0,1007010910,1}},{10,{0,1007020910,1}},{0,{0,1007030910,1}},{10,{0,1007040910,1}},{10,{0,1008010910,1}},{10,{0,1008020910,1}},{0,{0,1008030910,1}},{10,{0,1008040910,1}},{0,{0,1009000910,1}},{10,{0,1010010910,1}},{10,{0,1010020910,1}},{0,{0,1010030910,1}},{10,{0,1010040910,1}}]','[{10,{0,1001010920,1}},{10,{0,1001020920,1}},{0,{0,1001030920,1}},{10,{0,1001040920,1}},{10,{0,1002010920,1}},{10,{0,1002020920,1}},{0,{0,1002030920,1}},{10,{0,1002040920,1}},{3,{0,1003000920,1}},{10,{0,1004010920,1}},{10,{0,1004020920,1}},{0,{0,1004030920,1}},{10,{0,1004040920,1}},{0,{0,1005000920,1}},{10,{0,1006010920,1}},{10,{0,1006020920,1}},{0,{0,1006030920,1}},{10,{0,1006040920,1}},{10,{0,1007010920,1}},{10,{0,1007020920,1}},{0,{0,1007030920,1}},{10,{0,1007040920,1}},{10,{0,1008010920,1}},{10,{0,1008020920,1}},{0,{0,1008030920,1}},{10,{0,1008040920,1}},{0,{0,1009000920,1}},{10,{0,1010010920,1}},{10,{0,1010020920,1}},{0,{0,1010030920,1}},{10,{0,1010040920,1}}]','[{10,{0,1001010931,1}},{10,{0,1001020931,1}},{0,{0,1001030931,1}},{10,{0,1001040931,1}},{10,{0,1002010931,1}},{10,{0,1002020931,1}},{0,{0,1002030931,1}},{10,{0,1002040931,1}},{3,{0,1003000931,1}},{10,{0,1004010931,1}},{10,{0,1004020931,1}},{0,{0,1004030931,1}},{10,{0,1004040931,1}},{0,{0,1005000931,1}},{10,{0,1006010931,1}},{10,{0,1006020931,1}},{0,{0,1006030931,1}},{10,{0,1006040931,1}},{10,{0,1007010931,1}},{10,{0,1007020931,1}},{0,{0,1007030931,1}},{10,{0,1007040931,1}},{10,{0,1008010931,1}},{10,{0,1008020931,1}},{0,{0,1008030931,1}},{10,{0,1008040931,1}},{0,{0,1009000931,1}},{10,{0,1010010931,1}},{10,{0,1010020931,1}},{0,{0,1010030931,1}},{10,{0,1010040931,1}}]','[{252,{0,17010001,1}},{17,{0,38030006,1}},{17,{0,38030007,1}},{126,{0,38130001,1}},{42,{0,11020001,1}},{59,{0,18020001,1}},{252,{0,38040102,1}},{25,{0,38100001,1}},{84,{0,38190001,1}},{244,{0,17010001,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}},{244,{0,17010001,1}},{33,{0,38040010,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}}]','[{100,{0,38110004,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1010,6,'[{10,{0,1001010900,1}},{10,{0,1001020900,1}},{0,{0,1001030900,1}},{10,{0,1001040900,1}},{10,{0,1002010900,1}},{10,{0,1002020900,1}},{0,{0,1002030900,1}},{10,{0,1002040900,1}},{3,{0,1003000900,1}},{10,{0,1004010900,1}},{10,{0,1004020900,1}},{0,{0,1004030900,1}},{10,{0,1004040900,1}},{0,{0,1005000900,1}},{10,{0,1006010900,1}},{10,{0,1006020900,1}},{0,{0,1006030900,1}},{10,{0,1006040900,1}},{10,{0,1007010900,1}},{10,{0,1007020900,1}},{0,{0,1007030900,1}},{10,{0,1007040900,1}},{10,{0,1008010900,1}},{10,{0,1008020900,1}},{0,{0,1008030900,1}},{10,{0,1008040900,1}},{0,{0,1009000900,1}},{10,{0,1010010900,1}},{10,{0,1010020900,1}},{0,{0,1010030900,1}},{10,{0,1010040900,1}}]','[{10,{0,1001010910,1}},{10,{0,1001020910,1}},{0,{0,1001030910,1}},{10,{0,1001040910,1}},{10,{0,1002010910,1}},{10,{0,1002020910,1}},{0,{0,1002030910,1}},{10,{0,1002040910,1}},{3,{0,1003000910,1}},{10,{0,1004010910,1}},{10,{0,1004020910,1}},{0,{0,1004030910,1}},{10,{0,1004040910,1}},{0,{0,1005000910,1}},{10,{0,1006010910,1}},{10,{0,1006020910,1}},{0,{0,1006030910,1}},{10,{0,1006040910,1}},{10,{0,1007010910,1}},{10,{0,1007020910,1}},{0,{0,1007030910,1}},{10,{0,1007040910,1}},{10,{0,1008010910,1}},{10,{0,1008020910,1}},{0,{0,1008030910,1}},{10,{0,1008040910,1}},{0,{0,1009000910,1}},{10,{0,1010010910,1}},{10,{0,1010020910,1}},{0,{0,1010030910,1}},{10,{0,1010040910,1}}]','[{10,{0,1001010920,1}},{10,{0,1001020920,1}},{0,{0,1001030920,1}},{10,{0,1001040920,1}},{10,{0,1002010920,1}},{10,{0,1002020920,1}},{0,{0,1002030920,1}},{10,{0,1002040920,1}},{3,{0,1003000920,1}},{10,{0,1004010920,1}},{10,{0,1004020920,1}},{0,{0,1004030920,1}},{10,{0,1004040920,1}},{0,{0,1005000920,1}},{10,{0,1006010920,1}},{10,{0,1006020920,1}},{0,{0,1006030920,1}},{10,{0,1006040920,1}},{10,{0,1007010920,1}},{10,{0,1007020920,1}},{0,{0,1007030920,1}},{10,{0,1007040920,1}},{10,{0,1008010920,1}},{10,{0,1008020920,1}},{0,{0,1008030920,1}},{10,{0,1008040920,1}},{0,{0,1009000920,1}},{10,{0,1010010920,1}},{10,{0,1010020920,1}},{0,{0,1010030920,1}},{10,{0,1010040920,1}}]','[{10,{0,1001010931,1}},{10,{0,1001020931,1}},{0,{0,1001030931,1}},{10,{0,1001040931,1}},{10,{0,1002010931,1}},{10,{0,1002020931,1}},{0,{0,1002030931,1}},{10,{0,1002040931,1}},{3,{0,1003000931,1}},{10,{0,1004010931,1}},{10,{0,1004020931,1}},{0,{0,1004030931,1}},{10,{0,1004040931,1}},{0,{0,1005000931,1}},{10,{0,1006010931,1}},{10,{0,1006020931,1}},{0,{0,1006030931,1}},{10,{0,1006040931,1}},{10,{0,1007010931,1}},{10,{0,1007020931,1}},{0,{0,1007030931,1}},{10,{0,1007040931,1}},{10,{0,1008010931,1}},{10,{0,1008020931,1}},{0,{0,1008030931,1}},{10,{0,1008040931,1}},{0,{0,1009000931,1}},{10,{0,1010010931,1}},{10,{0,1010020931,1}},{0,{0,1010030931,1}},{10,{0,1010040931,1}}]','[{252,{0,17010001,1}},{17,{0,38030006,1}},{17,{0,38030007,1}},{126,{0,38130001,1}},{42,{0,11020001,1}},{59,{0,18020001,1}},{252,{0,38040102,1}},{25,{0,38100001,1}},{84,{0,38190001,1}},{244,{0,17010001,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}},{244,{0,17010001,1}},{33,{0,38040010,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}}]','[{100,{0,38110004,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1010,7,'[{10,{0,1001010900,1}},{10,{0,1001020900,1}},{0,{0,1001030900,1}},{10,{0,1001040900,1}},{10,{0,1002010900,1}},{10,{0,1002020900,1}},{0,{0,1002030900,1}},{10,{0,1002040900,1}},{3,{0,1003000900,1}},{10,{0,1004010900,1}},{10,{0,1004020900,1}},{0,{0,1004030900,1}},{10,{0,1004040900,1}},{0,{0,1005000900,1}},{10,{0,1006010900,1}},{10,{0,1006020900,1}},{0,{0,1006030900,1}},{10,{0,1006040900,1}},{10,{0,1007010900,1}},{10,{0,1007020900,1}},{0,{0,1007030900,1}},{10,{0,1007040900,1}},{10,{0,1008010900,1}},{10,{0,1008020900,1}},{0,{0,1008030900,1}},{10,{0,1008040900,1}},{0,{0,1009000900,1}},{10,{0,1010010900,1}},{10,{0,1010020900,1}},{0,{0,1010030900,1}},{10,{0,1010040900,1}}]','[{10,{0,1001010910,1}},{10,{0,1001020910,1}},{0,{0,1001030910,1}},{10,{0,1001040910,1}},{10,{0,1002010910,1}},{10,{0,1002020910,1}},{0,{0,1002030910,1}},{10,{0,1002040910,1}},{3,{0,1003000910,1}},{10,{0,1004010910,1}},{10,{0,1004020910,1}},{0,{0,1004030910,1}},{10,{0,1004040910,1}},{0,{0,1005000910,1}},{10,{0,1006010910,1}},{10,{0,1006020910,1}},{0,{0,1006030910,1}},{10,{0,1006040910,1}},{10,{0,1007010910,1}},{10,{0,1007020910,1}},{0,{0,1007030910,1}},{10,{0,1007040910,1}},{10,{0,1008010910,1}},{10,{0,1008020910,1}},{0,{0,1008030910,1}},{10,{0,1008040910,1}},{0,{0,1009000910,1}},{10,{0,1010010910,1}},{10,{0,1010020910,1}},{0,{0,1010030910,1}},{10,{0,1010040910,1}}]','[{10,{0,1001010920,1}},{10,{0,1001020920,1}},{0,{0,1001030920,1}},{10,{0,1001040920,1}},{10,{0,1002010920,1}},{10,{0,1002020920,1}},{0,{0,1002030920,1}},{10,{0,1002040920,1}},{3,{0,1003000920,1}},{10,{0,1004010920,1}},{10,{0,1004020920,1}},{0,{0,1004030920,1}},{10,{0,1004040920,1}},{0,{0,1005000920,1}},{10,{0,1006010920,1}},{10,{0,1006020920,1}},{0,{0,1006030920,1}},{10,{0,1006040920,1}},{10,{0,1007010920,1}},{10,{0,1007020920,1}},{0,{0,1007030920,1}},{10,{0,1007040920,1}},{10,{0,1008010920,1}},{10,{0,1008020920,1}},{0,{0,1008030920,1}},{10,{0,1008040920,1}},{0,{0,1009000920,1}},{10,{0,1010010920,1}},{10,{0,1010020920,1}},{0,{0,1010030920,1}},{10,{0,1010040920,1}}]','[{10,{0,1001010931,1}},{10,{0,1001020931,1}},{0,{0,1001030931,1}},{10,{0,1001040931,1}},{10,{0,1002010931,1}},{10,{0,1002020931,1}},{0,{0,1002030931,1}},{10,{0,1002040931,1}},{3,{0,1003000931,1}},{10,{0,1004010931,1}},{10,{0,1004020931,1}},{0,{0,1004030931,1}},{10,{0,1004040931,1}},{0,{0,1005000931,1}},{10,{0,1006010931,1}},{10,{0,1006020931,1}},{0,{0,1006030931,1}},{10,{0,1006040931,1}},{10,{0,1007010931,1}},{10,{0,1007020931,1}},{0,{0,1007030931,1}},{10,{0,1007040931,1}},{10,{0,1008010931,1}},{10,{0,1008020931,1}},{0,{0,1008030931,1}},{10,{0,1008040931,1}},{0,{0,1009000931,1}},{10,{0,1010010931,1}},{10,{0,1010020931,1}},{0,{0,1010030931,1}},{10,{0,1010040931,1}}]','[{252,{0,17010001,1}},{17,{0,38030006,1}},{17,{0,38030007,1}},{126,{0,38130001,1}},{42,{0,11020001,1}},{59,{0,18020001,1}},{252,{0,38040102,1}},{25,{0,38100001,1}},{84,{0,38190001,1}},{244,{0,17010001,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}},{244,{0,17010001,1}},{33,{0,38040010,1}},{122,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{122,{0,38130001,1}},{41,{0,11020001,1}},{57,{0,18020001,1}},{244,{0,38040102,1}},{24,{0,38100001,1}},{81,{0,38190001,1}}]','[{100,{0,38110004,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1011,1,'[{10,{0,1001011000,1}},{10,{0,1001021000,1}},{0,{0,1001031000,1}},{10,{0,1001041000,1}},{10,{0,1002011000,1}},{10,{0,1002021000,1}},{0,{0,1002031000,1}},{10,{0,1002041000,1}},{3,{0,1003001000,1}},{10,{0,1004011000,1}},{10,{0,1004021000,1}},{0,{0,1004031000,1}},{10,{0,1004041000,1}},{0,{0,1005001000,1}},{10,{0,1006011000,1}},{10,{0,1006021000,1}},{0,{0,1006031000,1}},{10,{0,1006041000,1}},{10,{0,1007011000,1}},{10,{0,1007021000,1}},{0,{0,1007031000,1}},{10,{0,1007041000,1}},{10,{0,1008011000,1}},{10,{0,1008021000,1}},{0,{0,1008031000,1}},{10,{0,1008041000,1}},{0,{0,1009001000,1}},{10,{0,1010011000,1}},{10,{0,1010021000,1}},{0,{0,1010031000,1}},{10,{0,1010041000,1}}]','[{10,{0,1001011010,1}},{10,{0,1001021010,1}},{0,{0,1001031010,1}},{10,{0,1001041010,1}},{10,{0,1002011010,1}},{10,{0,1002021010,1}},{0,{0,1002031010,1}},{10,{0,1002041010,1}},{3,{0,1003001010,1}},{10,{0,1004011010,1}},{10,{0,1004021010,1}},{0,{0,1004031010,1}},{10,{0,1004041010,1}},{0,{0,1005001010,1}},{10,{0,1006011010,1}},{10,{0,1006021010,1}},{0,{0,1006031010,1}},{10,{0,1006041010,1}},{10,{0,1007011010,1}},{10,{0,1007021010,1}},{0,{0,1007031010,1}},{10,{0,1007041010,1}},{10,{0,1008011010,1}},{10,{0,1008021010,1}},{0,{0,1008031010,1}},{10,{0,1008041010,1}},{0,{0,1009001010,1}},{10,{0,1010011010,1}},{10,{0,1010021010,1}},{0,{0,1010031010,1}},{10,{0,1010041010,1}}]','[{10,{0,1001011020,1}},{10,{0,1001021020,1}},{0,{0,1001031020,1}},{10,{0,1001041020,1}},{10,{0,1002011020,1}},{10,{0,1002021020,1}},{0,{0,1002031020,1}},{10,{0,1002041020,1}},{3,{0,1003001020,1}},{10,{0,1004011020,1}},{10,{0,1004021020,1}},{0,{0,1004031020,1}},{10,{0,1004041020,1}},{0,{0,1005001020,1}},{10,{0,1006011020,1}},{10,{0,1006021020,1}},{0,{0,1006031020,1}},{10,{0,1006041020,1}},{10,{0,1007011020,1}},{10,{0,1007021020,1}},{0,{0,1007031020,1}},{10,{0,1007041020,1}},{10,{0,1008011020,1}},{10,{0,1008021020,1}},{0,{0,1008031020,1}},{10,{0,1008041020,1}},{0,{0,1009001020,1}},{10,{0,1010011020,1}},{10,{0,1010021020,1}},{0,{0,1010031020,1}},{10,{0,1010041020,1}}]','[{10,{0,1001011031,1}},{10,{0,1001021031,1}},{0,{0,1001031031,1}},{10,{0,1001041031,1}},{10,{0,1002011031,1}},{10,{0,1002021031,1}},{0,{0,1002031031,1}},{10,{0,1002041031,1}},{3,{0,1003001031,1}},{10,{0,1004011031,1}},{10,{0,1004021031,1}},{0,{0,1004031031,1}},{10,{0,1004041031,1}},{0,{0,1005001031,1}},{10,{0,1006011031,1}},{10,{0,1006021031,1}},{0,{0,1006031031,1}},{10,{0,1006041031,1}},{10,{0,1007011031,1}},{10,{0,1007021031,1}},{0,{0,1007031031,1}},{10,{0,1007041031,1}},{10,{0,1008011031,1}},{10,{0,1008021031,1}},{0,{0,1008031031,1}},{10,{0,1008041031,1}},{0,{0,1009001031,1}},{10,{0,1010011031,1}},{10,{0,1010021031,1}},{0,{0,1010031031,1}},{10,{0,1010041031,1}}]','[{236,{0,17010001,1}},{31,{0,17010002,1}},{31,{0,38040010,1}},{118,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{118,{0,38130001,1}},{39,{0,11020001,1}},{55,{0,18020001,1}},{236,{0,38040102,1}},{24,{0,38100001,1}},{79,{0,38190001,1}}]','[{100,{0,38110004,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1011,2,'[{10,{0,1001011000,1}},{10,{0,1001021000,1}},{0,{0,1001031000,1}},{10,{0,1001041000,1}},{10,{0,1002011000,1}},{10,{0,1002021000,1}},{0,{0,1002031000,1}},{10,{0,1002041000,1}},{3,{0,1003001000,1}},{10,{0,1004011000,1}},{10,{0,1004021000,1}},{0,{0,1004031000,1}},{10,{0,1004041000,1}},{0,{0,1005001000,1}},{10,{0,1006011000,1}},{10,{0,1006021000,1}},{0,{0,1006031000,1}},{10,{0,1006041000,1}},{10,{0,1007011000,1}},{10,{0,1007021000,1}},{0,{0,1007031000,1}},{10,{0,1007041000,1}},{10,{0,1008011000,1}},{10,{0,1008021000,1}},{0,{0,1008031000,1}},{10,{0,1008041000,1}},{0,{0,1009001000,1}},{10,{0,1010011000,1}},{10,{0,1010021000,1}},{0,{0,1010031000,1}},{10,{0,1010041000,1}}]','[{10,{0,1001011010,1}},{10,{0,1001021010,1}},{0,{0,1001031010,1}},{10,{0,1001041010,1}},{10,{0,1002011010,1}},{10,{0,1002021010,1}},{0,{0,1002031010,1}},{10,{0,1002041010,1}},{3,{0,1003001010,1}},{10,{0,1004011010,1}},{10,{0,1004021010,1}},{0,{0,1004031010,1}},{10,{0,1004041010,1}},{0,{0,1005001010,1}},{10,{0,1006011010,1}},{10,{0,1006021010,1}},{0,{0,1006031010,1}},{10,{0,1006041010,1}},{10,{0,1007011010,1}},{10,{0,1007021010,1}},{0,{0,1007031010,1}},{10,{0,1007041010,1}},{10,{0,1008011010,1}},{10,{0,1008021010,1}},{0,{0,1008031010,1}},{10,{0,1008041010,1}},{0,{0,1009001010,1}},{10,{0,1010011010,1}},{10,{0,1010021010,1}},{0,{0,1010031010,1}},{10,{0,1010041010,1}}]','[{10,{0,1001011020,1}},{10,{0,1001021020,1}},{0,{0,1001031020,1}},{10,{0,1001041020,1}},{10,{0,1002011020,1}},{10,{0,1002021020,1}},{0,{0,1002031020,1}},{10,{0,1002041020,1}},{3,{0,1003001020,1}},{10,{0,1004011020,1}},{10,{0,1004021020,1}},{0,{0,1004031020,1}},{10,{0,1004041020,1}},{0,{0,1005001020,1}},{10,{0,1006011020,1}},{10,{0,1006021020,1}},{0,{0,1006031020,1}},{10,{0,1006041020,1}},{10,{0,1007011020,1}},{10,{0,1007021020,1}},{0,{0,1007031020,1}},{10,{0,1007041020,1}},{10,{0,1008011020,1}},{10,{0,1008021020,1}},{0,{0,1008031020,1}},{10,{0,1008041020,1}},{0,{0,1009001020,1}},{10,{0,1010011020,1}},{10,{0,1010021020,1}},{0,{0,1010031020,1}},{10,{0,1010041020,1}}]','[{10,{0,1001011031,1}},{10,{0,1001021031,1}},{0,{0,1001031031,1}},{10,{0,1001041031,1}},{10,{0,1002011031,1}},{10,{0,1002021031,1}},{0,{0,1002031031,1}},{10,{0,1002041031,1}},{3,{0,1003001031,1}},{10,{0,1004011031,1}},{10,{0,1004021031,1}},{0,{0,1004031031,1}},{10,{0,1004041031,1}},{0,{0,1005001031,1}},{10,{0,1006011031,1}},{10,{0,1006021031,1}},{0,{0,1006031031,1}},{10,{0,1006041031,1}},{10,{0,1007011031,1}},{10,{0,1007021031,1}},{0,{0,1007031031,1}},{10,{0,1007041031,1}},{10,{0,1008011031,1}},{10,{0,1008021031,1}},{0,{0,1008031031,1}},{10,{0,1008041031,1}},{0,{0,1009001031,1}},{10,{0,1010011031,1}},{10,{0,1010021031,1}},{0,{0,1010031031,1}},{10,{0,1010041031,1}}]','[{236,{0,17010001,1}},{31,{0,17010002,1}},{31,{0,38040010,1}},{118,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{118,{0,38130001,1}},{39,{0,11020001,1}},{55,{0,18020001,1}},{236,{0,38040102,1}},{24,{0,38100001,1}},{79,{0,38190001,1}}]','[{100,{0,38110005,1}},{100,{0,38110006,1}},{100,{0,38110007,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1011,3,'[{10,{0,1001011000,1}},{10,{0,1001021000,1}},{0,{0,1001031000,1}},{10,{0,1001041000,1}},{10,{0,1002011000,1}},{10,{0,1002021000,1}},{0,{0,1002031000,1}},{10,{0,1002041000,1}},{3,{0,1003001000,1}},{10,{0,1004011000,1}},{10,{0,1004021000,1}},{0,{0,1004031000,1}},{10,{0,1004041000,1}},{0,{0,1005001000,1}},{10,{0,1006011000,1}},{10,{0,1006021000,1}},{0,{0,1006031000,1}},{10,{0,1006041000,1}},{10,{0,1007011000,1}},{10,{0,1007021000,1}},{0,{0,1007031000,1}},{10,{0,1007041000,1}},{10,{0,1008011000,1}},{10,{0,1008021000,1}},{0,{0,1008031000,1}},{10,{0,1008041000,1}},{0,{0,1009001000,1}},{10,{0,1010011000,1}},{10,{0,1010021000,1}},{0,{0,1010031000,1}},{10,{0,1010041000,1}}]','[{10,{0,1001011010,1}},{10,{0,1001021010,1}},{0,{0,1001031010,1}},{10,{0,1001041010,1}},{10,{0,1002011010,1}},{10,{0,1002021010,1}},{0,{0,1002031010,1}},{10,{0,1002041010,1}},{3,{0,1003001010,1}},{10,{0,1004011010,1}},{10,{0,1004021010,1}},{0,{0,1004031010,1}},{10,{0,1004041010,1}},{0,{0,1005001010,1}},{10,{0,1006011010,1}},{10,{0,1006021010,1}},{0,{0,1006031010,1}},{10,{0,1006041010,1}},{10,{0,1007011010,1}},{10,{0,1007021010,1}},{0,{0,1007031010,1}},{10,{0,1007041010,1}},{10,{0,1008011010,1}},{10,{0,1008021010,1}},{0,{0,1008031010,1}},{10,{0,1008041010,1}},{0,{0,1009001010,1}},{10,{0,1010011010,1}},{10,{0,1010021010,1}},{0,{0,1010031010,1}},{10,{0,1010041010,1}}]','[{10,{0,1001011020,1}},{10,{0,1001021020,1}},{0,{0,1001031020,1}},{10,{0,1001041020,1}},{10,{0,1002011020,1}},{10,{0,1002021020,1}},{0,{0,1002031020,1}},{10,{0,1002041020,1}},{3,{0,1003001020,1}},{10,{0,1004011020,1}},{10,{0,1004021020,1}},{0,{0,1004031020,1}},{10,{0,1004041020,1}},{0,{0,1005001020,1}},{10,{0,1006011020,1}},{10,{0,1006021020,1}},{0,{0,1006031020,1}},{10,{0,1006041020,1}},{10,{0,1007011020,1}},{10,{0,1007021020,1}},{0,{0,1007031020,1}},{10,{0,1007041020,1}},{10,{0,1008011020,1}},{10,{0,1008021020,1}},{0,{0,1008031020,1}},{10,{0,1008041020,1}},{0,{0,1009001020,1}},{10,{0,1010011020,1}},{10,{0,1010021020,1}},{0,{0,1010031020,1}},{10,{0,1010041020,1}}]','[{10,{0,1001011031,1}},{10,{0,1001021031,1}},{0,{0,1001031031,1}},{10,{0,1001041031,1}},{10,{0,1002011031,1}},{10,{0,1002021031,1}},{0,{0,1002031031,1}},{10,{0,1002041031,1}},{3,{0,1003001031,1}},{10,{0,1004011031,1}},{10,{0,1004021031,1}},{0,{0,1004031031,1}},{10,{0,1004041031,1}},{0,{0,1005001031,1}},{10,{0,1006011031,1}},{10,{0,1006021031,1}},{0,{0,1006031031,1}},{10,{0,1006041031,1}},{10,{0,1007011031,1}},{10,{0,1007021031,1}},{0,{0,1007031031,1}},{10,{0,1007041031,1}},{10,{0,1008011031,1}},{10,{0,1008021031,1}},{0,{0,1008031031,1}},{10,{0,1008041031,1}},{0,{0,1009001031,1}},{10,{0,1010011031,1}},{10,{0,1010021031,1}},{0,{0,1010031031,1}},{10,{0,1010041031,1}}]','[{236,{0,17010001,1}},{31,{0,17010002,1}},{31,{0,38040010,1}},{118,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{118,{0,38130001,1}},{39,{0,11020001,1}},{55,{0,18020001,1}},{236,{0,38040102,1}},{24,{0,38100001,1}},{79,{0,38190001,1}}]','[{100,{0,38110005,1}},{100,{0,38110006,1}},{100,{0,38110007,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1011,4,'[{10,{0,1001011000,1}},{10,{0,1001021000,1}},{0,{0,1001031000,1}},{10,{0,1001041000,1}},{10,{0,1002011000,1}},{10,{0,1002021000,1}},{0,{0,1002031000,1}},{10,{0,1002041000,1}},{3,{0,1003001000,1}},{10,{0,1004011000,1}},{10,{0,1004021000,1}},{0,{0,1004031000,1}},{10,{0,1004041000,1}},{0,{0,1005001000,1}},{10,{0,1006011000,1}},{10,{0,1006021000,1}},{0,{0,1006031000,1}},{10,{0,1006041000,1}},{10,{0,1007011000,1}},{10,{0,1007021000,1}},{0,{0,1007031000,1}},{10,{0,1007041000,1}},{10,{0,1008011000,1}},{10,{0,1008021000,1}},{0,{0,1008031000,1}},{10,{0,1008041000,1}},{0,{0,1009001000,1}},{10,{0,1010011000,1}},{10,{0,1010021000,1}},{0,{0,1010031000,1}},{10,{0,1010041000,1}}]','[{10,{0,1001011010,1}},{10,{0,1001021010,1}},{0,{0,1001031010,1}},{10,{0,1001041010,1}},{10,{0,1002011010,1}},{10,{0,1002021010,1}},{0,{0,1002031010,1}},{10,{0,1002041010,1}},{3,{0,1003001010,1}},{10,{0,1004011010,1}},{10,{0,1004021010,1}},{0,{0,1004031010,1}},{10,{0,1004041010,1}},{0,{0,1005001010,1}},{10,{0,1006011010,1}},{10,{0,1006021010,1}},{0,{0,1006031010,1}},{10,{0,1006041010,1}},{10,{0,1007011010,1}},{10,{0,1007021010,1}},{0,{0,1007031010,1}},{10,{0,1007041010,1}},{10,{0,1008011010,1}},{10,{0,1008021010,1}},{0,{0,1008031010,1}},{10,{0,1008041010,1}},{0,{0,1009001010,1}},{10,{0,1010011010,1}},{10,{0,1010021010,1}},{0,{0,1010031010,1}},{10,{0,1010041010,1}}]','[{10,{0,1001011020,1}},{10,{0,1001021020,1}},{0,{0,1001031020,1}},{10,{0,1001041020,1}},{10,{0,1002011020,1}},{10,{0,1002021020,1}},{0,{0,1002031020,1}},{10,{0,1002041020,1}},{3,{0,1003001020,1}},{10,{0,1004011020,1}},{10,{0,1004021020,1}},{0,{0,1004031020,1}},{10,{0,1004041020,1}},{0,{0,1005001020,1}},{10,{0,1006011020,1}},{10,{0,1006021020,1}},{0,{0,1006031020,1}},{10,{0,1006041020,1}},{10,{0,1007011020,1}},{10,{0,1007021020,1}},{0,{0,1007031020,1}},{10,{0,1007041020,1}},{10,{0,1008011020,1}},{10,{0,1008021020,1}},{0,{0,1008031020,1}},{10,{0,1008041020,1}},{0,{0,1009001020,1}},{10,{0,1010011020,1}},{10,{0,1010021020,1}},{0,{0,1010031020,1}},{10,{0,1010041020,1}}]','[{10,{0,1001011031,1}},{10,{0,1001021031,1}},{0,{0,1001031031,1}},{10,{0,1001041031,1}},{10,{0,1002011031,1}},{10,{0,1002021031,1}},{0,{0,1002031031,1}},{10,{0,1002041031,1}},{3,{0,1003001031,1}},{10,{0,1004011031,1}},{10,{0,1004021031,1}},{0,{0,1004031031,1}},{10,{0,1004041031,1}},{0,{0,1005001031,1}},{10,{0,1006011031,1}},{10,{0,1006021031,1}},{0,{0,1006031031,1}},{10,{0,1006041031,1}},{10,{0,1007011031,1}},{10,{0,1007021031,1}},{0,{0,1007031031,1}},{10,{0,1007041031,1}},{10,{0,1008011031,1}},{10,{0,1008021031,1}},{0,{0,1008031031,1}},{10,{0,1008041031,1}},{0,{0,1009001031,1}},{10,{0,1010011031,1}},{10,{0,1010021031,1}},{0,{0,1010031031,1}},{10,{0,1010041031,1}}]','[{236,{0,17010001,1}},{31,{0,17010002,1}},{31,{0,38040010,1}},{118,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{118,{0,38130001,1}},{39,{0,11020001,1}},{55,{0,18020001,1}},{236,{0,38040102,1}},{24,{0,38100001,1}},{79,{0,38190001,1}}]','[{100,{0,38110005,1}},{100,{0,38110006,1}},{100,{0,38110007,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1011,5,'[{10,{0,1001011000,1}},{10,{0,1001021000,1}},{0,{0,1001031000,1}},{10,{0,1001041000,1}},{10,{0,1002011000,1}},{10,{0,1002021000,1}},{0,{0,1002031000,1}},{10,{0,1002041000,1}},{3,{0,1003001000,1}},{10,{0,1004011000,1}},{10,{0,1004021000,1}},{0,{0,1004031000,1}},{10,{0,1004041000,1}},{0,{0,1005001000,1}},{10,{0,1006011000,1}},{10,{0,1006021000,1}},{0,{0,1006031000,1}},{10,{0,1006041000,1}},{10,{0,1007011000,1}},{10,{0,1007021000,1}},{0,{0,1007031000,1}},{10,{0,1007041000,1}},{10,{0,1008011000,1}},{10,{0,1008021000,1}},{0,{0,1008031000,1}},{10,{0,1008041000,1}},{0,{0,1009001000,1}},{10,{0,1010011000,1}},{10,{0,1010021000,1}},{0,{0,1010031000,1}},{10,{0,1010041000,1}}]','[{10,{0,1001011010,1}},{10,{0,1001021010,1}},{0,{0,1001031010,1}},{10,{0,1001041010,1}},{10,{0,1002011010,1}},{10,{0,1002021010,1}},{0,{0,1002031010,1}},{10,{0,1002041010,1}},{3,{0,1003001010,1}},{10,{0,1004011010,1}},{10,{0,1004021010,1}},{0,{0,1004031010,1}},{10,{0,1004041010,1}},{0,{0,1005001010,1}},{10,{0,1006011010,1}},{10,{0,1006021010,1}},{0,{0,1006031010,1}},{10,{0,1006041010,1}},{10,{0,1007011010,1}},{10,{0,1007021010,1}},{0,{0,1007031010,1}},{10,{0,1007041010,1}},{10,{0,1008011010,1}},{10,{0,1008021010,1}},{0,{0,1008031010,1}},{10,{0,1008041010,1}},{0,{0,1009001010,1}},{10,{0,1010011010,1}},{10,{0,1010021010,1}},{0,{0,1010031010,1}},{10,{0,1010041010,1}}]','[{10,{0,1001011020,1}},{10,{0,1001021020,1}},{0,{0,1001031020,1}},{10,{0,1001041020,1}},{10,{0,1002011020,1}},{10,{0,1002021020,1}},{0,{0,1002031020,1}},{10,{0,1002041020,1}},{3,{0,1003001020,1}},{10,{0,1004011020,1}},{10,{0,1004021020,1}},{0,{0,1004031020,1}},{10,{0,1004041020,1}},{0,{0,1005001020,1}},{10,{0,1006011020,1}},{10,{0,1006021020,1}},{0,{0,1006031020,1}},{10,{0,1006041020,1}},{10,{0,1007011020,1}},{10,{0,1007021020,1}},{0,{0,1007031020,1}},{10,{0,1007041020,1}},{10,{0,1008011020,1}},{10,{0,1008021020,1}},{0,{0,1008031020,1}},{10,{0,1008041020,1}},{0,{0,1009001020,1}},{10,{0,1010011020,1}},{10,{0,1010021020,1}},{0,{0,1010031020,1}},{10,{0,1010041020,1}}]','[{10,{0,1001011031,1}},{10,{0,1001021031,1}},{0,{0,1001031031,1}},{10,{0,1001041031,1}},{10,{0,1002011031,1}},{10,{0,1002021031,1}},{0,{0,1002031031,1}},{10,{0,1002041031,1}},{3,{0,1003001031,1}},{10,{0,1004011031,1}},{10,{0,1004021031,1}},{0,{0,1004031031,1}},{10,{0,1004041031,1}},{0,{0,1005001031,1}},{10,{0,1006011031,1}},{10,{0,1006021031,1}},{0,{0,1006031031,1}},{10,{0,1006041031,1}},{10,{0,1007011031,1}},{10,{0,1007021031,1}},{0,{0,1007031031,1}},{10,{0,1007041031,1}},{10,{0,1008011031,1}},{10,{0,1008021031,1}},{0,{0,1008031031,1}},{10,{0,1008041031,1}},{0,{0,1009001031,1}},{10,{0,1010011031,1}},{10,{0,1010021031,1}},{0,{0,1010031031,1}},{10,{0,1010041031,1}}]','[{236,{0,17010001,1}},{31,{0,17010002,1}},{31,{0,38040010,1}},{118,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{118,{0,38130001,1}},{39,{0,11020001,1}},{55,{0,18020001,1}},{236,{0,38040102,1}},{24,{0,38100001,1}},{79,{0,38190001,1}}]','[{100,{0,38110005,1}},{100,{0,38110006,1}},{100,{0,38110007,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1011,6,'[{10,{0,1001011000,1}},{10,{0,1001021000,1}},{0,{0,1001031000,1}},{10,{0,1001041000,1}},{10,{0,1002011000,1}},{10,{0,1002021000,1}},{0,{0,1002031000,1}},{10,{0,1002041000,1}},{3,{0,1003001000,1}},{10,{0,1004011000,1}},{10,{0,1004021000,1}},{0,{0,1004031000,1}},{10,{0,1004041000,1}},{0,{0,1005001000,1}},{10,{0,1006011000,1}},{10,{0,1006021000,1}},{0,{0,1006031000,1}},{10,{0,1006041000,1}},{10,{0,1007011000,1}},{10,{0,1007021000,1}},{0,{0,1007031000,1}},{10,{0,1007041000,1}},{10,{0,1008011000,1}},{10,{0,1008021000,1}},{0,{0,1008031000,1}},{10,{0,1008041000,1}},{0,{0,1009001000,1}},{10,{0,1010011000,1}},{10,{0,1010021000,1}},{0,{0,1010031000,1}},{10,{0,1010041000,1}}]','[{10,{0,1001011010,1}},{10,{0,1001021010,1}},{0,{0,1001031010,1}},{10,{0,1001041010,1}},{10,{0,1002011010,1}},{10,{0,1002021010,1}},{0,{0,1002031010,1}},{10,{0,1002041010,1}},{3,{0,1003001010,1}},{10,{0,1004011010,1}},{10,{0,1004021010,1}},{0,{0,1004031010,1}},{10,{0,1004041010,1}},{0,{0,1005001010,1}},{10,{0,1006011010,1}},{10,{0,1006021010,1}},{0,{0,1006031010,1}},{10,{0,1006041010,1}},{10,{0,1007011010,1}},{10,{0,1007021010,1}},{0,{0,1007031010,1}},{10,{0,1007041010,1}},{10,{0,1008011010,1}},{10,{0,1008021010,1}},{0,{0,1008031010,1}},{10,{0,1008041010,1}},{0,{0,1009001010,1}},{10,{0,1010011010,1}},{10,{0,1010021010,1}},{0,{0,1010031010,1}},{10,{0,1010041010,1}}]','[{10,{0,1001011020,1}},{10,{0,1001021020,1}},{0,{0,1001031020,1}},{10,{0,1001041020,1}},{10,{0,1002011020,1}},{10,{0,1002021020,1}},{0,{0,1002031020,1}},{10,{0,1002041020,1}},{3,{0,1003001020,1}},{10,{0,1004011020,1}},{10,{0,1004021020,1}},{0,{0,1004031020,1}},{10,{0,1004041020,1}},{0,{0,1005001020,1}},{10,{0,1006011020,1}},{10,{0,1006021020,1}},{0,{0,1006031020,1}},{10,{0,1006041020,1}},{10,{0,1007011020,1}},{10,{0,1007021020,1}},{0,{0,1007031020,1}},{10,{0,1007041020,1}},{10,{0,1008011020,1}},{10,{0,1008021020,1}},{0,{0,1008031020,1}},{10,{0,1008041020,1}},{0,{0,1009001020,1}},{10,{0,1010011020,1}},{10,{0,1010021020,1}},{0,{0,1010031020,1}},{10,{0,1010041020,1}}]','[{10,{0,1001011031,1}},{10,{0,1001021031,1}},{0,{0,1001031031,1}},{10,{0,1001041031,1}},{10,{0,1002011031,1}},{10,{0,1002021031,1}},{0,{0,1002031031,1}},{10,{0,1002041031,1}},{3,{0,1003001031,1}},{10,{0,1004011031,1}},{10,{0,1004021031,1}},{0,{0,1004031031,1}},{10,{0,1004041031,1}},{0,{0,1005001031,1}},{10,{0,1006011031,1}},{10,{0,1006021031,1}},{0,{0,1006031031,1}},{10,{0,1006041031,1}},{10,{0,1007011031,1}},{10,{0,1007021031,1}},{0,{0,1007031031,1}},{10,{0,1007041031,1}},{10,{0,1008011031,1}},{10,{0,1008021031,1}},{0,{0,1008031031,1}},{10,{0,1008041031,1}},{0,{0,1009001031,1}},{10,{0,1010011031,1}},{10,{0,1010021031,1}},{0,{0,1010031031,1}},{10,{0,1010041031,1}}]','[{236,{0,17010001,1}},{31,{0,17010002,1}},{31,{0,38040010,1}},{118,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{118,{0,38130001,1}},{39,{0,11020001,1}},{55,{0,18020001,1}},{236,{0,38040102,1}},{24,{0,38100001,1}},{79,{0,38190001,1}}]','[{100,{0,38110005,1}},{100,{0,38110006,1}},{100,{0,38110007,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1011,7,'[{10,{0,1001011000,1}},{10,{0,1001021000,1}},{0,{0,1001031000,1}},{10,{0,1001041000,1}},{10,{0,1002011000,1}},{10,{0,1002021000,1}},{0,{0,1002031000,1}},{10,{0,1002041000,1}},{3,{0,1003001000,1}},{10,{0,1004011000,1}},{10,{0,1004021000,1}},{0,{0,1004031000,1}},{10,{0,1004041000,1}},{0,{0,1005001000,1}},{10,{0,1006011000,1}},{10,{0,1006021000,1}},{0,{0,1006031000,1}},{10,{0,1006041000,1}},{10,{0,1007011000,1}},{10,{0,1007021000,1}},{0,{0,1007031000,1}},{10,{0,1007041000,1}},{10,{0,1008011000,1}},{10,{0,1008021000,1}},{0,{0,1008031000,1}},{10,{0,1008041000,1}},{0,{0,1009001000,1}},{10,{0,1010011000,1}},{10,{0,1010021000,1}},{0,{0,1010031000,1}},{10,{0,1010041000,1}}]','[{10,{0,1001011010,1}},{10,{0,1001021010,1}},{0,{0,1001031010,1}},{10,{0,1001041010,1}},{10,{0,1002011010,1}},{10,{0,1002021010,1}},{0,{0,1002031010,1}},{10,{0,1002041010,1}},{3,{0,1003001010,1}},{10,{0,1004011010,1}},{10,{0,1004021010,1}},{0,{0,1004031010,1}},{10,{0,1004041010,1}},{0,{0,1005001010,1}},{10,{0,1006011010,1}},{10,{0,1006021010,1}},{0,{0,1006031010,1}},{10,{0,1006041010,1}},{10,{0,1007011010,1}},{10,{0,1007021010,1}},{0,{0,1007031010,1}},{10,{0,1007041010,1}},{10,{0,1008011010,1}},{10,{0,1008021010,1}},{0,{0,1008031010,1}},{10,{0,1008041010,1}},{0,{0,1009001010,1}},{10,{0,1010011010,1}},{10,{0,1010021010,1}},{0,{0,1010031010,1}},{10,{0,1010041010,1}}]','[{10,{0,1001011020,1}},{10,{0,1001021020,1}},{0,{0,1001031020,1}},{10,{0,1001041020,1}},{10,{0,1002011020,1}},{10,{0,1002021020,1}},{0,{0,1002031020,1}},{10,{0,1002041020,1}},{3,{0,1003001020,1}},{10,{0,1004011020,1}},{10,{0,1004021020,1}},{0,{0,1004031020,1}},{10,{0,1004041020,1}},{0,{0,1005001020,1}},{10,{0,1006011020,1}},{10,{0,1006021020,1}},{0,{0,1006031020,1}},{10,{0,1006041020,1}},{10,{0,1007011020,1}},{10,{0,1007021020,1}},{0,{0,1007031020,1}},{10,{0,1007041020,1}},{10,{0,1008011020,1}},{10,{0,1008021020,1}},{0,{0,1008031020,1}},{10,{0,1008041020,1}},{0,{0,1009001020,1}},{10,{0,1010011020,1}},{10,{0,1010021020,1}},{0,{0,1010031020,1}},{10,{0,1010041020,1}}]','[{10,{0,1001011031,1}},{10,{0,1001021031,1}},{0,{0,1001031031,1}},{10,{0,1001041031,1}},{10,{0,1002011031,1}},{10,{0,1002021031,1}},{0,{0,1002031031,1}},{10,{0,1002041031,1}},{3,{0,1003001031,1}},{10,{0,1004011031,1}},{10,{0,1004021031,1}},{0,{0,1004031031,1}},{10,{0,1004041031,1}},{0,{0,1005001031,1}},{10,{0,1006011031,1}},{10,{0,1006021031,1}},{0,{0,1006031031,1}},{10,{0,1006041031,1}},{10,{0,1007011031,1}},{10,{0,1007021031,1}},{0,{0,1007031031,1}},{10,{0,1007041031,1}},{10,{0,1008011031,1}},{10,{0,1008021031,1}},{0,{0,1008031031,1}},{10,{0,1008041031,1}},{0,{0,1009001031,1}},{10,{0,1010011031,1}},{10,{0,1010021031,1}},{0,{0,1010031031,1}},{10,{0,1010041031,1}}]','[{236,{0,17010001,1}},{31,{0,17010002,1}},{31,{0,38040010,1}},{118,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{118,{0,38130001,1}},{39,{0,11020001,1}},{55,{0,18020001,1}},{236,{0,38040102,1}},{24,{0,38100001,1}},{79,{0,38190001,1}}]','[{100,{0,38110005,1}},{100,{0,38110006,1}},{100,{0,38110007,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1011,8,'[{10,{0,1001011000,1}},{10,{0,1001021000,1}},{0,{0,1001031000,1}},{10,{0,1001041000,1}},{10,{0,1002011000,1}},{10,{0,1002021000,1}},{0,{0,1002031000,1}},{10,{0,1002041000,1}},{3,{0,1003001000,1}},{10,{0,1004011000,1}},{10,{0,1004021000,1}},{0,{0,1004031000,1}},{10,{0,1004041000,1}},{0,{0,1005001000,1}},{10,{0,1006011000,1}},{10,{0,1006021000,1}},{0,{0,1006031000,1}},{10,{0,1006041000,1}},{10,{0,1007011000,1}},{10,{0,1007021000,1}},{0,{0,1007031000,1}},{10,{0,1007041000,1}},{10,{0,1008011000,1}},{10,{0,1008021000,1}},{0,{0,1008031000,1}},{10,{0,1008041000,1}},{0,{0,1009001000,1}},{10,{0,1010011000,1}},{10,{0,1010021000,1}},{0,{0,1010031000,1}},{10,{0,1010041000,1}}]','[{10,{0,1001011010,1}},{10,{0,1001021010,1}},{0,{0,1001031010,1}},{10,{0,1001041010,1}},{10,{0,1002011010,1}},{10,{0,1002021010,1}},{0,{0,1002031010,1}},{10,{0,1002041010,1}},{3,{0,1003001010,1}},{10,{0,1004011010,1}},{10,{0,1004021010,1}},{0,{0,1004031010,1}},{10,{0,1004041010,1}},{0,{0,1005001010,1}},{10,{0,1006011010,1}},{10,{0,1006021010,1}},{0,{0,1006031010,1}},{10,{0,1006041010,1}},{10,{0,1007011010,1}},{10,{0,1007021010,1}},{0,{0,1007031010,1}},{10,{0,1007041010,1}},{10,{0,1008011010,1}},{10,{0,1008021010,1}},{0,{0,1008031010,1}},{10,{0,1008041010,1}},{0,{0,1009001010,1}},{10,{0,1010011010,1}},{10,{0,1010021010,1}},{0,{0,1010031010,1}},{10,{0,1010041010,1}}]','[{10,{0,1001011020,1}},{10,{0,1001021020,1}},{0,{0,1001031020,1}},{10,{0,1001041020,1}},{10,{0,1002011020,1}},{10,{0,1002021020,1}},{0,{0,1002031020,1}},{10,{0,1002041020,1}},{3,{0,1003001020,1}},{10,{0,1004011020,1}},{10,{0,1004021020,1}},{0,{0,1004031020,1}},{10,{0,1004041020,1}},{0,{0,1005001020,1}},{10,{0,1006011020,1}},{10,{0,1006021020,1}},{0,{0,1006031020,1}},{10,{0,1006041020,1}},{10,{0,1007011020,1}},{10,{0,1007021020,1}},{0,{0,1007031020,1}},{10,{0,1007041020,1}},{10,{0,1008011020,1}},{10,{0,1008021020,1}},{0,{0,1008031020,1}},{10,{0,1008041020,1}},{0,{0,1009001020,1}},{10,{0,1010011020,1}},{10,{0,1010021020,1}},{0,{0,1010031020,1}},{10,{0,1010041020,1}}]','[{10,{0,1001011031,1}},{10,{0,1001021031,1}},{0,{0,1001031031,1}},{10,{0,1001041031,1}},{10,{0,1002011031,1}},{10,{0,1002021031,1}},{0,{0,1002031031,1}},{10,{0,1002041031,1}},{3,{0,1003001031,1}},{10,{0,1004011031,1}},{10,{0,1004021031,1}},{0,{0,1004031031,1}},{10,{0,1004041031,1}},{0,{0,1005001031,1}},{10,{0,1006011031,1}},{10,{0,1006021031,1}},{0,{0,1006031031,1}},{10,{0,1006041031,1}},{10,{0,1007011031,1}},{10,{0,1007021031,1}},{0,{0,1007031031,1}},{10,{0,1007041031,1}},{10,{0,1008011031,1}},{10,{0,1008021031,1}},{0,{0,1008031031,1}},{10,{0,1008041031,1}},{0,{0,1009001031,1}},{10,{0,1010011031,1}},{10,{0,1010021031,1}},{0,{0,1010031031,1}},{10,{0,1010041031,1}}]','[{236,{0,17010001,1}},{31,{0,17010002,1}},{31,{0,38040010,1}},{118,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{118,{0,38130001,1}},{39,{0,11020001,1}},{55,{0,18020001,1}},{236,{0,38040102,1}},{24,{0,38100001,1}},{79,{0,38190001,1}}]','[{100,{0,38110005,1}},{100,{0,38110006,1}},{100,{0,38110007,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1012,1,'[{10,{0,1001011500,1}},{10,{0,1001021500,1}},{0,{0,1001031500,1}},{10,{0,1001041500,1}},{10,{0,1002011500,1}},{10,{0,1002021500,1}},{0,{0,1002031500,1}},{10,{0,1002041500,1}},{3,{0,1003001500,1}},{10,{0,1004011500,1}},{10,{0,1004021500,1}},{0,{0,1004031500,1}},{10,{0,1004041500,1}},{0,{0,1005001500,1}},{10,{0,1006011500,1}},{10,{0,1006021500,1}},{0,{0,1006031500,1}},{10,{0,1006041500,1}},{10,{0,1007011500,1}},{10,{0,1007021500,1}},{0,{0,1007031500,1}},{10,{0,1007041500,1}},{10,{0,1008011500,1}},{10,{0,1008021500,1}},{0,{0,1008031500,1}},{10,{0,1008041500,1}},{0,{0,1009001500,1}},{10,{0,1010011500,1}},{10,{0,1010021500,1}},{0,{0,1010031500,1}},{10,{0,1010041500,1}}]','[{10,{0,1001011510,1}},{10,{0,1001021510,1}},{0,{0,1001031510,1}},{10,{0,1001041510,1}},{10,{0,1002011510,1}},{10,{0,1002021510,1}},{0,{0,1002031510,1}},{10,{0,1002041510,1}},{3,{0,1003001510,1}},{10,{0,1004011510,1}},{10,{0,1004021510,1}},{0,{0,1004031510,1}},{10,{0,1004041510,1}},{0,{0,1005001510,1}},{10,{0,1006011510,1}},{10,{0,1006021510,1}},{0,{0,1006031510,1}},{10,{0,1006041510,1}},{10,{0,1007011510,1}},{10,{0,1007021510,1}},{0,{0,1007031510,1}},{10,{0,1007041510,1}},{10,{0,1008011510,1}},{10,{0,1008021510,1}},{0,{0,1008031510,1}},{10,{0,1008041510,1}},{0,{0,1009001510,1}},{10,{0,1010011510,1}},{10,{0,1010021510,1}},{0,{0,1010031510,1}},{10,{0,1010041510,1}}]','[{10,{0,1001011520,1}},{10,{0,1001021520,1}},{0,{0,1001031520,1}},{10,{0,1001041520,1}},{10,{0,1002011520,1}},{10,{0,1002021520,1}},{0,{0,1002031520,1}},{10,{0,1002041520,1}},{3,{0,1003001520,1}},{10,{0,1004011520,1}},{10,{0,1004021520,1}},{0,{0,1004031520,1}},{10,{0,1004041520,1}},{0,{0,1005001520,1}},{10,{0,1006011520,1}},{10,{0,1006021520,1}},{0,{0,1006031520,1}},{10,{0,1006041520,1}},{10,{0,1007011520,1}},{10,{0,1007021520,1}},{0,{0,1007031520,1}},{10,{0,1007041520,1}},{10,{0,1008011520,1}},{10,{0,1008021520,1}},{0,{0,1008031520,1}},{10,{0,1008041520,1}},{0,{0,1009001520,1}},{10,{0,1010011520,1}},{10,{0,1010021520,1}},{0,{0,1010031520,1}},{10,{0,1010041520,1}}]','[{10,{0,1001011531,1}},{10,{0,1001021531,1}},{0,{0,1001031531,1}},{10,{0,1001041531,1}},{10,{0,1002011531,1}},{10,{0,1002021531,1}},{0,{0,1002031531,1}},{10,{0,1002041531,1}},{3,{0,1003001531,1}},{10,{0,1004011531,1}},{10,{0,1004021531,1}},{0,{0,1004031531,1}},{10,{0,1004041531,1}},{0,{0,1005001531,1}},{10,{0,1006011531,1}},{10,{0,1006021531,1}},{0,{0,1006031531,1}},{10,{0,1006041531,1}},{10,{0,1007011531,1}},{10,{0,1007021531,1}},{0,{0,1007031531,1}},{10,{0,1007041531,1}},{10,{0,1008011531,1}},{10,{0,1008021531,1}},{0,{0,1008031531,1}},{10,{0,1008041531,1}},{0,{0,1009001531,1}},{10,{0,1010011531,1}},{10,{0,1010021531,1}},{0,{0,1010031531,1}},{10,{0,1010041531,1}}]','[{236,{0,17010001,1}},{31,{0,17010002,1}},{31,{0,38040010,1}},{118,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{118,{0,38130001,1}},{39,{0,11020001,1}},{55,{0,18020001,1}},{236,{0,38040102,1}},{24,{0,38100001,1}},{79,{0,38190001,1}}]','[{100,{0,38110004,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1012,2,'[{10,{0,1001011000,1}},{10,{0,1001021000,1}},{0,{0,1001031000,1}},{10,{0,1001041000,1}},{10,{0,1002011000,1}},{10,{0,1002021000,1}},{0,{0,1002031000,1}},{10,{0,1002041000,1}},{3,{0,1003001000,1}},{10,{0,1004011000,1}},{10,{0,1004021000,1}},{0,{0,1004031000,1}},{10,{0,1004041000,1}},{0,{0,1005001000,1}},{10,{0,1006011000,1}},{10,{0,1006021000,1}},{0,{0,1006031000,1}},{10,{0,1006041000,1}},{10,{0,1007011000,1}},{10,{0,1007021000,1}},{0,{0,1007031000,1}},{10,{0,1007041000,1}},{10,{0,1008011000,1}},{10,{0,1008021000,1}},{0,{0,1008031000,1}},{10,{0,1008041000,1}},{0,{0,1009001000,1}},{10,{0,1010011000,1}},{10,{0,1010021000,1}},{0,{0,1010031000,1}},{10,{0,1010041000,1}}]','[{10,{0,1001011010,1}},{10,{0,1001021010,1}},{0,{0,1001031010,1}},{10,{0,1001041010,1}},{10,{0,1002011010,1}},{10,{0,1002021010,1}},{0,{0,1002031010,1}},{10,{0,1002041010,1}},{3,{0,1003001010,1}},{10,{0,1004011010,1}},{10,{0,1004021010,1}},{0,{0,1004031010,1}},{10,{0,1004041010,1}},{0,{0,1005001010,1}},{10,{0,1006011010,1}},{10,{0,1006021010,1}},{0,{0,1006031010,1}},{10,{0,1006041010,1}},{10,{0,1007011010,1}},{10,{0,1007021010,1}},{0,{0,1007031010,1}},{10,{0,1007041010,1}},{10,{0,1008011010,1}},{10,{0,1008021010,1}},{0,{0,1008031010,1}},{10,{0,1008041010,1}},{0,{0,1009001010,1}},{10,{0,1010011010,1}},{10,{0,1010021010,1}},{0,{0,1010031010,1}},{10,{0,1010041010,1}}]','[{10,{0,1001011020,1}},{10,{0,1001021020,1}},{0,{0,1001031020,1}},{10,{0,1001041020,1}},{10,{0,1002011020,1}},{10,{0,1002021020,1}},{0,{0,1002031020,1}},{10,{0,1002041020,1}},{3,{0,1003001020,1}},{10,{0,1004011020,1}},{10,{0,1004021020,1}},{0,{0,1004031020,1}},{10,{0,1004041020,1}},{0,{0,1005001020,1}},{10,{0,1006011020,1}},{10,{0,1006021020,1}},{0,{0,1006031020,1}},{10,{0,1006041020,1}},{10,{0,1007011020,1}},{10,{0,1007021020,1}},{0,{0,1007031020,1}},{10,{0,1007041020,1}},{10,{0,1008011020,1}},{10,{0,1008021020,1}},{0,{0,1008031020,1}},{10,{0,1008041020,1}},{0,{0,1009001020,1}},{10,{0,1010011020,1}},{10,{0,1010021020,1}},{0,{0,1010031020,1}},{10,{0,1010041020,1}}]','[{10,{0,1001011031,1}},{10,{0,1001021031,1}},{0,{0,1001031031,1}},{10,{0,1001041031,1}},{10,{0,1002011031,1}},{10,{0,1002021031,1}},{0,{0,1002031031,1}},{10,{0,1002041031,1}},{3,{0,1003001031,1}},{10,{0,1004011031,1}},{10,{0,1004021031,1}},{0,{0,1004031031,1}},{10,{0,1004041031,1}},{0,{0,1005001031,1}},{10,{0,1006011031,1}},{10,{0,1006021031,1}},{0,{0,1006031031,1}},{10,{0,1006041031,1}},{10,{0,1007011031,1}},{10,{0,1007021031,1}},{0,{0,1007031031,1}},{10,{0,1007041031,1}},{10,{0,1008011031,1}},{10,{0,1008021031,1}},{0,{0,1008031031,1}},{10,{0,1008041031,1}},{0,{0,1009001031,1}},{10,{0,1010011031,1}},{10,{0,1010021031,1}},{0,{0,1010031031,1}},{10,{0,1010041031,1}}]','[{236,{0,17010001,1}},{31,{0,17010002,1}},{31,{0,38040010,1}},{118,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{118,{0,38130001,1}},{39,{0,11020001,1}},{55,{0,18020001,1}},{236,{0,38040102,1}},{24,{0,38100001,1}},{79,{0,38190001,1}}]','[{100,{0,38110004,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1012,3,'[{10,{0,1001011200,1}},{10,{0,1001021200,1}},{0,{0,1001031200,1}},{10,{0,1001041200,1}},{10,{0,1002011200,1}},{10,{0,1002021200,1}},{0,{0,1002031200,1}},{10,{0,1002041200,1}},{3,{0,1003001200,1}},{10,{0,1004011200,1}},{10,{0,1004021200,1}},{0,{0,1004031200,1}},{10,{0,1004041200,1}},{0,{0,1005001200,1}},{10,{0,1006011200,1}},{10,{0,1006021200,1}},{0,{0,1006031200,1}},{10,{0,1006041200,1}},{10,{0,1007011200,1}},{10,{0,1007021200,1}},{0,{0,1007031200,1}},{10,{0,1007041200,1}},{10,{0,1008011200,1}},{10,{0,1008021200,1}},{0,{0,1008031200,1}},{10,{0,1008041200,1}},{0,{0,1009001200,1}},{10,{0,1010011200,1}},{10,{0,1010021200,1}},{0,{0,1010031200,1}},{10,{0,1010041200,1}}]','[{10,{0,1001011210,1}},{10,{0,1001021210,1}},{0,{0,1001031210,1}},{10,{0,1001041210,1}},{10,{0,1002011210,1}},{10,{0,1002021210,1}},{0,{0,1002031210,1}},{10,{0,1002041210,1}},{3,{0,1003001210,1}},{10,{0,1004011210,1}},{10,{0,1004021210,1}},{0,{0,1004031210,1}},{10,{0,1004041210,1}},{0,{0,1005001210,1}},{10,{0,1006011210,1}},{10,{0,1006021210,1}},{0,{0,1006031210,1}},{10,{0,1006041210,1}},{10,{0,1007011210,1}},{10,{0,1007021210,1}},{0,{0,1007031210,1}},{10,{0,1007041210,1}},{10,{0,1008011210,1}},{10,{0,1008021210,1}},{0,{0,1008031210,1}},{10,{0,1008041210,1}},{0,{0,1009001210,1}},{10,{0,1010011210,1}},{10,{0,1010021210,1}},{0,{0,1010031210,1}},{10,{0,1010041210,1}}]','[{10,{0,1001011220,1}},{10,{0,1001021220,1}},{0,{0,1001031220,1}},{10,{0,1001041220,1}},{10,{0,1002011220,1}},{10,{0,1002021220,1}},{0,{0,1002031220,1}},{10,{0,1002041220,1}},{3,{0,1003001220,1}},{10,{0,1004011220,1}},{10,{0,1004021220,1}},{0,{0,1004031220,1}},{10,{0,1004041220,1}},{0,{0,1005001220,1}},{10,{0,1006011220,1}},{10,{0,1006021220,1}},{0,{0,1006031220,1}},{10,{0,1006041220,1}},{10,{0,1007011220,1}},{10,{0,1007021220,1}},{0,{0,1007031220,1}},{10,{0,1007041220,1}},{10,{0,1008011220,1}},{10,{0,1008021220,1}},{0,{0,1008031220,1}},{10,{0,1008041220,1}},{0,{0,1009001220,1}},{10,{0,1010011220,1}},{10,{0,1010021220,1}},{0,{0,1010031220,1}},{10,{0,1010041220,1}}]','[{10,{0,1001011231,1}},{10,{0,1001021231,1}},{0,{0,1001031231,1}},{10,{0,1001041231,1}},{10,{0,1002011231,1}},{10,{0,1002021231,1}},{0,{0,1002031231,1}},{10,{0,1002041231,1}},{3,{0,1003001231,1}},{10,{0,1004011231,1}},{10,{0,1004021231,1}},{0,{0,1004031231,1}},{10,{0,1004041231,1}},{0,{0,1005001231,1}},{10,{0,1006011231,1}},{10,{0,1006021231,1}},{0,{0,1006031231,1}},{10,{0,1006041231,1}},{10,{0,1007011231,1}},{10,{0,1007021231,1}},{0,{0,1007031231,1}},{10,{0,1007041231,1}},{10,{0,1008011231,1}},{10,{0,1008021231,1}},{0,{0,1008031231,1}},{10,{0,1008041231,1}},{0,{0,1009001231,1}},{10,{0,1010011231,1}},{10,{0,1010021231,1}},{0,{0,1010031231,1}},{10,{0,1010041231,1}}]','[{236,{0,17010001,1}},{31,{0,17010002,1}},{31,{0,38040010,1}},{118,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{118,{0,38130001,1}},{39,{0,11020001,1}},{55,{0,18020001,1}},{236,{0,38040102,1}},{24,{0,38100001,1}},{79,{0,38190001,1}}]','[{100,{0,38110004,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1012,4,'[{10,{0,1001011200,1}},{10,{0,1001021200,1}},{0,{0,1001031200,1}},{10,{0,1001041200,1}},{10,{0,1002011200,1}},{10,{0,1002021200,1}},{0,{0,1002031200,1}},{10,{0,1002041200,1}},{3,{0,1003001200,1}},{10,{0,1004011200,1}},{10,{0,1004021200,1}},{0,{0,1004031200,1}},{10,{0,1004041200,1}},{0,{0,1005001200,1}},{10,{0,1006011200,1}},{10,{0,1006021200,1}},{0,{0,1006031200,1}},{10,{0,1006041200,1}},{10,{0,1007011200,1}},{10,{0,1007021200,1}},{0,{0,1007031200,1}},{10,{0,1007041200,1}},{10,{0,1008011200,1}},{10,{0,1008021200,1}},{0,{0,1008031200,1}},{10,{0,1008041200,1}},{0,{0,1009001200,1}},{10,{0,1010011200,1}},{10,{0,1010021200,1}},{0,{0,1010031200,1}},{10,{0,1010041200,1}}]','[{10,{0,1001011210,1}},{10,{0,1001021210,1}},{0,{0,1001031210,1}},{10,{0,1001041210,1}},{10,{0,1002011210,1}},{10,{0,1002021210,1}},{0,{0,1002031210,1}},{10,{0,1002041210,1}},{3,{0,1003001210,1}},{10,{0,1004011210,1}},{10,{0,1004021210,1}},{0,{0,1004031210,1}},{10,{0,1004041210,1}},{0,{0,1005001210,1}},{10,{0,1006011210,1}},{10,{0,1006021210,1}},{0,{0,1006031210,1}},{10,{0,1006041210,1}},{10,{0,1007011210,1}},{10,{0,1007021210,1}},{0,{0,1007031210,1}},{10,{0,1007041210,1}},{10,{0,1008011210,1}},{10,{0,1008021210,1}},{0,{0,1008031210,1}},{10,{0,1008041210,1}},{0,{0,1009001210,1}},{10,{0,1010011210,1}},{10,{0,1010021210,1}},{0,{0,1010031210,1}},{10,{0,1010041210,1}}]','[{10,{0,1001011220,1}},{10,{0,1001021220,1}},{0,{0,1001031220,1}},{10,{0,1001041220,1}},{10,{0,1002011220,1}},{10,{0,1002021220,1}},{0,{0,1002031220,1}},{10,{0,1002041220,1}},{3,{0,1003001220,1}},{10,{0,1004011220,1}},{10,{0,1004021220,1}},{0,{0,1004031220,1}},{10,{0,1004041220,1}},{0,{0,1005001220,1}},{10,{0,1006011220,1}},{10,{0,1006021220,1}},{0,{0,1006031220,1}},{10,{0,1006041220,1}},{10,{0,1007011220,1}},{10,{0,1007021220,1}},{0,{0,1007031220,1}},{10,{0,1007041220,1}},{10,{0,1008011220,1}},{10,{0,1008021220,1}},{0,{0,1008031220,1}},{10,{0,1008041220,1}},{0,{0,1009001220,1}},{10,{0,1010011220,1}},{10,{0,1010021220,1}},{0,{0,1010031220,1}},{10,{0,1010041220,1}}]','[{10,{0,1001011231,1}},{10,{0,1001021231,1}},{0,{0,1001031231,1}},{10,{0,1001041231,1}},{10,{0,1002011231,1}},{10,{0,1002021231,1}},{0,{0,1002031231,1}},{10,{0,1002041231,1}},{3,{0,1003001231,1}},{10,{0,1004011231,1}},{10,{0,1004021231,1}},{0,{0,1004031231,1}},{10,{0,1004041231,1}},{0,{0,1005001231,1}},{10,{0,1006011231,1}},{10,{0,1006021231,1}},{0,{0,1006031231,1}},{10,{0,1006041231,1}},{10,{0,1007011231,1}},{10,{0,1007021231,1}},{0,{0,1007031231,1}},{10,{0,1007041231,1}},{10,{0,1008011231,1}},{10,{0,1008021231,1}},{0,{0,1008031231,1}},{10,{0,1008041231,1}},{0,{0,1009001231,1}},{10,{0,1010011231,1}},{10,{0,1010021231,1}},{0,{0,1010031231,1}},{10,{0,1010041231,1}}]','[{236,{0,17010001,1}},{31,{0,17010002,1}},{31,{0,38040010,1}},{118,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{118,{0,38130001,1}},{39,{0,11020001,1}},{55,{0,18020001,1}},{236,{0,38040102,1}},{24,{0,38100001,1}},{79,{0,38190001,1}}]','[{100,{0,38110004,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1012,5,'[{10,{0,1001011300,1}},{10,{0,1001021300,1}},{0,{0,1001031300,1}},{10,{0,1001041300,1}},{10,{0,1002011300,1}},{10,{0,1002021300,1}},{0,{0,1002031300,1}},{10,{0,1002041300,1}},{3,{0,1003001300,1}},{10,{0,1004011300,1}},{10,{0,1004021300,1}},{0,{0,1004031300,1}},{10,{0,1004041300,1}},{0,{0,1005001300,1}},{10,{0,1006011300,1}},{10,{0,1006021300,1}},{0,{0,1006031300,1}},{10,{0,1006041300,1}},{10,{0,1007011300,1}},{10,{0,1007021300,1}},{0,{0,1007031300,1}},{10,{0,1007041300,1}},{10,{0,1008011300,1}},{10,{0,1008021300,1}},{0,{0,1008031300,1}},{10,{0,1008041300,1}},{0,{0,1009001300,1}},{10,{0,1010011300,1}},{10,{0,1010021300,1}},{0,{0,1010031300,1}},{10,{0,1010041300,1}}]','[{10,{0,1001011310,1}},{10,{0,1001021310,1}},{0,{0,1001031310,1}},{10,{0,1001041310,1}},{10,{0,1002011310,1}},{10,{0,1002021310,1}},{0,{0,1002031310,1}},{10,{0,1002041310,1}},{3,{0,1003001310,1}},{10,{0,1004011310,1}},{10,{0,1004021310,1}},{0,{0,1004031310,1}},{10,{0,1004041310,1}},{0,{0,1005001310,1}},{10,{0,1006011310,1}},{10,{0,1006021310,1}},{0,{0,1006031310,1}},{10,{0,1006041310,1}},{10,{0,1007011310,1}},{10,{0,1007021310,1}},{0,{0,1007031310,1}},{10,{0,1007041310,1}},{10,{0,1008011310,1}},{10,{0,1008021310,1}},{0,{0,1008031310,1}},{10,{0,1008041310,1}},{0,{0,1009001310,1}},{10,{0,1010011310,1}},{10,{0,1010021310,1}},{0,{0,1010031310,1}},{10,{0,1010041310,1}}]','[{10,{0,1001011320,1}},{10,{0,1001021320,1}},{0,{0,1001031320,1}},{10,{0,1001041320,1}},{10,{0,1002011320,1}},{10,{0,1002021320,1}},{0,{0,1002031320,1}},{10,{0,1002041320,1}},{3,{0,1003001320,1}},{10,{0,1004011320,1}},{10,{0,1004021320,1}},{0,{0,1004031320,1}},{10,{0,1004041320,1}},{0,{0,1005001320,1}},{10,{0,1006011320,1}},{10,{0,1006021320,1}},{0,{0,1006031320,1}},{10,{0,1006041320,1}},{10,{0,1007011320,1}},{10,{0,1007021320,1}},{0,{0,1007031320,1}},{10,{0,1007041320,1}},{10,{0,1008011320,1}},{10,{0,1008021320,1}},{0,{0,1008031320,1}},{10,{0,1008041320,1}},{0,{0,1009001320,1}},{10,{0,1010011320,1}},{10,{0,1010021320,1}},{0,{0,1010031320,1}},{10,{0,1010041320,1}}]','[{10,{0,1001011331,1}},{10,{0,1001021331,1}},{0,{0,1001031331,1}},{10,{0,1001041331,1}},{10,{0,1002011331,1}},{10,{0,1002021331,1}},{0,{0,1002031331,1}},{10,{0,1002041331,1}},{3,{0,1003001331,1}},{10,{0,1004011331,1}},{10,{0,1004021331,1}},{0,{0,1004031331,1}},{10,{0,1004041331,1}},{0,{0,1005001331,1}},{10,{0,1006011331,1}},{10,{0,1006021331,1}},{0,{0,1006031331,1}},{10,{0,1006041331,1}},{10,{0,1007011331,1}},{10,{0,1007021331,1}},{0,{0,1007031331,1}},{10,{0,1007041331,1}},{10,{0,1008011331,1}},{10,{0,1008021331,1}},{0,{0,1008031331,1}},{10,{0,1008041331,1}},{0,{0,1009001331,1}},{10,{0,1010011331,1}},{10,{0,1010021331,1}},{0,{0,1010031331,1}},{10,{0,1010041331,1}}]','[{236,{0,17010001,1}},{31,{0,17010002,1}},{31,{0,38040010,1}},{118,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{118,{0,38130001,1}},{39,{0,11020001,1}},{55,{0,18020001,1}},{236,{0,38040102,1}},{24,{0,38100001,1}},{79,{0,38190001,1}}]','[{100,{0,38110004,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1012,6,'[{10,{0,1001011400,1}},{10,{0,1001021400,1}},{0,{0,1001031400,1}},{10,{0,1001041400,1}},{10,{0,1002011400,1}},{10,{0,1002021400,1}},{0,{0,1002031400,1}},{10,{0,1002041400,1}},{3,{0,1003001400,1}},{10,{0,1004011400,1}},{10,{0,1004021400,1}},{0,{0,1004031400,1}},{10,{0,1004041400,1}},{0,{0,1005001400,1}},{10,{0,1006011400,1}},{10,{0,1006021400,1}},{0,{0,1006031400,1}},{10,{0,1006041400,1}},{10,{0,1007011400,1}},{10,{0,1007021400,1}},{0,{0,1007031400,1}},{10,{0,1007041400,1}},{10,{0,1008011400,1}},{10,{0,1008021400,1}},{0,{0,1008031400,1}},{10,{0,1008041400,1}},{0,{0,1009001400,1}},{10,{0,1010011400,1}},{10,{0,1010021400,1}},{0,{0,1010031400,1}},{10,{0,1010041400,1}}]','[{10,{0,1001011410,1}},{10,{0,1001021410,1}},{0,{0,1001031410,1}},{10,{0,1001041410,1}},{10,{0,1002011410,1}},{10,{0,1002021410,1}},{0,{0,1002031410,1}},{10,{0,1002041410,1}},{3,{0,1003001410,1}},{10,{0,1004011410,1}},{10,{0,1004021410,1}},{0,{0,1004031410,1}},{10,{0,1004041410,1}},{0,{0,1005001410,1}},{10,{0,1006011410,1}},{10,{0,1006021410,1}},{0,{0,1006031410,1}},{10,{0,1006041410,1}},{10,{0,1007011410,1}},{10,{0,1007021410,1}},{0,{0,1007031410,1}},{10,{0,1007041410,1}},{10,{0,1008011410,1}},{10,{0,1008021410,1}},{0,{0,1008031410,1}},{10,{0,1008041410,1}},{0,{0,1009001410,1}},{10,{0,1010011410,1}},{10,{0,1010021410,1}},{0,{0,1010031410,1}},{10,{0,1010041410,1}}]','[{10,{0,1001011420,1}},{10,{0,1001021420,1}},{0,{0,1001031420,1}},{10,{0,1001041420,1}},{10,{0,1002011420,1}},{10,{0,1002021420,1}},{0,{0,1002031420,1}},{10,{0,1002041420,1}},{3,{0,1003001420,1}},{10,{0,1004011420,1}},{10,{0,1004021420,1}},{0,{0,1004031420,1}},{10,{0,1004041420,1}},{0,{0,1005001420,1}},{10,{0,1006011420,1}},{10,{0,1006021420,1}},{0,{0,1006031420,1}},{10,{0,1006041420,1}},{10,{0,1007011420,1}},{10,{0,1007021420,1}},{0,{0,1007031420,1}},{10,{0,1007041420,1}},{10,{0,1008011420,1}},{10,{0,1008021420,1}},{0,{0,1008031420,1}},{10,{0,1008041420,1}},{0,{0,1009001420,1}},{10,{0,1010011420,1}},{10,{0,1010021420,1}},{0,{0,1010031420,1}},{10,{0,1010041420,1}}]','[{10,{0,1001011431,1}},{10,{0,1001021431,1}},{0,{0,1001031431,1}},{10,{0,1001041431,1}},{10,{0,1002011431,1}},{10,{0,1002021431,1}},{0,{0,1002031431,1}},{10,{0,1002041431,1}},{3,{0,1003001431,1}},{10,{0,1004011431,1}},{10,{0,1004021431,1}},{0,{0,1004031431,1}},{10,{0,1004041431,1}},{0,{0,1005001431,1}},{10,{0,1006011431,1}},{10,{0,1006021431,1}},{0,{0,1006031431,1}},{10,{0,1006041431,1}},{10,{0,1007011431,1}},{10,{0,1007021431,1}},{0,{0,1007031431,1}},{10,{0,1007041431,1}},{10,{0,1008011431,1}},{10,{0,1008021431,1}},{0,{0,1008031431,1}},{10,{0,1008041431,1}},{0,{0,1009001431,1}},{10,{0,1010011431,1}},{10,{0,1010021431,1}},{0,{0,1010031431,1}},{10,{0,1010041431,1}}]','[{236,{0,17010001,1}},{31,{0,17010002,1}},{31,{0,38040010,1}},{118,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{118,{0,38130001,1}},{39,{0,11020001,1}},{55,{0,18020001,1}},{236,{0,38040102,1}},{24,{0,38100001,1}},{79,{0,38190001,1}}]','[{100,{0,38110004,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1012,7,'[{10,{0,1001011500,1}},{10,{0,1001021500,1}},{0,{0,1001031500,1}},{10,{0,1001041500,1}},{10,{0,1002011500,1}},{10,{0,1002021500,1}},{0,{0,1002031500,1}},{10,{0,1002041500,1}},{3,{0,1003001500,1}},{10,{0,1004011500,1}},{10,{0,1004021500,1}},{0,{0,1004031500,1}},{10,{0,1004041500,1}},{0,{0,1005001500,1}},{10,{0,1006011500,1}},{10,{0,1006021500,1}},{0,{0,1006031500,1}},{10,{0,1006041500,1}},{10,{0,1007011500,1}},{10,{0,1007021500,1}},{0,{0,1007031500,1}},{10,{0,1007041500,1}},{10,{0,1008011500,1}},{10,{0,1008021500,1}},{0,{0,1008031500,1}},{10,{0,1008041500,1}},{0,{0,1009001500,1}},{10,{0,1010011500,1}},{10,{0,1010021500,1}},{0,{0,1010031500,1}},{10,{0,1010041500,1}}]','[{10,{0,1001011510,1}},{10,{0,1001021510,1}},{0,{0,1001031510,1}},{10,{0,1001041510,1}},{10,{0,1002011510,1}},{10,{0,1002021510,1}},{0,{0,1002031510,1}},{10,{0,1002041510,1}},{3,{0,1003001510,1}},{10,{0,1004011510,1}},{10,{0,1004021510,1}},{0,{0,1004031510,1}},{10,{0,1004041510,1}},{0,{0,1005001510,1}},{10,{0,1006011510,1}},{10,{0,1006021510,1}},{0,{0,1006031510,1}},{10,{0,1006041510,1}},{10,{0,1007011510,1}},{10,{0,1007021510,1}},{0,{0,1007031510,1}},{10,{0,1007041510,1}},{10,{0,1008011510,1}},{10,{0,1008021510,1}},{0,{0,1008031510,1}},{10,{0,1008041510,1}},{0,{0,1009001510,1}},{10,{0,1010011510,1}},{10,{0,1010021510,1}},{0,{0,1010031510,1}},{10,{0,1010041510,1}}]','[{10,{0,1001011520,1}},{10,{0,1001021520,1}},{0,{0,1001031520,1}},{10,{0,1001041520,1}},{10,{0,1002011520,1}},{10,{0,1002021520,1}},{0,{0,1002031520,1}},{10,{0,1002041520,1}},{3,{0,1003001520,1}},{10,{0,1004011520,1}},{10,{0,1004021520,1}},{0,{0,1004031520,1}},{10,{0,1004041520,1}},{0,{0,1005001520,1}},{10,{0,1006011520,1}},{10,{0,1006021520,1}},{0,{0,1006031520,1}},{10,{0,1006041520,1}},{10,{0,1007011520,1}},{10,{0,1007021520,1}},{0,{0,1007031520,1}},{10,{0,1007041520,1}},{10,{0,1008011520,1}},{10,{0,1008021520,1}},{0,{0,1008031520,1}},{10,{0,1008041520,1}},{0,{0,1009001520,1}},{10,{0,1010011520,1}},{10,{0,1010021520,1}},{0,{0,1010031520,1}},{10,{0,1010041520,1}}]','[{10,{0,1001011531,1}},{10,{0,1001021531,1}},{0,{0,1001031531,1}},{10,{0,1001041531,1}},{10,{0,1002011531,1}},{10,{0,1002021531,1}},{0,{0,1002031531,1}},{10,{0,1002041531,1}},{3,{0,1003001531,1}},{10,{0,1004011531,1}},{10,{0,1004021531,1}},{0,{0,1004031531,1}},{10,{0,1004041531,1}},{0,{0,1005001531,1}},{10,{0,1006011531,1}},{10,{0,1006021531,1}},{0,{0,1006031531,1}},{10,{0,1006041531,1}},{10,{0,1007011531,1}},{10,{0,1007021531,1}},{0,{0,1007031531,1}},{10,{0,1007041531,1}},{10,{0,1008011531,1}},{10,{0,1008021531,1}},{0,{0,1008031531,1}},{10,{0,1008041531,1}},{0,{0,1009001531,1}},{10,{0,1010011531,1}},{10,{0,1010021531,1}},{0,{0,1010031531,1}},{10,{0,1010041531,1}}]','[{236,{0,17010001,1}},{31,{0,17010002,1}},{31,{0,38040010,1}},{118,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{118,{0,38130001,1}},{39,{0,11020001,1}},{55,{0,18020001,1}},{236,{0,38040102,1}},{24,{0,38100001,1}},{79,{0,38190001,1}}]','[{100,{0,38110004,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]'),(1012,8,'[{10,{0,1001011500,1}},{10,{0,1001021500,1}},{0,{0,1001031500,1}},{10,{0,1001041500,1}},{10,{0,1002011500,1}},{10,{0,1002021500,1}},{0,{0,1002031500,1}},{10,{0,1002041500,1}},{3,{0,1003001500,1}},{10,{0,1004011500,1}},{10,{0,1004021500,1}},{0,{0,1004031500,1}},{10,{0,1004041500,1}},{0,{0,1005001500,1}},{10,{0,1006011500,1}},{10,{0,1006021500,1}},{0,{0,1006031500,1}},{10,{0,1006041500,1}},{10,{0,1007011500,1}},{10,{0,1007021500,1}},{0,{0,1007031500,1}},{10,{0,1007041500,1}},{10,{0,1008011500,1}},{10,{0,1008021500,1}},{0,{0,1008031500,1}},{10,{0,1008041500,1}},{0,{0,1009001500,1}},{10,{0,1010011500,1}},{10,{0,1010021500,1}},{0,{0,1010031500,1}},{10,{0,1010041500,1}}]','[{10,{0,1001011510,1}},{10,{0,1001021510,1}},{0,{0,1001031510,1}},{10,{0,1001041510,1}},{10,{0,1002011510,1}},{10,{0,1002021510,1}},{0,{0,1002031510,1}},{10,{0,1002041510,1}},{3,{0,1003001510,1}},{10,{0,1004011510,1}},{10,{0,1004021510,1}},{0,{0,1004031510,1}},{10,{0,1004041510,1}},{0,{0,1005001510,1}},{10,{0,1006011510,1}},{10,{0,1006021510,1}},{0,{0,1006031510,1}},{10,{0,1006041510,1}},{10,{0,1007011510,1}},{10,{0,1007021510,1}},{0,{0,1007031510,1}},{10,{0,1007041510,1}},{10,{0,1008011510,1}},{10,{0,1008021510,1}},{0,{0,1008031510,1}},{10,{0,1008041510,1}},{0,{0,1009001510,1}},{10,{0,1010011510,1}},{10,{0,1010021510,1}},{0,{0,1010031510,1}},{10,{0,1010041510,1}}]','[{10,{0,1001011520,1}},{10,{0,1001021520,1}},{0,{0,1001031520,1}},{10,{0,1001041520,1}},{10,{0,1002011520,1}},{10,{0,1002021520,1}},{0,{0,1002031520,1}},{10,{0,1002041520,1}},{3,{0,1003001520,1}},{10,{0,1004011520,1}},{10,{0,1004021520,1}},{0,{0,1004031520,1}},{10,{0,1004041520,1}},{0,{0,1005001520,1}},{10,{0,1006011520,1}},{10,{0,1006021520,1}},{0,{0,1006031520,1}},{10,{0,1006041520,1}},{10,{0,1007011520,1}},{10,{0,1007021520,1}},{0,{0,1007031520,1}},{10,{0,1007041520,1}},{10,{0,1008011520,1}},{10,{0,1008021520,1}},{0,{0,1008031520,1}},{10,{0,1008041520,1}},{0,{0,1009001520,1}},{10,{0,1010011520,1}},{10,{0,1010021520,1}},{0,{0,1010031520,1}},{10,{0,1010041520,1}}]','[{10,{0,1001011531,1}},{10,{0,1001021531,1}},{0,{0,1001031531,1}},{10,{0,1001041531,1}},{10,{0,1002011531,1}},{10,{0,1002021531,1}},{0,{0,1002031531,1}},{10,{0,1002041531,1}},{3,{0,1003001531,1}},{10,{0,1004011531,1}},{10,{0,1004021531,1}},{0,{0,1004031531,1}},{10,{0,1004041531,1}},{0,{0,1005001531,1}},{10,{0,1006011531,1}},{10,{0,1006021531,1}},{0,{0,1006031531,1}},{10,{0,1006041531,1}},{10,{0,1007011531,1}},{10,{0,1007021531,1}},{0,{0,1007031531,1}},{10,{0,1007041531,1}},{10,{0,1008011531,1}},{10,{0,1008021531,1}},{0,{0,1008031531,1}},{10,{0,1008041531,1}},{0,{0,1009001531,1}},{10,{0,1010011531,1}},{10,{0,1010021531,1}},{0,{0,1010031531,1}},{10,{0,1010041531,1}}]','[{236,{0,17010001,1}},{31,{0,17010002,1}},{31,{0,38040010,1}},{118,{0,38330001,1}},{16,{0,38030006,1}},{16,{0,38030007,1}},{118,{0,38130001,1}},{39,{0,11020001,1}},{55,{0,18020001,1}},{236,{0,38040102,1}},{24,{0,38100001,1}},{79,{0,38190001,1}}]','[{100,{0,38110004,1}}]','[{{4,1},[{20,{0,38040013,1}},{20,{0,38040014,1}},{13,{0,38040015,1}},{13,{0,38040016,1}},{1,{0,38040017,1}}]}]');
/*!40000 ALTER TABLE `base_onhook_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_optional_gift`
--

DROP TABLE IF EXISTS `base_optional_gift`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_optional_gift` (
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '礼包id',
  `career` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '职业',
  `optional_num` tinyint(2) unsigned NOT NULL DEFAULT '1' COMMENT '自选数量',
  `list` varchar(2000) NOT NULL DEFAULT '[]' COMMENT '物品列表',
  PRIMARY KEY (`goods_id`,`career`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='自选宝箱';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_optional_gift`
--

LOCK TABLES `base_optional_gift` WRITE;
/*!40000 ALTER TABLE `base_optional_gift` DISABLE KEYS */;
INSERT INTO `base_optional_gift` VALUES (34010001,1,1,'[{1,{0,1001010863,1}},{2,{0,1007010863,1}}]'),(34010001,2,1,'[{1,{0,1001020863,1}},{2,{0,1007020863,1}}]'),(34010001,3,1,'[{1,{0,1001030863,1}},{2,{0,1007030863,1}}]'),(34010001,4,1,'[{1,{0,1001040863,1}},{2,{0,1007040863,1}}]'),(34010002,0,1,'[{1,{0,1003000863,1}}]'),(34010003,0,1,'[{1,{0,14010101,1}},{2,{0,14010301,1}},{3,{0,14010501,1}},{4,{0,14010701,1}}]'),(34010004,0,1,'[{1,{0,14020201,1}},{2,{0,14020401,1}},{3,{0,14020601,1}},{4,{0,14020801,1}}]'),(34010005,0,1,'[{1,{0,14010102,1}},{2,{0,14010302,1}},{3,{0,14010502,1}},{4,{0,14010702,1}}]'),(34010006,0,1,'[{1,{0,14020202,1}},{2,{0,14020402,1}},{3,{0,14020602,1}},{4,{0,14020802,1}}]'),(34010007,0,1,'[{1,{0,14010103,1}},{2,{0,14010303,1}},{3,{0,14010503,1}},{4,{0,14010703,1}}]'),(34010008,0,1,'[{1,{0,14020203,1}},{2,{0,14020403,1}},{3,{0,14020603,1}},{4,{0,14020803,1}}]'),(34010009,0,1,'[{1,{0,14010104,1}},{2,{0,14010304,1}},{3,{0,14010504,1}},{4,{0,14010704,1}}]'),(34010010,0,1,'[{1,{0,14020204,1}},{2,{0,14020404,1}},{3,{0,14020604,1}},{4,{0,14020804,1}}]'),(34010011,0,1,'[{1,{0,14010105,1}},{2,{0,14010305,1}},{3,{0,14010505,1}},{4,{0,14010705,1}}]'),(34010012,0,1,'[{1,{0,14020205,1}},{2,{0,14020405,1}},{3,{0,14020605,1}},{4,{0,14020805,1}}]'),(34010013,0,1,'[{1,{0,14010106,1}},{2,{0,14010306,1}},{3,{0,14010506,1}},{4,{0,14010706,1}}]'),(34010014,0,1,'[{1,{0,14020206,1}},{2,{0,14020406,1}},{3,{0,14020606,1}},{4,{0,14020806,1}}]'),(34010015,0,1,'[{1,{0,14010107,1}},{2,{0,14010307,1}},{3,{0,14010507,1}},{4,{0,14010707,1}}]'),(34010016,0,1,'[{1,{0,14020207,1}},{2,{0,14020407,1}},{3,{0,14020607,1}},{4,{0,14020807,1}}]'),(34010017,0,1,'[{1,{0,14010108,1}},{2,{0,14010308,1}},{3,{0,14010508,1}},{4,{0,14010708,1}}]'),(34010018,0,1,'[{1,{0,14020208,1}},{2,{0,14020408,1}},{3,{0,14020608,1}},{4,{0,14020808,1}}]'),(34010019,0,1,'[{1,{0,14010109,1}},{2,{0,14010309,1}},{3,{0,14010509,1}},{4,{0,14010709,1}}]'),(34010020,0,1,'[{1,{0,14020209,1}},{2,{0,14020409,1}},{3,{0,14020609,1}},{4,{0,14020809,1}}]'),(34010021,0,1,'[{1,{0,18041006,4}},{2,{0,18041003,4}},{3,{0,18041002,4}}]'),(34010022,0,1,'[{1,{0,18040003,1}},{2,{0,18040004,1}},{3,{0,18040002,1}}]'),(34010023,0,1,'[{1,{0,38150002,1}},{2,{0,38150007,1}}]'),(34010024,0,1,'[]'),(34010025,0,1,'[]'),(34010026,0,1,'[{1,{0,11040003,1}},{2,{0,11040004,1}},{3,{0,11040005,1}}]'),(34010027,0,1,'[{1,{100,18041002,1}},{2,{100,18041003,1}},{3,{100,18041004,1}},{4,{100,18041005,1}},{5,{100,18041006,1}},{6,{100,18041007,1}}]'),(34010028,0,1,'[]'),(34020001,0,1,'[{1,{0,16040101,1}},{2,{0,16040201,1}},{3,{0,16040301,1}},{4,{0,16040401,1}},{5,{0,16040501,1}},{6,{0,16040601,1}}]'),(34020002,0,1,'[{1,{0,16040102,1}},{2,{0,16040202,1}},{3,{0,16040302,1}},{4,{0,16040402,1}},{5,{0,16040502,1}},{6,{0,16040602,1}}]'),(34020003,0,1,'[{1,{0,16040103,1}},{2,{0,16040203,1}},{3,{0,16040303,1}},{4,{0,16040403,1}},{5,{0,16040503,1}},{6,{0,16040603,1}}]'),(34020004,0,1,'[{1,{0,16040104,1}},{2,{0,16040204,1}},{3,{0,16040304,1}},{4,{0,16040404,1}},{5,{0,16040504,1}},{6,{0,16040604,1}}]'),(34020005,0,1,'[{1,{0,16040105,1}},{2,{0,16040205,1}},{3,{0,16040305,1}},{4,{0,16040405,1}},{5,{0,16040505,1}},{6,{0,16040605,1}}]'),(34020101,0,1,'[{1,{0,16040111,1}},{2,{0,16040211,1}},{3,{0,16040311,1}},{4,{0,16040411,1}},{5,{0,16040511,1}},{6,{0,16040611,1}}]'),(34020102,0,1,'[{1,{0,16040112,1}},{2,{0,16040212,1}},{3,{0,16040312,1}},{4,{0,16040412,1}},{5,{0,16040512,1}},{6,{0,16040612,1}}]'),(34020103,0,1,'[{1,{0,16040113,1}},{2,{0,16040213,1}},{3,{0,16040313,1}},{4,{0,16040413,1}},{5,{0,16040513,1}},{6,{0,16040613,1}}]'),(34020104,0,1,'[{1,{0,16040114,1}},{2,{0,16040214,1}},{3,{0,16040314,1}},{4,{0,16040414,1}},{5,{0,16040514,1}},{6,{0,16040614,1}}]'),(34020105,0,1,'[{1,{0,16040115,1}},{2,{0,16040215,1}},{3,{0,16040315,1}},{4,{0,16040415,1}},{5,{0,16040515,1}},{6,{0,16040615,1}}]'),(34020201,0,1,'[{1,{0,16040121,1}},{2,{0,16040221,1}},{3,{0,16040321,1}},{4,{0,16040421,1}},{5,{0,16040521,1}},{6,{0,16040621,1}}]'),(34020202,0,1,'[{1,{0,16040122,1}},{2,{0,16040222,1}},{3,{0,16040322,1}},{4,{0,16040422,1}},{5,{0,16040522,1}},{6,{0,16040622,1}}]'),(34020203,0,1,'[{1,{0,16040123,1}},{2,{0,16040223,1}},{3,{0,16040323,1}},{4,{0,16040423,1}},{5,{0,16040523,1}},{6,{0,16040623,1}}]'),(34020204,0,1,'[{1,{0,16040124,1}},{2,{0,16040224,1}},{3,{0,16040324,1}},{4,{0,16040424,1}},{5,{0,16040524,1}},{6,{0,16040624,1}}]'),(34020205,0,1,'[{1,{0,16040125,1}},{2,{0,16040225,1}},{3,{0,16040325,1}},{4,{0,16040425,1}},{5,{0,16040525,1}},{6,{0,16040625,1}}]'),(34020301,0,1,'[{1,{0,16040131,1}},{2,{0,16040231,1}},{3,{0,16040331,1}},{4,{0,16040431,1}},{5,{0,16040531,1}},{6,{0,16040631,1}}]'),(34020302,0,1,'[{1,{0,16040132,1}},{2,{0,16040232,1}},{3,{0,16040332,1}},{4,{0,16040432,1}},{5,{0,16040532,1}},{6,{0,16040632,1}}]'),(34020303,0,1,'[{1,{0,16040133,1}},{2,{0,16040233,1}},{3,{0,16040333,1}},{4,{0,16040433,1}},{5,{0,16040533,1}},{6,{0,16040633,1}}]'),(34020304,0,1,'[{1,{0,16040134,1}},{2,{0,16040234,1}},{3,{0,16040334,1}},{4,{0,16040434,1}},{5,{0,16040534,1}},{6,{0,16040634,1}}]'),(34020305,0,1,'[{1,{0,16040135,1}},{2,{0,16040235,1}},{3,{0,16040335,1}},{4,{0,16040435,1}},{5,{0,16040535,1}},{6,{0,16040635,1}}]'),(34020401,0,1,'[{1,{0,16040141,1}},{2,{0,16040241,1}},{3,{0,16040341,1}},{4,{0,16040441,1}},{5,{0,16040541,1}},{6,{0,16040641,1}}]'),(34020402,0,1,'[{1,{0,16040142,1}},{2,{0,16040242,1}},{3,{0,16040342,1}},{4,{0,16040442,1}},{5,{0,16040542,1}},{6,{0,16040642,1}}]'),(34020403,0,1,'[{1,{0,16040143,1}},{2,{0,16040243,1}},{3,{0,16040343,1}},{4,{0,16040443,1}},{5,{0,16040543,1}},{6,{0,16040643,1}}]'),(34020404,0,1,'[{1,{0,16040144,1}},{2,{0,16040244,1}},{3,{0,16040344,1}},{4,{0,16040444,1}},{5,{0,16040544,1}},{6,{0,16040644,1}}]'),(34020405,0,1,'[{1,{0,16040145,1}},{2,{0,16040245,1}},{3,{0,16040345,1}},{4,{0,16040445,1}},{5,{0,16040545,1}},{6,{0,16040645,1}}]'),(34020501,0,1,'[{1,{0,16040151,1}},{2,{0,16040251,1}},{3,{0,16040351,1}},{4,{0,16040451,1}},{5,{0,16040551,1}},{6,{0,16040651,1}}]'),(34020502,0,1,'[{1,{0,16040152,1}},{2,{0,16040252,1}},{3,{0,16040352,1}},{4,{0,16040452,1}},{5,{0,16040552,1}},{6,{0,16040652,1}}]'),(34020503,0,1,'[{1,{0,16040153,1}},{2,{0,16040253,1}},{3,{0,16040353,1}},{4,{0,16040453,1}},{5,{0,16040553,1}},{6,{0,16040653,1}}]'),(34020504,0,1,'[{1,{0,16040154,1}},{2,{0,16040254,1}},{3,{0,16040354,1}},{4,{0,16040454,1}},{5,{0,16040554,1}},{6,{0,16040654,1}}]'),(34020505,0,1,'[{1,{0,16040155,1}},{2,{0,16040255,1}},{3,{0,16040355,1}},{4,{0,16040455,1}},{5,{0,16040555,1}},{6,{0,16040655,1}}]');
/*!40000 ALTER TABLE `base_optional_gift` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_parade_att_mon`
--

DROP TABLE IF EXISTS `base_parade_att_mon`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_parade_att_mon` (
  `id` int(10) unsigned NOT NULL COMMENT '编号',
  `parade_type` int(10) unsigned NOT NULL COMMENT '巡游类型',
  `times` int(10) unsigned NOT NULL COMMENT '波数',
  `refresh_list` varchar(512) NOT NULL COMMENT '刷新列表',
  `refresh_time` int(10) unsigned NOT NULL COMMENT '刷新时间',
  `aura` int(10) unsigned NOT NULL COMMENT '气氛值',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='巡游骚扰怪配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_parade_att_mon`
--

LOCK TABLES `base_parade_att_mon` WRITE;
/*!40000 ALTER TABLE `base_parade_att_mon` DISABLE KEYS */;
INSERT INTO `base_parade_att_mon` VALUES (1,1,1,'[{51550008,1004,10195,10844},{51550008,1004,9937,10763},{51550008,1004,9908,10490},{51550008,1004,10057,10298},{51550008,1004,10089,10053},{51550008,1004,10320,9912},{51550008,1004,10593,9873},{51550008,1004,10894,9911},{51550008,1004,11142,10031},{51550008,1004,11302,10258},{51550008,1004,11271,10492},{51550008,1004,10720,10060},{51550008,1004,10348,10102},{51550008,1004,10156,10425},{51550008,1004,10957,10166},{51550008,1004,10285,10271}]',3,6),(2,1,2,'[{51550008,1004,7400,6566},{51550008,1004,7258,6552},{51550008,1004,7136,6510},{51550008,1004,7029,6420},{51550008,1004,7081,6270},{51550008,1004,7157,6166},{51550008,1004,7331,6048},{51550008,1004,7418,5933},{51550008,1004,7574,5860},{51550008,1004,7769,5847},{51550008,1004,7953,5847},{51550008,1004,8088,5926},{51550008,1004,8092,6065},{51550008,1004,8067,6218},{51550008,1004,7949,6312},{51550008,1004,7737,6368}]',6,6),(3,1,3,'[{51550008,1004,10195,10844},{51550008,1004,9937,10763},{51550008,1004,9908,10490},{51550008,1004,10057,10298},{51550008,1004,10089,10053},{51550008,1004,10320,9912},{51550008,1004,10593,9873},{51550008,1004,10894,9911},{51550008,1004,11142,10031},{51550008,1004,11302,10258},{51550008,1004,11271,10492},{51550008,1004,10720,10060},{51550008,1004,10348,10102},{51550008,1004,10156,10425},{51550008,1004,10957,10166},{51550008,1004,10285,10271}]',10,6),(4,2,1,'[{51550008,1004,10195,10844},{51550008,1004,9937,10763},{51550008,1004,9908,10490},{51550008,1004,10057,10298},{51550008,1004,10089,10053},{51550008,1004,10320,9912},{51550008,1004,10593,9873},{51550008,1004,10894,9911},{51550008,1004,11142,10031},{51550008,1004,11302,10258},{51550008,1004,11271,10492},{51550008,1004,10720,10060},{51550008,1004,10348,10102},{51550008,1004,10156,10425},{51550008,1004,10957,10166},{51550008,1004,10285,10271}]',3,6),(5,2,2,'[{51550008,1004,7400,6566},{51550008,1004,7258,6552},{51550008,1004,7136,6510},{51550008,1004,7029,6420},{51550008,1004,7081,6270},{51550008,1004,7157,6166},{51550008,1004,7331,6048},{51550008,1004,7418,5933},{51550008,1004,7574,5860},{51550008,1004,7769,5847},{51550008,1004,7953,5847},{51550008,1004,8088,5926},{51550008,1004,8092,6065},{51550008,1004,8067,6218},{51550008,1004,7949,6312},{51550008,1004,7737,6368}]',6,6),(6,2,3,'[{51550008,1004,10195,10844},{51550008,1004,9937,10763},{51550008,1004,9908,10490},{51550008,1004,10057,10298},{51550008,1004,10089,10053},{51550008,1004,10320,9912},{51550008,1004,10593,9873},{51550008,1004,10894,9911},{51550008,1004,11142,10031},{51550008,1004,11302,10258},{51550008,1004,11271,10492},{51550008,1004,10720,10060},{51550008,1004,10348,10102},{51550008,1004,10156,10425},{51550008,1004,10957,10166},{51550008,1004,10285,10271}]',10,6),(7,3,1,'[{51550008,1004,10195,10844},{51550008,1004,9937,10763},{51550008,1004,9908,10490},{51550008,1004,10057,10298},{51550008,1004,10089,10053},{51550008,1004,10320,9912},{51550008,1004,10593,9873},{51550008,1004,10894,9911},{51550008,1004,11142,10031},{51550008,1004,11302,10258},{51550008,1004,11271,10492},{51550008,1004,10720,10060},{51550008,1004,10348,10102},{51550008,1004,10156,10425},{51550008,1004,10957,10166},{51550008,1004,10285,10271}]',3,6),(8,3,2,'[{51550008,1004,7400,6566},{51550008,1004,7258,6552},{51550008,1004,7136,6510},{51550008,1004,7029,6420},{51550008,1004,7081,6270},{51550008,1004,7157,6166},{51550008,1004,7331,6048},{51550008,1004,7418,5933},{51550008,1004,7574,5860},{51550008,1004,7769,5847},{51550008,1004,7953,5847},{51550008,1004,8088,5926},{51550008,1004,8092,6065},{51550008,1004,8067,6218},{51550008,1004,7949,6312},{51550008,1004,7737,6368}]',6,6),(9,3,3,'[{51550008,1004,10195,10844},{51550008,1004,9937,10763},{51550008,1004,9908,10490},{51550008,1004,10057,10298},{51550008,1004,10089,10053},{51550008,1004,10320,9912},{51550008,1004,10593,9873},{51550008,1004,10894,9911},{51550008,1004,11142,10031},{51550008,1004,11302,10258},{51550008,1004,11271,10492},{51550008,1004,10720,10060},{51550008,1004,10348,10102},{51550008,1004,10156,10425},{51550008,1004,10957,10166},{51550008,1004,10285,10271}]',10,6);
/*!40000 ALTER TABLE `base_parade_att_mon` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_parade_aura`
--

DROP TABLE IF EXISTS `base_parade_aura`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_parade_aura` (
  `aura_id` int(10) unsigned NOT NULL COMMENT '气氛编号',
  `aura_num` int(10) unsigned NOT NULL COMMENT '气氛值',
  `reward_list` varchar(512) NOT NULL COMMENT '奖励',
  PRIMARY KEY (`aura_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='巡游气氛奖励配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_parade_aura`
--

LOCK TABLES `base_parade_aura` WRITE;
/*!40000 ALTER TABLE `base_parade_aura` DISABLE KEYS */;
INSERT INTO `base_parade_aura` VALUES (1,188,'[{0,40010001,1},{0,40010011,5},{255,40040001,50}]'),(2,588,'[{0,40010001,2},{0,40010011,8},{255,40040001,80}]'),(3,988,'[{0,40010001,3},{0,40010011,15},{255,40040001,150}]');
/*!40000 ALTER TABLE `base_parade_aura` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_parade_box`
--

DROP TABLE IF EXISTS `base_parade_box`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_parade_box` (
  `parade_type` int(10) unsigned NOT NULL COMMENT '巡游类型',
  `box_id` int(10) unsigned NOT NULL COMMENT '宝箱怪物id',
  `type` int(10) unsigned NOT NULL COMMENT '宝箱类型',
  `box_num` int(10) unsigned NOT NULL COMMENT '宝箱数量',
  `box_loc` varchar(1024) NOT NULL COMMENT '宝箱生成位置',
  `box_reward` varchar(512) NOT NULL COMMENT '宝箱奖励',
  PRIMARY KEY (`parade_type`,`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='巡游宝箱配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_parade_box`
--

LOCK TABLES `base_parade_box` WRITE;
/*!40000 ALTER TABLE `base_parade_box` DISABLE KEYS */;
INSERT INTO `base_parade_box` VALUES (1,51550009,1,20,'[{1004,14693,17349},{1004,15556,16786},{1004,14072,17217},{1004,15672,16180},{1004,13593,16914},{1004,15594,15674},{1004,13577,16468},{1004,15162,15392},{1004,13682,15963},{1004,14723,15217},{1004,13919,15524},{1004,14323,15205},{1004,14136,16690},{1004,15193,15983},{1004,14090,16158},{1004,14731,15638},{1004,14327,17507},{1004,15960,16534},{1004,14706,17802},{1004,15953,17017}]','[[{0,38100001,4},{0,40010011,2}]]'),(1,51550010,2,1,'[{1004,15199,16761}]','[[{0,40010011,10},{255,40040001,100}]]'),(2,51550009,1,25,'[{1004,14693,17349},{1004,15556,16786},{1004,14072,17217},{1004,15672,16180},{1004,13593,16914},{1004,15594,15674},{1004,13577,16468},{1004,15162,15392},{1004,13682,15963},{1004,14723,15217},{1004,13919,15524},{1004,14323,15205},{1004,14136,16690},{1004,15193,15983},{1004,14090,16158},{1004,14731,15638},{1004,14327,17507},{1004,15960,16534},{1004,14706,17802},{1004,15953,17017},{1004,14831,15638},{1004,14427,17507},{1004,15860,16534},{1004,14806,17802},{1004,15853,17017}]','[[{0,38100001,6},{0,40010011,4}]]'),(2,51550010,2,1,'[{1004,15199,16761}]','[[{0,40010001,1},{0,40010011,15},{255,40040001,150}]]'),(3,51550009,1,30,'[{1004,14693,17349},{1004,15556,16786},{1004,14072,17217},{1004,15672,16180},{1004,13593,16914},{1004,15594,15674},{1004,13577,16468},{1004,15162,15392},{1004,13682,15963},{1004,14723,15217},{1004,13919,15524},{1004,14323,15205},{1004,14136,16690},{1004,15193,15983},{1004,14090,16158},{1004,14731,15638},{1004,14327,17507},{1004,15960,16534},{1004,14706,17802},{1004,15953,17017},{1004,14831,15638},{1004,14427,17507},{1004,15860,16534},{1004,14806,17802},{1004,15853,17017},{1004,14593,17349},{1004,15656,16786},{1004,14172,17217},{1004,15572,16180},{1004,13693,16914}]','[[{0,38100001,8},{0,40010011,6}]]'),(3,51550010,2,1,'[{1004,15199,16761}]','[[{0,40010002,1},{0,40010011,20},{255,40040001,200}]]');
/*!40000 ALTER TABLE `base_parade_box` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_parade_card`
--

DROP TABLE IF EXISTS `base_parade_card`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_parade_card` (
  `goods_type_id` int(10) unsigned NOT NULL COMMENT '物品类型id',
  `goods_name` varchar(500) NOT NULL COMMENT '物品名称@lang@',
  `goods_num` int(10) unsigned NOT NULL COMMENT '物品数量',
  `cost_list` varchar(500) NOT NULL COMMENT '消耗列表',
  `parade_type` int(10) NOT NULL COMMENT '巡游类型',
  `if_reward` int(10) unsigned NOT NULL COMMENT '是否能获得婚礼奖励（0不能 1能）',
  PRIMARY KEY (`goods_type_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='巡游巡游卡表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_parade_card`
--

LOCK TABLES `base_parade_card` WRITE;
/*!40000 ALTER TABLE `base_parade_card` DISABLE KEYS */;
INSERT INTO `base_parade_card` VALUES (40020004,'简约巡游卡',1,'[]',1,0),(40020005,'隆重巡游卡',1,'[]',2,0),(40020006,'豪华巡游卡',1,'[]',3,0);
/*!40000 ALTER TABLE `base_parade_card` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_parade_constant`
--

DROP TABLE IF EXISTS `base_parade_constant`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_parade_constant` (
  `id` int(10) unsigned NOT NULL COMMENT '序号',
  `constant` varchar(500) NOT NULL COMMENT '内容',
  `annotation` varchar(500) NOT NULL COMMENT '注释',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='巡游常量表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_parade_constant`
--

LOCK TABLES `base_parade_constant` WRITE;
/*!40000 ALTER TABLE `base_parade_constant` DISABLE KEYS */;
INSERT INTO `base_parade_constant` VALUES (1,'5','婚礼预约天数限制(1为今天）'),(2,'51540004','巡游开启NPC'),(3,'1500','开启巡游时，新人双方距离NPC的像素范围半径'),(4,'{1004,15286,16298}','巡游NPC坐标'),(5,'[{2,5,51550001},{3,9,51550002},{4,13,51550003},{5,17,51550004}]','护卫常量，格式[{路径类型,第一段路径id,护卫id}]'),(6,'1000','路人跟随婚车间距，像素距离'),(7,'[{1,-250,415},{2,250,415},{3,353,353},{4,353,-353},{5,250,-415},{6,-250,-415},{7,-353,-353},{8,-353,+353}]','婚车周围刷奖励坐标'),(8,'[{-353,-353},{-250,-415},{353,-353},{250,-415}]','婚车周围玩家跟随坐标'),(9,'[51550008]','骚扰怪id列表'),(10,'[51550005,51550006,51550007]','婚车怪物id列表'),(11,'[51550001,51550002,51550003,51550004]','巡游护卫id列表'),(12,'180','巡游入场时间'),(13,'[{1,1},{2,2},{3,3},{5,0},{6,0},{7,0},{9,0},{10,0},{11,0},{13,0},{14,0},{15,0},{17,0},{18,0},{19,0}]','刷怪点 {婚车路径id， 骚扰怪波数}'),(14,'1000','挂机经验获取有效范围（像素）'),(15,'1004','巡游场景id'),(16,'20','杀怪和采集计时器时间（s）'),(17,'1500','活动范围（像素）'),(18,'[{1,1},{2,1},{3,1}]','[{巡游类型,新人宝箱采集上限}]'),(19,'[{1,2},{2,2},{3,2}]','[{巡游类型,普通宝箱采集上限}]'),(20,'30','宝箱刷新时间间隔（s）');
/*!40000 ALTER TABLE `base_parade_constant` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_parade_fires`
--

DROP TABLE IF EXISTS `base_parade_fires`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_parade_fires` (
  `fires_id` int(10) unsigned NOT NULL COMMENT '烟花id',
  `fires_name` varchar(255) NOT NULL COMMENT '烟花名字@lang@',
  `cost_list` varchar(255) NOT NULL COMMENT '消耗列表',
  `discount` varchar(255) NOT NULL COMMENT '折扣',
  `charact` varchar(255) NOT NULL COMMENT '特效',
  `reward_list` varchar(255) NOT NULL COMMENT '奖励列表',
  `aura` int(10) unsigned NOT NULL COMMENT '气氛值',
  PRIMARY KEY (`fires_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='巡游烟花配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_parade_fires`
--

LOCK TABLES `base_parade_fires` WRITE;
/*!40000 ALTER TABLE `base_parade_fires` DISABLE KEYS */;
INSERT INTO `base_parade_fires` VALUES (1,'普通烟花','[{2,0,15}]','[{{1,3},0},{{4,10},0.4},{{11,20},0.8},{{21,50},1}]','ui_hunliyanhua02','[{0,40010011,2}]',5),(2,'豪华烟花','[{2,0,100}]','[{{1,1},0},{{2,5},0.4},{{6,15},0.8},{{16,30},1}]','ui_hunliyanhua01','[{0,40010011,10}]',50);
/*!40000 ALTER TABLE `base_parade_fires` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_parade_flower`
--

DROP TABLE IF EXISTS `base_parade_flower`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_parade_flower` (
  `id` int(10) unsigned NOT NULL COMMENT '撒花ID',
  `resource_id` int(10) unsigned NOT NULL COMMENT '资源id',
  `name` varchar(255) NOT NULL COMMENT '撒花名字@lang@',
  `cost` varchar(512) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `discount` varchar(255) NOT NULL COMMENT '折扣',
  `num` int(10) unsigned NOT NULL COMMENT '刷出数量',
  `other_reward` varchar(512) NOT NULL DEFAULT '[]' COMMENT '其他奖励',
  `reward` varchar(512) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `aura` int(10) unsigned NOT NULL COMMENT '气氛值',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='巡游撒花表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_parade_flower`
--

LOCK TABLES `base_parade_flower` WRITE;
/*!40000 ALTER TABLE `base_parade_flower` DISABLE KEYS */;
INSERT INTO `base_parade_flower` VALUES (1,5155001,'普通撒糖','[{2,0,100}]','[{{1,1},0},{{2,3},0.4},{{4,8},0.8},{{9,30},1}]',5,'[{0,40010011,6},{255,40040001,100}]','[{500,[{0,38100001,5}]},{200,[{0,38100009,1}]},{150,[{0,38100008,1}]},{100,[{0,38100007,1}]},{40,[{0,40010012,1}]},{10,[{0,38100010,1}]}]',70),(2,5155002,'豪华撒糖','[{2,0,300}]','[{{1,1},0.4},{{2,4},0.8},{{5,10},1}]',15,'[{0,40010011,15},{255,40040001,250}]','[{500,[{0,38100001,5}]},{200,[{0,38100009,1}]},{150,[{0,38100008,1}]},{100,[{0,38100007,1}]},{40,[{0,40010012,1}]},{10,[{0,38100010,1}]}]',240);
/*!40000 ALTER TABLE `base_parade_flower` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_parade_info`
--

DROP TABLE IF EXISTS `base_parade_info`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_parade_info` (
  `type` int(10) unsigned NOT NULL COMMENT '巡游类型',
  `name` varchar(500) NOT NULL COMMENT '婚戒名字@lang@',
  `car_name` varchar(500) NOT NULL COMMENT '婚车名字@lang@',
  `resource_id` int(10) unsigned NOT NULL COMMENT '婚车资源id',
  `image_id` varchar(255) NOT NULL COMMENT '婚车图片资源',
  `cost` varchar(500) NOT NULL COMMENT '消耗',
  `reward` varchar(500) NOT NULL COMMENT '巡游奖励',
  `parade_fail_return` varchar(500) NOT NULL COMMENT '巡游失败返还',
  `designation_id` int(10) unsigned NOT NULL COMMENT '称号id',
  `time` int(10) unsigned NOT NULL COMMENT '巡游时间',
  `car_hp` int(10) unsigned NOT NULL COMMENT '婚车血量',
  `help_npc_num` int(10) unsigned NOT NULL COMMENT '护卫NPC数量',
  `exp_time` int(10) unsigned NOT NULL COMMENT '发经验时间间隔',
  `exp_coefficient` int(10) unsigned NOT NULL COMMENT '基础经验',
  `couple_exp` int(10) unsigned NOT NULL COMMENT '新人经验系数（万分比）',
  `guest_exp` int(10) unsigned NOT NULL COMMENT '宾客经验系数（万分比）',
  `explain` varchar(500) NOT NULL COMMENT '说明@lang@',
  PRIMARY KEY (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='巡游数据表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_parade_info`
--

LOCK TABLES `base_parade_info` WRITE;
/*!40000 ALTER TABLE `base_parade_info` DISABLE KEYS */;
INSERT INTO `base_parade_info` VALUES (1,'恋爱巡游','简约婚车',51550005,'icon_fw','[{2,0,288}]','[{0,12023001,1},{0,12043001,1},{0,40010001,2},{0,38100002,1}]','[{100, 40020004, 1 }]',4907010,10,0,4,5,20000,100000,30000,'低级巡游'),(2,'甜蜜巡游','隆重婚车',51550006,'icon_fm','[{1,0,588}]','[{0,12021001,1},{0,12041001,1},{0,40010002,2},{0,38100004,1}]','[{100, 40020005, 1 }]',4907011,10,0,4,5,30000,100000,30000,'中级巡游'),(3,'真爱巡游','豪华婚车',51550007,'icon_xyc','[{1,0,1314}]','[{0,12020001,1},{0,12040001,1},{0,40010003,2},{0,38100005,1}]','[{100, 40020006, 1 }]',4907012,10,0,4,5,45000,100000,30000,'豪华婚车');
/*!40000 ALTER TABLE `base_parade_info` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_parade_path`
--

DROP TABLE IF EXISTS `base_parade_path`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_parade_path` (
  `id` int(10) unsigned NOT NULL COMMENT '编号',
  `type` int(10) unsigned NOT NULL COMMENT '路径类型',
  `path` varchar(4096) NOT NULL COMMENT '寻路路径',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='巡游寻路路径表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_parade_path`
--

LOCK TABLES `base_parade_path` WRITE;
/*!40000 ALTER TABLE `base_parade_path` DISABLE KEYS */;
INSERT INTO `base_parade_path` VALUES (1,1,'[{1004,14701,16304},{1004,14667,16244},{1004,14634,16183},{1004,14599,16122},{1004,14543,16059},{1004,14484,15999},{1004,14440,15938},{1004,14400,15876},{1004,14360,15813},{1004,14311,15750},{1004,14262,15688},{1004,14213,15625},{1004,14163,15563},{1004,14114,15500},{1004,14065,15438},{1004,14015,15376},{1004,13972,15315},{1004,13933,15251},{1004,13899,15191},{1004,13872,15127},{1004,13851,15066},{1004,13833,15004},{1004,13815,14942},{1004,13787,14878},{1004,13748,14814},{1004,13707,14752},{1004,13663,14692},{1004,13619,14632},{1004,13575,14572},{1004,13525,14510},{1004,13474,14449},{1004,13416,14387},{1004,13358,14325},{1004,13302,14261},{1004,13253,14199},{1004,13204,14136},{1004,13155,14072},{1004,13116,14009},{1004,13082,13948},{1004,13051,13886},{1004,13024,13821},{1004,12997,13757},{1004,12969,13694},{1004,12937,13632},{1004,12902,13572},{1004,12858,13512},{1004,12807,13451},{1004,12744,13387},{1004,12680,13324},{1004,12616,13262},{1004,12551,13200},{1004,12486,13139},{1004,12421,13078},{1004,12356,13017},{1004,12291,12955},{1004,12235,12892},{1004,12179,12828},{1004,12128,12767},{1004,12079,12705},{1004,12030,12642},{1004,11981,12579},{1004,11932,12517},{1004,11883,12454},{1004,11833,12393},{1004,11768,12331},{1004,11684,12269},{1004,11563,12213},{1004,11441,12187},{1004,11318,12173},{1004,11194,12167},{1004,11070,12163},{1004,10946,12150},{1004,10822,12116},{1004,10700,12060},{1004,10629,11999},{1004,10578,11937},{1004,10537,11875},{1004,10502,11815},{1004,10470,11753},{1004,10440,11691},{1004,10411,11627},{1004,10383,11564},{1004,10355,11500},{1004,10326,11436},{1004,10298,11373},{1004,10276,11312},{1004,10257,11251},{1004,10240,11188},{1004,10228,11125},{1004,10220,11061},{1004,10215,10996},{1004,10216,10932},{1004,10222,10867},{1004,10231,10803},{1004,10243,10740},{1004,10260,10677},{1004,10281,10616},{1004,10304,10556},{1004,10332,10492},{1004,10362,10429},{1004,10393,10367},{1004,10396,10363}]'),(2,1,'[{1004,10396,10363},{1004,10377,10301},{1004,10360,10239},{1004,10339,10178},{1004,10306,10117},{1004,10264,10055},{1004,10224,9992},{1004,10186,9928},{1004,10148,9864},{1004,10109,9800},{1004,10071,9736},{1004,10032,9673},{1004,9994,9609},{1004,9955,9545},{1004,9925,9482},{1004,9895,9419},{1004,9864,9357},{1004,9832,9295},{1004,9798,9234},{1004,9756,9173},{1004,9706,9112},{1004,9647,9051},{1004,9588,8991},{1004,9529,8930},{1004,9469,8870},{1004,9406,8807},{1004,9343,8743},{1004,9280,8680},{1004,9222,8619},{1004,9170,8559},{1004,9118,8499},{1004,9070,8435},{1004,9031,8371},{1004,8993,8307},{1004,8955,8243},{1004,8917,8179},{1004,8879,8115},{1004,8841,8051},{1004,8803,7987},{1004,8764,7923},{1004,8716,7860},{1004,8660,7797},{1004,8601,7736},{1004,8523,7674},{1004,8421,7613},{1004,8307,7552},{1004,8185,7510},{1004,8062,7493},{1004,7938,7487},{1004,7814,7481},{1004,7691,7465},{1004,7571,7434},{1004,7453,7371},{1004,7375,7308},{1004,7316,7248},{1004,7266,7187},{1004,7225,7124},{1004,7187,7060},{1004,7155,6999},{1004,7133,6938},{1004,7116,6876},{1004,7105,6812},{1004,7103,6748},{1004,7109,6683},{1004,7119,6619},{1004,7133,6556},{1004,7149,6494},{1004,7167,6432},{1004,7190,6371},{1004,7220,6308},{1004,7253,6248},{1004,7294,6185},{1004,7344,6123},{1004,7407,6060},{1004,7425,6043}]'),(3,1,'[{1004,7425,6043},{1004,7549,6009},{1004,7672,5990},{1004,7796,5982},{1004,7919,5997},{1004,8043,6032},{1004,8167,6071},{1004,8289,6112},{1004,8413,6162},{1004,8496,6225},{1004,8545,6288},{1004,8572,6352},{1004,8584,6415},{1004,8593,6479},{1004,8601,6543},{1004,8605,6608},{1004,8608,6672},{1004,8611,6737},{1004,8614,6801},{1004,8617,6866},{1004,8620,6930},{1004,8623,6995},{1004,8626,7060},{1004,8629,7124},{1004,8632,7189},{1004,8635,7253},{1004,8638,7318},{1004,8643,7382},{1004,8649,7446},{1004,8655,7511},{1004,8664,7575},{1004,8676,7638},{1004,8691,7701},{1004,8709,7763},{1004,8730,7824},{1004,8756,7889},{1004,8787,7951},{1004,8820,8012},{1004,8855,8072},{1004,8890,8132},{1004,8925,8192},{1004,8961,8252},{1004,8996,8313},{1004,9031,8373},{1004,9071,8436},{1004,9112,8498},{1004,9153,8560},{1004,9195,8622},{1004,9237,8683},{1004,9280,8744},{1004,9325,8804},{1004,9369,8864},{1004,9418,8926},{1004,9469,8987},{1004,9520,9048},{1004,9571,9109},{1004,9622,9170},{1004,9673,9231},{1004,9724,9292},{1004,9775,9354},{1004,9826,9415},{1004,9877,9476},{1004,9928,9537},{1004,9979,9598},{1004,10029,9659},{1004,10078,9722},{1004,10121,9783},{1004,10161,9845},{1004,10196,9906},{1004,10227,9968},{1004,10258,10030},{1004,10290,10092},{1004,10321,10154},{1004,10352,10216},{1004,10361,10234}]'),(4,1,'[{1004,10361,10234},{1004,10485,10197},{1004,10608,10182},{1004,10732,10174},{1004,10856,10177},{1004,10980,10182},{1004,11104,10192},{1004,11228,10206},{1004,11351,10223},{1004,11473,10265},{1004,11594,10322},{1004,11664,10385},{1004,11728,10447},{1004,11792,10510},{1004,11851,10570},{1004,11902,10631},{1004,11953,10692},{1004,12004,10753},{1004,12053,10816},{1004,12084,10878},{1004,12103,10940},{1004,12117,11003},{1004,12127,11067},{1004,12134,11131},{1004,12140,11195},{1004,12143,11260},{1004,12147,11324},{1004,12146,11389},{1004,12146,11453},{1004,12145,11518},{1004,12144,11582},{1004,12143,11647},{1004,12142,11712},{1004,12141,11776},{1004,12140,11841},{1004,12139,11906},{1004,12139,11970},{1004,12131,12034},{1004,12123,12098},{1004,12120,12163},{1004,12118,12228},{1004,12118,12292},{1004,12119,12357},{1004,12122,12421},{1004,12128,12486},{1004,12139,12549},{1004,12157,12611},{1004,12183,12676},{1004,12211,12739},{1004,12239,12803},{1004,12268,12866},{1004,12302,12927},{1004,12340,12991},{1004,12381,13053},{1004,12423,13115},{1004,12464,13177},{1004,12506,13239},{1004,12547,13301},{1004,12589,13363},{1004,12631,13424},{1004,12673,13486},{1004,12715,13548},{1004,12757,13609},{1004,12799,13671},{1004,12841,13733},{1004,12883,13794},{1004,12925,13856},{1004,12967,13917},{1004,13009,13979},{1004,13051,14040},{1004,13094,14101},{1004,13141,14165},{1004,13189,14229},{1004,13236,14293},{1004,13284,14356},{1004,13332,14420},{1004,13379,14484},{1004,13427,14548},{1004,13474,14611},{1004,13522,14675},{1004,13569,14739},{1004,13617,14803},{1004,13662,14863},{1004,13709,14927},{1004,13757,14991},{1004,13804,15055},{1004,13852,15118},{1004,13899,15182},{1004,13947,15246},{1004,13994,15310},{1004,14042,15374},{1004,14084,15435},{1004,14125,15497},{1004,14166,15560},{1004,14207,15622},{1004,14248,15684},{1004,14289,15746},{1004,14330,15808},{1004,14371,15871},{1004,14411,15934},{1004,14450,15997},{1004,14489,16061},{1004,14531,16122},{1004,14573,16184},{1004,14614,16246},{1004,14655,16309},{1004,14677,16342}]'),(5,2,'[{1004,14881,16424},{1004,14847,16364},{1004,14814,16303},{1004,14779,16242},{1004,14723,16179},{1004,14664,16119},{1004,14620,16058},{1004,14580,15996},{1004,14540,15933},{1004,14491,15870},{1004,14442,15808},{1004,14393,15745},{1004,14343,15683},{1004,14294,15620},{1004,14245,15558},{1004,14195,15496},{1004,14152,15435},{1004,14113,15371},{1004,14079,15311},{1004,14052,15247},{1004,14031,15186},{1004,14013,15124},{1004,13995,15062},{1004,13967,14998},{1004,13928,14934},{1004,13887,14872},{1004,13843,14812},{1004,13799,14752},{1004,13755,14692},{1004,13705,14630},{1004,13654,14569},{1004,13596,14507},{1004,13538,14445},{1004,13482,14381},{1004,13433,14319},{1004,13384,14256},{1004,13335,14192},{1004,13296,14129},{1004,13262,14068},{1004,13231,14006},{1004,13204,13941},{1004,13177,13877},{1004,13149,13814},{1004,13117,13752},{1004,13082,13692},{1004,13038,13632},{1004,12987,13571},{1004,12924,13507},{1004,12860,13444},{1004,12796,13382},{1004,12731,13320},{1004,12666,13259},{1004,12601,13198},{1004,12536,13137},{1004,12471,13075},{1004,12415,13012},{1004,12359,12948},{1004,12308,12887},{1004,12259,12825},{1004,12210,12762},{1004,12161,12699},{1004,12112,12637},{1004,12063,12574},{1004,12013,12513},{1004,11948,12451},{1004,11864,12389},{1004,11743,12333},{1004,11621,12307},{1004,11498,12293},{1004,11374,12287},{1004,11250,12283},{1004,11126,12270},{1004,11002,12236},{1004,10880,12180},{1004,10809,12119},{1004,10758,12057},{1004,10717,11995},{1004,10682,11935},{1004,10650,11873},{1004,10620,11811},{1004,10591,11747},{1004,10563,11684},{1004,10535,11620},{1004,10506,11556},{1004,10478,11493},{1004,10456,11432},{1004,10437,11371},{1004,10420,11308},{1004,10408,11245},{1004,10400,11181},{1004,10395,11116},{1004,10396,11052},{1004,10402,10987},{1004,10411,10923},{1004,10423,10860},{1004,10440,10797},{1004,10461,10736},{1004,10484,10676},{1004,10512,10612},{1004,10542,10549},{1004,10573,10487},{1004,10576,10483}]'),(6,2,'[{1004,10576,10483},{1004,10557,10421},{1004,10540,10359},{1004,10519,10298},{1004,10486,10237},{1004,10444,10175},{1004,10404,10112},{1004,10366,10048},{1004,10328,9984},{1004,10289,9920},{1004,10251,9856},{1004,10212,9793},{1004,10174,9729},{1004,10135,9665},{1004,10105,9602},{1004,10075,9539},{1004,10044,9477},{1004,10012,9415},{1004,9978,9354},{1004,9936,9293},{1004,9886,9232},{1004,9827,9171},{1004,9768,9111},{1004,9709,9050},{1004,9649,8990},{1004,9586,8927},{1004,9523,8863},{1004,9460,8800},{1004,9402,8739},{1004,9350,8679},{1004,9298,8619},{1004,9250,8555},{1004,9211,8491},{1004,9173,8427},{1004,9135,8363},{1004,9097,8299},{1004,9059,8235},{1004,9021,8171},{1004,8983,8107},{1004,8944,8043},{1004,8896,7980},{1004,8840,7917},{1004,8781,7856},{1004,8703,7794},{1004,8601,7733},{1004,8487,7672},{1004,8365,7630},{1004,8242,7613},{1004,8118,7607},{1004,7994,7601},{1004,7871,7585},{1004,7751,7554},{1004,7633,7491},{1004,7555,7428},{1004,7496,7368},{1004,7446,7307},{1004,7405,7244},{1004,7367,7180},{1004,7335,7119},{1004,7313,7058},{1004,7296,6996},{1004,7285,6932},{1004,7283,6868},{1004,7289,6803},{1004,7299,6739},{1004,7313,6676},{1004,7329,6614},{1004,7347,6552},{1004,7370,6491},{1004,7400,6428},{1004,7433,6368},{1004,7474,6305},{1004,7524,6243},{1004,7587,6180},{1004,7605,6163}]'),(7,2,'[{1004,7605,6163},{1004,7729,6129},{1004,7852,6110},{1004,7976,6102},{1004,8099,6117},{1004,8223,6152},{1004,8347,6191},{1004,8469,6232},{1004,8593,6282},{1004,8676,6345},{1004,8725,6408},{1004,8752,6472},{1004,8764,6535},{1004,8773,6599},{1004,8781,6663},{1004,8785,6728},{1004,8788,6792},{1004,8791,6857},{1004,8794,6921},{1004,8797,6986},{1004,8800,7050},{1004,8803,7115},{1004,8806,7180},{1004,8809,7244},{1004,8812,7309},{1004,8815,7373},{1004,8818,7438},{1004,8823,7502},{1004,8829,7566},{1004,8835,7631},{1004,8844,7695},{1004,8856,7758},{1004,8871,7821},{1004,8889,7883},{1004,8910,7944},{1004,8936,8009},{1004,8967,8071},{1004,9000,8132},{1004,9035,8192},{1004,9070,8252},{1004,9105,8312},{1004,9141,8372},{1004,9176,8433},{1004,9211,8493},{1004,9251,8556},{1004,9292,8618},{1004,9333,8680},{1004,9375,8742},{1004,9417,8803},{1004,9460,8864},{1004,9505,8924},{1004,9549,8984},{1004,9598,9046},{1004,9649,9107},{1004,9700,9168},{1004,9751,9229},{1004,9802,9290},{1004,9853,9351},{1004,9904,9412},{1004,9955,9474},{1004,10006,9535},{1004,10057,9596},{1004,10108,9657},{1004,10159,9718},{1004,10209,9779},{1004,10258,9842},{1004,10301,9903},{1004,10341,9965},{1004,10376,10026},{1004,10407,10088},{1004,10438,10150},{1004,10470,10212},{1004,10501,10274},{1004,10532,10336},{1004,10541,10354}]'),(8,2,'[{1004,10541,10354},{1004,10665,10317},{1004,10788,10302},{1004,10912,10294},{1004,11036,10297},{1004,11160,10302},{1004,11284,10312},{1004,11408,10326},{1004,11531,10343},{1004,11653,10385},{1004,11774,10442},{1004,11844,10505},{1004,11908,10567},{1004,11972,10630},{1004,12031,10690},{1004,12082,10751},{1004,12133,10812},{1004,12184,10873},{1004,12233,10936},{1004,12264,10998},{1004,12283,11060},{1004,12297,11123},{1004,12307,11187},{1004,12314,11251},{1004,12320,11315},{1004,12323,11380},{1004,12327,11444},{1004,12326,11509},{1004,12326,11573},{1004,12325,11638},{1004,12324,11702},{1004,12323,11767},{1004,12322,11832},{1004,12321,11896},{1004,12320,11961},{1004,12319,12026},{1004,12319,12090},{1004,12311,12154},{1004,12303,12218},{1004,12300,12283},{1004,12298,12348},{1004,12298,12412},{1004,12299,12477},{1004,12302,12541},{1004,12308,12606},{1004,12319,12669},{1004,12337,12731},{1004,12363,12796},{1004,12391,12859},{1004,12419,12923},{1004,12448,12986},{1004,12482,13047},{1004,12520,13111},{1004,12561,13173},{1004,12603,13235},{1004,12644,13297},{1004,12686,13359},{1004,12727,13421},{1004,12769,13483},{1004,12811,13544},{1004,12853,13606},{1004,12895,13668},{1004,12937,13729},{1004,12979,13791},{1004,13021,13853},{1004,13063,13914},{1004,13105,13976},{1004,13147,14037},{1004,13189,14099},{1004,13231,14160},{1004,13274,14221},{1004,13321,14285},{1004,13369,14349},{1004,13416,14413},{1004,13464,14476},{1004,13512,14540},{1004,13559,14604},{1004,13607,14668},{1004,13654,14731},{1004,13702,14795},{1004,13749,14859},{1004,13797,14923},{1004,13842,14983},{1004,13889,15047},{1004,13937,15111},{1004,13984,15175},{1004,14032,15238},{1004,14079,15302},{1004,14127,15366},{1004,14174,15430},{1004,14222,15494},{1004,14264,15555},{1004,14305,15617},{1004,14346,15680},{1004,14387,15742},{1004,14428,15804},{1004,14469,15866},{1004,14510,15928},{1004,14551,15991},{1004,14591,16054},{1004,14630,16117},{1004,14669,16181},{1004,14711,16242},{1004,14753,16304},{1004,14794,16366},{1004,14835,16429},{1004,14857,16462}]'),(9,3,'[{1004,14881,16184}, {1004,14847,16124}, {1004,14814,16063}, {1004,14779,16002}, {1004,14723,15939}, {1004,14664,15879}, {1004,14620,15818}, {1004,14580,15756}, {1004,14540,15693}, {1004,14491,15630}, {1004,14442,15568}, {1004,14393,15505}, {1004,14343,15443}, {1004,14294,15380}, {1004,14245,15318}, {1004,14195,15256}, {1004,14152,15195}, {1004,14113,15131}, {1004,14079,15071}, {1004,14052,15007}, {1004,14031,14946}, {1004,14013,14884}, {1004,13995,14822}, {1004,13967,14758}, {1004,13928,14694}, {1004,13887,14632}, {1004,13843,14572}, {1004,13799,14512}, {1004,13755,14452}, {1004,13705,14390}, {1004,13654,14329}, {1004,13596,14267}, {1004,13538,14205}, {1004,13482,14141}, {1004,13433,14079}, {1004,13384,14016}, {1004,13335,13952}, {1004,13296,13889}, {1004,13262,13828}, {1004,13231,13766}, {1004,13204,13701}, {1004,13177,13637}, {1004,13149,13574}, {1004,13117,13512}, {1004,13082,13452}, {1004,13038,13392}, {1004,12987,13331}, {1004,12924,13267}, {1004,12860,13204}, {1004,12796,13142}, {1004,12731,13080}, {1004,12666,13019}, {1004,12601,12958}, {1004,12536,12897}, {1004,12471,12835}, {1004,12415,12772}, {1004,12359,12708}, {1004,12308,12647}, {1004,12259,12585}, {1004,12210,12522}, {1004,12161,12459}, {1004,12112,12397}, {1004,12063,12334}, {1004,12013,12273}, {1004,11948,12211}, {1004,11864,12149}, {1004,11743,12093}, {1004,11621,12067}, {1004,11498,12053}, {1004,11374,12047}, {1004,11250,12043}, {1004,11126,12030}, {1004,11002,11996}, {1004,10880,11940}, {1004,10809,11879}, {1004,10758,11817}, {1004,10717,11755}, {1004,10682,11695}, {1004,10650,11633}, {1004,10620,11571}, {1004,10591,11507}, {1004,10563,11444}, {1004,10535,11380}, {1004,10506,11316}, {1004,10478,11253}, {1004,10456,11192}, {1004,10437,11131}, {1004,10420,11068}, {1004,10408,11005}, {1004,10400,10941}, {1004,10395,10876}, {1004,10396,10812}, {1004,10402,10747}, {1004,10411,10683}, {1004,10423,10620}, {1004,10440,10557}, {1004,10461,10496}, {1004,10484,10436}, {1004,10512,10372}, {1004,10542,10309}, {1004,10573,10247}, {1004,10576,10243}]'),(10,3,'[{1004,10576,10243},{1004,10557,10181},{1004,10540,10119},{1004,10519,10058},{1004,10486,9997},{1004,10444,9935},{1004,10404,9872},{1004,10366,9808},{1004,10328,9744},{1004,10289,9680},{1004,10251,9616},{1004,10212,9553},{1004,10174,9489},{1004,10135,9425},{1004,10105,9362},{1004,10075,9299},{1004,10044,9237},{1004,10012,9175},{1004,9978,9114},{1004,9936,9053},{1004,9886,8992},{1004,9827,8931},{1004,9768,8871},{1004,9709,8810},{1004,9649,8750},{1004,9586,8687},{1004,9523,8623},{1004,9460,8560},{1004,9402,8499},{1004,9350,8439},{1004,9298,8379},{1004,9250,8315},{1004,9211,8251},{1004,9173,8187},{1004,9135,8123},{1004,9097,8059},{1004,9059,7995},{1004,9021,7931},{1004,8983,7867},{1004,8944,7803},{1004,8896,7740},{1004,8840,7677},{1004,8781,7616},{1004,8703,7554},{1004,8601,7493},{1004,8487,7432},{1004,8365,7390},{1004,8242,7373},{1004,8118,7367},{1004,7994,7361},{1004,7871,7345},{1004,7751,7314},{1004,7633,7251},{1004,7555,7188},{1004,7496,7128},{1004,7446,7067},{1004,7405,7004},{1004,7367,6940},{1004,7335,6879},{1004,7313,6818},{1004,7296,6756},{1004,7285,6692},{1004,7283,6628},{1004,7289,6563},{1004,7299,6499},{1004,7313,6436},{1004,7329,6374},{1004,7347,6312},{1004,7370,6251},{1004,7400,6188},{1004,7433,6128},{1004,7474,6065},{1004,7524,6003},{1004,7587,5940},{1004,7605,5923}]'),(11,3,'[{1004,7605,5923},{1004,7729,5889},{1004,7852,5870},{1004,7976,5862},{1004,8099,5877},{1004,8223,5912},{1004,8347,5951},{1004,8469,5992},{1004,8593,6042},{1004,8676,6105},{1004,8725,6168},{1004,8752,6232},{1004,8764,6295},{1004,8773,6359},{1004,8781,6423},{1004,8785,6488},{1004,8788,6552},{1004,8791,6617},{1004,8794,6681},{1004,8797,6746},{1004,8800,6810},{1004,8803,6875},{1004,8806,6940},{1004,8809,7004},{1004,8812,7069},{1004,8815,7133},{1004,8818,7198},{1004,8823,7262},{1004,8829,7326},{1004,8835,7391},{1004,8844,7455},{1004,8856,7518},{1004,8871,7581},{1004,8889,7643},{1004,8910,7704},{1004,8936,7769},{1004,8967,7831},{1004,9000,7892},{1004,9035,7952},{1004,9070,8012},{1004,9105,8072},{1004,9141,8132},{1004,9176,8193},{1004,9211,8253},{1004,9251,8316},{1004,9292,8378},{1004,9333,8440},{1004,9375,8502},{1004,9417,8563},{1004,9460,8624},{1004,9505,8684},{1004,9549,8744},{1004,9598,8806},{1004,9649,8867},{1004,9700,8928},{1004,9751,8989},{1004,9802,9050},{1004,9853,9111},{1004,9904,9172},{1004,9955,9234},{1004,10006,9295},{1004,10057,9356},{1004,10108,9417},{1004,10159,9478},{1004,10209,9539},{1004,10258,9602},{1004,10301,9663},{1004,10341,9725},{1004,10376,9786},{1004,10407,9848},{1004,10438,9910},{1004,10470,9972},{1004,10501,10034},{1004,10532,10096},{1004,10541,10114}]'),(12,3,'[{1004,10541,10114},{1004,10665,10077},{1004,10788,10062},{1004,10912,10054},{1004,11036,10057},{1004,11160,10062},{1004,11284,10072},{1004,11408,10086},{1004,11531,10103},{1004,11653,10145},{1004,11774,10202},{1004,11844,10265},{1004,11908,10327},{1004,11972,10390},{1004,12031,10450},{1004,12082,10511},{1004,12133,10572},{1004,12184,10633},{1004,12233,10696},{1004,12264,10758},{1004,12283,10820},{1004,12297,10883},{1004,12307,10947},{1004,12314,11011},{1004,12320,11075},{1004,12323,11140},{1004,12327,11204},{1004,12326,11269},{1004,12326,11333},{1004,12325,11398},{1004,12324,11462},{1004,12323,11527},{1004,12322,11592},{1004,12321,11656},{1004,12320,11721},{1004,12319,11786},{1004,12319,11850},{1004,12311,11914},{1004,12303,11978},{1004,12300,12043},{1004,12298,12108},{1004,12298,12172},{1004,12299,12237},{1004,12302,12301},{1004,12308,12366},{1004,12319,12429},{1004,12337,12491},{1004,12363,12556},{1004,12391,12619},{1004,12419,12683},{1004,12448,12746},{1004,12482,12807},{1004,12520,12871},{1004,12561,12933},{1004,12603,12995},{1004,12644,13057},{1004,12686,13119},{1004,12727,13181},{1004,12769,13243},{1004,12811,13304},{1004,12853,13366},{1004,12895,13428},{1004,12937,13489},{1004,12979,13551},{1004,13021,13613},{1004,13063,13674},{1004,13105,13736},{1004,13147,13797},{1004,13189,13859},{1004,13231,13920},{1004,13274,13981},{1004,13321,14045},{1004,13369,14109},{1004,13416,14173},{1004,13464,14236},{1004,13512,14300},{1004,13559,14364},{1004,13607,14428},{1004,13654,14491},{1004,13702,14555},{1004,13749,14619},{1004,13797,14683},{1004,13842,14743},{1004,13889,14807},{1004,13937,14871},{1004,13984,14935},{1004,14032,14998},{1004,14079,15062},{1004,14127,15126},{1004,14174,15190},{1004,14222,15254},{1004,14264,15315},{1004,14305,15377},{1004,14346,15440},{1004,14387,15502},{1004,14428,15564},{1004,14469,15626},{1004,14510,15688},{1004,14551,15751},{1004,14591,15814},{1004,14630,15877},{1004,14669,15941},{1004,14711,16002},{1004,14753,16064},{1004,14794,16126},{1004,14835,16189},{1004,14857,16222}]'),(13,4,'[{1004,14521,16184},{1004,14487,16124},{1004,14454,16063},{1004,14419,16002},{1004,14363,15939},{1004,14304,15879},{1004,14260,15818},{1004,14220,15756},{1004,14180,15693},{1004,14131,15630},{1004,14082,15568},{1004,14033,15505},{1004,13983,15443},{1004,13934,15380},{1004,13885,15318},{1004,13835,15256},{1004,13792,15195},{1004,13753,15131},{1004,13719,15071},{1004,13692,15007},{1004,13671,14946},{1004,13653,14884},{1004,13635,14822},{1004,13607,14758},{1004,13568,14694},{1004,13527,14632},{1004,13483,14572},{1004,13439,14512},{1004,13395,14452},{1004,13345,14390},{1004,13294,14329},{1004,13236,14267},{1004,13178,14205},{1004,13122,14141},{1004,13073,14079},{1004,13024,14016},{1004,12975,13952},{1004,12936,13889},{1004,12902,13828},{1004,12871,13766},{1004,12844,13701},{1004,12817,13637},{1004,12789,13574},{1004,12757,13512},{1004,12722,13452},{1004,12678,13392},{1004,12627,13331},{1004,12564,13267},{1004,12500,13204},{1004,12436,13142},{1004,12371,13080},{1004,12306,13019},{1004,12241,12958},{1004,12176,12897},{1004,12111,12835},{1004,12055,12772},{1004,11999,12708},{1004,11948,12647},{1004,11899,12585},{1004,11850,12522},{1004,11801,12459},{1004,11752,12397},{1004,11703,12334},{1004,11653,12273},{1004,11588,12211},{1004,11504,12149},{1004,11383,12093},{1004,11261,12067},{1004,11138,12053},{1004,11014,12047},{1004,10890,12043},{1004,10766,12030},{1004,10642,11996},{1004,10520,11940},{1004,10449,11879},{1004,10398,11817},{1004,10357,11755},{1004,10322,11695},{1004,10290,11633},{1004,10260,11571},{1004,10231,11507},{1004,10203,11444},{1004,10175,11380},{1004,10146,11316},{1004,10118,11253},{1004,10096,11192},{1004,10077,11131},{1004,10060,11068},{1004,10048,11005},{1004,10040,10941},{1004,10035,10876},{1004,10036,10812},{1004,10042,10747},{1004,10051,10683},{1004,10063,10620},{1004,10080,10557},{1004,10101,10496},{1004,10124,10436},{1004,10152,10372},{1004,10182,10309},{1004,10213,10247},{1004,10216,10243}]'),(14,4,'[{1004,10216,10243},{1004,10197,10181},{1004,10180,10119},{1004,10159,10058},{1004,10126,9997},{1004,10084,9935},{1004,10044,9872},{1004,10006,9808},{1004,9968,9744},{1004,9929,9680},{1004,9891,9616},{1004,9852,9553},{1004,9814,9489},{1004,9775,9425},{1004,9745,9362},{1004,9715,9299},{1004,9684,9237},{1004,9652,9175},{1004,9618,9114},{1004,9576,9053},{1004,9526,8992},{1004,9467,8931},{1004,9408,8871},{1004,9349,8810},{1004,9289,8750},{1004,9226,8687},{1004,9163,8623},{1004,9100,8560},{1004,9042,8499},{1004,8990,8439},{1004,8938,8379},{1004,8890,8315},{1004,8851,8251},{1004,8813,8187},{1004,8775,8123},{1004,8737,8059},{1004,8699,7995},{1004,8661,7931},{1004,8623,7867},{1004,8584,7803},{1004,8536,7740},{1004,8480,7677},{1004,8421,7616},{1004,8343,7554},{1004,8241,7493},{1004,8127,7432},{1004,8005,7390},{1004,7882,7373},{1004,7758,7367},{1004,7634,7361},{1004,7511,7345},{1004,7391,7314},{1004,7273,7251},{1004,7195,7188},{1004,7136,7128},{1004,7086,7067},{1004,7045,7004},{1004,7007,6940},{1004,6975,6879},{1004,6953,6818},{1004,6936,6756},{1004,6925,6692},{1004,6923,6628},{1004,6929,6563},{1004,6939,6499},{1004,6953,6436},{1004,6969,6374},{1004,6987,6312},{1004,7010,6251},{1004,7040,6188},{1004,7073,6128},{1004,7114,6065},{1004,7164,6003},{1004,7227,5940},{1004,7245,5923}]'),(15,4,'[{1004,7245,5923},{1004,7369,5889},{1004,7492,5870},{1004,7616,5862},{1004,7739,5877},{1004,7863,5912},{1004,7987,5951},{1004,8109,5992},{1004,8233,6042},{1004,8316,6105},{1004,8365,6168},{1004,8392,6232},{1004,8404,6295},{1004,8413,6359},{1004,8421,6423},{1004,8425,6488},{1004,8428,6552},{1004,8431,6617},{1004,8434,6681},{1004,8437,6746},{1004,8440,6810},{1004,8443,6875},{1004,8446,6940},{1004,8449,7004},{1004,8452,7069},{1004,8455,7133},{1004,8458,7198},{1004,8463,7262},{1004,8469,7326},{1004,8475,7391},{1004,8484,7455},{1004,8496,7518},{1004,8511,7581},{1004,8529,7643},{1004,8550,7704},{1004,8576,7769},{1004,8607,7831},{1004,8640,7892},{1004,8675,7952},{1004,8710,8012},{1004,8745,8072},{1004,8781,8132},{1004,8816,8193},{1004,8851,8253},{1004,8891,8316},{1004,8932,8378},{1004,8973,8440},{1004,9015,8502},{1004,9057,8563},{1004,9100,8624},{1004,9145,8684},{1004,9189,8744},{1004,9238,8806},{1004,9289,8867},{1004,9340,8928},{1004,9391,8989},{1004,9442,9050},{1004,9493,9111},{1004,9544,9172},{1004,9595,9234},{1004,9646,9295},{1004,9697,9356},{1004,9748,9417},{1004,9799,9478},{1004,9849,9539},{1004,9898,9602},{1004,9941,9663},{1004,9981,9725},{1004,10016,9786},{1004,10047,9848},{1004,10078,9910},{1004,10110,9972},{1004,10141,10034},{1004,10172,10096},{1004,10181,10114}]'),(16,4,'[{1004,10181,10114},{1004,10305,10077},{1004,10428,10062},{1004,10552,10054},{1004,10676,10057},{1004,10800,10062},{1004,10924,10072},{1004,11048,10086},{1004,11171,10103},{1004,11293,10145},{1004,11414,10202},{1004,11484,10265},{1004,11548,10327},{1004,11612,10390},{1004,11671,10450},{1004,11722,10511},{1004,11773,10572},{1004,11824,10633},{1004,11873,10696},{1004,11904,10758},{1004,11923,10820},{1004,11937,10883},{1004,11947,10947},{1004,11954,11011},{1004,11960,11075},{1004,11963,11140},{1004,11967,11204},{1004,11966,11269},{1004,11966,11333},{1004,11965,11398},{1004,11964,11462},{1004,11963,11527},{1004,11962,11592},{1004,11961,11656},{1004,11960,11721},{1004,11959,11786},{1004,11959,11850},{1004,11951,11914},{1004,11943,11978},{1004,11940,12043},{1004,11938,12108},{1004,11938,12172},{1004,11939,12237},{1004,11942,12301},{1004,11948,12366},{1004,11959,12429},{1004,11977,12491},{1004,12003,12556},{1004,12031,12619},{1004,12059,12683},{1004,12088,12746},{1004,12122,12807},{1004,12160,12871},{1004,12201,12933},{1004,12243,12995},{1004,12284,13057},{1004,12326,13119},{1004,12367,13181},{1004,12409,13243},{1004,12451,13304},{1004,12493,13366},{1004,12535,13428},{1004,12577,13489},{1004,12619,13551},{1004,12661,13613},{1004,12703,13674},{1004,12745,13736},{1004,12787,13797},{1004,12829,13859},{1004,12871,13920},{1004,12914,13981},{1004,12961,14045},{1004,13009,14109},{1004,13056,14173},{1004,13104,14236},{1004,13152,14300},{1004,13199,14364},{1004,13247,14428},{1004,13294,14491},{1004,13342,14555},{1004,13389,14619},{1004,13437,14683},{1004,13482,14743},{1004,13529,14807},{1004,13577,14871},{1004,13624,14935},{1004,13672,14998},{1004,13719,15062},{1004,13767,15126},{1004,13814,15190},{1004,13862,15254},{1004,13904,15315},{1004,13945,15377},{1004,13986,15440},{1004,14027,15502},{1004,14068,15564},{1004,14109,15626},{1004,14150,15688},{1004,14191,15751},{1004,14231,15814},{1004,14270,15877},{1004,14309,15941},{1004,14351,16002},{1004,14393,16064},{1004,14434,16126},{1004,14475,16189},{1004,14497,16222}]'),(17,5,'[{1004,14521,16424},{1004,14487,16364},{1004,14454,16303},{1004,14419,16242},{1004,14363,16179},{1004,14304,16119},{1004,14260,16058},{1004,14220,15996},{1004,14180,15933},{1004,14131,15870},{1004,14082,15808},{1004,14033,15745},{1004,13983,15683},{1004,13934,15620},{1004,13885,15558},{1004,13835,15496},{1004,13792,15435},{1004,13753,15371},{1004,13719,15311},{1004,13692,15247},{1004,13671,15186},{1004,13653,15124},{1004,13635,15062},{1004,13607,14998},{1004,13568,14934},{1004,13527,14872},{1004,13483,14812},{1004,13439,14752},{1004,13395,14692},{1004,13345,14630},{1004,13294,14569},{1004,13236,14507},{1004,13178,14445},{1004,13122,14381},{1004,13073,14319},{1004,13024,14256},{1004,12975,14192},{1004,12936,14129},{1004,12902,14068},{1004,12871,14006},{1004,12844,13941},{1004,12817,13877},{1004,12789,13814},{1004,12757,13752},{1004,12722,13692},{1004,12678,13632},{1004,12627,13571},{1004,12564,13507},{1004,12500,13444},{1004,12436,13382},{1004,12371,13320},{1004,12306,13259},{1004,12241,13198},{1004,12176,13137},{1004,12111,13075},{1004,12055,13012},{1004,11999,12948},{1004,11948,12887},{1004,11899,12825},{1004,11850,12762},{1004,11801,12699},{1004,11752,12637},{1004,11703,12574},{1004,11653,12513},{1004,11588,12451},{1004,11504,12389},{1004,11383,12333},{1004,11261,12307},{1004,11138,12293},{1004,11014,12287},{1004,10890,12283},{1004,10766,12270},{1004,10642,12236},{1004,10520,12180},{1004,10449,12119},{1004,10398,12057},{1004,10357,11995},{1004,10322,11935},{1004,10290,11873},{1004,10260,11811},{1004,10231,11747},{1004,10203,11684},{1004,10175,11620},{1004,10146,11556},{1004,10118,11493},{1004,10096,11432},{1004,10077,11371},{1004,10060,11308},{1004,10048,11245},{1004,10040,11181},{1004,10035,11116},{1004,10036,11052},{1004,10042,10987},{1004,10051,10923},{1004,10063,10860},{1004,10080,10797},{1004,10101,10736},{1004,10124,10676},{1004,10152,10612},{1004,10182,10549},{1004,10213,10487},{1004,10216,10483}]'),(18,5,'[{1004,10216,10483},{1004,10197,10421},{1004,10180,10359},{1004,10159,10298},{1004,10126,10237},{1004,10084,10175},{1004,10044,10112},{1004,10006,10048},{1004,9968,9984},{1004,9929,9920},{1004,9891,9856},{1004,9852,9793},{1004,9814,9729},{1004,9775,9665},{1004,9745,9602},{1004,9715,9539},{1004,9684,9477},{1004,9652,9415},{1004,9618,9354},{1004,9576,9293},{1004,9526,9232},{1004,9467,9171},{1004,9408,9111},{1004,9349,9050},{1004,9289,8990},{1004,9226,8927},{1004,9163,8863},{1004,9100,8800},{1004,9042,8739},{1004,8990,8679},{1004,8938,8619},{1004,8890,8555},{1004,8851,8491},{1004,8813,8427},{1004,8775,8363},{1004,8737,8299},{1004,8699,8235},{1004,8661,8171},{1004,8623,8107},{1004,8584,8043},{1004,8536,7980},{1004,8480,7917},{1004,8421,7856},{1004,8343,7794},{1004,8241,7733},{1004,8127,7672},{1004,8005,7630},{1004,7882,7613},{1004,7758,7607},{1004,7634,7601},{1004,7511,7585},{1004,7391,7554},{1004,7273,7491},{1004,7195,7428},{1004,7136,7368},{1004,7086,7307},{1004,7045,7244},{1004,7007,7180},{1004,6975,7119},{1004,6953,7058},{1004,6936,6996},{1004,6925,6932},{1004,6923,6868},{1004,6929,6803},{1004,6939,6739},{1004,6953,6676},{1004,6969,6614},{1004,6987,6552},{1004,7010,6491},{1004,7040,6428},{1004,7073,6368},{1004,7114,6305},{1004,7164,6243},{1004,7227,6180},{1004,7245,6163}]'),(19,5,'[{1004,7245,6163},{1004,7369,6129},{1004,7492,6110},{1004,7616,6102},{1004,7739,6117},{1004,7863,6152},{1004,7987,6191},{1004,8109,6232},{1004,8233,6282},{1004,8316,6345},{1004,8365,6408},{1004,8392,6472},{1004,8404,6535},{1004,8413,6599},{1004,8421,6663},{1004,8425,6728},{1004,8428,6792},{1004,8431,6857},{1004,8434,6921},{1004,8437,6986},{1004,8440,7050},{1004,8443,7115},{1004,8446,7180},{1004,8449,7244},{1004,8452,7309},{1004,8455,7373},{1004,8458,7438},{1004,8463,7502},{1004,8469,7566},{1004,8475,7631},{1004,8484,7695},{1004,8496,7758},{1004,8511,7821},{1004,8529,7883},{1004,8550,7944},{1004,8576,8009},{1004,8607,8071},{1004,8640,8132},{1004,8675,8192},{1004,8710,8252},{1004,8745,8312},{1004,8781,8372},{1004,8816,8433},{1004,8851,8493},{1004,8891,8556},{1004,8932,8618},{1004,8973,8680},{1004,9015,8742},{1004,9057,8803},{1004,9100,8864},{1004,9145,8924},{1004,9189,8984},{1004,9238,9046},{1004,9289,9107},{1004,9340,9168},{1004,9391,9229},{1004,9442,9290},{1004,9493,9351},{1004,9544,9412},{1004,9595,9474},{1004,9646,9535},{1004,9697,9596},{1004,9748,9657},{1004,9799,9718},{1004,9849,9779},{1004,9898,9842},{1004,9941,9903},{1004,9981,9965},{1004,10016,10026},{1004,10047,10088},{1004,10078,10150},{1004,10110,10212},{1004,10141,10274},{1004,10172,10336},{1004,10181,10354}]'),(20,5,'[{1004,10181,10354},{1004,10305,10317},{1004,10428,10302},{1004,10552,10294},{1004,10676,10297},{1004,10800,10302},{1004,10924,10312},{1004,11048,10326},{1004,11171,10343},{1004,11293,10385},{1004,11414,10442},{1004,11484,10505},{1004,11548,10567},{1004,11612,10630},{1004,11671,10690},{1004,11722,10751},{1004,11773,10812},{1004,11824,10873},{1004,11873,10936},{1004,11904,10998},{1004,11923,11060},{1004,11937,11123},{1004,11947,11187},{1004,11954,11251},{1004,11960,11315},{1004,11963,11380},{1004,11967,11444},{1004,11966,11509},{1004,11966,11573},{1004,11965,11638},{1004,11964,11702},{1004,11963,11767},{1004,11962,11832},{1004,11961,11896},{1004,11960,11961},{1004,11959,12026},{1004,11959,12090},{1004,11951,12154},{1004,11943,12218},{1004,11940,12283},{1004,11938,12348},{1004,11938,12412},{1004,11939,12477},{1004,11942,12541},{1004,11948,12606},{1004,11959,12669},{1004,11977,12731},{1004,12003,12796},{1004,12031,12859},{1004,12059,12923},{1004,12088,12986},{1004,12122,13047},{1004,12160,13111},{1004,12201,13173},{1004,12243,13235},{1004,12284,13297},{1004,12326,13359},{1004,12367,13421},{1004,12409,13483},{1004,12451,13544},{1004,12493,13606},{1004,12535,13668},{1004,12577,13729},{1004,12619,13791},{1004,12661,13853},{1004,12703,13914},{1004,12745,13976},{1004,12787,14037},{1004,12829,14099},{1004,12871,14160},{1004,12914,14221},{1004,12961,14285},{1004,13009,14349},{1004,13056,14413},{1004,13104,14476},{1004,13152,14540},{1004,13199,14604},{1004,13247,14668},{1004,13294,14731},{1004,13342,14795},{1004,13389,14859},{1004,13437,14923},{1004,13482,14983},{1004,13529,15047},{1004,13577,15111},{1004,13624,15175},{1004,13672,15238},{1004,13719,15302},{1004,13767,15366},{1004,13814,15430},{1004,13862,15494},{1004,13904,15555},{1004,13945,15617},{1004,13986,15680},{1004,14027,15742},{1004,14068,15804},{1004,14109,15866},{1004,14150,15928},{1004,14191,15991},{1004,14231,16054},{1004,14270,16117},{1004,14309,16181},{1004,14351,16242},{1004,14393,16304},{1004,14434,16366},{1004,14475,16429},{1004,14497,16462}]');
/*!40000 ALTER TABLE `base_parade_path` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_parade_time`
--

DROP TABLE IF EXISTS `base_parade_time`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_parade_time` (
  `time_id` int(10) unsigned NOT NULL COMMENT '时间段序号',
  `begin_time` varchar(500) NOT NULL COMMENT '开始时间',
  `end_time` varchar(500) NOT NULL COMMENT '结束时间',
  PRIMARY KEY (`time_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='巡游时间表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_parade_time`
--

LOCK TABLES `base_parade_time` WRITE;
/*!40000 ALTER TABLE `base_parade_time` DISABLE KEYS */;
INSERT INTO `base_parade_time` VALUES (1,'{8,30}','{8,45}'),(2,'{9,30}','{9,45}'),(3,'{10,30}','{10,45}'),(4,'{11,30}','{11,45}'),(5,'{12,30}','{12,45}'),(6,'{13,30}','{13,45}'),(7,'{14,30}','{14,45}'),(8,'{15,30}','{15,45}'),(9,'{16,30}','{16,45}'),(10,'{17,30}','{17,45}'),(11,'{18,30}','{18,45}'),(12,'{19,30}','{19,45}'),(13,'{20,30}','{20,45}'),(14,'{21,30}','{21,45}'),(15,'{22,30}','{22,45}'),(16,'{23,30}','{23,45}');
/*!40000 ALTER TABLE `base_parade_time` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_parade_time_stage`
--

DROP TABLE IF EXISTS `base_parade_time_stage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_parade_time_stage` (
  `stage_id` int(10) unsigned NOT NULL COMMENT '阶段序号',
  `stage_name` varchar(255) NOT NULL COMMENT '阶段名@lang@',
  `continue_time` int(10) unsigned NOT NULL COMMENT '持续时间',
  `test` varchar(255) NOT NULL COMMENT '玩法说明@lang@',
  PRIMARY KEY (`stage_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='巡游时间阶段表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_parade_time_stage`
--

LOCK TABLES `base_parade_time_stage` WRITE;
/*!40000 ALTER TABLE `base_parade_time_stage` DISABLE KEYS */;
INSERT INTO `base_parade_time_stage` VALUES (1,'巡游准备',60,'巡游第一阶段'),(2,'巡游撒花',210,'巡游第二阶段'),(3,'巡游骚扰',210,'巡游第二阶段'),(4,'巡游福利',120,'巡游第四阶段');
/*!40000 ALTER TABLE `base_parade_time_stage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_partner`
--

DROP TABLE IF EXISTS `base_partner`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_partner` (
  `partner_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `name` varchar(128) NOT NULL COMMENT '名称@lang@',
  `model_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '模型id',
  `weapon_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '武器id',
  `chartlet_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '贴图id',
  `quality` tinyint(2) unsigned NOT NULL DEFAULT '1' COMMENT '品质',
  `career` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '五行',
  `born_attr` varchar(128) NOT NULL COMMENT '出生属性',
  `grow_up` varchar(128) NOT NULL COMMENT '成长',
  `attack_skill` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '攻击技能',
  `assist_skill` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '护主技能',
  `assist_condition` varchar(256) NOT NULL COMMENT '护主等级',
  `talent_skill` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '天赋',
  `talent_describe` varchar(1024) NOT NULL COMMENT '天赋描述@lang@',
  `personality` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '个性',
  `personality_desc` varchar(1024) NOT NULL COMMENT '个性描述',
  `speciality` varchar(2048) DEFAULT '' COMMENT '特性',
  `recruit_type` varchar(256) NOT NULL COMMENT '招募类型',
  PRIMARY KEY (`partner_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='伙伴配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_partner`
--

LOCK TABLES `base_partner` WRITE;
/*!40000 ALTER TABLE `base_partner` DISABLE KEYS */;
INSERT INTO `base_partner` VALUES (101,'绿翼毒蜂',5010074,0,0,1,1,'[800,73,102,73,44]','[3,4.2,3,1.8]',2001010,2100001,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,999999,6}]',2201010,'对目标造成基础攻击*257%的伤害',1,'优先攻击对主人造成伤害的敌人，并降低其攻击力的10%（攻击降低持续3秒）','忠诚','[{1,0,60},{2,0,18}]'),(102,'紫翼毒蜂',5010074,0,1,1,2,'[800,102,73,87,29]','[4.2,3,3.6,1.2]',2001020,2100003,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,999999,6}]',2201020,'对目标造成基础攻击*257%的伤害',2,'永久提升抗会心几率400点','稳重','[{1,0,60},{2,0,18}]'),(103,'黄翼毒蜂',5010074,0,2,1,3,'[800,102,73,44,73]','[4.2,3,1.8,3]',2001030,2100002,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,999999,6}]',2201030,'对目标造成基础攻击*257%的伤害',3,'优先攻击对主人造成伤害的敌人，并对优先目标伤害提升10%','护佑','[{1,0,60},{2,0,18}]'),(104,'顽皮蘑菇',5010070,0,0,1,4,'[800,102,73,87,29]','[4.2,3,3.6,1.2]',2001040,2100005,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,999999,6}]',2201040,'对目标造成基础攻击*257%的伤害',4,'优先攻击敌方玩家','无畏','[{1,0,60},{2,0,18}]'),(105,'低落蘑菇',5010070,0,1,1,5,'[800,87,73,102,29]','[3.6,3,4.2,1.2]',2001050,2100006,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,999999,6}]',2201050,'对目标造成基础攻击*257%的伤害',5,'优先攻击血量最少的目标，并提升全身总抗性10%','稳重','[{1,0,60},{2,0,18}]'),(106,'忧郁蘑菇',5010070,0,2,1,3,'[800,87,73,44,87]','[3.6,3,1.8,3.6]',2001060,2100007,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,999999,6}]',2201060,'对目标造成基础攻击*257%的伤害',6,'视野范围内属于你的敌人攻击力降低10%','观测','[{1,0,60},{2,0,18}]'),(107,'愤怒蘑菇',5010070,0,3,1,4,'[800,102,58,73,58]','[4.2,2.4,3,2.4]',2001070,2100001,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,999999,6}]',2201070,'对目标造成基础攻击*257%的伤害',7,'优先攻击血量最少的目标，并提升自身攻击力的5%','诡计','[{1,0,60},{2,0,18}]'),(108,'洞穴蝙蝠',5010075,0,0,1,5,'[800,58,29,102,102]','[2.4,1.2,4.2,4.2]',2001080,2100003,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,999999,6}]',2201080,'对目标造成基础攻击*257%的伤害',8,'优先攻击最近的目标，并提升全系抗性30%','豪放','[{1,0,60},{2,0,18}]'),(109,'深渊蝙蝠',5010075,0,1,1,1,'[800,102,87,44,58]','[4.2,3.6,1.8,2.4]',2001090,2100004,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,999999,6}]',2201090,'对目标造成基础攻击*257%的伤害',9,'视野范围内战力低于你的敌人攻击力降低10%','威慑','[{1,0,60},{2,0,18}]'),(110,'暗夜蝙蝠',5010075,0,2,1,2,'[800,73,58,44,116]','[3,2.4,1.8,4.8]',2001100,2100005,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,999999,6}]',2201100,'对目标造成基础攻击*257%的伤害',11,'与主人的攻击目标一致','睿智','[{1,0,60},{2,0,18}]'),(111,'水傀儡',5010007,0,0,1,4,'[800,58,73,58,102]','[2.4,3,2.4,4.2]',2001110,2100006,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,999999,6}]',2201110,'对目标造成基础攻击*257%的伤害',12,'血量低于30%时全系抗性提升75%','坚韧','[{1,0,60},{2,0,18}]'),(112,'工程地精',5010076,5010076,0,1,4,'[800,73,15,87,116]','[3,0.6,3.6,4.8]',2001120,2100007,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,999999,6}]',2201120,'对目标造成基础攻击*257%的伤害',13,'血量低于30%时攻击力提升45%','狂战','[{1,0,60},{2,0,18}]'),(113,'学徒地精',5010076,5010076,1,1,3,'[800,102,44,73,73]','[4.2,1.8,3,3]',2001130,2100001,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,999999,6}]',2201130,'对目标造成基础攻击*257%的伤害',15,'优先攻击血量低于30%的目标，且血量低于30%时攻击力提升30%','弑虐','[{1,0,60},{2,0,18}]'),(207,'暴食怪箱',5010068,0,0,2,1,'[1000,124,104,124,62]','[4.8,4,4.8,2.4]',2002070,2100005,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,1999,6},{2000,2499,7},{2500,999999,8}]',2202070,'对目标造成基础攻击*276%的伤害',5,'优先攻击血量最少的目标，并提升全身总抗性10%','稳重','[{1,0,20},{2,0,28}]'),(208,'贪欲怪箱',5010068,0,1,2,2,'[1000,124,124,124,41]','[4.8,4.8,4.8,1.6]',2002080,2100004,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,1999,6},{2000,2499,7},{2500,999999,8}]',2202080,'对目标造成基础攻击*276%的伤害',6,'视野范围内属于你的敌人攻击力降低10%','观测','[{1,0,20},{2,0,28}]'),(209,'元素怪箱',5010068,0,2,2,3,'[1000,124,124,83,83]','[4.8,4.8,3.2,3.2]',2002090,2100005,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,1999,6},{2000,2499,7},{2500,999999,8}]',2202090,'对目标造成基础攻击*276%的伤害',7,'优先攻击血量最少的目标，并提升自身攻击力的5%','诡计','[{1,0,20},{2,0,28}]'),(210,'恐惧怪箱',5010068,0,3,2,5,'[1000,104,124,83,104]','[4,4.8,3.2,4]',2002100,2100011,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,1999,6},{2000,2499,7},{2500,999999,8}]',2202100,'对目标造成基础攻击*276%的伤害',8,'优先攻击最近的目标，并提升全系抗性30%','豪放','[{1,0,20},{2,0,28}]'),(211,'沙漠龙龟',5010071,0,0,2,4,'[1000,124,62,104,124]','[4.8,2.4,4,4.8]',2002110,2100002,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,1999,6},{2000,2499,7},{2500,999999,8}]',2202110,'对目标造成基础攻击*276%的伤害',9,'视野范围内战力低于你的敌人攻击力降低10%','威慑','[{1,0,20},{2,0,28}]'),(212,'水华龙龟',5010071,0,1,2,3,'[1000,124,83,124,83]','[4.8,3.2,4.8,3.2]',2002120,2100001,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,1999,6},{2000,2499,7},{2500,999999,8}]',2202120,'对目标造成基础攻击*276%的伤害',12,'血量低于30%时全系抗性提升75%','坚韧','[{1,0,20},{2,0,28}]'),(213,'亡灵射手',5010077,5010077,0,2,2,'[1000,104,62,83,166]','[4,2.4,3.2,6.4]',2002130,2100003,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,1999,6},{2000,2499,7},{2500,999999,8}]',2202130,'对目标造成基础攻击*276%的伤害',11,'与主人的攻击目标一致','睿智','[{1,0,20},{2,0,28}]'),(214,'不死者射手',5010078,5010078,0,2,5,'[1000,83,104,83,145]','[3.2,4,3.2,5.6]',2002140,2100004,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,1999,6},{2000,2499,7},{2500,999999,8}]',2202140,'对目标造成基础攻击*276%的伤害',8,'优先攻击最近的目标，并提升全系抗性30%','豪放','[{1,0,20},{2,0,28}]'),(215,'亡灵猎人',5010079,5010079,0,2,3,'[1000,104,41,145,124]','[4,1.6,5.6,4.8]',2002150,2100008,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,1999,6},{2000,2499,7},{2500,999999,8}]',2202150,'对目标造成基础攻击*276%的伤害',13,'血量低于30%时攻击力提升45%','狂战','[{1,0,20},{2,0,28}]'),(216,'小火龙',5010037,0,0,2,4,'[1000,104,62,124,124]','[4,2.4,4.8,4.8]',2002160,2100006,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,1999,6},{2000,2499,7},{2500,999999,8}]',2202160,'对目标造成基础攻击*276%的伤害',14,'优先攻击对自身造成伤害的目标，并提升抗属性效果几率的45%','强攻','[{1,0,20},{2,0,28}]'),(217,'炼',2010201400,2020201400,0,2,2,'[1000,83,104,83,145]','[3.2,4,3.2,5.6]',2002170,2100010,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,1999,6},{2000,2499,7},{2500,3499,8},{3500,4499,9},{4500,5999,10},{6000,7999,11},{8000,999999,12}]',2202170,'对目标造成基础攻击*150%的伤害和1秒受伤时间',15,'优先攻击血量低于30%的目标，且血量低于30%时攻击力提升30%','弑虐','[{1,0,20},{2,0,28}]'),(301,'洛克',2010200600,2020200600,0,3,1,'[1200,186,155,186,93]','[6,5,6,3]',2003010,2100001,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,1999,6},{2000,2499,7},{2500,3499,8},{3500,4499,9},{4500,999999,10}]',2203010,'对目标造成基础攻击*400%的伤害',8,'优先攻击最近的目标，并提升全系抗性30%','豪放','[{1,1,10},{2,0,8}]'),(302,'夜枭法师',7010014,0,0,3,3,'[1200,217,93,186,124]','[7,3,6,4]',2003020,2100003,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,1999,6},{2000,2499,7},{2500,3499,8},{3500,4499,9},{4500,999999,10}]',2203020,'对目标造成基础攻击*315%的伤害',9,'视野范围内战力低于你的敌人攻击力降低10%','威慑','[]'),(303,'地牢巨人',6010012,0,0,3,4,'[1200,155,186,186,93]','[5,6,6,3]',2003030,2100004,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,1999,6},{2000,2499,7},{2500,3499,8},{3500,4499,9},{4500,999999,10}]',2203030,'对目标造成基础攻击*315%的伤害',7,'优先攻击血量最少的目标，并提升自身攻击力的5%','诡计','[]'),(315,'独食巨花',5010072,0,0,3,1,'[1200,93,155,124,248]','[3,5,4,8]',2003150,2100007,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,1999,6},{2000,2499,7},{2500,3499,8},{3500,4499,9},{4500,999999,10}]',2203150,'对目标造成基础攻击*330%的伤害',14,'优先攻击对自身造成伤害的目标，并提升抗属性效果几率的45%','强攻','[{1,1,10},{2,0,8}]'),(316,'剧毒巨花',5010072,0,1,3,2,'[1200,124,93,155,248]','[4,3,5,8]',2003160,2100001,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,1999,6},{2000,2499,7},{2500,3499,8},{3500,4499,9},{4500,999999,10}]',2203160,'对目标造成基础攻击*330%的伤害',15,'优先攻击血量低于30%的目标，且血量低于30%时攻击力提升30%','弑虐','[{1,1,10},{2,0,8}]'),(317,'冰冻巨花',5010072,0,2,3,3,'[1200,186,155,155,124]','[6,5,5,4]',2003170,2100003,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,1999,6},{2000,2499,7},{2500,3499,8},{3500,4499,9},{4500,999999,10}]',2203170,'对目标造成基础攻击*330%的伤害',1,'优先攻击对主人造成伤害的敌人，并降低其攻击力的10%（攻击降低持续3秒）','忠诚','[{1,1,10},{2,0,8}]'),(318,'陵墓守护者',5010080,0,0,3,4,'[1200,93,62,186,279]','[3,2,6,9]',2003180,2100002,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,1999,6},{2000,2499,7},{2500,3499,8},{3500,4499,9},{4500,999999,10}]',2203180,'对目标造成基础攻击*400%的伤害',2,'永久提升抗会心几率400点','稳重','[{1,1,10},{2,0,8}]'),(319,'陵墓寻路者',5010080,0,1,3,5,'[1200,155,186,124,155]','[5,6,4,5]',2003190,2100011,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,1999,6},{2000,2499,7},{2500,3499,8},{3500,4499,9},{4500,999999,10}]',2203190,'对目标造成基础攻击*400%的伤害',3,'优先攻击对主人造成伤害的敌人，并对优先目标伤害提升10%','护佑','[{1,1,10},{2,0,8}]'),(320,'冰霜战士',5010083,0,0,3,1,'[1200,155,186,186,93]','[5,6,6,3]',2003200,2100005,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,1999,6},{2000,2499,7},{2500,3499,8},{3500,4499,9},{4500,999999,10}]',2203200,'对目标造成基础攻击*180%的伤害，并晕眩1秒',4,'优先攻击敌方玩家','无畏','[{1,1,10},{2,0,8}]'),(321,'冰霜勇士',5010084,0,0,3,5,'[1200,186,186,186,62]','[6,6,6,2]',2003210,2100007,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,1999,6},{2000,2499,7},{2500,3499,8},{3500,4499,9},{4500,999999,10}]',2203210,'对目标造成基础攻击*315%的伤害',5,'优先攻击血量最少的目标，并提升全身总抗性10%','稳重','[{1,1,10},{2,0,8}]'),(322,'冰霜女巫',5010085,0,0,3,2,'[1200,217,93,186,124]','[7,3,6,4]',2003220,2100010,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,1999,6},{2000,2499,7},{2500,3499,8},{3500,4499,9},{4500,999999,10}]',2203220,'对目标造成基础攻击*315%的伤害',15,'优先攻击血量低于30%的目标，且血量低于30%时攻击力提升30%','弑虐','[{1,1,10},{2,0,8}]'),(323,'汉娜',2010400100,2020400100,0,3,3,'[1200,248,124,124,124]','[8,4,4,4]',2003230,2100005,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,1999,6},{2000,2499,7},{2500,3499,8},{3500,4499,9},{4500,5999,10},{6000,7999,11},{8000,999999,12}]',2203230,'回复一个目标的血量，持续5秒，每秒回复体质*1.5的血量',5,'优先攻击血量最少的目标，并提升全身总抗性10%','稳重','[{1,1,10},{2,0,8}]'),(324,'冰晶恶魔',6010013,0,1,3,3,'[1200,217,93,186,124]','[7,3,6,4]',2003240,2100004,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,1999,6},{2000,2499,7},{2500,3499,8},{3500,4499,9},{4500,999999,10}]',2203240,'对目标造成基础攻击*180%的伤害，并造成1秒受伤',6,'视野范围内属于你的敌人攻击力降低10%','观测','[]'),(325,'暗石恶魔',6010013,0,2,3,2,'[1200,248,124,124,124]','[8,4,4,4]',2003250,2100002,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,1999,6},{2000,2499,7},{2500,3499,8},{3500,4499,9},{4500,5999,10},{6000,7999,11},{8000,999999,12}]',2203250,'对目标造成基础攻击*180%的伤害，并造成1秒迟缓',12,'血量低于30%时全系抗性提升75%','坚韧','[]'),(326,'熔岩恶魔',6010013,0,0,3,5,'[1200,155,31,248,186]','[5,1,8,6]',2003260,2100011,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,1999,6},{2000,2499,7},{2500,3499,8},{3500,4499,9},{4500,999999,10}]',2203260,'对目标造成基础攻击*180%的伤害，并造成1秒弱体',9,'视野范围内战力低于你的敌人攻击力降低10%','威慑','[]'),(401,'梅迪莎',2010300200,2020300200,0,4,4,'[1500,173,86,345,259]','[4.8,2.4,9.6,7.2]',2004010,2100007,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,1999,6},{2000,2499,7},{2500,3499,8},{3500,4499,9},{4500,5999,10},{6000,7999,11},{8000,999999,12}]',2204010,'向前射击3下，最后一下造成爆炸，对命中单位总共造成基础攻击*400%的伤害',15,'优先攻击血量低于30%的目标，且血量低于30%时攻击力提升30%','弑虐','[{2,1,20}]'),(402,'夏洛特',2010200300,2020200300,0,4,1,'[1500,259,216,259,129]','[7.2,6,7.2,3.6]',2004020,2100005,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,1999,6},{2000,2499,7},{2500,3499,8},{3500,4499,9},{4500,5999,10},{6000,7999,11},{8000,999999,12}]',2204020,'持续剑舞攻击周围单位，对周围单位造成基础攻击*400%的伤害',13,'血量低于30%时攻击力提升45%','狂战','[{2,1,20}]'),(403,'龙之魔女',2010201200,2020201200,0,4,2,'[1500,129,173,173,388]','[3.6,4.8,4.8,10.8]',2004030,2100010,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,1999,6},{2000,2499,7},{2500,3499,8},{3500,4499,9},{4500,5999,10},{6000,7999,11},{8000,999999,12}]',2204030,'对目标造成基础攻击*200%的伤害，并造成2秒受伤',14,'优先攻击对自身造成伤害的目标，并提升抗属性效果几率的45%','强攻','[{2,1,20}]'),(406,'布莱克',2010200800,2020200800,0,4,5,'[1500,259,259,216,129]','[7.2,7.2,6,3.6]',2004060,2100004,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,1999,6},{2000,2499,7},{2500,3499,8},{3500,4499,9},{4500,5999,10},{6000,7999,11},{8000,999999,12}]',2204060,'对目标造成基础攻击*200%的伤害，并造成2秒受伤',11,'与主人的攻击目标一致','睿智','[{2,1,20}]'),(407,'菲利斯',2010200900,2020200900,0,4,4,'[1500,173,86,259,345]','[4.8,2.4,7.2,9.6]',2004070,2100006,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,1999,6},{2000,2499,7},{2500,3499,8},{3500,4499,9},{4500,5999,10},{6000,7999,11},{8000,999999,12}]',2204070,'对目标造成基础攻击*200%的伤害，并造成2秒弱体',12,'血量低于30%时全系抗性提升75%','坚韧','[{2,1,20}]'),(408,'圣少女贞德',2010301000,2020301000,0,4,3,'[1500,216,173,129,345]','[6,4.8,3.6,9.6]',2004080,2100008,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,1999,6},{2000,2499,7},{2500,3499,8},{3500,4499,9},{4500,5999,10},{6000,7999,11},{8000,999999,12}]',2204080,'对目标造成基础攻击*210%的伤害，并造成2秒迟缓',9,'视野范围内战力低于你的敌人攻击力降低10%','威慑','[{2,1,20}]'),(413,'蔷薇皇女',2010401600,2020401600,0,4,1,'[1500,259,216,302,86]','[7.2,6,8.4,2.4]',2004130,2100007,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,1999,6},{2000,2499,7},{2500,3499,8},{3500,4499,9},{4500,5999,10},{6000,7999,11},{8000,999999,12}]',2204130,'给队友增加一个护盾，共抵挡攻击*1.5+600点伤害，持续5秒',8,'优先攻击最近的目标，并提升全系抗性30%','豪放','[{2,1,20}]'),(417,'哥布林首领',6010007,0,0,4,5,'[1500,173,43,259,388]','[4.8,1.2,7.2,10.8]',2004170,2100010,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,1999,6},{2000,2499,7},{2500,3499,8},{3500,4499,9},{4500,5999,10},{6000,7999,11},{8000,999999,12}]',2204170,'对目标造成基础攻击*200%的伤害，并造成1.5秒晕眩',9,'视野范围内战力低于你的敌人攻击力降低10%','威慑','[]'),(418,'蜥蜴首领',6010010,0,0,4,5,'[1500,259,216,259,129]','[7.2,6,7.2,3.6]',2004180,2100003,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,1999,6},{2000,2499,7},{2500,3499,8},{3500,4499,9},{4500,5999,10},{6000,7999,11},{8000,999999,12}]',2204180,'攻击周围单位，造成基础攻击*200%伤害，并降低命中单位10%攻击和30%的会心几率',2,'永久提升抗会心几率400点','稳重','[]'),(422,'冥火之主',7010001,0,0,4,2,'[1500,129,173,173,388]','[3.6,4.8,4.8,10.8]',2004220,2100004,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,1999,6},{2000,2499,7},{2500,3499,8},{3500,4499,9},{4500,5999,10},{6000,7999,11},{8000,999999,12}]',2204220,'对目标造成基础攻击*315%的伤害',3,'优先攻击对主人造成伤害的敌人，并对优先目标伤害提升10%','护佑','[]'),(423,'娜迦女王',7010002,0,0,4,3,'[1500,259,129,259,216]','[7.2,3.6,7.2,6]',2004230,2100005,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,1999,6},{2000,2499,7},{2500,3499,8},{3500,4499,9},{4500,5999,10},{6000,7999,11},{8000,999999,12}]',2204230,'对目标范围攻击四次，每次造成基础攻击*75%的伤害，并有20%概率造成1.5秒迟缓',1,'优先攻击对主人造成伤害的敌人，并降低其攻击力的10%（攻击降低持续3秒）','忠诚','[]'),(428,'炎魔赤主',7010007,0,0,4,4,'[1500,129,129,302,302]','[3.6,3.6,8.4,8.4]',2004280,2100011,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,1999,6},{2000,2499,7},{2500,3499,8},{3500,4499,9},{4500,5999,10},{6000,7999,11},{8000,999999,12}]',2204280,'对目标范围攻击四次，每次造成基础攻击*80%的伤害',14,'优先攻击对自身造成伤害的目标，并提升抗属性效果几率的45%','强攻','[]'),(431,'凯文',2010443100,2020443100,0,4,4,'[1500,259,216,259,129]','[7.2,6,7.2,3.6]',2004310,2100007,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,1999,6},{2000,2499,7},{2500,3499,8},{3500,4499,9},{4500,5999,10},{6000,7999,11},{8000,999999,12}]',2204310,'向前冲刺500距离，对命中的单位造成200%基础伤害，并晕眩1秒',11,'与主人的攻击目标一致','睿智','[{2,1,20}]'),(432,'杰兰特',2010443200,2020443200,0,4,5,'[1500,129,173,173,388]','[3.6,4.8,4.8,10.8]',2004320,2100001,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,1999,6},{2000,2499,7},{2500,3499,8},{3500,4499,9},{4500,5999,10},{6000,7999,11},{8000,999999,12}]',2204320,'对目标持续攻击，造成400%基础攻击伤害',4,'优先攻击敌方玩家','无畏','[{2,1,20}]'),(433,'樱',2010443300,2020443300,0,4,2,'[1500,259,129,259,216]','[7.2,3.6,7.2,6]',2004330,2100003,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,1999,6},{2000,2499,7},{2500,3499,8},{3500,4499,9},{4500,5999,10},{6000,7999,11},{8000,999999,12}]',2204330,'对目标造成200%基础伤害，并造成2秒受伤',5,'优先攻击血量最少的目标，并提升全身总抗性10%','稳重','[{2,1,20}]'),(501,'圣女贞德',2010420100,2020420100,0,5,3,'[2000,396,226,283,226]','[10.5,6,7.5,6]',2005010,2100008,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,1999,6},{2000,2499,7},{2500,3499,8},{3500,4499,9},{4500,5999,10},{6000,7999,11},{8000,9999,12},{10000,14999,13},{15000,19999,14},{20000,24999,15},{25000,999999,16}]',2205010,'召唤剑阵围绕自己旋转，对靠近的单位每次造成基础攻击*80%的伤害',6,'视野范围内属于你的敌人攻击力降低10%','观测','[]'),(502,'亚瑟王',2010420200,2020420200,0,5,1,'[2000,339,339,339,113]','[9,9,9,3]',2005020,2100001,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,1999,6},{2000,2499,7},{2500,3499,8},{3500,4499,9},{4500,5999,10},{6000,7999,11},{8000,9999,12},{10000,14999,13},{15000,19999,14},{20000,24999,15},{25000,999999,16}]',2205020,'对目标区域造成390%基础伤害',2,'永久提升抗会心几率400点','稳重','[]'),(503,'布伦希尔德',2010520300,2020520300,0,5,5,'[2000,339,339,226,226]','[9,9,6,6]',2005030,2100009,'[{0,249,1},{250,499,2},{500,749,3},{750,999,4},{1000,1499,5},{1500,1999,6},{2000,2499,7},{2500,3499,8},{3500,4499,9},{4500,5999,10},{6000,7999,11},{8000,9999,12},{10000,14999,13},{15000,19999,14},{20000,24999,15},{25000,999999,16}]',2205030,'对目标造成300%基础伤害，并造成2秒浮空',7,'优先攻击血量最少的目标，并提升自身攻击力的5%','诡计','[{2,1,10}]');
/*!40000 ALTER TABLE `base_partner` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_partner_battle_slot`
--

DROP TABLE IF EXISTS `base_partner_battle_slot`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_partner_battle_slot` (
  `slot` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '位置',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  PRIMARY KEY (`slot`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='上阵配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_partner_battle_slot`
--

LOCK TABLES `base_partner_battle_slot` WRITE;
/*!40000 ALTER TABLE `base_partner_battle_slot` DISABLE KEYS */;
INSERT INTO `base_partner_battle_slot` VALUES (1,9),(2,9),(3,20),(4,30);
/*!40000 ALTER TABLE `base_partner_battle_slot` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_partner_break`
--

DROP TABLE IF EXISTS `base_partner_break`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_partner_break` (
  `quality` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '品质',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `attr_val` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '加成属性',
  `loss_coef` varchar(512) NOT NULL COMMENT '折损系数',
  PRIMARY KEY (`quality`,`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='突破配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_partner_break`
--

LOCK TABLES `base_partner_break` WRITE;
/*!40000 ALTER TABLE `base_partner_break` DISABLE KEYS */;
INSERT INTO `base_partner_break` VALUES (1,10,160,'[{1,0.5},{2,0.375},{3,0.25},{4,0.125},{5,0}]'),(1,20,160,'[{1,0.5},{2,0.375},{3,0.25},{4,0.125},{5,0}]'),(1,30,160,'[{1,0.5},{2,0.375},{3,0.25},{4,0.125},{5,0}]'),(1,40,160,'[{1,0.5},{2,0.375},{3,0.25},{4,0.125},{5,0}]'),(1,50,160,'[{1,0.5},{2,0.375},{3,0.25},{4,0.125},{5,0}]'),(1,60,160,'[{1,0.5},{2,0.375},{3,0.25},{4,0.125},{5,0}]'),(2,10,240,'[{1,0.167},{2,0.125},{3,0.083},{4,0.042},{5,0}]'),(2,20,240,'[{1,0.167},{2,0.125},{3,0.083},{4,0.042},{5,0}]'),(2,30,240,'[{1,0.167},{2,0.125},{3,0.083},{4,0.042},{5,0}]'),(2,40,240,'[{1,0.167},{2,0.125},{3,0.083},{4,0.042},{5,0}]'),(2,50,240,'[{1,0.167},{2,0.125},{3,0.083},{4,0.042},{5,0}]'),(2,60,240,'[{1,0.167},{2,0.125},{3,0.083},{4,0.042},{5,0}]'),(3,10,400,'[{1,0.2},{2,0.15},{3,0.1},{4,0.05},{5,0}]'),(3,20,400,'[{1,0.2},{2,0.15},{3,0.1},{4,0.05},{5,0}]'),(3,30,400,'[{1,0.2},{2,0.15},{3,0.1},{4,0.05},{5,0}]'),(3,40,400,'[{1,0.2},{2,0.15},{3,0.1},{4,0.05},{5,0}]'),(3,50,400,'[{1,0.2},{2,0.15},{3,0.1},{4,0.05},{5,0}]'),(3,60,400,'[{1,0.2},{2,0.15},{3,0.1},{4,0.05},{5,0}]'),(4,10,600,'[{1,0.267},{2,0.2},{3,0.133},{4,0.067},{5,0}]'),(4,20,600,'[{1,0.267},{2,0.2},{3,0.133},{4,0.067},{5,0}]'),(4,30,600,'[{1,0.267},{2,0.2},{3,0.133},{4,0.067},{5,0}]'),(4,40,600,'[{1,0.267},{2,0.2},{3,0.133},{4,0.067},{5,0}]'),(4,50,600,'[{1,0.267},{2,0.2},{3,0.133},{4,0.067},{5,0}]'),(4,60,600,'[{1,0.267},{2,0.2},{3,0.133},{4,0.067},{5,0}]'),(5,10,800,'[{1,0.1},{2,0.075},{3,0.05},{4,0.025},{5,0}]'),(5,20,800,'[{1,0.1},{2,0.075},{3,0.05},{4,0.025},{5,0}]'),(5,30,800,'[{1,0.1},{2,0.075},{3,0.05},{4,0.025},{5,0}]'),(5,40,800,'[{1,0.1},{2,0.075},{3,0.05},{4,0.025},{5,0}]'),(5,50,800,'[{1,0.1},{2,0.075},{3,0.05},{4,0.025},{5,0}]'),(5,60,800,'[{1,0.1},{2,0.075},{3,0.05},{4,0.025},{5,0}]');
/*!40000 ALTER TABLE `base_partner_break` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_partner_callback`
--

DROP TABLE IF EXISTS `base_partner_callback`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_partner_callback` (
  `quality` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '品质',
  `goods` varchar(512) NOT NULL COMMENT '消耗',
  PRIMARY KEY (`quality`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='召回配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_partner_callback`
--

LOCK TABLES `base_partner_callback` WRITE;
/*!40000 ALTER TABLE `base_partner_callback` DISABLE KEYS */;
INSERT INTO `base_partner_callback` VALUES (1,'[{0,212101,2}]'),(2,'[{0,212101,5}]'),(3,'[{0,212101,10}]'),(4,'[{0,212101,30}]'),(5,'[{0,212101,125}]');
/*!40000 ALTER TABLE `base_partner_callback` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_partner_disband`
--

DROP TABLE IF EXISTS `base_partner_disband`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_partner_disband` (
  `type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `quality` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '品质',
  `award` varchar(512) NOT NULL COMMENT '折算',
  PRIMARY KEY (`type`,`quality`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='遣散配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_partner_disband`
--

LOCK TABLES `base_partner_disband` WRITE;
/*!40000 ALTER TABLE `base_partner_disband` DISABLE KEYS */;
INSERT INTO `base_partner_disband` VALUES (1,1,'[{0,212101,0.2},{0,212001,0.1}]'),(1,2,'[{0,212101,1},{0,212001,0.2}]'),(1,3,'[{0,212101,2.8},{0,212001,1.2}]'),(1,4,'[{0,212101,10.4},{0,212001,5.6}]'),(1,5,'[{0,212101,30},{0,212001,20}]'),(2,1,'[{0,212001,0.2}]'),(2,2,'[{0,212001,0.6}]'),(2,3,'[{0,212001,1.8}]'),(2,4,'[{0,212001,5.4}]'),(2,5,'[{0,212001,16}]');
/*!40000 ALTER TABLE `base_partner_disband` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_partner_promote`
--

DROP TABLE IF EXISTS `base_partner_promote`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_partner_promote` (
  `quality` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '品质',
  `prodigy` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '奇才',
  `goods` varchar(512) NOT NULL COMMENT '消耗',
  `promote` varchar(512) NOT NULL COMMENT '提升',
  PRIMARY KEY (`quality`,`prodigy`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='提升配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_partner_promote`
--

LOCK TABLES `base_partner_promote` WRITE;
/*!40000 ALTER TABLE `base_partner_promote` DISABLE KEYS */;
INSERT INTO `base_partner_promote` VALUES (1,0,'[{0,212001,1}]','[{350,450,100}]'),(1,1,'[{0,212001,1}]','[{350,450,100}]'),(2,0,'[{0,212001,1}]','[{180,220,100}]'),(2,1,'[{0,212001,1}]','[{180,220,100}]'),(3,0,'[{0,212001,1}]','[{70,90,100}]'),(3,1,'[{0,212001,1}]','[{70,90,100}]'),(4,0,'[{0,212001,1}]','[{40,60,100}]'),(4,1,'[{0,212001,1}]','[{40,60,100}]'),(5,0,'[{0,212001,1}]','[{15,25,100}]'),(5,1,'[{0,212001,1}]','[{15,25,100}]');
/*!40000 ALTER TABLE `base_partner_promote` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_partner_recruit`
--

DROP TABLE IF EXISTS `base_partner_recruit`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_partner_recruit` (
  `recruit_type` tinyint(2) unsigned NOT NULL DEFAULT '1' COMMENT '招募类型',
  `free_cd` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '免费cd',
  `goods` varchar(256) NOT NULL COMMENT '奖励',
  `single_recruit` varchar(256) NOT NULL COMMENT '消耗',
  `ten_recruit` varchar(256) NOT NULL COMMENT '消耗',
  `pr` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '概率',
  `guaran_num` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '保底次数',
  `guaran_quality` varchar(128) NOT NULL COMMENT '保底品质',
  PRIMARY KEY (`recruit_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='招募配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_partner_recruit`
--

LOCK TABLES `base_partner_recruit` WRITE;
/*!40000 ALTER TABLE `base_partner_recruit` DISABLE KEYS */;
INSERT INTO `base_partner_recruit` VALUES (1,28800,'[{0,212202,1}]','[{3,0,30000}]','[{3,0,270000}]',1000,10,'[3]'),(2,172800,'[{0,212101,1}]','[{1,0,240}]','[{1,0,1980}]',1000,10,'[4,5]');
/*!40000 ALTER TABLE `base_partner_recruit` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_partner_sk`
--

DROP TABLE IF EXISTS `base_partner_sk`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_partner_sk` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品id',
  `skill_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能id',
  `color` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '品质',
  `power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能战力',
  `weight` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能权重',
  `career` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '五行',
  `sk_desc` varchar(512) NOT NULL COMMENT '技能描述@lang@',
  PRIMARY KEY (`id`),
  KEY `skill_id` (`skill_id`),
  KEY `color` (`color`),
  KEY `career` (`career`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='技能书配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_partner_sk`
--

LOCK TABLES `base_partner_sk` WRITE;
/*!40000 ALTER TABLE `base_partner_sk` DISABLE KEYS */;
INSERT INTO `base_partner_sk` VALUES (213001,2300001,2,120,50,6,'【被动】提升伙伴光抗'),(213002,2300002,3,400,50,6,'【被动】提升伙伴光抗'),(213003,2300003,4,1250,50,6,'【被动】提升伙伴光抗'),(213004,2300004,2,120,50,6,'【被动】提升伙伴暗抗'),(213005,2300005,3,400,50,6,'【被动】提升伙伴暗抗'),(213006,2300006,4,1250,50,6,'【被动】提升伙伴暗抗'),(213007,2300007,2,120,50,6,'【被动】提升伙伴水抗'),(213008,2300008,3,400,50,6,'【被动】提升伙伴水抗'),(213009,2300009,4,1250,50,6,'【被动】提升伙伴水抗'),(213010,2300010,2,120,50,6,'【被动】提升伙伴火抗'),(213011,2300011,3,400,50,6,'【被动】提升伙伴火抗'),(213012,2300012,4,1250,50,6,'【被动】提升伙伴火抗'),(213013,2300013,2,120,50,6,'【被动】提升伙伴风抗'),(213014,2300014,3,400,50,6,'【被动】提升伙伴风抗'),(213015,2300015,4,1250,50,6,'【被动】提升伙伴风抗'),(213016,2300016,3,400,50,6,'【被动】提升伙伴全抗'),(213017,2300017,4,1250,50,6,'【被动】提升伙伴全抗'),(213018,2300018,5,3750,50,6,'【被动】提升伙伴全抗'),(213019,2300019,2,120,50,6,'【被动】提升伙伴攻击'),(213020,2300020,3,400,50,6,'【被动】提升伙伴攻击'),(213021,2300021,4,1250,50,6,'【被动】提升伙伴攻击'),(213022,2300022,3,400,50,6,'【被动】提升伙伴攻击速度'),(213023,2300023,4,1250,50,6,'【被动】提升伙伴攻击速度'),(213024,2300024,5,3750,50,6,'【被动】提升伙伴攻击速度'),(213025,2300025,2,120,50,6,'【被动】提升伙伴抗属性效果'),(213026,2300026,3,400,50,6,'【被动】提升伙伴抗属性效果'),(213027,2300027,4,1250,50,6,'【被动】提升伙伴抗属性效果'),(213028,2300028,3,400,50,6,'【被动】提升伙伴忽略全抗'),(213029,2300029,4,1250,50,6,'【被动】提升伙伴忽略全抗'),(213030,2300030,5,3750,50,6,'【被动】提升伙伴忽略全抗'),(213031,2300031,3,400,50,6,'【被动】提升伙伴吸取生命'),(213032,2300032,4,1250,50,6,'【被动】提升伙伴吸取生命'),(213033,2300033,5,3750,50,6,'【被动】提升伙伴吸取生命'),(213034,2300034,1,40,50,6,'【被动】提升伙伴闪避'),(213035,2300035,2,120,50,6,'【被动】提升伙伴闪避'),(213036,2300036,3,400,50,6,'【被动】提升伙伴闪避'),(213037,2300037,1,40,50,6,'【被动】提升伙伴忽略闪避'),(213038,2300038,2,120,50,6,'【被动】提升伙伴忽略闪避'),(213039,2300039,3,400,50,6,'【被动】提升伙伴忽略闪避'),(213040,2300040,1,40,50,6,'【被动】提升伙伴生命回复效果'),(213041,2300041,2,120,50,6,'【被动】提升伙伴生命回复效果'),(213042,2300042,3,400,50,6,'【被动】提升伙伴生命回复效果'),(213043,2300043,2,120,50,6,'【被动】提升伙伴生命'),(213044,2300044,3,400,50,6,'【被动】提升伙伴生命'),(213045,2300045,4,1250,50,6,'【被动】提升伙伴生命'),(213046,2300046,1,40,50,6,'【被动】提升伙伴命中'),(213047,2300047,2,120,50,6,'【被动】提升伙伴命中'),(213048,2300048,3,400,50,6,'【被动】提升伙伴命中'),(213049,2300049,2,120,50,6,'【被动】提升伙伴会心几率'),(213050,2300050,3,400,50,6,'【被动】提升伙伴会心几率'),(213051,2300051,4,1250,50,6,'【被动】提升伙伴会心几率'),(213052,2300052,1,40,50,6,'【被动】提升伙伴抗会心几率'),(213053,2300053,2,120,50,6,'【被动】提升伙伴抗会心几率'),(213054,2300054,3,400,50,6,'【被动】提升伙伴抗会心几率');
/*!40000 ALTER TABLE `base_partner_sk` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_partner_upgrade`
--

DROP TABLE IF EXISTS `base_partner_upgrade`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_partner_upgrade` (
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `max_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大经验',
  `percentage` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '百分比',
  PRIMARY KEY (`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='升级配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_partner_upgrade`
--

LOCK TABLES `base_partner_upgrade` WRITE;
/*!40000 ALTER TABLE `base_partner_upgrade` DISABLE KEYS */;
INSERT INTO `base_partner_upgrade` VALUES (1,2500,25),(2,5000,25),(3,7500,25),(4,10000,25),(5,12500,25),(6,15000,25),(7,17500,25),(8,20000,25),(9,22500,25),(10,25000,25),(11,27500,25),(12,30000,25),(13,32500,25),(14,35000,25),(15,37500,25),(16,40000,25),(17,42500,25),(18,45000,25),(19,47500,25),(20,100000,25),(21,120000,25),(22,140000,25),(23,160000,25),(24,180000,25),(25,200000,25),(26,225000,25),(27,250000,25),(28,275000,25),(29,300000,25),(30,580000,25),(31,600000,20),(32,700000,20),(33,800000,20),(34,900000,20),(35,1000000,20),(36,1100000,20),(37,1200000,20),(38,1300000,20),(39,1400000,20),(40,2000000,20),(41,2090000,19),(42,2280000,19),(43,2470000,19),(44,2660000,19),(45,2850000,19),(46,3040000,19),(47,3230000,19),(48,3420000,19),(49,3610000,19),(50,4560000,19),(51,4680000,18),(52,5040000,18),(53,5400000,18),(54,5760000,18),(55,6120000,18),(56,6480000,18),(57,6840000,18),(58,7200000,18),(59,7560000,18),(60,8640000,18),(61,8670000,17),(62,9180000,17),(63,9690000,17),(64,10200000,17),(65,10710000,17),(66,11220000,17),(67,11730000,17),(68,12240000,17),(69,12750000,17),(70,13000000,17),(71,13360000,16),(72,13920000,16),(73,14480000,16),(74,15040000,16),(75,15600000,16),(76,16160000,16),(77,16720000,16),(78,17280000,16),(79,17840000,16),(80,19000000,16),(81,21000000,15),(82,21750000,15),(83,22500000,15),(84,23250000,15),(85,24000000,15),(86,24750000,15),(87,25500000,15),(88,26250000,15),(89,27000000,15),(90,29000000,15),(91,30520000,14),(92,31640000,14),(93,32760000,14),(94,33880000,14),(95,35000000,14),(96,36120000,14),(97,37240000,14),(98,38360000,14),(99,39480000,14),(100,40500000,14),(101,41990000,13),(102,43030000,13),(103,44070000,13),(104,45110000,13),(105,46150000,13),(106,47190000,13),(107,48230000,13),(108,49270000,13),(109,50310000,13),(110,50800000,13),(111,51600000,12),(112,52800000,12),(113,54000000,12),(114,55200000,12),(115,56400000,12),(116,57600000,12),(117,58800000,12),(118,60000000,12),(119,61200000,12),(120,62000000,12),(121,62920000,11),(122,64240000,11),(123,65560000,11),(124,66880000,11),(125,68200000,11),(126,69520000,11),(127,70840000,11),(128,72160000,11),(129,72600000,11),(130,73000000,11),(131,73400000,10),(132,74000000,10),(133,75500000,10),(134,77000000,10),(135,78500000,10),(136,80000000,10),(137,81500000,10),(138,83000000,10),(139,84500000,10),(140,90000000,10),(141,92250000,9),(142,94500000,9),(143,96750000,9),(144,99000000,9),(145,101250000,9),(146,103500000,9),(147,105750000,9),(148,108000000,9),(149,110250000,9);
/*!40000 ALTER TABLE `base_partner_upgrade` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_partner_wash`
--

DROP TABLE IF EXISTS `base_partner_wash`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_partner_wash` (
  `quality` tinyint(2) unsigned NOT NULL DEFAULT '1' COMMENT '品质',
  `goods` varchar(256) NOT NULL COMMENT '消耗',
  `wash_attr` varchar(256) NOT NULL COMMENT '属性品质',
  `random_attr` varchar(256) NOT NULL COMMENT '属性加成',
  `comm_skill` varchar(256) NOT NULL COMMENT '技能数量',
  `sk_quality` varchar(256) NOT NULL COMMENT '技能品质',
  `prodigy` varchar(512) NOT NULL COMMENT '奇才',
  PRIMARY KEY (`quality`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='洗髓配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_partner_wash`
--

LOCK TABLES `base_partner_wash` WRITE;
/*!40000 ALTER TABLE `base_partner_wash` DISABLE KEYS */;
INSERT INTO `base_partner_wash` VALUES (1,'[{0,212101,1}]','[{1,100},{2,300},{3,300},{4,200},{5,100}]','[{30,600,700},{50,700,800},{18,800,900},{2,900,1050}]','[{0,50},{1,40},{2,10}]','[{1,100}]','[{1,50,50},{50,200,300}]'),(2,'[{0,212101,2}]','[{1,100},{2,300},{3,300},{4,200},{5,100}]','[{30,600,700},{50,700,800},{18,800,900},{2,900,1050}]','[{0,40},{1,30},{2,20},{3,10}]','[{1,75},{2,25}]','[{1,100,50},{100,500,300}]'),(3,'[{0,212101,4}]','[{1,100},{2,300},{3,300},{4,200},{5,100}]','[{30,600,700},{50,700,800},{18,800,900},{2,900,1050}]','[{0,20},{1,40},{2,20},{3,15},{4,5}]','[{1,60},{2,25},{3,15}]','[{1,250,80},{250,3000,400}]'),(4,'[{0,212101,12}]','[{1,50},{2,100},{3,300},{4,350},{5,200}]','[{10,400,500},{40,500,700},{38,700,800},{10,800,900},{2,900,1050}]','[{1,10},{2,20},{3,50},{4,15},{5,5}]','[{1,20},{2,35},{3,25},{4,20}]','[{1,1500,150},{1500,30000,400}]'),(5,'[{0,212101,48}]','[{1,50},{2,100},{3,300},{4,350},{5,200}]','[{30,500,700},{35,700,800},{30,800,900},{5,900,1050}]','[{2,10},{3,50},{4,30},{5,10}]','[{1,5},{2,30},{3,35},{4,20},{5,10}]','[{1,3000,200},{3000,30000,600}]');
/*!40000 ALTER TABLE `base_partner_wash` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_partner_weapon`
--

DROP TABLE IF EXISTS `base_partner_weapon`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_partner_weapon` (
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品id',
  `partner_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '伙伴id',
  `weapon_l` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '左手武器资源id',
  `weapon_r` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '右手武器资源id',
  `attr` varchar(512) NOT NULL COMMENT '属性',
  `combat_power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战力',
  PRIMARY KEY (`goods_id`),
  KEY `partner_id` (`partner_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='专属配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_partner_weapon`
--

LOCK TABLES `base_partner_weapon` WRITE;
/*!40000 ALTER TABLE `base_partner_weapon` DISABLE KEYS */;
INSERT INTO `base_partner_weapon` VALUES (213101,503,0,2020520300,'[{2,100}]',1000),(213102,402,0,2020200300,'[{2,100}]',1000),(213103,401,0,2020300200,'[{2,100}]',1000),(213104,413,0,2020401600,'[{2,100}]',1000);
/*!40000 ALTER TABLE `base_partner_weapon` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_pic`
--

DROP TABLE IF EXISTS `base_pic`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_pic` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '图鉴id',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '图鉴类型',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '名称',
  `quality` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '品质',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '初始等级',
  `career` int(11) NOT NULL DEFAULT '0' COMMENT '职业',
  `open_con` varchar(255) NOT NULL DEFAULT '[]' COMMENT '前置条件',
  `open_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开启等级',
  `resource_id` varchar(50) NOT NULL DEFAULT '' COMMENT '资源id',
  `description` varchar(255) NOT NULL DEFAULT '' COMMENT '描述说明',
  `get_way` varchar(255) NOT NULL DEFAULT '[]' COMMENT '获取方法',
  `way_show` varchar(255) NOT NULL COMMENT '获取描述（客户端）',
  `photo_id` varchar(50) NOT NULL DEFAULT '0' COMMENT '图片资源id',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='图鉴配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_pic`
--

LOCK TABLES `base_pic` WRITE;
/*!40000 ALTER TABLE `base_pic` DISABLE KEYS */;
INSERT INTO `base_pic` VALUES (90010,1,'藏宝蟹',0,1,0,'[]',50,'202031','藏宝蟹，因其寄居在宝箱中而得名，捕猎这种螃蟹的人们可不是为了果腹，而是为了宝箱中可能残存的金银珠宝。','[{132,0,1}]','','tj_90010'),(90020,1,'魔化藏宝蟹',0,1,0,'[]',50,'202032','魔化藏宝蟹，受到暗裔之源侵蚀影响而魔化的藏宝蟹，宝箱中不再有价值连城的珠宝，反而藏匿着暗裔之源的污秽。','[{132,0,1}]','','tj_90020'),(90030,1,'树桩怪',0,1,0,'[]',50,'202033','树桩怪，森林被大规模砍伐后开始出现的树人型怪物，比较多地出现在繁华城镇的郊外，因为这些地方，对森林的破坏最为严重。','[{132,0,1}]','','tj_90030'),(90040,1,'火鸡骑士',0,1,0,'[]',50,'202034','火鸡骑士，本质上是一些原始部落的兽人，他们通过驯服笨拙胆小的火鸡来充当坐骑，值得一提的是，抵抗军通过择优培育，繁殖了第一只具有蓝色羽毛的火鸡！','[{132,0,1}]','','tj_90040'),(90050,1,'强盗',0,1,0,'[]',50,'202011','强盗，无论什么世界观，什么背景，什么作品当中都会出现的人物，嘛，反正往死里打就对了~','[{132,0,1}]','','tj_90050'),(90060,1,'叛变佣兵',0,1,0,'[]',200,'202012','叛变佣兵，一群连口粮都无法保证的可怜家伙，不得已只能背弃道德观念或是信仰，成为如同强盗一般的亡命之徒。','[{132,0,1}]','','tj_90060'),(90070,1,'魔化傀儡',0,1,0,'[]',200,'202015','魔化傀儡，被暗裔之源侵蚀后成为了有一定思维的机械生命，为了达成暗裔一族侵蚀大陆的意志而行动着。','[{132,0,1}]','','tj_90070'),(90080,1,'魔化楔形虫',0,1,0,'[]',200,'202013','魔化楔形虫，被暗裔之源影响后的虫类，其硕大的钳子能够瞬间将猎物撕成两半！','[{132,0,1}]','','tj_90080'),(90090,1,'魔化机兵',0,1,0,'[]',200,'202018','魔化机兵，帝国军采用水晶作为动力源而研制的机动士兵，是魔法与机械融合的产物，配备有专门的屠杀武器。','[{132,0,1}]','','tj_90090'),(90100,1,'魔化难民',0,1,0,'[]',200,'202017','魔化难民，帝国军在进行暗裔研究时，人道主义毁灭的牺牲品，这些平民和士兵沦为了暗裔意志的行尸走肉。','[{132,0,1}]','','tj_90100'),(90110,1,'暗影狼',0,1,0,'[]',300,'202006','暗影狼，栖息在苏米尔境内的野兽，喜欢群居狩猎，有资料称其当地居民有驯养暗影狼的历史，其唾液中含有微量毒素。','[{132,0,1}]','','tj_90110'),(90120,1,'骷髅兵',0,1,0,'[]',300,'202002','骷髅兵，昔日战败的士兵，成为了亡灵，他们忘记了生前为何而战，死后也不曾得到解脱。','[{132,0,1}]','','tj_90120'),(90130,1,'史莱姆',0,1,0,'[]',300,'202003','史莱姆，幻想作品中都会出现的类似吉祥物的生物，这个世界观下的史莱姆具有热变形的特点，还十分怕热~','[{132,0,1}]','','tj_90130'),(90140,1,'哥布林',0,1,0,'[]',300,'202005','哥布林，丑陋、矮小、绿皮，这是人们对于哥布林的固有印象，很遗憾，我们的哥布林也是如此~','[{132,0,1}]','','tj_90140'),(90150,1,'沼泽妖精',0,1,0,'[]',300,'202008','沼泽妖精，栖息在迷雾沼泽的特殊妖精，没有可爱的外形，芬芳的体香，所以你们可以停止那些龌龊的幻想了~','[{132,0,1}]','','tj_90150'),(90160,1,'蜥蜴人',0,1,0,'[]',400,'202014','蜥蜴人，主要栖息在苏米尔的森林境内，还有少部分会在萨维吉地区的荒漠中出现，是一种具有低等智慧的人形生物。','[{132,0,1}]','','tj_90160'),(90170,1,'吞噬花',1,1,0,'[]',400,'202001','吞噬花，同样是苏米尔森林境内的特有生物，它们会通过长相可爱的根茎来迷惑旅行者，待其放松警惕就将其吞噬。','[{132,0,1}]','','tj_90170'),(90190,1,'精灵侍卫',1,1,0,'[]',400,'202004','精灵侍卫，精灵部族当中训练有素的战士，族长会亲自挑选通过成年礼的精灵男子，作为女王和神殿区域的侍卫。','[{132,0,1}]','','tj_90190'),(90200,1,'岩龟',1,1,0,'[]',400,'202007','岩龟，因其背部的坚硬外壳和酷似岩石纹路的皮肤而得名，不过据说其肉质鲜美，当地居民也有专门养殖的习惯。','[{132,0,1}]','','tj_90200'),(90210,1,'雪原企鹅',1,1,0,'[]',500,'202009','雪原企鹅，目前只有在萨维吉的寒鸦峡谷地区有栖息痕迹，喜爱的食物是冰鱼。','[{132,0,1}]','','tj_90210'),(90220,1,'雪岩怪',1,1,0,'[]',500,'202010','雪岩怪，冰晶状的人形生物，目前只在寒鸦峡谷中出没，攻击欲望和好奇心旺盛，弱点是高温和冰激凌制造商。','[{132,0,1}]','','tj_90220'),(90230,1,'机械犬',1,1,0,'[]',500,'202016','机械犬，帝国军根据地狱三头犬的神话形象而设计的杀戮机械，三个头部可以协同配合进行侦查，撕咬，追踪等功能。','[{132,0,1}]','','tj_90230'),(90240,1,'恶魔幼体',1,1,0,'[]',500,'202019','恶魔幼体，帝国军的专家们将暗裔之源注入人类胚胎后诞生的产物，是一种不断觅食，不知恐惧的可怕恶魔。','[{132,0,1}]','','tj_90240'),(90250,1,'鱼人守卫',1,1,0,'[]',500,'202020','鱼人守卫，亚特兰蒂斯海域的海拉族人，守卫一般由精壮的海拉男性担任。','[{132,0,1}]','','tj_90250'),(90260,1,'鱼人刺客',1,1,0,'[]',600,'202021','鱼人刺客，亚特兰蒂斯海域的海拉族人，刺客一般由行动迅捷的海拉女性担任。','[{132,0,1}]','','tj_90260'),(90270,1,'巨齿鲨',1,1,0,'[]',600,'202023','巨齿鲨，栖息在失落之海的人形鲨鱼，具备中等智慧，能够制造粗略的冷兵器，即便如此，冷酷的杀戮天性依旧嗜血如命。','[{132,0,1}]','','tj_90270'),(90280,1,'海蜥蜴',1,1,0,'[]',600,'202024','海蜥蜴，适应了海底生活的海蜥蜴，具备更为灵敏的嗅觉和视觉，它们通常群体捕猎，用爪子撕碎目标。','[{132,0,1}]','','tj_90280'),(90290,1,'半人马',1,1,0,'[]',600,'203002','半人马，被誉为神殿的守护者，森林部族当中被看做是神圣强大的存在，擅长使用各式武器，擅长武斗。','[{132,0,1}]','','tj_90290'),(90300,1,'荆棘之花',1,1,0,'[]',600,'203001','荆棘之花，暗裔恶魔之一，此前有许多男性被其诱惑的低语吸引，随后便被其巨大的花朵吞噬，吸食生命至死。','[{132,0,1}]','','tj_90300'),(90310,1,'冰霜泰坦',1,1,0,'[]',700,'203003','冰霜泰坦，上古时期的巨型生物，曾与冰霜巨龙进行大战，战后各自都陷入了沉睡，而战场废墟成为了现在寒鸦峡谷。','[{132,0,1}]','','tj_90310'),(90320,1,'冰霜巨龙',1,1,0,'[]',700,'203004','冰霜巨龙，上古龙族，与泰坦一战使其沉睡至今，不过龙族本身的魔法天赋和战斗能力丝毫未减。','[{132,0,1}]','','tj_90320'),(90330,1,'阿努比斯',1,1,0,'[]',700,'203005','阿努比斯，法老王朝中掌司生与死的神明，不过即便如此，神明也无法阻止末代法老的疯狂行径，王朝也至此覆灭。','[{132,0,1}]','','tj_90330'),(90340,1,'美杜莎',1,1,0,'[]',700,'203006','美杜莎，蛇发女妖，据说是末代法老的妻子，也有说法是末代法老为了追求永生而献祭了他的妻子，然而法老没有得到永生，妻子则变为了蛇发女妖。','[{132,0,1}]','','tj_90340'),(90350,1,'恶魔骑士',2,1,0,'[]',50,'203007','恶魔骑士，据说在自愿成为暗裔附身的实验品之前，是帝国军的一名近卫骑士，这位骑士深爱着一名少女，而那位少女，本应才是实验品。','[{132,0,1}]','','tj_90350'),(90360,1,'质量检测员',2,1,0,'[]',50,'203008','质量检测员，型号CSN-97，帝国军暗裔秘所当中充当流水线质检员的大型机器人，配备了重型武器和大量防御装甲。','[{132,0,1}]','','tj_90360'),(90370,1,'海龙王',2,1,0,'[]',50,'203009','海龙王，上古龙族，亚特兰蒂斯的破坏神，海神波塞冬曾将其制服并且封印。','[{132,0,1}]','','tj_90370'),(90380,1,'暗裔猎手',2,1,0,'[]',200,'203010','暗裔猎手，强大的暗裔恶魔，冷酷嗜血的个性在面对同类时也毫不手软，它是暗裔意志的执行者，也是对失败同类的审判者。','[{132,0,1}]','','tj_90380'),(90390,1,'蜘蛛女皇',2,1,0,'[]',200,'203011','蜘蛛女皇，暗裔恶魔之一，具有筑巢繁殖的习性，身上的毛刺以及分泌的毒液含有致命剧毒，极度危险的暗裔。','[{132,0,1}]','','tj_90390'),(90400,1,'愤怒',2,1,0,'[]',200,'203012','愤怒，在帝国军专家们夜以继日的研究下，寄宿人类情感的实体恶魔诞生，愤怒是最初也是最危险的一个。','[{132,0,1}]','','tj_90400'),(90410,1,'怠惰',3,1,0,'[]',400,'203013','怠惰，寄宿着人类怠惰情感的实体恶魔，看似行动迟缓，实际上只是它懒得动而已。','[{132,0,1}]','','tj_90410'),(90420,1,'嫉妒',3,1,0,'[]',400,'203014','嫉妒，寄宿着人类嫉妒情感的实体恶魔，外形是一条可怖的大蛇，它能够吞噬周遭的一切生物，将其转化为自身的根源。','[{132,0,1}]','','tj_90420'),(90430,1,'暴食',3,1,0,'[]',400,'203015','暴食，寄宿着人类暴食欲望的实体恶魔，终日不知饱腹感地吞噬周遭的一切生灵和情感。','[{132,0,1}]','','tj_90430'),(90440,1,'色欲',3,1,0,'[]',500,'203016','色欲，寄宿着人类色欲的实体恶魔，时常化身为性感的女子，勾引各路男性，据说她本身是抖S属性，受害者常常是满怀着喜悦的表情死去。','[{132,0,1}]','','tj_90440'),(90450,1,'死神',3,1,0,'[]',500,'203018','死神，吞噬生物生命力的暗裔恶魔，死神是其邪教徒对它的称呼，它所到之处，满目疮痍，生灵涂炭。','[{132,0,1}]','','tj_90450'),(90460,1,'迦楼罗',3,1,0,'[]',500,'203020','迦楼罗，掌管大气与风元素的神明，可以操控天气，刮起龙卷风，并且在天空中的速度，无人比拟。','[{132,0,1}]','','tj_90460'),(90470,1,'八岐大蛇',4,1,0,'[]',700,'203024','八岐大蛇，吉煌之国中的传奇妖怪，在其作乱期间，被下凡的须佐之男斩掉所有头颅，随后在封印期间受到暗裔之源的影响而复活。','[{132,0,1}]','','tj_90470'),(90480,1,'熔岩战神',4,1,0,'[]',700,'203025','熔岩战神，栖息在焚烬火山领域的首领，是火山的守护神；据说它挥舞手中的重锤，就能引发一次火山爆发。','[{132,0,1}]','','tj_90480'),(90490,1,'巴哈姆特',4,1,0,'[]',700,'203026','巴哈姆特，上古龙神，龙族的唯一神和祖先，具备强大的武力和极高的魔法天赋。现世流传的魔法都是巴哈姆特所创造的微缩版。','[{132,0,1}]','','tj_90490'),(90500,2,'月神',1,1,0,'[{other,{god,1003}}]',50,'203022','月神，哈索尔，星界和星灵的守护神，性格温和亲切，星灵们称其为“温暖的大哥哥”；被光辉神视为宿敌。','[{440,1,1}]','','tj_90500'),(90510,2,'冰雪女王',2,1,0,'[{other,{god,1002}}]',50,'203017','冰雪女王，亦称冰神，星灵的守护神，拥有掌控冰雪元素的力量和疑似青春永驻的力量……','[{440,1,1}]','','tj_90510'),(90520,2,'光辉神',3,1,0,'[{other,{god,1001}}]',50,'203021','光辉神，赫利俄斯，星界和星灵的守护神，性格暴躁高傲，星灵们称其为“傲娇的暴躁老哥”；他本人十分讨厌这个外号。','[{440,1,1}]','','tj_90520'),(90530,2,'波塞冬',3,1,0,'[{other,{god,1004}}]',50,'601003','波塞冬，亚特兰蒂斯的君主与海神，星灵的守护神，如同大海一般，他本身也具备强大的包容力和远大的志向。','[{440,1,1}]','','tj_90530'),(90540,2,'雅典娜',4,1,0,'[{other,{god,1005}}]',50,'601001','雅典娜，英气的女武神，星界的守护神，每当星界领域受到侵犯时，她总是第一个察觉并且出战前线。','[{440,1,1}]','','tj_90540'),(90550,3,'月牙天冲',1,1,0,'[{other,{god_pyx,11030001}}]',50,'203022','月牙天冲，月神的武器，闪耀的月光虽然柔和，但是同样致命。','[{440,2,1}]','','tj_90550'),(90560,3,'霜之哀伤',2,1,0,'[{other,{god_pyx,11030002}}]',50,'203017','霜之哀伤，冰雪女王的武器，只要轻轻一挥，目标就能化为冰雕艺术品。','[{440,2,1}]','','tj_90560'),(90570,3,'太阳权杖',3,1,0,'[{other,{god_pyx,11030003}}]',50,'203021','太阳权杖，光辉神的武器，触之必焚，焚烧成烬，最终灰飞烟灭。','[{440,2,1}]','','tj_90570'),(90580,3,'海神之戟',3,1,0,'[{other,{god_pyx,11030004}}]',50,'601003','海神之戟，海神波塞冬的武器，挥舞神戟，翻江倒海，大陆湮灭也只是一念之间。','[{440,2,1}]','','tj_90580'),(90590,3,'荣耀之枪',4,1,0,'[{other,{god_pyx,11030005}}]',50,'601001','荣耀之枪，这把枪自从被铸造后就随雅典娜出征至今，未尝败绩。','[{440,2,1}]','','tj_90590'),(90600,3,'星象仪',1,1,0,'[{other,{talisman,0}}]',90,'607001','星象仪，人类为了窥探星空的奥秘，以自身的星球为中心，设置了这个观察星象的仪器。','[{168,3,1}]','','tj_90600'),(90610,3,'龙魂宝珠',1,1,0,'[{other,{talisman,1}}]',90,'607002','龙魂宝珠，死灵巫师们通过炼制死去的龙族灵魂而得到的宝物，市面上赝品居多，请多加甄别。','[{168,3,1}]','','tj_90610'),(90620,3,'失落魔方',2,1,0,'[{other,{talisman,2}}]',90,'607003','失落魔方，在失落之海打捞上来的众多宝物之一，至今也没有人能解开魔方的奥秘。','[{168,3,1}]','','tj_90620'),(90630,3,'古神典籍',2,1,0,'[{other,{talisman,3}}]',90,'607006','古神典籍，在肃清一些邪教徒组织时，其成员手中经常会拿着这类典籍，里面记载着召唤外域邪神的咒语和仪式。','[{168,3,1}]','','tj_90630'),(90640,3,'海洋之心',2,1,0,'[{other,{talisman,4}}]',90,'607007','海洋之心，湛蓝色宝石，如同大海一样的颜色，常年位居女性被求婚时最想得到的首饰第一位。','[{168,3,1}]','','tj_90640'),(90650,3,'圣赎十字',3,1,0,'[{other,{talisman,5}}]',90,'609011','圣赎十字，虔诚的圣教徒哟~不要忘记真祖的献身与教诲！','[{168,3,1}]','','tj_90650'),(90660,3,'航海宝珠',3,1,0,'[{other,{talisman,6}}]',90,'609012','航海宝珠，据说这也是海神波塞冬的宝物之一，持有它时，船只能够自动航行而不会触碰暗礁。','[{168,3,1}]','','tj_90660'),(90670,3,'善恶天秤',4,1,0,'[{other,{talisman,7}}]',90,'609014','善恶天秤，神造物之一，神明曾想过测量人类的善恶到底哪一个更重，结果这个天秤后来就被贩卖了。','[{168,3,1}]','','tj_90670'),(90680,2,'萌羊座',2,1,0,'[{other,{star_soul,1001}}]',50,'501002','萌羊座，见习星灵，是下一任白羊座的候补，据说只有白羊座才有世代继承的概念。','[{430,3,1}]','','tj_90680'),(90690,2,'熊霸霸',2,1,0,'[{other,{star_soul,2001}}]',50,'202028','熊霸霸，雄霸天下！！','[{430,3,1}]','','tj_90690'),(90700,2,'难大师',2,1,0,'[{other,{star_soul,2002}}]',50,'202003','难大师，难，亦我所欲也；易，亦我所欲也；两者不可得兼。','[{430,3,1}]','','tj_90700'),(90710,2,'代号09',2,1,0,'[{other,{star_soul,2003}}]',50,'202015','代号09，就是代号09呗！','[{430,3,1}]','','tj_90710'),(90720,2,'修罗虎',2,1,0,'[{other,{star_soul,2004}}]',50,'202029','修罗虎，野兽具备人性就很可怕了，这还是个佛系的野兽~','[{430,3,1}]','','tj_90720'),(90730,2,'暗影忍者',2,1,0,'[{other,{star_soul,2005}}]',50,'202027','暗影忍者，潜伏于暗影行动，暗杀，深得黑夜的眷顾。','[{430,3,1}]','','tj_90730'),(90740,2,'白羊座',3,1,0,'[{other,{star_soul,1002}}]',50,'501003','白羊座，黄道十二宫星灵之一，坚强而温柔的少女，喜爱毛绒绒的服饰，意外地力气很大。','[{430,3,1}]','','tj_90740'),(90750,2,'金牛座',3,1,0,'[{other,{star_soul,1003}}]',50,'501004','金牛座，黄道十二宫星灵之一，脾气暴躁的倔强大姐头，遇上犯蠢的星灵时会毫不留情的进行训斥，做事大大咧咧。','[{430,3,1}]','','tj_90750'),(90760,2,'双子座',3,1,0,'[{other,{star_soul,1004}}]',50,'501005','双子座，黄道十二宫星灵之一，双重人格的星灵，表人格是乐观的性格，里人格是阴郁的性格，大多数时间是乐观的表人格占据主导，在遭遇重大事变时里人格才会出现。','[{430,3,1}]','','tj_90760'),(90770,2,'巨蟹座',3,1,0,'[{other,{star_soul,1005}}]',50,'501006','巨蟹座，黄道十二宫星灵之一，邻家大姐姐，散发母性光辉的星灵，十分疼爱其他姐妹星灵，性格再恶劣的星灵都会被她的包容和微笑所治愈。','[{430,3,1}]','','tj_90770'),(90780,2,'狮子座',3,1,0,'[{other,{star_soul,1006}}]',50,'501007','狮子座，黄道十二宫星灵之一，英俊潇洒的少女，具备男子汉气概的性格和气度，视保护其他姐妹星灵为己任。','[{430,3,1}]','','tj_90780'),(90790,2,'处女座',3,1,0,'[{other,{star_soul,1007}}]',50,'501008','处女座，黄道十二宫星灵之一，纯真的萝莉星灵，星灵姐妹中年龄最小的一位，受姐姐们的关爱有加，但她内心其实更加渴望能够成长为独当一面的星灵。','[{430,3,1}]','','tj_90790'),(90800,2,'暴怒之火',1,1,0,'[{other,{spirit,1}}]',50,'608001','暴怒之火，火属性圣灵，掌控燃烧之力，性情暴躁。','[{428,1,1}]','','tj_90800'),(90810,2,'温润之水',1,1,0,'[{other,{spirit,2}}]',50,'608002','温润之水，水属性圣灵，掌控水元素之力，性情温婉。','[{428,1,1}]','','tj_90810'),(90820,2,'摄魂行者',2,1,0,'[{other,{spirit,3}}]',50,'608003','摄魂行者，魂属性圣灵，可摄取生物灵魂，性格怪异。','[{428,1,1}]','','tj_90820'),(90830,3,'光明号角',1,1,0,'[{other,{pyx,1}}]',50,'609005','光明号角，俗话说有光明的地方自然就有黑暗，那么我的黑暗号角呢？','[{428,1,1}]','','tj_90830'),(90840,3,'祷告之书',2,1,0,'[{other,{pyx,2}}]',50,'609010','祷告之书，虔诚的教徒在朝圣时朗诵着殉道者的祷告。','[{428,1,1}]','','tj_90840'),(90850,3,'起源之火',2,1,0,'[{other,{pyx,3}}]',50,'609008','起源之火，混沌未分之际，某位不愿意透露姓名的创世神点燃了一团生命之火，随后留下功与名。','[{428,1,1}]','','tj_90850'),(90860,3,'霜语皇冠',1,1,0,'[{other,{pyx,5}}]',50,'609009','霜语皇冠，这顶皇冠由不会消融的冰晶铸造而成，戴过这顶皇冠的各位王爵，全部都患有偏头痛。','[{428,1,1}]','','tj_90860'),(90870,3,'镇魂十字',2,1,0,'[{other,{pyx,6}}]',50,'609013','镇魂十字，“生前无法被救赎的灵魂啊~如今汝等可以安息，不必留恋尘世间的一切~”出自《镇魂曲》救赎之篇','[{428,1,1}]','','tj_90870'),(90880,3,'起源之水',2,1,0,'[{other,{pyx,7}}]',50,'609015','起源之水，万物未觉之时，某位不愿意透露姓名的创世神倾泻了一汪生命之水，随后留下功与名。','[{428,1,1}]','','tj_90880'),(90890,3,'恶魔契约',1,1,0,'[{other,{pyx,9}}]',50,'609006','恶魔契约，“那么，代价是什么呢？”','[{428,1,1}]','','tj_90890'),(90900,3,'死亡圣杯',2,1,0,'[{other,{pyx,10}}]',50,'609007','死亡圣杯，将圣杯中注满鲜血，刻下符文和咒印，到头来这样的不祥之物能够回应怎样的愿望？','[{428,1,1}]','','tj_90900'),(90910,3,'冥府之钥',3,1,0,'[{other,{pyx,11}}]',50,'609016','冥府之钥，生者想要召回死者的亡魂，然后人死不能复生，打开大门的同时，自己也身处在冥府。','[{428,1,1}]','','tj_90910'),(90920,3,'暗裔之翼',2,1,1,'[{other,{twing,20010011}}]',50,'401001','暗裔之翼，寄宿着暗裔之源的羽翼，邪魅，灾厄的代名词。','[{161,1,1}]','','tj_90920'),(90930,3,'光明之翼',2,1,2,'[{other,{twing,20010021}}]',50,'402001','光明之翼，闪耀着光芒的羽翼，希望，正义的象征。','[{161,1,1}]','','tj_90930'),(90940,3,'零之使翼',2,1,4,'[{other,{twing,20010041}}]',50,'404001','零之使翼，帝国军制造，科技水平的顶尖表现。','[{161,1,1}]','','tj_90940'),(90950,3,'暗影魔翼',3,1,1,'[{other,{twing,20010012}}]',50,'401002','暗影魔翼，挥动的双翼仿佛恶魔降临，无人不为之震慑而疯狂。','[{161,1,1}]','','tj_90950'),(90960,3,'流光天羽',3,1,2,'[{other,{twing,20010022}}]',50,'402002','流光天羽，闪耀而飘逸的羽翼，任谁都想凭借它遨游天际。','[{161,1,1}]','','tj_90960'),(90970,3,'仿生蝶翼',3,1,4,'[{other,{twing,20010042}}]',50,'404002','仿生蝶翼，仿生学和机械制造的完美融合，感受科技进步带来的便利。','[{161,1,1}]','','tj_90970'),(90980,3,'断罪之翼',4,1,1,'[{other,{twing,20010013}}]',50,'401003','断罪之翼，斩断罪孽的双翼，万物都将在其挥舞之下忏悔。','[{161,1,1}]','','tj_90980'),(90990,3,'裁决锋羽',4,1,2,'[{other,{twing,20010023}}]',50,'402003','裁决锋羽，黑暗也难掩其锋芒，一切的邪恶都将受到裁决。','[{161,1,1}]','','tj_90990'),(91000,3,'机械红莲',4,1,4,'[{other,{twing,20010043}}]',50,'404003','机械红莲，翅膀引擎的制动力使其穿戴者如同红莲般华丽绽放。','[{161,1,1}]','','tj_91000'),(91010,2,'独角兽',1,1,0,'[{other,{mount,1}}]',50,'301001','独角兽，民间俗称长角白马，一般只在苏米尔的原始森林地区出没。','[{160,1,1}]','','tj_91010'),(91020,2,'迅猛火鸡',1,1,0,'[{other,{mount,2}}]',50,'301020','迅猛火鸡，抵抗军通过培育普通火鸡而诞生的新品种，简直是火鸡中的战斗鸡！','[{160,1,1}]','','tj_91020'),(91030,2,'烈焰狐',1,1,0,'[{other,{mount,3}}]',50,'301003','烈焰狐，只在远东地区的吉煌之国境内栖息，擅长妖术变化。','[{160,1,1}]','','tj_91030'),(91040,2,'暗夜战狼',2,1,0,'[{other,{mount,4}}]',50,'301004','暗夜战狼，精灵部族当中通过驯服、训练暗影狼而成为的战斗单位。','[{160,1,1}]','','tj_91040'),(91050,2,'鹰嘴兽',2,1,0,'[{other,{mount,5}}]',50,'301021','鹰嘴兽，当地人喜欢称其为“五不像”，鸟羽、鹰嘴、鹿角、狮身、马蹄。','[{160,1,1}]','','tj_91050'),(91060,2,'白虎瑞兽',2,1,0,'[{other,{mount,6}}]',50,'301005','白虎瑞兽，只在远东地区的吉煌之国境内栖息，民间传说中的“四圣兽”之一。','[{160,1,1}]','','tj_91060'),(91070,2,'披甲天蝎',3,1,0,'[{other,{mount,7}}]',50,'301006','披甲天蝎，一般栖息在风蚀台地境内，适应了当地炎热干旱的气候，拥有坚硬的外壳。','[{160,1,1}]','','tj_91070'),(91080,2,'圣金狮鹫',3,1,0,'[{other,{mount,8}}]',50,'301007','圣金狮鹫，如同披金戴银的圣兽，羽毛光泽而顺滑，脾气暴躁凶狠。','[{160,1,1}]','','tj_91080'),(91090,2,'独角巨鲸',3,1,0,'[{other,{mount,9}}]',50,'301009','独角巨鲸，失落之海的传奇生物，能够脱离海水在空中漂浮。','[{160,1,1}]','','tj_91090'),(91130,2,'旋翼飞空艇',2,1,0,'[{other,{mount_huanhua,2}}]',50,'302001','旋翼飞空艇，机械师安娜在请教了加德纳技师之后，独自研发的坐骑，一如既往的“安娜风格”。','[{160,2,1}]','','tj_91130'),(91140,2,'赤焰飓风',3,1,0,'[{other,{mount_huanhua,1}}]',50,'302002','赤焰飓风，安娜与加德纳首次合作的坐骑，去掉了繁杂的机械轮驱构造，悬浮行驶更为拉风！','[{160,2,1}]','','tj_91140');
/*!40000 ALTER TABLE `base_pic` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_pic_chapter`
--

DROP TABLE IF EXISTS `base_pic_chapter`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_pic_chapter` (
  `chapter_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '章节id',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '图鉴类型',
  `chapter_name` varchar(50) NOT NULL DEFAULT '' COMMENT '章节名称',
  `description` varchar(255) NOT NULL DEFAULT '' COMMENT '章节描述',
  `resource` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '配图资源',
  `story_resource` varchar(255) NOT NULL DEFAULT '' COMMENT '剧情动画资源',
  `task_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '任务id',
  PRIMARY KEY (`chapter_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='图鉴章节表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_pic_chapter`
--

LOCK TABLES `base_pic_chapter` WRITE;
/*!40000 ALTER TABLE `base_pic_chapter` DISABLE KEYS */;
INSERT INTO `base_pic_chapter` VALUES (10000,4,'朔月海岸','劫后余生的你，被自称是抵抗军的组织所救，原来他们也在寻找陨落在各地的星辰之力，虽然他们盛意邀请你加入其阵营，不过在这陌生的地方，一切都要谨慎为妙，当务之急是找到唤醒萌羊座的方法！',20000,'30000',10240),(10001,4,'初来乍到','敬请期待',20001,'30001',0),(10002,4,'神秘组织','敬请期待',20002,'30002',0),(10003,4,'暗裔侵袭','敬请期待',20003,'30003',0),(10004,4,'降神试炼','敬请期待',20004,'30004',0),(20000,4,'抵抗军营','沉浸在战胜强大降神的你，缓过神来才发现自己的双手颤抖不已，那是一种对强大力量的敬畏吗？还是恐惧呢？降神托付给自己的力量，是否能够合理运用呢？',20010,'30010',10500),(20001,4,'组织据点','敬请期待',20011,'30011',0),(20002,4,'成为伙伴','敬请期待',20012,'30012',0),(20003,4,'唤醒星灵','敬请期待',20013,'30013',0),(30000,4,'迷雾沼泽','亲眼见证了抵抗军的大本营后，你正式成为了其中的一员，为了对抗野心膨胀的帝国军，抵抗军正在四处谋求联合，首要目标就是洛亚王城。不过在那之前，我们必须平安无事地穿过这片迷雾沼泽，危机四伏的凶险之地！',20020,'30020',10800),(30001,4,'暗流涌动','敬请期待',20021,'30021',0);
/*!40000 ALTER TABLE `base_pic_chapter` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_pic_lv`
--

DROP TABLE IF EXISTS `base_pic_lv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_pic_lv` (
  `pic_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '图鉴id',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `attr` varchar(512) NOT NULL DEFAULT '[]' COMMENT '属性',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗物品',
  PRIMARY KEY (`pic_id`,`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='升级表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_pic_lv`
--

LOCK TABLES `base_pic_lv` WRITE;
/*!40000 ALTER TABLE `base_pic_lv` DISABLE KEYS */;
INSERT INTO `base_pic_lv` VALUES (90010,1,'[{1,12},{2,240},{3,10},{4,10}]','[{0,45010001,1}]'),(90010,2,'[{1,17},{2,340},{3,14},{4,14}]','[{0,45010001,1}]'),(90010,3,'[{1,24},{2,480},{3,19},{4,19}]','[{0,45010001,2}]'),(90010,4,'[{1,33},{2,660},{3,25},{4,25}]','[{0,45010001,4}]'),(90010,5,'[{1,45},{2,900},{3,32},{4,32}]','[{0,45010001,6}]'),(90010,6,'[{1,59},{2,1180},{3,40},{4,40}]','[{0,45010001,8}]'),(90010,7,'[{1,75},{2,1500},{3,50},{4,50}]','[{0,45010001,10}]'),(90010,8,'[{1,93},{2,1860},{3,62},{4,62}]','[{0,45010001,12}]'),(90010,9,'[{1,114},{2,2280},{3,76},{4,76}]','[{0,45010001,15}]'),(90010,10,'[{1,138},{2,2760},{3,92},{4,92}]','[{0,45010001,18}]'),(90020,1,'[{1,12},{2,240},{3,10},{4,10}]','[{0,45010002,1}]'),(90020,2,'[{1,17},{2,340},{3,14},{4,14}]','[{0,45010002,1}]'),(90020,3,'[{1,24},{2,480},{3,19},{4,19}]','[{0,45010002,2}]'),(90020,4,'[{1,33},{2,660},{3,25},{4,25}]','[{0,45010002,4}]'),(90020,5,'[{1,45},{2,900},{3,32},{4,32}]','[{0,45010002,6}]'),(90020,6,'[{1,59},{2,1180},{3,40},{4,40}]','[{0,45010002,8}]'),(90020,7,'[{1,75},{2,1500},{3,50},{4,50}]','[{0,45010002,10}]'),(90020,8,'[{1,93},{2,1860},{3,62},{4,62}]','[{0,45010002,12}]'),(90020,9,'[{1,114},{2,2280},{3,76},{4,76}]','[{0,45010002,15}]'),(90020,10,'[{1,138},{2,2760},{3,92},{4,92}]','[{0,45010002,18}]'),(90030,1,'[{1,12},{2,240},{3,10},{4,10}]','[{0,45010003,1}]'),(90030,2,'[{1,17},{2,340},{3,14},{4,14}]','[{0,45010003,1}]'),(90030,3,'[{1,24},{2,480},{3,19},{4,19}]','[{0,45010003,2}]'),(90030,4,'[{1,33},{2,660},{3,25},{4,25}]','[{0,45010003,4}]'),(90030,5,'[{1,45},{2,900},{3,32},{4,32}]','[{0,45010003,6}]'),(90030,6,'[{1,59},{2,1180},{3,40},{4,40}]','[{0,45010003,8}]'),(90030,7,'[{1,75},{2,1500},{3,50},{4,50}]','[{0,45010003,10}]'),(90030,8,'[{1,93},{2,1860},{3,62},{4,62}]','[{0,45010003,12}]'),(90030,9,'[{1,114},{2,2280},{3,76},{4,76}]','[{0,45010003,15}]'),(90030,10,'[{1,138},{2,2760},{3,92},{4,92}]','[{0,45010003,18}]'),(90040,1,'[{1,12},{2,240},{3,10},{4,10}]','[{0,45010004,1}]'),(90040,2,'[{1,17},{2,340},{3,14},{4,14}]','[{0,45010004,1}]'),(90040,3,'[{1,24},{2,480},{3,19},{4,19}]','[{0,45010004,2}]'),(90040,4,'[{1,33},{2,660},{3,25},{4,25}]','[{0,45010004,4}]'),(90040,5,'[{1,45},{2,900},{3,32},{4,32}]','[{0,45010004,6}]'),(90040,6,'[{1,59},{2,1180},{3,40},{4,40}]','[{0,45010004,8}]'),(90040,7,'[{1,75},{2,1500},{3,50},{4,50}]','[{0,45010004,10}]'),(90040,8,'[{1,93},{2,1860},{3,62},{4,62}]','[{0,45010004,12}]'),(90040,9,'[{1,114},{2,2280},{3,76},{4,76}]','[{0,45010004,15}]'),(90040,10,'[{1,138},{2,2760},{3,92},{4,92}]','[{0,45010004,18}]'),(90050,1,'[{1,12},{2,240},{3,10},{4,10}]','[{0,45010005,1}]'),(90050,2,'[{1,17},{2,340},{3,14},{4,14}]','[{0,45010005,1}]'),(90050,3,'[{1,24},{2,480},{3,19},{4,19}]','[{0,45010005,2}]'),(90050,4,'[{1,33},{2,660},{3,25},{4,25}]','[{0,45010005,4}]'),(90050,5,'[{1,45},{2,900},{3,32},{4,32}]','[{0,45010005,6}]'),(90050,6,'[{1,59},{2,1180},{3,40},{4,40}]','[{0,45010005,8}]'),(90050,7,'[{1,75},{2,1500},{3,50},{4,50}]','[{0,45010005,10}]'),(90050,8,'[{1,93},{2,1860},{3,62},{4,62}]','[{0,45010005,12}]'),(90050,9,'[{1,114},{2,2280},{3,76},{4,76}]','[{0,45010005,15}]'),(90050,10,'[{1,138},{2,2760},{3,92},{4,92}]','[{0,45010005,18}]'),(90060,1,'[{1,12},{2,240},{3,10},{4,10}]','[{0,45010006,1}]'),(90060,2,'[{1,17},{2,340},{3,14},{4,14}]','[{0,45010006,1}]'),(90060,3,'[{1,24},{2,480},{3,19},{4,19}]','[{0,45010006,2}]'),(90060,4,'[{1,33},{2,660},{3,25},{4,25}]','[{0,45010006,4}]'),(90060,5,'[{1,45},{2,900},{3,32},{4,32}]','[{0,45010006,6}]'),(90060,6,'[{1,59},{2,1180},{3,40},{4,40}]','[{0,45010006,8}]'),(90060,7,'[{1,75},{2,1500},{3,50},{4,50}]','[{0,45010006,10}]'),(90060,8,'[{1,93},{2,1860},{3,62},{4,62}]','[{0,45010006,12}]'),(90060,9,'[{1,114},{2,2280},{3,76},{4,76}]','[{0,45010006,15}]'),(90060,10,'[{1,138},{2,2760},{3,92},{4,92}]','[{0,45010006,18}]'),(90070,1,'[{1,12},{2,240},{3,10},{4,10}]','[{0,45010007,1}]'),(90070,2,'[{1,17},{2,340},{3,14},{4,14}]','[{0,45010007,1}]'),(90070,3,'[{1,24},{2,480},{3,19},{4,19}]','[{0,45010007,2}]'),(90070,4,'[{1,33},{2,660},{3,25},{4,25}]','[{0,45010007,4}]'),(90070,5,'[{1,45},{2,900},{3,32},{4,32}]','[{0,45010007,6}]'),(90070,6,'[{1,59},{2,1180},{3,40},{4,40}]','[{0,45010007,8}]'),(90070,7,'[{1,75},{2,1500},{3,50},{4,50}]','[{0,45010007,10}]'),(90070,8,'[{1,93},{2,1860},{3,62},{4,62}]','[{0,45010007,12}]'),(90070,9,'[{1,114},{2,2280},{3,76},{4,76}]','[{0,45010007,15}]'),(90070,10,'[{1,138},{2,2760},{3,92},{4,92}]','[{0,45010007,18}]'),(90080,1,'[{1,12},{2,240},{3,10},{4,10}]','[{0,45010008,1}]'),(90080,2,'[{1,17},{2,340},{3,14},{4,14}]','[{0,45010008,1}]'),(90080,3,'[{1,24},{2,480},{3,19},{4,19}]','[{0,45010008,2}]'),(90080,4,'[{1,33},{2,660},{3,25},{4,25}]','[{0,45010008,4}]'),(90080,5,'[{1,45},{2,900},{3,32},{4,32}]','[{0,45010008,6}]'),(90080,6,'[{1,59},{2,1180},{3,40},{4,40}]','[{0,45010008,8}]'),(90080,7,'[{1,75},{2,1500},{3,50},{4,50}]','[{0,45010008,10}]'),(90080,8,'[{1,93},{2,1860},{3,62},{4,62}]','[{0,45010008,12}]'),(90080,9,'[{1,114},{2,2280},{3,76},{4,76}]','[{0,45010008,15}]'),(90080,10,'[{1,138},{2,2760},{3,92},{4,92}]','[{0,45010008,18}]'),(90090,1,'[{1,12},{2,240},{3,10},{4,10}]','[{0,45010009,1}]'),(90090,2,'[{1,17},{2,340},{3,14},{4,14}]','[{0,45010009,1}]'),(90090,3,'[{1,24},{2,480},{3,19},{4,19}]','[{0,45010009,2}]'),(90090,4,'[{1,33},{2,660},{3,25},{4,25}]','[{0,45010009,4}]'),(90090,5,'[{1,45},{2,900},{3,32},{4,32}]','[{0,45010009,6}]'),(90090,6,'[{1,59},{2,1180},{3,40},{4,40}]','[{0,45010009,8}]'),(90090,7,'[{1,75},{2,1500},{3,50},{4,50}]','[{0,45010009,10}]'),(90090,8,'[{1,93},{2,1860},{3,62},{4,62}]','[{0,45010009,12}]'),(90090,9,'[{1,114},{2,2280},{3,76},{4,76}]','[{0,45010009,15}]'),(90090,10,'[{1,138},{2,2760},{3,92},{4,92}]','[{0,45010009,18}]'),(90100,1,'[{1,12},{2,240},{3,10},{4,10}]','[{0,45010010,1}]'),(90100,2,'[{1,17},{2,340},{3,14},{4,14}]','[{0,45010010,1}]'),(90100,3,'[{1,24},{2,480},{3,19},{4,19}]','[{0,45010010,2}]'),(90100,4,'[{1,33},{2,660},{3,25},{4,25}]','[{0,45010010,4}]'),(90100,5,'[{1,45},{2,900},{3,32},{4,32}]','[{0,45010010,6}]'),(90100,6,'[{1,59},{2,1180},{3,40},{4,40}]','[{0,45010010,8}]'),(90100,7,'[{1,75},{2,1500},{3,50},{4,50}]','[{0,45010010,10}]'),(90100,8,'[{1,93},{2,1860},{3,62},{4,62}]','[{0,45010010,12}]'),(90100,9,'[{1,114},{2,2280},{3,76},{4,76}]','[{0,45010010,15}]'),(90100,10,'[{1,138},{2,2760},{3,92},{4,92}]','[{0,45010010,18}]'),(90110,1,'[{1,12},{2,240},{3,10},{4,10}]','[{0,45010011,1}]'),(90110,2,'[{1,17},{2,340},{3,14},{4,14}]','[{0,45010011,1}]'),(90110,3,'[{1,24},{2,480},{3,19},{4,19}]','[{0,45010011,2}]'),(90110,4,'[{1,33},{2,660},{3,25},{4,25}]','[{0,45010011,4}]'),(90110,5,'[{1,45},{2,900},{3,32},{4,32}]','[{0,45010011,6}]'),(90110,6,'[{1,59},{2,1180},{3,40},{4,40}]','[{0,45010011,8}]'),(90110,7,'[{1,75},{2,1500},{3,50},{4,50}]','[{0,45010011,10}]'),(90110,8,'[{1,93},{2,1860},{3,62},{4,62}]','[{0,45010011,12}]'),(90110,9,'[{1,114},{2,2280},{3,76},{4,76}]','[{0,45010011,15}]'),(90110,10,'[{1,138},{2,2760},{3,92},{4,92}]','[{0,45010011,18}]'),(90120,1,'[{1,12},{2,240},{3,10},{4,10}]','[{0,45010012,1}]'),(90120,2,'[{1,17},{2,340},{3,14},{4,14}]','[{0,45010012,1}]'),(90120,3,'[{1,24},{2,480},{3,19},{4,19}]','[{0,45010012,2}]'),(90120,4,'[{1,33},{2,660},{3,25},{4,25}]','[{0,45010012,4}]'),(90120,5,'[{1,45},{2,900},{3,32},{4,32}]','[{0,45010012,6}]'),(90120,6,'[{1,59},{2,1180},{3,40},{4,40}]','[{0,45010012,8}]'),(90120,7,'[{1,75},{2,1500},{3,50},{4,50}]','[{0,45010012,10}]'),(90120,8,'[{1,93},{2,1860},{3,62},{4,62}]','[{0,45010012,12}]'),(90120,9,'[{1,114},{2,2280},{3,76},{4,76}]','[{0,45010012,15}]'),(90120,10,'[{1,138},{2,2760},{3,92},{4,92}]','[{0,45010012,18}]'),(90130,1,'[{1,12},{2,240},{3,10},{4,10}]','[{0,45010013,1}]'),(90130,2,'[{1,17},{2,340},{3,14},{4,14}]','[{0,45010013,1}]'),(90130,3,'[{1,24},{2,480},{3,19},{4,19}]','[{0,45010013,2}]'),(90130,4,'[{1,33},{2,660},{3,25},{4,25}]','[{0,45010013,4}]'),(90130,5,'[{1,45},{2,900},{3,32},{4,32}]','[{0,45010013,6}]'),(90130,6,'[{1,59},{2,1180},{3,40},{4,40}]','[{0,45010013,8}]'),(90130,7,'[{1,75},{2,1500},{3,50},{4,50}]','[{0,45010013,10}]'),(90130,8,'[{1,93},{2,1860},{3,62},{4,62}]','[{0,45010013,12}]'),(90130,9,'[{1,114},{2,2280},{3,76},{4,76}]','[{0,45010013,15}]'),(90130,10,'[{1,138},{2,2760},{3,92},{4,92}]','[{0,45010013,18}]'),(90140,1,'[{1,12},{2,240},{3,10},{4,10}]','[{0,45010014,1}]'),(90140,2,'[{1,17},{2,340},{3,14},{4,14}]','[{0,45010014,1}]'),(90140,3,'[{1,24},{2,480},{3,19},{4,19}]','[{0,45010014,2}]'),(90140,4,'[{1,33},{2,660},{3,25},{4,25}]','[{0,45010014,4}]'),(90140,5,'[{1,45},{2,900},{3,32},{4,32}]','[{0,45010014,6}]'),(90140,6,'[{1,59},{2,1180},{3,40},{4,40}]','[{0,45010014,8}]'),(90140,7,'[{1,75},{2,1500},{3,50},{4,50}]','[{0,45010014,10}]'),(90140,8,'[{1,93},{2,1860},{3,62},{4,62}]','[{0,45010014,12}]'),(90140,9,'[{1,114},{2,2280},{3,76},{4,76}]','[{0,45010014,15}]'),(90140,10,'[{1,138},{2,2760},{3,92},{4,92}]','[{0,45010014,18}]'),(90150,1,'[{1,12},{2,240},{3,10},{4,10}]','[{0,45010015,1}]'),(90150,2,'[{1,17},{2,340},{3,14},{4,14}]','[{0,45010015,1}]'),(90150,3,'[{1,24},{2,480},{3,19},{4,19}]','[{0,45010015,2}]'),(90150,4,'[{1,33},{2,660},{3,25},{4,25}]','[{0,45010015,4}]'),(90150,5,'[{1,45},{2,900},{3,32},{4,32}]','[{0,45010015,6}]'),(90150,6,'[{1,59},{2,1180},{3,40},{4,40}]','[{0,45010015,8}]'),(90150,7,'[{1,75},{2,1500},{3,50},{4,50}]','[{0,45010015,10}]'),(90150,8,'[{1,93},{2,1860},{3,62},{4,62}]','[{0,45010015,12}]'),(90150,9,'[{1,114},{2,2280},{3,76},{4,76}]','[{0,45010015,15}]'),(90150,10,'[{1,138},{2,2760},{3,92},{4,92}]','[{0,45010015,18}]'),(90160,1,'[{1,12},{2,240},{3,10},{4,10}]','[{0,45010016,1}]'),(90160,2,'[{1,17},{2,340},{3,14},{4,14}]','[{0,45010016,1}]'),(90160,3,'[{1,24},{2,480},{3,19},{4,19}]','[{0,45010016,2}]'),(90160,4,'[{1,33},{2,660},{3,25},{4,25}]','[{0,45010016,4}]'),(90160,5,'[{1,45},{2,900},{3,32},{4,32}]','[{0,45010016,6}]'),(90160,6,'[{1,59},{2,1180},{3,40},{4,40}]','[{0,45010016,8}]'),(90160,7,'[{1,75},{2,1500},{3,50},{4,50}]','[{0,45010016,10}]'),(90160,8,'[{1,93},{2,1860},{3,62},{4,62}]','[{0,45010016,12}]'),(90160,9,'[{1,114},{2,2280},{3,76},{4,76}]','[{0,45010016,15}]'),(90160,10,'[{1,138},{2,2760},{3,92},{4,92}]','[{0,45010016,18}]'),(90170,1,'[{1,18},{2,360},{3,15},{4,15}]','[{0,45010101,1}]'),(90170,2,'[{1,26},{2,520},{3,21},{4,21}]','[{0,45010101,1}]'),(90170,3,'[{1,36},{2,720},{3,29},{4,29}]','[{0,45010101,2}]'),(90170,4,'[{1,50},{2,1000},{3,38},{4,38}]','[{0,45010101,4}]'),(90170,5,'[{1,68},{2,1360},{3,48},{4,48}]','[{0,45010101,6}]'),(90170,6,'[{1,89},{2,1780},{3,60},{4,60}]','[{0,45010101,8}]'),(90170,7,'[{1,113},{2,2260},{3,75},{4,75}]','[{0,45010101,10}]'),(90170,8,'[{1,140},{2,2800},{3,93},{4,93}]','[{0,45010101,12}]'),(90170,9,'[{1,171},{2,3420},{3,114},{4,114}]','[{0,45010101,15}]'),(90170,10,'[{1,207},{2,4140},{3,138},{4,138}]','[{0,45010101,18}]'),(90180,1,'[{1,18},{2,360},{3,15},{4,15}]','[{0,45010102,1}]'),(90180,2,'[{1,26},{2,520},{3,21},{4,21}]','[{0,45010102,1}]'),(90180,3,'[{1,36},{2,720},{3,29},{4,29}]','[{0,45010102,2}]'),(90180,4,'[{1,50},{2,1000},{3,38},{4,38}]','[{0,45010102,4}]'),(90180,5,'[{1,68},{2,1360},{3,48},{4,48}]','[{0,45010102,6}]'),(90180,6,'[{1,89},{2,1780},{3,60},{4,60}]','[{0,45010102,8}]'),(90180,7,'[{1,113},{2,2260},{3,75},{4,75}]','[{0,45010102,10}]'),(90180,8,'[{1,140},{2,2800},{3,93},{4,93}]','[{0,45010102,12}]'),(90180,9,'[{1,171},{2,3420},{3,114},{4,114}]','[{0,45010102,15}]'),(90180,10,'[{1,207},{2,4140},{3,138},{4,138}]','[{0,45010102,18}]'),(90190,1,'[{1,18},{2,360},{3,15},{4,15}]','[{0,45010103,1}]'),(90190,2,'[{1,26},{2,520},{3,21},{4,21}]','[{0,45010103,1}]'),(90190,3,'[{1,36},{2,720},{3,29},{4,29}]','[{0,45010103,2}]'),(90190,4,'[{1,50},{2,1000},{3,38},{4,38}]','[{0,45010103,4}]'),(90190,5,'[{1,68},{2,1360},{3,48},{4,48}]','[{0,45010103,6}]'),(90190,6,'[{1,89},{2,1780},{3,60},{4,60}]','[{0,45010103,8}]'),(90190,7,'[{1,113},{2,2260},{3,75},{4,75}]','[{0,45010103,10}]'),(90190,8,'[{1,140},{2,2800},{3,93},{4,93}]','[{0,45010103,12}]'),(90190,9,'[{1,171},{2,3420},{3,114},{4,114}]','[{0,45010103,15}]'),(90190,10,'[{1,207},{2,4140},{3,138},{4,138}]','[{0,45010103,18}]'),(90200,1,'[{1,18},{2,360},{3,15},{4,15}]','[{0,45010104,1}]'),(90200,2,'[{1,26},{2,520},{3,21},{4,21}]','[{0,45010104,1}]'),(90200,3,'[{1,36},{2,720},{3,29},{4,29}]','[{0,45010104,2}]'),(90200,4,'[{1,50},{2,1000},{3,38},{4,38}]','[{0,45010104,4}]'),(90200,5,'[{1,68},{2,1360},{3,48},{4,48}]','[{0,45010104,6}]'),(90200,6,'[{1,89},{2,1780},{3,60},{4,60}]','[{0,45010104,8}]'),(90200,7,'[{1,113},{2,2260},{3,75},{4,75}]','[{0,45010104,10}]'),(90200,8,'[{1,140},{2,2800},{3,93},{4,93}]','[{0,45010104,12}]'),(90200,9,'[{1,171},{2,3420},{3,114},{4,114}]','[{0,45010104,15}]'),(90200,10,'[{1,207},{2,4140},{3,138},{4,138}]','[{0,45010104,18}]'),(90210,1,'[{1,18},{2,360},{3,15},{4,15}]','[{0,45010105,1}]'),(90210,2,'[{1,26},{2,520},{3,21},{4,21}]','[{0,45010105,1}]'),(90210,3,'[{1,36},{2,720},{3,29},{4,29}]','[{0,45010105,2}]'),(90210,4,'[{1,50},{2,1000},{3,38},{4,38}]','[{0,45010105,4}]'),(90210,5,'[{1,68},{2,1360},{3,48},{4,48}]','[{0,45010105,6}]'),(90210,6,'[{1,89},{2,1780},{3,60},{4,60}]','[{0,45010105,8}]'),(90210,7,'[{1,113},{2,2260},{3,75},{4,75}]','[{0,45010105,10}]'),(90210,8,'[{1,140},{2,2800},{3,93},{4,93}]','[{0,45010105,12}]'),(90210,9,'[{1,171},{2,3420},{3,114},{4,114}]','[{0,45010105,15}]'),(90210,10,'[{1,207},{2,4140},{3,138},{4,138}]','[{0,45010105,18}]'),(90220,1,'[{1,18},{2,360},{3,15},{4,15}]','[{0,45010106,1}]'),(90220,2,'[{1,26},{2,520},{3,21},{4,21}]','[{0,45010106,1}]'),(90220,3,'[{1,36},{2,720},{3,29},{4,29}]','[{0,45010106,2}]'),(90220,4,'[{1,50},{2,1000},{3,38},{4,38}]','[{0,45010106,4}]'),(90220,5,'[{1,68},{2,1360},{3,48},{4,48}]','[{0,45010106,6}]'),(90220,6,'[{1,89},{2,1780},{3,60},{4,60}]','[{0,45010106,8}]'),(90220,7,'[{1,113},{2,2260},{3,75},{4,75}]','[{0,45010106,10}]'),(90220,8,'[{1,140},{2,2800},{3,93},{4,93}]','[{0,45010106,12}]'),(90220,9,'[{1,171},{2,3420},{3,114},{4,114}]','[{0,45010106,15}]'),(90220,10,'[{1,207},{2,4140},{3,138},{4,138}]','[{0,45010106,18}]'),(90230,1,'[{1,18},{2,360},{3,15},{4,15}]','[{0,45010107,1}]'),(90230,2,'[{1,26},{2,520},{3,21},{4,21}]','[{0,45010107,1}]'),(90230,3,'[{1,36},{2,720},{3,29},{4,29}]','[{0,45010107,2}]'),(90230,4,'[{1,50},{2,1000},{3,38},{4,38}]','[{0,45010107,4}]'),(90230,5,'[{1,68},{2,1360},{3,48},{4,48}]','[{0,45010107,6}]'),(90230,6,'[{1,89},{2,1780},{3,60},{4,60}]','[{0,45010107,8}]'),(90230,7,'[{1,113},{2,2260},{3,75},{4,75}]','[{0,45010107,10}]'),(90230,8,'[{1,140},{2,2800},{3,93},{4,93}]','[{0,45010107,12}]'),(90230,9,'[{1,171},{2,3420},{3,114},{4,114}]','[{0,45010107,15}]'),(90230,10,'[{1,207},{2,4140},{3,138},{4,138}]','[{0,45010107,18}]'),(90240,1,'[{1,18},{2,360},{3,15},{4,15}]','[{0,45010108,1}]'),(90240,2,'[{1,26},{2,520},{3,21},{4,21}]','[{0,45010108,1}]'),(90240,3,'[{1,36},{2,720},{3,29},{4,29}]','[{0,45010108,2}]'),(90240,4,'[{1,50},{2,1000},{3,38},{4,38}]','[{0,45010108,4}]'),(90240,5,'[{1,68},{2,1360},{3,48},{4,48}]','[{0,45010108,6}]'),(90240,6,'[{1,89},{2,1780},{3,60},{4,60}]','[{0,45010108,8}]'),(90240,7,'[{1,113},{2,2260},{3,75},{4,75}]','[{0,45010108,10}]'),(90240,8,'[{1,140},{2,2800},{3,93},{4,93}]','[{0,45010108,12}]'),(90240,9,'[{1,171},{2,3420},{3,114},{4,114}]','[{0,45010108,15}]'),(90240,10,'[{1,207},{2,4140},{3,138},{4,138}]','[{0,45010108,18}]'),(90250,1,'[{1,18},{2,360},{3,15},{4,15}]','[{0,45010109,1}]'),(90250,2,'[{1,26},{2,520},{3,21},{4,21}]','[{0,45010109,1}]'),(90250,3,'[{1,36},{2,720},{3,29},{4,29}]','[{0,45010109,2}]'),(90250,4,'[{1,50},{2,1000},{3,38},{4,38}]','[{0,45010109,4}]'),(90250,5,'[{1,68},{2,1360},{3,48},{4,48}]','[{0,45010109,6}]'),(90250,6,'[{1,89},{2,1780},{3,60},{4,60}]','[{0,45010109,8}]'),(90250,7,'[{1,113},{2,2260},{3,75},{4,75}]','[{0,45010109,10}]'),(90250,8,'[{1,140},{2,2800},{3,93},{4,93}]','[{0,45010109,12}]'),(90250,9,'[{1,171},{2,3420},{3,114},{4,114}]','[{0,45010109,15}]'),(90250,10,'[{1,207},{2,4140},{3,138},{4,138}]','[{0,45010109,18}]'),(90260,1,'[{1,18},{2,360},{3,15},{4,15}]','[{0,45010110,1}]'),(90260,2,'[{1,26},{2,520},{3,21},{4,21}]','[{0,45010110,1}]'),(90260,3,'[{1,36},{2,720},{3,29},{4,29}]','[{0,45010110,2}]'),(90260,4,'[{1,50},{2,1000},{3,38},{4,38}]','[{0,45010110,4}]'),(90260,5,'[{1,68},{2,1360},{3,48},{4,48}]','[{0,45010110,6}]'),(90260,6,'[{1,89},{2,1780},{3,60},{4,60}]','[{0,45010110,8}]'),(90260,7,'[{1,113},{2,2260},{3,75},{4,75}]','[{0,45010110,10}]'),(90260,8,'[{1,140},{2,2800},{3,93},{4,93}]','[{0,45010110,12}]'),(90260,9,'[{1,171},{2,3420},{3,114},{4,114}]','[{0,45010110,15}]'),(90260,10,'[{1,207},{2,4140},{3,138},{4,138}]','[{0,45010110,18}]'),(90270,1,'[{1,18},{2,360},{3,15},{4,15}]','[{0,45010111,1}]'),(90270,2,'[{1,26},{2,520},{3,21},{4,21}]','[{0,45010111,1}]'),(90270,3,'[{1,36},{2,720},{3,29},{4,29}]','[{0,45010111,2}]'),(90270,4,'[{1,50},{2,1000},{3,38},{4,38}]','[{0,45010111,4}]'),(90270,5,'[{1,68},{2,1360},{3,48},{4,48}]','[{0,45010111,6}]'),(90270,6,'[{1,89},{2,1780},{3,60},{4,60}]','[{0,45010111,8}]'),(90270,7,'[{1,113},{2,2260},{3,75},{4,75}]','[{0,45010111,10}]'),(90270,8,'[{1,140},{2,2800},{3,93},{4,93}]','[{0,45010111,12}]'),(90270,9,'[{1,171},{2,3420},{3,114},{4,114}]','[{0,45010111,15}]'),(90270,10,'[{1,207},{2,4140},{3,138},{4,138}]','[{0,45010111,18}]'),(90280,1,'[{1,18},{2,360},{3,15},{4,15}]','[{0,45010112,1}]'),(90280,2,'[{1,26},{2,520},{3,21},{4,21}]','[{0,45010112,1}]'),(90280,3,'[{1,36},{2,720},{3,29},{4,29}]','[{0,45010112,2}]'),(90280,4,'[{1,50},{2,1000},{3,38},{4,38}]','[{0,45010112,4}]'),(90280,5,'[{1,68},{2,1360},{3,48},{4,48}]','[{0,45010112,6}]'),(90280,6,'[{1,89},{2,1780},{3,60},{4,60}]','[{0,45010112,8}]'),(90280,7,'[{1,113},{2,2260},{3,75},{4,75}]','[{0,45010112,10}]'),(90280,8,'[{1,140},{2,2800},{3,93},{4,93}]','[{0,45010112,12}]'),(90280,9,'[{1,171},{2,3420},{3,114},{4,114}]','[{0,45010112,15}]'),(90280,10,'[{1,207},{2,4140},{3,138},{4,138}]','[{0,45010112,18}]'),(90290,1,'[{1,15},{2,300},{3,10},{4,10},{5,8},{6,8}]','[{0,45010113,1}]'),(90290,2,'[{1,21},{2,420},{3,15},{4,15},{5,11},{6,11}]','[{0,45010113,1}]'),(90290,3,'[{1,29},{2,580},{3,21},{4,21},{5,15},{6,15}]','[{0,45010113,2}]'),(90290,4,'[{1,39},{2,780},{3,28},{4,28},{5,20},{6,20}]','[{0,45010113,4}]'),(90290,5,'[{1,51},{2,1020},{3,36},{4,36},{5,26},{6,26}]','[{0,45010113,6}]'),(90290,6,'[{1,65},{2,1300},{3,45},{4,45},{5,33},{6,33}]','[{0,45010113,8}]'),(90290,7,'[{1,81},{2,1620},{3,55},{4,55},{5,41},{6,41}]','[{0,45010113,10}]'),(90290,8,'[{1,99},{2,1980},{3,67},{4,67},{5,50},{6,50}]','[{0,45010113,12}]'),(90290,9,'[{1,120},{2,2400},{3,81},{4,81},{5,60},{6,60}]','[{0,45010113,15}]'),(90290,10,'[{1,144},{2,2880},{3,97},{4,97},{5,72},{6,72}]','[{0,45010113,18}]'),(90300,1,'[{1,15},{2,300},{3,10},{4,10},{5,8},{6,8}]','[{0,45010114,1}]'),(90300,2,'[{1,21},{2,420},{3,15},{4,15},{5,11},{6,11}]','[{0,45010114,1}]'),(90300,3,'[{1,29},{2,580},{3,21},{4,21},{5,15},{6,15}]','[{0,45010114,2}]'),(90300,4,'[{1,39},{2,780},{3,28},{4,28},{5,20},{6,20}]','[{0,45010114,4}]'),(90300,5,'[{1,51},{2,1020},{3,36},{4,36},{5,26},{6,26}]','[{0,45010114,6}]'),(90300,6,'[{1,65},{2,1300},{3,45},{4,45},{5,33},{6,33}]','[{0,45010114,8}]'),(90300,7,'[{1,81},{2,1620},{3,55},{4,55},{5,41},{6,41}]','[{0,45010114,10}]'),(90300,8,'[{1,99},{2,1980},{3,67},{4,67},{5,50},{6,50}]','[{0,45010114,12}]'),(90300,9,'[{1,120},{2,2400},{3,81},{4,81},{5,60},{6,60}]','[{0,45010114,15}]'),(90300,10,'[{1,144},{2,2880},{3,97},{4,97},{5,72},{6,72}]','[{0,45010114,18}]'),(90310,1,'[{1,15},{2,300},{3,10},{4,10},{5,8},{6,8}]','[{0,45010115,1}]'),(90310,2,'[{1,21},{2,420},{3,15},{4,15},{5,11},{6,11}]','[{0,45010115,1}]'),(90310,3,'[{1,29},{2,580},{3,21},{4,21},{5,15},{6,15}]','[{0,45010115,2}]'),(90310,4,'[{1,39},{2,780},{3,28},{4,28},{5,20},{6,20}]','[{0,45010115,4}]'),(90310,5,'[{1,51},{2,1020},{3,36},{4,36},{5,26},{6,26}]','[{0,45010115,6}]'),(90310,6,'[{1,65},{2,1300},{3,45},{4,45},{5,33},{6,33}]','[{0,45010115,8}]'),(90310,7,'[{1,81},{2,1620},{3,55},{4,55},{5,41},{6,41}]','[{0,45010115,10}]'),(90310,8,'[{1,99},{2,1980},{3,67},{4,67},{5,50},{6,50}]','[{0,45010115,12}]'),(90310,9,'[{1,120},{2,2400},{3,81},{4,81},{5,60},{6,60}]','[{0,45010115,15}]'),(90310,10,'[{1,144},{2,2880},{3,97},{4,97},{5,72},{6,72}]','[{0,45010115,18}]'),(90320,1,'[{1,15},{2,300},{3,10},{4,10},{5,8},{6,8}]','[{0,45010116,1}]'),(90320,2,'[{1,21},{2,420},{3,15},{4,15},{5,11},{6,11}]','[{0,45010116,1}]'),(90320,3,'[{1,29},{2,580},{3,21},{4,21},{5,15},{6,15}]','[{0,45010116,2}]'),(90320,4,'[{1,39},{2,780},{3,28},{4,28},{5,20},{6,20}]','[{0,45010116,4}]'),(90320,5,'[{1,51},{2,1020},{3,36},{4,36},{5,26},{6,26}]','[{0,45010116,6}]'),(90320,6,'[{1,65},{2,1300},{3,45},{4,45},{5,33},{6,33}]','[{0,45010116,8}]'),(90320,7,'[{1,81},{2,1620},{3,55},{4,55},{5,41},{6,41}]','[{0,45010116,10}]'),(90320,8,'[{1,99},{2,1980},{3,67},{4,67},{5,50},{6,50}]','[{0,45010116,12}]'),(90320,9,'[{1,120},{2,2400},{3,81},{4,81},{5,60},{6,60}]','[{0,45010116,15}]'),(90320,10,'[{1,144},{2,2880},{3,97},{4,97},{5,72},{6,72}]','[{0,45010116,18}]'),(90330,1,'[{1,15},{2,300},{3,10},{4,10},{5,8},{6,8}]','[{0,45010117,1}]'),(90330,2,'[{1,21},{2,420},{3,15},{4,15},{5,11},{6,11}]','[{0,45010117,1}]'),(90330,3,'[{1,29},{2,580},{3,21},{4,21},{5,15},{6,15}]','[{0,45010117,2}]'),(90330,4,'[{1,39},{2,780},{3,28},{4,28},{5,20},{6,20}]','[{0,45010117,4}]'),(90330,5,'[{1,51},{2,1020},{3,36},{4,36},{5,26},{6,26}]','[{0,45010117,6}]'),(90330,6,'[{1,65},{2,1300},{3,45},{4,45},{5,33},{6,33}]','[{0,45010117,8}]'),(90330,7,'[{1,81},{2,1620},{3,55},{4,55},{5,41},{6,41}]','[{0,45010117,10}]'),(90330,8,'[{1,99},{2,1980},{3,67},{4,67},{5,50},{6,50}]','[{0,45010117,12}]'),(90330,9,'[{1,120},{2,2400},{3,81},{4,81},{5,60},{6,60}]','[{0,45010117,15}]'),(90330,10,'[{1,144},{2,2880},{3,97},{4,97},{5,72},{6,72}]','[{0,45010117,18}]'),(90340,1,'[{1,15},{2,300},{3,10},{4,10},{5,8},{6,8}]','[{0,45010118,1}]'),(90340,2,'[{1,21},{2,420},{3,15},{4,15},{5,11},{6,11}]','[{0,45010118,1}]'),(90340,3,'[{1,29},{2,580},{3,21},{4,21},{5,15},{6,15}]','[{0,45010118,2}]'),(90340,4,'[{1,39},{2,780},{3,28},{4,28},{5,20},{6,20}]','[{0,45010118,4}]'),(90340,5,'[{1,51},{2,1020},{3,36},{4,36},{5,26},{6,26}]','[{0,45010118,6}]'),(90340,6,'[{1,65},{2,1300},{3,45},{4,45},{5,33},{6,33}]','[{0,45010118,8}]'),(90340,7,'[{1,81},{2,1620},{3,55},{4,55},{5,41},{6,41}]','[{0,45010118,10}]'),(90340,8,'[{1,99},{2,1980},{3,67},{4,67},{5,50},{6,50}]','[{0,45010118,12}]'),(90340,9,'[{1,120},{2,2400},{3,81},{4,81},{5,60},{6,60}]','[{0,45010118,15}]'),(90340,10,'[{1,144},{2,2880},{3,97},{4,97},{5,72},{6,72}]','[{0,45010118,18}]'),(90350,1,'[{1,21},{2,417},{3,14},{4,14},{5,11},{6,11}]','[{0,45010201,1}]'),(90350,2,'[{1,29},{2,583},{3,21},{4,21},{5,15},{6,15}]','[{0,45010201,1}]'),(90350,3,'[{1,40},{2,806},{3,29},{4,29},{5,21},{6,21}]','[{0,45010201,2}]'),(90350,4,'[{1,54},{2,1083},{3,39},{4,39},{5,28},{6,28}]','[{0,45010201,4}]'),(90350,5,'[{1,71},{2,1417},{3,50},{4,50},{5,36},{6,36}]','[{0,45010201,6}]'),(90350,6,'[{1,90},{2,1806},{3,63},{4,63},{5,46},{6,46}]','[{0,45010201,8}]'),(90350,7,'[{1,113},{2,2250},{3,76},{4,76},{5,57},{6,57}]','[{0,45010201,10}]'),(90350,8,'[{1,138},{2,2750},{3,93},{4,93},{5,69},{6,69}]','[{0,45010201,12}]'),(90350,9,'[{1,167},{2,3333},{3,113},{4,113},{5,83},{6,83}]','[{0,45010201,15}]'),(90350,10,'[{1,200},{2,4000},{3,135},{4,135},{5,100},{6,100}]','[{0,45010201,18}]'),(90360,1,'[{1,21},{2,417},{3,14},{4,14},{5,11},{6,11}]','[{0,45010202,1}]'),(90360,2,'[{1,29},{2,583},{3,21},{4,21},{5,15},{6,15}]','[{0,45010202,1}]'),(90360,3,'[{1,40},{2,806},{3,29},{4,29},{5,21},{6,21}]','[{0,45010202,2}]'),(90360,4,'[{1,54},{2,1083},{3,39},{4,39},{5,28},{6,28}]','[{0,45010202,4}]'),(90360,5,'[{1,71},{2,1417},{3,50},{4,50},{5,36},{6,36}]','[{0,45010202,6}]'),(90360,6,'[{1,90},{2,1806},{3,63},{4,63},{5,46},{6,46}]','[{0,45010202,8}]'),(90360,7,'[{1,113},{2,2250},{3,76},{4,76},{5,57},{6,57}]','[{0,45010202,10}]'),(90360,8,'[{1,138},{2,2750},{3,93},{4,93},{5,69},{6,69}]','[{0,45010202,12}]'),(90360,9,'[{1,167},{2,3333},{3,113},{4,113},{5,83},{6,83}]','[{0,45010202,15}]'),(90360,10,'[{1,200},{2,4000},{3,135},{4,135},{5,100},{6,100}]','[{0,45010202,18}]'),(90370,1,'[{1,21},{2,417},{3,14},{4,14},{5,11},{6,11}]','[{0,45010203,1}]'),(90370,2,'[{1,29},{2,583},{3,21},{4,21},{5,15},{6,15}]','[{0,45010203,1}]'),(90370,3,'[{1,40},{2,806},{3,29},{4,29},{5,21},{6,21}]','[{0,45010203,2}]'),(90370,4,'[{1,54},{2,1083},{3,39},{4,39},{5,28},{6,28}]','[{0,45010203,4}]'),(90370,5,'[{1,71},{2,1417},{3,50},{4,50},{5,36},{6,36}]','[{0,45010203,6}]'),(90370,6,'[{1,90},{2,1806},{3,63},{4,63},{5,46},{6,46}]','[{0,45010203,8}]'),(90370,7,'[{1,113},{2,2250},{3,76},{4,76},{5,57},{6,57}]','[{0,45010203,10}]'),(90370,8,'[{1,138},{2,2750},{3,93},{4,93},{5,69},{6,69}]','[{0,45010203,12}]'),(90370,9,'[{1,167},{2,3333},{3,113},{4,113},{5,83},{6,83}]','[{0,45010203,15}]'),(90370,10,'[{1,200},{2,4000},{3,135},{4,135},{5,100},{6,100}]','[{0,45010203,18}]'),(90380,1,'[{1,21},{2,417},{3,14},{4,14},{5,11},{6,11}]','[{0,45010204,1}]'),(90380,2,'[{1,29},{2,583},{3,21},{4,21},{5,15},{6,15}]','[{0,45010204,1}]'),(90380,3,'[{1,40},{2,806},{3,29},{4,29},{5,21},{6,21}]','[{0,45010204,2}]'),(90380,4,'[{1,54},{2,1083},{3,39},{4,39},{5,28},{6,28}]','[{0,45010204,4}]'),(90380,5,'[{1,71},{2,1417},{3,50},{4,50},{5,36},{6,36}]','[{0,45010204,6}]'),(90380,6,'[{1,90},{2,1806},{3,63},{4,63},{5,46},{6,46}]','[{0,45010204,8}]'),(90380,7,'[{1,113},{2,2250},{3,76},{4,76},{5,57},{6,57}]','[{0,45010204,10}]'),(90380,8,'[{1,138},{2,2750},{3,93},{4,93},{5,69},{6,69}]','[{0,45010204,12}]'),(90380,9,'[{1,167},{2,3333},{3,113},{4,113},{5,83},{6,83}]','[{0,45010204,15}]'),(90380,10,'[{1,200},{2,4000},{3,135},{4,135},{5,100},{6,100}]','[{0,45010204,18}]'),(90390,1,'[{1,21},{2,417},{3,14},{4,14},{5,11},{6,11}]','[{0,45010205,1}]'),(90390,2,'[{1,29},{2,583},{3,21},{4,21},{5,15},{6,15}]','[{0,45010205,1}]'),(90390,3,'[{1,40},{2,806},{3,29},{4,29},{5,21},{6,21}]','[{0,45010205,2}]'),(90390,4,'[{1,54},{2,1083},{3,39},{4,39},{5,28},{6,28}]','[{0,45010205,4}]'),(90390,5,'[{1,71},{2,1417},{3,50},{4,50},{5,36},{6,36}]','[{0,45010205,6}]'),(90390,6,'[{1,90},{2,1806},{3,63},{4,63},{5,46},{6,46}]','[{0,45010205,8}]'),(90390,7,'[{1,113},{2,2250},{3,76},{4,76},{5,57},{6,57}]','[{0,45010205,10}]'),(90390,8,'[{1,138},{2,2750},{3,93},{4,93},{5,69},{6,69}]','[{0,45010205,12}]'),(90390,9,'[{1,167},{2,3333},{3,113},{4,113},{5,83},{6,83}]','[{0,45010205,15}]'),(90390,10,'[{1,200},{2,4000},{3,135},{4,135},{5,100},{6,100}]','[{0,45010205,18}]'),(90400,1,'[{1,21},{2,417},{3,14},{4,14},{5,11},{6,11}]','[{0,45010206,1}]'),(90400,2,'[{1,29},{2,583},{3,21},{4,21},{5,15},{6,15}]','[{0,45010206,1}]'),(90400,3,'[{1,40},{2,806},{3,29},{4,29},{5,21},{6,21}]','[{0,45010206,2}]'),(90400,4,'[{1,54},{2,1083},{3,39},{4,39},{5,28},{6,28}]','[{0,45010206,4}]'),(90400,5,'[{1,71},{2,1417},{3,50},{4,50},{5,36},{6,36}]','[{0,45010206,6}]'),(90400,6,'[{1,90},{2,1806},{3,63},{4,63},{5,46},{6,46}]','[{0,45010206,8}]'),(90400,7,'[{1,113},{2,2250},{3,76},{4,76},{5,57},{6,57}]','[{0,45010206,10}]'),(90400,8,'[{1,138},{2,2750},{3,93},{4,93},{5,69},{6,69}]','[{0,45010206,12}]'),(90400,9,'[{1,167},{2,3333},{3,113},{4,113},{5,83},{6,83}]','[{0,45010206,15}]'),(90400,10,'[{1,200},{2,4000},{3,135},{4,135},{5,100},{6,100}]','[{0,45010206,18}]'),(90410,1,'[{1,33},{2,667},{3,22},{4,22},{5,18},{6,18}]','[{0,45010301,1}]'),(90410,2,'[{1,47},{2,933},{3,33},{4,33},{5,24},{6,24}]','[{0,45010301,1}]'),(90410,3,'[{1,64},{2,1289},{3,47},{4,47},{5,33},{6,33}]','[{0,45010301,2}]'),(90410,4,'[{1,87},{2,1733},{3,62},{4,62},{5,44},{6,44}]','[{0,45010301,4}]'),(90410,5,'[{1,113},{2,2267},{3,80},{4,80},{5,58},{6,58}]','[{0,45010301,6}]'),(90410,6,'[{1,144},{2,2889},{3,100},{4,100},{5,73},{6,73}]','[{0,45010301,8}]'),(90410,7,'[{1,180},{2,3600},{3,122},{4,122},{5,91},{6,91}]','[{0,45010301,10}]'),(90410,8,'[{1,220},{2,4400},{3,149},{4,149},{5,111},{6,111}]','[{0,45010301,12}]'),(90410,9,'[{1,267},{2,5333},{3,180},{4,180},{5,133},{6,133}]','[{0,45010301,15}]'),(90410,10,'[{1,320},{2,6400},{3,216},{4,216},{5,160},{6,160}]','[{0,45010301,18}]'),(90420,1,'[{1,33},{2,667},{3,22},{4,22},{5,18},{6,18}]','[{0,45010302,1}]'),(90420,2,'[{1,47},{2,933},{3,33},{4,33},{5,24},{6,24}]','[{0,45010302,1}]'),(90420,3,'[{1,64},{2,1289},{3,47},{4,47},{5,33},{6,33}]','[{0,45010302,2}]'),(90420,4,'[{1,87},{2,1733},{3,62},{4,62},{5,44},{6,44}]','[{0,45010302,4}]'),(90420,5,'[{1,113},{2,2267},{3,80},{4,80},{5,58},{6,58}]','[{0,45010302,6}]'),(90420,6,'[{1,144},{2,2889},{3,100},{4,100},{5,73},{6,73}]','[{0,45010302,8}]'),(90420,7,'[{1,180},{2,3600},{3,122},{4,122},{5,91},{6,91}]','[{0,45010302,10}]'),(90420,8,'[{1,220},{2,4400},{3,149},{4,149},{5,111},{6,111}]','[{0,45010302,12}]'),(90420,9,'[{1,267},{2,5333},{3,180},{4,180},{5,133},{6,133}]','[{0,45010302,15}]'),(90420,10,'[{1,320},{2,6400},{3,216},{4,216},{5,160},{6,160}]','[{0,45010302,18}]'),(90430,1,'[{1,33},{2,667},{3,22},{4,22},{5,18},{6,18}]','[{0,45010303,1}]'),(90430,2,'[{1,47},{2,933},{3,33},{4,33},{5,24},{6,24}]','[{0,45010303,1}]'),(90430,3,'[{1,64},{2,1289},{3,47},{4,47},{5,33},{6,33}]','[{0,45010303,2}]'),(90430,4,'[{1,87},{2,1733},{3,62},{4,62},{5,44},{6,44}]','[{0,45010303,4}]'),(90430,5,'[{1,113},{2,2267},{3,80},{4,80},{5,58},{6,58}]','[{0,45010303,6}]'),(90430,6,'[{1,144},{2,2889},{3,100},{4,100},{5,73},{6,73}]','[{0,45010303,8}]'),(90430,7,'[{1,180},{2,3600},{3,122},{4,122},{5,91},{6,91}]','[{0,45010303,10}]'),(90430,8,'[{1,220},{2,4400},{3,149},{4,149},{5,111},{6,111}]','[{0,45010303,12}]'),(90430,9,'[{1,267},{2,5333},{3,180},{4,180},{5,133},{6,133}]','[{0,45010303,15}]'),(90430,10,'[{1,320},{2,6400},{3,216},{4,216},{5,160},{6,160}]','[{0,45010303,18}]'),(90440,1,'[{1,33},{2,667},{3,22},{4,22},{5,18},{6,18}]','[{0,45010304,1}]'),(90440,2,'[{1,47},{2,933},{3,33},{4,33},{5,24},{6,24}]','[{0,45010304,1}]'),(90440,3,'[{1,64},{2,1289},{3,47},{4,47},{5,33},{6,33}]','[{0,45010304,2}]'),(90440,4,'[{1,87},{2,1733},{3,62},{4,62},{5,44},{6,44}]','[{0,45010304,4}]'),(90440,5,'[{1,113},{2,2267},{3,80},{4,80},{5,58},{6,58}]','[{0,45010304,6}]'),(90440,6,'[{1,144},{2,2889},{3,100},{4,100},{5,73},{6,73}]','[{0,45010304,8}]'),(90440,7,'[{1,180},{2,3600},{3,122},{4,122},{5,91},{6,91}]','[{0,45010304,10}]'),(90440,8,'[{1,220},{2,4400},{3,149},{4,149},{5,111},{6,111}]','[{0,45010304,12}]'),(90440,9,'[{1,267},{2,5333},{3,180},{4,180},{5,133},{6,133}]','[{0,45010304,15}]'),(90440,10,'[{1,320},{2,6400},{3,216},{4,216},{5,160},{6,160}]','[{0,45010304,18}]'),(90450,1,'[{1,33},{2,667},{3,22},{4,22},{5,18},{6,18}]','[{0,45010305,1}]'),(90450,2,'[{1,47},{2,933},{3,33},{4,33},{5,24},{6,24}]','[{0,45010305,1}]'),(90450,3,'[{1,64},{2,1289},{3,47},{4,47},{5,33},{6,33}]','[{0,45010305,2}]'),(90450,4,'[{1,87},{2,1733},{3,62},{4,62},{5,44},{6,44}]','[{0,45010305,4}]'),(90450,5,'[{1,113},{2,2267},{3,80},{4,80},{5,58},{6,58}]','[{0,45010305,6}]'),(90450,6,'[{1,144},{2,2889},{3,100},{4,100},{5,73},{6,73}]','[{0,45010305,8}]'),(90450,7,'[{1,180},{2,3600},{3,122},{4,122},{5,91},{6,91}]','[{0,45010305,10}]'),(90450,8,'[{1,220},{2,4400},{3,149},{4,149},{5,111},{6,111}]','[{0,45010305,12}]'),(90450,9,'[{1,267},{2,5333},{3,180},{4,180},{5,133},{6,133}]','[{0,45010305,15}]'),(90450,10,'[{1,320},{2,6400},{3,216},{4,216},{5,160},{6,160}]','[{0,45010305,18}]'),(90460,1,'[{1,33},{2,667},{3,22},{4,22},{5,18},{6,18}]','[{0,45010306,1}]'),(90460,2,'[{1,47},{2,933},{3,33},{4,33},{5,24},{6,24}]','[{0,45010306,1}]'),(90460,3,'[{1,64},{2,1289},{3,47},{4,47},{5,33},{6,33}]','[{0,45010306,2}]'),(90460,4,'[{1,87},{2,1733},{3,62},{4,62},{5,44},{6,44}]','[{0,45010306,4}]'),(90460,5,'[{1,113},{2,2267},{3,80},{4,80},{5,58},{6,58}]','[{0,45010306,6}]'),(90460,6,'[{1,144},{2,2889},{3,100},{4,100},{5,73},{6,73}]','[{0,45010306,8}]'),(90460,7,'[{1,180},{2,3600},{3,122},{4,122},{5,91},{6,91}]','[{0,45010306,10}]'),(90460,8,'[{1,220},{2,4400},{3,149},{4,149},{5,111},{6,111}]','[{0,45010306,12}]'),(90460,9,'[{1,267},{2,5333},{3,180},{4,180},{5,133},{6,133}]','[{0,45010306,15}]'),(90460,10,'[{1,320},{2,6400},{3,216},{4,216},{5,160},{6,160}]','[{0,45010306,18}]'),(90470,1,'[{1,50},{2,1000},{3,33},{4,33},{5,27},{6,27}]','[{0,45010401,1}]'),(90470,2,'[{1,70},{2,1400},{3,50},{4,50},{5,37},{6,37}]','[{0,45010401,1}]'),(90470,3,'[{1,97},{2,1933},{3,70},{4,70},{5,50},{6,50}]','[{0,45010401,2}]'),(90470,4,'[{1,130},{2,2600},{3,93},{4,93},{5,67},{6,67}]','[{0,45010401,4}]'),(90470,5,'[{1,170},{2,3400},{3,120},{4,120},{5,87},{6,87}]','[{0,45010401,6}]'),(90470,6,'[{1,217},{2,4333},{3,150},{4,150},{5,110},{6,110}]','[{0,45010401,8}]'),(90470,7,'[{1,270},{2,5400},{3,183},{4,183},{5,137},{6,137}]','[{0,45010401,10}]'),(90470,8,'[{1,330},{2,6600},{3,223},{4,223},{5,167},{6,167}]','[{0,45010401,12}]'),(90470,9,'[{1,400},{2,8000},{3,270},{4,270},{5,200},{6,200}]','[{0,45010401,15}]'),(90470,10,'[{1,480},{2,9600},{3,323},{4,323},{5,240},{6,240}]','[{0,45010401,18}]'),(90480,1,'[{1,50},{2,1000},{3,33},{4,33},{5,27},{6,27}]','[{0,45010402,1}]'),(90480,2,'[{1,70},{2,1400},{3,50},{4,50},{5,37},{6,37}]','[{0,45010402,1}]'),(90480,3,'[{1,97},{2,1933},{3,70},{4,70},{5,50},{6,50}]','[{0,45010402,2}]'),(90480,4,'[{1,130},{2,2600},{3,93},{4,93},{5,67},{6,67}]','[{0,45010402,4}]'),(90480,5,'[{1,170},{2,3400},{3,120},{4,120},{5,87},{6,87}]','[{0,45010402,6}]'),(90480,6,'[{1,217},{2,4333},{3,150},{4,150},{5,110},{6,110}]','[{0,45010402,8}]'),(90480,7,'[{1,270},{2,5400},{3,183},{4,183},{5,137},{6,137}]','[{0,45010402,10}]'),(90480,8,'[{1,330},{2,6600},{3,223},{4,223},{5,167},{6,167}]','[{0,45010402,12}]'),(90480,9,'[{1,400},{2,8000},{3,270},{4,270},{5,200},{6,200}]','[{0,45010402,15}]'),(90480,10,'[{1,480},{2,9600},{3,323},{4,323},{5,240},{6,240}]','[{0,45010402,18}]'),(90490,1,'[{1,50},{2,1000},{3,33},{4,33},{5,27},{6,27}]','[{0,45010403,1}]'),(90490,2,'[{1,70},{2,1400},{3,50},{4,50},{5,37},{6,37}]','[{0,45010403,1}]'),(90490,3,'[{1,97},{2,1933},{3,70},{4,70},{5,50},{6,50}]','[{0,45010403,2}]'),(90490,4,'[{1,130},{2,2600},{3,93},{4,93},{5,67},{6,67}]','[{0,45010403,4}]'),(90490,5,'[{1,170},{2,3400},{3,120},{4,120},{5,87},{6,87}]','[{0,45010403,6}]'),(90490,6,'[{1,217},{2,4333},{3,150},{4,150},{5,110},{6,110}]','[{0,45010403,8}]'),(90490,7,'[{1,270},{2,5400},{3,183},{4,183},{5,137},{6,137}]','[{0,45010403,10}]'),(90490,8,'[{1,330},{2,6600},{3,223},{4,223},{5,167},{6,167}]','[{0,45010403,12}]'),(90490,9,'[{1,400},{2,8000},{3,270},{4,270},{5,200},{6,200}]','[{0,45010403,15}]'),(90490,10,'[{1,480},{2,9600},{3,323},{4,323},{5,240},{6,240}]','[{0,45010403,18}]'),(90500,1,'[{1,20},{2,400},{3,16},{4,16}]','[]'),(90510,1,'[{1,35},{2,700},{5,20},{6,20}]','[]'),(90520,1,'[{1,50},{2,1000},{3,40},{4,40},{5,24},{6,24}]','[]'),(90530,1,'[{1,80},{2,1600},{3,64},{4,64},{7,32},{8,32}]','[]'),(90540,1,'[{1,100},{2,2000},{3,80},{4,80},{5,40},{6,40},{7,40},{8,40}]','[]'),(90550,1,'[{1,20},{2,400},{3,16},{4,16}]','[]'),(90560,1,'[{1,35},{2,700},{5,20},{6,20}]','[]'),(90570,1,'[{1,50},{2,1000},{3,40},{4,40},{5,24},{6,24}]','[]'),(90580,1,'[{1,80},{2,1600},{3,64},{4,64},{7,32},{8,32}]','[]'),(90590,1,'[{1,100},{2,2000},{3,80},{4,80},{5,40},{6,40},{7,40},{8,40}]','[]'),(90600,1,'[{1,15},{2,300},{3,12},{4,12}]','[]'),(90610,1,'[{1,35},{2,700},{3,28},{4,28}]','[]'),(90620,1,'[{1,45},{2,900},{5,20},{6,20}]','[]'),(90630,1,'[{1,65},{2,1300},{3,52},{4,52}]','[]'),(90640,1,'[{1,90},{2,1800},{7,40},{8,40}]','[]'),(90650,1,'[{1,100},{2,2000},{3,80},{4,80},{5,40},{6,40}]','[]'),(90660,1,'[{1,150},{2,3000},{3,120},{4,120},{7,60},{8,60}]','[]'),(90670,1,'[{1,200},{2,4000},{3,160},{4,160},{5,50},{6,50},{7,50},{8,50}]','[]'),(90680,1,'[{1,15},{2,300},{3,12},{4,12}]','[]'),(90690,1,'[{1,20},{2,400},{5,8},{6,8}]','[]'),(90700,1,'[{1,25},{2,500},{7,12},{8,12}]','[]'),(90710,1,'[{1,25},{2,500},{5,12},{6,12}]','[]'),(90720,1,'[{1,30},{2,600},{3,24},{4,24}]','[]'),(90730,1,'[{1,30},{2,600},{7,16},{8,16}]','[]'),(90740,1,'[{3,32},{4,32},{5,16},{6,16},{7,16},{8,16}]','[]'),(90750,1,'[{1,40},{2,800},{3,32},{4,32},{7,16},{8,16}]','[]'),(90760,1,'[{1,40},{2,800},{5,16},{6,16},{7,16},{8,16}]','[]'),(90770,1,'[{1,40},{2,800},{3,32},{4,32},{5,16},{6,16}]','[]'),(90780,1,'[{1,40},{2,800},{3,32},{4,32},{5,16},{6,16}]','[]'),(90790,1,'[{1,40},{2,800},{3,32},{4,32},{7,16},{8,16}]','[]'),(90800,1,'[{1,8},{2,160},{3,4},{4,4}]','[]'),(90810,1,'[{1,12},{2,240},{3,6},{4,6}]','[]'),(90820,1,'[{1,16},{2,320},{3,8},{4,8}]','[]'),(90830,1,'[{1,8},{2,160},{5,4},{6,4}]','[]'),(90840,1,'[{1,12},{2,240},{7,6},{8,6}]','[]'),(90850,1,'[{1,20},{2,400},{5,12},{6,12}]','[]'),(90860,1,'[{1,10},{2,200},{7,6},{8,6}]','[]'),(90870,1,'[{3,12},{4,12},{7,8},{8,8}]','[]'),(90880,1,'[{1,25},{2,500},{7,16},{8,16}]','[]'),(90890,1,'[{1,12},{2,240},{3,14},{4,14}]','[]'),(90900,1,'[{1,32},{2,640},{3,25},{4,25}]','[]'),(90910,1,'[{1,36},{2,720},{3,28},{4,28}]','[]'),(90920,1,'[{1,40},{2,800},{3,32},{4,32}]','[]'),(90930,1,'[{1,40},{2,800},{3,32},{4,32}]','[]'),(90940,1,'[{1,40},{2,800},{3,32},{4,32}]','[]'),(90950,1,'[{1,60},{2,1200},{3,48},{4,48}]','[]'),(90960,1,'[{1,60},{2,1200},{3,48},{4,48}]','[]'),(90970,1,'[{1,60},{2,1200},{3,48},{4,48}]','[]'),(90980,1,'[{1,80},{2,1600},{3,50},{4,50},{7,25},{8,25}]','[]'),(90990,1,'[{1,80},{2,1600},{3,50},{4,50},{7,25},{8,25}]','[]'),(91000,1,'[{1,80},{2,1600},{3,50},{4,50},{7,25},{8,25}]','[]'),(91010,1,'[{1,20},{2,400},{3,16},{4,16}]','[]'),(91020,1,'[{1,30},{2,600},{3,24},{4,24}]','[]'),(91030,1,'[{1,40},{2,800},{3,32},{4,32}]','[]'),(91040,1,'[{1,60},{2,1200},{5,24},{6,24}]','[]'),(91050,1,'[{1,80},{2,1600},{7,32},{8,32}]','[]'),(91060,1,'[{1,120},{2,2400},{3,96},{4,96}]','[]'),(91070,1,'[{1,135},{2,2700},{3,100},{4,100},{5,30},{6,30}]','[]'),(91080,1,'[{1,180},{2,3600},{3,120},{4,120},{5,45},{6,45}]','[]'),(91090,1,'[{1,240},{2,4800},{3,160},{4,160},{7,60},{8,60}]','[]'),(91100,1,'[{1,280},{2,5600},{3,180},{4,180},{5,50},{6,50},{7,50},{8,50}]','[]'),(91110,1,'[{1,320},{2,6400},{3,200},{4,200},{5,75},{6,75},{7,75},{8,75}]','[]'),(91120,1,'[{1,360},{2,7200},{3,240},{4,240},{5,90},{6,90},{7,90},{8,90}]','[]'),(91130,1,'[{1,70},{2,1400},{3,50},{4,50},{5,22},{6,22}]','[]'),(91140,1,'[{1,80},{2,1600},{3,60},{4,60},{5,30},{6,30},{7,30},{8,30}]','[]');
/*!40000 ALTER TABLE `base_pic_lv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_pic_type`
--

DROP TABLE IF EXISTS `base_pic_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_pic_type` (
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '类型名称',
  `mark` varchar(255) NOT NULL DEFAULT '' COMMENT '备注',
  PRIMARY KEY (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='图鉴类型配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_pic_type`
--

LOCK TABLES `base_pic_type` WRITE;
/*!40000 ALTER TABLE `base_pic_type` DISABLE KEYS */;
INSERT INTO `base_pic_type` VALUES (1,'魔物异兽','怪物、boss'),(2,'守护之灵','星灵、圣灵、守护等'),(3,'天工利器','圣器、神器、宝具等'),(4,'传说事迹','剧情、动画');
/*!40000 ALTER TABLE `base_pic_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_player_interact`
--

DROP TABLE IF EXISTS `base_player_interact`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_player_interact` (
  `id` int(10) unsigned NOT NULL COMMENT 'ID',
  `name` varchar(255) NOT NULL COMMENT '@lang@动作名称',
  `condition` varchar(255) NOT NULL COMMENT '使用条件',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家交互-使用条件表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_player_interact`
--

LOCK TABLES `base_player_interact` WRITE;
/*!40000 ALTER TABLE `base_player_interact` DISABLE KEYS */;
INSERT INTO `base_player_interact` VALUES (1,'搂住Ta','[{relation,0}]'),(2,'摸摸头','[{relation,1},{intimacy,50}]'),(3,'惩罚Ta','[{relation,2},{intimacy,99}]'),(4,'公主抱','[{relation,2},{intimacy,150}]'),(5,'求爱','[{relation,2},{intimacy,213}]'),(6,'亲吻Ta','[{relation,3},{intimacy,300}]'),(7,'相互依偎','[{relation,3},{intimacy,520}]');
/*!40000 ALTER TABLE `base_player_interact` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_price_type`
--

DROP TABLE IF EXISTS `base_price_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_price_type` (
  `price_type` int(11) NOT NULL COMMENT '价格类型',
  `price_name` varchar(20) NOT NULL COMMENT '价格名称',
  PRIMARY KEY (`price_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='价格类型配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_price_type`
--

LOCK TABLES `base_price_type` WRITE;
/*!40000 ALTER TABLE `base_price_type` DISABLE KEYS */;
INSERT INTO `base_price_type` VALUES (0,'物品'),(1,'钻石'),(2,'绑定钻石'),(3,'卢币'),(4,'公会币'),(5,'经验'),(6,'荣誉1'),(7,'荣誉2'),(8,'公会资金'),(9,'公会贡献度');
/*!40000 ALTER TABLE `base_price_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_produce_type`
--

DROP TABLE IF EXISTS `base_produce_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_produce_type` (
  `type` varchar(255) NOT NULL COMMENT '类型',
  `id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `about` varchar(255) NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='产出类型配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_produce_type`
--

LOCK TABLES `base_produce_type` WRITE;
/*!40000 ALTER TABLE `base_produce_type` DISABLE KEYS */;
INSERT INTO `base_produce_type` VALUES ('unkown',0,'未知类型'),('mon_drop',1,'怪物掉落'),('mail_attachment',2,'邮件附件'),('achievement',3,'达成成就'),('gm',4,'秘籍获取'),('task',5,'任务奖励'),('sell_goods',6,'出售物品'),('recharge',7,'充值'),('recharge_card',8,'充值卡'),('mail',9,'邮件'),('dungeon',10,'副本'),('shop_normal',11,'常用道具商城'),('gift',12,'礼包'),('ac_custom_random',13,'定制活动随机奖励'),('send_flower',14,'花语鲜花'),('goods_use',15,'背包使用'),('ac_custom_sum_recharge',16,'累冲奖励'),('optional_gift',17,'自选宝箱'),('receive_guild_salary',18,'公会工资'),('guild_depot_exchange',19,'公会仓库兑换'),('red_envelopes',20,'红包'),('use_designtion_good',21,'使用已有称号的激活物品直接产出价格的货币'),('goods_compose',22,'物品合成'),('goods_decompose',23,'物品分解'),('equip_suit_take_off',24,'装备套装解散返还消耗'),('fashion_resolve',25,'时装道具分解'),('shop_week',26,'每周限购商城'),('shop_bgold',27,'绑钻商城'),('shop_fashion',28,'时装外形商城'),('dungeon_count_sweep_rewards',31,'副本扫荡奖励'),('rune_exchange',32,'符文兑换'),('dungeon_drop_auto_pick',33,'副本掉落自动拾取'),('equip_stone_return',34,'返还替换的宝石'),('void_fam',35,'虚空秘境'),('sell_down',36,'市场商品下架'),('pay_sell',37,'市场购买商品'),('jjc_challenge_reward',38,'竞技主动挑战奖励'),('jjc_break_reward',39,'竞技排名每日奖励'),('jjc_rank_reward',40,'竞技排名奖励'),('finish_daily_task',41,'完成悬赏任务奖励'),('finish_guild_task',42,'完成公会周任务奖励'),('daily_checkin',43,'每日签到签到奖励'),('total_checkin',44,'每日签到的累计签到奖励'),('top_pk_daily_honor',45,'巅峰竞技日常荣誉'),('top_pk_daily_count_reward',46,'决战之巅参与次数奖励'),('top_pk_grade_reward',47,'巅峰对决段位奖励'),('sell_up_hedge',48,'市场上架出错自动退还物品'),('top_pk_battle_reward',49,'决战之巅比赛结果奖励'),('guild_war_reward',50,'公会争霸比赛奖励'),('guild_war_salary_paul',51,'主宰公会俸禄'),('gift_card',52,'使用礼包卡'),('noon_quiz_rank_reward',53,'中午答题结算排行奖励'),('noon_quiz_answer',54,'中午答题单题结算'),('wedding_danmu',55,'婚礼弹幕'),('treasure_hunt',57,'寻宝'),('investment_reward',58,'投资活动回报'),('goods_exchange',59,'物品兑换'),('clusters_mon_drop',62,'跨服怪物掉落'),('pray',63,'祈愿'),('activity_live_reward',64,'日常活跃度奖励'),('resource_back',65,'资源找回'),('wedding_fires',66,'放烟花'),('wedding_kill_trouble',67,'杀死捣蛋鬼'),('eat_wedding_food',69,'吃喜宴'),('eat_wedding_candies',71,'吃喜糖'),('dog_food',72,'婚姻-撒狗粮'),('achv_reward',73,'达成成就奖励'),('husong_best',75,'护送最高品质飞艇额外奖励'),('husong_finish_first',76,'护送完成第一阶段'),('husong_finish_last',77,'护送完成最后阶段'),('rush_giftbag',78,'冲级礼包奖励'),('dungeon_evil_daily_reward',79,'诛邪战场每日积分奖励'),('rush_goal_reward',80,'冲榜目标奖励'),('login_reward',81,'七天登录'),('eternal_valley_stage_reward',82,'圣器契约阶段奖励'),('col_world_act',83,'开服集字产出'),('ac_recharge_cumulation',84,'累充活动奖励'),('down_load_gift',85,'下载礼包'),('guild_rename_fail',86,'公会重命名失败返还'),('recharge_gift_award',87,'首冲奖励礼包'),('achievement_reward',88,'成就奖励'),('treasure_hunt_fail',89,'寻宝失败退还'),('share_reward',90,'分享有礼'),('show_love',91,'秀恩爱'),('custom_act',92,'定制活动通用'),('night_welfare',93,'夜间福利'),('smashed_egg',94,'砸蛋'),('smashed_egg_cumulate_reward',95,'砸蛋累计奖励'),('cloud_buy_error',96,'众仙云购失败'),('cloud_buy_happy',97,'众仙云购小奖'),('exchange_act',98,'活动兑换'),('gboss_mat_donate_reward',99,'公会Boss兽魂兑换'),('shop_honour',100,'荣誉商城'),('recharge_reward',101,'充值奖励'),('wedding_aura',102,'婚礼气氛值奖励'),('boss_first_blood',104,'boss首杀'),('guild_create_act_reward',105,'勇者盟约奖励'),('hi_points',106,'嗨点活动'),('fireworks_act',109,'烟花活动'),('buy_goods',110,'购买物品'),('lucky_turntable_rewards',111,'幸运转盘抽中奖励'),('version_upgradebag',112,'领取版本礼包'),('limit_shop_buy',113,'神秘限购购买'),('soul_seal_treasure_hunt',114,'魂珠寻宝'),('honor_treasure_hunt',115,'至尊寻宝'),('top_treasure_hunt',116,'巅峰寻宝'),('treasure_evaluation',117,'幸运鉴宝'),('quick_buy',118,'快速购买'),('collect_put_s',119,'提交收集活动物品累计奖励'),('collect_put_n',120,'提交收集活动物品普通奖励'),('remove_equip_skill_return_cost',121,'拆除唤魔技能返回材料'),('diamond_league_guess_reward',122,'星钻联赛竞猜奖励'),('diamond_league_result',123,'星钻联赛比赛奖励'),('login_return_reward_buy',124,'0元豪礼'),('login_return_reward_return',125,'0元豪礼返利'),('twing',126,'翅膀合成'),('guild_bonfire_reply',127,'公会答题'),('butterfly_integration',128,'捕蝶积分'),('butterfly_rank',129,'捕蝶转盘'),('onhook_offline_reward',130,'离线挂机奖励'),('add_donate',131,'捐献增加'),('reward_add_donate',132,'奖励增加公会贡献'),('treasure_reward',133,'宝藏系统免费奖励'),('auction_fail',134,'竞拍失败，返还竞拍资金'),('active_chapter_pyx',135,'激活圣器目标'),('war_god_targer_reward',136,'荣耀战神目标奖励'),('war_god_targer_first_reward',137,'荣耀战神第一'),('guild_guard_event_reward',138,'公会守护波数奖励'),('guild_guard_boss',139,'公会守护召唤boss'),('melee_pk_rank_reward',140,'大乱斗排行奖励'),('melee_pk_stage_reward',141,'大乱斗阶段奖励'),('melee_pk_collecte',142,'大乱斗宝箱奖励'),('active_book',143,'星之轨迹'),('vip_limit_giftbag',144,'vip限购礼包'),('dungoen_flop',145,'副本翻牌'),('dungeon_couple_reward',146,'情侣副本领取奖励'),('kf_3v3',147,'跨服3v3结算'),('shop_3v3',148,'3v3商城'),('kf_3v3_wincount',149,'跨服3v3胜利N场奖励'),('kf_3v3_daily',150,'3v3今日段位奖励'),('war_god_targer_kill_reward',151,'荣耀战神最后一击'),('guild_guard_collect_reward',152,'守卫公会采集怪'),('drumwar',153,'钻石大战'),('husong_help',154,'护送协助成功奖励'),('husong_take',155,'护送抢劫成功奖励'),('perfect_lover',156,'三世恋人奖励'),('welfare_giftbag',157,'福利礼包'),('mount_smelt',158,'坐骑装备熔炼'),('kf_1vn_race_1_score_rank',159,'跨服1vn资格赛奖励'),('kf_1vn_race_2',160,'跨服1vn挑战赛奖励'),('mount_make',161,'坐骑装备打造'),('kf_town_war_own_reward',162,'跨服城战每日奖励'),('kf_town_war_buy_good',163,'跨服城战商店'),('kf_town_war_result_reward',164,'跨服城战结算奖励'),('kf_town_war_score_reward',165,'跨服城战个人积分'),('fishing',166,'钓鱼'),('kf_town_war_assist',167,'宣战失败和取消'),('kf_invade_task',168,'跨服入侵任务奖励'),('collect_wedding_box',169,'婚礼答题'),('kf_invade_collect',170,'跨服入侵采集'),('star_soul_treasure_lucky_draw',171,'星灵宝箱抽奖'),('star_soul_treasure_integral_redeem',172,'星灵宝箱积分兑换'),('discount_giftbag',173,'巨折献礼'),('spec_sell_act',174,'精品特卖'),('live_skill',175,'生活技能'),('drop_wedding_candies',176,'撒喜糖'),('lucky_flop',177,'幸运翻牌'),('pigeon',178,'白鸽传信'),('daily_turntable',179,'每日活跃转盘'),('build_pink_equip_return',180,'粉装、橙装打造失败返还'),('role_home',181,'家园'),('kf_cloud_buy_rand_reward',182,'跨服云购奖励'),('kf_cloud_buy_return_cost',183,'跨服云购返还'),('kf_cloud_buy_draw_reward',184,'跨服云购开奖'),('parade_return',185,'巡游返还'),('parade_strew_flower',186,'巡游撒花'),('parade_collect',187,'巡游采集奖励'),('parade_end',188,'巡游结束'),('parade_fires',189,'巡游放烟花'),('star_shadow_free',190,'星痕开启免费赠送'),('star_shadow_compose',191,'星痕合成'),('star_shadow_decompose',192,'星痕分解'),('recharge_daily_gift',193,'购买每日礼包'),('husong_max_designation',194,'累计护送最高品质飞艇10次称号'),('guild_buy_goods',195,'公会购买商品'),('star_soul_study_skill',196,'星灵替换技能返还'),('star_soul_war_sweep',197,'星灵试炼扫荡'),('treasure_devil_angel',198,'宝藏系统购买小恶魔或小天使'),('star_soul_equip_resolve',199,'星灵装备分解'),('star_soul_equip_stren_break',200,'星灵装备强化突破'),('onhook_online_reward',201,'在线挂机奖励'),('kf_1vn_auction',202,'跨服1vn竞拍'),('charm_beach',203,'魅力海滩'),('welfare_card',204,'福利卡返还'),('shop_star_war',205,'星灵试炼商城'),('shop_invade',206,'入侵商店'),('sp_shop_resolve',207,'黑市商店分解'),('sp_shop_buy',208,'黑市商店购买'),('kf_invade_stage_reward',209,'跨服入侵阶段奖励'),('star_soul_war',210,'星灵试炼'),('goldmine_receive',211,'矿洞付费领取'),('exp_library_receive',212,'经验书馆付费领取'),('shop_1vn',213,'1vn商城购买'),('kf_1vn_auction_fail',214,'跨服1vn竞拍返还'),('team_kill_mon',215,'队伍杀怪'),('guild_bonfire',216,'公会篝火'),('role_kill_mon',217,'个人杀怪'),('exp_goods',218,'使用经验丹'),('wedding',219,'婚礼'),('parade',220,'巡游'),('overflow_gift_act',221,'超值礼包'),('seal_soul_progress_reward',222,'魂珠寻宝进度奖励'),('seal_soul_times_reward',223,'魂珠寻宝次数奖励'),('limit_goal_task_reward',224,'限时目标任务奖励'),('kf_1vn',225,'跨服1vn'),('seal_soul_resolve',226,'分解魂珠'),('supplication',227,'祈愿'),('supplication_task',228,'祈愿完成任务'),('capsule_toys',229,'超级扭蛋'),('dungeon_stage_reward',230,'副本阶段奖励'),('repeat_recharge_truntable',231,'重复充值转盘'),('dungeon_daily_reward',232,'副本每日目标奖励'),('race_act',233,'竞榜抽奖'),('race_act_stage',234,'竞榜阶段奖励'),('shop_diamond_vip',235,'至尊vip商城'),('shop_life',236,'终生商城'),('love_box_buy_reward',237,'爱情宝盒购买奖励'),('love_box_daily_reward',238,'爱情宝盒每日奖励'),('vip_task',239,'vip任务奖励'),('equip_prefix_take_off',240,'重铸材料返还'),('upgrade_prefix',241,'装备重铸'),('module_advance',242,'功能预告'),('marriage_guidance',243,'结婚引导奖励'),('marriage_guidance_lv',244,'结婚引导等级奖励'),('joy_wish',245,'欢乐许愿'),('goldmine_lvup',246,'矿洞升级送'),('baby_figure_up_stage',247,'宝宝幻形升阶'),('add_depot_fail',248,'公会捐献失败'),('welfare_online_time',249,'福利在线时长礼包'),('kf_boss_rank_reward',250,'跨服boss伤害排名奖励'),('league_war_score',253,'三英会战积分奖励'),('rank_praise',254,'排行榜点赞奖励'),('lucky_flop_receive_reward',255,'幸运翻牌累计奖励'),('onhook_offline_uplv',256,'离线挂机升级'),('vip_lv_giftbag',257,'vip等级礼包'),('vip_honor_giftbag',258,'vip至尊礼包'),('limit_buy',259,'特惠商城');
/*!40000 ALTER TABLE `base_produce_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_pushmail`
--

DROP TABLE IF EXISTS `base_pushmail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_pushmail` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '触发id',
  `time` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '时间触发',
  `open_day` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开服天数',
  `merge_day` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '合服天数',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `career` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '职业',
  `sex` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '性别',
  `dun` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本ID',
  `other` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '其他',
  `title` varchar(1024) NOT NULL COMMENT '邮件标题@lang@',
  `msg` varchar(1024) NOT NULL COMMENT '邮件内容@lang@',
  `accessory` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '邮件附件',
  `about` varchar(1024) NOT NULL COMMENT '说明@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='邮件推送';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_pushmail`
--

LOCK TABLES `base_pushmail` WRITE;
/*!40000 ALTER TABLE `base_pushmail` DISABLE KEYS */;
INSERT INTO `base_pushmail` VALUES (1,'[]',0,0,30,'[]','[]',0,'[]','坐骑功能开启','坐骑功能开启啦，可以开开心心的培养属于自己的坐骑了，使用坐骑升星材料还可以提升坐骑的属性能力，解锁更多的外形哦','[{2,36020001,10},{0,16020001,1}]',''),(2,'[]',0,0,50,'[]','[]',0,'[]','星灵功能开启','星灵功能开启啦，进入<color=#62e874>【星灵】</color>界面中，可以召唤可爱的萌萌羊了呢，快带上自己的萌萌羊，一起去冒险吧','[{2,36020001,10},{0,18020001,2}]',''),(3,'[]',0,0,70,'[]','[]',0,'[]','魂珠功能开启','魂珠功能开启啦，进入<color=#62e874>【魂珠】</color>界面中，可以镶嵌魂珠，获得强力提升，打副本超快的哦~','[{0,5203002,1}]',''),(4,'[]',0,0,72,'[]','[]',0,'[]','宝具功能开启','宝具功能开启啦，进入<color=#62e874>【宝具】</color>界面，提升宝具等级，可以获得强大的属性能力','[{2,36020001,10},{0,24010001,2}]',''),(5,'[]',0,0,75,'[]','[]',0,'[]','经验本功能开启','经验宝库开启啦，点击<color=#62e874>【副本】-【单人副本】-【经验宝库】页签</color>进入；带上经验馆主还有50%经验加成，快去挑战经验宝库吧。','[{2,36020001,10}]',''),(6,'[]',0,0,90,'[]','[]',0,'[]','圣灵功能开启','圣灵功能开启啦，进入<color=#62e874>【圣灵】</color>界面中，可以培养属于的圣灵，获得强大的能力加成','[{2,36020001,10},{0,15020101,2}]',''),(7,'[]',0,0,95,'[]','[]',0,'[]','首领遗迹功能开启','首领遗迹开启啦，点击<color=#62e874>【首领】-【首领遗迹】页签</color>进入；击败首领掉落稀有装备、翅膀幻形材料和各类稀有材料，首领遗迹中竞争激烈，尽量提升战力后再前往。','[{2,36020001,10}]',''),(8,'[]',0,0,105,'[]','[]',0,'[]','装备本功能开启','装备副本开启啦，点击<color=#62e874>【副本】-【组队副本】-【装备副本】页签</color>进入；通关装备副本可获得大量装备，组队挑战通过成功率更高哦。','[{2,36020001,10}]',''),(9,'[]',0,0,110,'[]','[]',0,'[]','翅膀功能开启','翅膀功能开启啦，进入<color=#62e874>【翅膀】</color>界面中，炫酷翅膀，海量战力等你来哟！','[{2,36020001,10},{0,20060001,3}]',''),(10,'[]',0,0,115,'[]','[]',0,'[]','竞技场功能开启','竞技场开启啦，点击<color=#62e874>【战场】-【竞技场】页签</color>进入；战胜其他玩家，提高排名，还可以获得大量声望哦，声望可以用于兑换各种道具','[{2,36020001,10}]',''),(11,'[]',0,0,120,'[]','[]',0,'[]','神格功能开启','神格功能开启啦，进入<color=#62e874>【神格】</color>界面，提升个人头衔，向着最强大的【神子】进发吧','[{2,36020001,10},{0,17010001,10}]',''),(12,'[]',0,0,130,'[]','[]',0,'[]','护送功能开启','护送功能开启啦，点击<color=#62e874>【历练】-【每日必做】—【护送】页签</color>进入，护送星界飞艇，可以获得海量经验奖励，护送过程中会遇到其他玩家的拦截哦，请呼唤伙伴协助护送','[{2,36020001,10},{0,38330004,1}]',''),(13,'[]',0,0,160,'[]','[]',0,'[]','首领狩猎功能开启','首领狩猎开启啦，再也不用担心首领被抢啦，点击<color=#62e874>【首领】-【首领狩猎】页签</color>进入；击败个人首领掉落稀有装备、翅膀幻形材料和各类稀有材料，个人首领副本需达到<color=#62e874>贵族4</color>才可进入。','[{2,36020001,10}]',''),(14,'[]',0,0,170,'[]','[]',0,'[]','首领会所功能开启','首领会所开启啦，点击<color=#62e874>【首领】-【首领会所】页签</color>进入；会所首领掉落稀有装备、翅膀幻形材料和套装石。','[{2,36020001,10}]',''),(15,'[]',0,0,240,'[]','[]',0,'[]','混乱魔域功能开启','混乱魔域开启啦，点击<color=#62e874>【首领】-【混乱魔域】页签</color>进入；魔域首领掉落稀有装备、翅膀幻形材料和套装石，魔域中每击败一只怪物会增加怒气值。','[{2,36020001,10},{0,38030003,1}]',''),(16,'[]',0,0,240,'[]','[]',0,'[]','装备套装功能开启','装备套装功能开启啦，点击<color=#62e874>【打造】-【套装】页签</color>进入，可以利用套装石打造出更加强力的装备，冒险家快去尝试吧','[{2,36020001,10}]',''),(17,'[]',0,0,260,'[]','[]',0,'[]','洗练副本功能开启','洗练副本开启啦，点击<color=#62e874>【副本】-【组队副本】-【洗练副本】页签</color>进入；通关装备副本可获得大量洗练石和神炼石，组队挑战通过成功率更高哦。','[{2,36020001,10}]','');
/*!40000 ALTER TABLE `base_pushmail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_pyx`
--

DROP TABLE IF EXISTS `base_pyx`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_pyx` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '圣器id',
  `skill_id` varchar(255) NOT NULL DEFAULT '[]' COMMENT '圣器技能',
  `goods_id` varchar(255) NOT NULL DEFAULT '[]' COMMENT '激活道具',
  `condition` varchar(255) NOT NULL DEFAULT '[]' COMMENT '激活条件',
  `figure_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '圣器模型',
  `pyx_name` varchar(255) NOT NULL COMMENT '圣器名字',
  `icon_id` varchar(255) NOT NULL COMMENT '图标id',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_pyx`
--

LOCK TABLES `base_pyx` WRITE;
/*!40000 ALTER TABLE `base_pyx` DISABLE KEYS */;
INSERT INTO `base_pyx` VALUES (1,'[11000004]','[{0,15010001,1}]','[]',609005,'光明号角','artifact_101'),(2,'[11000007]','[{0,15010002,1}]','[]',609010,'祷告之书','artifact_102'),(3,'[11000013]','[{0,15010003,1}]','[]',609008,'起源之火','artifact_103'),(4,'[11000005]','[]','[{active,[1,2,3]}]',0,'镜面盾铠','artifact_104'),(5,'[11000011]','[{0,15010005,1}]','[]',609009,'霜语皇冠','artifact_201'),(6,'[14000001]','[{0,15010006,1}]','[]',609013,'镇魂十字','artifact_202'),(7,'[11000010]','[{0,15010007,1}]','[]',609015,'起源之水','artifact_203'),(8,'[11000003]','[]','[{active,[5,6,7]}]',0,'零度寒雀','artifact_204'),(9,'[11000002]','[{0,15010009,1}]','[]',609006,'恶魔契约','artifact_301'),(10,'[11000009]','[{0,15010010,1}]','[]',609007,'死亡圣杯','artifact_302'),(11,'[11000012]','[{0,15010011,1}]','[]',609016,'冥府之钥 ','artifact_303'),(12,'[11000006]','[]','[{active,[9,10,11]}]',0,'灵魂斗篷','artifact_304');
/*!40000 ALTER TABLE `base_pyx` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_quick_buy_price`
--

DROP TABLE IF EXISTS `base_quick_buy_price`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_quick_buy_price` (
  `goods_type_id` int(10) unsigned NOT NULL COMMENT '物品类型id',
  `gold_price` int(10) unsigned NOT NULL COMMENT '钻石价格',
  `bgold_price` int(10) unsigned NOT NULL COMMENT '绑钻价格（0为不可用绑钻买）',
  `coin_price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '金币价格（0为不可用金币买）',
  `consume_type` varchar(256) NOT NULL DEFAULT 'unknown' COMMENT '消耗类型',
  PRIMARY KEY (`goods_type_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='快速购买价格配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_quick_buy_price`
--

LOCK TABLES `base_quick_buy_price` WRITE;
/*!40000 ALTER TABLE `base_quick_buy_price` DISABLE KEYS */;
INSERT INTO `base_quick_buy_price` VALUES (11020001,10,10,0,'god'),(11020002,20,20,0,'god'),(11020003,40,40,0,'god'),(11070001,20,0,0,'god'),(11070010,80,80,0,'god'),(16020001,20,20,0,'mount_add_exp_cost'),(16020002,60,60,0,'mount_add_exp_cost'),(16020003,180,180,0,'mount_add_exp_cost'),(18010001,200,200,0,'star_soul_treasure_lucky_draw'),(18020001,10,10,0,'star_soul_stage'),(18020002,30,30,0,'star_soul_stage'),(18020003,90,90,0,'star_soul_stage'),(24010001,15,15,0,'talisman_upgrade_lv'),(24010002,60,60,0,'talisman_upgrade_lv'),(24010003,240,240,0,'talisman_upgrade_lv'),(36040001,288,0,0,'vip_turn_on'),(36040002,666,0,0,'vip_turn_on'),(36040003,998,0,0,'vip_turn_on'),(37020001,10,10,0,'unknown'),(37030002,100,0,0,'unknown'),(38030001,80,80,0,'dungeon_enter_cost'),(38030002,60,60,0,'boss_home'),(38030003,40,40,0,'dungeon_enter_cost'),(38040005,200,0,0,'unknown'),(38040006,200,0,0,'unknown'),(38040010,5,5,0,'dungeon_count_sweep_cost'),(38040101,10,10,0,'dungeon_encourage'),(38040102,0,0,5000,'dungeon_encourage'),(38050001,10,10,0,'chat'),(38050002,20,20,0,'chat'),(38070002,20,20,0,'onhook_card'),(38090001,50,50,0,'unknown'),(38110001,10,10,0,'unknown'),(38110002,10,10,0,'unknown'),(38110003,10,10,0,'unknown'),(38110004,50,50,0,'unknown'),(38110005,30,30,0,'unknown'),(38110006,45,45,0,'unknown'),(38110007,60,60,0,'unknown'),(38120001,100,100,0,'unknown'),(38130001,5,5,0,'unknown'),(38180001,20,0,0,'treasure_hunt'),(38180002,40,0,0,'treasure_hunt'),(38180003,50,0,0,'treasure_hunt'),(38180006,30,0,0,'smashed_egg'),(38180007,50,0,0,'treasure_evaluation'),(38180008,50,0,0,'lucky_flop_refresh'),(38180009,50,0,0,'lucky_flop_cost'),(38180010,50,0,0,'soul_pos'),(38180012,88,0,0,'capsule_toys'),(38180013,30,0,0,'kf_cloud_buy'),(38180014,50,0,0,'race_act_buy'),(38180015,1,0,0,'joy_wish'),(38210001,468,468,0,'change_name'),(38210002,998,998,0,'guild_rename'),(38250001,50,50,0,'equip_wash'),(38260001,10,10,0,'equip_wash'),(38300002,288,568,0,'treasure_guardian'),(38300004,588,0,0,'treasure_guardian'),(38330001,3,3,0,'husong'),(38330002,7,7,0,'husong'),(38330003,20,20,0,'husong'),(38330004,60,0,0,'husong'),(48040001,2,0,0,'role_home'),(48040002,2,0,0,'role_home'),(48050001,128,268,0,'role_home'),(50010101,0,0,10000,'fishing_consume'),(50010102,20,0,0,'fishing_consume'),(50010103,100,0,0,'fishing_consume'),(50010201,0,0,1000,'fishing_consume'),(50010202,0,5,0,'fishing_consume'),(54010001,20,20,0,'baby_lv_cost'),(54010002,60,60,0,'baby_lv_cost'),(54010003,180,180,0,'baby_lv_cost'),(54040001,20,20,0,'baby_mount_lv_cost'),(54040002,60,60,0,'baby_mount_lv_cost'),(54040003,180,180,0,'baby_mount_lv_cost'),(1011000001,288,568,0,'treasure_guardian'),(1011000002,268,488,0,'treasure_guardian'),(1011000003,488,0,0,'treasure_guardian'),(1011000004,468,0,0,'treasure_guardian');
/*!40000 ALTER TABLE `base_quick_buy_price` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_race_act_info`
--

DROP TABLE IF EXISTS `base_race_act_info`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_race_act_info` (
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `sub_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '次类型',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '活动名',
  `act_type` int(11) NOT NULL DEFAULT '0' COMMENT '活动类型',
  `open_day` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开服天数',
  `open_over` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开服结束',
  `start_time` varchar(30) NOT NULL DEFAULT '0' COMMENT '开始时间',
  `end_time` varchar(30) NOT NULL DEFAULT '0' COMMENT '结束时间',
  `clear_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '清除类型',
  `treasure` varchar(1024) NOT NULL DEFAULT '''[]''' COMMENT '抽奖方式',
  `others` varchar(1024) NOT NULL DEFAULT '''[]''' COMMENT '其他',
  PRIMARY KEY (`type`,`sub_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_race_act_info`
--

LOCK TABLES `base_race_act_info` WRITE;
/*!40000 ALTER TABLE `base_race_act_info` DISABLE KEYS */;
INSERT INTO `base_race_act_info` VALUES (1,1,'坐骑冲榜',2,15,9999,'2019-06-19 00:00:00','2019-06-20 23:59:59',2,'[{1,[{0,38180015,25}],1},{10,[{0,38180015,200}],10}]','[{is_show,1},{reward_show,6},{stage_clear_close,1},{skill_show,[{14000004,1000},{14000005,2000}]},{tv_show,[{16030004,1}]}]'),(2,1,'光武圣言冲榜',2,12,999,'2019-08-01 00:00:00','2019-08-02 21:59:59',2,'[{1,[{0,38180015,25}],1},{10,[{0,38180015,200}],10}]','[{is_show,1},{reward_show,career,[{1,1014},{2,2014},{4,4014}]},{stage_clear_close,1},{tv_show,[{53040104,1},{53040204,1},{53040404,1},{14010105,1},{14020205,1}]}]'),(2,2,'光武圣言冲榜',2,12,999,'2019-08-07 00:00:00','2019-08-08 21:59:59',2,'[{1,[{0,38180015,25}],1},{10,[{0,38180015,200}],10}]','[{is_show,1},{reward_show,career,[{1,1014},{2,2014},{4,4014}]},{stage_clear_close,1},{tv_show,[{53040104,1},{53040204,1},{53040404,1},{14010105,1},{14020205,1}]}]'),(2,3,'光武圣言冲榜',2,12,999,'2019-08-13 00:00:00','2019-08-14 21:59:59',2,'[{1,[{0,38180015,25}],1},{10,[{0,38180015,200}],10}]','[{is_show,1},{reward_show,career,[{1,1014},{2,2014},{4,4014}]},{stage_clear_close,1},{tv_show,[{53040104,1},{53040204,1},{53040404,1},{14010105,1},{14020205,1}]}]'),(2,4,'光武圣言冲榜',1,4,5,'','',2,'[{1,[{0,38180015,25}],1},{10,[{0,38180015,200}],10}]','[{is_show,1},{reward_show,career,[{1,1014},{2,2014},{4,4014}]},{stage_clear_close,1},{tv_show,[{53040104,1},{53040204,1},{53040404,1},{14010105,1},{14020205,1}]}]'),(2,5,'光武圣言冲榜',1,10,11,'','',2,'[{1,[{0,38180015,25}],1},{10,[{0,38180015,200}],10}]','[{is_show,1},{reward_show,career,[{1,1014},{2,2014},{4,4014}]},{stage_clear_close,1},{tv_show,[{53040104,1},{53040204,1},{53040404,1},{14010105,1},{14020205,1}]}]'),(3,1,'海底世界冲榜',2,12,999,'2019-07-28 00:00:00','2019-07-29 21:59:59',2,'[{1,[{0,38180015,25}],1},{10,[{0,38180015,200}],10}]','[{is_show,1},{reward_show,1013},{stage_clear_close,1},{tv_show,[{20070012,1},{14010105,1},{14020205,1}]}]'),(3,2,'圣月罗盘冲榜',2,12,999,'2019-07-30 00:00:00','2019-07-31 21:59:59',2,'[{1,[{0,38180015,25}],1},{10,[{0,38180015,200}],10}]','[{is_show,1},{reward_show,1008},{stage_clear_close,1},{tv_show,[{20070015,1},{14010105,1},{14020205,1}]}]'),(3,3,'长耳兔',2,12,999,'2019-08-03 00:00:00','2019-08-04 21:59:59',2,'[{1,[{0,38180015,25}],1},{10,[{0,38180015,200}],10}]','[{is_show,1},{reward_show,1009},{stage_clear_close,1},{tv_show,[{20070016,1},{14010105,1},{14020205,1}]}]'),(3,4,'魔法黑猫',2,12,999,'2019-08-05 00:00:00','2019-08-06 21:59:59',2,'[{1,[{0,38180015,25}],1},{10,[{0,38180015,200}],10}]','[{is_show,1},{reward_show,1010},{stage_clear_close,1},{tv_show,[{20070017,1},{14010105,1},{14020205,1}]}]'),(3,5,'小熊鼓手',2,12,999,'2019-08-09 00:00:00','2019-08-10 21:59:59',2,'[{1,[{0,38180015,25}],1},{10,[{0,38180015,200}],10}]','[{is_show,1},{reward_show,1011},{stage_clear_close,1},{tv_show,[{20070018,1},{14010105,1},{14020205,1}]}]'),(3,6,'海底世界冲榜',2,12,999,'2019-08-11 00:00:00','2019-08-12 21:59:59',2,'[{1,[{0,38180015,25}],1},{10,[{0,38180015,200}],10}]','[{is_show,1},{reward_show,1013},{stage_clear_close,1},{tv_show,[{20070012,1},{14010105,1},{14020205,1}]}]'),(3,7,'圣月罗盘冲榜',2,12,999,'2019-08-15 00:00:00','2019-08-16 21:59:59',2,'[{1,[{0,38180015,25}],1},{10,[{0,38180015,200}],10}]','[{is_show,1},{reward_show,1008},{stage_clear_close,1},{tv_show,[{20070015,1},{14010105,1},{14020205,1}]}]'),(3,8,'长耳兔',2,12,999,'2019-08-17 00:00:00','2019-08-18 21:59:59',2,'[{1,[{0,38180015,25}],1},{10,[{0,38180015,200}],10}]','[{is_show,1},{reward_show,1009},{stage_clear_close,1},{tv_show,[{20070016,1},{14010105,1},{14020205,1}]}]'),(3,9,'海底世界冲榜',1,6,7,'','',2,'[{1,[{0,38180015,25}],1},{10,[{0,38180015,200}],10}]','[{is_show,1},{reward_show,1013},{stage_clear_close,1},{tv_show,[{20070012,1},{14010105,1},{14020205,1}]}]'),(3,10,'圣月罗盘冲榜',1,8,9,'','',2,'[{1,[{0,38180015,25}],1},{10,[{0,38180015,200}],10}]','[{is_show,1},{reward_show,1008},{stage_clear_close,1},{tv_show,[{20070015,1},{14010105,1},{14020205,1}]}]');
/*!40000 ALTER TABLE `base_race_act_info` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_race_act_rank_reward`
--

DROP TABLE IF EXISTS `base_race_act_rank_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_race_act_rank_reward` (
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `sub_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '次类型',
  `reward_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励id',
  `rank_min` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名下限',
  `rank_max` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名上限',
  `limit_val` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最低上榜值',
  `reward` varchar(1024) NOT NULL DEFAULT '''[]''' COMMENT '奖励内容',
  PRIMARY KEY (`type`,`sub_type`,`reward_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_race_act_rank_reward`
--

LOCK TABLES `base_race_act_rank_reward` WRITE;
/*!40000 ALTER TABLE `base_race_act_rank_reward` DISABLE KEYS */;
INSERT INTO `base_race_act_rank_reward` VALUES (1,1,1,1,1,400,'[{0,16030004,1},{0,16020001,120},{0,16020001,2},{0,16020001,1}]'),(1,1,2,2,2,350,'[{0,16020001,105}]'),(1,1,3,3,3,300,'[{0,16020001,90}]'),(1,1,4,4,4,250,'[{0,16020001,83}]'),(1,1,5,5,5,200,'[{0,16020001,75}]'),(1,1,6,6,6,180,'[{0,16020001,68}]'),(1,1,7,7,7,160,'[{0,16020001,60}]'),(1,1,8,8,8,140,'[{0,16020001,53}]'),(1,1,9,9,9,120,'[{0,16020001,45}]'),(1,1,10,10,10,100,'[{0,16020001,38}]'),(1,1,11,11,20,80,'[{0,16020001,30}]'),(1,1,12,21,30,50,'[{0,16020001,22}]'),(1,1,13,31,40,30,'[{0,16020001,15}]'),(1,1,14,41,50,10,'[{0,16020001,8}]'),(2,1,1,1,1,400,'[{career,[{1,0,53040104,50},{2,0,53040204,50},{4,0,53040404,50}]},{0,53020020,50},{0,4917004,1}]'),(2,1,2,2,2,320,'[{career,[{1,0,53040104,45},{2,0,53040204,45},{4,0,53040404,45}]},{0,53020020,45}]'),(2,1,3,3,3,300,'[{career,[{1,0,53040104,40},{2,0,53040204,40},{4,0,53040404,40}]},{0,53020020,40}]'),(2,1,4,4,4,250,'[{career,[{1,0,53040104,35},{2,0,53040204,35},{4,0,53040404,35}]},{0,53020020,35}]'),(2,1,5,5,5,220,'[{career,[{1,0,53040104,30},{2,0,53040204,30},{4,0,53040404,30}]},{0,53020020,30}]'),(2,1,6,6,6,200,'[{career,[{1,0,53040104,28},{2,0,53040204,28},{4,0,53040404,28}]},{0,53020020,28}]'),(2,1,7,7,7,160,'[{career,[{1,0,53040104,25},{2,0,53040204,25},{4,0,53040404,25}]},{0,53020020,25}]'),(2,1,8,8,8,150,'[{career,[{1,0,53040104,22},{2,0,53040204,22},{4,0,53040404,22}]},{0,53020020,22}]'),(2,1,9,9,9,120,'[{career,[{1,0,53040104,20},{2,0,53040204,20},{4,0,53040404,20}]},{0,53020020,20}]'),(2,1,10,10,10,100,'[{career,[{1,0,53040104,15},{2,0,53040204,15},{4,0,53040404,15}]},{0,53020020,15}]'),(2,1,11,11,20,80,'[{career,[{1,0,53040104,10},{2,0,53040204,10},{4,0,53040404,10}]},{0,53020020,10}]'),(2,1,12,21,30,50,'[{career,[{1,0,53040104,5},{2,0,53040204,5},{4,0,53040404,5}]},{0,53020020,5}]'),(2,1,13,31,40,20,'[{career,[{1,0,53040104,3},{2,0,53040204,3},{4,0,53040404,3}]},{0,53020020,3}]'),(2,1,14,41,50,10,'[{career,[{1,0,53040104,2},{2,0,53040204,2},{4,0,53040404,2}]},{0,53020020,2}]'),(2,2,1,1,1,400,'[{career,[{1,0,53040104,50},{2,0,53040204,50},{4,0,53040404,50}]},{0,53020020,50},{0,4917004,1}]'),(2,2,2,2,2,320,'[{career,[{1,0,53040104,45},{2,0,53040204,45},{4,0,53040404,45}]},{0,53020020,45}]'),(2,2,3,3,3,300,'[{career,[{1,0,53040104,40},{2,0,53040204,40},{4,0,53040404,40}]},{0,53020020,40}]'),(2,2,4,4,4,250,'[{career,[{1,0,53040104,35},{2,0,53040204,35},{4,0,53040404,35}]},{0,53020020,35}]'),(2,2,5,5,5,220,'[{career,[{1,0,53040104,30},{2,0,53040204,30},{4,0,53040404,30}]},{0,53020020,30}]'),(2,2,6,6,6,200,'[{career,[{1,0,53040104,28},{2,0,53040204,28},{4,0,53040404,28}]},{0,53020020,28}]'),(2,2,7,7,7,160,'[{career,[{1,0,53040104,25},{2,0,53040204,25},{4,0,53040404,25}]},{0,53020020,25}]'),(2,2,8,8,8,150,'[{career,[{1,0,53040104,22},{2,0,53040204,22},{4,0,53040404,22}]},{0,53020020,22}]'),(2,2,9,9,9,120,'[{career,[{1,0,53040104,20},{2,0,53040204,20},{4,0,53040404,20}]},{0,53020020,20}]'),(2,2,10,10,10,100,'[{career,[{1,0,53040104,15},{2,0,53040204,15},{4,0,53040404,15}]},{0,53020020,15}]'),(2,2,11,11,20,80,'[{career,[{1,0,53040104,10},{2,0,53040204,10},{4,0,53040404,10}]},{0,53020020,10}]'),(2,2,12,21,30,50,'[{career,[{1,0,53040104,5},{2,0,53040204,5},{4,0,53040404,5}]},{0,53020020,5}]'),(2,2,13,31,40,20,'[{career,[{1,0,53040104,3},{2,0,53040204,3},{4,0,53040404,3}]},{0,53020020,3}]'),(2,2,14,41,50,10,'[{career,[{1,0,53040104,2},{2,0,53040204,2},{4,0,53040404,2}]},{0,53020020,2}]'),(2,3,1,1,1,400,'[{career,[{1,0,53040104,50},{2,0,53040204,50},{4,0,53040404,50}]},{0,53020020,50},{0,4917004,1}]'),(2,3,2,2,2,320,'[{career,[{1,0,53040104,45},{2,0,53040204,45},{4,0,53040404,45}]},{0,53020020,45}]'),(2,3,3,3,3,300,'[{career,[{1,0,53040104,40},{2,0,53040204,40},{4,0,53040404,40}]},{0,53020020,40}]'),(2,3,4,4,4,250,'[{career,[{1,0,53040104,35},{2,0,53040204,35},{4,0,53040404,35}]},{0,53020020,35}]'),(2,3,5,5,5,220,'[{career,[{1,0,53040104,30},{2,0,53040204,30},{4,0,53040404,30}]},{0,53020020,30}]'),(2,3,6,6,6,200,'[{career,[{1,0,53040104,28},{2,0,53040204,28},{4,0,53040404,28}]},{0,53020020,28}]'),(2,3,7,7,7,160,'[{career,[{1,0,53040104,25},{2,0,53040204,25},{4,0,53040404,25}]},{0,53020020,25}]'),(2,3,8,8,8,150,'[{career,[{1,0,53040104,22},{2,0,53040204,22},{4,0,53040404,22}]},{0,53020020,22}]'),(2,3,9,9,9,120,'[{career,[{1,0,53040104,20},{2,0,53040204,20},{4,0,53040404,20}]},{0,53020020,20}]'),(2,3,10,10,10,100,'[{career,[{1,0,53040104,15},{2,0,53040204,15},{4,0,53040404,15}]},{0,53020020,15}]'),(2,3,11,11,20,80,'[{career,[{1,0,53040104,10},{2,0,53040204,10},{4,0,53040404,10}]},{0,53020020,10}]'),(2,3,12,21,30,50,'[{career,[{1,0,53040104,5},{2,0,53040204,5},{4,0,53040404,5}]},{0,53020020,5}]'),(2,3,13,31,40,20,'[{career,[{1,0,53040104,3},{2,0,53040204,3},{4,0,53040404,3}]},{0,53020020,3}]'),(2,3,14,41,50,10,'[{career,[{1,0,53040104,2},{2,0,53040204,2},{4,0,53040404,2}]},{0,53020020,2}]'),(2,4,1,1,1,400,'[{career,[{1,0,53040104,50},{2,0,53040204,50},{4,0,53040404,50}]},{0,53020020,50},{0,4917004,1}]'),(2,4,2,2,2,320,'[{career,[{1,0,53040104,45},{2,0,53040204,45},{4,0,53040404,45}]},{0,53020020,45}]'),(2,4,3,3,3,300,'[{career,[{1,0,53040104,40},{2,0,53040204,40},{4,0,53040404,40}]},{0,53020020,40}]'),(2,4,4,4,4,250,'[{career,[{1,0,53040104,35},{2,0,53040204,35},{4,0,53040404,35}]},{0,53020020,35}]'),(2,4,5,5,5,220,'[{career,[{1,0,53040104,30},{2,0,53040204,30},{4,0,53040404,30}]},{0,53020020,30}]'),(2,4,6,6,6,200,'[{career,[{1,0,53040104,28},{2,0,53040204,28},{4,0,53040404,28}]},{0,53020020,28}]'),(2,4,7,7,7,160,'[{career,[{1,0,53040104,25},{2,0,53040204,25},{4,0,53040404,25}]},{0,53020020,25}]'),(2,4,8,8,8,150,'[{career,[{1,0,53040104,22},{2,0,53040204,22},{4,0,53040404,22}]},{0,53020020,22}]'),(2,4,9,9,9,120,'[{career,[{1,0,53040104,20},{2,0,53040204,20},{4,0,53040404,20}]},{0,53020020,20}]'),(2,4,10,10,10,100,'[{career,[{1,0,53040104,15},{2,0,53040204,15},{4,0,53040404,15}]},{0,53020020,15}]'),(2,4,11,11,20,80,'[{career,[{1,0,53040104,10},{2,0,53040204,10},{4,0,53040404,10}]},{0,53020020,10}]'),(2,4,12,21,30,50,'[{career,[{1,0,53040104,5},{2,0,53040204,5},{4,0,53040404,5}]},{0,53020020,5}]'),(2,4,13,31,40,20,'[{career,[{1,0,53040104,3},{2,0,53040204,3},{4,0,53040404,3}]},{0,53020020,3}]'),(2,4,14,41,50,10,'[{career,[{1,0,53040104,2},{2,0,53040204,2},{4,0,53040404,2}]},{0,53020020,2}]'),(2,5,1,1,1,400,'[{career,[{1,0,53040104,50},{2,0,53040204,50},{4,0,53040404,50}]},{0,53020020,50},{0,4917004,1}]'),(2,5,2,2,2,320,'[{career,[{1,0,53040104,45},{2,0,53040204,45},{4,0,53040404,45}]},{0,53020020,45}]'),(2,5,3,3,3,300,'[{career,[{1,0,53040104,40},{2,0,53040204,40},{4,0,53040404,40}]},{0,53020020,40}]'),(2,5,4,4,4,250,'[{career,[{1,0,53040104,35},{2,0,53040204,35},{4,0,53040404,35}]},{0,53020020,35}]'),(2,5,5,5,5,220,'[{career,[{1,0,53040104,30},{2,0,53040204,30},{4,0,53040404,30}]},{0,53020020,30}]'),(2,5,6,6,6,200,'[{career,[{1,0,53040104,28},{2,0,53040204,28},{4,0,53040404,28}]},{0,53020020,28}]'),(2,5,7,7,7,160,'[{career,[{1,0,53040104,25},{2,0,53040204,25},{4,0,53040404,25}]},{0,53020020,25}]'),(2,5,8,8,8,150,'[{career,[{1,0,53040104,22},{2,0,53040204,22},{4,0,53040404,22}]},{0,53020020,22}]'),(2,5,9,9,9,120,'[{career,[{1,0,53040104,20},{2,0,53040204,20},{4,0,53040404,20}]},{0,53020020,20}]'),(2,5,10,10,10,100,'[{career,[{1,0,53040104,15},{2,0,53040204,15},{4,0,53040404,15}]},{0,53020020,15}]'),(2,5,11,11,20,80,'[{career,[{1,0,53040104,10},{2,0,53040204,10},{4,0,53040404,10}]},{0,53020020,10}]'),(2,5,12,21,30,50,'[{career,[{1,0,53040104,5},{2,0,53040204,5},{4,0,53040404,5}]},{0,53020020,5}]'),(2,5,13,31,40,20,'[{career,[{1,0,53040104,3},{2,0,53040204,3},{4,0,53040404,3}]},{0,53020020,3}]'),(2,5,14,41,50,10,'[{career,[{1,0,53040104,2},{2,0,53040204,2},{4,0,53040404,2}]},{0,53020020,2}]'),(3,1,1,1,1,400,'[{0,20070012,50},{0,20060002,50},{0,4917005,1}]'),(3,1,2,2,2,320,'[{0,20070012,45},{0,20060002,45}]'),(3,1,3,3,3,300,'[{0,20070012,40},{0,20060002,40}]'),(3,1,4,4,4,250,'[{0,20070012,35},{0,20060002,35}]'),(3,1,5,5,5,220,'[{0,20070012,30},{0,20060002,30}]'),(3,1,6,6,6,200,'[{0,20070012,28},{0,20060002,28}]'),(3,1,7,7,7,160,'[{0,20070012,25},{0,20060002,25}]'),(3,1,8,8,8,150,'[{0,20070012,22},{0,20060002,22}]'),(3,1,9,9,9,120,'[{0,20070012,20},{0,20060002,20}]'),(3,1,10,10,10,100,'[{0,20070012,15},{0,20060002,15}]'),(3,1,11,11,20,80,'[{0,20070012,10},{0,20060002,10}]'),(3,1,12,21,30,50,'[{0,20070012,5},{0,20060002,5}]'),(3,1,13,31,40,20,'[{0,20070012,3},{0,20060002,3}]'),(3,1,14,41,50,10,'[{0,20070012,2},{0,20060002,2}]'),(3,2,1,1,1,400,'[{0,20070015,50},{0,20060002,50},{0,4917006,1}]'),(3,2,2,2,2,320,'[{0,20070015,45},{0,20060002,45}]'),(3,2,3,3,3,300,'[{0,20070015,40},{0,20060002,40}]'),(3,2,4,4,4,250,'[{0,20070015,35},{0,20060002,35}]'),(3,2,5,5,5,220,'[{0,20070015,30},{0,20060002,30}]'),(3,2,6,6,6,200,'[{0,20070015,28},{0,20060002,28}]'),(3,2,7,7,7,160,'[{0,20070015,25},{0,20060002,25}]'),(3,2,8,8,8,150,'[{0,20070015,22},{0,20060002,22}]'),(3,2,9,9,9,120,'[{0,20070015,20},{0,20060002,20}]'),(3,2,10,10,10,100,'[{0,20070015,15},{0,20060002,15}]'),(3,2,11,11,20,80,'[{0,20070015,10},{0,20060002,10}]'),(3,2,12,21,30,50,'[{0,20070015,5},{0,20060002,5}]'),(3,2,13,31,40,20,'[{0,20070015,3},{0,20060002,3}]'),(3,2,14,41,50,10,'[{0,20070015,2},{0,20060002,2}]'),(3,3,1,1,1,400,'[{0,20070016,50},{0,20060002,50},{0,4917007,1}]'),(3,3,2,2,2,320,'[{0,20070016,45},{0,20060002,45}]'),(3,3,3,3,3,300,'[{0,20070016,40},{0,20060002,40}]'),(3,3,4,4,4,250,'[{0,20070016,35},{0,20060002,35}]'),(3,3,5,5,5,220,'[{0,20070016,30},{0,20060002,30}]'),(3,3,6,6,6,200,'[{0,20070016,28},{0,20060002,28}]'),(3,3,7,7,7,160,'[{0,20070016,25},{0,20060002,25}]'),(3,3,8,8,8,150,'[{0,20070016,22},{0,20060002,22}]'),(3,3,9,9,9,120,'[{0,20070016,20},{0,20060002,20}]'),(3,3,10,10,10,100,'[{0,20070016,15},{0,20060002,15}]'),(3,3,11,11,20,80,'[{0,20070016,10},{0,20060002,10}]'),(3,3,12,21,30,50,'[{0,20070016,5},{0,20060002,5}]'),(3,3,13,31,40,20,'[{0,20070016,3},{0,20060002,3}]'),(3,3,14,41,50,10,'[{0,20070016,2},{0,20060002,2}]'),(3,4,1,1,1,400,'[{0,20070017,50},{0,20060002,50},{0,4917008,1}]'),(3,4,2,2,2,320,'[{0,20070017,45},{0,20060002,45}]'),(3,4,3,3,3,300,'[{0,20070017,40},{0,20060002,40}]'),(3,4,4,4,4,250,'[{0,20070017,35},{0,20060002,35}]'),(3,4,5,5,5,220,'[{0,20070017,30},{0,20060002,30}]'),(3,4,6,6,6,200,'[{0,20070017,28},{0,20060002,28}]'),(3,4,7,7,7,160,'[{0,20070017,25},{0,20060002,25}]'),(3,4,8,8,8,150,'[{0,20070017,22},{0,20060002,22}]'),(3,4,9,9,9,120,'[{0,20070017,20},{0,20060002,20}]'),(3,4,10,10,10,100,'[{0,20070017,15},{0,20060002,15}]'),(3,4,11,11,20,80,'[{0,20070017,10},{0,20060002,10}]'),(3,4,12,21,30,50,'[{0,20070017,5},{0,20060002,5}]'),(3,4,13,31,40,20,'[{0,20070017,3},{0,20060002,3}]'),(3,4,14,41,50,10,'[{0,20070017,2},{0,20060002,2}]'),(3,5,1,1,1,400,'[{0,20070018,50},{0,20060002,50},{0,4917009,1}]'),(3,5,2,2,2,320,'[{0,20070018,45},{0,20060002,45}]'),(3,5,3,3,3,300,'[{0,20070018,40},{0,20060002,40}]'),(3,5,4,4,4,250,'[{0,20070018,35},{0,20060002,35}]'),(3,5,5,5,5,220,'[{0,20070018,30},{0,20060002,30}]'),(3,5,6,6,6,200,'[{0,20070018,28},{0,20060002,28}]'),(3,5,7,7,7,160,'[{0,20070018,25},{0,20060002,25}]'),(3,5,8,8,8,150,'[{0,20070018,22},{0,20060002,22}]'),(3,5,9,9,9,120,'[{0,20070018,20},{0,20060002,20}]'),(3,5,10,10,10,100,'[{0,20070018,15},{0,20060002,15}]'),(3,5,11,11,20,80,'[{0,20070018,10},{0,20060002,10}]'),(3,5,12,21,30,50,'[{0,20070018,5},{0,20060002,5}]'),(3,5,13,31,40,20,'[{0,20070018,3},{0,20060002,3}]'),(3,5,14,41,50,10,'[{0,20070018,2},{0,20060002,2}]'),(3,6,1,1,1,400,'[{0,20070012,50},{0,20060002,50},{0,4917005,1}]'),(3,6,2,2,2,320,'[{0,20070012,45},{0,20060002,45}]'),(3,6,3,3,3,300,'[{0,20070012,40},{0,20060002,40}]'),(3,6,4,4,4,250,'[{0,20070012,35},{0,20060002,35}]'),(3,6,5,5,5,220,'[{0,20070012,30},{0,20060002,30}]'),(3,6,6,6,6,200,'[{0,20070012,28},{0,20060002,28}]'),(3,6,7,7,7,160,'[{0,20070012,25},{0,20060002,25}]'),(3,6,8,8,8,150,'[{0,20070012,22},{0,20060002,22}]'),(3,6,9,9,9,120,'[{0,20070012,20},{0,20060002,20}]'),(3,6,10,10,10,100,'[{0,20070012,15},{0,20060002,15}]'),(3,6,11,11,20,80,'[{0,20070012,10},{0,20060002,10}]'),(3,6,12,21,30,50,'[{0,20070012,5},{0,20060002,5}]'),(3,6,13,31,40,20,'[{0,20070012,3},{0,20060002,3}]'),(3,6,14,41,50,10,'[{0,20070012,2},{0,20060002,2}]'),(3,7,1,1,1,400,'[{0,20070015,50},{0,20060002,50},{0,4917006,1}]'),(3,7,2,2,2,320,'[{0,20070015,45},{0,20060002,45}]'),(3,7,3,3,3,300,'[{0,20070015,40},{0,20060002,40}]'),(3,7,4,4,4,250,'[{0,20070015,35},{0,20060002,35}]'),(3,7,5,5,5,220,'[{0,20070015,30},{0,20060002,30}]'),(3,7,6,6,6,200,'[{0,20070015,28},{0,20060002,28}]'),(3,7,7,7,7,160,'[{0,20070015,25},{0,20060002,25}]'),(3,7,8,8,8,150,'[{0,20070015,22},{0,20060002,22}]'),(3,7,9,9,9,120,'[{0,20070015,20},{0,20060002,20}]'),(3,7,10,10,10,100,'[{0,20070015,15},{0,20060002,15}]'),(3,7,11,11,20,80,'[{0,20070015,10},{0,20060002,10}]'),(3,7,12,21,30,50,'[{0,20070015,5},{0,20060002,5}]'),(3,7,13,31,40,20,'[{0,20070015,3},{0,20060002,3}]'),(3,7,14,41,50,10,'[{0,20070015,2},{0,20060002,2}]'),(3,8,1,1,1,400,'[{0,20070016,50},{0,20060002,50},{0,4917007,1}]'),(3,8,2,2,2,320,'[{0,20070016,45},{0,20060002,45}]'),(3,8,3,3,3,300,'[{0,20070016,40},{0,20060002,40}]'),(3,8,4,4,4,250,'[{0,20070016,35},{0,20060002,35}]'),(3,8,5,5,5,220,'[{0,20070016,30},{0,20060002,30}]'),(3,8,6,6,6,200,'[{0,20070016,28},{0,20060002,28}]'),(3,8,7,7,7,160,'[{0,20070016,25},{0,20060002,25}]'),(3,8,8,8,8,150,'[{0,20070016,22},{0,20060002,22}]'),(3,8,9,9,9,120,'[{0,20070016,20},{0,20060002,20}]'),(3,8,10,10,10,100,'[{0,20070016,15},{0,20060002,15}]'),(3,8,11,11,20,80,'[{0,20070016,10},{0,20060002,10}]'),(3,8,12,21,30,50,'[{0,20070016,5},{0,20060002,5}]'),(3,8,13,31,40,20,'[{0,20070016,3},{0,20060002,3}]'),(3,8,14,41,50,10,'[{0,20070016,2},{0,20060002,2}]'),(3,9,1,1,1,400,'[{0,20070012,50},{0,20060002,50},{0,4917005,1}]'),(3,9,2,2,2,320,'[{0,20070012,45},{0,20060002,45}]'),(3,9,3,3,3,300,'[{0,20070012,40},{0,20060002,40}]'),(3,9,4,4,4,250,'[{0,20070012,35},{0,20060002,35}]'),(3,9,5,5,5,220,'[{0,20070012,30},{0,20060002,30}]'),(3,9,6,6,6,200,'[{0,20070012,28},{0,20060002,28}]'),(3,9,7,7,7,160,'[{0,20070012,25},{0,20060002,25}]'),(3,9,8,8,8,150,'[{0,20070012,22},{0,20060002,22}]'),(3,9,9,9,9,120,'[{0,20070012,20},{0,20060002,20}]'),(3,9,10,10,10,100,'[{0,20070012,15},{0,20060002,15}]'),(3,9,11,11,20,80,'[{0,20070012,10},{0,20060002,10}]'),(3,9,12,21,30,50,'[{0,20070012,5},{0,20060002,5}]'),(3,9,13,31,40,20,'[{0,20070012,3},{0,20060002,3}]'),(3,9,14,41,50,10,'[{0,20070012,2},{0,20060002,2}]'),(3,10,1,1,1,400,'[{0,20070015,50},{0,20060002,50},{0,4917006,1}]'),(3,10,2,2,2,320,'[{0,20070015,45},{0,20060002,45}]'),(3,10,3,3,3,300,'[{0,20070015,40},{0,20060002,40}]'),(3,10,4,4,4,250,'[{0,20070015,35},{0,20060002,35}]'),(3,10,5,5,5,220,'[{0,20070015,30},{0,20060002,30}]'),(3,10,6,6,6,200,'[{0,20070015,28},{0,20060002,28}]'),(3,10,7,7,7,160,'[{0,20070015,25},{0,20060002,25}]'),(3,10,8,8,8,150,'[{0,20070015,22},{0,20060002,22}]'),(3,10,9,9,9,120,'[{0,20070015,20},{0,20060002,20}]'),(3,10,10,10,10,100,'[{0,20070015,15},{0,20060002,15}]'),(3,10,11,11,20,80,'[{0,20070015,10},{0,20060002,10}]'),(3,10,12,21,30,50,'[{0,20070015,5},{0,20060002,5}]'),(3,10,13,31,40,20,'[{0,20070015,3},{0,20060002,3}]'),(3,10,14,41,50,10,'[{0,20070015,2},{0,20060002,2}]');
/*!40000 ALTER TABLE `base_race_act_rank_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_race_act_reward`
--

DROP TABLE IF EXISTS `base_race_act_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_race_act_reward` (
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `sub_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '次类型',
  `cost_type` int(11) unsigned NOT NULL DEFAULT '1' COMMENT '奖池类型',
  `reward_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励id',
  `reward` varchar(1024) NOT NULL DEFAULT '''[]''' COMMENT '奖励内容',
  `ratio` int(11) NOT NULL DEFAULT '0' COMMENT '概率显示',
  `condition` varchar(1024) NOT NULL DEFAULT '''[]''' COMMENT '条件',
  PRIMARY KEY (`type`,`sub_type`,`cost_type`,`reward_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_race_act_reward`
--

LOCK TABLES `base_race_act_reward` WRITE;
/*!40000 ALTER TABLE `base_race_act_reward` DISABLE KEYS */;
INSERT INTO `base_race_act_reward` VALUES (1,1,1,1,'[{0,14010101,1}]',50,'[1,1,10,10,10]'),(1,1,1,2,'[{0,16020001,1}]',10,'[1,1,10,10,15]'),(1,1,1,3,'[{0,16020002,1}]',15,'[1,1,10,10,20]'),(1,1,1,4,'[{0,16010001,1}]',10,'[1,1,10,10,25]'),(1,1,1,5,'[{0,16010002,1}]',20,'[1,1,10,10,30]'),(1,1,1,6,'[{0,38040010,2}]',30,'[1,1,10,10,30]'),(1,1,1,7,'[{0,16030004,1}]',1,'[1,1,2,10,30]'),(2,1,1,1,'[{career,[{1,0,53040104,30},{2,0,53040204,30},{4,0,53040404,30}]}]',10,'[1,1,10,0,0]'),(2,1,1,2,'[{career,[{1,0,53040104,15},{2,0,53040204,15},{4,0,53040404,15}]}]',10,'[1,1,10,0,0]'),(2,1,1,3,'[{career,[{1,0,53040104,5},{2,0,53040204,5},{4,0,53040404,5}]}]',15,'[1,1,15,0,0]'),(2,1,1,4,'[{career,[{1,0,53040104,3},{2,0,53040204,3},{4,0,53040404,3}]}]',25,'[1,1,25,0,0]'),(2,1,1,5,'[{career,[{1,0,53040104,2},{2,0,53040204,2},{4,0,53040404,2}]}]',40,'[1,1,40,0,0]'),(2,1,1,6,'[{career,[{1,0,53040104,1},{2,0,53040204,1},{4,0,53040404,1}]}]',100,'[1,1,100,0,0]'),(2,1,1,7,'[{0,14010105,1}]',10,'[1,1,10,0,0]'),(2,1,1,8,'[{0,14020205,1}]',10,'[1,1,10,0,0]'),(2,1,1,9,'[{0,16010001,1}]',150,'[1,1,150,0,0]'),(2,1,1,10,'[{0,16010002,1}]',120,'[1,1,120,0,0]'),(2,1,1,11,'[{0,24020001,1}]',120,'[1,1,120,0,0]'),(2,1,1,12,'[{0,24020002,1}]',120,'[1,1,120,0,0]'),(2,1,1,13,'[{0,20060003,1}]',120,'[1,1,120,0,0]'),(2,1,1,14,'[{0,18020001,6}]',200,'[1,1,200,0,0]'),(2,1,1,15,'[{0,14010102,1}]',250,'[1,1,250,0,0]'),(2,1,1,16,'[{0,14020202,1}]',250,'[1,1,250,0,0]'),(2,1,1,17,'[{0,40010011,2}]',750,'[1,1,750,0,0]'),(2,1,1,18,'[{0,15020101,2}]',250,'[1,1,250,0,0]'),(2,1,1,19,'[{0,38260001,4}]',250,'[1,1,250,0,0]'),(2,1,1,20,'[{0,37020002,1}]',100,'[1,1,100,0,0]'),(2,1,1,21,'[{0,18020001,3}]',400,'[1,1,400,0,0]'),(2,1,1,22,'[{0,5203003,1}]',400,'[1,1,400,0,0]'),(2,1,1,23,'[{0,38100009,2}]',600,'[1,1,600,0,0]'),(2,1,1,24,'[{0,20060001,3}]',500,'[1,1,500,0,0]'),(2,1,1,25,'[{0,24010001,3}]',500,'[1,1,500,0,0]'),(2,1,1,26,'[{0,38260001,2}]',1800,'[1,1,1800,0,0]'),(2,1,1,27,'[{0,16020001,2}]',1000,'[1,1,1000,0,0]'),(2,1,1,28,'[{0,11020001,3}]',1000,'[1,1,1000,0,0]'),(2,1,1,29,'[{0,38070002,1}]',200,'[1,1,200,0,0]'),(2,1,1,30,'[{0,15020301,2}]',200,'[1,1,200,0,0]'),(2,1,1,31,'[{0,37020001,2}]',500,'[1,1,500,0,0]'),(2,2,1,1,'[{career,[{1,0,53040104,30},{2,0,53040204,30},{4,0,53040404,30}]}]',10,'[1,1,10,0,0]'),(2,2,1,2,'[{career,[{1,0,53040104,15},{2,0,53040204,15},{4,0,53040404,15}]}]',10,'[1,1,10,0,0]'),(2,2,1,3,'[{career,[{1,0,53040104,5},{2,0,53040204,5},{4,0,53040404,5}]}]',15,'[1,1,15,0,0]'),(2,2,1,4,'[{career,[{1,0,53040104,3},{2,0,53040204,3},{4,0,53040404,3}]}]',25,'[1,1,25,0,0]'),(2,2,1,5,'[{career,[{1,0,53040104,2},{2,0,53040204,2},{4,0,53040404,2}]}]',40,'[1,1,40,0,0]'),(2,2,1,6,'[{career,[{1,0,53040104,1},{2,0,53040204,1},{4,0,53040404,1}]}]',100,'[1,1,100,0,0]'),(2,2,1,7,'[{0,14010105,1}]',10,'[1,1,10,0,0]'),(2,2,1,8,'[{0,14020205,1}]',10,'[1,1,10,0,0]'),(2,2,1,9,'[{0,16010001,1}]',150,'[1,1,150,0,0]'),(2,2,1,10,'[{0,16010002,1}]',120,'[1,1,120,0,0]'),(2,2,1,11,'[{0,24020001,1}]',120,'[1,1,120,0,0]'),(2,2,1,12,'[{0,24020002,1}]',120,'[1,1,120,0,0]'),(2,2,1,13,'[{0,20060003,1}]',120,'[1,1,120,0,0]'),(2,2,1,14,'[{0,18020001,6}]',200,'[1,1,200,0,0]'),(2,2,1,15,'[{0,14010102,1}]',250,'[1,1,250,0,0]'),(2,2,1,16,'[{0,14020202,1}]',250,'[1,1,250,0,0]'),(2,2,1,17,'[{0,40010011,2}]',750,'[1,1,750,0,0]'),(2,2,1,18,'[{0,15020101,2}]',250,'[1,1,250,0,0]'),(2,2,1,19,'[{0,38260001,4}]',250,'[1,1,250,0,0]'),(2,2,1,20,'[{0,37020002,1}]',100,'[1,1,100,0,0]'),(2,2,1,21,'[{0,18020001,3}]',400,'[1,1,400,0,0]'),(2,2,1,22,'[{0,5203003,1}]',400,'[1,1,400,0,0]'),(2,2,1,23,'[{0,38100009,2}]',600,'[1,1,600,0,0]'),(2,2,1,24,'[{0,20060001,3}]',500,'[1,1,500,0,0]'),(2,2,1,25,'[{0,24010001,3}]',500,'[1,1,500,0,0]'),(2,2,1,26,'[{0,38260001,2}]',1800,'[1,1,1800,0,0]'),(2,2,1,27,'[{0,16020001,2}]',1000,'[1,1,1000,0,0]'),(2,2,1,28,'[{0,11020001,3}]',1000,'[1,1,1000,0,0]'),(2,2,1,29,'[{0,38070002,1}]',200,'[1,1,200,0,0]'),(2,2,1,30,'[{0,15020301,2}]',200,'[1,1,200,0,0]'),(2,2,1,31,'[{0,37020001,2}]',500,'[1,1,500,0,0]'),(2,3,1,1,'[{career,[{1,0,53040104,30},{2,0,53040204,30},{4,0,53040404,30}]}]',10,'[1,1,10,0,0]'),(2,3,1,2,'[{career,[{1,0,53040104,15},{2,0,53040204,15},{4,0,53040404,15}]}]',10,'[1,1,10,0,0]'),(2,3,1,3,'[{career,[{1,0,53040104,5},{2,0,53040204,5},{4,0,53040404,5}]}]',15,'[1,1,15,0,0]'),(2,3,1,4,'[{career,[{1,0,53040104,3},{2,0,53040204,3},{4,0,53040404,3}]}]',25,'[1,1,25,0,0]'),(2,3,1,5,'[{career,[{1,0,53040104,2},{2,0,53040204,2},{4,0,53040404,2}]}]',40,'[1,1,40,0,0]'),(2,3,1,6,'[{career,[{1,0,53040104,1},{2,0,53040204,1},{4,0,53040404,1}]}]',100,'[1,1,100,0,0]'),(2,3,1,7,'[{0,14010105,1}]',10,'[1,1,10,0,0]'),(2,3,1,8,'[{0,14020205,1}]',10,'[1,1,10,0,0]'),(2,3,1,9,'[{0,16010001,1}]',150,'[1,1,150,0,0]'),(2,3,1,10,'[{0,16010002,1}]',120,'[1,1,120,0,0]'),(2,3,1,11,'[{0,24020001,1}]',120,'[1,1,120,0,0]'),(2,3,1,12,'[{0,24020002,1}]',120,'[1,1,120,0,0]'),(2,3,1,13,'[{0,20060003,1}]',120,'[1,1,120,0,0]'),(2,3,1,14,'[{0,18020001,6}]',200,'[1,1,200,0,0]'),(2,3,1,15,'[{0,14010102,1}]',250,'[1,1,250,0,0]'),(2,3,1,16,'[{0,14020202,1}]',250,'[1,1,250,0,0]'),(2,3,1,17,'[{0,40010011,2}]',750,'[1,1,750,0,0]'),(2,3,1,18,'[{0,15020101,2}]',250,'[1,1,250,0,0]'),(2,3,1,19,'[{0,38260001,4}]',250,'[1,1,250,0,0]'),(2,3,1,20,'[{0,37020002,1}]',100,'[1,1,100,0,0]'),(2,3,1,21,'[{0,18020001,3}]',400,'[1,1,400,0,0]'),(2,3,1,22,'[{0,5203003,1}]',400,'[1,1,400,0,0]'),(2,3,1,23,'[{0,38100009,2}]',600,'[1,1,600,0,0]'),(2,3,1,24,'[{0,20060001,3}]',500,'[1,1,500,0,0]'),(2,3,1,25,'[{0,24010001,3}]',500,'[1,1,500,0,0]'),(2,3,1,26,'[{0,38260001,2}]',1800,'[1,1,1800,0,0]'),(2,3,1,27,'[{0,16020001,2}]',1000,'[1,1,1000,0,0]'),(2,3,1,28,'[{0,11020001,3}]',1000,'[1,1,1000,0,0]'),(2,3,1,29,'[{0,38070002,1}]',200,'[1,1,200,0,0]'),(2,3,1,30,'[{0,15020301,2}]',200,'[1,1,200,0,0]'),(2,3,1,31,'[{0,37020001,2}]',500,'[1,1,500,0,0]'),(2,4,1,1,'[{career,[{1,0,53040104,30},{2,0,53040204,30},{4,0,53040404,30}]}]',10,'[1,1,10,0,0]'),(2,4,1,2,'[{career,[{1,0,53040104,15},{2,0,53040204,15},{4,0,53040404,15}]}]',10,'[1,1,10,0,0]'),(2,4,1,3,'[{career,[{1,0,53040104,5},{2,0,53040204,5},{4,0,53040404,5}]}]',15,'[1,1,15,0,0]'),(2,4,1,4,'[{career,[{1,0,53040104,3},{2,0,53040204,3},{4,0,53040404,3}]}]',25,'[1,1,25,0,0]'),(2,4,1,5,'[{career,[{1,0,53040104,2},{2,0,53040204,2},{4,0,53040404,2}]}]',40,'[1,1,40,0,0]'),(2,4,1,6,'[{career,[{1,0,53040104,1},{2,0,53040204,1},{4,0,53040404,1}]}]',100,'[1,1,100,0,0]'),(2,4,1,7,'[{0,14010105,1}]',10,'[1,1,10,0,0]'),(2,4,1,8,'[{0,14020205,1}]',10,'[1,1,10,0,0]'),(2,4,1,9,'[{0,16010001,1}]',150,'[1,1,150,0,0]'),(2,4,1,10,'[{0,16010002,1}]',120,'[1,1,120,0,0]'),(2,4,1,11,'[{0,24020001,1}]',120,'[1,1,120,0,0]'),(2,4,1,12,'[{0,24020002,1}]',120,'[1,1,120,0,0]'),(2,4,1,13,'[{0,20060003,1}]',120,'[1,1,120,0,0]'),(2,4,1,14,'[{0,18020001,6}]',200,'[1,1,200,0,0]'),(2,4,1,15,'[{0,14010102,1}]',250,'[1,1,250,0,0]'),(2,4,1,16,'[{0,14020202,1}]',250,'[1,1,250,0,0]'),(2,4,1,17,'[{0,40010011,2}]',750,'[1,1,750,0,0]'),(2,4,1,18,'[{0,15020101,2}]',250,'[1,1,250,0,0]'),(2,4,1,19,'[{0,38260001,4}]',250,'[1,1,250,0,0]'),(2,4,1,20,'[{0,37020002,1}]',100,'[1,1,100,0,0]'),(2,4,1,21,'[{0,18020001,3}]',400,'[1,1,400,0,0]'),(2,4,1,22,'[{0,5203003,1}]',400,'[1,1,400,0,0]'),(2,4,1,23,'[{0,38100009,2}]',600,'[1,1,600,0,0]'),(2,4,1,24,'[{0,20060001,3}]',500,'[1,1,500,0,0]'),(2,4,1,25,'[{0,24010001,3}]',500,'[1,1,500,0,0]'),(2,4,1,26,'[{0,38260001,2}]',1800,'[1,1,1800,0,0]'),(2,4,1,27,'[{0,16020001,2}]',1000,'[1,1,1000,0,0]'),(2,4,1,28,'[{0,11020001,3}]',1000,'[1,1,1000,0,0]'),(2,4,1,29,'[{0,38070002,1}]',200,'[1,1,200,0,0]'),(2,4,1,30,'[{0,15020301,2}]',200,'[1,1,200,0,0]'),(2,4,1,31,'[{0,37020001,2}]',500,'[1,1,500,0,0]'),(2,5,1,1,'[{career,[{1,0,53040104,30},{2,0,53040204,30},{4,0,53040404,30}]}]',10,'[1,1,10,0,0]'),(2,5,1,2,'[{career,[{1,0,53040104,15},{2,0,53040204,15},{4,0,53040404,15}]}]',10,'[1,1,10,0,0]'),(2,5,1,3,'[{career,[{1,0,53040104,5},{2,0,53040204,5},{4,0,53040404,5}]}]',15,'[1,1,15,0,0]'),(2,5,1,4,'[{career,[{1,0,53040104,3},{2,0,53040204,3},{4,0,53040404,3}]}]',25,'[1,1,25,0,0]'),(2,5,1,5,'[{career,[{1,0,53040104,2},{2,0,53040204,2},{4,0,53040404,2}]}]',40,'[1,1,40,0,0]'),(2,5,1,6,'[{career,[{1,0,53040104,1},{2,0,53040204,1},{4,0,53040404,1}]}]',100,'[1,1,100,0,0]'),(2,5,1,7,'[{0,14010105,1}]',10,'[1,1,10,0,0]'),(2,5,1,8,'[{0,14020205,1}]',10,'[1,1,10,0,0]'),(2,5,1,9,'[{0,16010001,1}]',150,'[1,1,150,0,0]'),(2,5,1,10,'[{0,16010002,1}]',120,'[1,1,120,0,0]'),(2,5,1,11,'[{0,24020001,1}]',120,'[1,1,120,0,0]'),(2,5,1,12,'[{0,24020002,1}]',120,'[1,1,120,0,0]'),(2,5,1,13,'[{0,20060003,1}]',120,'[1,1,120,0,0]'),(2,5,1,14,'[{0,18020001,6}]',200,'[1,1,200,0,0]'),(2,5,1,15,'[{0,14010102,1}]',250,'[1,1,250,0,0]'),(2,5,1,16,'[{0,14020202,1}]',250,'[1,1,250,0,0]'),(2,5,1,17,'[{0,40010011,2}]',750,'[1,1,750,0,0]'),(2,5,1,18,'[{0,15020101,2}]',250,'[1,1,250,0,0]'),(2,5,1,19,'[{0,38260001,4}]',250,'[1,1,250,0,0]'),(2,5,1,20,'[{0,37020002,1}]',100,'[1,1,100,0,0]'),(2,5,1,21,'[{0,18020001,3}]',400,'[1,1,400,0,0]'),(2,5,1,22,'[{0,5203003,1}]',400,'[1,1,400,0,0]'),(2,5,1,23,'[{0,38100009,2}]',600,'[1,1,600,0,0]'),(2,5,1,24,'[{0,20060001,3}]',500,'[1,1,500,0,0]'),(2,5,1,25,'[{0,24010001,3}]',500,'[1,1,500,0,0]'),(2,5,1,26,'[{0,38260001,2}]',1800,'[1,1,1800,0,0]'),(2,5,1,27,'[{0,16020001,2}]',1000,'[1,1,1000,0,0]'),(2,5,1,28,'[{0,11020001,3}]',1000,'[1,1,1000,0,0]'),(2,5,1,29,'[{0,38070002,1}]',200,'[1,1,200,0,0]'),(2,5,1,30,'[{0,15020301,2}]',200,'[1,1,200,0,0]'),(2,5,1,31,'[{0,37020001,2}]',500,'[1,1,500,0,0]'),(3,1,1,1,'[{0,20070012,30}]',10,'[1,1,10,0,0]'),(3,1,1,2,'[{0,20070012,15}]',10,'[1,1,10,0,0]'),(3,1,1,3,'[{0,20070012,5}]',15,'[1,1,15,0,0]'),(3,1,1,4,'[{0,20070012,3}]',25,'[1,1,25,0,0]'),(3,1,1,5,'[{0,20070012,2}]',40,'[1,1,40,0,0]'),(3,1,1,6,'[{0,20070012,1}]',100,'[1,1,100,0,0]'),(3,1,1,7,'[{0,14010105,1}]',10,'[1,1,10,0,0]'),(3,1,1,8,'[{0,14020205,1}]',10,'[1,1,10,0,0]'),(3,1,1,9,'[{0,16010001,1}]',150,'[1,1,150,0,0]'),(3,1,1,10,'[{0,16010002,1}]',120,'[1,1,120,0,0]'),(3,1,1,11,'[{0,24020001,1}]',120,'[1,1,120,0,0]'),(3,1,1,12,'[{0,24020002,1}]',120,'[1,1,120,0,0]'),(3,1,1,13,'[{0,20060003,1}]',120,'[1,1,120,0,0]'),(3,1,1,14,'[{0,18020001,6}]',200,'[1,1,200,0,0]'),(3,1,1,15,'[{0,14010102,1}]',250,'[1,1,250,0,0]'),(3,1,1,16,'[{0,14020202,1}]',250,'[1,1,250,0,0]'),(3,1,1,17,'[{0,40010011,2}]',750,'[1,1,750,0,0]'),(3,1,1,18,'[{0,15020101,2}]',250,'[1,1,250,0,0]'),(3,1,1,19,'[{0,38260001,4}]',250,'[1,1,250,0,0]'),(3,1,1,20,'[{0,37020002,1}]',100,'[1,1,100,0,0]'),(3,1,1,21,'[{0,18020001,3}]',400,'[1,1,400,0,0]'),(3,1,1,22,'[{0,5203003,1}]',400,'[1,1,400,0,0]'),(3,1,1,23,'[{0,38100009,2}]',600,'[1,1,600,0,0]'),(3,1,1,24,'[{0,20060001,3}]',500,'[1,1,500,0,0]'),(3,1,1,25,'[{0,24010001,3}]',500,'[1,1,500,0,0]'),(3,1,1,26,'[{0,38260001,2}]',1800,'[1,1,1800,0,0]'),(3,1,1,27,'[{0,16020001,2}]',1000,'[1,1,1000,0,0]'),(3,1,1,28,'[{0,11020001,3}]',1000,'[1,1,1000,0,0]'),(3,1,1,29,'[{0,38070002,1}]',200,'[1,1,200,0,0]'),(3,1,1,30,'[{0,15020301,2}]',200,'[1,1,200,0,0]'),(3,1,1,31,'[{0,37020001,2}]',500,'[1,1,500,0,0]'),(3,2,1,1,'[{0,20070015,30}]',10,'[1,1,10,0,0]'),(3,2,1,2,'[{0,20070015,15}]',10,'[1,1,10,0,0]'),(3,2,1,3,'[{0,20070015,5}]',15,'[1,1,15,0,0]'),(3,2,1,4,'[{0,20070015,3}]',25,'[1,1,25,0,0]'),(3,2,1,5,'[{0,20070015,2}]',40,'[1,1,40,0,0]'),(3,2,1,6,'[{0,20070015,1}]',100,'[1,1,100,0,0]'),(3,2,1,7,'[{0,14010105,1}]',10,'[1,1,10,0,0]'),(3,2,1,8,'[{0,14020205,1}]',10,'[1,1,10,0,0]'),(3,2,1,9,'[{0,16010001,1}]',150,'[1,1,150,0,0]'),(3,2,1,10,'[{0,16010002,1}]',120,'[1,1,120,0,0]'),(3,2,1,11,'[{0,24020001,1}]',120,'[1,1,120,0,0]'),(3,2,1,12,'[{0,24020002,1}]',120,'[1,1,120,0,0]'),(3,2,1,13,'[{0,20060003,1}]',120,'[1,1,120,0,0]'),(3,2,1,14,'[{0,18020001,6}]',200,'[1,1,200,0,0]'),(3,2,1,15,'[{0,14010102,1}]',250,'[1,1,250,0,0]'),(3,2,1,16,'[{0,14020202,1}]',250,'[1,1,250,0,0]'),(3,2,1,17,'[{0,40010011,2}]',750,'[1,1,750,0,0]'),(3,2,1,18,'[{0,15020101,2}]',250,'[1,1,250,0,0]'),(3,2,1,19,'[{0,38260001,4}]',250,'[1,1,250,0,0]'),(3,2,1,20,'[{0,37020002,1}]',100,'[1,1,100,0,0]'),(3,2,1,21,'[{0,18020001,3}]',400,'[1,1,400,0,0]'),(3,2,1,22,'[{0,5203003,1}]',400,'[1,1,400,0,0]'),(3,2,1,23,'[{0,38100009,2}]',600,'[1,1,600,0,0]'),(3,2,1,24,'[{0,20060001,3}]',500,'[1,1,500,0,0]'),(3,2,1,25,'[{0,24010001,3}]',500,'[1,1,500,0,0]'),(3,2,1,26,'[{0,38260001,2}]',1800,'[1,1,1800,0,0]'),(3,2,1,27,'[{0,16020001,2}]',1000,'[1,1,1000,0,0]'),(3,2,1,28,'[{0,11020001,3}]',1000,'[1,1,1000,0,0]'),(3,2,1,29,'[{0,38070002,1}]',200,'[1,1,200,0,0]'),(3,2,1,30,'[{0,15020301,2}]',200,'[1,1,200,0,0]'),(3,2,1,31,'[{0,37020001,2}]',500,'[1,1,500,0,0]'),(3,3,1,1,'[{0,20070016,30}]',10,'[1,1,10,0,0]'),(3,3,1,2,'[{0,20070016,15}]',10,'[1,1,10,0,0]'),(3,3,1,3,'[{0,20070016,5}]',15,'[1,1,15,0,0]'),(3,3,1,4,'[{0,20070016,3}]',25,'[1,1,25,0,0]'),(3,3,1,5,'[{0,20070016,2}]',40,'[1,1,40,0,0]'),(3,3,1,6,'[{0,20070016,1}]',100,'[1,1,100,0,0]'),(3,3,1,7,'[{0,14010105,1}]',10,'[1,1,10,0,0]'),(3,3,1,8,'[{0,14020205,1}]',10,'[1,1,10,0,0]'),(3,3,1,9,'[{0,16010001,1}]',150,'[1,1,150,0,0]'),(3,3,1,10,'[{0,16010002,1}]',120,'[1,1,120,0,0]'),(3,3,1,11,'[{0,24020001,1}]',120,'[1,1,120,0,0]'),(3,3,1,12,'[{0,24020002,1}]',120,'[1,1,120,0,0]'),(3,3,1,13,'[{0,20060003,1}]',120,'[1,1,120,0,0]'),(3,3,1,14,'[{0,18020001,6}]',200,'[1,1,200,0,0]'),(3,3,1,15,'[{0,14010102,1}]',250,'[1,1,250,0,0]'),(3,3,1,16,'[{0,14020202,1}]',250,'[1,1,250,0,0]'),(3,3,1,17,'[{0,40010011,2}]',750,'[1,1,750,0,0]'),(3,3,1,18,'[{0,15020101,2}]',250,'[1,1,250,0,0]'),(3,3,1,19,'[{0,38260001,4}]',250,'[1,1,250,0,0]'),(3,3,1,20,'[{0,37020002,1}]',100,'[1,1,100,0,0]'),(3,3,1,21,'[{0,18020001,3}]',400,'[1,1,400,0,0]'),(3,3,1,22,'[{0,5203003,1}]',400,'[1,1,400,0,0]'),(3,3,1,23,'[{0,38100009,2}]',600,'[1,1,600,0,0]'),(3,3,1,24,'[{0,20060001,3}]',500,'[1,1,500,0,0]'),(3,3,1,25,'[{0,24010001,3}]',500,'[1,1,500,0,0]'),(3,3,1,26,'[{0,38260001,2}]',1800,'[1,1,1800,0,0]'),(3,3,1,27,'[{0,16020001,2}]',1000,'[1,1,1000,0,0]'),(3,3,1,28,'[{0,11020001,3}]',1000,'[1,1,1000,0,0]'),(3,3,1,29,'[{0,38070002,1}]',200,'[1,1,200,0,0]'),(3,3,1,30,'[{0,15020301,2}]',200,'[1,1,200,0,0]'),(3,3,1,31,'[{0,37020001,2}]',500,'[1,1,500,0,0]'),(3,4,1,1,'[{0,20070017,30}]',10,'[1,1,10,0,0]'),(3,4,1,2,'[{0,20070017,15}]',10,'[1,1,10,0,0]'),(3,4,1,3,'[{0,20070017,5}]',15,'[1,1,15,0,0]'),(3,4,1,4,'[{0,20070017,3}]',25,'[1,1,25,0,0]'),(3,4,1,5,'[{0,20070017,2}]',40,'[1,1,40,0,0]'),(3,4,1,6,'[{0,20070017,1}]',100,'[1,1,100,0,0]'),(3,4,1,7,'[{0,14010105,1}]',10,'[1,1,10,0,0]'),(3,4,1,8,'[{0,14020205,1}]',10,'[1,1,10,0,0]'),(3,4,1,9,'[{0,16010001,1}]',150,'[1,1,150,0,0]'),(3,4,1,10,'[{0,16010002,1}]',120,'[1,1,120,0,0]'),(3,4,1,11,'[{0,24020001,1}]',120,'[1,1,120,0,0]'),(3,4,1,12,'[{0,24020002,1}]',120,'[1,1,120,0,0]'),(3,4,1,13,'[{0,20060003,1}]',120,'[1,1,120,0,0]'),(3,4,1,14,'[{0,18020001,6}]',200,'[1,1,200,0,0]'),(3,4,1,15,'[{0,14010102,1}]',250,'[1,1,250,0,0]'),(3,4,1,16,'[{0,14020202,1}]',250,'[1,1,250,0,0]'),(3,4,1,17,'[{0,40010011,2}]',750,'[1,1,750,0,0]'),(3,4,1,18,'[{0,15020101,2}]',250,'[1,1,250,0,0]'),(3,4,1,19,'[{0,38260001,4}]',250,'[1,1,250,0,0]'),(3,4,1,20,'[{0,37020002,1}]',100,'[1,1,100,0,0]'),(3,4,1,21,'[{0,18020001,3}]',400,'[1,1,400,0,0]'),(3,4,1,22,'[{0,5203003,1}]',400,'[1,1,400,0,0]'),(3,4,1,23,'[{0,38100009,2}]',600,'[1,1,600,0,0]'),(3,4,1,24,'[{0,20060001,3}]',500,'[1,1,500,0,0]'),(3,4,1,25,'[{0,24010001,3}]',500,'[1,1,500,0,0]'),(3,4,1,26,'[{0,38260001,2}]',1800,'[1,1,1800,0,0]'),(3,4,1,27,'[{0,16020001,2}]',1000,'[1,1,1000,0,0]'),(3,4,1,28,'[{0,11020001,3}]',1000,'[1,1,1000,0,0]'),(3,4,1,29,'[{0,38070002,1}]',200,'[1,1,200,0,0]'),(3,4,1,30,'[{0,15020301,2}]',200,'[1,1,200,0,0]'),(3,4,1,31,'[{0,37020001,2}]',500,'[1,1,500,0,0]'),(3,5,1,1,'[{0,20070018,30}]',10,'[1,1,10,0,0]'),(3,5,1,2,'[{0,20070018,15}]',10,'[1,1,10,0,0]'),(3,5,1,3,'[{0,20070018,5}]',15,'[1,1,15,0,0]'),(3,5,1,4,'[{0,20070018,3}]',25,'[1,1,25,0,0]'),(3,5,1,5,'[{0,20070018,2}]',40,'[1,1,40,0,0]'),(3,5,1,6,'[{0,20070018,1}]',100,'[1,1,100,0,0]'),(3,5,1,7,'[{0,14010105,1}]',10,'[1,1,10,0,0]'),(3,5,1,8,'[{0,14020205,1}]',10,'[1,1,10,0,0]'),(3,5,1,9,'[{0,16010001,1}]',150,'[1,1,150,0,0]'),(3,5,1,10,'[{0,16010002,1}]',120,'[1,1,120,0,0]'),(3,5,1,11,'[{0,24020001,1}]',120,'[1,1,120,0,0]'),(3,5,1,12,'[{0,24020002,1}]',120,'[1,1,120,0,0]'),(3,5,1,13,'[{0,20060003,1}]',120,'[1,1,120,0,0]'),(3,5,1,14,'[{0,18020001,6}]',200,'[1,1,200,0,0]'),(3,5,1,15,'[{0,14010102,1}]',250,'[1,1,250,0,0]'),(3,5,1,16,'[{0,14020202,1}]',250,'[1,1,250,0,0]'),(3,5,1,17,'[{0,40010011,2}]',750,'[1,1,750,0,0]'),(3,5,1,18,'[{0,15020101,2}]',250,'[1,1,250,0,0]'),(3,5,1,19,'[{0,38260001,4}]',250,'[1,1,250,0,0]'),(3,5,1,20,'[{0,37020002,1}]',100,'[1,1,100,0,0]'),(3,5,1,21,'[{0,18020001,3}]',400,'[1,1,400,0,0]'),(3,5,1,22,'[{0,5203003,1}]',400,'[1,1,400,0,0]'),(3,5,1,23,'[{0,38100009,2}]',600,'[1,1,600,0,0]'),(3,5,1,24,'[{0,20060001,3}]',500,'[1,1,500,0,0]'),(3,5,1,25,'[{0,24010001,3}]',500,'[1,1,500,0,0]'),(3,5,1,26,'[{0,38260001,2}]',1800,'[1,1,1800,0,0]'),(3,5,1,27,'[{0,16020001,2}]',1000,'[1,1,1000,0,0]'),(3,5,1,28,'[{0,11020001,3}]',1000,'[1,1,1000,0,0]'),(3,5,1,29,'[{0,38070002,1}]',200,'[1,1,200,0,0]'),(3,5,1,30,'[{0,15020301,2}]',200,'[1,1,200,0,0]'),(3,5,1,31,'[{0,37020001,2}]',500,'[1,1,500,0,0]'),(3,6,1,1,'[{0,20070012,30}]',10,'[1,1,10,0,0]'),(3,6,1,2,'[{0,20070012,15}]',10,'[1,1,10,0,0]'),(3,6,1,3,'[{0,20070012,5}]',15,'[1,1,15,0,0]'),(3,6,1,4,'[{0,20070012,3}]',25,'[1,1,25,0,0]'),(3,6,1,5,'[{0,20070012,2}]',40,'[1,1,40,0,0]'),(3,6,1,6,'[{0,20070012,1}]',100,'[1,1,100,0,0]'),(3,6,1,7,'[{0,14010105,1}]',10,'[1,1,10,0,0]'),(3,6,1,8,'[{0,14020205,1}]',10,'[1,1,10,0,0]'),(3,6,1,9,'[{0,16010001,1}]',150,'[1,1,150,0,0]'),(3,6,1,10,'[{0,16010002,1}]',120,'[1,1,120,0,0]'),(3,6,1,11,'[{0,24020001,1}]',120,'[1,1,120,0,0]'),(3,6,1,12,'[{0,24020002,1}]',120,'[1,1,120,0,0]'),(3,6,1,13,'[{0,20060003,1}]',120,'[1,1,120,0,0]'),(3,6,1,14,'[{0,18020001,6}]',200,'[1,1,200,0,0]'),(3,6,1,15,'[{0,14010102,1}]',250,'[1,1,250,0,0]'),(3,6,1,16,'[{0,14020202,1}]',250,'[1,1,250,0,0]'),(3,6,1,17,'[{0,40010011,2}]',750,'[1,1,750,0,0]'),(3,6,1,18,'[{0,15020101,2}]',250,'[1,1,250,0,0]'),(3,6,1,19,'[{0,38260001,4}]',250,'[1,1,250,0,0]'),(3,6,1,20,'[{0,37020002,1}]',100,'[1,1,100,0,0]'),(3,6,1,21,'[{0,18020001,3}]',400,'[1,1,400,0,0]'),(3,6,1,22,'[{0,5203003,1}]',400,'[1,1,400,0,0]'),(3,6,1,23,'[{0,38100009,2}]',600,'[1,1,600,0,0]'),(3,6,1,24,'[{0,20060001,3}]',500,'[1,1,500,0,0]'),(3,6,1,25,'[{0,24010001,3}]',500,'[1,1,500,0,0]'),(3,6,1,26,'[{0,38260001,2}]',1800,'[1,1,1800,0,0]'),(3,6,1,27,'[{0,16020001,2}]',1000,'[1,1,1000,0,0]'),(3,6,1,28,'[{0,11020001,3}]',1000,'[1,1,1000,0,0]'),(3,6,1,29,'[{0,38070002,1}]',200,'[1,1,200,0,0]'),(3,6,1,30,'[{0,15020301,2}]',200,'[1,1,200,0,0]'),(3,6,1,31,'[{0,37020001,2}]',500,'[1,1,500,0,0]'),(3,7,1,1,'[{0,20070015,30}]',10,'[1,1,10,0,0]'),(3,7,1,2,'[{0,20070015,15}]',10,'[1,1,10,0,0]'),(3,7,1,3,'[{0,20070015,5}]',15,'[1,1,15,0,0]'),(3,7,1,4,'[{0,20070015,3}]',25,'[1,1,25,0,0]'),(3,7,1,5,'[{0,20070015,2}]',40,'[1,1,40,0,0]'),(3,7,1,6,'[{0,20070015,1}]',100,'[1,1,100,0,0]'),(3,7,1,7,'[{0,14010105,1}]',10,'[1,1,10,0,0]'),(3,7,1,8,'[{0,14020205,1}]',10,'[1,1,10,0,0]'),(3,7,1,9,'[{0,16010001,1}]',150,'[1,1,150,0,0]'),(3,7,1,10,'[{0,16010002,1}]',120,'[1,1,120,0,0]'),(3,7,1,11,'[{0,24020001,1}]',120,'[1,1,120,0,0]'),(3,7,1,12,'[{0,24020002,1}]',120,'[1,1,120,0,0]'),(3,7,1,13,'[{0,20060003,1}]',120,'[1,1,120,0,0]'),(3,7,1,14,'[{0,18020001,6}]',200,'[1,1,200,0,0]'),(3,7,1,15,'[{0,14010102,1}]',250,'[1,1,250,0,0]'),(3,7,1,16,'[{0,14020202,1}]',250,'[1,1,250,0,0]'),(3,7,1,17,'[{0,40010011,2}]',750,'[1,1,750,0,0]'),(3,7,1,18,'[{0,15020101,2}]',250,'[1,1,250,0,0]'),(3,7,1,19,'[{0,38260001,4}]',250,'[1,1,250,0,0]'),(3,7,1,20,'[{0,37020002,1}]',100,'[1,1,100,0,0]'),(3,7,1,21,'[{0,18020001,3}]',400,'[1,1,400,0,0]'),(3,7,1,22,'[{0,5203003,1}]',400,'[1,1,400,0,0]'),(3,7,1,23,'[{0,38100009,2}]',600,'[1,1,600,0,0]'),(3,7,1,24,'[{0,20060001,3}]',500,'[1,1,500,0,0]'),(3,7,1,25,'[{0,24010001,3}]',500,'[1,1,500,0,0]'),(3,7,1,26,'[{0,38260001,2}]',1800,'[1,1,1800,0,0]'),(3,7,1,27,'[{0,16020001,2}]',1000,'[1,1,1000,0,0]'),(3,7,1,28,'[{0,11020001,3}]',1000,'[1,1,1000,0,0]'),(3,7,1,29,'[{0,38070002,1}]',200,'[1,1,200,0,0]'),(3,7,1,30,'[{0,15020301,2}]',200,'[1,1,200,0,0]'),(3,7,1,31,'[{0,37020001,2}]',500,'[1,1,500,0,0]'),(3,8,1,1,'[{0,20070016,30}]',10,'[1,1,10,0,0]'),(3,8,1,2,'[{0,20070016,15}]',10,'[1,1,10,0,0]'),(3,8,1,3,'[{0,20070016,5}]',15,'[1,1,15,0,0]'),(3,8,1,4,'[{0,20070016,3}]',25,'[1,1,25,0,0]'),(3,8,1,5,'[{0,20070016,2}]',40,'[1,1,40,0,0]'),(3,8,1,6,'[{0,20070016,1}]',100,'[1,1,100,0,0]'),(3,8,1,7,'[{0,14010105,1}]',10,'[1,1,10,0,0]'),(3,8,1,8,'[{0,14020205,1}]',10,'[1,1,10,0,0]'),(3,8,1,9,'[{0,16010001,1}]',150,'[1,1,150,0,0]'),(3,8,1,10,'[{0,16010002,1}]',120,'[1,1,120,0,0]'),(3,8,1,11,'[{0,24020001,1}]',120,'[1,1,120,0,0]'),(3,8,1,12,'[{0,24020002,1}]',120,'[1,1,120,0,0]'),(3,8,1,13,'[{0,20060003,1}]',120,'[1,1,120,0,0]'),(3,8,1,14,'[{0,18020001,6}]',200,'[1,1,200,0,0]'),(3,8,1,15,'[{0,14010102,1}]',250,'[1,1,250,0,0]'),(3,8,1,16,'[{0,14020202,1}]',250,'[1,1,250,0,0]'),(3,8,1,17,'[{0,40010011,2}]',750,'[1,1,750,0,0]'),(3,8,1,18,'[{0,15020101,2}]',250,'[1,1,250,0,0]'),(3,8,1,19,'[{0,38260001,4}]',250,'[1,1,250,0,0]'),(3,8,1,20,'[{0,37020002,1}]',100,'[1,1,100,0,0]'),(3,8,1,21,'[{0,18020001,3}]',400,'[1,1,400,0,0]'),(3,8,1,22,'[{0,5203003,1}]',400,'[1,1,400,0,0]'),(3,8,1,23,'[{0,38100009,2}]',600,'[1,1,600,0,0]'),(3,8,1,24,'[{0,20060001,3}]',500,'[1,1,500,0,0]'),(3,8,1,25,'[{0,24010001,3}]',500,'[1,1,500,0,0]'),(3,8,1,26,'[{0,38260001,2}]',1800,'[1,1,1800,0,0]'),(3,8,1,27,'[{0,16020001,2}]',1000,'[1,1,1000,0,0]'),(3,8,1,28,'[{0,11020001,3}]',1000,'[1,1,1000,0,0]'),(3,8,1,29,'[{0,38070002,1}]',200,'[1,1,200,0,0]'),(3,8,1,30,'[{0,15020301,2}]',200,'[1,1,200,0,0]'),(3,8,1,31,'[{0,37020001,2}]',500,'[1,1,500,0,0]'),(3,9,1,1,'[{0,20070012,30}]',10,'[1,1,10,0,0]'),(3,9,1,2,'[{0,20070012,15}]',10,'[1,1,10,0,0]'),(3,9,1,3,'[{0,20070012,5}]',15,'[1,1,15,0,0]'),(3,9,1,4,'[{0,20070012,3}]',25,'[1,1,25,0,0]'),(3,9,1,5,'[{0,20070012,2}]',40,'[1,1,40,0,0]'),(3,9,1,6,'[{0,20070012,1}]',100,'[1,1,100,0,0]'),(3,9,1,7,'[{0,14010105,1}]',10,'[1,1,10,0,0]'),(3,9,1,8,'[{0,14020205,1}]',10,'[1,1,10,0,0]'),(3,9,1,9,'[{0,16010001,1}]',150,'[1,1,150,0,0]'),(3,9,1,10,'[{0,16010002,1}]',120,'[1,1,120,0,0]'),(3,9,1,11,'[{0,24020001,1}]',120,'[1,1,120,0,0]'),(3,9,1,12,'[{0,24020002,1}]',120,'[1,1,120,0,0]'),(3,9,1,13,'[{0,20060003,1}]',120,'[1,1,120,0,0]'),(3,9,1,14,'[{0,18020001,6}]',200,'[1,1,200,0,0]'),(3,9,1,15,'[{0,14010102,1}]',250,'[1,1,250,0,0]'),(3,9,1,16,'[{0,14020202,1}]',250,'[1,1,250,0,0]'),(3,9,1,17,'[{0,40010011,2}]',750,'[1,1,750,0,0]'),(3,9,1,18,'[{0,15020101,2}]',250,'[1,1,250,0,0]'),(3,9,1,19,'[{0,38260001,4}]',250,'[1,1,250,0,0]'),(3,9,1,20,'[{0,37020002,1}]',100,'[1,1,100,0,0]'),(3,9,1,21,'[{0,18020001,3}]',400,'[1,1,400,0,0]'),(3,9,1,22,'[{0,5203003,1}]',400,'[1,1,400,0,0]'),(3,9,1,23,'[{0,38100009,2}]',600,'[1,1,600,0,0]'),(3,9,1,24,'[{0,20060001,3}]',500,'[1,1,500,0,0]'),(3,9,1,25,'[{0,24010001,3}]',500,'[1,1,500,0,0]'),(3,9,1,26,'[{0,38260001,2}]',1800,'[1,1,1800,0,0]'),(3,9,1,27,'[{0,16020001,2}]',1000,'[1,1,1000,0,0]'),(3,9,1,28,'[{0,11020001,3}]',1000,'[1,1,1000,0,0]'),(3,9,1,29,'[{0,38070002,1}]',200,'[1,1,200,0,0]'),(3,9,1,30,'[{0,15020301,2}]',200,'[1,1,200,0,0]'),(3,9,1,31,'[{0,37020001,2}]',500,'[1,1,500,0,0]'),(3,10,1,1,'[{0,20070015,30}]',10,'[1,1,10,0,0]'),(3,10,1,2,'[{0,20070015,15}]',10,'[1,1,10,0,0]'),(3,10,1,3,'[{0,20070015,5}]',15,'[1,1,15,0,0]'),(3,10,1,4,'[{0,20070015,3}]',25,'[1,1,25,0,0]'),(3,10,1,5,'[{0,20070015,2}]',40,'[1,1,40,0,0]'),(3,10,1,6,'[{0,20070015,1}]',100,'[1,1,100,0,0]'),(3,10,1,7,'[{0,14010105,1}]',10,'[1,1,10,0,0]'),(3,10,1,8,'[{0,14020205,1}]',10,'[1,1,10,0,0]'),(3,10,1,9,'[{0,16010001,1}]',150,'[1,1,150,0,0]'),(3,10,1,10,'[{0,16010002,1}]',120,'[1,1,120,0,0]'),(3,10,1,11,'[{0,24020001,1}]',120,'[1,1,120,0,0]'),(3,10,1,12,'[{0,24020002,1}]',120,'[1,1,120,0,0]'),(3,10,1,13,'[{0,20060003,1}]',120,'[1,1,120,0,0]'),(3,10,1,14,'[{0,18020001,6}]',200,'[1,1,200,0,0]'),(3,10,1,15,'[{0,14010102,1}]',250,'[1,1,250,0,0]'),(3,10,1,16,'[{0,14020202,1}]',250,'[1,1,250,0,0]'),(3,10,1,17,'[{0,40010011,2}]',750,'[1,1,750,0,0]'),(3,10,1,18,'[{0,15020101,2}]',250,'[1,1,250,0,0]'),(3,10,1,19,'[{0,38260001,4}]',250,'[1,1,250,0,0]'),(3,10,1,20,'[{0,37020002,1}]',100,'[1,1,100,0,0]'),(3,10,1,21,'[{0,18020001,3}]',400,'[1,1,400,0,0]'),(3,10,1,22,'[{0,5203003,1}]',400,'[1,1,400,0,0]'),(3,10,1,23,'[{0,38100009,2}]',600,'[1,1,600,0,0]'),(3,10,1,24,'[{0,20060001,3}]',500,'[1,1,500,0,0]'),(3,10,1,25,'[{0,24010001,3}]',500,'[1,1,500,0,0]'),(3,10,1,26,'[{0,38260001,2}]',1800,'[1,1,1800,0,0]'),(3,10,1,27,'[{0,16020001,2}]',1000,'[1,1,1000,0,0]'),(3,10,1,28,'[{0,11020001,3}]',1000,'[1,1,1000,0,0]'),(3,10,1,29,'[{0,38070002,1}]',200,'[1,1,200,0,0]'),(3,10,1,30,'[{0,15020301,2}]',200,'[1,1,200,0,0]'),(3,10,1,31,'[{0,37020001,2}]',500,'[1,1,500,0,0]');
/*!40000 ALTER TABLE `base_race_act_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_race_act_stage_reward`
--

DROP TABLE IF EXISTS `base_race_act_stage_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_race_act_stage_reward` (
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `sub_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '次类型',
  `reward_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励id',
  `need_val` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '所需值',
  `reward` varchar(1024) NOT NULL DEFAULT '''[]''' COMMENT '奖励',
  PRIMARY KEY (`type`,`sub_type`,`reward_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_race_act_stage_reward`
--

LOCK TABLES `base_race_act_stage_reward` WRITE;
/*!40000 ALTER TABLE `base_race_act_stage_reward` DISABLE KEYS */;
INSERT INTO `base_race_act_stage_reward` VALUES (1,1,1,10,'[{0,14010101,1}]'),(1,1,2,30,'[{0,14010102,1}]'),(1,1,3,50,'[{0,14010103,1}]'),(1,1,4,80,'[{0,14010104,1}]'),(1,1,5,200,'[{0,14010105,1}]'),(1,1,6,500,'[{0,14010106,1}]'),(1,1,7,800,'[{0,14010107,1}]'),(2,1,1,10,'[{career,[{1,0,53040104,2},{2,0,53040204,2},{4,0,53040404,2}]},{0,53020020,2}]'),(2,1,2,30,'[{career,[{1,0,53040104,3},{2,0,53040204,3},{4,0,53040404,3}]},{0,53020020,3}]'),(2,1,3,50,'[{career,[{1,0,53040104,4},{2,0,53040204,4},{4,0,53040404,4}]},{0,53020020,8}]'),(2,1,4,80,'[{career,[{1,0,53040104,6},{2,0,53040204,6},{4,0,53040404,6}]},{0,53020020,25}]'),(2,1,5,200,'[{career,[{1,0,53040104,10},{2,0,53040204,10},{4,0,53040404,10}]},{0,53020020,40}]'),(2,1,6,500,'[{career,[{1,0,53040104,15},{2,0,53040204,15},{4,0,53040404,15}]},{0,53020020,60}]'),(2,1,7,800,'[{career,[{1,0,53040104,20},{2,0,53040204,20},{4,0,53040404,20}]},{0,53020020,100}]'),(2,2,1,10,'[{career,[{1,0,53040104,2},{2,0,53040204,2},{4,0,53040404,2}]},{0,53020020,2}]'),(2,2,2,30,'[{career,[{1,0,53040104,3},{2,0,53040204,3},{4,0,53040404,3}]},{0,53020020,3}]'),(2,2,3,50,'[{career,[{1,0,53040104,4},{2,0,53040204,4},{4,0,53040404,4}]},{0,53020020,8}]'),(2,2,4,80,'[{career,[{1,0,53040104,6},{2,0,53040204,6},{4,0,53040404,6}]},{0,53020020,25}]'),(2,2,5,200,'[{career,[{1,0,53040104,10},{2,0,53040204,10},{4,0,53040404,10}]},{0,53020020,40}]'),(2,2,6,500,'[{career,[{1,0,53040104,15},{2,0,53040204,15},{4,0,53040404,15}]},{0,53020020,60}]'),(2,2,7,800,'[{career,[{1,0,53040104,20},{2,0,53040204,20},{4,0,53040404,20}]},{0,53020020,100}]'),(2,3,1,10,'[{career,[{1,0,53040104,2},{2,0,53040204,2},{4,0,53040404,2}]},{0,53020020,2}]'),(2,3,2,30,'[{career,[{1,0,53040104,3},{2,0,53040204,3},{4,0,53040404,3}]},{0,53020020,3}]'),(2,3,3,50,'[{career,[{1,0,53040104,4},{2,0,53040204,4},{4,0,53040404,4}]},{0,53020020,8}]'),(2,3,4,80,'[{career,[{1,0,53040104,6},{2,0,53040204,6},{4,0,53040404,6}]},{0,53020020,25}]'),(2,3,5,200,'[{career,[{1,0,53040104,10},{2,0,53040204,10},{4,0,53040404,10}]},{0,53020020,40}]'),(2,3,6,500,'[{career,[{1,0,53040104,15},{2,0,53040204,15},{4,0,53040404,15}]},{0,53020020,60}]'),(2,3,7,800,'[{career,[{1,0,53040104,20},{2,0,53040204,20},{4,0,53040404,20}]},{0,53020020,100}]'),(2,4,1,10,'[{career,[{1,0,53040104,2},{2,0,53040204,2},{4,0,53040404,2}]},{0,53020020,2}]'),(2,4,2,30,'[{career,[{1,0,53040104,3},{2,0,53040204,3},{4,0,53040404,3}]},{0,53020020,3}]'),(2,4,3,50,'[{career,[{1,0,53040104,4},{2,0,53040204,4},{4,0,53040404,4}]},{0,53020020,8}]'),(2,4,4,80,'[{career,[{1,0,53040104,6},{2,0,53040204,6},{4,0,53040404,6}]},{0,53020020,25}]'),(2,4,5,200,'[{career,[{1,0,53040104,10},{2,0,53040204,10},{4,0,53040404,10}]},{0,53020020,40}]'),(2,4,6,500,'[{career,[{1,0,53040104,15},{2,0,53040204,15},{4,0,53040404,15}]},{0,53020020,60}]'),(2,4,7,800,'[{career,[{1,0,53040104,20},{2,0,53040204,20},{4,0,53040404,20}]},{0,53020020,100}]'),(2,5,1,10,'[{career,[{1,0,53040104,2},{2,0,53040204,2},{4,0,53040404,2}]},{0,53020020,2}]'),(2,5,2,30,'[{career,[{1,0,53040104,3},{2,0,53040204,3},{4,0,53040404,3}]},{0,53020020,3}]'),(2,5,3,50,'[{career,[{1,0,53040104,4},{2,0,53040204,4},{4,0,53040404,4}]},{0,53020020,8}]'),(2,5,4,80,'[{career,[{1,0,53040104,6},{2,0,53040204,6},{4,0,53040404,6}]},{0,53020020,25}]'),(2,5,5,200,'[{career,[{1,0,53040104,10},{2,0,53040204,10},{4,0,53040404,10}]},{0,53020020,40}]'),(2,5,6,500,'[{career,[{1,0,53040104,15},{2,0,53040204,15},{4,0,53040404,15}]},{0,53020020,60}]'),(2,5,7,800,'[{career,[{1,0,53040104,20},{2,0,53040204,20},{4,0,53040404,20}]},{0,53020020,100}]'),(3,1,1,10,'[{0,20070012,2},{0,20060002,2}]'),(3,1,2,30,'[{0,20070012,3},{0,20060002,3}]'),(3,1,3,50,'[{0,20070012,4},{0,20060002,8}]'),(3,1,4,80,'[{0,20070012,6},{0,20060002,25}]'),(3,1,5,200,'[{0,20070012,10},{0,20060002,40}]'),(3,1,6,500,'[{0,20070012,15},{0,20060002,60}]'),(3,1,7,800,'[{0,20070012,20},{0,20060002,100}]'),(3,2,1,10,'[{0,20070015,2},{0,20060002,2}]'),(3,2,2,30,'[{0,20070015,3},{0,20060002,3}]'),(3,2,3,50,'[{0,20070015,4},{0,20060002,8}]'),(3,2,4,80,'[{0,20070015,6},{0,20060002,25}]'),(3,2,5,200,'[{0,20070015,10},{0,20060002,40}]'),(3,2,6,500,'[{0,20070015,15},{0,20060002,60}]'),(3,2,7,800,'[{0,20070015,20},{0,20060002,100}]'),(3,3,1,10,'[{0,20070016,2},{0,20060002,2}]'),(3,3,2,30,'[{0,20070016,3},{0,20060002,3}]'),(3,3,3,50,'[{0,20070016,4},{0,20060002,8}]'),(3,3,4,80,'[{0,20070016,6},{0,20060002,25}]'),(3,3,5,200,'[{0,20070016,10},{0,20060002,40}]'),(3,3,6,500,'[{0,20070016,15},{0,20060002,60}]'),(3,3,7,800,'[{0,20070016,20},{0,20060002,100}]'),(3,4,1,10,'[{0,20070017,2},{0,20060002,2}]'),(3,4,2,30,'[{0,20070017,3},{0,20060002,3}]'),(3,4,3,50,'[{0,20070017,4},{0,20060002,8}]'),(3,4,4,80,'[{0,20070017,6},{0,20060002,25}]'),(3,4,5,200,'[{0,20070017,10},{0,20060002,40}]'),(3,4,6,500,'[{0,20070017,15},{0,20060002,60}]'),(3,4,7,800,'[{0,20070017,20},{0,20060002,100}]'),(3,5,1,10,'[{0,20070018,2},{0,20060002,2}]'),(3,5,2,30,'[{0,20070018,3},{0,20060002,3}]'),(3,5,3,50,'[{0,20070018,4},{0,20060002,8}]'),(3,5,4,80,'[{0,20070018,6},{0,20060002,25}]'),(3,5,5,200,'[{0,20070018,10},{0,20060002,40}]'),(3,5,6,500,'[{0,20070018,15},{0,20060002,60}]'),(3,5,7,800,'[{0,20070018,20},{0,20060002,100}]'),(3,6,1,10,'[{0,20070012,2},{0,20060002,2}]'),(3,6,2,30,'[{0,20070012,3},{0,20060002,3}]'),(3,6,3,50,'[{0,20070012,4},{0,20060002,8}]'),(3,6,4,80,'[{0,20070012,6},{0,20060002,25}]'),(3,6,5,200,'[{0,20070012,10},{0,20060002,40}]'),(3,6,6,500,'[{0,20070012,15},{0,20060002,60}]'),(3,6,7,800,'[{0,20070012,20},{0,20060002,100}]'),(3,7,1,10,'[{0,20070015,2},{0,20060002,2}]'),(3,7,2,30,'[{0,20070015,3},{0,20060002,3}]'),(3,7,3,50,'[{0,20070015,4},{0,20060002,8}]'),(3,7,4,80,'[{0,20070015,6},{0,20060002,25}]'),(3,7,5,200,'[{0,20070015,10},{0,20060002,40}]'),(3,7,6,500,'[{0,20070015,15},{0,20060002,60}]'),(3,7,7,800,'[{0,20070015,20},{0,20060002,100}]'),(3,8,1,10,'[{0,20070016,2},{0,20060002,2}]'),(3,8,2,30,'[{0,20070016,3},{0,20060002,3}]'),(3,8,3,50,'[{0,20070016,4},{0,20060002,8}]'),(3,8,4,80,'[{0,20070016,6},{0,20060002,25}]'),(3,8,5,200,'[{0,20070016,10},{0,20060002,40}]'),(3,8,6,500,'[{0,20070016,15},{0,20060002,60}]'),(3,8,7,800,'[{0,20070016,20},{0,20060002,100}]'),(3,9,1,10,'[{0,20070012,2},{0,20060002,2}]'),(3,9,2,30,'[{0,20070012,3},{0,20060002,3}]'),(3,9,3,50,'[{0,20070012,4},{0,20060002,8}]'),(3,9,4,80,'[{0,20070012,6},{0,20060002,25}]'),(3,9,5,200,'[{0,20070012,10},{0,20060002,40}]'),(3,9,6,500,'[{0,20070012,15},{0,20060002,60}]'),(3,9,7,800,'[{0,20070012,20},{0,20060002,100}]'),(3,10,1,10,'[{0,20070015,2},{0,20060002,2}]'),(3,10,2,30,'[{0,20070015,3},{0,20060002,3}]'),(3,10,3,50,'[{0,20070015,4},{0,20060002,8}]'),(3,10,4,80,'[{0,20070015,6},{0,20060002,25}]'),(3,10,5,200,'[{0,20070015,10},{0,20060002,40}]'),(3,10,6,500,'[{0,20070015,15},{0,20060002,60}]'),(3,10,7,800,'[{0,20070015,20},{0,20060002,100}]');
/*!40000 ALTER TABLE `base_race_act_stage_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_ranking`
--

DROP TABLE IF EXISTS `base_ranking`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_ranking` (
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排行榜类型',
  `rank_name` varchar(255) NOT NULL DEFAULT '' COMMENT '榜单名字',
  `rank_max` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排行榜最大长度',
  `rank_limit` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '当前类型的最低限度',
  `title_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '首位称号Id',
  `about` varchar(1024) NOT NULL COMMENT '说明@lang@',
  PRIMARY KEY (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='排行榜配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_ranking`
--

LOCK TABLES `base_ranking` WRITE;
/*!40000 ALTER TABLE `base_ranking` DISABLE KEYS */;
INSERT INTO `base_ranking` VALUES (100,'公会榜',60,1000000,0,'公会战力达到1000000'),(200,'战力榜',60,300000,4902005,'战力达到300000'),(300,'等级榜',60,120,4902006,'等级达到120'),(401,'魔剑士',20,300000,0,'战力达到300000'),(402,'龙骑士',20,300000,0,'战力达到300000'),(404,'重炮手',20,300000,0,'战力达到300000'),(500,'时装榜',60,10000,0,'时装战力达到10000'),(601,'坐骑榜',60,20000,0,'坐骑战力达到20000'),(602,'翅膀榜',60,20000,0,'翅膀战力达到20000'),(603,'宝具榜',60,20000,0,'宝具战力达到20000'),(604,'降神榜',60,20000,0,'降神总战力达到20000'),(605,'圣灵榜',60,20000,0,'圣灵总战力达到20000'),(606,'星灵榜',60,20000,0,'星灵总战力达到20000'),(700,'魅力周榜',60,100,0,'魅力周榜达到100'),(701,'魅力男榜',20,100,0,'魅力值达到100'),(702,'魅力女榜',20,100,0,'魅力值达到100'),(801,'神格榜',60,5,0,'神格塔达到5'),(802,'魂珠塔',60,5,0,'魂珠塔达到5'),(901,'成就榜',60,10,0,'成就星数达到10'),(902,'图鉴榜',60,10000,0,'图鉴总战力达到10000'),(1000,'魂珠榜',60,10000,0,'魂珠战斗力达到10000'),(1100,'装备榜',60,100000,4902019,'装备战斗力达到100000');
/*!40000 ALTER TABLE `base_ranking` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_realm`
--

DROP TABLE IF EXISTS `base_realm`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_realm` (
  `realm_id` smallint(5) NOT NULL,
  `realm_name` varchar(50) NOT NULL COMMENT '阵营@lang@',
  PRIMARY KEY (`realm_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_realm`
--

LOCK TABLES `base_realm` WRITE;
/*!40000 ALTER TABLE `base_realm` DISABLE KEYS */;
/*!40000 ALTER TABLE `base_realm` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_recharge_daily_gift`
--

DROP TABLE IF EXISTS `base_recharge_daily_gift`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_recharge_daily_gift` (
  `product_id` int(11) NOT NULL DEFAULT '0' COMMENT '商品编号',
  `level` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '档次',
  `value` int(10) unsigned NOT NULL COMMENT '充值钻石',
  `reward` varchar(256) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`product_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='每日礼包配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_recharge_daily_gift`
--

LOCK TABLES `base_recharge_daily_gift` WRITE;
/*!40000 ALTER TABLE `base_recharge_daily_gift` DISABLE KEYS */;
INSERT INTO `base_recharge_daily_gift` VALUES (10,1,0,'[{0,15020303,1},{0,15020302,2},{0,15020301,5},{0,38220003,1}]');
/*!40000 ALTER TABLE `base_recharge_daily_gift` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_recharge_first`
--

DROP TABLE IF EXISTS `base_recharge_first`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_recharge_first` (
  `product_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '商品编号',
  `type` int(10) unsigned NOT NULL COMMENT '类型',
  `index` tinyint(3) unsigned NOT NULL COMMENT '序号',
  `reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `title` varchar(256) NOT NULL COMMENT '标题@lang@',
  `content` varchar(256) NOT NULL COMMENT '描述@lang@',
  `left_res` varchar(256) NOT NULL COMMENT '左侧资源名',
  `right_res` varchar(256) NOT NULL COMMENT '右侧资源名',
  PRIMARY KEY (`product_id`,`type`,`index`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='首充配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_recharge_first`
--

LOCK TABLES `base_recharge_first` WRITE;
/*!40000 ALTER TABLE `base_recharge_first` DISABLE KEYS */;
INSERT INTO `base_recharge_first` VALUES (40,1,1,'[{0,1101010542,1},{0,12010012,1},{0,37020002,1},{0,38180001,2},{0,11020001,5},{0,18020001,5}]','极品武器、神级装备、超值礼包大派送！','瞬间走上人生巅峰！','[{1,12010012,12010012},{2,12020012,12020012},{3,12030012,12030012}]','[{1,5010101,5010101}]'),(40,1,2,'[{0,17020003,1},{0,12020012,1},{0,37020002,1},{0,38180010,2},{0,17010001,80},{0,15020301,5}]','极品武器、神级装备、超值礼包大派送！','瞬间走上人生巅峰！','[{1,12010012,12010012},{2,12020012,12020012},{3,12030012,12030012}]','[{2,figure_1,figure_1}]'),(40,1,3,'[{0,24020003,1},{0,12030012,1},{0,37020002,1},{0,38160001,1},{0,16020001,5},{0,24010001,5}]','极品武器、神级装备、超值礼包大派送！','瞬间走上人生巅峰！','[{1,12010012,12010012},{2,12020012,12020012},{3,12030012,12030012}]','[{2,figure_29,figure_29}]'),(40,2,1,'[{0,1101020542,1},{0,12010012,1},{0,37020002,1},{0,38180001,2},{0,11020001,5},{0,18020001,5}]','极品武器、神级装备、超值礼包大派送！','瞬间走上人生巅峰！','[{1,12010012,12010012},{2,12020012,12020012},{3,12030012,12030012}]','[{1,5110102,5110102}]'),(40,2,2,'[{0,17020003,1},{0,12020012,1},{0,37020002,1},{0,38180010,2},{0,17010001,80},{0,15020301,5}]','极品武器、神级装备、超值礼包大派送！','瞬间走上人生巅峰！','[{1,12010012,12010012},{2,12020012,12020012},{3,12030012,12030012}]','[{2,figure_1,figure_1}]'),(40,2,3,'[{0,24020003,1},{0,12030012,1},{0,37020002,1},{0,38160001,1},{0,16020001,5},{0,24010001,5}]','极品武器、神级装备、超值礼包大派送！','瞬间走上人生巅峰！','[{1,12010012,12010012},{2,12020012,12020012},{3,12030012,12030012}]','[{2,figure_29,figure_29}]'),(40,4,1,'[{0,1101040542,1},{0,12010012,1},{0,37020002,1},{0,38180001,2},{0,11020001,5},{0,18020001,5}]','极品武器、神级装备、超值礼包大派送！','瞬间走上人生巅峰！','[{1,12010012,12010012},{2,12020012,12020012},{3,12030012,12030012}]','[{1,5010104,5010104}]'),(40,4,2,'[{0,17020003,1},{0,12020012,1},{0,37020002,1},{0,38180010,2},{0,17010001,80},{0,15020301,5}]','极品武器、神级装备、超值礼包大派送！','瞬间走上人生巅峰！','[{1,12010012,12010012},{2,12020012,12020012},{3,12030012,12030012}]','[{2,figure_1,figure_1}]'),(40,4,3,'[{0,24020003,1},{0,12030012,1},{0,37020002,1},{0,38160001,1},{0,16020001,5},{0,24010001,5}]','极品武器、神级装备、超值礼包大派送！','瞬间走上人生巅峰！','[{1,12010012,12010012},{2,12020012,12020012},{3,12030012,12030012}]','[{2,figure_29,figure_29}]');
/*!40000 ALTER TABLE `base_recharge_first` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_recharge_product`
--

DROP TABLE IF EXISTS `base_recharge_product`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_recharge_product` (
  `product_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商品id',
  `product_name` varchar(255) NOT NULL COMMENT '商品名称@lang@',
  `product_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商品大类',
  `product_subtype` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商品子类',
  `money` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商品价格',
  `associate_list` varchar(1024) NOT NULL COMMENT '关联商品',
  `about` varchar(1024) NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`product_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='充值商品配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_recharge_product`
--

LOCK TABLES `base_recharge_product` WRITE;
/*!40000 ALTER TABLE `base_recharge_product` DISABLE KEYS */;
INSERT INTO `base_recharge_product` VALUES (0,'随心充',1,1,0,'[{4,1}]','金额自定，仅触发关联首充奖励'),(1,'60钻石',1,1,6,'[{4,1}]',''),(2,'300钻石',1,1,30,'[{4,1}]',''),(3,'680钻石',1,1,68,'[{4,1}]',''),(4,'1280钻石',1,1,128,'[{4,1}]',''),(5,'1980钻石',1,1,198,'[{4,1}]',''),(6,'3280钻石',1,1,328,'[{4,1}]',''),(7,'6480钻石',1,1,648,'[{4,1}]',''),(10,'每日礼包',3,1,12,'[]','圣灵材料宝箱'),(20,'周卡',2,3,18,'[]','连续<color=\'#FFEF67FF\'>7</color>天，每天领<color=\'#FFEF67FF\'>60</color>绑钻'),(40,'首充礼包',4,1,1,'[]','充值任意金额，个性时装，极品武器大派送！'),(999,'180钻石',1,1,18,'[{4,1}]','');
/*!40000 ALTER TABLE `base_recharge_product` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_recharge_product_ctrl`
--

DROP TABLE IF EXISTS `base_recharge_product_ctrl`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_recharge_product_ctrl` (
  `product_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商品id',
  `start_time` varchar(30) NOT NULL COMMENT '开始时间',
  `end_time` varchar(30) NOT NULL COMMENT '结束时间',
  `week_time_list` varchar(256) NOT NULL COMMENT '周几开启',
  `month_time_list` varchar(256) NOT NULL COMMENT '每月第几天开启',
  `open_begin` int(11) NOT NULL DEFAULT '0' COMMENT '开服开始天数',
  `open_end` int(11) NOT NULL DEFAULT '0' COMMENT '开服结束天数',
  `merge_begin` int(11) NOT NULL DEFAULT '0' COMMENT '合服开始天数',
  `merge_end` int(11) NOT NULL DEFAULT '0' COMMENT '合服结束天数',
  `serv_lv_begin` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '世界等级开始',
  `serv_lv_end` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '世界等级结束',
  `condition` varchar(1024) NOT NULL COMMENT '其它条件',
  PRIMARY KEY (`product_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='充值商品控制台配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_recharge_product_ctrl`
--

LOCK TABLES `base_recharge_product_ctrl` WRITE;
/*!40000 ALTER TABLE `base_recharge_product_ctrl` DISABLE KEYS */;
INSERT INTO `base_recharge_product_ctrl` VALUES (0,'2017-06-17 00:00:00','2017-12-14 23:13:49','[]','[]',0,0,0,0,0,0,'[]'),(1,'2017-12-14 00:00:00','2017-12-14 23:13:49','[]','[]',0,0,0,0,0,0,'[]'),(2,'2017-12-15 15:30:30','2017-12-14 23:13:49','[]','[]',0,0,0,0,0,0,'[]'),(3,'2017-12-15 00:00:00','2017-12-14 23:13:49','[]','[]',0,0,0,0,0,0,'[]'),(4,'2017-12-15 17:00:00','2017-12-14 23:13:49','[]','[]',0,0,0,0,0,0,'[]'),(5,'2017-12-15 14:51:29','2017-12-14 23:13:49','[]','[]',0,0,0,0,0,0,'[]'),(6,'2017-12-15 00:00:00','2017-12-14 23:13:49','[]','[]',0,0,0,0,0,0,'[]'),(10,'','','[]','[]',0,0,0,0,0,0,'[]'),(20,'','','[]','[]',0,0,0,0,0,0,'[]'),(40,'','','[]','[]',0,0,0,0,0,0,'[]'),(999,'2017-12-14 00:00:00','2017-12-14 23:13:49','[]','[]',0,0,0,0,0,0,'[]');
/*!40000 ALTER TABLE `base_recharge_product_ctrl` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_recharge_return`
--

DROP TABLE IF EXISTS `base_recharge_return`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_recharge_return` (
  `product_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商品id',
  `return_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '返利类型',
  `gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '基础钻石',
  `return_gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '返利钻石',
  PRIMARY KEY (`product_id`,`return_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='充值返利配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_recharge_return`
--

LOCK TABLES `base_recharge_return` WRITE;
/*!40000 ALTER TABLE `base_recharge_return` DISABLE KEYS */;
INSERT INTO `base_recharge_return` VALUES (1,1,60,60),(1,2,60,60),(2,1,300,300),(2,2,300,300),(3,1,680,680),(3,2,680,680),(4,1,1280,1280),(4,2,1280,1280),(5,1,1980,1980),(5,2,1980,1980),(6,1,3280,3280),(6,2,3280,3280),(7,1,6480,6480),(7,2,6480,6480),(20,0,0,0),(999,1,180,180),(999,2,180,180);
/*!40000 ALTER TABLE `base_recharge_return` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_recharge_welfare`
--

DROP TABLE IF EXISTS `base_recharge_welfare`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_recharge_welfare` (
  `product_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商品编号',
  `days` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '持续天数',
  `reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '每日奖励',
  `double_week` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '每周双倍',
  `buy_reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '购买立马获得',
  PRIMARY KEY (`product_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='福利卡';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_recharge_welfare`
--

LOCK TABLES `base_recharge_welfare` WRITE;
/*!40000 ALTER TABLE `base_recharge_welfare` DISABLE KEYS */;
INSERT INTO `base_recharge_welfare` VALUES (20,7,'[{2,0,60}]','[]','[{2,0,180}]');
/*!40000 ALTER TABLE `base_recharge_welfare` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_red_envelopes_goods`
--

DROP TABLE IF EXISTS `base_red_envelopes_goods`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_red_envelopes_goods` (
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '红包物品id',
  `ownership_type` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '红包的归属 1: 公会红包',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '名字@lang@',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '描述@lang@',
  `greetings` varchar(255) NOT NULL DEFAULT '' COMMENT '祝福语@lang@',
  `money_type` tinyint(1) unsigned NOT NULL DEFAULT '2' COMMENT '货币类型',
  `money` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '额度',
  `min_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小拆分数量',
  `times_lim` smallint(11) unsigned NOT NULL DEFAULT '0' COMMENT '使用次数限制',
  PRIMARY KEY (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='红包物品额外配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_red_envelopes_goods`
--

LOCK TABLES `base_red_envelopes_goods` WRITE;
/*!40000 ALTER TABLE `base_red_envelopes_goods` DISABLE KEYS */;
INSERT INTO `base_red_envelopes_goods` VALUES (38080000,1,'测试红包','这是一个测试红包','这是一个测试红包',2,50,2,100),(38080030,1,'30钻红包','随机获得钻石','随机获得钻石',2,30,10,100),(38080050,1,'50钻红包','随机获得钻石','随机获得钻石',2,50,10,100),(38080100,1,'100钻红包','随机获得钻石','随机获得钻石',2,100,10,100);
/*!40000 ALTER TABLE `base_red_envelopes_goods` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_red_packet`
--

DROP TABLE IF EXISTS `base_red_packet`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_red_packet` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '红包id',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '红包类型',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '红包名称',
  `greetings` varchar(255) NOT NULL DEFAULT '' COMMENT '祝福语',
  `trigger_interval` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '周期限制',
  `condition` varchar(255) NOT NULL DEFAULT '[]' COMMENT '条件',
  `money` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '金额',
  `num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '红包个数',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_red_packet`
--

LOCK TABLES `base_red_packet` WRITE;
/*!40000 ALTER TABLE `base_red_packet` DISABLE KEYS */;
INSERT INTO `base_red_packet` VALUES (1,2,'每日累充红包','每日累充',3,'[{today_recharge,300}]',50,10),(2,1,'贵族4级红包','贵族4级',1,'[{vip,4}]',50,10),(3,1,'贵族5级红包','贵族5级',1,'[{vip,5}]',60,10),(4,1,'贵族3级红包','贵族3级',1,'[{vip,3}]',40,10),(11,3,'世界boss红包','伤害第一biubiubiu！~',0,'[{boss_id, 1351001}]',50,10),(12,3,'世界boss红包','伤害第一biubiubiu！~',0,'[{boss_id, 1351002}]',50,10),(13,3,'世界boss红包','伤害第一biubiubiu！~',0,'[{boss_id, 1351003}]',50,10),(14,3,'世界boss红包','伤害第一biubiubiu！~',0,'[{boss_id, 1351004}]',50,10),(15,3,'世界boss红包','伤害第一biubiubiu！~',0,'[{boss_id, 1351005}]',50,10),(16,3,'世界boss红包','伤害第一biubiubiu！~',0,'[{boss_id, 1351006}]',50,10),(17,3,'世界boss红包','伤害第一biubiubiu！~',0,'[{boss_id, 1351007}]',50,10);
/*!40000 ALTER TABLE `base_red_packet` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_red_packet_reply`
--

DROP TABLE IF EXISTS `base_red_packet_reply`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_red_packet_reply` (
  `boss_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'boss_id',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '红包名称',
  `greeting` varchar(255) NOT NULL DEFAULT '' COMMENT '祝福语',
  `money` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '金额',
  PRIMARY KEY (`boss_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_red_packet_reply`
--

LOCK TABLES `base_red_packet_reply` WRITE;
/*!40000 ALTER TABLE `base_red_packet_reply` DISABLE KEYS */;
INSERT INTO `base_red_packet_reply` VALUES (4101001,'答题红包','答题红包',0),(4101002,'答题红包','答题红包',0);
/*!40000 ALTER TABLE `base_red_packet_reply` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_red_packet_vip`
--

DROP TABLE IF EXISTS `base_red_packet_vip`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_red_packet_vip` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `min_vip` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'vip等级下限',
  `max_vip` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'vip等级上限',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '红包名称',
  `money` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '金额',
  `num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '数量',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_red_packet_vip`
--

LOCK TABLES `base_red_packet_vip` WRITE;
/*!40000 ALTER TABLE `base_red_packet_vip` DISABLE KEYS */;
INSERT INTO `base_red_packet_vip` VALUES (1,1,1,'VIP红包',100,5),(2,2,2,'vip2红包',200,10),(3,3,3,'vip3红包',300,15),(4,4,4,'vip4红包',400,20),(5,5,5,'vip5红包',500,25),(6,6,6,'vip6红包',600,30),(7,7,7,'vip7红包',700,35),(8,8,8,'vip8红包',800,40),(9,9,9,'vip9红包',900,40),(10,10,10,'vip10红包',1000,40),(11,11,11,'vip11红包',1100,40),(12,12,12,'vip12红包',1200,40),(13,13,13,'vip13红包',1300,40),(14,14,14,'vip14红包',1400,40),(15,15,15,'vip15红包',1500,40);
/*!40000 ALTER TABLE `base_red_packet_vip` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_reincarnation_cfg`
--

DROP TABLE IF EXISTS `base_reincarnation_cfg`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_reincarnation_cfg` (
  `career` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '职业',
  `sex` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '性别',
  `turn` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '转生次数',
  `icon` varchar(255) NOT NULL DEFAULT '' COMMENT '头像',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '名字@lang@',
  `model_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '头部模型id',
  `attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '属性加成',
  `unlock_skill` varchar(255) NOT NULL DEFAULT '[]' COMMENT '解锁技能',
  `replace_skill` varchar(255) NOT NULL DEFAULT '[]' COMMENT '强化技能',
  `unlock_other` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '解锁其它',
  PRIMARY KEY (`career`,`sex`,`turn`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='转生配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_reincarnation_cfg`
--

LOCK TABLES `base_reincarnation_cfg` WRITE;
/*!40000 ALTER TABLE `base_reincarnation_cfg` DISABLE KEYS */;
INSERT INTO `base_reincarnation_cfg` VALUES (1,1,0,'1000','魔剑士',101000,'[]','[]','[]','[]'),(1,1,1,'1001','重剑士',101000,'[{1,360},{2,7200},{3,180},{4,180}]','[500000001,500000002]','[]','[24030002,1001010543,1004010643]'),(1,1,2,'1002','大剑士',101000,'[{1,720},{2,14400},{3,360},{4,360}]','[500000003,500000004]','[]','[24030003,1001010743,1004010843]'),(1,1,3,'1003','狂剑士',101000,'[{1,1080},{2,21600},{3,540},{4,540}]','[500000005,500000006]','[]','[24030004,1001010943,1004010943]'),(1,1,4,'1004','星曜剑士',101000,'[]','[500000007,500000008]','[]','[24030005,1001011043,1001011143,1002011043,1002011143]'),(1,1,5,'1005','圣谕剑士',101000,'[]','[]','[]','[24030006,1001011243,1001011343,1002011243,1002011343]'),(2,1,0,'2000','龙骑士',102000,'[]','[]','[]','[]'),(2,1,1,'2001','唤龙骑士',102000,'[{1,360},{2,7200},{3,180},{4,180}]','[500000021,500000022]','[]','[24030002,1001020543,1004020643]'),(2,1,2,'2002','御龙骑士',102000,'[{1,720},{2,14400},{3,360},{4,360}]','[500000023,500000024]','[]','[24030003,1001020743,1004020843]'),(2,1,3,'2003','屠龙骑士',102000,'[{1,1080},{2,21600},{3,540},{4,540}]','[500000025,500000026]','[]','[24030004,1001020943,1004020943]'),(2,1,4,'2004','灭龙骑士',102000,'[]','[500000027,500000028]','[]','[24030005,1001021043,1001021143,1002021043,1002021143]'),(2,1,5,'2005','真龙骑士',102000,'[]','[]','[]','[24030006,1001021243,1001021343,1002021243,1002021343]'),(3,2,0,'3000','魔导师',103000,'[]','[]','[]','[]'),(3,2,1,'3001','光魔导师',103000,'[{1,360},{2,7200},{3,180},{4,180}]','[]','[]','[]'),(3,2,2,'3002','黑魔导师',103000,'[{1,720},{2,14400},{3,360},{4,360}]','[]','[]','[]'),(3,2,3,'3003','猎魔导师',103000,'[{1,1080},{2,21600},{3,540},{4,540}]','[]','[]','[]'),(3,2,4,'3004','圣魔导师',103000,'[]','[]','[]','[]'),(3,2,5,'3005','真魔导师',103000,'[]','[]','[]','[]'),(4,2,0,'4000','重炮手',104000,'[]','[]','[]','[]'),(4,2,1,'4001','枪炮师',104000,'[{1,360},{2,7200},{3,180},{4,180}]','[500000041,500000042]','[]','[24030002,1001040543,1004040643]'),(4,2,2,'4002','爆破专家',104000,'[{1,720},{2,14400},{3,360},{4,360}]','[500000043,500000044]','[]','[24030003,1001040743,1004040843]'),(4,2,3,'4003','武装佣兵',104000,'[{1,1080},{2,21600},{3,540},{4,540}]','[500000045,500000046]','[]','[24030004,1001040943,1004040943]'),(4,2,4,'4004','暴走炮手',104000,'[]','[500000047,500000048]','[]','[24030005,1001041043,1001041143,1002041043,1002041143]'),(4,2,5,'4005','风暴枪手',104000,'[]','[]','[]','[24030006,1001041243,1001041343,1002041243,1002041343]');
/*!40000 ALTER TABLE `base_reincarnation_cfg` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_reincarnation_info_cfg`
--

DROP TABLE IF EXISTS `base_reincarnation_info_cfg`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_reincarnation_info_cfg` (
  `turn` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '转生数',
  `stage` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '阶段',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '阶段名@lang@',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '描述@lang@',
  `task_ids` varchar(255) NOT NULL DEFAULT '[]' COMMENT '任务列表',
  PRIMARY KEY (`turn`,`stage`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='转生阶段描述';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_reincarnation_info_cfg`
--

LOCK TABLES `base_reincarnation_info_cfg` WRITE;
/*!40000 ALTER TABLE `base_reincarnation_info_cfg` DISABLE KEYS */;
INSERT INTO `base_reincarnation_info_cfg` VALUES (1,1,'一转开启','经过不懈的历练和成长，埃罗恩大法师认为你要通过转职来突破自己，准备好迎接转职的一系列挑战了吗？','[1,2]'),(1,2,'见习勇者','开启转职试炼需要消耗大量能量，而只有通过搜集足够的转职道具，才能打开通往最终试炼的大门！（点击转职任务前往打怪，有概率掉落<color=#62e874>风神翎羽</color>）','[3,4]'),(1,3,'一转试炼','转职试炼开启，属于你的荣耀时刻，最终迎来的是蜕变？还是失败呢？放手一搏吧！','[5]'),(2,1,'二转开启','经过不懈的历练和成长，埃罗恩大法师认为你要通过转职来突破自己，准备好迎接转职的一系列挑战了吗？','[6,7]'),(2,2,'渐入佳境','开启转职试炼需要消耗大量能量，而只有通过搜集足够的转职道具，才能打开通往最终试炼的大门！（点击转职任务前往打怪，有概率掉落<color=#62e874>暗裔之爪</color>，也可通过商城或者市场直接购买）','[8,9]'),(2,3,'二转试炼','转职试炼开启，属于你的荣耀时刻，最终迎来的是蜕变？还是失败呢？放手一搏吧！','[10]'),(3,1,'三转开启','经过不懈的历练和成长，埃罗恩大法师认为你要通过转职来突破自己，准备好迎接转职的一系列挑战了吗？','[11,12]'),(3,2,'轻车熟路','开启转职试炼需要消耗大量能量，而只有通过搜集足够的转职道具，才能打开通往最终试炼的大门！（点击转职任务前往打怪，有概率掉落<color=#62e874>盖娅源石</color>，也可通过商城或者市场直接购买）','[13,14]'),(3,3,'三转试炼','转职试炼开启，属于你的荣耀时刻，最终迎来的是蜕变？还是失败呢？放手一搏吧！','[15]'),(4,1,'四转觉醒','四转星界觉醒，广袤的宇宙中蕴含着无穷的奥秘和能量，灌注躯体之后便可突破自身等级限制，接近神域！','[16]'),(5,1,'五转觉醒','五转踏入神域，开始领悟星界宇宙的浩瀚奥秘，真理之门正在开启，无尽的能量向你袭来！','[17]');
/*!40000 ALTER TABLE `base_reincarnation_info_cfg` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_reincarnation_task_cfg`
--

DROP TABLE IF EXISTS `base_reincarnation_task_cfg`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_reincarnation_task_cfg` (
  `task_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '任务id',
  `turn` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '转生次数',
  `stage` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '阶段',
  `attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '属性奖励',
  PRIMARY KEY (`task_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='转生任务属性奖励';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_reincarnation_task_cfg`
--

LOCK TABLES `base_reincarnation_task_cfg` WRITE;
/*!40000 ALTER TABLE `base_reincarnation_task_cfg` DISABLE KEYS */;
INSERT INTO `base_reincarnation_task_cfg` VALUES (1,1,1,'[]'),(2,1,1,'[]'),(3,1,2,'[]'),(4,1,2,'[]'),(5,1,3,'[]'),(6,2,1,'[]'),(7,2,1,'[]'),(8,2,2,'[]'),(9,2,2,'[]'),(10,2,3,'[]'),(11,3,1,'[]'),(12,3,1,'[]'),(13,3,2,'[]'),(14,3,2,'[]'),(15,3,3,'[]'),(16,4,1,'[]'),(17,5,1,'[]');
/*!40000 ALTER TABLE `base_reincarnation_task_cfg` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_rela_config`
--

DROP TABLE IF EXISTS `base_rela_config`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_rela_config` (
  `key` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'key',
  `value` varchar(1024) NOT NULL DEFAULT '[]' COMMENT 'value',
  `about` varchar(1024) NOT NULL COMMENT '说明@lang@',
  PRIMARY KEY (`key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='社交配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_rela_config`
--

LOCK TABLES `base_rela_config` WRITE;
/*!40000 ALTER TABLE `base_rela_config` DISABLE KEYS */;
INSERT INTO `base_rela_config` VALUES (1,'50','好友数量上限');
/*!40000 ALTER TABLE `base_rela_config` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_res_act`
--

DROP TABLE IF EXISTS `base_res_act`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_res_act` (
  `act_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动id',
  `act_sub` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类',
  `level` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家最小等级',
  `level_max` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家等级上限',
  `server_min_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '世界最小等级',
  `server_max_lv` int(11) NOT NULL DEFAULT '0' COMMENT '世界最大等级',
  `dun_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本id',
  `guild_limit` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '公会限制（1：需要公会 0：不需要）',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '名称',
  `coin_per` varchar(255) NOT NULL DEFAULT '[]' COMMENT '金币消耗',
  `coin_goods` varchar(255) NOT NULL DEFAULT '[]' COMMENT '金币对应奖励',
  `gold_per` varchar(255) NOT NULL DEFAULT '[]' COMMENT '绑钻消耗',
  `gold_goods` varchar(255) NOT NULL DEFAULT '[]' COMMENT '绑钻对应奖励',
  `filter_list` varchar(50) NOT NULL DEFAULT '[]' COMMENT '筛选id',
  PRIMARY KEY (`act_id`,`act_sub`,`level`,`level_max`,`server_min_lv`,`server_max_lv`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='资源找回配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_res_act`
--

LOCK TABLES `base_res_act` WRITE;
/*!40000 ALTER TABLE `base_res_act` DISABLE KEYS */;
INSERT INTO `base_res_act` VALUES (174,0,0,0,110,199,0,0,'智慧达人','[{3,36030001,500}]','[{5,36060001,7079590}]','[{2,36020001,25}]','[{5,36060001,14159180}]','[1]'),(174,0,0,0,200,259,0,0,'智慧达人','[{3,36030001,500}]','[{5,36060001,7831990}]','[{2,36020001,25}]','[{5,36060001,15663980}]','[1]'),(174,0,0,0,260,319,0,0,'智慧达人','[{3,36030001,500}]','[{5,36060001,12652432}]','[{2,36020001,25}]','[{5,36060001,25304863}]','[1]'),(174,0,0,0,320,349,0,0,'智慧达人','[{3,36030001,500}]','[{5,36060001,14948808}]','[{2,36020001,25}]','[{5,36060001,29897616}]','[1]'),(174,0,0,0,350,369,0,0,'智慧达人','[{3,36030001,500}]','[{5,36060001,17095376}]','[{2,36020001,25}]','[{5,36060001,34190751}]','[1]'),(174,0,0,0,370,389,0,0,'智慧达人','[{3,36030001,500}]','[{5,36060001,27623481}]','[{2,36020001,25}]','[{5,36060001,55246961}]','[1]'),(174,0,0,0,390,429,0,0,'智慧达人','[{3,36030001,500}]','[{5,36060001,38559213}]','[{2,36020001,25}]','[{5,36060001,77118425}]','[1]'),(174,0,0,0,430,499,0,0,'智慧达人','[{3,36030001,500}]','[{5,36060001,53759213}]','[{2,36020001,25}]','[{5,36060001,107518425}]','[1]'),(174,0,0,0,500,559,0,0,'智慧达人','[{3,36030001,500}]','[{5,36060001,88484410}]','[{2,36020001,25}]','[{5,36060001,176968819}]','[1]'),(174,0,0,0,560,609,0,0,'智慧达人','[{3,36030001,500}]','[{5,36060001,162444607}]','[{2,36020001,25}]','[{5,36060001,324889213}]','[1]'),(174,0,0,0,610,659,0,0,'智慧达人','[{3,36030001,500}]','[{5,36060001,200444607}]','[{2,36020001,25}]','[{5,36060001,400889213}]','[1]'),(174,0,0,0,660,749,0,0,'智慧达人','[{3,36030001,500}]','[{5,36060001,238444607}]','[{2,36020001,25}]','[{5,36060001,476889213}]','[1]'),(174,0,0,0,750,799,0,0,'智慧达人','[{3,36030001,500}]','[{5,36060001,306844607}]','[{2,36020001,25}]','[{5,36060001,613689213}]','[1]'),(174,0,0,0,800,1000,0,0,'智慧达人','[{3,36030001,500}]','[{5,36060001,337244607}]','[{2,36020001,25}]','[{5,36060001,674489213}]','[1]'),(280,0,115,200,0,0,0,0,'竞技场','[{3,36030001,500}]','[{16,0,60},{5,36060001,783199}]','[{2,36020001,5}]','[{16,0,120},{5,36060001,1566398}]','[1,4]'),(280,0,201,260,0,0,0,0,'竞技场','[{3,36030001,500}]','[{16,0,60},{5,36060001,1169103}]','[{2,36020001,5}]','[{16,0,120},{5,36060001,2338206}]','[1,4]'),(280,0,261,340,0,0,0,0,'竞技场','[{3,36030001,500}]','[{16,0,60},{5,36060001,1494881}]','[{2,36020001,5}]','[{16,0,120},{5,36060001,2989762}]','[1,4]'),(280,0,341,380,0,0,0,0,'竞技场','[{3,36030001,500}]','[{16,0,60},{5,36060001,1823101}]','[{2,36020001,5}]','[{16,0,120},{5,36060001,3646202}]','[1,4]'),(280,0,381,400,0,0,0,0,'竞技场','[{3,36030001,500}]','[{16,0,60},{5,36060001,3475921}]','[{2,36020001,5}]','[{16,0,120},{5,36060001,6951843}]','[1,4]'),(280,0,401,440,0,0,0,0,'竞技场','[{3,36030001,500}]','[{16,0,60},{5,36060001,4995921}]','[{2,36020001,5}]','[{16,0,120},{5,36060001,9991843}]','[1,4]'),(280,0,441,480,0,0,0,0,'竞技场','[{3,36030001,500}]','[{16,0,60},{5,36060001,7323019}]','[{2,36020001,5}]','[{16,0,120},{5,36060001,14646038}]','[1,4]'),(280,0,481,500,0,0,0,0,'竞技场','[{3,36030001,500}]','[{16,0,60},{5,36060001,8278441}]','[{2,36020001,5}]','[{16,0,120},{5,36060001,16556882}]','[1,4]'),(280,0,501,520,0,0,0,0,'竞技场','[{3,36030001,500}]','[{16,0,60},{5,36060001,8848441}]','[{2,36020001,5}]','[{16,0,120},{5,36060001,17696882}]','[1,4]'),(280,0,521,540,0,0,0,0,'竞技场','[{3,36030001,500}]','[{16,0,60},{5,36060001,10158688}]','[{2,36020001,5}]','[{16,0,120},{5,36060001,20317376}]','[1,4]'),(280,0,541,560,0,0,0,0,'竞技场','[{3,36030001,500}]','[{16,0,60},{5,36060001,13252014}]','[{2,36020001,5}]','[{16,0,120},{5,36060001,26504029}]','[1,4]'),(280,0,561,580,0,0,0,0,'竞技场','[{3,36030001,500}]','[{16,0,60},{5,36060001,16244460}]','[{2,36020001,5}]','[{16,0,120},{5,36060001,32488921}]','[1,4]'),(280,0,581,600,0,0,0,0,'竞技场','[{3,36030001,500}]','[{16,0,60},{5,36060001,17764460}]','[{2,36020001,5}]','[{16,0,120},{5,36060001,35528921}]','[1,4]'),(280,0,601,620,0,0,0,0,'竞技场','[{3,36030001,500}]','[{16,0,60},{5,36060001,19284460}]','[{2,36020001,5}]','[{16,0,120},{5,36060001,38568921}]','[1,4]'),(280,0,621,640,0,0,0,0,'竞技场','[{3,36030001,500}]','[{16,0,60},{5,36060001,20804460}]','[{2,36020001,5}]','[{16,0,120},{5,36060001,41608921}]','[1,4]'),(280,0,641,660,0,0,0,0,'竞技场','[{3,36030001,500}]','[{16,0,60},{5,36060001,22324460}]','[{2,36020001,5}]','[{16,0,120},{5,36060001,44648921}]','[1,4]'),(280,0,661,680,0,0,0,0,'竞技场','[{3,36030001,500}]','[{16,0,60},{5,36060001,23844460}]','[{2,36020001,5}]','[{16,0,120},{5,36060001,47688921}]','[1,4]'),(280,0,681,700,0,0,0,0,'竞技场','[{3,36030001,500}]','[{16,0,60},{5,36060001,25364460}]','[{2,36020001,5}]','[{16,0,120},{5,36060001,50728921}]','[1,4]'),(280,0,701,720,0,0,0,0,'竞技场','[{3,36030001,500}]','[{16,0,60},{5,36060001,26884460}]','[{2,36020001,5}]','[{16,0,120},{5,36060001,53768921}]','[1,4]'),(280,0,721,740,0,0,0,0,'竞技场','[{3,36030001,500}]','[{16,0,60},{5,36060001,28404460}]','[{2,36020001,5}]','[{16,0,120},{5,36060001,56808921}]','[1,4]'),(280,0,741,760,0,0,0,0,'竞技场','[{3,36030001,500}]','[{16,0,60},{5,36060001,29924460}]','[{2,36020001,5}]','[{16,0,120},{5,36060001,59848921}]','[1,4]'),(280,0,761,780,0,0,0,0,'竞技场','[{3,36030001,500}]','[{16,0,60},{5,36060001,31444460}]','[{2,36020001,5}]','[{16,0,120},{5,36060001,62888921}]','[1,4]'),(280,0,781,1000,0,0,0,0,'竞技场','[{3,36030001,500}]','[{16,0,60},{5,36060001,33724460}]','[{2,36020001,5}]','[{16,0,120},{5,36060001,67448921}]','[1,4]'),(300,6,50,103,0,0,0,1,'公会任务','[{3,36030001,500}]','[{5,36060001,2669997},{4,36050001,1000}]','[{2,36020001,10}]','[{5,36060001,5339994},{4,36050001,2000}]','[1]'),(300,6,104,138,0,0,0,1,'公会任务','[{3,36030001,500}]','[{5,36060001,2669997},{4,36050001,1000}]','[{2,36020001,10}]','[{5,36060001,5339994},{4,36050001,2000}]','[1]'),(300,6,139,178,0,0,0,1,'公会任务','[{3,36030001,500}]','[{5,36060001,2669997},{4,36050001,1000}]','[{2,36020001,10}]','[{5,36060001,5339994},{4,36050001,2000}]','[1]'),(300,6,179,238,0,0,0,1,'公会任务','[{3,36030001,500}]','[{5,36060001,2669997},{4,36050001,1000}]','[{2,36020001,10}]','[{5,36060001,5339994},{4,36050001,2000}]','[1]'),(300,6,239,278,0,0,0,1,'公会任务','[{3,36030001,500}]','[{5,36060001,2669997},{4,36050001,1000}]','[{2,36020001,10}]','[{5,36060001,5339994},{4,36050001,2000}]','[1]'),(300,6,279,318,0,0,0,1,'公会任务','[{3,36030001,500}]','[{5,36060001,3653448},{4,36050001,1000}]','[{2,36020001,10}]','[{5,36060001,7306895},{4,36050001,2000}]','[1]'),(300,6,319,348,0,0,0,1,'公会任务','[{3,36030001,500}]','[{5,36060001,4114892},{4,36050001,1000}]','[{2,36020001,10}]','[{5,36060001,8229784},{4,36050001,2000}]','[1]'),(300,6,349,373,0,0,0,1,'公会任务','[{3,36030001,500}]','[{5,36060001,4671503},{4,36050001,1000}]','[{2,36020001,10}]','[{5,36060001,9343005},{4,36050001,2000}]','[1]'),(300,6,374,398,0,0,0,1,'公会任务','[{3,36030001,500}]','[{5,36060001,4931359},{4,36050001,1000}]','[{2,36020001,10}]','[{5,36060001,9862717},{4,36050001,2000}]','[1]'),(300,6,399,423,0,0,0,1,'公会任务','[{3,36030001,500}]','[{5,36060001,7968312},{4,36050001,1000}]','[{2,36020001,10}]','[{5,36060001,15936624},{4,36050001,2000}]','[1]'),(300,6,424,448,0,0,0,1,'公会任务','[{3,36030001,500}]','[{5,36060001,11346218},{4,36050001,1000}]','[{2,36020001,10}]','[{5,36060001,22692436},{4,36050001,2000}]','[1]'),(300,6,449,473,0,0,0,1,'公会任务','[{3,36030001,500}]','[{5,36060001,13381932},{4,36050001,1000}]','[{2,36020001,10}]','[{5,36060001,26763864},{4,36050001,2000}]','[1]'),(300,6,474,513,0,0,0,1,'公会任务','[{3,36030001,500}]','[{5,36060001,16702742},{4,36050001,1000}]','[{2,36020001,10}]','[{5,36060001,33405484},{4,36050001,2000}]','[1]'),(300,6,514,548,0,0,0,1,'公会任务','[{3,36030001,500}]','[{5,36060001,19983603},{4,36050001,1000}]','[{2,36020001,10}]','[{5,36060001,39967205},{4,36050001,2000}]','[1]'),(300,6,549,573,0,0,0,1,'公会任务','[{3,36030001,500}]','[{5,36060001,21406502},{4,36050001,1000}]','[{2,36020001,10}]','[{5,36060001,42813004},{4,36050001,2000}]','[1]'),(300,6,574,593,0,0,0,1,'公会任务','[{3,36030001,500}]','[{5,36060001,34477120},{4,36050001,1000}]','[{2,36020001,10}]','[{5,36060001,68954239},{4,36050001,2000}]','[1]'),(300,6,594,608,0,0,0,1,'公会任务','[{3,36030001,500}]','[{5,36060001,37509840},{4,36050001,1000}]','[{2,36020001,10}]','[{5,36060001,75019679},{4,36050001,2000}]','[1]'),(300,6,609,628,0,0,0,1,'公会任务','[{3,36030001,500}]','[{5,36060001,40862781},{4,36050001,1000}]','[{2,36020001,10}]','[{5,36060001,81725562},{4,36050001,2000}]','[1]'),(300,6,629,648,0,0,0,1,'公会任务','[{3,36030001,500}]','[{5,36060001,41759293},{4,36050001,1000}]','[{2,36020001,10}]','[{5,36060001,83518586},{4,36050001,2000}]','[1]'),(300,6,649,668,0,0,0,1,'公会任务','[{3,36030001,500}]','[{5,36060001,44925960},{4,36050001,1000}]','[{2,36020001,10}]','[{5,36060001,89851919},{4,36050001,2000}]','[1]'),(300,6,669,688,0,0,0,1,'公会任务','[{3,36030001,500}]','[{5,36060001,45561436},{4,36050001,1000}]','[{2,36020001,10}]','[{5,36060001,91122871},{4,36050001,2000}]','[1]'),(300,6,689,708,0,0,0,1,'公会任务','[{3,36030001,500}]','[{5,36060001,48561436},{4,36050001,1000}]','[{2,36020001,10}]','[{5,36060001,97122871},{4,36050001,2000}]','[1]'),(300,6,709,728,0,0,0,1,'公会任务','[{3,36030001,500}]','[{5,36060001,48983364},{4,36050001,1000}]','[{2,36020001,10}]','[{5,36060001,97966728},{4,36050001,2000}]','[1]'),(300,6,729,748,0,0,0,1,'公会任务','[{3,36030001,500}]','[{5,36060001,51833364},{4,36050001,1000}]','[{2,36020001,10}]','[{5,36060001,103666728},{4,36050001,2000}]','[1]'),(300,6,749,768,0,0,0,1,'公会任务','[{3,36030001,500}]','[{5,36060001,54683364},{4,36050001,1000}]','[{2,36020001,10}]','[{5,36060001,109366728},{4,36050001,2000}]','[1]'),(300,6,769,788,0,0,0,1,'公会任务','[{3,36030001,500}]','[{5,36060001,57533364},{4,36050001,1000}]','[{2,36020001,10}]','[{5,36060001,115066728},{4,36050001,2000}]','[1]'),(300,6,789,808,0,0,0,1,'公会任务','[{3,36030001,500}]','[{5,36060001,60383364},{4,36050001,1000}]','[{2,36020001,10}]','[{5,36060001,120766728},{4,36050001,2000}]','[1]'),(300,6,809,828,0,0,0,1,'公会任务','[{3,36030001,500}]','[{5,36060001,63233364},{4,36050001,1000}]','[{2,36020001,10}]','[{5,36060001,126466728},{4,36050001,2000}]','[1]'),(300,6,829,848,0,0,0,1,'公会任务','[{3,36030001,500}]','[{5,36060001,63233364},{4,36050001,1000}]','[{2,36020001,10}]','[{5,36060001,126466728},{4,36050001,2000}]','[1]'),(300,6,849,868,0,0,0,1,'公会任务','[{3,36030001,500}]','[{5,36060001,63233364},{4,36050001,1000}]','[{2,36020001,10}]','[{5,36060001,126466728},{4,36050001,2000}]','[1]'),(300,6,869,888,0,0,0,1,'公会任务','[{3,36030001,500}]','[{5,36060001,63233364},{4,36050001,1000}]','[{2,36020001,10}]','[{5,36060001,126466728},{4,36050001,2000}]','[1]'),(300,6,889,908,0,0,0,1,'公会任务','[{3,36030001,500}]','[{5,36060001,63233364},{4,36050001,1000}]','[{2,36020001,10}]','[{5,36060001,126466728},{4,36050001,2000}]','[1]'),(300,6,909,928,0,0,0,1,'公会任务','[{3,36030001,500}]','[{5,36060001,63233364},{4,36050001,1000}]','[{2,36020001,10}]','[{5,36060001,126466728},{4,36050001,2000}]','[1]'),(300,6,929,948,0,0,0,1,'公会任务','[{3,36030001,500}]','[{5,36060001,63233364},{4,36050001,1000}]','[{2,36020001,10}]','[{5,36060001,126466728},{4,36050001,2000}]','[1]'),(300,6,949,968,0,0,0,1,'公会任务','[{3,36030001,500}]','[{5,36060001,63233364},{4,36050001,1000}]','[{2,36020001,10}]','[{5,36060001,126466728},{4,36050001,2000}]','[1]'),(300,6,969,988,0,0,0,1,'公会任务','[{3,36030001,500}]','[{5,36060001,63233364},{4,36050001,1000}]','[{2,36020001,10}]','[{5,36060001,126466728},{4,36050001,2000}]','[1]'),(300,6,989,999,0,0,0,1,'公会任务','[{3,36030001,500}]','[{5,36060001,63233364},{4,36050001,1000}]','[{2,36020001,10}]','[{5,36060001,126466728},{4,36050001,2000}]','[1]'),(300,6,1000,1000,0,0,0,1,'公会任务','[{3,36030001,500}]','[{5,36060001,63233364},{4,36050001,1000}]','[{2,36020001,10}]','[{5,36060001,126466728},{4,36050001,2000}]','[1]'),(300,7,55,103,0,0,0,0,'日常任务','[{3,36030001,500}]','[{5,36060001,179125},{3,36030001,5000}]','[{2,36020001,5}]','[{5,36060001,358250},{3,36030001,10000}]','[1,3]'),(300,7,104,138,0,0,0,0,'日常任务','[{3,36030001,500}]','[{5,36060001,179125},{3,36030001,5000}]','[{2,36020001,5}]','[{5,36060001,358250},{3,36030001,10000}]','[1,3]'),(300,7,139,178,0,0,0,0,'日常任务','[{3,36030001,500}]','[{5,36060001,179125},{3,36030001,5000}]','[{2,36020001,5}]','[{5,36060001,358250},{3,36030001,10000}]','[1,3]'),(300,7,179,238,0,0,0,0,'日常任务','[{3,36030001,500}]','[{5,36060001,179125},{3,36030001,5000}]','[{2,36020001,5}]','[{5,36060001,358250},{3,36030001,10000}]','[1,3]'),(300,7,239,278,0,0,0,0,'日常任务','[{3,36030001,500}]','[{5,36060001,1468498},{3,36030001,5965}]','[{2,36020001,5}]','[{5,36060001,2936996},{3,36030001,11930}]','[1,3]'),(300,7,279,318,0,0,0,0,'日常任务','[{3,36030001,500}]','[{5,36060001,2192069},{3,36030001,5965}]','[{2,36020001,5}]','[{5,36060001,4384137},{3,36030001,11930}]','[1,3]'),(300,7,319,348,0,0,0,0,'日常任务','[{3,36030001,500}]','[{5,36060001,2468936},{3,36030001,6530}]','[{2,36020001,5}]','[{5,36060001,4937871},{3,36030001,13060}]','[1,3]'),(300,7,349,373,0,0,0,0,'日常任务','[{3,36030001,500}]','[{5,36060001,2802902},{3,36030001,8135}]','[{2,36020001,5}]','[{5,36060001,5605803},{3,36030001,16270}]','[1,3]'),(300,7,374,398,0,0,0,0,'日常任务','[{3,36030001,500}]','[{5,36060001,3205383},{3,36030001,9100}]','[{2,36020001,5}]','[{5,36060001,6410766},{3,36030001,18200}]','[1,3]'),(300,7,399,423,0,0,0,0,'日常任务','[{3,36030001,500}]','[{5,36060001,5179403},{3,36030001,12080}]','[{2,36020001,5}]','[{5,36060001,10358805},{3,36030001,24160}]','[1,3]'),(300,7,424,448,0,0,0,0,'日常任务','[{3,36030001,500}]','[{5,36060001,7942353},{3,36030001,12420}]','[{2,36020001,5}]','[{5,36060001,15884705},{3,36030001,24840}]','[1,3]'),(300,7,449,473,0,0,0,0,'日常任务','[{3,36030001,500}]','[{5,36060001,9367353},{3,36030001,12755}]','[{2,36020001,5}]','[{5,36060001,18734705},{3,36030001,25510}]','[1,3]'),(300,7,474,513,0,0,0,0,'日常任务','[{3,36030001,500}]','[{5,36060001,12527057},{3,36030001,13825}]','[{2,36020001,5}]','[{5,36060001,25054113},{3,36030001,27650}]','[1,3]'),(300,7,514,548,0,0,0,0,'日常任务','[{3,36030001,500}]','[{5,36060001,14987702},{3,36030001,16235}]','[{2,36020001,5}]','[{5,36060001,29975404},{3,36030001,32470}]','[1,3]'),(300,7,549,573,0,0,0,0,'日常任务','[{3,36030001,500}]','[{5,36060001,17125202},{3,36030001,16800}]','[{2,36020001,5}]','[{5,36060001,34250404},{3,36030001,33600}]','[1,3]'),(300,7,574,593,0,0,0,0,'日常任务','[{3,36030001,500}]','[{5,36060001,27581696},{3,36030001,17385}]','[{2,36020001,5}]','[{5,36060001,55163391},{3,36030001,34770}]','[1,3]'),(300,7,594,608,0,0,0,0,'日常任务','[{3,36030001,500}]','[{5,36060001,31883364},{3,36030001,17955}]','[{2,36020001,5}]','[{5,36060001,63766727},{3,36030001,35910}]','[1,3]'),(300,7,609,628,0,0,0,0,'日常任务','[{3,36030001,500}]','[{5,36060001,34733364},{3,36030001,18460}]','[{2,36020001,5}]','[{5,36060001,69466727},{3,36030001,36920}]','[1,3]'),(300,7,629,648,0,0,0,0,'日常任务','[{3,36030001,500}]','[{5,36060001,37583364},{3,36030001,19255}]','[{2,36020001,5}]','[{5,36060001,75166727},{3,36030001,38510}]','[1,3]'),(300,7,649,668,0,0,0,0,'日常任务','[{3,36030001,500}]','[{5,36060001,40433364},{3,36030001,20550}]','[{2,36020001,5}]','[{5,36060001,80866727},{3,36030001,41100}]','[1,3]'),(300,7,669,688,0,0,0,0,'日常任务','[{3,36030001,500}]','[{5,36060001,43283364},{3,36030001,21715}]','[{2,36020001,5}]','[{5,36060001,86566727},{3,36030001,43430}]','[1,3]'),(300,7,689,708,0,0,0,0,'日常任务','[{3,36030001,500}]','[{5,36060001,46133364},{3,36030001,25220}]','[{2,36020001,5}]','[{5,36060001,92266727},{3,36030001,50440}]','[1,3]'),(300,7,709,728,0,0,0,0,'日常任务','[{3,36030001,500}]','[{5,36060001,48983364},{3,36030001,28930}]','[{2,36020001,5}]','[{5,36060001,97966727},{3,36030001,57860}]','[1,3]'),(300,7,729,748,0,0,0,0,'日常任务','[{3,36030001,500}]','[{5,36060001,51833364},{3,36030001,33915}]','[{2,36020001,5}]','[{5,36060001,103666727},{3,36030001,67830}]','[1,3]'),(300,7,749,768,0,0,0,0,'日常任务','[{3,36030001,500}]','[{5,36060001,54683364},{3,36030001,39385}]','[{2,36020001,5}]','[{5,36060001,109366727},{3,36030001,78770}]','[1,3]'),(300,7,769,788,0,0,0,0,'日常任务','[{3,36030001,500}]','[{5,36060001,57533364},{3,36030001,45175}]','[{2,36020001,5}]','[{5,36060001,115066727},{3,36030001,90350}]','[1,3]'),(300,7,789,808,0,0,0,0,'日常任务','[{3,36030001,500}]','[{5,36060001,60383364},{3,36030001,51700}]','[{2,36020001,5}]','[{5,36060001,120766727},{3,36030001,103400}]','[1,3]'),(300,7,809,828,0,0,0,0,'日常任务','[{3,36030001,500}]','[{5,36060001,63233364},{3,36030001,58695}]','[{2,36020001,5}]','[{5,36060001,126466727},{3,36030001,117390}]','[1,3]'),(300,7,829,848,0,0,0,0,'日常任务','[{3,36030001,500}]','[{5,36060001,63233364},{3,36030001,65805}]','[{2,36020001,5}]','[{5,36060001,126466727},{3,36030001,131610}]','[1,3]'),(300,7,849,868,0,0,0,0,'日常任务','[{3,36030001,500}]','[{5,36060001,63233364},{3,36030001,73765}]','[{2,36020001,5}]','[{5,36060001,126466727},{3,36030001,147530}]','[1,3]'),(300,7,869,888,0,0,0,0,'日常任务','[{3,36030001,500}]','[{5,36060001,63233364},{3,36030001,86040}]','[{2,36020001,5}]','[{5,36060001,126466727},{3,36030001,172080}]','[1,3]'),(300,7,889,908,0,0,0,0,'日常任务','[{3,36030001,500}]','[{5,36060001,63233364},{3,36030001,102305}]','[{2,36020001,5}]','[{5,36060001,126466727},{3,36030001,204610}]','[1,3]'),(300,7,909,928,0,0,0,0,'日常任务','[{3,36030001,500}]','[{5,36060001,63233364},{3,36030001,119815}]','[{2,36020001,5}]','[{5,36060001,126466727},{3,36030001,239630}]','[1,3]'),(300,7,929,948,0,0,0,0,'日常任务','[{3,36030001,500}]','[{5,36060001,63233364},{3,36030001,138770}]','[{2,36020001,5}]','[{5,36060001,126466727},{3,36030001,277540}]','[1,3]'),(300,7,949,968,0,0,0,0,'日常任务','[{3,36030001,500}]','[{5,36060001,63233364},{3,36030001,153195}]','[{2,36020001,5}]','[{5,36060001,126466727},{3,36030001,306390}]','[1,3]'),(300,7,969,988,0,0,0,0,'日常任务','[{3,36030001,500}]','[{5,36060001,63233364},{3,36030001,158785}]','[{2,36020001,5}]','[{5,36060001,126466727},{3,36030001,317570}]','[1,3]'),(300,7,989,999,0,0,0,0,'日常任务','[{3,36030001,500}]','[{5,36060001,63233364},{3,36030001,164370}]','[{2,36020001,5}]','[{5,36060001,126466727},{3,36030001,328740}]','[1,3]'),(300,7,1000,1000,0,0,0,0,'日常任务','[{3,36030001,500}]','[{5,36060001,63233364},{3,36030001,167445}]','[{2,36020001,5}]','[{5,36060001,126466727},{3,36030001,334890}]','[1,3]'),(402,3,0,0,150,229,0,1,'守卫公会','[{3,36030001,1000}]','[{5,36060001,10619385}]','[{2,36020001,100}]','[{5,36060001,21238770}]','[1]'),(402,3,0,0,230,269,0,1,'守卫公会','[{3,36030001,1000}]','[{5,36060001,14945716}]','[{2,36020001,100}]','[{5,36060001,29891431}]','[1]'),(402,3,0,0,270,309,0,1,'守卫公会','[{3,36030001,1000}]','[{5,36060001,19879551}]','[{2,36020001,100}]','[{5,36060001,39759101}]','[1]'),(402,3,0,0,310,349,0,1,'守卫公会','[{3,36030001,1000}]','[{5,36060001,21075726}]','[{2,36020001,100}]','[{5,36060001,42151452}]','[1]'),(402,3,0,0,350,389,0,1,'守卫公会','[{3,36030001,1000}]','[{5,36060001,25643064}]','[{2,36020001,100}]','[{5,36060001,51286127}]','[1]'),(402,3,0,0,390,429,0,1,'守卫公会','[{3,36030001,1000}]','[{5,36060001,57838819}]','[{2,36020001,100}]','[{5,36060001,115677638}]','[1]'),(402,3,0,0,430,469,0,1,'守卫公会','[{3,36030001,1000}]','[{5,36060001,80638819}]','[{2,36020001,100}]','[{5,36060001,161277638}]','[1]'),(402,3,0,0,470,509,0,1,'守卫公会','[{3,36030001,1000}]','[{5,36060001,119901614}]','[{2,36020001,100}]','[{5,36060001,239803228}]','[1]'),(402,3,0,0,510,549,0,1,'守卫公会','[{3,36030001,1000}]','[{5,36060001,137001614}]','[{2,36020001,100}]','[{5,36060001,274003228}]','[1]'),(402,3,0,0,550,589,0,1,'守卫公会','[{3,36030001,1000}]','[{5,36060001,220653564}]','[{2,36020001,100}]','[{5,36060001,441307128}]','[1]'),(402,3,0,0,590,629,0,1,'守卫公会','[{3,36030001,1000}]','[{5,36060001,277866910}]','[{2,36020001,100}]','[{5,36060001,555733819}]','[1]'),(402,3,0,0,630,669,0,1,'守卫公会','[{3,36030001,1000}]','[{5,36060001,323466910}]','[{2,36020001,100}]','[{5,36060001,646933819}]','[1]'),(402,3,0,0,670,709,0,1,'守卫公会','[{3,36030001,1000}]','[{5,36060001,369066910}]','[{2,36020001,100}]','[{5,36060001,738133819}]','[1]'),(402,3,0,0,710,749,0,1,'守卫公会','[{3,36030001,1000}]','[{5,36060001,414666910}]','[{2,36020001,100}]','[{5,36060001,829333819}]','[1]'),(402,3,0,0,750,789,0,1,'守卫公会','[{3,36030001,1000}]','[{5,36060001,460266910}]','[{2,36020001,100}]','[{5,36060001,920533819}]','[1]'),(402,3,0,0,790,829,0,1,'守卫公会','[{3,36030001,1000}]','[{5,36060001,505866910}]','[{2,36020001,100}]','[{5,36060001,1011733819}]','[1]'),(402,3,0,0,830,869,0,1,'守卫公会','[{3,36030001,1000}]','[{5,36060001,505866910}]','[{2,36020001,100}]','[{5,36060001,1011733819}]','[1]'),(402,3,0,0,870,909,0,1,'守卫公会','[{3,36030001,1000}]','[{5,36060001,505866910}]','[{2,36020001,100}]','[{5,36060001,1011733819}]','[1]'),(402,3,0,0,910,949,0,1,'守卫公会','[{3,36030001,1000}]','[{5,36060001,505866910}]','[{2,36020001,100}]','[{5,36060001,1011733819}]','[1]'),(402,3,0,0,950,999,0,1,'守卫公会','[{3,36030001,1000}]','[{5,36060001,505866910}]','[{2,36020001,100}]','[{5,36060001,1011733819}]','[1]'),(402,3,0,0,1000,1000,0,1,'守卫公会','[{3,36030001,1000}]','[{5,36060001,505866910}]','[{2,36020001,100}]','[{5,36060001,1011733819}]','[1]'),(402,4,0,0,150,229,0,1,'公会争霸','[{3,36030001,750}]','[{5,36060001,10619385},{4,36050001,25000}]','[{2,36020001,75}]','[{5,36060001,21238770},{4,36050001,50000}]','[1]'),(402,4,0,0,230,269,0,1,'公会争霸','[{3,36030001,750}]','[{5,36060001,14945716},{4,36050001,27500}]','[{2,36020001,75}]','[{5,36060001,29891431},{4,36050001,55000}]','[1]'),(402,4,0,0,270,309,0,1,'公会争霸','[{3,36030001,750}]','[{5,36060001,19879551},{4,36050001,27500}]','[{2,36020001,75}]','[{5,36060001,39759101},{4,36050001,55000}]','[1]'),(402,4,0,0,310,349,0,1,'公会争霸','[{3,36030001,750}]','[{5,36060001,21075726},{4,36050001,30000}]','[{2,36020001,75}]','[{5,36060001,42151452},{4,36050001,60000}]','[1]'),(402,4,0,0,350,389,0,1,'公会争霸','[{3,36030001,750}]','[{5,36060001,25643064},{4,36050001,30000}]','[{2,36020001,75}]','[{5,36060001,51286127},{4,36050001,60000}]','[1]'),(402,4,0,0,390,429,0,1,'公会争霸','[{3,36030001,750}]','[{5,36060001,57838819},{4,36050001,30000}]','[{2,36020001,75}]','[{5,36060001,115677638},{4,36050001,60000}]','[1]'),(402,4,0,0,430,469,0,1,'公会争霸','[{3,36030001,750}]','[{5,36060001,80638819},{4,36050001,32500}]','[{2,36020001,75}]','[{5,36060001,161277638},{4,36050001,65000}]','[1]'),(402,4,0,0,470,509,0,1,'公会争霸','[{3,36030001,750}]','[{5,36060001,119901614},{4,36050001,32500}]','[{2,36020001,75}]','[{5,36060001,239803228},{4,36050001,65000}]','[1]'),(402,4,0,0,510,549,0,1,'公会争霸','[{3,36030001,750}]','[{5,36060001,137001614},{4,36050001,35000}]','[{2,36020001,75}]','[{5,36060001,274003228},{4,36050001,70000}]','[1]'),(402,4,0,0,550,589,0,1,'公会争霸','[{3,36030001,750}]','[{5,36060001,220653564},{4,36050001,37500}]','[{2,36020001,75}]','[{5,36060001,441307128},{4,36050001,75000}]','[1]'),(402,4,0,0,590,629,0,1,'公会争霸','[{3,36030001,750}]','[{5,36060001,277866910},{4,36050001,37500}]','[{2,36020001,75}]','[{5,36060001,555733819},{4,36050001,75000}]','[1]'),(402,4,0,0,630,669,0,1,'公会争霸','[{3,36030001,750}]','[{5,36060001,323466910},{4,36050001,40000}]','[{2,36020001,75}]','[{5,36060001,646933819},{4,36050001,80000}]','[1]'),(402,4,0,0,670,709,0,1,'公会争霸','[{3,36030001,750}]','[{5,36060001,369066910},{4,36050001,42500}]','[{2,36020001,75}]','[{5,36060001,738133819},{4,36050001,85000}]','[1]'),(402,4,0,0,710,749,0,1,'公会争霸','[{3,36030001,750}]','[{5,36060001,414666910},{4,36050001,45000}]','[{2,36020001,75}]','[{5,36060001,829333819},{4,36050001,90000}]','[1]'),(402,4,0,0,750,789,0,1,'公会争霸','[{3,36030001,750}]','[{5,36060001,460266910},{4,36050001,47500}]','[{2,36020001,75}]','[{5,36060001,920533819},{4,36050001,95000}]','[1]'),(402,4,0,0,790,829,0,1,'公会争霸','[{3,36030001,750}]','[{5,36060001,505866910},{4,36050001,47500}]','[{2,36020001,75}]','[{5,36060001,1011733819},{4,36050001,95000}]','[1]'),(402,4,0,0,830,869,0,1,'公会争霸','[{3,36030001,750}]','[{5,36060001,505866910},{4,36050001,50000}]','[{2,36020001,75}]','[{5,36060001,1011733819},{4,36050001,100000}]','[1]'),(402,4,0,0,870,909,0,1,'公会争霸','[{3,36030001,750}]','[{5,36060001,505866910},{4,36050001,52500}]','[{2,36020001,75}]','[{5,36060001,1011733819},{4,36050001,105000}]','[1]'),(402,4,0,0,910,949,0,1,'公会争霸','[{3,36030001,750}]','[{5,36060001,505866910},{4,36050001,55000}]','[{2,36020001,75}]','[{5,36060001,1011733819},{4,36050001,110000}]','[1]'),(402,4,0,0,950,999,0,1,'公会争霸','[{3,36030001,750}]','[{5,36060001,505866910},{4,36050001,57500}]','[{2,36020001,75}]','[{5,36060001,1011733819},{4,36050001,115000}]','[1]'),(402,4,0,0,1000,1000,0,1,'公会争霸','[{3,36030001,750}]','[{5,36060001,505866910},{4,36050001,57500}]','[{2,36020001,75}]','[{5,36060001,1011733819},{4,36050001,115000}]','[1]'),(403,0,0,0,1,230,0,1,'公会篝火','[{3,36030001,500}]','[{5,36060001,14945716}]','[{2,36020001,50}]','[{5,36060001,29891431}]','[1]'),(403,0,0,0,231,260,0,1,'公会篝火','[{3,36030001,500}]','[{5,36060001,18978647}]','[{2,36020001,50}]','[{5,36060001,37957294}]','[1]'),(403,0,0,0,261,300,0,1,'公会篝火','[{3,36030001,500}]','[{5,36060001,21243579}]','[{2,36020001,50}]','[{5,36060001,42487157}]','[1]'),(403,0,0,0,301,320,0,1,'公会篝火','[{3,36030001,500}]','[{5,36060001,22423212}]','[{2,36020001,50}]','[{5,36060001,44846424}]','[1]'),(403,0,0,0,321,340,0,1,'公会篝火','[{3,36030001,500}]','[{5,36060001,23870838}]','[{2,36020001,50}]','[{5,36060001,47741676}]','[1]'),(403,0,0,0,341,360,0,1,'公会篝火','[{3,36030001,500}]','[{5,36060001,27346516}]','[{2,36020001,50}]','[{5,36060001,54693032}]','[1]'),(403,0,0,0,361,380,0,1,'公会篝火','[{3,36030001,500}]','[{5,36060001,52138819}]','[{2,36020001,50}]','[{5,36060001,104277638}]','[1]'),(403,0,0,0,381,400,0,1,'公会篝火','[{3,36030001,500}]','[{5,36060001,63538819}]','[{2,36020001,50}]','[{5,36060001,127077638}]','[1]'),(403,0,0,0,401,420,0,1,'公会篝火','[{3,36030001,500}]','[{5,36060001,74938819}]','[{2,36020001,50}]','[{5,36060001,149877638}]','[1]'),(403,0,0,0,421,440,0,1,'公会篝火','[{3,36030001,500}]','[{5,36060001,85915364}]','[{2,36020001,50}]','[{5,36060001,171830728}]','[1]'),(403,0,0,0,441,460,0,1,'公会篝火','[{3,36030001,500}]','[{5,36060001,109845284}]','[{2,36020001,50}]','[{5,36060001,219690567}]','[1]'),(403,0,0,0,461,480,0,1,'公会篝火','[{3,36030001,500}]','[{5,36060001,124176614}]','[{2,36020001,50}]','[{5,36060001,248353228}]','[1]'),(403,0,0,0,481,500,0,1,'公会篝火','[{3,36030001,500}]','[{5,36060001,132726614}]','[{2,36020001,50}]','[{5,36060001,265453228}]','[1]'),(403,0,0,0,501,520,0,1,'公会篝火','[{3,36030001,500}]','[{5,36060001,152380320}]','[{2,36020001,50}]','[{5,36060001,304760640}]','[1]'),(403,0,0,0,521,540,0,1,'公会篝火','[{3,36030001,500}]','[{5,36060001,198780219}]','[{2,36020001,50}]','[{5,36060001,397560437}]','[1]'),(403,0,0,0,541,560,0,1,'公会篝火','[{3,36030001,500}]','[{5,36060001,243666910}]','[{2,36020001,50}]','[{5,36060001,487333819}]','[1]'),(403,0,0,0,561,580,0,1,'公会篝火','[{3,36030001,500}]','[{5,36060001,266466910}]','[{2,36020001,50}]','[{5,36060001,532933819}]','[1]'),(403,0,0,0,581,600,0,1,'公会篝火','[{3,36030001,500}]','[{5,36060001,289266910}]','[{2,36020001,50}]','[{5,36060001,578533819}]','[1]'),(403,0,0,0,601,620,0,1,'公会篝火','[{3,36030001,500}]','[{5,36060001,312066910}]','[{2,36020001,50}]','[{5,36060001,624133819}]','[1]'),(403,0,0,0,621,640,0,1,'公会篝火','[{3,36030001,500}]','[{5,36060001,334866910}]','[{2,36020001,50}]','[{5,36060001,669733819}]','[1]'),(403,0,0,0,641,660,0,1,'公会篝火','[{3,36030001,500}]','[{5,36060001,357666910}]','[{2,36020001,50}]','[{5,36060001,715333819}]','[1]'),(403,0,0,0,661,680,0,1,'公会篝火','[{3,36030001,500}]','[{5,36060001,380466910}]','[{2,36020001,50}]','[{5,36060001,760933819}]','[1]'),(403,0,0,0,681,700,0,1,'公会篝火','[{3,36030001,500}]','[{5,36060001,403266910}]','[{2,36020001,50}]','[{5,36060001,806533819}]','[1]'),(403,0,0,0,701,720,0,1,'公会篝火','[{3,36030001,500}]','[{5,36060001,426066910}]','[{2,36020001,50}]','[{5,36060001,852133819}]','[1]'),(403,0,0,0,721,740,0,1,'公会篝火','[{3,36030001,500}]','[{5,36060001,448866910}]','[{2,36020001,50}]','[{5,36060001,897733819}]','[1]'),(403,0,0,0,741,760,0,1,'公会篝火','[{3,36030001,500}]','[{5,36060001,471666910}]','[{2,36020001,50}]','[{5,36060001,943333819}]','[1]'),(403,0,0,0,761,780,0,1,'公会篝火','[{3,36030001,500}]','[{5,36060001,494466910}]','[{2,36020001,50}]','[{5,36060001,988933819}]','[1]'),(403,0,0,0,781,800,0,1,'公会篝火','[{3,36030001,500}]','[{5,36060001,505866910}]','[{2,36020001,50}]','[{5,36060001,1011733819}]','[1]'),(403,0,0,0,801,850,0,1,'公会篝火','[{3,36030001,500}]','[{5,36060001,505866910}]','[{2,36020001,50}]','[{5,36060001,1011733819}]','[1]'),(403,0,0,0,851,900,0,1,'公会篝火','[{3,36030001,500}]','[{5,36060001,505866910}]','[{2,36020001,50}]','[{5,36060001,1011733819}]','[1]'),(403,0,0,0,901,950,0,1,'公会篝火','[{3,36030001,500}]','[{5,36060001,505866910}]','[{2,36020001,50}]','[{5,36060001,1011733819}]','[1]'),(403,0,0,0,951,1000,0,1,'公会篝火','[{3,36030001,500}]','[{5,36060001,505866910}]','[{2,36020001,50}]','[{5,36060001,1011733819}]','[1]'),(418,0,0,0,110,199,0,0,'魅力海滩','[{3,36030001,500}]','[{5,36060001,7079590}]','[{2,36020001,50}]','[{5,36060001,14159180}]','[1]'),(418,0,0,0,200,259,0,0,'魅力海滩','[{3,36030001,500}]','[{5,36060001,7831990}]','[{2,36020001,50}]','[{5,36060001,15663980}]','[1]'),(418,0,0,0,260,319,0,0,'魅力海滩','[{3,36030001,500}]','[{5,36060001,12652432}]','[{2,36020001,50}]','[{5,36060001,25304863}]','[1]'),(418,0,0,0,320,349,0,0,'魅力海滩','[{3,36030001,500}]','[{5,36060001,14948808}]','[{2,36020001,50}]','[{5,36060001,29897616}]','[1]'),(418,0,0,0,350,369,0,0,'魅力海滩','[{3,36030001,500}]','[{5,36060001,17095376}]','[{2,36020001,50}]','[{5,36060001,34190751}]','[1]'),(418,0,0,0,370,389,0,0,'魅力海滩','[{3,36030001,500}]','[{5,36060001,27623481}]','[{2,36020001,50}]','[{5,36060001,55246961}]','[1]'),(418,0,0,0,390,429,0,0,'魅力海滩','[{3,36030001,500}]','[{5,36060001,38559213}]','[{2,36020001,50}]','[{5,36060001,77118425}]','[1]'),(418,0,0,0,430,499,0,0,'魅力海滩','[{3,36030001,500}]','[{5,36060001,53759213}]','[{2,36020001,50}]','[{5,36060001,107518425}]','[1]'),(418,0,0,0,500,559,0,0,'魅力海滩','[{3,36030001,500}]','[{5,36060001,88484410}]','[{2,36020001,50}]','[{5,36060001,176968819}]','[1]'),(418,0,0,0,560,609,0,0,'魅力海滩','[{3,36030001,500}]','[{5,36060001,162444607}]','[{2,36020001,50}]','[{5,36060001,324889213}]','[1]'),(418,0,0,0,610,659,0,0,'魅力海滩','[{3,36030001,500}]','[{5,36060001,200444607}]','[{2,36020001,50}]','[{5,36060001,400889213}]','[1]'),(418,0,0,0,660,749,0,0,'魅力海滩','[{3,36030001,500}]','[{5,36060001,238444607}]','[{2,36020001,50}]','[{5,36060001,476889213}]','[1]'),(418,0,0,0,750,799,0,0,'魅力海滩','[{3,36030001,500}]','[{5,36060001,306844607}]','[{2,36020001,50}]','[{5,36060001,613689213}]','[1]'),(418,0,0,0,800,1000,0,0,'魅力海滩','[{3,36030001,500}]','[{5,36060001,337244607}]','[{2,36020001,50}]','[{5,36060001,674489213}]','[1]'),(429,0,0,0,110,199,0,0,'捕蝶','[{3,36030001,500}]','[{5,36060001,8849488},{0,18020001,13}]','[{2,36020001,50}]','[{5,36060001,17698975},{0,18020001,25}]','[1,4]'),(429,0,0,0,200,259,0,0,'捕蝶','[{3,36030001,500}]','[{5,36060001,9789988},{0,18020001,13}]','[{2,36020001,50}]','[{5,36060001,19579975},{0,18020001,25}]','[1,4]'),(429,0,0,0,260,319,0,0,'捕蝶','[{3,36030001,500}]','[{5,36060001,15815539},{0,18020001,15}]','[{2,36020001,50}]','[{5,36060001,31631078},{0,18020001,30}]','[1,4]'),(429,0,0,0,320,349,0,0,'捕蝶','[{3,36030001,500}]','[{5,36060001,18686010},{0,18020001,18}]','[{2,36020001,50}]','[{5,36060001,37372020},{0,18020001,35}]','[1,4]'),(429,0,0,0,350,369,0,0,'捕蝶','[{3,36030001,500}]','[{5,36060001,21369220},{0,18020001,20}]','[{2,36020001,50}]','[{5,36060001,42738439},{0,18020001,40}]','[1,4]'),(429,0,0,0,370,389,0,0,'捕蝶','[{3,36030001,500}]','[{5,36060001,34529351},{0,18020001,20}]','[{2,36020001,50}]','[{5,36060001,69058702},{0,18020001,40}]','[1,4]'),(429,0,0,0,390,429,0,0,'捕蝶','[{3,36030001,500}]','[{5,36060001,48199016},{0,18020001,20}]','[{2,36020001,50}]','[{5,36060001,96398032},{0,18020001,40}]','[1,4]'),(429,0,0,0,430,499,0,0,'捕蝶','[{3,36030001,500}]','[{5,36060001,67199016},{0,18020001,23}]','[{2,36020001,50}]','[{5,36060001,134398032},{0,18020001,45}]','[1,4]'),(429,0,0,0,500,559,0,0,'捕蝶','[{3,36030001,500}]','[{5,36060001,110605512},{0,18020002,8}]','[{2,36020001,50}]','[{5,36060001,221211024},{0,18020002,15}]','[1,4]'),(429,0,0,0,560,609,0,0,'捕蝶','[{3,36030001,500}]','[{5,36060001,203055758},{0,18020002,8}]','[{2,36020001,50}]','[{5,36060001,406111516},{0,18020002,15}]','[1,4]'),(429,0,0,0,610,659,0,0,'捕蝶','[{3,36030001,500}]','[{5,36060001,250555758},{0,18020002,10}]','[{2,36020001,50}]','[{5,36060001,501111516},{0,18020002,20}]','[1,4]'),(429,0,0,0,660,749,0,0,'捕蝶','[{3,36030001,500}]','[{5,36060001,298055758},{0,18020002,10}]','[{2,36020001,50}]','[{5,36060001,596111516},{0,18020002,20}]','[1,4]'),(429,0,0,0,750,799,0,0,'捕蝶','[{3,36030001,500}]','[{5,36060001,383555758},{0,18020002,10}]','[{2,36020001,50}]','[{5,36060001,767111516},{0,18020002,20}]','[1,4]'),(429,0,0,0,800,1000,0,0,'捕蝶','[{3,36030001,500}]','[{5,36060001,421555758},{0,18020002,10}]','[{2,36020001,50}]','[{5,36060001,843111516},{0,18020002,20}]','[1,4]'),(500,0,130,199,0,0,0,0,'飞艇护送','[{3,36030001,500}]','[{5,36060001,1720734},{3,36030001,14857}]','[{2,36020001,25}]','[{5,36060001,3441467},{3,36030001,29713}]','[1,3]'),(500,0,200,219,0,0,0,0,'飞艇护送','[{3,36030001,500}]','[{5,36060001,1720734},{3,36030001,15551}]','[{2,36020001,25}]','[{5,36060001,3441467},{3,36030001,31101}]','[1,3]'),(500,0,220,239,0,0,0,0,'飞艇护送','[{3,36030001,500}]','[{5,36060001,1903609},{3,36030001,16940}]','[{2,36020001,25}]','[{5,36060001,3807217},{3,36030001,33879}]','[1,3]'),(500,0,240,259,0,0,0,0,'飞艇护送','[{3,36030001,500}]','[{5,36060001,2297067},{3,36030001,18329}]','[{2,36020001,25}]','[{5,36060001,4594134},{3,36030001,36657}]','[1,3]'),(500,0,260,279,0,0,0,0,'飞艇护送','[{3,36030001,500}]','[{5,36060001,2841570},{3,36030001,19717}]','[{2,36020001,25}]','[{5,36060001,5683140},{3,36030001,39434}]','[1,3]'),(500,0,280,299,0,0,0,0,'飞艇护送','[{3,36030001,500}]','[{5,36060001,3075244},{3,36030001,30878}]','[{2,36020001,25}]','[{5,36060001,6150488},{3,36030001,61756}]','[1,3]'),(500,0,300,319,0,0,0,0,'飞艇护送','[{3,36030001,500}]','[{5,36060001,3200472},{3,36030001,42188}]','[{2,36020001,25}]','[{5,36060001,6400943},{3,36030001,84376}]','[1,3]'),(500,0,320,339,0,0,0,0,'飞艇护送','[{3,36030001,500}]','[{5,36060001,3442247},{3,36030001,47917}]','[{2,36020001,25}]','[{5,36060001,6884493},{3,36030001,95833}]','[1,3]'),(500,0,340,359,0,0,0,0,'飞艇护送','[{3,36030001,500}]','[{5,36060001,3633391},{3,36030001,51315}]','[{2,36020001,25}]','[{5,36060001,7266782},{3,36030001,102630}]','[1,3]'),(500,0,360,379,0,0,0,0,'飞艇护送','[{3,36030001,500}]','[{5,36060001,3867960},{3,36030001,54792}]','[{2,36020001,25}]','[{5,36060001,7735920},{3,36030001,109583}]','[1,3]'),(500,0,380,399,0,0,0,0,'飞艇护送','[{3,36030001,500}]','[{5,36060001,4431149},{3,36030001,64197}]','[{2,36020001,25}]','[{5,36060001,8862297},{3,36030001,128394}]','[1,3]'),(500,0,400,419,0,0,0,0,'飞艇护送','[{3,36030001,500}]','[{5,36060001,8448420},{3,36030001,72769}]','[{2,36020001,25}]','[{5,36060001,16896839},{3,36030001,145538}]','[1,3]'),(500,0,420,439,0,0,0,0,'飞艇护送','[{3,36030001,500}]','[{5,36060001,10295642},{3,36030001,82644}]','[{2,36020001,25}]','[{5,36060001,20591284},{3,36030001,165287}]','[1,3]'),(500,0,440,459,0,0,0,0,'飞艇护送','[{3,36030001,500}]','[{5,36060001,12142864},{3,36030001,93820}]','[{2,36020001,25}]','[{5,36060001,24285728},{3,36030001,187639}]','[1,3]'),(500,0,460,479,0,0,0,0,'飞艇护送','[{3,36030001,500}]','[{5,36060001,13921471},{3,36030001,110521}]','[{2,36020001,25}]','[{5,36060001,27842942},{3,36030001,221042}]','[1,3]'),(500,0,480,499,0,0,0,0,'飞艇护送','[{3,36030001,500}]','[{5,36060001,17799005},{3,36030001,129987}]','[{2,36020001,25}]','[{5,36060001,35598009},{3,36030001,259974}]','[1,3]'),(500,0,500,519,0,0,0,0,'飞艇护送','[{3,36030001,500}]','[{5,36060001,20121211},{3,36030001,152682}]','[{2,36020001,25}]','[{5,36060001,40242421},{3,36030001,305364}]','[1,3]'),(500,0,520,539,0,0,0,0,'飞艇护送','[{3,36030001,500}]','[{5,36060001,21506628},{3,36030001,176986}]','[{2,36020001,25}]','[{5,36060001,43013255},{3,36030001,353971}]','[1,3]'),(500,0,540,559,0,0,0,0,'飞艇护送','[{3,36030001,500}]','[{5,36060001,24691256},{3,36030001,209915}]','[{2,36020001,25}]','[{5,36060001,49382511},{3,36030001,419830}]','[1,3]'),(500,0,560,579,0,0,0,0,'飞艇护送','[{3,36030001,500}]','[{5,36060001,32209758},{3,36030001,255755}]','[{2,36020001,25}]','[{5,36060001,64419515},{3,36030001,511510}]','[1,3]'),(500,0,580,599,0,0,0,0,'飞艇护送','[{3,36030001,500}]','[{5,36060001,39483064},{3,36030001,305755}]','[{2,36020001,25}]','[{5,36060001,78966128},{3,36030001,611510}]','[1,3]'),(500,0,600,619,0,0,0,0,'飞艇护送','[{3,36030001,500}]','[{5,36060001,43177509},{3,36030001,360964}]','[{2,36020001,25}]','[{5,36060001,86355017},{3,36030001,721927}]','[1,3]'),(500,0,620,639,0,0,0,0,'飞艇护送','[{3,36030001,500}]','[{5,36060001,46871953},{3,36030001,421380}]','[{2,36020001,25}]','[{5,36060001,93743906},{3,36030001,842760}]','[1,3]'),(500,0,640,659,0,0,0,0,'飞艇护送','[{3,36030001,500}]','[{5,36060001,50566398},{3,36030001,487005}]','[{2,36020001,25}]','[{5,36060001,101132795},{3,36030001,974010}]','[1,3]'),(500,0,660,679,0,0,0,0,'飞艇护送','[{3,36030001,500}]','[{5,36060001,54260842},{3,36030001,557839}]','[{2,36020001,25}]','[{5,36060001,108521684},{3,36030001,1115677}]','[1,3]'),(500,0,680,699,0,0,0,0,'飞艇护送','[{3,36030001,500}]','[{5,36060001,57955287},{3,36030001,633880}]','[{2,36020001,25}]','[{5,36060001,115910573},{3,36030001,1267760}]','[1,3]'),(500,0,700,719,0,0,0,0,'飞艇护送','[{3,36030001,500}]','[{5,36060001,61649731},{3,36030001,715130}]','[{2,36020001,25}]','[{5,36060001,123299461},{3,36030001,1430260}]','[1,3]'),(500,0,720,739,0,0,0,0,'飞艇护送','[{3,36030001,500}]','[{5,36060001,65344175},{3,36030001,801589}]','[{2,36020001,25}]','[{5,36060001,130688350},{3,36030001,1603177}]','[1,3]'),(500,0,740,759,0,0,0,0,'飞艇护送','[{3,36030001,500}]','[{5,36060001,69038620},{3,36030001,893255}]','[{2,36020001,25}]','[{5,36060001,138077239},{3,36030001,1786510}]','[1,3]'),(500,0,760,779,0,0,0,0,'飞艇护送','[{3,36030001,500}]','[{5,36060001,72733064},{3,36030001,990130}]','[{2,36020001,25}]','[{5,36060001,145466128},{3,36030001,1980260}]','[1,3]'),(500,0,780,799,0,0,0,0,'飞艇护送','[{3,36030001,500}]','[{5,36060001,76427509},{3,36030001,1092214}]','[{2,36020001,25}]','[{5,36060001,152855017},{3,36030001,2184427}]','[1,3]'),(500,0,800,819,0,0,0,0,'飞艇护送','[{3,36030001,500}]','[{5,36060001,80121953},{3,36030001,1145209}]','[{2,36020001,25}]','[{5,36060001,160243906},{3,36030001,2290417}]','[1,3]'),(500,0,820,839,0,0,0,0,'飞艇护送','[{3,36030001,500}]','[{5,36060001,81969175},{3,36030001,1145209}]','[{2,36020001,25}]','[{5,36060001,163938350},{3,36030001,2290417}]','[1,3]'),(500,0,840,859,0,0,0,0,'飞艇护送','[{3,36030001,500}]','[{5,36060001,81969175},{3,36030001,1145209}]','[{2,36020001,25}]','[{5,36060001,163938350},{3,36030001,2290417}]','[1,3]'),(500,0,860,879,0,0,0,0,'飞艇护送','[{3,36030001,500}]','[{5,36060001,81969175},{3,36030001,1145209}]','[{2,36020001,25}]','[{5,36060001,163938350},{3,36030001,2290417}]','[1,3]'),(500,0,880,899,0,0,0,0,'飞艇护送','[{3,36030001,500}]','[{5,36060001,81969175},{3,36030001,1145209}]','[{2,36020001,25}]','[{5,36060001,163938350},{3,36030001,2290417}]','[1,3]'),(500,0,900,919,0,0,0,0,'飞艇护送','[{3,36030001,500}]','[{5,36060001,81969175},{3,36030001,1145209}]','[{2,36020001,25}]','[{5,36060001,163938350},{3,36030001,2290417}]','[1,3]'),(500,0,920,939,0,0,0,0,'飞艇护送','[{3,36030001,500}]','[{5,36060001,81969175},{3,36030001,1145209}]','[{2,36020001,25}]','[{5,36060001,163938350},{3,36030001,2290417}]','[1,3]'),(500,0,940,959,0,0,0,0,'飞艇护送','[{3,36030001,500}]','[{5,36060001,81969175},{3,36030001,1145209}]','[{2,36020001,25}]','[{5,36060001,163938350},{3,36030001,2290417}]','[1,3]'),(500,0,960,979,0,0,0,0,'飞艇护送','[{3,36030001,500}]','[{5,36060001,81969175},{3,36030001,1145209}]','[{2,36020001,25}]','[{5,36060001,163938350},{3,36030001,2290417}]','[1,3]'),(500,0,980,999,0,0,0,0,'飞艇护送','[{3,36030001,500}]','[{5,36060001,81969175},{3,36030001,1145209}]','[{2,36020001,25}]','[{5,36060001,163938350},{3,36030001,2290417}]','[1,3]'),(500,0,1000,1000,0,0,0,0,'飞艇护送','[{3,36030001,500}]','[{5,36060001,81969175},{3,36030001,1145209}]','[{2,36020001,25}]','[{5,36060001,163938350},{3,36030001,2290417}]','[1,3]'),(606,0,140,190,0,0,0,0,'大乱斗','[{3,36030001,500}]','[{0,17010001,16},{0,24010001,8}]','[{2,36020001,50}]','[{0,17010001,32},{0,24010001,16}]','[4]'),(606,0,191,230,0,0,0,0,'大乱斗','[{3,36030001,500}]','[{0,17010001,16},{0,24010001,8}]','[{2,36020001,50}]','[{0,17010001,32},{0,24010001,16}]','[4]'),(606,0,231,260,0,0,0,0,'大乱斗','[{3,36030001,500}]','[{0,17010001,16},{0,24010001,10}]','[{2,36020001,50}]','[{0,17010001,32},{0,24010001,20}]','[4]'),(606,0,261,320,0,0,0,0,'大乱斗','[{3,36030001,500}]','[{0,17010001,24},{0,24010001,12}]','[{2,36020001,50}]','[{0,17010001,48},{0,24010001,24}]','[4]'),(606,0,321,350,0,0,0,0,'大乱斗','[{3,36030001,500}]','[{0,17010001,32},{0,24010001,14}]','[{2,36020001,50}]','[{0,17010001,64},{0,24010001,28}]','[4]'),(606,0,351,370,0,0,0,0,'大乱斗','[{3,36030001,500}]','[{0,17010001,32},{0,24010001,16}]','[{2,36020001,50}]','[{0,17010001,64},{0,24010001,32}]','[4]'),(606,0,371,390,0,0,0,0,'大乱斗','[{3,36030001,500}]','[{0,17010001,36},{0,24010002,8}]','[{2,36020001,50}]','[{0,17010001,72},{0,24010002,16}]','[4]'),(606,0,391,430,0,0,0,0,'大乱斗','[{3,36030001,500}]','[{0,17010001,40},{0,24010002,10}]','[{2,36020001,50}]','[{0,17010001,80},{0,24010002,20}]','[4]'),(606,0,431,500,0,0,0,0,'大乱斗','[{3,36030001,500}]','[{0,17010001,48},{0,24010002,12}]','[{2,36020001,50}]','[{0,17010001,96},{0,24010002,24}]','[4]'),(606,0,501,560,0,0,0,0,'大乱斗','[{3,36030001,500}]','[{0,17010002,6},{0,24010002,14}]','[{2,36020001,50}]','[{0,17010002,12},{0,24010002,28}]','[4]'),(606,0,561,610,0,0,0,0,'大乱斗','[{3,36030001,500}]','[{0,17010002,7},{0,24010002,16}]','[{2,36020001,50}]','[{0,17010002,14},{0,24010002,32}]','[4]'),(606,0,611,660,0,0,0,0,'大乱斗','[{3,36030001,500}]','[{0,17010002,9},{0,24010003,6}]','[{2,36020001,50}]','[{0,17010002,18},{0,24010003,12}]','[4]'),(606,0,661,750,0,0,0,0,'大乱斗','[{3,36030001,500}]','[{0,17010002,12},{0,24010003,7}]','[{2,36020001,50}]','[{0,17010002,24},{0,24010003,14}]','[4]'),(606,0,751,1000,0,0,0,0,'大乱斗','[{3,36030001,500}]','[{0,17010002,16},{0,24010003,8}]','[{2,36020001,50}]','[{0,17010002,32},{0,24010003,16}]','[4]'),(610,4,75,179,0,0,3001,0,'经验宝库','[{3,36030001,750}]','[{5,36060001,9164200}]','[{2,36020001,75}]','[{5,36060001,18328400}]','[1]'),(610,4,180,239,0,0,3001,0,'经验宝库','[{3,36030001,750}]','[{5,36060001,9164200}]','[{2,36020001,75}]','[{5,36060001,18328400}]','[1]'),(610,4,240,279,0,0,3001,0,'经验宝库','[{3,36030001,750}]','[{5,36060001,33573800}]','[{2,36020001,75}]','[{5,36060001,67147600}]','[1]'),(610,4,280,319,0,0,3001,0,'经验宝库','[{3,36030001,750}]','[{5,36060001,44657000}]','[{2,36020001,75}]','[{5,36060001,89314000}]','[1]'),(610,4,320,349,0,0,3001,0,'经验宝库','[{3,36030001,750}]','[{5,36060001,47344000}]','[{2,36020001,75}]','[{5,36060001,94688000}]','[1]'),(610,4,350,374,0,0,3001,0,'经验宝库','[{3,36030001,750}]','[{5,36060001,53622800}]','[{2,36020001,75}]','[{5,36060001,107245600}]','[1]'),(610,4,375,399,0,0,3001,0,'经验宝库','[{3,36030001,750}]','[{5,36060001,93079200}]','[{2,36020001,75}]','[{5,36060001,186158400}]','[1]'),(610,4,400,424,0,0,3001,0,'经验宝库','[{3,36030001,750}]','[{5,36060001,129927800}]','[{2,36020001,75}]','[{5,36060001,259855600}]','[1]'),(610,4,425,449,0,0,3001,0,'经验宝库','[{3,36030001,750}]','[{5,36060001,168340800}]','[{2,36020001,75}]','[{5,36060001,336681600}]','[1]'),(610,4,450,474,0,0,3001,0,'经验宝库','[{3,36030001,750}]','[{5,36060001,192998200}]','[{2,36020001,75}]','[{5,36060001,385996400}]','[1]'),(610,4,475,514,0,0,3001,0,'经验宝库','[{3,36030001,750}]','[{5,36060001,269344200}]','[{2,36020001,75}]','[{5,36060001,538688400}]','[1]'),(610,4,515,549,0,0,3001,0,'经验宝库','[{3,36030001,750}]','[{5,36060001,307757200}]','[{2,36020001,75}]','[{5,36060001,615514400}]','[1]'),(610,4,550,574,0,0,3001,0,'经验宝库','[{3,36030001,750}]','[{5,36060001,446535200}]','[{2,36020001,75}]','[{5,36060001,893070400}]','[1]'),(610,4,575,594,0,0,3001,0,'经验宝库','[{3,36030001,750}]','[{5,36060001,572976400}]','[{2,36020001,75}]','[{5,36060001,1145952800}]','[1]'),(610,4,595,609,0,0,3001,0,'经验宝库','[{3,36030001,750}]','[{5,36060001,624193800}]','[{2,36020001,75}]','[{5,36060001,1248387600}]','[1]'),(610,4,610,629,0,0,3001,0,'经验宝库','[{3,36030001,750}]','[{5,36060001,649802400}]','[{2,36020001,75}]','[{5,36060001,1299604800}]','[1]'),(610,4,630,649,0,0,3001,0,'经验宝库','[{3,36030001,750}]','[{5,36060001,701019800}]','[{2,36020001,75}]','[{5,36060001,1402039600}]','[1]'),(610,4,650,669,0,0,3001,0,'经验宝库','[{3,36030001,750}]','[{5,36060001,752237200}]','[{2,36020001,75}]','[{5,36060001,1504474400}]','[1]'),(610,4,670,689,0,0,3001,0,'经验宝库','[{3,36030001,750}]','[{5,36060001,803454600}]','[{2,36020001,75}]','[{5,36060001,1606909200}]','[1]'),(610,4,690,709,0,0,3001,0,'经验宝库','[{3,36030001,750}]','[{5,36060001,854672000}]','[{2,36020001,75}]','[{5,36060001,1709344000}]','[1]'),(610,4,710,729,0,0,3001,0,'经验宝库','[{3,36030001,750}]','[{5,36060001,905889400}]','[{2,36020001,75}]','[{5,36060001,1811778800}]','[1]'),(610,4,730,749,0,0,3001,0,'经验宝库','[{3,36030001,750}]','[{5,36060001,957106800}]','[{2,36020001,75}]','[{5,36060001,1914213600}]','[1]'),(610,4,750,769,0,0,3001,0,'经验宝库','[{3,36030001,750}]','[{5,36060001,1008324200}]','[{2,36020001,75}]','[{5,36060001,2016648400}]','[1]'),(610,4,770,789,0,0,3001,0,'经验宝库','[{3,36030001,750}]','[{5,36060001,1059541600}]','[{2,36020001,75}]','[{5,36060001,2119083200}]','[1]'),(610,4,790,809,0,0,3001,0,'经验宝库','[{3,36030001,750}]','[{5,36060001,1110759000}]','[{2,36020001,75}]','[{5,36060001,2221518000}]','[1]'),(610,4,810,829,0,0,3001,0,'经验宝库','[{3,36030001,750}]','[{5,36060001,1136367600}]','[{2,36020001,75}]','[{5,36060001,2272735200}]','[1]'),(610,4,830,849,0,0,3001,0,'经验宝库','[{3,36030001,750}]','[{5,36060001,1136367600}]','[{2,36020001,75}]','[{5,36060001,2272735200}]','[1]'),(610,4,850,999,0,0,3001,0,'经验宝库','[{3,36030001,750}]','[{5,36060001,1136367600}]','[{2,36020001,75}]','[{5,36060001,2272735200}]','[1]'),(610,4,1000,1000,0,0,3001,0,'经验宝库','[{3,36030001,750}]','[{5,36060001,1136367600}]','[{2,36020001,75}]','[{5,36060001,2272735200}]','[1]'),(610,5,105,139,0,0,3110,0,'装备副本','[{3,36030001,500}]','[{0,32080507,1},{0,32080425,1},{0,32080492,3}]','[{2,36020001,50}]','[{0,32080507,1},{0,32080425,1},{0,32080492,5}]','[2]'),(610,5,140,199,0,0,3111,0,'装备副本','[{3,36030001,500}]','[{0,32080607,1},{0,32080525,1},{0,32080592,3}]','[{2,36020001,50}]','[{0,32080607,1},{0,32080525,1},{0,32080592,5}]','[2]'),(610,5,200,239,0,0,3112,0,'装备副本','[{3,36030001,500}]','[{0,32080707,1},{0,32080625,1},{0,32080692,3}]','[{2,36020001,50}]','[{0,32080707,1},{0,32080625,1},{0,32080692,5}]','[2]'),(610,5,240,299,0,0,3113,0,'装备副本','[{3,36030001,500}]','[{0,32080807,1},{0,32080725,1},{0,32080792,3}]','[{2,36020001,50}]','[{0,32080807,1},{0,32080725,1},{0,32080792,5}]','[2]'),(610,5,300,349,0,0,3114,0,'装备副本','[{3,36030001,500}]','[{0,32080907,1},{0,32080825,1},{0,32080892,3}]','[{2,36020001,50}]','[{0,32080907,1},{0,32080825,1},{0,32080892,5}]','[2]'),(610,5,350,399,0,0,3115,0,'装备副本','[{3,36030001,500}]','[{0,32081007,1},{0,32080925,1},{0,32080992,3}]','[{2,36020001,50}]','[{0,32081007,1},{0,32080925,1},{0,32080992,5}]','[2]'),(610,5,400,449,0,0,3116,0,'装备副本','[{3,36030001,500}]','[{0,32081107,1},{0,32081025,1},{0,32081092,3}]','[{2,36020001,50}]','[{0,32081107,1},{0,32081025,1},{0,32081092,5}]','[2]'),(610,5,450,499,0,0,3117,0,'装备副本','[{3,36030001,500}]','[{0,32081207,1},{0,32081125,1},{0,32081192,3}]','[{2,36020001,50}]','[{0,32081207,1},{0,32081125,1},{0,32081192,5}]','[2]'),(610,5,500,579,0,0,3118,0,'装备副本','[{3,36030001,500}]','[{0,32081307,1},{0,32081225,1},{0,32081292,3}]','[{2,36020001,50}]','[{0,32081307,1},{0,32081225,1},{0,32081292,5}]','[2]'),(610,5,580,619,0,0,3119,0,'装备副本','[{3,36030001,500}]','[{0,32081407,1},{0,32081325,1},{0,32081392,3}]','[{2,36020001,50}]','[{0,32081407,1},{0,32081325,1},{0,32081392,5}]','[2]'),(610,5,620,679,0,0,3120,0,'装备副本','[{3,36030001,500}]','[{0,32081507,1},{0,32081425,1},{0,32081492,3}]','[{2,36020001,50}]','[{0,32081507,1},{0,32081425,1},{0,32081492,5}]','[2]'),(610,5,680,749,0,0,3121,0,'装备副本','[{3,36030001,500}]','[{0,32081607,1},{0,32081525,1},{0,32081592,3}]','[{2,36020001,50}]','[{0,32081607,1},{0,32081525,1},{0,32081592,5}]','[2]'),(610,5,750,1000,0,0,3122,0,'装备副本','[{3,36030001,500}]','[{0,32081707,1},{0,32081625,1},{0,32081692,3}]','[{2,36020001,50}]','[{0,32081707,1},{0,32081625,1},{0,32081692,5}]','[2]'),(610,13,180,279,0,0,5200,0,'情侣副本','[{3,36030001,500}]','[{0,40010011,5},{0,40040001,63}]','[{2,36020001,50}]','[{0,40010011,10},{0,40040001,125}]','[4]'),(610,13,280,389,0,0,5201,0,'情侣副本','[{3,36030001,500}]','[{0,40010011,8},{0,40040001,100}]','[{2,36020001,50}]','[{0,40010011,16},{0,40040001,200}]','[4]'),(610,13,390,1000,0,0,5202,0,'情侣副本','[{3,36030001,500}]','[{0,40010011,13},{0,40040001,150}]','[{2,36020001,50}]','[{0,40010011,25},{0,40040001,300}]','[4]'),(610,18,85,229,0,0,5300,0,'星灵副本','[{3,36030001,500}]','[{0,18020001,8}]','[{2,36020001,50}]','[{0,18020001,15}]','[4]'),(610,18,230,319,0,0,5301,0,'星灵副本','[{3,36030001,500}]','[{0,18020001,13}]','[{2,36020001,50}]','[{0,18020001,25}]','[4]'),(610,18,320,379,0,0,5302,0,'星灵副本','[{3,36030001,500}]','[{0,18020001,13},{0,18020002,3}]','[{2,36020001,50}]','[{0,18020001,25},{0,18020002,5}]','[4]'),(610,18,380,509,0,0,5303,0,'星灵副本','[{3,36030001,500}]','[{0,18020002,8}]','[{2,36020001,50}]','[{0,18020002,15}]','[4]'),(610,18,510,1000,0,0,5304,0,'星灵副本','[{3,36030001,500}]','[{0,18020002,5},{0,18020003,3}]','[{2,36020001,50}]','[{0,18020002,9},{0,18020003,5}]','[4]'),(610,19,100,199,0,0,5400,0,'降神副本','[{3,36030001,500}]','[{0,11020001,5}]','[{2,36020001,50}]','[{0,11020001,10}]','[4]'),(610,19,200,299,0,0,5401,0,'降神副本','[{3,36030001,500}]','[{0,11020001,10}]','[{2,36020001,50}]','[{0,11020001,20}]','[4]'),(610,19,300,369,0,0,5402,0,'降神副本','[{3,36030001,500}]','[{0,11020001,7},{0,11020002,3}]','[{2,36020001,50}]','[{0,11020001,14},{0,11020002,5}]','[4]'),(610,19,370,499,0,0,5403,0,'降神副本','[{3,36030001,500}]','[{0,11020002,8}]','[{2,36020001,50}]','[{0,11020002,15}]','[4]'),(610,19,500,1000,0,0,5404,0,'降神副本','[{3,36030001,500}]','[{0,11020002,5},{0,11020003,3}]','[{2,36020001,50}]','[{0,11020002,10},{0,11020003,5}]','[4]'),(610,22,250,309,0,0,3300,0,'洗练副本','[{3,36030001,750}]','[{0,38260001,8}]','[{2,36020001,75}]','[{0,38260001,15}]','[4]'),(610,22,310,349,0,0,3301,0,'洗练副本','[{3,36030001,750}]','[{0,38260001,12}]','[{2,36020001,75}]','[{0,38260001,23}]','[4]'),(610,22,350,399,0,0,3302,0,'洗练副本','[{3,36030001,750}]','[{0,38260001,15}]','[{2,36020001,75}]','[{0,38260001,30}]','[4]'),(610,22,400,519,0,0,3303,0,'洗练副本','[{3,36030001,750}]','[{0,38260001,19}]','[{2,36020001,75}]','[{0,38260001,38}]','[4]'),(610,22,520,1000,0,0,3304,0,'洗练副本','[{3,36030001,750}]','[{0,38260001,23}]','[{2,36020001,75}]','[{0,38260001,45}]','[4]');
/*!40000 ALTER TABLE `base_res_act` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_res_act_type`
--

DROP TABLE IF EXISTS `base_res_act_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_res_act_type` (
  `act_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动id',
  `act_sub` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  PRIMARY KEY (`act_id`,`act_sub`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_res_act_type`
--

LOCK TABLES `base_res_act_type` WRITE;
/*!40000 ALTER TABLE `base_res_act_type` DISABLE KEYS */;
INSERT INTO `base_res_act_type` VALUES (174,0,2),(280,0,1),(281,0,1),(300,6,1),(300,7,1),(402,3,2),(402,4,1),(403,0,2),(418,0,2),(429,0,2),(500,0,1),(605,0,2),(606,0,2),(610,4,1),(610,5,1),(610,13,1),(610,18,1),(610,19,1),(610,22,1);
/*!40000 ALTER TABLE `base_res_act_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_ring_polish`
--

DROP TABLE IF EXISTS `base_ring_polish`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_ring_polish` (
  `goods_type_id` int(10) unsigned NOT NULL COMMENT '物品类型id',
  `attr_list` varchar(255) NOT NULL COMMENT '属性列表',
  `use_max` varchar(515) NOT NULL COMMENT '上限',
  `combat` int(10) unsigned NOT NULL COMMENT '战力',
  PRIMARY KEY (`goods_type_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='婚姻-戒指打磨配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_ring_polish`
--

LOCK TABLES `base_ring_polish` WRITE;
/*!40000 ALTER TABLE `base_ring_polish` DISABLE KEYS */;
INSERT INTO `base_ring_polish` VALUES (40010001,'[{3,30},{4,30}]','[{180,1000,100}]',0),(40010002,'[{1,60},{3,40},{4,40}]','[{180,1000,100}]',0),(40010003,'[{2,1800},{3,60},{4,60},{68,50}]','[{180,1000,100}]',0);
/*!40000 ALTER TABLE `base_ring_polish` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_ring_stage`
--

DROP TABLE IF EXISTS `base_ring_stage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_ring_stage` (
  `stage` int(10) unsigned NOT NULL COMMENT '阶数',
  `name` varchar(255) NOT NULL COMMENT '名字@lang@',
  `resource_id` int(10) unsigned NOT NULL COMMENT '形象id',
  PRIMARY KEY (`stage`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='婚姻-戒指阶数配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_ring_stage`
--

LOCK TABLES `base_ring_stage` WRITE;
/*!40000 ALTER TABLE `base_ring_stage` DISABLE KEYS */;
INSERT INTO `base_ring_stage` VALUES (1,'青铜戒指',0),(2,'白银戒指',0),(3,'爱心戒指',0),(4,'黄金戒指',0),(5,'镶钻金戒',0),(6,'蝴蝶戒指',0),(7,'铂金戒指',0),(8,'钻石戒指',0),(9,'宝钻戒指',0),(10,'镶钻宝戒',0),(11,'宝石戒指',0),(12,'璀璨戒指',0),(13,'星耀戒指',0),(14,'真爱无极',0),(15,'恒爱永久',0);
/*!40000 ALTER TABLE `base_ring_stage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_ring_star`
--

DROP TABLE IF EXISTS `base_ring_star`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_ring_star` (
  `stage` int(10) unsigned NOT NULL COMMENT '阶数',
  `star` int(10) unsigned NOT NULL COMMENT '星数',
  `upgrade_pray_num` int(10) unsigned NOT NULL COMMENT '升星所需祝福值',
  `attr_list` varchar(255) NOT NULL COMMENT '属性列表',
  `combat` int(20) unsigned NOT NULL COMMENT '战力',
  PRIMARY KEY (`stage`,`star`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='婚姻-戒指星数属性配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_ring_star`
--

LOCK TABLES `base_ring_star` WRITE;
/*!40000 ALTER TABLE `base_ring_star` DISABLE KEYS */;
INSERT INTO `base_ring_star` VALUES (0,0,0,'[]',0),(1,1,50,'[{2,172},{1,9},{3,4},{4,4}]',0),(1,2,80,'[{2,361},{1,18},{3,9},{4,9}]',0),(1,3,110,'[{2,567},{1,28},{3,14},{4,14}]',0),(1,4,140,'[{2,791},{1,39},{3,20},{4,20}]',0),(1,5,170,'[{2,1032},{1,51},{3,26},{4,26}]',0),(1,6,200,'[{2,1290},{1,64},{3,32},{4,32}]',0),(1,7,230,'[{2,1565},{1,78},{3,39},{4,39}]',0),(1,8,260,'[{2,1857},{1,93},{3,46},{4,46}]',0),(1,9,290,'[{2,2167},{1,108},{3,54},{4,54}]',0),(1,10,330,'[{2,2494},{1,124},{3,62},{4,62}]',0),(2,1,370,'[{2,2848},{1,142},{3,71},{4,71}]',0),(2,2,410,'[{2,3230},{1,161},{3,81},{4,81}]',0),(2,3,450,'[{2,3639},{1,181},{3,91},{4,91}]',0),(2,4,490,'[{2,4076},{1,203},{3,102},{4,102}]',0),(2,5,530,'[{2,4540},{1,226},{3,114},{4,114}]',0),(2,6,570,'[{2,5032},{1,251},{3,126},{4,126}]',0),(2,7,610,'[{2,5551},{1,277},{3,139},{4,139}]',0),(2,8,650,'[{2,6098},{1,304},{3,153},{4,153}]',0),(2,9,690,'[{2,6672},{1,333},{3,167},{4,167}]',0),(2,10,730,'[{2,7284},{1,364},{3,182},{4,182}]',0),(3,1,770,'[{2,7934},{1,397},{3,198},{4,198}]',0),(3,2,810,'[{2,8622},{1,431},{3,215},{4,215}]',0),(3,3,850,'[{2,9348},{1,467},{3,233},{4,233}]',0),(3,4,890,'[{2,10112},{1,505},{3,252},{4,252}]',0),(3,5,930,'[{2,10913},{1,545},{3,272},{4,272}]',0),(3,6,970,'[{2,11752},{1,587},{3,293},{4,293}]',0),(3,7,1010,'[{2,12629},{1,631},{3,315},{4,315}]',0),(3,8,1050,'[{2,13544},{1,677},{3,338},{4,338}]',0),(3,9,1090,'[{2,14507},{1,725},{3,362},{4,362}]',0),(3,10,1135,'[{2,15518},{1,776},{3,387},{4,387}]',0),(4,1,1180,'[{2,16577},{1,829},{3,413},{4,413}]',0),(4,2,1225,'[{2,17685},{1,884},{3,441},{4,441}]',0),(4,3,1270,'[{2,18841},{1,942},{3,470},{4,470}]',0),(4,4,1315,'[{2,20045},{1,1002},{3,500},{4,500}]',0),(4,5,1360,'[{2,21297},{1,1065},{3,531},{4,531}]',0),(4,6,1405,'[{2,22597},{1,1130},{3,564},{4,564}]',0),(4,7,1450,'[{2,23945},{1,1197},{3,598},{4,598}]',0),(4,8,1495,'[{2,25352},{1,1267},{3,633},{4,633}]',0),(4,9,1540,'[{2,26817},{1,1340},{3,670},{4,670}]',0),(4,10,1590,'[{2,28341},{1,1416},{3,708},{4,708}]',0),(5,1,1640,'[{2,29923},{1,1495},{3,748},{4,748}]',0),(5,2,1690,'[{2,31564},{1,1577},{3,789},{4,789}]',0),(5,3,1740,'[{2,33263},{1,1662},{3,831},{4,831}]',0),(5,4,1790,'[{2,35021},{1,1750},{3,875},{4,875}]',0),(5,5,1840,'[{2,36837},{1,1841},{3,920},{4,920}]',0),(5,6,1890,'[{2,38712},{1,1935},{3,967},{4,967}]',0),(5,7,1940,'[{2,40655},{1,2032},{3,1016},{4,1016}]',0),(5,8,1990,'[{2,42667},{1,2133},{3,1066},{4,1066}]',0),(5,9,2040,'[{2,44748},{1,2237},{3,1118},{4,1118}]',0),(5,10,2095,'[{2,46898},{1,2344},{3,1172},{4,1172}]',0),(6,1,2150,'[{2,49117},{1,2455},{3,1227},{4,1227}]',0),(6,2,2205,'[{2,51404},{1,2569},{3,1284},{4,1284}]',0),(6,3,2260,'[{2,53760},{1,2687},{3,1343},{4,1343}]',0),(6,4,2315,'[{2,56185},{1,2808},{3,1404},{4,1404}]',0),(6,5,2370,'[{2,58679},{1,2933},{3,1466},{4,1466}]',0),(6,6,2425,'[{2,61252},{1,3062},{3,1530},{4,1530}]',0),(6,7,2480,'[{2,63904},{1,3195},{3,1596},{4,1596}]',0),(6,8,2535,'[{2,66635},{1,3332},{3,1664},{4,1664}]',0),(6,9,2590,'[{2,69445},{1,3473},{3,1734},{4,1734}]',0),(6,10,2650,'[{2,72334},{1,3617},{3,1806},{4,1806}]',0),(7,1,2710,'[{2,75303},{1,3765},{3,1880},{4,1880}]',0),(7,2,2770,'[{2,78351},{1,3917},{3,1956},{4,1956}]',0),(7,3,2830,'[{2,81478},{1,4073},{3,2034},{4,2034}]',0),(7,4,2890,'[{2,84684},{1,4233},{3,2114},{4,2114}]',0),(7,5,2950,'[{2,87979},{1,4398},{3,2196},{4,2196}]',0),(7,6,3010,'[{2,91364},{1,4567},{3,2281},{4,2281}]',0),(7,7,3070,'[{2,94838},{1,4741},{3,2368},{4,2368}]',0),(7,8,3130,'[{2,98402},{1,4919},{3,2457},{4,2457}]',0),(7,9,3190,'[{2,102055},{1,5102},{3,2548},{4,2548}]',0),(7,10,3260,'[{2,105797},{1,5289},{3,2642},{4,2642}]',0),(8,1,3330,'[{2,109629},{1,5481},{3,2738},{4,2738}]',0),(8,2,3400,'[{2,113550},{1,5677},{3,2836},{4,2836}]',0),(8,3,3470,'[{2,117561},{1,5878},{3,2936},{4,2936}]',0),(8,4,3540,'[{2,121672},{1,6084},{3,3039},{4,3039}]',0),(8,5,3610,'[{2,125882},{1,6295},{3,3144},{4,3144}]',0),(8,6,3680,'[{2,130192},{1,6511},{3,3252},{4,3252}]',0),(8,7,3750,'[{2,134602},{1,6731},{3,3362},{4,3362}]',0),(8,8,3820,'[{2,139112},{1,6956},{3,3475},{4,3475}]',0),(8,9,3890,'[{2,143721},{1,7186},{3,3590},{4,3590}]',0),(8,10,3970,'[{2,148430},{1,7421},{3,3708},{4,3708}]',0),(9,1,4050,'[{2,153239},{1,7661},{3,3828},{4,3828}]',0),(9,2,4130,'[{2,158148},{1,7906},{3,3951},{4,3951}]',0),(9,3,4210,'[{2,163167},{1,8157},{3,4076},{4,4076}]',0),(9,4,4290,'[{2,168296},{1,8413},{3,4204},{4,4204}]',0),(9,5,4370,'[{2,173535},{1,8675},{3,4335},{4,4335}]',0),(9,6,4450,'[{2,178884},{1,8942},{3,4469},{4,4469}]',0),(9,7,4530,'[{2,184343},{1,9215},{3,4605},{4,4605}]',0),(9,8,4610,'[{2,189912},{1,9493},{3,4744},{4,4744}]',0),(9,9,4690,'[{2,195591},{1,9777},{3,4886},{4,4886}]',0),(9,10,4780,'[{2,201380},{1,10066},{3,5031},{4,5031}]',0),(10,1,4870,'[{2,207279},{1,10361},{3,5178},{4,5178}]',0),(10,2,4960,'[{2,213299},{1,10662},{3,5328},{4,5328}]',0),(10,3,5050,'[{2,219439},{1,10969},{3,5481},{4,5481}]',0),(10,4,5140,'[{2,225699},{1,11282},{3,5638},{4,5638}]',0),(10,5,5230,'[{2,232080},{1,11601},{3,5798},{4,5798}]',0),(10,6,5320,'[{2,238581},{1,11926},{3,5961},{4,5961}]',0),(10,7,5410,'[{2,245203},{1,12257},{3,6127},{4,6127}]',0),(10,8,5500,'[{2,251945},{1,12594},{3,6296},{4,6296}]',0),(10,9,5590,'[{2,258807},{1,12937},{3,6468},{4,6468}]',0),(10,10,5690,'[{2,265790},{1,13286},{3,6643},{4,6643}]',0),(11,1,5790,'[{2,272903},{1,13642},{3,6821},{4,6821}]',0),(11,2,5890,'[{2,280147},{1,14004},{3,7002},{4,7002}]',0),(11,3,5990,'[{2,287522},{1,14373},{3,7186},{4,7186}]',0),(11,4,6090,'[{2,295028},{1,14748},{3,7374},{4,7374}]',0),(11,5,6190,'[{2,302664},{1,15130},{3,7565},{4,7565}]',0),(11,6,6290,'[{2,310431},{1,15518},{3,7759},{4,7759}]',0),(11,7,6390,'[{2,318329},{1,15913},{3,7956},{4,7956}]',0),(11,8,6490,'[{2,326357},{1,16314},{3,8157},{4,8157}]',0),(11,9,6590,'[{2,334516},{1,16722},{3,8361},{4,8361}]',0),(11,10,6700,'[{2,342816},{1,17137},{3,8569},{4,8569}]',0),(12,1,6810,'[{2,351257},{1,17559},{3,8780},{4,8780}]',0),(12,2,6920,'[{2,359839},{1,17988},{3,8995},{4,8995}]',0),(12,3,7030,'[{2,368562},{1,18424},{3,9213},{4,9213}]',0),(12,4,7140,'[{2,377426},{1,18867},{3,9435},{4,9435}]',0),(12,5,7250,'[{2,386431},{1,19317},{3,9660},{4,9660}]',0),(12,6,7360,'[{2,395577},{1,19774},{3,9889},{4,9889}]',0),(12,7,7470,'[{2,404864},{1,20238},{3,10121},{4,10121}]',0),(12,8,7580,'[{2,414292},{1,20709},{3,10357},{4,10357}]',0),(12,9,7690,'[{2,423872},{1,21188},{3,10596},{4,10596}]',0),(12,10,7810,'[{2,433603},{1,21675},{3,10839},{4,10839}]',0),(13,1,7930,'[{2,443485},{1,22169},{3,11086},{4,11086}]',0),(13,2,8050,'[{2,453519},{1,22671},{3,11337},{4,11337}]',0),(13,3,8170,'[{2,463704},{1,23180},{3,11592},{4,11592}]',0),(13,4,8290,'[{2,474040},{1,23697},{3,11850},{4,11850}]',0),(13,5,8410,'[{2,484528},{1,24221},{3,12112},{4,12112}]',0),(13,6,8530,'[{2,495167},{1,24753},{3,12378},{4,12378}]',0),(13,7,8650,'[{2,505957},{1,25293},{3,12648},{4,12648}]',0),(13,8,8770,'[{2,516909},{1,25841},{3,12922},{4,12922}]',0),(13,9,8890,'[{2,528023},{1,26397},{3,13200},{4,13200}]',0),(13,10,9025,'[{2,539299},{1,26961},{3,13482},{4,13482}]',0),(14,1,9160,'[{2,550736},{1,27533},{3,13768},{4,13768}]',0),(14,2,9295,'[{2,562335},{1,28113},{3,14058},{4,14058}]',0),(14,3,9430,'[{2,574096},{1,28701},{3,14352},{4,14352}]',0),(14,4,9565,'[{2,586018},{1,29297},{3,14650},{4,14650}]',0),(14,5,9700,'[{2,598102},{1,29901},{3,14952},{4,14952}]',0),(14,6,9835,'[{2,610348},{1,30513},{3,15258},{4,15258}]',0),(14,7,9970,'[{2,622765},{1,31134},{3,15568},{4,15568}]',0),(14,8,10105,'[{2,635354},{1,31763},{3,15883},{4,15883}]',0),(14,9,10240,'[{2,648115},{1,32401},{3,16202},{4,16202}]',0),(14,10,10390,'[{2,661048},{1,33048},{3,16525},{4,16525}]',0),(15,1,10540,'[{2,674153},{1,33703},{3,16853},{4,16853}]',0),(15,2,10690,'[{2,687430},{1,34367},{3,17185},{4,17185}]',0),(15,3,10840,'[{2,700879},{1,35039},{3,17521},{4,17521}]',0),(15,4,10990,'[{2,714500},{1,35720},{3,17862},{4,17862}]',0),(15,5,11140,'[{2,728293},{1,36410},{3,18207},{4,18207}]',0),(15,6,11290,'[{2,742269},{1,37109},{3,18556},{4,18556}]',0),(15,7,11440,'[{2,756427},{1,37817},{3,18910},{4,18910}]',0),(15,8,11590,'[{2,770767},{1,38534},{3,19269},{4,19269}]',0),(15,9,11740,'[{2,785290},{1,39260},{3,19632},{4,19632}]',0),(15,10,0,'[{2,799995},{1,39995},{3,20000},{4,20000}]',0);
/*!40000 ALTER TABLE `base_ring_star` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_role_home`
--

DROP TABLE IF EXISTS `base_role_home`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_role_home` (
  `home_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '家园id',
  `home_name` varchar(50) NOT NULL DEFAULT '' COMMENT '名称',
  `home_type` tinyint(1) NOT NULL DEFAULT '1' COMMENT '家园类型',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励内容',
  `wall_reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '墙纸家具奖励',
  `home_scene` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '房屋场景',
  `upgrade_cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '升级扣除家园币数',
  `divorce_reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '分房奖励',
  `allow_wall` varchar(255) NOT NULL DEFAULT '[]' COMMENT '允许装置墙纸id',
  `icon` varchar(50) NOT NULL COMMENT '图标资源',
  `map_icon` varchar(50) NOT NULL COMMENT '界面地图资源',
  PRIMARY KEY (`home_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_role_home`
--

LOCK TABLES `base_role_home` WRITE;
/*!40000 ALTER TABLE `base_role_home` DISABLE KEYS */;
INSERT INTO `base_role_home` VALUES (1,'低级家园',1,'[{0,48050001,1}]','[]','[]',7411,'[]','[{4,100}]','[47060031,47060032,47060033,47060034]','icon_jz1','icon_fj_1'),(2,'中级家园',1,'[{0,48050001,1},{2,36020001,500}]','[]','[]',7412,'[{1,250}]','[{4,150}]','[47060031,47060032,47060033,47060034]','icon_jz2','icon_fj_2'),(3,'豪华家园',1,'[{0,48050001,1},{1,36010001,988}]','[]','[]',7413,'[{1,494},{2,244}]','[{4,200}]','[47060031,47060032,47060033,47060034]','icon_jz3','icon_fj_3'),(4,'浪漫家园',2,'[{0,48050001,1},{1,36010001,1314}]','[]','[]',7414,'[{1,657},{2,407},{3,163}]','[{4,500}]','[47060031,47060032,47060033,47060034]','icon_jz4','icon_fj_4');
/*!40000 ALTER TABLE `base_role_home` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_role_home_baby`
--

DROP TABLE IF EXISTS `base_role_home_baby`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_role_home_baby` (
  `baby_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '宝宝id',
  `ratio_list` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '等级概率',
  PRIMARY KEY (`baby_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_role_home_baby`
--

LOCK TABLES `base_role_home_baby` WRITE;
/*!40000 ALTER TABLE `base_role_home_baby` DISABLE KEYS */;
/*!40000 ALTER TABLE `base_role_home_baby` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_role_home_build`
--

DROP TABLE IF EXISTS `base_role_home_build`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_role_home_build` (
  `build_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '建筑类型',
  `location` varchar(50) NOT NULL DEFAULT '[]',
  `resource` varchar(50) NOT NULL DEFAULT '' COMMENT '资源标识',
  `description` varchar(50) NOT NULL COMMENT '建筑描述@lang@',
  `icon_id` varchar(50) NOT NULL DEFAULT '0' COMMENT '图标id',
  `build_desc` varchar(50) NOT NULL COMMENT '建筑描述',
  PRIMARY KEY (`build_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_role_home_build`
--

LOCK TABLES `base_role_home_build` WRITE;
/*!40000 ALTER TABLE `base_role_home_build` DISABLE KEYS */;
INSERT INTO `base_role_home_build` VALUES (1,'[{11963,13685}]','201007','房屋','icon_fw','房屋是家园内的主建筑，提升房屋等级可以获得加成'),(2,'[{11853,7021}]','201007','伐木场','icon_fmc','提升伐木场等级可以增加木材产量哦'),(3,'[{5507,11518}]','201007','铁矿场','icon_tkc','提升铁矿场等级可以增加铁矿产量哦'),(4,'[{7853,8090}]','201007','石料场','icon_skc','提升石料场等级可以增加石料产量哦'),(5,'[{9987,5934}]','201007','鱼塘','icon_dyc','提升鱼塘等级可以解锁更多的鱼类哦'),(6,'[{13145,8224}]','201007','许愿池','icon_xyc_1','许愿可以获得大量基础材料和图纸道具'),(7,'[{16287,9783}]','201007','任务场','icon_rwc','完成任务可以获得家园稀有材料哦'),(8,'[{10319,12772}]','201007','雕像','icon_dx','提升可以获得更多属性加成哦'),(9,'[{9512,16792}]','201007','餐厅','icon_ct','提升餐厅等级可以制作更多的食物哦'),(10,'[{6395,14935}]','201007','打造坊','icon_tjp','提升打造坊等级可以制作更多的家具哦');
/*!40000 ALTER TABLE `base_role_home_build` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_role_home_build_attr`
--

DROP TABLE IF EXISTS `base_role_home_build_attr`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_role_home_build_attr` (
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '建筑总等级',
  `attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '属性',
  PRIMARY KEY (`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_role_home_build_attr`
--

LOCK TABLES `base_role_home_build_attr` WRITE;
/*!40000 ALTER TABLE `base_role_home_build_attr` DISABLE KEYS */;
INSERT INTO `base_role_home_build_attr` VALUES (1,'[{2,200},{1,10},{5,4},{6,4}]'),(2,'[{2,400},{1,20},{5,8},{6,8}]'),(3,'[{2,600},{1,30},{5,12},{6,12}]'),(4,'[{2,800},{1,40},{5,16},{6,16}]'),(5,'[{2,1000},{1,50},{5,20},{6,20}]'),(6,'[{2,1200},{1,60},{5,24},{6,24}]'),(7,'[{2,1400},{1,70},{5,28},{6,28}]'),(8,'[{2,1600},{1,80},{5,32},{6,32}]'),(9,'[{2,1800},{1,90},{5,36},{6,36}]'),(10,'[{2,2000},{1,100},{5,40},{6,40}]'),(11,'[{2,2200},{1,110},{5,44},{6,44}]'),(12,'[{2,2400},{1,120},{5,48},{6,48}]'),(13,'[{2,2600},{1,130},{5,52},{6,52}]'),(14,'[{2,2800},{1,140},{5,56},{6,56}]'),(15,'[{2,3000},{1,150},{5,60},{6,60}]'),(16,'[{2,3200},{1,160},{5,64},{6,64}]'),(17,'[{2,3400},{1,170},{5,68},{6,68}]'),(18,'[{2,3600},{1,180},{5,72},{6,72}]'),(19,'[{2,3800},{1,190},{5,76},{6,76}]'),(20,'[{2,4000},{1,200},{5,80},{6,80}]'),(21,'[{2,4200},{1,210},{5,84},{6,84}]'),(22,'[{2,4400},{1,220},{5,88},{6,88}]'),(23,'[{2,4600},{1,230},{5,92},{6,92}]'),(24,'[{2,4800},{1,240},{5,96},{6,96}]'),(25,'[{2,5000},{1,250},{5,100},{6,100}]'),(26,'[{2,5200},{1,260},{5,104},{6,104}]'),(27,'[{2,5400},{1,270},{5,108},{6,108}]'),(28,'[{2,5600},{1,280},{5,112},{6,112}]'),(29,'[{2,5800},{1,290},{5,116},{6,116}]'),(30,'[{2,6000},{1,300},{5,120},{6,120}]'),(31,'[{2,6200},{1,310},{5,124},{6,124}]'),(32,'[{2,6400},{1,320},{5,128},{6,128}]'),(33,'[{2,6600},{1,330},{5,132},{6,132}]'),(34,'[{2,6800},{1,340},{5,136},{6,136}]'),(35,'[{2,7000},{1,350},{5,140},{6,140}]'),(36,'[{2,7200},{1,360},{5,144},{6,144}]'),(37,'[{2,7400},{1,370},{5,148},{6,148}]'),(38,'[{2,7600},{1,380},{5,152},{6,152}]'),(39,'[{2,7800},{1,390},{5,156},{6,156}]'),(40,'[{2,8000},{1,400},{5,160},{6,160}]'),(41,'[{2,8200},{1,410},{5,164},{6,164}]'),(42,'[{2,8400},{1,420},{5,168},{6,168}]'),(43,'[{2,8600},{1,430},{5,172},{6,172}]'),(44,'[{2,8800},{1,440},{5,176},{6,176}]'),(45,'[{2,9000},{1,450},{5,180},{6,180}]'),(46,'[{2,9200},{1,460},{5,184},{6,184}]'),(47,'[{2,9400},{1,470},{5,188},{6,188}]'),(48,'[{2,9600},{1,480},{5,192},{6,192}]'),(49,'[{2,9800},{1,490},{5,196},{6,196}]'),(50,'[{2,10000},{1,500},{5,200},{6,200}]'),(51,'[{2,10200},{1,510},{5,204},{6,204}]'),(52,'[{2,10400},{1,520},{5,208},{6,208}]'),(53,'[{2,10600},{1,530},{5,212},{6,212}]'),(54,'[{2,10800},{1,540},{5,216},{6,216}]'),(55,'[{2,11000},{1,550},{5,220},{6,220}]'),(56,'[{2,11200},{1,560},{5,224},{6,224}]'),(57,'[{2,11400},{1,570},{5,228},{6,228}]'),(58,'[{2,11600},{1,580},{5,232},{6,232}]'),(59,'[{2,11800},{1,590},{5,236},{6,236}]'),(60,'[{2,12000},{1,600},{5,240},{6,240}]'),(61,'[{2,12200},{1,610},{5,244},{6,244}]'),(62,'[{2,12400},{1,620},{5,248},{6,248}]'),(63,'[{2,12600},{1,630},{5,252},{6,252}]'),(64,'[{2,12800},{1,640},{5,256},{6,256}]'),(65,'[{2,13000},{1,650},{5,260},{6,260}]'),(66,'[{2,13200},{1,660},{5,264},{6,264}]'),(67,'[{2,13400},{1,670},{5,268},{6,268}]'),(68,'[{2,13600},{1,680},{5,272},{6,272}]'),(69,'[{2,13800},{1,690},{5,276},{6,276}]'),(70,'[{2,14000},{1,700},{5,280},{6,280}]'),(71,'[{2,14200},{1,710},{5,284},{6,284}]'),(72,'[{2,14400},{1,720},{5,288},{6,288}]'),(73,'[{2,14600},{1,730},{5,292},{6,292}]'),(74,'[{2,14800},{1,740},{5,296},{6,296}]'),(75,'[{2,15000},{1,750},{5,300},{6,300}]'),(76,'[{2,15200},{1,760},{5,304},{6,304}]'),(77,'[{2,15400},{1,770},{5,308},{6,308}]'),(78,'[{2,15600},{1,780},{5,312},{6,312}]'),(79,'[{2,15800},{1,790},{5,316},{6,316}]'),(80,'[{2,16000},{1,800},{5,320},{6,320}]'),(81,'[{2,16200},{1,810},{5,324},{6,324}]'),(82,'[{2,16400},{1,820},{5,328},{6,328}]'),(83,'[{2,16600},{1,830},{5,332},{6,332}]'),(84,'[{2,16800},{1,840},{5,336},{6,336}]'),(85,'[{2,17000},{1,850},{5,340},{6,340}]'),(86,'[{2,17200},{1,860},{5,344},{6,344}]'),(87,'[{2,17400},{1,870},{5,348},{6,348}]'),(88,'[{2,17600},{1,880},{5,352},{6,352}]'),(89,'[{2,17800},{1,890},{5,356},{6,356}]'),(90,'[{2,18000},{1,900},{5,360},{6,360}]'),(91,'[{2,18200},{1,910},{5,364},{6,364}]'),(92,'[{2,18400},{1,920},{5,368},{6,368}]'),(93,'[{2,18600},{1,930},{5,372},{6,372}]'),(94,'[{2,18800},{1,940},{5,376},{6,376}]'),(95,'[{2,19000},{1,950},{5,380},{6,380}]'),(96,'[{2,19200},{1,960},{5,384},{6,384}]'),(97,'[{2,19400},{1,970},{5,388},{6,388}]'),(98,'[{2,19600},{1,980},{5,392},{6,392}]'),(99,'[{2,19800},{1,990},{5,396},{6,396}]'),(100,'[{2,20000},{1,1000},{5,400},{6,400}]'),(101,'[{2,20300},{1,1015},{5,406},{6,406}]'),(102,'[{2,20600},{1,1030},{5,412},{6,412}]'),(103,'[{2,20900},{1,1045},{5,418},{6,418}]'),(104,'[{2,21200},{1,1060},{5,424},{6,424}]'),(105,'[{2,21500},{1,1075},{5,430},{6,430}]'),(106,'[{2,21800},{1,1090},{5,436},{6,436}]'),(107,'[{2,22100},{1,1105},{5,442},{6,442}]'),(108,'[{2,22400},{1,1120},{5,448},{6,448}]'),(109,'[{2,22700},{1,1135},{5,454},{6,454}]'),(110,'[{2,23000},{1,1150},{5,460},{6,460}]'),(111,'[{2,23300},{1,1165},{5,466},{6,466}]'),(112,'[{2,23600},{1,1180},{5,472},{6,472}]'),(113,'[{2,23900},{1,1195},{5,478},{6,478}]'),(114,'[{2,24200},{1,1210},{5,484},{6,484}]'),(115,'[{2,24500},{1,1225},{5,490},{6,490}]'),(116,'[{2,24800},{1,1240},{5,496},{6,496}]'),(117,'[{2,25100},{1,1255},{5,502},{6,502}]'),(118,'[{2,25400},{1,1270},{5,508},{6,508}]'),(119,'[{2,25700},{1,1285},{5,514},{6,514}]'),(120,'[{2,26000},{1,1300},{5,520},{6,520}]'),(121,'[{2,26300},{1,1315},{5,526},{6,526}]'),(122,'[{2,26600},{1,1330},{5,532},{6,532}]'),(123,'[{2,26900},{1,1345},{5,538},{6,538}]'),(124,'[{2,27200},{1,1360},{5,544},{6,544}]'),(125,'[{2,27500},{1,1375},{5,550},{6,550}]'),(126,'[{2,27800},{1,1390},{5,556},{6,556}]'),(127,'[{2,28100},{1,1405},{5,562},{6,562}]'),(128,'[{2,28400},{1,1420},{5,568},{6,568}]'),(129,'[{2,28700},{1,1435},{5,574},{6,574}]'),(130,'[{2,29000},{1,1450},{5,580},{6,580}]'),(131,'[{2,29300},{1,1465},{5,586},{6,586}]'),(132,'[{2,29600},{1,1480},{5,592},{6,592}]'),(133,'[{2,29900},{1,1495},{5,598},{6,598}]'),(134,'[{2,30200},{1,1510},{5,604},{6,604}]'),(135,'[{2,30500},{1,1525},{5,610},{6,610}]'),(136,'[{2,30800},{1,1540},{5,616},{6,616}]'),(137,'[{2,31100},{1,1555},{5,622},{6,622}]'),(138,'[{2,31400},{1,1570},{5,628},{6,628}]'),(139,'[{2,31700},{1,1585},{5,634},{6,634}]'),(140,'[{2,32000},{1,1600},{5,640},{6,640}]'),(141,'[{2,32300},{1,1615},{5,646},{6,646}]'),(142,'[{2,32600},{1,1630},{5,652},{6,652}]'),(143,'[{2,32900},{1,1645},{5,658},{6,658}]'),(144,'[{2,33200},{1,1660},{5,664},{6,664}]'),(145,'[{2,33500},{1,1675},{5,670},{6,670}]'),(146,'[{2,33800},{1,1690},{5,676},{6,676}]'),(147,'[{2,34100},{1,1705},{5,682},{6,682}]'),(148,'[{2,34400},{1,1720},{5,688},{6,688}]'),(149,'[{2,34700},{1,1735},{5,694},{6,694}]'),(150,'[{2,35000},{1,1750},{5,700},{6,700}]'),(151,'[{2,35300},{1,1765},{5,706},{6,706}]'),(152,'[{2,35600},{1,1780},{5,712},{6,712}]'),(153,'[{2,35900},{1,1795},{5,718},{6,718}]'),(154,'[{2,36200},{1,1810},{5,724},{6,724}]'),(155,'[{2,36500},{1,1825},{5,730},{6,730}]'),(156,'[{2,36800},{1,1840},{5,736},{6,736}]'),(157,'[{2,37100},{1,1855},{5,742},{6,742}]'),(158,'[{2,37400},{1,1870},{5,748},{6,748}]'),(159,'[{2,37700},{1,1885},{5,754},{6,754}]'),(160,'[{2,38000},{1,1900},{5,760},{6,760}]'),(161,'[{2,38300},{1,1915},{5,766},{6,766}]'),(162,'[{2,38600},{1,1930},{5,772},{6,772}]'),(163,'[{2,38900},{1,1945},{5,778},{6,778}]'),(164,'[{2,39200},{1,1960},{5,784},{6,784}]'),(165,'[{2,39500},{1,1975},{5,790},{6,790}]'),(166,'[{2,39800},{1,1990},{5,796},{6,796}]'),(167,'[{2,40100},{1,2005},{5,802},{6,802}]'),(168,'[{2,40400},{1,2020},{5,808},{6,808}]'),(169,'[{2,40700},{1,2035},{5,814},{6,814}]'),(170,'[{2,41000},{1,2050},{5,820},{6,820}]'),(171,'[{2,41300},{1,2065},{5,826},{6,826}]'),(172,'[{2,41600},{1,2080},{5,832},{6,832}]'),(173,'[{2,41900},{1,2095},{5,838},{6,838}]'),(174,'[{2,42200},{1,2110},{5,844},{6,844}]'),(175,'[{2,42500},{1,2125},{5,850},{6,850}]'),(176,'[{2,42800},{1,2140},{5,856},{6,856}]'),(177,'[{2,43100},{1,2155},{5,862},{6,862}]'),(178,'[{2,43400},{1,2170},{5,868},{6,868}]'),(179,'[{2,43700},{1,2185},{5,874},{6,874}]'),(180,'[{2,44000},{1,2200},{5,880},{6,880}]'),(181,'[{2,44300},{1,2215},{5,886},{6,886}]'),(182,'[{2,44600},{1,2230},{5,892},{6,892}]'),(183,'[{2,44900},{1,2245},{5,898},{6,898}]'),(184,'[{2,45200},{1,2260},{5,904},{6,904}]'),(185,'[{2,45500},{1,2275},{5,910},{6,910}]'),(186,'[{2,45800},{1,2290},{5,916},{6,916}]'),(187,'[{2,46100},{1,2305},{5,922},{6,922}]'),(188,'[{2,46400},{1,2320},{5,928},{6,928}]'),(189,'[{2,46700},{1,2335},{5,934},{6,934}]'),(190,'[{2,47000},{1,2350},{5,940},{6,940}]'),(191,'[{2,47300},{1,2365},{5,946},{6,946}]'),(192,'[{2,47600},{1,2380},{5,952},{6,952}]'),(193,'[{2,47900},{1,2395},{5,958},{6,958}]'),(194,'[{2,48200},{1,2410},{5,964},{6,964}]'),(195,'[{2,48500},{1,2425},{5,970},{6,970}]'),(196,'[{2,48800},{1,2440},{5,976},{6,976}]'),(197,'[{2,49100},{1,2455},{5,982},{6,982}]'),(198,'[{2,49400},{1,2470},{5,988},{6,988}]'),(199,'[{2,49700},{1,2485},{5,994},{6,994}]'),(200,'[{2,50000},{1,2500},{5,1000},{6,1000}]'),(201,'[{2,50500},{1,2525},{5,1010},{6,1010}]'),(202,'[{2,51000},{1,2550},{5,1020},{6,1020}]'),(203,'[{2,51500},{1,2575},{5,1030},{6,1030}]'),(204,'[{2,52000},{1,2600},{5,1040},{6,1040}]'),(205,'[{2,52500},{1,2625},{5,1050},{6,1050}]'),(206,'[{2,53000},{1,2650},{5,1060},{6,1060}]'),(207,'[{2,53500},{1,2675},{5,1070},{6,1070}]'),(208,'[{2,54000},{1,2700},{5,1080},{6,1080}]'),(209,'[{2,54500},{1,2725},{5,1090},{6,1090}]'),(210,'[{2,55000},{1,2750},{5,1100},{6,1100}]'),(211,'[{2,55500},{1,2775},{5,1110},{6,1110}]'),(212,'[{2,56000},{1,2800},{5,1120},{6,1120}]'),(213,'[{2,56500},{1,2825},{5,1130},{6,1130}]'),(214,'[{2,57000},{1,2850},{5,1140},{6,1140}]'),(215,'[{2,57500},{1,2875},{5,1150},{6,1150}]'),(216,'[{2,58000},{1,2900},{5,1160},{6,1160}]'),(217,'[{2,58500},{1,2925},{5,1170},{6,1170}]'),(218,'[{2,59000},{1,2950},{5,1180},{6,1180}]'),(219,'[{2,59500},{1,2975},{5,1190},{6,1190}]'),(220,'[{2,60000},{1,3000},{5,1200},{6,1200}]'),(221,'[{2,60500},{1,3025},{5,1210},{6,1210}]'),(222,'[{2,61000},{1,3050},{5,1220},{6,1220}]'),(223,'[{2,61500},{1,3075},{5,1230},{6,1230}]'),(224,'[{2,62000},{1,3100},{5,1240},{6,1240}]'),(225,'[{2,62500},{1,3125},{5,1250},{6,1250}]'),(226,'[{2,63000},{1,3150},{5,1260},{6,1260}]'),(227,'[{2,63500},{1,3175},{5,1270},{6,1270}]'),(228,'[{2,64000},{1,3200},{5,1280},{6,1280}]'),(229,'[{2,64500},{1,3225},{5,1290},{6,1290}]'),(230,'[{2,65000},{1,3250},{5,1300},{6,1300}]'),(231,'[{2,65500},{1,3275},{5,1310},{6,1310}]'),(232,'[{2,66000},{1,3300},{5,1320},{6,1320}]'),(233,'[{2,66500},{1,3325},{5,1330},{6,1330}]'),(234,'[{2,67000},{1,3350},{5,1340},{6,1340}]'),(235,'[{2,67500},{1,3375},{5,1350},{6,1350}]'),(236,'[{2,68000},{1,3400},{5,1360},{6,1360}]'),(237,'[{2,68500},{1,3425},{5,1370},{6,1370}]'),(238,'[{2,69000},{1,3450},{5,1380},{6,1380}]'),(239,'[{2,69500},{1,3475},{5,1390},{6,1390}]'),(240,'[{2,70000},{1,3500},{5,1400},{6,1400}]'),(241,'[{2,70500},{1,3525},{5,1410},{6,1410}]'),(242,'[{2,71000},{1,3550},{5,1420},{6,1420}]'),(243,'[{2,71500},{1,3575},{5,1430},{6,1430}]'),(244,'[{2,72000},{1,3600},{5,1440},{6,1440}]'),(245,'[{2,72500},{1,3625},{5,1450},{6,1450}]'),(246,'[{2,73000},{1,3650},{5,1460},{6,1460}]'),(247,'[{2,73500},{1,3675},{5,1470},{6,1470}]'),(248,'[{2,74000},{1,3700},{5,1480},{6,1480}]'),(249,'[{2,74500},{1,3725},{5,1490},{6,1490}]'),(250,'[{2,75000},{1,3750},{5,1500},{6,1500}]'),(251,'[{2,75500},{1,3775},{5,1510},{6,1510}]'),(252,'[{2,76000},{1,3800},{5,1520},{6,1520}]'),(253,'[{2,76500},{1,3825},{5,1530},{6,1530}]'),(254,'[{2,77000},{1,3850},{5,1540},{6,1540}]'),(255,'[{2,77500},{1,3875},{5,1550},{6,1550}]'),(256,'[{2,78000},{1,3900},{5,1560},{6,1560}]'),(257,'[{2,78500},{1,3925},{5,1570},{6,1570}]'),(258,'[{2,79000},{1,3950},{5,1580},{6,1580}]'),(259,'[{2,79500},{1,3975},{5,1590},{6,1590}]'),(260,'[{2,80000},{1,4000},{5,1600},{6,1600}]'),(261,'[{2,80500},{1,4025},{5,1610},{6,1610}]'),(262,'[{2,81000},{1,4050},{5,1620},{6,1620}]'),(263,'[{2,81500},{1,4075},{5,1630},{6,1630}]'),(264,'[{2,82000},{1,4100},{5,1640},{6,1640}]'),(265,'[{2,82500},{1,4125},{5,1650},{6,1650}]'),(266,'[{2,83000},{1,4150},{5,1660},{6,1660}]'),(267,'[{2,83500},{1,4175},{5,1670},{6,1670}]'),(268,'[{2,84000},{1,4200},{5,1680},{6,1680}]'),(269,'[{2,84500},{1,4225},{5,1690},{6,1690}]'),(270,'[{2,85000},{1,4250},{5,1700},{6,1700}]'),(271,'[{2,85500},{1,4275},{5,1710},{6,1710}]'),(272,'[{2,86000},{1,4300},{5,1720},{6,1720}]'),(273,'[{2,86500},{1,4325},{5,1730},{6,1730}]'),(274,'[{2,87000},{1,4350},{5,1740},{6,1740}]'),(275,'[{2,87500},{1,4375},{5,1750},{6,1750}]'),(276,'[{2,88000},{1,4400},{5,1760},{6,1760}]'),(277,'[{2,88500},{1,4425},{5,1770},{6,1770}]'),(278,'[{2,89000},{1,4450},{5,1780},{6,1780}]'),(279,'[{2,89500},{1,4475},{5,1790},{6,1790}]'),(280,'[{2,90000},{1,4500},{5,1800},{6,1800}]'),(281,'[{2,90500},{1,4525},{5,1810},{6,1810}]'),(282,'[{2,91000},{1,4550},{5,1820},{6,1820}]'),(283,'[{2,91500},{1,4575},{5,1830},{6,1830}]'),(284,'[{2,92000},{1,4600},{5,1840},{6,1840}]'),(285,'[{2,92500},{1,4625},{5,1850},{6,1850}]'),(286,'[{2,93000},{1,4650},{5,1860},{6,1860}]'),(287,'[{2,93500},{1,4675},{5,1870},{6,1870}]'),(288,'[{2,94000},{1,4700},{5,1880},{6,1880}]'),(289,'[{2,94500},{1,4725},{5,1890},{6,1890}]'),(290,'[{2,95000},{1,4750},{5,1900},{6,1900}]'),(291,'[{2,95500},{1,4775},{5,1910},{6,1910}]'),(292,'[{2,96000},{1,4800},{5,1920},{6,1920}]'),(293,'[{2,96500},{1,4825},{5,1930},{6,1930}]'),(294,'[{2,97000},{1,4850},{5,1940},{6,1940}]'),(295,'[{2,97500},{1,4875},{5,1950},{6,1950}]'),(296,'[{2,98000},{1,4900},{5,1960},{6,1960}]'),(297,'[{2,98500},{1,4925},{5,1970},{6,1970}]'),(298,'[{2,99000},{1,4950},{5,1980},{6,1980}]'),(299,'[{2,99500},{1,4975},{5,1990},{6,1990}]'),(300,'[{2,100000},{1,5000},{5,2000},{6,2000}]'),(301,'[{2,100800},{1,5040},{5,2016},{6,2016}]'),(302,'[{2,101600},{1,5080},{5,2032},{6,2032}]'),(303,'[{2,102400},{1,5120},{5,2048},{6,2048}]'),(304,'[{2,103200},{1,5160},{5,2064},{6,2064}]'),(305,'[{2,104000},{1,5200},{5,2080},{6,2080}]'),(306,'[{2,104800},{1,5240},{5,2096},{6,2096}]'),(307,'[{2,105600},{1,5280},{5,2112},{6,2112}]'),(308,'[{2,106400},{1,5320},{5,2128},{6,2128}]'),(309,'[{2,107200},{1,5360},{5,2144},{6,2144}]'),(310,'[{2,108000},{1,5400},{5,2160},{6,2160}]'),(311,'[{2,108800},{1,5440},{5,2176},{6,2176}]'),(312,'[{2,109600},{1,5480},{5,2192},{6,2192}]'),(313,'[{2,110400},{1,5520},{5,2208},{6,2208}]'),(314,'[{2,111200},{1,5560},{5,2224},{6,2224}]'),(315,'[{2,112000},{1,5600},{5,2240},{6,2240}]'),(316,'[{2,112800},{1,5640},{5,2256},{6,2256}]'),(317,'[{2,113600},{1,5680},{5,2272},{6,2272}]'),(318,'[{2,114400},{1,5720},{5,2288},{6,2288}]'),(319,'[{2,115200},{1,5760},{5,2304},{6,2304}]'),(320,'[{2,116000},{1,5800},{5,2320},{6,2320}]'),(321,'[{2,116800},{1,5840},{5,2336},{6,2336}]'),(322,'[{2,117600},{1,5880},{5,2352},{6,2352}]'),(323,'[{2,118400},{1,5920},{5,2368},{6,2368}]'),(324,'[{2,119200},{1,5960},{5,2384},{6,2384}]'),(325,'[{2,120000},{1,6000},{5,2400},{6,2400}]'),(326,'[{2,120800},{1,6040},{5,2416},{6,2416}]'),(327,'[{2,121600},{1,6080},{5,2432},{6,2432}]'),(328,'[{2,122400},{1,6120},{5,2448},{6,2448}]'),(329,'[{2,123200},{1,6160},{5,2464},{6,2464}]'),(330,'[{2,124000},{1,6200},{5,2480},{6,2480}]'),(331,'[{2,124800},{1,6240},{5,2496},{6,2496}]'),(332,'[{2,125600},{1,6280},{5,2512},{6,2512}]'),(333,'[{2,126400},{1,6320},{5,2528},{6,2528}]'),(334,'[{2,127200},{1,6360},{5,2544},{6,2544}]'),(335,'[{2,128000},{1,6400},{5,2560},{6,2560}]'),(336,'[{2,128800},{1,6440},{5,2576},{6,2576}]'),(337,'[{2,129600},{1,6480},{5,2592},{6,2592}]'),(338,'[{2,130400},{1,6520},{5,2608},{6,2608}]'),(339,'[{2,131200},{1,6560},{5,2624},{6,2624}]'),(340,'[{2,132000},{1,6600},{5,2640},{6,2640}]'),(341,'[{2,132800},{1,6640},{5,2656},{6,2656}]'),(342,'[{2,133600},{1,6680},{5,2672},{6,2672}]'),(343,'[{2,134400},{1,6720},{5,2688},{6,2688}]'),(344,'[{2,135200},{1,6760},{5,2704},{6,2704}]'),(345,'[{2,136000},{1,6800},{5,2720},{6,2720}]'),(346,'[{2,136800},{1,6840},{5,2736},{6,2736}]'),(347,'[{2,137600},{1,6880},{5,2752},{6,2752}]'),(348,'[{2,138400},{1,6920},{5,2768},{6,2768}]'),(349,'[{2,139200},{1,6960},{5,2784},{6,2784}]'),(350,'[{2,140000},{1,7000},{5,2800},{6,2800}]'),(351,'[{2,140800},{1,7040},{5,2816},{6,2816}]'),(352,'[{2,141600},{1,7080},{5,2832},{6,2832}]'),(353,'[{2,142400},{1,7120},{5,2848},{6,2848}]'),(354,'[{2,143200},{1,7160},{5,2864},{6,2864}]'),(355,'[{2,144000},{1,7200},{5,2880},{6,2880}]'),(356,'[{2,144800},{1,7240},{5,2896},{6,2896}]'),(357,'[{2,145600},{1,7280},{5,2912},{6,2912}]'),(358,'[{2,146400},{1,7320},{5,2928},{6,2928}]'),(359,'[{2,147200},{1,7360},{5,2944},{6,2944}]'),(360,'[{2,148000},{1,7400},{5,2960},{6,2960}]'),(361,'[{2,148800},{1,7440},{5,2976},{6,2976}]'),(362,'[{2,149600},{1,7480},{5,2992},{6,2992}]'),(363,'[{2,150400},{1,7520},{5,3008},{6,3008}]'),(364,'[{2,151200},{1,7560},{5,3024},{6,3024}]'),(365,'[{2,152000},{1,7600},{5,3040},{6,3040}]'),(366,'[{2,152800},{1,7640},{5,3056},{6,3056}]'),(367,'[{2,153600},{1,7680},{5,3072},{6,3072}]'),(368,'[{2,154400},{1,7720},{5,3088},{6,3088}]'),(369,'[{2,155200},{1,7760},{5,3104},{6,3104}]'),(370,'[{2,156000},{1,7800},{5,3120},{6,3120}]'),(371,'[{2,156800},{1,7840},{5,3136},{6,3136}]'),(372,'[{2,157600},{1,7880},{5,3152},{6,3152}]'),(373,'[{2,158400},{1,7920},{5,3168},{6,3168}]'),(374,'[{2,159200},{1,7960},{5,3184},{6,3184}]'),(375,'[{2,160000},{1,8000},{5,3200},{6,3200}]'),(376,'[{2,160800},{1,8040},{5,3216},{6,3216}]'),(377,'[{2,161600},{1,8080},{5,3232},{6,3232}]'),(378,'[{2,162400},{1,8120},{5,3248},{6,3248}]'),(379,'[{2,163200},{1,8160},{5,3264},{6,3264}]'),(380,'[{2,164000},{1,8200},{5,3280},{6,3280}]'),(381,'[{2,164800},{1,8240},{5,3296},{6,3296}]'),(382,'[{2,165600},{1,8280},{5,3312},{6,3312}]'),(383,'[{2,166400},{1,8320},{5,3328},{6,3328}]'),(384,'[{2,167200},{1,8360},{5,3344},{6,3344}]'),(385,'[{2,168000},{1,8400},{5,3360},{6,3360}]'),(386,'[{2,168800},{1,8440},{5,3376},{6,3376}]'),(387,'[{2,169600},{1,8480},{5,3392},{6,3392}]'),(388,'[{2,170400},{1,8520},{5,3408},{6,3408}]'),(389,'[{2,171200},{1,8560},{5,3424},{6,3424}]'),(390,'[{2,172000},{1,8600},{5,3440},{6,3440}]'),(391,'[{2,172800},{1,8640},{5,3456},{6,3456}]'),(392,'[{2,173600},{1,8680},{5,3472},{6,3472}]'),(393,'[{2,174400},{1,8720},{5,3488},{6,3488}]'),(394,'[{2,175200},{1,8760},{5,3504},{6,3504}]'),(395,'[{2,176000},{1,8800},{5,3520},{6,3520}]'),(396,'[{2,176800},{1,8840},{5,3536},{6,3536}]'),(397,'[{2,177600},{1,8880},{5,3552},{6,3552}]'),(398,'[{2,178400},{1,8920},{5,3568},{6,3568}]'),(399,'[{2,179200},{1,8960},{5,3584},{6,3584}]'),(400,'[{2,180000},{1,9000},{5,3600},{6,3600}]'),(401,'[{2,181200},{1,9060},{5,3624},{6,3624}]'),(402,'[{2,182400},{1,9120},{5,3648},{6,3648}]'),(403,'[{2,183600},{1,9180},{5,3672},{6,3672}]'),(404,'[{2,184800},{1,9240},{5,3696},{6,3696}]'),(405,'[{2,186000},{1,9300},{5,3720},{6,3720}]'),(406,'[{2,187200},{1,9360},{5,3744},{6,3744}]'),(407,'[{2,188400},{1,9420},{5,3768},{6,3768}]'),(408,'[{2,189600},{1,9480},{5,3792},{6,3792}]'),(409,'[{2,190800},{1,9540},{5,3816},{6,3816}]'),(410,'[{2,192000},{1,9600},{5,3840},{6,3840}]'),(411,'[{2,193200},{1,9660},{5,3864},{6,3864}]'),(412,'[{2,194400},{1,9720},{5,3888},{6,3888}]'),(413,'[{2,195600},{1,9780},{5,3912},{6,3912}]'),(414,'[{2,196800},{1,9840},{5,3936},{6,3936}]'),(415,'[{2,198000},{1,9900},{5,3960},{6,3960}]'),(416,'[{2,199200},{1,9960},{5,3984},{6,3984}]'),(417,'[{2,200400},{1,10020},{5,4008},{6,4008}]'),(418,'[{2,201600},{1,10080},{5,4032},{6,4032}]'),(419,'[{2,202800},{1,10140},{5,4056},{6,4056}]'),(420,'[{2,204000},{1,10200},{5,4080},{6,4080}]'),(421,'[{2,205200},{1,10260},{5,4104},{6,4104}]'),(422,'[{2,206400},{1,10320},{5,4128},{6,4128}]'),(423,'[{2,207600},{1,10380},{5,4152},{6,4152}]'),(424,'[{2,208800},{1,10440},{5,4176},{6,4176}]'),(425,'[{2,210000},{1,10500},{5,4200},{6,4200}]'),(426,'[{2,211200},{1,10560},{5,4224},{6,4224}]'),(427,'[{2,212400},{1,10620},{5,4248},{6,4248}]'),(428,'[{2,213600},{1,10680},{5,4272},{6,4272}]'),(429,'[{2,214800},{1,10740},{5,4296},{6,4296}]'),(430,'[{2,216000},{1,10800},{5,4320},{6,4320}]'),(431,'[{2,217200},{1,10860},{5,4344},{6,4344}]'),(432,'[{2,218400},{1,10920},{5,4368},{6,4368}]'),(433,'[{2,219600},{1,10980},{5,4392},{6,4392}]'),(434,'[{2,220800},{1,11040},{5,4416},{6,4416}]'),(435,'[{2,222000},{1,11100},{5,4440},{6,4440}]'),(436,'[{2,223200},{1,11160},{5,4464},{6,4464}]'),(437,'[{2,224400},{1,11220},{5,4488},{6,4488}]'),(438,'[{2,225600},{1,11280},{5,4512},{6,4512}]'),(439,'[{2,226800},{1,11340},{5,4536},{6,4536}]'),(440,'[{2,228000},{1,11400},{5,4560},{6,4560}]'),(441,'[{2,229200},{1,11460},{5,4584},{6,4584}]'),(442,'[{2,230400},{1,11520},{5,4608},{6,4608}]'),(443,'[{2,231600},{1,11580},{5,4632},{6,4632}]'),(444,'[{2,232800},{1,11640},{5,4656},{6,4656}]'),(445,'[{2,234000},{1,11700},{5,4680},{6,4680}]'),(446,'[{2,235200},{1,11760},{5,4704},{6,4704}]'),(447,'[{2,236400},{1,11820},{5,4728},{6,4728}]'),(448,'[{2,237600},{1,11880},{5,4752},{6,4752}]'),(449,'[{2,238800},{1,11940},{5,4776},{6,4776}]'),(450,'[{2,240000},{1,12000},{5,4800},{6,4800}]'),(451,'[{2,241200},{1,12060},{5,4824},{6,4824}]'),(452,'[{2,242400},{1,12120},{5,4848},{6,4848}]'),(453,'[{2,243600},{1,12180},{5,4872},{6,4872}]'),(454,'[{2,244800},{1,12240},{5,4896},{6,4896}]'),(455,'[{2,246000},{1,12300},{5,4920},{6,4920}]'),(456,'[{2,247200},{1,12360},{5,4944},{6,4944}]'),(457,'[{2,248400},{1,12420},{5,4968},{6,4968}]'),(458,'[{2,249600},{1,12480},{5,4992},{6,4992}]'),(459,'[{2,250800},{1,12540},{5,5016},{6,5016}]'),(460,'[{2,252000},{1,12600},{5,5040},{6,5040}]'),(461,'[{2,253200},{1,12660},{5,5064},{6,5064}]'),(462,'[{2,254400},{1,12720},{5,5088},{6,5088}]'),(463,'[{2,255600},{1,12780},{5,5112},{6,5112}]'),(464,'[{2,256800},{1,12840},{5,5136},{6,5136}]'),(465,'[{2,258000},{1,12900},{5,5160},{6,5160}]'),(466,'[{2,259200},{1,12960},{5,5184},{6,5184}]'),(467,'[{2,260400},{1,13020},{5,5208},{6,5208}]'),(468,'[{2,261600},{1,13080},{5,5232},{6,5232}]'),(469,'[{2,262800},{1,13140},{5,5256},{6,5256}]'),(470,'[{2,264000},{1,13200},{5,5280},{6,5280}]'),(471,'[{2,265200},{1,13260},{5,5304},{6,5304}]'),(472,'[{2,266400},{1,13320},{5,5328},{6,5328}]'),(473,'[{2,267600},{1,13380},{5,5352},{6,5352}]'),(474,'[{2,268800},{1,13440},{5,5376},{6,5376}]'),(475,'[{2,270000},{1,13500},{5,5400},{6,5400}]'),(476,'[{2,271200},{1,13560},{5,5424},{6,5424}]'),(477,'[{2,272400},{1,13620},{5,5448},{6,5448}]'),(478,'[{2,273600},{1,13680},{5,5472},{6,5472}]'),(479,'[{2,274800},{1,13740},{5,5496},{6,5496}]'),(480,'[{2,276000},{1,13800},{5,5520},{6,5520}]'),(481,'[{2,277200},{1,13860},{5,5544},{6,5544}]'),(482,'[{2,278400},{1,13920},{5,5568},{6,5568}]'),(483,'[{2,279600},{1,13980},{5,5592},{6,5592}]'),(484,'[{2,280800},{1,14040},{5,5616},{6,5616}]'),(485,'[{2,282000},{1,14100},{5,5640},{6,5640}]'),(486,'[{2,283200},{1,14160},{5,5664},{6,5664}]'),(487,'[{2,284400},{1,14220},{5,5688},{6,5688}]'),(488,'[{2,285600},{1,14280},{5,5712},{6,5712}]'),(489,'[{2,286800},{1,14340},{5,5736},{6,5736}]'),(490,'[{2,288000},{1,14400},{5,5760},{6,5760}]'),(491,'[{2,289200},{1,14460},{5,5784},{6,5784}]'),(492,'[{2,290400},{1,14520},{5,5808},{6,5808}]'),(493,'[{2,291600},{1,14580},{5,5832},{6,5832}]'),(494,'[{2,292800},{1,14640},{5,5856},{6,5856}]'),(495,'[{2,294000},{1,14700},{5,5880},{6,5880}]'),(496,'[{2,295200},{1,14760},{5,5904},{6,5904}]'),(497,'[{2,296400},{1,14820},{5,5928},{6,5928}]'),(498,'[{2,297600},{1,14880},{5,5952},{6,5952}]'),(499,'[{2,298800},{1,14940},{5,5976},{6,5976}]'),(500,'[{2,300000},{1,15000},{5,6000},{6,6000}]'),(501,'[{2,301600},{1,15080},{5,6032},{6,6032}]'),(502,'[{2,303200},{1,15160},{5,6064},{6,6064}]'),(503,'[{2,304800},{1,15240},{5,6096},{6,6096}]'),(504,'[{2,306400},{1,15320},{5,6128},{6,6128}]'),(505,'[{2,308000},{1,15400},{5,6160},{6,6160}]'),(506,'[{2,309600},{1,15480},{5,6192},{6,6192}]'),(507,'[{2,311200},{1,15560},{5,6224},{6,6224}]'),(508,'[{2,312800},{1,15640},{5,6256},{6,6256}]'),(509,'[{2,314400},{1,15720},{5,6288},{6,6288}]'),(510,'[{2,316000},{1,15800},{5,6320},{6,6320}]'),(511,'[{2,317600},{1,15880},{5,6352},{6,6352}]'),(512,'[{2,319200},{1,15960},{5,6384},{6,6384}]'),(513,'[{2,320800},{1,16040},{5,6416},{6,6416}]'),(514,'[{2,322400},{1,16120},{5,6448},{6,6448}]'),(515,'[{2,324000},{1,16200},{5,6480},{6,6480}]'),(516,'[{2,325600},{1,16280},{5,6512},{6,6512}]'),(517,'[{2,327200},{1,16360},{5,6544},{6,6544}]'),(518,'[{2,328800},{1,16440},{5,6576},{6,6576}]'),(519,'[{2,330400},{1,16520},{5,6608},{6,6608}]'),(520,'[{2,332000},{1,16600},{5,6640},{6,6640}]'),(521,'[{2,333600},{1,16680},{5,6672},{6,6672}]'),(522,'[{2,335200},{1,16760},{5,6704},{6,6704}]'),(523,'[{2,336800},{1,16840},{5,6736},{6,6736}]'),(524,'[{2,338400},{1,16920},{5,6768},{6,6768}]'),(525,'[{2,340000},{1,17000},{5,6800},{6,6800}]'),(526,'[{2,341600},{1,17080},{5,6832},{6,6832}]'),(527,'[{2,343200},{1,17160},{5,6864},{6,6864}]'),(528,'[{2,344800},{1,17240},{5,6896},{6,6896}]'),(529,'[{2,346400},{1,17320},{5,6928},{6,6928}]'),(530,'[{2,348000},{1,17400},{5,6960},{6,6960}]'),(531,'[{2,349600},{1,17480},{5,6992},{6,6992}]'),(532,'[{2,351200},{1,17560},{5,7024},{6,7024}]'),(533,'[{2,352800},{1,17640},{5,7056},{6,7056}]'),(534,'[{2,354400},{1,17720},{5,7088},{6,7088}]'),(535,'[{2,356000},{1,17800},{5,7120},{6,7120}]'),(536,'[{2,357600},{1,17880},{5,7152},{6,7152}]'),(537,'[{2,359200},{1,17960},{5,7184},{6,7184}]'),(538,'[{2,360800},{1,18040},{5,7216},{6,7216}]'),(539,'[{2,362400},{1,18120},{5,7248},{6,7248}]'),(540,'[{2,364000},{1,18200},{5,7280},{6,7280}]'),(541,'[{2,365600},{1,18280},{5,7312},{6,7312}]'),(542,'[{2,367200},{1,18360},{5,7344},{6,7344}]'),(543,'[{2,368800},{1,18440},{5,7376},{6,7376}]'),(544,'[{2,370400},{1,18520},{5,7408},{6,7408}]'),(545,'[{2,372000},{1,18600},{5,7440},{6,7440}]'),(546,'[{2,373600},{1,18680},{5,7472},{6,7472}]'),(547,'[{2,375200},{1,18760},{5,7504},{6,7504}]'),(548,'[{2,376800},{1,18840},{5,7536},{6,7536}]'),(549,'[{2,378400},{1,18920},{5,7568},{6,7568}]'),(550,'[{2,380000},{1,19000},{5,7600},{6,7600}]'),(551,'[{2,381600},{1,19080},{5,7632},{6,7632}]'),(552,'[{2,383200},{1,19160},{5,7664},{6,7664}]'),(553,'[{2,384800},{1,19240},{5,7696},{6,7696}]'),(554,'[{2,386400},{1,19320},{5,7728},{6,7728}]'),(555,'[{2,388000},{1,19400},{5,7760},{6,7760}]'),(556,'[{2,389600},{1,19480},{5,7792},{6,7792}]'),(557,'[{2,391200},{1,19560},{5,7824},{6,7824}]'),(558,'[{2,392800},{1,19640},{5,7856},{6,7856}]'),(559,'[{2,394400},{1,19720},{5,7888},{6,7888}]'),(560,'[{2,396000},{1,19800},{5,7920},{6,7920}]'),(561,'[{2,397600},{1,19880},{5,7952},{6,7952}]'),(562,'[{2,399200},{1,19960},{5,7984},{6,7984}]'),(563,'[{2,400800},{1,20040},{5,8016},{6,8016}]'),(564,'[{2,402400},{1,20120},{5,8048},{6,8048}]'),(565,'[{2,404000},{1,20200},{5,8080},{6,8080}]'),(566,'[{2,405600},{1,20280},{5,8112},{6,8112}]'),(567,'[{2,407200},{1,20360},{5,8144},{6,8144}]'),(568,'[{2,408800},{1,20440},{5,8176},{6,8176}]'),(569,'[{2,410400},{1,20520},{5,8208},{6,8208}]'),(570,'[{2,412000},{1,20600},{5,8240},{6,8240}]'),(571,'[{2,413600},{1,20680},{5,8272},{6,8272}]'),(572,'[{2,415200},{1,20760},{5,8304},{6,8304}]'),(573,'[{2,416800},{1,20840},{5,8336},{6,8336}]'),(574,'[{2,418400},{1,20920},{5,8368},{6,8368}]'),(575,'[{2,420000},{1,21000},{5,8400},{6,8400}]'),(576,'[{2,421600},{1,21080},{5,8432},{6,8432}]'),(577,'[{2,423200},{1,21160},{5,8464},{6,8464}]'),(578,'[{2,424800},{1,21240},{5,8496},{6,8496}]'),(579,'[{2,426400},{1,21320},{5,8528},{6,8528}]'),(580,'[{2,428000},{1,21400},{5,8560},{6,8560}]'),(581,'[{2,429600},{1,21480},{5,8592},{6,8592}]'),(582,'[{2,431200},{1,21560},{5,8624},{6,8624}]'),(583,'[{2,432800},{1,21640},{5,8656},{6,8656}]'),(584,'[{2,434400},{1,21720},{5,8688},{6,8688}]'),(585,'[{2,436000},{1,21800},{5,8720},{6,8720}]'),(586,'[{2,437600},{1,21880},{5,8752},{6,8752}]'),(587,'[{2,439200},{1,21960},{5,8784},{6,8784}]'),(588,'[{2,440800},{1,22040},{5,8816},{6,8816}]'),(589,'[{2,442400},{1,22120},{5,8848},{6,8848}]'),(590,'[{2,444000},{1,22200},{5,8880},{6,8880}]'),(591,'[{2,445600},{1,22280},{5,8912},{6,8912}]'),(592,'[{2,447200},{1,22360},{5,8944},{6,8944}]'),(593,'[{2,448800},{1,22440},{5,8976},{6,8976}]'),(594,'[{2,450400},{1,22520},{5,9008},{6,9008}]'),(595,'[{2,452000},{1,22600},{5,9040},{6,9040}]'),(596,'[{2,453600},{1,22680},{5,9072},{6,9072}]'),(597,'[{2,455200},{1,22760},{5,9104},{6,9104}]'),(598,'[{2,456800},{1,22840},{5,9136},{6,9136}]'),(599,'[{2,458400},{1,22920},{5,9168},{6,9168}]'),(600,'[{2,460000},{1,23000},{5,9200},{6,9200}]');
/*!40000 ALTER TABLE `base_role_home_build_attr` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_role_home_build_lv`
--

DROP TABLE IF EXISTS `base_role_home_build_lv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_role_home_build_lv` (
  `build_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '建筑类型',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '建筑名称',
  `build_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `condition` varchar(255) NOT NULL DEFAULT '[]' COMMENT '升级条件',
  `g_cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '物品消耗',
  `cost` varchar(50) NOT NULL DEFAULT '[]' COMMENT '资源消耗',
  `cd` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '升级cd',
  `up_cost` varchar(50) NOT NULL DEFAULT '[]' COMMENT '立即升级',
  PRIMARY KEY (`build_type`,`build_lv`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_role_home_build_lv`
--

LOCK TABLES `base_role_home_build_lv` WRITE;
/*!40000 ALTER TABLE `base_role_home_build_lv` DISABLE KEYS */;
INSERT INTO `base_role_home_build_lv` VALUES (1,'房屋',1,'[]','[]','[{1,38},{2,38},{3,38}]',20,'[{2,36020001,1}]'),(1,'房屋',2,'[{build_lv,[{1,1}]}]','[]','[{1,255},{2,255},{3,255}]',90,'[{2,36020001,2}]'),(1,'房屋',3,'[{build_lv,[{1,2}]}]','[]','[{1,2265},{2,2265},{3,2265}]',480,'[{2,36020001,8}]'),(1,'房屋',4,'[{build_lv,[{1,3}]}]','[]','[{1,18109},{2,18109},{3,18109}]',2400,'[{2,36020001,40}]'),(1,'房屋',5,'[{build_lv,[{1,4}]}]','[]','[{1,67914},{2,67914},{3,67914}]',6000,'[{2,36020001,100}]'),(1,'房屋',6,'[{build_lv,[{1,5}]}]','[]','[{1,230917},{2,230917},{3,230917}]',14400,'[{2,36020001,240}]'),(1,'房屋',7,'[{build_lv,[{1,6}]}]','[]','[{1,468625},{2,468625},{3,468625}]',21600,'[{2,36020001,360}]'),(1,'房屋',8,'[{build_lv,[{1,7}]}]','[]','[{1,713125},{2,713125},{3,713125}]',25200,'[{2,36020001,420}]'),(1,'房屋',9,'[{build_lv,[{1,8}]}]','[]','[{1,1032333},{2,1032333},{3,1032333}]',28800,'[{2,36020001,480}]'),(1,'房屋',10,'[{build_lv,[{1,9}]}]','[]','[{1,1436438},{2,1436438},{3,1436438}]',32400,'[{2,36020001,540}]'),(1,'房屋',11,'[{build_lv,[{1,10}]}]','[]','[{1,1946387},{2,1946387},{3,1946387}]',36200,'[{2,36020001,604}]'),(1,'房屋',12,'[{build_lv,[{1,11}]}]','[]','[{1,2578554},{2,2578554},{3,2578554}]',40200,'[{2,36020001,670}]'),(1,'房屋',13,'[{build_lv,[{1,12}]}]','[]','[{1,3350574},{2,3350574},{3,3350574}]',44400,'[{2,36020001,740}]'),(1,'房屋',14,'[{build_lv,[{1,13}]}]','[]','[{1,4281028},{2,4281028},{3,4281028}]',48800,'[{2,36020001,814}]'),(1,'房屋',15,'[{build_lv,[{1,14}]}]','[]','[{1,5389778},{2,5389778},{3,5389778}]',53400,'[{2,36020001,890}]'),(1,'房屋',16,'[{build_lv,[{1,15}]}]','[]','[{1,6697688},{2,6697688},{3,6697688}]',58200,'[{2,36020001,970}]'),(1,'房屋',17,'[{build_lv,[{1,16}]}]','[]','[{1,8226993},{2,8226993},{3,8226993}]',63200,'[{2,36020001,1054}]'),(1,'房屋',18,'[{build_lv,[{1,17}]}]','[]','[{1,10000729},{2,10000729},{3,10000729}]',68400,'[{2,36020001,1140}]'),(1,'房屋',19,'[{build_lv,[{1,18}]}]','[]','[{1,12043323},{2,12043323},{3,12043323}]',73800,'[{2,36020001,1230}]'),(1,'房屋',20,'[{build_lv,[{1,19}]}]','[]','[{1,14344000},{2,14344000},{3,14344000}]',79200,'[{2,36020001,1320}]'),(1,'房屋',21,'[{build_lv,[{1,20}]}]','[]','[{1,16918042},{2,16918042},{3,16918042}]',84600,'[{2,36020001,1410}]'),(1,'房屋',22,'[{build_lv,[{1,21}]}]','[]','[{1,19780729},{2,19780729},{3,19780729}]',90000,'[{2,36020001,1500}]'),(1,'房屋',23,'[{build_lv,[{1,22}]}]','[]','[{1,22947344},{2,22947344},{3,22947344}]',95400,'[{2,36020001,1590}]'),(1,'房屋',24,'[{build_lv,[{1,23}]}]','[]','[{1,26433167},{2,26433167},{3,26433167}]',100800,'[{2,36020001,1680}]'),(1,'房屋',25,'[{build_lv,[{1,24}]}]','[]','[{1,30253479},{2,30253479},{3,30253479}]',106200,'[{2,36020001,1770}]'),(1,'房屋',26,'[{build_lv,[{1,25}]}]','[]','[{1,34423563},{2,34423563},{3,34423563}]',111600,'[{2,36020001,1860}]'),(1,'房屋',27,'[{build_lv,[{1,26}]}]','[]','[{1,38958698},{2,38958698},{3,38958698}]',117000,'[{2,36020001,1950}]'),(1,'房屋',28,'[{build_lv,[{1,27}]}]','[]','[{1,43874167},{2,43874167},{3,43874167}]',122400,'[{2,36020001,2040}]'),(1,'房屋',29,'[{build_lv,[{1,28}]}]','[]','[{1,49185250},{2,49185250},{3,49185250}]',127800,'[{2,36020001,2130}]'),(1,'房屋',30,'[{build_lv,[{1,29}]}]','[]','[{1,54907229},{2,54907229},{3,54907229}]',133200,'[{2,36020001,2220}]'),(1,'房屋',31,'[{build_lv,[{1,30}]}]','[]','[{1,61055385},{2,61055385},{3,61055385}]',138600,'[{2,36020001,2310}]'),(1,'房屋',32,'[{build_lv,[{1,31}]}]','[]','[{1,67645000},{2,67645000},{3,67645000}]',144000,'[{2,36020001,2400}]'),(1,'房屋',33,'[{build_lv,[{1,32}]}]','[]','[{1,74691354},{2,74691354},{3,74691354}]',149400,'[{2,36020001,2490}]'),(1,'房屋',34,'[{build_lv,[{1,33}]}]','[]','[{1,82209729},{2,82209729},{3,82209729}]',154800,'[{2,36020001,2580}]'),(1,'房屋',35,'[{build_lv,[{1,34}]}]','[]','[{1,90215406},{2,90215406},{3,90215406}]',160200,'[{2,36020001,2670}]'),(1,'房屋',36,'[{build_lv,[{1,35}]}]','[]','[{1,98723667},{2,98723667},{3,98723667}]',165600,'[{2,36020001,2760}]'),(1,'房屋',37,'[{build_lv,[{1,36}]}]','[]','[{1,107749792},{2,107749792},{3,107749792}]',171000,'[{2,36020001,2850}]'),(1,'房屋',38,'[{build_lv,[{1,37}]}]','[]','[{1,117309063},{2,117309063},{3,117309063}]',176400,'[{2,36020001,2940}]'),(1,'房屋',39,'[{build_lv,[{1,38}]}]','[]','[{1,127416760},{2,127416760},{3,127416760}]',181800,'[{2,36020001,3030}]'),(1,'房屋',40,'[{build_lv,[{1,39}]}]','[]','[{1,139415938},{2,139415938},{3,139415938}]',189000,'[{2,36020001,3150}]'),(1,'房屋',41,'[{build_lv,[{1,40}]}]','[]','[{1,152129938},{2,152129938},{3,152129938}]',196200,'[{2,36020001,3270}]'),(1,'房屋',42,'[{build_lv,[{1,41}]}]','[]','[{1,165579135},{2,165579135},{3,165579135}]',203400,'[{2,36020001,3390}]'),(1,'房屋',43,'[{build_lv,[{1,42}]}]','[]','[{1,179783906},{2,179783906},{3,179783906}]',210600,'[{2,36020001,3510}]'),(1,'房屋',44,'[{build_lv,[{1,43}]}]','[]','[{1,194764625},{2,194764625},{3,194764625}]',217800,'[{2,36020001,3630}]'),(1,'房屋',45,'[{build_lv,[{1,44}]}]','[]','[{1,210541667},{2,210541667},{3,210541667}]',225000,'[{2,36020001,3750}]'),(1,'房屋',46,'[{build_lv,[{1,45}]}]','[]','[{1,227135406},{2,227135406},{3,227135406}]',232200,'[{2,36020001,3870}]'),(1,'房屋',47,'[{build_lv,[{1,46}]}]','[]','[{1,244566219},{2,244566219},{3,244566219}]',239400,'[{2,36020001,3990}]'),(1,'房屋',48,'[{build_lv,[{1,47}]}]','[]','[{1,262854479},{2,262854479},{3,262854479}]',246600,'[{2,36020001,4110}]'),(1,'房屋',49,'[{build_lv,[{1,48}]}]','[]','[{1,282020563},{2,282020563},{3,282020563}]',253800,'[{2,36020001,4230}]'),(1,'房屋',50,'[{build_lv,[{1,49}]}]','[]','[{1,302084844},{2,302084844},{3,302084844}]',261000,'[{2,36020001,4350}]'),(1,'房屋',51,'[{build_lv,[{1,50}]}]','[]','[{1,323067698},{2,323067698},{3,323067698}]',268200,'[{2,36020001,4470}]'),(1,'房屋',52,'[{build_lv,[{1,51}]}]','[]','[{1,344989500},{2,344989500},{3,344989500}]',275400,'[{2,36020001,4590}]'),(1,'房屋',53,'[{build_lv,[{1,52}]}]','[]','[{1,367870625},{2,367870625},{3,367870625}]',282600,'[{2,36020001,4710}]'),(1,'房屋',54,'[{build_lv,[{1,53}]}]','[]','[{1,391731448},{2,391731448},{3,391731448}]',289800,'[{2,36020001,4830}]'),(1,'房屋',55,'[{build_lv,[{1,54}]}]','[]','[{1,416592344},{2,416592344},{3,416592344}]',297000,'[{2,36020001,4950}]'),(1,'房屋',56,'[{build_lv,[{1,55}]}]','[]','[{1,442473688},{2,442473688},{3,442473688}]',304200,'[{2,36020001,5070}]'),(1,'房屋',57,'[{build_lv,[{1,56}]}]','[]','[{1,469395854},{2,469395854},{3,469395854}]',311400,'[{2,36020001,5190}]'),(1,'房屋',58,'[{build_lv,[{1,57}]}]','[]','[{1,497379219},{2,497379219},{3,497379219}]',318600,'[{2,36020001,5310}]'),(1,'房屋',59,'[{build_lv,[{1,58}]}]','[]','[{1,526444156},{2,526444156},{3,526444156}]',325800,'[{2,36020001,5430}]'),(1,'房屋',60,'[{build_lv,[{1,59}]}]','[]','[]',0,'[]'),(2,'伐木场',1,'[]','[]','[{2,25},{3,25}]',13,'[{2,36020001,1}]'),(2,'伐木场',2,'[{build_lv,[{2,1}]}]','[]','[{2,170},{3,170}]',60,'[{2,36020001,1}]'),(2,'伐木场',3,'[{build_lv,[{2,2}]}]','[]','[{2,1515},{3,1515}]',320,'[{2,36020001,6}]'),(2,'伐木场',4,'[{build_lv,[{2,3}]}]','[]','[{2,12110},{3,12110}]',1600,'[{2,36020001,27}]'),(2,'伐木场',5,'[{build_lv,[{2,4}]}]','[]','[{2,45415},{3,45415}]',4000,'[{2,36020001,67}]'),(2,'伐木场',6,'[{build_lv,[{2,5}]}]','[]','[{2,154417},{3,154417}]',9600,'[{2,36020001,160}]'),(2,'伐木场',7,'[{build_lv,[{2,6}]}]','[]','[{2,313375},{3,313375}]',14400,'[{2,36020001,240}]'),(2,'伐木场',8,'[{build_lv,[{2,7}]}]','[]','[{2,476875},{3,476875}]',16800,'[{2,36020001,280}]'),(2,'伐木场',9,'[{build_lv,[{2,8}]}]','[]','[{2,690333},{3,690333}]',19200,'[{2,36020001,320}]'),(2,'伐木场',10,'[{build_lv,[{2,9}]}]','[]','[{2,960563},{3,960563}]',21600,'[{2,36020001,360}]'),(2,'伐木场',11,'[{build_lv,[{2,10}]}]','[]','[{2,1301572},{3,1301572}]',24133,'[{2,36020001,403}]'),(2,'伐木场',12,'[{build_lv,[{2,11}]}]','[]','[{2,1724309},{3,1724309}]',26800,'[{2,36020001,447}]'),(2,'伐木场',13,'[{build_lv,[{2,12}]}]','[]','[{2,2240568},{3,2240568}]',29600,'[{2,36020001,494}]'),(2,'伐木场',14,'[{build_lv,[{2,13}]}]','[]','[{2,2862773},{3,2862773}]',32533,'[{2,36020001,543}]'),(2,'伐木场',15,'[{build_lv,[{2,14}]}]','[]','[{2,3604207},{3,3604207}]',35600,'[{2,36020001,594}]'),(2,'伐木场',16,'[{build_lv,[{2,15}]}]','[]','[{2,4478822},{3,4478822}]',38800,'[{2,36020001,647}]'),(2,'伐木场',17,'[{build_lv,[{2,16}]}]','[]','[{2,5501486},{3,5501486}]',42133,'[{2,36020001,703}]'),(2,'伐木场',18,'[{build_lv,[{2,17}]}]','[]','[{2,6687604},{3,6687604}]',45600,'[{2,36020001,760}]'),(2,'伐木场',19,'[{build_lv,[{2,18}]}]','[]','[{2,8053510},{3,8053510}]',49200,'[{2,36020001,820}]'),(2,'伐木场',20,'[{build_lv,[{2,19}]}]','[]','[{2,9592000},{3,9592000}]',52800,'[{2,36020001,880}]'),(2,'伐木场',21,'[{build_lv,[{2,20}]}]','[]','[{2,11313292},{3,11313292}]',56400,'[{2,36020001,940}]'),(2,'伐木场',22,'[{build_lv,[{2,21}]}]','[]','[{2,13227604},{3,13227604}]',60000,'[{2,36020001,1000}]'),(2,'伐木场',23,'[{build_lv,[{2,22}]}]','[]','[{2,15345156},{3,15345156}]',63600,'[{2,36020001,1060}]'),(2,'伐木场',24,'[{build_lv,[{2,23}]}]','[]','[{2,17676167},{3,17676167}]',67200,'[{2,36020001,1120}]'),(2,'伐木场',25,'[{build_lv,[{2,24}]}]','[]','[{2,20230854},{3,20230854}]',70800,'[{2,36020001,1180}]'),(2,'伐木场',26,'[{build_lv,[{2,25}]}]','[]','[{2,23019438},{3,23019438}]',74400,'[{2,36020001,1240}]'),(2,'伐木场',27,'[{build_lv,[{2,26}]}]','[]','[{2,26052135},{3,26052135}]',78000,'[{2,36020001,1300}]'),(2,'伐木场',28,'[{build_lv,[{2,27}]}]','[]','[{2,29339167},{3,29339167}]',81600,'[{2,36020001,1360}]'),(2,'伐木场',29,'[{build_lv,[{2,28}]}]','[]','[{2,32890750},{3,32890750}]',85200,'[{2,36020001,1420}]'),(2,'伐木场',30,'[{build_lv,[{2,29}]}]','[]','[{2,36717104},{3,36717104}]',88800,'[{2,36020001,1480}]'),(2,'伐木场',31,'[{build_lv,[{2,30}]}]','[]','[{2,40828448},{3,40828448}]',92400,'[{2,36020001,1540}]'),(2,'伐木场',32,'[{build_lv,[{2,31}]}]','[]','[{2,45235000},{3,45235000}]',96000,'[{2,36020001,1600}]'),(2,'伐木场',33,'[{build_lv,[{2,32}]}]','[]','[{2,49946979},{3,49946979}]',99600,'[{2,36020001,1660}]'),(2,'伐木场',34,'[{build_lv,[{2,33}]}]','[]','[{2,54974604},{3,54974604}]',103200,'[{2,36020001,1720}]'),(2,'伐木场',35,'[{build_lv,[{2,34}]}]','[]','[{2,60328094},{3,60328094}]',106800,'[{2,36020001,1780}]'),(2,'伐木场',36,'[{build_lv,[{2,35}]}]','[]','[{2,66017667},{3,66017667}]',110400,'[{2,36020001,1840}]'),(2,'伐木场',37,'[{build_lv,[{2,36}]}]','[]','[{2,72053542},{3,72053542}]',114000,'[{2,36020001,1900}]'),(2,'伐木场',38,'[{build_lv,[{2,37}]}]','[]','[{2,78445938},{3,78445938}]',117600,'[{2,36020001,1960}]'),(2,'伐木场',39,'[{build_lv,[{2,38}]}]','[]','[{2,85205073},{3,85205073}]',121200,'[{2,36020001,2020}]'),(2,'伐木场',40,'[{build_lv,[{2,39}]}]','[]','[{2,93229063},{3,93229063}]',126000,'[{2,36020001,2100}]'),(2,'伐木场',41,'[{build_lv,[{2,40}]}]','[]','[{2,101731063},{3,101731063}]',130800,'[{2,36020001,2180}]'),(2,'伐木场',42,'[{build_lv,[{2,41}]}]','[]','[{2,110724698},{3,110724698}]',135600,'[{2,36020001,2260}]'),(2,'伐木场',43,'[{build_lv,[{2,42}]}]','[]','[{2,120223594},{3,120223594}]',140400,'[{2,36020001,2340}]'),(2,'伐木场',44,'[{build_lv,[{2,43}]}]','[]','[{2,130241375},{3,130241375}]',145200,'[{2,36020001,2420}]'),(2,'伐木场',45,'[{build_lv,[{2,44}]}]','[]','[{2,140791667},{3,140791667}]',150000,'[{2,36020001,2500}]'),(2,'伐木场',46,'[{build_lv,[{2,45}]}]','[]','[{2,151888094},{3,151888094}]',154800,'[{2,36020001,2580}]'),(2,'伐木场',47,'[{build_lv,[{2,46}]}]','[]','[{2,163544281},{3,163544281}]',159600,'[{2,36020001,2660}]'),(2,'伐木场',48,'[{build_lv,[{2,47}]}]','[]','[{2,175773854},{3,175773854}]',164400,'[{2,36020001,2740}]'),(2,'伐木场',49,'[{build_lv,[{2,48}]}]','[]','[{2,188590438},{3,188590438}]',169200,'[{2,36020001,2820}]'),(2,'伐木场',50,'[{build_lv,[{2,49}]}]','[]','[{2,202007656},{3,202007656}]',174000,'[{2,36020001,2900}]'),(2,'伐木场',51,'[{build_lv,[{2,50}]}]','[]','[{2,216039135},{3,216039135}]',178800,'[{2,36020001,2980}]'),(2,'伐木场',52,'[{build_lv,[{2,51}]}]','[]','[{2,230698500},{3,230698500}]',183600,'[{2,36020001,3060}]'),(2,'伐木场',53,'[{build_lv,[{2,52}]}]','[]','[{2,245999375},{3,245999375}]',188400,'[{2,36020001,3140}]'),(2,'伐木场',54,'[{build_lv,[{2,53}]}]','[]','[{2,261955385},{3,261955385}]',193200,'[{2,36020001,3220}]'),(2,'伐木场',55,'[{build_lv,[{2,54}]}]','[]','[{2,278580156},{3,278580156}]',198000,'[{2,36020001,3300}]'),(2,'伐木场',56,'[{build_lv,[{2,55}]}]','[]','[{2,295887313},{3,295887313}]',202800,'[{2,36020001,3380}]'),(2,'伐木场',57,'[{build_lv,[{2,56}]}]','[]','[{2,313890479},{3,313890479}]',207600,'[{2,36020001,3460}]'),(2,'伐木场',58,'[{build_lv,[{2,57}]}]','[]','[{2,332603281},{3,332603281}]',212400,'[{2,36020001,3540}]'),(2,'伐木场',59,'[{build_lv,[{2,58}]}]','[]','[{2,352039344},{3,352039344}]',217200,'[{2,36020001,3620}]'),(2,'伐木场',60,'[{build_lv,[{2,59}]}]','[]','[]',0,'[]'),(3,'铁矿场',1,'[]','[]','[{1,25},{3,25}]',13,'[{2,36020001,1}]'),(3,'铁矿场',2,'[{build_lv,[{3,1}]}]','[]','[{1,170},{3,170}]',60,'[{2,36020001,1}]'),(3,'铁矿场',3,'[{build_lv,[{3,2}]}]','[]','[{1,1515},{3,1515}]',320,'[{2,36020001,6}]'),(3,'铁矿场',4,'[{build_lv,[{3,3}]}]','[]','[{1,12110},{3,12110}]',1600,'[{2,36020001,27}]'),(3,'铁矿场',5,'[{build_lv,[{3,4}]}]','[]','[{1,45415},{3,45415}]',4000,'[{2,36020001,67}]'),(3,'铁矿场',6,'[{build_lv,[{3,5}]}]','[]','[{1,154417},{3,154417}]',9600,'[{2,36020001,160}]'),(3,'铁矿场',7,'[{build_lv,[{3,6}]}]','[]','[{1,313375},{3,313375}]',14400,'[{2,36020001,240}]'),(3,'铁矿场',8,'[{build_lv,[{3,7}]}]','[]','[{1,476875},{3,476875}]',16800,'[{2,36020001,280}]'),(3,'铁矿场',9,'[{build_lv,[{3,8}]}]','[]','[{1,690333},{3,690333}]',19200,'[{2,36020001,320}]'),(3,'铁矿场',10,'[{build_lv,[{3,9}]}]','[]','[{1,960563},{3,960563}]',21600,'[{2,36020001,360}]'),(3,'铁矿场',11,'[{build_lv,[{3,10}]}]','[]','[{1,1301572},{3,1301572}]',24133,'[{2,36020001,403}]'),(3,'铁矿场',12,'[{build_lv,[{3,11}]}]','[]','[{1,1724309},{3,1724309}]',26800,'[{2,36020001,447}]'),(3,'铁矿场',13,'[{build_lv,[{3,12}]}]','[]','[{1,2240568},{3,2240568}]',29600,'[{2,36020001,494}]'),(3,'铁矿场',14,'[{build_lv,[{3,13}]}]','[]','[{1,2862773},{3,2862773}]',32533,'[{2,36020001,543}]'),(3,'铁矿场',15,'[{build_lv,[{3,14}]}]','[]','[{1,3604207},{3,3604207}]',35600,'[{2,36020001,594}]'),(3,'铁矿场',16,'[{build_lv,[{3,15}]}]','[]','[{1,4478822},{3,4478822}]',38800,'[{2,36020001,647}]'),(3,'铁矿场',17,'[{build_lv,[{3,16}]}]','[]','[{1,5501486},{3,5501486}]',42133,'[{2,36020001,703}]'),(3,'铁矿场',18,'[{build_lv,[{3,17}]}]','[]','[{1,6687604},{3,6687604}]',45600,'[{2,36020001,760}]'),(3,'铁矿场',19,'[{build_lv,[{3,18}]}]','[]','[{1,8053510},{3,8053510}]',49200,'[{2,36020001,820}]'),(3,'铁矿场',20,'[{build_lv,[{3,19}]}]','[]','[{1,9592000},{3,9592000}]',52800,'[{2,36020001,880}]'),(3,'铁矿场',21,'[{build_lv,[{3,20}]}]','[]','[{1,11313292},{3,11313292}]',56400,'[{2,36020001,940}]'),(3,'铁矿场',22,'[{build_lv,[{3,21}]}]','[]','[{1,13227604},{3,13227604}]',60000,'[{2,36020001,1000}]'),(3,'铁矿场',23,'[{build_lv,[{3,22}]}]','[]','[{1,15345156},{3,15345156}]',63600,'[{2,36020001,1060}]'),(3,'铁矿场',24,'[{build_lv,[{3,23}]}]','[]','[{1,17676167},{3,17676167}]',67200,'[{2,36020001,1120}]'),(3,'铁矿场',25,'[{build_lv,[{3,24}]}]','[]','[{1,20230854},{3,20230854}]',70800,'[{2,36020001,1180}]'),(3,'铁矿场',26,'[{build_lv,[{3,25}]}]','[]','[{1,23019438},{3,23019438}]',74400,'[{2,36020001,1240}]'),(3,'铁矿场',27,'[{build_lv,[{3,26}]}]','[]','[{1,26052135},{3,26052135}]',78000,'[{2,36020001,1300}]'),(3,'铁矿场',28,'[{build_lv,[{3,27}]}]','[]','[{1,29339167},{3,29339167}]',81600,'[{2,36020001,1360}]'),(3,'铁矿场',29,'[{build_lv,[{3,28}]}]','[]','[{1,32890750},{3,32890750}]',85200,'[{2,36020001,1420}]'),(3,'铁矿场',30,'[{build_lv,[{3,29}]}]','[]','[{1,36717104},{3,36717104}]',88800,'[{2,36020001,1480}]'),(3,'铁矿场',31,'[{build_lv,[{3,30}]}]','[]','[{1,40828448},{3,40828448}]',92400,'[{2,36020001,1540}]'),(3,'铁矿场',32,'[{build_lv,[{3,31}]}]','[]','[{1,45235000},{3,45235000}]',96000,'[{2,36020001,1600}]'),(3,'铁矿场',33,'[{build_lv,[{3,32}]}]','[]','[{1,49946979},{3,49946979}]',99600,'[{2,36020001,1660}]'),(3,'铁矿场',34,'[{build_lv,[{3,33}]}]','[]','[{1,54974604},{3,54974604}]',103200,'[{2,36020001,1720}]'),(3,'铁矿场',35,'[{build_lv,[{3,34}]}]','[]','[{1,60328094},{3,60328094}]',106800,'[{2,36020001,1780}]'),(3,'铁矿场',36,'[{build_lv,[{3,35}]}]','[]','[{1,66017667},{3,66017667}]',110400,'[{2,36020001,1840}]'),(3,'铁矿场',37,'[{build_lv,[{3,36}]}]','[]','[{1,72053542},{3,72053542}]',114000,'[{2,36020001,1900}]'),(3,'铁矿场',38,'[{build_lv,[{3,37}]}]','[]','[{1,78445938},{3,78445938}]',117600,'[{2,36020001,1960}]'),(3,'铁矿场',39,'[{build_lv,[{3,38}]}]','[]','[{1,85205073},{3,85205073}]',121200,'[{2,36020001,2020}]'),(3,'铁矿场',40,'[{build_lv,[{3,39}]}]','[]','[{1,93229063},{3,93229063}]',126000,'[{2,36020001,2100}]'),(3,'铁矿场',41,'[{build_lv,[{3,40}]}]','[]','[{1,101731063},{3,101731063}]',130800,'[{2,36020001,2180}]'),(3,'铁矿场',42,'[{build_lv,[{3,41}]}]','[]','[{1,110724698},{3,110724698}]',135600,'[{2,36020001,2260}]'),(3,'铁矿场',43,'[{build_lv,[{3,42}]}]','[]','[{1,120223594},{3,120223594}]',140400,'[{2,36020001,2340}]'),(3,'铁矿场',44,'[{build_lv,[{3,43}]}]','[]','[{1,130241375},{3,130241375}]',145200,'[{2,36020001,2420}]'),(3,'铁矿场',45,'[{build_lv,[{3,44}]}]','[]','[{1,140791667},{3,140791667}]',150000,'[{2,36020001,2500}]'),(3,'铁矿场',46,'[{build_lv,[{3,45}]}]','[]','[{1,151888094},{3,151888094}]',154800,'[{2,36020001,2580}]'),(3,'铁矿场',47,'[{build_lv,[{3,46}]}]','[]','[{1,163544281},{3,163544281}]',159600,'[{2,36020001,2660}]'),(3,'铁矿场',48,'[{build_lv,[{3,47}]}]','[]','[{1,175773854},{3,175773854}]',164400,'[{2,36020001,2740}]'),(3,'铁矿场',49,'[{build_lv,[{3,48}]}]','[]','[{1,188590438},{3,188590438}]',169200,'[{2,36020001,2820}]'),(3,'铁矿场',50,'[{build_lv,[{3,49}]}]','[]','[{1,202007656},{3,202007656}]',174000,'[{2,36020001,2900}]'),(3,'铁矿场',51,'[{build_lv,[{3,50}]}]','[]','[{1,216039135},{3,216039135}]',178800,'[{2,36020001,2980}]'),(3,'铁矿场',52,'[{build_lv,[{3,51}]}]','[]','[{1,230698500},{3,230698500}]',183600,'[{2,36020001,3060}]'),(3,'铁矿场',53,'[{build_lv,[{3,52}]}]','[]','[{1,245999375},{3,245999375}]',188400,'[{2,36020001,3140}]'),(3,'铁矿场',54,'[{build_lv,[{3,53}]}]','[]','[{1,261955385},{3,261955385}]',193200,'[{2,36020001,3220}]'),(3,'铁矿场',55,'[{build_lv,[{3,54}]}]','[]','[{1,278580156},{3,278580156}]',198000,'[{2,36020001,3300}]'),(3,'铁矿场',56,'[{build_lv,[{3,55}]}]','[]','[{1,295887313},{3,295887313}]',202800,'[{2,36020001,3380}]'),(3,'铁矿场',57,'[{build_lv,[{3,56}]}]','[]','[{1,313890479},{3,313890479}]',207600,'[{2,36020001,3460}]'),(3,'铁矿场',58,'[{build_lv,[{3,57}]}]','[]','[{1,332603281},{3,332603281}]',212400,'[{2,36020001,3540}]'),(3,'铁矿场',59,'[{build_lv,[{3,58}]}]','[]','[{1,352039344},{3,352039344}]',217200,'[{2,36020001,3620}]'),(3,'铁矿场',60,'[{build_lv,[{3,59}]}]','[]','[]',0,'[]'),(4,'石料场',1,'[]','[]','[{1,25},{2,25}]',13,'[{2,36020001,1}]'),(4,'石料场',2,'[{build_lv,[{4,1}]}]','[]','[{1,170},{2,170}]',60,'[{2,36020001,1}]'),(4,'石料场',3,'[{build_lv,[{4,2}]}]','[]','[{1,1515},{2,1515}]',320,'[{2,36020001,6}]'),(4,'石料场',4,'[{build_lv,[{4,3}]}]','[]','[{1,12110},{2,12110}]',1600,'[{2,36020001,27}]'),(4,'石料场',5,'[{build_lv,[{4,4}]}]','[]','[{1,45415},{2,45415}]',4000,'[{2,36020001,67}]'),(4,'石料场',6,'[{build_lv,[{4,5}]}]','[]','[{1,154417},{2,154417}]',9600,'[{2,36020001,160}]'),(4,'石料场',7,'[{build_lv,[{4,6}]}]','[]','[{1,313375},{2,313375}]',14400,'[{2,36020001,240}]'),(4,'石料场',8,'[{build_lv,[{4,7}]}]','[]','[{1,476875},{2,476875}]',16800,'[{2,36020001,280}]'),(4,'石料场',9,'[{build_lv,[{4,8}]}]','[]','[{1,690333},{2,690333}]',19200,'[{2,36020001,320}]'),(4,'石料场',10,'[{build_lv,[{4,9}]}]','[]','[{1,960563},{2,960563}]',21600,'[{2,36020001,360}]'),(4,'石料场',11,'[{build_lv,[{4,10}]}]','[]','[{1,1301572},{2,1301572}]',24133,'[{2,36020001,403}]'),(4,'石料场',12,'[{build_lv,[{4,11}]}]','[]','[{1,1724309},{2,1724309}]',26800,'[{2,36020001,447}]'),(4,'石料场',13,'[{build_lv,[{4,12}]}]','[]','[{1,2240568},{2,2240568}]',29600,'[{2,36020001,494}]'),(4,'石料场',14,'[{build_lv,[{4,13}]}]','[]','[{1,2862773},{2,2862773}]',32533,'[{2,36020001,543}]'),(4,'石料场',15,'[{build_lv,[{4,14}]}]','[]','[{1,3604207},{2,3604207}]',35600,'[{2,36020001,594}]'),(4,'石料场',16,'[{build_lv,[{4,15}]}]','[]','[{1,4478822},{2,4478822}]',38800,'[{2,36020001,647}]'),(4,'石料场',17,'[{build_lv,[{4,16}]}]','[]','[{1,5501486},{2,5501486}]',42133,'[{2,36020001,703}]'),(4,'石料场',18,'[{build_lv,[{4,17}]}]','[]','[{1,6687604},{2,6687604}]',45600,'[{2,36020001,760}]'),(4,'石料场',19,'[{build_lv,[{4,18}]}]','[]','[{1,8053510},{2,8053510}]',49200,'[{2,36020001,820}]'),(4,'石料场',20,'[{build_lv,[{4,19}]}]','[]','[{1,9592000},{2,9592000}]',52800,'[{2,36020001,880}]'),(4,'石料场',21,'[{build_lv,[{4,20}]}]','[]','[{1,11313292},{2,11313292}]',56400,'[{2,36020001,940}]'),(4,'石料场',22,'[{build_lv,[{4,21}]}]','[]','[{1,13227604},{2,13227604}]',60000,'[{2,36020001,1000}]'),(4,'石料场',23,'[{build_lv,[{4,22}]}]','[]','[{1,15345156},{2,15345156}]',63600,'[{2,36020001,1060}]'),(4,'石料场',24,'[{build_lv,[{4,23}]}]','[]','[{1,17676167},{2,17676167}]',67200,'[{2,36020001,1120}]'),(4,'石料场',25,'[{build_lv,[{4,24}]}]','[]','[{1,20230854},{2,20230854}]',70800,'[{2,36020001,1180}]'),(4,'石料场',26,'[{build_lv,[{4,25}]}]','[]','[{1,23019438},{2,23019438}]',74400,'[{2,36020001,1240}]'),(4,'石料场',27,'[{build_lv,[{4,26}]}]','[]','[{1,26052135},{2,26052135}]',78000,'[{2,36020001,1300}]'),(4,'石料场',28,'[{build_lv,[{4,27}]}]','[]','[{1,29339167},{2,29339167}]',81600,'[{2,36020001,1360}]'),(4,'石料场',29,'[{build_lv,[{4,28}]}]','[]','[{1,32890750},{2,32890750}]',85200,'[{2,36020001,1420}]'),(4,'石料场',30,'[{build_lv,[{4,29}]}]','[]','[{1,36717104},{2,36717104}]',88800,'[{2,36020001,1480}]'),(4,'石料场',31,'[{build_lv,[{4,30}]}]','[]','[{1,40828448},{2,40828448}]',92400,'[{2,36020001,1540}]'),(4,'石料场',32,'[{build_lv,[{4,31}]}]','[]','[{1,45235000},{2,45235000}]',96000,'[{2,36020001,1600}]'),(4,'石料场',33,'[{build_lv,[{4,32}]}]','[]','[{1,49946979},{2,49946979}]',99600,'[{2,36020001,1660}]'),(4,'石料场',34,'[{build_lv,[{4,33}]}]','[]','[{1,54974604},{2,54974604}]',103200,'[{2,36020001,1720}]'),(4,'石料场',35,'[{build_lv,[{4,34}]}]','[]','[{1,60328094},{2,60328094}]',106800,'[{2,36020001,1780}]'),(4,'石料场',36,'[{build_lv,[{4,35}]}]','[]','[{1,66017667},{2,66017667}]',110400,'[{2,36020001,1840}]'),(4,'石料场',37,'[{build_lv,[{4,36}]}]','[]','[{1,72053542},{2,72053542}]',114000,'[{2,36020001,1900}]'),(4,'石料场',38,'[{build_lv,[{4,37}]}]','[]','[{1,78445938},{2,78445938}]',117600,'[{2,36020001,1960}]'),(4,'石料场',39,'[{build_lv,[{4,38}]}]','[]','[{1,85205073},{2,85205073}]',121200,'[{2,36020001,2020}]'),(4,'石料场',40,'[{build_lv,[{4,39}]}]','[]','[{1,93229063},{2,93229063}]',126000,'[{2,36020001,2100}]'),(4,'石料场',41,'[{build_lv,[{4,40}]}]','[]','[{1,101731063},{2,101731063}]',130800,'[{2,36020001,2180}]'),(4,'石料场',42,'[{build_lv,[{4,41}]}]','[]','[{1,110724698},{2,110724698}]',135600,'[{2,36020001,2260}]'),(4,'石料场',43,'[{build_lv,[{4,42}]}]','[]','[{1,120223594},{2,120223594}]',140400,'[{2,36020001,2340}]'),(4,'石料场',44,'[{build_lv,[{4,43}]}]','[]','[{1,130241375},{2,130241375}]',145200,'[{2,36020001,2420}]'),(4,'石料场',45,'[{build_lv,[{4,44}]}]','[]','[{1,140791667},{2,140791667}]',150000,'[{2,36020001,2500}]'),(4,'石料场',46,'[{build_lv,[{4,45}]}]','[]','[{1,151888094},{2,151888094}]',154800,'[{2,36020001,2580}]'),(4,'石料场',47,'[{build_lv,[{4,46}]}]','[]','[{1,163544281},{2,163544281}]',159600,'[{2,36020001,2660}]'),(4,'石料场',48,'[{build_lv,[{4,47}]}]','[]','[{1,175773854},{2,175773854}]',164400,'[{2,36020001,2740}]'),(4,'石料场',49,'[{build_lv,[{4,48}]}]','[]','[{1,188590438},{2,188590438}]',169200,'[{2,36020001,2820}]'),(4,'石料场',50,'[{build_lv,[{4,49}]}]','[]','[{1,202007656},{2,202007656}]',174000,'[{2,36020001,2900}]'),(4,'石料场',51,'[{build_lv,[{4,50}]}]','[]','[{1,216039135},{2,216039135}]',178800,'[{2,36020001,2980}]'),(4,'石料场',52,'[{build_lv,[{4,51}]}]','[]','[{1,230698500},{2,230698500}]',183600,'[{2,36020001,3060}]'),(4,'石料场',53,'[{build_lv,[{4,52}]}]','[]','[{1,245999375},{2,245999375}]',188400,'[{2,36020001,3140}]'),(4,'石料场',54,'[{build_lv,[{4,53}]}]','[]','[{1,261955385},{2,261955385}]',193200,'[{2,36020001,3220}]'),(4,'石料场',55,'[{build_lv,[{4,54}]}]','[]','[{1,278580156},{2,278580156}]',198000,'[{2,36020001,3300}]'),(4,'石料场',56,'[{build_lv,[{4,55}]}]','[]','[{1,295887313},{2,295887313}]',202800,'[{2,36020001,3380}]'),(4,'石料场',57,'[{build_lv,[{4,56}]}]','[]','[{1,313890479},{2,313890479}]',207600,'[{2,36020001,3460}]'),(4,'石料场',58,'[{build_lv,[{4,57}]}]','[]','[{1,332603281},{2,332603281}]',212400,'[{2,36020001,3540}]'),(4,'石料场',59,'[{build_lv,[{4,58}]}]','[]','[{1,352039344},{2,352039344}]',217200,'[{2,36020001,3620}]'),(4,'石料场',60,'[{build_lv,[{4,59}]}]','[]','[]',0,'[]'),(5,'鱼塘',1,'[]','[]','[{1,25},{2,25}]',13,'[{2,36020001,1}]'),(5,'鱼塘',2,'[{build_lv,[{5,1}]}]','[]','[{1,170},{2,170}]',60,'[{2,36020001,1}]'),(5,'鱼塘',3,'[{build_lv,[{5,2}]}]','[]','[{1,1515},{2,1515}]',320,'[{2,36020001,6}]'),(5,'鱼塘',4,'[{build_lv,[{5,3}]}]','[]','[{1,12110},{2,12110}]',1600,'[{2,36020001,27}]'),(5,'鱼塘',5,'[{build_lv,[{5,4}]}]','[]','[{1,45415},{2,45415}]',4000,'[{2,36020001,67}]'),(5,'鱼塘',6,'[{build_lv,[{5,5}]}]','[]','[{1,154417},{2,154417}]',9600,'[{2,36020001,160}]'),(5,'鱼塘',7,'[{build_lv,[{5,6}]}]','[]','[{1,313375},{2,313375}]',14400,'[{2,36020001,240}]'),(5,'鱼塘',8,'[{build_lv,[{5,7}]}]','[]','[{1,476875},{2,476875}]',16800,'[{2,36020001,280}]'),(5,'鱼塘',9,'[{build_lv,[{5,8}]}]','[]','[{1,690333},{2,690333}]',19200,'[{2,36020001,320}]'),(5,'鱼塘',10,'[{build_lv,[{5,9}]}]','[]','[{1,960563},{2,960563}]',21600,'[{2,36020001,360}]'),(5,'鱼塘',11,'[{build_lv,[{5,10}]}]','[]','[{1,1301572},{2,1301572}]',24133,'[{2,36020001,403}]'),(5,'鱼塘',12,'[{build_lv,[{5,11}]}]','[]','[{1,1724309},{2,1724309}]',26800,'[{2,36020001,447}]'),(5,'鱼塘',13,'[{build_lv,[{5,12}]}]','[]','[{1,2240568},{2,2240568}]',29600,'[{2,36020001,494}]'),(5,'鱼塘',14,'[{build_lv,[{5,13}]}]','[]','[{1,2862773},{2,2862773}]',32533,'[{2,36020001,543}]'),(5,'鱼塘',15,'[{build_lv,[{5,14}]}]','[]','[{1,3604207},{2,3604207}]',35600,'[{2,36020001,594}]'),(5,'鱼塘',16,'[{build_lv,[{5,15}]}]','[]','[{1,4478822},{2,4478822}]',38800,'[{2,36020001,647}]'),(5,'鱼塘',17,'[{build_lv,[{5,16}]}]','[]','[{1,5501486},{2,5501486}]',42133,'[{2,36020001,703}]'),(5,'鱼塘',18,'[{build_lv,[{5,17}]}]','[]','[{1,6687604},{2,6687604}]',45600,'[{2,36020001,760}]'),(5,'鱼塘',19,'[{build_lv,[{5,18}]}]','[]','[{1,8053510},{2,8053510}]',49200,'[{2,36020001,820}]'),(5,'鱼塘',20,'[{build_lv,[{5,19}]}]','[]','[{1,9592000},{2,9592000}]',52800,'[{2,36020001,880}]'),(5,'鱼塘',21,'[{build_lv,[{5,20}]}]','[]','[{1,11313292},{2,11313292}]',56400,'[{2,36020001,940}]'),(5,'鱼塘',22,'[{build_lv,[{5,21}]}]','[]','[{1,13227604},{2,13227604}]',60000,'[{2,36020001,1000}]'),(5,'鱼塘',23,'[{build_lv,[{5,22}]}]','[]','[{1,15345156},{2,15345156}]',63600,'[{2,36020001,1060}]'),(5,'鱼塘',24,'[{build_lv,[{5,23}]}]','[]','[{1,17676167},{2,17676167}]',67200,'[{2,36020001,1120}]'),(5,'鱼塘',25,'[{build_lv,[{5,24}]}]','[]','[{1,20230854},{2,20230854}]',70800,'[{2,36020001,1180}]'),(5,'鱼塘',26,'[{build_lv,[{5,25}]}]','[]','[{1,23019438},{2,23019438}]',74400,'[{2,36020001,1240}]'),(5,'鱼塘',27,'[{build_lv,[{5,26}]}]','[]','[{1,26052135},{2,26052135}]',78000,'[{2,36020001,1300}]'),(5,'鱼塘',28,'[{build_lv,[{5,27}]}]','[]','[{1,29339167},{2,29339167}]',81600,'[{2,36020001,1360}]'),(5,'鱼塘',29,'[{build_lv,[{5,28}]}]','[]','[{1,32890750},{2,32890750}]',85200,'[{2,36020001,1420}]'),(5,'鱼塘',30,'[{build_lv,[{5,29}]}]','[]','[{1,36717104},{2,36717104}]',88800,'[{2,36020001,1480}]'),(5,'鱼塘',31,'[{build_lv,[{5,30}]}]','[]','[{1,40828448},{2,40828448}]',92400,'[{2,36020001,1540}]'),(5,'鱼塘',32,'[{build_lv,[{5,31}]}]','[]','[{1,45235000},{2,45235000}]',96000,'[{2,36020001,1600}]'),(5,'鱼塘',33,'[{build_lv,[{5,32}]}]','[]','[{1,49946979},{2,49946979}]',99600,'[{2,36020001,1660}]'),(5,'鱼塘',34,'[{build_lv,[{5,33}]}]','[]','[{1,54974604},{2,54974604}]',103200,'[{2,36020001,1720}]'),(5,'鱼塘',35,'[{build_lv,[{5,34}]}]','[]','[{1,60328094},{2,60328094}]',106800,'[{2,36020001,1780}]'),(5,'鱼塘',36,'[{build_lv,[{5,35}]}]','[]','[{1,66017667},{2,66017667}]',110400,'[{2,36020001,1840}]'),(5,'鱼塘',37,'[{build_lv,[{5,36}]}]','[]','[{1,72053542},{2,72053542}]',114000,'[{2,36020001,1900}]'),(5,'鱼塘',38,'[{build_lv,[{5,37}]}]','[]','[{1,78445938},{2,78445938}]',117600,'[{2,36020001,1960}]'),(5,'鱼塘',39,'[{build_lv,[{5,38}]}]','[]','[{1,85205073},{2,85205073}]',121200,'[{2,36020001,2020}]'),(5,'鱼塘',40,'[{build_lv,[{5,39}]}]','[]','[{1,93229063},{2,93229063}]',126000,'[{2,36020001,2100}]'),(5,'鱼塘',41,'[{build_lv,[{5,40}]}]','[]','[{1,101731063},{2,101731063}]',130800,'[{2,36020001,2180}]'),(5,'鱼塘',42,'[{build_lv,[{5,41}]}]','[]','[{1,110724698},{2,110724698}]',135600,'[{2,36020001,2260}]'),(5,'鱼塘',43,'[{build_lv,[{5,42}]}]','[]','[{1,120223594},{2,120223594}]',140400,'[{2,36020001,2340}]'),(5,'鱼塘',44,'[{build_lv,[{5,43}]}]','[]','[{1,130241375},{2,130241375}]',145200,'[{2,36020001,2420}]'),(5,'鱼塘',45,'[{build_lv,[{5,44}]}]','[]','[{1,140791667},{2,140791667}]',150000,'[{2,36020001,2500}]'),(5,'鱼塘',46,'[{build_lv,[{5,45}]}]','[]','[{1,151888094},{2,151888094}]',154800,'[{2,36020001,2580}]'),(5,'鱼塘',47,'[{build_lv,[{5,46}]}]','[]','[{1,163544281},{2,163544281}]',159600,'[{2,36020001,2660}]'),(5,'鱼塘',48,'[{build_lv,[{5,47}]}]','[]','[{1,175773854},{2,175773854}]',164400,'[{2,36020001,2740}]'),(5,'鱼塘',49,'[{build_lv,[{5,48}]}]','[]','[{1,188590438},{2,188590438}]',169200,'[{2,36020001,2820}]'),(5,'鱼塘',50,'[{build_lv,[{5,49}]}]','[]','[{1,202007656},{2,202007656}]',174000,'[{2,36020001,2900}]'),(5,'鱼塘',51,'[{build_lv,[{5,50}]}]','[]','[{1,216039135},{2,216039135}]',178800,'[{2,36020001,2980}]'),(5,'鱼塘',52,'[{build_lv,[{5,51}]}]','[]','[{1,230698500},{2,230698500}]',183600,'[{2,36020001,3060}]'),(5,'鱼塘',53,'[{build_lv,[{5,52}]}]','[]','[{1,245999375},{2,245999375}]',188400,'[{2,36020001,3140}]'),(5,'鱼塘',54,'[{build_lv,[{5,53}]}]','[]','[{1,261955385},{2,261955385}]',193200,'[{2,36020001,3220}]'),(5,'鱼塘',55,'[{build_lv,[{5,54}]}]','[]','[{1,278580156},{2,278580156}]',198000,'[{2,36020001,3300}]'),(5,'鱼塘',56,'[{build_lv,[{5,55}]}]','[]','[{1,295887313},{2,295887313}]',202800,'[{2,36020001,3380}]'),(5,'鱼塘',57,'[{build_lv,[{5,56}]}]','[]','[{1,313890479},{2,313890479}]',207600,'[{2,36020001,3460}]'),(5,'鱼塘',58,'[{build_lv,[{5,57}]}]','[]','[{1,332603281},{2,332603281}]',212400,'[{2,36020001,3540}]'),(5,'鱼塘',59,'[{build_lv,[{5,58}]}]','[]','[{1,352039344},{2,352039344}]',217200,'[{2,36020001,3620}]'),(5,'鱼塘',60,'[{build_lv,[{5,59}]}]','[]','[]',0,'[]'),(6,'许愿池',1,'[]','[]','[{1,28},{2,28},{3,28}]',15,'[{2,36020001,1}]'),(6,'许愿池',2,'[{build_lv,[{6,1}]}]','[]','[{1,188},{2,188},{3,188}]',68,'[{2,36020001,2}]'),(6,'许愿池',3,'[{build_lv,[{6,2}]}]','[]','[{1,1668},{2,1668},{3,1668}]',360,'[{2,36020001,6}]'),(6,'许愿池',4,'[{build_lv,[{6,3}]}]','[]','[{1,13332},{2,13332},{3,13332}]',1800,'[{2,36020001,30}]'),(6,'许愿池',5,'[{build_lv,[{6,4}]}]','[]','[{1,49998},{2,49998},{3,49998}]',4500,'[{2,36020001,75}]'),(6,'许愿池',6,'[{build_lv,[{6,5}]}]','[]','[{1,170000},{2,170000},{3,170000}]',10800,'[{2,36020001,180}]'),(6,'许愿池',7,'[{build_lv,[{6,6}]}]','[]','[{1,345000},{2,345000},{3,345000}]',16200,'[{2,36020001,270}]'),(6,'许愿池',8,'[{build_lv,[{6,7}]}]','[]','[{1,525000},{2,525000},{3,525000}]',18900,'[{2,36020001,315}]'),(6,'许愿池',9,'[{build_lv,[{6,8}]}]','[]','[{1,760000},{2,760000},{3,760000}]',21600,'[{2,36020001,360}]'),(6,'许愿池',10,'[{build_lv,[{6,9}]}]','[]','[{1,1057500},{2,1057500},{3,1057500}]',24300,'[{2,36020001,405}]'),(6,'许愿池',11,'[{build_lv,[{6,10}]}]','[]','[{1,1432923},{2,1432923},{3,1432923}]',27150,'[{2,36020001,453}]'),(6,'许愿池',12,'[{build_lv,[{6,11}]}]','[]','[{1,1898322},{2,1898322},{3,1898322}]',30150,'[{2,36020001,503}]'),(6,'许愿池',13,'[{build_lv,[{6,12}]}]','[]','[{1,2466680},{2,2466680},{3,2466680}]',33300,'[{2,36020001,555}]'),(6,'许愿池',14,'[{build_lv,[{6,13}]}]','[]','[{1,3151677},{2,3151677},{3,3151677}]',36600,'[{2,36020001,610}]'),(6,'许愿池',15,'[{build_lv,[{6,14}]}]','[]','[{1,3967935},{2,3967935},{3,3967935}]',40050,'[{2,36020001,668}]'),(6,'许愿池',16,'[{build_lv,[{6,15}]}]','[]','[{1,4930813},{2,4930813},{3,4930813}]',43650,'[{2,36020001,728}]'),(6,'许愿池',17,'[{build_lv,[{6,16}]}]','[]','[{1,6056682},{2,6056682},{3,6056682}]',47400,'[{2,36020001,790}]'),(6,'许愿池',18,'[{build_lv,[{6,17}]}]','[]','[{1,7362500},{2,7362500},{3,7362500}]',51300,'[{2,36020001,855}]'),(6,'许愿池',19,'[{build_lv,[{6,18}]}]','[]','[{1,8866250},{2,8866250},{3,8866250}]',55350,'[{2,36020001,923}]'),(6,'许愿池',20,'[{build_lv,[{6,19}]}]','[]','[{1,10560000},{2,10560000},{3,10560000}]',59400,'[{2,36020001,990}]'),(6,'许愿池',21,'[{build_lv,[{6,20}]}]','[]','[{1,12455000},{2,12455000},{3,12455000}]',63450,'[{2,36020001,1058}]'),(6,'许愿池',22,'[{build_lv,[{6,21}]}]','[]','[{1,14562500},{2,14562500},{3,14562500}]',67500,'[{2,36020001,1125}]'),(6,'许愿池',23,'[{build_lv,[{6,22}]}]','[]','[{1,16893750},{2,16893750},{3,16893750}]',71550,'[{2,36020001,1193}]'),(6,'许愿池',24,'[{build_lv,[{6,23}]}]','[]','[{1,19460000},{2,19460000},{3,19460000}]',75600,'[{2,36020001,1260}]'),(6,'许愿池',25,'[{build_lv,[{6,24}]}]','[]','[{1,22272500},{2,22272500},{3,22272500}]',79650,'[{2,36020001,1328}]'),(6,'许愿池',26,'[{build_lv,[{6,25}]}]','[]','[{1,25342500},{2,25342500},{3,25342500}]',83700,'[{2,36020001,1395}]'),(6,'许愿池',27,'[{build_lv,[{6,26}]}]','[]','[{1,28681250},{2,28681250},{3,28681250}]',87750,'[{2,36020001,1463}]'),(6,'许愿池',28,'[{build_lv,[{6,27}]}]','[]','[{1,32300000},{2,32300000},{3,32300000}]',91800,'[{2,36020001,1530}]'),(6,'许愿池',29,'[{build_lv,[{6,28}]}]','[]','[{1,36210000},{2,36210000},{3,36210000}]',95850,'[{2,36020001,1598}]'),(6,'许愿池',30,'[{build_lv,[{6,29}]}]','[]','[{1,40422500},{2,40422500},{3,40422500}]',99900,'[{2,36020001,1665}]'),(6,'许愿池',31,'[{build_lv,[{6,30}]}]','[]','[{1,44948750},{2,44948750},{3,44948750}]',103950,'[{2,36020001,1733}]'),(6,'许愿池',32,'[{build_lv,[{6,31}]}]','[]','[{1,49800000},{2,49800000},{3,49800000}]',108000,'[{2,36020001,1800}]'),(6,'许愿池',33,'[{build_lv,[{6,32}]}]','[]','[{1,54987500},{2,54987500},{3,54987500}]',112050,'[{2,36020001,1868}]'),(6,'许愿池',34,'[{build_lv,[{6,33}]}]','[]','[{1,60522500},{2,60522500},{3,60522500}]',116100,'[{2,36020001,1935}]'),(6,'许愿池',35,'[{build_lv,[{6,34}]}]','[]','[{1,66416250},{2,66416250},{3,66416250}]',120150,'[{2,36020001,2003}]'),(6,'许愿池',36,'[{build_lv,[{6,35}]}]','[]','[{1,72680000},{2,72680000},{3,72680000}]',124200,'[{2,36020001,2070}]'),(6,'许愿池',37,'[{build_lv,[{6,36}]}]','[]','[{1,79325000},{2,79325000},{3,79325000}]',128250,'[{2,36020001,2138}]'),(6,'许愿池',38,'[{build_lv,[{6,37}]}]','[]','[{1,86362500},{2,86362500},{3,86362500}]',132300,'[{2,36020001,2205}]'),(6,'许愿池',39,'[{build_lv,[{6,38}]}]','[]','[{1,93803750},{2,93803750},{3,93803750}]',136350,'[{2,36020001,2273}]'),(6,'许愿池',40,'[{build_lv,[{6,39}]}]','[]','[{1,102637500},{2,102637500},{3,102637500}]',141750,'[{2,36020001,2363}]'),(6,'许愿池',41,'[{build_lv,[{6,40}]}]','[]','[{1,111997500},{2,111997500},{3,111997500}]',147150,'[{2,36020001,2453}]'),(6,'许愿池',42,'[{build_lv,[{6,41}]}]','[]','[{1,121898750},{2,121898750},{3,121898750}]',152550,'[{2,36020001,2543}]'),(6,'许愿池',43,'[{build_lv,[{6,42}]}]','[]','[{1,132356250},{2,132356250},{3,132356250}]',157950,'[{2,36020001,2633}]'),(6,'许愿池',44,'[{build_lv,[{6,43}]}]','[]','[{1,143385000},{2,143385000},{3,143385000}]',163350,'[{2,36020001,2723}]'),(6,'许愿池',45,'[{build_lv,[{6,44}]}]','[]','[{1,155000000},{2,155000000},{3,155000000}]',168750,'[{2,36020001,2813}]'),(6,'许愿池',46,'[{build_lv,[{6,45}]}]','[]','[{1,167216250},{2,167216250},{3,167216250}]',174150,'[{2,36020001,2903}]'),(6,'许愿池',47,'[{build_lv,[{6,46}]}]','[]','[{1,180048750},{2,180048750},{3,180048750}]',179550,'[{2,36020001,2993}]'),(6,'许愿池',48,'[{build_lv,[{6,47}]}]','[]','[{1,193512500},{2,193512500},{3,193512500}]',184950,'[{2,36020001,3083}]'),(6,'许愿池',49,'[{build_lv,[{6,48}]}]','[]','[{1,207622500},{2,207622500},{3,207622500}]',190350,'[{2,36020001,3173}]'),(6,'许愿池',50,'[{build_lv,[{6,49}]}]','[]','[{1,222393750},{2,222393750},{3,222393750}]',195750,'[{2,36020001,3263}]'),(6,'许愿池',51,'[{build_lv,[{6,50}]}]','[]','[{1,237841250},{2,237841250},{3,237841250}]',201150,'[{2,36020001,3353}]'),(6,'许愿池',52,'[{build_lv,[{6,51}]}]','[]','[{1,253980000},{2,253980000},{3,253980000}]',206550,'[{2,36020001,3443}]'),(6,'许愿池',53,'[{build_lv,[{6,52}]}]','[]','[{1,270825000},{2,270825000},{3,270825000}]',211950,'[{2,36020001,3533}]'),(6,'许愿池',54,'[{build_lv,[{6,53}]}]','[]','[{1,288391250},{2,288391250},{3,288391250}]',217350,'[{2,36020001,3623}]'),(6,'许愿池',55,'[{build_lv,[{6,54}]}]','[]','[{1,306693750},{2,306693750},{3,306693750}]',222750,'[{2,36020001,3713}]'),(6,'许愿池',56,'[{build_lv,[{6,55}]}]','[]','[{1,325747500},{2,325747500},{3,325747500}]',228150,'[{2,36020001,3803}]'),(6,'许愿池',57,'[{build_lv,[{6,56}]}]','[]','[{1,345567500},{2,345567500},{3,345567500}]',233550,'[{2,36020001,3893}]'),(6,'许愿池',58,'[{build_lv,[{6,57}]}]','[]','[{1,366168750},{2,366168750},{3,366168750}]',238950,'[{2,36020001,3983}]'),(6,'许愿池',59,'[{build_lv,[{6,58}]}]','[]','[{1,387566250},{2,387566250},{3,387566250}]',244350,'[{2,36020001,4073}]'),(6,'许愿池',60,'[{build_lv,[{6,59}]}]','[]','[]',0,'[]'),(7,'任务场',1,'[]','[]','[{1,28},{2,28},{3,28}]',15,'[{2,36020001,1}]'),(7,'任务场',2,'[{build_lv,[{7,1}]}]','[]','[{1,189},{2,189},{3,189}]',68,'[{2,36020001,2}]'),(7,'任务场',3,'[{build_lv,[{7,2}]}]','[]','[{1,1681},{2,1681},{3,1681}]',360,'[{2,36020001,6}]'),(7,'任务场',4,'[{build_lv,[{7,3}]}]','[]','[{1,13443},{2,13443},{3,13443}]',1800,'[{2,36020001,30}]'),(7,'任务场',5,'[{build_lv,[{7,4}]}]','[]','[{1,50415},{2,50415},{3,50415}]',4500,'[{2,36020001,75}]'),(7,'任务场',6,'[{build_lv,[{7,5}]}]','[]','[{1,171417},{2,171417},{3,171417}]',10800,'[{2,36020001,180}]'),(7,'任务场',7,'[{build_lv,[{7,6}]}]','[]','[{1,347875},{2,347875},{3,347875}]',16200,'[{2,36020001,270}]'),(7,'任务场',8,'[{build_lv,[{7,7}]}]','[]','[{1,529375},{2,529375},{3,529375}]',18900,'[{2,36020001,315}]'),(7,'任务场',9,'[{build_lv,[{7,8}]}]','[]','[{1,766333},{2,766333},{3,766333}]',21600,'[{2,36020001,360}]'),(7,'任务场',10,'[{build_lv,[{7,9}]}]','[]','[{1,1066313},{2,1066313},{3,1066313}]',24300,'[{2,36020001,405}]'),(7,'任务场',11,'[{build_lv,[{7,10}]}]','[]','[{1,1444864},{2,1444864},{3,1444864}]',27150,'[{2,36020001,453}]'),(7,'任务场',12,'[{build_lv,[{7,11}]}]','[]','[{1,1914141},{2,1914141},{3,1914141}]',30150,'[{2,36020001,503}]'),(7,'任务场',13,'[{build_lv,[{7,12}]}]','[]','[{1,2487236},{2,2487236},{3,2487236}]',33300,'[{2,36020001,555}]'),(7,'任务场',14,'[{build_lv,[{7,13}]}]','[]','[{1,3177941},{2,3177941},{3,3177941}]',36600,'[{2,36020001,610}]'),(7,'任务场',15,'[{build_lv,[{7,14}]}]','[]','[{1,4001001},{2,4001001},{3,4001001}]',40050,'[{2,36020001,668}]'),(7,'任务场',16,'[{build_lv,[{7,15}]}]','[]','[{1,4971903},{2,4971903},{3,4971903}]',43650,'[{2,36020001,728}]'),(7,'任务场',17,'[{build_lv,[{7,16}]}]','[]','[{1,6107154},{2,6107154},{3,6107154}]',47400,'[{2,36020001,790}]'),(7,'任务场',18,'[{build_lv,[{7,17}]}]','[]','[{1,7423854},{2,7423854},{3,7423854}]',51300,'[{2,36020001,855}]'),(7,'任务场',19,'[{build_lv,[{7,18}]}]','[]','[{1,8940135},{2,8940135},{3,8940135}]',55350,'[{2,36020001,923}]'),(7,'任务场',20,'[{build_lv,[{7,19}]}]','[]','[{1,10648000},{2,10648000},{3,10648000}]',59400,'[{2,36020001,990}]'),(7,'任务场',21,'[{build_lv,[{7,20}]}]','[]','[{1,12558792},{2,12558792},{3,12558792}]',63450,'[{2,36020001,1058}]'),(7,'任务场',22,'[{build_lv,[{7,21}]}]','[]','[{1,14683854},{2,14683854},{3,14683854}]',67500,'[{2,36020001,1125}]'),(7,'任务场',23,'[{build_lv,[{7,22}]}]','[]','[{1,17034531},{2,17034531},{3,17034531}]',71550,'[{2,36020001,1193}]'),(7,'任务场',24,'[{build_lv,[{7,23}]}]','[]','[{1,19622167},{2,19622167},{3,19622167}]',75600,'[{2,36020001,1260}]'),(7,'任务场',25,'[{build_lv,[{7,24}]}]','[]','[{1,22458104},{2,22458104},{3,22458104}]',79650,'[{2,36020001,1328}]'),(7,'任务场',26,'[{build_lv,[{7,25}]}]','[]','[{1,25553688},{2,25553688},{3,25553688}]',83700,'[{2,36020001,1395}]'),(7,'任务场',27,'[{build_lv,[{7,26}]}]','[]','[{1,28920260},{2,28920260},{3,28920260}]',87750,'[{2,36020001,1463}]'),(7,'任务场',28,'[{build_lv,[{7,27}]}]','[]','[{1,32569167},{2,32569167},{3,32569167}]',91800,'[{2,36020001,1530}]'),(7,'任务场',29,'[{build_lv,[{7,28}]}]','[]','[{1,36511750},{2,36511750},{3,36511750}]',95850,'[{2,36020001,1598}]'),(7,'任务场',30,'[{build_lv,[{7,29}]}]','[]','[{1,40759354},{2,40759354},{3,40759354}]',99900,'[{2,36020001,1665}]'),(7,'任务场',31,'[{build_lv,[{7,30}]}]','[]','[{1,45323323},{2,45323323},{3,45323323}]',103950,'[{2,36020001,1733}]'),(7,'任务场',32,'[{build_lv,[{7,31}]}]','[]','[{1,50215000},{2,50215000},{3,50215000}]',108000,'[{2,36020001,1800}]'),(7,'任务场',33,'[{build_lv,[{7,32}]}]','[]','[{1,55445729},{2,55445729},{3,55445729}]',112050,'[{2,36020001,1868}]'),(7,'任务场',34,'[{build_lv,[{7,33}]}]','[]','[{1,61026854},{2,61026854},{3,61026854}]',116100,'[{2,36020001,1935}]'),(7,'任务场',35,'[{build_lv,[{7,34}]}]','[]','[{1,66969719},{2,66969719},{3,66969719}]',120150,'[{2,36020001,2003}]'),(7,'任务场',36,'[{build_lv,[{7,35}]}]','[]','[{1,73285667},{2,73285667},{3,73285667}]',124200,'[{2,36020001,2070}]'),(7,'任务场',37,'[{build_lv,[{7,36}]}]','[]','[{1,79986042},{2,79986042},{3,79986042}]',128250,'[{2,36020001,2138}]'),(7,'任务场',38,'[{build_lv,[{7,37}]}]','[]','[{1,87082188},{2,87082188},{3,87082188}]',132300,'[{2,36020001,2205}]'),(7,'任务场',39,'[{build_lv,[{7,38}]}]','[]','[{1,94585448},{2,94585448},{3,94585448}]',136350,'[{2,36020001,2273}]'),(7,'任务场',40,'[{build_lv,[{7,39}]}]','[]','[{1,103492813},{2,103492813},{3,103492813}]',141750,'[{2,36020001,2363}]'),(7,'任务场',41,'[{build_lv,[{7,40}]}]','[]','[{1,112930813},{2,112930813},{3,112930813}]',147150,'[{2,36020001,2453}]'),(7,'任务场',42,'[{build_lv,[{7,41}]}]','[]','[{1,122914573},{2,122914573},{3,122914573}]',152550,'[{2,36020001,2543}]'),(7,'任务场',43,'[{build_lv,[{7,42}]}]','[]','[{1,133459219},{2,133459219},{3,133459219}]',157950,'[{2,36020001,2633}]'),(7,'任务场',44,'[{build_lv,[{7,43}]}]','[]','[{1,144579875},{2,144579875},{3,144579875}]',163350,'[{2,36020001,2723}]'),(7,'任务场',45,'[{build_lv,[{7,44}]}]','[]','[{1,156291667},{2,156291667},{3,156291667}]',168750,'[{2,36020001,2813}]'),(7,'任务场',46,'[{build_lv,[{7,45}]}]','[]','[{1,168609719},{2,168609719},{3,168609719}]',174150,'[{2,36020001,2903}]'),(7,'任务场',47,'[{build_lv,[{7,46}]}]','[]','[{1,181549156},{2,181549156},{3,181549156}]',179550,'[{2,36020001,2993}]'),(7,'任务场',48,'[{build_lv,[{7,47}]}]','[]','[{1,195125104},{2,195125104},{3,195125104}]',184950,'[{2,36020001,3083}]'),(7,'任务场',49,'[{build_lv,[{7,48}]}]','[]','[{1,209352688},{2,209352688},{3,209352688}]',190350,'[{2,36020001,3173}]'),(7,'任务场',50,'[{build_lv,[{7,49}]}]','[]','[{1,224247031},{2,224247031},{3,224247031}]',195750,'[{2,36020001,3263}]'),(7,'任务场',51,'[{build_lv,[{7,50}]}]','[]','[{1,239823260},{2,239823260},{3,239823260}]',201150,'[{2,36020001,3353}]'),(7,'任务场',52,'[{build_lv,[{7,51}]}]','[]','[{1,256096500},{2,256096500},{3,256096500}]',206550,'[{2,36020001,3443}]'),(7,'任务场',53,'[{build_lv,[{7,52}]}]','[]','[{1,273081875},{2,273081875},{3,273081875}]',211950,'[{2,36020001,3533}]'),(7,'任务场',54,'[{build_lv,[{7,53}]}]','[]','[{1,290794510},{2,290794510},{3,290794510}]',217350,'[{2,36020001,3623}]'),(7,'任务场',55,'[{build_lv,[{7,54}]}]','[]','[{1,309249531},{2,309249531},{3,309249531}]',222750,'[{2,36020001,3713}]'),(7,'任务场',56,'[{build_lv,[{7,55}]}]','[]','[{1,328462063},{2,328462063},{3,328462063}]',228150,'[{2,36020001,3803}]'),(7,'任务场',57,'[{build_lv,[{7,56}]}]','[]','[{1,348447229},{2,348447229},{3,348447229}]',233550,'[{2,36020001,3893}]'),(7,'任务场',58,'[{build_lv,[{7,57}]}]','[]','[{1,369220156},{2,369220156},{3,369220156}]',238950,'[{2,36020001,3983}]'),(7,'任务场',59,'[{build_lv,[{7,58}]}]','[]','[{1,390795969},{2,390795969},{3,390795969}]',244350,'[{2,36020001,4073}]'),(7,'任务场',60,'[{build_lv,[{7,59}]}]','[]','[]',0,'[]'),(8,'雕像',1,'[]','[]','[{1,28},{2,28},{3,28}]',15,'[{2,36020001,1}]'),(8,'雕像',2,'[{build_lv,[{8,1}]}]','[]','[{1,188},{2,188},{3,188}]',68,'[{2,36020001,2}]'),(8,'雕像',3,'[{build_lv,[{8,2}]}]','[]','[{1,1668},{2,1668},{3,1668}]',360,'[{2,36020001,6}]'),(8,'雕像',4,'[{build_lv,[{8,3}]}]','[]','[{1,13332},{2,13332},{3,13332}]',1800,'[{2,36020001,30}]'),(8,'雕像',5,'[{build_lv,[{8,4}]}]','[]','[{1,49998},{2,49998},{3,49998}]',4500,'[{2,36020001,75}]'),(8,'雕像',6,'[{build_lv,[{8,5}]}]','[]','[{1,170000},{2,170000},{3,170000}]',10800,'[{2,36020001,180}]'),(8,'雕像',7,'[{build_lv,[{8,6}]}]','[]','[{1,345000},{2,345000},{3,345000}]',16200,'[{2,36020001,270}]'),(8,'雕像',8,'[{build_lv,[{8,7}]}]','[]','[{1,525000},{2,525000},{3,525000}]',18900,'[{2,36020001,315}]'),(8,'雕像',9,'[{build_lv,[{8,8}]}]','[]','[{1,760000},{2,760000},{3,760000}]',21600,'[{2,36020001,360}]'),(8,'雕像',10,'[{build_lv,[{8,9}]}]','[]','[{1,1057500},{2,1057500},{3,1057500}]',24300,'[{2,36020001,405}]'),(8,'雕像',11,'[{build_lv,[{8,10}]}]','[]','[{1,1432923},{2,1432923},{3,1432923}]',27150,'[{2,36020001,453}]'),(8,'雕像',12,'[{build_lv,[{8,11}]}]','[]','[{1,1898322},{2,1898322},{3,1898322}]',30150,'[{2,36020001,503}]'),(8,'雕像',13,'[{build_lv,[{8,12}]}]','[]','[{1,2466680},{2,2466680},{3,2466680}]',33300,'[{2,36020001,555}]'),(8,'雕像',14,'[{build_lv,[{8,13}]}]','[]','[{1,3151677},{2,3151677},{3,3151677}]',36600,'[{2,36020001,610}]'),(8,'雕像',15,'[{build_lv,[{8,14}]}]','[]','[{1,3967935},{2,3967935},{3,3967935}]',40050,'[{2,36020001,668}]'),(8,'雕像',16,'[{build_lv,[{8,15}]}]','[]','[{1,4930813},{2,4930813},{3,4930813}]',43650,'[{2,36020001,728}]'),(8,'雕像',17,'[{build_lv,[{8,16}]}]','[]','[{1,6056682},{2,6056682},{3,6056682}]',47400,'[{2,36020001,790}]'),(8,'雕像',18,'[{build_lv,[{8,17}]}]','[]','[{1,7362500},{2,7362500},{3,7362500}]',51300,'[{2,36020001,855}]'),(8,'雕像',19,'[{build_lv,[{8,18}]}]','[]','[{1,8866250},{2,8866250},{3,8866250}]',55350,'[{2,36020001,923}]'),(8,'雕像',20,'[{build_lv,[{8,19}]}]','[]','[{1,10560000},{2,10560000},{3,10560000}]',59400,'[{2,36020001,990}]'),(8,'雕像',21,'[{build_lv,[{8,20}]}]','[]','[{1,12455000},{2,12455000},{3,12455000}]',63450,'[{2,36020001,1058}]'),(8,'雕像',22,'[{build_lv,[{8,21}]}]','[]','[{1,14562500},{2,14562500},{3,14562500}]',67500,'[{2,36020001,1125}]'),(8,'雕像',23,'[{build_lv,[{8,22}]}]','[]','[{1,16893750},{2,16893750},{3,16893750}]',71550,'[{2,36020001,1193}]'),(8,'雕像',24,'[{build_lv,[{8,23}]}]','[]','[{1,19460000},{2,19460000},{3,19460000}]',75600,'[{2,36020001,1260}]'),(8,'雕像',25,'[{build_lv,[{8,24}]}]','[]','[{1,22272500},{2,22272500},{3,22272500}]',79650,'[{2,36020001,1328}]'),(8,'雕像',26,'[{build_lv,[{8,25}]}]','[]','[{1,25342500},{2,25342500},{3,25342500}]',83700,'[{2,36020001,1395}]'),(8,'雕像',27,'[{build_lv,[{8,26}]}]','[]','[{1,28681250},{2,28681250},{3,28681250}]',87750,'[{2,36020001,1463}]'),(8,'雕像',28,'[{build_lv,[{8,27}]}]','[]','[{1,32300000},{2,32300000},{3,32300000}]',91800,'[{2,36020001,1530}]'),(8,'雕像',29,'[{build_lv,[{8,28}]}]','[]','[{1,36210000},{2,36210000},{3,36210000}]',95850,'[{2,36020001,1598}]'),(8,'雕像',30,'[{build_lv,[{8,29}]}]','[]','[{1,40422500},{2,40422500},{3,40422500}]',99900,'[{2,36020001,1665}]'),(8,'雕像',31,'[{build_lv,[{8,30}]}]','[]','[{1,44948750},{2,44948750},{3,44948750}]',103950,'[{2,36020001,1733}]'),(8,'雕像',32,'[{build_lv,[{8,31}]}]','[]','[{1,49800000},{2,49800000},{3,49800000}]',108000,'[{2,36020001,1800}]'),(8,'雕像',33,'[{build_lv,[{8,32}]}]','[]','[{1,54987500},{2,54987500},{3,54987500}]',112050,'[{2,36020001,1868}]'),(8,'雕像',34,'[{build_lv,[{8,33}]}]','[]','[{1,60522500},{2,60522500},{3,60522500}]',116100,'[{2,36020001,1935}]'),(8,'雕像',35,'[{build_lv,[{8,34}]}]','[]','[{1,66416250},{2,66416250},{3,66416250}]',120150,'[{2,36020001,2003}]'),(8,'雕像',36,'[{build_lv,[{8,35}]}]','[]','[{1,72680000},{2,72680000},{3,72680000}]',124200,'[{2,36020001,2070}]'),(8,'雕像',37,'[{build_lv,[{8,36}]}]','[]','[{1,79325000},{2,79325000},{3,79325000}]',128250,'[{2,36020001,2138}]'),(8,'雕像',38,'[{build_lv,[{8,37}]}]','[]','[{1,86362500},{2,86362500},{3,86362500}]',132300,'[{2,36020001,2205}]'),(8,'雕像',39,'[{build_lv,[{8,38}]}]','[]','[{1,93803750},{2,93803750},{3,93803750}]',136350,'[{2,36020001,2273}]'),(8,'雕像',40,'[{build_lv,[{8,39}]}]','[]','[{1,102637500},{2,102637500},{3,102637500}]',141750,'[{2,36020001,2363}]'),(8,'雕像',41,'[{build_lv,[{8,40}]}]','[]','[{1,111997500},{2,111997500},{3,111997500}]',147150,'[{2,36020001,2453}]'),(8,'雕像',42,'[{build_lv,[{8,41}]}]','[]','[{1,121898750},{2,121898750},{3,121898750}]',152550,'[{2,36020001,2543}]'),(8,'雕像',43,'[{build_lv,[{8,42}]}]','[]','[{1,132356250},{2,132356250},{3,132356250}]',157950,'[{2,36020001,2633}]'),(8,'雕像',44,'[{build_lv,[{8,43}]}]','[]','[{1,143385000},{2,143385000},{3,143385000}]',163350,'[{2,36020001,2723}]'),(8,'雕像',45,'[{build_lv,[{8,44}]}]','[]','[{1,155000000},{2,155000000},{3,155000000}]',168750,'[{2,36020001,2813}]'),(8,'雕像',46,'[{build_lv,[{8,45}]}]','[]','[{1,167216250},{2,167216250},{3,167216250}]',174150,'[{2,36020001,2903}]'),(8,'雕像',47,'[{build_lv,[{8,46}]}]','[]','[{1,180048750},{2,180048750},{3,180048750}]',179550,'[{2,36020001,2993}]'),(8,'雕像',48,'[{build_lv,[{8,47}]}]','[]','[{1,193512500},{2,193512500},{3,193512500}]',184950,'[{2,36020001,3083}]'),(8,'雕像',49,'[{build_lv,[{8,48}]}]','[]','[{1,207622500},{2,207622500},{3,207622500}]',190350,'[{2,36020001,3173}]'),(8,'雕像',50,'[{build_lv,[{8,49}]}]','[]','[{1,222393750},{2,222393750},{3,222393750}]',195750,'[{2,36020001,3263}]'),(8,'雕像',51,'[{build_lv,[{8,50}]}]','[]','[{1,237841250},{2,237841250},{3,237841250}]',201150,'[{2,36020001,3353}]'),(8,'雕像',52,'[{build_lv,[{8,51}]}]','[]','[{1,253980000},{2,253980000},{3,253980000}]',206550,'[{2,36020001,3443}]'),(8,'雕像',53,'[{build_lv,[{8,52}]}]','[]','[{1,270825000},{2,270825000},{3,270825000}]',211950,'[{2,36020001,3533}]'),(8,'雕像',54,'[{build_lv,[{8,53}]}]','[]','[{1,288391250},{2,288391250},{3,288391250}]',217350,'[{2,36020001,3623}]'),(8,'雕像',55,'[{build_lv,[{8,54}]}]','[]','[{1,306693750},{2,306693750},{3,306693750}]',222750,'[{2,36020001,3713}]'),(8,'雕像',56,'[{build_lv,[{8,55}]}]','[]','[{1,325747500},{2,325747500},{3,325747500}]',228150,'[{2,36020001,3803}]'),(8,'雕像',57,'[{build_lv,[{8,56}]}]','[]','[{1,345567500},{2,345567500},{3,345567500}]',233550,'[{2,36020001,3893}]'),(8,'雕像',58,'[{build_lv,[{8,57}]}]','[]','[{1,366168750},{2,366168750},{3,366168750}]',238950,'[{2,36020001,3983}]'),(8,'雕像',59,'[{build_lv,[{8,58}]}]','[]','[{1,387566250},{2,387566250},{3,387566250}]',244350,'[{2,36020001,4073}]'),(8,'雕像',60,'[{build_lv,[{8,59}]}]','[]','[]',0,'[]'),(9,'餐厅',1,'[]','[]','[{1,32},{2,32},{3,32}]',17,'[{2,36020001,1}]'),(9,'餐厅',2,'[{build_lv,[{9,1}]}]','[]','[{1,213},{2,213},{3,213}]',75,'[{2,36020001,2}]'),(9,'餐厅',3,'[{build_lv,[{9,2}]}]','[]','[{1,1890},{2,1890},{3,1890}]',400,'[{2,36020001,7}]'),(9,'餐厅',4,'[{build_lv,[{9,3}]}]','[]','[{1,15110},{2,15110},{3,15110}]',2000,'[{2,36020001,34}]'),(9,'餐厅',5,'[{build_lv,[{9,4}]}]','[]','[{1,56664},{2,56664},{3,56664}]',5000,'[{2,36020001,84}]'),(9,'餐厅',6,'[{build_lv,[{9,5}]}]','[]','[{1,192667},{2,192667},{3,192667}]',12000,'[{2,36020001,200}]'),(9,'餐厅',7,'[{build_lv,[{9,6}]}]','[]','[{1,391000},{2,391000},{3,391000}]',18000,'[{2,36020001,300}]'),(9,'餐厅',8,'[{build_lv,[{9,7}]}]','[]','[{1,595000},{2,595000},{3,595000}]',21000,'[{2,36020001,350}]'),(9,'餐厅',9,'[{build_lv,[{9,8}]}]','[]','[{1,861333},{2,861333},{3,861333}]',24000,'[{2,36020001,400}]'),(9,'餐厅',10,'[{build_lv,[{9,9}]}]','[]','[{1,1198500},{2,1198500},{3,1198500}]',27000,'[{2,36020001,450}]'),(9,'餐厅',11,'[{build_lv,[{9,10}]}]','[]','[{1,1623979},{2,1623979},{3,1623979}]',30167,'[{2,36020001,503}]'),(9,'餐厅',12,'[{build_lv,[{9,11}]}]','[]','[{1,2151432},{2,2151432},{3,2151432}]',33500,'[{2,36020001,559}]'),(9,'餐厅',13,'[{build_lv,[{9,12}]}]','[]','[{1,2795571},{2,2795571},{3,2795571}]',37000,'[{2,36020001,617}]'),(9,'餐厅',14,'[{build_lv,[{9,13}]}]','[]','[{1,3571901},{2,3571901},{3,3571901}]',40667,'[{2,36020001,678}]'),(9,'餐厅',15,'[{build_lv,[{9,14}]}]','[]','[{1,4496992},{2,4496992},{3,4496992}]',44500,'[{2,36020001,742}]'),(9,'餐厅',16,'[{build_lv,[{9,15}]}]','[]','[{1,5588255},{2,5588255},{3,5588255}]',48500,'[{2,36020001,809}]'),(9,'餐厅',17,'[{build_lv,[{9,16}]}]','[]','[{1,6864240},{2,6864240},{3,6864240}]',52667,'[{2,36020001,878}]'),(9,'餐厅',18,'[{build_lv,[{9,17}]}]','[]','[{1,8344167},{2,8344167},{3,8344167}]',57000,'[{2,36020001,950}]'),(9,'餐厅',19,'[{build_lv,[{9,18}]}]','[]','[{1,10048417},{2,10048417},{3,10048417}]',61500,'[{2,36020001,1025}]'),(9,'餐厅',20,'[{build_lv,[{9,19}]}]','[]','[{1,11968000},{2,11968000},{3,11968000}]',66000,'[{2,36020001,1100}]'),(9,'餐厅',21,'[{build_lv,[{9,20}]}]','[]','[{1,14115667},{2,14115667},{3,14115667}]',70500,'[{2,36020001,1175}]'),(9,'餐厅',22,'[{build_lv,[{9,21}]}]','[]','[{1,16504167},{2,16504167},{3,16504167}]',75000,'[{2,36020001,1250}]'),(9,'餐厅',23,'[{build_lv,[{9,22}]}]','[]','[{1,19146250},{2,19146250},{3,19146250}]',79500,'[{2,36020001,1325}]'),(9,'餐厅',24,'[{build_lv,[{9,23}]}]','[]','[{1,22054667},{2,22054667},{3,22054667}]',84000,'[{2,36020001,1400}]'),(9,'餐厅',25,'[{build_lv,[{9,24}]}]','[]','[{1,25242167},{2,25242167},{3,25242167}]',88500,'[{2,36020001,1475}]'),(9,'餐厅',26,'[{build_lv,[{9,25}]}]','[]','[{1,28721500},{2,28721500},{3,28721500}]',93000,'[{2,36020001,1550}]'),(9,'餐厅',27,'[{build_lv,[{9,26}]}]','[]','[{1,32505417},{2,32505417},{3,32505417}]',97500,'[{2,36020001,1625}]'),(9,'餐厅',28,'[{build_lv,[{9,27}]}]','[]','[{1,36606667},{2,36606667},{3,36606667}]',102000,'[{2,36020001,1700}]'),(9,'餐厅',29,'[{build_lv,[{9,28}]}]','[]','[{1,41038000},{2,41038000},{3,41038000}]',106500,'[{2,36020001,1775}]'),(9,'餐厅',30,'[{build_lv,[{9,29}]}]','[]','[{1,45812167},{2,45812167},{3,45812167}]',111000,'[{2,36020001,1850}]'),(9,'餐厅',31,'[{build_lv,[{9,30}]}]','[]','[{1,50941917},{2,50941917},{3,50941917}]',115500,'[{2,36020001,1925}]'),(9,'餐厅',32,'[{build_lv,[{9,31}]}]','[]','[{1,56440000},{2,56440000},{3,56440000}]',120000,'[{2,36020001,2000}]'),(9,'餐厅',33,'[{build_lv,[{9,32}]}]','[]','[{1,62319167},{2,62319167},{3,62319167}]',124500,'[{2,36020001,2075}]'),(9,'餐厅',34,'[{build_lv,[{9,33}]}]','[]','[{1,68592167},{2,68592167},{3,68592167}]',129000,'[{2,36020001,2150}]'),(9,'餐厅',35,'[{build_lv,[{9,34}]}]','[]','[{1,75271750},{2,75271750},{3,75271750}]',133500,'[{2,36020001,2225}]'),(9,'餐厅',36,'[{build_lv,[{9,35}]}]','[]','[{1,82370667},{2,82370667},{3,82370667}]',138000,'[{2,36020001,2300}]'),(9,'餐厅',37,'[{build_lv,[{9,36}]}]','[]','[{1,89901667},{2,89901667},{3,89901667}]',142500,'[{2,36020001,2375}]'),(9,'餐厅',38,'[{build_lv,[{9,37}]}]','[]','[{1,97877500},{2,97877500},{3,97877500}]',147000,'[{2,36020001,2450}]'),(9,'餐厅',39,'[{build_lv,[{9,38}]}]','[]','[{1,106310917},{2,106310917},{3,106310917}]',151500,'[{2,36020001,2525}]'),(9,'餐厅',40,'[{build_lv,[{9,39}]}]','[]','[{1,116322500},{2,116322500},{3,116322500}]',157500,'[{2,36020001,2625}]'),(9,'餐厅',41,'[{build_lv,[{9,40}]}]','[]','[{1,126930500},{2,126930500},{3,126930500}]',163500,'[{2,36020001,2725}]'),(9,'餐厅',42,'[{build_lv,[{9,41}]}]','[]','[{1,138151917},{2,138151917},{3,138151917}]',169500,'[{2,36020001,2825}]'),(9,'餐厅',43,'[{build_lv,[{9,42}]}]','[]','[{1,150003750},{2,150003750},{3,150003750}]',175500,'[{2,36020001,2925}]'),(9,'餐厅',44,'[{build_lv,[{9,43}]}]','[]','[{1,162503000},{2,162503000},{3,162503000}]',181500,'[{2,36020001,3025}]'),(9,'餐厅',45,'[{build_lv,[{9,44}]}]','[]','[{1,175666667},{2,175666667},{3,175666667}]',187500,'[{2,36020001,3125}]'),(9,'餐厅',46,'[{build_lv,[{9,45}]}]','[]','[{1,189511750},{2,189511750},{3,189511750}]',193500,'[{2,36020001,3225}]'),(9,'餐厅',47,'[{build_lv,[{9,46}]}]','[]','[{1,204055250},{2,204055250},{3,204055250}]',199500,'[{2,36020001,3325}]'),(9,'餐厅',48,'[{build_lv,[{9,47}]}]','[]','[{1,219314167},{2,219314167},{3,219314167}]',205500,'[{2,36020001,3425}]'),(9,'餐厅',49,'[{build_lv,[{9,48}]}]','[]','[{1,235305500},{2,235305500},{3,235305500}]',211500,'[{2,36020001,3525}]'),(9,'餐厅',50,'[{build_lv,[{9,49}]}]','[]','[{1,252046250},{2,252046250},{3,252046250}]',217500,'[{2,36020001,3625}]'),(9,'餐厅',51,'[{build_lv,[{9,50}]}]','[]','[{1,269553417},{2,269553417},{3,269553417}]',223500,'[{2,36020001,3725}]'),(9,'餐厅',52,'[{build_lv,[{9,51}]}]','[]','[{1,287844000},{2,287844000},{3,287844000}]',229500,'[{2,36020001,3825}]'),(9,'餐厅',53,'[{build_lv,[{9,52}]}]','[]','[{1,306935000},{2,306935000},{3,306935000}]',235500,'[{2,36020001,3925}]'),(9,'餐厅',54,'[{build_lv,[{9,53}]}]','[]','[{1,326843417},{2,326843417},{3,326843417}]',241500,'[{2,36020001,4025}]'),(9,'餐厅',55,'[{build_lv,[{9,54}]}]','[]','[{1,347586250},{2,347586250},{3,347586250}]',247500,'[{2,36020001,4125}]'),(9,'餐厅',56,'[{build_lv,[{9,55}]}]','[]','[{1,369180500},{2,369180500},{3,369180500}]',253500,'[{2,36020001,4225}]'),(9,'餐厅',57,'[{build_lv,[{9,56}]}]','[]','[{1,391643167},{2,391643167},{3,391643167}]',259500,'[{2,36020001,4325}]'),(9,'餐厅',58,'[{build_lv,[{9,57}]}]','[]','[{1,414991250},{2,414991250},{3,414991250}]',265500,'[{2,36020001,4425}]'),(9,'餐厅',59,'[{build_lv,[{9,58}]}]','[]','[{1,439241750},{2,439241750},{3,439241750}]',271500,'[{2,36020001,4525}]'),(9,'餐厅',60,'[{build_lv,[{9,59}]}]','[]','[]',0,'[]'),(10,'打造坊',1,'[]','[]','[{1,32},{2,32},{3,32}]',17,'[{2,36020001,1}]'),(10,'打造坊',2,'[{build_lv,[{10,1}]}]','[]','[{1,213},{2,213},{3,213}]',75,'[{2,36020001,2}]'),(10,'打造坊',3,'[{build_lv,[{10,2}]}]','[]','[{1,1890},{2,1890},{3,1890}]',400,'[{2,36020001,7}]'),(10,'打造坊',4,'[{build_lv,[{10,3}]}]','[]','[{1,15110},{2,15110},{3,15110}]',2000,'[{2,36020001,34}]'),(10,'打造坊',5,'[{build_lv,[{10,4}]}]','[]','[{1,56664},{2,56664},{3,56664}]',5000,'[{2,36020001,84}]'),(10,'打造坊',6,'[{build_lv,[{10,5}]}]','[]','[{1,192667},{2,192667},{3,192667}]',12000,'[{2,36020001,200}]'),(10,'打造坊',7,'[{build_lv,[{10,6}]}]','[]','[{1,391000},{2,391000},{3,391000}]',18000,'[{2,36020001,300}]'),(10,'打造坊',8,'[{build_lv,[{10,7}]}]','[]','[{1,595000},{2,595000},{3,595000}]',21000,'[{2,36020001,350}]'),(10,'打造坊',9,'[{build_lv,[{10,8}]}]','[]','[{1,861333},{2,861333},{3,861333}]',24000,'[{2,36020001,400}]'),(10,'打造坊',10,'[{build_lv,[{10,9}]}]','[]','[{1,1198500},{2,1198500},{3,1198500}]',27000,'[{2,36020001,450}]'),(10,'打造坊',11,'[{build_lv,[{10,10}]}]','[]','[{1,1623979},{2,1623979},{3,1623979}]',30167,'[{2,36020001,503}]'),(10,'打造坊',12,'[{build_lv,[{10,11}]}]','[]','[{1,2151432},{2,2151432},{3,2151432}]',33500,'[{2,36020001,559}]'),(10,'打造坊',13,'[{build_lv,[{10,12}]}]','[]','[{1,2795571},{2,2795571},{3,2795571}]',37000,'[{2,36020001,617}]'),(10,'打造坊',14,'[{build_lv,[{10,13}]}]','[]','[{1,3571901},{2,3571901},{3,3571901}]',40667,'[{2,36020001,678}]'),(10,'打造坊',15,'[{build_lv,[{10,14}]}]','[]','[{1,4496992},{2,4496992},{3,4496992}]',44500,'[{2,36020001,742}]'),(10,'打造坊',16,'[{build_lv,[{10,15}]}]','[]','[{1,5588255},{2,5588255},{3,5588255}]',48500,'[{2,36020001,809}]'),(10,'打造坊',17,'[{build_lv,[{10,16}]}]','[]','[{1,6864240},{2,6864240},{3,6864240}]',52667,'[{2,36020001,878}]'),(10,'打造坊',18,'[{build_lv,[{10,17}]}]','[]','[{1,8344167},{2,8344167},{3,8344167}]',57000,'[{2,36020001,950}]'),(10,'打造坊',19,'[{build_lv,[{10,18}]}]','[]','[{1,10048417},{2,10048417},{3,10048417}]',61500,'[{2,36020001,1025}]'),(10,'打造坊',20,'[{build_lv,[{10,19}]}]','[]','[{1,11968000},{2,11968000},{3,11968000}]',66000,'[{2,36020001,1100}]'),(10,'打造坊',21,'[{build_lv,[{10,20}]}]','[]','[{1,14115667},{2,14115667},{3,14115667}]',70500,'[{2,36020001,1175}]'),(10,'打造坊',22,'[{build_lv,[{10,21}]}]','[]','[{1,16504167},{2,16504167},{3,16504167}]',75000,'[{2,36020001,1250}]'),(10,'打造坊',23,'[{build_lv,[{10,22}]}]','[]','[{1,19146250},{2,19146250},{3,19146250}]',79500,'[{2,36020001,1325}]'),(10,'打造坊',24,'[{build_lv,[{10,23}]}]','[]','[{1,22054667},{2,22054667},{3,22054667}]',84000,'[{2,36020001,1400}]'),(10,'打造坊',25,'[{build_lv,[{10,24}]}]','[]','[{1,25242167},{2,25242167},{3,25242167}]',88500,'[{2,36020001,1475}]'),(10,'打造坊',26,'[{build_lv,[{10,25}]}]','[]','[{1,28721500},{2,28721500},{3,28721500}]',93000,'[{2,36020001,1550}]'),(10,'打造坊',27,'[{build_lv,[{10,26}]}]','[]','[{1,32505417},{2,32505417},{3,32505417}]',97500,'[{2,36020001,1625}]'),(10,'打造坊',28,'[{build_lv,[{10,27}]}]','[]','[{1,36606667},{2,36606667},{3,36606667}]',102000,'[{2,36020001,1700}]'),(10,'打造坊',29,'[{build_lv,[{10,28}]}]','[]','[{1,41038000},{2,41038000},{3,41038000}]',106500,'[{2,36020001,1775}]'),(10,'打造坊',30,'[{build_lv,[{10,29}]}]','[]','[{1,45812167},{2,45812167},{3,45812167}]',111000,'[{2,36020001,1850}]'),(10,'打造坊',31,'[{build_lv,[{10,30}]}]','[]','[{1,50941917},{2,50941917},{3,50941917}]',115500,'[{2,36020001,1925}]'),(10,'打造坊',32,'[{build_lv,[{10,31}]}]','[]','[{1,56440000},{2,56440000},{3,56440000}]',120000,'[{2,36020001,2000}]'),(10,'打造坊',33,'[{build_lv,[{10,32}]}]','[]','[{1,62319167},{2,62319167},{3,62319167}]',124500,'[{2,36020001,2075}]'),(10,'打造坊',34,'[{build_lv,[{10,33}]}]','[]','[{1,68592167},{2,68592167},{3,68592167}]',129000,'[{2,36020001,2150}]'),(10,'打造坊',35,'[{build_lv,[{10,34}]}]','[]','[{1,75271750},{2,75271750},{3,75271750}]',133500,'[{2,36020001,2225}]'),(10,'打造坊',36,'[{build_lv,[{10,35}]}]','[]','[{1,82370667},{2,82370667},{3,82370667}]',138000,'[{2,36020001,2300}]'),(10,'打造坊',37,'[{build_lv,[{10,36}]}]','[]','[{1,89901667},{2,89901667},{3,89901667}]',142500,'[{2,36020001,2375}]'),(10,'打造坊',38,'[{build_lv,[{10,37}]}]','[]','[{1,97877500},{2,97877500},{3,97877500}]',147000,'[{2,36020001,2450}]'),(10,'打造坊',39,'[{build_lv,[{10,38}]}]','[]','[{1,106310917},{2,106310917},{3,106310917}]',151500,'[{2,36020001,2525}]'),(10,'打造坊',40,'[{build_lv,[{10,39}]}]','[]','[{1,116322500},{2,116322500},{3,116322500}]',157500,'[{2,36020001,2625}]'),(10,'打造坊',41,'[{build_lv,[{10,40}]}]','[]','[{1,126930500},{2,126930500},{3,126930500}]',163500,'[{2,36020001,2725}]'),(10,'打造坊',42,'[{build_lv,[{10,41}]}]','[]','[{1,138151917},{2,138151917},{3,138151917}]',169500,'[{2,36020001,2825}]'),(10,'打造坊',43,'[{build_lv,[{10,42}]}]','[]','[{1,150003750},{2,150003750},{3,150003750}]',175500,'[{2,36020001,2925}]'),(10,'打造坊',44,'[{build_lv,[{10,43}]}]','[]','[{1,162503000},{2,162503000},{3,162503000}]',181500,'[{2,36020001,3025}]'),(10,'打造坊',45,'[{build_lv,[{10,44}]}]','[]','[{1,175666667},{2,175666667},{3,175666667}]',187500,'[{2,36020001,3125}]'),(10,'打造坊',46,'[{build_lv,[{10,45}]}]','[]','[{1,189511750},{2,189511750},{3,189511750}]',193500,'[{2,36020001,3225}]'),(10,'打造坊',47,'[{build_lv,[{10,46}]}]','[]','[{1,204055250},{2,204055250},{3,204055250}]',199500,'[{2,36020001,3325}]'),(10,'打造坊',48,'[{build_lv,[{10,47}]}]','[]','[{1,219314167},{2,219314167},{3,219314167}]',205500,'[{2,36020001,3425}]'),(10,'打造坊',49,'[{build_lv,[{10,48}]}]','[]','[{1,235305500},{2,235305500},{3,235305500}]',211500,'[{2,36020001,3525}]'),(10,'打造坊',50,'[{build_lv,[{10,49}]}]','[]','[{1,252046250},{2,252046250},{3,252046250}]',217500,'[{2,36020001,3625}]'),(10,'打造坊',51,'[{build_lv,[{10,50}]}]','[]','[{1,269553417},{2,269553417},{3,269553417}]',223500,'[{2,36020001,3725}]'),(10,'打造坊',52,'[{build_lv,[{10,51}]}]','[]','[{1,287844000},{2,287844000},{3,287844000}]',229500,'[{2,36020001,3825}]'),(10,'打造坊',53,'[{build_lv,[{10,52}]}]','[]','[{1,306935000},{2,306935000},{3,306935000}]',235500,'[{2,36020001,3925}]'),(10,'打造坊',54,'[{build_lv,[{10,53}]}]','[]','[{1,326843417},{2,326843417},{3,326843417}]',241500,'[{2,36020001,4025}]'),(10,'打造坊',55,'[{build_lv,[{10,54}]}]','[]','[{1,347586250},{2,347586250},{3,347586250}]',247500,'[{2,36020001,4125}]'),(10,'打造坊',56,'[{build_lv,[{10,55}]}]','[]','[{1,369180500},{2,369180500},{3,369180500}]',253500,'[{2,36020001,4225}]'),(10,'打造坊',57,'[{build_lv,[{10,56}]}]','[]','[{1,391643167},{2,391643167},{3,391643167}]',259500,'[{2,36020001,4325}]'),(10,'打造坊',58,'[{build_lv,[{10,57}]}]','[]','[{1,414991250},{2,414991250},{3,414991250}]',265500,'[{2,36020001,4425}]'),(10,'打造坊',59,'[{build_lv,[{10,58}]}]','[]','[{1,439241750},{2,439241750},{3,439241750}]',271500,'[{2,36020001,4525}]'),(10,'打造坊',60,'[{build_lv,[{10,59}]}]','[]','[]',0,'[]');
/*!40000 ALTER TABLE `base_role_home_build_lv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_role_home_dispatch_task`
--

DROP TABLE IF EXISTS `base_role_home_dispatch_task`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_role_home_dispatch_task` (
  `task_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '任务id',
  `task_type` int(11) unsigned NOT NULL DEFAULT '0',
  `lv_min` int(11) NOT NULL DEFAULT '0' COMMENT '建筑等级下限',
  `lv_max` int(11) NOT NULL DEFAULT '0' COMMENT '建筑等级上限',
  `type_name` varchar(50) NOT NULL DEFAULT '' COMMENT '任务类型',
  `star` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '难度星级',
  `task_name` varchar(50) NOT NULL DEFAULT '' COMMENT '任务名称',
  `must_reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '必得奖励',
  `weight_reward` varchar(512) NOT NULL DEFAULT '[]' COMMENT '稀有奖励',
  `ratio` varchar(255) NOT NULL DEFAULT '[]' COMMENT '成功率',
  `baby_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT '专属宝宝',
  `cd` int(11) NOT NULL DEFAULT '0' COMMENT '任务完成cd时间',
  `npc_name` varchar(50) NOT NULL COMMENT '委托人名字@lang@',
  `description` varchar(255) NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`task_id`,`lv_min`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_role_home_dispatch_task`
--

LOCK TABLES `base_role_home_dispatch_task` WRITE;
/*!40000 ALTER TABLE `base_role_home_dispatch_task` DISABLE KEYS */;
INSERT INTO `base_role_home_dispatch_task` VALUES (1,1,1,2,'种类1任务',1,'任务1','[{1,0,20}]','[{500,[{1,0,30}]},{500,[{1,0,90}]}]','[{1,3000},{2,5000},{3,7000},{4,9000}]','[{1,1000}]',30,'葫芦娃','救爷爷救爷爷，打死那个蛇精，呦，呦，哟，我说救爷爷你说蛇精，“救爷爷”，“蛇精”，skr！！'),(2,1,1,2,'种类1任务',1,'任务2','[{1,0,20}]','[{500,[{1,0,30}]},{500,[{1,0,90}]}]','[{1,3000},{2,5000},{3,7000},{4,9000}]','[{1,1000}]',30,'葫芦娃','救爷爷救爷爷，打死那个蛇精，呦，呦，哟，我说救爷爷你说蛇精，“救爷爷”，“蛇精”，skr！！'),(3,1,1,2,'种类1任务',1,'任务3','[{1,0,20}]','[{500,[{1,0,30}]},{500,[{1,0,90}]}]','[{1,3000},{2,5000},{3,7000},{4,9000}]','[{1,1000}]',30,'葫芦娃','救爷爷救爷爷，打死那个蛇精，呦，呦，哟，我说救爷爷你说蛇精，“救爷爷”，“蛇精”，skr！！'),(4,1,1,2,'种类1任务',1,'任务4','[{1,0,20}]','[{500,[{1,0,30}]},{500,[{1,0,90}]}]','[{1,3000},{2,5000},{3,7000},{4,9000}]','[{1,1000}]',30,'葫芦娃','救爷爷救爷爷，打死那个蛇精，呦，呦，哟，我说救爷爷你说蛇精，“救爷爷”，“蛇精”，skr！！'),(5,1,3,4,'种类1任务',2,'任务1','[{1,0,30}]','[{500,[{1,0,30}]},{500,[{1,0,90}]}]','[{1,3000},{2,5000},{3,7000},{4,9000}]','[{1,1000}]',50,'葫芦娃','救爷爷救爷爷，打死那个蛇精，呦，呦，哟，我说救爷爷你说蛇精，“救爷爷”，“蛇精”，skr！！'),(6,1,3,4,'种类1任务',2,'任务2','[{1,0,30}]','[{500,[{1,0,30}]},{500,[{1,0,90}]}]','[{1,3000},{2,5000},{3,7000},{4,9000}]','[{1,1000}]',50,'葫芦娃','救爷爷救爷爷，打死那个蛇精，呦，呦，哟，我说救爷爷你说蛇精，“救爷爷”，“蛇精”，skr！！'),(7,1,3,4,'种类1任务',2,'任务3','[{1,0,30}]','[{500,[{1,0,30}]},{500,[{1,0,90}]}]','[{1,3000},{2,5000},{3,7000},{4,9000}]','[{1,1000}]',50,'葫芦娃','救爷爷救爷爷，打死那个蛇精，呦，呦，哟，我说救爷爷你说蛇精，“救爷爷”，“蛇精”，skr！！'),(8,1,3,4,'种类1任务',2,'任务4','[{1,0,30}]','[{500,[{1,0,30}]},{500,[{1,0,90}]}]','[{1,3000},{2,5000},{3,7000},{4,9000}]','[{1,1000}]',50,'葫芦娃','救爷爷救爷爷，打死那个蛇精，呦，呦，哟，我说救爷爷你说蛇精，“救爷爷”，“蛇精”，skr！！'),(9,1,5,7,'种类1任务',3,'任务2','[{1,0,50}]','[{500,[{1,0,30}]},{500,[{1,0,90}]}]','[{1,3000},{2,5000},{3,7000},{4,9000}]','[{2,1000}]',70,'葫芦娃','救爷爷救爷爷，打死那个蛇精，呦，呦，哟，我说救爷爷你说蛇精，“救爷爷”，“蛇精”，skr！！'),(10,1,5,7,'种类1任务',3,'任务2','[{1,0,50}]','[{500,[{1,0,30}]},{500,[{1,0,90}]}]','[{1,3000},{2,5000},{3,7000},{4,9000}]','[{2,1000}]',70,'葫芦娃','救爷爷救爷爷，打死那个蛇精，呦，呦，哟，我说救爷爷你说蛇精，“救爷爷”，“蛇精”，skr！！'),(11,1,5,7,'种类1任务',3,'任务2','[{1,0,50}]','[{500,[{1,0,30}]},{500,[{1,0,90}]}]','[{1,3000},{2,5000},{3,7000},{4,9000}]','[{2,1000}]',70,'葫芦娃','救爷爷救爷爷，打死那个蛇精，呦，呦，哟，我说救爷爷你说蛇精，“救爷爷”，“蛇精”，skr！！'),(12,1,5,7,'种类1任务',3,'任务2','[{1,0,50}]','[{500,[{1,0,30}]},{500,[{1,0,90}]}]','[{1,3000},{2,5000},{3,7000},{4,9000}]','[{2,1000}]',70,'葫芦娃','救爷爷救爷爷，打死那个蛇精，呦，呦，哟，我说救爷爷你说蛇精，“救爷爷”，“蛇精”，skr！！'),(13,1,8,10,'种类1任务',3,'任务3','[{1,0,100}]','[{500,[{1,0,30}]},{500,[{1,0,90}]}]','[{1,3000},{2,5000},{3,7000},{4,9000}]','[{3,1000}]',90,'葫芦娃','救爷爷救爷爷，打死那个蛇精，呦，呦，哟，我说救爷爷你说蛇精，“救爷爷”，“蛇精”，skr！！'),(14,1,8,10,'种类1任务',3,'任务3','[{1,0,100}]','[{500,[{1,0,30}]},{500,[{1,0,90}]}]','[{1,3000},{2,5000},{3,7000},{4,9000}]','[{3,1000}]',90,'葫芦娃','救爷爷救爷爷，打死那个蛇精，呦，呦，哟，我说救爷爷你说蛇精，“救爷爷”，“蛇精”，skr！！'),(15,1,8,10,'种类1任务',3,'任务3','[{1,0,100}]','[{500,[{1,0,30}]},{500,[{1,0,90}]}]','[{1,3000},{2,5000},{3,7000},{4,9000}]','[{3,1000}]',90,'葫芦娃','救爷爷救爷爷，打死那个蛇精，呦，呦，哟，我说救爷爷你说蛇精，“救爷爷”，“蛇精”，skr！！'),(16,1,8,10,'种类1任务',3,'任务3','[{1,0,100}]','[{500,[{1,0,30}]},{500,[{1,0,90}]}]','[{1,3000},{2,5000},{3,7000},{4,9000}]','[{3,1000}]',90,'葫芦娃','救爷爷救爷爷，打死那个蛇精，呦，呦，哟，我说救爷爷你说蛇精，“救爷爷”，“蛇精”，skr！！'),(17,2,1,2,'种类2任务',1,'任务1','[{1,0,20}]','[{500,[{1,0,30}]},{500,[{1,0,90}]}]','[{1,3000},{2,5000},{3,7000},{4,9000}]','[{3,1000}]',30,'葫芦娃','救爷爷救爷爷，打死那个蛇精，呦，呦，哟，我说救爷爷你说蛇精，“救爷爷”，“蛇精”，skr！！'),(18,2,1,2,'种类2任务',1,'任务1','[{1,0,20}]','[{500,[{1,0,30}]},{500,[{1,0,90}]}]','[{1,3000},{2,5000},{3,7000},{4,9000}]','[{3,1000}]',30,'葫芦娃','救爷爷救爷爷，打死那个蛇精，呦，呦，哟，我说救爷爷你说蛇精，“救爷爷”，“蛇精”，skr！！'),(19,2,1,2,'种类2任务',1,'任务1','[{1,0,20}]','[{500,[{1,0,30}]},{500,[{1,0,90}]}]','[{1,3000},{2,5000},{3,7000},{4,9000}]','[{3,1000}]',30,'葫芦娃','救爷爷救爷爷，打死那个蛇精，呦，呦，哟，我说救爷爷你说蛇精，“救爷爷”，“蛇精”，skr！！'),(20,2,1,2,'种类2任务',1,'任务1','[{1,0,20}]','[{500,[{1,0,30}]},{500,[{1,0,90}]}]','[{1,3000},{2,5000},{3,7000},{4,9000}]','[{3,1000}]',30,'葫芦娃','救爷爷救爷爷，打死那个蛇精，呦，呦，哟，我说救爷爷你说蛇精，“救爷爷”，“蛇精”，skr！！'),(21,2,3,4,'种类2任务',2,'任务1','[{1,0,30}]','[{500,[{1,0,30}]},{500,[{1,0,90}]}]','[{1,3000},{2,5000},{3,7000},{4,9000}]','[{3,1000}]',50,'葫芦娃','救爷爷救爷爷，打死那个蛇精，呦，呦，哟，我说救爷爷你说蛇精，“救爷爷”，“蛇精”，skr！！'),(22,2,3,4,'种类2任务',2,'任务1','[{1,0,30}]','[{500,[{1,0,30}]},{500,[{1,0,90}]}]','[{1,3000},{2,5000},{3,7000},{4,9000}]','[{3,1000}]',50,'葫芦娃','救爷爷救爷爷，打死那个蛇精，呦，呦，哟，我说救爷爷你说蛇精，“救爷爷”，“蛇精”，skr！！'),(23,2,3,4,'种类2任务',2,'任务1','[{1,0,30}]','[{500,[{1,0,30}]},{500,[{1,0,90}]}]','[{1,3000},{2,5000},{3,7000},{4,9000}]','[{3,1000}]',50,'葫芦娃','救爷爷救爷爷，打死那个蛇精，呦，呦，哟，我说救爷爷你说蛇精，“救爷爷”，“蛇精”，skr！！'),(24,2,3,4,'种类2任务',2,'任务1','[{1,0,30}]','[{500,[{1,0,30}]},{500,[{1,0,90}]}]','[{1,3000},{2,5000},{3,7000},{4,9000}]','[{3,1000}]',50,'葫芦娃','救爷爷救爷爷，打死那个蛇精，呦，呦，哟，我说救爷爷你说蛇精，“救爷爷”，“蛇精”，skr！！'),(25,2,5,7,'种类2任务',3,'任务2','[{1,0,50}]','[{500,[{1,0,30}]},{500,[{1,0,90}]}]','[{1,3000},{2,5000},{3,7000},{4,9000}]','[{4,1000}]',70,'葫芦娃','救爷爷救爷爷，打死那个蛇精，呦，呦，哟，我说救爷爷你说蛇精，“救爷爷”，“蛇精”，skr！！'),(26,2,5,7,'种类2任务',3,'任务2','[{1,0,50}]','[{500,[{1,0,30}]},{500,[{1,0,90}]}]','[{1,3000},{2,5000},{3,7000},{4,9000}]','[{4,1000}]',70,'葫芦娃','救爷爷救爷爷，打死那个蛇精，呦，呦，哟，我说救爷爷你说蛇精，“救爷爷”，“蛇精”，skr！！'),(27,2,5,7,'种类2任务',3,'任务2','[{1,0,50}]','[{500,[{1,0,30}]},{500,[{1,0,90}]}]','[{1,3000},{2,5000},{3,7000},{4,9000}]','[{4,1000}]',70,'葫芦娃','救爷爷救爷爷，打死那个蛇精，呦，呦，哟，我说救爷爷你说蛇精，“救爷爷”，“蛇精”，skr！！'),(28,2,5,7,'种类2任务',3,'任务2','[{1,0,50}]','[{500,[{1,0,30}]},{500,[{1,0,90}]}]','[{1,3000},{2,5000},{3,7000},{4,9000}]','[{4,1000}]',70,'葫芦娃','救爷爷救爷爷，打死那个蛇精，呦，呦，哟，我说救爷爷你说蛇精，“救爷爷”，“蛇精”，skr！！'),(29,2,8,10,'种类2任务',3,'任务3','[{1,0,100}]','[{500,[{1,0,30}]},{500,[{1,0,90}]}]','[{1,3000},{2,5000},{3,7000},{4,9000}]','[{4,1000}]',90,'葫芦娃','救爷爷救爷爷，打死那个蛇精，呦，呦，哟，我说救爷爷你说蛇精，“救爷爷”，“蛇精”，skr！！'),(30,2,8,10,'种类2任务',3,'任务3','[{1,0,100}]','[{500,[{1,0,30}]},{500,[{1,0,90}]}]','[{1,3000},{2,5000},{3,7000},{4,9000}]','[{4,1000}]',90,'葫芦娃','救爷爷救爷爷，打死那个蛇精，呦，呦，哟，我说救爷爷你说蛇精，“救爷爷”，“蛇精”，skr！！'),(31,2,8,10,'种类2任务',3,'任务3','[{1,0,100}]','[{500,[{1,0,30}]},{500,[{1,0,90}]}]','[{1,3000},{2,5000},{3,7000},{4,9000}]','[{4,1000}]',90,'葫芦娃','救爷爷救爷爷，打死那个蛇精，呦，呦，哟，我说救爷爷你说蛇精，“救爷爷”，“蛇精”，skr！！'),(32,2,8,10,'种类2任务',3,'任务3','[{1,0,100}]','[{500,[{1,0,30}]},{500,[{1,0,90}]}]','[{1,3000},{2,5000},{3,7000},{4,9000}]','[{4,1000}]',90,'葫芦娃','救爷爷救爷爷，打死那个蛇精，呦，呦，哟，我说救爷爷你说蛇精，“救爷爷”，“蛇精”，skr！！'),(33,3,1,2,'种类3任务',1,'任务1','[{1,0,20}]','[{500,[{1,0,30}]},{500,[{1,0,90}]}]','[{1,3000},{2,5000},{3,7000},{4,9000}]','[{5,1000}]',30,'葫芦娃','救爷爷救爷爷，打死那个蛇精，呦，呦，哟，我说救爷爷你说蛇精，“救爷爷”，“蛇精”，skr！！'),(34,3,1,2,'种类3任务',1,'任务1','[{1,0,20}]','[{500,[{1,0,30}]},{500,[{1,0,90}]}]','[{1,3000},{2,5000},{3,7000},{4,9000}]','[{5,1000}]',30,'葫芦娃','救爷爷救爷爷，打死那个蛇精，呦，呦，哟，我说救爷爷你说蛇精，“救爷爷”，“蛇精”，skr！！'),(35,3,1,2,'种类3任务',1,'任务1','[{1,0,20}]','[{500,[{1,0,30}]},{500,[{1,0,90}]}]','[{1,3000},{2,5000},{3,7000},{4,9000}]','[{5,1000}]',30,'葫芦娃','救爷爷救爷爷，打死那个蛇精，呦，呦，哟，我说救爷爷你说蛇精，“救爷爷”，“蛇精”，skr！！'),(36,3,1,2,'种类3任务',1,'任务1','[{1,0,20}]','[{500,[{1,0,30}]},{500,[{1,0,90}]}]','[{1,3000},{2,5000},{3,7000},{4,9000}]','[{5,1000}]',30,'葫芦娃','救爷爷救爷爷，打死那个蛇精，呦，呦，哟，我说救爷爷你说蛇精，“救爷爷”，“蛇精”，skr！！'),(37,3,3,4,'种类3任务',2,'任务1','[{1,0,30}]','[{500,[{1,0,30}]},{500,[{1,0,90}]}]','[{1,3000},{2,5000},{3,7000},{4,9000}]','[{5,1000}]',50,'葫芦娃','救爷爷救爷爷，打死那个蛇精，呦，呦，哟，我说救爷爷你说蛇精，“救爷爷”，“蛇精”，skr！！'),(38,3,3,4,'种类3任务',2,'任务1','[{1,0,30}]','[{500,[{1,0,30}]},{500,[{1,0,90}]}]','[{1,3000},{2,5000},{3,7000},{4,9000}]','[{5,1000}]',50,'葫芦娃','救爷爷救爷爷，打死那个蛇精，呦，呦，哟，我说救爷爷你说蛇精，“救爷爷”，“蛇精”，skr！！'),(39,3,3,4,'种类3任务',2,'任务1','[{1,0,30}]','[{500,[{1,0,30}]},{500,[{1,0,90}]}]','[{1,3000},{2,5000},{3,7000},{4,9000}]','[{5,1000}]',50,'葫芦娃','救爷爷救爷爷，打死那个蛇精，呦，呦，哟，我说救爷爷你说蛇精，“救爷爷”，“蛇精”，skr！！'),(40,3,3,4,'种类3任务',2,'任务1','[{1,0,30}]','[{500,[{1,0,30}]},{500,[{1,0,90}]}]','[{1,3000},{2,5000},{3,7000},{4,9000}]','[{5,1000}]',50,'葫芦娃','救爷爷救爷爷，打死那个蛇精，呦，呦，哟，我说救爷爷你说蛇精，“救爷爷”，“蛇精”，skr！！'),(41,3,5,7,'种类3任务',3,'任务2','[{1,0,50}]','[{500,[{1,0,30}]},{500,[{1,0,90}]}]','[{1,3000},{2,5000},{3,7000},{4,9000}]','[{6,1000}]',70,'葫芦娃','救爷爷救爷爷，打死那个蛇精，呦，呦，哟，我说救爷爷你说蛇精，“救爷爷”，“蛇精”，skr！！'),(42,3,5,7,'种类3任务',3,'任务2','[{1,0,50}]','[{500,[{1,0,30}]},{500,[{1,0,90}]}]','[{1,3000},{2,5000},{3,7000},{4,9000}]','[{6,1000}]',70,'葫芦娃','救爷爷救爷爷，打死那个蛇精，呦，呦，哟，我说救爷爷你说蛇精，“救爷爷”，“蛇精”，skr！！'),(43,3,5,7,'种类3任务',3,'任务2','[{1,0,50}]','[{500,[{1,0,30}]},{500,[{1,0,90}]}]','[{1,3000},{2,5000},{3,7000},{4,9000}]','[{6,1000}]',70,'葫芦娃','救爷爷救爷爷，打死那个蛇精，呦，呦，哟，我说救爷爷你说蛇精，“救爷爷”，“蛇精”，skr！！'),(44,3,5,7,'种类3任务',3,'任务2','[{1,0,50}]','[{500,[{1,0,30}]},{500,[{1,0,90}]}]','[{1,3000},{2,5000},{3,7000},{4,9000}]','[{6,1000}]',70,'葫芦娃','救爷爷救爷爷，打死那个蛇精，呦，呦，哟，我说救爷爷你说蛇精，“救爷爷”，“蛇精”，skr！！'),(45,3,8,10,'种类3任务',3,'任务3','[{1,0,100}]','[{500,[{1,0,30}]},{500,[{1,0,90}]}]','[{1,3000},{2,5000},{3,7000},{4,9000}]','[{6,1000}]',90,'葫芦娃','救爷爷救爷爷，打死那个蛇精，呦，呦，哟，我说救爷爷你说蛇精，“救爷爷”，“蛇精”，skr！！'),(46,3,8,10,'种类3任务',3,'任务3','[{1,0,100}]','[{500,[{1,0,30}]},{500,[{1,0,90}]}]','[{1,3000},{2,5000},{3,7000},{4,9000}]','[{6,1000}]',90,'葫芦娃','救爷爷救爷爷，打死那个蛇精，呦，呦，哟，我说救爷爷你说蛇精，“救爷爷”，“蛇精”，skr！！'),(47,3,8,10,'种类3任务',3,'任务3','[{1,0,100}]','[{500,[{1,0,30}]},{500,[{1,0,90}]}]','[{1,3000},{2,5000},{3,7000},{4,9000}]','[{6,1000}]',90,'葫芦娃','救爷爷救爷爷，打死那个蛇精，呦，呦，哟，我说救爷爷你说蛇精，“救爷爷”，“蛇精”，skr！！'),(48,3,8,10,'种类3任务',3,'任务3','[{1,0,100}]','[{500,[{1,0,30}]},{500,[{1,0,90}]}]','[{1,3000},{2,5000},{3,7000},{4,9000}]','[{6,1000}]',90,'葫芦娃','救爷爷救爷爷，打死那个蛇精，呦，呦，哟，我说救爷爷你说蛇精，“救爷爷”，“蛇精”，skr！！');
/*!40000 ALTER TABLE `base_role_home_dispatch_task` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_role_home_dispatch_task_type`
--

DROP TABLE IF EXISTS `base_role_home_dispatch_task_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_role_home_dispatch_task_type` (
  `task_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '任务种类',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '名称',
  `task_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '任务数量',
  `refresh_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '刷新时间',
  PRIMARY KEY (`task_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_role_home_dispatch_task_type`
--

LOCK TABLES `base_role_home_dispatch_task_type` WRITE;
/*!40000 ALTER TABLE `base_role_home_dispatch_task_type` DISABLE KEYS */;
INSERT INTO `base_role_home_dispatch_task_type` VALUES (1,'种类1',3,300),(2,'种类2',3,400),(3,'种类3',4,500);
/*!40000 ALTER TABLE `base_role_home_dispatch_task_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_role_home_guige`
--

DROP TABLE IF EXISTS `base_role_home_guige`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_role_home_guige` (
  `guige_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '规格id',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '名称',
  `prosperity` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '所需繁荣度',
  `attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '属性',
  PRIMARY KEY (`guige_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_role_home_guige`
--

LOCK TABLES `base_role_home_guige` WRITE;
/*!40000 ALTER TABLE `base_role_home_guige` DISABLE KEYS */;
INSERT INTO `base_role_home_guige` VALUES (1,'规格1',50,'[{3,24},{4,24},{7,12},{8,12}]'),(2,'规格2',100,'[{3,48},{4,48},{7,24},{8,24}]'),(3,'规格3',150,'[{3,72},{4,72},{7,36},{8,36}]'),(4,'规格4',200,'[{3,100},{4,100},{7,50},{8,50}]'),(5,'规格5',300,'[{3,128},{4,128},{7,64},{8,64}]'),(6,'规格6',400,'[{3,156},{4,156},{7,78},{8,78}]'),(7,'规格7',500,'[{3,188},{4,188},{7,94},{8,94}]'),(8,'规格8',600,'[{3,220},{4,220},{7,110},{8,110}]'),(9,'规格9',700,'[{3,252},{4,252},{7,126},{8,126}]'),(10,'规格10',800,'[{3,288},{4,288},{7,144},{8,144}]'),(11,'规格11',900,'[{3,324},{4,324},{7,162},{8,162}]'),(12,'规格12',1000,'[{3,360},{4,360},{7,180},{8,180}]'),(13,'规格13',1100,'[{3,400},{4,400},{7,200},{8,200}]'),(14,'规格14',1200,'[{3,440},{4,440},{7,220},{8,220}]'),(15,'规格15',1300,'[{3,480},{4,480},{7,240},{8,240}]'),(16,'规格16',1400,'[{3,520},{4,520},{7,260},{8,260}]'),(17,'规格17',1500,'[{3,560},{4,560},{7,280},{8,280}]'),(18,'规格18',1600,'[{3,600},{4,600},{7,300},{8,300}]'),(19,'规格19',1700,'[{3,644},{4,644},{7,322},{8,322}]'),(20,'规格20',1800,'[{3,688},{4,688},{7,344},{8,344}]'),(21,'规格21',1900,'[{3,732},{4,732},{7,366},{8,366}]'),(22,'规格22',2000,'[{3,776},{4,776},{7,388},{8,388}]');
/*!40000 ALTER TABLE `base_role_home_guige` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_role_home_kv`
--

DROP TABLE IF EXISTS `base_role_home_kv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_role_home_kv` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '键',
  `value` varchar(255) NOT NULL DEFAULT '0' COMMENT '值',
  `description` varchar(50) NOT NULL DEFAULT '' COMMENT '描述@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_role_home_kv`
--

LOCK TABLES `base_role_home_kv` WRITE;
/*!40000 ALTER TABLE `base_role_home_kv` DISABLE KEYS */;
INSERT INTO `base_role_home_kv` VALUES (1,'7406','庭院场景id'),(2,'[{1,1000000000},{2,1000000000},{3,1000000000},{4,1000000},{5,1000000}]','矿场资源上限值:[{资源类型,上限}],注:1木材，2铁，3石，4家园币，5许愿币'),(3,'{20000,20000,20000}','资源初始值:{木,铁,石头}'),(4,'{60,1}','升级cd消耗,{时间(秒),钻石}注：升级cd中剩余时间计算'),(5,'[{1,48040002,2}]','许愿币购买消耗:[{类型,物品id,数量}]'),(6,'60','派遣任务稀有奖励获得概率，70%则填70'),(7,'48050001','地契ID'),(8,'40010','任务激活ID'),(9,'[{1,48010001},{2,48020001},{3,48030001},{4,48040001}]','对应物品id:[{家园物品类型,物品id}]注:1木材，2铁，3石，4家园币'),(10,'10','临时队列上限数'),(11,'1','家具默认摆放数量');
/*!40000 ALTER TABLE `base_role_home_kv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_role_home_line_type`
--

DROP TABLE IF EXISTS `base_role_home_line_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_role_home_line_type` (
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `line_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '队列数量',
  PRIMARY KEY (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_role_home_line_type`
--

LOCK TABLES `base_role_home_line_type` WRITE;
/*!40000 ALTER TABLE `base_role_home_line_type` DISABLE KEYS */;
INSERT INTO `base_role_home_line_type` VALUES (1,1),(2,1),(3,1);
/*!40000 ALTER TABLE `base_role_home_line_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_role_home_lv`
--

DROP TABLE IF EXISTS `base_role_home_lv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_role_home_lv` (
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `unlock` varchar(50) NOT NULL DEFAULT '[]' COMMENT '解锁建筑',
  `up_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '同时升级个数',
  `up_line_cost` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '额外升级队列数购买',
  `effect_list` varchar(512) NOT NULL DEFAULT '[]' COMMENT '加成列表',
  `furniture` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '解锁家具类型',
  `furniture_limit` varchar(255) NOT NULL DEFAULT '[]' COMMENT '家具使用上限',
  `unlock_build` varchar(255) NOT NULL DEFAULT '[]' COMMENT '解锁建筑（客户端用）',
  PRIMARY KEY (`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_role_home_lv`
--

LOCK TABLES `base_role_home_lv` WRITE;
/*!40000 ALTER TABLE `base_role_home_lv` DISABLE KEYS */;
INSERT INTO `base_role_home_lv` VALUES (1,'[1,2,3,4,7]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,10,60}]},{3,[{1,10,60}]},{4,[{1,10,60}]}]','[4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25]','10','[]'),(2,'[1,2,3,4,7]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,30,60}]},{3,[{1,30,60}]},{4,[{1,30,60}]}]','[]','10','[]'),(3,'[1,2,3,4,7,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,50,60}]},{3,[{1,50,60}]},{4,[{1,50,60}]}]','[]','10','[10]'),(4,'[1,2,3,4,7,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,70,60}]},{3,[{1,70,60}]},{4,[{1,70,60}]}]','[]','10','[]'),(5,'[1,2,3,4,7,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,90,60}]},{3,[{1,90,60}]},{4,[{1,90,60}]}]','[]','12','[9]'),(6,'[1,2,3,4,7,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,110,60}]},{3,[{1,110,60}]},{4,[{1,110,60}]}]','[]','12','[]'),(7,'[1,2,3,4,7,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,130,60}]},{3,[{1,130,60}]},{4,[{1,130,60}]}]','[]','12','[]'),(8,'[1,2,3,4,5,7,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,150,60}]},{3,[{1,150,60}]},{4,[{1,150,60}]}]','[]','12','[5]'),(9,'[1,2,3,4,5,7,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,170,60}]},{3,[{1,170,60}]},{4,[{1,170,60}]}]','[]','12','[]'),(10,'[1,2,3,4,5,6,7,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,190,60}]},{3,[{1,190,60}]},{4,[{1,190,60}]}]','[]','14','[6]'),(11,'[1,2,3,4,5,6,7,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,210,60}]},{3,[{1,210,60}]},{4,[{1,210,60}]}]','[]','14','[]'),(12,'[1,2,3,4,5,6,7,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,230,60}]},{3,[{1,230,60}]},{4,[{1,230,60}]}]','[]','14','[]'),(13,'[1,2,3,4,5,6,7,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,250,60}]},{3,[{1,250,60}]},{4,[{1,250,60}]}]','[]','14','[]'),(14,'[1,2,3,4,5,6,7,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,270,60}]},{3,[{1,270,60}]},{4,[{1,270,60}]}]','[]','14','[]'),(15,'[1,2,3,4,5,6,7,8,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,290,60}]},{3,[{1,290,60}]},{4,[{1,290,60}]}]','[]','17','[]'),(16,'[1,2,3,4,5,6,7,8,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,310,60}]},{3,[{1,310,60}]},{4,[{1,310,60}]}]','[]','17','[]'),(17,'[1,2,3,4,5,6,7,8,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,330,60}]},{3,[{1,330,60}]},{4,[{1,330,60}]}]','[]','17','[]'),(18,'[1,2,3,4,5,6,7,8,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,350,60}]},{3,[{1,350,60}]},{4,[{1,350,60}]}]','[]','17','[]'),(19,'[1,2,3,4,5,6,7,8,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,370,60}]},{3,[{1,370,60}]},{4,[{1,370,60}]}]','[]','17','[]'),(20,'[1,2,3,4,5,6,7,8,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,390,60}]},{3,[{1,390,60}]},{4,[{1,390,60}]}]','[]','20','[]'),(21,'[1,2,3,4,5,6,7,8,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,410,60}]},{3,[{1,410,60}]},{4,[{1,410,60}]}]','[]','20','[]'),(22,'[1,2,3,4,5,6,7,8,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,430,60}]},{3,[{1,430,60}]},{4,[{1,430,60}]}]','[]','20','[]'),(23,'[1,2,3,4,5,6,7,8,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,450,60}]},{3,[{1,450,60}]},{4,[{1,450,60}]}]','[]','20','[]'),(24,'[1,2,3,4,5,6,7,8,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,470,60}]},{3,[{1,470,60}]},{4,[{1,470,60}]}]','[]','20','[]'),(25,'[1,2,3,4,5,6,7,8,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,490,60}]},{3,[{1,490,60}]},{4,[{1,490,60}]}]','[]','24','[]'),(26,'[1,2,3,4,5,6,7,8,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,510,60}]},{3,[{1,510,60}]},{4,[{1,510,60}]}]','[]','24','[]'),(27,'[1,2,3,4,5,6,7,8,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,530,60}]},{3,[{1,530,60}]},{4,[{1,530,60}]}]','[]','24','[]'),(28,'[1,2,3,4,5,6,7,8,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,550,60}]},{3,[{1,550,60}]},{4,[{1,550,60}]}]','[]','24','[]'),(29,'[1,2,3,4,5,6,7,8,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,570,60}]},{3,[{1,570,60}]},{4,[{1,570,60}]}]','[]','24','[]'),(30,'[1,2,3,4,5,6,7,8,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,590,60}]},{3,[{1,590,60}]},{4,[{1,590,60}]}]','[]','28','[]'),(31,'[1,2,3,4,5,6,7,8,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,610,60}]},{3,[{1,610,60}]},{4,[{1,610,60}]}]','[]','28','[]'),(32,'[1,2,3,4,5,6,7,8,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,630,60}]},{3,[{1,630,60}]},{4,[{1,630,60}]}]','[]','28','[]'),(33,'[1,2,3,4,5,6,7,8,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,650,60}]},{3,[{1,650,60}]},{4,[{1,650,60}]}]','[]','28','[]'),(34,'[1,2,3,4,5,6,7,8,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,670,60}]},{3,[{1,670,60}]},{4,[{1,670,60}]}]','[]','28','[]'),(35,'[1,2,3,4,5,6,7,8,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,690,60}]},{3,[{1,690,60}]},{4,[{1,690,60}]}]','[]','32','[]'),(36,'[1,2,3,4,5,6,7,8,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,710,60}]},{3,[{1,710,60}]},{4,[{1,710,60}]}]','[]','32','[]'),(37,'[1,2,3,4,5,6,7,8,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,730,60}]},{3,[{1,730,60}]},{4,[{1,730,60}]}]','[]','32','[]'),(38,'[1,2,3,4,5,6,7,8,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,750,60}]},{3,[{1,750,60}]},{4,[{1,750,60}]}]','[]','32','[]'),(39,'[1,2,3,4,5,6,7,8,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,770,60}]},{3,[{1,770,60}]},{4,[{1,770,60}]}]','[]','32','[]'),(40,'[1,2,3,4,5,6,7,8,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,790,60}]},{3,[{1,790,60}]},{4,[{1,790,60}]}]','[]','36','[]'),(41,'[1,2,3,4,5,6,7,8,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,810,60}]},{3,[{1,810,60}]},{4,[{1,810,60}]}]','[]','36','[]'),(42,'[1,2,3,4,5,6,7,8,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,830,60}]},{3,[{1,830,60}]},{4,[{1,830,60}]}]','[]','36','[]'),(43,'[1,2,3,4,5,6,7,8,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,850,60}]},{3,[{1,850,60}]},{4,[{1,850,60}]}]','[]','36','[]'),(44,'[1,2,3,4,5,6,7,8,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,870,60}]},{3,[{1,870,60}]},{4,[{1,870,60}]}]','[]','36','[]'),(45,'[1,2,3,4,5,6,7,8,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,890,60}]},{3,[{1,890,60}]},{4,[{1,890,60}]}]','[]','40','[]'),(46,'[1,2,3,4,5,6,7,8,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,910,60}]},{3,[{1,910,60}]},{4,[{1,910,60}]}]','[]','40','[]'),(47,'[1,2,3,4,5,6,7,8,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,930,60}]},{3,[{1,930,60}]},{4,[{1,930,60}]}]','[]','40','[]'),(48,'[1,2,3,4,5,6,7,8,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,950,60}]},{3,[{1,950,60}]},{4,[{1,950,60}]}]','[]','40','[]'),(49,'[1,2,3,4,5,6,7,8,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,970,60}]},{3,[{1,970,60}]},{4,[{1,970,60}]}]','[]','40','[]'),(50,'[1,2,3,4,5,6,7,8,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,990,60}]},{3,[{1,990,60}]},{4,[{1,990,60}]}]','[]','44','[]'),(51,'[1,2,3,4,5,6,7,8,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,1010,60}]},{3,[{1,1010,60}]},{4,[{1,1010,60}]}]','[]','44','[]'),(52,'[1,2,3,4,5,6,7,8,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,1030,60}]},{3,[{1,1030,60}]},{4,[{1,1030,60}]}]','[]','44','[]'),(53,'[1,2,3,4,5,6,7,8,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,1050,60}]},{3,[{1,1050,60}]},{4,[{1,1050,60}]}]','[]','44','[]'),(54,'[1,2,3,4,5,6,7,8,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,1070,60}]},{3,[{1,1070,60}]},{4,[{1,1070,60}]}]','[]','44','[]'),(55,'[1,2,3,4,5,6,7,8,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,1090,60}]},{3,[{1,1090,60}]},{4,[{1,1090,60}]}]','[]','48','[]'),(56,'[1,2,3,4,5,6,7,8,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,1110,60}]},{3,[{1,1110,60}]},{4,[{1,1110,60}]}]','[]','48','[]'),(57,'[1,2,3,4,5,6,7,8,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,1130,60}]},{3,[{1,1130,60}]},{4,[{1,1130,60}]}]','[]','48','[]'),(58,'[1,2,3,4,5,6,7,8,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,1150,60}]},{3,[{1,1150,60}]},{4,[{1,1150,60}]}]','[]','48','[]'),(59,'[1,2,3,4,5,6,7,8,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,1170,60}]},{3,[{1,1170,60}]},{4,[{1,1170,60}]}]','[]','48','[]'),(60,'[1,2,3,4,5,6,7,8,9,10]',1,'[{4,[{1,[{1,0,100}]}]},{5,[{1,[{1,0,100}]}]},{6,[{1,[{1,0,100}]}]},{7,[{1,[{1,0,100}]}]},{8,[{1,[{1,0,100}]}]},{9,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{10,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{11,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{12,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{13,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{14,[{1,[{1,0,100}]},{2,[{1,0,200}]}]},{15,[{1,[{1,0,100}]},{2,[{1,0,200}]}]}]','[{2,[{1,1190,60}]},{3,[{1,1190,60}]},{4,[{1,1190,60}]}]','[]','52','[]');
/*!40000 ALTER TABLE `base_role_home_lv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_role_home_marriage_reward`
--

DROP TABLE IF EXISTS `base_role_home_marriage_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_role_home_marriage_reward` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '组合id',
  `condition` varchar(50) NOT NULL DEFAULT '[]' COMMENT '家园规格组合',
  `reward` varchar(50) NOT NULL DEFAULT '[]' COMMENT '奖励内容',
  `share_cost` varchar(50) NOT NULL DEFAULT '[]' COMMENT '共享房屋消耗',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_role_home_marriage_reward`
--

LOCK TABLES `base_role_home_marriage_reward` WRITE;
/*!40000 ALTER TABLE `base_role_home_marriage_reward` DISABLE KEYS */;
INSERT INTO `base_role_home_marriage_reward` VALUES (1,'[{1,1}]','[{2,36020001,100}]','[{0,48050002,1}]'),(2,'[{1,2}]','[{2,36020001,100}]','[{0,48050002,1}]'),(3,'[{1,3}]','[{2,36020001,100}]','[{0,48050002,1}]'),(4,'[{1,4}]','[{2,36020001,100}]','[{0,48050002,1}]'),(5,'[{2,2}]','[{2,36020001,100}]','[{0,48050002,1}]'),(6,'[{2,3}]','[{2,36020001,100}]','[{0,48050002,1}]'),(7,'[{2,4}]','[{2,36020001,100}]','[{0,48050002,1}]'),(8,'[{3,3}]','[{2,36020001,100}]','[{0,48050002,1}]'),(9,'[{3,4}]','[{2,36020001,100}]','[{0,48050002,1}]'),(10,'[{4,4}]','[{2,36020001,100}]','[{0,48050002,1}]');
/*!40000 ALTER TABLE `base_role_home_marriage_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_role_home_pic`
--

DROP TABLE IF EXISTS `base_role_home_pic`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_role_home_pic` (
  `pic_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '图鉴id',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '图鉴类型',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '图鉴名称@lang@',
  `stage` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '图鉴品质',
  `condition` varchar(255) NOT NULL DEFAULT '[]' COMMENT '激活条件',
  `model_id` varchar(20) NOT NULL COMMENT '模型id',
  `picture` varchar(20) NOT NULL COMMENT '图片id',
  `way` varchar(50) NOT NULL COMMENT '获取途径',
  PRIMARY KEY (`pic_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_role_home_pic`
--

LOCK TABLES `base_role_home_pic` WRITE;
/*!40000 ALTER TABLE `base_role_home_pic` DISABLE KEYS */;
INSERT INTO `base_role_home_pic` VALUES (47030011,1,'【良好】朴素小床',0,'[]','0','47030011','6,10'),(47030012,1,'【精致】朴素小床',1,'[]','0','47030011','6,10'),(47030013,1,'【华丽】朴素小床',2,'[]','0','47030011','6,10'),(47030014,1,'【完美】朴素小床',3,'[]','0','47030011','6,10'),(47030021,1,'【良好】褐色书柜',0,'[]','0','47030021','6,10'),(47030022,1,'【精致】褐色书柜',1,'[]','0','47030021','6,10'),(47030023,1,'【华丽】褐色书柜',2,'[]','0','47030021','6,10'),(47030024,1,'【完美】褐色书柜',3,'[]','0','47030021','6,10'),(47030031,1,'【良好】白色衣柜',0,'[]','0','47030031','6,10'),(47030032,1,'【精致】白色衣柜',1,'[]','0','47030031','6,10'),(47030033,1,'【华丽】白色衣柜',2,'[]','0','47030031','6,10'),(47030034,1,'【完美】白色衣柜',3,'[]','0','47030031','6,10'),(47030041,1,'【完美】蜜语圆床',4,'[]','0','47030041','6,10'),(47040011,2,'【良好】红色圆凳',0,'[]','0','47040011','6,10'),(47040012,2,'【精致】红色圆凳',1,'[]','0','47040011','6,10'),(47040013,2,'【华丽】红色圆凳',2,'[]','0','47040011','6,10'),(47040014,2,'【完美】红色圆凳',3,'[]','0','47040011','6,10'),(47040021,2,'【良好】红色椅子',0,'[]','0','47040021','6,10'),(47040022,2,'【精致】红色椅子',1,'[]','0','47040021','6,10'),(47040023,2,'【华丽】红色椅子',2,'[]','0','47040021','6,10'),(47040024,2,'【完美】红色椅子',3,'[]','0','47040021','6,10'),(47040031,2,'【良好】简易圆桌',0,'[]','0','47040031','6,10'),(47040032,2,'【精致】简易圆桌',1,'[]','0','47040031','6,10'),(47040033,2,'【华丽】简易圆桌',2,'[]','0','47040031','6,10'),(47040034,2,'【完美】简易圆桌',3,'[]','0','47040031','6,10'),(47040041,2,'【良好】方形书桌',0,'[]','0','47040041','6,10'),(47040042,2,'【精致】方形书桌',1,'[]','0','47040041','6,10'),(47040043,2,'【华丽】方形书桌',2,'[]','0','47040041','6,10'),(47040044,2,'【完美】方形书桌',3,'[]','0','47040041','6,10'),(47040051,2,'【良好】简约茶几',0,'[]','0','47040051','6,10'),(47040052,2,'【精致】简约茶几',1,'[]','0','47040051','6,10'),(47040053,2,'【华丽】简约茶几',2,'[]','0','47040051','6,10'),(47040054,2,'【完美】简约茶几',3,'[]','0','47040051','6,10'),(47040061,2,'【完美】温馨沙发',4,'[]','0','47040061','6,10'),(47040071,2,'【完美】典雅茶几',4,'[]','0','47040071','6,10'),(47050011,3,'【良好】小伞台灯',0,'[]','0','47050011','6,10'),(47050012,3,'【精致】小伞台灯',1,'[]','0','47050011','6,10'),(47050013,3,'【华丽】小伞台灯',2,'[]','0','47050011','6,10'),(47050014,3,'【完美】小伞台灯',3,'[]','0','47050011','6,10'),(47050021,3,'【良好】风景屏风',0,'[]','0','47050021','6,10'),(47050022,3,'【精致】风景屏风',1,'[]','0','47050021','6,10'),(47050023,3,'【华丽】风景屏风',2,'[]','0','47050021','6,10'),(47050024,3,'【完美】风景屏风',3,'[]','0','47050021','6,10'),(47050031,3,'【良好】小树盆栽',0,'[]','0','47050031','6,10'),(47050032,3,'【精致】小树盆栽',1,'[]','0','47050031','6,10'),(47050033,3,'【华丽】小树盆栽',2,'[]','0','47050031','6,10'),(47050034,3,'【完美】小树盆栽',3,'[]','0','47050031','6,10'),(47050041,3,'【完美】复古台灯',4,'[]','0','47050041','6,10'),(47050051,3,'【完美】花语吊篮',4,'[]','0','47050051','6,10'),(47050061,3,'【完美】丰收屏风',4,'[]','0','47050061','6,10'),(47060011,4,'【良好】圆顶窗户',0,'[]','0','47060011','6,10'),(47060012,4,'【精致】圆顶窗户',1,'[]','0','47060011','6,10'),(47060013,4,'【华丽】圆顶窗户',2,'[]','0','47060011','6,10'),(47060014,4,'【完美】圆顶窗户',3,'[]','0','47060011','6,10'),(47060021,4,'【良好】纯净纱窗',0,'[]','0','47060021','6,10'),(47060022,4,'【精致】纯净纱窗',1,'[]','0','47060021','6,10'),(47060023,4,'【华丽】纯净纱窗',2,'[]','0','47060021','6,10'),(47060024,4,'【完美】纯净纱窗',3,'[]','0','47060021','6,10'),(47060031,4,'【良好】灰色墙纸',0,'[]','0','47060031','6,10'),(47060032,4,'【精致】灰色墙纸',1,'[]','0','47060031','6,10'),(47060033,4,'【华丽】灰色墙纸',2,'[]','0','47060031','6,10'),(47060034,4,'【完美】灰色墙纸',3,'[]','0','47060031','6,10'),(47060041,4,'【完美】爱意纱窗',4,'[]','0','47060041','6,10'),(47070011,5,'【良好】圆形地毯',0,'[]','0','47070011','6,10'),(47070012,5,'【精致】圆形地毯',1,'[]','0','47070011','6,10'),(47070013,5,'【华丽】圆形地毯',2,'[]','0','47070011','6,10'),(47070014,5,'【完美】圆形地毯',3,'[]','0','47070011','6,10');
/*!40000 ALTER TABLE `base_role_home_pic` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_role_home_pic_lv`
--

DROP TABLE IF EXISTS `base_role_home_pic_lv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_role_home_pic_lv` (
  `pic_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '图鉴id',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `attr` varchar(512) NOT NULL DEFAULT '[]' COMMENT '属性',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗道具',
  `limit` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '摆放上限',
  PRIMARY KEY (`pic_id`,`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_role_home_pic_lv`
--

LOCK TABLES `base_role_home_pic_lv` WRITE;
/*!40000 ALTER TABLE `base_role_home_pic_lv` DISABLE KEYS */;
INSERT INTO `base_role_home_pic_lv` VALUES (47030011,1,'[{2,200},{1,10},{3,8},{4,8}]','[{47030011,1}]',1),(47030011,2,'[{2,368},{1,18},{3,15},{4,15}]','[{47030011,2}]',1),(47030011,3,'[{2,558},{1,28},{3,23},{4,23}]','[{47030011,3}]',1),(47030011,4,'[{2,771},{1,39},{3,32},{4,32}]','[{47030011,4}]',1),(47030011,5,'[{2,1006},{1,51},{3,41},{4,41}]','[{47030011,5}]',1),(47030011,6,'[{2,1264},{1,64},{3,51},{4,51}]','[{47030011,6}]',1),(47030011,7,'[{2,1544},{1,78},{3,62},{4,62}]','[{47030011,7}]',1),(47030011,8,'[{2,1847},{1,93},{3,74},{4,74}]','[{47030011,8}]',1),(47030011,9,'[{2,2172},{1,109},{3,87},{4,87}]','[{47030011,9}]',1),(47030011,10,'[{2,2520},{1,126},{3,101},{4,101}]','[{47030011,10}]',2),(47030011,11,'[{2,2890},{1,145},{3,116},{4,116}]','[{47030011,11}]',2),(47030011,12,'[{2,3283},{1,165},{3,132},{4,132}]','[{47030011,12}]',2),(47030011,13,'[{2,3698},{1,186},{3,149},{4,149}]','[{47030011,13}]',2),(47030011,14,'[{2,4136},{1,208},{3,167},{4,167}]','[{47030011,14}]',2),(47030011,15,'[{2,4596},{1,231},{3,185},{4,185}]','[{47030011,15}]',2),(47030011,16,'[{2,5079},{1,255},{3,204},{4,204}]','[{47030011,16}]',2),(47030011,17,'[{2,5584},{1,280},{3,224},{4,224}]','[{47030011,17}]',2),(47030011,18,'[{2,6112},{1,306},{3,245},{4,245}]','[{47030011,18}]',2),(47030011,19,'[{2,6662},{1,334},{3,267},{4,267}]','[{47030011,19}]',2),(47030011,20,'[{2,7235},{1,363},{3,290},{4,290}]','[{47030011,20}]',3),(47030011,21,'[{2,7838},{1,393},{3,314},{4,314}]','[{47030011,22}]',3),(47030011,22,'[{2,8471},{1,425},{3,339},{4,339}]','[{47030011,24}]',3),(47030011,23,'[{2,9134},{1,458},{3,366},{4,366}]','[{47030011,26}]',3),(47030011,24,'[{2,9827},{1,493},{3,394},{4,394}]','[{47030011,28}]',3),(47030011,25,'[{2,10550},{1,529},{3,423},{4,423}]','[{47030011,30}]',3),(47030011,26,'[{2,11303},{1,567},{3,453},{4,453}]','[{47030011,32}]',3),(47030011,27,'[{2,12086},{1,606},{3,484},{4,484}]','[{47030011,34}]',3),(47030011,28,'[{2,12899},{1,647},{3,517},{4,517}]','[{47030011,36}]',3),(47030011,29,'[{2,13742},{1,689},{3,551},{4,551}]','[{47030011,38}]',3),(47030011,30,'[{2,14615},{1,733},{3,586},{4,586}]','[{47030011,40}]',4),(47030011,31,'[{2,15518},{1,778},{3,622},{4,622}]','[{47030011,42}]',4),(47030011,32,'[{2,16451},{1,825},{3,659},{4,659}]','[{47030011,44}]',4),(47030011,33,'[{2,17414},{1,873},{3,698},{4,698}]','[{47030011,46}]',4),(47030011,34,'[{2,18407},{1,923},{3,738},{4,738}]','[{47030011,48}]',4),(47030011,35,'[{2,19430},{1,974},{3,779},{4,779}]','[{47030011,50}]',4),(47030011,36,'[{2,20483},{1,1027},{3,821},{4,821}]','[{47030011,52}]',4),(47030011,37,'[{2,21566},{1,1081},{3,864},{4,864}]','[{47030011,54}]',4),(47030011,38,'[{2,22679},{1,1137},{3,909},{4,909}]','[{47030011,56}]',4),(47030011,39,'[{2,23822},{1,1194},{3,955},{4,955}]','[{47030011,58}]',4),(47030011,40,'[{2,24995},{1,1253},{3,1002},{4,1002}]','[{47030011,60}]',5),(47030012,1,'[{2,400},{1,20},{3,15},{4,15}]','[{47030012,1}]',1),(47030012,2,'[{2,664},{1,33},{3,25},{4,25}]','[{47030012,2}]',1),(47030012,3,'[{2,964},{1,48},{3,36},{4,36}]','[{47030012,3}]',1),(47030012,4,'[{2,1300},{1,65},{3,49},{4,49}]','[{47030012,4}]',1),(47030012,5,'[{2,1672},{1,84},{3,63},{4,63}]','[{47030012,5}]',1),(47030012,6,'[{2,2080},{1,104},{3,78},{4,78}]','[{47030012,6}]',1),(47030012,7,'[{2,2524},{1,126},{3,95},{4,95}]','[{47030012,7}]',1),(47030012,8,'[{2,3004},{1,150},{3,113},{4,113}]','[{47030012,8}]',1),(47030012,9,'[{2,3520},{1,176},{3,132},{4,132}]','[{47030012,9}]',1),(47030012,10,'[{2,4072},{1,204},{3,153},{4,153}]','[{47030012,10}]',2),(47030012,11,'[{2,4660},{1,233},{3,175},{4,175}]','[{47030012,11}]',2),(47030012,12,'[{2,5284},{1,264},{3,198},{4,198}]','[{47030012,12}]',2),(47030012,13,'[{2,5944},{1,297},{3,223},{4,223}]','[{47030012,13}]',2),(47030012,14,'[{2,6640},{1,332},{3,249},{4,249}]','[{47030012,14}]',2),(47030012,15,'[{2,7372},{1,369},{3,276},{4,276}]','[{47030012,15}]',2),(47030012,16,'[{2,8140},{1,407},{3,305},{4,305}]','[{47030012,16}]',2),(47030012,17,'[{2,8944},{1,447},{3,335},{4,335}]','[{47030012,17}]',2),(47030012,18,'[{2,9784},{1,489},{3,367},{4,367}]','[{47030012,18}]',2),(47030012,19,'[{2,10660},{1,533},{3,400},{4,400}]','[{47030012,19}]',2),(47030012,20,'[{2,11572},{1,579},{3,434},{4,434}]','[{47030012,20}]',3),(47030012,21,'[{2,12532},{1,627},{3,470},{4,470}]','[{47030012,22}]',3),(47030012,22,'[{2,13540},{1,677},{3,508},{4,508}]','[{47030012,24}]',3),(47030012,23,'[{2,14596},{1,730},{3,548},{4,548}]','[{47030012,26}]',3),(47030012,24,'[{2,15700},{1,785},{3,589},{4,589}]','[{47030012,28}]',3),(47030012,25,'[{2,16852},{1,843},{3,632},{4,632}]','[{47030012,30}]',3),(47030012,26,'[{2,18052},{1,903},{3,677},{4,677}]','[{47030012,32}]',3),(47030012,27,'[{2,19300},{1,965},{3,724},{4,724}]','[{47030012,34}]',3),(47030012,28,'[{2,20596},{1,1030},{3,773},{4,773}]','[{47030012,36}]',3),(47030012,29,'[{2,21940},{1,1097},{3,823},{4,823}]','[{47030012,38}]',3),(47030012,30,'[{2,23332},{1,1167},{3,875},{4,875}]','[{47030012,40}]',4),(47030012,31,'[{2,24772},{1,1239},{3,929},{4,929}]','[{47030012,42}]',4),(47030012,32,'[{2,26260},{1,1313},{3,985},{4,985}]','[{47030012,44}]',4),(47030012,33,'[{2,27796},{1,1390},{3,1043},{4,1043}]','[{47030012,46}]',4),(47030012,34,'[{2,29380},{1,1469},{3,1102},{4,1102}]','[{47030012,48}]',4),(47030012,35,'[{2,31012},{1,1551},{3,1163},{4,1163}]','[{47030012,50}]',4),(47030012,36,'[{2,32692},{1,1635},{3,1226},{4,1226}]','[{47030012,52}]',4),(47030012,37,'[{2,34420},{1,1721},{3,1291},{4,1291}]','[{47030012,54}]',4),(47030012,38,'[{2,36196},{1,1810},{3,1358},{4,1358}]','[{47030012,56}]',4),(47030012,39,'[{2,38020},{1,1901},{3,1426},{4,1426}]','[{47030012,58}]',4),(47030012,40,'[{2,39892},{1,1995},{3,1496},{4,1496}]','[{47030012,60}]',5),(47030013,1,'[{2,700},{1,35},{3,25},{4,25}]','[{47030013,1}]',1),(47030013,2,'[{2,1282},{1,64},{3,46},{4,46}]','[{47030013,2}]',1),(47030013,3,'[{2,1944},{1,97},{3,70},{4,70}]','[{47030013,3}]',1),(47030013,4,'[{2,2687},{1,134},{3,97},{4,97}]','[{47030013,4}]',1),(47030013,5,'[{2,3511},{1,175},{3,126},{4,126}]','[{47030013,5}]',1),(47030013,6,'[{2,4416},{1,220},{3,158},{4,158}]','[{47030013,6}]',1),(47030013,7,'[{2,5401},{1,269},{3,193},{4,193}]','[{47030013,7}]',1),(47030013,8,'[{2,6467},{1,322},{3,231},{4,231}]','[{47030013,8}]',1),(47030013,9,'[{2,7614},{1,379},{3,272},{4,272}]','[{47030013,9}]',1),(47030013,10,'[{2,8842},{1,440},{3,316},{4,316}]','[{47030013,10}]',2),(47030013,11,'[{2,10150},{1,505},{3,363},{4,363}]','[{47030013,12}]',2),(47030013,12,'[{2,11539},{1,574},{3,413},{4,413}]','[{47030013,14}]',2),(47030013,13,'[{2,13009},{1,648},{3,466},{4,466}]','[{47030013,16}]',2),(47030013,14,'[{2,14560},{1,726},{3,521},{4,521}]','[{47030013,18}]',2),(47030013,15,'[{2,16192},{1,808},{3,579},{4,579}]','[{47030013,20}]',2),(47030013,16,'[{2,17931},{1,895},{3,641},{4,641}]','[{47030013,22}]',2),(47030013,17,'[{2,19778},{1,987},{3,707},{4,707}]','[{47030013,24}]',2),(47030013,18,'[{2,21733},{1,1085},{3,777},{4,777}]','[{47030013,26}]',2),(47030013,19,'[{2,23795},{1,1188},{3,851},{4,851}]','[{47030013,28}]',2),(47030013,20,'[{2,25965},{1,1297},{3,929},{4,929}]','[{47030013,30}]',3),(47030013,21,'[{2,28243},{1,1411},{3,1010},{4,1010}]','[{47030013,33}]',3),(47030013,22,'[{2,30628},{1,1530},{3,1095},{4,1095}]','[{47030013,36}]',3),(47030013,23,'[{2,33121},{1,1655},{3,1184},{4,1184}]','[{47030013,39}]',3),(47030013,24,'[{2,35722},{1,1785},{3,1277},{4,1277}]','[{47030013,42}]',3),(47030013,25,'[{2,38430},{1,1920},{3,1374},{4,1374}]','[{47030013,45}]',3),(47030013,26,'[{2,41246},{1,2061},{3,1475},{4,1475}]','[{47030013,48}]',3),(47030013,27,'[{2,44197},{1,2209},{3,1580},{4,1580}]','[{47030013,51}]',3),(47030013,28,'[{2,47282},{1,2363},{3,1690},{4,1690}]','[{47030013,54}]',3),(47030013,29,'[{2,50502},{1,2524},{3,1805},{4,1805}]','[{47030013,57}]',3),(47030013,30,'[{2,53857},{1,2692},{3,1925},{4,1925}]','[{47030013,60}]',4),(47030014,1,'[{2,1200},{1,60},{3,40},{4,40}]','[{47030014,1}]',1),(47030014,2,'[{2,2133},{1,110},{3,73},{4,73}]','[{47030014,2}]',1),(47030014,3,'[{2,3266},{1,167},{3,111},{4,111}]','[{47030014,3}]',1),(47030014,4,'[{2,4599},{1,234},{3,155},{4,155}]','[{47030014,4}]',1),(47030014,5,'[{2,6132},{1,311},{3,206},{4,206}]','[{47030014,5}]',1),(47030014,6,'[{2,7932},{1,401},{3,266},{4,266}]','[{47030014,7}]',1),(47030014,7,'[{2,9999},{1,504},{3,335},{4,335}]','[{47030014,9}]',1),(47030014,8,'[{2,12332},{1,621},{3,413},{4,413}]','[{47030014,11}]',1),(47030014,9,'[{2,14932},{1,751},{3,500},{4,500}]','[{47030014,13}]',1),(47030014,10,'[{2,17865},{1,898},{3,598},{4,598}]','[{47030014,15}]',2),(47030014,11,'[{2,21132},{1,1061},{3,707},{4,707}]','[{47030014,18}]',2),(47030014,12,'[{2,24732},{1,1241},{3,827},{4,827}]','[{47030014,21}]',2),(47030014,13,'[{2,28665},{1,1438},{3,958},{4,958}]','[{47030014,24}]',2),(47030014,14,'[{2,32932},{1,1651},{3,1100},{4,1100}]','[{47030014,27}]',2),(47030014,15,'[{2,37532},{1,1881},{3,1253},{4,1253}]','[{47030014,30}]',2),(47030014,16,'[{2,42532},{1,2131},{3,1420},{4,1420}]','[{47030014,34}]',2),(47030014,17,'[{2,47932},{1,2401},{3,1600},{4,1600}]','[{47030014,38}]',2),(47030014,18,'[{2,53732},{1,2691},{3,1793},{4,1793}]','[{47030014,42}]',2),(47030014,19,'[{2,59932},{1,3001},{3,2000},{4,2000}]','[{47030014,46}]',2),(47030014,20,'[{2,66532},{1,3331},{3,2220},{4,2220}]','[{47030014,50}]',3),(47030021,1,'[{2,200},{1,10},{3,8},{4,8}]','[{47030021,1}]',1),(47030021,2,'[{2,368},{1,18},{3,15},{4,15}]','[{47030021,2}]',1),(47030021,3,'[{2,558},{1,28},{3,23},{4,23}]','[{47030021,3}]',1),(47030021,4,'[{2,771},{1,39},{3,32},{4,32}]','[{47030021,4}]',1),(47030021,5,'[{2,1006},{1,51},{3,41},{4,41}]','[{47030021,5}]',1),(47030021,6,'[{2,1264},{1,64},{3,51},{4,51}]','[{47030021,6}]',1),(47030021,7,'[{2,1544},{1,78},{3,62},{4,62}]','[{47030021,7}]',1),(47030021,8,'[{2,1847},{1,93},{3,74},{4,74}]','[{47030021,8}]',1),(47030021,9,'[{2,2172},{1,109},{3,87},{4,87}]','[{47030021,9}]',1),(47030021,10,'[{2,2520},{1,126},{3,101},{4,101}]','[{47030021,10}]',2),(47030021,11,'[{2,2890},{1,145},{3,116},{4,116}]','[{47030021,11}]',2),(47030021,12,'[{2,3283},{1,165},{3,132},{4,132}]','[{47030021,12}]',2),(47030021,13,'[{2,3698},{1,186},{3,149},{4,149}]','[{47030021,13}]',2),(47030021,14,'[{2,4136},{1,208},{3,167},{4,167}]','[{47030021,14}]',2),(47030021,15,'[{2,4596},{1,231},{3,185},{4,185}]','[{47030021,15}]',2),(47030021,16,'[{2,5079},{1,255},{3,204},{4,204}]','[{47030021,16}]',2),(47030021,17,'[{2,5584},{1,280},{3,224},{4,224}]','[{47030021,17}]',2),(47030021,18,'[{2,6112},{1,306},{3,245},{4,245}]','[{47030021,18}]',2),(47030021,19,'[{2,6662},{1,334},{3,267},{4,267}]','[{47030021,19}]',2),(47030021,20,'[{2,7235},{1,363},{3,290},{4,290}]','[{47030021,20}]',3),(47030021,21,'[{2,7838},{1,393},{3,314},{4,314}]','[{47030021,22}]',3),(47030021,22,'[{2,8471},{1,425},{3,339},{4,339}]','[{47030021,24}]',3),(47030021,23,'[{2,9134},{1,458},{3,366},{4,366}]','[{47030021,26}]',3),(47030021,24,'[{2,9827},{1,493},{3,394},{4,394}]','[{47030021,28}]',3),(47030021,25,'[{2,10550},{1,529},{3,423},{4,423}]','[{47030021,30}]',3),(47030021,26,'[{2,11303},{1,567},{3,453},{4,453}]','[{47030021,32}]',3),(47030021,27,'[{2,12086},{1,606},{3,484},{4,484}]','[{47030021,34}]',3),(47030021,28,'[{2,12899},{1,647},{3,517},{4,517}]','[{47030021,36}]',3),(47030021,29,'[{2,13742},{1,689},{3,551},{4,551}]','[{47030021,38}]',3),(47030021,30,'[{2,14615},{1,733},{3,586},{4,586}]','[{47030021,40}]',4),(47030021,31,'[{2,15518},{1,778},{3,622},{4,622}]','[{47030021,42}]',4),(47030021,32,'[{2,16451},{1,825},{3,659},{4,659}]','[{47030021,44}]',4),(47030021,33,'[{2,17414},{1,873},{3,698},{4,698}]','[{47030021,46}]',4),(47030021,34,'[{2,18407},{1,923},{3,738},{4,738}]','[{47030021,48}]',4),(47030021,35,'[{2,19430},{1,974},{3,779},{4,779}]','[{47030021,50}]',4),(47030021,36,'[{2,20483},{1,1027},{3,821},{4,821}]','[{47030021,52}]',4),(47030021,37,'[{2,21566},{1,1081},{3,864},{4,864}]','[{47030021,54}]',4),(47030021,38,'[{2,22679},{1,1137},{3,909},{4,909}]','[{47030021,56}]',4),(47030021,39,'[{2,23822},{1,1194},{3,955},{4,955}]','[{47030021,58}]',4),(47030021,40,'[{2,24995},{1,1253},{3,1002},{4,1002}]','[{47030021,60}]',5),(47030022,1,'[{2,400},{1,20},{3,15},{4,15}]','[{47030022,1}]',1),(47030022,2,'[{2,664},{1,33},{3,25},{4,25}]','[{47030022,2}]',1),(47030022,3,'[{2,964},{1,48},{3,36},{4,36}]','[{47030022,3}]',1),(47030022,4,'[{2,1300},{1,65},{3,49},{4,49}]','[{47030022,4}]',1),(47030022,5,'[{2,1672},{1,84},{3,63},{4,63}]','[{47030022,5}]',1),(47030022,6,'[{2,2080},{1,104},{3,78},{4,78}]','[{47030022,6}]',1),(47030022,7,'[{2,2524},{1,126},{3,95},{4,95}]','[{47030022,7}]',1),(47030022,8,'[{2,3004},{1,150},{3,113},{4,113}]','[{47030022,8}]',1),(47030022,9,'[{2,3520},{1,176},{3,132},{4,132}]','[{47030022,9}]',1),(47030022,10,'[{2,4072},{1,204},{3,153},{4,153}]','[{47030022,10}]',2),(47030022,11,'[{2,4660},{1,233},{3,175},{4,175}]','[{47030022,11}]',2),(47030022,12,'[{2,5284},{1,264},{3,198},{4,198}]','[{47030022,12}]',2),(47030022,13,'[{2,5944},{1,297},{3,223},{4,223}]','[{47030022,13}]',2),(47030022,14,'[{2,6640},{1,332},{3,249},{4,249}]','[{47030022,14}]',2),(47030022,15,'[{2,7372},{1,369},{3,276},{4,276}]','[{47030022,15}]',2),(47030022,16,'[{2,8140},{1,407},{3,305},{4,305}]','[{47030022,16}]',2),(47030022,17,'[{2,8944},{1,447},{3,335},{4,335}]','[{47030022,17}]',2),(47030022,18,'[{2,9784},{1,489},{3,367},{4,367}]','[{47030022,18}]',2),(47030022,19,'[{2,10660},{1,533},{3,400},{4,400}]','[{47030022,19}]',2),(47030022,20,'[{2,11572},{1,579},{3,434},{4,434}]','[{47030022,20}]',3),(47030022,21,'[{2,12532},{1,627},{3,470},{4,470}]','[{47030022,22}]',3),(47030022,22,'[{2,13540},{1,677},{3,508},{4,508}]','[{47030022,24}]',3),(47030022,23,'[{2,14596},{1,730},{3,548},{4,548}]','[{47030022,26}]',3),(47030022,24,'[{2,15700},{1,785},{3,589},{4,589}]','[{47030022,28}]',3),(47030022,25,'[{2,16852},{1,843},{3,632},{4,632}]','[{47030022,30}]',3),(47030022,26,'[{2,18052},{1,903},{3,677},{4,677}]','[{47030022,32}]',3),(47030022,27,'[{2,19300},{1,965},{3,724},{4,724}]','[{47030022,34}]',3),(47030022,28,'[{2,20596},{1,1030},{3,773},{4,773}]','[{47030022,36}]',3),(47030022,29,'[{2,21940},{1,1097},{3,823},{4,823}]','[{47030022,38}]',3),(47030022,30,'[{2,23332},{1,1167},{3,875},{4,875}]','[{47030022,40}]',4),(47030022,31,'[{2,24772},{1,1239},{3,929},{4,929}]','[{47030022,42}]',4),(47030022,32,'[{2,26260},{1,1313},{3,985},{4,985}]','[{47030022,44}]',4),(47030022,33,'[{2,27796},{1,1390},{3,1043},{4,1043}]','[{47030022,46}]',4),(47030022,34,'[{2,29380},{1,1469},{3,1102},{4,1102}]','[{47030022,48}]',4),(47030022,35,'[{2,31012},{1,1551},{3,1163},{4,1163}]','[{47030022,50}]',4),(47030022,36,'[{2,32692},{1,1635},{3,1226},{4,1226}]','[{47030022,52}]',4),(47030022,37,'[{2,34420},{1,1721},{3,1291},{4,1291}]','[{47030022,54}]',4),(47030022,38,'[{2,36196},{1,1810},{3,1358},{4,1358}]','[{47030022,56}]',4),(47030022,39,'[{2,38020},{1,1901},{3,1426},{4,1426}]','[{47030022,58}]',4),(47030022,40,'[{2,39892},{1,1995},{3,1496},{4,1496}]','[{47030022,60}]',5),(47030023,1,'[{2,700},{1,35},{3,25},{4,25}]','[{47030023,1}]',1),(47030023,2,'[{2,1282},{1,64},{3,46},{4,46}]','[{47030023,2}]',1),(47030023,3,'[{2,1944},{1,97},{3,70},{4,70}]','[{47030023,3}]',1),(47030023,4,'[{2,2687},{1,134},{3,97},{4,97}]','[{47030023,4}]',1),(47030023,5,'[{2,3511},{1,175},{3,126},{4,126}]','[{47030023,5}]',1),(47030023,6,'[{2,4416},{1,220},{3,158},{4,158}]','[{47030023,6}]',1),(47030023,7,'[{2,5401},{1,269},{3,193},{4,193}]','[{47030023,7}]',1),(47030023,8,'[{2,6467},{1,322},{3,231},{4,231}]','[{47030023,8}]',1),(47030023,9,'[{2,7614},{1,379},{3,272},{4,272}]','[{47030023,9}]',1),(47030023,10,'[{2,8842},{1,440},{3,316},{4,316}]','[{47030023,10}]',2),(47030023,11,'[{2,10150},{1,505},{3,363},{4,363}]','[{47030023,12}]',2),(47030023,12,'[{2,11539},{1,574},{3,413},{4,413}]','[{47030023,14}]',2),(47030023,13,'[{2,13009},{1,648},{3,466},{4,466}]','[{47030023,16}]',2),(47030023,14,'[{2,14560},{1,726},{3,521},{4,521}]','[{47030023,18}]',2),(47030023,15,'[{2,16192},{1,808},{3,579},{4,579}]','[{47030023,20}]',2),(47030023,16,'[{2,17931},{1,895},{3,641},{4,641}]','[{47030023,22}]',2),(47030023,17,'[{2,19778},{1,987},{3,707},{4,707}]','[{47030023,24}]',2),(47030023,18,'[{2,21733},{1,1085},{3,777},{4,777}]','[{47030023,26}]',2),(47030023,19,'[{2,23795},{1,1188},{3,851},{4,851}]','[{47030023,28}]',2),(47030023,20,'[{2,25965},{1,1297},{3,929},{4,929}]','[{47030023,30}]',3),(47030023,21,'[{2,28243},{1,1411},{3,1010},{4,1010}]','[{47030023,33}]',3),(47030023,22,'[{2,30628},{1,1530},{3,1095},{4,1095}]','[{47030023,36}]',3),(47030023,23,'[{2,33121},{1,1655},{3,1184},{4,1184}]','[{47030023,39}]',3),(47030023,24,'[{2,35722},{1,1785},{3,1277},{4,1277}]','[{47030023,42}]',3),(47030023,25,'[{2,38430},{1,1920},{3,1374},{4,1374}]','[{47030023,45}]',3),(47030023,26,'[{2,41246},{1,2061},{3,1475},{4,1475}]','[{47030023,48}]',3),(47030023,27,'[{2,44197},{1,2209},{3,1580},{4,1580}]','[{47030023,51}]',3),(47030023,28,'[{2,47282},{1,2363},{3,1690},{4,1690}]','[{47030023,54}]',3),(47030023,29,'[{2,50502},{1,2524},{3,1805},{4,1805}]','[{47030023,57}]',3),(47030023,30,'[{2,53857},{1,2692},{3,1925},{4,1925}]','[{47030023,60}]',4),(47030024,1,'[{2,1200},{1,60},{3,40},{4,40}]','[{47030024,1}]',1),(47030024,2,'[{2,2133},{1,110},{3,73},{4,73}]','[{47030024,2}]',1),(47030024,3,'[{2,3266},{1,167},{3,111},{4,111}]','[{47030024,3}]',1),(47030024,4,'[{2,4599},{1,234},{3,155},{4,155}]','[{47030024,4}]',1),(47030024,5,'[{2,6132},{1,311},{3,206},{4,206}]','[{47030024,5}]',1),(47030024,6,'[{2,7932},{1,401},{3,266},{4,266}]','[{47030024,7}]',1),(47030024,7,'[{2,9999},{1,504},{3,335},{4,335}]','[{47030024,9}]',1),(47030024,8,'[{2,12332},{1,621},{3,413},{4,413}]','[{47030024,11}]',1),(47030024,9,'[{2,14932},{1,751},{3,500},{4,500}]','[{47030024,13}]',1),(47030024,10,'[{2,17865},{1,898},{3,598},{4,598}]','[{47030024,15}]',2),(47030024,11,'[{2,21132},{1,1061},{3,707},{4,707}]','[{47030024,18}]',2),(47030024,12,'[{2,24732},{1,1241},{3,827},{4,827}]','[{47030024,21}]',2),(47030024,13,'[{2,28665},{1,1438},{3,958},{4,958}]','[{47030024,24}]',2),(47030024,14,'[{2,32932},{1,1651},{3,1100},{4,1100}]','[{47030024,27}]',2),(47030024,15,'[{2,37532},{1,1881},{3,1253},{4,1253}]','[{47030024,30}]',2),(47030024,16,'[{2,42532},{1,2131},{3,1420},{4,1420}]','[{47030024,34}]',2),(47030024,17,'[{2,47932},{1,2401},{3,1600},{4,1600}]','[{47030024,38}]',2),(47030024,18,'[{2,53732},{1,2691},{3,1793},{4,1793}]','[{47030024,42}]',2),(47030024,19,'[{2,59932},{1,3001},{3,2000},{4,2000}]','[{47030024,46}]',2),(47030024,20,'[{2,66532},{1,3331},{3,2220},{4,2220}]','[{47030024,50}]',3),(47030031,1,'[{2,200},{1,10},{3,8},{4,8}]','[{47030031,1}]',1),(47030031,2,'[{2,368},{1,18},{3,15},{4,15}]','[{47030031,2}]',1),(47030031,3,'[{2,558},{1,28},{3,23},{4,23}]','[{47030031,3}]',1),(47030031,4,'[{2,771},{1,39},{3,32},{4,32}]','[{47030031,4}]',1),(47030031,5,'[{2,1006},{1,51},{3,41},{4,41}]','[{47030031,5}]',1),(47030031,6,'[{2,1264},{1,64},{3,51},{4,51}]','[{47030031,6}]',1),(47030031,7,'[{2,1544},{1,78},{3,62},{4,62}]','[{47030031,7}]',1),(47030031,8,'[{2,1847},{1,93},{3,74},{4,74}]','[{47030031,8}]',1),(47030031,9,'[{2,2172},{1,109},{3,87},{4,87}]','[{47030031,9}]',1),(47030031,10,'[{2,2520},{1,126},{3,101},{4,101}]','[{47030031,10}]',2),(47030031,11,'[{2,2890},{1,145},{3,116},{4,116}]','[{47030031,11}]',2),(47030031,12,'[{2,3283},{1,165},{3,132},{4,132}]','[{47030031,12}]',2),(47030031,13,'[{2,3698},{1,186},{3,149},{4,149}]','[{47030031,13}]',2),(47030031,14,'[{2,4136},{1,208},{3,167},{4,167}]','[{47030031,14}]',2),(47030031,15,'[{2,4596},{1,231},{3,185},{4,185}]','[{47030031,15}]',2),(47030031,16,'[{2,5079},{1,255},{3,204},{4,204}]','[{47030031,16}]',2),(47030031,17,'[{2,5584},{1,280},{3,224},{4,224}]','[{47030031,17}]',2),(47030031,18,'[{2,6112},{1,306},{3,245},{4,245}]','[{47030031,18}]',2),(47030031,19,'[{2,6662},{1,334},{3,267},{4,267}]','[{47030031,19}]',2),(47030031,20,'[{2,7235},{1,363},{3,290},{4,290}]','[{47030031,20}]',3),(47030031,21,'[{2,7838},{1,393},{3,314},{4,314}]','[{47030031,22}]',3),(47030031,22,'[{2,8471},{1,425},{3,339},{4,339}]','[{47030031,24}]',3),(47030031,23,'[{2,9134},{1,458},{3,366},{4,366}]','[{47030031,26}]',3),(47030031,24,'[{2,9827},{1,493},{3,394},{4,394}]','[{47030031,28}]',3),(47030031,25,'[{2,10550},{1,529},{3,423},{4,423}]','[{47030031,30}]',3),(47030031,26,'[{2,11303},{1,567},{3,453},{4,453}]','[{47030031,32}]',3),(47030031,27,'[{2,12086},{1,606},{3,484},{4,484}]','[{47030031,34}]',3),(47030031,28,'[{2,12899},{1,647},{3,517},{4,517}]','[{47030031,36}]',3),(47030031,29,'[{2,13742},{1,689},{3,551},{4,551}]','[{47030031,38}]',3),(47030031,30,'[{2,14615},{1,733},{3,586},{4,586}]','[{47030031,40}]',4),(47030031,31,'[{2,15518},{1,778},{3,622},{4,622}]','[{47030031,42}]',4),(47030031,32,'[{2,16451},{1,825},{3,659},{4,659}]','[{47030031,44}]',4),(47030031,33,'[{2,17414},{1,873},{3,698},{4,698}]','[{47030031,46}]',4),(47030031,34,'[{2,18407},{1,923},{3,738},{4,738}]','[{47030031,48}]',4),(47030031,35,'[{2,19430},{1,974},{3,779},{4,779}]','[{47030031,50}]',4),(47030031,36,'[{2,20483},{1,1027},{3,821},{4,821}]','[{47030031,52}]',4),(47030031,37,'[{2,21566},{1,1081},{3,864},{4,864}]','[{47030031,54}]',4),(47030031,38,'[{2,22679},{1,1137},{3,909},{4,909}]','[{47030031,56}]',4),(47030031,39,'[{2,23822},{1,1194},{3,955},{4,955}]','[{47030031,58}]',4),(47030031,40,'[{2,24995},{1,1253},{3,1002},{4,1002}]','[{47030031,60}]',5),(47030032,1,'[{2,400},{1,20},{3,15},{4,15}]','[{47030032,1}]',1),(47030032,2,'[{2,664},{1,33},{3,25},{4,25}]','[{47030032,2}]',1),(47030032,3,'[{2,964},{1,48},{3,36},{4,36}]','[{47030032,3}]',1),(47030032,4,'[{2,1300},{1,65},{3,49},{4,49}]','[{47030032,4}]',1),(47030032,5,'[{2,1672},{1,84},{3,63},{4,63}]','[{47030032,5}]',1),(47030032,6,'[{2,2080},{1,104},{3,78},{4,78}]','[{47030032,6}]',1),(47030032,7,'[{2,2524},{1,126},{3,95},{4,95}]','[{47030032,7}]',1),(47030032,8,'[{2,3004},{1,150},{3,113},{4,113}]','[{47030032,8}]',1),(47030032,9,'[{2,3520},{1,176},{3,132},{4,132}]','[{47030032,9}]',1),(47030032,10,'[{2,4072},{1,204},{3,153},{4,153}]','[{47030032,10}]',2),(47030032,11,'[{2,4660},{1,233},{3,175},{4,175}]','[{47030032,11}]',2),(47030032,12,'[{2,5284},{1,264},{3,198},{4,198}]','[{47030032,12}]',2),(47030032,13,'[{2,5944},{1,297},{3,223},{4,223}]','[{47030032,13}]',2),(47030032,14,'[{2,6640},{1,332},{3,249},{4,249}]','[{47030032,14}]',2),(47030032,15,'[{2,7372},{1,369},{3,276},{4,276}]','[{47030032,15}]',2),(47030032,16,'[{2,8140},{1,407},{3,305},{4,305}]','[{47030032,16}]',2),(47030032,17,'[{2,8944},{1,447},{3,335},{4,335}]','[{47030032,17}]',2),(47030032,18,'[{2,9784},{1,489},{3,367},{4,367}]','[{47030032,18}]',2),(47030032,19,'[{2,10660},{1,533},{3,400},{4,400}]','[{47030032,19}]',2),(47030032,20,'[{2,11572},{1,579},{3,434},{4,434}]','[{47030032,20}]',3),(47030032,21,'[{2,12532},{1,627},{3,470},{4,470}]','[{47030032,22}]',3),(47030032,22,'[{2,13540},{1,677},{3,508},{4,508}]','[{47030032,24}]',3),(47030032,23,'[{2,14596},{1,730},{3,548},{4,548}]','[{47030032,26}]',3),(47030032,24,'[{2,15700},{1,785},{3,589},{4,589}]','[{47030032,28}]',3),(47030032,25,'[{2,16852},{1,843},{3,632},{4,632}]','[{47030032,30}]',3),(47030032,26,'[{2,18052},{1,903},{3,677},{4,677}]','[{47030032,32}]',3),(47030032,27,'[{2,19300},{1,965},{3,724},{4,724}]','[{47030032,34}]',3),(47030032,28,'[{2,20596},{1,1030},{3,773},{4,773}]','[{47030032,36}]',3),(47030032,29,'[{2,21940},{1,1097},{3,823},{4,823}]','[{47030032,38}]',3),(47030032,30,'[{2,23332},{1,1167},{3,875},{4,875}]','[{47030032,40}]',4),(47030032,31,'[{2,24772},{1,1239},{3,929},{4,929}]','[{47030032,42}]',4),(47030032,32,'[{2,26260},{1,1313},{3,985},{4,985}]','[{47030032,44}]',4),(47030032,33,'[{2,27796},{1,1390},{3,1043},{4,1043}]','[{47030032,46}]',4),(47030032,34,'[{2,29380},{1,1469},{3,1102},{4,1102}]','[{47030032,48}]',4),(47030032,35,'[{2,31012},{1,1551},{3,1163},{4,1163}]','[{47030032,50}]',4),(47030032,36,'[{2,32692},{1,1635},{3,1226},{4,1226}]','[{47030032,52}]',4),(47030032,37,'[{2,34420},{1,1721},{3,1291},{4,1291}]','[{47030032,54}]',4),(47030032,38,'[{2,36196},{1,1810},{3,1358},{4,1358}]','[{47030032,56}]',4),(47030032,39,'[{2,38020},{1,1901},{3,1426},{4,1426}]','[{47030032,58}]',4),(47030032,40,'[{2,39892},{1,1995},{3,1496},{4,1496}]','[{47030032,60}]',5),(47030033,1,'[{2,700},{1,35},{3,25},{4,25}]','[{47030033,1}]',1),(47030033,2,'[{2,1282},{1,64},{3,46},{4,46}]','[{47030033,2}]',1),(47030033,3,'[{2,1944},{1,97},{3,70},{4,70}]','[{47030033,3}]',1),(47030033,4,'[{2,2687},{1,134},{3,97},{4,97}]','[{47030033,4}]',1),(47030033,5,'[{2,3511},{1,175},{3,126},{4,126}]','[{47030033,5}]',1),(47030033,6,'[{2,4416},{1,220},{3,158},{4,158}]','[{47030033,6}]',1),(47030033,7,'[{2,5401},{1,269},{3,193},{4,193}]','[{47030033,7}]',1),(47030033,8,'[{2,6467},{1,322},{3,231},{4,231}]','[{47030033,8}]',1),(47030033,9,'[{2,7614},{1,379},{3,272},{4,272}]','[{47030033,9}]',1),(47030033,10,'[{2,8842},{1,440},{3,316},{4,316}]','[{47030033,10}]',2),(47030033,11,'[{2,10150},{1,505},{3,363},{4,363}]','[{47030033,12}]',2),(47030033,12,'[{2,11539},{1,574},{3,413},{4,413}]','[{47030033,14}]',2),(47030033,13,'[{2,13009},{1,648},{3,466},{4,466}]','[{47030033,16}]',2),(47030033,14,'[{2,14560},{1,726},{3,521},{4,521}]','[{47030033,18}]',2),(47030033,15,'[{2,16192},{1,808},{3,579},{4,579}]','[{47030033,20}]',2),(47030033,16,'[{2,17931},{1,895},{3,641},{4,641}]','[{47030033,22}]',2),(47030033,17,'[{2,19778},{1,987},{3,707},{4,707}]','[{47030033,24}]',2),(47030033,18,'[{2,21733},{1,1085},{3,777},{4,777}]','[{47030033,26}]',2),(47030033,19,'[{2,23795},{1,1188},{3,851},{4,851}]','[{47030033,28}]',2),(47030033,20,'[{2,25965},{1,1297},{3,929},{4,929}]','[{47030033,30}]',3),(47030033,21,'[{2,28243},{1,1411},{3,1010},{4,1010}]','[{47030033,33}]',3),(47030033,22,'[{2,30628},{1,1530},{3,1095},{4,1095}]','[{47030033,36}]',3),(47030033,23,'[{2,33121},{1,1655},{3,1184},{4,1184}]','[{47030033,39}]',3),(47030033,24,'[{2,35722},{1,1785},{3,1277},{4,1277}]','[{47030033,42}]',3),(47030033,25,'[{2,38430},{1,1920},{3,1374},{4,1374}]','[{47030033,45}]',3),(47030033,26,'[{2,41246},{1,2061},{3,1475},{4,1475}]','[{47030033,48}]',3),(47030033,27,'[{2,44197},{1,2209},{3,1580},{4,1580}]','[{47030033,51}]',3),(47030033,28,'[{2,47282},{1,2363},{3,1690},{4,1690}]','[{47030033,54}]',3),(47030033,29,'[{2,50502},{1,2524},{3,1805},{4,1805}]','[{47030033,57}]',3),(47030033,30,'[{2,53857},{1,2692},{3,1925},{4,1925}]','[{47030033,60}]',4),(47030034,1,'[{2,1200},{1,60},{3,40},{4,40}]','[{47030034,1}]',1),(47030034,2,'[{2,2133},{1,110},{3,73},{4,73}]','[{47030034,2}]',1),(47030034,3,'[{2,3266},{1,167},{3,111},{4,111}]','[{47030034,3}]',1),(47030034,4,'[{2,4599},{1,234},{3,155},{4,155}]','[{47030034,4}]',1),(47030034,5,'[{2,6132},{1,311},{3,206},{4,206}]','[{47030034,5}]',1),(47030034,6,'[{2,7932},{1,401},{3,266},{4,266}]','[{47030034,7}]',1),(47030034,7,'[{2,9999},{1,504},{3,335},{4,335}]','[{47030034,9}]',1),(47030034,8,'[{2,12332},{1,621},{3,413},{4,413}]','[{47030034,11}]',1),(47030034,9,'[{2,14932},{1,751},{3,500},{4,500}]','[{47030034,13}]',1),(47030034,10,'[{2,17865},{1,898},{3,598},{4,598}]','[{47030034,15}]',2),(47030034,11,'[{2,21132},{1,1061},{3,707},{4,707}]','[{47030034,18}]',2),(47030034,12,'[{2,24732},{1,1241},{3,827},{4,827}]','[{47030034,21}]',2),(47030034,13,'[{2,28665},{1,1438},{3,958},{4,958}]','[{47030034,24}]',2),(47030034,14,'[{2,32932},{1,1651},{3,1100},{4,1100}]','[{47030034,27}]',2),(47030034,15,'[{2,37532},{1,1881},{3,1253},{4,1253}]','[{47030034,30}]',2),(47030034,16,'[{2,42532},{1,2131},{3,1420},{4,1420}]','[{47030034,34}]',2),(47030034,17,'[{2,47932},{1,2401},{3,1600},{4,1600}]','[{47030034,38}]',2),(47030034,18,'[{2,53732},{1,2691},{3,1793},{4,1793}]','[{47030034,42}]',2),(47030034,19,'[{2,59932},{1,3001},{3,2000},{4,2000}]','[{47030034,46}]',2),(47030034,20,'[{2,66532},{1,3331},{3,2220},{4,2220}]','[{47030034,50}]',3),(47030041,1,'[{2,5000},{1,250},{3,200},{4,200},{50,200}]','[{47030041,1}]',1),(47030041,2,'[{2,8000},{1,400},{3,320},{4,320},{50,240}]','[{47030041,2}]',1),(47030041,3,'[{2,11400},{1,570},{3,456},{4,456},{50,280}]','[{47030041,3}]',1),(47030041,4,'[{2,15300},{1,765},{3,612},{4,612},{50,340}]','[{47030041,4}]',1),(47030041,5,'[{2,19700},{1,985},{3,788},{4,788},{50,400}]','[{47030041,5}]',1),(47030041,6,'[{2,24600},{1,1230},{3,984},{4,984},{50,480}]','[{47030041,7}]',1),(47030041,7,'[{2,30100},{1,1505},{3,1204},{4,1204},{50,560}]','[{47030041,9}]',1),(47030041,8,'[{2,36200},{1,1810},{3,1448},{4,1448},{50,660}]','[{47030041,11}]',1),(47030041,9,'[{2,43000},{1,2150},{3,1720},{4,1720},{50,760}]','[{47030041,13}]',1),(47030041,10,'[{2,50500},{1,2525},{3,2020},{4,2020},{50,880}]','[{47030041,15}]',2),(47030041,11,'[{2,58700},{1,2935},{3,2348},{4,2348},{50,1000}]','[{47030041,18}]',2),(47030041,12,'[{2,67700},{1,3385},{3,2708},{4,2708},{50,1140}]','[{47030041,21}]',2),(47030041,13,'[{2,77500},{1,3875},{3,3100},{4,3100},{50,1280}]','[{47030041,24}]',2),(47030041,14,'[{2,88200},{1,4410},{3,3528},{4,3528},{50,1440}]','[{47030041,27}]',2),(47030041,15,'[{2,99900},{1,4995},{3,3996},{4,3996},{50,1600}]','[{47030041,30}]',2),(47040011,1,'[{2,200},{1,10},{3,8},{4,8}]','[{47040011,1}]',1),(47040011,2,'[{2,368},{1,18},{3,15},{4,15}]','[{47040011,2}]',1),(47040011,3,'[{2,558},{1,28},{3,23},{4,23}]','[{47040011,3}]',1),(47040011,4,'[{2,771},{1,39},{3,32},{4,32}]','[{47040011,4}]',1),(47040011,5,'[{2,1006},{1,51},{3,41},{4,41}]','[{47040011,5}]',1),(47040011,6,'[{2,1264},{1,64},{3,51},{4,51}]','[{47040011,6}]',1),(47040011,7,'[{2,1544},{1,78},{3,62},{4,62}]','[{47040011,7}]',1),(47040011,8,'[{2,1847},{1,93},{3,74},{4,74}]','[{47040011,8}]',1),(47040011,9,'[{2,2172},{1,109},{3,87},{4,87}]','[{47040011,9}]',1),(47040011,10,'[{2,2520},{1,126},{3,101},{4,101}]','[{47040011,10}]',2),(47040011,11,'[{2,2890},{1,145},{3,116},{4,116}]','[{47040011,11}]',2),(47040011,12,'[{2,3283},{1,165},{3,132},{4,132}]','[{47040011,12}]',2),(47040011,13,'[{2,3698},{1,186},{3,149},{4,149}]','[{47040011,13}]',2),(47040011,14,'[{2,4136},{1,208},{3,167},{4,167}]','[{47040011,14}]',2),(47040011,15,'[{2,4596},{1,231},{3,185},{4,185}]','[{47040011,15}]',2),(47040011,16,'[{2,5079},{1,255},{3,204},{4,204}]','[{47040011,16}]',2),(47040011,17,'[{2,5584},{1,280},{3,224},{4,224}]','[{47040011,17}]',2),(47040011,18,'[{2,6112},{1,306},{3,245},{4,245}]','[{47040011,18}]',2),(47040011,19,'[{2,6662},{1,334},{3,267},{4,267}]','[{47040011,19}]',2),(47040011,20,'[{2,7235},{1,363},{3,290},{4,290}]','[{47040011,20}]',3),(47040011,21,'[{2,7838},{1,393},{3,314},{4,314}]','[{47040011,22}]',3),(47040011,22,'[{2,8471},{1,425},{3,339},{4,339}]','[{47040011,24}]',3),(47040011,23,'[{2,9134},{1,458},{3,366},{4,366}]','[{47040011,26}]',3),(47040011,24,'[{2,9827},{1,493},{3,394},{4,394}]','[{47040011,28}]',3),(47040011,25,'[{2,10550},{1,529},{3,423},{4,423}]','[{47040011,30}]',3),(47040011,26,'[{2,11303},{1,567},{3,453},{4,453}]','[{47040011,32}]',3),(47040011,27,'[{2,12086},{1,606},{3,484},{4,484}]','[{47040011,34}]',3),(47040011,28,'[{2,12899},{1,647},{3,517},{4,517}]','[{47040011,36}]',3),(47040011,29,'[{2,13742},{1,689},{3,551},{4,551}]','[{47040011,38}]',3),(47040011,30,'[{2,14615},{1,733},{3,586},{4,586}]','[{47040011,40}]',4),(47040011,31,'[{2,15518},{1,778},{3,622},{4,622}]','[{47040011,42}]',4),(47040011,32,'[{2,16451},{1,825},{3,659},{4,659}]','[{47040011,44}]',4),(47040011,33,'[{2,17414},{1,873},{3,698},{4,698}]','[{47040011,46}]',4),(47040011,34,'[{2,18407},{1,923},{3,738},{4,738}]','[{47040011,48}]',4),(47040011,35,'[{2,19430},{1,974},{3,779},{4,779}]','[{47040011,50}]',4),(47040011,36,'[{2,20483},{1,1027},{3,821},{4,821}]','[{47040011,52}]',4),(47040011,37,'[{2,21566},{1,1081},{3,864},{4,864}]','[{47040011,54}]',4),(47040011,38,'[{2,22679},{1,1137},{3,909},{4,909}]','[{47040011,56}]',4),(47040011,39,'[{2,23822},{1,1194},{3,955},{4,955}]','[{47040011,58}]',4),(47040011,40,'[{2,24995},{1,1253},{3,1002},{4,1002}]','[{47040011,60}]',5),(47040012,1,'[{2,400},{1,20},{3,15},{4,15}]','[{47040012,1}]',1),(47040012,2,'[{2,664},{1,33},{3,25},{4,25}]','[{47040012,2}]',1),(47040012,3,'[{2,964},{1,48},{3,36},{4,36}]','[{47040012,3}]',1),(47040012,4,'[{2,1300},{1,65},{3,49},{4,49}]','[{47040012,4}]',1),(47040012,5,'[{2,1672},{1,84},{3,63},{4,63}]','[{47040012,5}]',1),(47040012,6,'[{2,2080},{1,104},{3,78},{4,78}]','[{47040012,6}]',1),(47040012,7,'[{2,2524},{1,126},{3,95},{4,95}]','[{47040012,7}]',1),(47040012,8,'[{2,3004},{1,150},{3,113},{4,113}]','[{47040012,8}]',1),(47040012,9,'[{2,3520},{1,176},{3,132},{4,132}]','[{47040012,9}]',1),(47040012,10,'[{2,4072},{1,204},{3,153},{4,153}]','[{47040012,10}]',2),(47040012,11,'[{2,4660},{1,233},{3,175},{4,175}]','[{47040012,11}]',2),(47040012,12,'[{2,5284},{1,264},{3,198},{4,198}]','[{47040012,12}]',2),(47040012,13,'[{2,5944},{1,297},{3,223},{4,223}]','[{47040012,13}]',2),(47040012,14,'[{2,6640},{1,332},{3,249},{4,249}]','[{47040012,14}]',2),(47040012,15,'[{2,7372},{1,369},{3,276},{4,276}]','[{47040012,15}]',2),(47040012,16,'[{2,8140},{1,407},{3,305},{4,305}]','[{47040012,16}]',2),(47040012,17,'[{2,8944},{1,447},{3,335},{4,335}]','[{47040012,17}]',2),(47040012,18,'[{2,9784},{1,489},{3,367},{4,367}]','[{47040012,18}]',2),(47040012,19,'[{2,10660},{1,533},{3,400},{4,400}]','[{47040012,19}]',2),(47040012,20,'[{2,11572},{1,579},{3,434},{4,434}]','[{47040012,20}]',3),(47040012,21,'[{2,12532},{1,627},{3,470},{4,470}]','[{47040012,22}]',3),(47040012,22,'[{2,13540},{1,677},{3,508},{4,508}]','[{47040012,24}]',3),(47040012,23,'[{2,14596},{1,730},{3,548},{4,548}]','[{47040012,26}]',3),(47040012,24,'[{2,15700},{1,785},{3,589},{4,589}]','[{47040012,28}]',3),(47040012,25,'[{2,16852},{1,843},{3,632},{4,632}]','[{47040012,30}]',3),(47040012,26,'[{2,18052},{1,903},{3,677},{4,677}]','[{47040012,32}]',3),(47040012,27,'[{2,19300},{1,965},{3,724},{4,724}]','[{47040012,34}]',3),(47040012,28,'[{2,20596},{1,1030},{3,773},{4,773}]','[{47040012,36}]',3),(47040012,29,'[{2,21940},{1,1097},{3,823},{4,823}]','[{47040012,38}]',3),(47040012,30,'[{2,23332},{1,1167},{3,875},{4,875}]','[{47040012,40}]',4),(47040012,31,'[{2,24772},{1,1239},{3,929},{4,929}]','[{47040012,42}]',4),(47040012,32,'[{2,26260},{1,1313},{3,985},{4,985}]','[{47040012,44}]',4),(47040012,33,'[{2,27796},{1,1390},{3,1043},{4,1043}]','[{47040012,46}]',4),(47040012,34,'[{2,29380},{1,1469},{3,1102},{4,1102}]','[{47040012,48}]',4),(47040012,35,'[{2,31012},{1,1551},{3,1163},{4,1163}]','[{47040012,50}]',4),(47040012,36,'[{2,32692},{1,1635},{3,1226},{4,1226}]','[{47040012,52}]',4),(47040012,37,'[{2,34420},{1,1721},{3,1291},{4,1291}]','[{47040012,54}]',4),(47040012,38,'[{2,36196},{1,1810},{3,1358},{4,1358}]','[{47040012,56}]',4),(47040012,39,'[{2,38020},{1,1901},{3,1426},{4,1426}]','[{47040012,58}]',4),(47040012,40,'[{2,39892},{1,1995},{3,1496},{4,1496}]','[{47040012,60}]',5),(47040013,1,'[{2,700},{1,35},{3,25},{4,25}]','[{47040013,1}]',1),(47040013,2,'[{2,1282},{1,64},{3,46},{4,46}]','[{47040013,2}]',1),(47040013,3,'[{2,1944},{1,97},{3,70},{4,70}]','[{47040013,3}]',1),(47040013,4,'[{2,2687},{1,134},{3,97},{4,97}]','[{47040013,4}]',1),(47040013,5,'[{2,3511},{1,175},{3,126},{4,126}]','[{47040013,5}]',1),(47040013,6,'[{2,4416},{1,220},{3,158},{4,158}]','[{47040013,6}]',1),(47040013,7,'[{2,5401},{1,269},{3,193},{4,193}]','[{47040013,7}]',1),(47040013,8,'[{2,6467},{1,322},{3,231},{4,231}]','[{47040013,8}]',1),(47040013,9,'[{2,7614},{1,379},{3,272},{4,272}]','[{47040013,9}]',1),(47040013,10,'[{2,8842},{1,440},{3,316},{4,316}]','[{47040013,10}]',2),(47040013,11,'[{2,10150},{1,505},{3,363},{4,363}]','[{47040013,12}]',2),(47040013,12,'[{2,11539},{1,574},{3,413},{4,413}]','[{47040013,14}]',2),(47040013,13,'[{2,13009},{1,648},{3,466},{4,466}]','[{47040013,16}]',2),(47040013,14,'[{2,14560},{1,726},{3,521},{4,521}]','[{47040013,18}]',2),(47040013,15,'[{2,16192},{1,808},{3,579},{4,579}]','[{47040013,20}]',2),(47040013,16,'[{2,17931},{1,895},{3,641},{4,641}]','[{47040013,22}]',2),(47040013,17,'[{2,19778},{1,987},{3,707},{4,707}]','[{47040013,24}]',2),(47040013,18,'[{2,21733},{1,1085},{3,777},{4,777}]','[{47040013,26}]',2),(47040013,19,'[{2,23795},{1,1188},{3,851},{4,851}]','[{47040013,28}]',2),(47040013,20,'[{2,25965},{1,1297},{3,929},{4,929}]','[{47040013,30}]',3),(47040013,21,'[{2,28243},{1,1411},{3,1010},{4,1010}]','[{47040013,33}]',3),(47040013,22,'[{2,30628},{1,1530},{3,1095},{4,1095}]','[{47040013,36}]',3),(47040013,23,'[{2,33121},{1,1655},{3,1184},{4,1184}]','[{47040013,39}]',3),(47040013,24,'[{2,35722},{1,1785},{3,1277},{4,1277}]','[{47040013,42}]',3),(47040013,25,'[{2,38430},{1,1920},{3,1374},{4,1374}]','[{47040013,45}]',3),(47040013,26,'[{2,41246},{1,2061},{3,1475},{4,1475}]','[{47040013,48}]',3),(47040013,27,'[{2,44197},{1,2209},{3,1580},{4,1580}]','[{47040013,51}]',3),(47040013,28,'[{2,47282},{1,2363},{3,1690},{4,1690}]','[{47040013,54}]',3),(47040013,29,'[{2,50502},{1,2524},{3,1805},{4,1805}]','[{47040013,57}]',3),(47040013,30,'[{2,53857},{1,2692},{3,1925},{4,1925}]','[{47040013,60}]',4),(47040014,1,'[{2,1200},{1,60},{3,40},{4,40}]','[{47040014,1}]',1),(47040014,2,'[{2,2133},{1,110},{3,73},{4,73}]','[{47040014,2}]',1),(47040014,3,'[{2,3266},{1,167},{3,111},{4,111}]','[{47040014,3}]',1),(47040014,4,'[{2,4599},{1,234},{3,155},{4,155}]','[{47040014,4}]',1),(47040014,5,'[{2,6132},{1,311},{3,206},{4,206}]','[{47040014,5}]',1),(47040014,6,'[{2,7932},{1,401},{3,266},{4,266}]','[{47040014,7}]',1),(47040014,7,'[{2,9999},{1,504},{3,335},{4,335}]','[{47040014,9}]',1),(47040014,8,'[{2,12332},{1,621},{3,413},{4,413}]','[{47040014,11}]',1),(47040014,9,'[{2,14932},{1,751},{3,500},{4,500}]','[{47040014,13}]',1),(47040014,10,'[{2,17865},{1,898},{3,598},{4,598}]','[{47040014,15}]',2),(47040014,11,'[{2,21132},{1,1061},{3,707},{4,707}]','[{47040014,18}]',2),(47040014,12,'[{2,24732},{1,1241},{3,827},{4,827}]','[{47040014,21}]',2),(47040014,13,'[{2,28665},{1,1438},{3,958},{4,958}]','[{47040014,24}]',2),(47040014,14,'[{2,32932},{1,1651},{3,1100},{4,1100}]','[{47040014,27}]',2),(47040014,15,'[{2,37532},{1,1881},{3,1253},{4,1253}]','[{47040014,30}]',2),(47040014,16,'[{2,42532},{1,2131},{3,1420},{4,1420}]','[{47040014,34}]',2),(47040014,17,'[{2,47932},{1,2401},{3,1600},{4,1600}]','[{47040014,38}]',2),(47040014,18,'[{2,53732},{1,2691},{3,1793},{4,1793}]','[{47040014,42}]',2),(47040014,19,'[{2,59932},{1,3001},{3,2000},{4,2000}]','[{47040014,46}]',2),(47040014,20,'[{2,66532},{1,3331},{3,2220},{4,2220}]','[{47040014,50}]',3),(47040021,1,'[{2,200},{1,10},{3,8},{4,8}]','[{47040021,1}]',1),(47040021,2,'[{2,368},{1,18},{3,15},{4,15}]','[{47040021,2}]',1),(47040021,3,'[{2,558},{1,28},{3,23},{4,23}]','[{47040021,3}]',1),(47040021,4,'[{2,771},{1,39},{3,32},{4,32}]','[{47040021,4}]',1),(47040021,5,'[{2,1006},{1,51},{3,41},{4,41}]','[{47040021,5}]',1),(47040021,6,'[{2,1264},{1,64},{3,51},{4,51}]','[{47040021,6}]',1),(47040021,7,'[{2,1544},{1,78},{3,62},{4,62}]','[{47040021,7}]',1),(47040021,8,'[{2,1847},{1,93},{3,74},{4,74}]','[{47040021,8}]',1),(47040021,9,'[{2,2172},{1,109},{3,87},{4,87}]','[{47040021,9}]',1),(47040021,10,'[{2,2520},{1,126},{3,101},{4,101}]','[{47040021,10}]',2),(47040021,11,'[{2,2890},{1,145},{3,116},{4,116}]','[{47040021,11}]',2),(47040021,12,'[{2,3283},{1,165},{3,132},{4,132}]','[{47040021,12}]',2),(47040021,13,'[{2,3698},{1,186},{3,149},{4,149}]','[{47040021,13}]',2),(47040021,14,'[{2,4136},{1,208},{3,167},{4,167}]','[{47040021,14}]',2),(47040021,15,'[{2,4596},{1,231},{3,185},{4,185}]','[{47040021,15}]',2),(47040021,16,'[{2,5079},{1,255},{3,204},{4,204}]','[{47040021,16}]',2),(47040021,17,'[{2,5584},{1,280},{3,224},{4,224}]','[{47040021,17}]',2),(47040021,18,'[{2,6112},{1,306},{3,245},{4,245}]','[{47040021,18}]',2),(47040021,19,'[{2,6662},{1,334},{3,267},{4,267}]','[{47040021,19}]',2),(47040021,20,'[{2,7235},{1,363},{3,290},{4,290}]','[{47040021,20}]',3),(47040021,21,'[{2,7838},{1,393},{3,314},{4,314}]','[{47040021,22}]',3),(47040021,22,'[{2,8471},{1,425},{3,339},{4,339}]','[{47040021,24}]',3),(47040021,23,'[{2,9134},{1,458},{3,366},{4,366}]','[{47040021,26}]',3),(47040021,24,'[{2,9827},{1,493},{3,394},{4,394}]','[{47040021,28}]',3),(47040021,25,'[{2,10550},{1,529},{3,423},{4,423}]','[{47040021,30}]',3),(47040021,26,'[{2,11303},{1,567},{3,453},{4,453}]','[{47040021,32}]',3),(47040021,27,'[{2,12086},{1,606},{3,484},{4,484}]','[{47040021,34}]',3),(47040021,28,'[{2,12899},{1,647},{3,517},{4,517}]','[{47040021,36}]',3),(47040021,29,'[{2,13742},{1,689},{3,551},{4,551}]','[{47040021,38}]',3),(47040021,30,'[{2,14615},{1,733},{3,586},{4,586}]','[{47040021,40}]',4),(47040021,31,'[{2,15518},{1,778},{3,622},{4,622}]','[{47040021,42}]',4),(47040021,32,'[{2,16451},{1,825},{3,659},{4,659}]','[{47040021,44}]',4),(47040021,33,'[{2,17414},{1,873},{3,698},{4,698}]','[{47040021,46}]',4),(47040021,34,'[{2,18407},{1,923},{3,738},{4,738}]','[{47040021,48}]',4),(47040021,35,'[{2,19430},{1,974},{3,779},{4,779}]','[{47040021,50}]',4),(47040021,36,'[{2,20483},{1,1027},{3,821},{4,821}]','[{47040021,52}]',4),(47040021,37,'[{2,21566},{1,1081},{3,864},{4,864}]','[{47040021,54}]',4),(47040021,38,'[{2,22679},{1,1137},{3,909},{4,909}]','[{47040021,56}]',4),(47040021,39,'[{2,23822},{1,1194},{3,955},{4,955}]','[{47040021,58}]',4),(47040021,40,'[{2,24995},{1,1253},{3,1002},{4,1002}]','[{47040021,60}]',5),(47040022,1,'[{2,400},{1,20},{3,15},{4,15}]','[{47040022,1}]',1),(47040022,2,'[{2,664},{1,33},{3,25},{4,25}]','[{47040022,2}]',1),(47040022,3,'[{2,964},{1,48},{3,36},{4,36}]','[{47040022,3}]',1),(47040022,4,'[{2,1300},{1,65},{3,49},{4,49}]','[{47040022,4}]',1),(47040022,5,'[{2,1672},{1,84},{3,63},{4,63}]','[{47040022,5}]',1),(47040022,6,'[{2,2080},{1,104},{3,78},{4,78}]','[{47040022,6}]',1),(47040022,7,'[{2,2524},{1,126},{3,95},{4,95}]','[{47040022,7}]',1),(47040022,8,'[{2,3004},{1,150},{3,113},{4,113}]','[{47040022,8}]',1),(47040022,9,'[{2,3520},{1,176},{3,132},{4,132}]','[{47040022,9}]',1),(47040022,10,'[{2,4072},{1,204},{3,153},{4,153}]','[{47040022,10}]',2),(47040022,11,'[{2,4660},{1,233},{3,175},{4,175}]','[{47040022,11}]',2),(47040022,12,'[{2,5284},{1,264},{3,198},{4,198}]','[{47040022,12}]',2),(47040022,13,'[{2,5944},{1,297},{3,223},{4,223}]','[{47040022,13}]',2),(47040022,14,'[{2,6640},{1,332},{3,249},{4,249}]','[{47040022,14}]',2),(47040022,15,'[{2,7372},{1,369},{3,276},{4,276}]','[{47040022,15}]',2),(47040022,16,'[{2,8140},{1,407},{3,305},{4,305}]','[{47040022,16}]',2),(47040022,17,'[{2,8944},{1,447},{3,335},{4,335}]','[{47040022,17}]',2),(47040022,18,'[{2,9784},{1,489},{3,367},{4,367}]','[{47040022,18}]',2),(47040022,19,'[{2,10660},{1,533},{3,400},{4,400}]','[{47040022,19}]',2),(47040022,20,'[{2,11572},{1,579},{3,434},{4,434}]','[{47040022,20}]',3),(47040022,21,'[{2,12532},{1,627},{3,470},{4,470}]','[{47040022,22}]',3),(47040022,22,'[{2,13540},{1,677},{3,508},{4,508}]','[{47040022,24}]',3),(47040022,23,'[{2,14596},{1,730},{3,548},{4,548}]','[{47040022,26}]',3),(47040022,24,'[{2,15700},{1,785},{3,589},{4,589}]','[{47040022,28}]',3),(47040022,25,'[{2,16852},{1,843},{3,632},{4,632}]','[{47040022,30}]',3),(47040022,26,'[{2,18052},{1,903},{3,677},{4,677}]','[{47040022,32}]',3),(47040022,27,'[{2,19300},{1,965},{3,724},{4,724}]','[{47040022,34}]',3),(47040022,28,'[{2,20596},{1,1030},{3,773},{4,773}]','[{47040022,36}]',3),(47040022,29,'[{2,21940},{1,1097},{3,823},{4,823}]','[{47040022,38}]',3),(47040022,30,'[{2,23332},{1,1167},{3,875},{4,875}]','[{47040022,40}]',4),(47040022,31,'[{2,24772},{1,1239},{3,929},{4,929}]','[{47040022,42}]',4),(47040022,32,'[{2,26260},{1,1313},{3,985},{4,985}]','[{47040022,44}]',4),(47040022,33,'[{2,27796},{1,1390},{3,1043},{4,1043}]','[{47040022,46}]',4),(47040022,34,'[{2,29380},{1,1469},{3,1102},{4,1102}]','[{47040022,48}]',4),(47040022,35,'[{2,31012},{1,1551},{3,1163},{4,1163}]','[{47040022,50}]',4),(47040022,36,'[{2,32692},{1,1635},{3,1226},{4,1226}]','[{47040022,52}]',4),(47040022,37,'[{2,34420},{1,1721},{3,1291},{4,1291}]','[{47040022,54}]',4),(47040022,38,'[{2,36196},{1,1810},{3,1358},{4,1358}]','[{47040022,56}]',4),(47040022,39,'[{2,38020},{1,1901},{3,1426},{4,1426}]','[{47040022,58}]',4),(47040022,40,'[{2,39892},{1,1995},{3,1496},{4,1496}]','[{47040022,60}]',5),(47040023,1,'[{2,700},{1,35},{3,25},{4,25}]','[{47040023,1}]',1),(47040023,2,'[{2,1282},{1,64},{3,46},{4,46}]','[{47040023,2}]',1),(47040023,3,'[{2,1944},{1,97},{3,70},{4,70}]','[{47040023,3}]',1),(47040023,4,'[{2,2687},{1,134},{3,97},{4,97}]','[{47040023,4}]',1),(47040023,5,'[{2,3511},{1,175},{3,126},{4,126}]','[{47040023,5}]',1),(47040023,6,'[{2,4416},{1,220},{3,158},{4,158}]','[{47040023,6}]',1),(47040023,7,'[{2,5401},{1,269},{3,193},{4,193}]','[{47040023,7}]',1),(47040023,8,'[{2,6467},{1,322},{3,231},{4,231}]','[{47040023,8}]',1),(47040023,9,'[{2,7614},{1,379},{3,272},{4,272}]','[{47040023,9}]',1),(47040023,10,'[{2,8842},{1,440},{3,316},{4,316}]','[{47040023,10}]',2),(47040023,11,'[{2,10150},{1,505},{3,363},{4,363}]','[{47040023,12}]',2),(47040023,12,'[{2,11539},{1,574},{3,413},{4,413}]','[{47040023,14}]',2),(47040023,13,'[{2,13009},{1,648},{3,466},{4,466}]','[{47040023,16}]',2),(47040023,14,'[{2,14560},{1,726},{3,521},{4,521}]','[{47040023,18}]',2),(47040023,15,'[{2,16192},{1,808},{3,579},{4,579}]','[{47040023,20}]',2),(47040023,16,'[{2,17931},{1,895},{3,641},{4,641}]','[{47040023,22}]',2),(47040023,17,'[{2,19778},{1,987},{3,707},{4,707}]','[{47040023,24}]',2),(47040023,18,'[{2,21733},{1,1085},{3,777},{4,777}]','[{47040023,26}]',2),(47040023,19,'[{2,23795},{1,1188},{3,851},{4,851}]','[{47040023,28}]',2),(47040023,20,'[{2,25965},{1,1297},{3,929},{4,929}]','[{47040023,30}]',3),(47040023,21,'[{2,28243},{1,1411},{3,1010},{4,1010}]','[{47040023,33}]',3),(47040023,22,'[{2,30628},{1,1530},{3,1095},{4,1095}]','[{47040023,36}]',3),(47040023,23,'[{2,33121},{1,1655},{3,1184},{4,1184}]','[{47040023,39}]',3),(47040023,24,'[{2,35722},{1,1785},{3,1277},{4,1277}]','[{47040023,42}]',3),(47040023,25,'[{2,38430},{1,1920},{3,1374},{4,1374}]','[{47040023,45}]',3),(47040023,26,'[{2,41246},{1,2061},{3,1475},{4,1475}]','[{47040023,48}]',3),(47040023,27,'[{2,44197},{1,2209},{3,1580},{4,1580}]','[{47040023,51}]',3),(47040023,28,'[{2,47282},{1,2363},{3,1690},{4,1690}]','[{47040023,54}]',3),(47040023,29,'[{2,50502},{1,2524},{3,1805},{4,1805}]','[{47040023,57}]',3),(47040023,30,'[{2,53857},{1,2692},{3,1925},{4,1925}]','[{47040023,60}]',4),(47040024,1,'[{2,1200},{1,60},{3,40},{4,40}]','[{47040024,1}]',1),(47040024,2,'[{2,2133},{1,110},{3,73},{4,73}]','[{47040024,2}]',1),(47040024,3,'[{2,3266},{1,167},{3,111},{4,111}]','[{47040024,3}]',1),(47040024,4,'[{2,4599},{1,234},{3,155},{4,155}]','[{47040024,4}]',1),(47040024,5,'[{2,6132},{1,311},{3,206},{4,206}]','[{47040024,5}]',1),(47040024,6,'[{2,7932},{1,401},{3,266},{4,266}]','[{47040024,7}]',1),(47040024,7,'[{2,9999},{1,504},{3,335},{4,335}]','[{47040024,9}]',1),(47040024,8,'[{2,12332},{1,621},{3,413},{4,413}]','[{47040024,11}]',1),(47040024,9,'[{2,14932},{1,751},{3,500},{4,500}]','[{47040024,13}]',1),(47040024,10,'[{2,17865},{1,898},{3,598},{4,598}]','[{47040024,15}]',2),(47040024,11,'[{2,21132},{1,1061},{3,707},{4,707}]','[{47040024,18}]',2),(47040024,12,'[{2,24732},{1,1241},{3,827},{4,827}]','[{47040024,21}]',2),(47040024,13,'[{2,28665},{1,1438},{3,958},{4,958}]','[{47040024,24}]',2),(47040024,14,'[{2,32932},{1,1651},{3,1100},{4,1100}]','[{47040024,27}]',2),(47040024,15,'[{2,37532},{1,1881},{3,1253},{4,1253}]','[{47040024,30}]',2),(47040024,16,'[{2,42532},{1,2131},{3,1420},{4,1420}]','[{47040024,34}]',2),(47040024,17,'[{2,47932},{1,2401},{3,1600},{4,1600}]','[{47040024,38}]',2),(47040024,18,'[{2,53732},{1,2691},{3,1793},{4,1793}]','[{47040024,42}]',2),(47040024,19,'[{2,59932},{1,3001},{3,2000},{4,2000}]','[{47040024,46}]',2),(47040024,20,'[{2,66532},{1,3331},{3,2220},{4,2220}]','[{47040024,50}]',3),(47040031,1,'[{2,200},{1,10},{3,8},{4,8}]','[{47040031,1}]',1),(47040031,2,'[{2,368},{1,18},{3,15},{4,15}]','[{47040031,2}]',1),(47040031,3,'[{2,558},{1,28},{3,23},{4,23}]','[{47040031,3}]',1),(47040031,4,'[{2,771},{1,39},{3,32},{4,32}]','[{47040031,4}]',1),(47040031,5,'[{2,1006},{1,51},{3,41},{4,41}]','[{47040031,5}]',1),(47040031,6,'[{2,1264},{1,64},{3,51},{4,51}]','[{47040031,6}]',1),(47040031,7,'[{2,1544},{1,78},{3,62},{4,62}]','[{47040031,7}]',1),(47040031,8,'[{2,1847},{1,93},{3,74},{4,74}]','[{47040031,8}]',1),(47040031,9,'[{2,2172},{1,109},{3,87},{4,87}]','[{47040031,9}]',1),(47040031,10,'[{2,2520},{1,126},{3,101},{4,101}]','[{47040031,10}]',2),(47040031,11,'[{2,2890},{1,145},{3,116},{4,116}]','[{47040031,11}]',2),(47040031,12,'[{2,3283},{1,165},{3,132},{4,132}]','[{47040031,12}]',2),(47040031,13,'[{2,3698},{1,186},{3,149},{4,149}]','[{47040031,13}]',2),(47040031,14,'[{2,4136},{1,208},{3,167},{4,167}]','[{47040031,14}]',2),(47040031,15,'[{2,4596},{1,231},{3,185},{4,185}]','[{47040031,15}]',2),(47040031,16,'[{2,5079},{1,255},{3,204},{4,204}]','[{47040031,16}]',2),(47040031,17,'[{2,5584},{1,280},{3,224},{4,224}]','[{47040031,17}]',2),(47040031,18,'[{2,6112},{1,306},{3,245},{4,245}]','[{47040031,18}]',2),(47040031,19,'[{2,6662},{1,334},{3,267},{4,267}]','[{47040031,19}]',2),(47040031,20,'[{2,7235},{1,363},{3,290},{4,290}]','[{47040031,20}]',3),(47040031,21,'[{2,7838},{1,393},{3,314},{4,314}]','[{47040031,22}]',3),(47040031,22,'[{2,8471},{1,425},{3,339},{4,339}]','[{47040031,24}]',3),(47040031,23,'[{2,9134},{1,458},{3,366},{4,366}]','[{47040031,26}]',3),(47040031,24,'[{2,9827},{1,493},{3,394},{4,394}]','[{47040031,28}]',3),(47040031,25,'[{2,10550},{1,529},{3,423},{4,423}]','[{47040031,30}]',3),(47040031,26,'[{2,11303},{1,567},{3,453},{4,453}]','[{47040031,32}]',3),(47040031,27,'[{2,12086},{1,606},{3,484},{4,484}]','[{47040031,34}]',3),(47040031,28,'[{2,12899},{1,647},{3,517},{4,517}]','[{47040031,36}]',3),(47040031,29,'[{2,13742},{1,689},{3,551},{4,551}]','[{47040031,38}]',3),(47040031,30,'[{2,14615},{1,733},{3,586},{4,586}]','[{47040031,40}]',4),(47040031,31,'[{2,15518},{1,778},{3,622},{4,622}]','[{47040031,42}]',4),(47040031,32,'[{2,16451},{1,825},{3,659},{4,659}]','[{47040031,44}]',4),(47040031,33,'[{2,17414},{1,873},{3,698},{4,698}]','[{47040031,46}]',4),(47040031,34,'[{2,18407},{1,923},{3,738},{4,738}]','[{47040031,48}]',4),(47040031,35,'[{2,19430},{1,974},{3,779},{4,779}]','[{47040031,50}]',4),(47040031,36,'[{2,20483},{1,1027},{3,821},{4,821}]','[{47040031,52}]',4),(47040031,37,'[{2,21566},{1,1081},{3,864},{4,864}]','[{47040031,54}]',4),(47040031,38,'[{2,22679},{1,1137},{3,909},{4,909}]','[{47040031,56}]',4),(47040031,39,'[{2,23822},{1,1194},{3,955},{4,955}]','[{47040031,58}]',4),(47040031,40,'[{2,24995},{1,1253},{3,1002},{4,1002}]','[{47040031,60}]',5),(47040032,1,'[{2,400},{1,20},{3,15},{4,15}]','[{47040032,1}]',1),(47040032,2,'[{2,664},{1,33},{3,25},{4,25}]','[{47040032,2}]',1),(47040032,3,'[{2,964},{1,48},{3,36},{4,36}]','[{47040032,3}]',1),(47040032,4,'[{2,1300},{1,65},{3,49},{4,49}]','[{47040032,4}]',1),(47040032,5,'[{2,1672},{1,84},{3,63},{4,63}]','[{47040032,5}]',1),(47040032,6,'[{2,2080},{1,104},{3,78},{4,78}]','[{47040032,6}]',1),(47040032,7,'[{2,2524},{1,126},{3,95},{4,95}]','[{47040032,7}]',1),(47040032,8,'[{2,3004},{1,150},{3,113},{4,113}]','[{47040032,8}]',1),(47040032,9,'[{2,3520},{1,176},{3,132},{4,132}]','[{47040032,9}]',1),(47040032,10,'[{2,4072},{1,204},{3,153},{4,153}]','[{47040032,10}]',2),(47040032,11,'[{2,4660},{1,233},{3,175},{4,175}]','[{47040032,11}]',2),(47040032,12,'[{2,5284},{1,264},{3,198},{4,198}]','[{47040032,12}]',2),(47040032,13,'[{2,5944},{1,297},{3,223},{4,223}]','[{47040032,13}]',2),(47040032,14,'[{2,6640},{1,332},{3,249},{4,249}]','[{47040032,14}]',2),(47040032,15,'[{2,7372},{1,369},{3,276},{4,276}]','[{47040032,15}]',2),(47040032,16,'[{2,8140},{1,407},{3,305},{4,305}]','[{47040032,16}]',2),(47040032,17,'[{2,8944},{1,447},{3,335},{4,335}]','[{47040032,17}]',2),(47040032,18,'[{2,9784},{1,489},{3,367},{4,367}]','[{47040032,18}]',2),(47040032,19,'[{2,10660},{1,533},{3,400},{4,400}]','[{47040032,19}]',2),(47040032,20,'[{2,11572},{1,579},{3,434},{4,434}]','[{47040032,20}]',3),(47040032,21,'[{2,12532},{1,627},{3,470},{4,470}]','[{47040032,22}]',3),(47040032,22,'[{2,13540},{1,677},{3,508},{4,508}]','[{47040032,24}]',3),(47040032,23,'[{2,14596},{1,730},{3,548},{4,548}]','[{47040032,26}]',3),(47040032,24,'[{2,15700},{1,785},{3,589},{4,589}]','[{47040032,28}]',3),(47040032,25,'[{2,16852},{1,843},{3,632},{4,632}]','[{47040032,30}]',3),(47040032,26,'[{2,18052},{1,903},{3,677},{4,677}]','[{47040032,32}]',3),(47040032,27,'[{2,19300},{1,965},{3,724},{4,724}]','[{47040032,34}]',3),(47040032,28,'[{2,20596},{1,1030},{3,773},{4,773}]','[{47040032,36}]',3),(47040032,29,'[{2,21940},{1,1097},{3,823},{4,823}]','[{47040032,38}]',3),(47040032,30,'[{2,23332},{1,1167},{3,875},{4,875}]','[{47040032,40}]',4),(47040032,31,'[{2,24772},{1,1239},{3,929},{4,929}]','[{47040032,42}]',4),(47040032,32,'[{2,26260},{1,1313},{3,985},{4,985}]','[{47040032,44}]',4),(47040032,33,'[{2,27796},{1,1390},{3,1043},{4,1043}]','[{47040032,46}]',4),(47040032,34,'[{2,29380},{1,1469},{3,1102},{4,1102}]','[{47040032,48}]',4),(47040032,35,'[{2,31012},{1,1551},{3,1163},{4,1163}]','[{47040032,50}]',4),(47040032,36,'[{2,32692},{1,1635},{3,1226},{4,1226}]','[{47040032,52}]',4),(47040032,37,'[{2,34420},{1,1721},{3,1291},{4,1291}]','[{47040032,54}]',4),(47040032,38,'[{2,36196},{1,1810},{3,1358},{4,1358}]','[{47040032,56}]',4),(47040032,39,'[{2,38020},{1,1901},{3,1426},{4,1426}]','[{47040032,58}]',4),(47040032,40,'[{2,39892},{1,1995},{3,1496},{4,1496}]','[{47040032,60}]',5),(47040033,1,'[{2,700},{1,35},{3,25},{4,25}]','[{47040033,1}]',1),(47040033,2,'[{2,1282},{1,64},{3,46},{4,46}]','[{47040033,2}]',1),(47040033,3,'[{2,1944},{1,97},{3,70},{4,70}]','[{47040033,3}]',1),(47040033,4,'[{2,2687},{1,134},{3,97},{4,97}]','[{47040033,4}]',1),(47040033,5,'[{2,3511},{1,175},{3,126},{4,126}]','[{47040033,5}]',1),(47040033,6,'[{2,4416},{1,220},{3,158},{4,158}]','[{47040033,6}]',1),(47040033,7,'[{2,5401},{1,269},{3,193},{4,193}]','[{47040033,7}]',1),(47040033,8,'[{2,6467},{1,322},{3,231},{4,231}]','[{47040033,8}]',1),(47040033,9,'[{2,7614},{1,379},{3,272},{4,272}]','[{47040033,9}]',1),(47040033,10,'[{2,8842},{1,440},{3,316},{4,316}]','[{47040033,10}]',2),(47040033,11,'[{2,10150},{1,505},{3,363},{4,363}]','[{47040033,12}]',2),(47040033,12,'[{2,11539},{1,574},{3,413},{4,413}]','[{47040033,14}]',2),(47040033,13,'[{2,13009},{1,648},{3,466},{4,466}]','[{47040033,16}]',2),(47040033,14,'[{2,14560},{1,726},{3,521},{4,521}]','[{47040033,18}]',2),(47040033,15,'[{2,16192},{1,808},{3,579},{4,579}]','[{47040033,20}]',2),(47040033,16,'[{2,17931},{1,895},{3,641},{4,641}]','[{47040033,22}]',2),(47040033,17,'[{2,19778},{1,987},{3,707},{4,707}]','[{47040033,24}]',2),(47040033,18,'[{2,21733},{1,1085},{3,777},{4,777}]','[{47040033,26}]',2),(47040033,19,'[{2,23795},{1,1188},{3,851},{4,851}]','[{47040033,28}]',2),(47040033,20,'[{2,25965},{1,1297},{3,929},{4,929}]','[{47040033,30}]',3),(47040033,21,'[{2,28243},{1,1411},{3,1010},{4,1010}]','[{47040033,33}]',3),(47040033,22,'[{2,30628},{1,1530},{3,1095},{4,1095}]','[{47040033,36}]',3),(47040033,23,'[{2,33121},{1,1655},{3,1184},{4,1184}]','[{47040033,39}]',3),(47040033,24,'[{2,35722},{1,1785},{3,1277},{4,1277}]','[{47040033,42}]',3),(47040033,25,'[{2,38430},{1,1920},{3,1374},{4,1374}]','[{47040033,45}]',3),(47040033,26,'[{2,41246},{1,2061},{3,1475},{4,1475}]','[{47040033,48}]',3),(47040033,27,'[{2,44197},{1,2209},{3,1580},{4,1580}]','[{47040033,51}]',3),(47040033,28,'[{2,47282},{1,2363},{3,1690},{4,1690}]','[{47040033,54}]',3),(47040033,29,'[{2,50502},{1,2524},{3,1805},{4,1805}]','[{47040033,57}]',3),(47040033,30,'[{2,53857},{1,2692},{3,1925},{4,1925}]','[{47040033,60}]',4),(47040034,1,'[{2,1200},{1,60},{3,40},{4,40}]','[{47040034,1}]',1),(47040034,2,'[{2,2133},{1,110},{3,73},{4,73}]','[{47040034,2}]',1),(47040034,3,'[{2,3266},{1,167},{3,111},{4,111}]','[{47040034,3}]',1),(47040034,4,'[{2,4599},{1,234},{3,155},{4,155}]','[{47040034,4}]',1),(47040034,5,'[{2,6132},{1,311},{3,206},{4,206}]','[{47040034,5}]',1),(47040034,6,'[{2,7932},{1,401},{3,266},{4,266}]','[{47040034,7}]',1),(47040034,7,'[{2,9999},{1,504},{3,335},{4,335}]','[{47040034,9}]',1),(47040034,8,'[{2,12332},{1,621},{3,413},{4,413}]','[{47040034,11}]',1),(47040034,9,'[{2,14932},{1,751},{3,500},{4,500}]','[{47040034,13}]',1),(47040034,10,'[{2,17865},{1,898},{3,598},{4,598}]','[{47040034,15}]',2),(47040034,11,'[{2,21132},{1,1061},{3,707},{4,707}]','[{47040034,18}]',2),(47040034,12,'[{2,24732},{1,1241},{3,827},{4,827}]','[{47040034,21}]',2),(47040034,13,'[{2,28665},{1,1438},{3,958},{4,958}]','[{47040034,24}]',2),(47040034,14,'[{2,32932},{1,1651},{3,1100},{4,1100}]','[{47040034,27}]',2),(47040034,15,'[{2,37532},{1,1881},{3,1253},{4,1253}]','[{47040034,30}]',2),(47040034,16,'[{2,42532},{1,2131},{3,1420},{4,1420}]','[{47040034,34}]',2),(47040034,17,'[{2,47932},{1,2401},{3,1600},{4,1600}]','[{47040034,38}]',2),(47040034,18,'[{2,53732},{1,2691},{3,1793},{4,1793}]','[{47040034,42}]',2),(47040034,19,'[{2,59932},{1,3001},{3,2000},{4,2000}]','[{47040034,46}]',2),(47040034,20,'[{2,66532},{1,3331},{3,2220},{4,2220}]','[{47040034,50}]',3),(47040041,1,'[{2,200},{1,10},{3,8},{4,8}]','[{47040041,1}]',1),(47040041,2,'[{2,368},{1,18},{3,15},{4,15}]','[{47040041,2}]',1),(47040041,3,'[{2,558},{1,28},{3,23},{4,23}]','[{47040041,3}]',1),(47040041,4,'[{2,771},{1,39},{3,32},{4,32}]','[{47040041,4}]',1),(47040041,5,'[{2,1006},{1,51},{3,41},{4,41}]','[{47040041,5}]',1),(47040041,6,'[{2,1264},{1,64},{3,51},{4,51}]','[{47040041,6}]',1),(47040041,7,'[{2,1544},{1,78},{3,62},{4,62}]','[{47040041,7}]',1),(47040041,8,'[{2,1847},{1,93},{3,74},{4,74}]','[{47040041,8}]',1),(47040041,9,'[{2,2172},{1,109},{3,87},{4,87}]','[{47040041,9}]',1),(47040041,10,'[{2,2520},{1,126},{3,101},{4,101}]','[{47040041,10}]',2),(47040041,11,'[{2,2890},{1,145},{3,116},{4,116}]','[{47040041,11}]',2),(47040041,12,'[{2,3283},{1,165},{3,132},{4,132}]','[{47040041,12}]',2),(47040041,13,'[{2,3698},{1,186},{3,149},{4,149}]','[{47040041,13}]',2),(47040041,14,'[{2,4136},{1,208},{3,167},{4,167}]','[{47040041,14}]',2),(47040041,15,'[{2,4596},{1,231},{3,185},{4,185}]','[{47040041,15}]',2),(47040041,16,'[{2,5079},{1,255},{3,204},{4,204}]','[{47040041,16}]',2),(47040041,17,'[{2,5584},{1,280},{3,224},{4,224}]','[{47040041,17}]',2),(47040041,18,'[{2,6112},{1,306},{3,245},{4,245}]','[{47040041,18}]',2),(47040041,19,'[{2,6662},{1,334},{3,267},{4,267}]','[{47040041,19}]',2),(47040041,20,'[{2,7235},{1,363},{3,290},{4,290}]','[{47040041,20}]',3),(47040041,21,'[{2,7838},{1,393},{3,314},{4,314}]','[{47040041,22}]',3),(47040041,22,'[{2,8471},{1,425},{3,339},{4,339}]','[{47040041,24}]',3),(47040041,23,'[{2,9134},{1,458},{3,366},{4,366}]','[{47040041,26}]',3),(47040041,24,'[{2,9827},{1,493},{3,394},{4,394}]','[{47040041,28}]',3),(47040041,25,'[{2,10550},{1,529},{3,423},{4,423}]','[{47040041,30}]',3),(47040041,26,'[{2,11303},{1,567},{3,453},{4,453}]','[{47040041,32}]',3),(47040041,27,'[{2,12086},{1,606},{3,484},{4,484}]','[{47040041,34}]',3),(47040041,28,'[{2,12899},{1,647},{3,517},{4,517}]','[{47040041,36}]',3),(47040041,29,'[{2,13742},{1,689},{3,551},{4,551}]','[{47040041,38}]',3),(47040041,30,'[{2,14615},{1,733},{3,586},{4,586}]','[{47040041,40}]',4),(47040041,31,'[{2,15518},{1,778},{3,622},{4,622}]','[{47040041,42}]',4),(47040041,32,'[{2,16451},{1,825},{3,659},{4,659}]','[{47040041,44}]',4),(47040041,33,'[{2,17414},{1,873},{3,698},{4,698}]','[{47040041,46}]',4),(47040041,34,'[{2,18407},{1,923},{3,738},{4,738}]','[{47040041,48}]',4),(47040041,35,'[{2,19430},{1,974},{3,779},{4,779}]','[{47040041,50}]',4),(47040041,36,'[{2,20483},{1,1027},{3,821},{4,821}]','[{47040041,52}]',4),(47040041,37,'[{2,21566},{1,1081},{3,864},{4,864}]','[{47040041,54}]',4),(47040041,38,'[{2,22679},{1,1137},{3,909},{4,909}]','[{47040041,56}]',4),(47040041,39,'[{2,23822},{1,1194},{3,955},{4,955}]','[{47040041,58}]',4),(47040041,40,'[{2,24995},{1,1253},{3,1002},{4,1002}]','[{47040041,60}]',5),(47040042,1,'[{2,400},{1,20},{3,15},{4,15}]','[{47040042,1}]',1),(47040042,2,'[{2,664},{1,33},{3,25},{4,25}]','[{47040042,2}]',1),(47040042,3,'[{2,964},{1,48},{3,36},{4,36}]','[{47040042,3}]',1),(47040042,4,'[{2,1300},{1,65},{3,49},{4,49}]','[{47040042,4}]',1),(47040042,5,'[{2,1672},{1,84},{3,63},{4,63}]','[{47040042,5}]',1),(47040042,6,'[{2,2080},{1,104},{3,78},{4,78}]','[{47040042,6}]',1),(47040042,7,'[{2,2524},{1,126},{3,95},{4,95}]','[{47040042,7}]',1),(47040042,8,'[{2,3004},{1,150},{3,113},{4,113}]','[{47040042,8}]',1),(47040042,9,'[{2,3520},{1,176},{3,132},{4,132}]','[{47040042,9}]',1),(47040042,10,'[{2,4072},{1,204},{3,153},{4,153}]','[{47040042,10}]',2),(47040042,11,'[{2,4660},{1,233},{3,175},{4,175}]','[{47040042,11}]',2),(47040042,12,'[{2,5284},{1,264},{3,198},{4,198}]','[{47040042,12}]',2),(47040042,13,'[{2,5944},{1,297},{3,223},{4,223}]','[{47040042,13}]',2),(47040042,14,'[{2,6640},{1,332},{3,249},{4,249}]','[{47040042,14}]',2),(47040042,15,'[{2,7372},{1,369},{3,276},{4,276}]','[{47040042,15}]',2),(47040042,16,'[{2,8140},{1,407},{3,305},{4,305}]','[{47040042,16}]',2),(47040042,17,'[{2,8944},{1,447},{3,335},{4,335}]','[{47040042,17}]',2),(47040042,18,'[{2,9784},{1,489},{3,367},{4,367}]','[{47040042,18}]',2),(47040042,19,'[{2,10660},{1,533},{3,400},{4,400}]','[{47040042,19}]',2),(47040042,20,'[{2,11572},{1,579},{3,434},{4,434}]','[{47040042,20}]',3),(47040042,21,'[{2,12532},{1,627},{3,470},{4,470}]','[{47040042,22}]',3),(47040042,22,'[{2,13540},{1,677},{3,508},{4,508}]','[{47040042,24}]',3),(47040042,23,'[{2,14596},{1,730},{3,548},{4,548}]','[{47040042,26}]',3),(47040042,24,'[{2,15700},{1,785},{3,589},{4,589}]','[{47040042,28}]',3),(47040042,25,'[{2,16852},{1,843},{3,632},{4,632}]','[{47040042,30}]',3),(47040042,26,'[{2,18052},{1,903},{3,677},{4,677}]','[{47040042,32}]',3),(47040042,27,'[{2,19300},{1,965},{3,724},{4,724}]','[{47040042,34}]',3),(47040042,28,'[{2,20596},{1,1030},{3,773},{4,773}]','[{47040042,36}]',3),(47040042,29,'[{2,21940},{1,1097},{3,823},{4,823}]','[{47040042,38}]',3),(47040042,30,'[{2,23332},{1,1167},{3,875},{4,875}]','[{47040042,40}]',4),(47040042,31,'[{2,24772},{1,1239},{3,929},{4,929}]','[{47040042,42}]',4),(47040042,32,'[{2,26260},{1,1313},{3,985},{4,985}]','[{47040042,44}]',4),(47040042,33,'[{2,27796},{1,1390},{3,1043},{4,1043}]','[{47040042,46}]',4),(47040042,34,'[{2,29380},{1,1469},{3,1102},{4,1102}]','[{47040042,48}]',4),(47040042,35,'[{2,31012},{1,1551},{3,1163},{4,1163}]','[{47040042,50}]',4),(47040042,36,'[{2,32692},{1,1635},{3,1226},{4,1226}]','[{47040042,52}]',4),(47040042,37,'[{2,34420},{1,1721},{3,1291},{4,1291}]','[{47040042,54}]',4),(47040042,38,'[{2,36196},{1,1810},{3,1358},{4,1358}]','[{47040042,56}]',4),(47040042,39,'[{2,38020},{1,1901},{3,1426},{4,1426}]','[{47040042,58}]',4),(47040042,40,'[{2,39892},{1,1995},{3,1496},{4,1496}]','[{47040042,60}]',5),(47040043,1,'[{2,700},{1,35},{3,25},{4,25}]','[{47040043,1}]',1),(47040043,2,'[{2,1282},{1,64},{3,46},{4,46}]','[{47040043,2}]',1),(47040043,3,'[{2,1944},{1,97},{3,70},{4,70}]','[{47040043,3}]',1),(47040043,4,'[{2,2687},{1,134},{3,97},{4,97}]','[{47040043,4}]',1),(47040043,5,'[{2,3511},{1,175},{3,126},{4,126}]','[{47040043,5}]',1),(47040043,6,'[{2,4416},{1,220},{3,158},{4,158}]','[{47040043,6}]',1),(47040043,7,'[{2,5401},{1,269},{3,193},{4,193}]','[{47040043,7}]',1),(47040043,8,'[{2,6467},{1,322},{3,231},{4,231}]','[{47040043,8}]',1),(47040043,9,'[{2,7614},{1,379},{3,272},{4,272}]','[{47040043,9}]',1),(47040043,10,'[{2,8842},{1,440},{3,316},{4,316}]','[{47040043,10}]',2),(47040043,11,'[{2,10150},{1,505},{3,363},{4,363}]','[{47040043,12}]',2),(47040043,12,'[{2,11539},{1,574},{3,413},{4,413}]','[{47040043,14}]',2),(47040043,13,'[{2,13009},{1,648},{3,466},{4,466}]','[{47040043,16}]',2),(47040043,14,'[{2,14560},{1,726},{3,521},{4,521}]','[{47040043,18}]',2),(47040043,15,'[{2,16192},{1,808},{3,579},{4,579}]','[{47040043,20}]',2),(47040043,16,'[{2,17931},{1,895},{3,641},{4,641}]','[{47040043,22}]',2),(47040043,17,'[{2,19778},{1,987},{3,707},{4,707}]','[{47040043,24}]',2),(47040043,18,'[{2,21733},{1,1085},{3,777},{4,777}]','[{47040043,26}]',2),(47040043,19,'[{2,23795},{1,1188},{3,851},{4,851}]','[{47040043,28}]',2),(47040043,20,'[{2,25965},{1,1297},{3,929},{4,929}]','[{47040043,30}]',3),(47040043,21,'[{2,28243},{1,1411},{3,1010},{4,1010}]','[{47040043,33}]',3),(47040043,22,'[{2,30628},{1,1530},{3,1095},{4,1095}]','[{47040043,36}]',3),(47040043,23,'[{2,33121},{1,1655},{3,1184},{4,1184}]','[{47040043,39}]',3),(47040043,24,'[{2,35722},{1,1785},{3,1277},{4,1277}]','[{47040043,42}]',3),(47040043,25,'[{2,38430},{1,1920},{3,1374},{4,1374}]','[{47040043,45}]',3),(47040043,26,'[{2,41246},{1,2061},{3,1475},{4,1475}]','[{47040043,48}]',3),(47040043,27,'[{2,44197},{1,2209},{3,1580},{4,1580}]','[{47040043,51}]',3),(47040043,28,'[{2,47282},{1,2363},{3,1690},{4,1690}]','[{47040043,54}]',3),(47040043,29,'[{2,50502},{1,2524},{3,1805},{4,1805}]','[{47040043,57}]',3),(47040043,30,'[{2,53857},{1,2692},{3,1925},{4,1925}]','[{47040043,60}]',4),(47040044,1,'[{2,1200},{1,60},{3,40},{4,40}]','[{47040044,1}]',1),(47040044,2,'[{2,2133},{1,110},{3,73},{4,73}]','[{47040044,2}]',1),(47040044,3,'[{2,3266},{1,167},{3,111},{4,111}]','[{47040044,3}]',1),(47040044,4,'[{2,4599},{1,234},{3,155},{4,155}]','[{47040044,4}]',1),(47040044,5,'[{2,6132},{1,311},{3,206},{4,206}]','[{47040044,5}]',1),(47040044,6,'[{2,7932},{1,401},{3,266},{4,266}]','[{47040044,7}]',1),(47040044,7,'[{2,9999},{1,504},{3,335},{4,335}]','[{47040044,9}]',1),(47040044,8,'[{2,12332},{1,621},{3,413},{4,413}]','[{47040044,11}]',1),(47040044,9,'[{2,14932},{1,751},{3,500},{4,500}]','[{47040044,13}]',1),(47040044,10,'[{2,17865},{1,898},{3,598},{4,598}]','[{47040044,15}]',2),(47040044,11,'[{2,21132},{1,1061},{3,707},{4,707}]','[{47040044,18}]',2),(47040044,12,'[{2,24732},{1,1241},{3,827},{4,827}]','[{47040044,21}]',2),(47040044,13,'[{2,28665},{1,1438},{3,958},{4,958}]','[{47040044,24}]',2),(47040044,14,'[{2,32932},{1,1651},{3,1100},{4,1100}]','[{47040044,27}]',2),(47040044,15,'[{2,37532},{1,1881},{3,1253},{4,1253}]','[{47040044,30}]',2),(47040044,16,'[{2,42532},{1,2131},{3,1420},{4,1420}]','[{47040044,34}]',2),(47040044,17,'[{2,47932},{1,2401},{3,1600},{4,1600}]','[{47040044,38}]',2),(47040044,18,'[{2,53732},{1,2691},{3,1793},{4,1793}]','[{47040044,42}]',2),(47040044,19,'[{2,59932},{1,3001},{3,2000},{4,2000}]','[{47040044,46}]',2),(47040044,20,'[{2,66532},{1,3331},{3,2220},{4,2220}]','[{47040044,50}]',3),(47040051,1,'[{2,200},{1,10},{3,8},{4,8}]','[{47040051,1}]',1),(47040051,2,'[{2,368},{1,18},{3,15},{4,15}]','[{47040051,2}]',1),(47040051,3,'[{2,558},{1,28},{3,23},{4,23}]','[{47040051,3}]',1),(47040051,4,'[{2,771},{1,39},{3,32},{4,32}]','[{47040051,4}]',1),(47040051,5,'[{2,1006},{1,51},{3,41},{4,41}]','[{47040051,5}]',1),(47040051,6,'[{2,1264},{1,64},{3,51},{4,51}]','[{47040051,6}]',1),(47040051,7,'[{2,1544},{1,78},{3,62},{4,62}]','[{47040051,7}]',1),(47040051,8,'[{2,1847},{1,93},{3,74},{4,74}]','[{47040051,8}]',1),(47040051,9,'[{2,2172},{1,109},{3,87},{4,87}]','[{47040051,9}]',1),(47040051,10,'[{2,2520},{1,126},{3,101},{4,101}]','[{47040051,10}]',2),(47040051,11,'[{2,2890},{1,145},{3,116},{4,116}]','[{47040051,11}]',2),(47040051,12,'[{2,3283},{1,165},{3,132},{4,132}]','[{47040051,12}]',2),(47040051,13,'[{2,3698},{1,186},{3,149},{4,149}]','[{47040051,13}]',2),(47040051,14,'[{2,4136},{1,208},{3,167},{4,167}]','[{47040051,14}]',2),(47040051,15,'[{2,4596},{1,231},{3,185},{4,185}]','[{47040051,15}]',2),(47040051,16,'[{2,5079},{1,255},{3,204},{4,204}]','[{47040051,16}]',2),(47040051,17,'[{2,5584},{1,280},{3,224},{4,224}]','[{47040051,17}]',2),(47040051,18,'[{2,6112},{1,306},{3,245},{4,245}]','[{47040051,18}]',2),(47040051,19,'[{2,6662},{1,334},{3,267},{4,267}]','[{47040051,19}]',2),(47040051,20,'[{2,7235},{1,363},{3,290},{4,290}]','[{47040051,20}]',3),(47040051,21,'[{2,7838},{1,393},{3,314},{4,314}]','[{47040051,22}]',3),(47040051,22,'[{2,8471},{1,425},{3,339},{4,339}]','[{47040051,24}]',3),(47040051,23,'[{2,9134},{1,458},{3,366},{4,366}]','[{47040051,26}]',3),(47040051,24,'[{2,9827},{1,493},{3,394},{4,394}]','[{47040051,28}]',3),(47040051,25,'[{2,10550},{1,529},{3,423},{4,423}]','[{47040051,30}]',3),(47040051,26,'[{2,11303},{1,567},{3,453},{4,453}]','[{47040051,32}]',3),(47040051,27,'[{2,12086},{1,606},{3,484},{4,484}]','[{47040051,34}]',3),(47040051,28,'[{2,12899},{1,647},{3,517},{4,517}]','[{47040051,36}]',3),(47040051,29,'[{2,13742},{1,689},{3,551},{4,551}]','[{47040051,38}]',3),(47040051,30,'[{2,14615},{1,733},{3,586},{4,586}]','[{47040051,40}]',4),(47040051,31,'[{2,15518},{1,778},{3,622},{4,622}]','[{47040051,42}]',4),(47040051,32,'[{2,16451},{1,825},{3,659},{4,659}]','[{47040051,44}]',4),(47040051,33,'[{2,17414},{1,873},{3,698},{4,698}]','[{47040051,46}]',4),(47040051,34,'[{2,18407},{1,923},{3,738},{4,738}]','[{47040051,48}]',4),(47040051,35,'[{2,19430},{1,974},{3,779},{4,779}]','[{47040051,50}]',4),(47040051,36,'[{2,20483},{1,1027},{3,821},{4,821}]','[{47040051,52}]',4),(47040051,37,'[{2,21566},{1,1081},{3,864},{4,864}]','[{47040051,54}]',4),(47040051,38,'[{2,22679},{1,1137},{3,909},{4,909}]','[{47040051,56}]',4),(47040051,39,'[{2,23822},{1,1194},{3,955},{4,955}]','[{47040051,58}]',4),(47040051,40,'[{2,24995},{1,1253},{3,1002},{4,1002}]','[{47040051,60}]',5),(47040052,1,'[{2,400},{1,20},{3,15},{4,15}]','[{47040052,1}]',1),(47040052,2,'[{2,664},{1,33},{3,25},{4,25}]','[{47040052,2}]',1),(47040052,3,'[{2,964},{1,48},{3,36},{4,36}]','[{47040052,3}]',1),(47040052,4,'[{2,1300},{1,65},{3,49},{4,49}]','[{47040052,4}]',1),(47040052,5,'[{2,1672},{1,84},{3,63},{4,63}]','[{47040052,5}]',1),(47040052,6,'[{2,2080},{1,104},{3,78},{4,78}]','[{47040052,6}]',1),(47040052,7,'[{2,2524},{1,126},{3,95},{4,95}]','[{47040052,7}]',1),(47040052,8,'[{2,3004},{1,150},{3,113},{4,113}]','[{47040052,8}]',1),(47040052,9,'[{2,3520},{1,176},{3,132},{4,132}]','[{47040052,9}]',1),(47040052,10,'[{2,4072},{1,204},{3,153},{4,153}]','[{47040052,10}]',2),(47040052,11,'[{2,4660},{1,233},{3,175},{4,175}]','[{47040052,11}]',2),(47040052,12,'[{2,5284},{1,264},{3,198},{4,198}]','[{47040052,12}]',2),(47040052,13,'[{2,5944},{1,297},{3,223},{4,223}]','[{47040052,13}]',2),(47040052,14,'[{2,6640},{1,332},{3,249},{4,249}]','[{47040052,14}]',2),(47040052,15,'[{2,7372},{1,369},{3,276},{4,276}]','[{47040052,15}]',2),(47040052,16,'[{2,8140},{1,407},{3,305},{4,305}]','[{47040052,16}]',2),(47040052,17,'[{2,8944},{1,447},{3,335},{4,335}]','[{47040052,17}]',2),(47040052,18,'[{2,9784},{1,489},{3,367},{4,367}]','[{47040052,18}]',2),(47040052,19,'[{2,10660},{1,533},{3,400},{4,400}]','[{47040052,19}]',2),(47040052,20,'[{2,11572},{1,579},{3,434},{4,434}]','[{47040052,20}]',3),(47040052,21,'[{2,12532},{1,627},{3,470},{4,470}]','[{47040052,22}]',3),(47040052,22,'[{2,13540},{1,677},{3,508},{4,508}]','[{47040052,24}]',3),(47040052,23,'[{2,14596},{1,730},{3,548},{4,548}]','[{47040052,26}]',3),(47040052,24,'[{2,15700},{1,785},{3,589},{4,589}]','[{47040052,28}]',3),(47040052,25,'[{2,16852},{1,843},{3,632},{4,632}]','[{47040052,30}]',3),(47040052,26,'[{2,18052},{1,903},{3,677},{4,677}]','[{47040052,32}]',3),(47040052,27,'[{2,19300},{1,965},{3,724},{4,724}]','[{47040052,34}]',3),(47040052,28,'[{2,20596},{1,1030},{3,773},{4,773}]','[{47040052,36}]',3),(47040052,29,'[{2,21940},{1,1097},{3,823},{4,823}]','[{47040052,38}]',3),(47040052,30,'[{2,23332},{1,1167},{3,875},{4,875}]','[{47040052,40}]',4),(47040052,31,'[{2,24772},{1,1239},{3,929},{4,929}]','[{47040052,42}]',4),(47040052,32,'[{2,26260},{1,1313},{3,985},{4,985}]','[{47040052,44}]',4),(47040052,33,'[{2,27796},{1,1390},{3,1043},{4,1043}]','[{47040052,46}]',4),(47040052,34,'[{2,29380},{1,1469},{3,1102},{4,1102}]','[{47040052,48}]',4),(47040052,35,'[{2,31012},{1,1551},{3,1163},{4,1163}]','[{47040052,50}]',4),(47040052,36,'[{2,32692},{1,1635},{3,1226},{4,1226}]','[{47040052,52}]',4),(47040052,37,'[{2,34420},{1,1721},{3,1291},{4,1291}]','[{47040052,54}]',4),(47040052,38,'[{2,36196},{1,1810},{3,1358},{4,1358}]','[{47040052,56}]',4),(47040052,39,'[{2,38020},{1,1901},{3,1426},{4,1426}]','[{47040052,58}]',4),(47040052,40,'[{2,39892},{1,1995},{3,1496},{4,1496}]','[{47040052,60}]',5),(47040053,1,'[{2,700},{1,35},{3,25},{4,25}]','[{47040053,1}]',1),(47040053,2,'[{2,1282},{1,64},{3,46},{4,46}]','[{47040053,2}]',1),(47040053,3,'[{2,1944},{1,97},{3,70},{4,70}]','[{47040053,3}]',1),(47040053,4,'[{2,2687},{1,134},{3,97},{4,97}]','[{47040053,4}]',1),(47040053,5,'[{2,3511},{1,175},{3,126},{4,126}]','[{47040053,5}]',1),(47040053,6,'[{2,4416},{1,220},{3,158},{4,158}]','[{47040053,6}]',1),(47040053,7,'[{2,5401},{1,269},{3,193},{4,193}]','[{47040053,7}]',1),(47040053,8,'[{2,6467},{1,322},{3,231},{4,231}]','[{47040053,8}]',1),(47040053,9,'[{2,7614},{1,379},{3,272},{4,272}]','[{47040053,9}]',1),(47040053,10,'[{2,8842},{1,440},{3,316},{4,316}]','[{47040053,10}]',2),(47040053,11,'[{2,10150},{1,505},{3,363},{4,363}]','[{47040053,12}]',2),(47040053,12,'[{2,11539},{1,574},{3,413},{4,413}]','[{47040053,14}]',2),(47040053,13,'[{2,13009},{1,648},{3,466},{4,466}]','[{47040053,16}]',2),(47040053,14,'[{2,14560},{1,726},{3,521},{4,521}]','[{47040053,18}]',2),(47040053,15,'[{2,16192},{1,808},{3,579},{4,579}]','[{47040053,20}]',2),(47040053,16,'[{2,17931},{1,895},{3,641},{4,641}]','[{47040053,22}]',2),(47040053,17,'[{2,19778},{1,987},{3,707},{4,707}]','[{47040053,24}]',2),(47040053,18,'[{2,21733},{1,1085},{3,777},{4,777}]','[{47040053,26}]',2),(47040053,19,'[{2,23795},{1,1188},{3,851},{4,851}]','[{47040053,28}]',2),(47040053,20,'[{2,25965},{1,1297},{3,929},{4,929}]','[{47040053,30}]',3),(47040053,21,'[{2,28243},{1,1411},{3,1010},{4,1010}]','[{47040053,33}]',3),(47040053,22,'[{2,30628},{1,1530},{3,1095},{4,1095}]','[{47040053,36}]',3),(47040053,23,'[{2,33121},{1,1655},{3,1184},{4,1184}]','[{47040053,39}]',3),(47040053,24,'[{2,35722},{1,1785},{3,1277},{4,1277}]','[{47040053,42}]',3),(47040053,25,'[{2,38430},{1,1920},{3,1374},{4,1374}]','[{47040053,45}]',3),(47040053,26,'[{2,41246},{1,2061},{3,1475},{4,1475}]','[{47040053,48}]',3),(47040053,27,'[{2,44197},{1,2209},{3,1580},{4,1580}]','[{47040053,51}]',3),(47040053,28,'[{2,47282},{1,2363},{3,1690},{4,1690}]','[{47040053,54}]',3),(47040053,29,'[{2,50502},{1,2524},{3,1805},{4,1805}]','[{47040053,57}]',3),(47040053,30,'[{2,53857},{1,2692},{3,1925},{4,1925}]','[{47040053,60}]',4),(47040054,1,'[{2,1200},{1,60},{3,40},{4,40}]','[{47040054,1}]',1),(47040054,2,'[{2,2133},{1,110},{3,73},{4,73}]','[{47040054,2}]',1),(47040054,3,'[{2,3266},{1,167},{3,111},{4,111}]','[{47040054,3}]',1),(47040054,4,'[{2,4599},{1,234},{3,155},{4,155}]','[{47040054,4}]',1),(47040054,5,'[{2,6132},{1,311},{3,206},{4,206}]','[{47040054,5}]',1),(47040054,6,'[{2,7932},{1,401},{3,266},{4,266}]','[{47040054,7}]',1),(47040054,7,'[{2,9999},{1,504},{3,335},{4,335}]','[{47040054,9}]',1),(47040054,8,'[{2,12332},{1,621},{3,413},{4,413}]','[{47040054,11}]',1),(47040054,9,'[{2,14932},{1,751},{3,500},{4,500}]','[{47040054,13}]',1),(47040054,10,'[{2,17865},{1,898},{3,598},{4,598}]','[{47040054,15}]',2),(47040054,11,'[{2,21132},{1,1061},{3,707},{4,707}]','[{47040054,18}]',2),(47040054,12,'[{2,24732},{1,1241},{3,827},{4,827}]','[{47040054,21}]',2),(47040054,13,'[{2,28665},{1,1438},{3,958},{4,958}]','[{47040054,24}]',2),(47040054,14,'[{2,32932},{1,1651},{3,1100},{4,1100}]','[{47040054,27}]',2),(47040054,15,'[{2,37532},{1,1881},{3,1253},{4,1253}]','[{47040054,30}]',2),(47040054,16,'[{2,42532},{1,2131},{3,1420},{4,1420}]','[{47040054,34}]',2),(47040054,17,'[{2,47932},{1,2401},{3,1600},{4,1600}]','[{47040054,38}]',2),(47040054,18,'[{2,53732},{1,2691},{3,1793},{4,1793}]','[{47040054,42}]',2),(47040054,19,'[{2,59932},{1,3001},{3,2000},{4,2000}]','[{47040054,46}]',2),(47040054,20,'[{2,66532},{1,3331},{3,2220},{4,2220}]','[{47040054,50}]',3),(47040061,1,'[{2,5000},{1,250},{3,200},{4,200},{51,200}]','[{47040061,1}]',1),(47040061,2,'[{2,8000},{1,400},{3,320},{4,320},{51,240}]','[{47040061,2}]',1),(47040061,3,'[{2,11400},{1,570},{3,456},{4,456},{51,280}]','[{47040061,3}]',1),(47040061,4,'[{2,15300},{1,765},{3,612},{4,612},{51,340}]','[{47040061,4}]',1),(47040061,5,'[{2,19700},{1,985},{3,788},{4,788},{51,400}]','[{47040061,5}]',1),(47040061,6,'[{2,24600},{1,1230},{3,984},{4,984},{51,480}]','[{47040061,7}]',1),(47040061,7,'[{2,30100},{1,1505},{3,1204},{4,1204},{51,560}]','[{47040061,9}]',1),(47040061,8,'[{2,36200},{1,1810},{3,1448},{4,1448},{51,660}]','[{47040061,11}]',1),(47040061,9,'[{2,43000},{1,2150},{3,1720},{4,1720},{51,760}]','[{47040061,13}]',1),(47040061,10,'[{2,50500},{1,2525},{3,2020},{4,2020},{51,880}]','[{47040061,15}]',2),(47040061,11,'[{2,58700},{1,2935},{3,2348},{4,2348},{51,1000}]','[{47040061,18}]',2),(47040061,12,'[{2,67700},{1,3385},{3,2708},{4,2708},{51,1140}]','[{47040061,21}]',2),(47040061,13,'[{2,77500},{1,3875},{3,3100},{4,3100},{51,1280}]','[{47040061,24}]',2),(47040061,14,'[{2,88200},{1,4410},{3,3528},{4,3528},{51,1440}]','[{47040061,27}]',2),(47040061,15,'[{2,99900},{1,4995},{3,3996},{4,3996},{51,1600}]','[{47040061,30}]',2),(47040071,1,'[{2,5000},{1,250},{3,200},{4,200},{230,200}]','[{47040071,1}]',1),(47040071,2,'[{2,8000},{1,400},{3,320},{4,320},{230,240}]','[{47040071,2}]',1),(47040071,3,'[{2,11400},{1,570},{3,456},{4,456},{230,280}]','[{47040071,3}]',1),(47040071,4,'[{2,15300},{1,765},{3,612},{4,612},{230,340}]','[{47040071,4}]',1),(47040071,5,'[{2,19700},{1,985},{3,788},{4,788},{230,400}]','[{47040071,5}]',1),(47040071,6,'[{2,24600},{1,1230},{3,984},{4,984},{230,480}]','[{47040071,7}]',1),(47040071,7,'[{2,30100},{1,1505},{3,1204},{4,1204},{230,560}]','[{47040071,9}]',1),(47040071,8,'[{2,36200},{1,1810},{3,1448},{4,1448},{230,660}]','[{47040071,11}]',1),(47040071,9,'[{2,43000},{1,2150},{3,1720},{4,1720},{230,760}]','[{47040071,13}]',1),(47040071,10,'[{2,50500},{1,2525},{3,2020},{4,2020},{230,880}]','[{47040071,15}]',2),(47040071,11,'[{2,58700},{1,2935},{3,2348},{4,2348},{230,1000}]','[{47040071,18}]',2),(47040071,12,'[{2,67700},{1,3385},{3,2708},{4,2708},{230,1140}]','[{47040071,21}]',2),(47040071,13,'[{2,77500},{1,3875},{3,3100},{4,3100},{230,1280}]','[{47040071,24}]',2),(47040071,14,'[{2,88200},{1,4410},{3,3528},{4,3528},{230,1440}]','[{47040071,27}]',2),(47040071,15,'[{2,99900},{1,4995},{3,3996},{4,3996},{230,1600}]','[{47040071,30}]',2),(47050011,1,'[{2,200},{1,10},{3,8},{4,8}]','[{47050011,1}]',1),(47050011,2,'[{2,368},{1,18},{3,15},{4,15}]','[{47050011,2}]',1),(47050011,3,'[{2,558},{1,28},{3,23},{4,23}]','[{47050011,3}]',1),(47050011,4,'[{2,771},{1,39},{3,32},{4,32}]','[{47050011,4}]',1),(47050011,5,'[{2,1006},{1,51},{3,41},{4,41}]','[{47050011,5}]',1),(47050011,6,'[{2,1264},{1,64},{3,51},{4,51}]','[{47050011,6}]',1),(47050011,7,'[{2,1544},{1,78},{3,62},{4,62}]','[{47050011,7}]',1),(47050011,8,'[{2,1847},{1,93},{3,74},{4,74}]','[{47050011,8}]',1),(47050011,9,'[{2,2172},{1,109},{3,87},{4,87}]','[{47050011,9}]',1),(47050011,10,'[{2,2520},{1,126},{3,101},{4,101}]','[{47050011,10}]',2),(47050011,11,'[{2,2890},{1,145},{3,116},{4,116}]','[{47050011,11}]',2),(47050011,12,'[{2,3283},{1,165},{3,132},{4,132}]','[{47050011,12}]',2),(47050011,13,'[{2,3698},{1,186},{3,149},{4,149}]','[{47050011,13}]',2),(47050011,14,'[{2,4136},{1,208},{3,167},{4,167}]','[{47050011,14}]',2),(47050011,15,'[{2,4596},{1,231},{3,185},{4,185}]','[{47050011,15}]',2),(47050011,16,'[{2,5079},{1,255},{3,204},{4,204}]','[{47050011,16}]',2),(47050011,17,'[{2,5584},{1,280},{3,224},{4,224}]','[{47050011,17}]',2),(47050011,18,'[{2,6112},{1,306},{3,245},{4,245}]','[{47050011,18}]',2),(47050011,19,'[{2,6662},{1,334},{3,267},{4,267}]','[{47050011,19}]',2),(47050011,20,'[{2,7235},{1,363},{3,290},{4,290}]','[{47050011,20}]',3),(47050011,21,'[{2,7838},{1,393},{3,314},{4,314}]','[{47050011,22}]',3),(47050011,22,'[{2,8471},{1,425},{3,339},{4,339}]','[{47050011,24}]',3),(47050011,23,'[{2,9134},{1,458},{3,366},{4,366}]','[{47050011,26}]',3),(47050011,24,'[{2,9827},{1,493},{3,394},{4,394}]','[{47050011,28}]',3),(47050011,25,'[{2,10550},{1,529},{3,423},{4,423}]','[{47050011,30}]',3),(47050011,26,'[{2,11303},{1,567},{3,453},{4,453}]','[{47050011,32}]',3),(47050011,27,'[{2,12086},{1,606},{3,484},{4,484}]','[{47050011,34}]',3),(47050011,28,'[{2,12899},{1,647},{3,517},{4,517}]','[{47050011,36}]',3),(47050011,29,'[{2,13742},{1,689},{3,551},{4,551}]','[{47050011,38}]',3),(47050011,30,'[{2,14615},{1,733},{3,586},{4,586}]','[{47050011,40}]',4),(47050011,31,'[{2,15518},{1,778},{3,622},{4,622}]','[{47050011,42}]',4),(47050011,32,'[{2,16451},{1,825},{3,659},{4,659}]','[{47050011,44}]',4),(47050011,33,'[{2,17414},{1,873},{3,698},{4,698}]','[{47050011,46}]',4),(47050011,34,'[{2,18407},{1,923},{3,738},{4,738}]','[{47050011,48}]',4),(47050011,35,'[{2,19430},{1,974},{3,779},{4,779}]','[{47050011,50}]',4),(47050011,36,'[{2,20483},{1,1027},{3,821},{4,821}]','[{47050011,52}]',4),(47050011,37,'[{2,21566},{1,1081},{3,864},{4,864}]','[{47050011,54}]',4),(47050011,38,'[{2,22679},{1,1137},{3,909},{4,909}]','[{47050011,56}]',4),(47050011,39,'[{2,23822},{1,1194},{3,955},{4,955}]','[{47050011,58}]',4),(47050011,40,'[{2,24995},{1,1253},{3,1002},{4,1002}]','[{47050011,60}]',5),(47050012,1,'[{2,400},{1,20},{3,15},{4,15}]','[{47050012,1}]',1),(47050012,2,'[{2,664},{1,33},{3,25},{4,25}]','[{47050012,2}]',1),(47050012,3,'[{2,964},{1,48},{3,36},{4,36}]','[{47050012,3}]',1),(47050012,4,'[{2,1300},{1,65},{3,49},{4,49}]','[{47050012,4}]',1),(47050012,5,'[{2,1672},{1,84},{3,63},{4,63}]','[{47050012,5}]',1),(47050012,6,'[{2,2080},{1,104},{3,78},{4,78}]','[{47050012,6}]',1),(47050012,7,'[{2,2524},{1,126},{3,95},{4,95}]','[{47050012,7}]',1),(47050012,8,'[{2,3004},{1,150},{3,113},{4,113}]','[{47050012,8}]',1),(47050012,9,'[{2,3520},{1,176},{3,132},{4,132}]','[{47050012,9}]',1),(47050012,10,'[{2,4072},{1,204},{3,153},{4,153}]','[{47050012,10}]',2),(47050012,11,'[{2,4660},{1,233},{3,175},{4,175}]','[{47050012,11}]',2),(47050012,12,'[{2,5284},{1,264},{3,198},{4,198}]','[{47050012,12}]',2),(47050012,13,'[{2,5944},{1,297},{3,223},{4,223}]','[{47050012,13}]',2),(47050012,14,'[{2,6640},{1,332},{3,249},{4,249}]','[{47050012,14}]',2),(47050012,15,'[{2,7372},{1,369},{3,276},{4,276}]','[{47050012,15}]',2),(47050012,16,'[{2,8140},{1,407},{3,305},{4,305}]','[{47050012,16}]',2),(47050012,17,'[{2,8944},{1,447},{3,335},{4,335}]','[{47050012,17}]',2),(47050012,18,'[{2,9784},{1,489},{3,367},{4,367}]','[{47050012,18}]',2),(47050012,19,'[{2,10660},{1,533},{3,400},{4,400}]','[{47050012,19}]',2),(47050012,20,'[{2,11572},{1,579},{3,434},{4,434}]','[{47050012,20}]',3),(47050012,21,'[{2,12532},{1,627},{3,470},{4,470}]','[{47050012,22}]',3),(47050012,22,'[{2,13540},{1,677},{3,508},{4,508}]','[{47050012,24}]',3),(47050012,23,'[{2,14596},{1,730},{3,548},{4,548}]','[{47050012,26}]',3),(47050012,24,'[{2,15700},{1,785},{3,589},{4,589}]','[{47050012,28}]',3),(47050012,25,'[{2,16852},{1,843},{3,632},{4,632}]','[{47050012,30}]',3),(47050012,26,'[{2,18052},{1,903},{3,677},{4,677}]','[{47050012,32}]',3),(47050012,27,'[{2,19300},{1,965},{3,724},{4,724}]','[{47050012,34}]',3),(47050012,28,'[{2,20596},{1,1030},{3,773},{4,773}]','[{47050012,36}]',3),(47050012,29,'[{2,21940},{1,1097},{3,823},{4,823}]','[{47050012,38}]',3),(47050012,30,'[{2,23332},{1,1167},{3,875},{4,875}]','[{47050012,40}]',4),(47050012,31,'[{2,24772},{1,1239},{3,929},{4,929}]','[{47050012,42}]',4),(47050012,32,'[{2,26260},{1,1313},{3,985},{4,985}]','[{47050012,44}]',4),(47050012,33,'[{2,27796},{1,1390},{3,1043},{4,1043}]','[{47050012,46}]',4),(47050012,34,'[{2,29380},{1,1469},{3,1102},{4,1102}]','[{47050012,48}]',4),(47050012,35,'[{2,31012},{1,1551},{3,1163},{4,1163}]','[{47050012,50}]',4),(47050012,36,'[{2,32692},{1,1635},{3,1226},{4,1226}]','[{47050012,52}]',4),(47050012,37,'[{2,34420},{1,1721},{3,1291},{4,1291}]','[{47050012,54}]',4),(47050012,38,'[{2,36196},{1,1810},{3,1358},{4,1358}]','[{47050012,56}]',4),(47050012,39,'[{2,38020},{1,1901},{3,1426},{4,1426}]','[{47050012,58}]',4),(47050012,40,'[{2,39892},{1,1995},{3,1496},{4,1496}]','[{47050012,60}]',5),(47050013,1,'[{2,700},{1,35},{3,25},{4,25}]','[{47050013,1}]',1),(47050013,2,'[{2,1282},{1,64},{3,46},{4,46}]','[{47050013,2}]',1),(47050013,3,'[{2,1944},{1,97},{3,70},{4,70}]','[{47050013,3}]',1),(47050013,4,'[{2,2687},{1,134},{3,97},{4,97}]','[{47050013,4}]',1),(47050013,5,'[{2,3511},{1,175},{3,126},{4,126}]','[{47050013,5}]',1),(47050013,6,'[{2,4416},{1,220},{3,158},{4,158}]','[{47050013,6}]',1),(47050013,7,'[{2,5401},{1,269},{3,193},{4,193}]','[{47050013,7}]',1),(47050013,8,'[{2,6467},{1,322},{3,231},{4,231}]','[{47050013,8}]',1),(47050013,9,'[{2,7614},{1,379},{3,272},{4,272}]','[{47050013,9}]',1),(47050013,10,'[{2,8842},{1,440},{3,316},{4,316}]','[{47050013,10}]',2),(47050013,11,'[{2,10150},{1,505},{3,363},{4,363}]','[{47050013,12}]',2),(47050013,12,'[{2,11539},{1,574},{3,413},{4,413}]','[{47050013,14}]',2),(47050013,13,'[{2,13009},{1,648},{3,466},{4,466}]','[{47050013,16}]',2),(47050013,14,'[{2,14560},{1,726},{3,521},{4,521}]','[{47050013,18}]',2),(47050013,15,'[{2,16192},{1,808},{3,579},{4,579}]','[{47050013,20}]',2),(47050013,16,'[{2,17931},{1,895},{3,641},{4,641}]','[{47050013,22}]',2),(47050013,17,'[{2,19778},{1,987},{3,707},{4,707}]','[{47050013,24}]',2),(47050013,18,'[{2,21733},{1,1085},{3,777},{4,777}]','[{47050013,26}]',2),(47050013,19,'[{2,23795},{1,1188},{3,851},{4,851}]','[{47050013,28}]',2),(47050013,20,'[{2,25965},{1,1297},{3,929},{4,929}]','[{47050013,30}]',3),(47050013,21,'[{2,28243},{1,1411},{3,1010},{4,1010}]','[{47050013,33}]',3),(47050013,22,'[{2,30628},{1,1530},{3,1095},{4,1095}]','[{47050013,36}]',3),(47050013,23,'[{2,33121},{1,1655},{3,1184},{4,1184}]','[{47050013,39}]',3),(47050013,24,'[{2,35722},{1,1785},{3,1277},{4,1277}]','[{47050013,42}]',3),(47050013,25,'[{2,38430},{1,1920},{3,1374},{4,1374}]','[{47050013,45}]',3),(47050013,26,'[{2,41246},{1,2061},{3,1475},{4,1475}]','[{47050013,48}]',3),(47050013,27,'[{2,44197},{1,2209},{3,1580},{4,1580}]','[{47050013,51}]',3),(47050013,28,'[{2,47282},{1,2363},{3,1690},{4,1690}]','[{47050013,54}]',3),(47050013,29,'[{2,50502},{1,2524},{3,1805},{4,1805}]','[{47050013,57}]',3),(47050013,30,'[{2,53857},{1,2692},{3,1925},{4,1925}]','[{47050013,60}]',4),(47050014,1,'[{2,1200},{1,60},{3,40},{4,40}]','[{47050014,1}]',1),(47050014,2,'[{2,2133},{1,110},{3,73},{4,73}]','[{47050014,2}]',1),(47050014,3,'[{2,3266},{1,167},{3,111},{4,111}]','[{47050014,3}]',1),(47050014,4,'[{2,4599},{1,234},{3,155},{4,155}]','[{47050014,4}]',1),(47050014,5,'[{2,6132},{1,311},{3,206},{4,206}]','[{47050014,5}]',1),(47050014,6,'[{2,7932},{1,401},{3,266},{4,266}]','[{47050014,7}]',1),(47050014,7,'[{2,9999},{1,504},{3,335},{4,335}]','[{47050014,9}]',1),(47050014,8,'[{2,12332},{1,621},{3,413},{4,413}]','[{47050014,11}]',1),(47050014,9,'[{2,14932},{1,751},{3,500},{4,500}]','[{47050014,13}]',1),(47050014,10,'[{2,17865},{1,898},{3,598},{4,598}]','[{47050014,15}]',2),(47050014,11,'[{2,21132},{1,1061},{3,707},{4,707}]','[{47050014,18}]',2),(47050014,12,'[{2,24732},{1,1241},{3,827},{4,827}]','[{47050014,21}]',2),(47050014,13,'[{2,28665},{1,1438},{3,958},{4,958}]','[{47050014,24}]',2),(47050014,14,'[{2,32932},{1,1651},{3,1100},{4,1100}]','[{47050014,27}]',2),(47050014,15,'[{2,37532},{1,1881},{3,1253},{4,1253}]','[{47050014,30}]',2),(47050014,16,'[{2,42532},{1,2131},{3,1420},{4,1420}]','[{47050014,34}]',2),(47050014,17,'[{2,47932},{1,2401},{3,1600},{4,1600}]','[{47050014,38}]',2),(47050014,18,'[{2,53732},{1,2691},{3,1793},{4,1793}]','[{47050014,42}]',2),(47050014,19,'[{2,59932},{1,3001},{3,2000},{4,2000}]','[{47050014,46}]',2),(47050014,20,'[{2,66532},{1,3331},{3,2220},{4,2220}]','[{47050014,50}]',3),(47050021,1,'[{2,200},{1,10},{3,8},{4,8}]','[{47050021,1}]',1),(47050021,2,'[{2,368},{1,18},{3,15},{4,15}]','[{47050021,2}]',1),(47050021,3,'[{2,558},{1,28},{3,23},{4,23}]','[{47050021,3}]',1),(47050021,4,'[{2,771},{1,39},{3,32},{4,32}]','[{47050021,4}]',1),(47050021,5,'[{2,1006},{1,51},{3,41},{4,41}]','[{47050021,5}]',1),(47050021,6,'[{2,1264},{1,64},{3,51},{4,51}]','[{47050021,6}]',1),(47050021,7,'[{2,1544},{1,78},{3,62},{4,62}]','[{47050021,7}]',1),(47050021,8,'[{2,1847},{1,93},{3,74},{4,74}]','[{47050021,8}]',1),(47050021,9,'[{2,2172},{1,109},{3,87},{4,87}]','[{47050021,9}]',1),(47050021,10,'[{2,2520},{1,126},{3,101},{4,101}]','[{47050021,10}]',2),(47050021,11,'[{2,2890},{1,145},{3,116},{4,116}]','[{47050021,11}]',2),(47050021,12,'[{2,3283},{1,165},{3,132},{4,132}]','[{47050021,12}]',2),(47050021,13,'[{2,3698},{1,186},{3,149},{4,149}]','[{47050021,13}]',2),(47050021,14,'[{2,4136},{1,208},{3,167},{4,167}]','[{47050021,14}]',2),(47050021,15,'[{2,4596},{1,231},{3,185},{4,185}]','[{47050021,15}]',2),(47050021,16,'[{2,5079},{1,255},{3,204},{4,204}]','[{47050021,16}]',2),(47050021,17,'[{2,5584},{1,280},{3,224},{4,224}]','[{47050021,17}]',2),(47050021,18,'[{2,6112},{1,306},{3,245},{4,245}]','[{47050021,18}]',2),(47050021,19,'[{2,6662},{1,334},{3,267},{4,267}]','[{47050021,19}]',2),(47050021,20,'[{2,7235},{1,363},{3,290},{4,290}]','[{47050021,20}]',3),(47050021,21,'[{2,7838},{1,393},{3,314},{4,314}]','[{47050021,22}]',3),(47050021,22,'[{2,8471},{1,425},{3,339},{4,339}]','[{47050021,24}]',3),(47050021,23,'[{2,9134},{1,458},{3,366},{4,366}]','[{47050021,26}]',3),(47050021,24,'[{2,9827},{1,493},{3,394},{4,394}]','[{47050021,28}]',3),(47050021,25,'[{2,10550},{1,529},{3,423},{4,423}]','[{47050021,30}]',3),(47050021,26,'[{2,11303},{1,567},{3,453},{4,453}]','[{47050021,32}]',3),(47050021,27,'[{2,12086},{1,606},{3,484},{4,484}]','[{47050021,34}]',3),(47050021,28,'[{2,12899},{1,647},{3,517},{4,517}]','[{47050021,36}]',3),(47050021,29,'[{2,13742},{1,689},{3,551},{4,551}]','[{47050021,38}]',3),(47050021,30,'[{2,14615},{1,733},{3,586},{4,586}]','[{47050021,40}]',4),(47050021,31,'[{2,15518},{1,778},{3,622},{4,622}]','[{47050021,42}]',4),(47050021,32,'[{2,16451},{1,825},{3,659},{4,659}]','[{47050021,44}]',4),(47050021,33,'[{2,17414},{1,873},{3,698},{4,698}]','[{47050021,46}]',4),(47050021,34,'[{2,18407},{1,923},{3,738},{4,738}]','[{47050021,48}]',4),(47050021,35,'[{2,19430},{1,974},{3,779},{4,779}]','[{47050021,50}]',4),(47050021,36,'[{2,20483},{1,1027},{3,821},{4,821}]','[{47050021,52}]',4),(47050021,37,'[{2,21566},{1,1081},{3,864},{4,864}]','[{47050021,54}]',4),(47050021,38,'[{2,22679},{1,1137},{3,909},{4,909}]','[{47050021,56}]',4),(47050021,39,'[{2,23822},{1,1194},{3,955},{4,955}]','[{47050021,58}]',4),(47050021,40,'[{2,24995},{1,1253},{3,1002},{4,1002}]','[{47050021,60}]',5),(47050022,1,'[{2,400},{1,20},{3,15},{4,15}]','[{47050022,1}]',1),(47050022,2,'[{2,664},{1,33},{3,25},{4,25}]','[{47050022,2}]',1),(47050022,3,'[{2,964},{1,48},{3,36},{4,36}]','[{47050022,3}]',1),(47050022,4,'[{2,1300},{1,65},{3,49},{4,49}]','[{47050022,4}]',1),(47050022,5,'[{2,1672},{1,84},{3,63},{4,63}]','[{47050022,5}]',1),(47050022,6,'[{2,2080},{1,104},{3,78},{4,78}]','[{47050022,6}]',1),(47050022,7,'[{2,2524},{1,126},{3,95},{4,95}]','[{47050022,7}]',1),(47050022,8,'[{2,3004},{1,150},{3,113},{4,113}]','[{47050022,8}]',1),(47050022,9,'[{2,3520},{1,176},{3,132},{4,132}]','[{47050022,9}]',1),(47050022,10,'[{2,4072},{1,204},{3,153},{4,153}]','[{47050022,10}]',2),(47050022,11,'[{2,4660},{1,233},{3,175},{4,175}]','[{47050022,11}]',2),(47050022,12,'[{2,5284},{1,264},{3,198},{4,198}]','[{47050022,12}]',2),(47050022,13,'[{2,5944},{1,297},{3,223},{4,223}]','[{47050022,13}]',2),(47050022,14,'[{2,6640},{1,332},{3,249},{4,249}]','[{47050022,14}]',2),(47050022,15,'[{2,7372},{1,369},{3,276},{4,276}]','[{47050022,15}]',2),(47050022,16,'[{2,8140},{1,407},{3,305},{4,305}]','[{47050022,16}]',2),(47050022,17,'[{2,8944},{1,447},{3,335},{4,335}]','[{47050022,17}]',2),(47050022,18,'[{2,9784},{1,489},{3,367},{4,367}]','[{47050022,18}]',2),(47050022,19,'[{2,10660},{1,533},{3,400},{4,400}]','[{47050022,19}]',2),(47050022,20,'[{2,11572},{1,579},{3,434},{4,434}]','[{47050022,20}]',3),(47050022,21,'[{2,12532},{1,627},{3,470},{4,470}]','[{47050022,22}]',3),(47050022,22,'[{2,13540},{1,677},{3,508},{4,508}]','[{47050022,24}]',3),(47050022,23,'[{2,14596},{1,730},{3,548},{4,548}]','[{47050022,26}]',3),(47050022,24,'[{2,15700},{1,785},{3,589},{4,589}]','[{47050022,28}]',3),(47050022,25,'[{2,16852},{1,843},{3,632},{4,632}]','[{47050022,30}]',3),(47050022,26,'[{2,18052},{1,903},{3,677},{4,677}]','[{47050022,32}]',3),(47050022,27,'[{2,19300},{1,965},{3,724},{4,724}]','[{47050022,34}]',3),(47050022,28,'[{2,20596},{1,1030},{3,773},{4,773}]','[{47050022,36}]',3),(47050022,29,'[{2,21940},{1,1097},{3,823},{4,823}]','[{47050022,38}]',3),(47050022,30,'[{2,23332},{1,1167},{3,875},{4,875}]','[{47050022,40}]',4),(47050022,31,'[{2,24772},{1,1239},{3,929},{4,929}]','[{47050022,42}]',4),(47050022,32,'[{2,26260},{1,1313},{3,985},{4,985}]','[{47050022,44}]',4),(47050022,33,'[{2,27796},{1,1390},{3,1043},{4,1043}]','[{47050022,46}]',4),(47050022,34,'[{2,29380},{1,1469},{3,1102},{4,1102}]','[{47050022,48}]',4),(47050022,35,'[{2,31012},{1,1551},{3,1163},{4,1163}]','[{47050022,50}]',4),(47050022,36,'[{2,32692},{1,1635},{3,1226},{4,1226}]','[{47050022,52}]',4),(47050022,37,'[{2,34420},{1,1721},{3,1291},{4,1291}]','[{47050022,54}]',4),(47050022,38,'[{2,36196},{1,1810},{3,1358},{4,1358}]','[{47050022,56}]',4),(47050022,39,'[{2,38020},{1,1901},{3,1426},{4,1426}]','[{47050022,58}]',4),(47050022,40,'[{2,39892},{1,1995},{3,1496},{4,1496}]','[{47050022,60}]',5),(47050023,1,'[{2,700},{1,35},{3,25},{4,25}]','[{47050023,1}]',1),(47050023,2,'[{2,1282},{1,64},{3,46},{4,46}]','[{47050023,2}]',1),(47050023,3,'[{2,1944},{1,97},{3,70},{4,70}]','[{47050023,3}]',1),(47050023,4,'[{2,2687},{1,134},{3,97},{4,97}]','[{47050023,4}]',1),(47050023,5,'[{2,3511},{1,175},{3,126},{4,126}]','[{47050023,5}]',1),(47050023,6,'[{2,4416},{1,220},{3,158},{4,158}]','[{47050023,6}]',1),(47050023,7,'[{2,5401},{1,269},{3,193},{4,193}]','[{47050023,7}]',1),(47050023,8,'[{2,6467},{1,322},{3,231},{4,231}]','[{47050023,8}]',1),(47050023,9,'[{2,7614},{1,379},{3,272},{4,272}]','[{47050023,9}]',1),(47050023,10,'[{2,8842},{1,440},{3,316},{4,316}]','[{47050023,10}]',2),(47050023,11,'[{2,10150},{1,505},{3,363},{4,363}]','[{47050023,12}]',2),(47050023,12,'[{2,11539},{1,574},{3,413},{4,413}]','[{47050023,14}]',2),(47050023,13,'[{2,13009},{1,648},{3,466},{4,466}]','[{47050023,16}]',2),(47050023,14,'[{2,14560},{1,726},{3,521},{4,521}]','[{47050023,18}]',2),(47050023,15,'[{2,16192},{1,808},{3,579},{4,579}]','[{47050023,20}]',2),(47050023,16,'[{2,17931},{1,895},{3,641},{4,641}]','[{47050023,22}]',2),(47050023,17,'[{2,19778},{1,987},{3,707},{4,707}]','[{47050023,24}]',2),(47050023,18,'[{2,21733},{1,1085},{3,777},{4,777}]','[{47050023,26}]',2),(47050023,19,'[{2,23795},{1,1188},{3,851},{4,851}]','[{47050023,28}]',2),(47050023,20,'[{2,25965},{1,1297},{3,929},{4,929}]','[{47050023,30}]',3),(47050023,21,'[{2,28243},{1,1411},{3,1010},{4,1010}]','[{47050023,33}]',3),(47050023,22,'[{2,30628},{1,1530},{3,1095},{4,1095}]','[{47050023,36}]',3),(47050023,23,'[{2,33121},{1,1655},{3,1184},{4,1184}]','[{47050023,39}]',3),(47050023,24,'[{2,35722},{1,1785},{3,1277},{4,1277}]','[{47050023,42}]',3),(47050023,25,'[{2,38430},{1,1920},{3,1374},{4,1374}]','[{47050023,45}]',3),(47050023,26,'[{2,41246},{1,2061},{3,1475},{4,1475}]','[{47050023,48}]',3),(47050023,27,'[{2,44197},{1,2209},{3,1580},{4,1580}]','[{47050023,51}]',3),(47050023,28,'[{2,47282},{1,2363},{3,1690},{4,1690}]','[{47050023,54}]',3),(47050023,29,'[{2,50502},{1,2524},{3,1805},{4,1805}]','[{47050023,57}]',3),(47050023,30,'[{2,53857},{1,2692},{3,1925},{4,1925}]','[{47050023,60}]',4),(47050024,1,'[{2,1200},{1,60},{3,40},{4,40}]','[{47050024,1}]',1),(47050024,2,'[{2,2133},{1,110},{3,73},{4,73}]','[{47050024,2}]',1),(47050024,3,'[{2,3266},{1,167},{3,111},{4,111}]','[{47050024,3}]',1),(47050024,4,'[{2,4599},{1,234},{3,155},{4,155}]','[{47050024,4}]',1),(47050024,5,'[{2,6132},{1,311},{3,206},{4,206}]','[{47050024,5}]',1),(47050024,6,'[{2,7932},{1,401},{3,266},{4,266}]','[{47050024,7}]',1),(47050024,7,'[{2,9999},{1,504},{3,335},{4,335}]','[{47050024,9}]',1),(47050024,8,'[{2,12332},{1,621},{3,413},{4,413}]','[{47050024,11}]',1),(47050024,9,'[{2,14932},{1,751},{3,500},{4,500}]','[{47050024,13}]',1),(47050024,10,'[{2,17865},{1,898},{3,598},{4,598}]','[{47050024,15}]',2),(47050024,11,'[{2,21132},{1,1061},{3,707},{4,707}]','[{47050024,18}]',2),(47050024,12,'[{2,24732},{1,1241},{3,827},{4,827}]','[{47050024,21}]',2),(47050024,13,'[{2,28665},{1,1438},{3,958},{4,958}]','[{47050024,24}]',2),(47050024,14,'[{2,32932},{1,1651},{3,1100},{4,1100}]','[{47050024,27}]',2),(47050024,15,'[{2,37532},{1,1881},{3,1253},{4,1253}]','[{47050024,30}]',2),(47050024,16,'[{2,42532},{1,2131},{3,1420},{4,1420}]','[{47050024,34}]',2),(47050024,17,'[{2,47932},{1,2401},{3,1600},{4,1600}]','[{47050024,38}]',2),(47050024,18,'[{2,53732},{1,2691},{3,1793},{4,1793}]','[{47050024,42}]',2),(47050024,19,'[{2,59932},{1,3001},{3,2000},{4,2000}]','[{47050024,46}]',2),(47050024,20,'[{2,66532},{1,3331},{3,2220},{4,2220}]','[{47050024,50}]',3),(47050031,1,'[{2,200},{1,10},{3,8},{4,8}]','[{47050031,1}]',1),(47050031,2,'[{2,368},{1,18},{3,15},{4,15}]','[{47050031,2}]',1),(47050031,3,'[{2,558},{1,28},{3,23},{4,23}]','[{47050031,3}]',1),(47050031,4,'[{2,771},{1,39},{3,32},{4,32}]','[{47050031,4}]',1),(47050031,5,'[{2,1006},{1,51},{3,41},{4,41}]','[{47050031,5}]',1),(47050031,6,'[{2,1264},{1,64},{3,51},{4,51}]','[{47050031,6}]',1),(47050031,7,'[{2,1544},{1,78},{3,62},{4,62}]','[{47050031,7}]',1),(47050031,8,'[{2,1847},{1,93},{3,74},{4,74}]','[{47050031,8}]',1),(47050031,9,'[{2,2172},{1,109},{3,87},{4,87}]','[{47050031,9}]',1),(47050031,10,'[{2,2520},{1,126},{3,101},{4,101}]','[{47050031,10}]',2),(47050031,11,'[{2,2890},{1,145},{3,116},{4,116}]','[{47050031,11}]',2),(47050031,12,'[{2,3283},{1,165},{3,132},{4,132}]','[{47050031,12}]',2),(47050031,13,'[{2,3698},{1,186},{3,149},{4,149}]','[{47050031,13}]',2),(47050031,14,'[{2,4136},{1,208},{3,167},{4,167}]','[{47050031,14}]',2),(47050031,15,'[{2,4596},{1,231},{3,185},{4,185}]','[{47050031,15}]',2),(47050031,16,'[{2,5079},{1,255},{3,204},{4,204}]','[{47050031,16}]',2),(47050031,17,'[{2,5584},{1,280},{3,224},{4,224}]','[{47050031,17}]',2),(47050031,18,'[{2,6112},{1,306},{3,245},{4,245}]','[{47050031,18}]',2),(47050031,19,'[{2,6662},{1,334},{3,267},{4,267}]','[{47050031,19}]',2),(47050031,20,'[{2,7235},{1,363},{3,290},{4,290}]','[{47050031,20}]',3),(47050031,21,'[{2,7838},{1,393},{3,314},{4,314}]','[{47050031,22}]',3),(47050031,22,'[{2,8471},{1,425},{3,339},{4,339}]','[{47050031,24}]',3),(47050031,23,'[{2,9134},{1,458},{3,366},{4,366}]','[{47050031,26}]',3),(47050031,24,'[{2,9827},{1,493},{3,394},{4,394}]','[{47050031,28}]',3),(47050031,25,'[{2,10550},{1,529},{3,423},{4,423}]','[{47050031,30}]',3),(47050031,26,'[{2,11303},{1,567},{3,453},{4,453}]','[{47050031,32}]',3),(47050031,27,'[{2,12086},{1,606},{3,484},{4,484}]','[{47050031,34}]',3),(47050031,28,'[{2,12899},{1,647},{3,517},{4,517}]','[{47050031,36}]',3),(47050031,29,'[{2,13742},{1,689},{3,551},{4,551}]','[{47050031,38}]',3),(47050031,30,'[{2,14615},{1,733},{3,586},{4,586}]','[{47050031,40}]',4),(47050031,31,'[{2,15518},{1,778},{3,622},{4,622}]','[{47050031,42}]',4),(47050031,32,'[{2,16451},{1,825},{3,659},{4,659}]','[{47050031,44}]',4),(47050031,33,'[{2,17414},{1,873},{3,698},{4,698}]','[{47050031,46}]',4),(47050031,34,'[{2,18407},{1,923},{3,738},{4,738}]','[{47050031,48}]',4),(47050031,35,'[{2,19430},{1,974},{3,779},{4,779}]','[{47050031,50}]',4),(47050031,36,'[{2,20483},{1,1027},{3,821},{4,821}]','[{47050031,52}]',4),(47050031,37,'[{2,21566},{1,1081},{3,864},{4,864}]','[{47050031,54}]',4),(47050031,38,'[{2,22679},{1,1137},{3,909},{4,909}]','[{47050031,56}]',4),(47050031,39,'[{2,23822},{1,1194},{3,955},{4,955}]','[{47050031,58}]',4),(47050031,40,'[{2,24995},{1,1253},{3,1002},{4,1002}]','[{47050031,60}]',5),(47050032,1,'[{2,400},{1,20},{3,15},{4,15}]','[{47050032,1}]',1),(47050032,2,'[{2,664},{1,33},{3,25},{4,25}]','[{47050032,2}]',1),(47050032,3,'[{2,964},{1,48},{3,36},{4,36}]','[{47050032,3}]',1),(47050032,4,'[{2,1300},{1,65},{3,49},{4,49}]','[{47050032,4}]',1),(47050032,5,'[{2,1672},{1,84},{3,63},{4,63}]','[{47050032,5}]',1),(47050032,6,'[{2,2080},{1,104},{3,78},{4,78}]','[{47050032,6}]',1),(47050032,7,'[{2,2524},{1,126},{3,95},{4,95}]','[{47050032,7}]',1),(47050032,8,'[{2,3004},{1,150},{3,113},{4,113}]','[{47050032,8}]',1),(47050032,9,'[{2,3520},{1,176},{3,132},{4,132}]','[{47050032,9}]',1),(47050032,10,'[{2,4072},{1,204},{3,153},{4,153}]','[{47050032,10}]',2),(47050032,11,'[{2,4660},{1,233},{3,175},{4,175}]','[{47050032,11}]',2),(47050032,12,'[{2,5284},{1,264},{3,198},{4,198}]','[{47050032,12}]',2),(47050032,13,'[{2,5944},{1,297},{3,223},{4,223}]','[{47050032,13}]',2),(47050032,14,'[{2,6640},{1,332},{3,249},{4,249}]','[{47050032,14}]',2),(47050032,15,'[{2,7372},{1,369},{3,276},{4,276}]','[{47050032,15}]',2),(47050032,16,'[{2,8140},{1,407},{3,305},{4,305}]','[{47050032,16}]',2),(47050032,17,'[{2,8944},{1,447},{3,335},{4,335}]','[{47050032,17}]',2),(47050032,18,'[{2,9784},{1,489},{3,367},{4,367}]','[{47050032,18}]',2),(47050032,19,'[{2,10660},{1,533},{3,400},{4,400}]','[{47050032,19}]',2),(47050032,20,'[{2,11572},{1,579},{3,434},{4,434}]','[{47050032,20}]',3),(47050032,21,'[{2,12532},{1,627},{3,470},{4,470}]','[{47050032,22}]',3),(47050032,22,'[{2,13540},{1,677},{3,508},{4,508}]','[{47050032,24}]',3),(47050032,23,'[{2,14596},{1,730},{3,548},{4,548}]','[{47050032,26}]',3),(47050032,24,'[{2,15700},{1,785},{3,589},{4,589}]','[{47050032,28}]',3),(47050032,25,'[{2,16852},{1,843},{3,632},{4,632}]','[{47050032,30}]',3),(47050032,26,'[{2,18052},{1,903},{3,677},{4,677}]','[{47050032,32}]',3),(47050032,27,'[{2,19300},{1,965},{3,724},{4,724}]','[{47050032,34}]',3),(47050032,28,'[{2,20596},{1,1030},{3,773},{4,773}]','[{47050032,36}]',3),(47050032,29,'[{2,21940},{1,1097},{3,823},{4,823}]','[{47050032,38}]',3),(47050032,30,'[{2,23332},{1,1167},{3,875},{4,875}]','[{47050032,40}]',4),(47050032,31,'[{2,24772},{1,1239},{3,929},{4,929}]','[{47050032,42}]',4),(47050032,32,'[{2,26260},{1,1313},{3,985},{4,985}]','[{47050032,44}]',4),(47050032,33,'[{2,27796},{1,1390},{3,1043},{4,1043}]','[{47050032,46}]',4),(47050032,34,'[{2,29380},{1,1469},{3,1102},{4,1102}]','[{47050032,48}]',4),(47050032,35,'[{2,31012},{1,1551},{3,1163},{4,1163}]','[{47050032,50}]',4),(47050032,36,'[{2,32692},{1,1635},{3,1226},{4,1226}]','[{47050032,52}]',4),(47050032,37,'[{2,34420},{1,1721},{3,1291},{4,1291}]','[{47050032,54}]',4),(47050032,38,'[{2,36196},{1,1810},{3,1358},{4,1358}]','[{47050032,56}]',4),(47050032,39,'[{2,38020},{1,1901},{3,1426},{4,1426}]','[{47050032,58}]',4),(47050032,40,'[{2,39892},{1,1995},{3,1496},{4,1496}]','[{47050032,60}]',5),(47050033,1,'[{2,700},{1,35},{3,25},{4,25}]','[{47050033,1}]',1),(47050033,2,'[{2,1282},{1,64},{3,46},{4,46}]','[{47050033,2}]',1),(47050033,3,'[{2,1944},{1,97},{3,70},{4,70}]','[{47050033,3}]',1),(47050033,4,'[{2,2687},{1,134},{3,97},{4,97}]','[{47050033,4}]',1),(47050033,5,'[{2,3511},{1,175},{3,126},{4,126}]','[{47050033,5}]',1),(47050033,6,'[{2,4416},{1,220},{3,158},{4,158}]','[{47050033,6}]',1),(47050033,7,'[{2,5401},{1,269},{3,193},{4,193}]','[{47050033,7}]',1),(47050033,8,'[{2,6467},{1,322},{3,231},{4,231}]','[{47050033,8}]',1),(47050033,9,'[{2,7614},{1,379},{3,272},{4,272}]','[{47050033,9}]',1),(47050033,10,'[{2,8842},{1,440},{3,316},{4,316}]','[{47050033,10}]',2),(47050033,11,'[{2,10150},{1,505},{3,363},{4,363}]','[{47050033,12}]',2),(47050033,12,'[{2,11539},{1,574},{3,413},{4,413}]','[{47050033,14}]',2),(47050033,13,'[{2,13009},{1,648},{3,466},{4,466}]','[{47050033,16}]',2),(47050033,14,'[{2,14560},{1,726},{3,521},{4,521}]','[{47050033,18}]',2),(47050033,15,'[{2,16192},{1,808},{3,579},{4,579}]','[{47050033,20}]',2),(47050033,16,'[{2,17931},{1,895},{3,641},{4,641}]','[{47050033,22}]',2),(47050033,17,'[{2,19778},{1,987},{3,707},{4,707}]','[{47050033,24}]',2),(47050033,18,'[{2,21733},{1,1085},{3,777},{4,777}]','[{47050033,26}]',2),(47050033,19,'[{2,23795},{1,1188},{3,851},{4,851}]','[{47050033,28}]',2),(47050033,20,'[{2,25965},{1,1297},{3,929},{4,929}]','[{47050033,30}]',3),(47050033,21,'[{2,28243},{1,1411},{3,1010},{4,1010}]','[{47050033,33}]',3),(47050033,22,'[{2,30628},{1,1530},{3,1095},{4,1095}]','[{47050033,36}]',3),(47050033,23,'[{2,33121},{1,1655},{3,1184},{4,1184}]','[{47050033,39}]',3),(47050033,24,'[{2,35722},{1,1785},{3,1277},{4,1277}]','[{47050033,42}]',3),(47050033,25,'[{2,38430},{1,1920},{3,1374},{4,1374}]','[{47050033,45}]',3),(47050033,26,'[{2,41246},{1,2061},{3,1475},{4,1475}]','[{47050033,48}]',3),(47050033,27,'[{2,44197},{1,2209},{3,1580},{4,1580}]','[{47050033,51}]',3),(47050033,28,'[{2,47282},{1,2363},{3,1690},{4,1690}]','[{47050033,54}]',3),(47050033,29,'[{2,50502},{1,2524},{3,1805},{4,1805}]','[{47050033,57}]',3),(47050033,30,'[{2,53857},{1,2692},{3,1925},{4,1925}]','[{47050033,60}]',4),(47050034,1,'[{2,1200},{1,60},{3,40},{4,40}]','[{47050034,1}]',1),(47050034,2,'[{2,2133},{1,110},{3,73},{4,73}]','[{47050034,2}]',1),(47050034,3,'[{2,3266},{1,167},{3,111},{4,111}]','[{47050034,3}]',1),(47050034,4,'[{2,4599},{1,234},{3,155},{4,155}]','[{47050034,4}]',1),(47050034,5,'[{2,6132},{1,311},{3,206},{4,206}]','[{47050034,5}]',1),(47050034,6,'[{2,7932},{1,401},{3,266},{4,266}]','[{47050034,7}]',1),(47050034,7,'[{2,9999},{1,504},{3,335},{4,335}]','[{47050034,9}]',1),(47050034,8,'[{2,12332},{1,621},{3,413},{4,413}]','[{47050034,11}]',1),(47050034,9,'[{2,14932},{1,751},{3,500},{4,500}]','[{47050034,13}]',1),(47050034,10,'[{2,17865},{1,898},{3,598},{4,598}]','[{47050034,15}]',2),(47050034,11,'[{2,21132},{1,1061},{3,707},{4,707}]','[{47050034,18}]',2),(47050034,12,'[{2,24732},{1,1241},{3,827},{4,827}]','[{47050034,21}]',2),(47050034,13,'[{2,28665},{1,1438},{3,958},{4,958}]','[{47050034,24}]',2),(47050034,14,'[{2,32932},{1,1651},{3,1100},{4,1100}]','[{47050034,27}]',2),(47050034,15,'[{2,37532},{1,1881},{3,1253},{4,1253}]','[{47050034,30}]',2),(47050034,16,'[{2,42532},{1,2131},{3,1420},{4,1420}]','[{47050034,34}]',2),(47050034,17,'[{2,47932},{1,2401},{3,1600},{4,1600}]','[{47050034,38}]',2),(47050034,18,'[{2,53732},{1,2691},{3,1793},{4,1793}]','[{47050034,42}]',2),(47050034,19,'[{2,59932},{1,3001},{3,2000},{4,2000}]','[{47050034,46}]',2),(47050034,20,'[{2,66532},{1,3331},{3,2220},{4,2220}]','[{47050034,50}]',3),(47050041,1,'[{2,5000},{1,250},{3,200},{4,200},{231,200}]','[{47050041,1}]',1),(47050041,2,'[{2,8000},{1,400},{3,320},{4,320},{231,240}]','[{47050041,2}]',1),(47050041,3,'[{2,11400},{1,570},{3,456},{4,456},{231,280}]','[{47050041,3}]',1),(47050041,4,'[{2,15300},{1,765},{3,612},{4,612},{231,340}]','[{47050041,4}]',1),(47050041,5,'[{2,19700},{1,985},{3,788},{4,788},{231,400}]','[{47050041,5}]',1),(47050041,6,'[{2,24600},{1,1230},{3,984},{4,984},{231,480}]','[{47050041,7}]',1),(47050041,7,'[{2,30100},{1,1505},{3,1204},{4,1204},{231,560}]','[{47050041,9}]',1),(47050041,8,'[{2,36200},{1,1810},{3,1448},{4,1448},{231,660}]','[{47050041,11}]',1),(47050041,9,'[{2,43000},{1,2150},{3,1720},{4,1720},{231,760}]','[{47050041,13}]',1),(47050041,10,'[{2,50500},{1,2525},{3,2020},{4,2020},{231,880}]','[{47050041,15}]',2),(47050041,11,'[{2,58700},{1,2935},{3,2348},{4,2348},{231,1000}]','[{47050041,18}]',2),(47050041,12,'[{2,67700},{1,3385},{3,2708},{4,2708},{231,1140}]','[{47050041,21}]',2),(47050041,13,'[{2,77500},{1,3875},{3,3100},{4,3100},{231,1280}]','[{47050041,24}]',2),(47050041,14,'[{2,88200},{1,4410},{3,3528},{4,3528},{231,1440}]','[{47050041,27}]',2),(47050041,15,'[{2,99900},{1,4995},{3,3996},{4,3996},{231,1600}]','[{47050041,30}]',2),(47050051,1,'[{2,5000},{1,250},{3,200},{4,200},{27,150}]','[{47050051,1}]',1),(47050051,2,'[{2,8000},{1,400},{3,320},{4,320},{27,180}]','[{47050051,2}]',1),(47050051,3,'[{2,11400},{1,570},{3,456},{4,456},{27,210}]','[{47050051,3}]',1),(47050051,4,'[{2,15300},{1,765},{3,612},{4,612},{27,255}]','[{47050051,4}]',1),(47050051,5,'[{2,19700},{1,985},{3,788},{4,788},{27,300}]','[{47050051,5}]',1),(47050051,6,'[{2,24600},{1,1230},{3,984},{4,984},{27,360}]','[{47050051,7}]',1),(47050051,7,'[{2,30100},{1,1505},{3,1204},{4,1204},{27,420}]','[{47050051,9}]',1),(47050051,8,'[{2,36200},{1,1810},{3,1448},{4,1448},{27,495}]','[{47050051,11}]',1),(47050051,9,'[{2,43000},{1,2150},{3,1720},{4,1720},{27,570}]','[{47050051,13}]',1),(47050051,10,'[{2,50500},{1,2525},{3,2020},{4,2020},{27,660}]','[{47050051,15}]',2),(47050051,11,'[{2,58700},{1,2935},{3,2348},{4,2348},{27,750}]','[{47050051,18}]',2),(47050051,12,'[{2,67700},{1,3385},{3,2708},{4,2708},{27,855}]','[{47050051,21}]',2),(47050051,13,'[{2,77500},{1,3875},{3,3100},{4,3100},{27,960}]','[{47050051,24}]',2),(47050051,14,'[{2,88200},{1,4410},{3,3528},{4,3528},{27,1080}]','[{47050051,27}]',2),(47050051,15,'[{2,99900},{1,4995},{3,3996},{4,3996},{27,1200}]','[{47050051,30}]',2),(47050061,1,'[{2,5000},{1,250},{3,200},{4,200},{28,150}]','[{47050061,1}]',1),(47050061,2,'[{2,8000},{1,400},{3,320},{4,320},{28,180}]','[{47050061,2}]',1),(47050061,3,'[{2,11400},{1,570},{3,456},{4,456},{28,210}]','[{47050061,3}]',1),(47050061,4,'[{2,15300},{1,765},{3,612},{4,612},{28,255}]','[{47050061,4}]',1),(47050061,5,'[{2,19700},{1,985},{3,788},{4,788},{28,300}]','[{47050061,5}]',1),(47050061,6,'[{2,24600},{1,1230},{3,984},{4,984},{28,360}]','[{47050061,7}]',1),(47050061,7,'[{2,30100},{1,1505},{3,1204},{4,1204},{28,420}]','[{47050061,9}]',1),(47050061,8,'[{2,36200},{1,1810},{3,1448},{4,1448},{28,495}]','[{47050061,11}]',1),(47050061,9,'[{2,43000},{1,2150},{3,1720},{4,1720},{28,570}]','[{47050061,13}]',1),(47050061,10,'[{2,50500},{1,2525},{3,2020},{4,2020},{28,660}]','[{47050061,15}]',2),(47050061,11,'[{2,58700},{1,2935},{3,2348},{4,2348},{28,750}]','[{47050061,18}]',2),(47050061,12,'[{2,67700},{1,3385},{3,2708},{4,2708},{28,855}]','[{47050061,21}]',2),(47050061,13,'[{2,77500},{1,3875},{3,3100},{4,3100},{28,960}]','[{47050061,24}]',2),(47050061,14,'[{2,88200},{1,4410},{3,3528},{4,3528},{28,1080}]','[{47050061,27}]',2),(47050061,15,'[{2,99900},{1,4995},{3,3996},{4,3996},{28,1200}]','[{47050061,30}]',2),(47060011,1,'[{2,200},{1,10},{3,8},{4,8}]','[{47060011,1}]',1),(47060011,2,'[{2,368},{1,18},{3,15},{4,15}]','[{47060011,2}]',1),(47060011,3,'[{2,558},{1,28},{3,23},{4,23}]','[{47060011,3}]',1),(47060011,4,'[{2,771},{1,39},{3,32},{4,32}]','[{47060011,4}]',1),(47060011,5,'[{2,1006},{1,51},{3,41},{4,41}]','[{47060011,5}]',1),(47060011,6,'[{2,1264},{1,64},{3,51},{4,51}]','[{47060011,6}]',1),(47060011,7,'[{2,1544},{1,78},{3,62},{4,62}]','[{47060011,7}]',1),(47060011,8,'[{2,1847},{1,93},{3,74},{4,74}]','[{47060011,8}]',1),(47060011,9,'[{2,2172},{1,109},{3,87},{4,87}]','[{47060011,9}]',1),(47060011,10,'[{2,2520},{1,126},{3,101},{4,101}]','[{47060011,10}]',2),(47060011,11,'[{2,2890},{1,145},{3,116},{4,116}]','[{47060011,11}]',2),(47060011,12,'[{2,3283},{1,165},{3,132},{4,132}]','[{47060011,12}]',2),(47060011,13,'[{2,3698},{1,186},{3,149},{4,149}]','[{47060011,13}]',2),(47060011,14,'[{2,4136},{1,208},{3,167},{4,167}]','[{47060011,14}]',2),(47060011,15,'[{2,4596},{1,231},{3,185},{4,185}]','[{47060011,15}]',2),(47060011,16,'[{2,5079},{1,255},{3,204},{4,204}]','[{47060011,16}]',2),(47060011,17,'[{2,5584},{1,280},{3,224},{4,224}]','[{47060011,17}]',2),(47060011,18,'[{2,6112},{1,306},{3,245},{4,245}]','[{47060011,18}]',2),(47060011,19,'[{2,6662},{1,334},{3,267},{4,267}]','[{47060011,19}]',2),(47060011,20,'[{2,7235},{1,363},{3,290},{4,290}]','[{47060011,20}]',3),(47060011,21,'[{2,7838},{1,393},{3,314},{4,314}]','[{47060011,22}]',3),(47060011,22,'[{2,8471},{1,425},{3,339},{4,339}]','[{47060011,24}]',3),(47060011,23,'[{2,9134},{1,458},{3,366},{4,366}]','[{47060011,26}]',3),(47060011,24,'[{2,9827},{1,493},{3,394},{4,394}]','[{47060011,28}]',3),(47060011,25,'[{2,10550},{1,529},{3,423},{4,423}]','[{47060011,30}]',3),(47060011,26,'[{2,11303},{1,567},{3,453},{4,453}]','[{47060011,32}]',3),(47060011,27,'[{2,12086},{1,606},{3,484},{4,484}]','[{47060011,34}]',3),(47060011,28,'[{2,12899},{1,647},{3,517},{4,517}]','[{47060011,36}]',3),(47060011,29,'[{2,13742},{1,689},{3,551},{4,551}]','[{47060011,38}]',3),(47060011,30,'[{2,14615},{1,733},{3,586},{4,586}]','[{47060011,40}]',4),(47060011,31,'[{2,15518},{1,778},{3,622},{4,622}]','[{47060011,42}]',4),(47060011,32,'[{2,16451},{1,825},{3,659},{4,659}]','[{47060011,44}]',4),(47060011,33,'[{2,17414},{1,873},{3,698},{4,698}]','[{47060011,46}]',4),(47060011,34,'[{2,18407},{1,923},{3,738},{4,738}]','[{47060011,48}]',4),(47060011,35,'[{2,19430},{1,974},{3,779},{4,779}]','[{47060011,50}]',4),(47060011,36,'[{2,20483},{1,1027},{3,821},{4,821}]','[{47060011,52}]',4),(47060011,37,'[{2,21566},{1,1081},{3,864},{4,864}]','[{47060011,54}]',4),(47060011,38,'[{2,22679},{1,1137},{3,909},{4,909}]','[{47060011,56}]',4),(47060011,39,'[{2,23822},{1,1194},{3,955},{4,955}]','[{47060011,58}]',4),(47060011,40,'[{2,24995},{1,1253},{3,1002},{4,1002}]','[{47060011,60}]',5),(47060012,1,'[{2,400},{1,20},{3,15},{4,15}]','[{47060012,1}]',1),(47060012,2,'[{2,664},{1,33},{3,25},{4,25}]','[{47060012,2}]',1),(47060012,3,'[{2,964},{1,48},{3,36},{4,36}]','[{47060012,3}]',1),(47060012,4,'[{2,1300},{1,65},{3,49},{4,49}]','[{47060012,4}]',1),(47060012,5,'[{2,1672},{1,84},{3,63},{4,63}]','[{47060012,5}]',1),(47060012,6,'[{2,2080},{1,104},{3,78},{4,78}]','[{47060012,6}]',1),(47060012,7,'[{2,2524},{1,126},{3,95},{4,95}]','[{47060012,7}]',1),(47060012,8,'[{2,3004},{1,150},{3,113},{4,113}]','[{47060012,8}]',1),(47060012,9,'[{2,3520},{1,176},{3,132},{4,132}]','[{47060012,9}]',1),(47060012,10,'[{2,4072},{1,204},{3,153},{4,153}]','[{47060012,10}]',2),(47060012,11,'[{2,4660},{1,233},{3,175},{4,175}]','[{47060012,11}]',2),(47060012,12,'[{2,5284},{1,264},{3,198},{4,198}]','[{47060012,12}]',2),(47060012,13,'[{2,5944},{1,297},{3,223},{4,223}]','[{47060012,13}]',2),(47060012,14,'[{2,6640},{1,332},{3,249},{4,249}]','[{47060012,14}]',2),(47060012,15,'[{2,7372},{1,369},{3,276},{4,276}]','[{47060012,15}]',2),(47060012,16,'[{2,8140},{1,407},{3,305},{4,305}]','[{47060012,16}]',2),(47060012,17,'[{2,8944},{1,447},{3,335},{4,335}]','[{47060012,17}]',2),(47060012,18,'[{2,9784},{1,489},{3,367},{4,367}]','[{47060012,18}]',2),(47060012,19,'[{2,10660},{1,533},{3,400},{4,400}]','[{47060012,19}]',2),(47060012,20,'[{2,11572},{1,579},{3,434},{4,434}]','[{47060012,20}]',3),(47060012,21,'[{2,12532},{1,627},{3,470},{4,470}]','[{47060012,22}]',3),(47060012,22,'[{2,13540},{1,677},{3,508},{4,508}]','[{47060012,24}]',3),(47060012,23,'[{2,14596},{1,730},{3,548},{4,548}]','[{47060012,26}]',3),(47060012,24,'[{2,15700},{1,785},{3,589},{4,589}]','[{47060012,28}]',3),(47060012,25,'[{2,16852},{1,843},{3,632},{4,632}]','[{47060012,30}]',3),(47060012,26,'[{2,18052},{1,903},{3,677},{4,677}]','[{47060012,32}]',3),(47060012,27,'[{2,19300},{1,965},{3,724},{4,724}]','[{47060012,34}]',3),(47060012,28,'[{2,20596},{1,1030},{3,773},{4,773}]','[{47060012,36}]',3),(47060012,29,'[{2,21940},{1,1097},{3,823},{4,823}]','[{47060012,38}]',3),(47060012,30,'[{2,23332},{1,1167},{3,875},{4,875}]','[{47060012,40}]',4),(47060012,31,'[{2,24772},{1,1239},{3,929},{4,929}]','[{47060012,42}]',4),(47060012,32,'[{2,26260},{1,1313},{3,985},{4,985}]','[{47060012,44}]',4),(47060012,33,'[{2,27796},{1,1390},{3,1043},{4,1043}]','[{47060012,46}]',4),(47060012,34,'[{2,29380},{1,1469},{3,1102},{4,1102}]','[{47060012,48}]',4),(47060012,35,'[{2,31012},{1,1551},{3,1163},{4,1163}]','[{47060012,50}]',4),(47060012,36,'[{2,32692},{1,1635},{3,1226},{4,1226}]','[{47060012,52}]',4),(47060012,37,'[{2,34420},{1,1721},{3,1291},{4,1291}]','[{47060012,54}]',4),(47060012,38,'[{2,36196},{1,1810},{3,1358},{4,1358}]','[{47060012,56}]',4),(47060012,39,'[{2,38020},{1,1901},{3,1426},{4,1426}]','[{47060012,58}]',4),(47060012,40,'[{2,39892},{1,1995},{3,1496},{4,1496}]','[{47060012,60}]',5),(47060013,1,'[{2,700},{1,35},{3,25},{4,25}]','[{47060013,1}]',1),(47060013,2,'[{2,1282},{1,64},{3,46},{4,46}]','[{47060013,2}]',1),(47060013,3,'[{2,1944},{1,97},{3,70},{4,70}]','[{47060013,3}]',1),(47060013,4,'[{2,2687},{1,134},{3,97},{4,97}]','[{47060013,4}]',1),(47060013,5,'[{2,3511},{1,175},{3,126},{4,126}]','[{47060013,5}]',1),(47060013,6,'[{2,4416},{1,220},{3,158},{4,158}]','[{47060013,6}]',1),(47060013,7,'[{2,5401},{1,269},{3,193},{4,193}]','[{47060013,7}]',1),(47060013,8,'[{2,6467},{1,322},{3,231},{4,231}]','[{47060013,8}]',1),(47060013,9,'[{2,7614},{1,379},{3,272},{4,272}]','[{47060013,9}]',1),(47060013,10,'[{2,8842},{1,440},{3,316},{4,316}]','[{47060013,10}]',2),(47060013,11,'[{2,10150},{1,505},{3,363},{4,363}]','[{47060013,12}]',2),(47060013,12,'[{2,11539},{1,574},{3,413},{4,413}]','[{47060013,14}]',2),(47060013,13,'[{2,13009},{1,648},{3,466},{4,466}]','[{47060013,16}]',2),(47060013,14,'[{2,14560},{1,726},{3,521},{4,521}]','[{47060013,18}]',2),(47060013,15,'[{2,16192},{1,808},{3,579},{4,579}]','[{47060013,20}]',2),(47060013,16,'[{2,17931},{1,895},{3,641},{4,641}]','[{47060013,22}]',2),(47060013,17,'[{2,19778},{1,987},{3,707},{4,707}]','[{47060013,24}]',2),(47060013,18,'[{2,21733},{1,1085},{3,777},{4,777}]','[{47060013,26}]',2),(47060013,19,'[{2,23795},{1,1188},{3,851},{4,851}]','[{47060013,28}]',2),(47060013,20,'[{2,25965},{1,1297},{3,929},{4,929}]','[{47060013,30}]',3),(47060013,21,'[{2,28243},{1,1411},{3,1010},{4,1010}]','[{47060013,33}]',3),(47060013,22,'[{2,30628},{1,1530},{3,1095},{4,1095}]','[{47060013,36}]',3),(47060013,23,'[{2,33121},{1,1655},{3,1184},{4,1184}]','[{47060013,39}]',3),(47060013,24,'[{2,35722},{1,1785},{3,1277},{4,1277}]','[{47060013,42}]',3),(47060013,25,'[{2,38430},{1,1920},{3,1374},{4,1374}]','[{47060013,45}]',3),(47060013,26,'[{2,41246},{1,2061},{3,1475},{4,1475}]','[{47060013,48}]',3),(47060013,27,'[{2,44197},{1,2209},{3,1580},{4,1580}]','[{47060013,51}]',3),(47060013,28,'[{2,47282},{1,2363},{3,1690},{4,1690}]','[{47060013,54}]',3),(47060013,29,'[{2,50502},{1,2524},{3,1805},{4,1805}]','[{47060013,57}]',3),(47060013,30,'[{2,53857},{1,2692},{3,1925},{4,1925}]','[{47060013,60}]',4),(47060014,1,'[{2,1200},{1,60},{3,40},{4,40}]','[{47060014,1}]',1),(47060014,2,'[{2,2133},{1,110},{3,73},{4,73}]','[{47060014,2}]',1),(47060014,3,'[{2,3266},{1,167},{3,111},{4,111}]','[{47060014,3}]',1),(47060014,4,'[{2,4599},{1,234},{3,155},{4,155}]','[{47060014,4}]',1),(47060014,5,'[{2,6132},{1,311},{3,206},{4,206}]','[{47060014,5}]',1),(47060014,6,'[{2,7932},{1,401},{3,266},{4,266}]','[{47060014,7}]',1),(47060014,7,'[{2,9999},{1,504},{3,335},{4,335}]','[{47060014,9}]',1),(47060014,8,'[{2,12332},{1,621},{3,413},{4,413}]','[{47060014,11}]',1),(47060014,9,'[{2,14932},{1,751},{3,500},{4,500}]','[{47060014,13}]',1),(47060014,10,'[{2,17865},{1,898},{3,598},{4,598}]','[{47060014,15}]',2),(47060014,11,'[{2,21132},{1,1061},{3,707},{4,707}]','[{47060014,18}]',2),(47060014,12,'[{2,24732},{1,1241},{3,827},{4,827}]','[{47060014,21}]',2),(47060014,13,'[{2,28665},{1,1438},{3,958},{4,958}]','[{47060014,24}]',2),(47060014,14,'[{2,32932},{1,1651},{3,1100},{4,1100}]','[{47060014,27}]',2),(47060014,15,'[{2,37532},{1,1881},{3,1253},{4,1253}]','[{47060014,30}]',2),(47060014,16,'[{2,42532},{1,2131},{3,1420},{4,1420}]','[{47060014,34}]',2),(47060014,17,'[{2,47932},{1,2401},{3,1600},{4,1600}]','[{47060014,38}]',2),(47060014,18,'[{2,53732},{1,2691},{3,1793},{4,1793}]','[{47060014,42}]',2),(47060014,19,'[{2,59932},{1,3001},{3,2000},{4,2000}]','[{47060014,46}]',2),(47060014,20,'[{2,66532},{1,3331},{3,2220},{4,2220}]','[{47060014,50}]',3),(47060021,1,'[{2,200},{1,10},{3,8},{4,8}]','[{47060021,1}]',1),(47060021,2,'[{2,368},{1,18},{3,15},{4,15}]','[{47060021,2}]',1),(47060021,3,'[{2,558},{1,28},{3,23},{4,23}]','[{47060021,3}]',1),(47060021,4,'[{2,771},{1,39},{3,32},{4,32}]','[{47060021,4}]',1),(47060021,5,'[{2,1006},{1,51},{3,41},{4,41}]','[{47060021,5}]',1),(47060021,6,'[{2,1264},{1,64},{3,51},{4,51}]','[{47060021,6}]',1),(47060021,7,'[{2,1544},{1,78},{3,62},{4,62}]','[{47060021,7}]',1),(47060021,8,'[{2,1847},{1,93},{3,74},{4,74}]','[{47060021,8}]',1),(47060021,9,'[{2,2172},{1,109},{3,87},{4,87}]','[{47060021,9}]',1),(47060021,10,'[{2,2520},{1,126},{3,101},{4,101}]','[{47060021,10}]',2),(47060021,11,'[{2,2890},{1,145},{3,116},{4,116}]','[{47060021,11}]',2),(47060021,12,'[{2,3283},{1,165},{3,132},{4,132}]','[{47060021,12}]',2),(47060021,13,'[{2,3698},{1,186},{3,149},{4,149}]','[{47060021,13}]',2),(47060021,14,'[{2,4136},{1,208},{3,167},{4,167}]','[{47060021,14}]',2),(47060021,15,'[{2,4596},{1,231},{3,185},{4,185}]','[{47060021,15}]',2),(47060021,16,'[{2,5079},{1,255},{3,204},{4,204}]','[{47060021,16}]',2),(47060021,17,'[{2,5584},{1,280},{3,224},{4,224}]','[{47060021,17}]',2),(47060021,18,'[{2,6112},{1,306},{3,245},{4,245}]','[{47060021,18}]',2),(47060021,19,'[{2,6662},{1,334},{3,267},{4,267}]','[{47060021,19}]',2),(47060021,20,'[{2,7235},{1,363},{3,290},{4,290}]','[{47060021,20}]',3),(47060021,21,'[{2,7838},{1,393},{3,314},{4,314}]','[{47060021,22}]',3),(47060021,22,'[{2,8471},{1,425},{3,339},{4,339}]','[{47060021,24}]',3),(47060021,23,'[{2,9134},{1,458},{3,366},{4,366}]','[{47060021,26}]',3),(47060021,24,'[{2,9827},{1,493},{3,394},{4,394}]','[{47060021,28}]',3),(47060021,25,'[{2,10550},{1,529},{3,423},{4,423}]','[{47060021,30}]',3),(47060021,26,'[{2,11303},{1,567},{3,453},{4,453}]','[{47060021,32}]',3),(47060021,27,'[{2,12086},{1,606},{3,484},{4,484}]','[{47060021,34}]',3),(47060021,28,'[{2,12899},{1,647},{3,517},{4,517}]','[{47060021,36}]',3),(47060021,29,'[{2,13742},{1,689},{3,551},{4,551}]','[{47060021,38}]',3),(47060021,30,'[{2,14615},{1,733},{3,586},{4,586}]','[{47060021,40}]',4),(47060021,31,'[{2,15518},{1,778},{3,622},{4,622}]','[{47060021,42}]',4),(47060021,32,'[{2,16451},{1,825},{3,659},{4,659}]','[{47060021,44}]',4),(47060021,33,'[{2,17414},{1,873},{3,698},{4,698}]','[{47060021,46}]',4),(47060021,34,'[{2,18407},{1,923},{3,738},{4,738}]','[{47060021,48}]',4),(47060021,35,'[{2,19430},{1,974},{3,779},{4,779}]','[{47060021,50}]',4),(47060021,36,'[{2,20483},{1,1027},{3,821},{4,821}]','[{47060021,52}]',4),(47060021,37,'[{2,21566},{1,1081},{3,864},{4,864}]','[{47060021,54}]',4),(47060021,38,'[{2,22679},{1,1137},{3,909},{4,909}]','[{47060021,56}]',4),(47060021,39,'[{2,23822},{1,1194},{3,955},{4,955}]','[{47060021,58}]',4),(47060021,40,'[{2,24995},{1,1253},{3,1002},{4,1002}]','[{47060021,60}]',5),(47060022,1,'[{2,400},{1,20},{3,15},{4,15}]','[{47060022,1}]',1),(47060022,2,'[{2,664},{1,33},{3,25},{4,25}]','[{47060022,2}]',1),(47060022,3,'[{2,964},{1,48},{3,36},{4,36}]','[{47060022,3}]',1),(47060022,4,'[{2,1300},{1,65},{3,49},{4,49}]','[{47060022,4}]',1),(47060022,5,'[{2,1672},{1,84},{3,63},{4,63}]','[{47060022,5}]',1),(47060022,6,'[{2,2080},{1,104},{3,78},{4,78}]','[{47060022,6}]',1),(47060022,7,'[{2,2524},{1,126},{3,95},{4,95}]','[{47060022,7}]',1),(47060022,8,'[{2,3004},{1,150},{3,113},{4,113}]','[{47060022,8}]',1),(47060022,9,'[{2,3520},{1,176},{3,132},{4,132}]','[{47060022,9}]',1),(47060022,10,'[{2,4072},{1,204},{3,153},{4,153}]','[{47060022,10}]',2),(47060022,11,'[{2,4660},{1,233},{3,175},{4,175}]','[{47060022,11}]',2),(47060022,12,'[{2,5284},{1,264},{3,198},{4,198}]','[{47060022,12}]',2),(47060022,13,'[{2,5944},{1,297},{3,223},{4,223}]','[{47060022,13}]',2),(47060022,14,'[{2,6640},{1,332},{3,249},{4,249}]','[{47060022,14}]',2),(47060022,15,'[{2,7372},{1,369},{3,276},{4,276}]','[{47060022,15}]',2),(47060022,16,'[{2,8140},{1,407},{3,305},{4,305}]','[{47060022,16}]',2),(47060022,17,'[{2,8944},{1,447},{3,335},{4,335}]','[{47060022,17}]',2),(47060022,18,'[{2,9784},{1,489},{3,367},{4,367}]','[{47060022,18}]',2),(47060022,19,'[{2,10660},{1,533},{3,400},{4,400}]','[{47060022,19}]',2),(47060022,20,'[{2,11572},{1,579},{3,434},{4,434}]','[{47060022,20}]',3),(47060022,21,'[{2,12532},{1,627},{3,470},{4,470}]','[{47060022,22}]',3),(47060022,22,'[{2,13540},{1,677},{3,508},{4,508}]','[{47060022,24}]',3),(47060022,23,'[{2,14596},{1,730},{3,548},{4,548}]','[{47060022,26}]',3),(47060022,24,'[{2,15700},{1,785},{3,589},{4,589}]','[{47060022,28}]',3),(47060022,25,'[{2,16852},{1,843},{3,632},{4,632}]','[{47060022,30}]',3),(47060022,26,'[{2,18052},{1,903},{3,677},{4,677}]','[{47060022,32}]',3),(47060022,27,'[{2,19300},{1,965},{3,724},{4,724}]','[{47060022,34}]',3),(47060022,28,'[{2,20596},{1,1030},{3,773},{4,773}]','[{47060022,36}]',3),(47060022,29,'[{2,21940},{1,1097},{3,823},{4,823}]','[{47060022,38}]',3),(47060022,30,'[{2,23332},{1,1167},{3,875},{4,875}]','[{47060022,40}]',4),(47060022,31,'[{2,24772},{1,1239},{3,929},{4,929}]','[{47060022,42}]',4),(47060022,32,'[{2,26260},{1,1313},{3,985},{4,985}]','[{47060022,44}]',4),(47060022,33,'[{2,27796},{1,1390},{3,1043},{4,1043}]','[{47060022,46}]',4),(47060022,34,'[{2,29380},{1,1469},{3,1102},{4,1102}]','[{47060022,48}]',4),(47060022,35,'[{2,31012},{1,1551},{3,1163},{4,1163}]','[{47060022,50}]',4),(47060022,36,'[{2,32692},{1,1635},{3,1226},{4,1226}]','[{47060022,52}]',4),(47060022,37,'[{2,34420},{1,1721},{3,1291},{4,1291}]','[{47060022,54}]',4),(47060022,38,'[{2,36196},{1,1810},{3,1358},{4,1358}]','[{47060022,56}]',4),(47060022,39,'[{2,38020},{1,1901},{3,1426},{4,1426}]','[{47060022,58}]',4),(47060022,40,'[{2,39892},{1,1995},{3,1496},{4,1496}]','[{47060022,60}]',5),(47060023,1,'[{2,700},{1,35},{3,25},{4,25}]','[{47060023,1}]',1),(47060023,2,'[{2,1282},{1,64},{3,46},{4,46}]','[{47060023,2}]',1),(47060023,3,'[{2,1944},{1,97},{3,70},{4,70}]','[{47060023,3}]',1),(47060023,4,'[{2,2687},{1,134},{3,97},{4,97}]','[{47060023,4}]',1),(47060023,5,'[{2,3511},{1,175},{3,126},{4,126}]','[{47060023,5}]',1),(47060023,6,'[{2,4416},{1,220},{3,158},{4,158}]','[{47060023,6}]',1),(47060023,7,'[{2,5401},{1,269},{3,193},{4,193}]','[{47060023,7}]',1),(47060023,8,'[{2,6467},{1,322},{3,231},{4,231}]','[{47060023,8}]',1),(47060023,9,'[{2,7614},{1,379},{3,272},{4,272}]','[{47060023,9}]',1),(47060023,10,'[{2,8842},{1,440},{3,316},{4,316}]','[{47060023,10}]',2),(47060023,11,'[{2,10150},{1,505},{3,363},{4,363}]','[{47060023,12}]',2),(47060023,12,'[{2,11539},{1,574},{3,413},{4,413}]','[{47060023,14}]',2),(47060023,13,'[{2,13009},{1,648},{3,466},{4,466}]','[{47060023,16}]',2),(47060023,14,'[{2,14560},{1,726},{3,521},{4,521}]','[{47060023,18}]',2),(47060023,15,'[{2,16192},{1,808},{3,579},{4,579}]','[{47060023,20}]',2),(47060023,16,'[{2,17931},{1,895},{3,641},{4,641}]','[{47060023,22}]',2),(47060023,17,'[{2,19778},{1,987},{3,707},{4,707}]','[{47060023,24}]',2),(47060023,18,'[{2,21733},{1,1085},{3,777},{4,777}]','[{47060023,26}]',2),(47060023,19,'[{2,23795},{1,1188},{3,851},{4,851}]','[{47060023,28}]',2),(47060023,20,'[{2,25965},{1,1297},{3,929},{4,929}]','[{47060023,30}]',3),(47060023,21,'[{2,28243},{1,1411},{3,1010},{4,1010}]','[{47060023,33}]',3),(47060023,22,'[{2,30628},{1,1530},{3,1095},{4,1095}]','[{47060023,36}]',3),(47060023,23,'[{2,33121},{1,1655},{3,1184},{4,1184}]','[{47060023,39}]',3),(47060023,24,'[{2,35722},{1,1785},{3,1277},{4,1277}]','[{47060023,42}]',3),(47060023,25,'[{2,38430},{1,1920},{3,1374},{4,1374}]','[{47060023,45}]',3),(47060023,26,'[{2,41246},{1,2061},{3,1475},{4,1475}]','[{47060023,48}]',3),(47060023,27,'[{2,44197},{1,2209},{3,1580},{4,1580}]','[{47060023,51}]',3),(47060023,28,'[{2,47282},{1,2363},{3,1690},{4,1690}]','[{47060023,54}]',3),(47060023,29,'[{2,50502},{1,2524},{3,1805},{4,1805}]','[{47060023,57}]',3),(47060023,30,'[{2,53857},{1,2692},{3,1925},{4,1925}]','[{47060023,60}]',4),(47060024,1,'[{2,1200},{1,60},{3,40},{4,40}]','[{47060024,1}]',1),(47060024,2,'[{2,2133},{1,110},{3,73},{4,73}]','[{47060024,2}]',1),(47060024,3,'[{2,3266},{1,167},{3,111},{4,111}]','[{47060024,3}]',1),(47060024,4,'[{2,4599},{1,234},{3,155},{4,155}]','[{47060024,4}]',1),(47060024,5,'[{2,6132},{1,311},{3,206},{4,206}]','[{47060024,5}]',1),(47060024,6,'[{2,7932},{1,401},{3,266},{4,266}]','[{47060024,7}]',1),(47060024,7,'[{2,9999},{1,504},{3,335},{4,335}]','[{47060024,9}]',1),(47060024,8,'[{2,12332},{1,621},{3,413},{4,413}]','[{47060024,11}]',1),(47060024,9,'[{2,14932},{1,751},{3,500},{4,500}]','[{47060024,13}]',1),(47060024,10,'[{2,17865},{1,898},{3,598},{4,598}]','[{47060024,15}]',2),(47060024,11,'[{2,21132},{1,1061},{3,707},{4,707}]','[{47060024,18}]',2),(47060024,12,'[{2,24732},{1,1241},{3,827},{4,827}]','[{47060024,21}]',2),(47060024,13,'[{2,28665},{1,1438},{3,958},{4,958}]','[{47060024,24}]',2),(47060024,14,'[{2,32932},{1,1651},{3,1100},{4,1100}]','[{47060024,27}]',2),(47060024,15,'[{2,37532},{1,1881},{3,1253},{4,1253}]','[{47060024,30}]',2),(47060024,16,'[{2,42532},{1,2131},{3,1420},{4,1420}]','[{47060024,34}]',2),(47060024,17,'[{2,47932},{1,2401},{3,1600},{4,1600}]','[{47060024,38}]',2),(47060024,18,'[{2,53732},{1,2691},{3,1793},{4,1793}]','[{47060024,42}]',2),(47060024,19,'[{2,59932},{1,3001},{3,2000},{4,2000}]','[{47060024,46}]',2),(47060024,20,'[{2,66532},{1,3331},{3,2220},{4,2220}]','[{47060024,50}]',3),(47060031,1,'[{2,200},{1,10},{3,8},{4,8}]','[{47060031,1}]',1),(47060031,2,'[{2,368},{1,18},{3,15},{4,15}]','[{47060031,2}]',1),(47060031,3,'[{2,558},{1,28},{3,23},{4,23}]','[{47060031,3}]',1),(47060031,4,'[{2,771},{1,39},{3,32},{4,32}]','[{47060031,4}]',1),(47060031,5,'[{2,1006},{1,51},{3,41},{4,41}]','[{47060031,5}]',1),(47060031,6,'[{2,1264},{1,64},{3,51},{4,51}]','[{47060031,6}]',1),(47060031,7,'[{2,1544},{1,78},{3,62},{4,62}]','[{47060031,7}]',1),(47060031,8,'[{2,1847},{1,93},{3,74},{4,74}]','[{47060031,8}]',1),(47060031,9,'[{2,2172},{1,109},{3,87},{4,87}]','[{47060031,9}]',1),(47060031,10,'[{2,2520},{1,126},{3,101},{4,101}]','[{47060031,10}]',2),(47060031,11,'[{2,2890},{1,145},{3,116},{4,116}]','[{47060031,11}]',2),(47060031,12,'[{2,3283},{1,165},{3,132},{4,132}]','[{47060031,12}]',2),(47060031,13,'[{2,3698},{1,186},{3,149},{4,149}]','[{47060031,13}]',2),(47060031,14,'[{2,4136},{1,208},{3,167},{4,167}]','[{47060031,14}]',2),(47060031,15,'[{2,4596},{1,231},{3,185},{4,185}]','[{47060031,15}]',2),(47060031,16,'[{2,5079},{1,255},{3,204},{4,204}]','[{47060031,16}]',2),(47060031,17,'[{2,5584},{1,280},{3,224},{4,224}]','[{47060031,17}]',2),(47060031,18,'[{2,6112},{1,306},{3,245},{4,245}]','[{47060031,18}]',2),(47060031,19,'[{2,6662},{1,334},{3,267},{4,267}]','[{47060031,19}]',2),(47060031,20,'[{2,7235},{1,363},{3,290},{4,290}]','[{47060031,20}]',3),(47060031,21,'[{2,7838},{1,393},{3,314},{4,314}]','[{47060031,22}]',3),(47060031,22,'[{2,8471},{1,425},{3,339},{4,339}]','[{47060031,24}]',3),(47060031,23,'[{2,9134},{1,458},{3,366},{4,366}]','[{47060031,26}]',3),(47060031,24,'[{2,9827},{1,493},{3,394},{4,394}]','[{47060031,28}]',3),(47060031,25,'[{2,10550},{1,529},{3,423},{4,423}]','[{47060031,30}]',3),(47060031,26,'[{2,11303},{1,567},{3,453},{4,453}]','[{47060031,32}]',3),(47060031,27,'[{2,12086},{1,606},{3,484},{4,484}]','[{47060031,34}]',3),(47060031,28,'[{2,12899},{1,647},{3,517},{4,517}]','[{47060031,36}]',3),(47060031,29,'[{2,13742},{1,689},{3,551},{4,551}]','[{47060031,38}]',3),(47060031,30,'[{2,14615},{1,733},{3,586},{4,586}]','[{47060031,40}]',4),(47060031,31,'[{2,15518},{1,778},{3,622},{4,622}]','[{47060031,42}]',4),(47060031,32,'[{2,16451},{1,825},{3,659},{4,659}]','[{47060031,44}]',4),(47060031,33,'[{2,17414},{1,873},{3,698},{4,698}]','[{47060031,46}]',4),(47060031,34,'[{2,18407},{1,923},{3,738},{4,738}]','[{47060031,48}]',4),(47060031,35,'[{2,19430},{1,974},{3,779},{4,779}]','[{47060031,50}]',4),(47060031,36,'[{2,20483},{1,1027},{3,821},{4,821}]','[{47060031,52}]',4),(47060031,37,'[{2,21566},{1,1081},{3,864},{4,864}]','[{47060031,54}]',4),(47060031,38,'[{2,22679},{1,1137},{3,909},{4,909}]','[{47060031,56}]',4),(47060031,39,'[{2,23822},{1,1194},{3,955},{4,955}]','[{47060031,58}]',4),(47060031,40,'[{2,24995},{1,1253},{3,1002},{4,1002}]','[{47060031,60}]',5),(47060032,1,'[{2,400},{1,20},{3,15},{4,15}]','[{47060032,1}]',1),(47060032,2,'[{2,664},{1,33},{3,25},{4,25}]','[{47060032,2}]',1),(47060032,3,'[{2,964},{1,48},{3,36},{4,36}]','[{47060032,3}]',1),(47060032,4,'[{2,1300},{1,65},{3,49},{4,49}]','[{47060032,4}]',1),(47060032,5,'[{2,1672},{1,84},{3,63},{4,63}]','[{47060032,5}]',1),(47060032,6,'[{2,2080},{1,104},{3,78},{4,78}]','[{47060032,6}]',1),(47060032,7,'[{2,2524},{1,126},{3,95},{4,95}]','[{47060032,7}]',1),(47060032,8,'[{2,3004},{1,150},{3,113},{4,113}]','[{47060032,8}]',1),(47060032,9,'[{2,3520},{1,176},{3,132},{4,132}]','[{47060032,9}]',1),(47060032,10,'[{2,4072},{1,204},{3,153},{4,153}]','[{47060032,10}]',2),(47060032,11,'[{2,4660},{1,233},{3,175},{4,175}]','[{47060032,11}]',2),(47060032,12,'[{2,5284},{1,264},{3,198},{4,198}]','[{47060032,12}]',2),(47060032,13,'[{2,5944},{1,297},{3,223},{4,223}]','[{47060032,13}]',2),(47060032,14,'[{2,6640},{1,332},{3,249},{4,249}]','[{47060032,14}]',2),(47060032,15,'[{2,7372},{1,369},{3,276},{4,276}]','[{47060032,15}]',2),(47060032,16,'[{2,8140},{1,407},{3,305},{4,305}]','[{47060032,16}]',2),(47060032,17,'[{2,8944},{1,447},{3,335},{4,335}]','[{47060032,17}]',2),(47060032,18,'[{2,9784},{1,489},{3,367},{4,367}]','[{47060032,18}]',2),(47060032,19,'[{2,10660},{1,533},{3,400},{4,400}]','[{47060032,19}]',2),(47060032,20,'[{2,11572},{1,579},{3,434},{4,434}]','[{47060032,20}]',3),(47060032,21,'[{2,12532},{1,627},{3,470},{4,470}]','[{47060032,22}]',3),(47060032,22,'[{2,13540},{1,677},{3,508},{4,508}]','[{47060032,24}]',3),(47060032,23,'[{2,14596},{1,730},{3,548},{4,548}]','[{47060032,26}]',3),(47060032,24,'[{2,15700},{1,785},{3,589},{4,589}]','[{47060032,28}]',3),(47060032,25,'[{2,16852},{1,843},{3,632},{4,632}]','[{47060032,30}]',3),(47060032,26,'[{2,18052},{1,903},{3,677},{4,677}]','[{47060032,32}]',3),(47060032,27,'[{2,19300},{1,965},{3,724},{4,724}]','[{47060032,34}]',3),(47060032,28,'[{2,20596},{1,1030},{3,773},{4,773}]','[{47060032,36}]',3),(47060032,29,'[{2,21940},{1,1097},{3,823},{4,823}]','[{47060032,38}]',3),(47060032,30,'[{2,23332},{1,1167},{3,875},{4,875}]','[{47060032,40}]',4),(47060032,31,'[{2,24772},{1,1239},{3,929},{4,929}]','[{47060032,42}]',4),(47060032,32,'[{2,26260},{1,1313},{3,985},{4,985}]','[{47060032,44}]',4),(47060032,33,'[{2,27796},{1,1390},{3,1043},{4,1043}]','[{47060032,46}]',4),(47060032,34,'[{2,29380},{1,1469},{3,1102},{4,1102}]','[{47060032,48}]',4),(47060032,35,'[{2,31012},{1,1551},{3,1163},{4,1163}]','[{47060032,50}]',4),(47060032,36,'[{2,32692},{1,1635},{3,1226},{4,1226}]','[{47060032,52}]',4),(47060032,37,'[{2,34420},{1,1721},{3,1291},{4,1291}]','[{47060032,54}]',4),(47060032,38,'[{2,36196},{1,1810},{3,1358},{4,1358}]','[{47060032,56}]',4),(47060032,39,'[{2,38020},{1,1901},{3,1426},{4,1426}]','[{47060032,58}]',4),(47060032,40,'[{2,39892},{1,1995},{3,1496},{4,1496}]','[{47060032,60}]',5),(47060033,1,'[{2,700},{1,35},{3,25},{4,25}]','[{47060033,1}]',1),(47060033,2,'[{2,1282},{1,64},{3,46},{4,46}]','[{47060033,2}]',1),(47060033,3,'[{2,1944},{1,97},{3,70},{4,70}]','[{47060033,3}]',1),(47060033,4,'[{2,2687},{1,134},{3,97},{4,97}]','[{47060033,4}]',1),(47060033,5,'[{2,3511},{1,175},{3,126},{4,126}]','[{47060033,5}]',1),(47060033,6,'[{2,4416},{1,220},{3,158},{4,158}]','[{47060033,6}]',1),(47060033,7,'[{2,5401},{1,269},{3,193},{4,193}]','[{47060033,7}]',1),(47060033,8,'[{2,6467},{1,322},{3,231},{4,231}]','[{47060033,8}]',1),(47060033,9,'[{2,7614},{1,379},{3,272},{4,272}]','[{47060033,9}]',1),(47060033,10,'[{2,8842},{1,440},{3,316},{4,316}]','[{47060033,10}]',2),(47060033,11,'[{2,10150},{1,505},{3,363},{4,363}]','[{47060033,12}]',2),(47060033,12,'[{2,11539},{1,574},{3,413},{4,413}]','[{47060033,14}]',2),(47060033,13,'[{2,13009},{1,648},{3,466},{4,466}]','[{47060033,16}]',2),(47060033,14,'[{2,14560},{1,726},{3,521},{4,521}]','[{47060033,18}]',2),(47060033,15,'[{2,16192},{1,808},{3,579},{4,579}]','[{47060033,20}]',2),(47060033,16,'[{2,17931},{1,895},{3,641},{4,641}]','[{47060033,22}]',2),(47060033,17,'[{2,19778},{1,987},{3,707},{4,707}]','[{47060033,24}]',2),(47060033,18,'[{2,21733},{1,1085},{3,777},{4,777}]','[{47060033,26}]',2),(47060033,19,'[{2,23795},{1,1188},{3,851},{4,851}]','[{47060033,28}]',2),(47060033,20,'[{2,25965},{1,1297},{3,929},{4,929}]','[{47060033,30}]',3),(47060033,21,'[{2,28243},{1,1411},{3,1010},{4,1010}]','[{47060033,33}]',3),(47060033,22,'[{2,30628},{1,1530},{3,1095},{4,1095}]','[{47060033,36}]',3),(47060033,23,'[{2,33121},{1,1655},{3,1184},{4,1184}]','[{47060033,39}]',3),(47060033,24,'[{2,35722},{1,1785},{3,1277},{4,1277}]','[{47060033,42}]',3),(47060033,25,'[{2,38430},{1,1920},{3,1374},{4,1374}]','[{47060033,45}]',3),(47060033,26,'[{2,41246},{1,2061},{3,1475},{4,1475}]','[{47060033,48}]',3),(47060033,27,'[{2,44197},{1,2209},{3,1580},{4,1580}]','[{47060033,51}]',3),(47060033,28,'[{2,47282},{1,2363},{3,1690},{4,1690}]','[{47060033,54}]',3),(47060033,29,'[{2,50502},{1,2524},{3,1805},{4,1805}]','[{47060033,57}]',3),(47060033,30,'[{2,53857},{1,2692},{3,1925},{4,1925}]','[{47060033,60}]',4),(47060034,1,'[{2,1200},{1,60},{3,40},{4,40}]','[{47060034,1}]',1),(47060034,2,'[{2,2133},{1,110},{3,73},{4,73}]','[{47060034,2}]',1),(47060034,3,'[{2,3266},{1,167},{3,111},{4,111}]','[{47060034,3}]',1),(47060034,4,'[{2,4599},{1,234},{3,155},{4,155}]','[{47060034,4}]',1),(47060034,5,'[{2,6132},{1,311},{3,206},{4,206}]','[{47060034,5}]',1),(47060034,6,'[{2,7932},{1,401},{3,266},{4,266}]','[{47060034,7}]',1),(47060034,7,'[{2,9999},{1,504},{3,335},{4,335}]','[{47060034,9}]',1),(47060034,8,'[{2,12332},{1,621},{3,413},{4,413}]','[{47060034,11}]',1),(47060034,9,'[{2,14932},{1,751},{3,500},{4,500}]','[{47060034,13}]',1),(47060034,10,'[{2,17865},{1,898},{3,598},{4,598}]','[{47060034,15}]',2),(47060034,11,'[{2,21132},{1,1061},{3,707},{4,707}]','[{47060034,18}]',2),(47060034,12,'[{2,24732},{1,1241},{3,827},{4,827}]','[{47060034,21}]',2),(47060034,13,'[{2,28665},{1,1438},{3,958},{4,958}]','[{47060034,24}]',2),(47060034,14,'[{2,32932},{1,1651},{3,1100},{4,1100}]','[{47060034,27}]',2),(47060034,15,'[{2,37532},{1,1881},{3,1253},{4,1253}]','[{47060034,30}]',2),(47060034,16,'[{2,42532},{1,2131},{3,1420},{4,1420}]','[{47060034,34}]',2),(47060034,17,'[{2,47932},{1,2401},{3,1600},{4,1600}]','[{47060034,38}]',2),(47060034,18,'[{2,53732},{1,2691},{3,1793},{4,1793}]','[{47060034,42}]',2),(47060034,19,'[{2,59932},{1,3001},{3,2000},{4,2000}]','[{47060034,46}]',2),(47060034,20,'[{2,66532},{1,3331},{3,2220},{4,2220}]','[{47060034,50}]',3),(47060041,1,'[{2,5000},{1,250},{3,200},{4,200},{9,120}]','[{47060041,1}]',1),(47060041,2,'[{2,8000},{1,400},{3,320},{4,320},{9,144}]','[{47060041,2}]',1),(47060041,3,'[{2,11400},{1,570},{3,456},{4,456},{9,168}]','[{47060041,3}]',1),(47060041,4,'[{2,15300},{1,765},{3,612},{4,612},{9,204}]','[{47060041,4}]',1),(47060041,5,'[{2,19700},{1,985},{3,788},{4,788},{9,240}]','[{47060041,5}]',1),(47060041,6,'[{2,24600},{1,1230},{3,984},{4,984},{9,288}]','[{47060041,7}]',1),(47060041,7,'[{2,30100},{1,1505},{3,1204},{4,1204},{9,336}]','[{47060041,9}]',1),(47060041,8,'[{2,36200},{1,1810},{3,1448},{4,1448},{9,396}]','[{47060041,11}]',1),(47060041,9,'[{2,43000},{1,2150},{3,1720},{4,1720},{9,456}]','[{47060041,13}]',1),(47060041,10,'[{2,50500},{1,2525},{3,2020},{4,2020},{9,528}]','[{47060041,15}]',2),(47060041,11,'[{2,58700},{1,2935},{3,2348},{4,2348},{9,600}]','[{47060041,18}]',2),(47060041,12,'[{2,67700},{1,3385},{3,2708},{4,2708},{9,684}]','[{47060041,21}]',2),(47060041,13,'[{2,77500},{1,3875},{3,3100},{4,3100},{9,768}]','[{47060041,24}]',2),(47060041,14,'[{2,88200},{1,4410},{3,3528},{4,3528},{9,864}]','[{47060041,27}]',2),(47060041,15,'[{2,99900},{1,4995},{3,3996},{4,3996},{9,960}]','[{47060041,30}]',2),(47070011,1,'[{2,200},{1,10},{3,8},{4,8}]','[{47070011,1}]',1),(47070011,2,'[{2,368},{1,18},{3,15},{4,15}]','[{47070011,2}]',1),(47070011,3,'[{2,558},{1,28},{3,23},{4,23}]','[{47070011,3}]',1),(47070011,4,'[{2,771},{1,39},{3,32},{4,32}]','[{47070011,4}]',1),(47070011,5,'[{2,1006},{1,51},{3,41},{4,41}]','[{47070011,5}]',1),(47070011,6,'[{2,1264},{1,64},{3,51},{4,51}]','[{47070011,6}]',1),(47070011,7,'[{2,1544},{1,78},{3,62},{4,62}]','[{47070011,7}]',1),(47070011,8,'[{2,1847},{1,93},{3,74},{4,74}]','[{47070011,8}]',1),(47070011,9,'[{2,2172},{1,109},{3,87},{4,87}]','[{47070011,9}]',1),(47070011,10,'[{2,2520},{1,126},{3,101},{4,101}]','[{47070011,10}]',2),(47070011,11,'[{2,2890},{1,145},{3,116},{4,116}]','[{47070011,11}]',2),(47070011,12,'[{2,3283},{1,165},{3,132},{4,132}]','[{47070011,12}]',2),(47070011,13,'[{2,3698},{1,186},{3,149},{4,149}]','[{47070011,13}]',2),(47070011,14,'[{2,4136},{1,208},{3,167},{4,167}]','[{47070011,14}]',2),(47070011,15,'[{2,4596},{1,231},{3,185},{4,185}]','[{47070011,15}]',2),(47070011,16,'[{2,5079},{1,255},{3,204},{4,204}]','[{47070011,16}]',2),(47070011,17,'[{2,5584},{1,280},{3,224},{4,224}]','[{47070011,17}]',2),(47070011,18,'[{2,6112},{1,306},{3,245},{4,245}]','[{47070011,18}]',2),(47070011,19,'[{2,6662},{1,334},{3,267},{4,267}]','[{47070011,19}]',2),(47070011,20,'[{2,7235},{1,363},{3,290},{4,290}]','[{47070011,20}]',3),(47070011,21,'[{2,7838},{1,393},{3,314},{4,314}]','[{47070011,22}]',3),(47070011,22,'[{2,8471},{1,425},{3,339},{4,339}]','[{47070011,24}]',3),(47070011,23,'[{2,9134},{1,458},{3,366},{4,366}]','[{47070011,26}]',3),(47070011,24,'[{2,9827},{1,493},{3,394},{4,394}]','[{47070011,28}]',3),(47070011,25,'[{2,10550},{1,529},{3,423},{4,423}]','[{47070011,30}]',3),(47070011,26,'[{2,11303},{1,567},{3,453},{4,453}]','[{47070011,32}]',3),(47070011,27,'[{2,12086},{1,606},{3,484},{4,484}]','[{47070011,34}]',3),(47070011,28,'[{2,12899},{1,647},{3,517},{4,517}]','[{47070011,36}]',3),(47070011,29,'[{2,13742},{1,689},{3,551},{4,551}]','[{47070011,38}]',3),(47070011,30,'[{2,14615},{1,733},{3,586},{4,586}]','[{47070011,40}]',4),(47070011,31,'[{2,15518},{1,778},{3,622},{4,622}]','[{47070011,42}]',4),(47070011,32,'[{2,16451},{1,825},{3,659},{4,659}]','[{47070011,44}]',4),(47070011,33,'[{2,17414},{1,873},{3,698},{4,698}]','[{47070011,46}]',4),(47070011,34,'[{2,18407},{1,923},{3,738},{4,738}]','[{47070011,48}]',4),(47070011,35,'[{2,19430},{1,974},{3,779},{4,779}]','[{47070011,50}]',4),(47070011,36,'[{2,20483},{1,1027},{3,821},{4,821}]','[{47070011,52}]',4),(47070011,37,'[{2,21566},{1,1081},{3,864},{4,864}]','[{47070011,54}]',4),(47070011,38,'[{2,22679},{1,1137},{3,909},{4,909}]','[{47070011,56}]',4),(47070011,39,'[{2,23822},{1,1194},{3,955},{4,955}]','[{47070011,58}]',4),(47070011,40,'[{2,24995},{1,1253},{3,1002},{4,1002}]','[{47070011,60}]',5),(47070012,1,'[{2,400},{1,20},{3,15},{4,15}]','[{47070012,1}]',1),(47070012,2,'[{2,664},{1,33},{3,25},{4,25}]','[{47070012,2}]',1),(47070012,3,'[{2,964},{1,48},{3,36},{4,36}]','[{47070012,3}]',1),(47070012,4,'[{2,1300},{1,65},{3,49},{4,49}]','[{47070012,4}]',1),(47070012,5,'[{2,1672},{1,84},{3,63},{4,63}]','[{47070012,5}]',1),(47070012,6,'[{2,2080},{1,104},{3,78},{4,78}]','[{47070012,6}]',1),(47070012,7,'[{2,2524},{1,126},{3,95},{4,95}]','[{47070012,7}]',1),(47070012,8,'[{2,3004},{1,150},{3,113},{4,113}]','[{47070012,8}]',1),(47070012,9,'[{2,3520},{1,176},{3,132},{4,132}]','[{47070012,9}]',1),(47070012,10,'[{2,4072},{1,204},{3,153},{4,153}]','[{47070012,10}]',2),(47070012,11,'[{2,4660},{1,233},{3,175},{4,175}]','[{47070012,11}]',2),(47070012,12,'[{2,5284},{1,264},{3,198},{4,198}]','[{47070012,12}]',2),(47070012,13,'[{2,5944},{1,297},{3,223},{4,223}]','[{47070012,13}]',2),(47070012,14,'[{2,6640},{1,332},{3,249},{4,249}]','[{47070012,14}]',2),(47070012,15,'[{2,7372},{1,369},{3,276},{4,276}]','[{47070012,15}]',2),(47070012,16,'[{2,8140},{1,407},{3,305},{4,305}]','[{47070012,16}]',2),(47070012,17,'[{2,8944},{1,447},{3,335},{4,335}]','[{47070012,17}]',2),(47070012,18,'[{2,9784},{1,489},{3,367},{4,367}]','[{47070012,18}]',2),(47070012,19,'[{2,10660},{1,533},{3,400},{4,400}]','[{47070012,19}]',2),(47070012,20,'[{2,11572},{1,579},{3,434},{4,434}]','[{47070012,20}]',3),(47070012,21,'[{2,12532},{1,627},{3,470},{4,470}]','[{47070012,22}]',3),(47070012,22,'[{2,13540},{1,677},{3,508},{4,508}]','[{47070012,24}]',3),(47070012,23,'[{2,14596},{1,730},{3,548},{4,548}]','[{47070012,26}]',3),(47070012,24,'[{2,15700},{1,785},{3,589},{4,589}]','[{47070012,28}]',3),(47070012,25,'[{2,16852},{1,843},{3,632},{4,632}]','[{47070012,30}]',3),(47070012,26,'[{2,18052},{1,903},{3,677},{4,677}]','[{47070012,32}]',3),(47070012,27,'[{2,19300},{1,965},{3,724},{4,724}]','[{47070012,34}]',3),(47070012,28,'[{2,20596},{1,1030},{3,773},{4,773}]','[{47070012,36}]',3),(47070012,29,'[{2,21940},{1,1097},{3,823},{4,823}]','[{47070012,38}]',3),(47070012,30,'[{2,23332},{1,1167},{3,875},{4,875}]','[{47070012,40}]',4),(47070012,31,'[{2,24772},{1,1239},{3,929},{4,929}]','[{47070012,42}]',4),(47070012,32,'[{2,26260},{1,1313},{3,985},{4,985}]','[{47070012,44}]',4),(47070012,33,'[{2,27796},{1,1390},{3,1043},{4,1043}]','[{47070012,46}]',4),(47070012,34,'[{2,29380},{1,1469},{3,1102},{4,1102}]','[{47070012,48}]',4),(47070012,35,'[{2,31012},{1,1551},{3,1163},{4,1163}]','[{47070012,50}]',4),(47070012,36,'[{2,32692},{1,1635},{3,1226},{4,1226}]','[{47070012,52}]',4),(47070012,37,'[{2,34420},{1,1721},{3,1291},{4,1291}]','[{47070012,54}]',4),(47070012,38,'[{2,36196},{1,1810},{3,1358},{4,1358}]','[{47070012,56}]',4),(47070012,39,'[{2,38020},{1,1901},{3,1426},{4,1426}]','[{47070012,58}]',4),(47070012,40,'[{2,39892},{1,1995},{3,1496},{4,1496}]','[{47070012,60}]',5),(47070013,1,'[{2,700},{1,35},{3,25},{4,25}]','[{47070013,1}]',1),(47070013,2,'[{2,1282},{1,64},{3,46},{4,46}]','[{47070013,2}]',1),(47070013,3,'[{2,1944},{1,97},{3,70},{4,70}]','[{47070013,3}]',1),(47070013,4,'[{2,2687},{1,134},{3,97},{4,97}]','[{47070013,4}]',1),(47070013,5,'[{2,3511},{1,175},{3,126},{4,126}]','[{47070013,5}]',1),(47070013,6,'[{2,4416},{1,220},{3,158},{4,158}]','[{47070013,6}]',1),(47070013,7,'[{2,5401},{1,269},{3,193},{4,193}]','[{47070013,7}]',1),(47070013,8,'[{2,6467},{1,322},{3,231},{4,231}]','[{47070013,8}]',1),(47070013,9,'[{2,7614},{1,379},{3,272},{4,272}]','[{47070013,9}]',1),(47070013,10,'[{2,8842},{1,440},{3,316},{4,316}]','[{47070013,10}]',2),(47070013,11,'[{2,10150},{1,505},{3,363},{4,363}]','[{47070013,12}]',2),(47070013,12,'[{2,11539},{1,574},{3,413},{4,413}]','[{47070013,14}]',2),(47070013,13,'[{2,13009},{1,648},{3,466},{4,466}]','[{47070013,16}]',2),(47070013,14,'[{2,14560},{1,726},{3,521},{4,521}]','[{47070013,18}]',2),(47070013,15,'[{2,16192},{1,808},{3,579},{4,579}]','[{47070013,20}]',2),(47070013,16,'[{2,17931},{1,895},{3,641},{4,641}]','[{47070013,22}]',2),(47070013,17,'[{2,19778},{1,987},{3,707},{4,707}]','[{47070013,24}]',2),(47070013,18,'[{2,21733},{1,1085},{3,777},{4,777}]','[{47070013,26}]',2),(47070013,19,'[{2,23795},{1,1188},{3,851},{4,851}]','[{47070013,28}]',2),(47070013,20,'[{2,25965},{1,1297},{3,929},{4,929}]','[{47070013,30}]',3),(47070013,21,'[{2,28243},{1,1411},{3,1010},{4,1010}]','[{47070013,33}]',3),(47070013,22,'[{2,30628},{1,1530},{3,1095},{4,1095}]','[{47070013,36}]',3),(47070013,23,'[{2,33121},{1,1655},{3,1184},{4,1184}]','[{47070013,39}]',3),(47070013,24,'[{2,35722},{1,1785},{3,1277},{4,1277}]','[{47070013,42}]',3),(47070013,25,'[{2,38430},{1,1920},{3,1374},{4,1374}]','[{47070013,45}]',3),(47070013,26,'[{2,41246},{1,2061},{3,1475},{4,1475}]','[{47070013,48}]',3),(47070013,27,'[{2,44197},{1,2209},{3,1580},{4,1580}]','[{47070013,51}]',3),(47070013,28,'[{2,47282},{1,2363},{3,1690},{4,1690}]','[{47070013,54}]',3),(47070013,29,'[{2,50502},{1,2524},{3,1805},{4,1805}]','[{47070013,57}]',3),(47070013,30,'[{2,53857},{1,2692},{3,1925},{4,1925}]','[{47070013,60}]',4),(47070014,1,'[{2,1200},{1,60},{3,40},{4,40}]','[{47070014,1}]',1),(47070014,2,'[{2,2133},{1,110},{3,73},{4,73}]','[{47070014,2}]',1),(47070014,3,'[{2,3266},{1,167},{3,111},{4,111}]','[{47070014,3}]',1),(47070014,4,'[{2,4599},{1,234},{3,155},{4,155}]','[{47070014,4}]',1),(47070014,5,'[{2,6132},{1,311},{3,206},{4,206}]','[{47070014,5}]',1),(47070014,6,'[{2,7932},{1,401},{3,266},{4,266}]','[{47070014,7}]',1),(47070014,7,'[{2,9999},{1,504},{3,335},{4,335}]','[{47070014,9}]',1),(47070014,8,'[{2,12332},{1,621},{3,413},{4,413}]','[{47070014,11}]',1),(47070014,9,'[{2,14932},{1,751},{3,500},{4,500}]','[{47070014,13}]',1),(47070014,10,'[{2,17865},{1,898},{3,598},{4,598}]','[{47070014,15}]',2),(47070014,11,'[{2,21132},{1,1061},{3,707},{4,707}]','[{47070014,18}]',2),(47070014,12,'[{2,24732},{1,1241},{3,827},{4,827}]','[{47070014,21}]',2),(47070014,13,'[{2,28665},{1,1438},{3,958},{4,958}]','[{47070014,24}]',2),(47070014,14,'[{2,32932},{1,1651},{3,1100},{4,1100}]','[{47070014,27}]',2),(47070014,15,'[{2,37532},{1,1881},{3,1253},{4,1253}]','[{47070014,30}]',2),(47070014,16,'[{2,42532},{1,2131},{3,1420},{4,1420}]','[{47070014,34}]',2),(47070014,17,'[{2,47932},{1,2401},{3,1600},{4,1600}]','[{47070014,38}]',2),(47070014,18,'[{2,53732},{1,2691},{3,1793},{4,1793}]','[{47070014,42}]',2),(47070014,19,'[{2,59932},{1,3001},{3,2000},{4,2000}]','[{47070014,46}]',2),(47070014,20,'[{2,66532},{1,3331},{3,2220},{4,2220}]','[{47070014,50}]',3);
/*!40000 ALTER TABLE `base_role_home_pic_lv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_role_home_pic_type`
--

DROP TABLE IF EXISTS `base_role_home_pic_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_role_home_pic_type` (
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `name` varchar(50) DEFAULT '' COMMENT '类型名称',
  `remark` varchar(255) DEFAULT '' COMMENT '备注',
  PRIMARY KEY (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_role_home_pic_type`
--

LOCK TABLES `base_role_home_pic_type` WRITE;
/*!40000 ALTER TABLE `base_role_home_pic_type` DISABLE KEYS */;
INSERT INTO `base_role_home_pic_type` VALUES (1,'欧式床柜',''),(2,'欧式桌椅',''),(3,'欧式摆设',''),(4,'欧式墙饰',''),(5,'欧式地毯','');
/*!40000 ALTER TABLE `base_role_home_pic_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_role_home_quick_card`
--

DROP TABLE IF EXISTS `base_role_home_quick_card`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_role_home_quick_card` (
  `good_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '道具id',
  `build_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '建筑类型',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '加速时间',
  PRIMARY KEY (`good_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='建筑加速卡配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_role_home_quick_card`
--

LOCK TABLES `base_role_home_quick_card` WRITE;
/*!40000 ALTER TABLE `base_role_home_quick_card` DISABLE KEYS */;
INSERT INTO `base_role_home_quick_card` VALUES (48060101,0,300),(48060102,0,600),(48060103,0,1800);
/*!40000 ALTER TABLE `base_role_home_quick_card` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_role_home_resource_build`
--

DROP TABLE IF EXISTS `base_role_home_resource_build`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_role_home_resource_build` (
  `build_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '建筑类型',
  `build_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `produce` varchar(50) NOT NULL DEFAULT '[]' COMMENT '产量',
  `max_limit` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '产出上限',
  PRIMARY KEY (`build_type`,`build_lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_role_home_resource_build`
--

LOCK TABLES `base_role_home_resource_build` WRITE;
/*!40000 ALTER TABLE `base_role_home_resource_build` DISABLE KEYS */;
INSERT INTO `base_role_home_resource_build` VALUES (2,1,'[{100,60}]',48000),(2,2,'[{150,60}]',72000),(2,3,'[{250,60}]',120000),(2,4,'[{400,60}]',192000),(2,5,'[{600,60}]',288000),(2,6,'[{850,60}]',408000),(2,7,'[{1150,60}]',552000),(2,8,'[{1500,60}]',720000),(2,9,'[{1900,60}]',912000),(2,10,'[{2350,60}]',1128000),(2,11,'[{2850,60}]',1368000),(2,12,'[{3400,60}]',1632000),(2,13,'[{4000,60}]',1920000),(2,14,'[{4650,60}]',2232000),(2,15,'[{5350,60}]',2568000),(2,16,'[{6100,60}]',2928000),(2,17,'[{6900,60}]',3312000),(2,18,'[{7750,60}]',3720000),(2,19,'[{8650,60}]',4152000),(2,20,'[{9600,60}]',4608000),(2,21,'[{10600,60}]',5088000),(2,22,'[{11650,60}]',5592000),(2,23,'[{12750,60}]',6120000),(2,24,'[{13900,60}]',6672000),(2,25,'[{15100,60}]',7248000),(2,26,'[{16350,60}]',7848000),(2,27,'[{17650,60}]',8472000),(2,28,'[{19000,60}]',9120000),(2,29,'[{20400,60}]',9792000),(2,30,'[{21850,60}]',10488000),(2,31,'[{23350,60}]',11208000),(2,32,'[{24900,60}]',11952000),(2,33,'[{26500,60}]',12720000),(2,34,'[{28150,60}]',13512000),(2,35,'[{29850,60}]',14328000),(2,36,'[{31600,60}]',15168000),(2,37,'[{33400,60}]',16032000),(2,38,'[{35250,60}]',16920000),(2,39,'[{37150,60}]',17832000),(2,40,'[{39100,60}]',18768000),(2,41,'[{41100,60}]',19728000),(2,42,'[{43150,60}]',20712000),(2,43,'[{45250,60}]',21720000),(2,44,'[{47400,60}]',22752000),(2,45,'[{49600,60}]',23808000),(2,46,'[{51850,60}]',24888000),(2,47,'[{54150,60}]',25992000),(2,48,'[{56500,60}]',27120000),(2,49,'[{58900,60}]',28272000),(2,50,'[{61350,60}]',29448000),(2,51,'[{63850,60}]',30648000),(2,52,'[{66400,60}]',31872000),(2,53,'[{69000,60}]',33120000),(2,54,'[{71650,60}]',34392000),(2,55,'[{74350,60}]',35688000),(2,56,'[{77100,60}]',37008000),(2,57,'[{79900,60}]',38352000),(2,58,'[{82750,60}]',39720000),(2,59,'[{85650,60}]',41112000),(2,60,'[{88600,60}]',42528000),(3,1,'[{100,60}]',48000),(3,2,'[{150,60}]',72000),(3,3,'[{250,60}]',120000),(3,4,'[{400,60}]',192000),(3,5,'[{600,60}]',288000),(3,6,'[{850,60}]',408000),(3,7,'[{1150,60}]',552000),(3,8,'[{1500,60}]',720000),(3,9,'[{1900,60}]',912000),(3,10,'[{2350,60}]',1128000),(3,11,'[{2850,60}]',1368000),(3,12,'[{3400,60}]',1632000),(3,13,'[{4000,60}]',1920000),(3,14,'[{4650,60}]',2232000),(3,15,'[{5350,60}]',2568000),(3,16,'[{6100,60}]',2928000),(3,17,'[{6900,60}]',3312000),(3,18,'[{7750,60}]',3720000),(3,19,'[{8650,60}]',4152000),(3,20,'[{9600,60}]',4608000),(3,21,'[{10600,60}]',5088000),(3,22,'[{11650,60}]',5592000),(3,23,'[{12750,60}]',6120000),(3,24,'[{13900,60}]',6672000),(3,25,'[{15100,60}]',7248000),(3,26,'[{16350,60}]',7848000),(3,27,'[{17650,60}]',8472000),(3,28,'[{19000,60}]',9120000),(3,29,'[{20400,60}]',9792000),(3,30,'[{21850,60}]',10488000),(3,31,'[{23350,60}]',11208000),(3,32,'[{24900,60}]',11952000),(3,33,'[{26500,60}]',12720000),(3,34,'[{28150,60}]',13512000),(3,35,'[{29850,60}]',14328000),(3,36,'[{31600,60}]',15168000),(3,37,'[{33400,60}]',16032000),(3,38,'[{35250,60}]',16920000),(3,39,'[{37150,60}]',17832000),(3,40,'[{39100,60}]',18768000),(3,41,'[{41100,60}]',19728000),(3,42,'[{43150,60}]',20712000),(3,43,'[{45250,60}]',21720000),(3,44,'[{47400,60}]',22752000),(3,45,'[{49600,60}]',23808000),(3,46,'[{51850,60}]',24888000),(3,47,'[{54150,60}]',25992000),(3,48,'[{56500,60}]',27120000),(3,49,'[{58900,60}]',28272000),(3,50,'[{61350,60}]',29448000),(3,51,'[{63850,60}]',30648000),(3,52,'[{66400,60}]',31872000),(3,53,'[{69000,60}]',33120000),(3,54,'[{71650,60}]',34392000),(3,55,'[{74350,60}]',35688000),(3,56,'[{77100,60}]',37008000),(3,57,'[{79900,60}]',38352000),(3,58,'[{82750,60}]',39720000),(3,59,'[{85650,60}]',41112000),(3,60,'[{88600,60}]',42528000),(4,1,'[{100,60}]',48000),(4,2,'[{150,60}]',72000),(4,3,'[{250,60}]',120000),(4,4,'[{400,60}]',192000),(4,5,'[{600,60}]',288000),(4,6,'[{850,60}]',408000),(4,7,'[{1150,60}]',552000),(4,8,'[{1500,60}]',720000),(4,9,'[{1900,60}]',912000),(4,10,'[{2350,60}]',1128000),(4,11,'[{2850,60}]',1368000),(4,12,'[{3400,60}]',1632000),(4,13,'[{4000,60}]',1920000),(4,14,'[{4650,60}]',2232000),(4,15,'[{5350,60}]',2568000),(4,16,'[{6100,60}]',2928000),(4,17,'[{6900,60}]',3312000),(4,18,'[{7750,60}]',3720000),(4,19,'[{8650,60}]',4152000),(4,20,'[{9600,60}]',4608000),(4,21,'[{10600,60}]',5088000),(4,22,'[{11650,60}]',5592000),(4,23,'[{12750,60}]',6120000),(4,24,'[{13900,60}]',6672000),(4,25,'[{15100,60}]',7248000),(4,26,'[{16350,60}]',7848000),(4,27,'[{17650,60}]',8472000),(4,28,'[{19000,60}]',9120000),(4,29,'[{20400,60}]',9792000),(4,30,'[{21850,60}]',10488000),(4,31,'[{23350,60}]',11208000),(4,32,'[{24900,60}]',11952000),(4,33,'[{26500,60}]',12720000),(4,34,'[{28150,60}]',13512000),(4,35,'[{29850,60}]',14328000),(4,36,'[{31600,60}]',15168000),(4,37,'[{33400,60}]',16032000),(4,38,'[{35250,60}]',16920000),(4,39,'[{37150,60}]',17832000),(4,40,'[{39100,60}]',18768000),(4,41,'[{41100,60}]',19728000),(4,42,'[{43150,60}]',20712000),(4,43,'[{45250,60}]',21720000),(4,44,'[{47400,60}]',22752000),(4,45,'[{49600,60}]',23808000),(4,46,'[{51850,60}]',24888000),(4,47,'[{54150,60}]',25992000),(4,48,'[{56500,60}]',27120000),(4,49,'[{58900,60}]',28272000),(4,50,'[{61350,60}]',29448000),(4,51,'[{63850,60}]',30648000),(4,52,'[{66400,60}]',31872000),(4,53,'[{69000,60}]',33120000),(4,54,'[{71650,60}]',34392000),(4,55,'[{74350,60}]',35688000),(4,56,'[{77100,60}]',37008000),(4,57,'[{79900,60}]',38352000),(4,58,'[{82750,60}]',39720000),(4,59,'[{85650,60}]',41112000),(4,60,'[{88600,60}]',42528000);
/*!40000 ALTER TABLE `base_role_home_resource_build` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_role_home_task`
--

DROP TABLE IF EXISTS `base_role_home_task`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_role_home_task` (
  `task_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '任务id',
  `type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '任务类型',
  `type_name` varchar(50) NOT NULL COMMENT '任务类型名字',
  `name` varchar(50) NOT NULL COMMENT '任务名字',
  `pre_task` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '前置任务',
  `condition` varchar(256) DEFAULT '[]' COMMENT '完成参数',
  `achieve` varchar(128) DEFAULT '[]' COMMENT '完成数量',
  `res_reward` varchar(256) DEFAULT '[]' COMMENT '资源奖励',
  `reward` varchar(256) DEFAULT '[]' COMMENT '物品奖励',
  `description` varchar(256) DEFAULT '[]' COMMENT '任务描述@lang@',
  `tips` varchar(255) NOT NULL COMMENT '任务提示',
  PRIMARY KEY (`task_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='家园任务配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_role_home_task`
--

LOCK TABLES `base_role_home_task` WRITE;
/*!40000 ALTER TABLE `base_role_home_task` DISABLE KEYS */;
INSERT INTO `base_role_home_task` VALUES (1001,1,'建筑升级','房屋升级',0,'[{build_type,1}]','{build_lv,2}','[{1,1250},{3,1250}]','[]','将房屋升至<color=#4eae1a>2级</color>','收获更多的资源，可以快速升级哦'),(1002,1,'建筑升级','房屋升级',1001,'[{build_type,1}]','{build_lv,3}','[{1,5000},{3,5000}]','[]','将房屋升至<color=#4eae1a>3级</color>','收获更多的资源，可以快速升级哦'),(1003,1,'建筑升级','房屋升级',1002,'[{build_type,1}]','{build_lv,4}','[{1,15000},{3,15000}]','[]','将房屋升至<color=#4eae1a>4级</color>','收获更多的资源，可以快速升级哦'),(1004,1,'建筑升级','房屋升级',1003,'[{build_type,1}]','{build_lv,5}','[{1,25000},{3,25000}]','[]','将房屋升至<color=#4eae1a>5级</color>','收获更多的资源，可以快速升级哦'),(1005,1,'建筑升级','房屋升级',1004,'[{build_type,1}]','{build_lv,6}','[{1,37500},{3,37500}]','[]','将房屋升至<color=#4eae1a>6级</color>','收获更多的资源，可以快速升级哦'),(1006,1,'建筑升级','房屋升级',1005,'[{build_type,1}]','{build_lv,7}','[{1,50000},{3,50000}]','[]','将房屋升至<color=#4eae1a>7级</color>','收获更多的资源，可以快速升级哦'),(1007,1,'建筑升级','房屋升级',1006,'[{build_type,1}]','{build_lv,8}','[{1,75000},{3,75000}]','[]','将房屋升至<color=#4eae1a>8级</color>','收获更多的资源，可以快速升级哦'),(1008,1,'建筑升级','房屋升级',1007,'[{build_type,1}]','{build_lv,9}','[{1,100000},{3,100000}]','[]','将房屋升至<color=#4eae1a>9级</color>','收获更多的资源，可以快速升级哦'),(1009,1,'建筑升级','房屋升级',1008,'[{build_type,1}]','{build_lv,10}','[{1,150000},{3,150000}]','[]','将房屋升至<color=#4eae1a>10级</color>','收获更多的资源，可以快速升级哦'),(1010,1,'建筑升级','伐木场升级',1001,'[{build_type,2}]','{build_lv,2}','[{1,2500}]','[]','将伐木场升至<color=#4eae1a>2级</color>','收获更多的资源，可以快速升级哦'),(1011,1,'建筑升级','伐木场升级',1010,'[{build_type,2}]','{build_lv,3}','[{1,10000}]','[]','将伐木场升至<color=#4eae1a>3级</color>','收获更多的资源，可以快速升级哦'),(1012,1,'建筑升级','伐木场升级',1011,'[{build_type,2}]','{build_lv,4}','[{1,30000}]','[]','将伐木场升至<color=#4eae1a>4级</color>','收获更多的资源，可以快速升级哦'),(1013,1,'建筑升级','伐木场升级',1012,'[{build_type,2}]','{build_lv,5}','[{1,50000}]','[]','将伐木场升至<color=#4eae1a>5级</color>','收获更多的资源，可以快速升级哦'),(1014,1,'建筑升级','伐木场升级',1013,'[{build_type,2}]','{build_lv,6}','[{1,75000}]','[]','将伐木场升至<color=#4eae1a>6级</color>','收获更多的资源，可以快速升级哦'),(1015,1,'建筑升级','伐木场升级',1014,'[{build_type,2}]','{build_lv,7}','[{1,100000}]','[]','将伐木场升至<color=#4eae1a>7级</color>','收获更多的资源，可以快速升级哦'),(1016,1,'建筑升级','伐木场升级',1015,'[{build_type,2}]','{build_lv,8}','[{1,150000}]','[]','将伐木场升至<color=#4eae1a>8级</color>','收获更多的资源，可以快速升级哦'),(1017,1,'建筑升级','伐木场升级',1016,'[{build_type,2}]','{build_lv,9}','[{1,200000}]','[]','将伐木场升至<color=#4eae1a>9级</color>','收获更多的资源，可以快速升级哦'),(1018,1,'建筑升级','伐木场升级',1017,'[{build_type,2}]','{build_lv,10}','[{1,300000}]','[]','将伐木场升至<color=#4eae1a>10级</color>','收获更多的资源，可以快速升级哦'),(1019,1,'建筑升级','铁矿场升级',1001,'[{build_type,3}]','{build_lv,2}','[{2,2500}]','[]','将铁矿场升至<color=#4eae1a>2级</color>','收获更多的资源，可以快速升级哦'),(1020,1,'建筑升级','铁矿场升级',1019,'[{build_type,3}]','{build_lv,3}','[{2,10000}]','[]','将铁矿场升至<color=#4eae1a>3级</color>','收获更多的资源，可以快速升级哦'),(1021,1,'建筑升级','铁矿场升级',1020,'[{build_type,3}]','{build_lv,4}','[{2,30000}]','[]','将铁矿场升至<color=#4eae1a>4级</color>','收获更多的资源，可以快速升级哦'),(1022,1,'建筑升级','铁矿场升级',1021,'[{build_type,3}]','{build_lv,5}','[{2,50000}]','[]','将铁矿场升至<color=#4eae1a>5级</color>','收获更多的资源，可以快速升级哦'),(1023,1,'建筑升级','铁矿场升级',1022,'[{build_type,3}]','{build_lv,6}','[{2,75000}]','[]','将铁矿场升至<color=#4eae1a>6级</color>','收获更多的资源，可以快速升级哦'),(1024,1,'建筑升级','铁矿场升级',1023,'[{build_type,3}]','{build_lv,7}','[{2,100000}]','[]','将铁矿场升至<color=#4eae1a>7级</color>','收获更多的资源，可以快速升级哦'),(1025,1,'建筑升级','铁矿场升级',1024,'[{build_type,3}]','{build_lv,8}','[{2,150000}]','[]','将铁矿场升至<color=#4eae1a>8级</color>','收获更多的资源，可以快速升级哦'),(1026,1,'建筑升级','铁矿场升级',1025,'[{build_type,3}]','{build_lv,9}','[{2,200000}]','[]','将铁矿场升至<color=#4eae1a>9级</color>','收获更多的资源，可以快速升级哦'),(1027,1,'建筑升级','铁矿场升级',1026,'[{build_type,3}]','{build_lv,10}','[{2,300000}]','[]','将铁矿场升至<color=#4eae1a>10级</color>','收获更多的资源，可以快速升级哦'),(1028,1,'建筑升级','石矿场升级',1001,'[{build_type,4}]','{build_lv,2}','[{3,2500}]','[]','将石矿场升至<color=#4eae1a>2级</color>','收获更多的资源，可以快速升级哦'),(1029,1,'建筑升级','石矿场升级',1028,'[{build_type,4}]','{build_lv,3}','[{3,10000}]','[]','将石矿场升至<color=#4eae1a>3级</color>','收获更多的资源，可以快速升级哦'),(1030,1,'建筑升级','石矿场升级',1029,'[{build_type,4}]','{build_lv,4}','[{3,30000}]','[]','将石矿场升至<color=#4eae1a>4级</color>','收获更多的资源，可以快速升级哦'),(1031,1,'建筑升级','石矿场升级',1030,'[{build_type,4}]','{build_lv,5}','[{3,50000}]','[]','将石矿场升至<color=#4eae1a>5级</color>','收获更多的资源，可以快速升级哦'),(1032,1,'建筑升级','石矿场升级',1031,'[{build_type,4}]','{build_lv,6}','[{3,75000}]','[]','将石矿场升至<color=#4eae1a>6级</color>','收获更多的资源，可以快速升级哦'),(1033,1,'建筑升级','石矿场升级',1032,'[{build_type,4}]','{build_lv,7}','[{3,100000}]','[]','将石矿场升至<color=#4eae1a>7级</color>','收获更多的资源，可以快速升级哦'),(1034,1,'建筑升级','石矿场升级',1033,'[{build_type,4}]','{build_lv,8}','[{3,150000}]','[]','将石矿场升至<color=#4eae1a>8级</color>','收获更多的资源，可以快速升级哦'),(1035,1,'建筑升级','石矿场升级',1034,'[{build_type,4}]','{build_lv,9}','[{3,200000}]','[]','将石矿场升至<color=#4eae1a>9级</color>','收获更多的资源，可以快速升级哦'),(1036,1,'建筑升级','石矿场升级',1035,'[{build_type,4}]','{build_lv,10}','[{3,300000}]','[]','将石矿场升至<color=#4eae1a>10级</color>','收获更多的资源，可以快速升级哦'),(1037,1,'建筑升级','鱼塘升级',1007,'[{build_type,5}]','{build_lv,2}','[{2,1250},{3,1250}]','[]','将鱼塘升至<color=#4eae1a>2级</color>','收获更多的资源，可以快速升级哦'),(1038,1,'建筑升级','鱼塘升级',1037,'[{build_type,5}]','{build_lv,3}','[{2,5000},{3,5000}]','[]','将鱼塘升至<color=#4eae1a>3级</color>','收获更多的资源，可以快速升级哦'),(1039,1,'建筑升级','鱼塘升级',1038,'[{build_type,5}]','{build_lv,4}','[{2,15000},{3,15000}]','[]','将鱼塘升至<color=#4eae1a>4级</color>','收获更多的资源，可以快速升级哦'),(1040,1,'建筑升级','鱼塘升级',1039,'[{build_type,5}]','{build_lv,5}','[{2,25000},{3,25000}]','[]','将鱼塘升至<color=#4eae1a>5级</color>','收获更多的资源，可以快速升级哦'),(1041,1,'建筑升级','鱼塘升级',1040,'[{build_type,5}]','{build_lv,6}','[{2,37500},{3,37500}]','[]','将鱼塘升至<color=#4eae1a>6级</color>','收获更多的资源，可以快速升级哦'),(1042,1,'建筑升级','鱼塘升级',1041,'[{build_type,5}]','{build_lv,7}','[{2,50000},{3,50000}]','[]','将鱼塘升至<color=#4eae1a>7级</color>','收获更多的资源，可以快速升级哦'),(1043,1,'建筑升级','鱼塘升级',1042,'[{build_type,5}]','{build_lv,8}','[{2,75000},{3,75000}]','[]','将鱼塘升至<color=#4eae1a>8级</color>','收获更多的资源，可以快速升级哦'),(1044,1,'建筑升级','鱼塘升级',1043,'[{build_type,5}]','{build_lv,9}','[{2,100000},{3,100000}]','[]','将鱼塘升至<color=#4eae1a>9级</color>','收获更多的资源，可以快速升级哦'),(1045,1,'建筑升级','鱼塘升级',1044,'[{build_type,5}]','{build_lv,10}','[{2,150000},{3,150000}]','[]','将鱼塘升至<color=#4eae1a>10级</color>','收获更多的资源，可以快速升级哦'),(1046,1,'建筑升级','许愿池升级',1009,'[{build_type,6}]','{build_lv,2}','[]','[{0,48040002,100}]','将许愿池升至<color=#4eae1a>2级</color>','收获更多的资源，可以快速升级哦'),(1047,1,'建筑升级','许愿池升级',1046,'[{build_type,6}]','{build_lv,3}','[]','[{0,48040002,150}]','将许愿池升至<color=#4eae1a>3级</color>','收获更多的资源，可以快速升级哦'),(1048,1,'建筑升级','许愿池升级',1047,'[{build_type,6}]','{build_lv,4}','[]','[{0,48040002,200}]','将许愿池升至<color=#4eae1a>4级</color>','收获更多的资源，可以快速升级哦'),(1049,1,'建筑升级','许愿池升级',1048,'[{build_type,6}]','{build_lv,5}','[]','[{0,48040002,250}]','将许愿池升至<color=#4eae1a>5级</color>','收获更多的资源，可以快速升级哦'),(1050,1,'建筑升级','许愿池升级',1049,'[{build_type,6}]','{build_lv,6}','[]','[{0,48040002,300}]','将许愿池升至<color=#4eae1a>6级</color>','收获更多的资源，可以快速升级哦'),(1051,1,'建筑升级','许愿池升级',1050,'[{build_type,6}]','{build_lv,7}','[]','[{0,48040002,350}]','将许愿池升至<color=#4eae1a>7级</color>','收获更多的资源，可以快速升级哦'),(1052,1,'建筑升级','许愿池升级',1051,'[{build_type,6}]','{build_lv,8}','[]','[{0,48040002,400}]','将许愿池升至<color=#4eae1a>8级</color>','收获更多的资源，可以快速升级哦'),(1053,1,'建筑升级','许愿池升级',1052,'[{build_type,6}]','{build_lv,9}','[]','[{0,48040002,450}]','将许愿池升至<color=#4eae1a>9级</color>','收获更多的资源，可以快速升级哦'),(1054,1,'建筑升级','许愿池升级',1053,'[{build_type,6}]','{build_lv,10}','[]','[{0,48040002,500}]','将许愿池升至<color=#4eae1a>10级</color>','收获更多的资源，可以快速升级哦'),(1055,1,'建筑升级','任务场升级',1001,'[{build_type,7}]','{build_lv,2}','[{1,1250},{2,1250}]','[]','将任务场升至<color=#4eae1a>2级</color>','收获更多的资源，可以快速升级哦'),(1056,1,'建筑升级','任务场升级',1055,'[{build_type,7}]','{build_lv,3}','[{1,5000},{2,5000}]','[]','将任务场升至<color=#4eae1a>3级</color>','收获更多的资源，可以快速升级哦'),(1057,1,'建筑升级','任务场升级',1056,'[{build_type,7}]','{build_lv,4}','[{1,15000},{2,15000}]','[]','将任务场升至<color=#4eae1a>4级</color>','收获更多的资源，可以快速升级哦'),(1058,1,'建筑升级','任务场升级',1057,'[{build_type,7}]','{build_lv,5}','[{1,25000},{2,25000}]','[]','将任务场升至<color=#4eae1a>5级</color>','收获更多的资源，可以快速升级哦'),(1059,1,'建筑升级','任务场升级',1058,'[{build_type,7}]','{build_lv,6}','[{1,37500},{2,37500}]','[]','将任务场升至<color=#4eae1a>6级</color>','收获更多的资源，可以快速升级哦'),(1060,1,'建筑升级','任务场升级',1059,'[{build_type,7}]','{build_lv,7}','[{1,50000},{2,50000}]','[]','将任务场升至<color=#4eae1a>7级</color>','收获更多的资源，可以快速升级哦'),(1061,1,'建筑升级','任务场升级',1060,'[{build_type,7}]','{build_lv,8}','[{1,75000},{2,75000}]','[]','将任务场升至<color=#4eae1a>8级</color>','收获更多的资源，可以快速升级哦'),(1062,1,'建筑升级','任务场升级',1061,'[{build_type,7}]','{build_lv,9}','[{1,100000},{2,100000}]','[]','将任务场升至<color=#4eae1a>9级</color>','收获更多的资源，可以快速升级哦'),(1063,1,'建筑升级','任务场升级',1062,'[{build_type,7}]','{build_lv,10}','[{1,150000},{2,150000}]','[]','将任务场升至<color=#4eae1a>10级</color>','收获更多的资源，可以快速升级哦'),(1064,1,'建筑升级','餐厅升级',1004,'[{build_type,9}]','{build_lv,2}','[]','[{0,46010001,3}]','将餐厅升至<color=#4eae1a>2级</color>','收获更多的资源，可以快速升级哦'),(1065,1,'建筑升级','餐厅升级',1064,'[{build_type,9}]','{build_lv,3}','[]','[{0,46010002,3}]','将餐厅升至<color=#4eae1a>3级</color>','收获更多的资源，可以快速升级哦'),(1066,1,'建筑升级','餐厅升级',1065,'[{build_type,9}]','{build_lv,4}','[]','[{0,46010002,4}]','将餐厅升至<color=#4eae1a>4级</color>','收获更多的资源，可以快速升级哦'),(1067,1,'建筑升级','餐厅升级',1066,'[{build_type,9}]','{build_lv,5}','[]','[{0,46010002,5}]','将餐厅升至<color=#4eae1a>5级</color>','收获更多的资源，可以快速升级哦'),(1068,1,'建筑升级','餐厅升级',1067,'[{build_type,9}]','{build_lv,6}','[]','[{0,46010003,2}]','将餐厅升至<color=#4eae1a>6级</color>','收获更多的资源，可以快速升级哦'),(1069,1,'建筑升级','餐厅升级',1068,'[{build_type,9}]','{build_lv,7}','[]','[{0,46010003,3}]','将餐厅升至<color=#4eae1a>7级</color>','收获更多的资源，可以快速升级哦'),(1070,1,'建筑升级','餐厅升级',1069,'[{build_type,9}]','{build_lv,8}','[]','[{0,46010003,5}]','将餐厅升至<color=#4eae1a>8级</color>','收获更多的资源，可以快速升级哦'),(1071,1,'建筑升级','餐厅升级',1070,'[{build_type,9}]','{build_lv,9}','[]','[{0,46010004,2}]','将餐厅升至<color=#4eae1a>9级</color>','收获更多的资源，可以快速升级哦'),(1072,1,'建筑升级','餐厅升级',1071,'[{build_type,9}]','{build_lv,10}','[]','[{0,46010004,3}]','将餐厅升至<color=#4eae1a>10级</color>','收获更多的资源，可以快速升级哦'),(1073,1,'建筑升级','打造坊升级',1002,'[{build_type,10}]','{build_lv,2}','[{1,2500}]','[]','将打造坊升至<color=#4eae1a>2级</color>','收获更多的资源，可以快速升级哦'),(1074,1,'建筑升级','打造坊升级',1073,'[{build_type,10}]','{build_lv,3}','[{3,2500}]','[]','将打造坊升至<color=#4eae1a>3级</color>','收获更多的资源，可以快速升级哦'),(1075,1,'建筑升级','打造坊升级',1074,'[{build_type,10}]','{build_lv,4}','[{2,2500}]','[]','将打造坊升至<color=#4eae1a>4级</color>','收获更多的资源，可以快速升级哦'),(1076,1,'建筑升级','打造坊升级',1075,'[{build_type,10}]','{build_lv,5}','[{1,20000}]','[]','将打造坊升至<color=#4eae1a>5级</color>','收获更多的资源，可以快速升级哦'),(1077,1,'建筑升级','打造坊升级',1076,'[{build_type,10}]','{build_lv,6}','[{3,20000}]','[]','将打造坊升至<color=#4eae1a>6级</color>','收获更多的资源，可以快速升级哦'),(1078,1,'建筑升级','打造坊升级',1077,'[{build_type,10}]','{build_lv,7}','[{2,20000}]','[]','将打造坊升至<color=#4eae1a>7级</color>','收获更多的资源，可以快速升级哦'),(1079,1,'建筑升级','打造坊升级',1078,'[{build_type,10}]','{build_lv,8}','[{1,100000}]','[]','将打造坊升至<color=#4eae1a>8级</color>','收获更多的资源，可以快速升级哦'),(1080,1,'建筑升级','打造坊升级',1079,'[{build_type,10}]','{build_lv,9}','[{3,100000}]','[]','将打造坊升至<color=#4eae1a>9级</color>','收获更多的资源，可以快速升级哦'),(1081,1,'建筑升级','打造坊升级',1080,'[{build_type,10}]','{build_lv,10}','[{2,100000}]','[]','将打造坊升至<color=#4eae1a>10级</color>','收获更多的资源，可以快速升级哦'),(2001,3,'房屋布置','家具布置',0,'[]','{furniture_num,1}','[]','[{2,0,10}]','在房屋内布置<color=#4eae1a>1个</color>家具','通过打造坊可以获得家具哦'),(2002,3,'房屋布置','家具布置',2001,'[]','{furniture_num,3}','[]','[{2,0,15}]','在房屋内布置<color=#4eae1a>3个</color>家具','通过打造坊可以获得家具哦'),(2003,3,'房屋布置','家具布置',2002,'[]','{furniture_num,5}','[]','[{2,0,20}]','在房屋内布置<color=#4eae1a>5个</color>家具','通过打造坊可以获得家具哦'),(2004,3,'房屋布置','家具布置',2003,'[]','{furniture_num,10}','[]','[{2,0,25}]','在房屋内布置<color=#4eae1a>10个</color>家具','通过打造坊可以获得家具哦'),(3001,4,'收获资源','收获生产建筑资源',0,'[]','{collect_res_times, 1}','[]','[{0,48060101,1}]','手动收取<color=#4eae1a>1次</color>资源','在生产总览界面可以便捷完成哦'),(3002,4,'收获资源','收获生产建筑资源',3001,'[]','{collect_res_times, 4}','[]','[{0,48060101,2}]','手动收取<color=#4eae1a>4次</color>资源','在生产总览界面可以便捷完成哦'),(3003,4,'收获资源','收获生产建筑资源',3002,'[]','{collect_res_times, 10}','[]','[{0,48060101,3}]','手动收取<color=#4eae1a>10次</color>资源','在生产总览界面可以便捷完成哦');
/*!40000 ALTER TABLE `base_role_home_task` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_role_home_task_build`
--

DROP TABLE IF EXISTS `base_role_home_task_build`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_role_home_task_build` (
  `build_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '7',
  `build_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `dispatch_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '派遣队列',
  `main_add` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '主线任务加成',
  `dispatch_add` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '派遣任务加成',
  PRIMARY KEY (`build_type`,`build_lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_role_home_task_build`
--

LOCK TABLES `base_role_home_task_build` WRITE;
/*!40000 ALTER TABLE `base_role_home_task_build` DISABLE KEYS */;
INSERT INTO `base_role_home_task_build` VALUES (7,1,1,2,2),(7,2,1,4,4),(7,3,1,6,6),(7,4,1,8,8),(7,5,1,10,10),(7,6,1,12,12),(7,7,1,14,14),(7,8,1,16,16),(7,9,1,18,18),(7,10,1,20,20),(7,11,2,22,22),(7,12,2,24,24),(7,13,2,26,26),(7,14,2,28,28),(7,15,2,30,30),(7,16,2,32,32),(7,17,2,34,34),(7,18,2,36,36),(7,19,2,38,38),(7,20,2,40,40),(7,21,3,42,42),(7,22,3,44,44),(7,23,3,46,46),(7,24,3,48,48),(7,25,3,50,50),(7,26,3,52,52),(7,27,3,54,54),(7,28,3,56,56),(7,29,3,58,58),(7,30,3,60,60),(7,31,4,62,62),(7,32,4,64,64),(7,33,4,66,66),(7,34,4,68,68),(7,35,4,70,70),(7,36,4,72,72),(7,37,4,74,74),(7,38,4,76,76),(7,39,4,78,78),(7,40,4,80,80),(7,41,5,82,82),(7,42,5,84,84),(7,43,5,86,86),(7,44,5,88,88),(7,45,5,90,90),(7,46,5,92,92),(7,47,5,94,94),(7,48,5,96,96),(7,49,5,98,98),(7,50,5,100,100),(7,51,6,102,102),(7,52,6,104,104),(7,53,6,106,106),(7,54,6,108,108),(7,55,6,110,110),(7,56,6,112,112),(7,57,6,114,114),(7,58,6,116,116),(7,59,6,118,118),(7,60,6,120,120);
/*!40000 ALTER TABLE `base_role_home_task_build` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_role_home_temp_up_line`
--

DROP TABLE IF EXISTS `base_role_home_temp_up_line`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_role_home_temp_up_line` (
  `good_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '道具id',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`good_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='临时升级队列';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_role_home_temp_up_line`
--

LOCK TABLES `base_role_home_temp_up_line` WRITE;
/*!40000 ALTER TABLE `base_role_home_temp_up_line` DISABLE KEYS */;
INSERT INTO `base_role_home_temp_up_line` VALUES (48070001,1,86400);
/*!40000 ALTER TABLE `base_role_home_temp_up_line` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_role_home_wish`
--

DROP TABLE IF EXISTS `base_role_home_wish`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_role_home_wish` (
  `wish_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '许愿池id',
  `quality` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '品质',
  `event_weight` varchar(50) NOT NULL DEFAULT '[]' COMMENT '事件权重',
  `cost` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '许愿币消耗数',
  PRIMARY KEY (`wish_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_role_home_wish`
--

LOCK TABLES `base_role_home_wish` WRITE;
/*!40000 ALTER TABLE `base_role_home_wish` DISABLE KEYS */;
INSERT INTO `base_role_home_wish` VALUES (1,1,'[{1,0},{2,385},{3,615},{4,0}]',15),(2,2,'[{1,200},{2,200},{3,500},{4,100}]',25),(3,3,'[{1,260},{2,260},{3,350},{4,130}]',35),(4,4,'[{1,320},{2,320},{3,200},{4,160}]',45),(5,5,'[{1,400},{2,400},{3,0},{4,200}]',60);
/*!40000 ALTER TABLE `base_role_home_wish` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_role_home_wish_build`
--

DROP TABLE IF EXISTS `base_role_home_wish_build`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_role_home_wish_build` (
  `build_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '建筑类型',
  `build_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '建筑等级',
  `wish_coin` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '许愿币奖励数',
  `coin_store` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '许愿币自然上限',
  `res_list` text NOT NULL COMMENT '资源奖励',
  `must_res_list` text NOT NULL COMMENT '保底奖励',
  PRIMARY KEY (`build_type`,`build_lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_role_home_wish_build`
--

LOCK TABLES `base_role_home_wish_build` WRITE;
/*!40000 ALTER TABLE `base_role_home_wish_build` DISABLE KEYS */;
INSERT INTO `base_role_home_wish_build` VALUES (6,1,1000,3000,'[{1,[{100,1,500},{100,2,500},{100,3,500}]},{2,[{100,1,1800},{100,2,1800},{100,3,1800}]},{3,[{100,1,2800},{100,2,2800},{100,3,2800}]},{4,[{100,1,4100},{100,2,4100},{100,3,4100}]},{5,[{100,1,6300},{100,2,6300},{100,3,6300}]}]','[{1,[{100,1,300},{100,2,300},{100,3,300}]},{2,[{100,1,700},{100,2,700},{100,3,700}]},{3,[{100,1,1400},{100,2,1400},{100,3,1400}]},{4,[{100,1,2700},{100,2,2700},{100,3,2700}]}]'),(6,2,1020,3060,'[{1,[{100,1,800},{100,2,800},{100,3,800}]},{2,[{100,1,2600},{100,2,2600},{100,3,2600}]},{3,[{100,1,4200},{100,2,4200},{100,3,4200}]},{4,[{100,1,6100},{100,2,6100},{100,3,6100}]},{5,[{100,1,9500},{100,2,9500},{100,3,9500}]}]','[{1,[{100,1,400},{100,2,400},{100,3,400}]},{2,[{100,1,1000},{100,2,1000},{100,3,1000}]},{3,[{100,1,2000},{100,2,2000},{100,3,2000}]},{4,[{100,1,4100},{100,2,4100},{100,3,4100}]}]'),(6,3,1040,3120,'[{1,[{100,1,1400},{100,2,1400},{100,3,1400}]},{2,[{100,1,4400},{100,2,4400},{100,3,4400}]},{3,[{100,1,7000},{100,2,7000},{100,3,7000}]},{4,[{100,1,10100},{100,2,10100},{100,3,10100}]},{5,[{100,1,15800},{100,2,15800},{100,3,15800}]}]','[{1,[{100,1,700},{100,2,700},{100,3,700}]},{2,[{100,1,1700},{100,2,1700},{100,3,1700}]},{3,[{100,1,3400},{100,2,3400},{100,3,3400}]},{4,[{100,1,6800},{100,2,6800},{100,3,6800}]}]'),(6,4,1060,3180,'[{1,[{100,1,2200},{100,2,2200},{100,3,2200}]},{2,[{100,1,7100},{100,2,7100},{100,3,7100}]},{3,[{100,1,11200},{100,2,11200},{100,3,11200}]},{4,[{100,1,16200},{100,2,16200},{100,3,16200}]},{5,[{100,1,25200},{100,2,25200},{100,3,25200}]}]','[{1,[{100,1,1100},{100,2,1100},{100,3,1100}]},{2,[{100,1,2600},{100,2,2600},{100,3,2600}]},{3,[{100,1,5400},{100,2,5400},{100,3,5400}]},{4,[{100,1,10800},{100,2,10800},{100,3,10800}]}]'),(6,5,1080,3240,'[{1,[{100,1,3300},{100,2,3300},{100,3,3300}]},{2,[{100,1,10600},{100,2,10600},{100,3,10600}]},{3,[{100,1,16900},{100,2,16900},{100,3,16900}]},{4,[{100,1,24300},{100,2,24300},{100,3,24300}]},{5,[{100,1,37800},{100,2,37800},{100,3,37800}]}]','[{1,[{100,1,1700},{100,2,1700},{100,3,1700}]},{2,[{100,1,4000},{100,2,4000},{100,3,4000}]},{3,[{100,1,8100},{100,2,8100},{100,3,8100}]},{4,[{100,1,16200},{100,2,16200},{100,3,16200}]}]'),(6,6,1100,3300,'[{1,[{100,1,4600},{100,2,4600},{100,3,4600}]},{2,[{100,1,15000},{100,2,15000},{100,3,15000}]},{3,[{100,1,23900},{100,2,23900},{100,3,23900}]},{4,[{100,1,34400},{100,2,34400},{100,3,34400}]},{5,[{100,1,53600},{100,2,53600},{100,3,53600}]}]','[{1,[{100,1,2400},{100,2,2400},{100,3,2400}]},{2,[{100,1,5600},{100,2,5600},{100,3,5600}]},{3,[{100,1,11500},{100,2,11500},{100,3,11500}]},{4,[{100,1,23000},{100,2,23000},{100,3,23000}]}]'),(6,7,1120,3360,'[{1,[{100,1,6200},{100,2,6200},{100,3,6200}]},{2,[{100,1,20300},{100,2,20300},{100,3,20300}]},{3,[{100,1,32300},{100,2,32300},{100,3,32300}]},{4,[{100,1,46600},{100,2,46600},{100,3,46600}]},{5,[{100,1,72500},{100,2,72500},{100,3,72500}]}]','[{1,[{100,1,3300},{100,2,3300},{100,3,3300}]},{2,[{100,1,7600},{100,2,7600},{100,3,7600}]},{3,[{100,1,15500},{100,2,15500},{100,3,15500}]},{4,[{100,1,31100},{100,2,31100},{100,3,31100}]}]'),(6,8,1140,3420,'[{1,[{100,1,8200},{100,2,8200},{100,3,8200}]},{2,[{100,1,26500},{100,2,26500},{100,3,26500}]},{3,[{100,1,42200},{100,2,42200},{100,3,42200}]},{4,[{100,1,60800},{100,2,60800},{100,3,60800}]},{5,[{100,1,94500},{100,2,94500},{100,3,94500}]}]','[{1,[{100,1,4300},{100,2,4300},{100,3,4300}]},{2,[{100,1,9900},{100,2,9900},{100,3,9900}]},{3,[{100,1,20300},{100,2,20300},{100,3,20300}]},{4,[{100,1,40500},{100,2,40500},{100,3,40500}]}]'),(6,9,1160,3480,'[{1,[{100,1,10300},{100,2,10300},{100,3,10300}]},{2,[{100,1,33500},{100,2,33500},{100,3,33500}]},{3,[{100,1,53400},{100,2,53400},{100,3,53400}]},{4,[{100,1,77000},{100,2,77000},{100,3,77000}]},{5,[{100,1,119700},{100,2,119700},{100,3,119700}]}]','[{1,[{100,1,5400},{100,2,5400},{100,3,5400}]},{2,[{100,1,12600},{100,2,12600},{100,3,12600}]},{3,[{100,1,25700},{100,2,25700},{100,3,25700}]},{4,[{100,1,51300},{100,2,51300},{100,3,51300}]}]'),(6,10,1180,3540,'[{1,[{100,1,12800},{100,2,12800},{100,3,12800}]},{2,[{100,1,41500},{100,2,41500},{100,3,41500}]},{3,[{100,1,66100},{100,2,66100},{100,3,66100}]},{4,[{100,1,95200},{100,2,95200},{100,3,95200}]},{5,[{100,1,148100},{100,2,148100},{100,3,148100}]}]','[{1,[{100,1,6700},{100,2,6700},{100,3,6700}]},{2,[{100,1,15500},{100,2,15500},{100,3,15500}]},{3,[{100,1,31700},{100,2,31700},{100,3,31700}]},{4,[{100,1,63500},{100,2,63500},{100,3,63500}]}]'),(6,11,1200,3600,'[{1,[{100,1,15500},{100,2,15500},{100,3,15500}]},{2,[{100,1,50300},{100,2,50300},{100,3,50300}]},{3,[{100,1,80100},{100,2,80100},{100,3,80100}]},{4,[{100,1,115400},{100,2,115400},{100,3,115400}]},{5,[{100,1,179600},{100,2,179600},{100,3,179600}]}]','[{1,[{100,1,8100},{100,2,8100},{100,3,8100}]},{2,[{100,1,18900},{100,2,18900},{100,3,18900}]},{3,[{100,1,38500},{100,2,38500},{100,3,38500}]},{4,[{100,1,77000},{100,2,77000},{100,3,77000}]}]'),(6,12,1220,3660,'[{1,[{100,1,18500},{100,2,18500},{100,3,18500}]},{2,[{100,1,60000},{100,2,60000},{100,3,60000}]},{3,[{100,1,95600},{100,2,95600},{100,3,95600}]},{4,[{100,1,137700},{100,2,137700},{100,3,137700}]},{5,[{100,1,214200},{100,2,214200},{100,3,214200}]}]','[{1,[{100,1,9600},{100,2,9600},{100,3,9600}]},{2,[{100,1,22500},{100,2,22500},{100,3,22500}]},{3,[{100,1,45900},{100,2,45900},{100,3,45900}]},{4,[{100,1,91800},{100,2,91800},{100,3,91800}]}]'),(6,13,1240,3720,'[{1,[{100,1,21700},{100,2,21700},{100,3,21700}]},{2,[{100,1,70600},{100,2,70600},{100,3,70600}]},{3,[{100,1,112400},{100,2,112400},{100,3,112400}]},{4,[{100,1,162000},{100,2,162000},{100,3,162000}]},{5,[{100,1,252000},{100,2,252000},{100,3,252000}]}]','[{1,[{100,1,11300},{100,2,11300},{100,3,11300}]},{2,[{100,1,26500},{100,2,26500},{100,3,26500}]},{3,[{100,1,54000},{100,2,54000},{100,3,54000}]},{4,[{100,1,108000},{100,2,108000},{100,3,108000}]}]'),(6,14,1260,3780,'[{1,[{100,1,25300},{100,2,25300},{100,3,25300}]},{2,[{100,1,82000},{100,2,82000},{100,3,82000}]},{3,[{100,1,130700},{100,2,130700},{100,3,130700}]},{4,[{100,1,188300},{100,2,188300},{100,3,188300}]},{5,[{100,1,293000},{100,2,293000},{100,3,293000}]}]','[{1,[{100,1,13200},{100,2,13200},{100,3,13200}]},{2,[{100,1,30800},{100,2,30800},{100,3,30800}]},{3,[{100,1,62800},{100,2,62800},{100,3,62800}]},{4,[{100,1,125600},{100,2,125600},{100,3,125600}]}]'),(6,15,1280,3840,'[{1,[{100,1,29100},{100,2,29100},{100,3,29100}]},{2,[{100,1,94400},{100,2,94400},{100,3,94400}]},{3,[{100,1,150400},{100,2,150400},{100,3,150400}]},{4,[{100,1,216700},{100,2,216700},{100,3,216700}]},{5,[{100,1,337100},{100,2,337100},{100,3,337100}]}]','[{1,[{100,1,15200},{100,2,15200},{100,3,15200}]},{2,[{100,1,35400},{100,2,35400},{100,3,35400}]},{3,[{100,1,72200},{100,2,72200},{100,3,72200}]},{4,[{100,1,144500},{100,2,144500},{100,3,144500}]}]'),(6,16,1300,3900,'[{1,[{100,1,33100},{100,2,33100},{100,3,33100}]},{2,[{100,1,107600},{100,2,107600},{100,3,107600}]},{3,[{100,1,171500},{100,2,171500},{100,3,171500}]},{4,[{100,1,247100},{100,2,247100},{100,3,247100}]},{5,[{100,1,384300},{100,2,384300},{100,3,384300}]}]','[{1,[{100,1,17300},{100,2,17300},{100,3,17300}]},{2,[{100,1,40400},{100,2,40400},{100,3,40400}]},{3,[{100,1,82400},{100,2,82400},{100,3,82400}]},{4,[{100,1,164700},{100,2,164700},{100,3,164700}]}]'),(6,17,1320,3960,'[{1,[{100,1,37500},{100,2,37500},{100,3,37500}]},{2,[{100,1,121700},{100,2,121700},{100,3,121700}]},{3,[{100,1,193900},{100,2,193900},{100,3,193900}]},{4,[{100,1,279500},{100,2,279500},{100,3,279500}]},{5,[{100,1,434700},{100,2,434700},{100,3,434700}]}]','[{1,[{100,1,19600},{100,2,19600},{100,3,19600}]},{2,[{100,1,45600},{100,2,45600},{100,3,45600}]},{3,[{100,1,93200},{100,2,93200},{100,3,93200}]},{4,[{100,1,186300},{100,2,186300},{100,3,186300}]}]'),(6,18,1340,4020,'[{1,[{100,1,42100},{100,2,42100},{100,3,42100}]},{2,[{100,1,136700},{100,2,136700},{100,3,136700}]},{3,[{100,1,217800},{100,2,217800},{100,3,217800}]},{4,[{100,1,313900},{100,2,313900},{100,3,313900}]},{5,[{100,1,488300},{100,2,488300},{100,3,488300}]}]','[{1,[{100,1,22000},{100,2,22000},{100,3,22000}]},{2,[{100,1,51300},{100,2,51300},{100,3,51300}]},{3,[{100,1,104600},{100,2,104600},{100,3,104600}]},{4,[{100,1,209300},{100,2,209300},{100,3,209300}]}]'),(6,19,1360,4080,'[{1,[{100,1,47000},{100,2,47000},{100,3,47000}]},{2,[{100,1,152600},{100,2,152600},{100,3,152600}]},{3,[{100,1,243100},{100,2,243100},{100,3,243100}]},{4,[{100,1,350300},{100,2,350300},{100,3,350300}]},{5,[{100,1,545000},{100,2,545000},{100,3,545000}]}]','[{1,[{100,1,24500},{100,2,24500},{100,3,24500}]},{2,[{100,1,57200},{100,2,57200},{100,3,57200}]},{3,[{100,1,116800},{100,2,116800},{100,3,116800}]},{4,[{100,1,233600},{100,2,233600},{100,3,233600}]}]'),(6,20,1380,4140,'[{1,[{100,1,52200},{100,2,52200},{100,3,52200}]},{2,[{100,1,169300},{100,2,169300},{100,3,169300}]},{3,[{100,1,269800},{100,2,269800},{100,3,269800}]},{4,[{100,1,388800},{100,2,388800},{100,3,388800}]},{5,[{100,1,604800},{100,2,604800},{100,3,604800}]}]','[{1,[{100,1,27200},{100,2,27200},{100,3,27200}]},{2,[{100,1,63500},{100,2,63500},{100,3,63500}]},{3,[{100,1,129600},{100,2,129600},{100,3,129600}]},{4,[{100,1,259200},{100,2,259200},{100,3,259200}]}]'),(6,21,1400,4200,'[{1,[{100,1,57600},{100,2,57600},{100,3,57600}]},{2,[{100,1,187000},{100,2,187000},{100,3,187000}]},{3,[{100,1,297900},{100,2,297900},{100,3,297900}]},{4,[{100,1,429300},{100,2,429300},{100,3,429300}]},{5,[{100,1,667800},{100,2,667800},{100,3,667800}]}]','[{1,[{100,1,30100},{100,2,30100},{100,3,30100}]},{2,[{100,1,70100},{100,2,70100},{100,3,70100}]},{3,[{100,1,143100},{100,2,143100},{100,3,143100}]},{4,[{100,1,286200},{100,2,286200},{100,3,286200}]}]'),(6,22,1420,4260,'[{1,[{100,1,63300},{100,2,63300},{100,3,63300}]},{2,[{100,1,205500},{100,2,205500},{100,3,205500}]},{3,[{100,1,327500},{100,2,327500},{100,3,327500}]},{4,[{100,1,471800},{100,2,471800},{100,3,471800}]},{5,[{100,1,734000},{100,2,734000},{100,3,734000}]}]','[{1,[{100,1,33000},{100,2,33000},{100,3,33000}]},{2,[{100,1,77100},{100,2,77100},{100,3,77100}]},{3,[{100,1,157300},{100,2,157300},{100,3,157300}]},{4,[{100,1,314600},{100,2,314600},{100,3,314600}]}]'),(6,23,1440,4320,'[{1,[{100,1,69300},{100,2,69300},{100,3,69300}]},{2,[{100,1,224900},{100,2,224900},{100,3,224900}]},{3,[{100,1,358400},{100,2,358400},{100,3,358400}]},{4,[{100,1,516400},{100,2,516400},{100,3,516400}]},{5,[{100,1,803300},{100,2,803300},{100,3,803300}]}]','[{1,[{100,1,36100},{100,2,36100},{100,3,36100}]},{2,[{100,1,84300},{100,2,84300},{100,3,84300}]},{3,[{100,1,172100},{100,2,172100},{100,3,172100}]},{4,[{100,1,344300},{100,2,344300},{100,3,344300}]}]'),(6,24,1460,4380,'[{1,[{100,1,75500},{100,2,75500},{100,3,75500}]},{2,[{100,1,245200},{100,2,245200},{100,3,245200}]},{3,[{100,1,390700},{100,2,390700},{100,3,390700}]},{4,[{100,1,563000},{100,2,563000},{100,3,563000}]},{5,[{100,1,875700},{100,2,875700},{100,3,875700}]}]','[{1,[{100,1,39400},{100,2,39400},{100,3,39400}]},{2,[{100,1,91900},{100,2,91900},{100,3,91900}]},{3,[{100,1,187700},{100,2,187700},{100,3,187700}]},{4,[{100,1,375300},{100,2,375300},{100,3,375300}]}]'),(6,25,1480,4440,'[{1,[{100,1,82100},{100,2,82100},{100,3,82100}]},{2,[{100,1,266400},{100,2,266400},{100,3,266400}]},{3,[{100,1,424400},{100,2,424400},{100,3,424400}]},{4,[{100,1,611600},{100,2,611600},{100,3,611600}]},{5,[{100,1,951300},{100,2,951300},{100,3,951300}]}]','[{1,[{100,1,42800},{100,2,42800},{100,3,42800}]},{2,[{100,1,99900},{100,2,99900},{100,3,99900}]},{3,[{100,1,203900},{100,2,203900},{100,3,203900}]},{4,[{100,1,407700},{100,2,407700},{100,3,407700}]}]'),(6,26,1500,4500,'[{1,[{100,1,88900},{100,2,88900},{100,3,88900}]},{2,[{100,1,288400},{100,2,288400},{100,3,288400}]},{3,[{100,1,459600},{100,2,459600},{100,3,459600}]},{4,[{100,1,662200},{100,2,662200},{100,3,662200}]},{5,[{100,1,1030100},{100,2,1030100},{100,3,1030100}]}]','[{1,[{100,1,46400},{100,2,46400},{100,3,46400}]},{2,[{100,1,108200},{100,2,108200},{100,3,108200}]},{3,[{100,1,220700},{100,2,220700},{100,3,220700}]},{4,[{100,1,441500},{100,2,441500},{100,3,441500}]}]'),(6,27,1520,4560,'[{1,[{100,1,95900},{100,2,95900},{100,3,95900}]},{2,[{100,1,311300},{100,2,311300},{100,3,311300}]},{3,[{100,1,496100},{100,2,496100},{100,3,496100}]},{4,[{100,1,714800},{100,2,714800},{100,3,714800}]},{5,[{100,1,1112000},{100,2,1112000},{100,3,1112000}]}]','[{1,[{100,1,50000},{100,2,50000},{100,3,50000}]},{2,[{100,1,116800},{100,2,116800},{100,3,116800}]},{3,[{100,1,238300},{100,2,238300},{100,3,238300}]},{4,[{100,1,476600},{100,2,476600},{100,3,476600}]}]'),(6,28,1540,4620,'[{1,[{100,1,103300},{100,2,103300},{100,3,103300}]},{2,[{100,1,335200},{100,2,335200},{100,3,335200}]},{3,[{100,1,534000},{100,2,534000},{100,3,534000}]},{4,[{100,1,769500},{100,2,769500},{100,3,769500}]},{5,[{100,1,1197000},{100,2,1197000},{100,3,1197000}]}]','[{1,[{100,1,53900},{100,2,53900},{100,3,53900}]},{2,[{100,1,125700},{100,2,125700},{100,3,125700}]},{3,[{100,1,256500},{100,2,256500},{100,3,256500}]},{4,[{100,1,513000},{100,2,513000},{100,3,513000}]}]'),(6,29,1560,4680,'[{1,[{100,1,110900},{100,2,110900},{100,3,110900}]},{2,[{100,1,359900},{100,2,359900},{100,3,359900}]},{3,[{100,1,573400},{100,2,573400},{100,3,573400}]},{4,[{100,1,826200},{100,2,826200},{100,3,826200}]},{5,[{100,1,1285200},{100,2,1285200},{100,3,1285200}]}]','[{1,[{100,1,57800},{100,2,57800},{100,3,57800}]},{2,[{100,1,134900},{100,2,134900},{100,3,134900}]},{3,[{100,1,275400},{100,2,275400},{100,3,275400}]},{4,[{100,1,550800},{100,2,550800},{100,3,550800}]}]'),(6,30,1580,4740,'[{1,[{100,1,118700},{100,2,118700},{100,3,118700}]},{2,[{100,1,385400},{100,2,385400},{100,3,385400}]},{3,[{100,1,614200},{100,2,614200},{100,3,614200}]},{4,[{100,1,884900},{100,2,884900},{100,3,884900}]},{5,[{100,1,1376600},{100,2,1376600},{100,3,1376600}]}]','[{1,[{100,1,61900},{100,2,61900},{100,3,61900}]},{2,[{100,1,144500},{100,2,144500},{100,3,144500}]},{3,[{100,1,295000},{100,2,295000},{100,3,295000}]},{4,[{100,1,590000},{100,2,590000},{100,3,590000}]}]'),(6,31,1600,4800,'[{1,[{100,1,126900},{100,2,126900},{100,3,126900}]},{2,[{100,1,411900},{100,2,411900},{100,3,411900}]},{3,[{100,1,656300},{100,2,656300},{100,3,656300}]},{4,[{100,1,945700},{100,2,945700},{100,3,945700}]},{5,[{100,1,1471100},{100,2,1471100},{100,3,1471100}]}]','[{1,[{100,1,66200},{100,2,66200},{100,3,66200}]},{2,[{100,1,154500},{100,2,154500},{100,3,154500}]},{3,[{100,1,315200},{100,2,315200},{100,3,315200}]},{4,[{100,1,630500},{100,2,630500},{100,3,630500}]}]'),(6,32,1620,4860,'[{1,[{100,1,135300},{100,2,135300},{100,3,135300}]},{2,[{100,1,439200},{100,2,439200},{100,3,439200}]},{3,[{100,1,699900},{100,2,699900},{100,3,699900}]},{4,[{100,1,1008500},{100,2,1008500},{100,3,1008500}]},{5,[{100,1,1568700},{100,2,1568700},{100,3,1568700}]}]','[{1,[{100,1,70600},{100,2,70600},{100,3,70600}]},{2,[{100,1,164700},{100,2,164700},{100,3,164700}]},{3,[{100,1,336200},{100,2,336200},{100,3,336200}]},{4,[{100,1,672300},{100,2,672300},{100,3,672300}]}]'),(6,33,1640,4920,'[{1,[{100,1,144000},{100,2,144000},{100,3,144000}]},{2,[{100,1,467500},{100,2,467500},{100,3,467500}]},{3,[{100,1,744900},{100,2,744900},{100,3,744900}]},{4,[{100,1,1073300},{100,2,1073300},{100,3,1073300}]},{5,[{100,1,1669500},{100,2,1669500},{100,3,1669500}]}]','[{1,[{100,1,75100},{100,2,75100},{100,3,75100}]},{2,[{100,1,175300},{100,2,175300},{100,3,175300}]},{3,[{100,1,357800},{100,2,357800},{100,3,357800}]},{4,[{100,1,715500},{100,2,715500},{100,3,715500}]}]'),(6,34,1660,4980,'[{1,[{100,1,153000},{100,2,153000},{100,3,153000}]},{2,[{100,1,496600},{100,2,496600},{100,3,496600}]},{3,[{100,1,791200},{100,2,791200},{100,3,791200}]},{4,[{100,1,1140100},{100,2,1140100},{100,3,1140100}]},{5,[{100,1,1773500},{100,2,1773500},{100,3,1773500}]}]','[{1,[{100,1,79800},{100,2,79800},{100,3,79800}]},{2,[{100,1,186200},{100,2,186200},{100,3,186200}]},{3,[{100,1,380000},{100,2,380000},{100,3,380000}]},{4,[{100,1,760100},{100,2,760100},{100,3,760100}]}]'),(6,35,1680,5040,'[{1,[{100,1,162200},{100,2,162200},{100,3,162200}]},{2,[{100,1,526600},{100,2,526600},{100,3,526600}]},{3,[{100,1,839000},{100,2,839000},{100,3,839000}]},{4,[{100,1,1208900},{100,2,1208900},{100,3,1208900}]},{5,[{100,1,1880600},{100,2,1880600},{100,3,1880600}]}]','[{1,[{100,1,84600},{100,2,84600},{100,3,84600}]},{2,[{100,1,197500},{100,2,197500},{100,3,197500}]},{3,[{100,1,403000},{100,2,403000},{100,3,403000}]},{4,[{100,1,806000},{100,2,806000},{100,3,806000}]}]'),(6,36,1700,5100,'[{1,[{100,1,171700},{100,2,171700},{100,3,171700}]},{2,[{100,1,557400},{100,2,557400},{100,3,557400}]},{3,[{100,1,888200},{100,2,888200},{100,3,888200}]},{4,[{100,1,1279800},{100,2,1279800},{100,3,1279800}]},{5,[{100,1,1990800},{100,2,1990800},{100,3,1990800}]}]','[{1,[{100,1,89600},{100,2,89600},{100,3,89600}]},{2,[{100,1,209000},{100,2,209000},{100,3,209000}]},{3,[{100,1,426600},{100,2,426600},{100,3,426600}]},{4,[{100,1,853200},{100,2,853200},{100,3,853200}]}]'),(6,37,1720,5160,'[{1,[{100,1,181500},{100,2,181500},{100,3,181500}]},{2,[{100,1,589200},{100,2,589200},{100,3,589200}]},{3,[{100,1,938800},{100,2,938800},{100,3,938800}]},{4,[{100,1,1352700},{100,2,1352700},{100,3,1352700}]},{5,[{100,1,2104200},{100,2,2104200},{100,3,2104200}]}]','[{1,[{100,1,94700},{100,2,94700},{100,3,94700}]},{2,[{100,1,220900},{100,2,220900},{100,3,220900}]},{3,[{100,1,450900},{100,2,450900},{100,3,450900}]},{4,[{100,1,901800},{100,2,901800},{100,3,901800}]}]'),(6,38,1740,5220,'[{1,[{100,1,191600},{100,2,191600},{100,3,191600}]},{2,[{100,1,621800},{100,2,621800},{100,3,621800}]},{3,[{100,1,990800},{100,2,990800},{100,3,990800}]},{4,[{100,1,1427600},{100,2,1427600},{100,3,1427600}]},{5,[{100,1,2220800},{100,2,2220800},{100,3,2220800}]}]','[{1,[{100,1,99900},{100,2,99900},{100,3,99900}]},{2,[{100,1,233200},{100,2,233200},{100,3,233200}]},{3,[{100,1,475900},{100,2,475900},{100,3,475900}]},{4,[{100,1,951800},{100,2,951800},{100,3,951800}]}]'),(6,39,1760,5280,'[{1,[{100,1,201900},{100,2,201900},{100,3,201900}]},{2,[{100,1,655300},{100,2,655300},{100,3,655300}]},{3,[{100,1,1044200},{100,2,1044200},{100,3,1044200}]},{4,[{100,1,1504600},{100,2,1504600},{100,3,1504600}]},{5,[{100,1,2340500},{100,2,2340500},{100,3,2340500}]}]','[{1,[{100,1,105300},{100,2,105300},{100,3,105300}]},{2,[{100,1,245700},{100,2,245700},{100,3,245700}]},{3,[{100,1,501500},{100,2,501500},{100,3,501500}]},{4,[{100,1,1003100},{100,2,1003100},{100,3,1003100}]}]'),(6,40,1780,5340,'[{1,[{100,1,212500},{100,2,212500},{100,3,212500}]},{2,[{100,1,689700},{100,2,689700},{100,3,689700}]},{3,[{100,1,1099000},{100,2,1099000},{100,3,1099000}]},{4,[{100,1,1583600},{100,2,1583600},{100,3,1583600}]},{5,[{100,1,2463300},{100,2,2463300},{100,3,2463300}]}]','[{1,[{100,1,110800},{100,2,110800},{100,3,110800}]},{2,[{100,1,258600},{100,2,258600},{100,3,258600}]},{3,[{100,1,527900},{100,2,527900},{100,3,527900}]},{4,[{100,1,1055700},{100,2,1055700},{100,3,1055700}]}]'),(6,41,1800,5400,'[{1,[{100,1,223400},{100,2,223400},{100,3,223400}]},{2,[{100,1,725000},{100,2,725000},{100,3,725000}]},{3,[{100,1,1155200},{100,2,1155200},{100,3,1155200}]},{4,[{100,1,1664600},{100,2,1664600},{100,3,1664600}]},{5,[{100,1,2589300},{100,2,2589300},{100,3,2589300}]}]','[{1,[{100,1,116500},{100,2,116500},{100,3,116500}]},{2,[{100,1,271900},{100,2,271900},{100,3,271900}]},{3,[{100,1,554900},{100,2,554900},{100,3,554900}]},{4,[{100,1,1109700},{100,2,1109700},{100,3,1109700}]}]'),(6,42,1820,5460,'[{1,[{100,1,234500},{100,2,234500},{100,3,234500}]},{2,[{100,1,761200},{100,2,761200},{100,3,761200}]},{3,[{100,1,1212800},{100,2,1212800},{100,3,1212800}]},{4,[{100,1,1747600},{100,2,1747600},{100,3,1747600}]},{5,[{100,1,2718500},{100,2,2718500},{100,3,2718500}]}]','[{1,[{100,1,122300},{100,2,122300},{100,3,122300}]},{2,[{100,1,285400},{100,2,285400},{100,3,285400}]},{3,[{100,1,582500},{100,2,582500},{100,3,582500}]},{4,[{100,1,1165100},{100,2,1165100},{100,3,1165100}]}]'),(6,43,1840,5520,'[{1,[{100,1,245900},{100,2,245900},{100,3,245900}]},{2,[{100,1,798200},{100,2,798200},{100,3,798200}]},{3,[{100,1,1271900},{100,2,1271900},{100,3,1271900}]},{4,[{100,1,1832600},{100,2,1832600},{100,3,1832600}]},{5,[{100,1,2850800},{100,2,2850800},{100,3,2850800}]}]','[{1,[{100,1,128300},{100,2,128300},{100,3,128300}]},{2,[{100,1,299300},{100,2,299300},{100,3,299300}]},{3,[{100,1,610900},{100,2,610900},{100,3,610900}]},{4,[{100,1,1221800},{100,2,1221800},{100,3,1221800}]}]'),(6,44,1860,5580,'[{1,[{100,1,257600},{100,2,257600},{100,3,257600}]},{2,[{100,1,836100},{100,2,836100},{100,3,836100}]},{3,[{100,1,1332300},{100,2,1332300},{100,3,1332300}]},{4,[{100,1,1919700},{100,2,1919700},{100,3,1919700}]},{5,[{100,1,2986200},{100,2,2986200},{100,3,2986200}]}]','[{1,[{100,1,134400},{100,2,134400},{100,3,134400}]},{2,[{100,1,313600},{100,2,313600},{100,3,313600}]},{3,[{100,1,639900},{100,2,639900},{100,3,639900}]},{4,[{100,1,1279800},{100,2,1279800},{100,3,1279800}]}]'),(6,45,1880,5640,'[{1,[{100,1,269500},{100,2,269500},{100,3,269500}]},{2,[{100,1,874900},{100,2,874900},{100,3,874900}]},{3,[{100,1,1394100},{100,2,1394100},{100,3,1394100}]},{4,[{100,1,2008800},{100,2,2008800},{100,3,2008800}]},{5,[{100,1,3124800},{100,2,3124800},{100,3,3124800}]}]','[{1,[{100,1,140600},{100,2,140600},{100,3,140600}]},{2,[{100,1,328100},{100,2,328100},{100,3,328100}]},{3,[{100,1,669600},{100,2,669600},{100,3,669600}]},{4,[{100,1,1339200},{100,2,1339200},{100,3,1339200}]}]'),(6,46,1900,5700,'[{1,[{100,1,281800},{100,2,281800},{100,3,281800}]},{2,[{100,1,914600},{100,2,914600},{100,3,914600}]},{3,[{100,1,1457400},{100,2,1457400},{100,3,1457400}]},{4,[{100,1,2099900},{100,2,2099900},{100,3,2099900}]},{5,[{100,1,3266600},{100,2,3266600},{100,3,3266600}]}]','[{1,[{100,1,147000},{100,2,147000},{100,3,147000}]},{2,[{100,1,343000},{100,2,343000},{100,3,343000}]},{3,[{100,1,700000},{100,2,700000},{100,3,700000}]},{4,[{100,1,1400000},{100,2,1400000},{100,3,1400000}]}]'),(6,47,1920,5760,'[{1,[{100,1,294300},{100,2,294300},{100,3,294300}]},{2,[{100,1,955200},{100,2,955200},{100,3,955200}]},{3,[{100,1,1522000},{100,2,1522000},{100,3,1522000}]},{4,[{100,1,2193100},{100,2,2193100},{100,3,2193100}]},{5,[{100,1,3411500},{100,2,3411500},{100,3,3411500}]}]','[{1,[{100,1,153500},{100,2,153500},{100,3,153500}]},{2,[{100,1,358200},{100,2,358200},{100,3,358200}]},{3,[{100,1,731000},{100,2,731000},{100,3,731000}]},{4,[{100,1,1462100},{100,2,1462100},{100,3,1462100}]}]'),(6,48,1940,5820,'[{1,[{100,1,307000},{100,2,307000},{100,3,307000}]},{2,[{100,1,996700},{100,2,996700},{100,3,996700}]},{3,[{100,1,1588100},{100,2,1588100},{100,3,1588100}]},{4,[{100,1,2288300},{100,2,2288300},{100,3,2288300}]},{5,[{100,1,3559500},{100,2,3559500},{100,3,3559500}]}]','[{1,[{100,1,160200},{100,2,160200},{100,3,160200}]},{2,[{100,1,373700},{100,2,373700},{100,3,373700}]},{3,[{100,1,762800},{100,2,762800},{100,3,762800}]},{4,[{100,1,1525500},{100,2,1525500},{100,3,1525500}]}]'),(6,49,1960,5880,'[{1,[{100,1,320100},{100,2,320100},{100,3,320100}]},{2,[{100,1,1039000},{100,2,1039000},{100,3,1039000}]},{3,[{100,1,1655500},{100,2,1655500},{100,3,1655500}]},{4,[{100,1,2385500},{100,2,2385500},{100,3,2385500}]},{5,[{100,1,3710700},{100,2,3710700},{100,3,3710700}]}]','[{1,[{100,1,167000},{100,2,167000},{100,3,167000}]},{2,[{100,1,389600},{100,2,389600},{100,3,389600}]},{3,[{100,1,795200},{100,2,795200},{100,3,795200}]},{4,[{100,1,1590300},{100,2,1590300},{100,3,1590300}]}]'),(6,50,1980,5940,'[{1,[{100,1,333400},{100,2,333400},{100,3,333400}]},{2,[{100,1,1082200},{100,2,1082200},{100,3,1082200}]},{3,[{100,1,1724400},{100,2,1724400},{100,3,1724400}]},{4,[{100,1,2484700},{100,2,2484700},{100,3,2484700}]},{5,[{100,1,3865100},{100,2,3865100},{100,3,3865100}]}]','[{1,[{100,1,173900},{100,2,173900},{100,3,173900}]},{2,[{100,1,405800},{100,2,405800},{100,3,405800}]},{3,[{100,1,828200},{100,2,828200},{100,3,828200}]},{4,[{100,1,1656500},{100,2,1656500},{100,3,1656500}]}]'),(6,51,2000,6000,'[{1,[{100,1,347000},{100,2,347000},{100,3,347000}]},{2,[{100,1,1126300},{100,2,1126300},{100,3,1126300}]},{3,[{100,1,1794700},{100,2,1794700},{100,3,1794700}]},{4,[{100,1,2585900},{100,2,2585900},{100,3,2585900}]},{5,[{100,1,4022600},{100,2,4022600},{100,3,4022600}]}]','[{1,[{100,1,181000},{100,2,181000},{100,3,181000}]},{2,[{100,1,422400},{100,2,422400},{100,3,422400}]},{3,[{100,1,862000},{100,2,862000},{100,3,862000}]},{4,[{100,1,1724000},{100,2,1724000},{100,3,1724000}]}]'),(6,52,2020,6060,'[{1,[{100,1,360800},{100,2,360800},{100,3,360800}]},{2,[{100,1,1171300},{100,2,1171300},{100,3,1171300}]},{3,[{100,1,1866400},{100,2,1866400},{100,3,1866400}]},{4,[{100,1,2689200},{100,2,2689200},{100,3,2689200}]},{5,[{100,1,4183200},{100,2,4183200},{100,3,4183200}]}]','[{1,[{100,1,188200},{100,2,188200},{100,3,188200}]},{2,[{100,1,439200},{100,2,439200},{100,3,439200}]},{3,[{100,1,896400},{100,2,896400},{100,3,896400}]},{4,[{100,1,1792800},{100,2,1792800},{100,3,1792800}]}]'),(6,53,2040,6120,'[{1,[{100,1,375000},{100,2,375000},{100,3,375000}]},{2,[{100,1,1217200},{100,2,1217200},{100,3,1217200}]},{3,[{100,1,1939400},{100,2,1939400},{100,3,1939400}]},{4,[{100,1,2794500},{100,2,2794500},{100,3,2794500}]},{5,[{100,1,4347000},{100,2,4347000},{100,3,4347000}]}]','[{1,[{100,1,195600},{100,2,195600},{100,3,195600}]},{2,[{100,1,456400},{100,2,456400},{100,3,456400}]},{3,[{100,1,931500},{100,2,931500},{100,3,931500}]},{4,[{100,1,1863000},{100,2,1863000},{100,3,1863000}]}]'),(6,54,2060,6180,'[{1,[{100,1,389400},{100,2,389400},{100,3,389400}]},{2,[{100,1,1263900},{100,2,1263900},{100,3,1263900}]},{3,[{100,1,2013900},{100,2,2013900},{100,3,2013900}]},{4,[{100,1,2901800},{100,2,2901800},{100,3,2901800}]},{5,[{100,1,4514000},{100,2,4514000},{100,3,4514000}]}]','[{1,[{100,1,203100},{100,2,203100},{100,3,203100}]},{2,[{100,1,474000},{100,2,474000},{100,3,474000}]},{3,[{100,1,967300},{100,2,967300},{100,3,967300}]},{4,[{100,1,1934600},{100,2,1934600},{100,3,1934600}]}]'),(6,55,2080,6240,'[{1,[{100,1,404000},{100,2,404000},{100,3,404000}]},{2,[{100,1,1311500},{100,2,1311500},{100,3,1311500}]},{3,[{100,1,2089800},{100,2,2089800},{100,3,2089800}]},{4,[{100,1,3011200},{100,2,3011200},{100,3,3011200}]},{5,[{100,1,4684100},{100,2,4684100},{100,3,4684100}]}]','[{1,[{100,1,210800},{100,2,210800},{100,3,210800}]},{2,[{100,1,491800},{100,2,491800},{100,3,491800}]},{3,[{100,1,1003700},{100,2,1003700},{100,3,1003700}]},{4,[{100,1,2007500},{100,2,2007500},{100,3,2007500}]}]'),(6,56,2100,6300,'[{1,[{100,1,419000},{100,2,419000},{100,3,419000}]},{2,[{100,1,1360000},{100,2,1360000},{100,3,1360000}]},{3,[{100,1,2167100},{100,2,2167100},{100,3,2167100}]},{4,[{100,1,3122600},{100,2,3122600},{100,3,3122600}]},{5,[{100,1,4857300},{100,2,4857300},{100,3,4857300}]}]','[{1,[{100,1,218600},{100,2,218600},{100,3,218600}]},{2,[{100,1,510000},{100,2,510000},{100,3,510000}]},{3,[{100,1,1040900},{100,2,1040900},{100,3,1040900}]},{4,[{100,1,2081700},{100,2,2081700},{100,3,2081700}]}]'),(6,57,2120,6360,'[{1,[{100,1,434200},{100,2,434200},{100,3,434200}]},{2,[{100,1,1409400},{100,2,1409400},{100,3,1409400}]},{3,[{100,1,2245800},{100,2,2245800},{100,3,2245800}]},{4,[{100,1,3236000},{100,2,3236000},{100,3,3236000}]},{5,[{100,1,5033700},{100,2,5033700},{100,3,5033700}]}]','[{1,[{100,1,226500},{100,2,226500},{100,3,226500}]},{2,[{100,1,528500},{100,2,528500},{100,3,528500}]},{3,[{100,1,1078700},{100,2,1078700},{100,3,1078700}]},{4,[{100,1,2157300},{100,2,2157300},{100,3,2157300}]}]'),(6,58,2140,6420,'[{1,[{100,1,449700},{100,2,449700},{100,3,449700}]},{2,[{100,1,1459700},{100,2,1459700},{100,3,1459700}]},{3,[{100,1,2325900},{100,2,2325900},{100,3,2325900}]},{4,[{100,1,3351400},{100,2,3351400},{100,3,3351400}]},{5,[{100,1,5213300},{100,2,5213300},{100,3,5213300}]}]','[{1,[{100,1,234600},{100,2,234600},{100,3,234600}]},{2,[{100,1,547400},{100,2,547400},{100,3,547400}]},{3,[{100,1,1117100},{100,2,1117100},{100,3,1117100}]},{4,[{100,1,2234300},{100,2,2234300},{100,3,2234300}]}]'),(6,59,2160,6480,'[{1,[{100,1,465500},{100,2,465500},{100,3,465500}]},{2,[{100,1,1510900},{100,2,1510900},{100,3,1510900}]},{3,[{100,1,2407400},{100,2,2407400},{100,3,2407400}]},{4,[{100,1,3468800},{100,2,3468800},{100,3,3468800}]},{5,[{100,1,5396000},{100,2,5396000},{100,3,5396000}]}]','[{1,[{100,1,242800},{100,2,242800},{100,3,242800}]},{2,[{100,1,566600},{100,2,566600},{100,3,566600}]},{3,[{100,1,1156300},{100,2,1156300},{100,3,1156300}]},{4,[{100,1,2312600},{100,2,2312600},{100,3,2312600}]}]'),(6,60,2180,6540,'[{1,[{100,1,481200},{100,2,481200},{100,3,481200}]},{2,[{100,1,1562000},{100,2,1562000},{100,3,1562000}]},{3,[{100,1,2488900},{100,2,2488900},{100,3,2488900}]},{4,[{100,1,3586300},{100,2,3586300},{100,3,3586300}]},{5,[{100,1,5578700},{100,2,5578700},{100,3,5578700}]}]','[{1,[{100,1,251000},{100,2,251000},{100,3,251000}]},{2,[{100,1,585800},{100,2,585800},{100,3,585800}]},{3,[{100,1,1195400},{100,2,1195400},{100,3,1195400}]},{4,[{100,1,2390900},{100,2,2390900},{100,3,2390900}]}]');
/*!40000 ALTER TABLE `base_role_home_wish_build` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_role_home_wish_reward`
--

DROP TABLE IF EXISTS `base_role_home_wish_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_role_home_wish_reward` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '序号',
  `wish_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '许愿池id',
  `condition` varchar(512) NOT NULL DEFAULT '[]' COMMENT '建筑条件',
  `weight` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '权重',
  `reward` varchar(512) NOT NULL DEFAULT '[]' COMMENT '奖励列表',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_role_home_wish_reward`
--

LOCK TABLES `base_role_home_wish_reward` WRITE;
/*!40000 ALTER TABLE `base_role_home_wish_reward` DISABLE KEYS */;
INSERT INTO `base_role_home_wish_reward` VALUES (1,2,'[{6,1,60}]',65,'[{0,48060101,1}]'),(2,2,'[{6,1,60}]',35,'[{0,48060102,1}]'),(3,3,'[{9,1,2},{6,1,60}]',15,'[{0,46010001,1}]'),(4,3,'[{9,3,5},{6,3,60}]',15,'[{0,46010002,1}]'),(5,3,'[{9,6,8},{6,6,60}]',15,'[{0,46010003,1}]'),(6,3,'[{9,9,11},{6,9,60}]',12,'[{0,46010004,1}]'),(7,3,'[{9,12,14},{6,12,60}]',12,'[{0,46010005,1}]'),(8,3,'[{9,15,17},{6,15,60}]',12,'[{0,46010006,1}]'),(9,3,'[{9,18,20},{6,18,60}]',12,'[{0,46010007,1}]'),(10,3,'[{9,21,23},{6,21,60}]',12,'[{0,46010008,1}]'),(11,3,'[{9,24,26},{6,24,60}]',10,'[{0,46010009,1}]'),(12,3,'[{9,27,29},{6,27,60}]',10,'[{0,46010010,1}]'),(13,3,'[{9,27,29},{6,27,60}]',10,'[{0,46010011,1}]'),(14,3,'[{9,30,32},{6,30,60}]',10,'[{0,46010012,1}]'),(15,3,'[{9,30,32},{6,30,60}]',10,'[{0,46010013,1}]'),(16,3,'[{9,33,35},{6,33,60}]',8,'[{0,46010014,1}]'),(17,3,'[{9,33,35},{6,33,60}]',8,'[{0,46010015,1}]'),(18,3,'[{9,36,39},{6,36,60}]',8,'[{0,46010016,1}]'),(19,3,'[{9,36,39},{6,36,60}]',8,'[{0,46010017,1}]'),(20,3,'[{9,40,60},{6,40,60}]',8,'[{0,46010018,1}]'),(21,3,'[{6,1,60}]',60,'[{0,48060102,1}]'),(22,3,'[{6,1,60}]',40,'[{0,48060103,1}]'),(23,4,'[{9,1,2},{6,1,60}]',40,'[{0,46010001,1}]'),(24,4,'[{9,3,5},{6,3,60}]',40,'[{0,46010002,1}]'),(25,4,'[{9,6,8},{6,6,60}]',40,'[{0,46010003,1}]'),(26,4,'[{9,9,11},{6,9,60}]',40,'[{0,46010004,1}]'),(27,4,'[{9,12,14},{6,12,60}]',30,'[{0,46010005,1}]'),(28,4,'[{9,15,17},{6,15,60}]',30,'[{0,46010006,1}]'),(29,4,'[{9,18,20},{6,18,60}]',30,'[{0,46010007,1}]'),(30,4,'[{9,21,23},{6,21,60}]',30,'[{0,46010008,1}]'),(31,4,'[{9,24,26},{6,24,60}]',30,'[{0,46010009,1}]'),(32,4,'[{9,27,29},{6,27,60}]',25,'[{0,46010010,1}]'),(33,4,'[{9,27,29},{6,27,60}]',25,'[{0,46010011,1}]'),(34,4,'[{9,30,32},{6,30,60}]',25,'[{0,46010012,1}]'),(35,4,'[{9,30,32},{6,30,60}]',25,'[{0,46010013,1}]'),(36,4,'[{9,33,35},{6,33,60}]',25,'[{0,46010014,1}]'),(37,4,'[{9,33,35},{6,33,60}]',20,'[{0,46010015,1}]'),(38,4,'[{9,36,39},{6,36,60}]',20,'[{0,46010016,1}]'),(39,4,'[{9,36,39},{6,36,60}]',20,'[{0,46010017,1}]'),(40,4,'[{9,40,60},{6,40,60}]',20,'[{0,46010018,1}]'),(41,4,'[{6,1,60}]',50,'[{0,48060103,1}]'),(42,5,'[{6,1,60}]',40,'[{0,48070001,1}]'),(43,5,'[{10,5,9},{6,5,60}]',25,'[{0,47010001,1}]'),(44,5,'[{10,10,14},{6,10,60}]',20,'[{0,47010002,1}]'),(45,5,'[{10,15,19},{6,15,60}]',15,'[{0,47010003,1}]'),(46,5,'[{10,20,24},{6,20,60}]',15,'[{0,47010004,1}]'),(47,5,'[{10,25,29},{6,25,60}]',15,'[{0,47010005,1}]'),(48,5,'[{10,30,34},{6,30,60}]',10,'[{0,47010006,1}]'),(49,5,'[{10,35,60},{6,35,60}]',10,'[{0,47010007,1}]');
/*!40000 ALTER TABLE `base_role_home_wish_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_rule`
--

DROP TABLE IF EXISTS `base_rule`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_rule` (
  `id` int(11) unsigned NOT NULL COMMENT '编号',
  `goods_id` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗物品',
  `attr` varchar(255) NOT NULL COMMENT '法则属性',
  `combat` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战力',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_rule`
--

LOCK TABLES `base_rule` WRITE;
/*!40000 ALTER TABLE `base_rule` DISABLE KEYS */;
INSERT INTO `base_rule` VALUES (1,'[{0,17020001,1}]','[{2,500},{3,20}]',1500),(2,'[{0,17020002,1}]','[{1,50},{4,40}]',3000),(3,'[{0,17020003,1}]','[{2,1600},{1,80},{61,50},{63,50}]',3200),(4,'[{0,17020004,1}]','[{3,120},{4,120},{60,100},{62,100}]',12000);
/*!40000 ALTER TABLE `base_rule` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_rush_giftbag`
--

DROP TABLE IF EXISTS `base_rush_giftbag`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_rush_giftbag` (
  `id` smallint(5) unsigned NOT NULL COMMENT '礼包id',
  `bag_type` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '礼包类型',
  `bag_sub_type` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '礼包子类',
  `bag_number` smallint(6) unsigned NOT NULL DEFAULT '0' COMMENT '礼包数量',
  `bag_value` int(10) unsigned NOT NULL COMMENT '领取条件',
  `bag_name` varchar(255) NOT NULL COMMENT '礼包名称@lang@',
  `bag_gift` varchar(500) NOT NULL COMMENT '礼包奖励',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='礼包配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_rush_giftbag`
--

LOCK TABLES `base_rush_giftbag` WRITE;
/*!40000 ALTER TABLE `base_rush_giftbag` DISABLE KEYS */;
INSERT INTO `base_rush_giftbag` VALUES (11001,1,1,0,100,'100级礼包','[{1,[{2,36020001,20},{0,37020001,1},{3,36030001,35000}]},{2,[{2,36020001,20},{0,37020001,1},{3,36030001,35000}]},{3,[{2,36020001,20},{0,37020001,1},{3,36030001,35000}]},{4,[{2,36020001,20},{0,37020001,1},{3,36030001,35000}]}]'),(11002,1,1,0,140,'140级礼包','[{1,[{2,36020001,40},{0,17010001,80},{3,36030001,45000}]},{2,[{2,36020001,40},{0,17010001,80},{3,36030001,45000}]},{3,[{2,36020001,40},{0,17010001,80},{3,36030001,45000}]},{4,[{2,36020001,40},{0,17010001,80},{3,36030001,45000}]}]'),(11003,1,1,0,180,'180级礼包','[{1,[{2,36020001,60},{0,11020001,5},{3,36030001,50000}]},{2,[{2,36020001,60},{0,11020001,5},{3,36030001,50000}]},{3,[{2,36020001,60},{0,11020001,5},{3,36030001,50000}]},{4,[{2,36020001,60},{0,11020001,5},{3,36030001,50000}]}]'),(11004,1,1,0,220,'220级礼包','[{1,[{2,36020001,80},{0,24010001,5},{3,36030001,85000}]},{2,[{2,36020001,80},{0,24010001,5},{3,36030001,85000}]},{3,[{2,36020001,80},{0,24010001,5},{3,36030001,85000}]},{4,[{2,36020001,80},{0,24010001,5},{3,36030001,85000}]}]'),(11005,1,1,0,240,'240级礼包','[{1,[{2,36020001,100},{0,15020101,5},{3,36030001,105000}]},{2,[{2,36020001,100},{0,15020101,5},{3,36030001,105000}]},{3,[{2,36020001,100},{0,15020101,5},{3,36030001,105000}]},{4,[{2,36020001,100},{0,15020101,5},{3,36030001,105000}]}]'),(11006,1,1,0,260,'260级礼包','[{1,[{2,36020001,120},{0,18020001,10},{3,36030001,120000}]},{2,[{2,36020001,120},{0,18020001,10},{3,36030001,120000}]},{3,[{2,36020001,120},{0,18020001,10},{3,36030001,120000}]},{4,[{2,36020001,120},{0,18020001,10},{3,36030001,120000}]}]'),(11007,1,1,0,280,'280级礼包','[{1,[{2,36020001,140},{0,16020001,5},{3,36030001,140000}]},{2,[{2,36020001,140},{0,16020001,5},{3,36030001,140000}]},{3,[{2,36020001,140},{0,16020001,5},{3,36030001,140000}]},{4,[{2,36020001,140},{0,16020001,5},{3,36030001,140000}]}]'),(12001,1,2,600,300,'300级限量礼包','[{1,[{0,20040001,1},{0,20020001,1},{3,36030001,145000}]},{2,[{0,20040001,1},{0,20020001,1},{3,36030001,145000}]},{3,[{0,20040001,1},{0,20020001,1},{3,36030001,145000}]},{4,[{0,20040001,1},{0,20020001,1},{3,36030001,145000}]}]'),(12002,1,2,300,330,'330级限量礼包','[{1,[{0,32080432,1},{0,17020001,1},{3,36030001,150000}]},{2,[{0,32080432,1},{0,17020001,1},{3,36030001,150000}]},{3,[{0,32080432,1},{0,17020001,1},{3,36030001,150000}]},{4,[{0,32080432,1},{0,17020001,1},{3,36030001,150000}]}]'),(12003,1,2,100,360,'360级限量礼包','[{1,[{0,14020203,1},{0,14010103,1},{3,36030001,155000}]},{2,[{0,14020203,1},{0,14010103,1},{3,36030001,155000}]},{3,[{0,14020203,1},{0,14010103,1},{3,36030001,155000}]},{4,[{0,14020203,1},{0,14010103,1},{3,36030001,155000}]}]'),(12004,1,2,50,410,'410级限量礼包','[{1,[{0,24020001,1},{0,32020112,20},{3,36030001,160000}]},{2,[{0,24020001,1},{0,32020112,20},{3,36030001,160000}]},{3,[{0,24020001,1},{0,32020112,20},{3,36030001,160000}]},{4,[{0,24020001,1},{0,32020112,20},{3,36030001,160000}]}]'),(12005,1,2,10,460,'460级限量礼包','[{1,[{100,20040002,1},{0,14010104,1},{3,36030001,180000}]},{2,[{100,20040002,1},{0,14010104,1},{3,36030001,180000}]},{3,[{100,20040002,1},{0,14010104,1},{3,36030001,180000}]},{4,[{100,20040002,1},{0,14010104,1},{3,36030001,180000}]}]'),(12006,1,2,3,510,'510级限量礼包','[{1,[{0,32080642,1},{0,4902017,1},{3,36030001,200000}]},{2,[{0,32080642,1},{0,4902017,1},{3,36030001,200000}]},{3,[{0,32080642,1},{0,4902017,1},{3,36030001,200000}]},{4,[{0,32080642,1},{0,4902017,1},{3,36030001,200000}]}]'),(21001,2,1,0,200000,'20万战力礼包','[{1,[{2,36020001,20},{0,17010001,50},{3,36030001,20000}]},{2,[{2,36020001,20},{0,17010001,50},{3,36030001,20000}]},{3,[{2,36020001,20},{0,17010001,50},{3,36030001,20000}]},{4,[{2,36020001,20},{0,17010001,50},{3,36030001,20000}]}]'),(21002,2,1,0,400000,'40万战力礼包','[{1,[{2,36020001,40},{0,11020001,5},{3,36030001,40000}]},{2,[{2,36020001,40},{0,11020001,5},{3,36030001,40000}]},{3,[{2,36020001,40},{0,11020001,5},{3,36030001,40000}]},{4,[{2,36020001,40},{0,11020001,5},{3,36030001,40000}]}]'),(21003,2,1,0,600000,'60万战力礼包','[{1,[{2,36020001,60},{0,24010001,5},{3,36030001,60000}]},{2,[{2,36020001,60},{0,24010001,5},{3,36030001,60000}]},{3,[{2,36020001,60},{0,24010001,5},{3,36030001,60000}]},{4,[{2,36020001,60},{0,24010001,5},{3,36030001,60000}]}]'),(21004,2,1,0,800000,'80万战力礼包','[{1,[{2,36020001,80},{0,15020101,5},{3,36030001,80000}]},{2,[{2,36020001,80},{0,15020101,5},{3,36030001,80000}]},{3,[{2,36020001,80},{0,15020101,5},{3,36030001,80000}]},{4,[{2,36020001,80},{0,15020101,5},{3,36030001,80000}]}]'),(21005,2,1,0,1000000,'100万战力礼包','[{1,[{2,36020001,100},{0,18020001,10},{3,36030001,100000}]},{2,[{2,36020001,100},{0,18020001,10},{3,36030001,100000}]},{3,[{2,36020001,100},{0,18020001,10},{3,36030001,100000}]},{4,[{2,36020001,100},{0,18020001,10},{3,36030001,100000}]}]'),(21006,2,1,0,1200000,'120万战力礼包','[{1,[{2,36020001,120},{0,16020001,5},{3,36030001,120000}]},{2,[{2,36020001,120},{0,16020001,5},{3,36030001,120000}]},{3,[{2,36020001,120},{0,16020001,5},{3,36030001,120000}]},{4,[{2,36020001,120},{0,16020001,5},{3,36030001,120000}]}]'),(21007,2,1,0,1500000,'150万战力礼包','[{1,[{2,36020001,140},{0,18060001,6},{3,36030001,140000}]},{2,[{2,36020001,140},{0,18060001,6},{3,36030001,140000}]},{3,[{2,36020001,140},{0,18060001,6},{3,36030001,140000}]},{4,[{2,36020001,140},{0,18060001,6},{3,36030001,140000}]}]'),(21008,2,1,0,2000000,'200万战力礼包','[{1,[{2,36020001,160},{0,14020204,1},{3,36030001,160000}]},{2,[{2,36020001,160},{0,14020204,1},{3,36030001,160000}]},{3,[{2,36020001,160},{0,14020204,1},{3,36030001,160000}]},{4,[{2,36020001,160},{0,14020204,1},{3,36030001,160000}]}]'),(21009,2,1,0,2500000,'250万战力礼包','[{1,[{2,36020001,180},{0,14010104,1},{3,36030001,180000}]},{2,[{2,36020001,180},{0,14010104,1},{3,36030001,180000}]},{3,[{2,36020001,180},{0,14010104,1},{3,36030001,180000}]},{4,[{2,36020001,180},{0,14010104,1},{3,36030001,180000}]}]'),(21010,2,1,0,3000000,'300万战力礼包','[{1,[{2,36020001,200},{0,4902018,1},{3,36030001,200000}]},{2,[{2,36020001,200},{0,4902018,1},{3,36030001,200000}]},{3,[{2,36020001,200},{0,4902018,1},{3,36030001,200000}]},{4,[{2,36020001,200},{0,4902018,1},{3,36030001,200000}]}]');
/*!40000 ALTER TABLE `base_rush_giftbag` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_rush_goal_reward`
--

DROP TABLE IF EXISTS `base_rush_goal_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_rush_goal_reward` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动Id(冲榜)',
  `reward_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励id',
  `goal_value` varchar(255) NOT NULL DEFAULT '[]' COMMENT '目标值',
  `reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `about` varchar(1024) NOT NULL DEFAULT '' COMMENT '奖励说明',
  PRIMARY KEY (`id`,`reward_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='冲榜目标奖励配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_rush_goal_reward`
--

LOCK TABLES `base_rush_goal_reward` WRITE;
/*!40000 ALTER TABLE `base_rush_goal_reward` DISABLE KEYS */;
INSERT INTO `base_rush_goal_reward` VALUES (1,1,'[{lv,{150,0}}]','[{0,20060001,5}]','等级达到150级可领取'),(1,2,'[{lv,{190,0}}]','[{0,20060001,10},{0,20020001,1}]','等级达到190级可领取'),(1,3,'[{lv,{210,0}}]','[{0,20060001,15}]','等级达到210级可领取'),(1,4,'[{lv,{240,0}}]','[{0,20060001,20},{0,24020002,1}]','等级达到240级可领取'),(2,1,'[{combat,100000}]','[{0,11020001,5}]','降神战力达100000可领取'),(2,2,'[{combat,200000}]','[{0,11020001,10},{0,20020002,1}]','降神战力达200000可领取'),(6,1,'[{combat,1500000}]','[{0,32020111,2},{0,38250001,10}]','战力达到1500000可领取'),(6,2,'[{combat,2100000}]','[{0,32020111,5},{0,38250001,20}]','战力达到2100000可领取'),(7,1,'[{combat,70000}]','[{0,16020001,5}]','坐骑战力达70000可领取'),(7,2,'[{combat,150000}]','[{0,16020001,10},{0,16010002,1}]','坐骑战力达150000可领取'),(8,1,'[{combat,100000}]','[{0,32160005,5}]','魂珠战力达100000可领取'),(8,2,'[{combat,200000}]','[{0,32160005,10},{0,38180010,1}]','魂珠战力达200000可领取'),(9,1,'[{combat,1000000}]','[{0,32020111,2},{0,38250001,10}]','装备战力达1000000可领取'),(9,2,'[{combat,1500000}]','[{0,32020111,5},{0,38250001,20}]','装备战力达1500000可领取');
/*!40000 ALTER TABLE `base_rush_goal_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_rush_rank`
--

DROP TABLE IF EXISTS `base_rush_rank`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_rush_rank` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动id(冲榜)',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '活动名称(冲榜)',
  `start_day` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开服第几天开始',
  `clear_day` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开服第几天结算',
  `max_len` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '榜单长度',
  `limit` varchar(255) NOT NULL DEFAULT '[]' COMMENT '上榜阈值[{字段, 值}]',
  `figure_id` varchar(255) NOT NULL DEFAULT '[]' COMMENT '第一名额外奖励展示资源',
  `rec_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '资源类型',
  `tips` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '活动介绍',
  `sort_id` tinyint(3) unsigned NOT NULL COMMENT '顺序id（客户端排序用）',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='冲榜活动配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_rush_rank`
--

LOCK TABLES `base_rush_rank` WRITE;
/*!40000 ALTER TABLE `base_rush_rank` DISABLE KEYS */;
INSERT INTO `base_rush_rank` VALUES (1,'等级冲榜',1,3,50,'[{lv,{150,0}}]','[{1,5040101},{2,5040101},{4,5040101}]',7,'测试文字1',1),(2,'降神冲榜',4,5,50,'[{combat,40000}]','[{1,5020101},{2,5020101},{4,5020101}]',7,'测试文字3',3),(6,'战力冲榜',7,8,50,'[{combat,2200000}]','[{1,5060101},{2,5060101},{4,5060101}]',7,'测试文字6',6),(7,'坐骑冲榜',3,4,50,'[{combat,30000}]','[{1,5010101},{2,5110102},{4,5010104}]',7,'测试文字2',2),(8,'魂珠冲榜',5,6,50,'[{combat,70000}]','[{1,5050101},{2,5050101},{4,5050101}]',7,'测试文字4',4),(9,'装备冲榜',6,7,50,'[{combat,1000000}]','[{1,5030101},{2,5030101},{4,5030101}]',7,'测试文字5',5);
/*!40000 ALTER TABLE `base_rush_rank` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_rush_rank_reward`
--

DROP TABLE IF EXISTS `base_rush_rank_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_rush_rank_reward` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动id',
  `reward_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励Id',
  `rank_min` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名上限',
  `rank_max` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名下限',
  `rank_limit` varchar(255) NOT NULL DEFAULT '[]' COMMENT '排名限制',
  `reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `about` varchar(1024) NOT NULL DEFAULT '' COMMENT '奖励描述',
  PRIMARY KEY (`id`,`reward_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='冲榜排行奖励配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_rush_rank_reward`
--

LOCK TABLES `base_rush_rank_reward` WRITE;
/*!40000 ALTER TABLE `base_rush_rank_reward` DISABLE KEYS */;
INSERT INTO `base_rush_rank_reward` VALUES (1,1,1,1,'[{lv,{150,0}}]','[{1,[{0,1104010753,1},{0,4908003,1},{0,16010004,1},{0,16020001,30}]},{2,[{0,1104020753,1},{0,4908003,1},{0,16010004,1},{0,16020001,30}]},{3,[{0,1104030753,1},{0,4908003,1},{0,16010004,1},{0,16020001,30}]},{4,[{0,1104040753,1},{0,4908003,1},{0,16010004,1},{0,16020001,30}]}]','等级榜1名'),(1,2,2,3,'[{lv,{150,0}}]','[{1,[{0,1104010743,1},{0,4908002,1},{0,16010004,1},{0,16020001,25}]},{2,[{0,1104020743,1},{0,4908002,1},{0,16010004,1},{0,16020001,25}]},{3,[{0,1104030743,1},{0,4908002,1},{0,16010004,1},{0,16020001,25}]},{4,[{0,1104040743,1},{0,4908002,1},{0,16010004,1},{0,16020001,25}]}]','等级榜2-3名'),(1,3,4,10,'[{lv,{150,0}}]','[{1,[{0,1104010742,1},{0,4908001,1},{0,16010001,1},{0,16020001,20}]},{2,[{0,1104020742,1},{0,4908001,1},{0,16010001,1},{0,16020001,20}]},{3,[{0,1104030742,1},{0,4908001,1},{0,16010001,1},{0,16020001,20}]},{4,[{0,1104040742,1},{0,4908001,1},{0,16010001,1},{0,16020001,20}]}]','等级榜4-10名'),(1,4,11,30,'[{lv,{150,0}}]','[{1,[{0,1104010732,1},{0,16010002,1},{0,16020001,15}]},{2,[{0,1104020732,1},{0,16010002,1},{0,16020001,15}]},{3,[{0,1104030732,1},{0,16010002,1},{0,16020001,15}]},{4,[{0,1104040732,1},{0,16010002,1},{0,16020001,15}]}]','等级榜11-30名'),(1,5,31,50,'[{lv,{150,0}}]','[{1,[{0,16010001,1},{0,16020001,10}]},{2,[{0,16010001,1},{0,16020001,10}]},{3,[{0,16010001,1},{0,16020001,10}]},{4,[{0,16010001,1},{0,16020001,10}]}]','等级榜31-50名'),(2,1,1,1,'[{combat,40000}]','[{1,[{0,1102010753,1},{0,20020004,1},{0,20020002,1},{0,32160005,20}]},{2,[{0,1102020753,1},{0,20020004,1},{0,20020002,1},{0,32160005,20}]},{3,[{0,1102030753,1},{0,20020004,1},{0,20020002,1},{0,32160005,20}]},{4,[{0,1102040753,1},{0,20020004,1},{0,20020002,1},{0,32160005,20}]}]','降神榜1名'),(2,2,2,3,'[{combat,40000}]','[{1,[{0,1102010743,1},{0,20020004,1},{0,20020001,1},{0,32160005,16}]},{2,[{0,1102020743,1},{0,20020004,1},{0,20020001,1},{0,32160005,16}]},{3,[{0,1102030743,1},{0,20020004,1},{0,20020001,1},{0,32160005,16}]},{4,[{0,1102040743,1},{0,20020004,1},{0,20020001,1},{0,32160005,16}]}]','降神榜2-3名'),(2,3,4,10,'[{combat,40000}]','[{1,[{0,1102010742,1},{0,20020003,1},{0,20020001,1},{0,32160005,12}]},{2,[{0,1102020742,1},{0,20020003,1},{0,20020001,1},{0,32160005,12}]},{3,[{0,1102030742,1},{0,20020003,1},{0,20020001,1},{0,32160005,12}]},{4,[{0,1102040742,1},{0,20020003,1},{0,20020001,1},{0,32160005,12}]}]','降神榜4-10名'),(2,4,11,30,'[{combat,40000}]','[{1,[{0,1102010732,1},{0,20020002,1},{0,32160005,8}]},{2,[{0,1102020732,1},{0,20020002,1},{0,32160005,8}]},{3,[{0,1102030732,1},{0,20020002,1},{0,32160005,8}]},{4,[{0,1102040732,1},{0,20020002,1},{0,32160005,8}]}]','降神榜11-30名'),(2,5,31,50,'[{combat,40000}]','[{1,[{0,20020001,1},{0,32160005,6}]},{2,[{0,20020001,1},{0,32160005,6}]},{3,[{0,20020001,1},{0,32160005,6}]},{4,[{0,20020001,1},{0,32160005,6}]}]','降神榜31-50名'),(6,1,1,1,'[{combat,2200000}]','[{1,[{0,1110010753,1},{0,1107010742,1},{0,4908018,1},{0,53030030,1}]},{2,[{0,1110020753,1},{0,1107020742,1},{0,4908018,1},{0,53030030,1}]},{3,[{0,1110030753,1},{0,1107030742,1},{0,4908018,1},{0,53030030,1}]},{4,[{0,1110040753,1},{0,1107040742,1},{0,4908018,1},{0,53030030,1}]}]','战力榜1名'),(6,2,2,3,'[{combat,2200000}]','[{1,[{0,1110010743,1},{0,1107010742,1},{0,4908017,1},{0,53030030,1}]},{2,[{0,1110020743,1},{0,1107020742,1},{0,4908017,1},{0,53030030,1}]},{3,[{0,1110030743,1},{0,1107030742,1},{0,4908017,1},{0,53030030,1}]},{4,[{0,1110040743,1},{0,1107040742,1},{0,4908017,1},{0,53030030,1}]}]','战力榜2-3名'),(6,3,4,10,'[{combat,2200000}]','[{1,[{0,1110010742,1},{0,1007010642,1},{0,4908016,1},{0,53030020,1}]},{2,[{0,1110020742,1},{0,1007020642,1},{0,4908016,1},{0,53030020,1}]},{3,[{0,1110030742,1},{0,1007030642,1},{0,4908016,1},{0,53030020,1}]},{4,[{0,1110040742,1},{0,1007040642,1},{0,4908016,1},{0,53030020,1}]}]','战力榜4-10名'),(6,4,11,30,'[{combat,2200000}]','[{1,[{0,1110010732,1},{0,53030010,1},{0,53030020,1},{0,53020010,20}]},{2,[{0,1110020732,1},{0,53030010,1},{0,53030020,1},{0,53020010,20}]},{3,[{0,1110030732,1},{0,53030010,1},{0,53030020,1},{0,53020010,20}]},{4,[{0,1110040732,1},{0,53030010,1},{0,53030020,1},{0,53020010,20}]}]','战力榜11-30名'),(6,5,31,50,'[{combat,2200000}]','[{1,[{0,53030020,1},{0,53020010,15}]},{2,[{0,53030020,1},{0,53020010,15}]},{3,[{0,53030020,1},{0,53020010,15}]},{4,[{0,53030020,1},{0,53020010,15}]}]','战力榜31-50名'),(7,1,1,1,'[{combat,30000}]','[{1,[{0,1101010753,1},{0,17020004,1},{0,11040003,10},{0,11020001,50}]},{2,[{0,1101020753,1},{0,17020004,1},{0,11040003,10},{0,11020001,50}]},{3,[{0,1101030753,1},{0,17020004,1},{0,11040003,10},{0,11020001,50}]},{4,[{0,1101040753,1},{0,17020004,1},{0,11040003,10},{0,11020001,50}]}]','坐骑榜1名'),(7,2,2,3,'[{combat,30000}]','[{1,[{0,1101010743,1},{0,17020004,1},{0,11040003,8},{0,11020001,40}]},{2,[{0,1101020743,1},{0,17020004,1},{0,11040003,8},{0,11020001,40}]},{3,[{0,1101030743,1},{0,17020004,1},{0,11040003,8},{0,11020001,40}]},{4,[{0,1101040743,1},{0,17020004,1},{0,11040003,8},{0,11020001,40}]}]','坐骑榜2-3名'),(7,3,4,10,'[{combat,30000}]','[{1,[{0,1101010742,1},{0,17020003,1},{0,11040003,6},{0,11020001,30}]},{2,[{0,1101020742,1},{0,17020003,1},{0,11040003,6},{0,11020001,30}]},{3,[{0,1101030742,1},{0,17020003,1},{0,11040003,6},{0,11020001,30}]},{4,[{0,1101040742,1},{0,17020003,1},{0,11040003,6},{0,11020001,30}]}]','坐骑榜4-10名'),(7,4,11,30,'[{combat,30000}]','[{1,[{0,1101010732,1},{0,17020002,1},{0,11020001,20}]},{2,[{0,1101020732,1},{0,17020002,1},{0,11020001,20}]},{3,[{0,1101030732,1},{0,17020002,1},{0,11020001,20}]},{4,[{0,1101040732,1},{0,17020002,1},{0,11020001,20}]}]','坐骑榜11-30名'),(7,5,31,50,'[{combat,30000}]','[{1,[{0,17020001,1},{0,11020001,15}]},{2,[{0,17020001,1},{0,11020001,15}]},{3,[{0,17020001,1},{0,11020001,15}]},{4,[{0,17020001,1},{0,11020001,15}]}]','坐骑榜31-50名'),(8,1,1,1,'[{combat,70000}]','[{1,[{0,1106010753,1},{0,32020114,10},{0,32020111,50}]},{2,[{0,1106020753,1},{0,32020114,10},{0,32020111,50}]},{3,[{0,1106030753,1},{0,32020114,10},{0,32020111,50}]},{4,[{0,1106040753,1},{0,32020114,10},{0,32020111,50}]}]','魂珠榜1名'),(8,2,2,3,'[{combat,70000}]','[{1,[{0,1106010743,1},{0,32020114,8},{0,32020111,40}]},{2,[{0,1106020743,1},{0,32020114,8},{0,32020111,40}]},{3,[{0,1106030743,1},{0,32020114,8},{0,32020111,40}]},{4,[{0,1106040743,1},{0,32020114,8},{0,32020111,40}]}]','魂珠榜2-3名'),(8,3,4,10,'[{combat,70000}]','[{1,[{0,1106010742,1},{0,32020114,5},{0,32020111,30}]},{2,[{0,1106020742,1},{0,32020114,5},{0,32020111,30}]},{3,[{0,1106030742,1},{0,32020114,5},{0,32020111,30}]},{4,[{0,1106040742,1},{0,32020114,5},{0,32020111,30}]}]','魂珠榜4-10名'),(8,4,11,30,'[{combat,70000}]','[{1,[{0,1106010732,1},{0,32020114,3},{0,32020111,20}]},{2,[{0,1106020732,1},{0,32020114,3},{0,32020111,20}]},{3,[{0,1106030732,1},{0,32020114,3},{0,32020111,20}]},{4,[{0,1106040732,1},{0,32020114,3},{0,32020111,20}]}]','魂珠榜11-30名'),(8,5,31,50,'[{combat,70000}]','[{1,[{0,32020114,2},{0,32020111,10}]},{2,[{0,32020114,2},{0,32020111,10}]},{3,[{0,32020114,2},{0,32020111,10}]},{4,[{0,32020114,2},{0,32020111,10}]}]','魂珠榜31-50名'),(9,1,1,1,'[{combat,1000000}]','[{1,[{0,1108010753,1},{0,1103000742 ,1},{0,4908015,1},{0,24020004,1}]},{2,[{0,1108020753,1},{0,1103000742 ,1},{0,4908015,1},{0,24020004,1}]},{3,[{0,1108030753,1},{0,1103000742 ,1},{0,4908015,1},{0,24020004,1}]},{4,[{0,1108040753,1},{0,1103000742 ,1},{0,4908015,1},{0,24020004,1}]}]','装备榜1名'),(9,2,2,3,'[{combat,1000000}]','[{1,[{0,1108010743,1},{0,1103000742 ,1},{0,4908014,1},{0,24020004,1}]},{2,[{0,1108020743,1},{0,1103000742 ,1},{0,4908014,1},{0,24020004,1}]},{3,[{0,1108030743,1},{0,1103000742 ,1},{0,4908014,1},{0,24020004,1}]},{4,[{0,1108040743,1},{0,1103000742 ,1},{0,4908014,1},{0,24020004,1}]}]','装备榜2-3名'),(9,3,4,10,'[{combat,1000000}]','[{1,[{0,1108010742,1},{0,1003000642 ,1},{0,4908013,1},{0,24020003,1}]},{2,[{0,1108020742,1},{0,1003000642 ,1},{0,4908013,1},{0,24020003,1}]},{3,[{0,1108030742,1},{0,1003000642 ,1},{0,4908013,1},{0,24020003,1}]},{4,[{0,1108040742,1},{0,1003000642 ,1},{0,4908013,1},{0,24020003,1}]}]','装备榜4-10名'),(9,4,11,30,'[{combat,1000000}]','[{1,[{0,1108010732,1},{0,24020002,1},{0,24020001,1},{0,24010001,20}]},{2,[{0,1108020732,1},{0,24020002,1},{0,24020001,1},{0,24010001,20}]},{3,[{0,1108030732,1},{0,24020002,1},{0,24020001,1},{0,24010001,20}]},{4,[{0,1108040732,1},{0,24020002,1},{0,24020001,1},{0,24010001,20}]}]','装备榜11-30名'),(9,5,31,50,'[{combat,1000000}]','[{1,[{0,24020002,1},{0,24010001,15}]},{2,[{0,24020002,1},{0,24010001,15}]},{3,[{0,24020002,1},{0,24010001,15}]},{4,[{0,24020002,1},{0,24010001,15}]}]','装备榜31-50名');
/*!40000 ALTER TABLE `base_rush_rank_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_scene`
--

DROP TABLE IF EXISTS `base_scene`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_scene` (
  `id` int(11) NOT NULL COMMENT '场景id',
  `name` char(20) NOT NULL COMMENT '场景名',
  `type` int(1) NOT NULL DEFAULT '0' COMMENT '场景大类 0 主城1 野外 2 副本',
  `subtype` int(1) NOT NULL COMMENT '场景子类 0 普通,1 安全场景',
  `cls_type` int(1) NOT NULL COMMENT '是否跨服场景 0 非跨服 | 1 跨服',
  `broadcast` int(1) DEFAULT NULL COMMENT '广播类型 0九宫格 | 1全场景',
  `mount` int(1) NOT NULL COMMENT '是否可上坐骑',
  `x` int(11) NOT NULL COMMENT '默认x坐标',
  `y` int(11) NOT NULL COMMENT '默认y坐标',
  `is_have_safe_area` int(1) NOT NULL COMMENT '是否有安全区 0 否 | 1是',
  `width` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '场景横向长度(最大12000像素)',
  `height` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '场景纵向长度',
  `elem` text NOT NULL COMMENT '传送阵列表(格式:[{NextSceneId, x, y},...])',
  `npc` text NOT NULL COMMENT '场景NPC,数据结构(格式:[{NpcId, x, y},...])',
  `mon` text NOT NULL COMMENT '场景怪物,数据结构([{怪物id, x, y, 是否主动(0|1),分组id},...])',
  `mask` longtext NOT NULL COMMENT '障碍点',
  `jump` text NOT NULL COMMENT '跳跃点(格式:[{编号, 目的X, 目的Y},...])',
  `dynamicarea` text NOT NULL,
  `requirement` text NOT NULL COMMENT '进入需求(格式:[{lv, Lv},...])',
  `minimapwidth` int(10) NOT NULL DEFAULT '550',
  `minimapheight` int(10) NOT NULL DEFAULT '380',
  `scene_bright` varchar(10) NOT NULL DEFAULT '0.9',
  `is_have_minimap` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '否有小地图##0:无;1:有小地图',
  `parnter_battle_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '伙伴战斗类型',
  `fuhuoscene` int(11) NOT NULL DEFAULT '0' COMMENT '复活场景',
  `reborn_xys` text NOT NULL COMMENT '复活坐标列表',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='场景';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_scene`
--

LOCK TABLES `base_scene` WRITE;
/*!40000 ALTER TABLE `base_scene` DISABLE KEYS */;
INSERT INTO `base_scene` VALUES (1000,'朔月海岸',1,0,0,0,1,6350,8450,1,25200,23400,'[{\"x\":13697,\"y\":12157,\"name\":\"抵抗军营\",\"px\":15236,\"py\":1879,\"id\":1002,\"index\":1}]','{[100017]={id=100017,x=3905,y=13393,anima=\"idle_159\"},[100013]={id=100013,x=13672,y=12643,anima=\"idle_93\"},[100012]={id=100012,x=14105,y=14235,anima=\"idle_188\"},[100014]={id=100014,x=9449,y=20550,anima=\"idle_177\"},[100011]={id=100011,x=6549,y=18152,anima=\"idle_187\"},[100010]={id=100010,x=5942,y=15242,anima=\"idle_191\"},[100008]={id=100008,x=5350,y=12552,anima=\"idle_168\"},[100009]={id=100009,x=6538,y=11454,anima=\"idle_211\"},[100007]={id=100007,x=8812,y=8819,anima=\"idle_187\"},[100006]={id=100006,x=7497,y=7832,anima=\"idle_128\"},[100005]={id=100005,x=11348,y=4049,anima=\"idle_173\"},[100004]={id=100004,x=16235,y=6252,anima=\"idle_167\"},[100003]={id=100003,x=17796,y=2841,anima=\"idle_163\"},[100002]={id=100002,x=19253,y=3040,anima=\"idle_150\"},[100001]={id=100001,x=23405,y=4317,anima=\"idle_221\"},[100015]={id=100015,x=9502,y=10500,anima=\"idle_214\"},[1004102]={id=1004102,x=12657,y=8510,anima=\"idle_245\"},[201044]={id=201044,x=9319,y=5711,anima=\"idle_245\"}}','[10000021, 8349, 20051, 1, 1] ,[10000021, 8129, 19945, 1, 1] ,[10000020, 22070, 4295, 1, 1] ,[10000006, 4648, 17661, 1, 1] ,[10000006, 5261, 16830, 1, 1] ,[10000006, 4853, 16843, 1, 1] ,[10000006, 5540, 17036, 1, 1] ,[10000006, 5617, 17401, 1, 1] ,[10000006, 5252, 17443, 1, 1] ,[10000006, 4849, 17434, 1, 1] ,[10000006, 5048, 17740, 1, 1] ,[10000006, 4649, 17147, 1, 1] ,[10000006, 5043, 17145, 1, 1] ,[10000005, 8449, 11744, 1, 1] ,[10000005, 8053, 11746, 1, 1] ,[10000005, 8653, 11438, 1, 1] ,[10000005, 8848, 11742, 1, 1] ,[10000005, 8247, 11436, 1, 1] ,[10000005, 7854, 11429, 1, 1] ,[10000005, 8044, 11158, 1, 1] ,[10000005, 8649, 12042, 1, 1] ,[10000005, 8445, 11154, 1, 1] ,[10000005, 8243, 12044, 1, 1] ,[10000004, 5444, 8655, 1, 1] ,[10000004, 5049, 8650, 1, 1] ,[10000004, 5655, 9538, 1, 1] ,[10000004, 5258, 9540, 1, 1] ,[10000004, 4849, 9533, 1, 1] ,[10000004, 5652, 8946, 1, 1] ,[10000004, 5254, 8943, 1, 1] ,[10000004, 4850, 8939, 1, 1] ,[10000004, 5456, 9238, 1, 1] ,[10000004, 5045, 9243, 1, 1] ,[10000002, 16752, 5841, 1, 1] ,[10000002, 17545, 5848, 1, 1] ,[10000002, 17548, 6448, 1, 1] ,[10000002, 17346, 6147, 1, 1] ,[10000002, 16940, 6152, 1, 1] ,[10000002, 17143, 6439, 1, 1] ,[10000002, 16956, 6744, 1, 1] ,[10000002, 16758, 6446, 1, 1] ,[10000002, 17349, 6748, 1, 1] ,[10000002, 17144, 5850, 1, 1] ,[10000001, 20260, 4457, 1, 1] ,[10000001, 20857, 4665, 1, 1] ,[10000001, 20452, 4755, 1, 1] ,[10000001, 20078, 4103, 1, 1] ,[10000001, 20648, 4446, 1, 1] ,[10000001, 20455, 4140, 1, 1] ,[10000001, 21054, 3849, 1, 1] ,[10000001, 20879, 4167, 1, 1] ,[10000001, 20317, 3800, 1, 1] ,[10000001, 20644, 3842, 1, 1] ','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,0,0,0,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{0,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(1001,'彩云船崖',1,0,0,0,1,1585,4188,1,10000,10000,'[]','{}','','0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0:\n','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(1002,'抵抗军营',1,0,0,0,1,14270,8046,1,23000,22500,'[{\"x\":15189,\"y\":957,\"name\":\"朔月海岸\",\"px\":14365,\"py\":14045,\"id\":1000,\"index\":1},{\"x\":14145,\"y\":18251,\"name\":\"迷雾沼泽\",\"px\":9747,\"py\":2853,\"id\":1003,\"index\":1}]','{[100201]={id=100201,x=15272,y=2678,anima=\"idle_181\"},[100202]={id=100202,x=15811,y=5796,anima=\"idle_197\"},[100203]={id=100203,x=14406,y=7696,anima=\"idle_168\"},[100204]={id=100204,x=15386,y=8402,anima=\"idle_224\"},[100205]={id=100205,x=16143,y=12583,anima=\"idle@casual2_220\"},[100206]={id=100206,x=12845,y=11953,anima=\"idle_160\"},[100207]={id=100207,x=11676,y=11497,anima=\"idle_167\"},[100208]={id=100208,x=12047,y=8632,anima=\"idle_256\"},[100209]={id=100209,x=9797,y=7554,anima=\"idle_108\"},[100210]={id=100210,x=8003,y=7180,anima=\"idle_229\"},[100211]={id=100211,x=4804,y=11102,anima=\"idle_191\"},[100212]={id=100212,x=6351,y=13734,anima=\"idle_245\"},[100213]={id=100213,x=9053,y=14549,anima=\"idle_205\"},[100215]={id=100215,x=13253,y=16547,anima=\"idle_190\"},[100216]={id=100216,x=13939,y=17647,anima=\"idle_189\"},[100217]={id=100217,x=8751,y=10499,anima=\"idle_245\"}}','[100020001, 11753, 13084, 1, 1] ,[10020001, 14757, 4746, 1, 1] ,[10020002, 17254, 13352, 1, 1] ,[10020001, 14950, 4447, 1, 1] ,[10020002, 17046, 13041, 1, 1] ,[10020001, 14550, 5044, 1, 1] ,[10020001, 15348, 5038, 1, 1] ,[10020002, 17054, 13638, 1, 1] ,[10020001, 14945, 5057, 1, 1] ,[10020001, 15151, 4739, 1, 1] ,[10020001, 15553, 4751, 1, 1] ,[10020001, 14546, 4453, 1, 1] ,[10020002, 16658, 13043, 1, 1] ,[10020002, 16453, 13341, 1, 1] ,[10020002, 16652, 13640, 1, 1] ,[10020002, 16242, 13054, 1, 1] ,[10020002, 16843, 13342, 1, 1] ,[10020002, 16259, 13645, 1, 1] ,[10020002, 16053, 13348, 1, 1] ,[10020005, 3352, 11047, 1, 1] ,[10020005, 3748, 11040, 1, 1] ,[10020005, 4155, 11042, 1, 1] ,[10020005, 3145, 11334, 1, 1] ,[10020005, 3361, 10443, 1, 1] ,[10020005, 3159, 10746, 1, 1] ,[10020005, 3748, 10439, 1, 1] ,[10020005, 3943, 11338, 1, 1] ,[10020005, 3540, 10739, 1, 1] ,[10020005, 3551, 11341, 1, 1] ,[10020005, 3952, 10739, 1, 1] ,[10020004, 6661, 5448, 1, 1] ,[10020004, 7046, 5446, 1, 1] ,[10020004, 7043, 4836, 1, 1] ,[10020004, 6460, 5741, 1, 1] ,[10020004, 7461, 5442, 1, 1] ,[10020004, 7247, 5739, 1, 1] ,[10020004, 6848, 5733, 1, 1] ,[10020004, 6639, 4835, 1, 1] ,[10020004, 7261, 5128, 1, 1] ,[10020004, 6844, 5136, 1, 1] ,[10020004, 6459, 5122, 1, 1] ,[10020006, 4853, 14443, 1, 1] ,[10020006, 4455, 13852, 1, 1] ,[10020006, 3853, 14730, 1, 1] ,[10020006, 4445, 14446, 1, 1] ,[10020006, 4647, 14133, 1, 1] ,[10020006, 4656, 14745, 1, 1] ,[10020006, 4249, 14735, 1, 1] ,[10020006, 3851, 14146, 1, 1] ,[10020006, 4050, 14441, 1, 1] ,[10020006, 4050, 13853, 1, 1] ,[10020006, 4237, 14141, 1, 1] ,[10020007, 11755, 16541, 1, 1] ,[10020007, 11353, 16542, 1, 1] ,[10020007, 11753, 15930, 1, 1] ,[10020007, 11153, 16237, 1, 1] ,[10020007, 11155, 15653, 1, 1] ,[10020007, 11552, 15644, 1, 1] ,[10020007, 11552, 16238, 1, 1] ,[10020021, 10039, 15432, 1, 1] ,[10020007, 10945, 15931, 1, 1] ,[10020021, 9937, 15256, 1, 1] ,[10020007, 10956, 16542, 1, 1] ,[10020020, 10406, 8439, 1, 1] ,[10020020, 10177, 8383, 1, 1] ,[10020022, 5242, 7345, 1, 1] ,[10020022, 5458, 7341, 1, 1] ,[10020023, 14909, 9210, 1, 1] ,[10020001, 15349, 4445, 1, 1] ,[10020001, 15747, 5043, 1, 1] ,[10020007, 11361, 15940, 1, 1] ','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,0,1,1,1,1,1,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n','[]','[{\"id\":10021,\"type\":0,\"list\":\"144:62,145:61,145:62,145:63,146:61,146:62,146:63,146:64,147:61,147:62,147:63,147:64,148:61,148:62,148:63,148:64,148:65,149:62,149:63,149:64,149:65,150:62,150:63,150:64,150:65,150:66,151:63,151:64,151:65,151:66,152:64,152:65,152:66,153:64,153:65,153:66,153:67,154:65,154:66,154:67,155:65\"}]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{0,25}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(1003,'迷雾沼泽',1,0,0,0,1,7545,5650,1,14600,17600,'[{\"x\":10602,\"y\":2836,\"name\":\"抵抗军营\",\"px\":14444,\"py\":17758,\"id\":1002,\"index\":1},{\"x\":1784,\"y\":10243,\"name\":\"洛亚王城\",\"px\":20657,\"py\":5249,\"id\":1004,\"index\":1}]','{[100301]={id=100301,x=8849,y=2232,anima=\"idle_60\"},[100302]={id=100302,x=6803,y=3789,anima=\"idle_162\"},[100303]={id=100303,x=9308,y=6098,anima=\"idle_257\"},[100304]={id=100304,x=10941,y=6757,anima=\"idle_229\"},[100305]={id=100305,x=10633,y=9207,anima=\"idle_210\"},[100306]={id=100306,x=5818,y=9633,anima=\"idle_194\"},[100307]={id=100307,x=2506,y=10188,anima=\"idle_124\"},[100308]={id=100308,x=2987,y=3208,anima=\"idle_134\"},[100309]={id=100309,x=4793,y=7113,anima=\"idle_200\"},[100310]={id=100310,x=5172,y=10919,anima=\"idle_181\"},[100311]={id=100311,x=9068,y=10688,anima=\"idle_153\"},[51819002]={id=51819002,x=4205,y=10260,anima=\"idle_186\"},[51819003]={id=51819003,x=6136,y=15846,anima=\"idle_245\"},[100312]={id=100312,x=1744,y=1618,anima=\"idle_95\"},[100320]={id=100320,x=7303,y=5528,anima=\"idle_245\"}}','[10030002, 8254, 4949, 1, 1] ,[10030002, 8442, 4646, 1, 1] ,[10030002, 7859, 4339, 1, 1] ,[10030002, 7453, 4949, 1, 1] ,[10030002, 8250, 4343, 1, 1] ,[10030002, 7643, 4646, 1, 1] ,[10030002, 7848, 4942, 1, 1] ,[10030001, 5821, 2829, 1, 1] ,[10030002, 7638, 5233, 1, 1] ,[10030002, 8047, 4645, 1, 1] ,[10030002, 8049, 5230, 1, 1] ,[10030003, 10647, 4958, 1, 1] ,[10030003, 10453, 5248, 1, 1] ,[10030003, 10048, 5838, 1, 1] ,[10030003, 11251, 5250, 1, 1] ,[10030003, 10658, 5534, 1, 1] ,[10030003, 10861, 5257, 1, 1] ,[10030003, 10446, 5850, 1, 1] ,[10030003, 10250, 5545, 1, 1] ,[10030003, 10853, 5836, 1, 1] ,[10030003, 11048, 5548, 1, 1] ,[10030005, 10347, 10768, 1, 1] ,[10030005, 10348, 11140, 1, 1] ,[10030004, 12144, 10243, 1, 1] ,[10030004, 12939, 10242, 1, 1] ,[10030004, 12540, 10245, 1, 1] ,[10030004, 11934, 9936, 1, 1] ,[10030004, 12635, 10542, 1, 1] ,[10030004, 12753, 9939, 1, 1] ,[10030004, 12354, 9946, 1, 1] ,[10030004, 12253, 10536, 1, 1] ,[10030004, 12543, 9658, 1, 1] ,[10030004, 12151, 9760, 1, 1] ,[10030005, 10049, 10961, 1, 1] ,[10030005, 9757, 10761, 1, 1] ,[10030005, 10743, 11083, 1, 1] ,[10030005, 10038, 10532, 1, 1] ,[10030005, 10404, 10453, 1, 1] ,[10030005, 10701, 10750, 1, 1] ,[10030005, 10975, 11332, 1, 1] ,[10030005, 10584, 11368, 1, 1] ,[10030006, 5742, 7745, 1, 1] ,[10030006, 6745, 8041, 1, 1] ,[10030006, 5950, 8038, 1, 1] ,[10030006, 6349, 8037, 1, 1] ,[10030006, 6559, 8327, 1, 1] ,[10030006, 6154, 7742, 1, 1] ,[10030006, 6153, 8339, 1, 1] ,[10030006, 5947, 7428, 1, 1] ,[10030006, 6349, 7435, 1, 1] ,[10030006, 6746, 7441, 1, 1] ,[10030006, 6553, 7737, 1, 1] ,[10030007, 3841, 6433, 1, 1] ,[10030007, 3631, 6145, 1, 1] ,[10030007, 3846, 5847, 1, 1] ,[10030007, 4059, 6141, 1, 1] ,[10030007, 4256, 5843, 1, 1] ,[10030007, 4045, 5550, 1, 1] ,[10030007, 4443, 5534, 1, 1] ,[10030007, 4648, 5846, 1, 1] ,[10030007, 4445, 6148, 1, 1] ,[10030007, 4247, 6440, 1, 1] ,[10030020, 12361, 7230, 1, 1] ,[10030020, 12251, 7433, 1, 1] ,[10030021, 7842, 9092, 1, 1] ,[10030021, 7594, 9085, 1, 1] ','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{0,50}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(1004,'洛亚王城',1,0,0,0,1,12140,10650,1,26000,22688,'[{\"x\":4260,\"y\":9176,\"name\":\"蘑菇林\",\"px\":11015,\"py\":3550,\"id\":1005,\"index\":1},{\"x\":21203,\"y\":4902,\"name\":\"迷雾沼泽\",\"px\":2989,\"py\":10218,\"id\":1003,\"index\":1}]','{[100418]={id=100418,x=18612,y=6130,anima=\"idle_164\"},[100417]={id=100417,x=8809,y=6565,anima=\"idle_153\"},[100416]={id=100416,x=14801,y=8404,anima=\"idle_150\"},[100415]={id=100415,x=15993,y=7894,anima=\"idle_146\"},[100414]={id=100414,x=6815,y=4593,anima=\"idle_221\"},[100413]={id=100413,x=5501,y=4693,anima=\"idle_142\"},[100412]={id=100412,x=7902,y=3478,anima=\"idle_156\"},[100411]={id=100411,x=8882,y=4605,anima=\"idle_175\"},[100410]={id=100410,x=4901,y=3601,anima=\"idle_124\"},[100409]={id=100409,x=8090,y=8376,anima=\"idle_129\"},[100408]={id=100408,x=19640,y=5150,anima=\"idle_172\"},[100407]={id=100407,x=9799,y=12296,anima=\"idle_129\"},[100406]={id=100406,x=5402,y=15606,anima=\"idle_138\"},[100405]={id=100405,x=4668,y=15902,anima=\"idle_134\"},[100404]={id=100404,x=4738,y=8859,anima=\"idle_130\"},[100403]={id=100403,x=7606,y=7861,anima=\"idle_134\"},[100402]={id=100402,x=14892,y=16640,anima=\"idle_211\"},[100401]={id=100401,x=13488,y=9707,anima=\"idle_133\"},[51540004]={id=51540004,x=15306,y=16596,anima=\"idle_230\"},[51540002]={id=51540002,x=12546,y=12847,anima=\"idle_223\"},[51819001]={id=51819001,x=23015,y=16134,anima=\"idle_245\"},[100420]={id=100420,x=8335,y=8942,anima=\"idle_135\"},[100430]={id=100430,x=9338,y=7777,anima=\"idle_240\"},[1004100]={id=1004100,x=1497,y=4341,anima=\"idle_245\"},[1004101]={id=1004101,x=10350,y=3851,anima=\"idle_179\"}}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,0,0,0,0,0,1,1,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,1,1,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{0,50}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(1005,'蘑菇林',1,0,0,0,1,8350,5050,1,23050,19519,'[{\"x\":20786,\"y\":7820,\"name\":\"森林神殿\",\"px\":5660,\"py\":7345,\"id\":1006,\"index\":1},{\"x\":10549,\"y\":3054,\"name\":\"洛亚王城\",\"px\":5095,\"py\":8605,\"id\":1004,\"index\":1}]','{[100512]={id=100512,x=17341,y=8921,anima=\"idle_245\"},[100511]={id=100511,x=13094,y=9429,anima=\"idle_245\"},[100510]={id=100510,x=11408,y=10528,anima=\"idle_245\"},[100509]={id=100509,x=10753,y=12147,anima=\"idle_245\"},[100508]={id=100508,x=9055,y=14141,anima=\"idle_245\"},[100507]={id=100507,x=6050,y=14154,anima=\"idle_245\"},[100506]={id=100506,x=4955,y=11740,anima=\"idle_245\"},[100505]={id=100505,x=5255,y=8645,anima=\"idle_245\"},[100504]={id=100504,x=5648,y=6835,anima=\"idle_245\"},[100503]={id=100503,x=7849,y=5446,anima=\"idle_245\"},[100502]={id=100502,x=9161,y=4152,anima=\"idle_245\"},[100501]={id=100501,x=11243,y=4239,anima=\"idle_245\"},[100513]={id=100513,x=18744,y=7637,anima=\"idle_245\"},[100514]={id=100514,x=20356,y=6341,anima=\"idle_245\"}}','[10050002, 4551, 8841, 1, 1] ,[10050002, 4053, 8837, 1, 1] ,[10050002, 3559, 8837, 1, 1] ,[10050001, 7497, 4697, 1, 1] ,[10050001, 7761, 4352, 1, 1] ,[10050001, 7252, 4334, 1, 1] ,[10050001, 6744, 4345, 1, 1] ,[10050001, 6490, 4006, 1, 1] ,[10050001, 7502, 3996, 1, 1] ,[10050001, 7000, 4000, 1, 1] ,[10050001, 7244, 3643, 1, 1] ,[10050001, 6746, 3650, 1, 1] ,[10050021, 11745, 10747, 1, 1] ,[10050021, 12053, 10747, 1, 1] ,[10050021, 11845, 11040, 1, 1] ,[10050020, 5942, 15058, 1, 1] ,[10050020, 6055, 15245, 1, 1] ,[10050020, 5741, 15245, 1, 1] ,[10050006, 19050, 6436, 1, 1] ,[10050006, 18545, 6446, 1, 1] ,[10050006, 18052, 6447, 1, 1] ,[10050006, 18803, 6106, 1, 1] ,[10050006, 18302, 6097, 1, 1] ,[10050006, 18796, 5406, 1, 1] ,[10050006, 18302, 5406, 1, 1] ,[10050006, 18048, 5745, 1, 1] ,[10050006, 19057, 5745, 1, 1] ,[10050006, 18553, 5746, 1, 1] ,[10050005, 15542, 9650, 1, 1] ,[10050005, 15057, 9649, 1, 1] ,[10050005, 14545, 9649, 1, 1] ,[10050005, 15297, 9999, 1, 1] ,[10050005, 14799, 10003, 1, 1] ,[10050005, 14793, 10698, 1, 1] ,[10050005, 15305, 10691, 1, 1] ,[10050005, 14539, 10327, 1, 1] ,[10050005, 15562, 10341, 1, 1] ,[10050005, 15055, 10342, 1, 1] ,[10050004, 11049, 9039, 1, 1] ,[10050004, 10544, 9047, 1, 1] ,[10050004, 10043, 9049, 1, 1] ,[10050004, 10801, 9406, 1, 1] ,[10050004, 10293, 9399, 1, 1] ,[10050004, 10801, 10105, 1, 1] ,[10050004, 10289, 10095, 1, 1] ,[10050004, 10049, 9734, 1, 1] ,[10050004, 11048, 9745, 1, 1] ,[10050003, 8250, 15549, 1, 1] ,[10050003, 7748, 15545, 1, 1] ,[10050003, 7251, 15549, 1, 1] ,[10050004, 10543, 9748, 1, 1] ,[10050003, 7998, 14498, 1, 1] ,[10050003, 7503, 14501, 1, 1] ,[10050003, 8001, 15204, 1, 1] ,[10050003, 7502, 15199, 1, 1] ,[10050003, 8255, 14847, 1, 1] ,[10050003, 7241, 14836, 1, 1] ,[10050003, 7744, 14842, 1, 1] ,[10050002, 4054, 9542, 1, 1] ,[10050002, 3543, 9546, 1, 1] ,[10050002, 3292, 9200, 1, 1] ,[10050002, 4300, 9202, 1, 1] ,[10050002, 3795, 9202, 1, 1] ,[10050002, 4296, 8498, 1, 1] ,[10050002, 3795, 8505, 1, 1] ','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,0,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{0,80}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(1006,'森林神殿',1,0,0,0,1,10480,11730,1,22850,19959,'[{\"x\":13760,\"y\":1139,\"name\":\"寒鸦峡谷\",\"px\":12458,\"py\":3072,\"id\":1007,\"index\":1},{\"x\":5168,\"y\":6884,\"name\":\"蘑菇林\",\"px\":20245,\"py\":7350,\"id\":1005,\"index\":1}]','{[100613]={id=100613,x=12854,y=2346,anima=\"idle_245\"},[100612]={id=100612,x=15048,y=6842,anima=\"idle_245\"},[100611]={id=100611,x=15818,y=8767,anima=\"idle_245\"},[100610]={id=100610,x=11250,y=12447,anima=\"idle_245\"},[100609]={id=100609,x=12351,y=5549,anima=\"idle_245\"},[100608]={id=100608,x=11048,y=7746,anima=\"idle_245\"},[100607]={id=100607,x=9453,y=9439,anima=\"idle_245\"},[100606]={id=100606,x=3658,y=16050,anima=\"idle_245\"},[100605]={id=100605,x=3652,y=14857,anima=\"idle_245\"},[100604]={id=100604,x=5354,y=14552,anima=\"idle_245\"},[100603]={id=100603,x=6346,y=12751,anima=\"idle_245\"},[100602]={id=100602,x=8152,y=10843,anima=\"idle_245\"},[100601]={id=100601,x=8142,y=9550,anima=\"idle_245\"},[100620]={id=100620,x=2150,y=17545,anima=\"idle_245\"},[100614]={id=100614,x=9458,y=10800,anima=\"idle_245\"}}','[10060021, 13642, 5452, 1, 1] ,[10060020, 6149, 13531, 1, 1] ,[10060020, 6459, 13539, 1, 1] ,[10060100, 9053, 14550, 1, 1] ,[10060008, 17006, 10698, 1, 1] ,[10060008, 16503, 10695, 1, 1] ,[10060008, 16241, 10341, 1, 1] ,[10060008, 17249, 10336, 1, 1] ,[10060008, 16746, 10348, 1, 1] ,[10060008, 16500, 10002, 1, 1] ,[10060008, 17501, 9999, 1, 1] ,[10060008, 17002, 9998, 1, 1] ,[10060008, 17256, 9644, 1, 1] ,[10060008, 16748, 9643, 1, 1] ,[10060007, 13907, 8299, 1, 1] ,[10060007, 13398, 8299, 1, 1] ,[10060007, 14155, 7938, 1, 1] ,[10060007, 13659, 7940, 1, 1] ,[10060007, 13149, 7948, 1, 1] ,[10060007, 13903, 7597, 1, 1] ,[10060007, 13402, 7597, 1, 1] ,[10060007, 14154, 7231, 1, 1] ,[10060007, 13651, 7234, 1, 1] ,[10060007, 13148, 7244, 1, 1] ,[10060006, 12400, 2593, 1, 1] ,[10060006, 11895, 2596, 1, 1] ,[10060006, 12660, 2953, 1, 1] ,[10060006, 12153, 2943, 1, 1] ,[10060006, 11647, 2941, 1, 1] ,[10060006, 12402, 3296, 1, 1] ,[10060006, 11906, 3306, 1, 1] ,[10060006, 12651, 3636, 1, 1] ,[10060006, 12150, 3643, 1, 1] ,[10060006, 11645, 3643, 1, 1] ,[10060005, 11106, 6899, 1, 1] ,[10060005, 10600, 6894, 1, 1] ,[10060005, 11355, 6540, 1, 1] ,[10060005, 10855, 6540, 1, 1] ,[10060005, 10352, 6543, 1, 1] ,[10060005, 11102, 6201, 1, 1] ,[10060005, 10599, 6196, 1, 1] ,[10060005, 11352, 5846, 1, 1] ,[10060005, 10854, 5842, 1, 1] ,[10060005, 10349, 5842, 1, 1] ,[10060004, 11194, 9903, 1, 1] ,[10060004, 12199, 10609, 1, 1] ,[10060004, 11709, 10595, 1, 1] ,[10060004, 11444, 10242, 1, 1] ,[10060004, 12450, 10253, 1, 1] ,[10060004, 11945, 10263, 1, 1] ,[10060004, 12204, 9895, 1, 1] ,[10060004, 11698, 9898, 1, 1] ,[10060004, 11955, 9536, 1, 1] ,[10060004, 11447, 9536, 1, 1] ,[10060003, 5701, 16201, 1, 1] ,[10060003, 5203, 16205, 1, 1] ,[10060003, 5957, 16548, 1, 1] ,[10060003, 5452, 16544, 1, 1] ,[10060003, 4944, 16541, 1, 1] ,[10060003, 5704, 16902, 1, 1] ,[10060003, 5196, 16902, 1, 1] ,[10060003, 5958, 17234, 1, 1] ,[10060003, 5457, 17237, 1, 1] ,[10060003, 4942, 17245, 1, 1] ,[10060002, 2504, 14903, 1, 1] ,[10060002, 1900, 14903, 1, 1] ,[10060002, 2650, 14535, 1, 1] ,[10060002, 2145, 14553, 1, 1] ,[10060002, 1640, 14545, 1, 1] ,[10060002, 2399, 14196, 1, 1] ,[10060002, 1898, 14190, 1, 1] ,[10060002, 2657, 13856, 1, 1] ,[10060002, 2152, 13851, 1, 1] ,[10060002, 1647, 13850, 1, 1] ,[10060001, 5103, 12901, 1, 1] ,[10060001, 4600, 12897, 1, 1] ,[10060001, 5356, 12543, 1, 1] ,[10060001, 4844, 12540, 1, 1] ,[10060001, 4361, 12533, 1, 1] ,[10060001, 5097, 12197, 1, 1] ,[10060001, 4603, 12193, 1, 1] ,[10060001, 5362, 11839, 1, 1] ,[10060001, 4857, 11839, 1, 1] ,[10060001, 4356, 11850, 1, 1] ,[10060020, 6356, 13738, 1, 1] ,[10060021, 13853, 5245, 1, 1] ,[10060021, 14050, 5457, 1, 1] ','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,0,0,0,0,0,0,0,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{0,110}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(1007,'寒鸦峡谷',1,0,0,0,1,13035,2817,1,21400,13900,'[{\"x\":14017,\"y\":3354,\"name\":\"森林神殿\",\"px\":13460,\"py\":1450,\"id\":1006,\"index\":1},{\"x\":3427,\"y\":11179,\"name\":\"风蚀台地\",\"px\":2442,\"py\":2155,\"id\":1008,\"index\":1}]','{[100712]={id=100712,x=4815,y=10602,anima=\"idle_141\"},[100711]={id=100711,x=6738,y=10799,anima=\"idle_171\"},[100710]={id=100710,x=9862,y=9842,anima=\"idle_170\"},[100709]={id=100709,x=11637,y=10793,anima=\"idle_192\"},[100708]={id=100708,x=15094,y=6781,anima=\"idle_270\"},[100707]={id=100707,x=11766,y=5228,anima=\"idle_190\"},[100706]={id=100706,x=8054,y=7561,anima=\"idle_161\"},[100705]={id=100705,x=4836,y=5281,anima=\"idle_193\"},[100704]={id=100704,x=2319,y=5645,anima=\"idle_169\"},[100703]={id=100703,x=4230,y=3663,anima=\"idle_147\"},[100702]={id=100702,x=10361,y=2786,anima=\"idle_184\"},[100701]={id=100701,x=11812,y=3086,anima=\"idle_193\"},[100713]={id=100713,x=11838,y=8137,anima=\"idle_155\"},[100714]={id=100714,x=13867,y=10590,anima=\"idle_213\"}}','[10070001, 12553, 1966, 1, 1] ,[10070001, 12951, 1971, 1, 1] ,[10070002, 11154, 1162, 1, 1] ,[10070002, 10965, 1449, 1, 1] ,[10070002, 10745, 1171, 1, 1] ,[10070002, 11144, 1759, 1, 1] ,[10070002, 10352, 1742, 1, 1] ,[10070002, 10551, 1475, 1, 1] ,[10070003, 2256, 4055, 1, 1] ,[10070003, 2851, 4955, 1, 1] ,[10070003, 2443, 4362, 1, 1] ,[10070003, 2658, 4062, 1, 1] ,[10070003, 2459, 4948, 1, 1] ,[10070003, 2058, 4360, 1, 1] ,[10070003, 2046, 4948, 1, 1] ,[10070003, 2848, 4368, 1, 1] ,[10070003, 2252, 4672, 1, 1] ,[10070004, 2563, 8459, 1, 1] ,[10070004, 2152, 9040, 1, 1] ,[10070004, 2154, 8443, 1, 1] ,[10070004, 2746, 8753, 1, 1] ,[10070004, 2552, 9080, 1, 1] ,[10070004, 2956, 9055, 1, 1] ,[10070004, 2354, 8760, 1, 1] ,[10070005, 9549, 7856, 1, 1] ,[10070005, 10169, 8166, 1, 1] ,[10070005, 9346, 7559, 1, 1] ,[10070005, 9748, 8155, 1, 1] ,[10070005, 9748, 7565, 1, 1] ,[10070005, 9325, 8167, 1, 1] ,[10070005, 9957, 7876, 1, 1] ,[10070006, 12858, 7545, 1, 1] ,[10070006, 12448, 6974, 1, 1] ,[10070006, 12017, 6966, 1, 1] ,[10070006, 12662, 7254, 1, 1] ,[10070006, 12849, 6961, 1, 1] ,[10070006, 12040, 7551, 1, 1] ,[10070006, 12269, 7248, 1, 1] ,[10070007, 5150, 12066, 1, 1] ,[10070007, 5152, 11451, 1, 1] ,[10070007, 5754, 11755, 1, 1] ,[10070007, 6154, 11759, 1, 1] ,[10070007, 5754, 11156, 1, 1] ,[10070007, 5363, 11756, 1, 1] ,[10070007, 5955, 12077, 1, 1] ,[10070007, 5958, 11472, 1, 1] ,[10070007, 5567, 12075, 1, 1] ,[10070007, 6161, 11181, 1, 1] ,[10070007, 5362, 11169, 1, 1] ,[10070007, 5561, 11476, 1, 1] ,[10070020, 4021, 5790, 1, 1] ,[10070020, 3880, 6011, 1, 1] ,[10070021, 9318, 10758, 1, 1] ,[10070021, 9614, 10772, 1, 1] ,[10070001, 12348, 2246, 1, 1] ,[10070001, 12752, 2243, 1, 1] ,[10070001, 12957, 2454, 1, 1] ,[10070001, 12351, 2778, 1, 1] ,[10070001, 12752, 2771, 1, 1] ,[10070001, 12549, 2469, 1, 1] ,[10070001, 13148, 2779, 1, 1] ,[10070001, 13147, 2239, 1, 1] ,[10070002, 10749, 1744, 1, 1] ,[10070002, 10140, 2066, 1, 1] ,[10070002, 10554, 2060, 1, 1] ,[10070002, 10954, 2083, 1, 1] ,[10070003, 2658, 4659, 1, 1] ,[10070004, 2360, 8145, 1, 1] ,[10070004, 2763, 8147, 1, 1] ,[10070004, 2959, 8450, 1, 1] ,[10070005, 9553, 7270, 1, 1] ,[10070005, 9950, 7258, 1, 1] ,[10070005, 10151, 7557, 1, 1] ,[10070006, 12268, 7883, 1, 1] ,[10070006, 12654, 7894, 1, 1] ,[10070006, 12452, 7556, 1, 1]','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{0,200}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(1008,'风蚀台地',1,0,0,0,1,7432,8165,1,23500,20600,'[{\"x\":2415,\"y\":1636,\"name\":\"寒鸦峡谷\",\"px\":4634,\"py\":11358,\"id\":1007,\"index\":1},{\"x\":10498,\"y\":17504,\"name\":\"暗裔秘所\",\"px\":5750,\"py\":6358,\"id\":1009,\"index\":1}]','{[100801]={id=100801,x=2454,y=2693,anima=\"idle_184\"},[100802]={id=100802,x=6361,y=5956,anima=\"idle_206\"},[100803]={id=100803,x=7857,y=8146,anima=\"idle_219\"},[100804]={id=100804,x=6449,y=10958,anima=\"idle_202\"},[100805]={id=100805,x=7842,y=11238,anima=\"idle_235\"},[100806]={id=100806,x=3751,y=12838,anima=\"idle_126\"},[100807]={id=100807,x=9251,y=9430,anima=\"idle_201\"},[100808]={id=100808,x=12687,y=6604,anima=\"idle@casual2_197\"},[100809]={id=100809,x=16637,y=7855,anima=\"idle_198\"},[100810]={id=100810,x=17143,y=12143,anima=\"idle_191\"},[100811]={id=100811,x=9868,y=15631,anima=\"idle_203\"},[100812]={id=100812,x=14549,y=5034,anima=\"idle_176\"},[100813]={id=100813,x=12253,y=11741,anima=\"idle_152\"},[100820]={id=100820,x=11363,y=12944,anima=\"idle_159\"}}','[10080001, 3049, 3471, 1, 1] ,[10080001, 3446, 3489, 1, 1] ,[10080001, 3259, 3190, 1, 1] ,[10080001, 3845, 3494, 1, 1] ,[10080001, 3859, 2937, 1, 1] ,[10080001, 3453, 2919, 1, 1] ,[10080001, 3652, 3193, 1, 1] ,[10080001, 3246, 2605, 1, 1] ,[10080001, 3681, 2609, 1, 1] ,[10080001, 3046, 2911, 1, 1] ,[10080002, 6856, 6857, 1, 1] ,[10080002, 7255, 6877, 1, 1] ,[10080002, 7645, 6898, 1, 1] ,[10080002, 7053, 6555, 1, 1] ,[10080002, 7451, 6549, 1, 1] ,[10080002, 7050, 5961, 1, 1] ,[10080002, 7249, 6261, 1, 1] ,[10080002, 7641, 6267, 1, 1] ,[10080002, 7453, 5974, 1, 1] ,[10080002, 6853, 6281, 1, 1] ,[10080003, 5842, 10242, 1, 1] ,[10080003, 4856, 10531, 1, 1] ,[10080003, 5250, 10532, 1, 1] ,[10080003, 4850, 9957, 1, 1] ,[10080003, 5447, 10241, 1, 1] ,[10080003, 4663, 10240, 1, 1] ,[10080003, 5048, 10249, 1, 1] ,[10080003, 5264, 9955, 1, 1] ,[10080003, 5652, 10538, 1, 1] ,[10080003, 5651, 9957, 1, 1] ,[10080004, 5146, 13841, 1, 1] ,[10080004, 5558, 13849, 1, 1] ,[10080004, 5961, 13845, 1, 1] ,[10080004, 4959, 13565, 1, 1] ,[10080004, 5347, 13565, 1, 1] ,[10080004, 5748, 13568, 1, 1] ,[10080004, 5148, 13273, 1, 1] ,[10080004, 5557, 13278, 1, 1] ,[10080004, 4956, 14167, 1, 1] ,[10080004, 5348, 14166, 1, 1] ,[10080004, 5758, 14155, 1, 1] ,[10080005, 10127, 8863, 1, 1] ,[10080005, 10546, 8854, 1, 1] ,[10080005, 10954, 8868, 1, 1] ,[10080005, 10341, 8581, 1, 1] ,[10080005, 10758, 8563, 1, 1] ,[10080005, 10151, 8254, 1, 1] ,[10080005, 10558, 8258, 1, 1] ,[10080005, 10959, 8256, 1, 1] ,[10080005, 10355, 7981, 1, 1] ,[10080005, 10748, 7971, 1, 1] ,[10080006, 19554, 10062, 1, 1] ,[10080006, 19140, 10049, 1, 1] ,[10080006, 18752, 10077, 1, 1] ,[10080006, 18949, 9762, 1, 1] ,[10080006, 19352, 9767, 1, 1] ,[10080006, 18759, 9468, 1, 1] ,[10080006, 19156, 9456, 1, 1] ,[10080006, 19565, 9447, 1, 1] ,[10080006, 19351, 9137, 1, 1] ,[10080006, 18954, 9146, 1, 1] ,[10080007, 13742, 9959, 1, 1] ,[10080007, 13953, 9658, 1, 1] ,[10080007, 13558, 9674, 1, 1] ,[10080007, 14159, 9947, 1, 1] ,[10080007, 14356, 9653, 1, 1] ,[10080007, 13756, 9363, 1, 1] ,[10080007, 14155, 9359, 1, 1] ,[10080007, 13545, 10239, 1, 1] ,[10080007, 13952, 10246, 1, 1] ,[10080007, 14347, 10234, 1, 1] ,[10080008, 8539, 14958, 1, 1] ,[10080008, 8952, 14960, 1, 1] ,[10080008, 8367, 15253, 1, 1] ,[10080008, 8757, 15250, 1, 1] ,[10080008, 9158, 15248, 1, 1] ,[10080008, 8553, 15563, 1, 1] ,[10080008, 8958, 15549, 1, 1] ,[10080008, 8335, 15854, 1, 1] ,[10080008, 8745, 15849, 1, 1] ,[10080008, 9162, 15859, 1, 1] ,[10080020, 4284, 12612, 1, 1] ,[10080020, 4527, 12617, 1, 1] ,[10080021, 14793, 5647, 1, 1] ,[10080021, 14631, 5821, 1, 1]','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{0,250}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(1009,'暗裔秘所',1,0,0,0,1,5504,6337,1,19100,19400,'[{\"x\":5492,\"y\":6667,\"name\":\"风蚀台地\",\"px\":10164,\"py\":17159,\"id\":1008,\"index\":1},{\"x\":11496,\"y\":1797,\"name\":\"失落之海\",\"px\":1850,\"py\":2160,\"id\":1010,\"index\":1}]','{[100901]={id=100901,x=6857,y=6337,anima=\"idle_212\"},[100902]={id=100902,x=6505,y=6953,anima=\"idle_198\"},[100903]={id=100903,x=2796,y=9694,anima=\"idle_160\"},[100904]={id=100904,x=3856,y=10651,anima=\"idle_220\"},[100905]={id=100905,x=4957,y=12739,anima=\"idle_211\"},[100906]={id=100906,x=7564,y=13553,anima=\"idle_213\"},[100907]={id=100907,x=9951,y=11228,anima=\"idle_205\"},[100908]={id=100908,x=11250,y=9354,anima=\"idle_238\"},[100909]={id=100909,x=11848,y=8608,anima=\"idle_205\"},[100910]={id=100910,x=10831,y=6630,anima=\"idle_164\"},[100911]={id=100911,x=8651,y=4737,anima=\"idle_167\"},[100912]={id=100912,x=7456,y=3248,anima=\"idle_245\"},[100913]={id=100913,x=11047,y=5347,anima=\"idle_186\"},[100914]={id=100914,x=10554,y=2638,anima=\"idle_151\"},[100920]={id=100920,x=12602,y=9302,anima=\"idle_222\"}}','[10090008, 11761, 4760, 1, 1] ,[10090008, 11547, 4451, 1, 1] ,[10090008, 11343, 4746, 1, 1] ,[10090008, 11153, 4454, 1, 1] ,[10090008, 10947, 4142, 1, 1] ,[10090008, 11957, 4459, 1, 1] ,[10090008, 11139, 5029, 1, 1] ,[10090008, 11534, 5028, 1, 1] ,[10090008, 11941, 5039, 1, 1] ,[10090020, 2410, 12209, 1, 1] ,[10090007, 5554, 1337, 1, 1] ,[10090007, 5955, 1953, 1, 1] ,[10090007, 5754, 2240, 1, 1] ,[10090007, 5554, 1957, 1, 1] ,[10090007, 5958, 1350, 1, 1] ,[10090007, 5347, 2243, 1, 1] ,[10090007, 5750, 1652, 1, 1] ,[10090007, 6159, 2241, 1, 1] ,[10090007, 6150, 1648, 1, 1] ,[10090008, 11351, 4153, 1, 1] ,[10090007, 5346, 1640, 1, 1] ,[10090006, 9363, 3547, 1, 1] ,[10090006, 9753, 4149, 1, 1] ,[10090006, 9162, 3851, 1, 1] ,[10090006, 9748, 3554, 1, 1] ,[10090006, 8945, 4148, 1, 1] ,[10090006, 9558, 3256, 1, 1] ,[10090006, 9965, 3261, 1, 1] ,[10090006, 9350, 4138, 1, 1] ,[10090006, 9560, 3850, 1, 1] ,[10090006, 8940, 3547, 1, 1] ,[10090005, 10446, 7747, 1, 1] ,[10090005, 10047, 7749, 1, 1] ,[10090005, 9648, 7760, 1, 1] ,[10090005, 10458, 8342, 1, 1] ,[10090005, 10247, 8042, 1, 1] ,[10090005, 9855, 8045, 1, 1] ,[10090005, 10254, 8640, 1, 1] ,[10090005, 10055, 8342, 1, 1] ,[10090005, 9855, 8649, 1, 1] ,[10090005, 9651, 8347, 1, 1] ,[10090004, 11061, 10738, 1, 1] ,[10090004, 11264, 9848, 1, 1] ,[10090004, 11466, 10171, 1, 1] ,[10090004, 11642, 10443, 1, 1] ,[10090004, 11447, 10746, 1, 1] ,[10090004, 10853, 9849, 1, 1] ,[10090004, 11666, 9854, 1, 1] ,[10090004, 11062, 10160, 1, 1] ,[10090004, 11255, 10446, 1, 1] ,[10090004, 10844, 10441, 1, 1] ,[10090003, 6843, 14034, 1, 1] ,[10090003, 6452, 14050, 1, 1] ,[10090003, 6461, 14653, 1, 1] ,[10090003, 7068, 14946, 1, 1] ,[10090003, 7064, 14348, 1, 1] ,[10090003, 6651, 14932, 1, 1] ,[10090003, 7247, 14053, 1, 1] ,[10090003, 7238, 14638, 1, 1] ,[10090003, 6652, 14342, 1, 1] ,[10090003, 6862, 14639, 1, 1] ,[10090002, 2355, 10852, 1, 1] ,[10090002, 2559, 11141, 1, 1] ,[10090002, 2759, 10837, 1, 1] ,[10090002, 2142, 10549, 1, 1] ,[10090002, 2355, 11435, 1, 1] ,[10090002, 2763, 11439, 1, 1] ,[10090002, 1939, 10843, 1, 1] ,[10090002, 1939, 11436, 1, 1] ,[10090002, 2151, 11153, 1, 1] ,[10090002, 2567, 10553, 1, 1] ,[10090001, 2358, 8643, 1, 1] ,[10090001, 2962, 8350, 1, 1] ,[10090001, 2144, 8340, 1, 1] ,[10090001, 2739, 8636, 1, 1] ,[10090001, 2948, 8929, 1, 1] ,[10090001, 2543, 8936, 1, 1] ,[10090001, 2141, 8943, 1, 1] ,[10090001, 2553, 8349, 1, 1] ,[10090001, 2354, 8049, 1, 1] ,[10090001, 2749, 8047, 1, 1] ,[10090020, 2646, 12209, 1, 1] ,[10090021, 11216, 5707, 1, 1] ,[10090021, 11153, 5846, 1, 1]','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{0,300}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(1010,'失落之海',1,0,0,0,1,1850,2160,1,15700,18100,'[{\"x\":1518,\"y\":2596,\"name\":\"暗裔秘所\",\"px\":11155,\"py\":2155,\"id\":1009,\"index\":1},{\"x\":10874,\"y\":17106,\"name\":\"焚烬火山\",\"px\":3324,\"py\":9579,\"id\":1012,\"index\":1}]','{[101001]={id=101001,x=1965,y=2239,anima=\"idle_212\"},[101002]={id=101002,x=5352,y=1343,anima=\"idle_194\"},[101003]={id=101003,x=7477,y=3337,anima=\"idle_208\"},[101004]={id=101004,x=9762,y=4544,anima=\"idle_190\"},[101005]={id=101005,x=11845,y=5145,anima=\"idle_214\"},[101006]={id=101006,x=12364,y=7555,anima=\"idle_192\"},[101007]={id=101007,x=12152,y=9956,anima=\"idle_187\"},[101008]={id=101008,x=12957,y=10638,anima=\"idle_190\"},[101009]={id=101009,x=13956,y=12761,anima=\"idle_223\"},[101010]={id=101010,x=12506,y=15022,anima=\"idle_133\"},[101011]={id=101011,x=12854,y=15244,anima=\"idle_151\"},[101012]={id=101012,x=12234,y=16730,anima=\"idle_193\"},[101013]={id=101013,x=11647,y=17248,anima=\"idle_192\"},[101014]={id=101014,x=6241,y=5552,anima=\"idle_164\"},[1004103]={id=1004103,x=6280,y=5987,anima=\"idle_245\"}}','[10100002, 8859, 4862, 1, 1] ,[10100002, 8457, 4857, 1, 1] ,[10100002, 8056, 4847, 1, 1] ,[10100002, 8650, 5145, 1, 1] ,[10100002, 8248, 5145, 1, 1] ,[10100002, 8852, 5443, 1, 1] ,[10100002, 8061, 5449, 1, 1] ,[10100002, 8450, 5447, 1, 1] ,[10100001, 6248, 1458, 1, 1] ,[10100001, 6863, 1734, 1, 1] ,[10100001, 6452, 1753, 1, 1] ,[10100001, 6062, 1749, 1, 1] ,[10100001, 7061, 2059, 1, 1] ,[10100001, 6639, 2046, 1, 1] ,[10100001, 6652, 1451, 1, 1] ,[10100001, 6046, 1145, 1, 1] ,[10100001, 6449, 1146, 1, 1] ,[10100001, 6840, 1152, 1, 1] ,[10100002, 8254, 4547, 1, 1] ,[10100002, 8651, 4542, 1, 1] ,[10100003, 11039, 4443, 1, 1] ,[10100003, 10843, 4150, 1, 1] ,[10100003, 10463, 4151, 1, 1] ,[10100003, 10660, 4442, 1, 1] ,[10100003, 10642, 3846, 1, 1] ,[10100003, 11052, 3845, 1, 1] ,[10100003, 11261, 4155, 1, 1] ,[10100003, 10445, 4729, 1, 1] ,[10100003, 10863, 4736, 1, 1] ,[10100003, 11246, 4745, 1, 1] ,[10100004, 13046, 5934, 1, 1] ,[10100004, 12645, 5934, 1, 1] ,[10100004, 13257, 6244, 1, 1] ,[10100004, 12453, 6247, 1, 1] ,[10100004, 13055, 6543, 1, 1] ,[10100004, 12861, 6245, 1, 1] ,[10100004, 12447, 6837, 1, 1] ,[10100004, 12862, 6846, 1, 1] ,[10100004, 13256, 6842, 1, 1] ,[10100004, 12642, 6546, 1, 1] ,[10100005, 11346, 8554, 1, 1] ,[10100005, 11765, 8566, 1, 1] ,[10100005, 11154, 8852, 1, 1] ,[10100005, 11564, 8838, 1, 1] ,[10100005, 11960, 8838, 1, 1] ,[10100005, 11349, 9146, 1, 1] ,[10100005, 11758, 9163, 1, 1] ,[10100005, 11162, 9445, 1, 1] ,[10100005, 11547, 9448, 1, 1] ,[10100005, 11969, 9452, 1, 1] ,[10100006, 13955, 13546, 1, 1] ,[10100006, 13756, 13245, 1, 1] ,[10100006, 14151, 13253, 1, 1] ,[10100006, 14546, 13248, 1, 1] ,[10100006, 13750, 13850, 1, 1] ,[10100006, 14758, 13553, 1, 1] ,[10100006, 14159, 13843, 1, 1] ,[10100006, 14353, 13558, 1, 1] ,[10100006, 14544, 13852, 1, 1] ,[10100007, 11644, 16439, 1, 1] ,[10100007, 12047, 16439, 1, 1] ,[10100007, 11441, 16153, 1, 1] ,[10100007, 11651, 15853, 1, 1] ,[10100007, 11849, 16142, 1, 1] ,[10100007, 12247, 16147, 1, 1] ,[10100007, 11449, 15561, 1, 1] ,[10100007, 11857, 15561, 1, 1] ,[10100007, 12268, 15550, 1, 1] ,[10100007, 12055, 15855, 1, 1] ,[10100020, 6843, 5832, 1, 1] ,[10100020, 7075, 5835, 1, 1] ,[10100021, 13946, 14443, 1, 1] ,[10100021, 13731, 14521, 1, 1]','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{0,350}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(1011,'该隐神社',1,0,0,0,1,5697,9503,1,21209,19500,'[{\"x\":6303,\"y\":3008,\"name\":\"焚烬火山\",\"px\":12165,\"py\":9340,\"id\":1012,\"index\":1}]','{[101101]={id=101101,x=7314,y=3890,anima=\"idle_245\"},[101102]={id=101102,x=9002,y=5212,anima=\"idle_245\"},[101103]={id=101103,x=8557,y=7966,anima=\"idle_245\"},[101104]={id=101104,x=7950,y=9342,anima=\"idle_245\"},[101105]={id=101105,x=5303,y=9052,anima=\"idle_245\"},[101106]={id=101106,x=3905,y=9995,anima=\"idle_245\"},[101107]={id=101107,x=2141,y=11058,anima=\"idle_245\"},[101108]={id=101108,x=2806,y=12602,anima=\"idle_245\"},[101109]={id=101109,x=5846,y=11647,anima=\"idle_245\"},[101110]={id=101110,x=11150,y=11647,anima=\"idle_245\"},[101111]={id=101111,x=12593,y=9701,anima=\"idle_245\"},[101112]={id=101112,x=11641,y=7606,anima=\"idle_245\"},[101113]={id=101113,x=9650,y=13051,anima=\"idle_245\"},[101114]={id=101114,x=11309,y=14957,anima=\"idle_245\"},[101115]={id=101115,x=13112,y=16263,anima=\"idle_245\"},[101116]={id=101116,x=17650,y=6148,anima=\"idle_245\"},[101117]={id=101117,x=17509,y=3198,anima=\"idle_245\"}}','[10110001, 9502, 6396, 1, 1] ,[10110001, 9900, 6904, 1, 1] ,[10110001, 10559, 7052, 1, 1] ,[10110001, 11132, 6662, 1, 1] ,[10110001, 11265, 6034, 1, 1] ,[10110001, 10870, 5456, 1, 1] ,[10110001, 10200, 5302, 1, 1] ,[10110001, 9646, 5704, 1, 1] ,[10110001, 10098, 5897, 1, 1] ,[10110001, 10699, 5905, 1, 1] ,[10110001, 10104, 6498, 1, 1] ,[10110001, 10697, 6496, 1, 1] ,[10110001, 10410, 6208, 1, 1] ,[10110002, 6406, 10001, 1, 1] ,[10110002, 6865, 10345, 1, 1] ,[10110002, 6852, 9672, 1, 1] ,[10110002, 7499, 10451, 1, 1] ,[10110002, 6201, 10443, 1, 1] ,[10110002, 6854, 10893, 1, 1] ,[10110002, 7306, 10809, 1, 1] ,[10110002, 6397, 10807, 1, 1] ,[10110002, 7298, 10002, 1, 1] ,[10110003, 2345, 8448, 1, 1] ,[10110003, 2855, 8443, 1, 1] ,[10110003, 2596, 8104, 1, 1] ,[10110003, 3357, 8438, 1, 1] ,[10110003, 3103, 8096, 1, 1] ,[10110003, 2842, 7748, 1, 1] ,[10110003, 3364, 7759, 1, 1] ,[10110003, 2604, 8796, 1, 1] ,[10110003, 3097, 8796, 1, 1] ,[10110003, 2104, 8796, 1, 1] ,[10110005, 13950, 8743, 1, 1] ,[10110004, 5761, 12913, 1, 1] ,[10110004, 4895, 13748, 1, 1] ,[10110004, 4904, 12052, 1, 1] ,[10110004, 3967, 12908, 1, 1] ,[10110004, 4294, 12455, 1, 1] ,[10110004, 5398, 12445, 1, 1] ,[10110004, 4301, 13389, 1, 1] ,[10110004, 5397, 13395, 1, 1] ,[10110004, 4639, 13003, 1, 1] ,[10110004, 4897, 12603, 1, 1] ,[10110005, 13449, 8738, 1, 1] ,[10110004, 5155, 13004, 1, 1] ,[10110005, 12951, 8743, 1, 1] ,[10110005, 13456, 8046, 1, 1] ,[10110005, 13198, 8399, 1, 1] ,[10110005, 13704, 8404, 1, 1] ,[10110005, 13198, 9106, 1, 1] ,[10110005, 13698, 9101, 1, 1] ,[10110005, 12955, 8051, 1, 1] ,[10110005, 13960, 8057, 1, 1] ,[10110006, 8748, 11847, 1, 1] ,[10110006, 9255, 11846, 1, 1] ,[10110006, 8243, 11845, 1, 1] ,[10110006, 8507, 12194, 1, 1] ,[10110006, 8995, 12202, 1, 1] ,[10110006, 8504, 11502, 1, 1] ,[10110006, 9000, 11499, 1, 1] ,[10110006, 8251, 11146, 1, 1] ,[10110006, 8759, 11154, 1, 1] ,[10110006, 9252, 11151, 1, 1] ,[10110007, 15938, 5442, 1, 1] ,[10110007, 16447, 5447, 1, 1] ,[10110007, 15446, 5444, 1, 1] ,[10110007, 15701, 5801, 1, 1] ,[10110007, 16193, 5801, 1, 1] ,[10110007, 16697, 5806, 1, 1] ,[10110007, 15703, 5103, 1, 1] ,[10110007, 16196, 5108, 1, 1] ,[10110007, 15435, 4760, 1, 1] ,[10110007, 15953, 4755, 1, 1] ,[10110008, 18254, 7247, 1, 1] ,[10110008, 18752, 7245, 1, 1] ,[10110008, 17755, 7243, 1, 1] ,[10110008, 18002, 7600, 1, 1] ,[10110008, 18501, 7604, 1, 1] ,[10110008, 17750, 7945, 1, 1] ,[10110008, 18255, 7943, 1, 1] ,[10110008, 18741, 7945, 1, 1] ,[10110008, 18003, 6899, 1, 1] ,[10110008, 18498, 6902, 1, 1] ,[10110020, 6150, 8342, 1, 1] ,[10110020, 5850, 8447, 1, 1] ,[10110020, 5948, 8144, 1, 1] ,[10110021, 14247, 16643, 1, 1] ,[10110021, 13959, 16445, 1, 1] ,[10110021, 14200, 16296, 1, 1] ,[10110100, 9190, 17000, 1, 1] ','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,0,0,0,1,1,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,0,0,1,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{0,450}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(1012,'焚烬火山',1,0,0,0,1,3153,9426,1,21900,26400,'[{\"x\":2738,\"y\":9309,\"name\":\"失落之海\",\"px\":11159,\"py\":16880,\"id\":1010,\"index\":1},{\"x\":12650,\"y\":9747,\"name\":\"该隐神社\",\"px\":6650,\"py\":3250,\"id\":1011,\"index\":1}]','{[101201]={id=101201,x=4476,y=9851,anima=\"idle_300\"},[101202]={id=101202,x=6372,y=13204,anima=\"idle_90\"},[101203]={id=101203,x=4485,y=18031,anima=\"idle_90\"},[101204]={id=101204,x=7481,y=18681,anima=\"idle_260\"},[101205]={id=101205,x=12740,y=22096,anima=\"idle_240\"},[101206]={id=101206,x=14554,y=20048,anima=\"idle_90\"},[101207]={id=101207,x=11937,y=17792,anima=\"idle_130\"},[101208]={id=101208,x=13385,y=12614,anima=\"idle_35\"},[101209]={id=101209,x=15288,y=12033,anima=\"idle_240\"},[101210]={id=101210,x=15666,y=10003,anima=\"idle_60\"},[101211]={id=101211,x=13966,y=6341,anima=\"idle_120\"},[101212]={id=101212,x=10661,y=7375,anima=\"idle_230\"},[101213]={id=101213,x=9909,y=8261,anima=\"idle_230\"},[101214]={id=101214,x=7440,y=7155,anima=\"idle_245\"}}','[10120020, 3529, 11141, 1, 1] ,[10120001, 7162, 13590, 1, 1] ,[10120001, 7645, 13584, 1, 1] ,[10120001, 6939, 13289, 1, 1] ,[10120001, 7443, 13274, 1, 1] ,[10120001, 7960, 13297, 1, 1] ,[10120003, 15863, 19883, 1, 1] ,[10120020, 3906, 11089, 1, 1] ,[10120001, 7150, 12994, 1, 1] ,[10120001, 7652, 12997, 1, 1] ,[10120003, 15342, 19869, 1, 1] ,[10120001, 6943, 12690, 1, 1] ,[10120001, 7445, 12664, 1, 1] ,[10120001, 7949, 12679, 1, 1] ,[10120021, 4838, 19411, 1, 1] ,[10120002, 5531, 17552, 1, 1] ,[10120002, 6046, 17559, 1, 1] ,[10120002, 5258, 17264, 1, 1] ,[10120002, 5748, 17263, 1, 1] ,[10120002, 6270, 17263, 1, 1] ,[10120021, 4642, 19626, 1, 1] ,[10120002, 5547, 16950, 1, 1] ,[10120002, 6035, 16957, 1, 1] ,[10120002, 6250, 17858, 1, 1] ,[10120002, 5237, 17849, 1, 1] ,[10120002, 5752, 17849, 1, 1] ,[10120100, 11048, 21743, 1, 1] ,[10120003, 16343, 19868, 1, 1] ,[10120003, 15544, 19571, 1, 1] ,[10120003, 16045, 19583, 1, 1] ,[10120003, 15339, 19263, 1, 1] ,[10120003, 15861, 19258, 1, 1] ,[10120003, 16350, 19245, 1, 1] ,[10120003, 15554, 18951, 1, 1] ,[10120003, 16050, 18952, 1, 1] ,[10120004, 10750, 16653, 1, 1] ,[10120004, 11152, 16664, 1, 1] ,[10120004, 11636, 16656, 1, 1] ,[10120004, 10954, 16342, 1, 1] ,[10120004, 11447, 16347, 1, 1] ,[10120004, 10750, 16041, 1, 1] ,[10120004, 11264, 16046, 1, 1] ,[10120004, 11662, 16053, 1, 1] ,[10120004, 10943, 15747, 1, 1] ,[10120004, 11453, 15763, 1, 1] ,[10120005, 13850, 11352, 1, 1] ,[10120005, 14187, 11424, 1, 1] ,[10120005, 13998, 10735, 1, 1] ,[10120005, 14107, 11078, 1, 1] ,[10120005, 14436, 11129, 1, 1] ,[10120005, 13764, 11032, 1, 1] ,[10120005, 14331, 10782, 1, 1] ,[10120005, 14677, 10846, 1, 1] ,[10120005, 13995, 11681, 1, 1] ,[10120022, 16447, 10891, 1, 1] ,[10120022, 16678, 10655, 1, 1] ,[10120006, 17124, 9252, 1, 1] ,[10120006, 17639, 9268, 1, 1] ,[10120006, 18154, 9273, 1, 1] ,[10120006, 17413, 8963, 1, 1] ,[10120006, 17989, 8975, 1, 1] ,[10120006, 17149, 8635, 1, 1] ,[10120006, 17654, 8651, 1, 1] ,[10120006, 18158, 8662, 1, 1] ,[10120006, 17396, 8351, 1, 1] ,[10120006, 18002, 8334, 1, 1] ,[10120007, 11046, 4251, 1, 1] ,[10120007, 11550, 4229, 1, 1] ,[10120007, 12060, 4251, 1, 1] ,[10120007, 11239, 3945, 1, 1] ,[10120007, 11840, 3945, 1, 1] ,[10120007, 11041, 3618, 1, 1] ,[10120007, 11545, 3618, 1, 1] ,[10120007, 12060, 3634, 1, 1] ,[10120007, 11250, 3334, 1, 1] ,[10120007, 11840, 3328, 1, 1] ,[10120008, 7458, 8903, 1, 1] ,[10120008, 7941, 8914, 1, 1] ,[10120008, 7227, 8570, 1, 1] ,[10120008, 7747, 8581, 1, 1] ,[10120008, 8267, 8608, 1, 1] ,[10120008, 7447, 8264, 1, 1] ,[10120008, 7967, 8291, 1, 1] ,[10120008, 7237, 7964, 1, 1] ,[10120008, 7742, 7985, 1, 1] ,[10120008, 8252, 8002, 1, 1] ,[10120024, 9712, 7394, 1, 1] ,[10120023, 8635, 5152, 1, 1] ,[10120023, 9063, 5139, 1, 1]','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{0,400}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(1201,'世界首领1层',3,0,0,0,1,1268,1176,1,7882,6368,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,0,0,0,0,0,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,0,0,0,0,0,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,2,2,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{-1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"1\",\"type\":\"pkstate\"}]',607,491,'0.9',1,0,1201,'[{1268,1176}]'),(1202,'世界首领2层',3,0,0,0,1,1501,746,1,7413,6698,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1:\n1,1,1,1,1,1,1,1,1,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1:\n1,1,1,1,1,1,1,1,1,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,1,1:\n1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,1,1:\n1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1:\n1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1:\n1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1:\n1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1:\n1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1:\n1,1,1,1,2,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1:\n1,1,1,1,2,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,2,2,2,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1:\n1,1,1,2,2,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1:\n1,1,1,2,2,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1:\n1,1,0,2,2,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1:\n1,1,2,2,2,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1:\n1,1,2,2,2,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1:\n1,1,2,2,2,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1:\n1,1,2,2,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1:\n1,1,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,1,1,1,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,1,1,1,1,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{-1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"1\",\"type\":\"pkstate\"}]',543,491,'0.9',1,0,1202,'[{1501,746}]'),(1203,'世界首领3层',3,0,0,0,1,4770,4432,1,6144,5888,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,5,5,5,5,5,5,5,5,5,5,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,5,5,5,5,5,5,5,5,5,5,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1:\n1,0,0,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,1,1,1,1,1:\n1,0,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,1:\n1,0,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,1:\n1,2,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,1:\n1,2,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,1:\n1,2,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,1:\n1,2,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,1:\n1,2,2,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,1:\n1,2,2,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,1,1,1,0,1:\n1,2,2,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,1,1,1,1,1,1:\n1,2,2,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1:\n1,2,2,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1:\n1,2,2,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1:\n1,2,2,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1:\n1,2,2,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,1:\n1,2,2,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,1:\n1,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,2,2,2,2,2,2,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,2,2,2,2,2,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,2,2,2,2,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1:\n1,0,0,0,0,0,0,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1:\n1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1:\n1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,2,2,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,2,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1:\n1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1:\n1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1:\n1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1:\n1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,1,1,1,1:\n1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,0,0,0,0,0,0,0,0,1,1,1,1:\n1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,0,0,0,0,0,0,0,1,1,1,1,1:\n1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,0,0,0,0,0,0,0,1,1,1,1,1:\n1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,0,0,0,2,2,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,0,0,0,2,2,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,0,0,0,2,2,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,0,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,0,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1:\n1,0,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1:\n1,0,0,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,0,0,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,0,0,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,0,0,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,0,0,1,1,0,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,0,0,1,1,0,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,0,0,1,1,0,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,0,0,1,1,0,0,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,0,0,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,0,0,1,1,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1:\n1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1:\n1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1:\n1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{-1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"1\",\"type\":\"pkstate\"}]',512,491,'0.9',1,0,1203,'[{4770,4432}]'),(1204,'世界首领4层',3,0,0,0,1,3940,1178,1,8000,8000,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,1,1,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,0,0,1,1,1,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1:\n1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1:\n1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1:\n1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,1:\n1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1:\n1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1:\n1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1:\n1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1:\n1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1:\n1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,1,1,1,1,1:\n1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,2,2,2,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,0,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,0,1,1,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,1,1,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,2,2,2,2,2,2,1,1,1,1,2,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,2,2,2,2,2,2,2,1,1,1,1,2,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,2,2,2,2,2,2,2,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,2,2,2,2,2,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,2,2,2,2,2,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,0,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,0,0,1,1,1,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,0,0,1,1,1,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,0,0,1,1,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,5,5,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,5,5,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,5,5,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,5,5,5,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,5,5,5,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,0,2,2,2,2,2,2,2,2,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,2,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{-1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"1\",\"type\":\"pkstate\"}]',491,491,'0.9',1,0,1204,'[{3940,1178}]'),(1209,'原罪祭坛',2,0,0,0,1,2067,2091,1,9000,8900,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]');
INSERT INTO `base_scene` VALUES (1210,'原罪祭坛',3,0,0,0,1,2067,2091,1,9200,9100,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(1211,'原罪祭坛',3,3,0,0,1,2067,2091,1,9200,9100,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(1251,'首领会所1层',3,0,0,0,1,8978,6409,1,28000,31200,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"1\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(1252,'首领会所2层',3,0,0,0,1,8978,6409,1,28000,31200,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"1\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(1253,'首领会所3层',3,0,0,0,1,8978,6409,1,28000,31200,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"1\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(1254,'首领会所4层',3,0,0,0,1,8978,6409,1,28000,31200,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"1\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(1255,'首领会所5层',3,0,0,0,1,8978,6409,1,28000,31200,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"1\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(1256,'首领会所6层',3,0,0,0,1,8978,6409,1,28000,31200,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"1\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(1301,'混乱魔域1层',3,0,0,0,1,13103,908,1,24005,18002,'[]','{}','[1301901, 16011, 5906, 1, 1] ,[1301901, 15657, 5948, 1, 1] ,[1301901, 16082, 5603, 1, 1] ,[1301901, 15548, 5559, 1, 1] ,[1301901, 15848, 5319, 1, 1] ,[1301902, 7821, 5864, 1, 1] ,[1301902, 8732, 5082, 1, 1] ,[1301902, 8396, 4820, 1, 1] ,[1301902, 8750, 5492, 1, 1] ,[1301902, 8488, 5193, 1, 1] ,[1301902, 7622, 5595, 1, 1] ,[1301902, 7723, 6100, 1, 1] ,[1301903, 16014, 14221, 1, 1] ,[1301903, 16166, 14600, 1, 1] ,[1301903, 16501, 14365, 1, 1] ,[1301903, 15651, 14283, 1, 1] ,[1301903, 16317, 14076, 1, 1] ,[1301903, 15821, 14568, 1, 1] ,[1301904, 12922, 11957, 1, 1] ,[1301904, 12940, 11639, 1, 1] ,[1301904, 12701, 11787, 1, 1] ,[1301904, 12662, 11419, 1, 1] ,[1301904, 12965, 11339, 1, 1] ,[1301904, 12691, 11122, 1, 1] ,[1301904, 12936, 11061, 1, 1] ,[1301904, 12964, 11315, 1, 1] ,[1301905, 8999, 12664, 1, 1] ,[1301905, 9302, 12534, 1, 1] ,[1301905, 9595, 12553, 1, 1] ,[1301905, 9544, 12177, 1, 1] ,[1301905, 9255, 12195, 1, 1] ,[1301905, 8945, 12296, 1, 1] ,[1301905, 9219, 11884, 1, 1] ,[1301906, 3615, 6145, 1, 1] ,[1301906, 3464, 5722, 1, 1] ,[1301906, 3511, 5910, 1, 1] ,[1301906, 3529, 5386, 1, 1] ,[1301906, 3738, 5545, 1, 1] ,[1301906, 3796, 5834, 1, 1] ,[1301906, 3944, 6080, 1, 1] ,[1301906, 4024, 5469, 1, 1] ,[1301907, 1516, 13670, 1, 1] ,[1301907, 1277, 13410, 1, 1] ,[1301907, 1089, 13193, 1, 1] ,[1301907, 1360, 12955, 1, 1] ,[1301907, 1516, 13179, 1, 1] ,[1301907, 1722, 13374, 1, 1] ,[1301907, 1776, 12977, 1, 1] ,[1301907, 1528, 13202, 1, 1] ,[1301901, 15834, 5660, 1, 1] ,[1301901, 15659, 5716, 1, 1]','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,0,0,0,0,1,1,1,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"1\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(1302,'混乱魔域2层',3,0,0,0,1,13103,908,1,24005,18002,'[]','{}','[1302901, 16200, 5514, 1, 1] ,[1302901, 15624, 5382, 1, 1] ,[1302901, 16068, 5841, 1, 1] ,[1302901, 15454, 5623, 1, 1] ,[1302901, 15939, 5368, 1, 1] ,[1302901, 15843, 5619, 1, 1] ,[1302901, 15640, 5886, 1, 1] ,[1302902, 8587, 5756, 1, 1] ,[1302902, 8782, 5583, 1, 1] ,[1302902, 8356, 4911, 1, 1] ,[1302902, 8681, 4983, 1, 1] ,[1302902, 8695, 5286, 1, 1] ,[1302902, 8446, 5510, 1, 1] ,[1302902, 8277, 5236, 1, 1] ,[1302903, 12496, 11758, 1, 1] ,[1302903, 12897, 11501, 1, 1] ,[1302903, 12706, 11256, 1, 1] ,[1302903, 12789, 11751, 1, 1] ,[1302903, 12276, 11491, 1, 1] ,[1302903, 12330, 11234, 1, 1] ,[1302903, 12645, 11480, 1, 1] ,[1302904, 15967, 14475, 1, 1] ,[1302904, 16252, 14594, 1, 1] ,[1302904, 16534, 14381, 1, 1] ,[1302904, 16375, 14081, 1, 1] ,[1302904, 16097, 14006, 1, 1] ,[1302904, 15819, 14150, 1, 1] ,[1302904, 16212, 14287, 1, 1] ,[1302905, 3633, 6092, 1, 1] ,[1302905, 3565, 5774, 1, 1] ,[1302905, 3706, 5467, 1, 1] ,[1302905, 3984, 5529, 1, 1] ,[1302905, 3839, 5774, 1, 1] ,[1302905, 3969, 6045, 1, 1] ,[1302906, 9014, 12632, 1, 1] ,[1302906, 9326, 12489, 1, 1] ,[1302906, 9455, 12140, 1, 1] ,[1302906, 9175, 11933, 1, 1] ,[1302906, 8871, 12039, 1, 1] ,[1302906, 8793, 12361, 1, 1] ,[1302906, 9133, 12255, 1, 1] ,[1302908, 1254, 13163, 1, 1] ,[1302908, 1383, 13531, 1, 1] ,[1302908, 1548, 12984, 1, 1] ,[1302908, 1893, 13071, 1, 1] ,[1302908, 1884, 13434, 1, 1] ,[1302908, 1622, 13297, 1, 1]','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,0,0,0,0,1,1,1,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"1\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(1303,'混乱魔域3层',3,0,0,0,1,13103,908,1,24005,18002,'[]','{}','[1303901, 15976, 5940, 1, 1] ,[1303901, 15723, 5765, 1, 1] ,[1303901, 15530, 5503, 1, 1] ,[1303901, 15764, 5255, 1, 1] ,[1303901, 15934, 5489, 1, 1] ,[1303901, 16201, 5660, 1, 1] ,[1303901, 16155, 5227, 1, 1] ,[1303902, 8631, 5707, 1, 1] ,[1303902, 8774, 5367, 1, 1] ,[1303902, 8774, 5041, 1, 1] ,[1303902, 8456, 5041, 1, 1] ,[1303902, 8475, 5335, 1, 1] ,[1303902, 8309, 5565, 1, 1] ,[1303903, 12582, 10887, 1, 1] ,[1303903, 12899, 10896, 1, 1] ,[1303903, 12986, 11121, 1, 1] ,[1303903, 12375, 11089, 1, 1] ,[1303903, 12724, 11107, 1, 1] ,[1303903, 12784, 11411, 1, 1] ,[1303904, 15856, 14392, 1, 1] ,[1303904, 16160, 14472, 1, 1] ,[1303904, 16470, 14334, 1, 1] ,[1303904, 16369, 14024, 1, 1] ,[1303904, 16142, 14147, 1, 1] ,[1303904, 15766, 14071, 1, 1] ,[1303904, 16059, 13840, 1, 1] ,[1303905, 4544, 6523, 1, 1] ,[1303905, 4846, 6372, 1, 1] ,[1303905, 4963, 6037, 1, 1] ,[1303905, 4656, 5948, 1, 1] ,[1303905, 4572, 6166, 1, 1] ,[1303905, 4293, 6294, 1, 1] ,[1303906, 8762, 12492, 1, 1] ,[1303906, 9073, 12481, 1, 1] ,[1303906, 9340, 12250, 1, 1] ,[1303906, 9192, 11928, 1, 1] ,[1303906, 8957, 12087, 1, 1] ,[1303906, 8827, 11719, 1, 1] ,[1303906, 8650, 12080, 1, 1] ,[1303906, 9162, 12064, 1, 1]','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,0,0,0,0,1,1,1,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"1\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(1304,'混乱魔域4层',3,0,0,0,1,13103,908,1,24005,18002,'[]','{}','[1304901, 15780, 6026, 1, 1] ,[1304901, 16166, 5966, 1, 1] ,[1304901, 16254, 5622, 1, 1] ,[1304901, 15922, 5699, 1, 1] ,[1304901, 15559, 5787, 1, 1] ,[1304901, 15669, 5474, 1, 1] ,[1304901, 15977, 5336, 1, 1] ,[1304902, 16303, 13942, 1, 1] ,[1304902, 16018, 13919, 1, 1] ,[1304902, 16551, 14080, 1, 1] ,[1304902, 16262, 14191, 1, 1] ,[1304902, 15944, 14163, 1, 1] ,[1304902, 16211, 14434, 1, 1] ,[1304903, 12459, 11759, 1, 1] ,[1304903, 12745, 11755, 1, 1] ,[1304903, 12889, 11473, 1, 1] ,[1304903, 12683, 11184, 1, 1] ,[1304903, 12369, 11174, 1, 1] ,[1304903, 12607, 11426, 1, 1] ,[1304903, 12271, 11437, 1, 1] ,[1304904, 8710, 5578, 1, 1] ,[1304904, 8822, 5296, 1, 1] ,[1304904, 8732, 4964, 1, 1] ,[1304904, 8396, 4917, 1, 1] ,[1304904, 8540, 5159, 1, 1] ,[1304904, 8450, 5462, 1, 1] ,[1304905, 3587, 6068, 1, 1] ,[1304905, 3881, 5980, 1, 1] ,[1304905, 4014, 5654, 1, 1] ,[1304905, 3831, 5415, 1, 1] ,[1304905, 3715, 5709, 1, 1] ,[1304905, 3463, 5599, 1, 1] ,[1304906, 8679, 12482, 1, 1] ,[1304906, 9019, 12467, 1, 1] ,[1304906, 9044, 12124, 1, 1] ,[1304906, 8777, 12157, 1, 1] ,[1304906, 8813, 11795, 1, 1] ,[1304906, 9192, 11842, 1, 1] ,[1304906, 9319, 12160, 1, 1] ,[1304906, 8331, 11888, 1, 1]','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,0,0,0,0,1,1,1,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"1\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(1310,'黄昏遗迹',3,0,0,0,1,13103,908,1,24238,20469,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"1\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(1311,'和平遗迹',3,3,0,0,1,13103,908,1,24238,20469,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(1312,'日落遗迹',3,0,0,0,1,13103,908,1,24238,20469,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"1\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(1313,'和平遗迹',3,3,0,0,1,13103,908,1,24238,20469,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(1314,'落霞遗迹',3,0,0,0,1,13103,908,1,24238,20469,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"1\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(1315,'和平遗迹',3,3,0,0,1,13103,908,1,24238,20469,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(1316,'首领遗迹6层',3,0,0,0,1,13103,908,1,24238,20469,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"1\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(1317,'首领遗迹8层',3,0,0,0,1,13103,908,1,24238,20469,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"1\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(1318,'首领遗迹9层',3,0,0,0,1,13103,908,1,24238,20469,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"1\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(1319,'首领遗迹10层',3,0,0,0,1,13103,908,1,24238,20469,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"1\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(1320,'首领遗迹10层',3,0,0,0,1,13103,908,1,24238,20469,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"1\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(1341,'首领狩猎',2,0,0,0,1,1963,2886,1,6400,5900,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(1720,'测试之城',1,0,0,0,1,0,0,1,23500,20600,'[]','{[100430]={id=100430,x=2919,y=2900,anima=\"idle_245\"}}','[71201010, 3493, 3062, 1, 1] ','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,1,1,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,1,1,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(2300,'未命名',1,0,0,0,1,0,0,1,9440,9440,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(2501,'水形物语',2,0,0,1,1,4738,6080,1,15700,18100,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{10,10}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(2502,'暮光森林',2,0,0,1,1,2778,4003,1,23050,19519,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,0,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{80,80}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]');
INSERT INTO `base_scene` VALUES (2503,'迷失石窟',2,0,0,1,1,19059,5018,1,22850,19959,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,0,0,0,0,0,0,0,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{100,100}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(2504,'冰雪王座',2,0,0,1,1,17996,8308,1,21400,13900,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{100,100}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(2505,'机械迷城',2,0,0,1,1,10838,8826,1,19100,19400,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{100,100}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(3000,'经验副本',2,0,0,1,1,4402,4159,1,9440,9440,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(3003,'经验副本',2,0,0,1,1,4880,4500,1,10000,10000,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(3004,'未命名',1,0,0,0,1,0,0,1,23050,19519,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,0,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(3006,'蝴蝶山谷',10,0,0,1,1,14246,4997,1,22850,19959,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,0,0,0,0,0,0,0,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(3007,'刷怪测试图',2,0,0,0,1,4902,8087,1,10000,10000,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(3010,'蝴蝶山谷',10,0,0,0,1,10225,13372,1,17800,16400,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(3110,'装备本·简单',2,0,0,1,1,6240,1175,1,23050,19519,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,0,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(3111,'装备本·普通',2,0,0,1,1,6182,4426,1,23050,19519,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,0,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(3112,'装备本·困难',2,0,0,1,1,14133,10720,1,21400,13900,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,1,1,0,0,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(3113,'装备本·噩梦',2,0,0,1,1,19277,4999,1,22850,19959,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,0,0,0,0,0,0,0,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(3114,'装备本·炼狱',2,0,0,1,1,6566,1500,1,15700,18100,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(3115,'装备副本',2,0,1,1,1,7867,2311,1,14700,12800,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,','[]','[{\"id\":1,\"type\":1,\"list\":\"40:25,40:26,41:25,41:26,41:27,42:24,42:25,42:26,42:27,42:28,43:23,43:24,43:25,43:26,43:27,43:28,43:29,44:23,44:24,44:25,44:26,44:27,44:28,44:29,44:30,45:22,45:23,45:24,45:25,45:26,45:27,45:28,45:29,45:30,45:31,46:22,46:23,46:24,46:25,46:26,46:27,46:28,46:29,46:30,46:31,47:23,47:24,47:25,47:26,47:27,47:28,47:29,47:30,48:24,48:25,48:26,48:27,49:24,49:25,49:26\"},{\"id\":2,\"type\":1,\"list\":\"26:56,27:55,27:56,28:54,28:55,28:56,28:57,29:53,29:54,29:55,29:56,29:57,29:58,30:52,30:53,30:54,30:55,30:56,30:57,30:58,31:53,31:54,31:55,31:56,31:57,31:58,31:59,31:60,32:55,32:56,32:57,32:58,32:59,32:60,33:54,33:55,33:56,33:57,33:58,33:59,34:55,34:56,34:57,34:58\"},{\"id\":3,\"type\":1,\"list\":\"75:68,75:69,75:70,76:68,76:69,76:70,76:71,77:67,77:68,77:69,77:70,77:71,77:72,78:68,78:69,78:70,78:71,78:72,78:73,79:69,79:70,79:71,79:72,79:73,79:74,80:70,80:71,80:72,80:73,80:74,81:71,81:72\"}]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(3116,'装备本·普通',2,0,1,1,1,10585,2853,1,14600,17600,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,','[]','[{\"id\":1,\"type\":1,\"list\":\"60:36,60:37,61:34,61:35,61:36,61:37,62:33,62:34,62:35,62:36,62:37,62:38,63:31,63:32,63:33,63:34,63:35,63:36,63:37,63:38,64:32,64:33,64:34,64:35,64:36,64:37,64:38,65:32,65:33,65:34,65:35,65:36,65:37,66:33,66:34,66:35,66:36,67:33,67:34\"},{\"id\":2,\"type\":1,\"list\":\"87:51,87:52,87:53,88:49,88:50,88:51,88:52,88:53,89:49,89:50,89:51,89:52,89:53,89:54,90:50,90:51,90:52,90:53,90:54,91:50,91:51,91:52,92:50,92:51\"}]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(3117,'装备本·困难',2,0,1,1,1,17138,18180,1,21209,22250,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1','[]','[{\"id\":1,\"type\":1,\"list\":\"163:151,163:152,164:150,164:151,164:152,165:150,165:151,165:152,166:150,166:151,166:152,167:150,167:151,167:152,168:150,168:151,168:152,169:150,169:151,169:152,170:150,170:151,170:152,171:150,171:151,171:152,172:150,172:151,172:152,173:150,173:151,173:152,174:150,174:151,174:152,175:150,175:151,175:152,176:150,176:151,176:152,177:150,177:151,177:152,178:150,178:151,178:152,179:150,179:151,179:152,180:150,180:151,181:152\"},{\"id\":3,\"type\":1,\"list\":\"151:90,152:90,153:89,153:90,153:91,154:89,154:90,154:91,154:92,154:93,155:89,155:90,155:91,155:92,155:93,156:89,156:90,156:91,156:92,156:93,156:94,156:95,157:90,157:91,157:92,157:93,157:94,158:92,158:93,158:94,158:95,159:92,159:93,159:94\"},{\"id\":4,\"type\":1,\"list\":\"166:119,166:120,166:121,167:119,167:120,168:119,168:120,168:121,169:119,169:120,169:121,170:118,170:119,170:120,170:121,171:118,171:119,171:120,171:121,172:118,172:119,172:120,172:121,173:119,173:120,173:121,174:119,174:120,174:121,175:119,175:120,175:121,175:122,176:119,176:120,176:121,176:122,177:119,177:120,177:121,177:122,178:120,178:121,178:122,179:120,179:121,179:122,180:120,180:121,180:122,180:123,181:119,181:120,181:121,181:122,181:123,182:120,182:121,182:122,182:123,183:119,183:121,183:122,183:123,184:120,184:121,184:122,184:123,185:120,185:121,185:122,185:123,187:121,188:121,189:121,190:121\"}]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(3118,'装备本·噩梦',2,0,1,1,1,4042,11335,1,21400,13900,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,1,1,0,0,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1','[]','[{\"id\":1,\"type\":1,\"list\":\"70:105,70:106,71:103,71:104,71:105,71:106,71:107,71:108,71:109,72:103,72:104,72:105,72:106,72:107,72:108,72:109,72:110,73:102,73:103,73:104,73:105,73:106,73:107,73:108,73:109,73:110,73:111,74:102,74:103,74:104,74:105,74:106,74:107,74:108,74:109,74:110,74:111,75:102,75:103,75:104,75:105,75:106,75:107,75:108,75:109,76:101,76:102,76:103,76:104,76:105,76:106,76:107,77:102,77:103,77:104,77:105,77:106\"},{\"id\":2,\"type\":1,\"list\":\"109:108,110:106,110:107,110:108,110:109,111:104,111:105,111:106,111:107,111:108,111:109,111:110,112:103,112:104,112:105,112:106,112:107,112:108,112:109,112:110,112:111,113:102,113:103,113:104,113:105,113:106,113:107,113:108,113:109,113:110,113:111,114:102,114:103,114:104,114:105,114:106,114:107,114:108,114:109,114:110,114:111,115:102,115:103,115:104,115:105,115:106,115:107,115:108,115:109,115:110,115:111,115:112,116:103,116:104\"},{\"id\":3,\"type\":1,\"list\":\"136:94,136:95,137:94,137:95,137:96,138:94,138:95,138:96,138:97,139:95,139:96,139:97,140:95,140:96,140:97,141:95,141:96,141:97,141:98,142:94,142:95,142:96,142:97,142:98,143:94,143:95,143:96,143:97,143:98,144:93,144:94,144:95,144:96,144:97,144:98,145:93,145:94,145:95,145:96,145:97,145:98,146:95,146:96,146:97,146:98,147:95,147:96,147:97,147:98,148:95,148:96,148:97,149:96,149:97\"}]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(3119,'装备本·炼狱',2,0,1,1,1,12815,6506,1,15700,18100,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1','[]','[{\"id\":1,\"type\":1,\"list\":\"120:75,120:76,120:77,121:74,121:75,121:76,121:77,121:78,122:74,122:75,122:76,122:77,122:78,122:79,123:75,123:76,123:77,123:78,123:79,123:80,124:76,124:77,124:78,124:79,124:80,125:76,125:77,125:78,125:79,125:80,125:81,126:77,126:78,126:79,127:78,127:79\"},{\"id\":2,\"type\":1,\"list\":\"127:107,127:108,128:106,128:107,128:108,128:109,129:106,129:107,129:108,129:109,130:105,130:106,130:107,130:108,130:109,130:110,130:111,131:104,131:105,131:106,131:107,131:108,131:109,131:110,131:111,131:112,132:104,132:105,132:106,132:107,132:108,132:109,132:110,132:111,133:105,133:106,133:107,133:108,133:109,133:110,134:106,134:107,134:108,134:109,134:110,135:107,135:108,135:109\"},{\"id\":3,\"type\":1,\"list\":\"123:145,123:146,124:146,125:146,125:147,125:148,126:145,126:146,126:147,126:148,126:149,127:145,127:146,127:147,127:148,127:149,127:150,128:144,128:145,128:146,128:147,128:148,128:149,128:150,129:145,129:146,129:147,129:148,129:149,129:150,129:151,129:152,130:146,130:147,130:148,130:149,130:150,130:151,130:152,131:147,131:148,131:149,131:150,131:151,131:152,131:153,132:148,132:149,132:150,132:151,132:152,133:149,133:150,133:151\"}]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(3200,'诛邪战场',2,3,1,1,1,2165,1453,0,4302,2705,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,2,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1:\n1,1,1,1,1,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1:\n1,1,1,1,1,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1:\n1,1,1,1,1,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1:\n1,1,1,1,1,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1:\n1,1,1,1,1,1,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1:\n1,1,1,1,1,1,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1:\n1,1,1,1,1,1,1,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1:\n1,1,1,1,1,1,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,1,1,1,1,1:\n1,1,1,1,1,1,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,1,1,1,1,1:\n1,1,1,1,1,1,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,1,1,1,1,1:\n1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1:\n1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,0,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1:\n1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,2,2,2,2,2,2,0,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1:\n1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1:\n1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1:\n1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,420}]\",\"type\":\"lv\"},{\"attr\":\"1\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',780,491,'0.9',1,0,3200,'[{2165,1453}]'),(3300,'洗练本·简单',2,0,1,0,1,10330,2819,1,21209,22250,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]');
INSERT INTO `base_scene` VALUES (3301,'洗练本·普通',2,0,1,0,1,10330,2819,1,21209,22250,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(3302,'洗练本·困难',2,0,1,0,1,10330,2819,1,21209,22250,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(3303,'洗练本·噩梦',2,0,1,0,1,10330,2819,1,21209,22250,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(3304,'洗练本·炼狱',2,0,1,0,1,10330,2819,1,21209,22250,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(3306,'洗练副本',1,0,0,0,1,10537,2790,1,21209,22250,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(4051,'巅峰竞技',7,3,0,1,0,416,675,0,2759,1461,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,0,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1:\n1,1,1,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,0,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"2\",\"type\":\"pkstate\"}]',821,434,'0.9',1,0,3000,'[{416,675}]'),(4052,'巅峰竞技',7,3,1,1,0,416,675,0,2759,1461,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,0,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1:\n1,1,1,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,0,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"2\",\"type\":\"pkstate\"}]',821,434,'0.9',1,0,3000,'[{416,675}]'),(4053,'巅峰竞技',7,2,0,1,1,4880,4500,1,9440,9440,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"2\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(4054,'巅峰竞技',7,2,1,1,1,4880,4500,1,9440,9440,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"2\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(4061,'公会争霸',8,3,0,0,1,4880,4500,1,9440,9440,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(4063,'公会争霸',8,2,0,1,1,11308,10285,1,23180,22310,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(4101,'公会宴会',9,0,0,0,1,3333,5633,1,8000,8800,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(4102,'公会争霸',5,3,0,0,1,4880,4500,1,9440,9440,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(4201,'公会守卫',2,0,0,0,1,8004,5324,1,17400,15600,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,4201,'[4345,4344]'),(4601,'跨服海战',15,2,1,1,1,7477,10893,0,27400,28700,'[]','{}','[4061024, 4716, 11788, 1, 1] ,[4061024, 5135, 11825, 1, 1] ,[4061024, 4638, 11362, 1, 1] ,[4061024, 4776, 11026, 1, 1] ,[4061024, 5140, 10992, 1, 1] ,[4061024, 5028, 11376, 1, 1] ,[4061024, 5347, 11543, 1, 1] ,[4061024, 5427, 11188, 1, 1] ,[4061024, 12624, 5649, 1, 1] ,[4061024, 12243, 5522, 1, 1] ,[4061024, 13005, 5614, 1, 1] ,[4061024, 13167, 5188, 1, 1] ,[4061024, 12730, 4705, 1, 1] ,[4061024, 12310, 4699, 1, 1] ,[4061024, 12313, 5171, 1, 1] ,[4061024, 12734, 5126, 1, 1] ,[4061024, 17958, 4505, 1, 1] ,[4061024, 18398, 4647, 1, 1] ,[4061024, 18816, 4483, 1, 1] ,[4061024, 18790, 4074, 1, 1] ,[4061024, 18434, 3768, 1, 1] ,[4061024, 18019, 3745, 1, 1] ,[4061024, 17943, 4186, 1, 1] ,[4061024, 18342, 4191, 1, 1] ,[4061024, 17420, 24400, 1, 1] ,[4061024, 17110, 23557, 1, 1] ,[4061024, 17541, 23392, 1, 1] ,[4061024, 18013, 23503, 1, 1] ,[4061024, 18033, 24013, 1, 1] ,[4061024, 17881, 24373, 1, 1] ,[4061024, 17554, 23883, 1, 1] ,[4061024, 17113, 24061, 1, 1]','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"1\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(5153,'婚礼临时',5,1,0,0,1,3644,3692,1,7990,8000,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(5155,'风台婚礼',1,0,0,0,1,2707,2517,1,23500,20600,'[{\"x\":2415,\"y\":1636,\"name\":\"寒鸦峡谷\",\"px\":4634,\"py\":11358,\"id\":1007,\"index\":1}]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(5163,'海滩',5,1,0,1,1,11570,5710,1,18800,17200,'[]','{}','','3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,3,3,3,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,3,3,3,3,3,3,3,3,3,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,3,3,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,3,3,3,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,1,1,1,1,1,0,0,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,1,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,3,3,1,1,1,1,1,1,1,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,3,1,1,1,1,1,1,1,3,3,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,3,3,1,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,0,0,0,0,0,1,1,3,3,3,3,1,1,0,3,3,3,3,3,3,1,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,3,3,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,0,0,0,1,1,3,3,3,3,1,1,1,1,3,3,3,3,3,3,3,1,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,0,0,1,1,3,3,3,3,1,1,1,1,1,3,3,3,3,3,3,3,3,1,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,1,1,1,3,3,3,1,1,1,1,1,3,3,3,3,3,3,3,3,3,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,3,3,3,3,3,3,3,3,3,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,3,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,1,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,3,3,3,3,3,3,3,3,3,3,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,1,1,3,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,1,1,1,1,1,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,0,0,0,0,0,1,1,1,0,0,0,0,0,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,0,0,0,0,0,1,1,1,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,0,0,0,0,0,1,1,1,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,0,0,0,0,0,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,0,0,0,0,0,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,0,0,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,1,1,0,0,0,0,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[{9885,6072},{10934,5672},{7255,6354},{9422,12340},{10186,3232},{8787,3534},{16282,12099}]'),(5164,'海滩',5,1,1,1,1,11570,5710,1,18800,17200,'[]','{}','','3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,3,3,3,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,3,3,3,3,3,3,3,3,3,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,3,3,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,3,3,3,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,1,1,1,1,1,0,0,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,1,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,3,3,1,1,1,1,1,1,1,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,3,1,1,1,1,1,1,1,3,3,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,3,3,1,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,0,0,0,0,0,1,1,3,3,3,3,1,1,0,3,3,3,3,3,3,1,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,3,3,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,0,0,0,1,1,3,3,3,3,1,1,1,1,3,3,3,3,3,3,3,1,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,0,0,1,1,3,3,3,3,1,1,1,1,1,3,3,3,3,3,3,3,3,1,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,1,1,1,3,3,3,1,1,1,1,1,3,3,3,3,3,3,3,3,3,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,3,3,3,3,3,3,3,3,3,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,3,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,1,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,3,3,3,3,3,3,3,3,3,3,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,1,1,3,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,1,1,1,1,1,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,0,0,0,0,0,1,1,1,0,0,0,0,0,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,0,0,0,0,0,1,1,1,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,0,0,0,0,0,1,1,1,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,0,0,0,0,0,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,0,0,0,0,0,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,0,0,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3:\n3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,0,0,0,0,1,1,0,0,0,0,0,0,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[{9885,6072},{10934,5672},{7255,6354},{9422,12340},{10186,3232},{8787,3534},{16282,12099}]'),(5171,'中午答题',5,1,0,1,1,5698,1661,1,11500,6200,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(5181,'护送飞艇',1,0,0,0,1,2500,3337,1,9440,9440,'[{\"x\":2508,\"y\":3582,\"name\":\"森林神殿\",\"px\":10384,\"py\":841,\"id\":1006,\"index\":1}]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(5182,'护送飞艇',1,0,0,0,1,2500,3337,1,9440,9440,'[{\"x\":4824,\"y\":4427,\"name\":\"护送飞艇\",\"px\":2469,\"py\":3493,\"id\":5181,\"index\":1},{\"x\":4826,\"y\":7097,\"name\":\"护送飞艇\",\"px\":4875,\"py\":7172,\"id\":5183,\"index\":1}]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(5183,'护送飞艇',1,0,0,0,1,2500,3337,1,9440,9440,'[{\"x\":4828,\"y\":6963,\"name\":\"护送飞艇\",\"px\":4400,\"py\":7172,\"id\":5182,\"index\":1}]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(5191,'战场竞技',7,0,0,1,1,4880,4500,1,9440,9440,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(5200,'如胶似漆',2,0,1,1,1,3675,3702,1,7990,8000,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(5201,'相濡以沫',2,0,1,1,1,3675,3702,1,7990,8000,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(5202,'地久天长',2,0,1,1,1,3675,3702,1,7990,8000,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(5300,'铜币宝库',2,0,0,1,1,4880,4500,1,9440,9440,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(5303,'地底矿洞',2,0,0,1,1,4823,4528,1,9440,9440,'[]','{}','[1, 4798, 4502, 1, 1]','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[3837,3350]'),(5400,'降神副本',2,0,0,1,1,3266,2639,1,9000,9800,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(5401,'降神副本',2,0,0,1,1,4880,4500,1,9440,9440,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(5500,'星灵副本',2,0,0,1,1,8004,5324,1,9440,9440,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(5501,'星灵副本',2,0,0,1,1,4880,4500,1,9440,9440,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(5502,'星灵副本',2,0,0,1,1,2498,2158,1,17400,15600,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(5600,'神之试炼',2,0,0,1,1,2405,864,1,6000,5689,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(5700,'荣耀战神',5,3,0,0,1,4880,4500,1,9440,9440,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[{\"id\":1,\"type\":1,\"list\":\"15:49,15:50,15:51,15:52,15:53,15:54,15:55,15:56,15:57,16:48,16:49,16:50,16:51,16:52,16:53,16:54,16:55,16:56,16:57,17:47,17:48,17:49,17:50,17:51,17:52,17:53,17:54,17:55,17:56,17:57,18:46,18:47,18:48,18:49,18:50,18:51,18:52,18:53,18:54,18:55,18:56,18:57,19:46,19:47,19:48,19:49,19:50,19:51,19:52,19:53,19:54,19:55,19:56,19:57,20:45,20:46,20:47,20:48,20:49,20:50,20:51,20:52,20:53,20:54,20:55,20:56,20:57,21:44,21:45,21:46,21:47,21:48,21:49,21:50,21:51,21:52,21:53,21:54,21:55,21:56,21:57,22:44,22:45,22:46,22:47,22:48,22:49,22:50,22:51,22:52,22:53,22:54,22:55,22:56,22:57,23:44,23:45,23:46,23:47,23:48,23:49,23:50,23:51,23:52,23:53,23:54,23:55,23:56,23:57,24:44,24:45,24:46,24:47,24:48,24:49,24:50,24:51,24:52,24:53,24:54,24:55,24:56,25:44,25:45,25:46,25:47,25:48,25:49,25:50,25:51,25:52,25:53,25:54,25:55,25:56,26:43,26:44,26:45,26:46,26:47,26:48,26:49,26:50,26:51,26:52,26:53,26:54,26:55,27:43,27:44,27:45,27:46,27:47,27:48,27:49,27:50,27:51,27:52,27:53,27:54,27:55,28:43,28:44,28:45,28:46,28:47,28:48,28:49,28:50,28:51,28:52,28:53,28:54,29:43,29:44,29:45,29:46,29:47,29:48,29:49,29:50,29:51,29:52,29:53,29:54,30:42,30:43,30:44,30:45,30:46,30:47,30:48,30:49,30:50,30:51,30:52,30:53,30:54,30:55,30:56,31:42,31:43,31:44,31:45,31:46,31:47,31:48,31:49,31:50,31:51,31:52,31:53,31:54,31:55,31:56,31:57,32:42,32:43,32:44,32:45,32:46,32:47,32:48,32:49,32:50,32:51,32:52,32:53,32:54,32:55,32:56,32:57,32:58,33:42,33:43,33:44,33:45,33:46,33:47,33:48,33:49,33:50,33:51,33:52,33:53,33:54,33:55,33:56,33:57,33:58,33:59,34:42,34:43,34:44,34:45,34:46,34:47,34:48,34:49,34:50,34:51,34:52,34:53,34:55,34:56,34:57,34:58,34:59,34:60,35:42,35:43,35:44,35:45,35:46,35:47,35:48,35:49,35:50,35:51,35:52,35:53,35:54,35:55,35:56,35:57,35:58,35:59,35:60,35:61,35:68,35:69,35:70,35:71,35:72,35:73,35:74,36:42,36:43,36:44,36:45,36:46,36:47,36:48,36:49,36:50,36:51,36:52,36:53,36:54,36:55,36:56,36:57,36:58,36:59,36:60,36:61,36:62,36:66,36:67,36:68,36:69,36:70,36:71,36:72,36:73,36:74,37:42,37:43,37:44,37:45,37:46,37:47,37:48,37:49,37:50,37:51,37:52,37:53,37:54,37:55,37:56,37:57,37:58,37:59,37:60,37:61,37:62,37:65,37:66,37:67,37:68,37:69,37:70,37:71,37:72,37:73,37:74,38:42,38:43,38:44,38:45,38:46,38:47,38:48,38:49,38:50,38:51,38:52,38:53,38:54,38:55,38:56,38:57,38:58,38:59,38:60,38:61,38:62,38:63,38:64,38:65,38:66,38:67,38:68,38:69,38:70,38:71,38:72,38:73,38:74,39:42,39:43,39:44,39:45,39:46,39:47,39:48,39:49,39:50,39:51,39:52,39:53,39:54,39:55,39:56,39:57,39:58,39:59,39:60,39:61,39:62,39:63,39:64,39:65,39:66,39:67,39:68,39:69,39:70,39:71,39:72,39:73,39:74,40:42,40:43,40:44,40:45,40:46,40:47,40:48,40:49,40:50,40:51,40:52,40:53,40:54,40:55,40:56,40:57,40:58,40:59,40:60,40:61,40:62,40:63,40:64,40:65,40:66,40:67,40:68,40:69,40:70,40:71,40:72,40:73,40:74,41:42,41:43,41:44,41:45,41:46,41:47,41:48,41:49,41:50,41:51,41:52,41:53,41:54,41:55,41:56,41:57,41:58,41:59,41:60,41:61,41:62,41:63,41:64,41:65,41:66,41:67,41:68,41:69,41:70,41:71,41:72,41:73,41:74,42:42,42:43,42:44,42:45,42:46,42:47,42:48,42:49,42:50,42:51,42:52,42:53,42:54,42:55,42:56,42:57,42:58,42:59,42:60,42:61,42:62,42:63,42:64,42:65,42:66,42:67,42:68,42:69,42:70,42:71,42:72,42:73,42:74,43:43,43:44,43:45,43:46,43:47,43:48,43:49,43:50,43:51,43:52,43:53,43:54,43:55,43:56,43:57,43:58,43:59,43:60,43:61,43:62,43:63,43:64,43:65,43:66,43:67,43:68,43:69,43:70,43:71,43:72,43:73,43:74,44:43,44:44,44:45,44:46,44:47,44:48,44:49,44:50,44:51,44:52,44:53,44:54,44:55,44:56,44:57,44:58,44:59,44:60,44:61,44:62,44:63,44:64,44:65,44:66,44:67,44:68,44:69,44:70,44:71,44:72,44:73,45:43,45:44,45:45,45:46,45:47,45:48,45:49,45:50,45:51,45:52,45:53,45:54,45:55,45:56,45:57,45:58,45:59,45:60,45:61,45:62,45:63,45:64,45:65,45:66,45:67,45:68,45:69,45:70,45:71,45:72,46:43,46:44,46:45,46:46,46:47,46:48,46:49,46:50,46:51,46:52,46:53,46:54,46:55,46:56,46:57,46:58,46:59,46:60,46:61,46:62,46:63,46:64,46:65,46:66,46:67,46:68,46:69,46:70,46:71,47:44,47:45,47:46,47:47,47:48,47:49,47:50,47:51,47:52,47:53,47:54,47:55,47:56,47:57,47:58,47:59,47:60,47:61,47:62,47:63,47:64,47:65,47:66,47:67,47:68,47:69,48:46,48:47,48:48,48:49,48:50,48:51,48:52,48:53,48:54,48:55,48:56,48:57,48:58,48:59,48:60,48:61,48:62,48:63,48:64,48:65,48:66,48:67,48:68,49:48,49:49,49:50,49:51,49:52,49:53,49:54,49:55,49:56,49:57,49:58,49:59,49:60,49:61,49:62,49:63,49:64,49:65,50:53,50:54,50:55,50:56,50:57,50:58,50:59,50:60,50:61,50:62\"}]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(5701,'荣耀战神',5,3,1,0,1,4880,4500,1,9440,9440,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[{\"id\":1,\"type\":1,\"list\":\"15:51,15:52,15:53,15:54,15:55,15:56,16:49,16:50,16:51,16:52,16:53,16:54,16:55,16:56,17:47,17:48,17:49,17:50,17:51,17:52,17:53,17:54,17:55,17:56,17:57,17:58,18:46,18:47,18:48,18:49,18:50,18:51,18:52,18:53,18:54,18:55,18:56,18:57,18:58,19:45,19:46,19:47,19:48,19:49,19:50,19:51,19:52,19:53,19:54,19:55,19:56,19:57,19:58,20:45,20:46,20:47,20:48,20:49,20:50,20:51,20:52,20:53,20:54,20:55,20:56,20:57,20:58,21:44,21:45,21:46,21:47,21:48,21:49,21:50,21:51,21:52,21:53,21:54,21:55,21:56,21:57,21:58,22:44,22:45,22:46,22:47,22:48,22:49,22:50,22:51,22:52,22:53,22:54,22:55,22:56,22:57,22:58,23:44,23:45,23:46,23:47,23:48,23:49,23:50,23:51,23:52,23:53,23:54,23:55,23:56,23:57,24:44,24:45,24:46,24:47,24:48,24:49,24:50,24:51,24:52,24:53,24:54,24:55,24:56,25:43,25:44,25:45,25:46,25:47,25:48,25:49,25:50,25:51,25:52,25:53,25:54,25:55,26:43,26:44,26:45,26:46,26:47,26:48,26:49,26:50,26:51,26:52,26:53,26:54,26:55,27:43,27:44,27:45,27:46,27:47,27:48,27:49,27:50,27:51,27:52,27:53,27:54,27:55,28:43,28:44,28:45,28:46,28:47,28:48,28:49,28:50,28:51,28:52,28:53,28:54,29:42,29:43,29:44,29:45,29:46,29:47,29:48,29:49,29:50,29:51,29:52,29:53,29:54,29:55,30:42,30:43,30:44,30:45,30:46,30:47,30:48,30:49,30:50,30:51,30:52,30:53,30:54,30:55,30:56,31:42,31:43,31:44,31:45,31:46,31:47,31:48,31:49,31:50,31:51,31:52,31:53,31:54,31:55,31:56,31:57,32:42,32:43,32:44,32:45,32:46,32:47,32:48,32:49,32:50,32:51,32:52,32:53,32:54,32:55,32:56,32:57,32:58,33:42,33:43,33:44,33:45,33:46,33:47,33:48,33:49,33:50,33:51,33:52,33:53,33:54,33:55,33:56,33:57,33:58,33:59,34:42,34:43,34:44,34:45,34:46,34:47,34:48,34:49,34:50,34:51,34:52,34:53,34:54,34:55,34:56,34:57,34:58,34:59,34:60,34:70,34:71,34:72,34:73,34:74,34:75,35:42,35:43,35:44,35:45,35:46,35:47,35:48,35:49,35:50,35:51,35:52,35:53,35:54,35:55,35:56,35:57,35:58,35:59,35:60,35:61,35:68,35:69,35:70,35:71,35:72,35:73,35:74,35:75,36:42,36:43,36:44,36:45,36:46,36:47,36:48,36:49,36:50,36:51,36:52,36:53,36:54,36:55,36:56,36:57,36:58,36:59,36:60,36:61,36:62,36:66,36:67,36:68,36:69,36:70,36:71,36:72,36:73,36:74,36:75,37:42,37:43,37:44,37:45,37:46,37:47,37:48,37:49,37:50,37:51,37:52,37:53,37:54,37:55,37:56,37:57,37:58,37:59,37:60,37:61,37:62,37:64,37:65,37:66,37:67,37:68,37:69,37:70,37:71,37:72,37:73,37:74,37:75,38:42,38:43,38:44,38:45,38:46,38:47,38:48,38:49,38:50,38:51,38:52,38:53,38:54,38:55,38:56,38:57,38:58,38:59,38:60,38:61,38:62,38:63,38:64,38:65,38:66,38:67,38:68,38:69,38:70,38:71,38:72,38:73,38:74,38:75,39:42,39:43,39:44,39:45,39:46,39:47,39:48,39:49,39:50,39:51,39:52,39:53,39:54,39:55,39:56,39:57,39:58,39:59,39:60,39:61,39:62,39:63,39:64,39:65,39:66,39:67,39:68,39:69,39:70,39:71,39:72,39:73,39:74,40:42,40:43,40:44,40:45,40:46,40:47,40:48,40:49,40:50,40:51,40:52,40:53,40:54,40:55,40:56,40:57,40:58,40:59,40:60,40:61,40:62,40:63,40:64,40:65,40:66,40:67,40:68,40:69,40:70,40:71,40:72,40:73,41:42,41:43,41:44,41:45,41:46,41:47,41:48,41:49,41:50,41:51,41:52,41:53,41:54,41:55,41:56,41:57,41:58,41:59,41:60,41:61,41:62,41:63,41:64,41:65,41:66,41:67,41:68,41:69,41:70,41:71,41:72,42:43,42:44,42:45,42:46,42:47,42:48,42:49,42:50,42:51,42:52,42:53,42:54,42:55,42:56,42:57,42:58,42:59,42:60,42:61,42:62,42:63,42:64,42:65,42:66,42:67,42:68,42:69,42:70,42:71,43:44,43:45,43:46,43:47,43:48,43:49,43:50,43:51,43:52,43:53,43:54,43:55,43:56,43:57,43:58,43:59,43:60,43:61,43:62,43:63,43:64,43:65,43:66,43:67,43:68,43:69,43:70,43:71,44:44,44:45,44:46,44:47,44:48,44:49,44:50,44:51,44:52,44:53,44:54,44:55,44:56,44:57,44:58,44:59,44:60,44:61,44:62,44:63,44:64,44:65,44:66,44:67,44:68,44:69,44:70,44:71,45:45,45:46,45:47,45:48,45:49,45:50,45:51,45:52,45:53,45:54,45:55,45:56,45:57,45:58,45:59,45:60,45:61,45:62,45:63,45:64,45:65,45:66,45:67,45:68,45:69,45:70,45:71,46:46,46:47,46:48,46:49,46:50,46:51,46:52,46:53,46:54,46:55,46:56,46:57,46:58,46:59,46:60,46:61,46:62,46:63,46:64,46:65,46:66,46:67,46:68,46:69,46:70,47:47,47:48,47:49,47:50,47:51,47:52,47:53,47:54,47:55,47:56,47:57,47:58,47:59,47:60,47:61,47:62,47:63,47:64,47:65,47:66,47:67,47:68,48:49,48:50,48:51,48:52,48:53,48:54,48:55,48:56,48:57,48:58,48:59,48:60,48:61,48:62,48:63,48:64,48:65,48:66,49:55,49:56,49:57,49:58,49:59,49:60,49:61\"}]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(5800,'大乱斗',11,2,0,0,1,4880,4500,1,29547,30694,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"1\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(5801,'大乱斗',11,2,0,0,1,6406,14488,1,29547,30694,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"2\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(5802,'大乱斗',11,2,1,0,1,6406,14488,1,29547,30694,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"2\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(5803,'大乱斗',11,2,0,0,1,12651,4495,1,24600,22500,'[{\"x\":19697,\"y\":5701,\"name\":\"天空树二层\",\"px\":17395,\"py\":9740,\"id\":58002,\"index\":1},{\"x\":21607,\"y\":15815,\"name\":\"天空树三层\",\"px\":4214,\"py\":17861,\"id\":58003,\"index\":2},{\"x\":8936,\"y\":14760,\"name\":\"天空树顶层\",\"px\":2785,\"py\":4882,\"id\":58012,\"index\":3},{\"x\":1594,\"y\":19400,\"name\":\"天空树二层\",\"px\":17173,\"py\":10358,\"id\":580102,\"index\":4},{\"x\":3402,\"y\":5665,\"name\":\"天空树三层\",\"px\":3287,\"py\":21024,\"id\":580103,\"index\":5},{\"x\":17139,\"y\":8737,\"name\":\"天空树底层\",\"px\":12419,\"py\":4393,\"id\":580101,\"index\":6}]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1','[]','[{\"id\":1,\"type\":1,\"list\":\"189:60,189:61,189:62,189:63,189:64,189:65,190:58,190:59,190:60,191:56,191:57,191:58,192:56,193:55,193:56,194:55,195:55,196:54,196:55,197:54,198:54,199:54,200:54,201:54,202:54,203:54,204:54,204:55,205:55,206:55,207:55,207:56,208:56\"},{\"id\":2,\"type\":1,\"list\":\"203:169,203:170,203:171,204:164,204:165,204:166,204:167,204:168,205:163,205:164,206:161,206:162,207:159,207:160,207:161,208:158,208:159,209:157,209:158,210:156,210:157,211:154,211:155,211:156,212:153,212:154,213:152,213:153,214:152,215:151,215:152,216:151,217:151,218:150,218:151,219:149,219:150,220:149,221:148,221:149,222:147,222:148,223:147,224:146,224:147,225:146,226:146,227:146,228:145,228:146,229:145,230:145,231:145,232:145,233:145,234:145,235:144,235:145\"},{\"id\":3,\"type\":1,\"list\":\"73:144,74:144,74:145,75:146,75:147,75:148,75:149,76:150,76:151,77:151,77:152,77:153,78:153,79:154,80:154,81:154,82:154,82:155,83:155,84:155,85:155,86:155,87:155,88:155,89:155,89:156,90:156,91:156,92:156,93:156,94:156,95:156,96:156,97:156,98:155,99:155,100:155,101:154,101:155,102:154,103:154,104:154,105:154\"}]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"2\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(5811,'三英会战',21,2,0,1,1,11308,10285,1,20800,23100,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n','[]','[{\"id\":1,\"type\":0,\"list\":\"39:56,39:57,40:55,40:56,40:57,41:54,41:55,41:56,41:57,41:58,42:54,42:55,42:56,42:57,42:58,42:65,42:66,43:53,43:54,43:55,43:56,43:57,43:58,43:59,43:60,43:61,43:62,43:63,43:64,43:65,43:66,44:52,44:53,44:54,44:55,44:56,44:57,44:58,44:59,44:60,44:61,44:62,44:63,44:64,44:65,44:66,44:67,45:52,45:53,45:54,45:55,45:56,45:57,45:58,45:59,45:60,45:61,45:62,45:63,45:64,45:65,45:66,45:67,45:68,46:52,46:53,46:54,46:55,46:56,46:57,46:58,46:59,46:60,46:61,46:62,46:63,46:64,46:65,46:66,46:67,46:68,46:69,47:51,47:52,47:53,47:54,47:55,47:56,47:57,47:58,47:59,47:60,47:61,47:62,47:63,47:64,47:65,47:66,47:67,47:68,48:50,48:51,48:52,48:53,48:54,48:55,48:56,48:57,48:58,48:59,48:60,48:61,48:62,48:63,48:64,48:65,48:66,48:67,48:68,49:49,49:50,49:51,49:52,49:53,49:54,49:55,49:56,49:57,49:58,49:59,49:60,49:61,49:62,49:63,49:64,49:65,49:66,49:67,50:49,50:50,50:51,50:52,50:53,50:54,50:55,50:56,50:57,50:58,50:59,50:60,50:61,50:62,50:63,50:64,50:65,50:66,51:48,51:49,51:50,51:51,51:52,51:53,51:54,51:55,51:56,51:57,51:58,51:59,51:60,51:61,51:62,51:63,51:64,51:65,51:66,52:50,52:51,52:52,52:53,52:54,52:55,52:56,52:57,52:58,52:59,52:60,52:61,52:62,52:63,52:64,52:65,53:50,53:51,53:52,53:53,53:54,53:55,53:56,53:57,53:58,53:59,53:60,53:61,53:62,53:63,53:64,54:53,54:54,54:55,54:56,54:57,54:58,54:59,54:60,54:61,54:62,54:63,55:54,55:55,55:56,55:57,55:58,55:59,55:60,55:61,55:62,56:55,56:56,56:57,56:58,56:59,56:60,56:61,57:56,57:57,57:58,57:59,57:60,57:61,58:58,58:59,58:60\"},{\"id\":2,\"type\":0,\"list\":\"51:161,51:162,51:163,52:158,52:159,52:160,52:161,52:162,52:163,52:164,53:157,53:158,53:159,53:160,53:161,53:162,53:163,53:164,54:154,54:155,54:156,54:157,54:158,54:159,54:160,54:161,54:162,54:163,54:164,54:165,54:166,55:152,55:153,55:154,55:155,55:156,55:157,55:158,55:159,55:160,55:161,55:162,55:163,55:164,55:165,55:166,55:167,56:150,56:151,56:152,56:153,56:154,56:155,56:156,56:157,56:158,56:159,56:160,56:161,56:162,56:163,56:164,56:165,56:166,56:167,57:151,57:152,57:153,57:154,57:155,57:156,57:157,57:158,57:159,57:160,57:161,57:162,57:163,57:164,57:165,57:166,57:167,57:168,58:151,58:152,58:153,58:154,58:155,58:156,58:157,58:158,58:159,58:160,58:161,58:162,58:163,58:164,58:165,58:166,58:167,58:168,59:151,59:152,59:153,59:154,59:155,59:156,59:157,59:158,59:159,59:160,59:161,59:162,59:163,59:164,59:165,59:166,59:167,59:168,59:169,60:152,60:153,60:154,60:155,60:156,60:157,60:158,60:159,60:160,60:161,60:162,60:163,60:164,60:165,60:166,60:167,60:168,60:169,61:152,61:153,61:154,61:155,61:156,61:157,61:158,61:159,61:160,61:161,61:162,61:163,61:164,61:165,61:166,61:167,61:168,61:169,61:170,62:153,62:154,62:155,62:156,62:157,62:158,62:159,62:160,62:161,62:162,62:163,62:164,62:165,62:166,62:167,62:168,62:169,62:170,63:153,63:154,63:155,63:156,63:157,63:158,63:159,63:160,63:161,63:162,63:163,63:164,63:165,63:166,63:167,63:168,63:169,63:170,63:171,64:154,64:155,64:156,64:157,64:158,64:159,64:160,64:161,64:162,64:163,64:164,64:165,64:166,64:167,64:168,64:169,64:170,64:171,65:154,65:155,65:156,65:157,65:158,65:159,65:160,65:161,65:162,65:163,65:164,65:165,65:166,65:167,65:168,65:169,66:155,66:156,66:157,66:158,66:159,66:160,66:161,66:162,66:163,66:164,66:165,66:166,66:167,66:168,67:155,67:156,67:157,67:158,67:159,67:160,67:161,67:162,67:163,67:164,67:165,67:166,68:156,68:157,68:158,68:159,68:160,68:161,68:162,68:163,68:164,69:157,69:158,69:159,69:160,69:161,69:162,69:163,70:157,70:158,70:159,70:160,70:161,71:158,71:159,72:158\"},{\"id\":3,\"type\":0,\"list\":\"141:90,141:91,141:92,141:93,141:94,141:95,141:96,141:97,141:98,141:99,141:100,141:101,142:90,142:91,142:92,142:93,142:94,142:95,142:96,142:97,142:98,142:99,142:100,142:101,142:102,143:90,143:91,143:92,143:93,143:94,143:95,143:96,143:97,143:98,143:99,143:100,143:101,143:102,144:90,144:91,144:92,144:93,144:94,144:95,144:96,144:97,144:98,144:99,144:100,144:101,145:90,145:91,145:92,145:93,145:94,145:95,145:96,145:97,145:98,145:99,145:100,145:101,145:102,146:89,146:90,146:91,146:92,146:93,146:94,146:95,146:96,146:97,146:98,146:99,146:100,146:101,146:102,147:89,147:90,147:91,147:92,147:93,147:94,147:95,147:96,147:97,147:98,147:99,147:100,147:101,147:102,148:89,148:90,148:91,148:92,148:93,148:94,148:95,148:96,148:97,148:98,148:99,148:100,148:101,148:102,149:88,149:89,149:90,149:91,149:92,149:93,149:94,149:95,149:96,149:97,149:98,149:99,149:100,149:101,149:102,150:88,150:89,150:90,150:91,150:92,150:93,150:94,150:95,150:96,150:97,150:98,150:99,150:100,151:88,151:89,151:90,151:91,151:92,151:93,151:94,151:95,151:96,151:97,151:98,151:99,151:100,152:87,152:88,152:89,152:90,152:91,152:92,152:93,152:94,152:95,152:96,152:97,152:98,152:99,152:100,153:87,153:88,153:89,153:90,153:91,153:92,153:93,153:94,153:95,153:96,153:97,153:98,153:99,153:100,154:86,154:87,154:88,154:89,154:90,154:91,154:92,154:93,154:94,154:95,154:96,154:97,154:98,154:99,154:100,155:86,155:87,155:88,155:89,155:90,155:91,155:92,155:93,155:94,155:95,155:96,155:97,155:98,155:99,155:100,156:86,156:87,156:88,156:89,156:90,156:91,156:92,156:93,156:94,156:95,156:96,156:97,156:98,156:99,156:100,157:85,157:86,157:87,157:88,157:89,157:90,157:91,157:92,157:93,157:94,157:95,157:96,157:97,157:98,157:99\"},{\"id\":4,\"type\":1,\"list\":\"62:77,62:78,63:76,63:77,63:78,63:79,64:75,64:76,64:77,64:78,64:79,64:80,65:75,65:76,65:77,65:78,65:79,65:80,66:76,66:77,66:78,66:79,67:77,67:78,70:138,70:139,71:137,71:138,71:139,71:140,72:136,72:137,72:138,72:139,72:140,72:141,73:136,73:137,73:138,73:139,73:140,73:141,74:137,74:138,74:139,74:140,75:138,75:139,79:100,79:101,79:102,79:103,79:107,79:108,79:109,79:110,79:111,80:100,80:101,80:102,80:103,80:104,80:107,80:108,80:109,80:110,80:111,81:100,81:101,81:102,81:103,81:104,81:107,81:108,81:109,81:110,81:111,82:100,82:101,82:102,82:103,82:104,82:107,82:108,82:109,82:110,82:111,83:100,83:101,84:103,84:104,84:105,84:106,84:107,84:108,85:97,85:98,85:99,85:100,85:103,85:104,85:105,85:106,85:107,85:108,85:110,85:111,85:112,85:113,86:97,86:98,86:99,86:100,86:102,86:103,86:104,86:105,86:106,86:107,86:108,86:110,86:111,86:112,86:113,86:114,87:97,87:98,87:99,87:100,87:102,87:103,87:104,87:105,87:106,87:107,87:108,87:110,87:111,87:112,87:113,87:114,88:97,88:98,88:99,88:100,88:103,88:104,88:105,88:106,88:107,88:108,88:110,88:111,88:112,88:113,88:114,89:98,89:99,89:100,89:103,89:104,89:105,89:106,89:107,89:108,89:110,89:111,89:112,89:113,91:101,91:102,91:103,91:106,91:107,91:108,91:109,91:110,92:100,92:101,92:102,92:103,92:104,92:106,92:107,92:108,92:109,92:110,93:100,93:101,93:102,93:103,93:104,93:106,93:107,93:108,93:109,93:110,94:101,94:102,94:103,94:104,94:106,94:107,94:108,94:109,94:110,121:98,121:99,121:100,122:97,122:98,122:99,122:100,122:101,123:97,123:98,123:99,123:100,123:101,124:97,124:98,124:99,124:100,124:101,125:98,125:99,125:100\"}]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"2\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]');
INSERT INTO `base_scene` VALUES (5812,'三英会战',21,2,1,1,1,11308,10285,1,20800,23100,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n','[]','[{\"id\":1,\"type\":0,\"list\":\"39:56,39:57,40:55,40:56,40:57,41:54,41:55,41:56,41:57,41:58,42:54,42:55,42:56,42:57,42:58,42:65,42:66,43:53,43:54,43:55,43:56,43:57,43:58,43:59,43:60,43:61,43:62,43:63,43:64,43:65,43:66,44:52,44:53,44:54,44:55,44:56,44:57,44:58,44:59,44:60,44:61,44:62,44:63,44:64,44:65,44:66,44:67,45:52,45:53,45:54,45:55,45:56,45:57,45:58,45:59,45:60,45:61,45:62,45:63,45:64,45:65,45:66,45:67,45:68,46:52,46:53,46:54,46:55,46:56,46:57,46:58,46:59,46:60,46:61,46:62,46:63,46:64,46:65,46:66,46:67,46:68,46:69,47:51,47:52,47:53,47:54,47:55,47:56,47:57,47:58,47:59,47:60,47:61,47:62,47:63,47:64,47:65,47:66,47:67,47:68,48:50,48:51,48:52,48:53,48:54,48:55,48:56,48:57,48:58,48:59,48:60,48:61,48:62,48:63,48:64,48:65,48:66,48:67,48:68,49:49,49:50,49:51,49:52,49:53,49:54,49:55,49:56,49:57,49:58,49:59,49:60,49:61,49:62,49:63,49:64,49:65,49:66,49:67,50:49,50:50,50:51,50:52,50:53,50:54,50:55,50:56,50:57,50:58,50:59,50:60,50:61,50:62,50:63,50:64,50:65,50:66,51:48,51:49,51:50,51:51,51:52,51:53,51:54,51:55,51:56,51:57,51:58,51:59,51:60,51:61,51:62,51:63,51:64,51:65,51:66,52:50,52:51,52:52,52:53,52:54,52:55,52:56,52:57,52:58,52:59,52:60,52:61,52:62,52:63,52:64,52:65,53:50,53:51,53:52,53:53,53:54,53:55,53:56,53:57,53:58,53:59,53:60,53:61,53:62,53:63,53:64,54:53,54:54,54:55,54:56,54:57,54:58,54:59,54:60,54:61,54:62,54:63,55:54,55:55,55:56,55:57,55:58,55:59,55:60,55:61,55:62,56:55,56:56,56:57,56:58,56:59,56:60,56:61,57:56,57:57,57:58,57:59,57:60,57:61,58:58,58:59,58:60\"},{\"id\":2,\"type\":0,\"list\":\"51:161,51:162,51:163,52:158,52:159,52:160,52:161,52:162,52:163,52:164,53:157,53:158,53:159,53:160,53:161,53:162,53:163,53:164,54:154,54:155,54:156,54:157,54:158,54:159,54:160,54:161,54:162,54:163,54:164,54:165,54:166,55:152,55:153,55:154,55:155,55:156,55:157,55:158,55:159,55:160,55:161,55:162,55:163,55:164,55:165,55:166,55:167,56:150,56:151,56:152,56:153,56:154,56:155,56:156,56:157,56:158,56:159,56:160,56:161,56:162,56:163,56:164,56:165,56:166,56:167,57:151,57:152,57:153,57:154,57:155,57:156,57:157,57:158,57:159,57:160,57:161,57:162,57:163,57:164,57:165,57:166,57:167,57:168,58:151,58:152,58:153,58:154,58:155,58:156,58:157,58:158,58:159,58:160,58:161,58:162,58:163,58:164,58:165,58:166,58:167,58:168,59:151,59:152,59:153,59:154,59:155,59:156,59:157,59:158,59:159,59:160,59:161,59:162,59:163,59:164,59:165,59:166,59:167,59:168,59:169,60:152,60:153,60:154,60:155,60:156,60:157,60:158,60:159,60:160,60:161,60:162,60:163,60:164,60:165,60:166,60:167,60:168,60:169,61:152,61:153,61:154,61:155,61:156,61:157,61:158,61:159,61:160,61:161,61:162,61:163,61:164,61:165,61:166,61:167,61:168,61:169,61:170,62:153,62:154,62:155,62:156,62:157,62:158,62:159,62:160,62:161,62:162,62:163,62:164,62:165,62:166,62:167,62:168,62:169,62:170,63:153,63:154,63:155,63:156,63:157,63:158,63:159,63:160,63:161,63:162,63:163,63:164,63:165,63:166,63:167,63:168,63:169,63:170,63:171,64:154,64:155,64:156,64:157,64:158,64:159,64:160,64:161,64:162,64:163,64:164,64:165,64:166,64:167,64:168,64:169,64:170,64:171,65:154,65:155,65:156,65:157,65:158,65:159,65:160,65:161,65:162,65:163,65:164,65:165,65:166,65:167,65:168,65:169,66:155,66:156,66:157,66:158,66:159,66:160,66:161,66:162,66:163,66:164,66:165,66:166,66:167,66:168,67:155,67:156,67:157,67:158,67:159,67:160,67:161,67:162,67:163,67:164,67:165,67:166,68:156,68:157,68:158,68:159,68:160,68:161,68:162,68:163,68:164,69:157,69:158,69:159,69:160,69:161,69:162,69:163,70:157,70:158,70:159,70:160,70:161,71:158,71:159,72:158\"},{\"id\":3,\"type\":0,\"list\":\"141:90,141:91,141:92,141:93,141:94,141:95,141:96,141:97,141:98,141:99,141:100,141:101,142:90,142:91,142:92,142:93,142:94,142:95,142:96,142:97,142:98,142:99,142:100,142:101,142:102,143:90,143:91,143:92,143:93,143:94,143:95,143:96,143:97,143:98,143:99,143:100,143:101,143:102,144:90,144:91,144:92,144:93,144:94,144:95,144:96,144:97,144:98,144:99,144:100,144:101,145:90,145:91,145:92,145:93,145:94,145:95,145:96,145:97,145:98,145:99,145:100,145:101,145:102,146:89,146:90,146:91,146:92,146:93,146:94,146:95,146:96,146:97,146:98,146:99,146:100,146:101,146:102,147:89,147:90,147:91,147:92,147:93,147:94,147:95,147:96,147:97,147:98,147:99,147:100,147:101,147:102,148:89,148:90,148:91,148:92,148:93,148:94,148:95,148:96,148:97,148:98,148:99,148:100,148:101,148:102,149:88,149:89,149:90,149:91,149:92,149:93,149:94,149:95,149:96,149:97,149:98,149:99,149:100,149:101,149:102,150:88,150:89,150:90,150:91,150:92,150:93,150:94,150:95,150:96,150:97,150:98,150:99,150:100,151:88,151:89,151:90,151:91,151:92,151:93,151:94,151:95,151:96,151:97,151:98,151:99,151:100,152:87,152:88,152:89,152:90,152:91,152:92,152:93,152:94,152:95,152:96,152:97,152:98,152:99,152:100,153:87,153:88,153:89,153:90,153:91,153:92,153:93,153:94,153:95,153:96,153:97,153:98,153:99,153:100,154:86,154:87,154:88,154:89,154:90,154:91,154:92,154:93,154:94,154:95,154:96,154:97,154:98,154:99,154:100,155:86,155:87,155:88,155:89,155:90,155:91,155:92,155:93,155:94,155:95,155:96,155:97,155:98,155:99,155:100,156:86,156:87,156:88,156:89,156:90,156:91,156:92,156:93,156:94,156:95,156:96,156:97,156:98,156:99,156:100,157:85,157:86,157:87,157:88,157:89,157:90,157:91,157:92,157:93,157:94,157:95,157:96,157:97,157:98,157:99\"},{\"id\":4,\"type\":1,\"list\":\"62:77,62:78,63:76,63:77,63:78,63:79,64:75,64:76,64:77,64:78,64:79,64:80,65:75,65:76,65:77,65:78,65:79,65:80,66:76,66:77,66:78,66:79,67:77,67:78,70:138,70:139,71:137,71:138,71:139,71:140,72:136,72:137,72:138,72:139,72:140,72:141,73:136,73:137,73:138,73:139,73:140,73:141,74:137,74:138,74:139,74:140,75:138,75:139,79:100,79:101,79:102,79:103,79:107,79:108,79:109,79:110,79:111,80:100,80:101,80:102,80:103,80:104,80:107,80:108,80:109,80:110,80:111,81:100,81:101,81:102,81:103,81:104,81:107,81:108,81:109,81:110,81:111,82:100,82:101,82:102,82:103,82:104,82:107,82:108,82:109,82:110,82:111,83:100,83:101,84:103,84:104,84:105,84:106,84:107,84:108,85:97,85:98,85:99,85:100,85:103,85:104,85:105,85:106,85:107,85:108,85:110,85:111,85:112,85:113,86:97,86:98,86:99,86:100,86:102,86:103,86:104,86:105,86:106,86:107,86:108,86:110,86:111,86:112,86:113,86:114,87:97,87:98,87:99,87:100,87:102,87:103,87:104,87:105,87:106,87:107,87:108,87:110,87:111,87:112,87:113,87:114,88:97,88:98,88:99,88:100,88:103,88:104,88:105,88:106,88:107,88:108,88:110,88:111,88:112,88:113,88:114,89:98,89:99,89:100,89:103,89:104,89:105,89:106,89:107,89:108,89:110,89:111,89:112,89:113,91:101,91:102,91:103,91:106,91:107,91:108,91:109,91:110,92:100,92:101,92:102,92:103,92:104,92:106,92:107,92:108,92:109,92:110,93:100,93:101,93:102,93:103,93:104,93:106,93:107,93:108,93:109,93:110,94:101,94:102,94:103,94:104,94:106,94:107,94:108,94:109,94:110,121:98,121:99,121:100,122:97,122:98,122:99,122:100,122:101,123:97,123:98,123:99,123:100,123:101,124:97,124:98,124:99,124:100,124:101,125:98,125:99,125:100\"}]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(5900,'魂珠副本',2,0,0,1,1,4483,4255,1,9440,9440,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(6000,'3v3',12,2,1,1,1,1600,1900,0,16500,14800,'[]','{}','[6100011, 12893, 3455, 1, 1] ,[6100010, 2752, 9355, 1, 1]','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"1\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(6001,'3v3',2,0,0,0,1,4880,4500,1,9440,9440,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(6002,'3v3',2,0,0,0,1,4880,4500,1,9440,9440,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(6003,'3v3',2,0,0,0,1,4880,4500,1,9440,9440,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(6200,'跨服入侵',1,0,0,0,1,5504,6337,1,17400,17400,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(6201,'跨服入侵',16,0,1,0,1,9639,4755,0,17800,16400,'[]','{}','[6200106, 11517, 12887, 1, 1] ,[6200106, 11095, 12298, 1, 1] ,[6200106, 11451, 12301, 1, 1] ,[6200106, 11227, 12632, 1, 1] ,[6200106, 10850, 12835, 1, 1] ,[6200106, 10850, 12498, 1, 1] ,[6200106, 11167, 12980, 1, 1] ,[6200106, 11603, 12556, 1, 1] ,[6200105, 8482, 12384, 1, 1] ,[6200105, 8111, 12355, 1, 1] ,[6200105, 7888, 12604, 1, 1] ,[6200105, 8647, 12661, 1, 1] ,[6200105, 8292, 12689, 1, 1] ,[6200105, 7938, 12912, 1, 1] ,[6200105, 8559, 12961, 1, 1] ,[6200105, 8265, 13026, 1, 1] ,[6200101, 5154, 5033, 1, 1] ,[6200101, 4998, 4783, 1, 1] ,[6200101, 4696, 4689, 1, 1] ,[6200101, 4768, 5116, 1, 1] ,[6200101, 5064, 5329, 1, 1] ,[6200101, 4744, 5457, 1, 1] ,[6200101, 4381, 5283, 1, 1] ,[6200101, 4447, 4932, 1, 1] ,[6200100, 9382, 2517, 1, 1] ,[6200100, 9861, 2590, 1, 1] ,[6200100, 10017, 2880, 1, 1] ,[6200100, 9570, 2881, 1, 1] ,[6200100, 9109, 2826, 1, 1] ,[6200100, 9954, 3264, 1, 1] ,[6200100, 9567, 3299, 1, 1] ,[6200100, 9227, 3178, 1, 1] ,[6200109, 13960, 5293, 1, 1] ,[6200109, 14361, 5315, 1, 1] ,[6200109, 14609, 5071, 1, 1] ,[6200109, 14616, 4774, 1, 1] ,[6200109, 14238, 4937, 1, 1] ,[6200109, 13956, 4644, 1, 1] ,[6200109, 14320, 4579, 1, 1] ,[6200109, 13846, 4947, 1, 1] ','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"3\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(6202,'世界主城',17,0,1,0,1,4880,4500,1,9440,9440,'[{\"x\":4397,\"y\":2661,\"name\":\"首领会所4层\",\"px\":0,\"py\":0,\"id\":1254,\"index\":4},{\"x\":5368,\"y\":2634,\"name\":\"首领会所5层\",\"px\":0,\"py\":0,\"id\":1255,\"index\":5},{\"x\":6428,\"y\":4084,\"name\":\"首领会所6层\",\"px\":0,\"py\":0,\"id\":1256,\"index\":6},{\"x\":6441,\"y\":5170,\"name\":\"混乱魔域2层\",\"px\":0,\"py\":0,\"id\":1302,\"index\":8},{\"x\":5315,\"y\":6126,\"name\":\"混乱魔域3层\",\"px\":0,\"py\":0,\"id\":1303,\"index\":9},{\"x\":4309,\"y\":6126,\"name\":\"跨服入侵\",\"px\":0,\"py\":0,\"id\":6201,\"index\":10},{\"x\":2967,\"y\":5126,\"name\":\"首领会所1层\",\"px\":0,\"py\":0,\"id\":1251,\"index\":1},{\"x\":2961,\"y\":4472,\"name\":\"首领会所2层\",\"px\":0,\"py\":0,\"id\":1252,\"index\":2},{\"x\":3162,\"y\":3693,\"name\":\"首领会所3层\",\"px\":0,\"py\":0,\"id\":1253,\"index\":3},{\"x\":6539,\"y\":4603,\"name\":\"混乱魔域1层\",\"px\":0,\"py\":0,\"id\":1301,\"index\":7}]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(6300,'boss',3,0,1,0,1,4880,4500,1,9440,9440,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"1\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(6301,'时空乱流1层',19,0,1,0,1,7300,2500,1,24005,18002,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,0,0,0,0,1,1,1,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,5,5,5,5,5,5,5,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,5,5,5,5,5,5,5,5,5,5,5,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n','[]','[{\"id\":1,\"type\":1,\"list\":\"49:41,49:42,50:41,50:42,50:43,50:44,51:41,51:42,51:43,51:44,51:45,52:42,52:43,52:44,52:45,52:46,53:43,53:44,53:45,53:46,53:47,54:44,54:45,54:46,54:47,54:48,55:45,55:46,55:47,55:48,55:49,56:46,56:47,56:48,56:49,57:47,57:48,78:103,78:104,79:103,79:104,80:102,80:103,80:104,81:103,81:104,81:105,82:104,82:105,83:104,83:105,84:104,84:105,84:106,85:104,85:105,85:106,86:105,86:106,87:105,87:106,87:107,88:105,88:106,88:107,89:106,89:107,90:106,90:107\"},{\"id\":2,\"type\":1,\"list\":\"102:34,103:31,103:32,103:33,103:34,103:35,104:29,104:30,104:31,104:32,104:33,104:34,105:27,105:28,105:29,105:30,105:31,105:32,106:25,106:26,106:27,106:28,106:29,107:23,107:24,107:25,107:26,107:27,107:28,108:22,108:23,108:24,108:25,109:22\"},{\"id\":3,\"type\":1,\"list\":\"110:126,110:127,111:126,111:127,112:126,112:127,113:126,113:127,114:126,114:127,115:126,115:127,116:126,116:127,117:126,117:127,118:126,118:127,119:126,119:127,120:126,120:127,121:126,121:127,122:126,122:127,123:126,123:127,124:126,124:127,125:126,125:127\"},{\"id\":4,\"type\":1,\"list\":\"148:76,149:75,149:76,149:77,150:74,150:75,150:76,151:73,151:74,151:75,152:72,152:73,152:74,152:75,153:71,153:72,153:73,153:74,154:71,154:72,154:73,155:70,155:71,155:72,156:69,156:70,156:71,156:72,157:69,157:70,157:71,158:68,158:69,158:70,159:68\"},{\"id\":5,\"type\":1,\"list\":\"176:125,176:126,176:127,176:128,177:127,177:128,177:129,178:128,178:129,178:130,179:129,179:130,179:131,180:130,180:131,180:132,181:131,181:132,181:133,182:132,182:133,182:134,183:133,183:134,183:135,184:134,184:135,184:136,185:135,185:136,185:137,191:105,191:106,191:107,192:104,192:105,192:106,193:103,193:104,193:105,194:101,194:102,194:103,194:104,195:100,195:101,195:102,195:103,196:99,196:100,196:101,196:102,197:97,197:98,197:99,197:100,198:97,198:98,198:99,199:96,199:97\"}]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"3\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(6302,'时空乱流2层',19,0,1,0,1,7300,2500,1,24005,18002,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,0,0,0,0,1,1,1,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,5,5,5,5,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,5,5,5,5,5,5,5,5,5,5,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,1,5,5,5,5,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n','[]','[{\"id\":1,\"type\":1,\"list\":\"49:41,49:42,50:41,50:42,50:43,50:44,51:41,51:42,51:43,51:44,51:45,52:42,52:43,52:44,52:45,52:46,53:43,53:44,53:45,53:46,53:47,54:44,54:45,54:46,54:47,54:48,55:45,55:46,55:47,55:48,55:49,56:46,56:47,56:48,56:49,57:47,57:48,78:103,78:104,79:103,79:104,80:102,80:103,80:104,81:103,81:104,81:105,82:104,82:105,83:104,83:105,84:104,84:105,84:106,85:104,85:105,85:106,86:105,86:106,87:105,87:106,87:107,88:105,88:106,88:107,89:106,89:107,90:106,90:107\"},{\"id\":2,\"type\":1,\"list\":\"102:34,103:31,103:32,103:33,103:34,103:35,104:29,104:30,104:31,104:32,104:33,104:34,105:27,105:28,105:29,105:30,105:31,105:32,106:25,106:26,106:27,106:28,106:29,107:23,107:24,107:25,107:26,107:27,107:28,108:22,108:23,108:24,108:25,109:22\"},{\"id\":3,\"type\":1,\"list\":\"110:126,110:127,111:126,111:127,112:126,112:127,113:126,113:127,114:126,114:127,115:126,115:127,116:126,116:127,117:126,117:127,118:126,118:127,119:126,119:127,120:126,120:127,121:126,121:127,122:126,122:127,123:126,123:127,124:126,124:127,125:126,125:127\"},{\"id\":4,\"type\":1,\"list\":\"148:76,149:75,149:76,149:77,150:74,150:75,150:76,151:73,151:74,151:75,152:72,152:73,152:74,152:75,153:71,153:72,153:73,153:74,154:71,154:72,154:73,155:70,155:71,155:72,156:69,156:70,156:71,156:72,157:69,157:70,157:71,158:68,158:69,158:70,159:68\"},{\"id\":5,\"type\":1,\"list\":\"176:125,176:126,176:127,176:128,177:127,177:128,177:129,178:128,178:129,178:130,179:129,179:130,179:131,180:130,180:131,180:132,181:131,181:132,181:133,182:132,182:133,182:134,183:133,183:134,183:135,184:134,184:135,184:136,185:135,185:136,185:137,191:105,191:106,191:107,192:104,192:105,192:106,193:103,193:104,193:105,194:101,194:102,194:103,194:104,195:100,195:101,195:102,195:103,196:99,196:100,196:101,196:102,197:97,197:98,197:99,197:100,198:97,198:98,198:99,199:96,199:97\"}]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"3\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(6303,'时空乱流3层',19,0,1,0,1,7300,2500,1,24005,18002,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,0,0,0,0,1,1,1,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,5,5,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,5,5,5,5,5,5,5,5,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,5,5,5,5,5,5,5,5,5,5,5,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n','[]','[{\"id\":1,\"type\":1,\"list\":\"49:41,49:42,50:41,50:42,50:43,50:44,51:41,51:42,51:43,51:44,51:45,52:42,52:43,52:44,52:45,52:46,53:43,53:44,53:45,53:46,53:47,54:44,54:45,54:46,54:47,54:48,55:45,55:46,55:47,55:48,55:49,56:46,56:47,56:48,56:49,57:47,57:48,78:103,78:104,79:103,79:104,80:102,80:103,80:104,81:103,81:104,81:105,82:104,82:105,83:104,83:105,84:104,84:105,84:106,85:104,85:105,85:106,86:105,86:106,87:105,87:106,87:107,88:105,88:106,88:107,89:106,89:107,90:106,90:107\"},{\"id\":2,\"type\":1,\"list\":\"102:34,103:31,103:32,103:33,103:34,103:35,104:29,104:30,104:31,104:32,104:33,104:34,105:27,105:28,105:29,105:30,105:31,105:32,106:25,106:26,106:27,106:28,106:29,107:23,107:24,107:25,107:26,107:27,107:28,108:22,108:23,108:24,108:25,109:22\"},{\"id\":3,\"type\":1,\"list\":\"110:126,110:127,111:126,111:127,112:126,112:127,113:126,113:127,114:126,114:127,115:126,115:127,116:126,116:127,117:126,117:127,118:126,118:127,119:126,119:127,120:126,120:127,121:126,121:127,122:126,122:127,123:126,123:127,124:126,124:127,125:126,125:127\"},{\"id\":4,\"type\":1,\"list\":\"148:76,149:75,149:76,149:77,150:74,150:75,150:76,151:73,151:74,151:75,152:72,152:73,152:74,152:75,153:71,153:72,153:73,153:74,154:71,154:72,154:73,155:70,155:71,155:72,156:69,156:70,156:71,156:72,157:69,157:70,157:71,158:68,158:69,158:70,159:68\"},{\"id\":5,\"type\":1,\"list\":\"176:125,176:126,176:127,176:128,177:127,177:128,177:129,178:128,178:129,178:130,179:129,179:130,179:131,180:130,180:131,180:132,181:131,181:132,181:133,182:132,182:133,182:134,183:133,183:134,183:135,184:134,184:135,184:136,185:135,185:136,185:137,191:105,191:106,191:107,192:104,192:105,192:106,193:103,193:104,193:105,194:101,194:102,194:103,194:104,195:100,195:101,195:102,195:103,196:99,196:100,196:101,196:102,197:97,197:98,197:99,197:100,198:97,198:98,198:99,199:96,199:97\"}]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"3\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(6304,'时空乱流4层',19,0,1,0,1,7300,2500,1,24005,18002,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,0,0,0,0,1,1,1,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,5,5,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,5,5,5,5,5,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,5,5,5,5,5,5,5,5,5,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,5,5,5,5,5,5,5,5,5,5,5,5,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,5,5,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n','[]','[{\"id\":1,\"type\":1,\"list\":\"49:41,49:42,50:41,50:42,50:43,50:44,51:41,51:42,51:43,51:44,51:45,52:42,52:43,52:44,52:45,52:46,53:43,53:44,53:45,53:46,53:47,54:44,54:45,54:46,54:47,54:48,55:45,55:46,55:47,55:48,55:49,56:46,56:47,56:48,56:49,57:47,57:48,78:103,78:104,79:103,79:104,80:102,80:103,80:104,81:103,81:104,81:105,82:104,82:105,83:104,83:105,84:104,84:105,84:106,85:104,85:105,85:106,86:105,86:106,87:105,87:106,87:107,88:105,88:106,88:107,89:106,89:107,90:106,90:107\"},{\"id\":2,\"type\":1,\"list\":\"102:34,103:31,103:32,103:33,103:34,103:35,104:29,104:30,104:31,104:32,104:33,104:34,105:27,105:28,105:29,105:30,105:31,105:32,106:25,106:26,106:27,106:28,106:29,107:23,107:24,107:25,107:26,107:27,107:28,108:22,108:23,108:24,108:25,109:22\"},{\"id\":3,\"type\":1,\"list\":\"110:126,110:127,111:126,111:127,112:126,112:127,113:126,113:127,114:126,114:127,115:126,115:127,116:126,116:127,117:126,117:127,118:126,118:127,119:126,119:127,120:126,120:127,121:126,121:127,122:126,122:127,123:126,123:127,124:126,124:127,125:126,125:127\"},{\"id\":4,\"type\":1,\"list\":\"148:76,149:75,149:76,149:77,150:74,150:75,150:76,151:73,151:74,151:75,152:72,152:73,152:74,152:75,153:71,153:72,153:73,153:74,154:71,154:72,154:73,155:70,155:71,155:72,156:69,156:70,156:71,156:72,157:69,157:70,157:71,158:68,158:69,158:70,159:68\"},{\"id\":5,\"type\":1,\"list\":\"176:125,176:126,176:127,176:128,177:127,177:128,177:129,178:128,178:129,178:130,179:129,179:130,179:131,180:130,180:131,180:132,181:131,181:132,181:133,182:132,182:133,182:134,183:133,183:134,183:135,184:134,184:135,184:136,185:135,185:136,185:137,191:105,191:106,191:107,192:104,192:105,192:106,193:103,193:104,193:105,194:101,194:102,194:103,194:104,195:100,195:101,195:102,195:103,196:99,196:100,196:101,196:102,197:97,197:98,197:99,197:100,198:97,198:98,198:99,199:96,199:97\"}]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"3\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(6305,'跨服首领4层',19,0,1,0,1,13103,908,1,24005,18002,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,0,0,0,0,1,1,1,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"3\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(6601,'星战等待区',20,1,1,0,1,4835,8266,1,8000,8800,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(6602,'星战等待区',20,1,1,0,1,4835,8266,1,8000,8800,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(6603,'星战等待区',20,1,1,0,1,4835,8266,1,8000,8800,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(6604,'星战等待区',20,1,1,0,1,4835,8266,1,8000,8800,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(6605,'星战等待区',20,1,1,0,1,4835,8266,1,8000,8800,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(6606,'星战等待区',20,1,1,0,1,4835,8266,1,8000,8800,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(6607,'星战等待区',20,1,1,0,1,4835,8266,1,8000,8800,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(6608,'星战等待区',20,1,1,0,1,4835,8266,1,8000,8800,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(6610,'星灵战场',20,2,1,1,1,11696,13082,1,23500,20600,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{300,300}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(6611,'星灵战场',20,2,1,1,1,11696,13082,1,23500,20600,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{300,300}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(6612,'星灵战场',20,2,1,1,1,11696,13082,1,23500,20600,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{300,300}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(6613,'星灵战场',20,2,1,1,1,11696,13082,1,23500,20600,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{300,300}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(7001,'战斗区',13,2,1,1,1,3573,4558,1,9440,9440,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"2\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(7002,'战斗区',13,2,1,1,1,3573,4558,1,9440,9440,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"2\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(7003,'战斗区',13,2,1,1,1,3573,4558,1,9440,9440,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"2\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]');
INSERT INTO `base_scene` VALUES (7004,'战斗区',13,2,1,1,1,3573,4558,1,9440,9440,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"2\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(7005,'备战区',13,1,1,0,1,4835,8266,1,8000,8800,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(7006,'备战区',13,1,1,0,1,4835,8266,1,8000,8800,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(7007,'备战区',13,1,1,0,1,4835,8266,1,8000,8800,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(7008,'备战区',13,1,1,0,1,4835,8266,1,8000,8800,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(7009,'备战区',13,1,1,0,1,4835,8266,1,8000,8800,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(7010,'备战区',13,1,1,0,1,4835,8266,1,8000,8800,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(7011,'备战区',13,1,1,0,1,4835,8266,1,8000,8800,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(7012,'备战区',13,1,1,0,1,4835,8266,1,8000,8800,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(7100,'试炼副本',2,0,0,1,1,3065,4466,1,9440,9440,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(7110,'资格赛战斗',14,2,1,1,1,4886,4540,1,9440,9440,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"2\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(7111,'守擂赛战斗',14,2,1,1,1,4886,4540,1,9440,9440,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"2\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(7112,'资格赛备战',14,1,1,1,1,4835,8266,1,8000,8800,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(7113,'守擂赛备战',14,1,1,1,1,4835,8266,1,8000,8800,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(7401,'简单房屋',18,0,0,0,1,4887,4515,1,7990,8000,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(7402,'中等房屋',18,0,0,0,1,4887,4515,1,7990,8000,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(7403,'豪华房屋',18,0,0,0,1,4887,4515,1,7990,8000,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(7404,'婚房房屋',18,0,0,0,1,4887,4515,1,7990,8000,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(7405,'家园',18,0,0,0,1,3622,3695,1,7990,8000,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(7406,'家园',18,0,0,0,1,11484,13405,1,19980,20579,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,1,1,1,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,1,1,','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(7411,'房屋',18,0,0,0,1,2970,3193,1,5243,5868,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(7412,'房屋',18,0,0,0,1,2243,2055,1,4837,4218,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,0,0,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1:\n1,1,1,1,1,1,0,0,0,0,0,0,1,0,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1:\n1,1,1,1,1,1,0,0,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(7413,'房屋',18,0,0,0,1,2234,1841,1,4777,4737,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,1,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,0,1,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,0,0,0,1,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,0,0,0,0,0,1,0,0,0,0,1,1,0,0,0,0,0,1,1,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1:\n1,1,1,0,0,0,0,0,0,0,1,0,0,0,0,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1:\n1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,1,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1:\n1,1,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1:\n1,1,1,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1:\n1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1:\n1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(7414,'房屋',18,0,0,0,1,2555,3039,1,6000,6000,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,0,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,0,0,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,0,0,1,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,0,0,0,0,1,0,0,0,0,1,1,0,0,0,0,0,1,1,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,1,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1:\n1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(7500,'梦魇深处',2,0,0,0,1,10603,8893,1,14600,17600,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{50,50}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(7501,'迷雾沼泽',2,0,0,1,1,9400,2700,1,14600,17600,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{50,50}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(7502,'迷雾沼泽',2,0,0,1,1,12174,10180,1,14600,17600,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{50,50}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(7503,'风蚀台地',2,0,0,0,1,11247,12750,1,23500,20600,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{0,300}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(7504,'骑士试炼',2,0,0,0,1,12450,9150,1,17400,17400,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{0,400}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(7700,'降神塔',2,0,0,1,1,4483,4255,1,9440,9440,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(10000,'暗裔秘所',2,0,0,1,1,5150,12550,1,25200,23400,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,0,0,0,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{0,400}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(10002,'抵抗军营',2,0,0,1,1,12135,12476,1,23000,22500,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,0,1,1,1,1,1,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{25,25}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(10003,'迷雾沼泽',2,0,0,1,1,2439,1659,1,14600,17600,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{50,50}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(10006,'神殿试炼',2,0,0,0,1,2996,16494,1,22850,19959,'[]','{}','[6301001, 2162, 17549, 1, 1] ','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,0,0,0,0,0,0,0,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{200,200}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(10007,'寒鸦峡谷',2,0,0,0,1,13700,10200,1,21400,13900,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,1,1,0,0,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{200,200}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(10008,'死神试炼',2,0,0,0,1,12200,12100,1,23500,20600,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,1,1,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,1,1,1,1,1,1,0,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,1,1,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{0,300}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]');
INSERT INTO `base_scene` VALUES (10009,'魅惑魔林',2,0,0,0,1,11300,10100,1,14600,17600,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,1,1,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{0,400}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(10010,'黄昏遗迹',2,0,0,0,1,13103,908,1,24238,20469,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"1\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(10030,'拯救白羊',2,0,0,1,1,15999,8092,1,29547,30694,'[]','{}','[100300003, 21512, 10965, 1, 1]','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(20001,'未命名',1,0,0,0,1,0,0,1,12600,11400,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(20002,'未命名',1,0,0,0,1,0,0,1,12600,11400,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(40001,'宝宝副本',2,0,0,1,1,2498,2158,1,17400,15600,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(42011,'公会守卫',2,0,0,0,1,4915,2205,1,16259,15019,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(58001,'天空树底层',11,2,0,0,1,1345,2583,1,15700,18100,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"2\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(58002,'天空树二层',11,2,0,0,1,1345,2583,1,15700,18100,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"2\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(58003,'天空树三层',11,2,0,0,1,1345,2583,1,15700,18100,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"2\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(58012,'天空树顶层',11,2,0,0,1,1345,2583,1,15700,18100,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"2\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(60000,'守卫雅典娜',2,0,1,1,1,4918,2205,1,16259,15019,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(70000,'降神塔',2,0,0,1,1,4483,4255,1,9440,9440,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"0\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(580101,'天空树底层',11,2,0,0,1,1345,2583,1,15700,18100,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"2\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(580102,'天空树二层',11,2,0,0,1,1345,2583,1,15700,18100,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"2\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(580103,'天空树三层',11,2,0,0,1,1345,2583,1,15700,18100,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"2\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]'),(580104,'天空树顶层',11,2,0,0,1,1345,2583,1,15700,18100,'[]','{}','','1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1:\n1,1,1,1','[]','[]','[{\"attr\":\"0\",\"type\":\"item\"},{\"attr\":\"[{1,1}]\",\"type\":\"lv\"},{\"attr\":\"0\",\"type\":\"team\"},{\"attr\":\"2\",\"type\":\"pkstate\"}]',0,0,'1',1,0,0,'[]');
/*!40000 ALTER TABLE `base_scene` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_scene_other`
--

DROP TABLE IF EXISTS `base_scene_other`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_scene_other` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '场景ID',
  `room_max_people` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '房间最大人数（程序容错最小50人，仅野外和主城有效）',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='场景其他配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_scene_other`
--

LOCK TABLES `base_scene_other` WRITE;
/*!40000 ALTER TABLE `base_scene_other` DISABLE KEYS */;
INSERT INTO `base_scene_other` VALUES (1001,30),(1002,30),(1003,30),(1004,30),(1005,30),(1006,30),(1007,30),(1008,30),(1009,30),(1010,30),(1501,100),(1502,100),(1601,10),(1701,30),(4001,30),(4002,30),(4003,30),(4004,30),(4005,30),(4006,30),(4007,30),(4008,30),(4009,30),(4011,30),(4012,30),(4013,30),(4014,30),(4015,30),(4016,30),(4017,30),(4018,30),(4019,30),(4101,40),(4401,20),(4500,100),(5000,10);
/*!40000 ALTER TABLE `base_scene_other` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_seal_soul`
--

DROP TABLE IF EXISTS `base_seal_soul`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_seal_soul` (
  `seal_soul_type_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '魂珠类型id',
  `seal_soul_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '魂珠类型',
  `seal_soul_quality` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '魂珠品质',
  `pos_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '部位类型',
  `grow_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '成长类型',
  `attribute_type` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '属性类型',
  `base_attr` varchar(128) NOT NULL DEFAULT '[]' COMMENT '基础属性',
  `grow_attr` varchar(128) NOT NULL DEFAULT '[]' COMMENT '成长属性',
  `resolve_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '基础分解经验',
  `skill_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能id',
  PRIMARY KEY (`seal_soul_type_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='魂珠配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_seal_soul`
--

LOCK TABLES `base_seal_soul` WRITE;
/*!40000 ALTER TABLE `base_seal_soul` DISABLE KEYS */;
INSERT INTO `base_seal_soul` VALUES (5201010,1,0,1,1,1,'[{1,135}]','[{1,9000}]',520,0),(5201011,1,1,1,1,1,'[{1,214}]','[{1,14250}]',820,0),(5201012,1,2,1,1,1,'[{1,383}]','[{1,25500}]',1470,0),(5201013,1,3,1,1,1,'[{1,648}]','[{1,36000}]',2080,0),(5201014,1,4,1,1,1,'[{1,1155}]','[{1,52500}]',3030,0),(5201020,2,0,1,1,1,'[{2,2700}]','[{2,180000}]',520,0),(5201021,2,1,1,1,1,'[{2,4275}]','[{2,285000}]',820,0),(5201022,2,2,1,1,1,'[{2,7650}]','[{2,510000}]',1470,0),(5201023,2,3,1,1,1,'[{2,12960}]','[{2,720000}]',2080,0),(5201024,2,4,1,1,1,'[{2,23100}]','[{2,1050000}]',3030,0),(5201030,3,0,1,1,1,'[{3,108}]','[{3,7200}]',520,0),(5201031,3,1,1,1,1,'[{3,171}]','[{3,11400}]',820,0),(5201032,3,2,1,1,1,'[{3,306}]','[{3,20400}]',1470,0),(5201033,3,3,1,1,1,'[{3,518}]','[{3,28800}]',2080,0),(5201034,3,4,1,1,1,'[{3,924}]','[{3,42000}]',3030,0),(5201040,4,0,1,1,1,'[{4,108}]','[{4,7200}]',520,0),(5201041,4,1,1,1,1,'[{4,171}]','[{4,11400}]',820,0),(5201042,4,2,1,1,1,'[{4,306}]','[{4,20400}]',1470,0),(5201043,4,3,1,1,1,'[{4,518}]','[{4,28800}]',2080,0),(5201044,4,4,1,1,1,'[{4,924}]','[{4,42000}]',3030,0),(5201050,5,0,1,1,1,'[{5,54}]','[{5,3600}]',520,0),(5201051,5,1,1,1,1,'[{5,86}]','[{5,5700}]',820,0),(5201052,5,2,1,1,1,'[{5,153}]','[{5,10200}]',1470,0),(5201053,5,3,1,1,1,'[{5,259}]','[{5,14400}]',2080,0),(5201054,5,4,1,1,1,'[{5,462}]','[{5,21000}]',3030,0),(5201060,6,0,1,1,1,'[{6,54}]','[{6,3600}]',520,0),(5201061,6,1,1,1,1,'[{6,86}]','[{6,5700}]',820,0),(5201062,6,2,1,1,1,'[{6,153}]','[{6,10200}]',1470,0),(5201063,6,3,1,1,1,'[{6,259}]','[{6,14400}]',2080,0),(5201064,6,4,1,1,1,'[{6,462}]','[{6,21000}]',3030,0),(5201070,7,0,1,1,1,'[{7,54}]','[{7,3600}]',520,0),(5201071,7,1,1,1,1,'[{7,86}]','[{7,5700}]',820,0),(5201072,7,2,1,1,1,'[{7,153}]','[{7,10200}]',1470,0),(5201073,7,3,1,1,1,'[{7,259}]','[{7,14400}]',2080,0),(5201074,7,4,1,1,1,'[{7,462}]','[{7,21000}]',3030,0),(5201080,8,0,1,1,1,'[{8,54}]','[{8,3600}]',520,0),(5201081,8,1,1,1,1,'[{8,86}]','[{8,5700}]',820,0),(5201082,8,2,1,1,1,'[{8,153}]','[{8,10200}]',1470,0),(5201083,8,3,1,1,1,'[{8,259}]','[{8,14400}]',2080,0),(5201084,8,4,1,1,1,'[{8,462}]','[{8,21000}]',3030,0),(5201090,9,0,1,1,1,'[{15,90}]','[{15,6000}]',520,0),(5201091,9,1,1,1,1,'[{15,143}]','[{15,9500}]',820,0),(5201092,9,2,1,1,1,'[{15,255}]','[{15,17000}]',1470,0),(5201093,9,3,1,1,1,'[{15,432}]','[{15,24000}]',2080,0),(5201094,9,4,1,1,1,'[{15,770}]','[{15,35000}]',3030,0),(5201100,10,0,1,1,1,'[{16,90}]','[{16,6000}]',520,0),(5201101,10,1,1,1,1,'[{16,143}]','[{16,9500}]',820,0),(5201102,10,2,1,1,1,'[{16,255}]','[{16,17000}]',1470,0),(5201103,10,3,1,1,1,'[{16,432}]','[{16,24000}]',2080,0),(5201104,10,4,1,1,1,'[{16,770}]','[{16,35000}]',3030,0),(5201140,11,0,1,3,1,'[{202,131}]','[{202,1188}]',520,0),(5201141,11,1,1,3,1,'[{202,209}]','[{202,1902}]',820,0),(5201142,11,2,1,3,1,'[{202,375}]','[{202,3405}]',1470,0),(5201143,11,3,1,3,1,'[{202,539}]','[{202,4903}]',2080,0),(5201144,11,4,1,3,1,'[{202,755}]','[{202,6864}]',3030,0),(5201150,14,0,1,2,1,'[{221,146}]','[{221,3240}]',520,0),(5201151,14,1,1,2,1,'[{221,231}]','[{221,5130}]',820,0),(5201152,14,2,1,2,1,'[{221,413}]','[{221,9180}]',1470,0),(5201153,14,3,1,2,1,'[{221,583}]','[{221,12960}]',2080,0),(5201154,14,4,1,2,1,'[{221,851}]','[{221,18900}]',3030,0),(5201160,15,0,1,2,1,'[{222,233}]','[{222,5184}]',520,0),(5201161,15,1,1,2,1,'[{222,369}]','[{222,8208}]',820,0),(5201162,15,2,1,2,1,'[{222,661}]','[{222,14688}]',1470,0),(5201163,15,3,1,2,1,'[{222,933}]','[{222,20736}]',2080,0),(5201164,15,4,1,2,1,'[{222,1361}]','[{222,30240}]',3030,0),(5201170,12,0,1,2,1,'[{223,81}]','[{223,1800}]',520,0),(5201171,12,1,1,2,1,'[{223,128}]','[{223,2850}]',820,0),(5201172,12,2,1,2,1,'[{223,230}]','[{223,5100}]',1470,0),(5201173,12,3,1,2,1,'[{223,324}]','[{223,7200}]',2080,0),(5201174,12,4,1,2,1,'[{223,473}]','[{223,10500}]',3030,0),(5201180,13,0,1,2,1,'[{224,130}]','[{224,2880}]',520,0),(5201181,13,1,1,2,1,'[{224,205}]','[{224,4560}]',820,0),(5201182,13,2,1,2,1,'[{224,367}]','[{224,8160}]',1470,0),(5201183,13,3,1,2,1,'[{224,518}]','[{224,11520}]',2080,0),(5201184,13,4,1,2,1,'[{224,756}]','[{224,16800}]',3030,0),(5201190,16,0,1,2,1,'[{225,152}]','[{225,3375}]',520,0),(5201191,16,1,1,2,1,'[{225,240}]','[{225,5343.75}]',820,0),(5201192,16,2,1,2,1,'[{225,430}]','[{225,9562.5}]',1470,0),(5201193,16,3,1,2,1,'[{225,608}]','[{225,13500}]',2080,0),(5201194,16,4,1,2,1,'[{225,886}]','[{225,19687.5}]',3030,0),(5202015,100,5,2,0,1,'[]','[]',0,52020001),(5202025,200,5,3,0,1,'[]','[]',0,52020002),(5203001,300,0,0,0,1,'[]','[]',500,0),(5203002,300,1,0,0,1,'[]','[]',1000,0),(5203003,300,2,0,0,1,'[]','[]',2000,0),(5203004,300,3,0,0,1,'[]','[]',5000,0),(5203005,300,4,0,0,1,'[]','[]',10000,0),(5206313,401,3,1,0,2,'[]','[]',0,0),(5206314,401,4,1,0,2,'[]','[]',0,0),(5206323,402,3,1,0,2,'[]','[]',0,0),(5206324,402,4,1,0,2,'[]','[]',0,0),(5206333,403,3,1,0,2,'[]','[]',0,0),(5206334,403,4,1,0,2,'[]','[]',0,0),(5206343,404,3,1,0,2,'[]','[]',0,0),(5206344,404,4,1,0,2,'[]','[]',0,0),(5206353,405,3,1,0,2,'[]','[]',0,0),(5206354,405,4,1,0,2,'[]','[]',0,0),(5206363,406,3,1,0,2,'[]','[]',0,0),(5206364,406,4,1,0,2,'[]','[]',0,0),(5206373,407,3,1,0,2,'[]','[]',0,0),(5206374,407,4,1,0,2,'[]','[]',0,0),(5206383,408,3,1,0,2,'[]','[]',0,0),(5206384,408,4,1,0,2,'[]','[]',0,0);
/*!40000 ALTER TABLE `base_seal_soul` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_seal_soul_key_value`
--

DROP TABLE IF EXISTS `base_seal_soul_key_value`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_seal_soul_key_value` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号id',
  `key` varchar(50) NOT NULL DEFAULT '' COMMENT '键',
  `value` varchar(256) NOT NULL DEFAULT '' COMMENT '值',
  `describe` varchar(1024) NOT NULL DEFAULT '' COMMENT '描述@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=11 DEFAULT CHARSET=utf8 COMMENT='魂珠常量配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_seal_soul_key_value`
--

LOCK TABLES `base_seal_soul_key_value` WRITE;
/*!40000 ALTER TABLE `base_seal_soul_key_value` DISABLE KEYS */;
INSERT INTO `base_seal_soul_key_value` VALUES (1,'draw_times','150','抽奖进度'),(2,'draw_times_reward','[{0,32150001,1}]','抽奖进度奖励'),(3,'reset_time','[{1,0,0,0}]','抽奖次数重置时间，格式：[{周几,几时,几分,几秒}]'),(4,'open_lv','70','开启等级'),(5,'seal_effect','[{5201001,ui_shenge_lighting},{5201002,ui_shenge_green}]','特效魂珠配置格式[{魂珠id,特效资源}]'),(6,'bag_limit','200','魂珠背包上限'),(7,'fragment_id','36160008','魂珠碎片id（兑换消耗货币id）'),(8,'upgrade_id','36160007','魂珠经验id（升级消耗货币id）'),(9,'luck_draw_id','38180010','魂珠抽奖道具id'),(10,'open_day','1','开服天数限制');
/*!40000 ALTER TABLE `base_seal_soul_key_value` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_seal_soul_lv`
--

DROP TABLE IF EXISTS `base_seal_soul_lv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_seal_soul_lv` (
  `seal_soul_type_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '魂珠类型id',
  `seal_soul_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '魂珠等级',
  `attr` varchar(128) NOT NULL DEFAULT '[]' COMMENT '魂珠属性',
  `cost` varchar(128) NOT NULL DEFAULT '[]' COMMENT '升级消耗',
  PRIMARY KEY (`seal_soul_type_id`,`seal_soul_lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='魂珠升级配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_seal_soul_lv`
--

LOCK TABLES `base_seal_soul_lv` WRITE;
/*!40000 ALTER TABLE `base_seal_soul_lv` DISABLE KEYS */;
INSERT INTO `base_seal_soul_lv` VALUES (5202015,1,'[{1,2400},{3,1280}]','[{0,5202015,1}]'),(5202015,2,'[{1,5100},{3,2720}]','[{0,5202015,1}]'),(5202015,3,'[{1,10200},{3,5440}]','[{0,5202015,2}]'),(5202015,4,'[{1,15000},{3,8000}]','[{0,5202015,2}]'),(5202015,5,'[{1,19200},{3,10240}]','[{0,5202015,2}]'),(5202025,1,'[{2,48000},{4,1280}]','[{0,5202025,1}]'),(5202025,2,'[{2,102000},{4,2720}]','[{0,5202025,1}]'),(5202025,3,'[{2,204000},{4,5440}]','[{0,5202025,2}]'),(5202025,4,'[{2,300000},{4,8000}]','[{0,5202025,2}]'),(5202025,5,'[{2,384000},{4,10240}]','[{0,5202025,2}]'),(5206313,1,'[{1,1296},{221,583}]','[{255,36160007,4463}]'),(5206313,2,'[{1,1728},{221,648}]','[{255,36160007,4674}]'),(5206313,3,'[{1,2166},{221,714}]','[{255,36160007,4893}]'),(5206313,4,'[{1,2610},{221,781}]','[{255,36160007,5121}]'),(5206313,5,'[{1,3060},{221,849}]','[{255,36160007,5355}]'),(5206313,6,'[{1,3516},{221,919}]','[{255,36160007,5598}]'),(5206313,7,'[{1,3976},{221,990}]','[{255,36160007,5852}]'),(5206313,8,'[{1,4442},{221,1062}]','[{255,36160007,6113}]'),(5206313,9,'[{1,4914},{221,1135}]','[{255,36160007,6386}]'),(5206313,10,'[{1,5392},{221,1210}]','[{255,36160007,6668}]'),(5206313,11,'[{1,5876},{221,1286}]','[{255,36160007,6962}]'),(5206313,12,'[{1,6366},{221,1363}]','[{255,36160007,7268}]'),(5206313,13,'[{1,6862},{221,1441}]','[{255,36160007,7587}]'),(5206313,14,'[{1,7364},{221,1521}]','[{255,36160007,7919}]'),(5206313,15,'[{1,7870},{221,1602}]','[{255,36160007,8267}]'),(5206313,16,'[{1,8382},{221,1684}]','[{255,36160007,8628}]'),(5206313,17,'[{1,8900},{221,1767}]','[{255,36160007,9006}]'),(5206313,18,'[{1,9424},{221,1851}]','[{255,36160007,9402}]'),(5206313,19,'[{1,9954},{221,1937}]','[{255,36160007,9818}]'),(5206313,20,'[{1,10490},{221,2024}]','[{255,36160007,10253}]'),(5206313,21,'[{1,11032},{221,2112}]','[{255,36160007,10710}]'),(5206313,22,'[{1,11580},{221,2201}]','[{255,36160007,11049}]'),(5206313,23,'[{1,12132},{221,2292}]','[{255,36160007,11396}]'),(5206313,24,'[{1,12690},{221,2384}]','[{255,36160007,11753}]'),(5206313,25,'[{1,13254},{221,2477}]','[{255,36160007,12119}]'),(5206313,26,'[{1,13824},{221,2571}]','[{255,36160007,12495}]'),(5206313,27,'[{1,14400},{221,2667}]','[{255,36160007,12882}]'),(5206313,28,'[{1,14982},{221,2764}]','[{255,36160007,13278}]'),(5206313,29,'[{1,15570},{221,2862}]','[{255,36160007,13685}]'),(5206313,30,'[{1,16164},{221,2961}]','[{255,36160007,14105}]'),(5206313,31,'[{1,16764},{221,3062}]','[{255,36160007,14535}]'),(5206313,32,'[{1,17368},{221,3164}]','[{255,36160007,14979}]'),(5206313,33,'[{1,17978},{221,3267}]','[{255,36160007,15435}]'),(5206313,34,'[{1,18594},{221,3371}]','[{255,36160007,15906}]'),(5206313,35,'[{1,19216},{221,3476}]','[{255,36160007,16391}]'),(5206313,36,'[{1,19844},{221,3583}]','[{255,36160007,16889}]'),(5206313,37,'[{1,20478},{221,3691}]','[{255,36160007,17405}]'),(5206313,38,'[{1,21118},{221,3800}]','[{255,36160007,17936}]'),(5206313,39,'[{1,21764},{221,3910}]','[{255,36160007,18483}]'),(5206313,40,'[{1,22414},{221,4022}]','[{255,36160007,19050}]'),(5206313,41,'[{1,23070},{221,4135}]','[{255,36160007,19635}]'),(5206313,42,'[{1,23732},{221,4249}]','[{255,36160007,20105}]'),(5206313,43,'[{1,24400},{221,4364}]','[{255,36160007,20583}]'),(5206313,44,'[{1,25074},{221,4481}]','[{255,36160007,21071}]'),(5206313,45,'[{1,25754},{221,4599}]','[{255,36160007,21569}]'),(5206313,46,'[{1,26440},{221,4718}]','[{255,36160007,22079}]'),(5206313,47,'[{1,27132},{221,4838}]','[{255,36160007,22598}]'),(5206313,48,'[{1,27828},{221,4959}]','[{255,36160007,23129}]'),(5206313,49,'[{1,28530},{221,5082}]','[{255,36160007,23670}]'),(5206313,50,'[{1,29238},{221,5206}]','[{255,36160007,24225}]'),(5206313,51,'[{1,29952},{221,5331}]','[{255,36160007,24791}]'),(5206313,52,'[{1,30672},{221,5457}]','[{255,36160007,25371}]'),(5206313,53,'[{1,31398},{221,5585}]','[{255,36160007,25964}]'),(5206313,54,'[{1,32130},{221,5714}]','[{255,36160007,26570}]'),(5206313,55,'[{1,32868},{221,5844}]','[{255,36160007,27191}]'),(5206313,56,'[{1,33612},{221,5975}]','[{255,36160007,27825}]'),(5206313,57,'[{1,34360},{221,6108}]','[{255,36160007,28475}]'),(5206313,58,'[{1,35114},{221,6242}]','[{255,36160007,29141}]'),(5206313,59,'[{1,35874},{221,6377}]','[{255,36160007,29823}]'),(5206313,60,'[{1,36640},{221,6513}]','[{255,36160007,30521}]'),(5206313,61,'[{1,37412},{221,6650}]','[{255,36160007,31238}]'),(5206313,62,'[{1,38190},{221,6789}]','[{255,36160007,31973}]'),(5206313,63,'[{1,38974},{221,6929}]','[{255,36160007,32726}]'),(5206313,64,'[{1,39764},{221,7070}]','[{255,36160007,33498}]'),(5206313,65,'[{1,40558},{221,7212}]','[{255,36160007,34292}]'),(5206313,66,'[{1,41358},{221,7356}]','[{255,36160007,35105}]'),(5206313,67,'[{1,42164},{221,7501}]','[{255,36160007,35942}]'),(5206313,68,'[{1,42976},{221,7647}]','[{255,36160007,36801}]'),(5206313,69,'[{1,43794},{221,7794}]','[{255,36160007,37685}]'),(5206313,70,'[{1,44618},{221,7943}]','[{255,36160007,38592}]'),(5206313,71,'[{1,45448},{221,8093}]','[{255,36160007,39525}]'),(5206313,72,'[{1,46284},{221,8244}]','[{255,36160007,40487}]'),(5206313,73,'[{1,47124},{221,8396}]','[{255,36160007,41475}]'),(5206313,74,'[{1,47970},{221,8549}]','[{255,36160007,42494}]'),(5206313,75,'[{1,48822},{221,8704}]','[{255,36160007,43544}]'),(5206313,76,'[{1,49680},{221,8860}]','[{255,36160007,44397}]'),(5206313,77,'[{1,50544},{221,9017}]','[{255,36160007,45269}]'),(5206313,78,'[{1,51414},{221,9175}]','[{255,36160007,46160}]'),(5206313,79,'[{1,52290},{221,9335}]','[{255,36160007,47069}]'),(5206313,80,'[{1,53172},{221,9496}]','[{255,36160007,47996}]'),(5206313,81,'[{1,54060},{221,9658}]','[{255,36160007,48944}]'),(5206313,82,'[{1,54952},{221,9821}]','[{255,36160007,49913}]'),(5206313,83,'[{1,55850},{221,9986}]','[{255,36160007,50903}]'),(5206313,84,'[{1,56754},{221,10152}]','[{255,36160007,51914}]'),(5206313,85,'[{1,57664},{221,10319}]','[{255,36160007,52949}]'),(5206313,86,'[{1,58580},{221,10487}]','[{255,36160007,54006}]'),(5206313,87,'[{1,59502},{221,10656}]','[{255,36160007,55089}]'),(5206313,88,'[{1,60430},{221,10827}]','[{255,36160007,56198}]'),(5206313,89,'[{1,61364},{221,10999}]','[{255,36160007,57330}]'),(5206313,90,'[{1,62302},{221,11172}]','[{255,36160007,58491}]'),(5206313,91,'[{1,63246},{221,11346}]','[{255,36160007,59679}]'),(5206313,92,'[{1,64196},{221,11522}]','[{255,36160007,60897}]'),(5206313,93,'[{1,65152},{221,11699}]','[{255,36160007,62145}]'),(5206313,94,'[{1,66114},{221,11877}]','[{255,36160007,63423}]'),(5206313,95,'[{1,67082},{221,12056}]','[{255,36160007,64734}]'),(5206313,96,'[{1,68056},{221,12237}]','[{255,36160007,66080}]'),(5206313,97,'[{1,69036},{221,12419}]','[{255,36160007,67460}]'),(5206313,98,'[{1,70020},{221,12602}]','[{255,36160007,68876}]'),(5206313,99,'[{1,71010},{221,12786}]','[{255,36160007,70329}]'),(5206313,100,'[{1,72006},{221,12971}]','[{255,36160007,0}]'),(5206314,1,'[{1,2310},{221,851}]','[{255,36160007,5250}]'),(5206314,2,'[{1,2940},{221,946}]','[{255,36160007,5499}]'),(5206314,3,'[{1,3578},{221,1042}]','[{255,36160007,5757}]'),(5206314,4,'[{1,4224},{221,1140}]','[{255,36160007,6024}]'),(5206314,5,'[{1,4880},{221,1240}]','[{255,36160007,6300}]'),(5206314,6,'[{1,5544},{221,1342}]','[{255,36160007,6587}]'),(5206314,7,'[{1,6216},{221,1445}]','[{255,36160007,6884}]'),(5206314,8,'[{1,6896},{221,1550}]','[{255,36160007,7191}]'),(5206314,9,'[{1,7584},{221,1657}]','[{255,36160007,7512}]'),(5206314,10,'[{1,8282},{221,1766}]','[{255,36160007,7844}]'),(5206314,11,'[{1,8988},{221,1877}]','[{255,36160007,8190}]'),(5206314,12,'[{1,9702},{221,1989}]','[{255,36160007,8550}]'),(5206314,13,'[{1,10424},{221,2103}]','[{255,36160007,8925}]'),(5206314,14,'[{1,11154},{221,2219}]','[{255,36160007,9317}]'),(5206314,15,'[{1,11894},{221,2337}]','[{255,36160007,9725}]'),(5206314,16,'[{1,12642},{221,2457}]','[{255,36160007,10151}]'),(5206314,17,'[{1,13398},{221,2578}]','[{255,36160007,10596}]'),(5206314,18,'[{1,14162},{221,2701}]','[{255,36160007,11061}]'),(5206314,19,'[{1,14934},{221,2826}]','[{255,36160007,11550}]'),(5206314,20,'[{1,15716},{221,2953}]','[{255,36160007,12062}]'),(5206314,21,'[{1,16506},{221,3082}]','[{255,36160007,12600}]'),(5206314,22,'[{1,17304},{221,3212}]','[{255,36160007,12999}]'),(5206314,23,'[{1,18110},{221,3344}]','[{255,36160007,13407}]'),(5206314,24,'[{1,18924},{221,3478}]','[{255,36160007,13827}]'),(5206314,25,'[{1,19748},{221,3614}]','[{255,36160007,14258}]'),(5206314,26,'[{1,20580},{221,3752}]','[{255,36160007,14700}]'),(5206314,27,'[{1,21420},{221,3891}]','[{255,36160007,15155}]'),(5206314,28,'[{1,22268},{221,4032}]','[{255,36160007,15621}]'),(5206314,29,'[{1,23124},{221,4175}]','[{255,36160007,16100}]'),(5206314,30,'[{1,23990},{221,4320}]','[{255,36160007,16593}]'),(5206314,31,'[{1,24864},{221,4467}]','[{255,36160007,17100}]'),(5206314,32,'[{1,25746},{221,4615}]','[{255,36160007,17622}]'),(5206314,33,'[{1,26636},{221,4765}]','[{255,36160007,18159}]'),(5206314,34,'[{1,27534},{221,4917}]','[{255,36160007,18713}]'),(5206314,35,'[{1,28442},{221,5071}]','[{255,36160007,19283}]'),(5206314,36,'[{1,29358},{221,5227}]','[{255,36160007,19869}]'),(5206314,37,'[{1,30282},{221,5384}]','[{255,36160007,20475}]'),(5206314,38,'[{1,31214},{221,5543}]','[{255,36160007,21101}]'),(5206314,39,'[{1,32154},{221,5704}]','[{255,36160007,21746}]'),(5206314,40,'[{1,33104},{221,5867}]','[{255,36160007,22412}]'),(5206314,41,'[{1,34062},{221,6032}]','[{255,36160007,23100}]'),(5206314,42,'[{1,35028},{221,6198}]','[{255,36160007,23652}]'),(5206314,43,'[{1,36002},{221,6366}]','[{255,36160007,24215}]'),(5206314,44,'[{1,36984},{221,6536}]','[{255,36160007,24789}]'),(5206314,45,'[{1,37976},{221,6708}]','[{255,36160007,25376}]'),(5206314,46,'[{1,38976},{221,6882}]','[{255,36160007,25974}]'),(5206314,47,'[{1,39984},{221,7057}]','[{255,36160007,26585}]'),(5206314,48,'[{1,41000},{221,7234}]','[{255,36160007,27210}]'),(5206314,49,'[{1,42024},{221,7413}]','[{255,36160007,27848}]'),(5206314,50,'[{1,43058},{221,7594}]','[{255,36160007,28500}]'),(5206314,51,'[{1,44100},{221,7776}]','[{255,36160007,29166}]'),(5206314,52,'[{1,45150},{221,7960}]','[{255,36160007,29849}]'),(5206314,53,'[{1,46208},{221,8146}]','[{255,36160007,30546}]'),(5206314,54,'[{1,47274},{221,8334}]','[{255,36160007,31259}]'),(5206314,55,'[{1,48350},{221,8524}]','[{255,36160007,31989}]'),(5206314,56,'[{1,49434},{221,8715}]','[{255,36160007,32736}]'),(5206314,57,'[{1,50526},{221,8908}]','[{255,36160007,33500}]'),(5206314,58,'[{1,51626},{221,9103}]','[{255,36160007,34283}]'),(5206314,59,'[{1,52734},{221,9300}]','[{255,36160007,35085}]'),(5206314,60,'[{1,53852},{221,9499}]','[{255,36160007,35907}]'),(5206314,61,'[{1,54978},{221,9699}]','[{255,36160007,36750}]'),(5206314,62,'[{1,56112},{221,9901}]','[{255,36160007,37614}]'),(5206314,63,'[{1,57254},{221,10105}]','[{255,36160007,38501}]'),(5206314,64,'[{1,58404},{221,10311}]','[{255,36160007,39410}]'),(5206314,65,'[{1,59564},{221,10519}]','[{255,36160007,40343}]'),(5206314,66,'[{1,60732},{221,10728}]','[{255,36160007,41300}]'),(5206314,67,'[{1,61908},{221,10939}]','[{255,36160007,42284}]'),(5206314,68,'[{1,63092},{221,11152}]','[{255,36160007,43295}]'),(5206314,69,'[{1,64284},{221,11367}]','[{255,36160007,44334}]'),(5206314,70,'[{1,65486},{221,11584}]','[{255,36160007,45402}]'),(5206314,71,'[{1,66696},{221,11802}]','[{255,36160007,46500}]'),(5206314,72,'[{1,67914},{221,12022}]','[{255,36160007,47631}]'),(5206314,73,'[{1,69140},{221,12244}]','[{255,36160007,48794}]'),(5206314,74,'[{1,70374},{221,12468}]','[{255,36160007,49992}]'),(5206314,75,'[{1,71618},{221,12694}]','[{255,36160007,51228}]'),(5206314,76,'[{1,72870},{221,12921}]','[{255,36160007,52232}]'),(5206314,77,'[{1,74130},{221,13150}]','[{255,36160007,53258}]'),(5206314,78,'[{1,75398},{221,13381}]','[{255,36160007,54305}]'),(5206314,79,'[{1,76674},{221,13614}]','[{255,36160007,55374}]'),(5206314,80,'[{1,77960},{221,13849}]','[{255,36160007,56466}]'),(5206314,81,'[{1,79254},{221,14085}]','[{255,36160007,57581}]'),(5206314,82,'[{1,80556},{221,14323}]','[{255,36160007,58721}]'),(5206314,83,'[{1,81866},{221,14563}]','[{255,36160007,59885}]'),(5206314,84,'[{1,83184},{221,14805}]','[{255,36160007,61076}]'),(5206314,85,'[{1,84512},{221,15049}]','[{255,36160007,62292}]'),(5206314,86,'[{1,85848},{221,15294}]','[{255,36160007,63537}]'),(5206314,87,'[{1,87192},{221,15541}]','[{255,36160007,64811}]'),(5206314,88,'[{1,88544},{221,15790}]','[{255,36160007,66114}]'),(5206314,89,'[{1,89904},{221,16041}]','[{255,36160007,67448}]'),(5206314,90,'[{1,91274},{221,16294}]','[{255,36160007,68813}]'),(5206314,91,'[{1,92652},{221,16548}]','[{255,36160007,70211}]'),(5206314,92,'[{1,94038},{221,16804}]','[{255,36160007,71643}]'),(5206314,93,'[{1,95432},{221,17062}]','[{255,36160007,73112}]'),(5206314,94,'[{1,96834},{221,17322}]','[{255,36160007,74616}]'),(5206314,95,'[{1,98246},{221,17583}]','[{255,36160007,76158}]'),(5206314,96,'[{1,99666},{221,17846}]','[{255,36160007,77741}]'),(5206314,97,'[{1,101094},{221,18111}]','[{255,36160007,79364}]'),(5206314,98,'[{1,102530},{221,18378}]','[{255,36160007,81030}]'),(5206314,99,'[{1,103974},{221,18647}]','[{255,36160007,82740}]'),(5206314,100,'[{1,105428},{221,18917}]','[{255,36160007,0}]'),(5206323,1,'[{2,25920},{223,324}]','[{255,36160007,4463}]'),(5206323,2,'[{2,34560},{223,360}]','[{255,36160007,4674}]'),(5206323,3,'[{2,43316},{223,397}]','[{255,36160007,4893}]'),(5206323,4,'[{2,52186},{223,434}]','[{255,36160007,5121}]'),(5206323,5,'[{2,61172},{223,472}]','[{255,36160007,5355}]'),(5206323,6,'[{2,70272},{223,511}]','[{255,36160007,5598}]'),(5206323,7,'[{2,79488},{223,550}]','[{255,36160007,5852}]'),(5206323,8,'[{2,88820},{223,590}]','[{255,36160007,6113}]'),(5206323,9,'[{2,98266},{223,631}]','[{255,36160007,6386}]'),(5206323,10,'[{2,107828},{223,672}]','[{255,36160007,6668}]'),(5206323,11,'[{2,117504},{223,714}]','[{255,36160007,6962}]'),(5206323,12,'[{2,127296},{223,757}]','[{255,36160007,7268}]'),(5206323,13,'[{2,137204},{223,801}]','[{255,36160007,7587}]'),(5206323,14,'[{2,147226},{223,845}]','[{255,36160007,7919}]'),(5206323,15,'[{2,157364},{223,890}]','[{255,36160007,8267}]'),(5206323,16,'[{2,167616},{223,936}]','[{255,36160007,8628}]'),(5206323,17,'[{2,177984},{223,982}]','[{255,36160007,9006}]'),(5206323,18,'[{2,188468},{223,1029}]','[{255,36160007,9402}]'),(5206323,19,'[{2,199066},{223,1077}]','[{255,36160007,9818}]'),(5206323,20,'[{2,209780},{223,1125}]','[{255,36160007,10253}]'),(5206323,21,'[{2,220608},{223,1174}]','[{255,36160007,10710}]'),(5206323,22,'[{2,231552},{223,1224}]','[{255,36160007,11049}]'),(5206323,23,'[{2,242612},{223,1274}]','[{255,36160007,11396}]'),(5206323,24,'[{2,253786},{223,1325}]','[{255,36160007,11753}]'),(5206323,25,'[{2,265076},{223,1377}]','[{255,36160007,12119}]'),(5206323,26,'[{2,276480},{223,1429}]','[{255,36160007,12495}]'),(5206323,27,'[{2,288000},{223,1482}]','[{255,36160007,12882}]'),(5206323,28,'[{2,299636},{223,1536}]','[{255,36160007,13278}]'),(5206323,29,'[{2,311386},{223,1590}]','[{255,36160007,13685}]'),(5206323,30,'[{2,323252},{223,1645}]','[{255,36160007,14105}]'),(5206323,31,'[{2,335232},{223,1701}]','[{255,36160007,14535}]'),(5206323,32,'[{2,347328},{223,1758}]','[{255,36160007,14979}]'),(5206323,33,'[{2,359540},{223,1815}]','[{255,36160007,15435}]'),(5206323,34,'[{2,371866},{223,1873}]','[{255,36160007,15906}]'),(5206323,35,'[{2,384308},{223,1932}]','[{255,36160007,16391}]'),(5206323,36,'[{2,396864},{223,1991}]','[{255,36160007,16889}]'),(5206323,37,'[{2,409536},{223,2051}]','[{255,36160007,17405}]'),(5206323,38,'[{2,422324},{223,2112}]','[{255,36160007,17936}]'),(5206323,39,'[{2,435226},{223,2173}]','[{255,36160007,18483}]'),(5206323,40,'[{2,448244},{223,2235}]','[{255,36160007,19050}]'),(5206323,41,'[{2,461376},{223,2298}]','[{255,36160007,19635}]'),(5206323,42,'[{2,474624},{223,2361}]','[{255,36160007,20105}]'),(5206323,43,'[{2,487988},{223,2425}]','[{255,36160007,20583}]'),(5206323,44,'[{2,501466},{223,2490}]','[{255,36160007,21071}]'),(5206323,45,'[{2,515060},{223,2555}]','[{255,36160007,21569}]'),(5206323,46,'[{2,528768},{223,2621}]','[{255,36160007,22079}]'),(5206323,47,'[{2,542592},{223,2688}]','[{255,36160007,22598}]'),(5206323,48,'[{2,556532},{223,2755}]','[{255,36160007,23129}]'),(5206323,49,'[{2,570586},{223,2823}]','[{255,36160007,23670}]'),(5206323,50,'[{2,584756},{223,2892}]','[{255,36160007,24225}]'),(5206323,51,'[{2,599040},{223,2962}]','[{255,36160007,24791}]'),(5206323,52,'[{2,613440},{223,3032}]','[{255,36160007,25371}]'),(5206323,53,'[{2,627956},{223,3103}]','[{255,36160007,25964}]'),(5206323,54,'[{2,642586},{223,3175}]','[{255,36160007,26570}]'),(5206323,55,'[{2,657332},{223,3247}]','[{255,36160007,27191}]'),(5206323,56,'[{2,672192},{223,3320}]','[{255,36160007,27825}]'),(5206323,57,'[{2,687168},{223,3394}]','[{255,36160007,28475}]'),(5206323,58,'[{2,702260},{223,3468}]','[{255,36160007,29141}]'),(5206323,59,'[{2,717466},{223,3543}]','[{255,36160007,29823}]'),(5206323,60,'[{2,732788},{223,3619}]','[{255,36160007,30521}]'),(5206323,61,'[{2,748224},{223,3695}]','[{255,36160007,31238}]'),(5206323,62,'[{2,763776},{223,3772}]','[{255,36160007,31973}]'),(5206323,63,'[{2,779444},{223,3850}]','[{255,36160007,32726}]'),(5206323,64,'[{2,795226},{223,3928}]','[{255,36160007,33498}]'),(5206323,65,'[{2,811124},{223,4007}]','[{255,36160007,34292}]'),(5206323,66,'[{2,827136},{223,4087}]','[{255,36160007,35105}]'),(5206323,67,'[{2,843264},{223,4167}]','[{255,36160007,35942}]'),(5206323,68,'[{2,859508},{223,4248}]','[{255,36160007,36801}]'),(5206323,69,'[{2,875866},{223,4330}]','[{255,36160007,37685}]'),(5206323,70,'[{2,892340},{223,4413}]','[{255,36160007,38592}]'),(5206323,71,'[{2,908928},{223,4496}]','[{255,36160007,39525}]'),(5206323,72,'[{2,925632},{223,4580}]','[{255,36160007,40487}]'),(5206323,73,'[{2,942452},{223,4665}]','[{255,36160007,41475}]'),(5206323,74,'[{2,959386},{223,4750}]','[{255,36160007,42494}]'),(5206323,75,'[{2,976436},{223,4836}]','[{255,36160007,43544}]'),(5206323,76,'[{2,993600},{223,4923}]','[{255,36160007,44397}]'),(5206323,77,'[{2,1010880},{223,5010}]','[{255,36160007,45269}]'),(5206323,78,'[{2,1028276},{223,5098}]','[{255,36160007,46160}]'),(5206323,79,'[{2,1045786},{223,5187}]','[{255,36160007,47069}]'),(5206323,80,'[{2,1063412},{223,5276}]','[{255,36160007,47996}]'),(5206323,81,'[{2,1081152},{223,5366}]','[{255,36160007,48944}]'),(5206323,82,'[{2,1099008},{223,5457}]','[{255,36160007,49913}]'),(5206323,83,'[{2,1116980},{223,5548}]','[{255,36160007,50903}]'),(5206323,84,'[{2,1135066},{223,5640}]','[{255,36160007,51914}]'),(5206323,85,'[{2,1153268},{223,5733}]','[{255,36160007,52949}]'),(5206323,86,'[{2,1171584},{223,5826}]','[{255,36160007,54006}]'),(5206323,87,'[{2,1190016},{223,5920}]','[{255,36160007,55089}]'),(5206323,88,'[{2,1208564},{223,6015}]','[{255,36160007,56198}]'),(5206323,89,'[{2,1227226},{223,6111}]','[{255,36160007,57330}]'),(5206323,90,'[{2,1246004},{223,6207}]','[{255,36160007,58491}]'),(5206323,91,'[{2,1264896},{223,6304}]','[{255,36160007,59679}]'),(5206323,92,'[{2,1283904},{223,6402}]','[{255,36160007,60897}]'),(5206323,93,'[{2,1303028},{223,6500}]','[{255,36160007,62145}]'),(5206323,94,'[{2,1322266},{223,6599}]','[{255,36160007,63423}]'),(5206323,95,'[{2,1341620},{223,6699}]','[{255,36160007,64734}]'),(5206323,96,'[{2,1361088},{223,6799}]','[{255,36160007,66080}]'),(5206323,97,'[{2,1380672},{223,6900}]','[{255,36160007,67460}]'),(5206323,98,'[{2,1400372},{223,7002}]','[{255,36160007,68876}]'),(5206323,99,'[{2,1420186},{223,7104}]','[{255,36160007,70329}]'),(5206323,100,'[{2,1440116},{223,7207}]','[{255,36160007,0}]'),(5206324,1,'[{2,46200},{223,473}]','[{255,36160007,5250}]'),(5206324,2,'[{2,58800},{223,526}]','[{255,36160007,5499}]'),(5206324,3,'[{2,71568},{223,579}]','[{255,36160007,5757}]'),(5206324,4,'[{2,84504},{223,633}]','[{255,36160007,6024}]'),(5206324,5,'[{2,97608},{223,688}]','[{255,36160007,6300}]'),(5206324,6,'[{2,110880},{223,744}]','[{255,36160007,6587}]'),(5206324,7,'[{2,124320},{223,801}]','[{255,36160007,6884}]'),(5206324,8,'[{2,137928},{223,859}]','[{255,36160007,7191}]'),(5206324,9,'[{2,151704},{223,918}]','[{255,36160007,7512}]'),(5206324,10,'[{2,165648},{223,978}]','[{255,36160007,7844}]'),(5206324,11,'[{2,179760},{223,1039}]','[{255,36160007,8190}]'),(5206324,12,'[{2,194040},{223,1101}]','[{255,36160007,8550}]'),(5206324,13,'[{2,208488},{223,1164}]','[{255,36160007,8925}]'),(5206324,14,'[{2,223104},{223,1228}]','[{255,36160007,9317}]'),(5206324,15,'[{2,237888},{223,1293}]','[{255,36160007,9725}]'),(5206324,16,'[{2,252840},{223,1359}]','[{255,36160007,10151}]'),(5206324,17,'[{2,267960},{223,1426}]','[{255,36160007,10596}]'),(5206324,18,'[{2,283248},{223,1494}]','[{255,36160007,11061}]'),(5206324,19,'[{2,298704},{223,1563}]','[{255,36160007,11550}]'),(5206324,20,'[{2,314328},{223,1633}]','[{255,36160007,12062}]'),(5206324,21,'[{2,330120},{223,1704}]','[{255,36160007,12600}]'),(5206324,22,'[{2,346080},{223,1776}]','[{255,36160007,12999}]'),(5206324,23,'[{2,362208},{223,1849}]','[{255,36160007,13407}]'),(5206324,24,'[{2,378504},{223,1923}]','[{255,36160007,13827}]'),(5206324,25,'[{2,394968},{223,1998}]','[{255,36160007,14258}]'),(5206324,26,'[{2,411600},{223,2074}]','[{255,36160007,14700}]'),(5206324,27,'[{2,428400},{223,2151}]','[{255,36160007,15155}]'),(5206324,28,'[{2,445368},{223,2229}]','[{255,36160007,15621}]'),(5206324,29,'[{2,462504},{223,2308}]','[{255,36160007,16100}]'),(5206324,30,'[{2,479808},{223,2388}]','[{255,36160007,16593}]'),(5206324,31,'[{2,497280},{223,2469}]','[{255,36160007,17100}]'),(5206324,32,'[{2,514920},{223,2551}]','[{255,36160007,17622}]'),(5206324,33,'[{2,532728},{223,2634}]','[{255,36160007,18159}]'),(5206324,34,'[{2,550704},{223,2718}]','[{255,36160007,18713}]'),(5206324,35,'[{2,568848},{223,2803}]','[{255,36160007,19283}]'),(5206324,36,'[{2,587160},{223,2889}]','[{255,36160007,19869}]'),(5206324,37,'[{2,605640},{223,2976}]','[{255,36160007,20475}]'),(5206324,38,'[{2,624288},{223,3064}]','[{255,36160007,21101}]'),(5206324,39,'[{2,643104},{223,3153}]','[{255,36160007,21746}]'),(5206324,40,'[{2,662088},{223,3243}]','[{255,36160007,22412}]'),(5206324,41,'[{2,681240},{223,3334}]','[{255,36160007,23100}]'),(5206324,42,'[{2,700560},{223,3426}]','[{255,36160007,23652}]'),(5206324,43,'[{2,720048},{223,3519}]','[{255,36160007,24215}]'),(5206324,44,'[{2,739704},{223,3613}]','[{255,36160007,24789}]'),(5206324,45,'[{2,759528},{223,3708}]','[{255,36160007,25376}]'),(5206324,46,'[{2,779520},{223,3804}]','[{255,36160007,25974}]'),(5206324,47,'[{2,799680},{223,3901}]','[{255,36160007,26585}]'),(5206324,48,'[{2,820008},{223,3999}]','[{255,36160007,27210}]'),(5206324,49,'[{2,840504},{223,4098}]','[{255,36160007,27848}]'),(5206324,50,'[{2,861168},{223,4198}]','[{255,36160007,28500}]'),(5206324,51,'[{2,882000},{223,4299}]','[{255,36160007,29166}]'),(5206324,52,'[{2,903000},{223,4401}]','[{255,36160007,29849}]'),(5206324,53,'[{2,924168},{223,4504}]','[{255,36160007,30546}]'),(5206324,54,'[{2,945504},{223,4608}]','[{255,36160007,31259}]'),(5206324,55,'[{2,967008},{223,4713}]','[{255,36160007,31989}]'),(5206324,56,'[{2,988680},{223,4819}]','[{255,36160007,32736}]'),(5206324,57,'[{2,1010520},{223,4926}]','[{255,36160007,33500}]'),(5206324,58,'[{2,1032528},{223,5034}]','[{255,36160007,34283}]'),(5206324,59,'[{2,1054704},{223,5143}]','[{255,36160007,35085}]'),(5206324,60,'[{2,1077048},{223,5253}]','[{255,36160007,35907}]'),(5206324,61,'[{2,1099560},{223,5364}]','[{255,36160007,36750}]'),(5206324,62,'[{2,1122240},{223,5476}]','[{255,36160007,37614}]'),(5206324,63,'[{2,1145088},{223,5589}]','[{255,36160007,38501}]'),(5206324,64,'[{2,1168104},{223,5703}]','[{255,36160007,39410}]'),(5206324,65,'[{2,1191288},{223,5818}]','[{255,36160007,40343}]'),(5206324,66,'[{2,1214640},{223,5934}]','[{255,36160007,41300}]'),(5206324,67,'[{2,1238160},{223,6051}]','[{255,36160007,42284}]'),(5206324,68,'[{2,1261848},{223,6169}]','[{255,36160007,43295}]'),(5206324,69,'[{2,1285704},{223,6288}]','[{255,36160007,44334}]'),(5206324,70,'[{2,1309728},{223,6408}]','[{255,36160007,45402}]'),(5206324,71,'[{2,1333920},{223,6529}]','[{255,36160007,46500}]'),(5206324,72,'[{2,1358280},{223,6651}]','[{255,36160007,47631}]'),(5206324,73,'[{2,1382808},{223,6774}]','[{255,36160007,48794}]'),(5206324,74,'[{2,1407504},{223,6898}]','[{255,36160007,49992}]'),(5206324,75,'[{2,1432368},{223,7023}]','[{255,36160007,51228}]'),(5206324,76,'[{2,1457400},{223,7149}]','[{255,36160007,52232}]'),(5206324,77,'[{2,1482600},{223,7276}]','[{255,36160007,53258}]'),(5206324,78,'[{2,1507968},{223,7404}]','[{255,36160007,54305}]'),(5206324,79,'[{2,1533504},{223,7533}]','[{255,36160007,55374}]'),(5206324,80,'[{2,1559208},{223,7663}]','[{255,36160007,56466}]'),(5206324,81,'[{2,1585080},{223,7794}]','[{255,36160007,57581}]'),(5206324,82,'[{2,1611120},{223,7926}]','[{255,36160007,58721}]'),(5206324,83,'[{2,1637328},{223,8059}]','[{255,36160007,59885}]'),(5206324,84,'[{2,1663704},{223,8193}]','[{255,36160007,61076}]'),(5206324,85,'[{2,1690248},{223,8328}]','[{255,36160007,62292}]'),(5206324,86,'[{2,1716960},{223,8464}]','[{255,36160007,63537}]'),(5206324,87,'[{2,1743840},{223,8601}]','[{255,36160007,64811}]'),(5206324,88,'[{2,1770888},{223,8739}]','[{255,36160007,66114}]'),(5206324,89,'[{2,1798104},{223,8878}]','[{255,36160007,67448}]'),(5206324,90,'[{2,1825488},{223,9018}]','[{255,36160007,68813}]'),(5206324,91,'[{2,1853040},{223,9159}]','[{255,36160007,70211}]'),(5206324,92,'[{2,1880760},{223,9301}]','[{255,36160007,71643}]'),(5206324,93,'[{2,1908648},{223,9444}]','[{255,36160007,73112}]'),(5206324,94,'[{2,1936704},{223,9588}]','[{255,36160007,74616}]'),(5206324,95,'[{2,1964928},{223,9733}]','[{255,36160007,76158}]'),(5206324,96,'[{2,1993320},{223,9879}]','[{255,36160007,77741}]'),(5206324,97,'[{2,2021880},{223,10026}]','[{255,36160007,79364}]'),(5206324,98,'[{2,2050608},{223,10174}]','[{255,36160007,81030}]'),(5206324,99,'[{2,2079504},{223,10323}]','[{255,36160007,82740}]'),(5206324,100,'[{2,2108568},{223,10473}]','[{255,36160007,0}]'),(5206333,1,'[{3,1036},{222,933}]','[{255,36160007,4463}]'),(5206333,2,'[{3,1382},{222,1037}]','[{255,36160007,4674}]'),(5206333,3,'[{3,1732},{222,1143}]','[{255,36160007,4893}]'),(5206333,4,'[{3,2086},{222,1251}]','[{255,36160007,5121}]'),(5206333,5,'[{3,2446},{222,1361}]','[{255,36160007,5355}]'),(5206333,6,'[{3,2810},{222,1473}]','[{255,36160007,5598}]'),(5206333,7,'[{3,3178},{222,1587}]','[{255,36160007,5852}]'),(5206333,8,'[{3,3552},{222,1702}]','[{255,36160007,6113}]'),(5206333,9,'[{3,3930},{222,1819}]','[{255,36160007,6386}]'),(5206333,10,'[{3,4312},{222,1938}]','[{255,36160007,6668}]'),(5206333,11,'[{3,4700},{222,2059}]','[{255,36160007,6962}]'),(5206333,12,'[{3,5092},{222,2182}]','[{255,36160007,7268}]'),(5206333,13,'[{3,5488},{222,2307}]','[{255,36160007,7587}]'),(5206333,14,'[{3,5888},{222,2434}]','[{255,36160007,7919}]'),(5206333,15,'[{3,6294},{222,2563}]','[{255,36160007,8267}]'),(5206333,16,'[{3,6704},{222,2694}]','[{255,36160007,8628}]'),(5206333,17,'[{3,7118},{222,2827}]','[{255,36160007,9006}]'),(5206333,18,'[{3,7538},{222,2962}]','[{255,36160007,9402}]'),(5206333,19,'[{3,7962},{222,3099}]','[{255,36160007,9818}]'),(5206333,20,'[{3,8390},{222,3238}]','[{255,36160007,10253}]'),(5206333,21,'[{3,8824},{222,3379}]','[{255,36160007,10710}]'),(5206333,22,'[{3,9262},{222,3522}]','[{255,36160007,11049}]'),(5206333,23,'[{3,9704},{222,3667}]','[{255,36160007,11396}]'),(5206333,24,'[{3,10150},{222,3814}]','[{255,36160007,11753}]'),(5206333,25,'[{3,10602},{222,3963}]','[{255,36160007,12119}]'),(5206333,26,'[{3,11058},{222,4114}]','[{255,36160007,12495}]'),(5206333,27,'[{3,11518},{222,4267}]','[{255,36160007,12882}]'),(5206333,28,'[{3,11984},{222,4422}]','[{255,36160007,13278}]'),(5206333,29,'[{3,12454},{222,4579}]','[{255,36160007,13685}]'),(5206333,30,'[{3,12928},{222,4738}]','[{255,36160007,14105}]'),(5206333,31,'[{3,13408},{222,4899}]','[{255,36160007,14535}]'),(5206333,32,'[{3,13892},{222,5062}]','[{255,36160007,14979}]'),(5206333,33,'[{3,14380},{222,5227}]','[{255,36160007,15435}]'),(5206333,34,'[{3,14874},{222,5394}]','[{255,36160007,15906}]'),(5206333,35,'[{3,15372},{222,5563}]','[{255,36160007,16391}]'),(5206333,36,'[{3,15874},{222,5734}]','[{255,36160007,16889}]'),(5206333,37,'[{3,16380},{222,5907}]','[{255,36160007,17405}]'),(5206333,38,'[{3,16892},{222,6082}]','[{255,36160007,17936}]'),(5206333,39,'[{3,17408},{222,6259}]','[{255,36160007,18483}]'),(5206333,40,'[{3,17928},{222,6438}]','[{255,36160007,19050}]'),(5206333,41,'[{3,18454},{222,6619}]','[{255,36160007,19635}]'),(5206333,42,'[{3,18984},{222,6801}]','[{255,36160007,20105}]'),(5206333,43,'[{3,19518},{222,6985}]','[{255,36160007,20583}]'),(5206333,44,'[{3,20058},{222,7171}]','[{255,36160007,21071}]'),(5206333,45,'[{3,20602},{222,7359}]','[{255,36160007,21569}]'),(5206333,46,'[{3,21150},{222,7549}]','[{255,36160007,22079}]'),(5206333,47,'[{3,21702},{222,7741}]','[{255,36160007,22598}]'),(5206333,48,'[{3,22260},{222,7935}]','[{255,36160007,23129}]'),(5206333,49,'[{3,22822},{222,8131}]','[{255,36160007,23670}]'),(5206333,50,'[{3,23388},{222,8329}]','[{255,36160007,24225}]'),(5206333,51,'[{3,23960},{222,8529}]','[{255,36160007,24791}]'),(5206333,52,'[{3,24536},{222,8731}]','[{255,36160007,25371}]'),(5206333,53,'[{3,25116},{222,8935}]','[{255,36160007,25964}]'),(5206333,54,'[{3,25702},{222,9141}]','[{255,36160007,26570}]'),(5206333,55,'[{3,26292},{222,9349}]','[{255,36160007,27191}]'),(5206333,56,'[{3,26886},{222,9559}]','[{255,36160007,27825}]'),(5206333,57,'[{3,27486},{222,9771}]','[{255,36160007,28475}]'),(5206333,58,'[{3,28090},{222,9985}]','[{255,36160007,29141}]'),(5206333,59,'[{3,28698},{222,10201}]','[{255,36160007,29823}]'),(5206333,60,'[{3,29310},{222,10419}]','[{255,36160007,30521}]'),(5206333,61,'[{3,29928},{222,10639}]','[{255,36160007,31238}]'),(5206333,62,'[{3,30550},{222,10861}]','[{255,36160007,31973}]'),(5206333,63,'[{3,31176},{222,11085}]','[{255,36160007,32726}]'),(5206333,64,'[{3,31808},{222,11311}]','[{255,36160007,33498}]'),(5206333,65,'[{3,32444},{222,11539}]','[{255,36160007,34292}]'),(5206333,66,'[{3,33084},{222,11769}]','[{255,36160007,35105}]'),(5206333,67,'[{3,33730},{222,12001}]','[{255,36160007,35942}]'),(5206333,68,'[{3,34380},{222,12235}]','[{255,36160007,36801}]'),(5206333,69,'[{3,35034},{222,12471}]','[{255,36160007,37685}]'),(5206333,70,'[{3,35692},{222,12709}]','[{255,36160007,38592}]'),(5206333,71,'[{3,36356},{222,12949}]','[{255,36160007,39525}]'),(5206333,72,'[{3,37024},{222,13191}]','[{255,36160007,40487}]'),(5206333,73,'[{3,37696},{222,13435}]','[{255,36160007,41475}]'),(5206333,74,'[{3,38374},{222,13681}]','[{255,36160007,42494}]'),(5206333,75,'[{3,39056},{222,13928}]','[{255,36160007,43544}]'),(5206333,76,'[{3,39742},{222,14177}]','[{255,36160007,44397}]'),(5206333,77,'[{3,40434},{222,14428}]','[{255,36160007,45269}]'),(5206333,78,'[{3,41130},{222,14681}]','[{255,36160007,46160}]'),(5206333,79,'[{3,41830},{222,14936}]','[{255,36160007,47069}]'),(5206333,80,'[{3,42536},{222,15193}]','[{255,36160007,47996}]'),(5206333,81,'[{3,43246},{222,15452}]','[{255,36160007,48944}]'),(5206333,82,'[{3,43960},{222,15713}]','[{255,36160007,49913}]'),(5206333,83,'[{3,44678},{222,15976}]','[{255,36160007,50903}]'),(5206333,84,'[{3,45402},{222,16241}]','[{255,36160007,51914}]'),(5206333,85,'[{3,46130},{222,16508}]','[{255,36160007,52949}]'),(5206333,86,'[{3,46862},{222,16777}]','[{255,36160007,54006}]'),(5206333,87,'[{3,47600},{222,17048}]','[{255,36160007,55089}]'),(5206333,88,'[{3,48342},{222,17321}]','[{255,36160007,56198}]'),(5206333,89,'[{3,49088},{222,17596}]','[{255,36160007,57330}]'),(5206333,90,'[{3,49840},{222,17873}]','[{255,36160007,58491}]'),(5206333,91,'[{3,50596},{222,18152}]','[{255,36160007,59679}]'),(5206333,92,'[{3,51356},{222,18433}]','[{255,36160007,60897}]'),(5206333,93,'[{3,52120},{222,18716}]','[{255,36160007,62145}]'),(5206333,94,'[{3,52890},{222,19001}]','[{255,36160007,63423}]'),(5206333,95,'[{3,53664},{222,19288}]','[{255,36160007,64734}]'),(5206333,96,'[{3,54442},{222,19577}]','[{255,36160007,66080}]'),(5206333,97,'[{3,55226},{222,19868}]','[{255,36160007,67460}]'),(5206333,98,'[{3,56014},{222,20161}]','[{255,36160007,68876}]'),(5206333,99,'[{3,56806},{222,20456}]','[{255,36160007,70329}]'),(5206333,100,'[{3,57604},{222,20753}]','[{255,36160007,0}]'),(5206334,1,'[{3,1848},{222,1361}]','[{255,36160007,5250}]'),(5206334,2,'[{3,2352},{222,1512}]','[{255,36160007,5499}]'),(5206334,3,'[{3,2862},{222,1666}]','[{255,36160007,5757}]'),(5206334,4,'[{3,3380},{222,1823}]','[{255,36160007,6024}]'),(5206334,5,'[{3,3904},{222,1983}]','[{255,36160007,6300}]'),(5206334,6,'[{3,4434},{222,2146}]','[{255,36160007,6587}]'),(5206334,7,'[{3,4972},{222,2312}]','[{255,36160007,6884}]'),(5206334,8,'[{3,5516},{222,2480}]','[{255,36160007,7191}]'),(5206334,9,'[{3,6068},{222,2651}]','[{255,36160007,7512}]'),(5206334,10,'[{3,6626},{222,2825}]','[{255,36160007,7844}]'),(5206334,11,'[{3,7190},{222,3002}]','[{255,36160007,8190}]'),(5206334,12,'[{3,7762},{222,3182}]','[{255,36160007,8550}]'),(5206334,13,'[{3,8340},{222,3365}]','[{255,36160007,8925}]'),(5206334,14,'[{3,8924},{222,3551}]','[{255,36160007,9317}]'),(5206334,15,'[{3,9516},{222,3740}]','[{255,36160007,9725}]'),(5206334,16,'[{3,10114},{222,3931}]','[{255,36160007,10151}]'),(5206334,17,'[{3,10718},{222,4125}]','[{255,36160007,10596}]'),(5206334,18,'[{3,11330},{222,4322}]','[{255,36160007,11061}]'),(5206334,19,'[{3,11948},{222,4522}]','[{255,36160007,11550}]'),(5206334,20,'[{3,12572},{222,4725}]','[{255,36160007,12062}]'),(5206334,21,'[{3,13204},{222,4931}]','[{255,36160007,12600}]'),(5206334,22,'[{3,13842},{222,5140}]','[{255,36160007,12999}]'),(5206334,23,'[{3,14488},{222,5352}]','[{255,36160007,13407}]'),(5206334,24,'[{3,15140},{222,5566}]','[{255,36160007,13827}]'),(5206334,25,'[{3,15798},{222,5783}]','[{255,36160007,14258}]'),(5206334,26,'[{3,16464},{222,6003}]','[{255,36160007,14700}]'),(5206334,27,'[{3,17136},{222,6226}]','[{255,36160007,15155}]'),(5206334,28,'[{3,17814},{222,6452}]','[{255,36160007,15621}]'),(5206334,29,'[{3,18500},{222,6681}]','[{255,36160007,16100}]'),(5206334,30,'[{3,19192},{222,6913}]','[{255,36160007,16593}]'),(5206334,31,'[{3,19890},{222,7148}]','[{255,36160007,17100}]'),(5206334,32,'[{3,20596},{222,7385}]','[{255,36160007,17622}]'),(5206334,33,'[{3,21308},{222,7625}]','[{255,36160007,18159}]'),(5206334,34,'[{3,22028},{222,7868}]','[{255,36160007,18713}]'),(5206334,35,'[{3,22754},{222,8114}]','[{255,36160007,19283}]'),(5206334,36,'[{3,23486},{222,8363}]','[{255,36160007,19869}]'),(5206334,37,'[{3,24226},{222,8615}]','[{255,36160007,20475}]'),(5206334,38,'[{3,24972},{222,8870}]','[{255,36160007,21101}]'),(5206334,39,'[{3,25724},{222,9127}]','[{255,36160007,21746}]'),(5206334,40,'[{3,26484},{222,9387}]','[{255,36160007,22412}]'),(5206334,41,'[{3,27250},{222,9650}]','[{255,36160007,23100}]'),(5206334,42,'[{3,28022},{222,9916}]','[{255,36160007,23652}]'),(5206334,43,'[{3,28802},{222,10185}]','[{255,36160007,24215}]'),(5206334,44,'[{3,29588},{222,10457}]','[{255,36160007,24789}]'),(5206334,45,'[{3,30380},{222,10732}]','[{255,36160007,25376}]'),(5206334,46,'[{3,31180},{222,11010}]','[{255,36160007,25974}]'),(5206334,47,'[{3,31986},{222,11290}]','[{255,36160007,26585}]'),(5206334,48,'[{3,32800},{222,11573}]','[{255,36160007,27210}]'),(5206334,49,'[{3,33620},{222,11859}]','[{255,36160007,27848}]'),(5206334,50,'[{3,34446},{222,12148}]','[{255,36160007,28500}]'),(5206334,51,'[{3,35280},{222,12440}]','[{255,36160007,29166}]'),(5206334,52,'[{3,36120},{222,12735}]','[{255,36160007,29849}]'),(5206334,53,'[{3,36966},{222,13033}]','[{255,36160007,30546}]'),(5206334,54,'[{3,37820},{222,13334}]','[{255,36160007,31259}]'),(5206334,55,'[{3,38680},{222,13637}]','[{255,36160007,31989}]'),(5206334,56,'[{3,39546},{222,13943}]','[{255,36160007,32736}]'),(5206334,57,'[{3,40420},{222,14252}]','[{255,36160007,33500}]'),(5206334,58,'[{3,41300},{222,14564}]','[{255,36160007,34283}]'),(5206334,59,'[{3,42188},{222,14879}]','[{255,36160007,35085}]'),(5206334,60,'[{3,43082},{222,15197}]','[{255,36160007,35907}]'),(5206334,61,'[{3,43982},{222,15518}]','[{255,36160007,36750}]'),(5206334,62,'[{3,44890},{222,15842}]','[{255,36160007,37614}]'),(5206334,63,'[{3,45804},{222,16168}]','[{255,36160007,38501}]'),(5206334,64,'[{3,46724},{222,16497}]','[{255,36160007,39410}]'),(5206334,65,'[{3,47652},{222,16829}]','[{255,36160007,40343}]'),(5206334,66,'[{3,48586},{222,17164}]','[{255,36160007,41300}]'),(5206334,67,'[{3,49526},{222,17502}]','[{255,36160007,42284}]'),(5206334,68,'[{3,50474},{222,17843}]','[{255,36160007,43295}]'),(5206334,69,'[{3,51428},{222,18187}]','[{255,36160007,44334}]'),(5206334,70,'[{3,52388},{222,18534}]','[{255,36160007,45402}]'),(5206334,71,'[{3,53356},{222,18883}]','[{255,36160007,46500}]'),(5206334,72,'[{3,54330},{222,19235}]','[{255,36160007,47631}]'),(5206334,73,'[{3,55312},{222,19590}]','[{255,36160007,48794}]'),(5206334,74,'[{3,56300},{222,19948}]','[{255,36160007,49992}]'),(5206334,75,'[{3,57294},{222,20309}]','[{255,36160007,51228}]'),(5206334,76,'[{3,58296},{222,20673}]','[{255,36160007,52232}]'),(5206334,77,'[{3,59304},{222,21040}]','[{255,36160007,53258}]'),(5206334,78,'[{3,60318},{222,21410}]','[{255,36160007,54305}]'),(5206334,79,'[{3,61340},{222,21782}]','[{255,36160007,55374}]'),(5206334,80,'[{3,62368},{222,22157}]','[{255,36160007,56466}]'),(5206334,81,'[{3,63402},{222,22535}]','[{255,36160007,57581}]'),(5206334,82,'[{3,64444},{222,22916}]','[{255,36160007,58721}]'),(5206334,83,'[{3,65492},{222,23300}]','[{255,36160007,59885}]'),(5206334,84,'[{3,66548},{222,23687}]','[{255,36160007,61076}]'),(5206334,85,'[{3,67610},{222,24077}]','[{255,36160007,62292}]'),(5206334,86,'[{3,68678},{222,24470}]','[{255,36160007,63537}]'),(5206334,87,'[{3,69754},{222,24865}]','[{255,36160007,64811}]'),(5206334,88,'[{3,70836},{222,25263}]','[{255,36160007,66114}]'),(5206334,89,'[{3,71924},{222,25664}]','[{255,36160007,67448}]'),(5206334,90,'[{3,73020},{222,26068}]','[{255,36160007,68813}]'),(5206334,91,'[{3,74122},{222,26475}]','[{255,36160007,70211}]'),(5206334,92,'[{3,75230},{222,26885}]','[{255,36160007,71643}]'),(5206334,93,'[{3,76346},{222,27298}]','[{255,36160007,73112}]'),(5206334,94,'[{3,77468},{222,27713}]','[{255,36160007,74616}]'),(5206334,95,'[{3,78596},{222,28131}]','[{255,36160007,76158}]'),(5206334,96,'[{3,79732},{222,28552}]','[{255,36160007,77741}]'),(5206334,97,'[{3,80874},{222,28976}]','[{255,36160007,79364}]'),(5206334,98,'[{3,82024},{222,29403}]','[{255,36160007,81030}]'),(5206334,99,'[{3,83180},{222,29833}]','[{255,36160007,82740}]'),(5206334,100,'[{3,84342},{222,30266}]','[{255,36160007,0}]'),(5206343,1,'[{4,1036},{224,518}]','[{255,36160007,4463}]'),(5206343,2,'[{4,1382},{224,576}]','[{255,36160007,4674}]'),(5206343,3,'[{4,1732},{224,635}]','[{255,36160007,4893}]'),(5206343,4,'[{4,2086},{224,695}]','[{255,36160007,5121}]'),(5206343,5,'[{4,2446},{224,756}]','[{255,36160007,5355}]'),(5206343,6,'[{4,2810},{224,818}]','[{255,36160007,5598}]'),(5206343,7,'[{4,3178},{224,881}]','[{255,36160007,5852}]'),(5206343,8,'[{4,3552},{224,945}]','[{255,36160007,6113}]'),(5206343,9,'[{4,3930},{224,1010}]','[{255,36160007,6386}]'),(5206343,10,'[{4,4312},{224,1076}]','[{255,36160007,6668}]'),(5206343,11,'[{4,4700},{224,1143}]','[{255,36160007,6962}]'),(5206343,12,'[{4,5092},{224,1212}]','[{255,36160007,7268}]'),(5206343,13,'[{4,5488},{224,1282}]','[{255,36160007,7587}]'),(5206343,14,'[{4,5888},{224,1353}]','[{255,36160007,7919}]'),(5206343,15,'[{4,6294},{224,1425}]','[{255,36160007,8267}]'),(5206343,16,'[{4,6704},{224,1498}]','[{255,36160007,8628}]'),(5206343,17,'[{4,7118},{224,1572}]','[{255,36160007,9006}]'),(5206343,18,'[{4,7538},{224,1647}]','[{255,36160007,9402}]'),(5206343,19,'[{4,7962},{224,1723}]','[{255,36160007,9818}]'),(5206343,20,'[{4,8390},{224,1800}]','[{255,36160007,10253}]'),(5206343,21,'[{4,8824},{224,1878}]','[{255,36160007,10710}]'),(5206343,22,'[{4,9262},{224,1957}]','[{255,36160007,11049}]'),(5206343,23,'[{4,9704},{224,2038}]','[{255,36160007,11396}]'),(5206343,24,'[{4,10150},{224,2120}]','[{255,36160007,11753}]'),(5206343,25,'[{4,10602},{224,2203}]','[{255,36160007,12119}]'),(5206343,26,'[{4,11058},{224,2287}]','[{255,36160007,12495}]'),(5206343,27,'[{4,11518},{224,2372}]','[{255,36160007,12882}]'),(5206343,28,'[{4,11984},{224,2458}]','[{255,36160007,13278}]'),(5206343,29,'[{4,12454},{224,2545}]','[{255,36160007,13685}]'),(5206343,30,'[{4,12928},{224,2633}]','[{255,36160007,14105}]'),(5206343,31,'[{4,13408},{224,2722}]','[{255,36160007,14535}]'),(5206343,32,'[{4,13892},{224,2812}]','[{255,36160007,14979}]'),(5206343,33,'[{4,14380},{224,2904}]','[{255,36160007,15435}]'),(5206343,34,'[{4,14874},{224,2997}]','[{255,36160007,15906}]'),(5206343,35,'[{4,15372},{224,3091}]','[{255,36160007,16391}]'),(5206343,36,'[{4,15874},{224,3186}]','[{255,36160007,16889}]'),(5206343,37,'[{4,16380},{224,3282}]','[{255,36160007,17405}]'),(5206343,38,'[{4,16892},{224,3379}]','[{255,36160007,17936}]'),(5206343,39,'[{4,17408},{224,3477}]','[{255,36160007,18483}]'),(5206343,40,'[{4,17928},{224,3576}]','[{255,36160007,19050}]'),(5206343,41,'[{4,18454},{224,3676}]','[{255,36160007,19635}]'),(5206343,42,'[{4,18984},{224,3777}]','[{255,36160007,20105}]'),(5206343,43,'[{4,19518},{224,3879}]','[{255,36160007,20583}]'),(5206343,44,'[{4,20058},{224,3983}]','[{255,36160007,21071}]'),(5206343,45,'[{4,20602},{224,4088}]','[{255,36160007,21569}]'),(5206343,46,'[{4,21150},{224,4194}]','[{255,36160007,22079}]'),(5206343,47,'[{4,21702},{224,4301}]','[{255,36160007,22598}]'),(5206343,48,'[{4,22260},{224,4409}]','[{255,36160007,23129}]'),(5206343,49,'[{4,22822},{224,4518}]','[{255,36160007,23670}]'),(5206343,50,'[{4,23388},{224,4628}]','[{255,36160007,24225}]'),(5206343,51,'[{4,23960},{224,4739}]','[{255,36160007,24791}]'),(5206343,52,'[{4,24536},{224,4851}]','[{255,36160007,25371}]'),(5206343,53,'[{4,25116},{224,4964}]','[{255,36160007,25964}]'),(5206343,54,'[{4,25702},{224,5079}]','[{255,36160007,26570}]'),(5206343,55,'[{4,26292},{224,5195}]','[{255,36160007,27191}]'),(5206343,56,'[{4,26886},{224,5312}]','[{255,36160007,27825}]'),(5206343,57,'[{4,27486},{224,5430}]','[{255,36160007,28475}]'),(5206343,58,'[{4,28090},{224,5549}]','[{255,36160007,29141}]'),(5206343,59,'[{4,28698},{224,5669}]','[{255,36160007,29823}]'),(5206343,60,'[{4,29310},{224,5790}]','[{255,36160007,30521}]'),(5206343,61,'[{4,29928},{224,5912}]','[{255,36160007,31238}]'),(5206343,62,'[{4,30550},{224,6035}]','[{255,36160007,31973}]'),(5206343,63,'[{4,31176},{224,6159}]','[{255,36160007,32726}]'),(5206343,64,'[{4,31808},{224,6284}]','[{255,36160007,33498}]'),(5206343,65,'[{4,32444},{224,6411}]','[{255,36160007,34292}]'),(5206343,66,'[{4,33084},{224,6539}]','[{255,36160007,35105}]'),(5206343,67,'[{4,33730},{224,6668}]','[{255,36160007,35942}]'),(5206343,68,'[{4,34380},{224,6798}]','[{255,36160007,36801}]'),(5206343,69,'[{4,35034},{224,6929}]','[{255,36160007,37685}]'),(5206343,70,'[{4,35692},{224,7061}]','[{255,36160007,38592}]'),(5206343,71,'[{4,36356},{224,7194}]','[{255,36160007,39525}]'),(5206343,72,'[{4,37024},{224,7328}]','[{255,36160007,40487}]'),(5206343,73,'[{4,37696},{224,7463}]','[{255,36160007,41475}]'),(5206343,74,'[{4,38374},{224,7599}]','[{255,36160007,42494}]'),(5206343,75,'[{4,39056},{224,7736}]','[{255,36160007,43544}]'),(5206343,76,'[{4,39742},{224,7875}]','[{255,36160007,44397}]'),(5206343,77,'[{4,40434},{224,8015}]','[{255,36160007,45269}]'),(5206343,78,'[{4,41130},{224,8156}]','[{255,36160007,46160}]'),(5206343,79,'[{4,41830},{224,8298}]','[{255,36160007,47069}]'),(5206343,80,'[{4,42536},{224,8441}]','[{255,36160007,47996}]'),(5206343,81,'[{4,43246},{224,8585}]','[{255,36160007,48944}]'),(5206343,82,'[{4,43960},{224,8730}]','[{255,36160007,49913}]'),(5206343,83,'[{4,44678},{224,8876}]','[{255,36160007,50903}]'),(5206343,84,'[{4,45402},{224,9023}]','[{255,36160007,51914}]'),(5206343,85,'[{4,46130},{224,9171}]','[{255,36160007,52949}]'),(5206343,86,'[{4,46862},{224,9321}]','[{255,36160007,54006}]'),(5206343,87,'[{4,47600},{224,9472}]','[{255,36160007,55089}]'),(5206343,88,'[{4,48342},{224,9624}]','[{255,36160007,56198}]'),(5206343,89,'[{4,49088},{224,9777}]','[{255,36160007,57330}]'),(5206343,90,'[{4,49840},{224,9931}]','[{255,36160007,58491}]'),(5206343,91,'[{4,50596},{224,10086}]','[{255,36160007,59679}]'),(5206343,92,'[{4,51356},{224,10242}]','[{255,36160007,60897}]'),(5206343,93,'[{4,52120},{224,10399}]','[{255,36160007,62145}]'),(5206343,94,'[{4,52890},{224,10557}]','[{255,36160007,63423}]'),(5206343,95,'[{4,53664},{224,10716}]','[{255,36160007,64734}]'),(5206343,96,'[{4,54442},{224,10876}]','[{255,36160007,66080}]'),(5206343,97,'[{4,55226},{224,11038}]','[{255,36160007,67460}]'),(5206343,98,'[{4,56014},{224,11201}]','[{255,36160007,68876}]'),(5206343,99,'[{4,56806},{224,11365}]','[{255,36160007,70329}]'),(5206343,100,'[{4,57604},{224,11530}]','[{255,36160007,0}]'),(5206344,1,'[{4,1848},{224,756}]','[{255,36160007,5250}]'),(5206344,2,'[{4,2352},{224,840}]','[{255,36160007,5499}]'),(5206344,3,'[{4,2862},{224,926}]','[{255,36160007,5757}]'),(5206344,4,'[{4,3380},{224,1013}]','[{255,36160007,6024}]'),(5206344,5,'[{4,3904},{224,1102}]','[{255,36160007,6300}]'),(5206344,6,'[{4,4434},{224,1192}]','[{255,36160007,6587}]'),(5206344,7,'[{4,4972},{224,1284}]','[{255,36160007,6884}]'),(5206344,8,'[{4,5516},{224,1378}]','[{255,36160007,7191}]'),(5206344,9,'[{4,6068},{224,1473}]','[{255,36160007,7512}]'),(5206344,10,'[{4,6626},{224,1570}]','[{255,36160007,7844}]'),(5206344,11,'[{4,7190},{224,1668}]','[{255,36160007,8190}]'),(5206344,12,'[{4,7762},{224,1768}]','[{255,36160007,8550}]'),(5206344,13,'[{4,8340},{224,1870}]','[{255,36160007,8925}]'),(5206344,14,'[{4,8924},{224,1973}]','[{255,36160007,9317}]'),(5206344,15,'[{4,9516},{224,2078}]','[{255,36160007,9725}]'),(5206344,16,'[{4,10114},{224,2184}]','[{255,36160007,10151}]'),(5206344,17,'[{4,10718},{224,2292}]','[{255,36160007,10596}]'),(5206344,18,'[{4,11330},{224,2402}]','[{255,36160007,11061}]'),(5206344,19,'[{4,11948},{224,2513}]','[{255,36160007,11550}]'),(5206344,20,'[{4,12572},{224,2626}]','[{255,36160007,12062}]'),(5206344,21,'[{4,13204},{224,2740}]','[{255,36160007,12600}]'),(5206344,22,'[{4,13842},{224,2856}]','[{255,36160007,12999}]'),(5206344,23,'[{4,14488},{224,2974}]','[{255,36160007,13407}]'),(5206344,24,'[{4,15140},{224,3093}]','[{255,36160007,13827}]'),(5206344,25,'[{4,15798},{224,3214}]','[{255,36160007,14258}]'),(5206344,26,'[{4,16464},{224,3336}]','[{255,36160007,14700}]'),(5206344,27,'[{4,17136},{224,3460}]','[{255,36160007,15155}]'),(5206344,28,'[{4,17814},{224,3585}]','[{255,36160007,15621}]'),(5206344,29,'[{4,18500},{224,3712}]','[{255,36160007,16100}]'),(5206344,30,'[{4,19192},{224,3841}]','[{255,36160007,16593}]'),(5206344,31,'[{4,19890},{224,3971}]','[{255,36160007,17100}]'),(5206344,32,'[{4,20596},{224,4103}]','[{255,36160007,17622}]'),(5206344,33,'[{4,21308},{224,4236}]','[{255,36160007,18159}]'),(5206344,34,'[{4,22028},{224,4371}]','[{255,36160007,18713}]'),(5206344,35,'[{4,22754},{224,4508}]','[{255,36160007,19283}]'),(5206344,36,'[{4,23486},{224,4646}]','[{255,36160007,19869}]'),(5206344,37,'[{4,24226},{224,4786}]','[{255,36160007,20475}]'),(5206344,38,'[{4,24972},{224,4927}]','[{255,36160007,21101}]'),(5206344,39,'[{4,25724},{224,5070}]','[{255,36160007,21746}]'),(5206344,40,'[{4,26484},{224,5215}]','[{255,36160007,22412}]'),(5206344,41,'[{4,27250},{224,5361}]','[{255,36160007,23100}]'),(5206344,42,'[{4,28022},{224,5509}]','[{255,36160007,23652}]'),(5206344,43,'[{4,28802},{224,5658}]','[{255,36160007,24215}]'),(5206344,44,'[{4,29588},{224,5809}]','[{255,36160007,24789}]'),(5206344,45,'[{4,30380},{224,5962}]','[{255,36160007,25376}]'),(5206344,46,'[{4,31180},{224,6116}]','[{255,36160007,25974}]'),(5206344,47,'[{4,31986},{224,6272}]','[{255,36160007,26585}]'),(5206344,48,'[{4,32800},{224,6429}]','[{255,36160007,27210}]'),(5206344,49,'[{4,33620},{224,6588}]','[{255,36160007,27848}]'),(5206344,50,'[{4,34446},{224,6749}]','[{255,36160007,28500}]'),(5206344,51,'[{4,35280},{224,6911}]','[{255,36160007,29166}]'),(5206344,52,'[{4,36120},{224,7075}]','[{255,36160007,29849}]'),(5206344,53,'[{4,36966},{224,7240}]','[{255,36160007,30546}]'),(5206344,54,'[{4,37820},{224,7407}]','[{255,36160007,31259}]'),(5206344,55,'[{4,38680},{224,7576}]','[{255,36160007,31989}]'),(5206344,56,'[{4,39546},{224,7746}]','[{255,36160007,32736}]'),(5206344,57,'[{4,40420},{224,7918}]','[{255,36160007,33500}]'),(5206344,58,'[{4,41300},{224,8091}]','[{255,36160007,34283}]'),(5206344,59,'[{4,42188},{224,8266}]','[{255,36160007,35085}]'),(5206344,60,'[{4,43082},{224,8443}]','[{255,36160007,35907}]'),(5206344,61,'[{4,43982},{224,8621}]','[{255,36160007,36750}]'),(5206344,62,'[{4,44890},{224,8801}]','[{255,36160007,37614}]'),(5206344,63,'[{4,45804},{224,8982}]','[{255,36160007,38501}]'),(5206344,64,'[{4,46724},{224,9165}]','[{255,36160007,39410}]'),(5206344,65,'[{4,47652},{224,9350}]','[{255,36160007,40343}]'),(5206344,66,'[{4,48586},{224,9536}]','[{255,36160007,41300}]'),(5206344,67,'[{4,49526},{224,9724}]','[{255,36160007,42284}]'),(5206344,68,'[{4,50474},{224,9913}]','[{255,36160007,43295}]'),(5206344,69,'[{4,51428},{224,10104}]','[{255,36160007,44334}]'),(5206344,70,'[{4,52388},{224,10297}]','[{255,36160007,45402}]'),(5206344,71,'[{4,53356},{224,10491}]','[{255,36160007,46500}]'),(5206344,72,'[{4,54330},{224,10687}]','[{255,36160007,47631}]'),(5206344,73,'[{4,55312},{224,10884}]','[{255,36160007,48794}]'),(5206344,74,'[{4,56300},{224,11083}]','[{255,36160007,49992}]'),(5206344,75,'[{4,57294},{224,11284}]','[{255,36160007,51228}]'),(5206344,76,'[{4,58296},{224,11486}]','[{255,36160007,52232}]'),(5206344,77,'[{4,59304},{224,11690}]','[{255,36160007,53258}]'),(5206344,78,'[{4,60318},{224,11895}]','[{255,36160007,54305}]'),(5206344,79,'[{4,61340},{224,12102}]','[{255,36160007,55374}]'),(5206344,80,'[{4,62368},{224,12310}]','[{255,36160007,56466}]'),(5206344,81,'[{4,63402},{224,12520}]','[{255,36160007,57581}]'),(5206344,82,'[{4,64444},{224,12732}]','[{255,36160007,58721}]'),(5206344,83,'[{4,65492},{224,12945}]','[{255,36160007,59885}]'),(5206344,84,'[{4,66548},{224,13160}]','[{255,36160007,61076}]'),(5206344,85,'[{4,67610},{224,13376}]','[{255,36160007,62292}]'),(5206344,86,'[{4,68678},{224,13594}]','[{255,36160007,63537}]'),(5206344,87,'[{4,69754},{224,13814}]','[{255,36160007,64811}]'),(5206344,88,'[{4,70836},{224,14035}]','[{255,36160007,66114}]'),(5206344,89,'[{4,71924},{224,14258}]','[{255,36160007,67448}]'),(5206344,90,'[{4,73020},{224,14482}]','[{255,36160007,68813}]'),(5206344,91,'[{4,74122},{224,14708}]','[{255,36160007,70211}]'),(5206344,92,'[{4,75230},{224,14936}]','[{255,36160007,71643}]'),(5206344,93,'[{4,76346},{224,15165}]','[{255,36160007,73112}]'),(5206344,94,'[{4,77468},{224,15396}]','[{255,36160007,74616}]'),(5206344,95,'[{4,78596},{224,15628}]','[{255,36160007,76158}]'),(5206344,96,'[{4,79732},{224,15862}]','[{255,36160007,77741}]'),(5206344,97,'[{4,80874},{224,16098}]','[{255,36160007,79364}]'),(5206344,98,'[{4,82024},{224,16335}]','[{255,36160007,81030}]'),(5206344,99,'[{4,83180},{224,16574}]','[{255,36160007,82740}]'),(5206344,100,'[{4,84342},{224,16814}]','[{255,36160007,0}]'),(5206353,1,'[{5,518},{225,608}]','[{255,36160007,4463}]'),(5206353,2,'[{5,690},{225,676}]','[{255,36160007,4674}]'),(5206353,3,'[{5,866},{225,745}]','[{255,36160007,4893}]'),(5206353,4,'[{5,1044},{225,815}]','[{255,36160007,5121}]'),(5206353,5,'[{5,1224},{225,886}]','[{255,36160007,5355}]'),(5206353,6,'[{5,1406},{225,959}]','[{255,36160007,5598}]'),(5206353,7,'[{5,1590},{225,1033}]','[{255,36160007,5852}]'),(5206353,8,'[{5,1776},{225,1108}]','[{255,36160007,6113}]'),(5206353,9,'[{5,1964},{225,1184}]','[{255,36160007,6386}]'),(5206353,10,'[{5,2156},{225,1262}]','[{255,36160007,6668}]'),(5206353,11,'[{5,2350},{225,1341}]','[{255,36160007,6962}]'),(5206353,12,'[{5,2546},{225,1421}]','[{255,36160007,7268}]'),(5206353,13,'[{5,2744},{225,1503}]','[{255,36160007,7587}]'),(5206353,14,'[{5,2944},{225,1586}]','[{255,36160007,7919}]'),(5206353,15,'[{5,3146},{225,1670}]','[{255,36160007,8267}]'),(5206353,16,'[{5,3352},{225,1755}]','[{255,36160007,8628}]'),(5206353,17,'[{5,3560},{225,1842}]','[{255,36160007,9006}]'),(5206353,18,'[{5,3770},{225,1930}]','[{255,36160007,9402}]'),(5206353,19,'[{5,3982},{225,2019}]','[{255,36160007,9818}]'),(5206353,20,'[{5,4196},{225,2110}]','[{255,36160007,10253}]'),(5206353,21,'[{5,4412},{225,2202}]','[{255,36160007,10710}]'),(5206353,22,'[{5,4630},{225,2295}]','[{255,36160007,11049}]'),(5206353,23,'[{5,4852},{225,2389}]','[{255,36160007,11396}]'),(5206353,24,'[{5,5076},{225,2485}]','[{255,36160007,11753}]'),(5206353,25,'[{5,5302},{225,2582}]','[{255,36160007,12119}]'),(5206353,26,'[{5,5530},{225,2680}]','[{255,36160007,12495}]'),(5206353,27,'[{5,5760},{225,2780}]','[{255,36160007,12882}]'),(5206353,28,'[{5,5992},{225,2881}]','[{255,36160007,13278}]'),(5206353,29,'[{5,6228},{225,2983}]','[{255,36160007,13685}]'),(5206353,30,'[{5,6466},{225,3086}]','[{255,36160007,14105}]'),(5206353,31,'[{5,6706},{225,3191}]','[{255,36160007,14535}]'),(5206353,32,'[{5,6948},{225,3297}]','[{255,36160007,14979}]'),(5206353,33,'[{5,7192},{225,3404}]','[{255,36160007,15435}]'),(5206353,34,'[{5,7438},{225,3513}]','[{255,36160007,15906}]'),(5206353,35,'[{5,7686},{225,3623}]','[{255,36160007,16391}]'),(5206353,36,'[{5,7938},{225,3734}]','[{255,36160007,16889}]'),(5206353,37,'[{5,8192},{225,3846}]','[{255,36160007,17405}]'),(5206353,38,'[{5,8448},{225,3960}]','[{255,36160007,17936}]'),(5206353,39,'[{5,8706},{225,4075}]','[{255,36160007,18483}]'),(5206353,40,'[{5,8966},{225,4191}]','[{255,36160007,19050}]'),(5206353,41,'[{5,9228},{225,4309}]','[{255,36160007,19635}]'),(5206353,42,'[{5,9492},{225,4428}]','[{255,36160007,20105}]'),(5206353,43,'[{5,9760},{225,4548}]','[{255,36160007,20583}]'),(5206353,44,'[{5,10030},{225,4669}]','[{255,36160007,21071}]'),(5206353,45,'[{5,10302},{225,4792}]','[{255,36160007,21569}]'),(5206353,46,'[{5,10576},{225,4916}]','[{255,36160007,22079}]'),(5206353,47,'[{5,10852},{225,5041}]','[{255,36160007,22598}]'),(5206353,48,'[{5,11130},{225,5167}]','[{255,36160007,23129}]'),(5206353,49,'[{5,11412},{225,5295}]','[{255,36160007,23670}]'),(5206353,50,'[{5,11696},{225,5424}]','[{255,36160007,24225}]'),(5206353,51,'[{5,11982},{225,5554}]','[{255,36160007,24791}]'),(5206353,52,'[{5,12270},{225,5686}]','[{255,36160007,25371}]'),(5206353,53,'[{5,12560},{225,5819}]','[{255,36160007,25964}]'),(5206353,54,'[{5,12852},{225,5953}]','[{255,36160007,26570}]'),(5206353,55,'[{5,13146},{225,6088}]','[{255,36160007,27191}]'),(5206353,56,'[{5,13444},{225,6225}]','[{255,36160007,27825}]'),(5206353,57,'[{5,13744},{225,6363}]','[{255,36160007,28475}]'),(5206353,58,'[{5,14046},{225,6502}]','[{255,36160007,29141}]'),(5206353,59,'[{5,14350},{225,6643}]','[{255,36160007,29823}]'),(5206353,60,'[{5,14656},{225,6785}]','[{255,36160007,30521}]'),(5206353,61,'[{5,14964},{225,6928}]','[{255,36160007,31238}]'),(5206353,62,'[{5,15276},{225,7072}]','[{255,36160007,31973}]'),(5206353,63,'[{5,15590},{225,7218}]','[{255,36160007,32726}]'),(5206353,64,'[{5,15906},{225,7365}]','[{255,36160007,33498}]'),(5206353,65,'[{5,16224},{225,7513}]','[{255,36160007,34292}]'),(5206353,66,'[{5,16544},{225,7663}]','[{255,36160007,35105}]'),(5206353,67,'[{5,16866},{225,7814}]','[{255,36160007,35942}]'),(5206353,68,'[{5,17190},{225,7966}]','[{255,36160007,36801}]'),(5206353,69,'[{5,17518},{225,8119}]','[{255,36160007,37685}]'),(5206353,70,'[{5,17848},{225,8274}]','[{255,36160007,38592}]'),(5206353,71,'[{5,18180},{225,8430}]','[{255,36160007,39525}]'),(5206353,72,'[{5,18514},{225,8587}]','[{255,36160007,40487}]'),(5206353,73,'[{5,18850},{225,8746}]','[{255,36160007,41475}]'),(5206353,74,'[{5,19188},{225,8906}]','[{255,36160007,42494}]'),(5206353,75,'[{5,19528},{225,9067}]','[{255,36160007,43544}]'),(5206353,76,'[{5,19872},{225,9229}]','[{255,36160007,44397}]'),(5206353,77,'[{5,20218},{225,9393}]','[{255,36160007,45269}]'),(5206353,78,'[{5,20566},{225,9558}]','[{255,36160007,46160}]'),(5206353,79,'[{5,20916},{225,9724}]','[{255,36160007,47069}]'),(5206353,80,'[{5,21268},{225,9892}]','[{255,36160007,47996}]'),(5206353,81,'[{5,21622},{225,10061}]','[{255,36160007,48944}]'),(5206353,82,'[{5,21980},{225,10231}]','[{255,36160007,49913}]'),(5206353,83,'[{5,22340},{225,10402}]','[{255,36160007,50903}]'),(5206353,84,'[{5,22702},{225,10575}]','[{255,36160007,51914}]'),(5206353,85,'[{5,23066},{225,10749}]','[{255,36160007,52949}]'),(5206353,86,'[{5,23432},{225,10924}]','[{255,36160007,54006}]'),(5206353,87,'[{5,23800},{225,11101}]','[{255,36160007,55089}]'),(5206353,88,'[{5,24170},{225,11279}]','[{255,36160007,56198}]'),(5206353,89,'[{5,24544},{225,11458}]','[{255,36160007,57330}]'),(5206353,90,'[{5,24920},{225,11638}]','[{255,36160007,58491}]'),(5206353,91,'[{5,25298},{225,11820}]','[{255,36160007,59679}]'),(5206353,92,'[{5,25678},{225,12003}]','[{255,36160007,60897}]'),(5206353,93,'[{5,26060},{225,12187}]','[{255,36160007,62145}]'),(5206353,94,'[{5,26444},{225,12372}]','[{255,36160007,63423}]'),(5206353,95,'[{5,26832},{225,12559}]','[{255,36160007,64734}]'),(5206353,96,'[{5,27222},{225,12747}]','[{255,36160007,66080}]'),(5206353,97,'[{5,27614},{225,12936}]','[{255,36160007,67460}]'),(5206353,98,'[{5,28008},{225,13127}]','[{255,36160007,68876}]'),(5206353,99,'[{5,28404},{225,13319}]','[{255,36160007,70329}]'),(5206353,100,'[{5,28802},{225,13512}]','[{255,36160007,0}]'),(5206354,1,'[{5,924},{225,886}]','[{255,36160007,5250}]'),(5206354,2,'[{5,1176},{225,984}]','[{255,36160007,5499}]'),(5206354,3,'[{5,1432},{225,1084}]','[{255,36160007,5757}]'),(5206354,4,'[{5,1690},{225,1186}]','[{255,36160007,6024}]'),(5206354,5,'[{5,1952},{225,1290}]','[{255,36160007,6300}]'),(5206354,6,'[{5,2218},{225,1396}]','[{255,36160007,6587}]'),(5206354,7,'[{5,2486},{225,1504}]','[{255,36160007,6884}]'),(5206354,8,'[{5,2758},{225,1614}]','[{255,36160007,7191}]'),(5206354,9,'[{5,3034},{225,1726}]','[{255,36160007,7512}]'),(5206354,10,'[{5,3312},{225,1839}]','[{255,36160007,7844}]'),(5206354,11,'[{5,3594},{225,1954}]','[{255,36160007,8190}]'),(5206354,12,'[{5,3880},{225,2071}]','[{255,36160007,8550}]'),(5206354,13,'[{5,4168},{225,2190}]','[{255,36160007,8925}]'),(5206354,14,'[{5,4460},{225,2311}]','[{255,36160007,9317}]'),(5206354,15,'[{5,4756},{225,2434}]','[{255,36160007,9725}]'),(5206354,16,'[{5,5056},{225,2559}]','[{255,36160007,10151}]'),(5206354,17,'[{5,5358},{225,2685}]','[{255,36160007,10596}]'),(5206354,18,'[{5,5664},{225,2813}]','[{255,36160007,11061}]'),(5206354,19,'[{5,5974},{225,2943}]','[{255,36160007,11550}]'),(5206354,20,'[{5,6286},{225,3075}]','[{255,36160007,12062}]'),(5206354,21,'[{5,6602},{225,3209}]','[{255,36160007,12600}]'),(5206354,22,'[{5,6922},{225,3345}]','[{255,36160007,12999}]'),(5206354,23,'[{5,7244},{225,3483}]','[{255,36160007,13407}]'),(5206354,24,'[{5,7570},{225,3623}]','[{255,36160007,13827}]'),(5206354,25,'[{5,7900},{225,3764}]','[{255,36160007,14258}]'),(5206354,26,'[{5,8232},{225,3907}]','[{255,36160007,14700}]'),(5206354,27,'[{5,8568},{225,4052}]','[{255,36160007,15155}]'),(5206354,28,'[{5,8908},{225,4199}]','[{255,36160007,15621}]'),(5206354,29,'[{5,9250},{225,4348}]','[{255,36160007,16100}]'),(5206354,30,'[{5,9596},{225,4499}]','[{255,36160007,16593}]'),(5206354,31,'[{5,9946},{225,4652}]','[{255,36160007,17100}]'),(5206354,32,'[{5,10298},{225,4807}]','[{255,36160007,17622}]'),(5206354,33,'[{5,10654},{225,4963}]','[{255,36160007,18159}]'),(5206354,34,'[{5,11014},{225,5121}]','[{255,36160007,18713}]'),(5206354,35,'[{5,11376},{225,5281}]','[{255,36160007,19283}]'),(5206354,36,'[{5,11742},{225,5443}]','[{255,36160007,19869}]'),(5206354,37,'[{5,12112},{225,5607}]','[{255,36160007,20475}]'),(5206354,38,'[{5,12484},{225,5773}]','[{255,36160007,21101}]'),(5206354,39,'[{5,12860},{225,5941}]','[{255,36160007,21746}]'),(5206354,40,'[{5,13240},{225,6111}]','[{255,36160007,22412}]'),(5206354,41,'[{5,13624},{225,6282}]','[{255,36160007,23100}]'),(5206354,42,'[{5,14010},{225,6455}]','[{255,36160007,23652}]'),(5206354,43,'[{5,14400},{225,6630}]','[{255,36160007,24215}]'),(5206354,44,'[{5,14794},{225,6807}]','[{255,36160007,24789}]'),(5206354,45,'[{5,15190},{225,6986}]','[{255,36160007,25376}]'),(5206354,46,'[{5,15590},{225,7167}]','[{255,36160007,25974}]'),(5206354,47,'[{5,15994},{225,7350}]','[{255,36160007,26585}]'),(5206354,48,'[{5,16400},{225,7534}]','[{255,36160007,27210}]'),(5206354,49,'[{5,16810},{225,7720}]','[{255,36160007,27848}]'),(5206354,50,'[{5,17224},{225,7908}]','[{255,36160007,28500}]'),(5206354,51,'[{5,17640},{225,8098}]','[{255,36160007,29166}]'),(5206354,52,'[{5,18060},{225,8290}]','[{255,36160007,29849}]'),(5206354,53,'[{5,18484},{225,8484}]','[{255,36160007,30546}]'),(5206354,54,'[{5,18910},{225,8680}]','[{255,36160007,31259}]'),(5206354,55,'[{5,19340},{225,8878}]','[{255,36160007,31989}]'),(5206354,56,'[{5,19774},{225,9077}]','[{255,36160007,32736}]'),(5206354,57,'[{5,20210},{225,9278}]','[{255,36160007,33500}]'),(5206354,58,'[{5,20650},{225,9481}]','[{255,36160007,34283}]'),(5206354,59,'[{5,21094},{225,9686}]','[{255,36160007,35085}]'),(5206354,60,'[{5,21540},{225,9893}]','[{255,36160007,35907}]'),(5206354,61,'[{5,21990},{225,10102}]','[{255,36160007,36750}]'),(5206354,62,'[{5,22444},{225,10313}]','[{255,36160007,37614}]'),(5206354,63,'[{5,22900},{225,10526}]','[{255,36160007,38501}]'),(5206354,64,'[{5,23360},{225,10740}]','[{255,36160007,39410}]'),(5206354,65,'[{5,23824},{225,10956}]','[{255,36160007,40343}]'),(5206354,66,'[{5,24292},{225,11174}]','[{255,36160007,41300}]'),(5206354,67,'[{5,24762},{225,11394}]','[{255,36160007,42284}]'),(5206354,68,'[{5,25236},{225,11616}]','[{255,36160007,43295}]'),(5206354,69,'[{5,25714},{225,11840}]','[{255,36160007,44334}]'),(5206354,70,'[{5,26194},{225,12066}]','[{255,36160007,45402}]'),(5206354,71,'[{5,26678},{225,12293}]','[{255,36160007,46500}]'),(5206354,72,'[{5,27166},{225,12522}]','[{255,36160007,47631}]'),(5206354,73,'[{5,27656},{225,12753}]','[{255,36160007,48794}]'),(5206354,74,'[{5,28150},{225,12986}]','[{255,36160007,49992}]'),(5206354,75,'[{5,28648},{225,13221}]','[{255,36160007,51228}]'),(5206354,76,'[{5,29148},{225,13458}]','[{255,36160007,52232}]'),(5206354,77,'[{5,29652},{225,13697}]','[{255,36160007,53258}]'),(5206354,78,'[{5,30160},{225,13938}]','[{255,36160007,54305}]'),(5206354,79,'[{5,30670},{225,14180}]','[{255,36160007,55374}]'),(5206354,80,'[{5,31184},{225,14424}]','[{255,36160007,56466}]'),(5206354,81,'[{5,31702},{225,14670}]','[{255,36160007,57581}]'),(5206354,82,'[{5,32222},{225,14918}]','[{255,36160007,58721}]'),(5206354,83,'[{5,32746},{225,15168}]','[{255,36160007,59885}]'),(5206354,84,'[{5,33274},{225,15420}]','[{255,36160007,61076}]'),(5206354,85,'[{5,33804},{225,15674}]','[{255,36160007,62292}]'),(5206354,86,'[{5,34338},{225,15930}]','[{255,36160007,63537}]'),(5206354,87,'[{5,34876},{225,16187}]','[{255,36160007,64811}]'),(5206354,88,'[{5,35416},{225,16446}]','[{255,36160007,66114}]'),(5206354,89,'[{5,35960},{225,16707}]','[{255,36160007,67448}]'),(5206354,90,'[{5,36508},{225,16970}]','[{255,36160007,68813}]'),(5206354,91,'[{5,37060},{225,17235}]','[{255,36160007,70211}]'),(5206354,92,'[{5,37614},{225,17502}]','[{255,36160007,71643}]'),(5206354,93,'[{5,38172},{225,17771}]','[{255,36160007,73112}]'),(5206354,94,'[{5,38734},{225,18042}]','[{255,36160007,74616}]'),(5206354,95,'[{5,39298},{225,18314}]','[{255,36160007,76158}]'),(5206354,96,'[{5,39866},{225,18588}]','[{255,36160007,77741}]'),(5206354,97,'[{5,40438},{225,18864}]','[{255,36160007,79364}]'),(5206354,98,'[{5,41012},{225,19142}]','[{255,36160007,81030}]'),(5206354,99,'[{5,41590},{225,19422}]','[{255,36160007,82740}]'),(5206354,100,'[{5,42172},{225,19704}]','[{255,36160007,0}]'),(5206363,1,'[{6,518},{202,539}]','[{255,36160007,4463}]'),(5206363,2,'[{6,690},{202,583}]','[{255,36160007,4674}]'),(5206363,3,'[{6,866},{202,627}]','[{255,36160007,4893}]'),(5206363,4,'[{6,1044},{202,671}]','[{255,36160007,5121}]'),(5206363,5,'[{6,1224},{202,715}]','[{255,36160007,5355}]'),(5206363,6,'[{6,1406},{202,759}]','[{255,36160007,5598}]'),(5206363,7,'[{6,1590},{202,803}]','[{255,36160007,5852}]'),(5206363,8,'[{6,1776},{202,847}]','[{255,36160007,6113}]'),(5206363,9,'[{6,1964},{202,891}]','[{255,36160007,6386}]'),(5206363,10,'[{6,2156},{202,935}]','[{255,36160007,6668}]'),(5206363,11,'[{6,2350},{202,979}]','[{255,36160007,6962}]'),(5206363,12,'[{6,2546},{202,1023}]','[{255,36160007,7268}]'),(5206363,13,'[{6,2744},{202,1067}]','[{255,36160007,7587}]'),(5206363,14,'[{6,2944},{202,1111}]','[{255,36160007,7919}]'),(5206363,15,'[{6,3146},{202,1155}]','[{255,36160007,8267}]'),(5206363,16,'[{6,3352},{202,1199}]','[{255,36160007,8628}]'),(5206363,17,'[{6,3560},{202,1243}]','[{255,36160007,9006}]'),(5206363,18,'[{6,3770},{202,1287}]','[{255,36160007,9402}]'),(5206363,19,'[{6,3982},{202,1331}]','[{255,36160007,9818}]'),(5206363,20,'[{6,4196},{202,1375}]','[{255,36160007,10253}]'),(5206363,21,'[{6,4412},{202,1419}]','[{255,36160007,10710}]'),(5206363,22,'[{6,4630},{202,1463}]','[{255,36160007,11049}]'),(5206363,23,'[{6,4852},{202,1507}]','[{255,36160007,11396}]'),(5206363,24,'[{6,5076},{202,1551}]','[{255,36160007,11753}]'),(5206363,25,'[{6,5302},{202,1595}]','[{255,36160007,12119}]'),(5206363,26,'[{6,5530},{202,1639}]','[{255,36160007,12495}]'),(5206363,27,'[{6,5760},{202,1683}]','[{255,36160007,12882}]'),(5206363,28,'[{6,5992},{202,1727}]','[{255,36160007,13278}]'),(5206363,29,'[{6,6228},{202,1771}]','[{255,36160007,13685}]'),(5206363,30,'[{6,6466},{202,1815}]','[{255,36160007,14105}]'),(5206363,31,'[{6,6706},{202,1859}]','[{255,36160007,14535}]'),(5206363,32,'[{6,6948},{202,1903}]','[{255,36160007,14979}]'),(5206363,33,'[{6,7192},{202,1947}]','[{255,36160007,15435}]'),(5206363,34,'[{6,7438},{202,1991}]','[{255,36160007,15906}]'),(5206363,35,'[{6,7686},{202,2035}]','[{255,36160007,16391}]'),(5206363,36,'[{6,7938},{202,2079}]','[{255,36160007,16889}]'),(5206363,37,'[{6,8192},{202,2123}]','[{255,36160007,17405}]'),(5206363,38,'[{6,8448},{202,2167}]','[{255,36160007,17936}]'),(5206363,39,'[{6,8706},{202,2211}]','[{255,36160007,18483}]'),(5206363,40,'[{6,8966},{202,2255}]','[{255,36160007,19050}]'),(5206363,41,'[{6,9228},{202,2299}]','[{255,36160007,19635}]'),(5206363,42,'[{6,9492},{202,2343}]','[{255,36160007,20105}]'),(5206363,43,'[{6,9760},{202,2387}]','[{255,36160007,20583}]'),(5206363,44,'[{6,10030},{202,2431}]','[{255,36160007,21071}]'),(5206363,45,'[{6,10302},{202,2475}]','[{255,36160007,21569}]'),(5206363,46,'[{6,10576},{202,2519}]','[{255,36160007,22079}]'),(5206363,47,'[{6,10852},{202,2563}]','[{255,36160007,22598}]'),(5206363,48,'[{6,11130},{202,2607}]','[{255,36160007,23129}]'),(5206363,49,'[{6,11412},{202,2651}]','[{255,36160007,23670}]'),(5206363,50,'[{6,11696},{202,2695}]','[{255,36160007,24225}]'),(5206363,51,'[{6,11982},{202,2739}]','[{255,36160007,24791}]'),(5206363,52,'[{6,12270},{202,2783}]','[{255,36160007,25371}]'),(5206363,53,'[{6,12560},{202,2827}]','[{255,36160007,25964}]'),(5206363,54,'[{6,12852},{202,2871}]','[{255,36160007,26570}]'),(5206363,55,'[{6,13146},{202,2915}]','[{255,36160007,27191}]'),(5206363,56,'[{6,13444},{202,2959}]','[{255,36160007,27825}]'),(5206363,57,'[{6,13744},{202,3003}]','[{255,36160007,28475}]'),(5206363,58,'[{6,14046},{202,3047}]','[{255,36160007,29141}]'),(5206363,59,'[{6,14350},{202,3091}]','[{255,36160007,29823}]'),(5206363,60,'[{6,14656},{202,3135}]','[{255,36160007,30521}]'),(5206363,61,'[{6,14964},{202,3179}]','[{255,36160007,31238}]'),(5206363,62,'[{6,15276},{202,3223}]','[{255,36160007,31973}]'),(5206363,63,'[{6,15590},{202,3267}]','[{255,36160007,32726}]'),(5206363,64,'[{6,15906},{202,3311}]','[{255,36160007,33498}]'),(5206363,65,'[{6,16224},{202,3355}]','[{255,36160007,34292}]'),(5206363,66,'[{6,16544},{202,3399}]','[{255,36160007,35105}]'),(5206363,67,'[{6,16866},{202,3443}]','[{255,36160007,35942}]'),(5206363,68,'[{6,17190},{202,3487}]','[{255,36160007,36801}]'),(5206363,69,'[{6,17518},{202,3531}]','[{255,36160007,37685}]'),(5206363,70,'[{6,17848},{202,3575}]','[{255,36160007,38592}]'),(5206363,71,'[{6,18180},{202,3619}]','[{255,36160007,39525}]'),(5206363,72,'[{6,18514},{202,3663}]','[{255,36160007,40487}]'),(5206363,73,'[{6,18850},{202,3707}]','[{255,36160007,41475}]'),(5206363,74,'[{6,19188},{202,3751}]','[{255,36160007,42494}]'),(5206363,75,'[{6,19528},{202,3795}]','[{255,36160007,43544}]'),(5206363,76,'[{6,19872},{202,3839}]','[{255,36160007,44397}]'),(5206363,77,'[{6,20218},{202,3883}]','[{255,36160007,45269}]'),(5206363,78,'[{6,20566},{202,3927}]','[{255,36160007,46160}]'),(5206363,79,'[{6,20916},{202,3971}]','[{255,36160007,47069}]'),(5206363,80,'[{6,21268},{202,4015}]','[{255,36160007,47996}]'),(5206363,81,'[{6,21622},{202,4059}]','[{255,36160007,48944}]'),(5206363,82,'[{6,21980},{202,4103}]','[{255,36160007,49913}]'),(5206363,83,'[{6,22340},{202,4147}]','[{255,36160007,50903}]'),(5206363,84,'[{6,22702},{202,4191}]','[{255,36160007,51914}]'),(5206363,85,'[{6,23066},{202,4235}]','[{255,36160007,52949}]'),(5206363,86,'[{6,23432},{202,4279}]','[{255,36160007,54006}]'),(5206363,87,'[{6,23800},{202,4323}]','[{255,36160007,55089}]'),(5206363,88,'[{6,24170},{202,4367}]','[{255,36160007,56198}]'),(5206363,89,'[{6,24544},{202,4411}]','[{255,36160007,57330}]'),(5206363,90,'[{6,24920},{202,4455}]','[{255,36160007,58491}]'),(5206363,91,'[{6,25298},{202,4499}]','[{255,36160007,59679}]'),(5206363,92,'[{6,25678},{202,4543}]','[{255,36160007,60897}]'),(5206363,93,'[{6,26060},{202,4587}]','[{255,36160007,62145}]'),(5206363,94,'[{6,26444},{202,4631}]','[{255,36160007,63423}]'),(5206363,95,'[{6,26832},{202,4675}]','[{255,36160007,64734}]'),(5206363,96,'[{6,27222},{202,4719}]','[{255,36160007,66080}]'),(5206363,97,'[{6,27614},{202,4763}]','[{255,36160007,67460}]'),(5206363,98,'[{6,28008},{202,4807}]','[{255,36160007,68876}]'),(5206363,99,'[{6,28404},{202,4851}]','[{255,36160007,70329}]'),(5206363,100,'[{6,28802},{202,4895}]','[{255,36160007,0}]'),(5206364,1,'[{6,924},{202,755}]','[{255,36160007,5250}]'),(5206364,2,'[{6,1176},{202,817}]','[{255,36160007,5499}]'),(5206364,3,'[{6,1432},{202,879}]','[{255,36160007,5757}]'),(5206364,4,'[{6,1690},{202,941}]','[{255,36160007,6024}]'),(5206364,5,'[{6,1952},{202,1003}]','[{255,36160007,6300}]'),(5206364,6,'[{6,2218},{202,1065}]','[{255,36160007,6587}]'),(5206364,7,'[{6,2486},{202,1127}]','[{255,36160007,6884}]'),(5206364,8,'[{6,2758},{202,1189}]','[{255,36160007,7191}]'),(5206364,9,'[{6,3034},{202,1251}]','[{255,36160007,7512}]'),(5206364,10,'[{6,3312},{202,1313}]','[{255,36160007,7844}]'),(5206364,11,'[{6,3594},{202,1375}]','[{255,36160007,8190}]'),(5206364,12,'[{6,3880},{202,1437}]','[{255,36160007,8550}]'),(5206364,13,'[{6,4168},{202,1499}]','[{255,36160007,8925}]'),(5206364,14,'[{6,4460},{202,1561}]','[{255,36160007,9317}]'),(5206364,15,'[{6,4756},{202,1623}]','[{255,36160007,9725}]'),(5206364,16,'[{6,5056},{202,1685}]','[{255,36160007,10151}]'),(5206364,17,'[{6,5358},{202,1747}]','[{255,36160007,10596}]'),(5206364,18,'[{6,5664},{202,1809}]','[{255,36160007,11061}]'),(5206364,19,'[{6,5974},{202,1871}]','[{255,36160007,11550}]'),(5206364,20,'[{6,6286},{202,1933}]','[{255,36160007,12062}]'),(5206364,21,'[{6,6602},{202,1995}]','[{255,36160007,12600}]'),(5206364,22,'[{6,6922},{202,2057}]','[{255,36160007,12999}]'),(5206364,23,'[{6,7244},{202,2119}]','[{255,36160007,13407}]'),(5206364,24,'[{6,7570},{202,2181}]','[{255,36160007,13827}]'),(5206364,25,'[{6,7900},{202,2243}]','[{255,36160007,14258}]'),(5206364,26,'[{6,8232},{202,2305}]','[{255,36160007,14700}]'),(5206364,27,'[{6,8568},{202,2367}]','[{255,36160007,15155}]'),(5206364,28,'[{6,8908},{202,2429}]','[{255,36160007,15621}]'),(5206364,29,'[{6,9250},{202,2491}]','[{255,36160007,16100}]'),(5206364,30,'[{6,9596},{202,2553}]','[{255,36160007,16593}]'),(5206364,31,'[{6,9946},{202,2615}]','[{255,36160007,17100}]'),(5206364,32,'[{6,10298},{202,2677}]','[{255,36160007,17622}]'),(5206364,33,'[{6,10654},{202,2739}]','[{255,36160007,18159}]'),(5206364,34,'[{6,11014},{202,2801}]','[{255,36160007,18713}]'),(5206364,35,'[{6,11376},{202,2863}]','[{255,36160007,19283}]'),(5206364,36,'[{6,11742},{202,2925}]','[{255,36160007,19869}]'),(5206364,37,'[{6,12112},{202,2987}]','[{255,36160007,20475}]'),(5206364,38,'[{6,12484},{202,3049}]','[{255,36160007,21101}]'),(5206364,39,'[{6,12860},{202,3111}]','[{255,36160007,21746}]'),(5206364,40,'[{6,13240},{202,3173}]','[{255,36160007,22412}]'),(5206364,41,'[{6,13624},{202,3235}]','[{255,36160007,23100}]'),(5206364,42,'[{6,14010},{202,3297}]','[{255,36160007,23652}]'),(5206364,43,'[{6,14400},{202,3359}]','[{255,36160007,24215}]'),(5206364,44,'[{6,14794},{202,3421}]','[{255,36160007,24789}]'),(5206364,45,'[{6,15190},{202,3483}]','[{255,36160007,25376}]'),(5206364,46,'[{6,15590},{202,3545}]','[{255,36160007,25974}]'),(5206364,47,'[{6,15994},{202,3607}]','[{255,36160007,26585}]'),(5206364,48,'[{6,16400},{202,3669}]','[{255,36160007,27210}]'),(5206364,49,'[{6,16810},{202,3731}]','[{255,36160007,27848}]'),(5206364,50,'[{6,17224},{202,3793}]','[{255,36160007,28500}]'),(5206364,51,'[{6,17640},{202,3855}]','[{255,36160007,29166}]'),(5206364,52,'[{6,18060},{202,3917}]','[{255,36160007,29849}]'),(5206364,53,'[{6,18484},{202,3979}]','[{255,36160007,30546}]'),(5206364,54,'[{6,18910},{202,4041}]','[{255,36160007,31259}]'),(5206364,55,'[{6,19340},{202,4103}]','[{255,36160007,31989}]'),(5206364,56,'[{6,19774},{202,4165}]','[{255,36160007,32736}]'),(5206364,57,'[{6,20210},{202,4227}]','[{255,36160007,33500}]'),(5206364,58,'[{6,20650},{202,4289}]','[{255,36160007,34283}]'),(5206364,59,'[{6,21094},{202,4351}]','[{255,36160007,35085}]'),(5206364,60,'[{6,21540},{202,4413}]','[{255,36160007,35907}]'),(5206364,61,'[{6,21990},{202,4475}]','[{255,36160007,36750}]'),(5206364,62,'[{6,22444},{202,4537}]','[{255,36160007,37614}]'),(5206364,63,'[{6,22900},{202,4599}]','[{255,36160007,38501}]'),(5206364,64,'[{6,23360},{202,4661}]','[{255,36160007,39410}]'),(5206364,65,'[{6,23824},{202,4723}]','[{255,36160007,40343}]'),(5206364,66,'[{6,24292},{202,4785}]','[{255,36160007,41300}]'),(5206364,67,'[{6,24762},{202,4847}]','[{255,36160007,42284}]'),(5206364,68,'[{6,25236},{202,4909}]','[{255,36160007,43295}]'),(5206364,69,'[{6,25714},{202,4971}]','[{255,36160007,44334}]'),(5206364,70,'[{6,26194},{202,5033}]','[{255,36160007,45402}]'),(5206364,71,'[{6,26678},{202,5095}]','[{255,36160007,46500}]'),(5206364,72,'[{6,27166},{202,5157}]','[{255,36160007,47631}]'),(5206364,73,'[{6,27656},{202,5219}]','[{255,36160007,48794}]'),(5206364,74,'[{6,28150},{202,5281}]','[{255,36160007,49992}]'),(5206364,75,'[{6,28648},{202,5343}]','[{255,36160007,51228}]'),(5206364,76,'[{6,29148},{202,5405}]','[{255,36160007,52232}]'),(5206364,77,'[{6,29652},{202,5467}]','[{255,36160007,53258}]'),(5206364,78,'[{6,30160},{202,5529}]','[{255,36160007,54305}]'),(5206364,79,'[{6,30670},{202,5591}]','[{255,36160007,55374}]'),(5206364,80,'[{6,31184},{202,5653}]','[{255,36160007,56466}]'),(5206364,81,'[{6,31702},{202,5715}]','[{255,36160007,57581}]'),(5206364,82,'[{6,32222},{202,5777}]','[{255,36160007,58721}]'),(5206364,83,'[{6,32746},{202,5839}]','[{255,36160007,59885}]'),(5206364,84,'[{6,33274},{202,5901}]','[{255,36160007,61076}]'),(5206364,85,'[{6,33804},{202,5963}]','[{255,36160007,62292}]'),(5206364,86,'[{6,34338},{202,6025}]','[{255,36160007,63537}]'),(5206364,87,'[{6,34876},{202,6087}]','[{255,36160007,64811}]'),(5206364,88,'[{6,35416},{202,6149}]','[{255,36160007,66114}]'),(5206364,89,'[{6,35960},{202,6211}]','[{255,36160007,67448}]'),(5206364,90,'[{6,36508},{202,6273}]','[{255,36160007,68813}]'),(5206364,91,'[{6,37060},{202,6335}]','[{255,36160007,70211}]'),(5206364,92,'[{6,37614},{202,6397}]','[{255,36160007,71643}]'),(5206364,93,'[{6,38172},{202,6459}]','[{255,36160007,73112}]'),(5206364,94,'[{6,38734},{202,6521}]','[{255,36160007,74616}]'),(5206364,95,'[{6,39298},{202,6583}]','[{255,36160007,76158}]'),(5206364,96,'[{6,39866},{202,6645}]','[{255,36160007,77741}]'),(5206364,97,'[{6,40438},{202,6707}]','[{255,36160007,79364}]'),(5206364,98,'[{6,41012},{202,6769}]','[{255,36160007,81030}]'),(5206364,99,'[{6,41590},{202,6831}]','[{255,36160007,82740}]'),(5206364,100,'[{6,42172},{202,6893}]','[{255,36160007,0}]'),(5206373,1,'[{7,518},{15,432}]','[{255,36160007,4463}]'),(5206373,2,'[{7,690},{15,576}]','[{255,36160007,4674}]'),(5206373,3,'[{7,866},{15,722}]','[{255,36160007,4893}]'),(5206373,4,'[{7,1044},{15,870}]','[{255,36160007,5121}]'),(5206373,5,'[{7,1224},{15,1020}]','[{255,36160007,5355}]'),(5206373,6,'[{7,1406},{15,1172}]','[{255,36160007,5598}]'),(5206373,7,'[{7,1590},{15,1326}]','[{255,36160007,5852}]'),(5206373,8,'[{7,1776},{15,1482}]','[{255,36160007,6113}]'),(5206373,9,'[{7,1964},{15,1639}]','[{255,36160007,6386}]'),(5206373,10,'[{7,2156},{15,1798}]','[{255,36160007,6668}]'),(5206373,11,'[{7,2350},{15,1959}]','[{255,36160007,6962}]'),(5206373,12,'[{7,2546},{15,2122}]','[{255,36160007,7268}]'),(5206373,13,'[{7,2744},{15,2287}]','[{255,36160007,7587}]'),(5206373,14,'[{7,2944},{15,2454}]','[{255,36160007,7919}]'),(5206373,15,'[{7,3146},{15,2623}]','[{255,36160007,8267}]'),(5206373,16,'[{7,3352},{15,2794}]','[{255,36160007,8628}]'),(5206373,17,'[{7,3560},{15,2967}]','[{255,36160007,9006}]'),(5206373,18,'[{7,3770},{15,3142}]','[{255,36160007,9402}]'),(5206373,19,'[{7,3982},{15,3319}]','[{255,36160007,9818}]'),(5206373,20,'[{7,4196},{15,3498}]','[{255,36160007,10253}]'),(5206373,21,'[{7,4412},{15,3678}]','[{255,36160007,10710}]'),(5206373,22,'[{7,4630},{15,3860}]','[{255,36160007,11049}]'),(5206373,23,'[{7,4852},{15,4044}]','[{255,36160007,11396}]'),(5206373,24,'[{7,5076},{15,4230}]','[{255,36160007,11753}]'),(5206373,25,'[{7,5302},{15,4418}]','[{255,36160007,12119}]'),(5206373,26,'[{7,5530},{15,4608}]','[{255,36160007,12495}]'),(5206373,27,'[{7,5760},{15,4800}]','[{255,36160007,12882}]'),(5206373,28,'[{7,5992},{15,4994}]','[{255,36160007,13278}]'),(5206373,29,'[{7,6228},{15,5190}]','[{255,36160007,13685}]'),(5206373,30,'[{7,6466},{15,5388}]','[{255,36160007,14105}]'),(5206373,31,'[{7,6706},{15,5588}]','[{255,36160007,14535}]'),(5206373,32,'[{7,6948},{15,5790}]','[{255,36160007,14979}]'),(5206373,33,'[{7,7192},{15,5994}]','[{255,36160007,15435}]'),(5206373,34,'[{7,7438},{15,6199}]','[{255,36160007,15906}]'),(5206373,35,'[{7,7686},{15,6406}]','[{255,36160007,16391}]'),(5206373,36,'[{7,7938},{15,6615}]','[{255,36160007,16889}]'),(5206373,37,'[{7,8192},{15,6826}]','[{255,36160007,17405}]'),(5206373,38,'[{7,8448},{15,7039}]','[{255,36160007,17936}]'),(5206373,39,'[{7,8706},{15,7254}]','[{255,36160007,18483}]'),(5206373,40,'[{7,8966},{15,7471}]','[{255,36160007,19050}]'),(5206373,41,'[{7,9228},{15,7690}]','[{255,36160007,19635}]'),(5206373,42,'[{7,9492},{15,7911}]','[{255,36160007,20105}]'),(5206373,43,'[{7,9760},{15,8134}]','[{255,36160007,20583}]'),(5206373,44,'[{7,10030},{15,8359}]','[{255,36160007,21071}]'),(5206373,45,'[{7,10302},{15,8586}]','[{255,36160007,21569}]'),(5206373,46,'[{7,10576},{15,8814}]','[{255,36160007,22079}]'),(5206373,47,'[{7,10852},{15,9044}]','[{255,36160007,22598}]'),(5206373,48,'[{7,11130},{15,9276}]','[{255,36160007,23129}]'),(5206373,49,'[{7,11412},{15,9510}]','[{255,36160007,23670}]'),(5206373,50,'[{7,11696},{15,9746}]','[{255,36160007,24225}]'),(5206373,51,'[{7,11982},{15,9984}]','[{255,36160007,24791}]'),(5206373,52,'[{7,12270},{15,10224}]','[{255,36160007,25371}]'),(5206373,53,'[{7,12560},{15,10466}]','[{255,36160007,25964}]'),(5206373,54,'[{7,12852},{15,10710}]','[{255,36160007,26570}]'),(5206373,55,'[{7,13146},{15,10956}]','[{255,36160007,27191}]'),(5206373,56,'[{7,13444},{15,11204}]','[{255,36160007,27825}]'),(5206373,57,'[{7,13744},{15,11454}]','[{255,36160007,28475}]'),(5206373,58,'[{7,14046},{15,11706}]','[{255,36160007,29141}]'),(5206373,59,'[{7,14350},{15,11959}]','[{255,36160007,29823}]'),(5206373,60,'[{7,14656},{15,12214}]','[{255,36160007,30521}]'),(5206373,61,'[{7,14964},{15,12471}]','[{255,36160007,31238}]'),(5206373,62,'[{7,15276},{15,12730}]','[{255,36160007,31973}]'),(5206373,63,'[{7,15590},{15,12991}]','[{255,36160007,32726}]'),(5206373,64,'[{7,15906},{15,13254}]','[{255,36160007,33498}]'),(5206373,65,'[{7,16224},{15,13519}]','[{255,36160007,34292}]'),(5206373,66,'[{7,16544},{15,13786}]','[{255,36160007,35105}]'),(5206373,67,'[{7,16866},{15,14055}]','[{255,36160007,35942}]'),(5206373,68,'[{7,17190},{15,14326}]','[{255,36160007,36801}]'),(5206373,69,'[{7,17518},{15,14599}]','[{255,36160007,37685}]'),(5206373,70,'[{7,17848},{15,14874}]','[{255,36160007,38592}]'),(5206373,71,'[{7,18180},{15,15150}]','[{255,36160007,39525}]'),(5206373,72,'[{7,18514},{15,15428}]','[{255,36160007,40487}]'),(5206373,73,'[{7,18850},{15,15708}]','[{255,36160007,41475}]'),(5206373,74,'[{7,19188},{15,15990}]','[{255,36160007,42494}]'),(5206373,75,'[{7,19528},{15,16274}]','[{255,36160007,43544}]'),(5206373,76,'[{7,19872},{15,16560}]','[{255,36160007,44397}]'),(5206373,77,'[{7,20218},{15,16848}]','[{255,36160007,45269}]'),(5206373,78,'[{7,20566},{15,17138}]','[{255,36160007,46160}]'),(5206373,79,'[{7,20916},{15,17430}]','[{255,36160007,47069}]'),(5206373,80,'[{7,21268},{15,17724}]','[{255,36160007,47996}]'),(5206373,81,'[{7,21622},{15,18020}]','[{255,36160007,48944}]'),(5206373,82,'[{7,21980},{15,18318}]','[{255,36160007,49913}]'),(5206373,83,'[{7,22340},{15,18618}]','[{255,36160007,50903}]'),(5206373,84,'[{7,22702},{15,18919}]','[{255,36160007,51914}]'),(5206373,85,'[{7,23066},{15,19222}]','[{255,36160007,52949}]'),(5206373,86,'[{7,23432},{15,19527}]','[{255,36160007,54006}]'),(5206373,87,'[{7,23800},{15,19834}]','[{255,36160007,55089}]'),(5206373,88,'[{7,24170},{15,20143}]','[{255,36160007,56198}]'),(5206373,89,'[{7,24544},{15,20454}]','[{255,36160007,57330}]'),(5206373,90,'[{7,24920},{15,20767}]','[{255,36160007,58491}]'),(5206373,91,'[{7,25298},{15,21082}]','[{255,36160007,59679}]'),(5206373,92,'[{7,25678},{15,21399}]','[{255,36160007,60897}]'),(5206373,93,'[{7,26060},{15,21718}]','[{255,36160007,62145}]'),(5206373,94,'[{7,26444},{15,22039}]','[{255,36160007,63423}]'),(5206373,95,'[{7,26832},{15,22362}]','[{255,36160007,64734}]'),(5206373,96,'[{7,27222},{15,22686}]','[{255,36160007,66080}]'),(5206373,97,'[{7,27614},{15,23012}]','[{255,36160007,67460}]'),(5206373,98,'[{7,28008},{15,23340}]','[{255,36160007,68876}]'),(5206373,99,'[{7,28404},{15,23670}]','[{255,36160007,70329}]'),(5206373,100,'[{7,28802},{15,24002}]','[{255,36160007,0}]'),(5206374,1,'[{7,924},{15,770}]','[{255,36160007,5250}]'),(5206374,2,'[{7,1176},{15,980}]','[{255,36160007,5499}]'),(5206374,3,'[{7,1432},{15,1193}]','[{255,36160007,5757}]'),(5206374,4,'[{7,1690},{15,1409}]','[{255,36160007,6024}]'),(5206374,5,'[{7,1952},{15,1627}]','[{255,36160007,6300}]'),(5206374,6,'[{7,2218},{15,1848}]','[{255,36160007,6587}]'),(5206374,7,'[{7,2486},{15,2072}]','[{255,36160007,6884}]'),(5206374,8,'[{7,2758},{15,2299}]','[{255,36160007,7191}]'),(5206374,9,'[{7,3034},{15,2529}]','[{255,36160007,7512}]'),(5206374,10,'[{7,3312},{15,2761}]','[{255,36160007,7844}]'),(5206374,11,'[{7,3594},{15,2996}]','[{255,36160007,8190}]'),(5206374,12,'[{7,3880},{15,3234}]','[{255,36160007,8550}]'),(5206374,13,'[{7,4168},{15,3475}]','[{255,36160007,8925}]'),(5206374,14,'[{7,4460},{15,3719}]','[{255,36160007,9317}]'),(5206374,15,'[{7,4756},{15,3965}]','[{255,36160007,9725}]'),(5206374,16,'[{7,5056},{15,4214}]','[{255,36160007,10151}]'),(5206374,17,'[{7,5358},{15,4466}]','[{255,36160007,10596}]'),(5206374,18,'[{7,5664},{15,4721}]','[{255,36160007,11061}]'),(5206374,19,'[{7,5974},{15,4979}]','[{255,36160007,11550}]'),(5206374,20,'[{7,6286},{15,5239}]','[{255,36160007,12062}]'),(5206374,21,'[{7,6602},{15,5502}]','[{255,36160007,12600}]'),(5206374,22,'[{7,6922},{15,5768}]','[{255,36160007,12999}]'),(5206374,23,'[{7,7244},{15,6037}]','[{255,36160007,13407}]'),(5206374,24,'[{7,7570},{15,6309}]','[{255,36160007,13827}]'),(5206374,25,'[{7,7900},{15,6583}]','[{255,36160007,14258}]'),(5206374,26,'[{7,8232},{15,6860}]','[{255,36160007,14700}]'),(5206374,27,'[{7,8568},{15,7140}]','[{255,36160007,15155}]'),(5206374,28,'[{7,8908},{15,7423}]','[{255,36160007,15621}]'),(5206374,29,'[{7,9250},{15,7709}]','[{255,36160007,16100}]'),(5206374,30,'[{7,9596},{15,7997}]','[{255,36160007,16593}]'),(5206374,31,'[{7,9946},{15,8288}]','[{255,36160007,17100}]'),(5206374,32,'[{7,10298},{15,8582}]','[{255,36160007,17622}]'),(5206374,33,'[{7,10654},{15,8879}]','[{255,36160007,18159}]'),(5206374,34,'[{7,11014},{15,9179}]','[{255,36160007,18713}]'),(5206374,35,'[{7,11376},{15,9481}]','[{255,36160007,19283}]'),(5206374,36,'[{7,11742},{15,9786}]','[{255,36160007,19869}]'),(5206374,37,'[{7,12112},{15,10094}]','[{255,36160007,20475}]'),(5206374,38,'[{7,12484},{15,10405}]','[{255,36160007,21101}]'),(5206374,39,'[{7,12860},{15,10719}]','[{255,36160007,21746}]'),(5206374,40,'[{7,13240},{15,11035}]','[{255,36160007,22412}]'),(5206374,41,'[{7,13624},{15,11354}]','[{255,36160007,23100}]'),(5206374,42,'[{7,14010},{15,11676}]','[{255,36160007,23652}]'),(5206374,43,'[{7,14400},{15,12001}]','[{255,36160007,24215}]'),(5206374,44,'[{7,14794},{15,12329}]','[{255,36160007,24789}]'),(5206374,45,'[{7,15190},{15,12659}]','[{255,36160007,25376}]'),(5206374,46,'[{7,15590},{15,12992}]','[{255,36160007,25974}]'),(5206374,47,'[{7,15994},{15,13328}]','[{255,36160007,26585}]'),(5206374,48,'[{7,16400},{15,13667}]','[{255,36160007,27210}]'),(5206374,49,'[{7,16810},{15,14009}]','[{255,36160007,27848}]'),(5206374,50,'[{7,17224},{15,14353}]','[{255,36160007,28500}]'),(5206374,51,'[{7,17640},{15,14700}]','[{255,36160007,29166}]'),(5206374,52,'[{7,18060},{15,15050}]','[{255,36160007,29849}]'),(5206374,53,'[{7,18484},{15,15403}]','[{255,36160007,30546}]'),(5206374,54,'[{7,18910},{15,15759}]','[{255,36160007,31259}]'),(5206374,55,'[{7,19340},{15,16117}]','[{255,36160007,31989}]'),(5206374,56,'[{7,19774},{15,16478}]','[{255,36160007,32736}]'),(5206374,57,'[{7,20210},{15,16842}]','[{255,36160007,33500}]'),(5206374,58,'[{7,20650},{15,17209}]','[{255,36160007,34283}]'),(5206374,59,'[{7,21094},{15,17579}]','[{255,36160007,35085}]'),(5206374,60,'[{7,21540},{15,17951}]','[{255,36160007,35907}]'),(5206374,61,'[{7,21990},{15,18326}]','[{255,36160007,36750}]'),(5206374,62,'[{7,22444},{15,18704}]','[{255,36160007,37614}]'),(5206374,63,'[{7,22900},{15,19085}]','[{255,36160007,38501}]'),(5206374,64,'[{7,23360},{15,19469}]','[{255,36160007,39410}]'),(5206374,65,'[{7,23824},{15,19855}]','[{255,36160007,40343}]'),(5206374,66,'[{7,24292},{15,20244}]','[{255,36160007,41300}]'),(5206374,67,'[{7,24762},{15,20636}]','[{255,36160007,42284}]'),(5206374,68,'[{7,25236},{15,21031}]','[{255,36160007,43295}]'),(5206374,69,'[{7,25714},{15,21429}]','[{255,36160007,44334}]'),(5206374,70,'[{7,26194},{15,21829}]','[{255,36160007,45402}]'),(5206374,71,'[{7,26678},{15,22232}]','[{255,36160007,46500}]'),(5206374,72,'[{7,27166},{15,22638}]','[{255,36160007,47631}]'),(5206374,73,'[{7,27656},{15,23047}]','[{255,36160007,48794}]'),(5206374,74,'[{7,28150},{15,23459}]','[{255,36160007,49992}]'),(5206374,75,'[{7,28648},{15,23873}]','[{255,36160007,51228}]'),(5206374,76,'[{7,29148},{15,24290}]','[{255,36160007,52232}]'),(5206374,77,'[{7,29652},{15,24710}]','[{255,36160007,53258}]'),(5206374,78,'[{7,30160},{15,25133}]','[{255,36160007,54305}]'),(5206374,79,'[{7,30670},{15,25559}]','[{255,36160007,55374}]'),(5206374,80,'[{7,31184},{15,25987}]','[{255,36160007,56466}]'),(5206374,81,'[{7,31702},{15,26418}]','[{255,36160007,57581}]'),(5206374,82,'[{7,32222},{15,26852}]','[{255,36160007,58721}]'),(5206374,83,'[{7,32746},{15,27289}]','[{255,36160007,59885}]'),(5206374,84,'[{7,33274},{15,27729}]','[{255,36160007,61076}]'),(5206374,85,'[{7,33804},{15,28171}]','[{255,36160007,62292}]'),(5206374,86,'[{7,34338},{15,28616}]','[{255,36160007,63537}]'),(5206374,87,'[{7,34876},{15,29064}]','[{255,36160007,64811}]'),(5206374,88,'[{7,35416},{15,29515}]','[{255,36160007,66114}]'),(5206374,89,'[{7,35960},{15,29969}]','[{255,36160007,67448}]'),(5206374,90,'[{7,36508},{15,30425}]','[{255,36160007,68813}]'),(5206374,91,'[{7,37060},{15,30884}]','[{255,36160007,70211}]'),(5206374,92,'[{7,37614},{15,31346}]','[{255,36160007,71643}]'),(5206374,93,'[{7,38172},{15,31811}]','[{255,36160007,73112}]'),(5206374,94,'[{7,38734},{15,32279}]','[{255,36160007,74616}]'),(5206374,95,'[{7,39298},{15,32749}]','[{255,36160007,76158}]'),(5206374,96,'[{7,39866},{15,33222}]','[{255,36160007,77741}]'),(5206374,97,'[{7,40438},{15,33698}]','[{255,36160007,79364}]'),(5206374,98,'[{7,41012},{15,34177}]','[{255,36160007,81030}]'),(5206374,99,'[{7,41590},{15,34659}]','[{255,36160007,82740}]'),(5206374,100,'[{7,42172},{15,35143}]','[{255,36160007,0}]'),(5206383,1,'[{8,518},{16,432}]','[{255,36160007,4463}]'),(5206383,2,'[{8,690},{16,576}]','[{255,36160007,4674}]'),(5206383,3,'[{8,866},{16,722}]','[{255,36160007,4893}]'),(5206383,4,'[{8,1044},{16,870}]','[{255,36160007,5121}]'),(5206383,5,'[{8,1224},{16,1020}]','[{255,36160007,5355}]'),(5206383,6,'[{8,1406},{16,1172}]','[{255,36160007,5598}]'),(5206383,7,'[{8,1590},{16,1326}]','[{255,36160007,5852}]'),(5206383,8,'[{8,1776},{16,1482}]','[{255,36160007,6113}]'),(5206383,9,'[{8,1964},{16,1639}]','[{255,36160007,6386}]'),(5206383,10,'[{8,2156},{16,1798}]','[{255,36160007,6668}]'),(5206383,11,'[{8,2350},{16,1959}]','[{255,36160007,6962}]'),(5206383,12,'[{8,2546},{16,2122}]','[{255,36160007,7268}]'),(5206383,13,'[{8,2744},{16,2287}]','[{255,36160007,7587}]'),(5206383,14,'[{8,2944},{16,2454}]','[{255,36160007,7919}]'),(5206383,15,'[{8,3146},{16,2623}]','[{255,36160007,8267}]'),(5206383,16,'[{8,3352},{16,2794}]','[{255,36160007,8628}]'),(5206383,17,'[{8,3560},{16,2967}]','[{255,36160007,9006}]'),(5206383,18,'[{8,3770},{16,3142}]','[{255,36160007,9402}]'),(5206383,19,'[{8,3982},{16,3319}]','[{255,36160007,9818}]'),(5206383,20,'[{8,4196},{16,3498}]','[{255,36160007,10253}]'),(5206383,21,'[{8,4412},{16,3678}]','[{255,36160007,10710}]'),(5206383,22,'[{8,4630},{16,3860}]','[{255,36160007,11049}]'),(5206383,23,'[{8,4852},{16,4044}]','[{255,36160007,11396}]'),(5206383,24,'[{8,5076},{16,4230}]','[{255,36160007,11753}]'),(5206383,25,'[{8,5302},{16,4418}]','[{255,36160007,12119}]'),(5206383,26,'[{8,5530},{16,4608}]','[{255,36160007,12495}]'),(5206383,27,'[{8,5760},{16,4800}]','[{255,36160007,12882}]'),(5206383,28,'[{8,5992},{16,4994}]','[{255,36160007,13278}]'),(5206383,29,'[{8,6228},{16,5190}]','[{255,36160007,13685}]'),(5206383,30,'[{8,6466},{16,5388}]','[{255,36160007,14105}]'),(5206383,31,'[{8,6706},{16,5588}]','[{255,36160007,14535}]'),(5206383,32,'[{8,6948},{16,5790}]','[{255,36160007,14979}]'),(5206383,33,'[{8,7192},{16,5994}]','[{255,36160007,15435}]'),(5206383,34,'[{8,7438},{16,6199}]','[{255,36160007,15906}]'),(5206383,35,'[{8,7686},{16,6406}]','[{255,36160007,16391}]'),(5206383,36,'[{8,7938},{16,6615}]','[{255,36160007,16889}]'),(5206383,37,'[{8,8192},{16,6826}]','[{255,36160007,17405}]'),(5206383,38,'[{8,8448},{16,7039}]','[{255,36160007,17936}]'),(5206383,39,'[{8,8706},{16,7254}]','[{255,36160007,18483}]'),(5206383,40,'[{8,8966},{16,7471}]','[{255,36160007,19050}]'),(5206383,41,'[{8,9228},{16,7690}]','[{255,36160007,19635}]'),(5206383,42,'[{8,9492},{16,7911}]','[{255,36160007,20105}]'),(5206383,43,'[{8,9760},{16,8134}]','[{255,36160007,20583}]'),(5206383,44,'[{8,10030},{16,8359}]','[{255,36160007,21071}]'),(5206383,45,'[{8,10302},{16,8586}]','[{255,36160007,21569}]'),(5206383,46,'[{8,10576},{16,8814}]','[{255,36160007,22079}]'),(5206383,47,'[{8,10852},{16,9044}]','[{255,36160007,22598}]'),(5206383,48,'[{8,11130},{16,9276}]','[{255,36160007,23129}]'),(5206383,49,'[{8,11412},{16,9510}]','[{255,36160007,23670}]'),(5206383,50,'[{8,11696},{16,9746}]','[{255,36160007,24225}]'),(5206383,51,'[{8,11982},{16,9984}]','[{255,36160007,24791}]'),(5206383,52,'[{8,12270},{16,10224}]','[{255,36160007,25371}]'),(5206383,53,'[{8,12560},{16,10466}]','[{255,36160007,25964}]'),(5206383,54,'[{8,12852},{16,10710}]','[{255,36160007,26570}]'),(5206383,55,'[{8,13146},{16,10956}]','[{255,36160007,27191}]'),(5206383,56,'[{8,13444},{16,11204}]','[{255,36160007,27825}]'),(5206383,57,'[{8,13744},{16,11454}]','[{255,36160007,28475}]'),(5206383,58,'[{8,14046},{16,11706}]','[{255,36160007,29141}]'),(5206383,59,'[{8,14350},{16,11959}]','[{255,36160007,29823}]'),(5206383,60,'[{8,14656},{16,12214}]','[{255,36160007,30521}]'),(5206383,61,'[{8,14964},{16,12471}]','[{255,36160007,31238}]'),(5206383,62,'[{8,15276},{16,12730}]','[{255,36160007,31973}]'),(5206383,63,'[{8,15590},{16,12991}]','[{255,36160007,32726}]'),(5206383,64,'[{8,15906},{16,13254}]','[{255,36160007,33498}]'),(5206383,65,'[{8,16224},{16,13519}]','[{255,36160007,34292}]'),(5206383,66,'[{8,16544},{16,13786}]','[{255,36160007,35105}]'),(5206383,67,'[{8,16866},{16,14055}]','[{255,36160007,35942}]'),(5206383,68,'[{8,17190},{16,14326}]','[{255,36160007,36801}]'),(5206383,69,'[{8,17518},{16,14599}]','[{255,36160007,37685}]'),(5206383,70,'[{8,17848},{16,14874}]','[{255,36160007,38592}]'),(5206383,71,'[{8,18180},{16,15150}]','[{255,36160007,39525}]'),(5206383,72,'[{8,18514},{16,15428}]','[{255,36160007,40487}]'),(5206383,73,'[{8,18850},{16,15708}]','[{255,36160007,41475}]'),(5206383,74,'[{8,19188},{16,15990}]','[{255,36160007,42494}]'),(5206383,75,'[{8,19528},{16,16274}]','[{255,36160007,43544}]'),(5206383,76,'[{8,19872},{16,16560}]','[{255,36160007,44397}]'),(5206383,77,'[{8,20218},{16,16848}]','[{255,36160007,45269}]'),(5206383,78,'[{8,20566},{16,17138}]','[{255,36160007,46160}]'),(5206383,79,'[{8,20916},{16,17430}]','[{255,36160007,47069}]'),(5206383,80,'[{8,21268},{16,17724}]','[{255,36160007,47996}]'),(5206383,81,'[{8,21622},{16,18020}]','[{255,36160007,48944}]'),(5206383,82,'[{8,21980},{16,18318}]','[{255,36160007,49913}]'),(5206383,83,'[{8,22340},{16,18618}]','[{255,36160007,50903}]'),(5206383,84,'[{8,22702},{16,18919}]','[{255,36160007,51914}]'),(5206383,85,'[{8,23066},{16,19222}]','[{255,36160007,52949}]'),(5206383,86,'[{8,23432},{16,19527}]','[{255,36160007,54006}]'),(5206383,87,'[{8,23800},{16,19834}]','[{255,36160007,55089}]'),(5206383,88,'[{8,24170},{16,20143}]','[{255,36160007,56198}]'),(5206383,89,'[{8,24544},{16,20454}]','[{255,36160007,57330}]'),(5206383,90,'[{8,24920},{16,20767}]','[{255,36160007,58491}]'),(5206383,91,'[{8,25298},{16,21082}]','[{255,36160007,59679}]'),(5206383,92,'[{8,25678},{16,21399}]','[{255,36160007,60897}]'),(5206383,93,'[{8,26060},{16,21718}]','[{255,36160007,62145}]'),(5206383,94,'[{8,26444},{16,22039}]','[{255,36160007,63423}]'),(5206383,95,'[{8,26832},{16,22362}]','[{255,36160007,64734}]'),(5206383,96,'[{8,27222},{16,22686}]','[{255,36160007,66080}]'),(5206383,97,'[{8,27614},{16,23012}]','[{255,36160007,67460}]'),(5206383,98,'[{8,28008},{16,23340}]','[{255,36160007,68876}]'),(5206383,99,'[{8,28404},{16,23670}]','[{255,36160007,70329}]'),(5206383,100,'[{8,28802},{16,24002}]','[{255,36160007,0}]'),(5206384,1,'[{8,924},{16,770}]','[{255,36160007,5250}]'),(5206384,2,'[{8,1176},{16,980}]','[{255,36160007,5499}]'),(5206384,3,'[{8,1432},{16,1193}]','[{255,36160007,5757}]'),(5206384,4,'[{8,1690},{16,1409}]','[{255,36160007,6024}]'),(5206384,5,'[{8,1952},{16,1627}]','[{255,36160007,6300}]'),(5206384,6,'[{8,2218},{16,1848}]','[{255,36160007,6587}]'),(5206384,7,'[{8,2486},{16,2072}]','[{255,36160007,6884}]'),(5206384,8,'[{8,2758},{16,2299}]','[{255,36160007,7191}]'),(5206384,9,'[{8,3034},{16,2529}]','[{255,36160007,7512}]'),(5206384,10,'[{8,3312},{16,2761}]','[{255,36160007,7844}]'),(5206384,11,'[{8,3594},{16,2996}]','[{255,36160007,8190}]'),(5206384,12,'[{8,3880},{16,3234}]','[{255,36160007,8550}]'),(5206384,13,'[{8,4168},{16,3475}]','[{255,36160007,8925}]'),(5206384,14,'[{8,4460},{16,3719}]','[{255,36160007,9317}]'),(5206384,15,'[{8,4756},{16,3965}]','[{255,36160007,9725}]'),(5206384,16,'[{8,5056},{16,4214}]','[{255,36160007,10151}]'),(5206384,17,'[{8,5358},{16,4466}]','[{255,36160007,10596}]'),(5206384,18,'[{8,5664},{16,4721}]','[{255,36160007,11061}]'),(5206384,19,'[{8,5974},{16,4979}]','[{255,36160007,11550}]'),(5206384,20,'[{8,6286},{16,5239}]','[{255,36160007,12062}]'),(5206384,21,'[{8,6602},{16,5502}]','[{255,36160007,12600}]'),(5206384,22,'[{8,6922},{16,5768}]','[{255,36160007,12999}]'),(5206384,23,'[{8,7244},{16,6037}]','[{255,36160007,13407}]'),(5206384,24,'[{8,7570},{16,6309}]','[{255,36160007,13827}]'),(5206384,25,'[{8,7900},{16,6583}]','[{255,36160007,14258}]'),(5206384,26,'[{8,8232},{16,6860}]','[{255,36160007,14700}]'),(5206384,27,'[{8,8568},{16,7140}]','[{255,36160007,15155}]'),(5206384,28,'[{8,8908},{16,7423}]','[{255,36160007,15621}]'),(5206384,29,'[{8,9250},{16,7709}]','[{255,36160007,16100}]'),(5206384,30,'[{8,9596},{16,7997}]','[{255,36160007,16593}]'),(5206384,31,'[{8,9946},{16,8288}]','[{255,36160007,17100}]'),(5206384,32,'[{8,10298},{16,8582}]','[{255,36160007,17622}]'),(5206384,33,'[{8,10654},{16,8879}]','[{255,36160007,18159}]'),(5206384,34,'[{8,11014},{16,9179}]','[{255,36160007,18713}]'),(5206384,35,'[{8,11376},{16,9481}]','[{255,36160007,19283}]'),(5206384,36,'[{8,11742},{16,9786}]','[{255,36160007,19869}]'),(5206384,37,'[{8,12112},{16,10094}]','[{255,36160007,20475}]'),(5206384,38,'[{8,12484},{16,10405}]','[{255,36160007,21101}]'),(5206384,39,'[{8,12860},{16,10719}]','[{255,36160007,21746}]'),(5206384,40,'[{8,13240},{16,11035}]','[{255,36160007,22412}]'),(5206384,41,'[{8,13624},{16,11354}]','[{255,36160007,23100}]'),(5206384,42,'[{8,14010},{16,11676}]','[{255,36160007,23652}]'),(5206384,43,'[{8,14400},{16,12001}]','[{255,36160007,24215}]'),(5206384,44,'[{8,14794},{16,12329}]','[{255,36160007,24789}]'),(5206384,45,'[{8,15190},{16,12659}]','[{255,36160007,25376}]'),(5206384,46,'[{8,15590},{16,12992}]','[{255,36160007,25974}]'),(5206384,47,'[{8,15994},{16,13328}]','[{255,36160007,26585}]'),(5206384,48,'[{8,16400},{16,13667}]','[{255,36160007,27210}]'),(5206384,49,'[{8,16810},{16,14009}]','[{255,36160007,27848}]'),(5206384,50,'[{8,17224},{16,14353}]','[{255,36160007,28500}]'),(5206384,51,'[{8,17640},{16,14700}]','[{255,36160007,29166}]'),(5206384,52,'[{8,18060},{16,15050}]','[{255,36160007,29849}]'),(5206384,53,'[{8,18484},{16,15403}]','[{255,36160007,30546}]'),(5206384,54,'[{8,18910},{16,15759}]','[{255,36160007,31259}]'),(5206384,55,'[{8,19340},{16,16117}]','[{255,36160007,31989}]'),(5206384,56,'[{8,19774},{16,16478}]','[{255,36160007,32736}]'),(5206384,57,'[{8,20210},{16,16842}]','[{255,36160007,33500}]'),(5206384,58,'[{8,20650},{16,17209}]','[{255,36160007,34283}]'),(5206384,59,'[{8,21094},{16,17579}]','[{255,36160007,35085}]'),(5206384,60,'[{8,21540},{16,17951}]','[{255,36160007,35907}]'),(5206384,61,'[{8,21990},{16,18326}]','[{255,36160007,36750}]'),(5206384,62,'[{8,22444},{16,18704}]','[{255,36160007,37614}]'),(5206384,63,'[{8,22900},{16,19085}]','[{255,36160007,38501}]'),(5206384,64,'[{8,23360},{16,19469}]','[{255,36160007,39410}]'),(5206384,65,'[{8,23824},{16,19855}]','[{255,36160007,40343}]'),(5206384,66,'[{8,24292},{16,20244}]','[{255,36160007,41300}]'),(5206384,67,'[{8,24762},{16,20636}]','[{255,36160007,42284}]'),(5206384,68,'[{8,25236},{16,21031}]','[{255,36160007,43295}]'),(5206384,69,'[{8,25714},{16,21429}]','[{255,36160007,44334}]'),(5206384,70,'[{8,26194},{16,21829}]','[{255,36160007,45402}]'),(5206384,71,'[{8,26678},{16,22232}]','[{255,36160007,46500}]'),(5206384,72,'[{8,27166},{16,22638}]','[{255,36160007,47631}]'),(5206384,73,'[{8,27656},{16,23047}]','[{255,36160007,48794}]'),(5206384,74,'[{8,28150},{16,23459}]','[{255,36160007,49992}]'),(5206384,75,'[{8,28648},{16,23873}]','[{255,36160007,51228}]'),(5206384,76,'[{8,29148},{16,24290}]','[{255,36160007,52232}]'),(5206384,77,'[{8,29652},{16,24710}]','[{255,36160007,53258}]'),(5206384,78,'[{8,30160},{16,25133}]','[{255,36160007,54305}]'),(5206384,79,'[{8,30670},{16,25559}]','[{255,36160007,55374}]'),(5206384,80,'[{8,31184},{16,25987}]','[{255,36160007,56466}]'),(5206384,81,'[{8,31702},{16,26418}]','[{255,36160007,57581}]'),(5206384,82,'[{8,32222},{16,26852}]','[{255,36160007,58721}]'),(5206384,83,'[{8,32746},{16,27289}]','[{255,36160007,59885}]'),(5206384,84,'[{8,33274},{16,27729}]','[{255,36160007,61076}]'),(5206384,85,'[{8,33804},{16,28171}]','[{255,36160007,62292}]'),(5206384,86,'[{8,34338},{16,28616}]','[{255,36160007,63537}]'),(5206384,87,'[{8,34876},{16,29064}]','[{255,36160007,64811}]'),(5206384,88,'[{8,35416},{16,29515}]','[{255,36160007,66114}]'),(5206384,89,'[{8,35960},{16,29969}]','[{255,36160007,67448}]'),(5206384,90,'[{8,36508},{16,30425}]','[{255,36160007,68813}]'),(5206384,91,'[{8,37060},{16,30884}]','[{255,36160007,70211}]'),(5206384,92,'[{8,37614},{16,31346}]','[{255,36160007,71643}]'),(5206384,93,'[{8,38172},{16,31811}]','[{255,36160007,73112}]'),(5206384,94,'[{8,38734},{16,32279}]','[{255,36160007,74616}]'),(5206384,95,'[{8,39298},{16,32749}]','[{255,36160007,76158}]'),(5206384,96,'[{8,39866},{16,33222}]','[{255,36160007,77741}]'),(5206384,97,'[{8,40438},{16,33698}]','[{255,36160007,79364}]'),(5206384,98,'[{8,41012},{16,34177}]','[{255,36160007,81030}]'),(5206384,99,'[{8,41590},{16,34659}]','[{255,36160007,82740}]'),(5206384,100,'[{8,42172},{16,35143}]','[{255,36160007,0}]');
/*!40000 ALTER TABLE `base_seal_soul_lv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_seal_soul_pos`
--

DROP TABLE IF EXISTS `base_seal_soul_pos`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_seal_soul_pos` (
  `pos` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '魂珠位置',
  `inlay_type_list` varchar(50) NOT NULL DEFAULT '[]' COMMENT '可镶嵌的魂珠部位类型',
  `condition` varchar(128) NOT NULL DEFAULT '[]' COMMENT '解锁条件',
  PRIMARY KEY (`pos`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='魂珠位置解锁条件表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_seal_soul_pos`
--

LOCK TABLES `base_seal_soul_pos` WRITE;
/*!40000 ALTER TABLE `base_seal_soul_pos` DISABLE KEYS */;
INSERT INTO `base_seal_soul_pos` VALUES (1,'[1]','[{soul_dungeon,1}]'),(2,'[1]','[{soul_dungeon,4}]'),(3,'[1]','[{soul_dungeon,8}]'),(4,'[1]','[{soul_dungeon,12}]'),(5,'[1]','[{soul_dungeon,16}]'),(6,'[1]','[{soul_dungeon,20}]'),(7,'[1]','[{soul_dungeon,25}]'),(8,'[1]','[{soul_dungeon,30}]'),(9,'[2]','[{lv,70}]'),(10,'[3]','[{lv,70}]');
/*!40000 ALTER TABLE `base_seal_soul_pos` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_seal_soul_times_reward`
--

DROP TABLE IF EXISTS `base_seal_soul_times_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_seal_soul_times_reward` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '序号id',
  `times` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '条件次数',
  `rewards` varchar(128) NOT NULL DEFAULT '[]' COMMENT '奖励列表',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='限时目标奖励配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_seal_soul_times_reward`
--

LOCK TABLES `base_seal_soul_times_reward` WRITE;
/*!40000 ALTER TABLE `base_seal_soul_times_reward` DISABLE KEYS */;
INSERT INTO `base_seal_soul_times_reward` VALUES (1,10,'[{0,38180010,1},{255,36160008,10}]'),(2,30,'[{0,38180010,3},{255,36160008,20}]'),(3,60,'[{0,38180010,5},{255,36160008,30}]'),(4,90,'[{0,38180010,5},{255,36160008,50}]'),(5,120,'[{0,38180010,5},{255,36160008,80}]'),(6,150,'[{0,38180010,10},{255,36160008,100}]');
/*!40000 ALTER TABLE `base_seal_soul_times_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_sell_filter_stage`
--

DROP TABLE IF EXISTS `base_sell_filter_stage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_sell_filter_stage` (
  `stage` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '阶数',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '描述@lang@',
  PRIMARY KEY (`stage`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='市场物品阶数过滤配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_sell_filter_stage`
--

LOCK TABLES `base_sell_filter_stage` WRITE;
/*!40000 ALTER TABLE `base_sell_filter_stage` DISABLE KEYS */;
INSERT INTO `base_sell_filter_stage` VALUES (1,'一阶'),(2,'二阶'),(3,'三阶'),(4,'四阶'),(5,'五阶'),(6,'六阶'),(7,'七阶'),(8,'八阶'),(9,'九阶'),(10,'十阶'),(11,'十一阶'),(12,'十二阶'),(13,'十三阶'),(14,'十四阶'),(15,'十五阶'),(16,'十六阶');
/*!40000 ALTER TABLE `base_sell_filter_stage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_sell_filter_star`
--

DROP TABLE IF EXISTS `base_sell_filter_star`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_sell_filter_star` (
  `color` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '颜色',
  `star` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '星数',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '描述@lang@',
  PRIMARY KEY (`color`,`star`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='市场物品星数过滤配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_sell_filter_star`
--

LOCK TABLES `base_sell_filter_star` WRITE;
/*!40000 ALTER TABLE `base_sell_filter_star` DISABLE KEYS */;
INSERT INTO `base_sell_filter_star` VALUES (2,0,'紫色零星'),(3,1,'橙色一星'),(3,2,'橙色二星'),(4,1,'红色一星'),(4,2,'红色二星'),(4,3,'红色三星');
/*!40000 ALTER TABLE `base_sell_filter_star` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_sell_price`
--

DROP TABLE IF EXISTS `base_sell_price`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_sell_price` (
  `min_wlv` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '世界等级下限',
  `max_wlv` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '世界等级上限',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型id',
  `num_lim` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '单次上架数量限制',
  `min_unit_price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小单价',
  `max_unit_price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大单价',
  PRIMARY KEY (`min_wlv`,`max_wlv`,`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='市场出售价格限制';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_sell_price`
--

LOCK TABLES `base_sell_price` WRITE;
/*!40000 ALTER TABLE `base_sell_price` DISABLE KEYS */;
INSERT INTO `base_sell_price` VALUES (1,1000,12120000,10,6,200),(1,1000,12120001,10,6,200),(1,1000,12120002,10,6,200),(1,1000,12120003,10,6,200),(1,1000,12120004,10,6,200),(1,1000,12120005,10,6,200),(1,1000,12120006,10,6,200),(1,1000,17010001,99,1,10),(1,1000,17010002,99,3,100),(1,1000,17010003,99,30,1000),(1,1000,18030001,1,120,2500),(1,1000,20010011,1,60,2000),(1,1000,20010012,1,300,10000),(1,1000,20010013,1,1200,40000),(1,1000,20010014,1,2400,80000),(1,1000,20010015,1,5000,1000000),(1,1000,20010016,1,10000,9000000),(1,1000,20010021,1,60,2000),(1,1000,20010022,1,300,10000),(1,1000,20010023,1,1200,40000),(1,1000,20010024,1,2400,80000),(1,1000,20010025,1,5000,1000000),(1,1000,20010026,1,10000,9000000),(1,1000,20010031,1,60,2000),(1,1000,20010032,1,300,10000),(1,1000,20010033,1,1200,40000),(1,1000,20010034,1,2400,80000),(1,1000,20010035,1,5000,1000000),(1,1000,20010036,1,10000,9000000),(1,1000,20010041,1,60,2000),(1,1000,20010042,1,300,10000),(1,1000,20010043,1,1200,40000),(1,1000,20010044,1,2400,80000),(1,1000,20010045,1,5000,1000000),(1,1000,20010046,1,10000,9000000),(1,1000,20020001,1,1,10),(1,1000,20020002,1,1,10),(1,1000,20020003,1,1,10),(1,1000,20020004,1,1,10),(1,1000,20030001,1,1,10),(1,1000,20030008,1,1,10),(1,1000,20030009,1,1,10),(1,1000,20040000,1,240,8000),(1,1000,20040001,1,60,2000),(1,1000,20040002,1,105,3500),(1,1000,20040003,1,150,5000),(1,1000,20040004,1,240,8000),(1,1000,20040005,1,300,10000),(1,1000,20040006,1,450,15000),(1,1000,20041000,10,24,800),(1,1000,20041001,10,6,200),(1,1000,20041002,10,11,350),(1,1000,20041003,10,15,500),(1,1000,20041004,10,24,800),(1,1000,20041005,10,30,1000),(1,1000,20041006,10,45,1500),(1,1000,20050001,10,1,10),(1,1000,20050002,10,1,10),(1,1000,20050003,10,1,10),(1,1000,20050004,10,1,10),(1,1000,20050005,10,1,10),(1,1000,24030001,10,207,6880),(1,1000,24030002,10,267,8880),(1,1000,24030003,10,327,10880),(1,1000,24030004,10,387,12880),(1,1000,24030005,10,447,14880),(1,1000,24030006,10,507,16880),(1,1000,24030007,10,507,16880),(1,1000,24030008,10,3000,99990),(1,1000,24030009,10,3000,99990),(1,1000,24031001,10,21,690),(1,1000,24031002,10,27,890),(1,1000,24031003,10,33,1090),(1,1000,24031004,10,39,1290),(1,1000,24031005,10,45,1490),(1,1000,24031006,10,51,1690),(1,1000,24031007,10,51,1690),(1,1000,24031008,10,300,10000),(1,1000,24031009,10,300,10000),(1,1000,37040001,10,1,10),(1,1000,38030001,99,24,800),(1,1000,38030003,99,30,1000),(1,1000,38030004,99,15,500),(1,1000,38030005,99,15,500),(1,1000,38030006,99,12,400),(1,1000,38030007,99,12,400),(1,1000,38040010,99,2,50),(1,1000,38040102,99,2,50),(1,1000,38100001,99,1,20),(1,1000,38110001,99,2,50),(1,1000,38110002,99,3,100),(1,1000,38110003,99,5,150),(1,1000,38110004,99,300,9990),(1,1000,38110005,99,300,9990),(1,1000,38110006,99,300,9990),(1,1000,38110007,99,300,9990),(1,1000,38120001,99,300,9990),(1,1000,38130001,99,2,50),(1,1000,38140001,99,1,10),(1,1000,38140002,99,1,10),(1,1000,38140003,99,1,10),(1,1000,38140004,99,1,10),(1,1000,38140005,99,1,10),(1,1000,38140006,99,1,10),(1,1000,38140007,99,1,10),(1,1000,38140008,99,1,10),(1,1000,38150001,99,1,10),(1,1000,38150002,99,1,10),(1,1000,38150003,99,1,10),(1,1000,38150004,99,1,10),(1,1000,38150005,99,1,10),(1,1000,38150006,99,1,10),(1,1000,38150007,99,1,10),(1,1000,38150008,99,1,10),(1,1000,38160001,99,1,10),(1,1000,38170001,99,1,10),(1,1000,38180001,99,1,10),(1,1000,38180002,99,1,10),(1,1000,38180003,99,1,10),(1,1000,38180005,99,1,10),(1,1000,38180006,99,1,10),(1,1000,38180007,99,1,10),(1,1000,38190001,99,1,10),(1,1000,38210001,99,1,10),(1,1000,38210002,99,1,10),(1,1000,38220001,99,1,10),(1,1000,38220002,99,1,10),(1,1000,38220003,99,1,10),(1,1000,38220004,99,1,10),(1,1000,38220005,99,1,10),(1,1000,38230003,99,9,300),(1,1000,38230005,99,9,300),(1,1000,38230009,99,9,300),(1,1000,38230101,99,2,60),(1,1000,38230102,99,1,30),(1,1000,38230104,99,1,30),(1,1000,38230106,99,1,30),(1,1000,38230107,99,2,60),(1,1000,38230108,99,1,30),(1,1000,38230110,99,1,30),(1,1000,38230201,99,2,60),(1,1000,38230202,99,1,30),(1,1000,38230204,99,1,30),(1,1000,38230206,99,1,30),(1,1000,38230207,99,2,60),(1,1000,38230208,99,1,30),(1,1000,38230210,99,1,30),(1,1000,38230301,99,2,60),(1,1000,38230302,99,1,30),(1,1000,38230304,99,1,30),(1,1000,38230306,99,1,30),(1,1000,38230307,99,2,60),(1,1000,38230308,99,1,30),(1,1000,38230310,99,1,30),(1,1000,38230401,99,2,60),(1,1000,38230402,99,1,30),(1,1000,38230404,99,1,30),(1,1000,38230406,99,1,30),(1,1000,38230407,99,2,60),(1,1000,38230408,99,1,30),(1,1000,38230410,99,1,30),(1,1000,38240001,99,8,240),(1,1000,38240002,99,4,120),(1,1000,38240003,99,36,1200),(1,1000,38240004,99,4,120),(1,1000,38240005,99,36,1200),(1,1000,38240006,99,4,120),(1,1000,38240007,99,8,240),(1,1000,38240008,99,4,120),(1,1000,38240009,99,72,2400),(1,1000,38240010,99,4,120),(1,1000,38270011,99,1,10),(1,1000,38270012,99,1,20),(1,1000,38270013,99,1,30),(1,1000,38270021,99,1,20),(1,1000,38270022,99,2,40),(1,1000,38270023,99,4,120),(1,1000,45010001,1,8,250),(1,1000,45010002,1,8,250),(1,1000,45010003,1,8,250),(1,1000,45010004,1,8,250),(1,1000,45010005,1,8,250),(1,1000,45010006,1,8,250),(1,1000,45010007,1,8,250),(1,1000,45010008,1,8,250),(1,1000,45010009,1,8,250),(1,1000,45010010,1,8,250),(1,1000,45010011,1,8,250),(1,1000,45010012,1,8,250),(1,1000,45010013,1,8,250),(1,1000,45010014,1,8,250),(1,1000,45010015,1,8,250),(1,1000,45010016,1,8,250),(1,1000,45010101,1,12,400),(1,1000,45010102,1,12,400),(1,1000,45010103,1,12,400),(1,1000,45010104,1,12,400),(1,1000,45010105,1,12,400),(1,1000,45010106,1,12,400),(1,1000,45010107,1,12,400),(1,1000,45010108,1,12,400),(1,1000,45010109,1,12,400),(1,1000,45010110,1,12,400),(1,1000,45010111,1,12,400),(1,1000,45010112,1,12,400),(1,1000,45010113,1,12,400),(1,1000,45010114,1,12,400),(1,1000,45010115,1,12,400),(1,1000,45010116,1,12,400),(1,1000,45010117,1,12,400),(1,1000,45010118,1,12,400),(1,1000,45010201,1,20,650),(1,1000,45010202,1,20,650),(1,1000,45010203,1,20,650),(1,1000,45010204,1,20,650),(1,1000,45010205,1,20,650),(1,1000,45010206,1,20,650),(1,1000,45010301,1,30,1000),(1,1000,45010302,1,30,1000),(1,1000,45010303,1,30,1000),(1,1000,45010304,1,30,1000),(1,1000,45010305,1,30,1000),(1,1000,45010306,1,30,1000),(1,1000,45010401,1,39,1300),(1,1000,45010402,1,39,1300),(1,1000,45010403,1,39,1300),(1,1000,1001010100,1,1,100),(1,1000,1001010110,1,1,100),(1,1000,1001010120,1,1,100),(1,1000,1001010131,1,1,100),(1,1000,1001010132,1,1,100),(1,1000,1001010141,1,1,200),(1,1000,1001010142,1,1,300),(1,1000,1001010143,1,1,900),(1,1000,1001010153,1,1,99999),(1,1000,1001010163,1,1,99999),(1,1000,1001010200,1,1,100),(1,1000,1001010210,1,1,100),(1,1000,1001010220,1,1,100),(1,1000,1001010231,1,1,200),(1,1000,1001010232,1,1,200),(1,1000,1001010241,1,1,400),(1,1000,1001010242,1,1,500),(1,1000,1001010243,1,1,1500),(1,1000,1001010253,1,1,99999),(1,1000,1001010263,1,1,99999),(1,1000,1001010300,1,1,100),(1,1000,1001010310,1,1,100),(1,1000,1001010320,1,1,200),(1,1000,1001010331,1,1,200),(1,1000,1001010332,1,1,300),(1,1000,1001010341,1,1,500),(1,1000,1001010342,1,1,800),(1,1000,1001010343,1,1,2300),(1,1000,1001010353,1,1,99999),(1,1000,1001010363,1,1,99999),(1,1000,1001010400,1,1,100),(1,1000,1001010410,1,1,200),(1,1000,1001010420,1,1,300),(1,1000,1001010431,1,1,300),(1,1000,1001010432,1,1,400),(1,1000,1001010441,1,1,800),(1,1000,1001010442,1,1,1100),(1,1000,1001010443,1,1,3300),(1,1000,1001010453,1,1,99999),(1,1000,1001010463,1,1,99999),(1,1000,1001010500,1,1,100),(1,1000,1001010510,1,1,200),(1,1000,1001010520,1,1,300),(1,1000,1001010531,1,1,400),(1,1000,1001010532,1,1,500),(1,1000,1001010541,1,1,1000),(1,1000,1001010542,1,1,1600),(1,1000,1001010543,1,1,4600),(1,1000,1001010553,1,1,99999),(1,1000,1001010563,1,1,99999),(1,1000,1001010600,1,1,100),(1,1000,1001010610,1,1,200),(1,1000,1001010620,1,1,400),(1,1000,1001010631,1,1,500),(1,1000,1001010632,1,1,600),(1,1000,1001010641,1,1,1200),(1,1000,1001010642,1,1,1800),(1,1000,1001010643,1,1,6600),(1,1000,1001010653,1,1,99999),(1,1000,1001010663,1,1,99999),(1,1000,1001010700,1,1,100),(1,1000,1001010710,1,1,200),(1,1000,1001010720,1,1,400),(1,1000,1001010731,1,1,600),(1,1000,1001010732,1,1,700),(1,1000,1001010741,1,1,1600),(1,1000,1001010742,1,1,2400),(1,1000,1001010743,1,1,9000),(1,1000,1001010753,1,1,99999),(1,1000,1001010763,1,1,99999),(1,1000,1001010800,1,1,100),(1,1000,1001010810,1,1,300),(1,1000,1001010820,1,1,500),(1,1000,1001010831,1,1,600),(1,1000,1001010832,1,1,800),(1,1000,1001010841,1,1,1900),(1,1000,1001010842,1,1,2900),(1,1000,1001010843,1,1,12300),(1,1000,1001010853,1,1,99999),(1,1000,1001010863,1,1,99999),(1,1000,1001010900,1,1,100),(1,1000,1001010910,1,1,300),(1,1000,1001010920,1,1,500),(1,1000,1001010931,1,1,700),(1,1000,1001010932,1,1,900),(1,1000,1001010941,1,1,2200),(1,1000,1001010942,1,1,3500),(1,1000,1001010943,1,1,17300),(1,1000,1001010953,1,1,99999),(1,1000,1001010963,1,1,99999),(1,1000,1001011000,1,1,100),(1,1000,1001011010,1,1,300),(1,1000,1001011020,1,1,600),(1,1000,1001011031,1,1,800),(1,1000,1001011032,1,1,1000),(1,1000,1001011041,1,1,2500),(1,1000,1001011042,1,1,4000),(1,1000,1001011043,1,1,24000),(1,1000,1001011053,1,1,99999),(1,1000,1001011063,1,1,99999),(1,1000,1001011100,1,1,200),(1,1000,1001011110,1,1,400),(1,1000,1001011120,1,1,700),(1,1000,1001011131,1,1,1000),(1,1000,1001011132,1,1,1200),(1,1000,1001011141,1,1,3500),(1,1000,1001011142,1,1,5700),(1,1000,1001011143,1,1,34000),(1,1000,1001011153,1,1,99999),(1,1000,1001011163,1,1,99999),(1,1000,1001011200,1,1,200),(1,1000,1001011210,1,1,500),(1,1000,1001011220,1,1,900),(1,1000,1001011231,1,1,1200),(1,1000,1001011232,1,1,1500),(1,1000,1001011241,1,1,5000),(1,1000,1001011242,1,1,8500),(1,1000,1001011243,1,1,50600),(1,1000,1001011253,1,1,99999),(1,1000,1001011263,1,1,99999),(1,1000,1001011300,1,1,200),(1,1000,1001011310,1,1,500),(1,1000,1001011320,1,1,900),(1,1000,1001011331,1,1,1200),(1,1000,1001011332,1,1,1500),(1,1000,1001011341,1,1,6000),(1,1000,1001011342,1,1,10400),(1,1000,1001011343,1,1,74000),(1,1000,1001011353,1,1,99999),(1,1000,1001011363,1,1,99999),(1,1000,1001011400,1,1,200),(1,1000,1001011410,1,1,500),(1,1000,1001011420,1,1,1000),(1,1000,1001011431,1,1,1400),(1,1000,1001011432,1,1,1700),(1,1000,1001011441,1,1,7000),(1,1000,1001011442,1,1,12400),(1,1000,1001011443,1,1,99999),(1,1000,1001011453,1,1,99999),(1,1000,1001011463,1,1,99999),(1,1000,1001011500,1,1,200),(1,1000,1001011510,1,1,600),(1,1000,1001011520,1,1,1200),(1,1000,1001011531,1,1,1600),(1,1000,1001011532,1,1,2000),(1,1000,1001011541,1,1,7900),(1,1000,1001011542,1,1,13800),(1,1000,1001011543,1,1,99999),(1,1000,1001011553,1,1,99999),(1,1000,1001011563,1,1,99999),(1,1000,1001011600,1,1,300),(1,1000,1001011610,1,1,700),(1,1000,1001011620,1,1,1300),(1,1000,1001011631,1,1,1800),(1,1000,1001011632,1,1,2200),(1,1000,1001011641,1,1,10000),(1,1000,1001011642,1,1,17800),(1,1000,1001011643,1,1,99999),(1,1000,1001011653,1,1,99999),(1,1000,1001011663,1,1,99999),(1,1000,1001020100,1,1,100),(1,1000,1001020110,1,1,100),(1,1000,1001020120,1,1,100),(1,1000,1001020131,1,1,100),(1,1000,1001020132,1,1,100),(1,1000,1001020141,1,1,200),(1,1000,1001020142,1,1,300),(1,1000,1001020143,1,1,900),(1,1000,1001020153,1,1,99999),(1,1000,1001020163,1,1,99999),(1,1000,1001020200,1,1,100),(1,1000,1001020210,1,1,100),(1,1000,1001020220,1,1,100),(1,1000,1001020231,1,1,200),(1,1000,1001020232,1,1,200),(1,1000,1001020241,1,1,400),(1,1000,1001020242,1,1,500),(1,1000,1001020243,1,1,1500),(1,1000,1001020253,1,1,99999),(1,1000,1001020263,1,1,99999),(1,1000,1001020300,1,1,100),(1,1000,1001020310,1,1,100),(1,1000,1001020320,1,1,200),(1,1000,1001020331,1,1,200),(1,1000,1001020332,1,1,300),(1,1000,1001020341,1,1,500),(1,1000,1001020342,1,1,800),(1,1000,1001020343,1,1,2300),(1,1000,1001020353,1,1,99999),(1,1000,1001020363,1,1,99999),(1,1000,1001020400,1,1,100),(1,1000,1001020410,1,1,200),(1,1000,1001020420,1,1,300),(1,1000,1001020431,1,1,300),(1,1000,1001020432,1,1,400),(1,1000,1001020441,1,1,800),(1,1000,1001020442,1,1,1100),(1,1000,1001020443,1,1,3300),(1,1000,1001020453,1,1,99999),(1,1000,1001020463,1,1,99999),(1,1000,1001020500,1,1,100),(1,1000,1001020510,1,1,200),(1,1000,1001020520,1,1,300),(1,1000,1001020531,1,1,400),(1,1000,1001020532,1,1,500),(1,1000,1001020541,1,1,1000),(1,1000,1001020542,1,1,1600),(1,1000,1001020543,1,1,4600),(1,1000,1001020553,1,1,99999),(1,1000,1001020563,1,1,99999),(1,1000,1001020600,1,1,100),(1,1000,1001020610,1,1,200),(1,1000,1001020620,1,1,400),(1,1000,1001020631,1,1,500),(1,1000,1001020632,1,1,600),(1,1000,1001020641,1,1,1200),(1,1000,1001020642,1,1,1800),(1,1000,1001020643,1,1,6600),(1,1000,1001020653,1,1,99999),(1,1000,1001020663,1,1,99999),(1,1000,1001020700,1,1,100),(1,1000,1001020710,1,1,200),(1,1000,1001020720,1,1,400),(1,1000,1001020731,1,1,600),(1,1000,1001020732,1,1,700),(1,1000,1001020741,1,1,1600),(1,1000,1001020742,1,1,2400),(1,1000,1001020743,1,1,9000),(1,1000,1001020753,1,1,99999),(1,1000,1001020763,1,1,99999),(1,1000,1001020800,1,1,100),(1,1000,1001020810,1,1,300),(1,1000,1001020820,1,1,500),(1,1000,1001020831,1,1,600),(1,1000,1001020832,1,1,800),(1,1000,1001020841,1,1,1900),(1,1000,1001020842,1,1,2900),(1,1000,1001020843,1,1,12300),(1,1000,1001020853,1,1,99999),(1,1000,1001020863,1,1,99999),(1,1000,1001020900,1,1,100),(1,1000,1001020910,1,1,300),(1,1000,1001020920,1,1,500),(1,1000,1001020931,1,1,700),(1,1000,1001020932,1,1,900),(1,1000,1001020941,1,1,2200),(1,1000,1001020942,1,1,3500),(1,1000,1001020943,1,1,17300),(1,1000,1001020953,1,1,99999),(1,1000,1001020963,1,1,99999),(1,1000,1001021000,1,1,100),(1,1000,1001021010,1,1,300),(1,1000,1001021020,1,1,600),(1,1000,1001021031,1,1,800),(1,1000,1001021032,1,1,1000),(1,1000,1001021041,1,1,2500),(1,1000,1001021042,1,1,4000),(1,1000,1001021043,1,1,24000),(1,1000,1001021053,1,1,99999),(1,1000,1001021063,1,1,99999),(1,1000,1001021100,1,1,200),(1,1000,1001021110,1,1,400),(1,1000,1001021120,1,1,700),(1,1000,1001021131,1,1,1000),(1,1000,1001021132,1,1,1200),(1,1000,1001021141,1,1,3500),(1,1000,1001021142,1,1,5700),(1,1000,1001021143,1,1,34000),(1,1000,1001021153,1,1,99999),(1,1000,1001021163,1,1,99999),(1,1000,1001021200,1,1,200),(1,1000,1001021210,1,1,500),(1,1000,1001021220,1,1,900),(1,1000,1001021231,1,1,1200),(1,1000,1001021232,1,1,1500),(1,1000,1001021241,1,1,5000),(1,1000,1001021242,1,1,8500),(1,1000,1001021243,1,1,50600),(1,1000,1001021253,1,1,99999),(1,1000,1001021263,1,1,99999),(1,1000,1001021300,1,1,200),(1,1000,1001021310,1,1,500),(1,1000,1001021320,1,1,900),(1,1000,1001021331,1,1,1200),(1,1000,1001021332,1,1,1500),(1,1000,1001021341,1,1,6000),(1,1000,1001021342,1,1,10400),(1,1000,1001021343,1,1,74000),(1,1000,1001021353,1,1,99999),(1,1000,1001021363,1,1,99999),(1,1000,1001021400,1,1,200),(1,1000,1001021410,1,1,500),(1,1000,1001021420,1,1,1000),(1,1000,1001021431,1,1,1400),(1,1000,1001021432,1,1,1700),(1,1000,1001021441,1,1,7000),(1,1000,1001021442,1,1,12400),(1,1000,1001021443,1,1,99999),(1,1000,1001021453,1,1,99999),(1,1000,1001021463,1,1,99999),(1,1000,1001021500,1,1,200),(1,1000,1001021510,1,1,600),(1,1000,1001021520,1,1,1200),(1,1000,1001021531,1,1,1600),(1,1000,1001021532,1,1,2000),(1,1000,1001021541,1,1,7900),(1,1000,1001021542,1,1,13800),(1,1000,1001021543,1,1,99999),(1,1000,1001021553,1,1,99999),(1,1000,1001021563,1,1,99999),(1,1000,1001021600,1,1,300),(1,1000,1001021610,1,1,700),(1,1000,1001021620,1,1,1300),(1,1000,1001021631,1,1,1800),(1,1000,1001021632,1,1,2200),(1,1000,1001021641,1,1,10000),(1,1000,1001021642,1,1,17800),(1,1000,1001021643,1,1,99999),(1,1000,1001021653,1,1,99999),(1,1000,1001021663,1,1,99999),(1,1000,1001030100,1,1,100),(1,1000,1001030110,1,1,100),(1,1000,1001030120,1,1,100),(1,1000,1001030131,1,1,100),(1,1000,1001030132,1,1,100),(1,1000,1001030141,1,1,200),(1,1000,1001030142,1,1,300),(1,1000,1001030143,1,1,900),(1,1000,1001030153,1,1,99999),(1,1000,1001030163,1,1,99999),(1,1000,1001030200,1,1,100),(1,1000,1001030210,1,1,100),(1,1000,1001030220,1,1,100),(1,1000,1001030231,1,1,200),(1,1000,1001030232,1,1,200),(1,1000,1001030241,1,1,400),(1,1000,1001030242,1,1,500),(1,1000,1001030243,1,1,1500),(1,1000,1001030253,1,1,99999),(1,1000,1001030263,1,1,99999),(1,1000,1001030300,1,1,100),(1,1000,1001030310,1,1,100),(1,1000,1001030320,1,1,200),(1,1000,1001030331,1,1,200),(1,1000,1001030332,1,1,300),(1,1000,1001030341,1,1,500),(1,1000,1001030342,1,1,800),(1,1000,1001030343,1,1,2300),(1,1000,1001030353,1,1,99999),(1,1000,1001030363,1,1,99999),(1,1000,1001030400,1,1,100),(1,1000,1001030410,1,1,200),(1,1000,1001030420,1,1,300),(1,1000,1001030431,1,1,300),(1,1000,1001030432,1,1,400),(1,1000,1001030441,1,1,800),(1,1000,1001030442,1,1,1100),(1,1000,1001030443,1,1,3300),(1,1000,1001030453,1,1,99999),(1,1000,1001030463,1,1,99999),(1,1000,1001030500,1,1,100),(1,1000,1001030510,1,1,200),(1,1000,1001030520,1,1,300),(1,1000,1001030531,1,1,400),(1,1000,1001030532,1,1,500),(1,1000,1001030541,1,1,1000),(1,1000,1001030542,1,1,1600),(1,1000,1001030543,1,1,4600),(1,1000,1001030553,1,1,99999),(1,1000,1001030563,1,1,99999),(1,1000,1001030600,1,1,100),(1,1000,1001030610,1,1,200),(1,1000,1001030620,1,1,400),(1,1000,1001030631,1,1,500),(1,1000,1001030632,1,1,600),(1,1000,1001030641,1,1,1200),(1,1000,1001030642,1,1,1800),(1,1000,1001030643,1,1,6600),(1,1000,1001030653,1,1,99999),(1,1000,1001030663,1,1,99999),(1,1000,1001030700,1,1,100),(1,1000,1001030710,1,1,200),(1,1000,1001030720,1,1,400),(1,1000,1001030731,1,1,600),(1,1000,1001030732,1,1,700),(1,1000,1001030741,1,1,1600),(1,1000,1001030742,1,1,2400),(1,1000,1001030743,1,1,9000),(1,1000,1001030753,1,1,99999),(1,1000,1001030763,1,1,99999),(1,1000,1001030800,1,1,100),(1,1000,1001030810,1,1,300),(1,1000,1001030820,1,1,500),(1,1000,1001030831,1,1,600),(1,1000,1001030832,1,1,800),(1,1000,1001030841,1,1,1900),(1,1000,1001030842,1,1,2900),(1,1000,1001030843,1,1,12300),(1,1000,1001030853,1,1,99999),(1,1000,1001030863,1,1,99999),(1,1000,1001030900,1,1,100),(1,1000,1001030910,1,1,300),(1,1000,1001030920,1,1,500),(1,1000,1001030931,1,1,700),(1,1000,1001030932,1,1,900),(1,1000,1001030941,1,1,2200),(1,1000,1001030942,1,1,3500),(1,1000,1001030943,1,1,17300),(1,1000,1001030953,1,1,99999),(1,1000,1001030963,1,1,99999),(1,1000,1001031000,1,1,100),(1,1000,1001031010,1,1,300),(1,1000,1001031020,1,1,600),(1,1000,1001031031,1,1,800),(1,1000,1001031032,1,1,1000),(1,1000,1001031041,1,1,2500),(1,1000,1001031042,1,1,4000),(1,1000,1001031043,1,1,24000),(1,1000,1001031053,1,1,99999),(1,1000,1001031063,1,1,99999),(1,1000,1001031100,1,1,200),(1,1000,1001031110,1,1,400),(1,1000,1001031120,1,1,700),(1,1000,1001031131,1,1,1000),(1,1000,1001031132,1,1,1200),(1,1000,1001031141,1,1,3500),(1,1000,1001031142,1,1,5700),(1,1000,1001031143,1,1,34000),(1,1000,1001031153,1,1,99999),(1,1000,1001031163,1,1,99999),(1,1000,1001031200,1,1,200),(1,1000,1001031210,1,1,500),(1,1000,1001031220,1,1,900),(1,1000,1001031231,1,1,1200),(1,1000,1001031232,1,1,1500),(1,1000,1001031241,1,1,5000),(1,1000,1001031242,1,1,8500),(1,1000,1001031243,1,1,50600),(1,1000,1001031253,1,1,99999),(1,1000,1001031263,1,1,99999),(1,1000,1001031300,1,1,200),(1,1000,1001031310,1,1,500),(1,1000,1001031320,1,1,900),(1,1000,1001031331,1,1,1200),(1,1000,1001031332,1,1,1500),(1,1000,1001031341,1,1,6000),(1,1000,1001031342,1,1,10400),(1,1000,1001031343,1,1,74000),(1,1000,1001031353,1,1,99999),(1,1000,1001031363,1,1,99999),(1,1000,1001031400,1,1,200),(1,1000,1001031410,1,1,500),(1,1000,1001031420,1,1,1000),(1,1000,1001031431,1,1,1400),(1,1000,1001031432,1,1,1700),(1,1000,1001031441,1,1,7000),(1,1000,1001031442,1,1,12400),(1,1000,1001031443,1,1,99999),(1,1000,1001031453,1,1,99999),(1,1000,1001031463,1,1,99999),(1,1000,1001031500,1,1,200),(1,1000,1001031510,1,1,600),(1,1000,1001031520,1,1,1200),(1,1000,1001031531,1,1,1600),(1,1000,1001031532,1,1,2000),(1,1000,1001031541,1,1,7900),(1,1000,1001031542,1,1,13800),(1,1000,1001031543,1,1,99999),(1,1000,1001031553,1,1,99999),(1,1000,1001031563,1,1,99999),(1,1000,1001031600,1,1,300),(1,1000,1001031610,1,1,700),(1,1000,1001031620,1,1,1300),(1,1000,1001031631,1,1,1800),(1,1000,1001031632,1,1,2200),(1,1000,1001031641,1,1,10000),(1,1000,1001031642,1,1,17800),(1,1000,1001031643,1,1,99999),(1,1000,1001031653,1,1,99999),(1,1000,1001031663,1,1,99999),(1,1000,1001040100,1,1,100),(1,1000,1001040110,1,1,100),(1,1000,1001040120,1,1,100),(1,1000,1001040131,1,1,100),(1,1000,1001040132,1,1,100),(1,1000,1001040141,1,1,200),(1,1000,1001040142,1,1,300),(1,1000,1001040143,1,1,900),(1,1000,1001040153,1,1,99999),(1,1000,1001040163,1,1,99999),(1,1000,1001040200,1,1,100),(1,1000,1001040210,1,1,100),(1,1000,1001040220,1,1,100),(1,1000,1001040231,1,1,200),(1,1000,1001040232,1,1,200),(1,1000,1001040241,1,1,400),(1,1000,1001040242,1,1,500),(1,1000,1001040243,1,1,1500),(1,1000,1001040253,1,1,99999),(1,1000,1001040263,1,1,99999),(1,1000,1001040300,1,1,100),(1,1000,1001040310,1,1,100),(1,1000,1001040320,1,1,200),(1,1000,1001040331,1,1,200),(1,1000,1001040332,1,1,300),(1,1000,1001040341,1,1,500),(1,1000,1001040342,1,1,800),(1,1000,1001040343,1,1,2300),(1,1000,1001040353,1,1,99999),(1,1000,1001040363,1,1,99999),(1,1000,1001040400,1,1,100),(1,1000,1001040410,1,1,200),(1,1000,1001040420,1,1,300),(1,1000,1001040431,1,1,300),(1,1000,1001040432,1,1,400),(1,1000,1001040441,1,1,800),(1,1000,1001040442,1,1,1100),(1,1000,1001040443,1,1,3300),(1,1000,1001040453,1,1,99999),(1,1000,1001040463,1,1,99999),(1,1000,1001040500,1,1,100),(1,1000,1001040510,1,1,200),(1,1000,1001040520,1,1,300),(1,1000,1001040531,1,1,400),(1,1000,1001040532,1,1,500),(1,1000,1001040541,1,1,1000),(1,1000,1001040542,1,1,1600),(1,1000,1001040543,1,1,4600),(1,1000,1001040553,1,1,99999),(1,1000,1001040563,1,1,99999),(1,1000,1001040600,1,1,100),(1,1000,1001040610,1,1,200),(1,1000,1001040620,1,1,400),(1,1000,1001040631,1,1,500),(1,1000,1001040632,1,1,600),(1,1000,1001040641,1,1,1200),(1,1000,1001040642,1,1,1800),(1,1000,1001040643,1,1,6600),(1,1000,1001040653,1,1,99999),(1,1000,1001040663,1,1,99999),(1,1000,1001040700,1,1,100),(1,1000,1001040710,1,1,200),(1,1000,1001040720,1,1,400),(1,1000,1001040731,1,1,600),(1,1000,1001040732,1,1,700),(1,1000,1001040741,1,1,1600),(1,1000,1001040742,1,1,2400),(1,1000,1001040743,1,1,9000),(1,1000,1001040753,1,1,99999),(1,1000,1001040763,1,1,99999),(1,1000,1001040800,1,1,100),(1,1000,1001040810,1,1,300),(1,1000,1001040820,1,1,500),(1,1000,1001040831,1,1,600),(1,1000,1001040832,1,1,800),(1,1000,1001040841,1,1,1900),(1,1000,1001040842,1,1,2900),(1,1000,1001040843,1,1,12300),(1,1000,1001040853,1,1,99999),(1,1000,1001040863,1,1,99999),(1,1000,1001040900,1,1,100),(1,1000,1001040910,1,1,300),(1,1000,1001040920,1,1,500),(1,1000,1001040931,1,1,700),(1,1000,1001040932,1,1,900),(1,1000,1001040941,1,1,2200),(1,1000,1001040942,1,1,3500),(1,1000,1001040943,1,1,17300),(1,1000,1001040953,1,1,99999),(1,1000,1001040963,1,1,99999),(1,1000,1001041000,1,1,100),(1,1000,1001041010,1,1,300),(1,1000,1001041020,1,1,600),(1,1000,1001041031,1,1,800),(1,1000,1001041032,1,1,1000),(1,1000,1001041041,1,1,2500),(1,1000,1001041042,1,1,4000),(1,1000,1001041043,1,1,24000),(1,1000,1001041053,1,1,99999),(1,1000,1001041063,1,1,99999),(1,1000,1001041100,1,1,200),(1,1000,1001041110,1,1,400),(1,1000,1001041120,1,1,700),(1,1000,1001041131,1,1,1000),(1,1000,1001041132,1,1,1200),(1,1000,1001041141,1,1,3500),(1,1000,1001041142,1,1,5700),(1,1000,1001041143,1,1,34000),(1,1000,1001041153,1,1,99999),(1,1000,1001041163,1,1,99999),(1,1000,1001041200,1,1,200),(1,1000,1001041210,1,1,500),(1,1000,1001041220,1,1,900),(1,1000,1001041231,1,1,1200),(1,1000,1001041232,1,1,1500),(1,1000,1001041241,1,1,5000),(1,1000,1001041242,1,1,8500),(1,1000,1001041243,1,1,50600),(1,1000,1001041253,1,1,99999),(1,1000,1001041263,1,1,99999),(1,1000,1001041300,1,1,200),(1,1000,1001041310,1,1,500),(1,1000,1001041320,1,1,900),(1,1000,1001041331,1,1,1200),(1,1000,1001041332,1,1,1500),(1,1000,1001041341,1,1,6000),(1,1000,1001041342,1,1,10400),(1,1000,1001041343,1,1,74000),(1,1000,1001041353,1,1,99999),(1,1000,1001041363,1,1,99999),(1,1000,1001041400,1,1,200),(1,1000,1001041410,1,1,500),(1,1000,1001041420,1,1,1000),(1,1000,1001041431,1,1,1400),(1,1000,1001041432,1,1,1700),(1,1000,1001041441,1,1,7000),(1,1000,1001041442,1,1,12400),(1,1000,1001041443,1,1,99999),(1,1000,1001041453,1,1,99999),(1,1000,1001041463,1,1,99999),(1,1000,1001041500,1,1,200),(1,1000,1001041510,1,1,600),(1,1000,1001041520,1,1,1200),(1,1000,1001041531,1,1,1600),(1,1000,1001041532,1,1,2000),(1,1000,1001041541,1,1,7900),(1,1000,1001041542,1,1,13800),(1,1000,1001041543,1,1,99999),(1,1000,1001041553,1,1,99999),(1,1000,1001041563,1,1,99999),(1,1000,1001041600,1,1,300),(1,1000,1001041610,1,1,700),(1,1000,1001041620,1,1,1300),(1,1000,1001041631,1,1,1800),(1,1000,1001041632,1,1,2200),(1,1000,1001041641,1,1,10000),(1,1000,1001041642,1,1,17800),(1,1000,1001041643,1,1,99999),(1,1000,1001041653,1,1,99999),(1,1000,1001041663,1,1,99999),(1,1000,1002010100,1,1,100),(1,1000,1002010110,1,1,100),(1,1000,1002010120,1,1,100),(1,1000,1002010131,1,1,100),(1,1000,1002010132,1,1,100),(1,1000,1002010141,1,1,200),(1,1000,1002010142,1,1,300),(1,1000,1002010143,1,1,700),(1,1000,1002010153,1,1,99999),(1,1000,1002010163,1,1,99999),(1,1000,1002010200,1,1,100),(1,1000,1002010210,1,1,100),(1,1000,1002010220,1,1,100),(1,1000,1002010231,1,1,100),(1,1000,1002010232,1,1,200),(1,1000,1002010241,1,1,300),(1,1000,1002010242,1,1,400),(1,1000,1002010243,1,1,1200),(1,1000,1002010253,1,1,99999),(1,1000,1002010263,1,1,99999),(1,1000,1002010300,1,1,100),(1,1000,1002010310,1,1,100),(1,1000,1002010320,1,1,200),(1,1000,1002010331,1,1,200),(1,1000,1002010332,1,1,300),(1,1000,1002010341,1,1,500),(1,1000,1002010342,1,1,700),(1,1000,1002010343,1,1,1900),(1,1000,1002010353,1,1,99999),(1,1000,1002010363,1,1,99999),(1,1000,1002010400,1,1,100),(1,1000,1002010410,1,1,100),(1,1000,1002010420,1,1,200),(1,1000,1002010431,1,1,300),(1,1000,1002010432,1,1,300),(1,1000,1002010441,1,1,600),(1,1000,1002010442,1,1,900),(1,1000,1002010443,1,1,2700),(1,1000,1002010453,1,1,99999),(1,1000,1002010463,1,1,99999),(1,1000,1002010500,1,1,100),(1,1000,1002010510,1,1,200),(1,1000,1002010520,1,1,300),(1,1000,1002010531,1,1,300),(1,1000,1002010532,1,1,400),(1,1000,1002010541,1,1,900),(1,1000,1002010542,1,1,1300),(1,1000,1002010543,1,1,3800),(1,1000,1002010553,1,1,99999),(1,1000,1002010563,1,1,99999),(1,1000,1002010600,1,1,100),(1,1000,1002010610,1,1,200),(1,1000,1002010620,1,1,300),(1,1000,1002010631,1,1,400),(1,1000,1002010632,1,1,500),(1,1000,1002010641,1,1,1000),(1,1000,1002010642,1,1,1500),(1,1000,1002010643,1,1,5400),(1,1000,1002010653,1,1,99999),(1,1000,1002010663,1,1,99999),(1,1000,1002010700,1,1,100),(1,1000,1002010710,1,1,200),(1,1000,1002010720,1,1,400),(1,1000,1002010731,1,1,500),(1,1000,1002010732,1,1,600),(1,1000,1002010741,1,1,1300),(1,1000,1002010742,1,1,2000),(1,1000,1002010743,1,1,7300),(1,1000,1002010753,1,1,99999),(1,1000,1002010763,1,1,99999),(1,1000,1002010800,1,1,100),(1,1000,1002010810,1,1,200),(1,1000,1002010820,1,1,400),(1,1000,1002010831,1,1,500),(1,1000,1002010832,1,1,700),(1,1000,1002010841,1,1,1500),(1,1000,1002010842,1,1,2400),(1,1000,1002010843,1,1,10100),(1,1000,1002010853,1,1,99999),(1,1000,1002010863,1,1,99999),(1,1000,1002010900,1,1,100),(1,1000,1002010910,1,1,300),(1,1000,1002010920,1,1,500),(1,1000,1002010931,1,1,600),(1,1000,1002010932,1,1,700),(1,1000,1002010941,1,1,1800),(1,1000,1002010942,1,1,2900),(1,1000,1002010943,1,1,14200),(1,1000,1002010953,1,1,99999),(1,1000,1002010963,1,1,99999),(1,1000,1002011000,1,1,100),(1,1000,1002011010,1,1,300),(1,1000,1002011020,1,1,500),(1,1000,1002011031,1,1,700),(1,1000,1002011032,1,1,900),(1,1000,1002011041,1,1,2100),(1,1000,1002011042,1,1,3300),(1,1000,1002011043,1,1,19600),(1,1000,1002011053,1,1,99999),(1,1000,1002011063,1,1,99999),(1,1000,1002011100,1,1,100),(1,1000,1002011110,1,1,300),(1,1000,1002011120,1,1,600),(1,1000,1002011131,1,1,800),(1,1000,1002011132,1,1,1000),(1,1000,1002011141,1,1,2800),(1,1000,1002011142,1,1,4700),(1,1000,1002011143,1,1,27800),(1,1000,1002011153,1,1,99999),(1,1000,1002011163,1,1,99999),(1,1000,1002011200,1,1,200),(1,1000,1002011210,1,1,400),(1,1000,1002011220,1,1,700),(1,1000,1002011231,1,1,1000),(1,1000,1002011232,1,1,1200),(1,1000,1002011241,1,1,4100),(1,1000,1002011242,1,1,6900),(1,1000,1002011243,1,1,41400),(1,1000,1002011253,1,1,99999),(1,1000,1002011263,1,1,99999),(1,1000,1002011300,1,1,200),(1,1000,1002011310,1,1,400),(1,1000,1002011320,1,1,800),(1,1000,1002011331,1,1,1000),(1,1000,1002011332,1,1,1300),(1,1000,1002011341,1,1,4900),(1,1000,1002011342,1,1,8600),(1,1000,1002011343,1,1,60500),(1,1000,1002011353,1,1,99999),(1,1000,1002011363,1,1,99999),(1,1000,1002011400,1,1,200),(1,1000,1002011410,1,1,500),(1,1000,1002011420,1,1,900),(1,1000,1002011431,1,1,1100),(1,1000,1002011432,1,1,1400),(1,1000,1002011441,1,1,5800),(1,1000,1002011442,1,1,10100),(1,1000,1002011443,1,1,85100),(1,1000,1002011453,1,1,99999),(1,1000,1002011463,1,1,99999),(1,1000,1002011500,1,1,200),(1,1000,1002011510,1,1,500),(1,1000,1002011520,1,1,1000),(1,1000,1002011531,1,1,1400),(1,1000,1002011532,1,1,1700),(1,1000,1002011541,1,1,6500),(1,1000,1002011542,1,1,11300),(1,1000,1002011543,1,1,99999),(1,1000,1002011553,1,1,99999),(1,1000,1002011563,1,1,99999),(1,1000,1002011600,1,1,200),(1,1000,1002011610,1,1,600),(1,1000,1002011620,1,1,1100),(1,1000,1002011631,1,1,1500),(1,1000,1002011632,1,1,1800),(1,1000,1002011641,1,1,8200),(1,1000,1002011642,1,1,14600),(1,1000,1002011643,1,1,99999),(1,1000,1002011653,1,1,99999),(1,1000,1002011663,1,1,99999),(1,1000,1002020100,1,1,100),(1,1000,1002020110,1,1,100),(1,1000,1002020120,1,1,100),(1,1000,1002020131,1,1,100),(1,1000,1002020132,1,1,100),(1,1000,1002020141,1,1,200),(1,1000,1002020142,1,1,300),(1,1000,1002020143,1,1,700),(1,1000,1002020153,1,1,99999),(1,1000,1002020163,1,1,99999),(1,1000,1002020200,1,1,100),(1,1000,1002020210,1,1,100),(1,1000,1002020220,1,1,100),(1,1000,1002020231,1,1,100),(1,1000,1002020232,1,1,200),(1,1000,1002020241,1,1,300),(1,1000,1002020242,1,1,400),(1,1000,1002020243,1,1,1200),(1,1000,1002020253,1,1,99999),(1,1000,1002020263,1,1,99999),(1,1000,1002020300,1,1,100),(1,1000,1002020310,1,1,100),(1,1000,1002020320,1,1,200),(1,1000,1002020331,1,1,200),(1,1000,1002020332,1,1,300),(1,1000,1002020341,1,1,500),(1,1000,1002020342,1,1,700),(1,1000,1002020343,1,1,1900),(1,1000,1002020353,1,1,99999),(1,1000,1002020363,1,1,99999),(1,1000,1002020400,1,1,100),(1,1000,1002020410,1,1,100),(1,1000,1002020420,1,1,200),(1,1000,1002020431,1,1,300),(1,1000,1002020432,1,1,300),(1,1000,1002020441,1,1,600),(1,1000,1002020442,1,1,900),(1,1000,1002020443,1,1,2700),(1,1000,1002020453,1,1,99999),(1,1000,1002020463,1,1,99999),(1,1000,1002020500,1,1,100),(1,1000,1002020510,1,1,200),(1,1000,1002020520,1,1,300),(1,1000,1002020531,1,1,300),(1,1000,1002020532,1,1,400),(1,1000,1002020541,1,1,900),(1,1000,1002020542,1,1,1300),(1,1000,1002020543,1,1,3800),(1,1000,1002020553,1,1,99999),(1,1000,1002020563,1,1,99999),(1,1000,1002020600,1,1,100),(1,1000,1002020610,1,1,200),(1,1000,1002020620,1,1,300),(1,1000,1002020631,1,1,400),(1,1000,1002020632,1,1,500),(1,1000,1002020641,1,1,1000),(1,1000,1002020642,1,1,1500),(1,1000,1002020643,1,1,5400),(1,1000,1002020653,1,1,99999),(1,1000,1002020663,1,1,99999),(1,1000,1002020700,1,1,100),(1,1000,1002020710,1,1,200),(1,1000,1002020720,1,1,400),(1,1000,1002020731,1,1,500),(1,1000,1002020732,1,1,600),(1,1000,1002020741,1,1,1300),(1,1000,1002020742,1,1,2000),(1,1000,1002020743,1,1,7300),(1,1000,1002020753,1,1,99999),(1,1000,1002020763,1,1,99999),(1,1000,1002020800,1,1,100),(1,1000,1002020810,1,1,200),(1,1000,1002020820,1,1,400),(1,1000,1002020831,1,1,500),(1,1000,1002020832,1,1,700),(1,1000,1002020841,1,1,1500),(1,1000,1002020842,1,1,2400),(1,1000,1002020843,1,1,10100),(1,1000,1002020853,1,1,99999),(1,1000,1002020863,1,1,99999),(1,1000,1002020900,1,1,100),(1,1000,1002020910,1,1,300),(1,1000,1002020920,1,1,500),(1,1000,1002020931,1,1,600),(1,1000,1002020932,1,1,700),(1,1000,1002020941,1,1,1800),(1,1000,1002020942,1,1,2900),(1,1000,1002020943,1,1,14200),(1,1000,1002020953,1,1,99999),(1,1000,1002020963,1,1,99999),(1,1000,1002021000,1,1,100),(1,1000,1002021010,1,1,300),(1,1000,1002021020,1,1,500),(1,1000,1002021031,1,1,700),(1,1000,1002021032,1,1,900),(1,1000,1002021041,1,1,2100),(1,1000,1002021042,1,1,3300),(1,1000,1002021043,1,1,19600),(1,1000,1002021053,1,1,99999),(1,1000,1002021063,1,1,99999),(1,1000,1002021100,1,1,100),(1,1000,1002021110,1,1,300),(1,1000,1002021120,1,1,600),(1,1000,1002021131,1,1,800),(1,1000,1002021132,1,1,1000),(1,1000,1002021141,1,1,2800),(1,1000,1002021142,1,1,4700),(1,1000,1002021143,1,1,27800),(1,1000,1002021153,1,1,99999),(1,1000,1002021163,1,1,99999),(1,1000,1002021200,1,1,200),(1,1000,1002021210,1,1,400),(1,1000,1002021220,1,1,700),(1,1000,1002021231,1,1,1000),(1,1000,1002021232,1,1,1200),(1,1000,1002021241,1,1,4100),(1,1000,1002021242,1,1,6900),(1,1000,1002021243,1,1,41400),(1,1000,1002021253,1,1,99999),(1,1000,1002021263,1,1,99999),(1,1000,1002021300,1,1,200),(1,1000,1002021310,1,1,400),(1,1000,1002021320,1,1,800),(1,1000,1002021331,1,1,1000),(1,1000,1002021332,1,1,1300),(1,1000,1002021341,1,1,4900),(1,1000,1002021342,1,1,8600),(1,1000,1002021343,1,1,60500),(1,1000,1002021353,1,1,99999),(1,1000,1002021363,1,1,99999),(1,1000,1002021400,1,1,200),(1,1000,1002021410,1,1,500),(1,1000,1002021420,1,1,900),(1,1000,1002021431,1,1,1100),(1,1000,1002021432,1,1,1400),(1,1000,1002021441,1,1,5800),(1,1000,1002021442,1,1,10100),(1,1000,1002021443,1,1,85100),(1,1000,1002021453,1,1,99999),(1,1000,1002021463,1,1,99999),(1,1000,1002021500,1,1,200),(1,1000,1002021510,1,1,500),(1,1000,1002021520,1,1,1000),(1,1000,1002021531,1,1,1400),(1,1000,1002021532,1,1,1700),(1,1000,1002021541,1,1,6500),(1,1000,1002021542,1,1,11300),(1,1000,1002021543,1,1,99999),(1,1000,1002021553,1,1,99999),(1,1000,1002021563,1,1,99999),(1,1000,1002021600,1,1,200),(1,1000,1002021610,1,1,600),(1,1000,1002021620,1,1,1100),(1,1000,1002021631,1,1,1500),(1,1000,1002021632,1,1,1800),(1,1000,1002021641,1,1,8200),(1,1000,1002021642,1,1,14600),(1,1000,1002021643,1,1,99999),(1,1000,1002021653,1,1,99999),(1,1000,1002021663,1,1,99999),(1,1000,1002030100,1,1,100),(1,1000,1002030110,1,1,100),(1,1000,1002030120,1,1,100),(1,1000,1002030131,1,1,100),(1,1000,1002030132,1,1,100),(1,1000,1002030141,1,1,200),(1,1000,1002030142,1,1,300),(1,1000,1002030143,1,1,700),(1,1000,1002030153,1,1,99999),(1,1000,1002030163,1,1,99999),(1,1000,1002030200,1,1,100),(1,1000,1002030210,1,1,100),(1,1000,1002030220,1,1,100),(1,1000,1002030231,1,1,100),(1,1000,1002030232,1,1,200),(1,1000,1002030241,1,1,300),(1,1000,1002030242,1,1,400),(1,1000,1002030243,1,1,1200),(1,1000,1002030253,1,1,99999),(1,1000,1002030263,1,1,99999),(1,1000,1002030300,1,1,100),(1,1000,1002030310,1,1,100),(1,1000,1002030320,1,1,200),(1,1000,1002030331,1,1,200),(1,1000,1002030332,1,1,300),(1,1000,1002030341,1,1,500),(1,1000,1002030342,1,1,700),(1,1000,1002030343,1,1,1900),(1,1000,1002030353,1,1,99999),(1,1000,1002030363,1,1,99999),(1,1000,1002030400,1,1,100),(1,1000,1002030410,1,1,100),(1,1000,1002030420,1,1,200),(1,1000,1002030431,1,1,300),(1,1000,1002030432,1,1,300),(1,1000,1002030441,1,1,600),(1,1000,1002030442,1,1,900),(1,1000,1002030443,1,1,2700),(1,1000,1002030453,1,1,99999),(1,1000,1002030463,1,1,99999),(1,1000,1002030500,1,1,100),(1,1000,1002030510,1,1,200),(1,1000,1002030520,1,1,300),(1,1000,1002030531,1,1,300),(1,1000,1002030532,1,1,400),(1,1000,1002030541,1,1,900),(1,1000,1002030542,1,1,1300),(1,1000,1002030543,1,1,3800),(1,1000,1002030553,1,1,99999),(1,1000,1002030563,1,1,99999),(1,1000,1002030600,1,1,100),(1,1000,1002030610,1,1,200),(1,1000,1002030620,1,1,300),(1,1000,1002030631,1,1,400),(1,1000,1002030632,1,1,500),(1,1000,1002030641,1,1,1000),(1,1000,1002030642,1,1,1500),(1,1000,1002030643,1,1,5400),(1,1000,1002030653,1,1,99999),(1,1000,1002030663,1,1,99999),(1,1000,1002030700,1,1,100),(1,1000,1002030710,1,1,200),(1,1000,1002030720,1,1,400),(1,1000,1002030731,1,1,500),(1,1000,1002030732,1,1,600),(1,1000,1002030741,1,1,1300),(1,1000,1002030742,1,1,2000),(1,1000,1002030743,1,1,7300),(1,1000,1002030753,1,1,99999),(1,1000,1002030763,1,1,99999),(1,1000,1002030800,1,1,100),(1,1000,1002030810,1,1,200),(1,1000,1002030820,1,1,400),(1,1000,1002030831,1,1,500),(1,1000,1002030832,1,1,700),(1,1000,1002030841,1,1,1500),(1,1000,1002030842,1,1,2400),(1,1000,1002030843,1,1,10100),(1,1000,1002030853,1,1,99999),(1,1000,1002030863,1,1,99999),(1,1000,1002030900,1,1,100),(1,1000,1002030910,1,1,300),(1,1000,1002030920,1,1,500),(1,1000,1002030931,1,1,600),(1,1000,1002030932,1,1,700),(1,1000,1002030941,1,1,1800),(1,1000,1002030942,1,1,2900),(1,1000,1002030943,1,1,14200),(1,1000,1002030953,1,1,99999),(1,1000,1002030963,1,1,99999),(1,1000,1002031000,1,1,100),(1,1000,1002031010,1,1,300),(1,1000,1002031020,1,1,500),(1,1000,1002031031,1,1,700),(1,1000,1002031032,1,1,900),(1,1000,1002031041,1,1,2100),(1,1000,1002031042,1,1,3300),(1,1000,1002031043,1,1,19600),(1,1000,1002031053,1,1,99999),(1,1000,1002031063,1,1,99999),(1,1000,1002031100,1,1,100),(1,1000,1002031110,1,1,300),(1,1000,1002031120,1,1,600),(1,1000,1002031131,1,1,800),(1,1000,1002031132,1,1,1000),(1,1000,1002031141,1,1,2800),(1,1000,1002031142,1,1,4700),(1,1000,1002031143,1,1,27800),(1,1000,1002031153,1,1,99999),(1,1000,1002031163,1,1,99999),(1,1000,1002031200,1,1,200),(1,1000,1002031210,1,1,400),(1,1000,1002031220,1,1,700),(1,1000,1002031231,1,1,1000),(1,1000,1002031232,1,1,1200),(1,1000,1002031241,1,1,4100),(1,1000,1002031242,1,1,6900),(1,1000,1002031243,1,1,41400),(1,1000,1002031253,1,1,99999),(1,1000,1002031263,1,1,99999),(1,1000,1002031300,1,1,200),(1,1000,1002031310,1,1,400),(1,1000,1002031320,1,1,800),(1,1000,1002031331,1,1,1000),(1,1000,1002031332,1,1,1300),(1,1000,1002031341,1,1,4900),(1,1000,1002031342,1,1,8600),(1,1000,1002031343,1,1,60500),(1,1000,1002031353,1,1,99999),(1,1000,1002031363,1,1,99999),(1,1000,1002031400,1,1,200),(1,1000,1002031410,1,1,500),(1,1000,1002031420,1,1,900),(1,1000,1002031431,1,1,1100),(1,1000,1002031432,1,1,1400),(1,1000,1002031441,1,1,5800),(1,1000,1002031442,1,1,10100),(1,1000,1002031443,1,1,85100),(1,1000,1002031453,1,1,99999),(1,1000,1002031463,1,1,99999),(1,1000,1002031500,1,1,200),(1,1000,1002031510,1,1,500),(1,1000,1002031520,1,1,1000),(1,1000,1002031531,1,1,1400),(1,1000,1002031532,1,1,1700),(1,1000,1002031541,1,1,6500),(1,1000,1002031542,1,1,11300),(1,1000,1002031543,1,1,99999),(1,1000,1002031553,1,1,99999),(1,1000,1002031563,1,1,99999),(1,1000,1002031600,1,1,200),(1,1000,1002031610,1,1,600),(1,1000,1002031620,1,1,1100),(1,1000,1002031631,1,1,1500),(1,1000,1002031632,1,1,1800),(1,1000,1002031641,1,1,8200),(1,1000,1002031642,1,1,14600),(1,1000,1002031643,1,1,99999),(1,1000,1002031653,1,1,99999),(1,1000,1002031663,1,1,99999),(1,1000,1002040100,1,1,100),(1,1000,1002040110,1,1,100),(1,1000,1002040120,1,1,100),(1,1000,1002040131,1,1,100),(1,1000,1002040132,1,1,100),(1,1000,1002040141,1,1,200),(1,1000,1002040142,1,1,300),(1,1000,1002040143,1,1,700),(1,1000,1002040153,1,1,99999),(1,1000,1002040163,1,1,99999),(1,1000,1002040200,1,1,100),(1,1000,1002040210,1,1,100),(1,1000,1002040220,1,1,100),(1,1000,1002040231,1,1,100),(1,1000,1002040232,1,1,200),(1,1000,1002040241,1,1,300),(1,1000,1002040242,1,1,400),(1,1000,1002040243,1,1,1200),(1,1000,1002040253,1,1,99999),(1,1000,1002040263,1,1,99999),(1,1000,1002040300,1,1,100),(1,1000,1002040310,1,1,100),(1,1000,1002040320,1,1,200),(1,1000,1002040331,1,1,200),(1,1000,1002040332,1,1,300),(1,1000,1002040341,1,1,500),(1,1000,1002040342,1,1,700),(1,1000,1002040343,1,1,1900),(1,1000,1002040353,1,1,99999),(1,1000,1002040363,1,1,99999),(1,1000,1002040400,1,1,100),(1,1000,1002040410,1,1,100),(1,1000,1002040420,1,1,200),(1,1000,1002040431,1,1,300),(1,1000,1002040432,1,1,300),(1,1000,1002040441,1,1,600),(1,1000,1002040442,1,1,900),(1,1000,1002040443,1,1,2700),(1,1000,1002040453,1,1,99999),(1,1000,1002040463,1,1,99999),(1,1000,1002040500,1,1,100),(1,1000,1002040510,1,1,200),(1,1000,1002040520,1,1,300),(1,1000,1002040531,1,1,300),(1,1000,1002040532,1,1,400),(1,1000,1002040541,1,1,900),(1,1000,1002040542,1,1,1300),(1,1000,1002040543,1,1,3800),(1,1000,1002040553,1,1,99999),(1,1000,1002040563,1,1,99999),(1,1000,1002040600,1,1,100),(1,1000,1002040610,1,1,200),(1,1000,1002040620,1,1,300),(1,1000,1002040631,1,1,400),(1,1000,1002040632,1,1,500),(1,1000,1002040641,1,1,1000),(1,1000,1002040642,1,1,1500),(1,1000,1002040643,1,1,5400),(1,1000,1002040653,1,1,99999),(1,1000,1002040663,1,1,99999),(1,1000,1002040700,1,1,100),(1,1000,1002040710,1,1,200),(1,1000,1002040720,1,1,400),(1,1000,1002040731,1,1,500),(1,1000,1002040732,1,1,600),(1,1000,1002040741,1,1,1300),(1,1000,1002040742,1,1,2000),(1,1000,1002040743,1,1,7300),(1,1000,1002040753,1,1,99999),(1,1000,1002040763,1,1,99999),(1,1000,1002040800,1,1,100),(1,1000,1002040810,1,1,200),(1,1000,1002040820,1,1,400),(1,1000,1002040831,1,1,500),(1,1000,1002040832,1,1,700),(1,1000,1002040841,1,1,1500),(1,1000,1002040842,1,1,2400),(1,1000,1002040843,1,1,10100),(1,1000,1002040853,1,1,99999),(1,1000,1002040863,1,1,99999),(1,1000,1002040900,1,1,100),(1,1000,1002040910,1,1,300),(1,1000,1002040920,1,1,500),(1,1000,1002040931,1,1,600),(1,1000,1002040932,1,1,700),(1,1000,1002040941,1,1,1800),(1,1000,1002040942,1,1,2900),(1,1000,1002040943,1,1,14200),(1,1000,1002040953,1,1,99999),(1,1000,1002040963,1,1,99999),(1,1000,1002041000,1,1,100),(1,1000,1002041010,1,1,300),(1,1000,1002041020,1,1,500),(1,1000,1002041031,1,1,700),(1,1000,1002041032,1,1,900),(1,1000,1002041041,1,1,2100),(1,1000,1002041042,1,1,3300),(1,1000,1002041043,1,1,19600),(1,1000,1002041053,1,1,99999),(1,1000,1002041063,1,1,99999),(1,1000,1002041100,1,1,100),(1,1000,1002041110,1,1,300),(1,1000,1002041120,1,1,600),(1,1000,1002041131,1,1,800),(1,1000,1002041132,1,1,1000),(1,1000,1002041141,1,1,2800),(1,1000,1002041142,1,1,4700),(1,1000,1002041143,1,1,27800),(1,1000,1002041153,1,1,99999),(1,1000,1002041163,1,1,99999),(1,1000,1002041200,1,1,200),(1,1000,1002041210,1,1,400),(1,1000,1002041220,1,1,700),(1,1000,1002041231,1,1,1000),(1,1000,1002041232,1,1,1200),(1,1000,1002041241,1,1,4100),(1,1000,1002041242,1,1,6900),(1,1000,1002041243,1,1,41400),(1,1000,1002041253,1,1,99999),(1,1000,1002041263,1,1,99999),(1,1000,1002041300,1,1,200),(1,1000,1002041310,1,1,400),(1,1000,1002041320,1,1,800),(1,1000,1002041331,1,1,1000),(1,1000,1002041332,1,1,1300),(1,1000,1002041341,1,1,4900),(1,1000,1002041342,1,1,8600),(1,1000,1002041343,1,1,60500),(1,1000,1002041353,1,1,99999),(1,1000,1002041363,1,1,99999),(1,1000,1002041400,1,1,200),(1,1000,1002041410,1,1,500),(1,1000,1002041420,1,1,900),(1,1000,1002041431,1,1,1100),(1,1000,1002041432,1,1,1400),(1,1000,1002041441,1,1,5800),(1,1000,1002041442,1,1,10100),(1,1000,1002041443,1,1,85100),(1,1000,1002041453,1,1,99999),(1,1000,1002041463,1,1,99999),(1,1000,1002041500,1,1,200),(1,1000,1002041510,1,1,500),(1,1000,1002041520,1,1,1000),(1,1000,1002041531,1,1,1400),(1,1000,1002041532,1,1,1700),(1,1000,1002041541,1,1,6500),(1,1000,1002041542,1,1,11300),(1,1000,1002041543,1,1,99999),(1,1000,1002041553,1,1,99999),(1,1000,1002041563,1,1,99999),(1,1000,1002041600,1,1,200),(1,1000,1002041610,1,1,600),(1,1000,1002041620,1,1,1100),(1,1000,1002041631,1,1,1500),(1,1000,1002041632,1,1,1800),(1,1000,1002041641,1,1,8200),(1,1000,1002041642,1,1,14600),(1,1000,1002041643,1,1,99999),(1,1000,1002041653,1,1,99999),(1,1000,1002041663,1,1,99999),(1,1000,1003000100,1,1,100),(1,1000,1003000110,1,1,100),(1,1000,1003000120,1,1,100),(1,1000,1003000131,1,1,100),(1,1000,1003000132,1,1,100),(1,1000,1003000141,1,1,200),(1,1000,1003000142,1,1,200),(1,1000,1003000143,1,1,600),(1,1000,1003000153,1,1,99999),(1,1000,1003000163,1,1,99999),(1,1000,1003000200,1,1,100),(1,1000,1003000210,1,1,100),(1,1000,1003000220,1,1,100),(1,1000,1003000231,1,1,100),(1,1000,1003000232,1,1,100),(1,1000,1003000241,1,1,300),(1,1000,1003000242,1,1,400),(1,1000,1003000243,1,1,1000),(1,1000,1003000253,1,1,99999),(1,1000,1003000263,1,1,99999),(1,1000,1003000300,1,1,100),(1,1000,1003000310,1,1,100),(1,1000,1003000320,1,1,100),(1,1000,1003000331,1,1,200),(1,1000,1003000332,1,1,200),(1,1000,1003000341,1,1,400),(1,1000,1003000342,1,1,500),(1,1000,1003000343,1,1,1500),(1,1000,1003000353,1,1,99999),(1,1000,1003000363,1,1,99999),(1,1000,1003000400,1,1,100),(1,1000,1003000410,1,1,100),(1,1000,1003000420,1,1,200),(1,1000,1003000431,1,1,200),(1,1000,1003000432,1,1,300),(1,1000,1003000441,1,1,500),(1,1000,1003000442,1,1,800),(1,1000,1003000443,1,1,2200),(1,1000,1003000453,1,1,99999),(1,1000,1003000463,1,1,99999),(1,1000,1003000500,1,1,100),(1,1000,1003000510,1,1,100),(1,1000,1003000520,1,1,200),(1,1000,1003000531,1,1,300),(1,1000,1003000532,1,1,400),(1,1000,1003000541,1,1,700),(1,1000,1003000542,1,1,1100),(1,1000,1003000543,1,1,3100),(1,1000,1003000553,1,1,99999),(1,1000,1003000563,1,1,99999),(1,1000,1003000600,1,1,100),(1,1000,1003000610,1,1,200),(1,1000,1003000620,1,1,300),(1,1000,1003000631,1,1,400),(1,1000,1003000632,1,1,400),(1,1000,1003000641,1,1,800),(1,1000,1003000642,1,1,1200),(1,1000,1003000643,1,1,4400),(1,1000,1003000653,1,1,99999),(1,1000,1003000663,1,1,99999),(1,1000,1003000700,1,1,100),(1,1000,1003000710,1,1,200),(1,1000,1003000720,1,1,300),(1,1000,1003000731,1,1,400),(1,1000,1003000732,1,1,500),(1,1000,1003000741,1,1,1100),(1,1000,1003000742,1,1,1600),(1,1000,1003000743,1,1,6000),(1,1000,1003000753,1,1,99999),(1,1000,1003000763,1,1,99999),(1,1000,1003000800,1,1,100),(1,1000,1003000810,1,1,200),(1,1000,1003000820,1,1,300),(1,1000,1003000831,1,1,400),(1,1000,1003000832,1,1,500),(1,1000,1003000841,1,1,1300),(1,1000,1003000842,1,1,2000),(1,1000,1003000843,1,1,8200),(1,1000,1003000853,1,1,99999),(1,1000,1003000863,1,1,99999),(1,1000,1003000900,1,1,100),(1,1000,1003000910,1,1,200),(1,1000,1003000920,1,1,400),(1,1000,1003000931,1,1,500),(1,1000,1003000932,1,1,600),(1,1000,1003000941,1,1,1500),(1,1000,1003000942,1,1,2300),(1,1000,1003000943,1,1,11500),(1,1000,1003000953,1,1,99999),(1,1000,1003000963,1,1,99999),(1,1000,1003001000,1,1,100),(1,1000,1003001010,1,1,200),(1,1000,1003001020,1,1,400),(1,1000,1003001031,1,1,600),(1,1000,1003001032,1,1,700),(1,1000,1003001041,1,1,1700),(1,1000,1003001042,1,1,2700),(1,1000,1003001043,1,1,16000),(1,1000,1003001053,1,1,99999),(1,1000,1003001063,1,1,99999),(1,1000,1003001100,1,1,100),(1,1000,1003001110,1,1,300),(1,1000,1003001120,1,1,500),(1,1000,1003001131,1,1,700),(1,1000,1003001132,1,1,800),(1,1000,1003001141,1,1,2300),(1,1000,1003001142,1,1,3800),(1,1000,1003001143,1,1,22700),(1,1000,1003001153,1,1,99999),(1,1000,1003001163,1,1,99999),(1,1000,1003001200,1,1,100),(1,1000,1003001210,1,1,300),(1,1000,1003001220,1,1,600),(1,1000,1003001231,1,1,800),(1,1000,1003001232,1,1,1000),(1,1000,1003001241,1,1,3300),(1,1000,1003001242,1,1,5700),(1,1000,1003001243,1,1,33800),(1,1000,1003001253,1,1,99999),(1,1000,1003001263,1,1,99999),(1,1000,1003001300,1,1,100),(1,1000,1003001310,1,1,300),(1,1000,1003001320,1,1,600),(1,1000,1003001331,1,1,800),(1,1000,1003001332,1,1,1000),(1,1000,1003001341,1,1,4000),(1,1000,1003001342,1,1,7000),(1,1000,1003001343,1,1,49300),(1,1000,1003001353,1,1,99999),(1,1000,1003001363,1,1,99999),(1,1000,1003001400,1,1,200),(1,1000,1003001410,1,1,400),(1,1000,1003001420,1,1,700),(1,1000,1003001431,1,1,900),(1,1000,1003001432,1,1,1200),(1,1000,1003001441,1,1,4700),(1,1000,1003001442,1,1,8300),(1,1000,1003001443,1,1,69300),(1,1000,1003001453,1,1,99999),(1,1000,1003001463,1,1,99999),(1,1000,1003001500,1,1,200),(1,1000,1003001510,1,1,400),(1,1000,1003001520,1,1,800),(1,1000,1003001531,1,1,1100),(1,1000,1003001532,1,1,1400),(1,1000,1003001541,1,1,5300),(1,1000,1003001542,1,1,9200),(1,1000,1003001543,1,1,91500),(1,1000,1003001553,1,1,99999),(1,1000,1003001563,1,1,99999),(1,1000,1003001600,1,1,200),(1,1000,1003001610,1,1,500),(1,1000,1003001620,1,1,900),(1,1000,1003001631,1,1,1200),(1,1000,1003001632,1,1,1500),(1,1000,1003001641,1,1,6700),(1,1000,1003001642,1,1,11900),(1,1000,1003001643,1,1,99999),(1,1000,1003001653,1,1,99999),(1,1000,1003001663,1,1,99999),(1,1000,1004010100,1,1,100),(1,1000,1004010110,1,1,100),(1,1000,1004010120,1,1,100),(1,1000,1004010131,1,1,100),(1,1000,1004010132,1,1,100),(1,1000,1004010141,1,1,200),(1,1000,1004010142,1,1,200),(1,1000,1004010143,1,1,500),(1,1000,1004010153,1,1,99999),(1,1000,1004010163,1,1,99999),(1,1000,1004010200,1,1,100),(1,1000,1004010210,1,1,100),(1,1000,1004010220,1,1,100),(1,1000,1004010231,1,1,100),(1,1000,1004010232,1,1,100),(1,1000,1004010241,1,1,200),(1,1000,1004010242,1,1,300),(1,1000,1004010243,1,1,800),(1,1000,1004010253,1,1,99999),(1,1000,1004010263,1,1,99999),(1,1000,1004010300,1,1,100),(1,1000,1004010310,1,1,100),(1,1000,1004010320,1,1,100),(1,1000,1004010331,1,1,200),(1,1000,1004010332,1,1,200),(1,1000,1004010341,1,1,300),(1,1000,1004010342,1,1,500),(1,1000,1004010343,1,1,1300),(1,1000,1004010353,1,1,99999),(1,1000,1004010363,1,1,99999),(1,1000,1004010400,1,1,100),(1,1000,1004010410,1,1,100),(1,1000,1004010420,1,1,200),(1,1000,1004010431,1,1,200),(1,1000,1004010432,1,1,200),(1,1000,1004010441,1,1,400),(1,1000,1004010442,1,1,600),(1,1000,1004010443,1,1,1800),(1,1000,1004010453,1,1,99999),(1,1000,1004010463,1,1,99999),(1,1000,1004010500,1,1,100),(1,1000,1004010510,1,1,100),(1,1000,1004010520,1,1,200),(1,1000,1004010531,1,1,200),(1,1000,1004010532,1,1,300),(1,1000,1004010541,1,1,600),(1,1000,1004010542,1,1,900),(1,1000,1004010543,1,1,2500),(1,1000,1004010553,1,1,99999),(1,1000,1004010563,1,1,99999),(1,1000,1004010600,1,1,100),(1,1000,1004010610,1,1,100),(1,1000,1004010620,1,1,200),(1,1000,1004010631,1,1,300),(1,1000,1004010632,1,1,400),(1,1000,1004010641,1,1,700),(1,1000,1004010642,1,1,1000),(1,1000,1004010643,1,1,3600),(1,1000,1004010653,1,1,99999),(1,1000,1004010663,1,1,99999),(1,1000,1004010700,1,1,100),(1,1000,1004010710,1,1,200),(1,1000,1004010720,1,1,300),(1,1000,1004010731,1,1,300),(1,1000,1004010732,1,1,400),(1,1000,1004010741,1,1,900),(1,1000,1004010742,1,1,1300),(1,1000,1004010743,1,1,4900),(1,1000,1004010753,1,1,99999),(1,1000,1004010763,1,1,99999),(1,1000,1004010800,1,1,100),(1,1000,1004010810,1,1,200),(1,1000,1004010820,1,1,300),(1,1000,1004010831,1,1,400),(1,1000,1004010832,1,1,500),(1,1000,1004010841,1,1,1000),(1,1000,1004010842,1,1,1600),(1,1000,1004010843,1,1,6700),(1,1000,1004010853,1,1,99999),(1,1000,1004010863,1,1,99999),(1,1000,1004010900,1,1,100),(1,1000,1004010910,1,1,200),(1,1000,1004010920,1,1,300),(1,1000,1004010931,1,1,400),(1,1000,1004010932,1,1,500),(1,1000,1004010941,1,1,1200),(1,1000,1004010942,1,1,1900),(1,1000,1004010943,1,1,9500),(1,1000,1004010953,1,1,99999),(1,1000,1004010963,1,1,99999),(1,1000,1004011000,1,1,100),(1,1000,1004011010,1,1,200),(1,1000,1004011020,1,1,400),(1,1000,1004011031,1,1,500),(1,1000,1004011032,1,1,600),(1,1000,1004011041,1,1,1400),(1,1000,1004011042,1,1,2200),(1,1000,1004011043,1,1,13100),(1,1000,1004011053,1,1,99999),(1,1000,1004011063,1,1,99999),(1,1000,1004011100,1,1,100),(1,1000,1004011110,1,1,200),(1,1000,1004011120,1,1,400),(1,1000,1004011131,1,1,600),(1,1000,1004011132,1,1,700),(1,1000,1004011141,1,1,1900),(1,1000,1004011142,1,1,3100),(1,1000,1004011143,1,1,18500),(1,1000,1004011153,1,1,99999),(1,1000,1004011163,1,1,99999),(1,1000,1004011200,1,1,100),(1,1000,1004011210,1,1,300),(1,1000,1004011220,1,1,500),(1,1000,1004011231,1,1,700),(1,1000,1004011232,1,1,800),(1,1000,1004011241,1,1,2700),(1,1000,1004011242,1,1,4600),(1,1000,1004011243,1,1,27600),(1,1000,1004011253,1,1,99999),(1,1000,1004011263,1,1,99999),(1,1000,1004011300,1,1,100),(1,1000,1004011310,1,1,300),(1,1000,1004011320,1,1,500),(1,1000,1004011331,1,1,700),(1,1000,1004011332,1,1,900),(1,1000,1004011341,1,1,3300),(1,1000,1004011342,1,1,5700),(1,1000,1004011343,1,1,40400),(1,1000,1004011353,1,1,99999),(1,1000,1004011363,1,1,99999),(1,1000,1004011400,1,1,100),(1,1000,1004011410,1,1,300),(1,1000,1004011420,1,1,600),(1,1000,1004011431,1,1,800),(1,1000,1004011432,1,1,1000),(1,1000,1004011441,1,1,3900),(1,1000,1004011442,1,1,6800),(1,1000,1004011443,1,1,56700),(1,1000,1004011453,1,1,99999),(1,1000,1004011463,1,1,99999),(1,1000,1004011500,1,1,200),(1,1000,1004011510,1,1,400),(1,1000,1004011520,1,1,700),(1,1000,1004011531,1,1,900),(1,1000,1004011532,1,1,1100),(1,1000,1004011541,1,1,4300),(1,1000,1004011542,1,1,7500),(1,1000,1004011543,1,1,74900),(1,1000,1004011553,1,1,99999),(1,1000,1004011563,1,1,99999),(1,1000,1004011600,1,1,200),(1,1000,1004011610,1,1,400),(1,1000,1004011620,1,1,800),(1,1000,1004011631,1,1,1000),(1,1000,1004011632,1,1,1200),(1,1000,1004011641,1,1,5500),(1,1000,1004011642,1,1,9700),(1,1000,1004011643,1,1,96700),(1,1000,1004011653,1,1,99999),(1,1000,1004011663,1,1,99999),(1,1000,1004020100,1,1,100),(1,1000,1004020110,1,1,100),(1,1000,1004020120,1,1,100),(1,1000,1004020131,1,1,100),(1,1000,1004020132,1,1,100),(1,1000,1004020141,1,1,200),(1,1000,1004020142,1,1,200),(1,1000,1004020143,1,1,500),(1,1000,1004020153,1,1,99999),(1,1000,1004020163,1,1,99999),(1,1000,1004020200,1,1,100),(1,1000,1004020210,1,1,100),(1,1000,1004020220,1,1,100),(1,1000,1004020231,1,1,100),(1,1000,1004020232,1,1,100),(1,1000,1004020241,1,1,200),(1,1000,1004020242,1,1,300),(1,1000,1004020243,1,1,800),(1,1000,1004020253,1,1,99999),(1,1000,1004020263,1,1,99999),(1,1000,1004020300,1,1,100),(1,1000,1004020310,1,1,100),(1,1000,1004020320,1,1,100),(1,1000,1004020331,1,1,200),(1,1000,1004020332,1,1,200),(1,1000,1004020341,1,1,300),(1,1000,1004020342,1,1,500),(1,1000,1004020343,1,1,1300),(1,1000,1004020353,1,1,99999),(1,1000,1004020363,1,1,99999),(1,1000,1004020400,1,1,100),(1,1000,1004020410,1,1,100),(1,1000,1004020420,1,1,200),(1,1000,1004020431,1,1,200),(1,1000,1004020432,1,1,200),(1,1000,1004020441,1,1,400),(1,1000,1004020442,1,1,600),(1,1000,1004020443,1,1,1800),(1,1000,1004020453,1,1,99999),(1,1000,1004020463,1,1,99999),(1,1000,1004020500,1,1,100),(1,1000,1004020510,1,1,100),(1,1000,1004020520,1,1,200),(1,1000,1004020531,1,1,200),(1,1000,1004020532,1,1,300),(1,1000,1004020541,1,1,600),(1,1000,1004020542,1,1,900),(1,1000,1004020543,1,1,2500),(1,1000,1004020553,1,1,99999),(1,1000,1004020563,1,1,99999),(1,1000,1004020600,1,1,100),(1,1000,1004020610,1,1,100),(1,1000,1004020620,1,1,200),(1,1000,1004020631,1,1,300),(1,1000,1004020632,1,1,400),(1,1000,1004020641,1,1,700),(1,1000,1004020642,1,1,1000),(1,1000,1004020643,1,1,3600),(1,1000,1004020653,1,1,99999),(1,1000,1004020663,1,1,99999),(1,1000,1004020700,1,1,100),(1,1000,1004020710,1,1,200),(1,1000,1004020720,1,1,300),(1,1000,1004020731,1,1,300),(1,1000,1004020732,1,1,400),(1,1000,1004020741,1,1,900),(1,1000,1004020742,1,1,1300),(1,1000,1004020743,1,1,4900),(1,1000,1004020753,1,1,99999),(1,1000,1004020763,1,1,99999),(1,1000,1004020800,1,1,100),(1,1000,1004020810,1,1,200),(1,1000,1004020820,1,1,300),(1,1000,1004020831,1,1,400),(1,1000,1004020832,1,1,500),(1,1000,1004020841,1,1,1000),(1,1000,1004020842,1,1,1600),(1,1000,1004020843,1,1,6700),(1,1000,1004020853,1,1,99999),(1,1000,1004020863,1,1,99999),(1,1000,1004020900,1,1,100),(1,1000,1004020910,1,1,200),(1,1000,1004020920,1,1,300),(1,1000,1004020931,1,1,400),(1,1000,1004020932,1,1,500),(1,1000,1004020941,1,1,1200),(1,1000,1004020942,1,1,1900),(1,1000,1004020943,1,1,9500),(1,1000,1004020953,1,1,99999),(1,1000,1004020963,1,1,99999),(1,1000,1004021000,1,1,100),(1,1000,1004021010,1,1,200),(1,1000,1004021020,1,1,400),(1,1000,1004021031,1,1,500),(1,1000,1004021032,1,1,600),(1,1000,1004021041,1,1,1400),(1,1000,1004021042,1,1,2200),(1,1000,1004021043,1,1,13100),(1,1000,1004021053,1,1,99999),(1,1000,1004021063,1,1,99999),(1,1000,1004021100,1,1,100),(1,1000,1004021110,1,1,200),(1,1000,1004021120,1,1,400),(1,1000,1004021131,1,1,600),(1,1000,1004021132,1,1,700),(1,1000,1004021141,1,1,1900),(1,1000,1004021142,1,1,3100),(1,1000,1004021143,1,1,18500),(1,1000,1004021153,1,1,99999),(1,1000,1004021163,1,1,99999),(1,1000,1004021200,1,1,100),(1,1000,1004021210,1,1,300),(1,1000,1004021220,1,1,500),(1,1000,1004021231,1,1,700),(1,1000,1004021232,1,1,800),(1,1000,1004021241,1,1,2700),(1,1000,1004021242,1,1,4600),(1,1000,1004021243,1,1,27600),(1,1000,1004021253,1,1,99999),(1,1000,1004021263,1,1,99999),(1,1000,1004021300,1,1,100),(1,1000,1004021310,1,1,300),(1,1000,1004021320,1,1,500),(1,1000,1004021331,1,1,700),(1,1000,1004021332,1,1,900),(1,1000,1004021341,1,1,3300),(1,1000,1004021342,1,1,5700),(1,1000,1004021343,1,1,40400),(1,1000,1004021353,1,1,99999),(1,1000,1004021363,1,1,99999),(1,1000,1004021400,1,1,100),(1,1000,1004021410,1,1,300),(1,1000,1004021420,1,1,600),(1,1000,1004021431,1,1,800),(1,1000,1004021432,1,1,1000),(1,1000,1004021441,1,1,3900),(1,1000,1004021442,1,1,6800),(1,1000,1004021443,1,1,56700),(1,1000,1004021453,1,1,99999),(1,1000,1004021463,1,1,99999),(1,1000,1004021500,1,1,200),(1,1000,1004021510,1,1,400),(1,1000,1004021520,1,1,700),(1,1000,1004021531,1,1,900),(1,1000,1004021532,1,1,1100),(1,1000,1004021541,1,1,4300),(1,1000,1004021542,1,1,7500),(1,1000,1004021543,1,1,74900),(1,1000,1004021553,1,1,99999),(1,1000,1004021563,1,1,99999),(1,1000,1004021600,1,1,200),(1,1000,1004021610,1,1,400),(1,1000,1004021620,1,1,800),(1,1000,1004021631,1,1,1000),(1,1000,1004021632,1,1,1200),(1,1000,1004021641,1,1,5500),(1,1000,1004021642,1,1,9700),(1,1000,1004021643,1,1,96700),(1,1000,1004021653,1,1,99999),(1,1000,1004021663,1,1,99999),(1,1000,1004030100,1,1,100),(1,1000,1004030110,1,1,100),(1,1000,1004030120,1,1,100),(1,1000,1004030131,1,1,100),(1,1000,1004030132,1,1,100),(1,1000,1004030141,1,1,200),(1,1000,1004030142,1,1,200),(1,1000,1004030143,1,1,500),(1,1000,1004030153,1,1,99999),(1,1000,1004030163,1,1,99999),(1,1000,1004030200,1,1,100),(1,1000,1004030210,1,1,100),(1,1000,1004030220,1,1,100),(1,1000,1004030231,1,1,100),(1,1000,1004030232,1,1,100),(1,1000,1004030241,1,1,200),(1,1000,1004030242,1,1,300),(1,1000,1004030243,1,1,800),(1,1000,1004030253,1,1,99999),(1,1000,1004030263,1,1,99999),(1,1000,1004030300,1,1,100),(1,1000,1004030310,1,1,100),(1,1000,1004030320,1,1,100),(1,1000,1004030331,1,1,200),(1,1000,1004030332,1,1,200),(1,1000,1004030341,1,1,300),(1,1000,1004030342,1,1,500),(1,1000,1004030343,1,1,1300),(1,1000,1004030353,1,1,99999),(1,1000,1004030363,1,1,99999),(1,1000,1004030400,1,1,100),(1,1000,1004030410,1,1,100),(1,1000,1004030420,1,1,200),(1,1000,1004030431,1,1,200),(1,1000,1004030432,1,1,200),(1,1000,1004030441,1,1,400),(1,1000,1004030442,1,1,600),(1,1000,1004030443,1,1,1800),(1,1000,1004030453,1,1,99999),(1,1000,1004030463,1,1,99999),(1,1000,1004030500,1,1,100),(1,1000,1004030510,1,1,100),(1,1000,1004030520,1,1,200),(1,1000,1004030531,1,1,200),(1,1000,1004030532,1,1,300),(1,1000,1004030541,1,1,600),(1,1000,1004030542,1,1,900),(1,1000,1004030543,1,1,2500),(1,1000,1004030553,1,1,99999),(1,1000,1004030563,1,1,99999),(1,1000,1004030600,1,1,100),(1,1000,1004030610,1,1,100),(1,1000,1004030620,1,1,200),(1,1000,1004030631,1,1,300),(1,1000,1004030632,1,1,400),(1,1000,1004030641,1,1,700),(1,1000,1004030642,1,1,1000),(1,1000,1004030643,1,1,3600),(1,1000,1004030653,1,1,99999),(1,1000,1004030663,1,1,99999),(1,1000,1004030700,1,1,100),(1,1000,1004030710,1,1,200),(1,1000,1004030720,1,1,300),(1,1000,1004030731,1,1,300),(1,1000,1004030732,1,1,400),(1,1000,1004030741,1,1,900),(1,1000,1004030742,1,1,1300),(1,1000,1004030743,1,1,4900),(1,1000,1004030753,1,1,99999),(1,1000,1004030763,1,1,99999),(1,1000,1004030800,1,1,100),(1,1000,1004030810,1,1,200),(1,1000,1004030820,1,1,300),(1,1000,1004030831,1,1,400),(1,1000,1004030832,1,1,500),(1,1000,1004030841,1,1,1000),(1,1000,1004030842,1,1,1600),(1,1000,1004030843,1,1,6700),(1,1000,1004030853,1,1,99999),(1,1000,1004030863,1,1,99999),(1,1000,1004030900,1,1,100),(1,1000,1004030910,1,1,200),(1,1000,1004030920,1,1,300),(1,1000,1004030931,1,1,400),(1,1000,1004030932,1,1,500),(1,1000,1004030941,1,1,1200),(1,1000,1004030942,1,1,1900),(1,1000,1004030943,1,1,9500),(1,1000,1004030953,1,1,99999),(1,1000,1004030963,1,1,99999),(1,1000,1004031000,1,1,100),(1,1000,1004031010,1,1,200),(1,1000,1004031020,1,1,400),(1,1000,1004031031,1,1,500),(1,1000,1004031032,1,1,600),(1,1000,1004031041,1,1,1400),(1,1000,1004031042,1,1,2200),(1,1000,1004031043,1,1,13100),(1,1000,1004031053,1,1,99999),(1,1000,1004031063,1,1,99999),(1,1000,1004031100,1,1,100),(1,1000,1004031110,1,1,200),(1,1000,1004031120,1,1,400),(1,1000,1004031131,1,1,600),(1,1000,1004031132,1,1,700),(1,1000,1004031141,1,1,1900),(1,1000,1004031142,1,1,3100),(1,1000,1004031143,1,1,18500),(1,1000,1004031153,1,1,99999),(1,1000,1004031163,1,1,99999),(1,1000,1004031200,1,1,100),(1,1000,1004031210,1,1,300),(1,1000,1004031220,1,1,500),(1,1000,1004031231,1,1,700),(1,1000,1004031232,1,1,800),(1,1000,1004031241,1,1,2700),(1,1000,1004031242,1,1,4600),(1,1000,1004031243,1,1,27600),(1,1000,1004031253,1,1,99999),(1,1000,1004031263,1,1,99999),(1,1000,1004031300,1,1,100),(1,1000,1004031310,1,1,300),(1,1000,1004031320,1,1,500),(1,1000,1004031331,1,1,700),(1,1000,1004031332,1,1,900),(1,1000,1004031341,1,1,3300),(1,1000,1004031342,1,1,5700),(1,1000,1004031343,1,1,40400),(1,1000,1004031353,1,1,99999),(1,1000,1004031363,1,1,99999),(1,1000,1004031400,1,1,100),(1,1000,1004031410,1,1,300),(1,1000,1004031420,1,1,600),(1,1000,1004031431,1,1,800),(1,1000,1004031432,1,1,1000),(1,1000,1004031441,1,1,3900),(1,1000,1004031442,1,1,6800),(1,1000,1004031443,1,1,56700),(1,1000,1004031453,1,1,99999),(1,1000,1004031463,1,1,99999),(1,1000,1004031500,1,1,200),(1,1000,1004031510,1,1,400),(1,1000,1004031520,1,1,700),(1,1000,1004031531,1,1,900),(1,1000,1004031532,1,1,1100),(1,1000,1004031541,1,1,4300),(1,1000,1004031542,1,1,7500),(1,1000,1004031543,1,1,74900),(1,1000,1004031553,1,1,99999),(1,1000,1004031563,1,1,99999),(1,1000,1004031600,1,1,200),(1,1000,1004031610,1,1,400),(1,1000,1004031620,1,1,800),(1,1000,1004031631,1,1,1000),(1,1000,1004031632,1,1,1200),(1,1000,1004031641,1,1,5500),(1,1000,1004031642,1,1,9700),(1,1000,1004031643,1,1,96700),(1,1000,1004031653,1,1,99999),(1,1000,1004031663,1,1,99999),(1,1000,1004040100,1,1,100),(1,1000,1004040110,1,1,100),(1,1000,1004040120,1,1,100),(1,1000,1004040131,1,1,100),(1,1000,1004040132,1,1,100),(1,1000,1004040141,1,1,200),(1,1000,1004040142,1,1,200),(1,1000,1004040143,1,1,500),(1,1000,1004040153,1,1,99999),(1,1000,1004040163,1,1,99999),(1,1000,1004040200,1,1,100),(1,1000,1004040210,1,1,100),(1,1000,1004040220,1,1,100),(1,1000,1004040231,1,1,100),(1,1000,1004040232,1,1,100),(1,1000,1004040241,1,1,200),(1,1000,1004040242,1,1,300),(1,1000,1004040243,1,1,800),(1,1000,1004040253,1,1,99999),(1,1000,1004040263,1,1,99999),(1,1000,1004040300,1,1,100),(1,1000,1004040310,1,1,100),(1,1000,1004040320,1,1,100),(1,1000,1004040331,1,1,200),(1,1000,1004040332,1,1,200),(1,1000,1004040341,1,1,300),(1,1000,1004040342,1,1,500),(1,1000,1004040343,1,1,1300),(1,1000,1004040353,1,1,99999),(1,1000,1004040363,1,1,99999),(1,1000,1004040400,1,1,100),(1,1000,1004040410,1,1,100),(1,1000,1004040420,1,1,200),(1,1000,1004040431,1,1,200),(1,1000,1004040432,1,1,200),(1,1000,1004040441,1,1,400),(1,1000,1004040442,1,1,600),(1,1000,1004040443,1,1,1800),(1,1000,1004040453,1,1,99999),(1,1000,1004040463,1,1,99999),(1,1000,1004040500,1,1,100),(1,1000,1004040510,1,1,100),(1,1000,1004040520,1,1,200),(1,1000,1004040531,1,1,200),(1,1000,1004040532,1,1,300),(1,1000,1004040541,1,1,600),(1,1000,1004040542,1,1,900),(1,1000,1004040543,1,1,2500),(1,1000,1004040553,1,1,99999),(1,1000,1004040563,1,1,99999),(1,1000,1004040600,1,1,100),(1,1000,1004040610,1,1,100),(1,1000,1004040620,1,1,200),(1,1000,1004040631,1,1,300),(1,1000,1004040632,1,1,400),(1,1000,1004040641,1,1,700),(1,1000,1004040642,1,1,1000),(1,1000,1004040643,1,1,3600),(1,1000,1004040653,1,1,99999),(1,1000,1004040663,1,1,99999),(1,1000,1004040700,1,1,100),(1,1000,1004040710,1,1,200),(1,1000,1004040720,1,1,300),(1,1000,1004040731,1,1,300),(1,1000,1004040732,1,1,400),(1,1000,1004040741,1,1,900),(1,1000,1004040742,1,1,1300),(1,1000,1004040743,1,1,4900),(1,1000,1004040753,1,1,99999),(1,1000,1004040763,1,1,99999),(1,1000,1004040800,1,1,100),(1,1000,1004040810,1,1,200),(1,1000,1004040820,1,1,300),(1,1000,1004040831,1,1,400),(1,1000,1004040832,1,1,500),(1,1000,1004040841,1,1,1000),(1,1000,1004040842,1,1,1600),(1,1000,1004040843,1,1,6700),(1,1000,1004040853,1,1,99999),(1,1000,1004040863,1,1,99999),(1,1000,1004040900,1,1,100),(1,1000,1004040910,1,1,200),(1,1000,1004040920,1,1,300),(1,1000,1004040931,1,1,400),(1,1000,1004040932,1,1,500),(1,1000,1004040941,1,1,1200),(1,1000,1004040942,1,1,1900),(1,1000,1004040943,1,1,9500),(1,1000,1004040953,1,1,99999),(1,1000,1004040963,1,1,99999),(1,1000,1004041000,1,1,100),(1,1000,1004041010,1,1,200),(1,1000,1004041020,1,1,400),(1,1000,1004041031,1,1,500),(1,1000,1004041032,1,1,600),(1,1000,1004041041,1,1,1400),(1,1000,1004041042,1,1,2200),(1,1000,1004041043,1,1,13100),(1,1000,1004041053,1,1,99999),(1,1000,1004041063,1,1,99999),(1,1000,1004041100,1,1,100),(1,1000,1004041110,1,1,200),(1,1000,1004041120,1,1,400),(1,1000,1004041131,1,1,600),(1,1000,1004041132,1,1,700),(1,1000,1004041141,1,1,1900),(1,1000,1004041142,1,1,3100),(1,1000,1004041143,1,1,18500),(1,1000,1004041153,1,1,99999),(1,1000,1004041163,1,1,99999),(1,1000,1004041200,1,1,100),(1,1000,1004041210,1,1,300),(1,1000,1004041220,1,1,500),(1,1000,1004041231,1,1,700),(1,1000,1004041232,1,1,800),(1,1000,1004041241,1,1,2700),(1,1000,1004041242,1,1,4600),(1,1000,1004041243,1,1,27600),(1,1000,1004041253,1,1,99999),(1,1000,1004041263,1,1,99999),(1,1000,1004041300,1,1,100),(1,1000,1004041310,1,1,300),(1,1000,1004041320,1,1,500),(1,1000,1004041331,1,1,700),(1,1000,1004041332,1,1,900),(1,1000,1004041341,1,1,3300),(1,1000,1004041342,1,1,5700),(1,1000,1004041343,1,1,40400),(1,1000,1004041353,1,1,99999),(1,1000,1004041363,1,1,99999),(1,1000,1004041400,1,1,100),(1,1000,1004041410,1,1,300),(1,1000,1004041420,1,1,600),(1,1000,1004041431,1,1,800),(1,1000,1004041432,1,1,1000),(1,1000,1004041441,1,1,3900),(1,1000,1004041442,1,1,6800),(1,1000,1004041443,1,1,56700),(1,1000,1004041453,1,1,99999),(1,1000,1004041463,1,1,99999),(1,1000,1004041500,1,1,200),(1,1000,1004041510,1,1,400),(1,1000,1004041520,1,1,700),(1,1000,1004041531,1,1,900),(1,1000,1004041532,1,1,1100),(1,1000,1004041541,1,1,4300),(1,1000,1004041542,1,1,7500),(1,1000,1004041543,1,1,74900),(1,1000,1004041553,1,1,99999),(1,1000,1004041563,1,1,99999),(1,1000,1004041600,1,1,200),(1,1000,1004041610,1,1,400),(1,1000,1004041620,1,1,800),(1,1000,1004041631,1,1,1000),(1,1000,1004041632,1,1,1200),(1,1000,1004041641,1,1,5500),(1,1000,1004041642,1,1,9700),(1,1000,1004041643,1,1,96700),(1,1000,1004041653,1,1,99999),(1,1000,1004041663,1,1,99999),(1,1000,1005000100,1,1,10000),(1,1000,1005000110,1,1,10000),(1,1000,1005000120,1,1,10000),(1,1000,1005000131,1,1,10000),(1,1000,1005000132,1,1,10000),(1,1000,1005000141,1,1,10000),(1,1000,1005000142,1,1,10000),(1,1000,1005000143,1,1,10000),(1,1000,1005000153,1,1,99999),(1,1000,1005000163,1,1,99999),(1,1000,1005000200,1,1,10000),(1,1000,1005000210,1,1,10000),(1,1000,1005000220,1,1,10000),(1,1000,1005000231,1,1,10000),(1,1000,1005000232,1,1,10000),(1,1000,1005000241,1,1,10000),(1,1000,1005000242,1,1,10000),(1,1000,1005000243,1,1,10000),(1,1000,1005000253,1,1,99999),(1,1000,1005000263,1,1,99999),(1,1000,1005000300,1,1,10000),(1,1000,1005000310,1,1,10000),(1,1000,1005000320,1,1,10000),(1,1000,1005000331,1,1,10000),(1,1000,1005000332,1,1,10000),(1,1000,1005000341,1,1,10000),(1,1000,1005000342,1,1,10000),(1,1000,1005000343,1,1,10000),(1,1000,1005000353,1,1,99999),(1,1000,1005000363,1,1,99999),(1,1000,1005000400,1,1,10000),(1,1000,1005000410,1,1,10000),(1,1000,1005000420,1,1,10000),(1,1000,1005000431,1,1,10000),(1,1000,1005000432,1,1,10000),(1,1000,1005000441,1,1,10000),(1,1000,1005000442,1,1,10000),(1,1000,1005000443,1,1,10000),(1,1000,1005000453,1,1,99999),(1,1000,1005000463,1,1,99999),(1,1000,1005000500,1,1,10000),(1,1000,1005000510,1,1,10000),(1,1000,1005000520,1,1,10000),(1,1000,1005000531,1,1,10000),(1,1000,1005000532,1,1,10000),(1,1000,1005000541,1,1,10000),(1,1000,1005000542,1,1,10000),(1,1000,1005000543,1,1,10000),(1,1000,1005000553,1,1,99999),(1,1000,1005000563,1,1,99999),(1,1000,1005000600,1,1,10000),(1,1000,1005000610,1,1,10000),(1,1000,1005000620,1,1,10000),(1,1000,1005000631,1,1,10000),(1,1000,1005000632,1,1,10000),(1,1000,1005000641,1,1,10000),(1,1000,1005000642,1,1,10000),(1,1000,1005000643,1,1,10000),(1,1000,1005000653,1,1,99999),(1,1000,1005000663,1,1,99999),(1,1000,1005000700,1,1,10000),(1,1000,1005000710,1,1,10000),(1,1000,1005000720,1,1,10000),(1,1000,1005000731,1,1,10000),(1,1000,1005000732,1,1,10000),(1,1000,1005000741,1,1,10000),(1,1000,1005000742,1,1,10000),(1,1000,1005000743,1,1,10000),(1,1000,1005000753,1,1,99999),(1,1000,1005000763,1,1,99999),(1,1000,1005000800,1,1,10000),(1,1000,1005000810,1,1,10000),(1,1000,1005000820,1,1,10000),(1,1000,1005000831,1,1,10000),(1,1000,1005000832,1,1,10000),(1,1000,1005000841,1,1,10000),(1,1000,1005000842,1,1,10000),(1,1000,1005000843,1,1,10000),(1,1000,1005000853,1,1,99999),(1,1000,1005000863,1,1,99999),(1,1000,1005000900,1,1,10000),(1,1000,1005000910,1,1,10000),(1,1000,1005000920,1,1,10000),(1,1000,1005000931,1,1,10000),(1,1000,1005000932,1,1,10000),(1,1000,1005000941,1,1,10000),(1,1000,1005000942,1,1,10000),(1,1000,1005000943,1,1,10000),(1,1000,1005000953,1,1,99999),(1,1000,1005000963,1,1,99999),(1,1000,1005001000,1,1,10000),(1,1000,1005001010,1,1,10000),(1,1000,1005001020,1,1,10000),(1,1000,1005001031,1,1,10000),(1,1000,1005001032,1,1,10000),(1,1000,1005001041,1,1,10000),(1,1000,1005001042,1,1,10000),(1,1000,1005001043,1,1,10000),(1,1000,1005001053,1,1,99999),(1,1000,1005001063,1,1,99999),(1,1000,1005001100,1,1,10000),(1,1000,1005001110,1,1,10000),(1,1000,1005001120,1,1,10000),(1,1000,1005001131,1,1,10000),(1,1000,1005001132,1,1,10000),(1,1000,1005001141,1,1,10000),(1,1000,1005001142,1,1,10000),(1,1000,1005001143,1,1,10000),(1,1000,1005001153,1,1,99999),(1,1000,1005001163,1,1,99999),(1,1000,1005001200,1,1,10000),(1,1000,1005001210,1,1,10000),(1,1000,1005001220,1,1,10000),(1,1000,1005001231,1,1,10000),(1,1000,1005001232,1,1,10000),(1,1000,1005001241,1,1,10000),(1,1000,1005001242,1,1,10000),(1,1000,1005001243,1,1,10000),(1,1000,1005001253,1,1,99999),(1,1000,1005001263,1,1,99999),(1,1000,1005001300,1,1,10000),(1,1000,1005001310,1,1,10000),(1,1000,1005001320,1,1,10000),(1,1000,1005001331,1,1,10000),(1,1000,1005001332,1,1,10000),(1,1000,1005001341,1,1,10000),(1,1000,1005001342,1,1,10000),(1,1000,1005001343,1,1,10000),(1,1000,1005001353,1,1,99999),(1,1000,1005001363,1,1,99999),(1,1000,1005001400,1,1,10000),(1,1000,1005001410,1,1,10000),(1,1000,1005001420,1,1,10000),(1,1000,1005001431,1,1,10000),(1,1000,1005001432,1,1,10000),(1,1000,1005001441,1,1,10000),(1,1000,1005001442,1,1,10000),(1,1000,1005001443,1,1,10000),(1,1000,1005001453,1,1,99999),(1,1000,1005001463,1,1,99999),(1,1000,1005001500,1,1,10000),(1,1000,1005001510,1,1,10000),(1,1000,1005001520,1,1,10000),(1,1000,1005001531,1,1,10000),(1,1000,1005001532,1,1,10000),(1,1000,1005001541,1,1,10000),(1,1000,1005001542,1,1,10000),(1,1000,1005001543,1,1,10000),(1,1000,1005001553,1,1,99999),(1,1000,1005001563,1,1,99999),(1,1000,1005001600,1,1,10000),(1,1000,1005001610,1,1,10000),(1,1000,1005001620,1,1,10000),(1,1000,1005001631,1,1,10000),(1,1000,1005001632,1,1,10000),(1,1000,1005001641,1,1,10000),(1,1000,1005001642,1,1,10000),(1,1000,1005001643,1,1,10000),(1,1000,1005001653,1,1,99999),(1,1000,1005001663,1,1,99999),(1,1000,1006010100,1,1,100),(1,1000,1006010110,1,1,100),(1,1000,1006010120,1,1,100),(1,1000,1006010131,1,1,100),(1,1000,1006010132,1,1,100),(1,1000,1006010141,1,1,200),(1,1000,1006010142,1,1,200),(1,1000,1006010143,1,1,500),(1,1000,1006010153,1,1,99999),(1,1000,1006010163,1,1,99999),(1,1000,1006010200,1,1,100),(1,1000,1006010210,1,1,100),(1,1000,1006010220,1,1,100),(1,1000,1006010231,1,1,100),(1,1000,1006010232,1,1,100),(1,1000,1006010241,1,1,200),(1,1000,1006010242,1,1,300),(1,1000,1006010243,1,1,800),(1,1000,1006010253,1,1,99999),(1,1000,1006010263,1,1,99999),(1,1000,1006010300,1,1,100),(1,1000,1006010310,1,1,100),(1,1000,1006010320,1,1,100),(1,1000,1006010331,1,1,200),(1,1000,1006010332,1,1,200),(1,1000,1006010341,1,1,300),(1,1000,1006010342,1,1,500),(1,1000,1006010343,1,1,1300),(1,1000,1006010353,1,1,99999),(1,1000,1006010363,1,1,99999),(1,1000,1006010400,1,1,100),(1,1000,1006010410,1,1,100),(1,1000,1006010420,1,1,200),(1,1000,1006010431,1,1,200),(1,1000,1006010432,1,1,200),(1,1000,1006010441,1,1,400),(1,1000,1006010442,1,1,600),(1,1000,1006010443,1,1,1800),(1,1000,1006010453,1,1,99999),(1,1000,1006010463,1,1,99999),(1,1000,1006010500,1,1,100),(1,1000,1006010510,1,1,100),(1,1000,1006010520,1,1,200),(1,1000,1006010531,1,1,200),(1,1000,1006010532,1,1,300),(1,1000,1006010541,1,1,600),(1,1000,1006010542,1,1,900),(1,1000,1006010543,1,1,2500),(1,1000,1006010553,1,1,99999),(1,1000,1006010563,1,1,99999),(1,1000,1006010600,1,1,100),(1,1000,1006010610,1,1,100),(1,1000,1006010620,1,1,200),(1,1000,1006010631,1,1,300),(1,1000,1006010632,1,1,400),(1,1000,1006010641,1,1,700),(1,1000,1006010642,1,1,1000),(1,1000,1006010643,1,1,3600),(1,1000,1006010653,1,1,99999),(1,1000,1006010663,1,1,99999),(1,1000,1006010700,1,1,100),(1,1000,1006010710,1,1,200),(1,1000,1006010720,1,1,300),(1,1000,1006010731,1,1,300),(1,1000,1006010732,1,1,400),(1,1000,1006010741,1,1,900),(1,1000,1006010742,1,1,1300),(1,1000,1006010743,1,1,4900),(1,1000,1006010753,1,1,99999),(1,1000,1006010763,1,1,99999),(1,1000,1006010800,1,1,100),(1,1000,1006010810,1,1,200),(1,1000,1006010820,1,1,300),(1,1000,1006010831,1,1,400),(1,1000,1006010832,1,1,500),(1,1000,1006010841,1,1,1000),(1,1000,1006010842,1,1,1600),(1,1000,1006010843,1,1,6700),(1,1000,1006010853,1,1,99999),(1,1000,1006010863,1,1,99999),(1,1000,1006010900,1,1,100),(1,1000,1006010910,1,1,200),(1,1000,1006010920,1,1,300),(1,1000,1006010931,1,1,400),(1,1000,1006010932,1,1,500),(1,1000,1006010941,1,1,1200),(1,1000,1006010942,1,1,1900),(1,1000,1006010943,1,1,9500),(1,1000,1006010953,1,1,99999),(1,1000,1006010963,1,1,99999),(1,1000,1006011000,1,1,100),(1,1000,1006011010,1,1,200),(1,1000,1006011020,1,1,400),(1,1000,1006011031,1,1,500),(1,1000,1006011032,1,1,600),(1,1000,1006011041,1,1,1400),(1,1000,1006011042,1,1,2200),(1,1000,1006011043,1,1,13100),(1,1000,1006011053,1,1,99999),(1,1000,1006011063,1,1,99999),(1,1000,1006011100,1,1,100),(1,1000,1006011110,1,1,200),(1,1000,1006011120,1,1,400),(1,1000,1006011131,1,1,600),(1,1000,1006011132,1,1,700),(1,1000,1006011141,1,1,1900),(1,1000,1006011142,1,1,3100),(1,1000,1006011143,1,1,18500),(1,1000,1006011153,1,1,99999),(1,1000,1006011163,1,1,99999),(1,1000,1006011200,1,1,100),(1,1000,1006011210,1,1,300),(1,1000,1006011220,1,1,500),(1,1000,1006011231,1,1,700),(1,1000,1006011232,1,1,800),(1,1000,1006011241,1,1,2700),(1,1000,1006011242,1,1,4600),(1,1000,1006011243,1,1,27600),(1,1000,1006011253,1,1,99999),(1,1000,1006011263,1,1,99999),(1,1000,1006011300,1,1,100),(1,1000,1006011310,1,1,300),(1,1000,1006011320,1,1,500),(1,1000,1006011331,1,1,700),(1,1000,1006011332,1,1,900),(1,1000,1006011341,1,1,3300),(1,1000,1006011342,1,1,5700),(1,1000,1006011343,1,1,40400),(1,1000,1006011353,1,1,99999),(1,1000,1006011363,1,1,99999),(1,1000,1006011400,1,1,100),(1,1000,1006011410,1,1,300),(1,1000,1006011420,1,1,600),(1,1000,1006011431,1,1,800),(1,1000,1006011432,1,1,1000),(1,1000,1006011441,1,1,3900),(1,1000,1006011442,1,1,6800),(1,1000,1006011443,1,1,56700),(1,1000,1006011453,1,1,99999),(1,1000,1006011463,1,1,99999),(1,1000,1006011500,1,1,200),(1,1000,1006011510,1,1,400),(1,1000,1006011520,1,1,700),(1,1000,1006011531,1,1,900),(1,1000,1006011532,1,1,1100),(1,1000,1006011541,1,1,4300),(1,1000,1006011542,1,1,7500),(1,1000,1006011543,1,1,74900),(1,1000,1006011553,1,1,99999),(1,1000,1006011563,1,1,99999),(1,1000,1006011600,1,1,200),(1,1000,1006011610,1,1,400),(1,1000,1006011620,1,1,800),(1,1000,1006011631,1,1,1000),(1,1000,1006011632,1,1,1200),(1,1000,1006011641,1,1,5500),(1,1000,1006011642,1,1,9700),(1,1000,1006011643,1,1,96700),(1,1000,1006011653,1,1,99999),(1,1000,1006011663,1,1,99999),(1,1000,1006020100,1,1,100),(1,1000,1006020110,1,1,100),(1,1000,1006020120,1,1,100),(1,1000,1006020131,1,1,100),(1,1000,1006020132,1,1,100),(1,1000,1006020141,1,1,200),(1,1000,1006020142,1,1,200),(1,1000,1006020143,1,1,500),(1,1000,1006020153,1,1,99999),(1,1000,1006020163,1,1,99999),(1,1000,1006020200,1,1,100),(1,1000,1006020210,1,1,100),(1,1000,1006020220,1,1,100),(1,1000,1006020231,1,1,100),(1,1000,1006020232,1,1,100),(1,1000,1006020241,1,1,200),(1,1000,1006020242,1,1,300),(1,1000,1006020243,1,1,800),(1,1000,1006020253,1,1,99999),(1,1000,1006020263,1,1,99999),(1,1000,1006020300,1,1,100),(1,1000,1006020310,1,1,100),(1,1000,1006020320,1,1,100),(1,1000,1006020331,1,1,200),(1,1000,1006020332,1,1,200),(1,1000,1006020341,1,1,300),(1,1000,1006020342,1,1,500),(1,1000,1006020343,1,1,1300),(1,1000,1006020353,1,1,99999),(1,1000,1006020363,1,1,99999),(1,1000,1006020400,1,1,100),(1,1000,1006020410,1,1,100),(1,1000,1006020420,1,1,200),(1,1000,1006020431,1,1,200),(1,1000,1006020432,1,1,200),(1,1000,1006020441,1,1,400),(1,1000,1006020442,1,1,600),(1,1000,1006020443,1,1,1800),(1,1000,1006020453,1,1,99999),(1,1000,1006020463,1,1,99999),(1,1000,1006020500,1,1,100),(1,1000,1006020510,1,1,100),(1,1000,1006020520,1,1,200),(1,1000,1006020531,1,1,200),(1,1000,1006020532,1,1,300),(1,1000,1006020541,1,1,600),(1,1000,1006020542,1,1,900),(1,1000,1006020543,1,1,2500),(1,1000,1006020553,1,1,99999),(1,1000,1006020563,1,1,99999),(1,1000,1006020600,1,1,100),(1,1000,1006020610,1,1,100),(1,1000,1006020620,1,1,200),(1,1000,1006020631,1,1,300),(1,1000,1006020632,1,1,400),(1,1000,1006020641,1,1,700),(1,1000,1006020642,1,1,1000),(1,1000,1006020643,1,1,3600),(1,1000,1006020653,1,1,99999),(1,1000,1006020663,1,1,99999),(1,1000,1006020700,1,1,100),(1,1000,1006020710,1,1,200),(1,1000,1006020720,1,1,300),(1,1000,1006020731,1,1,300),(1,1000,1006020732,1,1,400),(1,1000,1006020741,1,1,900),(1,1000,1006020742,1,1,1300),(1,1000,1006020743,1,1,4900),(1,1000,1006020753,1,1,99999),(1,1000,1006020763,1,1,99999),(1,1000,1006020800,1,1,100),(1,1000,1006020810,1,1,200),(1,1000,1006020820,1,1,300),(1,1000,1006020831,1,1,400),(1,1000,1006020832,1,1,500),(1,1000,1006020841,1,1,1000),(1,1000,1006020842,1,1,1600),(1,1000,1006020843,1,1,6700),(1,1000,1006020853,1,1,99999),(1,1000,1006020863,1,1,99999),(1,1000,1006020900,1,1,100),(1,1000,1006020910,1,1,200),(1,1000,1006020920,1,1,300),(1,1000,1006020931,1,1,400),(1,1000,1006020932,1,1,500),(1,1000,1006020941,1,1,1200),(1,1000,1006020942,1,1,1900),(1,1000,1006020943,1,1,9500),(1,1000,1006020953,1,1,99999),(1,1000,1006020963,1,1,99999),(1,1000,1006021000,1,1,100),(1,1000,1006021010,1,1,200),(1,1000,1006021020,1,1,400),(1,1000,1006021031,1,1,500),(1,1000,1006021032,1,1,600),(1,1000,1006021041,1,1,1400),(1,1000,1006021042,1,1,2200),(1,1000,1006021043,1,1,13100),(1,1000,1006021053,1,1,99999),(1,1000,1006021063,1,1,99999),(1,1000,1006021100,1,1,100),(1,1000,1006021110,1,1,200),(1,1000,1006021120,1,1,400),(1,1000,1006021131,1,1,600),(1,1000,1006021132,1,1,700),(1,1000,1006021141,1,1,1900),(1,1000,1006021142,1,1,3100),(1,1000,1006021143,1,1,18500),(1,1000,1006021153,1,1,99999),(1,1000,1006021163,1,1,99999),(1,1000,1006021200,1,1,100),(1,1000,1006021210,1,1,300),(1,1000,1006021220,1,1,500),(1,1000,1006021231,1,1,700),(1,1000,1006021232,1,1,800),(1,1000,1006021241,1,1,2700),(1,1000,1006021242,1,1,4600),(1,1000,1006021243,1,1,27600),(1,1000,1006021253,1,1,99999),(1,1000,1006021263,1,1,99999),(1,1000,1006021300,1,1,100),(1,1000,1006021310,1,1,300),(1,1000,1006021320,1,1,500),(1,1000,1006021331,1,1,700),(1,1000,1006021332,1,1,900),(1,1000,1006021341,1,1,3300),(1,1000,1006021342,1,1,5700),(1,1000,1006021343,1,1,40400),(1,1000,1006021353,1,1,99999),(1,1000,1006021363,1,1,99999),(1,1000,1006021400,1,1,100),(1,1000,1006021410,1,1,300),(1,1000,1006021420,1,1,600),(1,1000,1006021431,1,1,800),(1,1000,1006021432,1,1,1000),(1,1000,1006021441,1,1,3900),(1,1000,1006021442,1,1,6800),(1,1000,1006021443,1,1,56700),(1,1000,1006021453,1,1,99999),(1,1000,1006021463,1,1,99999),(1,1000,1006021500,1,1,200),(1,1000,1006021510,1,1,400),(1,1000,1006021520,1,1,700),(1,1000,1006021531,1,1,900),(1,1000,1006021532,1,1,1100),(1,1000,1006021541,1,1,4300),(1,1000,1006021542,1,1,7500),(1,1000,1006021543,1,1,74900),(1,1000,1006021553,1,1,99999),(1,1000,1006021563,1,1,99999),(1,1000,1006021600,1,1,200),(1,1000,1006021610,1,1,400),(1,1000,1006021620,1,1,800),(1,1000,1006021631,1,1,1000),(1,1000,1006021632,1,1,1200),(1,1000,1006021641,1,1,5500),(1,1000,1006021642,1,1,9700),(1,1000,1006021643,1,1,96700),(1,1000,1006021653,1,1,99999),(1,1000,1006021663,1,1,99999),(1,1000,1006030100,1,1,100),(1,1000,1006030110,1,1,100),(1,1000,1006030120,1,1,100),(1,1000,1006030131,1,1,100),(1,1000,1006030132,1,1,100),(1,1000,1006030141,1,1,200),(1,1000,1006030142,1,1,200),(1,1000,1006030143,1,1,500),(1,1000,1006030153,1,1,99999),(1,1000,1006030163,1,1,99999),(1,1000,1006030200,1,1,100),(1,1000,1006030210,1,1,100),(1,1000,1006030220,1,1,100),(1,1000,1006030231,1,1,100),(1,1000,1006030232,1,1,100),(1,1000,1006030241,1,1,200),(1,1000,1006030242,1,1,300),(1,1000,1006030243,1,1,800),(1,1000,1006030253,1,1,99999),(1,1000,1006030263,1,1,99999),(1,1000,1006030300,1,1,100),(1,1000,1006030310,1,1,100),(1,1000,1006030320,1,1,100),(1,1000,1006030331,1,1,200),(1,1000,1006030332,1,1,200),(1,1000,1006030341,1,1,300),(1,1000,1006030342,1,1,500),(1,1000,1006030343,1,1,1300),(1,1000,1006030353,1,1,99999),(1,1000,1006030363,1,1,99999),(1,1000,1006030400,1,1,100),(1,1000,1006030410,1,1,100),(1,1000,1006030420,1,1,200),(1,1000,1006030431,1,1,200),(1,1000,1006030432,1,1,200),(1,1000,1006030441,1,1,400),(1,1000,1006030442,1,1,600),(1,1000,1006030443,1,1,1800),(1,1000,1006030453,1,1,99999),(1,1000,1006030463,1,1,99999),(1,1000,1006030500,1,1,100),(1,1000,1006030510,1,1,100),(1,1000,1006030520,1,1,200),(1,1000,1006030531,1,1,200),(1,1000,1006030532,1,1,300),(1,1000,1006030541,1,1,600),(1,1000,1006030542,1,1,900),(1,1000,1006030543,1,1,2500),(1,1000,1006030553,1,1,99999),(1,1000,1006030563,1,1,99999),(1,1000,1006030600,1,1,100),(1,1000,1006030610,1,1,100),(1,1000,1006030620,1,1,200),(1,1000,1006030631,1,1,300),(1,1000,1006030632,1,1,400),(1,1000,1006030641,1,1,700),(1,1000,1006030642,1,1,1000),(1,1000,1006030643,1,1,3600),(1,1000,1006030653,1,1,99999),(1,1000,1006030663,1,1,99999),(1,1000,1006030700,1,1,100),(1,1000,1006030710,1,1,200),(1,1000,1006030720,1,1,300),(1,1000,1006030731,1,1,300),(1,1000,1006030732,1,1,400),(1,1000,1006030741,1,1,900),(1,1000,1006030742,1,1,1300),(1,1000,1006030743,1,1,4900),(1,1000,1006030753,1,1,99999),(1,1000,1006030763,1,1,99999),(1,1000,1006030800,1,1,100),(1,1000,1006030810,1,1,200),(1,1000,1006030820,1,1,300),(1,1000,1006030831,1,1,400),(1,1000,1006030832,1,1,500),(1,1000,1006030841,1,1,1000),(1,1000,1006030842,1,1,1600),(1,1000,1006030843,1,1,6700),(1,1000,1006030853,1,1,99999),(1,1000,1006030863,1,1,99999),(1,1000,1006030900,1,1,100),(1,1000,1006030910,1,1,200),(1,1000,1006030920,1,1,300),(1,1000,1006030931,1,1,400),(1,1000,1006030932,1,1,500),(1,1000,1006030941,1,1,1200),(1,1000,1006030942,1,1,1900),(1,1000,1006030943,1,1,9500),(1,1000,1006030953,1,1,99999),(1,1000,1006030963,1,1,99999),(1,1000,1006031000,1,1,100),(1,1000,1006031010,1,1,200),(1,1000,1006031020,1,1,400),(1,1000,1006031031,1,1,500),(1,1000,1006031032,1,1,600),(1,1000,1006031041,1,1,1400),(1,1000,1006031042,1,1,2200),(1,1000,1006031043,1,1,13100),(1,1000,1006031053,1,1,99999),(1,1000,1006031063,1,1,99999),(1,1000,1006031100,1,1,100),(1,1000,1006031110,1,1,200),(1,1000,1006031120,1,1,400),(1,1000,1006031131,1,1,600),(1,1000,1006031132,1,1,700),(1,1000,1006031141,1,1,1900),(1,1000,1006031142,1,1,3100),(1,1000,1006031143,1,1,18500),(1,1000,1006031153,1,1,99999),(1,1000,1006031163,1,1,99999),(1,1000,1006031200,1,1,100),(1,1000,1006031210,1,1,300),(1,1000,1006031220,1,1,500),(1,1000,1006031231,1,1,700),(1,1000,1006031232,1,1,800),(1,1000,1006031241,1,1,2700),(1,1000,1006031242,1,1,4600),(1,1000,1006031243,1,1,27600),(1,1000,1006031253,1,1,99999),(1,1000,1006031263,1,1,99999),(1,1000,1006031300,1,1,100),(1,1000,1006031310,1,1,300),(1,1000,1006031320,1,1,500),(1,1000,1006031331,1,1,700),(1,1000,1006031332,1,1,900),(1,1000,1006031341,1,1,3300),(1,1000,1006031342,1,1,5700),(1,1000,1006031343,1,1,40400),(1,1000,1006031353,1,1,99999),(1,1000,1006031363,1,1,99999),(1,1000,1006031400,1,1,100),(1,1000,1006031410,1,1,300),(1,1000,1006031420,1,1,600),(1,1000,1006031431,1,1,800),(1,1000,1006031432,1,1,1000),(1,1000,1006031441,1,1,3900),(1,1000,1006031442,1,1,6800),(1,1000,1006031443,1,1,56700),(1,1000,1006031453,1,1,99999),(1,1000,1006031463,1,1,99999),(1,1000,1006031500,1,1,200),(1,1000,1006031510,1,1,400),(1,1000,1006031520,1,1,700),(1,1000,1006031531,1,1,900),(1,1000,1006031532,1,1,1100),(1,1000,1006031541,1,1,4300),(1,1000,1006031542,1,1,7500),(1,1000,1006031543,1,1,74900),(1,1000,1006031553,1,1,99999),(1,1000,1006031563,1,1,99999),(1,1000,1006031600,1,1,200),(1,1000,1006031610,1,1,400),(1,1000,1006031620,1,1,800),(1,1000,1006031631,1,1,1000),(1,1000,1006031632,1,1,1200),(1,1000,1006031641,1,1,5500),(1,1000,1006031642,1,1,9700),(1,1000,1006031643,1,1,96700),(1,1000,1006031653,1,1,99999),(1,1000,1006031663,1,1,99999),(1,1000,1006040100,1,1,100),(1,1000,1006040110,1,1,100),(1,1000,1006040120,1,1,100),(1,1000,1006040131,1,1,100),(1,1000,1006040132,1,1,100),(1,1000,1006040141,1,1,200),(1,1000,1006040142,1,1,200),(1,1000,1006040143,1,1,500),(1,1000,1006040153,1,1,99999),(1,1000,1006040163,1,1,99999),(1,1000,1006040200,1,1,100),(1,1000,1006040210,1,1,100),(1,1000,1006040220,1,1,100),(1,1000,1006040231,1,1,100),(1,1000,1006040232,1,1,100),(1,1000,1006040241,1,1,200),(1,1000,1006040242,1,1,300),(1,1000,1006040243,1,1,800),(1,1000,1006040253,1,1,99999),(1,1000,1006040263,1,1,99999),(1,1000,1006040300,1,1,100),(1,1000,1006040310,1,1,100),(1,1000,1006040320,1,1,100),(1,1000,1006040331,1,1,200),(1,1000,1006040332,1,1,200),(1,1000,1006040341,1,1,300),(1,1000,1006040342,1,1,500),(1,1000,1006040343,1,1,1300),(1,1000,1006040353,1,1,99999),(1,1000,1006040363,1,1,99999),(1,1000,1006040400,1,1,100),(1,1000,1006040410,1,1,100),(1,1000,1006040420,1,1,200),(1,1000,1006040431,1,1,200),(1,1000,1006040432,1,1,200),(1,1000,1006040441,1,1,400),(1,1000,1006040442,1,1,600),(1,1000,1006040443,1,1,1800),(1,1000,1006040453,1,1,99999),(1,1000,1006040463,1,1,99999),(1,1000,1006040500,1,1,100),(1,1000,1006040510,1,1,100),(1,1000,1006040520,1,1,200),(1,1000,1006040531,1,1,200),(1,1000,1006040532,1,1,300),(1,1000,1006040541,1,1,600),(1,1000,1006040542,1,1,900),(1,1000,1006040543,1,1,2500),(1,1000,1006040553,1,1,99999),(1,1000,1006040563,1,1,99999),(1,1000,1006040600,1,1,100),(1,1000,1006040610,1,1,100),(1,1000,1006040620,1,1,200),(1,1000,1006040631,1,1,300),(1,1000,1006040632,1,1,400),(1,1000,1006040641,1,1,700),(1,1000,1006040642,1,1,1000),(1,1000,1006040643,1,1,3600),(1,1000,1006040653,1,1,99999),(1,1000,1006040663,1,1,99999),(1,1000,1006040700,1,1,100),(1,1000,1006040710,1,1,200),(1,1000,1006040720,1,1,300),(1,1000,1006040731,1,1,300),(1,1000,1006040732,1,1,400),(1,1000,1006040741,1,1,900),(1,1000,1006040742,1,1,1300),(1,1000,1006040743,1,1,4900),(1,1000,1006040753,1,1,99999),(1,1000,1006040763,1,1,99999),(1,1000,1006040800,1,1,100),(1,1000,1006040810,1,1,200),(1,1000,1006040820,1,1,300),(1,1000,1006040831,1,1,400),(1,1000,1006040832,1,1,500),(1,1000,1006040841,1,1,1000),(1,1000,1006040842,1,1,1600),(1,1000,1006040843,1,1,6700),(1,1000,1006040853,1,1,99999),(1,1000,1006040863,1,1,99999),(1,1000,1006040900,1,1,100),(1,1000,1006040910,1,1,200),(1,1000,1006040920,1,1,300),(1,1000,1006040931,1,1,400),(1,1000,1006040932,1,1,500),(1,1000,1006040941,1,1,1200),(1,1000,1006040942,1,1,1900),(1,1000,1006040943,1,1,9500),(1,1000,1006040953,1,1,99999),(1,1000,1006040963,1,1,99999),(1,1000,1006041000,1,1,100),(1,1000,1006041010,1,1,200),(1,1000,1006041020,1,1,400),(1,1000,1006041031,1,1,500),(1,1000,1006041032,1,1,600),(1,1000,1006041041,1,1,1400),(1,1000,1006041042,1,1,2200),(1,1000,1006041043,1,1,13100),(1,1000,1006041053,1,1,99999),(1,1000,1006041063,1,1,99999),(1,1000,1006041100,1,1,100),(1,1000,1006041110,1,1,200),(1,1000,1006041120,1,1,400),(1,1000,1006041131,1,1,600),(1,1000,1006041132,1,1,700),(1,1000,1006041141,1,1,1900),(1,1000,1006041142,1,1,3100),(1,1000,1006041143,1,1,18500),(1,1000,1006041153,1,1,99999),(1,1000,1006041163,1,1,99999),(1,1000,1006041200,1,1,100),(1,1000,1006041210,1,1,300),(1,1000,1006041220,1,1,500),(1,1000,1006041231,1,1,700),(1,1000,1006041232,1,1,800),(1,1000,1006041241,1,1,2700),(1,1000,1006041242,1,1,4600),(1,1000,1006041243,1,1,27600),(1,1000,1006041253,1,1,99999),(1,1000,1006041263,1,1,99999),(1,1000,1006041300,1,1,100),(1,1000,1006041310,1,1,300),(1,1000,1006041320,1,1,500),(1,1000,1006041331,1,1,700),(1,1000,1006041332,1,1,900),(1,1000,1006041341,1,1,3300),(1,1000,1006041342,1,1,5700),(1,1000,1006041343,1,1,40400),(1,1000,1006041353,1,1,99999),(1,1000,1006041363,1,1,99999),(1,1000,1006041400,1,1,100),(1,1000,1006041410,1,1,300),(1,1000,1006041420,1,1,600),(1,1000,1006041431,1,1,800),(1,1000,1006041432,1,1,1000),(1,1000,1006041441,1,1,3900),(1,1000,1006041442,1,1,6800),(1,1000,1006041443,1,1,56700),(1,1000,1006041453,1,1,99999),(1,1000,1006041463,1,1,99999),(1,1000,1006041500,1,1,200),(1,1000,1006041510,1,1,400),(1,1000,1006041520,1,1,700),(1,1000,1006041531,1,1,900),(1,1000,1006041532,1,1,1100),(1,1000,1006041541,1,1,4300),(1,1000,1006041542,1,1,7500),(1,1000,1006041543,1,1,74900),(1,1000,1006041553,1,1,99999),(1,1000,1006041563,1,1,99999),(1,1000,1006041600,1,1,200),(1,1000,1006041610,1,1,400),(1,1000,1006041620,1,1,800),(1,1000,1006041631,1,1,1000),(1,1000,1006041632,1,1,1200),(1,1000,1006041641,1,1,5500),(1,1000,1006041642,1,1,9700),(1,1000,1006041643,1,1,96700),(1,1000,1006041653,1,1,99999),(1,1000,1006041663,1,1,99999),(1,1000,1007010100,1,1,100),(1,1000,1007010110,1,1,100),(1,1000,1007010120,1,1,100),(1,1000,1007010131,1,1,100),(1,1000,1007010132,1,1,100),(1,1000,1007010141,1,1,200),(1,1000,1007010142,1,1,200),(1,1000,1007010143,1,1,600),(1,1000,1007010153,1,1,99999),(1,1000,1007010163,1,1,99999),(1,1000,1007010200,1,1,100),(1,1000,1007010210,1,1,100),(1,1000,1007010220,1,1,100),(1,1000,1007010231,1,1,100),(1,1000,1007010232,1,1,100),(1,1000,1007010241,1,1,300),(1,1000,1007010242,1,1,400),(1,1000,1007010243,1,1,1000),(1,1000,1007010253,1,1,99999),(1,1000,1007010263,1,1,99999),(1,1000,1007010300,1,1,100),(1,1000,1007010310,1,1,100),(1,1000,1007010320,1,1,100),(1,1000,1007010331,1,1,200),(1,1000,1007010332,1,1,200),(1,1000,1007010341,1,1,400),(1,1000,1007010342,1,1,500),(1,1000,1007010343,1,1,1500),(1,1000,1007010353,1,1,99999),(1,1000,1007010363,1,1,99999),(1,1000,1007010400,1,1,100),(1,1000,1007010410,1,1,100),(1,1000,1007010420,1,1,200),(1,1000,1007010431,1,1,200),(1,1000,1007010432,1,1,300),(1,1000,1007010441,1,1,500),(1,1000,1007010442,1,1,800),(1,1000,1007010443,1,1,2200),(1,1000,1007010453,1,1,99999),(1,1000,1007010463,1,1,99999),(1,1000,1007010500,1,1,100),(1,1000,1007010510,1,1,100),(1,1000,1007010520,1,1,200),(1,1000,1007010531,1,1,300),(1,1000,1007010532,1,1,400),(1,1000,1007010541,1,1,700),(1,1000,1007010542,1,1,1100),(1,1000,1007010543,1,1,3100),(1,1000,1007010553,1,1,99999),(1,1000,1007010563,1,1,99999),(1,1000,1007010600,1,1,100),(1,1000,1007010610,1,1,200),(1,1000,1007010620,1,1,300),(1,1000,1007010631,1,1,400),(1,1000,1007010632,1,1,400),(1,1000,1007010641,1,1,800),(1,1000,1007010642,1,1,1200),(1,1000,1007010643,1,1,4400),(1,1000,1007010653,1,1,99999),(1,1000,1007010663,1,1,99999),(1,1000,1007010700,1,1,100),(1,1000,1007010710,1,1,200),(1,1000,1007010720,1,1,300),(1,1000,1007010731,1,1,400),(1,1000,1007010732,1,1,500),(1,1000,1007010741,1,1,1100),(1,1000,1007010742,1,1,1600),(1,1000,1007010743,1,1,6000),(1,1000,1007010753,1,1,99999),(1,1000,1007010763,1,1,99999),(1,1000,1007010800,1,1,100),(1,1000,1007010810,1,1,200),(1,1000,1007010820,1,1,300),(1,1000,1007010831,1,1,400),(1,1000,1007010832,1,1,500),(1,1000,1007010841,1,1,1300),(1,1000,1007010842,1,1,2000),(1,1000,1007010843,1,1,8200),(1,1000,1007010853,1,1,99999),(1,1000,1007010863,1,1,99999),(1,1000,1007010900,1,1,100),(1,1000,1007010910,1,1,200),(1,1000,1007010920,1,1,400),(1,1000,1007010931,1,1,500),(1,1000,1007010932,1,1,600),(1,1000,1007010941,1,1,1500),(1,1000,1007010942,1,1,2300),(1,1000,1007010943,1,1,11500),(1,1000,1007010953,1,1,99999),(1,1000,1007010963,1,1,99999),(1,1000,1007011000,1,1,100),(1,1000,1007011010,1,1,200),(1,1000,1007011020,1,1,400),(1,1000,1007011031,1,1,600),(1,1000,1007011032,1,1,700),(1,1000,1007011041,1,1,1700),(1,1000,1007011042,1,1,2700),(1,1000,1007011043,1,1,16000),(1,1000,1007011053,1,1,99999),(1,1000,1007011063,1,1,99999),(1,1000,1007011100,1,1,100),(1,1000,1007011110,1,1,300),(1,1000,1007011120,1,1,500),(1,1000,1007011131,1,1,700),(1,1000,1007011132,1,1,800),(1,1000,1007011141,1,1,2300),(1,1000,1007011142,1,1,3800),(1,1000,1007011143,1,1,22700),(1,1000,1007011153,1,1,99999),(1,1000,1007011163,1,1,99999),(1,1000,1007011200,1,1,100),(1,1000,1007011210,1,1,300),(1,1000,1007011220,1,1,600),(1,1000,1007011231,1,1,800),(1,1000,1007011232,1,1,1000),(1,1000,1007011241,1,1,3300),(1,1000,1007011242,1,1,5700),(1,1000,1007011243,1,1,33800),(1,1000,1007011253,1,1,99999),(1,1000,1007011263,1,1,99999),(1,1000,1007011300,1,1,100),(1,1000,1007011310,1,1,300),(1,1000,1007011320,1,1,600),(1,1000,1007011331,1,1,800),(1,1000,1007011332,1,1,1000),(1,1000,1007011341,1,1,4000),(1,1000,1007011342,1,1,7000),(1,1000,1007011343,1,1,49300),(1,1000,1007011353,1,1,99999),(1,1000,1007011363,1,1,99999),(1,1000,1007011400,1,1,200),(1,1000,1007011410,1,1,400),(1,1000,1007011420,1,1,700),(1,1000,1007011431,1,1,900),(1,1000,1007011432,1,1,1200),(1,1000,1007011441,1,1,4700),(1,1000,1007011442,1,1,8300),(1,1000,1007011443,1,1,69300),(1,1000,1007011453,1,1,99999),(1,1000,1007011463,1,1,99999),(1,1000,1007011500,1,1,200),(1,1000,1007011510,1,1,400),(1,1000,1007011520,1,1,800),(1,1000,1007011531,1,1,1100),(1,1000,1007011532,1,1,1400),(1,1000,1007011541,1,1,5300),(1,1000,1007011542,1,1,9200),(1,1000,1007011543,1,1,91500),(1,1000,1007011553,1,1,99999),(1,1000,1007011563,1,1,99999),(1,1000,1007011600,1,1,200),(1,1000,1007011610,1,1,500),(1,1000,1007011620,1,1,900),(1,1000,1007011631,1,1,1200),(1,1000,1007011632,1,1,1500),(1,1000,1007011641,1,1,6700),(1,1000,1007011642,1,1,11900),(1,1000,1007011643,1,1,99999),(1,1000,1007011653,1,1,99999),(1,1000,1007011663,1,1,99999),(1,1000,1007020100,1,1,100),(1,1000,1007020110,1,1,100),(1,1000,1007020120,1,1,100),(1,1000,1007020131,1,1,100),(1,1000,1007020132,1,1,100),(1,1000,1007020141,1,1,200),(1,1000,1007020142,1,1,200),(1,1000,1007020143,1,1,600),(1,1000,1007020153,1,1,99999),(1,1000,1007020163,1,1,99999),(1,1000,1007020200,1,1,100),(1,1000,1007020210,1,1,100),(1,1000,1007020220,1,1,100),(1,1000,1007020231,1,1,100),(1,1000,1007020232,1,1,100),(1,1000,1007020241,1,1,300),(1,1000,1007020242,1,1,400),(1,1000,1007020243,1,1,1000),(1,1000,1007020253,1,1,99999),(1,1000,1007020263,1,1,99999),(1,1000,1007020300,1,1,100),(1,1000,1007020310,1,1,100),(1,1000,1007020320,1,1,100),(1,1000,1007020331,1,1,200),(1,1000,1007020332,1,1,200),(1,1000,1007020341,1,1,400),(1,1000,1007020342,1,1,500),(1,1000,1007020343,1,1,1500),(1,1000,1007020353,1,1,99999),(1,1000,1007020363,1,1,99999),(1,1000,1007020400,1,1,100),(1,1000,1007020410,1,1,100),(1,1000,1007020420,1,1,200),(1,1000,1007020431,1,1,200),(1,1000,1007020432,1,1,300),(1,1000,1007020441,1,1,500),(1,1000,1007020442,1,1,800),(1,1000,1007020443,1,1,2200),(1,1000,1007020453,1,1,99999),(1,1000,1007020463,1,1,99999),(1,1000,1007020500,1,1,100),(1,1000,1007020510,1,1,100),(1,1000,1007020520,1,1,200),(1,1000,1007020531,1,1,300),(1,1000,1007020532,1,1,400),(1,1000,1007020541,1,1,700),(1,1000,1007020542,1,1,1100),(1,1000,1007020543,1,1,3100),(1,1000,1007020553,1,1,99999),(1,1000,1007020563,1,1,99999),(1,1000,1007020600,1,1,100),(1,1000,1007020610,1,1,200),(1,1000,1007020620,1,1,300),(1,1000,1007020631,1,1,400),(1,1000,1007020632,1,1,400),(1,1000,1007020641,1,1,800),(1,1000,1007020642,1,1,1200),(1,1000,1007020643,1,1,4400),(1,1000,1007020653,1,1,99999),(1,1000,1007020663,1,1,99999),(1,1000,1007020700,1,1,100),(1,1000,1007020710,1,1,200),(1,1000,1007020720,1,1,300),(1,1000,1007020731,1,1,400),(1,1000,1007020732,1,1,500),(1,1000,1007020741,1,1,1100),(1,1000,1007020742,1,1,1600),(1,1000,1007020743,1,1,6000),(1,1000,1007020753,1,1,99999),(1,1000,1007020763,1,1,99999),(1,1000,1007020800,1,1,100),(1,1000,1007020810,1,1,200),(1,1000,1007020820,1,1,300),(1,1000,1007020831,1,1,400),(1,1000,1007020832,1,1,500),(1,1000,1007020841,1,1,1300),(1,1000,1007020842,1,1,2000),(1,1000,1007020843,1,1,8200),(1,1000,1007020853,1,1,99999),(1,1000,1007020863,1,1,99999),(1,1000,1007020900,1,1,100),(1,1000,1007020910,1,1,200),(1,1000,1007020920,1,1,400),(1,1000,1007020931,1,1,500),(1,1000,1007020932,1,1,600),(1,1000,1007020941,1,1,1500),(1,1000,1007020942,1,1,2300),(1,1000,1007020943,1,1,11500),(1,1000,1007020953,1,1,99999),(1,1000,1007020963,1,1,99999),(1,1000,1007021000,1,1,100),(1,1000,1007021010,1,1,200),(1,1000,1007021020,1,1,400),(1,1000,1007021031,1,1,600),(1,1000,1007021032,1,1,700),(1,1000,1007021041,1,1,1700),(1,1000,1007021042,1,1,2700),(1,1000,1007021043,1,1,16000),(1,1000,1007021053,1,1,99999),(1,1000,1007021063,1,1,99999),(1,1000,1007021100,1,1,100),(1,1000,1007021110,1,1,300),(1,1000,1007021120,1,1,500),(1,1000,1007021131,1,1,700),(1,1000,1007021132,1,1,800),(1,1000,1007021141,1,1,2300),(1,1000,1007021142,1,1,3800),(1,1000,1007021143,1,1,22700),(1,1000,1007021153,1,1,99999),(1,1000,1007021163,1,1,99999),(1,1000,1007021200,1,1,100),(1,1000,1007021210,1,1,300),(1,1000,1007021220,1,1,600),(1,1000,1007021231,1,1,800),(1,1000,1007021232,1,1,1000),(1,1000,1007021241,1,1,3300),(1,1000,1007021242,1,1,5700),(1,1000,1007021243,1,1,33800),(1,1000,1007021253,1,1,99999),(1,1000,1007021263,1,1,99999),(1,1000,1007021300,1,1,100),(1,1000,1007021310,1,1,300),(1,1000,1007021320,1,1,600),(1,1000,1007021331,1,1,800),(1,1000,1007021332,1,1,1000),(1,1000,1007021341,1,1,4000),(1,1000,1007021342,1,1,7000),(1,1000,1007021343,1,1,49300),(1,1000,1007021353,1,1,99999),(1,1000,1007021363,1,1,99999),(1,1000,1007021400,1,1,200),(1,1000,1007021410,1,1,400),(1,1000,1007021420,1,1,700),(1,1000,1007021431,1,1,900),(1,1000,1007021432,1,1,1200),(1,1000,1007021441,1,1,4700),(1,1000,1007021442,1,1,8300),(1,1000,1007021443,1,1,69300),(1,1000,1007021453,1,1,99999),(1,1000,1007021463,1,1,99999),(1,1000,1007021500,1,1,200),(1,1000,1007021510,1,1,400),(1,1000,1007021520,1,1,800),(1,1000,1007021531,1,1,1100),(1,1000,1007021532,1,1,1400),(1,1000,1007021541,1,1,5300),(1,1000,1007021542,1,1,9200),(1,1000,1007021543,1,1,91500),(1,1000,1007021553,1,1,99999),(1,1000,1007021563,1,1,99999),(1,1000,1007021600,1,1,200),(1,1000,1007021610,1,1,500),(1,1000,1007021620,1,1,900),(1,1000,1007021631,1,1,1200),(1,1000,1007021632,1,1,1500),(1,1000,1007021641,1,1,6700),(1,1000,1007021642,1,1,11900),(1,1000,1007021643,1,1,99999),(1,1000,1007021653,1,1,99999),(1,1000,1007021663,1,1,99999),(1,1000,1007030100,1,1,100),(1,1000,1007030110,1,1,100),(1,1000,1007030120,1,1,100),(1,1000,1007030131,1,1,100),(1,1000,1007030132,1,1,100),(1,1000,1007030141,1,1,200),(1,1000,1007030142,1,1,200),(1,1000,1007030143,1,1,600),(1,1000,1007030153,1,1,99999),(1,1000,1007030163,1,1,99999),(1,1000,1007030200,1,1,100),(1,1000,1007030210,1,1,100),(1,1000,1007030220,1,1,100),(1,1000,1007030231,1,1,100),(1,1000,1007030232,1,1,100),(1,1000,1007030241,1,1,300),(1,1000,1007030242,1,1,400),(1,1000,1007030243,1,1,1000),(1,1000,1007030253,1,1,99999),(1,1000,1007030263,1,1,99999),(1,1000,1007030300,1,1,100),(1,1000,1007030310,1,1,100),(1,1000,1007030320,1,1,100),(1,1000,1007030331,1,1,200),(1,1000,1007030332,1,1,200),(1,1000,1007030341,1,1,400),(1,1000,1007030342,1,1,500),(1,1000,1007030343,1,1,1500),(1,1000,1007030353,1,1,99999),(1,1000,1007030363,1,1,99999),(1,1000,1007030400,1,1,100),(1,1000,1007030410,1,1,100),(1,1000,1007030420,1,1,200),(1,1000,1007030431,1,1,200),(1,1000,1007030432,1,1,300),(1,1000,1007030441,1,1,500),(1,1000,1007030442,1,1,800),(1,1000,1007030443,1,1,2200),(1,1000,1007030453,1,1,99999),(1,1000,1007030463,1,1,99999),(1,1000,1007030500,1,1,100),(1,1000,1007030510,1,1,100),(1,1000,1007030520,1,1,200),(1,1000,1007030531,1,1,300),(1,1000,1007030532,1,1,400),(1,1000,1007030541,1,1,700),(1,1000,1007030542,1,1,1100),(1,1000,1007030543,1,1,3100),(1,1000,1007030553,1,1,99999),(1,1000,1007030563,1,1,99999),(1,1000,1007030600,1,1,100),(1,1000,1007030610,1,1,200),(1,1000,1007030620,1,1,300),(1,1000,1007030631,1,1,400),(1,1000,1007030632,1,1,400),(1,1000,1007030641,1,1,800),(1,1000,1007030642,1,1,1200),(1,1000,1007030643,1,1,4400),(1,1000,1007030653,1,1,99999),(1,1000,1007030663,1,1,99999),(1,1000,1007030700,1,1,100),(1,1000,1007030710,1,1,200),(1,1000,1007030720,1,1,300),(1,1000,1007030731,1,1,400),(1,1000,1007030732,1,1,500),(1,1000,1007030741,1,1,1100),(1,1000,1007030742,1,1,1600),(1,1000,1007030743,1,1,6000),(1,1000,1007030753,1,1,99999),(1,1000,1007030763,1,1,99999),(1,1000,1007030800,1,1,100),(1,1000,1007030810,1,1,200),(1,1000,1007030820,1,1,300),(1,1000,1007030831,1,1,400),(1,1000,1007030832,1,1,500),(1,1000,1007030841,1,1,1300),(1,1000,1007030842,1,1,2000),(1,1000,1007030843,1,1,8200),(1,1000,1007030853,1,1,99999),(1,1000,1007030863,1,1,99999),(1,1000,1007030900,1,1,100),(1,1000,1007030910,1,1,200),(1,1000,1007030920,1,1,400),(1,1000,1007030931,1,1,500),(1,1000,1007030932,1,1,600),(1,1000,1007030941,1,1,1500),(1,1000,1007030942,1,1,2300),(1,1000,1007030943,1,1,11500),(1,1000,1007030953,1,1,99999),(1,1000,1007030963,1,1,99999),(1,1000,1007031000,1,1,100),(1,1000,1007031010,1,1,200),(1,1000,1007031020,1,1,400),(1,1000,1007031031,1,1,600),(1,1000,1007031032,1,1,700),(1,1000,1007031041,1,1,1700),(1,1000,1007031042,1,1,2700),(1,1000,1007031043,1,1,16000),(1,1000,1007031053,1,1,99999),(1,1000,1007031063,1,1,99999),(1,1000,1007031100,1,1,100),(1,1000,1007031110,1,1,300),(1,1000,1007031120,1,1,500),(1,1000,1007031131,1,1,700),(1,1000,1007031132,1,1,800),(1,1000,1007031141,1,1,2300),(1,1000,1007031142,1,1,3800),(1,1000,1007031143,1,1,22700),(1,1000,1007031153,1,1,99999),(1,1000,1007031163,1,1,99999),(1,1000,1007031200,1,1,100),(1,1000,1007031210,1,1,300),(1,1000,1007031220,1,1,600),(1,1000,1007031231,1,1,800),(1,1000,1007031232,1,1,1000),(1,1000,1007031241,1,1,3300),(1,1000,1007031242,1,1,5700),(1,1000,1007031243,1,1,33800),(1,1000,1007031253,1,1,99999),(1,1000,1007031263,1,1,99999),(1,1000,1007031300,1,1,100),(1,1000,1007031310,1,1,300),(1,1000,1007031320,1,1,600),(1,1000,1007031331,1,1,800),(1,1000,1007031332,1,1,1000),(1,1000,1007031341,1,1,4000),(1,1000,1007031342,1,1,7000),(1,1000,1007031343,1,1,49300),(1,1000,1007031353,1,1,99999),(1,1000,1007031363,1,1,99999),(1,1000,1007031400,1,1,200),(1,1000,1007031410,1,1,400),(1,1000,1007031420,1,1,700),(1,1000,1007031431,1,1,900),(1,1000,1007031432,1,1,1200),(1,1000,1007031441,1,1,4700),(1,1000,1007031442,1,1,8300),(1,1000,1007031443,1,1,69300),(1,1000,1007031453,1,1,99999),(1,1000,1007031463,1,1,99999),(1,1000,1007031500,1,1,200),(1,1000,1007031510,1,1,400),(1,1000,1007031520,1,1,800),(1,1000,1007031531,1,1,1100),(1,1000,1007031532,1,1,1400),(1,1000,1007031541,1,1,5300),(1,1000,1007031542,1,1,9200),(1,1000,1007031543,1,1,91500),(1,1000,1007031553,1,1,99999),(1,1000,1007031563,1,1,99999),(1,1000,1007031600,1,1,200),(1,1000,1007031610,1,1,500),(1,1000,1007031620,1,1,900),(1,1000,1007031631,1,1,1200),(1,1000,1007031632,1,1,1500),(1,1000,1007031641,1,1,6700),(1,1000,1007031642,1,1,11900),(1,1000,1007031643,1,1,99999),(1,1000,1007031653,1,1,99999),(1,1000,1007031663,1,1,99999),(1,1000,1007040100,1,1,100),(1,1000,1007040110,1,1,100),(1,1000,1007040120,1,1,100),(1,1000,1007040131,1,1,100),(1,1000,1007040132,1,1,100),(1,1000,1007040141,1,1,200),(1,1000,1007040142,1,1,200),(1,1000,1007040143,1,1,600),(1,1000,1007040153,1,1,99999),(1,1000,1007040163,1,1,99999),(1,1000,1007040200,1,1,100),(1,1000,1007040210,1,1,100),(1,1000,1007040220,1,1,100),(1,1000,1007040231,1,1,100),(1,1000,1007040232,1,1,100),(1,1000,1007040241,1,1,300),(1,1000,1007040242,1,1,400),(1,1000,1007040243,1,1,1000),(1,1000,1007040253,1,1,99999),(1,1000,1007040263,1,1,99999),(1,1000,1007040300,1,1,100),(1,1000,1007040310,1,1,100),(1,1000,1007040320,1,1,100),(1,1000,1007040331,1,1,200),(1,1000,1007040332,1,1,200),(1,1000,1007040341,1,1,400),(1,1000,1007040342,1,1,500),(1,1000,1007040343,1,1,1500),(1,1000,1007040353,1,1,99999),(1,1000,1007040363,1,1,99999),(1,1000,1007040400,1,1,100),(1,1000,1007040410,1,1,100),(1,1000,1007040420,1,1,200),(1,1000,1007040431,1,1,200),(1,1000,1007040432,1,1,300),(1,1000,1007040441,1,1,500),(1,1000,1007040442,1,1,800),(1,1000,1007040443,1,1,2200),(1,1000,1007040453,1,1,99999),(1,1000,1007040463,1,1,99999),(1,1000,1007040500,1,1,100),(1,1000,1007040510,1,1,100),(1,1000,1007040520,1,1,200),(1,1000,1007040531,1,1,300),(1,1000,1007040532,1,1,400),(1,1000,1007040541,1,1,700),(1,1000,1007040542,1,1,1100),(1,1000,1007040543,1,1,3100),(1,1000,1007040553,1,1,99999),(1,1000,1007040563,1,1,99999),(1,1000,1007040600,1,1,100),(1,1000,1007040610,1,1,200),(1,1000,1007040620,1,1,300),(1,1000,1007040631,1,1,400),(1,1000,1007040632,1,1,400),(1,1000,1007040641,1,1,800),(1,1000,1007040642,1,1,1200),(1,1000,1007040643,1,1,4400),(1,1000,1007040653,1,1,99999),(1,1000,1007040663,1,1,99999),(1,1000,1007040700,1,1,100),(1,1000,1007040710,1,1,200),(1,1000,1007040720,1,1,300),(1,1000,1007040731,1,1,400),(1,1000,1007040732,1,1,500),(1,1000,1007040741,1,1,1100),(1,1000,1007040742,1,1,1600),(1,1000,1007040743,1,1,6000),(1,1000,1007040753,1,1,99999),(1,1000,1007040763,1,1,99999),(1,1000,1007040800,1,1,100),(1,1000,1007040810,1,1,200),(1,1000,1007040820,1,1,300),(1,1000,1007040831,1,1,400),(1,1000,1007040832,1,1,500),(1,1000,1007040841,1,1,1300),(1,1000,1007040842,1,1,2000),(1,1000,1007040843,1,1,8200),(1,1000,1007040853,1,1,99999),(1,1000,1007040863,1,1,99999),(1,1000,1007040900,1,1,100),(1,1000,1007040910,1,1,200),(1,1000,1007040920,1,1,400),(1,1000,1007040931,1,1,500),(1,1000,1007040932,1,1,600),(1,1000,1007040941,1,1,1500),(1,1000,1007040942,1,1,2300),(1,1000,1007040943,1,1,11500),(1,1000,1007040953,1,1,99999),(1,1000,1007040963,1,1,99999),(1,1000,1007041000,1,1,100),(1,1000,1007041010,1,1,200),(1,1000,1007041020,1,1,400),(1,1000,1007041031,1,1,600),(1,1000,1007041032,1,1,700),(1,1000,1007041041,1,1,1700),(1,1000,1007041042,1,1,2700),(1,1000,1007041043,1,1,16000),(1,1000,1007041053,1,1,99999),(1,1000,1007041063,1,1,99999),(1,1000,1007041100,1,1,100),(1,1000,1007041110,1,1,300),(1,1000,1007041120,1,1,500),(1,1000,1007041131,1,1,700),(1,1000,1007041132,1,1,800),(1,1000,1007041141,1,1,2300),(1,1000,1007041142,1,1,3800),(1,1000,1007041143,1,1,22700),(1,1000,1007041153,1,1,99999),(1,1000,1007041163,1,1,99999),(1,1000,1007041200,1,1,100),(1,1000,1007041210,1,1,300),(1,1000,1007041220,1,1,600),(1,1000,1007041231,1,1,800),(1,1000,1007041232,1,1,1000),(1,1000,1007041241,1,1,3300),(1,1000,1007041242,1,1,5700),(1,1000,1007041243,1,1,33800),(1,1000,1007041253,1,1,99999),(1,1000,1007041263,1,1,99999),(1,1000,1007041300,1,1,100),(1,1000,1007041310,1,1,300),(1,1000,1007041320,1,1,600),(1,1000,1007041331,1,1,800),(1,1000,1007041332,1,1,1000),(1,1000,1007041341,1,1,4000),(1,1000,1007041342,1,1,7000),(1,1000,1007041343,1,1,49300),(1,1000,1007041353,1,1,99999),(1,1000,1007041363,1,1,99999),(1,1000,1007041400,1,1,200),(1,1000,1007041410,1,1,400),(1,1000,1007041420,1,1,700),(1,1000,1007041431,1,1,900),(1,1000,1007041432,1,1,1200),(1,1000,1007041441,1,1,4700),(1,1000,1007041442,1,1,8300),(1,1000,1007041443,1,1,69300),(1,1000,1007041453,1,1,99999),(1,1000,1007041463,1,1,99999),(1,1000,1007041500,1,1,200),(1,1000,1007041510,1,1,400),(1,1000,1007041520,1,1,800),(1,1000,1007041531,1,1,1100),(1,1000,1007041532,1,1,1400),(1,1000,1007041541,1,1,5300),(1,1000,1007041542,1,1,9200),(1,1000,1007041543,1,1,91500),(1,1000,1007041553,1,1,99999),(1,1000,1007041563,1,1,99999),(1,1000,1007041600,1,1,200),(1,1000,1007041610,1,1,500),(1,1000,1007041620,1,1,900),(1,1000,1007041631,1,1,1200),(1,1000,1007041632,1,1,1500),(1,1000,1007041641,1,1,6700),(1,1000,1007041642,1,1,11900),(1,1000,1007041643,1,1,99999),(1,1000,1007041653,1,1,99999),(1,1000,1007041663,1,1,99999),(1,1000,1008010100,1,1,100),(1,1000,1008010110,1,1,100),(1,1000,1008010120,1,1,100),(1,1000,1008010131,1,1,100),(1,1000,1008010132,1,1,100),(1,1000,1008010141,1,1,200),(1,1000,1008010142,1,1,200),(1,1000,1008010143,1,1,500),(1,1000,1008010153,1,1,99999),(1,1000,1008010163,1,1,99999),(1,1000,1008010200,1,1,100),(1,1000,1008010210,1,1,100),(1,1000,1008010220,1,1,100),(1,1000,1008010231,1,1,100),(1,1000,1008010232,1,1,100),(1,1000,1008010241,1,1,200),(1,1000,1008010242,1,1,300),(1,1000,1008010243,1,1,800),(1,1000,1008010253,1,1,99999),(1,1000,1008010263,1,1,99999),(1,1000,1008010300,1,1,100),(1,1000,1008010310,1,1,100),(1,1000,1008010320,1,1,100),(1,1000,1008010331,1,1,200),(1,1000,1008010332,1,1,200),(1,1000,1008010341,1,1,300),(1,1000,1008010342,1,1,500),(1,1000,1008010343,1,1,1300),(1,1000,1008010353,1,1,99999),(1,1000,1008010363,1,1,99999),(1,1000,1008010400,1,1,100),(1,1000,1008010410,1,1,100),(1,1000,1008010420,1,1,200),(1,1000,1008010431,1,1,200),(1,1000,1008010432,1,1,200),(1,1000,1008010441,1,1,400),(1,1000,1008010442,1,1,600),(1,1000,1008010443,1,1,1800),(1,1000,1008010453,1,1,99999),(1,1000,1008010463,1,1,99999),(1,1000,1008010500,1,1,100),(1,1000,1008010510,1,1,100),(1,1000,1008010520,1,1,200),(1,1000,1008010531,1,1,200),(1,1000,1008010532,1,1,300),(1,1000,1008010541,1,1,600),(1,1000,1008010542,1,1,900),(1,1000,1008010543,1,1,2500),(1,1000,1008010553,1,1,99999),(1,1000,1008010563,1,1,99999),(1,1000,1008010600,1,1,100),(1,1000,1008010610,1,1,100),(1,1000,1008010620,1,1,200),(1,1000,1008010631,1,1,300),(1,1000,1008010632,1,1,400),(1,1000,1008010641,1,1,700),(1,1000,1008010642,1,1,1000),(1,1000,1008010643,1,1,3600),(1,1000,1008010653,1,1,99999),(1,1000,1008010663,1,1,99999),(1,1000,1008010700,1,1,100),(1,1000,1008010710,1,1,200),(1,1000,1008010720,1,1,300),(1,1000,1008010731,1,1,300),(1,1000,1008010732,1,1,400),(1,1000,1008010741,1,1,900),(1,1000,1008010742,1,1,1300),(1,1000,1008010743,1,1,4900),(1,1000,1008010753,1,1,99999),(1,1000,1008010763,1,1,99999),(1,1000,1008010800,1,1,100),(1,1000,1008010810,1,1,200),(1,1000,1008010820,1,1,300),(1,1000,1008010831,1,1,400),(1,1000,1008010832,1,1,500),(1,1000,1008010841,1,1,1000),(1,1000,1008010842,1,1,1600),(1,1000,1008010843,1,1,6700),(1,1000,1008010853,1,1,99999),(1,1000,1008010863,1,1,99999),(1,1000,1008010900,1,1,100),(1,1000,1008010910,1,1,200),(1,1000,1008010920,1,1,300),(1,1000,1008010931,1,1,400),(1,1000,1008010932,1,1,500),(1,1000,1008010941,1,1,1200),(1,1000,1008010942,1,1,1900),(1,1000,1008010943,1,1,9500),(1,1000,1008010953,1,1,99999),(1,1000,1008010963,1,1,99999),(1,1000,1008011000,1,1,100),(1,1000,1008011010,1,1,200),(1,1000,1008011020,1,1,400),(1,1000,1008011031,1,1,500),(1,1000,1008011032,1,1,600),(1,1000,1008011041,1,1,1400),(1,1000,1008011042,1,1,2200),(1,1000,1008011043,1,1,13100),(1,1000,1008011053,1,1,99999),(1,1000,1008011063,1,1,99999),(1,1000,1008011100,1,1,100),(1,1000,1008011110,1,1,200),(1,1000,1008011120,1,1,400),(1,1000,1008011131,1,1,600),(1,1000,1008011132,1,1,700),(1,1000,1008011141,1,1,1900),(1,1000,1008011142,1,1,3100),(1,1000,1008011143,1,1,18500),(1,1000,1008011153,1,1,99999),(1,1000,1008011163,1,1,99999),(1,1000,1008011200,1,1,100),(1,1000,1008011210,1,1,300),(1,1000,1008011220,1,1,500),(1,1000,1008011231,1,1,700),(1,1000,1008011232,1,1,800),(1,1000,1008011241,1,1,2700),(1,1000,1008011242,1,1,4600),(1,1000,1008011243,1,1,27600),(1,1000,1008011253,1,1,99999),(1,1000,1008011263,1,1,99999),(1,1000,1008011300,1,1,100),(1,1000,1008011310,1,1,300),(1,1000,1008011320,1,1,500),(1,1000,1008011331,1,1,700),(1,1000,1008011332,1,1,900),(1,1000,1008011341,1,1,3300),(1,1000,1008011342,1,1,5700),(1,1000,1008011343,1,1,40400),(1,1000,1008011353,1,1,99999),(1,1000,1008011363,1,1,99999),(1,1000,1008011400,1,1,100),(1,1000,1008011410,1,1,300),(1,1000,1008011420,1,1,600),(1,1000,1008011431,1,1,800),(1,1000,1008011432,1,1,1000),(1,1000,1008011441,1,1,3900),(1,1000,1008011442,1,1,6800),(1,1000,1008011443,1,1,56700),(1,1000,1008011453,1,1,99999),(1,1000,1008011463,1,1,99999),(1,1000,1008011500,1,1,200),(1,1000,1008011510,1,1,400),(1,1000,1008011520,1,1,700),(1,1000,1008011531,1,1,900),(1,1000,1008011532,1,1,1100),(1,1000,1008011541,1,1,4300),(1,1000,1008011542,1,1,7500),(1,1000,1008011543,1,1,74900),(1,1000,1008011553,1,1,99999),(1,1000,1008011563,1,1,99999),(1,1000,1008011600,1,1,200),(1,1000,1008011610,1,1,400),(1,1000,1008011620,1,1,800),(1,1000,1008011631,1,1,1000),(1,1000,1008011632,1,1,1200),(1,1000,1008011641,1,1,5500),(1,1000,1008011642,1,1,9700),(1,1000,1008011643,1,1,96700),(1,1000,1008011653,1,1,99999),(1,1000,1008011663,1,1,99999),(1,1000,1008020100,1,1,100),(1,1000,1008020110,1,1,100),(1,1000,1008020120,1,1,100),(1,1000,1008020131,1,1,100),(1,1000,1008020132,1,1,100),(1,1000,1008020141,1,1,200),(1,1000,1008020142,1,1,200),(1,1000,1008020143,1,1,500),(1,1000,1008020153,1,1,99999),(1,1000,1008020163,1,1,99999),(1,1000,1008020200,1,1,100),(1,1000,1008020210,1,1,100),(1,1000,1008020220,1,1,100),(1,1000,1008020231,1,1,100),(1,1000,1008020232,1,1,100),(1,1000,1008020241,1,1,200),(1,1000,1008020242,1,1,300),(1,1000,1008020243,1,1,800),(1,1000,1008020253,1,1,99999),(1,1000,1008020263,1,1,99999),(1,1000,1008020300,1,1,100),(1,1000,1008020310,1,1,100),(1,1000,1008020320,1,1,100),(1,1000,1008020331,1,1,200),(1,1000,1008020332,1,1,200),(1,1000,1008020341,1,1,300),(1,1000,1008020342,1,1,500),(1,1000,1008020343,1,1,1300),(1,1000,1008020353,1,1,99999),(1,1000,1008020363,1,1,99999),(1,1000,1008020400,1,1,100),(1,1000,1008020410,1,1,100),(1,1000,1008020420,1,1,200),(1,1000,1008020431,1,1,200),(1,1000,1008020432,1,1,200),(1,1000,1008020441,1,1,400),(1,1000,1008020442,1,1,600),(1,1000,1008020443,1,1,1800),(1,1000,1008020453,1,1,99999),(1,1000,1008020463,1,1,99999),(1,1000,1008020500,1,1,100),(1,1000,1008020510,1,1,100),(1,1000,1008020520,1,1,200),(1,1000,1008020531,1,1,200),(1,1000,1008020532,1,1,300),(1,1000,1008020541,1,1,600),(1,1000,1008020542,1,1,900),(1,1000,1008020543,1,1,2500),(1,1000,1008020553,1,1,99999),(1,1000,1008020563,1,1,99999),(1,1000,1008020600,1,1,100),(1,1000,1008020610,1,1,100),(1,1000,1008020620,1,1,200),(1,1000,1008020631,1,1,300),(1,1000,1008020632,1,1,400),(1,1000,1008020641,1,1,700),(1,1000,1008020642,1,1,1000),(1,1000,1008020643,1,1,3600),(1,1000,1008020653,1,1,99999),(1,1000,1008020663,1,1,99999),(1,1000,1008020700,1,1,100),(1,1000,1008020710,1,1,200),(1,1000,1008020720,1,1,300),(1,1000,1008020731,1,1,300),(1,1000,1008020732,1,1,400),(1,1000,1008020741,1,1,900),(1,1000,1008020742,1,1,1300),(1,1000,1008020743,1,1,4900),(1,1000,1008020753,1,1,99999),(1,1000,1008020763,1,1,99999),(1,1000,1008020800,1,1,100),(1,1000,1008020810,1,1,200),(1,1000,1008020820,1,1,300),(1,1000,1008020831,1,1,400),(1,1000,1008020832,1,1,500),(1,1000,1008020841,1,1,1000),(1,1000,1008020842,1,1,1600),(1,1000,1008020843,1,1,6700),(1,1000,1008020853,1,1,99999),(1,1000,1008020863,1,1,99999),(1,1000,1008020900,1,1,100),(1,1000,1008020910,1,1,200),(1,1000,1008020920,1,1,300),(1,1000,1008020931,1,1,400),(1,1000,1008020932,1,1,500),(1,1000,1008020941,1,1,1200),(1,1000,1008020942,1,1,1900),(1,1000,1008020943,1,1,9500),(1,1000,1008020953,1,1,99999),(1,1000,1008020963,1,1,99999),(1,1000,1008021000,1,1,100),(1,1000,1008021010,1,1,200),(1,1000,1008021020,1,1,400),(1,1000,1008021031,1,1,500),(1,1000,1008021032,1,1,600),(1,1000,1008021041,1,1,1400),(1,1000,1008021042,1,1,2200),(1,1000,1008021043,1,1,13100),(1,1000,1008021053,1,1,99999),(1,1000,1008021063,1,1,99999),(1,1000,1008021100,1,1,100),(1,1000,1008021110,1,1,200),(1,1000,1008021120,1,1,400),(1,1000,1008021131,1,1,600),(1,1000,1008021132,1,1,700),(1,1000,1008021141,1,1,1900),(1,1000,1008021142,1,1,3100),(1,1000,1008021143,1,1,18500),(1,1000,1008021153,1,1,99999),(1,1000,1008021163,1,1,99999),(1,1000,1008021200,1,1,100),(1,1000,1008021210,1,1,300),(1,1000,1008021220,1,1,500),(1,1000,1008021231,1,1,700),(1,1000,1008021232,1,1,800),(1,1000,1008021241,1,1,2700),(1,1000,1008021242,1,1,4600),(1,1000,1008021243,1,1,27600),(1,1000,1008021253,1,1,99999),(1,1000,1008021263,1,1,99999),(1,1000,1008021300,1,1,100),(1,1000,1008021310,1,1,300),(1,1000,1008021320,1,1,500),(1,1000,1008021331,1,1,700),(1,1000,1008021332,1,1,900),(1,1000,1008021341,1,1,3300),(1,1000,1008021342,1,1,5700),(1,1000,1008021343,1,1,40400),(1,1000,1008021353,1,1,99999),(1,1000,1008021363,1,1,99999),(1,1000,1008021400,1,1,100),(1,1000,1008021410,1,1,300),(1,1000,1008021420,1,1,600),(1,1000,1008021431,1,1,800),(1,1000,1008021432,1,1,1000),(1,1000,1008021441,1,1,3900),(1,1000,1008021442,1,1,6800),(1,1000,1008021443,1,1,56700),(1,1000,1008021453,1,1,99999),(1,1000,1008021463,1,1,99999),(1,1000,1008021500,1,1,200),(1,1000,1008021510,1,1,400),(1,1000,1008021520,1,1,700),(1,1000,1008021531,1,1,900),(1,1000,1008021532,1,1,1100),(1,1000,1008021541,1,1,4300),(1,1000,1008021542,1,1,7500),(1,1000,1008021543,1,1,74900),(1,1000,1008021553,1,1,99999),(1,1000,1008021563,1,1,99999),(1,1000,1008021600,1,1,200),(1,1000,1008021610,1,1,400),(1,1000,1008021620,1,1,800),(1,1000,1008021631,1,1,1000),(1,1000,1008021632,1,1,1200),(1,1000,1008021641,1,1,5500),(1,1000,1008021642,1,1,9700),(1,1000,1008021643,1,1,96700),(1,1000,1008021653,1,1,99999),(1,1000,1008021663,1,1,99999),(1,1000,1008030100,1,1,100),(1,1000,1008030110,1,1,100),(1,1000,1008030120,1,1,100),(1,1000,1008030131,1,1,100),(1,1000,1008030132,1,1,100),(1,1000,1008030141,1,1,200),(1,1000,1008030142,1,1,200),(1,1000,1008030143,1,1,500),(1,1000,1008030153,1,1,99999),(1,1000,1008030163,1,1,99999),(1,1000,1008030200,1,1,100),(1,1000,1008030210,1,1,100),(1,1000,1008030220,1,1,100),(1,1000,1008030231,1,1,100),(1,1000,1008030232,1,1,100),(1,1000,1008030241,1,1,200),(1,1000,1008030242,1,1,300),(1,1000,1008030243,1,1,800),(1,1000,1008030253,1,1,99999),(1,1000,1008030263,1,1,99999),(1,1000,1008030300,1,1,100),(1,1000,1008030310,1,1,100),(1,1000,1008030320,1,1,100),(1,1000,1008030331,1,1,200),(1,1000,1008030332,1,1,200),(1,1000,1008030341,1,1,300),(1,1000,1008030342,1,1,500),(1,1000,1008030343,1,1,1300),(1,1000,1008030353,1,1,99999),(1,1000,1008030363,1,1,99999),(1,1000,1008030400,1,1,100),(1,1000,1008030410,1,1,100),(1,1000,1008030420,1,1,200),(1,1000,1008030431,1,1,200),(1,1000,1008030432,1,1,200),(1,1000,1008030441,1,1,400),(1,1000,1008030442,1,1,600),(1,1000,1008030443,1,1,1800),(1,1000,1008030453,1,1,99999),(1,1000,1008030463,1,1,99999),(1,1000,1008030500,1,1,100),(1,1000,1008030510,1,1,100),(1,1000,1008030520,1,1,200),(1,1000,1008030531,1,1,200),(1,1000,1008030532,1,1,300),(1,1000,1008030541,1,1,600),(1,1000,1008030542,1,1,900),(1,1000,1008030543,1,1,2500),(1,1000,1008030553,1,1,99999),(1,1000,1008030563,1,1,99999),(1,1000,1008030600,1,1,100),(1,1000,1008030610,1,1,100),(1,1000,1008030620,1,1,200),(1,1000,1008030631,1,1,300),(1,1000,1008030632,1,1,400),(1,1000,1008030641,1,1,700),(1,1000,1008030642,1,1,1000),(1,1000,1008030643,1,1,3600),(1,1000,1008030653,1,1,99999),(1,1000,1008030663,1,1,99999),(1,1000,1008030700,1,1,100),(1,1000,1008030710,1,1,200),(1,1000,1008030720,1,1,300),(1,1000,1008030731,1,1,300),(1,1000,1008030732,1,1,400),(1,1000,1008030741,1,1,900),(1,1000,1008030742,1,1,1300),(1,1000,1008030743,1,1,4900),(1,1000,1008030753,1,1,99999),(1,1000,1008030763,1,1,99999),(1,1000,1008030800,1,1,100),(1,1000,1008030810,1,1,200),(1,1000,1008030820,1,1,300),(1,1000,1008030831,1,1,400),(1,1000,1008030832,1,1,500),(1,1000,1008030841,1,1,1000),(1,1000,1008030842,1,1,1600),(1,1000,1008030843,1,1,6700),(1,1000,1008030853,1,1,99999),(1,1000,1008030863,1,1,99999),(1,1000,1008030900,1,1,100),(1,1000,1008030910,1,1,200),(1,1000,1008030920,1,1,300),(1,1000,1008030931,1,1,400),(1,1000,1008030932,1,1,500),(1,1000,1008030941,1,1,1200),(1,1000,1008030942,1,1,1900),(1,1000,1008030943,1,1,9500),(1,1000,1008030953,1,1,99999),(1,1000,1008030963,1,1,99999),(1,1000,1008031000,1,1,100),(1,1000,1008031010,1,1,200),(1,1000,1008031020,1,1,400),(1,1000,1008031031,1,1,500),(1,1000,1008031032,1,1,600),(1,1000,1008031041,1,1,1400),(1,1000,1008031042,1,1,2200),(1,1000,1008031043,1,1,13100),(1,1000,1008031053,1,1,99999),(1,1000,1008031063,1,1,99999),(1,1000,1008031100,1,1,100),(1,1000,1008031110,1,1,200),(1,1000,1008031120,1,1,400),(1,1000,1008031131,1,1,600),(1,1000,1008031132,1,1,700),(1,1000,1008031141,1,1,1900),(1,1000,1008031142,1,1,3100),(1,1000,1008031143,1,1,18500),(1,1000,1008031153,1,1,99999),(1,1000,1008031163,1,1,99999),(1,1000,1008031200,1,1,100),(1,1000,1008031210,1,1,300),(1,1000,1008031220,1,1,500),(1,1000,1008031231,1,1,700),(1,1000,1008031232,1,1,800),(1,1000,1008031241,1,1,2700),(1,1000,1008031242,1,1,4600),(1,1000,1008031243,1,1,27600),(1,1000,1008031253,1,1,99999),(1,1000,1008031263,1,1,99999),(1,1000,1008031300,1,1,100),(1,1000,1008031310,1,1,300),(1,1000,1008031320,1,1,500),(1,1000,1008031331,1,1,700),(1,1000,1008031332,1,1,900),(1,1000,1008031341,1,1,3300),(1,1000,1008031342,1,1,5700),(1,1000,1008031343,1,1,40400),(1,1000,1008031353,1,1,99999),(1,1000,1008031363,1,1,99999),(1,1000,1008031400,1,1,100),(1,1000,1008031410,1,1,300),(1,1000,1008031420,1,1,600),(1,1000,1008031431,1,1,800),(1,1000,1008031432,1,1,1000),(1,1000,1008031441,1,1,3900),(1,1000,1008031442,1,1,6800),(1,1000,1008031443,1,1,56700),(1,1000,1008031453,1,1,99999),(1,1000,1008031463,1,1,99999),(1,1000,1008031500,1,1,200),(1,1000,1008031510,1,1,400),(1,1000,1008031520,1,1,700),(1,1000,1008031531,1,1,900),(1,1000,1008031532,1,1,1100),(1,1000,1008031541,1,1,4300),(1,1000,1008031542,1,1,7500),(1,1000,1008031543,1,1,74900),(1,1000,1008031553,1,1,99999),(1,1000,1008031563,1,1,99999),(1,1000,1008031600,1,1,200),(1,1000,1008031610,1,1,400),(1,1000,1008031620,1,1,800),(1,1000,1008031631,1,1,1000),(1,1000,1008031632,1,1,1200),(1,1000,1008031641,1,1,5500),(1,1000,1008031642,1,1,9700),(1,1000,1008031643,1,1,96700),(1,1000,1008031653,1,1,99999),(1,1000,1008031663,1,1,99999),(1,1000,1008040100,1,1,100),(1,1000,1008040110,1,1,100),(1,1000,1008040120,1,1,100),(1,1000,1008040131,1,1,100),(1,1000,1008040132,1,1,100),(1,1000,1008040141,1,1,200),(1,1000,1008040142,1,1,200),(1,1000,1008040143,1,1,500),(1,1000,1008040153,1,1,99999),(1,1000,1008040163,1,1,99999),(1,1000,1008040200,1,1,100),(1,1000,1008040210,1,1,100),(1,1000,1008040220,1,1,100),(1,1000,1008040231,1,1,100),(1,1000,1008040232,1,1,100),(1,1000,1008040241,1,1,200),(1,1000,1008040242,1,1,300),(1,1000,1008040243,1,1,800),(1,1000,1008040253,1,1,99999),(1,1000,1008040263,1,1,99999),(1,1000,1008040300,1,1,100),(1,1000,1008040310,1,1,100),(1,1000,1008040320,1,1,100),(1,1000,1008040331,1,1,200),(1,1000,1008040332,1,1,200),(1,1000,1008040341,1,1,300),(1,1000,1008040342,1,1,500),(1,1000,1008040343,1,1,1300),(1,1000,1008040353,1,1,99999),(1,1000,1008040363,1,1,99999),(1,1000,1008040400,1,1,100),(1,1000,1008040410,1,1,100),(1,1000,1008040420,1,1,200),(1,1000,1008040431,1,1,200),(1,1000,1008040432,1,1,200),(1,1000,1008040441,1,1,400),(1,1000,1008040442,1,1,600),(1,1000,1008040443,1,1,1800),(1,1000,1008040453,1,1,99999),(1,1000,1008040463,1,1,99999),(1,1000,1008040500,1,1,100),(1,1000,1008040510,1,1,100),(1,1000,1008040520,1,1,200),(1,1000,1008040531,1,1,200),(1,1000,1008040532,1,1,300),(1,1000,1008040541,1,1,600),(1,1000,1008040542,1,1,900),(1,1000,1008040543,1,1,2500),(1,1000,1008040553,1,1,99999),(1,1000,1008040563,1,1,99999),(1,1000,1008040600,1,1,100),(1,1000,1008040610,1,1,100),(1,1000,1008040620,1,1,200),(1,1000,1008040631,1,1,300),(1,1000,1008040632,1,1,400),(1,1000,1008040641,1,1,700),(1,1000,1008040642,1,1,1000),(1,1000,1008040643,1,1,3600),(1,1000,1008040653,1,1,99999),(1,1000,1008040663,1,1,99999),(1,1000,1008040700,1,1,100),(1,1000,1008040710,1,1,200),(1,1000,1008040720,1,1,300),(1,1000,1008040731,1,1,300),(1,1000,1008040732,1,1,400),(1,1000,1008040741,1,1,900),(1,1000,1008040742,1,1,1300),(1,1000,1008040743,1,1,4900),(1,1000,1008040753,1,1,99999),(1,1000,1008040763,1,1,99999),(1,1000,1008040800,1,1,100),(1,1000,1008040810,1,1,200),(1,1000,1008040820,1,1,300),(1,1000,1008040831,1,1,400),(1,1000,1008040832,1,1,500),(1,1000,1008040841,1,1,1000),(1,1000,1008040842,1,1,1600),(1,1000,1008040843,1,1,6700),(1,1000,1008040853,1,1,99999),(1,1000,1008040863,1,1,99999),(1,1000,1008040900,1,1,100),(1,1000,1008040910,1,1,200),(1,1000,1008040920,1,1,300),(1,1000,1008040931,1,1,400),(1,1000,1008040932,1,1,500),(1,1000,1008040941,1,1,1200),(1,1000,1008040942,1,1,1900),(1,1000,1008040943,1,1,9500),(1,1000,1008040953,1,1,99999),(1,1000,1008040963,1,1,99999),(1,1000,1008041000,1,1,100),(1,1000,1008041010,1,1,200),(1,1000,1008041020,1,1,400),(1,1000,1008041031,1,1,500),(1,1000,1008041032,1,1,600),(1,1000,1008041041,1,1,1400),(1,1000,1008041042,1,1,2200),(1,1000,1008041043,1,1,13100),(1,1000,1008041053,1,1,99999),(1,1000,1008041063,1,1,99999),(1,1000,1008041100,1,1,100),(1,1000,1008041110,1,1,200),(1,1000,1008041120,1,1,400),(1,1000,1008041131,1,1,600),(1,1000,1008041132,1,1,700),(1,1000,1008041141,1,1,1900),(1,1000,1008041142,1,1,3100),(1,1000,1008041143,1,1,18500),(1,1000,1008041153,1,1,99999),(1,1000,1008041163,1,1,99999),(1,1000,1008041200,1,1,100),(1,1000,1008041210,1,1,300),(1,1000,1008041220,1,1,500),(1,1000,1008041231,1,1,700),(1,1000,1008041232,1,1,800),(1,1000,1008041241,1,1,2700),(1,1000,1008041242,1,1,4600),(1,1000,1008041243,1,1,27600),(1,1000,1008041253,1,1,99999),(1,1000,1008041263,1,1,99999),(1,1000,1008041300,1,1,100),(1,1000,1008041310,1,1,300),(1,1000,1008041320,1,1,500),(1,1000,1008041331,1,1,700),(1,1000,1008041332,1,1,900),(1,1000,1008041341,1,1,3300),(1,1000,1008041342,1,1,5700),(1,1000,1008041343,1,1,40400),(1,1000,1008041353,1,1,99999),(1,1000,1008041363,1,1,99999),(1,1000,1008041400,1,1,100),(1,1000,1008041410,1,1,300),(1,1000,1008041420,1,1,600),(1,1000,1008041431,1,1,800),(1,1000,1008041432,1,1,1000),(1,1000,1008041441,1,1,3900),(1,1000,1008041442,1,1,6800),(1,1000,1008041443,1,1,56700),(1,1000,1008041453,1,1,99999),(1,1000,1008041463,1,1,99999),(1,1000,1008041500,1,1,200),(1,1000,1008041510,1,1,400),(1,1000,1008041520,1,1,700),(1,1000,1008041531,1,1,900),(1,1000,1008041532,1,1,1100),(1,1000,1008041541,1,1,4300),(1,1000,1008041542,1,1,7500),(1,1000,1008041543,1,1,74900),(1,1000,1008041553,1,1,99999),(1,1000,1008041563,1,1,99999),(1,1000,1008041600,1,1,200),(1,1000,1008041610,1,1,400),(1,1000,1008041620,1,1,800),(1,1000,1008041631,1,1,1000),(1,1000,1008041632,1,1,1200),(1,1000,1008041641,1,1,5500),(1,1000,1008041642,1,1,9700),(1,1000,1008041643,1,1,96700),(1,1000,1008041653,1,1,99999),(1,1000,1008041663,1,1,99999),(1,1000,1009000100,1,1,10000),(1,1000,1009000110,1,1,10000),(1,1000,1009000120,1,1,10000),(1,1000,1009000131,1,1,10000),(1,1000,1009000132,1,1,10000),(1,1000,1009000141,1,1,10000),(1,1000,1009000142,1,1,10000),(1,1000,1009000143,1,1,10000),(1,1000,1009000153,1,1,99999),(1,1000,1009000163,1,1,99999),(1,1000,1009000200,1,1,10000),(1,1000,1009000210,1,1,10000),(1,1000,1009000220,1,1,10000),(1,1000,1009000231,1,1,10000),(1,1000,1009000232,1,1,10000),(1,1000,1009000241,1,1,10000),(1,1000,1009000242,1,1,10000),(1,1000,1009000243,1,1,10000),(1,1000,1009000253,1,1,99999),(1,1000,1009000263,1,1,99999),(1,1000,1009000300,1,1,10000),(1,1000,1009000310,1,1,10000),(1,1000,1009000320,1,1,10000),(1,1000,1009000331,1,1,10000),(1,1000,1009000332,1,1,10000),(1,1000,1009000341,1,1,10000),(1,1000,1009000342,1,1,10000),(1,1000,1009000343,1,1,10000),(1,1000,1009000353,1,1,99999),(1,1000,1009000363,1,1,99999),(1,1000,1009000400,1,1,10000),(1,1000,1009000410,1,1,10000),(1,1000,1009000420,1,1,10000),(1,1000,1009000431,1,1,10000),(1,1000,1009000432,1,1,10000),(1,1000,1009000441,1,1,10000),(1,1000,1009000442,1,1,10000),(1,1000,1009000443,1,1,10000),(1,1000,1009000453,1,1,99999),(1,1000,1009000463,1,1,99999),(1,1000,1009000500,1,1,10000),(1,1000,1009000510,1,1,10000),(1,1000,1009000520,1,1,10000),(1,1000,1009000531,1,1,10000),(1,1000,1009000532,1,1,10000),(1,1000,1009000541,1,1,10000),(1,1000,1009000542,1,1,10000),(1,1000,1009000543,1,1,10000),(1,1000,1009000553,1,1,99999),(1,1000,1009000563,1,1,99999),(1,1000,1009000600,1,1,10000),(1,1000,1009000610,1,1,10000),(1,1000,1009000620,1,1,10000),(1,1000,1009000631,1,1,10000),(1,1000,1009000632,1,1,10000),(1,1000,1009000641,1,1,10000),(1,1000,1009000642,1,1,10000),(1,1000,1009000643,1,1,10000),(1,1000,1009000653,1,1,99999),(1,1000,1009000663,1,1,99999),(1,1000,1009000700,1,1,10000),(1,1000,1009000710,1,1,10000),(1,1000,1009000720,1,1,10000),(1,1000,1009000731,1,1,10000),(1,1000,1009000732,1,1,10000),(1,1000,1009000741,1,1,10000),(1,1000,1009000742,1,1,10000),(1,1000,1009000743,1,1,10000),(1,1000,1009000753,1,1,99999),(1,1000,1009000763,1,1,99999),(1,1000,1009000800,1,1,10000),(1,1000,1009000810,1,1,10000),(1,1000,1009000820,1,1,10000),(1,1000,1009000831,1,1,10000),(1,1000,1009000832,1,1,10000),(1,1000,1009000841,1,1,10000),(1,1000,1009000842,1,1,10000),(1,1000,1009000843,1,1,10000),(1,1000,1009000853,1,1,99999),(1,1000,1009000863,1,1,99999),(1,1000,1009000900,1,1,10000),(1,1000,1009000910,1,1,10000),(1,1000,1009000920,1,1,10000),(1,1000,1009000931,1,1,10000),(1,1000,1009000932,1,1,10000),(1,1000,1009000941,1,1,10000),(1,1000,1009000942,1,1,10000),(1,1000,1009000943,1,1,10000),(1,1000,1009000953,1,1,99999),(1,1000,1009000963,1,1,99999),(1,1000,1009001000,1,1,10000),(1,1000,1009001010,1,1,10000),(1,1000,1009001020,1,1,10000),(1,1000,1009001031,1,1,10000),(1,1000,1009001032,1,1,10000),(1,1000,1009001041,1,1,10000),(1,1000,1009001042,1,1,10000),(1,1000,1009001043,1,1,10000),(1,1000,1009001053,1,1,99999),(1,1000,1009001063,1,1,99999),(1,1000,1009001100,1,1,10000),(1,1000,1009001110,1,1,10000),(1,1000,1009001120,1,1,10000),(1,1000,1009001131,1,1,10000),(1,1000,1009001132,1,1,10000),(1,1000,1009001141,1,1,10000),(1,1000,1009001142,1,1,10000),(1,1000,1009001143,1,1,10000),(1,1000,1009001153,1,1,99999),(1,1000,1009001163,1,1,99999),(1,1000,1009001200,1,1,10000),(1,1000,1009001210,1,1,10000),(1,1000,1009001220,1,1,10000),(1,1000,1009001231,1,1,10000),(1,1000,1009001232,1,1,10000),(1,1000,1009001241,1,1,10000),(1,1000,1009001242,1,1,10000),(1,1000,1009001243,1,1,10000),(1,1000,1009001253,1,1,99999),(1,1000,1009001263,1,1,99999),(1,1000,1009001300,1,1,10000),(1,1000,1009001310,1,1,10000),(1,1000,1009001320,1,1,10000),(1,1000,1009001331,1,1,10000),(1,1000,1009001332,1,1,10000),(1,1000,1009001341,1,1,10000),(1,1000,1009001342,1,1,10000),(1,1000,1009001343,1,1,10000),(1,1000,1009001353,1,1,99999),(1,1000,1009001363,1,1,99999),(1,1000,1009001400,1,1,10000),(1,1000,1009001410,1,1,10000),(1,1000,1009001420,1,1,10000),(1,1000,1009001431,1,1,10000),(1,1000,1009001432,1,1,10000),(1,1000,1009001441,1,1,10000),(1,1000,1009001442,1,1,10000),(1,1000,1009001443,1,1,10000),(1,1000,1009001453,1,1,99999),(1,1000,1009001463,1,1,99999),(1,1000,1009001500,1,1,10000),(1,1000,1009001510,1,1,10000),(1,1000,1009001520,1,1,10000),(1,1000,1009001531,1,1,10000),(1,1000,1009001532,1,1,10000),(1,1000,1009001541,1,1,10000),(1,1000,1009001542,1,1,10000),(1,1000,1009001543,1,1,10000),(1,1000,1009001553,1,1,99999),(1,1000,1009001563,1,1,99999),(1,1000,1009001600,1,1,10000),(1,1000,1009001610,1,1,10000),(1,1000,1009001620,1,1,10000),(1,1000,1009001631,1,1,10000),(1,1000,1009001632,1,1,10000),(1,1000,1009001641,1,1,10000),(1,1000,1009001642,1,1,10000),(1,1000,1009001643,1,1,10000),(1,1000,1009001653,1,1,99999),(1,1000,1009001663,1,1,99999),(1,1000,1010010100,1,1,100),(1,1000,1010010110,1,1,100),(1,1000,1010010120,1,1,100),(1,1000,1010010131,1,1,100),(1,1000,1010010132,1,1,100),(1,1000,1010010141,1,1,200),(1,1000,1010010142,1,1,200),(1,1000,1010010143,1,1,500),(1,1000,1010010153,1,1,99999),(1,1000,1010010163,1,1,99999),(1,1000,1010010200,1,1,100),(1,1000,1010010210,1,1,100),(1,1000,1010010220,1,1,100),(1,1000,1010010231,1,1,100),(1,1000,1010010232,1,1,100),(1,1000,1010010241,1,1,200),(1,1000,1010010242,1,1,300),(1,1000,1010010243,1,1,800),(1,1000,1010010253,1,1,99999),(1,1000,1010010263,1,1,99999),(1,1000,1010010300,1,1,100),(1,1000,1010010310,1,1,100),(1,1000,1010010320,1,1,100),(1,1000,1010010331,1,1,200),(1,1000,1010010332,1,1,200),(1,1000,1010010341,1,1,300),(1,1000,1010010342,1,1,500),(1,1000,1010010343,1,1,1300),(1,1000,1010010353,1,1,99999),(1,1000,1010010363,1,1,99999),(1,1000,1010010400,1,1,100),(1,1000,1010010410,1,1,100),(1,1000,1010010420,1,1,200),(1,1000,1010010431,1,1,200),(1,1000,1010010432,1,1,200),(1,1000,1010010441,1,1,400),(1,1000,1010010442,1,1,600),(1,1000,1010010443,1,1,1800),(1,1000,1010010453,1,1,99999),(1,1000,1010010463,1,1,99999),(1,1000,1010010500,1,1,100),(1,1000,1010010510,1,1,100),(1,1000,1010010520,1,1,200),(1,1000,1010010531,1,1,200),(1,1000,1010010532,1,1,300),(1,1000,1010010541,1,1,600),(1,1000,1010010542,1,1,900),(1,1000,1010010543,1,1,2500),(1,1000,1010010553,1,1,99999),(1,1000,1010010563,1,1,99999),(1,1000,1010010600,1,1,100),(1,1000,1010010610,1,1,100),(1,1000,1010010620,1,1,200),(1,1000,1010010631,1,1,300),(1,1000,1010010632,1,1,400),(1,1000,1010010641,1,1,700),(1,1000,1010010642,1,1,1000),(1,1000,1010010643,1,1,3600),(1,1000,1010010653,1,1,99999),(1,1000,1010010663,1,1,99999),(1,1000,1010010700,1,1,100),(1,1000,1010010710,1,1,200),(1,1000,1010010720,1,1,300),(1,1000,1010010731,1,1,300),(1,1000,1010010732,1,1,400),(1,1000,1010010741,1,1,900),(1,1000,1010010742,1,1,1300),(1,1000,1010010743,1,1,4900),(1,1000,1010010753,1,1,99999),(1,1000,1010010763,1,1,99999),(1,1000,1010010800,1,1,100),(1,1000,1010010810,1,1,200),(1,1000,1010010820,1,1,300),(1,1000,1010010831,1,1,400),(1,1000,1010010832,1,1,500),(1,1000,1010010841,1,1,1000),(1,1000,1010010842,1,1,1600),(1,1000,1010010843,1,1,6700),(1,1000,1010010853,1,1,99999),(1,1000,1010010863,1,1,99999),(1,1000,1010010900,1,1,100),(1,1000,1010010910,1,1,200),(1,1000,1010010920,1,1,300),(1,1000,1010010931,1,1,400),(1,1000,1010010932,1,1,500),(1,1000,1010010941,1,1,1200),(1,1000,1010010942,1,1,1900),(1,1000,1010010943,1,1,9500),(1,1000,1010010953,1,1,99999),(1,1000,1010010963,1,1,99999),(1,1000,1010011000,1,1,100),(1,1000,1010011010,1,1,200),(1,1000,1010011020,1,1,400),(1,1000,1010011031,1,1,500),(1,1000,1010011032,1,1,600),(1,1000,1010011041,1,1,1400),(1,1000,1010011042,1,1,2200),(1,1000,1010011043,1,1,13100),(1,1000,1010011053,1,1,99999),(1,1000,1010011063,1,1,99999),(1,1000,1010011100,1,1,100),(1,1000,1010011110,1,1,200),(1,1000,1010011120,1,1,400),(1,1000,1010011131,1,1,600),(1,1000,1010011132,1,1,700),(1,1000,1010011141,1,1,1900),(1,1000,1010011142,1,1,3100),(1,1000,1010011143,1,1,18500),(1,1000,1010011153,1,1,99999),(1,1000,1010011163,1,1,99999),(1,1000,1010011200,1,1,100),(1,1000,1010011210,1,1,300),(1,1000,1010011220,1,1,500),(1,1000,1010011231,1,1,700),(1,1000,1010011232,1,1,800),(1,1000,1010011241,1,1,2700),(1,1000,1010011242,1,1,4600),(1,1000,1010011243,1,1,27600),(1,1000,1010011253,1,1,99999),(1,1000,1010011263,1,1,99999),(1,1000,1010011300,1,1,100),(1,1000,1010011310,1,1,300),(1,1000,1010011320,1,1,500),(1,1000,1010011331,1,1,700),(1,1000,1010011332,1,1,900),(1,1000,1010011341,1,1,3300),(1,1000,1010011342,1,1,5700),(1,1000,1010011343,1,1,40400),(1,1000,1010011353,1,1,99999),(1,1000,1010011363,1,1,99999),(1,1000,1010011400,1,1,100),(1,1000,1010011410,1,1,300),(1,1000,1010011420,1,1,600),(1,1000,1010011431,1,1,800),(1,1000,1010011432,1,1,1000),(1,1000,1010011441,1,1,3900),(1,1000,1010011442,1,1,6800),(1,1000,1010011443,1,1,56700),(1,1000,1010011453,1,1,99999),(1,1000,1010011463,1,1,99999),(1,1000,1010011500,1,1,200),(1,1000,1010011510,1,1,400),(1,1000,1010011520,1,1,700),(1,1000,1010011531,1,1,900),(1,1000,1010011532,1,1,1100),(1,1000,1010011541,1,1,4300),(1,1000,1010011542,1,1,7500),(1,1000,1010011543,1,1,74900),(1,1000,1010011553,1,1,99999),(1,1000,1010011563,1,1,99999),(1,1000,1010011600,1,1,200),(1,1000,1010011610,1,1,400),(1,1000,1010011620,1,1,800),(1,1000,1010011631,1,1,1000),(1,1000,1010011632,1,1,1200),(1,1000,1010011641,1,1,5500),(1,1000,1010011642,1,1,9700),(1,1000,1010011643,1,1,96700),(1,1000,1010011653,1,1,99999),(1,1000,1010011663,1,1,99999),(1,1000,1010020100,1,1,100),(1,1000,1010020110,1,1,100),(1,1000,1010020120,1,1,100),(1,1000,1010020131,1,1,100),(1,1000,1010020132,1,1,100),(1,1000,1010020141,1,1,200),(1,1000,1010020142,1,1,200),(1,1000,1010020143,1,1,500),(1,1000,1010020153,1,1,99999),(1,1000,1010020163,1,1,99999),(1,1000,1010020200,1,1,100),(1,1000,1010020210,1,1,100),(1,1000,1010020220,1,1,100),(1,1000,1010020231,1,1,100),(1,1000,1010020232,1,1,100),(1,1000,1010020241,1,1,200),(1,1000,1010020242,1,1,300),(1,1000,1010020243,1,1,800),(1,1000,1010020253,1,1,99999),(1,1000,1010020263,1,1,99999),(1,1000,1010020300,1,1,100),(1,1000,1010020310,1,1,100),(1,1000,1010020320,1,1,100),(1,1000,1010020331,1,1,200),(1,1000,1010020332,1,1,200),(1,1000,1010020341,1,1,300),(1,1000,1010020342,1,1,500),(1,1000,1010020343,1,1,1300),(1,1000,1010020353,1,1,99999),(1,1000,1010020363,1,1,99999),(1,1000,1010020400,1,1,100),(1,1000,1010020410,1,1,100),(1,1000,1010020420,1,1,200),(1,1000,1010020431,1,1,200),(1,1000,1010020432,1,1,200),(1,1000,1010020441,1,1,400),(1,1000,1010020442,1,1,600),(1,1000,1010020443,1,1,1800),(1,1000,1010020453,1,1,99999),(1,1000,1010020463,1,1,99999),(1,1000,1010020500,1,1,100),(1,1000,1010020510,1,1,100),(1,1000,1010020520,1,1,200),(1,1000,1010020531,1,1,200),(1,1000,1010020532,1,1,300),(1,1000,1010020541,1,1,600),(1,1000,1010020542,1,1,900),(1,1000,1010020543,1,1,2500),(1,1000,1010020553,1,1,99999),(1,1000,1010020563,1,1,99999),(1,1000,1010020600,1,1,100),(1,1000,1010020610,1,1,100),(1,1000,1010020620,1,1,200),(1,1000,1010020631,1,1,300),(1,1000,1010020632,1,1,400),(1,1000,1010020641,1,1,700),(1,1000,1010020642,1,1,1000),(1,1000,1010020643,1,1,3600),(1,1000,1010020653,1,1,99999),(1,1000,1010020663,1,1,99999),(1,1000,1010020700,1,1,100),(1,1000,1010020710,1,1,200),(1,1000,1010020720,1,1,300),(1,1000,1010020731,1,1,300),(1,1000,1010020732,1,1,400),(1,1000,1010020741,1,1,900),(1,1000,1010020742,1,1,1300),(1,1000,1010020743,1,1,4900),(1,1000,1010020753,1,1,99999),(1,1000,1010020763,1,1,99999),(1,1000,1010020800,1,1,100),(1,1000,1010020810,1,1,200),(1,1000,1010020820,1,1,300),(1,1000,1010020831,1,1,400),(1,1000,1010020832,1,1,500),(1,1000,1010020841,1,1,1000),(1,1000,1010020842,1,1,1600),(1,1000,1010020843,1,1,6700),(1,1000,1010020853,1,1,99999),(1,1000,1010020863,1,1,99999),(1,1000,1010020900,1,1,100),(1,1000,1010020910,1,1,200),(1,1000,1010020920,1,1,300),(1,1000,1010020931,1,1,400),(1,1000,1010020932,1,1,500),(1,1000,1010020941,1,1,1200),(1,1000,1010020942,1,1,1900),(1,1000,1010020943,1,1,9500),(1,1000,1010020953,1,1,99999),(1,1000,1010020963,1,1,99999),(1,1000,1010021000,1,1,100),(1,1000,1010021010,1,1,200),(1,1000,1010021020,1,1,400),(1,1000,1010021031,1,1,500),(1,1000,1010021032,1,1,600),(1,1000,1010021041,1,1,1400),(1,1000,1010021042,1,1,2200),(1,1000,1010021043,1,1,13100),(1,1000,1010021053,1,1,99999),(1,1000,1010021063,1,1,99999),(1,1000,1010021100,1,1,100),(1,1000,1010021110,1,1,200),(1,1000,1010021120,1,1,400),(1,1000,1010021131,1,1,600),(1,1000,1010021132,1,1,700),(1,1000,1010021141,1,1,1900),(1,1000,1010021142,1,1,3100),(1,1000,1010021143,1,1,18500),(1,1000,1010021153,1,1,99999),(1,1000,1010021163,1,1,99999),(1,1000,1010021200,1,1,100),(1,1000,1010021210,1,1,300),(1,1000,1010021220,1,1,500),(1,1000,1010021231,1,1,700),(1,1000,1010021232,1,1,800),(1,1000,1010021241,1,1,2700),(1,1000,1010021242,1,1,4600),(1,1000,1010021243,1,1,27600),(1,1000,1010021253,1,1,99999),(1,1000,1010021263,1,1,99999),(1,1000,1010021300,1,1,100),(1,1000,1010021310,1,1,300),(1,1000,1010021320,1,1,500),(1,1000,1010021331,1,1,700),(1,1000,1010021332,1,1,900),(1,1000,1010021341,1,1,3300),(1,1000,1010021342,1,1,5700),(1,1000,1010021343,1,1,40400),(1,1000,1010021353,1,1,99999),(1,1000,1010021363,1,1,99999),(1,1000,1010021400,1,1,100),(1,1000,1010021410,1,1,300),(1,1000,1010021420,1,1,600),(1,1000,1010021431,1,1,800),(1,1000,1010021432,1,1,1000),(1,1000,1010021441,1,1,3900),(1,1000,1010021442,1,1,6800),(1,1000,1010021443,1,1,56700),(1,1000,1010021453,1,1,99999),(1,1000,1010021463,1,1,99999),(1,1000,1010021500,1,1,200),(1,1000,1010021510,1,1,400),(1,1000,1010021520,1,1,700),(1,1000,1010021531,1,1,900),(1,1000,1010021532,1,1,1100),(1,1000,1010021541,1,1,4300),(1,1000,1010021542,1,1,7500),(1,1000,1010021543,1,1,74900),(1,1000,1010021553,1,1,99999),(1,1000,1010021563,1,1,99999),(1,1000,1010021600,1,1,200),(1,1000,1010021610,1,1,400),(1,1000,1010021620,1,1,800),(1,1000,1010021631,1,1,1000),(1,1000,1010021632,1,1,1200),(1,1000,1010021641,1,1,5500),(1,1000,1010021642,1,1,9700),(1,1000,1010021643,1,1,96700),(1,1000,1010021653,1,1,99999),(1,1000,1010021663,1,1,99999),(1,1000,1010030100,1,1,100),(1,1000,1010030110,1,1,100),(1,1000,1010030120,1,1,100),(1,1000,1010030131,1,1,100),(1,1000,1010030132,1,1,100),(1,1000,1010030141,1,1,200),(1,1000,1010030142,1,1,200),(1,1000,1010030143,1,1,500),(1,1000,1010030153,1,1,99999),(1,1000,1010030163,1,1,99999),(1,1000,1010030200,1,1,100),(1,1000,1010030210,1,1,100),(1,1000,1010030220,1,1,100),(1,1000,1010030231,1,1,100),(1,1000,1010030232,1,1,100),(1,1000,1010030241,1,1,200),(1,1000,1010030242,1,1,300),(1,1000,1010030243,1,1,800),(1,1000,1010030253,1,1,99999),(1,1000,1010030263,1,1,99999),(1,1000,1010030300,1,1,100),(1,1000,1010030310,1,1,100),(1,1000,1010030320,1,1,100),(1,1000,1010030331,1,1,200),(1,1000,1010030332,1,1,200),(1,1000,1010030341,1,1,300),(1,1000,1010030342,1,1,500),(1,1000,1010030343,1,1,1300),(1,1000,1010030353,1,1,99999),(1,1000,1010030363,1,1,99999),(1,1000,1010030400,1,1,100),(1,1000,1010030410,1,1,100),(1,1000,1010030420,1,1,200),(1,1000,1010030431,1,1,200),(1,1000,1010030432,1,1,200),(1,1000,1010030441,1,1,400),(1,1000,1010030442,1,1,600),(1,1000,1010030443,1,1,1800),(1,1000,1010030453,1,1,99999),(1,1000,1010030463,1,1,99999),(1,1000,1010030500,1,1,100),(1,1000,1010030510,1,1,100),(1,1000,1010030520,1,1,200),(1,1000,1010030531,1,1,200),(1,1000,1010030532,1,1,300),(1,1000,1010030541,1,1,600),(1,1000,1010030542,1,1,900),(1,1000,1010030543,1,1,2500),(1,1000,1010030553,1,1,99999),(1,1000,1010030563,1,1,99999),(1,1000,1010030600,1,1,100),(1,1000,1010030610,1,1,100),(1,1000,1010030620,1,1,200),(1,1000,1010030631,1,1,300),(1,1000,1010030632,1,1,400),(1,1000,1010030641,1,1,700),(1,1000,1010030642,1,1,1000),(1,1000,1010030643,1,1,3600),(1,1000,1010030653,1,1,99999),(1,1000,1010030663,1,1,99999),(1,1000,1010030700,1,1,100),(1,1000,1010030710,1,1,200),(1,1000,1010030720,1,1,300),(1,1000,1010030731,1,1,300),(1,1000,1010030732,1,1,400),(1,1000,1010030741,1,1,900),(1,1000,1010030742,1,1,1300),(1,1000,1010030743,1,1,4900),(1,1000,1010030753,1,1,99999),(1,1000,1010030763,1,1,99999),(1,1000,1010030800,1,1,100),(1,1000,1010030810,1,1,200),(1,1000,1010030820,1,1,300),(1,1000,1010030831,1,1,400),(1,1000,1010030832,1,1,500),(1,1000,1010030841,1,1,1000),(1,1000,1010030842,1,1,1600),(1,1000,1010030843,1,1,6700),(1,1000,1010030853,1,1,99999),(1,1000,1010030863,1,1,99999),(1,1000,1010030900,1,1,100),(1,1000,1010030910,1,1,200),(1,1000,1010030920,1,1,300),(1,1000,1010030931,1,1,400),(1,1000,1010030932,1,1,500),(1,1000,1010030941,1,1,1200),(1,1000,1010030942,1,1,1900),(1,1000,1010030943,1,1,9500),(1,1000,1010030953,1,1,99999),(1,1000,1010030963,1,1,99999),(1,1000,1010031000,1,1,100),(1,1000,1010031010,1,1,200),(1,1000,1010031020,1,1,400),(1,1000,1010031031,1,1,500),(1,1000,1010031032,1,1,600),(1,1000,1010031041,1,1,1400),(1,1000,1010031042,1,1,2200),(1,1000,1010031043,1,1,13100),(1,1000,1010031053,1,1,99999),(1,1000,1010031063,1,1,99999),(1,1000,1010031100,1,1,100),(1,1000,1010031110,1,1,200),(1,1000,1010031120,1,1,400),(1,1000,1010031131,1,1,600),(1,1000,1010031132,1,1,700),(1,1000,1010031141,1,1,1900),(1,1000,1010031142,1,1,3100),(1,1000,1010031143,1,1,18500),(1,1000,1010031153,1,1,99999),(1,1000,1010031163,1,1,99999),(1,1000,1010031200,1,1,100),(1,1000,1010031210,1,1,300),(1,1000,1010031220,1,1,500),(1,1000,1010031231,1,1,700),(1,1000,1010031232,1,1,800),(1,1000,1010031241,1,1,2700),(1,1000,1010031242,1,1,4600),(1,1000,1010031243,1,1,27600),(1,1000,1010031253,1,1,99999),(1,1000,1010031263,1,1,99999),(1,1000,1010031300,1,1,100),(1,1000,1010031310,1,1,300),(1,1000,1010031320,1,1,500),(1,1000,1010031331,1,1,700),(1,1000,1010031332,1,1,900),(1,1000,1010031341,1,1,3300),(1,1000,1010031342,1,1,5700),(1,1000,1010031343,1,1,40400),(1,1000,1010031353,1,1,99999),(1,1000,1010031363,1,1,99999),(1,1000,1010031400,1,1,100),(1,1000,1010031410,1,1,300),(1,1000,1010031420,1,1,600),(1,1000,1010031431,1,1,800),(1,1000,1010031432,1,1,1000),(1,1000,1010031441,1,1,3900),(1,1000,1010031442,1,1,6800),(1,1000,1010031443,1,1,56700),(1,1000,1010031453,1,1,99999),(1,1000,1010031463,1,1,99999),(1,1000,1010031500,1,1,200),(1,1000,1010031510,1,1,400),(1,1000,1010031520,1,1,700),(1,1000,1010031531,1,1,900),(1,1000,1010031532,1,1,1100),(1,1000,1010031541,1,1,4300),(1,1000,1010031542,1,1,7500),(1,1000,1010031543,1,1,74900),(1,1000,1010031553,1,1,99999),(1,1000,1010031563,1,1,99999),(1,1000,1010031600,1,1,200),(1,1000,1010031610,1,1,400),(1,1000,1010031620,1,1,800),(1,1000,1010031631,1,1,1000),(1,1000,1010031632,1,1,1200),(1,1000,1010031641,1,1,5500),(1,1000,1010031642,1,1,9700),(1,1000,1010031643,1,1,96700),(1,1000,1010031653,1,1,99999),(1,1000,1010031663,1,1,99999),(1,1000,1010040100,1,1,100),(1,1000,1010040110,1,1,100),(1,1000,1010040120,1,1,100),(1,1000,1010040131,1,1,100),(1,1000,1010040132,1,1,100),(1,1000,1010040141,1,1,200),(1,1000,1010040142,1,1,200),(1,1000,1010040143,1,1,500),(1,1000,1010040153,1,1,99999),(1,1000,1010040163,1,1,99999),(1,1000,1010040200,1,1,100),(1,1000,1010040210,1,1,100),(1,1000,1010040220,1,1,100),(1,1000,1010040231,1,1,100),(1,1000,1010040232,1,1,100),(1,1000,1010040241,1,1,200),(1,1000,1010040242,1,1,300),(1,1000,1010040243,1,1,800),(1,1000,1010040253,1,1,99999),(1,1000,1010040263,1,1,99999),(1,1000,1010040300,1,1,100),(1,1000,1010040310,1,1,100),(1,1000,1010040320,1,1,100),(1,1000,1010040331,1,1,200),(1,1000,1010040332,1,1,200),(1,1000,1010040341,1,1,300),(1,1000,1010040342,1,1,500),(1,1000,1010040343,1,1,1300),(1,1000,1010040353,1,1,99999),(1,1000,1010040363,1,1,99999),(1,1000,1010040400,1,1,100),(1,1000,1010040410,1,1,100),(1,1000,1010040420,1,1,200),(1,1000,1010040431,1,1,200),(1,1000,1010040432,1,1,200),(1,1000,1010040441,1,1,400),(1,1000,1010040442,1,1,600),(1,1000,1010040443,1,1,1800),(1,1000,1010040453,1,1,99999),(1,1000,1010040463,1,1,99999),(1,1000,1010040500,1,1,100),(1,1000,1010040510,1,1,100),(1,1000,1010040520,1,1,200),(1,1000,1010040531,1,1,200),(1,1000,1010040532,1,1,300),(1,1000,1010040541,1,1,600),(1,1000,1010040542,1,1,900),(1,1000,1010040543,1,1,2500),(1,1000,1010040553,1,1,99999),(1,1000,1010040563,1,1,99999),(1,1000,1010040600,1,1,100),(1,1000,1010040610,1,1,100),(1,1000,1010040620,1,1,200),(1,1000,1010040631,1,1,300),(1,1000,1010040632,1,1,400),(1,1000,1010040641,1,1,700),(1,1000,1010040642,1,1,1000),(1,1000,1010040643,1,1,3600),(1,1000,1010040653,1,1,99999),(1,1000,1010040663,1,1,99999),(1,1000,1010040700,1,1,100),(1,1000,1010040710,1,1,200),(1,1000,1010040720,1,1,300),(1,1000,1010040731,1,1,300),(1,1000,1010040732,1,1,400),(1,1000,1010040741,1,1,900),(1,1000,1010040742,1,1,1300),(1,1000,1010040743,1,1,4900),(1,1000,1010040753,1,1,99999),(1,1000,1010040763,1,1,99999),(1,1000,1010040800,1,1,100),(1,1000,1010040810,1,1,200),(1,1000,1010040820,1,1,300),(1,1000,1010040831,1,1,400),(1,1000,1010040832,1,1,500),(1,1000,1010040841,1,1,1000),(1,1000,1010040842,1,1,1600),(1,1000,1010040843,1,1,6700),(1,1000,1010040853,1,1,99999),(1,1000,1010040863,1,1,99999),(1,1000,1010040900,1,1,100),(1,1000,1010040910,1,1,200),(1,1000,1010040920,1,1,300),(1,1000,1010040931,1,1,400),(1,1000,1010040932,1,1,500),(1,1000,1010040941,1,1,1200),(1,1000,1010040942,1,1,1900),(1,1000,1010040943,1,1,9500),(1,1000,1010040953,1,1,99999),(1,1000,1010040963,1,1,99999),(1,1000,1010041000,1,1,100),(1,1000,1010041010,1,1,200),(1,1000,1010041020,1,1,400),(1,1000,1010041031,1,1,500),(1,1000,1010041032,1,1,600),(1,1000,1010041041,1,1,1400),(1,1000,1010041042,1,1,2200),(1,1000,1010041043,1,1,13100),(1,1000,1010041053,1,1,99999),(1,1000,1010041063,1,1,99999),(1,1000,1010041100,1,1,100),(1,1000,1010041110,1,1,200),(1,1000,1010041120,1,1,400),(1,1000,1010041131,1,1,600),(1,1000,1010041132,1,1,700),(1,1000,1010041141,1,1,1900),(1,1000,1010041142,1,1,3100),(1,1000,1010041143,1,1,18500),(1,1000,1010041153,1,1,99999),(1,1000,1010041163,1,1,99999),(1,1000,1010041200,1,1,100),(1,1000,1010041210,1,1,300),(1,1000,1010041220,1,1,500),(1,1000,1010041231,1,1,700),(1,1000,1010041232,1,1,800),(1,1000,1010041241,1,1,2700),(1,1000,1010041242,1,1,4600),(1,1000,1010041243,1,1,27600),(1,1000,1010041253,1,1,99999),(1,1000,1010041263,1,1,99999),(1,1000,1010041300,1,1,100),(1,1000,1010041310,1,1,300),(1,1000,1010041320,1,1,500),(1,1000,1010041331,1,1,700),(1,1000,1010041332,1,1,900),(1,1000,1010041341,1,1,3300),(1,1000,1010041342,1,1,5700),(1,1000,1010041343,1,1,40400),(1,1000,1010041353,1,1,99999),(1,1000,1010041363,1,1,99999),(1,1000,1010041400,1,1,100),(1,1000,1010041410,1,1,300),(1,1000,1010041420,1,1,600),(1,1000,1010041431,1,1,800),(1,1000,1010041432,1,1,1000),(1,1000,1010041441,1,1,3900),(1,1000,1010041442,1,1,6800),(1,1000,1010041443,1,1,56700),(1,1000,1010041453,1,1,99999),(1,1000,1010041463,1,1,99999),(1,1000,1010041500,1,1,200),(1,1000,1010041510,1,1,400),(1,1000,1010041520,1,1,700),(1,1000,1010041531,1,1,900),(1,1000,1010041532,1,1,1100),(1,1000,1010041541,1,1,4300),(1,1000,1010041542,1,1,7500),(1,1000,1010041543,1,1,74900),(1,1000,1010041553,1,1,99999),(1,1000,1010041563,1,1,99999),(1,1000,1010041600,1,1,200),(1,1000,1010041610,1,1,400),(1,1000,1010041620,1,1,800),(1,1000,1010041631,1,1,1000),(1,1000,1010041632,1,1,1200),(1,1000,1010041641,1,1,5500),(1,1000,1010041642,1,1,9700),(1,1000,1010041643,1,1,96700),(1,1000,1010041653,1,1,99999),(1,1000,1010041663,1,1,99999),(1,1000,1101010320,1,1,200),(1,1000,1101010442,1,1,1100),(1,1000,1101010531,1,1,400),(1,1000,1101010532,1,1,500),(1,1000,1101010542,1,1,1600),(1,1000,1101010543,1,1,4600),(1,1000,1101010641,1,1,1200),(1,1000,1101010732,1,1,700),(1,1000,1101010742,1,1,2400),(1,1000,1101010743,1,1,9000),(1,1000,1101010753,1,1,99999),(1,1000,1101010842,1,1,2900),(1,1000,1101020320,1,1,200),(1,1000,1101020442,1,1,1100),(1,1000,1101020531,1,1,400),(1,1000,1101020532,1,1,500),(1,1000,1101020542,1,1,1600),(1,1000,1101020543,1,1,4600),(1,1000,1101020641,1,1,1200),(1,1000,1101020732,1,1,700),(1,1000,1101020742,1,1,2400),(1,1000,1101020743,1,1,9000),(1,1000,1101020753,1,1,99999),(1,1000,1101020842,1,1,2900),(1,1000,1101030320,1,1,200),(1,1000,1101030442,1,1,1100),(1,1000,1101030531,1,1,400),(1,1000,1101030532,1,1,500),(1,1000,1101030542,1,1,1600),(1,1000,1101030543,1,1,4600),(1,1000,1101030641,1,1,1200),(1,1000,1101030732,1,1,700),(1,1000,1101030742,1,1,2400),(1,1000,1101030743,1,1,9000),(1,1000,1101030753,1,1,99999),(1,1000,1101030842,1,1,2900),(1,1000,1101040320,1,1,200),(1,1000,1101040442,1,1,1100),(1,1000,1101040531,1,1,400),(1,1000,1101040532,1,1,500),(1,1000,1101040542,1,1,1600),(1,1000,1101040543,1,1,4600),(1,1000,1101040641,1,1,1200),(1,1000,1101040732,1,1,700),(1,1000,1101040742,1,1,2400),(1,1000,1101040743,1,1,9000),(1,1000,1101040753,1,1,99999),(1,1000,1101040842,1,1,2900),(1,1000,1102010320,1,1,200),(1,1000,1102010442,1,1,900),(1,1000,1102010531,1,1,300),(1,1000,1102010532,1,1,400),(1,1000,1102010542,1,1,1300),(1,1000,1102010543,1,1,3800),(1,1000,1102010641,1,1,1000),(1,1000,1102010732,1,1,600),(1,1000,1102010742,1,1,2000),(1,1000,1102010743,1,1,7300),(1,1000,1102010753,1,1,99999),(1,1000,1102010842,1,1,2400),(1,1000,1102020320,1,1,200),(1,1000,1102020442,1,1,900),(1,1000,1102020531,1,1,300),(1,1000,1102020532,1,1,400),(1,1000,1102020542,1,1,1300),(1,1000,1102020543,1,1,3800),(1,1000,1102020641,1,1,1000),(1,1000,1102020732,1,1,600),(1,1000,1102020742,1,1,2000),(1,1000,1102020743,1,1,7300),(1,1000,1102020753,1,1,99999),(1,1000,1102020842,1,1,2400),(1,1000,1102030320,1,1,200),(1,1000,1102030442,1,1,900),(1,1000,1102030531,1,1,300),(1,1000,1102030532,1,1,400),(1,1000,1102030542,1,1,1300),(1,1000,1102030543,1,1,3800),(1,1000,1102030641,1,1,1000),(1,1000,1102030732,1,1,600),(1,1000,1102030742,1,1,2000),(1,1000,1102030743,1,1,7300),(1,1000,1102030753,1,1,99999),(1,1000,1102030842,1,1,2400),(1,1000,1102040320,1,1,200),(1,1000,1102040442,1,1,900),(1,1000,1102040531,1,1,300),(1,1000,1102040532,1,1,400),(1,1000,1102040542,1,1,1300),(1,1000,1102040543,1,1,3800),(1,1000,1102040641,1,1,1000),(1,1000,1102040732,1,1,600),(1,1000,1102040742,1,1,2000),(1,1000,1102040743,1,1,7300),(1,1000,1102040753,1,1,99999),(1,1000,1102040842,1,1,2400),(1,1000,1103000320,1,1,100),(1,1000,1103000442,1,1,800),(1,1000,1103000531,1,1,300),(1,1000,1103000532,1,1,400),(1,1000,1103000542,1,1,1100),(1,1000,1103000543,1,1,3100),(1,1000,1103000641,1,1,800),(1,1000,1103000732,1,1,500),(1,1000,1103000742,1,1,1600),(1,1000,1103000743,1,1,6000),(1,1000,1103000753,1,1,99999),(1,1000,1103000842,1,1,2000),(1,1000,1104010320,1,1,100),(1,1000,1104010442,1,1,600),(1,1000,1104010531,1,1,200),(1,1000,1104010532,1,1,300),(1,1000,1104010542,1,1,900),(1,1000,1104010543,1,1,2500),(1,1000,1104010641,1,1,700),(1,1000,1104010732,1,1,400),(1,1000,1104010742,1,1,1300),(1,1000,1104010743,1,1,4900),(1,1000,1104010753,1,1,99999),(1,1000,1104010842,1,1,1600),(1,1000,1104020320,1,1,100),(1,1000,1104020442,1,1,600),(1,1000,1104020531,1,1,200),(1,1000,1104020532,1,1,300),(1,1000,1104020542,1,1,900),(1,1000,1104020543,1,1,2500),(1,1000,1104020641,1,1,700),(1,1000,1104020732,1,1,400),(1,1000,1104020742,1,1,1300),(1,1000,1104020743,1,1,4900),(1,1000,1104020753,1,1,99999),(1,1000,1104020842,1,1,1600),(1,1000,1104030320,1,1,100),(1,1000,1104030442,1,1,600),(1,1000,1104030531,1,1,200),(1,1000,1104030532,1,1,300),(1,1000,1104030542,1,1,900),(1,1000,1104030543,1,1,2500),(1,1000,1104030641,1,1,700),(1,1000,1104030732,1,1,400),(1,1000,1104030742,1,1,1300),(1,1000,1104030743,1,1,4900),(1,1000,1104030753,1,1,99999),(1,1000,1104030842,1,1,1600),(1,1000,1104040320,1,1,100),(1,1000,1104040442,1,1,600),(1,1000,1104040531,1,1,200),(1,1000,1104040532,1,1,300),(1,1000,1104040542,1,1,900),(1,1000,1104040543,1,1,2500),(1,1000,1104040641,1,1,700),(1,1000,1104040732,1,1,400),(1,1000,1104040742,1,1,1300),(1,1000,1104040743,1,1,4900),(1,1000,1104040753,1,1,99999),(1,1000,1104040842,1,1,1600),(1,1000,1105000320,1,1,10000),(1,1000,1105000442,1,1,10000),(1,1000,1105000531,1,1,10000),(1,1000,1105000532,1,1,10000),(1,1000,1105000542,1,1,10000),(1,1000,1105000543,1,1,10000),(1,1000,1105000641,1,1,10000),(1,1000,1105000732,1,1,10000),(1,1000,1105000742,1,1,10000),(1,1000,1105000743,1,1,10000),(1,1000,1105000753,1,1,99999),(1,1000,1105000842,1,1,10000),(1,1000,1106010320,1,1,100),(1,1000,1106010442,1,1,600),(1,1000,1106010531,1,1,200),(1,1000,1106010532,1,1,300),(1,1000,1106010542,1,1,900),(1,1000,1106010543,1,1,2500),(1,1000,1106010641,1,1,700),(1,1000,1106010732,1,1,400),(1,1000,1106010742,1,1,1300),(1,1000,1106010743,1,1,4900),(1,1000,1106010753,1,1,99999),(1,1000,1106010842,1,1,1600),(1,1000,1106020320,1,1,100),(1,1000,1106020442,1,1,600),(1,1000,1106020531,1,1,200),(1,1000,1106020532,1,1,300),(1,1000,1106020542,1,1,900),(1,1000,1106020543,1,1,2500),(1,1000,1106020641,1,1,700),(1,1000,1106020732,1,1,400),(1,1000,1106020742,1,1,1300),(1,1000,1106020743,1,1,4900),(1,1000,1106020753,1,1,99999),(1,1000,1106020842,1,1,1600),(1,1000,1106030320,1,1,100),(1,1000,1106030442,1,1,600),(1,1000,1106030531,1,1,200),(1,1000,1106030532,1,1,300),(1,1000,1106030542,1,1,900),(1,1000,1106030543,1,1,2500),(1,1000,1106030641,1,1,700),(1,1000,1106030732,1,1,400),(1,1000,1106030742,1,1,1300),(1,1000,1106030743,1,1,4900),(1,1000,1106030753,1,1,99999),(1,1000,1106030842,1,1,1600),(1,1000,1106040320,1,1,100),(1,1000,1106040442,1,1,600),(1,1000,1106040531,1,1,200),(1,1000,1106040532,1,1,300),(1,1000,1106040542,1,1,900),(1,1000,1106040543,1,1,2500),(1,1000,1106040641,1,1,700),(1,1000,1106040732,1,1,400),(1,1000,1106040742,1,1,1300),(1,1000,1106040743,1,1,4900),(1,1000,1106040753,1,1,99999),(1,1000,1106040842,1,1,1600),(1,1000,1107010320,1,1,100),(1,1000,1107010442,1,1,800),(1,1000,1107010531,1,1,300),(1,1000,1107010532,1,1,400),(1,1000,1107010542,1,1,1100),(1,1000,1107010543,1,1,3100),(1,1000,1107010641,1,1,800),(1,1000,1107010732,1,1,500),(1,1000,1107010742,1,1,1600),(1,1000,1107010743,1,1,6000),(1,1000,1107010753,1,1,99999),(1,1000,1107010842,1,1,2000),(1,1000,1107020320,1,1,100),(1,1000,1107020442,1,1,800),(1,1000,1107020531,1,1,300),(1,1000,1107020532,1,1,400),(1,1000,1107020542,1,1,1100),(1,1000,1107020543,1,1,3100),(1,1000,1107020641,1,1,800),(1,1000,1107020732,1,1,500),(1,1000,1107020742,1,1,1600),(1,1000,1107020743,1,1,6000),(1,1000,1107020753,1,1,99999),(1,1000,1107020842,1,1,2000),(1,1000,1107030320,1,1,100),(1,1000,1107030442,1,1,800),(1,1000,1107030531,1,1,300),(1,1000,1107030532,1,1,400),(1,1000,1107030542,1,1,1100),(1,1000,1107030543,1,1,3100),(1,1000,1107030641,1,1,800),(1,1000,1107030732,1,1,500),(1,1000,1107030742,1,1,1600),(1,1000,1107030743,1,1,6000),(1,1000,1107030753,1,1,99999),(1,1000,1107030842,1,1,2000),(1,1000,1107040320,1,1,100),(1,1000,1107040442,1,1,800),(1,1000,1107040531,1,1,300),(1,1000,1107040532,1,1,400),(1,1000,1107040542,1,1,1100),(1,1000,1107040543,1,1,3100),(1,1000,1107040641,1,1,800),(1,1000,1107040732,1,1,500),(1,1000,1107040742,1,1,1600),(1,1000,1107040743,1,1,6000),(1,1000,1107040753,1,1,99999),(1,1000,1107040842,1,1,2000),(1,1000,1108010320,1,1,100),(1,1000,1108010442,1,1,600),(1,1000,1108010531,1,1,200),(1,1000,1108010532,1,1,300),(1,1000,1108010542,1,1,900),(1,1000,1108010543,1,1,2500),(1,1000,1108010641,1,1,700),(1,1000,1108010732,1,1,400),(1,1000,1108010742,1,1,1300),(1,1000,1108010743,1,1,4900),(1,1000,1108010753,1,1,99999),(1,1000,1108010842,1,1,1600),(1,1000,1108020320,1,1,100),(1,1000,1108020442,1,1,600),(1,1000,1108020531,1,1,200),(1,1000,1108020532,1,1,300),(1,1000,1108020542,1,1,900),(1,1000,1108020543,1,1,2500),(1,1000,1108020641,1,1,700),(1,1000,1108020732,1,1,400),(1,1000,1108020742,1,1,1300),(1,1000,1108020743,1,1,4900),(1,1000,1108020753,1,1,99999),(1,1000,1108020842,1,1,1600),(1,1000,1108030320,1,1,100),(1,1000,1108030442,1,1,600),(1,1000,1108030531,1,1,200),(1,1000,1108030532,1,1,300),(1,1000,1108030542,1,1,900),(1,1000,1108030543,1,1,2500),(1,1000,1108030641,1,1,700),(1,1000,1108030732,1,1,400),(1,1000,1108030742,1,1,1300),(1,1000,1108030743,1,1,4900),(1,1000,1108030753,1,1,99999),(1,1000,1108030842,1,1,1600),(1,1000,1108040320,1,1,100),(1,1000,1108040442,1,1,600),(1,1000,1108040531,1,1,200),(1,1000,1108040532,1,1,300),(1,1000,1108040542,1,1,900),(1,1000,1108040543,1,1,2500),(1,1000,1108040641,1,1,700),(1,1000,1108040732,1,1,400),(1,1000,1108040742,1,1,1300),(1,1000,1108040743,1,1,4900),(1,1000,1108040753,1,1,99999),(1,1000,1108040842,1,1,1600),(1,1000,1109000320,1,1,10000),(1,1000,1109000442,1,1,10000),(1,1000,1109000531,1,1,10000),(1,1000,1109000532,1,1,10000),(1,1000,1109000542,1,1,10000),(1,1000,1109000543,1,1,10000),(1,1000,1109000641,1,1,10000),(1,1000,1109000732,1,1,10000),(1,1000,1109000742,1,1,10000),(1,1000,1109000743,1,1,10000),(1,1000,1109000753,1,1,99999),(1,1000,1109000842,1,1,10000),(1,1000,1110010320,1,1,100),(1,1000,1110010442,1,1,600),(1,1000,1110010531,1,1,200),(1,1000,1110010532,1,1,300),(1,1000,1110010542,1,1,900),(1,1000,1110010543,1,1,2500),(1,1000,1110010641,1,1,700),(1,1000,1110010732,1,1,400),(1,1000,1110010742,1,1,1300),(1,1000,1110010743,1,1,4900),(1,1000,1110010753,1,1,99999),(1,1000,1110010842,1,1,1600),(1,1000,1110020320,1,1,100),(1,1000,1110020442,1,1,600),(1,1000,1110020531,1,1,200),(1,1000,1110020532,1,1,300),(1,1000,1110020542,1,1,900),(1,1000,1110020543,1,1,2500),(1,1000,1110020641,1,1,700),(1,1000,1110020732,1,1,400),(1,1000,1110020742,1,1,1300),(1,1000,1110020743,1,1,4900),(1,1000,1110020753,1,1,99999),(1,1000,1110020842,1,1,1600),(1,1000,1110030320,1,1,100),(1,1000,1110030442,1,1,600),(1,1000,1110030531,1,1,200),(1,1000,1110030532,1,1,300),(1,1000,1110030542,1,1,900),(1,1000,1110030543,1,1,2500),(1,1000,1110030641,1,1,700),(1,1000,1110030732,1,1,400),(1,1000,1110030742,1,1,1300),(1,1000,1110030743,1,1,4900),(1,1000,1110030753,1,1,99999),(1,1000,1110030842,1,1,1600),(1,1000,1110040320,1,1,100),(1,1000,1110040442,1,1,600),(1,1000,1110040531,1,1,200),(1,1000,1110040532,1,1,300),(1,1000,1110040542,1,1,900),(1,1000,1110040543,1,1,2500),(1,1000,1110040641,1,1,700),(1,1000,1110040732,1,1,400),(1,1000,1110040742,1,1,1300),(1,1000,1110040743,1,1,4900),(1,1000,1110040753,1,1,99999),(1,1000,1110040842,1,1,1600);
/*!40000 ALTER TABLE `base_sell_price` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_setting`
--

DROP TABLE IF EXISTS `base_setting`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_setting` (
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '主类别',
  `subtype` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '次类别',
  `name` varchar(200) NOT NULL DEFAULT '' COMMENT '名字@lang@',
  `is_open` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '默认开关',
  PRIMARY KEY (`type`,`subtype`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='设置配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_setting`
--

LOCK TABLES `base_setting` WRITE;
/*!40000 ALTER TABLE `base_setting` DISABLE KEYS */;
INSERT INTO `base_setting` VALUES (1,1,'系统频道',1),(1,2,'世界频道',1),(1,3,'附近频道',1),(1,4,'公会频道',1),(1,5,'队伍频道',1),(1,6,'好友频道',1),(1,7,'职业频道',1),(2,1,'语音转文字',0),(2,2,'世界语音',1),(2,3,'附近语音',0),(2,4,'公会语音',1),(2,5,'队伍语音',1),(2,6,'好友语音',1),(2,7,'职业语音',0),(2,8,'仅在wifi下自动播放语音',1);
/*!40000 ALTER TABLE `base_setting` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_shop`
--

DROP TABLE IF EXISTS `base_shop`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_shop` (
  `key_id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增ID',
  `shop_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商店类型',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排序ID',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品ID',
  `num` int(11) unsigned NOT NULL DEFAULT '1' COMMENT '单次出售数量',
  `ctype` int(11) unsigned NOT NULL DEFAULT '1' COMMENT '价格类型##1-钻石，2-绑定钻石，其他待定',
  `price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '价格##直接填数字',
  `discount` int(11) unsigned NOT NULL DEFAULT '100' COMMENT '折扣',
  `quota_type` int(1) unsigned NOT NULL DEFAULT '0' COMMENT '限购类型',
  `quota_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '限购数量',
  `on_sale` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开发天数（开售）',
  `halt_sale` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开服天数（停售）',
  `wlv_sale` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '世界等级（开售）##默认是0,0为不限制，若有则为到该等级开始出售',
  `wlv_unsale` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '世界等级（停售）##默认是0,0为不限制，若有则为到该等级停止出售',
  `condition` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '购买条件##不限时默认[]，根据需求填条件[{lv,122,123},{vip,3}],可同时填多个',
  `counter_module` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '次数模块ID',
  `counter_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '次数Id',
  `bind` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否绑定##默认是0,0为不绑定，1为绑定',
  `preview` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否可试穿',
  PRIMARY KEY (`key_id`),
  KEY `shop_type` (`shop_type`)
) ENGINE=InnoDB AUTO_INCREMENT=110092 DEFAULT CHARSET=utf8 COMMENT='商城';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_shop`
--

LOCK TABLES `base_shop` WRITE;
/*!40000 ALTER TABLE `base_shop` DISABLE KEYS */;
INSERT INTO `base_shop` VALUES (11001,1,1,11020001,30,1,300,50,1,10,0,0,1,350,'[{vip,2}]',153,1,1,0),(11002,1,2,24010001,30,1,450,50,1,10,0,0,1,350,'[{vip,2}]',153,2,1,0),(11003,1,3,15020101,30,1,450,50,1,6,0,0,1,350,'[{vip,2}]',153,3,1,0),(11004,1,4,18020001,30,1,300,50,1,10,0,0,1,350,'[{vip,2}]',153,5,1,0),(11005,1,5,16020001,20,1,400,50,1,5,0,0,1,350,'[{vip,2}]',153,6,1,0),(11006,1,6,37020002,1,1,50,100,1,1,0,0,1,350,'[{vip,2}]',153,7,1,0),(11007,1,7,11020002,30,1,600,50,1,10,0,0,351,1000,'[{vip,2}]',153,11,1,0),(11008,1,8,24010002,30,1,1350,50,1,10,0,0,351,1000,'[{vip,2}]',153,12,1,0),(11009,1,9,15020102,30,1,1350,50,1,6,0,0,351,1000,'[{vip,2}]',153,13,1,0),(11010,1,10,18020002,30,1,900,50,1,10,0,0,351,1000,'[{vip,2}]',153,15,1,0),(11011,1,11,16020001,20,1,400,50,1,5,0,0,351,1000,'[{vip,2}]',153,16,1,0),(11012,1,12,37020002,1,1,50,100,1,1,0,0,351,1000,'[{vip,2}]',153,17,1,0),(11013,1,13,15020201,30,1,450,50,1,5,0,0,1,350,'[{vip,4}]',153,4,1,0),(11014,1,14,37020003,1,1,150,100,1,1,0,0,1,350,'[{vip,4}]',153,8,1,0),(11015,1,15,32030402,1,1,270,70,1,3,0,0,1,350,'[{vip,4}]',153,9,1,0),(11016,1,16,32030403,1,1,270,70,1,3,0,0,1,350,'[{vip,4}]',153,10,1,0),(11017,1,17,15020202,30,1,1350,50,1,5,0,0,351,1000,'[{vip,4}]',153,14,1,0),(11018,1,18,37020003,1,1,150,100,1,1,0,0,351,1000,'[{vip,4}]',153,18,1,0),(11019,1,19,32030502,1,1,810,60,1,3,0,0,351,1000,'[{vip,4}]',153,19,1,0),(11020,1,20,32030503,1,1,810,60,1,3,0,0,351,1000,'[{vip,4}]',153,20,1,0),(11021,1,21,11070002,10,1,600,50,1,5,0,0,0,0,'[{vip,2}]',153,22,1,0),(13000,13,2,36020001,10,3,500000,100,2,0,0,0,0,0,'[{vip_type, 3},{vip_extra_times, 2}]',450,14,0,0),(13001,13,3,37010201,1,22,30,100,2,1,0,0,0,0,'[{vip_type, 3}]',450,2,0,0),(13002,13,4,11020001,1,22,30,100,2,50,0,0,0,0,'[{vip_type, 3}, {diamond_vip_need_buy, [13001]}]',450,3,0,0),(13003,13,5,18020001,1,22,30,100,2,50,0,0,0,0,'[{vip_type, 3}, {diamond_vip_need_buy, [13002]}]',450,4,0,0),(13004,13,6,17010001,1,22,3,100,2,150,0,0,0,0,'[{vip_type, 3}, {diamond_vip_need_buy, [13003]}]',450,5,0,0),(13005,13,7,38180001,1,22,80,100,2,2,0,0,0,0,'[{vip_type, 3}, {diamond_vip_need_buy, [13004]}]',450,6,0,0),(13006,13,8,37010202,1,22,60,100,2,1,0,0,0,0,'[{vip_type, 3}, {diamond_vip_need_buy, [13005]}]',450,7,0,0),(13008,13,9,38330003,1,22,60,100,2,3,0,0,0,0,'[{vip_type, 3}, {diamond_vip_need_buy, [13006]}]',450,9,0,0),(13009,13,10,38100001,1,22,6,100,2,99,0,0,0,0,'[{vip_type, 3}, {diamond_vip_need_buy, [13008]}]',450,10,0,0),(13010,13,11,38180010,1,22,180,100,2,1,0,0,0,0,'[{vip_type, 3}, {diamond_vip_need_buy, [13009]}]',450,11,0,0),(13011,13,12,5203004,1,22,200,100,2,1,0,0,0,0,'[{vip_type, 3}, {diamond_vip_need_buy, [13010]}]',450,12,0,0),(13012,13,13,40010011,1,22,60,100,2,50,0,0,0,0,'[{vip_type, 3}, {diamond_vip_need_buy, [13011]}]',450,13,0,0),(13013,13,14,11040003,1,22,150,100,2,10,0,0,0,0,'[{vip_type, 3}, {diamond_vip_need_buy, [13012]}]',450,16,0,0),(13014,13,1,36010001,10,10,10,100,2,3,0,0,0,0,'[{vip_type, 3}]',450,17,0,0),(13015,13,15,32020112,1,22,30,100,2,5,0,0,0,0,'[{vip_type, 3}, {diamond_vip_need_buy, [13013]}]',450,18,0,0),(13016,13,16,32020122,1,22,120,100,2,2,0,0,0,0,'[{vip_type, 3}, {diamond_vip_need_buy, [13015]}]',450,19,0,0),(13017,13,17,11040004,1,22,150,100,2,10,0,0,0,0,'[{vip_type, 3}, {diamond_vip_need_buy, [13016]}]',450,20,0,0),(13018,13,18,38260001,1,22,15,100,2,50,0,0,0,0,'[{vip_type, 3}, {diamond_vip_need_buy, [13017]}]',450,21,0,0),(13019,13,19,18060001,1,22,60,100,2,50,0,0,0,0,'[{vip_type, 3}, {diamond_vip_need_buy, [13018]}]',450,22,0,0),(13020,13,20,54010001,1,22,60,100,2,50,0,0,0,0,'[{vip_type, 3}, {diamond_vip_need_buy, [13019]}]',450,23,0,0),(13021,13,21,11070001,1,22,60,100,2,50,0,0,0,0,'[{vip_type, 3}, {diamond_vip_need_buy, [13020]}]',450,24,0,0),(13022,13,22,4901012,1,22,1000,100,2,1,0,0,0,0,'[{vip_type, 3}, {diamond_vip_need_buy, [13021]}]',450,25,0,0),(20001,2,1,36040001,1,1,288,100,0,0,0,0,1,1000,'[]',0,0,0,0),(20002,2,2,36040002,1,1,666,100,0,0,0,0,1,1000,'[]',0,0,0,0),(20003,2,3,36040003,1,1,998,100,0,0,0,0,1,1000,'[]',0,0,0,0),(20004,2,4,1011000001,1,1,288,100,0,0,0,0,1,1000,'[]',0,0,0,0),(20005,2,5,1011000002,1,1,268,100,0,0,0,0,1,1000,'[]',0,0,0,0),(20006,2,6,38040005,1,1,200,100,0,0,0,0,1,1000,'[{lv,371,9999}]',0,0,0,0),(20007,2,7,38040006,1,1,200,100,0,0,0,0,1,1000,'[{lv,371,9999}]',0,0,0,0),(20008,2,8,1011000003,1,1,488,100,0,0,0,0,1,1000,'[{lv,371,9999}]',0,0,0,0),(20009,2,9,1011000004,1,1,468,100,0,0,0,0,1,1000,'[{lv,371,9999}]',0,0,0,0),(20010,2,10,38300002,1,1,188,100,0,0,0,0,1,1000,'[]',0,0,0,0),(20011,2,11,38300004,1,1,128,100,0,0,0,0,1,1000,'[]',0,0,0,0),(20012,2,12,38030001,1,1,80,100,0,0,0,0,1,1000,'[{lv,70,9999}]',0,0,0,0),(20013,2,13,38210001,1,1,468,100,0,0,0,0,1,1000,'[]',0,0,0,0),(20014,2,14,38210002,1,1,998,100,0,0,0,0,1,1000,'[]',0,0,0,0),(20015,2,15,38130001,1,1,5,100,0,0,0,0,1,1000,'[]',0,0,0,0),(20016,2,16,14020201,1,1,10,100,0,0,0,0,1,1000,'[]',0,0,0,0),(20017,2,17,14010101,1,1,10,100,0,0,0,0,1,1000,'[]',0,0,0,0),(20018,2,18,14020202,1,1,30,100,0,0,0,0,1,1000,'[]',0,0,0,0),(20019,2,19,14010102,1,1,30,100,0,0,0,0,1,1000,'[]',0,0,0,0),(20020,2,20,14020203,1,1,90,100,0,0,0,0,1,1000,'[{lv,150,9999}]',0,0,0,0),(20021,2,21,14010103,1,1,90,100,0,0,0,0,1,1000,'[{lv,150,9999}]',0,0,0,0),(20022,2,22,14010303,1,1,90,100,0,0,0,0,1,1000,'[{lv,150,9999}]',0,0,0,0),(20023,2,23,14020403,1,1,90,100,0,0,0,0,1,1000,'[{lv,150,9999}]',0,0,0,0),(20024,2,24,11020001,1,1,10,100,0,0,0,0,1,1000,'[]',0,0,0,0),(20025,2,25,24010001,1,1,15,100,0,0,0,0,1,1000,'[]',0,0,0,0),(20026,2,26,18020001,1,1,10,100,0,0,0,0,1,1000,'[]',0,0,0,0),(20027,2,27,16020001,1,1,20,100,0,0,0,0,1,1000,'[]',0,0,0,0),(20028,2,28,20040001,1,1,200,100,0,0,0,0,1,1000,'[]',0,0,0,0),(20029,2,29,37020001,1,1,10,100,0,0,0,0,1,1000,'[]',0,0,0,0),(20030,2,30,38330004,1,1,60,100,0,0,0,0,1,1000,'[]',0,0,0,0),(20031,2,31,38330003,1,1,20,100,0,0,0,0,1,1000,'[]',0,0,0,0),(20032,2,32,38330002,1,1,7,100,0,0,0,0,1,1000,'[]',0,0,0,0),(20033,2,33,38330001,1,1,3,100,0,0,0,0,1,1000,'[]',0,0,0,0),(20034,2,34,38040010,1,1,5,100,0,0,0,0,1,1000,'[]',0,0,0,0),(20035,2,35,38110001,1,1,10,100,0,0,0,0,1,1000,'[{lv,150,9999}]',0,0,0,0),(20036,2,36,38110002,1,1,10,100,0,0,0,0,1,1000,'[{lv,220,9999}]',0,0,0,0),(20037,2,37,38110003,1,1,15,100,0,0,0,0,1,1000,'[{lv,280,9999}]',0,0,0,0),(20038,2,38,38110004,1,1,50,100,0,0,0,0,1,1000,'[{lv,355,9999}]',0,0,0,0),(20039,2,39,38110005,1,1,30,100,0,0,0,0,1,1000,'[{lv,500,9999}]',0,0,0,0),(20040,2,40,38110006,1,1,45,100,0,0,0,0,1,1000,'[{lv,500,9999}]',0,0,0,0),(20041,2,41,38110007,1,1,60,100,0,0,0,0,1,1000,'[{lv,500,9999}]',0,0,0,0),(20042,2,42,40050001,1,1,99,100,0,0,0,0,0,0,'[]',0,0,0,0),(20043,2,43,38030003,1,1,40,100,0,0,0,0,0,0,'[{lv,240,9999}]',0,0,0,0),(20044,2,44,38250001,1,1,50,100,0,0,0,0,0,0,'[{lv,260,9999}]',0,0,0,0),(20045,2,45,38090001,1,1,50,100,0,0,0,0,0,0,'[]',0,0,0,0),(20046,2,46,38070002,1,1,20,100,0,0,0,0,0,0,'[]',0,0,0,0),(20047,2,47,38040101,1,1,10,100,0,0,0,0,0,0,'[]',0,0,0,0),(20048,2,48,38040001,1,1,10,100,0,0,0,0,0,0,'[]',0,0,0,0),(20049,2,49,38320004,1,1,488,100,0,0,0,0,0,0,'[{lv,65,9999}]',0,0,0,0),(20050,2,50,37030002,1,1,100,100,2,2,0,0,0,0,'[]',153,15,0,0),(20051,2,51,14120001,1,1,4,100,0,0,0,0,0,0,'[{lv,110,9999}]',0,0,0,0),(20052,2,52,48050001,1,1,128,100,0,0,0,0,0,0,'[{lv,250,9999}]',0,0,0,0),(20053,2,53,48050002,1,1,188,100,0,0,0,0,0,0,'[{lv,250,9999}]',0,0,0,0),(20054,2,54,38260001,1,1,10,100,0,0,0,0,0,0,'[{lv,260,9999}]',0,0,0,0),(20055,2,55,11070001,1,1,20,100,0,0,0,0,0,0,'[]',0,0,0,0),(30001,3,1,1011000001,1,2,568,100,0,0,0,0,0,0,'[]',0,0,0,0),(30002,3,2,1011000002,1,2,488,100,0,0,0,0,0,0,'[]',0,0,0,0),(30003,3,3,38300002,1,2,328,100,0,0,0,0,0,0,'[]',0,0,0,0),(30004,3,4,38300004,1,2,218,100,0,0,0,0,0,0,'[]',0,0,0,0),(30005,3,5,38030001,1,2,80,100,0,0,0,0,0,0,'[{lv,70,9999}]',0,0,0,0),(30006,3,6,38130001,1,2,5,100,0,0,0,0,0,0,'[]',0,0,0,0),(30007,3,7,11020001,1,2,10,100,0,0,0,0,0,0,'[]',0,0,0,0),(30008,3,8,24010001,1,2,15,100,0,0,0,0,0,0,'[]',0,0,0,0),(30009,3,9,18020001,1,2,10,100,0,0,0,0,0,0,'[]',0,0,0,0),(30010,3,10,16020001,1,2,20,100,0,0,0,0,0,0,'[]',0,0,0,0),(30011,3,11,37020001,1,2,10,100,0,0,0,0,0,0,'[]',0,0,0,0),(30012,3,12,38330003,1,2,20,100,0,0,0,0,0,0,'[]',0,0,0,0),(30013,3,13,38330002,1,2,7,100,0,0,0,0,0,0,'[]',0,0,0,0),(30014,3,14,38330001,1,2,3,100,0,0,0,0,0,0,'[]',0,0,0,0),(30015,3,15,38040010,1,2,5,100,0,0,0,0,0,0,'[]',0,0,0,0),(30016,3,16,38110001,1,2,10,100,0,0,0,0,0,0,'[{lv,150,9999}]',0,0,0,0),(30017,3,17,38110002,1,2,10,100,0,0,0,0,0,0,'[{lv,220,9999}]',0,0,0,0),(30018,3,18,38110003,1,2,15,100,0,0,0,0,0,0,'[{lv,280,9999}]',0,0,0,0),(30019,3,19,38110004,1,2,50,100,0,0,0,0,0,0,'[{lv,355,9999}]',0,0,0,0),(30020,3,20,38110005,1,2,30,100,0,0,0,0,0,0,'[{lv,500,9999}]',0,0,0,0),(30021,3,21,38110006,1,2,45,100,0,0,0,0,0,0,'[{lv,500,9999}]',0,0,0,0),(30022,3,22,38110007,1,2,60,100,0,0,0,0,0,0,'[{lv,500,9999}]',0,0,0,0),(30023,3,23,38030003,1,2,40,100,0,0,0,0,0,0,'[{lv,240,9999}]',0,0,0,0),(30024,3,25,38250001,1,2,50,100,0,0,0,0,0,0,'[{lv,260,9999}]',0,0,0,0),(30025,3,26,38090001,1,2,50,100,0,0,0,0,0,0,'[]',0,0,0,0),(30026,3,27,38070002,1,2,20,100,0,0,0,0,0,0,'[]',0,0,0,0),(30027,3,28,38040101,1,2,10,100,0,0,0,0,0,0,'[]',0,0,0,0),(30028,3,29,38120001,1,2,100,100,0,0,0,0,0,0,'[]',0,0,0,0),(30029,3,30,38040001,1,2,10,100,0,0,0,0,0,0,'[]',0,0,0,0),(30030,3,32,48050001,1,2,268,100,0,0,0,0,0,0,'[{lv,250,9999}]',0,0,0,0),(30031,3,33,38260001,1,2,10,100,0,0,0,0,0,0,'[{lv,260,9999}]',0,0,0,0),(30032,3,34,11070010,1,2,80,100,0,0,0,0,0,0,'[]',0,0,0,0),(40001,4,1,12010008,1,1,488,100,0,0,0,0,0,0,'[]',0,0,0,1),(40002,4,2,12020008,1,1,488,100,0,0,0,0,0,0,'[]',0,0,0,1),(40003,4,3,12030008,1,1,488,100,0,0,0,0,0,0,'[]',0,0,0,1),(40004,4,4,12040008,1,1,488,100,0,0,0,0,0,0,'[]',0,0,0,1),(40005,4,5,38140002,1,1,288,100,0,0,0,0,0,0,'[]',0,0,0,0),(40006,4,6,38150002,1,1,288,100,0,0,0,0,0,0,'[]',0,0,0,0),(40007,4,7,32010006,1,1,30,100,0,0,0,0,0,0,'[]',0,0,0,0),(60001,6,1,11040003,1,16,1000,100,0,0,0,0,0,0,'[]',153,10,1,0),(60002,6,2,11040004,1,16,1200,100,0,0,0,0,0,0,'[]',153,9,1,0),(60003,6,3,11040005,1,16,1400,100,0,0,0,0,0,0,'[]',153,8,1,0),(60005,6,4,15020101,1,16,150,100,2,15,0,0,0,0,'[]',153,12,1,0),(60006,6,5,15020102,1,16,500,100,2,3,0,0,350,0,'[]',153,13,1,0),(60007,6,6,15020103,1,16,1500,100,2,1,0,0,450,0,'[]',153,14,1,0),(60008,6,7,36020001,50,16,1500,100,2,1,0,0,0,0,'[]',153,16,1,0),(60009,6,8,38330003,1,16,1000,100,2,1,0,0,0,0,'[]',153,17,1,0),(70001,7,1,32020112,1,255,60,100,1,50,0,0,0,0,'[]',650,1,0,0),(70002,7,2,32020113,1,255,120,100,1,25,0,0,0,0,'[]',650,2,0,0),(70003,7,3,32020122,1,255,240,100,1,20,0,0,0,0,'[]',650,3,0,0),(70004,7,4,32020123,1,255,480,100,1,10,0,0,0,0,'[]',650,4,0,0),(70005,7,5,15020101,1,255,150,100,1,20,0,0,0,0,'[]',650,5,0,0),(70006,7,6,15020102,1,255,400,100,1,10,0,0,0,0,'[]',650,6,0,0),(70007,7,7,15020103,1,255,1200,100,1,5,0,0,0,0,'[]',650,7,0,0),(70008,7,8,11040003,1,255,500,100,1,10,0,0,0,0,'[]',650,8,0,0),(70009,7,9,11040004,1,255,600,100,1,10,0,0,0,0,'[]',650,9,0,0),(70010,7,10,11040005,1,255,700,100,1,10,0,0,0,0,'[]',650,10,0,0),(80001,8,1,14110001,1,1,100,40,1,15,0,0,0,0,'[{is_kf_1vn_def},{kf_1vn_area,1}]',621,1,0,0),(80002,8,2,14110002,1,1,100,40,1,15,0,0,0,0,'[{is_kf_1vn_def},{kf_1vn_area,1}]',621,2,0,0),(80003,8,3,14110003,1,1,200,60,1,4,0,0,0,0,'[{is_kf_1vn_def},{kf_1vn_area,1}]',621,3,0,0),(80004,8,4,14110004,1,1,200,60,1,4,0,0,0,0,'[{is_kf_1vn_def},{kf_1vn_area,1}]',621,4,0,0),(80005,8,5,32030601,1,1,2430,26,1,10,0,0,0,0,'[{is_kf_1vn_def},{kf_1vn_area,1}]',621,5,0,0),(80006,8,6,14110001,1,2,100,60,1,6,0,0,0,0,'[{is_kf_1vn_def},{kf_1vn_area,1}]',621,6,0,0),(80007,8,7,14110002,1,2,100,60,1,6,0,0,0,0,'[{is_kf_1vn_def},{kf_1vn_area,1}]',621,7,0,0),(80008,8,8,32030501,1,2,810,43,1,4,0,0,0,0,'[{is_kf_1vn_def},{kf_1vn_area,1}]',621,8,0,0),(80009,8,9,14110001,1,1,100,40,1,15,0,0,0,0,'[{is_kf_1vn_def},{kf_1vn_area,2}]',621,9,0,0),(80010,8,10,14110002,1,1,100,40,1,15,0,0,0,0,'[{is_kf_1vn_def},{kf_1vn_area,2}]',621,10,0,0),(80011,8,11,14110003,1,1,200,60,1,4,0,0,0,0,'[{is_kf_1vn_def},{kf_1vn_area,2}]',621,11,0,0),(80012,8,12,14110004,1,1,200,60,1,4,0,0,0,0,'[{is_kf_1vn_def},{kf_1vn_area,2}]',621,12,0,0),(80013,8,13,32030701,1,1,2430,32,1,10,0,0,0,0,'[{is_kf_1vn_def},{kf_1vn_area,2}]',621,13,0,0),(80014,8,14,14110001,1,2,100,60,1,6,0,0,0,0,'[{is_kf_1vn_def},{kf_1vn_area,2}]',621,14,0,0),(80015,8,15,14110002,1,2,100,60,1,6,0,0,0,0,'[{is_kf_1vn_def},{kf_1vn_area,2}]',621,15,0,0),(80016,8,16,32030601,1,2,2430,37,1,4,0,0,0,0,'[{is_kf_1vn_def},{kf_1vn_area,2}]',621,16,0,0),(90001,9,1,14110001,1,1,100,50,1,10,0,0,0,0,'[{is_kf_1vn_challenger},{kf_1vn_area,1}]',621,17,0,0),(90002,9,2,14110002,1,1,100,50,1,10,0,0,0,0,'[{is_kf_1vn_challenger},{kf_1vn_area,1}]',621,18,0,0),(90003,9,3,32030501,1,1,810,37,1,4,0,0,0,0,'[{is_kf_1vn_challenger},{kf_1vn_area,1}]',621,19,0,0),(90004,9,4,14110001,1,2,100,80,1,4,0,0,0,0,'[{is_kf_1vn_challenger},{kf_1vn_area,1}]',621,20,0,0),(90005,9,5,14110002,1,2,100,80,1,4,0,0,0,0,'[{is_kf_1vn_challenger},{kf_1vn_area,1}]',621,21,0,0),(90006,9,6,32030401,1,2,270,44,1,2,0,0,0,0,'[{is_kf_1vn_challenger},{kf_1vn_area,1}]',621,22,0,0),(90007,9,7,14110001,1,1,100,50,1,10,0,0,0,0,'[{is_kf_1vn_challenger},{kf_1vn_area,2}]',621,23,0,0),(90008,9,8,14110002,1,1,100,50,1,10,0,0,0,0,'[{is_kf_1vn_challenger},{kf_1vn_area,2}]',621,24,0,0),(90009,9,9,32030601,1,1,2430,27,1,4,0,0,0,0,'[{is_kf_1vn_challenger},{kf_1vn_area,2}]',621,25,0,0),(90010,9,10,14110001,1,2,100,80,1,4,0,0,0,0,'[{is_kf_1vn_challenger},{kf_1vn_area,2}]',621,26,0,0),(90011,9,11,14110002,1,2,100,80,1,4,0,0,0,0,'[{is_kf_1vn_challenger},{kf_1vn_area,2}]',621,27,0,0),(90012,9,12,32030501,1,2,810,43,1,2,0,0,0,0,'[{is_kf_1vn_challenger},{kf_1vn_area,2}]',621,28,0,0),(110001,12,1,34020001,1,255,50,100,0,0,0,0,0,0,'[{lv,520,9999}]',0,0,1,0),(110025,12,2,34020005,1,255,400,100,0,0,0,0,0,0,'[{lv,600,9999}]',0,0,1,0),(110031,12,3,34020101,1,255,350,100,0,0,0,0,0,0,'[{lv,650,9999}]',0,0,1,0),(110055,12,4,34020105,1,255,3450,100,0,0,0,0,0,0,'[{lv,700,9999}]',0,0,1,0),(110061,12,5,34020201,1,255,2800,100,0,0,0,0,0,0,'[{lv,750,9999}]',0,0,1,0),(110085,12,6,34020205,1,255,29100,100,0,0,0,0,0,0,'[{lv,800,9999}]',0,0,1,0),(110091,12,7,34020301,1,255,27250,100,0,0,0,0,0,0,'[{lv,850,9999}]',0,0,1,0);
/*!40000 ALTER TABLE `base_shop` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_skill`
--

DROP TABLE IF EXISTS `base_skill`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_skill` (
  `id` int(10) unsigned NOT NULL,
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '技能名称@lang@',
  `about` varchar(128) NOT NULL COMMENT '技能备注@lang@',
  `career` int(11) NOT NULL COMMENT '所属职业:1-剑客，10-通用被动，11-怪物，12-宠物，14-坐骑，15-翅膀，16-法宝，17-神兵，18-披风，19-神兽，20-公会，21-副本。这里的职业指基础职业，同一个职业多次转生，但都属于同一基础职业。',
  `type` int(11) NOT NULL COMMENT '类型：1主动技能，2辅助技能，3被动技能',
  `is_normal` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否普攻(0|1)',
  `is_combo` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否副技能(0|1)',
  `is_anger` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否怒气技能(0|1)',
  `refind_target` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否重新选取目标(0|1)',
  `mod` tinyint(2) DEFAULT '1' COMMENT '攻击模式：1单体，2群体',
  `obj` tinyint(2) NOT NULL COMMENT '目标选取类型：1自己，2最近敌方，3最近队友，4朝向，5最少血队友，6指定怪物',
  `calc` int(11) NOT NULL COMMENT '是否计算伤害：0否，1是',
  `release` int(11) DEFAULT '1' COMMENT '技能释放模式：1普通，2蓄能，3移动施法',
  `around_hurt` int(11) NOT NULL COMMENT '群攻周围伤害比：1-1000',
  `range` int(11) NOT NULL COMMENT '群攻范围模式：1圆形，2直线，3扇形',
  `talent` varchar(128) CHARACTER SET ucs2 DEFAULT '[]' COMMENT '天赋技能id列表 [{技能id,概率(千分制),持续时间(毫秒)}...]',
  `combo` text NOT NULL COMMENT '连技[{技能id,ms},...]',
  `bullet_spd` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '子弹速度（填写在主技能）',
  `bullet_att_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '子弹检测时间',
  `count` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '子弹判定次数',
  `time` int(11) NOT NULL COMMENT '技能施放时间,ms',
  `skill_link` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '关联技能##[技能id,技能id...]',
  `rune_skill` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '符文技能 [skill_id]',
  `sex` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '性别',
  `broadcast` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '程序用，动作播放设置#（0客户端直接播放，1等服务端返回播）',
  `lv_data` text NOT NULL COMMENT '等级属性',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='技能数据';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_skill`
--

LOCK TABLES `base_skill` WRITE;
/*!40000 ALTER TABLE `base_skill` DISABLE KEYS */;
INSERT INTO `base_skill` VALUES (1001,'测试技能1眩晕5秒','',11,1,1,0,0,0,1,4,1,1,1000,2,'0','[]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"测试下技能1眩晕5秒\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"11000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"300\",\"num\":\"[1,1]\",\"attr\":\"[]\",\"hurt\":\"10000\",\"effect\":\"[{101,3,10000,4,0,0,0,5000,0,1}]\"}]'),(10001,'人物跳跃','',13,1,0,0,0,0,1,1,0,1,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(2100003,'攻击buff','',11,3,0,0,0,0,1,1,0,1,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"攻击加成\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"120000\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{1,1,1000,1,10000,100,60000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(2100004,'防御buff','',11,3,0,0,0,0,1,1,0,1,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"增加防御\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{4,1,1000,1,2000,100,60000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(2100005,'速度buff','',11,3,0,0,0,0,1,1,0,1,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"加速BUFF\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{18,2,1000,1,200,0,60000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(2100006,'禁疗buff','',10,3,0,0,0,0,1,1,0,1,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"禁疗BUFF\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{129,3,10000,1,0,0,0,72000,1,0}]\"}]'),(10011000,'男剑客展示','',0,0,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"0\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[]\",\"attr\":\"\",\"hurt\":\"0\",\"effect\":\"\"}]'),(10011001,'魔剑士普攻','职业技能',1,1,1,0,0,0,2,2,1,1,1000,3,'0','[]',0,0,0,500,'[10011001,10011002,10011003,10011004]','[16002050]',1,0,'[{\"desc\":\"对前方直线区域2个玩家（3个怪物）造成4段共205%的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"450\",\"area\":\"300\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"3500\",\"effect\":\"\"}]'),(10011002,'魔剑士普攻四连2','职业技能',1,1,1,0,0,0,2,2,1,1,1000,3,'0','[]',0,0,0,500,'[10011001,10011002,10011003,10011004]','[16002050]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"450\",\"area\":\"300\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"5000\",\"effect\":\"\"}]'),(10011003,'魔剑士普攻四连3','职业技能',1,1,1,0,0,0,2,2,1,1,1000,3,'0','[]',0,0,0,500,'[10011001,10011002,10011003,10011004]','[16002050]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"500\",\"trigger\":\"[]\",\"distance\":\"450\",\"area\":\"300\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"5000\",\"effect\":\"\"}]'),(10011004,'魔剑士普攻四连4','职业技能',1,1,1,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,800,'[10011001,10011002,10011003,10011004]','[16002050]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"[]\",\"distance\":\"450\",\"area\":\"300\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"7000\",\"effect\":\"\"}]'),(10011011,'华尔兹斩','职业技能',1,1,0,0,0,0,2,2,1,1,1000,1,'0','[{10011011,300,0},{10011012,200,0},{10011013,0,0}]',0,0,0,500,'0','[500000001,500000002]',1,0,'[{\"desc\":\"对周围圆形区域内的3个玩家（5个怪物）造成3段共130%的伤害\",\"condition\":\"[{lv,4}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"500\",\"num\":\"[3,5]\",\"attr\":\"\",\"hurt\":\"4300\",\"effect\":\"\"}]'),(10011012,'华尔兹斩-副1','职业技能',1,1,0,1,0,0,2,2,1,1,1000,1,'0','[{10011011,300,0},{10011012,200,0},{10011013,0,0}]',0,0,0,0,'0','[500000001,500000002]',1,0,'[{\"desc\":\"\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"500\",\"num\":\"[3,5]\",\"attr\":\"\",\"hurt\":\"4300\",\"effect\":\"\"}]'),(10011013,'华尔兹斩-副2','职业技能',1,1,0,1,0,0,2,2,1,1,1000,1,'0','[{10011011,300,0},{10011012,200,0},{10011013,0,0}]',0,0,0,0,'0','[500000001,500000002]',1,0,'[{\"desc\":\"\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"500\",\"num\":\"[3,5]\",\"attr\":\"\",\"hurt\":\"4400\",\"effect\":\"\"}]'),(10011021,'魔爪突刺','职业技能',1,1,0,0,0,0,2,2,1,1,1000,3,'0','[{10011021,200,0},{10011022,200,0},{10011023,0,0}]',0,0,0,600,'0','[500000003,500000004]',1,0,'[{\"desc\":\"对前方扇形区域4个玩家（5个怪物）造成3段共160%的伤害\",\"condition\":\"[{lv,13}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"6000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,5]\",\"attr\":\"\",\"hurt\":\"5300\",\"effect\":\"\"}]'),(10011022,'魔爪突刺-副1','职业技能',1,1,0,1,0,0,2,2,1,1,1000,3,'0','[{10011021,200,0},{10011022,200,0},{10011023,0,0}]',0,0,0,0,'0','[500000003]',1,0,'[{\"desc\":\"\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,5]\",\"attr\":\"\",\"hurt\":\"5300\",\"effect\":\"\"}]'),(10011023,'魔爪突刺-副2','职业技能',1,1,0,1,0,0,2,2,1,1,1000,3,'0','[{10011021,200,0},{10011022,200,0},{10011023,0,0}]',0,0,0,0,'0','[500000003]',1,0,'[{\"desc\":\"\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,5]\",\"attr\":\"\",\"hurt\":\"5400\",\"effect\":\"\"}]'),(10011031,'战意喷涌','职业技能',1,1,0,0,0,0,2,2,1,1,1000,1,'[{70100101,1000,8000}]','[{10011031,100,0},{10011032,100,0}]',0,0,0,800,'0','[500000005,500000006]',1,0,'[{\"desc\":\"对自身圆形区域5个玩家（6个怪物）造成190%的伤害\",\"condition\":\"[{lv,27}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"8000\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"500\",\"num\":\"[5,6]\",\"attr\":\"\",\"hurt\":\"19000\",\"effect\":\"\"}]'),(10011041,'虚空斩击','职业技能',1,1,0,0,0,0,2,2,1,1,1000,1,'[{70100401,1000,8000}]','[{10011041,200,0},{10011042,200,0},{10011043,250,0},{10011044,0,0}]',0,0,0,800,'0','[500000007,500000008]',1,0,'[{\"desc\":\"对小范围区域5个玩家（8个怪物）造成4段共360%的伤害\",\"condition\":\"[{lv,38}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"16000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"500\",\"num\":\"[5,8]\",\"attr\":\"\",\"hurt\":\"9000\",\"effect\":\"[]\"}]'),(10011042,'虚空斩击-副1','职业技能',1,1,0,1,0,0,2,2,1,1,1000,2,'0','[{10011041,200,0},{10011042,200,0},{10011043,250,0},{10011044,0,0}]',0,0,0,0,'0','[500000007]',1,0,'[{\"desc\":\"\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"500\",\"num\":\"[5,8]\",\"attr\":\"\",\"hurt\":\"9000\",\"effect\":\"\"}]'),(10011043,'虚空斩击-副2','职业技能',1,1,0,1,0,0,2,2,1,1,1000,2,'0','[{10011041,200,0},{10011042,200,0},{10011043,250,0},{10011044,0,0}]',0,0,0,0,'0','[500000007]',1,0,'[{\"desc\":\"\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"500\",\"num\":\"[5,8]\",\"attr\":\"\",\"hurt\":\"9000\",\"effect\":\"\"}]'),(10011044,'虚空斩击-副3','职业技能',1,1,0,1,0,0,2,2,1,1,1000,2,'0','[{10011041,200,0},{10011042,200,0},{10011043,250,0},{10011044,0,0}]',0,0,0,0,'0','[500000007]',1,0,'[{\"desc\":\"\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"500\",\"num\":\"[5,8]\",\"attr\":\"\",\"hurt\":\"9000\",\"effect\":\"\"}]'),(10011051,'强化普通攻击','职业技能',1,1,1,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,500,'[10011051,10011052,10011053,10011054]','[]',1,0,'[{\"desc\":\"对前方直线区域2个玩家（4个怪物）造成120%的伤害\",\"condition\":\"[{turn,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"433\",\"trigger\":\"[]\",\"distance\":\"300\",\"area\":\"200\",\"num\":\"[2,4]\",\"attr\":\"\",\"hurt\":\"12000\",\"effect\":\"\"}]'),(10011052,'男剑客强化普攻四连2','职业技能',1,1,1,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,500,'[10011051,10011052,10011053,10011054]','[]',1,0,'[{\"desc\":\"\",\"condition\":\"[{turn,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"367\",\"trigger\":\"[]\",\"distance\":\"300\",\"area\":\"200\",\"num\":\"[2,4]\",\"attr\":\"\",\"hurt\":\"12000\",\"effect\":\"\"}]'),(10011053,'男剑客强化普攻四连3','职业技能',1,1,1,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,500,'[10011051,10011052,10011053,10011054]','[]',1,0,'[{\"desc\":\"\",\"condition\":\"[{turn,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"700\",\"trigger\":\"[]\",\"distance\":\"300\",\"area\":\"200\",\"num\":\"[2,4]\",\"attr\":\"\",\"hurt\":\"12000\",\"effect\":\"\"}]'),(10011054,'男剑客强化普攻四连4','职业技能',1,1,1,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,800,'[10011051,10011052,10011053,10011054]','[]',1,0,'[{\"desc\":\"\",\"condition\":\"[{turn,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"1133\",\"trigger\":\"[]\",\"distance\":\"300\",\"area\":\"200\",\"num\":\"[2,4]\",\"attr\":\"\",\"hurt\":\"12000\",\"effect\":\"\"}]'),(10011061,'灼热震击','',1,1,0,0,0,0,2,2,1,1,1000,1,'0','[{10011061,100,0},{10011062,100,0}]',0,0,0,800,'0','[]',1,0,'[{\"desc\":\"对小范围区域3个玩家（3个怪物）造成400%的伤害，并晕眩1秒\",\"condition\":\"[{turn,2}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"12000\",\"trigger\":\"[]\",\"distance\":\"300\",\"area\":\"500\",\"num\":\"[3,3]\",\"attr\":\"\",\"hurt\":\"20000\",\"effect\":\"[{112,0,1000,1,150,0,0,0,0,0},{101,3,1000,4,0,0,0,1000,0,1}]\"}]'),(10011062,'灼热震击-副1','',1,1,0,1,0,0,2,2,1,1,1000,1,'0','[{10011061,100,0},{10011062,100,0}]',0,0,0,0,'0','[]',1,0,'[{\"desc\":\"\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"300\",\"area\":\"500\",\"num\":\"[3,3]\",\"attr\":\"\",\"hurt\":\"20000\",\"effect\":\"\"}]'),(10011063,'灼热震击-副2(暂不用）','',1,1,0,1,0,0,2,2,1,1,1000,1,'0','[{10011061,100,0},{10011062,100,0},{10011063,100,0}]',0,0,0,0,'0','[]',1,0,'[{\"desc\":\"\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"300\",\"area\":\"500\",\"num\":\"[3,3]\",\"attr\":\"\",\"hurt\":\"0\",\"effect\":\"\"}]'),(10011071,'聚能强吸','',1,1,0,0,0,0,1,2,1,1,0,0,'0','[{10011071,100,0},{10011072,100,0}]',0,0,0,900,'0','[]',1,0,'[{\"desc\":\"把敌方目标拉回身边并晕眩1秒，同时造成300%的伤害\",\"condition\":\"[{turn,3}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"30000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"0\",\"num\":\"[1,1]\",\"attr\":\"\",\"hurt\":\"15000\",\"effect\":\"[{112,3,1000,2,150,0,0,0,0,0},{101,3,1000,4,0,0,0,1000,0,1}]\"}]'),(10011072,'聚能强吸-副1','',1,1,0,1,0,0,1,2,1,1,0,0,'0','[{10011071,100,0},{10011072,100,0}]',0,0,0,0,'0','[]',1,0,'[{\"desc\":\"\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"0\",\"num\":\"[1,1]\",\"attr\":\"\",\"hurt\":\"15000\",\"effect\":\"\"}]'),(10011073,'聚能强吸-副2（暂不用）','',1,1,0,1,0,0,1,2,1,1,0,0,'0','[{10011071,100,0},{10011072,100,0},{10011073,100,0}]',0,0,0,0,'0','[]',1,0,'[{\"desc\":\"\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"0\",\"num\":\"[1,1]\",\"attr\":\"\",\"hurt\":\"0\",\"effect\":\"\"}]'),(10011081,'怒火回音','',1,3,0,0,0,0,1,1,1,1,0,0,'0','[]',0,0,0,900,'0','[]',1,0,'[{\"desc\":\"解除负面状态并瞬间回复10%血量，同时获得20%最大血量的护盾，持续5秒\",\"condition\":\"[{turn,3}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"60000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[1,0]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"[{118,0,1000,1,0,0,0,0,1,0},{116,0,1000,1,0,0.1,2,100,1,1},{104,1,1000,1,0,0.2,2,5000,0,0}]\"}]'),(10011091,'激爆冲撞','',1,1,0,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,600,'0','[]',1,0,'[{\"desc\":\"对目标角色造成200%的伤害，如果目标处于晕眩状态，则降低对方10%防御，持续3秒\",\"condition\":\"[{turn,3}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"60000\",\"trigger\":\"[{2,1000,0,1,0,0,101,4}]\",\"distance\":\"300\",\"area\":\"0\",\"num\":\"[1,1]\",\"attr\":\"[{4,2,1000,4,0,-0.3,1000,1,0}]\",\"hurt\":\"20000\",\"effect\":\"[{112,0,1000,1,150,0,0,0,0,0}]\"}]'),(10012000,'龙骑士展示','职业技能',0,0,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"0\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[]\",\"attr\":\"\",\"hurt\":\"0\",\"effect\":\"\"}]'),(10012001,'龙骑士普攻','职业技能',2,1,1,0,0,0,2,2,1,1,1000,3,'0','[]',0,0,0,500,'[10012001,10012002,10012003,10012004]','[16002050]',1,0,'[{\"desc\":\"对前方直线区域2个玩家（3个怪物）造成4段共200%的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"450\",\"area\":\"300\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"4000\",\"effect\":\"\"}]'),(10012002,'龙骑士普攻四连2','职业技能',2,1,1,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,500,'[10012001,10012002,10012003,10012004]','[16002050]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"450\",\"area\":\"300\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"5000\",\"effect\":\"\"}]'),(10012003,'龙骑士普攻四连3','职业技能',2,1,1,0,0,0,2,2,1,1,1000,3,'0','[]',0,0,0,500,'[10012001,10012002,10012003,10012004]','[16002050]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"500\",\"trigger\":\"[]\",\"distance\":\"450\",\"area\":\"300\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(10012004,'龙骑士普攻四连4','职业技能',2,1,1,0,0,0,2,2,1,1,1000,3,'0','[{10012004,100,0},{10012005,0,0}]',0,0,0,800,'[10012001,10012002,10012003,10012004]','[16002050]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"[]\",\"distance\":\"450\",\"area\":\"300\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"4000\",\"effect\":\"\"}]'),(10012005,'龙骑士普攻四连4-副1','职业技能',2,1,1,1,0,0,2,2,1,1,1000,3,'0','[{10012004,100,0},{10012005,0,0}]',0,0,0,800,'[]','[]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"1060\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"4000\",\"effect\":\"\"}]'),(10012011,'翔龙突刺','职业技能',2,1,0,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,500,'0','[500000021,500000022]',1,0,'[{\"desc\":\"对前方直线区域3个玩家（5个怪物）造成120%的伤害\",\"condition\":\"[{lv,4}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"400\",\"num\":\"[3,5]\",\"attr\":\"\",\"hurt\":\"12000\",\"effect\":\"[{113,4,1000,1,600,0,0,400,0,0}]\"}]'),(10012021,'流光枪舞','职业技能',2,1,0,0,0,0,2,2,1,1,1000,1,'0','[{10012021,200,0},{10012022,300,0},{10012023,300,0},{10012024,300,0},{10012025,300,0},{10012026,0,0}]',0,0,0,600,'0','[500000023,500000024]',1,0,'[{\"desc\":\"对周围圆形区域内的4个玩家（6个怪物）造成6段共340%的伤害\",\"condition\":\"[{lv,13}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"6000\",\"trigger\":\"[]\",\"distance\":\"300\",\"area\":\"500\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"5000\",\"effect\":\"\"}]'),(10012022,'流光枪舞-副1','职业技能',2,1,0,1,0,0,2,2,1,1,1000,1,'0','[{10012021,200,0},{10012022,300,0},{10012023,300,0},{10012024,300,0},{10012025,300,0},{10012026,0,0}]',0,0,0,600,'0','[500000023]',1,0,'[{\"desc\":\"对周围圆形区域4个玩家（8个怪物）造成300%的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"500\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"5000\",\"effect\":\"\"}]'),(10012023,'流光枪舞-副2','职业技能',2,1,0,1,0,0,2,2,1,1,1000,1,'0','[{10012021,200,0},{10012022,300,0},{10012023,300,0},{10012024,300,0},{10012025,300,0},{10012026,0,0}]',0,0,0,600,'0','[500000023]',1,0,'[{\"desc\":\"对周围圆形区域4个玩家（8个怪物）造成300%的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"2000\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"500\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"5000\",\"effect\":\"\"}]'),(10012024,'流光枪舞-副3','职业技能',2,1,0,1,0,0,2,2,1,1,1000,1,'0','[{10012021,200,0},{10012022,300,0},{10012023,300,0},{10012024,300,0},{10012025,300,0},{10012026,0,0}]',0,0,0,600,'0','[500000023]',1,0,'[{\"desc\":\"对周围圆形范围内的4个玩家（8个怪物）造成300%的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"2000\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"500\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"5000\",\"effect\":\"\"}]'),(10012025,'流光枪舞-副4','职业技能',2,1,0,1,0,0,2,2,1,1,1000,1,'0','[{10012021,200,0},{10012022,300,0},{10012023,300,0},{10012024,300,0},{10012025,300,0},{10012026,0,0}]',0,0,0,600,'0','[500000023]',1,0,'[{\"desc\":\"对周围圆形区域内4个玩家（8个怪物）造成300%的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"2000\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"500\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"5200\",\"effect\":\"\"}]'),(10012026,'流光枪舞-副5','职业技能',2,1,0,1,0,0,2,2,1,1,1000,1,'0','[{10012021,200,0},{10012022,300,0},{10012023,300,0},{10012024,300,0},{10012025,300,0},{10012026,0,0}]',0,0,0,600,'0','[500000023]',1,0,'[{\"desc\":\"对周围圆形区域内4个玩家（8个怪物）造成300%的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"2000\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"500\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"5200\",\"effect\":\"\"}]'),(10012031,'巨龙吐息','职业技能',2,1,0,0,0,0,2,2,1,1,1000,2,'[{70100111,1000,8000}]','[{10012031,300,0},{10012032,300,0},{10012033,0,0}]',0,0,0,800,'0','[500000025,500000026]',1,0,'[{\"desc\":\"对前方直线上的4个玩家（5个怪物）造成3段共220%的伤害\",\"condition\":\"[{lv,27}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"8000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"400\",\"num\":\"[4,5]\",\"attr\":\"\",\"hurt\":\"7000\",\"effect\":\"\"}]'),(10012032,'巨龙吐息-副1','职业技能',2,1,0,1,0,0,2,2,1,1,1000,2,'0','[{10012031,300,0},{10012032,300,0},{10012033,0,0}]',0,0,0,800,'0','[500000025,500000026]',1,0,'[{\"desc\":\"对前方直线上的5个玩家（10个怪物）造成400%的伤害\",\"condition\":\"[{lv,15}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"3000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"400\",\"num\":\"[4,5]\",\"attr\":\"\",\"hurt\":\"7000\",\"effect\":\"\"}]'),(10012033,'巨龙吐息-副2','职业技能',2,1,0,1,0,0,2,2,1,1,1000,2,'0','[{10012031,300,0},{10012032,300,0},{10012033,0,0}]',0,0,0,800,'0','[500000025,500000026]',1,0,'[{\"desc\":\"对前方直线上的5个玩家（10个怪物）造成400%的伤害\",\"condition\":\"[{lv,15}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"3000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"400\",\"num\":\"[4,5]\",\"attr\":\"\",\"hurt\":\"8000\",\"effect\":\"\"}]'),(10012041,'审判枪罚','职业技能',2,1,0,0,0,0,2,2,1,1,1000,1,'[{70100411,1000,8000}]','[{10012041,150,0},{10012042,0,0}]',0,0,0,800,'0','[500000027,500000028]',1,0,'[{\"desc\":\"对小范围区域5个玩家（8个怪物）造成2段共340%的伤害\",\"condition\":\"[{lv,38}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"16000\",\"trigger\":\"[]\",\"distance\":\"650\",\"area\":\"550\",\"num\":\"[5,8]\",\"attr\":\"\",\"hurt\":\"17000\",\"effect\":\"[]\"}]'),(10012042,'审判枪罚副1','职业技能',2,1,0,1,0,0,2,2,1,1,1000,1,'0','[{10012041,150,0},{10012042,0,0}]',0,0,0,800,'0','[500000027]',1,0,'[{\"desc\":\"对小范围区域5个玩家（8个怪物）造成400%的伤害\",\"condition\":\"[{lv,21}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"6000\",\"trigger\":\"[]\",\"distance\":\"650\",\"area\":\"550\",\"num\":\"[5,8]\",\"attr\":\"\",\"hurt\":\"17000\",\"effect\":\"\"}]'),(10012051,'强化普通攻击','职业技能',2,1,1,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,500,'[10011051,10011052,10011053,10011054]','[]',1,0,'[{\"desc\":\"对前方直线区域2个玩家（4个怪物）造成120%的伤害\",\"condition\":\"[{turn,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"433\",\"trigger\":\"[]\",\"distance\":\"300\",\"area\":\"200\",\"num\":\"[2,4]\",\"attr\":\"\",\"hurt\":\"12000\",\"effect\":\"\"}]'),(10012052,'龙骑士强化普攻四连2','职业技能',2,1,1,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,500,'[10011051,10011052,10011053,10011054]','[]',1,0,'[{\"desc\":\"\",\"condition\":\"[{turn,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"367\",\"trigger\":\"[]\",\"distance\":\"300\",\"area\":\"200\",\"num\":\"[2,4]\",\"attr\":\"\",\"hurt\":\"12000\",\"effect\":\"\"}]'),(10012053,'龙骑士强化普攻四连3','职业技能',2,1,1,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,500,'[10011051,10011052,10011053,10011054]','[]',1,0,'[{\"desc\":\"\",\"condition\":\"[{turn,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"700\",\"trigger\":\"[]\",\"distance\":\"300\",\"area\":\"200\",\"num\":\"[2,4]\",\"attr\":\"\",\"hurt\":\"12000\",\"effect\":\"\"}]'),(10012054,'龙骑士强化普攻四连4','职业技能',2,1,1,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,800,'[10011051,10011052,10011053,10011054]','[]',1,0,'[{\"desc\":\"\",\"condition\":\"[{turn,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"1133\",\"trigger\":\"[]\",\"distance\":\"300\",\"area\":\"200\",\"num\":\"[2,4]\",\"attr\":\"\",\"hurt\":\"12000\",\"effect\":\"\"}]'),(10012061,'灼热震击','',2,1,0,0,0,0,2,2,1,1,1000,1,'0','[{10011061,100,0},{10011062,100,0}]',0,0,0,800,'0','[]',1,0,'[{\"desc\":\"对小范围区域3个玩家（3个怪物）造成400%的伤害，并晕眩1秒\",\"condition\":\"[{turn,2}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"12000\",\"trigger\":\"[]\",\"distance\":\"300\",\"area\":\"500\",\"num\":\"[3,3]\",\"attr\":\"\",\"hurt\":\"20000\",\"effect\":\"[{112,0,1000,1,150,0,0,0,0,0},{101,3,1000,4,0,0,0,1000,0,1}]\"}]'),(10012062,'灼热震击-副1','',2,1,0,1,0,0,2,2,1,1,1000,1,'0','[{10011061,100,0},{10011062,100,0}]',0,0,0,0,'0','[]',1,0,'[{\"desc\":\"\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"300\",\"area\":\"500\",\"num\":\"[3,3]\",\"attr\":\"\",\"hurt\":\"20000\",\"effect\":\"\"}]'),(10012063,'灼热震击-副2(暂不用）','',2,1,0,1,0,0,2,2,1,1,1000,1,'0','[{10011061,100,0},{10011062,100,0},{10011063,100,0}]',0,0,0,0,'0','[]',1,0,'[{\"desc\":\"\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"300\",\"area\":\"500\",\"num\":\"[3,3]\",\"attr\":\"\",\"hurt\":\"0\",\"effect\":\"\"}]'),(10012071,'聚能强吸','',2,1,0,0,0,0,1,2,1,1,0,0,'0','[{10011071,100,0},{10011072,100,0}]',0,0,0,900,'0','[]',1,0,'[{\"desc\":\"把敌方目标拉回身边并晕眩1秒，同时造成300%的伤害\",\"condition\":\"[{turn,3}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"30000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"0\",\"num\":\"[1,1]\",\"attr\":\"\",\"hurt\":\"15000\",\"effect\":\"[{112,3,1000,2,150,0,0,0,0,0},{101,3,1000,4,0,0,0,1000,0,1}]\"}]'),(10012072,'聚能强吸-副1','',2,1,0,1,0,0,1,2,1,1,0,0,'0','[{10011071,100,0},{10011072,100,0}]',0,0,0,0,'0','[]',1,0,'[{\"desc\":\"\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"0\",\"num\":\"[1,1]\",\"attr\":\"\",\"hurt\":\"15000\",\"effect\":\"\"}]'),(10012073,'聚能强吸-副2（暂不用）','',2,1,0,1,0,0,1,2,1,1,0,0,'0','[{10011071,100,0},{10011072,100,0},{10011073,100,0}]',0,0,0,0,'0','[]',1,0,'[{\"desc\":\"\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"0\",\"num\":\"[1,1]\",\"attr\":\"\",\"hurt\":\"0\",\"effect\":\"\"}]'),(10012081,'怒火回音','',2,3,0,0,0,0,1,1,1,1,0,0,'0','[]',0,0,0,900,'0','[]',1,0,'[{\"desc\":\"解除负面状态并瞬间回复10%血量，同时获得20%最大血量的护盾，持续5秒\",\"condition\":\"[{turn,3}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"60000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[1,0]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"[{118,0,1000,1,0,0,0,0,1,0},{116,0,1000,1,0,0.1,2,100,1,1},{104,1,1000,1,0,0.2,2,5000,0,0}]\"}]'),(10012091,'激爆冲撞','',2,1,0,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,600,'0','[]',1,0,'[{\"desc\":\"对目标角色造成200%的伤害，如果目标处于晕眩状态，则降低对方10%防御，持续3秒\",\"condition\":\"[{turn,3}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"60000\",\"trigger\":\"[{2,1000,0,1,0,0,101,4}]\",\"distance\":\"300\",\"area\":\"0\",\"num\":\"[1,1]\",\"attr\":\"[{4,2,1000,4,0,-0.3,1000,1,0}]\",\"hurt\":\"20000\",\"effect\":\"[{112,0,1000,1,150,0,0,0,0,0}]\"}]'),(10013000,'女剑客展示','',0,0,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"0\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[]\",\"attr\":\"\",\"hurt\":\"0\",\"effect\":\"\"}]'),(10013001,'魔导士普攻','职业技能',3,1,1,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,433,'[10013001,10013002,10013003,10013004]','[]',2,0,'[{\"desc\":\"对前方直线区域2个玩家（2个怪物）造成100%的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"330\",\"trigger\":\"[]\",\"distance\":\"1000\",\"area\":\"200\",\"num\":\"[2,2]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(10013002,'魔导士普攻四连2','职业技能',3,1,1,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,367,'[10013001,10013002,10013003,10013004]','[]',2,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"360\",\"trigger\":\"[]\",\"distance\":\"1000\",\"area\":\"200\",\"num\":\"[2,2]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(10013003,'魔导士普攻四连3','职业技能',3,1,1,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,700,'[10013001,10013002,10013003,10013004]','[]',2,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"430\",\"trigger\":\"[]\",\"distance\":\"1000\",\"area\":\"200\",\"num\":\"[2,2]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(10013004,'魔导士普攻四连4','职业技能',3,1,1,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,1133,'[10013001,10013002,10013003,10013004]','[]',2,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"1260\",\"trigger\":\"[]\",\"distance\":\"1000\",\"area\":\"200\",\"num\":\"[2,2]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(10013011,'灼热射线','职业技能',3,1,0,0,0,0,2,2,1,1,1000,2,'0','[{10013011,100,0},{10013012,100,0}]',0,0,0,500,'0','[500000031,500000032]',2,0,'[{\"desc\":\"对前方直线区域3个玩家（6个怪物）造成200%的伤害\",\"condition\":\"[{lv,6}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"1000\",\"area\":\"500\",\"num\":\"[3,6]\",\"attr\":\"\",\"hurt\":\"20000\",\"effect\":\"\"}]'),(10013012,'灼热射线-副1','职业技能',3,1,0,1,0,0,2,2,1,1,1000,2,'0','[{10013011,100,0},{10013012,100,0}]',0,0,0,500,'0','[500000031,500000032]',2,0,'[{\"desc\":\"\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"300\",\"area\":\"500\",\"num\":\"[3,6]\",\"attr\":\"\",\"hurt\":\"20000\",\"effect\":\"\"}]'),(10013021,'冰霜践踏','职业技能',3,1,0,0,0,0,2,2,1,1,1000,2,'0','[{10013021,100,0},{10013022,100,0}]',0,0,0,1200,'0','[500000033,500000034]',2,0,'[{\"desc\":\"对前方扇形区域4个玩家（8个怪物）造成300%的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"6000\",\"trigger\":\"[]\",\"distance\":\"300\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"15000\",\"effect\":\"\"}]'),(10013022,'冰霜践踏-副1','职业技能',3,1,0,1,0,0,2,2,1,1,1000,2,'0','[{10013021,100,0},{10013022,100,0}]',0,0,0,0,'0','[]',2,0,'[{\"desc\":\"\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"300\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"15000\",\"effect\":\"\"}]'),(10013031,'漫天花火','职业技能',3,1,0,0,0,0,2,1,1,1,1000,1,'0','[{10013031,100,0},{10013032,100,0}]',0,0,0,1267,'0','[500000035,500000036]',2,0,'[{\"desc\":\"对自身圆形区域5个玩家（10个怪物）造成400%的伤害\",\"condition\":\"[{lv,15}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"8000\",\"trigger\":\"[]\",\"distance\":\"300\",\"area\":\"500\",\"num\":\"[5,10]\",\"attr\":\"\",\"hurt\":\"20000\",\"effect\":\"\"}]'),(10013032,'漫天花火-副1','职业技能',3,1,0,1,0,0,2,1,1,1,1000,1,'0','[{10013031,100,0},{10013032,100,0}]',0,0,0,0,'0','[]',2,0,'[{\"desc\":\"\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"300\",\"area\":\"500\",\"num\":\"[5,10]\",\"attr\":\"\",\"hurt\":\"20000\",\"effect\":\"\"}]'),(10013041,'霜寒领域','职业技能',3,1,0,0,0,0,2,2,1,1,1000,1,'0','[{10013041,100,0},{10013042,100,0}]',0,0,0,1167,'0','[500000037,500000038]',2,0,'[{\"desc\":\"对自身圆形区域5个玩家（10个怪物）造成400%的伤害\",\"condition\":\"[{lv,21}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"16000\",\"trigger\":\"[]\",\"distance\":\"300\",\"area\":\"500\",\"num\":\"[3,3]\",\"attr\":\"\",\"hurt\":\"20000\",\"effect\":\"[]\"}]'),(10013042,'霜寒领域-副1','职业技能',3,1,0,1,0,0,2,2,1,1,1000,1,'0','[{10013041,100,0},{10013042,100,0}]',0,0,0,0,'0','[]',2,0,'[{\"desc\":\"\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"300\",\"area\":\"500\",\"num\":\"[3,3]\",\"attr\":\"\",\"hurt\":\"20000\",\"effect\":\"\"}]'),(10013051,'强化普通攻击','',3,1,1,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,433,'[10012051,10012052,10012053,10012054]','[]',2,0,'[{\"desc\":\"对前方直线区域2个玩家（4个怪物）造成120%的伤害\",\"condition\":\"[{turn,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"330\",\"trigger\":\"[]\",\"distance\":\"300\",\"area\":\"200\",\"num\":\"[2,4]\",\"attr\":\"\",\"hurt\":\"12000\",\"effect\":\"\"}]'),(10013052,'女剑客强化普攻四连2','',3,1,1,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,367,'[10012051,10012052,10012053,10012054]','[]',2,0,'[{\"desc\":\"\",\"condition\":\"[{turn,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"360\",\"trigger\":\"[]\",\"distance\":\"300\",\"area\":\"200\",\"num\":\"[2,4]\",\"attr\":\"\",\"hurt\":\"12000\",\"effect\":\"\"}]'),(10013053,'女剑客强化普攻四连3','',3,1,1,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,700,'[10012051,10012052,10012053,10012054]','[]',2,0,'[{\"desc\":\"\",\"condition\":\"[{turn,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"430\",\"trigger\":\"[]\",\"distance\":\"300\",\"area\":\"200\",\"num\":\"[2,4]\",\"attr\":\"\",\"hurt\":\"12000\",\"effect\":\"\"}]'),(10013054,'女剑客强化普攻四连4','',3,1,1,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,1133,'[10012051,10012052,10012053,10012054]','[]',2,0,'[{\"desc\":\"\",\"condition\":\"[{turn,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"1260\",\"trigger\":\"[]\",\"distance\":\"300\",\"area\":\"200\",\"num\":\"[2,4]\",\"attr\":\"\",\"hurt\":\"12000\",\"effect\":\"\"}]'),(10013061,'凝霜震波','',3,1,0,0,0,0,2,2,1,1,1000,1,'0','[{10012061,100,0},{10012062,100,0}]',0,0,0,1167,'0','[]',2,0,'[{\"desc\":\"对小范围区域3个玩家（3个怪物）造成400%的伤害，并晕眩1秒\",\"condition\":\"[{turn,2}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"12000\",\"trigger\":\"[]\",\"distance\":\"300\",\"area\":\"500\",\"num\":\"[3,3]\",\"attr\":\"\",\"hurt\":\"20000\",\"effect\":\"[{112,0,1000,1,150,0,0,0,0,0},{101,3,1000,4,0,0,0,1000,0,1}]\"}]'),(10013062,'凝霜震波-副1','',3,1,0,1,0,0,2,2,1,1,1000,1,'0','[{10012061,100,0},{10012062,100,0}]',0,0,0,0,'0','[]',2,0,'[{\"desc\":\"\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"300\",\"area\":\"500\",\"num\":\"[3,3]\",\"attr\":\"\",\"hurt\":\"20000\",\"effect\":\"\"}]'),(10013063,'凝霜震波-副2（暂不用）','',3,1,0,1,0,0,2,2,1,1,1000,1,'0','[{10012061,100,0},{10012062,100,0},{10012063,100,0}]',0,0,0,0,'0','[]',2,0,'[{\"desc\":\"\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"300\",\"area\":\"500\",\"num\":\"[3,3]\",\"attr\":\"\",\"hurt\":\"0\",\"effect\":\"\"}]'),(10013071,'霜语狂吸','',3,1,0,0,0,0,1,2,1,1,0,0,'0','[{10012071,100,0},{10012072,100,0}]',0,0,0,1267,'0','[]',2,0,'[{\"desc\":\"把敌方目标拉回身边并晕眩1秒，同时造成300%的伤害\",\"condition\":\"[{turn,3}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"30000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"0\",\"num\":\"[1,1]\",\"attr\":\"\",\"hurt\":\"15000\",\"effect\":\"[{112,3,1000,2,150,0,0,0,0,0},{101,3,1000,4,0,0,0,1000,0,1}]\"}]'),(10013072,'霜语狂吸-副1','',3,1,0,1,0,0,1,2,1,1,0,0,'0','[{10012071,100,0},{10012072,100,0}]',0,0,0,0,'0','[]',2,0,'[{\"desc\":\"\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"0\",\"num\":\"[1,1]\",\"attr\":\"\",\"hurt\":\"15000\",\"effect\":\"\"}]'),(10013073,'霜语狂吸-副2（暂不用）','',3,1,0,1,0,0,1,2,1,1,0,0,'0','[{10012071,100,0},{10012072,100,0},{10012073,100,0}]',0,0,0,0,'0','[]',2,0,'[{\"desc\":\"\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"0\",\"num\":\"[1,1]\",\"attr\":\"\",\"hurt\":\"0\",\"effect\":\"\"}]'),(10013081,'破冰信语','',3,3,0,0,0,0,1,1,1,1,0,0,'0','[]',0,0,0,1267,'0','[]',2,0,'[{\"desc\":\"解除负面状态并瞬间回复10%血量，同时获得20%最大血量的护盾，持续5秒\",\"condition\":\"[{turn,3}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"60000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[1,0]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"[{118,0,1000,1,0,0,0,0,1,0},{116,0,1000,1,0,0.1,2,100,1,1},{104,1,1000,1,0,0.2,2,5000,0,0}]\"}]'),(10013091,'冻土破怒','',3,1,0,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,733,'0','[]',2,0,'[{\"desc\":\"对目标角色造成200%的伤害，如果目标处于晕眩状态，则降低对方10%防御，持续3秒\",\"condition\":\"[{turn,3}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"60000\",\"trigger\":\"[{2,1000,0,1,0,0,101,4}]\",\"distance\":\"300\",\"area\":\"0\",\"num\":\"[1,1]\",\"attr\":\"[{4,2,1000,4,0,-0.3,1000,1,0}]\",\"hurt\":\"20000\",\"effect\":\"[{112,0,1000,1,150,0,0,0,0,0}]\"}]'),(10014001,'重炮手普攻','职业技能',4,1,1,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,500,'[10014001,10014002,10014003,10014004]','[16002050]',2,0,'[{\"desc\":\"对前方直线区域2个玩家（3个怪物）造成4段共180%的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"300\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"2000\",\"effect\":\"\"}]'),(10014002,'重炮手普攻四连2','职业技能',4,1,1,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,500,'[10014001,10014002,10014003,10014004]','[16002050]',2,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"300\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"3000\",\"effect\":\"\"}]'),(10014003,'重炮手普攻四连3','职业技能',4,1,1,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,500,'[10014001,10014002,10014003,10014004]','[16002050]',2,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"300\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"5000\",\"effect\":\"\"}]'),(10014004,'重炮手普攻四连4','职业技能',4,1,1,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,800,'[10014001,10014002,10014003,10014004]','[16002050]',2,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"300\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"8000\",\"effect\":\"\"}]'),(10014011,'零距喷射','职业技能',4,1,0,0,0,0,2,2,1,1,1000,2,'0','[{10014011,200,0},{10014012,200,0},{10014013,0,0}]',0,0,0,500,'0','[500000041,500000042]',2,0,'[{\"desc\":\"对前方直线区域3个玩家（5个怪物）造成3段共150%的伤害\",\"condition\":\"[{lv,4}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"400\",\"num\":\"[3,5]\",\"attr\":\"\",\"hurt\":\"5000\",\"effect\":\"[]\"}]'),(10014012,'零距喷射-副1','职业技能',4,1,0,1,0,0,2,2,1,1,1000,2,'0','[{10014011,200,0},{10014012,200,0},{10014013,0,0}]',0,0,0,800,'0','[500000041]',2,0,'[{\"desc\":\"对前方直线上的5个玩家（10个怪物）造成400%的伤害\",\"condition\":\"[{lv,15}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"3000\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"400\",\"num\":\"[4,5]\",\"attr\":\"\",\"hurt\":\"5000\",\"effect\":\"\"}]'),(10014013,'零距喷射-副2','职业技能',4,1,0,1,0,0,2,2,1,1,1000,2,'0','[{10014011,200,0},{10014012,200,0},{10014013,0,0}]',0,0,0,0,'0','[500000041]',2,0,'[{\"desc\":\"对前方直线上的5个玩家（10个怪物）造成400%的伤害\",\"condition\":\"[{lv,15}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"3000\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"400\",\"num\":\"[4,5]\",\"attr\":\"\",\"hurt\":\"5000\",\"effect\":\"\"}]'),(10014021,'黑洞效应','职业技能',4,1,0,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,500,'0','[500000043,500000044]',2,0,'[{\"desc\":\"对前方直线区域3个玩家（6个怪物）造成200%的伤害\",\"condition\":\"[{lv,13}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"6000\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"400\",\"num\":\"[3,6]\",\"attr\":\"\",\"hurt\":\"20000\",\"effect\":\"[]\"}]'),(10014031,'重力磁场','职业技能',4,1,0,0,0,0,2,2,1,1,1000,1,'[{70100121,1000,8000}]','[{10014031,200,0},{10014032,200,0},{10014033,300,0},{10014034,0,0}]',0,0,0,600,'0','[500000045,500000046]',2,0,'[{\"desc\":\"对周围圆形区域内的4个玩家（5个怪物）造成4段共290%的伤害\",\"condition\":\"[{lv,27}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"8000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"500\",\"num\":\"[4,5]\",\"attr\":\"\",\"hurt\":\"7000\",\"effect\":\"\"}]'),(10014032,'重力磁场-副1','职业技能',4,1,0,1,0,0,2,2,1,1,1000,1,'0','[{10014031,200,0},{10014032,200,0},{10014033,300,0},{10014034,0,0}]',0,0,0,600,'0','[500000045]',2,0,'[{\"desc\":\"对周围圆形区域4个玩家（5个怪物）造成300%的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"2000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"500\",\"num\":\"[4,5]\",\"attr\":\"\",\"hurt\":\"7000\",\"effect\":\"\"}]'),(10014033,'重力磁场-副2','职业技能',4,1,0,1,0,0,2,2,1,1,1000,1,'0','[{10014031,200,0},{10014032,200,0},{10014033,300,0},{10014034,0,0}]',0,0,0,600,'0','[500000045]',2,0,'[{\"desc\":\"对周围圆形区域4个玩家（5个怪物）造成300%的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"2000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"500\",\"num\":\"[4,5]\",\"attr\":\"\",\"hurt\":\"7000\",\"effect\":\"\"}]'),(10014034,'重力磁场-副3','职业技能',4,1,0,1,0,0,2,2,1,1,1000,1,'0','[{10014031,200,0},{10014032,200,0},{10014033,300,0},{10014034,0,0}]',0,0,0,600,'0','[500000045]',2,0,'[{\"desc\":\"对周围圆形范围内的4个玩家（5个怪物）造成300%的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"2000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"500\",\"num\":\"[4,5]\",\"attr\":\"\",\"hurt\":\"8000\",\"effect\":\"\"}]'),(10014041,'暴走轰炸','职业技能',4,1,0,0,0,0,2,2,1,1,1000,1,'[{70100421,1000,8000}]','[{10014041,200,0},{10014042,100,0},{10014043,0,0}]',0,0,0,800,'0','[500000047,500000048]',2,0,'[{\"desc\":\"对小范围区域5个玩家（8个怪物）造成3段共340%的伤害\",\"condition\":\"[{lv,38}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"16000\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"500\",\"num\":\"[5,8]\",\"attr\":\"\",\"hurt\":\"11000\",\"effect\":\"[]\"}]'),(10014042,'暴走轰炸-副1','职业技能',4,1,0,1,0,0,2,2,1,1,1000,2,'0','[{10014041,200,0},{10014042,100,0},{10014043,0,0}]',0,0,0,0,'0','[500000047]',2,0,'[{\"desc\":\"\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"500\",\"num\":\"[5,8]\",\"attr\":\"\",\"hurt\":\"11000\",\"effect\":\"\"}]'),(10014043,'暴走轰炸-副2','职业技能',4,1,0,1,0,0,2,2,1,1,1000,2,'0','[{10014041,200,0},{10014042,100,0},{10014043,0,0}]',0,0,0,0,'0','[500000047]',2,0,'[{\"desc\":\"\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"500\",\"num\":\"[5,8]\",\"attr\":\"\",\"hurt\":\"12000\",\"effect\":\"\"}]'),(11000001,'虔信誓语','废弃',10,2,0,0,0,0,1,1,0,0,0,0,'0','[]',0,0,0,733,'0','[]',0,0,'[{\"desc\":\"每10秒回复玩家5%的生命\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,201,500}]\",\"cd\":\"10000\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(11000002,'恶魔契约','圣器技能',10,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"增加30%人物经验获得\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,202,3000}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(11000003,'零度寒雀','圣器技能',10,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"被晕眩时有10%概率免除晕眩，冷却时间60秒\",\"condition\":\"\",\"power\":\"12000\",\"base_attr\":\"\",\"cd\":\"60000\",\"trigger\":\"[{1,1000,0,4,0,0,101,110}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{110,0,100,1,0,0,0,0,1,0}]\"}]'),(11000004,'光明号角','圣器技能',10,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"攻击boss时伤害增加10%\",\"condition\":\"\",\"power\":\"2500\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,1,0,0,0,203}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{203,0,1000,1,1000,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(11000005,'镜面盾铠','圣器技能',10,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"增加10%的固定伤害和固定防御\",\"condition\":\"\",\"power\":\"12000\",\"base_attr\":\"[{0,29,1000},{0,30,1000}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(11000006,'灵魂斗篷','圣器技能',10,2,0,0,0,0,1,1,0,0,0,0,'0','[]',0,0,0,1267,'0','[]',0,0,'[{\"desc\":\"增加人物移动速度10%\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,59,1000}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(11000007,'祷告之书','圣器技能',10,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"玩家职业技能伤害增加10%\",\"condition\":\"\",\"power\":\"4000\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,1,0,0,0,27}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{27,0,1000,1,1000,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(11000008,'磐石之力','坐骑技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"减免自身受到的伤害5%，PVP时减免10%\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,10,500}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(11000009,'死亡圣杯','圣器技能',10,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"攻击时有5%概率使敌人减速10%，持续3秒\",\"condition\":\"\",\"power\":\"4000\",\"base_attr\":\"\",\"cd\":\"60000\",\"trigger\":\"[{0,1000,0,1,0,0,0,121}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{121,2,50,4,0,-0.1,0,3000,0,0}]\"}]'),(11000010,'起源之水','圣器技能',10,2,0,0,0,0,0,1,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"为屏幕范围内的自己和队友反弹敌人5%的伤害\",\"condition\":\"\",\"power\":\"7000\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,4,0,0,0,115}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{115,0,1000,1,0,0.05,0,100,1,1}]\"}]'),(11000011,'霜语皇冠','圣器技能',0,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"每次受到攻击有10%的几率减免30%的伤害\",\"condition\":\"\",\"power\":\"2500\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,2,0,0,0,10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,100,1,3000,0,0,0,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(11000012,'冥府之钥','圣器技能',16,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"攻击时有5%的概率提高自己3%的破甲，持续5秒\",\"condition\":\"\",\"power\":\"7000\",\"base_attr\":\"\",\"cd\":\"30000\",\"trigger\":\"[{0,1000,0,1,0,0,0,3}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,50,1,0,0.03,5000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(11000013,'起源之火','圣器技能',18,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"血量低于25%时，暴击提高20%，持续10秒\",\"condition\":\"\",\"power\":\"7000\",\"base_attr\":\"\",\"cd\":\"10000\",\"trigger\":\"[{3,1000,0,0,0,0.25,0,13}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{13,0,1000,1,2000,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(14000001,'镇魂十字','圣器技能',10,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"每10秒回复玩家5%的生命\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,201,500}]\",\"cd\":\"10000\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14000002,'迅捷之力','坐骑技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"提高30点移动速度\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,18,30}]\",\"cd\":\"\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14000004,'缠绕之力','坐骑技能',14,2,0,0,0,0,0,2,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"攻击时有10%概率降低敌人15%的移动速度，持续3秒\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"30000\",\"trigger\":\"[{0,1000,0,1,0,0,0,121}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{121,0,100,4,0,-0.2,0,3000,0,0}]\"}]'),(14000005,'盾防之力','坐骑技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"受伤害时，有5%的概率提高20%的伤害减免，持续3秒，冷却20秒\",\"condition\":\"[]\",\"power\":\"2000\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[{0,1000,0,2,0,0,0,10}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{10,0,50,1,2000,0,5000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(14000006,'金刚之力','坐骑技能',14,2,0,0,0,0,0,1,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"伤害减免10%\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,10,1000}]\",\"cd\":\"\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14010001,'异兽之体','赤炎飓风幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"生命+12200\\\\n<color@7>战力+12200</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,2,12200}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14010002,'异兽之魂','赤炎飓风幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"攻击+1020\\\\n<color@7>战力+20400</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,1,1020}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14010003,'异兽之灵','赤炎飓风幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"抗暴+612\\\\n<color@7>战力+30600</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,49,612}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14010004,'异兽之护','赤炎飓风幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"生命+20400\\\\n攻击+1020\\\\n<color@7>战力+40800</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,2,20400},{0,1,1020}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14020001,'异兽之体','旋翼飞空艇幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"生命+6100\\\\n<color@7>战力+6100</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,2,6100}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14020002,'异兽之魂','旋翼飞空艇幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"攻击+510\\\\n<color@7>战力+10200</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,1,510}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14020003,'异兽之灵','旋翼飞空艇幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"抗暴+304\\\\n<color@7>战力+15200</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,49,304}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14020004,'异兽之护','旋翼飞空艇幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"生命+10150\\\\n攻击+508\\\\n<color@7>战力+20300</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,2,10150},{0,1,508}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14030001,'异兽之体','呆萌兔幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"生命+4200\\\\n<color@7>战力+4200</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,2,4200}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14030002,'异兽之魂','呆萌兔幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"攻击+355\\\\n<color@7>战力+7100</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,1,355}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14030003,'异兽之灵','呆萌兔幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"抗暴+212\\\\n<color@7>战力+10600</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,49,212}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14030004,'异兽之护','呆萌兔幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"生命+7050\\\\n攻击+353\\\\n<color@7>战力+14100</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,2,7050},{0,1,353}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14040001,'异兽之体','尸烬龙幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"生命+79300\\\\n<color@7>战力+79300</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,2,79300}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14040002,'异兽之魂','尸烬龙幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"攻击+6605\\\\n<color@7>战力+132100</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,1,6605}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14040003,'异兽之灵','尸烬龙幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"抗暴+3964\\\\n<color@7>战力+198200</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,49,3964}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14040004,'异兽之护','尸烬龙幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"生命+132150\\\\n攻击+6608\\\\n<color@7>战力+264300</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,2,132150},{0,1,6608}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14050001,'异兽之体','利维坦幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"生命+17800\\\\n<color@7>战力+17800</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,2,17800}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14050002,'异兽之魂','利维坦幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"攻击+1480\\\\n<color@7>战力+29600</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,1,1480}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14050003,'异兽之灵','利维坦幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"抗暴+888\\\\n<color@7>战力+44400</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,49,888}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14050004,'异兽之护','利维坦幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"生命+29600\\\\n攻击+1480\\\\n<color@7>战力+59200</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,2,29600},{0,1,1480}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14060001,'异兽之体','旅行蜗牛幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"生命+7900\\\\n<color@7>战力+7900</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,2,7900}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14060002,'异兽之魂','旅行蜗牛幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"攻击+660\\\\n<color@7>战力+13200</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,1,660}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14060003,'异兽之灵','旅行蜗牛幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"抗暴+396\\\\n<color@7>战力+19800</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,49,396}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14060004,'异兽之护','旅行蜗牛幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"生命+13200\\\\n攻击+660\\\\n<color@7>战力+26400</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,2,13200},{0,1,660}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14070001,'异兽之体','机械达人幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"生命+22000\\\\n<color@7>战力+22000</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,2,22000}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14070002,'异兽之魂','机械达人幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"攻击+1835\\\\n<color@7>战力+36700</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,1,1835}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14070003,'异兽之灵','机械达人幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"抗暴+1102\\\\n<color@7>战力+55100</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,49,1102}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14070004,'异兽之护','机械达人幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"生命+36700\\\\n攻击+1835\\\\n<color@7>战力+73400</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,2,36700},{0,1,1835}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14080001,'异兽之体','猫咪飞椅幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"生命+22600\\\\n<color@7>战力+22600</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,2,22600}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14080002,'异兽之魂','猫咪飞椅幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"攻击+1885\\\\n<color@7>战力+37700</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,1,1885}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14080003,'异兽之灵','猫咪飞椅幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"抗暴+1132\\\\n<color@7>战力+56600</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,49,1132}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14080004,'异兽之护','猫咪飞椅幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"生命+37750\\\\n攻击+1888\\\\n<color@7>战力+75500</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,2,37750},{0,1,1888}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14090001,'异兽之体','魔法飞毯幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"生命+23300\\\\n<color@7>战力+23300</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,2,23300}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14090002,'异兽之魂','魔法飞毯幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"攻击+1940\\\\n<color@7>战力+38800</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,1,1940}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14090003,'异兽之灵','魔法飞毯幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"抗暴+1162\\\\n<color@7>战力+58100</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,49,1162}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14090004,'异兽之护','魔法飞毯幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"生命+38750\\\\n攻击+1938\\\\n<color@7>战力+77500</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,2,38750},{0,1,1938}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14100001,'异兽之体','白熊首领幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"生命+23900\\\\n<color@7>战力+23900</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,2,23900}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14100002,'异兽之魂','白熊首领幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"攻击+1990\\\\n<color@7>战力+39800</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,1,1990}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14100003,'异兽之灵','白熊首领幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"抗暴+1194\\\\n<color@7>战力+59700</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,49,1194}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14100004,'异兽之护','白熊首领幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"生命+39800\\\\n攻击+1990\\\\n<color@7>战力+79600</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,2,39800},{0,1,1990}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14110001,'异兽之体','夏日闲鸭幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"生命+21400\\\\n<color@7>战力+21400</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,2,21400}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14110002,'异兽之魂','夏日闲鸭幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"攻击+1785\\\\n<color@7>战力+35700</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,1,1785}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14110003,'异兽之灵','夏日闲鸭幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"抗暴+1070\\\\n<color@7>战力+53500</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,49,1070}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14110004,'异兽之护','夏日闲鸭幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"生命+35700\\\\n攻击+1785\\\\n<color@7>战力+71400</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,2,35700},{0,1,1785}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14120001,'异兽之体','科技魔狼幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"生命+21400\\\\n<color@7>战力+21400</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,2,21400}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14120002,'异兽之魂','科技魔狼幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"攻击+1785\\\\n<color@7>战力+35700</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,1,1785}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14120003,'异兽之灵','科技魔狼幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"抗暴+1070\\\\n<color@7>战力+53500</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,49,1070}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14120004,'异兽之护','科技魔狼幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"生命+35700\\\\n攻击+1785\\\\n<color@7>战力+71400</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,2,35700},{0,1,1785}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14130001,'异兽之体','大佬座驾幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"生命+21400\\\\n<color@7>战力+21400</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,2,21400}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14130002,'异兽之魂','大佬座驾幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"攻击+1785\\\\n<color@7>战力+35700</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,1,1785}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14130003,'异兽之灵','大佬座驾幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"抗暴+1070\\\\n<color@7>战力+53500</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,49,1070}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(14130004,'异兽之护','大佬座驾幻化技能',14,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"生命+35700\\\\n攻击+1785\\\\n<color@7>战力+71400</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,2,35700},{0,1,1785}]\",\"cd\":\"\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(16000001,'闪电锁链','宝具技能',16,1,1,0,0,0,1,6,1,1,1000,0,'0','[]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"对三个目标造成150%的伤害\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"1000\",\"trigger\":\"\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[3,3]\",\"attr\":\"\",\"hurt\":\"15000\",\"effect\":\"\"}]'),(16000002,'腐蚀之力','宝具技能',16,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"攻击时有5%的概率降低对方30%的防御，持续3秒\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"30000\",\"trigger\":\"[{0,1000,0,1,0,0,0,4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,50,4,0,-0.3,3000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(16000003,'宝具之光','宝具技能',16,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"提高宝具攻击属性30%\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{168,60,3000}]\",\"cd\":\"\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(16000004,'穿透之力','宝具技能',16,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"攻击时有5%的概率提高20%的破甲，持续3秒\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"30000\",\"trigger\":\"[{0,1000,0,1,0,0,0,3}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,50,1,0,0.2,3000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(16000005,'激励之力','宝具技能',16,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"攻击时有5%的概率提高20%的攻击，持续3秒\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"30000\",\"trigger\":\"[{0,1000,0,1,0,0,0,1}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,50,1,0,0.2,3000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(16000010,'海王戟术','降神技能',25,1,1,0,0,0,2,2,1,1,1000,3,'0','[]',0,0,0,500,'[16000010,16000011,16000012,16000013]','[16002030]',1,0,'[{\"desc\":\"对目标区域<color@7>3</color>个玩家（<color@7>4</color>个怪物）造成<color@7>4</color>段共<color@7>442%</color>的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"8800\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>3</color>个玩家（<color@7>4</color>个怪物）造成<color@7>4</color>段共<color@7>494%</color>的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"9900\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>3</color>个玩家（<color@7>4</color>个怪物）造成<color@7>4</color>段共<color@7>550%</color>的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"11000\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>3</color>个玩家（<color@7>4</color>个怪物）造成<color@7>4</color>段共<color@7>614%</color>的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"12300\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>3</color>个玩家（<color@7>4</color>个怪物）造成<color@7>4</color>段共<color@7>676%</color>的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"13500\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>3</color>个玩家（<color@7>4</color>个怪物）造成<color@7>4</color>段共<color@7>743%</color>的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"14900\",\"effect\":\"\"}]'),(16000011,'波塞冬普攻四连2','降神技能',25,1,1,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,500,'[16000010,16000011,16000012,16000013]','[16002030]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"10600\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"11900\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"13200\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"14700\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"16200\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"17800\",\"effect\":\"\"}]'),(16000012,'波塞冬普攻四连3','降神技能',25,1,1,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,500,'[16000010,16000011,16000012,16000013]','[16002030]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"560\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"11500\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"560\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"12800\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"560\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"14300\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"560\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"16000\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"560\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"17600\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"560\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"19300\",\"effect\":\"\"}]'),(16000013,'波塞冬普攻四连4','降神技能',25,1,1,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,800,'[16000010,16000011,16000012,16000013]','[16002030]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"13300\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"14800\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"16500\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"18400\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"20300\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"22300\",\"effect\":\"\"}]'),(16000014,'海皇碎击','降神技能',25,1,0,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,500,'0','[]',1,0,'[{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>6</color>个怪物）造成<color@7>290%</color>的伤害\",\"condition\":\"[{lv,6}]\",\"power\":\"7500\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"400\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"29000\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>6</color>个怪物）造成<color@7>325%</color>的伤害\",\"condition\":\"[{lv,6}]\",\"power\":\"8380\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"400\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"32500\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>6</color>个怪物）造成<color@7>360%</color>的伤害\",\"condition\":\"[{lv,6}]\",\"power\":\"9350\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"400\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"36000\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>6</color>个怪物）造成<color@7>400%</color>的伤害\",\"condition\":\"[{lv,6}]\",\"power\":\"10410\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"400\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"40000\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>6</color>个怪物）造成<color@7>440%</color>的伤害\",\"condition\":\"[{lv,6}]\",\"power\":\"114720\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"400\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"44000\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>6</color>个怪物）造成<color@7>485%</color>的伤害\",\"condition\":\"[{lv,6}]\",\"power\":\"12620\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"400\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"48500\",\"effect\":\"\"}]'),(16000015,'海皇之怒','降神技能',25,1,0,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,600,'0','[]',1,0,'[{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>575%</color>的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"9000\",\"base_attr\":\"\",\"cd\":\"7000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"600\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"57500\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>645%</color>的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"10060\",\"base_attr\":\"\",\"cd\":\"7000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"600\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"64500\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>720%</color>的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"11220\",\"base_attr\":\"\",\"cd\":\"7000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"600\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"72000\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>800%</color>的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"12490\",\"base_attr\":\"\",\"cd\":\"7000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"600\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"80000\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>885%</color>的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"13760\",\"base_attr\":\"\",\"cd\":\"7000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"600\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"88500\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>970%</color>的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"15140\",\"base_attr\":\"\",\"cd\":\"7000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"600\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"97000\",\"effect\":\"\"}]'),(16000016,'水之风旋','降神技能',25,1,0,0,0,0,2,2,1,1,1000,3,'0','[]',0,0,0,600,'0','[]',1,0,'[{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>755%</color>的伤害，对目标施加<color@7>沉默</color>效果，持续<color@7>1.5</color>秒\",\"condition\":\"[{lv,10}]\",\"power\":\"13500\",\"base_attr\":\"\",\"cd\":\"15000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"75500\",\"effect\":\"[{102,3,1000,2,0,0,0,1500,0,1}]\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>845%</color>的伤害，对目标施加<color@7>沉默</color>效果，持续<color@7>1.5</color>秒\",\"condition\":\"[{lv,10}]\",\"power\":\"15090\",\"base_attr\":\"\",\"cd\":\"15000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"84500\",\"effect\":\"[{102,3,1000,2,0,0,0,1500,0,1}]\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>945%</color>的伤害，对目标施加<color@7>沉默</color>效果，持续<color@7>1.5</color>秒\",\"condition\":\"[{lv,10}]\",\"power\":\"16840\",\"base_attr\":\"\",\"cd\":\"15000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"94500\",\"effect\":\"[{102,3,1000,2,0,0,0,1500,0,1}]\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>1050%</color>的伤害，对目标施加<color@7>沉默</color>效果，持续<color@7>1.5</color>秒\",\"condition\":\"[{lv,10}]\",\"power\":\"18740\",\"base_attr\":\"\",\"cd\":\"15000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"105000\",\"effect\":\"[{102,3,1000,2,0,0,0,1500,0,1}]\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>1155%</color>的伤害，对目标施加<color@7>沉默</color>效果，持续<color@7>1.5</color>秒\",\"condition\":\"[{lv,10}]\",\"power\":\"20650\",\"base_attr\":\"\",\"cd\":\"15000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"115500\",\"effect\":\"[{102,3,1000,2,0,0,0,1500,0,1}]\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>1275%</color>的伤害，对目标施加<color@7>沉默</color>效果，持续<color@7>1.5</color>秒\",\"condition\":\"[{lv,10}]\",\"power\":\"22710\",\"base_attr\":\"\",\"cd\":\"15000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"127500\",\"effect\":\"[{102,3,1000,2,0,0,0,1500,0,1}]\"}]'),(16000020,'胜利枪术','降神技能',25,1,1,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,500,'[16000020,16000021,16000022,16000023]','[16002030]',1,0,'[{\"desc\":\"对目标区域<color@7>3</color>个玩家（<color@7>4</color>个怪物）造成<color@7>4</color>段共<color@7>374%</color>的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"7500\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>3</color>个玩家（<color@7>4</color>个怪物）造成<color@7>4</color>段共<color@7>418%</color>的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"8400\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>3</color>个玩家（<color@7>4</color>个怪物）造成<color@7>4</color>段共<color@7>466%</color>的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"9300\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>3</color>个玩家（<color@7>4</color>个怪物）造成<color@7>4</color>段共<color@7>520%</color>的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"10400\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>3</color>个玩家（<color@7>4</color>个怪物）造成<color@7>4</color>段共<color@7>572%</color>的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"11400\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>3</color>个玩家（<color@7>4</color>个怪物）造成<color@7>4</color>段共<color@7>630%</color>的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"12600\",\"effect\":\"\"}]'),(16000021,'女武神普攻四连2','降神技能',25,1,1,0,0,0,2,2,1,1,1000,3,'0','[]',0,0,0,500,'[16000020,16000021,16000022,16000023]','[16002030]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"9000\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"11200\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"12500\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"13700\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"15100\",\"effect\":\"\"}]'),(16000022,'女武神普攻四连3','降神技能',25,1,1,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,500,'[16000020,16000021,16000022,16000023]','[16002030]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"560\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"9700\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"560\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"10900\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"560\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"12100\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"560\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"13500\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"560\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"14900\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"560\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"16400\",\"effect\":\"\"}]'),(16000023,'女武神普攻四连4','降神技能',25,1,1,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,800,'[16000020,16000021,16000022,16000023]','[16002030]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"[]\",\"distance\":\"450\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"11200\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"[]\",\"distance\":\"450\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"12500\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"[]\",\"distance\":\"450\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"14000\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"[]\",\"distance\":\"450\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"15600\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"[]\",\"distance\":\"450\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"17200\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"[]\",\"distance\":\"450\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"18900\",\"effect\":\"\"}]'),(16000024,'胜利渴望','降神技能',25,1,0,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,500,'0','[]',1,0,'[{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>6</color>个怪物）造成<color@7>205%</color>的伤害\",\"condition\":\"[{lv,6}]\",\"power\":\"6750\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"400\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"20500\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>6</color>个怪物）造成<color@7>230%</color>的伤害\",\"condition\":\"[{lv,6}]\",\"power\":\"7540\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"400\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"23000\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>6</color>个怪物）造成<color@7>255%</color>的伤害\",\"condition\":\"[{lv,6}]\",\"power\":\"8420\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"400\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"25500\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>6</color>个怪物）造成<color@7>285%</color>的伤害\",\"condition\":\"[{lv,6}]\",\"power\":\"9370\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"400\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"28500\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>6</color>个怪物）造成<color@7>315%</color>的伤害\",\"condition\":\"[{lv,6}]\",\"power\":\"10320\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"400\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"31500\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>6</color>个怪物）造成<color@7>345%</color>的伤害\",\"condition\":\"[{lv,6}]\",\"power\":\"11360\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"400\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"34500\",\"effect\":\"\"}]'),(16000025,'无双乱舞','降神技能',25,1,0,0,0,0,2,2,1,1,1000,3,'0','[{16000025,300,0},{16000027,300,0},{16000028,0,0}]',0,0,0,600,'0','[]',1,0,'[{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>475%</color>的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"8100\",\"base_attr\":\"\",\"cd\":\"7000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>530%</color>的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"9050\",\"base_attr\":\"\",\"cd\":\"7000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"11500\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>590%</color>的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"10100\",\"base_attr\":\"\",\"cd\":\"7000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"13000\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>660%</color>的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"11240\",\"base_attr\":\"\",\"cd\":\"7000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"15000\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>730%</color>的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"12390\",\"base_attr\":\"\",\"cd\":\"7000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"17000\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>800%</color>的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"13630\",\"base_attr\":\"\",\"cd\":\"7000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"19000\",\"effect\":\"\"}]'),(16000026,'崩坏之矛','降神技能',25,1,0,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,600,'0','[]',1,0,'[{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>750%</color>的伤害，提升自身暴击率<color@7>40%</color>，持续<color@7>2</color>秒\",\"condition\":\"[{lv,10}]\",\"power\":\"12150\",\"base_attr\":\"\",\"cd\":\"15000\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"[{13,0,1000,1,4000,0,2000,1,0}]\",\"hurt\":\"75000\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>835%</color>的伤害，提升自身暴击率<color@7>40%</color>，持续<color@7>2</color>秒\",\"condition\":\"[{lv,10}]\",\"power\":\"13580\",\"base_attr\":\"\",\"cd\":\"15000\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"[{13,0,1000,1,4000,0,2000,1,0}]\",\"hurt\":\"83500\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>935%</color>的伤害，提升自身暴击率<color@7>40%</color>，持续<color@7>2</color>秒\",\"condition\":\"[{lv,10}]\",\"power\":\"15150\",\"base_attr\":\"\",\"cd\":\"15000\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"[{13,0,1000,1,4000,0,2000,1,0}]\",\"hurt\":\"93500\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>1040%</color>的伤害，提升自身暴击率<color@7>40%</color>，持续<color@7>2</color>秒\",\"condition\":\"[{lv,10}]\",\"power\":\"16870\",\"base_attr\":\"\",\"cd\":\"15000\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"[{13,0,1000,1,4000,0,2000,1,0}]\",\"hurt\":\"104000\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>1145%</color>的伤害，提升自身暴击率<color@7>40%</color>，持续<color@7>2</color>秒\",\"condition\":\"[{lv,10}]\",\"power\":\"18580\",\"base_attr\":\"\",\"cd\":\"15000\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"[{13,0,1000,1,4000,0,2000,1,0}]\",\"hurt\":\"114500\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>1260%</color>的伤害，提升自身暴击率<color@7>40%</color>，持续<color@7>2</color>秒\",\"condition\":\"[{lv,10}]\",\"power\":\"20440\",\"base_attr\":\"\",\"cd\":\"15000\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"[{13,0,1000,1,4000,0,2000,1,0}]\",\"hurt\":\"126000\",\"effect\":\"\"}]'),(16000027,'无双乱舞副1','降神技能',25,1,0,1,0,0,2,2,1,1,1000,3,'0','[{16000025,300,0},{16000027,300,0},{16000028,0,0}]',0,0,0,600,'0','[]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"11500\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"13000\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"15000\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"17000\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"19000\",\"effect\":\"\"}]'),(16000028,'无双乱舞副2','降神技能',25,1,0,1,0,0,2,2,1,1,1000,3,'0','[{16000025,300,0},{16000027,300,0},{16000028,0,0}]',0,0,0,600,'0','[]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"27500\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"30000\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"33000\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"36000\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"39000\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"42000\",\"effect\":\"\"}]'),(16000100,'光辉之杖','降神技能',25,1,0,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,500,'[16000100,16000101,16000102,16000103]','[16002030]',1,0,'[{\"desc\":\"对目标区域<color@7>3</color>个玩家（<color@7>4</color>个怪物）造成<color@7>4</color>段共<color@7>244%</color>的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"5000\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>3</color>个玩家（<color@7>4</color>个怪物）造成<color@7>4</color>段共<color@7>277%</color>的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"5700\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>3</color>个玩家（<color@7>4</color>个怪物）造成<color@7>4</color>段共<color@7>309%</color>的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"6400\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>3</color>个玩家（<color@7>4</color>个怪物）造成<color@7>4</color>段共<color@7>342%</color>的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"700\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"7100\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>3</color>个玩家（<color@7>4</color>个怪物）造成<color@7>4</color>段共<color@7>377%</color>的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"7800\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>3</color>个玩家（<color@7>4</color>个怪物）造成<color@7>4</color>段共<color@7>415%</color>的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"700\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"8600\",\"effect\":\"\"}]'),(16000101,'光明神普攻四连2','降神技能',25,1,1,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,500,'[16000100,16000101,16000102,16000103]','[16002030]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"3400\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"3800\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"4300\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"4700\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"5200\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"5700\",\"effect\":\"\"}]'),(16000102,'光明神普攻四连3','降神技能',25,1,1,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,500,'[16000100,16000101,16000102,16000103]','[16002030]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"560\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"5000\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"560\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"5700\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"560\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"6400\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"560\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"7100\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"560\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"7800\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"560\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"8600\",\"effect\":\"\"}]'),(16000103,'光明神普攻四连4','降神技能',25,1,1,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,800,'[16000100,16000101,16000102,16000103]','[16002030]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"11000\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"12500\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"13800\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"15300\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"16900\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"18600\",\"effect\":\"\"}]'),(16000110,'审判之光','降神技能',25,1,0,0,0,0,2,2,1,1,1000,3,'0','[{16000110,300,0},{16000111,0,0}]',0,0,0,500,'0','[]',1,0,'[{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>6</color>个怪物）造成<color@7>245%</color>的伤害\",\"condition\":\"[{lv,6}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"500\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>6</color>个怪物）造成<color@7>275%</color>的伤害\",\"condition\":\"[{lv,6}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"500\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"11500\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>6</color>个怪物）造成<color@7>305%</color>的伤害\",\"condition\":\"[{lv,6}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"500\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"13000\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>6</color>个怪物）造成<color@7>340%</color>的伤害\",\"condition\":\"[{lv,6}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"500\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"14500\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>6</color>个怪物）造成<color@7>375%</color>的伤害\",\"condition\":\"[{lv,6}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"500\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"16000\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>6</color>个怪物）造成<color@7>415%</color>的伤害\",\"condition\":\"[{lv,6}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"500\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"18500\",\"effect\":\"\"}]'),(16000111,'审判之光副1','降神技能',25,1,0,1,0,0,2,2,1,1,1000,3,'0','[{16000110,300,0},{16000111,0,0}]',0,0,0,500,'0','[]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,6}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"3000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"400\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"14500\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,6}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"3000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"400\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"16000\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,6}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"3000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"400\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"17500\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,6}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"3000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"400\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"19500\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,6}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"3000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"400\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"21500\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,6}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"3000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"400\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"23000\",\"effect\":\"\"}]'),(16000120,'圣光天罚','降神技能',25,1,0,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,600,'0','[]',1,0,'[{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>290%</color>的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"7000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"29000\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>325%</color>的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"7000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"32500\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>360%</color>的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"7000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"36000\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>400%</color>的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"7000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"40000\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>440%</color>的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"7000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"44000\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>485%</color>的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"7000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"48500\",\"effect\":\"\"}]'),(16000130,'无间光域','降神技能',25,1,0,0,0,0,2,2,1,1,1000,1,'0','[{16000130,300,0},{16000131,200,0},{16000132,300,0},{16000133,0,0}]',0,0,0,600,'0','[]',1,0,'[{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>545%</color>的伤害，提升自身boss伤害减免<color@7>15%</color>，持续<color@7>5</color>秒\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"15000\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"600\",\"num\":\"[4,8]\",\"attr\":\"[{232,0,1000,1,1500,0,5000,1,0}]\",\"hurt\":\"13500\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>608%</color>的伤害，提升自身boss伤害减免<color@7>15%</color>，持续<color@7>5</color>秒\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"15000\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"600\",\"num\":\"[4,8]\",\"attr\":\"[{232,0,1000,1,1500,0,5000,1,0}]\",\"hurt\":\"15000\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>680%</color>的伤害，提升自身boss伤害减免<color@7>15%</color>，持续<color@7>5</color>秒\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"15000\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"600\",\"num\":\"[4,8]\",\"attr\":\"[{232,0,1000,1,1500,0,5000,1,0}]\",\"hurt\":\"17000\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>755%</color>的伤害，提升自身boss伤害减免<color@7>15%</color>，持续<color@7>5</color>秒\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"15000\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"600\",\"num\":\"[4,8]\",\"attr\":\"[{232,0,1000,1,1500,0,5000,1,0}]\",\"hurt\":\"18800\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>830%</color>的伤害，提升自身boss伤害减免<color@7>15%</color>，持续<color@7>5</color>秒\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"15000\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"600\",\"num\":\"[4,8]\",\"attr\":\"[{232,0,1000,1,1500,0,5000,1,0}]\",\"hurt\":\"20500\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>915%</color>的伤害，提升自身boss伤害减免<color@7>15%</color>，持续<color@7>5</color>秒\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"15000\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"600\",\"num\":\"[4,8]\",\"attr\":\"[{232,0,1000,1,1500,0,5000,1,0}]\",\"hurt\":\"22800\",\"effect\":\"\"}]'),(16000131,'无间光域1','降神技能',25,1,0,1,0,0,2,2,1,1,1000,1,'0','[{16000130,300,0},{16000131,200,0},{16000132,300,0},{16000133,0,0}]',0,0,0,600,'0','[]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"13500\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"15000\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"17000\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"18800\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"20500\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"22800\",\"effect\":\"\"}]'),(16000132,'无间光域副2','降神技能',25,1,0,1,0,0,2,2,1,1,1000,1,'0','[{16000130,300,0},{16000131,200,0},{16000132,300,0},{16000133,0,0}]',0,0,0,600,'0','[]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"13500\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"15000\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"17000\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"18800\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"20500\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"22800\",\"effect\":\"\"}]'),(16000133,'无间光域副3','降神技能',25,1,0,1,0,0,2,2,1,1,1000,1,'0','[{16000130,300,0},{16000131,200,0},{16000132,300,0},{16000133,0,0}]',0,0,0,600,'0','[]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"14000\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"15800\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"17000\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"19100\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"21500\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"23100\",\"effect\":\"\"}]'),(16000200,'清泠剑舞','降神技能',25,1,1,0,0,0,2,2,1,1,1000,3,'0','[]',0,0,0,500,'[16000200,16000201,16000202,16000203]','[16002030]',1,0,'[{\"desc\":\"对目标区域<color@7>3</color>个玩家（<color@7>4</color>个怪物）造成<color@7>4</color>段共<color@7>324%</color>的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"4000\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"6500\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>3</color>个玩家（<color@7>4</color>个怪物）造成<color@7>4</color>段共<color@7>362%</color>的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"4500\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"7200\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>3</color>个玩家（<color@7>4</color>个怪物）造成<color@7>4</color>段共<color@7>402%</color>的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"5000\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"8100\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>3</color>个玩家（<color@7>4</color>个怪物）造成<color@7>4</color>段共<color@7>449%</color>的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"5500\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"9000\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>3</color>个玩家（<color@7>4</color>个怪物）造成<color@7>4</color>段共<color@7>494%</color>的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"6000\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"9900\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>3</color>个玩家（<color@7>4</color>个怪物）造成<color@7>4</color>段共<color@7>543%</color>的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"6500\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"10900\",\"effect\":\"\"}]'),(16000201,'冰神普攻四连2','降神技能',25,1,1,0,0,0,2,2,1,1,1000,3,'0','[]',0,0,0,500,'[16000200,16000201,16000202,16000203]','[16002030]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"7800\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"8700\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"9700\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"10800\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"11900\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"13000\",\"effect\":\"\"}]'),(16000202,'冰神普攻四连3','降神技能',25,1,1,0,0,0,2,2,1,1,1000,3,'0','[]',0,0,0,500,'[16000200,16000201,16000202,16000203]','[16002030]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"560\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"8400\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"560\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"9400\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"560\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"10500\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"560\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"11700\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"560\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"12800\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"560\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"14100\",\"effect\":\"\"}]'),(16000203,'冰神普攻四连4','降神技能',25,1,1,0,0,0,2,2,1,1,1000,3,'0','[]',0,0,0,800,'[16000200,16000201,16000202,16000203]','[16002030]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"9700\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"10800\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"12100\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"13500\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"14800\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"16300\",\"effect\":\"\"}]'),(16000210,'冰刺碎击','降神技能',25,1,0,0,0,0,2,2,1,1,1000,2,'0','[{16000210,300,0},{16000211,0,0}]',0,0,0,500,'0','[]',1,0,'[{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>6</color>个怪物）造成<color@7>270%</color>的伤害\",\"condition\":\"[{lv,6}]\",\"power\":\"5000\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"400\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"13000\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>6</color>个怪物）造成<color@7>305%</color>的伤害\",\"condition\":\"[{lv,6}]\",\"power\":\"5590\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"400\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"14000\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>6</color>个怪物）造成<color@7>340%</color>的伤害\",\"condition\":\"[{lv,6}]\",\"power\":\"6240\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"400\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"15000\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>6</color>个怪物）造成<color@7>380%</color>的伤害\",\"condition\":\"[{lv,6}]\",\"power\":\"6940\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"400\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"16000\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>6</color>个怪物）造成<color@7>420%</color>的伤害\",\"condition\":\"[{lv,6}]\",\"power\":\"7650\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"400\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"18000\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>6</color>个怪物）造成<color@7>460%</color>的伤害\",\"condition\":\"[{lv,6}]\",\"power\":\"8410\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"400\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"20000\",\"effect\":\"\"}]'),(16000211,'冰刺碎击副1','降神技能',25,1,0,1,0,0,2,2,1,1,1000,2,'0','[{16000210,300,0},{16000211,0,0}]',0,0,0,500,'0','[]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,6}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"3000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"400\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"14000\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,6}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"3000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"400\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"16500\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,6}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"3000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"400\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"19000\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,6}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"3000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"400\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"22000\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,6}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"3000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"400\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"24000\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,6}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"3000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"400\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"26000\",\"effect\":\"\"}]'),(16000220,'寒冰领域','降神技能',25,1,0,0,0,0,2,2,1,1,1000,3,'0','[]',0,0,0,600,'0','[]',1,0,'[{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>400%</color>的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"6000\",\"base_attr\":\"\",\"cd\":\"7000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"40000\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>445%</color>的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"6710\",\"base_attr\":\"\",\"cd\":\"7000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"44500\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>495%</color>的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"7480\",\"base_attr\":\"\",\"cd\":\"7000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"49500\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>550%</color>的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"8330\",\"base_attr\":\"\",\"cd\":\"7000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"55000\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>610%</color>的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"9180\",\"base_attr\":\"\",\"cd\":\"7000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"61000\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>670%</color>的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"10090\",\"base_attr\":\"\",\"cd\":\"7000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"67000\",\"effect\":\"\"}]'),(16000230,'冰雪刃舞','降神技能',25,1,0,0,0,0,2,2,1,1,1000,3,'0','[]',0,0,0,600,'0','[]',1,0,'[{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>545%</color>的伤害，提升自身PVE伤害<color@7>20%</color>，持续<color@7>3</color>秒\",\"condition\":\"[{lv,10}]\",\"power\":\"9000\",\"base_attr\":\"\",\"cd\":\"15000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"[{50,0,1000,1,2000,0,3000,1,0}]\",\"hurt\":\"54500\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>605%</color>的伤害，提升自身PVE伤害<color@7>20%</color>，持续<color@7>3</color>秒\",\"condition\":\"[{lv,10}]\",\"power\":\"10060\",\"base_attr\":\"\",\"cd\":\"15000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"[{50,0,1000,1,2000,0,3000,1,0}]\",\"hurt\":\"60500\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>675%</color>的伤害，提升自身PVE伤害<color@7>20%</color>，持续<color@7>3</color>秒\",\"condition\":\"[{lv,10}]\",\"power\":\"11220\",\"base_attr\":\"\",\"cd\":\"15000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"[{50,0,1000,1,2000,0,3000,1,0}]\",\"hurt\":\"67500\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>750%</color>的伤害，提升自身PVE伤害<color@7>20%</color>，持续<color@7>3</color>秒\",\"condition\":\"[{lv,10}]\",\"power\":\"12490\",\"base_attr\":\"\",\"cd\":\"15000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"[{50,0,1000,1,2000,0,3000,1,0}]\",\"hurt\":\"75000\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>830%</color>的伤害，提升自身PVE伤害<color@7>20%</color>，持续<color@7>3</color>秒\",\"condition\":\"[{lv,10}]\",\"power\":\"13760\",\"base_attr\":\"\",\"cd\":\"15000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"[{50,0,1000,1,2000,0,3000,1,0}]\",\"hurt\":\"83000\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>915%</color>的伤害，提升自身PVE伤害<color@7>20%</color>，持续<color@7>3</color>秒\",\"condition\":\"[{lv,10}]\",\"power\":\"15140\",\"base_attr\":\"\",\"cd\":\"15000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"[{50,0,1000,1,2000,0,3000,1,0}]\",\"hurt\":\"91500\",\"effect\":\"\"}]'),(16000300,'辉夜枪术','降神技能',25,1,1,0,0,0,2,2,1,1,1000,3,'0','[]',0,0,0,500,'[16000300,16000301,16000302,16000303]','[16002030]',1,0,'[{\"desc\":\"对目标区域<color@7>3</color>个玩家（<color@7>4</color>个怪物）造成<color@7>4</color>段共<color@7>388%</color>的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"400\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>3</color>个玩家（<color@7>4</color>个怪物）造成<color@7>4</color>段共<color@7>438%</color>的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"400\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"11500\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>3</color>个玩家（<color@7>4</color>个怪物）造成<color@7>4</color>段共<color@7>486%</color>的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"400\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"12700\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>3</color>个玩家（<color@7>4</color>个怪物）造成<color@7>4</color>段共<color@7>543%</color>的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"400\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"14200\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>3</color>个玩家（<color@7>4</color>个怪物）造成<color@7>4</color>段共<color@7>599%</color>的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"400\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"15600\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>3</color>个玩家（<color@7>4</color>个怪物）造成<color@7>4</color>段共<color@7>658%</color>的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"400\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"17200\",\"effect\":\"\"}]'),(16000301,'月神普攻四连2','降神技能',25,1,1,0,0,0,2,2,1,1,1000,3,'0','[]',0,0,0,500,'[16000300,16000301,16000302,16000303]','[16002030]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"400\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"6800\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"400\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"7600\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"400\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"8500\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"400\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"9500\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"400\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"10500\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"400\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"11500\",\"effect\":\"\"}]'),(16000302,'月神普攻四连3','降神技能',25,1,1,0,0,0,2,2,1,1,1000,3,'0','[]',0,0,0,500,'[16000300,16000301,16000302,16000303]','[16002030]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"560\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"400\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"5000\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"560\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"400\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"5700\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"560\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"400\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"6400\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"560\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"400\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"7100\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"560\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"400\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"7800\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"560\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"400\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"8600\",\"effect\":\"\"}]'),(16000303,'月神普攻四连4','降神技能',25,1,1,0,0,0,2,2,1,1,1000,3,'0','[]',0,0,0,800,'[16000300,16000301,16000302,16000303]','[16002030]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"400\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"17000\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"400\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"19000\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"400\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"21000\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"400\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"23500\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"400\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"26000\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"400\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"28500\",\"effect\":\"\"}]'),(16000310,'月牙天冲','降神技能',25,1,0,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,500,'0','[]',1,0,'[{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>6</color>个怪物）造成<color@7>315%</color>的伤害\",\"condition\":\"[{lv,6}]\",\"power\":\"6250\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"400\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"31500\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>6</color>个怪物）造成<color@7>350%</color>的伤害\",\"condition\":\"[{lv,6}]\",\"power\":\"6990\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"400\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"35000\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>6</color>个怪物）造成<color@7>390%</color>的伤害\",\"condition\":\"[{lv,6}]\",\"power\":\"7790\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"400\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"39000\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>6</color>个怪物）造成<color@7>435%</color>的伤害\",\"condition\":\"[{lv,6}]\",\"power\":\"8680\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"400\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"43500\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>6</color>个怪物）造成<color@7>480%</color>的伤害\",\"condition\":\"[{lv,6}]\",\"power\":\"9560\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"400\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"48000\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>6</color>个怪物）造成<color@7>530%</color>的伤害\",\"condition\":\"[{lv,6}]\",\"power\":\"10510\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"400\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"53000\",\"effect\":\"\"}]'),(16000320,'月辉枪击','降神技能',25,1,0,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,600,'0','[]',1,0,'[{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>495%</color>的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"7500\",\"base_attr\":\"\",\"cd\":\"7000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"49500\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>550%</color>的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"8380\",\"base_attr\":\"\",\"cd\":\"7000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"55000\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>645%</color>的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"9350\",\"base_attr\":\"\",\"cd\":\"7000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"64500\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>685%</color>的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"10410\",\"base_attr\":\"\",\"cd\":\"7000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"68500\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>755%</color>的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"11470\",\"base_attr\":\"\",\"cd\":\"7000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"75500\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>830%</color>的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"12620\",\"base_attr\":\"\",\"cd\":\"7000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"83000\",\"effect\":\"\"}]'),(16000330,'月下独舞','降神技能',25,1,0,0,0,0,2,2,1,1,1000,1,'0','[{16000330,300,0},{16000331,500,0},{16000332,0,0}]',0,0,0,600,'0','[]',1,0,'[{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>815%</color>的伤害，并给自身每秒回血<color@7>5%</color>，持续<color@7>3</color>秒\",\"condition\":\"[{lv,10}]\",\"power\":\"11250\",\"base_attr\":\"\",\"cd\":\"15000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"27000\",\"effect\":\"[{116,0,1000,1,0,0.05,2,3000,3,0}]\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>910%</color>的伤害，并给自身每秒回血<color@7>5%</color>，持续<color@7>3</color>秒\",\"condition\":\"[{lv,10}]\",\"power\":\"12570\",\"base_attr\":\"\",\"cd\":\"15000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"30300\",\"effect\":\"[{116,0,1000,1,0,0.05,2,3000,3,0}]\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>1015%</color>的伤害，并给自身每秒回血<color@7>5%</color>，持续<color@7>3</color>秒\",\"condition\":\"[{lv,10}]\",\"power\":\"14030\",\"base_attr\":\"\",\"cd\":\"15000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"33800\",\"effect\":\"[{116,0,1000,1,0,0.05,2,3000,3,0}]\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>1130%</color>的伤害，并给自身每秒回血<color@7>5%</color>，持续<color@7>3</color>秒\",\"condition\":\"[{lv,10}]\",\"power\":\"15620\",\"base_attr\":\"\",\"cd\":\"15000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"37600\",\"effect\":\"[{116,0,1000,1,0,0.05,2,3000,3,0}]\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>1250%</color>的伤害，并给自身每秒回血<color@7>5%</color>，持续<color@7>3</color>秒\",\"condition\":\"[{lv,10}]\",\"power\":\"17210\",\"base_attr\":\"\",\"cd\":\"15000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"41600\",\"effect\":\"[{116,0,1000,1,0,0.05,2,3000,3,0}]\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>1370%</color>的伤害，并给自身每秒回血<color@7>5%</color>，持续<color@7>3</color>秒\",\"condition\":\"[{lv,10}]\",\"power\":\"18930\",\"base_attr\":\"\",\"cd\":\"15000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"45600\",\"effect\":\"[{116,0,1000,1,0,0.05,2,3000,3,0}]\"}]'),(16000331,'月下独舞副1','降神技能',25,1,0,1,0,0,2,2,1,1,1000,1,'0','[{16000330,300,0},{16000331,500,0},{16000332,0,0}]',0,0,0,600,'0','[]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"27000\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"30300\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"33800\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"37600\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"41600\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"45600\",\"effect\":\"\"}]'),(16000332,'月下独舞副2','降神技能',25,1,0,1,0,0,2,2,1,1,1000,1,'0','[{16000330,300,0},{16000331,500,0},{16000332,0,0}]',0,0,0,600,'0','[]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"27500\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"30400\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"33900\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"37800\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"41800\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"45800\",\"effect\":\"\"}]'),(16000400,'死亡之镰','降神技能',25,1,0,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,500,'[16000400,16000401,16000402,16000403]','[16002030]',1,0,'[{\"desc\":\"对目标区域<color@7>3</color>个玩家（<color@7>4</color>个怪物）造成<color@7>4</color>段共<color@7>563%</color>的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>3</color>个玩家（<color@7>4</color>个怪物）造成<color@7>4</color>段共<color@7>624%</color>的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"11000\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>3</color>个玩家（<color@7>4</color>个怪物）造成<color@7>4</color>段共<color@7>702%</color>的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"12500\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>3</color>个玩家（<color@7>4</color>个怪物）造成<color@7>4</color>段共<color@7>781%</color>的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"14000\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>3</color>个玩家（<color@7>4</color>个怪物）造成<color@7>4</color>段共<color@7>860%</color>的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"15500\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>3</color>个玩家（<color@7>4</color>个怪物）造成<color@7>4</color>段共<color@7>945%</color>的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"17000\",\"effect\":\"\"}]'),(16000401,'死神普攻四连2','降神技能',25,1,1,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,500,'[16000400,16000401,16000402,16000403]','[16002030]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"9800\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"10900\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"12200\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"13600\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"15000\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"16500\",\"effect\":\"\"}]'),(16000402,'死神普攻四连3','降神技能',25,1,1,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,500,'[16000400,16000401,16000402,16000403]','[16002030]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"560\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"560\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"11000\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"560\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"12500\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"560\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"14000\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"560\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"15500\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"560\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"17000\",\"effect\":\"\"}]'),(16000403,'死神普攻四连4','降神技能',25,1,1,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,800,'[16000400,16000401,16000402,16000403]','[16002030]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"26500\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"29500\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"33000\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"36500\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"40000\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"44000\",\"effect\":\"\"}]'),(16000410,'地狱之爪','降神技能',25,1,0,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,600,'0','[]',1,0,'[{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>380%</color>的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"8750\",\"base_attr\":\"\",\"cd\":\"7000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"38000\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>425%</color>的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"9780\",\"base_attr\":\"\",\"cd\":\"7000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"42500\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>475%</color>的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"10910\",\"base_attr\":\"\",\"cd\":\"7000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"47500\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>530%</color>的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"12150\",\"base_attr\":\"\",\"cd\":\"7000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"53000\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>585%</color>的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"13380\",\"base_attr\":\"\",\"cd\":\"7000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"58500\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>645%</color>的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"14720\",\"base_attr\":\"\",\"cd\":\"7000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"64500\",\"effect\":\"\"}]'),(16000420,'灵魂割裂','降神技能',25,1,0,0,0,0,2,2,1,1,1000,3,'0','[{16000420,300,0},{16000421,0,0}]',0,0,0,500,'0','[]',1,0,'[{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>6</color>个怪物）造成<color@7>640%</color>的伤害\",\"condition\":\"[{lv,6}]\",\"power\":\"10500\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"400\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"64000\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>6</color>个怪物）造成<color@7>710%</color>的伤害\",\"condition\":\"[{lv,6}]\",\"power\":\"11740\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"400\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"71000\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>6</color>个怪物）造成<color@7>795%</color>的伤害\",\"condition\":\"[{lv,6}]\",\"power\":\"13090\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"400\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"79500\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>6</color>个怪物）造成<color@7>885%</color>的伤害\",\"condition\":\"[{lv,6}]\",\"power\":\"14580\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"400\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"88500\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>6</color>个怪物）造成<color@7>975%</color>的伤害\",\"condition\":\"[{lv,6}]\",\"power\":\"16060\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"400\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"97500\",\"effect\":\"\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>6</color>个怪物）造成<color@7>1075%</color>的伤害\",\"condition\":\"[{lv,6}]\",\"power\":\"17660\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"400\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"107500\",\"effect\":\"\"}]'),(16000421,'灵魂割裂副1','降神技能',25,1,0,1,0,0,2,2,1,1,1000,3,'0','[{16000420,300,0},{16000421,0,0}]',0,0,0,500,'0','[]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,6}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"3000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"400\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"64000\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,6}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"3000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"400\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"71000\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,6}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"3000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"400\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"79500\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,6}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"3000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"400\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"88500\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,6}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"3000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"400\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"97500\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,6}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"3000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"400\",\"num\":\"[4,6]\",\"attr\":\"\",\"hurt\":\"107500\",\"effect\":\"\"}]'),(16000430,'哀嚎冲击','降神技能',25,1,0,0,0,0,2,2,1,1,1000,1,'0','[{16000430,300,0},{16000431,200,0},{16000432,0,0}]',0,0,0,600,'0','[]',1,0,'[{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>1100%</color>的伤害，对目标施加<color@7>恐惧</color>效果，持续<color@7>2</color>秒\",\"condition\":\"[{lv,10}]\",\"power\":\"15750\",\"base_attr\":\"\",\"cd\":\"15000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"110000\",\"effect\":\"[{130,2,1000,2,0,0,0,2000,0,0}]\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>1235%</color>的伤害，对目标施加<color@7>恐惧</color>效果，持续<color@7>2</color>秒\",\"condition\":\"[{lv,10}]\",\"power\":\"17600\",\"base_attr\":\"\",\"cd\":\"15000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"123500\",\"effect\":\"[{130,2,1000,2,0,0,0,2000,0,0}]\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>1380%</color>的伤害，对目标施加<color@7>恐惧</color>效果，持续<color@7>2</color>秒\",\"condition\":\"[{lv,10}]\",\"power\":\"19640\",\"base_attr\":\"\",\"cd\":\"15000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"138000\",\"effect\":\"[{130,2,1000,2,0,0,0,2000,0,0}]\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>1535%</color>的伤害，对目标施加<color@7>恐惧</color>效果，持续<color@7>2</color>秒\",\"condition\":\"[{lv,10}]\",\"power\":\"21860\",\"base_attr\":\"\",\"cd\":\"15000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"153500\",\"effect\":\"[{130,2,1000,2,0,0,0,2000,0,0}]\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>1690%</color>的伤害，对目标施加<color@7>恐惧</color>效果，持续<color@7>2</color>秒\",\"condition\":\"[{lv,10}]\",\"power\":\"24090\",\"base_attr\":\"\",\"cd\":\"15000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"169000\",\"effect\":\"[{130,2,1000,2,0,0,0,2000,0,0}]\"},{\"desc\":\"对目标区域<color@7>4</color>个玩家（<color@7>8</color>个怪物）造成<color@7>1860%</color>的伤害，对目标施加<color@7>恐惧</color>效果，持续<color@7>2</color>秒\",\"condition\":\"[{lv,10}]\",\"power\":\"26500\",\"base_attr\":\"\",\"cd\":\"15000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"186000\",\"effect\":\"[{130,2,1000,2,0,0,0,2000,0,0}]\"}]'),(16000431,'哀嚎冲击1','降神技能',25,1,0,1,0,0,2,2,1,1,1000,1,'0','[{16000430,300,0},{16000431,200,0},{16000432,0,0}]',0,0,0,600,'0','[]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"110000\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"123500\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"138000\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"153500\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"169000\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"186000\",\"effect\":\"\"}]'),(16000432,'哀嚎冲击副2','降神技能',25,1,0,1,0,0,2,2,1,1,1000,1,'0','[{16000430,300,0},{16000431,200,0},{16000432,0,0}]',0,0,0,600,'0','[]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"110000\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"123500\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"138000\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"153500\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"169000\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"186000\",\"effect\":\"\"}]'),(16002010,'战神之力','降神符文技能，变身期间增加攻击与防御',25,1,0,0,0,0,1,1,0,1,0,0,'[]','[]',0,0,0,0,'0','[]',1,0,'[{\"desc\":\"变身时，提升自身4%的攻击以及4%防御\",\"condition\":\"[]\",\"power\":\"40000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{1,2,1000,1,0,0.04,16000,1,0},{2,2,1000,1,0,0.04,16000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"变身时，提升自身6%的攻击以及6%防御\",\"condition\":\"[]\",\"power\":\"60000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{1,2,1000,1,0,0.06,16000,1,0},{2,2,1000,1,0,0.06,16000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"变身时，提升自身8.5%的攻击以及8.5%防御\",\"condition\":\"[]\",\"power\":\"85000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{1,2,1000,1,0,0.085,16000,1,0},{2,2,1000,1,0,0.085,16000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"变身时，提升自身11%的攻击以及11%防御\",\"condition\":\"[]\",\"power\":\"110000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{1,2,1000,1,0,0.109,16000,1,0},{2,2,1000,1,0,0.109,16000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"变身时，提升自身13.5%的攻击以及13.5%防御\",\"condition\":\"[]\",\"power\":\"135000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{1,2,1000,1,0,0.137,16000,1,0},{2,2,1000,1,0,0.137,16000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"变身时，提升自身16.5%的攻击以及16.5%防御\",\"condition\":\"[]\",\"power\":\"165000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{1,2,1000,1,0,0.165,16000,1,0},{2,2,1000,1,0,0.165,16000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"变身时，提升降神攻击与防御\",\"condition\":\"[]\",\"power\":\"50000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{1,2,1000,1,0,0.2,20000,1,0},{2,2,1000,1,0,0.2,20000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"变身时，提升降神攻击与防御\",\"condition\":\"[]\",\"power\":\"5500\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{1,2,1000,1,0,0.2,20000,1,0},{2,2,1000,1,0,0.2,20000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"变身时，提升降神攻击与防御\",\"condition\":\"[]\",\"power\":\"60000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{1,2,1000,1,0,0.2,20000,1,0},{2,2,1000,1,0,0.2,20000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"变身时，提升自身16.5%的攻击与16.5%防御\",\"condition\":\"[]\",\"power\":\"165000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{1,2,1000,1,0,0.165,16000,1,0},{2,2,1000,1,0,0.165,16000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(16002020,'雷神之罚','降神符文技能，群体眩晕',25,1,0,0,0,0,2,2,1,1,1000,1,'[]','[]',0,0,0,100,'0','[]',1,0,'[{\"desc\":\"变身时，对周围圆形区域的敌人造成150%的伤害以及0.5秒眩晕\",\"condition\":\"[]\",\"power\":\"10000\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[10,10]\",\"attr\":\"[]\",\"hurt\":\"15000\",\"effect\":\"[{101,2,1000,2,0,0,0,500,0,0}]\"},{\"desc\":\"变身时，对周围圆形区域的敌人造成225%伤害以及0.75秒眩晕效果\",\"condition\":\"[]\",\"power\":\"150000\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[10,10]\",\"attr\":\"[]\",\"hurt\":\"22500\",\"effect\":\"[{101,2,1000,2,0,0,0,750,0,0}]\"},{\"desc\":\"变身时，对周围圆形区域的敌人造成315%伤害以及1秒眩晕效果\",\"condition\":\"[]\",\"power\":\"210000\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[10,10]\",\"attr\":\"[]\",\"hurt\":\"31500\",\"effect\":\"[{101,2,1000,2,0,0,0,1000,0,0}]\"},{\"desc\":\"变身时，对周围圆形区域的敌人造成410%伤害以及1.25秒眩晕效果\",\"condition\":\"[]\",\"power\":\"273000\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[10,10]\",\"attr\":\"[]\",\"hurt\":\"41000\",\"effect\":\"[{101,2,1000,2,0,0,0,1250,0,0}]\"},{\"desc\":\"变身时，对周围圆形区域的敌人造成512%伤害以及1.5秒眩晕效果\",\"condition\":\"[]\",\"power\":\"341000\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[10,10]\",\"attr\":\"[]\",\"hurt\":\"51200\",\"effect\":\"[{101,2,1000,2,0,0,0,15000,0}]\"},{\"desc\":\"变身时，对周围圆形区域的敌人造成619%伤害以及1.75秒眩晕效果\",\"condition\":\"[]\",\"power\":\"413000\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[10,10]\",\"attr\":\"[]\",\"hurt\":\"61900\",\"effect\":\"[{101,2,1000,2,0,0,0,1750,0,0}]\"}]'),(16002030,'火神之炎','降神符文技能，变身期间攻击叠加流血',25,9,0,0,0,0,1,2,0,1,0,0,'[]','[]',0,0,0,0,'0','[]',1,0,'[{\"desc\":\"变身期间，降神普通攻击有35%的概率给敌人造成持续3秒的0.8%灼烧效果，冷却时间12秒\",\"condition\":\"[]\",\"power\":\"100000\",\"base_attr\":\"[]\",\"cd\":\"12000\",\"trigger\":\"[{0,1000,0,3,0,0,0,117}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{117,0,350,2,0,0.008,0,3000,3,0}]\"},{\"desc\":\"变身期间，降神普通攻击有35%的概率给敌人造成持续3秒的1.2%灼烧效果，冷却时间12秒\",\"condition\":\"[]\",\"power\":\"150000\",\"base_attr\":\"[]\",\"cd\":\"12000\",\"trigger\":\"[{0,1000,0,3,0,0,0,117}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{117,0,350,2,0,0.012,0,3000,3,0}]\"},{\"desc\":\"变身期间，降神普通攻击有35%的概率给敌人造成持续4秒的1.25%灼烧效果，冷却时间12秒\",\"condition\":\"[]\",\"power\":\"210000\",\"base_attr\":\"[]\",\"cd\":\"12000\",\"trigger\":\"[{0,1000,0,3,0,0,0,117}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{117,0,350,2,0,0.0125,0,4000,4,0}]\"},{\"desc\":\"变身期间，降神普通攻击有35%的概率给敌人造成持续4秒的1.5%灼烧效果，冷却时间12秒\",\"condition\":\"[]\",\"power\":\"273000\",\"base_attr\":\"[]\",\"cd\":\"12000\",\"trigger\":\"[{0,1000,0,3,0,0,0,117}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{117,0,350,2,0,0.015,0,4000,4,0}]\"},{\"desc\":\"变身期间，降神普通攻击有35%的概率给敌人造成持续5秒的1.6%灼烧效果，冷却时间12秒\",\"condition\":\"[]\",\"power\":\"341000\",\"base_attr\":\"[]\",\"cd\":\"12000\",\"trigger\":\"[{0,1000,0,3,0,0,0,117}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{117,0,350,2,0,0.016,0,5000,5,0}]\"},{\"desc\":\"变身期间，降神普通攻击有35%的概率给敌人造成持续5秒的1.8%灼烧效果，冷却时间12秒\",\"condition\":\"[]\",\"power\":\"413000\",\"base_attr\":\"[]\",\"cd\":\"12000\",\"trigger\":\"[{0,1000,0,3,0,0,0,117}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{117,0,350,2,0,0.018,0,5000,5,0}]\"}]'),(16002040,'生命之护','降神符文技能，一段时间内恢复生命值并免疫控制',25,1,0,0,0,0,1,1,0,1,0,0,'[]','[]',0,0,0,0,'0','[]',1,0,'[{\"desc\":\"变身后的2.5秒内每秒恢复3%生命值并免疫控制\",\"condition\":\"[]\",\"power\":\"100000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{116,0,1000,1,0,0.03,2,2500,2,0},{108,0,1000,1,0,0,0,2500,1,0}]\"},{\"desc\":\"变身后的2.8秒内每秒恢复3.6%生命值并免疫控制\",\"condition\":\"[]\",\"power\":\"150000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{116,0,1000,1,0,0.036,2,2800,2,0},{108,0,1000,1,0,0,0,2800,1,0}]\"},{\"desc\":\"变身后的3.2秒内每秒恢复4%生命值并免疫控制\",\"condition\":\"[]\",\"power\":\"210000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{116,0,1000,1,0,0.04,2,3200,3,0},{108,0,1000,1,0,0,0,3200,1,0}]\"},{\"desc\":\"变身后的3.6秒内每秒恢复4.6%生命值并免疫控制\",\"condition\":\"[]\",\"power\":\"273000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{116,0,1000,1,0,0.046,2,3600,3,0},{108,0,1000,1,0,0,0,3600,1,0}]\"},{\"desc\":\"变身后的4秒内每秒恢复5%生命值并免疫控制\",\"condition\":\"[]\",\"power\":\"341000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{116,0,1000,1,0,0.05,2,4000,4,0},{108,0,1000,1,0,0,0,4000,1,0}]\"},{\"desc\":\"变身后的4.5秒内每秒恢复5.6%生命值并免疫控制\",\"condition\":\"[]\",\"power\":\"413000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{116,0,1000,1,0,0.056,2,4500,4,0},{108,0,1000,1,0,0,0,4500,1,0}]\"}]'),(16002050,'众神之怒','降神符文技能，额外获得怒气',25,8,0,0,0,0,1,1,0,1,0,0,'[]','[]',0,0,0,0,'0','[]',1,0,'[{\"desc\":\"未变身时，攻击有30%概率额外获得12点怒气\",\"condition\":\"[]\",\"power\":\"100000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{125,0,300,1,12,0,0,0,0,0}]\"},{\"desc\":\"未变身时，攻击有34%概率额外获得16点怒气\",\"condition\":\"[]\",\"power\":\"150000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{125,0,340,1,16,0,0,0,0,0}]\"},{\"desc\":\"未变身时，攻击有38%概率额外获得20怒气\",\"condition\":\"[]\",\"power\":\"210000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{125,0,380,1,20,0,0,0,0,0}]\"},{\"desc\":\"未变身时，攻击有42%概率额外获得24怒气\",\"condition\":\"[]\",\"power\":\"273000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{125,0,420,1,24,0,0,0,0,0}]\"},{\"desc\":\"未变身时，攻击有46%概率额外获得28怒气\",\"condition\":\"[]\",\"power\":\"341000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{125,0,460,1,28,0,0,0,0,0}]\"},{\"desc\":\"未变身时，攻击有50%概率额外获得32怒气\",\"condition\":\"[]\",\"power\":\"413000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{125,0,500,1,32,0,0,0,0,0}]\"}]'),(17000001,'火炮发射','战舰技能',0,1,1,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,300,'0','[]',0,0,'[{\"desc\":\"对前方直线区域3个目标造成30%的伤害\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"300\",\"num\":\"[3,5]\",\"attr\":\"\",\"hurt\":\"3000\",\"effect\":\"[]\"}]'),(17000002,'榴弹喷射','战舰技能',0,1,0,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,500,'0','[]',0,0,'[{\"desc\":\"对前方直线区域4个目标造成150%的伤害\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"3000\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"500\",\"num\":\"[4,5]\",\"attr\":\"\",\"hurt\":\"15000\",\"effect\":\"[]\"}]'),(17000003,'防御工事','战舰技能',0,1,0,0,0,0,1,1,1,1,1000,1,'0','[]',0,0,0,500,'0','[]',0,0,'[{\"desc\":\"给舰体施加一个血量15%的护盾，持续4s\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"6000\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{104,1,1000,1,0,0.15,2,4000,0,0}]\"}]'),(17000004,'火焰喷射','战舰技能',0,1,0,0,0,0,2,2,1,1,1000,3,'0','[]',0,0,0,500,'0','[]',2,0,'[{\"desc\":\"对前方直线区域5个目标造成225%的伤害\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"8000\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"500\",\"num\":\"[5,6]\",\"attr\":\"\",\"hurt\":\"22500\",\"effect\":\"[]\"}]'),(17000011,'冲锋火炮','战舰技能',0,1,1,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,300,'0','[]',0,0,'[{\"desc\":\"对前方直线区域3个目标造成36%的伤害\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"400\",\"num\":\"[3,5]\",\"attr\":\"\",\"hurt\":\"3600\",\"effect\":\"[]\"}]'),(17000012,'自爆袭击','自爆袭击',0,1,0,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,500,'0','[]',0,0,'[{\"desc\":\"对周围圆形区域5个目标造成180%的伤害\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"3000\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"600\",\"num\":\"[5,6]\",\"attr\":\"\",\"hurt\":\"18000\",\"effect\":\"[]\"}]'),(17000013,'冲锋护盾','战舰技能',0,1,0,0,0,0,1,1,1,1,1000,1,'0','[]',0,0,0,500,'0','[]',0,0,'[{\"desc\":\"给舰体施加一个血量20%的护盾，持续4s\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"6000\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{104,1,1000,1,0,0.2,2,4000,0,0}]\"}]'),(17000014,'怒海冲锋','战舰技能',0,1,0,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,500,'0','[]',2,0,'[{\"desc\":\"对前方直线区域5个目标造成270%的伤害\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"8000\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"500\",\"num\":\"[5,5]\",\"attr\":\"\",\"hurt\":\"27000\",\"effect\":\"[{113,4,1000,1,700,0,0,400,0,0}]\"}]'),(17000021,'战舰火炮','战舰技能',0,1,1,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,300,'0','[]',0,0,'[{\"desc\":\"对前方直线区域3个目标造成42%的伤害\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"300\",\"num\":\"[3,5]\",\"attr\":\"\",\"hurt\":\"4200\",\"effect\":\"[]\"}]'),(17000022,'减速弹雨','战舰技能',0,1,0,0,0,0,2,2,1,1,1000,3,'0','[]',0,0,0,500,'0','[]',0,0,'[{\"desc\":\"对前方扇形区域4个目标造成210%的伤害，有概率减速25%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"3000\",\"trigger\":\"[{0,1000,0,1,0,0,0,121}]\",\"distance\":\"700\",\"area\":\"500\",\"num\":\"[4,5]\",\"attr\":\"\",\"hurt\":\"21000\",\"effect\":\"[{121,4,250,2,0,-0.25,0,3000,1,1}]\"}]'),(17000023,'疾行风雷','战舰技能',0,1,0,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,500,'0','[]',0,0,'[{\"desc\":\"召唤风雷元素之力，增加战舰30%移动速度，持续3s\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"6000\",\"trigger\":\"[{0,1000,0,1,0,0,0,121}]\",\"distance\":\"800\",\"area\":\"400\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"20000\",\"effect\":\"[{121,4,1000,1,0,0.30,0,3000,1,1}]\"}]'),(17000024,'疾行轰炸','战舰技能',0,1,0,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,500,'0','[]',2,0,'[{\"desc\":\"对前方直线区域5个目标造成315%的伤害\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"8000\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"600\",\"num\":\"[5,6]\",\"attr\":\"\",\"hurt\":\"31500\",\"effect\":\"[]\"}]'),(17000031,'主炮发射','战舰技能',0,1,1,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,300,'0','[]',0,0,'[{\"desc\":\"对前方直线区域3个目标造成51%的伤害\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"400\",\"num\":\"[3,5]\",\"attr\":\"\",\"hurt\":\"5100\",\"effect\":\"[]\"}]'),(17000032,'海王喷射','战舰技能',0,1,0,0,0,0,2,2,1,1,1000,3,'0','[]',0,0,0,500,'0','[]',0,0,'[{\"desc\":\"对前方直线区域4个目标造成250%的伤害\",\"condition\":\"[{lv,13}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"3000\",\"trigger\":\"[]\",\"distance\":\"750\",\"area\":\"400\",\"num\":\"[4,5]\",\"attr\":\"\",\"hurt\":\"25000\",\"effect\":\"[]\"}]'),(17000033,'海王庇护','战舰技能',0,3,0,0,0,0,1,1,0,1,1000,1,'0','[]',0,0,0,500,'0','[]',0,0,'[{\"desc\":\"给自己的战舰进行补给，回复25%的血量\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"6000\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"600\",\"num\":\"[1,0]\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,1,1000,1,0,0.25,2,1000,1,1}]\"}]'),(17000034,'海王怒涛','战舰技能',0,1,0,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,500,'0','[]',2,0,'[{\"desc\":\"对前方直线区域6个目标造成380%的伤害\",\"condition\":\"[{lv,13}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"8000\",\"trigger\":\"[]\",\"distance\":\"750\",\"area\":\"600\",\"num\":\"[6,6]\",\"attr\":\"\",\"hurt\":\"38000\",\"effect\":\"[]\"}]'),(20002001,'冲车普攻','公会争霸技能',20,1,1,0,0,0,1,2,1,2,1000,2,'0','[]',0,0,0,2500,'0','[]',0,0,'[{\"desc\":\"冲车普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"300\",\"area\":\"300\",\"num\":\"[6,6]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(20002002,'冲车技能','公会争霸技能',20,1,0,0,0,0,1,1,0,1,1000,1,'0','[]',0,0,0,2500,'0','[]',0,0,'[{\"desc\":\"冲车冲冲冲,提升20%移动速度，持续10s\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"20000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"500\",\"num\":\"[1,1]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"[{121,1,10000,1,0,0.2,0,10000,1,1}]\"}]'),(20002003,'炮车普攻','公会争霸技能',20,1,1,0,0,0,1,2,1,2,1000,2,'0','[]',0,0,0,2500,'0','[]',0,0,'[{\"desc\":\"炮车普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"300\",\"num\":\"[6,6]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(20002004,'炮车技能','公会争霸技能',20,1,0,0,0,0,1,1,1,1,1000,1,'0','[]',0,0,0,2500,'0','[]',0,0,'[{\"desc\":\"炮车冲冲冲，提升20%移动速度，持续10s\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"20000\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"800\",\"num\":\"[1,1]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"[{121,1,10000,1,0,0.2,0,10000,1,1}]\"}]'),(20002201,'半人马普攻','半人马普攻',11,1,1,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"300\",\"area\":\"300\",\"num\":\"[1,1]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(20003000,'暗裔一号普攻','暗裔一号普攻',11,1,0,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"100\",\"area\":\"200\",\"num\":\"[1,1]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(20003001,'暗裔一号预警','暗裔一号预警',11,1,0,0,0,0,2,2,0,1,1500,1,'0','[{20003001,3000,0},{20003002,1500,0},{20003002,500,0}]',0,0,0,5000,'[20003001,20003002,20003003]','[]',0,0,'[{\"desc\":\"技能预警\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"12000\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"800\",\"num\":\"[1,1]\",\"attr\":\"[]\",\"hurt\":\"20000\",\"effect\":\"[]\"}]'),(20003002,'暗裔一号技能','暗裔一号技能',11,1,0,0,0,0,2,2,1,1,1000,1,'0','[{20003001,3000,0},{20003002,1500,0},{20003002,600,0}]',0,0,0,1500,'[20003001,20003002,20003003]','[]',1,0,'[{\"desc\":\"对前方扇形区域4个玩家（8个怪物）造成300%的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"25000\",\"effect\":\"\"}]'),(20003003,'暗裔一号飘字','暗裔一号飘字',11,1,0,1,0,0,2,2,1,1,1000,1,'0','[{20003001,3000,0},{20003002,1500,0},{20003002,600,0}]',0,0,0,600,'[20003001,20003002,20003003]','[]',1,0,'[{\"desc\":\"对前方扇形区域4个玩家（8个怪物）造成300%的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"25000\",\"effect\":\"\"}]'),(20003004,'暗裔二号普攻','暗裔二号普攻',11,1,0,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"100\",\"area\":\"200\",\"num\":\"[1,1]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(20003005,'暗裔二号预警','暗裔二号预警',11,1,0,0,0,0,2,2,0,1,1500,1,'0','[{20003005,3000,0},{20003006,1500,0},{20003007,500,0}]',0,0,0,5000,'[20003005,20003006,20003007]','[]',0,0,'[{\"desc\":\"技能预警\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"12000\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"800\",\"num\":\"[1,1]\",\"attr\":\"[]\",\"hurt\":\"20000\",\"effect\":\"[]\"}]'),(20003006,'暗裔二号技能','暗裔二号技能',11,1,0,0,0,0,2,2,1,1,1000,1,'0','[{20003005,3000,0},{20003006,1500,0},{20003007,600,0}]',0,0,0,1500,'[20003005,20003006,20003008]','[]',0,0,'[{\"desc\":\"对前方扇形区域4个玩家（8个怪物）造成300%的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"16000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"25000\",\"effect\":\"\"}]'),(20003007,'暗裔二号飘字','暗裔二号飘字',11,1,0,1,0,0,2,2,1,1,1000,1,'0','[{20003005,3000,0},{20003006,1500,0},{20003007,600,0}]',0,0,0,600,'[20003005,20003006,20003009]','[]',0,0,'[{\"desc\":\"对前方扇形区域4个玩家（8个怪物）造成300%的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"25000\",\"effect\":\"\"}]'),(20003008,'主线BOSS3普攻','主线BOSS3普攻',11,1,0,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"100\",\"area\":\"200\",\"num\":\"[1,1]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(20003009,'主线BOSS3技能1','主线BOSS3技能1',11,1,0,0,0,0,2,2,0,1,1500,1,'0','[{20003009,3000,0},{20003010,1500,0},{20003011,500,0}]',0,0,0,5000,'[20003009,20003010,20003011]','[]',0,0,'[{\"desc\":\"技能预警\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"12000\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"800\",\"num\":\"[1,1]\",\"attr\":\"[]\",\"hurt\":\"30000\",\"effect\":\"[]\"}]'),(20003010,'主线BOSS3技能2','主线BOSS3技能2',11,1,0,0,0,0,2,2,1,1,1000,1,'0','[{20003009,3000,0},{20003010,1500,0},{20003011,600,0}]',0,0,0,1500,'[20003009,20003010,20003012]','[]',0,0,'[{\"desc\":\"对前方扇形区域4个玩家（8个怪物）造成300%的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"25000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"15000\",\"effect\":\"\"}]'),(20003011,'主线BOSS3技能3','主线BOSS3技能3',11,1,0,1,0,0,2,2,1,1,1000,1,'0','[{20003009,3000,0},{20003010,1500,0},{20003011,600,0}]',0,0,0,600,'[20003009,20003010,20003013]','[]',0,0,'[{\"desc\":\"对前方扇形区域4个玩家（8个怪物）造成300%的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"25000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"15000\",\"effect\":\"\"}]'),(20005400,'波塞冬普攻','波塞冬普攻',11,1,0,0,0,0,2,2,1,1,1000,2,'0','[{20005400,400,0},{20005401,300,0},{20005402,400,0},{20005403,300,0}]',0,0,0,2000,'[20005400,20005421,20005422,20005423]','[]',1,0,'[{\"desc\":\"对前方直线区域2个玩家（2个怪物）造成100%的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"200\",\"num\":\"[2,2]\",\"attr\":\"\",\"hurt\":\"5000\",\"effect\":\"\"}]'),(20005401,'波塞冬普攻四连2','波塞冬普攻四连2',11,1,1,1,0,0,2,2,1,1,1000,2,'0','[{20005400,400,0},{20005401,300,0},{20005402,400,0},{20005403,300,0}]',0,0,0,500,'[20005400,20005421,20005422,20005423]','[]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"200\",\"num\":\"[2,2]\",\"attr\":\"\",\"hurt\":\"5000\",\"effect\":\"\"}]'),(20005402,'波塞冬普攻四连3','波塞冬普攻四连3',11,1,1,1,0,0,2,2,1,1,1000,2,'0','[{20005400,400,0},{20005401,300,0},{20005402,400,0},{20005403,300,0}]',0,0,0,500,'[20005400,20005421,20005422,20005423]','[]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"560\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"200\",\"num\":\"[2,2]\",\"attr\":\"\",\"hurt\":\"5000\",\"effect\":\"\"}]'),(20005403,'波塞冬普攻四连4','波塞冬普攻四连4',11,1,1,1,0,0,2,2,1,1,1000,2,'0','[{20005400,400,0},{20005401,300,0},{20005402,400,0},{20005403,300,0}]',0,0,0,800,'[20005400,20005421,20005422,20005423]','[]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"1060\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"200\",\"num\":\"[2,2]\",\"attr\":\"\",\"hurt\":\"5000\",\"effect\":\"\"}]'),(20005404,'海皇碎击','波塞冬技能1',11,1,0,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,1000,'0','[]',1,0,'[{\"desc\":\"对前方直线区域3个玩家（6个怪物）造成200%的伤害\",\"condition\":\"[{lv,6}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"3000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[3,6]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(20005405,'海皇之怒','波塞冬技能2',11,1,0,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,1000,'0','[]',1,0,'[{\"desc\":\"对前方扇形区域4个玩家（8个怪物）造成300%的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(20005406,'极寒领域','波塞冬技能3',11,1,0,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,1000,'0','[]',1,0,'[{\"desc\":\"对前方扇形区域4个玩家（8个怪物）造成300%的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(20005411,'女武神普攻','女武神普攻1',11,1,0,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,1667,'0','[]',1,0,'[{\"desc\":\"<color>对前</color>方直线区域2个玩家（2个怪物）造成100%的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"16670\",\"effect\":\"\"}]'),(20005412,'女武神预警','女武神预警',11,1,0,0,0,0,2,2,0,1,1000,1,'0','[{20005412,2500,0},{20005417,1300,0}]',0,0,0,4500,'[20005412,20005417]','[]',0,0,'[{\"desc\":\"123\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"12000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"10000\",\"effect\":\"[]\"}]'),(20005417,'女神之怒','女武神技能3',11,1,0,1,0,0,2,2,1,1,1000,1,'0','[{20005412,2500,0},{20005417,1300,0}]',0,0,0,4500,'[20005412,20005417]','[]',1,0,'[{\"desc\":\"对前方扇形区域4个玩家（8个怪物）造成300%的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"45000\",\"effect\":\"\"}]'),(20005420,'光明神普攻','光明神普攻',11,1,0,0,0,0,2,2,1,1,250,2,'0','[{20005420,400,0},{20005421,300,0},{20005422,400,0},{20005423,300,0}]',0,0,0,2000,'[20005420,20005421,20005422,20005423]','[]',1,0,'[{\"desc\":\"<color>对前</color>方直线区域2个玩家（2个怪物）造成100%的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"10000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"5000\",\"effect\":\"\"}]'),(20005421,'光明神普攻四连2','光明神普攻四连2',11,1,1,1,0,0,2,2,1,1,250,2,'0','[{20005420,400,0},{20005421,300,0},{20005422,400,0},{20005423,300,0}]',0,0,0,500,'[20005420,20005421,20005422,20005423]','[]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"10000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"5000\",\"effect\":\"\"}]'),(20005422,'光明神普攻四连3','光明神普攻四连3',11,1,1,1,0,0,2,2,1,1,1000,2,'0','[{20005420,400,0},{20005421,300,0},{20005422,400,0},{20005423,300,0}]',0,0,0,500,'[20005420,20005421,20005422,20005423]','[]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"10000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"5000\",\"effect\":\"\"}]'),(20005423,'光明神普攻四连4','光明神普攻四连4',11,1,1,1,0,0,2,2,1,1,1000,2,'0','[{20005420,400,0},{20005421,300,0},{20005422,400,0},{20005423,300,0}]',0,0,0,800,'[20005420,20005421,20005422,20005423]','[]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"5000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"5000\",\"effect\":\"\"}]'),(20005424,'审判之光','光明神技能1',11,1,0,0,0,0,2,2,1,1,1000,2,'0','[{20005424,300,0},{20005425,0,0}]',0,0,0,2000,'0','[]',1,0,'[{\"desc\":\"对前方直线区域3个玩家（6个怪物）造成200%的伤害\",\"condition\":\"[{lv,6}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"3000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"400\",\"num\":\"[3,6]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(20005425,'审判之光副1','光明神技能1副技能',11,1,0,1,0,0,2,2,1,1,1000,2,'0','[{20005424,300,0},{20005425,0,0}]',0,0,0,500,'0','[]',1,0,'[{\"desc\":\"对前方直线区域3个玩家（6个怪物）造成200%的伤害\",\"condition\":\"[{lv,6}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"3000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"400\",\"num\":\"[3,6]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(20005426,'圣光天罚','光明神技能2',11,1,0,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,1000,'0','[]',1,0,'[{\"desc\":\"对前方扇形区域4个玩家（8个怪物）造成300%的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"15000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(20005427,'无间光域','光明神技能3',11,1,0,1,0,0,2,2,1,1,1000,1,'0','[{200054200,2500,0},{20005427,600,0},{20005428,200,0},{20005429,300,0},{20005430,0,0}]',0,0,0,4000,'[200054200,20005427,20005428,20005429,20005430]','[]',1,0,'[{\"desc\":\"对前方扇形区域4个玩家（8个怪物）造成300%的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"15000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"2000\",\"effect\":\"\"}]'),(20005428,'无间光域1','光明神技能3副1',11,1,0,1,0,0,2,2,1,1,1000,1,'0','[{200054200,2500,0},{20005427,600,0},{20005428,200,0},{20005429,300,0},{20005430,0,0}]',0,0,0,600,'[200054200,20005427,20005428,20005429,20005430]','[]',1,0,'[{\"desc\":\"对前方扇形区域4个玩家（8个怪物）造成300%的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(20005429,'无间光域副2','光明神技能3副2',11,1,0,1,0,0,2,2,1,1,1000,1,'0','[{200054200,2500,0},{20005427,600,0},{20005428,200,0},{20005429,300,0},{20005430,0,0}]',0,0,0,600,'[200054200,20005427,20005428,20005429,20005430]','[]',1,0,'[{\"desc\":\"对前方扇形区域4个玩家（8个怪物）造成300%的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(20005430,'无间光域副3','光明神技能3副3',11,1,0,1,0,0,2,2,1,1,1000,1,'0','[{200054200,2500,0},{20005427,600,0},{20005428,200,0},{20005429,300,0},{20005430,0,0}]',0,0,0,600,'[200054200,20005427,20005428,20005429,20005430]','[]',1,0,'[{\"desc\":\"对前方扇形区域4个玩家（8个怪物）造成300%的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(20005431,'冰神普攻','冰神普攻1',11,1,0,0,0,0,2,2,1,1,1000,2,'0','[{20005431,400,0},{20005432,300,0},{20005433,400,0},{20005434,300,0}]',0,0,0,500,'[20005431,20005432,20005433,20005434]','[]',1,0,'[{\"desc\":\"<color>对前</color>方直线区域2个玩家（2个怪物）造成100%的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(20005432,'冰神普攻四连2','冰神普攻2',11,1,1,1,0,0,2,2,1,1,1000,2,'0','[{20005431,400,0},{20005432,300,0},{20005433,400,0},{20005434,300,0}]',0,0,0,500,'[20005431,20005432,20005433,20005434]','[]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(20005433,'冰神普攻四连3','冰神普攻3',11,1,1,1,0,0,2,2,1,1,1000,2,'0','[{20005431,400,0},{20005432,300,0},{20005433,400,0},{20005434,300,0}]',0,0,0,500,'[20005431,20005432,20005433,20005434]','[]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"560\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(20005434,'冰神普攻四连4','冰神普攻4',11,1,1,1,0,0,2,2,1,1,1000,2,'0','[{20005431,400,0},{20005432,300,0},{20005433,400,0},{20005434,300,0}]',0,0,0,800,'[20005431,20005432,20005433,20005434]','[]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"1060\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(20005435,'冰刺碎击','冰神技能1',11,1,0,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,500,'0','[]',1,0,'[{\"desc\":\"对前方直线区域3个玩家（6个怪物）造成200%的伤害\",\"condition\":\"[{lv,6}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"3000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[3,6]\",\"attr\":\"\",\"hurt\":\"20000\",\"effect\":\"\"}]'),(20005436,'寒冰领域','冰神技能2',11,1,0,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,600,'0','[]',1,0,'[{\"desc\":\"对前方扇形区域4个玩家（8个怪物）造成300%的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"15000\",\"effect\":\"\"}]'),(20005437,'冰雪刃舞','冰神技能3',11,1,0,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,600,'0','[]',1,0,'[{\"desc\":\"对前方扇形区域4个玩家（8个怪物）造成300%的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"15000\",\"effect\":\"\"}]'),(20005440,'月神普攻','月神普攻1',11,1,0,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,500,'[20005440,20005441,20005442,20005443]','[]',1,0,'[{\"desc\":\"对前方直线区域2个玩家（3个怪物）造成80%的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"8000\",\"effect\":\"\"}]'),(20005441,'月神普攻四连2','月神普攻2',11,1,1,1,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,500,'[20005440,20005441,20005442,20005443]','[]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"12000\",\"effect\":\"\"}]'),(20005442,'月神普攻四连3','月神普攻3',11,1,1,1,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,500,'[20005440,20005441,20005442,20005443]','[]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"560\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"6000\",\"effect\":\"\"}]'),(20005443,'月神普攻四连4','月神普攻4',11,1,1,1,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,800,'[20005440,20005441,20005442,20005443]','[]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"1060\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"20000\",\"effect\":\"\"}]'),(20005444,'月光神罚','月神技能1',11,1,0,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,500,'0','[]',1,0,'[{\"desc\":\"对前方直线区域3个玩家（6个怪物）造成200%的伤害\",\"condition\":\"[{lv,6}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"3000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[3,6]\",\"attr\":\"\",\"hurt\":\"20000\",\"effect\":\"\"}]'),(20005445,'月辉枪击','月神技能2',11,1,0,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,600,'0','[]',1,0,'[{\"desc\":\"对前方扇形区域4个玩家（8个怪物）造成300%的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"15000\",\"effect\":\"\"}]'),(20005446,'月下独舞','月神技能3',11,1,0,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,600,'0','[]',1,0,'[{\"desc\":\"对前方扇形区域4个玩家（8个怪物）造成300%的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"15000\",\"effect\":\"\"}]'),(20005450,'死神普攻','死神普攻',11,1,1,0,0,0,2,2,1,1,1000,1,'0','[{20005450,400,0},{20005451,400,0},{20005452,1300,0}]',0,0,0,2000,'0','[]',0,0,'[{\"desc\":\"怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"10000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"400\",\"num\":\"[1,1]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(20005451,'死神普攻2','死神普攻',11,1,1,1,0,0,2,2,1,1,250,1,'0','[{20005450,400,0},{20005451,400,0},{20005452,1300,0}]',0,0,0,400,'[20005450,20005451,20005452]','[]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(20005452,'死神普攻3','死神普攻',11,1,1,1,0,0,2,2,1,1,1000,1,'0','[{20005450,400,0},{20005451,400,0},{20005452,1300,0}]',0,0,0,1300,'[20005450,20005451,20005452]','[]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"560\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(20005453,'死神技能1','死神普攻',11,1,0,1,0,0,2,2,1,2,1000,1,'0','[{20005455,2500,0},{20005453,2500,0}]',0,0,0,2500,'[20005455,20005453]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[1,1]\",\"attr\":\"[]\",\"hurt\":\"15000\",\"effect\":\"[]\"}]'),(20005454,'死神技能副1','死神普攻',11,1,0,0,0,0,2,2,1,1,1000,1,'0','[{20005455,2500,0},{20005453,2500,0}]',0,0,0,2000,'[20005455,20005453]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"400\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[500,500]\",\"attr\":\"[]\",\"hurt\":\"15000\",\"effect\":\"[]\"}]'),(20005455,'死神技能预警','死神技能预警',11,1,0,0,0,0,2,2,0,1,1000,1,'0','[{20005455,2500,0},{20005453,2500,0}]',0,0,0,5000,'[20005455,20005453]','[]',0,0,'[{\"desc\":\"123\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"14000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"700\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"10000\",\"effect\":\"[]\"}]'),(20005456,'死神技能1','死神技能1',11,1,0,1,0,0,2,2,1,2,1000,1,'0','[{20005458,2500,0},{20005456,1500,0},{20005457,2000,0}]',0,0,0,2000,'[20005458,20005456,20005457]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[500,500]\",\"attr\":\"[]\",\"hurt\":\"25000\",\"effect\":\"[]\"}]'),(20005457,'死神技能副1','死神技能副1',11,1,0,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,350,'[{20005458,2500,0},{20005456,1500,0},{20005457,2000,0}]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"800\",\"num\":\"[500,500]\",\"attr\":\"[]\",\"hurt\":\"25000\",\"effect\":\"[]\"}]'),(20005458,'死神技能预警','死神技能预警',11,1,0,0,0,0,2,2,0,2,1000,1,'0','[{20005458,2500,0},{20005456,1500,0},{20005457,2000,0}]',0,0,0,5000,'[20005458,20005456,20005457]','[]',0,0,'[{\"desc\":\"123\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"12800\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"30000\",\"effect\":\"[]\"}]'),(20005700,'荣耀战神普攻','荣耀战神普攻',11,1,1,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,1000,'[]','[]',0,0,'[{\"desc\":\"普通攻击\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"1000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"1000\",\"num\":\"[500,500]\",\"attr\":\"[]\",\"hurt\":\"10000\",\"effect\":\"[]\"}]'),(20005701,'荣耀战神普攻副1','荣耀战神普攻副1',11,1,1,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,1000,'[]','[]',0,0,'[{\"desc\":\"[]\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"1000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"1000\",\"num\":\"[500,500]\",\"attr\":\"[]\",\"hurt\":\"10000\",\"effect\":\"[]\"}]'),(20005710,'荣耀战神全屏大招','荣耀战神全屏大招',11,1,0,0,0,0,2,2,0,1,1000,1,'0','[{20005710,600,0},{20005711,500,0}]',0,0,0,2000,'[20005710,20005711]','[]',0,0,'[{\"desc\":\"荣耀战神全屏大招\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"20000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"10000\",\"num\":\"[500,500]\",\"attr\":\"[]\",\"hurt\":\"15000\",\"effect\":\"[]\"}]'),(20005711,'荣耀全屏大招副1','荣耀全屏大招副1',11,1,0,1,0,0,2,2,1,1,1000,1,'0','[{20005710,1000,0},{20005711,1000,0}]',0,0,0,0,'[20005710,20005711]','[]',0,0,'[{\"desc\":\"荣耀战神全屏大招伤害\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"20000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"10000\",\"num\":\"[500,500]\",\"attr\":\"[]\",\"hurt\":\"99999\",\"effect\":\"[]\"}]'),(20005720,'荣耀战神小技能','荣耀战神小技能',11,1,0,1,0,0,2,2,0,1,1000,1,'0','[{20005722,3500,0},{20005720,500,0},{20005721,500,0}]',0,0,0,3000,'[20005722,20005720,20005721]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"18000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"10000\",\"num\":\"[500,500]\",\"attr\":\"[]\",\"hurt\":\"20000\",\"effect\":\"[]\"}]'),(20005721,'荣耀战神小技能副1','荣耀战神小技能副1',11,1,0,1,0,0,2,2,1,1,1000,1,'0','[{20005722,3500,0},{20005720,500,0},{20005721,500,0}]',0,0,0,0,'[20005722,20005720,20005721]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"18000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"800\",\"num\":\"[500,500]\",\"attr\":\"[]\",\"hurt\":\"20000\",\"effect\":\"[]\"}]'),(20005722,'荣耀战神小技能预警','荣耀战神小技能预警',11,1,0,0,0,0,2,2,0,1,1000,1,'0','[{20005722,3500,0},{20005720,1200,0},{20005721,1200,0}]',0,0,0,3500,'[20005722,20005720,20005721]','[]',0,0,'[{\"desc\":\"123\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"20000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"10000\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"10000\",\"effect\":\"[]\"}]'),(21000001,'鼓舞加成','鼓舞',21,3,0,0,0,0,1,1,0,1,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"增加自身5%伤害\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"0\",\"num\":\"[1,1]\",\"attr\":\"[{9,2,1000,1,500,0,500000,10,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(21000002,'鼓舞加成钻石','鼓舞钻石',21,3,0,0,0,0,1,1,0,1,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"增加自身10%伤害\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"\",\"num\":\"[1,1]\",\"attr\":\"[{9,2,1000,1,1000,0,500000,10,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(21001003,'愈战愈勇','大乱斗连续死亡BUFF',10,2,0,0,0,0,1,1,0,1,0,0,'[]','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"增加3%伤害减免\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{10,2,1000,1,500,0,120000,10,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{10,2,1000,1,500,0,120000,10,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{10,2,1000,1,500,0,120000,10,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{10,2,1000,1,500,0,120000,10,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{10,2,1000,1,500,0,120000,10,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{10,2,1000,1,500,0,120000,10,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{10,2,1000,1,500,0,120000,10,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{10,2,1000,1,500,0,120000,10,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{10,2,1000,1,500,0,120000,10,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{10,2,1000,1,500,0,120000,10,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(21005151,'婚戒技能1','婚姻技能',28,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"PVE伤害加成+5%\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[{0,50,500}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(21005152,'婚戒技能2','婚姻技能',28,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"PVP伤害加成+5%\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[{0,51,500}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(21005153,'婚戒技能3','婚姻技能',28,2,0,0,0,0,1,2,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"PVE伤害减免+8%\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[{0,230,800}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(21005154,'婚戒技能4','婚姻技能',28,2,0,0,0,0,1,1,0,1,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"PVP伤害减免+8%\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[{0,231,800}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(21005155,'同心结技能1','婚姻技能',28,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"bosss伤害加成+5%\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[{0,203,500}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(21005156,'同心结技能2','婚姻技能',28,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"bosss伤害减免+5%\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[{0,232,500}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(21005157,'同心结技能3','婚姻技能',28,2,0,0,0,0,1,1,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"命中率+5%\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[{0,11,500}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(21005158,'同心结技能4','婚姻技能',28,2,0,0,0,0,1,2,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"闪避率+5%\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[{0,12,500}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(21005200,'你侬我侬','情侣副本技能',21,3,0,0,0,0,1,1,0,1,0,1,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"使用后无敌5s\",\"condition\":\"[]\",\"power\":\"[]\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{106,3,10000,1,0,0,0,5000,0,1}]\"}]'),(21005201,'情比金坚','情侣副本技能',21,1,0,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"全屏AOE\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"15000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"500\",\"num\":\"[10,10]\",\"attr\":\"[]\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(21007001,'眩晕1s','钻石大战及鞥',0,1,0,0,0,0,1,2,1,1,1000,3,'0','[]',0,0,0,500,'0','[]',0,0,'[{\"desc\":\"眩晕1s\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"5000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"500\",\"num\":\"[1,1]\",\"attr\":\"[]\",\"hurt\":\"1000\",\"effect\":\"[{101,3,10000,4,0,0,0,1000,1,1}]\"}]'),(21007002,'无敌2s','钻石大战及鞥',0,3,0,0,0,0,1,1,0,1,0,1,'0','[]',0,0,0,500,'0','[]',0,0,'[{\"desc\":\"无敌2s\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"6000\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{106,3,10000,1,0,0,0,2000,1,1}]\"}]'),(21007003,'增伤3s','钻石大战及鞥',0,3,0,0,0,0,1,1,0,1,0,0,'0','[]',0,0,0,500,'0','[]',0,0,'[{\"desc\":\"增伤3s\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"8000\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[1,1]\",\"attr\":\"[{1,2,10000,1,0,0.2,3000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(24000001,'超驱动','飞艇技能',24,1,0,0,0,0,1,1,0,1,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"飞艇引擎全力运转，使玩家攻击力+50%，持续10秒\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{1,0,1000,1,5000,0,10000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(30000001,'爆裂炙炎','光辉神圣器技能',25,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"攻击时有10%几率降低目标15%的暴击，持续3s\",\"condition\":\"[]\",\"power\":\"10000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,7}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{7,0,100,2,0,-0.15,3000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有12%几率降低目标15%的暴击，持续3s\",\"condition\":\"[]\",\"power\":\"18000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,7}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{7,0,120,2,0,-0.15,3000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有14%几率降低目标15%的暴击，持续3s\",\"condition\":\"[]\",\"power\":\"26000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,7}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{7,0,140,2,0,-0.15,3000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有16%几率降低目标15%的暴击，持续3s\",\"condition\":\"[]\",\"power\":\"34000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,7}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{7,0,160,2,0,-0.15,3000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有18%几率降低目标15%的暴击，持续3s\",\"condition\":\"[]\",\"power\":\"42000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,7}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{7,0,180,2,0,-0.15,3000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有20%几率降低目标15%的暴击，持续3s\",\"condition\":\"[]\",\"power\":\"50000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,7}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{7,0,200,2,0,-0.15,3000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有22%几率降低目标15%的暴击，持续3s\",\"condition\":\"[]\",\"power\":\"58000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,7}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{7,0,220,2,0,-0.15,3000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有24%几率降低目标15%的暴击，持续3s\",\"condition\":\"[]\",\"power\":\"66000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,7}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{7,0,240,2,0,-0.15,3000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有26%几率降低目标15%的暴击，持续3s\",\"condition\":\"[]\",\"power\":\"74000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,7}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{7,0,260,2,0,-0.15,3000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有28%几率降低目标15%的暴击，持续3s\",\"condition\":\"[]\",\"power\":\"82000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,7}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{7,0,280,2,0,-0.15,3000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(30000002,'极寒之躯','霜之哀伤圣器技能',25,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"攻击时有10%的概率提升自身减伤10%，持续5s\",\"condition\":\"[]\",\"power\":\"15000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,10}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{10,0,100,1,1000,0,5000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有10%的概率提升自身减伤10%，持续5s\",\"condition\":\"[]\",\"power\":\"25000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,10}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{10,0,120,1,1000,0,5000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有10%的概率提升自身减伤10%，持续5s\",\"condition\":\"[]\",\"power\":\"35000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,10}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{10,0,140,1,1000,0,5000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有10%的概率提升自身减伤10%，持续5s\",\"condition\":\"[]\",\"power\":\"45000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,10}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{10,0,160,1,1000,0,5000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有10%的概率提升自身减伤10%，持续5s\",\"condition\":\"[]\",\"power\":\"55000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,10}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{10,0,180,1,1000,0,5000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有10%的概率提升自身减伤10%，持续5s\",\"condition\":\"[]\",\"power\":\"65000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,10}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{10,0,200,1,1000,0,5000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有10%的概率提升自身减伤10%，持续5s\",\"condition\":\"[]\",\"power\":\"75000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,10}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{10,0,220,1,1000,0,5000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有10%的概率提升自身减伤10%，持续5s\",\"condition\":\"[]\",\"power\":\"85000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,10}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{10,0,240,1,1000,0,5000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有10%的概率提升自身减伤10%，持续5s\",\"condition\":\"[]\",\"power\":\"95000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,10}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{10,0,260,1,1000,0,5000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有10%的概率提升自身减伤10%，持续5s\",\"condition\":\"[]\",\"power\":\"105000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,10}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{10,0,280,1,1000,0,5000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(30000003,'月华漫天','月神圣器技能',25,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"攻击时有10%几率提升自身伤害15%，持续3s\",\"condition\":\"[]\",\"power\":\"21880\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,9}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{9,0,100,1,1500,0,3000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有12%几率提升自身伤害15%，持续3s\",\"condition\":\"[]\",\"power\":\"37800\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,9}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{9,0,120,1,1500,0,3000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有14%几率提升自身伤害15%，持续3s\",\"condition\":\"[]\",\"power\":\"62300\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,9}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{9,0,140,1,1500,0,3000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有16%几率提升自身伤害15%，持续3s\",\"condition\":\"[]\",\"power\":\"100600\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,9}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{9,0,160,1,1500,0,3000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有18%几率提升自身伤害15%，持续3s\",\"condition\":\"[]\",\"power\":\"152700\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,9}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{9,0,180,1,1500,0,3000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有20%几率提升自身伤害15%，持续3s\",\"condition\":\"[]\",\"power\":\"218450\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,9}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{9,0,200,1,1500,0,3000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有22%几率提升自身伤害15%，持续3s\",\"condition\":\"[]\",\"power\":\"298000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,9}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{9,0,220,1,1500,0,3000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有24%几率提升自身伤害15%，持续3s\",\"condition\":\"[]\",\"power\":\"391350\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,9}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{9,0,240,1,1500,0,3000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有26%几率提升自身伤害15%，持续3s\",\"condition\":\"[]\",\"power\":\"498350\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,9}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{9,0,260,1,1500,0,3000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有28%几率提升自身伤害15%，持续3s\",\"condition\":\"[]\",\"power\":\"619150\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,9}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{9,0,280,1,1500,0,3000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(30000004,'深海重压','海神之戟圣器技能',25,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"攻击时有10%几率对目标施加缓速30%效果，持续3s\",\"condition\":\"[]\",\"power\":\"27000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,102}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{121,2,100,2,0,-0.3,0,3000,0,0}]\"},{\"desc\":\"攻击时有12%几率对目标施加缓速30%效果，持续3s\",\"condition\":\"[]\",\"power\":\"45000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,102}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{121,2,120,2,0,-0.3,0,3000,0,0}]\"},{\"desc\":\"攻击时有14%几率对目标施加缓速30%效果，持续3s\",\"condition\":\"[]\",\"power\":\"63000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,102}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{121,2,140,2,0,-0.3,0,3000,0,0}]\"},{\"desc\":\"攻击时有16%几率对目标施加缓速30%效果，持续3s\",\"condition\":\"[]\",\"power\":\"81000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,102}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{121,2,160,2,0,-0.3,0,3000,0,0}]\"},{\"desc\":\"攻击时有18%几率对目标施加缓速30%效果，持续3s\",\"condition\":\"[]\",\"power\":\"99000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,102}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{121,2,180,2,0,-0.3,0,3000,0,0}]\"},{\"desc\":\"攻击时有20%几率对目标施加缓速30%效果，持续3s\",\"condition\":\"[]\",\"power\":\"117000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,102}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{121,2,200,2,0,-0.3,0,3000,0,0}]\"},{\"desc\":\"攻击时有22%几率对目标施加缓速30%效果，持续3s\",\"condition\":\"[]\",\"power\":\"135000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,102}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{121,2,220,2,0,-0.3,0,3000,0,0}]\"},{\"desc\":\"攻击时有24%几率对目标施加缓速30%效果，持续3s\",\"condition\":\"[]\",\"power\":\"153000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,102}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{121,2,240,2,0,-0.3,0,3000,0,0}]\"},{\"desc\":\"攻击时有26%几率对目标施加缓速30%效果，持续3s\",\"condition\":\"[]\",\"power\":\"171000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,102}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{121,2,260,2,0,-0.3,0,3000,0,0}]\"},{\"desc\":\"攻击时有28%几率对目标施加缓速30%效果，持续3s\",\"condition\":\"[]\",\"power\":\"189000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,102}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{121,2,280,2,0,-0.3,0,3000,0,0}]\"}]'),(30000005,'神圣一击','荣耀之枪圣器技能',25,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"攻击时有10%几率无视对方50%防御\",\"condition\":\"[]\",\"power\":\"24000\",\"base_attr\":\"[]\",\"cd\":\"5000\",\"trigger\":\"[{0,1000,0,1,0,0,0,4}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{4,0,100,2,0,-0.5,1000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有12%几率无视对方50%防御\",\"condition\":\"[]\",\"power\":\"40000\",\"base_attr\":\"[]\",\"cd\":\"5000\",\"trigger\":\"[{0,1000,0,1,0,0,0,4}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{4,0,120,2,0,-0.5,1000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有14%几率无视对方50%防御\",\"condition\":\"[]\",\"power\":\"56000\",\"base_attr\":\"[]\",\"cd\":\"5000\",\"trigger\":\"[{0,1000,0,1,0,0,0,4}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{4,0,140,2,0,-0.5,1000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有16%几率无视对方50%防御\",\"condition\":\"[]\",\"power\":\"72000\",\"base_attr\":\"[]\",\"cd\":\"5000\",\"trigger\":\"[{0,1000,0,1,0,0,0,4}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{4,0,160,2,0,-0.5,1000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有18%几率无视对方50%防御\",\"condition\":\"[]\",\"power\":\"88000\",\"base_attr\":\"[]\",\"cd\":\"5000\",\"trigger\":\"[{0,1000,0,1,0,0,0,4}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{4,0,180,2,0,-0.5,1000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有20%几率无视对方50%防御\",\"condition\":\"[]\",\"power\":\"104000\",\"base_attr\":\"[]\",\"cd\":\"5000\",\"trigger\":\"[{0,1000,0,1,0,0,0,4}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{4,0,200,2,0,-0.5,1000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有22%几率无视对方50%防御\",\"condition\":\"[]\",\"power\":\"120000\",\"base_attr\":\"[]\",\"cd\":\"5000\",\"trigger\":\"[{0,1000,0,1,0,0,0,4}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{4,0,220,2,0,-0.5,1000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有24%几率无视对方50%防御\",\"condition\":\"[]\",\"power\":\"136000\",\"base_attr\":\"[]\",\"cd\":\"5000\",\"trigger\":\"[{0,1000,0,1,0,0,0,4}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{4,0,240,2,0,-0.5,1000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有26%几率无视对方50%防御\",\"condition\":\"[]\",\"power\":\"152000\",\"base_attr\":\"[]\",\"cd\":\"5000\",\"trigger\":\"[{0,1000,0,1,0,0,0,4}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{4,0,260,2,0,-0.5,1000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有28%几率无视对方50%防御\",\"condition\":\"[]\",\"power\":\"168000\",\"base_attr\":\"[]\",\"cd\":\"5000\",\"trigger\":\"[{0,1000,0,1,0,0,0,4}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{4,0,280,2,0,-0.5,1000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(30000006,'黑暗降临','死神镰刀圣器技能',25,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"攻击时有10%几率给目标施加盲目效果，命中率降低30%，持续3s\",\"condition\":\"[]\",\"power\":\"35000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,11}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{11,0,100,2,-3000,0,3000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有12%几率给目标施加盲目效果，命中率降低30%，持续3s\",\"condition\":\"[]\",\"power\":\"55000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,11}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{11,0,120,2,-3000,0,3000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有14%几率给目标施加盲目效果，命中率降低30%，持续3s\",\"condition\":\"[]\",\"power\":\"75000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,11}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{11,0,140,2,-3000,0,3000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有16%几率给目标施加盲目效果，命中率降低30%，持续3s\",\"condition\":\"[]\",\"power\":\"95000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,11}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{11,0,160,2,-3000,0,3000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有18%几率给目标施加盲目效果，命中率降低30%，持续3s\",\"condition\":\"[]\",\"power\":\"115000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,11}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{11,0,180,2,-3000,0,3000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有20%几率给目标施加盲目效果，命中率降低30%，持续3s\",\"condition\":\"[]\",\"power\":\"135000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,11}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{11,0,200,2,-3000,0,3000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有22%几率给目标施加盲目效果，命中率降低30%，持续3s\",\"condition\":\"[]\",\"power\":\"155000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,11}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{11,0,220,2,-3000,0,3000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有24%几率给目标施加盲目效果，命中率降低30%，持续3s\",\"condition\":\"[]\",\"power\":\"175000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,11}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{11,0,240,2,-3000,0,3000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有26%几率给目标施加盲目效果，命中率降低30%，持续3s\",\"condition\":\"[]\",\"power\":\"195000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,11}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{11,0,260,2,-3000,0,3000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有28%几率给目标施加盲目效果，命中率降低30%，持续3s\",\"condition\":\"[]\",\"power\":\"215000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,11}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{11,0,280,2,-3000,0,3000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(50210010,'锋芒','光武被动技能',30,2,0,0,0,0,0,1,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"光武攻击力提升50\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{502,1,50}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(50210020,'坚韧','光武被动技能',30,2,0,0,0,0,0,1,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"攻击时有5%的概率提高3%的攻击，持续5s\",\"condition\":\"[]\",\"power\":\"20000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,1}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{1,0,50,1,300,0,5000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(50210030,'破军','光武被动技能',30,2,0,0,0,0,0,1,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"光武命中提升1000点\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{502,5,1000}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(50210040,'铠甲','光武被动技能',30,2,0,0,0,0,0,1,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"攻击时有5%的概率恢复2%的生命\",\"condition\":\"[]\",\"power\":\"30000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{116,1,500,2,0,0.02,2,1000,1,1}]\"}]'),(51630001,'无敌5s','大乱斗传送无敌',0,3,0,0,0,0,1,1,0,1,0,1,'0','[]',0,0,0,500,'0','[]',0,0,'[{\"desc\":\"无敌3s\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"6000\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{106,3,10000,1,0,0,0,5000,1,1}]\"}]'),(52020001,'魂珠：致命一击','魂珠特殊技能',10,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"<color=#a77755>攻击时</color><color=#4eae1a>5%</color><color=#a77755>概率额外造成</color><color=#4eae1a>100%</color><color=#a77755>伤害</color>\",\"condition\":\"\",\"power\":\"10000\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,1,0,0,0,9}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"[5,5]\",\"attr\":\"[{9,0,50,1,10000,0,0,0,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"<color=#a77755>攻击时</color><color=#4eae1a>7.5%</color><color=#a77755>概率额外造成</color><color=#4eae1a>100%</color><color=#a77755>伤害</color>\",\"condition\":\"\",\"power\":\"10000\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,1,0,0,0,9}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"[5,5]\",\"attr\":\"[{9,0,75,1,10000,0,0,0,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"<color=#a77755>攻击时</color><color=#4eae1a>10%</color><color=#a77755>概率额外造成</color><color=#4eae1a>100%</color><color=#a77755>伤害</color>\",\"condition\":\"\",\"power\":\"10000\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,1,0,0,0,9}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"[5,5]\",\"attr\":\"[{9,0,100,1,10000,0,0,0,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"<color=#a77755>攻击时</color><color=#4eae1a>12.5%</color><color=#a77755>概率额外造成</color><color=#4eae1a>100%</color><color=#a77755>伤害</color>\",\"condition\":\"\",\"power\":\"10000\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,1,0,0,0,9}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"[5,5]\",\"attr\":\"[{9,0,125,1,10000,0,0,0,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"<color=#a77755>攻击时</color><color=#4eae1a>15%</color><color=#a77755>概率额外造成</color><color=#4eae1a>100%</color><color=#a77755>伤害</color>\",\"condition\":\"\",\"power\":\"10000\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,1,0,0,0,9}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"[5,5]\",\"attr\":\"[{9,0,150,1,10000,0,0,0,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(52020002,'魂珠：绝对闪避','魂珠特殊技能',10,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"<color=#a77755>受击时</color><color=#4eae1a>5%</color><color=#a77755>概率</color><color=#4eae1a>100%</color><color=#a77755>闪避这次伤害</color>\",\"condition\":\"\",\"power\":\"10000\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,1,0,0,0,12}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{12,0,50,1,10000,0,0,0,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"<color=#a77755>受击时</color><color=#4eae1a>7.5%</color><color=#a77755>概率</color><color=#4eae1a>100%</color><color=#a77755>闪避这次伤害</color>\",\"condition\":\"\",\"power\":\"10000\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,1,0,0,0,12}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{12,0,75,1,10000,0,0,0,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"<color=#a77755>受击时</color><color=#4eae1a>10%</color><color=#a77755>概率</color><color=#4eae1a>100%</color><color=#a77755>闪避这次伤害</color>\",\"condition\":\"\",\"power\":\"10000\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,1,0,0,0,12}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{12,0,100,1,10000,0,0,0,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"<color=#a77755>受击时</color><color=#4eae1a>12.5%</color><color=#a77755>概率</color><color=#4eae1a>100%</color><color=#a77755>闪避这次伤害</color>\",\"condition\":\"\",\"power\":\"10000\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,1,0,0,0,12}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{12,0,125,1,10000,0,0,0,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"<color=#a77755>受击时</color><color=#4eae1a>15%</color><color=#a77755>概率</color><color=#4eae1a>100%</color><color=#a77755>闪避这次伤害</color>\",\"condition\":\"\",\"power\":\"10000\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,1,0,0,0,12}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{12,0,150,1,10000,0,0,0,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(60100101,'金牛枪术','星灵主动技能',26,1,1,0,0,0,2,6,0,1,1000,2,'0','[{60100101,600,1},{60100102,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"对前方目标造成100%的伤害\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"\",\"distance\":\"450\",\"area\":\"200\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(60100102,'金牛座普攻-副','星灵主动技能',26,1,1,1,0,0,2,6,1,1,1000,2,'0','[{60100101,600,1},{60100102,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"对前方目标造成100%的伤害\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"\",\"distance\":\"450\",\"area\":\"200\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(60100201,'水瓶座普攻','星灵主动技能',26,1,1,0,0,0,2,6,0,1,1000,2,'0','[{60100201,600,1},{60100202,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"对前方目标造成100%的伤害\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"\",\"distance\":\"600\",\"area\":\"200\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(60100202,'水瓶座普攻-副','星灵主动技能',26,1,1,1,0,0,2,6,1,1,1000,2,'0','[{60100201,600,1},{60100202,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"对前方目标造成100%的伤害\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"\",\"distance\":\"600\",\"area\":\"200\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(60100301,'双鱼座普攻','星灵主动技能',26,1,1,0,0,0,2,6,0,1,1000,2,'0','[{60100301,600,1},{60100302,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"对前方目标造成100%的伤害\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"\",\"distance\":\"600\",\"area\":\"200\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(60100302,'双鱼座普攻-副','星灵主动技能',26,1,1,1,0,0,2,6,1,1,1000,2,'0','[{60100301,600,1},{60100302,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"对前方目标造成100%的伤害\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"\",\"distance\":\"600\",\"area\":\"200\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(60100401,'巨蟹伞击','星灵主动技能',26,1,1,0,0,0,2,6,0,1,1000,2,'0','[{60100401,600,1},{60100402,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"对前方目标造成100%的伤害\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"\",\"distance\":\"350\",\"area\":\"300\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(60100402,'巨蟹座普攻-副','星灵主动技能',26,1,1,1,0,0,2,6,1,1,1000,2,'0','[{60100401,600,1},{60100402,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"对前方目标造成100%的伤害\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"\",\"distance\":\"350\",\"area\":\"300\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(60100501,'射手箭术','星灵主动技能',26,1,1,0,0,0,2,6,0,1,1000,2,'0','[{60100501,600,1},{60100502,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"对前方目标造成100%的伤害\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"\",\"distance\":\"600\",\"area\":\"200\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(60100502,'射手座普攻-副','星灵主动技能',26,1,1,1,0,0,2,6,1,1,1000,2,'0','[{60100501,600,1},{60100502,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"对前方目标造成100%的伤害\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"\",\"distance\":\"600\",\"area\":\"200\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(60100601,'摩羯座普攻','星灵主动技能',26,1,1,0,0,0,2,6,0,1,1000,2,'0','[{60100601,600,1},{60100602,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"对前方目标造成100%的伤害\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"\",\"distance\":\"600\",\"area\":\"200\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(60100602,'摩羯座普攻-副','星灵主动技能',26,1,1,1,0,0,2,6,1,1,1000,2,'0','[{60100601,600,1},{60100602,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"对前方目标造成100%的伤害\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"\",\"distance\":\"600\",\"area\":\"200\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(60100701,'狮子刀舞','星灵主动技能',26,1,1,0,0,0,2,6,0,1,1000,2,'0','[{60100701,600,1},{60100702,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"对前方目标造成100%的伤害\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"\",\"distance\":\"300\",\"area\":\"300\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(60100702,'狮子座普攻-副','星灵主动技能',26,1,1,1,0,0,2,6,1,1,1000,2,'0','[{60100701,600,1},{60100702,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"对前方目标造成100%的伤害\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"\",\"distance\":\"300\",\"area\":\"300\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(60100801,'双子斩击','星灵主动技能',26,1,1,0,0,0,2,6,0,1,1000,2,'0','[{60100801,600,1},{60100802,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"对前方目标造成100%的伤害\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"\",\"distance\":\"350\",\"area\":\"300\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(60100802,'双子座普攻-副','星灵主动技能',26,1,1,1,0,0,2,6,1,1,1000,2,'0','[{60100801,600,1},{60100802,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"对前方目标造成100%的伤害\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"\",\"distance\":\"350\",\"area\":\"300\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(60100901,'处女飞箭','星灵主动技能',26,1,1,0,0,0,2,6,0,1,1000,2,'0','[{60100901,600,1},{60100902,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"对前方目标造成100%的伤害\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"\",\"distance\":\"600\",\"area\":\"200\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(60100902,'处女座普攻-副','星灵主动技能',26,1,1,1,0,0,2,6,1,1,1000,2,'0','[{60100901,600,1},{60100902,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"对前方目标造成100%的伤害\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"\",\"distance\":\"600\",\"area\":\"200\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(60101001,'天蝎座普攻','星灵主动技能',26,1,1,0,0,0,2,6,0,1,1000,2,'0','[{60101001,600,1},{60101002,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"对前方目标造成100%的伤害\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"\",\"distance\":\"600\",\"area\":\"200\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(60101002,'天蝎座普攻-副','星灵主动技能',26,1,1,1,0,0,2,6,1,1,1000,2,'0','[{60101001,600,1},{60101002,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"对前方目标造成100%的伤害\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"\",\"distance\":\"600\",\"area\":\"200\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(60101101,'白羊星锤','星灵主动技能',26,1,1,0,0,0,2,6,0,1,1000,2,'0','[{60101101,600,1},{60101102,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"对前方目标造成100%的伤害\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"\",\"distance\":\"350\",\"area\":\"300\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(60101102,'白羊座普攻-副','星灵主动技能',26,1,1,1,0,0,2,6,1,1,1000,2,'0','[{60101101,600,1},{60101102,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"对前方目标造成100%的伤害\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"\",\"distance\":\"350\",\"area\":\"300\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(60101201,'天秤座普攻','星灵主动技能',26,1,1,0,0,0,2,6,0,1,1000,2,'0','[{60101201,600,1},{60101202,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"对前方目标造成100%的伤害\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"\",\"distance\":\"600\",\"area\":\"200\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(60101202,'天秤座普攻-副','星灵主动技能',26,1,1,1,0,0,2,6,1,1,1000,2,'0','[{60101201,600,1},{60101202,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"对前方目标造成100%的伤害\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"\",\"distance\":\"600\",\"area\":\"200\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(60101301,'萌羊射线','星灵主动技能',26,1,1,0,0,0,2,6,0,1,1000,2,'0','[{60101301,600,1},{60101302,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"对前方目标造成100%的伤害\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"\",\"distance\":\"500\",\"area\":\"200\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(60101302,'新手萌羊座普攻-副','星灵主动技能',26,1,1,1,0,0,2,6,1,1,1000,2,'0','[{60101301,600,1},{60101302,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"对前方目标造成100%的伤害\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"\",\"distance\":\"500\",\"area\":\"200\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(60101401,'霸道斩','星灵主动技能',26,1,1,0,0,0,2,6,0,1,1000,2,'0','[{60101401,600,1},{60101402,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"对前方目标造成100%的伤害\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"\",\"distance\":\"350\",\"area\":\"300\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(60101402,'熊霸霸普攻-副','星灵主动技能',26,1,1,1,0,0,2,6,1,1,1000,2,'0','[{60101401,600,1},{60101402,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"对前方目标造成100%的伤害\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"\",\"distance\":\"350\",\"area\":\"200\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(60101501,'大师刀术','星灵主动技能',26,1,1,0,0,0,2,6,0,1,1000,2,'0','[{60101501,600,1},{60101502,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"对前方目标造成100%的伤害\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"\",\"distance\":\"300\",\"area\":\"200\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(60101502,'易拓大师普攻-副','星灵主动技能',26,1,1,1,0,0,2,6,1,1,1000,2,'0','[{60101501,600,1},{60101502,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"对前方目标造成100%的伤害\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"\",\"distance\":\"300\",\"area\":\"200\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(60101601,'电击疗法','星灵主动技能',26,1,1,0,0,0,2,6,0,1,1000,2,'0','[{60101601,600,1},{60101602,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"对前方目标造成100%的伤害\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"\",\"distance\":\"600\",\"area\":\"200\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(60101602,'代号09普攻-副','星灵主动技能',26,1,1,1,0,0,2,6,1,1,1000,2,'0','[{60101601,600,1},{60101602,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"对前方目标造成100%的伤害\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"\",\"distance\":\"600\",\"area\":\"200\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(60101701,'修罗拳法','星灵主动技能',26,1,1,0,0,0,2,6,0,1,1000,2,'0','[{60101701,600,1},{60101702,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"对前方目标造成100%的伤害\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"\",\"distance\":\"500\",\"area\":\"200\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(60101702,'修罗虎普攻-副','星灵主动技能',26,1,1,1,0,0,2,6,1,1,1000,2,'0','[{60101701,600,1},{60101702,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"对前方目标造成100%的伤害\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"\",\"distance\":\"500\",\"area\":\"200\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(60101801,'一刀流','星灵主动技能',26,1,1,0,0,0,2,6,0,1,1000,2,'0','[{60101801,600,1},{60101802,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"对前方目标造成100%的伤害\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"\",\"distance\":\"350\",\"area\":\"300\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(60101802,'暗影忍者普攻-副','星灵主动技能',26,1,1,1,0,0,2,6,1,1,1000,2,'0','[{60101801,600,1},{60101802,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"对前方目标造成100%的伤害\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"\",\"distance\":\"350\",\"area\":\"200\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(60101901,'次元射线','星灵主动技能',26,1,1,0,0,0,2,6,0,1,1000,2,'0','[{60101901,600,1},{60101902,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"对前方目标造成100%的伤害\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"\",\"distance\":\"600\",\"area\":\"200\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(60101902,'蛇夫座普攻-副','星灵主动技能',26,1,1,1,0,0,2,6,1,1,1000,2,'0','[{60101901,600,1},{60101902,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"对前方目标造成100%的伤害\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"800\",\"trigger\":\"\",\"distance\":\"600\",\"area\":\"200\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"[{117,2,100,2,0,0.03,0,0,1,1}]\"}]'),(60200101,'舞枪之术','星灵主动技能',26,1,0,0,0,0,2,2,0,1,1000,2,'0','[{60200101,600,1},{60200102,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"星灵对目标打出250%的技能伤害，并在后续3s的时间内，伤害提升40%，CD时间20s\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"20000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"300\",\"num\":\"[2,4]\",\"attr\":\"[{9,1,1000,1,4000,0,3000,1,0}]\",\"hurt\":\"25000\",\"effect\":\"\"}]'),(60200102,'金牛座主动技-副(群体)','星灵主动技能',26,1,0,1,0,0,2,2,1,1,1000,2,'0','[{60200101,600,1},{60200102,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"星灵对目标打出250%的技能伤害，并在后续3s的时间内，伤害提升40%，CD时间20s\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"20000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"300\",\"num\":\"[2,4]\",\"attr\":\"\",\"hurt\":\"25000\",\"effect\":\"\"}]'),(60200201,'水瓶座主动技(群体)','星灵主动技能',26,1,0,0,0,0,2,2,0,1,1000,2,'0','[{60200201,600,1},{60200202,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"星灵对目标打出150%的伤害，在持续2s的时间内，暴击率提升至100%，CD时间20s\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"20000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"200\",\"num\":\"[2,4]\",\"attr\":\"[{13,1,1000,1,0,0.99,2000,1,0}]\",\"hurt\":\"15000\",\"effect\":\"\"}]'),(60200202,'水瓶座主动技-副(群体)','星灵主动技能',26,1,0,1,0,0,2,2,1,1,1000,2,'0','[{60200201,600,1},{60200202,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"星灵对目标打出150%的伤害，在持续2s的时间内，暴击率提升至100%，CD时间20s\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"20000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"200\",\"num\":\"[2,4]\",\"attr\":\"\",\"hurt\":\"15000\",\"effect\":\"\"}]'),(60200301,'双鱼座主动技(群体)','星灵主动技能',26,1,0,0,0,0,2,2,0,1,1000,2,'0','[{60200301,600,1},{60200302,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"星灵对目标打出150%的技能伤害，并对目标施加持续3s掉血buff,每秒掉血2%，CD时间20s\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"20000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"200\",\"num\":\"[2,4]\",\"attr\":\"\",\"hurt\":\"15000\",\"effect\":\"\"}]'),(60200302,'双鱼座主动技-副(群体)','星灵主动技能',26,1,0,1,0,0,2,2,1,1,1000,2,'0','[{60200301,600,1},{60200302,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"星灵对目标打出150%的技能伤害，并对目标施加持续3s掉血buff,每秒掉血2%，CD时间20s\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"20000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"200\",\"num\":\"[2,4]\",\"attr\":\"\",\"hurt\":\"15000\",\"effect\":\"[{117,2,1000,2,0,0.02,2,3000,3,0}]\"}]'),(60200401,'爱的泡泡','星灵主动技能',26,3,0,0,0,0,2,0,0,1,0,0,'0','[]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"星灵给所有出战单位施加一个血量20%的护盾，持续4s，承受超出护盾的伤害或者超出时间，护盾均消失，CD时间30s\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"30000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{104,1,1000,2,0,0.15,2,4000,0,0}]\"}]'),(60200501,'射手座主动技','星灵主动技能',26,3,0,0,0,0,1,1,0,1,0,0,'0','[]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"星灵给自己施加一个伤害减免60%的buff，持续3s，CD时间20s\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"20000\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"0\",\"num\":\"\",\"attr\":\"[{10,1,1000,1,6000,0,3000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(60200601,'摩羯座主动技','星灵主动技能',26,3,0,0,0,0,1,1,0,1,0,0,'0','[]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"星灵给自己施加一个提升闪避率60%的buff，持续3s，CD时间20s\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"20000\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"0\",\"num\":\"\",\"attr\":\"[{12,1,1000,1,6000,0,3000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(60200701,'旋风斩击','星灵主动技能',26,1,0,0,0,0,1,2,0,1,0,0,'0','[{60200701,600,1},{60200702,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"星灵对目标造成120%伤害，并打出眩晕控制，持续2s，CD时间25s\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"25000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"200\",\"num\":\"[1,1]\",\"attr\":\"\",\"hurt\":\"12000\",\"effect\":\"\"}]'),(60200702,'狮子座主动技-副(单体)','星灵主动技能',26,1,0,1,0,0,1,2,1,1,0,0,'0','[{60200701,600,1},{60200702,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"星灵对目标造成120%伤害，并打出眩晕控制，持续2s，CD时间25s\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"25000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"200\",\"num\":\"[1,1]\",\"attr\":\"\",\"hurt\":\"12000\",\"effect\":\"[{101,3,1000,2,0,0,0,2000,0,1}]\"}]'),(60200801,'双刃斩击','星灵主动技能',26,1,0,0,0,0,1,2,0,1,0,0,'0','[{60200801,600,1},{60200802,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"星灵对目标打出100%伤害，并对目标沉默控制，持续4s，CD时间25s\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"25000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"200\",\"num\":\"[1,1]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(60200802,'双子座主动技-副(单体)','星灵主动技能',26,1,0,1,0,0,1,2,1,1,0,0,'0','[{60200801,600,1},{60200802,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"星灵对目标打出100%伤害，并对目标沉默控制，持续4s，CD时间25s\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"25000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"200\",\"num\":\"[1,1]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"[{102,3,1000,2,0,0,0,4000,0,1}]\"}]'),(60200901,'风驰之箭','星灵主动技能',26,1,0,0,0,0,1,2,0,1,0,0,'0','[{60200901,600,1},{60200902,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"星灵对目标造成140%的技能伤害，并禁锢目标，持续3s，CD时间25s\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"25000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"200\",\"num\":\"[1,1]\",\"attr\":\"\",\"hurt\":\"14000\",\"effect\":\"\"}]'),(60200902,'处女座主动技-副(单体)','星灵主动技能',26,1,0,1,0,0,1,2,1,1,0,0,'0','[{60200901,600,1},{60200902,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"星灵对目标造成140%的技能伤害，并禁锢目标，持续3s，CD时间25s\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"25000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"200\",\"num\":\"[1,1]\",\"attr\":\"\",\"hurt\":\"14000\",\"effect\":\"[{103,3,1000,2,0,0,0,3000,0,1}]\"}]'),(60201001,'天蝎座主动技','星灵主动技能',26,3,0,0,0,0,2,0,0,1,1000,2,'0','[]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"星灵对所有出战单位进行治疗，治疗效果为5%目标血量上限，CD时间30s\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"30000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,1,1000,2,0,0.05,2,1000,1,1}]\"}]'),(60201101,'白羊疗法','星灵主动技能',26,3,0,0,0,0,1,5,0,1,0,0,'0','[]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"选择血量百分比最低的单位进行治疗，恢复该单位18%的血量，CD时间30s\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"30000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,1,1000,2,0,0.15,2,1000,1,1}]\"}]'),(60201201,'天秤座主动技','星灵主动技能',26,3,0,0,0,0,1,5,0,1,0,0,'0','[]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"给血量百分比最低的单位施加回血buff，在接下来的6s内，(每秒回血3%)，CD时间30s\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"30000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,1,1000,2,0,0.03,2,6000,6,1}]\"}]'),(60201301,'动感光波','星灵主动技能',26,3,0,0,0,0,1,7,0,1,0,0,'0','[]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"星灵对主角回复血量，每次恢复生命值上限2%+1200点，CD时间8s\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"8000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,1,1000,2,1200,0.02,2,1000,1,1}]\"}]'),(60201401,'地裂斩','星灵主动技能',26,1,0,0,0,0,2,2,0,1,1000,2,'0','[{60201401,600,1},{60201402,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"对敌方造成120%的技能伤害，并给目标施加攻击削弱10%的debuff，持续3s，CD时间20s\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"20000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"300\",\"num\":\"[2,4]\",\"attr\":\"\",\"hurt\":\"12000\",\"effect\":\"\"}]'),(60201402,'熊霸霸主动技-副','星灵主动技能',26,1,0,1,0,0,2,2,1,1,1000,2,'0','[{60201401,600,1},{60201402,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"对敌方造成120%的技能伤害，并给目标施加攻击削弱10%的debuff，持续3s，CD时间20s\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"20000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"300\",\"num\":\"[2,4]\",\"attr\":\"[{1,0,1000,2,0,-0.1,3000,1,0}]\",\"hurt\":\"12000\",\"effect\":\"\"}]'),(60201501,'呕吐之毒','星灵主动技能',26,1,0,0,0,0,2,2,0,1,1000,2,'0','[{60201501,600,1},{60201502,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"对敌方造成120%的技能伤害，并给目标施加防御削弱10%的debuff，持续3s，CD时间20s\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"20000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"300\",\"num\":\"[2,4]\",\"attr\":\"\",\"hurt\":\"12000\",\"effect\":\"\"}]'),(60201502,'易拓大师主动技-副','星灵主动技能',26,1,0,1,0,0,2,2,1,1,1000,2,'0','[{60201501,600,1},{60201502,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"对敌方造成120%的技能伤害，并给目标施加防御削弱10%的debuff，持续3s，CD时间20s\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"20000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"300\",\"num\":\"[2,4]\",\"attr\":\"[{4,0,1000,2,0,-0.1,3000,1,0}]\",\"hurt\":\"12000\",\"effect\":\"\"}]'),(60201601,'电磁之网','星灵主动技能',26,1,0,0,0,0,2,2,0,1,1000,2,'0','[{60201601,600,1},{60201602,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"对敌方造成120%的技能伤害，并给目标施加20%的缓速效果，持续3s，CD时间20s\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"20000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"300\",\"num\":\"[2,4]\",\"attr\":\"\",\"hurt\":\"12000\",\"effect\":\"\"}]'),(60201602,'代号09主动技-副','星灵主动技能',26,1,0,1,0,0,2,2,1,1,1000,2,'0','[{60201601,600,1},{60201602,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"对敌方造成120%的技能伤害，并给目标施加20%的缓速效果，持续3s，CD时间20s\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"20000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"300\",\"num\":\"[2,4]\",\"attr\":\"[{18,0,2000,2,0,-0.1,3000,1,0}]\",\"hurt\":\"12000\",\"effect\":\"\"}]'),(60201701,'虎踞拳法','星灵主动技能',26,1,0,0,0,0,2,2,0,1,1000,2,'0','[{60201701,600,1},{60201702,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"对敌方造成120%的技能伤害，并在持续3s的时间内，暴击率提升20%，CD时间20s\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"20000\",\"trigger\":\"[]\",\"distance\":\"450\",\"area\":\"300\",\"num\":\"[2,4]\",\"attr\":\"\",\"hurt\":\"12000\",\"effect\":\"\"}]'),(60201702,'修罗虎主动技-副','星灵主动技能',26,1,0,1,0,0,2,2,1,1,1000,2,'0','[{60201701,600,1},{60201702,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"对敌方造成120%的技能伤害，并在持续3s的时间内，暴击率提升20%，CD时间20s\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"20000\",\"trigger\":\"[]\",\"distance\":\"450\",\"area\":\"300\",\"num\":\"[2,4]\",\"attr\":\"[{13,0,1000,1,2000,0,3000,1,0}]\",\"hurt\":\"12000\",\"effect\":\"\"}]'),(60201801,'燕十字斩','星灵主动技能',26,1,0,0,0,0,2,2,0,1,1000,2,'0','[{60201801,600,1},{60201802,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"星灵对目标打出130%的技能伤害，并在后续3s的时间内，伤害提升15%，CD时间20s\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"20000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"300\",\"num\":\"[2,4]\",\"attr\":\"\",\"hurt\":\"13000\",\"effect\":\"\"}]'),(60201802,'暗影忍者主动技-副','星灵主动技能',26,1,0,1,0,0,2,2,1,1,1000,2,'0','[{60201801,600,1},{60201802,0,1}]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"星灵对目标打出130%的技能伤害，并在后续3s的时间内，伤害提升15%，CD时间20s\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"20000\",\"trigger\":\"[]\",\"distance\":\"550\",\"area\":\"300\",\"num\":\"[2,4]\",\"attr\":\"[{9,0,1000,1,1500,0,3000,1,0}]\",\"hurt\":\"13000\",\"effect\":\"\"}]'),(60201901,'虚空次元盾','星灵主动技能',26,3,0,0,0,0,2,0,0,1,0,0,'0','[]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"发动空间力量，创造次元空间，吸收对己方单位造成的伤害以及负面效果，持续4s，CD时间35s\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"35000\",\"trigger\":\"[]\",\"distance\":\"2000\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{106,1,1000,2,0,0,0,4000,0,0}]\"}]'),(60300101,'CD重置','星灵羁绊技能',26,1,0,0,0,0,1,1,0,1,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"主角技能CD全部重置为0\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"75000\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{123,0,1000,1,40000,0,0,0,1,0}]\"}]'),(60300201,'CD减少','星灵羁绊技能',26,1,0,0,0,0,1,1,0,1,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"在15s内，主角的所有技能CD时间减少30%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"75000\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{123,0,1000,1,0,0.3,0,15000,0,0}]\"}]'),(60300301,'冰箱无敌','星灵羁绊技能',26,1,0,0,0,0,1,1,0,1,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"冰封主角3s，冰封期间无法攻击、无法移动也不会受到伤害，每秒恢复血量10%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"75000\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{101,0,1000,1,0,0,0,3000,0,0},{106,0,1000,1,0,0,0,3000,0,0},{116,0,1000,1,0,0.1,2,3000,3,0}]\"}]'),(60300401,'净化之光','星灵羁绊技能',26,1,0,0,0,0,1,1,0,1,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"净化主角，清除主角身上的所有debuff效果，并在持续6s的时间内，不受控制效果\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"75000\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{118,1,1000,1,0,0,0,1000,1,0},{108,1,1000,1,0,0,0,6000,0,0}]\"}]'),(60300501,'跳跃恢复','星灵羁绊技能',26,1,0,0,0,0,1,1,0,1,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"战斗中跳跃能量条立刻恢复满，同时在接下来的20s内，能量条恢复速度提升50%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"75000\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{124,0,1000,1,4,0,0,1000,1,0},{124,0,1000,1,0,0.5,0,20000,0,0}]\"}]'),(60300601,'怒气恢复','星灵羁绊技能',26,1,0,0,0,0,1,1,0,1,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"提供一半降神怒气值，并在20s内降神怒气恢复速度加快50%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"75000\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{125,0,1000,1,0,0.5,0,0,1,0},{125,0,1000,1,0,0.5,0,20000,0,0}]\"}]'),(60300701,'全面强化','星灵羁绊技能',26,1,0,0,0,0,1,1,0,1,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"全属性提升20%，持续5s\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"75000\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{126,0,1000,1,0,0.2,0,5000,0,0}]\"}]'),(60300801,'攻击提升','星灵羁绊技能',26,1,0,0,0,0,1,1,0,1,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"提升主角攻击10%，持续6s\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"75000\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"[{1,0,1000,1,0,0.1,6000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(60300901,'命中提升','星灵羁绊技能',26,1,0,0,0,0,1,1,0,1,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"提升主角命中7%，持续6s\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"75000\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"[{1,0,1000,1,0,0.07,6000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(60301001,'破甲提升','星灵羁绊技能',26,1,0,0,0,0,1,1,0,1,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"提升主角破甲7%，持续6s\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"75000\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"[{1,0,1000,1,0,0.07,6000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(60301101,'防御提升','星灵羁绊技能',26,1,0,0,0,0,1,1,0,1,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"提升主角防御7%，持续6s\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"75000\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"[{1,0,1000,1,0,0.07,6000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(60301201,'暴击提升','星灵羁绊技能',26,1,0,0,0,0,1,1,0,1,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"提升主角暴击10%，持续6s\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"75000\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"[{1,0,1000,1,0,0.1,6000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(60400101,'攻击之灵·星','星灵被动技能',26,2,0,0,0,0,0,1,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"星灵攻击提升150\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,1,150}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵攻击提升250\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,1,250}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵攻击提升350\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,1,350}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵攻击提升450\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,1,450}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵攻击提升550\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,1,550}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵攻击提升650\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,1,650}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵攻击提升750\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,1,750}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵攻击提升850\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,1,850}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵攻击提升950\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,1,950}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵攻击提升1050\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,1,1050}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵攻击提升1150\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,1,1150}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵攻击提升1250\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,1,1250}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵攻击提升1350\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,1,1350}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵攻击提升1450\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,1,1450}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵攻击提升1550\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,1,1550}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵攻击提升1650\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,1,1650}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵攻击提升1750\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,1,1750}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵攻击提升1850\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,1,1850}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵攻击提升1950\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,1,1950}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵攻击提升2050\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,1,2050}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(60400201,'破甲之灵·星','星灵被动技能',26,2,0,0,0,0,0,1,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"星灵破甲提升120\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,3,120}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵破甲提升200\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,3,200}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵破甲提升280\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,3,280}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵破甲提升360\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,3,360}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵破甲提升440\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,3,440}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵破甲提升520\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,3,520}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵破甲提升600\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,3,600}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵破甲提升680\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,3,680}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵破甲提升760\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,3,760}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵破甲提升840\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,3,840}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵破甲提升920\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,3,920}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵破甲提升1000\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,3,1000}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵破甲提升1080\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,3,1080}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵破甲提升1160\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,3,1160}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵破甲提升1240\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,3,1240}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵破甲提升1320\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,3,1320}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵破甲提升1400\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,3,1400}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵破甲提升1480\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,3,1480}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵破甲提升1560\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,3,1560}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵破甲提升1640\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,3,1640}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(60400301,'防御之灵·星','星灵被动技能',26,2,0,0,0,0,0,1,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"星灵防御提升120\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,4,120}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵防御提升200\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,4,200}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵防御提升280\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,4,280}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵防御提升360\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,4,360}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵防御提升440\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,4,440}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵防御提升520\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,4,520}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵防御提升600\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,4,600}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵防御提升680\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,4,680}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵防御提升760\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,4,760}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵防御提升840\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,4,840}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵防御提升920\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,4,920}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵防御提升1000\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,4,1000}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵防御提升1080\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,4,1080}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵防御提升1160\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,4,1160}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵防御提升1240\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,4,1240}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵防御提升1320\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,4,1320}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵防御提升1400\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,4,1400}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵防御提升1480\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,4,1480}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵防御提升1560\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,4,1560}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵防御提升1640\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,4,1640}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(60400401,'命中之灵·星','星灵被动技能',26,2,0,0,0,0,0,1,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"星灵命中提升60\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,5,60}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵命中提升100\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,5,100}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵命中提升140\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,5,140}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵命中提升180\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,5,180}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵命中提升220\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,5,220}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵命中提升260\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,5,260}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵命中提升300\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,5,300}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵命中提升340\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,5,340}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵命中提升380\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,5,380}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵命中提升420\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,5,420}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵命中提升460\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,5,460}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵命中提升500\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,5,500}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵命中提升540\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,5,540}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵命中提升580\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,5,580}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵命中提升620\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,5,620}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵命中提升660\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,5,660}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵命中提升700\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,5,700}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵命中提升740\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,5,740}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵命中提升780\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,5,780}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵命中提升820\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,5,820}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(60400501,'闪避之灵·星','星灵被动技能',26,2,0,0,0,0,0,1,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"星灵闪避提升60\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,6,60}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵闪避提升100\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,6,100}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵闪避提升140\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,6,140}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵闪避提升180\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,6,180}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵闪避提升220\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,6,220}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵闪避提升260\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,6,260}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵闪避提升300\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,6,300}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵闪避提升340\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,6,340}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵闪避提升380\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,6,380}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵闪避提升420\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,6,420}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵闪避提升460\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,6,460}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵闪避提升500\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,6,500}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵闪避提升540\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,6,540}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵闪避提升580\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,6,580}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵闪避提升620\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,6,620}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵闪避提升660\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,6,660}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵闪避提升700\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,6,700}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵闪避提升740\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,6,740}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵闪避提升780\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,6,780}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵闪避提升820\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,6,820}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(60400601,'暴击之灵·星','星灵被动技能',26,2,0,0,0,0,0,1,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"星灵暴击提升60\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,7,60}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵暴击提升100\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,7,100}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵暴击提升140\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,7,140}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵暴击提升180\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,7,180}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵暴击提升220\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,7,220}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵暴击提升260\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,7,260}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵暴击提升300\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,7,300}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵暴击提升340\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,7,340}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵暴击提升380\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,7,380}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵暴击提升420\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,7,420}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵暴击提升460\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,7,460}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵暴击提升500\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,7,500}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵暴击提升540\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,7,540}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵暴击提升580\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,7,580}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵暴击提升620\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,7,620}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵暴击提升660\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,7,660}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵暴击提升700\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,7,700}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵暴击提升740\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,7,740}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵暴击提升780\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,7,780}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵暴击提升820\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,7,820}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(60400701,'韧性之灵·星','星灵被动技能',26,2,0,0,0,0,0,1,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"星灵韧性提升60\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,8,60}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵韧性提升100\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,8,100}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵韧性提升140\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,8,140}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵韧性提升180\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,8,180}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵韧性提升220\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,8,220}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵韧性提升260\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,8,260}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵韧性提升300\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,8,300}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵韧性提升340\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,8,340}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵韧性提升380\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,8,380}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵韧性提升420\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,8,420}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵韧性提升460\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,8,460}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵韧性提升500\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,8,500}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵韧性提升540\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,8,540}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵韧性提升580\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,8,580}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵韧性提升620\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,8,620}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵韧性提升660\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,8,660}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵韧性提升700\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,8,700}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵韧性提升740\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,8,740}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵韧性提升780\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,8,780}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵韧性提升820\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,8,820}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(60400801,'攻击之心·星','星灵被动技能',26,2,0,0,0,0,0,1,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"星灵攻击提升2.5%+150\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,60,250},{430,1,150}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵攻击提升3.5%+250\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,60,350},{430,1,250}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵攻击提升4.5%+350\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,60,450},{430,1,350}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵攻击提升5.5%+450\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,60,550},{430,1,450}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵攻击提升6.5%+550\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,60,650},{430,1,550}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵攻击提升7.5%+650\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,60,750},{430,1,650}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵攻击提升8.5%+750\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,60,850},{430,1,750}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵攻击提升9.5%+850\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,60,950},{430,1,850}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵攻击提升10.5%+950\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,60,1050},{430,1,950}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵攻击提升11.5%+1050\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,60,1150},{430,1,1050}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵攻击提升12.5%+1150\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,60,1250},{430,1,1150}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵攻击提升13.5%+1250\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,60,1350},{430,1,1250}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵攻击提升14.5%+1350\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,60,1450},{430,1,1350}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵攻击提升15.5%+1450\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,60,1550},{430,1,1450}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵攻击提升16.5%+1550\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,60,1650},{430,1,1550}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵攻击提升17.5%+1650\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,60,1750},{430,1,1650}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵攻击提升18.5%+1750\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,60,1850},{430,1,1750}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵攻击提升19.5%+1850\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,60,1950},{430,1,1850}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵攻击提升20.5%+1950\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,60,2050},{430,1,1950}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵攻击提升21.5%+2050\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,60,2150},{430,1,2050}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵攻击提升22.5%+2150\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,60,2250},{430,1,2150}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵攻击提升23.5%+2250\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,60,2350},{430,1,2250}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵攻击提升24.5%+2350\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,60,2450},{430,1,2350}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵攻击提升25.5%+2450\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,60,2550},{430,1,2450}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵攻击提升26.5%+2550\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,60,2650},{430,1,2550}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(60400901,'破甲之心·星','星灵被动技能',26,2,0,0,0,0,0,1,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"星灵破甲提升2.5%+120\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,62,250},{430,3,120}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵破甲提升3.5%+200\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,62,350},{430,3,200}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵破甲提升4.5%+280\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,62,450},{430,3,280}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵破甲提升5.5%+360\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,62,550},{430,3,360}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵破甲提升6.5%+440\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,62,650},{430,3,440}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵破甲提升7.5%+520\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,62,750},{430,3,520}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵破甲提升8.5%+600\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,62,850},{430,3,600}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵破甲提升9.5%+680\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,62,950},{430,3,680}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵破甲提升10.5%+760\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,62,1050},{430,3,760}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵破甲提升11.5%+840\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,62,1150},{430,3,840}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵破甲提升12.5%+920\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,62,1250},{430,3,920}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵破甲提升13.5%+1000\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,62,1350},{430,3,1000}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵破甲提升14.5%+1080\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,62,1450},{430,3,1080}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵破甲提升15.5%+1160\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,62,1550},{430,3,1160}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵破甲提升16.5%+1240\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,62,1650},{430,3,1240}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵破甲提升17.5%+1320\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,62,1750},{430,3,1320}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵破甲提升18.5%+1400\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,62,1850},{430,3,1400}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵破甲提升19.5%+1480\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,62,1950},{430,3,1480}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵破甲提升20.5%+1560\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,62,2050},{430,3,1560}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵破甲提升21.5%+1640\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,62,2150},{430,3,1640}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵破甲提升22.5%+1720\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,62,2250},{430,3,1720}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵破甲提升23.5%+1800\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,62,2350},{430,3,1800}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵破甲提升24.5%+1880\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,62,2450},{430,3,1880}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵破甲提升25.5%+1960\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,62,2550},{430,3,1960}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵破甲提升26.5%+2040\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,62,2650},{430,3,2040}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(60401001,'防御之心·星','星灵被动技能',26,2,0,0,0,0,0,1,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"星灵防御提升2.5%+120\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,63,250},{430,4,120}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵防御提升3.5%+200\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,63,350},{430,4,200}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵防御提升4.5%+280\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,63,450},{430,4,280}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵防御提升5.5%+360\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,63,550},{430,4,360}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵防御提升6.5%+440\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,63,650},{430,4,440}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵防御提升7.5%+520\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,63,750},{430,4,520}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵防御提升8.5%+600\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,63,850},{430,4,600}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵防御提升9.5%+680\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,63,950},{430,4,680}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵防御提升10.5%+760\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,63,1050},{430,4,760}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵防御提升11.5%+840\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,63,1150},{430,4,840}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵防御提升12.5%+920\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,63,1250},{430,4,920}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵防御提升13.5%+1000\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,63,1350},{430,4,1000}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵防御提升14.5%+1080\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,63,1450},{430,4,1080}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵防御提升15.5%+1160\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,63,1550},{430,4,1160}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵防御提升16.5%+1240\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,63,1650},{430,4,1240}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵防御提升17.5%+1320\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,63,1750},{430,4,1320}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵防御提升18.5%+1400\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,63,1850},{430,4,1400}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵防御提升19.5%+1480\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,63,1950},{430,4,1480}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵防御提升20.5%+1560\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,63,2050},{430,4,1560}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵防御提升21.5%+1640\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,63,2150},{430,4,1640}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵防御提升22.5%+1720\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,63,2250},{430,4,1720}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵防御提升23.5%+1800\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,63,2350},{430,4,1800}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵防御提升24.5%+1880\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,63,2450},{430,4,1880}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵防御提升25.5%+1960\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,63,2550},{430,4,1960}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵防御提升26.5%+2040\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,63,2650},{430,4,2040}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(60401101,'命中之心·星','星灵被动技能',26,2,0,0,0,0,0,1,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"星灵命中提升2.5%+60\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,64,250},{430,5,60}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵命中提升3.5%+100\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,64,350},{430,5,100}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵命中提升4.5%+140\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,64,450},{430,5,140}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵命中提升5.5%+180\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,64,550},{430,5,180}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵命中提升6.5%+220\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,64,650},{430,5,220}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵命中提升7.5%+260\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,64,750},{430,5,260}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵命中提升8.5%+300\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,64,850},{430,5,300}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵命中提升9.5%+340\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,64,950},{430,5,340}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵命中提升10.5%+380\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,64,1050},{430,5,380}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵命中提升11.5%+420\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,64,1150},{430,5,420}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵命中提升12.5%+460\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,64,1250},{430,5,460}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵命中提升13.5%+500\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,64,1350},{430,5,500}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵命中提升14.5%+540\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,64,1450},{430,5,540}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵命中提升15.5%+580\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,64,1550},{430,5,580}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵命中提升16.5%+620\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,64,1650},{430,5,620}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵命中提升17.5%+660\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,64,1750},{430,5,660}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵命中提升18.5%+700\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,64,1850},{430,5,700}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵命中提升19.5%+740\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,64,1950},{430,5,740}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵命中提升20.5%+780\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,64,2050},{430,5,780}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵命中提升21.5%+820\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,64,2150},{430,5,820}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵命中提升22.5%+860\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,64,2250},{430,5,860}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵命中提升23.5%+900\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,64,2350},{430,5,900}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵命中提升24.5%+940\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,64,2450},{430,5,940}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵命中提升25.5%+980\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,64,2550},{430,5,980}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵命中提升26.5%+1020\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,64,2650},{430,5,1020}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(60401201,'闪避之心·星','星灵被动技能',26,2,0,0,0,0,0,1,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"星灵闪避提升2.5%+60\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,65,250},{430,6,60}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵闪避提升3.5%+100\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,65,350},{430,6,100}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵闪避提升4.5%+140\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,65,450},{430,6,140}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵闪避提升5.5%+180\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,65,550},{430,6,180}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵闪避提升6.5%+220\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,65,650},{430,6,220}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵闪避提升7.5%+260\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,65,750},{430,6,260}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵闪避提升8.5%+300\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,65,850},{430,6,300}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵闪避提升9.5%+340\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,65,950},{430,6,340}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵闪避提升10.5%+380\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,65,1050},{430,6,380}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵闪避提升11.5%+420\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,65,1150},{430,6,420}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵闪避提升12.5%+460\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,65,1250},{430,6,460}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵闪避提升13.5%+500\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,65,1350},{430,6,500}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵闪避提升14.5%+540\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,65,1450},{430,6,540}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵闪避提升15.5%+580\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,65,1550},{430,6,580}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵闪避提升16.5%+620\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,65,1650},{430,6,620}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵闪避提升17.5%+660\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,65,1750},{430,6,660}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵闪避提升18.5%+700\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,65,1850},{430,6,700}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵闪避提升19.5%+740\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,65,1950},{430,6,740}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵闪避提升20.5%+780\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,65,2050},{430,6,780}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵闪避提升21.5%+820\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,65,2150},{430,6,820}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵闪避提升22.5%+860\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,65,2250},{430,6,860}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵闪避提升23.5%+900\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,65,2350},{430,6,900}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵闪避提升24.5%+940\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,65,2450},{430,6,940}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵闪避提升25.5%+980\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,65,2550},{430,6,980}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵闪避提升26.5%+1020\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,65,2650},{430,6,1020}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(60401301,'暴击之心·星','星灵被动技能',26,2,0,0,0,0,0,1,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"星灵暴击提升2.5%+60\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,66,250},{430,7,60}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵暴击提升3.5%+100\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,66,350},{430,7,100}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵暴击提升4.5%+140\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,66,450},{430,7,140}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵暴击提升5.5%+180\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,66,550},{430,7,180}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵暴击提升6.5%+220\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,66,650},{430,7,220}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵暴击提升7.5%+260\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,66,750},{430,7,260}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵暴击提升8.5%+300\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,66,850},{430,7,300}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵暴击提升9.5%+340\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,66,950},{430,7,340}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵暴击提升10.5%+380\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,66,1050},{430,7,380}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵暴击提升11.5%+420\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,66,1150},{430,7,420}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵暴击提升12.5%+460\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,66,1250},{430,7,460}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵暴击提升13.5%+500\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,66,1350},{430,7,500}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵暴击提升14.5%+540\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,66,1450},{430,7,540}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵暴击提升15.5%+580\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,66,1550},{430,7,580}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵暴击提升16.5%+620\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,66,1650},{430,7,620}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵暴击提升17.5%+660\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,66,1750},{430,7,660}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵暴击提升18.5%+700\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,66,1850},{430,7,700}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵暴击提升19.5%+740\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,66,1950},{430,7,740}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵暴击提升20.5%+780\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,66,2050},{430,7,780}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵暴击提升21.5%+820\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,66,2150},{430,7,820}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵暴击提升22.5%+860\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,66,2250},{430,7,860}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵暴击提升23.5%+900\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,66,2350},{430,7,900}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵暴击提升24.5%+940\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,66,2450},{430,7,940}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵暴击提升25.5%+980\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,66,2550},{430,7,980}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵暴击提升26.5%+1020\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,66,2650},{430,7,1020}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(60401401,'韧性之心·星','星灵被动技能',26,2,0,0,0,0,0,1,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"星灵韧性提升2.5%+60\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,67,250},{430,8,60}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵韧性提升3.5%+100\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,67,350},{430,8,100}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵韧性提升4.5%+140\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,67,450},{430,8,140}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵韧性提升5.5%+180\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,67,550},{430,8,180}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵韧性提升6.5%+220\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,67,650},{430,8,220}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵韧性提升7.5%+260\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,67,750},{430,8,260}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵韧性提升8.5%+300\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,67,850},{430,8,300}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵韧性提升9.5%+340\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,67,950},{430,8,340}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵韧性提升10.5%+380\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,67,1050},{430,8,380}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵韧性提升11.5%+420\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,67,1150},{430,8,420}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵韧性提升12.5%+460\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,67,1250},{430,8,460}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵韧性提升13.5%+500\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,67,1350},{430,8,500}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵韧性提升14.5%+540\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,67,1450},{430,8,540}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵韧性提升15.5%+580\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,67,1550},{430,8,580}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵韧性提升16.5%+620\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,67,1650},{430,8,620}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵韧性提升17.5%+660\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,67,1750},{430,8,660}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵韧性提升18.5%+700\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,67,1850},{430,8,700}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵韧性提升19.5%+740\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,67,1950},{430,8,740}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵韧性提升20.5%+780\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,67,2050},{430,8,780}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵韧性提升21.5%+820\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,67,2150},{430,8,820}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵韧性提升22.5%+860\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,67,2250},{430,8,860}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵韧性提升23.5%+900\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,67,2350},{430,8,900}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵韧性提升24.5%+940\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,67,2450},{430,8,940}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵韧性提升25.5%+980\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,67,2550},{430,8,980}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵韧性提升26.5%+1020\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,67,2650},{430,8,1020}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(60401501,'治疗之心·星','星灵被动技能',26,3,0,0,0,0,1,1,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"星灵治疗效果+4%\",\"condition\":\"[]\",\"power\":\"11400\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{127,0,1000,1,0,0.04,0,10000,0,0}]\"},{\"desc\":\"星灵治疗效果+5.5%\",\"condition\":\"[]\",\"power\":\"17175\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{127,0,1000,1,0,0.055,0,10000,0,0}]\"},{\"desc\":\"星灵治疗效果+7%\",\"condition\":\"[]\",\"power\":\"22950\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{127,0,1000,1,0,0.07,0,10000,0,0}]\"},{\"desc\":\"星灵治疗效果+8.5%\",\"condition\":\"[]\",\"power\":\"28725\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{127,0,1000,1,0,0.085,0,10000,0,0}]\"},{\"desc\":\"星灵治疗效果+10%\",\"condition\":\"[]\",\"power\":\"34500\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{127,0,1000,1,0,0.1,0,10000,0,0}]\"},{\"desc\":\"星灵治疗效果+11.5%\",\"condition\":\"[]\",\"power\":\"40275\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{127,0,1000,1,0,0.115,0,10000,0,0}]\"},{\"desc\":\"星灵治疗效果+13%\",\"condition\":\"[]\",\"power\":\"46050\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{127,0,1000,1,0,0.13,0,10000,0,0}]\"},{\"desc\":\"星灵治疗效果+14.5%\",\"condition\":\"[]\",\"power\":\"51825\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{127,0,1000,1,0,0.145,0,10000,0,0}]\"},{\"desc\":\"星灵治疗效果+16%\",\"condition\":\"[]\",\"power\":\"57600\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{127,0,1000,1,0,0.16,0,10000,0,0}]\"},{\"desc\":\"星灵治疗效果+17.5%\",\"condition\":\"[]\",\"power\":\"63375\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{127,0,1000,1,0,0.175,0,10000,0,0}]\"},{\"desc\":\"星灵治疗效果+19%\",\"condition\":\"[]\",\"power\":\"69150\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{127,0,1000,1,0,0.19,0,10000,0,0}]\"},{\"desc\":\"星灵治疗效果+20.5%\",\"condition\":\"[]\",\"power\":\"74925\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{127,0,1000,1,0,0.205,0,10000,0,0}]\"},{\"desc\":\"星灵治疗效果+22%\",\"condition\":\"[]\",\"power\":\"80700\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{127,0,1000,1,0,0.22,0,10000,0,0}]\"},{\"desc\":\"星灵治疗效果+23.5%\",\"condition\":\"[]\",\"power\":\"86475\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{127,0,1000,1,0,0.235,0,10000,0,0}]\"},{\"desc\":\"星灵治疗效果+25%\",\"condition\":\"[]\",\"power\":\"92250\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{127,0,1000,1,0,0.25,0,10000,0,0}]\"},{\"desc\":\"星灵治疗效果+26.5%\",\"condition\":\"[]\",\"power\":\"98025\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{127,0,1000,1,0,0.265,0,10000,0,0}]\"},{\"desc\":\"星灵治疗效果+28%\",\"condition\":\"[]\",\"power\":\"103800\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{127,0,1000,1,0,0.28,0,10000,0,0}]\"},{\"desc\":\"星灵治疗效果+29.5%\",\"condition\":\"[]\",\"power\":\"109575\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{127,0,1000,1,0,0.295,0,10000,0,0}]\"},{\"desc\":\"星灵治疗效果+31%\",\"condition\":\"[]\",\"power\":\"115350\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{127,0,1000,1,0,0.31,0,10000,0,0}]\"},{\"desc\":\"星灵治疗效果+32.5%\",\"condition\":\"[]\",\"power\":\"121125\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{127,0,1000,1,0,0.325,0,10000,0,0}]\"},{\"desc\":\"星灵治疗效果+34%\",\"condition\":\"[]\",\"power\":\"126900\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{127,0,1000,1,0,0.34,0,10000,0,0}]\"},{\"desc\":\"星灵治疗效果+35.5%\",\"condition\":\"[]\",\"power\":\"132675\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{127,0,1000,1,0,0.355,0,10000,0,0}]\"},{\"desc\":\"星灵治疗效果+37%\",\"condition\":\"[]\",\"power\":\"138450\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{127,0,1000,1,0,0.37,0,10000,0,0}]\"},{\"desc\":\"星灵治疗效果+38.5%\",\"condition\":\"[]\",\"power\":\"144225\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{127,0,1000,1,0,0.385,0,10000,0,0}]\"},{\"desc\":\"星灵治疗效果+40%\",\"condition\":\"[]\",\"power\":\"150000\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{127,0,1000,1,0,0.4,0,10000,0,0}]\"}]'),(60401601,'自愈之心·星','星灵被动技能',26,3,0,0,0,0,1,1,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"星灵被治疗效果+4%\",\"condition\":\"[]\",\"power\":\"11400\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,1,0,0.04,0,10000,0,0}]\"},{\"desc\":\"星灵被治疗效果+5.5%\",\"condition\":\"[]\",\"power\":\"17175\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,1,0,0.055,0,10000,0,0}]\"},{\"desc\":\"星灵被治疗效果+7%\",\"condition\":\"[]\",\"power\":\"22950\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,1,0,0.07,0,10000,0,0}]\"},{\"desc\":\"星灵被治疗效果+8.5%\",\"condition\":\"[]\",\"power\":\"28725\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,1,0,0.085,0,10000,0,0}]\"},{\"desc\":\"星灵被治疗效果+10%\",\"condition\":\"[]\",\"power\":\"34500\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,1,0,0.1,0,10000,0,0}]\"},{\"desc\":\"星灵被治疗效果+11.5%\",\"condition\":\"[]\",\"power\":\"40275\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,1,0,0.115,0,10000,0,0}]\"},{\"desc\":\"星灵被治疗效果+13%\",\"condition\":\"[]\",\"power\":\"46050\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,1,0,0.13,0,10000,0,0}]\"},{\"desc\":\"星灵被治疗效果+14.5%\",\"condition\":\"[]\",\"power\":\"51825\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,1,0,0.145,0,10000,0,0}]\"},{\"desc\":\"星灵被治疗效果+16%\",\"condition\":\"[]\",\"power\":\"57600\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,1,0,0.16,0,10000,0,0}]\"},{\"desc\":\"星灵被治疗效果+17.5%\",\"condition\":\"[]\",\"power\":\"63375\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,1,0,0.175,0,10000,0,0}]\"},{\"desc\":\"星灵被治疗效果+19%\",\"condition\":\"[]\",\"power\":\"69150\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,1,0,0.19,0,10000,0,0}]\"},{\"desc\":\"星灵被治疗效果+20.5%\",\"condition\":\"[]\",\"power\":\"74925\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,1,0,0.205,0,10000,0,0}]\"},{\"desc\":\"星灵被治疗效果+22%\",\"condition\":\"[]\",\"power\":\"80700\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,1,0,0.22,0,10000,0,0}]\"},{\"desc\":\"星灵被治疗效果+23.5%\",\"condition\":\"[]\",\"power\":\"86475\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,1,0,0.235,0,10000,0,0}]\"},{\"desc\":\"星灵被治疗效果+25%\",\"condition\":\"[]\",\"power\":\"92250\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,1,0,0.25,0,10000,0,0}]\"},{\"desc\":\"星灵被治疗效果+26.5%\",\"condition\":\"[]\",\"power\":\"98025\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,1,0,0.265,0,10000,0,0}]\"},{\"desc\":\"星灵被治疗效果+28%\",\"condition\":\"[]\",\"power\":\"103800\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,1,0,0.28,0,10000,0,0}]\"},{\"desc\":\"星灵被治疗效果+29.5%\",\"condition\":\"[]\",\"power\":\"109575\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,1,0,0.295,0,10000,0,0}]\"},{\"desc\":\"星灵被治疗效果+31%\",\"condition\":\"[]\",\"power\":\"115350\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,1,0,0.31,0,10000,0,0}]\"},{\"desc\":\"星灵被治疗效果+32.5%\",\"condition\":\"[]\",\"power\":\"121125\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,1,0,0.325,0,10000,0,0}]\"},{\"desc\":\"星灵被治疗效果+34%\",\"condition\":\"[]\",\"power\":\"126900\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,1,0,0.34,0,10000,0,0}]\"},{\"desc\":\"星灵被治疗效果+35.5%\",\"condition\":\"[]\",\"power\":\"132675\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,1,0,0.355,0,10000,0,0}]\"},{\"desc\":\"星灵被治疗效果+37%\",\"condition\":\"[]\",\"power\":\"138450\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,1,0,0.37,0,10000,0,0}]\"},{\"desc\":\"星灵被治疗效果+38.5%\",\"condition\":\"[]\",\"power\":\"144225\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,1,0,0.385,0,10000,0,0}]\"},{\"desc\":\"星灵被治疗效果+40%\",\"condition\":\"[]\",\"power\":\"150000\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,1,0,0.4,0,10000,0,0}]\"}]'),(60401701,'攻击之魂·战','星灵被动技能',26,3,0,0,0,0,2,8,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"出战时，所有星灵攻击提升2.5%+180\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,180,0.025,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵攻击提升3.5%,+240\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,240,0.035,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵攻击提升4.5%,+300\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,300,0.045,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵攻击提升5.5%,+360\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,360,0.055,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵攻击提升6.5%,+420\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,420,0.065,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵攻击提升7.5%,+480\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,480,0.075,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵攻击提升8.5%,+540\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,540,0.085,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵攻击提升9.5%,+600\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,600,0.095,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵攻击提升10.5%,+660\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,660,0.105,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵攻击提升11.5%,+720\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,720,0.115,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵攻击提升12.5%,+780\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,780,0.125,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵攻击提升13.5%,+840\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,840,0.135,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵攻击提升14.5%,+900\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,900,0.145,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵攻击提升15.5%,+960\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,960,0.155,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵攻击提升16.5%,+1020\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,1020,0.165,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵攻击提升17.5%,+1080\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,1080,0.175,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵攻击提升18.5%,+1140\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,1140,0.185,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵攻击提升19.5%,+1200\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,1200,0.195,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵攻击提升20.5%,+1260\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,1260,0.205,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵攻击提升21.5%,+1320\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,1320,0.215,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵攻击提升22.5%,+1380\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,1380,0.225,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵攻击提升23.5%,+1440\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,1440,0.235,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵攻击提升24.5%,+1500\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,1500,0.245,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵攻击提升25.5%,+1560\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,1560,0.255,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵攻击提升26.5%,+1620\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,1620,0.265,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(60401801,'破甲之魂·战','星灵被动技能',26,3,0,0,0,0,2,8,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"出战时，所有星灵破甲提升2.5%,+144\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,144,0.025,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵破甲提升3.5%,+192\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,192,0.035,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵破甲提升4.5%,+240\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,240,0.045,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵破甲提升5.5%,+288\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,288,0.055,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵破甲提升6.5%,+336\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,336,0.065,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵破甲提升7.5%,+384\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,384,0.075,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵破甲提升8.5%,+432\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,432,0.085,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵破甲提升9.5%,+480\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,480,0.095,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵破甲提升10.5%,+528\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,528,0.105,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵破甲提升11.5%,+576\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,576,0.115,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵破甲提升12.5%,+624\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,624,0.125,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵破甲提升13.5%,+672\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,672,0.135,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵破甲提升14.5%,+720\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,720,0.145,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵破甲提升15.5%,+768\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,768,0.155,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵破甲提升16.5%,+816\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,816,0.165,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵破甲提升17.5%,+864\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,864,0.175,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵破甲提升18.5%,+912\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,912,0.185,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵破甲提升19.5%,+960\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,960,0.195,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵破甲提升20.5%,+1008\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,1008,0.205,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵破甲提升21.5%,+1056\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,1056,0.215,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵破甲提升22.5%,+1104\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,1104,0.225,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵破甲提升23.5%,+1152\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,1152,0.235,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵破甲提升24.5%,+1200\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,1200,0.245,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵破甲提升25.5%,+1248\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,1248,0.255,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵破甲提升26.5%,+1296\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,1296,0.265,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(60401901,'防御之魂·战','星灵被动技能',26,3,0,0,0,0,2,8,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"出战时，所有星灵防御提升2.5%,+144\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,144,0.025,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵防御提升3.5%,+192\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,192,0.035,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵防御提升4.5%,+240\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,240,0.045,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵防御提升5.5%,+288\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,288,0.055,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵防御提升6.5%,+336\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,336,0.065,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵防御提升7.5%,+384\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,384,0.075,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵防御提升8.5%,+432\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,432,0.085,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵防御提升9.5%,+480\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,480,0.095,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵防御提升10.5%,+528\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,528,0.105,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵防御提升11.5%,+576\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,576,0.115,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵防御提升12.5%,+624\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,624,0.125,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵防御提升13.5%,+672\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,672,0.135,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵防御提升14.5%,+720\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,720,0.145,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵防御提升15.5%,+768\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,768,0.155,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵防御提升16.5%,+816\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,816,0.165,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵防御提升17.5%,+864\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,864,0.175,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵防御提升18.5%,+912\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,912,0.185,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵防御提升19.5%,+960\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,960,0.195,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵防御提升20.5%,+1008\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,1008,0.205,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵防御提升21.5%,+1056\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,1056,0.215,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵防御提升22.5%,+1104\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,1104,0.225,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵防御提升23.5%,+1152\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,1152,0.235,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵防御提升24.5%,+1200\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,1200,0.245,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵防御提升25.5%,+1248\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,1248,0.255,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵防御提升26.5%,+1296\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,1296,0.265,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(60402001,'命中之魂·战','星灵被动技能',26,3,0,0,0,0,2,8,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"出战时，所有星灵命中提升2.5%,+72\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,72,0.025,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵命中提升3.5%,+96\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,96,0.035,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵命中提升4.5%,+120\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,120,0.045,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵命中提升5.5%,+144\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,144,0.055,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵命中提升6.5%,+168\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,168,0.065,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵命中提升7.5%,+192\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,192,0.075,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵命中提升8.5%,+216\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,216,0.085,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵命中提升9.5%,+240\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,240,0.095,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵命中提升10.5%,+264\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,264,0.105,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵命中提升11.5%,+288\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,288,0.115,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵命中提升12.5%,+312\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,312,0.125,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵命中提升13.5%,+336\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,336,0.135,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵命中提升14.5%,+360\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,360,0.145,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵命中提升15.5%,+384\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,384,0.155,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵命中提升16.5%,+408\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,408,0.165,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵命中提升17.5%,+432\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,432,0.175,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵命中提升18.5%,+456\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,456,0.185,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵命中提升19.5%,+480\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,480,0.195,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵命中提升20.5%,+504\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,504,0.205,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵命中提升21.5%,+528\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,528,0.215,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵命中提升22.5%,+552\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,552,0.225,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵命中提升23.5%,+576\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,576,0.235,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵命中提升24.5%,+600\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,600,0.245,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵命中提升25.5%,+624\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,624,0.255,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵命中提升26.5%,+648\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,648,0.265,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(60402101,'闪避之魂·战','星灵被动技能',26,3,0,0,0,0,2,8,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"出战时，所有星灵闪避提升2.5%,+72\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,72,0.025,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵闪避提升3.5%,+96\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,96,0.035,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵闪避提升4.5%,+120\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,120,0.045,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵闪避提升5.5%,+144\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,144,0.055,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵闪避提升6.5%,+168\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,168,0.065,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵闪避提升7.5%,+192\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,192,0.075,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵闪避提升8.5%,+216\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,216,0.085,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵闪避提升9.5%,+240\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,240,0.095,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵闪避提升10.5%,+264\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,264,0.105,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵闪避提升11.5%,+288\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,288,0.115,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵闪避提升12.5%,+312\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,312,0.125,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵闪避提升13.5%,+336\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,336,0.135,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵闪避提升14.5%,+360\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,360,0.145,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵闪避提升15.5%,+384\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,384,0.155,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵闪避提升16.5%,+408\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,408,0.165,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵闪避提升17.5%,+432\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,432,0.175,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵闪避提升18.5%,+456\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,456,0.185,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵闪避提升19.5%,+480\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,480,0.195,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵闪避提升20.5%,+504\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,504,0.205,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵闪避提升21.5%,+528\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,528,0.215,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵闪避提升22.5%,+552\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,552,0.225,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵闪避提升23.5%,+576\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,576,0.235,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵闪避提升24.5%,+600\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,600,0.245,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵闪避提升25.5%,+624\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,624,0.255,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵闪避提升26.5%,+648\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,648,0.265,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(60402201,'暴击之魂·战','星灵被动技能',26,3,0,0,0,0,2,8,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"出战时，所有星灵暴击提升2.5%,+72\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,72,0.025,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵暴击提升3.5%,+96\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,96,0.035,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵暴击提升4.5%,+120\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,120,0.045,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵暴击提升5.5%,+144\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,144,0.055,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵暴击提升6.5%,+168\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,168,0.065,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵暴击提升7.5%,+192\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,192,0.075,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵暴击提升8.5%,+216\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,216,0.085,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵暴击提升9.5%,+240\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,240,0.095,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵暴击提升10.5%,+264\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,264,0.105,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵暴击提升11.5%,+288\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,288,0.115,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵暴击提升12.5%,+312\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,312,0.125,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵暴击提升13.5%,+336\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,336,0.135,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵暴击提升14.5%,+360\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,360,0.145,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵暴击提升15.5%,+384\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,384,0.155,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵暴击提升16.5%,+408\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,408,0.165,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵暴击提升17.5%,+432\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,432,0.175,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵暴击提升18.5%,+456\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,456,0.185,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵暴击提升19.5%,+480\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,480,0.195,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵暴击提升20.5%,+504\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,504,0.205,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵暴击提升21.5%,+528\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,528,0.215,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵暴击提升22.5%,+552\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,552,0.225,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵暴击提升23.5%,+576\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,576,0.235,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵暴击提升24.5%,+600\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,600,0.245,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵暴击提升25.5%,+624\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,624,0.255,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵暴击提升26.5%,+648\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,648,0.265,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(60402301,'韧性之魂·战','星灵被动技能',26,3,0,0,0,0,2,8,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"出战时，所有星灵韧性提升2.5%,+72\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,72,0.025,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵韧性提升3.5%,+96\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,96,0.035,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵韧性提升4.5%,+120\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,120,0.045,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵韧性提升5.5%,+144\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,144,0.055,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵韧性提升6.5%,+168\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,168,0.065,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵韧性提升7.5%,+192\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,192,0.075,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵韧性提升8.5%,+216\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,216,0.085,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵韧性提升9.5%,+240\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,240,0.095,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵韧性提升10.5%,+264\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,264,0.105,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵韧性提升11.5%,+288\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,288,0.115,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵韧性提升12.5%,+312\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,312,0.125,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵韧性提升13.5%,+336\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,336,0.135,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵韧性提升14.5%,+360\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,360,0.145,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵韧性提升15.5%,+384\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,384,0.155,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵韧性提升16.5%,+408\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,408,0.165,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵韧性提升17.5%,+432\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,432,0.175,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵韧性提升18.5%,+456\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,456,0.185,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵韧性提升19.5%,+480\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,480,0.195,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵韧性提升20.5%,+504\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,504,0.205,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵韧性提升21.5%,+528\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,528,0.215,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵韧性提升22.5%,+552\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,552,0.225,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵韧性提升23.5%,+576\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,576,0.235,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵韧性提升24.5%,+600\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,600,0.245,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵韧性提升25.5%,+624\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,624,0.255,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，所有星灵韧性提升26.5%,+648\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,648,0.265,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(60402401,'攻击神魂·主','星灵被动技能',26,3,0,0,0,0,1,7,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"出战时，提升主角攻击2%+240\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,240,0.02,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角攻击2.6%+300\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,300,0.026,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角攻击3.2%+360\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,360,0.032,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角攻击3.8%+420\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,420,0.038,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角攻击4.4%+480\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,480,0.044,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角攻击5%+540\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,540,0.05,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角攻击5.6%+600\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,600,0.056,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角攻击6.2%+660\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,660,0.062,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角攻击6.8%+720\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,720,0.068,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角攻击7.4%+780\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,780,0.074,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角攻击8%+840\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,840,0.08,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角攻击8.6%+900\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,900,0.086,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角攻击9.2%+960\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,960,0.092,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角攻击9.8%+1020\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,1020,0.098,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角攻击10.4%+1080\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,1080,0.104,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角攻击11%+1140\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,1140,0.11,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角攻击11.6%+1200\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,1200,0.116,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角攻击12.2%+1260\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,1260,0.122,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角攻击12.8%+1320\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,1320,0.128,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角攻击13.4%+1380\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,1380,0.134,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角攻击14%+1440\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,1440,0.14,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角攻击14.6%+1500\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,1500,0.146,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角攻击15.2%+1560\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,1560,0.152,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角攻击15.8%+1620\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,1620,0.158,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角攻击16.4%+1680\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,1680,0.164,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角攻击17%+1740\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,1740,0.17,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角攻击17.6%+1800\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,1800,0.176,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角攻击18.2%+1860\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,1860,0.182,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角攻击18.8%+1920\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,1920,0.188,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角攻击19.4%+1980\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,2,1980,0.194,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(60402501,'破甲神魂·主','星灵被动技能',26,3,0,0,0,0,1,7,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"出战时，提升主角破甲2%+192\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,192,0.02,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角破甲2.6%+240\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,240,0.026,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角破甲3.2%+288\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,288,0.032,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角破甲3.8%+336\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,336,0.038,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角破甲4.4%+384\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,384,0.044,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角破甲5%+432\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,432,0.05,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角破甲5.6%+480\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,480,0.056,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角破甲6.2%+528\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,528,0.062,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角破甲6.8%+576\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,576,0.068,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角破甲7.4%+624\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,624,0.074,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角破甲8%+672\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,672,0.08,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角破甲8.6%+720\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,720,0.086,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角破甲9.2%+768\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,768,0.092,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角破甲9.8%+816\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,816,0.098,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角破甲10.4%+864\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,864,0.104,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角破甲11%+912\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,912,0.11,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角破甲11.6%+960\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,960,0.116,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角破甲12.2%+1008\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,1008,0.122,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角破甲12.8%+1056\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,1056,0.128,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角破甲13.4%+1104\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,1104,0.134,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角破甲14%+1152\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,1152,0.14,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角破甲14.6%+1200\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,1200,0.146,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角破甲15.2%+1248\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,1248,0.152,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角破甲15.8%+1296\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,1296,0.158,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角破甲16.4%+1344\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,1344,0.164,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角破甲17%+1392\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,1392,0.17,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角破甲17.6%+1440\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,1440,0.176,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角破甲18.2%+1488\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,1488,0.182,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角破甲18.8%+1536\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,1536,0.188,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角破甲19.4%+1584\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{3,0,1000,2,1584,0.194,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(60402601,'防御神魂·主','星灵被动技能',26,3,0,0,0,0,1,7,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"出战时，提升主角防御2%+192\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,192,0.02,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角防御2.6%+240\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,240,0.026,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角防御3.2%+288\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,288,0.032,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角防御3.8%+336\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,336,0.038,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角防御4.4%+384\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,384,0.044,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角防御5%+432\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,432,0.05,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角防御5.6%+480\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,480,0.056,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角防御6.2%+528\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,528,0.062,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角防御6.8%+576\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,576,0.068,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角防御7.4%+624\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,624,0.074,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角防御8%+672\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,672,0.08,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角防御8.6%+720\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,720,0.086,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角防御9.2%+768\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,768,0.092,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角防御9.8%+816\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,816,0.098,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角防御10.4%+864\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,864,0.104,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角防御11%+912\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,912,0.11,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角防御11.6%+960\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,960,0.116,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角防御12.2%+1008\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,1008,0.122,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角防御12.8%+1056\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,1056,0.128,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角防御13.4%+1104\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,1104,0.134,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角防御14%+1152\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,1152,0.14,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角防御14.6%+1200\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,1200,0.146,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角防御15.2%+1248\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,1248,0.152,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角防御15.8%+1296\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,1296,0.158,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角防御16.4%+1344\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,1344,0.164,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角防御17%+1392\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,1392,0.17,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角防御17.6%+1440\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,1440,0.176,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角防御18.2%+1488\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,1488,0.182,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角防御18.8%+1536\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,1536,0.188,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角防御19.4%+1584\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,1584,0.194,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(60402701,'命中神魂·主','星灵被动技能',26,3,0,0,0,0,1,7,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"出战时，提升主角命中2%+96\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,96,0.02,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角命中2.6%+120\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,120,0.026,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角命中3.2%+144\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,144,0.032,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角命中3.8%+168\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,168,0.038,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角命中4.4%+192\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,192,0.044,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角命中5%+216\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,216,0.05,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角命中5.6%+240\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,240,0.056,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角命中6.2%+264\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,264,0.062,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角命中6.8%+288\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,288,0.068,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角命中7.4%+312\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,312,0.074,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角命中8%+336\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,336,0.08,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角命中8.6%+360\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,360,0.086,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角命中9.2%+384\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,384,0.092,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角命中9.8%+408\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,408,0.098,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角命中10.4%+432\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,432,0.104,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角命中11%+456\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,456,0.11,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角命中11.6%+480\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,480,0.116,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角命中12.2%+504\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,504,0.122,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角命中12.8%+528\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,528,0.128,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角命中13.4%+552\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,552,0.134,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角命中14%+576\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,576,0.14,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角命中14.6%+600\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,600,0.146,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角命中15.2%+624\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,624,0.152,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角命中15.8%+648\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,648,0.158,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角命中16.4%+672\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,672,0.164,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角命中17%+696\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,696,0.17,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角命中17.6%+720\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,720,0.176,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角命中18.2%+744\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,744,0.182,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角命中18.8%+768\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,768,0.188,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角命中19.4%+792\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{5,0,1000,2,792,0.194,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(60402801,'闪避神魂·主','星灵被动技能',26,3,0,0,0,0,1,7,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"出战时，提升主角闪避2%+96\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,96,0.02,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角闪避2.6%+120\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,120,0.026,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角闪避3.2%+144\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,144,0.032,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角闪避3.8%+168\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,168,0.038,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角闪避4.4%+192\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,192,0.044,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角闪避5%+216\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,216,0.05,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角闪避5.6%+240\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,240,0.056,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角闪避6.2%+264\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,264,0.062,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角闪避6.8%+288\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,288,0.068,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角闪避7.4%+312\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,312,0.074,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角闪避8%+336\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,336,0.08,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角闪避8.6%+360\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,360,0.086,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角闪避9.2%+384\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,384,0.092,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角闪避9.8%+408\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,408,0.098,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角闪避10.4%+432\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,432,0.104,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角闪避11%+456\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,456,0.11,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角闪避11.6%+480\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,480,0.116,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角闪避12.2%+504\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,504,0.122,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角闪避12.8%+528\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,528,0.128,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角闪避13.4%+552\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,552,0.134,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角闪避14%+576\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,576,0.14,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角闪避14.6%+600\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,600,0.146,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角闪避15.2%+624\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,624,0.152,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角闪避15.8%+648\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,648,0.158,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角闪避16.4%+672\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,672,0.164,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角闪避17%+696\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,696,0.17,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角闪避17.6%+720\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,720,0.176,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角闪避18.2%+744\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,744,0.182,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角闪避18.8%+768\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,768,0.188,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角闪避19.4%+792\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{6,0,1000,2,792,0.194,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(60402901,'暴击神魂·主','星灵被动技能',26,3,0,0,0,0,1,7,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"出战时，提升主角暴击2%+96\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,96,0.02,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角暴击2.6%+120\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,120,0.026,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角暴击3.2%+144\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,144,0.032,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角暴击3.8%+168\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,168,0.038,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角暴击4.4%+192\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,192,0.044,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角暴击5%+216\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,216,0.05,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角暴击5.6%+240\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,240,0.056,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角暴击6.2%+264\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,264,0.062,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角暴击6.8%+288\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,288,0.068,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角暴击7.4%+312\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,312,0.074,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角暴击8%+336\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,336,0.08,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角暴击8.6%+360\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,360,0.086,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角暴击9.2%+384\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,384,0.092,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角暴击9.8%+408\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,408,0.098,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角暴击10.4%+432\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,432,0.104,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角暴击11%+456\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,456,0.11,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角暴击11.6%+480\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,480,0.116,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角暴击12.2%+504\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,504,0.122,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角暴击12.8%+528\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,528,0.128,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角暴击13.4%+552\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,552,0.134,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角暴击14%+576\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,576,0.14,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角暴击14.6%+600\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,600,0.146,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角暴击15.2%+624\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,624,0.152,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角暴击15.8%+648\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,648,0.158,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角暴击16.4%+672\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,672,0.164,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角暴击17%+696\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,696,0.17,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角暴击17.6%+720\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,720,0.176,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角暴击18.2%+744\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,744,0.182,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角暴击18.8%+768\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,768,0.188,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角暴击19.4%+792\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,2,792,0.194,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(60403001,'韧性神魂·主','星灵被动技能',26,3,0,0,0,0,1,7,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"出战时，提升主角韧性2%+96\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,96,0.02,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角韧性2.6%+120\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,120,0.026,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角韧性3.2%+144\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,144,0.032,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角韧性3.8%+168\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,168,0.038,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角韧性4.4%+192\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,192,0.044,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角韧性5%+216\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,216,0.05,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角韧性5.6%+240\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,240,0.056,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角韧性6.2%+264\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,264,0.062,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角韧性6.8%+288\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,288,0.068,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角韧性7.4%+312\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,312,0.074,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角韧性8%+336\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,336,0.08,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角韧性8.6%+360\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,360,0.086,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角韧性9.2%+384\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,384,0.092,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角韧性9.8%+408\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,408,0.098,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角韧性10.4%+432\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,432,0.104,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角韧性11%+456\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,456,0.11,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角韧性11.6%+480\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,480,0.116,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角韧性12.2%+504\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,504,0.122,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角韧性12.8%+528\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,528,0.128,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角韧性13.4%+552\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,552,0.134,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角韧性14%+576\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,576,0.14,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角韧性14.6%+600\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,600,0.146,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角韧性15.2%+624\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,624,0.152,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角韧性15.8%+648\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,648,0.158,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角韧性16.4%+672\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,672,0.164,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角韧性17%+696\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,696,0.17,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角韧性17.6%+720\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,720,0.176,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角韧性18.2%+744\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,744,0.182,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角韧性18.8%+768\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,768,0.188,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角韧性19.4%+792\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{8,0,1000,2,792,0.194,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(60403101,'技伤神魂·主','星灵被动技能',26,3,0,0,0,0,1,7,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"出战时，提升主角技能伤害2.8%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{27,0,1000,2,280,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害3.6%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{27,0,1000,2,360,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害4.4%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{27,0,1000,2,440,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害5.2%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{27,0,1000,2,520,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害6%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{27,0,1000,2,600,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害6.8%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{27,0,1000,2,680,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害7.6%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{27,0,1000,2,760,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害8.4%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{27,0,1000,2,840,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害9.2%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{27,0,1000,2,920,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害10%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{27,0,1000,2,1000,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害10.8%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{27,0,1000,2,1080,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害11.6%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{27,0,1000,2,1160,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害12.4%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{27,0,1000,2,1240,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害13.2%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{27,0,1000,2,1320,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害14%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{27,0,1000,2,1400,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害14.8%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{27,0,1000,2,1480,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害15.6%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{27,0,1000,2,1560,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害16.4%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{27,0,1000,2,1640,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害17.2%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{27,0,1000,2,1720,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害18%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{27,0,1000,2,1800,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害18.8%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{27,0,1000,2,1880,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害19.6%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{27,0,1000,2,1960,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害20.4%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{27,0,1000,2,2040,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害21.2%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{27,0,1000,2,2120,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害22%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{27,0,1000,2,2200,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害22.8%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{27,0,1000,2,2280,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害23.6%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{27,0,1000,2,2360,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害24.4%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{27,0,1000,2,2440,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害25.2%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{27,0,1000,2,2520,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害26%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{27,0,1000,2,2600,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(60403201,'技免神魂·主','星灵被动技能',26,3,0,0,0,0,1,7,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"出战时，提升主角技能伤害减免2.8%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,280,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害减免3.6%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,360,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害减免4.4%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,440,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害减免5.2%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,520,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害减免6%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,600,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害减免6.8%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,680,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害减免7.6%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,760,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害减免8.4%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,840,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害减免9.2%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,920,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害减免10%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,1000,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害减免10.8%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,1080,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害减免11.6%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,1160,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害减免12.4%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,1240,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害减免13.2%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,1320,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害减免14%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,1400,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害减免14.8%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,1480,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害减免15.6%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,1560,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害减免16.4%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,1640,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害减免17.2%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,1720,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害减免18%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,1800,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害减免18.8%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,1880,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害减免19.6%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,1960,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害减免20.4%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,2040,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害减免21.2%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,2120,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害减免22%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,2200,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害减免22.8%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,2280,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害减免23.6%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,2360,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害减免24.4%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,2440,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害减免25.2%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,2520,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角技能伤害减免26%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,2600,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(60403301,'伤害神魂·主','星灵被动技能',26,3,0,0,0,0,1,7,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"出战时，提升主角伤害加成2.4%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{9,0,1000,2,240,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害加成3.1%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{9,0,1000,2,310,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害加成3.8%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{9,0,1000,2,380,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害加成4.5%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{9,0,1000,2,450,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害加成5.2%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{9,0,1000,2,520,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害加成5.9%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{9,0,1000,2,590,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害加成6.6%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{9,0,1000,2,660,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害加成7.3%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{9,0,1000,2,730,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害加成8%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{9,0,1000,2,800,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害加成8.7%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{9,0,1000,2,870,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害加成9.4%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{9,0,1000,2,940,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害加成10.1%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{9,0,1000,2,1010,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害加成10.8%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{9,0,1000,2,1080,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害加成11.5%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{9,0,1000,2,1150,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害加成12.2%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{9,0,1000,2,1220,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害加成12.9%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{9,0,1000,2,1290,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害加成13.6%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{9,0,1000,2,1360,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害加成14.3%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{9,0,1000,2,1430,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害加成15%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{9,0,1000,2,1500,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害加成15.7%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{9,0,1000,2,1570,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害加成16.4%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{9,0,1000,2,1640,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害加成17.1%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{9,0,1000,2,1710,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害加成17.8%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{9,0,1000,2,1780,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害加成18.5%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{9,0,1000,2,1850,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害加成19.2%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{9,0,1000,2,1920,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害加成19.9%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{9,0,1000,2,1990,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害加成20.6%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{9,0,1000,2,2060,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害加成21.3%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{9,0,1000,2,2130,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害加成22%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{9,0,1000,2,2200,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害加成22.7%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{9,0,1000,2,2270,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(60403401,'减伤神魂·主','星灵被动技能',26,3,0,0,0,0,1,7,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"出战时，提升主角伤害减免2.4%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,240,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害减免3.1%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,310,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害减免3.8%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,380,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害减免4.5%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,450,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害减免5.2%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,520,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害减免5.9%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,590,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害减免6.6%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,660,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害减免7.3%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,730,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害减免8%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,800,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害减免8.7%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,870,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害减免9.4%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,940,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害减免10.1%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,1010,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害减免10.8%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,1080,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害减免11.5%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,1150,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害减免12.2%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,1220,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害减免12.9%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,1290,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害减免13.6%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,1360,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害减免14.3%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,1430,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害减免15%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,1500,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害减免15.7%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,1570,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害减免16.4%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,1640,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害减免17.1%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,1710,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害减免17.8%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,1780,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害减免18.5%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,1850,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害减免19.2%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,1920,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害减免19.9%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,1990,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害减免20.6%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,2060,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害减免21.3%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,2130,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害减免22%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,2200,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"出战时，提升主角伤害减免22.7%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,2270,0,10000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(60403501,'自愈神魂·主','星灵被动技能',26,3,0,0,0,0,1,7,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"出战时，提升主角被治疗效果3%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,2,0,0.03,0,10000,0,0}]\"},{\"desc\":\"出战时，提升主角被治疗效果4.5%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,2,0,0.045,0,10000,0,0}]\"},{\"desc\":\"出战时，提升主角被治疗效果6%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,2,0,0.06,0,10000,0,0}]\"},{\"desc\":\"出战时，提升主角被治疗效果7.5%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,2,0,0.075,0,10000,0,0}]\"},{\"desc\":\"出战时，提升主角被治疗效果9%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,2,0,0.09,0,10000,0,0}]\"},{\"desc\":\"出战时，提升主角被治疗效果10.5%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,2,0,0.105,0,10000,0,0}]\"},{\"desc\":\"出战时，提升主角被治疗效果12%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,2,0,0.12,0,10000,0,0}]\"},{\"desc\":\"出战时，提升主角被治疗效果13.5%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,2,0,0.135,0,10000,0,0}]\"},{\"desc\":\"出战时，提升主角被治疗效果15%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,2,0,0.15,0,10000,0,0}]\"},{\"desc\":\"出战时，提升主角被治疗效果16.5%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,2,0,0.165,0,10000,0,0}]\"},{\"desc\":\"出战时，提升主角被治疗效果18%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,2,0,0.18,0,10000,0,0}]\"},{\"desc\":\"出战时，提升主角被治疗效果19.5%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,2,0,0.195,0,10000,0,0}]\"},{\"desc\":\"出战时，提升主角被治疗效果21%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,2,0,0.21,0,10000,0,0}]\"},{\"desc\":\"出战时，提升主角被治疗效果22.5%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,2,0,0.225,0,10000,0,0}]\"},{\"desc\":\"出战时，提升主角被治疗效果24%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,2,0,0.24,0,10000,0,0}]\"},{\"desc\":\"出战时，提升主角被治疗效果25.5%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,2,0,0.255,0,10000,0,0}]\"},{\"desc\":\"出战时，提升主角被治疗效果27%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,2,0,0.27,0,10000,0,0}]\"},{\"desc\":\"出战时，提升主角被治疗效果28.5%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,2,0,0.285,0,10000,0,0}]\"},{\"desc\":\"出战时，提升主角被治疗效果30%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,2,0,0.3,0,10000,0,0}]\"},{\"desc\":\"出战时，提升主角被治疗效果31.5%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,2,0,0.315,0,10000,0,0}]\"},{\"desc\":\"出战时，提升主角被治疗效果33%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,2,0,0.33,0,10000,0,0}]\"},{\"desc\":\"出战时，提升主角被治疗效果34.5%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,2,0,0.345,0,10000,0,0}]\"},{\"desc\":\"出战时，提升主角被治疗效果36%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,2,0,0.36,0,10000,0,0}]\"},{\"desc\":\"出战时，提升主角被治疗效果37.5%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,2,0,0.375,0,10000,0,0}]\"},{\"desc\":\"出战时，提升主角被治疗效果39%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,2,0,0.39,0,10000,0,0}]\"},{\"desc\":\"出战时，提升主角被治疗效果40.5%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,2,0,0.405,0,10000,0,0}]\"},{\"desc\":\"出战时，提升主角被治疗效果42%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,2,0,0.42,0,10000,0,0}]\"},{\"desc\":\"出战时，提升主角被治疗效果43.5%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,2,0,0.435,0,10000,0,0}]\"},{\"desc\":\"出战时，提升主角被治疗效果45%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,2,0,0.45,0,10000,0,0}]\"},{\"desc\":\"出战时，提升主角被治疗效果46.5%\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"9000\",\"trigger\":\"\",\"distance\":\"2500\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{128,0,1000,2,0,0.465,0,10000,0,0}]\"}]'),(60403601,'护身之灵','星灵被动技能',26,2,0,0,0,0,1,1,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"身上有负面状态时，提升伤害减免4%\",\"condition\":\"[]\",\"power\":\"12160\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,1,400,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升伤害减免6%\",\"condition\":\"[]\",\"power\":\"18320\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,1,600,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升伤害减免8%\",\"condition\":\"[]\",\"power\":\"24480\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,1,800,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升伤害减免10%\",\"condition\":\"[]\",\"power\":\"30640\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,1,1000,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升伤害减免12%\",\"condition\":\"[]\",\"power\":\"36800\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,1,1200,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升伤害减免14%\",\"condition\":\"[]\",\"power\":\"42960\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,1,1400,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升伤害减免16%\",\"condition\":\"[]\",\"power\":\"49120\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,1,1600,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升伤害减免18%\",\"condition\":\"[]\",\"power\":\"55280\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,1,1800,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升伤害减免20%\",\"condition\":\"[]\",\"power\":\"61440\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,1,2000,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升伤害减免22%\",\"condition\":\"[]\",\"power\":\"67600\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,1,2200,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升伤害减免24%\",\"condition\":\"[]\",\"power\":\"73760\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,1,2400,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升伤害减免26%\",\"condition\":\"[]\",\"power\":\"79920\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,1,2600,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升伤害减免28%\",\"condition\":\"[]\",\"power\":\"86080\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,1,2800,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升伤害减免30%\",\"condition\":\"[]\",\"power\":\"92240\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,1,3000,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升伤害减免32%\",\"condition\":\"[]\",\"power\":\"98400\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,1,3200,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升伤害减免34%\",\"condition\":\"[]\",\"power\":\"104560\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,1,3400,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升伤害减免36%\",\"condition\":\"[]\",\"power\":\"110720\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,1,3600,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升伤害减免38%\",\"condition\":\"[]\",\"power\":\"116880\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,1,3800,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升伤害减免40%\",\"condition\":\"[]\",\"power\":\"123040\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,1,4000,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升伤害减免42%\",\"condition\":\"[]\",\"power\":\"129200\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,1,4200,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升伤害减免44%\",\"condition\":\"[]\",\"power\":\"135360\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,1,4400,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升伤害减免46%\",\"condition\":\"[]\",\"power\":\"141520\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,1,4600,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升伤害减免48%\",\"condition\":\"[]\",\"power\":\"147680\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,1,4800,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升伤害减免50%\",\"condition\":\"[]\",\"power\":\"153840\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,1,5000,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升伤害减免52%\",\"condition\":\"[]\",\"power\":\"160000\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,1,5200,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(60403701,'大地之护','星灵被动技能',26,2,0,0,0,0,1,1,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"身上有负面状态时，提升防御值4%\",\"condition\":\"[]\",\"power\":\"12160\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,1,0,0.04,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升防御值6%\",\"condition\":\"[]\",\"power\":\"18320\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,1,0,0.06,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升防御值8%\",\"condition\":\"[]\",\"power\":\"24480\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,1,0,0.08,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升防御值10%\",\"condition\":\"[]\",\"power\":\"30640\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,1,0,0.1,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升防御值12%\",\"condition\":\"[]\",\"power\":\"36800\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,1,0,0.12,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升防御值14%\",\"condition\":\"[]\",\"power\":\"42960\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,1,0,0.14,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升防御值16%\",\"condition\":\"[]\",\"power\":\"49120\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,1,0,0.16,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升防御值18%\",\"condition\":\"[]\",\"power\":\"55280\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,1,0,0.18,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升防御值20%\",\"condition\":\"[]\",\"power\":\"61440\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,1,0,0.2,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升防御值22%\",\"condition\":\"[]\",\"power\":\"67600\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,1,0,0.22,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升防御值24%\",\"condition\":\"[]\",\"power\":\"73760\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,1,0,0.24,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升防御值26%\",\"condition\":\"[]\",\"power\":\"79920\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,1,0,0.26,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升防御值28%\",\"condition\":\"[]\",\"power\":\"86080\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,1,0,0.28,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升防御值30%\",\"condition\":\"[]\",\"power\":\"92240\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,1,0,0.3,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升防御值32%\",\"condition\":\"[]\",\"power\":\"98400\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,1,0,0.32,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升防御值34%\",\"condition\":\"[]\",\"power\":\"104560\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,1,0,0.34,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升防御值36%\",\"condition\":\"[]\",\"power\":\"110720\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,1,0,0.36,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升防御值38%\",\"condition\":\"[]\",\"power\":\"116880\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,1,0,0.38,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升防御值40%\",\"condition\":\"[]\",\"power\":\"123040\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,1,0,0.4,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升防御值42%\",\"condition\":\"[]\",\"power\":\"129200\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,1,0,0.42,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升防御值44%\",\"condition\":\"[]\",\"power\":\"135360\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,1,0,0.44,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升防御值46%\",\"condition\":\"[]\",\"power\":\"141520\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,1,0,0.46,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升防御值48%\",\"condition\":\"[]\",\"power\":\"147680\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,1,0,0.48,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升防御值50%\",\"condition\":\"[]\",\"power\":\"153840\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,1,0,0.5,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升防御值52%\",\"condition\":\"[]\",\"power\":\"160000\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,1,0,0.52,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(60403801,'岩石之甲','星灵被动技能',26,2,0,0,0,0,1,1,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"身上有负面状态时，提升技能伤害减免4%\",\"condition\":\"[]\",\"power\":\"12160\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,1,400,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升技能伤害减免6%\",\"condition\":\"[]\",\"power\":\"18320\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,1,600,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升技能伤害减免8%\",\"condition\":\"[]\",\"power\":\"24480\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,1,800,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升技能伤害减免10%\",\"condition\":\"[]\",\"power\":\"30640\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,1,1000,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升技能伤害减免12%\",\"condition\":\"[]\",\"power\":\"36800\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,1,1200,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升技能伤害减免14%\",\"condition\":\"[]\",\"power\":\"42960\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,1,1400,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升技能伤害减免16%\",\"condition\":\"[]\",\"power\":\"49120\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,1,1600,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升技能伤害减免18%\",\"condition\":\"[]\",\"power\":\"55280\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,1,1800,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升技能伤害减免20%\",\"condition\":\"[]\",\"power\":\"61440\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,1,2000,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升技能伤害减免22%\",\"condition\":\"[]\",\"power\":\"67600\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,1,2200,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升技能伤害减免24%\",\"condition\":\"[]\",\"power\":\"73760\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,1,2400,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升技能伤害减免26%\",\"condition\":\"[]\",\"power\":\"79920\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,1,2600,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升技能伤害减免28%\",\"condition\":\"[]\",\"power\":\"86080\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,1,2800,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升技能伤害减免30%\",\"condition\":\"[]\",\"power\":\"92240\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,1,3000,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升技能伤害减免32%\",\"condition\":\"[]\",\"power\":\"98400\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,1,3200,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升技能伤害减免34%\",\"condition\":\"[]\",\"power\":\"104560\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,1,3400,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升技能伤害减免36%\",\"condition\":\"[]\",\"power\":\"110720\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,1,3600,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升技能伤害减免38%\",\"condition\":\"[]\",\"power\":\"116880\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,1,3800,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升技能伤害减免40%\",\"condition\":\"[]\",\"power\":\"123040\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,1,4000,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升技能伤害减免42%\",\"condition\":\"[]\",\"power\":\"129200\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,1,4200,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升技能伤害减免44%\",\"condition\":\"[]\",\"power\":\"135360\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,1,4400,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升技能伤害减免46%\",\"condition\":\"[]\",\"power\":\"141520\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,1,4600,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升技能伤害减免48%\",\"condition\":\"[]\",\"power\":\"147680\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,1,4800,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升技能伤害减免50%\",\"condition\":\"[]\",\"power\":\"153840\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,1,5000,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，提升技能伤害减免52%\",\"condition\":\"[]\",\"power\":\"160000\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,1,5200,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(60403901,'森林之心','星灵被动技能',26,2,0,0,0,0,1,1,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"身上有负面状态时，受治疗效果提升5%\",\"condition\":\"[]\",\"power\":\"12160\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],128}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{128,0,1000,1,0,0.05,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，受治疗效果提升7.5%\",\"condition\":\"[]\",\"power\":\"18320\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],128}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{128,0,1000,1,0,0.075,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，受治疗效果提升10%\",\"condition\":\"[]\",\"power\":\"24480\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],128}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{128,0,1000,1,0,0.1,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，受治疗效果提升12.5%\",\"condition\":\"[]\",\"power\":\"30640\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],128}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{128,0,1000,1,0,0.125,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，受治疗效果提升15%\",\"condition\":\"[]\",\"power\":\"36800\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],128}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{128,0,1000,1,0,0.15,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，受治疗效果提升17.5%\",\"condition\":\"[]\",\"power\":\"42960\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],128}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{128,0,1000,1,0,0.175,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，受治疗效果提升20%\",\"condition\":\"[]\",\"power\":\"49120\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],128}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{128,0,1000,1,0,0.2,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，受治疗效果提升22.5%\",\"condition\":\"[]\",\"power\":\"55280\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],128}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{128,0,1000,1,0,0.225,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，受治疗效果提升25%\",\"condition\":\"[]\",\"power\":\"61440\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],128}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{128,0,1000,1,0,0.25,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，受治疗效果提升27.5%\",\"condition\":\"[]\",\"power\":\"67600\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],128}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{128,0,1000,1,0,0.275,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，受治疗效果提升30%\",\"condition\":\"[]\",\"power\":\"73760\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],128}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{128,0,1000,1,0,0.3,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，受治疗效果提升32.5%\",\"condition\":\"[]\",\"power\":\"79920\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],128}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{128,0,1000,1,0,0.325,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，受治疗效果提升35%\",\"condition\":\"[]\",\"power\":\"86080\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],128}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{128,0,1000,1,0,0.35,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，受治疗效果提升37.5%\",\"condition\":\"[]\",\"power\":\"92240\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],128}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{128,0,1000,1,0,0.375,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，受治疗效果提升40%\",\"condition\":\"[]\",\"power\":\"98400\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],128}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{128,0,1000,1,0,0.4,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，受治疗效果提升42.5%\",\"condition\":\"[]\",\"power\":\"104560\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],128}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{128,0,1000,1,0,0.425,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，受治疗效果提升45%\",\"condition\":\"[]\",\"power\":\"110720\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],128}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{128,0,1000,1,0,0.45,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，受治疗效果提升47.5%\",\"condition\":\"[]\",\"power\":\"116880\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],128}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{128,0,1000,1,0,0.475,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，受治疗效果提升50%\",\"condition\":\"[]\",\"power\":\"123040\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],128}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{128,0,1000,1,0,0.5,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，受治疗效果提升52.5%\",\"condition\":\"[]\",\"power\":\"129200\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],128}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{128,0,1000,1,0,0.525,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，受治疗效果提升55%\",\"condition\":\"[]\",\"power\":\"135360\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],128}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{128,0,1000,1,0,0.55,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，受治疗效果提升57.5%\",\"condition\":\"[]\",\"power\":\"141520\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],128}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{128,0,1000,1,0,0.575,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，受治疗效果提升60%\",\"condition\":\"[]\",\"power\":\"147680\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],128}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{128,0,1000,1,0,0.6,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，受治疗效果提升62.5%\",\"condition\":\"[]\",\"power\":\"153840\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],128}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{128,0,1000,1,0,0.625,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"身上有负面状态时，受治疗效果提升65%\",\"condition\":\"[]\",\"power\":\"160000\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{8,1000,0,0,0,0,[101,102,103],128}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{128,0,1000,1,0,0.65,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(60404001,'寒灵之触','星灵被动技能',26,2,0,0,0,0,1,1,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"攻击眩晕目标时，伤害提升4%\",\"condition\":\"[]\",\"power\":\"12160\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,101,10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,-400,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击眩晕目标时，伤害提升6%\",\"condition\":\"[]\",\"power\":\"18320\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,101,10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,-600,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击眩晕目标时，伤害提升8%\",\"condition\":\"[]\",\"power\":\"24480\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,101,10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,-800,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击眩晕目标时，伤害提升10%\",\"condition\":\"[]\",\"power\":\"30640\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,101,10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,-1000,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击眩晕目标时，伤害提升12%\",\"condition\":\"[]\",\"power\":\"36800\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,101,10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,-1200,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击眩晕目标时，伤害提升14%\",\"condition\":\"[]\",\"power\":\"42960\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,101,10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,-1400,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击眩晕目标时，伤害提升16%\",\"condition\":\"[]\",\"power\":\"49120\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,101,10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,-1600,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击眩晕目标时，伤害提升18%\",\"condition\":\"[]\",\"power\":\"55280\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,101,10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,-1800,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击眩晕目标时，伤害提升20%\",\"condition\":\"[]\",\"power\":\"61440\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,101,10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,-2000,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击眩晕目标时，伤害提升22%\",\"condition\":\"[]\",\"power\":\"67600\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,101,10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,-2200,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击眩晕目标时，伤害提升24%\",\"condition\":\"[]\",\"power\":\"73760\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,101,10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,-2400,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击眩晕目标时，伤害提升26%\",\"condition\":\"[]\",\"power\":\"79920\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,101,10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,-2600,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击眩晕目标时，伤害提升28%\",\"condition\":\"[]\",\"power\":\"86080\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,101,10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,-2800,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击眩晕目标时，伤害提升30%\",\"condition\":\"[]\",\"power\":\"92240\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,101,10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,-3000,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击眩晕目标时，伤害提升32%\",\"condition\":\"[]\",\"power\":\"98400\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,101,10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,-3200,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击眩晕目标时，伤害提升34%\",\"condition\":\"[]\",\"power\":\"104560\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,101,10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,-3400,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击眩晕目标时，伤害提升36%\",\"condition\":\"[]\",\"power\":\"110720\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,101,10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,-3600,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击眩晕目标时，伤害提升38%\",\"condition\":\"[]\",\"power\":\"116880\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,101,10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,-3800,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击眩晕目标时，伤害提升40%\",\"condition\":\"[]\",\"power\":\"123040\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,101,10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,-4000,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击眩晕目标时，伤害提升42%\",\"condition\":\"[]\",\"power\":\"129200\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,101,10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,-4200,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击眩晕目标时，伤害提升44%\",\"condition\":\"[]\",\"power\":\"135360\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,101,10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,-4400,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击眩晕目标时，伤害提升46%\",\"condition\":\"[]\",\"power\":\"141520\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,101,10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,-4600,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击眩晕目标时，伤害提升48%\",\"condition\":\"[]\",\"power\":\"147680\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,101,10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,-4800,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击眩晕目标时，伤害提升50%\",\"condition\":\"[]\",\"power\":\"153840\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,101,10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,-5000,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击眩晕目标时，伤害提升52%\",\"condition\":\"[]\",\"power\":\"160000\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,101,10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,1000,2,-5200,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(60404101,'奥术之光','星灵被动技能',26,2,0,0,0,0,1,1,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"攻击沉默目标时，技能伤害提升4%\",\"condition\":\"[]\",\"power\":\"12160\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,102,28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,-400,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击沉默目标时，技能伤害提升6%\",\"condition\":\"[]\",\"power\":\"18320\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,102,28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,-600,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击沉默目标时，技能伤害提升8%\",\"condition\":\"[]\",\"power\":\"24480\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,102,28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,-800,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击沉默目标时，技能伤害提升10%\",\"condition\":\"[]\",\"power\":\"30640\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,102,28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,-1000,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击沉默目标时，技能伤害提升12%\",\"condition\":\"[]\",\"power\":\"36800\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,102,28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,-1200,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击沉默目标时，技能伤害提升14%\",\"condition\":\"[]\",\"power\":\"42960\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,102,28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,-1400,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击沉默目标时，技能伤害提升16%\",\"condition\":\"[]\",\"power\":\"49120\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,102,28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,-1600,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击沉默目标时，技能伤害提升18%\",\"condition\":\"[]\",\"power\":\"55280\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,102,28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,-1800,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击沉默目标时，技能伤害提升20%\",\"condition\":\"[]\",\"power\":\"61440\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,102,28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,-2000,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击沉默目标时，技能伤害提升22%\",\"condition\":\"[]\",\"power\":\"67600\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,102,28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,-2200,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击沉默目标时，技能伤害提升24%\",\"condition\":\"[]\",\"power\":\"73760\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,102,28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,-2400,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击沉默目标时，技能伤害提升26%\",\"condition\":\"[]\",\"power\":\"79920\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,102,28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,-2600,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击沉默目标时，技能伤害提升28%\",\"condition\":\"[]\",\"power\":\"86080\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,102,28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,-2800,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击沉默目标时，技能伤害提升30%\",\"condition\":\"[]\",\"power\":\"92240\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,102,28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,-3000,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击沉默目标时，技能伤害提升32%\",\"condition\":\"[]\",\"power\":\"98400\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,102,28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,-3200,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击沉默目标时，技能伤害提升34%\",\"condition\":\"[]\",\"power\":\"104560\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,102,28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,-3400,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击沉默目标时，技能伤害提升36%\",\"condition\":\"[]\",\"power\":\"110720\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,102,28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,-3600,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击沉默目标时，技能伤害提升38%\",\"condition\":\"[]\",\"power\":\"116880\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,102,28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,-3800,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击沉默目标时，技能伤害提升40%\",\"condition\":\"[]\",\"power\":\"123040\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,102,28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,-4000,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击沉默目标时，技能伤害提升42%\",\"condition\":\"[]\",\"power\":\"129200\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,102,28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,-4200,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击沉默目标时，技能伤害提升44%\",\"condition\":\"[]\",\"power\":\"135360\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,102,28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,-4400,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击沉默目标时，技能伤害提升46%\",\"condition\":\"[]\",\"power\":\"141520\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,102,28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,-4600,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击沉默目标时，技能伤害提升48%\",\"condition\":\"[]\",\"power\":\"147680\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,102,28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,-4800,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击沉默目标时，技能伤害提升50%\",\"condition\":\"[]\",\"power\":\"153840\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,102,28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,-5000,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击沉默目标时，技能伤害提升52%\",\"condition\":\"[]\",\"power\":\"160000\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,102,28}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{28,0,1000,2,-5200,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(60404201,'专注之眼','星灵被动技能',26,2,0,0,0,0,1,1,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"攻击禁锢目标时，破甲提升4%\",\"condition\":\"[]\",\"power\":\"12160\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,103,4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,0,-0.04,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击禁锢目标时，破甲提升6%\",\"condition\":\"[]\",\"power\":\"18320\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,103,4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,0,-0.06,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击禁锢目标时，破甲提升8%\",\"condition\":\"[]\",\"power\":\"24480\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,103,4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,0,-0.08,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击禁锢目标时，破甲提升10%\",\"condition\":\"[]\",\"power\":\"30640\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,103,4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,0,-0.1,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击禁锢目标时，破甲提升12%\",\"condition\":\"[]\",\"power\":\"36800\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,103,4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,0,-0.12,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击禁锢目标时，破甲提升14%\",\"condition\":\"[]\",\"power\":\"42960\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,103,4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,0,-0.14,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击禁锢目标时，破甲提升16%\",\"condition\":\"[]\",\"power\":\"49120\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,103,4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,0,-0.16,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击禁锢目标时，破甲提升18%\",\"condition\":\"[]\",\"power\":\"55280\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,103,4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,0,-0.18,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击禁锢目标时，破甲提升20%\",\"condition\":\"[]\",\"power\":\"61440\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,103,4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,0,-0.2,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击禁锢目标时，破甲提升22%\",\"condition\":\"[]\",\"power\":\"67600\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,103,4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,0,-0.22,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击禁锢目标时，破甲提升24%\",\"condition\":\"[]\",\"power\":\"73760\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,103,4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,0,-0.24,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击禁锢目标时，破甲提升26%\",\"condition\":\"[]\",\"power\":\"79920\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,103,4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,0,-0.26,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击禁锢目标时，破甲提升28%\",\"condition\":\"[]\",\"power\":\"86080\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,103,4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,0,-0.28,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击禁锢目标时，破甲提升30%\",\"condition\":\"[]\",\"power\":\"92240\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,103,4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,0,-0.3,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击禁锢目标时，破甲提升32%\",\"condition\":\"[]\",\"power\":\"98400\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,103,4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,0,-0.32,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击禁锢目标时，破甲提升34%\",\"condition\":\"[]\",\"power\":\"104560\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,103,4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,0,-0.34,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击禁锢目标时，破甲提升36%\",\"condition\":\"[]\",\"power\":\"110720\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,103,4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,0,-0.36,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击禁锢目标时，破甲提升38%\",\"condition\":\"[]\",\"power\":\"116880\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,103,4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,0,-0.38,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击禁锢目标时，破甲提升40%\",\"condition\":\"[]\",\"power\":\"123040\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,103,4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,0,-0.4,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击禁锢目标时，破甲提升42%\",\"condition\":\"[]\",\"power\":\"129200\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,103,4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,0,-0.42,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击禁锢目标时，破甲提升44%\",\"condition\":\"[]\",\"power\":\"135360\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,103,4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,0,-0.44,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击禁锢目标时，破甲提升46%\",\"condition\":\"[]\",\"power\":\"141520\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,103,4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,0,-0.46,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击禁锢目标时，破甲提升48%\",\"condition\":\"[]\",\"power\":\"147680\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,103,4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,0,-0.48,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击禁锢目标时，破甲提升50%\",\"condition\":\"[]\",\"power\":\"153840\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,103,4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,0,-0.5,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击禁锢目标时，破甲提升52%\",\"condition\":\"[]\",\"power\":\"160000\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{2,1000,0,0,0,0,103,4}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,0,-0.52,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(60404301,'治愈之魂','星灵被动技能',26,2,0,0,0,0,1,1,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"血量低于10%时，立刻回血15%，CD80s\",\"condition\":\"[]\",\"power\":\"34000\",\"base_attr\":\"\",\"cd\":\"80000\",\"trigger\":\"[{3,1000,0,0,0,0.1,0,116}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,0,1000,1,0,0.15,2,0,1,0}]\"},{\"desc\":\"血量低于10%时，立刻回血18%，CD78s\",\"condition\":\"[]\",\"power\":\"58000\",\"base_attr\":\"\",\"cd\":\"78000\",\"trigger\":\"[{3,1000,0,0,0,0.1,0,116}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,0,1000,1,0,0.18,2,0,1,0}]\"},{\"desc\":\"血量低于10%时，立刻回血21%，CD76s\",\"condition\":\"[]\",\"power\":\"82000\",\"base_attr\":\"\",\"cd\":\"76000\",\"trigger\":\"[{3,1000,0,0,0,0.1,0,116}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,0,1000,1,0,0.21,2,0,1,0}]\"},{\"desc\":\"血量低于10%时，立刻回血24%，CD74s\",\"condition\":\"[]\",\"power\":\"106000\",\"base_attr\":\"\",\"cd\":\"74000\",\"trigger\":\"[{3,1000,0,0,0,0.1,0,116}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,0,1000,1,0,0.24,2,0,1,0}]\"},{\"desc\":\"血量低于10%时，立刻回血27%，CD72s\",\"condition\":\"[]\",\"power\":\"130000\",\"base_attr\":\"\",\"cd\":\"72000\",\"trigger\":\"[{3,1000,0,0,0,0.1,0,116}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,0,1000,1,0,0.27,2,0,1,0}]\"},{\"desc\":\"血量低于10%时，立刻回血30%，CD70s\",\"condition\":\"[]\",\"power\":\"154000\",\"base_attr\":\"\",\"cd\":\"70000\",\"trigger\":\"[{3,1000,0,0,0,0.1,0,116}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,0,1000,1,0,0.3,2,0,1,0}]\"},{\"desc\":\"血量低于10%时，立刻回血33%，CD68s\",\"condition\":\"[]\",\"power\":\"178000\",\"base_attr\":\"\",\"cd\":\"68000\",\"trigger\":\"[{3,1000,0,0,0,0.1,0,116}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,0,1000,1,0,0.33,2,0,1,0}]\"},{\"desc\":\"血量低于10%时，立刻回血36%，CD66s\",\"condition\":\"[]\",\"power\":\"202000\",\"base_attr\":\"\",\"cd\":\"66000\",\"trigger\":\"[{3,1000,0,0,0,0.1,0,116}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,0,1000,1,0,0.36,2,0,1,0}]\"},{\"desc\":\"血量低于10%时，立刻回血39%，CD64s\",\"condition\":\"[]\",\"power\":\"226000\",\"base_attr\":\"\",\"cd\":\"64000\",\"trigger\":\"[{3,1000,0,0,0,0.1,0,116}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,0,1000,1,0,0.39,2,0,1,0}]\"},{\"desc\":\"血量低于10%时，立刻回血42%，CD62s\",\"condition\":\"[]\",\"power\":\"250000\",\"base_attr\":\"\",\"cd\":\"62000\",\"trigger\":\"[{3,1000,0,0,0,0.2,0,116}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,0,1000,1,0,0.42,2,0,1,0}]\"}]'),(60404401,'圣水印记','星灵被动技能',26,2,0,0,0,0,1,1,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"血量低于20%时，触发回血效果，每秒回血3%，持续5s,CD80s\",\"condition\":\"[]\",\"power\":\"34000\",\"base_attr\":\"\",\"cd\":\"80000\",\"trigger\":\"[{3,1000,0,0,0,0.2,0,116}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,0,1000,1,0,0.03,2,5000,5,0}]\"},{\"desc\":\"血量低于20%时，触发回血效果，每秒回血4%，持续5s,CD78s\",\"condition\":\"[]\",\"power\":\"58000\",\"base_attr\":\"\",\"cd\":\"78000\",\"trigger\":\"[{3,1000,0,0,0,0.2,0,116}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,0,1000,1,0,0.04,2,5000,5,0}]\"},{\"desc\":\"血量低于20%时，触发回血效果，每秒回血5%，持续5s,CD76s\",\"condition\":\"[]\",\"power\":\"82000\",\"base_attr\":\"\",\"cd\":\"76000\",\"trigger\":\"[{3,1000,0,0,0,0.2,0,116}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,0,1000,1,0,0.05,2,5000,5,0}]\"},{\"desc\":\"血量低于20%时，触发回血效果，每秒回血6%，持续5s,CD74s\",\"condition\":\"[]\",\"power\":\"106000\",\"base_attr\":\"\",\"cd\":\"74000\",\"trigger\":\"[{3,1000,0,0,0,0.2,0,116}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,0,1000,1,0,0.06,2,5000,5,0}]\"},{\"desc\":\"血量低于20%时，触发回血效果，每秒回血7%，持续5s,CD72s\",\"condition\":\"[]\",\"power\":\"130000\",\"base_attr\":\"\",\"cd\":\"72000\",\"trigger\":\"[{3,1000,0,0,0,0.2,0,116}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,0,1000,1,0,0.07,2,5000,5,0}]\"},{\"desc\":\"血量低于20%时，触发回血效果，每秒回血8%，持续5s,CD70s\",\"condition\":\"[]\",\"power\":\"154000\",\"base_attr\":\"\",\"cd\":\"70000\",\"trigger\":\"[{3,1000,0,0,0,0.2,0,116}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,0,1000,1,0,0.08,2,5000,5,0}]\"},{\"desc\":\"血量低于20%时，触发回血效果，每秒回血9%，持续5s,CD68s\",\"condition\":\"[]\",\"power\":\"178000\",\"base_attr\":\"\",\"cd\":\"68000\",\"trigger\":\"[{3,1000,0,0,0,0.2,0,116}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,0,1000,1,0,0.09,2,5000,5,0}]\"},{\"desc\":\"血量低于20%时，触发回血效果，每秒回血10%，持续5s,CD66s\",\"condition\":\"[]\",\"power\":\"202000\",\"base_attr\":\"\",\"cd\":\"66000\",\"trigger\":\"[{3,1000,0,0,0,0.2,0,116}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,0,1000,1,0,0.1,2,5000,5,0}]\"},{\"desc\":\"血量低于20%时，触发回血效果，每秒回血11%，持续5s,CD64s\",\"condition\":\"[]\",\"power\":\"226000\",\"base_attr\":\"\",\"cd\":\"64000\",\"trigger\":\"[{3,1000,0,0,0,0.2,0,116}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,0,1000,1,0,0.11,2,5000,5,0}]\"},{\"desc\":\"血量低于20%时，触发回血效果，每秒回血12%，持续5s,CD62s\",\"condition\":\"[]\",\"power\":\"250000\",\"base_attr\":\"\",\"cd\":\"62000\",\"trigger\":\"[{6,1000,0,4,0,0,0,116}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,0,1000,1,0,0.12,2,5000,5,0}]\"}]'),(60404501,'复生之魂','星灵被动技能',26,2,0,0,0,0,1,1,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"受到致死伤害时，免疫该次伤害，并立即回血8%，并在后续的3s内累计回血12%，CD90s\",\"condition\":\"[]\",\"power\":\"34000\",\"base_attr\":\"\",\"cd\":\"90000\",\"trigger\":\"[{6,1000,0,4,0,0,0,116}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,0,1000,1,0,0.08,2,0,1,0},{116,0,1000,1,0,0.04,2,3000,3,0}]\"},{\"desc\":\"受到致死伤害时，免疫该次伤害，并立即回血9%，并在后续的3s内累计回血13.5%，CD88s\",\"condition\":\"[]\",\"power\":\"58000\",\"base_attr\":\"\",\"cd\":\"88000\",\"trigger\":\"[{6,1000,0,4,0,0,0,116}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,0,1000,1,0,0.09,2,0,1,0},{116,0,1000,1,0,0.045,2,3000,3,0}]\"},{\"desc\":\"受到致死伤害时，免疫该次伤害，并立即回血10%，并在后续的3s内累计回血15%，CD86s\",\"condition\":\"[]\",\"power\":\"82000\",\"base_attr\":\"\",\"cd\":\"86000\",\"trigger\":\"[{6,1000,0,4,0,0,0,116}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,0,1000,1,0,0.1,2,0,1,0},{116,0,1000,1,0,0.05,2,3000,3,0}]\"},{\"desc\":\"受到致死伤害时，免疫该次伤害，并立即回血11%，并在后续的3s内累计回血16.5%，CD84s\",\"condition\":\"[]\",\"power\":\"106000\",\"base_attr\":\"\",\"cd\":\"84000\",\"trigger\":\"[{6,1000,0,4,0,0,0,116}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,0,1000,1,0,0.11,2,0,1,0},{116,0,1000,1,0,0.055,2,3000,3,0}]\"},{\"desc\":\"受到致死伤害时，免疫该次伤害，并立即回血12%，并在后续的3s内累计回血18%，CD82s\",\"condition\":\"[]\",\"power\":\"130000\",\"base_attr\":\"\",\"cd\":\"82000\",\"trigger\":\"[{6,1000,0,4,0,0,0,116}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,0,1000,1,0,0.12,2,0,1,0},{116,0,1000,1,0,0.06,2,3000,3,0}]\"},{\"desc\":\"受到致死伤害时，免疫该次伤害，并立即回血13%，并在后续的3s内累计回血19.5%，CD80s\",\"condition\":\"[]\",\"power\":\"154000\",\"base_attr\":\"\",\"cd\":\"80000\",\"trigger\":\"[{6,1000,0,4,0,0,0,116}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,0,1000,1,0,0.13,2,0,1,0},{116,0,1000,1,0,0.065,2,3000,3,0}]\"},{\"desc\":\"受到致死伤害时，免疫该次伤害，并立即回血14%，并在后续的3s内累计回血21%，CD78s\",\"condition\":\"[]\",\"power\":\"178000\",\"base_attr\":\"\",\"cd\":\"78000\",\"trigger\":\"[{6,1000,0,4,0,0,0,116}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,0,1000,1,0,0.14,2,0,1,0},{116,0,1000,1,0,0.07,2,3000,3,0}]\"},{\"desc\":\"受到致死伤害时，免疫该次伤害，并立即回血15%，并在后续的3s内累计回血22.5%，CD76s\",\"condition\":\"[]\",\"power\":\"202000\",\"base_attr\":\"\",\"cd\":\"76000\",\"trigger\":\"[{6,1000,0,4,0,0,0,116}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,0,1000,1,0,0.15,2,0,1,0},{116,0,1000,1,0,0.075,2,3000,3,0}]\"},{\"desc\":\"受到致死伤害时，免疫该次伤害，并立即回血16%，并在后续的3s内累计回血24%，CD74s\",\"condition\":\"[]\",\"power\":\"226000\",\"base_attr\":\"\",\"cd\":\"74000\",\"trigger\":\"[{6,1000,0,4,0,0,0,116}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,0,1000,1,0,0.16,2,0,1,0},{116,0,1000,1,0,0.08,2,3000,3,0}]\"},{\"desc\":\"受到致死伤害时，免疫该次伤害，并立即回血17%，并在后续的3s内累计回血25.5%，CD72s\",\"condition\":\"[]\",\"power\":\"250000\",\"base_attr\":\"\",\"cd\":\"72000\",\"trigger\":\"[{0,1000,0,3,0,0,0,116}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,0,1000,1,0,0.17,2,0,1,0},{116,0,1000,1,0,0.085,2,3000,3,0}]\"}]'),(60404601,'致命之魂','星灵被动技能',26,2,0,0,0,0,1,1,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"攻击时，有6.5%直接扣除目标8%的生命值，CD60s\",\"condition\":\"[]\",\"power\":\"34000\",\"base_attr\":\"\",\"cd\":\"60000\",\"trigger\":\"[{0,1000,0,3,0,0,0,117}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{117,0,65,2,0,0.08,2,0,1,1}]\"},{\"desc\":\"攻击时，有8%直接扣除目标8%的生命值，CD59s\",\"condition\":\"[]\",\"power\":\"58000\",\"base_attr\":\"\",\"cd\":\"59000\",\"trigger\":\"[{0,1000,0,3,0,0,0,117}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{117,0,80,2,0,0.08,2,0,1,1}]\"},{\"desc\":\"攻击时，有9.5%直接扣除目标8%的生命值，CD58s\",\"condition\":\"[]\",\"power\":\"82000\",\"base_attr\":\"\",\"cd\":\"58000\",\"trigger\":\"[{0,1000,0,3,0,0,0,117}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{117,0,95,2,0,0.08,2,0,1,1}]\"},{\"desc\":\"攻击时，有11%直接扣除目标8%的生命值，CD57s\",\"condition\":\"[]\",\"power\":\"106000\",\"base_attr\":\"\",\"cd\":\"57000\",\"trigger\":\"[{0,1000,0,3,0,0,0,117}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{117,0,110,2,0,0.08,2,0,1,1}]\"},{\"desc\":\"攻击时，有12.5%直接扣除目标8%的生命值，CD56s\",\"condition\":\"[]\",\"power\":\"130000\",\"base_attr\":\"\",\"cd\":\"56000\",\"trigger\":\"[{0,1000,0,3,0,0,0,117}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{117,0,125,2,0,0.08,2,0,1,1}]\"},{\"desc\":\"攻击时，有14%直接扣除目标8%的生命值，CD55s\",\"condition\":\"[]\",\"power\":\"154000\",\"base_attr\":\"\",\"cd\":\"55000\",\"trigger\":\"[{0,1000,0,3,0,0,0,117}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{117,0,140,2,0,0.08,2,0,1,1}]\"},{\"desc\":\"攻击时，有15.5%直接扣除目标8%的生命值，CD54s\",\"condition\":\"[]\",\"power\":\"178000\",\"base_attr\":\"\",\"cd\":\"54000\",\"trigger\":\"[{0,1000,0,3,0,0,0,117}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{117,0,155,2,0,0.08,2,0,1,1}]\"},{\"desc\":\"攻击时，有17%直接扣除目标8%的生命值，CD53s\",\"condition\":\"[]\",\"power\":\"202000\",\"base_attr\":\"\",\"cd\":\"53000\",\"trigger\":\"[{0,1000,0,3,0,0,0,117}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{117,0,170,2,0,0.08,2,0,1,1}]\"},{\"desc\":\"攻击时，有18.5%直接扣除目标8%的生命值，CD52s\",\"condition\":\"[]\",\"power\":\"226000\",\"base_attr\":\"\",\"cd\":\"52000\",\"trigger\":\"[{0,1000,0,3,0,0,0,117}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{117,0,185,2,0,0.08,2,0,1,1}]\"},{\"desc\":\"攻击时，有20%直接扣除目标8%的生命值，CD50s\",\"condition\":\"[]\",\"power\":\"250000\",\"base_attr\":\"\",\"cd\":\"50000\",\"trigger\":\"[{0,1000,0,3,0,0,0,117}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{117,0,200,2,0,0.08,2,0,1,1}]\"}]'),(60404701,'生命之灵·星','星灵被动技能',26,2,0,0,0,0,0,1,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"星灵血量提升3000\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,2,3000}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵血量提升5000\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,2,5000}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵血量提升7000\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,2,7000}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵血量提升9000\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,2,9000}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵血量提升11000\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,2,11000}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵血量提升13000\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,2,13000}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵血量提升15000\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,2,15000}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵血量提升17000\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,2,17000}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵血量提升19000\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,2,19000}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵血量提升21000\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,2,21000}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵血量提升23000\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,2,23000}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵血量提升25000\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,2,25000}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵血量提升27000\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,2,27000}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵血量提升29000\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,2,29000}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵血量提升31000\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,2,31000}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵血量提升33000\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,2,33000}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵血量提升35000\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,2,35000}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵血量提升37000\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,2,37000}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵血量提升39000\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,2,39000}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵血量提升41000\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,2,41000}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(60404801,'生命之心·星','星灵被动技能',26,2,0,0,0,0,0,1,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"星灵血量提升2.5%+3000\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,61,250},{430,2,3000}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵血量提升3.5%+5000\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,61,350},{430,2,5000}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵血量提升4.5%+7000\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,61,450},{430,2,7000}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵血量提升5.5%+9000\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,61,550},{430,2,9000}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵血量提升6.5%+11000\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,61,650},{430,2,11000}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵血量提升7.5%+13000\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,61,750},{430,2,13000}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵血量提升8.5%+15000\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,61,850},{430,2,15000}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵血量提升9.5%+17000\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,61,950},{430,2,17000}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵血量提升10.5%+19000\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,61,1050},{430,2,19000}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵血量提升11.5%+21000\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,61,1150},{430,2,21000}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵血量提升12.5%+23000\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,61,1250},{430,2,23000}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵血量提升13.5%+25000\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,61,1350},{430,2,25000}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵血量提升14.5%+27000\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,61,1450},{430,2,27000}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵血量提升15.5%+29000\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,61,1550},{430,2,29000}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵血量提升16.5%+31000\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,61,1650},{430,2,31000}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵血量提升17.5%+33000\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,61,1750},{430,2,33000}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵血量提升18.5%+35000\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,61,1850},{430,2,35000}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵血量提升19.5%+37000\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,61,1950},{430,2,37000}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵血量提升20.5%+39000\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,61,2050},{430,2,39000}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵血量提升21.5%+41000\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,61,2150},{430,2,41000}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵血量提升22.5%+43000\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,61,2250},{430,2,43000}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵血量提升23.5%+45000\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,61,2350},{430,2,45000}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵血量提升24.5%+47000\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,61,2450},{430,2,47000}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵血量提升25.5%+49000\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,61,2550},{430,2,49000}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵血量提升26.5%+51000\",\"condition\":\"[]\",\"power\":\"\",\"base_attr\":\"[{430,61,2650},{430,2,51000}]\",\"cd\":\"0\",\"trigger\":\"\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(60500001,'追魂夺命','星灵特性',26,2,0,0,0,0,1,1,0,1,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"趁他病，要他命！优先攻击敌方血量最低的单位\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(60500002,'弱者杀手','星灵特性',26,2,0,0,0,0,1,1,0,1,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"我闻到了一股弱者的气息：优先攻击在场目标中战力最低的单位\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(60500003,'无所畏惧','星灵特性',26,2,0,0,0,0,1,1,0,1,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"我就是喜欢挑战！优先攻击敌方攻击最高者\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(60500004,'越战越勇','星灵特性',26,2,0,0,0,0,1,1,0,1,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"伤了又怎样，我越挫越强！血量每降低5%时，伤害减免提升1.5%\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(60500005,'背水奋战','星灵特性',26,2,0,0,0,0,1,1,0,1,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"逆风翻盘，我是全场MVP！血量低于30%时，攻击提升40%\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(60500006,'他强任他强','星灵特性',26,2,0,0,0,0,1,1,0,1,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"他强任他强，劳资小白羊！血量低于40%时，伤害减免提升30%\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(60500007,'毒术','星灵特性',26,2,0,0,0,0,1,1,0,1,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"每次普攻都有概率10%的概率触发毒素效果，额外扣除对手3%的生命\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(70100101,'魔蝠护体','天赋技能',1,1,0,0,0,0,1,1,0,1,0,0,'0','[]',0,0,0,1000,'[]','[70100201,70100301]',0,0,'[{\"desc\":\"释放一个蝙蝠护盾，持续3s，反弹所受到伤害的45%,CD时间30s\",\"condition\":\"\",\"power\":\"40000\",\"base_attr\":\"\",\"cd\":\"30000\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{115,0,1000,1,0,0.45,0,3000,0,0}]\"}]'),(70100111,'雷神之体','天赋技能',2,1,0,0,0,0,1,1,0,1,0,0,'0','[]',0,0,0,1000,'[]','[70100211,70100311]',0,0,'[{\"desc\":\"雷电之力环绕，守护主角，吸收最大生命值3%的伤害，持续3s,CD时间30s\",\"condition\":\"\",\"power\":\"40000\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{104,0,1000,1,0,0.08,2,3000,0,0}]\"}]'),(70100121,'重力护盾','天赋技能',4,1,0,0,0,0,1,1,0,1,0,0,'0','[]',0,0,0,1000,'[]','[70100221,70100321]',0,0,'[{\"desc\":\"召唤重力护盾，每0.5秒恢复最大生命值的1%，持续4s,CD30s\",\"condition\":\"\",\"power\":\"40000\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,2,1000,1,0,0.01,2,4000,8,0}]\"}]'),(70100201,'沙漏之盾','天赋技能',1,8,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'[]','[]',0,0,'[{\"desc\":\"魔蝠护体持续时间延长0.3s\",\"condition\":\"[{point,1,5},{pre_skill,70100101,1}]\",\"power\":\"10000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{115,0,1000,1,0,0,0,300,0,0}]\"},{\"desc\":\"魔蝠护体持续时间延长0.6s\",\"condition\":\"[{point,1,5},{pre_skill,70100101,1}]\",\"power\":\"20000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{115,0,1000,1,0,0,0,600,0,0}]\"},{\"desc\":\"魔蝠护体持续时间延长0.9s\",\"condition\":\"[{point,1,5},{pre_skill,70100101,1}]\",\"power\":\"30000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{115,0,1000,1,0,0,0,900,0,0}]\"},{\"desc\":\"魔蝠护体持续时间延长1.2s\",\"condition\":\"[{point,1,5},{pre_skill,70100101,1}]\",\"power\":\"40000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{115,0,1000,1,0,0,0,1200,0,0}]\"},{\"desc\":\"魔蝠护体持续时间延长1.5s\",\"condition\":\"[{point,1,5},{pre_skill,70100101,1}]\",\"power\":\"50000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{115,0,1000,1,0,0,0,1500,0,0}]\"}]'),(70100211,'时光之雷','天赋技能',2,8,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'[]','[]',0,0,'[{\"desc\":\"雷神之体持续时间+0.3s\",\"condition\":\"[{point,1,5},{pre_skill,70100111,1}]\",\"power\":\"10000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{104,0,1000,1,0,0,0,300,0,0}]\"},{\"desc\":\"雷神之体持续时间+0.6s\",\"condition\":\"[{point,1,5},{pre_skill,70100111,1}]\",\"power\":\"20000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{104,0,1000,1,0,0,0,600,0,0}]\"},{\"desc\":\"雷神之体持续时间+0.9s\",\"condition\":\"[{point,1,5},{pre_skill,70100111,1}]\",\"power\":\"30000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{104,0,1000,1,0,0,0,900,0,0}]\"},{\"desc\":\"雷神之体持续时间+0.12s\",\"condition\":\"[{point,1,5},{pre_skill,70100111,1}]\",\"power\":\"40000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{104,0,1000,1,0,0,0,1200,0,0}]\"},{\"desc\":\"雷神之体持续时间+0.15s\",\"condition\":\"[{point,1,5},{pre_skill,70100111,1}]\",\"power\":\"50000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{104,0,1000,1,0,0,0,1500,0,0}]\"}]'),(70100221,'时之护盾','天赋技能',4,8,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'[]','[]',0,0,'[{\"desc\":\"重力护盾时间延长0.5s\",\"condition\":\"[{point,1,5},{pre_skill,70100121,1}]\",\"power\":\"10000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,2,1000,1,0,0,2,500,1,0}]\"},{\"desc\":\"重力护盾时间延长1s\",\"condition\":\"[{point,1,5},{pre_skill,70100121,1}]\",\"power\":\"20000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,2,1000,1,0,0,2,1000,2,0}]\"},{\"desc\":\"重力护盾时间延长1.5s\",\"condition\":\"[{point,1,5},{pre_skill,70100121,1}]\",\"power\":\"30000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,2,1000,1,0,0,2,1500,3,0}]\"},{\"desc\":\"重力护盾时间延长2s\",\"condition\":\"[{point,1,5},{pre_skill,70100121,1}]\",\"power\":\"40000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,2,1000,1,0,0,2,2000,4,0}]\"},{\"desc\":\"重力护盾时间延长2.5s\",\"condition\":\"[{point,1,5},{pre_skill,70100121,1}]\",\"power\":\"50000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,2,1000,1,0,0,2,2500,5,0}]\"}]'),(70100301,'反击之咬','天赋技能',1,8,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'[]','[]',0,0,'[{\"desc\":\"魔蝠护体伤害反弹比例提升5%\",\"condition\":\"[{point,1,14},{pre_skill,70100201,2}]\",\"power\":\"10000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{115,0,1000,1,0,0.05,0,0,0,4}]\"},{\"desc\":\"魔蝠护体伤害反弹比例提升10%\",\"condition\":\"[{point,1,14},{pre_skill,70100201,2}]\",\"power\":\"20000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{115,0,1000,1,0,0.10,0,0,0,4}]\"},{\"desc\":\"魔蝠护体伤害反弹比例提升15%\",\"condition\":\"[{point,1,14},{pre_skill,70100201,2}]\",\"power\":\"30000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{115,0,1000,1,0,0.15,0,0,0,4}]\"},{\"desc\":\"魔蝠护体伤害反弹比例提升20%\",\"condition\":\"[{point,1,14},{pre_skill,70100201,2}]\",\"power\":\"40000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{115,0,1000,1,0,0.20,0,0,0,4}]\"},{\"desc\":\"魔蝠护体伤害反弹比例提升25%\",\"condition\":\"[{point,1,14},{pre_skill,70100201,2}]\",\"power\":\"50000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{115,0,1000,1,0,0.25,0,0,0,4}]\"}]'),(70100311,'雷电汲取','天赋技能',2,8,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'[]','[]',0,0,'[{\"desc\":\"雷神之体抵挡伤害+1%的最大生命值\",\"condition\":\"[{point,1,14},{pre_skill,70100211,2}]\",\"power\":\"10000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{104,0,1000,1,0,0.01,2,0,0,0}]\"},{\"desc\":\"雷神之体抵挡伤害+2%的最大生命值\",\"condition\":\"[{point,1,14},{pre_skill,70100211,2}]\",\"power\":\"20000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{104,0,1000,1,0,0.02,2,0,0,0}]\"},{\"desc\":\"雷神之体抵挡伤害+3%的最大生命值\",\"condition\":\"[{point,1,14},{pre_skill,70100211,2}]\",\"power\":\"30000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{104,0,1000,1,0,0.03,2,0,0,0}]\"},{\"desc\":\"雷神之体抵挡伤害+4%的最大生命值\",\"condition\":\"[{point,1,14},{pre_skill,70100211,2}]\",\"power\":\"40000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{104,0,1000,1,0,0.04,2,0,0,0}]\"},{\"desc\":\"雷神之体抵挡伤害+5%的最大生命值\",\"condition\":\"[{point,1,14},{pre_skill,70100211,2}]\",\"power\":\"50000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{104,0,1000,1,0,0.05,2,0,0,0}]\"}]'),(70100321,'治疗之盾','天赋技能',4,8,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'[]','[]',0,0,'[{\"desc\":\"重力护盾每次恢复效果提升10%\",\"condition\":\"[{point,1,14},{pre_skill,70100221,2}]\",\"power\":\"10000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,2,1000,1,0,0.001,2,0,0,0}]\"},{\"desc\":\"重力护盾每次恢复效果提升20%\",\"condition\":\"[{point,1,14},{pre_skill,70100221,2}]\",\"power\":\"20000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,2,1000,1,0,0.002,2,0,0,0}]\"},{\"desc\":\"重力护盾每次恢复效果提升30%\",\"condition\":\"[{point,1,14},{pre_skill,70100221,2}]\",\"power\":\"30000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,2,1000,1,0,0.003,2,0,0,0}]\"},{\"desc\":\"重力护盾每次恢复效果提升40%\",\"condition\":\"[{point,1,14},{pre_skill,70100221,2}]\",\"power\":\"40000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,2,1000,1,0,0.004,2,0,0,0}]\"},{\"desc\":\"重力护盾每次恢复效果提升50%\",\"condition\":\"[{point,1,14},{pre_skill,70100221,2}]\",\"power\":\"50000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,2,1000,1,0,0.005,2,0,0,0}]\"}]'),(70100401,'斩空刃击','天赋技能',1,1,0,0,0,0,2,2,1,0,1000,3,'0','[{70100401,300,0},{70100402,300,0},{70100403,300,0},{70100404,300,0}]',0,0,0,400,'[]','[70100501,70100601]',0,0,'[{\"desc\":\"刀光乱舞，给前方600码以内扇形范围的最多4个敌人造成200%的技能伤害，并附带吸血之力，吸收对主目标造成伤害的50%转化为自身血量，CD时间45s\",\"condition\":\"\",\"power\":\"40000\",\"base_attr\":\"[]\",\"cd\":\"45000\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"500\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"4500\",\"effect\":\"[{114,0,1000,1,0,0.5,0,0,1,0}]\"}]'),(70100402,'魔-天赋主技能2-副1','天赋技能',1,1,0,1,0,0,2,2,1,0,1000,3,'0','[{70100401,300,0},{70100402,300,0},{70100403,300,0},{70100404,300,0}]',0,0,0,400,'[]','[70100501,70100601]',0,0,'[{\"desc\":\"刀光乱舞，给前方600码以内扇形范围的最多4个敌人造成200%的技能伤害，并附带吸血之力，吸收对主目标造成伤害的50%转化为自身血量，CD时间45s\",\"condition\":\"\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"500\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"5000\",\"effect\":\"[{114,0,1000,1,0,0.5,0,0,1,0}]\"}]'),(70100403,'魔-天赋主技能2-副2','天赋技能',1,1,0,1,0,0,2,2,1,0,1000,3,'0','[{70100401,300,0},{70100402,300,0},{70100403,300,0},{70100404,300,0}]',0,0,0,400,'[]','[70100501,70100601]',0,0,'[{\"desc\":\"刀光乱舞，给前方600码以内扇形范围的最多4个敌人造成200%的技能伤害，并附带吸血之力，吸收对主目标造成伤害的50%转化为自身血量，CD时间45s\",\"condition\":\"\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"500\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"5000\",\"effect\":\"[{114,0,1000,1,0,0.5,0,0,1,0}]\"}]'),(70100404,'魔-天赋主技能2-副3','天赋技能',1,1,0,1,0,0,2,2,1,0,1000,3,'0','[{70100401,300,0},{70100402,300,0},{70100403,300,0},{70100404,300,0}]',0,0,0,400,'[]','[70100501,70100601]',0,0,'[{\"desc\":\"刀光乱舞，给前方600码以内扇形范围的最多4个敌人造成200%的技能伤害，并附带吸血之力，吸收对主目标造成伤害的50%转化为自身血量，CD时间45s\",\"condition\":\"\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"500\",\"num\":\"[3,4]\",\"attr\":\"\",\"hurt\":\"5500\",\"effect\":\"[{114,0,1000,1,0,0.5,0,0,1,0}]\"}]'),(70100411,'雷电风卷','天赋技能',2,1,0,0,0,0,2,2,1,0,1000,1,'0','[{70100411,300,0},{70100412,300,0},{70100413,300,0},{70100414,300,0}]',0,0,0,400,'[]','[70100511,70100611]',0,0,'[{\"desc\":\"长枪向前释放出龙卷风，将800码范围的最多5个敌人拉至身边周围200码范围内，造成150%的技能伤害，并眩晕目标1.5s，CD时间45s\",\"condition\":\"\",\"power\":\"40000\",\"base_attr\":\"[]\",\"cd\":\"45000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[5,5]\",\"attr\":\"\",\"hurt\":\"3000\",\"effect\":\"[{112,3,1000,2,150,0,0,0,0,0},{101,3,1000,2,0,0,0,1500,0,101}]\"}]'),(70100412,'龙-天赋主技能2-副1','天赋技能',2,1,0,1,0,0,2,2,1,0,1000,1,'0','[{70100411,300,0},{70100412,300,0},{70100413,300,0},{70100414,300,0}]',0,0,0,400,'[]','[70100511,70100611]',0,0,'[{\"desc\":\"长枪向前释放出龙卷风，将800码范围的最多5个敌人拉至身边周围200码范围内，造成150%的技能伤害，并眩晕目标1.5s，CD时间46s\",\"condition\":\"\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"45000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[5,5]\",\"attr\":\"\",\"hurt\":\"3500\",\"effect\":\"\"}]'),(70100413,'龙-天赋主技能2-副2','天赋技能',2,1,0,1,0,0,2,2,1,0,1000,1,'0','[{70100411,300,0},{70100412,300,0},{70100413,300,0},{70100414,300,0}]',0,0,0,400,'[]','[70100511,70100611]',0,0,'[{\"desc\":\"长枪向前释放出龙卷风，将800码范围的最多5个敌人拉至身边周围200码范围内，造成150%的技能伤害，并眩晕目标1.5s，CD时间47s\",\"condition\":\"\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"45000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[5,5]\",\"attr\":\"\",\"hurt\":\"4000\",\"effect\":\"\"}]'),(70100414,'龙-天赋主技能2-副3','天赋技能',2,1,0,1,0,0,2,2,1,0,1000,1,'0','[{70100411,300,0},{70100412,300,0},{70100413,300,0},{70100414,300,0}]',0,0,0,400,'[]','[70100511,70100611]',0,0,'[{\"desc\":\"长枪向前释放出龙卷风，将800码范围的最多5个敌人拉至身边周围200码范围内，造成150%的技能伤害，并眩晕目标1.5s，CD时间48s\",\"condition\":\"\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"45000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"500\",\"num\":\"[5,5]\",\"attr\":\"\",\"hurt\":\"4500\",\"effect\":\"\"}]'),(70100421,'激光制导','天赋技能',4,1,0,0,0,0,2,2,1,0,1000,1,'0','[{70100421,300,0},{70100422,300,0},{70100423,300,0},{70100424,300,0}]',0,0,0,400,'[]','[70100421,70100621]',0,0,'[{\"desc\":\"重炮手重置武器系统，再次召唤制导打击，对敌方造成350%的伤害，CD时间45s\",\"condition\":\"\",\"power\":\"40000\",\"base_attr\":\"[]\",\"cd\":\"45000\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"500\",\"num\":\"[5,8]\",\"attr\":\"\",\"hurt\":\"8000\",\"effect\":\"\"}]'),(70100422,'炮-天赋主技能2-副1','天赋技能',4,1,0,1,0,0,2,2,1,0,1000,1,'0','[{70100421,300,0},{70100422,300,0},{70100423,300,0},{70100424,300,0}]',0,0,0,400,'[]','[70100421,70100621]',0,0,'[{\"desc\":\"重炮手重置武器系统，再次召唤制导打击，对敌方造成350%的伤害，CD时间45s\",\"condition\":\"\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"45000\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"500\",\"num\":\"[5,8]\",\"attr\":\"\",\"hurt\":\"8000\",\"effect\":\"\"}]'),(70100423,'炮-天赋主技能2-副2','天赋技能',4,1,0,1,0,0,2,2,1,0,1000,1,'0','[{70100421,300,0},{70100422,300,0},{70100423,300,0},{70100424,300,0}]',0,0,0,400,'[]','[70100421,70100621]',0,0,'[{\"desc\":\"重炮手重置武器系统，再次召唤制导打击，对敌方造成350%的伤害，CD时间45s\",\"condition\":\"\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"45000\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"500\",\"num\":\"[5,8]\",\"attr\":\"\",\"hurt\":\"9000\",\"effect\":\"\"}]'),(70100424,'炮-天赋主技能2-副3','天赋技能',4,1,0,1,0,0,2,2,1,0,1000,1,'0','[{70100421,300,0},{70100422,300,0},{70100423,300,0},{70100424,300,0}]',0,0,0,400,'[]','[70100421,70100621]',0,0,'[{\"desc\":\"重炮手重置武器系统，再次召唤制导打击，对敌方造成350%的伤害，CD时间45s\",\"condition\":\"\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"45000\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"500\",\"num\":\"[5,8]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(70100501,'锋利之刃','天赋技能',1,8,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'[]','[]',0,0,'[{\"desc\":\"斩空刃击技能伤害提升20%\",\"condition\":\"[{point,1,5},{pre_skill,70100401,1}]\",\"power\":\"10000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"[{27,0,1000,1,500,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"斩空刃击技能伤害提升40%\",\"condition\":\"[{point,1,5},{pre_skill,70100401,1}]\",\"power\":\"20000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"[{27,0,1000,1,1000,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"斩空刃击技能伤害提升60%\",\"condition\":\"[{point,1,5},{pre_skill,70100401,1}]\",\"power\":\"30000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"[{27,0,1000,1,1500,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"斩空刃击技能伤害提升80%\",\"condition\":\"[{point,1,5},{pre_skill,70100401,1}]\",\"power\":\"40000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"[{27,0,1000,1,2000,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"斩空刃击技能伤害提升100%\",\"condition\":\"[{point,1,5},{pre_skill,70100401,1}]\",\"power\":\"50000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"[{27,0,1000,1,2500,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(70100511,'增伤之雷','天赋技能',2,8,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'[]','[]',0,0,'[{\"desc\":\"雷电风卷技能伤害提升20%\",\"condition\":\"[{point,1,5},{pre_skill,70100411,1}]\",\"power\":\"10000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"[{27,0,1000,1,500,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"雷电风卷技能伤害提升40%\",\"condition\":\"[{point,1,5},{pre_skill,70100411,1}]\",\"power\":\"20000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"[{27,0,1000,1,1000,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"雷电风卷技能伤害提升60%\",\"condition\":\"[{point,1,5},{pre_skill,70100411,1}]\",\"power\":\"30000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"[{27,0,1000,1,1500,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"雷电风卷技能伤害提升80%\",\"condition\":\"[{point,1,5},{pre_skill,70100411,1}]\",\"power\":\"40000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"[{27,0,1000,1,2000,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"雷电风卷技能伤害提升100%\",\"condition\":\"[{point,1,5},{pre_skill,70100411,1}]\",\"power\":\"50000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"[{27,0,1000,1,2500,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(70100521,'爆裂之弹','天赋技能',4,8,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'[]','[]',0,0,'[{\"desc\":\"激光制导技能伤害提升30%\",\"condition\":\"[{point,1,5},{pre_skill,70100421,1}]\",\"power\":\"10000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"[{27,0,1000,1,600,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"激光制导技能伤害提升60%\",\"condition\":\"[{point,1,5},{pre_skill,70100421,1}]\",\"power\":\"20000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"[{27,0,1000,1,1200,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"激光制导技能伤害提升90%\",\"condition\":\"[{point,1,5},{pre_skill,70100421,1}]\",\"power\":\"30000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"[{27,0,1000,1,1800,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"激光制导技能伤害提升120%\",\"condition\":\"[{point,1,5},{pre_skill,70100421,1}]\",\"power\":\"40000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"[{27,0,1000,1,2400,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"激光制导技能伤害提升150%\",\"condition\":\"[{point,1,5},{pre_skill,70100421,1}]\",\"power\":\"50000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"[{27,0,1000,1,3000,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(70100601,'血之獠牙','天赋技能',1,8,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'[]','[]',0,0,'[{\"desc\":\"斩空刃击吸血转化提升5%\",\"condition\":\"[{point,1,14},{pre_skill,70100501,2}]\",\"power\":\"10000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{114,0,1000,1,0,0.05,0,0,1,0}]\"},{\"desc\":\"斩空刃击吸血转化提升10%\",\"condition\":\"[{point,1,14},{pre_skill,70100501,2}]\",\"power\":\"20000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{114,0,1000,1,0,0.1,0,0,1,0}]\"},{\"desc\":\"斩空刃击吸血转化提升15%\",\"condition\":\"[{point,1,14},{pre_skill,70100501,2}]\",\"power\":\"30000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{114,0,1000,1,0,0.15,0,0,1,0}]\"},{\"desc\":\"斩空刃击吸血转化提升20%\",\"condition\":\"[{point,1,14},{pre_skill,70100501,2}]\",\"power\":\"40000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{114,0,1000,1,0,0.2,0,0,1,0}]\"},{\"desc\":\"斩空刃击吸血转化提升25%\",\"condition\":\"[{point,1,14},{pre_skill,70100501,2}]\",\"power\":\"50000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{114,0,1000,1,0,0.25,0,0,1,0}]\"}]'),(70100611,'眩晕之雷','天赋技能',2,8,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'[]','[]',0,0,'[{\"desc\":\"雷电风卷眩晕时长+0.2s\",\"condition\":\"[{point,1,14},{pre_skill,70100511,2}]\",\"power\":\"10000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{101,3,1000,2,0,0,0,200,0,1}]\"},{\"desc\":\"雷电风卷眩晕时长+0.4s\",\"condition\":\"[{point,1,14},{pre_skill,70100511,2}]\",\"power\":\"20000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{101,3,1000,2,0,0,0,400,0,1}]\"},{\"desc\":\"雷电风卷眩晕时长+0.6s\",\"condition\":\"[{point,1,14},{pre_skill,70100511,2}]\",\"power\":\"30000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{101,3,1000,2,0,0,0,600,0,1}]\"},{\"desc\":\"雷电风卷眩晕时长+0.8s\",\"condition\":\"[{point,1,14},{pre_skill,70100511,2}]\",\"power\":\"40000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{101,3,1000,2,0,0,0,800,0,1}]\"},{\"desc\":\"雷电风卷眩晕时长+0.10s\",\"condition\":\"[{point,1,14},{pre_skill,70100511,2}]\",\"power\":\"50000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{101,3,1000,2,0,0,0,1000,0,1}]\"}]'),(70100621,'撕裂之弹','天赋技能',4,8,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'[]','[]',0,0,'[{\"desc\":\"激光制导防御削弱3%\",\"condition\":\"[{point,1,14},{pre_skill,70100521,2}]\",\"power\":\"10000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,0,-0.03,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"激光制导防御削弱6%\",\"condition\":\"[{point,1,14},{pre_skill,70100521,2}]\",\"power\":\"20000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,0,-0.06,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"激光制导防御削弱9%\",\"condition\":\"[{point,1,14},{pre_skill,70100521,2}]\",\"power\":\"30000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,0,-0.09,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"激光制导防御削弱12%\",\"condition\":\"[{point,1,14},{pre_skill,70100521,2}]\",\"power\":\"40000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,0,-0.12,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"激光制导防御削弱15%\",\"condition\":\"[{point,1,14},{pre_skill,70100521,2}]\",\"power\":\"50000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"\",\"attr\":\"[{4,0,1000,2,0,-0.15,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(70100701,'背水一战','天赋技能',10,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'[]','[]',0,0,'[{\"desc\":\"自身血量低于25%时，增加自身5%的暴击值，持续5s，CD10s\",\"condition\":\"\",\"power\":\"12000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{3,1000,0,0,0,0.25,0,7}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,1,0,0.05,5000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"自身血量低于25%时，增加自身10%的暴击值，持续5s，CD10s\",\"condition\":\"\",\"power\":\"24000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{3,1000,0,0,0,0.25,0,7}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,1,0,0.1,5000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"自身血量低于25%时，增加自身15%的暴击值，持续5s，CD10s\",\"condition\":\"\",\"power\":\"36000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{3,1000,0,0,0,0.25,0,7}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,1,0,0.15,5000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"自身血量低于25%时，增加自身20%的暴击值，持续5s，CD10s\",\"condition\":\"\",\"power\":\"48000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{3,1000,0,0,0,0.25,0,7}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,1,0,0.2,5000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"自身血量低于25%时，增加自身25%的暴击值，持续5s，CD10s\",\"condition\":\"\",\"power\":\"60000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{3,1000,0,0,0,0.25,0,7}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,1,0,0.25,5000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"自身血量低于25%时，增加自身30%的暴击值，持续5s，CD10s\",\"condition\":\"\",\"power\":\"72000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{3,1000,0,0,0,0.25,0,7}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,1,0,0.3,5000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"自身血量低于25%时，增加自身35%的暴击值，持续5s，CD10s\",\"condition\":\"\",\"power\":\"84000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{3,1000,0,0,0,0.25,0,7}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,1,0,0.35,5000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"自身血量低于25%时，增加自身40%的暴击值，持续5s，CD10s\",\"condition\":\"\",\"power\":\"96000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{3,1000,0,0,0,0.25,0,7}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,1,0,0.4,5000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"自身血量低于25%时，增加自身45%的暴击值，持续5s，CD10s\",\"condition\":\"\",\"power\":\"108000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{3,1000,0,0,0,0.25,0,7}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,1,0,0.45,5000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"自身血量低于25%时，增加自身50%的暴击值，持续5s，CD10s\",\"condition\":\"\",\"power\":\"120000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{3,1000,0,0,0,0.25,0,7}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{7,0,1000,1,0,0.5,5000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(70100801,'越战越勇','天赋技能',10,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'[]','[]',0,0,'[{\"desc\":\"自身血量低于25%时，增加自身3%的攻击力，持续3s，CD10s\",\"condition\":\"[{point,1,5},{pre_skill,70100701,4}]\",\"power\":\"12000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{3,1000,0,0,0,0.25,0,1}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,1,0,0.03,3000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"自身血量低于25%时，增加自身6%的攻击力，持续3s，CD10s\",\"condition\":\"[{point,1,5},{pre_skill,70100701,4}]\",\"power\":\"24000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{3,1000,0,0,0,0.25,0,1}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,1,0,0.06,3000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"自身血量低于25%时，增加自身9%的攻击力，持续3s，CD10s\",\"condition\":\"[{point,1,5},{pre_skill,70100701,4}]\",\"power\":\"36000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{3,1000,0,0,0,0.25,0,1}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,1,0,0.09,3000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"自身血量低于25%时，增加自身12%的攻击力，持续3s，CD10s\",\"condition\":\"[{point,1,5},{pre_skill,70100701,4}]\",\"power\":\"48000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{3,1000,0,0,0,0.25,0,1}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,1,0,0.12,3000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"自身血量低于25%时，增加自身15%的攻击力，持续3s，CD10s\",\"condition\":\"[{point,1,5},{pre_skill,70100701,4}]\",\"power\":\"60000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{3,1000,0,0,0,0.25,0,1}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,1,0,0.15,3000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"自身血量低于25%时，增加自身18%的攻击力，持续3s，CD10s\",\"condition\":\"[{point,1,5},{pre_skill,70100701,4}]\",\"power\":\"72000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{3,1000,0,0,0,0.25,0,1}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,1,0,0.18,3000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"自身血量低于25%时，增加自身21%的攻击力，持续3s，CD10s\",\"condition\":\"[{point,1,5},{pre_skill,70100701,4}]\",\"power\":\"84000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{3,1000,0,0,0,0.25,0,1}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,1,0,0.21,3000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"自身血量低于25%时，增加自身24%的攻击力，持续3s，CD10s\",\"condition\":\"[{point,1,5},{pre_skill,70100701,4}]\",\"power\":\"96000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{3,1000,0,0,0,0.25,0,1}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,1,0,0.24,3000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"自身血量低于25%时，增加自身27%的攻击力，持续3s，CD10s\",\"condition\":\"[{point,1,5},{pre_skill,70100701,4}]\",\"power\":\"108000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{3,1000,0,0,0,0.25,0,1}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,1,0,0.27,3000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"自身血量低于25%时，增加自身30%的攻击力，持续3s，CD10s\",\"condition\":\"[{point,1,5},{pre_skill,70100701,4}]\",\"power\":\"120000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{3,1000,0,0,0,0.25,0,1}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{1,0,1000,1,0,0.3,3000,1,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(70100901,'喋血暴击','天赋技能',10,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'[]','[]',0,0,'[{\"desc\":\"造成暴击时，有5%概率造成持续3s的每秒2.5%最大生命值的流血效果，CD20s\",\"condition\":\"[{point,1,14},{pre_skill,70100801,4}]\",\"power\":\"12000\",\"base_attr\":\"[]\",\"cd\":\"20000\",\"trigger\":\"[{4,1000,0,3,0,0,0,117}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{117,0,50,2,0,0.025,2,3000,3,0}]\"},{\"desc\":\"造成暴击时，有10%概率造成持续3s的每秒2.5%最大生命值的流血效果，CD20s\",\"condition\":\"[{point,1,14},{pre_skill,70100801,4}]\",\"power\":\"24000\",\"base_attr\":\"[]\",\"cd\":\"20000\",\"trigger\":\"[{4,1000,0,3,0,0,0,117}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{117,0,100,2,0,0.025,2,3000,3,0}]\"},{\"desc\":\"造成暴击时，有15%概率造成持续3s的每秒2.5%最大生命值的流血效果，CD20s\",\"condition\":\"[{point,1,14},{pre_skill,70100801,4}]\",\"power\":\"36000\",\"base_attr\":\"[]\",\"cd\":\"20000\",\"trigger\":\"[{4,1000,0,3,0,0,0,117}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{117,0,150,2,0,0.025,2,3000,3,0}]\"},{\"desc\":\"造成暴击时，有20%概率造成持续3s的每秒2.5%最大生命值的流血效果，CD20s\",\"condition\":\"[{point,1,14},{pre_skill,70100801,4}]\",\"power\":\"48000\",\"base_attr\":\"[]\",\"cd\":\"20000\",\"trigger\":\"[{4,1000,0,3,0,0,0,117}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{117,0,200,2,0,0.025,2,3000,3,0}]\"},{\"desc\":\"造成暴击时，有25%概率造成持续3s的每秒2.5%最大生命值的流血效果，CD20s\",\"condition\":\"[{point,1,14},{pre_skill,70100801,4}]\",\"power\":\"60000\",\"base_attr\":\"[]\",\"cd\":\"20000\",\"trigger\":\"[{4,1000,0,3,0,0,0,117}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{117,0,250,2,0,0.025,2,3000,3,0}]\"},{\"desc\":\"造成暴击时，有30%概率造成持续3s的每秒2.5%最大生命值的流血效果，CD20s\",\"condition\":\"[{point,1,14},{pre_skill,70100801,4}]\",\"power\":\"72000\",\"base_attr\":\"[]\",\"cd\":\"20000\",\"trigger\":\"[{4,1000,0,3,0,0,0,117}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{117,0,300,2,0,0.025,2,3000,3,0}]\"},{\"desc\":\"造成暴击时，有35%概率造成持续3s的每秒2.5%最大生命值的流血效果，CD20s\",\"condition\":\"[{point,1,14},{pre_skill,70100801,4}]\",\"power\":\"84000\",\"base_attr\":\"[]\",\"cd\":\"20000\",\"trigger\":\"[{4,1000,0,3,0,0,0,117}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{117,0,350,2,0,0.025,2,3000,3,0}]\"},{\"desc\":\"造成暴击时，有40%概率造成持续3s的每秒2.5%最大生命值的流血效果，CD20s\",\"condition\":\"[{point,1,14},{pre_skill,70100801,4}]\",\"power\":\"96000\",\"base_attr\":\"[]\",\"cd\":\"20000\",\"trigger\":\"[{4,1000,0,3,0,0,0,117}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{117,0,400,2,0,0.025,2,3000,3,0}]\"},{\"desc\":\"造成暴击时，有45%概率造成持续3s的每秒2.5%最大生命值的流血效果，CD20s\",\"condition\":\"[{point,1,14},{pre_skill,70100801,4}]\",\"power\":\"108000\",\"base_attr\":\"[]\",\"cd\":\"20000\",\"trigger\":\"[{4,1000,0,3,0,0,0,117}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{117,0,450,2,0,0.025,2,3000,3,0}]\"},{\"desc\":\"造成暴击时，有50%概率造成持续3s的每秒2.5%最大生命值的流血效果，CD20s\",\"condition\":\"[{point,1,14},{pre_skill,70100801,4}]\",\"power\":\"120000\",\"base_attr\":\"[]\",\"cd\":\"20000\",\"trigger\":\"[{4,1000,0,3,0,0,0,117}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{117,0,500,2,0,0.025,2,3000,3,0}]\"}]'),(70101001,'全面出击','天赋技能',10,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'[]','[]',0,0,'[{\"desc\":\"造成会心伤害时，有15%概率眩晕目标1.5s，CD10s\",\"condition\":\"[{point,1,22},{pre_skill,70100901,4}]\",\"power\":\"30000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{9,1000,0,3,0,0,[4],101}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{101,3,150,2,0,0,0,1500,0,1}]\"},{\"desc\":\"造成会心伤害时，有30%概率眩晕目标1.5s，CD10s\",\"condition\":\"[{point,1,22},{pre_skill,70100901,4}]\",\"power\":\"60000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{9,1000,0,3,0,0,[4],101}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{101,3,300,2,0,0,0,1500,0,1}]\"},{\"desc\":\"造成会心伤害时，有45%概率眩晕目标1.5s，CD10s\",\"condition\":\"[{point,1,22},{pre_skill,70100901,4}]\",\"power\":\"90000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{9,1000,0,3,0,0,[4],101}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{101,3,450,2,0,0,0,1500,0,1}]\"},{\"desc\":\"造成会心伤害时，有60%概率眩晕目标1.5s，CD10s\",\"condition\":\"[{point,1,22},{pre_skill,70100901,4}]\",\"power\":\"120000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{9,1000,0,3,0,0,[4],101}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{101,3,600,2,0,0,0,1500,0,1}]\"},{\"desc\":\"造成会心伤害时，有75%概率眩晕目标1.5s，CD10s\",\"condition\":\"[{point,1,22},{pre_skill,70100901,4}]\",\"power\":\"150000\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[{9,1000,0,3,0,0,[4],101}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{101,3,750,2,0,0,0,1500,0,1}]\"}]'),(70101101,'战意盎然','天赋技能',10,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'[]','[]',0,0,'[{\"desc\":\"自身血量低于25%时，增加自身2%的致命几率\",\"condition\":\"[{point,1,22},{pre_skill,70100901,4}]\",\"power\":\"30000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[{3,1000,0,0,0,0.25,0,55}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{55,0,1000,1,20,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"自身血量低于25%时，增加自身4%的致命几率\",\"condition\":\"[{point,1,22},{pre_skill,70100901,4}]\",\"power\":\"60000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[{3,1000,0,0,0,0.25,0,55}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{55,0,1000,1,40,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"自身血量低于25%时，增加自身6%的致命几率\",\"condition\":\"[{point,1,22},{pre_skill,70100901,4}]\",\"power\":\"90000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[{3,1000,0,0,0,0.25,0,55}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{55,0,1000,1,60,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"自身血量低于25%时，增加自身8%的致命几率\",\"condition\":\"[{point,1,22},{pre_skill,70100901,4}]\",\"power\":\"120000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[{3,1000,0,0,0,0.25,0,55}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{55,0,1000,1,80,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"自身血量低于25%时，增加自身10%的致命几率\",\"condition\":\"[{point,1,22},{pre_skill,70100901,4}]\",\"power\":\"150000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[{3,1000,0,0,0,0.25,0,55}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{55,0,1000,1,100,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(70200101,'守护之光','天赋技能',10,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'[]','[]',0,0,'[{\"desc\":\"生命+8000，坚韧+150\",\"condition\":\"[{point,1,28}]\",\"power\":\"\",\"base_attr\":\"[{0,2,8000},{0,8,150}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"生命+16000，坚韧+300\",\"condition\":\"[{point,1,28}]\",\"power\":\"\",\"base_attr\":\"[{0,2,16000},{0,8,300}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"生命+24000，坚韧+450\",\"condition\":\"[{point,1,28}]\",\"power\":\"\",\"base_attr\":\"[{0,2,24000},{0,8,450}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"生命+32000，坚韧+600\",\"condition\":\"[{point,1,28}]\",\"power\":\"\",\"base_attr\":\"[{0,2,32000},{0,8,600}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"生命+40000，坚韧+750\",\"condition\":\"[{point,1,28}]\",\"power\":\"\",\"base_attr\":\"[{0,2,40000},{0,8,750}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"生命+48000，坚韧+900\",\"condition\":\"[{point,1,28}]\",\"power\":\"\",\"base_attr\":\"[{0,2,48000},{0,8,900}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"生命+56000，坚韧+1050\",\"condition\":\"[{point,1,28}]\",\"power\":\"\",\"base_attr\":\"[{0,2,56000},{0,8,1050}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"生命+64000，坚韧+1200\",\"condition\":\"[{point,1,28}]\",\"power\":\"\",\"base_attr\":\"[{0,2,64000},{0,8,1200}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"生命+72000，坚韧+1350\",\"condition\":\"[{point,1,28}]\",\"power\":\"\",\"base_attr\":\"[{0,2,72000},{0,8,1350}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"生命+80000，坚韧+1500\",\"condition\":\"[{point,1,28}]\",\"power\":\"\",\"base_attr\":\"[{0,2,80000},{0,8,1500}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(70200201,'克敌制胜','天赋技能',10,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'[]','[]',0,0,'[{\"desc\":\"每次受到攻击，有10%的几率减少5%伤害\",\"condition\":\"[{point,2,8},{pre_skill,70200101,4}]\",\"power\":\"12500\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,2,0,0,0,10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,100,1,500,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"每次受到攻击，有10%的几率减少10%伤害\",\"condition\":\"[{point,2,8},{pre_skill,70200101,4}]\",\"power\":\"25000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,2,0,0,0,10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,100,1,1000,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"每次受到攻击，有10%的几率减少15%伤害\",\"condition\":\"[{point,2,8},{pre_skill,70200101,4}]\",\"power\":\"37500\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,2,0,0,0,10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,100,1,1500,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"每次受到攻击，有10%的几率减少20%伤害\",\"condition\":\"[{point,2,8},{pre_skill,70200101,4}]\",\"power\":\"50000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,2,0,0,0,10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,100,1,2000,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"每次受到攻击，有10%的几率减少25%伤害\",\"condition\":\"[{point,2,8},{pre_skill,70200101,4}]\",\"power\":\"62500\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,2,0,0,0,10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,100,1,2500,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"每次受到攻击，有10%的几率减少30%伤害\",\"condition\":\"[{point,2,8},{pre_skill,70200101,4}]\",\"power\":\"75000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,2,0,0,0,10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,100,1,3000,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"每次受到攻击，有10%的几率减少35%伤害\",\"condition\":\"[{point,2,8},{pre_skill,70200101,4}]\",\"power\":\"87500\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,2,0,0,0,10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,100,1,3500,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"每次受到攻击，有10%的几率减少40%伤害\",\"condition\":\"[{point,2,8},{pre_skill,70200101,4}]\",\"power\":\"100000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,2,0,0,0,10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,100,1,4000,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"每次受到攻击，有10%的几率减少45%伤害\",\"condition\":\"[{point,2,8},{pre_skill,70200101,4}]\",\"power\":\"112500\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,2,0,0,0,10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,100,1,4500,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"每次受到攻击，有10%的几率减少50%伤害\",\"condition\":\"[{point,2,8},{pre_skill,70200101,4}]\",\"power\":\"125000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,2,0,0,0,10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"[{10,0,100,1,5000,0,0,1,0}]\",\"hurt\":\"\",\"effect\":\"\"}]'),(70200301,'守护之盾','天赋技能',10,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'[]','[]',0,0,'[{\"desc\":\"防御+200，闪避+150\",\"condition\":\"[{point,1,28}]\",\"power\":\"\",\"base_attr\":\"[{0,4,200},{0,6,150}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"防御+400，闪避+300\",\"condition\":\"[{point,1,28}]\",\"power\":\"\",\"base_attr\":\"[{0,4,400},{0,6,300}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"防御+600，闪避+450\",\"condition\":\"[{point,1,28}]\",\"power\":\"\",\"base_attr\":\"[{0,4,600},{0,6,450}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"防御+800，闪避+600\",\"condition\":\"[{point,1,28}]\",\"power\":\"\",\"base_attr\":\"[{0,4,800},{0,6,600}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"防御+1000，闪避+750\",\"condition\":\"[{point,1,28}]\",\"power\":\"\",\"base_attr\":\"[{0,4,1000},{0,6,750}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"防御+1200，闪避+900\",\"condition\":\"[{point,1,28}]\",\"power\":\"\",\"base_attr\":\"[{0,4,1200},{0,6,900}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"防御+1400，闪避+1050\",\"condition\":\"[{point,1,28}]\",\"power\":\"\",\"base_attr\":\"[{0,4,1400},{0,6,1050}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"防御+1600，闪避+1200\",\"condition\":\"[{point,1,28}]\",\"power\":\"\",\"base_attr\":\"[{0,4,1600},{0,6,1200}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"防御+1800，闪避+1350\",\"condition\":\"[{point,1,28}]\",\"power\":\"\",\"base_attr\":\"[{0,4,1800},{0,6,1350}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"防御+2000，闪避+1500\",\"condition\":\"[{point,1,28}]\",\"power\":\"\",\"base_attr\":\"[{0,4,2000},{0,6,1500}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(70200401,'生命之光','天赋技能',10,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'[]','[]',0,0,'[{\"desc\":\"血量低于20%时，有10%几率增加一个最大生命值5%的护盾，持续2s，CD30s\",\"condition\":\"[{point,2,30},{pre_skill,70200601,4}]\",\"power\":\"30000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[{3,1000,0,0,0,0.2,0,104}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{104,0,100,1,0,0.05,2,2000,0,0}]\"},{\"desc\":\"血量低于20%时，有10%几率增加一个最大生命值10%的护盾，持续2s，CD30s\",\"condition\":\"[{point,2,30},{pre_skill,70200601,4}]\",\"power\":\"60000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[{3,1000,0,0,0,0.2,0,104}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{104,0,100,1,0,0.1,2,2000,0,0}]\"},{\"desc\":\"血量低于20%时，有10%几率增加一个最大生命值15%的护盾，持续2s，CD30s\",\"condition\":\"[{point,2,30},{pre_skill,70200601,4}]\",\"power\":\"90000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[{3,1000,0,0,0,0.2,0,104}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{104,0,100,1,0,0.15,2,2000,0,0}]\"},{\"desc\":\"血量低于20%时，有10%几率增加一个最大生命值20%的护盾，持续2s，CD30s\",\"condition\":\"[{point,2,30},{pre_skill,70200601,4}]\",\"power\":\"120000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[{3,1000,0,0,0,0.2,0,104}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{104,0,100,1,0,0.2,2,2000,0,0}]\"},{\"desc\":\"血量低于20%时，有10%几率增加一个最大生命值25%的护盾，持续2s，CD30s\",\"condition\":\"[{point,2,30},{pre_skill,70200601,4}]\",\"power\":\"150000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[{3,1000,0,0,0,0.2,0,104}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{104,0,100,1,0,0.25,2,2000,0,0}]\"}]'),(70200501,'全面守护','天赋技能',10,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'[]','[]',0,0,'[{\"desc\":\"伤害减免+1%\",\"condition\":\"[{point,2,8},{pre_skill,70200301,4}]\",\"power\":\"\",\"base_attr\":\"[{0,10,100}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"伤害减免+2%\",\"condition\":\"[{point,2,8},{pre_skill,70200301,4}]\",\"power\":\"\",\"base_attr\":\"[{0,10,200}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"伤害减免+3%\",\"condition\":\"[{point,2,8},{pre_skill,70200301,4}]\",\"power\":\"\",\"base_attr\":\"[{0,10,300}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"伤害减免+4%\",\"condition\":\"[{point,2,8},{pre_skill,70200301,4}]\",\"power\":\"\",\"base_attr\":\"[{0,10,400}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"伤害减免+5%\",\"condition\":\"[{point,2,8},{pre_skill,70200301,4}]\",\"power\":\"\",\"base_attr\":\"[{0,10,500}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"伤害减免+6%\",\"condition\":\"[{point,2,8},{pre_skill,70200301,4}]\",\"power\":\"\",\"base_attr\":\"[{0,10,600}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"伤害减免+7%\",\"condition\":\"[{point,2,8},{pre_skill,70200301,4}]\",\"power\":\"\",\"base_attr\":\"[{0,10,700}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"伤害减免+8%\",\"condition\":\"[{point,2,8},{pre_skill,70200301,4}]\",\"power\":\"\",\"base_attr\":\"[{0,10,800}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"伤害减免+9%\",\"condition\":\"[{point,2,8},{pre_skill,70200301,4}]\",\"power\":\"\",\"base_attr\":\"[{0,10,900}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"伤害减免+10%\",\"condition\":\"[{point,2,8},{pre_skill,70200301,4}]\",\"power\":\"\",\"base_attr\":\"[{0,10,1000}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(70200601,'尖刺防御','天赋技能',10,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'[]','[]',0,0,'[{\"desc\":\"技能减免+1%\",\"condition\":\"[{point,2,20},{pre_skill,70200201,4}]\",\"power\":\"\",\"base_attr\":\"[{0,28,100}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"技能减免+2%\",\"condition\":\"[{point,2,20},{pre_skill,70200201,4}]\",\"power\":\"\",\"base_attr\":\"[{0,28,200}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"技能减免+3%\",\"condition\":\"[{point,2,20},{pre_skill,70200201,4}]\",\"power\":\"\",\"base_attr\":\"[{0,28,300}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"技能减免+4%\",\"condition\":\"[{point,2,20},{pre_skill,70200201,4}]\",\"power\":\"\",\"base_attr\":\"[{0,28,400}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"技能减免+5%\",\"condition\":\"[{point,2,20},{pre_skill,70200201,4}]\",\"power\":\"\",\"base_attr\":\"[{0,28,500}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"技能减免+6%\",\"condition\":\"[{point,2,20},{pre_skill,70200201,4}]\",\"power\":\"\",\"base_attr\":\"[{0,28,600}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"技能减免+7%\",\"condition\":\"[{point,2,20},{pre_skill,70200201,4}]\",\"power\":\"\",\"base_attr\":\"[{0,28,700}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"技能减免+8%\",\"condition\":\"[{point,2,20},{pre_skill,70200201,4}]\",\"power\":\"\",\"base_attr\":\"[{0,28,800}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"技能减免+9%\",\"condition\":\"[{point,2,20},{pre_skill,70200201,4}]\",\"power\":\"\",\"base_attr\":\"[{0,28,900}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"技能减免+10%\",\"condition\":\"[{point,2,20},{pre_skill,70200201,4}]\",\"power\":\"\",\"base_attr\":\"[{0,28,1000}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(70200701,'迅捷之力','天赋技能',10,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'[]','[]',0,0,'[{\"desc\":\"闪避率+2%\",\"condition\":\"[{point,2,20},{pre_skill,70200901,4}]\",\"power\":\"\",\"base_attr\":\"[{0,12,200}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"闪避率+4%\",\"condition\":\"[{point,2,20},{pre_skill,70200901,4}]\",\"power\":\"\",\"base_attr\":\"[{0,12,400}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"闪避率+6%\",\"condition\":\"[{point,2,20},{pre_skill,70200901,4}]\",\"power\":\"\",\"base_attr\":\"[{0,12,600}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"闪避率+8%\",\"condition\":\"[{point,2,20},{pre_skill,70200901,4}]\",\"power\":\"\",\"base_attr\":\"[{0,12,800}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"闪避率+10%\",\"condition\":\"[{point,2,20},{pre_skill,70200901,4}]\",\"power\":\"\",\"base_attr\":\"[{0,12,1000}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(70200801,'不屈不挠','天赋技能',10,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'[]','[]',0,0,'[{\"desc\":\"抗暴值+500\",\"condition\":\"[{point,2,20},{pre_skill,70200501,4}]\",\"power\":\"\",\"base_attr\":\"[{0,49,500}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"抗暴值+1000\",\"condition\":\"[{point,2,20},{pre_skill,70200501,4}]\",\"power\":\"\",\"base_attr\":\"[{0,49,1000}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"抗暴值+1500\",\"condition\":\"[{point,2,20},{pre_skill,70200501,4}]\",\"power\":\"\",\"base_attr\":\"[{0,49,1500}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"抗暴值+2000\",\"condition\":\"[{point,2,20},{pre_skill,70200501,4}]\",\"power\":\"\",\"base_attr\":\"[{0,49,2000}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"抗暴值+2500\",\"condition\":\"[{point,2,20},{pre_skill,70200501,4}]\",\"power\":\"\",\"base_attr\":\"[{0,49,2500}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"抗暴值+3000\",\"condition\":\"[{point,2,20},{pre_skill,70200501,4}]\",\"power\":\"\",\"base_attr\":\"[{0,49,3000}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"抗暴值+3500\",\"condition\":\"[{point,2,20},{pre_skill,70200501,4}]\",\"power\":\"\",\"base_attr\":\"[{0,49,3500}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"抗暴值+4000\",\"condition\":\"[{point,2,20},{pre_skill,70200501,4}]\",\"power\":\"\",\"base_attr\":\"[{0,49,4000}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"抗暴值+4500\",\"condition\":\"[{point,2,20},{pre_skill,70200501,4}]\",\"power\":\"\",\"base_attr\":\"[{0,49,4500}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"抗暴值+5000\",\"condition\":\"[{point,2,20},{pre_skill,70200501,4}]\",\"power\":\"\",\"base_attr\":\"[{0,49,5000}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(70200901,'和平使者','天赋技能',10,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'[]','[]',0,0,'[{\"desc\":\"pvp伤害减免+1%\",\"condition\":\"[{point,2,8}]\",\"power\":\"\",\"base_attr\":\"[{0,231,100}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"pvp伤害减免+2%\",\"condition\":\"[{point,2,8}]\",\"power\":\"\",\"base_attr\":\"[{0,231,200}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"pvp伤害减免+3%\",\"condition\":\"[{point,2,8}]\",\"power\":\"\",\"base_attr\":\"[{0,231,300}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"pvp伤害减免+4%\",\"condition\":\"[{point,2,8}]\",\"power\":\"\",\"base_attr\":\"[{0,231,400}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"pvp伤害减免+5%\",\"condition\":\"[{point,2,8}]\",\"power\":\"\",\"base_attr\":\"[{0,231,500}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"pvp伤害减免+6%\",\"condition\":\"[{point,2,8}]\",\"power\":\"\",\"base_attr\":\"[{0,231,600}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"pvp伤害减免+7%\",\"condition\":\"[{point,2,8}]\",\"power\":\"\",\"base_attr\":\"[{0,231,700}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"pvp伤害减免+8%\",\"condition\":\"[{point,2,8}]\",\"power\":\"\",\"base_attr\":\"[{0,231,800}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"pvp伤害减免+9%\",\"condition\":\"[{point,2,8}]\",\"power\":\"\",\"base_attr\":\"[{0,231,900}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"pvp伤害减免+10%\",\"condition\":\"[{point,2,8}]\",\"power\":\"\",\"base_attr\":\"[{0,231,1000}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(70201001,'防御大师','天赋技能',1,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'[]','[]',0,0,'[{\"desc\":\"第4下普攻有5%概率触发免伤护盾，免疫下次伤害，CD30s\",\"condition\":\"[{point,2,30},{pre_skill,70200701,2}]\",\"power\":\"30000\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[{10,1000,0,3,0,0,10011004,105}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{105,0,50,1,0,0,0,0,1,0}]\"},{\"desc\":\"第4下普攻有10%概率触发免伤护盾，免疫下次伤害，CD30s\",\"condition\":\"[{point,2,30},{pre_skill,70200701,2}]\",\"power\":\"60000\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[{10,1000,0,3,0,0,10011004,105}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{105,0,100,1,0,0,0,0,1,0}]\"},{\"desc\":\"第4下普攻有15%概率触发免伤护盾，免疫下次伤害，CD30s\",\"condition\":\"[{point,2,30},{pre_skill,70200701,2}]\",\"power\":\"90000\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[{10,1000,0,3,0,0,10011004,105}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{105,0,150,1,0,0,0,0,1,0}]\"},{\"desc\":\"第4下普攻有20%概率触发免伤护盾，免疫下次伤害，CD30s\",\"condition\":\"[{point,2,30},{pre_skill,70200701,2}]\",\"power\":\"120000\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[{10,1000,0,3,0,0,10011004,105}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{105,0,200,1,0,0,0,0,1,0}]\"},{\"desc\":\"第4下普攻有25%概率触发免伤护盾，免疫下次伤害，CD30s\",\"condition\":\"[{point,2,30},{pre_skill,70200701,2}]\",\"power\":\"150000\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[{10,1000,0,3,0,0,10011004,105}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{105,0,250,1,0,0,0,0,1,0}]\"}]'),(70201011,'防御大师','天赋技能',2,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'[]','[]',0,0,'[{\"desc\":\"第4下普攻有5%概率触发免伤护盾，免疫下次伤害，CD30s\",\"condition\":\"[{point,2,30},{pre_skill,70200701,2}]\",\"power\":\"30000\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[{10,1000,0,3,0,0,10012004,105}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{105,0,50,1,0,0,0,0,1,0}]\"},{\"desc\":\"第4下普攻有10%概率触发免伤护盾，免疫下次伤害，CD30s\",\"condition\":\"[{point,2,30},{pre_skill,70200701,2}]\",\"power\":\"60000\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[{10,1000,0,3,0,0,10012004,105}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{105,0,100,1,0,0,0,0,1,0}]\"},{\"desc\":\"第4下普攻有15%概率触发免伤护盾，免疫下次伤害，CD30s\",\"condition\":\"[{point,2,30},{pre_skill,70200701,2}]\",\"power\":\"90000\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[{10,1000,0,3,0,0,10012004,105}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{105,0,150,1,0,0,0,0,1,0}]\"},{\"desc\":\"第4下普攻有20%概率触发免伤护盾，免疫下次伤害，CD30s\",\"condition\":\"[{point,2,30},{pre_skill,70200701,2}]\",\"power\":\"120000\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[{10,1000,0,3,0,0,10012004,105}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{105,0,200,1,0,0,0,0,1,0}]\"},{\"desc\":\"第4下普攻有25%概率触发免伤护盾，免疫下次伤害，CD30s\",\"condition\":\"[{point,2,30},{pre_skill,70200701,2}]\",\"power\":\"150000\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[{10,1000,0,3,0,0,10012004,105}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{105,0,250,1,0,0,0,0,1,0}]\"}]'),(70201021,'防御大师','天赋技能',4,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'[]','[]',0,0,'[{\"desc\":\"第4下普攻有5%概率触发免伤护盾，免疫下次伤害，CD30s\",\"condition\":\"[{point,2,30},{pre_skill,70200701,2}]\",\"power\":\"30000\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[{10,1000,0,3,0,0,10013004,105}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{105,0,50,1,0,0,0,0,1,0}]\"},{\"desc\":\"第4下普攻有10%概率触发免伤护盾，免疫下次伤害，CD30s\",\"condition\":\"[{point,2,30},{pre_skill,70200701,2}]\",\"power\":\"60000\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[{10,1000,0,3,0,0,10013004,105}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{105,0,100,1,0,0,0,0,1,0}]\"},{\"desc\":\"第4下普攻有15%概率触发免伤护盾，免疫下次伤害，CD30s\",\"condition\":\"[{point,2,30},{pre_skill,70200701,2}]\",\"power\":\"90000\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[{10,1000,0,3,0,0,10013004,105}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{105,0,150,1,0,0,0,0,1,0}]\"},{\"desc\":\"第4下普攻有20%概率触发免伤护盾，免疫下次伤害，CD30s\",\"condition\":\"[{point,2,30},{pre_skill,70200701,2}]\",\"power\":\"120000\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[{10,1000,0,3,0,0,10013004,105}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{105,0,200,1,0,0,0,0,1,0}]\"},{\"desc\":\"第4下普攻有25%概率触发免伤护盾，免疫下次伤害，CD30s\",\"condition\":\"[{point,2,30},{pre_skill,70200701,2}]\",\"power\":\"150000\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[{10,1000,0,3,0,0,10013004,105}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{105,0,250,1,0,0,0,0,1,0}]\"}]'),(70201101,'绝地反击','天赋技能',10,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'[]','[]',0,0,'[{\"desc\":\"受到致死伤害时，有5%概率恢复20%最大血量，CD60s\",\"condition\":\"[{point,2,30},{pre_skill,70200801,4}]\",\"power\":\"30000\",\"base_attr\":\"[]\",\"cd\":\"60000\",\"trigger\":\"[{6,1000,0,4,0,0,0,116}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,0,50,1,0,0.2,2,0,1,0}]\"},{\"desc\":\"受到致死伤害时，有10%概率恢复20%最大血量，CD60s\",\"condition\":\"[{point,2,30},{pre_skill,70200801,4}]\",\"power\":\"60000\",\"base_attr\":\"[]\",\"cd\":\"60000\",\"trigger\":\"[{6,1000,0,4,0,0,0,116}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,0,100,1,0,0.2,2,0,1,0}]\"},{\"desc\":\"受到致死伤害时，有15%概率恢复20%最大血量，CD60s\",\"condition\":\"[{point,2,30},{pre_skill,70200801,4}]\",\"power\":\"90000\",\"base_attr\":\"[]\",\"cd\":\"60000\",\"trigger\":\"[{6,1000,0,4,0,0,0,116}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,0,150,1,0,0.2,2,0,1,0}]\"},{\"desc\":\"受到致死伤害时，有20%概率恢复20%最大血量，CD60s\",\"condition\":\"[{point,2,30},{pre_skill,70200801,4}]\",\"power\":\"120000\",\"base_attr\":\"[]\",\"cd\":\"60000\",\"trigger\":\"[{6,1000,0,4,0,0,0,116}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,0,200,1,0,0.2,2,0,1,0}]\"},{\"desc\":\"受到致死伤害时，有25%概率恢复20%最大血量，CD60s\",\"condition\":\"[{point,2,30},{pre_skill,70200801,4}]\",\"power\":\"150000\",\"base_attr\":\"[]\",\"cd\":\"60000\",\"trigger\":\"[{6,1000,0,4,0,0,0,116}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,0,250,1,0,0.2,2,0,1,0}]\"}]'),(70300101,'战神之力','天赋技能',10,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'[]','[]',0,0,'[{\"desc\":\"攻击+400，暴击+150\",\"condition\":\"[{point,2,40}]\",\"power\":\"\",\"base_attr\":\"[{0,1,400},{0,7,150}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击+800，暴击+300\",\"condition\":\"[{point,2,40}]\",\"power\":\"\",\"base_attr\":\"[{0,1,800},{0,7,300}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击+1200，暴击+450\",\"condition\":\"[{point,2,40}]\",\"power\":\"\",\"base_attr\":\"[{0,1,1200},{0,7,450}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击+1600，暴击+600\",\"condition\":\"[{point,2,40}]\",\"power\":\"\",\"base_attr\":\"[{0,1,1600},{0,7,600}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击+2000，暴击+750\",\"condition\":\"[{point,2,40}]\",\"power\":\"\",\"base_attr\":\"[{0,1,2000},{0,7,750}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击+2400，暴击+900\",\"condition\":\"[{point,2,40}]\",\"power\":\"\",\"base_attr\":\"[{0,1,2400},{0,7,900}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击+2800，暴击+1050\",\"condition\":\"[{point,2,40}]\",\"power\":\"\",\"base_attr\":\"[{0,1,2800},{0,7,1050}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击+3200，暴击+1200\",\"condition\":\"[{point,2,40}]\",\"power\":\"\",\"base_attr\":\"[{0,1,3200},{0,7,1200}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击+3600，暴击+1350\",\"condition\":\"[{point,2,40}]\",\"power\":\"\",\"base_attr\":\"[{0,1,3600},{0,7,1350}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"攻击+4000，暴击+1500\",\"condition\":\"[{point,2,40}]\",\"power\":\"\",\"base_attr\":\"[{0,1,4000},{0,7,1500}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(70300201,'星灵守护','天赋技能',10,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'[]','[]',0,0,'[{\"desc\":\"星灵基础属性提升1%\",\"condition\":\"[{point,2,40}]\",\"power\":\"\",\"base_attr\":\"[{430,68,100}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵基础属性提升2%\",\"condition\":\"[{point,2,40}]\",\"power\":\"\",\"base_attr\":\"[{430,68,200}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵基础属性提升3%\",\"condition\":\"[{point,2,40}]\",\"power\":\"\",\"base_attr\":\"[{430,68,300}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵基础属性提升4%\",\"condition\":\"[{point,2,40}]\",\"power\":\"\",\"base_attr\":\"[{430,68,400}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵基础属性提升5%\",\"condition\":\"[{point,2,40}]\",\"power\":\"\",\"base_attr\":\"[{430,68,500}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵基础属性提升6%\",\"condition\":\"[{point,2,40}]\",\"power\":\"\",\"base_attr\":\"[{430,68,600}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵基础属性提升7%\",\"condition\":\"[{point,2,40}]\",\"power\":\"\",\"base_attr\":\"[{430,68,700}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵基础属性提升8%\",\"condition\":\"[{point,2,40}]\",\"power\":\"\",\"base_attr\":\"[{430,68,800}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵基础属性提升9%\",\"condition\":\"[{point,2,40}]\",\"power\":\"\",\"base_attr\":\"[{430,68,900}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"星灵基础属性提升10%\",\"condition\":\"[{point,2,40}]\",\"power\":\"\",\"base_attr\":\"[{430,68,1000}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(70300301,'破灭之力','天赋技能',10,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'[]','[]',0,0,'[{\"desc\":\"破甲+200，命中+150\",\"condition\":\"[{point,2,40}]\",\"power\":\"\",\"base_attr\":\"[{0,2,200},{0,5,200}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"破甲+400，命中+300\",\"condition\":\"[{point,2,40}]\",\"power\":\"\",\"base_attr\":\"[{0,2,400},{0,5,400}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"破甲+600，命中+450\",\"condition\":\"[{point,2,40}]\",\"power\":\"\",\"base_attr\":\"[{0,2,600},{0,5,600}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"破甲+800，命中+600\",\"condition\":\"[{point,2,40}]\",\"power\":\"\",\"base_attr\":\"[{0,2,800},{0,5,800}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"破甲+1000，命中+750\",\"condition\":\"[{point,2,40}]\",\"power\":\"\",\"base_attr\":\"[{0,2,1000},{0,5,1000}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"破甲+1200，命中+900\",\"condition\":\"[{point,2,40}]\",\"power\":\"\",\"base_attr\":\"[{0,2,1200},{0,5,1200}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"破甲+1400，命中+1050\",\"condition\":\"[{point,2,40}]\",\"power\":\"\",\"base_attr\":\"[{0,2,1400},{0,5,1400}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"破甲+1600，命中+1200\",\"condition\":\"[{point,2,40}]\",\"power\":\"\",\"base_attr\":\"[{0,2,1600},{0,5,1600}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"破甲+1800，命中+1350\",\"condition\":\"[{point,2,40}]\",\"power\":\"\",\"base_attr\":\"[{0,2,1800},{0,5,1800}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"破甲+2000，命中+1500\",\"condition\":\"[{point,2,40}]\",\"power\":\"\",\"base_attr\":\"[{0,2,2000},{0,5,2000}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(70300401,'战骑统帅','天赋技能',10,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'[]','[]',0,0,'[{\"desc\":\"坐骑基础属性提升1%\",\"condition\":\"[{point,3,12},{pre_skill,70300201,4}]\",\"power\":\"\",\"base_attr\":\"[{160,68,100}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"坐骑基础属性提升2%\",\"condition\":\"[{point,3,12},{pre_skill,70300201,4}]\",\"power\":\"\",\"base_attr\":\"[{160,68,200}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"坐骑基础属性提升3%\",\"condition\":\"[{point,3,12},{pre_skill,70300201,4}]\",\"power\":\"\",\"base_attr\":\"[{160,68,300}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"坐骑基础属性提升4%\",\"condition\":\"[{point,3,12},{pre_skill,70300201,4}]\",\"power\":\"\",\"base_attr\":\"[{160,68,400}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"坐骑基础属性提升5%\",\"condition\":\"[{point,3,12},{pre_skill,70300201,4}]\",\"power\":\"\",\"base_attr\":\"[{160,68,500}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"坐骑基础属性提升6%\",\"condition\":\"[{point,3,12},{pre_skill,70300201,4}]\",\"power\":\"\",\"base_attr\":\"[{160,68,600}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"坐骑基础属性提升7%\",\"condition\":\"[{point,3,12},{pre_skill,70300201,4}]\",\"power\":\"\",\"base_attr\":\"[{160,68,700}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"坐骑基础属性提升8%\",\"condition\":\"[{point,3,12},{pre_skill,70300201,4}]\",\"power\":\"\",\"base_attr\":\"[{160,68,800}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"坐骑基础属性提升9%\",\"condition\":\"[{point,3,12},{pre_skill,70300201,4}]\",\"power\":\"\",\"base_attr\":\"[{160,68,900}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"坐骑基础属性提升10%\",\"condition\":\"[{point,3,12},{pre_skill,70300201,4}]\",\"power\":\"\",\"base_attr\":\"[{160,68,1000}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(70300501,'宝具之光','天赋技能',10,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'[]','[]',0,0,'[{\"desc\":\"宝具基础属性提升1%\",\"condition\":\"[{point,3,12},{pre_skill,70300101,4}]\",\"power\":\"\",\"base_attr\":\"[{168,68,100}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"宝具基础属性提升2%\",\"condition\":\"[{point,3,12},{pre_skill,70300101,4}]\",\"power\":\"\",\"base_attr\":\"[{168,68,200}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"宝具基础属性提升3%\",\"condition\":\"[{point,3,12},{pre_skill,70300101,4}]\",\"power\":\"\",\"base_attr\":\"[{168,68,300}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"宝具基础属性提升4%\",\"condition\":\"[{point,3,12},{pre_skill,70300101,4}]\",\"power\":\"\",\"base_attr\":\"[{168,68,400}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"宝具基础属性提升5%\",\"condition\":\"[{point,3,12},{pre_skill,70300101,4}]\",\"power\":\"\",\"base_attr\":\"[{168,68,500}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"宝具基础属性提升6%\",\"condition\":\"[{point,3,12},{pre_skill,70300101,4}]\",\"power\":\"\",\"base_attr\":\"[{168,68,600}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"宝具基础属性提升7%\",\"condition\":\"[{point,3,12},{pre_skill,70300101,4}]\",\"power\":\"\",\"base_attr\":\"[{168,68,700}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"宝具基础属性提升8%\",\"condition\":\"[{point,3,12},{pre_skill,70300101,4}]\",\"power\":\"\",\"base_attr\":\"[{168,68,800}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"宝具基础属性提升9%\",\"condition\":\"[{point,3,12},{pre_skill,70300101,4}]\",\"power\":\"\",\"base_attr\":\"[{168,68,900}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"宝具基础属性提升10%\",\"condition\":\"[{point,3,12},{pre_skill,70300101,4}]\",\"power\":\"\",\"base_attr\":\"[{168,68,1000}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(70300601,'神翼印记','天赋技能',10,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'[]','[]',0,0,'[{\"desc\":\"翅膀基础属性提升1%\",\"condition\":\"[{point,3,24},{pre_skill,70300401,4}]\",\"power\":\"\",\"base_attr\":\"[{161,68,100}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"翅膀基础属性提升2%\",\"condition\":\"[{point,3,24},{pre_skill,70300401,4}]\",\"power\":\"\",\"base_attr\":\"[{161,68,200}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"翅膀基础属性提升3%\",\"condition\":\"[{point,3,24},{pre_skill,70300401,4}]\",\"power\":\"\",\"base_attr\":\"[{161,68,300}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"翅膀基础属性提升4%\",\"condition\":\"[{point,3,24},{pre_skill,70300401,4}]\",\"power\":\"\",\"base_attr\":\"[{161,68,400}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"翅膀基础属性提升5%\",\"condition\":\"[{point,3,24},{pre_skill,70300401,4}]\",\"power\":\"\",\"base_attr\":\"[{161,68,500}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"翅膀基础属性提升6%\",\"condition\":\"[{point,3,24},{pre_skill,70300401,4}]\",\"power\":\"\",\"base_attr\":\"[{161,68,600}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"翅膀基础属性提升7%\",\"condition\":\"[{point,3,24},{pre_skill,70300401,4}]\",\"power\":\"\",\"base_attr\":\"[{161,68,700}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"翅膀基础属性提升8%\",\"condition\":\"[{point,3,24},{pre_skill,70300401,4}]\",\"power\":\"\",\"base_attr\":\"[{161,68,800}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"翅膀基础属性提升9%\",\"condition\":\"[{point,3,24},{pre_skill,70300401,4}]\",\"power\":\"\",\"base_attr\":\"[{161,68,900}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"翅膀基础属性提升10%\",\"condition\":\"[{point,3,24},{pre_skill,70300401,4}]\",\"power\":\"\",\"base_attr\":\"[{161,68,1000}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(70300701,'与神同行','天赋技能',10,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'[]','[]',0,0,'[{\"desc\":\"降神基础属性提升1%\",\"condition\":\"[{point,3,12},{pre_skill,70300301,4}]\",\"power\":\"\",\"base_attr\":\"[{440,68,100}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"降神基础属性提升2%\",\"condition\":\"[{point,3,12},{pre_skill,70300301,4}]\",\"power\":\"\",\"base_attr\":\"[{440,68,200}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"降神基础属性提升3%\",\"condition\":\"[{point,3,12},{pre_skill,70300301,4}]\",\"power\":\"\",\"base_attr\":\"[{440,68,300}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"降神基础属性提升4%\",\"condition\":\"[{point,3,12},{pre_skill,70300301,4}]\",\"power\":\"\",\"base_attr\":\"[{440,68,400}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"降神基础属性提升5%\",\"condition\":\"[{point,3,12},{pre_skill,70300301,4}]\",\"power\":\"\",\"base_attr\":\"[{440,68,500}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"降神基础属性提升6%\",\"condition\":\"[{point,3,12},{pre_skill,70300301,4}]\",\"power\":\"\",\"base_attr\":\"[{440,68,600}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"降神基础属性提升7%\",\"condition\":\"[{point,3,12},{pre_skill,70300301,4}]\",\"power\":\"\",\"base_attr\":\"[{440,68,700}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"降神基础属性提升8%\",\"condition\":\"[{point,3,12},{pre_skill,70300301,4}]\",\"power\":\"\",\"base_attr\":\"[{440,68,800}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"降神基础属性提升9%\",\"condition\":\"[{point,3,12},{pre_skill,70300301,4}]\",\"power\":\"\",\"base_attr\":\"[{440,68,900}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"降神基础属性提升10%\",\"condition\":\"[{point,3,12},{pre_skill,70300301,4}]\",\"power\":\"\",\"base_attr\":\"[{440,68,1000}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(70300801,'最强神格','天赋技能',10,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'[]','[]',0,0,'[{\"desc\":\"神格基础属性提升1%\",\"condition\":\"[{point,3,24},{pre_skill,70300101,4}]\",\"power\":\"\",\"base_attr\":\"[{427,68,100}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"神格基础属性提升2%\",\"condition\":\"[{point,3,24},{pre_skill,70300101,4}]\",\"power\":\"\",\"base_attr\":\"[{427,68,200}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"神格基础属性提升3%\",\"condition\":\"[{point,3,24},{pre_skill,70300101,4}]\",\"power\":\"\",\"base_attr\":\"[{427,68,300}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"神格基础属性提升4%\",\"condition\":\"[{point,3,24},{pre_skill,70300101,4}]\",\"power\":\"\",\"base_attr\":\"[{427,68,400}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"神格基础属性提升5%\",\"condition\":\"[{point,3,24},{pre_skill,70300101,4}]\",\"power\":\"\",\"base_attr\":\"[{427,68,500}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"神格基础属性提升6%\",\"condition\":\"[{point,3,24},{pre_skill,70300101,4}]\",\"power\":\"\",\"base_attr\":\"[{427,68,600}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"神格基础属性提升7%\",\"condition\":\"[{point,3,24},{pre_skill,70300101,4}]\",\"power\":\"\",\"base_attr\":\"[{427,68,700}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"神格基础属性提升8%\",\"condition\":\"[{point,3,24},{pre_skill,70300101,4}]\",\"power\":\"\",\"base_attr\":\"[{427,68,800}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"神格基础属性提升9%\",\"condition\":\"[{point,3,24},{pre_skill,70300101,4}]\",\"power\":\"\",\"base_attr\":\"[{427,68,900}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"神格基础属性提升10%\",\"condition\":\"[{point,3,24},{pre_skill,70300101,4}]\",\"power\":\"\",\"base_attr\":\"[{427,68,1000}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(70300901,'光辉圣灵','天赋技能',10,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'[]','[]',0,0,'[{\"desc\":\"圣灵基础属性提升1%\",\"condition\":\"[{point,3,24},{pre_skill,70300701,4}]\",\"power\":\"\",\"base_attr\":\"[{428,68,100}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"圣灵基础属性提升2%\",\"condition\":\"[{point,3,24},{pre_skill,70300701,4}]\",\"power\":\"\",\"base_attr\":\"[{428,68,200}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"圣灵基础属性提升3%\",\"condition\":\"[{point,3,24},{pre_skill,70300701,4}]\",\"power\":\"\",\"base_attr\":\"[{428,68,300}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"圣灵基础属性提升4%\",\"condition\":\"[{point,3,24},{pre_skill,70300701,4}]\",\"power\":\"\",\"base_attr\":\"[{428,68,400}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"圣灵基础属性提升5%\",\"condition\":\"[{point,3,24},{pre_skill,70300701,4}]\",\"power\":\"\",\"base_attr\":\"[{428,68,500}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"圣灵基础属性提升6%\",\"condition\":\"[{point,3,24},{pre_skill,70300701,4}]\",\"power\":\"\",\"base_attr\":\"[{428,68,600}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"圣灵基础属性提升7%\",\"condition\":\"[{point,3,24},{pre_skill,70300701,4}]\",\"power\":\"\",\"base_attr\":\"[{428,68,700}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"圣灵基础属性提升8%\",\"condition\":\"[{point,3,24},{pre_skill,70300701,4}]\",\"power\":\"\",\"base_attr\":\"[{428,68,800}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"圣灵基础属性提升9%\",\"condition\":\"[{point,3,24},{pre_skill,70300701,4}]\",\"power\":\"\",\"base_attr\":\"[{428,68,900}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"圣灵基础属性提升10%\",\"condition\":\"[{point,3,24},{pre_skill,70300701,4}]\",\"power\":\"\",\"base_attr\":\"[{428,68,1000}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(70301001,'技能精通','天赋技能',10,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'[]','[]',0,0,'[{\"desc\":\"技能加成提升2%\",\"condition\":\"[{point,3,36},{pre_skill,70300601,4}]\",\"power\":\"\",\"base_attr\":\"[{0,27,200}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"技能加成提升4%\",\"condition\":\"[{point,3,36},{pre_skill,70300601,4}]\",\"power\":\"\",\"base_attr\":\"[{0,27,400}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"技能加成提升6%\",\"condition\":\"[{point,3,36},{pre_skill,70300601,4}]\",\"power\":\"\",\"base_attr\":\"[{0,27,600}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"技能加成提升8%\",\"condition\":\"[{point,3,36},{pre_skill,70300601,4}]\",\"power\":\"\",\"base_attr\":\"[{0,27,800}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"技能加成提升10%\",\"condition\":\"[{point,3,36},{pre_skill,70300601,4}]\",\"power\":\"\",\"base_attr\":\"[{0,27,1000}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(70301101,'巅峰对决','天赋技能',10,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'[]','[]',0,0,'[{\"desc\":\"pvp伤害提升2%\",\"condition\":\"[{point,3,36},{pre_skill,70300601,4}]\",\"power\":\"\",\"base_attr\":\"[{0,51,200}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"pvp伤害提升4%\",\"condition\":\"[{point,3,36},{pre_skill,70300601,4}]\",\"power\":\"\",\"base_attr\":\"[{0,51,400}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"pvp伤害提升6%\",\"condition\":\"[{point,3,36},{pre_skill,70300601,4}]\",\"power\":\"\",\"base_attr\":\"[{0,51,600}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"pvp伤害提升8%\",\"condition\":\"[{point,3,36},{pre_skill,70300601,4}]\",\"power\":\"\",\"base_attr\":\"[{0,51,800}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"},{\"desc\":\"pvp伤害提升10%\",\"condition\":\"[{point,3,36},{pre_skill,70300601,4}]\",\"power\":\"\",\"base_attr\":\"[{0,51,1000}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(80100101,'雷霆法则','神格法则技能',10,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"蕴含强大的禁锢之力，每次攻击都有15%的概率麻痹目标，使其无法攻击和移动，持续1.5s，CD10s\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,103}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{101,3,150,2,0,0,0,1500,0,0}]\"},{\"desc\":\"蕴含强大的禁锢之力，每次攻击都有15%的概率麻痹目标，使其无法攻击和移动，持续1.75s，CD10s\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,103}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{101,3,150,2,0,0,0,1750,0,0}]\"},{\"desc\":\"蕴含强大的禁锢之力，每次攻击都有15%的概率麻痹目标，使其无法攻击和移动，持续2s，CD10s\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,103}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{101,3,150,2,0,0,0,2000,0,0}]\"},{\"desc\":\"蕴含强大的禁锢之力，每次攻击都有15%的概率麻痹目标，使其无法攻击和移动，持续2.25s，CD10s\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,103}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{101,3,150,2,0,0,0,2250,0,0}]\"},{\"desc\":\"蕴含强大的禁锢之力，每次攻击都有15%的概率麻痹目标，使其无法攻击和移动，持续2.5s，CD10s\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,103}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{101,3,150,2,0,0,0,2500,0,0}]\"}]'),(80100201,'生命法则','神格法则技能',10,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"蕴含强大的治愈之力，每次攻击都有15%的概率回复生命，回复效果为所造成的最终伤害的60%，CD10s\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,103}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{114,3,150,2,0,0.6,0,0,1,0}]\"},{\"desc\":\"蕴含强大的治愈之力，每次攻击都有15%的概率回复生命，回复效果为所造成的最终伤害的70%，CD10s\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,103}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{114,3,150,2,0,0.7,0,0,1,0}]\"},{\"desc\":\"蕴含强大的治愈之力，每次攻击都有15%的概率回复生命，回复效果为所造成的最终伤害的80%，CD10s\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,103}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{114,3,150,2,0,0.8,0,0,1,0}]\"},{\"desc\":\"蕴含强大的治愈之力，每次攻击都有15%的概率回复生命，回复效果为所造成的最终伤害的90%，CD10s\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,103}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{114,3,150,2,0,0.9,0,0,1,0}]\"},{\"desc\":\"蕴含强大的治愈之力，每次攻击都有15%的概率回复生命，回复效果为所造成的最终伤害的100%，CD10s\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,1,0,0,0,103}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{114,3,150,2,0,1,0,0,1,0}]\"}]'),(80100301,'光明法则','神格法则技能',10,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"蕴含强大的生命之力，受到致死伤害后免疫该次伤害，并恢复生命上限35%的血量，CD120s\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"120000\",\"trigger\":\"[{6,1000,0,4,0,0,0,116}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,0,1000,1,0,0.35,2,0,1,0}]\"},{\"desc\":\"蕴含强大的生命之力，受到致死伤害后免疫该次伤害，并恢复生命上限50%的血量，CD120s\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"120000\",\"trigger\":\"[{6,1000,0,4,0,0,0,116}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,0,1000,1,0,0.5,2,0,1,0}]\"},{\"desc\":\"蕴含强大的生命之力，受到致死伤害后免疫该次伤害，并恢复生命上限65%的血量，CD120s\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"120000\",\"trigger\":\"[{6,1000,0,4,0,0,0,116}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,0,1000,1,0,0.65,2,0,1,0}]\"},{\"desc\":\"蕴含强大的生命之力，受到致死伤害后免疫该次伤害，并恢复生命上限80%的血量，CD120s\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"120000\",\"trigger\":\"[{6,1000,0,4,0,0,0,116}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,0,1000,1,0,0.8,2,0,1,0}]\"},{\"desc\":\"蕴含强大的生命之力，受到致死伤害后免疫该次伤害，并恢复生命上限100%的血量，CD120s\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"120000\",\"trigger\":\"[{6,1000,0,4,0,0,0,116}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{116,0,1000,1,0,1,2,0,1,0}]\"}]'),(80100401,'大地法则','神格法则技能',10,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"蕴含强大的守护之力，受到攻击时有15%的概率获得60%的伤害减免，CD10s\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,2,0,0,0,10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{10,0,100,1,6000,0,0,1,0}]\"},{\"desc\":\"蕴含强大的守护之力，受到攻击时有15%的概率获得70%的伤害减免，CD10s\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,2,0,0,0,10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{10,0,100,1,7000,0,0,1,0}]\"},{\"desc\":\"蕴含强大的守护之力，受到攻击时有15%的概率获得80%的伤害减免，CD10s\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,2,0,0,0,10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{10,0,100,1,8000,0,0,1,0}]\"},{\"desc\":\"蕴含强大的守护之力，受到攻击时有15%的概率获得90%的伤害减免，CD10s\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,2,0,0,0,10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{10,0,100,1,9000,0,0,1,0}]\"},{\"desc\":\"蕴含强大的守护之力，受到攻击时有15%的概率获得100%的伤害减免，CD10s\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"10000\",\"trigger\":\"[{0,1000,0,2,0,0,0,10}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{10,0,100,1,10000,0,0,1,0}]\"}]'),(200022011,'半人马普攻','半人马普攻',11,1,1,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,2500,'0','[]',0,0,'[{\"desc\":\"怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[5,5]\",\"attr\":\"\",\"hurt\":\"25000\",\"effect\":\"\"}]'),(200022012,'半人马技能1','半人马技能1',11,1,0,1,0,0,2,2,1,1,1000,1,'0','[{200022014,2500,0},{200022012,2500,0}]',0,0,0,2500,'[200022014,200022012]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"600\",\"num\":\"[500,500]\",\"attr\":\"[]\",\"hurt\":\"50000\",\"effect\":\"[]\"}]'),(200022013,'半人马技能副1','半人马技能副1',11,1,0,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,0,'[]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"600\",\"num\":\"[500,500]\",\"attr\":\"[]\",\"hurt\":\"20000\",\"effect\":\"[]\"}]'),(200022014,'半人马技能预警','半人马技能预警',11,1,0,0,0,0,2,2,0,1,1000,1,'0','[{200022014,2500,0},{200022012,2500,0}]',0,0,0,5000,'[200022014,200022012]','[]',0,0,'[{\"desc\":\"123\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"14000\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"10000\",\"effect\":\"[]\"}]'),(200022021,'蜘蛛普攻','蜘蛛普攻',11,1,0,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,2500,'0','[]',0,0,'[{\"desc\":\"怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"1000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[1,1]\",\"attr\":\"\",\"hurt\":\"25000\",\"effect\":\"\"}]'),(200022022,'蜘蛛技能预警','蜘蛛技能1',11,1,0,0,0,0,2,2,0,1,1000,1,'0','[{200022022,2500,0},{200022023,1333,0}]',0,0,0,4333,'[200022022,200022023]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"15000\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"600\",\"num\":\"[500,500]\",\"attr\":\"[]\",\"hurt\":\"16000\",\"effect\":\"[]\"}]'),(200022023,'蜘蛛技能1','蜘蛛技能1',11,1,0,1,0,0,2,2,1,1,1000,1,'0','[{200022022,2500,0},{200022023,1333,0}]',0,0,0,4333,'[200022022,200022023]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"600\",\"num\":\"[500,500]\",\"attr\":\"[]\",\"hurt\":\"43000\",\"effect\":\"[]\"}]'),(200022024,'蜘蛛技能2预警','蜘蛛技能1预警',11,1,0,0,0,0,2,2,0,1,1000,1,'0','[{200022024,2500,0},{200022025,1333,0}]',0,0,0,4333,'[200022024,200022025]','[]',0,0,'[{\"desc\":\"123\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"15000\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"10000\",\"effect\":\"[]\"}]'),(200022025,'蜘蛛技能2','蜘蛛技能2',11,1,0,0,0,0,2,2,1,1,1000,1,'0','[{200022024,2500,0},{200022025,1333,0}]',0,0,0,4333,'[200022024,200022025]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"15000\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"600\",\"num\":\"[500,500]\",\"attr\":\"[]\",\"hurt\":\"43000\",\"effect\":\"[]\"}]'),(200054200,'光明神技能预警','光明神技能预警',11,1,0,0,0,0,2,2,0,1,1000,1,'0','[{200054200,2500,0},{20005427,300,0},{20005428,200,0},{20005429,300,0},{20005430,0,0}]',0,0,0,2500,'[200054200,20005427,20005428,20005429,20005430]','[]',0,0,'[{\"desc\":\"123\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"12800\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"30000\",\"effect\":\"[]\"}]'),(202030011,'食人花普攻','食人花普攻',11,1,1,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,2000,'0','[]',0,0,'[{\"desc\":\"怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"400\",\"num\":\"[1,1]\",\"attr\":\"\",\"hurt\":\"20000\",\"effect\":\"\"}]'),(202030012,'食人花预警','食人花预警',11,1,0,0,0,0,2,2,0,1,1000,1,'0','[{202030012,2500,0},{202030013,600,0},{202030014,600,0},{202030015,600,0}]',0,0,0,4333,'[202030012,202030013,202030014,202030015]','[]',0,0,'[{\"desc\":\"123\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"12000\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"500\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"10000\",\"effect\":\"[]\"}]'),(202030013,'食人花技能1','食人花技能1',11,1,0,1,0,0,2,2,1,2,1000,1,'0','[{202030012,2500,0},{202030013,600,0},{202030014,600,0},{202030015,600,0}]',0,0,0,4333,'[202030012,202030013,202030014,202030015]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"500\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"14400\",\"effect\":\"[]\"}]'),(202030014,'食人花技能1','食人花技能1',11,1,0,1,0,0,2,2,1,2,1000,1,'0','[{202030012,2500,0},{202030013,600,0},{202030014,600,0},{202030015,600,0}]',0,0,0,4333,'[202030012,202030013,202030014,202030015]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"500\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"14400\",\"effect\":\"[]\"}]'),(202030015,'食人花技能1','食人花技能1',11,1,0,1,0,0,2,2,1,2,1000,1,'0','[{202030012,2500,0},{202030013,600,0},{202030014,600,0},{202030015,600,0}]',0,0,0,4333,'[202030012,202030013,202030014,202030015]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"500\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"14500\",\"effect\":\"[]\"}]'),(202030031,'泰坦普攻','泰坦普攻',11,1,1,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,2000,'0','[]',0,0,'[{\"desc\":\"怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"2000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"400\",\"num\":\"[50,50]\",\"attr\":\"\",\"hurt\":\"20000\",\"effect\":\"\"}]'),(202030032,'泰坦预警','泰坦预警',11,1,0,0,0,0,2,2,0,1,1000,1,'0','[{202030032,2500,0},{202030033,1600,0},{202030034,1000,0},{202030035,1500,0}]',0,0,0,7400,'[202030032,202030033,202030034,202030035]','[]',0,0,'[{\"desc\":\"123\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"15000\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"10000\",\"effect\":\"[]\"}]'),(202030033,'泰坦技能1','泰坦技能1',11,1,0,1,0,0,2,2,1,2,1000,1,'0','[{202030032,2500,0},{202030033,1600,0},{202030034,1500,0},{202030035,1000,0}]',0,0,0,7400,'[202030032,202030033,202030034,202030035]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"18000\",\"effect\":\"[]\"}]'),(202030034,'泰坦技能1','泰坦技能1',11,1,0,1,0,0,2,2,1,2,1000,1,'0','[{202030032,2500,0},{202030033,1600,0},{202030034,1500,0},{202030035,1000,0}]',0,0,0,7400,'[202030032,202030033,202030034,202030035]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"18000\",\"effect\":\"[]\"}]'),(202030035,'泰坦技能1','泰坦技能1',11,1,0,1,0,0,2,2,1,2,1000,1,'0','[{202030032,2500,0},{202030033,1600,0},{202030034,1500,0},{202030035,1000,0}]',0,0,0,7400,'[202030032,202030033,202030034,202030035]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"28000\",\"effect\":\"[]\"}]'),(202030041,'冰龙普攻','冰龙普攻',11,1,1,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,2876,'[]','[]',0,0,'[{\"desc\":\"怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"\",\"hurt\":\"20000\",\"effect\":\"\"}]'),(202030042,'冰龙普攻2段','冰龙普攻2段',11,1,1,1,0,0,2,2,1,1,1000,1,'0','[{202030041,1400,0},{202030042,1476,0}]',0,0,0,2000,'[202030041,202030042]','[]',0,0,'[{\"desc\":\"怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"\",\"hurt\":\"8000\",\"effect\":\"\"}]'),(202030043,'冰龙预警','冰龙预警',11,1,0,0,0,0,2,2,0,1,1000,1,'0','[{202030043,2500,0},{202030044,2700,0}]',0,0,0,5200,'[202030043,202030044]','[]',0,0,'[{\"desc\":\"123\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"12000\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"10000\",\"effect\":\"[]\"}]'),(202030044,'冰龙技能1','冰龙技能1',11,1,0,1,0,0,2,2,1,2,1000,1,'0','[{202030043,2500,0},{202030044,2700,0}]',0,0,0,5200,'[202030043,202030044]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"52000\",\"effect\":\"[]\"}]'),(202030051,'阿努比斯普攻','阿努比斯普攻',11,1,1,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,1467,'0','[]',0,0,'[{\"desc\":\"怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"200\",\"num\":\"[50,50]\",\"attr\":\"\",\"hurt\":\"14670\",\"effect\":\"\"}]'),(202030052,'阿努比斯预警','阿努比斯预警',11,1,0,0,0,0,2,2,0,1,1000,1,'0','[{202030052,2500,0},{202030053,1933,0}]',0,0,0,4433,'[202030092,202030093]','[]',0,0,'[{\"desc\":\"123\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"12000\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"700\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"10000\",\"effect\":\"[]\"}]'),(202030053,'阿努比斯技能1','阿努比斯技能1',11,1,0,1,0,0,2,2,1,2,1000,1,'0','[{202030052,2500,0},{202030053,1933,0}]',0,0,0,4433,'[202030092,202030093]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"800\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"44330\",\"effect\":\"[]\"}]'),(202030081,'检测员普攻','检测员普攻',11,1,1,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,1667,'0','[]',0,0,'[{\"desc\":\"怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"200\",\"num\":\"[50,50]\",\"attr\":\"\",\"hurt\":\"16670\",\"effect\":\"\"}]'),(202030082,'检测员预警','检测员预警',11,1,0,0,0,0,2,2,0,1,1000,1,'0','[{202030082,2500,0},{202030083,1000,0},{202030084,1000,0},{202030085,1670,0}]',0,0,0,6170,'[202030082,202030083,202030084,202030085]','[]',0,0,'[{\"desc\":\"123\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"12000\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"10000\",\"effect\":\"[]\"}]'),(202030083,'检测员技能1','检测员技能1',11,1,0,1,0,0,2,2,1,2,1000,1,'0','[{202030082,2500,0},{202030083,1000,0},{202030084,1000,0},{202030085,1670,0}]',0,0,0,6170,'[202030082,202030083,202030084,202030085]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"20000\",\"effect\":\"[]\"}]'),(202030084,'检测员技能1','检测员技能1',11,1,0,1,0,0,2,2,1,2,1000,1,'0','[{202030082,2500,0},{202030083,1000,0},{202030084,1000,0},{202030085,1670,0}]',0,0,0,6170,'[202030082,202030083,202030084,202030085]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"20000\",\"effect\":\"[]\"}]'),(202030085,'检测员技能1','检测员技能1',11,1,0,1,0,0,2,2,1,2,1000,1,'0','[{202030082,2500,0},{202030083,1000,0},{202030084,1000,0},{202030085,1670,0}]',0,0,0,6170,'[202030082,202030083,202030084,202030085]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"21700\",\"effect\":\"[]\"}]'),(202030091,'海龙普攻','海龙普攻',11,1,1,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,2100,'0','[]',0,0,'[{\"desc\":\"怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"200\",\"num\":\"[50,50]\",\"attr\":\"\",\"hurt\":\"21000\",\"effect\":\"\"}]'),(202030092,'海龙预警','海龙预警',11,1,0,0,0,0,2,2,0,1,1000,1,'0','[{202030092,2500,0},{202030093,2667,0}]',0,0,0,5167,'[202030092,202030093]','[]',0,0,'[{\"desc\":\"123\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"12000\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"700\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"10000\",\"effect\":\"[]\"}]'),(202030093,'海龙技能1','海龙技能1',11,1,0,1,0,0,2,2,1,2,1000,1,'0','[{202030092,2500,0},{202030093,2667,0}]',0,0,0,5167,'[202030092,202030093]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"800\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"51670\",\"effect\":\"[]\"}]'),(202030101,'傲慢普攻','傲慢普攻',11,1,1,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,1300,'0','[]',0,0,'[{\"desc\":\"怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"200\",\"num\":\"[50,50]\",\"attr\":\"\",\"hurt\":\"13000\",\"effect\":\"\"}]'),(202030102,'傲慢预警','傲慢预警',11,1,0,0,0,0,2,2,0,1,1000,1,'0','[{202030102,2500,0},{202030103,2500,0}]',0,0,0,5000,'[202030102,202030103]','[]',0,0,'[{\"desc\":\"123\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"12000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"10000\",\"effect\":\"[]\"}]'),(202030103,'傲慢技能1','傲慢技能1',11,1,0,1,0,0,2,2,1,2,1000,1,'0','[{202030102,2500,0},{202030103,2500,0}]',0,0,0,5000,'[202030102,202030103]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"50000\",\"effect\":\"[]\"}]'),(202030121,'愤怒普攻','愤怒普攻',11,1,1,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,1333,'0','[]',0,0,'[{\"desc\":\"怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"200\",\"num\":\"[50,50]\",\"attr\":\"\",\"hurt\":\"13333\",\"effect\":\"\"}]'),(202030122,'愤怒预警','愤怒预警',11,1,0,0,0,0,2,2,0,1,1000,1,'0','[{202030122,2500,0},{202030123,4000,0}]',0,0,0,6500,'[202030122,202030123]','[]',0,0,'[{\"desc\":\"123\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"18000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"10000\",\"effect\":\"[]\"}]'),(202030123,'愤怒技能1','愤怒技能1',11,1,0,1,0,0,2,2,1,2,1000,1,'0','[{202030122,2500,0},{202030123,4000,0}]',0,0,0,6500,'[202030122,202030123]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"65000\",\"effect\":\"[]\"}]'),(202030124,'愤怒预警2','愤怒预警2',11,1,0,0,0,0,2,2,0,1,1000,1,'0','[{202030124,2500,0},{202030125,2667,0}]',0,0,0,5176,'[202030124,202030125]','[]',0,0,'[{\"desc\":\"123\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"18000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"10000\",\"effect\":\"[]\"}]'),(202030125,'愤怒技能2','愤怒技能2',11,1,0,1,0,0,2,2,1,2,1000,1,'0','[{202030124,2500,0},{202030125,2667,0}]',0,0,0,5176,'[202030124,202030125]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"51760\",\"effect\":\"[]\"}]'),(202030131,'怠惰普攻','怠惰普攻',11,1,1,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,1667,'0','[]',0,0,'[{\"desc\":\"怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"200\",\"num\":\"[50,50]\",\"attr\":\"\",\"hurt\":\"13333\",\"effect\":\"\"}]'),(202030132,'怠惰预警','怠惰预警',11,1,0,0,0,0,2,2,0,1,1000,1,'0','[{202030132,2500,0},{202030133,1700,0},{202030134,500,0},{202030135,2800,0}]',0,0,0,7500,'[202030132,202030133,202030134,202030135]','[]',0,0,'[{\"desc\":\"123\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"15000\",\"trigger\":\"[]\",\"distance\":\"650\",\"area\":\"700\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"10000\",\"effect\":\"[]\"}]'),(202030133,'怠惰技能1','怠惰技能1',11,1,0,1,0,0,2,2,1,2,1000,1,'0','[{202030132,2500,0},{202030133,1700,0},{202030134,500,0},{202030135,2800,0}]',0,0,0,7500,'[202030132,202030133,202030134,202030135]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"650\",\"area\":\"800\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"25000\",\"effect\":\"[]\"}]'),(202030134,'怠惰技能1副1','怠惰技能1副1',11,1,0,1,0,0,2,2,1,2,1000,1,'0','[{202030132,2500,0},{202030133,1700,0},{202030134,500,0},{202030135,2800,0}]',0,0,0,7500,'[202030132,202030133,202030134,202030135]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"650\",\"area\":\"800\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"25000\",\"effect\":\"[]\"}]'),(202030135,'怠惰技能1副2','怠惰技能1副2',11,1,0,1,0,0,2,2,1,2,1000,1,'0','[{202030132,2500,0},{202030133,1700,0},{202030134,500,0},{202030135,2800,0}]',0,0,0,7500,'[202030132,202030133,202030134,202030135]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"650\",\"area\":\"800\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"25000\",\"effect\":\"[]\"}]'),(202030136,'怠惰预警','怠惰预警',11,1,0,0,0,0,2,2,0,1,1000,1,'0','[{202030136,2500,0},{202030137,1700,0},{202030138,500,0},{202030139,2450,0}]',0,0,0,7167,'[202030136,202030137,202030138,202030139]','[]',0,0,'[{\"desc\":\"123\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"23000\",\"trigger\":\"[]\",\"distance\":\"650\",\"area\":\"700\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"10000\",\"effect\":\"[]\"}]'),(202030137,'怠惰技能1','怠惰技能1',11,1,0,1,0,0,2,2,1,2,1000,1,'0','[{202030136,2500,0},{202030137,1700,0},{202030138,500,0},{202030139,2450,0}]',0,0,0,7167,'[202030136,202030137,202030138,202030139]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"650\",\"area\":\"800\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"25000\",\"effect\":\"[]\"}]'),(202030138,'怠惰技能1副1','怠惰技能1副1',11,1,0,1,0,0,2,2,1,2,1000,1,'0','[{202030136,2500,0},{202030137,1700,0},{202030138,500,0},{202030139,2450,0}]',0,0,0,7167,'[202030136,202030137,202030138,202030139]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"650\",\"area\":\"800\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"25000\",\"effect\":\"[]\"}]'),(202030139,'怠惰技能1副2','怠惰技能1副2',11,1,0,1,0,0,2,2,1,2,1000,1,'0','[{202030136,2500,0},{202030137,1700,0},{202030138,500,0},{202030139,2450,0}]',0,0,0,7167,'[202030136,202030137,202030138,202030139]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"650\",\"area\":\"800\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"25000\",\"effect\":\"[]\"}]'),(202030141,'嫉妒普攻','嫉妒普攻',11,1,1,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,1600,'0','[]',0,0,'[{\"desc\":\"怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[50,50]\",\"attr\":\"\",\"hurt\":\"16000\",\"effect\":\"\"}]'),(202030142,'嫉妒预警','嫉妒预警',11,1,0,0,0,0,2,2,0,1,1000,1,'0','[{202030142,2500,0},{202030143,1333,0},{202030148,1000,0},{202030149,1000,0}]',0,0,0,5833,'[202030142,202030143,202030148,202030149]','[]',0,0,'[{\"desc\":\"123\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"12000\",\"trigger\":\"[]\",\"distance\":\"300\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"10000\",\"effect\":\"[]\"}]'),(202030143,'嫉妒技能1','嫉妒技能1',11,1,0,1,0,0,2,2,1,2,1000,1,'0','[{202030142,2500,0},{202030143,1333,0},{202030148,1000,0},{202030149,1000,0}]',0,0,0,5833,'[202030142,202030143,202030148,202030149]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"38330\",\"effect\":\"[]\"}]'),(202030144,'嫉妒预警','嫉妒预警',11,1,0,0,0,0,2,2,0,1,1000,1,'0','[{202030144,2500,0},{202030145,2000,0},{202030146,2000,0},{202030147,2000,0}]',0,0,0,8500,'[202030144,202030145,202030146,202030147]','[]',0,0,'[{\"desc\":\"123\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"12000\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"700\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"10000\",\"effect\":\"[]\"}]'),(202030145,'嫉妒技能1','嫉妒技能1',11,1,0,1,0,0,2,2,1,2,1000,1,'0','[{202030144,2500,0},{202030145,2000,0},{202030146,2000,0},{202030147,2000,0}]',0,0,0,8500,'[202030144,202030145,202030146,202030147]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"650\",\"area\":\"800\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"25000\",\"effect\":\"[]\"}]'),(202030146,'嫉妒技能1副1','嫉妒技能1副1',11,1,0,1,0,0,2,2,1,2,1000,1,'0','[{202030144,2500,0},{202030145,2000,0},{202030146,2000,0},{202030147,2000,0}]',0,0,0,8500,'[202030144,202030145,202030146,202030147]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"650\",\"area\":\"800\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"25000\",\"effect\":\"[]\"}]'),(202030147,'嫉妒技能1副2','嫉妒技能1副2',11,1,0,1,0,0,2,2,1,2,1000,1,'0','[{202030144,2500,0},{202030145,2000,0},{202030146,2000,0},{202030147,2000,0}]',0,0,0,8500,'[202030144,202030145,202030146,202030147]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"800\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"35000\",\"effect\":\"[]\"}]'),(202030148,'嫉妒技能1副1','嫉妒技能1副1',11,1,0,1,0,0,2,2,1,2,1000,1,'0','[{202030142,2500,0},{202030143,1333,0},{202030148,1000,0},{202030149,1000,0}]',0,0,0,8500,'[202030142,202030143,202030148,202030149]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"650\",\"area\":\"800\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"10000\",\"effect\":\"[]\"}]'),(202030149,'嫉妒技能1副2','嫉妒技能1副2',11,1,0,1,0,0,2,2,1,2,1000,1,'0','[{202030144,2500,0},{202030145,2000,0},{202030146,2000,0},{202030147,2000,0}]',0,0,0,8500,'[202030144,202030145,202030146,202030147]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"400\",\"area\":\"800\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"10000\",\"effect\":\"[]\"}]'),(202030151,'暴食普攻','暴食普攻',11,1,1,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,1233,'0','[]',0,0,'[{\"desc\":\"怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"200\",\"num\":\"[50,50]\",\"attr\":\"\",\"hurt\":\"16000\",\"effect\":\"\"}]'),(202030152,'暴食预警','暴食预警',11,1,0,0,0,0,2,2,0,1,1000,1,'0','[{202030152,2500,0},{202030153,3333,0}]',0,0,0,5833,'[202030152,202030153]','[]',0,0,'[{\"desc\":\"123\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"12000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"10000\",\"effect\":\"[]\"}]'),(202030153,'暴食技能1','暴食技能1',11,1,0,1,0,0,2,2,1,2,1000,1,'0','[{202030152,2500,0},{202030153,3333,0}]',0,0,0,5833,'[202030152,202030153]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"58330\",\"effect\":\"[]\"}]'),(202030161,'色欲普攻','色欲普攻',11,1,1,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,1333,'0','[]',0,0,'[{\"desc\":\"怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"200\",\"num\":\"[50,50]\",\"attr\":\"\",\"hurt\":\"13330\",\"effect\":\"\"}]'),(202030162,'色欲预警','色欲预警',11,1,0,0,0,0,2,2,0,1,1000,1,'0','[{202030162,2500,0},{202030163,1400,0}]',0,0,0,3900,'[202030162,202030163]','[]',0,0,'[{\"desc\":\"123\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"12000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"1000\",\"effect\":\"[]\"}]'),(202030163,'色欲技能1','色欲技能1',11,1,0,1,0,0,2,2,1,2,1000,1,'0','[{202030162,2500,0},{202030163,1400,0}]',0,0,0,3900,'[202030162,202030163]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"39000\",\"effect\":\"[]\"}]'),(202030164,'色欲预警2','色欲预警2',11,1,0,0,0,0,2,2,0,1,1000,1,'0','[{202030164,2500,0},{202030165,2167,0}]',0,0,0,4667,'[202030164,202030165]','[]',0,0,'[{\"desc\":\"123\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"12000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"1000\",\"effect\":\"[]\"}]'),(202030165,'色欲技能2','色欲技能2',11,1,0,1,0,0,2,2,1,2,1000,1,'0','[{202030164,2500,0},{202030165,2167,0}]',0,0,0,4667,'[202030164,202030165]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"46670\",\"effect\":\"[]\"}]'),(202030201,'迦楼罗普攻','迦楼罗普攻',11,1,1,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,1333,'0','[]',0,0,'[{\"desc\":\"怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"200\",\"num\":\"[50,50]\",\"attr\":\"\",\"hurt\":\"13330\",\"effect\":\"\"}]'),(202030202,'迦楼罗预警','迦楼罗预警',11,1,0,0,0,0,2,2,0,1,1000,1,'0','[{202030202,2500,0},{202030203,1833,0}]',0,0,0,4333,'[202030202,202030203]','[]',0,0,'[{\"desc\":\"123\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"12000\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"700\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"10000\",\"effect\":\"[]\"}]'),(202030203,'迦楼罗技能1','迦楼罗技能1',11,1,0,1,0,0,2,2,1,2,1000,2,'0','[{202030202,2500,0},{202030203,1833,0}]',0,0,0,4333,'[202030202,202030203]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"800\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"44330\",\"effect\":\"[]\"}]'),(202030204,'迦楼罗预警2','迦楼罗预警2',11,1,0,0,0,0,2,2,0,1,1000,1,'0','[{202030202,2500,0},{202030203,1667,0}]',0,0,0,4133,'[202030204,202030205]','[]',0,0,'[{\"desc\":\"123\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"12000\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"700\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"10000\",\"effect\":\"[]\"}]'),(202030205,'迦楼罗技能2','迦楼罗技能2',11,1,0,1,0,0,2,2,1,2,1000,1,'0','[{202030202,2500,0},{202030203,1667,0}]',0,0,0,4133,'[202030204,202030205]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"800\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"41330\",\"effect\":\"[]\"}]'),(202030251,'熔岩普攻','熔岩普攻',11,1,1,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,1867,'0','[]',0,0,'[{\"desc\":\"怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"200\",\"num\":\"[50,50]\",\"attr\":\"\",\"hurt\":\"18670\",\"effect\":\"\"}]'),(202030252,'熔岩预警','熔岩预警',11,1,0,0,0,0,2,2,0,1,1000,1,'0','[{202030252,2500,0},{202030253,2500,0}]',0,0,0,5000,'[202030252,202030253]','[]',0,0,'[{\"desc\":\"123\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"12000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"10000\",\"effect\":\"[]\"}]'),(202030253,'熔岩技能1','熔岩技能1',11,1,0,1,0,0,2,2,1,2,1000,1,'0','[{202030252,2500,0},{202030253,2500,0}]',0,0,0,5000,'[202030252,202030253]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"46670\",\"effect\":\"[]\"}]'),(202030254,'熔岩预警','熔岩预警',11,1,0,0,0,0,2,2,0,1,1000,1,'0','[{202030254,2500,0},{202030255,1500,0}]',0,0,0,4000,'[202030254,202030255]','[]',0,0,'[{\"desc\":\"123\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"12000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"10000\",\"effect\":\"[]\"}]'),(202030255,'熔岩技能1','熔岩技能1',11,1,0,1,0,0,2,2,1,2,1000,1,'0','[{202030254,2500,0},{202030255,1500,0}]',0,0,0,4000,'[202030254,202030255]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"40000\",\"effect\":\"[]\"}]'),(202030261,'巴哈普攻','巴哈普攻',11,1,1,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,1333,'0','[]',0,0,'[{\"desc\":\"怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"200\",\"num\":\"[50,50]\",\"attr\":\"\",\"hurt\":\"13330\",\"effect\":\"\"}]'),(202030262,'巴哈预警','巴哈预警',11,1,0,0,0,0,2,2,0,1,1000,1,'0','[{202030262,2500,0},{202030263,300,0},{202030264,300,0},{202030265,300,0},{202030266,300,0},{202030267,500,0},{202030268,300,0},{202030269,500,0}]',0,0,0,5100,'[202030262,202030263,202030264,202030265,202030266,202030267,202030268,202030269]','[]',0,0,'[{\"desc\":\"123\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"12000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"10000\",\"effect\":\"[]\"}]'),(202030263,'巴哈技能1','巴哈技能1',11,1,0,1,0,0,2,2,1,2,1000,1,'0','[{202030262,2500,0},{202030263,300,0},{202030264,300,0},{202030265,300,0},{202030266,300,0},{202030267,500,0},{202030268,300,0},{202030269,500,0}]',0,0,0,5067,'[202030262,202030263,202030264,202030265,202030266,202030267,202030268,202030269]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"7000\",\"effect\":\"[]\"}]'),(202030264,'巴哈技能2','巴哈技能2',11,1,0,1,0,0,2,2,1,2,1000,1,'0','[{202030262,2500,0},{202030263,300,0},{202030264,300,0},{202030265,300,0},{202030266,300,0},{202030267,500,0},{202030268,300,0},{202030269,500,0}]',0,0,0,5067,'[202030262,202030263,202030264,202030265,202030266,202030267,202030268,202030269]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"7000\",\"effect\":\"[]\"}]'),(202030265,'巴哈技能3','巴哈技能3',11,1,0,1,0,0,2,2,1,2,1000,1,'0','[{202030262,2500,0},{202030263,300,0},{202030264,300,0},{202030265,300,0},{202030266,300,0},{202030267,500,0},{202030268,300,0},{202030269,500,0}]',0,0,0,5067,'[202030262,202030263,202030264,202030265,202030266,202030267,202030268,202030269]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"7000\",\"effect\":\"[]\"}]'),(202030266,'巴哈技能4','巴哈技能4',11,1,0,1,0,0,2,2,1,2,1000,1,'0','[{202030262,2500,0},{202030263,300,0},{202030264,300,0},{202030265,300,0},{202030266,300,0},{202030267,500,0},{202030268,300,0},{202030269,500,0}]',0,0,0,5067,'[202030262,202030263,202030264,202030265,202030266,202030267,202030268,202030269]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"7000\",\"effect\":\"[]\"}]'),(202030267,'巴哈技能5','巴哈技能5',11,1,0,1,0,0,2,2,1,2,1000,1,'0','[{202030262,2500,0},{202030263,300,0},{202030264,300,0},{202030265,300,0},{202030266,300,0},{202030267,500,0},{202030268,300,0},{202030269,500,0}]',0,0,0,5067,'[202030262,202030263,202030264,202030265,202030266,202030267,202030268,202030269]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"7000\",\"effect\":\"[]\"}]'),(202030268,'巴哈技能6','巴哈技能6',11,1,0,1,0,0,2,2,1,2,1000,1,'0','[{202030262,2500,0},{202030263,300,0},{202030264,300,0},{202030265,300,0},{202030266,300,0},{202030267,500,0},{202030268,300,0},{202030269,500,0}]',0,0,0,5067,'[202030262,202030263,202030264,202030265,202030266,202030267,202030268,202030269]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"7000\",\"effect\":\"[]\"}]'),(202030269,'巴哈技能7','巴哈技能7',11,1,0,1,0,0,2,2,1,2,1000,1,'0','[{202030262,2500,0},{202030263,300,0},{202030264,300,0},{202030265,300,0},{202030266,300,0},{202030267,500,0},{202030268,300,0},{202030269,500,0}]',0,0,0,1000,'[202030262,202030263,202030264,202030265,202030266,202030267,202030268,202030269]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"9000\",\"effect\":\"[]\"}]'),(202030301,'D5普攻1','星界试炼怪物技能',11,1,1,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"2000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[3,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(202030302,'D5技能1','星界试炼怪物技能',11,1,0,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,1000,'[]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"500\",\"num\":\"[5,5]\",\"attr\":\"[]\",\"hurt\":\"15000\",\"effect\":\"[]\"}]'),(202030303,'D5普攻2','星界试炼怪物技能',11,1,1,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"2000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[3,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(202030304,'D5技能2','星界试炼怪物技能',11,1,0,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,1060,'[]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"500\",\"num\":\"[5,5]\",\"attr\":\"[]\",\"hurt\":\"15000\",\"effect\":\"[]\"}]'),(202030305,'C5普攻1','星界试炼怪物技能',11,1,1,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,1060,'0','[]',0,0,'[{\"desc\":\"怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"2000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[3,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(202030306,'C5技能1','星界试炼怪物技能',11,1,0,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,2000,'[]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"500\",\"num\":\"[5,5]\",\"attr\":\"[]\",\"hurt\":\"15000\",\"effect\":\"[]\"}]'),(202030307,'C5普攻2','星界试炼怪物技能',11,1,1,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,1800,'0','[]',0,0,'[{\"desc\":\"怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"2000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[3,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(202030308,'C5技能2','星界试炼怪物技能',11,1,0,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,1000,'[]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"500\",\"num\":\"[5,5]\",\"attr\":\"[]\",\"hurt\":\"15000\",\"effect\":\"[]\"}]'),(202030309,'B5普攻1','星界试炼怪物技能',11,1,1,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"2000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[3,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(202030310,'B5技能1','星界试炼怪物技能',11,1,0,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,2000,'[]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"500\",\"num\":\"[5,5]\",\"attr\":\"[]\",\"hurt\":\"15000\",\"effect\":\"[]\"}]'),(202030311,'B5普攻2','星界试炼怪物技能',11,1,1,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,1800,'0','[]',0,0,'[{\"desc\":\"怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"2000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[3,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(202030312,'B5技能2','星界试炼怪物技能',11,1,0,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,1600,'[]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"500\",\"num\":\"[5,5]\",\"attr\":\"[]\",\"hurt\":\"15000\",\"effect\":\"[]\"}]'),(202030313,'A5普攻1','星界试炼怪物技能',11,1,1,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,2200,'0','[]',0,0,'[{\"desc\":\"怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"2000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[3,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(202030314,'A5技能1','星界试炼怪物技能',11,1,0,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,2000,'[]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"500\",\"num\":\"[5,5]\",\"attr\":\"[]\",\"hurt\":\"15000\",\"effect\":\"[]\"}]'),(202030315,'A5普攻2','星界试炼怪物技能',11,1,1,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,3000,'0','[]',0,0,'[{\"desc\":\"怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"2000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[3,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(202030316,'A5技能2','星界试炼怪物技能',11,1,0,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,1600,'[]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"500\",\"num\":\"[5,5]\",\"attr\":\"[]\",\"hurt\":\"15000\",\"effect\":\"[]\"}]'),(202030317,'S5普攻1','星界试炼怪物技能',11,1,1,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,1200,'0','[]',0,0,'[{\"desc\":\"怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"2000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[3,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(202030318,'S5技能1','星界试炼怪物技能',11,1,0,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,1300,'[]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"500\",\"num\":\"[5,5]\",\"attr\":\"[]\",\"hurt\":\"15000\",\"effect\":\"[]\"}]'),(202030319,'S5普攻2','星界试炼怪物技能',11,1,1,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,1400,'0','[]',0,0,'[{\"desc\":\"怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"2000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[3,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(202030320,'S5技能2','星界试炼怪物技能',11,1,0,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,3000,'[]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"10000\",\"trigger\":\"[]\",\"distance\":\"800\",\"area\":\"500\",\"num\":\"[5,5]\",\"attr\":\"[]\",\"hurt\":\"15000\",\"effect\":\"[]\"}]'),(211701001,'治疗守卫技能','',21,1,0,0,0,0,1,3,0,1,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"1000\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[1,1]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{116,0,1000,2,10000,0,2,1,1,1}]\"}]'),(240100101,'伤害鼓舞','',21,3,0,0,0,0,1,1,0,1,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"伤害提升5%\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{9,2,1000,1,500,0,500000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"伤害提升10%\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{9,2,1000,1,1000,0,500000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"伤害提升15%\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{9,2,1000,1,1500,0,500000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"伤害提升20%\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{9,2,1000,1,2000,0,500000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"伤害提升25%\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{9,2,1000,1,2500,0,500000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"伤害提升30%\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{9,2,1000,1,3000,0,500000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"伤害提升35%\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{9,2,1000,1,3500,0,500000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"伤害提升40%\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{9,2,1000,1,4000,0,500000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"伤害提升45%\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{9,2,1000,1,4500,0,500000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"伤害提升50%\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{9,2,1000,1,5000,0,500000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(420100101,'守卫公会怪物普攻','',11,1,0,0,0,0,1,2,1,1,1000,1,'0','[{420100101,1000,0},{420100102,0,0}]',2000,500,1,1000,'0','[]',0,0,'[{\"desc\":\"守卫公会怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"200\",\"num\":\"[5,5]\",\"attr\":\"\",\"hurt\":\"0\",\"effect\":\"\"}]'),(420100102,'守卫公会怪物普攻','',11,1,0,1,0,0,1,2,1,1,1000,1,'0','[{420100101,1000,0},{420100102,0,0}]',2000,500,1,1000,'0','[]',0,0,'[{\"desc\":\"守卫公会怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"500\",\"area\":\"200\",\"num\":\"[5,5]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(420100401,'生命+20%','',11,3,0,0,0,0,2,3,0,1,1000,1,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"生命+20%\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[100,100]\",\"attr\":\"[{20,2,1000,2,2000,0,360000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(420100501,'伤害+20%','',11,3,0,0,0,0,2,3,0,1,1000,1,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"伤害+20%\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[100,100]\",\"attr\":\"[{27,2,1000,2,2000,0,360000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(440100101,'伤害鼓舞','',21,3,0,0,0,0,1,1,0,1,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"伤害提升5%\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{9,2,1000,1,500,0,500000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"伤害提升10%\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{9,2,1000,1,1000,0,500000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"伤害提升15%\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{9,2,1000,1,1500,0,500000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"伤害提升20%\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{9,2,1000,1,2000,0,500000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"伤害提升25%\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{9,2,1000,1,2500,0,500000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(460100001,'伤害+20%','',0,3,0,0,0,0,2,3,0,1,1000,1,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"海贼王之怒\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[]\",\"attr\":\"[{27,2,1000,2,2000,0,360000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(500000001,'重击','铭文技能',1,8,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',1,0,'[{\"desc\":\"华尔兹斩伤害额外增加10%\",\"condition\":\"[{goods,0,19010001,1},{skill,10011011,1},{turn,1}]\",\"power\":\"5000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,1000,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"华尔兹斩伤害额外增加20%\",\"condition\":\"[{goods,0,19010001,2}]\",\"power\":\"9380\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,2000,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"华尔兹斩伤害额外增加31%\",\"condition\":\"[{goods,0,19010001,4}]\",\"power\":\"15010\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,3100,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"华尔兹斩伤害额外增加46%\",\"condition\":\"[{goods,0,19010001,7}]\",\"power\":\"21890\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,4600,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"华尔兹斩伤害额外增加62%\",\"condition\":\"[{goods,0,19010001,12}]\",\"power\":\"30020\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,6200,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(500000002,'割裂','铭文技能',1,9,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',1,0,'[{\"desc\":\"割裂目标，每秒造成基础伤害*16%的额外伤害，持续2秒\",\"condition\":\"[{goods,0,19010002,1},{skill,10011011,1},{turn,1}]\",\"power\":\"7500\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,3,0,0,0,122}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{122,4,1000,2,0,0.16,0,2000,3,1}]\"},{\"desc\":\"割裂目标，每秒造成基础伤害*24%的额外伤害，持续2秒\",\"condition\":\"[{goods,0,19010002,2}]\",\"power\":\"14060\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,3,0,0,0,122}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{122,4,1000,2,0,0.24,0,2000,3,1}]\"},{\"desc\":\"割裂目标，每秒造成基础伤害*32%的额外伤害，持续2秒\",\"condition\":\"[{goods,0,19010002,4}]\",\"power\":\"22500\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,3,0,0,0,122}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{122,4,1000,2,0,0.32,0,2000,3,1}]\"},{\"desc\":\"割裂目标，每秒造成基础伤害*40%的额外伤害，持续2秒\",\"condition\":\"[{goods,0,19010002,7}]\",\"power\":\"32810\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,3,0,0,0,122}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{122,4,1000,2,0,0.4,0,2000,3,1}]\"},{\"desc\":\"割裂目标，每秒造成基础伤害*48%的额外伤害，持续2秒\",\"condition\":\"[{goods,0,19010002,12}]\",\"power\":\"45000\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,3,0,0,0,122}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{122,4,1000,2,0,0.48,0,2000,3,1}]\"}]'),(500000003,'刺伤','铭文技能',1,8,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',1,0,'[{\"desc\":\"魔爪突刺伤害额外增加13%\",\"condition\":\"[{goods,0,19010003,1},{skill,10011021,1},{turn,2}]\",\"power\":\"6000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,1300,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"魔爪突刺伤害额外增加24%\",\"condition\":\"[{goods,0,19010003,2}]\",\"power\":\"11250\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,2400,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"魔爪突刺伤害额外增加38%\",\"condition\":\"[{goods,0,19010003,4}]\",\"power\":\"18000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,3800,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"魔爪突刺伤害额外增加56%\",\"condition\":\"[{goods,0,19010003,7}]\",\"power\":\"26250\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,5600,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"魔爪突刺伤害额外增加77%\",\"condition\":\"[{goods,0,19010003,12}]\",\"power\":\"36000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,7700,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(500000004,'泥沼','铭文技能',1,8,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',1,0,'[{\"desc\":\"有25%的概率降低目标8%的移速，持续3秒\",\"condition\":\"[{goods,0,19010004,1},{skill,10011021,1},{turn,2}]\",\"power\":\"9000\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[{0,1000,0,1,0,0,0,121}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{121,4,250,2,0,-0.08,0,3000,1,1}]\"},{\"desc\":\"有25%的概率降低目标12%的移速，持续3秒\",\"condition\":\"[{goods,0,19010004,2}]\",\"power\":\"16880\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[{0,1000,0,1,0,0,0,121}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{121,4,250,2,0,-0.12,0,3000,1,1}]\"},{\"desc\":\"有25%的概率降低目标18%的移速，持续3秒\",\"condition\":\"[{goods,0,19010004,4}]\",\"power\":\"27010\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[{0,1000,0,1,0,0,0,121}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{121,4,250,2,0,-0.18,0,3000,1,1}]\"},{\"desc\":\"有25%的概率降低目标24%的移速，持续3秒\",\"condition\":\"[{goods,0,19010004,7}]\",\"power\":\"39390\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[{0,1000,0,1,0,0,0,121}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{121,4,250,2,0,-0.24,0,3000,1,1}]\"},{\"desc\":\"有25%的概率降低目标30%的移速，持续3秒\",\"condition\":\"[{goods,0,19010004,12}]\",\"power\":\"54020\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[{0,1000,0,1,0,0,0,121}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{121,4,250,2,0,-0.3,0,3000,1,1}]\"}]'),(500000005,'暴怒','铭文技能',1,8,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',1,0,'[{\"desc\":\"战意喷涌伤害额外增加15%\",\"condition\":\"[{goods,0,19010005,1},{skill,10011031,1},{turn,3}]\",\"power\":\"7000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,1500,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"战意喷涌伤害额外增加29%\",\"condition\":\"[{goods,0,19010005,2}]\",\"power\":\"13130\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,2900,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"战意喷涌伤害额外增加46%\",\"condition\":\"[{goods,0,19010005,4}]\",\"power\":\"21010\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,4600,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"战意喷涌伤害额外增加67%\",\"condition\":\"[{goods,0,19010005,7}]\",\"power\":\"30640\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,6700,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"战意喷涌伤害额外增加91%\",\"condition\":\"[{goods,0,19010005,12}]\",\"power\":\"42020\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,9100,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(500000006,'震慑','铭文技能',1,8,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',1,0,'[{\"desc\":\"攻击时有25%的概率降低对方6%的防御，持续3秒\",\"condition\":\"[{goods,0,19010006,1},{skill,10011031,1},{turn,3}]\",\"power\":\"10500\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[{0,1000,0,1,0,0,0,4}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{4,0,250,2,0,-0.06,3000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有25%的概率降低对方10%的防御，持续3秒\",\"condition\":\"[{goods,0,19010006,2}]\",\"power\":\"19690\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[{0,1000,0,1,0,0,0,4}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{4,0,250,2,0,-0.1,3000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有25%的概率降低对方15%的防御，持续3秒\",\"condition\":\"[{goods,0,19010006,4}]\",\"power\":\"31500\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[{0,1000,0,1,0,0,0,4}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{4,0,250,2,0,-0.15,3000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有25%的概率降低对方20%的防御，持续3秒\",\"condition\":\"[{goods,0,19010006,7}]\",\"power\":\"45940\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[{0,1000,0,1,0,0,0,4}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{4,0,250,2,0,-0.2,3000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有25%的概率降低对方25%的防御，持续3秒\",\"condition\":\"[{goods,0,19010006,12}]\",\"power\":\"63000\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[{0,1000,0,1,0,0,0,4}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{4,0,250,2,0,-0.25,3000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(500000007,'斩痕','铭文技能',1,8,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',1,0,'[{\"desc\":\"虚空斩击伤害额外增加29%\",\"condition\":\"[{goods,0,19010007,1},{skill,10011041,1},{turn,4}]\",\"power\":\"8000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,2900,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"虚空斩击伤害额外增加54%\",\"condition\":\"[{goods,0,19010007,2}]\",\"power\":\"15000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,5400,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"虚空斩击伤害额外增加86%\",\"condition\":\"[{goods,0,19010007,4}]\",\"power\":\"24000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,8600,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"虚空斩击伤害额外增加126%\",\"condition\":\"[{goods,0,19010007,7}]\",\"power\":\"35000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,12600,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"虚空斩击伤害额外增加173%\",\"condition\":\"[{goods,0,19010007,12}]\",\"power\":\"48000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,17300,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(500000008,'空震','铭文技能',1,8,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',1,0,'[{\"desc\":\"该技能命中敌人时，有10%概率眩晕敌人2秒\",\"condition\":\"[{goods,0,19010008,1},{skill,10011041,1},{turn,4}]\",\"power\":\"12000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{101,3,100,4,0,0,0,2000,0,1}]\"},{\"desc\":\"该技能命中敌人时，有15%概率眩晕敌人2秒\",\"condition\":\"[{goods,0,19010008,2}]\",\"power\":\"22500\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{101,3,150,4,0,0,0,2000,0,1}]\"},{\"desc\":\"该技能命中敌人时，有20%概率眩晕敌人2秒\",\"condition\":\"[{goods,0,19010008,4}]\",\"power\":\"36000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"20000\",\"effect\":\"[{101,3,200,4,0,0,0,2000,0,1}]\"},{\"desc\":\"该技能命中敌人时，有25%概率眩晕敌人2秒\",\"condition\":\"[{goods,0,19010008,7}]\",\"power\":\"52500\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{101,3,250,4,0,0,0,2000,0,1}]\"},{\"desc\":\"该技能命中敌人时，有30%概率眩晕敌人2秒\",\"condition\":\"[{goods,0,19010008,12}]\",\"power\":\"72000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{101,3,300,4,0,0,0,2000,0,1}]\"}]'),(500000021,'翔击','铭文技能',2,8,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',1,0,'[{\"desc\":\"翔龙突刺伤害额外增加10%\",\"condition\":\"[{goods,0,19010011,1},{skill,10012011,1},{turn,1}]\",\"power\":\"5000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,1000,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"翔龙突刺伤害额外增加18%\",\"condition\":\"[{goods,0,19010011,2}]\",\"power\":\"9380\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,1800,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"翔龙突刺伤害额外增加29%\",\"condition\":\"[{goods,0,19010011,4}]\",\"power\":\"15010\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,2900,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"翔龙突刺伤害额外增加42%\",\"condition\":\"[{goods,0,19010011,7}]\",\"power\":\"21890\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,4200,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"翔龙突刺伤害额外增加58%\",\"condition\":\"[{goods,0,19010011,12}]\",\"power\":\"30020\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,5800,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(500000022,'龙吼','铭文技能',2,8,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',1,0,'[{\"desc\":\"攻击时，有25%的概率提高自身6%的攻击，持续3秒\",\"condition\":\"[{goods,0,19010012,1},{skill,10012011,1},{turn,1}]\",\"power\":\"7500\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,3,0,0,0,1}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{1,0,250,1,0,0.06,3000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时，有25%的概率提高自身10%的攻击，持续3秒\",\"condition\":\"[{goods,0,19010012,2}]\",\"power\":\"14060\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,3,0,0,0,1}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{1,0,250,1,0,0.1,3000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时，有25%的概率提高自身15%的攻击，持续3秒\",\"condition\":\"[{goods,0,19010012,4}]\",\"power\":\"22500\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,3,0,0,0,1}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{1,0,250,1,0,0.15,3000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时，有25%的概率提高自身20%的攻击，持续3秒\",\"condition\":\"[{goods,0,19010012,7}]\",\"power\":\"32810\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,3,0,0,0,1}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{1,0,250,1,0,0.2,2000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时，有25%的概率提高自身25%的攻击，持续5秒\",\"condition\":\"[{goods,0,19010012,12}]\",\"power\":\"45000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,3,0,0,0,1}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{1,0,250,1,0,0.25,2000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(500000023,'光击','铭文技能',2,8,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',1,0,'[{\"desc\":\"流光枪舞伤害额外增加27%\",\"condition\":\"[{goods,0,19010013,1},{skill,10012021,1},{turn,2}]\",\"power\":\"6000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,2700,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"流光枪舞伤害额外增加51%\",\"condition\":\"[{goods,0,19010013,2}]\",\"power\":\"11250\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,5100,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"流光枪舞伤害额外增加82%\",\"condition\":\"[{goods,0,19010013,4}]\",\"power\":\"18000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,8200,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"流光枪舞伤害额外增加119%\",\"condition\":\"[{goods,0,19010013,7}]\",\"power\":\"26250\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,11900,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"流光枪舞伤害额外增加163%\",\"condition\":\"[{goods,0,19010013,12}]\",\"power\":\"36000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,16300,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(500000024,'流沙','铭文技能',2,8,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',1,0,'[{\"desc\":\"有25%的概率降低目标8%的移速，持续3秒\",\"condition\":\"[{goods,0,19010014,1},{skill,10012021,1},{turn,2}]\",\"power\":\"9000\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[{0,1000,0,1,0,0,0,121}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{121,4,250,2,0,-0.08,0,3000,1,1}]\"},{\"desc\":\"有25%的概率降低目标12%的移速，持续3秒\",\"condition\":\"[{goods,0,19010014,2}]\",\"power\":\"16880\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[{0,1000,0,1,0,0,0,121}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{121,4,250,2,0,-0.12,0,3000,1,1}]\"},{\"desc\":\"有25%的概率降低目标18%的移速，持续3秒\",\"condition\":\"[{goods,0,19010014,4}]\",\"power\":\"27010\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[{0,1000,0,1,0,0,0,121}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{121,4,250,2,0,-0.18,0,3000,1,1}]\"},{\"desc\":\"有25%的概率降低目标24%的移速，持续3秒\",\"condition\":\"[{goods,0,19010014,7}]\",\"power\":\"39390\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[{0,1000,0,1,0,0,0,121}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{121,4,250,2,0,-0.24,0,3000,1,1}]\"},{\"desc\":\"有25%的概率降低目标30%的移速，持续3秒\",\"condition\":\"[{goods,0,19010014,12}]\",\"power\":\"54020\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[{0,1000,0,1,0,0,0,121}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{121,4,250,2,0,-0.3,0,3000,1,1}]\"}]'),(500000025,'龙息','铭文技能',2,8,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',1,0,'[{\"desc\":\"巨龙吐息伤害额外增加18%\",\"condition\":\"[{goods,0,19010015,1},{skill,10012031,1},{turn,3}]\",\"power\":\"7000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,1800,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"巨龙吐息伤害额外增加33%\",\"condition\":\"[{goods,0,19010015,2}]\",\"power\":\"13130\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,3300,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"巨龙吐息伤害额外增加53%\",\"condition\":\"[{goods,0,19010015,4}]\",\"power\":\"21010\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,5300,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"巨龙吐息伤害额外增加77%\",\"condition\":\"[{goods,0,19010015,7}]\",\"power\":\"30640\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,7700,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"巨龙吐息伤害额外增加106%\",\"condition\":\"[{goods,0,19010015,12}]\",\"power\":\"42020\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,10600,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(500000026,'电疗','铭文技能',2,8,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',1,0,'[{\"desc\":\"电疗目标，每秒造成基础伤害*16%的额外伤害，持续2秒\",\"condition\":\"[{goods,0,19010016,1},{skill,10012031,1},{turn,3}]\",\"power\":\"10500\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,3,0,0,0,122}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{122,4,1000,2,0,0.16,0,2000,3,1}]\"},{\"desc\":\"电疗目标，每秒造成基础伤害*24%的额外伤害，持续2秒\",\"condition\":\"[{goods,0,19010016,2}]\",\"power\":\"19690\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,3,0,0,0,122}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{122,4,1000,2,0,0.24,0,2000,3,1}]\"},{\"desc\":\"电疗目标，每秒造成基础伤害*32%的额外伤害，持续2秒\",\"condition\":\"[{goods,0,19010016,4}]\",\"power\":\"31500\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,3,0,0,0,122}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{122,4,1000,2,0,0.32,0,2000,3,1}]\"},{\"desc\":\"电疗目标，每秒造成基础伤害*40%的额外伤害，持续2秒\",\"condition\":\"[{goods,0,19010016,7}]\",\"power\":\"45940\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,3,0,0,0,122}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{122,4,1000,2,0,0.4,0,2000,3,1}]\"},{\"desc\":\"电疗目标，每秒造成基础伤害*48%的额外伤害，持续2秒\",\"condition\":\"[{goods,0,19010016,12}]\",\"power\":\"63000\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,3,0,0,0,122}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{122,4,1000,2,0,0.48,0,2000,3,1}]\"}]'),(500000027,'龙怒','铭文技能',2,8,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',1,0,'[{\"desc\":\"审判枪罚伤害额外增加27%\",\"condition\":\"[{goods,0,19010017,1},{skill,10012041,1},{turn,4}]\",\"power\":\"8000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,2700,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"审判枪罚伤害额外增加51%\",\"condition\":\"[{goods,0,19010017,2}]\",\"power\":\"15000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,5100,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"审判枪罚伤害额外增加82%\",\"condition\":\"[{goods,0,19010017,4}]\",\"power\":\"24000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,8200,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"审判枪罚伤害额外增加119%\",\"condition\":\"[{goods,0,19010017,7}]\",\"power\":\"35000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,11900,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"审判枪罚伤害额外增加163%\",\"condition\":\"[{goods,0,19010017,12}]\",\"power\":\"48000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,16300,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(500000028,'天罚','铭文技能',2,8,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',1,0,'[{\"desc\":\"该技能命中敌人时，有10%概率眩晕敌人2秒\",\"condition\":\"[{goods,0,19010018,1},{skill,10012041,1},{turn,4}]\",\"power\":\"12000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{101,3,100,4,0,0,0,2000,0,1}]\"},{\"desc\":\"该技能命中敌人时，有15%概率眩晕敌人2秒\",\"condition\":\"[{goods,0,19010018,2}]\",\"power\":\"22500\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{101,3,150,4,0,0,0,2000,0,1}]\"},{\"desc\":\"该技能命中敌人时，有20%概率眩晕敌人2秒\",\"condition\":\"[{goods,0,19010018,4}]\",\"power\":\"36000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{101,3,200,4,0,0,0,2000,0,1}]\"},{\"desc\":\"该技能命中敌人时，有25%概率眩晕敌人2秒\",\"condition\":\"[{goods,0,19010018,7}]\",\"power\":\"52500\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{101,3,250,4,0,0,0,2000,0,1}]\"},{\"desc\":\"该技能命中敌人时，有30%概率眩晕敌人2秒\",\"condition\":\"[{goods,0,19010018,12}]\",\"power\":\"72000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{101,3,300,4,0,0,0,2000,0,1}]\"}]'),(500000031,'铭文.怒','铭文技能',3,8,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',1,0,'[{\"desc\":\"技能伤害额外增加5%\",\"condition\":\"[{goods,0,19010021,1},{skill,10013011,1},{turn,1}]\",\"power\":\"2000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,0,0.05,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"技能伤害额外增加10%\",\"condition\":\"[{goods,0,19010021,2}]\",\"power\":\"3000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,0,0.1,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"技能伤害额外增加15%\",\"condition\":\"[{goods,0,19010021,2}]\",\"power\":\"5000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,0,0.15,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(500000032,'铭文·风','铭文技能',3,8,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',1,0,'[{\"desc\":\"攻击时，有25%的概率降低目标5%的命中，持续5秒\",\"condition\":\"[{goods,0,19010022,1},{skill,10013011,1},{turn,1}]\",\"power\":\"2000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,1,0,0,0,4}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[3,6]\",\"attr\":\"[{4,0,300,2,0,-0.05,5000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时，有25%的概率降低目标8%的命中，持续5秒\",\"condition\":\"[{goods,0,19010022,1}]\",\"power\":\"4000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,1,0,0,0,4}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[3,6]\",\"attr\":\"[{4,0,300,2,0,-0.08,5000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时，有25%的概率降低目标10%的防御，持续5秒\",\"condition\":\"[{goods,0,19010022,2}]\",\"power\":\"6000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,1,0,0,0,4}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[3,6]\",\"attr\":\"[{4,0,300,2,0,-0.1,5000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(500000033,'铭文·雷','铭文技能',3,8,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',1,0,'[{\"desc\":\"攻击时，有25%的概率提高自身5%的攻击，持续5秒\",\"condition\":\"[{goods,0,19010023,1},{skill,10013021,1},{turn,2}]\",\"power\":\"2000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,3,0,0,0,1}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{1,0,300,1,0,0.05,5000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时，有25%的概率提高自身8%的攻击，持续5秒\",\"condition\":\"[{goods,0,19010023,1}]\",\"power\":\"4000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,3,0,0,0,1}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{1,0,300,1,0,0.08,5000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时，有25%的概率提高自身10%的攻击，持续5秒\",\"condition\":\"[{goods,0,19010023,2}]\",\"power\":\"6000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,3,0,0,0,1}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{1,0,300,1,0,0.1,5000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(500000034,'铭文·电','铭文技能',3,8,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',1,0,'[{\"desc\":\"有5%的概率降低目标30%的移速，持续5秒，冷却30秒\",\"condition\":\"[{goods,0,19010024,1},{skill,10013021,1},{turn,2}]\",\"power\":\"2000\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[{0,1000,0,1,0,0,0,121}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{121,4,50,2,0,-0.3,0,5000,1,0}]\"},{\"desc\":\"有10%的概率降低目标30%的移速，持续5秒，冷却30秒\",\"condition\":\"[{goods,0,19010024,1}]\",\"power\":\"5000\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[{0,1000,0,1,0,0,0,121}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{121,4,100,2,0,-0.3,0,5000,1,0}]\"},{\"desc\":\"有30%的概率降低目标30%的移速，持续5秒，冷却30秒\",\"condition\":\"[{goods,0,19010024,2}]\",\"power\":\"8000\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[{0,1000,0,1,0,0,0,121}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{121,4,200,2,0,-0.3,0,5000,1,0}]\"}]'),(500000035,'铭文·金','铭文技能',3,8,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',1,0,'[{\"desc\":\"攻击时有5%的概率降低对方3%的防御，持续5秒\",\"condition\":\"[{goods,0,19010025,1},{skill,10013031,1},{turn,3}]\",\"power\":\"2000\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[{0,1000,0,1,0,0,0,4}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{4,0,50,2,0,-0.03,5000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有5%的概率降低对方3%的防御，持续5秒\",\"condition\":\"[{goods,0,19010025,1}]\",\"power\":\"4000\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[{0,1000,0,1,0,0,0,4}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{4,0,50,2,0,-0.03,5000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时有5%的概率降低对方3%的防御，持续5秒\",\"condition\":\"[{goods,0,19010025,2}]\",\"power\":\"6000\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[{0,1000,0,1,0,0,0,4}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{4,0,50,2,0,-0.03,5000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(500000036,'铭文·魂','铭文技能',3,8,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',1,0,'[{\"desc\":\"10%的几率减少该技能2秒的冷却时间\",\"condition\":\"[{goods,0,19010026,1},{skill,10013031,1},{turn,3}]\",\"power\":\"1500\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,1,0,0,0,123}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[1,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{123,4,100,1,2000,0,10013031,0,1,0}]\"},{\"desc\":\"20%的几率减少该技能2秒的冷却时间\",\"condition\":\"[{goods,0,19010026,1}]\",\"power\":\"3000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,1,0,0,0,123}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{123,4,200,1,2000,0,10013031,0,1,0}]\"},{\"desc\":\"30%的几率减少该技能2秒的冷却时间\",\"condition\":\"[{goods,0,19010026,2}]\",\"power\":\"4500\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,1,0,0,0,123}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{123,4,300,1,2000,0,10013031,0,1,0}]\"}]'),(500000037,'铭文·暗','铭文技能',3,8,0,0,0,0,0,0,1,1,0,0,'0','[]',0,0,0,0,'0','[]',1,0,'[{\"desc\":\"解除负面状态，同时获得10%最大血量的护盾，持续5秒\",\"condition\":\"[{goods,0,19010027,1},{skill,10013041,1},{turn,4}]\",\"power\":\"3000\",\"base_attr\":\"\",\"cd\":\"30000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[1,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{118,4,1000,1,0,0,0,0,1,0},{104,4,1000,1,0,0.1,2,5000,0,0}]\"},{\"desc\":\"解除负面状态，同时获得20%最大血量的护盾，持续5秒\",\"condition\":\"[{goods,0,19010027,1}]\",\"power\":\"5000\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[1,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{118,4,1000,1,0,0,0,0,1,0},{104,4,1000,1,0,0.2,2,5000,0,0}]\"},{\"desc\":\"解除负面状态，同时获得30%最大血量的护盾，持续5秒\",\"condition\":\"[{goods,0,19010027,2}]\",\"power\":\"8000\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[1,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{118,4,1000,1,0,0,0,0,1,0},{104,4,1000,1,0,0.3,2,5000,0,0}]\"}]'),(500000038,'铭文·氪','铭文技能',3,8,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',1,0,'[{\"desc\":\"灼烧目标，每秒造成基础伤害*10%的额外伤害，持续5秒\",\"condition\":\"[{goods,0,19010028,1},{skill,10013041,1},{turn,4}]\",\"power\":\"2000\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,3,0,0,0,122}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{122,4,200,2,0,0.1,0,5000,3,1}]\"},{\"desc\":\"灼烧目标，每秒造成基础伤害*12%的额外伤害，持续5秒\",\"condition\":\"[{goods,0,19010028,1}]\",\"power\":\"4000\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,3,0,0,0,122}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{122,4,200,2,0,0.12,0,5000,3,1}]\"},{\"desc\":\"灼烧目标，每秒造成基础伤害*15%的额外伤害，持续5秒\",\"condition\":\"[{goods,0,19010028,2}]\",\"power\":\"6000\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,3,0,0,0,122}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{122,4,200,2,0,0.15,0,5000,3,1}]\"}]'),(500000041,'怒焰','铭文技能',4,8,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',2,0,'[{\"desc\":\"零距喷射伤害额外增加12%\",\"condition\":\"[{goods,0,19010031,1},{skill,10014011,1},{turn,1}]\",\"power\":\"5000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,1200,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"零距喷射伤害额外增加23%\",\"condition\":\"[{goods,0,19010031,2}]\",\"power\":\"9380\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,2300,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"零距喷射伤害额外增加36%\",\"condition\":\"[{goods,0,19010031,4}]\",\"power\":\"15010\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,3600,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"零距喷射伤害额外增加53%\",\"condition\":\"[{goods,0,19010031,7}]\",\"power\":\"21890\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,5300,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"零距喷射伤害额外增加72%\",\"condition\":\"[{goods,0,19010031,12}]\",\"power\":\"30020\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,7200,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(500000042,'致盲','铭文技能',4,8,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',2,0,'[{\"desc\":\"攻击时，有25%的概率降低目标6%的命中，持续3秒\",\"condition\":\"[{goods,0,19010032,1},{skill,10014011,1},{turn,1}]\",\"power\":\"7500\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,1,0,0,0,4}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[3,6]\",\"attr\":\"[{5,0,250,2,0,-0.06,3000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时，有25%的概率降低目标10%的命中，持续3秒\",\"condition\":\"[{goods,0,19010032,2}]\",\"power\":\"14060\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,1,0,0,0,4}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[3,6]\",\"attr\":\"[{5,0,250,2,0,-0.1,3000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时，有25%的概率降低目标15%的命中，持续3秒\",\"condition\":\"[{goods,0,19010032,4}]\",\"power\":\"22500\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,1,0,0,0,4}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[3,6]\",\"attr\":\"[{5,0,250,2,0,-0.15,3000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时，有25%的概率降低目标20%的命中，持续3秒\",\"condition\":\"[{goods,0,19010032,7}]\",\"power\":\"32810\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,1,0,0,0,4}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[3,6]\",\"attr\":\"[{5,0,250,2,0,-0.2,3000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击时，有25%的概率降低目标25%的命中，持续3秒\",\"condition\":\"[{goods,0,19010032,12}]\",\"power\":\"45000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,1,0,0,0,4}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[3,6]\",\"attr\":\"[{5,0,250,2,0,-0.25,3000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(500000043,'聚能','铭文技能',4,8,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',2,0,'[{\"desc\":\"黑洞效应伤害额外增加16%\",\"condition\":\"[{goods,0,19010033,1},{skill,10014021,1},{turn,2}]\",\"power\":\"6000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,1600,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"黑洞效应伤害额外增加30%\",\"condition\":\"[{goods,0,19010033,2}]\",\"power\":\"11250\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,3000,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"黑洞效应伤害额外增加48%\",\"condition\":\"[{goods,0,19010033,4}]\",\"power\":\"18000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,4800,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"黑洞效应伤害额外增加70%\",\"condition\":\"[{goods,0,19010033,7}]\",\"power\":\"26250\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,7000,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"黑洞效应伤害额外增加96%\",\"condition\":\"[{goods,0,19010033,12}]\",\"power\":\"36000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,9600,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(500000044,'泯灭','铭文技能',4,8,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',2,0,'[{\"desc\":\"灼烧目标，每秒造成基础伤害*16%的额外伤害，持续2秒\",\"condition\":\"[{goods,0,19010034,1},{skill,10014021,1},{turn,2}]\",\"power\":\"9000\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,3,0,0,0,122}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{122,4,1000,2,0,0.16,0,2000,3,1}]\"},{\"desc\":\"灼烧目标，每秒造成基础伤害*24%的额外伤害，持续2秒\",\"condition\":\"[{goods,0,19010034,2}]\",\"power\":\"16880\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,3,0,0,0,122}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{122,4,1000,2,0,0.24,0,2000,3,1}]\"},{\"desc\":\"灼烧目标，每秒造成基础伤害*32%的额外伤害，持续2秒\",\"condition\":\"[{goods,0,19010034,4}]\",\"power\":\"27010\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,3,0,0,0,122}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{122,4,1000,2,0,0.32,0,2000,3,1}]\"},{\"desc\":\"灼烧目标，每秒造成基础伤害*40%的额外伤害，持续2秒\",\"condition\":\"[{goods,0,19010034,7}]\",\"power\":\"39390\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,3,0,0,0,122}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{122,4,1000,2,0,0.4,0,2000,3,1}]\"},{\"desc\":\"灼烧目标，每秒造成基础伤害*48%的额外伤害，持续2秒\",\"condition\":\"[{goods,0,19010034,12}]\",\"power\":\"54020\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[{0,1000,0,3,0,0,0,122}]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"[{122,4,1000,2,0,0.48,0,2000,3,1}]\"}]'),(500000045,'磁暴','铭文技能',4,8,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',2,0,'[{\"desc\":\"重力磁场伤害额外增加23%\",\"condition\":\"[{goods,0,19010035,1},{skill,10014031,1},{turn,3}]\",\"power\":\"7000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,2300,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"重力磁场伤害额外增加44%\",\"condition\":\"[{goods,0,19010035,2}]\",\"power\":\"13130\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,4400,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"重力磁场伤害额外增加70%\",\"condition\":\"[{goods,0,19010035,4}]\",\"power\":\"21010\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,7000,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"重力磁场伤害额外增加102%\",\"condition\":\"[{goods,0,19010035,7}]\",\"power\":\"30640\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,10200,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"重力磁场伤害额外增加139%\",\"condition\":\"[{goods,0,19010035,12}]\",\"power\":\"42020\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,13900,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(500000046,'旋涡','铭文技能',4,8,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',2,0,'[{\"desc\":\"有25%的概率降低目标8%的移速，持续3秒\",\"condition\":\"[{goods,0,19010036,1},{skill,10014031,1},{turn,3}]\",\"power\":\"10500\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[{0,1000,0,1,0,0,0,121}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{121,4,250,2,0,-0.08,0,3000,1,1}]\"},{\"desc\":\"有25%的概率降低目标12%的移速，持续3秒\",\"condition\":\"[{goods,0,19010036,2}]\",\"power\":\"19690\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[{0,1000,0,1,0,0,0,121}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{121,4,250,2,0,-0.12,0,3000,1,1}]\"},{\"desc\":\"有25%的概率降低目标18%的移速，持续3秒\",\"condition\":\"[{goods,0,19010036,4}]\",\"power\":\"31500\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[{0,1000,0,1,0,0,0,121}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{121,4,250,2,0,-0.18,0,3000,1,1}]\"},{\"desc\":\"有25%的概率降低目标24%的移速，持续3秒\",\"condition\":\"[{goods,0,19010036,7}]\",\"power\":\"45940\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[{0,1000,0,1,0,0,0,121}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{121,4,250,2,0,-0.24,0,3000,1,1}]\"},{\"desc\":\"有25%的概率降低目标30%的移速，持续3秒\",\"condition\":\"[{goods,0,19010036,12}]\",\"power\":\"63000\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[{0,1000,0,1,0,0,0,121}]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{121,4,250,2,0,-0.3,0,3000,1,1}]\"}]'),(500000047,'弹幕','铭文技能',4,8,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',2,0,'[{\"desc\":\"暴走轰炸伤害额外增加27%\",\"condition\":\"[{goods,0,19010037,1},{skill,10014041,1},{turn,4}]\",\"power\":\"8000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,2700,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"暴走轰炸伤害额外增加51%\",\"condition\":\"[{goods,0,19010037,2}]\",\"power\":\"15000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,5100,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"暴走轰炸伤害额外增加82%\",\"condition\":\"[{goods,0,19010037,4}]\",\"power\":\"24000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,8200,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"暴走轰炸伤害额外增加119%\",\"condition\":\"[{goods,0,19010037,7}]\",\"power\":\"35000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,11900,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"暴走轰炸伤害额外增加163%\",\"condition\":\"[{goods,0,19010037,12}]\",\"power\":\"48000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{27,0,1000,1,16300,0,0,0,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(500000048,'核爆','铭文技能',4,8,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',2,0,'[{\"desc\":\"该技能命中敌人时，有10%概率眩晕敌人2秒\",\"condition\":\"[{goods,0,19010038,1},{skill,10014041,1},{turn,4}]\",\"power\":\"12000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{101,3,100,4,0,0,0,2000,0,1}]\"},{\"desc\":\"该技能命中敌人时，有15%概率眩晕敌人2秒\",\"condition\":\"[{goods,0,19010038,2}]\",\"power\":\"22500\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{101,3,150,4,0,0,0,2000,0,1}]\"},{\"desc\":\"该技能命中敌人时，有20%概率眩晕敌人2秒\",\"condition\":\"[{goods,0,19010038,4}]\",\"power\":\"36000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{101,3,200,4,0,0,0,2000,0,1}]\"},{\"desc\":\"该技能命中敌人时，有25%概率眩晕敌人2秒\",\"condition\":\"[{goods,0,19010038,7}]\",\"power\":\"52500\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{101,3,250,4,0,0,0,2000,0,1}]\"},{\"desc\":\"该技能命中敌人时，有30%概率眩晕敌人2秒\",\"condition\":\"[{goods,0,19010038,12}]\",\"power\":\"72000\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{101,3,300,4,0,0,0,2000,0,1}]\"}]'),(1013005001,'捕蝶','捕蝶技能',29,1,1,0,0,0,1,2,1,1,0,1,'0','[]',0,0,0,500,'0','[]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"200\",\"trigger\":\"[]\",\"distance\":\"200\",\"area\":\"200\",\"num\":\"[0,1]\",\"attr\":\"[]\",\"hurt\":\"1000\",\"effect\":\"[]\"}]'),(1110000001,'怪物普攻200','通用普攻',11,1,1,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"300\",\"area\":\"200\",\"num\":\"[1,1]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(1110000002,'怪物晕眩技能','通用眩晕',11,1,0,0,0,0,2,2,1,1,1000,2,'0','',0,0,0,1000,'','[]',0,0,'[{\"desc\":\"怪物晕眩技能\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"300\",\"num\":\"[2,0]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"[{101,2,1000,4,0,0,0,2000,1,1}]\"}]'),(1110000003,'怪物普攻100','通用普攻',11,1,1,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"300\",\"area\":\"200\",\"num\":\"[1,1]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(1110000004,'怪物普攻-经验','通用普攻',11,1,1,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"100\",\"area\":\"200\",\"num\":\"[1,1]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(2000201801,'死神普攻','死神普攻',11,1,1,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,1500,'0','[]',0,0,'[{\"desc\":\"怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"200\",\"num\":\"[1,1]\",\"attr\":\"\",\"hurt\":\"15000\",\"effect\":\"\"},{\"desc\":\"怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"200\",\"num\":\"[1,1]\",\"attr\":\"\",\"hurt\":\"15000\",\"effect\":\"\"}]'),(2000202101,'光明神普攻','光明神普攻',11,1,1,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,1500,'0','[]',0,0,'[{\"desc\":\"怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"900\",\"area\":\"200\",\"num\":\"[1,1]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"},{\"desc\":\"怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"900\",\"area\":\"200\",\"num\":\"[1,1]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(2000220221,'蜘蛛技能展示','蜘蛛技能1',11,1,0,0,0,0,2,2,0,1,1000,1,'0','[{2000220221,2500,0},{2000220231,1333,0}]',0,0,0,4333,'[2000220221,2000220231]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"15000\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"600\",\"num\":\"[500,500]\",\"attr\":\"[]\",\"hurt\":\"16000\",\"effect\":\"[]\"}]'),(2000220231,'蜘蛛技能1展示','蜘蛛技能1',11,1,0,1,0,0,2,2,1,1,1000,1,'0','[{2000220221,2500,0},{2000220231,1333,0}]',0,0,0,4333,'[2000220221,2000220231]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"700\",\"area\":\"600\",\"num\":\"[500,500]\",\"attr\":\"[]\",\"hurt\":\"43000\",\"effect\":\"[]\"}]'),(2000230101,'美杜莎普攻','美杜莎普攻',11,1,1,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,1500,'0','[]',0,0,'[{\"desc\":\"怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"900\",\"area\":\"200\",\"num\":\"[1,1]\",\"attr\":\"\",\"hurt\":\"15000\",\"effect\":\"\"}]'),(2000230102,'美杜莎预警','美杜莎预警',11,1,0,0,0,0,2,2,0,1,1000,1,'0','[{2000230102,2500,0},{2000230103,2500,0}]',0,0,0,5000,'[2000230102,2000230103]','[]',0,0,'[{\"desc\":\"123\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"12000\",\"trigger\":\"[]\",\"distance\":\"900\",\"area\":\"700\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"10000\",\"effect\":\"[]\"}]'),(2000230103,'美杜莎技能1','美杜莎技能1',11,1,0,1,0,0,2,2,1,2,1000,1,'0','[{2000230102,2500,0},{2000230103,2500,0}]',0,0,0,2500,'[2000230102,2000230103]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"900\",\"area\":\"800\",\"num\":\"[1,1]\",\"attr\":\"[]\",\"hurt\":\"35000\",\"effect\":\"[]\"}]'),(2000230201,'八岐大蛇普攻','八岐大蛇普攻',11,1,1,0,0,0,2,2,1,1,2667,1,'0','[]',0,0,0,2667,'0','[]',0,0,'[{\"desc\":\"怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"900\",\"area\":\"200\",\"num\":\"[1,1]\",\"attr\":\"\",\"hurt\":\"26670\",\"effect\":\"\"}]'),(2000230202,'八岐大蛇预警','八岐大蛇预警',11,1,0,0,0,0,2,2,0,1,2500,1,'0','[{2000230202,2500,0},{2000230203,1000,0},{2000230203,2333,0}]',0,0,0,5833,'[2000230202,2000230203,2000230204]','[]',0,0,'[{\"desc\":\"123\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"12000\",\"trigger\":\"[]\",\"distance\":\"900\",\"area\":\"700\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"23000\",\"effect\":\"[]\"}]'),(2000230203,'八岐大蛇技能1','八岐大蛇技能1',11,1,0,1,0,0,2,2,1,2,3333,1,'0','[{2000230202,2500,0},{2000230203,1000,0},{2000230203,2333,0}]',0,0,0,5833,'[2000230202,2000230203,2000230204]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"900\",\"area\":\"800\",\"num\":\"[1,1]\",\"attr\":\"[]\",\"hurt\":\"15000\",\"effect\":\"[]\"}]'),(2000230204,'八岐大蛇技能1副技能','八岐大蛇技能1副技能',11,1,0,1,0,0,2,2,1,1,1000,1,'0','[{2000230202,2500,0},{2000230203,1000,0},{2000230203,2333,0}]',0,0,0,5833,'[2000230202,2000230203,2000230204]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"400\",\"trigger\":\"[]\",\"distance\":\"900\",\"area\":\"800\",\"num\":\"[500,500]\",\"attr\":\"[]\",\"hurt\":\"18333\",\"effect\":\"[]\"}]'),(2000230301,'暗裔魔神普攻','暗裔魔神普攻',11,1,1,0,0,0,2,2,1,1,1667,1,'0','[]',0,0,0,1500,'0','[]',0,0,'[{\"desc\":\"怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"200\",\"num\":\"[1,1]\",\"attr\":\"\",\"hurt\":\"16670\",\"effect\":\"\"}]'),(2000230303,'暗裔魔神技能1','暗裔魔神技能1',11,1,0,0,0,0,2,2,1,2,1200,1,'0','[]',0,0,0,1000,'[]','[]',0,0,'[{\"desc\":\"\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"12000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"800\",\"num\":\"[1,1]\",\"attr\":\"[]\",\"hurt\":\"12000\",\"effect\":\"[]\"}]'),(2000540201,'冰神普攻','冰神普攻',11,1,0,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,1000,'0','[]',1,0,'[{\"desc\":\"<color>对前</color>方直线区域2个玩家（2个怪物）造成100%的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(2000540202,'冰神普攻','冰神普攻',11,1,0,0,0,0,2,2,1,1,1000,1,'0','[{2000540202,400,0},{2000540203,300,0},{2000540204,400,0},{2000540205,300,0}]',0,0,0,500,'[2000540202,2000540203,2000540204,2000540205]','[]',1,0,'[{\"desc\":\"<color>对前</color>方直线区域2个玩家（2个怪物）造成100%的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"5000\",\"effect\":\"\"}]'),(2000540203,'冰神普攻四连2','冰神普攻四连2',11,1,1,1,0,0,2,2,1,1,1000,2,'0','[{2000540202,400,0},{2000540203,300,0},{2000540204,400,0},{2000540205,300,0}]',0,0,0,500,'[2000540202,2000540203,2000540204,2000540205]','[]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"5000\",\"effect\":\"\"}]'),(2000540204,'冰神普攻四连3','冰神普攻四连3',11,1,1,1,0,0,2,2,1,1,1000,2,'0','[{2000540202,400,0},{2000540203,300,0},{2000540204,400,0},{2000540205,300,0}]',0,0,0,500,'[2000540202,2000540203,2000540204,2000540205]','[]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"560\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"5000\",\"effect\":\"\"}]'),(2000540205,'冰神普攻四连4','冰神普攻四连4',11,1,1,1,0,0,2,2,1,1,1000,2,'0','[{2000540202,400,0},{2000540203,300,0},{2000540204,400,0},{2000540205,300,0}]',0,0,0,800,'[2000540202,2000540203,2000540204,2000540205]','[]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"1060\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"8000\",\"effect\":\"\"}]'),(2000540206,'冰神预警','冰神预警',11,1,0,0,0,0,2,2,0,1,1000,1,'0','[{2000540206,2500,0},{2000540207,1600,0}]',0,0,0,4100,'[2000540206,2000540207]','[]',0,0,'[{\"desc\":\"123\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"12000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"10000\",\"effect\":\"[]\"}]'),(2000540207,'冰刺碎击','冰刺碎击',11,1,0,1,0,0,2,2,1,1,1600,2,'0','[{2000540206,2500,0},{2000540207,1600,0}]',0,0,0,4100,'[2000540206,2000540207]','[]',1,0,'[{\"desc\":\"对前方直线区域3个玩家（6个怪物）造成200%的伤害\",\"condition\":\"[{lv,6}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"3000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[3,6]\",\"attr\":\"\",\"hurt\":\"41000\",\"effect\":\"\"}]'),(2000540208,'冰神预警','冰神预警',11,1,0,0,0,0,2,2,0,1,1000,1,'0','[{2000540208,2500,0},{2000540209,1667,0}]',0,0,0,4167,'[2000540208,2000540209]','[]',0,0,'[{\"desc\":\"123\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"20000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"10000\",\"effect\":\"[]\"}]'),(2000540209,'寒冰领域','寒冰领域',11,1,0,1,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,4167,'[2000540208,2000540209]','[]',1,0,'[{\"desc\":\"对前方扇形区域4个玩家（8个怪物）造成300%的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"15000\",\"effect\":\"\"}]'),(2000540210,'冰神预警','冰神预警',11,1,0,0,0,0,2,2,0,1,1000,1,'0','[{2000540210,2500,0},{2000540211,1000,0}]',0,0,0,4100,'[2000540210,2000540211]','[]',0,0,'[{\"desc\":\"123\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"10000\",\"effect\":\"[]\"}]'),(2000540211,'冰雪刃舞','冰雪刃舞',11,1,0,1,0,0,2,2,1,1,1000,2,'0','[{2000540210,2500,0},{2000540211,1000,0}]',0,0,0,4100,'[2000540210,2000540211]','[]',1,0,'[{\"desc\":\"对前方扇形区域4个玩家（8个怪物）造成300%的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"41000\",\"effect\":\"\"}]'),(2000540401,'月神普攻','月神普攻',11,1,0,0,0,0,2,2,1,1,1000,2,'0','[]',0,0,0,1667,'0','[]',1,0,'[{\"desc\":\"<color>对前</color>方直线区域2个玩家（2个怪物）造成100%的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"16670\",\"effect\":\"\"},{\"desc\":\"<color>对前</color>方直线区域2个玩家（2个怪物）造成100%的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"16670\",\"effect\":\"\"}]'),(2000540402,'月神普攻','月神普攻',11,1,0,0,0,0,2,2,1,1,1000,2,'0','[{2000540402,767,0},{2000540403,400,0},{2000540404,367,0},{2000540405,1167,0}]',0,0,0,500,'[2000540402,2000540403,2000540404,2000540405]','[]',1,0,'[{\"desc\":\"<color>对前</color>方直线区域2个玩家（2个怪物）造成100%的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"5000\",\"effect\":\"\"},{\"desc\":\"<color>对前</color>方直线区域2个玩家（2个怪物）造成100%的伤害\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"5000\",\"effect\":\"\"}]'),(2000540403,'月神普攻','月神普攻',11,1,1,1,0,0,2,2,1,1,1000,2,'0','[{2000540402,767,0},{2000540403,400,0},{2000540404,367,0},{2000540405,1167,0}]',0,0,0,500,'[2000540402,2000540403,2000540404,2000540405]','[]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"5000\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"300\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"5000\",\"effect\":\"\"}]'),(2000540404,'月神普攻','月神普攻',11,1,1,1,0,0,2,2,1,1,1000,2,'0','[{2000540402,767,0},{2000540403,400,0},{2000540404,367,0},{2000540405,1167,0}]',0,0,0,500,'[2000540402,2000540403,2000540404,2000540405]','[]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"560\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"5000\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"560\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"5000\",\"effect\":\"\"}]'),(2000540405,'月神普攻','月神普攻',11,1,1,1,0,0,2,2,1,1,1000,2,'0','[{2000540402,767,0},{2000540403,400,0},{2000540404,367,0},{2000540405,1167,0}]',0,0,0,800,'[2000540402,2000540403,2000540404,2000540405]','[]',1,0,'[{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"1060\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"8000\",\"effect\":\"\"},{\"desc\":\"\",\"condition\":\"[{lv,1}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"1060\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[2,3]\",\"attr\":\"\",\"hurt\":\"8000\",\"effect\":\"\"}]'),(2000540406,'月神预警','月神预警',11,1,0,0,0,0,2,2,0,1,1000,1,'0','[{2000540406,2500,0},{2000540407,2000,0}]',0,0,0,4500,'[2000540406,2000540407]','[]',0,0,'[{\"desc\":\"123\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"12000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"10000\",\"effect\":\"[]\"},{\"desc\":\"123\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"12000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"10000\",\"effect\":\"[]\"}]'),(2000540407,'月光神罚','月光神罚',11,1,0,1,0,0,2,2,1,1,1600,2,'0','[{2000540406,2500,0},{2000540407,2000,0}]',0,0,0,4500,'[2000540406,2000540407]','[]',1,0,'[{\"desc\":\"对前方直线区域3个玩家（6个怪物）造成200%的伤害\",\"condition\":\"[{lv,6}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"3000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[3,6]\",\"attr\":\"\",\"hurt\":\"45000\",\"effect\":\"\"},{\"desc\":\"对前方直线区域3个玩家（6个怪物）造成200%的伤害\",\"condition\":\"[{lv,6}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"3000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[3,6]\",\"attr\":\"\",\"hurt\":\"45000\",\"effect\":\"\"}]'),(2000540410,'月神预警','月神预警',11,1,0,0,0,0,2,2,0,1,1000,1,'0','[{2000540410,2500,0},{2000540411,1667,0}]',0,0,0,4166,'[2000540410,2000540411]','[]',0,0,'[{\"desc\":\"123\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"10000\",\"effect\":\"[]\"},{\"desc\":\"123\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"30000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[50,50]\",\"attr\":\"[]\",\"hurt\":\"10000\",\"effect\":\"[]\"}]'),(2000540411,'月下独舞','月下独舞',11,1,0,1,0,0,2,2,1,1,1000,2,'0','[{2000540410,2500,0},{2000540411,1667,0}]',0,0,0,4166,'0','[]',1,0,'[{\"desc\":\"对前方扇形区域4个玩家（8个怪物）造成300%的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"41667\",\"effect\":\"\"},{\"desc\":\"对前方扇形区域4个玩家（8个怪物）造成300%的伤害\",\"condition\":\"[{lv,10}]\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"4000\",\"trigger\":\"[]\",\"distance\":\"600\",\"area\":\"600\",\"num\":\"[4,8]\",\"attr\":\"\",\"hurt\":\"41667\",\"effect\":\"\"}]'),(2200000001,'宝宝普攻','宝宝1普攻',22,1,1,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"250\",\"area\":\"200\",\"num\":\"[1,1]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(2200000002,'宝宝普攻','宝宝2普攻',22,1,1,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"250\",\"area\":\"200\",\"num\":\"[1,1]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(2200000003,'宝宝普攻','宝宝3普攻',22,1,1,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"250\",\"area\":\"200\",\"num\":\"[1,1]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(2200000004,'宝宝普攻','宝宝4普攻',22,1,1,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"250\",\"area\":\"200\",\"num\":\"[1,1]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(2200000005,'宝宝普攻','宝宝5普攻',22,1,1,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"250\",\"area\":\"200\",\"num\":\"[1,1]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(2200000006,'宝宝普攻','宝宝6普攻',22,1,1,0,0,0,2,2,1,1,1000,1,'0','[]',0,0,0,1000,'0','[]',0,0,'[{\"desc\":\"怪物普攻\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"250\",\"area\":\"200\",\"num\":\"[1,1]\",\"attr\":\"\",\"hurt\":\"10000\",\"effect\":\"\"}]'),(2200000111,'宝宝大力神','宝宝本体技能',22,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"<color@7>宝宝攻击+1000</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,1,1000}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(2200000112,'宝宝无双盾','宝宝本体技能',22,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"<color@7>宝宝生命+40000</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,2,40000}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(2200000113,'宝宝绝世攻','宝宝本体技能',22,2,0,0,0,0,0,2,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"<color@7>宝宝生命+5%</color>\\\\n<color@7>宝宝命中+5%</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,61,500},{0,64,500}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(2200000114,'宝宝无伤闪','宝宝本体技能',22,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"<color@7>宝宝攻击+8%</color>\\\\n<color@7>宝宝闪避+8%</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,60,800},{0,65,800}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(2200000115,'宝宝大智慧','宝宝本体技能',22,2,0,0,0,0,0,1,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"<color@7>宝宝全属性+8%</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,68,800}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(2200000221,'坐骑之力','宝宝坐骑滑板技能',22,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"<color@7>攻击+715</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,1,715}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(2200000222,'坐骑之命','宝宝坐骑滑板技能',22,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"<color@7>生命+23000</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,2,23000}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(2200000223,'坐骑之攻','宝宝坐骑滑板技能',22,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"<color@7>命中+344</color>\\\\n<color@7>闪避+344</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,5,344},{0,6,344}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(2200000224,'坐骑之闪','宝宝坐骑滑板技能',22,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"<color@7>攻击+1148</color>\\\\n<color@7>生命+22950</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,1,1148},{0,2,22950}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(2200000231,'坐骑之力','宝宝坐骑云技能',22,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"<color@7>攻击+1510</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,1,1510}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(2200000232,'坐骑之命','宝宝坐骑云技能',22,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"<color@7>生命+48400</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,2,48400}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(2200000233,'坐骑之攻','宝宝坐骑云技能',22,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"<color@7>命中+726</color>\\\\n<color@7>闪避+726</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,5,726},{0,6,726}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(2200000234,'坐骑之闪','宝宝坐骑云技能',22,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"<color@7>攻击+2418</color>\\\\n<color@7>生命+48350</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,1,2418},{0,2,48350}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(2200000241,'坐骑之力','宝宝坐骑飞行器技能',22,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"<color@7>攻击+1690</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,1,1690}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(2200000242,'坐骑之命','宝宝坐骑飞行器技能',22,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"<color@7>生命+54100</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,2,54100}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(2200000243,'坐骑之攻','宝宝坐骑飞行器技能',22,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"<color@7>命中+812</color>\\\\n<color@7>闪避+812</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,5,812},{0,6,812}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(2200000244,'坐骑之闪','宝宝坐骑飞行器技能',22,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"<color@7>攻击+2708</color>\\\\n<color@7>生命+54150</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,1,2708},{0,2,54150}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(2200000251,'坐骑之力','宝宝坐骑船技能',22,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"<color@7>攻击+1910</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,1,1910}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(2200000252,'坐骑之命','宝宝坐骑船技能',22,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"<color@7>生命+61100</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,2,61100}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(2200000253,'坐骑之攻','宝宝坐骑船技能',22,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"<color@7>命中+916</color>\\\\n<color@7>闪避+916</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,5,916},{0,6,916}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(2200000254,'坐骑之闪','宝宝坐骑船技能',22,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"<color@7>攻击+3055</color>\\\\n<color@7>生命+6110</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,1,3055},{0,2,61100}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(2200000261,'坐骑之力','宝宝坐骑尸烬龙技能',22,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"<color@7>攻击+715</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,1,715}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(2200000262,'坐骑之命','宝宝坐骑尸烬龙技能',22,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"<color@7>生命+23000</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,2,23000}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(2200000263,'坐骑之攻','宝宝坐骑尸烬龙技能',22,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"<color@7>命中+344</color>\\\\n<color@7>闪避+344</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,5,344},{0,6,344}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(2200000264,'坐骑之闪','宝宝坐骑尸烬龙技能',22,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"<color@7>攻击+1148</color>\\\\n<color@7>生命+22950</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,1,1148},{0,2,22950}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(2220000001,'翅膀之力','宝宝翅膀测试技能1-1',22,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"<color@7>攻击+715</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,1,715}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(2220000002,'翅膀之命','宝宝翅膀测试技能1-2',22,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"<color@7>生命+23000</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,2,23000}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(2220000003,'翅膀之攻','宝宝翅膀测试技能1-3',22,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"<color@7>命中+344</color>\\\\n<color@7>闪避+344</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,5,344},{0,6,344}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(2220000004,'翅膀之闪','宝宝翅膀测试技能1-4',22,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"<color@7>攻击+1148</color>\\\\n<color@7>生命+22950</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,1,1148},{0,2,22950}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(2220000005,'翅膀之力','宝宝翅膀测试技能2-1',22,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"<color@7>攻击+715</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,1,715}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(2220000006,'翅膀之命','宝宝翅膀测试技能2-2',22,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"<color@7>生命+23000</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,2,23000}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(2220000007,'翅膀之攻','宝宝翅膀测试技能2-3',22,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"<color@7>命中+344</color>\\\\n<color@7>闪避+344</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,5,344},{0,6,344}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(2220000008,'翅膀之闪','宝宝翅膀测试技能2-4',22,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"<color@7>攻击+1148</color>\\\\n<color@7>生命+22950</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,1,1148},{0,2,22950}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(2220000009,'翅膀之力','宝宝翅膀测试技能3-1',22,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"<color@7>攻击+715</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,1,715}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(2220000010,'翅膀之命','宝宝翅膀测试技能3-2',22,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"<color@7>生命+23000</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,2,23000}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(2220000011,'翅膀之攻','宝宝翅膀测试技能3-3',22,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"<color@7>命中+344</color>\\\\n<color@7>闪避+344</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,5,344},{0,6,344}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(2220000012,'翅膀之闪','宝宝翅膀测试技能3-4',22,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"<color@7>攻击+1148</color>\\\\n<color@7>生命+22950</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,1,1148},{0,2,22950}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(2220000013,'翅膀之力','宝宝翅膀测试技能3-1',22,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"<color@7>攻击+715</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,1,715}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(2220000014,'翅膀之命','宝宝翅膀测试技能3-2',22,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"<color@7>生命+23000</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,2,23000}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(2220000015,'翅膀之攻','宝宝翅膀测试技能3-3',22,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"<color@7>命中+344</color>\\\\n<color@7>闪避+344</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,5,344},{0,6,344}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(2220000016,'翅膀之闪','宝宝翅膀测试技能3-4',22,2,0,0,0,0,0,0,0,0,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"<color@7>攻击+1148</color>\\\\n<color@7>生命+22950</color>\",\"condition\":\"\",\"power\":\"\",\"base_attr\":\"[{0,1,1148},{0,2,22950}]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"\",\"area\":\"\",\"num\":\"\",\"attr\":\"\",\"hurt\":\"\",\"effect\":\"\"}]'),(3100000001,'增伤buff','三英之战宝箱BUFF',10,3,0,0,0,0,1,1,0,1,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"增伤buff+15%\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{9,0,1000,1,1500,0,60000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(3100000002,'减免buff','三英之战宝箱BUFF',10,3,0,0,0,0,1,1,0,1,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"伤害减免+15%\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{10,0,1000,1,1500,0,60000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(3100000003,'移速提升','三英之战宝箱BUFF',10,3,0,0,0,0,1,1,0,1,0,0,'0','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"移速加成+100\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{18,0,1000,1,100,0,60000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(3100000004,'生命回复buff','三英会战宝箱buff',10,3,0,0,0,0,1,1,0,1,0,0,'[]','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"生命回复 每秒+5%\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[{116,0,1000,1,0,0.05,2,60000,30,0}]\"}]'),(3100000005,'反击增益buff','三英会战 反击buff',10,3,0,0,0,0,1,1,0,1,0,0,'[]','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"攻击提升 +5%\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{19,0,1000,1,500,0,30000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"攻击提升 +10%\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{19,0,1000,1,1000,0,30000,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(3100000006,'怒气buff','三英会战死亡怒气buff',10,3,0,0,0,0,1,1,0,1,0,0,'[]','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"防御提升+1%\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{22,0,1000,1,100,0,99999,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"防御提升+2%\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{22,0,1000,1,200,0,99999,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"防御提升+3%\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{22,0,1000,1,300,0,99999,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"防御提升+4%\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{22,0,1000,1,400,0,99999,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"防御提升+5%\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{22,0,1000,1,500,0,99999,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"防御提升+6%\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{22,0,1000,1,600,0,99999,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"防御提升+7%\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{22,0,1000,1,700,0,99999,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"防御提升+8%\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{22,0,1000,1,800,0,99999,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"防御提升+9%\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{22,0,1000,1,900,0,99999,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"},{\"desc\":\"防御提升+10%\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[]\",\"cd\":\"0\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[{22,0,1000,1,1000,0,99999,1,0}]\",\"hurt\":\"0\",\"effect\":\"[]\"}]'),(3110000001,'三英防御塔回复血量','三英会战防御塔回复',11,2,0,0,0,0,1,1,0,1,0,0,'[]','[]',0,0,0,0,'0','[]',0,0,'[{\"desc\":\"防御塔回血\",\"condition\":\"[]\",\"power\":\"0\",\"base_attr\":\"[{0,201,500}]\",\"cd\":\"10000\",\"trigger\":\"[]\",\"distance\":\"0\",\"area\":\"0\",\"num\":\"[0,0]\",\"attr\":\"[]\",\"hurt\":\"0\",\"effect\":\"[]\"}]');
/*!40000 ALTER TABLE `base_skill` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_skill_buff_ui`
--

DROP TABLE IF EXISTS `base_skill_buff_ui`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_skill_buff_ui` (
  `skill_id` int(10) unsigned NOT NULL COMMENT '技能id',
  `icon_id` int(10) unsigned NOT NULL COMMENT '图标id',
  `name` varchar(255) NOT NULL COMMENT '名字@lang@',
  `desc` varchar(1000) NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`skill_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='技能buff图标配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_skill_buff_ui`
--

LOCK TABLES `base_skill_buff_ui` WRITE;
/*!40000 ALTER TABLE `base_skill_buff_ui` DISABLE KEYS */;
INSERT INTO `base_skill_buff_ui` VALUES (420100401,420100401,'经验加成','经验+30%'),(420100501,420100501,'经验加成','经验+30%');
/*!40000 ALTER TABLE `base_skill_buff_ui` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_skill_power`
--

DROP TABLE IF EXISTS `base_skill_power`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_skill_power` (
  `point` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能点数目',
  `power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能战力',
  PRIMARY KEY (`point`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='技能战力数据';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_skill_power`
--

LOCK TABLES `base_skill_power` WRITE;
/*!40000 ALTER TABLE `base_skill_power` DISABLE KEYS */;
INSERT INTO `base_skill_power` VALUES (1,15),(2,30),(3,45),(4,60),(5,75),(6,90),(7,105),(8,120),(9,135),(10,150),(11,225),(12,300),(13,375),(14,450),(15,525),(16,600),(17,675),(18,750),(19,825),(20,900),(21,1050),(22,1200),(23,1350),(24,1500),(25,1650),(26,1800),(27,1950),(28,2100),(29,2250),(30,2400),(31,2700),(32,3000),(33,3300),(34,3600),(35,3900),(36,4200),(37,4500),(38,4800),(39,5100),(40,5400),(41,5850),(42,6300),(43,6750),(44,7200),(45,7650),(46,8100),(47,8550),(48,9000),(49,9450),(50,9900),(51,10500),(52,11100),(53,11700),(54,12300),(55,12900),(56,13500),(57,14100),(58,14700),(59,15300),(60,15900),(61,16650),(62,17400),(63,18150),(64,18900),(65,19650),(66,20400),(67,21150),(68,21900),(69,22650),(70,23400),(71,24300),(72,25200),(73,26100),(74,27000),(75,27900),(76,28800),(77,29700),(78,30600),(79,31500),(80,32400);
/*!40000 ALTER TABLE `base_skill_power` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_skill_talent`
--

DROP TABLE IF EXISTS `base_skill_talent`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_skill_talent` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '编号',
  `career` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '职业',
  `sort_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排序ID',
  `talent_type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '天赋类型',
  `skill_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能id',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='天赋技能配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_skill_talent`
--

LOCK TABLES `base_skill_talent` WRITE;
/*!40000 ALTER TABLE `base_skill_talent` DISABLE KEYS */;
INSERT INTO `base_skill_talent` VALUES (1,1,1,1,70100101),(2,1,3,1,70100201),(3,1,6,1,70100301),(4,1,2,1,70100401),(5,1,5,1,70100501),(6,1,8,1,70100601),(7,2,1,1,70100111),(8,2,3,1,70100211),(9,2,6,1,70100311),(10,2,2,1,70100411),(11,2,5,1,70100511),(12,2,8,1,70100611),(13,4,1,1,70100121),(14,4,3,1,70100221),(15,4,6,1,70100321),(16,4,2,1,70100421),(17,4,5,1,70100521),(18,4,8,1,70100621),(19,0,4,1,70100701),(20,0,7,1,70100801),(21,0,10,1,70100901),(22,0,9,1,70101001),(23,0,11,1,70101101),(24,0,1,2,70200101),(25,0,3,2,70200201),(26,0,2,2,70200301),(27,0,9,2,70200401),(28,0,5,2,70200501),(29,0,6,2,70200601),(30,0,7,2,70200701),(31,0,8,2,70200801),(32,0,4,2,70200901),(33,1,10,2,70201001),(34,2,10,2,70201011),(35,4,10,2,70201021),(36,0,11,2,70201101),(37,0,2,3,70300101),(38,0,1,3,70300201),(39,0,4,3,70300301),(40,0,3,3,70300401),(41,0,5,3,70300501),(42,0,6,3,70300601),(43,0,7,3,70300701),(44,0,8,3,70300801),(45,0,11,3,70300901),(46,0,9,3,70301001),(47,0,10,3,70301101);
/*!40000 ALTER TABLE `base_skill_talent` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_smashed_egg`
--

DROP TABLE IF EXISTS `base_smashed_egg`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_smashed_egg` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `value` varchar(255) NOT NULL DEFAULT '' COMMENT '值',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '描述',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='砸蛋配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_smashed_egg`
--

LOCK TABLES `base_smashed_egg` WRITE;
/*!40000 ALTER TABLE `base_smashed_egg` DISABLE KEYS */;
INSERT INTO `base_smashed_egg` VALUES (1,'160','一次全砸消耗道具数量'),(2,'20','手动刷新消耗多少钻石'),(3,'38180015','砸蛋消耗道具id');
/*!40000 ALTER TABLE `base_smashed_egg` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_smashed_egg_free`
--

DROP TABLE IF EXISTS `base_smashed_egg_free`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_smashed_egg_free` (
  `times` smallint(1) unsigned NOT NULL DEFAULT '0' COMMENT '第几次',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '需要在线时间',
  PRIMARY KEY (`times`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='免费砸蛋刷新时间';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_smashed_egg_free`
--

LOCK TABLES `base_smashed_egg_free` WRITE;
/*!40000 ALTER TABLE `base_smashed_egg_free` DISABLE KEYS */;
INSERT INTO `base_smashed_egg_free` VALUES (1,60),(2,300),(3,600),(4,1800),(5,3600);
/*!40000 ALTER TABLE `base_smashed_egg_free` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_smashed_egg_goods`
--

DROP TABLE IF EXISTS `base_smashed_egg_goods`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_smashed_egg_goods` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励id',
  `min_wlv` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '世界等级下限(包含)',
  `max_wlv` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '世界等级上限(包含)',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品id',
  `goods_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品数量',
  `weights` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '权重',
  `effect` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否有特效',
  `is_tv` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否有传闻',
  `is_rare` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否稀有',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='砸蛋物品奖励';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_smashed_egg_goods`
--

LOCK TABLES `base_smashed_egg_goods` WRITE;
/*!40000 ALTER TABLE `base_smashed_egg_goods` DISABLE KEYS */;
INSERT INTO `base_smashed_egg_goods` VALUES (1,1,1000,4917010,1,10,1,1,1),(2,1,1000,38180010,1,40,1,1,1),(3,1,1000,38220009,1,2250,1,1,1),(4,1,1000,12030011,1,20,1,1,1),(5,1,1000,38220009,5,70,1,1,1),(6,1,1000,38220009,3,1350,1,1,1),(7,1,1000,12010011,1,20,1,1,1),(8,1,1000,38180012,2,10,1,1,1),(9,1,1000,20030014,1,5,1,1,1),(10,1,1000,18041002,2,20,1,1,1),(11,1,1000,18041002,1,30,1,1,1),(12,1,1000,18041005,2,20,1,1,1),(13,1,1000,38180012,1,20,1,1,1),(14,1,1000,5203004,4,30,1,1,1),(15,1,1000,15020303,1,30,1,1,1),(16,1,1000,18041005,1,30,1,1,1),(17,1,1000,24010001,10,180,0,0,0),(18,1,1000,20060003,1,180,1,1,1),(19,1,1000,53020030,1,180,1,1,1),(20,1,1000,20020001,1,180,1,1,0),(21,1,1000,20020002,1,180,1,1,0),(22,1,1000,16010001,1,180,1,1,0),(23,1,1000,16010002,1,180,1,1,0),(24,1,1000,53030010,1,180,1,1,0),(25,1,1000,53030020,1,180,1,1,0),(26,1,1000,17020001,1,180,1,1,0),(27,1,1000,17020002,1,180,0,1,0),(28,1,1000,32020112,10,20,1,1,1),(29,1,1000,32020112,5,50,0,0,0),(30,1,1000,32020112,3,100,0,0,0),(31,1,1000,32020113,2,50,1,1,1),(32,1,1000,32020114,1,20,1,1,1),(33,1,1000,16020001,5,310,0,0,0),(34,1,1000,11020001,5,310,0,0,0),(35,1,1000,5203003,3,310,0,0,0),(36,1,1000,38260001,10,310,0,0,0),(37,1,1000,20060001,3,310,0,0,0),(38,1,1000,24010001,3,310,0,0,0),(39,1,1000,53020010,3,310,0,0,0),(40,1,1000,18020001,5,310,0,0,0),(41,1,1000,20060002,1,310,1,1,1),(42,1,1000,15020301,2,310,0,0,0),(43,1,1000,15020302,1,115,1,1,1),(44,1,1000,53020020,1,310,1,1,1),(45,1,1000,14010104,1,50,0,0,0),(46,1,1000,14020204,1,50,0,0,0),(47,1,1000,14010103,1,100,0,0,0),(48,1,1000,14020203,1,100,0,0,0);
/*!40000 ALTER TABLE `base_smashed_egg_goods` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_smashed_egg_reward`
--

DROP TABLE IF EXISTS `base_smashed_egg_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_smashed_egg_reward` (
  `min_wlv` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '世界等级下限(包含)',
  `max_wlv` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '世界等级上限(包含)',
  `times` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '累计次数',
  `reward` varchar(255) NOT NULL DEFAULT '' COMMENT '奖励',
  PRIMARY KEY (`min_wlv`,`max_wlv`,`times`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='砸蛋累计次数奖励';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_smashed_egg_reward`
--

LOCK TABLES `base_smashed_egg_reward` WRITE;
/*!40000 ALTER TABLE `base_smashed_egg_reward` DISABLE KEYS */;
INSERT INTO `base_smashed_egg_reward` VALUES (0,9999,15,'[{0,38220009,8}]'),(0,9999,45,'[{0,38220009,14}]'),(0,9999,95,'[{0,38220009,20}]'),(0,9999,188,'[{0,38220009,88}]');
/*!40000 ALTER TABLE `base_smashed_egg_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_spirit_config`
--

DROP TABLE IF EXISTS `base_spirit_config`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_spirit_config` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '圣灵id',
  `lv` int(11) unsigned NOT NULL DEFAULT '1' COMMENT '培养等级',
  `attr` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '等级属性',
  `exp_max` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '经验上限',
  PRIMARY KEY (`id`,`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_spirit_config`
--

LOCK TABLES `base_spirit_config` WRITE;
/*!40000 ALTER TABLE `base_spirit_config` DISABLE KEYS */;
INSERT INTO `base_spirit_config` VALUES (1,1,'[{1,6},{2,129},{7,3}]',30),(1,2,'[{1,13},{2,271},{7,7}]',45),(1,3,'[{1,21},{2,426},{7,11}]',60),(1,4,'[{1,29},{2,594},{7,15}]',70),(1,5,'[{1,38},{2,775},{7,20}]',80),(1,6,'[{1,48},{2,968},{7,25}]',90),(1,7,'[{1,58},{2,1174},{7,30}]',100),(1,8,'[{1,69},{2,1393},{7,35}]',110),(1,9,'[{1,81},{2,1625},{7,41}]',120),(1,10,'[{1,93},{2,1870},{7,47}]',130),(1,11,'[{1,106},{2,2136},{7,54}]',140),(1,12,'[{1,120},{2,2422},{7,61}]',150),(1,13,'[{1,135},{2,2729},{7,69}]',160),(1,14,'[{1,151},{2,3057},{7,77}]',170),(1,15,'[{1,168},{2,3405},{7,86}]',180),(1,16,'[{1,186},{2,3774},{7,95}]',190),(1,17,'[{1,205},{2,4164},{7,105}]',200),(1,18,'[{1,226},{2,4574},{7,115}]',210),(1,19,'[{1,248},{2,5005},{7,126}]',220),(1,20,'[{1,271},{2,5464},{7,137}]',230),(1,21,'[{1,295},{2,5952},{7,149}]',240),(1,22,'[{1,321},{2,6468},{7,162}]',250),(1,23,'[{1,348},{2,7012},{7,176}]',260),(1,24,'[{1,377},{2,7585},{7,190}]',270),(1,25,'[{1,407},{2,8186},{7,205}]',280),(1,26,'[{1,438},{2,8815},{7,221}]',290),(1,27,'[{1,471},{2,9473},{7,237}]',300),(1,28,'[{1,505},{2,10159},{7,254}]',310),(1,29,'[{1,541},{2,10881},{7,272}]',320),(1,30,'[{1,579},{2,11639},{7,291}]',335),(1,31,'[{1,619},{2,12434},{7,311}]',355),(1,32,'[{1,661},{2,13265},{7,332}]',375),(1,33,'[{1,704},{2,14132},{7,354}]',395),(1,34,'[{1,749},{2,15035},{7,377}]',415),(1,35,'[{1,796},{2,15974},{7,400}]',435),(1,36,'[{1,845},{2,16949},{7,424}]',455),(1,37,'[{1,896},{2,17960},{7,449}]',475),(1,38,'[{1,949},{2,19015},{7,475}]',495),(1,39,'[{1,1004},{2,20114},{7,502}]',515),(1,40,'[{1,1061},{2,21257},{7,531}]',540),(1,41,'[{1,1120},{2,22444},{7,561}]',565),(1,42,'[{1,1182},{2,23675},{7,592}]',590),(1,43,'[{1,1246},{2,24949},{7,624}]',615),(1,44,'[{1,1312},{2,26267},{7,657}]',640),(1,45,'[{1,1380},{2,27629},{7,691}]',665),(1,46,'[{1,1450},{2,29035},{7,726}]',690),(1,47,'[{1,1523},{2,30493},{7,762}]',715),(1,48,'[{1,1598},{2,32002},{7,800}]',740),(1,49,'[{1,1676},{2,33563},{7,839}]',765),(1,50,'[{1,1757},{2,35175},{7,879}]',795),(1,51,'[{1,1840},{2,36839},{7,921}]',825),(1,52,'[{1,1926},{2,38555},{7,964}]',855),(1,53,'[{1,2014},{2,40322},{7,1008}]',885),(1,54,'[{1,2105},{2,42141},{7,1053}]',915),(1,55,'[{1,2199},{2,44011},{7,1100}]',945),(1,56,'[{1,2295},{2,45941},{7,1148}]',975),(1,57,'[{1,2394},{2,47930},{7,1198}]',1005),(1,58,'[{1,2496},{2,49978},{7,1249}]',1035),(1,59,'[{1,2601},{2,52086},{7,1302}]',1065),(1,60,'[{1,2709},{2,54253},{7,1356}]',1105),(1,61,'[{1,2820},{2,56479},{7,1412}]',1145),(1,62,'[{1,2934},{2,58765},{7,1469}]',1185),(1,63,'[{1,3051},{2,61110},{7,1528}]',1225),(1,64,'[{1,3171},{2,63514},{7,1588}]',1265),(1,65,'[{1,3295},{2,65985},{7,1650}]',1305),(1,66,'[{1,3422},{2,68524},{7,1713}]',1345),(1,67,'[{1,3552},{2,71130},{7,1778}]',1385),(1,68,'[{1,3686},{2,73803},{7,1845}]',1425),(1,69,'[{1,3823},{2,76543},{7,1913}]',1465),(1,70,'[{1,3963},{2,79350},{7,1983}]',1505),(1,71,'[{1,4107},{2,82224},{7,2055}]',1545),(1,72,'[{1,4254},{2,85165},{7,2129}]',1585),(1,73,'[{1,4404},{2,88173},{7,2204}]',1625),(1,74,'[{1,4558},{2,91256},{7,2281}]',1665),(1,75,'[{1,4716},{2,94414},{7,2360}]',1705),(1,76,'[{1,4878},{2,97647},{7,2441}]',1745),(1,77,'[{1,5043},{2,100954},{7,2524}]',1785),(1,78,'[{1,5212},{2,104336},{7,2609}]',1825),(1,79,'[{1,5385},{2,107793},{7,2695}]',1865),(1,80,'[{1,5562},{2,111325},{7,2783}]',1915),(1,81,'[{1,5742},{2,114932},{7,2873}]',1965),(1,82,'[{1,5926},{2,118613},{7,2965}]',2015),(1,83,'[{1,6114},{2,122377},{7,3059}]',2065),(1,84,'[{1,6306},{2,126224},{7,3155}]',2115),(1,85,'[{1,6502},{2,130153},{7,3253}]',2165),(1,86,'[{1,6703},{2,134165},{7,3353}]',2215),(1,87,'[{1,6908},{2,138259},{7,3455}]',2265),(1,88,'[{1,7117},{2,142436},{7,3559}]',2315),(1,89,'[{1,7330},{2,146695},{7,3665}]',2365),(1,90,'[{1,7547},{2,151037},{7,3774}]',2425),(1,91,'[{1,7768},{2,155461},{7,3885}]',2485),(1,92,'[{1,7994},{2,159976},{7,3998}]',2545),(1,93,'[{1,8224},{2,164581},{7,4113}]',2605),(1,94,'[{1,8459},{2,169276},{7,4230}]',2665),(1,95,'[{1,8698},{2,174062},{7,4350}]',2725),(1,96,'[{1,8942},{2,178938},{7,4472}]',2785),(1,97,'[{1,9190},{2,183904},{7,4596}]',2845),(1,98,'[{1,9443},{2,188960},{7,4722}]',2905),(1,99,'[{1,9700},{2,194107},{7,4851}]',2965),(1,100,'[{1,9962},{2,199344},{7,4982}]',3035),(1,101,'[{1,10229},{2,204679},{7,5115}]',3105),(1,102,'[{1,10501},{2,210112},{7,5251}]',3175),(1,103,'[{1,10778},{2,215643},{7,5389}]',3245),(1,104,'[{1,11059},{2,221272},{7,5530}]',3315),(1,105,'[{1,11345},{2,226999},{7,5673}]',3385),(1,106,'[{1,11636},{2,232824},{7,5819}]',3455),(1,107,'[{1,11932},{2,238747},{7,5967}]',3525),(1,108,'[{1,12233},{2,244768},{7,6118}]',3595),(1,109,'[{1,12539},{2,250887},{7,6271}]',3665),(1,110,'[{1,12850},{2,257112},{7,6427}]',3735),(1,111,'[{1,13167},{2,263443},{7,6585}]',3805),(1,112,'[{1,13489},{2,269880},{7,6746}]',3875),(1,113,'[{1,13816},{2,276422},{7,6910}]',3945),(1,114,'[{1,14148},{2,283070},{7,7076}]',4015),(1,115,'[{1,14486},{2,289824},{7,7245}]',4085),(1,116,'[{1,14829},{2,296684},{7,7416}]',4155),(1,117,'[{1,15177},{2,303649},{7,7590}]',4225),(1,118,'[{1,15531},{2,310720},{7,7767}]',4295),(1,119,'[{1,15890},{2,317905},{7,7947}]',4365),(1,120,'[{1,16255},{2,325203},{7,8129}]',4445),(1,121,'[{1,16626},{2,332615},{7,8314}]',4525),(1,122,'[{1,17002},{2,340140},{7,8502}]',4605),(1,123,'[{1,17384},{2,347779},{7,8693}]',4685),(1,124,'[{1,17772},{2,355531},{7,8887}]',4765),(1,125,'[{1,18165},{2,363397},{7,9084}]',4845),(1,126,'[{1,18564},{2,371376},{7,9283}]',4925),(1,127,'[{1,18969},{2,379469},{7,9485}]',5005),(1,128,'[{1,19380},{2,387683},{7,9690}]',5085),(1,129,'[{1,19797},{2,396018},{7,9898}]',5165),(1,130,'[{1,20220},{2,404475},{7,10109}]',5245),(1,131,'[{1,20649},{2,413053},{7,10323}]',5325),(1,132,'[{1,21084},{2,421752},{7,10540}]',5405),(1,133,'[{1,21525},{2,430572},{7,10761}]',5485),(1,134,'[{1,21972},{2,439514},{7,10985}]',5565),(1,135,'[{1,22425},{2,448577},{7,11212}]',5645),(1,136,'[{1,22884},{2,457761},{7,11442}]',5725),(1,137,'[{1,23350},{2,467074},{7,11675}]',5805),(1,138,'[{1,23822},{2,476516},{7,11911}]',5885),(1,139,'[{1,24301},{2,486087},{7,12150}]',5965),(1,140,'[{1,24786},{2,495787},{7,12393}]',6045),(1,141,'[{1,25277},{2,505616},{7,12639}]',6125),(1,142,'[{1,25775},{2,515574},{7,12888}]',6205),(1,143,'[{1,26279},{2,525661},{7,13140}]',6285),(1,144,'[{1,26790},{2,535877},{7,13395}]',6365),(1,145,'[{1,27307},{2,546222},{7,13654}]',6445),(1,146,'[{1,27831},{2,556704},{7,13916}]',6525),(1,147,'[{1,28362},{2,567323},{7,14181}]',6605),(1,148,'[{1,28900},{2,578078},{7,14450}]',6685),(1,149,'[{1,29445},{2,588970},{7,14722}]',6765),(1,150,'[{1,29996},{2,599999},{7,14998}]',0),(2,1,'[{1,6},{2,129},{8,3}]',30),(2,2,'[{1,13},{2,271},{8,7}]',45),(2,3,'[{1,21},{2,426},{8,11}]',60),(2,4,'[{1,29},{2,594},{8,15}]',70),(2,5,'[{1,38},{2,775},{8,20}]',80),(2,6,'[{1,48},{2,968},{8,25}]',90),(2,7,'[{1,58},{2,1174},{8,30}]',100),(2,8,'[{1,69},{2,1393},{8,35}]',110),(2,9,'[{1,81},{2,1625},{8,41}]',120),(2,10,'[{1,93},{2,1870},{8,47}]',130),(2,11,'[{1,106},{2,2136},{8,54}]',140),(2,12,'[{1,120},{2,2422},{8,61}]',150),(2,13,'[{1,135},{2,2729},{8,69}]',160),(2,14,'[{1,151},{2,3057},{8,77}]',170),(2,15,'[{1,168},{2,3405},{8,86}]',180),(2,16,'[{1,186},{2,3774},{8,95}]',190),(2,17,'[{1,205},{2,4164},{8,105}]',200),(2,18,'[{1,226},{2,4574},{8,115}]',210),(2,19,'[{1,248},{2,5005},{8,126}]',220),(2,20,'[{1,271},{2,5464},{8,137}]',230),(2,21,'[{1,295},{2,5952},{8,149}]',240),(2,22,'[{1,321},{2,6468},{8,162}]',250),(2,23,'[{1,348},{2,7012},{8,176}]',260),(2,24,'[{1,377},{2,7585},{8,190}]',270),(2,25,'[{1,407},{2,8186},{8,205}]',280),(2,26,'[{1,438},{2,8815},{8,221}]',290),(2,27,'[{1,471},{2,9473},{8,237}]',300),(2,28,'[{1,505},{2,10159},{8,254}]',310),(2,29,'[{1,541},{2,10881},{8,272}]',320),(2,30,'[{1,579},{2,11639},{8,291}]',335),(2,31,'[{1,619},{2,12434},{8,311}]',355),(2,32,'[{1,661},{2,13265},{8,332}]',375),(2,33,'[{1,704},{2,14132},{8,354}]',395),(2,34,'[{1,749},{2,15035},{8,377}]',415),(2,35,'[{1,796},{2,15974},{8,400}]',435),(2,36,'[{1,845},{2,16949},{8,424}]',455),(2,37,'[{1,896},{2,17960},{8,449}]',475),(2,38,'[{1,949},{2,19015},{8,475}]',495),(2,39,'[{1,1004},{2,20114},{8,502}]',515),(2,40,'[{1,1061},{2,21257},{8,531}]',540),(2,41,'[{1,1120},{2,22444},{8,561}]',565),(2,42,'[{1,1182},{2,23675},{8,592}]',590),(2,43,'[{1,1246},{2,24949},{8,624}]',615),(2,44,'[{1,1312},{2,26267},{8,657}]',640),(2,45,'[{1,1380},{2,27629},{8,691}]',665),(2,46,'[{1,1450},{2,29035},{8,726}]',690),(2,47,'[{1,1523},{2,30493},{8,762}]',715),(2,48,'[{1,1598},{2,32002},{8,800}]',740),(2,49,'[{1,1676},{2,33563},{8,839}]',765),(2,50,'[{1,1757},{2,35175},{8,879}]',795),(2,51,'[{1,1840},{2,36839},{8,921}]',825),(2,52,'[{1,1926},{2,38555},{8,964}]',855),(2,53,'[{1,2014},{2,40322},{8,1008}]',885),(2,54,'[{1,2105},{2,42141},{8,1053}]',915),(2,55,'[{1,2199},{2,44011},{8,1100}]',945),(2,56,'[{1,2295},{2,45941},{8,1148}]',975),(2,57,'[{1,2394},{2,47930},{8,1198}]',1005),(2,58,'[{1,2496},{2,49978},{8,1249}]',1035),(2,59,'[{1,2601},{2,52086},{8,1302}]',1065),(2,60,'[{1,2709},{2,54253},{8,1356}]',1105),(2,61,'[{1,2820},{2,56479},{8,1412}]',1145),(2,62,'[{1,2934},{2,58765},{8,1469}]',1185),(2,63,'[{1,3051},{2,61110},{8,1528}]',1225),(2,64,'[{1,3171},{2,63514},{8,1588}]',1265),(2,65,'[{1,3295},{2,65985},{8,1650}]',1305),(2,66,'[{1,3422},{2,68524},{8,1713}]',1345),(2,67,'[{1,3552},{2,71130},{8,1778}]',1385),(2,68,'[{1,3686},{2,73803},{8,1845}]',1425),(2,69,'[{1,3823},{2,76543},{8,1913}]',1465),(2,70,'[{1,3963},{2,79350},{8,1983}]',1505),(2,71,'[{1,4107},{2,82224},{8,2055}]',1545),(2,72,'[{1,4254},{2,85165},{8,2129}]',1585),(2,73,'[{1,4404},{2,88173},{8,2204}]',1625),(2,74,'[{1,4558},{2,91256},{8,2281}]',1665),(2,75,'[{1,4716},{2,94414},{8,2360}]',1705),(2,76,'[{1,4878},{2,97647},{8,2441}]',1745),(2,77,'[{1,5043},{2,100954},{8,2524}]',1785),(2,78,'[{1,5212},{2,104336},{8,2609}]',1825),(2,79,'[{1,5385},{2,107793},{8,2695}]',1865),(2,80,'[{1,5562},{2,111325},{8,2783}]',1915),(2,81,'[{1,5742},{2,114932},{8,2873}]',1965),(2,82,'[{1,5926},{2,118613},{8,2965}]',2015),(2,83,'[{1,6114},{2,122377},{8,3059}]',2065),(2,84,'[{1,6306},{2,126224},{8,3155}]',2115),(2,85,'[{1,6502},{2,130153},{8,3253}]',2165),(2,86,'[{1,6703},{2,134165},{8,3353}]',2215),(2,87,'[{1,6908},{2,138259},{8,3455}]',2265),(2,88,'[{1,7117},{2,142436},{8,3559}]',2315),(2,89,'[{1,7330},{2,146695},{8,3665}]',2365),(2,90,'[{1,7547},{2,151037},{8,3774}]',2425),(2,91,'[{1,7768},{2,155461},{8,3885}]',2485),(2,92,'[{1,7994},{2,159976},{8,3998}]',2545),(2,93,'[{1,8224},{2,164581},{8,4113}]',2605),(2,94,'[{1,8459},{2,169276},{8,4230}]',2665),(2,95,'[{1,8698},{2,174062},{8,4350}]',2725),(2,96,'[{1,8942},{2,178938},{8,4472}]',2785),(2,97,'[{1,9190},{2,183904},{8,4596}]',2845),(2,98,'[{1,9443},{2,188960},{8,4722}]',2905),(2,99,'[{1,9700},{2,194107},{8,4851}]',2965),(2,100,'[{1,9962},{2,199344},{8,4982}]',3035),(2,101,'[{1,10229},{2,204679},{8,5115}]',3105),(2,102,'[{1,10501},{2,210112},{8,5251}]',3175),(2,103,'[{1,10778},{2,215643},{8,5389}]',3245),(2,104,'[{1,11059},{2,221272},{8,5530}]',3315),(2,105,'[{1,11345},{2,226999},{8,5673}]',3385),(2,106,'[{1,11636},{2,232824},{8,5819}]',3455),(2,107,'[{1,11932},{2,238747},{8,5967}]',3525),(2,108,'[{1,12233},{2,244768},{8,6118}]',3595),(2,109,'[{1,12539},{2,250887},{8,6271}]',3665),(2,110,'[{1,12850},{2,257112},{8,6427}]',3735),(2,111,'[{1,13167},{2,263443},{8,6585}]',3805),(2,112,'[{1,13489},{2,269880},{8,6746}]',3875),(2,113,'[{1,13816},{2,276422},{8,6910}]',3945),(2,114,'[{1,14148},{2,283070},{8,7076}]',4015),(2,115,'[{1,14486},{2,289824},{8,7245}]',4085),(2,116,'[{1,14829},{2,296684},{8,7416}]',4155),(2,117,'[{1,15177},{2,303649},{8,7590}]',4225),(2,118,'[{1,15531},{2,310720},{8,7767}]',4295),(2,119,'[{1,15890},{2,317905},{8,7947}]',4365),(2,120,'[{1,16255},{2,325203},{8,8129}]',4445),(2,121,'[{1,16626},{2,332615},{8,8314}]',4525),(2,122,'[{1,17002},{2,340140},{8,8502}]',4605),(2,123,'[{1,17384},{2,347779},{8,8693}]',4685),(2,124,'[{1,17772},{2,355531},{8,8887}]',4765),(2,125,'[{1,18165},{2,363397},{8,9084}]',4845),(2,126,'[{1,18564},{2,371376},{8,9283}]',4925),(2,127,'[{1,18969},{2,379469},{8,9485}]',5005),(2,128,'[{1,19380},{2,387683},{8,9690}]',5085),(2,129,'[{1,19797},{2,396018},{8,9898}]',5165),(2,130,'[{1,20220},{2,404475},{8,10109}]',5245),(2,131,'[{1,20649},{2,413053},{8,10323}]',5325),(2,132,'[{1,21084},{2,421752},{8,10540}]',5405),(2,133,'[{1,21525},{2,430572},{8,10761}]',5485),(2,134,'[{1,21972},{2,439514},{8,10985}]',5565),(2,135,'[{1,22425},{2,448577},{8,11212}]',5645),(2,136,'[{1,22884},{2,457761},{8,11442}]',5725),(2,137,'[{1,23350},{2,467074},{8,11675}]',5805),(2,138,'[{1,23822},{2,476516},{8,11911}]',5885),(2,139,'[{1,24301},{2,486087},{8,12150}]',5965),(2,140,'[{1,24786},{2,495787},{8,12393}]',6045),(2,141,'[{1,25277},{2,505616},{8,12639}]',6125),(2,142,'[{1,25775},{2,515574},{8,12888}]',6205),(2,143,'[{1,26279},{2,525661},{8,13140}]',6285),(2,144,'[{1,26790},{2,535877},{8,13395}]',6365),(2,145,'[{1,27307},{2,546222},{8,13654}]',6445),(2,146,'[{1,27831},{2,556704},{8,13916}]',6525),(2,147,'[{1,28362},{2,567323},{8,14181}]',6605),(2,148,'[{1,28900},{2,578078},{8,14450}]',6685),(2,149,'[{1,29445},{2,588970},{8,14722}]',6765),(2,150,'[{1,29996},{2,599999},{8,14998}]',0),(3,1,'[{7,4},{8,4},{54,4}]',30),(3,2,'[{7,8},{8,8},{54,8}]',45),(3,3,'[{7,12},{8,12},{54,12}]',60),(3,4,'[{7,17},{8,17},{54,16}]',70),(3,5,'[{7,22},{8,22},{54,21}]',80),(3,6,'[{7,27},{8,27},{54,26}]',90),(3,7,'[{7,33},{8,33},{54,31}]',100),(3,8,'[{7,39},{8,39},{54,36}]',110),(3,9,'[{7,46},{8,46},{54,42}]',120),(3,10,'[{7,53},{8,53},{54,48}]',130),(3,11,'[{7,61},{8,61},{54,54}]',140),(3,12,'[{7,69},{8,69},{54,60}]',150),(3,13,'[{7,78},{8,78},{54,67}]',160),(3,14,'[{7,87},{8,87},{54,74}]',170),(3,15,'[{7,97},{8,97},{54,81}]',180),(3,16,'[{7,107},{8,107},{54,88}]',190),(3,17,'[{7,118},{8,118},{54,96}]',200),(3,18,'[{7,130},{8,130},{54,104}]',210),(3,19,'[{7,142},{8,142},{54,112}]',220),(3,20,'[{7,155},{8,155},{54,120}]',230),(3,21,'[{7,169},{8,169},{54,129}]',240),(3,22,'[{7,184},{8,184},{54,138}]',250),(3,23,'[{7,199},{8,199},{54,147}]',260),(3,24,'[{7,215},{8,215},{54,156}]',270),(3,25,'[{7,232},{8,232},{54,166}]',280),(3,26,'[{7,250},{8,250},{54,176}]',290),(3,27,'[{7,269},{8,269},{54,186}]',300),(3,28,'[{7,288},{8,288},{54,196}]',310),(3,29,'[{7,308},{8,308},{54,207}]',320),(3,30,'[{7,329},{8,329},{54,218}]',335),(3,31,'[{7,352},{8,352},{54,229}]',355),(3,32,'[{7,376},{8,376},{54,240}]',375),(3,33,'[{7,401},{8,401},{54,252}]',395),(3,34,'[{7,427},{8,427},{54,264}]',415),(3,35,'[{7,454},{8,454},{54,276}]',435),(3,36,'[{7,482},{8,482},{54,288}]',455),(3,37,'[{7,511},{8,511},{54,301}]',475),(3,38,'[{7,541},{8,541},{54,314}]',495),(3,39,'[{7,572},{8,572},{54,327}]',515),(3,40,'[{7,604},{8,604},{54,340}]',540),(3,41,'[{7,638},{8,638},{54,354}]',565),(3,42,'[{7,673},{8,673},{54,368}]',590),(3,43,'[{7,709},{8,709},{54,382}]',615),(3,44,'[{7,746},{8,746},{54,396}]',640),(3,45,'[{7,785},{8,785},{54,411}]',665),(3,46,'[{7,825},{8,825},{54,426}]',690),(3,47,'[{7,866},{8,866},{54,441}]',715),(3,48,'[{7,909},{8,909},{54,456}]',740),(3,49,'[{7,953},{8,953},{54,472}]',765),(3,50,'[{7,999},{8,999},{54,488}]',795),(3,51,'[{7,1046},{8,1046},{54,504}]',825),(3,52,'[{7,1095},{8,1095},{54,520}]',855),(3,53,'[{7,1145},{8,1145},{54,537}]',885),(3,54,'[{7,1197},{8,1197},{54,554}]',915),(3,55,'[{7,1250},{8,1250},{54,571}]',945),(3,56,'[{7,1305},{8,1305},{54,588}]',975),(3,57,'[{7,1361},{8,1361},{54,606}]',1005),(3,58,'[{7,1419},{8,1419},{54,624}]',1035),(3,59,'[{7,1479},{8,1479},{54,642}]',1065),(3,60,'[{7,1540},{8,1540},{54,660}]',1105),(3,61,'[{7,1603},{8,1603},{54,679}]',1145),(3,62,'[{7,1668},{8,1668},{54,698}]',1185),(3,63,'[{7,1734},{8,1734},{54,717}]',1225),(3,64,'[{7,1802},{8,1802},{54,736}]',1265),(3,65,'[{7,1872},{8,1872},{54,756}]',1305),(3,66,'[{7,1944},{8,1944},{54,776}]',1345),(3,67,'[{7,2018},{8,2018},{54,796}]',1385),(3,68,'[{7,2094},{8,2094},{54,816}]',1425),(3,69,'[{7,2172},{8,2172},{54,837}]',1465),(3,70,'[{7,2252},{8,2252},{54,858}]',1505),(3,71,'[{7,2333},{8,2333},{54,879}]',1545),(3,72,'[{7,2416},{8,2416},{54,900}]',1585),(3,73,'[{7,2501},{8,2501},{54,922}]',1625),(3,74,'[{7,2588},{8,2588},{54,944}]',1665),(3,75,'[{7,2677},{8,2677},{54,966}]',1705),(3,76,'[{7,2769},{8,2769},{54,988}]',1745),(3,77,'[{7,2863},{8,2863},{54,1011}]',1785),(3,78,'[{7,2959},{8,2959},{54,1034}]',1825),(3,79,'[{7,3057},{8,3057},{54,1057}]',1865),(3,80,'[{7,3157},{8,3157},{54,1080}]',1915),(3,81,'[{7,3259},{8,3259},{54,1104}]',1965),(3,82,'[{7,3363},{8,3363},{54,1128}]',2015),(3,83,'[{7,3470},{8,3470},{54,1152}]',2065),(3,84,'[{7,3579},{8,3579},{54,1176}]',2115),(3,85,'[{7,3690},{8,3690},{54,1201}]',2165),(3,86,'[{7,3804},{8,3804},{54,1226}]',2215),(3,87,'[{7,3920},{8,3920},{54,1251}]',2265),(3,88,'[{7,4038},{8,4038},{54,1276}]',2315),(3,89,'[{7,4159},{8,4159},{54,1302}]',2365),(3,90,'[{7,4282},{8,4282},{54,1328}]',2425),(3,91,'[{7,4407},{8,4407},{54,1354}]',2485),(3,92,'[{7,4535},{8,4535},{54,1380}]',2545),(3,93,'[{7,4665},{8,4665},{54,1407}]',2605),(3,94,'[{7,4798},{8,4798},{54,1434}]',2665),(3,95,'[{7,4934},{8,4934},{54,1461}]',2725),(3,96,'[{7,5072},{8,5072},{54,1488}]',2785),(3,97,'[{7,5213},{8,5213},{54,1516}]',2845),(3,98,'[{7,5356},{8,5356},{54,1544}]',2905),(3,99,'[{7,5502},{8,5502},{54,1572}]',2965),(3,100,'[{7,5650},{8,5650},{54,1600}]',3035),(3,101,'[{7,5801},{8,5801},{54,1629}]',3105),(3,102,'[{7,5955},{8,5955},{54,1658}]',3175),(3,103,'[{7,6112},{8,6112},{54,1687}]',3245),(3,104,'[{7,6271},{8,6271},{54,1716}]',3315),(3,105,'[{7,6433},{8,6433},{54,1746}]',3385),(3,106,'[{7,6598},{8,6598},{54,1776}]',3455),(3,107,'[{7,6766},{8,6766},{54,1806}]',3525),(3,108,'[{7,6937},{8,6937},{54,1836}]',3595),(3,109,'[{7,7110},{8,7110},{54,1867}]',3665),(3,110,'[{7,7286},{8,7286},{54,1898}]',3735),(3,111,'[{7,7465},{8,7465},{54,1929}]',3805),(3,112,'[{7,7647},{8,7647},{54,1960}]',3875),(3,113,'[{7,7832},{8,7832},{54,1992}]',3945),(3,114,'[{7,8020},{8,8020},{54,2024}]',4015),(3,115,'[{7,8211},{8,8211},{54,2056}]',4085),(3,116,'[{7,8405},{8,8405},{54,2088}]',4155),(3,117,'[{7,8602},{8,8602},{54,2121}]',4225),(3,118,'[{7,8802},{8,8802},{54,2154}]',4295),(3,119,'[{7,9006},{8,9006},{54,2187}]',4365),(3,120,'[{7,9213},{8,9213},{54,2220}]',4445),(3,121,'[{7,9423},{8,9423},{54,2254}]',4525),(3,122,'[{7,9636},{8,9636},{54,2288}]',4605),(3,123,'[{7,9852},{8,9852},{54,2322}]',4685),(3,124,'[{7,10072},{8,10072},{54,2356}]',4765),(3,125,'[{7,10295},{8,10295},{54,2391}]',4845),(3,126,'[{7,10521},{8,10521},{54,2426}]',4925),(3,127,'[{7,10750},{8,10750},{54,2461}]',5005),(3,128,'[{7,10983},{8,10983},{54,2496}]',5085),(3,129,'[{7,11219},{8,11219},{54,2532}]',5165),(3,130,'[{7,11459},{8,11459},{54,2568}]',5245),(3,131,'[{7,11702},{8,11702},{54,2604}]',5325),(3,132,'[{7,11948},{8,11948},{54,2640}]',5405),(3,133,'[{7,12198},{8,12198},{54,2677}]',5485),(3,134,'[{7,12451},{8,12451},{54,2714}]',5565),(3,135,'[{7,12708},{8,12708},{54,2751}]',5645),(3,136,'[{7,12968},{8,12968},{54,2788}]',5725),(3,137,'[{7,13232},{8,13232},{54,2826}]',5805),(3,138,'[{7,13500},{8,13500},{54,2864}]',5885),(3,139,'[{7,13771},{8,13771},{54,2902}]',5965),(3,140,'[{7,14046},{8,14046},{54,2940}]',6045),(3,141,'[{7,14324},{8,14324},{54,2979}]',6125),(3,142,'[{7,14606},{8,14606},{54,3018}]',6205),(3,143,'[{7,14892},{8,14892},{54,3069}]',6285),(3,144,'[{7,15181},{8,15181},{54,3120}]',6365),(3,145,'[{7,15474},{8,15474},{54,3172}]',6445),(3,146,'[{7,15771},{8,15771},{54,3224}]',6525),(3,147,'[{7,16072},{8,16072},{54,3277}]',6605),(3,148,'[{7,16377},{8,16377},{54,3330}]',6685),(3,149,'[{7,16686},{8,16686},{54,3384}]',6765),(3,150,'[{7,16998},{8,16998},{54,3438}]',0);
/*!40000 ALTER TABLE `base_spirit_config` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_star_shadow_cfg`
--

DROP TABLE IF EXISTS `base_star_shadow_cfg`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_star_shadow_cfg` (
  `id` tinyint(3) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `value` varchar(255) NOT NULL COMMENT '常量值',
  `tips` varchar(255) NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8 COMMENT='星痕常量配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_star_shadow_cfg`
--

LOCK TABLES `base_star_shadow_cfg` WRITE;
/*!40000 ALTER TABLE `base_star_shadow_cfg` DISABLE KEYS */;
INSERT INTO `base_star_shadow_cfg` VALUES (1,'335','开启等级'),(2,'[{0,21010101,1},{0,21010102,1}]','开启时赠送的星痕');
/*!40000 ALTER TABLE `base_star_shadow_cfg` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_star_shadow_equip_cfg`
--

DROP TABLE IF EXISTS `base_star_shadow_equip_cfg`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_star_shadow_equip_cfg` (
  `id` int(11) unsigned NOT NULL COMMENT '星痕物品id',
  `name` varchar(255) NOT NULL COMMENT '星痕名字@lang@',
  `color` tinyint(3) unsigned NOT NULL COMMENT '颜色',
  `stage` tinyint(3) unsigned NOT NULL COMMENT '阶数',
  `lv` smallint(5) unsigned NOT NULL COMMENT '需要等级',
  `location` tinyint(3) unsigned NOT NULL COMMENT '装备部位',
  `max_stren` tinyint(3) unsigned NOT NULL COMMENT '强化等级上限',
  `base_attr` varchar(255) NOT NULL COMMENT '基础属性',
  `special_attr` varchar(255) NOT NULL COMMENT '特殊属性',
  `best_attr` varchar(255) NOT NULL COMMENT '极品属性',
  `decompose` varchar(255) NOT NULL COMMENT '分解获得',
  `compose` varchar(255) NOT NULL COMMENT '合成所需',
  `suit` tinyint(3) unsigned NOT NULL COMMENT '所属套装',
  `score` int(11) unsigned NOT NULL COMMENT '评分',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星痕装备配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_star_shadow_equip_cfg`
--

LOCK TABLES `base_star_shadow_equip_cfg` WRITE;
/*!40000 ALTER TABLE `base_star_shadow_equip_cfg` DISABLE KEYS */;
INSERT INTO `base_star_shadow_equip_cfg` VALUES (21010101,'小马头冠星痕',0,1,335,1,5,'[{2,1800},{4,48}]','[]','[{82,135},{84,135}]','[{0,21020001,2}]','[]',1,0),(21010102,'小马战甲星痕',0,1,335,2,5,'[{1,90},{3,48}]','[]','[{81,135},{83,135}]','[{0,21020001,2}]','[]',1,0),(21010103,'小犬下装星痕',0,1,335,3,5,'[{2,1800},{6,24}]','[]','[{78,135},{80,135}]','[{0,21020001,2}]','[]',2,0),(21010104,'小犬战靴星痕',0,1,335,4,5,'[{1,90},{5,24}]','[]','[{77,135},{79,135}]','[{0,21020001,2}]','[]',2,0),(21010105,'蛇夫手套星痕',0,1,335,5,5,'[{2,2000},{8,26}]','[]','[{82,120},{84,120},{78,120}]','[{0,21020001,2}]','[]',3,0),(21010106,'蛇夫武器星痕',0,1,335,6,5,'[{1,100},{7,26}]','[]','[{81,120},{83,120},{77,120}]','[{0,21020001,2}]','[]',3,0),(21010107,'蛇夫盾牌星痕',0,1,335,7,5,'[{2,2100}]','[{49,40}]','[{82,120},{84,120},{80,120}]','[{0,21020001,3}]','[]',3,0),(21010108,'鲸鱼项链星痕',0,1,335,8,5,'[{1,105}]','[{48,40}]','[{81,120},{83,120},{79,120}]','[{0,21020001,3}]','[]',4,0),(21010109,'鲸鱼手镯星痕',0,1,335,9,5,'[{2,2100},{4,50}]','[]','[{82,120},{78,120},{80,120}]','[{0,21020001,2}]','[]',4,0),(21010110,'鲸鱼戒指星痕',0,1,335,10,5,'[{1,105},{3,50}]','[]','[{81,120},{77,120},{79,120}]','[{0,21020001,2}]','[]',4,0),(21010201,'天坛头冠星痕',1,2,335,1,10,'[{2,3200},{4,80}]','[]','[{82,270},{84,270}]','[{0,21020001,5}]','[]',5,0),(21010202,'天坛战甲星痕',1,2,335,2,10,'[{1,160},{3,80}]','[]','[{81,270},{83,270}]','[{0,21020001,5}]','[]',5,0),(21010203,'山案下装星痕',1,2,335,3,10,'[{2,3200},{6,40}]','[]','[{78,270},{80,270}]','[{0,21020001,5}]','[]',6,0),(21010204,'山案战靴星痕',1,2,335,4,10,'[{1,160},{5,40}]','[]','[{77,270},{79,270}]','[{0,21020001,5}]','[]',6,0),(21010205,'绘架手套星痕',1,2,335,5,10,'[{2,3600},{8,45}]','[]','[{82,240},{84,240},{78,240}]','[{0,21020001,5}]','[]',7,0),(21010206,'绘架武器星痕',1,2,335,6,10,'[{1,180},{7,45}]','[]','[{81,240},{83,240},{77,240}]','[{0,21020001,5}]','[]',7,0),(21010207,'绘架盾牌星痕',1,2,335,7,10,'[{2,3600}]','[{49,75}]','[{82,240},{84,240},{80,240}]','[{0,21020001,6}]','[]',7,0),(21010208,'天燕项链星痕',1,2,335,8,10,'[{1,180}]','[{48,75}]','[{81,240},{83,240},{79,240}]','[{0,21020001,6}]','[]',8,0),(21010209,'天燕手镯星痕',1,2,335,9,10,'[{2,3600},{4,90}]','[]','[{84,240},{78,240},{80,240}]','[{0,21020001,5}]','[]',8,0),(21010210,'天燕戒指星痕',1,2,335,10,10,'[{1,180},{3,90}]','[]','[{83,240},{77,240},{79,240}]','[{0,21020001,5}]','[]',8,0),(21010301,'飞鱼头冠星痕',1,3,335,1,15,'[{2,5000},{4,125}]','[]','[{82,420},{84,420}]','[{0,21020001,5}]','[]',9,0),(21010302,'飞鱼战甲星痕',1,3,335,2,15,'[{1,250},{3,125}]','[]','[{81,420},{83,420}]','[{0,21020001,5}]','[]',9,0),(21010303,'飞鱼下装星痕',1,3,335,3,15,'[{2,5000},{6,63}]','[]','[{78,420},{80,420}]','[{0,21020001,5}]','[]',9,0),(21010304,'飞鱼战靴星痕',1,3,335,4,15,'[{1,250},{5,63}]','[]','[{77,420},{79,420}]','[{0,21020001,5}]','[]',9,0),(21010305,'矩尺手套星痕',1,3,335,5,15,'[{2,5600},{8,70}]','[]','[{82,385},{84,385},{78,385}]','[{0,21020001,5}]','[]',10,0),(21010306,'矩尺武器星痕',1,3,335,6,15,'[{1,280},{7,70}]','[]','[{81,385},{83,385},{77,385}]','[{0,21020001,5}]','[]',10,0),(21010307,'矩尺盾牌星痕',1,3,335,7,15,'[{2,5600}]','[{49,120}]','[{82,385},{78,385},{80,385}]','[{0,21020001,6}]','[]',10,0),(21010308,'矩尺项链星痕',1,3,335,8,15,'[{1,280}]','[{48,120}]','[{81,385},{77,385},{79,385}]','[{0,21020001,6}]','[]',10,0),(21010309,'矩尺手镯星痕',1,3,335,9,15,'[{2,5600},{4,145}]','[]','[{84,385},{78,385},{80,385}]','[{0,21020001,5}]','[]',10,0),(21010310,'矩尺戒指星痕',1,3,335,10,15,'[{1,280},{3,145}]','[]','[{83,385},{77,385},{79,385}]','[{0,21020001,5}]','[]',10,0),(21010401,'剑鱼头冠星痕',1,4,335,1,15,'[{2,7450},{4,185}]','[]','[{82,640},{84,640}]','[{0,21020001,5}]','[]',11,0),(21010402,'剑鱼战甲星痕',1,4,335,2,15,'[{1,370},{3,185}]','[]','[{81,640},{83,640}]','[{0,21020001,5}]','[]',11,0),(21010403,'剑鱼下装星痕',1,4,335,3,15,'[{2,7450},{6,93}]','[]','[{78,640},{80,640}]','[{0,21020001,5}]','[]',11,0),(21010404,'剑鱼战靴星痕',1,4,335,4,15,'[{1,370},{5,93}]','[]','[{77,640},{79,640}]','[{0,21020001,5}]','[]',11,0),(21010405,'孔雀手套星痕',1,4,335,5,15,'[{2,8300},{8,105}]','[]','[{84,580},{78,580},{80,580}]','[{0,21020001,5}]','[]',12,0),(21010406,'孔雀武器星痕',1,4,335,6,15,'[{1,415},{7,105}]','[]','[{83,580},{77,580},{79,580}]','[{0,21020001,5}]','[]',12,0),(21010407,'孔雀盾牌星痕',1,4,335,7,15,'[{2,8300}]','[{49,170}]','[{82,580},{84,580},{80,580}]','[{0,21020001,6}]','[]',12,0),(21010408,'孔雀项链星痕',1,4,335,8,15,'[{1,415}]','[{48,170}]','[{81,580},{83,580},{79,580}]','[{0,21020001,6}]','[]',12,0),(21010409,'孔雀手镯星痕',1,4,335,9,15,'[{2,8300},{4,210}]','[]','[{82,580},{78,580},{80,580}]','[{0,21020001,5}]','[]',12,0),(21010410,'孔雀戒指星痕',1,4,335,10,15,'[{1,415},{3,210}]','[]','[{81,580},{77,580},{79,580}]','[{0,21020001,5}]','[]',12,0),(21010411,'剑鱼耳坠星痕',1,4,335,11,15,'[{1,420},{5,105},{7,105}]','[]','[{82,540},{84,540},{78,540},{80,540}]','[{0,21020001,7}]','[]',11,0),(21010412,'剑鱼圣痕星痕',1,4,335,12,15,'[{2,15000},{6,105},{8,105}]','[]','[{81,540},{83,540},{77,540},{79,540}]','[{0,21020001,7}]','[]',11,0),(21010501,'鹿豹头冠星痕',2,5,335,1,20,'[{2,10250},{4,250}]','[]','[{82,880},{84,880}]','[{0,21020001,10}]','[]',15,0),(21010502,'蝎虎战甲星痕',2,5,335,2,20,'[{1,510},{3,250}]','[]','[{81,880},{83,880}]','[{0,21020001,10}]','[]',13,0),(21010503,'仙女下装星痕',2,5,335,3,20,'[{2,10250},{6,125}]','[]','[{78,880},{80,880}]','[{0,21020001,10}]','[]',14,0),(21010504,'鹿豹战靴星痕',2,5,335,4,20,'[{1,510},{5,125}]','[]','[{77,880},{79,880}]','[{0,21020001,10}]','[]',15,0),(21010505,'蝎虎手套星痕',2,5,335,5,20,'[{2,11400},{8,145}]','[]','[{82,800},{84,800},{78,800}]','[{0,21020001,10}]','[]',13,0),(21010506,'蝎虎武器星痕',2,5,335,6,20,'[{1,570},{7,145}]','[]','[{81,800},{83,800},{77,800}]','[{0,21020001,10}]','[]',13,0),(21010507,'蝎虎盾牌星痕',2,5,335,7,20,'[{2,11400}]','[{49,235}]','[{82,800},{84,800},{80,800}]','[{0,21020001,12}]','[]',13,0),(21010508,'仙女项链星痕',2,5,335,8,20,'[{1,570}]','[{48,235}]','[{81,800},{83,800},{79,800}]','[{0,21020001,12}]','[]',14,0),(21010509,'仙女手镯星痕',2,5,335,9,20,'[{2,11400},{4,290}]','[]','[{82,800},{78,800},{80,800}]','[{0,21020001,10}]','[]',14,0),(21010510,'仙女戒指星痕',2,5,335,10,20,'[{1,570},{3,290}]','[]','[{81,800},{77,800},{79,800}]','[{0,21020001,10}]','[]',14,0),(21010511,'鹿豹耳坠星痕',2,5,335,11,20,'[{1,580},{5,145},{7,145}]','[]','[{82,745},{84,745},{78,745},{80,745}]','[{0,21020001,15}]','[]',15,0),(21010512,'鹿豹圣痕星痕',2,5,335,12,20,'[{2,20650},{6,145},{8,145}]','[]','[{81,745},{83,745},{77,745},{79,745}]','[{0,21020001,15}]','[]',15,0),(21010601,'御夫头冠星痕',2,6,335,1,20,'[{2,16000},{4,400}]','[]','[{82,1260},{84,1260}]','[{0,21020001,10}]','[]',16,0),(21010602,'御夫战甲星痕',2,6,335,2,20,'[{1,800},{3,400}]','[]','[{81,1260},{83,1260}]','[{0,21020001,10}]','[]',16,0),(21010603,'御夫下装星痕',2,6,335,3,20,'[{2,16000},{6,200}]','[]','[{78,1260},{80,1260}]','[{0,21020001,10}]','[]',16,0),(21010604,'御夫战靴星痕',2,6,335,4,20,'[{1,800},{5,200}]','[]','[{77,1260},{79,1260}]','[{0,21020001,10}]','[]',16,0),(21010605,'猎犬手套星痕',2,6,335,5,20,'[{2,16800},{8,210}]','[]','[{82,1155},{84,1155},{78,1155}]','[{0,21020001,10}]','[]',17,0),(21010606,'猎犬武器星痕',2,6,335,6,20,'[{1,840},{7,210}]','[]','[{81,1155},{83,1155},{77,1155}]','[{0,21020001,10}]','[]',17,0),(21010607,'猎犬盾牌星痕',2,6,335,7,20,'[{2,16800}]','[{49,360}]','[{82,1155},{84,1155},{80,1155}]','[{0,21020001,12}]','[]',17,0),(21010608,'猎犬项链星痕',2,6,335,8,20,'[{1,840}]','[{48,360}]','[{81,1155},{83,1155},{79,1155}]','[{0,21020001,12}]','[]',17,0),(21010609,'猎犬手镯星痕',2,6,335,9,20,'[{2,16800},{4,435}]','[]','[{84,1155},{78,1155},{80,1155}]','[{0,21020001,10}]','[]',17,0),(21010610,'猎犬戒指星痕',2,6,335,10,20,'[{1,840},{3,435}]','[]','[{83,1155},{77,1155},{79,1155}]','[{0,21020001,10}]','[]',17,0),(21010701,'狐狸头冠星痕',2,7,335,1,25,'[{2,19200},{4,480}]','[]','[{82,1520},{84,1520}]','[{0,21020001,10}]','[]',18,0),(21010702,'狐狸战甲星痕',2,7,335,2,25,'[{1,960},{3,480}]','[]','[{81,1520},{83,1520}]','[{0,21020001,10}]','[]',18,0),(21010703,'天鹅下装星痕',2,7,335,3,25,'[{2,19200},{6,240}]','[]','[{78,1520},{80,1520}]','[{0,21020001,10}]','[]',19,0),(21010704,'天鹅战靴星痕',2,7,335,4,25,'[{1,960},{5,240}]','[]','[{77,1520},{79,1520}]','[{0,21020001,10}]','[]',19,0),(21010705,'狐狸手套星痕',2,7,335,5,25,'[{2,20160},{8,135}]','[]','[{82,1400},{84,1400},{78,1400}]','[{0,21020001,10}]','[]',18,0),(21010706,'狐狸武器星痕',2,7,335,6,25,'[{1,1008},{7,135}]','[]','[{81,1400},{83,1400},{77,1400}]','[{0,21020001,10}]','[]',18,0),(21010707,'狐狸盾牌星痕',2,7,335,7,25,'[{2,20160}]','[{49,230}]','[{82,1400},{78,1400},{80,1400}]','[{0,21020001,12}]','[]',18,0),(21010708,'天鹅项链星痕',2,7,335,8,25,'[{1,1008}]','[{48,230}]','[{81,1400},{77,1400},{79,1400}]','[{0,21020001,12}]','[]',19,0),(21010709,'天鹅手镯星痕',2,7,335,9,25,'[{2,20160},{4,280}]','[]','[{84,1400},{78,1400},{80,1400}]','[{0,21020001,10}]','[]',19,0),(21010710,'天鹅戒指星痕',2,7,335,10,25,'[{1,1008},{3,280}]','[]','[{83,1400},{77,1400},{79,1400}]','[{0,21020001,10}]','[]',19,0),(21010801,'小狮头冠星痕',2,8,335,1,25,'[{2,22400},{4,560}]','[]','[{82,1920},{84,1920}]','[{0,21020001,10}]','[]',20,0),(21010802,'小狮战甲星痕',2,8,335,2,25,'[{1,1120},{3,560}]','[]','[{81,1920},{83,1920}]','[{0,21020001,10}]','[]',20,0),(21010803,'小狮下装星痕',2,8,335,3,25,'[{2,22400},{6,280}]','[]','[{78,1920},{80,1920}]','[{0,21020001,10}]','[]',20,0),(21010804,'小狮战靴星痕',2,8,335,4,25,'[{1,1120},{5,280}]','[]','[{77,1920},{79,1920}]','[{0,21020001,10}]','[]',20,0),(21010805,'英仙手套星痕',2,8,335,5,25,'[{2,24800},{8,310}]','[]','[{84,1750},{78,1750},{80,1750}]','[{0,21020001,10}]','[]',21,0),(21010806,'英仙武器星痕',2,8,335,6,25,'[{1,1240},{7,310}]','[]','[{83,1750},{77,1750},{79,1750}]','[{0,21020001,10}]','[]',21,0),(21010807,'英仙盾牌星痕',2,8,335,7,25,'[{2,24800}]','[{49,520}]','[{82,1750},{84,1750},{80,1750}]','[{0,21020001,12}]','[]',21,0),(21010808,'英仙项链星痕',2,8,335,8,25,'[{1,1240}]','[{48,520}]','[{81,1750},{83,1750},{79,1750}]','[{0,21020001,12}]','[]',21,0),(21010809,'英仙手镯星痕',2,8,335,9,25,'[{2,24800},{4,630}]','[]','[{82,1750},{78,1750},{80,1750}]','[{0,21020001,10}]','[]',21,0),(21010810,'英仙戒指星痕',2,8,335,10,25,'[{1,1240},{3,630}]','[]','[{81,1750},{77,1750},{79,1750}]','[{0,21020001,10}]','[]',21,0),(21010811,'小狮耳坠星痕',2,8,335,11,25,'[{1,1250},{5,315},{7,315}]','[]','[{82,1650},{84,1650},{78,1650},{80,1650}]','[{0,21020001,15}]','[]',20,0),(21010812,'小狮圣痕星痕',2,8,335,12,25,'[{2,45000},{6,315},{8,315}]','[]','[{81,1650},{83,1650},{77,1650},{79,1650}]','[{0,21020001,15}]','[]',20,0),(21010901,'三角头冠星痕',3,9,335,1,25,'[{2,28000},{4,700}]','[]','[{82,2400},{84,2400}]','[{0,21020001,20}]','[]',24,0),(21010902,'牧夫战甲星痕',3,9,335,2,25,'[{1,1400},{3,700}]','[]','[{81,2400},{83,2400}]','[{0,21020001,20}]','[]',22,0),(21010903,'飞马下装星痕',3,9,335,3,25,'[{2,28000},{6,350}]','[]','[{78,2400},{80,2400}]','[{0,21020001,20}]','[]',23,0),(21010904,'三角战靴星痕',3,9,335,4,25,'[{1,1400},{5,350}]','[]','[{77,2400},{79,2400}]','[{0,21020001,20}]','[]',24,0),(21010905,'牧夫手套星痕',3,9,335,5,30,'[{2,31000},{8,385}]','[]','[{82,2180},{78,2180},{80,2180}]','[{0,21020001,20}]','[]',22,0),(21010906,'牧夫武器星痕',3,9,335,6,30,'[{1,1550},{7,385}]','[]','[{81,2180},{77,2180},{79,2180}]','[{0,21020001,20}]','[]',22,0),(21010907,'牧夫盾牌星痕',3,9,335,7,30,'[{2,31000}]','[{49,650}]','[{82,2180},{84,2180},{80,2180}]','[{0,21020001,22}]','[]',22,0),(21010908,'飞马项链星痕',3,9,335,8,30,'[{1,1550}]','[{48,650}]','[{81,2180},{83,2180},{79,2180}]','[{0,21020001,22}]','[]',23,0),(21010909,'飞马手镯星痕',3,9,335,9,30,'[{2,31000},{4,780}]','[]','[{82,2180},{84,2180},{78,2180}]','[{0,21020001,20}]','[]',23,0),(21010910,'飞马戒指星痕',3,9,335,10,30,'[{1,1550},{3,780}]','[]','[{81,2180},{83,2180},{77,2180}]','[{0,21020001,20}]','[]',23,0),(21010911,'三角耳坠星痕',3,9,335,11,30,'[{1,1570},{5,395},{7,395}]','[]','[{82,2050},{84,2050},{78,2050},{80,2050}]','[{0,21020001,25}]','[]',24,0),(21010912,'三角圣痕星痕',3,9,335,12,30,'[{2,56250},{6,395},{8,395}]','[]','[{81,2050},{83,2050},{77,2050},{79,2050}]','[{0,21020001,25}]','[]',24,0),(21011001,'天箭头冠星痕',3,10,335,1,30,'[{2,40500},{4,1010}]','[]','[{82,3200},{84,3200}]','[{0,21020001,20}]','[]',25,0),(21011002,'天箭战甲星痕',3,10,335,2,30,'[{1,2025},{3,1010}]','[]','[{81,3200},{83,3200}]','[{0,21020001,20}]','[]',25,0),(21011003,'天箭下装星痕',3,10,335,3,30,'[{2,40500},{6,510}]','[]','[{78,3200},{80,3200}]','[{0,21020001,20}]','[]',25,0),(21011004,'天箭战靴星痕',3,10,335,4,30,'[{1,2025},{5,510}]','[]','[{77,3200},{79,3200}]','[{0,21020001,20}]','[]',25,0),(21011005,'巨蟹手套星痕',3,10,335,5,30,'[{2,42560},{8,285}]','[]','[{82,2950},{84,2950},{78,2950}]','[{0,21020001,20}]','[]',26,0),(21011006,'巨蟹武器星痕',3,10,335,6,30,'[{1,2128},{7,285}]','[]','[{81,2950},{83,2950},{77,2950}]','[{0,21020001,20}]','[]',26,0),(21011007,'巨蟹盾牌星痕',3,10,335,7,30,'[{2,42560}]','[{49,485}]','[{82,2950},{84,2950},{80,2950}]','[{0,21020001,22}]','[]',26,0),(21011008,'巨蟹项链星痕',3,10,335,8,30,'[{1,2128}]','[{48,485}]','[{81,2950},{83,2950},{79,2950}]','[{0,21020001,22}]','[]',26,0),(21011009,'巨蟹手镯星痕',3,10,335,9,30,'[{2,42560},{4,590}]','[]','[{84,2950},{78,2950},{80,2950}]','[{0,21020001,20}]','[]',26,0),(21011010,'巨蟹戒指星痕',3,10,335,10,30,'[{1,2128},{3,590}]','[]','[{83,2950},{77,2950},{79,2950}]','[{0,21020001,20}]','[]',26,0),(21011101,'人马头冠星痕',3,11,335,1,35,'[{2,50000},{4,1250}]','[]','[{82,3950},{84,3950}]','[{0,21020001,20}]','[]',27,0),(21011102,'人马战甲星痕',3,11,335,2,35,'[{1,2500},{3,1250}]','[]','[{81,3950},{83,3950}]','[{0,21020001,20}]','[]',27,0),(21011103,'双子下装星痕',3,11,335,3,35,'[{2,50000},{6,630}]','[]','[{78,3950},{80,3950}]','[{0,21020001,20}]','[]',28,0),(21011104,'双子战靴星痕',3,11,335,4,35,'[{1,2500},{5,630}]','[]','[{77,3950},{79,3950}]','[{0,21020001,20}]','[]',28,0),(21011105,'人马手套星痕',3,11,335,5,35,'[{2,52640},{8,350}]','[]','[{82,3650},{78,3650},{80,3650}]','[{0,21020001,20}]','[]',27,0),(21011106,'人马武器星痕',3,11,335,6,35,'[{1,2635},{7,350}]','[]','[{81,3650},{77,3650},{79,3650}]','[{0,21020001,20}]','[]',27,0),(21011107,'人马盾牌星痕',3,11,335,7,35,'[{2,52640}]','[{49,600}]','[{82,3650},{84,3650},{78,3650}]','[{0,21020001,22}]','[]',27,0),(21011108,'双子项链星痕',3,11,335,8,35,'[{1,2635}]','[{48,600}]','[{81,3650},{83,3650},{77,3650}]','[{0,21020001,22}]','[]',28,0),(21011109,'双子手镯星痕',3,11,335,9,35,'[{2,52640},{4,730}]','[]','[{84,3650},{78,3650},{80,3650}]','[{0,21020001,20}]','[]',28,0),(21011110,'双子戒指星痕',3,11,335,10,35,'[{1,2635},{3,730}]','[]','[{83,3650},{77,3650},{79,3650}]','[{0,21020001,20}]','[]',28,0),(21011201,'宝瓶头冠星痕',3,12,335,1,35,'[{2,52200},{4,1300}]','[]','[{82,4500},{84,4500}]','[{0,21020001,20}]','[]',29,0),(21011202,'宝瓶战甲星痕',3,12,335,2,35,'[{1,2600},{3,1300}]','[]','[{81,4500},{83,4500}]','[{0,21020001,20}]','[]',29,0),(21011203,'宝瓶下装星痕',3,12,335,3,35,'[{2,52200},{6,650}]','[]','[{78,4500},{80,4500}]','[{0,21020001,20}]','[]',29,0),(21011204,'宝瓶战靴星痕',3,12,335,4,35,'[{1,2600},{5,650}]','[]','[{77,4500},{79,4500}]','[{0,21020001,20}]','[]',29,0),(21011205,'室女手套星痕',3,12,335,5,35,'[{2,58000},{8,720}]','[]','[{82,4080},{78,4080},{80,4080}]','[{0,21020001,20}]','[]',30,0),(21011206,'室女武器星痕',3,12,335,6,35,'[{1,2900},{7,720}]','[]','[{81,4080},{77,4080},{79,4080}]','[{0,21020001,20}]','[]',30,0),(21011207,'室女盾牌星痕',3,12,335,7,35,'[{2,58000}]','[{49,1200}]','[{82,4080},{84,4080},{80,4080}]','[{0,21020001,22}]','[]',30,0),(21011208,'室女项链星痕',3,12,335,8,35,'[{1,2900}]','[{48,1200}]','[{81,4080},{83,4080},{79,4080}]','[{0,21020001,22}]','[]',30,0),(21011209,'室女手镯星痕',3,12,335,9,35,'[{2,58000},{4,1450}]','[]','[{84,4080},{78,4080},{80,4080}]','[{0,21020001,20}]','[]',30,0),(21011210,'室女戒指星痕',3,12,335,10,35,'[{1,2900},{3,1450}]','[]','[{83,4080},{77,4080},{79,4080}]','[{0,21020001,20}]','[]',30,0),(21011211,'宝瓶耳坠星痕',3,12,335,11,35,'[{1,2900},{5,740},{7,740}]','[]','[{82,3850},{84,3850},{78,3850},{80,3850}]','[{0,21020001,25}]','[]',29,0),(21011212,'宝瓶圣痕星痕',3,12,335,12,35,'[{2,105000},{6,740},{8,740}]','[]','[{81,3850},{83,3850},{77,3850},{79,3850}]','[{0,21020001,25}]','[]',29,0),(21011301,'双鱼头冠星痕',3,13,335,1,35,'[{2,65000},{4,1625}]','[]','[{82,5400},{84,5400}]','[{0,21020001,20}]','[]',31,0),(21011302,'双鱼战甲星痕',3,13,335,2,35,'[{1,3250},{3,1625}]','[]','[{81,5400},{83,5400}]','[{0,21020001,20}]','[]',31,0),(21011303,'双鱼下装星痕',3,13,335,3,35,'[{2,65000},{6,810}]','[]','[{78,5400},{80,5400}]','[{0,21020001,20}]','[]',31,0),(21011304,'双鱼战靴星痕',3,13,335,4,35,'[{1,3250},{5,810}]','[]','[{77,5400},{79,5400}]','[{0,21020001,20}]','[]',31,0),(21011305,'双鱼手套星痕',3,13,335,5,35,'[{2,69400},{8,860}]','[]','[{82,4900},{78,4900},{80,4900}]','[{0,21020001,20}]','[]',31,0),(21011306,'双鱼武器星痕',3,13,335,6,35,'[{1,3470},{7,860}]','[]','[{81,4900},{77,4900},{79,4900}]','[{0,21020001,20}]','[]',31,0),(21011307,'双鱼盾牌星痕',3,13,335,7,35,'[{2,69400}]','[{49,1435}]','[{82,4900},{84,4900},{80,4900}]','[{0,21020001,22}]','[]',31,0),(21011308,'双鱼项链星痕',3,13,335,8,35,'[{1,3470}]','[{48,1435}]','[{81,4900},{83,4900},{79,4900}]','[{0,21020001,22}]','[]',31,0),(21011309,'双鱼手镯星痕',3,13,335,9,35,'[{2,69400},{4,1735}]','[]','[{82,4900},{84,4900},{78,4900}]','[{0,21020001,20}]','[]',31,0),(21011310,'双鱼戒指星痕',3,13,335,10,35,'[{1,3470},{3,1735}]','[]','[{81,4900},{83,4900},{77,4900}]','[{0,21020001,20}]','[]',31,0),(21011311,'双鱼耳坠星痕',3,13,335,11,35,'[{1,3500},{5,885},{7,885}]','[]','[{82,4600},{84,4600},{78,4600},{80,4600}]','[{0,21020001,25}]','[]',31,0),(21011312,'双鱼圣痕星痕',3,13,335,12,35,'[{2,125000},{6,885},{8,885}]','[]','[{81,4600},{83,4600},{77,4600},{79,4600}]','[{0,21020001,25}]','[]',31,0),(21011401,'天秤头冠星痕',4,14,335,1,40,'[{2,77600},{4,1940}]','[]','[{82,6400},{84,6400}]','[{0,21011301,1},{0,21030001,10}]','[{0,21011301,1},{0,21030001,10}]',32,0),(21011402,'天秤战甲星痕',4,14,335,2,40,'[{1,3880},{3,1940}]','[]','[{81,6400},{83,6400}]','[{0,21011302,1},{0,21030001,10}]','[{0,21011302,1},{0,21030001,10}]',32,0),(21011403,'天秤下装星痕',4,14,335,3,40,'[{2,77600},{8,965}]','[]','[{78,6400},{80,6400}]','[{0,21011303,1},{0,21030001,10}]','[{0,21011303,1},{0,21030001,10}]',32,0),(21011404,'天秤战靴星痕',4,14,335,4,40,'[{1,3880},{7,965}]','[]','[{77,6400},{79,6400}]','[{0,21011304,1},{0,21030001,10}]','[{0,21011304,1},{0,21030001,10}]',32,0),(21011405,'天秤手套星痕',4,14,335,5,40,'[{2,82860},{6,1025}]','[]','[{82,5850},{84,5850},{78,5850}]','[{0,21011305,1},{0,21030001,10}]','[{0,21011305,1},{0,21030001,10}]',32,0),(21011406,'天秤武器星痕',4,14,335,6,40,'[{1,4145},{5,1025}]','[]','[{81,5850},{83,5850},{77,5850}]','[{0,21011306,1},{0,21030001,10}]','[{0,21011306,1},{0,21030001,10}]',32,0),(21011407,'天秤盾牌星痕',4,14,335,7,40,'[{2,82860}]','[{49,1710}]','[{82,5850},{84,5850},{80,5850}]','[{0,21011307,1},{0,21030001,10}]','[{0,21011307,1},{0,21030001,10}]',32,0),(21011408,'天秤项链星痕',4,14,335,8,40,'[{1,4145}]','[{48,1710}]','[{81,5850},{83,5850},{79,5850}]','[{0,21011308,1},{0,21030001,10}]','[{0,21011308,1},{0,21030001,10}]',32,0),(21011409,'天秤手镯星痕',4,14,335,9,40,'[{2,82860},{4,2070}]','[]','[{84,5850},{78,5850},{80,5850}]','[{0,21011309,1},{0,21030001,10}]','[{0,21011309,1},{0,21030001,10}]',32,0),(21011410,'天秤戒指星痕',4,14,335,10,40,'[{1,4145},{3,2070}]','[]','[{83,5850},{77,5850},{79,5850}]','[{0,21011310,1},{0,21030001,10}]','[{0,21011310,1},{0,21030001,10}]',32,0),(21011411,'天秤耳坠星痕',4,14,335,11,40,'[{1,4180},{5,1040},{7,1040}]','[]','[{82,5480},{84,5480},{78,5480},{80,5480}]','[{0,21011311,1},{0,21030001,10}]','[{0,21011311,1},{0,21030001,10}]',32,0),(21011412,'天秤圣痕星痕',4,14,335,12,40,'[{2,148250},{6,1040},{8,1040}]','[]','[{81,5480},{83,5480},{77,5480},{79,5480}]','[{0,21011312,1},{0,21030001,10}]','[{0,21011312,1},{0,21030001,10}]',32,0),(21011501,'摩羯头冠星痕',4,14,335,1,40,'[{2,77600},{4,1940}]','[]','[{82,6400},{84,6400}]','[{0,21011301,1},{0,21030001,10}]','[{0,21011301,1},{0,21030001,10}]',33,0),(21011502,'摩羯战甲星痕',4,14,335,2,40,'[{1,3880},{3,1940}]','[]','[{81,6400},{83,6400}]','[{0,21011302,1},{0,21030001,10}]','[{0,21011302,1},{0,21030001,10}]',33,0),(21011503,'摩羯下装星痕',4,14,335,3,40,'[{2,77600},{6,965}]','[]','[{78,6400},{80,6400}]','[{0,21011303,1},{0,21030001,10}]','[{0,21011303,1},{0,21030001,10}]',33,0),(21011504,'摩羯战靴星痕',4,14,335,4,40,'[{1,3880},{5,965}]','[]','[{77,6400},{79,6400}]','[{0,21011304,1},{0,21030001,10}]','[{0,21011304,1},{0,21030001,10}]',33,0),(21011505,'摩羯手套星痕',4,14,335,5,40,'[{2,82860},{8,1025}]','[]','[{82,5850},{84,5850},{78,5850}]','[{0,21011305,1},{0,21030001,10}]','[{0,21011305,1},{0,21030001,10}]',33,0),(21011506,'摩羯武器星痕',4,14,335,6,40,'[{1,4145},{7,1025}]','[]','[{81,5850},{83,5850},{77,5850}]','[{0,21011306,1},{0,21030001,10}]','[{0,21011306,1},{0,21030001,10}]',33,0),(21011507,'摩羯盾牌星痕',4,14,335,7,40,'[{2,82860}]','[{49,1710}]','[{82,5850},{78,5850},{80,5850}]','[{0,21011307,1},{0,21030001,10}]','[{0,21011307,1},{0,21030001,10}]',33,0),(21011508,'摩羯项链星痕',4,14,335,8,40,'[{1,4145}]','[{48,1710}]','[{81,5850},{77,5850},{79,5850}]','[{0,21011308,1},{0,21030001,10}]','[{0,21011308,1},{0,21030001,10}]',33,0),(21011509,'摩羯手镯星痕',4,14,335,9,40,'[{2,82860},{4,2070}]','[]','[{84,5850},{78,5850},{80,5850}]','[{0,21011309,1},{0,21030001,10}]','[{0,21011309,1},{0,21030001,10}]',33,0),(21011510,'摩羯戒指星痕',4,14,335,10,40,'[{1,4145},{3,2070}]','[]','[{83,5850},{77,5850},{79,5850}]','[{0,21011310,1},{0,21030001,10}]','[{0,21011310,1},{0,21030001,10}]',33,0),(21011511,'摩羯耳坠星痕',4,14,335,11,40,'[{1,4180},{5,1040},{7,1040}]','[]','[{82,5480},{84,5480},{78,5480},{80,5480}]','[{0,21011311,1},{0,21030001,10}]','[{0,21011311,1},{0,21030001,10}]',33,0),(21011512,'摩羯圣痕星痕',4,14,335,12,40,'[{2,148250},{6,1040},{8,1040}]','[]','[{81,5480},{83,5480},{77,5480},{79,5480}]','[{0,21011312,1},{0,21030001,10}]','[{0,21011312,1},{0,21030001,10}]',33,0),(21011601,'狮子头冠星痕',4,14,335,1,40,'[{2,77600},{4,1940}]','[]','[{82,6400},{84,6400}]','[{0,21011301,1},{0,21030001,10}]','[{0,21011301,1},{0,21030001,10}]',34,0),(21011602,'狮子战甲星痕',4,14,335,2,40,'[{1,3880},{3,1940}]','[]','[{81,6400},{83,6400}]','[{0,21011302,1},{0,21030001,10}]','[{0,21011302,1},{0,21030001,10}]',34,0),(21011603,'狮子下装星痕',4,14,335,3,40,'[{2,77600},{8,965}]','[]','[{78,6400},{80,6400}]','[{0,21011303,1},{0,21030001,10}]','[{0,21011303,1},{0,21030001,10}]',34,0),(21011604,'狮子战靴星痕',4,14,335,4,40,'[{1,3880},{7,965}]','[]','[{77,6400},{79,6400}]','[{0,21011304,1},{0,21030001,10}]','[{0,21011304,1},{0,21030001,10}]',34,0),(21011605,'狮子手套星痕',4,14,335,5,40,'[{2,82860},{6,1025}]','[]','[{82,5850},{84,5850},{80,5850}]','[{0,21011305,1},{0,21030001,10}]','[{0,21011305,1},{0,21030001,10}]',34,0),(21011606,'狮子武器星痕',4,14,335,6,40,'[{1,4145},{5,1025}]','[]','[{81,5850},{83,5850},{79,5850}]','[{0,21011306,1},{0,21030001,10}]','[{0,21011306,1},{0,21030001,10}]',34,0),(21011607,'狮子盾牌星痕',4,14,335,7,40,'[{2,82860}]','[{49,1710}]','[{82,5850},{78,5850},{80,5850}]','[{0,21011307,1},{0,21030001,10}]','[{0,21011307,1},{0,21030001,10}]',34,0),(21011608,'狮子项链星痕',4,14,335,8,40,'[{1,4145}]','[{48,1710}]','[{81,5850},{77,5850},{79,5850}]','[{0,21011308,1},{0,21030001,10}]','[{0,21011308,1},{0,21030001,10}]',34,0),(21011609,'狮子手镯星痕',4,14,335,9,40,'[{2,82860},{4,2070}]','[]','[{84,5850},{78,5850},{80,5850}]','[{0,21011309,1},{0,21030001,10}]','[{0,21011309,1},{0,21030001,10}]',34,0),(21011610,'狮子戒指星痕',4,14,335,10,40,'[{1,4145},{3,2070}]','[]','[{83,5850},{77,5850},{79,5850}]','[{0,21011310,1},{0,21030001,10}]','[{0,21011310,1},{0,21030001,10}]',34,0),(21011611,'狮子耳坠星痕',4,14,335,11,40,'[{1,4180},{5,1040},{7,1040}]','[]','[{82,5480},{84,5480},{78,5480},{80,5480}]','[{0,21011311,1},{0,21030001,10}]','[{0,21011311,1},{0,21030001,10}]',34,0),(21011612,'狮子圣痕星痕',4,14,335,12,40,'[{2,148250},{6,1040},{8,1040}]','[]','[{81,5480},{83,5480},{77,5480},{79,5480}]','[{0,21011312,1},{0,21030001,10}]','[{0,21011312,1},{0,21030001,10}]',34,0),(21011701,'白羊头冠星痕',4,14,335,1,40,'[{2,77600},{4,1940}]','[]','[{82,6400},{84,6400}]','[{0,21011301,1},{0,21030001,10}]','[{0,21011301,1},{0,21030001,10}]',35,0),(21011702,'白羊战甲星痕',4,14,335,2,40,'[{1,3880},{3,1940}]','[]','[{81,6400},{83,6400}]','[{0,21011302,1},{0,21030001,10}]','[{0,21011302,1},{0,21030001,10}]',35,0),(21011703,'白羊下装星痕',4,14,335,3,40,'[{2,77600},{6,965}]','[]','[{78,6400},{80,6400}]','[{0,21011303,1},{0,21030001,10}]','[{0,21011303,1},{0,21030001,10}]',35,0),(21011704,'白羊战靴星痕',4,14,335,4,40,'[{1,3880},{5,965}]','[]','[{77,6400},{79,6400}]','[{0,21011304,1},{0,21030001,10}]','[{0,21011304,1},{0,21030001,10}]',35,0),(21011705,'白羊手套星痕',4,14,335,5,40,'[{2,82860},{8,1025}]','[]','[{82,5850},{84,5850},{78,5850}]','[{0,21011305,1},{0,21030001,10}]','[{0,21011305,1},{0,21030001,10}]',35,0),(21011706,'白羊武器星痕',4,14,335,6,40,'[{1,4145},{7,1025}]','[]','[{81,5850},{83,5850},{77,5850}]','[{0,21011306,1},{0,21030001,10}]','[{0,21011306,1},{0,21030001,10}]',35,0),(21011707,'白羊盾牌星痕',4,14,335,7,40,'[{2,82860}]','[{49,1710}]','[{82,5850},{84,5850},{80,5850}]','[{0,21011307,1},{0,21030001,10}]','[{0,21011307,1},{0,21030001,10}]',35,0),(21011708,'白羊项链星痕',4,14,335,8,40,'[{1,4145}]','[{48,1710}]','[{81,5850},{83,5850},{79,5850}]','[{0,21011308,1},{0,21030001,10}]','[{0,21011308,1},{0,21030001,10}]',35,0),(21011709,'白羊手镯星痕',4,14,335,9,40,'[{2,82860},{4,2070}]','[]','[{82,5850},{78,5850},{80,5850}]','[{0,21011309,1},{0,21030001,10}]','[{0,21011309,1},{0,21030001,10}]',35,0),(21011710,'白羊戒指星痕',4,14,335,10,40,'[{1,4145},{3,2070}]','[]','[{81,5850},{77,5850},{79,5850}]','[{0,21011310,1},{0,21030001,10}]','[{0,21011310,1},{0,21030001,10}]',35,0),(21011711,'白羊耳坠星痕',4,14,335,11,40,'[{1,4180},{5,1040},{7,1040}]','[]','[{82,5480},{84,5480},{78,5480},{80,5480}]','[{0,21011311,1},{0,21030001,10}]','[{0,21011311,1},{0,21030001,10}]',35,0),(21011712,'白羊圣痕星痕',4,14,335,12,40,'[{2,148250},{6,1040},{8,1040}]','[]','[{81,5480},{83,5480},{77,5480},{79,5480}]','[{0,21011312,1},{0,21030001,10}]','[{0,21011312,1},{0,21030001,10}]',35,0);
/*!40000 ALTER TABLE `base_star_shadow_equip_cfg` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_star_shadow_location_cfg`
--

DROP TABLE IF EXISTS `base_star_shadow_location_cfg`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_star_shadow_location_cfg` (
  `location` tinyint(3) unsigned NOT NULL COMMENT '部位id',
  `location_name` varchar(255) NOT NULL COMMENT '部位名@lang@',
  `area` tinyint(3) unsigned NOT NULL COMMENT '区域id',
  `area_name` varchar(255) NOT NULL COMMENT '区域名@lang@',
  `open_lv` smallint(5) unsigned NOT NULL COMMENT '开启等级',
  PRIMARY KEY (`location`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星痕部位配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_star_shadow_location_cfg`
--

LOCK TABLES `base_star_shadow_location_cfg` WRITE;
/*!40000 ALTER TABLE `base_star_shadow_location_cfg` DISABLE KEYS */;
INSERT INTO `base_star_shadow_location_cfg` VALUES (1,'头冠',1,'战争星痕',335),(2,'战甲',1,'战争星痕',335),(3,'下装',1,'战争星痕',335),(4,'战靴',1,'战争星痕',335),(5,'手套',2,'战争星痕',335),(6,'武器',2,'战争星痕',335),(7,'副武器',2,'战争星痕',335),(8,'项链',3,'智慧星痕',335),(9,'手镯',3,'智慧星痕',335),(10,'戒指',3,'守护星痕',335),(11,'耳坠',4,'守护星痕',335),(12,'圣痕',4,'神圣星痕',335);
/*!40000 ALTER TABLE `base_star_shadow_location_cfg` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_star_shadow_mold_soul_cfg`
--

DROP TABLE IF EXISTS `base_star_shadow_mold_soul_cfg`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_star_shadow_mold_soul_cfg` (
  `id` tinyint(3) unsigned NOT NULL COMMENT '铸魂id',
  `min_lv` smallint(5) unsigned NOT NULL COMMENT '铸魂等级下限',
  `max_lv` smallint(5) unsigned NOT NULL COMMENT '铸魂等级上限',
  `cost` varchar(255) NOT NULL COMMENT '升级消耗',
  `base_attr` varchar(255) NOT NULL COMMENT '基础属性',
  `area_attr` varchar(518) NOT NULL COMMENT '区域属性',
  `open_lv` smallint(5) unsigned NOT NULL COMMENT '开放等级',
  `tips` text NOT NULL COMMENT '描述',
  PRIMARY KEY (`id`,`min_lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星痕铸魂配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_star_shadow_mold_soul_cfg`
--

LOCK TABLES `base_star_shadow_mold_soul_cfg` WRITE;
/*!40000 ALTER TABLE `base_star_shadow_mold_soul_cfg` DISABLE KEYS */;
INSERT INTO `base_star_shadow_mold_soul_cfg` VALUES (1,0,600,'[{0,21040001,1}]','[{2,1000},{1,50}]','[]',0,''),(2,0,300,'[{0,21040002,1}]','[{81,40},{82,40},{83,40},{84,40}]','[]',0,''),(3,0,300,'[{0,21040003,1}]','[{77,40},{78,40},{79,40},{80,40}]','[]',0,''),(4,0,200,'[{0,21040004,1}]','[{2,4000},{1,200}]','[{77,50},{78,50},{79,50},{80,50},{81,50},{82,50},{83,50},{84,50}]',0,'元素攻击:0.5%\\n元素防御:0.5%');
/*!40000 ALTER TABLE `base_star_shadow_mold_soul_cfg` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_star_shadow_stren_cfg`
--

DROP TABLE IF EXISTS `base_star_shadow_stren_cfg`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_star_shadow_stren_cfg` (
  `location` tinyint(3) unsigned NOT NULL COMMENT '部位id',
  `lv` smallint(5) unsigned NOT NULL COMMENT '强化等级',
  `cost` varchar(255) NOT NULL COMMENT '强化消耗',
  `exp` int(11) unsigned NOT NULL COMMENT '升级所需经验',
  `attr` varchar(255) NOT NULL COMMENT '强化属性',
  PRIMARY KEY (`location`,`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星痕强化等级配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_star_shadow_stren_cfg`
--

LOCK TABLES `base_star_shadow_stren_cfg` WRITE;
/*!40000 ALTER TABLE `base_star_shadow_stren_cfg` DISABLE KEYS */;
INSERT INTO `base_star_shadow_stren_cfg` VALUES (1,1,'21020001',4,'[{1,16},{3,8},{81,10}]'),(1,2,'21020001',6,'[{1,24},{3,12},{81,15}]'),(1,3,'21020001',8,'[{1,32},{3,16},{81,20}]'),(1,4,'21020001',10,'[{1,40},{3,20},{81,25}]'),(1,5,'21020001',12,'[{1,48},{3,24},{81,30}]'),(1,6,'21020001',14,'[{1,56},{3,28},{81,35}]'),(1,7,'21020001',16,'[{1,64},{3,32},{81,40}]'),(1,8,'21020001',18,'[{1,72},{3,36},{81,45}]'),(1,9,'21020001',20,'[{1,80},{3,40},{81,50}]'),(1,10,'21020001',22,'[{1,88},{3,44},{81,55}]'),(1,11,'21020001',24,'[{1,96},{3,48},{81,60}]'),(1,12,'21020001',26,'[{1,104},{3,52},{81,65}]'),(1,13,'21020001',28,'[{1,112},{3,56},{81,70}]'),(1,14,'21020001',30,'[{1,120},{3,60},{81,75}]'),(1,15,'21020001',32,'[{1,128},{3,64},{81,80}]'),(1,16,'21020001',34,'[{1,136},{3,68},{81,85}]'),(1,17,'21020001',36,'[{1,144},{3,72},{81,90}]'),(1,18,'21020001',38,'[{1,152},{3,76},{81,95}]'),(1,19,'21020001',40,'[{1,160},{3,80},{81,100}]'),(1,20,'21020001',42,'[{1,168},{3,84},{81,105}]'),(1,21,'21020001',44,'[{1,176},{3,88},{81,110}]'),(1,22,'21020001',46,'[{1,184},{3,92},{81,115}]'),(1,23,'21020001',48,'[{1,192},{3,96},{81,120}]'),(1,24,'21020001',50,'[{1,200},{3,100},{81,125}]'),(1,25,'21020001',52,'[{1,208},{3,104},{81,130}]'),(1,26,'21020001',54,'[{1,216},{3,108},{81,135}]'),(1,27,'21020001',56,'[{1,224},{3,112},{81,140}]'),(1,28,'21020001',58,'[{1,232},{3,116},{81,145}]'),(1,29,'21020001',60,'[{1,240},{3,120},{81,150}]'),(1,30,'21020001',62,'[{1,248},{3,124},{81,155}]'),(1,31,'21020001',64,'[{1,256},{3,128},{81,160}]'),(1,32,'21020001',66,'[{1,264},{3,132},{81,165}]'),(1,33,'21020001',68,'[{1,272},{3,136},{81,170}]'),(1,34,'21020001',70,'[{1,280},{3,140},{81,175}]'),(1,35,'21020001',72,'[{1,288},{3,144},{81,180}]'),(1,36,'21020001',74,'[{1,296},{3,148},{81,185}]'),(1,37,'21020001',76,'[{1,304},{3,152},{81,190}]'),(1,38,'21020001',78,'[{1,312},{3,156},{81,195}]'),(1,39,'21020001',80,'[{1,320},{3,160},{81,200}]'),(1,40,'21020001',82,'[{1,328},{3,164},{81,205}]'),(2,1,'21020001',4,'[{2,320},{4,8},{82,10}]'),(2,2,'21020001',6,'[{2,480},{4,12},{82,15}]'),(2,3,'21020001',8,'[{2,640},{4,16},{82,20}]'),(2,4,'21020001',10,'[{2,800},{4,20},{82,25}]'),(2,5,'21020001',12,'[{2,960},{4,24},{82,30}]'),(2,6,'21020001',14,'[{2,1120},{4,28},{82,35}]'),(2,7,'21020001',16,'[{2,1280},{4,32},{82,40}]'),(2,8,'21020001',18,'[{2,1440},{4,36},{82,45}]'),(2,9,'21020001',20,'[{2,1600},{4,40},{82,50}]'),(2,10,'21020001',22,'[{2,1760},{4,44},{82,55}]'),(2,11,'21020001',24,'[{2,1920},{4,48},{82,60}]'),(2,12,'21020001',26,'[{2,2080},{4,52},{82,65}]'),(2,13,'21020001',28,'[{2,2240},{4,56},{82,70}]'),(2,14,'21020001',30,'[{2,2400},{4,60},{82,75}]'),(2,15,'21020001',32,'[{2,2560},{4,64},{82,80}]'),(2,16,'21020001',34,'[{2,2720},{4,68},{82,85}]'),(2,17,'21020001',36,'[{2,2880},{4,72},{82,90}]'),(2,18,'21020001',38,'[{2,3040},{4,76},{82,95}]'),(2,19,'21020001',40,'[{2,3200},{4,80},{82,100}]'),(2,20,'21020001',42,'[{2,3360},{4,84},{82,105}]'),(2,21,'21020001',44,'[{2,3520},{4,88},{82,110}]'),(2,22,'21020001',46,'[{2,3680},{4,92},{82,115}]'),(2,23,'21020001',48,'[{2,3840},{4,96},{82,120}]'),(2,24,'21020001',50,'[{2,4000},{4,100},{82,125}]'),(2,25,'21020001',52,'[{2,4160},{4,104},{82,130}]'),(2,26,'21020001',54,'[{2,4320},{4,108},{82,135}]'),(2,27,'21020001',56,'[{2,4480},{4,112},{82,140}]'),(2,28,'21020001',58,'[{2,4640},{4,116},{82,145}]'),(2,29,'21020001',60,'[{2,4800},{4,120},{82,150}]'),(2,30,'21020001',62,'[{2,4960},{4,124},{82,155}]'),(2,31,'21020001',64,'[{2,5120},{4,128},{82,160}]'),(2,32,'21020001',66,'[{2,5280},{4,132},{82,165}]'),(2,33,'21020001',68,'[{2,5440},{4,136},{82,170}]'),(2,34,'21020001',70,'[{2,5600},{4,140},{82,175}]'),(2,35,'21020001',72,'[{2,5760},{4,144},{82,180}]'),(2,36,'21020001',74,'[{2,5920},{4,148},{82,185}]'),(2,37,'21020001',76,'[{2,6080},{4,152},{82,190}]'),(2,38,'21020001',78,'[{2,6240},{4,156},{82,195}]'),(2,39,'21020001',80,'[{2,6400},{4,160},{82,200}]'),(2,40,'21020001',82,'[{2,6560},{4,164},{82,205}]'),(3,1,'21020001',4,'[{1,16},{5,4},{83,10}]'),(3,2,'21020001',6,'[{1,24},{5,6},{83,15}]'),(3,3,'21020001',8,'[{1,32},{5,8},{83,20}]'),(3,4,'21020001',10,'[{1,40},{5,10},{83,25}]'),(3,5,'21020001',12,'[{1,48},{5,12},{83,30}]'),(3,6,'21020001',14,'[{1,56},{5,14},{83,35}]'),(3,7,'21020001',16,'[{1,64},{5,16},{83,40}]'),(3,8,'21020001',18,'[{1,72},{5,18},{83,45}]'),(3,9,'21020001',20,'[{1,80},{5,20},{83,50}]'),(3,10,'21020001',22,'[{1,88},{5,22},{83,55}]'),(3,11,'21020001',24,'[{1,96},{5,24},{83,60}]'),(3,12,'21020001',26,'[{1,104},{5,26},{83,65}]'),(3,13,'21020001',28,'[{1,112},{5,28},{83,70}]'),(3,14,'21020001',30,'[{1,120},{5,30},{83,75}]'),(3,15,'21020001',32,'[{1,128},{5,32},{83,80}]'),(3,16,'21020001',34,'[{1,136},{5,34},{83,85}]'),(3,17,'21020001',36,'[{1,144},{5,36},{83,90}]'),(3,18,'21020001',38,'[{1,152},{5,38},{83,95}]'),(3,19,'21020001',40,'[{1,160},{5,40},{83,100}]'),(3,20,'21020001',42,'[{1,168},{5,42},{83,105}]'),(3,21,'21020001',44,'[{1,176},{5,44},{83,110}]'),(3,22,'21020001',46,'[{1,184},{5,46},{83,115}]'),(3,23,'21020001',48,'[{1,192},{5,48},{83,120}]'),(3,24,'21020001',50,'[{1,200},{5,50},{83,125}]'),(3,25,'21020001',52,'[{1,208},{5,52},{83,130}]'),(3,26,'21020001',54,'[{1,216},{5,54},{83,135}]'),(3,27,'21020001',56,'[{1,224},{5,56},{83,140}]'),(3,28,'21020001',58,'[{1,232},{5,58},{83,145}]'),(3,29,'21020001',60,'[{1,240},{5,60},{83,150}]'),(3,30,'21020001',62,'[{1,248},{5,62},{83,155}]'),(3,31,'21020001',64,'[{1,256},{5,64},{83,160}]'),(3,32,'21020001',66,'[{1,264},{5,66},{83,165}]'),(3,33,'21020001',68,'[{1,272},{5,68},{83,170}]'),(3,34,'21020001',70,'[{1,280},{5,70},{83,175}]'),(3,35,'21020001',72,'[{1,288},{5,72},{83,180}]'),(3,36,'21020001',74,'[{1,296},{5,74},{83,185}]'),(3,37,'21020001',76,'[{1,304},{5,76},{83,190}]'),(3,38,'21020001',78,'[{1,312},{5,78},{83,195}]'),(3,39,'21020001',80,'[{1,320},{5,80},{83,200}]'),(3,40,'21020001',82,'[{1,328},{5,82},{83,205}]'),(4,1,'21020001',4,'[{2,320},{6,4},{84,10}]'),(4,2,'21020001',6,'[{2,480},{6,6},{84,15}]'),(4,3,'21020001',8,'[{2,640},{6,8},{84,20}]'),(4,4,'21020001',10,'[{2,800},{6,10},{84,25}]'),(4,5,'21020001',12,'[{2,960},{6,12},{84,30}]'),(4,6,'21020001',14,'[{2,1120},{6,14},{84,35}]'),(4,7,'21020001',16,'[{2,1280},{6,16},{84,40}]'),(4,8,'21020001',18,'[{2,1440},{6,18},{84,45}]'),(4,9,'21020001',20,'[{2,1600},{6,20},{84,50}]'),(4,10,'21020001',22,'[{2,1760},{6,22},{84,55}]'),(4,11,'21020001',24,'[{2,1920},{6,24},{84,60}]'),(4,12,'21020001',26,'[{2,2080},{6,26},{84,65}]'),(4,13,'21020001',28,'[{2,2240},{6,28},{84,70}]'),(4,14,'21020001',30,'[{2,2400},{6,30},{84,75}]'),(4,15,'21020001',32,'[{2,2560},{6,32},{84,80}]'),(4,16,'21020001',34,'[{2,2720},{6,34},{84,85}]'),(4,17,'21020001',36,'[{2,2880},{6,36},{84,90}]'),(4,18,'21020001',38,'[{2,3040},{6,38},{84,95}]'),(4,19,'21020001',40,'[{2,3200},{6,40},{84,100}]'),(4,20,'21020001',42,'[{2,3360},{6,42},{84,105}]'),(4,21,'21020001',44,'[{2,3520},{6,44},{84,110}]'),(4,22,'21020001',46,'[{2,3680},{6,46},{84,115}]'),(4,23,'21020001',48,'[{2,3840},{6,48},{84,120}]'),(4,24,'21020001',50,'[{2,4000},{6,50},{84,125}]'),(4,25,'21020001',52,'[{2,4160},{6,52},{84,130}]'),(4,26,'21020001',54,'[{2,4320},{6,54},{84,135}]'),(4,27,'21020001',56,'[{2,4480},{6,56},{84,140}]'),(4,28,'21020001',58,'[{2,4640},{6,58},{84,145}]'),(4,29,'21020001',60,'[{2,4800},{6,60},{84,150}]'),(4,30,'21020001',62,'[{2,4960},{6,62},{84,155}]'),(4,31,'21020001',64,'[{2,5120},{6,64},{84,160}]'),(4,32,'21020001',66,'[{2,5280},{6,66},{84,165}]'),(4,33,'21020001',68,'[{2,5440},{6,68},{84,170}]'),(4,34,'21020001',70,'[{2,5600},{6,70},{84,175}]'),(4,35,'21020001',72,'[{2,5760},{6,72},{84,180}]'),(4,36,'21020001',74,'[{2,5920},{6,74},{84,185}]'),(4,37,'21020001',76,'[{2,6080},{6,76},{84,190}]'),(4,38,'21020001',78,'[{2,6240},{6,78},{84,195}]'),(4,39,'21020001',80,'[{2,6400},{6,80},{84,200}]'),(4,40,'21020001',82,'[{2,6560},{6,82},{84,205}]'),(5,1,'21020001',4,'[{1,16},{7,4},{77,10}]'),(5,2,'21020001',6,'[{1,24},{7,6},{77,15}]'),(5,3,'21020001',8,'[{1,32},{7,8},{77,20}]'),(5,4,'21020001',10,'[{1,40},{7,10},{77,25}]'),(5,5,'21020001',12,'[{1,48},{7,12},{77,30}]'),(5,6,'21020001',14,'[{1,56},{7,14},{77,35}]'),(5,7,'21020001',16,'[{1,64},{7,16},{77,40}]'),(5,8,'21020001',18,'[{1,72},{7,18},{77,45}]'),(5,9,'21020001',20,'[{1,80},{7,20},{77,50}]'),(5,10,'21020001',22,'[{1,88},{7,22},{77,55}]'),(5,11,'21020001',24,'[{1,96},{7,24},{77,60}]'),(5,12,'21020001',26,'[{1,104},{7,26},{77,65}]'),(5,13,'21020001',28,'[{1,112},{7,28},{77,70}]'),(5,14,'21020001',30,'[{1,120},{7,30},{77,75}]'),(5,15,'21020001',32,'[{1,128},{7,32},{77,80}]'),(5,16,'21020001',34,'[{1,136},{7,34},{77,85}]'),(5,17,'21020001',36,'[{1,144},{7,36},{77,90}]'),(5,18,'21020001',38,'[{1,152},{7,38},{77,95}]'),(5,19,'21020001',40,'[{1,160},{7,40},{77,100}]'),(5,20,'21020001',42,'[{1,168},{7,42},{77,105}]'),(5,21,'21020001',44,'[{1,176},{7,44},{77,110}]'),(5,22,'21020001',46,'[{1,184},{7,46},{77,115}]'),(5,23,'21020001',48,'[{1,192},{7,48},{77,120}]'),(5,24,'21020001',50,'[{1,200},{7,50},{77,125}]'),(5,25,'21020001',52,'[{1,208},{7,52},{77,130}]'),(5,26,'21020001',54,'[{1,216},{7,54},{77,135}]'),(5,27,'21020001',56,'[{1,224},{7,56},{77,140}]'),(5,28,'21020001',58,'[{1,232},{7,58},{77,145}]'),(5,29,'21020001',60,'[{1,240},{7,60},{77,150}]'),(5,30,'21020001',62,'[{1,248},{7,62},{77,155}]'),(5,31,'21020001',64,'[{1,256},{7,64},{77,160}]'),(5,32,'21020001',66,'[{1,264},{7,66},{77,165}]'),(5,33,'21020001',68,'[{1,272},{7,68},{77,170}]'),(5,34,'21020001',70,'[{1,280},{7,70},{77,175}]'),(5,35,'21020001',72,'[{1,288},{7,72},{77,180}]'),(5,36,'21020001',74,'[{1,296},{7,74},{77,185}]'),(5,37,'21020001',76,'[{1,304},{7,76},{77,190}]'),(5,38,'21020001',78,'[{1,312},{7,78},{77,195}]'),(5,39,'21020001',80,'[{1,320},{7,80},{77,200}]'),(5,40,'21020001',82,'[{1,328},{7,82},{77,205}]'),(6,1,'21020001',4,'[{2,320},{8,4},{78,10}]'),(6,2,'21020001',6,'[{2,480},{8,6},{78,15}]'),(6,3,'21020001',8,'[{2,640},{8,8},{78,20}]'),(6,4,'21020001',10,'[{2,800},{8,10},{78,25}]'),(6,5,'21020001',12,'[{2,960},{8,12},{78,30}]'),(6,6,'21020001',14,'[{2,1120},{8,14},{78,35}]'),(6,7,'21020001',16,'[{2,1280},{8,16},{78,40}]'),(6,8,'21020001',18,'[{2,1440},{8,18},{78,45}]'),(6,9,'21020001',20,'[{2,1600},{8,20},{78,50}]'),(6,10,'21020001',22,'[{2,1760},{8,22},{78,55}]'),(6,11,'21020001',24,'[{2,1920},{8,24},{78,60}]'),(6,12,'21020001',26,'[{2,2080},{8,26},{78,65}]'),(6,13,'21020001',28,'[{2,2240},{8,28},{78,70}]'),(6,14,'21020001',30,'[{2,2400},{8,30},{78,75}]'),(6,15,'21020001',32,'[{2,2560},{8,32},{78,80}]'),(6,16,'21020001',34,'[{2,2720},{8,34},{78,85}]'),(6,17,'21020001',36,'[{2,2880},{8,36},{78,90}]'),(6,18,'21020001',38,'[{2,3040},{8,38},{78,95}]'),(6,19,'21020001',40,'[{2,3200},{8,40},{78,100}]'),(6,20,'21020001',42,'[{2,3360},{8,42},{78,105}]'),(6,21,'21020001',44,'[{2,3520},{8,44},{78,110}]'),(6,22,'21020001',46,'[{2,3680},{8,46},{78,115}]'),(6,23,'21020001',48,'[{2,3840},{8,48},{78,120}]'),(6,24,'21020001',50,'[{2,4000},{8,50},{78,125}]'),(6,25,'21020001',52,'[{2,4160},{8,52},{78,130}]'),(6,26,'21020001',54,'[{2,4320},{8,54},{78,135}]'),(6,27,'21020001',56,'[{2,4480},{8,56},{78,140}]'),(6,28,'21020001',58,'[{2,4640},{8,58},{78,145}]'),(6,29,'21020001',60,'[{2,4800},{8,60},{78,150}]'),(6,30,'21020001',62,'[{2,4960},{8,62},{78,155}]'),(6,31,'21020001',64,'[{2,5120},{8,64},{78,160}]'),(6,32,'21020001',66,'[{2,5280},{8,66},{78,165}]'),(6,33,'21020001',68,'[{2,5440},{8,68},{78,170}]'),(6,34,'21020001',70,'[{2,5600},{8,70},{78,175}]'),(6,35,'21020001',72,'[{2,5760},{8,72},{78,180}]'),(6,36,'21020001',74,'[{2,5920},{8,74},{78,185}]'),(6,37,'21020001',76,'[{2,6080},{8,76},{78,190}]'),(6,38,'21020001',78,'[{2,6240},{8,78},{78,195}]'),(6,39,'21020001',80,'[{2,6400},{8,80},{78,200}]'),(6,40,'21020001',82,'[{2,6560},{8,82},{78,205}]'),(7,1,'21020001',6,'[{1,20},{3,8},{81,10},{82,10}]'),(7,2,'21020001',9,'[{1,30},{3,12},{81,15},{82,15}]'),(7,3,'21020001',12,'[{1,40},{3,16},{81,20},{82,20}]'),(7,4,'21020001',15,'[{1,50},{3,20},{81,25},{82,25}]'),(7,5,'21020001',18,'[{1,60},{3,24},{81,30},{82,30}]'),(7,6,'21020001',21,'[{1,70},{3,28},{81,35},{82,35}]'),(7,7,'21020001',24,'[{1,80},{3,32},{81,40},{82,40}]'),(7,8,'21020001',27,'[{1,90},{3,36},{81,45},{82,45}]'),(7,9,'21020001',30,'[{1,100},{3,40},{81,50},{82,50}]'),(7,10,'21020001',33,'[{1,110},{3,44},{81,55},{82,55}]'),(7,11,'21020001',36,'[{1,120},{3,48},{81,60},{82,60}]'),(7,12,'21020001',39,'[{1,130},{3,52},{81,65},{82,65}]'),(7,13,'21020001',42,'[{1,140},{3,56},{81,70},{82,70}]'),(7,14,'21020001',45,'[{1,150},{3,60},{81,75},{82,75}]'),(7,15,'21020001',48,'[{1,160},{3,64},{81,80},{82,80}]'),(7,16,'21020001',51,'[{1,170},{3,68},{81,85},{82,85}]'),(7,17,'21020001',54,'[{1,180},{3,72},{81,90},{82,90}]'),(7,18,'21020001',57,'[{1,190},{3,76},{81,95},{82,95}]'),(7,19,'21020001',60,'[{1,200},{3,80},{81,100},{82,100}]'),(7,20,'21020001',63,'[{1,210},{3,84},{81,105},{82,105}]'),(7,21,'21020001',66,'[{1,220},{3,88},{81,110},{82,110}]'),(7,22,'21020001',69,'[{1,230},{3,92},{81,115},{82,115}]'),(7,23,'21020001',72,'[{1,240},{3,96},{81,120},{82,120}]'),(7,24,'21020001',75,'[{1,250},{3,100},{81,125},{82,125}]'),(7,25,'21020001',78,'[{1,260},{3,104},{81,130},{82,130}]'),(7,26,'21020001',81,'[{1,270},{3,108},{81,135},{82,135}]'),(7,27,'21020001',84,'[{1,280},{3,112},{81,140},{82,140}]'),(7,28,'21020001',87,'[{1,290},{3,116},{81,145},{82,145}]'),(7,29,'21020001',90,'[{1,300},{3,120},{81,150},{82,150}]'),(7,30,'21020001',93,'[{1,310},{3,124},{81,155},{82,155}]'),(7,31,'21020001',96,'[{1,320},{3,128},{81,160},{82,160}]'),(7,32,'21020001',99,'[{1,330},{3,132},{81,165},{82,165}]'),(7,33,'21020001',102,'[{1,340},{3,136},{81,170},{82,170}]'),(7,34,'21020001',105,'[{1,350},{3,140},{81,175},{82,175}]'),(7,35,'21020001',108,'[{1,360},{3,144},{81,180},{82,180}]'),(7,36,'21020001',111,'[{1,370},{3,148},{81,185},{82,185}]'),(7,37,'21020001',114,'[{1,380},{3,152},{81,190},{82,190}]'),(7,38,'21020001',117,'[{1,390},{3,156},{81,195},{82,195}]'),(7,39,'21020001',120,'[{1,400},{3,160},{81,200},{82,200}]'),(7,40,'21020001',123,'[{1,410},{3,164},{81,205},{82,205}]'),(8,1,'21020001',6,'[{2,400},{4,8},{83,10},{84,10}]'),(8,2,'21020001',9,'[{2,600},{4,12},{83,15},{84,15}]'),(8,3,'21020001',12,'[{2,800},{4,16},{83,20},{84,20}]'),(8,4,'21020001',15,'[{2,1000},{4,20},{83,25},{84,25}]'),(8,5,'21020001',18,'[{2,1200},{4,24},{83,30},{84,30}]'),(8,6,'21020001',21,'[{2,1400},{4,28},{83,35},{84,35}]'),(8,7,'21020001',24,'[{2,1600},{4,32},{83,40},{84,40}]'),(8,8,'21020001',27,'[{2,1800},{4,36},{83,45},{84,45}]'),(8,9,'21020001',30,'[{2,2000},{4,40},{83,50},{84,50}]'),(8,10,'21020001',33,'[{2,2200},{4,44},{83,55},{84,55}]'),(8,11,'21020001',36,'[{2,2400},{4,48},{83,60},{84,60}]'),(8,12,'21020001',39,'[{2,2600},{4,52},{83,65},{84,65}]'),(8,13,'21020001',42,'[{2,2800},{4,56},{83,70},{84,70}]'),(8,14,'21020001',45,'[{2,3000},{4,60},{83,75},{84,75}]'),(8,15,'21020001',48,'[{2,3200},{4,64},{83,80},{84,80}]'),(8,16,'21020001',51,'[{2,3400},{4,68},{83,85},{84,85}]'),(8,17,'21020001',54,'[{2,3600},{4,72},{83,90},{84,90}]'),(8,18,'21020001',57,'[{2,3800},{4,76},{83,95},{84,95}]'),(8,19,'21020001',60,'[{2,4000},{4,80},{83,100},{84,100}]'),(8,20,'21020001',63,'[{2,4200},{4,84},{83,105},{84,105}]'),(8,21,'21020001',66,'[{2,4400},{4,88},{83,110},{84,110}]'),(8,22,'21020001',69,'[{2,4600},{4,92},{83,115},{84,115}]'),(8,23,'21020001',72,'[{2,4800},{4,96},{83,120},{84,120}]'),(8,24,'21020001',75,'[{2,5000},{4,100},{83,125},{84,125}]'),(8,25,'21020001',78,'[{2,5200},{4,104},{83,130},{84,130}]'),(8,26,'21020001',81,'[{2,5400},{4,108},{83,135},{84,135}]'),(8,27,'21020001',84,'[{2,5600},{4,112},{83,140},{84,140}]'),(8,28,'21020001',87,'[{2,5800},{4,116},{83,145},{84,145}]'),(8,29,'21020001',90,'[{2,6000},{4,120},{83,150},{84,150}]'),(8,30,'21020001',93,'[{2,6200},{4,124},{83,155},{84,155}]'),(8,31,'21020001',96,'[{2,6400},{4,128},{83,160},{84,160}]'),(8,32,'21020001',99,'[{2,6600},{4,132},{83,165},{84,165}]'),(8,33,'21020001',102,'[{2,6800},{4,136},{83,170},{84,170}]'),(8,34,'21020001',105,'[{2,7000},{4,140},{83,175},{84,175}]'),(8,35,'21020001',108,'[{2,7200},{4,144},{83,180},{84,180}]'),(8,36,'21020001',111,'[{2,7400},{4,148},{83,185},{84,185}]'),(8,37,'21020001',114,'[{2,7600},{4,152},{83,190},{84,190}]'),(8,38,'21020001',117,'[{2,7800},{4,156},{83,195},{84,195}]'),(8,39,'21020001',120,'[{2,8000},{4,160},{83,200},{84,200}]'),(8,40,'21020001',123,'[{2,8200},{4,164},{83,205},{84,205}]'),(9,1,'21020001',4,'[{1,16},{79,10}]'),(9,2,'21020001',6,'[{1,24},{79,15}]'),(9,3,'21020001',8,'[{1,32},{79,20}]'),(9,4,'21020001',10,'[{1,40},{79,25}]'),(9,5,'21020001',12,'[{1,48},{79,30}]'),(9,6,'21020001',14,'[{1,56},{79,35}]'),(9,7,'21020001',16,'[{1,64},{79,40}]'),(9,8,'21020001',18,'[{1,72},{79,45}]'),(9,9,'21020001',20,'[{1,80},{79,50}]'),(9,10,'21020001',22,'[{1,88},{79,55}]'),(9,11,'21020001',24,'[{1,96},{79,60}]'),(9,12,'21020001',26,'[{1,104},{79,65}]'),(9,13,'21020001',28,'[{1,112},{79,70}]'),(9,14,'21020001',30,'[{1,120},{79,75}]'),(9,15,'21020001',32,'[{1,128},{79,80}]'),(9,16,'21020001',34,'[{1,136},{79,85}]'),(9,17,'21020001',36,'[{1,144},{79,90}]'),(9,18,'21020001',38,'[{1,152},{79,95}]'),(9,19,'21020001',40,'[{1,160},{79,100}]'),(9,20,'21020001',42,'[{1,168},{79,105}]'),(9,21,'21020001',44,'[{1,176},{79,110}]'),(9,22,'21020001',46,'[{1,184},{79,115}]'),(9,23,'21020001',48,'[{1,192},{79,120}]'),(9,24,'21020001',50,'[{1,200},{79,125}]'),(9,25,'21020001',52,'[{1,208},{79,130}]'),(9,26,'21020001',54,'[{1,216},{79,135}]'),(9,27,'21020001',56,'[{1,224},{79,140}]'),(9,28,'21020001',58,'[{1,232},{79,145}]'),(9,29,'21020001',60,'[{1,240},{79,150}]'),(9,30,'21020001',62,'[{1,248},{79,155}]'),(9,31,'21020001',64,'[{1,256},{79,160}]'),(9,32,'21020001',66,'[{1,264},{79,165}]'),(9,33,'21020001',68,'[{1,272},{79,170}]'),(9,34,'21020001',70,'[{1,280},{79,175}]'),(9,35,'21020001',72,'[{1,288},{79,180}]'),(9,36,'21020001',74,'[{1,296},{79,185}]'),(9,37,'21020001',76,'[{1,304},{79,190}]'),(9,38,'21020001',78,'[{1,312},{79,195}]'),(9,39,'21020001',80,'[{1,320},{79,200}]'),(9,40,'21020001',82,'[{1,328},{79,205}]'),(10,1,'21020001',4,'[{2,320},{80,10}]'),(10,2,'21020001',6,'[{2,480},{80,15}]'),(10,3,'21020001',8,'[{2,640},{80,20}]'),(10,4,'21020001',10,'[{2,800},{80,25}]'),(10,5,'21020001',12,'[{2,960},{80,30}]'),(10,6,'21020001',14,'[{2,1120},{80,35}]'),(10,7,'21020001',16,'[{2,1280},{80,40}]'),(10,8,'21020001',18,'[{2,1440},{80,45}]'),(10,9,'21020001',20,'[{2,1600},{80,50}]'),(10,10,'21020001',22,'[{2,1760},{80,55}]'),(10,11,'21020001',24,'[{2,1920},{80,60}]'),(10,12,'21020001',26,'[{2,2080},{80,65}]'),(10,13,'21020001',28,'[{2,2240},{80,70}]'),(10,14,'21020001',30,'[{2,2400},{80,75}]'),(10,15,'21020001',32,'[{2,2560},{80,80}]'),(10,16,'21020001',34,'[{2,2720},{80,85}]'),(10,17,'21020001',36,'[{2,2880},{80,90}]'),(10,18,'21020001',38,'[{2,3040},{80,95}]'),(10,19,'21020001',40,'[{2,3200},{80,100}]'),(10,20,'21020001',42,'[{2,3360},{80,105}]'),(10,21,'21020001',44,'[{2,3520},{80,110}]'),(10,22,'21020001',46,'[{2,3680},{80,115}]'),(10,23,'21020001',48,'[{2,3840},{80,120}]'),(10,24,'21020001',50,'[{2,4000},{80,125}]'),(10,25,'21020001',52,'[{2,4160},{80,130}]'),(10,26,'21020001',54,'[{2,4320},{80,135}]'),(10,27,'21020001',56,'[{2,4480},{80,140}]'),(10,28,'21020001',58,'[{2,4640},{80,145}]'),(10,29,'21020001',60,'[{2,4800},{80,150}]'),(10,30,'21020001',62,'[{2,4960},{80,155}]'),(10,31,'21020001',64,'[{2,5120},{80,160}]'),(10,32,'21020001',66,'[{2,5280},{80,165}]'),(10,33,'21020001',68,'[{2,5440},{80,170}]'),(10,34,'21020001',70,'[{2,5600},{80,175}]'),(10,35,'21020001',72,'[{2,5760},{80,180}]'),(10,36,'21020001',74,'[{2,5920},{80,185}]'),(10,37,'21020001',76,'[{2,6080},{80,190}]'),(10,38,'21020001',78,'[{2,6240},{80,195}]'),(10,39,'21020001',80,'[{2,6400},{80,200}]'),(10,40,'21020001',82,'[{2,6560},{80,205}]'),(11,1,'21020001',8,'[{1,18},{2,360},{5,6},{77,10},{78,10}]'),(11,2,'21020001',12,'[{1,27},{2,540},{5,9},{77,15},{78,15}]'),(11,3,'21020001',16,'[{1,36},{2,720},{5,12},{77,20},{78,20}]'),(11,4,'21020001',20,'[{1,45},{2,900},{5,15},{77,25},{78,25}]'),(11,5,'21020001',24,'[{1,54},{2,1080},{5,18},{77,30},{78,30}]'),(11,6,'21020001',28,'[{1,63},{2,1260},{5,21},{77,35},{78,35}]'),(11,7,'21020001',32,'[{1,72},{2,1440},{5,24},{77,40},{78,40}]'),(11,8,'21020001',36,'[{1,81},{2,1620},{5,27},{77,45},{78,45}]'),(11,9,'21020001',40,'[{1,90},{2,1800},{5,30},{77,50},{78,50}]'),(11,10,'21020001',44,'[{1,99},{2,1980},{5,33},{77,55},{78,55}]'),(11,11,'21020001',48,'[{1,108},{2,2160},{5,36},{77,60},{78,60}]'),(11,12,'21020001',52,'[{1,117},{2,2340},{5,39},{77,65},{78,65}]'),(11,13,'21020001',56,'[{1,126},{2,2520},{5,42},{77,70},{78,70}]'),(11,14,'21020001',60,'[{1,135},{2,2700},{5,45},{77,75},{78,75}]'),(11,15,'21020001',64,'[{1,144},{2,2880},{5,48},{77,80},{78,80}]'),(11,16,'21020001',68,'[{1,153},{2,3060},{5,51},{77,85},{78,85}]'),(11,17,'21020001',72,'[{1,162},{2,3240},{5,54},{77,90},{78,90}]'),(11,18,'21020001',76,'[{1,171},{2,3420},{5,57},{77,95},{78,95}]'),(11,19,'21020001',80,'[{1,180},{2,3600},{5,60},{77,100},{78,100}]'),(11,20,'21020001',84,'[{1,189},{2,3780},{5,63},{77,105},{78,105}]'),(11,21,'21020001',88,'[{1,198},{2,3960},{5,66},{77,110},{78,110}]'),(11,22,'21020001',92,'[{1,207},{2,4140},{5,69},{77,115},{78,115}]'),(11,23,'21020001',96,'[{1,216},{2,4320},{5,72},{77,120},{78,120}]'),(11,24,'21020001',100,'[{1,225},{2,4500},{5,75},{77,125},{78,125}]'),(11,25,'21020001',104,'[{1,234},{2,4680},{5,78},{77,130},{78,130}]'),(11,26,'21020001',108,'[{1,243},{2,4860},{5,81},{77,135},{78,135}]'),(11,27,'21020001',112,'[{1,252},{2,5040},{5,84},{77,140},{78,140}]'),(11,28,'21020001',116,'[{1,261},{2,5220},{5,87},{77,145},{78,145}]'),(11,29,'21020001',120,'[{1,270},{2,5400},{5,90},{77,150},{78,150}]'),(11,30,'21020001',124,'[{1,279},{2,5580},{5,93},{77,155},{78,155}]'),(11,31,'21020001',128,'[{1,288},{2,5760},{5,96},{77,160},{78,160}]'),(11,32,'21020001',132,'[{1,297},{2,5940},{5,99},{77,165},{78,165}]'),(11,33,'21020001',136,'[{1,306},{2,6120},{5,102},{77,170},{78,170}]'),(11,34,'21020001',140,'[{1,315},{2,6300},{5,105},{77,175},{78,175}]'),(11,35,'21020001',144,'[{1,324},{2,6480},{5,108},{77,180},{78,180}]'),(11,36,'21020001',148,'[{1,333},{2,6660},{5,111},{77,185},{78,185}]'),(11,37,'21020001',152,'[{1,342},{2,6840},{5,114},{77,190},{78,190}]'),(11,38,'21020001',156,'[{1,351},{2,7020},{5,117},{77,195},{78,195}]'),(11,39,'21020001',160,'[{1,360},{2,7200},{5,120},{77,200},{78,200}]'),(11,40,'21020001',164,'[{1,369},{2,7380},{5,123},{77,205},{78,205}]'),(12,1,'21020001',8,'[{1,18},{2,360},{6,6},{79,10},{80,10}]'),(12,2,'21020001',12,'[{1,27},{2,540},{6,9},{79,15},{80,15}]'),(12,3,'21020001',16,'[{1,36},{2,720},{6,12},{79,20},{80,20}]'),(12,4,'21020001',20,'[{1,45},{2,900},{6,15},{79,25},{80,25}]'),(12,5,'21020001',24,'[{1,54},{2,1080},{6,18},{79,30},{80,30}]'),(12,6,'21020001',28,'[{1,63},{2,1260},{6,21},{79,35},{80,35}]'),(12,7,'21020001',32,'[{1,72},{2,1440},{6,24},{79,40},{80,40}]'),(12,8,'21020001',36,'[{1,81},{2,1620},{6,27},{79,45},{80,45}]'),(12,9,'21020001',40,'[{1,90},{2,1800},{6,30},{79,50},{80,50}]'),(12,10,'21020001',44,'[{1,99},{2,1980},{6,33},{79,55},{80,55}]'),(12,11,'21020001',48,'[{1,108},{2,2160},{6,36},{79,60},{80,60}]'),(12,12,'21020001',52,'[{1,117},{2,2340},{6,39},{79,65},{80,65}]'),(12,13,'21020001',56,'[{1,126},{2,2520},{6,42},{79,70},{80,70}]'),(12,14,'21020001',60,'[{1,135},{2,2700},{6,45},{79,75},{80,75}]'),(12,15,'21020001',64,'[{1,144},{2,2880},{6,48},{79,80},{80,80}]'),(12,16,'21020001',68,'[{1,153},{2,3060},{6,51},{79,85},{80,85}]'),(12,17,'21020001',72,'[{1,162},{2,3240},{6,54},{79,90},{80,90}]'),(12,18,'21020001',76,'[{1,171},{2,3420},{6,57},{79,95},{80,95}]'),(12,19,'21020001',80,'[{1,180},{2,3600},{6,60},{79,100},{80,100}]'),(12,20,'21020001',84,'[{1,189},{2,3780},{6,63},{79,105},{80,105}]'),(12,21,'21020001',88,'[{1,198},{2,3960},{6,66},{79,110},{80,110}]'),(12,22,'21020001',92,'[{1,207},{2,4140},{6,69},{79,115},{80,115}]'),(12,23,'21020001',96,'[{1,216},{2,4320},{6,72},{79,120},{80,120}]'),(12,24,'21020001',100,'[{1,225},{2,4500},{6,75},{79,125},{80,125}]'),(12,25,'21020001',104,'[{1,234},{2,4680},{6,78},{79,130},{80,130}]'),(12,26,'21020001',108,'[{1,243},{2,4860},{6,81},{79,135},{80,135}]'),(12,27,'21020001',112,'[{1,252},{2,5040},{6,84},{79,140},{80,140}]'),(12,28,'21020001',116,'[{1,261},{2,5220},{6,87},{79,145},{80,145}]'),(12,29,'21020001',120,'[{1,270},{2,5400},{6,90},{79,150},{80,150}]'),(12,30,'21020001',124,'[{1,279},{2,5580},{6,93},{79,155},{80,155}]'),(12,31,'21020001',128,'[{1,288},{2,5760},{6,96},{79,160},{80,160}]'),(12,32,'21020001',132,'[{1,297},{2,5940},{6,99},{79,165},{80,165}]'),(12,33,'21020001',136,'[{1,306},{2,6120},{6,102},{79,170},{80,170}]'),(12,34,'21020001',140,'[{1,315},{2,6300},{6,105},{79,175},{80,175}]'),(12,35,'21020001',144,'[{1,324},{2,6480},{6,108},{79,180},{80,180}]'),(12,36,'21020001',148,'[{1,333},{2,6660},{6,111},{79,185},{80,185}]'),(12,37,'21020001',152,'[{1,342},{2,6840},{6,114},{79,190},{80,190}]'),(12,38,'21020001',156,'[{1,351},{2,7020},{6,117},{79,195},{80,195}]'),(12,39,'21020001',160,'[{1,360},{2,7200},{6,120},{79,200},{80,200}]'),(12,40,'21020001',164,'[{1,369},{2,7380},{6,123},{79,205},{80,205}]');
/*!40000 ALTER TABLE `base_star_shadow_stren_cfg` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_star_shadow_suit_cfg`
--

DROP TABLE IF EXISTS `base_star_shadow_suit_cfg`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_star_shadow_suit_cfg` (
  `id` tinyint(3) unsigned NOT NULL COMMENT '套装id',
  `color` tinyint(3) unsigned NOT NULL COMMENT '套装颜色',
  `name` varchar(255) NOT NULL COMMENT '套装名@lang@',
  `member_list` varchar(255) NOT NULL COMMENT '套装内容',
  `attr` varchar(1024) NOT NULL COMMENT '套装属性',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星痕套装配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_star_shadow_suit_cfg`
--

LOCK TABLES `base_star_shadow_suit_cfg` WRITE;
/*!40000 ALTER TABLE `base_star_shadow_suit_cfg` DISABLE KEYS */;
INSERT INTO `base_star_shadow_suit_cfg` VALUES (1,0,'小马','[21010101,21010102]','[{2,[{1,350},{2,9000},{81,575}]}]'),(2,0,'小犬','[21010103,21010104]','[{2,[{3,320},{4,320},{82,575}]}]'),(3,0,'蛇夫','[21010105,21010106,21010107]','[{3,[{1,500},{5,200},{6,200},{83,575},{84,575}]}]'),(4,0,'鲸鱼','[21010108,21010109,21010110]','[{3,[{2,12000},{7,180},{8,180},{77,575},{78,575}]}]'),(5,1,'天坛','[21010201,21010202]','[{2,[{1,600},{2,15000},{81,625},{82,625}]}]'),(6,1,'山案','[21010203,21010204]','[{2,[{3,550},{4,550},{79,625},{80,625}]}]'),(7,1,'绘架','[21010205,21010206,21010207]','[{3,[{1,900},{5,450},{6,450},{83,1000},{84,1000}]}]'),(8,1,'天燕','[21010208,21010209,21010210]','[{3,[{2,23000},{7,400},{8,400},{77,1000},{78,1000}]}]'),(9,1,'飞鱼','[21010301,21010302,21010303,21010304]','[{2,[{1,850},{3,750},{79,750},{80,750}]},{4,[{2,26000},{4,750},{81,1250},{82,1250}]}]'),(10,1,'矩尺','[21010305,21010306,21010307,21010308,21010309,21010310]','[{2,[{1,600},{5,450},{6,450},{83,1000},{84,1000}]},{4,[{2,17000},{7,400},{8,400},{77,1000},{78,1000}]},{6,[{1,650},{2,20000},{48,525},{49,525},{79,1500},{80,1500}]}]'),(11,1,'剑鱼','[21010401,21010402,21010403,21010404,21010411,21010412]','[{2,[{1,1000},{5,750},{6,750},{79,1250},{80,1250}]},{4,[{2,24000},{7,620},{8,620},{83,1400},{84,1400}]},{6,[{1,1600},{2,40000},{3,1400},{81,1800},{82,1800}]}]'),(12,1,'孔雀','[21010405,21010406,21010407,21010408,21010409,21010410]','[{2,[{1,1200},{3,850},{48,1000},{77,1600},{78,1600}]},{4,[{2,27000},{4,850},{49,1000},{79,1600},{80,1600}]},{6,[{1,2000},{2,45000},{4,1400},{83,1800},{84,1800}]}]'),(13,2,'蝎虎','[21010502,21010505,21010506,21010507]','[{2,[{1,1350},{3,600},{4,600},{81,1800},{82,1800}]},{4,[{2,35000},{5,650},{6,650},{77,2500},{78,2500}]}]'),(14,2,'仙女','[21010503,21010508,21010509,21010510]','[{2,[{1,1600},{7,700},{8,700},{83,2200},{84,2200}]},{4,[{2,55000},{5,750},{6,750},{49,1200},{79,3000},{80,3000}]}]'),(15,2,'鹿豹','[21010501,21010504,21010511,21010512]','[{2,[{1,1650},{3,1500},{4,1500},{77,2200},{78,2200}]},{4,[{2,57500},{7,800},{8,800},{48,1200},{81,3000},{82,3000}]}]'),(16,2,'御夫','[21010601,21010602,21010603,21010604]','[{2,[{1,2590},{3,2290},{79,2290},{80,2290}]},{4,[{2,79240},{4,2290},{81,3810},{82,3810}]}]'),(17,2,'猎犬','[21010605,21010606,21010607,21010608,21010609,21010610]','[{2,[{1,1800},{5,1350},{6,1350},{83,3000},{84,3000}]},{4,[{2,51000},{7,1200},{8,1200},{77,3000},{78,3000}]},{6,[{1,1950},{2,60000},{48,1580},{49,1580},{79,4500},{80,4500}]}]'),(18,2,'狐狸','[21010701,21010702,21010705,21010706,21010707]','[{2,[{1,1840},{5,1380},{6,1380},{77,2310},{78,2310}]},{4,[{2,51660},{7,1330},{8,1330},{83,3010},{84,3010}]}]'),(19,2,'天鹅','[21010703,21010704,21010708,21010709,21010710]','[{2,[{1,2170},{3,1540},{48,1810},{77,2900},{78,2900}]},{4,[{2,57080},{4,1800},{49,2110},{79,3380},{80,3380}]}]'),(20,2,'小狮','[21010801,21010802,21010803,21010804,21010811,21010812]','[{2,[{1,3020},{5,2260},{6,2260},{79,3770},{80,3770}]},{4,[{2,72410},{7,1870},{8,1870},{83,4220},{84,4220}]},{6,[{1,4830},{2,120690},{3,4220},{81,5430},{82,5430}]}]'),(21,2,'英仙','[21010805,21010806,21010807,21010808,21010809,21010810]','[{2,[{1,3620},{3,2560},{48,3020},{77,4830},{78,4830}]},{4,[{2,81430},{4,2560},{49,3020},{79,4830},{80,4830}]},{6,[{1,6030},{2,135710},{4,4220},{83,5430},{84,5430}]}]'),(22,3,'牧夫','[21010902,21010905,21010906,21010907]','[{2,[{1,3690},{3,1640},{4,1640},{81,4920},{82,4920}]},{4,[{2,95740},{5,1780},{6,1780},{77,6840},{78,6840}]}]'),(23,3,'飞马','[21010903,21010908,21010909,21010910]','[{2,[{1,4370},{7,1910},{8,1910},{83,6000},{84,6000}]},{4,[{2,150050},{5,2050},{6,2050},{49,3270},{79,8180},{80,8180}]}]'),(24,3,'三角','[21010901,21010904,21010911,21010912]','[{2,[{1,4500},{3,4090},{4,4090},{77,6010},{78,6010}]},{4,[{2,156970},{7,2180},{8,2180},{48,3280},{81,8190},{82,8190}]}]'),(25,3,'天箭','[21011001,21011002,21011003,21011004]','[{2,[{1,6570},{3,5810},{77,5810},{78,5810}]},{4,[{2,201120},{4,5810},{81,9670},{82,9670}]}]'),(26,3,'巨蟹','[21011005,21011006,21011007,21011008,21011009,21011010]','[{2,[{1,4420},{5,3310},{6,3310},{83,7360},{84,7360}]},{4,[{2,125130},{7,2940},{8,2940},{77,7360},{78,7360}]},{6,[{1,4780},{2,147210},{48,3880},{49,3880},{79,11040},{80,11040}]}]'),(27,3,'人马','[21011101,21011102,21011105,21011106,21011107]','[{2,[{1,4790},{5,3600},{6,3600},{79,6020},{80,6020}]},{4,[{2,134590},{7,3460},{8,3460},{83,7840},{84,7840}]}]'),(28,3,'双子','[21011103,21011104,21011108,21011109,21011110]','[{2,[{1,5650},{3,4010},{48,4720},{77,7560},{78,7560}]},{4,[{2,148730},{4,4690},{49,5500},{79,8810},{80,8810}]}]'),(29,3,'宝瓶','[21011201,21011202,21011203,21011204,21011211,21011212]','[{2,[{1,7050},{5,5270},{6,5270},{79,8800},{80,8800}]},{4,[{2,168960},{7,4360},{8,4360},{83,9850},{84,9850}]},{6,[{1,11270},{2,281610},{3,9850},{81,12670},{82,12670}]}]'),(30,3,'室女','[21011205,21011206,21011207,21011208,21011209,21011210]','[{2,[{1,8450},{3,5980},{48,7050},{77,11270},{78,11270}]},{4,[{2,190070},{4,5980},{49,7050},{79,11270},{80,11270}]},{6,[{1,14080},{2,316770},{4,9850},{83,12670},{84,12670}]}]'),(31,3,'双鱼','[21011301,21011302,21011303,21011304,21011305,21011306,21011307,21011308,21011309,21011310,21011311,21011312]','[{2,[{1,7930},{3,3520},{4,3520},{81,10570},{82,10570}]},{4,[{2,165000},{5,2250},{6,2250},{77,9800},{78,9800}]},{6,[{1,10110},{7,4250},{8,4250},{83,13880},{84,13880}]},{8,[{2,235000},{5,4250},{6,4250},{79,13880},{80,13880}]},{10,[{1,14000},{2,340000},{48,8000},{49,8000},{81,9250},{83,7680},{77,9250},{79,7680}]},{12,[{1,25000},{2,570000},{3,15500},{4,15500},{82,9250},{84,7680},{78,9250},{80,7680}]}]'),(32,4,'天秤','[21011401,21011402,21011403,21011404,21011405,21011406,21011407,21011408,21011409,21011410,21011411,21011412]','[{2,[{1,9440},{3,4190},{4,4190},{83,12590},{84,12590}]},{4,[{2,196510},{5,2680},{6,2680},{77,11670},{78,11670}]},{6,[{1,12040},{7,5060},{8,5060},{81,16530},{82,16530}]},{8,[{2,279880},{5,5060},{6,5060},{79,16530},{80,16530}]},{10,[{1,16670},{2,404930},{48,9530},{49,9530},{81,6500},{82,6500},{77,12290},{78,12290}]},{12,[{1,29770},{2,678860},{3,18460},{4,18460},{83,16500},{84,16500},{79,6500},{80,6500}]}]'),(33,4,'摩羯','[21011501,21011502,21011503,21011504,21011505,21011506,21011507,21011508,21011509,21011510,21011511,21011512]','[{2,[{1,9440},{3,4190},{4,4190},{77,12590},{78,12590}]},{4,[{2,196510},{7,2680},{8,2680},{79,11670},{80,11670}]},{6,[{1,12040},{5,5060},{6,5060},{83,16530},{84,16530}]},{8,[{2,279880},{7,5060},{8,5060},{81,16530},{82,16530}]},{10,[{1,16670},{2,404930},{48,9530},{49,9530},{83,6500},{84,6500},{79,12290},{80,12290}]},{12,[{1,29770},{2,678860},{3,18460},{4,18460},{81,6500},{82,6500},{77,16500},{78,16500}]}]'),(34,4,'狮子','[21011601,21011602,21011603,21011604,21011605,21011606,21011607,21011608,21011609,21011610,21011611,21011612]','[{2,[{1,9440},{3,4190},{4,4190},{79,12590},{80,12590}]},{4,[{2,196510},{5,2680},{6,2680},{81,11670},{82,11670}]},{6,[{1,12040},{7,5060},{8,5060},{77,16530},{78,16530}]},{8,[{2,279880},{5,5060},{6,5060},{83,16530},{84,16530}]},{10,[{1,16670},{2,404930},{48,9530},{49,9530},{81,12290},{82,12290},{77,6500},{78,6500}]},{12,[{1,29770},{2,678860},{3,18460},{4,18460},{83,6500},{84,6500},{79,16500},{80,16500}]}]'),(35,4,'白羊','[21011701,21011702,21011703,21011704,21011705,21011706,21011707,21011708,21011709,21011710,21011711,21011712]','[{2,[{1,9440},{3,4190},{4,4190},{81,12590},{82,12590}]},{4,[{2,196510},{7,2680},{8,2680},{83,11670},{84,11670}]},{6,[{1,12040},{5,5060},{6,5060},{79,16530},{80,16530}]},{8,[{2,279880},{7,5060},{8,5060},{77,16530},{78,16530}]},{10,[{1,16670},{2,404930},{48,9530},{49,9530},{83,12290},{84,12290},{79,6500},{80,6500}]},{12,[{1,29770},{2,678860},{3,18460},{4,18460},{81,16500},{82,16500},{77,6500},{78,6500}]}]');
/*!40000 ALTER TABLE `base_star_shadow_suit_cfg` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_star_soul_active_cfg`
--

DROP TABLE IF EXISTS `base_star_soul_active_cfg`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_star_soul_active_cfg` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '星灵id',
  `name` varchar(255) NOT NULL COMMENT '星灵名字@lang@',
  `goods` varchar(255) NOT NULL COMMENT '激活道具',
  `attr` varchar(255) NOT NULL COMMENT '提供的属性',
  `quality` tinyint(2) unsigned NOT NULL COMMENT '初始品质',
  `common_skill` int(11) unsigned NOT NULL COMMENT '普功技能id',
  `skills` varchar(255) NOT NULL COMMENT '技能列表',
  `passive_skill` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '默认提供的被动技能id',
  `personality_type` tinyint(3) unsigned DEFAULT '0' COMMENT '个性类型',
  `personality` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '个性编号',
  `personality_name` varchar(128) NOT NULL COMMENT '个性名称@lang@',
  `personality_desc` varchar(1024) NOT NULL COMMENT '个性描述@lang@',
  `figure_id` int(11) unsigned NOT NULL COMMENT '模型id',
  `icon_id` int(11) unsigned NOT NULL COMMENT '头像图标id',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星灵激活配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_star_soul_active_cfg`
--

LOCK TABLES `base_star_soul_active_cfg` WRITE;
/*!40000 ALTER TABLE `base_star_soul_active_cfg` DISABLE KEYS */;
INSERT INTO `base_star_soul_active_cfg` VALUES (1001,'萌羊座','[{0,18040001,1}]','[{1,18},{2,319},{3,8},{4,9},{5,5},{6,4},{7,4},{8,4}]',1,60101301,'[{60201301,1}]',60404701,0,0,'','',501002,180001),(1002,'白羊座','[{0,18040002,1}]','[{1,30},{2,525},{3,15},{4,13},{5,7},{6,7},{7,6},{8,8}]',2,60101101,'[{60201101,1}]',60404801,2,303,'他强任他强','血量低于40%时，伤害减免提升30%',501003,180002),(1003,'金牛座','[{0,18040003,1}]','[{1,30},{2,526},{3,14},{4,14},{5,7},{6,7},{7,7},{8,7}]',2,60100101,'[{60200101,1}]',60400801,1,102,'追魂夺命','优先攻击敌方血量最低的单位',501004,180003),(1004,'双子座','[{0,18040004,1}]','[{1,28},{2,563},{3,15},{4,13},{5,7},{6,7},{7,8},{8,6}]',2,60100801,'[{60200801,1}]',60400901,1,108,'无所畏惧','优先攻击敌方攻击最高者',501005,180004),(1005,'巨蟹座','[{0,18040005,1}]','[{1,30},{2,510},{3,15},{4,13},{5,7},{6,7},{7,7},{8,7}]',2,60100401,'[{60200401,1}]',60401001,2,301,'越战越勇','血量每降低5%时，伤害减免提升1.5%',501006,180005),(1006,'狮子座','[{0,18040006,1}]','[{1,29},{2,541},{3,14},{4,14},{5,8},{6,6},{7,7},{8,7}]',2,60100701,'[{60200701,1}]',60401101,2,302,'背水奋战','血量低于30%时，攻击提升40%',501007,180006),(1007,'处女座','[{0,18040007,1}]','[{1,26},{2,603},{3,15},{4,13},{5,7},{6,7},{7,7},{8,7}]',2,60100901,'[{60200901,1}]',60401201,1,107,'弱者杀手','优先攻击在场目标中战力最低的单位',501008,180007),(2001,'熊霸霸','[{0,18040101,1}]','[{1,17},{2,333},{3,8},{4,9},{5,4},{6,4},{7,4},{8,5}]',1,60101401,'[{60201401,1}]',60400301,0,0,'','',202028,180008),(2002,'难大师','[{0,18040102,1}]','[{1,18},{2,316},{3,8},{4,8},{5,5},{6,4},{7,4},{8,4}]',1,60101501,'[{60201501,1}]',60400401,0,0,'','',202003,180009),(2003,'代号09','[{0,18040103,1}]','[{1,17},{2,337},{3,9},{4,8},{5,4},{6,4},{7,4},{8,4}]',1,60101601,'[{60201601,1}]',60400501,0,0,'','',202015,180010),(2004,'修罗虎','[{0,18040104,1}]','[{1,16},{2,359},{3,9},{4,8},{5,4},{6,4},{7,4},{8,5}]',1,60101701,'[{60201701,1}]',60400601,0,0,'','',202029,180011),(2005,'暗影忍者','[{0,18040105,1}]','[{1,18},{2,312},{3,9},{4,8},{5,4},{6,4},{7,4},{8,5}]',1,60101801,'[{60201801,1}]',60400101,0,0,'','',202027,180012),(3001,'蛇夫座','[{0,18040008,1}]','[{1,30},{2,650},{3,18},{4,16},{5,10},{6,10},{7,10},{8,10}]',3,60101901,'[{60201901,1}]',60401001,0,0,'毒术','每次普攻都有概率10%的概率触发毒素效果，额外扣除对手3%的生命',501015,180013);
/*!40000 ALTER TABLE `base_star_soul_active_cfg` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_star_soul_attr`
--

DROP TABLE IF EXISTS `base_star_soul_attr`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_star_soul_attr` (
  `location` tinyint(3) unsigned NOT NULL COMMENT '阵型位置',
  `star_num` tinyint(3) unsigned NOT NULL COMMENT '星灵星数',
  `attr` tinyint(3) unsigned NOT NULL COMMENT '加成属性百分比',
  PRIMARY KEY (`location`,`star_num`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星灵属性加成配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_star_soul_attr`
--

LOCK TABLES `base_star_soul_attr` WRITE;
/*!40000 ALTER TABLE `base_star_soul_attr` DISABLE KEYS */;
INSERT INTO `base_star_soul_attr` VALUES (1,0,100),(1,1,104),(1,2,110),(1,3,119),(1,4,131),(1,5,146),(2,0,60),(2,1,62),(2,2,66),(2,3,71),(2,4,79),(2,5,88),(3,0,30),(3,1,31),(3,2,33),(3,3,36),(3,4,39),(3,5,44);
/*!40000 ALTER TABLE `base_star_soul_attr` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_star_soul_drum_cfg`
--

DROP TABLE IF EXISTS `base_star_soul_drum_cfg`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_star_soul_drum_cfg` (
  `id` int(11) unsigned NOT NULL,
  `open_day` varchar(512) NOT NULL DEFAULT '[]' COMMENT '开启日期',
  `sign_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '报名持续时间',
  `sea_ready` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '入场时间',
  `sea_prepare` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '海选赛准备时间',
  `sea_enter` int(11) NOT NULL DEFAULT '0' COMMENT '海选赛选择星灵时间',
  `sea_war` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '海选赛战斗时间',
  `rank_ready` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '争霸赛备战时间(转场时间)',
  `rank_prepare` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '争霸赛准备时间',
  `rank_enter` int(11) NOT NULL DEFAULT '0' COMMENT '争霸赛选择星灵时间(3场)',
  `rank_war` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '争霸赛战斗时间(3场)',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_star_soul_drum_cfg`
--

LOCK TABLES `base_star_soul_drum_cfg` WRITE;
/*!40000 ALTER TABLE `base_star_soul_drum_cfg` DISABLE KEYS */;
INSERT INTO `base_star_soul_drum_cfg` VALUES (1,'[{6,0,0,0}]',75600,90,10,12,60,15,30,22,60);
/*!40000 ALTER TABLE `base_star_soul_drum_cfg` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_star_soul_drum_choose`
--

DROP TABLE IF EXISTS `base_star_soul_drum_choose`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_star_soul_drum_choose` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '场次',
  `type` int(11) NOT NULL DEFAULT '0' COMMENT '类型',
  `input` varchar(512) NOT NULL DEFAULT '[]' COMMENT '投入金额',
  `output` varchar(512) NOT NULL DEFAULT '[]' COMMENT '成功奖励',
  PRIMARY KEY (`id`,`type`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星灵竞猜';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_star_soul_drum_choose`
--

LOCK TABLES `base_star_soul_drum_choose` WRITE;
/*!40000 ALTER TABLE `base_star_soul_drum_choose` DISABLE KEYS */;
INSERT INTO `base_star_soul_drum_choose` VALUES (9,1,'[{2,36020001,15}]','[{2,36020001,30}]'),(9,2,'[{2,36020001,30}]','[{2,36020001,60}]'),(9,3,'[{2,36020001,50}]','[{2,36020001,100}]'),(10,1,'[{2,36020001,30}]','[{2,36020001,60}]'),(10,2,'[{2,36020001,50}]','[{2,36020001,100}]'),(10,3,'[{2,36020001,80}]','[{2,36020001,160}]'),(11,1,'[{2,36020001,50}]','[{2,36020001,100}]'),(11,2,'[{2,36020001,80}]','[{2,36020001,160}]'),(11,3,'[{2,36020001,100}]','[{2,36020001,200}]'),(12,1,'[{2,36020001,80}]','[{2,36020001,160}]'),(12,2,'[{2,36020001,100}]','[{2,36020001,200}]'),(12,3,'[{2,36020001,150}]','[{2,36020001,300}]');
/*!40000 ALTER TABLE `base_star_soul_drum_choose` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_star_soul_drum_kv`
--

DROP TABLE IF EXISTS `base_star_soul_drum_kv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_star_soul_drum_kv` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '键',
  `val` varchar(255) NOT NULL DEFAULT '0' COMMENT '值',
  `description` varchar(50) NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_star_soul_drum_kv`
--

LOCK TABLES `base_star_soul_drum_kv` WRITE;
/*!40000 ALTER TABLE `base_star_soul_drum_kv` DISABLE KEYS */;
INSERT INTO `base_star_soul_drum_kv` VALUES (1,'420','参加比赛等级'),(2,'420','参加竞猜等级'),(3,'1','区开启所需最小人数'),(4,'3','参加所需最少星灵数'),(5,'[{1,[{1,10454,13127},{3,10930,12848},{5,10611,12492}]},{2,[{1,12008,12498},{3,11893,12963},{5,12188,13261}]}]','星灵出生坐标,格式：[{阵方,[{Pos,x,y}]}], 阵方：1左边；2右边;Pos是出战位'),(6,'0','报名门票id'),(7,'[6601,6602,6603,6604,6605,6606,6607,6608]','[准备场景id]'),(8,'[6610,6611,6612,6613]','战斗场景id，[场景id]'),(9,'[{2887,6604,300},{4844,6478,300},{3488,5766,300},{2293,3369,300},{3902,3540,300},{4592,3184,300},{1704,2077,300},{4914,1335,300}]','准备区坐标准备场景出生点,格式:[{圆心坐标X,圆心坐标Y,圆半径}]'),(10,'{11478,12331}','左边出生位置'),(11,'{11936,13953}','右边出生位置'),(12,'[{6,21,00}]','开启时间'),(13,'15','星灵争霸开服天数≥15天');
/*!40000 ALTER TABLE `base_star_soul_drum_kv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_star_soul_drum_lv_zone`
--

DROP TABLE IF EXISTS `base_star_soul_drum_lv_zone`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_star_soul_drum_lv_zone` (
  `zid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战区',
  `turn` int(11) NOT NULL DEFAULT '0' COMMENT '传奇等级',
  `min_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小等级',
  `max_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大等级',
  PRIMARY KEY (`zid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星灵等级转换';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_star_soul_drum_lv_zone`
--

LOCK TABLES `base_star_soul_drum_lv_zone` WRITE;
/*!40000 ALTER TABLE `base_star_soul_drum_lv_zone` DISABLE KEYS */;
INSERT INTO `base_star_soul_drum_lv_zone` VALUES (1,1,50,999);
/*!40000 ALTER TABLE `base_star_soul_drum_lv_zone` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_star_soul_drum_mon`
--

DROP TABLE IF EXISTS `base_star_soul_drum_mon`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_star_soul_drum_mon` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '序号',
  `zone` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战区',
  `act` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '轮次',
  `min_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级下限',
  `max_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级上限',
  `stage` varchar(50) NOT NULL DEFAULT '{0,0}' COMMENT '假星灵阶数{stage, star}',
  `star_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT '假星灵id',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_star_soul_drum_mon`
--

LOCK TABLES `base_star_soul_drum_mon` WRITE;
/*!40000 ALTER TABLE `base_star_soul_drum_mon` DISABLE KEYS */;
INSERT INTO `base_star_soul_drum_mon` VALUES (1,1,1,420,1000,'{8,0}','[1003,1005,1006]'),(2,1,2,420,1000,'{8,2}','[1002,1005,1007]'),(3,1,3,420,1000,'{9,1}','[1003,1004,1006]'),(4,1,4,420,1000,'{9,3}','[1003,1004,1007]'),(5,1,5,420,1000,'{10,1}','[1003,1004,1006]'),(6,1,6,420,1000,'{10,3}','[1002,1004,1007]'),(7,1,7,420,1000,'{11,1}','[1003,1004,1007]'),(8,1,8,420,1000,'{11,3}','[1002,1005,1007]'),(9,2,1,701,800,'{10,1}','[1002,1005,1007]'),(10,2,2,701,800,'{11,1}','[1003,1005,1007]'),(11,2,3,701,800,'{12,2}','[1002,1004,1007]'),(12,2,4,701,800,'{13,3}','[1002,1004,1007]'),(13,2,5,701,800,'{14,2}','[1003,1004,1007]'),(14,2,6,701,800,'{15,1}','[1002,1004,1006]'),(15,2,7,701,800,'{15,3}','[1002,1005,1006]'),(16,2,8,701,800,'{16,1}','[1003,1005,1006]'),(17,3,1,801,900,'{17,0}','[1002,1004,1007]'),(18,3,2,801,900,'{17,3}','[1003,1004,1007]'),(19,3,3,801,900,'{18,2}','[1003,1005,1007]'),(20,3,4,801,900,'{19,1}','[1002,1005,1006]'),(21,3,5,801,900,'{19,3}','[1002,1004,1006]'),(22,3,6,801,900,'{20,1}','[1003,1004,1006]'),(23,3,7,801,900,'{20,3}','[1002,1005,1006]'),(24,3,8,801,900,'{21,1}','[1003,1005,1007]'),(25,4,1,901,1000,'{21,3}','[1003,1004,1007]'),(26,4,2,901,1000,'{22,2}','[1003,1005,1006]'),(27,4,3,901,1000,'{23,1}','[1003,1005,1006]'),(28,4,4,901,1000,'{24,0}','[1003,1004,1007]'),(29,4,5,901,1000,'{24,3}','[1002,1004,1006]'),(30,4,6,901,1000,'{25,2}','[1003,1004,1006]'),(31,4,7,901,1000,'{26,0}','[1003,1004,1006]'),(32,4,8,901,1000,'{26,2}','[1003,1004,1006]');
/*!40000 ALTER TABLE `base_star_soul_drum_mon` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_star_soul_drum_rank_reward`
--

DROP TABLE IF EXISTS `base_star_soul_drum_rank_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_star_soul_drum_rank_reward` (
  `zid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战区id',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排行',
  `lv_min` int(11) NOT NULL DEFAULT '0' COMMENT '等级下限',
  `lv_max` int(11) NOT NULL DEFAULT '0' COMMENT '等级上限',
  `reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`zid`,`rank`,`lv_min`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星灵排行奖励';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_star_soul_drum_rank_reward`
--

LOCK TABLES `base_star_soul_drum_rank_reward` WRITE;
/*!40000 ALTER TABLE `base_star_soul_drum_rank_reward` DISABLE KEYS */;
INSERT INTO `base_star_soul_drum_rank_reward` VALUES (1,1,420,540,'[{0,32110011,1}]'),(1,1,541,620,'[{0,32110012,1}]'),(1,1,621,710,'[{0,32110013,1}]'),(1,1,711,1000,'[{0,32110014,1}]'),(1,2,420,540,'[{0,32110021,1}]'),(1,2,541,620,'[{0,32110022,1}]'),(1,2,621,710,'[{0,32110023,1}]'),(1,2,711,1000,'[{0,32110024,1}]'),(1,3,420,540,'[{0,32110031,1}]'),(1,3,541,620,'[{0,32110032,1}]'),(1,3,621,710,'[{0,32110033,1}]'),(1,3,711,1000,'[{0,32110034,1}]'),(1,4,420,540,'[{0,32110031,1}]'),(1,4,541,620,'[{0,32110032,1}]'),(1,4,621,710,'[{0,32110033,1}]'),(1,4,711,1000,'[{0,32110034,1}]'),(1,5,420,540,'[{0,32110041,1}]'),(1,5,541,620,'[{0,32110042,1}]'),(1,5,621,710,'[{0,32110043,1}]'),(1,5,711,1000,'[{0,32110044,1}]'),(1,6,420,540,'[{0,32110041,1}]'),(1,6,541,620,'[{0,32110042,1}]'),(1,6,621,710,'[{0,32110043,1}]'),(1,6,711,1000,'[{0,32110044,1}]'),(1,7,420,540,'[{0,32110041,1}]'),(1,7,541,620,'[{0,32110042,1}]'),(1,7,621,710,'[{0,32110043,1}]'),(1,7,711,1000,'[{0,32110044,1}]'),(1,8,420,540,'[{0,32110041,1}]'),(1,8,541,620,'[{0,32110042,1}]'),(1,8,621,710,'[{0,32110043,1}]'),(1,8,711,1000,'[{0,32110044,1}]'),(1,9,420,540,'[{0,32110051,1}]'),(1,9,541,620,'[{0,32110052,1}]'),(1,9,621,710,'[{0,32110053,1}]'),(1,9,711,1000,'[{0,32110054,1}]'),(1,10,420,540,'[{0,32110051,1}]'),(1,10,541,620,'[{0,32110052,1}]'),(1,10,621,710,'[{0,32110053,1}]'),(1,10,711,1000,'[{0,32110054,1}]'),(1,11,420,540,'[{0,32110051,1}]'),(1,11,541,620,'[{0,32110052,1}]'),(1,11,621,710,'[{0,32110053,1}]'),(1,11,711,1000,'[{0,32110054,1}]'),(1,12,420,540,'[{0,32110051,1}]'),(1,12,541,620,'[{0,32110052,1}]'),(1,12,621,710,'[{0,32110053,1}]'),(1,12,711,1000,'[{0,32110054,1}]'),(1,13,420,540,'[{0,32110051,1}]'),(1,13,541,620,'[{0,32110052,1}]'),(1,13,621,710,'[{0,32110053,1}]'),(1,13,711,1000,'[{0,32110054,1}]'),(1,14,420,540,'[{0,32110051,1}]'),(1,14,541,620,'[{0,32110052,1}]'),(1,14,621,710,'[{0,32110053,1}]'),(1,14,711,1000,'[{0,32110054,1}]'),(1,15,420,540,'[{0,32110051,1}]'),(1,15,541,620,'[{0,32110052,1}]'),(1,15,621,710,'[{0,32110053,1}]'),(1,15,711,1000,'[{0,32110054,1}]'),(1,16,420,540,'[{0,32110051,1}]'),(1,16,541,620,'[{0,32110052,1}]'),(1,16,621,710,'[{0,32110053,1}]'),(1,16,711,1000,'[{0,32110054,1}]');
/*!40000 ALTER TABLE `base_star_soul_drum_rank_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_star_soul_drum_reward`
--

DROP TABLE IF EXISTS `base_star_soul_drum_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_star_soul_drum_reward` (
  `zid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战区',
  `act` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '轮次',
  `lv_min` int(11) NOT NULL DEFAULT '0' COMMENT '等级下限',
  `lv_max` int(11) NOT NULL DEFAULT '0' COMMENT '等级上限',
  `win_reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '胜奖励',
  `lose_reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '败奖励',
  PRIMARY KEY (`zid`,`act`,`lv_min`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星灵战场奖励';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_star_soul_drum_reward`
--

LOCK TABLES `base_star_soul_drum_reward` WRITE;
/*!40000 ALTER TABLE `base_star_soul_drum_reward` DISABLE KEYS */;
INSERT INTO `base_star_soul_drum_reward` VALUES (1,1,420,540,'[{0,32110101,4},{0,32110201,2}]','[{0,32110101,2},{0,32110201,1}]'),(1,1,541,620,'[{0,32110102,4},{0,32110202,2}]','[{0,32110102,2},{0,32110202,1}]'),(1,1,621,710,'[{0,32110103,4},{0,32110203,2}]','[{0,32110103,2},{0,32110203,1}]'),(1,1,711,1000,'[{0,32110104,4},{0,32110204,2}]','[{0,32110104,2},{0,32110204,1}]'),(1,2,420,540,'[{0,32110101,4},{0,32110201,2}]','[{0,32110101,2},{0,32110201,1}]'),(1,2,541,620,'[{0,32110102,4},{0,32110202,2}]','[{0,32110102,2},{0,32110202,1}]'),(1,2,621,710,'[{0,32110103,4},{0,32110203,2}]','[{0,32110103,2},{0,32110203,1}]'),(1,2,711,1000,'[{0,32110104,4},{0,32110204,2}]','[{0,32110104,2},{0,32110204,1}]'),(1,3,420,540,'[{0,32110101,4},{0,32110201,2}]','[{0,32110101,2},{0,32110201,1}]'),(1,3,541,620,'[{0,32110102,4},{0,32110202,2}]','[{0,32110102,2},{0,32110202,1}]'),(1,3,621,710,'[{0,32110103,4},{0,32110203,2}]','[{0,32110103,2},{0,32110203,1}]'),(1,3,711,1000,'[{0,32110104,4},{0,32110204,2}]','[{0,32110104,2},{0,32110204,1}]'),(1,4,420,540,'[{0,32110101,4},{0,32110201,2},{0,18190001,4}]','[{0,32110101,2},{0,32110201,1},{0,18190001,2}]'),(1,4,541,620,'[{0,32110102,4},{0,32110202,2},{0,18190002,4}]','[{0,32110102,2},{0,32110202,1},{0,18190002,2}]'),(1,4,621,710,'[{0,32110103,4},{0,32110203,2},{0,18190003,4}]','[{0,32110103,2},{0,32110203,1},{0,18190003,2}]'),(1,4,711,1000,'[{0,32110104,4},{0,32110204,2},{0,18190004,4}]','[{0,32110104,2},{0,32110204,1},{0,18190004,2}]'),(1,5,420,540,'[{0,32110101,6},{0,32110201,2}]','[{0,32110101,3},{0,32110201,1}]'),(1,5,541,620,'[{0,32110102,6},{0,32110202,2}]','[{0,32110102,3},{0,32110202,1}]'),(1,5,621,710,'[{0,32110103,6},{0,32110203,2}]','[{0,32110103,3},{0,32110203,1}]'),(1,5,711,1000,'[{0,32110104,6},{0,32110204,2}]','[{0,32110104,3},{0,32110204,1}]'),(1,6,420,540,'[{0,32110101,6},{0,32110201,2}]','[{0,32110101,3},{0,32110201,1}]'),(1,6,541,620,'[{0,32110102,6},{0,32110202,2}]','[{0,32110102,3},{0,32110202,1}]'),(1,6,621,710,'[{0,32110103,6},{0,32110203,2}]','[{0,32110103,3},{0,32110203,1}]'),(1,6,711,1000,'[{0,32110104,6},{0,32110204,2}]','[{0,32110104,3},{0,32110204,1}]'),(1,7,420,540,'[{0,32110101,6},{0,32110201,2}]','[{0,32110101,3},{0,32110201,1}]'),(1,7,541,620,'[{0,32110102,6},{0,32110202,2}]','[{0,32110102,3},{0,32110202,1}]'),(1,7,621,710,'[{0,32110103,6},{0,32110203,2}]','[{0,32110103,3},{0,32110203,1}]'),(1,7,711,1000,'[{0,32110104,6},{0,32110204,2}]','[{0,32110104,3},{0,32110204,1}]'),(1,8,420,540,'[{0,32110101,6},{0,32110201,2},{0,18190001,4}]','[{0,32110101,3},{0,32110201,1},{0,18190001,2}]'),(1,8,541,620,'[{0,32110102,6},{0,32110202,2},{0,18190002,4}]','[{0,32110102,3},{0,32110202,1},{0,18190002,2}]'),(1,8,621,710,'[{0,32110103,6},{0,32110203,2},{0,18190003,4}]','[{0,32110103,3},{0,32110203,1},{0,18190003,2}]'),(1,8,711,1000,'[{0,32110104,6},{0,32110204,2},{0,18190004,4}]','[{0,32110104,3},{0,32110204,1},{0,18190004,2}]'),(1,9,420,540,'[{0,32110101,8},{0,32110201,2}]','[{0,32110101,4},{0,32110201,1}]'),(1,9,541,620,'[{0,32110102,8},{0,32110202,2}]','[{0,32110102,4},{0,32110202,1}]'),(1,9,621,710,'[{0,32110103,8},{0,32110203,2}]','[{0,32110103,4},{0,32110203,1}]'),(1,9,711,1000,'[{0,32110104,8},{0,32110204,2}]','[{0,32110104,4},{0,32110204,1}]'),(1,10,420,540,'[{0,32110101,8},{0,32110201,2}]','[{0,32110101,4},{0,32110201,1}]'),(1,10,541,620,'[{0,32110102,8},{0,32110202,2}]','[{0,32110102,4},{0,32110202,1}]'),(1,10,621,710,'[{0,32110103,8},{0,32110203,2}]','[{0,32110103,4},{0,32110203,1}]'),(1,10,711,1000,'[{0,32110104,8},{0,32110204,2}]','[{0,32110104,4},{0,32110204,1}]'),(1,11,420,540,'[{0,32110101,8},{0,32110201,2}]','[{0,32110101,4},{0,32110201,1}]'),(1,11,541,620,'[{0,32110102,8},{0,32110202,2}]','[{0,32110102,4},{0,32110202,1}]'),(1,11,621,710,'[{0,32110103,8},{0,32110203,2}]','[{0,32110103,4},{0,32110203,1}]'),(1,11,711,1000,'[{0,32110104,8},{0,32110204,2}]','[{0,32110104,4},{0,32110204,1}]'),(1,12,420,540,'[{0,32110101,8},{0,32110201,2},{0,18190001,4}]','[{0,32110101,4},{0,32110201,1},{0,18190001,2}]'),(1,12,541,620,'[{0,32110102,8},{0,32110202,2},{0,18190002,4}]','[{0,32110102,4},{0,32110202,1},{0,18190002,2}]'),(1,12,621,710,'[{0,32110103,8},{0,32110203,2},{0,18190003,4}]','[{0,32110103,4},{0,32110203,1},{0,18190003,2}]'),(1,12,711,1000,'[{0,32110104,8},{0,32110204,2},{0,18190004,4}]','[{0,32110104,4},{0,32110204,1},{0,18190004,2}]');
/*!40000 ALTER TABLE `base_star_soul_drum_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_star_soul_equip`
--

DROP TABLE IF EXISTS `base_star_soul_equip`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_star_soul_equip` (
  `goods_type_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型id',
  `pos` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '装备部位',
  `rare` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '稀有度',
  `star` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '装备星级',
  `base_rating` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '基础装备评分(预览展示用)',
  `recommend_attr` varchar(512) NOT NULL DEFAULT '[]' COMMENT '推荐属性(预览属性用)',
  `blue_attr` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '蓝属',
  `blue_num` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '蓝属数量',
  `purple_attr` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '紫属',
  `purple_num` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '紫属数量',
  `yellow_attr` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '橙属',
  `yellow_num` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '橙属数量',
  `red_attr` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '红属',
  `red_num` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '红属数量',
  `best_attr` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '极品属性',
  `stren_lv_upper_limit` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '强化上限',
  `star_soul_power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分解获得的星魂之力数量',
  PRIMARY KEY (`goods_type_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星灵装备';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_star_soul_equip`
--

LOCK TABLES `base_star_soul_equip` WRITE;
/*!40000 ALTER TABLE `base_star_soul_equip` DISABLE KEYS */;
INSERT INTO `base_star_soul_equip` VALUES (18071001,1,0,0,10000,'[{100,{1,1,50}},{100,{1,5,20}}]','[{100,{1,1,50}},{100,{1,3,40}},{100,{1,5,20}},{100,{1,7,20}}]',2,'[]',0,'[]',0,'[]',0,'[]',10,40),(18071002,1,0,1,15000,'[{100,{1,1,75}},{100,{1,5,30}}]','[{100,{1,1,75}},{100,{1,3,60}},{100,{1,5,30}},{100,{1,7,30}}]',2,'[]',0,'[]',0,'[]',0,'[]',20,50),(18071003,1,0,2,20000,'[{100,{1,1,100}},{100,{1,5,40}}]','[{100,{1,1,100}},{100,{1,3,80}},{100,{1,5,40}},{100,{1,7,40}}]',2,'[]',0,'[]',0,'[]',0,'[]',30,60),(18071004,1,0,0,25000,'[{100,{2,1,125}},{100,{2,5,50}}]','[]',0,'[{100,{2,1,125}},{100,{2,3,100}},{100,{2,5,50}},{100,{2,7,50}}]',2,'[]',0,'[]',0,'[]',45,80),(18071005,1,0,1,30000,'[{100,{2,1,150}},{100,{2,5,60}}]','[]',0,'[{100,{2,1,150}},{100,{2,3,120}},{100,{2,5,60}},{100,{2,7,60}}]',2,'[]',0,'[]',0,'[]',60,100),(18071006,1,0,2,35000,'[{100,{2,1,175}},{100,{2,5,70}}]','[]',0,'[{100,{2,1,175}},{100,{2,3,140}},{100,{2,5,70}},{100,{2,7,70}}]',2,'[]',0,'[]',0,'[]',75,120),(18071007,1,0,0,40000,'[{100,{2,1,200}},{100,{3,5,96}}]','[]',0,'[{100,{2,1,200}},{100,{2,3,160}}]',1,'[{100,{3,5,96}},{100,{3,7,96}}]',1,'[]',0,'[]',90,150),(18071008,1,0,1,45000,'[{100,{2,1,225}},{100,{3,5,108}}]','[]',0,'[{100,{2,1,225}},{100,{2,3,180}}]',1,'[{100,{3,5,108}},{100,{3,7,108}}]',1,'[]',0,'[]',105,180),(18071009,1,0,2,50000,'[{100,{2,1,250}},{100,{3,5,120}}]','[]',0,'[{100,{2,1,250}},{100,{2,3,200}}]',1,'[{100,{3,5,120}},{100,{3,7,120}}]',1,'[]',0,'[]',120,210),(18071010,1,0,3,55000,'[{100,{2,1,275}},{100,{3,5,132}}]','[]',0,'[{100,{2,1,275}},{100,{2,3,220}}]',1,'[{100,{3,5,132}},{100,{3,7,132}}]',1,'[]',0,'[]',135,240),(18071011,1,0,0,60000,'[{100,{3,1,360}},{100,{3,5,144}}]','[]',0,'[]',0,'[{100,{3,1,360}},{100,{3,3,288}},{100,{3,5,144}},{100,{3,7,144}}]',2,'[]',0,'[]',150,300),(18071101,1,1,0,32000,'[{100,{1,1,160}},{100,{1,5,64}}]','[{100,{1,1,160}},{100,{1,3,128}},{100,{1,5,64}},{100,{1,7,64}}]',2,'[]',0,'[]',0,'[]',0,'[{15,160}]',10,100),(18071102,1,1,1,40000,'[{100,{1,1,200}},{100,{1,5,80}}]','[{100,{1,1,200}},{100,{1,3,160}},{100,{1,5,80}},{100,{1,7,80}}]',2,'[]',0,'[]',0,'[]',0,'[{15,160}]',20,125),(18071103,1,1,2,48000,'[{100,{1,1,240}},{100,{1,5,96}}]','[{100,{1,1,240}},{100,{1,3,192}},{100,{1,5,96}},{100,{1,7,96}}]',2,'[]',0,'[]',0,'[]',0,'[{15,160}]',30,150),(18071104,1,1,0,56000,'[{100,{2,1,280}},{100,{2,5,112}}]','[]',0,'[{100,{2,1,280}},{100,{2,3,224}},{100,{2,5,112}},{100,{2,7,112}}]',2,'[]',0,'[]',0,'[{15,280}]',45,200),(18071105,1,1,1,64000,'[{100,{2,1,320}},{100,{2,5,128}}]','[]',0,'[{100,{2,1,320}},{100,{2,3,256}},{100,{2,5,128}},{100,{2,7,128}}]',2,'[]',0,'[]',0,'[{15,280}]',60,250),(18071106,1,1,2,72000,'[{100,{2,1,360}},{100,{2,5,144}}]','[]',0,'[{100,{2,1,360}},{100,{2,3,288}},{100,{2,5,144}},{100,{2,7,144}}]',2,'[]',0,'[]',0,'[{15,280}]',75,300),(18071107,1,1,0,80000,'[{100,{2,1,400}},{100,{3,5,192}}]','[]',0,'[{100,{2,1,400}},{100,{2,3,320}}]',1,'[{100,{3,5,192}},{100,{3,7,192}}]',1,'[]',0,'[{15,400}]',90,375),(18071108,1,1,1,88000,'[{100,{2,1,440}},{100,{3,5,211}}]','[]',0,'[{100,{2,1,440}},{100,{2,3,352}}]',1,'[{100,{3,5,211}},{100,{3,7,211}}]',1,'[]',0,'[{15,400}]',105,450),(18071109,1,1,2,96000,'[{100,{2,1,480}},{100,{3,5,230}}]','[]',0,'[{100,{2,1,480}},{100,{2,3,384}}]',1,'[{100,{3,5,230}},{100,{3,7,230}}]',1,'[]',0,'[{15,400}]',120,525),(18071110,1,1,3,104000,'[{100,{2,1,520}},{100,{3,5,250}}]','[]',0,'[{100,{2,1,520}},{100,{2,3,416}}]',1,'[{100,{3,5,250}},{100,{3,7,250}}]',1,'[]',0,'[{15,400}]',135,600),(18071111,1,1,0,112000,'[{100,{3,1,672}},{100,{3,5,269}}]','[]',0,'[]',0,'[{100,{3,1,672}},{100,{3,3,538}},{100,{3,5,269}},{100,{3,7,269}}]',2,'[]',0,'[{15,560}]',150,750),(18071201,1,2,0,66000,'[{100,{1,1,330}},{100,{1,5,132}}]','[{100,{1,1,330}},{100,{1,3,264}},{100,{1,5,132}},{100,{1,7,132}}]',2,'[]',0,'[]',0,'[]',0,'[{15,330},{50,50}]',10,160),(18071202,1,2,1,76000,'[{100,{1,1,380}},{100,{1,5,152}}]','[{100,{1,1,380}},{100,{1,3,304}},{100,{1,5,152}},{100,{1,7,152}}]',2,'[]',0,'[]',0,'[]',0,'[{15,330},{50,50}]',20,200),(18071203,1,2,2,86000,'[{100,{1,1,430}},{100,{1,5,172}}]','[{100,{1,1,430}},{100,{1,3,344}},{100,{1,5,172}},{100,{1,7,172}}]',2,'[]',0,'[]',0,'[]',0,'[{15,330},{50,50}]',30,240),(18071204,1,2,0,96000,'[{100,{2,1,480}},{100,{2,5,192}}]','[]',0,'[{100,{2,1,480}},{100,{2,3,384}},{100,{2,5,192}},{100,{2,7,192}}]',2,'[]',0,'[]',0,'[{15,480},{50,100}]',45,320),(18071205,1,2,1,106000,'[{100,{2,1,530}},{100,{2,5,212}}]','[]',0,'[{100,{2,1,530}},{100,{2,3,424}},{100,{2,5,212}},{100,{2,7,212}}]',2,'[]',0,'[]',0,'[{15,480},{50,100}]',60,400),(18071206,1,2,2,116000,'[{100,{2,1,580}},{100,{2,5,232}}]','[]',0,'[{100,{2,1,580}},{100,{2,3,464}},{100,{2,5,232}},{100,{2,7,232}}]',2,'[]',0,'[]',0,'[{15,480},{50,100}]',75,480),(18071207,1,2,0,126000,'[{100,{2,1,630}},{100,{3,5,302}}]','[]',0,'[{100,{2,1,630}},{100,{2,3,504}}]',1,'[{100,{3,5,302}},{100,{3,7,302}}]',1,'[]',0,'[{15,630},{50,150}]',90,600),(18071208,1,2,1,136000,'[{100,{2,1,680}},{100,{3,5,326}}]','[]',0,'[{100,{2,1,680}},{100,{2,3,544}}]',1,'[{100,{3,5,326}},{100,{3,7,326}}]',1,'[]',0,'[{15,630},{50,150}]',105,720),(18071209,1,2,2,146000,'[{100,{2,1,730}},{100,{3,5,350}}]','[]',0,'[{100,{2,1,730}},{100,{2,3,584}}]',1,'[{100,{3,5,350}},{100,{3,7,350}}]',1,'[]',0,'[{15,630},{50,150}]',120,840),(18071210,1,2,3,156000,'[{100,{2,1,780}},{100,{3,5,374}}]','[]',0,'[{100,{2,1,780}},{100,{2,3,624}}]',1,'[{100,{3,5,374}},{100,{3,7,374}}]',1,'[]',0,'[{15,630},{50,150}]',135,960),(18071211,1,2,0,166000,'[{100,{3,1,996}},{100,{3,5,398}}]','[]',0,'[]',0,'[{100,{3,1,996}},{100,{3,3,797}},{100,{3,5,398}},{100,{3,7,398}}]',2,'[]',0,'[{15,830},{50,200}]',150,1200),(18071301,1,3,0,116000,'[{100,{1,1,580}},{100,{1,5,232}}]','[{100,{1,1,580}},{100,{1,3,464}},{100,{1,5,232}},{100,{1,7,232}}]',2,'[]',0,'[]',0,'[]',0,'[{15,580},{50,100},{27,80}]',10,240),(18071302,1,3,1,128000,'[{100,{1,1,640}},{100,{1,5,256}}]','[{100,{1,1,640}},{100,{1,3,512}},{100,{1,5,256}},{100,{1,7,256}}]',2,'[]',0,'[]',0,'[]',0,'[{15,580},{50,100},{27,80}]',20,300),(18071303,1,3,2,140000,'[{100,{1,1,700}},{100,{1,5,280}}]','[{100,{1,1,700}},{100,{1,3,560}},{100,{1,5,280}},{100,{1,7,280}}]',2,'[]',0,'[]',0,'[]',0,'[{15,580},{50,100},{27,80}]',30,360),(18071304,1,3,0,152000,'[{100,{2,1,760}},{100,{2,5,304}}]','[]',0,'[{100,{2,1,760}},{100,{2,3,608}},{100,{2,5,304}},{100,{2,7,304}}]',2,'[]',0,'[]',0,'[{15,760},{50,200},{27,160}]',45,480),(18071305,1,3,1,164000,'[{100,{2,1,820}},{100,{2,5,328}}]','[]',0,'[{100,{2,1,820}},{100,{2,3,656}},{100,{2,5,328}},{100,{2,7,328}}]',2,'[]',0,'[]',0,'[{15,760},{50,200},{27,160}]',60,600),(18071306,1,3,2,176000,'[{100,{2,1,880}},{100,{2,5,352}}]','[]',0,'[{100,{2,1,880}},{100,{2,3,704}},{100,{2,5,352}},{100,{2,7,352}}]',2,'[]',0,'[]',0,'[{15,760},{50,200},{27,160}]',75,720),(18071307,1,3,0,188000,'[{100,{2,1,940}},{100,{3,5,451}}]','[]',0,'[{100,{2,1,940}},{100,{2,3,752}}]',1,'[{100,{3,5,451}},{100,{3,7,451}}]',1,'[]',0,'[{15,940},{50,300},{27,250}]',90,900),(18071308,1,3,1,200000,'[{100,{2,1,1000}},{100,{3,5,480}}]','[]',0,'[{100,{2,1,1000}},{100,{2,3,800}}]',1,'[{100,{3,5,480}},{100,{3,7,480}}]',1,'[]',0,'[{15,940},{50,300},{27,250}]',105,1080),(18071309,1,3,2,212000,'[{100,{2,1,1060}},{100,{3,5,509}}]','[]',0,'[{100,{2,1,1060}},{100,{2,3,848}}]',1,'[{100,{3,5,509}},{100,{3,7,509}}]',1,'[]',0,'[{15,940},{50,300},{27,250}]',120,1260),(18071310,1,3,3,224000,'[{100,{2,1,1120}},{100,{3,5,538}}]','[]',0,'[{100,{2,1,1120}},{100,{2,3,896}}]',1,'[{100,{3,5,538}},{100,{3,7,538}}]',1,'[]',0,'[{15,940},{50,300},{27,250}]',135,1440),(18071311,1,3,0,236000,'[{100,{3,1,1416}},{100,{3,5,566}}]','[]',0,'[]',0,'[{100,{3,1,1416}},{100,{3,3,1133}},{100,{3,5,566}},{100,{3,7,566}}]',2,'[]',0,'[{15,1180},{50,400},{27,350}]',150,1800),(18072001,2,0,0,10000,'[{100,{1,1,50}},{100,{1,5,20}}]','[{100,{1,1,50}},{100,{1,3,40}},{100,{1,5,20}},{100,{1,7,20}}]',2,'[]',0,'[]',0,'[]',0,'[]',10,40),(18072002,2,0,1,15000,'[{100,{1,1,75}},{100,{1,5,30}}]','[{100,{1,1,75}},{100,{1,3,60}},{100,{1,5,30}},{100,{1,7,30}}]',2,'[]',0,'[]',0,'[]',0,'[]',20,50),(18072003,2,0,2,20000,'[{100,{1,1,100}},{100,{1,5,40}}]','[{100,{1,1,100}},{100,{1,3,80}},{100,{1,5,40}},{100,{1,7,40}}]',2,'[]',0,'[]',0,'[]',0,'[]',30,60),(18072004,2,0,0,25000,'[{100,{2,1,125}},{100,{2,5,50}}]','[]',0,'[{100,{2,1,125}},{100,{2,3,100}},{100,{2,5,50}},{100,{2,7,50}}]',2,'[]',0,'[]',0,'[]',45,80),(18072005,2,0,1,30000,'[{100,{2,1,150}},{100,{2,5,60}}]','[]',0,'[{100,{2,1,150}},{100,{2,3,120}},{100,{2,5,60}},{100,{2,7,60}}]',2,'[]',0,'[]',0,'[]',60,100),(18072006,2,0,2,35000,'[{100,{2,1,175}},{100,{2,5,70}}]','[]',0,'[{100,{2,1,175}},{100,{2,3,140}},{100,{2,5,70}},{100,{2,7,70}}]',2,'[]',0,'[]',0,'[]',75,120),(18072007,2,0,0,40000,'[{100,{2,1,200}},{100,{3,5,96}}]','[]',0,'[{100,{2,1,200}},{100,{2,3,160}}]',1,'[{100,{3,5,96}},{100,{3,7,96}}]',1,'[]',0,'[]',90,150),(18072008,2,0,1,45000,'[{100,{2,1,225}},{100,{3,5,108}}]','[]',0,'[{100,{2,1,225}},{100,{2,3,180}}]',1,'[{100,{3,5,108}},{100,{3,7,108}}]',1,'[]',0,'[]',105,180),(18072009,2,0,2,50000,'[{100,{2,1,250}},{100,{3,5,120}}]','[]',0,'[{100,{2,1,250}},{100,{2,3,200}}]',1,'[{100,{3,5,120}},{100,{3,7,120}}]',1,'[]',0,'[]',120,210),(18072010,2,0,3,55000,'[{100,{2,1,275}},{100,{3,5,132}}]','[]',0,'[{100,{2,1,275}},{100,{2,3,220}}]',1,'[{100,{3,5,132}},{100,{3,7,132}}]',1,'[]',0,'[]',135,240),(18072011,2,0,0,60000,'[{100,{3,1,360}},{100,{3,5,144}}]','[]',0,'[]',0,'[{100,{3,1,360}},{100,{3,3,288}},{100,{3,5,144}},{100,{3,7,144}}]',2,'[]',0,'[]',150,300),(18072101,2,1,0,32000,'[{100,{1,1,160}},{100,{1,5,64}}]','[{100,{1,1,160}},{100,{1,3,128}},{100,{1,5,64}},{100,{1,7,64}}]',2,'[]',0,'[]',0,'[]',0,'[{16,160}]',10,100),(18072102,2,1,1,40000,'[{100,{1,1,200}},{100,{1,5,80}}]','[{100,{1,1,200}},{100,{1,3,160}},{100,{1,5,80}},{100,{1,7,80}}]',2,'[]',0,'[]',0,'[]',0,'[{16,160}]',20,125),(18072103,2,1,2,48000,'[{100,{1,1,240}},{100,{1,5,96}}]','[{100,{1,1,240}},{100,{1,3,192}},{100,{1,5,96}},{100,{1,7,96}}]',2,'[]',0,'[]',0,'[]',0,'[{16,160}]',30,150),(18072104,2,1,0,56000,'[{100,{2,1,280}},{100,{2,5,112}}]','[]',0,'[{100,{2,1,280}},{100,{2,3,224}},{100,{2,5,112}},{100,{2,7,112}}]',2,'[]',0,'[]',0,'[{16,280}]',45,200),(18072105,2,1,1,64000,'[{100,{2,1,320}},{100,{2,5,128}}]','[]',0,'[{100,{2,1,320}},{100,{2,3,256}},{100,{2,5,128}},{100,{2,7,128}}]',2,'[]',0,'[]',0,'[{16,280}]',60,250),(18072106,2,1,2,72000,'[{100,{2,1,360}},{100,{2,5,144}}]','[]',0,'[{100,{2,1,360}},{100,{2,3,288}},{100,{2,5,144}},{100,{2,7,144}}]',2,'[]',0,'[]',0,'[{16,280}]',75,300),(18072107,2,1,0,80000,'[{100,{2,1,400}},{100,{3,5,192}}]','[]',0,'[{100,{2,1,400}},{100,{2,3,320}}]',1,'[{100,{3,5,192}},{100,{3,7,192}}]',1,'[]',0,'[{16,400}]',90,375),(18072108,2,1,1,88000,'[{100,{2,1,440}},{100,{3,5,211}}]','[]',0,'[{100,{2,1,440}},{100,{2,3,352}}]',1,'[{100,{3,5,211}},{100,{3,7,211}}]',1,'[]',0,'[{16,400}]',105,450),(18072109,2,1,2,96000,'[{100,{2,1,480}},{100,{3,5,230}}]','[]',0,'[{100,{2,1,480}},{100,{2,3,384}}]',1,'[{100,{3,5,230}},{100,{3,7,230}}]',1,'[]',0,'[{16,400}]',120,525),(18072110,2,1,3,104000,'[{100,{2,1,520}},{100,{3,5,250}}]','[]',0,'[{100,{2,1,520}},{100,{2,3,416}}]',1,'[{100,{3,5,250}},{100,{3,7,250}}]',1,'[]',0,'[{16,400}]',135,600),(18072111,2,1,0,112000,'[{100,{3,1,672}},{100,{3,5,269}}]','[]',0,'[]',0,'[{100,{3,1,672}},{100,{3,3,538}},{100,{3,5,269}},{100,{3,7,269}}]',2,'[]',0,'[{16,560}]',150,750),(18072201,2,2,0,66000,'[{100,{1,1,330}},{100,{1,5,132}}]','[{100,{1,1,330}},{100,{1,3,264}},{100,{1,5,132}},{100,{1,7,132}}]',2,'[]',0,'[]',0,'[]',0,'[{16,330},{230,50}]',10,160),(18072202,2,2,1,76000,'[{100,{1,1,380}},{100,{1,5,152}}]','[{100,{1,1,380}},{100,{1,3,304}},{100,{1,5,152}},{100,{1,7,152}}]',2,'[]',0,'[]',0,'[]',0,'[{16,330},{230,50}]',20,200),(18072203,2,2,2,86000,'[{100,{1,1,430}},{100,{1,5,172}}]','[{100,{1,1,430}},{100,{1,3,344}},{100,{1,5,172}},{100,{1,7,172}}]',2,'[]',0,'[]',0,'[]',0,'[{16,330},{230,50}]',30,240),(18072204,2,2,0,96000,'[{100,{2,1,480}},{100,{2,5,192}}]','[]',0,'[{100,{2,1,480}},{100,{2,3,384}},{100,{2,5,192}},{100,{2,7,192}}]',2,'[]',0,'[]',0,'[{16,480},{230,100}]',45,320),(18072205,2,2,1,106000,'[{100,{2,1,530}},{100,{2,5,212}}]','[]',0,'[{100,{2,1,530}},{100,{2,3,424}},{100,{2,5,212}},{100,{2,7,212}}]',2,'[]',0,'[]',0,'[{16,480},{230,100}]',60,400),(18072206,2,2,2,116000,'[{100,{2,1,580}},{100,{2,5,232}}]','[]',0,'[{100,{2,1,580}},{100,{2,3,464}},{100,{2,5,232}},{100,{2,7,232}}]',2,'[]',0,'[]',0,'[{16,480},{230,100}]',75,480),(18072207,2,2,0,126000,'[{100,{2,1,630}},{100,{3,5,302}}]','[]',0,'[{100,{2,1,630}},{100,{2,3,504}}]',1,'[{100,{3,5,302}},{100,{3,7,302}}]',1,'[]',0,'[{16,630},{230,150}]',90,600),(18072208,2,2,1,136000,'[{100,{2,1,680}},{100,{3,5,326}}]','[]',0,'[{100,{2,1,680}},{100,{2,3,544}}]',1,'[{100,{3,5,326}},{100,{3,7,326}}]',1,'[]',0,'[{16,630},{230,150}]',105,720),(18072209,2,2,2,146000,'[{100,{2,1,730}},{100,{3,5,350}}]','[]',0,'[{100,{2,1,730}},{100,{2,3,584}}]',1,'[{100,{3,5,350}},{100,{3,7,350}}]',1,'[]',0,'[{16,630},{230,150}]',120,840),(18072210,2,2,3,156000,'[{100,{2,1,780}},{100,{3,5,374}}]','[]',0,'[{100,{2,1,780}},{100,{2,3,624}}]',1,'[{100,{3,5,374}},{100,{3,7,374}}]',1,'[]',0,'[{16,630},{230,150}]',135,960),(18072211,2,2,0,166000,'[{100,{3,1,996}},{100,{3,5,398}}]','[]',0,'[]',0,'[{100,{3,1,996}},{100,{3,3,797}},{100,{3,5,398}},{100,{3,7,398}}]',2,'[]',0,'[{16,830},{230,200}]',150,1200),(18072301,2,3,0,116000,'[{100,{1,1,580}},{100,{1,5,232}}]','[{100,{1,1,580}},{100,{1,3,464}},{100,{1,5,232}},{100,{1,7,232}}]',2,'[]',0,'[]',0,'[]',0,'[{16,580},{230,100},{28,80}]',10,240),(18072302,2,3,1,128000,'[{100,{1,1,640}},{100,{1,5,256}}]','[{100,{1,1,640}},{100,{1,3,512}},{100,{1,5,256}},{100,{1,7,256}}]',2,'[]',0,'[]',0,'[]',0,'[{16,580},{230,100},{28,80}]',20,300),(18072303,2,3,2,140000,'[{100,{1,1,700}},{100,{1,5,280}}]','[{100,{1,1,700}},{100,{1,3,560}},{100,{1,5,280}},{100,{1,7,280}}]',2,'[]',0,'[]',0,'[]',0,'[{16,580},{230,100},{28,80}]',30,360),(18072304,2,3,0,152000,'[{100,{2,1,760}},{100,{2,5,304}}]','[]',0,'[{100,{2,1,760}},{100,{2,3,608}},{100,{2,5,304}},{100,{2,7,304}}]',2,'[]',0,'[]',0,'[{16,760},{230,200},{28,160}]',45,480),(18072305,2,3,1,164000,'[{100,{2,1,820}},{100,{2,5,328}}]','[]',0,'[{100,{2,1,820}},{100,{2,3,656}},{100,{2,5,328}},{100,{2,7,328}}]',2,'[]',0,'[]',0,'[{16,760},{230,200},{28,160}]',60,600),(18072306,2,3,2,176000,'[{100,{2,1,880}},{100,{2,5,352}}]','[]',0,'[{100,{2,1,880}},{100,{2,3,704}},{100,{2,5,352}},{100,{2,7,352}}]',2,'[]',0,'[]',0,'[{16,760},{230,200},{28,160}]',75,720),(18072307,2,3,0,188000,'[{100,{2,1,940}},{100,{3,5,451}}]','[]',0,'[{100,{2,1,940}},{100,{2,3,752}}]',1,'[{100,{3,5,451}},{100,{3,7,451}}]',1,'[]',0,'[{16,940},{230,300},{28,250}]',90,900),(18072308,2,3,1,200000,'[{100,{2,1,1000}},{100,{3,5,480}}]','[]',0,'[{100,{2,1,1000}},{100,{2,3,800}}]',1,'[{100,{3,5,480}},{100,{3,7,480}}]',1,'[]',0,'[{16,940},{230,300},{28,250}]',105,1080),(18072309,2,3,2,212000,'[{100,{2,1,1060}},{100,{3,5,509}}]','[]',0,'[{100,{2,1,1060}},{100,{2,3,848}}]',1,'[{100,{3,5,509}},{100,{3,7,509}}]',1,'[]',0,'[{16,940},{230,300},{28,250}]',120,1260),(18072310,2,3,3,224000,'[{100,{2,1,1120}},{100,{3,5,538}}]','[]',0,'[{100,{2,1,1120}},{100,{2,3,896}}]',1,'[{100,{3,5,538}},{100,{3,7,538}}]',1,'[]',0,'[{16,940},{230,300},{28,250}]',135,1440),(18072311,2,3,0,236000,'[{100,{3,1,1416}},{100,{3,5,566}}]','[]',0,'[]',0,'[{100,{3,1,1416}},{100,{3,3,1133}},{100,{3,5,566}},{100,{3,7,566}}]',2,'[]',0,'[{16,1180},{230,400},{28,350}]',150,1800),(18073001,3,0,0,10000,'[{100,{1,1,50}},{100,{1,5,20}}]','[{100,{1,1,50}},{100,{1,3,40}},{100,{1,5,20}},{100,{1,7,20}}]',2,'[]',0,'[]',0,'[]',0,'[]',10,40),(18073002,3,0,1,15000,'[{100,{1,1,75}},{100,{1,5,30}}]','[{100,{1,1,75}},{100,{1,3,60}},{100,{1,5,30}},{100,{1,7,30}}]',2,'[]',0,'[]',0,'[]',0,'[]',20,50),(18073003,3,0,2,20000,'[{100,{1,1,100}},{100,{1,5,40}}]','[{100,{1,1,100}},{100,{1,3,80}},{100,{1,5,40}},{100,{1,7,40}}]',2,'[]',0,'[]',0,'[]',0,'[]',30,60),(18073004,3,0,0,25000,'[{100,{2,1,125}},{100,{2,5,50}}]','[]',0,'[{100,{2,1,125}},{100,{2,3,100}},{100,{2,5,50}},{100,{2,7,50}}]',2,'[]',0,'[]',0,'[]',45,80),(18073005,3,0,1,30000,'[{100,{2,1,150}},{100,{2,5,60}}]','[]',0,'[{100,{2,1,150}},{100,{2,3,120}},{100,{2,5,60}},{100,{2,7,60}}]',2,'[]',0,'[]',0,'[]',60,100),(18073006,3,0,2,35000,'[{100,{2,1,175}},{100,{2,5,70}}]','[]',0,'[{100,{2,1,175}},{100,{2,3,140}},{100,{2,5,70}},{100,{2,7,70}}]',2,'[]',0,'[]',0,'[]',75,120),(18073007,3,0,0,40000,'[{100,{2,1,200}},{100,{3,5,96}}]','[]',0,'[{100,{2,1,200}},{100,{2,3,160}}]',1,'[{100,{3,5,96}},{100,{3,7,96}}]',1,'[]',0,'[]',90,150),(18073008,3,0,1,45000,'[{100,{2,1,225}},{100,{3,5,108}}]','[]',0,'[{100,{2,1,225}},{100,{2,3,180}}]',1,'[{100,{3,5,108}},{100,{3,7,108}}]',1,'[]',0,'[]',105,180),(18073009,3,0,2,50000,'[{100,{2,1,250}},{100,{3,5,120}}]','[]',0,'[{100,{2,1,250}},{100,{2,3,200}}]',1,'[{100,{3,5,120}},{100,{3,7,120}}]',1,'[]',0,'[]',120,210),(18073010,3,0,3,55000,'[{100,{2,1,275}},{100,{3,5,132}}]','[]',0,'[{100,{2,1,275}},{100,{2,3,220}}]',1,'[{100,{3,5,132}},{100,{3,7,132}}]',1,'[]',0,'[]',135,240),(18073011,3,0,0,60000,'[{100,{3,1,360}},{100,{3,5,144}}]','[]',0,'[]',0,'[{100,{3,1,360}},{100,{3,3,288}},{100,{3,5,144}},{100,{3,7,144}}]',2,'[]',0,'[]',150,300),(18073101,3,1,0,32000,'[{100,{1,1,160}},{100,{1,5,64}}]','[{100,{1,1,160}},{100,{1,3,128}},{100,{1,5,64}},{100,{1,7,64}}]',2,'[]',0,'[]',0,'[]',0,'[{48,160}]',10,100),(18073102,3,1,1,40000,'[{100,{1,1,200}},{100,{1,5,80}}]','[{100,{1,1,200}},{100,{1,3,160}},{100,{1,5,80}},{100,{1,7,80}}]',2,'[]',0,'[]',0,'[]',0,'[{48,160}]',20,125),(18073103,3,1,2,48000,'[{100,{1,1,240}},{100,{1,5,96}}]','[{100,{1,1,240}},{100,{1,3,192}},{100,{1,5,96}},{100,{1,7,96}}]',2,'[]',0,'[]',0,'[]',0,'[{48,160}]',30,150),(18073104,3,1,0,56000,'[{100,{2,1,280}},{100,{2,5,112}}]','[]',0,'[{100,{2,1,280}},{100,{2,3,224}},{100,{2,5,112}},{100,{2,7,112}}]',2,'[]',0,'[]',0,'[{48,280}]',45,200),(18073105,3,1,1,64000,'[{100,{2,1,320}},{100,{2,5,128}}]','[]',0,'[{100,{2,1,320}},{100,{2,3,256}},{100,{2,5,128}},{100,{2,7,128}}]',2,'[]',0,'[]',0,'[{48,280}]',60,250),(18073106,3,1,2,72000,'[{100,{2,1,360}},{100,{2,5,144}}]','[]',0,'[{100,{2,1,360}},{100,{2,3,288}},{100,{2,5,144}},{100,{2,7,144}}]',2,'[]',0,'[]',0,'[{48,280}]',75,300),(18073107,3,1,0,80000,'[{100,{2,1,400}},{100,{3,5,192}}]','[]',0,'[{100,{2,1,400}},{100,{2,3,320}}]',1,'[{100,{3,5,192}},{100,{3,7,192}}]',1,'[]',0,'[{48,400}]',90,375),(18073108,3,1,1,88000,'[{100,{2,1,440}},{100,{3,5,211}}]','[]',0,'[{100,{2,1,440}},{100,{2,3,352}}]',1,'[{100,{3,5,211}},{100,{3,7,211}}]',1,'[]',0,'[{48,400}]',105,450),(18073109,3,1,2,96000,'[{100,{2,1,480}},{100,{3,5,230}}]','[]',0,'[{100,{2,1,480}},{100,{2,3,384}}]',1,'[{100,{3,5,230}},{100,{3,7,230}}]',1,'[]',0,'[{48,400}]',120,525),(18073110,3,1,3,104000,'[{100,{2,1,520}},{100,{3,5,250}}]','[]',0,'[{100,{2,1,520}},{100,{2,3,416}}]',1,'[{100,{3,5,250}},{100,{3,7,250}}]',1,'[]',0,'[{48,400}]',135,600),(18073111,3,1,0,112000,'[{100,{3,1,672}},{100,{3,5,269}}]','[]',0,'[]',0,'[{100,{3,1,672}},{100,{3,3,538}},{100,{3,5,269}},{100,{3,7,269}}]',2,'[]',0,'[{48,560}]',150,750),(18073201,3,2,0,66000,'[{100,{1,1,330}},{100,{1,5,132}}]','[{100,{1,1,330}},{100,{1,3,264}},{100,{1,5,132}},{100,{1,7,132}}]',2,'[]',0,'[]',0,'[]',0,'[{48,330},{51,50}]',10,160),(18073202,3,2,1,76000,'[{100,{1,1,380}},{100,{1,5,152}}]','[{100,{1,1,380}},{100,{1,3,304}},{100,{1,5,152}},{100,{1,7,152}}]',2,'[]',0,'[]',0,'[]',0,'[{48,330},{51,50}]',20,200),(18073203,3,2,2,86000,'[{100,{1,1,430}},{100,{1,5,172}}]','[{100,{1,1,430}},{100,{1,3,344}},{100,{1,5,172}},{100,{1,7,172}}]',2,'[]',0,'[]',0,'[]',0,'[{48,330},{51,50}]',30,240),(18073204,3,2,0,96000,'[{100,{2,1,480}},{100,{2,5,192}}]','[]',0,'[{100,{2,1,480}},{100,{2,3,384}},{100,{2,5,192}},{100,{2,7,192}}]',2,'[]',0,'[]',0,'[{48,480},{51,100}]',45,320),(18073205,3,2,1,106000,'[{100,{2,1,530}},{100,{2,5,212}}]','[]',0,'[{100,{2,1,530}},{100,{2,3,424}},{100,{2,5,212}},{100,{2,7,212}}]',2,'[]',0,'[]',0,'[{48,480},{51,100}]',60,400),(18073206,3,2,2,116000,'[{100,{2,1,580}},{100,{2,5,232}}]','[]',0,'[{100,{2,1,580}},{100,{2,3,464}},{100,{2,5,232}},{100,{2,7,232}}]',2,'[]',0,'[]',0,'[{48,480},{51,100}]',75,480),(18073207,3,2,0,126000,'[{100,{2,1,630}},{100,{3,5,302}}]','[]',0,'[{100,{2,1,630}},{100,{2,3,504}}]',1,'[{100,{3,5,302}},{100,{3,7,302}}]',1,'[]',0,'[{48,630},{51,150}]',90,600),(18073208,3,2,1,136000,'[{100,{2,1,680}},{100,{3,5,326}}]','[]',0,'[{100,{2,1,680}},{100,{2,3,544}}]',1,'[{100,{3,5,326}},{100,{3,7,326}}]',1,'[]',0,'[{48,630},{51,150}]',105,720),(18073209,3,2,2,146000,'[{100,{2,1,730}},{100,{3,5,350}}]','[]',0,'[{100,{2,1,730}},{100,{2,3,584}}]',1,'[{100,{3,5,350}},{100,{3,7,350}}]',1,'[]',0,'[{48,630},{51,150}]',120,840),(18073210,3,2,3,156000,'[{100,{2,1,780}},{100,{3,5,374}}]','[]',0,'[{100,{2,1,780}},{100,{2,3,624}}]',1,'[{100,{3,5,374}},{100,{3,7,374}}]',1,'[]',0,'[{48,630},{51,150}]',135,960),(18073211,3,2,0,166000,'[{100,{3,1,996}},{100,{3,5,398}}]','[]',0,'[]',0,'[{100,{3,1,996}},{100,{3,3,797}},{100,{3,5,398}},{100,{3,7,398}}]',2,'[]',0,'[{48,830},{51,200}]',150,1200),(18073301,3,3,0,116000,'[{100,{1,1,580}},{100,{1,5,232}}]','[{100,{1,1,580}},{100,{1,3,464}},{100,{1,5,232}},{100,{1,7,232}}]',2,'[]',0,'[]',0,'[]',0,'[{48,580},{51,100},{9,80}]',10,240),(18073302,3,3,1,128000,'[{100,{1,1,640}},{100,{1,5,256}}]','[{100,{1,1,640}},{100,{1,3,512}},{100,{1,5,256}},{100,{1,7,256}}]',2,'[]',0,'[]',0,'[]',0,'[{48,580},{51,100},{9,80}]',20,300),(18073303,3,3,2,140000,'[{100,{1,1,700}},{100,{1,5,280}}]','[{100,{1,1,700}},{100,{1,3,560}},{100,{1,5,280}},{100,{1,7,280}}]',2,'[]',0,'[]',0,'[]',0,'[{48,580},{51,100},{9,80}]',30,360),(18073304,3,3,0,152000,'[{100,{2,1,760}},{100,{2,5,304}}]','[]',0,'[{100,{2,1,760}},{100,{2,3,608}},{100,{2,5,304}},{100,{2,7,304}}]',2,'[]',0,'[]',0,'[{48,760},{51,200},{9,160}]',45,480),(18073305,3,3,1,164000,'[{100,{2,1,820}},{100,{2,5,328}}]','[]',0,'[{100,{2,1,820}},{100,{2,3,656}},{100,{2,5,328}},{100,{2,7,328}}]',2,'[]',0,'[]',0,'[{48,760},{51,200},{9,160}]',60,600),(18073306,3,3,2,176000,'[{100,{2,1,880}},{100,{2,5,352}}]','[]',0,'[{100,{2,1,880}},{100,{2,3,704}},{100,{2,5,352}},{100,{2,7,352}}]',2,'[]',0,'[]',0,'[{48,760},{51,200},{9,160}]',75,720),(18073307,3,3,0,188000,'[{100,{2,1,940}},{100,{3,5,451}}]','[]',0,'[{100,{2,1,940}},{100,{2,3,752}}]',1,'[{100,{3,5,451}},{100,{3,7,451}}]',1,'[]',0,'[{48,940},{51,300},{9,250}]',90,900),(18073308,3,3,1,200000,'[{100,{2,1,1000}},{100,{3,5,480}}]','[]',0,'[{100,{2,1,1000}},{100,{2,3,800}}]',1,'[{100,{3,5,480}},{100,{3,7,480}}]',1,'[]',0,'[{48,940},{51,300},{9,250}]',105,1080),(18073309,3,3,2,212000,'[{100,{2,1,1060}},{100,{3,5,509}}]','[]',0,'[{100,{2,1,1060}},{100,{2,3,848}}]',1,'[{100,{3,5,509}},{100,{3,7,509}}]',1,'[]',0,'[{48,940},{51,300},{9,250}]',120,1260),(18073310,3,3,3,224000,'[{100,{2,1,1120}},{100,{3,5,538}}]','[]',0,'[{100,{2,1,1120}},{100,{2,3,896}}]',1,'[{100,{3,5,538}},{100,{3,7,538}}]',1,'[]',0,'[{48,940},{51,300},{9,250}]',135,1440),(18073311,3,3,0,236000,'[{100,{3,1,1416}},{100,{3,5,566}}]','[]',0,'[]',0,'[{100,{3,1,1416}},{100,{3,3,1133}},{100,{3,5,566}},{100,{3,7,566}}]',2,'[]',0,'[{48,1180},{51,400},{9,350}]',150,1800),(18074001,4,0,0,10000,'[{100,{1,1,50}},{100,{1,5,20}}]','[{100,{1,1,50}},{100,{1,3,40}},{100,{1,5,20}},{100,{1,7,20}}]',2,'[]',0,'[]',0,'[]',0,'[]',10,40),(18074002,4,0,1,15000,'[{100,{1,1,75}},{100,{1,5,30}}]','[{100,{1,1,75}},{100,{1,3,60}},{100,{1,5,30}},{100,{1,7,30}}]',2,'[]',0,'[]',0,'[]',0,'[]',20,50),(18074003,4,0,2,20000,'[{100,{1,1,100}},{100,{1,5,40}}]','[{100,{1,1,100}},{100,{1,3,80}},{100,{1,5,40}},{100,{1,7,40}}]',2,'[]',0,'[]',0,'[]',0,'[]',30,60),(18074004,4,0,0,25000,'[{100,{2,1,125}},{100,{2,5,50}}]','[]',0,'[{100,{2,1,125}},{100,{2,3,100}},{100,{2,5,50}},{100,{2,7,50}}]',2,'[]',0,'[]',0,'[]',45,80),(18074005,4,0,1,30000,'[{100,{2,1,150}},{100,{2,5,60}}]','[]',0,'[{100,{2,1,150}},{100,{2,3,120}},{100,{2,5,60}},{100,{2,7,60}}]',2,'[]',0,'[]',0,'[]',60,100),(18074006,4,0,2,35000,'[{100,{2,1,175}},{100,{2,5,70}}]','[]',0,'[{100,{2,1,175}},{100,{2,3,140}},{100,{2,5,70}},{100,{2,7,70}}]',2,'[]',0,'[]',0,'[]',75,120),(18074007,4,0,0,40000,'[{100,{2,1,200}},{100,{3,5,96}}]','[]',0,'[{100,{2,1,200}},{100,{2,3,160}}]',1,'[{100,{3,5,96}},{100,{3,7,96}}]',1,'[]',0,'[]',90,150),(18074008,4,0,1,45000,'[{100,{2,1,225}},{100,{3,5,108}}]','[]',0,'[{100,{2,1,225}},{100,{2,3,180}}]',1,'[{100,{3,5,108}},{100,{3,7,108}}]',1,'[]',0,'[]',105,180),(18074009,4,0,2,50000,'[{100,{2,1,250}},{100,{3,5,120}}]','[]',0,'[{100,{2,1,250}},{100,{2,3,200}}]',1,'[{100,{3,5,120}},{100,{3,7,120}}]',1,'[]',0,'[]',120,210),(18074010,4,0,3,55000,'[{100,{2,1,275}},{100,{3,5,132}}]','[]',0,'[{100,{2,1,275}},{100,{2,3,220}}]',1,'[{100,{3,5,132}},{100,{3,7,132}}]',1,'[]',0,'[]',135,240),(18074011,4,0,0,60000,'[{100,{3,1,360}},{100,{3,5,144}}]','[]',0,'[]',0,'[{100,{3,1,360}},{100,{3,3,288}},{100,{3,5,144}},{100,{3,7,144}}]',2,'[]',0,'[]',150,300),(18074101,4,1,0,32000,'[{100,{1,1,160}},{100,{1,5,64}}]','[{100,{1,1,160}},{100,{1,3,128}},{100,{1,5,64}},{100,{1,7,64}}]',2,'[]',0,'[]',0,'[]',0,'[{49,160}]',10,100),(18074102,4,1,1,40000,'[{100,{1,1,200}},{100,{1,5,80}}]','[{100,{1,1,200}},{100,{1,3,160}},{100,{1,5,80}},{100,{1,7,80}}]',2,'[]',0,'[]',0,'[]',0,'[{49,160}]',20,125),(18074103,4,1,2,48000,'[{100,{1,1,240}},{100,{1,5,96}}]','[{100,{1,1,240}},{100,{1,3,192}},{100,{1,5,96}},{100,{1,7,96}}]',2,'[]',0,'[]',0,'[]',0,'[{49,160}]',30,150),(18074104,4,1,0,56000,'[{100,{2,1,280}},{100,{2,5,112}}]','[]',0,'[{100,{2,1,280}},{100,{2,3,224}},{100,{2,5,112}},{100,{2,7,112}}]',2,'[]',0,'[]',0,'[{49,280}]',45,200),(18074105,4,1,1,64000,'[{100,{2,1,320}},{100,{2,5,128}}]','[]',0,'[{100,{2,1,320}},{100,{2,3,256}},{100,{2,5,128}},{100,{2,7,128}}]',2,'[]',0,'[]',0,'[{49,280}]',60,250),(18074106,4,1,2,72000,'[{100,{2,1,360}},{100,{2,5,144}}]','[]',0,'[{100,{2,1,360}},{100,{2,3,288}},{100,{2,5,144}},{100,{2,7,144}}]',2,'[]',0,'[]',0,'[{49,280}]',75,300),(18074107,4,1,0,80000,'[{100,{2,1,400}},{100,{3,5,192}}]','[]',0,'[{100,{2,1,400}},{100,{2,3,320}}]',1,'[{100,{3,5,192}},{100,{3,7,192}}]',1,'[]',0,'[{49,400}]',90,375),(18074108,4,1,1,88000,'[{100,{2,1,440}},{100,{3,5,211}}]','[]',0,'[{100,{2,1,440}},{100,{2,3,352}}]',1,'[{100,{3,5,211}},{100,{3,7,211}}]',1,'[]',0,'[{49,400}]',105,450),(18074109,4,1,2,96000,'[{100,{2,1,480}},{100,{3,5,230}}]','[]',0,'[{100,{2,1,480}},{100,{2,3,384}}]',1,'[{100,{3,5,230}},{100,{3,7,230}}]',1,'[]',0,'[{49,400}]',120,525),(18074110,4,1,3,104000,'[{100,{2,1,520}},{100,{3,5,250}}]','[]',0,'[{100,{2,1,520}},{100,{2,3,416}}]',1,'[{100,{3,5,250}},{100,{3,7,250}}]',1,'[]',0,'[{49,400}]',135,600),(18074111,4,1,0,112000,'[{100,{3,1,672}},{100,{3,5,269}}]','[]',0,'[]',0,'[{100,{3,1,672}},{100,{3,3,538}},{100,{3,5,269}},{100,{3,7,269}}]',2,'[]',0,'[{49,560}]',150,750),(18074201,4,2,0,66000,'[{100,{1,1,330}},{100,{1,5,132}}]','[{100,{1,1,330}},{100,{1,3,264}},{100,{1,5,132}},{100,{1,7,132}}]',2,'[]',0,'[]',0,'[]',0,'[{49,330},{231,50}]',10,160),(18074202,4,2,1,76000,'[{100,{1,1,380}},{100,{1,5,152}}]','[{100,{1,1,380}},{100,{1,3,304}},{100,{1,5,152}},{100,{1,7,152}}]',2,'[]',0,'[]',0,'[]',0,'[{49,330},{231,50}]',20,200),(18074203,4,2,2,86000,'[{100,{1,1,430}},{100,{1,5,172}}]','[{100,{1,1,430}},{100,{1,3,344}},{100,{1,5,172}},{100,{1,7,172}}]',2,'[]',0,'[]',0,'[]',0,'[{49,330},{231,50}]',30,240),(18074204,4,2,0,96000,'[{100,{2,1,480}},{100,{2,5,192}}]','[]',0,'[{100,{2,1,480}},{100,{2,3,384}},{100,{2,5,192}},{100,{2,7,192}}]',2,'[]',0,'[]',0,'[{49,480},{231,100}]',45,320),(18074205,4,2,1,106000,'[{100,{2,1,530}},{100,{2,5,212}}]','[]',0,'[{100,{2,1,530}},{100,{2,3,424}},{100,{2,5,212}},{100,{2,7,212}}]',2,'[]',0,'[]',0,'[{49,480},{231,100}]',60,400),(18074206,4,2,2,116000,'[{100,{2,1,580}},{100,{2,5,232}}]','[]',0,'[{100,{2,1,580}},{100,{2,3,464}},{100,{2,5,232}},{100,{2,7,232}}]',2,'[]',0,'[]',0,'[{49,480},{231,100}]',75,480),(18074207,4,2,0,126000,'[{100,{2,1,630}},{100,{3,5,302}}]','[]',0,'[{100,{2,1,630}},{100,{2,3,504}}]',1,'[{100,{3,5,302}},{100,{3,7,302}}]',1,'[]',0,'[{49,630},{231,150}]',90,600),(18074208,4,2,1,136000,'[{100,{2,1,680}},{100,{3,5,326}}]','[]',0,'[{100,{2,1,680}},{100,{2,3,544}}]',1,'[{100,{3,5,326}},{100,{3,7,326}}]',1,'[]',0,'[{49,630},{231,150}]',105,720),(18074209,4,2,2,146000,'[{100,{2,1,730}},{100,{3,5,350}}]','[]',0,'[{100,{2,1,730}},{100,{2,3,584}}]',1,'[{100,{3,5,350}},{100,{3,7,350}}]',1,'[]',0,'[{49,630},{231,150}]',120,840),(18074210,4,2,3,156000,'[{100,{2,1,780}},{100,{3,5,374}}]','[]',0,'[{100,{2,1,780}},{100,{2,3,624}}]',1,'[{100,{3,5,374}},{100,{3,7,374}}]',1,'[]',0,'[{49,630},{231,150}]',135,960),(18074211,4,2,0,166000,'[{100,{3,1,996}},{100,{3,5,398}}]','[]',0,'[]',0,'[{100,{3,1,996}},{100,{3,3,797}},{100,{3,5,398}},{100,{3,7,398}}]',2,'[]',0,'[{49,830},{231,200}]',150,1200),(18074301,4,3,0,116000,'[{100,{1,1,580}},{100,{1,5,232}}]','[{100,{1,1,580}},{100,{1,3,464}},{100,{1,5,232}},{100,{1,7,232}}]',2,'[]',0,'[]',0,'[]',0,'[{49,580},{231,100},{10,80}]',10,240),(18074302,4,3,1,128000,'[{100,{1,1,640}},{100,{1,5,256}}]','[{100,{1,1,640}},{100,{1,3,512}},{100,{1,5,256}},{100,{1,7,256}}]',2,'[]',0,'[]',0,'[]',0,'[{49,580},{231,100},{10,80}]',20,300),(18074303,4,3,2,140000,'[{100,{1,1,700}},{100,{1,5,280}}]','[{100,{1,1,700}},{100,{1,3,560}},{100,{1,5,280}},{100,{1,7,280}}]',2,'[]',0,'[]',0,'[]',0,'[{49,580},{231,100},{10,80}]',30,360),(18074304,4,3,0,152000,'[{100,{2,1,760}},{100,{2,5,304}}]','[]',0,'[{100,{2,1,760}},{100,{2,3,608}},{100,{2,5,304}},{100,{2,7,304}}]',2,'[]',0,'[]',0,'[{49,760},{231,200},{10,160}]',45,480),(18074305,4,3,1,164000,'[{100,{2,1,820}},{100,{2,5,328}}]','[]',0,'[{100,{2,1,820}},{100,{2,3,656}},{100,{2,5,328}},{100,{2,7,328}}]',2,'[]',0,'[]',0,'[{49,760},{231,200},{10,160}]',60,600),(18074306,4,3,2,176000,'[{100,{2,1,880}},{100,{2,5,352}}]','[]',0,'[{100,{2,1,880}},{100,{2,3,704}},{100,{2,5,352}},{100,{2,7,352}}]',2,'[]',0,'[]',0,'[{49,760},{231,200},{10,160}]',75,720),(18074307,4,3,0,188000,'[{100,{2,1,940}},{100,{3,5,451}}]','[]',0,'[{100,{2,1,940}},{100,{2,3,752}}]',1,'[{100,{3,5,451}},{100,{3,7,451}}]',1,'[]',0,'[{49,940},{231,300},{10,250}]',90,900),(18074308,4,3,1,200000,'[{100,{2,1,1000}},{100,{3,5,480}}]','[]',0,'[{100,{2,1,1000}},{100,{2,3,800}}]',1,'[{100,{3,5,480}},{100,{3,7,480}}]',1,'[]',0,'[{49,940},{231,300},{10,250}]',105,1080),(18074309,4,3,2,212000,'[{100,{2,1,1060}},{100,{3,5,509}}]','[]',0,'[{100,{2,1,1060}},{100,{2,3,848}}]',1,'[{100,{3,5,509}},{100,{3,7,509}}]',1,'[]',0,'[{49,940},{231,300},{10,250}]',120,1260),(18074310,4,3,3,224000,'[{100,{2,1,1120}},{100,{3,5,538}}]','[]',0,'[{100,{2,1,1120}},{100,{2,3,896}}]',1,'[{100,{3,5,538}},{100,{3,7,538}}]',1,'[]',0,'[{49,940},{231,300},{10,250}]',135,1440),(18074311,4,3,0,236000,'[{100,{3,1,1416}},{100,{3,5,566}}]','[]',0,'[]',0,'[{100,{3,1,1416}},{100,{3,3,1133}},{100,{3,5,566}},{100,{3,7,566}}]',2,'[]',0,'[{49,1180},{231,400},{10,350}]',150,1800);
/*!40000 ALTER TABLE `base_star_soul_equip` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_star_soul_equip_break_through`
--

DROP TABLE IF EXISTS `base_star_soul_equip_break_through`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_star_soul_equip_break_through` (
  `goods_type_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型id',
  `break_through_cost` varchar(128) NOT NULL DEFAULT '[]' COMMENT '突破消耗',
  `target_goods_type_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '目标装备',
  PRIMARY KEY (`goods_type_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星灵装备突破';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_star_soul_equip_break_through`
--

LOCK TABLES `base_star_soul_equip_break_through` WRITE;
/*!40000 ALTER TABLE `base_star_soul_equip_break_through` DISABLE KEYS */;
INSERT INTO `base_star_soul_equip_break_through` VALUES (18071001,'[{0,18190001,4}]',18071002),(18071002,'[{0,18190001,4}]',18071003),(18071003,'[{0,18190001,6}]',18071004),(18071004,'[{0,18190001,6}]',18071005),(18071005,'[{0,18190001,6}]',18071006),(18071006,'[{0,18190001,8}]',18071007),(18071007,'[{0,18190001,8}]',18071008),(18071008,'[{0,18190001,8}]',18071009),(18071009,'[{0,18190001,8}]',18071010),(18071010,'[{0,18190001,10}]',18071011),(18071101,'[{0,18190002,4}]',18071102),(18071102,'[{0,18190002,4}]',18071103),(18071103,'[{0,18190002,6}]',18071104),(18071104,'[{0,18190002,6}]',18071105),(18071105,'[{0,18190002,6}]',18071106),(18071106,'[{0,18190002,8}]',18071107),(18071107,'[{0,18190002,8}]',18071108),(18071108,'[{0,18190002,8}]',18071109),(18071109,'[{0,18190002,8}]',18071110),(18071110,'[{0,18190002,10}]',18071111),(18071201,'[{0,18190003,4}]',18071202),(18071202,'[{0,18190003,4}]',18071203),(18071203,'[{0,18190003,6}]',18071204),(18071204,'[{0,18190003,6}]',18071205),(18071205,'[{0,18190003,6}]',18071206),(18071206,'[{0,18190003,8}]',18071207),(18071207,'[{0,18190003,8}]',18071208),(18071208,'[{0,18190003,8}]',18071209),(18071209,'[{0,18190003,8}]',18071210),(18071210,'[{0,18190003,10}]',18071211),(18071301,'[{0,18190004,4}]',18071302),(18071302,'[{0,18190004,4}]',18071303),(18071303,'[{0,18190004,6}]',18071304),(18071304,'[{0,18190004,6}]',18071305),(18071305,'[{0,18190004,6}]',18071306),(18071306,'[{0,18190004,8}]',18071307),(18071307,'[{0,18190004,8}]',18071308),(18071308,'[{0,18190004,8}]',18071309),(18071309,'[{0,18190004,8}]',18071310),(18071310,'[{0,18190004,10}]',18071311),(18072001,'[{0,18190001,4}]',18072002),(18072002,'[{0,18190001,4}]',18072003),(18072003,'[{0,18190001,6}]',18072004),(18072004,'[{0,18190001,6}]',18072005),(18072005,'[{0,18190001,6}]',18072006),(18072006,'[{0,18190001,8}]',18072007),(18072007,'[{0,18190001,8}]',18072008),(18072008,'[{0,18190001,8}]',18072009),(18072009,'[{0,18190001,8}]',18072010),(18072010,'[{0,18190001,10}]',18072011),(18072101,'[{0,18190002,4}]',18072102),(18072102,'[{0,18190002,4}]',18072103),(18072103,'[{0,18190002,6}]',18072104),(18072104,'[{0,18190002,6}]',18072105),(18072105,'[{0,18190002,6}]',18072106),(18072106,'[{0,18190002,8}]',18072107),(18072107,'[{0,18190002,8}]',18072108),(18072108,'[{0,18190002,8}]',18072109),(18072109,'[{0,18190002,8}]',18072110),(18072110,'[{0,18190002,10}]',18072111),(18072201,'[{0,18190003,4}]',18072202),(18072202,'[{0,18190003,4}]',18072203),(18072203,'[{0,18190003,6}]',18072204),(18072204,'[{0,18190003,6}]',18072205),(18072205,'[{0,18190003,6}]',18072206),(18072206,'[{0,18190003,8}]',18072207),(18072207,'[{0,18190003,8}]',18072208),(18072208,'[{0,18190003,8}]',18072209),(18072209,'[{0,18190003,8}]',18072210),(18072210,'[{0,18190003,10}]',18072211),(18072301,'[{0,18190004,4}]',18072302),(18072302,'[{0,18190004,4}]',18072303),(18072303,'[{0,18190004,6}]',18072304),(18072304,'[{0,18190004,6}]',18072305),(18072305,'[{0,18190004,6}]',18072306),(18072306,'[{0,18190004,8}]',18072307),(18072307,'[{0,18190004,8}]',18072308),(18072308,'[{0,18190004,8}]',18072309),(18072309,'[{0,18190004,8}]',18072310),(18072310,'[{0,18190004,10}]',18072311),(18073001,'[{0,18190001,4}]',18073002),(18073002,'[{0,18190001,4}]',18073003),(18073003,'[{0,18190001,6}]',18073004),(18073004,'[{0,18190001,6}]',18073005),(18073005,'[{0,18190001,6}]',18073006),(18073006,'[{0,18190001,8}]',18073007),(18073007,'[{0,18190001,8}]',18073008),(18073008,'[{0,18190001,8}]',18073009),(18073009,'[{0,18190001,8}]',18073010),(18073010,'[{0,18190001,10}]',18073011),(18073101,'[{0,18190002,4}]',18073102),(18073102,'[{0,18190002,4}]',18073103),(18073103,'[{0,18190002,6}]',18073104),(18073104,'[{0,18190002,6}]',18073105),(18073105,'[{0,18190002,6}]',18073106),(18073106,'[{0,18190002,8}]',18073107),(18073107,'[{0,18190002,8}]',18073108),(18073108,'[{0,18190002,8}]',18073109),(18073109,'[{0,18190002,8}]',18073110),(18073110,'[{0,18190002,10}]',18073111),(18073201,'[{0,18190003,4}]',18073202),(18073202,'[{0,18190003,4}]',18073203),(18073203,'[{0,18190003,6}]',18073204),(18073204,'[{0,18190003,6}]',18073205),(18073205,'[{0,18190003,6}]',18073206),(18073206,'[{0,18190003,8}]',18073207),(18073207,'[{0,18190003,8}]',18073208),(18073208,'[{0,18190003,8}]',18073209),(18073209,'[{0,18190003,8}]',18073210),(18073210,'[{0,18190003,10}]',18073211),(18073301,'[{0,18190004,4}]',18073302),(18073302,'[{0,18190004,4}]',18073303),(18073303,'[{0,18190004,6}]',18073304),(18073304,'[{0,18190004,6}]',18073305),(18073305,'[{0,18190004,6}]',18073306),(18073306,'[{0,18190004,8}]',18073307),(18073307,'[{0,18190004,8}]',18073308),(18073308,'[{0,18190004,8}]',18073309),(18073309,'[{0,18190004,8}]',18073310),(18073310,'[{0,18190004,10}]',18073311),(18074001,'[{0,18190001,4}]',18074002),(18074002,'[{0,18190001,4}]',18074003),(18074003,'[{0,18190001,6}]',18074004),(18074004,'[{0,18190001,6}]',18074005),(18074005,'[{0,18190001,6}]',18074006),(18074006,'[{0,18190001,8}]',18074007),(18074007,'[{0,18190001,8}]',18074008),(18074008,'[{0,18190001,8}]',18074009),(18074009,'[{0,18190001,8}]',18074010),(18074010,'[{0,18190001,10}]',18074011),(18074101,'[{0,18190002,4}]',18074102),(18074102,'[{0,18190002,4}]',18074103),(18074103,'[{0,18190002,6}]',18074104),(18074104,'[{0,18190002,6}]',18074105),(18074105,'[{0,18190002,6}]',18074106),(18074106,'[{0,18190002,8}]',18074107),(18074107,'[{0,18190002,8}]',18074108),(18074108,'[{0,18190002,8}]',18074109),(18074109,'[{0,18190002,8}]',18074110),(18074110,'[{0,18190002,10}]',18074111),(18074201,'[{0,18190003,4}]',18074202),(18074202,'[{0,18190003,4}]',18074203),(18074203,'[{0,18190003,6}]',18074204),(18074204,'[{0,18190003,6}]',18074205),(18074205,'[{0,18190003,6}]',18074206),(18074206,'[{0,18190003,8}]',18074207),(18074207,'[{0,18190003,8}]',18074208),(18074208,'[{0,18190003,8}]',18074209),(18074209,'[{0,18190003,8}]',18074210),(18074210,'[{0,18190003,10}]',18074211),(18074301,'[{0,18190004,4}]',18074302),(18074302,'[{0,18190004,4}]',18074303),(18074303,'[{0,18190004,6}]',18074304),(18074304,'[{0,18190004,6}]',18074305),(18074305,'[{0,18190004,6}]',18074306),(18074306,'[{0,18190004,8}]',18074307),(18074307,'[{0,18190004,8}]',18074308),(18074308,'[{0,18190004,8}]',18074309),(18074309,'[{0,18190004,8}]',18074310),(18074310,'[{0,18190004,10}]',18074311);
/*!40000 ALTER TABLE `base_star_soul_equip_break_through` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_star_soul_equip_lv`
--

DROP TABLE IF EXISTS `base_star_soul_equip_lv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_star_soul_equip_lv` (
  `pos` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '装备部位',
  `rare` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '稀有度',
  `stren_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '强化等级',
  `cost_list` varchar(128) NOT NULL DEFAULT '[]' COMMENT '单次强化消耗',
  `exp_plus` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '单次强化增加的经验',
  `exp_limit` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '当前等级最大经验值',
  `attr_list` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '属性列表',
  PRIMARY KEY (`pos`,`stren_lv`,`rare`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='强化星灵装备';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_star_soul_equip_lv`
--

LOCK TABLES `base_star_soul_equip_lv` WRITE;
/*!40000 ALTER TABLE `base_star_soul_equip_lv` DISABLE KEYS */;
INSERT INTO `base_star_soul_equip_lv` VALUES (1,0,0,'[{255,36160004,5}]',10,50,'[{1,0},{5,0}]'),(1,1,0,'[{255,36160004,15}]',30,150,'[{1,0},{5,0}]'),(1,2,0,'[{255,36160004,25}]',50,250,'[{1,0},{5,0}]'),(1,3,0,'[{255,36160004,40}]',80,400,'[{1,0},{5,0}]'),(1,0,1,'[{255,36160004,5}]',10,50,'[{1,5},{5,2}]'),(1,1,1,'[{255,36160004,15}]',30,150,'[{1,10},{5,4}]'),(1,2,1,'[{255,36160004,25}]',50,250,'[{1,20},{5,8}]'),(1,3,1,'[{255,36160004,40}]',80,400,'[{1,28},{5,12}]'),(1,0,2,'[{255,36160004,5}]',10,50,'[{1,10},{5,4}]'),(1,1,2,'[{255,36160004,15}]',30,150,'[{1,20},{5,8}]'),(1,2,2,'[{255,36160004,25}]',50,250,'[{1,40},{5,16}]'),(1,3,2,'[{255,36160004,40}]',80,400,'[{1,56},{5,24}]'),(1,0,3,'[{255,36160004,5}]',10,50,'[{1,15},{5,6}]'),(1,1,3,'[{255,36160004,15}]',30,150,'[{1,30},{5,12}]'),(1,2,3,'[{255,36160004,25}]',50,250,'[{1,60},{5,24}]'),(1,3,3,'[{255,36160004,40}]',80,400,'[{1,84},{5,36}]'),(1,0,4,'[{255,36160004,5}]',10,50,'[{1,20},{5,8}]'),(1,1,4,'[{255,36160004,15}]',30,150,'[{1,40},{5,16}]'),(1,2,4,'[{255,36160004,25}]',50,250,'[{1,80},{5,32}]'),(1,3,4,'[{255,36160004,40}]',80,400,'[{1,112},{5,48}]'),(1,0,5,'[{255,36160004,5}]',10,50,'[{1,25},{5,10}]'),(1,1,5,'[{255,36160004,15}]',30,150,'[{1,50},{5,20}]'),(1,2,5,'[{255,36160004,25}]',50,250,'[{1,100},{5,40}]'),(1,3,5,'[{255,36160004,40}]',80,400,'[{1,140},{5,60}]'),(1,0,6,'[{255,36160004,5}]',10,50,'[{1,30},{5,12}]'),(1,1,6,'[{255,36160004,15}]',30,150,'[{1,60},{5,24}]'),(1,2,6,'[{255,36160004,25}]',50,250,'[{1,120},{5,48}]'),(1,3,6,'[{255,36160004,40}]',80,400,'[{1,168},{5,72}]'),(1,0,7,'[{255,36160004,5}]',10,50,'[{1,35},{5,14}]'),(1,1,7,'[{255,36160004,15}]',30,150,'[{1,70},{5,28}]'),(1,2,7,'[{255,36160004,25}]',50,250,'[{1,140},{5,56}]'),(1,3,7,'[{255,36160004,40}]',80,400,'[{1,196},{5,84}]'),(1,0,8,'[{255,36160004,5}]',10,50,'[{1,40},{5,16}]'),(1,1,8,'[{255,36160004,15}]',30,150,'[{1,80},{5,32}]'),(1,2,8,'[{255,36160004,25}]',50,250,'[{1,160},{5,64}]'),(1,3,8,'[{255,36160004,40}]',80,400,'[{1,224},{5,96}]'),(1,0,9,'[{255,36160004,5}]',10,50,'[{1,45},{5,18}]'),(1,1,9,'[{255,36160004,15}]',30,150,'[{1,90},{5,36}]'),(1,2,9,'[{255,36160004,25}]',50,250,'[{1,180},{5,72}]'),(1,3,9,'[{255,36160004,40}]',80,400,'[{1,252},{5,108}]'),(1,0,10,'[{255,36160004,6}]',12,60,'[{1,50},{5,20}]'),(1,1,10,'[{255,36160004,18}]',36,180,'[{1,100},{5,40}]'),(1,2,10,'[{255,36160004,30}]',60,300,'[{1,200},{5,80}]'),(1,3,10,'[{255,36160004,48}]',96,480,'[{1,280},{5,120}]'),(1,0,11,'[{255,36160004,6}]',12,60,'[{1,55},{5,22}]'),(1,1,11,'[{255,36160004,18}]',36,180,'[{1,110},{5,44}]'),(1,2,11,'[{255,36160004,30}]',60,300,'[{1,220},{5,88}]'),(1,3,11,'[{255,36160004,48}]',96,480,'[{1,308},{5,132}]'),(1,0,12,'[{255,36160004,6}]',12,60,'[{1,60},{5,24}]'),(1,1,12,'[{255,36160004,18}]',36,180,'[{1,120},{5,48}]'),(1,2,12,'[{255,36160004,30}]',60,300,'[{1,240},{5,96}]'),(1,3,12,'[{255,36160004,48}]',96,480,'[{1,336},{5,144}]'),(1,0,13,'[{255,36160004,6}]',12,60,'[{1,65},{5,26}]'),(1,1,13,'[{255,36160004,18}]',36,180,'[{1,130},{5,52}]'),(1,2,13,'[{255,36160004,30}]',60,300,'[{1,260},{5,104}]'),(1,3,13,'[{255,36160004,48}]',96,480,'[{1,364},{5,156}]'),(1,0,14,'[{255,36160004,6}]',12,60,'[{1,70},{5,28}]'),(1,1,14,'[{255,36160004,18}]',36,180,'[{1,140},{5,56}]'),(1,2,14,'[{255,36160004,30}]',60,300,'[{1,280},{5,112}]'),(1,3,14,'[{255,36160004,48}]',96,480,'[{1,392},{5,168}]'),(1,0,15,'[{255,36160004,6}]',12,60,'[{1,75},{5,30}]'),(1,1,15,'[{255,36160004,18}]',36,180,'[{1,150},{5,60}]'),(1,2,15,'[{255,36160004,30}]',60,300,'[{1,300},{5,120}]'),(1,3,15,'[{255,36160004,48}]',96,480,'[{1,420},{5,180}]'),(1,0,16,'[{255,36160004,6}]',12,60,'[{1,80},{5,32}]'),(1,1,16,'[{255,36160004,18}]',36,180,'[{1,160},{5,64}]'),(1,2,16,'[{255,36160004,30}]',60,300,'[{1,320},{5,128}]'),(1,3,16,'[{255,36160004,48}]',96,480,'[{1,448},{5,192}]'),(1,0,17,'[{255,36160004,6}]',12,60,'[{1,85},{5,34}]'),(1,1,17,'[{255,36160004,18}]',36,180,'[{1,170},{5,68}]'),(1,2,17,'[{255,36160004,30}]',60,300,'[{1,340},{5,136}]'),(1,3,17,'[{255,36160004,48}]',96,480,'[{1,476},{5,204}]'),(1,0,18,'[{255,36160004,6}]',12,60,'[{1,90},{5,36}]'),(1,1,18,'[{255,36160004,18}]',36,180,'[{1,180},{5,72}]'),(1,2,18,'[{255,36160004,30}]',60,300,'[{1,360},{5,144}]'),(1,3,18,'[{255,36160004,48}]',96,480,'[{1,504},{5,216}]'),(1,0,19,'[{255,36160004,6}]',12,60,'[{1,95},{5,38}]'),(1,1,19,'[{255,36160004,18}]',36,180,'[{1,190},{5,76}]'),(1,2,19,'[{255,36160004,30}]',60,300,'[{1,380},{5,152}]'),(1,3,19,'[{255,36160004,48}]',96,480,'[{1,532},{5,228}]'),(1,0,20,'[{255,36160004,7}]',14,70,'[{1,100},{5,40}]'),(1,1,20,'[{255,36160004,21}]',42,210,'[{1,200},{5,80}]'),(1,2,20,'[{255,36160004,35}]',70,350,'[{1,400},{5,160}]'),(1,3,20,'[{255,36160004,56}]',112,560,'[{1,560},{5,240}]'),(1,0,21,'[{255,36160004,7}]',14,70,'[{1,105},{5,42}]'),(1,1,21,'[{255,36160004,21}]',42,210,'[{1,210},{5,84}]'),(1,2,21,'[{255,36160004,35}]',70,350,'[{1,420},{5,168}]'),(1,3,21,'[{255,36160004,56}]',112,560,'[{1,588},{5,252}]'),(1,0,22,'[{255,36160004,7}]',14,70,'[{1,110},{5,44}]'),(1,1,22,'[{255,36160004,21}]',42,210,'[{1,220},{5,88}]'),(1,2,22,'[{255,36160004,35}]',70,350,'[{1,440},{5,176}]'),(1,3,22,'[{255,36160004,56}]',112,560,'[{1,616},{5,264}]'),(1,0,23,'[{255,36160004,7}]',14,70,'[{1,115},{5,46}]'),(1,1,23,'[{255,36160004,21}]',42,210,'[{1,230},{5,92}]'),(1,2,23,'[{255,36160004,35}]',70,350,'[{1,460},{5,184}]'),(1,3,23,'[{255,36160004,56}]',112,560,'[{1,644},{5,276}]'),(1,0,24,'[{255,36160004,7}]',14,70,'[{1,120},{5,48}]'),(1,1,24,'[{255,36160004,21}]',42,210,'[{1,240},{5,96}]'),(1,2,24,'[{255,36160004,35}]',70,350,'[{1,480},{5,192}]'),(1,3,24,'[{255,36160004,56}]',112,560,'[{1,672},{5,288}]'),(1,0,25,'[{255,36160004,7}]',14,70,'[{1,125},{5,50}]'),(1,1,25,'[{255,36160004,21}]',42,210,'[{1,250},{5,100}]'),(1,2,25,'[{255,36160004,35}]',70,350,'[{1,500},{5,200}]'),(1,3,25,'[{255,36160004,56}]',112,560,'[{1,700},{5,300}]'),(1,0,26,'[{255,36160004,7}]',14,70,'[{1,130},{5,52}]'),(1,1,26,'[{255,36160004,21}]',42,210,'[{1,260},{5,104}]'),(1,2,26,'[{255,36160004,35}]',70,350,'[{1,520},{5,208}]'),(1,3,26,'[{255,36160004,56}]',112,560,'[{1,728},{5,312}]'),(1,0,27,'[{255,36160004,7}]',14,70,'[{1,135},{5,54}]'),(1,1,27,'[{255,36160004,21}]',42,210,'[{1,270},{5,108}]'),(1,2,27,'[{255,36160004,35}]',70,350,'[{1,540},{5,216}]'),(1,3,27,'[{255,36160004,56}]',112,560,'[{1,756},{5,324}]'),(1,0,28,'[{255,36160004,7}]',14,70,'[{1,140},{5,56}]'),(1,1,28,'[{255,36160004,21}]',42,210,'[{1,280},{5,112}]'),(1,2,28,'[{255,36160004,35}]',70,350,'[{1,560},{5,224}]'),(1,3,28,'[{255,36160004,56}]',112,560,'[{1,784},{5,336}]'),(1,0,29,'[{255,36160004,7}]',14,70,'[{1,145},{5,58}]'),(1,1,29,'[{255,36160004,21}]',42,210,'[{1,290},{5,116}]'),(1,2,29,'[{255,36160004,35}]',70,350,'[{1,580},{5,232}]'),(1,3,29,'[{255,36160004,56}]',112,560,'[{1,812},{5,348}]'),(1,0,30,'[{255,36160004,8}]',16,80,'[{1,150},{5,60}]'),(1,1,30,'[{255,36160004,24}]',48,240,'[{1,300},{5,120}]'),(1,2,30,'[{255,36160004,40}]',80,400,'[{1,600},{5,240}]'),(1,3,30,'[{255,36160004,64}]',128,640,'[{1,840},{5,360}]'),(1,0,31,'[{255,36160004,8}]',16,80,'[{1,155},{5,62}]'),(1,1,31,'[{255,36160004,24}]',48,240,'[{1,310},{5,124}]'),(1,2,31,'[{255,36160004,40}]',80,400,'[{1,620},{5,248}]'),(1,3,31,'[{255,36160004,64}]',128,640,'[{1,868},{5,372}]'),(1,0,32,'[{255,36160004,8}]',16,80,'[{1,160},{5,64}]'),(1,1,32,'[{255,36160004,24}]',48,240,'[{1,320},{5,128}]'),(1,2,32,'[{255,36160004,40}]',80,400,'[{1,640},{5,256}]'),(1,3,32,'[{255,36160004,64}]',128,640,'[{1,896},{5,384}]'),(1,0,33,'[{255,36160004,8}]',16,80,'[{1,165},{5,66}]'),(1,1,33,'[{255,36160004,24}]',48,240,'[{1,330},{5,132}]'),(1,2,33,'[{255,36160004,40}]',80,400,'[{1,660},{5,264}]'),(1,3,33,'[{255,36160004,64}]',128,640,'[{1,924},{5,396}]'),(1,0,34,'[{255,36160004,8}]',16,80,'[{1,170},{5,68}]'),(1,1,34,'[{255,36160004,24}]',48,240,'[{1,340},{5,136}]'),(1,2,34,'[{255,36160004,40}]',80,400,'[{1,680},{5,272}]'),(1,3,34,'[{255,36160004,64}]',128,640,'[{1,952},{5,408}]'),(1,0,35,'[{255,36160004,8}]',16,80,'[{1,175},{5,70}]'),(1,1,35,'[{255,36160004,24}]',48,240,'[{1,350},{5,140}]'),(1,2,35,'[{255,36160004,40}]',80,400,'[{1,700},{5,280}]'),(1,3,35,'[{255,36160004,64}]',128,640,'[{1,980},{5,420}]'),(1,0,36,'[{255,36160004,8}]',16,80,'[{1,180},{5,72}]'),(1,1,36,'[{255,36160004,24}]',48,240,'[{1,360},{5,144}]'),(1,2,36,'[{255,36160004,40}]',80,400,'[{1,720},{5,288}]'),(1,3,36,'[{255,36160004,64}]',128,640,'[{1,1008},{5,432}]'),(1,0,37,'[{255,36160004,8}]',16,80,'[{1,185},{5,74}]'),(1,1,37,'[{255,36160004,24}]',48,240,'[{1,370},{5,148}]'),(1,2,37,'[{255,36160004,40}]',80,400,'[{1,740},{5,296}]'),(1,3,37,'[{255,36160004,64}]',128,640,'[{1,1036},{5,444}]'),(1,0,38,'[{255,36160004,8}]',16,80,'[{1,190},{5,76}]'),(1,1,38,'[{255,36160004,24}]',48,240,'[{1,380},{5,152}]'),(1,2,38,'[{255,36160004,40}]',80,400,'[{1,760},{5,304}]'),(1,3,38,'[{255,36160004,64}]',128,640,'[{1,1064},{5,456}]'),(1,0,39,'[{255,36160004,8}]',16,80,'[{1,195},{5,78}]'),(1,1,39,'[{255,36160004,24}]',48,240,'[{1,390},{5,156}]'),(1,2,39,'[{255,36160004,40}]',80,400,'[{1,780},{5,312}]'),(1,3,39,'[{255,36160004,64}]',128,640,'[{1,1092},{5,468}]'),(1,0,40,'[{255,36160004,8}]',16,80,'[{1,200},{5,80}]'),(1,1,40,'[{255,36160004,24}]',48,240,'[{1,400},{5,160}]'),(1,2,40,'[{255,36160004,40}]',80,400,'[{1,800},{5,320}]'),(1,3,40,'[{255,36160004,64}]',128,640,'[{1,1120},{5,480}]'),(1,0,41,'[{255,36160004,8}]',16,80,'[{1,205},{5,82}]'),(1,1,41,'[{255,36160004,24}]',48,240,'[{1,410},{5,164}]'),(1,2,41,'[{255,36160004,40}]',80,400,'[{1,820},{5,328}]'),(1,3,41,'[{255,36160004,64}]',128,640,'[{1,1148},{5,492}]'),(1,0,42,'[{255,36160004,8}]',16,80,'[{1,210},{5,84}]'),(1,1,42,'[{255,36160004,24}]',48,240,'[{1,420},{5,168}]'),(1,2,42,'[{255,36160004,40}]',80,400,'[{1,840},{5,336}]'),(1,3,42,'[{255,36160004,64}]',128,640,'[{1,1176},{5,504}]'),(1,0,43,'[{255,36160004,8}]',16,80,'[{1,215},{5,86}]'),(1,1,43,'[{255,36160004,24}]',48,240,'[{1,430},{5,172}]'),(1,2,43,'[{255,36160004,40}]',80,400,'[{1,860},{5,344}]'),(1,3,43,'[{255,36160004,64}]',128,640,'[{1,1204},{5,516}]'),(1,0,44,'[{255,36160004,8}]',16,80,'[{1,220},{5,88}]'),(1,1,44,'[{255,36160004,24}]',48,240,'[{1,440},{5,176}]'),(1,2,44,'[{255,36160004,40}]',80,400,'[{1,880},{5,352}]'),(1,3,44,'[{255,36160004,64}]',128,640,'[{1,1232},{5,528}]'),(1,0,45,'[{255,36160004,9}]',18,90,'[{1,225},{5,90}]'),(1,1,45,'[{255,36160004,27}]',54,270,'[{1,450},{5,180}]'),(1,2,45,'[{255,36160004,45}]',90,450,'[{1,900},{5,360}]'),(1,3,45,'[{255,36160004,72}]',144,720,'[{1,1260},{5,540}]'),(1,0,46,'[{255,36160004,9}]',18,90,'[{1,230},{5,92}]'),(1,1,46,'[{255,36160004,27}]',54,270,'[{1,460},{5,184}]'),(1,2,46,'[{255,36160004,45}]',90,450,'[{1,920},{5,368}]'),(1,3,46,'[{255,36160004,72}]',144,720,'[{1,1288},{5,552}]'),(1,0,47,'[{255,36160004,9}]',18,90,'[{1,235},{5,94}]'),(1,1,47,'[{255,36160004,27}]',54,270,'[{1,470},{5,188}]'),(1,2,47,'[{255,36160004,45}]',90,450,'[{1,940},{5,376}]'),(1,3,47,'[{255,36160004,72}]',144,720,'[{1,1316},{5,564}]'),(1,0,48,'[{255,36160004,9}]',18,90,'[{1,240},{5,96}]'),(1,1,48,'[{255,36160004,27}]',54,270,'[{1,480},{5,192}]'),(1,2,48,'[{255,36160004,45}]',90,450,'[{1,960},{5,384}]'),(1,3,48,'[{255,36160004,72}]',144,720,'[{1,1344},{5,576}]'),(1,0,49,'[{255,36160004,9}]',18,90,'[{1,245},{5,98}]'),(1,1,49,'[{255,36160004,27}]',54,270,'[{1,490},{5,196}]'),(1,2,49,'[{255,36160004,45}]',90,450,'[{1,980},{5,392}]'),(1,3,49,'[{255,36160004,72}]',144,720,'[{1,1372},{5,588}]'),(1,0,50,'[{255,36160004,9}]',18,90,'[{1,250},{5,100}]'),(1,1,50,'[{255,36160004,27}]',54,270,'[{1,500},{5,200}]'),(1,2,50,'[{255,36160004,45}]',90,450,'[{1,1000},{5,400}]'),(1,3,50,'[{255,36160004,72}]',144,720,'[{1,1400},{5,600}]'),(1,0,51,'[{255,36160004,9}]',18,90,'[{1,260},{5,104}]'),(1,1,51,'[{255,36160004,27}]',54,270,'[{1,515},{5,206}]'),(1,2,51,'[{255,36160004,45}]',90,450,'[{1,1025},{5,410}]'),(1,3,51,'[{255,36160004,72}]',144,720,'[{1,1435},{5,615}]'),(1,0,52,'[{255,36160004,9}]',18,90,'[{1,270},{5,108}]'),(1,1,52,'[{255,36160004,27}]',54,270,'[{1,530},{5,212}]'),(1,2,52,'[{255,36160004,45}]',90,450,'[{1,1050},{5,420}]'),(1,3,52,'[{255,36160004,72}]',144,720,'[{1,1470},{5,630}]'),(1,0,53,'[{255,36160004,9}]',18,90,'[{1,280},{5,112}]'),(1,1,53,'[{255,36160004,27}]',54,270,'[{1,545},{5,218}]'),(1,2,53,'[{255,36160004,45}]',90,450,'[{1,1075},{5,430}]'),(1,3,53,'[{255,36160004,72}]',144,720,'[{1,1505},{5,645}]'),(1,0,54,'[{255,36160004,9}]',18,90,'[{1,290},{5,116}]'),(1,1,54,'[{255,36160004,27}]',54,270,'[{1,560},{5,224}]'),(1,2,54,'[{255,36160004,45}]',90,450,'[{1,1100},{5,440}]'),(1,3,54,'[{255,36160004,72}]',144,720,'[{1,1540},{5,660}]'),(1,0,55,'[{255,36160004,9}]',18,90,'[{1,300},{5,120}]'),(1,1,55,'[{255,36160004,27}]',54,270,'[{1,575},{5,230}]'),(1,2,55,'[{255,36160004,45}]',90,450,'[{1,1125},{5,450}]'),(1,3,55,'[{255,36160004,72}]',144,720,'[{1,1575},{5,675}]'),(1,0,56,'[{255,36160004,9}]',18,90,'[{1,310},{5,124}]'),(1,1,56,'[{255,36160004,27}]',54,270,'[{1,590},{5,236}]'),(1,2,56,'[{255,36160004,45}]',90,450,'[{1,1150},{5,460}]'),(1,3,56,'[{255,36160004,72}]',144,720,'[{1,1610},{5,690}]'),(1,0,57,'[{255,36160004,9}]',18,90,'[{1,320},{5,128}]'),(1,1,57,'[{255,36160004,27}]',54,270,'[{1,605},{5,242}]'),(1,2,57,'[{255,36160004,45}]',90,450,'[{1,1175},{5,470}]'),(1,3,57,'[{255,36160004,72}]',144,720,'[{1,1645},{5,705}]'),(1,0,58,'[{255,36160004,9}]',18,90,'[{1,330},{5,132}]'),(1,1,58,'[{255,36160004,27}]',54,270,'[{1,620},{5,248}]'),(1,2,58,'[{255,36160004,45}]',90,450,'[{1,1200},{5,480}]'),(1,3,58,'[{255,36160004,72}]',144,720,'[{1,1680},{5,720}]'),(1,0,59,'[{255,36160004,9}]',18,90,'[{1,340},{5,136}]'),(1,1,59,'[{255,36160004,27}]',54,270,'[{1,635},{5,254}]'),(1,2,59,'[{255,36160004,45}]',90,450,'[{1,1225},{5,490}]'),(1,3,59,'[{255,36160004,72}]',144,720,'[{1,1715},{5,735}]'),(1,0,60,'[{255,36160004,10}]',20,100,'[{1,350},{5,140}]'),(1,1,60,'[{255,36160004,30}]',60,300,'[{1,650},{5,260}]'),(1,2,60,'[{255,36160004,50}]',100,500,'[{1,1250},{5,500}]'),(1,3,60,'[{255,36160004,80}]',160,800,'[{1,1750},{5,750}]'),(1,0,61,'[{255,36160004,10}]',20,100,'[{1,360},{5,144}]'),(1,1,61,'[{255,36160004,30}]',60,300,'[{1,665},{5,266}]'),(1,2,61,'[{255,36160004,50}]',100,500,'[{1,1275},{5,510}]'),(1,3,61,'[{255,36160004,80}]',160,800,'[{1,1785},{5,765}]'),(1,0,62,'[{255,36160004,10}]',20,100,'[{1,370},{5,148}]'),(1,1,62,'[{255,36160004,30}]',60,300,'[{1,680},{5,272}]'),(1,2,62,'[{255,36160004,50}]',100,500,'[{1,1300},{5,520}]'),(1,3,62,'[{255,36160004,80}]',160,800,'[{1,1820},{5,780}]'),(1,0,63,'[{255,36160004,10}]',20,100,'[{1,380},{5,152}]'),(1,1,63,'[{255,36160004,30}]',60,300,'[{1,695},{5,278}]'),(1,2,63,'[{255,36160004,50}]',100,500,'[{1,1325},{5,530}]'),(1,3,63,'[{255,36160004,80}]',160,800,'[{1,1855},{5,795}]'),(1,0,64,'[{255,36160004,10}]',20,100,'[{1,390},{5,156}]'),(1,1,64,'[{255,36160004,30}]',60,300,'[{1,710},{5,284}]'),(1,2,64,'[{255,36160004,50}]',100,500,'[{1,1350},{5,540}]'),(1,3,64,'[{255,36160004,80}]',160,800,'[{1,1890},{5,810}]'),(1,0,65,'[{255,36160004,10}]',20,100,'[{1,400},{5,160}]'),(1,1,65,'[{255,36160004,30}]',60,300,'[{1,725},{5,290}]'),(1,2,65,'[{255,36160004,50}]',100,500,'[{1,1375},{5,550}]'),(1,3,65,'[{255,36160004,80}]',160,800,'[{1,1925},{5,825}]'),(1,0,66,'[{255,36160004,10}]',20,100,'[{1,410},{5,164}]'),(1,1,66,'[{255,36160004,30}]',60,300,'[{1,740},{5,296}]'),(1,2,66,'[{255,36160004,50}]',100,500,'[{1,1400},{5,560}]'),(1,3,66,'[{255,36160004,80}]',160,800,'[{1,1960},{5,840}]'),(1,0,67,'[{255,36160004,10}]',20,100,'[{1,420},{5,168}]'),(1,1,67,'[{255,36160004,30}]',60,300,'[{1,755},{5,302}]'),(1,2,67,'[{255,36160004,50}]',100,500,'[{1,1425},{5,570}]'),(1,3,67,'[{255,36160004,80}]',160,800,'[{1,1995},{5,855}]'),(1,0,68,'[{255,36160004,10}]',20,100,'[{1,430},{5,172}]'),(1,1,68,'[{255,36160004,30}]',60,300,'[{1,770},{5,308}]'),(1,2,68,'[{255,36160004,50}]',100,500,'[{1,1450},{5,580}]'),(1,3,68,'[{255,36160004,80}]',160,800,'[{1,2030},{5,870}]'),(1,0,69,'[{255,36160004,10}]',20,100,'[{1,440},{5,176}]'),(1,1,69,'[{255,36160004,30}]',60,300,'[{1,785},{5,314}]'),(1,2,69,'[{255,36160004,50}]',100,500,'[{1,1475},{5,590}]'),(1,3,69,'[{255,36160004,80}]',160,800,'[{1,2065},{5,885}]'),(1,0,70,'[{255,36160004,10}]',20,100,'[{1,450},{5,180}]'),(1,1,70,'[{255,36160004,30}]',60,300,'[{1,800},{5,320}]'),(1,2,70,'[{255,36160004,50}]',100,500,'[{1,1500},{5,600}]'),(1,3,70,'[{255,36160004,80}]',160,800,'[{1,2100},{5,900}]'),(1,0,71,'[{255,36160004,10}]',20,100,'[{1,460},{5,184}]'),(1,1,71,'[{255,36160004,30}]',60,300,'[{1,815},{5,326}]'),(1,2,71,'[{255,36160004,50}]',100,500,'[{1,1525},{5,610}]'),(1,3,71,'[{255,36160004,80}]',160,800,'[{1,2135},{5,915}]'),(1,0,72,'[{255,36160004,10}]',20,100,'[{1,470},{5,188}]'),(1,1,72,'[{255,36160004,30}]',60,300,'[{1,830},{5,332}]'),(1,2,72,'[{255,36160004,50}]',100,500,'[{1,1550},{5,620}]'),(1,3,72,'[{255,36160004,80}]',160,800,'[{1,2170},{5,930}]'),(1,0,73,'[{255,36160004,10}]',20,100,'[{1,480},{5,192}]'),(1,1,73,'[{255,36160004,30}]',60,300,'[{1,845},{5,338}]'),(1,2,73,'[{255,36160004,50}]',100,500,'[{1,1575},{5,630}]'),(1,3,73,'[{255,36160004,80}]',160,800,'[{1,2205},{5,945}]'),(1,0,74,'[{255,36160004,10}]',20,100,'[{1,490},{5,196}]'),(1,1,74,'[{255,36160004,30}]',60,300,'[{1,860},{5,344}]'),(1,2,74,'[{255,36160004,50}]',100,500,'[{1,1600},{5,640}]'),(1,3,74,'[{255,36160004,80}]',160,800,'[{1,2240},{5,960}]'),(1,0,75,'[{255,36160004,11}]',22,110,'[{1,500},{5,200}]'),(1,1,75,'[{255,36160004,33}]',66,330,'[{1,875},{5,350}]'),(1,2,75,'[{255,36160004,55}]',110,550,'[{1,1625},{5,650}]'),(1,3,75,'[{255,36160004,88}]',176,880,'[{1,2275},{5,975}]'),(1,0,76,'[{255,36160004,11}]',22,110,'[{1,510},{5,204}]'),(1,1,76,'[{255,36160004,33}]',66,330,'[{1,890},{5,356}]'),(1,2,76,'[{255,36160004,55}]',110,550,'[{1,1650},{5,660}]'),(1,3,76,'[{255,36160004,88}]',176,880,'[{1,2310},{5,990}]'),(1,0,77,'[{255,36160004,11}]',22,110,'[{1,520},{5,208}]'),(1,1,77,'[{255,36160004,33}]',66,330,'[{1,905},{5,362}]'),(1,2,77,'[{255,36160004,55}]',110,550,'[{1,1675},{5,670}]'),(1,3,77,'[{255,36160004,88}]',176,880,'[{1,2345},{5,1005}]'),(1,0,78,'[{255,36160004,11}]',22,110,'[{1,530},{5,212}]'),(1,1,78,'[{255,36160004,33}]',66,330,'[{1,920},{5,368}]'),(1,2,78,'[{255,36160004,55}]',110,550,'[{1,1700},{5,680}]'),(1,3,78,'[{255,36160004,88}]',176,880,'[{1,2380},{5,1020}]'),(1,0,79,'[{255,36160004,11}]',22,110,'[{1,540},{5,216}]'),(1,1,79,'[{255,36160004,33}]',66,330,'[{1,935},{5,374}]'),(1,2,79,'[{255,36160004,55}]',110,550,'[{1,1725},{5,690}]'),(1,3,79,'[{255,36160004,88}]',176,880,'[{1,2415},{5,1035}]'),(1,0,80,'[{255,36160004,11}]',22,110,'[{1,550},{5,220}]'),(1,1,80,'[{255,36160004,33}]',66,330,'[{1,950},{5,380}]'),(1,2,80,'[{255,36160004,55}]',110,550,'[{1,1750},{5,700}]'),(1,3,80,'[{255,36160004,88}]',176,880,'[{1,2450},{5,1050}]'),(1,0,81,'[{255,36160004,11}]',22,110,'[{1,560},{5,224}]'),(1,1,81,'[{255,36160004,33}]',66,330,'[{1,965},{5,386}]'),(1,2,81,'[{255,36160004,55}]',110,550,'[{1,1775},{5,710}]'),(1,3,81,'[{255,36160004,88}]',176,880,'[{1,2485},{5,1065}]'),(1,0,82,'[{255,36160004,11}]',22,110,'[{1,570},{5,228}]'),(1,1,82,'[{255,36160004,33}]',66,330,'[{1,980},{5,392}]'),(1,2,82,'[{255,36160004,55}]',110,550,'[{1,1800},{5,720}]'),(1,3,82,'[{255,36160004,88}]',176,880,'[{1,2520},{5,1080}]'),(1,0,83,'[{255,36160004,11}]',22,110,'[{1,580},{5,232}]'),(1,1,83,'[{255,36160004,33}]',66,330,'[{1,995},{5,398}]'),(1,2,83,'[{255,36160004,55}]',110,550,'[{1,1825},{5,730}]'),(1,3,83,'[{255,36160004,88}]',176,880,'[{1,2555},{5,1095}]'),(1,0,84,'[{255,36160004,11}]',22,110,'[{1,590},{5,236}]'),(1,1,84,'[{255,36160004,33}]',66,330,'[{1,1010},{5,404}]'),(1,2,84,'[{255,36160004,55}]',110,550,'[{1,1850},{5,740}]'),(1,3,84,'[{255,36160004,88}]',176,880,'[{1,2590},{5,1110}]'),(1,0,85,'[{255,36160004,11}]',22,110,'[{1,600},{5,240}]'),(1,1,85,'[{255,36160004,33}]',66,330,'[{1,1025},{5,410}]'),(1,2,85,'[{255,36160004,55}]',110,550,'[{1,1875},{5,750}]'),(1,3,85,'[{255,36160004,88}]',176,880,'[{1,2625},{5,1125}]'),(1,0,86,'[{255,36160004,11}]',22,110,'[{1,610},{5,244}]'),(1,1,86,'[{255,36160004,33}]',66,330,'[{1,1040},{5,416}]'),(1,2,86,'[{255,36160004,55}]',110,550,'[{1,1900},{5,760}]'),(1,3,86,'[{255,36160004,88}]',176,880,'[{1,2660},{5,1140}]'),(1,0,87,'[{255,36160004,11}]',22,110,'[{1,620},{5,248}]'),(1,1,87,'[{255,36160004,33}]',66,330,'[{1,1055},{5,422}]'),(1,2,87,'[{255,36160004,55}]',110,550,'[{1,1925},{5,770}]'),(1,3,87,'[{255,36160004,88}]',176,880,'[{1,2695},{5,1155}]'),(1,0,88,'[{255,36160004,11}]',22,110,'[{1,630},{5,252}]'),(1,1,88,'[{255,36160004,33}]',66,330,'[{1,1070},{5,428}]'),(1,2,88,'[{255,36160004,55}]',110,550,'[{1,1950},{5,780}]'),(1,3,88,'[{255,36160004,88}]',176,880,'[{1,2730},{5,1170}]'),(1,0,89,'[{255,36160004,11}]',22,110,'[{1,640},{5,256}]'),(1,1,89,'[{255,36160004,33}]',66,330,'[{1,1085},{5,434}]'),(1,2,89,'[{255,36160004,55}]',110,550,'[{1,1975},{5,790}]'),(1,3,89,'[{255,36160004,88}]',176,880,'[{1,2765},{5,1185}]'),(1,0,90,'[{255,36160004,12}]',24,120,'[{1,650},{5,260}]'),(1,1,90,'[{255,36160004,36}]',72,360,'[{1,1100},{5,440}]'),(1,2,90,'[{255,36160004,60}]',120,600,'[{1,2000},{5,800}]'),(1,3,90,'[{255,36160004,96}]',192,960,'[{1,2800},{5,1200}]'),(1,0,91,'[{255,36160004,12}]',24,120,'[{1,660},{5,264}]'),(1,1,91,'[{255,36160004,36}]',72,360,'[{1,1115},{5,446}]'),(1,2,91,'[{255,36160004,60}]',120,600,'[{1,2025},{5,810}]'),(1,3,91,'[{255,36160004,96}]',192,960,'[{1,2835},{5,1215}]'),(1,0,92,'[{255,36160004,12}]',24,120,'[{1,670},{5,268}]'),(1,1,92,'[{255,36160004,36}]',72,360,'[{1,1130},{5,452}]'),(1,2,92,'[{255,36160004,60}]',120,600,'[{1,2050},{5,820}]'),(1,3,92,'[{255,36160004,96}]',192,960,'[{1,2870},{5,1230}]'),(1,0,93,'[{255,36160004,12}]',24,120,'[{1,680},{5,272}]'),(1,1,93,'[{255,36160004,36}]',72,360,'[{1,1145},{5,458}]'),(1,2,93,'[{255,36160004,60}]',120,600,'[{1,2075},{5,830}]'),(1,3,93,'[{255,36160004,96}]',192,960,'[{1,2905},{5,1245}]'),(1,0,94,'[{255,36160004,12}]',24,120,'[{1,690},{5,276}]'),(1,1,94,'[{255,36160004,36}]',72,360,'[{1,1160},{5,464}]'),(1,2,94,'[{255,36160004,60}]',120,600,'[{1,2100},{5,840}]'),(1,3,94,'[{255,36160004,96}]',192,960,'[{1,2940},{5,1260}]'),(1,0,95,'[{255,36160004,12}]',24,120,'[{1,700},{5,280}]'),(1,1,95,'[{255,36160004,36}]',72,360,'[{1,1175},{5,470}]'),(1,2,95,'[{255,36160004,60}]',120,600,'[{1,2125},{5,850}]'),(1,3,95,'[{255,36160004,96}]',192,960,'[{1,2975},{5,1275}]'),(1,0,96,'[{255,36160004,12}]',24,120,'[{1,710},{5,284}]'),(1,1,96,'[{255,36160004,36}]',72,360,'[{1,1190},{5,476}]'),(1,2,96,'[{255,36160004,60}]',120,600,'[{1,2150},{5,860}]'),(1,3,96,'[{255,36160004,96}]',192,960,'[{1,3010},{5,1290}]'),(1,0,97,'[{255,36160004,12}]',24,120,'[{1,720},{5,288}]'),(1,1,97,'[{255,36160004,36}]',72,360,'[{1,1205},{5,482}]'),(1,2,97,'[{255,36160004,60}]',120,600,'[{1,2175},{5,870}]'),(1,3,97,'[{255,36160004,96}]',192,960,'[{1,3045},{5,1305}]'),(1,0,98,'[{255,36160004,12}]',24,120,'[{1,730},{5,292}]'),(1,1,98,'[{255,36160004,36}]',72,360,'[{1,1220},{5,488}]'),(1,2,98,'[{255,36160004,60}]',120,600,'[{1,2200},{5,880}]'),(1,3,98,'[{255,36160004,96}]',192,960,'[{1,3080},{5,1320}]'),(1,0,99,'[{255,36160004,12}]',24,120,'[{1,740},{5,296}]'),(1,1,99,'[{255,36160004,36}]',72,360,'[{1,1235},{5,494}]'),(1,2,99,'[{255,36160004,60}]',120,600,'[{1,2225},{5,890}]'),(1,3,99,'[{255,36160004,96}]',192,960,'[{1,3115},{5,1335}]'),(1,0,100,'[{255,36160004,12}]',24,120,'[{1,750},{5,300}]'),(1,1,100,'[{255,36160004,36}]',72,360,'[{1,1250},{5,500}]'),(1,2,100,'[{255,36160004,60}]',120,600,'[{1,2250},{5,900}]'),(1,3,100,'[{255,36160004,96}]',192,960,'[{1,3150},{5,1350}]'),(1,0,101,'[{255,36160004,12}]',24,120,'[{1,765},{5,306}]'),(1,1,101,'[{255,36160004,36}]',72,360,'[{1,1270},{5,508}]'),(1,2,101,'[{255,36160004,60}]',120,600,'[{1,2280},{5,912}]'),(1,3,101,'[{255,36160004,96}]',192,960,'[{1,3192},{5,1368}]'),(1,0,102,'[{255,36160004,12}]',24,120,'[{1,780},{5,312}]'),(1,1,102,'[{255,36160004,36}]',72,360,'[{1,1290},{5,516}]'),(1,2,102,'[{255,36160004,60}]',120,600,'[{1,2310},{5,924}]'),(1,3,102,'[{255,36160004,96}]',192,960,'[{1,3234},{5,1386}]'),(1,0,103,'[{255,36160004,12}]',24,120,'[{1,795},{5,318}]'),(1,1,103,'[{255,36160004,36}]',72,360,'[{1,1310},{5,524}]'),(1,2,103,'[{255,36160004,60}]',120,600,'[{1,2340},{5,936}]'),(1,3,103,'[{255,36160004,96}]',192,960,'[{1,3276},{5,1404}]'),(1,0,104,'[{255,36160004,12}]',24,120,'[{1,810},{5,324}]'),(1,1,104,'[{255,36160004,36}]',72,360,'[{1,1330},{5,532}]'),(1,2,104,'[{255,36160004,60}]',120,600,'[{1,2370},{5,948}]'),(1,3,104,'[{255,36160004,96}]',192,960,'[{1,3318},{5,1422}]'),(1,0,105,'[{255,36160004,13}]',26,130,'[{1,825},{5,330}]'),(1,1,105,'[{255,36160004,39}]',78,390,'[{1,1350},{5,540}]'),(1,2,105,'[{255,36160004,65}]',130,650,'[{1,2400},{5,960}]'),(1,3,105,'[{255,36160004,104}]',208,1040,'[{1,3360},{5,1440}]'),(1,0,106,'[{255,36160004,13}]',26,130,'[{1,840},{5,336}]'),(1,1,106,'[{255,36160004,39}]',78,390,'[{1,1370},{5,548}]'),(1,2,106,'[{255,36160004,65}]',130,650,'[{1,2430},{5,972}]'),(1,3,106,'[{255,36160004,104}]',208,1040,'[{1,3402},{5,1458}]'),(1,0,107,'[{255,36160004,13}]',26,130,'[{1,855},{5,342}]'),(1,1,107,'[{255,36160004,39}]',78,390,'[{1,1390},{5,556}]'),(1,2,107,'[{255,36160004,65}]',130,650,'[{1,2460},{5,984}]'),(1,3,107,'[{255,36160004,104}]',208,1040,'[{1,3444},{5,1476}]'),(1,0,108,'[{255,36160004,13}]',26,130,'[{1,870},{5,348}]'),(1,1,108,'[{255,36160004,39}]',78,390,'[{1,1410},{5,564}]'),(1,2,108,'[{255,36160004,65}]',130,650,'[{1,2490},{5,996}]'),(1,3,108,'[{255,36160004,104}]',208,1040,'[{1,3486},{5,1494}]'),(1,0,109,'[{255,36160004,13}]',26,130,'[{1,885},{5,354}]'),(1,1,109,'[{255,36160004,39}]',78,390,'[{1,1430},{5,572}]'),(1,2,109,'[{255,36160004,65}]',130,650,'[{1,2520},{5,1008}]'),(1,3,109,'[{255,36160004,104}]',208,1040,'[{1,3528},{5,1512}]'),(1,0,110,'[{255,36160004,13}]',26,130,'[{1,900},{5,360}]'),(1,1,110,'[{255,36160004,39}]',78,390,'[{1,1450},{5,580}]'),(1,2,110,'[{255,36160004,65}]',130,650,'[{1,2550},{5,1020}]'),(1,3,110,'[{255,36160004,104}]',208,1040,'[{1,3570},{5,1530}]'),(1,0,111,'[{255,36160004,13}]',26,130,'[{1,915},{5,366}]'),(1,1,111,'[{255,36160004,39}]',78,390,'[{1,1470},{5,588}]'),(1,2,111,'[{255,36160004,65}]',130,650,'[{1,2580},{5,1032}]'),(1,3,111,'[{255,36160004,104}]',208,1040,'[{1,3612},{5,1548}]'),(1,0,112,'[{255,36160004,13}]',26,130,'[{1,930},{5,372}]'),(1,1,112,'[{255,36160004,39}]',78,390,'[{1,1490},{5,596}]'),(1,2,112,'[{255,36160004,65}]',130,650,'[{1,2610},{5,1044}]'),(1,3,112,'[{255,36160004,104}]',208,1040,'[{1,3654},{5,1566}]'),(1,0,113,'[{255,36160004,13}]',26,130,'[{1,945},{5,378}]'),(1,1,113,'[{255,36160004,39}]',78,390,'[{1,1510},{5,604}]'),(1,2,113,'[{255,36160004,65}]',130,650,'[{1,2640},{5,1056}]'),(1,3,113,'[{255,36160004,104}]',208,1040,'[{1,3696},{5,1584}]'),(1,0,114,'[{255,36160004,13}]',26,130,'[{1,960},{5,384}]'),(1,1,114,'[{255,36160004,39}]',78,390,'[{1,1530},{5,612}]'),(1,2,114,'[{255,36160004,65}]',130,650,'[{1,2670},{5,1068}]'),(1,3,114,'[{255,36160004,104}]',208,1040,'[{1,3738},{5,1602}]'),(1,0,115,'[{255,36160004,13}]',26,130,'[{1,975},{5,390}]'),(1,1,115,'[{255,36160004,39}]',78,390,'[{1,1550},{5,620}]'),(1,2,115,'[{255,36160004,65}]',130,650,'[{1,2700},{5,1080}]'),(1,3,115,'[{255,36160004,104}]',208,1040,'[{1,3780},{5,1620}]'),(1,0,116,'[{255,36160004,13}]',26,130,'[{1,990},{5,396}]'),(1,1,116,'[{255,36160004,39}]',78,390,'[{1,1570},{5,628}]'),(1,2,116,'[{255,36160004,65}]',130,650,'[{1,2730},{5,1092}]'),(1,3,116,'[{255,36160004,104}]',208,1040,'[{1,3822},{5,1638}]'),(1,0,117,'[{255,36160004,13}]',26,130,'[{1,1005},{5,402}]'),(1,1,117,'[{255,36160004,39}]',78,390,'[{1,1590},{5,636}]'),(1,2,117,'[{255,36160004,65}]',130,650,'[{1,2760},{5,1104}]'),(1,3,117,'[{255,36160004,104}]',208,1040,'[{1,3864},{5,1656}]'),(1,0,118,'[{255,36160004,13}]',26,130,'[{1,1020},{5,408}]'),(1,1,118,'[{255,36160004,39}]',78,390,'[{1,1610},{5,644}]'),(1,2,118,'[{255,36160004,65}]',130,650,'[{1,2790},{5,1116}]'),(1,3,118,'[{255,36160004,104}]',208,1040,'[{1,3906},{5,1674}]'),(1,0,119,'[{255,36160004,13}]',26,130,'[{1,1035},{5,414}]'),(1,1,119,'[{255,36160004,39}]',78,390,'[{1,1630},{5,652}]'),(1,2,119,'[{255,36160004,65}]',130,650,'[{1,2820},{5,1128}]'),(1,3,119,'[{255,36160004,104}]',208,1040,'[{1,3948},{5,1692}]'),(1,0,120,'[{255,36160004,14}]',28,140,'[{1,1050},{5,420}]'),(1,1,120,'[{255,36160004,42}]',84,420,'[{1,1650},{5,660}]'),(1,2,120,'[{255,36160004,70}]',140,700,'[{1,2850},{5,1140}]'),(1,3,120,'[{255,36160004,112}]',224,1120,'[{1,3990},{5,1710}]'),(1,0,121,'[{255,36160004,14}]',28,140,'[{1,1065},{5,426}]'),(1,1,121,'[{255,36160004,42}]',84,420,'[{1,1670},{5,668}]'),(1,2,121,'[{255,36160004,70}]',140,700,'[{1,2880},{5,1152}]'),(1,3,121,'[{255,36160004,112}]',224,1120,'[{1,4032},{5,1728}]'),(1,0,122,'[{255,36160004,14}]',28,140,'[{1,1080},{5,432}]'),(1,1,122,'[{255,36160004,42}]',84,420,'[{1,1690},{5,676}]'),(1,2,122,'[{255,36160004,70}]',140,700,'[{1,2910},{5,1164}]'),(1,3,122,'[{255,36160004,112}]',224,1120,'[{1,4074},{5,1746}]'),(1,0,123,'[{255,36160004,14}]',28,140,'[{1,1095},{5,438}]'),(1,1,123,'[{255,36160004,42}]',84,420,'[{1,1710},{5,684}]'),(1,2,123,'[{255,36160004,70}]',140,700,'[{1,2940},{5,1176}]'),(1,3,123,'[{255,36160004,112}]',224,1120,'[{1,4116},{5,1764}]'),(1,0,124,'[{255,36160004,14}]',28,140,'[{1,1110},{5,444}]'),(1,1,124,'[{255,36160004,42}]',84,420,'[{1,1730},{5,692}]'),(1,2,124,'[{255,36160004,70}]',140,700,'[{1,2970},{5,1188}]'),(1,3,124,'[{255,36160004,112}]',224,1120,'[{1,4158},{5,1782}]'),(1,0,125,'[{255,36160004,14}]',28,140,'[{1,1125},{5,450}]'),(1,1,125,'[{255,36160004,42}]',84,420,'[{1,1750},{5,700}]'),(1,2,125,'[{255,36160004,70}]',140,700,'[{1,3000},{5,1200}]'),(1,3,125,'[{255,36160004,112}]',224,1120,'[{1,4200},{5,1800}]'),(1,0,126,'[{255,36160004,14}]',28,140,'[{1,1140},{5,456}]'),(1,1,126,'[{255,36160004,42}]',84,420,'[{1,1770},{5,708}]'),(1,2,126,'[{255,36160004,70}]',140,700,'[{1,3030},{5,1212}]'),(1,3,126,'[{255,36160004,112}]',224,1120,'[{1,4242},{5,1818}]'),(1,0,127,'[{255,36160004,14}]',28,140,'[{1,1155},{5,462}]'),(1,1,127,'[{255,36160004,42}]',84,420,'[{1,1790},{5,716}]'),(1,2,127,'[{255,36160004,70}]',140,700,'[{1,3060},{5,1224}]'),(1,3,127,'[{255,36160004,112}]',224,1120,'[{1,4284},{5,1836}]'),(1,0,128,'[{255,36160004,14}]',28,140,'[{1,1170},{5,468}]'),(1,1,128,'[{255,36160004,42}]',84,420,'[{1,1810},{5,724}]'),(1,2,128,'[{255,36160004,70}]',140,700,'[{1,3090},{5,1236}]'),(1,3,128,'[{255,36160004,112}]',224,1120,'[{1,4326},{5,1854}]'),(1,0,129,'[{255,36160004,14}]',28,140,'[{1,1185},{5,474}]'),(1,1,129,'[{255,36160004,42}]',84,420,'[{1,1830},{5,732}]'),(1,2,129,'[{255,36160004,70}]',140,700,'[{1,3120},{5,1248}]'),(1,3,129,'[{255,36160004,112}]',224,1120,'[{1,4368},{5,1872}]'),(1,0,130,'[{255,36160004,14}]',28,140,'[{1,1200},{5,480}]'),(1,1,130,'[{255,36160004,42}]',84,420,'[{1,1850},{5,740}]'),(1,2,130,'[{255,36160004,70}]',140,700,'[{1,3150},{5,1260}]'),(1,3,130,'[{255,36160004,112}]',224,1120,'[{1,4410},{5,1890}]'),(1,0,131,'[{255,36160004,14}]',28,140,'[{1,1215},{5,486}]'),(1,1,131,'[{255,36160004,42}]',84,420,'[{1,1870},{5,748}]'),(1,2,131,'[{255,36160004,70}]',140,700,'[{1,3180},{5,1272}]'),(1,3,131,'[{255,36160004,112}]',224,1120,'[{1,4452},{5,1908}]'),(1,0,132,'[{255,36160004,14}]',28,140,'[{1,1230},{5,492}]'),(1,1,132,'[{255,36160004,42}]',84,420,'[{1,1890},{5,756}]'),(1,2,132,'[{255,36160004,70}]',140,700,'[{1,3210},{5,1284}]'),(1,3,132,'[{255,36160004,112}]',224,1120,'[{1,4494},{5,1926}]'),(1,0,133,'[{255,36160004,14}]',28,140,'[{1,1245},{5,498}]'),(1,1,133,'[{255,36160004,42}]',84,420,'[{1,1910},{5,764}]'),(1,2,133,'[{255,36160004,70}]',140,700,'[{1,3240},{5,1296}]'),(1,3,133,'[{255,36160004,112}]',224,1120,'[{1,4536},{5,1944}]'),(1,0,134,'[{255,36160004,14}]',28,140,'[{1,1260},{5,504}]'),(1,1,134,'[{255,36160004,42}]',84,420,'[{1,1930},{5,772}]'),(1,2,134,'[{255,36160004,70}]',140,700,'[{1,3270},{5,1308}]'),(1,3,134,'[{255,36160004,112}]',224,1120,'[{1,4578},{5,1962}]'),(1,0,135,'[{255,36160004,15}]',30,150,'[{1,1275},{5,510}]'),(1,1,135,'[{255,36160004,45}]',90,450,'[{1,1950},{5,780}]'),(1,2,135,'[{255,36160004,75}]',150,750,'[{1,3300},{5,1320}]'),(1,3,135,'[{255,36160004,120}]',240,1200,'[{1,4620},{5,1980}]'),(1,0,136,'[{255,36160004,15}]',30,150,'[{1,1290},{5,516}]'),(1,1,136,'[{255,36160004,45}]',90,450,'[{1,1970},{5,788}]'),(1,2,136,'[{255,36160004,75}]',150,750,'[{1,3330},{5,1332}]'),(1,3,136,'[{255,36160004,120}]',240,1200,'[{1,4662},{5,1998}]'),(1,0,137,'[{255,36160004,15}]',30,150,'[{1,1305},{5,522}]'),(1,1,137,'[{255,36160004,45}]',90,450,'[{1,1990},{5,796}]'),(1,2,137,'[{255,36160004,75}]',150,750,'[{1,3360},{5,1344}]'),(1,3,137,'[{255,36160004,120}]',240,1200,'[{1,4704},{5,2016}]'),(1,0,138,'[{255,36160004,15}]',30,150,'[{1,1320},{5,528}]'),(1,1,138,'[{255,36160004,45}]',90,450,'[{1,2010},{5,804}]'),(1,2,138,'[{255,36160004,75}]',150,750,'[{1,3390},{5,1356}]'),(1,3,138,'[{255,36160004,120}]',240,1200,'[{1,4746},{5,2034}]'),(1,0,139,'[{255,36160004,15}]',30,150,'[{1,1335},{5,534}]'),(1,1,139,'[{255,36160004,45}]',90,450,'[{1,2030},{5,812}]'),(1,2,139,'[{255,36160004,75}]',150,750,'[{1,3420},{5,1368}]'),(1,3,139,'[{255,36160004,120}]',240,1200,'[{1,4788},{5,2052}]'),(1,0,140,'[{255,36160004,15}]',30,150,'[{1,1350},{5,540}]'),(1,1,140,'[{255,36160004,45}]',90,450,'[{1,2050},{5,820}]'),(1,2,140,'[{255,36160004,75}]',150,750,'[{1,3450},{5,1380}]'),(1,3,140,'[{255,36160004,120}]',240,1200,'[{1,4830},{5,2070}]'),(1,0,141,'[{255,36160004,15}]',30,150,'[{1,1365},{5,546}]'),(1,1,141,'[{255,36160004,45}]',90,450,'[{1,2070},{5,828}]'),(1,2,141,'[{255,36160004,75}]',150,750,'[{1,3480},{5,1392}]'),(1,3,141,'[{255,36160004,120}]',240,1200,'[{1,4872},{5,2088}]'),(1,0,142,'[{255,36160004,15}]',30,150,'[{1,1380},{5,552}]'),(1,1,142,'[{255,36160004,45}]',90,450,'[{1,2090},{5,836}]'),(1,2,142,'[{255,36160004,75}]',150,750,'[{1,3510},{5,1404}]'),(1,3,142,'[{255,36160004,120}]',240,1200,'[{1,4914},{5,2106}]'),(1,0,143,'[{255,36160004,15}]',30,150,'[{1,1395},{5,558}]'),(1,1,143,'[{255,36160004,45}]',90,450,'[{1,2110},{5,844}]'),(1,2,143,'[{255,36160004,75}]',150,750,'[{1,3540},{5,1416}]'),(1,3,143,'[{255,36160004,120}]',240,1200,'[{1,4956},{5,2124}]'),(1,0,144,'[{255,36160004,15}]',30,150,'[{1,1410},{5,564}]'),(1,1,144,'[{255,36160004,45}]',90,450,'[{1,2130},{5,852}]'),(1,2,144,'[{255,36160004,75}]',150,750,'[{1,3570},{5,1428}]'),(1,3,144,'[{255,36160004,120}]',240,1200,'[{1,4998},{5,2142}]'),(1,0,145,'[{255,36160004,15}]',30,150,'[{1,1425},{5,570}]'),(1,1,145,'[{255,36160004,45}]',90,450,'[{1,2150},{5,860}]'),(1,2,145,'[{255,36160004,75}]',150,750,'[{1,3600},{5,1440}]'),(1,3,145,'[{255,36160004,120}]',240,1200,'[{1,5040},{5,2160}]'),(1,0,146,'[{255,36160004,15}]',30,150,'[{1,1440},{5,576}]'),(1,1,146,'[{255,36160004,45}]',90,450,'[{1,2170},{5,868}]'),(1,2,146,'[{255,36160004,75}]',150,750,'[{1,3630},{5,1452}]'),(1,3,146,'[{255,36160004,120}]',240,1200,'[{1,5082},{5,2178}]'),(1,0,147,'[{255,36160004,15}]',30,150,'[{1,1455},{5,582}]'),(1,1,147,'[{255,36160004,45}]',90,450,'[{1,2190},{5,876}]'),(1,2,147,'[{255,36160004,75}]',150,750,'[{1,3660},{5,1464}]'),(1,3,147,'[{255,36160004,120}]',240,1200,'[{1,5124},{5,2196}]'),(1,0,148,'[{255,36160004,15}]',30,150,'[{1,1470},{5,588}]'),(1,1,148,'[{255,36160004,45}]',90,450,'[{1,2210},{5,884}]'),(1,2,148,'[{255,36160004,75}]',150,750,'[{1,3690},{5,1476}]'),(1,3,148,'[{255,36160004,120}]',240,1200,'[{1,5166},{5,2214}]'),(1,0,149,'[{255,36160004,15}]',30,150,'[{1,1485},{5,594}]'),(1,1,149,'[{255,36160004,45}]',90,450,'[{1,2230},{5,892}]'),(1,2,149,'[{255,36160004,75}]',150,750,'[{1,3720},{5,1488}]'),(1,3,149,'[{255,36160004,120}]',240,1200,'[{1,5208},{5,2232}]'),(1,0,150,'[{255,36160004,15}]',30,150,'[{1,1500},{5,600}]'),(1,1,150,'[{255,36160004,45}]',90,450,'[{1,2250},{5,900}]'),(1,2,150,'[{255,36160004,75}]',150,750,'[{1,3750},{5,1500}]'),(1,3,150,'[{255,36160004,120}]',240,1200,'[{1,5250},{5,2250}]'),(2,0,0,'[{255,36160004,5}]',10,50,'[{2,0},{6,0}]'),(2,1,0,'[{255,36160004,15}]',30,150,'[{2,0},{6,0}]'),(2,2,0,'[{255,36160004,25}]',50,250,'[{2,0},{6,0}]'),(2,3,0,'[{255,36160004,40}]',80,400,'[{2,0},{6,0}]'),(2,0,1,'[{255,36160004,5}]',10,50,'[{2,100},{6,2}]'),(2,1,1,'[{255,36160004,15}]',30,150,'[{2,200},{6,4}]'),(2,2,1,'[{255,36160004,25}]',50,250,'[{2,400},{6,8}]'),(2,3,1,'[{255,36160004,40}]',80,400,'[{2,560},{6,12}]'),(2,0,2,'[{255,36160004,5}]',10,50,'[{2,200},{6,4}]'),(2,1,2,'[{255,36160004,15}]',30,150,'[{2,400},{6,8}]'),(2,2,2,'[{255,36160004,25}]',50,250,'[{2,800},{6,16}]'),(2,3,2,'[{255,36160004,40}]',80,400,'[{2,1120},{6,24}]'),(2,0,3,'[{255,36160004,5}]',10,50,'[{2,300},{6,6}]'),(2,1,3,'[{255,36160004,15}]',30,150,'[{2,600},{6,12}]'),(2,2,3,'[{255,36160004,25}]',50,250,'[{2,1200},{6,24}]'),(2,3,3,'[{255,36160004,40}]',80,400,'[{2,1680},{6,36}]'),(2,0,4,'[{255,36160004,5}]',10,50,'[{2,400},{6,8}]'),(2,1,4,'[{255,36160004,15}]',30,150,'[{2,800},{6,16}]'),(2,2,4,'[{255,36160004,25}]',50,250,'[{2,1600},{6,32}]'),(2,3,4,'[{255,36160004,40}]',80,400,'[{2,2240},{6,48}]'),(2,0,5,'[{255,36160004,5}]',10,50,'[{2,500},{6,10}]'),(2,1,5,'[{255,36160004,15}]',30,150,'[{2,1000},{6,20}]'),(2,2,5,'[{255,36160004,25}]',50,250,'[{2,2000},{6,40}]'),(2,3,5,'[{255,36160004,40}]',80,400,'[{2,2800},{6,60}]'),(2,0,6,'[{255,36160004,5}]',10,50,'[{2,600},{6,12}]'),(2,1,6,'[{255,36160004,15}]',30,150,'[{2,1200},{6,24}]'),(2,2,6,'[{255,36160004,25}]',50,250,'[{2,2400},{6,48}]'),(2,3,6,'[{255,36160004,40}]',80,400,'[{2,3360},{6,72}]'),(2,0,7,'[{255,36160004,5}]',10,50,'[{2,700},{6,14}]'),(2,1,7,'[{255,36160004,15}]',30,150,'[{2,1400},{6,28}]'),(2,2,7,'[{255,36160004,25}]',50,250,'[{2,2800},{6,56}]'),(2,3,7,'[{255,36160004,40}]',80,400,'[{2,3920},{6,84}]'),(2,0,8,'[{255,36160004,5}]',10,50,'[{2,800},{6,16}]'),(2,1,8,'[{255,36160004,15}]',30,150,'[{2,1600},{6,32}]'),(2,2,8,'[{255,36160004,25}]',50,250,'[{2,3200},{6,64}]'),(2,3,8,'[{255,36160004,40}]',80,400,'[{2,4480},{6,96}]'),(2,0,9,'[{255,36160004,5}]',10,50,'[{2,900},{6,18}]'),(2,1,9,'[{255,36160004,15}]',30,150,'[{2,1800},{6,36}]'),(2,2,9,'[{255,36160004,25}]',50,250,'[{2,3600},{6,72}]'),(2,3,9,'[{255,36160004,40}]',80,400,'[{2,5040},{6,108}]'),(2,0,10,'[{255,36160004,6}]',12,60,'[{2,1000},{6,20}]'),(2,1,10,'[{255,36160004,18}]',36,180,'[{2,2000},{6,40}]'),(2,2,10,'[{255,36160004,30}]',60,300,'[{2,4000},{6,80}]'),(2,3,10,'[{255,36160004,48}]',96,480,'[{2,5600},{6,120}]'),(2,0,11,'[{255,36160004,6}]',12,60,'[{2,1100},{6,22}]'),(2,1,11,'[{255,36160004,18}]',36,180,'[{2,2200},{6,44}]'),(2,2,11,'[{255,36160004,30}]',60,300,'[{2,4400},{6,88}]'),(2,3,11,'[{255,36160004,48}]',96,480,'[{2,6160},{6,132}]'),(2,0,12,'[{255,36160004,6}]',12,60,'[{2,1200},{6,24}]'),(2,1,12,'[{255,36160004,18}]',36,180,'[{2,2400},{6,48}]'),(2,2,12,'[{255,36160004,30}]',60,300,'[{2,4800},{6,96}]'),(2,3,12,'[{255,36160004,48}]',96,480,'[{2,6720},{6,144}]'),(2,0,13,'[{255,36160004,6}]',12,60,'[{2,1300},{6,26}]'),(2,1,13,'[{255,36160004,18}]',36,180,'[{2,2600},{6,52}]'),(2,2,13,'[{255,36160004,30}]',60,300,'[{2,5200},{6,104}]'),(2,3,13,'[{255,36160004,48}]',96,480,'[{2,7280},{6,156}]'),(2,0,14,'[{255,36160004,6}]',12,60,'[{2,1400},{6,28}]'),(2,1,14,'[{255,36160004,18}]',36,180,'[{2,2800},{6,56}]'),(2,2,14,'[{255,36160004,30}]',60,300,'[{2,5600},{6,112}]'),(2,3,14,'[{255,36160004,48}]',96,480,'[{2,7840},{6,168}]'),(2,0,15,'[{255,36160004,6}]',12,60,'[{2,1500},{6,30}]'),(2,1,15,'[{255,36160004,18}]',36,180,'[{2,3000},{6,60}]'),(2,2,15,'[{255,36160004,30}]',60,300,'[{2,6000},{6,120}]'),(2,3,15,'[{255,36160004,48}]',96,480,'[{2,8400},{6,180}]'),(2,0,16,'[{255,36160004,6}]',12,60,'[{2,1600},{6,32}]'),(2,1,16,'[{255,36160004,18}]',36,180,'[{2,3200},{6,64}]'),(2,2,16,'[{255,36160004,30}]',60,300,'[{2,6400},{6,128}]'),(2,3,16,'[{255,36160004,48}]',96,480,'[{2,8960},{6,192}]'),(2,0,17,'[{255,36160004,6}]',12,60,'[{2,1700},{6,34}]'),(2,1,17,'[{255,36160004,18}]',36,180,'[{2,3400},{6,68}]'),(2,2,17,'[{255,36160004,30}]',60,300,'[{2,6800},{6,136}]'),(2,3,17,'[{255,36160004,48}]',96,480,'[{2,9520},{6,204}]'),(2,0,18,'[{255,36160004,6}]',12,60,'[{2,1800},{6,36}]'),(2,1,18,'[{255,36160004,18}]',36,180,'[{2,3600},{6,72}]'),(2,2,18,'[{255,36160004,30}]',60,300,'[{2,7200},{6,144}]'),(2,3,18,'[{255,36160004,48}]',96,480,'[{2,10080},{6,216}]'),(2,0,19,'[{255,36160004,6}]',12,60,'[{2,1900},{6,38}]'),(2,1,19,'[{255,36160004,18}]',36,180,'[{2,3800},{6,76}]'),(2,2,19,'[{255,36160004,30}]',60,300,'[{2,7600},{6,152}]'),(2,3,19,'[{255,36160004,48}]',96,480,'[{2,10640},{6,228}]'),(2,0,20,'[{255,36160004,7}]',14,70,'[{2,2000},{6,40}]'),(2,1,20,'[{255,36160004,21}]',42,210,'[{2,4000},{6,80}]'),(2,2,20,'[{255,36160004,35}]',70,350,'[{2,8000},{6,160}]'),(2,3,20,'[{255,36160004,56}]',112,560,'[{2,11200},{6,240}]'),(2,0,21,'[{255,36160004,7}]',14,70,'[{2,2100},{6,42}]'),(2,1,21,'[{255,36160004,21}]',42,210,'[{2,4200},{6,84}]'),(2,2,21,'[{255,36160004,35}]',70,350,'[{2,8400},{6,168}]'),(2,3,21,'[{255,36160004,56}]',112,560,'[{2,11760},{6,252}]'),(2,0,22,'[{255,36160004,7}]',14,70,'[{2,2200},{6,44}]'),(2,1,22,'[{255,36160004,21}]',42,210,'[{2,4400},{6,88}]'),(2,2,22,'[{255,36160004,35}]',70,350,'[{2,8800},{6,176}]'),(2,3,22,'[{255,36160004,56}]',112,560,'[{2,12320},{6,264}]'),(2,0,23,'[{255,36160004,7}]',14,70,'[{2,2300},{6,46}]'),(2,1,23,'[{255,36160004,21}]',42,210,'[{2,4600},{6,92}]'),(2,2,23,'[{255,36160004,35}]',70,350,'[{2,9200},{6,184}]'),(2,3,23,'[{255,36160004,56}]',112,560,'[{2,12880},{6,276}]'),(2,0,24,'[{255,36160004,7}]',14,70,'[{2,2400},{6,48}]'),(2,1,24,'[{255,36160004,21}]',42,210,'[{2,4800},{6,96}]'),(2,2,24,'[{255,36160004,35}]',70,350,'[{2,9600},{6,192}]'),(2,3,24,'[{255,36160004,56}]',112,560,'[{2,13440},{6,288}]'),(2,0,25,'[{255,36160004,7}]',14,70,'[{2,2500},{6,50}]'),(2,1,25,'[{255,36160004,21}]',42,210,'[{2,5000},{6,100}]'),(2,2,25,'[{255,36160004,35}]',70,350,'[{2,10000},{6,200}]'),(2,3,25,'[{255,36160004,56}]',112,560,'[{2,14000},{6,300}]'),(2,0,26,'[{255,36160004,7}]',14,70,'[{2,2600},{6,52}]'),(2,1,26,'[{255,36160004,21}]',42,210,'[{2,5200},{6,104}]'),(2,2,26,'[{255,36160004,35}]',70,350,'[{2,10400},{6,208}]'),(2,3,26,'[{255,36160004,56}]',112,560,'[{2,14560},{6,312}]'),(2,0,27,'[{255,36160004,7}]',14,70,'[{2,2700},{6,54}]'),(2,1,27,'[{255,36160004,21}]',42,210,'[{2,5400},{6,108}]'),(2,2,27,'[{255,36160004,35}]',70,350,'[{2,10800},{6,216}]'),(2,3,27,'[{255,36160004,56}]',112,560,'[{2,15120},{6,324}]'),(2,0,28,'[{255,36160004,7}]',14,70,'[{2,2800},{6,56}]'),(2,1,28,'[{255,36160004,21}]',42,210,'[{2,5600},{6,112}]'),(2,2,28,'[{255,36160004,35}]',70,350,'[{2,11200},{6,224}]'),(2,3,28,'[{255,36160004,56}]',112,560,'[{2,15680},{6,336}]'),(2,0,29,'[{255,36160004,7}]',14,70,'[{2,2900},{6,58}]'),(2,1,29,'[{255,36160004,21}]',42,210,'[{2,5800},{6,116}]'),(2,2,29,'[{255,36160004,35}]',70,350,'[{2,11600},{6,232}]'),(2,3,29,'[{255,36160004,56}]',112,560,'[{2,16240},{6,348}]'),(2,0,30,'[{255,36160004,8}]',16,80,'[{2,3000},{6,60}]'),(2,1,30,'[{255,36160004,24}]',48,240,'[{2,6000},{6,120}]'),(2,2,30,'[{255,36160004,40}]',80,400,'[{2,12000},{6,240}]'),(2,3,30,'[{255,36160004,64}]',128,640,'[{2,16800},{6,360}]'),(2,0,31,'[{255,36160004,8}]',16,80,'[{2,3100},{6,62}]'),(2,1,31,'[{255,36160004,24}]',48,240,'[{2,6200},{6,124}]'),(2,2,31,'[{255,36160004,40}]',80,400,'[{2,12400},{6,248}]'),(2,3,31,'[{255,36160004,64}]',128,640,'[{2,17360},{6,372}]'),(2,0,32,'[{255,36160004,8}]',16,80,'[{2,3200},{6,64}]'),(2,1,32,'[{255,36160004,24}]',48,240,'[{2,6400},{6,128}]'),(2,2,32,'[{255,36160004,40}]',80,400,'[{2,12800},{6,256}]'),(2,3,32,'[{255,36160004,64}]',128,640,'[{2,17920},{6,384}]'),(2,0,33,'[{255,36160004,8}]',16,80,'[{2,3300},{6,66}]'),(2,1,33,'[{255,36160004,24}]',48,240,'[{2,6600},{6,132}]'),(2,2,33,'[{255,36160004,40}]',80,400,'[{2,13200},{6,264}]'),(2,3,33,'[{255,36160004,64}]',128,640,'[{2,18480},{6,396}]'),(2,0,34,'[{255,36160004,8}]',16,80,'[{2,3400},{6,68}]'),(2,1,34,'[{255,36160004,24}]',48,240,'[{2,6800},{6,136}]'),(2,2,34,'[{255,36160004,40}]',80,400,'[{2,13600},{6,272}]'),(2,3,34,'[{255,36160004,64}]',128,640,'[{2,19040},{6,408}]'),(2,0,35,'[{255,36160004,8}]',16,80,'[{2,3500},{6,70}]'),(2,1,35,'[{255,36160004,24}]',48,240,'[{2,7000},{6,140}]'),(2,2,35,'[{255,36160004,40}]',80,400,'[{2,14000},{6,280}]'),(2,3,35,'[{255,36160004,64}]',128,640,'[{2,19600},{6,420}]'),(2,0,36,'[{255,36160004,8}]',16,80,'[{2,3600},{6,72}]'),(2,1,36,'[{255,36160004,24}]',48,240,'[{2,7200},{6,144}]'),(2,2,36,'[{255,36160004,40}]',80,400,'[{2,14400},{6,288}]'),(2,3,36,'[{255,36160004,64}]',128,640,'[{2,20160},{6,432}]'),(2,0,37,'[{255,36160004,8}]',16,80,'[{2,3700},{6,74}]'),(2,1,37,'[{255,36160004,24}]',48,240,'[{2,7400},{6,148}]'),(2,2,37,'[{255,36160004,40}]',80,400,'[{2,14800},{6,296}]'),(2,3,37,'[{255,36160004,64}]',128,640,'[{2,20720},{6,444}]'),(2,0,38,'[{255,36160004,8}]',16,80,'[{2,3800},{6,76}]'),(2,1,38,'[{255,36160004,24}]',48,240,'[{2,7600},{6,152}]'),(2,2,38,'[{255,36160004,40}]',80,400,'[{2,15200},{6,304}]'),(2,3,38,'[{255,36160004,64}]',128,640,'[{2,21280},{6,456}]'),(2,0,39,'[{255,36160004,8}]',16,80,'[{2,3900},{6,78}]'),(2,1,39,'[{255,36160004,24}]',48,240,'[{2,7800},{6,156}]'),(2,2,39,'[{255,36160004,40}]',80,400,'[{2,15600},{6,312}]'),(2,3,39,'[{255,36160004,64}]',128,640,'[{2,21840},{6,468}]'),(2,0,40,'[{255,36160004,8}]',16,80,'[{2,4000},{6,80}]'),(2,1,40,'[{255,36160004,24}]',48,240,'[{2,8000},{6,160}]'),(2,2,40,'[{255,36160004,40}]',80,400,'[{2,16000},{6,320}]'),(2,3,40,'[{255,36160004,64}]',128,640,'[{2,22400},{6,480}]'),(2,0,41,'[{255,36160004,8}]',16,80,'[{2,4100},{6,82}]'),(2,1,41,'[{255,36160004,24}]',48,240,'[{2,8200},{6,164}]'),(2,2,41,'[{255,36160004,40}]',80,400,'[{2,16400},{6,328}]'),(2,3,41,'[{255,36160004,64}]',128,640,'[{2,22960},{6,492}]'),(2,0,42,'[{255,36160004,8}]',16,80,'[{2,4200},{6,84}]'),(2,1,42,'[{255,36160004,24}]',48,240,'[{2,8400},{6,168}]'),(2,2,42,'[{255,36160004,40}]',80,400,'[{2,16800},{6,336}]'),(2,3,42,'[{255,36160004,64}]',128,640,'[{2,23520},{6,504}]'),(2,0,43,'[{255,36160004,8}]',16,80,'[{2,4300},{6,86}]'),(2,1,43,'[{255,36160004,24}]',48,240,'[{2,8600},{6,172}]'),(2,2,43,'[{255,36160004,40}]',80,400,'[{2,17200},{6,344}]'),(2,3,43,'[{255,36160004,64}]',128,640,'[{2,24080},{6,516}]'),(2,0,44,'[{255,36160004,8}]',16,80,'[{2,4400},{6,88}]'),(2,1,44,'[{255,36160004,24}]',48,240,'[{2,8800},{6,176}]'),(2,2,44,'[{255,36160004,40}]',80,400,'[{2,17600},{6,352}]'),(2,3,44,'[{255,36160004,64}]',128,640,'[{2,24640},{6,528}]'),(2,0,45,'[{255,36160004,9}]',18,90,'[{2,4500},{6,90}]'),(2,1,45,'[{255,36160004,27}]',54,270,'[{2,9000},{6,180}]'),(2,2,45,'[{255,36160004,45}]',90,450,'[{2,18000},{6,360}]'),(2,3,45,'[{255,36160004,72}]',144,720,'[{2,25200},{6,540}]'),(2,0,46,'[{255,36160004,9}]',18,90,'[{2,4600},{6,92}]'),(2,1,46,'[{255,36160004,27}]',54,270,'[{2,9200},{6,184}]'),(2,2,46,'[{255,36160004,45}]',90,450,'[{2,18400},{6,368}]'),(2,3,46,'[{255,36160004,72}]',144,720,'[{2,25760},{6,552}]'),(2,0,47,'[{255,36160004,9}]',18,90,'[{2,4700},{6,94}]'),(2,1,47,'[{255,36160004,27}]',54,270,'[{2,9400},{6,188}]'),(2,2,47,'[{255,36160004,45}]',90,450,'[{2,18800},{6,376}]'),(2,3,47,'[{255,36160004,72}]',144,720,'[{2,26320},{6,564}]'),(2,0,48,'[{255,36160004,9}]',18,90,'[{2,4800},{6,96}]'),(2,1,48,'[{255,36160004,27}]',54,270,'[{2,9600},{6,192}]'),(2,2,48,'[{255,36160004,45}]',90,450,'[{2,19200},{6,384}]'),(2,3,48,'[{255,36160004,72}]',144,720,'[{2,26880},{6,576}]'),(2,0,49,'[{255,36160004,9}]',18,90,'[{2,4900},{6,98}]'),(2,1,49,'[{255,36160004,27}]',54,270,'[{2,9800},{6,196}]'),(2,2,49,'[{255,36160004,45}]',90,450,'[{2,19600},{6,392}]'),(2,3,49,'[{255,36160004,72}]',144,720,'[{2,27440},{6,588}]'),(2,0,50,'[{255,36160004,9}]',18,90,'[{2,5000},{6,100}]'),(2,1,50,'[{255,36160004,27}]',54,270,'[{2,10000},{6,200}]'),(2,2,50,'[{255,36160004,45}]',90,450,'[{2,20000},{6,400}]'),(2,3,50,'[{255,36160004,72}]',144,720,'[{2,28000},{6,600}]'),(2,0,51,'[{255,36160004,9}]',18,90,'[{2,5200},{6,104}]'),(2,1,51,'[{255,36160004,27}]',54,270,'[{2,10300},{6,206}]'),(2,2,51,'[{255,36160004,45}]',90,450,'[{2,20500},{6,410}]'),(2,3,51,'[{255,36160004,72}]',144,720,'[{2,28700},{6,615}]'),(2,0,52,'[{255,36160004,9}]',18,90,'[{2,5400},{6,108}]'),(2,1,52,'[{255,36160004,27}]',54,270,'[{2,10600},{6,212}]'),(2,2,52,'[{255,36160004,45}]',90,450,'[{2,21000},{6,420}]'),(2,3,52,'[{255,36160004,72}]',144,720,'[{2,29400},{6,630}]'),(2,0,53,'[{255,36160004,9}]',18,90,'[{2,5600},{6,112}]'),(2,1,53,'[{255,36160004,27}]',54,270,'[{2,10900},{6,218}]'),(2,2,53,'[{255,36160004,45}]',90,450,'[{2,21500},{6,430}]'),(2,3,53,'[{255,36160004,72}]',144,720,'[{2,30100},{6,645}]'),(2,0,54,'[{255,36160004,9}]',18,90,'[{2,5800},{6,116}]'),(2,1,54,'[{255,36160004,27}]',54,270,'[{2,11200},{6,224}]'),(2,2,54,'[{255,36160004,45}]',90,450,'[{2,22000},{6,440}]'),(2,3,54,'[{255,36160004,72}]',144,720,'[{2,30800},{6,660}]'),(2,0,55,'[{255,36160004,9}]',18,90,'[{2,6000},{6,120}]'),(2,1,55,'[{255,36160004,27}]',54,270,'[{2,11500},{6,230}]'),(2,2,55,'[{255,36160004,45}]',90,450,'[{2,22500},{6,450}]'),(2,3,55,'[{255,36160004,72}]',144,720,'[{2,31500},{6,675}]'),(2,0,56,'[{255,36160004,9}]',18,90,'[{2,6200},{6,124}]'),(2,1,56,'[{255,36160004,27}]',54,270,'[{2,11800},{6,236}]'),(2,2,56,'[{255,36160004,45}]',90,450,'[{2,23000},{6,460}]'),(2,3,56,'[{255,36160004,72}]',144,720,'[{2,32200},{6,690}]'),(2,0,57,'[{255,36160004,9}]',18,90,'[{2,6400},{6,128}]'),(2,1,57,'[{255,36160004,27}]',54,270,'[{2,12100},{6,242}]'),(2,2,57,'[{255,36160004,45}]',90,450,'[{2,23500},{6,470}]'),(2,3,57,'[{255,36160004,72}]',144,720,'[{2,32900},{6,705}]'),(2,0,58,'[{255,36160004,9}]',18,90,'[{2,6600},{6,132}]'),(2,1,58,'[{255,36160004,27}]',54,270,'[{2,12400},{6,248}]'),(2,2,58,'[{255,36160004,45}]',90,450,'[{2,24000},{6,480}]'),(2,3,58,'[{255,36160004,72}]',144,720,'[{2,33600},{6,720}]'),(2,0,59,'[{255,36160004,9}]',18,90,'[{2,6800},{6,136}]'),(2,1,59,'[{255,36160004,27}]',54,270,'[{2,12700},{6,254}]'),(2,2,59,'[{255,36160004,45}]',90,450,'[{2,24500},{6,490}]'),(2,3,59,'[{255,36160004,72}]',144,720,'[{2,34300},{6,735}]'),(2,0,60,'[{255,36160004,10}]',20,100,'[{2,7000},{6,140}]'),(2,1,60,'[{255,36160004,30}]',60,300,'[{2,13000},{6,260}]'),(2,2,60,'[{255,36160004,50}]',100,500,'[{2,25000},{6,500}]'),(2,3,60,'[{255,36160004,80}]',160,800,'[{2,35000},{6,750}]'),(2,0,61,'[{255,36160004,10}]',20,100,'[{2,7200},{6,144}]'),(2,1,61,'[{255,36160004,30}]',60,300,'[{2,13300},{6,266}]'),(2,2,61,'[{255,36160004,50}]',100,500,'[{2,25500},{6,510}]'),(2,3,61,'[{255,36160004,80}]',160,800,'[{2,35700},{6,765}]'),(2,0,62,'[{255,36160004,10}]',20,100,'[{2,7400},{6,148}]'),(2,1,62,'[{255,36160004,30}]',60,300,'[{2,13600},{6,272}]'),(2,2,62,'[{255,36160004,50}]',100,500,'[{2,26000},{6,520}]'),(2,3,62,'[{255,36160004,80}]',160,800,'[{2,36400},{6,780}]'),(2,0,63,'[{255,36160004,10}]',20,100,'[{2,7600},{6,152}]'),(2,1,63,'[{255,36160004,30}]',60,300,'[{2,13900},{6,278}]'),(2,2,63,'[{255,36160004,50}]',100,500,'[{2,26500},{6,530}]'),(2,3,63,'[{255,36160004,80}]',160,800,'[{2,37100},{6,795}]'),(2,0,64,'[{255,36160004,10}]',20,100,'[{2,7800},{6,156}]'),(2,1,64,'[{255,36160004,30}]',60,300,'[{2,14200},{6,284}]'),(2,2,64,'[{255,36160004,50}]',100,500,'[{2,27000},{6,540}]'),(2,3,64,'[{255,36160004,80}]',160,800,'[{2,37800},{6,810}]'),(2,0,65,'[{255,36160004,10}]',20,100,'[{2,8000},{6,160}]'),(2,1,65,'[{255,36160004,30}]',60,300,'[{2,14500},{6,290}]'),(2,2,65,'[{255,36160004,50}]',100,500,'[{2,27500},{6,550}]'),(2,3,65,'[{255,36160004,80}]',160,800,'[{2,38500},{6,825}]'),(2,0,66,'[{255,36160004,10}]',20,100,'[{2,8200},{6,164}]'),(2,1,66,'[{255,36160004,30}]',60,300,'[{2,14800},{6,296}]'),(2,2,66,'[{255,36160004,50}]',100,500,'[{2,28000},{6,560}]'),(2,3,66,'[{255,36160004,80}]',160,800,'[{2,39200},{6,840}]'),(2,0,67,'[{255,36160004,10}]',20,100,'[{2,8400},{6,168}]'),(2,1,67,'[{255,36160004,30}]',60,300,'[{2,15100},{6,302}]'),(2,2,67,'[{255,36160004,50}]',100,500,'[{2,28500},{6,570}]'),(2,3,67,'[{255,36160004,80}]',160,800,'[{2,39900},{6,855}]'),(2,0,68,'[{255,36160004,10}]',20,100,'[{2,8600},{6,172}]'),(2,1,68,'[{255,36160004,30}]',60,300,'[{2,15400},{6,308}]'),(2,2,68,'[{255,36160004,50}]',100,500,'[{2,29000},{6,580}]'),(2,3,68,'[{255,36160004,80}]',160,800,'[{2,40600},{6,870}]'),(2,0,69,'[{255,36160004,10}]',20,100,'[{2,8800},{6,176}]'),(2,1,69,'[{255,36160004,30}]',60,300,'[{2,15700},{6,314}]'),(2,2,69,'[{255,36160004,50}]',100,500,'[{2,29500},{6,590}]'),(2,3,69,'[{255,36160004,80}]',160,800,'[{2,41300},{6,885}]'),(2,0,70,'[{255,36160004,10}]',20,100,'[{2,9000},{6,180}]'),(2,1,70,'[{255,36160004,30}]',60,300,'[{2,16000},{6,320}]'),(2,2,70,'[{255,36160004,50}]',100,500,'[{2,30000},{6,600}]'),(2,3,70,'[{255,36160004,80}]',160,800,'[{2,42000},{6,900}]'),(2,0,71,'[{255,36160004,10}]',20,100,'[{2,9200},{6,184}]'),(2,1,71,'[{255,36160004,30}]',60,300,'[{2,16300},{6,326}]'),(2,2,71,'[{255,36160004,50}]',100,500,'[{2,30500},{6,610}]'),(2,3,71,'[{255,36160004,80}]',160,800,'[{2,42700},{6,915}]'),(2,0,72,'[{255,36160004,10}]',20,100,'[{2,9400},{6,188}]'),(2,1,72,'[{255,36160004,30}]',60,300,'[{2,16600},{6,332}]'),(2,2,72,'[{255,36160004,50}]',100,500,'[{2,31000},{6,620}]'),(2,3,72,'[{255,36160004,80}]',160,800,'[{2,43400},{6,930}]'),(2,0,73,'[{255,36160004,10}]',20,100,'[{2,9600},{6,192}]'),(2,1,73,'[{255,36160004,30}]',60,300,'[{2,16900},{6,338}]'),(2,2,73,'[{255,36160004,50}]',100,500,'[{2,31500},{6,630}]'),(2,3,73,'[{255,36160004,80}]',160,800,'[{2,44100},{6,945}]'),(2,0,74,'[{255,36160004,10}]',20,100,'[{2,9800},{6,196}]'),(2,1,74,'[{255,36160004,30}]',60,300,'[{2,17200},{6,344}]'),(2,2,74,'[{255,36160004,50}]',100,500,'[{2,32000},{6,640}]'),(2,3,74,'[{255,36160004,80}]',160,800,'[{2,44800},{6,960}]'),(2,0,75,'[{255,36160004,11}]',22,110,'[{2,10000},{6,200}]'),(2,1,75,'[{255,36160004,33}]',66,330,'[{2,17500},{6,350}]'),(2,2,75,'[{255,36160004,55}]',110,550,'[{2,32500},{6,650}]'),(2,3,75,'[{255,36160004,88}]',176,880,'[{2,45500},{6,975}]'),(2,0,76,'[{255,36160004,11}]',22,110,'[{2,10200},{6,204}]'),(2,1,76,'[{255,36160004,33}]',66,330,'[{2,17800},{6,356}]'),(2,2,76,'[{255,36160004,55}]',110,550,'[{2,33000},{6,660}]'),(2,3,76,'[{255,36160004,88}]',176,880,'[{2,46200},{6,990}]'),(2,0,77,'[{255,36160004,11}]',22,110,'[{2,10400},{6,208}]'),(2,1,77,'[{255,36160004,33}]',66,330,'[{2,18100},{6,362}]'),(2,2,77,'[{255,36160004,55}]',110,550,'[{2,33500},{6,670}]'),(2,3,77,'[{255,36160004,88}]',176,880,'[{2,46900},{6,1005}]'),(2,0,78,'[{255,36160004,11}]',22,110,'[{2,10600},{6,212}]'),(2,1,78,'[{255,36160004,33}]',66,330,'[{2,18400},{6,368}]'),(2,2,78,'[{255,36160004,55}]',110,550,'[{2,34000},{6,680}]'),(2,3,78,'[{255,36160004,88}]',176,880,'[{2,47600},{6,1020}]'),(2,0,79,'[{255,36160004,11}]',22,110,'[{2,10800},{6,216}]'),(2,1,79,'[{255,36160004,33}]',66,330,'[{2,18700},{6,374}]'),(2,2,79,'[{255,36160004,55}]',110,550,'[{2,34500},{6,690}]'),(2,3,79,'[{255,36160004,88}]',176,880,'[{2,48300},{6,1035}]'),(2,0,80,'[{255,36160004,11}]',22,110,'[{2,11000},{6,220}]'),(2,1,80,'[{255,36160004,33}]',66,330,'[{2,19000},{6,380}]'),(2,2,80,'[{255,36160004,55}]',110,550,'[{2,35000},{6,700}]'),(2,3,80,'[{255,36160004,88}]',176,880,'[{2,49000},{6,1050}]'),(2,0,81,'[{255,36160004,11}]',22,110,'[{2,11200},{6,224}]'),(2,1,81,'[{255,36160004,33}]',66,330,'[{2,19300},{6,386}]'),(2,2,81,'[{255,36160004,55}]',110,550,'[{2,35500},{6,710}]'),(2,3,81,'[{255,36160004,88}]',176,880,'[{2,49700},{6,1065}]'),(2,0,82,'[{255,36160004,11}]',22,110,'[{2,11400},{6,228}]'),(2,1,82,'[{255,36160004,33}]',66,330,'[{2,19600},{6,392}]'),(2,2,82,'[{255,36160004,55}]',110,550,'[{2,36000},{6,720}]'),(2,3,82,'[{255,36160004,88}]',176,880,'[{2,50400},{6,1080}]'),(2,0,83,'[{255,36160004,11}]',22,110,'[{2,11600},{6,232}]'),(2,1,83,'[{255,36160004,33}]',66,330,'[{2,19900},{6,398}]'),(2,2,83,'[{255,36160004,55}]',110,550,'[{2,36500},{6,730}]'),(2,3,83,'[{255,36160004,88}]',176,880,'[{2,51100},{6,1095}]'),(2,0,84,'[{255,36160004,11}]',22,110,'[{2,11800},{6,236}]'),(2,1,84,'[{255,36160004,33}]',66,330,'[{2,20200},{6,404}]'),(2,2,84,'[{255,36160004,55}]',110,550,'[{2,37000},{6,740}]'),(2,3,84,'[{255,36160004,88}]',176,880,'[{2,51800},{6,1110}]'),(2,0,85,'[{255,36160004,11}]',22,110,'[{2,12000},{6,240}]'),(2,1,85,'[{255,36160004,33}]',66,330,'[{2,20500},{6,410}]'),(2,2,85,'[{255,36160004,55}]',110,550,'[{2,37500},{6,750}]'),(2,3,85,'[{255,36160004,88}]',176,880,'[{2,52500},{6,1125}]'),(2,0,86,'[{255,36160004,11}]',22,110,'[{2,12200},{6,244}]'),(2,1,86,'[{255,36160004,33}]',66,330,'[{2,20800},{6,416}]'),(2,2,86,'[{255,36160004,55}]',110,550,'[{2,38000},{6,760}]'),(2,3,86,'[{255,36160004,88}]',176,880,'[{2,53200},{6,1140}]'),(2,0,87,'[{255,36160004,11}]',22,110,'[{2,12400},{6,248}]'),(2,1,87,'[{255,36160004,33}]',66,330,'[{2,21100},{6,422}]'),(2,2,87,'[{255,36160004,55}]',110,550,'[{2,38500},{6,770}]'),(2,3,87,'[{255,36160004,88}]',176,880,'[{2,53900},{6,1155}]'),(2,0,88,'[{255,36160004,11}]',22,110,'[{2,12600},{6,252}]'),(2,1,88,'[{255,36160004,33}]',66,330,'[{2,21400},{6,428}]'),(2,2,88,'[{255,36160004,55}]',110,550,'[{2,39000},{6,780}]'),(2,3,88,'[{255,36160004,88}]',176,880,'[{2,54600},{6,1170}]'),(2,0,89,'[{255,36160004,11}]',22,110,'[{2,12800},{6,256}]'),(2,1,89,'[{255,36160004,33}]',66,330,'[{2,21700},{6,434}]'),(2,2,89,'[{255,36160004,55}]',110,550,'[{2,39500},{6,790}]'),(2,3,89,'[{255,36160004,88}]',176,880,'[{2,55300},{6,1185}]'),(2,0,90,'[{255,36160004,12}]',24,120,'[{2,13000},{6,260}]'),(2,1,90,'[{255,36160004,36}]',72,360,'[{2,22000},{6,440}]'),(2,2,90,'[{255,36160004,60}]',120,600,'[{2,40000},{6,800}]'),(2,3,90,'[{255,36160004,96}]',192,960,'[{2,56000},{6,1200}]'),(2,0,91,'[{255,36160004,12}]',24,120,'[{2,13200},{6,264}]'),(2,1,91,'[{255,36160004,36}]',72,360,'[{2,22300},{6,446}]'),(2,2,91,'[{255,36160004,60}]',120,600,'[{2,40500},{6,810}]'),(2,3,91,'[{255,36160004,96}]',192,960,'[{2,56700},{6,1215}]'),(2,0,92,'[{255,36160004,12}]',24,120,'[{2,13400},{6,268}]'),(2,1,92,'[{255,36160004,36}]',72,360,'[{2,22600},{6,452}]'),(2,2,92,'[{255,36160004,60}]',120,600,'[{2,41000},{6,820}]'),(2,3,92,'[{255,36160004,96}]',192,960,'[{2,57400},{6,1230}]'),(2,0,93,'[{255,36160004,12}]',24,120,'[{2,13600},{6,272}]'),(2,1,93,'[{255,36160004,36}]',72,360,'[{2,22900},{6,458}]'),(2,2,93,'[{255,36160004,60}]',120,600,'[{2,41500},{6,830}]'),(2,3,93,'[{255,36160004,96}]',192,960,'[{2,58100},{6,1245}]'),(2,0,94,'[{255,36160004,12}]',24,120,'[{2,13800},{6,276}]'),(2,1,94,'[{255,36160004,36}]',72,360,'[{2,23200},{6,464}]'),(2,2,94,'[{255,36160004,60}]',120,600,'[{2,42000},{6,840}]'),(2,3,94,'[{255,36160004,96}]',192,960,'[{2,58800},{6,1260}]'),(2,0,95,'[{255,36160004,12}]',24,120,'[{2,14000},{6,280}]'),(2,1,95,'[{255,36160004,36}]',72,360,'[{2,23500},{6,470}]'),(2,2,95,'[{255,36160004,60}]',120,600,'[{2,42500},{6,850}]'),(2,3,95,'[{255,36160004,96}]',192,960,'[{2,59500},{6,1275}]'),(2,0,96,'[{255,36160004,12}]',24,120,'[{2,14200},{6,284}]'),(2,1,96,'[{255,36160004,36}]',72,360,'[{2,23800},{6,476}]'),(2,2,96,'[{255,36160004,60}]',120,600,'[{2,43000},{6,860}]'),(2,3,96,'[{255,36160004,96}]',192,960,'[{2,60200},{6,1290}]'),(2,0,97,'[{255,36160004,12}]',24,120,'[{2,14400},{6,288}]'),(2,1,97,'[{255,36160004,36}]',72,360,'[{2,24100},{6,482}]'),(2,2,97,'[{255,36160004,60}]',120,600,'[{2,43500},{6,870}]'),(2,3,97,'[{255,36160004,96}]',192,960,'[{2,60900},{6,1305}]'),(2,0,98,'[{255,36160004,12}]',24,120,'[{2,14600},{6,292}]'),(2,1,98,'[{255,36160004,36}]',72,360,'[{2,24400},{6,488}]'),(2,2,98,'[{255,36160004,60}]',120,600,'[{2,44000},{6,880}]'),(2,3,98,'[{255,36160004,96}]',192,960,'[{2,61600},{6,1320}]'),(2,0,99,'[{255,36160004,12}]',24,120,'[{2,14800},{6,296}]'),(2,1,99,'[{255,36160004,36}]',72,360,'[{2,24700},{6,494}]'),(2,2,99,'[{255,36160004,60}]',120,600,'[{2,44500},{6,890}]'),(2,3,99,'[{255,36160004,96}]',192,960,'[{2,62300},{6,1335}]'),(2,0,100,'[{255,36160004,12}]',24,120,'[{2,15000},{6,300}]'),(2,1,100,'[{255,36160004,36}]',72,360,'[{2,25000},{6,500}]'),(2,2,100,'[{255,36160004,60}]',120,600,'[{2,45000},{6,900}]'),(2,3,100,'[{255,36160004,96}]',192,960,'[{2,63000},{6,1350}]'),(2,0,101,'[{255,36160004,12}]',24,120,'[{2,15300},{6,306}]'),(2,1,101,'[{255,36160004,36}]',72,360,'[{2,25400},{6,508}]'),(2,2,101,'[{255,36160004,60}]',120,600,'[{2,45600},{6,912}]'),(2,3,101,'[{255,36160004,96}]',192,960,'[{2,63840},{6,1368}]'),(2,0,102,'[{255,36160004,12}]',24,120,'[{2,15600},{6,312}]'),(2,1,102,'[{255,36160004,36}]',72,360,'[{2,25800},{6,516}]'),(2,2,102,'[{255,36160004,60}]',120,600,'[{2,46200},{6,924}]'),(2,3,102,'[{255,36160004,96}]',192,960,'[{2,64680},{6,1386}]'),(2,0,103,'[{255,36160004,12}]',24,120,'[{2,15900},{6,318}]'),(2,1,103,'[{255,36160004,36}]',72,360,'[{2,26200},{6,524}]'),(2,2,103,'[{255,36160004,60}]',120,600,'[{2,46800},{6,936}]'),(2,3,103,'[{255,36160004,96}]',192,960,'[{2,65520},{6,1404}]'),(2,0,104,'[{255,36160004,12}]',24,120,'[{2,16200},{6,324}]'),(2,1,104,'[{255,36160004,36}]',72,360,'[{2,26600},{6,532}]'),(2,2,104,'[{255,36160004,60}]',120,600,'[{2,47400},{6,948}]'),(2,3,104,'[{255,36160004,96}]',192,960,'[{2,66360},{6,1422}]'),(2,0,105,'[{255,36160004,13}]',26,130,'[{2,16500},{6,330}]'),(2,1,105,'[{255,36160004,39}]',78,390,'[{2,27000},{6,540}]'),(2,2,105,'[{255,36160004,65}]',130,650,'[{2,48000},{6,960}]'),(2,3,105,'[{255,36160004,104}]',208,1040,'[{2,67200},{6,1440}]'),(2,0,106,'[{255,36160004,13}]',26,130,'[{2,16800},{6,336}]'),(2,1,106,'[{255,36160004,39}]',78,390,'[{2,27400},{6,548}]'),(2,2,106,'[{255,36160004,65}]',130,650,'[{2,48600},{6,972}]'),(2,3,106,'[{255,36160004,104}]',208,1040,'[{2,68040},{6,1458}]'),(2,0,107,'[{255,36160004,13}]',26,130,'[{2,17100},{6,342}]'),(2,1,107,'[{255,36160004,39}]',78,390,'[{2,27800},{6,556}]'),(2,2,107,'[{255,36160004,65}]',130,650,'[{2,49200},{6,984}]'),(2,3,107,'[{255,36160004,104}]',208,1040,'[{2,68880},{6,1476}]'),(2,0,108,'[{255,36160004,13}]',26,130,'[{2,17400},{6,348}]'),(2,1,108,'[{255,36160004,39}]',78,390,'[{2,28200},{6,564}]'),(2,2,108,'[{255,36160004,65}]',130,650,'[{2,49800},{6,996}]'),(2,3,108,'[{255,36160004,104}]',208,1040,'[{2,69720},{6,1494}]'),(2,0,109,'[{255,36160004,13}]',26,130,'[{2,17700},{6,354}]'),(2,1,109,'[{255,36160004,39}]',78,390,'[{2,28600},{6,572}]'),(2,2,109,'[{255,36160004,65}]',130,650,'[{2,50400},{6,1008}]'),(2,3,109,'[{255,36160004,104}]',208,1040,'[{2,70560},{6,1512}]'),(2,0,110,'[{255,36160004,13}]',26,130,'[{2,18000},{6,360}]'),(2,1,110,'[{255,36160004,39}]',78,390,'[{2,29000},{6,580}]'),(2,2,110,'[{255,36160004,65}]',130,650,'[{2,51000},{6,1020}]'),(2,3,110,'[{255,36160004,104}]',208,1040,'[{2,71400},{6,1530}]'),(2,0,111,'[{255,36160004,13}]',26,130,'[{2,18300},{6,366}]'),(2,1,111,'[{255,36160004,39}]',78,390,'[{2,29400},{6,588}]'),(2,2,111,'[{255,36160004,65}]',130,650,'[{2,51600},{6,1032}]'),(2,3,111,'[{255,36160004,104}]',208,1040,'[{2,72240},{6,1548}]'),(2,0,112,'[{255,36160004,13}]',26,130,'[{2,18600},{6,372}]'),(2,1,112,'[{255,36160004,39}]',78,390,'[{2,29800},{6,596}]'),(2,2,112,'[{255,36160004,65}]',130,650,'[{2,52200},{6,1044}]'),(2,3,112,'[{255,36160004,104}]',208,1040,'[{2,73080},{6,1566}]'),(2,0,113,'[{255,36160004,13}]',26,130,'[{2,18900},{6,378}]'),(2,1,113,'[{255,36160004,39}]',78,390,'[{2,30200},{6,604}]'),(2,2,113,'[{255,36160004,65}]',130,650,'[{2,52800},{6,1056}]'),(2,3,113,'[{255,36160004,104}]',208,1040,'[{2,73920},{6,1584}]'),(2,0,114,'[{255,36160004,13}]',26,130,'[{2,19200},{6,384}]'),(2,1,114,'[{255,36160004,39}]',78,390,'[{2,30600},{6,612}]'),(2,2,114,'[{255,36160004,65}]',130,650,'[{2,53400},{6,1068}]'),(2,3,114,'[{255,36160004,104}]',208,1040,'[{2,74760},{6,1602}]'),(2,0,115,'[{255,36160004,13}]',26,130,'[{2,19500},{6,390}]'),(2,1,115,'[{255,36160004,39}]',78,390,'[{2,31000},{6,620}]'),(2,2,115,'[{255,36160004,65}]',130,650,'[{2,54000},{6,1080}]'),(2,3,115,'[{255,36160004,104}]',208,1040,'[{2,75600},{6,1620}]'),(2,0,116,'[{255,36160004,13}]',26,130,'[{2,19800},{6,396}]'),(2,1,116,'[{255,36160004,39}]',78,390,'[{2,31400},{6,628}]'),(2,2,116,'[{255,36160004,65}]',130,650,'[{2,54600},{6,1092}]'),(2,3,116,'[{255,36160004,104}]',208,1040,'[{2,76440},{6,1638}]'),(2,0,117,'[{255,36160004,13}]',26,130,'[{2,20100},{6,402}]'),(2,1,117,'[{255,36160004,39}]',78,390,'[{2,31800},{6,636}]'),(2,2,117,'[{255,36160004,65}]',130,650,'[{2,55200},{6,1104}]'),(2,3,117,'[{255,36160004,104}]',208,1040,'[{2,77280},{6,1656}]'),(2,0,118,'[{255,36160004,13}]',26,130,'[{2,20400},{6,408}]'),(2,1,118,'[{255,36160004,39}]',78,390,'[{2,32200},{6,644}]'),(2,2,118,'[{255,36160004,65}]',130,650,'[{2,55800},{6,1116}]'),(2,3,118,'[{255,36160004,104}]',208,1040,'[{2,78120},{6,1674}]'),(2,0,119,'[{255,36160004,13}]',26,130,'[{2,20700},{6,414}]'),(2,1,119,'[{255,36160004,39}]',78,390,'[{2,32600},{6,652}]'),(2,2,119,'[{255,36160004,65}]',130,650,'[{2,56400},{6,1128}]'),(2,3,119,'[{255,36160004,104}]',208,1040,'[{2,78960},{6,1692}]'),(2,0,120,'[{255,36160004,14}]',28,140,'[{2,21000},{6,420}]'),(2,1,120,'[{255,36160004,42}]',84,420,'[{2,33000},{6,660}]'),(2,2,120,'[{255,36160004,70}]',140,700,'[{2,57000},{6,1140}]'),(2,3,120,'[{255,36160004,112}]',224,1120,'[{2,79800},{6,1710}]'),(2,0,121,'[{255,36160004,14}]',28,140,'[{2,21300},{6,426}]'),(2,1,121,'[{255,36160004,42}]',84,420,'[{2,33400},{6,668}]'),(2,2,121,'[{255,36160004,70}]',140,700,'[{2,57600},{6,1152}]'),(2,3,121,'[{255,36160004,112}]',224,1120,'[{2,80640},{6,1728}]'),(2,0,122,'[{255,36160004,14}]',28,140,'[{2,21600},{6,432}]'),(2,1,122,'[{255,36160004,42}]',84,420,'[{2,33800},{6,676}]'),(2,2,122,'[{255,36160004,70}]',140,700,'[{2,58200},{6,1164}]'),(2,3,122,'[{255,36160004,112}]',224,1120,'[{2,81480},{6,1746}]'),(2,0,123,'[{255,36160004,14}]',28,140,'[{2,21900},{6,438}]'),(2,1,123,'[{255,36160004,42}]',84,420,'[{2,34200},{6,684}]'),(2,2,123,'[{255,36160004,70}]',140,700,'[{2,58800},{6,1176}]'),(2,3,123,'[{255,36160004,112}]',224,1120,'[{2,82320},{6,1764}]'),(2,0,124,'[{255,36160004,14}]',28,140,'[{2,22200},{6,444}]'),(2,1,124,'[{255,36160004,42}]',84,420,'[{2,34600},{6,692}]'),(2,2,124,'[{255,36160004,70}]',140,700,'[{2,59400},{6,1188}]'),(2,3,124,'[{255,36160004,112}]',224,1120,'[{2,83160},{6,1782}]'),(2,0,125,'[{255,36160004,14}]',28,140,'[{2,22500},{6,450}]'),(2,1,125,'[{255,36160004,42}]',84,420,'[{2,35000},{6,700}]'),(2,2,125,'[{255,36160004,70}]',140,700,'[{2,60000},{6,1200}]'),(2,3,125,'[{255,36160004,112}]',224,1120,'[{2,84000},{6,1800}]'),(2,0,126,'[{255,36160004,14}]',28,140,'[{2,22800},{6,456}]'),(2,1,126,'[{255,36160004,42}]',84,420,'[{2,35400},{6,708}]'),(2,2,126,'[{255,36160004,70}]',140,700,'[{2,60600},{6,1212}]'),(2,3,126,'[{255,36160004,112}]',224,1120,'[{2,84840},{6,1818}]'),(2,0,127,'[{255,36160004,14}]',28,140,'[{2,23100},{6,462}]'),(2,1,127,'[{255,36160004,42}]',84,420,'[{2,35800},{6,716}]'),(2,2,127,'[{255,36160004,70}]',140,700,'[{2,61200},{6,1224}]'),(2,3,127,'[{255,36160004,112}]',224,1120,'[{2,85680},{6,1836}]'),(2,0,128,'[{255,36160004,14}]',28,140,'[{2,23400},{6,468}]'),(2,1,128,'[{255,36160004,42}]',84,420,'[{2,36200},{6,724}]'),(2,2,128,'[{255,36160004,70}]',140,700,'[{2,61800},{6,1236}]'),(2,3,128,'[{255,36160004,112}]',224,1120,'[{2,86520},{6,1854}]'),(2,0,129,'[{255,36160004,14}]',28,140,'[{2,23700},{6,474}]'),(2,1,129,'[{255,36160004,42}]',84,420,'[{2,36600},{6,732}]'),(2,2,129,'[{255,36160004,70}]',140,700,'[{2,62400},{6,1248}]'),(2,3,129,'[{255,36160004,112}]',224,1120,'[{2,87360},{6,1872}]'),(2,0,130,'[{255,36160004,14}]',28,140,'[{2,24000},{6,480}]'),(2,1,130,'[{255,36160004,42}]',84,420,'[{2,37000},{6,740}]'),(2,2,130,'[{255,36160004,70}]',140,700,'[{2,63000},{6,1260}]'),(2,3,130,'[{255,36160004,112}]',224,1120,'[{2,88200},{6,1890}]'),(2,0,131,'[{255,36160004,14}]',28,140,'[{2,24300},{6,486}]'),(2,1,131,'[{255,36160004,42}]',84,420,'[{2,37400},{6,748}]'),(2,2,131,'[{255,36160004,70}]',140,700,'[{2,63600},{6,1272}]'),(2,3,131,'[{255,36160004,112}]',224,1120,'[{2,89040},{6,1908}]'),(2,0,132,'[{255,36160004,14}]',28,140,'[{2,24600},{6,492}]'),(2,1,132,'[{255,36160004,42}]',84,420,'[{2,37800},{6,756}]'),(2,2,132,'[{255,36160004,70}]',140,700,'[{2,64200},{6,1284}]'),(2,3,132,'[{255,36160004,112}]',224,1120,'[{2,89880},{6,1926}]'),(2,0,133,'[{255,36160004,14}]',28,140,'[{2,24900},{6,498}]'),(2,1,133,'[{255,36160004,42}]',84,420,'[{2,38200},{6,764}]'),(2,2,133,'[{255,36160004,70}]',140,700,'[{2,64800},{6,1296}]'),(2,3,133,'[{255,36160004,112}]',224,1120,'[{2,90720},{6,1944}]'),(2,0,134,'[{255,36160004,14}]',28,140,'[{2,25200},{6,504}]'),(2,1,134,'[{255,36160004,42}]',84,420,'[{2,38600},{6,772}]'),(2,2,134,'[{255,36160004,70}]',140,700,'[{2,65400},{6,1308}]'),(2,3,134,'[{255,36160004,112}]',224,1120,'[{2,91560},{6,1962}]'),(2,0,135,'[{255,36160004,15}]',30,150,'[{2,25500},{6,510}]'),(2,1,135,'[{255,36160004,45}]',90,450,'[{2,39000},{6,780}]'),(2,2,135,'[{255,36160004,75}]',150,750,'[{2,66000},{6,1320}]'),(2,3,135,'[{255,36160004,120}]',240,1200,'[{2,92400},{6,1980}]'),(2,0,136,'[{255,36160004,15}]',30,150,'[{2,25800},{6,516}]'),(2,1,136,'[{255,36160004,45}]',90,450,'[{2,39400},{6,788}]'),(2,2,136,'[{255,36160004,75}]',150,750,'[{2,66600},{6,1332}]'),(2,3,136,'[{255,36160004,120}]',240,1200,'[{2,93240},{6,1998}]'),(2,0,137,'[{255,36160004,15}]',30,150,'[{2,26100},{6,522}]'),(2,1,137,'[{255,36160004,45}]',90,450,'[{2,39800},{6,796}]'),(2,2,137,'[{255,36160004,75}]',150,750,'[{2,67200},{6,1344}]'),(2,3,137,'[{255,36160004,120}]',240,1200,'[{2,94080},{6,2016}]'),(2,0,138,'[{255,36160004,15}]',30,150,'[{2,26400},{6,528}]'),(2,1,138,'[{255,36160004,45}]',90,450,'[{2,40200},{6,804}]'),(2,2,138,'[{255,36160004,75}]',150,750,'[{2,67800},{6,1356}]'),(2,3,138,'[{255,36160004,120}]',240,1200,'[{2,94920},{6,2034}]'),(2,0,139,'[{255,36160004,15}]',30,150,'[{2,26700},{6,534}]'),(2,1,139,'[{255,36160004,45}]',90,450,'[{2,40600},{6,812}]'),(2,2,139,'[{255,36160004,75}]',150,750,'[{2,68400},{6,1368}]'),(2,3,139,'[{255,36160004,120}]',240,1200,'[{2,95760},{6,2052}]'),(2,0,140,'[{255,36160004,15}]',30,150,'[{2,27000},{6,540}]'),(2,1,140,'[{255,36160004,45}]',90,450,'[{2,41000},{6,820}]'),(2,2,140,'[{255,36160004,75}]',150,750,'[{2,69000},{6,1380}]'),(2,3,140,'[{255,36160004,120}]',240,1200,'[{2,96600},{6,2070}]'),(2,0,141,'[{255,36160004,15}]',30,150,'[{2,27300},{6,546}]'),(2,1,141,'[{255,36160004,45}]',90,450,'[{2,41400},{6,828}]'),(2,2,141,'[{255,36160004,75}]',150,750,'[{2,69600},{6,1392}]'),(2,3,141,'[{255,36160004,120}]',240,1200,'[{2,97440},{6,2088}]'),(2,0,142,'[{255,36160004,15}]',30,150,'[{2,27600},{6,552}]'),(2,1,142,'[{255,36160004,45}]',90,450,'[{2,41800},{6,836}]'),(2,2,142,'[{255,36160004,75}]',150,750,'[{2,70200},{6,1404}]'),(2,3,142,'[{255,36160004,120}]',240,1200,'[{2,98280},{6,2106}]'),(2,0,143,'[{255,36160004,15}]',30,150,'[{2,27900},{6,558}]'),(2,1,143,'[{255,36160004,45}]',90,450,'[{2,42200},{6,844}]'),(2,2,143,'[{255,36160004,75}]',150,750,'[{2,70800},{6,1416}]'),(2,3,143,'[{255,36160004,120}]',240,1200,'[{2,99120},{6,2124}]'),(2,0,144,'[{255,36160004,15}]',30,150,'[{2,28200},{6,564}]'),(2,1,144,'[{255,36160004,45}]',90,450,'[{2,42600},{6,852}]'),(2,2,144,'[{255,36160004,75}]',150,750,'[{2,71400},{6,1428}]'),(2,3,144,'[{255,36160004,120}]',240,1200,'[{2,99960},{6,2142}]'),(2,0,145,'[{255,36160004,15}]',30,150,'[{2,28500},{6,570}]'),(2,1,145,'[{255,36160004,45}]',90,450,'[{2,43000},{6,860}]'),(2,2,145,'[{255,36160004,75}]',150,750,'[{2,72000},{6,1440}]'),(2,3,145,'[{255,36160004,120}]',240,1200,'[{2,100800},{6,2160}]'),(2,0,146,'[{255,36160004,15}]',30,150,'[{2,28800},{6,576}]'),(2,1,146,'[{255,36160004,45}]',90,450,'[{2,43400},{6,868}]'),(2,2,146,'[{255,36160004,75}]',150,750,'[{2,72600},{6,1452}]'),(2,3,146,'[{255,36160004,120}]',240,1200,'[{2,101640},{6,2178}]'),(2,0,147,'[{255,36160004,15}]',30,150,'[{2,29100},{6,582}]'),(2,1,147,'[{255,36160004,45}]',90,450,'[{2,43800},{6,876}]'),(2,2,147,'[{255,36160004,75}]',150,750,'[{2,73200},{6,1464}]'),(2,3,147,'[{255,36160004,120}]',240,1200,'[{2,102480},{6,2196}]'),(2,0,148,'[{255,36160004,15}]',30,150,'[{2,29400},{6,588}]'),(2,1,148,'[{255,36160004,45}]',90,450,'[{2,44200},{6,884}]'),(2,2,148,'[{255,36160004,75}]',150,750,'[{2,73800},{6,1476}]'),(2,3,148,'[{255,36160004,120}]',240,1200,'[{2,103320},{6,2214}]'),(2,0,149,'[{255,36160004,15}]',30,150,'[{2,29700},{6,594}]'),(2,1,149,'[{255,36160004,45}]',90,450,'[{2,44600},{6,892}]'),(2,2,149,'[{255,36160004,75}]',150,750,'[{2,74400},{6,1488}]'),(2,3,149,'[{255,36160004,120}]',240,1200,'[{2,104160},{6,2232}]'),(2,0,150,'[{255,36160004,15}]',30,150,'[{2,30000},{6,600}]'),(2,1,150,'[{255,36160004,45}]',90,450,'[{2,45000},{6,900}]'),(2,2,150,'[{255,36160004,75}]',150,750,'[{2,75000},{6,1500}]'),(2,3,150,'[{255,36160004,120}]',240,1200,'[{2,105000},{6,2250}]'),(3,0,0,'[{255,36160004,5}]',10,50,'[{3,0},{7,0}]'),(3,1,0,'[{255,36160004,15}]',30,150,'[{3,0},{7,0}]'),(3,2,0,'[{255,36160004,25}]',50,250,'[{3,0},{7,0}]'),(3,3,0,'[{255,36160004,40}]',80,400,'[{3,0},{7,0}]'),(3,0,1,'[{255,36160004,5}]',10,50,'[{3,4},{7,2}]'),(3,1,1,'[{255,36160004,15}]',30,150,'[{3,8},{7,4}]'),(3,2,1,'[{255,36160004,25}]',50,250,'[{3,16},{7,8}]'),(3,3,1,'[{255,36160004,40}]',80,400,'[{3,23},{7,12}]'),(3,0,2,'[{255,36160004,5}]',10,50,'[{3,8},{7,4}]'),(3,1,2,'[{255,36160004,15}]',30,150,'[{3,16},{7,8}]'),(3,2,2,'[{255,36160004,25}]',50,250,'[{3,32},{7,16}]'),(3,3,2,'[{255,36160004,40}]',80,400,'[{3,46},{7,24}]'),(3,0,3,'[{255,36160004,5}]',10,50,'[{3,12},{7,6}]'),(3,1,3,'[{255,36160004,15}]',30,150,'[{3,24},{7,12}]'),(3,2,3,'[{255,36160004,25}]',50,250,'[{3,48},{7,24}]'),(3,3,3,'[{255,36160004,40}]',80,400,'[{3,69},{7,36}]'),(3,0,4,'[{255,36160004,5}]',10,50,'[{3,16},{7,8}]'),(3,1,4,'[{255,36160004,15}]',30,150,'[{3,32},{7,16}]'),(3,2,4,'[{255,36160004,25}]',50,250,'[{3,64},{7,32}]'),(3,3,4,'[{255,36160004,40}]',80,400,'[{3,92},{7,48}]'),(3,0,5,'[{255,36160004,5}]',10,50,'[{3,20},{7,10}]'),(3,1,5,'[{255,36160004,15}]',30,150,'[{3,40},{7,20}]'),(3,2,5,'[{255,36160004,25}]',50,250,'[{3,80},{7,40}]'),(3,3,5,'[{255,36160004,40}]',80,400,'[{3,115},{7,60}]'),(3,0,6,'[{255,36160004,5}]',10,50,'[{3,24},{7,12}]'),(3,1,6,'[{255,36160004,15}]',30,150,'[{3,48},{7,24}]'),(3,2,6,'[{255,36160004,25}]',50,250,'[{3,96},{7,48}]'),(3,3,6,'[{255,36160004,40}]',80,400,'[{3,138},{7,72}]'),(3,0,7,'[{255,36160004,5}]',10,50,'[{3,28},{7,14}]'),(3,1,7,'[{255,36160004,15}]',30,150,'[{3,56},{7,28}]'),(3,2,7,'[{255,36160004,25}]',50,250,'[{3,112},{7,56}]'),(3,3,7,'[{255,36160004,40}]',80,400,'[{3,161},{7,84}]'),(3,0,8,'[{255,36160004,5}]',10,50,'[{3,32},{7,16}]'),(3,1,8,'[{255,36160004,15}]',30,150,'[{3,64},{7,32}]'),(3,2,8,'[{255,36160004,25}]',50,250,'[{3,128},{7,64}]'),(3,3,8,'[{255,36160004,40}]',80,400,'[{3,184},{7,96}]'),(3,0,9,'[{255,36160004,5}]',10,50,'[{3,36},{7,18}]'),(3,1,9,'[{255,36160004,15}]',30,150,'[{3,72},{7,36}]'),(3,2,9,'[{255,36160004,25}]',50,250,'[{3,144},{7,72}]'),(3,3,9,'[{255,36160004,40}]',80,400,'[{3,207},{7,108}]'),(3,0,10,'[{255,36160004,6}]',12,60,'[{3,40},{7,20}]'),(3,1,10,'[{255,36160004,18}]',36,180,'[{3,80},{7,40}]'),(3,2,10,'[{255,36160004,30}]',60,300,'[{3,160},{7,80}]'),(3,3,10,'[{255,36160004,48}]',96,480,'[{3,230},{7,120}]'),(3,0,11,'[{255,36160004,6}]',12,60,'[{3,44},{7,22}]'),(3,1,11,'[{255,36160004,18}]',36,180,'[{3,88},{7,44}]'),(3,2,11,'[{255,36160004,30}]',60,300,'[{3,176},{7,88}]'),(3,3,11,'[{255,36160004,48}]',96,480,'[{3,253},{7,132}]'),(3,0,12,'[{255,36160004,6}]',12,60,'[{3,48},{7,24}]'),(3,1,12,'[{255,36160004,18}]',36,180,'[{3,96},{7,48}]'),(3,2,12,'[{255,36160004,30}]',60,300,'[{3,192},{7,96}]'),(3,3,12,'[{255,36160004,48}]',96,480,'[{3,276},{7,144}]'),(3,0,13,'[{255,36160004,6}]',12,60,'[{3,52},{7,26}]'),(3,1,13,'[{255,36160004,18}]',36,180,'[{3,104},{7,52}]'),(3,2,13,'[{255,36160004,30}]',60,300,'[{3,208},{7,104}]'),(3,3,13,'[{255,36160004,48}]',96,480,'[{3,299},{7,156}]'),(3,0,14,'[{255,36160004,6}]',12,60,'[{3,56},{7,28}]'),(3,1,14,'[{255,36160004,18}]',36,180,'[{3,112},{7,56}]'),(3,2,14,'[{255,36160004,30}]',60,300,'[{3,224},{7,112}]'),(3,3,14,'[{255,36160004,48}]',96,480,'[{3,322},{7,168}]'),(3,0,15,'[{255,36160004,6}]',12,60,'[{3,60},{7,30}]'),(3,1,15,'[{255,36160004,18}]',36,180,'[{3,120},{7,60}]'),(3,2,15,'[{255,36160004,30}]',60,300,'[{3,240},{7,120}]'),(3,3,15,'[{255,36160004,48}]',96,480,'[{3,345},{7,180}]'),(3,0,16,'[{255,36160004,6}]',12,60,'[{3,64},{7,32}]'),(3,1,16,'[{255,36160004,18}]',36,180,'[{3,128},{7,64}]'),(3,2,16,'[{255,36160004,30}]',60,300,'[{3,256},{7,128}]'),(3,3,16,'[{255,36160004,48}]',96,480,'[{3,368},{7,192}]'),(3,0,17,'[{255,36160004,6}]',12,60,'[{3,68},{7,34}]'),(3,1,17,'[{255,36160004,18}]',36,180,'[{3,136},{7,68}]'),(3,2,17,'[{255,36160004,30}]',60,300,'[{3,272},{7,136}]'),(3,3,17,'[{255,36160004,48}]',96,480,'[{3,391},{7,204}]'),(3,0,18,'[{255,36160004,6}]',12,60,'[{3,72},{7,36}]'),(3,1,18,'[{255,36160004,18}]',36,180,'[{3,144},{7,72}]'),(3,2,18,'[{255,36160004,30}]',60,300,'[{3,288},{7,144}]'),(3,3,18,'[{255,36160004,48}]',96,480,'[{3,414},{7,216}]'),(3,0,19,'[{255,36160004,6}]',12,60,'[{3,76},{7,38}]'),(3,1,19,'[{255,36160004,18}]',36,180,'[{3,152},{7,76}]'),(3,2,19,'[{255,36160004,30}]',60,300,'[{3,304},{7,152}]'),(3,3,19,'[{255,36160004,48}]',96,480,'[{3,437},{7,228}]'),(3,0,20,'[{255,36160004,7}]',14,70,'[{3,80},{7,40}]'),(3,1,20,'[{255,36160004,21}]',42,210,'[{3,160},{7,80}]'),(3,2,20,'[{255,36160004,35}]',70,350,'[{3,320},{7,160}]'),(3,3,20,'[{255,36160004,56}]',112,560,'[{3,460},{7,240}]'),(3,0,21,'[{255,36160004,7}]',14,70,'[{3,84},{7,42}]'),(3,1,21,'[{255,36160004,21}]',42,210,'[{3,168},{7,84}]'),(3,2,21,'[{255,36160004,35}]',70,350,'[{3,336},{7,168}]'),(3,3,21,'[{255,36160004,56}]',112,560,'[{3,483},{7,252}]'),(3,0,22,'[{255,36160004,7}]',14,70,'[{3,88},{7,44}]'),(3,1,22,'[{255,36160004,21}]',42,210,'[{3,176},{7,88}]'),(3,2,22,'[{255,36160004,35}]',70,350,'[{3,352},{7,176}]'),(3,3,22,'[{255,36160004,56}]',112,560,'[{3,506},{7,264}]'),(3,0,23,'[{255,36160004,7}]',14,70,'[{3,92},{7,46}]'),(3,1,23,'[{255,36160004,21}]',42,210,'[{3,184},{7,92}]'),(3,2,23,'[{255,36160004,35}]',70,350,'[{3,368},{7,184}]'),(3,3,23,'[{255,36160004,56}]',112,560,'[{3,529},{7,276}]'),(3,0,24,'[{255,36160004,7}]',14,70,'[{3,96},{7,48}]'),(3,1,24,'[{255,36160004,21}]',42,210,'[{3,192},{7,96}]'),(3,2,24,'[{255,36160004,35}]',70,350,'[{3,384},{7,192}]'),(3,3,24,'[{255,36160004,56}]',112,560,'[{3,552},{7,288}]'),(3,0,25,'[{255,36160004,7}]',14,70,'[{3,100},{7,50}]'),(3,1,25,'[{255,36160004,21}]',42,210,'[{3,200},{7,100}]'),(3,2,25,'[{255,36160004,35}]',70,350,'[{3,400},{7,200}]'),(3,3,25,'[{255,36160004,56}]',112,560,'[{3,575},{7,300}]'),(3,0,26,'[{255,36160004,7}]',14,70,'[{3,104},{7,52}]'),(3,1,26,'[{255,36160004,21}]',42,210,'[{3,208},{7,104}]'),(3,2,26,'[{255,36160004,35}]',70,350,'[{3,416},{7,208}]'),(3,3,26,'[{255,36160004,56}]',112,560,'[{3,598},{7,312}]'),(3,0,27,'[{255,36160004,7}]',14,70,'[{3,108},{7,54}]'),(3,1,27,'[{255,36160004,21}]',42,210,'[{3,216},{7,108}]'),(3,2,27,'[{255,36160004,35}]',70,350,'[{3,432},{7,216}]'),(3,3,27,'[{255,36160004,56}]',112,560,'[{3,621},{7,324}]'),(3,0,28,'[{255,36160004,7}]',14,70,'[{3,112},{7,56}]'),(3,1,28,'[{255,36160004,21}]',42,210,'[{3,224},{7,112}]'),(3,2,28,'[{255,36160004,35}]',70,350,'[{3,448},{7,224}]'),(3,3,28,'[{255,36160004,56}]',112,560,'[{3,644},{7,336}]'),(3,0,29,'[{255,36160004,7}]',14,70,'[{3,116},{7,58}]'),(3,1,29,'[{255,36160004,21}]',42,210,'[{3,232},{7,116}]'),(3,2,29,'[{255,36160004,35}]',70,350,'[{3,464},{7,232}]'),(3,3,29,'[{255,36160004,56}]',112,560,'[{3,667},{7,348}]'),(3,0,30,'[{255,36160004,8}]',16,80,'[{3,120},{7,60}]'),(3,1,30,'[{255,36160004,24}]',48,240,'[{3,240},{7,120}]'),(3,2,30,'[{255,36160004,40}]',80,400,'[{3,480},{7,240}]'),(3,3,30,'[{255,36160004,64}]',128,640,'[{3,690},{7,360}]'),(3,0,31,'[{255,36160004,8}]',16,80,'[{3,124},{7,62}]'),(3,1,31,'[{255,36160004,24}]',48,240,'[{3,248},{7,124}]'),(3,2,31,'[{255,36160004,40}]',80,400,'[{3,496},{7,248}]'),(3,3,31,'[{255,36160004,64}]',128,640,'[{3,713},{7,372}]'),(3,0,32,'[{255,36160004,8}]',16,80,'[{3,128},{7,64}]'),(3,1,32,'[{255,36160004,24}]',48,240,'[{3,256},{7,128}]'),(3,2,32,'[{255,36160004,40}]',80,400,'[{3,512},{7,256}]'),(3,3,32,'[{255,36160004,64}]',128,640,'[{3,736},{7,384}]'),(3,0,33,'[{255,36160004,8}]',16,80,'[{3,132},{7,66}]'),(3,1,33,'[{255,36160004,24}]',48,240,'[{3,264},{7,132}]'),(3,2,33,'[{255,36160004,40}]',80,400,'[{3,528},{7,264}]'),(3,3,33,'[{255,36160004,64}]',128,640,'[{3,759},{7,396}]'),(3,0,34,'[{255,36160004,8}]',16,80,'[{3,136},{7,68}]'),(3,1,34,'[{255,36160004,24}]',48,240,'[{3,272},{7,136}]'),(3,2,34,'[{255,36160004,40}]',80,400,'[{3,544},{7,272}]'),(3,3,34,'[{255,36160004,64}]',128,640,'[{3,782},{7,408}]'),(3,0,35,'[{255,36160004,8}]',16,80,'[{3,140},{7,70}]'),(3,1,35,'[{255,36160004,24}]',48,240,'[{3,280},{7,140}]'),(3,2,35,'[{255,36160004,40}]',80,400,'[{3,560},{7,280}]'),(3,3,35,'[{255,36160004,64}]',128,640,'[{3,805},{7,420}]'),(3,0,36,'[{255,36160004,8}]',16,80,'[{3,144},{7,72}]'),(3,1,36,'[{255,36160004,24}]',48,240,'[{3,288},{7,144}]'),(3,2,36,'[{255,36160004,40}]',80,400,'[{3,576},{7,288}]'),(3,3,36,'[{255,36160004,64}]',128,640,'[{3,828},{7,432}]'),(3,0,37,'[{255,36160004,8}]',16,80,'[{3,148},{7,74}]'),(3,1,37,'[{255,36160004,24}]',48,240,'[{3,296},{7,148}]'),(3,2,37,'[{255,36160004,40}]',80,400,'[{3,592},{7,296}]'),(3,3,37,'[{255,36160004,64}]',128,640,'[{3,851},{7,444}]'),(3,0,38,'[{255,36160004,8}]',16,80,'[{3,152},{7,76}]'),(3,1,38,'[{255,36160004,24}]',48,240,'[{3,304},{7,152}]'),(3,2,38,'[{255,36160004,40}]',80,400,'[{3,608},{7,304}]'),(3,3,38,'[{255,36160004,64}]',128,640,'[{3,874},{7,456}]'),(3,0,39,'[{255,36160004,8}]',16,80,'[{3,156},{7,78}]'),(3,1,39,'[{255,36160004,24}]',48,240,'[{3,312},{7,156}]'),(3,2,39,'[{255,36160004,40}]',80,400,'[{3,624},{7,312}]'),(3,3,39,'[{255,36160004,64}]',128,640,'[{3,897},{7,468}]'),(3,0,40,'[{255,36160004,8}]',16,80,'[{3,160},{7,80}]'),(3,1,40,'[{255,36160004,24}]',48,240,'[{3,320},{7,160}]'),(3,2,40,'[{255,36160004,40}]',80,400,'[{3,640},{7,320}]'),(3,3,40,'[{255,36160004,64}]',128,640,'[{3,920},{7,480}]'),(3,0,41,'[{255,36160004,8}]',16,80,'[{3,164},{7,82}]'),(3,1,41,'[{255,36160004,24}]',48,240,'[{3,328},{7,164}]'),(3,2,41,'[{255,36160004,40}]',80,400,'[{3,656},{7,328}]'),(3,3,41,'[{255,36160004,64}]',128,640,'[{3,943},{7,492}]'),(3,0,42,'[{255,36160004,8}]',16,80,'[{3,168},{7,84}]'),(3,1,42,'[{255,36160004,24}]',48,240,'[{3,336},{7,168}]'),(3,2,42,'[{255,36160004,40}]',80,400,'[{3,672},{7,336}]'),(3,3,42,'[{255,36160004,64}]',128,640,'[{3,966},{7,504}]'),(3,0,43,'[{255,36160004,8}]',16,80,'[{3,172},{7,86}]'),(3,1,43,'[{255,36160004,24}]',48,240,'[{3,344},{7,172}]'),(3,2,43,'[{255,36160004,40}]',80,400,'[{3,688},{7,344}]'),(3,3,43,'[{255,36160004,64}]',128,640,'[{3,989},{7,516}]'),(3,0,44,'[{255,36160004,8}]',16,80,'[{3,176},{7,88}]'),(3,1,44,'[{255,36160004,24}]',48,240,'[{3,352},{7,176}]'),(3,2,44,'[{255,36160004,40}]',80,400,'[{3,704},{7,352}]'),(3,3,44,'[{255,36160004,64}]',128,640,'[{3,1012},{7,528}]'),(3,0,45,'[{255,36160004,9}]',18,90,'[{3,180},{7,90}]'),(3,1,45,'[{255,36160004,27}]',54,270,'[{3,360},{7,180}]'),(3,2,45,'[{255,36160004,45}]',90,450,'[{3,720},{7,360}]'),(3,3,45,'[{255,36160004,72}]',144,720,'[{3,1035},{7,540}]'),(3,0,46,'[{255,36160004,9}]',18,90,'[{3,184},{7,92}]'),(3,1,46,'[{255,36160004,27}]',54,270,'[{3,368},{7,184}]'),(3,2,46,'[{255,36160004,45}]',90,450,'[{3,736},{7,368}]'),(3,3,46,'[{255,36160004,72}]',144,720,'[{3,1058},{7,552}]'),(3,0,47,'[{255,36160004,9}]',18,90,'[{3,188},{7,94}]'),(3,1,47,'[{255,36160004,27}]',54,270,'[{3,376},{7,188}]'),(3,2,47,'[{255,36160004,45}]',90,450,'[{3,752},{7,376}]'),(3,3,47,'[{255,36160004,72}]',144,720,'[{3,1081},{7,564}]'),(3,0,48,'[{255,36160004,9}]',18,90,'[{3,192},{7,96}]'),(3,1,48,'[{255,36160004,27}]',54,270,'[{3,384},{7,192}]'),(3,2,48,'[{255,36160004,45}]',90,450,'[{3,768},{7,384}]'),(3,3,48,'[{255,36160004,72}]',144,720,'[{3,1104},{7,576}]'),(3,0,49,'[{255,36160004,9}]',18,90,'[{3,196},{7,98}]'),(3,1,49,'[{255,36160004,27}]',54,270,'[{3,392},{7,196}]'),(3,2,49,'[{255,36160004,45}]',90,450,'[{3,784},{7,392}]'),(3,3,49,'[{255,36160004,72}]',144,720,'[{3,1127},{7,588}]'),(3,0,50,'[{255,36160004,9}]',18,90,'[{3,200},{7,100}]'),(3,1,50,'[{255,36160004,27}]',54,270,'[{3,400},{7,200}]'),(3,2,50,'[{255,36160004,45}]',90,450,'[{3,800},{7,400}]'),(3,3,50,'[{255,36160004,72}]',144,720,'[{3,1150},{7,600}]'),(3,0,51,'[{255,36160004,9}]',18,90,'[{3,208},{7,104}]'),(3,1,51,'[{255,36160004,27}]',54,270,'[{3,412},{7,206}]'),(3,2,51,'[{255,36160004,45}]',90,450,'[{3,820},{7,410}]'),(3,3,51,'[{255,36160004,72}]',144,720,'[{3,1178},{7,615}]'),(3,0,52,'[{255,36160004,9}]',18,90,'[{3,216},{7,108}]'),(3,1,52,'[{255,36160004,27}]',54,270,'[{3,424},{7,212}]'),(3,2,52,'[{255,36160004,45}]',90,450,'[{3,840},{7,420}]'),(3,3,52,'[{255,36160004,72}]',144,720,'[{3,1206},{7,630}]'),(3,0,53,'[{255,36160004,9}]',18,90,'[{3,224},{7,112}]'),(3,1,53,'[{255,36160004,27}]',54,270,'[{3,436},{7,218}]'),(3,2,53,'[{255,36160004,45}]',90,450,'[{3,860},{7,430}]'),(3,3,53,'[{255,36160004,72}]',144,720,'[{3,1234},{7,645}]'),(3,0,54,'[{255,36160004,9}]',18,90,'[{3,232},{7,116}]'),(3,1,54,'[{255,36160004,27}]',54,270,'[{3,448},{7,224}]'),(3,2,54,'[{255,36160004,45}]',90,450,'[{3,880},{7,440}]'),(3,3,54,'[{255,36160004,72}]',144,720,'[{3,1262},{7,660}]'),(3,0,55,'[{255,36160004,9}]',18,90,'[{3,240},{7,120}]'),(3,1,55,'[{255,36160004,27}]',54,270,'[{3,460},{7,230}]'),(3,2,55,'[{255,36160004,45}]',90,450,'[{3,900},{7,450}]'),(3,3,55,'[{255,36160004,72}]',144,720,'[{3,1290},{7,675}]'),(3,0,56,'[{255,36160004,9}]',18,90,'[{3,248},{7,124}]'),(3,1,56,'[{255,36160004,27}]',54,270,'[{3,472},{7,236}]'),(3,2,56,'[{255,36160004,45}]',90,450,'[{3,920},{7,460}]'),(3,3,56,'[{255,36160004,72}]',144,720,'[{3,1318},{7,690}]'),(3,0,57,'[{255,36160004,9}]',18,90,'[{3,256},{7,128}]'),(3,1,57,'[{255,36160004,27}]',54,270,'[{3,484},{7,242}]'),(3,2,57,'[{255,36160004,45}]',90,450,'[{3,940},{7,470}]'),(3,3,57,'[{255,36160004,72}]',144,720,'[{3,1346},{7,705}]'),(3,0,58,'[{255,36160004,9}]',18,90,'[{3,264},{7,132}]'),(3,1,58,'[{255,36160004,27}]',54,270,'[{3,496},{7,248}]'),(3,2,58,'[{255,36160004,45}]',90,450,'[{3,960},{7,480}]'),(3,3,58,'[{255,36160004,72}]',144,720,'[{3,1374},{7,720}]'),(3,0,59,'[{255,36160004,9}]',18,90,'[{3,272},{7,136}]'),(3,1,59,'[{255,36160004,27}]',54,270,'[{3,508},{7,254}]'),(3,2,59,'[{255,36160004,45}]',90,450,'[{3,980},{7,490}]'),(3,3,59,'[{255,36160004,72}]',144,720,'[{3,1402},{7,735}]'),(3,0,60,'[{255,36160004,10}]',20,100,'[{3,280},{7,140}]'),(3,1,60,'[{255,36160004,30}]',60,300,'[{3,520},{7,260}]'),(3,2,60,'[{255,36160004,50}]',100,500,'[{3,1000},{7,500}]'),(3,3,60,'[{255,36160004,80}]',160,800,'[{3,1430},{7,750}]'),(3,0,61,'[{255,36160004,10}]',20,100,'[{3,288},{7,144}]'),(3,1,61,'[{255,36160004,30}]',60,300,'[{3,532},{7,266}]'),(3,2,61,'[{255,36160004,50}]',100,500,'[{3,1020},{7,510}]'),(3,3,61,'[{255,36160004,80}]',160,800,'[{3,1458},{7,765}]'),(3,0,62,'[{255,36160004,10}]',20,100,'[{3,296},{7,148}]'),(3,1,62,'[{255,36160004,30}]',60,300,'[{3,544},{7,272}]'),(3,2,62,'[{255,36160004,50}]',100,500,'[{3,1040},{7,520}]'),(3,3,62,'[{255,36160004,80}]',160,800,'[{3,1486},{7,780}]'),(3,0,63,'[{255,36160004,10}]',20,100,'[{3,304},{7,152}]'),(3,1,63,'[{255,36160004,30}]',60,300,'[{3,556},{7,278}]'),(3,2,63,'[{255,36160004,50}]',100,500,'[{3,1060},{7,530}]'),(3,3,63,'[{255,36160004,80}]',160,800,'[{3,1514},{7,795}]'),(3,0,64,'[{255,36160004,10}]',20,100,'[{3,312},{7,156}]'),(3,1,64,'[{255,36160004,30}]',60,300,'[{3,568},{7,284}]'),(3,2,64,'[{255,36160004,50}]',100,500,'[{3,1080},{7,540}]'),(3,3,64,'[{255,36160004,80}]',160,800,'[{3,1542},{7,810}]'),(3,0,65,'[{255,36160004,10}]',20,100,'[{3,320},{7,160}]'),(3,1,65,'[{255,36160004,30}]',60,300,'[{3,580},{7,290}]'),(3,2,65,'[{255,36160004,50}]',100,500,'[{3,1100},{7,550}]'),(3,3,65,'[{255,36160004,80}]',160,800,'[{3,1570},{7,825}]'),(3,0,66,'[{255,36160004,10}]',20,100,'[{3,328},{7,164}]'),(3,1,66,'[{255,36160004,30}]',60,300,'[{3,592},{7,296}]'),(3,2,66,'[{255,36160004,50}]',100,500,'[{3,1120},{7,560}]'),(3,3,66,'[{255,36160004,80}]',160,800,'[{3,1598},{7,840}]'),(3,0,67,'[{255,36160004,10}]',20,100,'[{3,336},{7,168}]'),(3,1,67,'[{255,36160004,30}]',60,300,'[{3,604},{7,302}]'),(3,2,67,'[{255,36160004,50}]',100,500,'[{3,1140},{7,570}]'),(3,3,67,'[{255,36160004,80}]',160,800,'[{3,1626},{7,855}]'),(3,0,68,'[{255,36160004,10}]',20,100,'[{3,344},{7,172}]'),(3,1,68,'[{255,36160004,30}]',60,300,'[{3,616},{7,308}]'),(3,2,68,'[{255,36160004,50}]',100,500,'[{3,1160},{7,580}]'),(3,3,68,'[{255,36160004,80}]',160,800,'[{3,1654},{7,870}]'),(3,0,69,'[{255,36160004,10}]',20,100,'[{3,352},{7,176}]'),(3,1,69,'[{255,36160004,30}]',60,300,'[{3,628},{7,314}]'),(3,2,69,'[{255,36160004,50}]',100,500,'[{3,1180},{7,590}]'),(3,3,69,'[{255,36160004,80}]',160,800,'[{3,1682},{7,885}]'),(3,0,70,'[{255,36160004,10}]',20,100,'[{3,360},{7,180}]'),(3,1,70,'[{255,36160004,30}]',60,300,'[{3,640},{7,320}]'),(3,2,70,'[{255,36160004,50}]',100,500,'[{3,1200},{7,600}]'),(3,3,70,'[{255,36160004,80}]',160,800,'[{3,1710},{7,900}]'),(3,0,71,'[{255,36160004,10}]',20,100,'[{3,368},{7,184}]'),(3,1,71,'[{255,36160004,30}]',60,300,'[{3,652},{7,326}]'),(3,2,71,'[{255,36160004,50}]',100,500,'[{3,1220},{7,610}]'),(3,3,71,'[{255,36160004,80}]',160,800,'[{3,1738},{7,915}]'),(3,0,72,'[{255,36160004,10}]',20,100,'[{3,376},{7,188}]'),(3,1,72,'[{255,36160004,30}]',60,300,'[{3,664},{7,332}]'),(3,2,72,'[{255,36160004,50}]',100,500,'[{3,1240},{7,620}]'),(3,3,72,'[{255,36160004,80}]',160,800,'[{3,1766},{7,930}]'),(3,0,73,'[{255,36160004,10}]',20,100,'[{3,384},{7,192}]'),(3,1,73,'[{255,36160004,30}]',60,300,'[{3,676},{7,338}]'),(3,2,73,'[{255,36160004,50}]',100,500,'[{3,1260},{7,630}]'),(3,3,73,'[{255,36160004,80}]',160,800,'[{3,1794},{7,945}]'),(3,0,74,'[{255,36160004,10}]',20,100,'[{3,392},{7,196}]'),(3,1,74,'[{255,36160004,30}]',60,300,'[{3,688},{7,344}]'),(3,2,74,'[{255,36160004,50}]',100,500,'[{3,1280},{7,640}]'),(3,3,74,'[{255,36160004,80}]',160,800,'[{3,1822},{7,960}]'),(3,0,75,'[{255,36160004,11}]',22,110,'[{3,400},{7,200}]'),(3,1,75,'[{255,36160004,33}]',66,330,'[{3,700},{7,350}]'),(3,2,75,'[{255,36160004,55}]',110,550,'[{3,1300},{7,650}]'),(3,3,75,'[{255,36160004,88}]',176,880,'[{3,1850},{7,975}]'),(3,0,76,'[{255,36160004,11}]',22,110,'[{3,408},{7,204}]'),(3,1,76,'[{255,36160004,33}]',66,330,'[{3,712},{7,356}]'),(3,2,76,'[{255,36160004,55}]',110,550,'[{3,1320},{7,660}]'),(3,3,76,'[{255,36160004,88}]',176,880,'[{3,1878},{7,990}]'),(3,0,77,'[{255,36160004,11}]',22,110,'[{3,416},{7,208}]'),(3,1,77,'[{255,36160004,33}]',66,330,'[{3,724},{7,362}]'),(3,2,77,'[{255,36160004,55}]',110,550,'[{3,1340},{7,670}]'),(3,3,77,'[{255,36160004,88}]',176,880,'[{3,1906},{7,1005}]'),(3,0,78,'[{255,36160004,11}]',22,110,'[{3,424},{7,212}]'),(3,1,78,'[{255,36160004,33}]',66,330,'[{3,736},{7,368}]'),(3,2,78,'[{255,36160004,55}]',110,550,'[{3,1360},{7,680}]'),(3,3,78,'[{255,36160004,88}]',176,880,'[{3,1934},{7,1020}]'),(3,0,79,'[{255,36160004,11}]',22,110,'[{3,432},{7,216}]'),(3,1,79,'[{255,36160004,33}]',66,330,'[{3,748},{7,374}]'),(3,2,79,'[{255,36160004,55}]',110,550,'[{3,1380},{7,690}]'),(3,3,79,'[{255,36160004,88}]',176,880,'[{3,1962},{7,1035}]'),(3,0,80,'[{255,36160004,11}]',22,110,'[{3,440},{7,220}]'),(3,1,80,'[{255,36160004,33}]',66,330,'[{3,760},{7,380}]'),(3,2,80,'[{255,36160004,55}]',110,550,'[{3,1400},{7,700}]'),(3,3,80,'[{255,36160004,88}]',176,880,'[{3,1990},{7,1050}]'),(3,0,81,'[{255,36160004,11}]',22,110,'[{3,448},{7,224}]'),(3,1,81,'[{255,36160004,33}]',66,330,'[{3,772},{7,386}]'),(3,2,81,'[{255,36160004,55}]',110,550,'[{3,1420},{7,710}]'),(3,3,81,'[{255,36160004,88}]',176,880,'[{3,2018},{7,1065}]'),(3,0,82,'[{255,36160004,11}]',22,110,'[{3,456},{7,228}]'),(3,1,82,'[{255,36160004,33}]',66,330,'[{3,784},{7,392}]'),(3,2,82,'[{255,36160004,55}]',110,550,'[{3,1440},{7,720}]'),(3,3,82,'[{255,36160004,88}]',176,880,'[{3,2046},{7,1080}]'),(3,0,83,'[{255,36160004,11}]',22,110,'[{3,464},{7,232}]'),(3,1,83,'[{255,36160004,33}]',66,330,'[{3,796},{7,398}]'),(3,2,83,'[{255,36160004,55}]',110,550,'[{3,1460},{7,730}]'),(3,3,83,'[{255,36160004,88}]',176,880,'[{3,2074},{7,1095}]'),(3,0,84,'[{255,36160004,11}]',22,110,'[{3,472},{7,236}]'),(3,1,84,'[{255,36160004,33}]',66,330,'[{3,808},{7,404}]'),(3,2,84,'[{255,36160004,55}]',110,550,'[{3,1480},{7,740}]'),(3,3,84,'[{255,36160004,88}]',176,880,'[{3,2102},{7,1110}]'),(3,0,85,'[{255,36160004,11}]',22,110,'[{3,480},{7,240}]'),(3,1,85,'[{255,36160004,33}]',66,330,'[{3,820},{7,410}]'),(3,2,85,'[{255,36160004,55}]',110,550,'[{3,1500},{7,750}]'),(3,3,85,'[{255,36160004,88}]',176,880,'[{3,2130},{7,1125}]'),(3,0,86,'[{255,36160004,11}]',22,110,'[{3,488},{7,244}]'),(3,1,86,'[{255,36160004,33}]',66,330,'[{3,832},{7,416}]'),(3,2,86,'[{255,36160004,55}]',110,550,'[{3,1520},{7,760}]'),(3,3,86,'[{255,36160004,88}]',176,880,'[{3,2158},{7,1140}]'),(3,0,87,'[{255,36160004,11}]',22,110,'[{3,496},{7,248}]'),(3,1,87,'[{255,36160004,33}]',66,330,'[{3,844},{7,422}]'),(3,2,87,'[{255,36160004,55}]',110,550,'[{3,1540},{7,770}]'),(3,3,87,'[{255,36160004,88}]',176,880,'[{3,2186},{7,1155}]'),(3,0,88,'[{255,36160004,11}]',22,110,'[{3,504},{7,252}]'),(3,1,88,'[{255,36160004,33}]',66,330,'[{3,856},{7,428}]'),(3,2,88,'[{255,36160004,55}]',110,550,'[{3,1560},{7,780}]'),(3,3,88,'[{255,36160004,88}]',176,880,'[{3,2214},{7,1170}]'),(3,0,89,'[{255,36160004,11}]',22,110,'[{3,512},{7,256}]'),(3,1,89,'[{255,36160004,33}]',66,330,'[{3,868},{7,434}]'),(3,2,89,'[{255,36160004,55}]',110,550,'[{3,1580},{7,790}]'),(3,3,89,'[{255,36160004,88}]',176,880,'[{3,2242},{7,1185}]'),(3,0,90,'[{255,36160004,12}]',24,120,'[{3,520},{7,260}]'),(3,1,90,'[{255,36160004,36}]',72,360,'[{3,880},{7,440}]'),(3,2,90,'[{255,36160004,60}]',120,600,'[{3,1600},{7,800}]'),(3,3,90,'[{255,36160004,96}]',192,960,'[{3,2270},{7,1200}]'),(3,0,91,'[{255,36160004,12}]',24,120,'[{3,528},{7,264}]'),(3,1,91,'[{255,36160004,36}]',72,360,'[{3,892},{7,446}]'),(3,2,91,'[{255,36160004,60}]',120,600,'[{3,1620},{7,810}]'),(3,3,91,'[{255,36160004,96}]',192,960,'[{3,2298},{7,1215}]'),(3,0,92,'[{255,36160004,12}]',24,120,'[{3,536},{7,268}]'),(3,1,92,'[{255,36160004,36}]',72,360,'[{3,904},{7,452}]'),(3,2,92,'[{255,36160004,60}]',120,600,'[{3,1640},{7,820}]'),(3,3,92,'[{255,36160004,96}]',192,960,'[{3,2326},{7,1230}]'),(3,0,93,'[{255,36160004,12}]',24,120,'[{3,544},{7,272}]'),(3,1,93,'[{255,36160004,36}]',72,360,'[{3,916},{7,458}]'),(3,2,93,'[{255,36160004,60}]',120,600,'[{3,1660},{7,830}]'),(3,3,93,'[{255,36160004,96}]',192,960,'[{3,2354},{7,1245}]'),(3,0,94,'[{255,36160004,12}]',24,120,'[{3,552},{7,276}]'),(3,1,94,'[{255,36160004,36}]',72,360,'[{3,928},{7,464}]'),(3,2,94,'[{255,36160004,60}]',120,600,'[{3,1680},{7,840}]'),(3,3,94,'[{255,36160004,96}]',192,960,'[{3,2382},{7,1260}]'),(3,0,95,'[{255,36160004,12}]',24,120,'[{3,560},{7,280}]'),(3,1,95,'[{255,36160004,36}]',72,360,'[{3,940},{7,470}]'),(3,2,95,'[{255,36160004,60}]',120,600,'[{3,1700},{7,850}]'),(3,3,95,'[{255,36160004,96}]',192,960,'[{3,2410},{7,1275}]'),(3,0,96,'[{255,36160004,12}]',24,120,'[{3,568},{7,284}]'),(3,1,96,'[{255,36160004,36}]',72,360,'[{3,952},{7,476}]'),(3,2,96,'[{255,36160004,60}]',120,600,'[{3,1720},{7,860}]'),(3,3,96,'[{255,36160004,96}]',192,960,'[{3,2438},{7,1290}]'),(3,0,97,'[{255,36160004,12}]',24,120,'[{3,576},{7,288}]'),(3,1,97,'[{255,36160004,36}]',72,360,'[{3,964},{7,482}]'),(3,2,97,'[{255,36160004,60}]',120,600,'[{3,1740},{7,870}]'),(3,3,97,'[{255,36160004,96}]',192,960,'[{3,2466},{7,1305}]'),(3,0,98,'[{255,36160004,12}]',24,120,'[{3,584},{7,292}]'),(3,1,98,'[{255,36160004,36}]',72,360,'[{3,976},{7,488}]'),(3,2,98,'[{255,36160004,60}]',120,600,'[{3,1760},{7,880}]'),(3,3,98,'[{255,36160004,96}]',192,960,'[{3,2494},{7,1320}]'),(3,0,99,'[{255,36160004,12}]',24,120,'[{3,592},{7,296}]'),(3,1,99,'[{255,36160004,36}]',72,360,'[{3,988},{7,494}]'),(3,2,99,'[{255,36160004,60}]',120,600,'[{3,1780},{7,890}]'),(3,3,99,'[{255,36160004,96}]',192,960,'[{3,2522},{7,1335}]'),(3,0,100,'[{255,36160004,12}]',24,120,'[{3,600},{7,300}]'),(3,1,100,'[{255,36160004,36}]',72,360,'[{3,1000},{7,500}]'),(3,2,100,'[{255,36160004,60}]',120,600,'[{3,1800},{7,900}]'),(3,3,100,'[{255,36160004,96}]',192,960,'[{3,2550},{7,1350}]'),(3,0,101,'[{255,36160004,12}]',24,120,'[{3,612},{7,306}]'),(3,1,101,'[{255,36160004,36}]',72,360,'[{3,1016},{7,508}]'),(3,2,101,'[{255,36160004,60}]',120,600,'[{3,1824},{7,912}]'),(3,3,101,'[{255,36160004,96}]',192,960,'[{3,2584},{7,1368}]'),(3,0,102,'[{255,36160004,12}]',24,120,'[{3,624},{7,312}]'),(3,1,102,'[{255,36160004,36}]',72,360,'[{3,1032},{7,516}]'),(3,2,102,'[{255,36160004,60}]',120,600,'[{3,1848},{7,924}]'),(3,3,102,'[{255,36160004,96}]',192,960,'[{3,2618},{7,1386}]'),(3,0,103,'[{255,36160004,12}]',24,120,'[{3,636},{7,318}]'),(3,1,103,'[{255,36160004,36}]',72,360,'[{3,1048},{7,524}]'),(3,2,103,'[{255,36160004,60}]',120,600,'[{3,1872},{7,936}]'),(3,3,103,'[{255,36160004,96}]',192,960,'[{3,2652},{7,1404}]'),(3,0,104,'[{255,36160004,12}]',24,120,'[{3,648},{7,324}]'),(3,1,104,'[{255,36160004,36}]',72,360,'[{3,1064},{7,532}]'),(3,2,104,'[{255,36160004,60}]',120,600,'[{3,1896},{7,948}]'),(3,3,104,'[{255,36160004,96}]',192,960,'[{3,2686},{7,1422}]'),(3,0,105,'[{255,36160004,13}]',26,130,'[{3,660},{7,330}]'),(3,1,105,'[{255,36160004,39}]',78,390,'[{3,1080},{7,540}]'),(3,2,105,'[{255,36160004,65}]',130,650,'[{3,1920},{7,960}]'),(3,3,105,'[{255,36160004,104}]',208,1040,'[{3,2720},{7,1440}]'),(3,0,106,'[{255,36160004,13}]',26,130,'[{3,672},{7,336}]'),(3,1,106,'[{255,36160004,39}]',78,390,'[{3,1096},{7,548}]'),(3,2,106,'[{255,36160004,65}]',130,650,'[{3,1944},{7,972}]'),(3,3,106,'[{255,36160004,104}]',208,1040,'[{3,2754},{7,1458}]'),(3,0,107,'[{255,36160004,13}]',26,130,'[{3,684},{7,342}]'),(3,1,107,'[{255,36160004,39}]',78,390,'[{3,1112},{7,556}]'),(3,2,107,'[{255,36160004,65}]',130,650,'[{3,1968},{7,984}]'),(3,3,107,'[{255,36160004,104}]',208,1040,'[{3,2788},{7,1476}]'),(3,0,108,'[{255,36160004,13}]',26,130,'[{3,696},{7,348}]'),(3,1,108,'[{255,36160004,39}]',78,390,'[{3,1128},{7,564}]'),(3,2,108,'[{255,36160004,65}]',130,650,'[{3,1992},{7,996}]'),(3,3,108,'[{255,36160004,104}]',208,1040,'[{3,2822},{7,1494}]'),(3,0,109,'[{255,36160004,13}]',26,130,'[{3,708},{7,354}]'),(3,1,109,'[{255,36160004,39}]',78,390,'[{3,1144},{7,572}]'),(3,2,109,'[{255,36160004,65}]',130,650,'[{3,2016},{7,1008}]'),(3,3,109,'[{255,36160004,104}]',208,1040,'[{3,2856},{7,1512}]'),(3,0,110,'[{255,36160004,13}]',26,130,'[{3,720},{7,360}]'),(3,1,110,'[{255,36160004,39}]',78,390,'[{3,1160},{7,580}]'),(3,2,110,'[{255,36160004,65}]',130,650,'[{3,2040},{7,1020}]'),(3,3,110,'[{255,36160004,104}]',208,1040,'[{3,2890},{7,1530}]'),(3,0,111,'[{255,36160004,13}]',26,130,'[{3,732},{7,366}]'),(3,1,111,'[{255,36160004,39}]',78,390,'[{3,1176},{7,588}]'),(3,2,111,'[{255,36160004,65}]',130,650,'[{3,2064},{7,1032}]'),(3,3,111,'[{255,36160004,104}]',208,1040,'[{3,2924},{7,1548}]'),(3,0,112,'[{255,36160004,13}]',26,130,'[{3,744},{7,372}]'),(3,1,112,'[{255,36160004,39}]',78,390,'[{3,1192},{7,596}]'),(3,2,112,'[{255,36160004,65}]',130,650,'[{3,2088},{7,1044}]'),(3,3,112,'[{255,36160004,104}]',208,1040,'[{3,2958},{7,1566}]'),(3,0,113,'[{255,36160004,13}]',26,130,'[{3,756},{7,378}]'),(3,1,113,'[{255,36160004,39}]',78,390,'[{3,1208},{7,604}]'),(3,2,113,'[{255,36160004,65}]',130,650,'[{3,2112},{7,1056}]'),(3,3,113,'[{255,36160004,104}]',208,1040,'[{3,2992},{7,1584}]'),(3,0,114,'[{255,36160004,13}]',26,130,'[{3,768},{7,384}]'),(3,1,114,'[{255,36160004,39}]',78,390,'[{3,1224},{7,612}]'),(3,2,114,'[{255,36160004,65}]',130,650,'[{3,2136},{7,1068}]'),(3,3,114,'[{255,36160004,104}]',208,1040,'[{3,3026},{7,1602}]'),(3,0,115,'[{255,36160004,13}]',26,130,'[{3,780},{7,390}]'),(3,1,115,'[{255,36160004,39}]',78,390,'[{3,1240},{7,620}]'),(3,2,115,'[{255,36160004,65}]',130,650,'[{3,2160},{7,1080}]'),(3,3,115,'[{255,36160004,104}]',208,1040,'[{3,3060},{7,1620}]'),(3,0,116,'[{255,36160004,13}]',26,130,'[{3,792},{7,396}]'),(3,1,116,'[{255,36160004,39}]',78,390,'[{3,1256},{7,628}]'),(3,2,116,'[{255,36160004,65}]',130,650,'[{3,2184},{7,1092}]'),(3,3,116,'[{255,36160004,104}]',208,1040,'[{3,3094},{7,1638}]'),(3,0,117,'[{255,36160004,13}]',26,130,'[{3,804},{7,402}]'),(3,1,117,'[{255,36160004,39}]',78,390,'[{3,1272},{7,636}]'),(3,2,117,'[{255,36160004,65}]',130,650,'[{3,2208},{7,1104}]'),(3,3,117,'[{255,36160004,104}]',208,1040,'[{3,3128},{7,1656}]'),(3,0,118,'[{255,36160004,13}]',26,130,'[{3,816},{7,408}]'),(3,1,118,'[{255,36160004,39}]',78,390,'[{3,1288},{7,644}]'),(3,2,118,'[{255,36160004,65}]',130,650,'[{3,2232},{7,1116}]'),(3,3,118,'[{255,36160004,104}]',208,1040,'[{3,3162},{7,1674}]'),(3,0,119,'[{255,36160004,13}]',26,130,'[{3,828},{7,414}]'),(3,1,119,'[{255,36160004,39}]',78,390,'[{3,1304},{7,652}]'),(3,2,119,'[{255,36160004,65}]',130,650,'[{3,2256},{7,1128}]'),(3,3,119,'[{255,36160004,104}]',208,1040,'[{3,3196},{7,1692}]'),(3,0,120,'[{255,36160004,14}]',28,140,'[{3,840},{7,420}]'),(3,1,120,'[{255,36160004,42}]',84,420,'[{3,1320},{7,660}]'),(3,2,120,'[{255,36160004,70}]',140,700,'[{3,2280},{7,1140}]'),(3,3,120,'[{255,36160004,112}]',224,1120,'[{3,3230},{7,1710}]'),(3,0,121,'[{255,36160004,14}]',28,140,'[{3,852},{7,426}]'),(3,1,121,'[{255,36160004,42}]',84,420,'[{3,1336},{7,668}]'),(3,2,121,'[{255,36160004,70}]',140,700,'[{3,2304},{7,1152}]'),(3,3,121,'[{255,36160004,112}]',224,1120,'[{3,3264},{7,1728}]'),(3,0,122,'[{255,36160004,14}]',28,140,'[{3,864},{7,432}]'),(3,1,122,'[{255,36160004,42}]',84,420,'[{3,1352},{7,676}]'),(3,2,122,'[{255,36160004,70}]',140,700,'[{3,2328},{7,1164}]'),(3,3,122,'[{255,36160004,112}]',224,1120,'[{3,3298},{7,1746}]'),(3,0,123,'[{255,36160004,14}]',28,140,'[{3,876},{7,438}]'),(3,1,123,'[{255,36160004,42}]',84,420,'[{3,1368},{7,684}]'),(3,2,123,'[{255,36160004,70}]',140,700,'[{3,2352},{7,1176}]'),(3,3,123,'[{255,36160004,112}]',224,1120,'[{3,3332},{7,1764}]'),(3,0,124,'[{255,36160004,14}]',28,140,'[{3,888},{7,444}]'),(3,1,124,'[{255,36160004,42}]',84,420,'[{3,1384},{7,692}]'),(3,2,124,'[{255,36160004,70}]',140,700,'[{3,2376},{7,1188}]'),(3,3,124,'[{255,36160004,112}]',224,1120,'[{3,3366},{7,1782}]'),(3,0,125,'[{255,36160004,14}]',28,140,'[{3,900},{7,450}]'),(3,1,125,'[{255,36160004,42}]',84,420,'[{3,1400},{7,700}]'),(3,2,125,'[{255,36160004,70}]',140,700,'[{3,2400},{7,1200}]'),(3,3,125,'[{255,36160004,112}]',224,1120,'[{3,3400},{7,1800}]'),(3,0,126,'[{255,36160004,14}]',28,140,'[{3,912},{7,456}]'),(3,1,126,'[{255,36160004,42}]',84,420,'[{3,1416},{7,708}]'),(3,2,126,'[{255,36160004,70}]',140,700,'[{3,2424},{7,1212}]'),(3,3,126,'[{255,36160004,112}]',224,1120,'[{3,3434},{7,1818}]'),(3,0,127,'[{255,36160004,14}]',28,140,'[{3,924},{7,462}]'),(3,1,127,'[{255,36160004,42}]',84,420,'[{3,1432},{7,716}]'),(3,2,127,'[{255,36160004,70}]',140,700,'[{3,2448},{7,1224}]'),(3,3,127,'[{255,36160004,112}]',224,1120,'[{3,3468},{7,1836}]'),(3,0,128,'[{255,36160004,14}]',28,140,'[{3,936},{7,468}]'),(3,1,128,'[{255,36160004,42}]',84,420,'[{3,1448},{7,724}]'),(3,2,128,'[{255,36160004,70}]',140,700,'[{3,2472},{7,1236}]'),(3,3,128,'[{255,36160004,112}]',224,1120,'[{3,3502},{7,1854}]'),(3,0,129,'[{255,36160004,14}]',28,140,'[{3,948},{7,474}]'),(3,1,129,'[{255,36160004,42}]',84,420,'[{3,1464},{7,732}]'),(3,2,129,'[{255,36160004,70}]',140,700,'[{3,2496},{7,1248}]'),(3,3,129,'[{255,36160004,112}]',224,1120,'[{3,3536},{7,1872}]'),(3,0,130,'[{255,36160004,14}]',28,140,'[{3,960},{7,480}]'),(3,1,130,'[{255,36160004,42}]',84,420,'[{3,1480},{7,740}]'),(3,2,130,'[{255,36160004,70}]',140,700,'[{3,2520},{7,1260}]'),(3,3,130,'[{255,36160004,112}]',224,1120,'[{3,3570},{7,1890}]'),(3,0,131,'[{255,36160004,14}]',28,140,'[{3,972},{7,486}]'),(3,1,131,'[{255,36160004,42}]',84,420,'[{3,1496},{7,748}]'),(3,2,131,'[{255,36160004,70}]',140,700,'[{3,2544},{7,1272}]'),(3,3,131,'[{255,36160004,112}]',224,1120,'[{3,3604},{7,1908}]'),(3,0,132,'[{255,36160004,14}]',28,140,'[{3,984},{7,492}]'),(3,1,132,'[{255,36160004,42}]',84,420,'[{3,1512},{7,756}]'),(3,2,132,'[{255,36160004,70}]',140,700,'[{3,2568},{7,1284}]'),(3,3,132,'[{255,36160004,112}]',224,1120,'[{3,3638},{7,1926}]'),(3,0,133,'[{255,36160004,14}]',28,140,'[{3,996},{7,498}]'),(3,1,133,'[{255,36160004,42}]',84,420,'[{3,1528},{7,764}]'),(3,2,133,'[{255,36160004,70}]',140,700,'[{3,2592},{7,1296}]'),(3,3,133,'[{255,36160004,112}]',224,1120,'[{3,3672},{7,1944}]'),(3,0,134,'[{255,36160004,14}]',28,140,'[{3,1008},{7,504}]'),(3,1,134,'[{255,36160004,42}]',84,420,'[{3,1544},{7,772}]'),(3,2,134,'[{255,36160004,70}]',140,700,'[{3,2616},{7,1308}]'),(3,3,134,'[{255,36160004,112}]',224,1120,'[{3,3706},{7,1962}]'),(3,0,135,'[{255,36160004,15}]',30,150,'[{3,1020},{7,510}]'),(3,1,135,'[{255,36160004,45}]',90,450,'[{3,1560},{7,780}]'),(3,2,135,'[{255,36160004,75}]',150,750,'[{3,2640},{7,1320}]'),(3,3,135,'[{255,36160004,120}]',240,1200,'[{3,3740},{7,1980}]'),(3,0,136,'[{255,36160004,15}]',30,150,'[{3,1032},{7,516}]'),(3,1,136,'[{255,36160004,45}]',90,450,'[{3,1576},{7,788}]'),(3,2,136,'[{255,36160004,75}]',150,750,'[{3,2664},{7,1332}]'),(3,3,136,'[{255,36160004,120}]',240,1200,'[{3,3774},{7,1998}]'),(3,0,137,'[{255,36160004,15}]',30,150,'[{3,1044},{7,522}]'),(3,1,137,'[{255,36160004,45}]',90,450,'[{3,1592},{7,796}]'),(3,2,137,'[{255,36160004,75}]',150,750,'[{3,2688},{7,1344}]'),(3,3,137,'[{255,36160004,120}]',240,1200,'[{3,3808},{7,2016}]'),(3,0,138,'[{255,36160004,15}]',30,150,'[{3,1056},{7,528}]'),(3,1,138,'[{255,36160004,45}]',90,450,'[{3,1608},{7,804}]'),(3,2,138,'[{255,36160004,75}]',150,750,'[{3,2712},{7,1356}]'),(3,3,138,'[{255,36160004,120}]',240,1200,'[{3,3842},{7,2034}]'),(3,0,139,'[{255,36160004,15}]',30,150,'[{3,1068},{7,534}]'),(3,1,139,'[{255,36160004,45}]',90,450,'[{3,1624},{7,812}]'),(3,2,139,'[{255,36160004,75}]',150,750,'[{3,2736},{7,1368}]'),(3,3,139,'[{255,36160004,120}]',240,1200,'[{3,3876},{7,2052}]'),(3,0,140,'[{255,36160004,15}]',30,150,'[{3,1080},{7,540}]'),(3,1,140,'[{255,36160004,45}]',90,450,'[{3,1640},{7,820}]'),(3,2,140,'[{255,36160004,75}]',150,750,'[{3,2760},{7,1380}]'),(3,3,140,'[{255,36160004,120}]',240,1200,'[{3,3910},{7,2070}]'),(3,0,141,'[{255,36160004,15}]',30,150,'[{3,1092},{7,546}]'),(3,1,141,'[{255,36160004,45}]',90,450,'[{3,1656},{7,828}]'),(3,2,141,'[{255,36160004,75}]',150,750,'[{3,2784},{7,1392}]'),(3,3,141,'[{255,36160004,120}]',240,1200,'[{3,3944},{7,2088}]'),(3,0,142,'[{255,36160004,15}]',30,150,'[{3,1104},{7,552}]'),(3,1,142,'[{255,36160004,45}]',90,450,'[{3,1672},{7,836}]'),(3,2,142,'[{255,36160004,75}]',150,750,'[{3,2808},{7,1404}]'),(3,3,142,'[{255,36160004,120}]',240,1200,'[{3,3978},{7,2106}]'),(3,0,143,'[{255,36160004,15}]',30,150,'[{3,1116},{7,558}]'),(3,1,143,'[{255,36160004,45}]',90,450,'[{3,1688},{7,844}]'),(3,2,143,'[{255,36160004,75}]',150,750,'[{3,2832},{7,1416}]'),(3,3,143,'[{255,36160004,120}]',240,1200,'[{3,4012},{7,2124}]'),(3,0,144,'[{255,36160004,15}]',30,150,'[{3,1128},{7,564}]'),(3,1,144,'[{255,36160004,45}]',90,450,'[{3,1704},{7,852}]'),(3,2,144,'[{255,36160004,75}]',150,750,'[{3,2856},{7,1428}]'),(3,3,144,'[{255,36160004,120}]',240,1200,'[{3,4046},{7,2142}]'),(3,0,145,'[{255,36160004,15}]',30,150,'[{3,1140},{7,570}]'),(3,1,145,'[{255,36160004,45}]',90,450,'[{3,1720},{7,860}]'),(3,2,145,'[{255,36160004,75}]',150,750,'[{3,2880},{7,1440}]'),(3,3,145,'[{255,36160004,120}]',240,1200,'[{3,4080},{7,2160}]'),(3,0,146,'[{255,36160004,15}]',30,150,'[{3,1152},{7,576}]'),(3,1,146,'[{255,36160004,45}]',90,450,'[{3,1736},{7,868}]'),(3,2,146,'[{255,36160004,75}]',150,750,'[{3,2904},{7,1452}]'),(3,3,146,'[{255,36160004,120}]',240,1200,'[{3,4114},{7,2178}]'),(3,0,147,'[{255,36160004,15}]',30,150,'[{3,1164},{7,582}]'),(3,1,147,'[{255,36160004,45}]',90,450,'[{3,1752},{7,876}]'),(3,2,147,'[{255,36160004,75}]',150,750,'[{3,2928},{7,1464}]'),(3,3,147,'[{255,36160004,120}]',240,1200,'[{3,4148},{7,2196}]'),(3,0,148,'[{255,36160004,15}]',30,150,'[{3,1176},{7,588}]'),(3,1,148,'[{255,36160004,45}]',90,450,'[{3,1768},{7,884}]'),(3,2,148,'[{255,36160004,75}]',150,750,'[{3,2952},{7,1476}]'),(3,3,148,'[{255,36160004,120}]',240,1200,'[{3,4182},{7,2214}]'),(3,0,149,'[{255,36160004,15}]',30,150,'[{3,1188},{7,594}]'),(3,1,149,'[{255,36160004,45}]',90,450,'[{3,1784},{7,892}]'),(3,2,149,'[{255,36160004,75}]',150,750,'[{3,2976},{7,1488}]'),(3,3,149,'[{255,36160004,120}]',240,1200,'[{3,4216},{7,2232}]'),(3,0,150,'[{255,36160004,15}]',30,150,'[{3,1200},{7,600}]'),(3,1,150,'[{255,36160004,45}]',90,450,'[{3,1800},{7,900}]'),(3,2,150,'[{255,36160004,75}]',150,750,'[{3,3000},{7,1500}]'),(3,3,150,'[{255,36160004,120}]',240,1200,'[{3,4250},{7,2250}]'),(4,0,0,'[{255,36160004,5}]',10,50,'[{4,0},{8,0}]'),(4,1,0,'[{255,36160004,15}]',30,150,'[{4,0},{8,0}]'),(4,2,0,'[{255,36160004,25}]',50,250,'[{4,0},{8,0}]'),(4,3,0,'[{255,36160004,40}]',80,400,'[{4,0},{8,0}]'),(4,0,1,'[{255,36160004,5}]',10,50,'[{4,4},{8,2}]'),(4,1,1,'[{255,36160004,15}]',30,150,'[{4,8},{8,4}]'),(4,2,1,'[{255,36160004,25}]',50,250,'[{4,16},{8,8}]'),(4,3,1,'[{255,36160004,40}]',80,400,'[{4,23},{8,12}]'),(4,0,2,'[{255,36160004,5}]',10,50,'[{4,8},{8,4}]'),(4,1,2,'[{255,36160004,15}]',30,150,'[{4,16},{8,8}]'),(4,2,2,'[{255,36160004,25}]',50,250,'[{4,32},{8,16}]'),(4,3,2,'[{255,36160004,40}]',80,400,'[{4,46},{8,24}]'),(4,0,3,'[{255,36160004,5}]',10,50,'[{4,12},{8,6}]'),(4,1,3,'[{255,36160004,15}]',30,150,'[{4,24},{8,12}]'),(4,2,3,'[{255,36160004,25}]',50,250,'[{4,48},{8,24}]'),(4,3,3,'[{255,36160004,40}]',80,400,'[{4,69},{8,36}]'),(4,0,4,'[{255,36160004,5}]',10,50,'[{4,16},{8,8}]'),(4,1,4,'[{255,36160004,15}]',30,150,'[{4,32},{8,16}]'),(4,2,4,'[{255,36160004,25}]',50,250,'[{4,64},{8,32}]'),(4,3,4,'[{255,36160004,40}]',80,400,'[{4,92},{8,48}]'),(4,0,5,'[{255,36160004,5}]',10,50,'[{4,20},{8,10}]'),(4,1,5,'[{255,36160004,15}]',30,150,'[{4,40},{8,20}]'),(4,2,5,'[{255,36160004,25}]',50,250,'[{4,80},{8,40}]'),(4,3,5,'[{255,36160004,40}]',80,400,'[{4,115},{8,60}]'),(4,0,6,'[{255,36160004,5}]',10,50,'[{4,24},{8,12}]'),(4,1,6,'[{255,36160004,15}]',30,150,'[{4,48},{8,24}]'),(4,2,6,'[{255,36160004,25}]',50,250,'[{4,96},{8,48}]'),(4,3,6,'[{255,36160004,40}]',80,400,'[{4,138},{8,72}]'),(4,0,7,'[{255,36160004,5}]',10,50,'[{4,28},{8,14}]'),(4,1,7,'[{255,36160004,15}]',30,150,'[{4,56},{8,28}]'),(4,2,7,'[{255,36160004,25}]',50,250,'[{4,112},{8,56}]'),(4,3,7,'[{255,36160004,40}]',80,400,'[{4,161},{8,84}]'),(4,0,8,'[{255,36160004,5}]',10,50,'[{4,32},{8,16}]'),(4,1,8,'[{255,36160004,15}]',30,150,'[{4,64},{8,32}]'),(4,2,8,'[{255,36160004,25}]',50,250,'[{4,128},{8,64}]'),(4,3,8,'[{255,36160004,40}]',80,400,'[{4,184},{8,96}]'),(4,0,9,'[{255,36160004,5}]',10,50,'[{4,36},{8,18}]'),(4,1,9,'[{255,36160004,15}]',30,150,'[{4,72},{8,36}]'),(4,2,9,'[{255,36160004,25}]',50,250,'[{4,144},{8,72}]'),(4,3,9,'[{255,36160004,40}]',80,400,'[{4,207},{8,108}]'),(4,0,10,'[{255,36160004,6}]',12,60,'[{4,40},{8,20}]'),(4,1,10,'[{255,36160004,18}]',36,180,'[{4,80},{8,40}]'),(4,2,10,'[{255,36160004,30}]',60,300,'[{4,160},{8,80}]'),(4,3,10,'[{255,36160004,48}]',96,480,'[{4,230},{8,120}]'),(4,0,11,'[{255,36160004,6}]',12,60,'[{4,44},{8,22}]'),(4,1,11,'[{255,36160004,18}]',36,180,'[{4,88},{8,44}]'),(4,2,11,'[{255,36160004,30}]',60,300,'[{4,176},{8,88}]'),(4,3,11,'[{255,36160004,48}]',96,480,'[{4,253},{8,132}]'),(4,0,12,'[{255,36160004,6}]',12,60,'[{4,48},{8,24}]'),(4,1,12,'[{255,36160004,18}]',36,180,'[{4,96},{8,48}]'),(4,2,12,'[{255,36160004,30}]',60,300,'[{4,192},{8,96}]'),(4,3,12,'[{255,36160004,48}]',96,480,'[{4,276},{8,144}]'),(4,0,13,'[{255,36160004,6}]',12,60,'[{4,52},{8,26}]'),(4,1,13,'[{255,36160004,18}]',36,180,'[{4,104},{8,52}]'),(4,2,13,'[{255,36160004,30}]',60,300,'[{4,208},{8,104}]'),(4,3,13,'[{255,36160004,48}]',96,480,'[{4,299},{8,156}]'),(4,0,14,'[{255,36160004,6}]',12,60,'[{4,56},{8,28}]'),(4,1,14,'[{255,36160004,18}]',36,180,'[{4,112},{8,56}]'),(4,2,14,'[{255,36160004,30}]',60,300,'[{4,224},{8,112}]'),(4,3,14,'[{255,36160004,48}]',96,480,'[{4,322},{8,168}]'),(4,0,15,'[{255,36160004,6}]',12,60,'[{4,60},{8,30}]'),(4,1,15,'[{255,36160004,18}]',36,180,'[{4,120},{8,60}]'),(4,2,15,'[{255,36160004,30}]',60,300,'[{4,240},{8,120}]'),(4,3,15,'[{255,36160004,48}]',96,480,'[{4,345},{8,180}]'),(4,0,16,'[{255,36160004,6}]',12,60,'[{4,64},{8,32}]'),(4,1,16,'[{255,36160004,18}]',36,180,'[{4,128},{8,64}]'),(4,2,16,'[{255,36160004,30}]',60,300,'[{4,256},{8,128}]'),(4,3,16,'[{255,36160004,48}]',96,480,'[{4,368},{8,192}]'),(4,0,17,'[{255,36160004,6}]',12,60,'[{4,68},{8,34}]'),(4,1,17,'[{255,36160004,18}]',36,180,'[{4,136},{8,68}]'),(4,2,17,'[{255,36160004,30}]',60,300,'[{4,272},{8,136}]'),(4,3,17,'[{255,36160004,48}]',96,480,'[{4,391},{8,204}]'),(4,0,18,'[{255,36160004,6}]',12,60,'[{4,72},{8,36}]'),(4,1,18,'[{255,36160004,18}]',36,180,'[{4,144},{8,72}]'),(4,2,18,'[{255,36160004,30}]',60,300,'[{4,288},{8,144}]'),(4,3,18,'[{255,36160004,48}]',96,480,'[{4,414},{8,216}]'),(4,0,19,'[{255,36160004,6}]',12,60,'[{4,76},{8,38}]'),(4,1,19,'[{255,36160004,18}]',36,180,'[{4,152},{8,76}]'),(4,2,19,'[{255,36160004,30}]',60,300,'[{4,304},{8,152}]'),(4,3,19,'[{255,36160004,48}]',96,480,'[{4,437},{8,228}]'),(4,0,20,'[{255,36160004,7}]',14,70,'[{4,80},{8,40}]'),(4,1,20,'[{255,36160004,21}]',42,210,'[{4,160},{8,80}]'),(4,2,20,'[{255,36160004,35}]',70,350,'[{4,320},{8,160}]'),(4,3,20,'[{255,36160004,56}]',112,560,'[{4,460},{8,240}]'),(4,0,21,'[{255,36160004,7}]',14,70,'[{4,84},{8,42}]'),(4,1,21,'[{255,36160004,21}]',42,210,'[{4,168},{8,84}]'),(4,2,21,'[{255,36160004,35}]',70,350,'[{4,336},{8,168}]'),(4,3,21,'[{255,36160004,56}]',112,560,'[{4,483},{8,252}]'),(4,0,22,'[{255,36160004,7}]',14,70,'[{4,88},{8,44}]'),(4,1,22,'[{255,36160004,21}]',42,210,'[{4,176},{8,88}]'),(4,2,22,'[{255,36160004,35}]',70,350,'[{4,352},{8,176}]'),(4,3,22,'[{255,36160004,56}]',112,560,'[{4,506},{8,264}]'),(4,0,23,'[{255,36160004,7}]',14,70,'[{4,92},{8,46}]'),(4,1,23,'[{255,36160004,21}]',42,210,'[{4,184},{8,92}]'),(4,2,23,'[{255,36160004,35}]',70,350,'[{4,368},{8,184}]'),(4,3,23,'[{255,36160004,56}]',112,560,'[{4,529},{8,276}]'),(4,0,24,'[{255,36160004,7}]',14,70,'[{4,96},{8,48}]'),(4,1,24,'[{255,36160004,21}]',42,210,'[{4,192},{8,96}]'),(4,2,24,'[{255,36160004,35}]',70,350,'[{4,384},{8,192}]'),(4,3,24,'[{255,36160004,56}]',112,560,'[{4,552},{8,288}]'),(4,0,25,'[{255,36160004,7}]',14,70,'[{4,100},{8,50}]'),(4,1,25,'[{255,36160004,21}]',42,210,'[{4,200},{8,100}]'),(4,2,25,'[{255,36160004,35}]',70,350,'[{4,400},{8,200}]'),(4,3,25,'[{255,36160004,56}]',112,560,'[{4,575},{8,300}]'),(4,0,26,'[{255,36160004,7}]',14,70,'[{4,104},{8,52}]'),(4,1,26,'[{255,36160004,21}]',42,210,'[{4,208},{8,104}]'),(4,2,26,'[{255,36160004,35}]',70,350,'[{4,416},{8,208}]'),(4,3,26,'[{255,36160004,56}]',112,560,'[{4,598},{8,312}]'),(4,0,27,'[{255,36160004,7}]',14,70,'[{4,108},{8,54}]'),(4,1,27,'[{255,36160004,21}]',42,210,'[{4,216},{8,108}]'),(4,2,27,'[{255,36160004,35}]',70,350,'[{4,432},{8,216}]'),(4,3,27,'[{255,36160004,56}]',112,560,'[{4,621},{8,324}]'),(4,0,28,'[{255,36160004,7}]',14,70,'[{4,112},{8,56}]'),(4,1,28,'[{255,36160004,21}]',42,210,'[{4,224},{8,112}]'),(4,2,28,'[{255,36160004,35}]',70,350,'[{4,448},{8,224}]'),(4,3,28,'[{255,36160004,56}]',112,560,'[{4,644},{8,336}]'),(4,0,29,'[{255,36160004,7}]',14,70,'[{4,116},{8,58}]'),(4,1,29,'[{255,36160004,21}]',42,210,'[{4,232},{8,116}]'),(4,2,29,'[{255,36160004,35}]',70,350,'[{4,464},{8,232}]'),(4,3,29,'[{255,36160004,56}]',112,560,'[{4,667},{8,348}]'),(4,0,30,'[{255,36160004,8}]',16,80,'[{4,120},{8,60}]'),(4,1,30,'[{255,36160004,24}]',48,240,'[{4,240},{8,120}]'),(4,2,30,'[{255,36160004,40}]',80,400,'[{4,480},{8,240}]'),(4,3,30,'[{255,36160004,64}]',128,640,'[{4,690},{8,360}]'),(4,0,31,'[{255,36160004,8}]',16,80,'[{4,124},{8,62}]'),(4,1,31,'[{255,36160004,24}]',48,240,'[{4,248},{8,124}]'),(4,2,31,'[{255,36160004,40}]',80,400,'[{4,496},{8,248}]'),(4,3,31,'[{255,36160004,64}]',128,640,'[{4,713},{8,372}]'),(4,0,32,'[{255,36160004,8}]',16,80,'[{4,128},{8,64}]'),(4,1,32,'[{255,36160004,24}]',48,240,'[{4,256},{8,128}]'),(4,2,32,'[{255,36160004,40}]',80,400,'[{4,512},{8,256}]'),(4,3,32,'[{255,36160004,64}]',128,640,'[{4,736},{8,384}]'),(4,0,33,'[{255,36160004,8}]',16,80,'[{4,132},{8,66}]'),(4,1,33,'[{255,36160004,24}]',48,240,'[{4,264},{8,132}]'),(4,2,33,'[{255,36160004,40}]',80,400,'[{4,528},{8,264}]'),(4,3,33,'[{255,36160004,64}]',128,640,'[{4,759},{8,396}]'),(4,0,34,'[{255,36160004,8}]',16,80,'[{4,136},{8,68}]'),(4,1,34,'[{255,36160004,24}]',48,240,'[{4,272},{8,136}]'),(4,2,34,'[{255,36160004,40}]',80,400,'[{4,544},{8,272}]'),(4,3,34,'[{255,36160004,64}]',128,640,'[{4,782},{8,408}]'),(4,0,35,'[{255,36160004,8}]',16,80,'[{4,140},{8,70}]'),(4,1,35,'[{255,36160004,24}]',48,240,'[{4,280},{8,140}]'),(4,2,35,'[{255,36160004,40}]',80,400,'[{4,560},{8,280}]'),(4,3,35,'[{255,36160004,64}]',128,640,'[{4,805},{8,420}]'),(4,0,36,'[{255,36160004,8}]',16,80,'[{4,144},{8,72}]'),(4,1,36,'[{255,36160004,24}]',48,240,'[{4,288},{8,144}]'),(4,2,36,'[{255,36160004,40}]',80,400,'[{4,576},{8,288}]'),(4,3,36,'[{255,36160004,64}]',128,640,'[{4,828},{8,432}]'),(4,0,37,'[{255,36160004,8}]',16,80,'[{4,148},{8,74}]'),(4,1,37,'[{255,36160004,24}]',48,240,'[{4,296},{8,148}]'),(4,2,37,'[{255,36160004,40}]',80,400,'[{4,592},{8,296}]'),(4,3,37,'[{255,36160004,64}]',128,640,'[{4,851},{8,444}]'),(4,0,38,'[{255,36160004,8}]',16,80,'[{4,152},{8,76}]'),(4,1,38,'[{255,36160004,24}]',48,240,'[{4,304},{8,152}]'),(4,2,38,'[{255,36160004,40}]',80,400,'[{4,608},{8,304}]'),(4,3,38,'[{255,36160004,64}]',128,640,'[{4,874},{8,456}]'),(4,0,39,'[{255,36160004,8}]',16,80,'[{4,156},{8,78}]'),(4,1,39,'[{255,36160004,24}]',48,240,'[{4,312},{8,156}]'),(4,2,39,'[{255,36160004,40}]',80,400,'[{4,624},{8,312}]'),(4,3,39,'[{255,36160004,64}]',128,640,'[{4,897},{8,468}]'),(4,0,40,'[{255,36160004,8}]',16,80,'[{4,160},{8,80}]'),(4,1,40,'[{255,36160004,24}]',48,240,'[{4,320},{8,160}]'),(4,2,40,'[{255,36160004,40}]',80,400,'[{4,640},{8,320}]'),(4,3,40,'[{255,36160004,64}]',128,640,'[{4,920},{8,480}]'),(4,0,41,'[{255,36160004,8}]',16,80,'[{4,164},{8,82}]'),(4,1,41,'[{255,36160004,24}]',48,240,'[{4,328},{8,164}]'),(4,2,41,'[{255,36160004,40}]',80,400,'[{4,656},{8,328}]'),(4,3,41,'[{255,36160004,64}]',128,640,'[{4,943},{8,492}]'),(4,0,42,'[{255,36160004,8}]',16,80,'[{4,168},{8,84}]'),(4,1,42,'[{255,36160004,24}]',48,240,'[{4,336},{8,168}]'),(4,2,42,'[{255,36160004,40}]',80,400,'[{4,672},{8,336}]'),(4,3,42,'[{255,36160004,64}]',128,640,'[{4,966},{8,504}]'),(4,0,43,'[{255,36160004,8}]',16,80,'[{4,172},{8,86}]'),(4,1,43,'[{255,36160004,24}]',48,240,'[{4,344},{8,172}]'),(4,2,43,'[{255,36160004,40}]',80,400,'[{4,688},{8,344}]'),(4,3,43,'[{255,36160004,64}]',128,640,'[{4,989},{8,516}]'),(4,0,44,'[{255,36160004,8}]',16,80,'[{4,176},{8,88}]'),(4,1,44,'[{255,36160004,24}]',48,240,'[{4,352},{8,176}]'),(4,2,44,'[{255,36160004,40}]',80,400,'[{4,704},{8,352}]'),(4,3,44,'[{255,36160004,64}]',128,640,'[{4,1012},{8,528}]'),(4,0,45,'[{255,36160004,9}]',18,90,'[{4,180},{8,90}]'),(4,1,45,'[{255,36160004,27}]',54,270,'[{4,360},{8,180}]'),(4,2,45,'[{255,36160004,45}]',90,450,'[{4,720},{8,360}]'),(4,3,45,'[{255,36160004,72}]',144,720,'[{4,1035},{8,540}]'),(4,0,46,'[{255,36160004,9}]',18,90,'[{4,184},{8,92}]'),(4,1,46,'[{255,36160004,27}]',54,270,'[{4,368},{8,184}]'),(4,2,46,'[{255,36160004,45}]',90,450,'[{4,736},{8,368}]'),(4,3,46,'[{255,36160004,72}]',144,720,'[{4,1058},{8,552}]'),(4,0,47,'[{255,36160004,9}]',18,90,'[{4,188},{8,94}]'),(4,1,47,'[{255,36160004,27}]',54,270,'[{4,376},{8,188}]'),(4,2,47,'[{255,36160004,45}]',90,450,'[{4,752},{8,376}]'),(4,3,47,'[{255,36160004,72}]',144,720,'[{4,1081},{8,564}]'),(4,0,48,'[{255,36160004,9}]',18,90,'[{4,192},{8,96}]'),(4,1,48,'[{255,36160004,27}]',54,270,'[{4,384},{8,192}]'),(4,2,48,'[{255,36160004,45}]',90,450,'[{4,768},{8,384}]'),(4,3,48,'[{255,36160004,72}]',144,720,'[{4,1104},{8,576}]'),(4,0,49,'[{255,36160004,9}]',18,90,'[{4,196},{8,98}]'),(4,1,49,'[{255,36160004,27}]',54,270,'[{4,392},{8,196}]'),(4,2,49,'[{255,36160004,45}]',90,450,'[{4,784},{8,392}]'),(4,3,49,'[{255,36160004,72}]',144,720,'[{4,1127},{8,588}]'),(4,0,50,'[{255,36160004,9}]',18,90,'[{4,200},{8,100}]'),(4,1,50,'[{255,36160004,27}]',54,270,'[{4,400},{8,200}]'),(4,2,50,'[{255,36160004,45}]',90,450,'[{4,800},{8,400}]'),(4,3,50,'[{255,36160004,72}]',144,720,'[{4,1150},{8,600}]'),(4,0,51,'[{255,36160004,9}]',18,90,'[{4,208},{8,104}]'),(4,1,51,'[{255,36160004,27}]',54,270,'[{4,412},{8,206}]'),(4,2,51,'[{255,36160004,45}]',90,450,'[{4,820},{8,410}]'),(4,3,51,'[{255,36160004,72}]',144,720,'[{4,1178},{8,615}]'),(4,0,52,'[{255,36160004,9}]',18,90,'[{4,216},{8,108}]'),(4,1,52,'[{255,36160004,27}]',54,270,'[{4,424},{8,212}]'),(4,2,52,'[{255,36160004,45}]',90,450,'[{4,840},{8,420}]'),(4,3,52,'[{255,36160004,72}]',144,720,'[{4,1206},{8,630}]'),(4,0,53,'[{255,36160004,9}]',18,90,'[{4,224},{8,112}]'),(4,1,53,'[{255,36160004,27}]',54,270,'[{4,436},{8,218}]'),(4,2,53,'[{255,36160004,45}]',90,450,'[{4,860},{8,430}]'),(4,3,53,'[{255,36160004,72}]',144,720,'[{4,1234},{8,645}]'),(4,0,54,'[{255,36160004,9}]',18,90,'[{4,232},{8,116}]'),(4,1,54,'[{255,36160004,27}]',54,270,'[{4,448},{8,224}]'),(4,2,54,'[{255,36160004,45}]',90,450,'[{4,880},{8,440}]'),(4,3,54,'[{255,36160004,72}]',144,720,'[{4,1262},{8,660}]'),(4,0,55,'[{255,36160004,9}]',18,90,'[{4,240},{8,120}]'),(4,1,55,'[{255,36160004,27}]',54,270,'[{4,460},{8,230}]'),(4,2,55,'[{255,36160004,45}]',90,450,'[{4,900},{8,450}]'),(4,3,55,'[{255,36160004,72}]',144,720,'[{4,1290},{8,675}]'),(4,0,56,'[{255,36160004,9}]',18,90,'[{4,248},{8,124}]'),(4,1,56,'[{255,36160004,27}]',54,270,'[{4,472},{8,236}]'),(4,2,56,'[{255,36160004,45}]',90,450,'[{4,920},{8,460}]'),(4,3,56,'[{255,36160004,72}]',144,720,'[{4,1318},{8,690}]'),(4,0,57,'[{255,36160004,9}]',18,90,'[{4,256},{8,128}]'),(4,1,57,'[{255,36160004,27}]',54,270,'[{4,484},{8,242}]'),(4,2,57,'[{255,36160004,45}]',90,450,'[{4,940},{8,470}]'),(4,3,57,'[{255,36160004,72}]',144,720,'[{4,1346},{8,705}]'),(4,0,58,'[{255,36160004,9}]',18,90,'[{4,264},{8,132}]'),(4,1,58,'[{255,36160004,27}]',54,270,'[{4,496},{8,248}]'),(4,2,58,'[{255,36160004,45}]',90,450,'[{4,960},{8,480}]'),(4,3,58,'[{255,36160004,72}]',144,720,'[{4,1374},{8,720}]'),(4,0,59,'[{255,36160004,9}]',18,90,'[{4,272},{8,136}]'),(4,1,59,'[{255,36160004,27}]',54,270,'[{4,508},{8,254}]'),(4,2,59,'[{255,36160004,45}]',90,450,'[{4,980},{8,490}]'),(4,3,59,'[{255,36160004,72}]',144,720,'[{4,1402},{8,735}]'),(4,0,60,'[{255,36160004,10}]',20,100,'[{4,280},{8,140}]'),(4,1,60,'[{255,36160004,30}]',60,300,'[{4,520},{8,260}]'),(4,2,60,'[{255,36160004,50}]',100,500,'[{4,1000},{8,500}]'),(4,3,60,'[{255,36160004,80}]',160,800,'[{4,1430},{8,750}]'),(4,0,61,'[{255,36160004,10}]',20,100,'[{4,288},{8,144}]'),(4,1,61,'[{255,36160004,30}]',60,300,'[{4,532},{8,266}]'),(4,2,61,'[{255,36160004,50}]',100,500,'[{4,1020},{8,510}]'),(4,3,61,'[{255,36160004,80}]',160,800,'[{4,1458},{8,765}]'),(4,0,62,'[{255,36160004,10}]',20,100,'[{4,296},{8,148}]'),(4,1,62,'[{255,36160004,30}]',60,300,'[{4,544},{8,272}]'),(4,2,62,'[{255,36160004,50}]',100,500,'[{4,1040},{8,520}]'),(4,3,62,'[{255,36160004,80}]',160,800,'[{4,1486},{8,780}]'),(4,0,63,'[{255,36160004,10}]',20,100,'[{4,304},{8,152}]'),(4,1,63,'[{255,36160004,30}]',60,300,'[{4,556},{8,278}]'),(4,2,63,'[{255,36160004,50}]',100,500,'[{4,1060},{8,530}]'),(4,3,63,'[{255,36160004,80}]',160,800,'[{4,1514},{8,795}]'),(4,0,64,'[{255,36160004,10}]',20,100,'[{4,312},{8,156}]'),(4,1,64,'[{255,36160004,30}]',60,300,'[{4,568},{8,284}]'),(4,2,64,'[{255,36160004,50}]',100,500,'[{4,1080},{8,540}]'),(4,3,64,'[{255,36160004,80}]',160,800,'[{4,1542},{8,810}]'),(4,0,65,'[{255,36160004,10}]',20,100,'[{4,320},{8,160}]'),(4,1,65,'[{255,36160004,30}]',60,300,'[{4,580},{8,290}]'),(4,2,65,'[{255,36160004,50}]',100,500,'[{4,1100},{8,550}]'),(4,3,65,'[{255,36160004,80}]',160,800,'[{4,1570},{8,825}]'),(4,0,66,'[{255,36160004,10}]',20,100,'[{4,328},{8,164}]'),(4,1,66,'[{255,36160004,30}]',60,300,'[{4,592},{8,296}]'),(4,2,66,'[{255,36160004,50}]',100,500,'[{4,1120},{8,560}]'),(4,3,66,'[{255,36160004,80}]',160,800,'[{4,1598},{8,840}]'),(4,0,67,'[{255,36160004,10}]',20,100,'[{4,336},{8,168}]'),(4,1,67,'[{255,36160004,30}]',60,300,'[{4,604},{8,302}]'),(4,2,67,'[{255,36160004,50}]',100,500,'[{4,1140},{8,570}]'),(4,3,67,'[{255,36160004,80}]',160,800,'[{4,1626},{8,855}]'),(4,0,68,'[{255,36160004,10}]',20,100,'[{4,344},{8,172}]'),(4,1,68,'[{255,36160004,30}]',60,300,'[{4,616},{8,308}]'),(4,2,68,'[{255,36160004,50}]',100,500,'[{4,1160},{8,580}]'),(4,3,68,'[{255,36160004,80}]',160,800,'[{4,1654},{8,870}]'),(4,0,69,'[{255,36160004,10}]',20,100,'[{4,352},{8,176}]'),(4,1,69,'[{255,36160004,30}]',60,300,'[{4,628},{8,314}]'),(4,2,69,'[{255,36160004,50}]',100,500,'[{4,1180},{8,590}]'),(4,3,69,'[{255,36160004,80}]',160,800,'[{4,1682},{8,885}]'),(4,0,70,'[{255,36160004,10}]',20,100,'[{4,360},{8,180}]'),(4,1,70,'[{255,36160004,30}]',60,300,'[{4,640},{8,320}]'),(4,2,70,'[{255,36160004,50}]',100,500,'[{4,1200},{8,600}]'),(4,3,70,'[{255,36160004,80}]',160,800,'[{4,1710},{8,900}]'),(4,0,71,'[{255,36160004,10}]',20,100,'[{4,368},{8,184}]'),(4,1,71,'[{255,36160004,30}]',60,300,'[{4,652},{8,326}]'),(4,2,71,'[{255,36160004,50}]',100,500,'[{4,1220},{8,610}]'),(4,3,71,'[{255,36160004,80}]',160,800,'[{4,1738},{8,915}]'),(4,0,72,'[{255,36160004,10}]',20,100,'[{4,376},{8,188}]'),(4,1,72,'[{255,36160004,30}]',60,300,'[{4,664},{8,332}]'),(4,2,72,'[{255,36160004,50}]',100,500,'[{4,1240},{8,620}]'),(4,3,72,'[{255,36160004,80}]',160,800,'[{4,1766},{8,930}]'),(4,0,73,'[{255,36160004,10}]',20,100,'[{4,384},{8,192}]'),(4,1,73,'[{255,36160004,30}]',60,300,'[{4,676},{8,338}]'),(4,2,73,'[{255,36160004,50}]',100,500,'[{4,1260},{8,630}]'),(4,3,73,'[{255,36160004,80}]',160,800,'[{4,1794},{8,945}]'),(4,0,74,'[{255,36160004,10}]',20,100,'[{4,392},{8,196}]'),(4,1,74,'[{255,36160004,30}]',60,300,'[{4,688},{8,344}]'),(4,2,74,'[{255,36160004,50}]',100,500,'[{4,1280},{8,640}]'),(4,3,74,'[{255,36160004,80}]',160,800,'[{4,1822},{8,960}]'),(4,0,75,'[{255,36160004,11}]',22,110,'[{4,400},{8,200}]'),(4,1,75,'[{255,36160004,33}]',66,330,'[{4,700},{8,350}]'),(4,2,75,'[{255,36160004,55}]',110,550,'[{4,1300},{8,650}]'),(4,3,75,'[{255,36160004,88}]',176,880,'[{4,1850},{8,975}]'),(4,0,76,'[{255,36160004,11}]',22,110,'[{4,408},{8,204}]'),(4,1,76,'[{255,36160004,33}]',66,330,'[{4,712},{8,356}]'),(4,2,76,'[{255,36160004,55}]',110,550,'[{4,1320},{8,660}]'),(4,3,76,'[{255,36160004,88}]',176,880,'[{4,1878},{8,990}]'),(4,0,77,'[{255,36160004,11}]',22,110,'[{4,416},{8,208}]'),(4,1,77,'[{255,36160004,33}]',66,330,'[{4,724},{8,362}]'),(4,2,77,'[{255,36160004,55}]',110,550,'[{4,1340},{8,670}]'),(4,3,77,'[{255,36160004,88}]',176,880,'[{4,1906},{8,1005}]'),(4,0,78,'[{255,36160004,11}]',22,110,'[{4,424},{8,212}]'),(4,1,78,'[{255,36160004,33}]',66,330,'[{4,736},{8,368}]'),(4,2,78,'[{255,36160004,55}]',110,550,'[{4,1360},{8,680}]'),(4,3,78,'[{255,36160004,88}]',176,880,'[{4,1934},{8,1020}]'),(4,0,79,'[{255,36160004,11}]',22,110,'[{4,432},{8,216}]'),(4,1,79,'[{255,36160004,33}]',66,330,'[{4,748},{8,374}]'),(4,2,79,'[{255,36160004,55}]',110,550,'[{4,1380},{8,690}]'),(4,3,79,'[{255,36160004,88}]',176,880,'[{4,1962},{8,1035}]'),(4,0,80,'[{255,36160004,11}]',22,110,'[{4,440},{8,220}]'),(4,1,80,'[{255,36160004,33}]',66,330,'[{4,760},{8,380}]'),(4,2,80,'[{255,36160004,55}]',110,550,'[{4,1400},{8,700}]'),(4,3,80,'[{255,36160004,88}]',176,880,'[{4,1990},{8,1050}]'),(4,0,81,'[{255,36160004,11}]',22,110,'[{4,448},{8,224}]'),(4,1,81,'[{255,36160004,33}]',66,330,'[{4,772},{8,386}]'),(4,2,81,'[{255,36160004,55}]',110,550,'[{4,1420},{8,710}]'),(4,3,81,'[{255,36160004,88}]',176,880,'[{4,2018},{8,1065}]'),(4,0,82,'[{255,36160004,11}]',22,110,'[{4,456},{8,228}]'),(4,1,82,'[{255,36160004,33}]',66,330,'[{4,784},{8,392}]'),(4,2,82,'[{255,36160004,55}]',110,550,'[{4,1440},{8,720}]'),(4,3,82,'[{255,36160004,88}]',176,880,'[{4,2046},{8,1080}]'),(4,0,83,'[{255,36160004,11}]',22,110,'[{4,464},{8,232}]'),(4,1,83,'[{255,36160004,33}]',66,330,'[{4,796},{8,398}]'),(4,2,83,'[{255,36160004,55}]',110,550,'[{4,1460},{8,730}]'),(4,3,83,'[{255,36160004,88}]',176,880,'[{4,2074},{8,1095}]'),(4,0,84,'[{255,36160004,11}]',22,110,'[{4,472},{8,236}]'),(4,1,84,'[{255,36160004,33}]',66,330,'[{4,808},{8,404}]'),(4,2,84,'[{255,36160004,55}]',110,550,'[{4,1480},{8,740}]'),(4,3,84,'[{255,36160004,88}]',176,880,'[{4,2102},{8,1110}]'),(4,0,85,'[{255,36160004,11}]',22,110,'[{4,480},{8,240}]'),(4,1,85,'[{255,36160004,33}]',66,330,'[{4,820},{8,410}]'),(4,2,85,'[{255,36160004,55}]',110,550,'[{4,1500},{8,750}]'),(4,3,85,'[{255,36160004,88}]',176,880,'[{4,2130},{8,1125}]'),(4,0,86,'[{255,36160004,11}]',22,110,'[{4,488},{8,244}]'),(4,1,86,'[{255,36160004,33}]',66,330,'[{4,832},{8,416}]'),(4,2,86,'[{255,36160004,55}]',110,550,'[{4,1520},{8,760}]'),(4,3,86,'[{255,36160004,88}]',176,880,'[{4,2158},{8,1140}]'),(4,0,87,'[{255,36160004,11}]',22,110,'[{4,496},{8,248}]'),(4,1,87,'[{255,36160004,33}]',66,330,'[{4,844},{8,422}]'),(4,2,87,'[{255,36160004,55}]',110,550,'[{4,1540},{8,770}]'),(4,3,87,'[{255,36160004,88}]',176,880,'[{4,2186},{8,1155}]'),(4,0,88,'[{255,36160004,11}]',22,110,'[{4,504},{8,252}]'),(4,1,88,'[{255,36160004,33}]',66,330,'[{4,856},{8,428}]'),(4,2,88,'[{255,36160004,55}]',110,550,'[{4,1560},{8,780}]'),(4,3,88,'[{255,36160004,88}]',176,880,'[{4,2214},{8,1170}]'),(4,0,89,'[{255,36160004,11}]',22,110,'[{4,512},{8,256}]'),(4,1,89,'[{255,36160004,33}]',66,330,'[{4,868},{8,434}]'),(4,2,89,'[{255,36160004,55}]',110,550,'[{4,1580},{8,790}]'),(4,3,89,'[{255,36160004,88}]',176,880,'[{4,2242},{8,1185}]'),(4,0,90,'[{255,36160004,12}]',24,120,'[{4,520},{8,260}]'),(4,1,90,'[{255,36160004,36}]',72,360,'[{4,880},{8,440}]'),(4,2,90,'[{255,36160004,60}]',120,600,'[{4,1600},{8,800}]'),(4,3,90,'[{255,36160004,96}]',192,960,'[{4,2270},{8,1200}]'),(4,0,91,'[{255,36160004,12}]',24,120,'[{4,528},{8,264}]'),(4,1,91,'[{255,36160004,36}]',72,360,'[{4,892},{8,446}]'),(4,2,91,'[{255,36160004,60}]',120,600,'[{4,1620},{8,810}]'),(4,3,91,'[{255,36160004,96}]',192,960,'[{4,2298},{8,1215}]'),(4,0,92,'[{255,36160004,12}]',24,120,'[{4,536},{8,268}]'),(4,1,92,'[{255,36160004,36}]',72,360,'[{4,904},{8,452}]'),(4,2,92,'[{255,36160004,60}]',120,600,'[{4,1640},{8,820}]'),(4,3,92,'[{255,36160004,96}]',192,960,'[{4,2326},{8,1230}]'),(4,0,93,'[{255,36160004,12}]',24,120,'[{4,544},{8,272}]'),(4,1,93,'[{255,36160004,36}]',72,360,'[{4,916},{8,458}]'),(4,2,93,'[{255,36160004,60}]',120,600,'[{4,1660},{8,830}]'),(4,3,93,'[{255,36160004,96}]',192,960,'[{4,2354},{8,1245}]'),(4,0,94,'[{255,36160004,12}]',24,120,'[{4,552},{8,276}]'),(4,1,94,'[{255,36160004,36}]',72,360,'[{4,928},{8,464}]'),(4,2,94,'[{255,36160004,60}]',120,600,'[{4,1680},{8,840}]'),(4,3,94,'[{255,36160004,96}]',192,960,'[{4,2382},{8,1260}]'),(4,0,95,'[{255,36160004,12}]',24,120,'[{4,560},{8,280}]'),(4,1,95,'[{255,36160004,36}]',72,360,'[{4,940},{8,470}]'),(4,2,95,'[{255,36160004,60}]',120,600,'[{4,1700},{8,850}]'),(4,3,95,'[{255,36160004,96}]',192,960,'[{4,2410},{8,1275}]'),(4,0,96,'[{255,36160004,12}]',24,120,'[{4,568},{8,284}]'),(4,1,96,'[{255,36160004,36}]',72,360,'[{4,952},{8,476}]'),(4,2,96,'[{255,36160004,60}]',120,600,'[{4,1720},{8,860}]'),(4,3,96,'[{255,36160004,96}]',192,960,'[{4,2438},{8,1290}]'),(4,0,97,'[{255,36160004,12}]',24,120,'[{4,576},{8,288}]'),(4,1,97,'[{255,36160004,36}]',72,360,'[{4,964},{8,482}]'),(4,2,97,'[{255,36160004,60}]',120,600,'[{4,1740},{8,870}]'),(4,3,97,'[{255,36160004,96}]',192,960,'[{4,2466},{8,1305}]'),(4,0,98,'[{255,36160004,12}]',24,120,'[{4,584},{8,292}]'),(4,1,98,'[{255,36160004,36}]',72,360,'[{4,976},{8,488}]'),(4,2,98,'[{255,36160004,60}]',120,600,'[{4,1760},{8,880}]'),(4,3,98,'[{255,36160004,96}]',192,960,'[{4,2494},{8,1320}]'),(4,0,99,'[{255,36160004,12}]',24,120,'[{4,592},{8,296}]'),(4,1,99,'[{255,36160004,36}]',72,360,'[{4,988},{8,494}]'),(4,2,99,'[{255,36160004,60}]',120,600,'[{4,1780},{8,890}]'),(4,3,99,'[{255,36160004,96}]',192,960,'[{4,2522},{8,1335}]'),(4,0,100,'[{255,36160004,12}]',24,120,'[{4,600},{8,300}]'),(4,1,100,'[{255,36160004,36}]',72,360,'[{4,1000},{8,500}]'),(4,2,100,'[{255,36160004,60}]',120,600,'[{4,1800},{8,900}]'),(4,3,100,'[{255,36160004,96}]',192,960,'[{4,2550},{8,1350}]'),(4,0,101,'[{255,36160004,12}]',24,120,'[{4,612},{8,306}]'),(4,1,101,'[{255,36160004,36}]',72,360,'[{4,1016},{8,508}]'),(4,2,101,'[{255,36160004,60}]',120,600,'[{4,1824},{8,912}]'),(4,3,101,'[{255,36160004,96}]',192,960,'[{4,2584},{8,1368}]'),(4,0,102,'[{255,36160004,12}]',24,120,'[{4,624},{8,312}]'),(4,1,102,'[{255,36160004,36}]',72,360,'[{4,1032},{8,516}]'),(4,2,102,'[{255,36160004,60}]',120,600,'[{4,1848},{8,924}]'),(4,3,102,'[{255,36160004,96}]',192,960,'[{4,2618},{8,1386}]'),(4,0,103,'[{255,36160004,12}]',24,120,'[{4,636},{8,318}]'),(4,1,103,'[{255,36160004,36}]',72,360,'[{4,1048},{8,524}]'),(4,2,103,'[{255,36160004,60}]',120,600,'[{4,1872},{8,936}]'),(4,3,103,'[{255,36160004,96}]',192,960,'[{4,2652},{8,1404}]'),(4,0,104,'[{255,36160004,12}]',24,120,'[{4,648},{8,324}]'),(4,1,104,'[{255,36160004,36}]',72,360,'[{4,1064},{8,532}]'),(4,2,104,'[{255,36160004,60}]',120,600,'[{4,1896},{8,948}]'),(4,3,104,'[{255,36160004,96}]',192,960,'[{4,2686},{8,1422}]'),(4,0,105,'[{255,36160004,13}]',26,130,'[{4,660},{8,330}]'),(4,1,105,'[{255,36160004,39}]',78,390,'[{4,1080},{8,540}]'),(4,2,105,'[{255,36160004,65}]',130,650,'[{4,1920},{8,960}]'),(4,3,105,'[{255,36160004,104}]',208,1040,'[{4,2720},{8,1440}]'),(4,0,106,'[{255,36160004,13}]',26,130,'[{4,672},{8,336}]'),(4,1,106,'[{255,36160004,39}]',78,390,'[{4,1096},{8,548}]'),(4,2,106,'[{255,36160004,65}]',130,650,'[{4,1944},{8,972}]'),(4,3,106,'[{255,36160004,104}]',208,1040,'[{4,2754},{8,1458}]'),(4,0,107,'[{255,36160004,13}]',26,130,'[{4,684},{8,342}]'),(4,1,107,'[{255,36160004,39}]',78,390,'[{4,1112},{8,556}]'),(4,2,107,'[{255,36160004,65}]',130,650,'[{4,1968},{8,984}]'),(4,3,107,'[{255,36160004,104}]',208,1040,'[{4,2788},{8,1476}]'),(4,0,108,'[{255,36160004,13}]',26,130,'[{4,696},{8,348}]'),(4,1,108,'[{255,36160004,39}]',78,390,'[{4,1128},{8,564}]'),(4,2,108,'[{255,36160004,65}]',130,650,'[{4,1992},{8,996}]'),(4,3,108,'[{255,36160004,104}]',208,1040,'[{4,2822},{8,1494}]'),(4,0,109,'[{255,36160004,13}]',26,130,'[{4,708},{8,354}]'),(4,1,109,'[{255,36160004,39}]',78,390,'[{4,1144},{8,572}]'),(4,2,109,'[{255,36160004,65}]',130,650,'[{4,2016},{8,1008}]'),(4,3,109,'[{255,36160004,104}]',208,1040,'[{4,2856},{8,1512}]'),(4,0,110,'[{255,36160004,13}]',26,130,'[{4,720},{8,360}]'),(4,1,110,'[{255,36160004,39}]',78,390,'[{4,1160},{8,580}]'),(4,2,110,'[{255,36160004,65}]',130,650,'[{4,2040},{8,1020}]'),(4,3,110,'[{255,36160004,104}]',208,1040,'[{4,2890},{8,1530}]'),(4,0,111,'[{255,36160004,13}]',26,130,'[{4,732},{8,366}]'),(4,1,111,'[{255,36160004,39}]',78,390,'[{4,1176},{8,588}]'),(4,2,111,'[{255,36160004,65}]',130,650,'[{4,2064},{8,1032}]'),(4,3,111,'[{255,36160004,104}]',208,1040,'[{4,2924},{8,1548}]'),(4,0,112,'[{255,36160004,13}]',26,130,'[{4,744},{8,372}]'),(4,1,112,'[{255,36160004,39}]',78,390,'[{4,1192},{8,596}]'),(4,2,112,'[{255,36160004,65}]',130,650,'[{4,2088},{8,1044}]'),(4,3,112,'[{255,36160004,104}]',208,1040,'[{4,2958},{8,1566}]'),(4,0,113,'[{255,36160004,13}]',26,130,'[{4,756},{8,378}]'),(4,1,113,'[{255,36160004,39}]',78,390,'[{4,1208},{8,604}]'),(4,2,113,'[{255,36160004,65}]',130,650,'[{4,2112},{8,1056}]'),(4,3,113,'[{255,36160004,104}]',208,1040,'[{4,2992},{8,1584}]'),(4,0,114,'[{255,36160004,13}]',26,130,'[{4,768},{8,384}]'),(4,1,114,'[{255,36160004,39}]',78,390,'[{4,1224},{8,612}]'),(4,2,114,'[{255,36160004,65}]',130,650,'[{4,2136},{8,1068}]'),(4,3,114,'[{255,36160004,104}]',208,1040,'[{4,3026},{8,1602}]'),(4,0,115,'[{255,36160004,13}]',26,130,'[{4,780},{8,390}]'),(4,1,115,'[{255,36160004,39}]',78,390,'[{4,1240},{8,620}]'),(4,2,115,'[{255,36160004,65}]',130,650,'[{4,2160},{8,1080}]'),(4,3,115,'[{255,36160004,104}]',208,1040,'[{4,3060},{8,1620}]'),(4,0,116,'[{255,36160004,13}]',26,130,'[{4,792},{8,396}]'),(4,1,116,'[{255,36160004,39}]',78,390,'[{4,1256},{8,628}]'),(4,2,116,'[{255,36160004,65}]',130,650,'[{4,2184},{8,1092}]'),(4,3,116,'[{255,36160004,104}]',208,1040,'[{4,3094},{8,1638}]'),(4,0,117,'[{255,36160004,13}]',26,130,'[{4,804},{8,402}]'),(4,1,117,'[{255,36160004,39}]',78,390,'[{4,1272},{8,636}]'),(4,2,117,'[{255,36160004,65}]',130,650,'[{4,2208},{8,1104}]'),(4,3,117,'[{255,36160004,104}]',208,1040,'[{4,3128},{8,1656}]'),(4,0,118,'[{255,36160004,13}]',26,130,'[{4,816},{8,408}]'),(4,1,118,'[{255,36160004,39}]',78,390,'[{4,1288},{8,644}]'),(4,2,118,'[{255,36160004,65}]',130,650,'[{4,2232},{8,1116}]'),(4,3,118,'[{255,36160004,104}]',208,1040,'[{4,3162},{8,1674}]'),(4,0,119,'[{255,36160004,13}]',26,130,'[{4,828},{8,414}]'),(4,1,119,'[{255,36160004,39}]',78,390,'[{4,1304},{8,652}]'),(4,2,119,'[{255,36160004,65}]',130,650,'[{4,2256},{8,1128}]'),(4,3,119,'[{255,36160004,104}]',208,1040,'[{4,3196},{8,1692}]'),(4,0,120,'[{255,36160004,14}]',28,140,'[{4,840},{8,420}]'),(4,1,120,'[{255,36160004,42}]',84,420,'[{4,1320},{8,660}]'),(4,2,120,'[{255,36160004,70}]',140,700,'[{4,2280},{8,1140}]'),(4,3,120,'[{255,36160004,112}]',224,1120,'[{4,3230},{8,1710}]'),(4,0,121,'[{255,36160004,14}]',28,140,'[{4,852},{8,426}]'),(4,1,121,'[{255,36160004,42}]',84,420,'[{4,1336},{8,668}]'),(4,2,121,'[{255,36160004,70}]',140,700,'[{4,2304},{8,1152}]'),(4,3,121,'[{255,36160004,112}]',224,1120,'[{4,3264},{8,1728}]'),(4,0,122,'[{255,36160004,14}]',28,140,'[{4,864},{8,432}]'),(4,1,122,'[{255,36160004,42}]',84,420,'[{4,1352},{8,676}]'),(4,2,122,'[{255,36160004,70}]',140,700,'[{4,2328},{8,1164}]'),(4,3,122,'[{255,36160004,112}]',224,1120,'[{4,3298},{8,1746}]'),(4,0,123,'[{255,36160004,14}]',28,140,'[{4,876},{8,438}]'),(4,1,123,'[{255,36160004,42}]',84,420,'[{4,1368},{8,684}]'),(4,2,123,'[{255,36160004,70}]',140,700,'[{4,2352},{8,1176}]'),(4,3,123,'[{255,36160004,112}]',224,1120,'[{4,3332},{8,1764}]'),(4,0,124,'[{255,36160004,14}]',28,140,'[{4,888},{8,444}]'),(4,1,124,'[{255,36160004,42}]',84,420,'[{4,1384},{8,692}]'),(4,2,124,'[{255,36160004,70}]',140,700,'[{4,2376},{8,1188}]'),(4,3,124,'[{255,36160004,112}]',224,1120,'[{4,3366},{8,1782}]'),(4,0,125,'[{255,36160004,14}]',28,140,'[{4,900},{8,450}]'),(4,1,125,'[{255,36160004,42}]',84,420,'[{4,1400},{8,700}]'),(4,2,125,'[{255,36160004,70}]',140,700,'[{4,2400},{8,1200}]'),(4,3,125,'[{255,36160004,112}]',224,1120,'[{4,3400},{8,1800}]'),(4,0,126,'[{255,36160004,14}]',28,140,'[{4,912},{8,456}]'),(4,1,126,'[{255,36160004,42}]',84,420,'[{4,1416},{8,708}]'),(4,2,126,'[{255,36160004,70}]',140,700,'[{4,2424},{8,1212}]'),(4,3,126,'[{255,36160004,112}]',224,1120,'[{4,3434},{8,1818}]'),(4,0,127,'[{255,36160004,14}]',28,140,'[{4,924},{8,462}]'),(4,1,127,'[{255,36160004,42}]',84,420,'[{4,1432},{8,716}]'),(4,2,127,'[{255,36160004,70}]',140,700,'[{4,2448},{8,1224}]'),(4,3,127,'[{255,36160004,112}]',224,1120,'[{4,3468},{8,1836}]'),(4,0,128,'[{255,36160004,14}]',28,140,'[{4,936},{8,468}]'),(4,1,128,'[{255,36160004,42}]',84,420,'[{4,1448},{8,724}]'),(4,2,128,'[{255,36160004,70}]',140,700,'[{4,2472},{8,1236}]'),(4,3,128,'[{255,36160004,112}]',224,1120,'[{4,3502},{8,1854}]'),(4,0,129,'[{255,36160004,14}]',28,140,'[{4,948},{8,474}]'),(4,1,129,'[{255,36160004,42}]',84,420,'[{4,1464},{8,732}]'),(4,2,129,'[{255,36160004,70}]',140,700,'[{4,2496},{8,1248}]'),(4,3,129,'[{255,36160004,112}]',224,1120,'[{4,3536},{8,1872}]'),(4,0,130,'[{255,36160004,14}]',28,140,'[{4,960},{8,480}]'),(4,1,130,'[{255,36160004,42}]',84,420,'[{4,1480},{8,740}]'),(4,2,130,'[{255,36160004,70}]',140,700,'[{4,2520},{8,1260}]'),(4,3,130,'[{255,36160004,112}]',224,1120,'[{4,3570},{8,1890}]'),(4,0,131,'[{255,36160004,14}]',28,140,'[{4,972},{8,486}]'),(4,1,131,'[{255,36160004,42}]',84,420,'[{4,1496},{8,748}]'),(4,2,131,'[{255,36160004,70}]',140,700,'[{4,2544},{8,1272}]'),(4,3,131,'[{255,36160004,112}]',224,1120,'[{4,3604},{8,1908}]'),(4,0,132,'[{255,36160004,14}]',28,140,'[{4,984},{8,492}]'),(4,1,132,'[{255,36160004,42}]',84,420,'[{4,1512},{8,756}]'),(4,2,132,'[{255,36160004,70}]',140,700,'[{4,2568},{8,1284}]'),(4,3,132,'[{255,36160004,112}]',224,1120,'[{4,3638},{8,1926}]'),(4,0,133,'[{255,36160004,14}]',28,140,'[{4,996},{8,498}]'),(4,1,133,'[{255,36160004,42}]',84,420,'[{4,1528},{8,764}]'),(4,2,133,'[{255,36160004,70}]',140,700,'[{4,2592},{8,1296}]'),(4,3,133,'[{255,36160004,112}]',224,1120,'[{4,3672},{8,1944}]'),(4,0,134,'[{255,36160004,14}]',28,140,'[{4,1008},{8,504}]'),(4,1,134,'[{255,36160004,42}]',84,420,'[{4,1544},{8,772}]'),(4,2,134,'[{255,36160004,70}]',140,700,'[{4,2616},{8,1308}]'),(4,3,134,'[{255,36160004,112}]',224,1120,'[{4,3706},{8,1962}]'),(4,0,135,'[{255,36160004,15}]',30,150,'[{4,1020},{8,510}]'),(4,1,135,'[{255,36160004,45}]',90,450,'[{4,1560},{8,780}]'),(4,2,135,'[{255,36160004,75}]',150,750,'[{4,2640},{8,1320}]'),(4,3,135,'[{255,36160004,120}]',240,1200,'[{4,3740},{8,1980}]'),(4,0,136,'[{255,36160004,15}]',30,150,'[{4,1032},{8,516}]'),(4,1,136,'[{255,36160004,45}]',90,450,'[{4,1576},{8,788}]'),(4,2,136,'[{255,36160004,75}]',150,750,'[{4,2664},{8,1332}]'),(4,3,136,'[{255,36160004,120}]',240,1200,'[{4,3774},{8,1998}]'),(4,0,137,'[{255,36160004,15}]',30,150,'[{4,1044},{8,522}]'),(4,1,137,'[{255,36160004,45}]',90,450,'[{4,1592},{8,796}]'),(4,2,137,'[{255,36160004,75}]',150,750,'[{4,2688},{8,1344}]'),(4,3,137,'[{255,36160004,120}]',240,1200,'[{4,3808},{8,2016}]'),(4,0,138,'[{255,36160004,15}]',30,150,'[{4,1056},{8,528}]'),(4,1,138,'[{255,36160004,45}]',90,450,'[{4,1608},{8,804}]'),(4,2,138,'[{255,36160004,75}]',150,750,'[{4,2712},{8,1356}]'),(4,3,138,'[{255,36160004,120}]',240,1200,'[{4,3842},{8,2034}]'),(4,0,139,'[{255,36160004,15}]',30,150,'[{4,1068},{8,534}]'),(4,1,139,'[{255,36160004,45}]',90,450,'[{4,1624},{8,812}]'),(4,2,139,'[{255,36160004,75}]',150,750,'[{4,2736},{8,1368}]'),(4,3,139,'[{255,36160004,120}]',240,1200,'[{4,3876},{8,2052}]'),(4,0,140,'[{255,36160004,15}]',30,150,'[{4,1080},{8,540}]'),(4,1,140,'[{255,36160004,45}]',90,450,'[{4,1640},{8,820}]'),(4,2,140,'[{255,36160004,75}]',150,750,'[{4,2760},{8,1380}]'),(4,3,140,'[{255,36160004,120}]',240,1200,'[{4,3910},{8,2070}]'),(4,0,141,'[{255,36160004,15}]',30,150,'[{4,1092},{8,546}]'),(4,1,141,'[{255,36160004,45}]',90,450,'[{4,1656},{8,828}]'),(4,2,141,'[{255,36160004,75}]',150,750,'[{4,2784},{8,1392}]'),(4,3,141,'[{255,36160004,120}]',240,1200,'[{4,3944},{8,2088}]'),(4,0,142,'[{255,36160004,15}]',30,150,'[{4,1104},{8,552}]'),(4,1,142,'[{255,36160004,45}]',90,450,'[{4,1672},{8,836}]'),(4,2,142,'[{255,36160004,75}]',150,750,'[{4,2808},{8,1404}]'),(4,3,142,'[{255,36160004,120}]',240,1200,'[{4,3978},{8,2106}]'),(4,0,143,'[{255,36160004,15}]',30,150,'[{4,1116},{8,558}]'),(4,1,143,'[{255,36160004,45}]',90,450,'[{4,1688},{8,844}]'),(4,2,143,'[{255,36160004,75}]',150,750,'[{4,2832},{8,1416}]'),(4,3,143,'[{255,36160004,120}]',240,1200,'[{4,4012},{8,2124}]'),(4,0,144,'[{255,36160004,15}]',30,150,'[{4,1128},{8,564}]'),(4,1,144,'[{255,36160004,45}]',90,450,'[{4,1704},{8,852}]'),(4,2,144,'[{255,36160004,75}]',150,750,'[{4,2856},{8,1428}]'),(4,3,144,'[{255,36160004,120}]',240,1200,'[{4,4046},{8,2142}]'),(4,0,145,'[{255,36160004,15}]',30,150,'[{4,1140},{8,570}]'),(4,1,145,'[{255,36160004,45}]',90,450,'[{4,1720},{8,860}]'),(4,2,145,'[{255,36160004,75}]',150,750,'[{4,2880},{8,1440}]'),(4,3,145,'[{255,36160004,120}]',240,1200,'[{4,4080},{8,2160}]'),(4,0,146,'[{255,36160004,15}]',30,150,'[{4,1152},{8,576}]'),(4,1,146,'[{255,36160004,45}]',90,450,'[{4,1736},{8,868}]'),(4,2,146,'[{255,36160004,75}]',150,750,'[{4,2904},{8,1452}]'),(4,3,146,'[{255,36160004,120}]',240,1200,'[{4,4114},{8,2178}]'),(4,0,147,'[{255,36160004,15}]',30,150,'[{4,1164},{8,582}]'),(4,1,147,'[{255,36160004,45}]',90,450,'[{4,1752},{8,876}]'),(4,2,147,'[{255,36160004,75}]',150,750,'[{4,2928},{8,1464}]'),(4,3,147,'[{255,36160004,120}]',240,1200,'[{4,4148},{8,2196}]'),(4,0,148,'[{255,36160004,15}]',30,150,'[{4,1176},{8,588}]'),(4,1,148,'[{255,36160004,45}]',90,450,'[{4,1768},{8,884}]'),(4,2,148,'[{255,36160004,75}]',150,750,'[{4,2952},{8,1476}]'),(4,3,148,'[{255,36160004,120}]',240,1200,'[{4,4182},{8,2214}]'),(4,0,149,'[{255,36160004,15}]',30,150,'[{4,1188},{8,594}]'),(4,1,149,'[{255,36160004,45}]',90,450,'[{4,1784},{8,892}]'),(4,2,149,'[{255,36160004,75}]',150,750,'[{4,2976},{8,1488}]'),(4,3,149,'[{255,36160004,120}]',240,1200,'[{4,4216},{8,2232}]'),(4,0,150,'[{255,36160004,15}]',30,150,'[{4,1200},{8,600}]'),(4,1,150,'[{255,36160004,45}]',90,450,'[{4,1800},{8,900}]'),(4,2,150,'[{255,36160004,75}]',150,750,'[{4,3000},{8,1500}]'),(4,3,150,'[{255,36160004,120}]',240,1200,'[{4,4250},{8,2250}]');
/*!40000 ALTER TABLE `base_star_soul_equip_lv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_star_soul_equip_pos`
--

DROP TABLE IF EXISTS `base_star_soul_equip_pos`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_star_soul_equip_pos` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增ID',
  `pos` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '部位',
  `describe` varchar(128) NOT NULL DEFAULT '' COMMENT '部位描述',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8 COMMENT='星灵装备部位';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_star_soul_equip_pos`
--

LOCK TABLES `base_star_soul_equip_pos` WRITE;
/*!40000 ALTER TABLE `base_star_soul_equip_pos` DISABLE KEYS */;
INSERT INTO `base_star_soul_equip_pos` VALUES (1,1,'武器'),(2,2,'衣服'),(3,3,'饰品'),(4,4,'鞋子');
/*!40000 ALTER TABLE `base_star_soul_equip_pos` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_star_soul_fetter`
--

DROP TABLE IF EXISTS `base_star_soul_fetter`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_star_soul_fetter` (
  `id` tinyint(3) unsigned NOT NULL COMMENT '羁绊id',
  `name` varchar(255) NOT NULL COMMENT '羁绊名称@lang@',
  `star_list` varchar(255) NOT NULL COMMENT '羁绊星灵',
  `effect` varchar(255) NOT NULL COMMENT '羁绊效果',
  `skill` int(11) unsigned NOT NULL COMMENT '羁绊技能',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星灵羁绊配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_star_soul_fetter`
--

LOCK TABLES `base_star_soul_fetter` WRITE;
/*!40000 ALTER TABLE `base_star_soul_fetter` DISABLE KEYS */;
INSERT INTO `base_star_soul_fetter` VALUES (1,'难兄难弟','[2002,2003]','[{5,20},{7,20}]',0),(2,'虎背熊腰','[2001,2004]','[{1,50},{3,40}]',0),(3,'羊羊得意','[1001,1002]','[{2,1000},{4,40}]',0),(4,'刺客联盟','[2005,2004,1004]','[{3,80},{7,40}]',60301201),(5,'萌与力量','[1001,2001,1003]','[{1,100},{2,2000}]',60300801),(6,'狂暴之力','[1002,1003,1006]','[{1,250},{3,200}]',60300201),(7,'灵动之力','[1004,1005,1007]','[{2,5000},{4,200}]',60300501),(8,'众星拱月','[3001,1006,1005,1007]','[{1,300},{3,240},{5,120}]',60300101);
/*!40000 ALTER TABLE `base_star_soul_fetter` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_star_soul_key_value`
--

DROP TABLE IF EXISTS `base_star_soul_key_value`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_star_soul_key_value` (
  `key_id` int(32) NOT NULL DEFAULT '1' COMMENT '键',
  `value` varchar(5000) NOT NULL DEFAULT '' COMMENT '值',
  `describe` varchar(5000) NOT NULL DEFAULT '' COMMENT '描述',
  PRIMARY KEY (`key_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_star_soul_key_value`
--

LOCK TABLES `base_star_soul_key_value` WRITE;
/*!40000 ALTER TABLE `base_star_soul_key_value` DISABLE KEYS */;
INSERT INTO `base_star_soul_key_value` VALUES (1,'[{0,18010001,1}]','单次抽奖消耗道具数'),(2,' [{0,18010001,9}]','10次抽奖消耗道具数'),(3,'1','每次抽奖可获得积分'),(4,'86400','免费抽奖次数的CD(秒)'),(5,'100','每个抽奖道具的钻石价格'),(6,'0','新手开启功能免费一发的cd（秒）'),(7,'[{10,{0,18040101,1}},{20,{0,18040101,1}}]','新手免费一发的固定奖池');
/*!40000 ALTER TABLE `base_star_soul_key_value` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_star_soul_skill_cfg`
--

DROP TABLE IF EXISTS `base_star_soul_skill_cfg`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_star_soul_skill_cfg` (
  `skill_id` int(11) unsigned NOT NULL COMMENT '技能id',
  `skill_lv` tinyint(3) unsigned NOT NULL COMMENT '技能等级',
  `study_goods` varchar(255) NOT NULL COMMENT '学习消耗',
  `exp` smallint(5) unsigned NOT NULL COMMENT '升级经验',
  `goods_exp` varchar(255) NOT NULL COMMENT '升级道具与经验',
  `quality` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '品质',
  PRIMARY KEY (`skill_id`,`skill_lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星灵技能配置（新）';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_star_soul_skill_cfg`
--

LOCK TABLES `base_star_soul_skill_cfg` WRITE;
/*!40000 ALTER TABLE `base_star_soul_skill_cfg` DISABLE KEYS */;
INSERT INTO `base_star_soul_skill_cfg` VALUES (60400101,1,'18050101',20,'[{18060001,20},{18060002,40},{18060003,80},{18050101,100}]',1),(60400101,2,'0',35,'[{18060001,20},{18060002,40},{18060003,80},{18050101,100}]',1),(60400101,3,'0',50,'[{18060001,20},{18060002,40},{18060003,80},{18050101,100}]',1),(60400101,4,'0',65,'[{18060001,20},{18060002,40},{18060003,80},{18050101,100}]',1),(60400101,5,'0',80,'[{18060001,20},{18060002,40},{18060003,80},{18050101,100}]',1),(60400101,6,'0',95,'[{18060001,20},{18060002,40},{18060003,80},{18050101,100}]',1),(60400101,7,'0',110,'[{18060001,20},{18060002,40},{18060003,80},{18050101,100}]',1),(60400101,8,'0',125,'[{18060001,20},{18060002,40},{18060003,80},{18050101,100}]',1),(60400101,9,'0',140,'[{18060001,20},{18060002,40},{18060003,80},{18050101,100}]',1),(60400101,10,'0',160,'[{18060001,20},{18060002,40},{18060003,80},{18050101,100}]',1),(60400101,11,'0',180,'[{18060001,20},{18060002,40},{18060003,80},{18050101,100}]',1),(60400101,12,'0',200,'[{18060001,20},{18060002,40},{18060003,80},{18050101,100}]',1),(60400101,13,'0',220,'[{18060001,20},{18060002,40},{18060003,80},{18050101,100}]',1),(60400101,14,'0',240,'[{18060001,20},{18060002,40},{18060003,80},{18050101,100}]',1),(60400101,15,'0',260,'[{18060001,20},{18060002,40},{18060003,80},{18050101,100}]',1),(60400101,16,'0',280,'[{18060001,20},{18060002,40},{18060003,80},{18050101,100}]',1),(60400101,17,'0',300,'[{18060001,20},{18060002,40},{18060003,80},{18050101,100}]',1),(60400101,18,'0',320,'[{18060001,20},{18060002,40},{18060003,80},{18050101,100}]',1),(60400101,19,'0',340,'[{18060001,20},{18060002,40},{18060003,80},{18050101,100}]',1),(60400101,20,'0',0,'[{18060001,20},{18060002,40},{18060003,80},{18050101,100}]',1),(60400201,1,'18050201',20,'[{18060001,20},{18060002,40},{18060003,80},{18050201,100}]',1),(60400201,2,'0',35,'[{18060001,20},{18060002,40},{18060003,80},{18050201,100}]',1),(60400201,3,'0',50,'[{18060001,20},{18060002,40},{18060003,80},{18050201,100}]',1),(60400201,4,'0',65,'[{18060001,20},{18060002,40},{18060003,80},{18050201,100}]',1),(60400201,5,'0',80,'[{18060001,20},{18060002,40},{18060003,80},{18050201,100}]',1),(60400201,6,'0',95,'[{18060001,20},{18060002,40},{18060003,80},{18050201,100}]',1),(60400201,7,'0',110,'[{18060001,20},{18060002,40},{18060003,80},{18050201,100}]',1),(60400201,8,'0',125,'[{18060001,20},{18060002,40},{18060003,80},{18050201,100}]',1),(60400201,9,'0',140,'[{18060001,20},{18060002,40},{18060003,80},{18050201,100}]',1),(60400201,10,'0',160,'[{18060001,20},{18060002,40},{18060003,80},{18050201,100}]',1),(60400201,11,'0',180,'[{18060001,20},{18060002,40},{18060003,80},{18050201,100}]',1),(60400201,12,'0',200,'[{18060001,20},{18060002,40},{18060003,80},{18050201,100}]',1),(60400201,13,'0',220,'[{18060001,20},{18060002,40},{18060003,80},{18050201,100}]',1),(60400201,14,'0',240,'[{18060001,20},{18060002,40},{18060003,80},{18050201,100}]',1),(60400201,15,'0',260,'[{18060001,20},{18060002,40},{18060003,80},{18050201,100}]',1),(60400201,16,'0',280,'[{18060001,20},{18060002,40},{18060003,80},{18050201,100}]',1),(60400201,17,'0',300,'[{18060001,20},{18060002,40},{18060003,80},{18050201,100}]',1),(60400201,18,'0',320,'[{18060001,20},{18060002,40},{18060003,80},{18050201,100}]',1),(60400201,19,'0',340,'[{18060001,20},{18060002,40},{18060003,80},{18050201,100}]',1),(60400201,20,'0',0,'[{18060001,20},{18060002,40},{18060003,80},{18050201,100}]',1),(60400301,1,'18050301',20,'[{18060001,20},{18060002,40},{18060003,80},{18050301,100}]',1),(60400301,2,'0',35,'[{18060001,20},{18060002,40},{18060003,80},{18050301,100}]',1),(60400301,3,'0',50,'[{18060001,20},{18060002,40},{18060003,80},{18050301,100}]',1),(60400301,4,'0',65,'[{18060001,20},{18060002,40},{18060003,80},{18050301,100}]',1),(60400301,5,'0',80,'[{18060001,20},{18060002,40},{18060003,80},{18050301,100}]',1),(60400301,6,'0',95,'[{18060001,20},{18060002,40},{18060003,80},{18050301,100}]',1),(60400301,7,'0',110,'[{18060001,20},{18060002,40},{18060003,80},{18050301,100}]',1),(60400301,8,'0',125,'[{18060001,20},{18060002,40},{18060003,80},{18050301,100}]',1),(60400301,9,'0',140,'[{18060001,20},{18060002,40},{18060003,80},{18050301,100}]',1),(60400301,10,'0',160,'[{18060001,20},{18060002,40},{18060003,80},{18050301,100}]',1),(60400301,11,'0',180,'[{18060001,20},{18060002,40},{18060003,80},{18050301,100}]',1),(60400301,12,'0',200,'[{18060001,20},{18060002,40},{18060003,80},{18050301,100}]',1),(60400301,13,'0',220,'[{18060001,20},{18060002,40},{18060003,80},{18050301,100}]',1),(60400301,14,'0',240,'[{18060001,20},{18060002,40},{18060003,80},{18050301,100}]',1),(60400301,15,'0',260,'[{18060001,20},{18060002,40},{18060003,80},{18050301,100}]',1),(60400301,16,'0',280,'[{18060001,20},{18060002,40},{18060003,80},{18050301,100}]',1),(60400301,17,'0',300,'[{18060001,20},{18060002,40},{18060003,80},{18050301,100}]',1),(60400301,18,'0',320,'[{18060001,20},{18060002,40},{18060003,80},{18050301,100}]',1),(60400301,19,'0',340,'[{18060001,20},{18060002,40},{18060003,80},{18050301,100}]',1),(60400301,20,'0',0,'[{18060001,20},{18060002,40},{18060003,80},{18050301,100}]',1),(60400401,1,'18050401',20,'[{18060001,20},{18060002,40},{18060003,80},{18050401,100}]',1),(60400401,2,'0',35,'[{18060001,20},{18060002,40},{18060003,80},{18050401,100}]',1),(60400401,3,'0',50,'[{18060001,20},{18060002,40},{18060003,80},{18050401,100}]',1),(60400401,4,'0',65,'[{18060001,20},{18060002,40},{18060003,80},{18050401,100}]',1),(60400401,5,'0',80,'[{18060001,20},{18060002,40},{18060003,80},{18050401,100}]',1),(60400401,6,'0',95,'[{18060001,20},{18060002,40},{18060003,80},{18050401,100}]',1),(60400401,7,'0',110,'[{18060001,20},{18060002,40},{18060003,80},{18050401,100}]',1),(60400401,8,'0',125,'[{18060001,20},{18060002,40},{18060003,80},{18050401,100}]',1),(60400401,9,'0',140,'[{18060001,20},{18060002,40},{18060003,80},{18050401,100}]',1),(60400401,10,'0',160,'[{18060001,20},{18060002,40},{18060003,80},{18050401,100}]',1),(60400401,11,'0',180,'[{18060001,20},{18060002,40},{18060003,80},{18050401,100}]',1),(60400401,12,'0',200,'[{18060001,20},{18060002,40},{18060003,80},{18050401,100}]',1),(60400401,13,'0',220,'[{18060001,20},{18060002,40},{18060003,80},{18050401,100}]',1),(60400401,14,'0',240,'[{18060001,20},{18060002,40},{18060003,80},{18050401,100}]',1),(60400401,15,'0',260,'[{18060001,20},{18060002,40},{18060003,80},{18050401,100}]',1),(60400401,16,'0',280,'[{18060001,20},{18060002,40},{18060003,80},{18050401,100}]',1),(60400401,17,'0',300,'[{18060001,20},{18060002,40},{18060003,80},{18050401,100}]',1),(60400401,18,'0',320,'[{18060001,20},{18060002,40},{18060003,80},{18050401,100}]',1),(60400401,19,'0',340,'[{18060001,20},{18060002,40},{18060003,80},{18050401,100}]',1),(60400401,20,'0',0,'[{18060001,20},{18060002,40},{18060003,80},{18050401,100}]',1),(60400501,1,'18050501',20,'[{18060001,20},{18060002,40},{18060003,80},{18050501,100}]',1),(60400501,2,'0',35,'[{18060001,20},{18060002,40},{18060003,80},{18050501,100}]',1),(60400501,3,'0',50,'[{18060001,20},{18060002,40},{18060003,80},{18050501,100}]',1),(60400501,4,'0',65,'[{18060001,20},{18060002,40},{18060003,80},{18050501,100}]',1),(60400501,5,'0',80,'[{18060001,20},{18060002,40},{18060003,80},{18050501,100}]',1),(60400501,6,'0',95,'[{18060001,20},{18060002,40},{18060003,80},{18050501,100}]',1),(60400501,7,'0',110,'[{18060001,20},{18060002,40},{18060003,80},{18050501,100}]',1),(60400501,8,'0',125,'[{18060001,20},{18060002,40},{18060003,80},{18050501,100}]',1),(60400501,9,'0',140,'[{18060001,20},{18060002,40},{18060003,80},{18050501,100}]',1),(60400501,10,'0',160,'[{18060001,20},{18060002,40},{18060003,80},{18050501,100}]',1),(60400501,11,'0',180,'[{18060001,20},{18060002,40},{18060003,80},{18050501,100}]',1),(60400501,12,'0',200,'[{18060001,20},{18060002,40},{18060003,80},{18050501,100}]',1),(60400501,13,'0',220,'[{18060001,20},{18060002,40},{18060003,80},{18050501,100}]',1),(60400501,14,'0',240,'[{18060001,20},{18060002,40},{18060003,80},{18050501,100}]',1),(60400501,15,'0',260,'[{18060001,20},{18060002,40},{18060003,80},{18050501,100}]',1),(60400501,16,'0',280,'[{18060001,20},{18060002,40},{18060003,80},{18050501,100}]',1),(60400501,17,'0',300,'[{18060001,20},{18060002,40},{18060003,80},{18050501,100}]',1),(60400501,18,'0',320,'[{18060001,20},{18060002,40},{18060003,80},{18050501,100}]',1),(60400501,19,'0',340,'[{18060001,20},{18060002,40},{18060003,80},{18050501,100}]',1),(60400501,20,'0',0,'[{18060001,20},{18060002,40},{18060003,80},{18050501,100}]',1),(60400601,1,'18050601',20,'[{18060001,20},{18060002,40},{18060003,80},{18050601,100}]',1),(60400601,2,'0',35,'[{18060001,20},{18060002,40},{18060003,80},{18050601,100}]',1),(60400601,3,'0',50,'[{18060001,20},{18060002,40},{18060003,80},{18050601,100}]',1),(60400601,4,'0',65,'[{18060001,20},{18060002,40},{18060003,80},{18050601,100}]',1),(60400601,5,'0',80,'[{18060001,20},{18060002,40},{18060003,80},{18050601,100}]',1),(60400601,6,'0',95,'[{18060001,20},{18060002,40},{18060003,80},{18050601,100}]',1),(60400601,7,'0',110,'[{18060001,20},{18060002,40},{18060003,80},{18050601,100}]',1),(60400601,8,'0',125,'[{18060001,20},{18060002,40},{18060003,80},{18050601,100}]',1),(60400601,9,'0',140,'[{18060001,20},{18060002,40},{18060003,80},{18050601,100}]',1),(60400601,10,'0',160,'[{18060001,20},{18060002,40},{18060003,80},{18050601,100}]',1),(60400601,11,'0',180,'[{18060001,20},{18060002,40},{18060003,80},{18050601,100}]',1),(60400601,12,'0',200,'[{18060001,20},{18060002,40},{18060003,80},{18050601,100}]',1),(60400601,13,'0',220,'[{18060001,20},{18060002,40},{18060003,80},{18050601,100}]',1),(60400601,14,'0',240,'[{18060001,20},{18060002,40},{18060003,80},{18050601,100}]',1),(60400601,15,'0',260,'[{18060001,20},{18060002,40},{18060003,80},{18050601,100}]',1),(60400601,16,'0',280,'[{18060001,20},{18060002,40},{18060003,80},{18050601,100}]',1),(60400601,17,'0',300,'[{18060001,20},{18060002,40},{18060003,80},{18050601,100}]',1),(60400601,18,'0',320,'[{18060001,20},{18060002,40},{18060003,80},{18050601,100}]',1),(60400601,19,'0',340,'[{18060001,20},{18060002,40},{18060003,80},{18050601,100}]',1),(60400601,20,'0',0,'[{18060001,20},{18060002,40},{18060003,80},{18050601,100}]',1),(60400701,1,'18050701',20,'[{18060001,20},{18060002,40},{18060003,80},{18050701,100}]',1),(60400701,2,'0',35,'[{18060001,20},{18060002,40},{18060003,80},{18050701,100}]',1),(60400701,3,'0',50,'[{18060001,20},{18060002,40},{18060003,80},{18050701,100}]',1),(60400701,4,'0',65,'[{18060001,20},{18060002,40},{18060003,80},{18050701,100}]',1),(60400701,5,'0',80,'[{18060001,20},{18060002,40},{18060003,80},{18050701,100}]',1),(60400701,6,'0',95,'[{18060001,20},{18060002,40},{18060003,80},{18050701,100}]',1),(60400701,7,'0',110,'[{18060001,20},{18060002,40},{18060003,80},{18050701,100}]',1),(60400701,8,'0',125,'[{18060001,20},{18060002,40},{18060003,80},{18050701,100}]',1),(60400701,9,'0',140,'[{18060001,20},{18060002,40},{18060003,80},{18050701,100}]',1),(60400701,10,'0',160,'[{18060001,20},{18060002,40},{18060003,80},{18050701,100}]',1),(60400701,11,'0',180,'[{18060001,20},{18060002,40},{18060003,80},{18050701,100}]',1),(60400701,12,'0',200,'[{18060001,20},{18060002,40},{18060003,80},{18050701,100}]',1),(60400701,13,'0',220,'[{18060001,20},{18060002,40},{18060003,80},{18050701,100}]',1),(60400701,14,'0',240,'[{18060001,20},{18060002,40},{18060003,80},{18050701,100}]',1),(60400701,15,'0',260,'[{18060001,20},{18060002,40},{18060003,80},{18050701,100}]',1),(60400701,16,'0',280,'[{18060001,20},{18060002,40},{18060003,80},{18050701,100}]',1),(60400701,17,'0',300,'[{18060001,20},{18060002,40},{18060003,80},{18050701,100}]',1),(60400701,18,'0',320,'[{18060001,20},{18060002,40},{18060003,80},{18050701,100}]',1),(60400701,19,'0',340,'[{18060001,20},{18060002,40},{18060003,80},{18050701,100}]',1),(60400701,20,'0',0,'[{18060001,20},{18060002,40},{18060003,80},{18050701,100}]',1),(60400801,1,'18050801',30,'[{18060001,20},{18060002,40},{18060003,80},{18050801,200}]',2),(60400801,2,'0',50,'[{18060001,20},{18060002,40},{18060003,80},{18050801,200}]',2),(60400801,3,'0',70,'[{18060001,20},{18060002,40},{18060003,80},{18050801,200}]',2),(60400801,4,'0',90,'[{18060001,20},{18060002,40},{18060003,80},{18050801,200}]',2),(60400801,5,'0',110,'[{18060001,20},{18060002,40},{18060003,80},{18050801,200}]',2),(60400801,6,'0',130,'[{18060001,20},{18060002,40},{18060003,80},{18050801,200}]',2),(60400801,7,'0',150,'[{18060001,20},{18060002,40},{18060003,80},{18050801,200}]',2),(60400801,8,'0',170,'[{18060001,20},{18060002,40},{18060003,80},{18050801,200}]',2),(60400801,9,'0',190,'[{18060001,20},{18060002,40},{18060003,80},{18050801,200}]',2),(60400801,10,'0',210,'[{18060001,20},{18060002,40},{18060003,80},{18050801,200}]',2),(60400801,11,'0',230,'[{18060001,20},{18060002,40},{18060003,80},{18050801,200}]',2),(60400801,12,'0',250,'[{18060001,20},{18060002,40},{18060003,80},{18050801,200}]',2),(60400801,13,'0',275,'[{18060001,20},{18060002,40},{18060003,80},{18050801,200}]',2),(60400801,14,'0',300,'[{18060001,20},{18060002,40},{18060003,80},{18050801,200}]',2),(60400801,15,'0',325,'[{18060001,20},{18060002,40},{18060003,80},{18050801,200}]',2),(60400801,16,'0',350,'[{18060001,20},{18060002,40},{18060003,80},{18050801,200}]',2),(60400801,17,'0',375,'[{18060001,20},{18060002,40},{18060003,80},{18050801,200}]',2),(60400801,18,'0',400,'[{18060001,20},{18060002,40},{18060003,80},{18050801,200}]',2),(60400801,19,'0',425,'[{18060001,20},{18060002,40},{18060003,80},{18050801,200}]',2),(60400801,20,'0',450,'[{18060001,20},{18060002,40},{18060003,80},{18050801,200}]',2),(60400801,21,'0',475,'[{18060001,20},{18060002,40},{18060003,80},{18050801,200}]',2),(60400801,22,'0',500,'[{18060001,20},{18060002,40},{18060003,80},{18050801,200}]',2),(60400801,23,'0',525,'[{18060001,20},{18060002,40},{18060003,80},{18050801,200}]',2),(60400801,24,'0',550,'[{18060001,20},{18060002,40},{18060003,80},{18050801,200}]',2),(60400801,25,'0',0,'[{18060001,20},{18060002,40},{18060003,80},{18050801,200}]',2),(60400901,1,'18050901',30,'[{18060001,20},{18060002,40},{18060003,80},{18050901,200}]',2),(60400901,2,'0',50,'[{18060001,20},{18060002,40},{18060003,80},{18050901,200}]',2),(60400901,3,'0',70,'[{18060001,20},{18060002,40},{18060003,80},{18050901,200}]',2),(60400901,4,'0',90,'[{18060001,20},{18060002,40},{18060003,80},{18050901,200}]',2),(60400901,5,'0',110,'[{18060001,20},{18060002,40},{18060003,80},{18050901,200}]',2),(60400901,6,'0',130,'[{18060001,20},{18060002,40},{18060003,80},{18050901,200}]',2),(60400901,7,'0',150,'[{18060001,20},{18060002,40},{18060003,80},{18050901,200}]',2),(60400901,8,'0',170,'[{18060001,20},{18060002,40},{18060003,80},{18050901,200}]',2),(60400901,9,'0',190,'[{18060001,20},{18060002,40},{18060003,80},{18050901,200}]',2),(60400901,10,'0',210,'[{18060001,20},{18060002,40},{18060003,80},{18050901,200}]',2),(60400901,11,'0',230,'[{18060001,20},{18060002,40},{18060003,80},{18050901,200}]',2),(60400901,12,'0',250,'[{18060001,20},{18060002,40},{18060003,80},{18050901,200}]',2),(60400901,13,'0',275,'[{18060001,20},{18060002,40},{18060003,80},{18050901,200}]',2),(60400901,14,'0',300,'[{18060001,20},{18060002,40},{18060003,80},{18050901,200}]',2),(60400901,15,'0',325,'[{18060001,20},{18060002,40},{18060003,80},{18050901,200}]',2),(60400901,16,'0',350,'[{18060001,20},{18060002,40},{18060003,80},{18050901,200}]',2),(60400901,17,'0',375,'[{18060001,20},{18060002,40},{18060003,80},{18050901,200}]',2),(60400901,18,'0',400,'[{18060001,20},{18060002,40},{18060003,80},{18050901,200}]',2),(60400901,19,'0',425,'[{18060001,20},{18060002,40},{18060003,80},{18050901,200}]',2),(60400901,20,'0',450,'[{18060001,20},{18060002,40},{18060003,80},{18050901,200}]',2),(60400901,21,'0',475,'[{18060001,20},{18060002,40},{18060003,80},{18050901,200}]',2),(60400901,22,'0',500,'[{18060001,20},{18060002,40},{18060003,80},{18050901,200}]',2),(60400901,23,'0',525,'[{18060001,20},{18060002,40},{18060003,80},{18050901,200}]',2),(60400901,24,'0',550,'[{18060001,20},{18060002,40},{18060003,80},{18050901,200}]',2),(60400901,25,'0',0,'[{18060001,20},{18060002,40},{18060003,80},{18050901,200}]',2),(60401001,1,'18051001',30,'[{18060001,20},{18060002,40},{18060003,80},{18051001,200}]',2),(60401001,2,'0',50,'[{18060001,20},{18060002,40},{18060003,80},{18051001,200}]',2),(60401001,3,'0',70,'[{18060001,20},{18060002,40},{18060003,80},{18051001,200}]',2),(60401001,4,'0',90,'[{18060001,20},{18060002,40},{18060003,80},{18051001,200}]',2),(60401001,5,'0',110,'[{18060001,20},{18060002,40},{18060003,80},{18051001,200}]',2),(60401001,6,'0',130,'[{18060001,20},{18060002,40},{18060003,80},{18051001,200}]',2),(60401001,7,'0',150,'[{18060001,20},{18060002,40},{18060003,80},{18051001,200}]',2),(60401001,8,'0',170,'[{18060001,20},{18060002,40},{18060003,80},{18051001,200}]',2),(60401001,9,'0',190,'[{18060001,20},{18060002,40},{18060003,80},{18051001,200}]',2),(60401001,10,'0',210,'[{18060001,20},{18060002,40},{18060003,80},{18051001,200}]',2),(60401001,11,'0',230,'[{18060001,20},{18060002,40},{18060003,80},{18051001,200}]',2),(60401001,12,'0',250,'[{18060001,20},{18060002,40},{18060003,80},{18051001,200}]',2),(60401001,13,'0',275,'[{18060001,20},{18060002,40},{18060003,80},{18051001,200}]',2),(60401001,14,'0',300,'[{18060001,20},{18060002,40},{18060003,80},{18051001,200}]',2),(60401001,15,'0',325,'[{18060001,20},{18060002,40},{18060003,80},{18051001,200}]',2),(60401001,16,'0',350,'[{18060001,20},{18060002,40},{18060003,80},{18051001,200}]',2),(60401001,17,'0',375,'[{18060001,20},{18060002,40},{18060003,80},{18051001,200}]',2),(60401001,18,'0',400,'[{18060001,20},{18060002,40},{18060003,80},{18051001,200}]',2),(60401001,19,'0',425,'[{18060001,20},{18060002,40},{18060003,80},{18051001,200}]',2),(60401001,20,'0',450,'[{18060001,20},{18060002,40},{18060003,80},{18051001,200}]',2),(60401001,21,'0',475,'[{18060001,20},{18060002,40},{18060003,80},{18051001,200}]',2),(60401001,22,'0',500,'[{18060001,20},{18060002,40},{18060003,80},{18051001,200}]',2),(60401001,23,'0',525,'[{18060001,20},{18060002,40},{18060003,80},{18051001,200}]',2),(60401001,24,'0',550,'[{18060001,20},{18060002,40},{18060003,80},{18051001,200}]',2),(60401001,25,'0',0,'[{18060001,20},{18060002,40},{18060003,80},{18051001,200}]',2),(60401101,1,'18051101',30,'[{18060001,20},{18060002,40},{18060003,80},{18051101,200}]',2),(60401101,2,'0',50,'[{18060001,20},{18060002,40},{18060003,80},{18051101,200}]',2),(60401101,3,'0',70,'[{18060001,20},{18060002,40},{18060003,80},{18051101,200}]',2),(60401101,4,'0',90,'[{18060001,20},{18060002,40},{18060003,80},{18051101,200}]',2),(60401101,5,'0',110,'[{18060001,20},{18060002,40},{18060003,80},{18051101,200}]',2),(60401101,6,'0',130,'[{18060001,20},{18060002,40},{18060003,80},{18051101,200}]',2),(60401101,7,'0',150,'[{18060001,20},{18060002,40},{18060003,80},{18051101,200}]',2),(60401101,8,'0',170,'[{18060001,20},{18060002,40},{18060003,80},{18051101,200}]',2),(60401101,9,'0',190,'[{18060001,20},{18060002,40},{18060003,80},{18051101,200}]',2),(60401101,10,'0',210,'[{18060001,20},{18060002,40},{18060003,80},{18051101,200}]',2),(60401101,11,'0',230,'[{18060001,20},{18060002,40},{18060003,80},{18051101,200}]',2),(60401101,12,'0',250,'[{18060001,20},{18060002,40},{18060003,80},{18051101,200}]',2),(60401101,13,'0',275,'[{18060001,20},{18060002,40},{18060003,80},{18051101,200}]',2),(60401101,14,'0',300,'[{18060001,20},{18060002,40},{18060003,80},{18051101,200}]',2),(60401101,15,'0',325,'[{18060001,20},{18060002,40},{18060003,80},{18051101,200}]',2),(60401101,16,'0',350,'[{18060001,20},{18060002,40},{18060003,80},{18051101,200}]',2),(60401101,17,'0',375,'[{18060001,20},{18060002,40},{18060003,80},{18051101,200}]',2),(60401101,18,'0',400,'[{18060001,20},{18060002,40},{18060003,80},{18051101,200}]',2),(60401101,19,'0',425,'[{18060001,20},{18060002,40},{18060003,80},{18051101,200}]',2),(60401101,20,'0',450,'[{18060001,20},{18060002,40},{18060003,80},{18051101,200}]',2),(60401101,21,'0',475,'[{18060001,20},{18060002,40},{18060003,80},{18051101,200}]',2),(60401101,22,'0',500,'[{18060001,20},{18060002,40},{18060003,80},{18051101,200}]',2),(60401101,23,'0',525,'[{18060001,20},{18060002,40},{18060003,80},{18051101,200}]',2),(60401101,24,'0',550,'[{18060001,20},{18060002,40},{18060003,80},{18051101,200}]',2),(60401101,25,'0',0,'[{18060001,20},{18060002,40},{18060003,80},{18051101,200}]',2),(60401201,1,'18051201',30,'[{18060001,20},{18060002,40},{18060003,80},{18051201,200}]',2),(60401201,2,'0',50,'[{18060001,20},{18060002,40},{18060003,80},{18051201,200}]',2),(60401201,3,'0',70,'[{18060001,20},{18060002,40},{18060003,80},{18051201,200}]',2),(60401201,4,'0',90,'[{18060001,20},{18060002,40},{18060003,80},{18051201,200}]',2),(60401201,5,'0',110,'[{18060001,20},{18060002,40},{18060003,80},{18051201,200}]',2),(60401201,6,'0',130,'[{18060001,20},{18060002,40},{18060003,80},{18051201,200}]',2),(60401201,7,'0',150,'[{18060001,20},{18060002,40},{18060003,80},{18051201,200}]',2),(60401201,8,'0',170,'[{18060001,20},{18060002,40},{18060003,80},{18051201,200}]',2),(60401201,9,'0',190,'[{18060001,20},{18060002,40},{18060003,80},{18051201,200}]',2),(60401201,10,'0',210,'[{18060001,20},{18060002,40},{18060003,80},{18051201,200}]',2),(60401201,11,'0',230,'[{18060001,20},{18060002,40},{18060003,80},{18051201,200}]',2),(60401201,12,'0',250,'[{18060001,20},{18060002,40},{18060003,80},{18051201,200}]',2),(60401201,13,'0',275,'[{18060001,20},{18060002,40},{18060003,80},{18051201,200}]',2),(60401201,14,'0',300,'[{18060001,20},{18060002,40},{18060003,80},{18051201,200}]',2),(60401201,15,'0',325,'[{18060001,20},{18060002,40},{18060003,80},{18051201,200}]',2),(60401201,16,'0',350,'[{18060001,20},{18060002,40},{18060003,80},{18051201,200}]',2),(60401201,17,'0',375,'[{18060001,20},{18060002,40},{18060003,80},{18051201,200}]',2),(60401201,18,'0',400,'[{18060001,20},{18060002,40},{18060003,80},{18051201,200}]',2),(60401201,19,'0',425,'[{18060001,20},{18060002,40},{18060003,80},{18051201,200}]',2),(60401201,20,'0',450,'[{18060001,20},{18060002,40},{18060003,80},{18051201,200}]',2),(60401201,21,'0',475,'[{18060001,20},{18060002,40},{18060003,80},{18051201,200}]',2),(60401201,22,'0',500,'[{18060001,20},{18060002,40},{18060003,80},{18051201,200}]',2),(60401201,23,'0',525,'[{18060001,20},{18060002,40},{18060003,80},{18051201,200}]',2),(60401201,24,'0',550,'[{18060001,20},{18060002,40},{18060003,80},{18051201,200}]',2),(60401201,25,'0',0,'[{18060001,20},{18060002,40},{18060003,80},{18051201,200}]',2),(60401301,1,'18051301',30,'[{18060001,20},{18060002,40},{18060003,80},{18051301,200}]',2),(60401301,2,'0',50,'[{18060001,20},{18060002,40},{18060003,80},{18051301,200}]',2),(60401301,3,'0',70,'[{18060001,20},{18060002,40},{18060003,80},{18051301,200}]',2),(60401301,4,'0',90,'[{18060001,20},{18060002,40},{18060003,80},{18051301,200}]',2),(60401301,5,'0',110,'[{18060001,20},{18060002,40},{18060003,80},{18051301,200}]',2),(60401301,6,'0',130,'[{18060001,20},{18060002,40},{18060003,80},{18051301,200}]',2),(60401301,7,'0',150,'[{18060001,20},{18060002,40},{18060003,80},{18051301,200}]',2),(60401301,8,'0',170,'[{18060001,20},{18060002,40},{18060003,80},{18051301,200}]',2),(60401301,9,'0',190,'[{18060001,20},{18060002,40},{18060003,80},{18051301,200}]',2),(60401301,10,'0',210,'[{18060001,20},{18060002,40},{18060003,80},{18051301,200}]',2),(60401301,11,'0',230,'[{18060001,20},{18060002,40},{18060003,80},{18051301,200}]',2),(60401301,12,'0',250,'[{18060001,20},{18060002,40},{18060003,80},{18051301,200}]',2),(60401301,13,'0',275,'[{18060001,20},{18060002,40},{18060003,80},{18051301,200}]',2),(60401301,14,'0',300,'[{18060001,20},{18060002,40},{18060003,80},{18051301,200}]',2),(60401301,15,'0',325,'[{18060001,20},{18060002,40},{18060003,80},{18051301,200}]',2),(60401301,16,'0',350,'[{18060001,20},{18060002,40},{18060003,80},{18051301,200}]',2),(60401301,17,'0',375,'[{18060001,20},{18060002,40},{18060003,80},{18051301,200}]',2),(60401301,18,'0',400,'[{18060001,20},{18060002,40},{18060003,80},{18051301,200}]',2),(60401301,19,'0',425,'[{18060001,20},{18060002,40},{18060003,80},{18051301,200}]',2),(60401301,20,'0',450,'[{18060001,20},{18060002,40},{18060003,80},{18051301,200}]',2),(60401301,21,'0',475,'[{18060001,20},{18060002,40},{18060003,80},{18051301,200}]',2),(60401301,22,'0',500,'[{18060001,20},{18060002,40},{18060003,80},{18051301,200}]',2),(60401301,23,'0',525,'[{18060001,20},{18060002,40},{18060003,80},{18051301,200}]',2),(60401301,24,'0',550,'[{18060001,20},{18060002,40},{18060003,80},{18051301,200}]',2),(60401301,25,'0',0,'[{18060001,20},{18060002,40},{18060003,80},{18051301,200}]',2),(60401401,1,'18051401',30,'[{18060001,20},{18060002,40},{18060003,80},{18051401,200}]',2),(60401401,2,'0',50,'[{18060001,20},{18060002,40},{18060003,80},{18051401,200}]',2),(60401401,3,'0',70,'[{18060001,20},{18060002,40},{18060003,80},{18051401,200}]',2),(60401401,4,'0',90,'[{18060001,20},{18060002,40},{18060003,80},{18051401,200}]',2),(60401401,5,'0',110,'[{18060001,20},{18060002,40},{18060003,80},{18051401,200}]',2),(60401401,6,'0',130,'[{18060001,20},{18060002,40},{18060003,80},{18051401,200}]',2),(60401401,7,'0',150,'[{18060001,20},{18060002,40},{18060003,80},{18051401,200}]',2),(60401401,8,'0',170,'[{18060001,20},{18060002,40},{18060003,80},{18051401,200}]',2),(60401401,9,'0',190,'[{18060001,20},{18060002,40},{18060003,80},{18051401,200}]',2),(60401401,10,'0',210,'[{18060001,20},{18060002,40},{18060003,80},{18051401,200}]',2),(60401401,11,'0',230,'[{18060001,20},{18060002,40},{18060003,80},{18051401,200}]',2),(60401401,12,'0',250,'[{18060001,20},{18060002,40},{18060003,80},{18051401,200}]',2),(60401401,13,'0',275,'[{18060001,20},{18060002,40},{18060003,80},{18051401,200}]',2),(60401401,14,'0',300,'[{18060001,20},{18060002,40},{18060003,80},{18051401,200}]',2),(60401401,15,'0',325,'[{18060001,20},{18060002,40},{18060003,80},{18051401,200}]',2),(60401401,16,'0',350,'[{18060001,20},{18060002,40},{18060003,80},{18051401,200}]',2),(60401401,17,'0',375,'[{18060001,20},{18060002,40},{18060003,80},{18051401,200}]',2),(60401401,18,'0',400,'[{18060001,20},{18060002,40},{18060003,80},{18051401,200}]',2),(60401401,19,'0',425,'[{18060001,20},{18060002,40},{18060003,80},{18051401,200}]',2),(60401401,20,'0',450,'[{18060001,20},{18060002,40},{18060003,80},{18051401,200}]',2),(60401401,21,'0',475,'[{18060001,20},{18060002,40},{18060003,80},{18051401,200}]',2),(60401401,22,'0',500,'[{18060001,20},{18060002,40},{18060003,80},{18051401,200}]',2),(60401401,23,'0',525,'[{18060001,20},{18060002,40},{18060003,80},{18051401,200}]',2),(60401401,24,'0',550,'[{18060001,20},{18060002,40},{18060003,80},{18051401,200}]',2),(60401401,25,'0',0,'[{18060001,20},{18060002,40},{18060003,80},{18051401,200}]',2),(60401501,1,'18051501',30,'[{18060001,20},{18060002,40},{18060003,80},{18051501,200}]',2),(60401501,2,'0',50,'[{18060001,20},{18060002,40},{18060003,80},{18051501,200}]',2),(60401501,3,'0',70,'[{18060001,20},{18060002,40},{18060003,80},{18051501,200}]',2),(60401501,4,'0',90,'[{18060001,20},{18060002,40},{18060003,80},{18051501,200}]',2),(60401501,5,'0',110,'[{18060001,20},{18060002,40},{18060003,80},{18051501,200}]',2),(60401501,6,'0',130,'[{18060001,20},{18060002,40},{18060003,80},{18051501,200}]',2),(60401501,7,'0',150,'[{18060001,20},{18060002,40},{18060003,80},{18051501,200}]',2),(60401501,8,'0',170,'[{18060001,20},{18060002,40},{18060003,80},{18051501,200}]',2),(60401501,9,'0',190,'[{18060001,20},{18060002,40},{18060003,80},{18051501,200}]',2),(60401501,10,'0',210,'[{18060001,20},{18060002,40},{18060003,80},{18051501,200}]',2),(60401501,11,'0',230,'[{18060001,20},{18060002,40},{18060003,80},{18051501,200}]',2),(60401501,12,'0',250,'[{18060001,20},{18060002,40},{18060003,80},{18051501,200}]',2),(60401501,13,'0',275,'[{18060001,20},{18060002,40},{18060003,80},{18051501,200}]',2),(60401501,14,'0',300,'[{18060001,20},{18060002,40},{18060003,80},{18051501,200}]',2),(60401501,15,'0',325,'[{18060001,20},{18060002,40},{18060003,80},{18051501,200}]',2),(60401501,16,'0',350,'[{18060001,20},{18060002,40},{18060003,80},{18051501,200}]',2),(60401501,17,'0',375,'[{18060001,20},{18060002,40},{18060003,80},{18051501,200}]',2),(60401501,18,'0',400,'[{18060001,20},{18060002,40},{18060003,80},{18051501,200}]',2),(60401501,19,'0',425,'[{18060001,20},{18060002,40},{18060003,80},{18051501,200}]',2),(60401501,20,'0',450,'[{18060001,20},{18060002,40},{18060003,80},{18051501,200}]',2),(60401501,21,'0',475,'[{18060001,20},{18060002,40},{18060003,80},{18051501,200}]',2),(60401501,22,'0',500,'[{18060001,20},{18060002,40},{18060003,80},{18051501,200}]',2),(60401501,23,'0',525,'[{18060001,20},{18060002,40},{18060003,80},{18051501,200}]',2),(60401501,24,'0',550,'[{18060001,20},{18060002,40},{18060003,80},{18051501,200}]',2),(60401501,25,'0',0,'[{18060001,20},{18060002,40},{18060003,80},{18051501,200}]',2),(60401601,1,'18051601',30,'[{18060001,20},{18060002,40},{18060003,80},{18051601,200}]',2),(60401601,2,'0',50,'[{18060001,20},{18060002,40},{18060003,80},{18051601,200}]',2),(60401601,3,'0',70,'[{18060001,20},{18060002,40},{18060003,80},{18051601,200}]',2),(60401601,4,'0',90,'[{18060001,20},{18060002,40},{18060003,80},{18051601,200}]',2),(60401601,5,'0',110,'[{18060001,20},{18060002,40},{18060003,80},{18051601,200}]',2),(60401601,6,'0',130,'[{18060001,20},{18060002,40},{18060003,80},{18051601,200}]',2),(60401601,7,'0',150,'[{18060001,20},{18060002,40},{18060003,80},{18051601,200}]',2),(60401601,8,'0',170,'[{18060001,20},{18060002,40},{18060003,80},{18051601,200}]',2),(60401601,9,'0',190,'[{18060001,20},{18060002,40},{18060003,80},{18051601,200}]',2),(60401601,10,'0',210,'[{18060001,20},{18060002,40},{18060003,80},{18051601,200}]',2),(60401601,11,'0',230,'[{18060001,20},{18060002,40},{18060003,80},{18051601,200}]',2),(60401601,12,'0',250,'[{18060001,20},{18060002,40},{18060003,80},{18051601,200}]',2),(60401601,13,'0',275,'[{18060001,20},{18060002,40},{18060003,80},{18051601,200}]',2),(60401601,14,'0',300,'[{18060001,20},{18060002,40},{18060003,80},{18051601,200}]',2),(60401601,15,'0',325,'[{18060001,20},{18060002,40},{18060003,80},{18051601,200}]',2),(60401601,16,'0',350,'[{18060001,20},{18060002,40},{18060003,80},{18051601,200}]',2),(60401601,17,'0',375,'[{18060001,20},{18060002,40},{18060003,80},{18051601,200}]',2),(60401601,18,'0',400,'[{18060001,20},{18060002,40},{18060003,80},{18051601,200}]',2),(60401601,19,'0',425,'[{18060001,20},{18060002,40},{18060003,80},{18051601,200}]',2),(60401601,20,'0',450,'[{18060001,20},{18060002,40},{18060003,80},{18051601,200}]',2),(60401601,21,'0',475,'[{18060001,20},{18060002,40},{18060003,80},{18051601,200}]',2),(60401601,22,'0',500,'[{18060001,20},{18060002,40},{18060003,80},{18051601,200}]',2),(60401601,23,'0',525,'[{18060001,20},{18060002,40},{18060003,80},{18051601,200}]',2),(60401601,24,'0',550,'[{18060001,20},{18060002,40},{18060003,80},{18051601,200}]',2),(60401601,25,'0',0,'[{18060001,20},{18060002,40},{18060003,80},{18051601,200}]',2),(60401701,1,'18051701',30,'[{18060001,20},{18060002,40},{18060003,80},{18051701,200}]',2),(60401701,2,'0',50,'[{18060001,20},{18060002,40},{18060003,80},{18051701,200}]',2),(60401701,3,'0',70,'[{18060001,20},{18060002,40},{18060003,80},{18051701,200}]',2),(60401701,4,'0',90,'[{18060001,20},{18060002,40},{18060003,80},{18051701,200}]',2),(60401701,5,'0',110,'[{18060001,20},{18060002,40},{18060003,80},{18051701,200}]',2),(60401701,6,'0',130,'[{18060001,20},{18060002,40},{18060003,80},{18051701,200}]',2),(60401701,7,'0',150,'[{18060001,20},{18060002,40},{18060003,80},{18051701,200}]',2),(60401701,8,'0',170,'[{18060001,20},{18060002,40},{18060003,80},{18051701,200}]',2),(60401701,9,'0',190,'[{18060001,20},{18060002,40},{18060003,80},{18051701,200}]',2),(60401701,10,'0',210,'[{18060001,20},{18060002,40},{18060003,80},{18051701,200}]',2),(60401701,11,'0',230,'[{18060001,20},{18060002,40},{18060003,80},{18051701,200}]',2),(60401701,12,'0',250,'[{18060001,20},{18060002,40},{18060003,80},{18051701,200}]',2),(60401701,13,'0',275,'[{18060001,20},{18060002,40},{18060003,80},{18051701,200}]',2),(60401701,14,'0',300,'[{18060001,20},{18060002,40},{18060003,80},{18051701,200}]',2),(60401701,15,'0',325,'[{18060001,20},{18060002,40},{18060003,80},{18051701,200}]',2),(60401701,16,'0',350,'[{18060001,20},{18060002,40},{18060003,80},{18051701,200}]',2),(60401701,17,'0',375,'[{18060001,20},{18060002,40},{18060003,80},{18051701,200}]',2),(60401701,18,'0',400,'[{18060001,20},{18060002,40},{18060003,80},{18051701,200}]',2),(60401701,19,'0',425,'[{18060001,20},{18060002,40},{18060003,80},{18051701,200}]',2),(60401701,20,'0',450,'[{18060001,20},{18060002,40},{18060003,80},{18051701,200}]',2),(60401701,21,'0',475,'[{18060001,20},{18060002,40},{18060003,80},{18051701,200}]',2),(60401701,22,'0',500,'[{18060001,20},{18060002,40},{18060003,80},{18051701,200}]',2),(60401701,23,'0',525,'[{18060001,20},{18060002,40},{18060003,80},{18051701,200}]',2),(60401701,24,'0',550,'[{18060001,20},{18060002,40},{18060003,80},{18051701,200}]',2),(60401701,25,'0',0,'[{18060001,20},{18060002,40},{18060003,80},{18051701,200}]',2),(60401801,1,'18051801',30,'[{18060001,20},{18060002,40},{18060003,80},{18051801,200}]',2),(60401801,2,'0',50,'[{18060001,20},{18060002,40},{18060003,80},{18051801,200}]',2),(60401801,3,'0',70,'[{18060001,20},{18060002,40},{18060003,80},{18051801,200}]',2),(60401801,4,'0',90,'[{18060001,20},{18060002,40},{18060003,80},{18051801,200}]',2),(60401801,5,'0',110,'[{18060001,20},{18060002,40},{18060003,80},{18051801,200}]',2),(60401801,6,'0',130,'[{18060001,20},{18060002,40},{18060003,80},{18051801,200}]',2),(60401801,7,'0',150,'[{18060001,20},{18060002,40},{18060003,80},{18051801,200}]',2),(60401801,8,'0',170,'[{18060001,20},{18060002,40},{18060003,80},{18051801,200}]',2),(60401801,9,'0',190,'[{18060001,20},{18060002,40},{18060003,80},{18051801,200}]',2),(60401801,10,'0',210,'[{18060001,20},{18060002,40},{18060003,80},{18051801,200}]',2),(60401801,11,'0',230,'[{18060001,20},{18060002,40},{18060003,80},{18051801,200}]',2),(60401801,12,'0',250,'[{18060001,20},{18060002,40},{18060003,80},{18051801,200}]',2),(60401801,13,'0',275,'[{18060001,20},{18060002,40},{18060003,80},{18051801,200}]',2),(60401801,14,'0',300,'[{18060001,20},{18060002,40},{18060003,80},{18051801,200}]',2),(60401801,15,'0',325,'[{18060001,20},{18060002,40},{18060003,80},{18051801,200}]',2),(60401801,16,'0',350,'[{18060001,20},{18060002,40},{18060003,80},{18051801,200}]',2),(60401801,17,'0',375,'[{18060001,20},{18060002,40},{18060003,80},{18051801,200}]',2),(60401801,18,'0',400,'[{18060001,20},{18060002,40},{18060003,80},{18051801,200}]',2),(60401801,19,'0',425,'[{18060001,20},{18060002,40},{18060003,80},{18051801,200}]',2),(60401801,20,'0',450,'[{18060001,20},{18060002,40},{18060003,80},{18051801,200}]',2),(60401801,21,'0',475,'[{18060001,20},{18060002,40},{18060003,80},{18051801,200}]',2),(60401801,22,'0',500,'[{18060001,20},{18060002,40},{18060003,80},{18051801,200}]',2),(60401801,23,'0',525,'[{18060001,20},{18060002,40},{18060003,80},{18051801,200}]',2),(60401801,24,'0',550,'[{18060001,20},{18060002,40},{18060003,80},{18051801,200}]',2),(60401801,25,'0',0,'[{18060001,20},{18060002,40},{18060003,80},{18051801,200}]',2),(60401901,1,'18051901',30,'[{18060001,20},{18060002,40},{18060003,80},{18051901,200}]',2),(60401901,2,'0',50,'[{18060001,20},{18060002,40},{18060003,80},{18051901,200}]',2),(60401901,3,'0',70,'[{18060001,20},{18060002,40},{18060003,80},{18051901,200}]',2),(60401901,4,'0',90,'[{18060001,20},{18060002,40},{18060003,80},{18051901,200}]',2),(60401901,5,'0',110,'[{18060001,20},{18060002,40},{18060003,80},{18051901,200}]',2),(60401901,6,'0',130,'[{18060001,20},{18060002,40},{18060003,80},{18051901,200}]',2),(60401901,7,'0',150,'[{18060001,20},{18060002,40},{18060003,80},{18051901,200}]',2),(60401901,8,'0',170,'[{18060001,20},{18060002,40},{18060003,80},{18051901,200}]',2),(60401901,9,'0',190,'[{18060001,20},{18060002,40},{18060003,80},{18051901,200}]',2),(60401901,10,'0',210,'[{18060001,20},{18060002,40},{18060003,80},{18051901,200}]',2),(60401901,11,'0',230,'[{18060001,20},{18060002,40},{18060003,80},{18051901,200}]',2),(60401901,12,'0',250,'[{18060001,20},{18060002,40},{18060003,80},{18051901,200}]',2),(60401901,13,'0',275,'[{18060001,20},{18060002,40},{18060003,80},{18051901,200}]',2),(60401901,14,'0',300,'[{18060001,20},{18060002,40},{18060003,80},{18051901,200}]',2),(60401901,15,'0',325,'[{18060001,20},{18060002,40},{18060003,80},{18051901,200}]',2),(60401901,16,'0',350,'[{18060001,20},{18060002,40},{18060003,80},{18051901,200}]',2),(60401901,17,'0',375,'[{18060001,20},{18060002,40},{18060003,80},{18051901,200}]',2),(60401901,18,'0',400,'[{18060001,20},{18060002,40},{18060003,80},{18051901,200}]',2),(60401901,19,'0',425,'[{18060001,20},{18060002,40},{18060003,80},{18051901,200}]',2),(60401901,20,'0',450,'[{18060001,20},{18060002,40},{18060003,80},{18051901,200}]',2),(60401901,21,'0',475,'[{18060001,20},{18060002,40},{18060003,80},{18051901,200}]',2),(60401901,22,'0',500,'[{18060001,20},{18060002,40},{18060003,80},{18051901,200}]',2),(60401901,23,'0',525,'[{18060001,20},{18060002,40},{18060003,80},{18051901,200}]',2),(60401901,24,'0',550,'[{18060001,20},{18060002,40},{18060003,80},{18051901,200}]',2),(60401901,25,'0',0,'[{18060001,20},{18060002,40},{18060003,80},{18051901,200}]',2),(60402001,1,'18052001',30,'[{18060001,20},{18060002,40},{18060003,80},{18052001,200}]',2),(60402001,2,'0',50,'[{18060001,20},{18060002,40},{18060003,80},{18052001,200}]',2),(60402001,3,'0',70,'[{18060001,20},{18060002,40},{18060003,80},{18052001,200}]',2),(60402001,4,'0',90,'[{18060001,20},{18060002,40},{18060003,80},{18052001,200}]',2),(60402001,5,'0',110,'[{18060001,20},{18060002,40},{18060003,80},{18052001,200}]',2),(60402001,6,'0',130,'[{18060001,20},{18060002,40},{18060003,80},{18052001,200}]',2),(60402001,7,'0',150,'[{18060001,20},{18060002,40},{18060003,80},{18052001,200}]',2),(60402001,8,'0',170,'[{18060001,20},{18060002,40},{18060003,80},{18052001,200}]',2),(60402001,9,'0',190,'[{18060001,20},{18060002,40},{18060003,80},{18052001,200}]',2),(60402001,10,'0',210,'[{18060001,20},{18060002,40},{18060003,80},{18052001,200}]',2),(60402001,11,'0',230,'[{18060001,20},{18060002,40},{18060003,80},{18052001,200}]',2),(60402001,12,'0',250,'[{18060001,20},{18060002,40},{18060003,80},{18052001,200}]',2),(60402001,13,'0',275,'[{18060001,20},{18060002,40},{18060003,80},{18052001,200}]',2),(60402001,14,'0',300,'[{18060001,20},{18060002,40},{18060003,80},{18052001,200}]',2),(60402001,15,'0',325,'[{18060001,20},{18060002,40},{18060003,80},{18052001,200}]',2),(60402001,16,'0',350,'[{18060001,20},{18060002,40},{18060003,80},{18052001,200}]',2),(60402001,17,'0',375,'[{18060001,20},{18060002,40},{18060003,80},{18052001,200}]',2),(60402001,18,'0',400,'[{18060001,20},{18060002,40},{18060003,80},{18052001,200}]',2),(60402001,19,'0',425,'[{18060001,20},{18060002,40},{18060003,80},{18052001,200}]',2),(60402001,20,'0',450,'[{18060001,20},{18060002,40},{18060003,80},{18052001,200}]',2),(60402001,21,'0',475,'[{18060001,20},{18060002,40},{18060003,80},{18052001,200}]',2),(60402001,22,'0',500,'[{18060001,20},{18060002,40},{18060003,80},{18052001,200}]',2),(60402001,23,'0',525,'[{18060001,20},{18060002,40},{18060003,80},{18052001,200}]',2),(60402001,24,'0',550,'[{18060001,20},{18060002,40},{18060003,80},{18052001,200}]',2),(60402001,25,'0',0,'[{18060001,20},{18060002,40},{18060003,80},{18052001,200}]',2),(60402101,1,'18052101',30,'[{18060001,20},{18060002,40},{18060003,80},{18052101,200}]',2),(60402101,2,'0',50,'[{18060001,20},{18060002,40},{18060003,80},{18052101,200}]',2),(60402101,3,'0',70,'[{18060001,20},{18060002,40},{18060003,80},{18052101,200}]',2),(60402101,4,'0',90,'[{18060001,20},{18060002,40},{18060003,80},{18052101,200}]',2),(60402101,5,'0',110,'[{18060001,20},{18060002,40},{18060003,80},{18052101,200}]',2),(60402101,6,'0',130,'[{18060001,20},{18060002,40},{18060003,80},{18052101,200}]',2),(60402101,7,'0',150,'[{18060001,20},{18060002,40},{18060003,80},{18052101,200}]',2),(60402101,8,'0',170,'[{18060001,20},{18060002,40},{18060003,80},{18052101,200}]',2),(60402101,9,'0',190,'[{18060001,20},{18060002,40},{18060003,80},{18052101,200}]',2),(60402101,10,'0',210,'[{18060001,20},{18060002,40},{18060003,80},{18052101,200}]',2),(60402101,11,'0',230,'[{18060001,20},{18060002,40},{18060003,80},{18052101,200}]',2),(60402101,12,'0',250,'[{18060001,20},{18060002,40},{18060003,80},{18052101,200}]',2),(60402101,13,'0',275,'[{18060001,20},{18060002,40},{18060003,80},{18052101,200}]',2),(60402101,14,'0',300,'[{18060001,20},{18060002,40},{18060003,80},{18052101,200}]',2),(60402101,15,'0',325,'[{18060001,20},{18060002,40},{18060003,80},{18052101,200}]',2),(60402101,16,'0',350,'[{18060001,20},{18060002,40},{18060003,80},{18052101,200}]',2),(60402101,17,'0',375,'[{18060001,20},{18060002,40},{18060003,80},{18052101,200}]',2),(60402101,18,'0',400,'[{18060001,20},{18060002,40},{18060003,80},{18052101,200}]',2),(60402101,19,'0',425,'[{18060001,20},{18060002,40},{18060003,80},{18052101,200}]',2),(60402101,20,'0',450,'[{18060001,20},{18060002,40},{18060003,80},{18052101,200}]',2),(60402101,21,'0',475,'[{18060001,20},{18060002,40},{18060003,80},{18052101,200}]',2),(60402101,22,'0',500,'[{18060001,20},{18060002,40},{18060003,80},{18052101,200}]',2),(60402101,23,'0',525,'[{18060001,20},{18060002,40},{18060003,80},{18052101,200}]',2),(60402101,24,'0',550,'[{18060001,20},{18060002,40},{18060003,80},{18052101,200}]',2),(60402101,25,'0',0,'[{18060001,20},{18060002,40},{18060003,80},{18052101,200}]',2),(60402201,1,'18052201',30,'[{18060001,20},{18060002,40},{18060003,80},{18052201,200}]',2),(60402201,2,'0',50,'[{18060001,20},{18060002,40},{18060003,80},{18052201,200}]',2),(60402201,3,'0',70,'[{18060001,20},{18060002,40},{18060003,80},{18052201,200}]',2),(60402201,4,'0',90,'[{18060001,20},{18060002,40},{18060003,80},{18052201,200}]',2),(60402201,5,'0',110,'[{18060001,20},{18060002,40},{18060003,80},{18052201,200}]',2),(60402201,6,'0',130,'[{18060001,20},{18060002,40},{18060003,80},{18052201,200}]',2),(60402201,7,'0',150,'[{18060001,20},{18060002,40},{18060003,80},{18052201,200}]',2),(60402201,8,'0',170,'[{18060001,20},{18060002,40},{18060003,80},{18052201,200}]',2),(60402201,9,'0',190,'[{18060001,20},{18060002,40},{18060003,80},{18052201,200}]',2),(60402201,10,'0',210,'[{18060001,20},{18060002,40},{18060003,80},{18052201,200}]',2),(60402201,11,'0',230,'[{18060001,20},{18060002,40},{18060003,80},{18052201,200}]',2),(60402201,12,'0',250,'[{18060001,20},{18060002,40},{18060003,80},{18052201,200}]',2),(60402201,13,'0',275,'[{18060001,20},{18060002,40},{18060003,80},{18052201,200}]',2),(60402201,14,'0',300,'[{18060001,20},{18060002,40},{18060003,80},{18052201,200}]',2),(60402201,15,'0',325,'[{18060001,20},{18060002,40},{18060003,80},{18052201,200}]',2),(60402201,16,'0',350,'[{18060001,20},{18060002,40},{18060003,80},{18052201,200}]',2),(60402201,17,'0',375,'[{18060001,20},{18060002,40},{18060003,80},{18052201,200}]',2),(60402201,18,'0',400,'[{18060001,20},{18060002,40},{18060003,80},{18052201,200}]',2),(60402201,19,'0',425,'[{18060001,20},{18060002,40},{18060003,80},{18052201,200}]',2),(60402201,20,'0',450,'[{18060001,20},{18060002,40},{18060003,80},{18052201,200}]',2),(60402201,21,'0',475,'[{18060001,20},{18060002,40},{18060003,80},{18052201,200}]',2),(60402201,22,'0',500,'[{18060001,20},{18060002,40},{18060003,80},{18052201,200}]',2),(60402201,23,'0',525,'[{18060001,20},{18060002,40},{18060003,80},{18052201,200}]',2),(60402201,24,'0',550,'[{18060001,20},{18060002,40},{18060003,80},{18052201,200}]',2),(60402201,25,'0',0,'[{18060001,20},{18060002,40},{18060003,80},{18052201,200}]',2),(60402301,1,'18052301',30,'[{18060001,20},{18060002,40},{18060003,80},{18052301,200}]',2),(60402301,2,'0',50,'[{18060001,20},{18060002,40},{18060003,80},{18052301,200}]',2),(60402301,3,'0',70,'[{18060001,20},{18060002,40},{18060003,80},{18052301,200}]',2),(60402301,4,'0',90,'[{18060001,20},{18060002,40},{18060003,80},{18052301,200}]',2),(60402301,5,'0',110,'[{18060001,20},{18060002,40},{18060003,80},{18052301,200}]',2),(60402301,6,'0',130,'[{18060001,20},{18060002,40},{18060003,80},{18052301,200}]',2),(60402301,7,'0',150,'[{18060001,20},{18060002,40},{18060003,80},{18052301,200}]',2),(60402301,8,'0',170,'[{18060001,20},{18060002,40},{18060003,80},{18052301,200}]',2),(60402301,9,'0',190,'[{18060001,20},{18060002,40},{18060003,80},{18052301,200}]',2),(60402301,10,'0',210,'[{18060001,20},{18060002,40},{18060003,80},{18052301,200}]',2),(60402301,11,'0',230,'[{18060001,20},{18060002,40},{18060003,80},{18052301,200}]',2),(60402301,12,'0',250,'[{18060001,20},{18060002,40},{18060003,80},{18052301,200}]',2),(60402301,13,'0',275,'[{18060001,20},{18060002,40},{18060003,80},{18052301,200}]',2),(60402301,14,'0',300,'[{18060001,20},{18060002,40},{18060003,80},{18052301,200}]',2),(60402301,15,'0',325,'[{18060001,20},{18060002,40},{18060003,80},{18052301,200}]',2),(60402301,16,'0',350,'[{18060001,20},{18060002,40},{18060003,80},{18052301,200}]',2),(60402301,17,'0',375,'[{18060001,20},{18060002,40},{18060003,80},{18052301,200}]',2),(60402301,18,'0',400,'[{18060001,20},{18060002,40},{18060003,80},{18052301,200}]',2),(60402301,19,'0',425,'[{18060001,20},{18060002,40},{18060003,80},{18052301,200}]',2),(60402301,20,'0',450,'[{18060001,20},{18060002,40},{18060003,80},{18052301,200}]',2),(60402301,21,'0',475,'[{18060001,20},{18060002,40},{18060003,80},{18052301,200}]',2),(60402301,22,'0',500,'[{18060001,20},{18060002,40},{18060003,80},{18052301,200}]',2),(60402301,23,'0',525,'[{18060001,20},{18060002,40},{18060003,80},{18052301,200}]',2),(60402301,24,'0',550,'[{18060001,20},{18060002,40},{18060003,80},{18052301,200}]',2),(60402301,25,'0',0,'[{18060001,20},{18060002,40},{18060003,80},{18052301,200}]',2),(60402401,1,'18052401',40,'[{18060001,20},{18060002,40},{18060003,80},{18052401,450}]',3),(60402401,2,'0',70,'[{18060001,20},{18060002,40},{18060003,80},{18052401,450}]',3),(60402401,3,'0',100,'[{18060001,20},{18060002,40},{18060003,80},{18052401,450}]',3),(60402401,4,'0',130,'[{18060001,20},{18060002,40},{18060003,80},{18052401,450}]',3),(60402401,5,'0',160,'[{18060001,20},{18060002,40},{18060003,80},{18052401,450}]',3),(60402401,6,'0',190,'[{18060001,20},{18060002,40},{18060003,80},{18052401,450}]',3),(60402401,7,'0',220,'[{18060001,20},{18060002,40},{18060003,80},{18052401,450}]',3),(60402401,8,'0',250,'[{18060001,20},{18060002,40},{18060003,80},{18052401,450}]',3),(60402401,9,'0',280,'[{18060001,20},{18060002,40},{18060003,80},{18052401,450}]',3),(60402401,10,'0',310,'[{18060001,20},{18060002,40},{18060003,80},{18052401,450}]',3),(60402401,11,'0',340,'[{18060001,20},{18060002,40},{18060003,80},{18052401,450}]',3),(60402401,12,'0',370,'[{18060001,20},{18060002,40},{18060003,80},{18052401,450}]',3),(60402401,13,'0',400,'[{18060001,20},{18060002,40},{18060003,80},{18052401,450}]',3),(60402401,14,'0',430,'[{18060001,20},{18060002,40},{18060003,80},{18052401,450}]',3),(60402401,15,'0',470,'[{18060001,20},{18060002,40},{18060003,80},{18052401,450}]',3),(60402401,16,'0',510,'[{18060001,20},{18060002,40},{18060003,80},{18052401,450}]',3),(60402401,17,'0',550,'[{18060001,20},{18060002,40},{18060003,80},{18052401,450}]',3),(60402401,18,'0',590,'[{18060001,20},{18060002,40},{18060003,80},{18052401,450}]',3),(60402401,19,'0',630,'[{18060001,20},{18060002,40},{18060003,80},{18052401,450}]',3),(60402401,20,'0',670,'[{18060001,20},{18060002,40},{18060003,80},{18052401,450}]',3),(60402401,21,'0',710,'[{18060001,20},{18060002,40},{18060003,80},{18052401,450}]',3),(60402401,22,'0',750,'[{18060001,20},{18060002,40},{18060003,80},{18052401,450}]',3),(60402401,23,'0',790,'[{18060001,20},{18060002,40},{18060003,80},{18052401,450}]',3),(60402401,24,'0',830,'[{18060001,20},{18060002,40},{18060003,80},{18052401,450}]',3),(60402401,25,'0',870,'[{18060001,20},{18060002,40},{18060003,80},{18052401,450}]',3),(60402401,26,'0',910,'[{18060001,20},{18060002,40},{18060003,80},{18052401,450}]',3),(60402401,27,'0',950,'[{18060001,20},{18060002,40},{18060003,80},{18052401,450}]',3),(60402401,28,'0',990,'[{18060001,20},{18060002,40},{18060003,80},{18052401,450}]',3),(60402401,29,'0',1030,'[{18060001,20},{18060002,40},{18060003,80},{18052401,450}]',3),(60402401,30,'0',0,'[{18060001,20},{18060002,40},{18060003,80},{18052401,450}]',3),(60402501,1,'18052501',40,'[{18060001,20},{18060002,40},{18060003,80},{18052501,450}]',3),(60402501,2,'0',70,'[{18060001,20},{18060002,40},{18060003,80},{18052501,450}]',3),(60402501,3,'0',100,'[{18060001,20},{18060002,40},{18060003,80},{18052501,450}]',3),(60402501,4,'0',130,'[{18060001,20},{18060002,40},{18060003,80},{18052501,450}]',3),(60402501,5,'0',160,'[{18060001,20},{18060002,40},{18060003,80},{18052501,450}]',3),(60402501,6,'0',190,'[{18060001,20},{18060002,40},{18060003,80},{18052501,450}]',3),(60402501,7,'0',220,'[{18060001,20},{18060002,40},{18060003,80},{18052501,450}]',3),(60402501,8,'0',250,'[{18060001,20},{18060002,40},{18060003,80},{18052501,450}]',3),(60402501,9,'0',280,'[{18060001,20},{18060002,40},{18060003,80},{18052501,450}]',3),(60402501,10,'0',310,'[{18060001,20},{18060002,40},{18060003,80},{18052501,450}]',3),(60402501,11,'0',340,'[{18060001,20},{18060002,40},{18060003,80},{18052501,450}]',3),(60402501,12,'0',370,'[{18060001,20},{18060002,40},{18060003,80},{18052501,450}]',3),(60402501,13,'0',400,'[{18060001,20},{18060002,40},{18060003,80},{18052501,450}]',3),(60402501,14,'0',430,'[{18060001,20},{18060002,40},{18060003,80},{18052501,450}]',3),(60402501,15,'0',470,'[{18060001,20},{18060002,40},{18060003,80},{18052501,450}]',3),(60402501,16,'0',510,'[{18060001,20},{18060002,40},{18060003,80},{18052501,450}]',3),(60402501,17,'0',550,'[{18060001,20},{18060002,40},{18060003,80},{18052501,450}]',3),(60402501,18,'0',590,'[{18060001,20},{18060002,40},{18060003,80},{18052501,450}]',3),(60402501,19,'0',630,'[{18060001,20},{18060002,40},{18060003,80},{18052501,450}]',3),(60402501,20,'0',670,'[{18060001,20},{18060002,40},{18060003,80},{18052501,450}]',3),(60402501,21,'0',710,'[{18060001,20},{18060002,40},{18060003,80},{18052501,450}]',3),(60402501,22,'0',750,'[{18060001,20},{18060002,40},{18060003,80},{18052501,450}]',3),(60402501,23,'0',790,'[{18060001,20},{18060002,40},{18060003,80},{18052501,450}]',3),(60402501,24,'0',830,'[{18060001,20},{18060002,40},{18060003,80},{18052501,450}]',3),(60402501,25,'0',870,'[{18060001,20},{18060002,40},{18060003,80},{18052501,450}]',3),(60402501,26,'0',910,'[{18060001,20},{18060002,40},{18060003,80},{18052501,450}]',3),(60402501,27,'0',950,'[{18060001,20},{18060002,40},{18060003,80},{18052501,450}]',3),(60402501,28,'0',990,'[{18060001,20},{18060002,40},{18060003,80},{18052501,450}]',3),(60402501,29,'0',1030,'[{18060001,20},{18060002,40},{18060003,80},{18052501,450}]',3),(60402501,30,'0',0,'[{18060001,20},{18060002,40},{18060003,80},{18052501,450}]',3),(60402601,1,'18052601',40,'[{18060001,20},{18060002,40},{18060003,80},{18052601,450}]',3),(60402601,2,'0',70,'[{18060001,20},{18060002,40},{18060003,80},{18052601,450}]',3),(60402601,3,'0',100,'[{18060001,20},{18060002,40},{18060003,80},{18052601,450}]',3),(60402601,4,'0',130,'[{18060001,20},{18060002,40},{18060003,80},{18052601,450}]',3),(60402601,5,'0',160,'[{18060001,20},{18060002,40},{18060003,80},{18052601,450}]',3),(60402601,6,'0',190,'[{18060001,20},{18060002,40},{18060003,80},{18052601,450}]',3),(60402601,7,'0',220,'[{18060001,20},{18060002,40},{18060003,80},{18052601,450}]',3),(60402601,8,'0',250,'[{18060001,20},{18060002,40},{18060003,80},{18052601,450}]',3),(60402601,9,'0',280,'[{18060001,20},{18060002,40},{18060003,80},{18052601,450}]',3),(60402601,10,'0',310,'[{18060001,20},{18060002,40},{18060003,80},{18052601,450}]',3),(60402601,11,'0',340,'[{18060001,20},{18060002,40},{18060003,80},{18052601,450}]',3),(60402601,12,'0',370,'[{18060001,20},{18060002,40},{18060003,80},{18052601,450}]',3),(60402601,13,'0',400,'[{18060001,20},{18060002,40},{18060003,80},{18052601,450}]',3),(60402601,14,'0',430,'[{18060001,20},{18060002,40},{18060003,80},{18052601,450}]',3),(60402601,15,'0',470,'[{18060001,20},{18060002,40},{18060003,80},{18052601,450}]',3),(60402601,16,'0',510,'[{18060001,20},{18060002,40},{18060003,80},{18052601,450}]',3),(60402601,17,'0',550,'[{18060001,20},{18060002,40},{18060003,80},{18052601,450}]',3),(60402601,18,'0',590,'[{18060001,20},{18060002,40},{18060003,80},{18052601,450}]',3),(60402601,19,'0',630,'[{18060001,20},{18060002,40},{18060003,80},{18052601,450}]',3),(60402601,20,'0',670,'[{18060001,20},{18060002,40},{18060003,80},{18052601,450}]',3),(60402601,21,'0',710,'[{18060001,20},{18060002,40},{18060003,80},{18052601,450}]',3),(60402601,22,'0',750,'[{18060001,20},{18060002,40},{18060003,80},{18052601,450}]',3),(60402601,23,'0',790,'[{18060001,20},{18060002,40},{18060003,80},{18052601,450}]',3),(60402601,24,'0',830,'[{18060001,20},{18060002,40},{18060003,80},{18052601,450}]',3),(60402601,25,'0',870,'[{18060001,20},{18060002,40},{18060003,80},{18052601,450}]',3),(60402601,26,'0',910,'[{18060001,20},{18060002,40},{18060003,80},{18052601,450}]',3),(60402601,27,'0',950,'[{18060001,20},{18060002,40},{18060003,80},{18052601,450}]',3),(60402601,28,'0',990,'[{18060001,20},{18060002,40},{18060003,80},{18052601,450}]',3),(60402601,29,'0',1030,'[{18060001,20},{18060002,40},{18060003,80},{18052601,450}]',3),(60402601,30,'0',0,'[{18060001,20},{18060002,40},{18060003,80},{18052601,450}]',3),(60402701,1,'18052701',40,'[{18060001,20},{18060002,40},{18060003,80},{18052701,450}]',3),(60402701,2,'0',70,'[{18060001,20},{18060002,40},{18060003,80},{18052701,450}]',3),(60402701,3,'0',100,'[{18060001,20},{18060002,40},{18060003,80},{18052701,450}]',3),(60402701,4,'0',130,'[{18060001,20},{18060002,40},{18060003,80},{18052701,450}]',3),(60402701,5,'0',160,'[{18060001,20},{18060002,40},{18060003,80},{18052701,450}]',3),(60402701,6,'0',190,'[{18060001,20},{18060002,40},{18060003,80},{18052701,450}]',3),(60402701,7,'0',220,'[{18060001,20},{18060002,40},{18060003,80},{18052701,450}]',3),(60402701,8,'0',250,'[{18060001,20},{18060002,40},{18060003,80},{18052701,450}]',3),(60402701,9,'0',280,'[{18060001,20},{18060002,40},{18060003,80},{18052701,450}]',3),(60402701,10,'0',310,'[{18060001,20},{18060002,40},{18060003,80},{18052701,450}]',3),(60402701,11,'0',340,'[{18060001,20},{18060002,40},{18060003,80},{18052701,450}]',3),(60402701,12,'0',370,'[{18060001,20},{18060002,40},{18060003,80},{18052701,450}]',3),(60402701,13,'0',400,'[{18060001,20},{18060002,40},{18060003,80},{18052701,450}]',3),(60402701,14,'0',430,'[{18060001,20},{18060002,40},{18060003,80},{18052701,450}]',3),(60402701,15,'0',470,'[{18060001,20},{18060002,40},{18060003,80},{18052701,450}]',3),(60402701,16,'0',510,'[{18060001,20},{18060002,40},{18060003,80},{18052701,450}]',3),(60402701,17,'0',550,'[{18060001,20},{18060002,40},{18060003,80},{18052701,450}]',3),(60402701,18,'0',590,'[{18060001,20},{18060002,40},{18060003,80},{18052701,450}]',3),(60402701,19,'0',630,'[{18060001,20},{18060002,40},{18060003,80},{18052701,450}]',3),(60402701,20,'0',670,'[{18060001,20},{18060002,40},{18060003,80},{18052701,450}]',3),(60402701,21,'0',710,'[{18060001,20},{18060002,40},{18060003,80},{18052701,450}]',3),(60402701,22,'0',750,'[{18060001,20},{18060002,40},{18060003,80},{18052701,450}]',3),(60402701,23,'0',790,'[{18060001,20},{18060002,40},{18060003,80},{18052701,450}]',3),(60402701,24,'0',830,'[{18060001,20},{18060002,40},{18060003,80},{18052701,450}]',3),(60402701,25,'0',870,'[{18060001,20},{18060002,40},{18060003,80},{18052701,450}]',3),(60402701,26,'0',910,'[{18060001,20},{18060002,40},{18060003,80},{18052701,450}]',3),(60402701,27,'0',950,'[{18060001,20},{18060002,40},{18060003,80},{18052701,450}]',3),(60402701,28,'0',990,'[{18060001,20},{18060002,40},{18060003,80},{18052701,450}]',3),(60402701,29,'0',1030,'[{18060001,20},{18060002,40},{18060003,80},{18052701,450}]',3),(60402701,30,'0',0,'[{18060001,20},{18060002,40},{18060003,80},{18052701,450}]',3),(60402801,1,'18052801',40,'[{18060001,20},{18060002,40},{18060003,80},{18052801,450}]',3),(60402801,2,'0',70,'[{18060001,20},{18060002,40},{18060003,80},{18052801,450}]',3),(60402801,3,'0',100,'[{18060001,20},{18060002,40},{18060003,80},{18052801,450}]',3),(60402801,4,'0',130,'[{18060001,20},{18060002,40},{18060003,80},{18052801,450}]',3),(60402801,5,'0',160,'[{18060001,20},{18060002,40},{18060003,80},{18052801,450}]',3),(60402801,6,'0',190,'[{18060001,20},{18060002,40},{18060003,80},{18052801,450}]',3),(60402801,7,'0',220,'[{18060001,20},{18060002,40},{18060003,80},{18052801,450}]',3),(60402801,8,'0',250,'[{18060001,20},{18060002,40},{18060003,80},{18052801,450}]',3),(60402801,9,'0',280,'[{18060001,20},{18060002,40},{18060003,80},{18052801,450}]',3),(60402801,10,'0',310,'[{18060001,20},{18060002,40},{18060003,80},{18052801,450}]',3),(60402801,11,'0',340,'[{18060001,20},{18060002,40},{18060003,80},{18052801,450}]',3),(60402801,12,'0',370,'[{18060001,20},{18060002,40},{18060003,80},{18052801,450}]',3),(60402801,13,'0',400,'[{18060001,20},{18060002,40},{18060003,80},{18052801,450}]',3),(60402801,14,'0',430,'[{18060001,20},{18060002,40},{18060003,80},{18052801,450}]',3),(60402801,15,'0',470,'[{18060001,20},{18060002,40},{18060003,80},{18052801,450}]',3),(60402801,16,'0',510,'[{18060001,20},{18060002,40},{18060003,80},{18052801,450}]',3),(60402801,17,'0',550,'[{18060001,20},{18060002,40},{18060003,80},{18052801,450}]',3),(60402801,18,'0',590,'[{18060001,20},{18060002,40},{18060003,80},{18052801,450}]',3),(60402801,19,'0',630,'[{18060001,20},{18060002,40},{18060003,80},{18052801,450}]',3),(60402801,20,'0',670,'[{18060001,20},{18060002,40},{18060003,80},{18052801,450}]',3),(60402801,21,'0',710,'[{18060001,20},{18060002,40},{18060003,80},{18052801,450}]',3),(60402801,22,'0',750,'[{18060001,20},{18060002,40},{18060003,80},{18052801,450}]',3),(60402801,23,'0',790,'[{18060001,20},{18060002,40},{18060003,80},{18052801,450}]',3),(60402801,24,'0',830,'[{18060001,20},{18060002,40},{18060003,80},{18052801,450}]',3),(60402801,25,'0',870,'[{18060001,20},{18060002,40},{18060003,80},{18052801,450}]',3),(60402801,26,'0',910,'[{18060001,20},{18060002,40},{18060003,80},{18052801,450}]',3),(60402801,27,'0',950,'[{18060001,20},{18060002,40},{18060003,80},{18052801,450}]',3),(60402801,28,'0',990,'[{18060001,20},{18060002,40},{18060003,80},{18052801,450}]',3),(60402801,29,'0',1030,'[{18060001,20},{18060002,40},{18060003,80},{18052801,450}]',3),(60402801,30,'0',0,'[{18060001,20},{18060002,40},{18060003,80},{18052801,450}]',3),(60402901,1,'18052901',40,'[{18060001,20},{18060002,40},{18060003,80},{18052901,450}]',3),(60402901,2,'0',70,'[{18060001,20},{18060002,40},{18060003,80},{18052901,450}]',3),(60402901,3,'0',100,'[{18060001,20},{18060002,40},{18060003,80},{18052901,450}]',3),(60402901,4,'0',130,'[{18060001,20},{18060002,40},{18060003,80},{18052901,450}]',3),(60402901,5,'0',160,'[{18060001,20},{18060002,40},{18060003,80},{18052901,450}]',3),(60402901,6,'0',190,'[{18060001,20},{18060002,40},{18060003,80},{18052901,450}]',3),(60402901,7,'0',220,'[{18060001,20},{18060002,40},{18060003,80},{18052901,450}]',3),(60402901,8,'0',250,'[{18060001,20},{18060002,40},{18060003,80},{18052901,450}]',3),(60402901,9,'0',280,'[{18060001,20},{18060002,40},{18060003,80},{18052901,450}]',3),(60402901,10,'0',310,'[{18060001,20},{18060002,40},{18060003,80},{18052901,450}]',3),(60402901,11,'0',340,'[{18060001,20},{18060002,40},{18060003,80},{18052901,450}]',3),(60402901,12,'0',370,'[{18060001,20},{18060002,40},{18060003,80},{18052901,450}]',3),(60402901,13,'0',400,'[{18060001,20},{18060002,40},{18060003,80},{18052901,450}]',3),(60402901,14,'0',430,'[{18060001,20},{18060002,40},{18060003,80},{18052901,450}]',3),(60402901,15,'0',470,'[{18060001,20},{18060002,40},{18060003,80},{18052901,450}]',3),(60402901,16,'0',510,'[{18060001,20},{18060002,40},{18060003,80},{18052901,450}]',3),(60402901,17,'0',550,'[{18060001,20},{18060002,40},{18060003,80},{18052901,450}]',3),(60402901,18,'0',590,'[{18060001,20},{18060002,40},{18060003,80},{18052901,450}]',3),(60402901,19,'0',630,'[{18060001,20},{18060002,40},{18060003,80},{18052901,450}]',3),(60402901,20,'0',670,'[{18060001,20},{18060002,40},{18060003,80},{18052901,450}]',3),(60402901,21,'0',710,'[{18060001,20},{18060002,40},{18060003,80},{18052901,450}]',3),(60402901,22,'0',750,'[{18060001,20},{18060002,40},{18060003,80},{18052901,450}]',3),(60402901,23,'0',790,'[{18060001,20},{18060002,40},{18060003,80},{18052901,450}]',3),(60402901,24,'0',830,'[{18060001,20},{18060002,40},{18060003,80},{18052901,450}]',3),(60402901,25,'0',870,'[{18060001,20},{18060002,40},{18060003,80},{18052901,450}]',3),(60402901,26,'0',910,'[{18060001,20},{18060002,40},{18060003,80},{18052901,450}]',3),(60402901,27,'0',950,'[{18060001,20},{18060002,40},{18060003,80},{18052901,450}]',3),(60402901,28,'0',990,'[{18060001,20},{18060002,40},{18060003,80},{18052901,450}]',3),(60402901,29,'0',1030,'[{18060001,20},{18060002,40},{18060003,80},{18052901,450}]',3),(60402901,30,'0',0,'[{18060001,20},{18060002,40},{18060003,80},{18052901,450}]',3),(60403001,1,'18053001',40,'[{18060001,20},{18060002,40},{18060003,80},{18053001,450}]',3),(60403001,2,'0',70,'[{18060001,20},{18060002,40},{18060003,80},{18053001,450}]',3),(60403001,3,'0',100,'[{18060001,20},{18060002,40},{18060003,80},{18053001,450}]',3),(60403001,4,'0',130,'[{18060001,20},{18060002,40},{18060003,80},{18053001,450}]',3),(60403001,5,'0',160,'[{18060001,20},{18060002,40},{18060003,80},{18053001,450}]',3),(60403001,6,'0',190,'[{18060001,20},{18060002,40},{18060003,80},{18053001,450}]',3),(60403001,7,'0',220,'[{18060001,20},{18060002,40},{18060003,80},{18053001,450}]',3),(60403001,8,'0',250,'[{18060001,20},{18060002,40},{18060003,80},{18053001,450}]',3),(60403001,9,'0',280,'[{18060001,20},{18060002,40},{18060003,80},{18053001,450}]',3),(60403001,10,'0',310,'[{18060001,20},{18060002,40},{18060003,80},{18053001,450}]',3),(60403001,11,'0',340,'[{18060001,20},{18060002,40},{18060003,80},{18053001,450}]',3),(60403001,12,'0',370,'[{18060001,20},{18060002,40},{18060003,80},{18053001,450}]',3),(60403001,13,'0',400,'[{18060001,20},{18060002,40},{18060003,80},{18053001,450}]',3),(60403001,14,'0',430,'[{18060001,20},{18060002,40},{18060003,80},{18053001,450}]',3),(60403001,15,'0',470,'[{18060001,20},{18060002,40},{18060003,80},{18053001,450}]',3),(60403001,16,'0',510,'[{18060001,20},{18060002,40},{18060003,80},{18053001,450}]',3),(60403001,17,'0',550,'[{18060001,20},{18060002,40},{18060003,80},{18053001,450}]',3),(60403001,18,'0',590,'[{18060001,20},{18060002,40},{18060003,80},{18053001,450}]',3),(60403001,19,'0',630,'[{18060001,20},{18060002,40},{18060003,80},{18053001,450}]',3),(60403001,20,'0',670,'[{18060001,20},{18060002,40},{18060003,80},{18053001,450}]',3),(60403001,21,'0',710,'[{18060001,20},{18060002,40},{18060003,80},{18053001,450}]',3),(60403001,22,'0',750,'[{18060001,20},{18060002,40},{18060003,80},{18053001,450}]',3),(60403001,23,'0',790,'[{18060001,20},{18060002,40},{18060003,80},{18053001,450}]',3),(60403001,24,'0',830,'[{18060001,20},{18060002,40},{18060003,80},{18053001,450}]',3),(60403001,25,'0',870,'[{18060001,20},{18060002,40},{18060003,80},{18053001,450}]',3),(60403001,26,'0',910,'[{18060001,20},{18060002,40},{18060003,80},{18053001,450}]',3),(60403001,27,'0',950,'[{18060001,20},{18060002,40},{18060003,80},{18053001,450}]',3),(60403001,28,'0',990,'[{18060001,20},{18060002,40},{18060003,80},{18053001,450}]',3),(60403001,29,'0',1030,'[{18060001,20},{18060002,40},{18060003,80},{18053001,450}]',3),(60403001,30,'0',0,'[{18060001,20},{18060002,40},{18060003,80},{18053001,450}]',3),(60403101,1,'18053101',40,'[{18060001,20},{18060002,40},{18060003,80},{18053101,450}]',3),(60403101,2,'0',70,'[{18060001,20},{18060002,40},{18060003,80},{18053101,450}]',3),(60403101,3,'0',100,'[{18060001,20},{18060002,40},{18060003,80},{18053101,450}]',3),(60403101,4,'0',130,'[{18060001,20},{18060002,40},{18060003,80},{18053101,450}]',3),(60403101,5,'0',160,'[{18060001,20},{18060002,40},{18060003,80},{18053101,450}]',3),(60403101,6,'0',190,'[{18060001,20},{18060002,40},{18060003,80},{18053101,450}]',3),(60403101,7,'0',220,'[{18060001,20},{18060002,40},{18060003,80},{18053101,450}]',3),(60403101,8,'0',250,'[{18060001,20},{18060002,40},{18060003,80},{18053101,450}]',3),(60403101,9,'0',280,'[{18060001,20},{18060002,40},{18060003,80},{18053101,450}]',3),(60403101,10,'0',310,'[{18060001,20},{18060002,40},{18060003,80},{18053101,450}]',3),(60403101,11,'0',340,'[{18060001,20},{18060002,40},{18060003,80},{18053101,450}]',3),(60403101,12,'0',370,'[{18060001,20},{18060002,40},{18060003,80},{18053101,450}]',3),(60403101,13,'0',400,'[{18060001,20},{18060002,40},{18060003,80},{18053101,450}]',3),(60403101,14,'0',430,'[{18060001,20},{18060002,40},{18060003,80},{18053101,450}]',3),(60403101,15,'0',470,'[{18060001,20},{18060002,40},{18060003,80},{18053101,450}]',3),(60403101,16,'0',510,'[{18060001,20},{18060002,40},{18060003,80},{18053101,450}]',3),(60403101,17,'0',550,'[{18060001,20},{18060002,40},{18060003,80},{18053101,450}]',3),(60403101,18,'0',590,'[{18060001,20},{18060002,40},{18060003,80},{18053101,450}]',3),(60403101,19,'0',630,'[{18060001,20},{18060002,40},{18060003,80},{18053101,450}]',3),(60403101,20,'0',670,'[{18060001,20},{18060002,40},{18060003,80},{18053101,450}]',3),(60403101,21,'0',710,'[{18060001,20},{18060002,40},{18060003,80},{18053101,450}]',3),(60403101,22,'0',750,'[{18060001,20},{18060002,40},{18060003,80},{18053101,450}]',3),(60403101,23,'0',790,'[{18060001,20},{18060002,40},{18060003,80},{18053101,450}]',3),(60403101,24,'0',830,'[{18060001,20},{18060002,40},{18060003,80},{18053101,450}]',3),(60403101,25,'0',870,'[{18060001,20},{18060002,40},{18060003,80},{18053101,450}]',3),(60403101,26,'0',910,'[{18060001,20},{18060002,40},{18060003,80},{18053101,450}]',3),(60403101,27,'0',950,'[{18060001,20},{18060002,40},{18060003,80},{18053101,450}]',3),(60403101,28,'0',990,'[{18060001,20},{18060002,40},{18060003,80},{18053101,450}]',3),(60403101,29,'0',1030,'[{18060001,20},{18060002,40},{18060003,80},{18053101,450}]',3),(60403101,30,'0',0,'[{18060001,20},{18060002,40},{18060003,80},{18053101,450}]',3),(60403201,1,'18053201',40,'[{18060001,20},{18060002,40},{18060003,80},{18053201,450}]',3),(60403201,2,'0',70,'[{18060001,20},{18060002,40},{18060003,80},{18053201,450}]',3),(60403201,3,'0',100,'[{18060001,20},{18060002,40},{18060003,80},{18053201,450}]',3),(60403201,4,'0',130,'[{18060001,20},{18060002,40},{18060003,80},{18053201,450}]',3),(60403201,5,'0',160,'[{18060001,20},{18060002,40},{18060003,80},{18053201,450}]',3),(60403201,6,'0',190,'[{18060001,20},{18060002,40},{18060003,80},{18053201,450}]',3),(60403201,7,'0',220,'[{18060001,20},{18060002,40},{18060003,80},{18053201,450}]',3),(60403201,8,'0',250,'[{18060001,20},{18060002,40},{18060003,80},{18053201,450}]',3),(60403201,9,'0',280,'[{18060001,20},{18060002,40},{18060003,80},{18053201,450}]',3),(60403201,10,'0',310,'[{18060001,20},{18060002,40},{18060003,80},{18053201,450}]',3),(60403201,11,'0',340,'[{18060001,20},{18060002,40},{18060003,80},{18053201,450}]',3),(60403201,12,'0',370,'[{18060001,20},{18060002,40},{18060003,80},{18053201,450}]',3),(60403201,13,'0',400,'[{18060001,20},{18060002,40},{18060003,80},{18053201,450}]',3),(60403201,14,'0',430,'[{18060001,20},{18060002,40},{18060003,80},{18053201,450}]',3),(60403201,15,'0',470,'[{18060001,20},{18060002,40},{18060003,80},{18053201,450}]',3),(60403201,16,'0',510,'[{18060001,20},{18060002,40},{18060003,80},{18053201,450}]',3),(60403201,17,'0',550,'[{18060001,20},{18060002,40},{18060003,80},{18053201,450}]',3),(60403201,18,'0',590,'[{18060001,20},{18060002,40},{18060003,80},{18053201,450}]',3),(60403201,19,'0',630,'[{18060001,20},{18060002,40},{18060003,80},{18053201,450}]',3),(60403201,20,'0',670,'[{18060001,20},{18060002,40},{18060003,80},{18053201,450}]',3),(60403201,21,'0',710,'[{18060001,20},{18060002,40},{18060003,80},{18053201,450}]',3),(60403201,22,'0',750,'[{18060001,20},{18060002,40},{18060003,80},{18053201,450}]',3),(60403201,23,'0',790,'[{18060001,20},{18060002,40},{18060003,80},{18053201,450}]',3),(60403201,24,'0',830,'[{18060001,20},{18060002,40},{18060003,80},{18053201,450}]',3),(60403201,25,'0',870,'[{18060001,20},{18060002,40},{18060003,80},{18053201,450}]',3),(60403201,26,'0',910,'[{18060001,20},{18060002,40},{18060003,80},{18053201,450}]',3),(60403201,27,'0',950,'[{18060001,20},{18060002,40},{18060003,80},{18053201,450}]',3),(60403201,28,'0',990,'[{18060001,20},{18060002,40},{18060003,80},{18053201,450}]',3),(60403201,29,'0',1030,'[{18060001,20},{18060002,40},{18060003,80},{18053201,450}]',3),(60403201,30,'0',0,'[{18060001,20},{18060002,40},{18060003,80},{18053201,450}]',3),(60403301,1,'18053301',40,'[{18060001,20},{18060002,40},{18060003,80},{18053301,450}]',3),(60403301,2,'0',70,'[{18060001,20},{18060002,40},{18060003,80},{18053301,450}]',3),(60403301,3,'0',100,'[{18060001,20},{18060002,40},{18060003,80},{18053301,450}]',3),(60403301,4,'0',130,'[{18060001,20},{18060002,40},{18060003,80},{18053301,450}]',3),(60403301,5,'0',160,'[{18060001,20},{18060002,40},{18060003,80},{18053301,450}]',3),(60403301,6,'0',190,'[{18060001,20},{18060002,40},{18060003,80},{18053301,450}]',3),(60403301,7,'0',220,'[{18060001,20},{18060002,40},{18060003,80},{18053301,450}]',3),(60403301,8,'0',250,'[{18060001,20},{18060002,40},{18060003,80},{18053301,450}]',3),(60403301,9,'0',280,'[{18060001,20},{18060002,40},{18060003,80},{18053301,450}]',3),(60403301,10,'0',310,'[{18060001,20},{18060002,40},{18060003,80},{18053301,450}]',3),(60403301,11,'0',340,'[{18060001,20},{18060002,40},{18060003,80},{18053301,450}]',3),(60403301,12,'0',370,'[{18060001,20},{18060002,40},{18060003,80},{18053301,450}]',3),(60403301,13,'0',400,'[{18060001,20},{18060002,40},{18060003,80},{18053301,450}]',3),(60403301,14,'0',430,'[{18060001,20},{18060002,40},{18060003,80},{18053301,450}]',3),(60403301,15,'0',470,'[{18060001,20},{18060002,40},{18060003,80},{18053301,450}]',3),(60403301,16,'0',510,'[{18060001,20},{18060002,40},{18060003,80},{18053301,450}]',3),(60403301,17,'0',550,'[{18060001,20},{18060002,40},{18060003,80},{18053301,450}]',3),(60403301,18,'0',590,'[{18060001,20},{18060002,40},{18060003,80},{18053301,450}]',3),(60403301,19,'0',630,'[{18060001,20},{18060002,40},{18060003,80},{18053301,450}]',3),(60403301,20,'0',670,'[{18060001,20},{18060002,40},{18060003,80},{18053301,450}]',3),(60403301,21,'0',710,'[{18060001,20},{18060002,40},{18060003,80},{18053301,450}]',3),(60403301,22,'0',750,'[{18060001,20},{18060002,40},{18060003,80},{18053301,450}]',3),(60403301,23,'0',790,'[{18060001,20},{18060002,40},{18060003,80},{18053301,450}]',3),(60403301,24,'0',830,'[{18060001,20},{18060002,40},{18060003,80},{18053301,450}]',3),(60403301,25,'0',870,'[{18060001,20},{18060002,40},{18060003,80},{18053301,450}]',3),(60403301,26,'0',910,'[{18060001,20},{18060002,40},{18060003,80},{18053301,450}]',3),(60403301,27,'0',950,'[{18060001,20},{18060002,40},{18060003,80},{18053301,450}]',3),(60403301,28,'0',990,'[{18060001,20},{18060002,40},{18060003,80},{18053301,450}]',3),(60403301,29,'0',1030,'[{18060001,20},{18060002,40},{18060003,80},{18053301,450}]',3),(60403301,30,'0',0,'[{18060001,20},{18060002,40},{18060003,80},{18053301,450}]',3),(60403401,1,'18053401',40,'[{18060001,20},{18060002,40},{18060003,80},{18053401,450}]',3),(60403401,2,'0',70,'[{18060001,20},{18060002,40},{18060003,80},{18053401,450}]',3),(60403401,3,'0',100,'[{18060001,20},{18060002,40},{18060003,80},{18053401,450}]',3),(60403401,4,'0',130,'[{18060001,20},{18060002,40},{18060003,80},{18053401,450}]',3),(60403401,5,'0',160,'[{18060001,20},{18060002,40},{18060003,80},{18053401,450}]',3),(60403401,6,'0',190,'[{18060001,20},{18060002,40},{18060003,80},{18053401,450}]',3),(60403401,7,'0',220,'[{18060001,20},{18060002,40},{18060003,80},{18053401,450}]',3),(60403401,8,'0',250,'[{18060001,20},{18060002,40},{18060003,80},{18053401,450}]',3),(60403401,9,'0',280,'[{18060001,20},{18060002,40},{18060003,80},{18053401,450}]',3),(60403401,10,'0',310,'[{18060001,20},{18060002,40},{18060003,80},{18053401,450}]',3),(60403401,11,'0',340,'[{18060001,20},{18060002,40},{18060003,80},{18053401,450}]',3),(60403401,12,'0',370,'[{18060001,20},{18060002,40},{18060003,80},{18053401,450}]',3),(60403401,13,'0',400,'[{18060001,20},{18060002,40},{18060003,80},{18053401,450}]',3),(60403401,14,'0',430,'[{18060001,20},{18060002,40},{18060003,80},{18053401,450}]',3),(60403401,15,'0',470,'[{18060001,20},{18060002,40},{18060003,80},{18053401,450}]',3),(60403401,16,'0',510,'[{18060001,20},{18060002,40},{18060003,80},{18053401,450}]',3),(60403401,17,'0',550,'[{18060001,20},{18060002,40},{18060003,80},{18053401,450}]',3),(60403401,18,'0',590,'[{18060001,20},{18060002,40},{18060003,80},{18053401,450}]',3),(60403401,19,'0',630,'[{18060001,20},{18060002,40},{18060003,80},{18053401,450}]',3),(60403401,20,'0',670,'[{18060001,20},{18060002,40},{18060003,80},{18053401,450}]',3),(60403401,21,'0',710,'[{18060001,20},{18060002,40},{18060003,80},{18053401,450}]',3),(60403401,22,'0',750,'[{18060001,20},{18060002,40},{18060003,80},{18053401,450}]',3),(60403401,23,'0',790,'[{18060001,20},{18060002,40},{18060003,80},{18053401,450}]',3),(60403401,24,'0',830,'[{18060001,20},{18060002,40},{18060003,80},{18053401,450}]',3),(60403401,25,'0',870,'[{18060001,20},{18060002,40},{18060003,80},{18053401,450}]',3),(60403401,26,'0',910,'[{18060001,20},{18060002,40},{18060003,80},{18053401,450}]',3),(60403401,27,'0',950,'[{18060001,20},{18060002,40},{18060003,80},{18053401,450}]',3),(60403401,28,'0',990,'[{18060001,20},{18060002,40},{18060003,80},{18053401,450}]',3),(60403401,29,'0',1030,'[{18060001,20},{18060002,40},{18060003,80},{18053401,450}]',3),(60403401,30,'0',0,'[{18060001,20},{18060002,40},{18060003,80},{18053401,450}]',3),(60403501,1,'18053501',40,'[{18060001,20},{18060002,40},{18060003,80},{18053501,450}]',3),(60403501,2,'0',70,'[{18060001,20},{18060002,40},{18060003,80},{18053501,450}]',3),(60403501,3,'0',100,'[{18060001,20},{18060002,40},{18060003,80},{18053501,450}]',3),(60403501,4,'0',130,'[{18060001,20},{18060002,40},{18060003,80},{18053501,450}]',3),(60403501,5,'0',160,'[{18060001,20},{18060002,40},{18060003,80},{18053501,450}]',3),(60403501,6,'0',190,'[{18060001,20},{18060002,40},{18060003,80},{18053501,450}]',3),(60403501,7,'0',220,'[{18060001,20},{18060002,40},{18060003,80},{18053501,450}]',3),(60403501,8,'0',250,'[{18060001,20},{18060002,40},{18060003,80},{18053501,450}]',3),(60403501,9,'0',280,'[{18060001,20},{18060002,40},{18060003,80},{18053501,450}]',3),(60403501,10,'0',310,'[{18060001,20},{18060002,40},{18060003,80},{18053501,450}]',3),(60403501,11,'0',340,'[{18060001,20},{18060002,40},{18060003,80},{18053501,450}]',3),(60403501,12,'0',370,'[{18060001,20},{18060002,40},{18060003,80},{18053501,450}]',3),(60403501,13,'0',400,'[{18060001,20},{18060002,40},{18060003,80},{18053501,450}]',3),(60403501,14,'0',430,'[{18060001,20},{18060002,40},{18060003,80},{18053501,450}]',3),(60403501,15,'0',470,'[{18060001,20},{18060002,40},{18060003,80},{18053501,450}]',3),(60403501,16,'0',510,'[{18060001,20},{18060002,40},{18060003,80},{18053501,450}]',3),(60403501,17,'0',550,'[{18060001,20},{18060002,40},{18060003,80},{18053501,450}]',3),(60403501,18,'0',590,'[{18060001,20},{18060002,40},{18060003,80},{18053501,450}]',3),(60403501,19,'0',630,'[{18060001,20},{18060002,40},{18060003,80},{18053501,450}]',3),(60403501,20,'0',670,'[{18060001,20},{18060002,40},{18060003,80},{18053501,450}]',3),(60403501,21,'0',710,'[{18060001,20},{18060002,40},{18060003,80},{18053501,450}]',3),(60403501,22,'0',750,'[{18060001,20},{18060002,40},{18060003,80},{18053501,450}]',3),(60403501,23,'0',790,'[{18060001,20},{18060002,40},{18060003,80},{18053501,450}]',3),(60403501,24,'0',830,'[{18060001,20},{18060002,40},{18060003,80},{18053501,450}]',3),(60403501,25,'0',870,'[{18060001,20},{18060002,40},{18060003,80},{18053501,450}]',3),(60403501,26,'0',910,'[{18060001,20},{18060002,40},{18060003,80},{18053501,450}]',3),(60403501,27,'0',950,'[{18060001,20},{18060002,40},{18060003,80},{18053501,450}]',3),(60403501,28,'0',990,'[{18060001,20},{18060002,40},{18060003,80},{18053501,450}]',3),(60403501,29,'0',1030,'[{18060001,20},{18060002,40},{18060003,80},{18053501,450}]',3),(60403501,30,'0',0,'[{18060001,20},{18060002,40},{18060003,80},{18053501,450}]',3),(60403601,1,'18053601',30,'[{18060001,20},{18060002,40},{18060003,80},{18053601,200}]',2),(60403601,2,'0',50,'[{18060001,20},{18060002,40},{18060003,80},{18053601,200}]',2),(60403601,3,'0',70,'[{18060001,20},{18060002,40},{18060003,80},{18053601,200}]',2),(60403601,4,'0',90,'[{18060001,20},{18060002,40},{18060003,80},{18053601,200}]',2),(60403601,5,'0',110,'[{18060001,20},{18060002,40},{18060003,80},{18053601,200}]',2),(60403601,6,'0',130,'[{18060001,20},{18060002,40},{18060003,80},{18053601,200}]',2),(60403601,7,'0',150,'[{18060001,20},{18060002,40},{18060003,80},{18053601,200}]',2),(60403601,8,'0',170,'[{18060001,20},{18060002,40},{18060003,80},{18053601,200}]',2),(60403601,9,'0',190,'[{18060001,20},{18060002,40},{18060003,80},{18053601,200}]',2),(60403601,10,'0',210,'[{18060001,20},{18060002,40},{18060003,80},{18053601,200}]',2),(60403601,11,'0',230,'[{18060001,20},{18060002,40},{18060003,80},{18053601,200}]',2),(60403601,12,'0',250,'[{18060001,20},{18060002,40},{18060003,80},{18053601,200}]',2),(60403601,13,'0',275,'[{18060001,20},{18060002,40},{18060003,80},{18053601,200}]',2),(60403601,14,'0',300,'[{18060001,20},{18060002,40},{18060003,80},{18053601,200}]',2),(60403601,15,'0',325,'[{18060001,20},{18060002,40},{18060003,80},{18053601,200}]',2),(60403601,16,'0',350,'[{18060001,20},{18060002,40},{18060003,80},{18053601,200}]',2),(60403601,17,'0',375,'[{18060001,20},{18060002,40},{18060003,80},{18053601,200}]',2),(60403601,18,'0',400,'[{18060001,20},{18060002,40},{18060003,80},{18053601,200}]',2),(60403601,19,'0',425,'[{18060001,20},{18060002,40},{18060003,80},{18053601,200}]',2),(60403601,20,'0',450,'[{18060001,20},{18060002,40},{18060003,80},{18053601,200}]',2),(60403601,21,'0',475,'[{18060001,20},{18060002,40},{18060003,80},{18053601,200}]',2),(60403601,22,'0',500,'[{18060001,20},{18060002,40},{18060003,80},{18053601,200}]',2),(60403601,23,'0',525,'[{18060001,20},{18060002,40},{18060003,80},{18053601,200}]',2),(60403601,24,'0',550,'[{18060001,20},{18060002,40},{18060003,80},{18053601,200}]',2),(60403601,25,'0',0,'[{18060001,20},{18060002,40},{18060003,80},{18053601,200}]',2),(60403701,1,'18053701',30,'[{18060001,20},{18060002,40},{18060003,80},{18053701,200}]',2),(60403701,2,'0',50,'[{18060001,20},{18060002,40},{18060003,80},{18053701,200}]',2),(60403701,3,'0',70,'[{18060001,20},{18060002,40},{18060003,80},{18053701,200}]',2),(60403701,4,'0',90,'[{18060001,20},{18060002,40},{18060003,80},{18053701,200}]',2),(60403701,5,'0',110,'[{18060001,20},{18060002,40},{18060003,80},{18053701,200}]',2),(60403701,6,'0',130,'[{18060001,20},{18060002,40},{18060003,80},{18053701,200}]',2),(60403701,7,'0',150,'[{18060001,20},{18060002,40},{18060003,80},{18053701,200}]',2),(60403701,8,'0',170,'[{18060001,20},{18060002,40},{18060003,80},{18053701,200}]',2),(60403701,9,'0',190,'[{18060001,20},{18060002,40},{18060003,80},{18053701,200}]',2),(60403701,10,'0',210,'[{18060001,20},{18060002,40},{18060003,80},{18053701,200}]',2),(60403701,11,'0',230,'[{18060001,20},{18060002,40},{18060003,80},{18053701,200}]',2),(60403701,12,'0',250,'[{18060001,20},{18060002,40},{18060003,80},{18053701,200}]',2),(60403701,13,'0',275,'[{18060001,20},{18060002,40},{18060003,80},{18053701,200}]',2),(60403701,14,'0',300,'[{18060001,20},{18060002,40},{18060003,80},{18053701,200}]',2),(60403701,15,'0',325,'[{18060001,20},{18060002,40},{18060003,80},{18053701,200}]',2),(60403701,16,'0',350,'[{18060001,20},{18060002,40},{18060003,80},{18053701,200}]',2),(60403701,17,'0',375,'[{18060001,20},{18060002,40},{18060003,80},{18053701,200}]',2),(60403701,18,'0',400,'[{18060001,20},{18060002,40},{18060003,80},{18053701,200}]',2),(60403701,19,'0',425,'[{18060001,20},{18060002,40},{18060003,80},{18053701,200}]',2),(60403701,20,'0',450,'[{18060001,20},{18060002,40},{18060003,80},{18053701,200}]',2),(60403701,21,'0',475,'[{18060001,20},{18060002,40},{18060003,80},{18053701,200}]',2),(60403701,22,'0',500,'[{18060001,20},{18060002,40},{18060003,80},{18053701,200}]',2),(60403701,23,'0',525,'[{18060001,20},{18060002,40},{18060003,80},{18053701,200}]',2),(60403701,24,'0',550,'[{18060001,20},{18060002,40},{18060003,80},{18053701,200}]',2),(60403701,25,'0',0,'[{18060001,20},{18060002,40},{18060003,80},{18053701,200}]',2),(60403801,1,'18053801',30,'[{18060001,20},{18060002,40},{18060003,80},{18053801,200}]',2),(60403801,2,'0',50,'[{18060001,20},{18060002,40},{18060003,80},{18053801,200}]',2),(60403801,3,'0',70,'[{18060001,20},{18060002,40},{18060003,80},{18053801,200}]',2),(60403801,4,'0',90,'[{18060001,20},{18060002,40},{18060003,80},{18053801,200}]',2),(60403801,5,'0',110,'[{18060001,20},{18060002,40},{18060003,80},{18053801,200}]',2),(60403801,6,'0',130,'[{18060001,20},{18060002,40},{18060003,80},{18053801,200}]',2),(60403801,7,'0',150,'[{18060001,20},{18060002,40},{18060003,80},{18053801,200}]',2),(60403801,8,'0',170,'[{18060001,20},{18060002,40},{18060003,80},{18053801,200}]',2),(60403801,9,'0',190,'[{18060001,20},{18060002,40},{18060003,80},{18053801,200}]',2),(60403801,10,'0',210,'[{18060001,20},{18060002,40},{18060003,80},{18053801,200}]',2),(60403801,11,'0',230,'[{18060001,20},{18060002,40},{18060003,80},{18053801,200}]',2),(60403801,12,'0',250,'[{18060001,20},{18060002,40},{18060003,80},{18053801,200}]',2),(60403801,13,'0',275,'[{18060001,20},{18060002,40},{18060003,80},{18053801,200}]',2),(60403801,14,'0',300,'[{18060001,20},{18060002,40},{18060003,80},{18053801,200}]',2),(60403801,15,'0',325,'[{18060001,20},{18060002,40},{18060003,80},{18053801,200}]',2),(60403801,16,'0',350,'[{18060001,20},{18060002,40},{18060003,80},{18053801,200}]',2),(60403801,17,'0',375,'[{18060001,20},{18060002,40},{18060003,80},{18053801,200}]',2),(60403801,18,'0',400,'[{18060001,20},{18060002,40},{18060003,80},{18053801,200}]',2),(60403801,19,'0',425,'[{18060001,20},{18060002,40},{18060003,80},{18053801,200}]',2),(60403801,20,'0',450,'[{18060001,20},{18060002,40},{18060003,80},{18053801,200}]',2),(60403801,21,'0',475,'[{18060001,20},{18060002,40},{18060003,80},{18053801,200}]',2),(60403801,22,'0',500,'[{18060001,20},{18060002,40},{18060003,80},{18053801,200}]',2),(60403801,23,'0',525,'[{18060001,20},{18060002,40},{18060003,80},{18053801,200}]',2),(60403801,24,'0',550,'[{18060001,20},{18060002,40},{18060003,80},{18053801,200}]',2),(60403801,25,'0',0,'[{18060001,20},{18060002,40},{18060003,80},{18053801,200}]',2),(60403901,1,'18053901',30,'[{18060001,20},{18060002,40},{18060003,80},{18053901,200}]',2),(60403901,2,'0',50,'[{18060001,20},{18060002,40},{18060003,80},{18053901,200}]',2),(60403901,3,'0',70,'[{18060001,20},{18060002,40},{18060003,80},{18053901,200}]',2),(60403901,4,'0',90,'[{18060001,20},{18060002,40},{18060003,80},{18053901,200}]',2),(60403901,5,'0',110,'[{18060001,20},{18060002,40},{18060003,80},{18053901,200}]',2),(60403901,6,'0',130,'[{18060001,20},{18060002,40},{18060003,80},{18053901,200}]',2),(60403901,7,'0',150,'[{18060001,20},{18060002,40},{18060003,80},{18053901,200}]',2),(60403901,8,'0',170,'[{18060001,20},{18060002,40},{18060003,80},{18053901,200}]',2),(60403901,9,'0',190,'[{18060001,20},{18060002,40},{18060003,80},{18053901,200}]',2),(60403901,10,'0',210,'[{18060001,20},{18060002,40},{18060003,80},{18053901,200}]',2),(60403901,11,'0',230,'[{18060001,20},{18060002,40},{18060003,80},{18053901,200}]',2),(60403901,12,'0',250,'[{18060001,20},{18060002,40},{18060003,80},{18053901,200}]',2),(60403901,13,'0',275,'[{18060001,20},{18060002,40},{18060003,80},{18053901,200}]',2),(60403901,14,'0',300,'[{18060001,20},{18060002,40},{18060003,80},{18053901,200}]',2),(60403901,15,'0',325,'[{18060001,20},{18060002,40},{18060003,80},{18053901,200}]',2),(60403901,16,'0',350,'[{18060001,20},{18060002,40},{18060003,80},{18053901,200}]',2),(60403901,17,'0',375,'[{18060001,20},{18060002,40},{18060003,80},{18053901,200}]',2),(60403901,18,'0',400,'[{18060001,20},{18060002,40},{18060003,80},{18053901,200}]',2),(60403901,19,'0',425,'[{18060001,20},{18060002,40},{18060003,80},{18053901,200}]',2),(60403901,20,'0',450,'[{18060001,20},{18060002,40},{18060003,80},{18053901,200}]',2),(60403901,21,'0',475,'[{18060001,20},{18060002,40},{18060003,80},{18053901,200}]',2),(60403901,22,'0',500,'[{18060001,20},{18060002,40},{18060003,80},{18053901,200}]',2),(60403901,23,'0',525,'[{18060001,20},{18060002,40},{18060003,80},{18053901,200}]',2),(60403901,24,'0',550,'[{18060001,20},{18060002,40},{18060003,80},{18053901,200}]',2),(60403901,25,'0',0,'[{18060001,20},{18060002,40},{18060003,80},{18053901,200}]',2),(60404001,1,'18054001',30,'[{18060001,20},{18060002,40},{18060003,80},{18054001,200}]',2),(60404001,2,'0',50,'[{18060001,20},{18060002,40},{18060003,80},{18054001,200}]',2),(60404001,3,'0',70,'[{18060001,20},{18060002,40},{18060003,80},{18054001,200}]',2),(60404001,4,'0',90,'[{18060001,20},{18060002,40},{18060003,80},{18054001,200}]',2),(60404001,5,'0',110,'[{18060001,20},{18060002,40},{18060003,80},{18054001,200}]',2),(60404001,6,'0',130,'[{18060001,20},{18060002,40},{18060003,80},{18054001,200}]',2),(60404001,7,'0',150,'[{18060001,20},{18060002,40},{18060003,80},{18054001,200}]',2),(60404001,8,'0',170,'[{18060001,20},{18060002,40},{18060003,80},{18054001,200}]',2),(60404001,9,'0',190,'[{18060001,20},{18060002,40},{18060003,80},{18054001,200}]',2),(60404001,10,'0',210,'[{18060001,20},{18060002,40},{18060003,80},{18054001,200}]',2),(60404001,11,'0',230,'[{18060001,20},{18060002,40},{18060003,80},{18054001,200}]',2),(60404001,12,'0',250,'[{18060001,20},{18060002,40},{18060003,80},{18054001,200}]',2),(60404001,13,'0',275,'[{18060001,20},{18060002,40},{18060003,80},{18054001,200}]',2),(60404001,14,'0',300,'[{18060001,20},{18060002,40},{18060003,80},{18054001,200}]',2),(60404001,15,'0',325,'[{18060001,20},{18060002,40},{18060003,80},{18054001,200}]',2),(60404001,16,'0',350,'[{18060001,20},{18060002,40},{18060003,80},{18054001,200}]',2),(60404001,17,'0',375,'[{18060001,20},{18060002,40},{18060003,80},{18054001,200}]',2),(60404001,18,'0',400,'[{18060001,20},{18060002,40},{18060003,80},{18054001,200}]',2),(60404001,19,'0',425,'[{18060001,20},{18060002,40},{18060003,80},{18054001,200}]',2),(60404001,20,'0',450,'[{18060001,20},{18060002,40},{18060003,80},{18054001,200}]',2),(60404001,21,'0',475,'[{18060001,20},{18060002,40},{18060003,80},{18054001,200}]',2),(60404001,22,'0',500,'[{18060001,20},{18060002,40},{18060003,80},{18054001,200}]',2),(60404001,23,'0',525,'[{18060001,20},{18060002,40},{18060003,80},{18054001,200}]',2),(60404001,24,'0',550,'[{18060001,20},{18060002,40},{18060003,80},{18054001,200}]',2),(60404001,25,'0',0,'[{18060001,20},{18060002,40},{18060003,80},{18054001,200}]',2),(60404101,1,'18054101',30,'[{18060001,20},{18060002,40},{18060003,80},{18054101,200}]',2),(60404101,2,'0',50,'[{18060001,20},{18060002,40},{18060003,80},{18054101,200}]',2),(60404101,3,'0',70,'[{18060001,20},{18060002,40},{18060003,80},{18054101,200}]',2),(60404101,4,'0',90,'[{18060001,20},{18060002,40},{18060003,80},{18054101,200}]',2),(60404101,5,'0',110,'[{18060001,20},{18060002,40},{18060003,80},{18054101,200}]',2),(60404101,6,'0',130,'[{18060001,20},{18060002,40},{18060003,80},{18054101,200}]',2),(60404101,7,'0',150,'[{18060001,20},{18060002,40},{18060003,80},{18054101,200}]',2),(60404101,8,'0',170,'[{18060001,20},{18060002,40},{18060003,80},{18054101,200}]',2),(60404101,9,'0',190,'[{18060001,20},{18060002,40},{18060003,80},{18054101,200}]',2),(60404101,10,'0',210,'[{18060001,20},{18060002,40},{18060003,80},{18054101,200}]',2),(60404101,11,'0',230,'[{18060001,20},{18060002,40},{18060003,80},{18054101,200}]',2),(60404101,12,'0',250,'[{18060001,20},{18060002,40},{18060003,80},{18054101,200}]',2),(60404101,13,'0',275,'[{18060001,20},{18060002,40},{18060003,80},{18054101,200}]',2),(60404101,14,'0',300,'[{18060001,20},{18060002,40},{18060003,80},{18054101,200}]',2),(60404101,15,'0',325,'[{18060001,20},{18060002,40},{18060003,80},{18054101,200}]',2),(60404101,16,'0',350,'[{18060001,20},{18060002,40},{18060003,80},{18054101,200}]',2),(60404101,17,'0',375,'[{18060001,20},{18060002,40},{18060003,80},{18054101,200}]',2),(60404101,18,'0',400,'[{18060001,20},{18060002,40},{18060003,80},{18054101,200}]',2),(60404101,19,'0',425,'[{18060001,20},{18060002,40},{18060003,80},{18054101,200}]',2),(60404101,20,'0',450,'[{18060001,20},{18060002,40},{18060003,80},{18054101,200}]',2),(60404101,21,'0',475,'[{18060001,20},{18060002,40},{18060003,80},{18054101,200}]',2),(60404101,22,'0',500,'[{18060001,20},{18060002,40},{18060003,80},{18054101,200}]',2),(60404101,23,'0',525,'[{18060001,20},{18060002,40},{18060003,80},{18054101,200}]',2),(60404101,24,'0',550,'[{18060001,20},{18060002,40},{18060003,80},{18054101,200}]',2),(60404101,25,'0',0,'[{18060001,20},{18060002,40},{18060003,80},{18054101,200}]',2),(60404201,1,'18054201',30,'[{18060001,20},{18060002,40},{18060003,80},{18054201,200}]',2),(60404201,2,'0',50,'[{18060001,20},{18060002,40},{18060003,80},{18054201,200}]',2),(60404201,3,'0',70,'[{18060001,20},{18060002,40},{18060003,80},{18054201,200}]',2),(60404201,4,'0',90,'[{18060001,20},{18060002,40},{18060003,80},{18054201,200}]',2),(60404201,5,'0',110,'[{18060001,20},{18060002,40},{18060003,80},{18054201,200}]',2),(60404201,6,'0',130,'[{18060001,20},{18060002,40},{18060003,80},{18054201,200}]',2),(60404201,7,'0',150,'[{18060001,20},{18060002,40},{18060003,80},{18054201,200}]',2),(60404201,8,'0',170,'[{18060001,20},{18060002,40},{18060003,80},{18054201,200}]',2),(60404201,9,'0',190,'[{18060001,20},{18060002,40},{18060003,80},{18054201,200}]',2),(60404201,10,'0',210,'[{18060001,20},{18060002,40},{18060003,80},{18054201,200}]',2),(60404201,11,'0',230,'[{18060001,20},{18060002,40},{18060003,80},{18054201,200}]',2),(60404201,12,'0',250,'[{18060001,20},{18060002,40},{18060003,80},{18054201,200}]',2),(60404201,13,'0',275,'[{18060001,20},{18060002,40},{18060003,80},{18054201,200}]',2),(60404201,14,'0',300,'[{18060001,20},{18060002,40},{18060003,80},{18054201,200}]',2),(60404201,15,'0',325,'[{18060001,20},{18060002,40},{18060003,80},{18054201,200}]',2),(60404201,16,'0',350,'[{18060001,20},{18060002,40},{18060003,80},{18054201,200}]',2),(60404201,17,'0',375,'[{18060001,20},{18060002,40},{18060003,80},{18054201,200}]',2),(60404201,18,'0',400,'[{18060001,20},{18060002,40},{18060003,80},{18054201,200}]',2),(60404201,19,'0',425,'[{18060001,20},{18060002,40},{18060003,80},{18054201,200}]',2),(60404201,20,'0',450,'[{18060001,20},{18060002,40},{18060003,80},{18054201,200}]',2),(60404201,21,'0',475,'[{18060001,20},{18060002,40},{18060003,80},{18054201,200}]',2),(60404201,22,'0',500,'[{18060001,20},{18060002,40},{18060003,80},{18054201,200}]',2),(60404201,23,'0',525,'[{18060001,20},{18060002,40},{18060003,80},{18054201,200}]',2),(60404201,24,'0',550,'[{18060001,20},{18060002,40},{18060003,80},{18054201,200}]',2),(60404201,25,'0',0,'[{18060001,20},{18060002,40},{18060003,80},{18054201,200}]',2),(60404301,1,'18054301',100,'[{18054301,100}]',3),(60404301,2,'0',100,'[{18054301,100}]',3),(60404301,3,'0',100,'[{18054301,100}]',3),(60404301,4,'0',200,'[{18054301,100}]',3),(60404301,5,'0',200,'[{18054301,100}]',3),(60404301,6,'0',200,'[{18054301,100}]',3),(60404301,7,'0',300,'[{18054301,100}]',3),(60404301,8,'0',300,'[{18054301,100}]',3),(60404301,9,'0',300,'[{18054301,100}]',3),(60404301,10,'0',0,'[{18054301,100}]',3),(60404401,1,'18054401',100,'[{18054401,100}]',3),(60404401,2,'0',100,'[{18054401,100}]',3),(60404401,3,'0',100,'[{18054401,100}]',3),(60404401,4,'0',200,'[{18054401,100}]',3),(60404401,5,'0',200,'[{18054401,100}]',3),(60404401,6,'0',200,'[{18054401,100}]',3),(60404401,7,'0',300,'[{18054401,100}]',3),(60404401,8,'0',300,'[{18054401,100}]',3),(60404401,9,'0',300,'[{18054401,100}]',3),(60404401,10,'0',0,'[{18054401,100}]',3),(60404501,1,'18054501',100,'[{18054501,100}]',3),(60404501,2,'0',100,'[{18054501,100}]',3),(60404501,3,'0',100,'[{18054501,100}]',3),(60404501,4,'0',200,'[{18054501,100}]',3),(60404501,5,'0',200,'[{18054501,100}]',3),(60404501,6,'0',200,'[{18054501,100}]',3),(60404501,7,'0',300,'[{18054501,100}]',3),(60404501,8,'0',300,'[{18054501,100}]',3),(60404501,9,'0',300,'[{18054501,100}]',3),(60404501,10,'0',0,'[{18054501,100}]',3),(60404601,1,'18054601',100,'[{18054601,100}]',3),(60404601,2,'0',100,'[{18054601,100}]',3),(60404601,3,'0',100,'[{18054601,100}]',3),(60404601,4,'0',200,'[{18054601,100}]',3),(60404601,5,'0',200,'[{18054601,100}]',3),(60404601,6,'0',200,'[{18054601,100}]',3),(60404601,7,'0',300,'[{18054601,100}]',3),(60404601,8,'0',300,'[{18054601,100}]',3),(60404601,9,'0',300,'[{18054601,100}]',3),(60404601,10,'0',0,'[{18054601,100}]',3),(60404701,1,'18054701',20,'[{18060001,20},{18060002,40},{18060003,80},{18054701,100}]',1),(60404701,2,'0',35,'[{18060001,20},{18060002,40},{18060003,80},{18054701,100}]',1),(60404701,3,'0',50,'[{18060001,20},{18060002,40},{18060003,80},{18054701,100}]',1),(60404701,4,'0',65,'[{18060001,20},{18060002,40},{18060003,80},{18054701,100}]',1),(60404701,5,'0',80,'[{18060001,20},{18060002,40},{18060003,80},{18054701,100}]',1),(60404701,6,'0',95,'[{18060001,20},{18060002,40},{18060003,80},{18054701,100}]',1),(60404701,7,'0',110,'[{18060001,20},{18060002,40},{18060003,80},{18054701,100}]',1),(60404701,8,'0',125,'[{18060001,20},{18060002,40},{18060003,80},{18054701,100}]',1),(60404701,9,'0',140,'[{18060001,20},{18060002,40},{18060003,80},{18054701,100}]',1),(60404701,10,'0',160,'[{18060001,20},{18060002,40},{18060003,80},{18054701,100}]',1),(60404701,11,'0',180,'[{18060001,20},{18060002,40},{18060003,80},{18054701,100}]',1),(60404701,12,'0',200,'[{18060001,20},{18060002,40},{18060003,80},{18054701,100}]',1),(60404701,13,'0',220,'[{18060001,20},{18060002,40},{18060003,80},{18054701,100}]',1),(60404701,14,'0',240,'[{18060001,20},{18060002,40},{18060003,80},{18054701,100}]',1),(60404701,15,'0',260,'[{18060001,20},{18060002,40},{18060003,80},{18054701,100}]',1),(60404701,16,'0',280,'[{18060001,20},{18060002,40},{18060003,80},{18054701,100}]',1),(60404701,17,'0',300,'[{18060001,20},{18060002,40},{18060003,80},{18054701,100}]',1),(60404701,18,'0',320,'[{18060001,20},{18060002,40},{18060003,80},{18054701,100}]',1),(60404701,19,'0',340,'[{18060001,20},{18060002,40},{18060003,80},{18054701,100}]',1),(60404701,20,'0',0,'[{18060001,20},{18060002,40},{18060003,80},{18054701,100}]',1),(60404801,1,'18054801',30,'[{18060001,20},{18060002,40},{18060003,80},{18054801,200}]',2),(60404801,2,'0',50,'[{18060001,20},{18060002,40},{18060003,80},{18054801,200}]',2),(60404801,3,'0',70,'[{18060001,20},{18060002,40},{18060003,80},{18054801,200}]',2),(60404801,4,'0',90,'[{18060001,20},{18060002,40},{18060003,80},{18054801,200}]',2),(60404801,5,'0',110,'[{18060001,20},{18060002,40},{18060003,80},{18054801,200}]',2),(60404801,6,'0',130,'[{18060001,20},{18060002,40},{18060003,80},{18054801,200}]',2),(60404801,7,'0',150,'[{18060001,20},{18060002,40},{18060003,80},{18054801,200}]',2),(60404801,8,'0',170,'[{18060001,20},{18060002,40},{18060003,80},{18054801,200}]',2),(60404801,9,'0',190,'[{18060001,20},{18060002,40},{18060003,80},{18054801,200}]',2),(60404801,10,'0',210,'[{18060001,20},{18060002,40},{18060003,80},{18054801,200}]',2),(60404801,11,'0',230,'[{18060001,20},{18060002,40},{18060003,80},{18054801,200}]',2),(60404801,12,'0',250,'[{18060001,20},{18060002,40},{18060003,80},{18054801,200}]',2),(60404801,13,'0',275,'[{18060001,20},{18060002,40},{18060003,80},{18054801,200}]',2),(60404801,14,'0',300,'[{18060001,20},{18060002,40},{18060003,80},{18054801,200}]',2),(60404801,15,'0',325,'[{18060001,20},{18060002,40},{18060003,80},{18054801,200}]',2),(60404801,16,'0',350,'[{18060001,20},{18060002,40},{18060003,80},{18054801,200}]',2),(60404801,17,'0',375,'[{18060001,20},{18060002,40},{18060003,80},{18054801,200}]',2),(60404801,18,'0',400,'[{18060001,20},{18060002,40},{18060003,80},{18054801,200}]',2),(60404801,19,'0',425,'[{18060001,20},{18060002,40},{18060003,80},{18054801,200}]',2),(60404801,20,'0',450,'[{18060001,20},{18060002,40},{18060003,80},{18054801,200}]',2),(60404801,21,'0',475,'[{18060001,20},{18060002,40},{18060003,80},{18054801,200}]',2),(60404801,22,'0',500,'[{18060001,20},{18060002,40},{18060003,80},{18054801,200}]',2),(60404801,23,'0',525,'[{18060001,20},{18060002,40},{18060003,80},{18054801,200}]',2),(60404801,24,'0',550,'[{18060001,20},{18060002,40},{18060003,80},{18054801,200}]',2),(60404801,25,'0',0,'[{18060001,20},{18060002,40},{18060003,80},{18054801,200}]',2);
/*!40000 ALTER TABLE `base_star_soul_skill_cfg` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_star_soul_skill_location_cfg`
--

DROP TABLE IF EXISTS `base_star_soul_skill_location_cfg`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_star_soul_skill_location_cfg` (
  `skill_loc` tinyint(3) unsigned NOT NULL COMMENT '技能槽位',
  `need_star` tinyint(3) unsigned NOT NULL COMMENT '开启所需星数',
  PRIMARY KEY (`skill_loc`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星灵技能槽位配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_star_soul_skill_location_cfg`
--

LOCK TABLES `base_star_soul_skill_location_cfg` WRITE;
/*!40000 ALTER TABLE `base_star_soul_skill_location_cfg` DISABLE KEYS */;
INSERT INTO `base_star_soul_skill_location_cfg` VALUES (1,0),(2,0),(3,1),(4,2),(5,3),(6,4);
/*!40000 ALTER TABLE `base_star_soul_skill_location_cfg` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_star_soul_stage`
--

DROP TABLE IF EXISTS `base_star_soul_stage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_star_soul_stage` (
  `star_soul_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '星灵id',
  `stage` tinyint(2) unsigned NOT NULL COMMENT '阶数',
  `sub_stage` tinyint(2) unsigned NOT NULL COMMENT '星阶',
  `max_exp` int(11) unsigned NOT NULL COMMENT '经验上限',
  `attr` varchar(255) NOT NULL COMMENT '提供属性',
  `combat` int(11) unsigned NOT NULL COMMENT '提供战力',
  `goods_exp` varchar(255) NOT NULL COMMENT '道具提供经验',
  `every_attr` varchar(255) NOT NULL COMMENT '每次增加的属性',
  `every_combat` int(11) unsigned NOT NULL COMMENT '每次增加的战力',
  PRIMARY KEY (`star_soul_id`,`stage`,`sub_stage`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星灵进阶配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_star_soul_stage`
--

LOCK TABLES `base_star_soul_stage` WRITE;
/*!40000 ALTER TABLE `base_star_soul_stage` DISABLE KEYS */;
INSERT INTO `base_star_soul_stage` VALUES (1001,1,0,40,'[{1,48},{2,968},{3,24},{4,24},{5,12},{6,12},{7,12},{8,12}]',5528,'[{18020001,10}]','[{2,20}]',20),(1001,1,1,40,'[{1,54},{2,1089},{3,27},{4,27},{5,14},{6,14},{7,14},{8,14}]',6319,'[{18020001,10}]','[{1,1}]',20),(1001,1,2,40,'[{1,60},{2,1212},{3,30},{4,30},{5,16},{6,16},{7,16},{8,16}]',7112,'[{18020001,10}]','[{2,22}]',22),(1001,1,3,40,'[{1,66},{2,1338},{3,33},{4,33},{5,18},{6,18},{7,18},{8,18}]',7908,'[{18020001,10}]','[{1,1}]',20),(1001,2,0,60,'[{1,73},{2,1488},{3,37},{4,37},{5,20},{6,20},{7,20},{8,20}]',8798,'[{18020001,10}]','[{2,24}]',24),(1001,2,1,60,'[{1,81},{2,1643},{3,41},{4,41},{5,22},{6,22},{7,22},{8,22}]',9713,'[{18020001,10}]','[{1,1}]',20),(1001,2,2,60,'[{1,89},{2,1803},{3,45},{4,45},{5,24},{6,24},{7,24},{8,24}]',10633,'[{18020001,10}]','[{2,27}]',27),(1001,2,3,60,'[{1,97},{2,1968},{3,49},{4,49},{5,26},{6,26},{7,26},{8,26}]',11558,'[{18020001,10}]','[{1,2}]',40),(1001,3,0,90,'[{1,107},{2,2162},{3,54},{4,54},{5,28},{6,28},{7,28},{8,28}]',12602,'[{18020001,10}]','[{2,31}]',31),(1001,3,1,90,'[{1,117},{2,2363},{3,59},{4,59},{5,31},{6,31},{7,31},{8,31}]',13853,'[{18020001,10}]','[{1,2}]',40),(1001,3,2,90,'[{1,127},{2,2571},{3,64},{4,64},{5,34},{6,34},{7,34},{8,34}]',15111,'[{18020001,10}]','[{2,32}]',32),(1001,3,3,90,'[{1,138},{2,2786},{3,69},{4,69},{5,37},{6,37},{7,37},{8,37}]',16396,'[{18020001,10}]','[{1,2}]',40),(1001,4,0,120,'[{1,150},{2,3035},{3,75},{4,75},{5,40},{6,40},{7,40},{8,40}]',17785,'[{18020001,10}]','[{2,37}]',37),(1001,4,1,120,'[{1,163},{2,3294},{3,81},{4,81},{5,43},{6,43},{7,43},{8,43}]',19204,'[{18020001,10}]','[{1,2}]',40),(1001,4,2,120,'[{1,176},{2,3563},{3,88},{4,88},{5,46},{6,46},{7,46},{8,46}]',20683,'[{18020001,10}]','[{2,39}]',39),(1001,4,3,120,'[{1,190},{2,3841},{3,95},{4,95},{5,49},{6,49},{7,49},{8,49}]',22191,'[{18020001,10}]','[{1,2}]',40),(1001,5,0,160,'[{1,206},{2,4158},{3,103},{4,103},{5,53},{6,53},{7,53},{8,53}]',24028,'[{18020001,10}]','[{2,43}]',43),(1001,5,1,160,'[{1,222},{2,4487},{3,111},{4,111},{5,57},{6,57},{7,57},{8,57}]',25877,'[{18020001,10}]','[{1,2}]',40),(1001,5,2,160,'[{1,239},{2,4828},{3,120},{4,120},{5,61},{6,61},{7,61},{8,61}]',27808,'[{18020001,10}]','[{2,45}]',45),(1001,5,3,160,'[{1,257},{2,5181},{3,129},{4,129},{5,65},{6,65},{7,65},{8,65}]',29771,'[{18020001,10}]','[{1,2}]',40),(1001,6,0,210,'[{1,277},{2,5578},{3,139},{4,139},{5,70},{6,70},{7,70},{8,70}]',32068,'[{18020001,10}]','[{2,50}]',50),(1001,6,1,210,'[{1,298},{2,5989},{3,149},{4,149},{5,75},{6,75},{7,75},{8,75}]',34399,'[{18020001,10}]','[{1,3}]',60),(1001,6,2,210,'[{1,319},{2,6415},{3,160},{4,160},{5,80},{6,80},{7,80},{8,80}]',36795,'[{18020001,10}]','[{2,53}]',53),(1001,6,3,210,'[{1,341},{2,6855},{3,171},{4,171},{5,86},{6,86},{7,86},{8,86}]',39425,'[{18020001,10}]','[{1,3}]',60),(1001,7,0,290,'[{1,365},{2,7344},{3,183},{4,183},{5,92},{6,92},{7,92},{8,92}]',42194,'[{18020001,10}]','[{2,59}]',59),(1001,7,1,290,'[{1,390},{2,7850},{3,196},{4,196},{5,98},{6,98},{7,98},{8,98}]',45050,'[{18020001,10}]','[{1,3}]',60),(1001,7,2,290,'[{1,416},{2,8373},{3,209},{4,209},{5,105},{6,105},{7,105},{8,105}]',48143,'[{18020001,10}]','[{2,60}]',60),(1001,7,3,290,'[{1,443},{2,8912},{3,222},{4,222},{5,112},{6,112},{7,112},{8,112}]',51272,'[{18020001,10}]','[{1,3}]',60),(1001,8,0,390,'[{1,473},{2,9505},{3,237},{4,237},{5,119},{6,119},{7,119},{8,119}]',54615,'[{18020001,10}]','[{2,66}]',66),(1001,8,1,390,'[{1,503},{2,10115},{3,252},{4,252},{5,127},{6,127},{7,127},{8,127}]',58175,'[{18020001,10}]','[{1,3}]',60),(1001,8,2,390,'[{1,534},{2,10742},{3,268},{4,268},{5,135},{6,135},{7,135},{8,135}]',61822,'[{18020001,10}]','[{2,69}]',69),(1001,8,3,390,'[{1,566},{2,11386},{3,284},{4,284},{5,143},{6,143},{7,143},{8,143}]',65506,'[{18020001,10}]','[{1,4}]',80),(1001,9,0,510,'[{1,601},{2,12088},{3,302},{4,302},{5,152},{6,152},{7,152},{8,152}]',69608,'[{18020001,10}]','[{2,75}]',75),(1001,9,1,510,'[{1,637},{2,12809},{3,320},{4,320},{5,161},{6,161},{7,161},{8,161}]',73749,'[{18020001,10}]','[{1,4}]',80),(1001,9,2,510,'[{1,674},{2,13549},{3,339},{4,339},{5,170},{6,170},{7,170},{8,170}]',77979,'[{18020001,10}]','[{2,78}]',78),(1001,9,3,510,'[{1,712},{2,14309},{3,358},{4,358},{5,179},{6,179},{7,179},{8,179}]',82249,'[{18020001,10}]','[{1,4}]',80),(1001,10,0,650,'[{1,753},{2,15132},{3,379},{4,379},{5,189},{6,189},{7,189},{8,189}]',86942,'[{18020001,10}]','[{2,84}]',84),(1001,10,1,650,'[{1,795},{2,15974},{3,400},{4,400},{5,200},{6,200},{7,200},{8,200}]',91874,'[{18020001,10}]','[{1,4}]',80),(1001,10,2,650,'[{1,838},{2,16835},{3,422},{4,422},{5,211},{6,211},{7,211},{8,211}]',96895,'[{18020001,10}]','[{2,88}]',88),(1001,10,3,650,'[{1,882},{2,17716},{3,444},{4,444},{5,222},{6,222},{7,222},{8,222}]',101956,'[{18020001,10}]','[{1,5}]',100),(1001,11,0,810,'[{1,929},{2,18664},{3,468},{4,468},{5,234},{6,234},{7,234},{8,234}]',107444,'[{18020002,30}]','[{2,96}]',96),(1001,11,1,810,'[{1,978},{2,19634},{3,492},{4,492},{5,246},{6,246},{7,246},{8,246}]',112994,'[{18020002,30}]','[{1,5}]',100),(1001,11,2,810,'[{1,1028},{2,20626},{3,517},{4,517},{5,258},{6,258},{7,258},{8,258}]',118636,'[{18020002,30}]','[{2,98}]',98),(1001,11,3,810,'[{1,1079},{2,21640},{3,542},{4,542},{5,271},{6,271},{7,271},{8,271}]',124520,'[{18020002,30}]','[{1,5}]',100),(1001,12,0,970,'[{1,1133},{2,22726},{3,569},{4,569},{5,285},{6,285},{7,285},{8,285}]',130836,'[{18020002,30}]','[{2,105}]',105),(1001,12,1,970,'[{1,1188},{2,23834},{3,597},{4,597},{5,299},{6,299},{7,299},{8,299}]',137244,'[{18020002,30}]','[{1,5}]',100),(1001,12,2,970,'[{1,1244},{2,24964},{3,625},{4,625},{5,313},{6,313},{7,313},{8,313}]',143694,'[{18020002,30}]','[{2,109}]',109),(1001,12,3,970,'[{1,1302},{2,26116},{3,654},{4,654},{5,327},{6,327},{7,327},{8,327}]',150256,'[{18020002,30}]','[{1,6}]',120),(1001,13,0,1150,'[{1,1363},{2,27345},{3,685},{4,685},{5,342},{6,342},{7,342},{8,342}]',157255,'[{18020002,30}]','[{2,116}]',116),(1001,13,1,1150,'[{1,1426},{2,28598},{3,716},{4,716},{5,358},{6,358},{7,358},{8,358}]',164518,'[{18020002,30}]','[{1,6}]',120),(1001,13,2,1150,'[{1,1490},{2,29875},{3,748},{4,748},{5,374},{6,374},{7,374},{8,374}]',171875,'[{18020002,30}]','[{2,119}]',119),(1001,13,3,1150,'[{1,1555},{2,31177},{3,781},{4,781},{5,390},{6,390},{7,390},{8,390}]',179327,'[{18020002,30}]','[{1,6}]',120),(1001,14,0,1330,'[{1,1624},{2,32561},{3,816},{4,816},{5,407},{6,407},{7,407},{8,407}]',187241,'[{18020002,30}]','[{2,129}]',129),(1001,14,1,1330,'[{1,1694},{2,33969},{3,851},{4,851},{5,425},{6,425},{7,425},{8,425}]',195399,'[{18020002,30}]','[{1,6}]',120),(1001,14,2,1330,'[{1,1766},{2,35401},{3,887},{4,887},{5,443},{6,443},{7,443},{8,443}]',203671,'[{18020002,30}]','[{2,132}]',132),(1001,14,3,1330,'[{1,1839},{2,36857},{3,923},{4,923},{5,461},{6,461},{7,461},{8,461}]',211987,'[{18020002,30}]','[{1,7}]',140),(1001,15,0,1540,'[{1,1916},{2,38400},{3,962},{4,962},{5,480},{6,480},{7,480},{8,480}]',220820,'[{18020002,30}]','[{2,140}]',140),(1001,15,1,1540,'[{1,1995},{2,39970},{3,1001},{4,1001},{5,500},{6,500},{7,500},{8,500}]',229920,'[{18020002,30}]','[{1,7}]',140),(1001,15,2,1540,'[{1,2075},{2,41567},{3,1041},{4,1041},{5,520},{6,520},{7,520},{8,520}]',239117,'[{18020002,30}]','[{2,143}]',143),(1001,15,3,1540,'[{1,2156},{2,43190},{3,1082},{4,1082},{5,540},{6,540},{7,540},{8,540}]',248410,'[{18020002,30}]','[{1,8}]',160),(1001,16,0,1750,'[{1,2242},{2,44905},{3,1125},{4,1125},{5,561},{6,561},{7,561},{8,561}]',258195,'[{18020002,30}]','[{2,152}]',152),(1001,16,1,1750,'[{1,2329},{2,46647},{3,1169},{4,1169},{5,583},{6,583},{7,583},{8,583}]',268277,'[{18020002,30}]','[{1,8}]',160),(1001,16,2,1750,'[{1,2417},{2,48415},{3,1213},{4,1213},{5,605},{6,605},{7,605},{8,605}]',278405,'[{18020002,30}]','[{2,156}]',156),(1001,16,3,1750,'[{1,2507},{2,50210},{3,1258},{4,1258},{5,627},{6,627},{7,627},{8,627}]',288650,'[{18020002,30}]','[{1,8}]',160),(1001,17,0,1990,'[{1,2602},{2,52102},{3,1305},{4,1305},{5,651},{6,651},{7,651},{8,651}]',299592,'[{18020002,30}]','[{2,166}]',166),(1001,17,1,1990,'[{1,2698},{2,54020},{3,1353},{4,1353},{5,675},{6,675},{7,675},{8,675}]',310630,'[{18020002,30}]','[{1,8}]',160),(1001,17,2,1990,'[{1,2795},{2,55965},{3,1402},{4,1402},{5,699},{6,699},{7,699},{8,699}]',321765,'[{18020002,30}]','[{2,170}]',170),(1001,17,3,1990,'[{1,2894},{2,57937},{3,1451},{4,1451},{5,724},{6,724},{7,724},{8,724}]',333167,'[{18020002,30}]','[{1,9}]',180),(1001,18,0,2230,'[{1,2998},{2,60010},{3,1503},{4,1503},{5,750},{6,750},{7,750},{8,750}]',345120,'[{18020002,30}]','[{2,181}]',181),(1001,18,1,2230,'[{1,3103},{2,62112},{3,1556},{4,1556},{5,776},{6,776},{7,776},{8,776}]',357172,'[{18020002,30}]','[{1,9}]',180),(1001,18,2,2230,'[{1,3210},{2,64243},{3,1609},{4,1609},{5,803},{6,803},{7,803},{8,803}]',369493,'[{18020002,30}]','[{2,183}]',183),(1001,18,3,2230,'[{1,3318},{2,66403},{3,1663},{4,1663},{5,830},{6,830},{7,830},{8,830}]',381913,'[{18020002,30}]','[{1,10}]',200),(1001,19,0,2500,'[{1,3431},{2,68670},{3,1720},{4,1720},{5,858},{6,858},{7,858},{8,858}]',394890,'[{18020002,30}]','[{2,195}]',195),(1001,19,1,2500,'[{1,3546},{2,70966},{3,1777},{4,1777},{5,887},{6,887},{7,887},{8,887}]',408136,'[{18020002,30}]','[{1,10}]',200),(1001,19,2,2500,'[{1,3662},{2,73291},{3,1835},{4,1835},{5,916},{6,916},{7,916},{8,916}]',421481,'[{18020002,30}]','[{2,197}]',197),(1001,19,3,2500,'[{1,3780},{2,75645},{3,1894},{4,1894},{5,945},{6,945},{7,945},{8,945}]',434945,'[{18020002,30}]','[{1,10}]',200),(1001,20,0,2770,'[{1,3903},{2,78110},{3,1956},{4,1956},{5,976},{6,976},{7,976},{8,976}]',449170,'[{18020002,30}]','[{2,210}]',210),(1001,20,1,2770,'[{1,4028},{2,80607},{3,2018},{4,2018},{5,1007},{6,1007},{7,1007},{8,1007}]',463467,'[{18020002,30}]','[{1,11}]',220),(1001,20,2,2770,'[{1,4154},{2,83135},{3,2081},{4,2081},{5,1039},{6,1039},{7,1039},{8,1039}]',478065,'[{18020002,30}]','[{2,214}]',214),(1001,20,3,2770,'[{1,4282},{2,85695},{3,2145},{4,2145},{5,1071},{6,1071},{7,1071},{8,1071}]',492785,'[{18020002,30}]','[{1,11}]',220),(1001,21,0,3070,'[{1,4416},{2,88371},{3,2212},{4,2212},{5,1104},{6,1104},{7,1104},{8,1104}]',508091,'[{18020003,90}]','[{2,225}]',225),(1001,21,1,3070,'[{1,4551},{2,91078},{3,2280},{4,2280},{5,1138},{6,1138},{7,1138},{8,1138}]',523698,'[{18020003,90}]','[{1,11}]',220),(1001,21,2,3070,'[{1,4688},{2,93817},{3,2348},{4,2348},{5,1172},{6,1172},{7,1172},{8,1172}]',539377,'[{18020003,90}]','[{2,230}]',230),(1001,21,3,3070,'[{1,4826},{2,96587},{3,2417},{4,2417},{5,1207},{6,1207},{7,1207},{8,1207}]',555357,'[{18020003,90}]','[{1,12}]',240),(1001,22,0,3370,'[{1,4971},{2,99478},{3,2489},{4,2489},{5,1243},{6,1243},{7,1243},{8,1243}]',571948,'[{18020003,90}]','[{2,241}]',241),(1001,22,1,3370,'[{1,5117},{2,102403},{3,2562},{4,2562},{5,1280},{6,1280},{7,1280},{8,1280}]',588843,'[{18020003,90}]','[{1,12}]',240),(1001,22,2,3370,'[{1,5265},{2,105362},{3,2636},{4,2636},{5,1317},{6,1317},{7,1317},{8,1317}]',605862,'[{18020003,90}]','[{2,246}]',246),(1001,22,3,3370,'[{1,5415},{2,108355},{3,2711},{4,2711},{5,1354},{6,1354},{7,1354},{8,1354}]',623005,'[{18020003,90}]','[{1,13}]',260),(1001,23,0,3720,'[{1,5571},{2,111473},{3,2789},{4,2789},{5,1393},{6,1393},{7,1393},{8,1393}]',640943,'[{18020003,90}]','[{2,258}]',258),(1001,23,1,3720,'[{1,5729},{2,114625},{3,2868},{4,2868},{5,1432},{6,1432},{7,1432},{8,1432}]',659005,'[{18020003,90}]','[{1,13}]',260),(1001,23,2,3720,'[{1,5888},{2,117811},{3,2948},{4,2948},{5,1472},{6,1472},{7,1472},{8,1472}]',677371,'[{18020003,90}]','[{2,262}]',262),(1001,23,3,3720,'[{1,6049},{2,121031},{3,3028},{4,3028},{5,1512},{6,1512},{7,1512},{8,1512}]',695811,'[{18020003,90}]','[{1,14}]',280),(1001,24,0,4070,'[{1,6217},{2,124382},{3,3112},{4,3112},{5,1554},{6,1554},{7,1554},{8,1554}]',715122,'[{18020003,90}]','[{2,276}]',276),(1001,24,1,4070,'[{1,6386},{2,127769},{3,3197},{4,3197},{5,1596},{6,1596},{7,1596},{8,1596}]',734539,'[{18020003,90}]','[{1,14}]',280),(1001,24,2,4070,'[{1,6557},{2,131192},{3,3283},{4,3283},{5,1639},{6,1639},{7,1639},{8,1639}]',754282,'[{18020003,90}]','[{2,281}]',281),(1001,24,3,4070,'[{1,6730},{2,134651},{3,3369},{4,3369},{5,1682},{6,1682},{7,1682},{8,1682}]',774101,'[{18020003,90}]','[{1,15}]',300),(1001,25,0,4470,'[{1,6910},{2,138246},{3,3459},{4,3459},{5,1727},{6,1727},{7,1727},{8,1727}]',794796,'[{18020003,90}]','[{2,296}]',296),(1001,25,1,4470,'[{1,7092},{2,141880},{3,3550},{4,3550},{5,1772},{6,1772},{7,1772},{8,1772}]',815620,'[{18020003,90}]','[{1,15}]',300),(1001,25,2,4470,'[{1,7276},{2,145552},{3,3642},{4,3642},{5,1818},{6,1818},{7,1818},{8,1818}]',836772,'[{18020003,90}]','[{2,300}]',300),(1001,25,3,4470,'[{1,7462},{2,149263},{3,3735},{4,3735},{5,1864},{6,1864},{7,1864},{8,1864}]',858053,'[{18020003,90}]','[{1,16}]',320),(1001,26,0,4870,'[{1,7655},{2,153114},{3,3831},{4,3831},{5,1912},{6,1912},{7,1912},{8,1912}]',880164,'[{18020003,90}]','[{2,314}]',314),(1001,26,1,4870,'[{1,7850},{2,157004},{3,3928},{4,3928},{5,1961},{6,1961},{7,1961},{8,1961}]',902604,'[{18020003,90}]','[{1,16}]',320),(1001,26,2,4870,'[{1,8046},{2,160933},{3,4026},{4,4026},{5,2010},{6,2010},{7,2010},{8,2010}]',925153,'[{18020003,90}]','[{2,320}]',320),(1001,26,3,4870,'[{1,8244},{2,164900},{3,4125},{4,4125},{5,2060},{6,2060},{7,2060},{8,2060}]',948030,'[{18020003,90}]','[{1,17}]',340),(1001,27,0,5320,'[{1,8450},{2,169013},{3,4228},{4,4228},{5,2111},{6,2111},{7,2111},{8,2111}]',971613,'[{18020003,90}]','[{2,335}]',335),(1001,27,1,5320,'[{1,8658},{2,173169},{3,4332},{4,4332},{5,2163},{6,2163},{7,2163},{8,2163}]',995529,'[{18020003,90}]','[{1,17}]',340),(1001,27,2,5320,'[{1,8868},{2,177369},{3,4437},{4,4437},{5,2215},{6,2215},{7,2215},{8,2215}]',1019579,'[{18020003,90}]','[{2,340}]',340),(1001,27,3,5320,'[{1,9080},{2,181612},{3,4543},{4,4543},{5,2268},{6,2268},{7,2268},{8,2268}]',1043962,'[{18020003,90}]','[{1,18}]',360),(1001,28,0,5770,'[{1,9300},{2,186005},{3,4653},{4,4653},{5,2323},{6,2323},{7,2323},{8,2323}]',1069255,'[{18020003,90}]','[{2,356}]',356),(1001,28,1,5770,'[{1,9522},{2,190442},{3,4764},{4,4764},{5,2378},{6,2378},{7,2378},{8,2378}]',1094682,'[{18020003,90}]','[{1,18}]',360),(1001,28,2,5770,'[{1,9746},{2,194922},{3,4876},{4,4876},{5,2434},{6,2434},{7,2434},{8,2434}]',1120442,'[{18020003,90}]','[{2,362}]',362),(1001,28,3,5770,'[{1,9972},{2,199446},{3,4989},{4,4989},{5,2491},{6,2491},{7,2491},{8,2491}]',1146536,'[{18020003,90}]','[{1,19}]',380),(1001,29,0,6270,'[{1,10206},{2,204125},{3,5106},{4,5106},{5,2549},{6,2549},{7,2549},{8,2549}]',1173345,'[{18020003,90}]','[{2,379}]',379),(1001,29,1,6270,'[{1,10442},{2,208847},{3,5224},{4,5224},{5,2608},{6,2608},{7,2608},{8,2608}]',1200487,'[{18020003,90}]','[{1,19}]',380),(1001,29,2,6270,'[{1,10680},{2,213613},{3,5343},{4,5343},{5,2668},{6,2668},{7,2668},{8,2668}]',1227963,'[{18020003,90}]','[{2,386}]',386),(1001,29,3,6270,'[{1,10920},{2,218422},{3,5463},{4,5463},{5,2728},{6,2728},{7,2728},{8,2728}]',1255572,'[{18020003,90}]','[{1,20}]',400),(1001,30,0,6770,'[{1,11168},{2,223391},{3,5587},{4,5587},{5,2790},{6,2790},{7,2790},{8,2790}]',1284101,'[{18020003,90}]','[{2,404}]',404),(1001,30,1,6770,'[{1,11419},{2,228404},{3,5712},{4,5712},{5,2853},{6,2853},{7,2853},{8,2853}]',1312984,'[{18020003,90}]','[{1,20}]',400),(1001,30,2,6770,'[{1,11672},{2,233460},{3,5838},{4,5838},{5,2916},{6,2916},{7,2916},{8,2916}]',1342000,'[{18020003,90}]','[{2,412}]',412),(1001,30,3,0,'[{1,11927},{2,238560},{3,5965},{4,5965},{5,2980},{6,2980},{7,2980},{8,2980}]',1371350,'[{18020003,90}]','[]',0),(1002,1,0,40,'[{1,428},{2,7564},{3,210},{4,194},{5,102},{6,100},{7,93},{8,109}]',46424,'[{18020001,10}]','[{2,34}]',34),(1002,1,1,40,'[{1,440},{2,7774},{3,216},{4,200},{5,105},{6,103},{7,96},{8,112}]',47774,'[{18020001,10}]','[{1,2}]',40),(1002,1,2,40,'[{1,451},{2,7988},{3,223},{4,205},{5,108},{6,106},{7,99},{8,115}]',49108,'[{18020001,10}]','[{2,35}]',35),(1002,1,3,40,'[{1,464},{2,8207},{3,229},{4,211},{5,111},{6,109},{7,101},{8,119}]',50487,'[{18020001,10}]','[{1,2}]',40),(1002,2,0,60,'[{1,479},{2,8467},{3,236},{4,218},{5,114},{6,112},{7,104},{8,122}]',51997,'[{18020001,10}]','[{2,43}]',43),(1002,2,1,60,'[{1,494},{2,8737},{3,243},{4,225},{5,118},{6,116},{7,108},{8,126}]',53717,'[{18020001,10}]','[{1,2}]',40),(1002,2,2,60,'[{1,510},{2,9014},{3,251},{4,231},{5,122},{6,120},{7,112},{8,130}]',55464,'[{18020001,10}]','[{2,46}]',46),(1002,2,3,60,'[{1,526},{2,9300},{3,259},{4,239},{5,126},{6,124},{7,115},{8,135}]',57270,'[{18020001,10}]','[{1,3}]',60),(1002,3,0,90,'[{1,545},{2,9636},{3,268},{4,248},{5,130},{6,128},{7,119},{8,139}]',59236,'[{18020001,10}]','[{2,52}]',52),(1002,3,1,90,'[{1,565},{2,9985},{3,278},{4,256},{5,135},{6,133},{7,124},{8,144}]',61435,'[{18020001,10}]','[{1,3}]',60),(1002,3,2,90,'[{1,585},{2,10346},{3,288},{4,266},{5,140},{6,138},{7,128},{8,150}]',63696,'[{18020001,10}]','[{2,54}]',54),(1002,3,3,90,'[{1,606},{2,10720},{3,298},{4,276},{5,145},{6,143},{7,133},{8,155}]',65990,'[{18020001,10}]','[{1,3}]',60),(1002,4,0,120,'[{1,631},{2,11153},{3,311},{4,287},{5,151},{6,149},{7,138},{8,162}]',68723,'[{18020001,10}]','[{2,61}]',61),(1002,4,1,120,'[{1,656},{2,11602},{3,323},{4,299},{5,157},{6,155},{7,144},{8,168}]',71472,'[{18020001,10}]','[{1,3}]',60),(1002,4,2,120,'[{1,683},{2,12068},{3,336},{4,310},{5,163},{6,161},{7,149},{8,175}]',74278,'[{18020001,10}]','[{2,65}]',65),(1002,4,3,120,'[{1,710},{2,12551},{3,349},{4,323},{5,170},{6,166},{7,155},{8,181}]',77151,'[{18020001,10}]','[{1,3}]',60),(1002,5,0,160,'[{1,741},{2,13102},{3,365},{4,337},{5,177},{6,173},{7,161},{8,189}]',80472,'[{18020001,10}]','[{2,73}]',73),(1002,5,1,160,'[{1,773},{2,13673},{3,381},{4,351},{5,185},{6,181},{7,169},{8,197}]',84033,'[{18020001,10}]','[{1,4}]',80),(1002,5,2,160,'[{1,807},{2,14266},{3,397},{4,367},{5,193},{6,189},{7,176},{8,206}]',87706,'[{18020001,10}]','[{2,77}]',77),(1002,5,3,160,'[{1,842},{2,14879},{3,414},{4,382},{5,201},{6,197},{7,183},{8,215}]',91419,'[{18020001,10}]','[{1,4}]',80),(1002,6,0,210,'[{1,881},{2,15569},{3,433},{4,399},{5,210},{6,206},{7,192},{8,224}]',95589,'[{18020001,10}]','[{2,83}]',83),(1002,6,1,210,'[{1,922},{2,16284},{3,452},{4,418},{5,220},{6,216},{7,201},{8,235}]',100074,'[{18020001,10}]','[{1,4}]',80),(1002,6,2,210,'[{1,963},{2,17023},{3,473},{4,437},{5,230},{6,226},{7,210},{8,246}]',104633,'[{18020001,10}]','[{2,88}]',88),(1002,6,3,210,'[{1,1007},{2,17787},{3,494},{4,456},{5,240},{6,236},{7,219},{8,257}]',109277,'[{18020001,10}]','[{1,5}]',100),(1002,7,0,290,'[{1,1055},{2,18636},{3,518},{4,478},{5,251},{6,247},{7,230},{8,268}]',114436,'[{18020001,10}]','[{2,97}]',97),(1002,7,1,290,'[{1,1104},{2,19514},{3,542},{4,500},{5,263},{6,259},{7,241},{8,281}]',119844,'[{18020001,10}]','[{1,5}]',100),(1002,7,2,290,'[{1,1155},{2,20422},{3,567},{4,523},{5,275},{6,271},{7,252},{8,294}]',125372,'[{18020001,10}]','[{2,101}]',101),(1002,7,3,290,'[{1,1209},{2,21359},{3,593},{4,547},{5,288},{6,282},{7,263},{8,307}]',131039,'[{18020001,10}]','[{1,5}]',100),(1002,8,0,390,'[{1,1267},{2,22389},{3,621},{4,573},{5,302},{6,296},{7,276},{8,322}]',137379,'[{18020001,10}]','[{2,111}]',111),(1002,8,1,390,'[{1,1326},{2,23448},{3,650},{4,600},{5,316},{6,310},{7,289},{8,337}]',143818,'[{18020001,10}]','[{1,6}]',120),(1002,8,2,390,'[{1,1388},{2,24536},{3,680},{4,628},{5,331},{6,325},{7,302},{8,354}]',150596,'[{18020001,10}]','[{2,114}]',114),(1002,8,3,390,'[{1,1452},{2,25654},{3,711},{4,657},{5,346},{6,340},{7,316},{8,370}]',157494,'[{18020001,10}]','[{1,6}]',120),(1002,9,0,510,'[{1,1521},{2,26873},{3,745},{4,687},{5,362},{6,356},{7,331},{8,387}]',164893,'[{18020001,10}]','[{2,126}]',126),(1002,9,1,510,'[{1,1592},{2,28125},{3,779},{4,719},{5,379},{6,373},{7,347},{8,405}]',172615,'[{18020001,10}]','[{1,6}]',120),(1002,9,2,510,'[{1,1665},{2,29411},{3,814},{4,752},{5,397},{6,389},{7,362},{8,424}]',180461,'[{18020001,10}]','[{2,132}]',132),(1002,9,3,510,'[{1,1740},{2,30731},{3,851},{4,785},{5,415},{6,407},{7,379},{8,443}]',188631,'[{18020001,10}]','[{1,7}]',140),(1002,10,0,650,'[{1,1820},{2,32159},{3,890},{4,822},{5,434},{6,426},{7,396},{8,464}]',197359,'[{18020001,10}]','[{2,142}]',142),(1002,10,1,650,'[{1,1903},{2,33622},{3,931},{4,859},{5,453},{6,445},{7,414},{8,484}]',206232,'[{18020001,10}]','[{1,7}]',140),(1002,10,2,650,'[{1,1988},{2,35118},{3,972},{4,898},{5,473},{6,465},{7,432},{8,506}]',215428,'[{18020001,10}]','[{2,147}]',147),(1002,10,3,650,'[{1,2075},{2,36648},{3,1015},{4,937},{5,493},{6,485},{7,451},{8,527}]',224748,'[{18020001,10}]','[{1,8}]',160),(1002,11,0,810,'[{1,2169},{2,38295},{3,1061},{4,979},{5,516},{6,506},{7,471},{8,551}]',234875,'[{18020002,30}]','[{2,158}]',158),(1002,11,1,810,'[{1,2264},{2,39979},{3,1108},{4,1022},{5,538},{6,528},{7,491},{8,575}]',245109,'[{18020002,30}]','[{1,8}]',160),(1002,11,2,810,'[{1,2362},{2,41703},{3,1155},{4,1067},{5,561},{6,551},{7,513},{8,599}]',255693,'[{18020002,30}]','[{2,163}]',163),(1002,11,3,810,'[{1,2462},{2,43463},{3,1204},{4,1112},{5,584},{6,574},{7,534},{8,624}]',266403,'[{18020002,30}]','[{1,9}]',180),(1002,12,0,970,'[{1,2569},{2,45350},{3,1256},{4,1160},{5,609},{6,599},{7,557},{8,651}]',277930,'[{18020002,30}]','[{2,176}]',176),(1002,12,1,970,'[{1,2678},{2,47275},{3,1309},{4,1209},{5,636},{6,624},{7,581},{8,679}]',289785,'[{18020002,30}]','[{1,9}]',180),(1002,12,2,970,'[{1,2790},{2,49237},{3,1363},{4,1259},{5,662},{6,650},{7,605},{8,707}]',301787,'[{18020002,30}]','[{2,181}]',181),(1002,12,3,970,'[{1,2904},{2,51237},{3,1419},{4,1309},{5,689},{6,677},{7,630},{8,736}]',314117,'[{18020002,30}]','[{1,10}]',200),(1002,13,0,1150,'[{1,3025},{2,53372},{3,1478},{4,1364},{5,717},{6,705},{7,656},{8,766}]',327122,'[{18020002,30}]','[{2,195}]',195),(1002,13,1,1150,'[{1,3148},{2,55549},{3,1538},{4,1420},{5,747},{6,733},{7,682},{8,798}]',340459,'[{18020002,30}]','[{1,10}]',200),(1002,13,2,1150,'[{1,3273},{2,57768},{3,1600},{4,1476},{5,777},{6,763},{7,710},{8,830}]',354128,'[{18020002,30}]','[{2,200}]',200),(1002,13,3,1150,'[{1,3402},{2,60028},{3,1662},{4,1534},{5,807},{6,793},{7,738},{8,862}]',367968,'[{18020002,30}]','[{1,11}]',220),(1002,14,0,1330,'[{1,3538},{2,62432},{3,1728},{4,1596},{5,839},{6,825},{7,767},{8,897}]',382692,'[{18020002,30}]','[{2,215}]',215),(1002,14,1,1330,'[{1,3676},{2,64878},{3,1796},{4,1658},{5,873},{6,857},{7,798},{8,932}]',397748,'[{18020002,30}]','[{1,11}]',220),(1002,14,2,1330,'[{1,3817},{2,67365},{3,1865},{4,1721},{5,906},{6,890},{7,828},{8,968}]',412955,'[{18020002,30}]','[{2,219}]',219),(1002,14,3,1330,'[{1,3960},{2,69895},{3,1934},{4,1786},{5,940},{6,924},{7,859},{8,1005}]',428495,'[{18020002,30}]','[{1,12}]',240),(1002,15,0,1540,'[{1,4112},{2,72576},{3,2008},{4,1854},{5,977},{6,959},{7,892},{8,1044}]',444966,'[{18020002,30}]','[{2,234}]',234),(1002,15,1,1540,'[{1,4266},{2,75304},{3,2084},{4,1924},{5,1013},{6,995},{7,926},{8,1082}]',461624,'[{18020002,30}]','[{1,12}]',240),(1002,15,2,1540,'[{1,4423},{2,78077},{3,2161},{4,1995},{5,1050},{6,1032},{7,960},{8,1122}]',478637,'[{18020002,30}]','[{2,239}]',239),(1002,15,3,1540,'[{1,4583},{2,80897},{3,2239},{4,2067},{5,1089},{6,1069},{7,995},{8,1163}]',496007,'[{18020002,30}]','[{1,13}]',260),(1002,16,0,1750,'[{1,4751},{2,83876},{3,2321},{4,2143},{5,1129},{6,1109},{7,1032},{8,1206}]',514296,'[{18020002,30}]','[{2,255}]',255),(1002,16,1,1750,'[{1,4922},{2,86902},{3,2406},{4,2220},{5,1169},{6,1149},{7,1069},{8,1249}]',532792,'[{18020002,30}]','[{1,13}]',260),(1002,16,2,1750,'[{1,5097},{2,89974},{3,2491},{4,2299},{5,1211},{6,1189},{7,1106},{8,1294}]',551664,'[{18020002,30}]','[{2,261}]',261),(1002,16,3,1750,'[{1,5273},{2,93092},{3,2577},{4,2379},{5,1253},{6,1231},{7,1145},{8,1339}]',570852,'[{18020002,30}]','[{1,14}]',280),(1002,17,0,1990,'[{1,5459},{2,96378},{3,2669},{4,2463},{5,1298},{6,1274},{7,1186},{8,1386}]',591058,'[{18020002,30}]','[{2,278}]',278),(1002,17,1,1990,'[{1,5648},{2,99710},{3,2761},{4,2549},{5,1342},{6,1318},{7,1226},{8,1434}]',611420,'[{18020002,30}]','[{1,14}]',280),(1002,17,2,1990,'[{1,5839},{2,103089},{3,2855},{4,2635},{5,1387},{6,1363},{7,1268},{8,1482}]',632119,'[{18020002,30}]','[{2,284}]',284),(1002,17,3,1990,'[{1,6033},{2,106514},{3,2949},{4,2723},{5,1434},{6,1408},{7,1310},{8,1532}]',653174,'[{18020002,30}]','[{1,15}]',300),(1002,18,0,2230,'[{1,6237},{2,110115},{3,3049},{4,2815},{5,1482},{6,1456},{7,1354},{8,1584}]',675255,'[{18020002,30}]','[{2,300}]',300),(1002,18,1,2230,'[{1,6444},{2,113766},{3,3150},{4,2908},{5,1532},{6,1504},{7,1400},{8,1636}]',697696,'[{18020002,30}]','[{1,15}]',300),(1002,18,2,2230,'[{1,6653},{2,117469},{3,3253},{4,3003},{5,1581},{6,1553},{7,1445},{8,1689}]',720329,'[{18020002,30}]','[{2,307}]',307),(1002,18,3,2230,'[{1,6866},{2,121221},{3,3357},{4,3099},{5,1632},{6,1602},{7,1491},{8,1743}]',743341,'[{18020002,30}]','[{1,16}]',320),(1002,19,0,2500,'[{1,7089},{2,125159},{3,3466},{4,3200},{5,1684},{6,1654},{7,1539},{8,1799}]',767389,'[{18020002,30}]','[{2,325}]',325),(1002,19,1,2500,'[{1,7315},{2,129148},{3,3577},{4,3301},{5,1737},{6,1707},{7,1588},{8,1856}]',791798,'[{18020002,30}]','[{1,16}]',320),(1002,19,2,2500,'[{1,7543},{2,133186},{3,3689},{4,3405},{5,1792},{6,1760},{7,1637},{8,1915}]',816596,'[{18020002,30}]','[{2,331}]',331),(1002,19,3,2500,'[{1,7775},{2,137274},{3,3802},{4,3510},{5,1846},{6,1814},{7,1687},{8,1973}]',841574,'[{18020002,30}]','[{1,17}]',340),(1002,20,0,2770,'[{1,8017},{2,141556},{3,3921},{4,3619},{5,1904},{6,1870},{7,1740},{8,2034}]',867796,'[{18020002,30}]','[{2,349}]',349),(1002,20,1,2770,'[{1,8262},{2,145893},{3,4041},{4,3731},{5,1963},{6,1927},{7,1793},{8,2097}]',894433,'[{18020002,30}]','[{1,18}]',360),(1002,20,2,2770,'[{1,8511},{2,150284},{3,4163},{4,3843},{5,2022},{6,1986},{7,1848},{8,2160}]',921454,'[{18020002,30}]','[{2,356}]',356),(1002,20,3,2770,'[{1,8763},{2,154731},{3,4286},{4,3956},{5,2082},{6,2044},{7,1902},{8,2224}]',948641,'[{18020002,30}]','[{1,19}]',380),(1002,21,0,3070,'[{1,9026},{2,159378},{3,4415},{4,4075},{5,2144},{6,2106},{7,1959},{8,2291}]',977148,'[{18020003,90}]','[{2,376}]',376),(1002,21,1,3070,'[{1,9293},{2,164081},{3,4545},{4,4195},{5,2208},{6,2168},{7,2017},{8,2359}]',1006041,'[{18020003,90}]','[{1,19}]',380),(1002,21,2,3070,'[{1,9562},{2,168837},{3,4677},{4,4317},{5,2271},{6,2231},{7,2075},{8,2427}]',1035127,'[{18020003,90}]','[{2,382}]',382),(1002,21,3,3070,'[{1,9834},{2,173649},{3,4810},{4,4440},{5,2336},{6,2294},{7,2134},{8,2496}]',1064579,'[{18020003,90}]','[{1,20}]',400),(1002,22,0,3370,'[{1,10119},{2,178671},{3,4949},{4,4569},{5,2403},{6,2361},{7,2196},{8,2568}]',1095401,'[{18020003,90}]','[{2,403}]',403),(1002,22,1,3370,'[{1,10407},{2,183751},{3,5090},{4,4698},{5,2472},{6,2428},{7,2259},{8,2641}]',1126591,'[{18020003,90}]','[{1,20}]',400),(1002,22,2,3370,'[{1,10698},{2,188891},{3,5232},{4,4830},{5,2541},{6,2495},{7,2322},{8,2714}]',1158001,'[{18020003,90}]','[{2,409}]',409),(1002,22,3,3370,'[{1,10992},{2,194089},{3,5377},{4,4963},{5,2610},{6,2564},{7,2385},{8,2789}]',1189829,'[{18020003,90}]','[{1,21}]',420),(1002,23,0,3720,'[{1,11299},{2,199506},{3,5527},{4,5101},{5,2683},{6,2635},{7,2452},{8,2866}]',1222986,'[{18020003,90}]','[{2,432}]',432),(1002,23,1,3720,'[{1,11609},{2,204981},{3,5678},{4,5242},{5,2757},{6,2707},{7,2519},{8,2945}]',1256561,'[{18020003,90}]','[{1,22}]',440),(1002,23,2,3720,'[{1,11922},{2,210515},{3,5832},{4,5384},{5,2831},{6,2781},{7,2587},{8,3025}]',1290555,'[{18020003,90}]','[{2,439}]',439),(1002,23,3,3720,'[{1,12238},{2,216109},{3,5987},{4,5527},{5,2907},{6,2855},{7,2656},{8,3106}]',1324919,'[{18020003,90}]','[{1,23}]',460),(1002,24,0,4070,'[{1,12568},{2,221929},{3,6148},{4,5676},{5,2986},{6,2932},{7,2728},{8,3190}]',1360689,'[{18020003,90}]','[{2,460}]',460),(1002,24,1,4070,'[{1,12901},{2,227812},{3,6312},{4,5826},{5,3064},{6,3010},{7,2800},{8,3274}]',1396682,'[{18020003,90}]','[{1,23}]',460),(1002,24,2,4070,'[{1,13238},{2,233758},{3,6476},{4,5978},{5,3144},{6,3088},{7,2873},{8,3359}]',1433068,'[{18020003,90}]','[{2,469}]',469),(1002,24,3,4070,'[{1,13578},{2,239767},{3,6642},{4,6132},{5,3225},{6,3167},{7,2947},{8,3445}]',1469877,'[{18020003,90}]','[{1,24}]',480),(1002,25,0,4470,'[{1,13931},{2,246011},{3,6815},{4,6291},{5,3309},{6,3249},{7,3023},{8,3535}]',1508081,'[{18020003,90}]','[{2,491}]',491),(1002,25,1,4470,'[{1,14288},{2,252323},{3,6990},{4,6452},{5,3393},{6,3333},{7,3101},{8,3625}]',1546733,'[{18020003,90}]','[{1,25}]',500),(1002,25,2,4470,'[{1,14649},{2,258702},{3,7167},{4,6615},{5,3479},{6,3417},{7,3179},{8,3717}]',1585832,'[{18020003,90}]','[{2,500}]',500),(1002,25,3,4470,'[{1,15015},{2,265148},{3,7346},{4,6780},{5,3566},{6,3502},{7,3258},{8,3810}]',1625398,'[{18020003,90}]','[{1,26}]',520),(1002,26,0,4870,'[{1,15394},{2,271838},{3,7531},{4,6951},{5,3656},{6,3590},{7,3340},{8,3906}]',1666368,'[{18020003,90}]','[{2,524}]',524),(1002,26,1,4870,'[{1,15776},{2,278595},{3,7718},{4,7124},{5,3746},{6,3680},{7,3423},{8,4003}]',1707765,'[{18020003,90}]','[{1,26}]',520),(1002,26,2,4870,'[{1,16163},{2,285420},{3,7907},{4,7299},{5,3838},{6,3770},{7,3507},{8,4101}]',1749630,'[{18020003,90}]','[{2,533}]',533),(1002,26,3,4870,'[{1,16552},{2,292312},{3,8098},{4,7476},{5,3931},{6,3861},{7,3592},{8,4200}]',1791902,'[{18020003,90}]','[{1,28}]',560),(1002,27,0,5320,'[{1,16957},{2,299456},{3,8296},{4,7658},{5,4027},{6,3955},{7,3680},{8,4302}]',1835646,'[{18020003,90}]','[{2,556}]',556),(1002,27,1,5320,'[{1,17366},{2,306675},{3,8496},{4,7842},{5,4124},{6,4050},{7,3768},{8,4406}]',1879845,'[{18020003,90}]','[{1,28}]',560),(1002,27,2,5320,'[{1,17779},{2,313970},{3,8698},{4,8028},{5,4222},{6,4146},{7,3858},{8,4510}]',1924500,'[{18020003,90}]','[{2,568}]',568),(1002,27,3,5320,'[{1,18196},{2,321341},{3,8901},{4,8217},{5,4321},{6,4243},{7,3948},{8,4616}]',1969611,'[{18020003,90}]','[{1,29}]',580),(1002,28,0,5770,'[{1,18629},{2,328973},{3,9112},{4,8412},{5,4423},{6,4345},{7,4042},{8,4726}]',2016453,'[{18020003,90}]','[{2,594}]',594),(1002,28,1,5770,'[{1,19065},{2,336679},{3,9326},{4,8608},{5,4527},{6,4447},{7,4137},{8,4837}]',2063729,'[{18020003,90}]','[{1,30}]',600),(1002,28,2,5770,'[{1,19506},{2,344462},{3,9541},{4,8807},{5,4632},{6,4550},{7,4233},{8,4949}]',2111482,'[{18020003,90}]','[{2,603}]',603),(1002,28,3,5770,'[{1,19951},{2,352320},{3,9758},{4,9008},{5,4738},{6,4654},{7,4330},{8,5062}]',2159690,'[{18020003,90}]','[{1,31}]',620),(1002,29,0,6270,'[{1,20411},{2,360447},{3,9984},{4,9216},{5,4847},{6,4761},{7,4429},{8,5179}]',2209467,'[{18020003,90}]','[{2,632}]',632),(1002,29,1,6270,'[{1,20875},{2,368650},{3,10212},{4,9426},{5,4957},{6,4869},{7,4530},{8,5296}]',2259700,'[{18020003,90}]','[{1,32}]',640),(1002,29,2,6270,'[{1,21343},{2,376929},{3,10442},{4,9638},{5,5068},{6,4978},{7,4631},{8,5415}]',2310389,'[{18020003,90}]','[{2,643}]',643),(1002,29,3,6270,'[{1,21816},{2,385283},{3,10674},{4,9852},{5,5180},{6,5088},{7,4734},{8,5534}]',2361553,'[{18020003,90}]','[{1,33}]',660),(1002,30,0,6770,'[{1,22304},{2,393914},{3,10913},{4,10073},{5,5296},{6,5202},{7,4840},{8,5658}]',2414444,'[{18020003,90}]','[{2,671}]',671),(1002,30,1,6770,'[{1,22797},{2,402621},{3,11154},{4,10296},{5,5413},{6,5317},{7,4947},{8,5783}]',2467811,'[{18020003,90}]','[{1,34}]',680),(1002,30,2,6770,'[{1,23294},{2,411404},{3,11397},{4,10521},{5,5531},{6,5433},{7,5054},{8,5910}]',2521634,'[{18020003,90}]','[{2,685}]',685),(1002,30,3,0,'[{1,23795},{2,420262},{3,11643},{4,10747},{5,5650},{6,5550},{7,5163},{8,6037}]',2575912,'[{18020003,90}]','[]',0),(1003,1,0,40,'[{1,428},{2,7572},{3,204},{4,200},{5,101},{6,101},{7,99},{8,103}]',46432,'[{18020001,10}]','[{2,35}]',35),(1003,1,1,40,'[{1,439},{2,7782},{3,210},{4,206},{5,104},{6,104},{7,102},{8,106}]',47762,'[{18020001,10}]','[{1,2}]',40),(1003,1,2,40,'[{1,451},{2,7997},{3,217},{4,211},{5,107},{6,107},{7,105},{8,109}]',49117,'[{18020001,10}]','[{2,36}]',36),(1003,1,3,40,'[{1,464},{2,8215},{3,223},{4,217},{5,110},{6,110},{7,108},{8,112}]',50495,'[{18020001,10}]','[{1,2}]',40),(1003,2,0,60,'[{1,479},{2,8476},{3,230},{4,224},{5,113},{6,113},{7,111},{8,115}]',52006,'[{18020001,10}]','[{2,42}]',42),(1003,2,1,60,'[{1,493},{2,8746},{3,237},{4,231},{5,117},{6,117},{7,115},{8,119}]',53706,'[{18020001,10}]','[{1,2}]',40),(1003,2,2,60,'[{1,509},{2,9024},{3,244},{4,238},{5,121},{6,121},{7,119},{8,123}]',55454,'[{18020001,10}]','[{2,45}]',45),(1003,2,3,60,'[{1,525},{2,9310},{3,252},{4,246},{5,126},{6,125},{7,123},{8,127}]',57310,'[{18020001,10}]','[{1,3}]',60),(1003,3,0,90,'[{1,544},{2,9646},{3,261},{4,255},{5,130},{6,128},{7,127},{8,131}]',59226,'[{18020001,10}]','[{2,50}]',50),(1003,3,1,90,'[{1,564},{2,9996},{3,270},{4,264},{5,135},{6,133},{7,132},{8,136}]',61426,'[{18020001,10}]','[{1,3}]',60),(1003,3,2,90,'[{1,585},{2,10357},{3,280},{4,274},{5,140},{6,138},{7,137},{8,141}]',63707,'[{18020001,10}]','[{2,54}]',54),(1003,3,3,90,'[{1,606},{2,10732},{3,290},{4,284},{5,145},{6,143},{7,142},{8,146}]',66002,'[{18020001,10}]','[{1,3}]',60),(1003,4,0,120,'[{1,630},{2,11165},{3,303},{4,295},{5,151},{6,149},{7,147},{8,153}]',68715,'[{18020001,10}]','[{2,61}]',61),(1003,4,1,120,'[{1,656},{2,11614},{3,315},{4,307},{5,157},{6,155},{7,153},{8,159}]',71484,'[{18020001,10}]','[{1,3}]',60),(1003,4,2,120,'[{1,682},{2,12081},{3,327},{4,319},{5,163},{6,161},{7,159},{8,165}]',74271,'[{18020001,10}]','[{2,66}]',66),(1003,4,3,120,'[{1,710},{2,12565},{3,340},{4,332},{5,169},{6,167},{7,165},{8,171}]',77165,'[{18020001,10}]','[{1,3}]',60),(1003,5,0,160,'[{1,741},{2,13116},{3,355},{4,347},{5,176},{6,174},{7,172},{8,178}]',80486,'[{18020001,10}]','[{2,73}]',73),(1003,5,1,160,'[{1,772},{2,13688},{3,370},{4,362},{5,184},{6,182},{7,180},{8,186}]',84028,'[{18020001,10}]','[{1,4}]',80),(1003,5,2,160,'[{1,806},{2,14281},{3,387},{4,377},{5,192},{6,190},{7,188},{8,194}]',87701,'[{18020001,10}]','[{2,75}]',75),(1003,5,3,160,'[{1,841},{2,14895},{3,403},{4,393},{5,200},{6,198},{7,196},{8,202}]',91415,'[{18020001,10}]','[{1,4}]',80),(1003,6,0,210,'[{1,881},{2,15586},{3,421},{4,411},{5,209},{6,207},{7,204},{8,212}]',95606,'[{18020001,10}]','[{2,84}]',84),(1003,6,1,210,'[{1,921},{2,16301},{3,440},{4,430},{5,219},{6,217},{7,214},{8,222}]',100071,'[{18020001,10}]','[{1,4}]',80),(1003,6,2,210,'[{1,962},{2,17041},{3,460},{4,450},{5,229},{6,227},{7,224},{8,232}]',104631,'[{18020001,10}]','[{2,87}]',87),(1003,6,3,210,'[{1,1006},{2,17806},{3,481},{4,469},{5,239},{6,237},{7,234},{8,242}]',109276,'[{18020001,10}]','[{1,5}]',100),(1003,7,0,290,'[{1,1054},{2,18656},{3,504},{4,492},{5,250},{6,248},{7,245},{8,253}]',114436,'[{18020001,10}]','[{2,97}]',97),(1003,7,1,290,'[{1,1103},{2,19535},{3,527},{4,515},{5,262},{6,260},{7,257},{8,265}]',119845,'[{18020001,10}]','[{1,5}]',100),(1003,7,2,290,'[{1,1154},{2,20444},{3,552},{4,538},{5,274},{6,272},{7,268},{8,278}]',125374,'[{18020001,10}]','[{2,101}]',101),(1003,7,3,290,'[{1,1207},{2,21382},{3,577},{4,563},{5,286},{6,284},{7,280},{8,290}]',131022,'[{18020001,10}]','[{1,5}]',100),(1003,8,0,390,'[{1,1266},{2,22413},{3,604},{4,590},{5,300},{6,298},{7,294},{8,304}]',137383,'[{18020001,10}]','[{2,111}]',111),(1003,8,1,390,'[{1,1325},{2,23473},{3,633},{4,618},{5,314},{6,312},{7,308},{8,318}]',143848,'[{18020001,10}]','[{1,6}]',120),(1003,8,2,390,'[{1,1387},{2,24562},{3,662},{4,646},{5,329},{6,327},{7,322},{8,334}]',150602,'[{18020001,10}]','[{2,116}]',116),(1003,8,3,390,'[{1,1450},{2,25682},{3,692},{4,676},{5,344},{6,342},{7,337},{8,349}]',157482,'[{18020001,10}]','[{1,6}]',120),(1003,9,0,510,'[{1,1519},{2,26901},{3,725},{4,707},{5,360},{6,358},{7,353},{8,365}]',164881,'[{18020001,10}]','[{2,126}]',126),(1003,9,1,510,'[{1,1590},{2,28155},{3,758},{4,740},{5,378},{6,374},{7,370},{8,382}]',172605,'[{18020001,10}]','[{1,6}]',120),(1003,9,2,510,'[{1,1664},{2,29442},{3,792},{4,774},{5,395},{6,391},{7,386},{8,400}]',180472,'[{18020001,10}]','[{2,131}]',131),(1003,9,3,510,'[{1,1738},{2,30764},{3,828},{4,808},{5,413},{6,409},{7,404},{8,418}]',188624,'[{18020001,10}]','[{1,7}]',140),(1003,10,0,650,'[{1,1819},{2,32194},{3,866},{4,846},{5,432},{6,428},{7,423},{8,437}]',197374,'[{18020001,10}]','[{2,143}]',143),(1003,10,1,650,'[{1,1901},{2,33658},{3,906},{4,884},{5,451},{6,447},{7,441},{8,457}]',206228,'[{18020001,10}]','[{1,7}]',140),(1003,10,2,650,'[{1,1986},{2,35155},{3,946},{4,924},{5,471},{6,467},{7,461},{8,477}]',215425,'[{18020001,10}]','[{2,146}]',146),(1003,10,3,650,'[{1,2073},{2,36687},{3,988},{4,964},{5,491},{6,487},{7,481},{8,497}]',224747,'[{18020001,10}]','[{1,8}]',160),(1003,11,0,810,'[{1,2167},{2,38336},{3,1032},{4,1008},{5,513},{6,509},{7,502},{8,520}]',234876,'[{18020002,30}]','[{2,159}]',159),(1003,11,1,810,'[{1,2262},{2,40022},{3,1078},{4,1052},{5,535},{6,531},{7,524},{8,542}]',245112,'[{18020002,30}]','[{1,8}]',160),(1003,11,2,810,'[{1,2360},{2,41747},{3,1124},{4,1098},{5,558},{6,554},{7,547},{8,565}]',255697,'[{18020002,30}]','[{2,163}]',163),(1003,11,3,810,'[{1,2459},{2,43510},{3,1172},{4,1144},{5,581},{6,577},{7,569},{8,589}]',266390,'[{18020002,30}]','[{1,9}]',180),(1003,12,0,970,'[{1,2567},{2,45399},{3,1222},{4,1194},{5,606},{6,602},{7,594},{8,614}]',277939,'[{18020002,30}]','[{2,176}]',176),(1003,12,1,970,'[{1,2676},{2,47326},{3,1274},{4,1244},{5,633},{6,627},{7,619},{8,641}]',289796,'[{18020002,30}]','[{1,9}]',180),(1003,12,2,970,'[{1,2787},{2,49290},{3,1327},{4,1295},{5,659},{6,653},{7,645},{8,667}]',301780,'[{18020002,30}]','[{2,180}]',180),(1003,12,3,970,'[{1,2901},{2,51292},{3,1380},{4,1348},{5,686},{6,680},{7,671},{8,695}]',314112,'[{18020002,30}]','[{1,10}]',200),(1003,13,0,1150,'[{1,3022},{2,53429},{3,1438},{4,1404},{5,714},{6,708},{7,699},{8,723}]',327119,'[{18020002,30}]','[{2,194}]',194),(1003,13,1,1150,'[{1,3145},{2,55609},{3,1497},{4,1461},{5,743},{6,737},{7,727},{8,753}]',340459,'[{18020002,30}]','[{1,10}]',200),(1003,13,2,1150,'[{1,3270},{2,57829},{3,1556},{4,1520},{5,773},{6,767},{7,757},{8,783}]',354129,'[{18020002,30}]','[{2,199}]',199),(1003,13,3,1150,'[{1,3398},{2,60092},{3,1617},{4,1579},{5,803},{6,797},{7,786},{8,814}]',367952,'[{18020002,30}]','[{1,11}]',220),(1003,14,0,1330,'[{1,3534},{2,62499},{3,1682},{4,1642},{5,835},{6,829},{7,818},{8,846}]',382679,'[{18020002,30}]','[{2,214}]',214),(1003,14,1,1330,'[{1,3672},{2,64947},{3,1748},{4,1706},{5,868},{6,862},{7,850},{8,880}]',397737,'[{18020002,30}]','[{1,11}]',220),(1003,14,2,1330,'[{1,3813},{2,67437},{3,1815},{4,1771},{5,902},{6,894},{7,883},{8,913}]',412947,'[{18020002,30}]','[{2,218}]',218),(1003,14,3,1330,'[{1,3956},{2,69970},{3,1882},{4,1838},{5,936},{6,928},{7,916},{8,948}]',428490,'[{18020002,30}]','[{1,12}]',240),(1003,15,0,1540,'[{1,4108},{2,72653},{3,1954},{4,1908},{5,972},{6,964},{7,952},{8,984}]',444963,'[{18020002,30}]','[{2,234}]',234),(1003,15,1,1540,'[{1,4262},{2,75384},{3,2028},{4,1980},{5,1008},{6,1000},{7,987},{8,1021}]',461624,'[{18020002,30}]','[{1,12}]',240),(1003,15,2,1540,'[{1,4419},{2,78160},{3,2103},{4,2053},{5,1045},{6,1037},{7,1023},{8,1059}]',478640,'[{18020002,30}]','[{2,239}]',239),(1003,15,3,1540,'[{1,4578},{2,80983},{3,2179},{4,2127},{5,1083},{6,1075},{7,1061},{8,1097}]',495993,'[{18020002,30}]','[{1,13}]',260),(1003,16,0,1750,'[{1,4747},{2,83965},{3,2259},{4,2205},{5,1123},{6,1115},{7,1100},{8,1138}]',514305,'[{18020002,30}]','[{2,255}]',255),(1003,16,1,1750,'[{1,4918},{2,86995},{3,2341},{4,2285},{5,1164},{6,1154},{7,1139},{8,1179}]',532805,'[{18020002,30}]','[{1,13}]',260),(1003,16,2,1750,'[{1,5092},{2,90070},{3,2424},{4,2366},{5,1205},{6,1195},{7,1180},{8,1220}]',551660,'[{18020002,30}]','[{2,261}]',261),(1003,16,3,1750,'[{1,5268},{2,93191},{3,2508},{4,2448},{5,1247},{6,1237},{7,1221},{8,1263}]',570851,'[{18020002,30}]','[{1,14}]',280),(1003,17,0,1990,'[{1,5454},{2,96480},{3,2597},{4,2535},{5,1291},{6,1281},{7,1264},{8,1308}]',591060,'[{18020002,30}]','[{2,278}]',278),(1003,17,1,1990,'[{1,5642},{2,99817},{3,2687},{4,2623},{5,1335},{6,1325},{7,1307},{8,1353}]',611407,'[{18020002,30}]','[{1,14}]',280),(1003,17,2,1990,'[{1,5833},{2,103199},{3,2778},{4,2712},{5,1381},{6,1370},{7,1352},{8,1398}]',632159,'[{18020002,30}]','[{2,283}]',283),(1003,17,3,1990,'[{1,6028},{2,106627},{3,2870},{4,2802},{5,1427},{6,1415},{7,1397},{8,1445}]',653187,'[{18020002,30}]','[{1,15}]',300),(1003,18,0,2230,'[{1,6231},{2,110232},{3,2967},{4,2897},{5,1475},{6,1463},{7,1444},{8,1494}]',675252,'[{18020002,30}]','[{2,300}]',300),(1003,18,1,2230,'[{1,6438},{2,113888},{3,3065},{4,2993},{5,1524},{6,1512},{7,1492},{8,1544}]',697698,'[{18020002,30}]','[{1,15}]',300),(1003,18,2,2230,'[{1,6647},{2,117594},{3,3166},{4,3090},{5,1573},{6,1561},{7,1540},{8,1594}]',720334,'[{18020002,30}]','[{2,307}]',307),(1003,18,3,2230,'[{1,6859},{2,121351},{3,3267},{4,3189},{5,1623},{6,1611},{7,1590},{8,1644}]',743331,'[{18020002,30}]','[{1,16}]',320),(1003,19,0,2500,'[{1,7082},{2,125293},{3,3373},{4,3293},{5,1676},{6,1662},{7,1641},{8,1697}]',767383,'[{18020002,30}]','[{2,325}]',325),(1003,19,1,2500,'[{1,7308},{2,129285},{3,3480},{4,3398},{5,1729},{6,1715},{7,1693},{8,1751}]',791795,'[{18020002,30}]','[{1,16}]',320),(1003,19,2,2500,'[{1,7536},{2,133328},{3,3590},{4,3504},{5,1783},{6,1769},{7,1746},{8,1806}]',816598,'[{18020002,30}]','[{2,331}]',331),(1003,19,3,2500,'[{1,7768},{2,137421},{3,3700},{4,3612},{5,1837},{6,1823},{7,1799},{8,1861}]',841581,'[{18020002,30}]','[{1,17}]',340),(1003,20,0,2770,'[{1,8009},{2,141707},{3,3815},{4,3725},{5,1895},{6,1879},{7,1855},{8,1919}]',867787,'[{18020002,30}]','[{2,349}]',349),(1003,20,1,2770,'[{1,8255},{2,146048},{3,3933},{4,3839},{5,1953},{6,1937},{7,1912},{8,1978}]',894448,'[{18020002,30}]','[{1,18}]',360),(1003,20,2,2770,'[{1,8503},{2,150445},{3,4051},{4,3955},{5,2012},{6,1996},{7,1970},{8,2038}]',921455,'[{18020002,30}]','[{2,355}]',355),(1003,20,3,2770,'[{1,8754},{2,154896},{3,4170},{4,4072},{5,2071},{6,2055},{7,2028},{8,2098}]',948626,'[{18020002,30}]','[{1,19}]',380),(1003,21,0,3070,'[{1,9017},{2,159548},{3,4296},{4,4194},{5,2134},{6,2117},{7,2089},{8,2161}]',977188,'[{18020003,90}]','[{2,375}]',375),(1003,21,1,3070,'[{1,9284},{2,164256},{3,4422},{4,4318},{5,2197},{6,2179},{7,2151},{8,2225}]',1006036,'[{18020003,90}]','[{1,19}]',380),(1003,21,2,3070,'[{1,9553},{2,169017},{3,4551},{4,4443},{5,2260},{6,2242},{7,2213},{8,2289}]',1035127,'[{18020003,90}]','[{2,382}]',382),(1003,21,3,3070,'[{1,9825},{2,173834},{3,4681},{4,4570},{5,2324},{6,2306},{7,2276},{8,2354}]',1064609,'[{18020003,90}]','[{1,20}]',400),(1003,22,0,3370,'[{1,10109},{2,178862},{3,4816},{4,4702},{5,2392},{6,2372},{7,2342},{8,2422}]',1095392,'[{18020003,90}]','[{2,403}]',403),(1003,22,1,3370,'[{1,10397},{2,183947},{3,4953},{4,4835},{5,2460},{6,2440},{7,2408},{8,2492}]',1126587,'[{18020003,90}]','[{1,20}]',400),(1003,22,2,3370,'[{1,10687},{2,189092},{3,5091},{4,4971},{5,2528},{6,2508},{7,2475},{8,2561}]',1157982,'[{18020003,90}]','[{2,408}]',408),(1003,22,3,3370,'[{1,10981},{2,194296},{3,5232},{4,5108},{5,2597},{6,2577},{7,2543},{8,2631}]',1189816,'[{18020003,90}]','[{1,21}]',420),(1003,23,0,3720,'[{1,11288},{2,199719},{3,5378},{4,5250},{5,2670},{6,2648},{7,2614},{8,2704}]',1222979,'[{18020003,90}]','[{2,431}]',431),(1003,23,1,3720,'[{1,11598},{2,205200},{3,5526},{4,5394},{5,2743},{6,2721},{7,2686},{8,2778}]',1256560,'[{18020003,90}]','[{1,22}]',440),(1003,23,2,3720,'[{1,11911},{2,210740},{3,5675},{4,5541},{5,2817},{6,2795},{7,2758},{8,2854}]',1290560,'[{18020003,90}]','[{2,437}]',437),(1003,23,3,3720,'[{1,12227},{2,216339},{3,5826},{4,5688},{5,2893},{6,2869},{7,2832},{8,2930}]',1324929,'[{18020003,90}]','[{1,23}]',460),(1003,24,0,4070,'[{1,12556},{2,222166},{3,5983},{4,5841},{5,2971},{6,2947},{7,2909},{8,3009}]',1360686,'[{18020003,90}]','[{2,460}]',460),(1003,24,1,4070,'[{1,12889},{2,228055},{3,6142},{4,5996},{5,3049},{6,3025},{7,2985},{8,3089}]',1396685,'[{18020003,90}]','[{1,23}]',460),(1003,24,2,4070,'[{1,13225},{2,234007},{3,6302},{4,6152},{5,3128},{6,3104},{7,3063},{8,3169}]',1433057,'[{18020003,90}]','[{2,468}]',468),(1003,24,3,4070,'[{1,13565},{2,240022},{3,6464},{4,6310},{5,3209},{6,3183},{7,3142},{8,3250}]',1469872,'[{18020003,90}]','[{1,24}]',480),(1003,25,0,4470,'[{1,13918},{2,246273},{3,6632},{4,6474},{5,3292},{6,3266},{7,3223},{8,3335}]',1508083,'[{18020003,90}]','[{2,492}]',492),(1003,25,1,4470,'[{1,14275},{2,252592},{3,6802},{4,6640},{5,3376},{6,3350},{7,3306},{8,3420}]',1546742,'[{18020003,90}]','[{1,25}]',500),(1003,25,2,4470,'[{1,14635},{2,258978},{3,6974},{4,6808},{5,3462},{6,3434},{7,3389},{8,3507}]',1585828,'[{18020003,90}]','[{2,500}]',500),(1003,25,3,4470,'[{1,15000},{2,265431},{3,7148},{4,6978},{5,3548},{6,3520},{7,3474},{8,3594}]',1625381,'[{18020003,90}]','[{1,26}]',520),(1003,26,0,4870,'[{1,15379},{2,272128},{3,7328},{4,7154},{5,3637},{6,3609},{7,3561},{8,3685}]',1666358,'[{18020003,90}]','[{2,524}]',524),(1003,26,1,4870,'[{1,15761},{2,278892},{3,7510},{4,7332},{5,3728},{6,3698},{7,3650},{8,3776}]',1707762,'[{18020003,90}]','[{1,26}]',520),(1003,26,2,4870,'[{1,16147},{2,285725},{3,7694},{4,7512},{5,3819},{6,3789},{7,3739},{8,3869}]',1749615,'[{18020003,90}]','[{2,532}]',532),(1003,26,3,4870,'[{1,16537},{2,292623},{3,7880},{4,7694},{5,3912},{6,3880},{7,3830},{8,3962}]',1791913,'[{18020003,90}]','[{1,28}]',560),(1003,27,0,5320,'[{1,16941},{2,299775},{3,8073},{4,7881},{5,4007},{6,3975},{7,3923},{8,4059}]',1835645,'[{18020003,90}]','[{2,557}]',557),(1003,27,1,5320,'[{1,17349},{2,307002},{3,8267},{4,8071},{5,4103},{6,4071},{7,4018},{8,4156}]',1879832,'[{18020003,90}]','[{1,28}]',560),(1003,27,2,5320,'[{1,17762},{2,314305},{3,8463},{4,8263},{5,4201},{6,4167},{7,4113},{8,4255}]',1924495,'[{18020003,90}]','[{2,567}]',567),(1003,27,3,5320,'[{1,18179},{2,321684},{3,8662},{4,8456},{5,4299},{6,4265},{7,4209},{8,4355}]',1969614,'[{18020003,90}]','[{1,29}]',580),(1003,28,0,5770,'[{1,18611},{2,329323},{3,8867},{4,8657},{5,4402},{6,4366},{7,4309},{8,4459}]',2016443,'[{18020003,90}]','[{2,593}]',593),(1003,28,1,5770,'[{1,19047},{2,337038},{3,9075},{4,8859},{5,4505},{6,4469},{7,4411},{8,4563}]',2063728,'[{18020003,90}]','[{1,30}]',600),(1003,28,2,5770,'[{1,19487},{2,344829},{3,9284},{4,9064},{5,4609},{6,4573},{7,4513},{8,4669}]',2111469,'[{18020003,90}]','[{2,604}]',604),(1003,28,3,5770,'[{1,19932},{2,352696},{3,9496},{4,9270},{5,4715},{6,4677},{7,4616},{8,4776}]',2159686,'[{18020003,90}]','[{1,31}]',620),(1003,29,0,6270,'[{1,20391},{2,360831},{3,9715},{4,9485},{5,4823},{6,4785},{7,4722},{8,4886}]',2209451,'[{18020003,90}]','[{2,632}]',632),(1003,29,1,6270,'[{1,20855},{2,369043},{3,9937},{4,9701},{5,4933},{6,4893},{7,4829},{8,4997}]',2259693,'[{18020003,90}]','[{1,32}]',640),(1003,29,2,6270,'[{1,21323},{2,377331},{3,10160},{4,9920},{5,5043},{6,5003},{7,4938},{8,5108}]',2310391,'[{18020003,90}]','[{2,643}]',643),(1003,29,3,6270,'[{1,21795},{2,385693},{3,10386},{4,10140},{5,5155},{6,5113},{7,5047},{8,5221}]',2361543,'[{18020003,90}]','[{1,33}]',660),(1003,30,0,6770,'[{1,22283},{2,394334},{3,10619},{4,10367},{5,5270},{6,5228},{7,5160},{8,5338}]',2414444,'[{18020003,90}]','[{2,672}]',672),(1003,30,1,6770,'[{1,22775},{2,403051},{3,10854},{4,10596},{5,5386},{6,5344},{7,5274},{8,5456}]',2467801,'[{18020003,90}]','[{1,34}]',680),(1003,30,2,6770,'[{1,23272},{2,411843},{3,11091},{4,10827},{5,5504},{6,5460},{7,5389},{8,5575}]',2521633,'[{18020003,90}]','[{2,685}]',685),(1003,30,3,0,'[{1,23773},{2,420710},{3,11329},{4,11061},{5,5622},{6,5578},{7,5505},{8,5695}]',2575920,'[{18020003,90}]','[]',0),(1004,1,0,40,'[{1,401},{2,8112},{3,219},{4,185},{5,107},{6,95},{7,109},{8,93}]',46432,'[{18020001,10}]','[{2,34}]',34),(1004,1,1,40,'[{1,412},{2,8338},{3,225},{4,191},{5,110},{6,98},{7,112},{8,96}]',47778,'[{18020001,10}]','[{1,2}]',40),(1004,1,2,40,'[{1,422},{2,8567},{3,232},{4,196},{5,113},{6,101},{7,116},{8,98}]',49107,'[{18020001,10}]','[{2,35}]',35),(1004,1,3,40,'[{1,434},{2,8801},{3,238},{4,202},{5,116},{6,104},{7,119},{8,101}]',50481,'[{18020001,10}]','[{1,2}]',40),(1004,2,0,60,'[{1,448},{2,9081},{3,246},{4,208},{5,120},{6,106},{7,122},{8,104}]',51991,'[{18020001,10}]','[{2,42}]',42),(1004,2,1,60,'[{1,462},{2,9370},{3,253},{4,215},{5,124},{6,110},{7,126},{8,108}]',53710,'[{18020001,10}]','[{1,2}]',40),(1004,2,2,60,'[{1,477},{2,9668},{3,261},{4,221},{5,128},{6,114},{7,131},{8,111}]',55458,'[{18020001,10}]','[{2,45}]',45),(1004,2,3,60,'[{1,492},{2,9974},{3,269},{4,229},{5,132},{6,118},{7,135},{8,115}]',57264,'[{18020001,10}]','[{1,3}]',60),(1004,3,0,90,'[{1,510},{2,10335},{3,279},{4,237},{5,136},{6,122},{7,139},{8,119}]',59235,'[{18020001,10}]','[{2,50}]',50),(1004,3,1,90,'[{1,529},{2,10709},{3,289},{4,245},{5,142},{6,126},{7,145},{8,123}]',61439,'[{18020001,10}]','[{1,3}]',60),(1004,3,2,90,'[{1,548},{2,11096},{3,300},{4,254},{5,147},{6,131},{7,150},{8,128}]',63706,'[{18020001,10}]','[{2,55}]',55),(1004,3,3,90,'[{1,568},{2,11498},{3,311},{4,263},{5,152},{6,136},{7,156},{8,132}]',66008,'[{18020001,10}]','[{1,3}]',60),(1004,4,0,120,'[{1,590},{2,11961},{3,324},{4,274},{5,159},{6,141},{7,162},{8,138}]',68711,'[{18020001,10}]','[{2,61}]',61),(1004,4,1,120,'[{1,614},{2,12443},{3,337},{4,285},{5,165},{6,147},{7,168},{8,144}]',71473,'[{18020001,10}]','[{1,3}]',60),(1004,4,2,120,'[{1,639},{2,12943},{3,349},{4,297},{5,171},{6,153},{7,175},{8,149}]',74273,'[{18020001,10}]','[{2,64}]',64),(1004,4,3,120,'[{1,665},{2,13461},{3,364},{4,308},{5,178},{6,158},{7,181},{8,155}]',77161,'[{18020001,10}]','[{1,4}]',80),(1004,5,0,160,'[{1,694},{2,14052},{3,380},{4,322},{5,185},{6,165},{7,189},{8,161}]',80482,'[{18020001,10}]','[{2,73}]',73),(1004,5,1,160,'[{1,724},{2,14664},{3,396},{4,336},{5,194},{6,172},{7,198},{8,168}]',84044,'[{18020001,10}]','[{1,4}]',80),(1004,5,2,160,'[{1,755},{2,15300},{3,413},{4,351},{5,202},{6,180},{7,206},{8,176}]',87700,'[{18020001,10}]','[{2,76}]',76),(1004,5,3,160,'[{1,788},{2,15958},{3,431},{4,365},{5,211},{6,187},{7,215},{8,183}]',91418,'[{18020001,10}]','[{1,4}]',80),(1004,6,0,210,'[{1,825},{2,16698},{3,450},{4,382},{5,220},{6,196},{7,225},{8,191}]',95598,'[{18020001,10}]','[{2,84}]',84),(1004,6,1,210,'[{1,863},{2,17464},{3,471},{4,399},{5,231},{6,205},{7,235},{8,201}]',100074,'[{18020001,10}]','[{1,4}]',80),(1004,6,2,210,'[{1,902},{2,18257},{3,492},{4,418},{5,241},{6,215},{7,246},{8,210}]',104647,'[{18020001,10}]','[{2,87}]',87),(1004,6,3,210,'[{1,942},{2,19077},{3,514},{4,436},{5,252},{6,224},{7,257},{8,219}]',109267,'[{18020001,10}]','[{1,5}]',100),(1004,7,0,290,'[{1,987},{2,19987},{3,539},{4,457},{5,263},{6,235},{7,269},{8,229}]',114427,'[{18020001,10}]','[{2,97}]',97),(1004,7,1,290,'[{1,1034},{2,20929},{3,564},{4,478},{5,276},{6,246},{7,282},{8,240}]',119859,'[{18020001,10}]','[{1,5}]',100),(1004,7,2,290,'[{1,1081},{2,21903},{3,590},{4,500},{5,289},{6,257},{7,295},{8,251}]',125373,'[{18020001,10}]','[{2,101}]',101),(1004,7,3,290,'[{1,1131},{2,22908},{3,617},{4,523},{5,302},{6,268},{7,308},{8,262}]',131028,'[{18020001,10}]','[{1,5}]',100),(1004,8,0,390,'[{1,1186},{2,24012},{3,646},{4,548},{5,316},{6,282},{7,323},{8,275}]',137382,'[{18020001,10}]','[{2,111}]',111),(1004,8,1,390,'[{1,1242},{2,25148},{3,676},{4,574},{5,331},{6,295},{7,338},{8,288}]',143838,'[{18020001,10}]','[{1,6}]',120),(1004,8,2,390,'[{1,1299},{2,26315},{3,708},{4,600},{5,347},{6,309},{7,354},{8,302}]',150595,'[{18020001,10}]','[{2,116}]',116),(1004,8,3,390,'[{1,1359},{2,27514},{3,740},{4,628},{5,363},{6,323},{7,370},{8,316}]',157494,'[{18020001,10}]','[{1,6}]',120),(1004,9,0,510,'[{1,1423},{2,28821},{3,775},{4,657},{5,380},{6,338},{7,388},{8,330}]',164881,'[{18020001,10}]','[{2,126}]',126),(1004,9,1,510,'[{1,1490},{2,30164},{3,810},{4,688},{5,398},{6,354},{7,406},{8,346}]',172614,'[{18020001,10}]','[{1,6}]',120),(1004,9,2,510,'[{1,1559},{2,31543},{3,847},{4,719},{5,416},{6,370},{7,424},{8,362}]',180473,'[{18020001,10}]','[{2,131}]',131),(1004,9,3,510,'[{1,1628},{2,32959},{3,885},{4,751},{5,435},{6,387},{7,444},{8,378}]',188619,'[{18020001,10}]','[{1,7}]',140),(1004,10,0,650,'[{1,1704},{2,34491},{3,926},{4,786},{5,455},{6,405},{7,464},{8,396}]',197371,'[{18020001,10}]','[{2,142}]',142),(1004,10,1,650,'[{1,1781},{2,36059},{3,968},{4,822},{5,475},{6,423},{7,485},{8,413}]',206229,'[{18020001,10}]','[{1,7}]',140),(1004,10,2,650,'[{1,1861},{2,37664},{3,1012},{4,858},{5,496},{6,442},{7,507},{8,431}]',215434,'[{18020001,10}]','[{2,147}]',147),(1004,10,3,650,'[{1,1942},{2,39304},{3,1056},{4,896},{5,517},{6,461},{7,528},{8,450}]',224744,'[{18020001,10}]','[{1,8}]',160),(1004,11,0,810,'[{1,2030},{2,41071},{3,1104},{4,936},{5,541},{6,481},{7,552},{8,470}]',234871,'[{18020002,30}]','[{2,159}]',159),(1004,11,1,810,'[{1,2119},{2,42878},{3,1152},{4,978},{5,564},{6,502},{7,576},{8,490}]',245108,'[{18020002,30}]','[{1,8}]',160),(1004,11,2,810,'[{1,2211},{2,44726},{3,1202},{4,1020},{5,588},{6,524},{7,600},{8,512}]',255696,'[{18020002,30}]','[{2,163}]',163),(1004,11,3,810,'[{1,2304},{2,46614},{3,1253},{4,1063},{5,613},{6,545},{7,625},{8,533}]',266394,'[{18020002,30}]','[{1,9}]',180),(1004,12,0,970,'[{1,2404},{2,48638},{3,1307},{4,1109},{5,639},{6,569},{7,652},{8,556}]',277918,'[{18020002,30}]','[{2,176}]',176),(1004,12,1,970,'[{1,2507},{2,50702},{3,1362},{4,1156},{5,667},{6,593},{7,680},{8,580}]',289792,'[{18020002,30}]','[{1,9}]',180),(1004,12,2,970,'[{1,2611},{2,52807},{3,1419},{4,1203},{5,694},{6,618},{7,708},{8,604}]',301777,'[{18020002,30}]','[{2,181}]',181),(1004,12,3,970,'[{1,2718},{2,54952},{3,1476},{4,1252},{5,723},{6,643},{7,738},{8,628}]',314112,'[{18020002,30}]','[{1,10}]',200),(1004,13,0,1150,'[{1,2831},{2,57241},{3,1538},{4,1304},{5,752},{6,670},{7,768},{8,654}]',327111,'[{18020002,30}]','[{2,194}]',194),(1004,13,1,1150,'[{1,2946},{2,59576},{3,1600},{4,1358},{5,783},{6,697},{7,799},{8,681}]',340446,'[{18020002,30}]','[{1,10}]',200),(1004,13,2,1150,'[{1,3064},{2,61956},{3,1664},{4,1412},{5,815},{6,725},{7,832},{8,708}]',354136,'[{18020002,30}]','[{2,199}]',199),(1004,13,3,1150,'[{1,3184},{2,64380},{3,1729},{4,1467},{5,846},{6,754},{7,864},{8,736}]',367960,'[{18020002,30}]','[{1,11}]',220),(1004,14,0,1330,'[{1,3311},{2,66958},{3,1798},{4,1526},{5,880},{6,784},{7,899},{8,765}]',382678,'[{18020002,30}]','[{2,214}]',214),(1004,14,1,1330,'[{1,3440},{2,69581},{3,1869},{4,1585},{5,915},{6,815},{7,934},{8,796}]',397731,'[{18020002,30}]','[{1,11}]',220),(1004,14,2,1330,'[{1,3572},{2,72249},{3,1940},{4,1646},{5,950},{6,846},{7,970},{8,826}]',412939,'[{18020002,30}]','[{2,219}]',219),(1004,14,3,1330,'[{1,3707},{2,74962},{3,2013},{4,1707},{5,986},{6,878},{7,1007},{8,857}]',428502,'[{18020002,30}]','[{1,12}]',240),(1004,15,0,1540,'[{1,3849},{2,77837},{3,2089},{4,1773},{5,1024},{6,912},{7,1045},{8,891}]',444967,'[{18020002,30}]','[{2,234}]',234),(1004,15,1,1540,'[{1,3993},{2,80763},{3,2168},{4,1840},{5,1062},{6,946},{7,1084},{8,924}]',461623,'[{18020002,30}]','[{1,12}]',240),(1004,15,2,1540,'[{1,4140},{2,83737},{3,2248},{4,1908},{5,1101},{6,981},{7,1124},{8,958}]',478637,'[{18020002,30}]','[{2,241}]',241),(1004,15,3,1540,'[{1,4289},{2,86761},{3,2330},{4,1976},{5,1142},{6,1016},{7,1165},{8,993}]',495991,'[{18020002,30}]','[{1,13}]',260),(1004,16,0,1750,'[{1,4447},{2,89957},{3,2415},{4,2049},{5,1184},{6,1054},{7,1209},{8,1029}]',514297,'[{18020002,30}]','[{2,254}]',254),(1004,16,1,1750,'[{1,4607},{2,93202},{3,2503},{4,2123},{5,1226},{6,1092},{7,1252},{8,1066}]',532792,'[{18020002,30}]','[{1,13}]',260),(1004,16,2,1750,'[{1,4770},{2,96497},{3,2591},{4,2199},{5,1270},{6,1130},{7,1296},{8,1104}]',551647,'[{18020002,30}]','[{2,260}]',260),(1004,16,3,1750,'[{1,4935},{2,99840},{3,2681},{4,2275},{5,1314},{6,1170},{7,1341},{8,1143}]',570840,'[{18020002,30}]','[{1,14}]',280),(1004,17,0,1990,'[{1,5109},{2,103364},{3,2776},{4,2356},{5,1361},{6,1211},{7,1389},{8,1183}]',591044,'[{18020002,30}]','[{2,277}]',277),(1004,17,1,1990,'[{1,5286},{2,106939},{3,2873},{4,2437},{5,1407},{6,1253},{7,1436},{8,1224}]',611409,'[{18020002,30}]','[{1,14}]',280),(1004,17,2,1990,'[{1,5465},{2,110562},{3,2970},{4,2520},{5,1455},{6,1295},{7,1485},{8,1265}]',632112,'[{18020002,30}]','[{2,283}]',283),(1004,17,3,1990,'[{1,5647},{2,114235},{3,3069},{4,2603},{5,1503},{6,1339},{7,1535},{8,1307}]',653175,'[{18020002,30}]','[{1,15}]',300),(1004,18,0,2230,'[{1,5838},{2,118097},{3,3172},{4,2692},{5,1554},{6,1384},{7,1587},{8,1351}]',675257,'[{18020002,30}]','[{2,301}]',301),(1004,18,1,2230,'[{1,6032},{2,122014},{3,3277},{4,2781},{5,1606},{6,1430},{7,1639},{8,1397}]',697704,'[{18020002,30}]','[{1,15}]',300),(1004,18,2,2230,'[{1,6227},{2,125984},{3,3384},{4,2872},{5,1658},{6,1476},{7,1692},{8,1442}]',720324,'[{18020002,30}]','[{2,307}]',307),(1004,18,3,2230,'[{1,6426},{2,130009},{3,3493},{4,2963},{5,1711},{6,1523},{7,1746},{8,1488}]',743329,'[{18020002,30}]','[{1,16}]',320),(1004,19,0,2500,'[{1,6635},{2,134233},{3,3606},{4,3060},{5,1766},{6,1572},{7,1803},{8,1535}]',767383,'[{18020002,30}]','[{2,326}]',326),(1004,19,1,2500,'[{1,6847},{2,138510},{3,3721},{4,3157},{5,1822},{6,1622},{7,1860},{8,1584}]',791800,'[{18020002,30}]','[{1,16}]',320),(1004,19,2,2500,'[{1,7060},{2,142841},{3,3838},{4,3256},{5,1879},{6,1673},{7,1918},{8,1634}]',816591,'[{18020002,30}]','[{2,332}]',332),(1004,19,3,2500,'[{1,7277},{2,147226},{3,3956},{4,3356},{5,1936},{6,1724},{7,1976},{8,1684}]',841566,'[{18020002,30}]','[{1,17}]',340),(1004,20,0,2770,'[{1,7504},{2,151818},{3,4079},{4,3461},{5,1996},{6,1778},{7,2038},{8,1736}]',867798,'[{18020002,30}]','[{2,350}]',350),(1004,20,1,2770,'[{1,7733},{2,156469},{3,4205},{4,3567},{5,2058},{6,1832},{7,2101},{8,1789}]',894429,'[{18020002,30}]','[{1,18}]',360),(1004,20,2,2770,'[{1,7966},{2,161179},{3,4331},{4,3675},{5,2120},{6,1888},{7,2164},{8,1844}]',921449,'[{18020002,30}]','[{2,356}]',356),(1004,20,3,2770,'[{1,8201},{2,165948},{3,4459},{4,3783},{5,2183},{6,1943},{7,2228},{8,1898}]',948618,'[{18020002,30}]','[{1,19}]',380),(1004,21,0,3070,'[{1,8448},{2,170932},{3,4593},{4,3897},{5,2248},{6,2002},{7,2295},{8,1955}]',977142,'[{18020003,90}]','[{2,375}]',375),(1004,21,1,3070,'[{1,8698},{2,175976},{3,4728},{4,4012},{5,2315},{6,2061},{7,2363},{8,2013}]',1006036,'[{18020003,90}]','[{1,19}]',380),(1004,21,2,3070,'[{1,8950},{2,181077},{3,4866},{4,4128},{5,2382},{6,2120},{7,2431},{8,2071}]',1035127,'[{18020003,90}]','[{2,383}]',383),(1004,21,3,3070,'[{1,9204},{2,186238},{3,5004},{4,4246},{5,2449},{6,2181},{7,2500},{8,2130}]',1064568,'[{18020003,90}]','[{1,20}]',400),(1004,22,0,3370,'[{1,9471},{2,191624},{3,5149},{4,4369},{5,2520},{6,2244},{7,2573},{8,2191}]',1095394,'[{18020003,90}]','[{2,402}]',402),(1004,22,1,3370,'[{1,9740},{2,197072},{3,5295},{4,4493},{5,2592},{6,2308},{7,2646},{8,2254}]',1126572,'[{18020003,90}]','[{1,20}]',400),(1004,22,2,3370,'[{1,10013},{2,202584},{3,5444},{4,4618},{5,2664},{6,2372},{7,2719},{8,2317}]',1157994,'[{18020003,90}]','[{2,409}]',409),(1004,22,3,3370,'[{1,10288},{2,208160},{3,5594},{4,4746},{5,2737},{6,2437},{7,2794},{8,2380}]',1189820,'[{18020003,90}]','[{1,21}]',420),(1004,23,0,3720,'[{1,10575},{2,213969},{3,5750},{4,4878},{5,2813},{6,2505},{7,2872},{8,2446}]',1222969,'[{18020003,90}]','[{2,431}]',431),(1004,23,1,3720,'[{1,10865},{2,219841},{3,5908},{4,5012},{5,2890},{6,2574},{7,2951},{8,2513}]',1256541,'[{18020003,90}]','[{1,22}]',440),(1004,23,2,3720,'[{1,11159},{2,225777},{3,6068},{4,5148},{5,2969},{6,2643},{7,3030},{8,2582}]',1290557,'[{18020003,90}]','[{2,438}]',438),(1004,23,3,3720,'[{1,11455},{2,231775},{3,6229},{4,5285},{5,3048},{6,2714},{7,3111},{8,2651}]',1324925,'[{18020003,90}]','[{1,23}]',460),(1004,24,0,4070,'[{1,11763},{2,238018},{3,6397},{4,5427},{5,3131},{6,2787},{7,3196},{8,2722}]',1360678,'[{18020003,90}]','[{2,460}]',460),(1004,24,1,4070,'[{1,12075},{2,244327},{3,6567},{4,5571},{5,3213},{6,2861},{7,3280},{8,2794}]',1396677,'[{18020003,90}]','[{1,23}]',460),(1004,24,2,4070,'[{1,12390},{2,250704},{3,6738},{4,5716},{5,3297},{6,2935},{7,3365},{8,2867}]',1433054,'[{18020003,90}]','[{2,467}]',467),(1004,24,3,4070,'[{1,12708},{2,257149},{3,6911},{4,5863},{5,3381},{6,3011},{7,3452},{8,2940}]',1469859,'[{18020003,90}]','[{1,24}]',480),(1004,25,0,4470,'[{1,13039},{2,263846},{3,7090},{4,6016},{5,3469},{6,3089},{7,3541},{8,3017}]',1508076,'[{18020003,90}]','[{2,490}]',490),(1004,25,1,4470,'[{1,13373},{2,270615},{3,7272},{4,6170},{5,3558},{6,3168},{7,3632},{8,3094}]',1546725,'[{18020003,90}]','[{1,25}]',500),(1004,25,2,4470,'[{1,13711},{2,277457},{3,7456},{4,6326},{5,3648},{6,3248},{7,3724},{8,3172}]',1585827,'[{18020003,90}]','[{2,500}]',500),(1004,25,3,4470,'[{1,14053},{2,284370},{3,7642},{4,6484},{5,3739},{6,3329},{7,3817},{8,3251}]',1625380,'[{18020003,90}]','[{1,26}]',520),(1004,26,0,4870,'[{1,14408},{2,291545},{3,7835},{4,6647},{5,3833},{6,3413},{7,3913},{8,3333}]',1666355,'[{18020003,90}]','[{2,524}]',524),(1004,26,1,4870,'[{1,14766},{2,298792},{3,8030},{4,6812},{5,3928},{6,3498},{7,4010},{8,3416}]',1707762,'[{18020003,90}]','[{1,26}]',520),(1004,26,2,4870,'[{1,15128},{2,306112},{3,8226},{4,6980},{5,4025},{6,3583},{7,4108},{8,3500}]',1749622,'[{18020003,90}]','[{2,533}]',533),(1004,26,3,4870,'[{1,15492},{2,313503},{3,8426},{4,7148},{5,4122},{6,3670},{7,4208},{8,3584}]',1791893,'[{18020003,90}]','[{1,28}]',560),(1004,27,0,5320,'[{1,15871},{2,321164},{3,8631},{4,7323},{5,4222},{6,3760},{7,4310},{8,3672}]',1835634,'[{18020003,90}]','[{2,558}]',558),(1004,27,1,5320,'[{1,16254},{2,328908},{3,8839},{4,7499},{5,4324},{6,3850},{7,4414},{8,3760}]',1879838,'[{18020003,90}]','[{1,28}]',560),(1004,27,2,5320,'[{1,16641},{2,336731},{3,9049},{4,7677},{5,4427},{6,3941},{7,4519},{8,3849}]',1924501,'[{18020003,90}]','[{2,566}]',566),(1004,27,3,5320,'[{1,17031},{2,344636},{3,9261},{4,7857},{5,4530},{6,4034},{7,4625},{8,3939}]',1969606,'[{18020003,90}]','[{1,29}]',580),(1004,28,0,5770,'[{1,17436},{2,352821},{3,9480},{4,8044},{5,4638},{6,4130},{7,4735},{8,4033}]',2016441,'[{18020003,90}]','[{2,593}]',593),(1004,28,1,5770,'[{1,17844},{2,361087},{3,9702},{4,8232},{5,4747},{6,4227},{7,4846},{8,4128}]',2063717,'[{18020003,90}]','[{1,30}]',600),(1004,28,2,5770,'[{1,18257},{2,369433},{3,9926},{4,8422},{5,4857},{6,4325},{7,4958},{8,4224}]',2111473,'[{18020003,90}]','[{2,603}]',603),(1004,28,3,5770,'[{1,18673},{2,377862},{3,10152},{4,8614},{5,4968},{6,4424},{7,5072},{8,4320}]',2159672,'[{18020003,90}]','[{1,31}]',620),(1004,29,0,6270,'[{1,19104},{2,386578},{3,10387},{4,8813},{5,5083},{6,4525},{7,5188},{8,4420}]',2209458,'[{18020003,90}]','[{2,632}]',632),(1004,29,1,6270,'[{1,19538},{2,395375},{3,10624},{4,9014},{5,5198},{6,4628},{7,5306},{8,4520}]',2259685,'[{18020003,90}]','[{1,32}]',640),(1004,29,2,6270,'[{1,19976},{2,404254},{3,10863},{4,9217},{5,5314},{6,4732},{7,5425},{8,4621}]',2310374,'[{18020003,90}]','[{2,644}]',644),(1004,29,3,6270,'[{1,20419},{2,413213},{3,11105},{4,9421},{5,5432},{6,4836},{7,5545},{8,4723}]',2361543,'[{18020003,90}]','[{1,33}]',660),(1004,30,0,6770,'[{1,20876},{2,422471},{3,11353},{4,9633},{5,5553},{6,4945},{7,5669},{8,4829}]',2414441,'[{18020003,90}]','[{2,673}]',673),(1004,30,1,6770,'[{1,21337},{2,431809},{3,11604},{4,9846},{5,5676},{6,5054},{7,5794},{8,4936}]',2467799,'[{18020003,90}]','[{1,34}]',680),(1004,30,2,6770,'[{1,21802},{2,441229},{3,11858},{4,10060},{5,5800},{6,5164},{7,5921},{8,5043}]',2521619,'[{18020003,90}]','[{2,686}]',686),(1004,30,3,0,'[{1,22272},{2,450729},{3,12113},{4,10277},{5,5925},{6,5275},{7,6048},{8,5152}]',2575919,'[{18020003,90}]','[]',0),(1005,1,0,40,'[{1,439},{2,7346},{3,213},{4,191},{5,97},{6,105},{7,100},{8,102}]',46426,'[{18020001,10}]','[{2,35}]',35),(1005,1,1,40,'[{1,451},{2,7550},{3,219},{4,197},{5,100},{6,108},{7,103},{8,105}]',47770,'[{18020001,10}]','[{1,2}]',40),(1005,1,2,40,'[{1,463},{2,7758},{3,225},{4,203},{5,103},{6,111},{7,106},{8,108}]',49118,'[{18020001,10}]','[{2,37}]',37),(1005,1,3,40,'[{1,476},{2,7970},{3,232},{4,208},{5,106},{6,114},{7,109},{8,111}]',50490,'[{18020001,10}]','[{1,2}]',40),(1005,2,0,60,'[{1,491},{2,8224},{3,239},{4,215},{5,109},{6,117},{7,112},{8,114}]',51994,'[{18020001,10}]','[{2,42}]',42),(1005,2,1,60,'[{1,506},{2,8485},{3,246},{4,222},{5,113},{6,121},{7,116},{8,118}]',53705,'[{18020001,10}]','[{1,2}]',40),(1005,2,2,60,'[{1,523},{2,8755},{3,254},{4,228},{5,116},{6,126},{7,120},{8,122}]',55465,'[{18020001,10}]','[{2,45}]',45),(1005,2,3,60,'[{1,539},{2,9033},{3,262},{4,236},{5,120},{6,130},{7,124},{8,127}]',57313,'[{18020001,10}]','[{1,2}]',40),(1005,3,0,90,'[{1,559},{2,9359},{3,272},{4,244},{5,124},{6,134},{7,127},{8,131}]',59239,'[{18020001,10}]','[{2,52}]',52),(1005,3,1,90,'[{1,579},{2,9698},{3,281},{4,253},{5,129},{6,139},{7,132},{8,136}]',61428,'[{18020001,10}]','[{1,3}]',60),(1005,3,2,90,'[{1,600},{2,10048},{3,292},{4,262},{5,134},{6,144},{7,137},{8,141}]',63698,'[{18020001,10}]','[{2,54}]',54),(1005,3,3,90,'[{1,622},{2,10412},{3,302},{4,272},{5,139},{6,149},{7,142},{8,146}]',66002,'[{18020001,10}]','[{1,3}]',60),(1005,4,0,120,'[{1,647},{2,10832},{3,315},{4,283},{5,144},{6,156},{7,148},{8,152}]',68722,'[{18020001,10}]','[{2,60}]',60),(1005,4,1,120,'[{1,673},{2,11268},{3,327},{4,295},{5,150},{6,162},{7,154},{8,158}]',71478,'[{18020001,10}]','[{1,3}]',60),(1005,4,2,120,'[{1,700},{2,11721},{3,340},{4,306},{5,156},{6,168},{7,160},{8,164}]',74271,'[{18020001,10}]','[{2,65}]',65),(1005,4,3,120,'[{1,729},{2,12190},{3,354},{4,318},{5,162},{6,174},{7,166},{8,170}]',77170,'[{18020001,10}]','[{1,4}]',80),(1005,5,0,160,'[{1,760},{2,12725},{3,370},{4,332},{5,168},{6,182},{7,173},{8,177}]',80475,'[{18020001,10}]','[{2,72}]',72),(1005,5,1,160,'[{1,793},{2,13280},{3,385},{4,347},{5,176},{6,190},{7,181},{8,185}]',84040,'[{18020001,10}]','[{1,4}]',80),(1005,5,2,160,'[{1,828},{2,13855},{3,402},{4,362},{5,184},{6,198},{7,189},{8,193}]',87715,'[{18020001,10}]','[{2,76}]',76),(1005,5,3,160,'[{1,864},{2,14451},{3,419},{4,377},{5,191},{6,207},{7,197},{8,201}]',91431,'[{18020001,10}]','[{1,4}]',80),(1005,6,0,210,'[{1,904},{2,15121},{3,438},{4,394},{5,200},{6,216},{7,206},{8,210}]',95601,'[{18020001,10}]','[{2,84}]',84),(1005,6,1,210,'[{1,945},{2,15815},{3,458},{4,412},{5,210},{6,226},{7,215},{8,221}]',100065,'[{18020001,10}]','[{1,4}]',80),(1005,6,2,210,'[{1,988},{2,16533},{3,479},{4,431},{5,219},{6,237},{7,225},{8,231}]',104643,'[{18020001,10}]','[{2,88}]',88),(1005,6,3,210,'[{1,1032},{2,17275},{3,500},{4,450},{5,229},{6,247},{7,235},{8,241}]',109265,'[{18020001,10}]','[{1,5}]',100),(1005,7,0,290,'[{1,1081},{2,18100},{3,524},{4,472},{5,240},{6,258},{7,246},{8,252}]',114420,'[{18020001,10}]','[{2,97}]',97),(1005,7,1,290,'[{1,1133},{2,18952},{3,549},{4,493},{5,251},{6,271},{7,258},{8,264}]',119862,'[{18020001,10}]','[{1,5}]',100),(1005,7,2,290,'[{1,1185},{2,19834},{3,574},{4,516},{5,263},{6,283},{7,270},{8,276}]',125384,'[{18020001,10}]','[{2,101}]',101),(1005,7,3,290,'[{1,1239},{2,20744},{3,600},{4,540},{5,274},{6,296},{7,282},{8,288}]',131024,'[{18020001,10}]','[{1,5}]',100),(1005,8,0,390,'[{1,1299},{2,21745},{3,629},{4,565},{5,288},{6,310},{7,295},{8,303}]',137375,'[{18020001,10}]','[{2,112}]',112),(1005,8,1,390,'[{1,1360},{2,22773},{3,658},{4,592},{5,301},{6,325},{7,309},{8,317}]',143823,'[{18020001,10}]','[{1,6}]',120),(1005,8,2,390,'[{1,1423},{2,23830},{3,689},{4,619},{5,316},{6,340},{7,324},{8,332}]',150590,'[{18020001,10}]','[{2,116}]',116),(1005,8,3,390,'[{1,1489},{2,24916},{3,720},{4,648},{5,330},{6,356},{7,339},{8,347}]',157496,'[{18020001,10}]','[{1,6}]',120),(1005,9,0,510,'[{1,1559},{2,26099},{3,754},{4,678},{5,345},{6,373},{7,355},{8,363}]',164879,'[{18020001,10}]','[{2,127}]',127),(1005,9,1,510,'[{1,1632},{2,27315},{3,789},{4,709},{5,362},{6,390},{7,371},{8,381}]',172605,'[{18020001,10}]','[{1,6}]',120),(1005,9,2,510,'[{1,1708},{2,28564},{3,824},{4,742},{5,378},{6,408},{7,388},{8,398}]',180474,'[{18020001,10}]','[{2,131}]',131),(1005,9,3,510,'[{1,1784},{2,29846},{3,861},{4,775},{5,395},{6,427},{7,406},{8,416}]',188626,'[{18020001,10}]','[{1,7}]',140),(1005,10,0,650,'[{1,1867},{2,31234},{3,901},{4,811},{5,414},{6,446},{7,425},{8,435}]',197374,'[{18020001,10}]','[{2,143}]',143),(1005,10,1,650,'[{1,1951},{2,32654},{3,942},{4,848},{5,432},{6,466},{7,444},{8,454}]',206224,'[{18020001,10}]','[{1,7}]',140),(1005,10,2,650,'[{1,2039},{2,34107},{3,985},{4,885},{5,451},{6,487},{7,463},{8,475}]',215437,'[{18020001,10}]','[{2,147}]',147),(1005,10,3,650,'[{1,2128},{2,35593},{3,1028},{4,924},{5,470},{6,508},{7,483},{8,495}]',224753,'[{18020001,10}]','[{1,8}]',160),(1005,11,0,810,'[{1,2224},{2,37192},{3,1074},{4,966},{5,492},{6,530},{7,505},{8,517}]',234872,'[{18020002,30}]','[{2,159}]',159),(1005,11,1,810,'[{1,2322},{2,38829},{3,1121},{4,1009},{5,513},{6,553},{7,527},{8,539}]',245119,'[{18020002,30}]','[{1,8}]',160),(1005,11,2,810,'[{1,2422},{2,40502},{3,1170},{4,1052},{5,535},{6,577},{7,549},{8,563}]',255692,'[{18020002,30}]','[{2,163}]',163),(1005,11,3,810,'[{1,2524},{2,42212},{3,1219},{4,1097},{5,557},{6,601},{7,572},{8,586}]',266392,'[{18020002,30}]','[{1,9}]',180),(1005,12,0,970,'[{1,2634},{2,44045},{3,1272},{4,1144},{5,581},{6,627},{7,597},{8,611}]',277925,'[{18020002,30}]','[{2,176}]',176),(1005,12,1,970,'[{1,2746},{2,45914},{3,1326},{4,1192},{5,606},{6,654},{7,622},{8,638}]',289784,'[{18020002,30}]','[{1,9}]',180),(1005,12,2,970,'[{1,2861},{2,47820},{3,1380},{4,1242},{5,631},{6,681},{7,648},{8,664}]',301790,'[{18020002,30}]','[{2,181}]',181),(1005,12,3,970,'[{1,2977},{2,49762},{3,1436},{4,1292},{5,657},{6,709},{7,675},{8,691}]',314102,'[{18020002,30}]','[{1,10}]',200),(1005,13,0,1150,'[{1,3101},{2,51836},{3,1496},{4,1346},{5,684},{6,738},{7,702},{8,720}]',327106,'[{18020002,30}]','[{2,195}]',195),(1005,13,1,1150,'[{1,3228},{2,53950},{3,1557},{4,1401},{5,712},{6,768},{7,731},{8,749}]',340460,'[{18020002,30}]','[{1,10}]',200),(1005,13,2,1150,'[{1,3356},{2,56105},{3,1620},{4,1456},{5,741},{6,799},{7,761},{8,779}]',354125,'[{18020002,30}]','[{2,199}]',199),(1005,13,3,1150,'[{1,3488},{2,58300},{3,1683},{4,1513},{5,770},{6,830},{7,790},{8,810}]',367960,'[{18020002,30}]','[{1,11}]',220),(1005,14,0,1330,'[{1,3627},{2,60635},{3,1750},{4,1574},{5,800},{6,864},{7,822},{8,842}]',382675,'[{18020002,30}]','[{2,213}]',213),(1005,14,1,1330,'[{1,3769},{2,63010},{3,1819},{4,1635},{5,832},{6,898},{7,855},{8,875}]',397740,'[{18020002,30}]','[{1,11}]',220),(1005,14,2,1330,'[{1,3914},{2,65426},{3,1888},{4,1698},{5,864},{6,932},{7,887},{8,909}]',412956,'[{18020002,30}]','[{2,219}]',219),(1005,14,3,1330,'[{1,4061},{2,67883},{3,1959},{4,1761},{5,897},{6,967},{7,921},{8,943}]',428503,'[{18020002,30}]','[{1,12}]',240),(1005,15,0,1540,'[{1,4217},{2,70487},{3,2033},{4,1829},{5,931},{6,1005},{7,956},{8,980}]',444977,'[{18020002,30}]','[{2,234}]',234),(1005,15,1,1540,'[{1,4375},{2,73136},{3,2110},{4,1898},{5,966},{6,1042},{7,992},{8,1016}]',461636,'[{18020002,30}]','[{1,12}]',240),(1005,15,2,1540,'[{1,4536},{2,75830},{3,2188},{4,1968},{5,1001},{6,1081},{7,1029},{8,1053}]',478650,'[{18020002,30}]','[{2,239}]',239),(1005,15,3,1540,'[{1,4699},{2,78568},{3,2267},{4,2039},{5,1038},{6,1120},{7,1066},{8,1092}]',495998,'[{18020002,30}]','[{1,13}]',260),(1005,16,0,1750,'[{1,4872},{2,81462},{3,2350},{4,2114},{5,1076},{6,1162},{7,1106},{8,1132}]',514302,'[{18020002,30}]','[{2,255}]',255),(1005,16,1,1750,'[{1,5048},{2,84401},{3,2436},{4,2190},{5,1115},{6,1203},{7,1145},{8,1173}]',532811,'[{18020002,30}]','[{1,13}]',260),(1005,16,2,1750,'[{1,5226},{2,87384},{3,2522},{4,2268},{5,1154},{6,1246},{7,1186},{8,1214}]',551654,'[{18020002,30}]','[{2,262}]',262),(1005,16,3,1750,'[{1,5407},{2,90412},{3,2609},{4,2347},{5,1195},{6,1289},{7,1227},{8,1257}]',570852,'[{18020002,30}]','[{1,14}]',280),(1005,17,0,1990,'[{1,5597},{2,93603},{3,2702},{4,2430},{5,1237},{6,1335},{7,1271},{8,1301}]',591043,'[{18020002,30}]','[{2,278}]',278),(1005,17,1,1990,'[{1,5791},{2,96840},{3,2796},{4,2514},{5,1279},{6,1381},{7,1314},{8,1346}]',611410,'[{18020002,30}]','[{1,14}]',280),(1005,17,2,1990,'[{1,5987},{2,100122},{3,2890},{4,2600},{5,1323},{6,1427},{7,1359},{8,1392}]',632162,'[{18020002,30}]','[{2,284}]',284),(1005,17,3,1990,'[{1,6187},{2,103448},{3,2986},{4,2686},{5,1367},{6,1475},{7,1404},{8,1438}]',653188,'[{18020002,30}]','[{1,15}]',300),(1005,18,0,2230,'[{1,6396},{2,106945},{3,3087},{4,2777},{5,1413},{6,1525},{7,1451},{8,1487}]',675265,'[{18020002,30}]','[{2,301}]',301),(1005,18,1,2230,'[{1,6608},{2,110492},{3,3190},{4,2868},{5,1460},{6,1576},{7,1500},{8,1536}]',697702,'[{18020002,30}]','[{1,15}]',300),(1005,18,2,2230,'[{1,6823},{2,114087},{3,3294},{4,2962},{5,1507},{6,1627},{7,1548},{8,1586}]',720347,'[{18020002,30}]','[{2,307}]',307),(1005,18,3,2230,'[{1,7040},{2,117732},{3,3399},{4,3057},{5,1556},{6,1678},{7,1598},{8,1636}]',743332,'[{18020002,30}]','[{1,16}]',320),(1005,19,0,2500,'[{1,7269},{2,121557},{3,3510},{4,3156},{5,1606},{6,1732},{7,1649},{8,1689}]',767387,'[{18020002,30}]','[{2,325}]',325),(1005,19,1,2500,'[{1,7501},{2,125430},{3,3621},{4,3257},{5,1657},{6,1787},{7,1701},{8,1743}]',791800,'[{18020002,30}]','[{1,16}]',320),(1005,19,2,2500,'[{1,7735},{2,129352},{3,3735},{4,3359},{5,1709},{6,1843},{7,1755},{8,1797}]',816602,'[{18020002,30}]','[{2,331}]',331),(1005,19,3,2500,'[{1,7973},{2,133323},{3,3850},{4,3462},{5,1760},{6,1900},{7,1808},{8,1852}]',841583,'[{18020002,30}]','[{1,17}]',340),(1005,20,0,2770,'[{1,8221},{2,137482},{3,3970},{4,3570},{5,1815},{6,1959},{7,1864},{8,1910}]',867802,'[{18020002,30}]','[{2,349}]',349),(1005,20,1,2770,'[{1,8472},{2,141693},{3,4092},{4,3680},{5,1871},{6,2019},{7,1922},{8,1968}]',894433,'[{18020002,30}]','[{1,18}]',360),(1005,20,2,2770,'[{1,8727},{2,145959},{3,4215},{4,3791},{5,1928},{6,2080},{7,1980},{8,2028}]',921449,'[{18020002,30}]','[{2,355}]',355),(1005,20,3,2770,'[{1,8985},{2,150277},{3,4339},{4,3903},{5,1985},{6,2141},{7,2038},{8,2088}]',948627,'[{18020002,30}]','[{1,19}]',380),(1005,21,0,3070,'[{1,9255},{2,154791},{3,4470},{4,4020},{5,2044},{6,2206},{7,2100},{8,2151}]',977191,'[{18020003,90}]','[{2,376}]',376),(1005,21,1,3070,'[{1,9529},{2,159358},{3,4602},{4,4138},{5,2105},{6,2271},{7,2162},{8,2214}]',1006038,'[{18020003,90}]','[{1,19}]',380),(1005,21,2,3070,'[{1,9805},{2,163977},{3,4735},{4,4259},{5,2165},{6,2337},{7,2224},{8,2278}]',1035127,'[{18020003,90}]','[{2,381}]',381),(1005,21,3,3070,'[{1,10084},{2,168651},{3,4870},{4,4380},{5,2227},{6,2403},{7,2287},{8,2343}]',1064581,'[{18020003,90}]','[{1,20}]',400),(1005,22,0,3370,'[{1,10376},{2,173528},{3,5011},{4,4507},{5,2291},{6,2473},{7,2353},{8,2411}]',1095398,'[{18020003,90}]','[{2,403}]',403),(1005,22,1,3370,'[{1,10671},{2,178462},{3,5153},{4,4635},{5,2357},{6,2543},{7,2421},{8,2479}]',1126582,'[{18020003,90}]','[{1,20}]',400),(1005,22,2,3370,'[{1,10969},{2,183454},{3,5298},{4,4764},{5,2422},{6,2614},{7,2488},{8,2548}]',1157984,'[{18020003,90}]','[{2,409}]',409),(1005,22,3,3370,'[{1,11271},{2,188502},{3,5444},{4,4896},{5,2489},{6,2685},{7,2556},{8,2618}]',1189822,'[{18020003,90}]','[{1,21}]',420),(1005,23,0,3720,'[{1,11586},{2,193763},{3,5596},{4,5032},{5,2558},{6,2760},{7,2627},{8,2691}]',1222983,'[{18020003,90}]','[{2,431}]',431),(1005,23,1,3720,'[{1,11904},{2,199081},{3,5749},{4,5171},{5,2628},{6,2836},{7,2699},{8,2765}]',1256561,'[{18020003,90}]','[{1,22}]',440),(1005,23,2,3720,'[{1,12225},{2,204456},{3,5905},{4,5311},{5,2699},{6,2913},{7,2772},{8,2840}]',1290556,'[{18020003,90}]','[{2,438}]',438),(1005,23,3,3720,'[{1,12550},{2,209888},{3,6062},{4,5452},{5,2772},{6,2990},{7,2846},{8,2916}]',1324938,'[{18020003,90}]','[{1,23}]',460),(1005,24,0,4070,'[{1,12887},{2,215541},{3,6225},{4,5599},{5,2847},{6,3071},{7,2923},{8,2995}]',1360681,'[{18020003,90}]','[{2,461}]',461),(1005,24,1,4070,'[{1,13229},{2,221255},{3,6391},{4,5747},{5,2922},{6,3152},{7,3001},{8,3073}]',1396685,'[{18020003,90}]','[{1,23}]',460),(1005,24,2,4070,'[{1,13574},{2,227029},{3,6557},{4,5897},{5,2998},{6,3234},{7,3079},{8,3153}]',1433059,'[{18020003,90}]','[{2,469}]',469),(1005,24,3,4070,'[{1,13923},{2,232865},{3,6726},{4,6048},{5,3075},{6,3317},{7,3158},{8,3234}]',1469875,'[{18020003,90}]','[{1,24}]',480),(1005,25,0,4470,'[{1,14286},{2,238930},{3,6900},{4,6206},{5,3154},{6,3404},{7,3240},{8,3318}]',1508100,'[{18020003,90}]','[{2,491}]',491),(1005,25,1,4470,'[{1,14651},{2,245060},{3,7077},{4,6365},{5,3235},{6,3491},{7,3323},{8,3403}]',1546730,'[{18020003,90}]','[{1,25}]',500),(1005,25,2,4470,'[{1,15022},{2,251256},{3,7256},{4,6526},{5,3317},{6,3579},{7,3407},{8,3489}]',1585846,'[{18020003,90}]','[{2,500}]',500),(1005,25,3,4470,'[{1,15396},{2,257516},{3,7437},{4,6689},{5,3400},{6,3668},{7,3492},{8,3576}]',1625386,'[{18020003,90}]','[{1,26}]',520),(1005,26,0,4870,'[{1,15785},{2,264013},{3,7625},{4,6857},{5,3485},{6,3761},{7,3580},{8,3666}]',1666363,'[{18020003,90}]','[{2,524}]',524),(1005,26,1,4870,'[{1,16177},{2,270576},{3,7814},{4,7028},{5,3572},{6,3854},{7,3668},{8,3758}]',1707766,'[{18020003,90}]','[{1,26}]',520),(1005,26,2,4870,'[{1,16573},{2,277205},{3,8006},{4,7200},{5,3659},{6,3949},{7,3758},{8,3850}]',1749615,'[{18020003,90}]','[{2,533}]',533),(1005,26,3,4870,'[{1,16973},{2,283898},{3,8200},{4,7374},{5,3748},{6,4044},{7,3849},{8,3943}]',1791908,'[{18020003,90}]','[{1,28}]',560),(1005,27,0,5320,'[{1,17388},{2,290836},{3,8400},{4,7554},{5,3839},{6,4143},{7,3943},{8,4039}]',1835646,'[{18020003,90}]','[{2,558}]',558),(1005,27,1,5320,'[{1,17807},{2,297848},{3,8602},{4,7736},{5,3932},{6,4242},{7,4038},{8,4136}]',1879838,'[{18020003,90}]','[{1,28}]',560),(1005,27,2,5320,'[{1,18231},{2,304933},{3,8806},{4,7920},{5,4025},{6,4343},{7,4134},{8,4234}]',1924503,'[{18020003,90}]','[{2,568}]',568),(1005,27,3,5320,'[{1,18659},{2,312091},{3,9013},{4,8105},{5,4119},{6,4445},{7,4231},{8,4333}]',1969621,'[{18020003,90}]','[{1,29}]',580),(1005,28,0,5770,'[{1,19102},{2,319503},{3,9226},{4,8298},{5,4217},{6,4551},{7,4331},{8,4437}]',2016443,'[{18020003,90}]','[{2,593}]',593),(1005,28,1,5770,'[{1,19550},{2,326988},{3,9442},{4,8492},{5,4316},{6,4658},{7,4433},{8,4541}]',2063738,'[{18020003,90}]','[{1,30}]',600),(1005,28,2,5770,'[{1,20002},{2,334547},{3,9660},{4,8688},{5,4417},{6,4765},{7,4536},{8,4646}]',2111487,'[{18020003,90}]','[{2,603}]',603),(1005,28,3,5770,'[{1,20458},{2,342179},{3,9880},{4,8886},{5,4518},{6,4874},{7,4640},{8,4752}]',2159689,'[{18020003,90}]','[{1,31}]',620),(1005,29,0,6270,'[{1,20929},{2,350072},{3,10109},{4,9091},{5,4621},{6,4987},{7,4746},{8,4862}]',2209452,'[{18020003,90}]','[{2,631}]',631),(1005,29,1,6270,'[{1,21405},{2,358038},{3,10339},{4,9299},{5,4726},{6,5100},{7,4854},{8,4972}]',2259688,'[{18020003,90}]','[{1,32}]',640),(1005,29,2,6270,'[{1,21886},{2,366079},{3,10572},{4,9508},{5,4832},{6,5214},{7,4963},{8,5083}]',2310399,'[{18020003,90}]','[{2,644}]',644),(1005,29,3,6270,'[{1,22370},{2,374192},{3,10807},{4,9719},{5,4939},{6,5329},{7,5072},{8,5196}]',2361542,'[{18020003,90}]','[{1,33}]',660),(1005,30,0,6770,'[{1,22871},{2,382575},{3,11049},{4,9937},{5,5050},{6,5448},{7,5186},{8,5312}]',2414445,'[{18020003,90}]','[{2,672}]',672),(1005,30,1,6770,'[{1,23376},{2,391032},{3,11293},{4,10157},{5,5161},{6,5569},{7,5301},{8,5429}]',2467802,'[{18020003,90}]','[{1,34}]',680),(1005,30,2,6770,'[{1,23886},{2,399562},{3,11540},{4,10378},{5,5274},{6,5690},{7,5416},{8,5548}]',2521632,'[{18020003,90}]','[{2,686}]',686),(1005,30,3,0,'[{1,24400},{2,408165},{3,11788},{4,10602},{5,5387},{6,5813},{7,5533},{8,5667}]',2575915,'[{18020003,90}]','[]',0),(1006,1,0,40,'[{1,417},{2,7790},{3,204},{4,200},{5,109},{6,93},{7,102},{8,100}]',46430,'[{18020001,10}]','[{2,34}]',34),(1006,1,1,40,'[{1,428},{2,8006},{3,210},{4,206},{5,113},{6,95},{7,105},{8,103}]',47766,'[{18020001,10}]','[{1,2}]',40),(1006,1,2,40,'[{1,439},{2,8226},{3,216},{4,212},{5,116},{6,98},{7,108},{8,106}]',49106,'[{18020001,10}]','[{2,37}]',37),(1006,1,3,40,'[{1,452},{2,8452},{3,222},{4,218},{5,119},{6,101},{7,111},{8,109}]',50492,'[{18020001,10}]','[{1,2}]',40),(1006,2,0,60,'[{1,466},{2,8720},{3,229},{4,225},{5,122},{6,104},{7,114},{8,112}]',51990,'[{18020001,10}]','[{2,42}]',42),(1006,2,1,60,'[{1,481},{2,8997},{3,236},{4,232},{5,127},{6,107},{7,118},{8,116}]',53717,'[{18020001,10}]','[{1,2}]',40),(1006,2,2,60,'[{1,496},{2,9283},{3,243},{4,239},{5,131},{6,111},{7,122},{8,120}]',55453,'[{18020001,10}]','[{2,46}]',46),(1006,2,3,60,'[{1,512},{2,9578},{3,251},{4,247},{5,135},{6,115},{7,126},{8,124}]',57268,'[{18020001,10}]','[{1,3}]',60),(1006,3,0,90,'[{1,530},{2,9924},{3,261},{4,255},{5,140},{6,118},{7,130},{8,128}]',59224,'[{18020001,10}]','[{2,51}]',51),(1006,3,1,90,'[{1,550},{2,10283},{3,270},{4,264},{5,145},{6,123},{7,135},{8,133}]',61433,'[{18020001,10}]','[{1,3}]',60),(1006,3,2,90,'[{1,570},{2,10655},{3,280},{4,274},{5,151},{6,127},{7,140},{8,138}]',63705,'[{18020001,10}]','[{2,54}]',54),(1006,3,3,90,'[{1,590},{2,11040},{3,290},{4,284},{5,156},{6,132},{7,145},{8,143}]',65990,'[{18020001,10}]','[{1,3}]',60),(1006,4,0,120,'[{1,614},{2,11486},{3,302},{4,296},{5,162},{6,138},{7,151},{8,149}]',68716,'[{18020001,10}]','[{2,62}]',62),(1006,4,1,120,'[{1,639},{2,11948},{3,314},{4,308},{5,169},{6,143},{7,157},{8,155}]',71478,'[{18020001,10}]','[{1,3}]',60),(1006,4,2,120,'[{1,665},{2,12429},{3,326},{4,320},{5,175},{6,149},{7,163},{8,161}]',74279,'[{18020001,10}]','[{2,65}]',65),(1006,4,3,120,'[{1,692},{2,12926},{3,339},{4,333},{5,182},{6,154},{7,169},{8,167}]',77166,'[{18020001,10}]','[{1,4}]',80),(1006,5,0,160,'[{1,722},{2,13493},{3,355},{4,347},{5,190},{6,160},{7,176},{8,174}]',80483,'[{18020001,10}]','[{2,72}]',72),(1006,5,1,160,'[{1,753},{2,14081},{3,370},{4,362},{5,198},{6,168},{7,184},{8,182}]',84041,'[{18020001,10}]','[{1,4}]',80),(1006,5,2,160,'[{1,786},{2,14692},{3,386},{4,378},{5,207},{6,175},{7,192},{8,190}]',87712,'[{18020001,10}]','[{2,76}]',76),(1006,5,3,160,'[{1,820},{2,15324},{3,402},{4,394},{5,216},{6,182},{7,200},{8,198}]',91424,'[{18020001,10}]','[{1,4}]',80),(1006,6,0,210,'[{1,858},{2,16034},{3,420},{4,412},{5,225},{6,191},{7,209},{8,207}]',95594,'[{18020001,10}]','[{2,84}]',84),(1006,6,1,210,'[{1,898},{2,16770},{3,439},{4,431},{5,236},{6,200},{7,219},{8,217}]',100080,'[{18020001,10}]','[{1,4}]',80),(1006,6,2,210,'[{1,938},{2,17531},{3,460},{4,450},{5,247},{6,209},{7,229},{8,227}]',104641,'[{18020001,10}]','[{2,88}]',88),(1006,6,3,210,'[{1,980},{2,18318},{3,480},{4,470},{5,258},{6,218},{7,239},{8,237}]',109268,'[{18020001,10}]','[{1,5}]',100),(1006,7,0,290,'[{1,1027},{2,19192},{3,503},{4,493},{5,270},{6,228},{7,250},{8,248}]',114432,'[{18020001,10}]','[{2,97}]',97),(1006,7,1,290,'[{1,1075},{2,20097},{3,526},{4,516},{5,283},{6,239},{7,262},{8,260}]',119847,'[{18020001,10}]','[{1,5}]',100),(1006,7,2,290,'[{1,1125},{2,21032},{3,550},{4,540},{5,296},{6,250},{7,274},{8,272}]',125382,'[{18020001,10}]','[{2,101}]',101),(1006,7,3,290,'[{1,1177},{2,21997},{3,576},{4,564},{5,309},{6,261},{7,286},{8,284}]',131037,'[{18020001,10}]','[{1,5}]',100),(1006,8,0,390,'[{1,1234},{2,23057},{3,603},{4,591},{5,324},{6,274},{7,300},{8,298}]',137387,'[{18020001,10}]','[{2,112}]',112),(1006,8,1,390,'[{1,1291},{2,24148},{3,631},{4,619},{5,339},{6,287},{7,315},{8,311}]',143818,'[{18020001,10}]','[{1,6}]',120),(1006,8,2,390,'[{1,1351},{2,25269},{3,661},{4,647},{5,355},{6,301},{7,330},{8,326}]',150589,'[{18020001,10}]','[{2,115}]',115),(1006,8,3,390,'[{1,1413},{2,26420},{3,691},{4,677},{5,371},{6,315},{7,345},{8,341}]',157480,'[{18020001,10}]','[{1,6}]',120),(1006,9,0,510,'[{1,1481},{2,27675},{3,723},{4,709},{5,389},{6,329},{7,361},{8,357}]',164895,'[{18020001,10}]','[{2,127}]',127),(1006,9,1,510,'[{1,1550},{2,28965},{3,756},{4,742},{5,407},{6,345},{7,378},{8,374}]',172615,'[{18020001,10}]','[{1,6}]',120),(1006,9,2,510,'[{1,1621},{2,30289},{3,791},{4,775},{5,426},{6,360},{7,395},{8,391}]',180459,'[{18020001,10}]','[{2,131}]',131),(1006,9,3,510,'[{1,1694},{2,31648},{3,826},{4,810},{5,445},{6,377},{7,413},{8,409}]',188628,'[{18020001,10}]','[{1,7}]',140),(1006,10,0,650,'[{1,1772},{2,33119},{3,865},{4,847},{5,466},{6,394},{7,432},{8,428}]',197359,'[{18020001,10}]','[{2,142}]',142),(1006,10,1,650,'[{1,1853},{2,34625},{3,904},{4,886},{5,486},{6,412},{7,451},{8,447}]',206235,'[{18020001,10}]','[{1,7}]',140),(1006,10,2,650,'[{1,1936},{2,36166},{3,944},{4,926},{5,508},{6,430},{7,471},{8,467}]',215436,'[{18020001,10}]','[{2,148}]',148),(1006,10,3,650,'[{1,2020},{2,37742},{3,986},{4,966},{5,530},{6,448},{7,491},{8,487}]',224742,'[{18020001,10}]','[{1,8}]',160),(1006,11,0,810,'[{1,2111},{2,39438},{3,1030},{4,1010},{5,553},{6,469},{7,514},{8,508}]',234858,'[{18020002,30}]','[{2,160}]',160),(1006,11,1,810,'[{1,2204},{2,41173},{3,1076},{4,1054},{5,577},{6,489},{7,536},{8,530}]',245103,'[{18020002,30}]','[{1,8}]',160),(1006,11,2,810,'[{1,2300},{2,42947},{3,1122},{4,1100},{5,602},{6,510},{7,559},{8,553}]',255697,'[{18020002,30}]','[{2,164}]',164),(1006,11,3,810,'[{1,2397},{2,44761},{3,1170},{4,1146},{5,627},{6,531},{7,582},{8,576}]',266401,'[{18020002,30}]','[{1,9}]',180),(1006,12,0,970,'[{1,2501},{2,46704},{3,1220},{4,1196},{5,654},{6,554},{7,607},{8,601}]',277924,'[{18020002,30}]','[{2,177}]',177),(1006,12,1,970,'[{1,2608},{2,48686},{3,1272},{4,1246},{5,682},{6,578},{7,633},{8,627}]',289796,'[{18020002,30}]','[{1,9}]',180),(1006,12,2,970,'[{1,2716},{2,50707},{3,1324},{4,1298},{5,710},{6,602},{7,659},{8,653}]',301777,'[{18020002,30}]','[{2,180}]',180),(1006,12,3,970,'[{1,2827},{2,52767},{3,1378},{4,1350},{5,740},{6,626},{7,686},{8,680}]',314107,'[{18020002,30}]','[{1,10}]',200),(1006,13,0,1150,'[{1,2945},{2,54965},{3,1435},{4,1407},{5,770},{6,652},{7,715},{8,707}]',327115,'[{18020002,30}]','[{2,194}]',194),(1006,13,1,1150,'[{1,3065},{2,57207},{3,1494},{4,1464},{5,801},{6,679},{7,744},{8,736}]',340457,'[{18020002,30}]','[{1,10}]',200),(1006,13,2,1150,'[{1,3187},{2,59492},{3,1553},{4,1523},{5,834},{6,706},{7,774},{8,766}]',354132,'[{18020002,30}]','[{2,199}]',199),(1006,13,3,1150,'[{1,3312},{2,61820},{3,1614},{4,1582},{5,866},{6,734},{7,804},{8,796}]',367960,'[{18020002,30}]','[{1,11}]',220),(1006,14,0,1330,'[{1,3444},{2,64296},{3,1679},{4,1645},{5,901},{6,763},{7,836},{8,828}]',382676,'[{18020002,30}]','[{2,215}]',215),(1006,14,1,1330,'[{1,3579},{2,66814},{3,1744},{4,1710},{5,937},{6,793},{7,869},{8,861}]',397744,'[{18020002,30}]','[{1,11}]',220),(1006,14,2,1330,'[{1,3716},{2,69376},{3,1811},{4,1775},{5,973},{6,823},{7,902},{8,894}]',412946,'[{18020002,30}]','[{2,219}]',219),(1006,14,3,1330,'[{1,3856},{2,71981},{3,1879},{4,1841},{5,1009},{6,855},{7,937},{8,927}]',428501,'[{18020002,30}]','[{1,12}]',240),(1006,15,0,1540,'[{1,4004},{2,74742},{3,1950},{4,1912},{5,1048},{6,888},{7,973},{8,963}]',444972,'[{18020002,30}]','[{2,233}]',233),(1006,15,1,1540,'[{1,4154},{2,77551},{3,2024},{4,1984},{5,1087},{6,921},{7,1009},{8,999}]',461631,'[{18020002,30}]','[{1,12}]',240),(1006,15,2,1540,'[{1,4307},{2,80408},{3,2099},{4,2057},{5,1127},{6,955},{7,1046},{8,1036}]',478648,'[{18020002,30}]','[{2,239}]',239),(1006,15,3,1540,'[{1,4462},{2,83312},{3,2175},{4,2131},{5,1169},{6,989},{7,1084},{8,1074}]',496002,'[{18020002,30}]','[{1,13}]',260),(1006,16,0,1750,'[{1,4626},{2,86380},{3,2254},{4,2210},{5,1212},{6,1026},{7,1125},{8,1113}]',514300,'[{18020002,30}]','[{2,254}]',254),(1006,16,1,1750,'[{1,4793},{2,89496},{3,2336},{4,2290},{5,1255},{6,1063},{7,1165},{8,1153}]',532806,'[{18020002,30}]','[{1,13}]',260),(1006,16,2,1750,'[{1,4962},{2,92660},{3,2419},{4,2371},{5,1300},{6,1100},{7,1206},{8,1194}]',551650,'[{18020002,30}]','[{2,260}]',260),(1006,16,3,1750,'[{1,5134},{2,95871},{3,2503},{4,2453},{5,1345},{6,1139},{7,1248},{8,1236}]',570851,'[{18020002,30}]','[{1,14}]',280),(1006,17,0,1990,'[{1,5315},{2,99255},{3,2592},{4,2540},{5,1393},{6,1179},{7,1292},{8,1280}]',591055,'[{18020002,30}]','[{2,276}]',276),(1006,17,1,1990,'[{1,5499},{2,102687},{3,2682},{4,2628},{5,1440},{6,1220},{7,1337},{8,1323}]',611417,'[{18020002,30}]','[{1,14}]',280),(1006,17,2,1990,'[{1,5685},{2,106166},{3,2772},{4,2718},{5,1489},{6,1261},{7,1382},{8,1368}]',632116,'[{18020002,30}]','[{2,283}]',283),(1006,17,3,1990,'[{1,5874},{2,109693},{3,2864},{4,2808},{5,1539},{6,1303},{7,1428},{8,1414}]',653173,'[{18020002,30}]','[{1,15}]',300),(1006,18,0,2230,'[{1,6073},{2,113402},{3,2961},{4,2903},{5,1591},{6,1347},{7,1476},{8,1462}]',675262,'[{18020002,30}]','[{2,301}]',301),(1006,18,1,2230,'[{1,6274},{2,117162},{3,3059},{4,2999},{5,1644},{6,1392},{7,1526},{8,1510}]',697692,'[{18020002,30}]','[{1,15}]',300),(1006,18,2,2230,'[{1,6478},{2,120975},{3,3159},{4,3097},{5,1697},{6,1437},{7,1575},{8,1559}]',720335,'[{18020002,30}]','[{2,306}]',306),(1006,18,3,2230,'[{1,6685},{2,124840},{3,3260},{4,3196},{5,1751},{6,1483},{7,1625},{8,1609}]',743340,'[{18020002,30}]','[{1,16}]',320),(1006,19,0,2500,'[{1,6902},{2,128895},{3,3366},{4,3300},{5,1808},{6,1530},{7,1677},{8,1661}]',767385,'[{18020002,30}]','[{2,325}]',325),(1006,19,1,2500,'[{1,7122},{2,133003},{3,3473},{4,3405},{5,1865},{6,1579},{7,1731},{8,1713}]',791793,'[{18020002,30}]','[{1,16}]',320),(1006,19,2,2500,'[{1,7345},{2,137161},{3,3582},{4,3512},{5,1923},{6,1629},{7,1785},{8,1767}]',816611,'[{18020002,30}]','[{2,330}]',330),(1006,19,3,2500,'[{1,7570},{2,141372},{3,3693},{4,3619},{5,1982},{6,1678},{7,1839},{8,1821}]',841572,'[{18020002,30}]','[{1,17}]',340),(1006,20,0,2770,'[{1,7806},{2,145782},{3,3808},{4,3732},{5,2044},{6,1730},{7,1896},{8,1878}]',867802,'[{18020002,30}]','[{2,350}]',350),(1006,20,1,2770,'[{1,8045},{2,150248},{3,3925},{4,3847},{5,2106},{6,1784},{7,1955},{8,1935}]',894448,'[{18020002,30}]','[{1,18}]',360),(1006,20,2,2770,'[{1,8286},{2,154771},{3,4043},{4,3963},{5,2170},{6,1838},{7,2014},{8,1994}]',921441,'[{18020002,30}]','[{2,356}]',356),(1006,20,3,2770,'[{1,8532},{2,159349},{3,4162},{4,4080},{5,2234},{6,1892},{7,2073},{8,2053}]',948639,'[{18020002,30}]','[{1,19}]',380),(1006,21,0,3070,'[{1,8788},{2,164136},{3,4287},{4,4203},{5,2301},{6,1949},{7,2136},{8,2114}]',977146,'[{18020003,90}]','[{2,375}]',375),(1006,21,1,3070,'[{1,9048},{2,168979},{3,4414},{4,4326},{5,2370},{6,2006},{7,2199},{8,2177}]',1006039,'[{18020003,90}]','[{1,19}]',380),(1006,21,2,3070,'[{1,9310},{2,173877},{3,4542},{4,4452},{5,2438},{6,2064},{7,2262},{8,2240}]',1035127,'[{18020003,90}]','[{2,382}]',382),(1006,21,3,3070,'[{1,9575},{2,178833},{3,4671},{4,4579},{5,2507},{6,2123},{7,2327},{8,2303}]',1064583,'[{18020003,90}]','[{1,20}]',400),(1006,22,0,3370,'[{1,9852},{2,184005},{3,4807},{4,4711},{5,2580},{6,2184},{7,2394},{8,2370}]',1095395,'[{18020003,90}]','[{2,402}]',402),(1006,22,1,3370,'[{1,10132},{2,189237},{3,4943},{4,4845},{5,2653},{6,2247},{7,2462},{8,2438}]',1126577,'[{18020003,90}]','[{1,20}]',400),(1006,22,2,3370,'[{1,10415},{2,194529},{3,5081},{4,4981},{5,2727},{6,2309},{7,2531},{8,2505}]',1157979,'[{18020003,90}]','[{2,409}]',409),(1006,22,3,3370,'[{1,10702},{2,199883},{3,5222},{4,5118},{5,2802},{6,2372},{7,2600},{8,2574}]',1189823,'[{18020003,90}]','[{1,21}]',420),(1006,23,0,3720,'[{1,11001},{2,205461},{3,5367},{4,5261},{5,2880},{6,2438},{7,2672},{8,2646}]',1222981,'[{18020003,90}]','[{2,432}]',432),(1006,23,1,3720,'[{1,11303},{2,211100},{3,5515},{4,5405},{5,2959},{6,2505},{7,2746},{8,2718}]',1256560,'[{18020003,90}]','[{1,22}]',440),(1006,23,2,3720,'[{1,11608},{2,216799},{3,5664},{4,5552},{5,3039},{6,2573},{7,2820},{8,2792}]',1290559,'[{18020003,90}]','[{2,437}]',437),(1006,23,3,3720,'[{1,11916},{2,222560},{3,5815},{4,5699},{5,3120},{6,2642},{7,2895},{8,2867}]',1324930,'[{18020003,90}]','[{1,23}]',460),(1006,24,0,4070,'[{1,12236},{2,228554},{3,5971},{4,5853},{5,3205},{6,2713},{7,2974},{8,2944}]',1360674,'[{18020003,90}]','[{2,460}]',460),(1006,24,1,4070,'[{1,12561},{2,234612},{3,6130},{4,6008},{5,3289},{6,2785},{7,3052},{8,3022}]',1396682,'[{18020003,90}]','[{1,23}]',460),(1006,24,2,4070,'[{1,12889},{2,240736},{3,6289},{4,6165},{5,3375},{6,2857},{7,3132},{8,3100}]',1433066,'[{18020003,90}]','[{2,469}]',469),(1006,24,3,4070,'[{1,13220},{2,246924},{3,6451},{4,6323},{5,3461},{6,2931},{7,3212},{8,3180}]',1469874,'[{18020003,90}]','[{1,24}]',480),(1006,25,0,4470,'[{1,13564},{2,253355},{3,6619},{4,6487},{5,3551},{6,3007},{7,3295},{8,3263}]',1508085,'[{18020003,90}]','[{2,491}]',491),(1006,25,1,4470,'[{1,13911},{2,259855},{3,6788},{4,6654},{5,3642},{6,3084},{7,3380},{8,3346}]',1546725,'[{18020003,90}]','[{1,25}]',500),(1006,25,2,4470,'[{1,14263},{2,266425},{3,6960},{4,6822},{5,3734},{6,3162},{7,3465},{8,3431}]',1585835,'[{18020003,90}]','[{2,499}]',499),(1006,25,3,4470,'[{1,14619},{2,273063},{3,7134},{4,6992},{5,3827},{6,3241},{7,3552},{8,3516}]',1625393,'[{18020003,90}]','[{1,26}]',520),(1006,26,0,4870,'[{1,14988},{2,279953},{3,7313},{4,7169},{5,3924},{6,3322},{7,3641},{8,3605}]',1666363,'[{18020003,90}]','[{2,522}]',522),(1006,26,1,4870,'[{1,15360},{2,286912},{3,7495},{4,7347},{5,4021},{6,3405},{7,3732},{8,3694}]',1707762,'[{18020003,90}]','[{1,26}]',520),(1006,26,2,4870,'[{1,15736},{2,293940},{3,7679},{4,7527},{5,4120},{6,3488},{7,3823},{8,3785}]',1749610,'[{18020003,90}]','[{2,532}]',532),(1006,26,3,4870,'[{1,16116},{2,301037},{3,7865},{4,7709},{5,4219},{6,3573},{7,3915},{8,3877}]',1791907,'[{18020003,90}]','[{1,28}]',560),(1006,27,0,5320,'[{1,16510},{2,308395},{3,8057},{4,7897},{5,4322},{6,3660},{7,4011},{8,3971}]',1835645,'[{18020003,90}]','[{2,557}]',557),(1006,27,1,5320,'[{1,16908},{2,315830},{3,8251},{4,8087},{5,4426},{6,3748},{7,4107},{8,4067}]',1879840,'[{18020003,90}]','[{1,28}]',560),(1006,27,2,5320,'[{1,17310},{2,323342},{3,8447},{4,8279},{5,4531},{6,3837},{7,4205},{8,4163}]',1924492,'[{18020003,90}]','[{2,567}]',567),(1006,27,3,5320,'[{1,17717},{2,330933},{3,8645},{4,8473},{5,4637},{6,3927},{7,4303},{8,4261}]',1969623,'[{18020003,90}]','[{1,29}]',580),(1006,28,0,5770,'[{1,18137},{2,338793},{3,8850},{4,8674},{5,4748},{6,4020},{7,4406},{8,4362}]',2016433,'[{18020003,90}]','[{2,594}]',594),(1006,28,1,5770,'[{1,18562},{2,346729},{3,9057},{4,8877},{5,4859},{6,4115},{7,4509},{8,4465}]',2063719,'[{18020003,90}]','[{1,30}]',600),(1006,28,2,5770,'[{1,18991},{2,354744},{3,9266},{4,9082},{5,4972},{6,4210},{7,4614},{8,4568}]',2111464,'[{18020003,90}]','[{2,603}]',603),(1006,28,3,5770,'[{1,19425},{2,362837},{3,9477},{4,9289},{5,5086},{6,4306},{7,4719},{8,4673}]',2159687,'[{18020003,90}]','[{1,31}]',620),(1006,29,0,6270,'[{1,19872},{2,371207},{3,9696},{4,9504},{5,5203},{6,4405},{7,4828},{8,4780}]',2209447,'[{18020003,90}]','[{2,631}]',631),(1006,29,1,6270,'[{1,20324},{2,379654},{3,9917},{4,9721},{5,5321},{6,4505},{7,4938},{8,4888}]',2259684,'[{18020003,90}]','[{1,32}]',640),(1006,29,2,6270,'[{1,20780},{2,388180},{3,10140},{4,9940},{5,5440},{6,4606},{7,5048},{8,4998}]',2310380,'[{18020003,90}]','[{2,644}]',644),(1006,29,3,6270,'[{1,21240},{2,396784},{3,10366},{4,10160},{5,5560},{6,4708},{7,5160},{8,5108}]',2361534,'[{18020003,90}]','[{1,33}]',660),(1006,30,0,6770,'[{1,21716},{2,405673},{3,10598},{4,10388},{5,5685},{6,4813},{7,5275},{8,5223}]',2414443,'[{18020003,90}]','[{2,674}]',674),(1006,30,1,6770,'[{1,22196},{2,414640},{3,10832},{4,10618},{5,5810},{6,4920},{7,5392},{8,5338}]',2467810,'[{18020003,90}]','[{1,34}]',680),(1006,30,2,6770,'[{1,22680},{2,423685},{3,11069},{4,10849},{5,5937},{6,5027},{7,5509},{8,5455}]',2521635,'[{18020003,90}]','[{2,685}]',685),(1006,30,3,0,'[{1,23168},{2,432808},{3,11307},{4,11083},{5,6065},{6,5135},{7,5628},{8,5572}]',2575918,'[{18020003,90}]','[]',0),(1007,1,0,40,'[{1,372},{2,8677},{3,215},{4,189},{5,102},{6,100},{7,98},{8,104}]',46417,'[{18020001,10}]','[{2,34}]',34),(1007,1,1,40,'[{1,383},{2,8918},{3,221},{4,195},{5,105},{6,103},{7,101},{8,107}]',47778,'[{18020001,10}]','[{1,2}]',40),(1007,1,2,40,'[{1,393},{2,9163},{3,227},{4,201},{5,108},{6,106},{7,104},{8,110}]',49123,'[{18020001,10}]','[{2,36}]',36),(1007,1,3,40,'[{1,404},{2,9414},{3,234},{4,206},{5,111},{6,109},{7,106},{8,114}]',50494,'[{18020001,10}]','[{1,2}]',40),(1007,2,0,60,'[{1,417},{2,9713},{3,241},{4,213},{5,114},{6,112},{7,109},{8,117}]',52003,'[{18020001,10}]','[{2,42}]',42),(1007,2,1,60,'[{1,430},{2,10022},{3,249},{4,219},{5,118},{6,116},{7,113},{8,121}]',53722,'[{18020001,10}]','[{1,2}]',40),(1007,2,2,60,'[{1,444},{2,10340},{3,256},{4,226},{5,122},{6,120},{7,117},{8,125}]',55470,'[{18020001,10}]','[{2,44}]',44),(1007,2,3,60,'[{1,457},{2,10669},{3,264},{4,234},{5,126},{6,124},{7,121},{8,129}]',57259,'[{18020001,10}]','[{1,3}]',60),(1007,3,0,90,'[{1,474},{2,11054},{3,274},{4,242},{5,130},{6,128},{7,125},{8,133}]',59234,'[{18020001,10}]','[{2,51}]',51),(1007,3,1,90,'[{1,492},{2,11454},{3,284},{4,250},{5,135},{6,133},{7,130},{8,138}]',61444,'[{18020001,10}]','[{1,3}]',60),(1007,3,2,90,'[{1,509},{2,11868},{3,294},{4,260},{5,140},{6,138},{7,135},{8,143}]',63698,'[{18020001,10}]','[{2,54}]',54),(1007,3,3,90,'[{1,528},{2,12298},{3,305},{4,269},{5,145},{6,143},{7,139},{8,149}]',66008,'[{18020001,10}]','[{1,3}]',60),(1007,4,0,120,'[{1,549},{2,12794},{3,318},{4,280},{5,151},{6,149},{7,145},{8,155}]',68724,'[{18020001,10}]','[{2,61}]',61),(1007,4,1,120,'[{1,571},{2,13309},{3,330},{4,292},{5,157},{6,155},{7,151},{8,161}]',71479,'[{18020001,10}]','[{1,3}]',60),(1007,4,2,120,'[{1,594},{2,13844},{3,343},{4,303},{5,163},{6,161},{7,157},{8,167}]',74274,'[{18020001,10}]','[{2,64}]',64),(1007,4,3,120,'[{1,618},{2,14398},{3,357},{4,315},{5,169},{6,167},{7,163},{8,173}]',77158,'[{18020001,10}]','[{1,4}]',80),(1007,5,0,160,'[{1,645},{2,15030},{3,373},{4,329},{5,176},{6,174},{7,169},{8,181}]',80480,'[{18020001,10}]','[{2,72}]',72),(1007,5,1,160,'[{1,673},{2,15685},{3,389},{4,343},{5,184},{6,182},{7,177},{8,189}]',84045,'[{18020001,10}]','[{1,4}]',80),(1007,5,2,160,'[{1,702},{2,16365},{3,406},{4,358},{5,192},{6,190},{7,185},{8,197}]',87705,'[{18020001,10}]','[{2,75}]',75),(1007,5,3,160,'[{1,733},{2,17069},{3,423},{4,373},{5,200},{6,198},{7,193},{8,205}]',91429,'[{18020001,10}]','[{1,4}]',80),(1007,6,0,210,'[{1,767},{2,17859},{3,442},{4,390},{5,209},{6,207},{7,201},{8,215}]',95599,'[{18020001,10}]','[{2,84}]',84),(1007,6,1,210,'[{1,802},{2,18679},{3,462},{4,408},{5,219},{6,217},{7,211},{8,225}]',100069,'[{18020001,10}]','[{1,4}]',80),(1007,6,2,210,'[{1,838},{2,19527},{3,483},{4,427},{5,229},{6,227},{7,221},{8,235}]',104637,'[{18020001,10}]','[{2,88}]',88),(1007,6,3,210,'[{1,876},{2,20404},{3,504},{4,446},{5,239},{6,237},{7,230},{8,246}]',109274,'[{18020001,10}]','[{1,5}]',100),(1007,7,0,290,'[{1,918},{2,21378},{3,529},{4,467},{5,250},{6,248},{7,241},{8,257}]',114438,'[{18020001,10}]','[{2,97}]',97),(1007,7,1,290,'[{1,961},{2,22385},{3,553},{4,489},{5,262},{6,260},{7,253},{8,269}]',119855,'[{18020001,10}]','[{1,5}]',100),(1007,7,2,290,'[{1,1005},{2,23427},{3,579},{4,511},{5,274},{6,272},{7,264},{8,282}]',125377,'[{18020001,10}]','[{2,101}]',101),(1007,7,3,290,'[{1,1052},{2,24502},{3,605},{4,535},{5,286},{6,284},{7,276},{8,294}]',131042,'[{18020001,10}]','[{1,5}]',100),(1007,8,0,390,'[{1,1102},{2,25683},{3,634},{4,560},{5,300},{6,298},{7,289},{8,309}]',137373,'[{18020001,10}]','[{2,112}]',112),(1007,8,1,390,'[{1,1154},{2,26898},{3,664},{4,586},{5,315},{6,311},{7,303},{8,323}]',143828,'[{18020001,10}]','[{1,6}]',120),(1007,8,2,390,'[{1,1208},{2,28146},{3,695},{4,613},{5,330},{6,326},{7,318},{8,338}]',150606,'[{18020001,10}]','[{2,115}]',115),(1007,8,3,390,'[{1,1263},{2,29429},{3,726},{4,642},{5,345},{6,341},{7,332},{8,354}]',157489,'[{18020001,10}]','[{1,6}]',120),(1007,9,0,510,'[{1,1323},{2,30826},{3,760},{4,672},{5,361},{6,357},{7,348},{8,370}]',164886,'[{18020001,10}]','[{2,127}]',127),(1007,9,1,510,'[{1,1385},{2,32263},{3,795},{4,703},{5,378},{6,374},{7,364},{8,388}]',172613,'[{18020001,10}]','[{1,6}]',120),(1007,9,2,510,'[{1,1449},{2,33738},{3,832},{4,734},{5,395},{6,391},{7,380},{8,406}]',180468,'[{18020001,10}]','[{2,130}]',130),(1007,9,3,510,'[{1,1514},{2,35252},{3,869},{4,767},{5,413},{6,409},{7,398},{8,424}]',188632,'[{18020001,10}]','[{1,7}]',140),(1007,10,0,650,'[{1,1584},{2,36891},{3,909},{4,803},{5,432},{6,428},{7,416},{8,444}]',197371,'[{18020001,10}]','[{2,142}]',142),(1007,10,1,650,'[{1,1656},{2,38568},{3,950},{4,840},{5,451},{6,447},{7,435},{8,463}]',206238,'[{18020001,10}]','[{1,7}]',140),(1007,10,2,650,'[{1,1730},{2,40284},{3,993},{4,877},{5,471},{6,467},{7,454},{8,484}]',215434,'[{18020001,10}]','[{2,148}]',148),(1007,10,3,650,'[{1,1805},{2,42039},{3,1037},{4,915},{5,491},{6,487},{7,473},{8,505}]',224739,'[{18020001,10}]','[{1,8}]',160),(1007,11,0,810,'[{1,1887},{2,43929},{3,1083},{4,957},{5,514},{6,508},{7,495},{8,527}]',234869,'[{18020002,30}]','[{2,160}]',160),(1007,11,1,810,'[{1,1970},{2,45861},{3,1131},{4,999},{5,536},{6,530},{7,516},{8,550}]',245111,'[{18020002,30}]','[{1,8}]',160),(1007,11,2,810,'[{1,2055},{2,47838},{3,1180},{4,1042},{5,559},{6,553},{7,538},{8,574}]',255688,'[{18020002,30}]','[{2,163}]',163),(1007,11,3,810,'[{1,2142},{2,49858},{3,1230},{4,1086},{5,582},{6,576},{7,560},{8,598}]',266398,'[{18020002,30}]','[{1,9}]',180),(1007,12,0,970,'[{1,2235},{2,52022},{3,1283},{4,1133},{5,607},{6,601},{7,585},{8,623}]',277922,'[{18020002,30}]','[{2,177}]',177),(1007,12,1,970,'[{1,2330},{2,54230},{3,1337},{4,1181},{5,633},{6,627},{7,610},{8,650}]',289780,'[{18020002,30}]','[{1,9}]',180),(1007,12,2,970,'[{1,2427},{2,56481},{3,1392},{4,1230},{5,659},{6,653},{7,635},{8,677}]',301771,'[{18020002,30}]','[{2,181}]',181),(1007,12,3,970,'[{1,2526},{2,58775},{3,1449},{4,1279},{5,686},{6,680},{7,661},{8,705}]',314095,'[{18020002,30}]','[{1,10}]',200),(1007,13,0,1150,'[{1,2632},{2,61224},{3,1509},{4,1333},{5,715},{6,707},{7,688},{8,734}]',327114,'[{18020002,30}]','[{2,195}]',195),(1007,13,1,1150,'[{1,2739},{2,63722},{3,1571},{4,1387},{5,744},{6,736},{7,716},{8,764}]',340452,'[{18020002,30}]','[{1,10}]',200),(1007,13,2,1150,'[{1,2848},{2,66267},{3,1633},{4,1443},{5,774},{6,766},{7,745},{8,795}]',354127,'[{18020002,30}]','[{2,199}]',199),(1007,13,3,1150,'[{1,2960},{2,68860},{3,1697},{4,1499},{5,804},{6,796},{7,774},{8,826}]',367960,'[{18020002,30}]','[{1,11}]',220),(1007,14,0,1330,'[{1,3078},{2,71617},{3,1765},{4,1559},{5,836},{6,828},{7,805},{8,859}]',382677,'[{18020002,30}]','[{2,214}]',214),(1007,14,1,1330,'[{1,3198},{2,74423},{3,1834},{4,1620},{5,869},{6,861},{7,837},{8,893}]',397733,'[{18020002,30}]','[{1,11}]',220),(1007,14,2,1330,'[{1,3321},{2,77276},{3,1904},{4,1682},{5,902},{6,894},{7,869},{8,927}]',412946,'[{18020002,30}]','[{2,219}]',219),(1007,14,3,1330,'[{1,3446},{2,80178},{3,1975},{4,1745},{5,937},{6,927},{7,902},{8,962}]',428498,'[{18020002,30}]','[{1,12}]',240),(1007,15,0,1540,'[{1,3578},{2,83253},{3,2051},{4,1811},{5,973},{6,963},{7,937},{8,999}]',444963,'[{18020002,30}]','[{2,234}]',234),(1007,15,1,1540,'[{1,3712},{2,86382},{3,2128},{4,1880},{5,1009},{6,999},{7,972},{8,1036}]',461622,'[{18020002,30}]','[{1,12}]',240),(1007,15,2,1540,'[{1,3848},{2,89564},{3,2207},{4,1949},{5,1046},{6,1036},{7,1008},{8,1074}]',478624,'[{18020002,30}]','[{2,240}]',240),(1007,15,3,1540,'[{1,3987},{2,92799},{3,2286},{4,2020},{5,1084},{6,1074},{7,1044},{8,1114}]',495989,'[{18020002,30}]','[{1,13}]',260),(1007,16,0,1750,'[{1,4134},{2,96216},{3,2370},{4,2094},{5,1125},{6,1113},{7,1083},{8,1155}]',514296,'[{18020002,30}]','[{2,254}]',254),(1007,16,1,1750,'[{1,4283},{2,99687},{3,2456},{4,2170},{5,1165},{6,1153},{7,1122},{8,1196}]',532797,'[{18020002,30}]','[{1,13}]',260),(1007,16,2,1750,'[{1,4434},{2,103211},{3,2543},{4,2247},{5,1206},{6,1194},{7,1162},{8,1238}]',551641,'[{18020002,30}]','[{2,261}]',261),(1007,16,3,1750,'[{1,4588},{2,106788},{3,2632},{4,2324},{5,1248},{6,1236},{7,1202},{8,1282}]',570848,'[{18020002,30}]','[{1,14}]',280),(1007,17,0,1990,'[{1,4749},{2,110557},{3,2725},{4,2407},{5,1292},{6,1280},{7,1245},{8,1327}]',591037,'[{18020002,30}]','[{2,277}]',277),(1007,17,1,1990,'[{1,4914},{2,114380},{3,2820},{4,2490},{5,1337},{6,1323},{7,1287},{8,1373}]',611410,'[{18020002,30}]','[{1,14}]',280),(1007,17,2,1990,'[{1,5080},{2,118256},{3,2915},{4,2575},{5,1382},{6,1368},{7,1331},{8,1419}]',632106,'[{18020002,30}]','[{2,284}]',284),(1007,17,3,1990,'[{1,5249},{2,122184},{3,3012},{4,2660},{5,1428},{6,1414},{7,1376},{8,1466}]',653164,'[{18020002,30}]','[{1,15}]',300),(1007,18,0,2230,'[{1,5427},{2,126315},{3,3114},{4,2750},{5,1476},{6,1462},{7,1422},{8,1516}]',675255,'[{18020002,30}]','[{2,301}]',301),(1007,18,1,2230,'[{1,5607},{2,130504},{3,3217},{4,2841},{5,1526},{6,1510},{7,1469},{8,1567}]',697694,'[{18020002,30}]','[{1,15}]',300),(1007,18,2,2230,'[{1,5789},{2,134751},{3,3322},{4,2934},{5,1575},{6,1559},{7,1517},{8,1617}]',720331,'[{18020002,30}]','[{2,306}]',306),(1007,18,3,2230,'[{1,5974},{2,139056},{3,3428},{4,3028},{5,1625},{6,1609},{7,1565},{8,1669}]',743336,'[{18020002,30}]','[{1,16}]',320),(1007,19,0,2500,'[{1,6168},{2,143573},{3,3540},{4,3126},{5,1677},{6,1661},{7,1616},{8,1722}]',767383,'[{18020002,30}]','[{2,325}]',325),(1007,19,1,2500,'[{1,6365},{2,148148},{3,3652},{4,3226},{5,1731},{6,1713},{7,1667},{8,1777}]',791798,'[{18020002,30}]','[{1,16}]',320),(1007,19,2,2500,'[{1,6563},{2,152780},{3,3767},{4,3327},{5,1785},{6,1767},{7,1719},{8,1833}]',816590,'[{18020002,30}]','[{2,331}]',331),(1007,19,3,2500,'[{1,6765},{2,157470},{3,3883},{4,3429},{5,1839},{6,1821},{7,1771},{8,1889}]',841570,'[{18020002,30}]','[{1,17}]',340),(1007,20,0,2770,'[{1,6975},{2,162382},{3,4004},{4,3536},{5,1896},{6,1878},{7,1827},{8,1947}]',867782,'[{18020002,30}]','[{2,351}]',351),(1007,20,1,2770,'[{1,7189},{2,167357},{3,4127},{4,3645},{5,1955},{6,1935},{7,1883},{8,2007}]',894437,'[{18020002,30}]','[{1,18}]',360),(1007,20,2,2770,'[{1,7405},{2,172395},{3,4251},{4,3755},{5,2014},{6,1994},{7,1940},{8,2068}]',921445,'[{18020002,30}]','[{2,356}]',356),(1007,20,3,2770,'[{1,7624},{2,177495},{3,4377},{4,3865},{5,2073},{6,2053},{7,1997},{8,2129}]',948625,'[{18020002,30}]','[{1,19}]',380),(1007,21,0,3070,'[{1,7853},{2,182826},{3,4508},{4,3982},{5,2136},{6,2114},{7,2057},{8,2193}]',977136,'[{18020003,90}]','[{2,375}]',375),(1007,21,1,3070,'[{1,8085},{2,188220},{3,4641},{4,4099},{5,2199},{6,2177},{7,2118},{8,2258}]',1006020,'[{18020003,90}]','[{1,19}]',380),(1007,21,2,3070,'[{1,8320},{2,193677},{3,4776},{4,4218},{5,2262},{6,2240},{7,2179},{8,2323}]',1035127,'[{18020003,90}]','[{2,382}]',382),(1007,21,3,3070,'[{1,8556},{2,199197},{3,4912},{4,4338},{5,2327},{6,2303},{7,2241},{8,2389}]',1064567,'[{18020003,90}]','[{1,20}]',400),(1007,22,0,3370,'[{1,8804},{2,204958},{3,5054},{4,4464},{5,2394},{6,2370},{7,2306},{8,2458}]',1095388,'[{18020003,90}]','[{2,402}]',402),(1007,22,1,3370,'[{1,9054},{2,210785},{3,5197},{4,4591},{5,2462},{6,2438},{7,2372},{8,2528}]',1126565,'[{18020003,90}]','[{1,20}]',400),(1007,22,2,3370,'[{1,9307},{2,216681},{3,5343},{4,4719},{5,2531},{6,2505},{7,2437},{8,2599}]',1157971,'[{18020003,90}]','[{2,408}]',408),(1007,22,3,3370,'[{1,9563},{2,222644},{3,5491},{4,4849},{5,2600},{6,2574},{7,2504},{8,2670}]',1189804,'[{18020003,90}]','[{1,21}]',420),(1007,23,0,3720,'[{1,9830},{2,228858},{3,5643},{4,4985},{5,2672},{6,2646},{7,2574},{8,2744}]',1222958,'[{18020003,90}]','[{2,431}]',431),(1007,23,1,3720,'[{1,10100},{2,235138},{3,5799},{4,5121},{5,2746},{6,2718},{7,2645},{8,2819}]',1256538,'[{18020003,90}]','[{1,22}]',440),(1007,23,2,3720,'[{1,10373},{2,241487},{3,5956},{4,5260},{5,2820},{6,2792},{7,2716},{8,2896}]',1290547,'[{18020003,90}]','[{2,438}]',438),(1007,23,3,3720,'[{1,10648},{2,247903},{3,6114},{4,5400},{5,2895},{6,2867},{7,2789},{8,2973}]',1324913,'[{18020003,90}]','[{1,23}]',460),(1007,24,0,4070,'[{1,10935},{2,254579},{3,6279},{4,5545},{5,2974},{6,2944},{7,2864},{8,3054}]',1360679,'[{18020003,90}]','[{2,460}]',460),(1007,24,1,4070,'[{1,11225},{2,261328},{3,6445},{4,5693},{5,3052},{6,3022},{7,2940},{8,3134}]',1396678,'[{18020003,90}]','[{1,23}]',460),(1007,24,2,4070,'[{1,11518},{2,268149},{3,6613},{4,5841},{5,3132},{6,3100},{7,3016},{8,3216}]',1433059,'[{18020003,90}]','[{2,468}]',468),(1007,24,3,4070,'[{1,11813},{2,275042},{3,6783},{4,5991},{5,3212},{6,3180},{7,3094},{8,3298}]',1469852,'[{18020003,90}]','[{1,24}]',480),(1007,25,0,4470,'[{1,12121},{2,282205},{3,6959},{4,6147},{5,3295},{6,3263},{7,3174},{8,3384}]',1508075,'[{18020003,90}]','[{2,491}]',491),(1007,25,1,4470,'[{1,12431},{2,289445},{3,7138},{4,6304},{5,3380},{6,3346},{7,3255},{8,3471}]',1546715,'[{18020003,90}]','[{1,25}]',500),(1007,25,2,4470,'[{1,12746},{2,296763},{3,7318},{4,6464},{5,3465},{6,3431},{7,3338},{8,3558}]',1585833,'[{18020003,90}]','[{2,499}]',499),(1007,25,3,4470,'[{1,13064},{2,304157},{3,7501},{4,6625},{5,3552},{6,3516},{7,3421},{8,3647}]',1625387,'[{18020003,90}]','[{1,26}]',520),(1007,26,0,4870,'[{1,13393},{2,311831},{3,7690},{4,6792},{5,3641},{6,3605},{7,3507},{8,3739}]',1666341,'[{18020003,90}]','[{2,523}]',523),(1007,26,1,4870,'[{1,13726},{2,319583},{3,7881},{4,6961},{5,3732},{6,3694},{7,3594},{8,3832}]',1707753,'[{18020003,90}]','[{1,26}]',520),(1007,26,2,4870,'[{1,14062},{2,327412},{3,8074},{4,7132},{5,3823},{6,3785},{7,3682},{8,3926}]',1749602,'[{18020003,90}]','[{2,531}]',531),(1007,26,3,4870,'[{1,14401},{2,335317},{3,8270},{4,7304},{5,3915},{6,3877},{7,3771},{8,4021}]',1791887,'[{18020003,90}]','[{1,28}]',560),(1007,27,0,5320,'[{1,14754},{2,343512},{3,8472},{4,7482},{5,4011},{6,3971},{7,3863},{8,4119}]',1835642,'[{18020003,90}]','[{2,557}]',557),(1007,27,1,5320,'[{1,15109},{2,351794},{3,8675},{4,7663},{5,4107},{6,4067},{7,3956},{8,4218}]',1879824,'[{18020003,90}]','[{1,28}]',560),(1007,27,2,5320,'[{1,15469},{2,360162},{3,8882},{4,7844},{5,4205},{6,4163},{7,4050},{8,4318}]',1924492,'[{18020003,90}]','[{2,568}]',568),(1007,27,3,5320,'[{1,15832},{2,368617},{3,9090},{4,8028},{5,4303},{6,4261},{7,4145},{8,4419}]',1969607,'[{18020003,90}]','[{1,29}]',580),(1007,28,0,5770,'[{1,16208},{2,377371},{3,9305},{4,8219},{5,4406},{6,4362},{7,4244},{8,4524}]',2016431,'[{18020003,90}]','[{2,593}]',593),(1007,28,1,5770,'[{1,16588},{2,386212},{3,9523},{4,8411},{5,4509},{6,4465},{7,4343},{8,4631}]',2063722,'[{18020003,90}]','[{1,30}]',600),(1007,28,2,5770,'[{1,16971},{2,395139},{3,9743},{4,8605},{5,4614},{6,4568},{7,4444},{8,4738}]',2111459,'[{18020003,90}]','[{2,604}]',604),(1007,28,3,5770,'[{1,17358},{2,404154},{3,9965},{4,8801},{5,4719},{6,4673},{7,4546},{8,4846}]',2159664,'[{18020003,90}]','[{1,31}]',620),(1007,29,0,6270,'[{1,17758},{2,413477},{3,10195},{4,9005},{5,4828},{6,4780},{7,4650},{8,4958}]',2209437,'[{18020003,90}]','[{2,631}]',631),(1007,29,1,6270,'[{1,18162},{2,422886},{3,10428},{4,9210},{5,4938},{6,4888},{7,4756},{8,5070}]',2259676,'[{18020003,90}]','[{1,32}]',640),(1007,29,2,6270,'[{1,18570},{2,432383},{3,10662},{4,9418},{5,5048},{6,4998},{7,4862},{8,5184}]',2310383,'[{18020003,90}]','[{2,644}]',644),(1007,29,3,6270,'[{1,18981},{2,441966},{3,10899},{4,9627},{5,5160},{6,5108},{7,4970},{8,5298}]',2361536,'[{18020003,90}]','[{1,33}]',660),(1007,30,0,6770,'[{1,19406},{2,451867},{3,11144},{4,9842},{5,5275},{6,5223},{7,5081},{8,5417}]',2414437,'[{18020003,90}]','[{2,673}]',673),(1007,30,1,6770,'[{1,19835},{2,461856},{3,11390},{4,10060},{5,5392},{6,5338},{7,5193},{8,5537}]',2467806,'[{18020003,90}]','[{1,34}]',680),(1007,30,2,6770,'[{1,20267},{2,471930},{3,11638},{4,10280},{5,5509},{6,5455},{7,5307},{8,5657}]',2521620,'[{18020003,90}]','[{2,685}]',685),(1007,30,3,0,'[{1,20703},{2,482092},{3,11889},{4,10501},{5,5628},{6,5572},{7,5421},{8,5779}]',2575902,'[{18020003,90}]','[]',0),(1008,1,0,40,'[{1,403},{2,8064},{3,202},{4,202},{5,101},{6,101},{7,101},{8,101}]',46424,'[{18020001,10}]','[{2,32}]',32),(1008,1,1,40,'[{1,414},{2,8288},{3,208},{4,208},{5,104},{6,104},{7,104},{8,104}]',47768,'[{18020001,10}]','[{1,2}]',40),(1008,1,2,40,'[{1,425},{2,8516},{3,214},{4,214},{5,107},{6,107},{7,107},{8,107}]',49116,'[{18020001,10}]','[{2,36}]',36),(1008,1,3,40,'[{1,437},{2,8749},{3,220},{4,220},{5,110},{6,110},{7,110},{8,110}]',50489,'[{18020001,10}]','[{1,2}]',40),(1008,2,0,60,'[{1,451},{2,9027},{3,227},{4,227},{5,113},{6,113},{7,113},{8,113}]',51997,'[{18020001,10}]','[{2,39}]',39),(1008,2,1,60,'[{1,465},{2,9314},{3,234},{4,234},{5,117},{6,117},{7,117},{8,117}]',53714,'[{18020001,10}]','[{1,2}]',40),(1008,2,2,60,'[{1,480},{2,9610},{3,241},{4,241},{5,121},{6,121},{7,121},{8,121}]',55460,'[{18020001,10}]','[{2,44}]',44),(1008,2,3,60,'[{1,495},{2,9915},{3,249},{4,249},{5,125},{6,125},{7,125},{8,125}]',57265,'[{18020001,10}]','[{1,2}]',40),(1008,3,0,90,'[{1,513},{2,10273},{3,258},{4,258},{5,129},{6,129},{7,129},{8,129}]',59233,'[{18020001,10}]','[{2,53}]',53),(1008,3,1,90,'[{1,532},{2,10645},{3,267},{4,267},{5,134},{6,134},{7,134},{8,134}]',61435,'[{18020001,10}]','[{1,3}]',60),(1008,3,2,90,'[{1,551},{2,11030},{3,277},{4,277},{5,139},{6,139},{7,139},{8,139}]',63700,'[{18020001,10}]','[{2,55}]',55),(1008,3,3,90,'[{1,571},{2,11429},{3,287},{4,287},{5,144},{6,144},{7,144},{8,144}]',65999,'[{18020001,10}]','[{1,3}]',60),(1008,4,0,120,'[{1,594},{2,11890},{3,299},{4,299},{5,150},{6,150},{7,150},{8,150}]',68720,'[{18020001,10}]','[{2,61}]',61),(1008,4,1,120,'[{1,618},{2,12369},{3,311},{4,311},{5,156},{6,156},{7,156},{8,156}]',71479,'[{18020001,10}]','[{1,3}]',60),(1008,4,2,120,'[{1,643},{2,12866},{3,323},{4,323},{5,162},{6,162},{7,162},{8,162}]',74276,'[{18020001,10}]','[{2,63}]',63),(1008,4,3,120,'[{1,669},{2,13381},{3,336},{4,336},{5,168},{6,168},{7,168},{8,168}]',77161,'[{18020001,10}]','[{1,4}]',80),(1008,5,0,160,'[{1,698},{2,13968},{3,351},{4,351},{5,175},{6,175},{7,175},{8,175}]',80478,'[{18020001,10}]','[{2,73}]',73),(1008,5,1,160,'[{1,728},{2,14577},{3,366},{4,366},{5,183},{6,183},{7,183},{8,183}]',84037,'[{18020001,10}]','[{1,4}]',80),(1008,5,2,160,'[{1,760},{2,15209},{3,382},{4,382},{5,191},{6,191},{7,191},{8,191}]',87709,'[{18020001,10}]','[{2,74}]',74),(1008,5,3,160,'[{1,793},{2,15863},{3,398},{4,398},{5,199},{6,199},{7,199},{8,199}]',91423,'[{18020001,10}]','[{1,4}]',80),(1008,6,0,210,'[{1,830},{2,16598},{3,416},{4,416},{5,208},{6,208},{7,208},{8,208}]',95598,'[{18020001,10}]','[{2,81}]',81),(1008,6,1,210,'[{1,868},{2,17360},{3,435},{4,435},{5,218},{6,218},{7,218},{8,218}]',100070,'[{18020001,10}]','[{1,4}]',80),(1008,6,2,210,'[{1,907},{2,18148},{3,455},{4,455},{5,228},{6,228},{7,228},{8,228}]',104638,'[{18020001,10}]','[{2,87}]',87),(1008,6,3,210,'[{1,948},{2,18963},{3,475},{4,475},{5,238},{6,238},{7,238},{8,238}]',109273,'[{18020001,10}]','[{1,5}]',100),(1008,7,0,290,'[{1,993},{2,19868},{3,498},{4,498},{5,249},{6,249},{7,249},{8,249}]',114428,'[{18020001,10}]','[{2,94}]',94),(1008,7,1,290,'[{1,1040},{2,20804},{3,521},{4,521},{5,261},{6,261},{7,261},{8,261}]',119854,'[{18020001,10}]','[{1,5}]',100),(1008,7,2,290,'[{1,1088},{2,21772},{3,545},{4,545},{5,273},{6,273},{7,273},{8,273}]',125382,'[{18020001,10}]','[{2,99}]',99),(1008,7,3,290,'[{1,1138},{2,22771},{3,570},{4,570},{5,285},{6,285},{7,285},{8,285}]',131031,'[{18020001,10}]','[{1,5}]',100),(1008,8,0,390,'[{1,1193},{2,23869},{3,597},{4,597},{5,299},{6,299},{7,299},{8,299}]',137379,'[{18020001,10}]','[{2,110}]',110),(1008,8,1,390,'[{1,1249},{2,24998},{3,625},{4,625},{5,313},{6,313},{7,313},{8,313}]',143828,'[{18020001,10}]','[{1,6}]',120),(1008,8,2,390,'[{1,1307},{2,26158},{3,654},{4,654},{5,328},{6,328},{7,328},{8,328}]',150598,'[{18020001,10}]','[{2,116}]',116),(1008,8,3,390,'[{1,1367},{2,27350},{3,684},{4,684},{5,343},{6,343},{7,343},{8,343}]',157490,'[{18020001,10}]','[{1,6}]',120),(1008,9,0,510,'[{1,1432},{2,28649},{3,716},{4,716},{5,359},{6,359},{7,359},{8,359}]',164889,'[{18020001,10}]','[{2,127}]',127),(1008,9,1,510,'[{1,1499},{2,29984},{3,749},{4,749},{5,376},{6,376},{7,376},{8,376}]',172614,'[{18020001,10}]','[{1,6}]',120),(1008,9,2,510,'[{1,1568},{2,31355},{3,783},{4,783},{5,393},{6,393},{7,393},{8,393}]',180465,'[{18020001,10}]','[{2,132}]',132),(1008,9,3,510,'[{1,1638},{2,32762},{3,818},{4,818},{5,411},{6,411},{7,411},{8,411}]',188622,'[{18020001,10}]','[{1,7}]',140),(1008,10,0,650,'[{1,1714},{2,34285},{3,856},{4,856},{5,430},{6,430},{7,430},{8,430}]',197365,'[{18020001,10}]','[{2,141}]',141),(1008,10,1,650,'[{1,1792},{2,35844},{3,895},{4,895},{5,449},{6,449},{7,449},{8,449}]',206234,'[{18020001,10}]','[{1,7}]',140),(1008,10,2,650,'[{1,1872},{2,37439},{3,935},{4,935},{5,469},{6,469},{7,469},{8,469}]',215429,'[{18020001,10}]','[{2,146}]',146),(1008,10,3,650,'[{1,1954},{2,39070},{3,976},{4,976},{5,489},{6,489},{7,489},{8,489}]',224750,'[{18020001,10}]','[{1,8}]',160),(1008,11,0,810,'[{1,2042},{2,40826},{3,1020},{4,1020},{5,511},{6,511},{7,511},{8,511}]',234866,'[{18020002,30}]','[{2,162}]',162),(1008,11,1,810,'[{1,2132},{2,42622},{3,1065},{4,1065},{5,533},{6,533},{7,533},{8,533}]',245112,'[{18020002,30}]','[{1,8}]',160),(1008,11,2,810,'[{1,2224},{2,44459},{3,1111},{4,1111},{5,556},{6,556},{7,556},{8,556}]',255689,'[{18020002,30}]','[{2,163}]',163),(1008,11,3,810,'[{1,2318},{2,46336},{3,1158},{4,1158},{5,579},{6,579},{7,579},{8,579}]',266396,'[{18020002,30}]','[{1,9}]',180),(1008,12,0,970,'[{1,2419},{2,48348},{3,1208},{4,1208},{5,604},{6,604},{7,604},{8,604}]',277928,'[{18020002,30}]','[{2,177}]',177),(1008,12,1,970,'[{1,2522},{2,50400},{3,1259},{4,1259},{5,630},{6,630},{7,630},{8,630}]',289790,'[{18020002,30}]','[{1,9}]',180),(1008,12,2,970,'[{1,2627},{2,52492},{3,1311},{4,1311},{5,656},{6,656},{7,656},{8,656}]',301782,'[{18020002,30}]','[{2,179}]',179),(1008,12,3,970,'[{1,2734},{2,54624},{3,1364},{4,1364},{5,683},{6,683},{7,683},{8,683}]',314104,'[{18020002,30}]','[{1,10}]',200),(1008,13,0,1150,'[{1,2848},{2,56900},{3,1421},{4,1421},{5,711},{6,711},{7,711},{8,711}]',327110,'[{18020002,30}]','[{2,194}]',194),(1008,13,1,1150,'[{1,2964},{2,59221},{3,1479},{4,1479},{5,740},{6,740},{7,740},{8,740}]',340451,'[{18020002,30}]','[{1,10}]',200),(1008,13,2,1150,'[{1,3082},{2,61586},{3,1538},{4,1538},{5,770},{6,770},{7,770},{8,770}]',354126,'[{18020002,30}]','[{2,199}]',199),(1008,13,3,1150,'[{1,3203},{2,63996},{3,1598},{4,1598},{5,800},{6,800},{7,800},{8,800}]',367956,'[{18020002,30}]','[{1,11}]',220),(1008,14,0,1330,'[{1,3331},{2,66559},{3,1662},{4,1662},{5,832},{6,832},{7,832},{8,832}]',382679,'[{18020002,30}]','[{2,213}]',213),(1008,14,1,1330,'[{1,3461},{2,69166},{3,1727},{4,1727},{5,865},{6,865},{7,865},{8,865}]',397736,'[{18020002,30}]','[{1,11}]',220),(1008,14,2,1330,'[{1,3594},{2,71818},{3,1793},{4,1793},{5,898},{6,898},{7,898},{8,898}]',412948,'[{18020002,30}]','[{2,219}]',219),(1008,14,3,1330,'[{1,3729},{2,74515},{3,1860},{4,1860},{5,932},{6,932},{7,932},{8,932}]',428495,'[{18020002,30}]','[{1,12}]',240),(1008,15,0,1540,'[{1,3872},{2,77373},{3,1931},{4,1931},{5,968},{6,968},{7,968},{8,968}]',444963,'[{18020002,30}]','[{2,232}]',232),(1008,15,1,1540,'[{1,4017},{2,80281},{3,2004},{4,2004},{5,1004},{6,1004},{7,1004},{8,1004}]',461621,'[{18020002,30}]','[{1,12}]',240),(1008,15,2,1540,'[{1,4165},{2,83238},{3,2078},{4,2078},{5,1041},{6,1041},{7,1041},{8,1041}]',478638,'[{18020002,30}]','[{2,241}]',241),(1008,15,3,1540,'[{1,4315},{2,86244},{3,2153},{4,2153},{5,1079},{6,1079},{7,1079},{8,1079}]',495994,'[{18020002,30}]','[{1,13}]',260),(1008,16,0,1750,'[{1,4474},{2,89420},{3,2232},{4,2232},{5,1119},{6,1119},{7,1119},{8,1119}]',514300,'[{18020002,30}]','[{2,255}]',255),(1008,16,1,1750,'[{1,4635},{2,92646},{3,2313},{4,2313},{5,1159},{6,1159},{7,1159},{8,1159}]',532796,'[{18020002,30}]','[{1,13}]',260),(1008,16,2,1750,'[{1,4799},{2,95921},{3,2395},{4,2395},{5,1200},{6,1200},{7,1200},{8,1200}]',551651,'[{18020002,30}]','[{2,261}]',261),(1008,16,3,1750,'[{1,4965},{2,99245},{3,2478},{4,2478},{5,1242},{6,1242},{7,1242},{8,1242}]',570845,'[{18020002,30}]','[{1,14}]',280),(1008,17,0,1990,'[{1,5140},{2,102748},{3,2566},{4,2566},{5,1286},{6,1286},{7,1286},{8,1286}]',591048,'[{18020002,30}]','[{2,278}]',278),(1008,17,1,1990,'[{1,5318},{2,106301},{3,2655},{4,2655},{5,1330},{6,1330},{7,1330},{8,1330}]',611411,'[{18020002,30}]','[{1,14}]',280),(1008,17,2,1990,'[{1,5498},{2,109903},{3,2745},{4,2745},{5,1375},{6,1375},{7,1375},{8,1375}]',632113,'[{18020002,30}]','[{2,282}]',282),(1008,17,3,1990,'[{1,5681},{2,113554},{3,2836},{4,2836},{5,1421},{6,1421},{7,1421},{8,1421}]',653174,'[{18020002,30}]','[{1,15}]',300),(1008,18,0,2230,'[{1,5873},{2,117393},{3,2932},{4,2932},{5,1469},{6,1469},{7,1469},{8,1469}]',675253,'[{18020002,30}]','[{2,299}]',299),(1008,18,1,2230,'[{1,6068},{2,121286},{3,3029},{4,3029},{5,1518},{6,1518},{7,1518},{8,1518}]',697696,'[{18020002,30}]','[{1,15}]',300),(1008,18,2,2230,'[{1,6265},{2,125233},{3,3128},{4,3128},{5,1567},{6,1567},{7,1567},{8,1567}]',720333,'[{18020002,30}]','[{2,309}]',309),(1008,18,3,2230,'[{1,6465},{2,129234},{3,3228},{4,3228},{5,1617},{6,1617},{7,1617},{8,1617}]',743334,'[{18020002,30}]','[{1,16}]',320),(1008,19,0,2500,'[{1,6675},{2,133432},{3,3333},{4,3333},{5,1669},{6,1669},{7,1669},{8,1669}]',767382,'[{18020002,30}]','[{2,324}]',324),(1008,19,1,2500,'[{1,6888},{2,137684},{3,3439},{4,3439},{5,1722},{6,1722},{7,1722},{8,1722}]',791794,'[{18020002,30}]','[{1,16}]',320),(1008,19,2,2500,'[{1,7103},{2,141989},{3,3547},{4,3547},{5,1776},{6,1776},{7,1776},{8,1776}]',816599,'[{18020002,30}]','[{2,330}]',330),(1008,19,3,2500,'[{1,7321},{2,146348},{3,3656},{4,3656},{5,1830},{6,1830},{7,1830},{8,1830}]',841568,'[{18020002,30}]','[{1,17}]',340),(1008,20,0,2770,'[{1,7549},{2,150913},{3,3770},{4,3770},{5,1887},{6,1887},{7,1887},{8,1887}]',867793,'[{18020002,30}]','[{2,351}]',351),(1008,20,1,2770,'[{1,7780},{2,155536},{3,3886},{4,3886},{5,1945},{6,1945},{7,1945},{8,1945}]',894436,'[{18020002,30}]','[{1,18}]',360),(1008,20,2,2770,'[{1,8014},{2,160218},{3,4003},{4,4003},{5,2004},{6,2004},{7,2004},{8,2004}]',921448,'[{18020002,30}]','[{2,354}]',354),(1008,20,3,2770,'[{1,8251},{2,164958},{3,4121},{4,4121},{5,2063},{6,2063},{7,2063},{8,2063}]',948628,'[{18020002,30}]','[{1,19}]',380),(1008,21,0,3070,'[{1,8499},{2,169913},{3,4245},{4,4245},{5,2125},{6,2125},{7,2125},{8,2125}]',977143,'[{18020003,90}]','[{2,377}]',377),(1008,21,1,3070,'[{1,8750},{2,174926},{3,4370},{4,4370},{5,2188},{6,2188},{7,2188},{8,2188}]',1006026,'[{18020003,90}]','[{1,19}]',380),(1008,21,2,3070,'[{1,9004},{2,179997},{3,4497},{4,4497},{5,2251},{6,2251},{7,2251},{8,2251}]',1035127,'[{18020003,90}]','[{2,383}]',383),(1008,21,3,3070,'[{1,9260},{2,185127},{3,4625},{4,4625},{5,2315},{6,2315},{7,2315},{8,2315}]',1064577,'[{18020003,90}]','[{1,20}]',400),(1008,22,0,3370,'[{1,9528},{2,190481},{3,4759},{4,4759},{5,2382},{6,2382},{7,2382},{8,2382}]',1095391,'[{18020003,90}]','[{2,402}]',402),(1008,22,1,3370,'[{1,9799},{2,195897},{3,4894},{4,4894},{5,2450},{6,2450},{7,2450},{8,2450}]',1126577,'[{18020003,90}]','[{1,20}]',400),(1008,22,2,3370,'[{1,10073},{2,201376},{3,5031},{4,5031},{5,2518},{6,2518},{7,2518},{8,2518}]',1157986,'[{18020003,90}]','[{2,409}]',409),(1008,22,3,3370,'[{1,10350},{2,206918},{3,5170},{4,5170},{5,2587},{6,2587},{7,2587},{8,2587}]',1189818,'[{18020003,90}]','[{1,21}]',420),(1008,23,0,3720,'[{1,10639},{2,212693},{3,5314},{4,5314},{5,2659},{6,2659},{7,2659},{8,2659}]',1222973,'[{18020003,90}]','[{2,432}]',432),(1008,23,1,3720,'[{1,10931},{2,218530},{3,5460},{4,5460},{5,2732},{6,2732},{7,2732},{8,2732}]',1256550,'[{18020003,90}]','[{1,22}]',440),(1008,23,2,3720,'[{1,11226},{2,224430},{3,5608},{4,5608},{5,2806},{6,2806},{7,2806},{8,2806}]',1290550,'[{18020003,90}]','[{2,438}]',438),(1008,23,3,3720,'[{1,11524},{2,230393},{3,5757},{4,5757},{5,2881},{6,2881},{7,2881},{8,2881}]',1324923,'[{18020003,90}]','[{1,23}]',460),(1008,24,0,4070,'[{1,11834},{2,236598},{3,5912},{4,5912},{5,2959},{6,2959},{7,2959},{8,2959}]',1360678,'[{18020003,90}]','[{2,462}]',462),(1008,24,1,4070,'[{1,12148},{2,242870},{3,6069},{4,6069},{5,3037},{6,3037},{7,3037},{8,3037}]',1396680,'[{18020003,90}]','[{1,23}]',460),(1008,24,2,4070,'[{1,12465},{2,249209},{3,6227},{4,6227},{5,3116},{6,3116},{7,3116},{8,3116}]',1433059,'[{18020003,90}]','[{2,469}]',469),(1008,24,3,4070,'[{1,12785},{2,255615},{3,6387},{4,6387},{5,3196},{6,3196},{7,3196},{8,3196}]',1469865,'[{18020003,90}]','[{1,24}]',480),(1008,25,0,4470,'[{1,13118},{2,262272},{3,6553},{4,6553},{5,3279},{6,3279},{7,3279},{8,3279}]',1508082,'[{18020003,90}]','[{2,492}]',492),(1008,25,1,4470,'[{1,13454},{2,269001},{3,6721},{4,6721},{5,3363},{6,3363},{7,3363},{8,3363}]',1546731,'[{18020003,90}]','[{1,25}]',500),(1008,25,2,4470,'[{1,13794},{2,275802},{3,6891},{4,6891},{5,3448},{6,3448},{7,3448},{8,3448}]',1585832,'[{18020003,90}]','[{2,499}]',499),(1008,25,3,4470,'[{1,14138},{2,282674},{3,7063},{4,7063},{5,3534},{6,3534},{7,3534},{8,3534}]',1625384,'[{18020003,90}]','[{1,26}]',520),(1008,26,0,4870,'[{1,14495},{2,289806},{3,7241},{4,7241},{5,3623},{6,3623},{7,3623},{8,3623}]',1666356,'[{18020003,90}]','[{2,524}]',524),(1008,26,1,4870,'[{1,14855},{2,297010},{3,7421},{4,7421},{5,3713},{6,3713},{7,3713},{8,3713}]',1707760,'[{18020003,90}]','[{1,26}]',520),(1008,26,2,4870,'[{1,15219},{2,304286},{3,7603},{4,7603},{5,3804},{6,3804},{7,3804},{8,3804}]',1749616,'[{18020003,90}]','[{2,534}]',534),(1008,26,3,4870,'[{1,15586},{2,311633},{3,7787},{4,7787},{5,3896},{6,3896},{7,3896},{8,3896}]',1791903,'[{18020003,90}]','[{1,28}]',560),(1008,27,0,5320,'[{1,15967},{2,319249},{3,7977},{4,7977},{5,3991},{6,3991},{7,3991},{8,3991}]',1835639,'[{18020003,90}]','[{2,559}]',559),(1008,27,1,5320,'[{1,16352},{2,326946},{3,8169},{4,8169},{5,4087},{6,4087},{7,4087},{8,4087}]',1879836,'[{18020003,90}]','[{1,28}]',560),(1008,27,2,5320,'[{1,16741},{2,334723},{3,8363},{4,8363},{5,4184},{6,4184},{7,4184},{8,4184}]',1924493,'[{18020003,90}]','[{2,566}]',566),(1008,27,3,5320,'[{1,17134},{2,342581},{3,8559},{4,8559},{5,4282},{6,4282},{7,4282},{8,4282}]',1969611,'[{18020003,90}]','[{1,29}]',580),(1008,28,0,5770,'[{1,17541},{2,350717},{3,8762},{4,8762},{5,4384},{6,4384},{7,4384},{8,4384}]',2016437,'[{18020003,90}]','[{2,595}]',595),(1008,28,1,5770,'[{1,17952},{2,358933},{3,8967},{4,8967},{5,4487},{6,4487},{7,4487},{8,4487}]',2063723,'[{18020003,90}]','[{1,30}]',600),(1008,28,2,5770,'[{1,18367},{2,367230},{3,9174},{4,9174},{5,4591},{6,4591},{7,4591},{8,4591}]',2111470,'[{18020003,90}]','[{2,604}]',604),(1008,28,3,5770,'[{1,18786},{2,375608},{3,9383},{4,9383},{5,4696},{6,4696},{7,4696},{8,4696}]',2159678,'[{18020003,90}]','[{1,31}]',620),(1008,29,0,6270,'[{1,19219},{2,384272},{3,9600},{4,9600},{5,4804},{6,4804},{7,4804},{8,4804}]',2209452,'[{18020003,90}]','[{2,633}]',633),(1008,29,1,6270,'[{1,19656},{2,393017},{3,9819},{4,9819},{5,4913},{6,4913},{7,4913},{8,4913}]',2259687,'[{18020003,90}]','[{1,32}]',640),(1008,29,2,6270,'[{1,20097},{2,401843},{3,10040},{4,10040},{5,5023},{6,5023},{7,5023},{8,5023}]',2310383,'[{18020003,90}]','[{2,644}]',644),(1008,29,3,6270,'[{1,20542},{2,410749},{3,10263},{4,10263},{5,5134},{6,5134},{7,5134},{8,5134}]',2361539,'[{18020003,90}]','[{1,33}]',660),(1008,30,0,6770,'[{1,21002},{2,419951},{3,10493},{4,10493},{5,5249},{6,5249},{7,5249},{8,5249}]',2414441,'[{18020003,90}]','[{2,674}]',674),(1008,30,1,6770,'[{1,21466},{2,429234},{3,10725},{4,10725},{5,5365},{6,5365},{7,5365},{8,5365}]',2467804,'[{18020003,90}]','[{1,34}]',680),(1008,30,2,6770,'[{1,21934},{2,438597},{3,10959},{4,10959},{5,5482},{6,5482},{7,5482},{8,5482}]',2521627,'[{18020003,90}]','[{2,686}]',686),(1008,30,3,0,'[{1,22406},{2,448041},{3,11195},{4,11195},{5,5600},{6,5600},{7,5600},{8,5600}]',2575911,'[{18020003,90}]','[]',0),(1009,1,0,40,'[{1,420},{2,7717},{3,190},{4,214},{5,102},{6,100},{7,103},{8,99}]',46417,'[{18020001,10}]','[{2,35}]',35),(1009,1,1,40,'[{1,432},{2,7932},{3,195},{4,221},{5,105},{6,103},{7,106},{8,102}]',47772,'[{18020001,10}]','[{1,2}]',40),(1009,1,2,40,'[{1,443},{2,8150},{3,201},{4,227},{5,108},{6,106},{7,109},{8,105}]',49110,'[{18020001,10}]','[{2,37}]',37),(1009,1,3,40,'[{1,456},{2,8373},{3,207},{4,233},{5,112},{6,108},{7,112},{8,108}]',50493,'[{18020001,10}]','[{1,2}]',40),(1009,2,0,60,'[{1,470},{2,8639},{3,213},{4,241},{5,115},{6,111},{7,115},{8,111}]',51989,'[{18020001,10}]','[{2,43}]',43),(1009,2,1,60,'[{1,485},{2,8913},{3,220},{4,248},{5,119},{6,115},{7,119},{8,115}]',53713,'[{18020001,10}]','[{1,2}]',40),(1009,2,2,60,'[{1,501},{2,9197},{3,226},{4,256},{5,123},{6,119},{7,123},{8,119}]',55467,'[{18020001,10}]','[{2,45}]',45),(1009,2,3,60,'[{1,516},{2,9489},{3,234},{4,264},{5,127},{6,123},{7,128},{8,123}]',57309,'[{18020001,10}]','[{1,3}]',60),(1009,3,0,90,'[{1,535},{2,9831},{3,242},{4,274},{5,131},{6,127},{7,132},{8,126}]',59231,'[{18020001,10}]','[{2,52}]',52),(1009,3,1,90,'[{1,555},{2,10187},{3,251},{4,283},{5,136},{6,132},{7,137},{8,131}]',61437,'[{18020001,10}]','[{1,3}]',60),(1009,3,2,90,'[{1,575},{2,10556},{3,260},{4,294},{5,141},{6,137},{7,142},{8,136}]',63706,'[{18020001,10}]','[{2,55}]',55),(1009,3,3,90,'[{1,596},{2,10938},{3,269},{4,305},{5,146},{6,142},{7,147},{8,141}]',66008,'[{18020001,10}]','[{1,3}]',60),(1009,4,0,120,'[{1,620},{2,11379},{3,281},{4,317},{5,152},{6,148},{7,153},{8,147}]',68729,'[{18020001,10}]','[{2,62}]',62),(1009,4,1,120,'[{1,645},{2,11837},{3,292},{4,330},{5,158},{6,154},{7,159},{8,153}]',71487,'[{18020001,10}]','[{1,3}]',60),(1009,4,2,120,'[{1,671},{2,12313},{3,303},{4,343},{5,164},{6,160},{7,165},{8,159}]',74283,'[{18020001,10}]','[{2,65}]',65),(1009,4,3,120,'[{1,698},{2,12806},{3,316},{4,356},{5,170},{6,166},{7,171},{8,165}]',77166,'[{18020001,10}]','[{1,4}]',80),(1009,5,0,160,'[{1,728},{2,13367},{3,330},{4,372},{5,177},{6,173},{7,179},{8,172}]',80527,'[{18020001,10}]','[{2,72}]',72),(1009,5,1,160,'[{1,759},{2,13950},{3,344},{4,388},{5,186},{6,180},{7,187},{8,179}]',84030,'[{18020001,10}]','[{1,4}]',80),(1009,5,2,160,'[{1,793},{2,14555},{3,359},{4,405},{5,194},{6,188},{7,195},{8,187}]',87715,'[{18020001,10}]','[{2,76}]',76),(1009,5,3,160,'[{1,827},{2,15181},{3,374},{4,422},{5,202},{6,196},{7,203},{8,195}]',91421,'[{18020001,10}]','[{1,4}]',80),(1009,6,0,210,'[{1,866},{2,15884},{3,391},{4,441},{5,211},{6,205},{7,212},{8,204}]',95604,'[{18020001,10}]','[{2,84}]',84),(1009,6,1,210,'[{1,905},{2,16614},{3,408},{4,462},{5,221},{6,215},{7,222},{8,214}]',100064,'[{18020001,10}]','[{1,4}]',80),(1009,6,2,210,'[{1,946},{2,17368},{3,427},{4,483},{5,231},{6,225},{7,233},{8,223}]',104638,'[{18020001,10}]','[{2,88}]',88),(1009,6,3,210,'[{1,989},{2,18148},{3,446},{4,504},{5,241},{6,235},{7,243},{8,233}]',109278,'[{18020001,10}]','[{1,5}]',100),(1009,7,0,290,'[{1,1036},{2,19014},{3,468},{4,528},{5,252},{6,246},{7,254},{8,244}]',114434,'[{18020001,10}]','[{2,97}]',97),(1009,7,1,290,'[{1,1085},{2,19909},{3,489},{4,553},{5,265},{6,257},{7,266},{8,256}]',119859,'[{18020001,10}]','[{1,5}]',100),(1009,7,2,290,'[{1,1135},{2,20836},{3,512},{4,578},{5,277},{6,269},{7,278},{8,268}]',125386,'[{18020001,10}]','[{2,101}]',101),(1009,7,3,290,'[{1,1187},{2,21792},{3,535},{4,605},{5,289},{6,281},{7,291},{8,279}]',131032,'[{18020001,10}]','[{1,5}]',100),(1009,8,0,390,'[{1,1244},{2,22843},{3,561},{4,633},{5,303},{6,295},{7,305},{8,293}]',137373,'[{18020001,10}]','[{2,110}]',110),(1009,8,1,390,'[{1,1303},{2,23923},{3,587},{4,663},{5,317},{6,309},{7,319},{8,307}]',143833,'[{18020001,10}]','[{1,6}]',120),(1009,8,2,390,'[{1,1363},{2,25033},{3,614},{4,694},{5,333},{6,323},{7,335},{8,321}]',150593,'[{18020001,10}]','[{2,116}]',116),(1009,8,3,390,'[{1,1426},{2,26174},{3,642},{4,726},{5,348},{6,338},{7,350},{8,336}]',157494,'[{18020001,10}]','[{1,6}]',120),(1009,9,0,510,'[{1,1494},{2,27417},{3,672},{4,760},{5,364},{6,354},{7,366},{8,352}]',164897,'[{18020001,10}]','[{2,127}]',127),(1009,9,1,510,'[{1,1563},{2,28695},{3,703},{4,795},{5,381},{6,371},{7,384},{8,368}]',172605,'[{18020001,10}]','[{1,6}]',120),(1009,9,2,510,'[{1,1635},{2,30007},{3,735},{4,831},{5,399},{6,387},{7,401},{8,385}]',180457,'[{18020001,10}]','[{2,131}]',131),(1009,9,3,510,'[{1,1708},{2,31353},{3,768},{4,868},{5,417},{6,405},{7,419},{8,403}]',188613,'[{18020001,10}]','[{1,7}]',140),(1009,10,0,650,'[{1,1788},{2,32811},{3,804},{4,908},{5,436},{6,424},{7,439},{8,421}]',197371,'[{18020001,10}]','[{2,142}]',142),(1009,10,1,650,'[{1,1869},{2,34303},{3,840},{4,950},{5,455},{6,443},{7,458},{8,440}]',206233,'[{18020001,10}]','[{1,7}]',140),(1009,10,2,650,'[{1,1952},{2,35829},{3,878},{4,992},{5,476},{6,462},{7,478},{8,460}]',215419,'[{18020001,10}]','[{2,147}]',147),(1009,10,3,650,'[{1,2038},{2,37390},{3,916},{4,1036},{5,496},{6,482},{7,499},{8,479}]',224750,'[{18020001,10}]','[{1,8}]',160),(1009,11,0,810,'[{1,2130},{2,39070},{3,958},{4,1082},{5,518},{6,504},{7,521},{8,501}]',234870,'[{18020002,30}]','[{2,159}]',159),(1009,11,1,810,'[{1,2224},{2,40789},{3,1000},{4,1130},{5,540},{6,526},{7,544},{8,522}]',245119,'[{18020002,30}]','[{1,8}]',160),(1009,11,2,810,'[{1,2320},{2,42547},{3,1043},{4,1179},{5,564},{6,548},{7,567},{8,545}]',255697,'[{18020002,30}]','[{2,162}]',162),(1009,11,3,810,'[{1,2418},{2,44344},{3,1087},{4,1229},{5,587},{6,571},{7,591},{8,567}]',266404,'[{18020002,30}]','[{1,9}]',180),(1009,12,0,970,'[{1,2523},{2,46269},{3,1134},{4,1282},{5,612},{6,596},{7,616},{8,592}]',277929,'[{18020002,30}]','[{2,177}]',177),(1009,12,1,970,'[{1,2630},{2,48233},{3,1182},{4,1336},{5,639},{6,621},{7,643},{8,617}]',289783,'[{18020002,30}]','[{1,9}]',180),(1009,12,2,970,'[{1,2740},{2,50235},{3,1231},{4,1391},{5,665},{6,647},{7,669},{8,643}]',301785,'[{18020002,30}]','[{2,181}]',181),(1009,12,3,970,'[{1,2852},{2,52275},{3,1281},{4,1447},{5,693},{6,673},{7,697},{8,669}]',314115,'[{18020002,30}]','[{1,10}]',200),(1009,13,0,1150,'[{1,2970},{2,54453},{3,1334},{4,1508},{5,721},{6,701},{7,725},{8,697}]',327103,'[{18020002,30}]','[{2,194}]',194),(1009,13,1,1150,'[{1,3091},{2,56674},{3,1389},{4,1569},{5,750},{6,730},{7,755},{8,725}]',340444,'[{18020002,30}]','[{1,10}]',200),(1009,13,2,1150,'[{1,3215},{2,58938},{3,1444},{4,1632},{5,781},{6,759},{7,785},{8,755}]',354138,'[{18020002,30}]','[{2,198}]',198),(1009,13,3,1150,'[{1,3341},{2,61244},{3,1501},{4,1695},{5,811},{6,789},{7,816},{8,784}]',367964,'[{18020002,30}]','[{1,11}]',220),(1009,14,0,1330,'[{1,3474},{2,63697},{3,1561},{4,1763},{5,844},{6,820},{7,849},{8,815}]',382677,'[{18020002,30}]','[{2,212}]',212),(1009,14,1,1330,'[{1,3610},{2,66192},{3,1622},{4,1832},{5,877},{6,853},{7,882},{8,848}]',397742,'[{18020002,30}]','[{1,11}]',220),(1009,14,2,1330,'[{1,3749},{2,68730},{3,1684},{4,1902},{5,911},{6,885},{7,916},{8,880}]',412960,'[{18020002,30}]','[{2,218}]',218),(1009,14,3,1330,'[{1,3889},{2,71311},{3,1747},{4,1973},{5,945},{6,919},{7,951},{8,913}]',428491,'[{18020002,30}]','[{1,12}]',240),(1009,15,0,1540,'[{1,4038},{2,74046},{3,1813},{4,2049},{5,982},{6,954},{7,987},{8,949}]',444956,'[{18020002,30}]','[{2,234}]',234),(1009,15,1,1540,'[{1,4190},{2,76829},{3,1882},{4,2126},{5,1018},{6,990},{7,1024},{8,984}]',461629,'[{18020002,30}]','[{1,12}]',240),(1009,15,2,1540,'[{1,4344},{2,79659},{3,1951},{4,2205},{5,1056},{6,1026},{7,1062},{8,1020}]',478639,'[{18020002,30}]','[{2,239}]',239),(1009,15,3,1540,'[{1,4501},{2,82536},{3,2022},{4,2284},{5,1094},{6,1064},{7,1101},{8,1057}]',496006,'[{18020002,30}]','[{1,13}]',260),(1009,16,0,1750,'[{1,4666},{2,85575},{3,2096},{4,2368},{5,1135},{6,1103},{7,1141},{8,1097}]',514295,'[{18020002,30}]','[{2,256}]',256),(1009,16,1,1750,'[{1,4834},{2,88662},{3,2172},{4,2454},{5,1175},{6,1143},{7,1182},{8,1136}]',532792,'[{18020002,30}]','[{1,13}]',260),(1009,16,2,1750,'[{1,5005},{2,91796},{3,2249},{4,2541},{5,1217},{6,1183},{7,1224},{8,1176}]',551646,'[{18020002,30}]','[{2,259}]',259),(1009,16,3,1750,'[{1,5178},{2,94977},{3,2327},{4,2629},{5,1259},{6,1225},{7,1267},{8,1217}]',570837,'[{18020002,30}]','[{1,14}]',280),(1009,17,0,1990,'[{1,5361},{2,98330},{3,2409},{4,2723},{5,1304},{6,1268},{7,1312},{8,1260}]',591050,'[{18020002,30}]','[{2,276}]',276),(1009,17,1,1990,'[{1,5547},{2,101730},{3,2493},{4,2817},{5,1349},{6,1311},{7,1357},{8,1303}]',611420,'[{18020002,30}]','[{1,14}]',280),(1009,17,2,1990,'[{1,5734},{2,105177},{3,2578},{4,2912},{5,1394},{6,1356},{7,1403},{8,1348}]',632157,'[{18020002,30}]','[{2,284}]',284),(1009,17,3,1990,'[{1,5925},{2,108671},{3,2663},{4,3009},{5,1441},{6,1401},{7,1449},{8,1393}]',653171,'[{18020002,30}]','[{1,15}]',300),(1009,18,0,2230,'[{1,6126},{2,112345},{3,2753},{4,3111},{5,1490},{6,1448},{7,1498},{8,1440}]',675265,'[{18020002,30}]','[{2,300}]',300),(1009,18,1,2230,'[{1,6329},{2,116071},{3,2844},{4,3214},{5,1539},{6,1497},{7,1548},{8,1488}]',697701,'[{18020002,30}]','[{1,15}]',300),(1009,18,2,2230,'[{1,6534},{2,119848},{3,2937},{4,3319},{5,1589},{6,1545},{7,1598},{8,1536}]',720328,'[{18020002,30}]','[{2,307}]',307),(1009,18,3,2230,'[{1,6743},{2,123677},{3,3031},{4,3425},{5,1640},{6,1594},{7,1649},{8,1585}]',743337,'[{18020002,30}]','[{1,16}]',320),(1009,19,0,2500,'[{1,6962},{2,127694},{3,3130},{4,3536},{5,1692},{6,1646},{7,1702},{8,1636}]',767384,'[{18020002,30}]','[{2,325}]',325),(1009,19,1,2500,'[{1,7184},{2,131764},{3,3229},{4,3649},{5,1746},{6,1698},{7,1756},{8,1688}]',791794,'[{18020002,30}]','[{1,16}]',320),(1009,19,2,2500,'[{1,7408},{2,135883},{3,3331},{4,3763},{5,1801},{6,1751},{7,1812},{8,1740}]',816593,'[{18020002,30}]','[{2,332}]',332),(1009,19,3,2500,'[{1,7636},{2,140055},{3,3433},{4,3879},{5,1856},{6,1804},{7,1867},{8,1793}]',841575,'[{18020002,30}]','[{1,17}]',340),(1009,20,0,2770,'[{1,7874},{2,144424},{3,3540},{4,4000},{5,1913},{6,1861},{7,1925},{8,1849}]',867804,'[{18020002,30}]','[{2,350}]',350),(1009,20,1,2770,'[{1,8115},{2,148848},{3,3649},{4,4123},{5,1972},{6,1918},{7,1984},{8,1906}]',894448,'[{18020002,30}]','[{1,18}]',360),(1009,20,2,2770,'[{1,8359},{2,153329},{3,3759},{4,4247},{5,2032},{6,1976},{7,2044},{8,1964}]',921459,'[{18020002,30}]','[{2,355}]',355),(1009,20,3,2770,'[{1,8606},{2,157865},{3,3870},{4,4372},{5,2092},{6,2034},{7,2104},{8,2022}]',948635,'[{18020002,30}]','[{1,19}]',380),(1009,21,0,3070,'[{1,8864},{2,162607},{3,3986},{4,4504},{5,2155},{6,2095},{7,2168},{8,2083}]',977187,'[{18020003,90}]','[{2,375}]',375),(1009,21,1,3070,'[{1,9126},{2,167404},{3,4103},{4,4637},{5,2219},{6,2157},{7,2232},{8,2144}]',1006024,'[{18020003,90}]','[{1,19}]',380),(1009,21,2,3070,'[{1,9391},{2,172257},{3,4223},{4,4771},{5,2283},{6,2219},{7,2296},{8,2206}]',1035127,'[{18020003,90}]','[{2,382}]',382),(1009,21,3,3070,'[{1,9658},{2,177167},{3,4343},{4,4907},{5,2347},{6,2283},{7,2361},{8,2269}]',1064577,'[{18020003,90}]','[{1,20}]',400),(1009,22,0,3370,'[{1,9938},{2,182290},{3,4469},{4,5049},{5,2415},{6,2349},{7,2430},{8,2334}]',1095400,'[{18020003,90}]','[{2,402}]',402),(1009,22,1,3370,'[{1,10220},{2,187473},{3,4595},{4,5193},{5,2484},{6,2416},{7,2499},{8,2401}]',1126573,'[{18020003,90}]','[{1,20}]',400),(1009,22,2,3370,'[{1,10506},{2,192717},{3,4724},{4,5338},{5,2553},{6,2483},{7,2568},{8,2468}]',1157987,'[{18020003,90}]','[{2,410}]',410),(1009,22,3,3370,'[{1,10795},{2,198021},{3,4855},{4,5485},{5,2623},{6,2551},{7,2639},{8,2535}]',1189821,'[{18020003,90}]','[{1,21}]',420),(1009,23,0,3720,'[{1,11096},{2,203547},{3,4990},{4,5638},{5,2696},{6,2622},{7,2712},{8,2606}]',1222967,'[{18020003,90}]','[{2,431}]',431),(1009,23,1,3720,'[{1,11401},{2,209133},{3,5127},{4,5793},{5,2770},{6,2694},{7,2787},{8,2677}]',1256553,'[{18020003,90}]','[{1,22}]',440),(1009,23,2,3720,'[{1,11709},{2,214780},{3,5266},{4,5950},{5,2845},{6,2767},{7,2862},{8,2750}]',1290560,'[{18020003,90}]','[{2,438}]',438),(1009,23,3,3720,'[{1,12020},{2,220486},{3,5406},{4,6108},{5,2921},{6,2841},{7,2939},{8,2823}]',1324936,'[{18020003,90}]','[{1,23}]',460),(1009,24,0,4070,'[{1,12343},{2,226424},{3,5551},{4,6273},{5,3000},{6,2918},{7,3018},{8,2900}]',1360684,'[{18020003,90}]','[{2,460}]',460),(1009,24,1,4070,'[{1,12670},{2,232427},{3,5699},{4,6439},{5,3080},{6,2994},{7,3098},{8,2976}]',1396677,'[{18020003,90}]','[{1,23}]',460),(1009,24,2,4070,'[{1,13001},{2,238493},{3,5847},{4,6607},{5,3160},{6,3072},{7,3178},{8,3054}]',1433063,'[{18020003,90}]','[{2,467}]',467),(1009,24,3,4070,'[{1,13335},{2,244624},{3,5997},{4,6777},{5,3241},{6,3151},{7,3260},{8,3132}]',1469874,'[{18020003,90}]','[{1,24}]',480),(1009,25,0,4470,'[{1,13682},{2,250994},{3,6153},{4,6953},{5,3325},{6,3233},{7,3345},{8,3213}]',1508084,'[{18020003,90}]','[{2,491}]',491),(1009,25,1,4470,'[{1,14033},{2,257434},{3,6311},{4,7131},{5,3410},{6,3316},{7,3430},{8,3296}]',1546744,'[{18020003,90}]','[{1,25}]',500),(1009,25,2,4470,'[{1,14387},{2,263943},{3,6471},{4,7311},{5,3496},{6,3400},{7,3517},{8,3379}]',1585833,'[{18020003,90}]','[{2,499}]',499),(1009,25,3,4470,'[{1,14746},{2,270519},{3,6632},{4,7494},{5,3583},{6,3485},{7,3605},{8,3463}]',1625389,'[{18020003,90}]','[{1,26}]',520),(1009,26,0,4870,'[{1,15118},{2,277344},{3,6799},{4,7683},{5,3674},{6,3572},{7,3695},{8,3551}]',1666354,'[{18020003,90}]','[{2,524}]',524),(1009,26,1,4870,'[{1,15494},{2,284239},{3,6968},{4,7874},{5,3765},{6,3661},{7,3787},{8,3639}]',1707769,'[{18020003,90}]','[{1,26}]',520),(1009,26,2,4870,'[{1,15873},{2,291202},{3,7139},{4,8067},{5,3857},{6,3751},{7,3880},{8,3728}]',1749612,'[{18020003,90}]','[{2,532}]',532),(1009,26,3,4870,'[{1,16256},{2,298233},{3,7312},{4,8262},{5,3951},{6,3841},{7,3974},{8,3818}]',1791903,'[{18020003,90}]','[{1,28}]',560),(1009,27,0,5320,'[{1,16654},{2,305521},{3,7490},{4,8464},{5,4047},{6,3935},{7,4071},{8,3911}]',1835651,'[{18020003,90}]','[{2,558}]',558),(1009,27,1,5320,'[{1,17055},{2,312887},{3,7671},{4,8667},{5,4144},{6,4030},{7,4169},{8,4005}]',1879837,'[{18020003,90}]','[{1,28}]',560),(1009,27,2,5320,'[{1,17461},{2,320330},{3,7853},{4,8873},{5,4243},{6,4125},{7,4268},{8,4100}]',1924500,'[{18020003,90}]','[{2,567}]',567),(1009,27,3,5320,'[{1,17871},{2,327850},{3,8037},{4,9081},{5,4342},{6,4222},{7,4368},{8,4196}]',1969620,'[{18020003,90}]','[{1,29}]',580),(1009,28,0,5770,'[{1,18295},{2,335636},{3,8228},{4,9296},{5,4445},{6,4323},{7,4472},{8,4296}]',2016436,'[{18020003,90}]','[{2,594}]',594),(1009,28,1,5770,'[{1,18724},{2,343499},{3,8420},{4,9514},{5,4550},{6,4424},{7,4577},{8,4397}]',2063729,'[{18020003,90}]','[{1,30}]',600),(1009,28,2,5770,'[{1,19157},{2,351439},{3,8614},{4,9734},{5,4655},{6,4527},{7,4683},{8,4499}]',2111479,'[{18020003,90}]','[{2,604}]',604),(1009,28,3,5770,'[{1,19594},{2,359457},{3,8811},{4,9955},{5,4762},{6,4630},{7,4790},{8,4602}]',2159687,'[{18020003,90}]','[{1,31}]',620),(1009,29,0,6270,'[{1,20045},{2,367748},{3,9014},{4,10186},{5,4871},{6,4737},{7,4900},{8,4708}]',2209448,'[{18020003,90}]','[{2,631}]',631),(1009,29,1,6270,'[{1,20501},{2,376117},{3,9220},{4,10418},{5,4982},{6,4844},{7,5011},{8,4815}]',2259687,'[{18020003,90}]','[{1,32}]',640),(1009,29,2,6270,'[{1,20961},{2,384564},{3,9428},{4,10652},{5,5093},{6,4953},{7,5123},{8,4923}]',2310384,'[{18020003,90}]','[{2,643}]',643),(1009,29,3,6270,'[{1,21425},{2,393087},{3,9637},{4,10889},{5,5206},{6,5062},{7,5237},{8,5031}]',2361537,'[{18020003,90}]','[{1,33}]',660),(1009,30,0,6770,'[{1,21905},{2,401893},{3,9853},{4,11133},{5,5322},{6,5176},{7,5354},{8,5144}]',2414443,'[{18020003,90}]','[{2,671}]',671),(1009,30,1,6770,'[{1,22389},{2,410777},{3,10071},{4,11379},{5,5440},{6,5290},{7,5472},{8,5258}]',2467807,'[{18020003,90}]','[{1,34}]',680),(1009,30,2,6770,'[{1,22877},{2,419737},{3,10291},{4,11627},{5,5559},{6,5405},{7,5592},{8,5372}]',2521627,'[{18020003,90}]','[{2,686}]',686),(1009,30,3,0,'[{1,23369},{2,428775},{3,10512},{4,11878},{5,5678},{6,5522},{7,5712},{8,5488}]',2575905,'[{18020003,90}]','[]',0),(1010,1,0,40,'[{1,400},{2,8120},{3,201},{4,203},{5,95},{6,107},{7,91},{8,111}]',46420,'[{18020001,10}]','[{2,34}]',34),(1010,1,1,40,'[{1,411},{2,8346},{3,207},{4,209},{5,98},{6,110},{7,94},{8,114}]',47766,'[{18020001,10}]','[{1,2}]',40),(1010,1,2,40,'[{1,422},{2,8576},{3,213},{4,215},{5,101},{6,113},{7,97},{8,117}]',49116,'[{18020001,10}]','[{2,35}]',35),(1010,1,3,40,'[{1,434},{2,8810},{3,219},{4,221},{5,104},{6,116},{7,99},{8,121}]',50490,'[{18020001,10}]','[{1,2}]',40),(1010,2,0,60,'[{1,448},{2,9090},{3,226},{4,228},{5,106},{6,120},{7,102},{8,124}]',52000,'[{18020001,10}]','[{2,41}]',41),(1010,2,1,60,'[{1,462},{2,9379},{3,233},{4,235},{5,110},{6,124},{7,106},{8,128}]',53719,'[{18020001,10}]','[{1,2}]',40),(1010,2,2,60,'[{1,477},{2,9677},{3,240},{4,242},{5,114},{6,128},{7,109},{8,133}]',55467,'[{18020001,10}]','[{2,46}]',46),(1010,2,3,60,'[{1,492},{2,9984},{3,248},{4,250},{5,118},{6,132},{7,113},{8,137}]',57274,'[{18020001,10}]','[{1,3}]',60),(1010,3,0,90,'[{1,509},{2,10345},{3,257},{4,259},{5,122},{6,136},{7,117},{8,141}]',59225,'[{18020001,10}]','[{2,50}]',50),(1010,3,1,90,'[{1,528},{2,10720},{3,266},{4,268},{5,126},{6,142},{7,121},{8,147}]',61430,'[{18020001,10}]','[{1,3}]',60),(1010,3,2,90,'[{1,547},{2,11107},{3,276},{4,278},{5,131},{6,147},{7,126},{8,152}]',63697,'[{18020001,10}]','[{2,54}]',54),(1010,3,3,90,'[{1,567},{2,11509},{3,286},{4,288},{5,136},{6,152},{7,130},{8,158}]',65999,'[{18020001,10}]','[{1,3}]',60),(1010,4,0,120,'[{1,590},{2,11973},{3,298},{4,300},{5,141},{6,159},{7,136},{8,164}]',68723,'[{18020001,10}]','[{2,62}]',62),(1010,4,1,120,'[{1,614},{2,12456},{3,310},{4,312},{5,147},{6,165},{7,141},{8,171}]',71486,'[{18020001,10}]','[{1,3}]',60),(1010,4,2,120,'[{1,638},{2,12956},{3,322},{4,324},{5,153},{6,171},{7,146},{8,178}]',74266,'[{18020001,10}]','[{2,64}]',64),(1010,4,3,120,'[{1,664},{2,13475},{3,335},{4,337},{5,158},{6,178},{7,152},{8,184}]',77155,'[{18020001,10}]','[{1,3}]',60),(1010,5,0,160,'[{1,693},{2,14066},{3,350},{4,352},{5,165},{6,185},{7,158},{8,192}]',80476,'[{18020001,10}]','[{2,73}]',73),(1010,5,1,160,'[{1,723},{2,14679},{3,365},{4,367},{5,172},{6,194},{7,165},{8,201}]',84039,'[{18020001,10}]','[{1,4}]',80),(1010,5,2,160,'[{1,755},{2,15315},{3,381},{4,383},{5,180},{6,202},{7,173},{8,209}]',87715,'[{18020001,10}]','[{2,77}]',77),(1010,5,3,160,'[{1,787},{2,15974},{3,397},{4,399},{5,187},{6,211},{7,180},{8,218}]',91414,'[{18020001,10}]','[{1,4}]',80),(1010,6,0,210,'[{1,824},{2,16714},{3,415},{4,417},{5,196},{6,220},{7,188},{8,228}]',95594,'[{18020001,10}]','[{2,84}]',84),(1010,6,1,210,'[{1,862},{2,17482},{3,434},{4,436},{5,205},{6,231},{7,197},{8,239}]',100072,'[{18020001,10}]','[{1,4}]',80),(1010,6,2,210,'[{1,901},{2,18275},{3,454},{4,456},{5,215},{6,241},{7,206},{8,250}]',104645,'[{18020001,10}]','[{2,88}]',88),(1010,6,3,210,'[{1,941},{2,19096},{3,474},{4,476},{5,224},{6,252},{7,215},{8,261}]',109266,'[{18020001,10}]','[{1,5}]',100),(1010,7,0,290,'[{1,986},{2,20007},{3,497},{4,499},{5,235},{6,263},{7,225},{8,273}]',114427,'[{18020001,10}]','[{2,97}]',97),(1010,7,1,290,'[{1,1033},{2,20950},{3,519},{4,523},{5,246},{6,276},{7,236},{8,286}]',119860,'[{18020001,10}]','[{1,5}]',100),(1010,7,2,290,'[{1,1080},{2,21924},{3,543},{4,547},{5,257},{6,289},{7,247},{8,299}]',125374,'[{18020001,10}]','[{2,101}]',101),(1010,7,3,290,'[{1,1130},{2,22930},{3,568},{4,572},{5,268},{6,302},{7,258},{8,312}]',131030,'[{18020001,10}]','[{1,5}]',100),(1010,8,0,390,'[{1,1185},{2,24036},{3,595},{4,599},{5,282},{6,316},{7,270},{8,328}]',137386,'[{18020001,10}]','[{2,110}]',110),(1010,8,1,390,'[{1,1240},{2,25173},{3,623},{4,627},{5,295},{6,331},{7,283},{8,343}]',143823,'[{18020001,10}]','[{1,6}]',120),(1010,8,2,390,'[{1,1298},{2,26341},{3,652},{4,656},{5,309},{6,347},{7,297},{8,359}]',150601,'[{18020001,10}]','[{2,116}]',116),(1010,8,3,390,'[{1,1357},{2,27541},{3,682},{4,686},{5,323},{6,363},{7,310},{8,376}]',157481,'[{18020001,10}]','[{1,6}]',120),(1010,9,0,510,'[{1,1422},{2,28850},{3,714},{4,718},{5,338},{6,380},{7,325},{8,393}]',164890,'[{18020001,10}]','[{2,127}]',127),(1010,9,1,510,'[{1,1489},{2,30194},{3,747},{4,751},{5,354},{6,398},{7,340},{8,412}]',172624,'[{18020001,10}]','[{1,6}]',120),(1010,9,2,510,'[{1,1557},{2,31574},{3,781},{4,785},{5,370},{6,416},{7,355},{8,431}]',180464,'[{18020001,10}]','[{2,131}]',131),(1010,9,3,510,'[{1,1627},{2,32991},{3,816},{4,820},{5,387},{6,435},{7,372},{8,450}]',188631,'[{18020001,10}]','[{1,7}]',140),(1010,10,0,650,'[{1,1702},{2,34525},{3,853},{4,859},{5,405},{6,455},{7,389},{8,471}]',197365,'[{18020001,10}]','[{2,142}]',142),(1010,10,1,650,'[{1,1779},{2,36095},{3,892},{4,898},{5,423},{6,475},{7,406},{8,492}]',206225,'[{18020001,10}]','[{1,7}]',140),(1010,10,2,650,'[{1,1859},{2,37701},{3,932},{4,938},{5,442},{6,496},{7,424},{8,514}]',215431,'[{18020001,10}]','[{2,147}]',147),(1010,10,3,650,'[{1,1940},{2,39343},{3,973},{4,979},{5,461},{6,517},{7,442},{8,536}]',224743,'[{18020001,10}]','[{1,8}]',160),(1010,11,0,810,'[{1,2028},{2,41112},{3,1017},{4,1023},{5,481},{6,541},{7,462},{8,560}]',234872,'[{18020002,30}]','[{2,159}]',159),(1010,11,1,810,'[{1,2117},{2,42920},{3,1062},{4,1068},{5,502},{6,564},{7,482},{8,584}]',245110,'[{18020002,30}]','[{1,8}]',160),(1010,11,2,810,'[{1,2208},{2,44770},{3,1108},{4,1114},{5,524},{6,588},{7,503},{8,609}]',255680,'[{18020002,30}]','[{2,163}]',163),(1010,11,3,810,'[{1,2302},{2,46660},{3,1155},{4,1161},{5,545},{6,613},{7,523},{8,635}]',266400,'[{18020002,30}]','[{1,9}]',180),(1010,12,0,970,'[{1,2402},{2,48686},{3,1204},{4,1212},{5,569},{6,639},{7,546},{8,662}]',277926,'[{18020002,30}]','[{2,176}]',176),(1010,12,1,970,'[{1,2504},{2,50753},{3,1255},{4,1263},{5,593},{6,667},{7,570},{8,690}]',289783,'[{18020002,30}]','[{1,9}]',180),(1010,12,2,970,'[{1,2609},{2,52859},{3,1307},{4,1315},{5,618},{6,694},{7,593},{8,719}]',301789,'[{18020002,30}]','[{2,180}]',180),(1010,12,3,970,'[{1,2715},{2,55006},{3,1360},{4,1368},{5,643},{6,723},{7,617},{8,749}]',314106,'[{18020002,30}]','[{1,10}]',200),(1010,13,0,1150,'[{1,2828},{2,57298},{3,1417},{4,1425},{5,670},{6,752},{7,643},{8,779}]',327108,'[{18020002,30}]','[{2,194}]',194),(1010,13,1,1150,'[{1,2943},{2,59636},{3,1475},{4,1483},{5,697},{6,783},{7,669},{8,811}]',340446,'[{18020002,30}]','[{1,10}]',200),(1010,13,2,1150,'[{1,3060},{2,62017},{3,1533},{4,1543},{5,725},{6,815},{7,696},{8,844}]',354117,'[{18020002,30}]','[{2,199}]',199),(1010,13,3,1150,'[{1,3181},{2,64444},{3,1593},{4,1603},{5,754},{6,846},{7,723},{8,877}]',367964,'[{18020002,30}]','[{1,11}]',220),(1010,14,0,1330,'[{1,3308},{2,67025},{3,1657},{4,1667},{5,784},{6,880},{7,752},{8,912}]',382685,'[{18020002,30}]','[{2,213}]',213),(1010,14,1,1330,'[{1,3437},{2,69650},{3,1722},{4,1732},{5,815},{6,915},{7,782},{8,948}]',397740,'[{18020002,30}]','[{1,11}]',220),(1010,14,2,1330,'[{1,3569},{2,72321},{3,1788},{4,1798},{5,846},{6,950},{7,812},{8,984}]',412951,'[{18020002,30}]','[{2,219}]',219),(1010,14,3,1330,'[{1,3703},{2,75037},{3,1854},{4,1866},{5,878},{6,986},{7,843},{8,1021}]',428497,'[{18020002,30}]','[{1,12}]',240),(1010,15,0,1540,'[{1,3845},{2,77915},{3,1925},{4,1937},{5,912},{6,1024},{7,875},{8,1061}]',444965,'[{18020002,30}]','[{2,234}]',234),(1010,15,1,1540,'[{1,3989},{2,80843},{3,1998},{4,2010},{5,946},{6,1062},{7,908},{8,1100}]',461623,'[{18020002,30}]','[{1,12}]',240),(1010,15,2,1540,'[{1,4136},{2,83821},{3,2072},{4,2084},{5,981},{6,1101},{7,941},{8,1141}]',478641,'[{18020002,30}]','[{2,239}]',239),(1010,15,3,1540,'[{1,4285},{2,86848},{3,2147},{4,2159},{5,1016},{6,1142},{7,975},{8,1183}]',495998,'[{18020002,30}]','[{1,13}]',260),(1010,16,0,1750,'[{1,4443},{2,90046},{3,2225},{4,2239},{5,1054},{6,1184},{7,1012},{8,1226}]',514306,'[{18020002,30}]','[{2,255}]',255),(1010,16,1,1750,'[{1,4603},{2,93295},{3,2306},{4,2320},{5,1092},{6,1226},{7,1048},{8,1270}]',532805,'[{18020002,30}]','[{1,13}]',260),(1010,16,2,1750,'[{1,4765},{2,96592},{3,2388},{4,2402},{5,1130},{6,1270},{7,1085},{8,1315}]',551642,'[{18020002,30}]','[{2,260}]',260),(1010,16,3,1750,'[{1,4930},{2,99940},{3,2471},{4,2485},{5,1170},{6,1314},{7,1123},{8,1361}]',570840,'[{18020002,30}]','[{1,14}]',280),(1010,17,0,1990,'[{1,5104},{2,103467},{3,2558},{4,2574},{5,1211},{6,1361},{7,1163},{8,1409}]',591047,'[{18020002,30}]','[{2,277}]',277),(1010,17,1,1990,'[{1,5281},{2,107045},{3,2647},{4,2663},{5,1253},{6,1407},{7,1202},{8,1458}]',611415,'[{18020002,30}]','[{1,14}]',280),(1010,17,2,1990,'[{1,5460},{2,110672},{3,2737},{4,2753},{5,1295},{6,1455},{7,1243},{8,1507}]',632122,'[{18020002,30}]','[{2,282}]',282),(1010,17,3,1990,'[{1,5641},{2,114349},{3,2827},{4,2845},{5,1339},{6,1503},{7,1285},{8,1557}]',653169,'[{18020002,30}]','[{1,15}]',300),(1010,18,0,2230,'[{1,5832},{2,118215},{3,2923},{4,2941},{5,1384},{6,1554},{7,1328},{8,1610}]',675255,'[{18020002,30}]','[{2,301}]',301),(1010,18,1,2230,'[{1,6026},{2,122135},{3,3020},{4,3038},{5,1430},{6,1606},{7,1372},{8,1664}]',697705,'[{18020002,30}]','[{1,15}]',300),(1010,18,2,2230,'[{1,6221},{2,126110},{3,3119},{4,3137},{5,1476},{6,1658},{7,1417},{8,1717}]',720330,'[{18020002,30}]','[{2,306}]',306),(1010,18,3,2230,'[{1,6420},{2,130139},{3,3218},{4,3238},{5,1523},{6,1711},{7,1462},{8,1772}]',743339,'[{18020002,30}]','[{1,16}]',320),(1010,19,0,2500,'[{1,6628},{2,134366},{3,3323},{4,3343},{5,1572},{6,1766},{7,1509},{8,1829}]',767376,'[{18020002,30}]','[{2,326}]',326),(1010,19,1,2500,'[{1,6840},{2,138648},{3,3429},{4,3449},{5,1622},{6,1822},{7,1557},{8,1887}]',791798,'[{18020002,30}]','[{1,16}]',320),(1010,19,2,2500,'[{1,7053},{2,142983},{3,3536},{4,3558},{5,1673},{6,1879},{7,1606},{8,1946}]',816593,'[{18020002,30}]','[{2,331}]',331),(1010,19,3,2500,'[{1,7270},{2,147372},{3,3645},{4,3667},{5,1724},{6,1936},{7,1654},{8,2006}]',841572,'[{18020002,30}]','[{1,17}]',340),(1010,20,0,2770,'[{1,7496},{2,151969},{3,3759},{4,3781},{5,1778},{6,1996},{7,1706},{8,2068}]',867789,'[{18020002,30}]','[{2,350}]',350),(1010,20,1,2770,'[{1,7726},{2,156625},{3,3874},{4,3898},{5,1832},{6,2058},{7,1758},{8,2132}]',894445,'[{18020002,30}]','[{1,18}]',360),(1010,20,2,2770,'[{1,7958},{2,161340},{3,3991},{4,4015},{5,1888},{6,2120},{7,1812},{8,2196}]',921450,'[{18020002,30}]','[{2,356}]',356),(1010,20,3,2770,'[{1,8193},{2,166113},{3,4109},{4,4133},{5,1943},{6,2183},{7,1865},{8,2261}]',948623,'[{18020002,30}]','[{1,19}]',380),(1010,21,0,3070,'[{1,8440},{2,171102},{3,4232},{4,4258},{5,2002},{6,2248},{7,1921},{8,2329}]',977152,'[{18020003,90}]','[{2,376}]',376),(1010,21,1,3070,'[{1,8689},{2,176150},{3,4357},{4,4383},{5,2061},{6,2315},{7,1978},{8,2398}]',1006030,'[{18020003,90}]','[{1,19}]',380),(1010,21,2,3070,'[{1,8941},{2,181257},{3,4484},{4,4510},{5,2120},{6,2382},{7,2035},{8,2467}]',1035127,'[{18020003,90}]','[{2,381}]',381),(1010,21,3,3070,'[{1,9195},{2,186423},{3,4611},{4,4639},{5,2181},{6,2449},{7,2093},{8,2537}]',1064573,'[{18020003,90}]','[{1,20}]',400),(1010,22,0,3370,'[{1,9461},{2,191814},{3,4745},{4,4773},{5,2244},{6,2520},{7,2153},{8,2611}]',1095384,'[{18020003,90}]','[{2,403}]',403),(1010,22,1,3370,'[{1,9730},{2,197268},{3,4879},{4,4909},{5,2308},{6,2592},{7,2215},{8,2685}]',1126568,'[{18020003,90}]','[{1,20}]',400),(1010,22,2,3370,'[{1,10002},{2,202786},{3,5016},{4,5046},{5,2372},{6,2664},{7,2276},{8,2760}]',1157976,'[{18020003,90}]','[{2,409}]',409),(1010,22,3,3370,'[{1,10278},{2,208366},{3,5154},{4,5186},{5,2437},{6,2737},{7,2339},{8,2835}]',1189826,'[{18020003,90}]','[{1,21}]',420),(1010,23,0,3720,'[{1,10565},{2,214182},{3,5298},{4,5330},{5,2505},{6,2813},{7,2404},{8,2914}]',1222982,'[{18020003,90}]','[{2,431}]',431),(1010,23,1,3720,'[{1,10854},{2,220060},{3,5444},{4,5476},{5,2574},{6,2890},{7,2470},{8,2994}]',1256540,'[{18020003,90}]','[{1,22}]',440),(1010,23,2,3720,'[{1,11147},{2,226001},{3,5591},{4,5625},{5,2643},{6,2969},{7,2537},{8,3075}]',1290541,'[{18020003,90}]','[{2,438}]',438),(1010,23,3,3720,'[{1,11443},{2,232006},{3,5740},{4,5774},{5,2714},{6,3048},{7,2604},{8,3158}]',1324916,'[{18020003,90}]','[{1,23}]',460),(1010,24,0,4070,'[{1,11751},{2,238254},{3,5894},{4,5930},{5,2787},{6,3131},{7,2675},{8,3243}]',1360674,'[{18020003,90}]','[{2,460}]',460),(1010,24,1,4070,'[{1,12063},{2,244570},{3,6051},{4,6087},{5,2861},{6,3213},{7,2745},{8,3329}]',1396680,'[{18020003,90}]','[{1,23}]',460),(1010,24,2,4070,'[{1,12378},{2,250953},{3,6208},{4,6246},{5,2935},{6,3297},{7,2817},{8,3415}]',1433063,'[{18020003,90}]','[{2,467}]',467),(1010,24,3,4070,'[{1,12696},{2,257404},{3,6368},{4,6406},{5,3011},{6,3381},{7,2889},{8,3503}]',1469874,'[{18020003,90}]','[{1,24}]',480),(1010,25,0,4470,'[{1,13026},{2,264108},{3,6533},{4,6573},{5,3089},{6,3469},{7,2964},{8,3594}]',1508078,'[{18020003,90}]','[{2,491}]',491),(1010,25,1,4470,'[{1,13360},{2,270884},{3,6701},{4,6741},{5,3168},{6,3558},{7,3040},{8,3686}]',1546734,'[{18020003,90}]','[{1,25}]',500),(1010,25,2,4470,'[{1,13697},{2,277733},{3,6870},{4,6912},{5,3248},{6,3648},{7,3117},{8,3779}]',1585823,'[{18020003,90}]','[{2,500}]',500),(1010,25,3,4470,'[{1,14039},{2,284653},{3,7042},{4,7084},{5,3329},{6,3739},{7,3195},{8,3873}]',1625383,'[{18020003,90}]','[{1,26}]',520),(1010,26,0,4870,'[{1,14394},{2,291835},{3,7219},{4,7263},{5,3413},{6,3833},{7,3275},{8,3971}]',1666365,'[{18020003,90}]','[{2,524}]',524),(1010,26,1,4870,'[{1,14751},{2,299089},{3,7399},{4,7443},{5,3498},{6,3928},{7,3357},{8,4069}]',1707759,'[{18020003,90}]','[{1,26}]',520),(1010,26,2,4870,'[{1,15112},{2,306416},{3,7580},{4,7626},{5,3583},{6,4025},{7,3439},{8,4169}]',1749606,'[{18020003,90}]','[{2,533}]',533),(1010,26,3,4870,'[{1,15477},{2,313814},{3,7764},{4,7810},{5,3670},{6,4122},{7,3522},{8,4270}]',1791904,'[{18020003,90}]','[{1,28}]',560),(1010,27,0,5320,'[{1,15855},{2,321484},{3,7953},{4,8001},{5,3760},{6,4222},{7,3608},{8,4374}]',1835634,'[{18020003,90}]','[{2,558}]',558),(1010,27,1,5320,'[{1,16238},{2,329235},{3,8144},{4,8194},{5,3850},{6,4324},{7,3695},{8,4479}]',1879845,'[{18020003,90}]','[{1,28}]',560),(1010,27,2,5320,'[{1,16624},{2,337066},{3,8338},{4,8388},{5,3941},{6,4427},{7,3782},{8,4586}]',1924496,'[{18020003,90}]','[{2,566}]',566),(1010,27,3,5320,'[{1,17014},{2,344979},{3,8533},{4,8585},{5,4034},{6,4530},{7,3871},{8,4693}]',1969609,'[{18020003,90}]','[{1,29}]',580),(1010,28,0,5770,'[{1,17418},{2,353172},{3,8736},{4,8788},{5,4130},{6,4638},{7,3963},{8,4805}]',2016432,'[{18020003,90}]','[{2,594}]',594),(1010,28,1,5770,'[{1,17826},{2,361446},{3,8940},{4,8994},{5,4227},{6,4747},{7,4056},{8,4918}]',2063716,'[{18020003,90}]','[{1,30}]',600),(1010,28,2,5770,'[{1,18238},{2,369801},{3,9146},{4,9202},{5,4325},{6,4857},{7,4150},{8,5032}]',2111461,'[{18020003,90}]','[{2,604}]',604),(1010,28,3,5770,'[{1,18654},{2,378237},{3,9355},{4,9411},{5,4424},{6,4968},{7,4245},{8,5147}]',2159667,'[{18020003,90}]','[{1,31}]',620),(1010,29,0,6270,'[{1,19084},{2,386962},{3,9571},{4,9629},{5,4525},{6,5083},{7,4343},{8,5265}]',2209442,'[{18020003,90}]','[{2,631}]',631),(1010,29,1,6270,'[{1,19518},{2,395768},{3,9790},{4,9848},{5,4628},{6,5198},{7,4441},{8,5385}]',2259678,'[{18020003,90}]','[{1,32}]',640),(1010,29,2,6270,'[{1,19956},{2,404656},{3,10010},{4,10070},{5,4732},{6,5314},{7,4541},{8,5505}]',2310376,'[{18020003,90}]','[{2,644}]',644),(1010,29,3,6270,'[{1,20398},{2,413624},{3,10232},{4,10294},{5,4836},{6,5432},{7,4641},{8,5627}]',2361534,'[{18020003,90}]','[{1,33}]',660),(1010,30,0,6770,'[{1,20855},{2,422891},{3,10462},{4,10524},{5,4945},{6,5553},{7,4745},{8,5753}]',2414441,'[{18020003,90}]','[{2,672}]',672),(1010,30,1,6770,'[{1,21316},{2,432239},{3,10693},{4,10757},{5,5054},{6,5676},{7,4850},{8,5880}]',2467809,'[{18020003,90}]','[{1,34}]',680),(1010,30,2,6770,'[{1,21780},{2,441667},{3,10926},{4,10992},{5,5164},{6,5800},{7,4956},{8,6008}]',2521617,'[{18020003,90}]','[{2,685}]',685),(1010,30,3,0,'[{1,22249},{2,451177},{3,11161},{4,11229},{5,5275},{6,5925},{7,5062},{8,6138}]',2575907,'[{18020003,90}]','[]',0),(1011,1,0,40,'[{1,409},{2,7943},{3,212},{4,192},{5,103},{6,99},{7,100},{8,102}]',46423,'[{18020001,10}]','[{2,34}]',34),(1011,1,1,40,'[{1,420},{2,8164},{3,219},{4,197},{5,106},{6,102},{7,103},{8,105}]',47764,'[{18020001,10}]','[{1,2}]',40),(1011,1,2,40,'[{1,431},{2,8388},{3,225},{4,203},{5,109},{6,105},{7,106},{8,108}]',49108,'[{18020001,10}]','[{2,36}]',36),(1011,1,3,40,'[{1,444},{2,8618},{3,231},{4,209},{5,112},{6,108},{7,109},{8,111}]',50498,'[{18020001,10}]','[{1,2}]',40),(1011,2,0,60,'[{1,458},{2,8892},{3,239},{4,215},{5,115},{6,111},{7,112},{8,114}]',52002,'[{18020001,10}]','[{2,42}]',42),(1011,2,1,60,'[{1,472},{2,9174},{3,246},{4,222},{5,119},{6,115},{7,116},{8,118}]',53714,'[{18020001,10}]','[{1,2}]',40),(1011,2,2,60,'[{1,487},{2,9466},{3,253},{4,229},{5,123},{6,119},{7,120},{8,122}]',55456,'[{18020001,10}]','[{2,44}]',44),(1011,2,3,60,'[{1,502},{2,9766},{3,262},{4,236},{5,127},{6,123},{7,124},{8,126}]',57256,'[{18020001,10}]','[{1,3}]',60),(1011,3,0,90,'[{1,521},{2,10119},{3,271},{4,245},{5,131},{6,127},{7,128},{8,130}]',59239,'[{18020001,10}]','[{2,51}]',51),(1011,3,1,90,'[{1,540},{2,10485},{3,281},{4,253},{5,136},{6,132},{7,133},{8,135}]',61435,'[{18020001,10}]','[{1,3}]',60),(1011,3,2,90,'[{1,559},{2,10865},{3,291},{4,263},{5,141},{6,137},{7,138},{8,140}]',63695,'[{18020001,10}]','[{2,55}]',55),(1011,3,3,90,'[{1,580},{2,11258},{3,302},{4,272},{5,146},{6,142},{7,143},{8,145}]',66008,'[{18020001,10}]','[{1,3}]',60),(1011,4,0,120,'[{1,603},{2,11712},{3,314},{4,284},{5,152},{6,148},{7,149},{8,151}]',68722,'[{18020001,10}]','[{2,61}]',61),(1011,4,1,120,'[{1,627},{2,12183},{3,327},{4,295},{5,158},{6,154},{7,155},{8,157}]',71473,'[{18020001,10}]','[{1,3}]',60),(1011,4,2,120,'[{1,653},{2,12673},{3,339},{4,307},{5,164},{6,160},{7,161},{8,163}]',74283,'[{18020001,10}]','[{2,65}]',65),(1011,4,3,120,'[{1,679},{2,13180},{3,353},{4,319},{5,171},{6,165},{7,167},{8,169}]',77160,'[{18020001,10}]','[{1,4}]',80),(1011,5,0,160,'[{1,708},{2,13758},{3,369},{4,333},{5,178},{6,172},{7,174},{8,176}]',80468,'[{18020001,10}]','[{2,72}]',72),(1011,5,1,160,'[{1,739},{2,14358},{3,385},{4,347},{5,186},{6,180},{7,182},{8,184}]',84038,'[{18020001,10}]','[{1,4}]',80),(1011,5,2,160,'[{1,771},{2,14981},{3,401},{4,363},{5,194},{6,188},{7,190},{8,192}]',87701,'[{18020001,10}]','[{2,75}]',75),(1011,5,3,160,'[{1,805},{2,15625},{3,418},{4,378},{5,202},{6,196},{7,198},{8,200}]',91425,'[{18020001,10}]','[{1,4}]',80),(1011,6,0,210,'[{1,842},{2,16349},{3,437},{4,395},{5,211},{6,205},{7,207},{8,209}]',95589,'[{18020001,10}]','[{2,83}]',83),(1011,6,1,210,'[{1,881},{2,17100},{3,457},{4,413},{5,221},{6,215},{7,217},{8,219}]',100070,'[{18020001,10}]','[{1,4}]',80),(1011,6,2,210,'[{1,921},{2,17876},{3,478},{4,432},{5,231},{6,225},{7,227},{8,229}]',104646,'[{18020001,10}]','[{2,88}]',88),(1011,6,3,210,'[{1,962},{2,18679},{3,499},{4,451},{5,242},{6,234},{7,237},{8,239}]',109269,'[{18020001,10}]','[{1,5}]',100),(1011,7,0,290,'[{1,1008},{2,19570},{3,523},{4,473},{5,253},{6,245},{7,248},{8,250}]',114430,'[{18020001,10}]','[{2,96}]',96),(1011,7,1,290,'[{1,1056},{2,20492},{3,548},{4,494},{5,265},{6,257},{7,260},{8,262}]',119862,'[{18020001,10}]','[{1,5}]',100),(1011,7,2,290,'[{1,1104},{2,21445},{3,573},{4,517},{5,277},{6,269},{7,272},{8,274}]',125375,'[{18020001,10}]','[{2,102}]',102),(1011,7,3,290,'[{1,1155},{2,22429},{3,599},{4,541},{5,289},{6,281},{7,284},{8,286}]',131029,'[{18020001,10}]','[{1,5}]',100),(1011,8,0,390,'[{1,1211},{2,23511},{3,627},{4,567},{5,303},{6,295},{7,298},{8,300}]',137381,'[{18020001,10}]','[{2,111}]',111),(1011,8,1,390,'[{1,1268},{2,24623},{3,657},{4,593},{5,318},{6,308},{7,311},{8,315}]',143833,'[{18020001,10}]','[{1,6}]',120),(1011,8,2,390,'[{1,1327},{2,25766},{3,687},{4,621},{5,333},{6,323},{7,326},{8,330}]',150606,'[{18020001,10}]','[{2,116}]',116),(1011,8,3,390,'[{1,1388},{2,26940},{3,719},{4,649},{5,348},{6,338},{7,341},{8,345}]',157500,'[{18020001,10}]','[{1,6}]',120),(1011,9,0,510,'[{1,1453},{2,28219},{3,753},{4,679},{5,364},{6,354},{7,357},{8,361}]',164879,'[{18020001,10}]','[{2,126}]',126),(1011,9,1,510,'[{1,1521},{2,29534},{3,787},{4,711},{5,382},{6,370},{7,374},{8,378}]',172604,'[{18020001,10}]','[{1,6}]',120),(1011,9,2,510,'[{1,1592},{2,30885},{3,823},{4,743},{5,399},{6,387},{7,391},{8,395}]',180475,'[{18020001,10}]','[{2,131}]',131),(1011,9,3,510,'[{1,1663},{2,32271},{3,860},{4,776},{5,417},{6,405},{7,409},{8,413}]',188631,'[{18020001,10}]','[{1,7}]',140),(1011,10,0,650,'[{1,1740},{2,33771},{3,900},{4,812},{5,436},{6,424},{7,428},{8,432}]',197371,'[{18020001,10}]','[{2,142}]',142),(1011,10,1,650,'[{1,1819},{2,35306},{3,941},{4,849},{5,456},{6,442},{7,447},{8,451}]',206236,'[{18020001,10}]','[{1,7}]',140),(1011,10,2,650,'[{1,1900},{2,36877},{3,983},{4,887},{5,476},{6,462},{7,467},{8,471}]',215427,'[{18020001,10}]','[{2,147}]',147),(1011,10,3,650,'[{1,1983},{2,38484},{3,1026},{4,926},{5,496},{6,482},{7,487},{8,491}]',224744,'[{18020001,10}]','[{1,8}]',160),(1011,11,0,810,'[{1,2073},{2,40214},{3,1072},{4,968},{5,519},{6,503},{7,508},{8,514}]',234874,'[{18020002,30}]','[{2,159}]',159),(1011,11,1,810,'[{1,2164},{2,41983},{3,1119},{4,1011},{5,541},{6,525},{7,530},{8,536}]',245113,'[{18020002,30}]','[{1,8}]',160),(1011,11,2,810,'[{1,2257},{2,43792},{3,1168},{4,1054},{5,564},{6,548},{7,553},{8,559}]',255682,'[{18020002,30}]','[{2,164}]',164),(1011,11,3,810,'[{1,2353},{2,45641},{3,1217},{4,1099},{5,588},{6,570},{7,576},{8,582}]',266401,'[{18020002,30}]','[{1,9}]',180),(1011,12,0,970,'[{1,2455},{2,47623},{3,1270},{4,1146},{5,613},{6,595},{7,601},{8,607}]',277923,'[{18020002,30}]','[{2,176}]',176),(1011,12,1,970,'[{1,2560},{2,49644},{3,1323},{4,1195},{5,639},{6,621},{7,627},{8,633}]',289794,'[{18020002,30}]','[{1,9}]',180),(1011,12,2,970,'[{1,2666},{2,51705},{3,1378},{4,1244},{5,666},{6,646},{7,653},{8,659}]',301775,'[{18020002,30}]','[{2,181}]',181),(1011,12,3,970,'[{1,2775},{2,53805},{3,1434},{4,1294},{5,693},{6,673},{7,680},{8,686}]',314105,'[{18020002,30}]','[{1,10}]',200),(1011,13,0,1150,'[{1,2891},{2,56047},{3,1493},{4,1349},{5,722},{6,700},{7,707},{8,715}]',327117,'[{18020002,30}]','[{2,194}]',194),(1011,13,1,1150,'[{1,3008},{2,58333},{3,1554},{4,1404},{5,751},{6,729},{7,736},{8,744}]',340443,'[{18020002,30}]','[{1,10}]',200),(1011,13,2,1150,'[{1,3128},{2,60662},{3,1616},{4,1460},{5,782},{6,758},{7,766},{8,774}]',354122,'[{18020002,30}]','[{2,198}]',198),(1011,13,3,1150,'[{1,3251},{2,63036},{3,1679},{4,1517},{5,812},{6,788},{7,796},{8,804}]',367956,'[{18020002,30}]','[{1,11}]',220),(1011,14,0,1330,'[{1,3381},{2,65561},{3,1747},{4,1577},{5,844},{6,820},{7,828},{8,836}]',382681,'[{18020002,30}]','[{2,214}]',214),(1011,14,1,1330,'[{1,3513},{2,68129},{3,1815},{4,1639},{5,878},{6,852},{7,861},{8,869}]',397739,'[{18020002,30}]','[{1,11}]',220),(1011,14,2,1330,'[{1,3648},{2,70741},{3,1884},{4,1702},{5,911},{6,885},{7,894},{8,902}]',412951,'[{18020002,30}]','[{2,219}]',219),(1011,14,3,1330,'[{1,3785},{2,73397},{3,1955},{4,1765},{5,946},{6,918},{7,927},{8,937}]',428497,'[{18020002,30}]','[{1,12}]',240),(1011,15,0,1540,'[{1,3930},{2,76212},{3,2029},{4,1833},{5,983},{6,953},{7,963},{8,973}]',444962,'[{18020002,30}]','[{2,232}]',232),(1011,15,1,1540,'[{1,4077},{2,79077},{3,2106},{4,1902},{5,1019},{6,989},{7,999},{8,1009}]',461617,'[{18020002,30}]','[{1,12}]',240),(1011,15,2,1540,'[{1,4227},{2,81989},{3,2184},{4,1972},{5,1057},{6,1025},{7,1036},{8,1046}]',478629,'[{18020002,30}]','[{2,240}]',240),(1011,15,3,1540,'[{1,4380},{2,84950},{3,2263},{4,2043},{5,1095},{6,1063},{7,1074},{8,1084}]',496000,'[{18020002,30}]','[{1,13}]',260),(1011,16,0,1750,'[{1,4541},{2,88079},{3,2346},{4,2118},{5,1136},{6,1102},{7,1113},{8,1125}]',514299,'[{18020002,30}]','[{2,254}]',254),(1011,16,1,1750,'[{1,4705},{2,91256},{3,2431},{4,2195},{5,1176},{6,1142},{7,1153},{8,1165}]',532806,'[{18020002,30}]','[{1,13}]',260),(1011,16,2,1750,'[{1,4871},{2,94482},{3,2517},{4,2273},{5,1218},{6,1182},{7,1194},{8,1206}]',551652,'[{18020002,30}]','[{2,261}]',261),(1011,16,3,1750,'[{1,5039},{2,97756},{3,2604},{4,2352},{5,1261},{6,1223},{7,1236},{8,1248}]',570836,'[{18020002,30}]','[{1,14}]',280),(1011,17,0,1990,'[{1,5217},{2,101207},{3,2697},{4,2435},{5,1305},{6,1267},{7,1280},{8,1292}]',591047,'[{18020002,30}]','[{2,277}]',277),(1011,17,1,1990,'[{1,5398},{2,104706},{3,2790},{4,2520},{5,1350},{6,1310},{7,1323},{8,1337}]',611416,'[{18020002,30}]','[{1,14}]',280),(1011,17,2,1990,'[{1,5580},{2,108254},{3,2885},{4,2605},{5,1396},{6,1354},{7,1368},{8,1382}]',632104,'[{18020002,30}]','[{2,284}]',284),(1011,17,3,1990,'[{1,5766},{2,111851},{3,2981},{4,2691},{5,1442},{6,1400},{7,1414},{8,1428}]',653171,'[{18020002,30}]','[{1,15}]',300),(1011,18,0,2230,'[{1,5961},{2,115632},{3,3082},{4,2782},{5,1491},{6,1447},{7,1462},{8,1476}]',675252,'[{18020002,30}]','[{2,301}]',301),(1011,18,1,2230,'[{1,6159},{2,119467},{3,3183},{4,2875},{5,1541},{6,1495},{7,1510},{8,1526}]',697697,'[{18020002,30}]','[{1,15}]',300),(1011,18,2,2230,'[{1,6359},{2,123355},{3,3288},{4,2968},{5,1591},{6,1543},{7,1559},{8,1575}]',720335,'[{18020002,30}]','[{2,306}]',306),(1011,18,3,2230,'[{1,6562},{2,127295},{3,3393},{4,3063},{5,1641},{6,1593},{7,1609},{8,1625}]',743335,'[{18020002,30}]','[{1,16}]',320),(1011,19,0,2500,'[{1,6775},{2,131431},{3,3503},{4,3163},{5,1694},{6,1644},{7,1661},{8,1677}]',767381,'[{18020002,30}]','[{2,325}]',325),(1011,19,1,2500,'[{1,6991},{2,135619},{3,3614},{4,3264},{5,1748},{6,1696},{7,1713},{8,1731}]',791789,'[{18020002,30}]','[{1,16}]',320),(1011,19,2,2500,'[{1,7210},{2,139859},{3,3728},{4,3366},{5,1803},{6,1749},{7,1767},{8,1785}]',816609,'[{18020002,30}]','[{2,331}]',331),(1011,19,3,2500,'[{1,7431},{2,144153},{3,3842},{4,3470},{5,1857},{6,1803},{7,1821},{8,1839}]',841573,'[{18020002,30}]','[{1,17}]',340),(1011,20,0,2770,'[{1,7662},{2,148649},{3,3962},{4,3578},{5,1915},{6,1859},{7,1878},{8,1896}]',867789,'[{18020002,30}]','[{2,349}]',349),(1011,20,1,2770,'[{1,7897},{2,153203},{3,4084},{4,3688},{5,1974},{6,1916},{7,1935},{8,1955}]',894443,'[{18020002,30}]','[{1,18}]',360),(1011,20,2,2770,'[{1,8134},{2,157815},{3,4207},{4,3799},{5,2034},{6,1974},{7,1994},{8,2014}]',921445,'[{18020002,30}]','[{2,356}]',356),(1011,20,3,2770,'[{1,8375},{2,162484},{3,4331},{4,3911},{5,2094},{6,2032},{7,2053},{8,2073}]',948634,'[{18020002,30}]','[{1,19}]',380),(1011,21,0,3070,'[{1,8626},{2,167364},{3,4461},{4,4029},{5,2157},{6,2093},{7,2114},{8,2136}]',977134,'[{18020003,90}]','[{2,376}]',376),(1011,21,1,3070,'[{1,8881},{2,172302},{3,4593},{4,4147},{5,2221},{6,2155},{7,2177},{8,2199}]',1006022,'[{18020003,90}]','[{1,19}]',380),(1011,21,2,3070,'[{1,9139},{2,177297},{3,4726},{4,4268},{5,2285},{6,2217},{7,2240},{8,2262}]',1035127,'[{18020003,90}]','[{2,381}]',381),(1011,21,3,3070,'[{1,9399},{2,182350},{3,4861},{4,4389},{5,2350},{6,2280},{7,2303},{8,2327}]',1064580,'[{18020003,90}]','[{1,20}]',400),(1011,22,0,3370,'[{1,9671},{2,187624},{3,5002},{4,4516},{5,2418},{6,2346},{7,2370},{8,2394}]',1095394,'[{18020003,90}]','[{2,403}]',403),(1011,22,1,3370,'[{1,9946},{2,192959},{3,5144},{4,4644},{5,2487},{6,2413},{7,2438},{8,2462}]',1126579,'[{18020003,90}]','[{1,20}]',400),(1011,22,2,3370,'[{1,10224},{2,198355},{3,5288},{4,4774},{5,2556},{6,2480},{7,2505},{8,2531}]',1157985,'[{18020003,90}]','[{2,409}]',409),(1011,22,3,3370,'[{1,10505},{2,203814},{3,5434},{4,4906},{5,2626},{6,2548},{7,2574},{8,2600}]',1189814,'[{18020003,90}]','[{1,21}]',420),(1011,23,0,3720,'[{1,10799},{2,209503},{3,5585},{4,5043},{5,2699},{6,2619},{7,2646},{8,2672}]',1222983,'[{18020003,90}]','[{2,431}]',431),(1011,23,1,3720,'[{1,11095},{2,215252},{3,5738},{4,5182},{5,2773},{6,2691},{7,2718},{8,2746}]',1256552,'[{18020003,90}]','[{1,22}]',440),(1011,23,2,3720,'[{1,11394},{2,221064},{3,5894},{4,5322},{5,2848},{6,2764},{7,2792},{8,2820}]',1290544,'[{18020003,90}]','[{2,438}]',438),(1011,23,3,3720,'[{1,11697},{2,226937},{3,6051},{4,5463},{5,2924},{6,2838},{7,2867},{8,2895}]',1324927,'[{18020003,90}]','[{1,23}]',460),(1011,24,0,4070,'[{1,12012},{2,233049},{3,6214},{4,5610},{5,3003},{6,2915},{7,2944},{8,2974}]',1360689,'[{18020003,90}]','[{2,460}]',460),(1011,24,1,4070,'[{1,12330},{2,239227},{3,6379},{4,5759},{5,3083},{6,2991},{7,3022},{8,3052}]',1396677,'[{18020003,90}]','[{1,23}]',460),(1011,24,2,4070,'[{1,12652},{2,245471},{3,6545},{4,5909},{5,3163},{6,3069},{7,3100},{8,3132}]',1433061,'[{18020003,90}]','[{2,468}]',468),(1011,24,3,4070,'[{1,12977},{2,251781},{3,6713},{4,6061},{5,3244},{6,3148},{7,3180},{8,3212}]',1469871,'[{18020003,90}]','[{1,24}]',480),(1011,25,0,4470,'[{1,13315},{2,258338},{3,6887},{4,6219},{5,3328},{6,3230},{7,3263},{8,3295}]',1508088,'[{18020003,90}]','[{2,491}]',491),(1011,25,1,4470,'[{1,13656},{2,264966},{3,7064},{4,6378},{5,3413},{6,3313},{7,3346},{8,3380}]',1546736,'[{18020003,90}]','[{1,25}]',500),(1011,25,2,4470,'[{1,14001},{2,271665},{3,7242},{4,6540},{5,3500},{6,3396},{7,3431},{8,3465}]',1585835,'[{18020003,90}]','[{2,500}]',500),(1011,25,3,4470,'[{1,14350},{2,278434},{3,7423},{4,6703},{5,3587},{6,3481},{7,3516},{8,3552}]',1625384,'[{18020003,90}]','[{1,26}]',520),(1011,26,0,4870,'[{1,14712},{2,285459},{3,7610},{4,6872},{5,3677},{6,3569},{7,3605},{8,3641}]',1666349,'[{18020003,90}]','[{2,522}]',522),(1011,26,1,4870,'[{1,15078},{2,292555},{3,7799},{4,7043},{5,3769},{6,3657},{7,3694},{8,3732}]',1707765,'[{18020003,90}]','[{1,26}]',520),(1011,26,2,4870,'[{1,15447},{2,299722},{3,7991},{4,7215},{5,3861},{6,3747},{7,3785},{8,3823}]',1749612,'[{18020003,90}]','[{2,532}]',532),(1011,26,3,4870,'[{1,15820},{2,306959},{3,8184},{4,7390},{5,3954},{6,3838},{7,3877},{8,3915}]',1791909,'[{18020003,90}]','[{1,28}]',560),(1011,27,0,5320,'[{1,16207},{2,314460},{3,8384},{4,7570},{5,4051},{6,3931},{7,3971},{8,4011}]',1835650,'[{18020003,90}]','[{2,558}]',558),(1011,27,1,5320,'[{1,16597},{2,322042},{3,8586},{4,7752},{5,4148},{6,4026},{7,4067},{8,4107}]',1879832,'[{18020003,90}]','[{1,28}]',560),(1011,27,2,5320,'[{1,16992},{2,329702},{3,8790},{4,7936},{5,4247},{6,4121},{7,4163},{8,4205}]',1924492,'[{18020003,90}]','[{2,568}]',568),(1011,27,3,5320,'[{1,17391},{2,337442},{3,8996},{4,8122},{5,4346},{6,4218},{7,4261},{8,4303}]',1969612,'[{18020003,90}]','[{1,29}]',580),(1011,28,0,5770,'[{1,17804},{2,345456},{3,9209},{4,8315},{5,4450},{6,4318},{7,4362},{8,4406}]',2016436,'[{18020003,90}]','[{2,594}]',594),(1011,28,1,5770,'[{1,18221},{2,353549},{3,9424},{4,8510},{5,4554},{6,4420},{7,4465},{8,4509}]',2063719,'[{18020003,90}]','[{1,30}]',600),(1011,28,2,5770,'[{1,18643},{2,361722},{3,9642},{4,8706},{5,4660},{6,4522},{7,4568},{8,4614}]',2111482,'[{18020003,90}]','[{2,604}]',604),(1011,28,3,5770,'[{1,19068},{2,369974},{3,9862},{4,8904},{5,4766},{6,4626},{7,4673},{8,4719}]',2159684,'[{18020003,90}]','[{1,31}]',620),(1011,29,0,6270,'[{1,19507},{2,378508},{3,10090},{4,9110},{5,4876},{6,4732},{7,4780},{8,4828}]',2209448,'[{18020003,90}]','[{2,632}]',632),(1011,29,1,6270,'[{1,19951},{2,387122},{3,10320},{4,9318},{5,4987},{6,4839},{7,4888},{8,4938}]',2259692,'[{18020003,90}]','[{1,32}]',640),(1011,29,2,6270,'[{1,20398},{2,395815},{3,10552},{4,9528},{5,5098},{6,4948},{7,4998},{8,5048}]',2310375,'[{18020003,90}]','[{2,644}]',644),(1011,29,3,6270,'[{1,20850},{2,404588},{3,10786},{4,9740},{5,5211},{6,5057},{7,5108},{8,5160}]',2361538,'[{18020003,90}]','[{1,33}]',660),(1011,30,0,6770,'[{1,21317},{2,413652},{3,11028},{4,9958},{5,5328},{6,5170},{7,5223},{8,5275}]',2414442,'[{18020003,90}]','[{2,673}]',673),(1011,30,1,6770,'[{1,21788},{2,422795},{3,11272},{4,10178},{5,5445},{6,5285},{7,5338},{8,5392}]',2467805,'[{18020003,90}]','[{1,34}]',680),(1011,30,2,6770,'[{1,22263},{2,432018},{3,11518},{4,10400},{5,5564},{6,5400},{7,5455},{8,5509}]',2521628,'[{18020003,90}]','[{2,685}]',685),(1011,30,3,0,'[{1,22742},{2,441320},{3,11766},{4,10624},{5,5684},{6,5516},{7,5572},{8,5628}]',2575910,'[{18020003,90}]','[]',0),(1012,1,0,40,'[{1,424},{2,7645},{3,205},{4,199},{5,99},{6,103},{7,98},{8,104}]',46425,'[{18020001,10}]','[{2,34}]',34),(1012,1,1,40,'[{1,436},{2,7857},{3,211},{4,205},{5,102},{6,106},{7,100},{8,108}]',47777,'[{18020001,10}]','[{1,2}]',40),(1012,1,2,40,'[{1,447},{2,8073},{3,217},{4,211},{5,105},{6,109},{7,103},{8,111}]',49113,'[{18020001,10}]','[{2,36}]',36),(1012,1,3,40,'[{1,460},{2,8294},{3,223},{4,217},{5,108},{6,112},{7,106},{8,114}]',50494,'[{18020001,10}]','[{1,2}]',40),(1012,2,0,60,'[{1,474},{2,8558},{3,230},{4,224},{5,111},{6,115},{7,109},{8,117}]',51988,'[{18020001,10}]','[{2,42}]',42),(1012,2,1,60,'[{1,489},{2,8830},{3,238},{4,230},{5,114},{6,120},{7,113},{8,121}]',53710,'[{18020001,10}]','[{1,2}]',40),(1012,2,2,60,'[{1,505},{2,9110},{3,245},{4,237},{5,118},{6,124},{7,117},{8,125}]',55460,'[{18020001,10}]','[{2,46}]',46),(1012,2,3,60,'[{1,521},{2,9399},{3,253},{4,245},{5,122},{6,128},{7,121},{8,129}]',57269,'[{18020001,10}]','[{1,2}]',40),(1012,3,0,90,'[{1,540},{2,9739},{3,262},{4,254},{5,126},{6,132},{7,125},{8,133}]',59239,'[{18020001,10}]','[{2,53}]',53),(1012,3,1,90,'[{1,560},{2,10091},{3,271},{4,263},{5,131},{6,137},{7,129},{8,139}]',61441,'[{18020001,10}]','[{1,3}]',60),(1012,3,2,90,'[{1,580},{2,10456},{3,281},{4,273},{5,136},{6,142},{7,134},{8,144}]',63706,'[{18020001,10}]','[{2,54}]',54),(1012,3,3,90,'[{1,601},{2,10835},{3,291},{4,283},{5,141},{6,147},{7,139},{8,149}]',66005,'[{18020001,10}]','[{1,3}]',60),(1012,4,0,120,'[{1,625},{2,11272},{3,303},{4,295},{5,147},{6,153},{7,145},{8,155}]',68722,'[{18020001,10}]','[{2,62}]',62),(1012,4,1,120,'[{1,650},{2,11726},{3,316},{4,306},{5,153},{6,159},{7,151},{8,161}]',71476,'[{18020001,10}]','[{1,3}]',60),(1012,4,2,120,'[{1,676},{2,12197},{3,328},{4,318},{5,158},{6,166},{7,156},{8,168}]',74267,'[{18020001,10}]','[{2,64}]',64),(1012,4,3,120,'[{1,704},{2,12685},{3,341},{4,331},{5,164},{6,172},{7,162},{8,174}]',77165,'[{18020001,10}]','[{1,4}]',80),(1012,5,0,160,'[{1,734},{2,13242},{3,356},{4,346},{5,171},{6,179},{7,169},{8,181}]',80472,'[{18020001,10}]','[{2,73}]',73),(1012,5,1,160,'[{1,766},{2,13819},{3,371},{4,361},{5,179},{6,187},{7,177},{8,189}]',84039,'[{18020001,10}]','[{1,4}]',80),(1012,5,2,160,'[{1,800},{2,14418},{3,388},{4,376},{5,187},{6,195},{7,185},{8,197}]',87718,'[{18020001,10}]','[{2,76}]',76),(1012,5,3,160,'[{1,834},{2,15038},{3,404},{4,392},{5,195},{6,203},{7,192},{8,206}]',91418,'[{18020001,10}]','[{1,4}]',80),(1012,6,0,210,'[{1,873},{2,15735},{3,422},{4,410},{5,203},{6,213},{7,201},{8,215}]',95595,'[{18020001,10}]','[{2,84}]',84),(1012,6,1,210,'[{1,913},{2,16457},{3,442},{4,428},{5,213},{6,223},{7,211},{8,225}]',100067,'[{18020001,10}]','[{1,4}]',80),(1012,6,2,210,'[{1,954},{2,17204},{3,462},{4,448},{5,223},{6,233},{7,220},{8,236}]',104634,'[{18020001,10}]','[{2,88}]',88),(1012,6,3,210,'[{1,997},{2,17977},{3,482},{4,468},{5,233},{6,243},{7,230},{8,246}]',109267,'[{18020001,10}]','[{1,5}]',100),(1012,7,0,290,'[{1,1045},{2,18835},{3,505},{4,491},{5,244},{6,254},{7,241},{8,257}]',114435,'[{18020001,10}]','[{2,97}]',97),(1012,7,1,290,'[{1,1094},{2,19722},{3,529},{4,513},{5,255},{6,267},{7,252},{8,270}]',119852,'[{18020001,10}]','[{1,5}]',100),(1012,7,2,290,'[{1,1145},{2,20640},{3,553},{4,537},{5,267},{6,279},{7,264},{8,282}]',125390,'[{18020001,10}]','[{2,101}]',101),(1012,7,3,290,'[{1,1197},{2,21587},{3,579},{4,561},{5,279},{6,291},{7,275},{8,295}]',131027,'[{18020001,10}]','[{1,5}]',100),(1012,8,0,390,'[{1,1255},{2,22628},{3,606},{4,588},{5,292},{6,306},{7,289},{8,309}]',137378,'[{18020001,10}]','[{2,111}]',111),(1012,8,1,390,'[{1,1314},{2,23698},{3,634},{4,616},{5,306},{6,320},{7,302},{8,324}]',143828,'[{18020001,10}]','[{1,6}]',120),(1012,8,2,390,'[{1,1375},{2,24798},{3,664},{4,644},{5,321},{6,335},{7,317},{8,339}]',150598,'[{18020001,10}]','[{2,115}]',115),(1012,8,3,390,'[{1,1438},{2,25928},{3,694},{4,674},{5,335},{6,351},{7,331},{8,355}]',157488,'[{18020001,10}]','[{1,6}]',120),(1012,9,0,510,'[{1,1506},{2,27159},{3,727},{4,705},{5,351},{6,367},{7,347},{8,371}]',164879,'[{18020001,10}]','[{2,126}]',126),(1012,9,1,510,'[{1,1577},{2,28425},{3,760},{4,738},{5,368},{6,384},{7,363},{8,389}]',172615,'[{18020001,10}]','[{1,6}]',120),(1012,9,2,510,'[{1,1650},{2,29725},{3,795},{4,771},{5,384},{6,402},{7,380},{8,406}]',180475,'[{18020001,10}]','[{2,131}]',131),(1012,9,3,510,'[{1,1723},{2,31058},{3,830},{4,806},{5,402},{6,420},{7,397},{8,425}]',188618,'[{18020001,10}]','[{1,7}]',140),(1012,10,0,650,'[{1,1803},{2,32502},{3,869},{4,843},{5,421},{6,439},{7,415},{8,445}]',197362,'[{18020001,10}]','[{2,142}]',142),(1012,10,1,650,'[{1,1885},{2,33980},{3,908},{4,882},{5,439},{6,459},{7,434},{8,464}]',206230,'[{18020001,10}]','[{1,7}]',140),(1012,10,2,650,'[{1,1969},{2,35492},{3,949},{4,921},{5,459},{6,479},{7,453},{8,485}]',215422,'[{18020001,10}]','[{2,146}]',146),(1012,10,3,650,'[{1,2056},{2,37038},{3,991},{4,961},{5,478},{6,500},{7,472},{8,506}]',224758,'[{18020001,10}]','[{1,8}]',160),(1012,11,0,810,'[{1,2148},{2,38703},{3,1035},{4,1005},{5,500},{6,522},{7,494},{8,528}]',234863,'[{18020002,30}]','[{2,159}]',159),(1012,11,1,810,'[{1,2243},{2,40406},{3,1081},{4,1049},{5,521},{6,545},{7,515},{8,551}]',245116,'[{18020002,30}]','[{1,8}]',160),(1012,11,2,810,'[{1,2340},{2,42147},{3,1128},{4,1094},{5,544},{6,568},{7,537},{8,575}]',255697,'[{18020002,30}]','[{2,164}]',164),(1012,11,3,810,'[{1,2439},{2,43927},{3,1175},{4,1141},{5,566},{6,592},{7,559},{8,599}]',266407,'[{18020002,30}]','[{1,9}]',180),(1012,12,0,970,'[{1,2545},{2,45834},{3,1226},{4,1190},{5,591},{6,617},{7,583},{8,625}]',277934,'[{18020002,30}]','[{2,176}]',176),(1012,12,1,970,'[{1,2653},{2,47779},{3,1278},{4,1240},{5,616},{6,644},{7,609},{8,651}]',289789,'[{18020002,30}]','[{1,9}]',180),(1012,12,2,970,'[{1,2764},{2,49762},{3,1331},{4,1291},{5,642},{6,670},{7,634},{8,678}]',301792,'[{18020002,30}]','[{2,181}]',181),(1012,12,3,970,'[{1,2876},{2,51784},{3,1384},{4,1344},{5,668},{6,698},{7,660},{8,706}]',314104,'[{18020002,30}]','[{1,10}]',200),(1012,13,0,1150,'[{1,2996},{2,53941},{3,1442},{4,1400},{5,695},{6,727},{7,687},{8,735}]',327111,'[{18020002,30}]','[{2,195}]',195),(1012,13,1,1150,'[{1,3118},{2,56142},{3,1501},{4,1457},{5,724},{6,756},{7,715},{8,765}]',340452,'[{18020002,30}]','[{1,10}]',200),(1012,13,2,1150,'[{1,3242},{2,58384},{3,1561},{4,1515},{5,753},{6,787},{7,744},{8,796}]',354124,'[{18020002,30}]','[{2,199}]',199),(1012,13,3,1150,'[{1,3370},{2,60668},{3,1622},{4,1574},{5,782},{6,818},{7,773},{8,827}]',367968,'[{18020002,30}]','[{1,11}]',220),(1012,14,0,1330,'[{1,3504},{2,63098},{3,1687},{4,1637},{5,814},{6,850},{7,804},{8,860}]',382678,'[{18020002,30}]','[{2,213}]',213),(1012,14,1,1330,'[{1,3641},{2,65569},{3,1753},{4,1701},{5,846},{6,884},{7,836},{8,894}]',397739,'[{18020002,30}]','[{1,11}]',220),(1012,14,2,1330,'[{1,3781},{2,68083},{3,1820},{4,1766},{5,878},{6,918},{7,867},{8,929}]',412953,'[{18020002,30}]','[{2,218}]',218),(1012,14,3,1330,'[{1,3923},{2,70640},{3,1888},{4,1832},{5,911},{6,953},{7,900},{8,964}]',428500,'[{18020002,30}]','[{1,12}]',240),(1012,15,0,1540,'[{1,4073},{2,73350},{3,1960},{4,1902},{5,947},{6,989},{7,935},{8,1001}]',444960,'[{18020002,30}]','[{2,233}]',233),(1012,15,1,1540,'[{1,4226},{2,76106},{3,2034},{4,1974},{5,982},{6,1026},{7,970},{8,1038}]',461626,'[{18020002,30}]','[{1,12}]',240),(1012,15,2,1540,'[{1,4382},{2,78910},{3,2109},{4,2047},{5,1018},{6,1064},{7,1006},{8,1076}]',478650,'[{18020002,30}]','[{2,240}]',240),(1012,15,3,1540,'[{1,4539},{2,81759},{3,2185},{4,2121},{5,1055},{6,1103},{7,1042},{8,1116}]',495989,'[{18020002,30}]','[{1,13}]',260),(1012,16,0,1750,'[{1,4707},{2,84770},{3,2265},{4,2199},{5,1094},{6,1144},{7,1081},{8,1157}]',514310,'[{18020002,30}]','[{2,255}]',255),(1012,16,1,1750,'[{1,4876},{2,87828},{3,2348},{4,2278},{5,1134},{6,1184},{7,1120},{8,1198}]',532798,'[{18020002,30}]','[{1,13}]',260),(1012,16,2,1750,'[{1,5049},{2,90933},{3,2431},{4,2359},{5,1174},{6,1226},{7,1159},{8,1241}]',551663,'[{18020002,30}]','[{2,260}]',260),(1012,16,3,1750,'[{1,5223},{2,94084},{3,2515},{4,2441},{5,1215},{6,1269},{7,1200},{8,1284}]',570844,'[{18020002,30}]','[{1,14}]',280),(1012,17,0,1990,'[{1,5407},{2,97405},{3,2604},{4,2528},{5,1258},{6,1314},{7,1242},{8,1330}]',591045,'[{18020002,30}]','[{2,276}]',276),(1012,17,1,1990,'[{1,5595},{2,100773},{3,2695},{4,2615},{5,1301},{6,1359},{7,1285},{8,1375}]',611423,'[{18020002,30}]','[{1,14}]',280),(1012,17,2,1990,'[{1,5784},{2,104188},{3,2786},{4,2704},{5,1345},{6,1405},{7,1328},{8,1422}]',632118,'[{18020002,30}]','[{2,284}]',284),(1012,17,3,1990,'[{1,5976},{2,107649},{3,2879},{4,2793},{5,1390},{6,1452},{7,1373},{8,1469}]',653169,'[{18020002,30}]','[{1,15}]',300),(1012,18,0,2230,'[{1,6178},{2,111289},{3,2976},{4,2888},{5,1437},{6,1501},{7,1419},{8,1519}]',675249,'[{18020002,30}]','[{2,301}]',301),(1012,18,1,2230,'[{1,6384},{2,114979},{3,3074},{4,2984},{5,1485},{6,1551},{7,1466},{8,1570}]',697709,'[{18020002,30}]','[{1,15}]',300),(1012,18,2,2230,'[{1,6591},{2,118721},{3,3175},{4,3081},{5,1533},{6,1601},{7,1514},{8,1620}]',720341,'[{18020002,30}]','[{2,307}]',307),(1012,18,3,2230,'[{1,6801},{2,122514},{3,3276},{4,3180},{5,1581},{6,1653},{7,1562},{8,1672}]',743334,'[{18020002,30}]','[{1,16}]',320),(1012,19,0,2500,'[{1,7022},{2,126494},{3,3383},{4,3283},{5,1632},{6,1706},{7,1612},{8,1726}]',767384,'[{18020002,30}]','[{2,325}]',325),(1012,19,1,2500,'[{1,7246},{2,130524},{3,3491},{4,3387},{5,1684},{6,1760},{7,1663},{8,1781}]',791794,'[{18020002,30}]','[{1,16}]',320),(1012,19,2,2500,'[{1,7472},{2,134606},{3,3600},{4,3494},{5,1737},{6,1815},{7,1716},{8,1836}]',816596,'[{18020002,30}]','[{2,332}]',332),(1012,19,3,2500,'[{1,7702},{2,138738},{3,3711},{4,3601},{5,1790},{6,1870},{7,1768},{8,1892}]',841578,'[{18020002,30}]','[{1,17}]',340),(1012,20,0,2770,'[{1,7942},{2,143066},{3,3827},{4,3713},{5,1845},{6,1929},{7,1823},{8,1951}]',867806,'[{18020002,30}]','[{2,350}]',350),(1012,20,1,2770,'[{1,8185},{2,147448},{3,3944},{4,3828},{5,1902},{6,1988},{7,1879},{8,2011}]',894448,'[{18020002,30}]','[{1,18}]',360),(1012,20,2,2770,'[{1,8431},{2,151887},{3,4063},{4,3943},{5,1960},{6,2048},{7,1936},{8,2072}]',921457,'[{18020002,30}]','[{2,356}]',356),(1012,20,3,2770,'[{1,8680},{2,156380},{3,4183},{4,4059},{5,2018},{6,2108},{7,1993},{8,2133}]',948630,'[{18020002,30}]','[{1,19}]',380),(1012,21,0,3070,'[{1,8941},{2,161078},{3,4309},{4,4181},{5,2078},{6,2172},{7,2053},{8,2197}]',977148,'[{18020003,90}]','[{2,375}]',375),(1012,21,1,3070,'[{1,9205},{2,165830},{3,4436},{4,4304},{5,2140},{6,2236},{7,2114},{8,2262}]',1006030,'[{18020003,90}]','[{1,19}]',380),(1012,21,2,3070,'[{1,9472},{2,170637},{3,4564},{4,4430},{5,2201},{6,2301},{7,2174},{8,2328}]',1035127,'[{18020003,90}]','[{2,383}]',383),(1012,21,3,3070,'[{1,9742},{2,175500},{3,4694},{4,4556},{5,2264},{6,2366},{7,2236},{8,2394}]',1064590,'[{18020003,90}]','[{1,20}]',400),(1012,22,0,3370,'[{1,10023},{2,180576},{3,4830},{4,4688},{5,2330},{6,2434},{7,2301},{8,2463}]',1095386,'[{18020003,90}]','[{2,402}]',402),(1012,22,1,3370,'[{1,10309},{2,185710},{3,4967},{4,4821},{5,2396},{6,2504},{7,2367},{8,2533}]',1126590,'[{18020003,90}]','[{1,20}]',400),(1012,22,2,3370,'[{1,10597},{2,190904},{3,5106},{4,4956},{5,2463},{6,2573},{7,2432},{8,2604}]',1157994,'[{18020003,90}]','[{2,410}]',410),(1012,22,3,3370,'[{1,10888},{2,196158},{3,5248},{4,5092},{5,2530},{6,2644},{7,2499},{8,2675}]',1189818,'[{18020003,90}]','[{1,21}]',420),(1012,23,0,3720,'[{1,11192},{2,201633},{3,5394},{4,5234},{5,2601},{6,2717},{7,2569},{8,2749}]',1222973,'[{18020003,90}]','[{2,431}]',431),(1012,23,1,3720,'[{1,11499},{2,207166},{3,5542},{4,5378},{5,2672},{6,2792},{7,2639},{8,2825}]',1256546,'[{18020003,90}]','[{1,22}]',440),(1012,23,2,3720,'[{1,11810},{2,212760},{3,5692},{4,5524},{5,2744},{6,2868},{7,2711},{8,2901}]',1290560,'[{18020003,90}]','[{2,438}]',438),(1012,23,3,3720,'[{1,12123},{2,218413},{3,5843},{4,5671},{5,2818},{6,2944},{7,2783},{8,2979}]',1324923,'[{18020003,90}]','[{1,23}]',460),(1012,24,0,4070,'[{1,12449},{2,224295},{3,6001},{4,5823},{5,2894},{6,3024},{7,2858},{8,3060}]',1360675,'[{18020003,90}]','[{2,460}]',460),(1012,24,1,4070,'[{1,12780},{2,230241},{3,6160},{4,5978},{5,2970},{6,3104},{7,2934},{8,3140}]',1396691,'[{18020003,90}]','[{1,23}]',460),(1012,24,2,4070,'[{1,13113},{2,236250},{3,6320},{4,6134},{5,3047},{6,3185},{7,3010},{8,3222}]',1433060,'[{18020003,90}]','[{2,469}]',469),(1012,24,3,4070,'[{1,13450},{2,242323},{3,6483},{4,6291},{5,3126},{6,3266},{7,3087},{8,3305}]',1469873,'[{18020003,90}]','[{1,24}]',480),(1012,25,0,4470,'[{1,13800},{2,248634},{3,6651},{4,6455},{5,3207},{6,3351},{7,3168},{8,3390}]',1508084,'[{18020003,90}]','[{2,491}]',491),(1012,25,1,4470,'[{1,14154},{2,255013},{3,6822},{4,6620},{5,3289},{6,3437},{7,3249},{8,3477}]',1546743,'[{18020003,90}]','[{1,25}]',500),(1012,25,2,4470,'[{1,14511},{2,261460},{3,6994},{4,6788},{5,3372},{6,3524},{7,3331},{8,3565}]',1585830,'[{18020003,90}]','[{2,500}]',500),(1012,25,3,4470,'[{1,14873},{2,267975},{3,7169},{4,6957},{5,3456},{6,3612},{7,3414},{8,3654}]',1625385,'[{18020003,90}]','[{1,26}]',520),(1012,26,0,4870,'[{1,15249},{2,274736},{3,7350},{4,7132},{5,3543},{6,3703},{7,3500},{8,3746}]',1666366,'[{18020003,90}]','[{2,523}]',523),(1012,26,1,4870,'[{1,15627},{2,281565},{3,7532},{4,7310},{5,3631},{6,3795},{7,3587},{8,3839}]',1707755,'[{18020003,90}]','[{1,26}]',520),(1012,26,2,4870,'[{1,16010},{2,288463},{3,7717},{4,7489},{5,3720},{6,3888},{7,3675},{8,3933}]',1749613,'[{18020003,90}]','[{2,532}]',532),(1012,26,3,4870,'[{1,16396},{2,295428},{3,7904},{4,7670},{5,3810},{6,3982},{7,3764},{8,4028}]',1791898,'[{18020003,90}]','[{1,28}]',560),(1012,27,0,5320,'[{1,16797},{2,302648},{3,8097},{4,7857},{5,3903},{6,4079},{7,3855},{8,4127}]',1835638,'[{18020003,90}]','[{2,556}]',556),(1012,27,1,5320,'[{1,17202},{2,309945},{3,8292},{4,8046},{5,3997},{6,4177},{7,3948},{8,4226}]',1879835,'[{18020003,90}]','[{1,28}]',560),(1012,27,2,5320,'[{1,17612},{2,317317},{3,8488},{4,8238},{5,4092},{6,4276},{7,4042},{8,4326}]',1924507,'[{18020003,90}]','[{2,567}]',567),(1012,27,3,5320,'[{1,18025},{2,324767},{3,8687},{4,8431},{5,4188},{6,4376},{7,4136},{8,4428}]',1969617,'[{18020003,90}]','[{1,29}]',580),(1012,28,0,5770,'[{1,18453},{2,332480},{3,8893},{4,8631},{5,4288},{6,4480},{7,4235},{8,4533}]',2016440,'[{18020003,90}]','[{2,594}]',594),(1012,28,1,5770,'[{1,18886},{2,340268},{3,9102},{4,8832},{5,4388},{6,4586},{7,4334},{8,4640}]',2063738,'[{18020003,90}]','[{1,30}]',600),(1012,28,2,5770,'[{1,19322},{2,348134},{3,9312},{4,9036},{5,4490},{6,4692},{7,4435},{8,4747}]',2111474,'[{18020003,90}]','[{2,603}]',603),(1012,28,3,5770,'[{1,19763},{2,356076},{3,9524},{4,9242},{5,4593},{6,4799},{7,4536},{8,4856}]',2159686,'[{18020003,90}]','[{1,31}]',620),(1012,29,0,6270,'[{1,20218},{2,364290},{3,9744},{4,9456},{5,4698},{6,4910},{7,4641},{8,4967}]',2209450,'[{18020003,90}]','[{2,632}]',632),(1012,29,1,6270,'[{1,20678},{2,372580},{3,9966},{4,9672},{5,4805},{6,5021},{7,4746},{8,5080}]',2259690,'[{18020003,90}]','[{1,32}]',640),(1012,29,2,6270,'[{1,21142},{2,380947},{3,10191},{4,9889},{5,4912},{6,5134},{7,4852},{8,5194}]',2310387,'[{18020003,90}]','[{2,644}]',644),(1012,29,3,6270,'[{1,21610},{2,389390},{3,10417},{4,10109},{5,5021},{6,5247},{7,4959},{8,5309}]',2361540,'[{18020003,90}]','[{1,33}]',660),(1012,30,0,6770,'[{1,22094},{2,398114},{3,10650},{4,10336},{5,5134},{6,5364},{7,5071},{8,5427}]',2414444,'[{18020003,90}]','[{2,674}]',674),(1012,30,1,6770,'[{1,22582},{2,406914},{3,10886},{4,10564},{5,5247},{6,5483},{7,5183},{8,5547}]',2467804,'[{18020003,90}]','[{1,34}]',680),(1012,30,2,6770,'[{1,23075},{2,415790},{3,11123},{4,10795},{5,5361},{6,5603},{7,5296},{8,5668}]',2521640,'[{18020003,90}]','[{2,684}]',684),(1012,30,3,0,'[{1,23571},{2,424743},{3,11363},{4,11027},{5,5477},{6,5723},{7,5410},{8,5790}]',2575913,'[{18020003,90}]','[]',0),(1013,1,0,40,'[{1,367},{2,8782},{3,216},{4,188},{5,111},{6,91},{7,111},{8,91}]',46422,'[{18020001,10}]','[{2,21}]',21),(1013,1,1,40,'[{1,377},{2,9026},{3,222},{4,194},{5,114},{6,94},{7,114},{8,94}]',47766,'[{18020001,10}]','[{1,1}]',20),(1013,1,2,40,'[{1,387},{2,9274},{3,229},{4,199},{5,118},{6,96},{7,117},{8,97}]',49114,'[{18020001,10}]','[{2,21}]',21),(1013,1,3,40,'[{1,398},{2,9528},{3,235},{4,205},{5,121},{6,99},{7,121},{8,99}]',50488,'[{18020001,10}]','[{1,1}]',20),(1013,2,0,60,'[{1,411},{2,9830},{3,242},{4,212},{5,124},{6,102},{7,124},{8,102}]',52000,'[{18020001,10}]','[{2,23}]',23),(1013,2,1,60,'[{1,424},{2,10143},{3,250},{4,218},{5,129},{6,105},{7,128},{8,106}]',53723,'[{18020001,10}]','[{1,1}]',20),(1013,2,2,60,'[{1,437},{2,10465},{3,257},{4,225},{5,133},{6,109},{7,133},{8,109}]',55455,'[{18020001,10}]','[{2,28}]',28),(1013,2,3,60,'[{1,451},{2,10797},{3,266},{4,232},{5,138},{6,113},{7,137},{8,113}]',57317,'[{18020001,10}]','[{1,1}]',20),(1013,3,0,90,'[{1,467},{2,11187},{3,276},{4,240},{5,142},{6,116},{7,142},{8,116}]',59227,'[{18020001,10}]','[{2,31}]',31),(1013,3,1,90,'[{1,485},{2,11592},{3,285},{4,249},{5,147},{6,121},{7,147},{8,121}]',61442,'[{18020001,10}]','[{1,2}]',40),(1013,3,2,90,'[{1,502},{2,12012},{3,296},{4,258},{5,153},{6,125},{7,152},{8,126}]',63702,'[{18020001,10}]','[{2,32}]',32),(1013,3,3,90,'[{1,520},{2,12446},{3,307},{4,267},{5,158},{6,130},{7,158},{8,130}]',65996,'[{18020001,10}]','[{1,2}]',40),(1013,4,0,120,'[{1,541},{2,12948},{3,319},{4,279},{5,165},{6,135},{7,165},{8,135}]',68718,'[{18020001,10}]','[{2,37}]',37),(1013,4,1,120,'[{1,563},{2,13470},{3,332},{4,290},{5,172},{6,140},{7,171},{8,141}]',71480,'[{18020001,10}]','[{1,2}]',40),(1013,4,2,120,'[{1,586},{2,14011},{3,345},{4,301},{5,178},{6,146},{7,178},{8,146}]',74281,'[{18020001,10}]','[{2,40}]',40),(1013,4,3,120,'[{1,609},{2,14572},{3,359},{4,313},{5,185},{6,151},{7,184},{8,152}]',77152,'[{18020001,10}]','[{1,2}]',40),(1013,5,0,160,'[{1,636},{2,15211},{3,375},{4,327},{5,193},{6,158},{7,192},{8,158}]',80531,'[{18020001,10}]','[{2,44}]',44),(1013,5,1,160,'[{1,663},{2,15874},{3,391},{4,341},{5,201},{6,165},{7,201},{8,165}]',84034,'[{18020001,10}]','[{1,2}]',40),(1013,5,2,160,'[{1,692},{2,16563},{3,408},{4,356},{5,210},{6,172},{7,210},{8,172}]',87703,'[{18020001,10}]','[{2,46}]',46),(1013,5,3,160,'[{1,722},{2,17275},{3,425},{4,371},{5,219},{6,179},{7,218},{8,180}]',91415,'[{18020001,10}]','[{1,2}]',40),(1013,6,0,210,'[{1,756},{2,18075},{3,444},{4,388},{5,229},{6,187},{7,228},{8,188}]',95595,'[{18020001,10}]','[{2,50}]',50),(1013,6,1,210,'[{1,791},{2,18905},{3,465},{4,405},{5,240},{6,196},{7,239},{8,197}]',100075,'[{18020001,10}]','[{1,3}]',60),(1013,6,2,210,'[{1,826},{2,19763},{3,486},{4,424},{5,251},{6,205},{7,250},{8,206}]',104633,'[{18020001,10}]','[{2,53}]',53),(1013,6,3,210,'[{1,864},{2,20651},{3,507},{4,443},{5,262},{6,214},{7,261},{8,215}]',109281,'[{18020001,10}]','[{1,3}]',60),(1013,7,0,290,'[{1,905},{2,21636},{3,532},{4,464},{5,274},{6,224},{7,273},{8,225}]',114436,'[{18020001,10}]','[{2,58}]',58),(1013,7,1,290,'[{1,947},{2,22656},{3,556},{4,486},{5,287},{6,235},{7,286},{8,236}]',119846,'[{18020001,10}]','[{1,3}]',60),(1013,7,2,290,'[{1,991},{2,23710},{3,582},{4,508},{5,300},{6,246},{7,299},{8,247}]',125380,'[{18020001,10}]','[{2,61}]',61),(1013,7,3,290,'[{1,1037},{2,24798},{3,609},{4,531},{5,314},{6,257},{7,313},{8,257}]',131088,'[{18020001,10}]','[{1,3}]',60),(1013,8,0,390,'[{1,1087},{2,25993},{3,638},{4,556},{5,329},{6,269},{7,328},{8,270}]',137383,'[{18020001,10}]','[{2,67}]',67),(1013,8,1,390,'[{1,1138},{2,27223},{3,668},{4,583},{5,344},{6,282},{7,343},{8,283}]',143858,'[{18020001,10}]','[{1,3}]',60),(1013,8,2,390,'[{1,1191},{2,28486},{3,698},{4,610},{5,361},{6,295},{7,360},{8,296}]',150606,'[{18020001,10}]','[{2,68}]',68),(1013,8,3,390,'[{1,1245},{2,29784},{3,731},{4,637},{5,377},{6,309},{7,376},{8,310}]',157484,'[{18020001,10}]','[{1,4}]',80),(1013,9,0,510,'[{1,1305},{2,31199},{3,765},{4,667},{5,395},{6,323},{7,394},{8,324}]',164899,'[{18020001,10}]','[{2,74}]',74),(1013,9,1,510,'[{1,1366},{2,32653},{3,800},{4,698},{5,414},{6,338},{7,412},{8,340}]',172623,'[{18020001,10}]','[{1,4}]',80),(1013,9,2,510,'[{1,1428},{2,34146},{3,836},{4,730},{5,432},{6,354},{7,431},{8,355}]',180456,'[{18020001,10}]','[{2,78}]',78),(1013,9,3,510,'[{1,1492},{2,35678},{3,874},{4,762},{5,452},{6,370},{7,451},{8,371}]',188618,'[{18020001,10}]','[{1,4}]',80),(1013,10,0,650,'[{1,1561},{2,37336},{3,914},{4,798},{5,473},{6,387},{7,472},{8,388}]',197356,'[{18020001,10}]','[{2,84}]',84),(1013,10,1,650,'[{1,1633},{2,39034},{3,956},{4,834},{5,494},{6,404},{7,493},{8,405}]',206244,'[{18020001,10}]','[{1,4}]',80),(1013,10,2,650,'[{1,1705},{2,40771},{3,999},{4,871},{5,516},{6,422},{7,514},{8,424}]',215421,'[{18020001,10}]','[{2,88}]',88),(1013,10,3,650,'[{1,1780},{2,42547},{3,1042},{4,910},{5,538},{6,440},{7,536},{8,442}]',224747,'[{18020001,10}]','[{1,5}]',100),(1013,11,0,810,'[{1,1860},{2,44460},{3,1089},{4,951},{5,562},{6,460},{7,561},{8,461}]',234860,'[{18020002,30}]','[{2,96}]',96),(1013,11,1,810,'[{1,1942},{2,46415},{3,1137},{4,993},{5,586},{6,480},{7,585},{8,481}]',245105,'[{18020002,30}]','[{1,5}]',100),(1013,11,2,810,'[{1,2026},{2,48416},{3,1187},{4,1035},{5,612},{6,500},{7,610},{8,502}]',255686,'[{18020002,30}]','[{2,98}]',98),(1013,11,3,810,'[{1,2112},{2,50460},{3,1237},{4,1079},{5,637},{6,521},{7,635},{8,523}]',266400,'[{18020002,30}]','[{1,5}]',100),(1013,12,0,970,'[{1,2204},{2,52651},{3,1290},{4,1126},{5,664},{6,544},{7,663},{8,545}]',277931,'[{18020002,30}]','[{2,105}]',105),(1013,12,1,970,'[{1,2298},{2,54886},{3,1345},{4,1173},{5,693},{6,567},{7,691},{8,569}]',289796,'[{18020002,30}]','[{1,5}]',100),(1013,12,2,970,'[{1,2393},{2,57164},{3,1400},{4,1222},{5,722},{6,590},{7,720},{8,592}]',301774,'[{18020002,30}]','[{2,109}]',109),(1013,12,3,970,'[{1,2491},{2,59486},{3,1457},{4,1271},{5,751},{6,615},{7,749},{8,617}]',314106,'[{18020002,30}]','[{1,6}]',120),(1013,13,0,1150,'[{1,2595},{2,61964},{3,1518},{4,1324},{5,782},{6,640},{7,780},{8,642}]',327114,'[{18020002,30}]','[{2,116}]',116),(1013,13,1,1150,'[{1,2700},{2,64492},{3,1580},{4,1378},{5,814},{6,666},{7,812},{8,668}]',340442,'[{18020002,30}]','[{1,6}]',120),(1013,13,2,1150,'[{1,2808},{2,67067},{3,1643},{4,1433},{5,847},{6,693},{7,845},{8,695}]',354127,'[{18020002,30}]','[{2,119}]',119),(1013,13,3,1150,'[{1,2918},{2,69692},{3,1707},{4,1489},{5,880},{6,720},{7,878},{8,722}]',367952,'[{18020002,30}]','[{1,6}]',120),(1013,14,0,1330,'[{1,3035},{2,72483},{3,1775},{4,1549},{5,915},{6,749},{7,913},{8,751}]',382683,'[{18020002,30}]','[{2,128}]',128),(1013,14,1,1330,'[{1,3153},{2,75322},{3,1844},{4,1610},{5,952},{6,779},{7,949},{8,781}]',397782,'[{18020002,30}]','[{1,6}]',120),(1013,14,2,1330,'[{1,3274},{2,78210},{3,1915},{4,1671},{5,988},{6,808},{7,985},{8,811}]',412940,'[{18020002,30}]','[{2,133}]',133),(1013,14,3,1330,'[{1,3397},{2,81147},{3,1986},{4,1734},{5,1025},{6,839},{7,1022},{8,842}]',428487,'[{18020002,30}]','[{1,7}]',140),(1013,15,0,1540,'[{1,3527},{2,84259},{3,2062},{4,1800},{5,1065},{6,871},{7,1062},{8,874}]',444949,'[{18020002,30}]','[{2,140}]',140),(1013,15,1,1540,'[{1,3659},{2,87426},{3,2140},{4,1868},{5,1104},{6,904},{7,1101},{8,907}]',461606,'[{18020002,30}]','[{1,7}]',140),(1013,15,2,1540,'[{1,3794},{2,90646},{3,2219},{4,1937},{5,1145},{6,937},{7,1142},{8,940}]',478626,'[{18020002,30}]','[{2,144}]',144),(1013,15,3,1540,'[{1,3931},{2,93920},{3,2299},{4,2007},{5,1187},{6,971},{7,1184},{8,974}]',495990,'[{18020002,30}]','[{1,8}]',160),(1013,16,0,1750,'[{1,4076},{2,97378},{3,2384},{4,2080},{5,1231},{6,1007},{7,1228},{8,1010}]',514298,'[{18020002,30}]','[{2,152}]',152),(1013,16,1,1750,'[{1,4222},{2,100891},{3,2470},{4,2156},{5,1275},{6,1043},{7,1271},{8,1047}]',532781,'[{18020002,30}]','[{1,8}]',160),(1013,16,2,1750,'[{1,4372},{2,104458},{3,2558},{4,2232},{5,1320},{6,1080},{7,1316},{8,1084}]',551648,'[{18020002,30}]','[{2,157}]',157),(1013,16,3,1750,'[{1,4523},{2,108078},{3,2647},{4,2309},{5,1366},{6,1118},{7,1362},{8,1122}]',570838,'[{18020002,30}]','[{1,8}]',160),(1013,17,0,1990,'[{1,4683},{2,111893},{3,2740},{4,2392},{5,1415},{6,1157},{7,1411},{8,1161}]',591053,'[{18020002,30}]','[{2,167}]',167),(1013,17,1,1990,'[{1,4845},{2,115762},{3,2836},{4,2474},{5,1463},{6,1197},{7,1459},{8,1201}]',611412,'[{18020002,30}]','[{1,8}]',160),(1013,17,2,1990,'[{1,5009},{2,119684},{3,2932},{4,2558},{5,1513},{6,1238},{7,1508},{8,1242}]',632164,'[{18020002,30}]','[{2,170}]',170),(1013,17,3,1990,'[{1,5175},{2,123660},{3,3029},{4,2643},{5,1563},{6,1279},{7,1559},{8,1283}]',653160,'[{18020002,30}]','[{1,9}]',180),(1013,18,0,2230,'[{1,5350},{2,127841},{3,3131},{4,2733},{5,1616},{6,1322},{7,1611},{8,1327}]',675241,'[{18020002,30}]','[{2,181}]',181),(1013,18,1,2230,'[{1,5528},{2,132080},{3,3235},{4,2823},{5,1670},{6,1366},{7,1665},{8,1371}]',697690,'[{18020002,30}]','[{1,9}]',180),(1013,18,2,2230,'[{1,5707},{2,136379},{3,3341},{4,2915},{5,1724},{6,1410},{7,1719},{8,1415}]',720319,'[{18020002,30}]','[{2,184}]',184),(1013,18,3,2230,'[{1,5890},{2,140736},{3,3448},{4,3008},{5,1779},{6,1455},{7,1774},{8,1460}]',743336,'[{18020002,30}]','[{1,10}]',200),(1013,19,0,2500,'[{1,6081},{2,145307},{3,3560},{4,3106},{5,1836},{6,1502},{7,1831},{8,1507}]',767377,'[{18020002,30}]','[{2,195}]',195),(1013,19,1,2500,'[{1,6275},{2,149938},{3,3673},{4,3205},{5,1894},{6,1550},{7,1889},{8,1555}]',791788,'[{18020002,30}]','[{1,10}]',200),(1013,19,2,2500,'[{1,6471},{2,154626},{3,3788},{4,3306},{5,1954},{6,1598},{7,1948},{8,1604}]',816596,'[{18020002,30}]','[{2,198}]',198),(1013,19,3,2500,'[{1,6669},{2,159373},{3,3905},{4,3407},{5,2013},{6,1647},{7,2008},{8,1652}]',841553,'[{18020002,30}]','[{1,10}]',200),(1013,20,0,2770,'[{1,6877},{2,164344},{3,4026},{4,3514},{5,2076},{6,1698},{7,2070},{8,1704}]',867784,'[{18020002,30}]','[{2,211}]',211),(1013,20,1,2770,'[{1,7088},{2,169379},{3,4150},{4,3622},{5,2140},{6,1751},{7,2134},{8,1756}]',894489,'[{18020002,30}]','[{1,11}]',220),(1013,20,2,2770,'[{1,7301},{2,174477},{3,4275},{4,3731},{5,2204},{6,1804},{7,2198},{8,1810}]',921447,'[{18020002,30}]','[{2,215}]',215),(1013,20,3,2770,'[{1,7517},{2,179639},{3,4401},{4,3841},{5,2269},{6,1857},{7,2263},{8,1863}]',948629,'[{18020002,30}]','[{1,11}]',220),(1013,21,0,3070,'[{1,7743},{2,185035},{3,4534},{4,3956},{5,2338},{6,1913},{7,2331},{8,1919}]',977195,'[{18020003,90}]','[{2,225}]',225),(1013,21,1,3070,'[{1,7971},{2,190494},{3,4667},{4,4073},{5,2407},{6,1969},{7,2400},{8,1976}]',1006014,'[{18020003,90}]','[{1,11}]',220),(1013,21,2,3070,'[{1,8203},{2,196017},{3,4803},{4,4191},{5,2476},{6,2026},{7,2469},{8,2033}]',1035127,'[{18020003,90}]','[{2,230}]',230),(1013,21,3,3070,'[{1,8436},{2,201603},{3,4940},{4,4311},{5,2547},{6,2084},{7,2540},{8,2090}]',1064648,'[{18020003,90}]','[{1,12}]',240),(1013,22,0,3370,'[{1,8680},{2,207434},{3,5083},{4,4435},{5,2620},{6,2144},{7,2613},{8,2151}]',1095384,'[{18020003,90}]','[{2,241}]',241),(1013,22,1,3370,'[{1,8927},{2,213332},{3,5227},{4,4561},{5,2695},{6,2205},{7,2688},{8,2212}]',1126572,'[{18020003,90}]','[{1,12}]',240),(1013,22,2,3370,'[{1,9177},{2,219298},{3,5373},{4,4689},{5,2770},{6,2266},{7,2762},{8,2274}]',1157988,'[{18020003,90}]','[{2,247}]',247),(1013,22,3,3370,'[{1,9429},{2,225334},{3,5522},{4,4818},{5,2846},{6,2328},{7,2838},{8,2336}]',1189814,'[{18020003,90}]','[{1,13}]',260),(1013,23,0,3720,'[{1,9692},{2,231623},{3,5675},{4,4953},{5,2925},{6,2393},{7,2917},{8,2401}]',1222963,'[{18020003,90}]','[{2,257}]',257),(1013,23,1,3720,'[{1,9958},{2,237979},{3,5831},{4,5089},{5,3005},{6,2459},{7,2997},{8,2467}]',1256539,'[{18020003,90}]','[{1,13}]',260),(1013,23,2,3720,'[{1,10227},{2,244404},{3,5989},{4,5227},{5,3087},{6,2525},{7,3078},{8,2534}]',1290544,'[{18020003,90}]','[{2,263}]',263),(1013,23,3,3720,'[{1,10498},{2,250898},{3,6148},{4,5366},{5,3169},{6,2593},{7,3160},{8,2602}]',1324908,'[{18020003,90}]','[{1,14}]',280),(1013,24,0,4070,'[{1,10781},{2,257655},{3,6314},{4,5510},{5,3255},{6,2663},{7,3246},{8,2672}]',1360675,'[{18020003,90}]','[{2,276}]',276),(1013,24,1,4070,'[{1,11067},{2,264485},{3,6482},{4,5656},{5,3341},{6,2733},{7,3332},{8,2742}]',1396675,'[{18020003,90}]','[{1,14}]',280),(1013,24,2,4070,'[{1,11356},{2,271389},{3,6650},{4,5804},{5,3428},{6,2804},{7,3418},{8,2814}]',1433059,'[{18020003,90}]','[{2,280}]',280),(1013,24,3,4070,'[{1,11647},{2,278365},{3,6821},{4,5953},{5,3516},{6,2876},{7,3506},{8,2886}]',1469855,'[{18020003,90}]','[{1,15}]',300),(1013,25,0,4470,'[{1,11950},{2,285614},{3,6999},{4,6107},{5,3607},{6,2951},{7,3597},{8,2961}]',1508064,'[{18020003,90}]','[{2,295}]',295),(1013,25,1,4470,'[{1,12257},{2,292942},{3,7178},{4,6264},{5,3699},{6,3027},{7,3689},{8,3037}]',1546732,'[{18020003,90}]','[{1,15}]',300),(1013,25,2,4470,'[{1,12566},{2,300348},{3,7360},{4,6422},{5,3793},{6,3103},{7,3782},{8,3114}]',1585818,'[{18020003,90}]','[{2,299}]',299),(1013,25,3,4470,'[{1,12880},{2,307832},{3,7543},{4,6583},{5,3887},{6,3181},{7,3877},{8,3191}]',1625382,'[{18020003,90}]','[{1,16}]',320),(1013,26,0,4870,'[{1,13205},{2,315599},{3,7733},{4,6749},{5,3985},{6,3261},{7,3974},{8,3272}]',1666349,'[{18020003,90}]','[{2,314}]',314),(1013,26,1,4870,'[{1,13533},{2,323444},{3,7926},{4,6916},{5,4084},{6,3342},{7,4073},{8,3353}]',1707754,'[{18020003,90}]','[{1,16}]',320),(1013,26,2,4870,'[{1,13865},{2,331367},{3,8120},{4,7086},{5,4184},{6,3424},{7,4173},{8,3435}]',1749617,'[{18020003,90}]','[{2,319}]',319),(1013,26,3,4870,'[{1,14199},{2,339368},{3,8317},{4,7257},{5,4286},{6,3506},{7,4274},{8,3518}]',1791898,'[{18020003,90}]','[{1,17}]',340),(1013,27,0,5320,'[{1,14546},{2,347662},{3,8519},{4,7435},{5,4390},{6,3592},{7,4378},{8,3604}]',1835632,'[{18020003,90}]','[{2,335}]',335),(1013,27,1,5320,'[{1,14897},{2,356044},{3,8724},{4,7614},{5,4496},{6,3678},{7,4483},{8,3691}]',1879834,'[{18020003,90}]','[{1,17}]',340),(1013,27,2,5320,'[{1,15251},{2,364513},{3,8932},{4,7794},{5,4602},{6,3766},{7,4590},{8,3778}]',1924483,'[{18020003,90}]','[{2,340}]',340),(1013,27,3,5320,'[{1,15609},{2,373071},{3,9141},{4,7977},{5,4710},{6,3854},{7,4697},{8,3867}]',1969601,'[{18020003,90}]','[{1,18}]',360),(1013,28,0,5770,'[{1,15980},{2,381931},{3,9358},{4,8166},{5,4822},{6,3946},{7,4809},{8,3959}]',2016431,'[{18020003,90}]','[{2,355}]',355),(1013,28,1,5770,'[{1,16354},{2,390878},{3,9577},{4,8357},{5,4936},{6,4038},{7,4922},{8,4052}]',2063708,'[{18020003,90}]','[{1,18}]',360),(1013,28,2,5770,'[{1,16732},{2,399913},{3,9798},{4,8550},{5,5050},{6,4132},{7,5036},{8,4146}]',2111453,'[{18020003,90}]','[{2,362}]',362),(1013,28,3,5770,'[{1,17114},{2,409037},{3,10021},{4,8745},{5,5166},{6,4226},{7,5152},{8,4240}]',2159667,'[{18020003,90}]','[{1,19}]',380),(1013,29,0,6270,'[{1,17509},{2,418472},{3,10253},{4,8947},{5,5284},{6,4324},{7,5270},{8,4338}]',2209452,'[{18020003,90}]','[{2,379}]',379),(1013,29,1,6270,'[{1,17907},{2,427996},{3,10487},{4,9151},{5,5404},{6,4422},{7,5390},{8,4436}]',2259686,'[{18020003,90}]','[{1,19}]',380),(1013,29,2,6270,'[{1,18308},{2,437607},{3,10723},{4,9357},{5,5525},{6,4521},{7,5510},{8,4536}]',2310367,'[{18020003,90}]','[{2,385}]',385),(1013,29,3,6270,'[{1,18714},{2,447306},{3,10961},{4,9565},{5,5647},{6,4621},{7,5632},{8,4636}]',2361536,'[{18020003,90}]','[{1,20}]',400),(1013,30,0,6770,'[{1,19133},{2,457327},{3,11207},{4,9779},{5,5774},{6,4724},{7,5758},{8,4740}]',2414437,'[{18020003,90}]','[{2,403}]',403),(1013,30,1,6770,'[{1,19556},{2,467436},{3,11454},{4,9996},{5,5902},{6,4829},{7,5885},{8,4845}]',2467856,'[{18020003,90}]','[{1,20}]',400),(1013,30,2,6770,'[{1,19982},{2,477632},{3,11704},{4,10214},{5,6030},{6,4934},{7,6014},{8,4950}]',2521622,'[{18020003,90}]','[{2,412}]',412),(1013,30,3,0,'[{1,20412},{2,487917},{3,11956},{4,10434},{5,6160},{6,5040},{7,6143},{8,5057}]',2575907,'[{18020003,90}]','[]',0),(2001,1,0,40,'[{1,244},{2,4794},{3,117},{4,125},{5,58},{6,64},{7,56},{8,66}]',27924,'[{18020001,10}]','[{2,20}]',20),(2001,1,1,40,'[{1,250},{2,4928},{3,121},{4,129},{5,59},{6,65},{7,57},{8,67}]',28578,'[{18020001,10}]','[{1,1}]',20),(2001,1,2,40,'[{1,257},{2,5064},{3,124},{4,132},{5,61},{6,67},{7,59},{8,69}]',29404,'[{18020001,10}]','[{2,24}]',24),(2001,1,3,40,'[{1,264},{2,5202},{3,128},{4,136},{5,63},{6,69},{7,61},{8,71}]',30282,'[{18020001,10}]','[{1,1}]',20),(2001,2,0,50,'[{1,273},{2,5367},{3,132},{4,140},{5,65},{6,71},{7,63},{8,73}]',31227,'[{18020001,10}]','[{2,26}]',26),(2001,2,1,50,'[{1,282},{2,5538},{3,135},{4,145},{5,67},{6,73},{7,65},{8,75}]',32178,'[{18020001,10}]','[{1,1}]',20),(2001,2,2,50,'[{1,291},{2,5714},{3,140},{4,150},{5,70},{6,76},{7,67},{8,79}]',33384,'[{18020001,10}]','[{2,28}]',28),(2001,2,3,50,'[{1,300},{2,5895},{3,144},{4,154},{5,72},{6,78},{7,69},{8,81}]',34345,'[{18020001,10}]','[{1,2}]',40),(2001,3,0,80,'[{1,311},{2,6109},{3,150},{4,160},{5,74},{6,80},{7,71},{8,83}]',35479,'[{18020001,10}]','[{2,31}]',31),(2001,3,1,80,'[{1,322},{2,6330},{3,155},{4,165},{5,77},{6,83},{7,74},{8,86}]',36770,'[{18020001,10}]','[{1,2}]',40),(2001,3,2,80,'[{1,334},{2,6558},{3,161},{4,171},{5,80},{6,86},{7,77},{8,89}]',38138,'[{18020001,10}]','[{2,35}]',35),(2001,3,3,80,'[{1,346},{2,6795},{3,166},{4,178},{5,82},{6,90},{7,79},{8,93}]',39515,'[{18020001,10}]','[{1,2}]',40),(2001,4,0,100,'[{1,359},{2,7070},{3,173},{4,185},{5,86},{6,94},{7,83},{8,97}]',41200,'[{18020001,10}]','[{2,37}]',37),(2001,4,1,100,'[{1,374},{2,7354},{3,181},{4,193},{5,90},{6,98},{7,87},{8,101}]',42984,'[{18020001,10}]','[{1,2}]',40),(2001,4,2,100,'[{1,389},{2,7651},{3,188},{4,200},{5,93},{6,101},{7,89},{8,105}]',44531,'[{18020001,10}]','[{2,39}]',39),(2001,4,3,100,'[{1,405},{2,7957},{3,195},{4,209},{5,97},{6,105},{7,93},{8,109}]',46357,'[{18020001,10}]','[{1,2}]',40),(2001,5,0,130,'[{1,423},{2,8306},{3,204},{4,218},{5,101},{6,109},{7,97},{8,113}]',48316,'[{18020001,10}]','[{2,45}]',45),(2001,5,1,130,'[{1,441},{2,8667},{3,213},{4,227},{5,105},{6,115},{7,101},{8,119}]',50487,'[{18020001,10}]','[{1,2}]',40),(2001,5,2,130,'[{1,460},{2,9043},{3,221},{4,237},{5,110},{6,120},{7,106},{8,124}]',52693,'[{18020001,10}]','[{2,46}]',46),(2001,5,3,130,'[{1,480},{2,9432},{3,231},{4,247},{5,114},{6,124},{7,110},{8,128}]',54782,'[{18020001,10}]','[{1,3}]',60),(2001,6,0,170,'[{1,502},{2,9869},{3,242},{4,258},{5,120},{6,130},{7,115},{8,135}]',57409,'[{18020001,10}]','[{2,51}]',51),(2001,6,1,170,'[{1,526},{2,10322},{3,252},{4,270},{5,126},{6,136},{7,121},{8,141}]',60092,'[{18020001,10}]','[{1,3}]',60),(2001,6,2,170,'[{1,549},{2,10791},{3,264},{4,282},{5,131},{6,143},{7,126},{8,148}]',62821,'[{18020001,10}]','[{2,55}]',55),(2001,6,3,170,'[{1,574},{2,11276},{3,276},{4,294},{5,137},{6,149},{7,132},{8,154}]',65606,'[{18020001,10}]','[{1,3}]',60),(2001,7,0,240,'[{1,601},{2,11814},{3,289},{4,309},{5,143},{6,155},{7,137},{8,161}]',68584,'[{18020001,10}]','[{2,59}]',59),(2001,7,1,240,'[{1,630},{2,12370},{3,303},{4,323},{5,151},{6,163},{7,145},{8,169}]',72020,'[{18020001,10}]','[{1,3}]',60),(2001,7,2,240,'[{1,659},{2,12945},{3,316},{4,338},{5,157},{6,171},{7,151},{8,177}]',75275,'[{18020001,10}]','[{2,61}]',61),(2001,7,3,240,'[{1,689},{2,13540},{3,331},{4,353},{5,164},{6,178},{7,158},{8,184}]',78620,'[{18020001,10}]','[{1,3}]',60),(2001,8,0,320,'[{1,722},{2,14192},{3,346},{4,370},{5,172},{6,186},{7,165},{8,193}]',82332,'[{18020001,10}]','[{2,69}]',69),(2001,8,1,320,'[{1,756},{2,14864},{3,363},{4,387},{5,180},{6,196},{7,173},{8,203}]',86334,'[{18020001,10}]','[{1,3}]',60),(2001,8,2,320,'[{1,791},{2,15554},{3,379},{4,405},{5,189},{6,205},{7,182},{8,212}]',90374,'[{18020001,10}]','[{2,71}]',71),(2001,8,3,320,'[{1,827},{2,16262},{3,396},{4,424},{5,198},{6,214},{7,190},{8,222}]',94502,'[{18020001,10}]','[{1,4}]',80),(2001,9,0,410,'[{1,867},{2,17034},{3,416},{4,444},{5,206},{6,224},{7,198},{8,232}]',98874,'[{18020001,10}]','[{2,78}]',78),(2001,9,1,410,'[{1,907},{2,17828},{3,434},{4,464},{5,217},{6,235},{7,208},{8,244}]',103618,'[{18020001,10}]','[{1,4}]',80),(2001,9,2,410,'[{1,949},{2,18644},{3,454},{4,486},{5,226},{6,246},{7,218},{8,254}]',108324,'[{18020001,10}]','[{2,81}]',81),(2001,9,3,410,'[{1,992},{2,19480},{3,475},{4,507},{5,237},{6,257},{7,228},{8,266}]',113270,'[{18020001,10}]','[{1,4}]',80),(2001,10,0,520,'[{1,1037},{2,20386},{3,497},{4,531},{5,247},{6,269},{7,238},{8,278}]',118426,'[{18020001,10}]','[{2,88}]',88),(2001,10,1,520,'[{1,1085},{2,21312},{3,519},{4,555},{5,258},{6,280},{7,248},{8,290}]',123662,'[{18020001,10}]','[{1,4}]',80),(2001,10,2,520,'[{1,1133},{2,22261},{3,542},{4,580},{5,269},{6,293},{7,259},{8,303}]',129171,'[{18020001,10}]','[{2,91}]',91),(2001,10,3,520,'[{1,1183},{2,23231},{3,567},{4,605},{5,281},{6,305},{7,270},{8,316}]',134791,'[{18020001,10}]','[{1,5}]',100),(2001,11,0,650,'[{1,1236},{2,24276},{3,592},{4,632},{5,294},{6,320},{7,283},{8,331}]',140996,'[{18020002,30}]','[{2,99}]',99),(2001,11,1,650,'[{1,1291},{2,25343},{3,618},{4,660},{5,307},{6,333},{7,295},{8,345}]',147113,'[{18020002,30}]','[{1,5}]',100),(2001,11,2,650,'[{1,1346},{2,26435},{3,645},{4,689},{5,320},{6,348},{7,308},{8,360}]',153505,'[{18020002,30}]','[{2,100}]',100),(2001,11,3,650,'[{1,1404},{2,27552},{3,672},{4,718},{5,333},{6,361},{7,320},{8,374}]',159782,'[{18020002,30}]','[{1,5}]',100),(2001,12,0,780,'[{1,1464},{2,28748},{3,701},{4,749},{5,347},{6,377},{7,334},{8,390}]',166678,'[{18020002,30}]','[{2,108}]',108),(2001,12,1,780,'[{1,1527},{2,29968},{3,730},{4,780},{5,363},{6,393},{7,349},{8,407}]',173858,'[{18020002,30}]','[{1,5}]',100),(2001,12,2,780,'[{1,1590},{2,31212},{3,761},{4,813},{5,378},{6,410},{7,363},{8,425}]',181162,'[{18020002,30}]','[{2,112}]',112),(2001,12,3,780,'[{1,1655},{2,32479},{3,791},{4,845},{5,393},{6,427},{7,378},{8,442}]',188479,'[{18020002,30}]','[{1,6}]',120),(2001,13,0,920,'[{1,1724},{2,33833},{3,825},{4,881},{5,409},{6,445},{7,394},{8,460}]',196363,'[{18020002,30}]','[{2,120}]',120),(2001,13,1,920,'[{1,1794},{2,35213},{3,858},{4,916},{5,426},{6,462},{7,409},{8,479}]',204243,'[{18020002,30}]','[{1,6}]',120),(2001,13,2,920,'[{1,1866},{2,36619},{3,893},{4,953},{5,443},{6,481},{7,426},{8,498}]',212489,'[{18020002,30}]','[{2,124}]',124),(2001,13,3,920,'[{1,1939},{2,38052},{3,927},{4,991},{5,460},{6,500},{7,443},{8,517}]',220782,'[{18020002,30}]','[{1,6}]',120),(2001,14,0,1070,'[{1,2017},{2,39576},{3,964},{4,1030},{5,479},{6,519},{7,460},{8,538}]',229566,'[{18020002,30}]','[{2,131}]',131),(2001,14,1,1070,'[{1,2096},{2,41127},{3,1002},{4,1070},{5,498},{6,540},{7,479},{8,559}]',238647,'[{18020002,30}]','[{1,7}]',140),(2001,14,2,1070,'[{1,2175},{2,42703},{3,1040},{4,1112},{5,517},{6,561},{7,497},{8,581}]',247803,'[{18020002,30}]','[{2,135}]',135),(2001,14,3,1070,'[{1,2257},{2,44307},{3,1079},{4,1153},{5,536},{6,582},{7,515},{8,603}]',257047,'[{18020002,30}]','[{1,7}]',140),(2001,15,0,1240,'[{1,2344},{2,46006},{3,1121},{4,1197},{5,557},{6,605},{7,536},{8,626}]',267036,'[{18020002,30}]','[{2,144}]',144),(2001,15,1,1240,'[{1,2432},{2,47735},{3,1162},{4,1242},{5,577},{6,627},{7,555},{8,649}]',276875,'[{18020002,30}]','[{1,7}]',140),(2001,15,2,1240,'[{1,2521},{2,49494},{3,1206},{4,1288},{5,599},{6,651},{7,576},{8,674}]',287264,'[{18020002,30}]','[{2,149}]',149),(2001,15,3,1240,'[{1,2612},{2,51280},{3,1249},{4,1335},{5,620},{6,674},{7,597},{8,697}]',297520,'[{18020002,30}]','[{1,8}]',160),(2001,16,0,1400,'[{1,2708},{2,53169},{3,1295},{4,1383},{5,643},{6,699},{7,619},{8,723}]',308479,'[{18020002,30}]','[{2,157}]',157),(2001,16,1,1400,'[{1,2806},{2,55088},{3,1342},{4,1434},{5,667},{6,723},{7,641},{8,749}]',319608,'[{18020002,30}]','[{1,8}]',160),(2001,16,2,1400,'[{1,2905},{2,57035},{3,1390},{4,1484},{5,690},{6,750},{7,664},{8,776}]',330985,'[{18020002,30}]','[{2,161}]',161),(2001,16,3,1400,'[{1,3006},{2,59011},{3,1438},{4,1536},{5,714},{6,776},{7,687},{8,803}]',342481,'[{18020002,30}]','[{1,8}]',160),(2001,17,0,1600,'[{1,3112},{2,61094},{3,1489},{4,1591},{5,740},{6,804},{7,712},{8,832}]',354734,'[{18020002,30}]','[{2,171}]',171),(2001,17,1,1600,'[{1,3220},{2,63207},{3,1540},{4,1646},{5,765},{6,831},{7,736},{8,860}]',366857,'[{18020002,30}]','[{1,9}]',180),(2001,17,2,1600,'[{1,3329},{2,65349},{3,1593},{4,1701},{5,791},{6,859},{7,761},{8,889}]',379279,'[{18020002,30}]','[{2,174}]',174),(2001,17,3,1600,'[{1,3440},{2,67519},{3,1646},{4,1758},{5,818},{6,888},{7,786},{8,920}]',392019,'[{18020002,30}]','[{1,9}]',180),(2001,18,0,1790,'[{1,3556},{2,69802},{3,1701},{4,1817},{5,845},{6,917},{7,812},{8,950}]',405072,'[{18020002,30}]','[{2,185}]',185),(2001,18,1,1790,'[{1,3674},{2,72117},{3,1757},{4,1877},{5,874},{6,948},{7,840},{8,982}]',418647,'[{18020002,30}]','[{1,9}]',180),(2001,18,2,1790,'[{1,3793},{2,74464},{3,1815},{4,1939},{5,901},{6,979},{7,867},{8,1013}]',432174,'[{18020002,30}]','[{2,189}]',189),(2001,18,3,1790,'[{1,3914},{2,76842},{3,1873},{4,2001},{5,930},{6,1010},{7,894},{8,1046}]',445972,'[{18020002,30}]','[{1,10}]',200),(2001,19,0,2000,'[{1,4041},{2,79338},{3,1934},{4,2066},{5,960},{6,1042},{7,923},{8,1079}]',460358,'[{18020002,30}]','[{2,200}]',200),(2001,19,1,2000,'[{1,4170},{2,81867},{3,1995},{4,2131},{5,991},{6,1075},{7,952},{8,1114}]',475017,'[{18020002,30}]','[{1,10}]',200),(2001,19,2,2000,'[{1,4300},{2,84426},{3,2058},{4,2198},{5,1022},{6,1110},{7,983},{8,1149}]',490026,'[{18020002,30}]','[{2,203}]',203),(2001,19,3,2000,'[{1,4433},{2,87019},{3,2122},{4,2266},{5,1053},{6,1143},{7,1012},{8,1184}]',504979,'[{18020002,30}]','[{1,11}]',220),(2001,20,0,2220,'[{1,4570},{2,89733},{3,2187},{4,2337},{5,1086},{6,1178},{7,1044},{8,1220}]',520633,'[{18020002,30}]','[{2,214}]',214),(2001,20,1,2220,'[{1,4710},{2,92482},{3,2255},{4,2409},{5,1119},{6,1215},{7,1076},{8,1258}]',536682,'[{18020002,30}]','[{1,11}]',220),(2001,20,2,2220,'[{1,4851},{2,95266},{3,2323},{4,2481},{5,1153},{6,1251},{7,1108},{8,1296}]',552786,'[{18020002,30}]','[{2,220}]',220),(2001,20,3,2220,'[{1,4996},{2,98084},{3,2391},{4,2555},{5,1187},{6,1289},{7,1141},{8,1335}]',569254,'[{18020002,30}]','[{1,11}]',220),(2001,21,0,2460,'[{1,5145},{2,101030},{3,2463},{4,2631},{5,1223},{6,1327},{7,1176},{8,1374}]',586280,'[{18020003,90}]','[{2,230}]',230),(2001,21,1,2460,'[{1,5297},{2,104011},{3,2535},{4,2709},{5,1259},{6,1367},{7,1211},{8,1415}]',603651,'[{18020003,90}]','[{1,12}]',240),(2001,21,2,2460,'[{1,5451},{2,107026},{3,2609},{4,2787},{5,1296},{6,1406},{7,1246},{8,1456}]',621146,'[{18020003,90}]','[{2,236}]',236),(2001,21,3,2460,'[{1,5606},{2,110076},{3,2683},{4,2867},{5,1332},{6,1446},{7,1281},{8,1497}]',638746,'[{18020003,90}]','[{1,12}]',240),(2001,22,0,2700,'[{1,5768},{2,113260},{3,2761},{4,2949},{5,1370},{6,1488},{7,1318},{8,1540}]',657170,'[{18020003,90}]','[{2,248}]',248),(2001,22,1,2700,'[{1,5932},{2,116480},{3,2839},{4,3033},{5,1410},{6,1530},{7,1355},{8,1585}]',675920,'[{18020003,90}]','[{1,12}]',240),(2001,22,2,2700,'[{1,6098},{2,119739},{3,2919},{4,3119},{5,1449},{6,1573},{7,1393},{8,1629}]',694849,'[{18020003,90}]','[{2,252}]',252),(2001,22,3,2700,'[{1,6266},{2,123034},{3,3000},{4,3204},{5,1488},{6,1616},{7,1431},{8,1673}]',713854,'[{18020003,90}]','[{1,13}]',260),(2001,23,0,2980,'[{1,6440},{2,126467},{3,3083},{4,3293},{5,1530},{6,1660},{7,1471},{8,1719}]',733667,'[{18020003,90}]','[{2,266}]',266),(2001,23,1,2980,'[{1,6618},{2,129938},{3,3168},{4,3384},{5,1572},{6,1706},{7,1511},{8,1767}]',753898,'[{18020003,90}]','[{1,13}]',260),(2001,23,2,2980,'[{1,6797},{2,133446},{3,3254},{4,3476},{5,1615},{6,1753},{7,1553},{8,1815}]',774436,'[{18020003,90}]','[{2,270}]',270),(2001,23,3,2980,'[{1,6976},{2,136992},{3,3340},{4,3568},{5,1658},{6,1800},{7,1594},{8,1864}]',795012,'[{18020003,90}]','[{1,14}]',280),(2001,24,0,3260,'[{1,7164},{2,140681},{3,3430},{4,3664},{5,1702},{6,1848},{7,1637},{8,1913}]',816311,'[{18020003,90}]','[{2,284}]',284),(2001,24,1,3260,'[{1,7355},{2,144411},{3,3521},{4,3761},{5,1747},{6,1897},{7,1680},{8,1964}]',837961,'[{18020003,90}]','[{1,14}]',280),(2001,24,2,3260,'[{1,7546},{2,148179},{3,3613},{4,3859},{5,1793},{6,1947},{7,1724},{8,2016}]',859899,'[{18020003,90}]','[{2,288}]',288),(2001,24,3,3260,'[{1,7740},{2,151989},{3,3706},{4,3958},{5,1839},{6,1997},{7,1768},{8,2068}]',881989,'[{18020003,90}]','[{1,15}]',300),(2001,25,0,3580,'[{1,7942},{2,155947},{3,3802},{4,4062},{5,1886},{6,2048},{7,1814},{8,2120}]',904787,'[{18020003,90}]','[{2,304}]',304),(2001,25,1,3580,'[{1,8145},{2,159948},{3,3900},{4,4166},{5,1935},{6,2101},{7,1861},{8,2175}]',928098,'[{18020003,90}]','[{1,15}]',300),(2001,25,2,3580,'[{1,8350},{2,163992},{3,3999},{4,4271},{5,1984},{6,2154},{7,1908},{8,2230}]',951542,'[{18020003,90}]','[{2,308}]',308),(2001,25,3,3580,'[{1,8559},{2,168078},{3,4098},{4,4378},{5,2033},{6,2207},{7,1955},{8,2285}]',975158,'[{18020003,90}]','[{1,16}]',320),(2001,26,0,3900,'[{1,8775},{2,172319},{3,4202},{4,4488},{5,2085},{6,2263},{7,2004},{8,2344}]',999869,'[{18020003,90}]','[{2,322}]',322),(2001,26,1,3900,'[{1,8993},{2,176602},{3,4306},{4,4600},{5,2137},{6,2319},{7,2054},{8,2402}]',1024712,'[{18020003,90}]','[{1,16}]',320),(2001,26,2,3900,'[{1,9213},{2,180929},{3,4411},{4,4713},{5,2188},{6,2376},{7,2104},{8,2460}]',1049689,'[{18020003,90}]','[{2,328}]',328),(2001,26,3,3900,'[{1,9436},{2,185297},{3,4518},{4,4826},{5,2242},{6,2434},{7,2156},{8,2520}]',1075217,'[{18020003,90}]','[{1,17}]',340),(2001,27,0,4260,'[{1,9666},{2,189825},{3,4628},{4,4944},{5,2297},{6,2493},{7,2208},{8,2582}]',1101445,'[{18020003,90}]','[{2,344}]',344),(2001,27,1,4260,'[{1,9899},{2,194402},{3,4739},{4,5063},{5,2351},{6,2553},{7,2261},{8,2643}]',1127832,'[{18020003,90}]','[{1,17}]',340),(2001,27,2,4260,'[{1,10135},{2,199026},{3,4852},{4,5184},{5,2407},{6,2613},{7,2314},{8,2706}]',1154626,'[{18020003,90}]','[{2,349}]',349),(2001,27,3,4260,'[{1,10373},{2,203699},{3,4966},{4,5304},{5,2464},{6,2674},{7,2369},{8,2769}]',1181709,'[{18020003,90}]','[{1,18}]',360),(2001,28,0,4620,'[{1,10620},{2,208536},{3,5084},{4,5430},{5,2522},{6,2738},{7,2425},{8,2835}]',1209786,'[{18020003,90}]','[{2,365}]',365),(2001,28,1,4620,'[{1,10868},{2,213422},{3,5202},{4,5558},{5,2582},{6,2802},{7,2482},{8,2902}]',1238182,'[{18020003,90}]','[{1,19}]',380),(2001,28,2,4620,'[{1,11119},{2,218355},{3,5322},{4,5686},{5,2642},{6,2868},{7,2540},{8,2970}]',1266935,'[{18020003,90}]','[{2,371}]',371),(2001,28,3,4620,'[{1,11373},{2,223337},{3,5444},{4,5816},{5,2702},{6,2934},{7,2598},{8,3038}]',1295897,'[{18020003,90}]','[{1,19}]',380),(2001,29,0,5020,'[{1,11635},{2,228488},{3,5570},{4,5950},{5,2764},{6,3000},{7,2657},{8,3107}]',1325588,'[{18020003,90}]','[{2,390}]',390),(2001,29,1,5020,'[{1,11900},{2,233688},{3,5697},{4,6085},{5,2827},{6,3069},{7,2718},{8,3178}]',1355838,'[{18020003,90}]','[{1,20}]',400),(2001,29,2,5020,'[{1,12167},{2,238936},{3,5825},{4,6223},{5,2890},{6,3138},{7,2779},{8,3249}]',1386276,'[{18020003,90}]','[{2,396}]',396),(2001,29,3,5020,'[{1,12436},{2,244231},{3,5955},{4,6361},{5,2954},{6,3206},{7,2840},{8,3320}]',1416851,'[{18020003,90}]','[{1,21}]',420),(2001,30,0,5420,'[{1,12714},{2,249703},{3,6088},{4,6504},{5,3020},{6,3278},{7,2903},{8,3395}]',1448583,'[{18020003,90}]','[{2,415}]',415),(2001,30,1,5420,'[{1,12996},{2,255222},{3,6223},{4,6647},{5,3087},{6,3351},{7,2968},{8,3470}]',1480692,'[{18020003,90}]','[{1,21}]',420),(2001,30,2,5420,'[{1,13278},{2,260790},{3,6358},{4,6792},{5,3154},{6,3424},{7,3032},{8,3546}]',1512900,'[{18020003,90}]','[{2,423}]',423),(2001,30,3,5420,'[{1,13565},{2,266406},{3,6495},{4,6939},{5,3222},{6,3498},{7,3098},{8,3622}]',1545556,'[{18020003,90}]','[]',0),(2002,1,0,40,'[{1,256},{2,4553},{3,121},{4,121},{5,66},{6,56},{7,62},{8,60}]',27923,'[{18020001,10}]','[{2,21}]',21),(2002,1,1,40,'[{1,263},{2,4680},{3,125},{4,125},{5,67},{6,57},{7,63},{8,61}]',28590,'[{18020001,10}]','[{1,1}]',20),(2002,1,2,40,'[{1,270},{2,4809},{3,128},{4,128},{5,69},{6,59},{7,65},{8,63}]',29409,'[{18020001,10}]','[{2,22}]',22),(2002,1,3,40,'[{1,277},{2,4939},{3,132},{4,132},{5,72},{6,60},{7,67},{8,65}]',30279,'[{18020001,10}]','[{1,1}]',20),(2002,2,0,50,'[{1,287},{2,5096},{3,136},{4,136},{5,74},{6,62},{7,69},{8,67}]',31236,'[{18020001,10}]','[{2,27}]',27),(2002,2,1,50,'[{1,295},{2,5258},{3,140},{4,140},{5,76},{6,64},{7,71},{8,69}]',32158,'[{18020001,10}]','[{1,1}]',20),(2002,2,2,50,'[{1,305},{2,5426},{3,145},{4,145},{5,79},{6,67},{7,74},{8,72}]',33376,'[{18020001,10}]','[{2,26}]',26),(2002,2,3,50,'[{1,315},{2,5598},{3,149},{4,149},{5,81},{6,69},{7,76},{8,74}]',34348,'[{18020001,10}]','[{1,2}]',40),(2002,3,0,80,'[{1,326},{2,5800},{3,155},{4,155},{5,83},{6,71},{7,78},{8,76}]',35470,'[{18020001,10}]','[{2,32}]',32),(2002,3,1,80,'[{1,338},{2,6010},{3,160},{4,160},{5,87},{6,73},{7,81},{8,79}]',36770,'[{18020001,10}]','[{1,2}]',40),(2002,3,2,80,'[{1,351},{2,6228},{3,166},{4,166},{5,90},{6,76},{7,84},{8,82}]',38148,'[{18020001,10}]','[{2,34}]',34),(2002,3,3,80,'[{1,363},{2,6452},{3,171},{4,173},{5,93},{6,79},{7,87},{8,85}]',39512,'[{18020001,10}]','[{1,2}]',40),(2002,4,0,100,'[{1,377},{2,6713},{3,178},{4,180},{5,98},{6,82},{7,91},{8,89}]',41203,'[{18020001,10}]','[{2,38}]',38),(2002,4,1,100,'[{1,393},{2,6983},{3,186},{4,188},{5,102},{6,86},{7,95},{8,93}]',42993,'[{18020001,10}]','[{1,2}]',40),(2002,4,2,100,'[{1,409},{2,7265},{3,193},{4,195},{5,105},{6,89},{7,98},{8,96}]',44545,'[{18020001,10}]','[{2,40}]',40),(2002,4,3,100,'[{1,425},{2,7555},{3,201},{4,203},{5,109},{6,93},{7,102},{8,100}]',46355,'[{18020001,10}]','[{1,2}]',40),(2002,5,0,130,'[{1,444},{2,7887},{3,210},{4,212},{5,114},{6,96},{7,106},{8,104}]',48317,'[{18020001,10}]','[{2,44}]',44),(2002,5,1,130,'[{1,463},{2,8230},{3,219},{4,221},{5,119},{6,101},{7,111},{8,109}]',50490,'[{18020001,10}]','[{1,2}]',40),(2002,5,2,130,'[{1,483},{2,8587},{3,228},{4,230},{5,125},{6,105},{7,116},{8,114}]',52697,'[{18020001,10}]','[{2,47}]',47),(2002,5,3,130,'[{1,504},{2,8956},{3,238},{4,240},{5,129},{6,109},{7,120},{8,118}]',54786,'[{18020001,10}]','[{1,3}]',60),(2002,6,0,170,'[{1,527},{2,9371},{3,249},{4,251},{5,136},{6,115},{7,126},{8,124}]',57461,'[{18020001,10}]','[{2,52}]',52),(2002,6,1,170,'[{1,552},{2,9801},{3,260},{4,262},{5,142},{6,120},{7,132},{8,130}]',60091,'[{18020001,10}]','[{1,3}]',60),(2002,6,2,170,'[{1,576},{2,10247},{3,272},{4,274},{5,149},{6,125},{7,138},{8,136}]',62817,'[{18020001,10}]','[{2,54}]',54),(2002,6,3,170,'[{1,603},{2,10707},{3,284},{4,286},{5,155},{6,131},{7,144},{8,142}]',65617,'[{18020001,10}]','[{1,3}]',60),(2002,7,0,240,'[{1,631},{2,11218},{3,298},{4,300},{5,162},{6,136},{7,150},{8,148}]',68588,'[{18020001,10}]','[{2,59}]',59),(2002,7,1,240,'[{1,661},{2,11746},{3,312},{4,314},{5,170},{6,144},{7,159},{8,155}]',72016,'[{18020001,10}]','[{1,3}]',60),(2002,7,2,240,'[{1,692},{2,12292},{3,326},{4,328},{5,178},{6,150},{7,166},{8,162}]',75282,'[{18020001,10}]','[{2,63}]',63),(2002,7,3,240,'[{1,723},{2,12857},{3,341},{4,343},{5,185},{6,157},{7,173},{8,169}]',78617,'[{18020001,10}]','[{1,3}]',60),(2002,8,0,320,'[{1,758},{2,13476},{3,357},{4,359},{5,194},{6,164},{7,181},{8,177}]',82336,'[{18020001,10}]','[{2,69}]',69),(2002,8,1,320,'[{1,793},{2,14114},{3,374},{4,376},{5,204},{6,172},{7,190},{8,186}]',86324,'[{18020001,10}]','[{1,4}]',80),(2002,8,2,320,'[{1,830},{2,14769},{3,391},{4,393},{5,214},{6,180},{7,199},{8,195}]',90369,'[{18020001,10}]','[{2,70}]',70),(2002,8,3,320,'[{1,868},{2,15442},{3,409},{4,411},{5,223},{6,189},{7,208},{8,204}]',94502,'[{18020001,10}]','[{1,4}]',80),(2002,9,0,410,'[{1,910},{2,16175},{3,429},{4,431},{5,233},{6,197},{7,217},{8,213}]',98875,'[{18020001,10}]','[{2,79}]',79),(2002,9,1,410,'[{1,952},{2,16929},{3,448},{4,450},{5,245},{6,207},{7,228},{8,224}]',103619,'[{18020001,10}]','[{1,4}]',80),(2002,9,2,410,'[{1,997},{2,17703},{3,469},{4,471},{5,256},{6,216},{7,238},{8,234}]',108343,'[{18020001,10}]','[{2,81}]',81),(2002,9,3,410,'[{1,1041},{2,18497},{3,490},{4,492},{5,268},{6,226},{7,249},{8,245}]',113267,'[{18020001,10}]','[{1,4}]',80),(2002,10,0,520,'[{1,1089},{2,19357},{3,512},{4,516},{5,280},{6,236},{7,261},{8,255}]',118437,'[{18020001,10}]','[{2,87}]',87),(2002,10,1,520,'[{1,1138},{2,20237},{3,535},{4,539},{5,292},{6,246},{7,272},{8,266}]',123647,'[{18020001,10}]','[{1,4}]',80),(2002,10,2,520,'[{1,1189},{2,21138},{3,559},{4,563},{5,305},{6,257},{7,284},{8,278}]',129168,'[{18020001,10}]','[{2,91}]',91),(2002,10,3,520,'[{1,1241},{2,22059},{3,584},{4,588},{5,318},{6,268},{7,296},{8,290}]',134779,'[{18020001,10}]','[{1,5}]',100),(2002,11,0,650,'[{1,1297},{2,23051},{3,610},{4,614},{5,333},{6,281},{7,310},{8,304}]',140991,'[{18020002,30}]','[{2,98}]',98),(2002,11,1,650,'[{1,1354},{2,24064},{3,637},{4,641},{5,347},{6,293},{7,323},{8,317}]',147094,'[{18020002,30}]','[{1,5}]',100),(2002,11,2,650,'[{1,1413},{2,25101},{3,665},{4,669},{5,362},{6,306},{7,337},{8,331}]',153511,'[{18020002,30}]','[{2,100}]',100),(2002,11,3,650,'[{1,1473},{2,26162},{3,693},{4,697},{5,376},{6,318},{7,350},{8,344}]',159772,'[{18020002,30}]','[{1,5}]',100),(2002,12,0,780,'[{1,1537},{2,27297},{3,723},{4,727},{5,392},{6,332},{7,366},{8,358}]',166687,'[{18020002,30}]','[{2,109}]',109),(2002,12,1,780,'[{1,1602},{2,28456},{3,753},{4,757},{5,410},{6,346},{7,382},{8,374}]',173846,'[{18020002,30}]','[{1,6}]',120),(2002,12,2,780,'[{1,1669},{2,29637},{3,785},{4,789},{5,427},{6,361},{7,398},{8,390}]',181167,'[{18020002,30}]','[{2,112}]',112),(2002,12,3,780,'[{1,1737},{2,30840},{3,816},{4,820},{5,444},{6,376},{7,414},{8,406}]',188480,'[{18020002,30}]','[{1,6}]',120),(2002,13,0,920,'[{1,1810},{2,32126},{3,850},{4,856},{5,463},{6,391},{7,431},{8,423}]',196376,'[{18020002,30}]','[{2,121}]',121),(2002,13,1,920,'[{1,1883},{2,33437},{3,884},{4,890},{5,481},{6,407},{7,448},{8,440}]',204247,'[{18020002,30}]','[{1,6}]',120),(2002,13,2,920,'[{1,1958},{2,34772},{3,920},{4,926},{5,501},{6,423},{7,467},{8,457}]',212482,'[{18020002,30}]','[{2,122}]',122),(2002,13,3,920,'[{1,2035},{2,36133},{3,956},{4,962},{5,520},{6,440},{7,485},{8,475}]',220783,'[{18020002,30}]','[{1,7}]',140),(2002,14,0,1070,'[{1,2117},{2,37579},{3,994},{4,1000},{5,541},{6,457},{7,504},{8,494}]',229569,'[{18020002,30}]','[{2,131}]',131),(2002,14,1,1070,'[{1,2200},{2,39052},{3,1033},{4,1039},{5,563},{6,475},{7,524},{8,514}]',238652,'[{18020002,30}]','[{1,7}]',140),(2002,14,2,1070,'[{1,2283},{2,40549},{3,1073},{4,1079},{5,584},{6,494},{7,544},{8,534}]',247809,'[{18020002,30}]','[{2,135}]',135),(2002,14,3,1070,'[{1,2369},{2,42071},{3,1113},{4,1119},{5,606},{6,512},{7,565},{8,553}]',257051,'[{18020002,30}]','[{1,7}]',140),(2002,15,0,1240,'[{1,2460},{2,43685},{3,1156},{4,1162},{5,630},{6,532},{7,587},{8,575}]',267035,'[{18020002,30}]','[{2,144}]',144),(2002,15,1,1240,'[{1,2552},{2,45327},{3,1198},{4,1206},{5,653},{6,551},{7,608},{8,596}]',276867,'[{18020002,30}]','[{1,7}]',140),(2002,15,2,1240,'[{1,2646},{2,46996},{3,1243},{4,1251},{5,678},{6,573},{7,631},{8,619}]',287316,'[{18020002,30}]','[{2,148}]',148),(2002,15,3,1240,'[{1,2742},{2,48693},{3,1288},{4,1296},{5,701},{6,593},{7,653},{8,641}]',297533,'[{18020002,30}]','[{1,8}]',160),(2002,16,0,1400,'[{1,2842},{2,50487},{3,1335},{4,1343},{5,727},{6,615},{7,678},{8,664}]',308477,'[{18020002,30}]','[{2,157}]',157),(2002,16,1,1400,'[{1,2945},{2,52308},{3,1384},{4,1392},{5,753},{6,637},{7,702},{8,688}]',319608,'[{18020002,30}]','[{1,8}]',160),(2002,16,2,1400,'[{1,3049},{2,54157},{3,1433},{4,1441},{5,780},{6,660},{7,727},{8,713}]',330987,'[{18020002,30}]','[{2,161}]',161),(2002,16,3,1400,'[{1,3155},{2,56034},{3,1483},{4,1491},{5,808},{6,682},{7,752},{8,738}]',342484,'[{18020002,30}]','[{1,8}]',160),(2002,17,0,1600,'[{1,3266},{2,58012},{3,1535},{4,1545},{5,837},{6,707},{7,780},{8,764}]',354732,'[{18020002,30}]','[{2,172}]',172),(2002,17,1,1600,'[{1,3379},{2,60018},{3,1588},{4,1598},{5,865},{6,731},{7,806},{8,790}]',366848,'[{18020002,30}]','[{1,9}]',180),(2002,17,2,1600,'[{1,3494},{2,62051},{3,1642},{4,1652},{5,894},{6,756},{7,833},{8,817}]',379281,'[{18020002,30}]','[{2,175}]',175),(2002,17,3,1600,'[{1,3610},{2,64112},{3,1697},{4,1707},{5,925},{6,781},{7,862},{8,844}]',392012,'[{18020002,30}]','[{1,9}]',180),(2002,18,0,1790,'[{1,3732},{2,66280},{3,1754},{4,1764},{5,955},{6,807},{7,890},{8,872}]',405070,'[{18020002,30}]','[{2,185}]',185),(2002,18,1,1790,'[{1,3856},{2,68478},{3,1812},{4,1822},{5,988},{6,834},{7,920},{8,902}]',418648,'[{18020002,30}]','[{1,9}]',180),(2002,18,2,1790,'[{1,3981},{2,70707},{3,1871},{4,1883},{5,1019},{6,861},{7,949},{8,931}]',432177,'[{18020002,30}]','[{2,189}]',189),(2002,18,3,1790,'[{1,4108},{2,72965},{3,1931},{4,1943},{5,1051},{6,889},{7,980},{8,960}]',445975,'[{18020002,30}]','[{1,10}]',200),(2002,19,0,2000,'[{1,4241},{2,75336},{3,1994},{4,2006},{5,1085},{6,917},{7,1011},{8,991}]',460356,'[{18020002,30}]','[{2,200}]',200),(2002,19,1,2000,'[{1,4377},{2,77736},{3,2057},{4,2069},{5,1120},{6,946},{7,1043},{8,1023}]',475026,'[{18020002,30}]','[{1,10}]',200),(2002,19,2,2000,'[{1,4513},{2,80167},{3,2122},{4,2134},{5,1156},{6,976},{7,1077},{8,1055}]',490027,'[{18020002,30}]','[{2,203}]',203),(2002,19,3,2000,'[{1,4652},{2,82628},{3,2187},{4,2201},{5,1190},{6,1006},{7,1109},{8,1087}]',504968,'[{18020002,30}]','[{1,11}]',220),(2002,20,0,2220,'[{1,4796},{2,85206},{3,2255},{4,2269},{5,1227},{6,1037},{7,1143},{8,1121}]',520626,'[{18020002,30}]','[{2,216}]',216),(2002,20,1,2220,'[{1,4943},{2,87816},{3,2325},{4,2339},{5,1265},{6,1069},{7,1179},{8,1155}]',536676,'[{18020002,30}]','[{1,11}]',220),(2002,20,2,2220,'[{1,5092},{2,90459},{3,2395},{4,2409},{5,1303},{6,1101},{7,1214},{8,1190}]',552799,'[{18020002,30}]','[{2,219}]',219),(2002,20,3,2220,'[{1,5243},{2,93135},{3,2466},{4,2480},{5,1342},{6,1134},{7,1250},{8,1226}]',569245,'[{18020002,30}]','[{1,11}]',220),(2002,21,0,2460,'[{1,5400},{2,95933},{3,2539},{4,2555},{5,1382},{6,1168},{7,1288},{8,1262}]',586283,'[{18020003,90}]','[{2,232}]',232),(2002,21,1,2460,'[{1,5560},{2,98764},{3,2614},{4,2630},{5,1423},{6,1203},{7,1326},{8,1300}]',603664,'[{18020003,90}]','[{1,12}]',240),(2002,21,2,2460,'[{1,5721},{2,101626},{3,2690},{4,2706},{5,1464},{6,1238},{7,1365},{8,1337}]',621146,'[{18020003,90}]','[{2,236}]',236),(2002,21,3,2460,'[{1,5884},{2,104523},{3,2767},{4,2783},{5,1506},{6,1272},{7,1403},{8,1375}]',638753,'[{18020003,90}]','[{1,12}]',240),(2002,22,0,2700,'[{1,6054},{2,107546},{3,2846},{4,2864},{5,1549},{6,1309},{7,1443},{8,1415}]',657176,'[{18020003,90}]','[{2,247}]',247),(2002,22,1,2700,'[{1,6226},{2,110603},{3,2927},{4,2945},{5,1593},{6,1347},{7,1485},{8,1455}]',675923,'[{18020003,90}]','[{1,13}]',260),(2002,22,2,2700,'[{1,6401},{2,113697},{3,3010},{4,3028},{5,1638},{6,1384},{7,1526},{8,1496}]',694867,'[{18020003,90}]','[{2,251}]',251),(2002,22,3,2700,'[{1,6576},{2,116826},{3,3093},{4,3111},{5,1682},{6,1422},{7,1568},{8,1536}]',713846,'[{18020003,90}]','[{1,13}]',260),(2002,23,0,2980,'[{1,6760},{2,120087},{3,3178},{4,3198},{5,1729},{6,1461},{7,1611},{8,1579}]',733687,'[{18020003,90}]','[{2,265}]',265),(2002,23,1,2980,'[{1,6946},{2,123382},{3,3266},{4,3286},{5,1777},{6,1501},{7,1655},{8,1623}]',753902,'[{18020003,90}]','[{1,13}]',260),(2002,23,2,2980,'[{1,7133},{2,126713},{3,3355},{4,3375},{5,1825},{6,1543},{7,1701},{8,1667}]',774423,'[{18020003,90}]','[{2,270}]',270),(2002,23,3,2980,'[{1,7322},{2,130080},{3,3444},{4,3464},{5,1874},{6,1584},{7,1746},{8,1712}]',795020,'[{18020003,90}]','[{1,14}]',280),(2002,24,0,3260,'[{1,7519},{2,133583},{3,3536},{4,3558},{5,1924},{6,1626},{7,1793},{8,1757}]',816313,'[{18020003,90}]','[{2,284}]',284),(2002,24,1,3260,'[{1,7719},{2,137124},{3,3630},{4,3652},{5,1975},{6,1669},{7,1840},{8,1804}]',837954,'[{18020003,90}]','[{1,14}]',280),(2002,24,2,3260,'[{1,7920},{2,140703},{3,3725},{4,3747},{5,2027},{6,1713},{7,1889},{8,1851}]',859903,'[{18020003,90}]','[{2,289}]',289),(2002,24,3,3260,'[{1,8124},{2,144320},{3,3821},{4,3843},{5,2079},{6,1757},{7,1937},{8,1899}]',882000,'[{18020003,90}]','[{1,15}]',300),(2002,25,0,3580,'[{1,8335},{2,148079},{3,3920},{4,3944},{5,2132},{6,1802},{7,1987},{8,1947}]',904779,'[{18020003,90}]','[{2,302}]',302),(2002,25,1,3580,'[{1,8548},{2,151878},{3,4021},{4,4045},{5,2188},{6,1848},{7,2038},{8,1998}]',928088,'[{18020003,90}]','[{1,15}]',300),(2002,25,2,3580,'[{1,8764},{2,155718},{3,4123},{4,4147},{5,2243},{6,1895},{7,2090},{8,2048}]',951548,'[{18020003,90}]','[{2,307}]',307),(2002,25,3,3580,'[{1,8983},{2,159597},{3,4225},{4,4251},{5,2298},{6,1942},{7,2141},{8,2099}]',975157,'[{18020003,90}]','[{1,16}]',320),(2002,26,0,3900,'[{1,9210},{2,163625},{3,4332},{4,4358},{5,2357},{6,1991},{7,2196},{8,2152}]',999875,'[{18020003,90}]','[{2,322}]',322),(2002,26,1,3900,'[{1,9439},{2,167692},{3,4440},{4,4466},{5,2415},{6,2041},{7,2250},{8,2206}]',1024722,'[{18020003,90}]','[{1,16}]',320),(2002,26,2,3900,'[{1,9670},{2,171800},{3,4548},{4,4576},{5,2474},{6,2090},{7,2305},{8,2259}]',1049700,'[{18020003,90}]','[{2,328}]',328),(2002,26,3,3900,'[{1,9904},{2,175948},{3,4658},{4,4686},{5,2534},{6,2142},{7,2361},{8,2315}]',1075228,'[{18020003,90}]','[{1,17}]',340),(2002,27,0,4260,'[{1,10145},{2,180248},{3,4772},{4,4800},{5,2596},{6,2194},{7,2419},{8,2371}]',1101448,'[{18020003,90}]','[{2,343}]',343),(2002,27,1,4260,'[{1,10390},{2,184594},{3,4886},{4,4916},{5,2658},{6,2246},{7,2477},{8,2427}]',1127844,'[{18020003,90}]','[{1,17}]',340),(2002,27,2,4260,'[{1,10638},{2,188985},{3,5003},{4,5033},{5,2721},{6,2299},{7,2535},{8,2485}]',1154645,'[{18020003,90}]','[{2,348}]',348),(2002,27,3,4260,'[{1,10887},{2,193422},{3,5120},{4,5150},{5,2785},{6,2353},{7,2595},{8,2543}]',1181712,'[{18020003,90}]','[{1,18}]',360),(2002,28,0,4620,'[{1,11146},{2,198015},{3,5241},{4,5273},{5,2851},{6,2409},{7,2656},{8,2604}]',1209785,'[{18020003,90}]','[{2,366}]',366),(2002,28,1,4620,'[{1,11406},{2,202654},{3,5364},{4,5396},{5,2918},{6,2466},{7,2719},{8,2665}]',1238174,'[{18020003,90}]','[{1,18}]',360),(2002,28,2,4620,'[{1,11670},{2,207338},{3,5487},{4,5521},{5,2986},{6,2524},{7,2783},{8,2727}]',1266938,'[{18020003,90}]','[{2,371}]',371),(2002,28,3,4620,'[{1,11937},{2,212068},{3,5613},{4,5647},{5,3055},{6,2581},{7,2846},{8,2790}]',1295908,'[{18020003,90}]','[{1,19}]',380),(2002,29,0,5020,'[{1,12211},{2,216960},{3,5743},{4,5777},{5,3124},{6,2640},{7,2911},{8,2853}]',1325580,'[{18020003,90}]','[{2,388}]',388),(2002,29,1,5020,'[{1,12490},{2,221897},{3,5873},{4,5909},{5,3196},{6,2700},{7,2977},{8,2919}]',1355847,'[{18020003,90}]','[{1,20}]',400),(2002,29,2,5020,'[{1,12769},{2,226881},{3,6006},{4,6042},{5,3267},{6,2761},{7,3044},{8,2984}]',1386261,'[{18020003,90}]','[{2,396}]',396),(2002,29,3,5020,'[{1,13052},{2,231909},{3,6140},{4,6176},{5,3339},{6,2821},{7,3111},{8,3049}]',1416849,'[{18020003,90}]','[{1,21}]',420),(2002,30,0,5420,'[{1,13344},{2,237105},{3,6277},{4,6315},{5,3414},{6,2884},{7,3180},{8,3118}]',1448585,'[{18020003,90}]','[{2,414}]',414),(2002,30,1,5420,'[{1,13640},{2,242345},{3,6416},{4,6454},{5,3489},{6,2949},{7,3251},{8,3187}]',1480695,'[{18020003,90}]','[{1,21}]',420),(2002,30,2,5420,'[{1,13936},{2,247632},{3,6555},{4,6595},{5,3565},{6,3013},{7,3322},{8,3256}]',1512902,'[{18020003,90}]','[{2,421}]',421),(2002,30,3,5420,'[{1,14237},{2,252964},{3,6697},{4,6737},{5,3642},{6,3078},{7,3394},{8,3326}]',1545554,'[{18020003,90}]','[]',0),(2003,1,0,40,'[{1,242},{2,4848},{3,132},{4,110},{5,60},{6,62},{7,64},{8,58}]',27938,'[{18020001,10}]','[{2,21}]',21),(2003,1,1,40,'[{1,248},{2,4983},{3,136},{4,114},{5,61},{6,63},{7,65},{8,59}]',28593,'[{18020001,10}]','[{1,1}]',20),(2003,1,2,40,'[{1,254},{2,5120},{3,139},{4,117},{5,63},{6,65},{7,67},{8,61}]',29400,'[{18020001,10}]','[{2,21}]',21),(2003,1,3,40,'[{1,261},{2,5259},{3,143},{4,121},{5,65},{6,67},{7,69},{8,63}]',30279,'[{18020001,10}]','[{1,1}]',20),(2003,2,0,50,'[{1,270},{2,5427},{3,148},{4,124},{5,67},{6,69},{7,71},{8,65}]',31227,'[{18020001,10}]','[{2,27}]',27),(2003,2,1,50,'[{1,278},{2,5599},{3,152},{4,128},{5,69},{6,71},{7,74},{8,66}]',32159,'[{18020001,10}]','[{1,1}]',20),(2003,2,2,50,'[{1,287},{2,5778},{3,158},{4,132},{5,71},{6,75},{7,77},{8,69}]',33368,'[{18020001,10}]','[{2,28}]',28),(2003,2,3,50,'[{1,296},{2,5961},{3,162},{4,136},{5,73},{6,77},{7,79},{8,71}]',34331,'[{18020001,10}]','[{1,2}]',40),(2003,3,0,80,'[{1,307},{2,6176},{3,168},{4,142},{5,75},{6,79},{7,81},{8,73}]',35466,'[{18020001,10}]','[{2,31}]',31),(2003,3,1,80,'[{1,318},{2,6400},{3,174},{4,146},{5,78},{6,82},{7,84},{8,76}]',36760,'[{18020001,10}]','[{1,2}]',40),(2003,3,2,80,'[{1,330},{2,6631},{3,180},{4,152},{5,81},{6,85},{7,87},{8,79}]',38131,'[{18020001,10}]','[{2,34}]',34),(2003,3,3,80,'[{1,342},{2,6871},{3,187},{4,157},{5,84},{6,88},{7,90},{8,82}]',39511,'[{18020001,10}]','[{1,2}]',40),(2003,4,0,100,'[{1,355},{2,7148},{3,195},{4,163},{5,88},{6,92},{7,95},{8,85}]',41198,'[{18020001,10}]','[{2,37}]',37),(2003,4,1,100,'[{1,370},{2,7436},{3,203},{4,171},{5,92},{6,96},{7,99},{8,89}]',42986,'[{18020001,10}]','[{1,2}]',40),(2003,4,2,100,'[{1,385},{2,7735},{3,211},{4,177},{5,95},{6,99},{7,102},{8,92}]',44535,'[{18020001,10}]','[{2,39}]',39),(2003,4,3,100,'[{1,400},{2,8045},{3,220},{4,184},{5,99},{6,103},{7,106},{8,96}]',46345,'[{18020001,10}]','[{1,2}]',40),(2003,5,0,130,'[{1,418},{2,8398},{3,229},{4,193},{5,103},{6,107},{7,110},{8,100}]',48308,'[{18020001,10}]','[{2,44}]',44),(2003,5,1,130,'[{1,436},{2,8763},{3,239},{4,201},{5,108},{6,112},{7,116},{8,104}]',50483,'[{18020001,10}]','[{1,2}]',40),(2003,5,2,130,'[{1,455},{2,9143},{3,249},{4,209},{5,113},{6,117},{7,121},{8,109}]',52693,'[{18020001,10}]','[{2,48}]',48),(2003,5,3,130,'[{1,475},{2,9537},{3,260},{4,218},{5,117},{6,121},{7,125},{8,113}]',54787,'[{18020001,10}]','[{1,2}]',40),(2003,6,0,170,'[{1,497},{2,9979},{3,272},{4,228},{5,122},{6,128},{7,131},{8,119}]',57419,'[{18020001,10}]','[{2,52}]',52),(2003,6,1,170,'[{1,520},{2,10437},{3,284},{4,238},{5,128},{6,134},{7,138},{8,124}]',60087,'[{18020001,10}]','[{1,3}]',60),(2003,6,2,170,'[{1,543},{2,10911},{3,297},{4,249},{5,134},{6,140},{7,144},{8,130}]',62821,'[{18020001,10}]','[{2,54}]',54),(2003,6,3,170,'[{1,568},{2,11401},{3,310},{4,260},{5,140},{6,146},{7,150},{8,136}]',65611,'[{18020001,10}]','[{1,3}]',60),(2003,7,0,240,'[{1,595},{2,11945},{3,325},{4,273},{5,146},{6,152},{7,157},{8,141}]',68595,'[{18020001,10}]','[{2,59}]',59),(2003,7,1,240,'[{1,623},{2,12507},{3,340},{4,286},{5,154},{6,160},{7,165},{8,149}]',72017,'[{18020001,10}]','[{1,3}]',60),(2003,7,2,240,'[{1,652},{2,13089},{3,355},{4,299},{5,161},{6,167},{7,172},{8,156}]',75279,'[{18020001,10}]','[{2,63}]',63),(2003,7,3,240,'[{1,682},{2,13690},{3,372},{4,312},{5,167},{6,175},{7,180},{8,162}]',78630,'[{18020001,10}]','[{1,3}]',60),(2003,8,0,320,'[{1,715},{2,14350},{3,389},{4,327},{5,175},{6,183},{7,188},{8,170}]',82350,'[{18020001,10}]','[{2,69}]',69),(2003,8,1,320,'[{1,748},{2,15029},{3,408},{4,342},{5,184},{6,192},{7,198},{8,178}]',86339,'[{18020001,10}]','[{1,3}]',60),(2003,8,2,320,'[{1,782},{2,15726},{3,426},{4,358},{5,193},{6,201},{7,207},{8,187}]',90366,'[{18020001,10}]','[{2,72}]',72),(2003,8,3,320,'[{1,818},{2,16443},{3,446},{4,374},{5,202},{6,210},{7,217},{8,195}]',94503,'[{18020001,10}]','[{1,4}]',80),(2003,9,0,410,'[{1,857},{2,17223},{3,467},{4,393},{5,210},{6,220},{7,226},{8,204}]',98863,'[{18020001,10}]','[{2,79}]',79),(2003,9,1,410,'[{1,897},{2,18026},{3,488},{4,410},{5,221},{6,231},{7,238},{8,214}]',103616,'[{18020001,10}]','[{1,4}]',80),(2003,9,2,410,'[{1,939},{2,18851},{3,511},{4,429},{5,231},{6,241},{7,248},{8,224}]',108331,'[{18020001,10}]','[{2,80}]',80),(2003,9,3,410,'[{1,981},{2,19696},{3,534},{4,448},{5,242},{6,252},{7,260},{8,234}]',113266,'[{18020001,10}]','[{1,4}]',80),(2003,10,0,520,'[{1,1026},{2,20612},{3,559},{4,469},{5,253},{6,263},{7,271},{8,245}]',118432,'[{18020001,10}]','[{2,88}]',88),(2003,10,1,520,'[{1,1073},{2,21549},{3,584},{4,490},{5,263},{6,275},{7,283},{8,255}]',123659,'[{18020001,10}]','[{1,4}]',80),(2003,10,2,520,'[{1,1121},{2,22508},{3,610},{4,512},{5,275},{6,287},{7,295},{8,267}]',129178,'[{18020001,10}]','[{2,91}]',91),(2003,10,3,520,'[{1,1170},{2,23489},{3,637},{4,535},{5,287},{6,299},{7,308},{8,278}]',134789,'[{18020001,10}]','[{1,5}]',100),(2003,11,0,650,'[{1,1223},{2,24545},{3,665},{4,559},{5,301},{6,313},{7,323},{8,291}]',141005,'[{18020002,30}]','[{2,98}]',98),(2003,11,1,650,'[{1,1276},{2,25624},{3,695},{4,583},{5,313},{6,327},{7,336},{8,304}]',147094,'[{18020002,30}]','[{1,5}]',100),(2003,11,2,650,'[{1,1331},{2,26728},{3,725},{4,609},{5,327},{6,341},{7,351},{8,317}]',153498,'[{18020002,30}]','[{2,100}]',100),(2003,11,3,650,'[{1,1388},{2,27858},{3,755},{4,635},{5,340},{6,354},{7,365},{8,329}]',159768,'[{18020002,30}]','[{1,5}]',100),(2003,12,0,780,'[{1,1448},{2,29067},{3,788},{4,662},{5,354},{6,370},{7,380},{8,344}]',166677,'[{18020002,30}]','[{2,108}]',108),(2003,12,1,780,'[{1,1510},{2,30300},{3,821},{4,689},{5,370},{6,386},{7,397},{8,359}]',173850,'[{18020002,30}]','[{1,5}]',100),(2003,12,2,780,'[{1,1573},{2,31558},{3,855},{4,719},{5,386},{6,402},{7,414},{8,374}]',181168,'[{18020002,30}]','[{2,112}]',112),(2003,12,3,780,'[{1,1637},{2,32840},{3,889},{4,747},{5,401},{6,419},{7,431},{8,389}]',188480,'[{18020002,30}]','[{1,6}]',120),(2003,13,0,920,'[{1,1706},{2,34208},{3,927},{4,779},{5,418},{6,436},{7,449},{8,405}]',196378,'[{18020002,30}]','[{2,120}]',120),(2003,13,1,920,'[{1,1774},{2,35604},{3,964},{4,810},{5,435},{6,453},{7,467},{8,421}]',204234,'[{18020002,30}]','[{1,6}]',120),(2003,13,2,920,'[{1,1845},{2,37026},{3,1003},{4,843},{5,452},{6,472},{7,486},{8,438}]',212476,'[{18020002,30}]','[{2,122}]',122),(2003,13,3,920,'[{1,1918},{2,38475},{3,1042},{4,876},{5,470},{6,490},{7,504},{8,456}]',220785,'[{18020002,30}]','[{1,6}]',120),(2003,14,0,1070,'[{1,1995},{2,40015},{3,1084},{4,910},{5,489},{6,509},{7,524},{8,474}]',229565,'[{18020002,30}]','[{2,132}]',132),(2003,14,1,1070,'[{1,2073},{2,41583},{3,1126},{4,946},{5,508},{6,530},{7,545},{8,493}]',238643,'[{18020002,30}]','[{1,7}]',140),(2003,14,2,1070,'[{1,2152},{2,43177},{3,1170},{4,982},{5,528},{6,550},{7,566},{8,512}]',247817,'[{18020002,30}]','[{2,135}]',135),(2003,14,3,1070,'[{1,2233},{2,44798},{3,1213},{4,1019},{5,547},{6,571},{7,588},{8,530}]',257058,'[{18020002,30}]','[{1,7}]',140),(2003,15,0,1240,'[{1,2318},{2,46517},{3,1260},{4,1058},{5,569},{6,593},{7,611},{8,551}]',267027,'[{18020002,30}]','[{2,144}]',144),(2003,15,1,1240,'[{1,2405},{2,48265},{3,1307},{4,1097},{5,589},{6,615},{7,633},{8,571}]',276865,'[{18020002,30}]','[{1,7}]',140),(2003,15,2,1240,'[{1,2494},{2,50043},{3,1355},{4,1139},{5,612},{6,638},{7,657},{8,593}]',287273,'[{18020002,30}]','[{2,148}]',148),(2003,15,3,1240,'[{1,2584},{2,51849},{3,1404},{4,1180},{5,633},{6,661},{7,680},{8,614}]',297529,'[{18020002,30}]','[{1,8}]',160),(2003,16,0,1400,'[{1,2679},{2,53759},{3,1455},{4,1223},{5,657},{6,685},{7,705},{8,637}]',308489,'[{18020002,30}]','[{2,157}]',157),(2003,16,1,1400,'[{1,2775},{2,55699},{3,1509},{4,1267},{5,680},{6,710},{7,730},{8,660}]',319599,'[{18020002,30}]','[{1,8}]',160),(2003,16,2,1400,'[{1,2873},{2,57668},{3,1562},{4,1312},{5,705},{6,735},{7,757},{8,683}]',330978,'[{18020002,30}]','[{2,161}]',161),(2003,16,3,1400,'[{1,2973},{2,59666},{3,1616},{4,1358},{5,729},{6,761},{7,783},{8,707}]',342476,'[{18020002,30}]','[{1,8}]',160),(2003,17,0,1600,'[{1,3078},{2,61772},{3,1674},{4,1406},{5,756},{6,788},{7,811},{8,733}]',354732,'[{18020002,30}]','[{2,170}]',170),(2003,17,1,1600,'[{1,3185},{2,63909},{3,1732},{4,1454},{5,781},{6,815},{7,839},{8,757}]',366859,'[{18020002,30}]','[{1,9}]',180),(2003,17,2,1600,'[{1,3292},{2,66074},{3,1790},{4,1504},{5,808},{6,842},{7,867},{8,783}]',379264,'[{18020002,30}]','[{2,175}]',175),(2003,17,3,1600,'[{1,3402},{2,68268},{3,1850},{4,1554},{5,835},{6,871},{7,897},{8,809}]',392008,'[{18020002,30}]','[{1,9}]',180),(2003,18,0,1790,'[{1,3517},{2,70577},{3,1912},{4,1606},{5,862},{6,900},{7,926},{8,836}]',405067,'[{18020002,30}]','[{2,185}]',185),(2003,18,1,1790,'[{1,3634},{2,72918},{3,1975},{4,1659},{5,892},{6,930},{7,957},{8,865}]',418648,'[{18020002,30}]','[{1,9}]',180),(2003,18,2,1790,'[{1,3751},{2,75290},{3,2040},{4,1714},{5,920},{6,960},{7,988},{8,892}]',432160,'[{18020002,30}]','[{2,190}]',190),(2003,18,3,1790,'[{1,3871},{2,77695},{3,2106},{4,1768},{5,950},{6,990},{7,1019},{8,921}]',445965,'[{18020002,30}]','[{1,10}]',200),(2003,19,0,2000,'[{1,3997},{2,80219},{3,2174},{4,1826},{5,980},{6,1022},{7,1052},{8,950}]',460359,'[{18020002,30}]','[{2,200}]',200),(2003,19,1,2000,'[{1,4125},{2,82775},{3,2242},{4,1884},{5,1011},{6,1055},{7,1086},{8,980}]',475025,'[{18020002,30}]','[{1,10}]',200),(2003,19,2,2000,'[{1,4253},{2,85363},{3,2313},{4,1943},{5,1044},{6,1088},{7,1120},{8,1012}]',490023,'[{18020002,30}]','[{2,204}]',204),(2003,19,3,2000,'[{1,4384},{2,87985},{3,2385},{4,2003},{5,1075},{6,1121},{7,1154},{8,1042}]',504965,'[{18020002,30}]','[{1,11}]',220),(2003,20,0,2220,'[{1,4520},{2,90729},{3,2459},{4,2065},{5,1108},{6,1156},{7,1190},{8,1074}]',520629,'[{18020002,30}]','[{2,215}]',215),(2003,20,1,2220,'[{1,4659},{2,93509},{3,2535},{4,2129},{5,1142},{6,1192},{7,1227},{8,1107}]',536689,'[{18020002,30}]','[{1,11}]',220),(2003,20,2,2220,'[{1,4798},{2,96323},{3,2611},{4,2193},{5,1177},{6,1227},{7,1263},{8,1141}]',552783,'[{18020002,30}]','[{2,220}]',220),(2003,20,3,2220,'[{1,4941},{2,99173},{3,2688},{4,2258},{5,1212},{6,1264},{7,1301},{8,1175}]',569243,'[{18020002,30}]','[{1,11}]',220),(2003,21,0,2460,'[{1,5089},{2,102152},{3,2769},{4,2325},{5,1248},{6,1302},{7,1340},{8,1210}]',586282,'[{18020003,90}]','[{2,231}]',231),(2003,21,1,2460,'[{1,5240},{2,105166},{3,2850},{4,2394},{5,1285},{6,1341},{7,1380},{8,1246}]',603666,'[{18020003,90}]','[{1,12}]',240),(2003,21,2,2460,'[{1,5391},{2,108214},{3,2933},{4,2463},{5,1323},{6,1379},{7,1420},{8,1282}]',621134,'[{18020003,90}]','[{2,236}]',236),(2003,21,3,2460,'[{1,5545},{2,111298},{3,3016},{4,2534},{5,1360},{6,1418},{7,1460},{8,1318}]',638748,'[{18020003,90}]','[{1,12}]',240),(2003,22,0,2700,'[{1,5706},{2,114518},{3,3103},{4,2607},{5,1399},{6,1459},{7,1502},{8,1356}]',657188,'[{18020003,90}]','[{2,248}]',248),(2003,22,1,2700,'[{1,5867},{2,117773},{3,3191},{4,2681},{5,1439},{6,1501},{7,1545},{8,1395}]',675913,'[{18020003,90}]','[{1,12}]',240),(2003,22,2,2700,'[{1,6032},{2,121068},{3,3282},{4,2756},{5,1479},{6,1543},{7,1588},{8,1434}]',694858,'[{18020003,90}]','[{2,252}]',252),(2003,22,3,2700,'[{1,6198},{2,124399},{3,3372},{4,2832},{5,1519},{6,1585},{7,1631},{8,1473}]',713859,'[{18020003,90}]','[{1,13}]',260),(2003,23,0,2980,'[{1,6370},{2,127871},{3,3465},{4,2911},{5,1562},{6,1628},{7,1676},{8,1514}]',733671,'[{18020003,90}]','[{2,266}]',266),(2003,23,1,2980,'[{1,6546},{2,131380},{3,3561},{4,2991},{5,1605},{6,1673},{7,1723},{8,1555}]',753900,'[{18020003,90}]','[{1,13}]',260),(2003,23,2,2980,'[{1,6723},{2,134927},{3,3658},{4,3072},{5,1649},{6,1719},{7,1770},{8,1598}]',774437,'[{18020003,90}]','[{2,272}]',272),(2003,23,3,2980,'[{1,6900},{2,138512},{3,3754},{4,3154},{5,1693},{6,1765},{7,1817},{8,1641}]',795012,'[{18020003,90}]','[{1,14}]',280),(2003,24,0,3260,'[{1,7086},{2,142243},{3,3856},{4,3238},{5,1738},{6,1812},{7,1866},{8,1684}]',816313,'[{18020003,90}]','[{2,284}]',284),(2003,24,1,3260,'[{1,7274},{2,146013},{3,3958},{4,3324},{5,1784},{6,1860},{7,1915},{8,1729}]',837943,'[{18020003,90}]','[{1,14}]',280),(2003,24,2,3260,'[{1,7464},{2,149824},{3,4061},{4,3411},{5,1831},{6,1909},{7,1965},{8,1775}]',859904,'[{18020003,90}]','[{2,289}]',289),(2003,24,3,3260,'[{1,7656},{2,153676},{3,4165},{4,3499},{5,1878},{6,1958},{7,2016},{8,1820}]',881996,'[{18020003,90}]','[{1,15}]',300),(2003,25,0,3580,'[{1,7855},{2,157678},{3,4274},{4,3590},{5,1926},{6,2008},{7,2067},{8,1867}]',904778,'[{18020003,90}]','[{2,302}]',302),(2003,25,1,3580,'[{1,8056},{2,161724},{3,4384},{4,3682},{5,1976},{6,2060},{7,2121},{8,1915}]',928094,'[{18020003,90}]','[{1,15}]',300),(2003,25,2,3580,'[{1,8259},{2,165812},{3,4495},{4,3775},{5,2026},{6,2112},{7,2175},{8,1963}]',951542,'[{18020003,90}]','[{2,307}]',307),(2003,25,3,3580,'[{1,8466},{2,169943},{3,4607},{4,3869},{5,2075},{6,2165},{7,2228},{8,2012}]',975163,'[{18020003,90}]','[{1,16}]',320),(2003,26,0,3900,'[{1,8680},{2,174232},{3,4723},{4,3967},{5,2128},{6,2220},{7,2285},{8,2063}]',999882,'[{18020003,90}]','[{2,322}]',322),(2003,26,1,3900,'[{1,8895},{2,178562},{3,4840},{4,4066},{5,2181},{6,2275},{7,2342},{8,2114}]',1024712,'[{18020003,90}]','[{1,16}]',320),(2003,26,2,3900,'[{1,9113},{2,182937},{3,4959},{4,4165},{5,2234},{6,2330},{7,2398},{8,2166}]',1049697,'[{18020003,90}]','[{2,328}]',328),(2003,26,3,3900,'[{1,9333},{2,187354},{3,5078},{4,4266},{5,2289},{6,2387},{7,2457},{8,2219}]',1075214,'[{18020003,90}]','[{1,17}]',340),(2003,27,0,4260,'[{1,9561},{2,191932},{3,5202},{4,4370},{5,2345},{6,2445},{7,2517},{8,2273}]',1101452,'[{18020003,90}]','[{2,344}]',344),(2003,27,1,4260,'[{1,9791},{2,196560},{3,5327},{4,4475},{5,2401},{6,2503},{7,2577},{8,2327}]',1127830,'[{18020003,90}]','[{1,17}]',340),(2003,27,2,4260,'[{1,10025},{2,201236},{3,5455},{4,4581},{5,2457},{6,2563},{7,2638},{8,2382}]',1154636,'[{18020003,90}]','[{2,348}]',348),(2003,27,3,4260,'[{1,10259},{2,205960},{3,5582},{4,4688},{5,2515},{6,2623},{7,2700},{8,2438}]',1181690,'[{18020003,90}]','[{1,18}]',360),(2003,28,0,4620,'[{1,10504},{2,210851},{3,5714},{4,4800},{5,2575},{6,2685},{7,2764},{8,2496}]',1209781,'[{18020003,90}]','[{2,366}]',366),(2003,28,1,4620,'[{1,10749},{2,215791},{3,5848},{4,4912},{5,2635},{6,2749},{7,2829},{8,2555}]',1238171,'[{18020003,90}]','[{1,18}]',360),(2003,28,2,4620,'[{1,10998},{2,220779},{3,5983},{4,5025},{5,2697},{6,2813},{7,2896},{8,2614}]',1266939,'[{18020003,90}]','[{2,372}]',372),(2003,28,3,4620,'[{1,11249},{2,225816},{3,6120},{4,5140},{5,2759},{6,2877},{7,2962},{8,2674}]',1295896,'[{18020003,90}]','[{1,19}]',380),(2003,29,0,5020,'[{1,11508},{2,231024},{3,6261},{4,5259},{5,2821},{6,2943},{7,3029},{8,2735}]',1325584,'[{18020003,90}]','[{2,388}]',388),(2003,29,1,5020,'[{1,11770},{2,236282},{3,6404},{4,5378},{5,2886},{6,3010},{7,3098},{8,2798}]',1355832,'[{18020003,90}]','[{1,20}]',400),(2003,29,2,5020,'[{1,12034},{2,241588},{3,6548},{4,5500},{5,2951},{6,3077},{7,3168},{8,2860}]',1386268,'[{18020003,90}]','[{2,396}]',396),(2003,29,3,5020,'[{1,12300},{2,246942},{3,6694},{4,5622},{5,3015},{6,3145},{7,3237},{8,2923}]',1416842,'[{18020003,90}]','[{1,21}]',420),(2003,30,0,5420,'[{1,12576},{2,252475},{3,6844},{4,5748},{5,3083},{6,3215},{7,3310},{8,2988}]',1448595,'[{18020003,90}]','[{2,415}]',415),(2003,30,1,5420,'[{1,12854},{2,258055},{3,6995},{4,5875},{5,3151},{6,3287},{7,3383},{8,3055}]',1480685,'[{18020003,90}]','[{1,21}]',420),(2003,30,2,5420,'[{1,13134},{2,263684},{3,7147},{4,6003},{5,3220},{6,3358},{7,3457},{8,3121}]',1512914,'[{18020003,90}]','[{2,421}]',421),(2003,30,3,5420,'[{1,13417},{2,269363},{3,7301},{4,6133},{5,3289},{6,3431},{7,3531},{8,3189}]',1545553,'[{18020003,90}]','[]',0),(2004,1,0,40,'[{1,225},{2,5172},{3,133},{4,109},{5,65},{6,57},{7,57},{8,65}]',27922,'[{18020001,10}]','[{2,21}]',21),(2004,1,1,40,'[{1,231},{2,5316},{3,137},{4,113},{5,66},{6,58},{7,57},{8,67}]',28586,'[{18020001,10}]','[{1,1}]',20),(2004,1,2,40,'[{1,237},{2,5463},{3,141},{4,115},{5,68},{6,60},{7,59},{8,69}]',29403,'[{18020001,10}]','[{2,22}]',22),(2004,1,3,40,'[{1,244},{2,5611},{3,145},{4,119},{5,70},{6,62},{7,61},{8,71}]',30291,'[{18020001,10}]','[{1,1}]',20),(2004,2,0,50,'[{1,252},{2,5790},{3,149},{4,123},{5,72},{6,64},{7,63},{8,73}]',31230,'[{18020001,10}]','[{2,25}]',25),(2004,2,1,50,'[{1,260},{2,5974},{3,154},{4,126},{5,74},{6,66},{7,65},{8,75}]',32174,'[{18020001,10}]','[{1,1}]',20),(2004,2,2,50,'[{1,268},{2,6164},{3,159},{4,131},{5,78},{6,68},{7,68},{8,78}]',33374,'[{18020001,10}]','[{2,27}]',27),(2004,2,3,50,'[{1,277},{2,6359},{3,164},{4,134},{5,80},{6,70},{7,70},{8,80}]',34349,'[{18020001,10}]','[{1,2}]',40),(2004,3,0,80,'[{1,287},{2,6589},{3,170},{4,140},{5,82},{6,72},{7,71},{8,83}]',35479,'[{18020001,10}]','[{2,32}]',32),(2004,3,1,80,'[{1,297},{2,6828},{3,176},{4,144},{5,85},{6,75},{7,74},{8,86}]',36768,'[{18020001,10}]','[{1,2}]',40),(2004,3,2,80,'[{1,308},{2,7075},{3,182},{4,150},{5,88},{6,78},{7,77},{8,89}]',38135,'[{18020001,10}]','[{2,33}]',33),(2004,3,3,80,'[{1,319},{2,7330},{3,189},{4,155},{5,91},{6,81},{7,80},{8,92}]',39510,'[{18020001,10}]','[{1,2}]',40),(2004,4,0,100,'[{1,331},{2,7626},{3,197},{4,161},{5,96},{6,84},{7,83},{8,97}]',41196,'[{18020001,10}]','[{2,38}]',38),(2004,4,1,100,'[{1,345},{2,7933},{3,206},{4,168},{5,100},{6,88},{7,87},{8,101}]',42983,'[{18020001,10}]','[{1,2}]',40),(2004,4,2,100,'[{1,359},{2,8253},{3,213},{4,175},{5,103},{6,91},{7,90},{8,104}]',44533,'[{18020001,10}]','[{2,39}]',39),(2004,4,3,100,'[{1,373},{2,8583},{3,222},{4,182},{5,107},{6,95},{7,94},{8,108}]',46343,'[{18020001,10}]','[{1,2}]',40),(2004,5,0,130,'[{1,390},{2,8959},{3,232},{4,190},{5,112},{6,98},{7,97},{8,113}]',48309,'[{18020001,10}]','[{2,43}]',43),(2004,5,1,130,'[{1,407},{2,9349},{3,242},{4,198},{5,117},{6,103},{7,102},{8,118}]',50489,'[{18020001,10}]','[{1,2}]',40),(2004,5,2,130,'[{1,425},{2,9755},{3,252},{4,206},{5,122},{6,108},{7,107},{8,123}]',52705,'[{18020001,10}]','[{2,47}]',47),(2004,5,3,130,'[{1,443},{2,10175},{3,263},{4,215},{5,126},{6,112},{7,110},{8,128}]',54785,'[{18020001,10}]','[{1,3}]',60),(2004,6,0,170,'[{1,464},{2,10646},{3,275},{4,225},{5,133},{6,117},{7,116},{8,134}]',57426,'[{18020001,10}]','[{2,51}]',51),(2004,6,1,170,'[{1,485},{2,11135},{3,287},{4,235},{5,139},{6,123},{7,121},{8,141}]',60085,'[{18020001,10}]','[{1,3}]',60),(2004,6,2,170,'[{1,506},{2,11640},{3,300},{4,246},{5,146},{6,128},{7,127},{8,147}]',62810,'[{18020001,10}]','[{2,55}]',55),(2004,6,3,170,'[{1,530},{2,12163},{3,313},{4,257},{5,152},{6,134},{7,133},{8,153}]',65613,'[{18020001,10}]','[{1,3}]',60),(2004,7,0,240,'[{1,555},{2,12744},{3,329},{4,269},{5,158},{6,140},{7,138},{8,160}]',68594,'[{18020001,10}]','[{2,60}]',60),(2004,7,1,240,'[{1,581},{2,13343},{3,344},{4,282},{5,167},{6,147},{7,146},{8,168}]',72013,'[{18020001,10}]','[{1,3}]',60),(2004,7,2,240,'[{1,608},{2,13964},{3,359},{4,295},{5,174},{6,154},{7,152},{8,176}]',75274,'[{18020001,10}]','[{2,63}]',63),(2004,7,3,240,'[{1,636},{2,14606},{3,376},{4,308},{5,182},{6,160},{7,159},{8,183}]',78626,'[{18020001,10}]','[{1,3}]',60),(2004,8,0,320,'[{1,667},{2,15309},{3,393},{4,323},{5,190},{6,168},{7,166},{8,192}]',82349,'[{18020001,10}]','[{2,69}]',69),(2004,8,1,320,'[{1,697},{2,16034},{3,412},{4,338},{5,200},{6,176},{7,174},{8,202}]',86324,'[{18020001,10}]','[{1,3}]',60),(2004,8,2,320,'[{1,730},{2,16778},{3,431},{4,353},{5,209},{6,185},{7,183},{8,211}]',90378,'[{18020001,10}]','[{2,72}]',72),(2004,8,3,320,'[{1,763},{2,17542},{3,451},{4,369},{5,219},{6,193},{7,191},{8,221}]',94502,'[{18020001,10}]','[{1,4}]',80),(2004,9,0,410,'[{1,800},{2,18375},{3,473},{4,387},{5,229},{6,201},{7,199},{8,231}]',98875,'[{18020001,10}]','[{2,78}]',78),(2004,9,1,410,'[{1,837},{2,19231},{3,493},{4,405},{5,240},{6,212},{7,210},{8,242}]',103621,'[{18020001,10}]','[{1,4}]',80),(2004,9,2,410,'[{1,876},{2,20111},{3,517},{4,423},{5,251},{6,221},{7,219},{8,253}]',108331,'[{18020001,10}]','[{2,81}]',81),(2004,9,3,410,'[{1,915},{2,21013},{3,540},{4,442},{5,263},{6,231},{7,229},{8,265}]',113263,'[{18020001,10}]','[{1,4}]',80),(2004,10,0,520,'[{1,957},{2,21990},{3,565},{4,463},{5,274},{6,242},{7,239},{8,277}]',118430,'[{18020001,10}]','[{2,88}]',88),(2004,10,1,520,'[{1,1001},{2,22990},{3,590},{4,484},{5,286},{6,252},{7,249},{8,289}]',123660,'[{18020001,10}]','[{1,4}]',80),(2004,10,2,520,'[{1,1046},{2,24013},{3,617},{4,505},{5,299},{6,263},{7,260},{8,302}]',129183,'[{18020001,10}]','[{2,91}]',91),(2004,10,3,520,'[{1,1091},{2,25059},{3,644},{4,528},{5,311},{6,275},{7,272},{8,314}]',134779,'[{18020001,10}]','[{1,5}]',100),(2004,11,0,650,'[{1,1140},{2,26186},{3,673},{4,551},{5,326},{6,288},{7,285},{8,329}]',140986,'[{18020002,30}]','[{2,98}]',98),(2004,11,1,650,'[{1,1191},{2,27338},{3,702},{4,576},{5,340},{6,300},{7,297},{8,343}]',147108,'[{18020002,30}]','[{1,5}]',100),(2004,11,2,650,'[{1,1242},{2,28516},{3,733},{4,601},{5,355},{6,313},{7,310},{8,358}]',153506,'[{18020002,30}]','[{2,101}]',101),(2004,11,3,650,'[{1,1295},{2,29720},{3,764},{4,626},{5,369},{6,325},{7,322},{8,372}]',159770,'[{18020002,30}]','[{1,5}]',100),(2004,12,0,780,'[{1,1351},{2,31011},{3,797},{4,653},{5,385},{6,339},{7,336},{8,388}]',166681,'[{18020002,30}]','[{2,109}]',109),(2004,12,1,780,'[{1,1409},{2,32327},{3,830},{4,680},{5,402},{6,354},{7,350},{8,406}]',173857,'[{18020002,30}]','[{1,5}]',100),(2004,12,2,780,'[{1,1467},{2,33668},{3,865},{4,709},{5,419},{6,369},{7,365},{8,423}]',181158,'[{18020002,30}]','[{2,112}]',112),(2004,12,3,780,'[{1,1527},{2,35035},{3,899},{4,737},{5,436},{6,384},{7,380},{8,440}]',188475,'[{18020002,30}]','[{1,6}]',120),(2004,13,0,920,'[{1,1591},{2,36496},{3,937},{4,769},{5,454},{6,400},{7,396},{8,458}]',196366,'[{18020002,30}]','[{2,120}]',120),(2004,13,1,920,'[{1,1655},{2,37985},{3,975},{4,799},{5,472},{6,416},{7,412},{8,476}]',204235,'[{18020002,30}]','[{1,6}]',120),(2004,13,2,920,'[{1,1721},{2,39502},{3,1014},{4,832},{5,491},{6,433},{7,428},{8,496}]',212472,'[{18020002,30}]','[{2,123}]',123),(2004,13,3,920,'[{1,1789},{2,41047},{3,1054},{4,864},{5,510},{6,450},{7,445},{8,515}]',220777,'[{18020002,30}]','[{1,6}]',120),(2004,14,0,1070,'[{1,1861},{2,42691},{3,1096},{4,898},{5,530},{6,468},{7,463},{8,535}]',229561,'[{18020002,30}]','[{2,132}]',132),(2004,14,1,1070,'[{1,1934},{2,44364},{3,1139},{4,933},{5,552},{6,486},{7,481},{8,557}]',238644,'[{18020002,30}]','[{1,7}]',140),(2004,14,2,1070,'[{1,2007},{2,46064},{3,1183},{4,969},{5,573},{6,505},{7,500},{8,578}]',247804,'[{18020002,30}]','[{2,135}]',135),(2004,14,3,1070,'[{1,2083},{2,47794},{3,1226},{4,1006},{5,594},{6,524},{7,518},{8,600}]',257054,'[{18020002,30}]','[{1,7}]',140),(2004,15,0,1240,'[{1,2163},{2,49627},{3,1274},{4,1044},{5,618},{6,544},{7,539},{8,623}]',267037,'[{18020002,30}]','[{2,144}]',144),(2004,15,1,1240,'[{1,2244},{2,51493},{3,1321},{4,1083},{5,640},{6,564},{7,558},{8,646}]',276873,'[{18020002,30}]','[{1,7}]',140),(2004,15,2,1240,'[{1,2327},{2,53389},{3,1370},{4,1124},{5,664},{6,586},{7,579},{8,671}]',287279,'[{18020002,30}]','[{2,147}]',147),(2004,15,3,1240,'[{1,2410},{2,55316},{3,1420},{4,1164},{5,688},{6,606},{7,600},{8,694}]',297516,'[{18020002,30}]','[{1,8}]',160),(2004,16,0,1400,'[{1,2499},{2,57354},{3,1472},{4,1206},{5,713},{6,629},{7,622},{8,720}]',308484,'[{18020002,30}]','[{2,158}]',158),(2004,16,1,1400,'[{1,2589},{2,59424},{3,1525},{4,1251},{5,739},{6,651},{7,644},{8,746}]',319604,'[{18020002,30}]','[{1,8}]',160),(2004,16,2,1400,'[{1,2680},{2,61524},{3,1579},{4,1295},{5,765},{6,675},{7,667},{8,773}]',330974,'[{18020002,30}]','[{2,160}]',160),(2004,16,3,1400,'[{1,2773},{2,63656},{3,1634},{4,1340},{5,792},{6,698},{7,691},{8,799}]',342466,'[{18020002,30}]','[{1,8}]',160),(2004,17,0,1600,'[{1,2871},{2,65903},{3,1692},{4,1388},{5,821},{6,723},{7,716},{8,828}]',354723,'[{18020002,30}]','[{2,171}]',171),(2004,17,1,1600,'[{1,2971},{2,68182},{3,1751},{4,1435},{5,848},{6,748},{7,740},{8,856}]',366852,'[{18020002,30}]','[{1,9}]',180),(2004,17,2,1600,'[{1,3071},{2,70492},{3,1810},{4,1484},{5,877},{6,773},{7,765},{8,885}]',379262,'[{18020002,30}]','[{2,174}]',174),(2004,17,3,1600,'[{1,3174},{2,72833},{3,1870},{4,1534},{5,907},{6,799},{7,791},{8,915}]',392013,'[{18020002,30}]','[{1,9}]',180),(2004,18,0,1790,'[{1,3281},{2,75296},{3,1933},{4,1585},{5,937},{6,825},{7,817},{8,945}]',405066,'[{18020002,30}]','[{2,186}]',186),(2004,18,1,1790,'[{1,3390},{2,77793},{3,1997},{4,1637},{5,968},{6,854},{7,844},{8,978}]',418643,'[{18020002,30}]','[{1,9}]',180),(2004,18,2,1790,'[{1,3500},{2,80325},{3,2063},{4,1691},{5,999},{6,881},{7,871},{8,1009}]',432175,'[{18020002,30}]','[{2,188}]',188),(2004,18,3,1790,'[{1,3611},{2,82890},{3,2129},{4,1745},{5,1031},{6,909},{7,899},{8,1041}]',445960,'[{18020002,30}]','[{1,10}]',200),(2004,19,0,2000,'[{1,3729},{2,85583},{3,2198},{4,1802},{5,1064},{6,938},{7,928},{8,1074}]',460363,'[{18020002,30}]','[{2,201}]',201),(2004,19,1,2000,'[{1,3848},{2,88310},{3,2267},{4,1859},{5,1098},{6,968},{7,958},{8,1108}]',475020,'[{18020002,30}]','[{1,10}]',200),(2004,19,2,2000,'[{1,3968},{2,91071},{3,2339},{4,1917},{5,1133},{6,999},{7,988},{8,1144}]',490031,'[{18020002,30}]','[{2,205}]',205),(2004,19,3,2000,'[{1,4090},{2,93868},{3,2411},{4,1977},{5,1167},{6,1029},{7,1018},{8,1178}]',504968,'[{18020002,30}]','[{1,11}]',220),(2004,20,0,2220,'[{1,4216},{2,96796},{3,2486},{4,2038},{5,1203},{6,1061},{7,1049},{8,1215}]',520616,'[{18020002,30}]','[{2,215}]',215),(2004,20,1,2220,'[{1,4346},{2,99761},{3,2563},{4,2101},{5,1241},{6,1093},{7,1082},{8,1252}]',536681,'[{18020002,30}]','[{1,11}]',220),(2004,20,2,2220,'[{1,4476},{2,102764},{3,2640},{4,2164},{5,1278},{6,1126},{7,1114},{8,1290}]',552784,'[{18020002,30}]','[{2,219}]',219),(2004,20,3,2220,'[{1,4609},{2,105804},{3,2718},{4,2228},{5,1316},{6,1160},{7,1148},{8,1328}]',569234,'[{18020002,30}]','[{1,11}]',220),(2004,21,0,2460,'[{1,4747},{2,108982},{3,2799},{4,2295},{5,1355},{6,1195},{7,1182},{8,1368}]',586272,'[{18020003,90}]','[{2,232}]',232),(2004,21,1,2460,'[{1,4888},{2,112198},{3,2882},{4,2362},{5,1396},{6,1230},{7,1217},{8,1409}]',603658,'[{18020003,90}]','[{1,12}]',240),(2004,21,2,2460,'[{1,5029},{2,115450},{3,2965},{4,2431},{5,1436},{6,1266},{7,1252},{8,1450}]',621130,'[{18020003,90}]','[{2,235}]',235),(2004,21,3,2460,'[{1,5173},{2,118740},{3,3050},{4,2500},{5,1477},{6,1301},{7,1288},{8,1490}]',638750,'[{18020003,90}]','[{1,12}]',240),(2004,22,0,2700,'[{1,5323},{2,122175},{3,3138},{4,2572},{5,1519},{6,1339},{7,1325},{8,1533}]',657185,'[{18020003,90}]','[{2,247}]',247),(2004,22,1,2700,'[{1,5473},{2,125648},{3,3227},{4,2645},{5,1563},{6,1377},{7,1363},{8,1577}]',675908,'[{18020003,90}]','[{1,12}]',240),(2004,22,2,2700,'[{1,5627},{2,129163},{3,3318},{4,2720},{5,1606},{6,1416},{7,1401},{8,1621}]',694853,'[{18020003,90}]','[{2,253}]',253),(2004,22,3,2700,'[{1,5782},{2,132717},{3,3409},{4,2795},{5,1650},{6,1454},{7,1439},{8,1665}]',713857,'[{18020003,90}]','[{1,13}]',260),(2004,23,0,2980,'[{1,5943},{2,136422},{3,3504},{4,2872},{5,1695},{6,1495},{7,1479},{8,1711}]',733682,'[{18020003,90}]','[{2,265}]',265),(2004,23,1,2980,'[{1,6106},{2,140165},{3,3600},{4,2952},{5,1742},{6,1536},{7,1519},{8,1759}]',753885,'[{18020003,90}]','[{1,13}]',260),(2004,23,2,2980,'[{1,6271},{2,143949},{3,3698},{4,3032},{5,1790},{6,1578},{7,1561},{8,1807}]',774419,'[{18020003,90}]','[{2,270}]',270),(2004,23,3,2980,'[{1,6437},{2,147774},{3,3796},{4,3112},{5,1838},{6,1620},{7,1603},{8,1855}]',795014,'[{18020003,90}]','[{1,14}]',280),(2004,24,0,3260,'[{1,6610},{2,151754},{3,3898},{4,3196},{5,1887},{6,1663},{7,1645},{8,1905}]',816304,'[{18020003,90}]','[{2,283}]',283),(2004,24,1,3260,'[{1,6786},{2,155777},{3,4001},{4,3281},{5,1937},{6,1707},{7,1689},{8,1955}]',837947,'[{18020003,90}]','[{1,14}]',280),(2004,24,2,3260,'[{1,6963},{2,159842},{3,4106},{4,3366},{5,1988},{6,1752},{7,1733},{8,2007}]',859902,'[{18020003,90}]','[{2,289}]',289),(2004,24,3,3260,'[{1,7142},{2,163951},{3,4211},{4,3453},{5,2039},{6,1797},{7,1778},{8,2058}]',881991,'[{18020003,90}]','[{1,15}]',300),(2004,25,0,3580,'[{1,7328},{2,168221},{3,4321},{4,3543},{5,2091},{6,1843},{7,1823},{8,2111}]',904781,'[{18020003,90}]','[{2,302}]',302),(2004,25,1,3580,'[{1,7515},{2,172538},{3,4432},{4,3634},{5,2145},{6,1891},{7,1871},{8,2165}]',928088,'[{18020003,90}]','[{1,15}]',300),(2004,25,2,3580,'[{1,7705},{2,176899},{3,4544},{4,3726},{5,2199},{6,1939},{7,1918},{8,2220}]',951549,'[{18020003,90}]','[{2,308}]',308),(2004,25,3,3580,'[{1,7898},{2,181307},{3,4658},{4,3818},{5,2254},{6,1986},{7,1965},{8,2275}]',975167,'[{18020003,90}]','[{1,16}]',320),(2004,26,0,3900,'[{1,8097},{2,185882},{3,4775},{4,3915},{5,2311},{6,2037},{7,2015},{8,2333}]',999872,'[{18020003,90}]','[{2,323}]',323),(2004,26,1,3900,'[{1,8298},{2,190502},{3,4894},{4,4012},{5,2368},{6,2088},{7,2065},{8,2391}]',1024712,'[{18020003,90}]','[{1,16}]',320),(2004,26,2,3900,'[{1,8501},{2,195169},{3,5014},{4,4110},{5,2426},{6,2138},{7,2115},{8,2449}]',1049689,'[{18020003,90}]','[{2,327}]',327),(2004,26,3,3900,'[{1,8707},{2,199882},{3,5135},{4,4209},{5,2485},{6,2191},{7,2167},{8,2509}]',1075222,'[{18020003,90}]','[{1,17}]',340),(2004,27,0,4260,'[{1,8919},{2,204766},{3,5260},{4,4312},{5,2546},{6,2244},{7,2220},{8,2570}]',1101446,'[{18020003,90}]','[{2,344}]',344),(2004,27,1,4260,'[{1,9134},{2,209704},{3,5386},{4,4416},{5,2606},{6,2298},{7,2273},{8,2631}]',1127834,'[{18020003,90}]','[{1,17}]',340),(2004,27,2,4260,'[{1,9352},{2,214692},{3,5515},{4,4521},{5,2668},{6,2352},{7,2327},{8,2693}]',1154632,'[{18020003,90}]','[{2,350}]',350),(2004,27,3,4260,'[{1,9571},{2,219732},{3,5643},{4,4627},{5,2731},{6,2407},{7,2381},{8,2757}]',1181702,'[{18020003,90}]','[{1,18}]',360),(2004,28,0,4620,'[{1,9799},{2,224950},{3,5777},{4,4737},{5,2796},{6,2464},{7,2438},{8,2822}]',1209780,'[{18020003,90}]','[{2,366}]',366),(2004,28,1,4620,'[{1,10028},{2,230220},{3,5913},{4,4847},{5,2862},{6,2522},{7,2495},{8,2889}]',1238180,'[{18020003,90}]','[{1,18}]',360),(2004,28,2,4620,'[{1,10260},{2,235541},{3,6049},{4,4959},{5,2929},{6,2581},{7,2554},{8,2956}]',1266941,'[{18020003,90}]','[{2,372}]',372),(2004,28,3,4620,'[{1,10494},{2,240915},{3,6187},{4,5073},{5,2996},{6,2640},{7,2612},{8,3024}]',1295895,'[{18020003,90}]','[{1,19}]',380),(2004,29,0,5020,'[{1,10735},{2,246472},{3,6330},{4,5190},{5,3064},{6,2700},{7,2672},{8,3092}]',1325572,'[{18020003,90}]','[{2,388}]',388),(2004,29,1,5020,'[{1,10980},{2,252081},{3,6474},{4,5308},{5,3134},{6,2762},{7,2733},{8,3163}]',1355831,'[{18020003,90}]','[{1,20}]',400),(2004,29,2,5020,'[{1,11226},{2,257742},{3,6620},{4,5428},{5,3204},{6,2824},{7,2794},{8,3234}]',1386262,'[{18020003,90}]','[{2,396}]',396),(2004,29,3,5020,'[{1,11475},{2,263454},{3,6768},{4,5548},{5,3274},{6,2886},{7,2855},{8,3305}]',1416854,'[{18020003,90}]','[{1,21}]',420),(2004,30,0,5420,'[{1,11732},{2,269357},{3,6919},{4,5673},{5,3347},{6,2951},{7,2919},{8,3379}]',1448597,'[{18020003,90}]','[{2,414}]',414),(2004,30,1,5420,'[{1,11991},{2,275310},{3,7072},{4,5798},{5,3422},{6,3016},{7,2984},{8,3454}]',1480680,'[{18020003,90}]','[{1,21}]',420),(2004,30,2,5420,'[{1,12252},{2,281316},{3,7226},{4,5924},{5,3496},{6,3082},{7,3049},{8,3529}]',1512906,'[{18020003,90}]','[{2,420}]',420),(2004,30,3,5420,'[{1,12516},{2,287374},{3,7382},{4,6052},{5,3572},{6,3148},{7,3115},{8,3605}]',1545544,'[{18020003,90}]','[]',0),(2005,1,0,40,'[{1,259},{2,4495},{3,126},{4,116},{5,61},{6,61},{7,56},{8,66}]',27925,'[{18020001,10}]','[{2,21}]',21),(2005,1,1,40,'[{1,266},{2,4620},{3,131},{4,120},{5,62},{6,62},{7,57},{8,67}]',28615,'[{18020001,10}]','[{1,1}]',20),(2005,1,2,40,'[{1,273},{2,4747},{3,134},{4,122},{5,64},{6,64},{7,59},{8,69}]',29407,'[{18020001,10}]','[{2,22}]',22),(2005,1,3,40,'[{1,281},{2,4876},{3,138},{4,126},{5,66},{6,66},{7,61},{8,71}]',30296,'[{18020001,10}]','[{1,1}]',20),(2005,2,0,50,'[{1,290},{2,5031},{3,142},{4,130},{5,68},{6,68},{7,63},{8,73}]',31231,'[{18020001,10}]','[{2,27}]',27),(2005,2,1,50,'[{1,299},{2,5191},{3,146},{4,134},{5,70},{6,70},{7,65},{8,75}]',32171,'[{18020001,10}]','[{1,1}]',20),(2005,2,2,50,'[{1,308},{2,5357},{3,151},{4,139},{5,74},{6,72},{7,68},{8,78}]',33367,'[{18020001,10}]','[{2,28}]',28),(2005,2,3,50,'[{1,318},{2,5527},{3,156},{4,142},{5,76},{6,74},{7,69},{8,81}]',34337,'[{18020001,10}]','[{1,2}]',40),(2005,3,0,80,'[{1,330},{2,5726},{3,162},{4,148},{5,78},{6,76},{7,71},{8,83}]',35476,'[{18020001,10}]','[{2,32}]',32),(2005,3,1,80,'[{1,342},{2,5934},{3,167},{4,153},{5,81},{6,79},{7,74},{8,86}]',36774,'[{18020001,10}]','[{1,2}]',40),(2005,3,2,80,'[{1,355},{2,6148},{3,173},{4,159},{5,84},{6,82},{7,77},{8,89}]',38148,'[{18020001,10}]','[{2,35}]',35),(2005,3,3,80,'[{1,367},{2,6370},{3,180},{4,164},{5,87},{6,85},{7,80},{8,92}]',39510,'[{18020001,10}]','[{1,2}]',40),(2005,4,0,100,'[{1,381},{2,6627},{3,187},{4,171},{5,91},{6,89},{7,83},{8,97}]',41197,'[{18020001,10}]','[{2,38}]',38),(2005,4,1,100,'[{1,397},{2,6894},{3,195},{4,179},{5,95},{6,93},{7,87},{8,101}]',42984,'[{18020001,10}]','[{1,2}]',40),(2005,4,2,100,'[{1,413},{2,7172},{3,203},{4,185},{5,98},{6,96},{7,90},{8,104}]',44532,'[{18020001,10}]','[{2,39}]',39),(2005,4,3,100,'[{1,429},{2,7459},{3,211},{4,193},{5,102},{6,100},{7,93},{8,109}]',46339,'[{18020001,10}]','[{1,2}]',40),(2005,5,0,130,'[{1,449},{2,7786},{3,220},{4,202},{5,106},{6,104},{7,97},{8,113}]',48316,'[{18020001,10}]','[{2,46}]',46),(2005,5,1,130,'[{1,468},{2,8125},{3,230},{4,210},{5,111},{6,109},{7,102},{8,118}]',50485,'[{18020001,10}]','[{1,2}]',40),(2005,5,2,130,'[{1,488},{2,8477},{3,239},{4,219},{5,116},{6,114},{7,106},{8,124}]',52687,'[{18020001,10}]','[{2,47}]',47),(2005,5,3,130,'[{1,510},{2,8842},{3,250},{4,228},{5,120},{6,118},{7,110},{8,128}]',54792,'[{18020001,10}]','[{1,3}]',60),(2005,6,0,170,'[{1,533},{2,9252},{3,261},{4,239},{5,126},{6,124},{7,116},{8,134}]',57412,'[{18020001,10}]','[{2,52}]',52),(2005,6,1,170,'[{1,558},{2,9676},{3,272},{4,250},{5,132},{6,130},{7,121},{8,141}]',60086,'[{18020001,10}]','[{1,3}]',60),(2005,6,2,170,'[{1,583},{2,10116},{3,285},{4,261},{5,138},{6,136},{7,127},{8,147}]',62826,'[{18020001,10}]','[{2,54}]',54),(2005,6,3,170,'[{1,609},{2,10570},{3,298},{4,272},{5,144},{6,142},{7,132},{8,154}]',65600,'[{18020001,10}]','[{1,3}]',60),(2005,7,0,240,'[{1,638},{2,11075},{3,312},{4,286},{5,150},{6,148},{7,138},{8,160}]',68585,'[{18020001,10}]','[{2,61}]',61),(2005,7,1,240,'[{1,668},{2,11596},{3,327},{4,299},{5,158},{6,156},{7,145},{8,169}]',72006,'[{18020001,10}]','[{1,3}]',60),(2005,7,2,240,'[{1,699},{2,12136},{3,341},{4,313},{5,165},{6,163},{7,152},{8,176}]',75266,'[{18020001,10}]','[{2,62}]',62),(2005,7,3,240,'[{1,731},{2,12693},{3,357},{4,327},{5,172},{6,170},{7,158},{8,184}]',78613,'[{18020001,10}]','[{1,3}]',60),(2005,8,0,320,'[{1,767},{2,13304},{3,374},{4,342},{5,180},{6,178},{7,166},{8,192}]',82344,'[{18020001,10}]','[{2,68}]',68),(2005,8,1,320,'[{1,802},{2,13934},{3,392},{4,359},{5,189},{6,187},{7,174},{8,202}]',86349,'[{18020001,10}]','[{1,4}]',80),(2005,8,2,320,'[{1,840},{2,14581},{3,409},{4,375},{5,198},{6,196},{7,182},{8,212}]',90381,'[{18020001,10}]','[{2,70}]',70),(2005,8,3,320,'[{1,878},{2,15245},{3,428},{4,392},{5,207},{6,205},{7,191},{8,221}]',94505,'[{18020001,10}]','[{1,4}]',80),(2005,9,0,410,'[{1,920},{2,15969},{3,449},{4,411},{5,217},{6,213},{7,199},{8,231}]',98869,'[{18020001,10}]','[{2,78}]',78),(2005,9,1,410,'[{1,963},{2,16713},{3,469},{4,429},{5,228},{6,224},{7,209},{8,243}]',103623,'[{18020001,10}]','[{1,4}]',80),(2005,9,2,410,'[{1,1008},{2,17477},{3,491},{4,449},{5,238},{6,234},{7,218},{8,254}]',108337,'[{18020001,10}]','[{2,81}]',81),(2005,9,3,410,'[{1,1053},{2,18261},{3,513},{4,469},{5,249},{6,245},{7,228},{8,266}]',113271,'[{18020001,10}]','[{1,4}]',80),(2005,10,0,520,'[{1,1101},{2,19110},{3,537},{4,491},{5,260},{6,256},{7,239},{8,277}]',118430,'[{18020001,10}]','[{2,87}]',87),(2005,10,1,520,'[{1,1151},{2,19979},{3,561},{4,513},{5,271},{6,267},{7,249},{8,289}]',123649,'[{18020001,10}]','[{1,4}]',80),(2005,10,2,520,'[{1,1203},{2,20868},{3,586},{4,536},{5,283},{6,279},{7,260},{8,302}]',129178,'[{18020001,10}]','[{2,91}]',91),(2005,10,3,520,'[{1,1255},{2,21778},{3,612},{4,560},{5,295},{6,291},{7,271},{8,315}]',134778,'[{18020001,10}]','[{1,5}]',100),(2005,11,0,650,'[{1,1312},{2,22757},{3,639},{4,585},{5,309},{6,305},{7,284},{8,330}]',140997,'[{18020002,30}]','[{2,98}]',98),(2005,11,1,650,'[{1,1370},{2,23757},{3,667},{4,611},{5,322},{6,318},{7,296},{8,344}]',147107,'[{18020002,30}]','[{1,5}]',100),(2005,11,2,650,'[{1,1429},{2,24781},{3,696},{4,638},{5,336},{6,332},{7,309},{8,359}]',153511,'[{18020002,30}]','[{2,101}]',101),(2005,11,3,650,'[{1,1490},{2,25828},{3,726},{4,664},{5,349},{6,345},{7,321},{8,373}]',159778,'[{18020002,30}]','[{1,5}]',100),(2005,12,0,780,'[{1,1554},{2,26949},{3,757},{4,693},{5,365},{6,359},{7,335},{8,389}]',166679,'[{18020002,30}]','[{2,108}]',108),(2005,12,1,780,'[{1,1620},{2,28093},{3,788},{4,722},{5,381},{6,375},{7,350},{8,406}]',173843,'[{18020002,30}]','[{1,6}]',120),(2005,12,2,780,'[{1,1688},{2,29259},{3,822},{4,752},{5,397},{6,391},{7,364},{8,424}]',181169,'[{18020002,30}]','[{2,112}]',112),(2005,12,3,780,'[{1,1756},{2,30447},{3,854},{4,782},{5,413},{6,407},{7,379},{8,441}]',188467,'[{18020002,30}]','[{1,6}]',120),(2005,13,0,920,'[{1,1830},{2,31716},{3,891},{4,815},{5,430},{6,424},{7,395},{8,459}]',196366,'[{18020002,30}]','[{2,120}]',120),(2005,13,1,920,'[{1,1904},{2,33010},{3,926},{4,848},{5,447},{6,441},{7,411},{8,477}]',204240,'[{18020002,30}]','[{1,6}]',120),(2005,13,2,920,'[{1,1980},{2,34328},{3,964},{4,882},{5,465},{6,459},{7,427},{8,497}]',212478,'[{18020002,30}]','[{2,122}]',122),(2005,13,3,920,'[{1,2058},{2,35672},{3,1001},{4,917},{5,483},{6,477},{7,444},{8,516}]',220782,'[{18020002,30}]','[{1,6}]',120),(2005,14,0,1070,'[{1,2141},{2,37100},{3,1041},{4,953},{5,502},{6,496},{7,462},{8,536}]',229570,'[{18020002,30}]','[{2,133}]',133),(2005,14,1,1070,'[{1,2224},{2,38554},{3,1082},{4,990},{5,523},{6,515},{7,480},{8,558}]',238634,'[{18020002,30}]','[{1,7}]',140),(2005,14,2,1070,'[{1,2309},{2,40032},{3,1123},{4,1029},{5,543},{6,535},{7,499},{8,579}]',247812,'[{18020002,30}]','[{2,135}]',135),(2005,14,3,1070,'[{1,2396},{2,41535},{3,1165},{4,1067},{5,563},{6,555},{7,517},{8,601}]',257055,'[{18020002,30}]','[{1,7}]',140),(2005,15,0,1240,'[{1,2488},{2,43128},{3,1210},{4,1108},{5,585},{6,577},{7,537},{8,625}]',267038,'[{18020002,30}]','[{2,144}]',144),(2005,15,1,1240,'[{1,2581},{2,44749},{3,1255},{4,1149},{5,606},{6,598},{7,557},{8,647}]',276869,'[{18020002,30}]','[{1,7}]',140),(2005,15,2,1240,'[{1,2676},{2,46397},{3,1302},{4,1192},{5,629},{6,621},{7,578},{8,672}]',287267,'[{18020002,30}]','[{2,148}]',148),(2005,15,3,1240,'[{1,2773},{2,48072},{3,1349},{4,1235},{5,652},{6,642},{7,598},{8,696}]',297532,'[{18020002,30}]','[{1,8}]',160),(2005,16,0,1400,'[{1,2875},{2,49843},{3,1398},{4,1280},{5,676},{6,666},{7,621},{8,721}]',308493,'[{18020002,30}]','[{2,158}]',158),(2005,16,1,1400,'[{1,2978},{2,51641},{3,1449},{4,1327},{5,700},{6,690},{7,643},{8,747}]',319601,'[{18020002,30}]','[{1,8}]',160),(2005,16,2,1400,'[{1,3083},{2,53467},{3,1500},{4,1374},{5,725},{6,715},{7,666},{8,774}]',330977,'[{18020002,30}]','[{2,160}]',160),(2005,16,3,1400,'[{1,3191},{2,55319},{3,1552},{4,1422},{5,750},{6,740},{7,689},{8,801}]',342489,'[{18020002,30}]','[{1,8}]',160),(2005,17,0,1600,'[{1,3303},{2,57272},{3,1608},{4,1472},{5,777},{6,767},{7,714},{8,830}]',354732,'[{18020002,30}]','[{2,171}]',171),(2005,17,1,1600,'[{1,3418},{2,59253},{3,1663},{4,1523},{5,804},{6,792},{7,738},{8,858}]',366863,'[{18020002,30}]','[{1,9}]',180),(2005,17,2,1600,'[{1,3533},{2,61260},{3,1719},{4,1575},{5,831},{6,819},{7,763},{8,887}]',379270,'[{18020002,30}]','[{2,174}]',174),(2005,17,3,1600,'[{1,3651},{2,63295},{3,1777},{4,1627},{5,859},{6,847},{7,789},{8,917}]',392015,'[{18020002,30}]','[{1,9}]',180),(2005,18,0,1790,'[{1,3774},{2,65435},{3,1836},{4,1682},{5,887},{6,875},{7,815},{8,947}]',405065,'[{18020002,30}]','[{2,185}]',185),(2005,18,1,1790,'[{1,3900},{2,67605},{3,1897},{4,1737},{5,917},{6,905},{7,843},{8,979}]',418655,'[{18020002,30}]','[{1,9}]',180),(2005,18,2,1790,'[{1,4026},{2,69805},{3,1960},{4,1794},{5,947},{6,933},{7,870},{8,1011}]',432225,'[{18020002,30}]','[{2,188}]',188),(2005,18,3,1790,'[{1,4154},{2,72035},{3,2022},{4,1852},{5,977},{6,963},{7,897},{8,1043}]',445965,'[{18020002,30}]','[{1,10}]',200),(2005,19,0,2000,'[{1,4289},{2,74375},{3,2088},{4,1912},{5,1008},{6,994},{7,926},{8,1076}]',460355,'[{18020002,30}]','[{2,201}]',201),(2005,19,1,2000,'[{1,4426},{2,76745},{3,2154},{4,1972},{5,1040},{6,1026},{7,956},{8,1110}]',475015,'[{18020002,30}]','[{1,10}]',200),(2005,19,2,2000,'[{1,4565},{2,79144},{3,2222},{4,2034},{5,1073},{6,1059},{7,986},{8,1146}]',490044,'[{18020002,30}]','[{2,204}]',204),(2005,19,3,2000,'[{1,4705},{2,81575},{3,2291},{4,2097},{5,1106},{6,1090},{7,1016},{8,1180}]',504975,'[{18020002,30}]','[{1,11}]',220),(2005,20,0,2220,'[{1,4851},{2,84119},{3,2362},{4,2162},{5,1140},{6,1124},{7,1047},{8,1217}]',520639,'[{18020002,30}]','[{2,216}]',216),(2005,20,1,2220,'[{1,4999},{2,86696},{3,2435},{4,2229},{5,1175},{6,1159},{7,1079},{8,1255}]',536676,'[{18020002,30}]','[{1,11}]',220),(2005,20,2,2220,'[{1,5149},{2,89306},{3,2508},{4,2296},{5,1210},{6,1194},{7,1112},{8,1292}]',552786,'[{18020002,30}]','[{2,219}]',219),(2005,20,3,2220,'[{1,5303},{2,91948},{3,2582},{4,2364},{5,1247},{6,1229},{7,1145},{8,1331}]',569258,'[{18020002,30}]','[{1,11}]',220),(2005,21,0,2460,'[{1,5461},{2,94710},{3,2659},{4,2435},{5,1284},{6,1266},{7,1179},{8,1371}]',586280,'[{18020003,90}]','[{2,232}]',232),(2005,21,1,2460,'[{1,5623},{2,97504},{3,2737},{4,2507},{5,1322},{6,1304},{7,1215},{8,1411}]',603664,'[{18020003,90}]','[{1,12}]',240),(2005,21,2,2460,'[{1,5786},{2,100330},{3,2817},{4,2579},{5,1360},{6,1342},{7,1250},{8,1452}]',621150,'[{18020003,90}]','[{2,235}]',235),(2005,21,3,2460,'[{1,5950},{2,103190},{3,2897},{4,2653},{5,1399},{6,1379},{7,1285},{8,1493}]',638740,'[{18020003,90}]','[{1,12}]',240),(2005,22,0,2700,'[{1,6123},{2,106174},{3,2981},{4,2729},{5,1439},{6,1419},{7,1322},{8,1536}]',657184,'[{18020003,90}]','[{2,248}]',248),(2005,22,1,2700,'[{1,6296},{2,109193},{3,3065},{4,2807},{5,1480},{6,1460},{7,1360},{8,1580}]',675913,'[{18020003,90}]','[{1,12}]',240),(2005,22,2,2700,'[{1,6473},{2,112247},{3,3152},{4,2886},{5,1522},{6,1500},{7,1398},{8,1624}]',694857,'[{18020003,90}]','[{2,252}]',252),(2005,22,3,2700,'[{1,6651},{2,115336},{3,3238},{4,2966},{5,1563},{6,1541},{7,1436},{8,1668}]',713856,'[{18020003,90}]','[{1,13}]',260),(2005,23,0,2980,'[{1,6836},{2,118555},{3,3328},{4,3048},{5,1606},{6,1584},{7,1475},{8,1715}]',733675,'[{18020003,90}]','[{2,267}]',267),(2005,23,1,2980,'[{1,7025},{2,121809},{3,3420},{4,3132},{5,1650},{6,1628},{7,1516},{8,1762}]',753909,'[{18020003,90}]','[{1,13}]',260),(2005,23,2,2980,'[{1,7214},{2,125097},{3,3513},{4,3217},{5,1696},{6,1672},{7,1558},{8,1810}]',774427,'[{18020003,90}]','[{2,270}]',270),(2005,23,3,2980,'[{1,7405},{2,128421},{3,3606},{4,3302},{5,1741},{6,1717},{7,1599},{8,1859}]',795021,'[{18020003,90}]','[{1,14}]',280),(2005,24,0,3260,'[{1,7604},{2,131880},{3,3703},{4,3391},{5,1787},{6,1763},{7,1642},{8,1908}]',816310,'[{18020003,90}]','[{2,284}]',284),(2005,24,1,3260,'[{1,7807},{2,135376},{3,3801},{4,3481},{5,1835},{6,1809},{7,1685},{8,1959}]',837966,'[{18020003,90}]','[{1,14}]',280),(2005,24,2,3260,'[{1,8010},{2,138909},{3,3900},{4,3572},{5,1883},{6,1857},{7,1730},{8,2010}]',859909,'[{18020003,90}]','[{2,289}]',289),(2005,24,3,3260,'[{1,8216},{2,142480},{3,4001},{4,3663},{5,1931},{6,1905},{7,1774},{8,2062}]',882000,'[{18020003,90}]','[{1,15}]',300),(2005,25,0,3580,'[{1,8430},{2,146190},{3,4105},{4,3759},{5,1981},{6,1953},{7,1819},{8,2115}]',904790,'[{18020003,90}]','[{2,303}]',303),(2005,25,1,3580,'[{1,8645},{2,149942},{3,4210},{4,3856},{5,2032},{6,2004},{7,1867},{8,2169}]',928092,'[{18020003,90}]','[{1,15}]',300),(2005,25,2,3580,'[{1,8864},{2,153732},{3,4317},{4,3953},{5,2083},{6,2055},{7,1914},{8,2224}]',951562,'[{18020003,90}]','[{2,308}]',308),(2005,25,3,3580,'[{1,9085},{2,157562},{3,4424},{4,4052},{5,2135},{6,2105},{7,1961},{8,2279}]',975162,'[{18020003,90}]','[{1,16}]',320),(2005,26,0,3900,'[{1,9314},{2,161538},{3,4536},{4,4154},{5,2189},{6,2159},{7,2011},{8,2337}]',999868,'[{18020003,90}]','[{2,322}]',322),(2005,26,1,3900,'[{1,9546},{2,165553},{3,4649},{4,4257},{5,2244},{6,2212},{7,2061},{8,2395}]',1024723,'[{18020003,90}]','[{1,16}]',320),(2005,26,2,3900,'[{1,9779},{2,169609},{3,4763},{4,4361},{5,2298},{6,2266},{7,2111},{8,2453}]',1049689,'[{18020003,90}]','[{2,328}]',328),(2005,26,3,3900,'[{1,10016},{2,173704},{3,4878},{4,4466},{5,2354},{6,2322},{7,2163},{8,2513}]',1075224,'[{18020003,90}]','[{1,17}]',340),(2005,27,0,4260,'[{1,10260},{2,177949},{3,4997},{4,4575},{5,2412},{6,2378},{7,2215},{8,2575}]',1101449,'[{18020003,90}]','[{2,343}]',343),(2005,27,1,4260,'[{1,10508},{2,182240},{3,5117},{4,4685},{5,2469},{6,2435},{7,2268},{8,2636}]',1127850,'[{18020003,90}]','[{1,17}]',340),(2005,27,2,4260,'[{1,10758},{2,186575},{3,5239},{4,4797},{5,2528},{6,2492},{7,2322},{8,2698}]',1154635,'[{18020003,90}]','[{2,349}]',349),(2005,27,3,4260,'[{1,11010},{2,190955},{3,5361},{4,4909},{5,2587},{6,2551},{7,2376},{8,2762}]',1181705,'[{18020003,90}]','[{1,18}]',360),(2005,28,0,4620,'[{1,11272},{2,195489},{3,5488},{4,5026},{5,2648},{6,2612},{7,2433},{8,2827}]',1209779,'[{18020003,90}]','[{2,365}]',365),(2005,28,1,4620,'[{1,11536},{2,200069},{3,5617},{4,5143},{5,2711},{6,2673},{7,2490},{8,2894}]',1238189,'[{18020003,90}]','[{1,18}]',360),(2005,28,2,4620,'[{1,11802},{2,204694},{3,5746},{4,5262},{5,2774},{6,2736},{7,2548},{8,2962}]',1266934,'[{18020003,90}]','[{2,371}]',371),(2005,28,3,4620,'[{1,12072},{2,209364},{3,5878},{4,5382},{5,2838},{6,2798},{7,2607},{8,3029}]',1295904,'[{18020003,90}]','[{1,19}]',380),(2005,29,0,5020,'[{1,12350},{2,214193},{3,6013},{4,5507},{5,2902},{6,2862},{7,2666},{8,3098}]',1325593,'[{18020003,90}]','[{2,389}]',389),(2005,29,1,5020,'[{1,12631},{2,219067},{3,6150},{4,5632},{5,2969},{6,2927},{7,2727},{8,3169}]',1355837,'[{18020003,90}]','[{1,20}]',400),(2005,29,2,5020,'[{1,12914},{2,223987},{3,6289},{4,5759},{5,3035},{6,2993},{7,2788},{8,3240}]',1386267,'[{18020003,90}]','[{1,20}]',400),(2005,29,3,5020,'[{1,13200},{2,228951},{3,6429},{4,5887},{5,3102},{6,3058},{7,2849},{8,3311}]',1416851,'[{18020003,90}]','[{1,21}]',420),(2005,30,0,5420,'[{1,13496},{2,234081},{3,6573},{4,6019},{5,3171},{6,3127},{7,2913},{8,3385}]',1448601,'[{18020003,90}]','[{1,21}]',420),(2005,30,1,5420,'[{1,13794},{2,239255},{3,6718},{4,6152},{5,3242},{6,3196},{7,2978},{8,3460}]',1480685,'[{18020003,90}]','[{1,21}]',420),(2005,30,2,5420,'[{1,14094},{2,244474},{3,6864},{4,6286},{5,3312},{6,3266},{7,3042},{8,3536}]',1512904,'[{18020003,90}]','[{1,21}]',420),(2005,30,3,5420,'[{1,14399},{2,249738},{3,7013},{4,6421},{5,3384},{6,3336},{7,3108},{8,3612}]',1545568,'[{18020003,90}]','[]',0),(3001,1,0,40,'[{1,725},{2,14515},{3,364},{4,364},{5,182},{6,182},{7,182},{8,182}]',83615,'[{18020001,10}]','[{2,20}]',20),(3001,1,1,40,'[{1,742},{2,14851},{3,372},{4,372},{5,186},{6,186},{7,186},{8,186}]',85491,'[{18020001,10}]','[{1,1}]',20),(3001,1,2,40,'[{1,759},{2,15194},{3,381},{4,381},{5,190},{6,190},{7,190},{8,190}]',87424,'[{18020001,10}]','[{2,24}]',22),(3001,1,3,40,'[{1,776},{2,15543},{3,390},{4,390},{5,194},{6,194},{7,194},{8,194}]',89363,'[{18020001,10}]','[{1,1}]',20),(3001,2,0,60,'[{1,797},{2,15960},{3,400},{4,400},{5,199},{6,199},{7,199},{8,199}]',91700,'[{18020001,10}]','[{2,26}]',24),(3001,2,1,60,'[{1,819},{2,16390},{3,411},{4,411},{5,204},{6,204},{7,204},{8,204}]',94120,'[{18020001,10}]','[{1,1}]',20),(3001,2,2,60,'[{1,841},{2,16834},{3,422},{4,422},{5,210},{6,210},{7,210},{8,210}]',96754,'[{18020001,10}]','[{2,28}]',27),(3001,2,3,60,'[{1,864},{2,17291},{3,433},{4,433},{5,216},{6,216},{7,216},{8,216}]',99421,'[{18020001,10}]','[{1,2}]',40),(3001,3,0,80,'[{1,891},{2,17829},{3,446},{4,446},{5,223},{6,223},{7,223},{8,223}]',102549,'[{18020001,10}]','[{2,31}]',31),(3001,3,1,80,'[{1,919},{2,18387},{3,460},{4,460},{5,230},{6,230},{7,230},{8,230}]',105767,'[{18020001,10}]','[{1,2}]',40),(3001,3,2,80,'[{1,948},{2,18965},{3,474},{4,474},{5,237},{6,237},{7,237},{8,237}]',109025,'[{18020001,10}]','[{2,35}]',32),(3001,3,3,80,'[{1,978},{2,19563},{3,489},{4,489},{5,244},{6,244},{7,244},{8,244}]',112373,'[{18020001,10}]','[{1,2}]',40),(3001,4,0,110,'[{1,1013},{2,20255},{3,506},{4,506},{5,253},{6,253},{7,253},{8,253}]',116415,'[{18020001,10}]','[{2,37}]',37),(3001,4,1,110,'[{1,1049},{2,20974},{3,524},{4,524},{5,262},{6,262},{7,262},{8,262}]',120554,'[{18020001,10}]','[{1,2}]',40),(3001,4,2,110,'[{1,1086},{2,21720},{3,543},{4,543},{5,271},{6,271},{7,271},{8,271}]',124790,'[{18020001,10}]','[{2,39}]',39),(3001,4,3,110,'[{1,1125},{2,22493},{3,562},{4,562},{5,281},{6,281},{7,281},{8,281}]',129293,'[{18020001,10}]','[{1,2}]',40),(3001,5,0,170,'[{1,1169},{2,23373},{3,584},{4,584},{5,292},{6,292},{7,292},{8,292}]',134353,'[{18020001,10}]','[{2,45}]',43),(3001,5,1,170,'[{1,1215},{2,24287},{3,607},{4,607},{5,303},{6,303},{7,303},{8,303}]',139537,'[{18020001,10}]','[{1,2}]',40),(3001,5,2,170,'[{1,1262},{2,25235},{3,631},{4,631},{5,315},{6,315},{7,315},{8,315}]',145025,'[{18020001,10}]','[{2,46}]',45),(3001,5,3,170,'[{1,1311},{2,26216},{3,656},{4,656},{5,327},{6,327},{7,327},{8,327}]',150636,'[{18020001,10}]','[{1,3}]',40),(3001,6,0,240,'[{1,1366},{2,27318},{3,684},{4,684},{5,341},{6,341},{7,341},{8,341}]',157038,'[{18020001,10}]','[{2,51}]',50),(3001,6,1,240,'[{1,1423},{2,28460},{3,713},{4,713},{5,355},{6,355},{7,355},{8,355}]',163570,'[{18020001,10}]','[{1,3}]',60),(3001,6,2,240,'[{1,1482},{2,29643},{3,743},{4,743},{5,370},{6,370},{7,370},{8,370}]',170433,'[{18020001,10}]','[{2,55}]',53),(3001,6,3,240,'[{1,1543},{2,30866},{3,774},{4,774},{5,385},{6,385},{7,385},{8,385}]',177426,'[{18020001,10}]','[{1,3}]',60),(3001,7,0,320,'[{1,1611},{2,32223},{3,808},{4,808},{5,402},{6,402},{7,402},{8,402}]',185243,'[{18020001,10}]','[{2,59}]',59),(3001,7,1,320,'[{1,1681},{2,33627},{3,843},{4,843},{5,420},{6,420},{7,420},{8,420}]',193397,'[{18020001,10}]','[{1,3}]',60),(3001,7,2,320,'[{1,1754},{2,35079},{3,879},{4,879},{5,438},{6,438},{7,438},{8,438}]',201709,'[{18020001,10}]','[{2,61}]',60),(3001,7,3,320,'[{1,1829},{2,36578},{3,916},{4,916},{5,457},{6,457},{7,457},{8,457}]',210358,'[{18020001,10}]','[{1,3}]',60),(3001,8,0,450,'[{1,1911},{2,38224},{3,957},{4,957},{5,478},{6,478},{7,478},{8,478}]',219894,'[{18020001,10}]','[{2,69}]',66),(3001,8,1,450,'[{1,1996},{2,39917},{3,999},{4,999},{5,499},{6,499},{7,499},{8,499}]',229587,'[{18020001,10}]','[{1,3}]',60),(3001,8,2,450,'[{1,2083},{2,41657},{3,1043},{4,1043},{5,521},{6,521},{7,521},{8,521}]',239667,'[{18020001,10}]','[{2,71}]',69),(3001,8,3,450,'[{1,2172},{2,43445},{3,1088},{4,1088},{5,543},{6,543},{7,543},{8,543}]',249885,'[{18020001,10}]','[{1,4}]',80),(3001,9,0,580,'[{1,2269},{2,45394},{3,1137},{4,1137},{5,567},{6,567},{7,567},{8,567}]',261024,'[{18020001,10}]','[{2,78}]',75),(3001,9,1,580,'[{1,2369},{2,47397},{3,1187},{4,1187},{5,592},{6,592},{7,592},{8,592}]',272527,'[{18020001,10}]','[{1,4}]',80),(3001,9,2,580,'[{1,2472},{2,49453},{3,1238},{4,1238},{5,618},{6,618},{7,618},{8,618}]',284393,'[{18020001,10}]','[{2,81}]',78),(3001,9,3,580,'[{1,2578},{2,51563},{3,1291},{4,1291},{5,644},{6,644},{7,644},{8,644}]',296473,'[{18020001,10}]','[{1,4}]',80),(3001,10,0,750,'[{1,2692},{2,53848},{3,1348},{4,1348},{5,673},{6,673},{7,673},{8,673}]',309688,'[{18020001,10}]','[{2,88}]',84),(3001,10,1,750,'[{1,2809},{2,56187},{3,1406},{4,1406},{5,702},{6,702},{7,702},{8,702}]',323067,'[{18020001,10}]','[{1,4}]',80),(3001,10,2,750,'[{1,2929},{2,58579},{3,1466},{4,1466},{5,732},{6,732},{7,732},{8,732}]',336859,'[{18020001,10}]','[{2,91}]',88),(3001,10,3,750,'[{1,3051},{2,61025},{3,1527},{4,1527},{5,763},{6,763},{7,763},{8,763}]',350995,'[{18020001,10}]','[{1,5}]',100),(3001,11,0,900,'[{1,3183},{2,63659},{3,1593},{4,1593},{5,796},{6,796},{7,796},{8,796}]',366169,'[{18020002,30}]','[{2,99}]',96),(3001,11,1,900,'[{1,3318},{2,66354},{3,1660},{4,1660},{5,830},{6,830},{7,830},{8,830}]',381714,'[{18020002,30}]','[{1,5}]',100),(3001,11,2,900,'[{1,3456},{2,69109},{3,1729},{4,1729},{5,864},{6,864},{7,864},{8,864}]',397479,'[{18020002,30}]','[{2,100}]',98),(3001,11,3,900,'[{1,3597},{2,71925},{3,1799},{4,1799},{5,899},{6,899},{7,899},{8,899}]',413615,'[{18020002,30}]','[{1,5}]',100),(3001,12,0,1120,'[{1,3748},{2,74942},{3,1874},{4,1874},{5,937},{6,937},{7,937},{8,937}]',431002,'[{18020002,30}]','[{2,108}]',105),(3001,12,1,1120,'[{1,3902},{2,78020},{3,1951},{4,1951},{5,975},{6,975},{7,975},{8,975}]',448610,'[{18020002,30}]','[{1,5}]',100),(3001,12,2,1120,'[{1,4059},{2,81158},{3,2029},{4,2029},{5,1014},{6,1014},{7,1014},{8,1014}]',466588,'[{18020002,30}]','[{2,112}]',109),(3001,12,3,1120,'[{1,4219},{2,84357},{3,2109},{4,2109},{5,1054},{6,1054},{7,1054},{8,1054}]',484987,'[{18020002,30}]','[{1,6}]',120),(3001,13,0,1300,'[{1,4390},{2,87771},{3,2194},{4,2194},{5,1097},{6,1097},{7,1097},{8,1097}]',504671,'[{18020002,30}]','[{2,120}]',116),(3001,13,1,1300,'[{1,4564},{2,91252},{3,2281},{4,2281},{5,1141},{6,1141},{7,1141},{8,1141}]',524782,'[{18020002,30}]','[{1,6}]',120),(3001,13,2,1300,'[{1,4741},{2,94800},{3,2370},{4,2370},{5,1185},{6,1185},{7,1185},{8,1185}]',545120,'[{18020002,30}]','[{2,124}]',119),(3001,13,3,1300,'[{1,4922},{2,98415},{3,2460},{4,2460},{5,1230},{6,1230},{7,1230},{8,1230}]',565855,'[{18020002,30}]','[{1,6}]',120),(3001,14,0,1500,'[{1,5114},{2,102259},{3,2556},{4,2556},{5,1278},{6,1278},{7,1278},{8,1278}]',587939,'[{18020002,30}]','[{2,131}]',129),(3001,14,1,1500,'[{1,5310},{2,106170},{3,2654},{4,2654},{5,1327},{6,1327},{7,1327},{8,1327}]',610470,'[{18020002,30}]','[{1,7}]',120),(3001,14,2,1500,'[{1,5509},{2,110148},{3,2753},{4,2753},{5,1377},{6,1377},{7,1377},{8,1377}]',633378,'[{18020002,30}]','[{2,135}]',132),(3001,14,3,1500,'[{1,5711},{2,114193},{3,2854},{4,2854},{5,1428},{6,1428},{7,1428},{8,1428}]',656713,'[{18020002,30}]','[{1,7}]',140),(3001,15,0,1700,'[{1,5925},{2,118480},{3,2961},{4,2961},{5,1482},{6,1482},{7,1482},{8,1482}]',681430,'[{18020002,30}]','[{2,144}]',140),(3001,15,1,1700,'[{1,6143},{2,122841},{3,3070},{4,3070},{5,1537},{6,1537},{7,1537},{8,1537}]',706601,'[{18020002,30}]','[{1,7}]',140),(3001,15,2,1700,'[{1,6365},{2,127276},{3,3181},{4,3181},{5,1592},{6,1592},{7,1592},{8,1592}]',732026,'[{18020002,30}]','[{2,149}]',143),(3001,15,3,1700,'[{1,6590},{2,131785},{3,3294},{4,3294},{5,1648},{6,1648},{7,1648},{8,1648}]',757885,'[{18020002,30}]','[{1,8}]',160),(3001,16,0,1900,'[{1,6828},{2,136549},{3,3413},{4,3413},{5,1708},{6,1708},{7,1708},{8,1708}]',785359,'[{18020002,30}]','[{2,157}]',152),(3001,16,1,1900,'[{1,7070},{2,141387},{3,3534},{4,3534},{5,1768},{6,1768},{7,1768},{8,1768}]',813087,'[{18020002,30}]','[{1,8}]',160),(3001,16,2,1900,'[{1,7316},{2,146299},{3,3657},{4,3657},{5,1829},{6,1829},{7,1829},{8,1829}]',841269,'[{18020002,30}]','[{2,161}]',156),(3001,16,3,1900,'[{1,7565},{2,151285},{3,3782},{4,3782},{5,1891},{6,1891},{7,1891},{8,1891}]',869885,'[{18020002,30}]','[{1,8}]',160),(3001,17,0,2150,'[{1,7828},{2,156540},{3,3913},{4,3913},{5,1957},{6,1957},{7,1957},{8,1957}]',900150,'[{18020002,30}]','[{2,171}]',166),(3001,17,1,2150,'[{1,8094},{2,161869},{3,4046},{4,4046},{5,2024},{6,2024},{7,2024},{8,2024}]',930849,'[{18020002,30}]','[{1,9}]',160),(3001,17,2,2150,'[{1,8364},{2,167272},{3,4181},{4,4181},{5,2092},{6,2092},{7,2092},{8,2092}]',962002,'[{18020002,30}]','[{2,174}]',170),(3001,17,3,2150,'[{1,8638},{2,172749},{3,4318},{4,4318},{5,2160},{6,2160},{7,2160},{8,2160}]',993409,'[{18020002,30}]','[{1,9}]',180),(3001,18,0,2400,'[{1,8926},{2,178508},{3,4462},{4,4462},{5,2232},{6,2232},{7,2232},{8,2232}]',1026528,'[{18020002,30}]','[{2,185}]',181),(3001,18,1,2400,'[{1,9218},{2,184348},{3,4608},{4,4608},{5,2305},{6,2305},{7,2305},{8,2305}]',1060108,'[{18020002,30}]','[{1,9}]',180),(3001,18,2,2400,'[{1,9514},{2,190268},{3,4756},{4,4756},{5,2379},{6,2379},{7,2379},{8,2379}]',1094148,'[{18020002,30}]','[{2,189}]',183),(3001,18,3,2400,'[{1,9814},{2,196269},{3,4906},{4,4906},{5,2454},{6,2454},{7,2454},{8,2454}]',1128649,'[{18020002,30}]','[{1,10}]',200),(3001,19,0,2700,'[{1,10129},{2,202566},{3,5063},{4,5063},{5,2533},{6,2533},{7,2533},{8,2533}]',1164896,'[{18020002,30}]','[{2,200}]',195),(3001,19,1,2700,'[{1,10448},{2,208943},{3,5222},{4,5222},{5,2613},{6,2613},{7,2613},{8,2613}]',1201603,'[{18020002,30}]','[{1,10}]',200),(3001,19,2,2700,'[{1,10771},{2,215401},{3,5383},{4,5383},{5,2694},{6,2694},{7,2694},{8,2694}]',1238771,'[{18020002,30}]','[{2,203}]',197),(3001,19,3,2700,'[{1,11098},{2,221940},{3,5546},{4,5546},{5,2776},{6,2776},{7,2776},{8,2776}]',1276400,'[{18020002,30}]','[{1,11}]',200),(3001,20,0,3000,'[{1,11440},{2,228788},{3,5717},{4,5717},{5,2862},{6,2862},{7,2862},{8,2862}]',1315838,'[{18020002,30}]','[{2,214}]',210),(3001,20,1,3000,'[{1,11787},{2,235723},{3,5890},{4,5890},{5,2949},{6,2949},{7,2949},{8,2949}]',1355763,'[{18020002,30}]','[{1,11}]',220),(3001,20,2,3000,'[{1,12138},{2,242745},{3,6066},{4,6066},{5,3037},{6,3037},{7,3037},{8,3037}]',1396205,'[{18020002,30}]','[{2,220}]',214),(3001,20,3,3000,'[{1,12493},{2,249855},{3,6244},{4,6244},{5,3126},{6,3126},{7,3126},{8,3126}]',1437115,'[{18020002,30}]','[{1,11}]',220),(3001,21,0,3350,'[{1,12865},{2,257287},{3,6430},{4,6430},{5,3219},{6,3219},{7,3219},{8,3219}]',1479887,'[{18020003,90}]','[{2,230}]',225),(3001,21,1,3350,'[{1,13241},{2,264807},{3,6618},{4,6618},{5,3313},{6,3313},{7,3313},{8,3313}]',1523127,'[{18020003,90}]','[{1,12}]',220),(3001,21,2,3350,'[{1,13621},{2,272414},{3,6808},{4,6808},{5,3408},{6,3408},{7,3408},{8,3408}]',1566834,'[{18020003,90}]','[{2,236}]',230),(3001,21,3,3350,'[{1,14006},{2,280108},{3,7000},{4,7000},{5,3504},{6,3504},{7,3504},{8,3504}]',1611028,'[{18020003,90}]','[{1,12}]',240),(3001,22,0,3800,'[{1,14408},{2,288138},{3,7201},{4,7201},{5,3604},{6,3604},{7,3604},{8,3604}]',1657148,'[{18020003,90}]','[{2,248}]',241),(3001,22,1,3800,'[{1,14814},{2,296262},{3,7404},{4,7404},{5,3706},{6,3706},{7,3706},{8,3706}]',1703942,'[{18020003,90}]','[{1,12}]',240),(3001,22,2,3800,'[{1,15225},{2,304481},{3,7609},{4,7609},{5,3809},{6,3809},{7,3809},{8,3809}]',1751231,'[{18020003,90}]','[{2,252}]',246),(3001,22,3,3800,'[{1,15641},{2,312794},{3,7817},{4,7817},{5,3913},{6,3913},{7,3913},{8,3913}]',1799064,'[{18020003,90}]','[{1,13}]',260),(3001,23,0,4250,'[{1,16074},{2,321456},{3,8034},{4,8034},{5,4021},{6,4021},{7,4021},{8,4021}]',1848836,'[{18020003,90}]','[{2,266}]',258),(3001,23,1,4250,'[{1,16512},{2,330212},{3,8253},{4,8253},{5,4130},{6,4130},{7,4130},{8,4130}]',1899102,'[{18020003,90}]','[{1,13}]',260),(3001,23,2,4250,'[{1,16955},{2,339062},{3,8474},{4,8474},{5,4241},{6,4241},{7,4241},{8,4241}]',1950062,'[{18020003,90}]','[{2,270}]',262),(3001,23,3,4250,'[{1,17402},{2,348006},{3,8698},{4,8698},{5,4353},{6,4353},{7,4353},{8,4353}]',2001546,'[{18020003,90}]','[{1,14}]',280),(3001,24,0,4700,'[{1,17867},{2,357313},{3,8931},{4,8931},{5,4469},{6,4469},{7,4469},{8,4469}]',2055003,'[{18020003,90}]','[{2,284}]',276),(3001,24,1,4700,'[{1,18337},{2,366721},{3,9166},{4,9166},{5,4587},{6,4587},{7,4587},{8,4587}]',2109161,'[{18020003,90}]','[{1,14}]',280),(3001,24,2,4700,'[{1,18812},{2,376230},{3,9404},{4,9404},{5,4706},{6,4706},{7,4706},{8,4706}]',2163870,'[{18020003,90}]','[{2,288}]',281),(3001,24,3,4700,'[{1,19292},{2,385840},{3,9644},{4,9644},{5,4826},{6,4826},{7,4826},{8,4826}]',2219080,'[{18020003,90}]','[{1,15}]',300),(3001,25,0,5150,'[{1,19791},{2,395826},{3,9894},{4,9894},{5,4951},{6,4951},{7,4951},{8,4951}]',2276546,'[{18020003,90}]','[{2,304}]',296),(3001,25,1,5150,'[{1,20296},{2,405919},{3,10146},{4,10146},{5,5077},{6,5077},{7,5077},{8,5077}]',2334539,'[{18020003,90}]','[{1,15}]',300),(3001,25,2,5150,'[{1,20806},{2,416120},{3,10401},{4,10401},{5,5205},{6,5205},{7,5205},{8,5205}]',2393290,'[{18020003,90}]','[{2,308}]',300),(3001,25,3,5150,'[{1,21321},{2,426428},{3,10659},{4,10659},{5,5334},{6,5334},{7,5334},{8,5334}]',2452598,'[{18020003,90}]','[{1,16}]',320),(3001,26,0,5650,'[{1,21856},{2,437126},{3,10926},{4,10926},{5,5468},{6,5468},{7,5468},{8,5468}]',2514146,'[{18020003,90}]','[{2,322}]',314),(3001,26,1,5650,'[{1,22396},{2,447932},{3,11196},{4,11196},{5,5603},{6,5603},{7,5603},{8,5603}]',2576252,'[{18020003,90}]','[{1,16}]',320),(3001,26,2,5650,'[{1,22942},{2,458845},{3,11469},{4,11469},{5,5739},{6,5739},{7,5739},{8,5739}]',2638935,'[{18020003,90}]','[{2,328}]',320),(3001,26,3,5650,'[{1,23493},{2,469866},{3,11745},{4,11745},{5,5877},{6,5877},{7,5877},{8,5877}]',2702376,'[{18020003,90}]','[{1,17}]',340),(3001,27,0,6150,'[{1,24064},{2,481290},{3,12031},{4,12031},{5,6020},{6,6020},{7,6020},{8,6020}]',2768120,'[{18020003,90}]','[{2,344}]',335),(3001,27,1,6150,'[{1,24641},{2,492835},{3,12320},{4,12320},{5,6164},{6,6164},{7,6164},{8,6164}]',2834455,'[{18020003,90}]','[{1,17}]',340),(3001,27,2,6150,'[{1,25224},{2,504501},{3,12612},{4,12612},{5,6310},{6,6310},{7,6310},{8,6310}]',2901581,'[{18020003,90}]','[{2,349}]',340),(3001,27,3,6150,'[{1,25813},{2,516288},{3,12907},{4,12907},{5,6457},{6,6457},{7,6457},{8,6457}]',2969298,'[{18020003,90}]','[{1,18}]',360),(3001,28,0,6700,'[{1,26423},{2,528492},{3,13212},{4,13212},{5,6610},{6,6610},{7,6610},{8,6610}]',3039552,'[{18020003,90}]','[{2,365}]',356),(3001,28,1,6700,'[{1,27039},{2,540816},{3,13520},{4,13520},{5,6764},{6,6764},{7,6764},{8,6764}]',3110396,'[{18020003,90}]','[{1,19}]',360),(3001,28,2,6700,'[{1,27661},{2,553261},{3,13831},{4,13831},{5,6920},{6,6920},{7,6920},{8,6920}]',3182031,'[{18020003,90}]','[{2,371}]',362),(3001,28,3,6700,'[{1,28289},{2,565827},{3,14145},{4,14145},{5,7077},{6,7077},{7,7077},{8,7077}]',3254257,'[{18020003,90}]','[{1,19}]',380),(3001,29,0,7300,'[{1,28939},{2,578823},{3,14470},{4,14470},{5,7239},{6,7239},{7,7239},{8,7239}]',3328903,'[{18020003,90}]','[{2,390}]',379),(3001,29,1,7300,'[{1,29595},{2,591940},{3,14798},{4,14798},{5,7403},{6,7403},{7,7403},{8,7403}]',3404340,'[{18020003,90}]','[{1,20}]',380),(3001,29,2,7300,'[{1,30257},{2,605178},{3,15129},{4,15129},{5,7568},{6,7568},{7,7568},{8,7568}]',3480368,'[{18020003,90}]','[{2,396}]',386),(3001,29,3,7300,'[{1,30925},{2,618537},{3,15463},{4,15463},{5,7735},{6,7735},{7,7735},{8,7735}]',3557187,'[{18020003,90}]','[{1,21}]',400),(3001,30,0,8000,'[{1,31615},{2,632340},{3,15808},{4,15808},{5,7908},{6,7908},{7,7908},{8,7908}]',3636640,'[{18020003,90}]','[{2,415}]',404),(3001,30,1,8000,'[{1,32311},{2,646264},{3,16156},{4,16156},{5,8082},{6,8082},{7,8082},{8,8082}]',3716684,'[{18020003,90}]','[{1,21}]',400),(3001,30,2,8000,'[{1,33013},{2,660309},{3,16507},{4,16507},{5,8258},{6,8258},{7,8258},{8,8258}]',3797519,'[{18020003,90}]','[{2,423}]',412),(3001,30,3,0,'[{1,33721},{2,674475},{3,16861},{4,16861},{5,8435},{6,8435},{7,8435},{8,8435}]',3878945,'[{18020003,90}]','[]',0);
/*!40000 ALTER TABLE `base_star_soul_stage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_star_soul_star`
--

DROP TABLE IF EXISTS `base_star_soul_star`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_star_soul_star` (
  `id` int(11) unsigned NOT NULL COMMENT '星灵id',
  `star` tinyint(2) unsigned NOT NULL COMMENT '星数',
  `attr` varchar(255) NOT NULL COMMENT '提供属性',
  `combat` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '提供的战力',
  `goods` varchar(255) NOT NULL COMMENT '升星材料',
  `quality` tinyint(2) unsigned NOT NULL COMMENT '品质',
  PRIMARY KEY (`id`,`star`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星灵升星配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_star_soul_star`
--

LOCK TABLES `base_star_soul_star` WRITE;
/*!40000 ALTER TABLE `base_star_soul_star` DISABLE KEYS */;
INSERT INTO `base_star_soul_star` VALUES (1001,0,'[{1,28},{2,510},{3,12},{4,14},{5,7},{6,6},{7,6},{8,6}]',2970,'[{0,18040001,2}]',2),(1001,1,'[{1,381},{2,6894},{3,166},{4,196},{5,99},{6,81},{7,87},{8,93}]',41564,'[{0,18040001,4}]',2),(1001,2,'[{1,910},{2,16470},{3,397},{4,469},{5,238},{6,195},{7,209},{8,223}]',99570,'[{0,18040001,6}]',2),(1001,3,'[{1,1615},{2,29238},{3,705},{4,833},{5,423},{6,346},{7,371},{8,397}]',176838,'[{0,18040001,8}]',2),(1001,4,'[{1,2497},{2,45198},{3,1090},{4,1288},{5,654},{6,535},{7,574},{8,614}]',273438,'[{0,18040001,10}]',2),(1001,5,'[{1,3556},{2,64350},{3,1552},{4,1834},{5,931},{6,762},{7,818},{8,874}]',389370,'[]',2),(1002,0,'[{1,47},{2,840},{3,23},{4,21},{5,11},{6,11},{7,10},{8,12}]',5080,'[{0,18040002,2}]',3),(1002,1,'[{1,642},{2,11346},{3,314},{4,290},{5,152},{6,149},{7,139},{8,162}]',69386,'[{0,18040002,4}]',3),(1002,2,'[{1,1534},{2,27104},{3,751},{4,693},{5,364},{6,357},{7,333},{8,389}]',166034,'[{0,18040002,6}]',3),(1002,3,'[{1,2723},{2,48115},{3,1333},{4,1231},{5,646},{6,635},{7,591},{8,691}]',294825,'[{0,18040002,8}]',3),(1002,4,'[{1,4210},{2,74379},{3,2061},{4,1903},{5,1000},{6,982},{7,913},{8,1068}]',455829,'[{0,18040002,10}]',3),(1002,5,'[{1,5994},{2,105896},{3,2935},{4,2709},{5,1423},{6,1398},{7,1301},{8,1521}]',649026,'[]',3),(1003,0,'[{1,47},{2,841},{3,22},{4,22},{5,11},{6,11},{7,11},{8,11}]',5081,'[{0,18040003,2}]',3),(1003,1,'[{1,641},{2,11358},{3,306},{4,298},{5,151},{6,150},{7,148},{8,153}]',69378,'[{0,18040003,4}]',3),(1003,2,'[{1,1532},{2,27133},{3,731},{4,713},{5,362},{6,359},{7,355},{8,367}]',166023,'[{0,18040003,6}]',3),(1003,3,'[{1,2721},{2,48166},{3,1297},{4,1267},{5,643},{6,638},{7,630},{8,652}]',294836,'[{0,18040003,8}]',3),(1003,4,'[{1,4206},{2,74458},{3,2006},{4,1958},{5,995},{6,987},{7,974},{8,1008}]',455878,'[{0,18040003,10}]',3),(1003,5,'[{1,5989},{2,106009},{3,2856},{4,2788},{5,1416},{6,1405},{7,1387},{8,1435}]',649039,'[]',3),(1004,0,'[{1,44},{2,901},{3,24},{4,20},{5,11},{6,10},{7,12},{8,10}]',5031,'[{0,18040004,2}]',3),(1004,1,'[{1,601},{2,12168},{3,327},{4,277},{5,159},{6,142},{7,163},{8,139}]',69438,'[{0,18040004,4}]',3),(1004,2,'[{1,1436},{2,29069},{3,781},{4,663},{5,382},{6,340},{7,390},{8,332}]',166089,'[{0,18040004,6}]',3),(1004,3,'[{1,2549},{2,51603},{3,1387},{4,1177},{5,678},{6,604},{7,692},{8,589}]',294833,'[{0,18040004,8}]',3),(1004,4,'[{1,3941},{2,79771},{3,2144},{4,1819},{5,1048},{6,933},{7,1070},{8,911}]',455766,'[{0,18040004,10}]',3),(1004,5,'[{1,5610},{2,113573},{3,3053},{4,2590},{5,1493},{6,1329},{7,1524},{8,1298}]',649048,'[]',3),(1005,0,'[{1,48},{2,816},{3,23},{4,21},{5,10},{6,11},{7,11},{8,11}]',5026,'[{0,18040005,2}]',3),(1005,1,'[{1,658},{2,11019},{3,318},{4,286},{5,145},{6,156},{7,149},{8,153}]',69429,'[{0,18040005,4}]',3),(1005,2,'[{1,1573},{2,26324},{3,760},{4,684},{5,347},{6,374},{7,356},{8,365}]',165984,'[{0,18040005,6}]',3),(1005,3,'[{1,2793},{2,46730},{3,1350},{4,1214},{5,616},{6,665},{7,633},{8,648}]',294790,'[{0,18040005,8}]',3),(1005,4,'[{1,4317},{2,72238},{3,2087},{4,1877},{5,953},{6,1028},{7,979},{8,1003}]',455828,'[{0,18040005,10}]',3),(1005,5,'[{1,6147},{2,102848},{3,2971},{4,2672},{5,1357},{6,1464},{7,1394},{8,1428}]',649013,'[]',3),(1006,0,'[{1,46},{2,865},{3,22},{4,22},{5,12},{6,10},{7,11},{8,11}]',5085,'[{0,18040006,2}]',3),(1006,1,'[{1,625},{2,11684},{3,305},{4,299},{5,163},{6,138},{7,151},{8,150}]',69384,'[{0,18040006,4}]',3),(1006,2,'[{1,1493},{2,27913},{3,729},{4,715},{5,391},{6,331},{7,363},{8,359}]',166073,'[{0,18040006,6}]',3),(1006,3,'[{1,2652},{2,49551},{3,1295},{4,1269},{5,694},{6,587},{7,644},{8,637}]',294791,'[{0,18040006,8}]',3),(1006,4,'[{1,4099},{2,76599},{3,2002},{4,1962},{5,1073},{6,908},{7,996},{8,986}]',455829,'[{0,18040006,10}]',3),(1006,5,'[{1,5836},{2,109057},{3,2850},{4,2794},{5,1528},{6,1294},{7,1418},{8,1404}]',649077,'[]',3),(1007,0,'[{1,41},{2,964},{3,23},{4,21},{5,11},{6,11},{7,10},{8,11}]',5034,'[{0,18040007,2}]',3),(1007,1,'[{1,558},{2,13015},{3,321},{4,283},{5,151},{6,150},{7,146},{8,156}]',69425,'[{0,18040007,4}]',3),(1007,2,'[{1,1334},{2,31092},{3,767},{4,677},{5,363},{6,359},{7,349},{8,372}]',166022,'[{0,18040007,6}]',3),(1007,3,'[{1,2369},{2,55194},{3,1361},{4,1202},{5,644},{6,637},{7,620},{8,661}]',294749,'[{0,18040007,8}]',3),(1007,4,'[{1,3663},{2,85322},{3,2105},{4,1859},{5,996},{6,986},{7,959},{8,1022}]',455832,'[{0,18040007,10}]',3),(1007,5,'[{1,5215},{2,121476},{3,2997},{4,2647},{5,1418},{6,1404},{7,1366},{8,1456}]',649076,'[]',3),(1008,0,'[{1,44},{2,896},{3,22},{4,22},{5,11},{6,11},{7,11},{8,11}]',5076,'[{0,18040008,2}]',3),(1008,1,'[{1,604},{2,12096},{3,302},{4,302},{5,151},{6,151},{7,151},{8,151}]',69476,'[{0,18040008,4}]',3),(1008,2,'[{1,1444},{2,28896},{3,722},{4,722},{5,361},{6,361},{7,361},{8,361}]',166076,'[{0,18040008,6}]',3),(1008,3,'[{1,2564},{2,51296},{3,1282},{4,1282},{5,641},{6,641},{7,641},{8,641}]',294876,'[{0,18040008,8}]',3),(1008,4,'[{1,3964},{2,79296},{3,1982},{4,1982},{5,991},{6,991},{7,991},{8,991}]',455876,'[{0,18040008,10}]',3),(1008,5,'[{1,5644},{2,112896},{3,2822},{4,2822},{5,1411},{6,1411},{7,1411},{8,1411}]',649076,'[]',3),(1009,0,'[{1,46},{2,857},{3,21},{4,23},{5,11},{6,11},{7,11},{8,10}]',5027,'[{0,18040009,2}]',3),(1009,1,'[{1,630},{2,11575},{3,283},{4,320},{5,153},{6,149},{7,154},{8,148}]',69450,'[{0,18040009,4}]',3),(1009,2,'[{1,1506},{2,27653},{3,678},{4,766},{5,366},{6,356},{7,368},{8,353}]',166023,'[{0,18040009,6}]',3),(1009,3,'[{1,2675},{2,49090},{3,1204},{4,1360},{5,650},{6,632},{7,654},{8,628}]',294890,'[{0,18040009,8}]',3),(1009,4,'[{1,4135},{2,75886},{3,1861},{4,2103},{5,1005},{6,977},{7,1011},{8,971}]',455886,'[{0,18040009,10}]',3),(1009,5,'[{1,5887},{2,108041},{3,2650},{4,2994},{5,1430},{6,1391},{7,1439},{8,1382}]',648981,'[]',3),(1010,0,'[{1,44},{2,902},{3,22},{4,22},{5,10},{6,11},{7,10},{8,12}]',5032,'[{0,18040010,2}]',3),(1010,1,'[{1,600},{2,12180},{3,301},{4,303},{5,142},{6,159},{7,136},{8,165}]',69380,'[{0,18040010,4}]',3),(1010,2,'[{1,1434},{2,29098},{3,720},{4,724},{5,340},{6,382},{7,326},{8,395}]',166028,'[{0,18040010,6}]',3),(1010,3,'[{1,2546},{2,51655},{3,1278},{4,1286},{5,604},{6,678},{7,579},{8,702}]',294825,'[{0,18040010,8}]',3),(1010,4,'[{1,3937},{2,79851},{3,1976},{4,1988},{5,933},{6,1048},{7,896},{8,1086}]',455841,'[{0,18040010,10}]',3),(1010,5,'[{1,5605},{2,113686},{3,2813},{4,2830},{5,1329},{6,1493},{7,1275},{8,1546}]',649011,'[]',3),(1011,0,'[{1,45},{2,882},{3,23},{4,21},{5,11},{6,11},{7,11},{8,11}]',5082,'[{0,18040011,2}]',3),(1011,1,'[{1,613},{2,11914},{3,317},{4,286},{5,153},{6,148},{7,150},{8,151}]',69349,'[{0,18040011,4}]',3),(1011,2,'[{1,1466},{2,28462},{3,759},{4,685},{5,366},{6,355},{7,359},{8,363}]',166032,'[{0,18040011,6}]',3),(1011,3,'[{1,2603},{2,50526},{3,1347},{4,1216},{5,650},{6,631},{7,637},{8,644}]',294761,'[{0,18040011,8}]',3),(1011,4,'[{1,4024},{2,78106},{3,2083},{4,1881},{5,1006},{6,976},{7,986},{8,996}]',455886,'[{0,18040011,10}]',3),(1011,5,'[{1,5729},{2,111202},{3,2966},{4,2678},{5,1432},{6,1390},{7,1404},{8,1418}]',649082,'[]',3),(1012,0,'[{1,47},{2,849},{3,22},{4,22},{5,10},{6,11},{7,10},{8,11}]',4989,'[{0,18040012,2}]',3),(1012,1,'[{1,636},{2,11467},{3,306},{4,297},{5,147},{6,154},{7,146},{8,156}]',69412,'[{0,18040012,4}]',3),(1012,2,'[{1,1519},{2,27393},{3,733},{4,711},{5,353},{6,369},{7,348},{8,373}]',166023,'[{0,18040012,6}]',3),(1012,3,'[{1,2698},{2,48628},{3,1301},{4,1263},{5,627},{6,655},{7,619},{8,663}]',294888,'[{0,18040012,8}]',3),(1012,4,'[{1,4170},{2,75172},{3,2012},{4,1952},{5,969},{6,1013},{7,957},{8,1024}]',455822,'[{0,18040012,10}]',3),(1012,5,'[{1,5938},{2,107025},{3,2864},{4,2780},{5,1380},{6,1442},{7,1363},{8,1459}]',649085,'[]',3),(1013,0,'[{1,24},{2,585},{3,14},{4,12},{5,7},{6,6},{7,7},{8,6}]',3015,'[{0,18040013,2}]',3),(1013,1,'[{1,330},{2,7903},{3,193},{4,169},{5,99},{6,81},{7,99},{8,81}]',41553,'[{0,18040013,4}]',3),(1013,2,'[{1,789},{2,18880},{3,462},{4,403},{5,238},{6,195},{7,237},{8,195}]',99535,'[{0,18040013,6}]',3),(1013,3,'[{1,1401},{2,33516},{3,821},{4,717},{5,423},{6,346},{7,422},{8,347}]',176886,'[{0,18040013,8}]',3),(1013,4,'[{1,2167},{2,51812},{3,1270},{4,1108},{5,654},{6,535},{7,652},{8,537}]',273502,'[{0,18040013,10}]',3),(1013,5,'[{1,3085},{2,73766},{3,1808},{4,1578},{5,931},{6,762},{7,928},{8,764}]',389366,'[]',3),(2001,0,'[{1,27},{2,532},{3,12},{4,13},{5,6},{6,6},{7,6},{8,7}]',2947,'[{0,18040101,2}]',1),(2001,1,'[{1,366},{2,7192},{3,175},{4,187},{5,87},{6,94},{7,83},{8,97}]',41612,'[{0,18040101,4}]',1),(2001,2,'[{1,874},{2,17181},{3,419},{4,447},{5,207},{6,225},{7,199},{8,233}]',99511,'[{0,18040101,6}]',1),(2001,3,'[{1,1552},{2,30500},{3,744},{4,794},{5,368},{6,400},{7,354},{8,414}]',176790,'[{0,18040101,8}]',1),(2001,4,'[{1,2400},{2,47149},{3,1150},{4,1228},{5,570},{6,619},{7,548},{8,641}]',273499,'[{0,18040101,10}]',1),(2001,5,'[{1,3417},{2,67127},{3,1637},{4,1749},{5,812},{6,881},{7,780},{8,912}]',389367,'[]',1),(2002,0,'[{1,28},{2,505},{3,13},{4,13},{5,7},{6,6},{7,6},{8,6}]',2965,'[{0,18040102,2}]',1),(2002,1,'[{1,384},{2,6829},{3,180},{4,181},{5,98},{6,83},{7,91},{8,89}]',41584,'[{0,18040102,4}]',1),(2002,2,'[{1,918},{2,16314},{3,432},{4,434},{5,234},{6,198},{7,218},{8,214}]',99524,'[{0,18040102,6}]',1),(2002,3,'[{1,1629},{2,28961},{3,767},{4,771},{5,417},{6,352},{7,388},{8,380}]',176841,'[{0,18040102,8}]',1),(2002,4,'[{1,2519},{2,44770},{3,1185},{4,1193},{5,644},{6,544},{7,600},{8,588}]',273400,'[{0,18040102,10}]',1),(2002,5,'[{1,3586},{2,63741},{3,1688},{4,1698},{5,917},{6,775},{7,855},{8,838}]',389361,'[]',1),(2003,0,'[{1,26},{2,538},{3,14},{4,12},{5,6},{6,6},{7,7},{8,6}]',2958,'[{0,18040103,2}]',1),(2003,1,'[{1,362},{2,7272},{3,197},{4,165},{5,88},{6,92},{7,95},{8,86}]',41612,'[{0,18040103,4}]',1),(2003,2,'[{1,865},{2,17372},{3,471},{4,395},{5,212},{6,221},{7,227},{8,205}]',99572,'[{0,18040103,6}]',1),(2003,3,'[{1,1535},{2,30839},{3,836},{4,702},{5,376},{6,392},{7,404},{8,365}]',176839,'[{0,18040103,8}]',1),(2003,4,'[{1,2374},{2,47672},{3,1292},{4,1085},{5,582},{6,607},{7,625},{8,564}]',273477,'[{0,18040103,10}]',1),(2003,5,'[{1,3380},{2,67873},{3,1840},{4,1546},{5,828},{6,864},{7,889},{8,803}]',389323,'[]',1),(2004,0,'[{1,25},{2,574},{3,14},{4,12},{5,7},{6,6},{7,6},{8,7}]',3024,'[{0,18040104,2}]',1),(2004,1,'[{1,337},{2,7758},{3,199},{4,163},{5,96},{6,85},{7,84},{8,97}]',41648,'[{0,18040104,4}]',1),(2004,2,'[{1,807},{2,18533},{3,476},{4,390},{5,230},{6,203},{7,200},{8,232}]',99573,'[{0,18040104,6}]',1),(2004,3,'[{1,1432},{2,32901},{3,845},{4,693},{5,408},{6,360},{7,356},{8,412}]',176791,'[{0,18040104,8}]',1),(2004,4,'[{1,2214},{2,50860},{3,1307},{4,1071},{5,632},{6,557},{7,551},{8,638}]',273490,'[{0,18040104,10}]',1),(2004,5,'[{1,3153},{2,72411},{3,1861},{4,1525},{5,900},{6,793},{7,784},{8,908}]',389371,'[]',1),(2005,0,'[{1,28},{2,499},{3,14},{4,12},{5,6},{6,6},{7,6},{8,7}]',2959,'[{0,18040105,2}]',1),(2005,1,'[{1,388},{2,6742},{3,189},{4,173},{5,91},{6,90},{7,83},{8,97}]',41602,'[{0,18040105,4}]',1),(2005,2,'[{1,928},{2,16106},{3,452},{4,414},{5,218},{6,215},{7,200},{8,232}]',99566,'[{0,18040105,6}]',1),(2005,3,'[{1,1648},{2,28592},{3,803},{4,735},{5,387},{6,382},{7,355},{8,413}]',176852,'[{0,18040105,8}]',1),(2005,4,'[{1,2547},{2,44199},{3,1241},{4,1137},{5,598},{6,590},{7,550},{8,639}]',273439,'[{0,18040105,10}]',1),(2005,5,'[{1,3627},{2,62928},{3,1767},{4,1618},{5,852},{6,840},{7,783},{8,910}]',389343,'[]',1),(3001,0,'[{1,0},{2,0},{3,0},{4,0},{5,0},{6,0},{7,0},{8,0}]',0,'[{0,18040008,2}]',3),(3001,1,'[{1,800},{2,16000},{3,400},{4,400},{5,200},{6,200},{7,200},{8,200}]',92000,'[{0,18040008,4}]',3),(3001,2,'[{1,2000},{2,40000},{3,1000},{4,1000},{5,500},{6,500},{7,500},{8,500}]',230000,'[{0,18040008,6}]',3),(3001,3,'[{1,3600},{2,72000},{3,1800},{4,1800},{5,900},{6,900},{7,900},{8,900}]',414000,'[{0,18040008,8}]',3),(3001,4,'[{1,5600},{2,112000},{3,2800},{4,2800},{5,1400},{6,1400},{7,1400},{8,1400}]',644000,'[{0,18040008,10}]',3),(3001,5,'[{1,8000},{2,160000},{3,4000},{4,4000},{5,2000},{6,2000},{7,2000},{8,2000}]',920000,'[]',4);
/*!40000 ALTER TABLE `base_star_soul_star` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_star_soul_universe`
--

DROP TABLE IF EXISTS `base_star_soul_universe`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_star_soul_universe` (
  `universe_id` int(11) unsigned NOT NULL COMMENT '小宇宙id',
  `universe_name` varchar(255) NOT NULL COMMENT '小宇宙名称@lang@',
  `cost_goods` varchar(255) NOT NULL COMMENT '突破消耗',
  `resources_id` int(11) unsigned NOT NULL COMMENT '资源id',
  `attr_ratio` smallint(6) unsigned NOT NULL COMMENT '上阵属性转化率',
  PRIMARY KEY (`universe_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星灵小宇宙配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_star_soul_universe`
--

LOCK TABLES `base_star_soul_universe` WRITE;
/*!40000 ALTER TABLE `base_star_soul_universe` DISABLE KEYS */;
INSERT INTO `base_star_soul_universe` VALUES (2001,'青铜小宇宙','[{0,18030001,4}]',2001,0),(2002,'白银小宇宙','[{0,18030001,8}]',2002,5),(2003,'黄金小宇宙','[{0,18030001,15}]',2002,13),(2004,'璀璨小宇宙','[]',2002,25);
/*!40000 ALTER TABLE `base_star_soul_universe` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_star_soul_value`
--

DROP TABLE IF EXISTS `base_star_soul_value`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_star_soul_value` (
  `id` tinyint(3) unsigned NOT NULL COMMENT '常量id',
  `value` varchar(255) NOT NULL COMMENT '常量值',
  `annotation` varchar(255) NOT NULL COMMENT '常量描述@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星灵常量配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_star_soul_value`
--

LOCK TABLES `base_star_soul_value` WRITE;
/*!40000 ALTER TABLE `base_star_soul_value` DISABLE KEYS */;
INSERT INTO `base_star_soul_value` VALUES (1,'50','星灵功能开放等级'),(2,'[{980,1},{20,2}]','暴击率[ {权重， 倍率}]，请务必配一条1倍的'),(3,'[{1,40}, {2,300}, {3,300}, {4,320}, {5,340}, {6,360}]','小宇宙阵位开启等级[{Pos,NeedLv}]'),(4,'[{1001, 1}, {1003, 2}, {2001, 2}]','新手经验副本引导时星灵的id和阵位[{id, loc}]');
/*!40000 ALTER TABLE `base_star_soul_value` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_star_soul_war_birth`
--

DROP TABLE IF EXISTS `base_star_soul_war_birth`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_star_soul_war_birth` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本id',
  `location` varchar(512) NOT NULL DEFAULT '[]' COMMENT '出生坐标',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_star_soul_war_birth`
--

LOCK TABLES `base_star_soul_war_birth` WRITE;
/*!40000 ALTER TABLE `base_star_soul_war_birth` DISABLE KEYS */;
INSERT INTO `base_star_soul_war_birth` VALUES (2501,'[{4011,5943},{3851,5666},{4233,5643},{4055,5487},{4448,5498},{4218,5300}]'),(2502,'[{3872,8997},{3607,8709},{4071,8597},{3832,8331},{4300,8282},{4000,8143}]'),(2503,'[{18877,7872},{18615,7828},{18927,7468},{18663,7398},{19004,7099},{18744,7033}]'),(2504,'[{17381,8466},{17143,8183},{17514,8005},{17272,7885},{17657,7693},{17370,7600}]'),(2505,'[{9881,8991},{9592,8746},{10010,8616},{9748,8397},{10142,8248 },{9881,8140}]');
/*!40000 ALTER TABLE `base_star_soul_war_birth` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_star_soul_war_diff`
--

DROP TABLE IF EXISTS `base_star_soul_war_diff`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_star_soul_war_diff` (
  `level` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '关卡id',
  `week_times` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '通关周次数',
  `week_time_max` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '周上限',
  `ratio` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '成长系数',
  PRIMARY KEY (`level`,`week_times`,`week_time_max`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_star_soul_war_diff`
--

LOCK TABLES `base_star_soul_war_diff` WRITE;
/*!40000 ALTER TABLE `base_star_soul_war_diff` DISABLE KEYS */;
INSERT INTO `base_star_soul_war_diff` VALUES (101,0,0,10000),(101,1,1,37200),(101,2,2,61300),(101,3,3,101200),(101,4,4,167100),(101,5,5,275800),(101,6,6,455000),(101,7,7,750900),(101,8,8,1238800),(101,9,9999,2044000),(102,0,0,10000),(102,1,1,37200),(102,2,2,61300),(102,3,3,101200),(102,4,4,167100),(102,5,5,275800),(102,6,6,455000),(102,7,7,750900),(102,8,8,1238800),(102,9,9999,2044000),(103,0,0,10000),(103,1,1,37200),(103,2,2,61300),(103,3,3,101200),(103,4,4,167100),(103,5,5,275800),(103,6,6,455000),(103,7,7,750900),(103,8,8,1238800),(103,9,9999,2044000),(104,0,0,10000),(104,1,1,37200),(104,2,2,61300),(104,3,3,101200),(104,4,4,167100),(104,5,5,275800),(104,6,6,455000),(104,7,7,750800),(104,8,8,1238800),(104,9,9999,2044000),(105,0,0,10000),(105,1,1,37200),(105,2,2,61300),(105,3,3,101200),(105,4,4,167100),(105,5,5,275800),(105,6,6,455000),(105,7,7,750900),(105,8,8,1238800),(105,9,9999,2044000),(201,0,0,10000),(201,1,1,23900),(201,2,2,39300),(201,3,3,64900),(201,4,4,107200),(201,5,5,176900),(201,6,6,291900),(201,7,7,481600),(201,8,8,794600),(201,9,9999,1311100),(202,0,0,10000),(202,1,1,23900),(202,2,2,39300),(202,3,3,64900),(202,4,4,107200),(202,5,5,176900),(202,6,6,291900),(202,7,7,481600),(202,8,8,794600),(202,9,9999,1311100),(203,0,0,10000),(203,1,1,23900),(203,2,2,39300),(203,3,3,64900),(203,4,4,107200),(203,5,5,176900),(203,6,6,291900),(203,7,7,481600),(203,8,8,794600),(203,9,9999,1311100),(204,0,0,10000),(204,1,1,23900),(204,2,2,39300),(204,3,3,64900),(204,4,4,107200),(204,5,5,176900),(204,6,6,291900),(204,7,7,481600),(204,8,8,794600),(204,9,9999,1311100),(205,0,0,10000),(205,1,1,23900),(205,2,2,39300),(205,3,3,64900),(205,4,4,107200),(205,5,5,176900),(205,6,6,291900),(205,7,7,481600),(205,8,8,794600),(205,9,9999,1311100),(301,0,0,10000),(301,1,1,23900),(301,2,2,39300),(301,3,3,64900),(301,4,4,107200),(301,5,5,176900),(301,6,6,291900),(301,7,7,481600),(301,8,8,794600),(301,9,9999,1311100),(302,0,0,10000),(302,1,1,23900),(302,2,2,39300),(302,3,3,64900),(302,4,4,107200),(302,5,5,176900),(302,6,6,291900),(302,7,7,481600),(302,8,8,794600),(302,9,9999,1311100),(303,0,0,10000),(303,1,1,23900),(303,2,2,39300),(303,3,3,64900),(303,4,4,107200),(303,5,5,176900),(303,6,6,291900),(303,7,7,481600),(303,8,8,794600),(303,9,9999,1311100),(304,0,0,10000),(304,1,1,23900),(304,2,2,39300),(304,3,3,64900),(304,4,4,107200),(304,5,5,176900),(304,6,6,291900),(304,7,7,481600),(304,8,8,794600),(304,9,9999,1311100),(305,0,0,10000),(305,1,1,23900),(305,2,2,39300),(305,3,3,64900),(305,4,4,107200),(305,5,5,176900),(305,6,6,291900),(305,7,7,481600),(305,8,8,794600),(305,9,9999,1311100),(401,0,0,10000),(401,1,1,16500),(401,2,2,27200),(401,3,3,44900),(401,4,4,74100),(401,5,5,122300),(401,6,6,201800),(401,7,7,333000),(401,8,8,549400),(401,9,9999,906500),(402,0,0,10000),(402,1,1,16500),(402,2,2,27200),(402,3,3,44900),(402,4,4,74100),(402,5,5,122300),(402,6,6,201800),(402,7,7,333000),(402,8,8,549400),(402,9,9999,906500),(403,0,0,10000),(403,1,1,16500),(403,2,2,27200),(403,3,3,44900),(403,4,4,74100),(403,5,5,122300),(403,6,6,201800),(403,7,7,333000),(403,8,8,549400),(403,9,9999,906500),(404,0,0,10000),(404,1,1,16500),(404,2,2,27200),(404,3,3,44900),(404,4,4,74100),(404,5,5,122300),(404,6,6,201800),(404,7,7,333000),(404,8,8,549400),(404,9,9999,906500),(405,0,0,10000),(405,1,1,16500),(405,2,2,27200),(405,3,3,44900),(405,4,4,74100),(405,5,5,122300),(405,6,6,201800),(405,7,7,333000),(405,8,8,549400),(405,9,9999,906500),(501,0,0,10000),(501,1,1,16500),(501,2,2,27200),(501,3,3,44900),(501,4,4,74100),(501,5,5,122300),(501,6,6,201800),(501,7,7,333000),(501,8,8,549400),(501,9,9999,906500),(502,0,0,10000),(502,1,1,16500),(502,2,2,27200),(502,3,3,44900),(502,4,4,74100),(502,5,5,122300),(502,6,6,201800),(502,7,7,333000),(502,8,8,549400),(502,9,9999,906500),(503,0,0,10000),(503,1,1,16500),(503,2,2,27200),(503,3,3,44900),(503,4,4,74100),(503,5,5,122300),(503,6,6,201800),(503,7,7,333000),(503,8,8,549400),(503,9,9999,906500),(504,0,0,10000),(504,1,1,16500),(504,2,2,27200),(504,3,3,44900),(504,4,4,74100),(504,5,5,122300),(504,6,6,201800),(504,7,7,333000),(504,8,8,549400),(504,9,9999,906500),(505,0,0,10000),(505,1,1,16500),(505,2,2,27200),(505,3,3,44900),(505,4,4,74100),(505,5,5,122300),(505,6,6,201800),(505,7,7,333000),(505,8,8,549400),(505,9,9999,906500);
/*!40000 ALTER TABLE `base_star_soul_war_diff` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_star_soul_war_kv`
--

DROP TABLE IF EXISTS `base_star_soul_war_kv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_star_soul_war_kv` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '键',
  `val` varchar(512) NOT NULL DEFAULT '0' COMMENT '值',
  `description` varchar(50) NOT NULL DEFAULT '' COMMENT '描述@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_star_soul_war_kv`
--

LOCK TABLES `base_star_soul_war_kv` WRITE;
/*!40000 ALTER TABLE `base_star_soul_war_kv` DISABLE KEYS */;
INSERT INTO `base_star_soul_war_kv` VALUES (1,'10','每周免费扫荡次数'),(2,'[{1,[{2,0,5}]},{2,[{2,0,5}]},{3,[{2,0,5}]},{4,[{2,0,5}]},{5,[{2,0,5}]},{6,[{2,0,10}]},{7,[{2,0,10}]},{8,[{2,0,10}]},{9,[{2,0,10}]},{10,[{2,0,10}]},{11,[{2,0,15}]},{12,[{2,0,15}]},{13,[{2,0,15}]},{14,[{2,0,15}]},{15,[{2,0,15}]},{16,[{2,0,20}]},{17,[{2,0,20}]},{18,[{2,0,20}]},{19,[{2,0,20}]},{20,[{2,0,20}]}]','vip购买消耗,格式[{次数,[{类型,物品id,数量}]}]');
/*!40000 ALTER TABLE `base_star_soul_war_kv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_star_soul_war_level`
--

DROP TABLE IF EXISTS `base_star_soul_war_level`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_star_soul_war_level` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '关卡编号',
  `diff_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '难度id',
  `dungeon_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT '副本库',
  `resource` varchar(50) NOT NULL DEFAULT '' COMMENT '展示模型id',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_star_soul_war_level`
--

LOCK TABLES `base_star_soul_war_level` WRITE;
/*!40000 ALTER TABLE `base_star_soul_war_level` DISABLE KEYS */;
INSERT INTO `base_star_soul_war_level` VALUES (101,1,'[30000]','202011'),(102,1,'[30001]','202012'),(103,1,'[30002]','202013'),(104,1,'[30003]','202014'),(105,1,'[30004]','202015'),(201,2,'[30005]','202011'),(202,2,'[30006]','202012'),(203,2,'[30007]','202013'),(204,2,'[30008]','202014'),(205,2,'[30009]','202015'),(301,3,'[30010]','202011'),(302,3,'[30011]','202012'),(303,3,'[30012]','202013'),(304,3,'[30013]','202014'),(305,3,'[30014]','202015'),(401,4,'[30015]','202011'),(402,4,'[30016]','202012'),(403,4,'[30017]','202013'),(404,4,'[30018]','202014'),(405,4,'[30019]','202015'),(501,5,'[30020]','202011'),(502,5,'[30021]','202012'),(503,5,'[30022]','202013'),(504,5,'[30023]','202014'),(505,5,'[30024]','202015');
/*!40000 ALTER TABLE `base_star_soul_war_level` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_star_soul_war_reward`
--

DROP TABLE IF EXISTS `base_star_soul_war_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_star_soul_war_reward` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '关卡编号',
  `week_min` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '周下限',
  `week_max` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '周上限',
  `first_reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '首通奖励',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励内容',
  PRIMARY KEY (`id`,`week_min`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_star_soul_war_reward`
--

LOCK TABLES `base_star_soul_war_reward` WRITE;
/*!40000 ALTER TABLE `base_star_soul_war_reward` DISABLE KEYS */;
INSERT INTO `base_star_soul_war_reward` VALUES (101,0,0,'[{0,18020001,5}]','[{255,36160005,40}]'),(101,1,1,'[]','[{255,36160005,80}]'),(101,2,2,'[]','[{255,36160005,120}]'),(101,3,3,'[]','[{255,36160005,160}]'),(101,4,4,'[]','[{255,36160005,200}]'),(101,5,5,'[]','[{255,36160005,240}]'),(101,6,6,'[]','[{255,36160005,280}]'),(101,7,7,'[]','[{255,36160005,320}]'),(101,8,8,'[]','[{255,36160005,360}]'),(101,9,9999,'[]','[{255,36160005,400}]'),(102,0,0,'[{0,18060001,5}]','[{255,36160005,42}]'),(102,1,1,'[]','[{255,36160005,82}]'),(102,2,2,'[]','[{255,36160005,122}]'),(102,3,3,'[]','[{255,36160005,162}]'),(102,4,4,'[]','[{255,36160005,202}]'),(102,5,5,'[]','[{255,36160005,242}]'),(102,6,6,'[]','[{255,36160005,282}]'),(102,7,7,'[]','[{255,36160005,322}]'),(102,8,8,'[]','[{255,36160005,362}]'),(102,9,9999,'[]','[{255,36160005,402}]'),(103,0,0,'[{0,18020001,5}]','[{255,36160005,44}]'),(103,1,1,'[]','[{255,36160005,84}]'),(103,2,2,'[]','[{255,36160005,124}]'),(103,3,3,'[]','[{255,36160005,164}]'),(103,4,4,'[]','[{255,36160005,204}]'),(103,5,5,'[]','[{255,36160005,244}]'),(103,6,6,'[]','[{255,36160005,284}]'),(103,7,7,'[]','[{255,36160005,324}]'),(103,8,8,'[]','[{255,36160005,364}]'),(103,9,9999,'[]','[{255,36160005,404}]'),(104,0,0,'[{0,18060001,5}]','[{255,36160005,46}]'),(104,1,1,'[]','[{255,36160005,86}]'),(104,2,2,'[]','[{255,36160005,126}]'),(104,3,3,'[]','[{255,36160005,166}]'),(104,4,4,'[]','[{255,36160005,206}]'),(104,5,5,'[]','[{255,36160005,246}]'),(104,6,6,'[]','[{255,36160005,286}]'),(104,7,7,'[]','[{255,36160005,326}]'),(104,8,8,'[]','[{255,36160005,366}]'),(104,9,9999,'[]','[{255,36160005,406}]'),(105,0,0,'[{0,18040101,1}]','[{255,36160005,50}]'),(105,1,1,'[]','[{255,36160005,90}]'),(105,2,2,'[]','[{255,36160005,130}]'),(105,3,3,'[]','[{255,36160005,170}]'),(105,4,4,'[]','[{255,36160005,210}]'),(105,5,5,'[]','[{255,36160005,250}]'),(105,6,6,'[]','[{255,36160005,290}]'),(105,7,7,'[]','[{255,36160005,330}]'),(105,8,8,'[]','[{255,36160005,370}]'),(105,9,9999,'[]','[{255,36160005,410}]'),(201,0,0,'[{0,18020001,6}]','[{255,36160005,50}]'),(201,1,1,'[]','[{255,36160005,90}]'),(201,2,2,'[]','[{255,36160005,130}]'),(201,3,3,'[]','[{255,36160005,170}]'),(201,4,4,'[]','[{255,36160005,210}]'),(201,5,5,'[]','[{255,36160005,250}]'),(201,6,6,'[]','[{255,36160005,290}]'),(201,7,7,'[]','[{255,36160005,330}]'),(201,8,8,'[]','[{255,36160005,370}]'),(201,9,9999,'[]','[{255,36160005,410}]'),(202,0,0,'[{0,18060001,6}]','[{255,36160005,52}]'),(202,1,1,'[]','[{255,36160005,92}]'),(202,2,2,'[]','[{255,36160005,132}]'),(202,3,3,'[]','[{255,36160005,172}]'),(202,4,4,'[]','[{255,36160005,212}]'),(202,5,5,'[]','[{255,36160005,252}]'),(202,6,6,'[]','[{255,36160005,292}]'),(202,7,7,'[]','[{255,36160005,332}]'),(202,8,8,'[]','[{255,36160005,372}]'),(202,9,9999,'[]','[{255,36160005,412}]'),(203,0,0,'[{0,18054701,1}]','[{255,36160005,54}]'),(203,1,1,'[]','[{255,36160005,94}]'),(203,2,2,'[]','[{255,36160005,134}]'),(203,3,3,'[]','[{255,36160005,174}]'),(203,4,4,'[]','[{255,36160005,214}]'),(203,5,5,'[]','[{255,36160005,254}]'),(203,6,6,'[]','[{255,36160005,294}]'),(203,7,7,'[]','[{255,36160005,334}]'),(203,8,8,'[]','[{255,36160005,374}]'),(203,9,9999,'[]','[{255,36160005,414}]'),(204,0,0,'[{0,18020001,6}]','[{255,36160005,56}]'),(204,1,1,'[]','[{255,36160005,96}]'),(204,2,2,'[]','[{255,36160005,136}]'),(204,3,3,'[]','[{255,36160005,176}]'),(204,4,4,'[]','[{255,36160005,216}]'),(204,5,5,'[]','[{255,36160005,256}]'),(204,6,6,'[]','[{255,36160005,296}]'),(204,7,7,'[]','[{255,36160005,336}]'),(204,8,8,'[]','[{255,36160005,376}]'),(204,9,9999,'[]','[{255,36160005,416}]'),(205,0,0,'[{0,18050301,1}]','[{255,36160005,60}]'),(205,1,1,'[]','[{255,36160005,100}]'),(205,2,2,'[]','[{255,36160005,140}]'),(205,3,3,'[]','[{255,36160005,180}]'),(205,4,4,'[]','[{255,36160005,220}]'),(205,5,5,'[]','[{255,36160005,260}]'),(205,6,6,'[]','[{255,36160005,300}]'),(205,7,7,'[]','[{255,36160005,340}]'),(205,8,8,'[]','[{255,36160005,380}]'),(205,9,9999,'[]','[{255,36160005,420}]'),(301,0,0,'[{0,18020001,8}]','[{255,36160005,60}]'),(301,1,1,'[]','[{255,36160005,100}]'),(301,2,2,'[]','[{255,36160005,140}]'),(301,3,3,'[]','[{255,36160005,180}]'),(301,4,4,'[]','[{255,36160005,220}]'),(301,5,5,'[]','[{255,36160005,260}]'),(301,6,6,'[]','[{255,36160005,300}]'),(301,7,7,'[]','[{255,36160005,340}]'),(301,8,8,'[]','[{255,36160005,380}]'),(301,9,9999,'[]','[{255,36160005,420}]'),(302,0,0,'[{0,18060001,8}]','[{255,36160005,62}]'),(302,1,1,'[]','[{255,36160005,102}]'),(302,2,2,'[]','[{255,36160005,142}]'),(302,3,3,'[]','[{255,36160005,182}]'),(302,4,4,'[]','[{255,36160005,222}]'),(302,5,5,'[]','[{255,36160005,262}]'),(302,6,6,'[]','[{255,36160005,302}]'),(302,7,7,'[]','[{255,36160005,342}]'),(302,8,8,'[]','[{255,36160005,382}]'),(302,9,9999,'[]','[{255,36160005,422}]'),(303,0,0,'[{0,18030001,1}]','[{255,36160005,64}]'),(303,1,1,'[]','[{255,36160005,104}]'),(303,2,2,'[]','[{255,36160005,144}]'),(303,3,3,'[]','[{255,36160005,184}]'),(303,4,4,'[]','[{255,36160005,224}]'),(303,5,5,'[]','[{255,36160005,264}]'),(303,6,6,'[]','[{255,36160005,304}]'),(303,7,7,'[]','[{255,36160005,344}]'),(303,8,8,'[]','[{255,36160005,384}]'),(303,9,9999,'[]','[{255,36160005,424}]'),(304,0,0,'[{0,18020001,8}]','[{255,36160005,66}]'),(304,1,1,'[]','[{255,36160005,106}]'),(304,2,2,'[]','[{255,36160005,146}]'),(304,3,3,'[]','[{255,36160005,186}]'),(304,4,4,'[]','[{255,36160005,226}]'),(304,5,5,'[]','[{255,36160005,266}]'),(304,6,6,'[]','[{255,36160005,306}]'),(304,7,7,'[]','[{255,36160005,346}]'),(304,8,8,'[]','[{255,36160005,386}]'),(304,9,9999,'[]','[{255,36160005,426}]'),(305,0,0,'[{0,18030001,1}]','[{255,36160005,70}]'),(305,1,1,'[]','[{255,36160005,110}]'),(305,2,2,'[]','[{255,36160005,150}]'),(305,3,3,'[]','[{255,36160005,190}]'),(305,4,4,'[]','[{255,36160005,230}]'),(305,5,5,'[]','[{255,36160005,270}]'),(305,6,6,'[]','[{255,36160005,310}]'),(305,7,7,'[]','[{255,36160005,350}]'),(305,8,8,'[]','[{255,36160005,390}]'),(305,9,9999,'[]','[{255,36160005,430}]'),(401,0,0,'[{0,18020001,10}]','[{255,36160005,70}]'),(401,1,1,'[]','[{255,36160005,110}]'),(401,2,2,'[]','[{255,36160005,150}]'),(401,3,3,'[]','[{255,36160005,190}]'),(401,4,4,'[]','[{255,36160005,230}]'),(401,5,5,'[]','[{255,36160005,270}]'),(401,6,6,'[]','[{255,36160005,310}]'),(401,7,7,'[]','[{255,36160005,350}]'),(401,8,8,'[]','[{255,36160005,390}]'),(401,9,9999,'[]','[{255,36160005,430}]'),(402,0,0,'[{0,18060001,10}]','[{255,36160005,72}]'),(402,1,1,'[]','[{255,36160005,112}]'),(402,2,2,'[]','[{255,36160005,152}]'),(402,3,3,'[]','[{255,36160005,192}]'),(402,4,4,'[]','[{255,36160005,232}]'),(402,5,5,'[]','[{255,36160005,272}]'),(402,6,6,'[]','[{255,36160005,312}]'),(402,7,7,'[]','[{255,36160005,352}]'),(402,8,8,'[]','[{255,36160005,392}]'),(402,9,9999,'[]','[{255,36160005,432}]'),(403,0,0,'[{0,18020001,10}]','[{255,36160005,74}]'),(403,1,1,'[]','[{255,36160005,114}]'),(403,2,2,'[]','[{255,36160005,154}]'),(403,3,3,'[]','[{255,36160005,194}]'),(403,4,4,'[]','[{255,36160005,234}]'),(403,5,5,'[]','[{255,36160005,274}]'),(403,6,6,'[]','[{255,36160005,314}]'),(403,7,7,'[]','[{255,36160005,354}]'),(403,8,8,'[]','[{255,36160005,394}]'),(403,9,9999,'[]','[{255,36160005,434}]'),(404,0,0,'[{0,18060001,10}]','[{255,36160005,76}]'),(404,1,1,'[]','[{255,36160005,116}]'),(404,2,2,'[]','[{255,36160005,156}]'),(404,3,3,'[]','[{255,36160005,196}]'),(404,4,4,'[]','[{255,36160005,236}]'),(404,5,5,'[]','[{255,36160005,276}]'),(404,6,6,'[]','[{255,36160005,316}]'),(404,7,7,'[]','[{255,36160005,356}]'),(404,8,8,'[]','[{255,36160005,396}]'),(404,9,9999,'[]','[{255,36160005,436}]'),(405,0,0,'[{0,18040103,1}]','[{255,36160005,80}]'),(405,1,1,'[]','[{255,36160005,120}]'),(405,2,2,'[]','[{255,36160005,160}]'),(405,3,3,'[]','[{255,36160005,200}]'),(405,4,4,'[]','[{255,36160005,240}]'),(405,5,5,'[]','[{255,36160005,280}]'),(405,6,6,'[]','[{255,36160005,320}]'),(405,7,7,'[]','[{255,36160005,360}]'),(405,8,8,'[]','[{255,36160005,400}]'),(405,9,9999,'[]','[{255,36160005,440}]'),(501,0,0,'[{0,18020001,12}]','[{255,36160005,80}]'),(501,1,1,'[]','[{255,36160005,120}]'),(501,2,2,'[]','[{255,36160005,160}]'),(501,3,3,'[]','[{255,36160005,200}]'),(501,4,4,'[]','[{255,36160005,240}]'),(501,5,5,'[]','[{255,36160005,280}]'),(501,6,6,'[]','[{255,36160005,320}]'),(501,7,7,'[]','[{255,36160005,360}]'),(501,8,8,'[]','[{255,36160005,400}]'),(501,9,9999,'[]','[{255,36160005,440}]'),(502,0,0,'[{0,18060001,12}]','[{255,36160005,82}]'),(502,1,1,'[]','[{255,36160005,122}]'),(502,2,2,'[]','[{255,36160005,162}]'),(502,3,3,'[]','[{255,36160005,202}]'),(502,4,4,'[]','[{255,36160005,242}]'),(502,5,5,'[]','[{255,36160005,282}]'),(502,6,6,'[]','[{255,36160005,322}]'),(502,7,7,'[]','[{255,36160005,362}]'),(502,8,8,'[]','[{255,36160005,402}]'),(502,9,9999,'[]','[{255,36160005,442}]'),(503,0,0,'[{0,18041003,2}]','[{255,36160005,84}]'),(503,1,1,'[]','[{255,36160005,124}]'),(503,2,2,'[]','[{255,36160005,164}]'),(503,3,3,'[]','[{255,36160005,204}]'),(503,4,4,'[]','[{255,36160005,244}]'),(503,5,5,'[]','[{255,36160005,284}]'),(503,6,6,'[]','[{255,36160005,324}]'),(503,7,7,'[]','[{255,36160005,364}]'),(503,8,8,'[]','[{255,36160005,404}]'),(503,9,9999,'[]','[{255,36160005,444}]'),(504,0,0,'[{0,18020001,12}]','[{255,36160005,86}]'),(504,1,1,'[]','[{255,36160005,126}]'),(504,2,2,'[]','[{255,36160005,166}]'),(504,3,3,'[]','[{255,36160005,206}]'),(504,4,4,'[]','[{255,36160005,246}]'),(504,5,5,'[]','[{255,36160005,286}]'),(504,6,6,'[]','[{255,36160005,326}]'),(504,7,7,'[]','[{255,36160005,366}]'),(504,8,8,'[]','[{255,36160005,406}]'),(504,9,9999,'[]','[{255,36160005,446}]'),(505,0,0,'[{0,18041003,3}]','[{255,36160005,90}]'),(505,1,1,'[]','[{255,36160005,130}]'),(505,2,2,'[]','[{255,36160005,170}]'),(505,3,3,'[]','[{255,36160005,210}]'),(505,4,4,'[]','[{255,36160005,250}]'),(505,5,5,'[]','[{255,36160005,290}]'),(505,6,6,'[]','[{255,36160005,330}]'),(505,7,7,'[]','[{255,36160005,370}]'),(505,8,8,'[]','[{255,36160005,410}]'),(505,9,9999,'[]','[{255,36160005,450}]');
/*!40000 ALTER TABLE `base_star_soul_war_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_starsoul_goods_reward`
--

DROP TABLE IF EXISTS `base_starsoul_goods_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_starsoul_goods_reward` (
  `id` int(32) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增ID',
  `reward_list_id` int(32) unsigned NOT NULL DEFAULT '0' COMMENT '奖励列表ID',
  `goods_id` int(32) unsigned NOT NULL DEFAULT '0' COMMENT '道具ID',
  `reward_num` int(32) unsigned NOT NULL DEFAULT '0' COMMENT '奖励数量',
  `least` int(16) unsigned NOT NULL DEFAULT '0' COMMENT '是否保底',
  `weight` int(32) unsigned NOT NULL DEFAULT '0' COMMENT '抽中权重',
  `limit_times` int(32) unsigned NOT NULL DEFAULT '0' COMMENT '限制次数',
  `reset_times` int(32) unsigned NOT NULL DEFAULT '0' COMMENT '重置次数',
  `broadcast` int(16) unsigned NOT NULL DEFAULT '0' COMMENT '是否传闻',
  `rare` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否稀有',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=100 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_starsoul_goods_reward`
--

LOCK TABLES `base_starsoul_goods_reward` WRITE;
/*!40000 ALTER TABLE `base_starsoul_goods_reward` DISABLE KEYS */;
INSERT INTO `base_starsoul_goods_reward` VALUES (1,1,18041002,1,0,250,4,30,1,77),(2,2,18041002,2,0,133,4,30,1,77),(3,3,18041002,3,0,100,4,30,1,77),(4,4,18041002,5,0,33,4,30,1,77),(5,5,18041003,1,0,250,4,30,1,77),(6,6,18041003,2,0,133,4,30,1,77),(7,7,18041003,3,0,100,4,30,1,77),(8,8,18041003,5,0,33,4,30,1,77),(9,9,18041004,1,0,250,4,30,1,77),(10,10,18041004,2,0,133,4,30,1,77),(11,11,18041004,3,0,100,4,30,1,77),(12,12,18041004,5,0,33,4,30,1,77),(13,13,18041005,1,0,250,4,30,1,77),(14,14,18041005,2,0,133,4,30,1,77),(15,15,18041005,3,0,100,4,30,1,77),(16,16,18041005,5,0,33,4,30,1,77),(17,17,18041006,1,0,250,4,30,1,77),(18,18,18041006,2,0,133,4,30,1,77),(19,19,18041006,3,0,100,4,30,1,77),(20,20,18041006,5,0,33,4,30,1,77),(21,21,18041007,1,0,250,4,30,1,77),(22,22,18041007,2,0,133,4,30,1,77),(23,23,18041007,3,0,100,4,30,1,77),(24,24,18041007,5,0,33,4,30,1,77),(25,25,18041101,2,0,400,0,0,0,66),(26,26,18041101,3,0,360,0,0,0,66),(27,27,18041101,4,0,240,0,0,0,66),(28,28,18041101,5,0,120,0,0,0,66),(29,29,18041102,2,0,400,0,0,0,66),(30,30,18041102,3,0,360,0,0,0,66),(31,31,18041102,4,0,240,0,0,0,66),(32,32,18041102,5,0,120,0,0,0,66),(33,33,18041103,2,0,400,0,0,0,66),(34,34,18041103,3,0,360,0,0,0,66),(35,35,18041103,4,0,240,0,0,0,66),(36,36,18041103,5,0,120,0,0,0,66),(37,37,18041104,2,0,400,0,0,0,66),(38,38,18041104,3,0,360,0,0,0,66),(39,39,18041104,4,0,240,0,0,0,66),(40,40,18041104,5,0,120,0,0,0,66),(41,41,18041105,2,0,400,0,0,0,66),(42,42,18041105,3,0,360,0,0,0,66),(43,43,18041105,4,0,240,0,0,0,66),(44,44,18041105,5,0,120,0,0,0,66),(45,45,18020001,10,0,1500,0,0,0,0),(46,46,18020001,20,0,1200,0,0,0,0),(47,47,18020001,5,0,1200,0,0,0,0),(48,48,18040001,1,0,50,1,10,0,88),(49,49,18040002,1,1,8,1,10,0,99),(50,50,18040003,1,1,8,1,10,0,99),(51,51,18040004,1,1,8,1,10,0,99),(52,52,18040005,1,1,8,1,10,0,99),(53,53,18040006,1,1,8,1,10,0,99),(54,54,18040007,1,1,8,1,10,0,99),(55,55,18040101,1,0,50,0,0,0,88),(56,56,18040102,1,0,50,0,0,0,88),(57,57,18040103,1,0,50,0,0,0,88),(58,58,18040104,1,0,50,0,0,0,88),(59,59,18040105,1,0,50,0,0,0,88),(60,60,18054701,1,0,188,0,0,0,0),(61,61,18050101,1,0,188,0,0,0,0),(62,62,18050201,1,0,188,0,0,0,0),(63,63,18050301,1,0,188,0,0,0,0),(64,64,18050401,1,0,188,0,0,0,0),(65,65,18050501,1,0,188,0,0,0,0),(66,66,18050601,1,0,188,0,0,0,0),(67,67,18050701,1,0,188,0,0,0,0),(68,68,18054801,1,0,18,0,0,0,0),(69,69,18050801,1,0,18,0,0,0,0),(70,70,18050901,1,0,18,0,0,0,0),(71,71,18051001,1,0,18,0,0,0,0),(72,72,18051101,1,0,18,0,0,0,0),(73,73,18051201,1,0,18,0,0,0,0),(74,74,18051301,1,0,18,0,0,0,0),(75,75,18051401,1,0,18,0,0,0,0),(76,76,18051501,1,0,18,0,0,0,0),(77,77,18051601,1,0,18,0,0,0,0),(78,78,18053601,1,0,18,0,0,0,0),(79,79,18053701,1,0,18,0,0,0,0),(80,80,18053801,1,0,18,0,0,0,0),(81,81,18053901,1,0,18,0,0,0,0),(82,82,18054001,1,0,18,0,0,0,0),(83,83,18054101,1,0,18,0,0,0,0),(84,84,18054201,1,0,18,0,0,0,0),(85,85,18054301,1,0,25,0,0,0,0),(86,86,18054401,1,0,25,0,0,0,0),(87,87,18054501,1,0,25,0,0,0,0),(88,88,18054601,1,0,25,0,0,0,0),(89,89,18060001,5,0,450,0,0,0,0),(90,90,18060001,7,0,315,0,0,0,0),(91,91,18060001,8,0,276,0,0,0,0),(92,92,18060001,10,0,220,0,0,0,0),(93,93,18060002,2,0,552,0,0,0,0),(94,94,18060002,3,0,368,0,0,0,0),(95,95,18060002,4,0,276,0,0,0,0),(96,96,18060002,6,0,184,0,0,0,0),(97,97,18060003,1,0,552,0,0,0,0),(98,98,18060003,2,0,276,0,0,0,0),(99,99,18060003,3,0,184,0,0,0,0);
/*!40000 ALTER TABLE `base_starsoul_goods_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_starsoul_integral_reward`
--

DROP TABLE IF EXISTS `base_starsoul_integral_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_starsoul_integral_reward` (
  `id` int(32) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号ID',
  `goods_id` int(32) unsigned NOT NULL DEFAULT '0' COMMENT '物品ID',
  `goods_num` int(32) unsigned NOT NULL DEFAULT '0' COMMENT '物品数量',
  `to_redeem_num` int(32) unsigned NOT NULL DEFAULT '0' COMMENT '兑换积分数',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=14 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_starsoul_integral_reward`
--

LOCK TABLES `base_starsoul_integral_reward` WRITE;
/*!40000 ALTER TABLE `base_starsoul_integral_reward` DISABLE KEYS */;
INSERT INTO `base_starsoul_integral_reward` VALUES (1,18041002,1,16),(2,18041003,1,16),(3,18041004,1,16),(4,18041005,1,16),(5,18041006,1,16),(6,18041007,1,16),(7,18041101,1,10),(8,18041102,1,10),(9,18041103,1,10),(10,18041104,1,10),(11,18041105,1,10),(12,18020001,1,1),(13,18060001,1,2);
/*!40000 ALTER TABLE `base_starsoul_integral_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_starsoul_specific_up`
--

DROP TABLE IF EXISTS `base_starsoul_specific_up`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_starsoul_specific_up` (
  `id` int(32) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号ID',
  `reward_list_id` int(32) unsigned NOT NULL DEFAULT '0' COMMENT '奖励列表ID',
  `time_type` int(16) unsigned NOT NULL DEFAULT '0' COMMENT '时间类型',
  `start_time` datetime DEFAULT NULL COMMENT '开始时间',
  `end_time` datetime DEFAULT NULL COMMENT '结束时间',
  `start_days` varchar(500) NOT NULL DEFAULT '[]' COMMENT '开服天数',
  `end_days` varchar(500) NOT NULL DEFAULT '[]' COMMENT '合服天数',
  `weight_multiple` int(32) unsigned NOT NULL DEFAULT '1' COMMENT '权重up倍数',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_starsoul_specific_up`
--

LOCK TABLES `base_starsoul_specific_up` WRITE;
/*!40000 ALTER TABLE `base_starsoul_specific_up` DISABLE KEYS */;
INSERT INTO `base_starsoul_specific_up` VALUES (1,1,1,'2018-10-18 15:11:23','2018-11-18 00:00:00','[]','[]',1),(2,2,2,'0000-00-00 00:00:00','0000-00-00 00:00:00','[1,7]','[]',1);
/*!40000 ALTER TABLE `base_starsoul_specific_up` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_summon_card`
--

DROP TABLE IF EXISTS `base_summon_card`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_summon_card` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品id',
  `partner_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '伙伴id',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='召唤卡配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_summon_card`
--

LOCK TABLES `base_summon_card` WRITE;
/*!40000 ALTER TABLE `base_summon_card` DISABLE KEYS */;
INSERT INTO `base_summon_card` VALUES (211207,207),(211208,208),(211209,209),(211210,210),(211211,211),(211212,212),(211213,213),(211214,214),(211215,215),(211216,216),(211217,217),(211301,301),(211302,302),(211303,303),(211304,304),(211313,313),(211315,315),(211316,316),(211317,317),(211318,318),(211319,319),(211320,320),(211321,321),(211322,322),(211323,323),(211324,324),(211325,325),(211326,326),(211399,323),(211401,401),(211402,402),(211403,403),(211406,406),(211407,407),(211408,408),(211413,413),(211417,417),(211418,418),(211422,422),(211423,423),(211428,428),(211431,431),(211432,432),(211433,433),(211434,434),(211501,501),(211502,502),(211503,503);
/*!40000 ALTER TABLE `base_summon_card` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_talisman_change`
--

DROP TABLE IF EXISTS `base_talisman_change`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_talisman_change` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '化形id',
  `prop` varchar(255) NOT NULL DEFAULT '[]' COMMENT '化形激活道具',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '名称@lang@',
  `turn` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '化形所需转生数',
  `figure_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '形象id',
  `max_star` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '最大星数',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='法宝化形表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_talisman_change`
--

LOCK TABLES `base_talisman_change` WRITE;
/*!40000 ALTER TABLE `base_talisman_change` DISABLE KEYS */;
INSERT INTO `base_talisman_change` VALUES (0,'[]','星象仪',0,607001,0),(1,'[{0,24030001,1}]','龙魂宝珠',0,607002,5),(2,'[{0,24030002,1}]','失落魔方',1,607003,5),(3,'[{0,24030003,1}]','古神典籍',2,607006,5),(4,'[{0,24030004,1}]','海洋之心',3,607007,5),(5,'[{0,24030005,1}]','海洋护符',4,609011,5),(6,'[{0,24030006,1}]','航海宝珠',5,609012,5),(7,'[{0,24030007,1}]','善恶天秤',0,609014,5);
/*!40000 ALTER TABLE `base_talisman_change` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_talisman_feather`
--

DROP TABLE IF EXISTS `base_talisman_feather`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_talisman_feather` (
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '魂珠物品id',
  `attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '属性增加',
  `combat` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战力增加',
  `max_times` varchar(255) NOT NULL DEFAULT '[]' COMMENT '最大使用次数',
  PRIMARY KEY (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='魂珠提升表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_talisman_feather`
--

LOCK TABLES `base_talisman_feather` WRITE;
/*!40000 ALTER TABLE `base_talisman_feather` DISABLE KEYS */;
INSERT INTO `base_talisman_feather` VALUES (24020001,'[{2,450},{5,12}]',1050,'[{1,250,500},{251,400,800},{401,1000,1000}]'),(24020002,'[{1,40},{6,25}]',2050,'[{1,250,250},{251,400,400},{401,1000,500}]'),(24020003,'[{2,1500},{1,75},{61,50},{65,50}]',3000,'[{1,250,100},{251,400,150},{401,1000,200}]'),(24020004,'[{5,60},{6,60},{60,100},{64,100}]',6000,'[{1,250,50},{251,400,80},{401,1000,100}]');
/*!40000 ALTER TABLE `base_talisman_feather` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_talisman_goods_lv`
--

DROP TABLE IF EXISTS `base_talisman_goods_lv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_talisman_goods_lv` (
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品id',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '道具提供经验',
  `min_lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '道具可用最低等级',
  `max_lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '道具使用最高等级',
  PRIMARY KEY (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='法宝升级道具配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_talisman_goods_lv`
--

LOCK TABLES `base_talisman_goods_lv` WRITE;
/*!40000 ALTER TABLE `base_talisman_goods_lv` DISABLE KEYS */;
INSERT INTO `base_talisman_goods_lv` VALUES (24010001,30,1,60),(24010002,100,61,150),(24010003,300,151,240);
/*!40000 ALTER TABLE `base_talisman_goods_lv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_talisman_lv`
--

DROP TABLE IF EXISTS `base_talisman_lv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_talisman_lv` (
  `lv` int(5) unsigned NOT NULL DEFAULT '0' COMMENT '法宝等级',
  `max_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '升级所需经验值',
  `attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '属性',
  `combat` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战力',
  `is_tv` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '升级传闻',
  PRIMARY KEY (`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='法宝等级表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_talisman_lv`
--

LOCK TABLES `base_talisman_lv` WRITE;
/*!40000 ALTER TABLE `base_talisman_lv` DISABLE KEYS */;
INSERT INTO `base_talisman_lv` VALUES (1,30,'[{1,8},{2,163},{5,3},{6,3}]',623,0),(2,60,'[{1,17},{2,342},{5,7},{6,7}]',1382,0),(3,80,'[{1,27},{2,537},{5,11},{6,11}]',2177,0),(4,100,'[{1,38},{2,749},{5,15},{6,15}]',3009,0),(5,110,'[{1,49},{2,977},{5,20},{6,20}]',3957,0),(6,120,'[{1,61},{2,1221},{5,25},{6,25}]',4941,0),(7,130,'[{1,74},{2,1481},{5,30},{6,30}]',5961,0),(8,140,'[{1,88},{2,1758},{5,36},{6,36}]',7118,0),(9,150,'[{1,103},{2,2051},{5,42},{6,42}]',8311,0),(10,160,'[{1,118},{2,2360},{5,48},{6,48}]',9520,0),(11,170,'[{1,134},{2,2685},{5,55},{6,55}]',10865,0),(12,180,'[{1,151},{2,3027},{5,62},{6,62}]',12247,0),(13,190,'[{1,169},{2,3385},{5,69},{6,69}]',13665,0),(14,200,'[{1,188},{2,3759},{5,76},{6,76}]',15119,0),(15,210,'[{1,208},{2,4149},{5,84},{6,84}]',16709,0),(16,220,'[{1,228},{2,4556},{5,92},{6,92}]',18316,0),(17,230,'[{1,249},{2,4979},{5,100},{6,100}]',19959,0),(18,240,'[{1,271},{2,5418},{5,109},{6,109}]',21738,0),(19,250,'[{1,294},{2,5874},{5,118},{6,118}]',23554,0),(20,260,'[{1,318},{2,6346},{5,127},{6,127}]',25406,1),(21,270,'[{1,343},{2,6844},{5,137},{6,137}]',27404,0),(22,280,'[{1,369},{2,7368},{5,147},{6,147}]',29448,0),(23,290,'[{1,396},{2,7918},{5,158},{6,158}]',31638,0),(24,300,'[{1,425},{2,8494},{5,170},{6,170}]',33994,0),(25,310,'[{1,455},{2,9096},{5,182},{6,182}]',36396,0),(26,325,'[{1,486},{2,9724},{5,195},{6,195}]',38944,0),(27,345,'[{1,519},{2,10378},{5,208},{6,208}]',41558,0),(28,365,'[{1,553},{2,11058},{5,222},{6,222}]',44318,0),(29,385,'[{1,588},{2,11764},{5,236},{6,236}]',47124,0),(30,405,'[{1,625},{2,12496},{5,251},{6,251}]',50096,0),(31,425,'[{1,663},{2,13254},{5,266},{6,266}]',53114,0),(32,445,'[{1,702},{2,14038},{5,282},{6,282}]',56278,0),(33,465,'[{1,743},{2,14848},{5,298},{6,298}]',59508,0),(34,485,'[{1,785},{2,15684},{5,315},{6,315}]',62884,0),(35,505,'[{1,828},{2,16546},{5,332},{6,332}]',66306,0),(36,525,'[{1,872},{2,17434},{5,350},{6,350}]',69874,0),(37,545,'[{1,918},{2,18348},{5,368},{6,368}]',73508,0),(38,565,'[{1,965},{2,19288},{5,387},{6,387}]',77288,0),(39,585,'[{1,1013},{2,20254},{5,406},{6,406}]',81114,0),(40,610,'[{1,1063},{2,21246},{5,426},{6,426}]',85106,1),(41,635,'[{1,1114},{2,22274},{5,447},{6,447}]',89254,0),(42,660,'[{1,1167},{2,23338},{5,468},{6,468}]',93478,0),(43,685,'[{1,1222},{2,24438},{5,490},{6,490}]',97878,0),(44,710,'[{1,1279},{2,25574},{5,513},{6,513}]',102454,0),(45,735,'[{1,1338},{2,26745},{5,536},{6,536}]',107105,0),(46,760,'[{1,1398},{2,27952},{5,560},{6,560}]',111912,0),(47,785,'[{1,1460},{2,29195},{5,585},{6,585}]',116895,0),(48,810,'[{1,1524},{2,30474},{5,611},{6,611}]',122054,0),(49,835,'[{1,1590},{2,31789},{5,637},{6,637}]',127289,0),(50,860,'[{1,1658},{2,33139},{5,664},{6,664}]',132699,0),(51,885,'[{1,1727},{2,34525},{5,692},{6,692}]',138265,0),(52,910,'[{1,1798},{2,35947},{5,720},{6,720}]',143907,0),(53,935,'[{1,1871},{2,37405},{5,749},{6,749}]',149725,0),(54,960,'[{1,1946},{2,38899},{5,779},{6,779}]',155719,0),(55,985,'[{1,2022},{2,40428},{5,810},{6,810}]',161868,0),(56,1010,'[{1,2100},{2,41993},{5,841},{6,841}]',168093,0),(57,1035,'[{1,2180},{2,43594},{5,873},{6,873}]',174494,0),(58,1060,'[{1,2262},{2,45231},{5,906},{6,906}]',181071,0),(59,1085,'[{1,2346},{2,46904},{5,939},{6,939}]',187724,0),(60,1115,'[{1,2431},{2,48612},{5,973},{6,973}]',194532,1),(61,1145,'[{1,2519},{2,50366},{5,1008},{6,1008}]',201546,0),(62,1175,'[{1,2609},{2,52165},{5,1044},{6,1044}]',208745,0),(63,1205,'[{1,2701},{2,54010},{5,1081},{6,1081}]',216130,0),(64,1235,'[{1,2796},{2,55901},{5,1119},{6,1119}]',223721,0),(65,1265,'[{1,2893},{2,57837},{5,1158},{6,1158}]',231497,0),(66,1295,'[{1,2992},{2,59819},{5,1198},{6,1198}]',239459,0),(67,1325,'[{1,3093},{2,61846},{5,1239},{6,1239}]',247606,0),(68,1355,'[{1,3197},{2,63919},{5,1280},{6,1280}]',255859,0),(69,1385,'[{1,3303},{2,66037},{5,1322},{6,1322}]',264297,0),(70,1415,'[{1,3411},{2,68201},{5,1365},{6,1365}]',272921,0),(71,1445,'[{1,3521},{2,70410},{5,1409},{6,1409}]',281730,0),(72,1475,'[{1,3634},{2,72665},{5,1454},{6,1454}]',290745,0),(73,1505,'[{1,3749},{2,74966},{5,1500},{6,1500}]',299946,0),(74,1535,'[{1,3866},{2,77312},{5,1547},{6,1547}]',309332,0),(75,1565,'[{1,3986},{2,79704},{5,1595},{6,1595}]',318924,0),(76,1595,'[{1,4108},{2,82141},{5,1644},{6,1644}]',328701,0),(77,1625,'[{1,4232},{2,84624},{5,1694},{6,1694}]',338664,0),(78,1655,'[{1,4358},{2,87152},{5,1745},{6,1745}]',348812,0),(79,1685,'[{1,4487},{2,89726},{5,1796},{6,1796}]',359066,0),(80,1725,'[{1,4618},{2,92345},{5,1848},{6,1848}]',369505,1),(81,1765,'[{1,4752},{2,95020},{5,1901},{6,1901}]',380160,0),(82,1805,'[{1,4889},{2,97750},{5,1956},{6,1956}]',391130,0),(83,1845,'[{1,5028},{2,100535},{5,2012},{6,2012}]',402295,0),(84,1885,'[{1,5170},{2,103376},{5,2069},{6,2069}]',413676,0),(85,1925,'[{1,5315},{2,106272},{5,2127},{6,2127}]',425272,0),(86,1965,'[{1,5463},{2,109223},{5,2186},{6,2186}]',437083,0),(87,2005,'[{1,5613},{2,112230},{5,2246},{6,2246}]',449090,0),(88,2045,'[{1,5766},{2,115292},{5,2307},{6,2307}]',461312,0),(89,2085,'[{1,5922},{2,118409},{5,2369},{6,2369}]',473749,0),(90,2125,'[{1,6081},{2,121582},{5,2432},{6,2432}]',486402,0),(91,2165,'[{1,6242},{2,124810},{5,2497},{6,2497}]',499350,0),(92,2205,'[{1,6406},{2,128093},{5,2563},{6,2563}]',512513,0),(93,2245,'[{1,6573},{2,131432},{5,2630},{6,2630}]',525892,0),(94,2285,'[{1,6743},{2,134826},{5,2698},{6,2698}]',539486,0),(95,2325,'[{1,6915},{2,138275},{5,2767},{6,2767}]',553275,0),(96,2365,'[{1,7090},{2,141779},{5,2837},{6,2837}]',567279,0),(97,2405,'[{1,7268},{2,145339},{5,2908},{6,2908}]',581499,0),(98,2445,'[{1,7449},{2,148954},{5,2980},{6,2980}]',595934,0),(99,2485,'[{1,7633},{2,152624},{5,3053},{6,3053}]',610584,0),(100,2535,'[{1,7819},{2,156350},{5,3128},{6,3128}]',625530,1),(101,2585,'[{1,8009},{2,160141},{5,3204},{6,3204}]',640721,0),(102,2635,'[{1,8202},{2,163997},{5,3281},{6,3281}]',656137,0),(103,2685,'[{1,8398},{2,167918},{5,3359},{6,3359}]',671778,0),(104,2735,'[{1,8597},{2,171904},{5,3439},{6,3439}]',687744,0),(105,2785,'[{1,8800},{2,175955},{5,3520},{6,3520}]',703955,0),(106,2835,'[{1,9006},{2,180071},{5,3602},{6,3602}]',720391,0),(107,2885,'[{1,9215},{2,184252},{5,3686},{6,3686}]',737152,0),(108,2935,'[{1,9427},{2,188498},{5,3771},{6,3771}]',754138,0),(109,2985,'[{1,9643},{2,192809},{5,3857},{6,3857}]',771369,0),(110,3035,'[{1,9862},{2,197186},{5,3945},{6,3945}]',788926,0),(111,3085,'[{1,10084},{2,201628},{5,4034},{6,4034}]',806708,0),(112,3135,'[{1,10309},{2,206135},{5,4124},{6,4124}]',824715,0),(113,3185,'[{1,10538},{2,210707},{5,4215},{6,4215}]',842967,0),(114,3235,'[{1,10770},{2,215344},{5,4308},{6,4308}]',861544,0),(115,3285,'[{1,11005},{2,220046},{5,4402},{6,4402}]',880346,0),(116,3335,'[{1,11243},{2,224813},{5,4497},{6,4497}]',899373,0),(117,3385,'[{1,11485},{2,229645},{5,4594},{6,4594}]',918745,0),(118,3435,'[{1,11730},{2,234542},{5,4692},{6,4692}]',938342,0),(119,3485,'[{1,11978},{2,239504},{5,4791},{6,4791}]',958164,0),(120,3550,'[{1,12229},{2,244531},{5,4892},{6,4892}]',978311,1),(121,3615,'[{1,12484},{2,249633},{5,4994},{6,4994}]',998713,0),(122,3680,'[{1,12743},{2,254810},{5,5098},{6,5098}]',1019470,0),(123,3745,'[{1,13006},{2,260062},{5,5203},{6,5203}]',1040482,0),(124,3810,'[{1,13272},{2,265389},{5,5310},{6,5310}]',1061829,0),(125,3875,'[{1,13542},{2,270791},{5,5418},{6,5418}]',1083431,0),(126,3940,'[{1,13816},{2,276267},{5,5528},{6,5528}]',1105387,0),(127,4005,'[{1,14094},{2,281818},{5,5639},{6,5639}]',1127598,0),(128,4070,'[{1,14375},{2,287444},{5,5752},{6,5752}]',1150144,0),(129,4135,'[{1,14660},{2,293145},{5,5866},{6,5866}]',1172945,0),(130,4200,'[{1,14949},{2,298921},{5,5982},{6,5982}]',1196101,0),(131,4265,'[{1,15242},{2,304772},{5,6099},{6,6099}]',1219512,0),(132,4330,'[{1,15538},{2,310697},{5,6218},{6,6218}]',1243257,0),(133,4395,'[{1,15838},{2,316697},{5,6338},{6,6338}]',1267257,0),(134,4460,'[{1,16142},{2,322772},{5,6460},{6,6460}]',1291612,0),(135,4540,'[{1,16449},{2,328922},{5,6583},{6,6583}]',1316202,0),(136,4620,'[{1,16760},{2,335147},{5,6707},{6,6707}]',1341047,0),(137,4700,'[{1,17075},{2,341447},{5,6833},{6,6833}]',1366247,0),(138,4780,'[{1,17394},{2,347821},{5,6960},{6,6960}]',1391701,0),(139,4860,'[{1,17716},{2,354270},{5,7089},{6,7089}]',1417490,0),(140,4940,'[{1,18042},{2,360794},{5,7219},{6,7219}]',1443534,1),(141,5020,'[{1,18372},{2,367403},{5,7351},{6,7351}]',1469943,0),(142,5100,'[{1,18707},{2,374096},{5,7485},{6,7485}]',1496736,0),(143,5180,'[{1,19046},{2,380874},{5,7621},{6,7621}]',1523894,0),(144,5260,'[{1,19389},{2,387737},{5,7758},{6,7758}]',1551317,0),(145,5340,'[{1,19736},{2,394684},{5,7897},{6,7897}]',1579104,0),(146,5420,'[{1,20088},{2,401716},{5,8038},{6,8038}]',1607276,0),(147,5500,'[{1,20444},{2,408832},{5,8180},{6,8180}]',1635712,0),(148,5580,'[{1,20804},{2,416033},{5,8324},{6,8324}]',1664513,0),(149,5660,'[{1,21168},{2,423319},{5,8470},{6,8470}]',1693679,0),(150,5740,'[{1,21537},{2,430689},{5,8617},{6,8617}]',1723129,0),(151,5820,'[{1,21910},{2,438144},{5,8766},{6,8766}]',1752944,0),(152,5900,'[{1,22287},{2,445683},{5,8917},{6,8917}]',1783123,0),(153,5980,'[{1,22668},{2,453307},{5,9069},{6,9069}]',1813567,0),(154,6060,'[{1,23053},{2,461016},{5,9223},{6,9223}]',1844376,0),(155,6140,'[{1,23443},{2,468809},{5,9379},{6,9379}]',1875569,0),(156,6220,'[{1,23837},{2,476687},{5,9537},{6,9537}]',1907127,0),(157,6300,'[{1,24235},{2,484649},{5,9696},{6,9696}]',1938949,0),(158,6380,'[{1,24637},{2,492696},{5,9857},{6,9857}]',1971136,0),(159,6460,'[{1,25044},{2,500828},{5,10020},{6,10020}]',2003708,0),(160,6555,'[{1,25455},{2,509044},{5,10184},{6,10184}]',2036544,1),(161,6650,'[{1,25871},{2,517355},{5,10350},{6,10350}]',2069775,0),(162,6745,'[{1,26291},{2,525760},{5,10518},{6,10518}]',2103380,0),(163,6840,'[{1,26716},{2,534259},{5,10688},{6,10688}]',2137379,0),(164,6935,'[{1,27146},{2,542853},{5,10860},{6,10860}]',2171773,0),(165,7030,'[{1,27580},{2,551541},{5,11034},{6,11034}]',2206541,0),(166,7125,'[{1,28019},{2,560323},{5,11210},{6,11210}]',2241703,0),(167,7220,'[{1,28463},{2,569200},{5,11388},{6,11388}]',2277260,0),(168,7315,'[{1,28912},{2,578171},{5,11567},{6,11567}]',2313111,0),(169,7410,'[{1,29365},{2,587236},{5,11748},{6,11748}]',2349336,0),(170,7505,'[{1,29823},{2,596396},{5,11931},{6,11931}]',2385956,0),(171,7600,'[{1,30286},{2,605650},{5,12116},{6,12116}]',2422970,0),(172,7695,'[{1,30753},{2,614999},{5,12303},{6,12303}]',2460359,0),(173,7790,'[{1,31225},{2,624442},{5,12492},{6,12492}]',2498142,0),(174,7885,'[{1,31702},{2,633979},{5,12683},{6,12683}]',2536319,0),(175,7980,'[{1,32184},{2,643611},{5,12876},{6,12876}]',2574891,0),(176,8075,'[{1,32670},{2,653337},{5,13071},{6,13071}]',2613837,0),(177,8170,'[{1,33161},{2,663157},{5,13267},{6,13267}]',2653077,0),(178,8265,'[{1,33657},{2,673072},{5,13465},{6,13465}]',2692712,0),(179,8360,'[{1,34157},{2,683081},{5,13665},{6,13665}]',2732721,0),(180,8470,'[{1,34662},{2,693184},{5,13867},{6,13867}]',2773124,1),(181,8580,'[{1,35172},{2,703392},{5,14071},{6,14071}]',2813932,0),(182,8690,'[{1,35688},{2,713704},{5,14277},{6,14277}]',2855164,0),(183,8800,'[{1,36209},{2,724120},{5,14485},{6,14485}]',2896800,0),(184,8910,'[{1,36735},{2,734640},{5,14695},{6,14695}]',2938840,0),(185,9020,'[{1,37266},{2,745264},{5,14907},{6,14907}]',2981284,0),(186,9130,'[{1,37802},{2,755992},{5,15122},{6,15122}]',3024232,0),(187,9240,'[{1,38344},{2,766824},{5,15339},{6,15339}]',3067604,0),(188,9350,'[{1,38891},{2,777760},{5,15558},{6,15558}]',3111380,0),(189,9460,'[{1,39443},{2,788801},{5,15779},{6,15779}]',3155561,0),(190,9570,'[{1,40000},{2,799946},{5,16002},{6,16002}]',3200146,0),(191,9680,'[{1,40562},{2,811195},{5,16227},{6,16227}]',3245135,0),(192,9790,'[{1,41130},{2,822548},{5,16454},{6,16454}]',3290548,0),(193,9900,'[{1,41703},{2,834005},{5,16683},{6,16683}]',3336365,0),(194,10010,'[{1,42281},{2,845566},{5,16914},{6,16914}]',3382586,0),(195,10120,'[{1,42864},{2,857231},{5,17147},{6,17147}]',3429211,0),(196,10230,'[{1,43452},{2,869000},{5,17382},{6,17382}]',3476240,0),(197,10340,'[{1,44046},{2,880874},{5,17619},{6,17619}]',3523694,0),(198,10450,'[{1,44645},{2,892852},{5,17859},{6,17859}]',3571652,0),(199,10560,'[{1,45249},{2,904934},{5,18101},{6,18101}]',3620014,0),(200,10670,'[{1,45858},{2,917120},{5,18345},{6,18345}]',3668780,1),(201,10780,'[{1,46473},{2,929420},{5,18591},{6,18591}]',3717980,0),(202,10890,'[{1,47094},{2,941834},{5,18839},{6,18839}]',3767614,0),(203,11000,'[{1,47720},{2,954362},{5,19090},{6,19090}]',3817762,0),(204,11110,'[{1,48352},{2,967004},{5,19343},{6,19343}]',3868344,0),(205,11220,'[{1,48990},{2,979759},{5,19598},{6,19598}]',3919359,0),(206,11330,'[{1,49633},{2,992628},{5,19855},{6,19855}]',3970788,0),(207,11440,'[{1,50282},{2,1005611},{5,20115},{6,20115}]',4022751,0),(208,11550,'[{1,50937},{2,1018708},{5,20377},{6,20377}]',4075148,0),(209,11660,'[{1,51598},{2,1031919},{5,20641},{6,20641}]',4127979,0),(210,11770,'[{1,52264},{2,1045244},{5,20907},{6,20907}]',4181224,0),(211,11880,'[{1,52936},{2,1058683},{5,21176},{6,21176}]',4235003,0),(212,11990,'[{1,53614},{2,1072236},{5,21447},{6,21447}]',4289216,0),(213,12100,'[{1,54297},{2,1085903},{5,21720},{6,21720}]',4343843,0),(214,12210,'[{1,54986},{2,1099683},{5,21996},{6,21996}]',4399003,0),(215,12320,'[{1,55681},{2,1113577},{5,22274},{6,22274}]',4454597,0),(216,12430,'[{1,56381},{2,1127585},{5,22554},{6,22554}]',4510605,0),(217,12540,'[{1,57087},{2,1141707},{5,22836},{6,22836}]',4567047,0),(218,12650,'[{1,57799},{2,1155943},{5,23121},{6,23121}]',4624023,0),(219,12760,'[{1,58516},{2,1170293},{5,23408},{6,23408}]',4681413,0),(220,12870,'[{1,59239},{2,1184757},{5,23697},{6,23697}]',4739237,1),(221,12980,'[{1,59968},{2,1199344},{5,23989},{6,23989}]',4797604,0),(222,13090,'[{1,60704},{2,1214055},{5,24283},{6,24283}]',4856435,0),(223,13200,'[{1,61446},{2,1228890},{5,24580},{6,24580}]',4915810,0),(224,13310,'[{1,62194},{2,1243848},{5,24879},{6,24879}]',4975628,0),(225,13420,'[{1,62948},{2,1258930},{5,25181},{6,25181}]',5035990,0),(226,13530,'[{1,63708},{2,1274136},{5,25485},{6,25485}]',5096796,0),(227,13640,'[{1,64474},{2,1289465},{5,25792},{6,25792}]',5158145,0),(228,13750,'[{1,65247},{2,1304918},{5,26101},{6,26101}]',5219958,0),(229,13860,'[{1,66026},{2,1320495},{5,26413},{6,26413}]',5282315,0),(230,13970,'[{1,66811},{2,1336195},{5,26727},{6,26727}]',5345115,0),(231,14080,'[{1,67602},{2,1352019},{5,27043},{6,27043}]',5408359,0),(232,14190,'[{1,68399},{2,1367967},{5,27362},{6,27362}]',5472147,0),(233,14300,'[{1,69203},{2,1384038},{5,27683},{6,27683}]',5536398,0),(234,14410,'[{1,70013},{2,1400233},{5,28007},{6,28007}]',5601193,0),(235,14520,'[{1,70829},{2,1416551},{5,28333},{6,28333}]',5666431,0),(236,14630,'[{1,71651},{2,1432993},{5,28662},{6,28662}]',5732213,0),(237,14740,'[{1,72479},{2,1449559},{5,28993},{6,28993}]',5798439,0),(238,14850,'[{1,73313},{2,1466248},{5,29327},{6,29327}]',5865208,0),(239,14960,'[{1,74154},{2,1483061},{5,29663},{6,29663}]',5932441,0),(240,0,'[{1,75001},{2,1499998},{5,30002},{6,30002}]',6000218,1);
/*!40000 ALTER TABLE `base_talisman_lv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_talisman_skills`
--

DROP TABLE IF EXISTS `base_talisman_skills`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_talisman_skills` (
  `skill_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能id',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能解锁等级',
  PRIMARY KEY (`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='法宝技能表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_talisman_skills`
--

LOCK TABLES `base_talisman_skills` WRITE;
/*!40000 ALTER TABLE `base_talisman_skills` DISABLE KEYS */;
INSERT INTO `base_talisman_skills` VALUES (16000001,1),(16000002,21),(16000003,41),(16000004,61),(16000005,91);
/*!40000 ALTER TABLE `base_talisman_skills` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_talisman_star`
--

DROP TABLE IF EXISTS `base_talisman_star`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_talisman_star` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '化形id',
  `star` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '星数',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '升星消耗',
  `combat` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战力增加',
  `attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '属性',
  PRIMARY KEY (`id`,`star`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='法宝化形升星表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_talisman_star`
--

LOCK TABLES `base_talisman_star` WRITE;
/*!40000 ALTER TABLE `base_talisman_star` DISABLE KEYS */;
INSERT INTO `base_talisman_star` VALUES (1,0,'[{0,24030001,1}]',33500,'[{1,515},{2,10300},{5,129},{6,129},{203,100}]'),(1,1,'[{0,24030001,1}]',60500,'[{1,930},{2,18600},{5,233},{6,233},{203,200}]'),(1,2,'[{0,24030001,2}]',96940,'[{1,1491},{2,29820},{5,373},{6,373},{203,300}]'),(1,3,'[{0,24030001,4}]',142140,'[{1,2186},{2,43720},{5,547},{6,547},{203,400}]'),(1,4,'[{0,24030001,6}]',196780,'[{1,3027},{2,60540},{5,757},{6,757},{203,550}]'),(1,5,'[{0,24030001,8}]',261520,'[{1,4023},{2,80460},{5,1006},{6,1006},{203,700}]'),(2,0,'[{0,24030002,1}]',41780,'[{1,642},{2,12840},{5,161},{6,161},{50,100}]'),(2,1,'[{0,24030002,1}]',75240,'[{1,1156},{2,23120},{5,290},{6,290},{50,200}]'),(2,2,'[{0,24030002,2}]',120260,'[{1,1849},{2,36980},{5,463},{6,463},{50,300}]'),(2,3,'[{0,24030002,4}]',176160,'[{1,2709},{2,54180},{5,678},{6,678},{50,400}]'),(2,4,'[{0,24030002,6}]',243760,'[{1,3749},{2,74980},{5,938},{6,938},{50,550}]'),(2,5,'[{0,24030002,8}]',323880,'[{1,4982},{2,99640},{5,1246},{6,1246},{50,700}]'),(3,0,'[{0,24030003,1}]',53740,'[{1,828},{2,16560},{5,207},{6,207},{51,100}]'),(3,1,'[{0,24030003,1}]',96680,'[{1,1491},{2,29820},{5,373},{6,373},{51,200}]'),(3,2,'[{0,24030003,2}]',154700,'[{1,2386},{2,47720},{5,597},{6,597},{51,300}]'),(3,3,'[{0,24030003,4}]',226680,'[{1,3496},{2,69920},{5,875},{6,875},{51,400}]'),(3,4,'[{0,24030003,6}]',313740,'[{1,4838},{2,96760},{5,1211},{6,1211},{51,550}]'),(3,5,'[{0,24030003,8}]',416920,'[{1,6429},{2,128580},{5,1609},{6,1609},{51,700}]'),(4,0,'[{0,24030004,1}]',65740,'[{1,1013},{2,20260},{5,253},{6,253},{27,100}]'),(4,1,'[{0,24030004,1}]',118300,'[{1,1824},{2,36480},{5,456},{6,456},{27,200}]'),(4,2,'[{0,24030004,2}]',189280,'[{1,2918},{2,58360},{5,730},{6,730},{27,300}]'),(4,3,'[{0,24030004,4}]',277380,'[{1,4276},{2,85520},{5,1070},{6,1070},{27,400}]'),(4,4,'[{0,24030004,6}]',383900,'[{1,5918},{2,118360},{5,1481},{6,1481},{27,550}]'),(4,5,'[{0,24030004,8}]',510040,'[{1,7864},{2,157280},{5,1968},{6,1968},{27,700}]'),(5,0,'[{0,24030005,1}]',73760,'[{1,1137},{2,22740},{5,284},{6,284},{28,100}]'),(5,1,'[{0,24030005,1}]',132740,'[{1,2046},{2,40920},{5,511},{6,511},{28,200}]'),(5,2,'[{0,24030005,2}]',212340,'[{1,3274},{2,65480},{5,818},{6,818},{28,300}]'),(5,3,'[{0,24030005,4}]',311100,'[{1,4797},{2,95940},{5,1199},{6,1199},{28,400}]'),(5,4,'[{0,24030005,6}]',430480,'[{1,6638},{2,132760},{5,1659},{6,1659},{28,550}]'),(5,5,'[{0,24030005,8}]',571960,'[{1,8820},{2,176400},{5,2205},{6,2205},{28,700}]'),(6,0,'[{0,24030006,1}]',81680,'[{1,1260},{2,25200},{5,315},{6,315},{9,100}]'),(6,1,'[{0,24030006,1}]',147120,'[{1,2268},{2,45360},{5,567},{6,567},{9,200}]'),(6,2,'[{0,24030006,2}]',235300,'[{1,3629},{2,72580},{5,907},{6,907},{9,300}]'),(6,3,'[{0,24030006,4}]',344760,'[{1,5317},{2,106340},{5,1329},{6,1329},{9,400}]'),(6,4,'[{0,24030006,6}]',477100,'[{1,7358},{2,147160},{5,1839},{6,1839},{9,550}]'),(6,5,'[{0,24030006,8}]',633920,'[{1,9777},{2,195540},{5,2444},{6,2444},{9,700}]'),(7,0,'[{0,24030007,1}]',105740,'[{1,1630},{2,32600},{5,408},{6,408},{10,100}]'),(7,1,'[{0,24030007,1}]',190280,'[{1,2934},{2,58680},{5,734},{6,734},{10,200}]'),(7,2,'[{0,24030007,2}]',304420,'[{1,4694},{2,93880},{5,1174},{6,1174},{10,300}]'),(7,3,'[{0,24030007,4}]',446080,'[{1,6878},{2,137560},{5,1720},{6,1720},{10,400}]'),(7,4,'[{0,24030007,6}]',617340,'[{1,9518},{2,190360},{5,2380},{6,2380},{10,550}]'),(7,5,'[{0,24030007,8}]',820320,'[{1,12647},{2,252940},{5,3162},{6,3162},{10,700}]');
/*!40000 ALTER TABLE `base_talisman_star` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_talk`
--

DROP TABLE IF EXISTS `base_talk`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_talk` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `content` text NOT NULL COMMENT '对话内容@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1908478 DEFAULT CHARSET=utf8 COMMENT='对话';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_talk`
--

LOCK TABLES `base_talk` WRITE;
/*!40000 ALTER TABLE `base_talk` DISABLE KEYS */;
INSERT INTO `base_talk` VALUES (9805,'[[[\"npc\",\"嘘小点声，这是绝密行动。\"]]]'),(9928,'[[[\"npc\",\"\",\"0\"],[\"trigger\",\"触发任务\",\"100010\"]]]'),(9929,'[[[\"npc\",\"\",\"0\"],[\"finish\",\"完成任务\",\"100010\"]]]'),(9932,'[[[\"role\",\"你的这柄剑真不错！\",\"0\"],[\"finish\",\"完成任务\",\"10000101\"]]]'),(9933,'[[[\"npc\",\"你！你不就是刚刚把本公...本小姐推下来的蠢货吗！\",\"0\"],[\"trigger\",\"触发任务\",\"10000101\"]]]'),(9941,'[[[\"npc\",\"一转任务1接取\",\"10006\"],[\"trigger\",\"触发任务\",\"1\"]]]'),(9942,'[[[\"npc\",\"一转任务1完成\",\"10006\"],[\"finish\",\"完成任务\",\"1\"]]]'),(9943,'[[[\"npc\",\"一转任务2接取\",\"10006\"],[\"trigger\",\"触发任务\",\"2\"]]]'),(9944,'[[[\"npc\",\"一转任务2完成\",\"10006\"],[\"finish\",\"完成任务\",\"2\"]]]'),(9945,'[[[\"npc\",\"对话内容\",\"10006\"],[\"trigger\",\"触发任务\",\"3\"]]]'),(9946,'[[[\"npc\",\"对话内容\",\"10006\"],[\"finish\",\"完成任务\",\"3\"]]]'),(9947,'[[[\"npc\",\"二转任务2\",\"10006\"],[\"trigger\",\"触发任务\",\"4\"]]]'),(9948,'[[[\"npc\",\"二转任务2\",\"10006\"],[\"finish\",\"完成任务\",\"4\"]]]'),(9949,'[[[\"npc\",\"三转任务1\",\"10006\"],[\"trigger\",\"触发任务\",\"5\"]]]'),(9950,'[[[\"npc\",\"对话内容\",\"10006\"],[\"finish\",\"完成任务\",\"5\"]]]'),(9951,'[[[\"npc\",\"三转任务2\",\"10006\"],[\"trigger\",\"触发任务\",\"6\"]]]'),(9952,'[[[\"npc\",\"对话内容\",\"10006\"],[\"finish\",\"完成任务\",\"6\"]]]'),(9953,'[[[\"npc\",\"公会要发展壮大，离不开大家的共同努力！每10环公会任务还会有特殊阶段奖励！加油吧！\",\"0\"],[\"trigger\",\"触发任务\",\"10000200\"]]]'),(9954,'[[[\"npc\",\"干的不错，我们又变强了！\",\"0\"],[\"finish\",\"完成任务\",\"10000200\"]]]'),(9955,'[[[\"npc\",\"终于解决了这个大麻烦！\",\"0\"],[\"trigger\",\"触发任务\",\"10000400\"]]]'),(9957,'[[[\"npc\",\"等等，这群怪模怪样的大叔是什么时候窜出来的？\",\"0\"],[\"trigger\",\"触发任务\",\"10000500\"]]]'),(9958,'[[[\"npc\",\"真是不看不中用的家伙！\",\"0\"],[\"finish\",\"完成任务\",\"10000500\"]]]'),(9959,'[[[\"npc\",\"你是聋子吗！都让你不要盯着我这幅脸看啦！\",\"0\"],[\"trigger\",\"触发任务\",\"10050\"]]]'),(9960,'[[[\"npc\",\"这难道是？没错，这就是我最讨厌的大蒜！\",\"0\"],[\"finish\",\"完成任务\",\"10050\"]]]'),(9961,'[[[\"npc\",\"都怪你！我才会被刚刚那群蜜蜂咬成这个样子。\",\"0\"],[\"trigger\",\"触发任务\",\"10000700\"]]]'),(9962,'[[[\"npc\",\"呜呜··呜呜··这么丑，怎么去见人啊··\",\"0\"],[\"finish\",\"完成任务\",\"10000700\"]]]'),(9963,'[[[\"npc\",\"希望消肿蒜能管用，只能去采几个试一试了\",\"0\"],[\"trigger\",\"触发任务\",\"10000800\"]]]'),(9964,'[[[\"npc\",\"谁...谁都...不...不许碰俺的“宝贝”！\",\"0\"],[\"finish\",\"完成任务\",\"10000800\"]]]'),(9965,'[[[\"npc\",\"没有...蛋...蛋蛋...俺也不活啦！\",\"0\"],[\"trigger\",\"触发任务\",\"10000900\"]]]'),(9966,'[[[\"npc\",\"坏...坏家伙都...都被赶跑啦？\",\"0\"],[\"finish\",\"完成任务\",\"10000900\"]]]'),(9967,'[[[\"npc\",\"你把..把俺的蛋蛋找回来，俺...俺就告诉你离开的路。俺在下面的平台等...等你。\",\"0\"],[\"trigger\",\"触发任务\",\"10001000\"]]]'),(9968,'[[[\"npc\",\"俺...俺的蛋...蛋蛋都回来啦！\",\"0\"],[\"finish\",\"完成任务\",\"10001000\"]]]'),(9969,'[[[\"npc\",\"别怕，按照俺给你的标记往下跳就行...\",\"0\"],[\"trigger\",\"触发任务\",\"10001200\"]]]'),(9970,'[[[\"npc\",\"你们这群土贼！赶快给我站住啊！不然我...我就开抢啦！\",\"0\"],[\"finish\",\"完成任务\",\"10001200\"]]]'),(9971,'[[[\"npc\",\"把你们引来的麻烦清除之前甭想逃走！\",\"0\"],[\"trigger\",\"触发任务\",\"10001300\"]]]'),(9972,'[[[\"npc\",\"我是爱开玩笑，可我枪可不爱开玩笑！\",\"0\"],[\"finish\",\"完成任务\",\"10001300\"]]]'),(9973,'[[[\"npc\",\"看来我们又解决了一个大麻烦！\",\"0\"],[\"finish\",\"完成任务\",\"10000400\"]]]'),(9974,'[[[\"npc\",\"你看上去也没这么坏！\",\"0\"],[\"trigger\",\"触发任务\",\"10001500\"]]]'),(9975,'[[[\"npc\",\"跳舞能够强身健体，但是出来扰民就是你的不对啦！\",\"0\"],[\"finish\",\"完成任务\",\"10001500\"]]]'),(9976,'[[[\"npc\",\"好吃懒做的士兵总在我睡着偷我的面包，真是岂有此理！\",\"0\"],[\"trigger\",\"触发任务\",\"10001600\"]]]'),(9977,'[[[\"npc\",\"解决了这个偷听我们说话的家伙，你就从后面的小道离开吧！\",\"0\"],[\"finish\",\"完成任务\",\"10001600\"]]]'),(9978,'[[[\"npc\",\"哈哈哈，算你厉害！下午茶就由你来埋单吧。\",\"0\"],[\"trigger\",\"触发任务\",\"100040\"]]]'),(9980,'[[[\"npc\",\"\",\"0\"],[\"trigger\",\"触发任务\",\"10130\"]]]'),(9981,'[[[\"npc\",\"嘘！别说话，我正在进行一项秘密的工作。\",\"0\"],[\"finish\",\"完成任务\",\"10130\"]]]'),(9982,'[[[\"npc\",\"小飞贼太多啦！\",\"0\"],[\"trigger\",\"触发任务\",\"1\"]]]'),(9983,'[[[\"npc\",\"好疼，我是怎么到这来的！\",\"99999\"],[\"trigger_and_finish\",\"触发并完成任务\",\"10000\"]]]'),(9984,'[[[\"role\",\"我的小命总算保住了！你...你没事吧！\",\"0\"],[\"trigger\",\"触发任务\",\"10000000\"]]]'),(9987,'[[[\"npc\",\"还好我们跑得快，没想到帝国这么快就追了上来！咦，你的武器呢？\",\"0\"],[\"finish\",\"完成任务\",\"10000000\"]]]'),(9988,'[[[\"npc\",\"你就是拯救了蘑菇林的英雄！？比我想象中的要弱不禁风呢！神殿的路就在前面，不过怪物已经盘踞在附近，请务必小心！\",\"100510\"],[\"finish\",\"完成任务\",\"10001700\"]]]'),(9998,'[[[\"npc\",\"哟~你就是拯救了蘑菇林的那位外乡人吗？年轻就是好啊~欢迎来到森林神殿！\",\"100601\"],[\"finish\",\"完成任务\",\"10002000\"]]]'),(10000,'[[[\"npc\",\"这殿外的树林有一群捣乱的熊族，你去鹿琪儿那里打听一下情报吧！\",\"100601\"],[\"finish\",\"完成任务\",\"10002100\"]]]'),(10002,'[[[\"role\",\"你就是长老预言的那个外乡人吗？看起来不太可靠的样子，算了，熊族就在殿外的树林里，去证明你的能耐吧！\",\"100602\"],[\"finish\",\"完成任务\",\"10002200\"]]]'),(10004,'[[[\"npc\",\"我看你三两下就把熊族搞定了~不过你看起来又不像是我们森林里的伙伴！\",\"100603\"],[\"finish\",\"完成任务\",\"10002300\"]]]'),(10008,'[[[\"npc\",\"唉？原来你就是长老预言的外乡人吗？怪不得那么厉害，如果是你的话一定可以帮我找到辉星石的！\",\"100603\"],[\"finish\",\"完成任务\",\"10002400\"]]]'),(10010,'[[[\"npc\",\"这不就是传说中的辉星石吗？难道……难道你就是预言的外乡人？太好了~我总算是可以回家了！\",\"100604\"],[\"finish\",\"完成任务\",\"10002500\"]]]'),(10012,'[[[\"npc\",\"根据当年女王下达的戒令，我被放逐在此，直到带着辉星石的人到来，我的罪过才能被赦免，否则我永远无法回到我的家乡！\",\"100604\"],[\"finish\",\"完成任务\",\"10002600\"]]]'),(10014,'[[[\"npc\",\"嘿嘿，年轻人，你身上的味道让我很在意，噢~让我猜猜，这一定是那个闪耀着星辰光芒的石头！\",\"100605\"],[\"finish\",\"完成任务\",\"10002700\"]]]'),(10016,'[[[\"npc\",\"啊~~我梦寐以求的辉星石，能够成为不老不死存在的触媒！交出来！快给我交出来！！\",\"100605\"],[\"finish\",\"完成任务\",\"10002800\"]]]'),(10018,'[[[\"npc\",\"哎？这是……辉星石！！长老的预言成真了！要快点交给女王才行！\",\"100602\"],[\"finish\",\"完成任务\",\"10002900\"]]]'),(10020,'[[[\"npc\",\"慢着，擅闯神殿可是死罪！没有女王的命名不许通行！\",\"100606\"],[\"finish\",\"完成任务\",\"10003000\"]]]'),(10022,'[[[\"npc\",\"我聆听了月神的旨意，知道会有一名外乡人带着辉星石来到神殿，却没想到是如此鲁莽之人~\",\"100610\"],[\"finish\",\"完成任务\",\"10003100\"]]]'),(10024,'[[[\"role\",\"但是辉星石是我辈先祖遗留下来的东西，还请你交还予我，相应的我不会阻拦你进出神殿，你可以随意探索，找寻你要的答案~\",\"100610\"],[\"finish\",\"完成任务\",\"10003200\"]]]'),(10026,'[[[\"npc\",\"神殿东边的树林百花繁盛，勇者可以尽情观赏哦~\",\"100607\"],[\"finish\",\"完成任务\",\"10003300\"]]]'),(10028,'[[[\"npc\",\"感谢勇者相救，那群妖精太小气了，不就是几个破水晶吗？\",\"100608\"],[\"finish\",\"完成任务\",\"10003400\"]]]'),(10030,'[[[\"npc\",\"那群狡猾的哥布林会趁人不注意就偷袭的，我觉得你还是先下手为强比较好~\",\"100608\"],[\"finish\",\"完成任务\",\"10003500\"]]]'),(10032,'[[[\"npc\",\"嗯？这位年轻人~你……你知道现在是什么时代了吗？嗯……这个问法有点奇怪，我的意思是你知道现在的精灵女王叫什么吗？\",\"100609\"],[\"finish\",\"完成任务\",\"10003600\"]]]'),(10040,'[[[\"npc\",\"吼吼吼~想不到那个小机灵鬼现在都当上女王了，哎呀~这样看来已经过去好几百年了，我这都熬成老骨头了，不知道回去之后小机灵鬼还认不认得我了~\",\"100609\"],[\"finish\",\"完成任务\",\"10004300\"]]]'),(10042,'[[[\"npc\",\"看你弱不禁风的，想不到意外地能打啊！俺是十分佩服！\",\"100612\"],[\"finish\",\"完成任务\",\"10004400\"]]]'),(10044,'[[[\"npc\",\"俺一直有个夙愿，就是能够亲手打败精灵族的战士，但是俺的族群已经没落了，孤军奋战的话俺就是找死，希望你能帮助我~\",\"100612\"],[\"finish\",\"完成任务\",\"10004500\"]]]'),(10048,'[[[\"npc\",\"救命啊！！谁来救救我！！\",\"100611\"],[\"finish\",\"完成任务\",\"10004700\"]]]'),(10050,'[[[\"npc\",\"多谢勇者出手相救，顺便问一下……我……我能跟在你后面吗？我找不到回神殿的路了~\",\"100611\"],[\"finish\",\"完成任务\",\"10004800\"]]]'),(10052,'[[[\"npc\",\"天色不早了，顺道采些木材回去吧！\",\"100609\"],[\"finish\",\"完成任务\",\"10004900\"]]]'),(10054,'[[[\"npc\",\"哈~勇者欢迎回来！\",\"100607\"],[\"finish\",\"完成任务\",\"10005100\"]]]'),(10056,'[[[\"npc\",\"不知为何，神殿的战士突然就向寡人袭来，所幸勇者及时相助~\",\"100610\"],[\"finish\",\"完成任务\",\"10005100\"]]]'),(10058,'[[[\"npc\",\"神殿的禁卫：人马战士，如果你能够打到他的话，也许就能知晓更多关于神殿的秘密~\",\"100610\"],[\"finish\",\"完成任务\",\"10005200\"]]]'),(10060,'[[[\"role\",\"看来你已经在这里找到答案了，很遗憾我不能告诉你这之后的事情了，因为我的预言就只是到此为止了，你的未来要靠你来开拓了！\",\"100601\"],[\"finish\",\"完成任务\",\"10005300\"]]]'),(10062,'[[[\"npc\",\"年轻人，如果你不是执着于宝藏的话，我劝你还是赶紧离开，这片海域可是最为冷酷无情的！\",\"101001\"],[\"finish\",\"完成任务\",\"10005400\"]]]'),(10064,'[[[\"npc\",\"真是不知天高地厚的臭小子，算了，反正与我无关，想送死的话告诉你也无妨，沿着水母桥一直往前走吧！\",\"101001\"],[\"finish\",\"完成任务\",\"10005500\"]]]'),(10066,'[[[\"npc\",\"我看你三两下就把怪物打趴下了，看来你来历不小啊~\",\"101002\"],[\"finish\",\"完成任务\",\"10005600\"]]]'),(10068,'[[[\"npc\",\"原来你是为了对抗帝国军，四处搜集辉星石啊~\",\"101002\"],[\"finish\",\"完成任务\",\"10005700\"]]]'),(10070,'[[[\"npc\",\"好久没看到新的人类面孔了，你也是来陪我玩的吗？\",\"101003\"],[\"finish\",\"完成任务\",\"10005800\"]]]'),(10072,'[[[\"npc\",\"这些哥布林专干些偷摸拐骗的勾当，幸亏你教训了他们~\",\"101003\"],[\"finish\",\"完成任务\",\"10005900\"]]]'),(10074,'[[[\"npc\",\"平时都是别人委托我办事，但是这次不小心接了个大买卖，有点棘手，如果你肯分摊的话，报酬也是有的哦！\",\"101005\"],[\"finish\",\"完成任务\",\"10006001\"]]]'),(10076,'[[[\"npc\",\"不错嘛！看来我小看你了，干脆把这个任务也委托给你把~\",\"101005\"],[\"finish\",\"完成任务\",\"10006002\"]]]'),(10078,'[[[\"npc\",\"喏~这是给你的酬劳，以后还有这样的委托的话，我一定再找你哦~\",\"101005\"],[\"finish\",\"完成任务\",\"10006200\"]]]'),(10080,'[[[\"npc\",\"嘿~好久没看到生面孔啦！\",\"101004\"],[\"finish\",\"完成任务\",\"10006003\"]]]'),(10082,'[[[\"npc\",\"当心那些狡诈的水布林~\",\"101004\"],[\"finish\",\"完成任务\",\"10006004\"]]]'),(10084,'[[[\"npc\",\"打架最消耗体力了，去采些海蓝果，补充下体力吧~\",\"101004\"],[\"finish\",\"完成任务\",\"10006005\"]]]'),(10086,'[[[\"npc\",\"你这就要走了吗？有朝一日我要到你们生活的陆地上看看~\",\"101003\"],[\"finish\",\"完成任务\",\"10006600\"]]]'),(10088,'[[[\"npc\",\"这里之所以叫失落之海，是因为这里的传说中记载了一种失落的宝藏~\",\"101006\"],[\"finish\",\"完成任务\",\"10006700\"]]]'),(10090,'[[[\"npc\",\"传说中是这样记载的：光芒划破长空，直坠深渊，唯有被选召之人，才能唤起昔日的希望。但是直到今天也没人知道那究竟是什么~\",\"101006\"],[\"finish\",\"完成任务\",\"10006800\"]]]'),(10092,'[[[\"npc\",\"勇者你也在寻找失落的宝藏吗？但那只是传说中记载的东西，是真是假都没人知道的东西啊~\",\"101007\"],[\"finish\",\"完成任务\",\"10006900\"]]]'),(10094,'[[[\"npc\",\"要是能够找到些许线索就好了，遥遥无期的感觉太糟糕了~\",\"101007\"],[\"finish\",\"完成任务\",\"10007000\"]]]'),(10096,'[[[\"npc\",\"哦哦~我看你身手不凡，想必是有什么特殊的目的吧？什么？你还要到前方探索，这可是本喵都未曾涉足的领域啊~\",\"101008\"],[\"finish\",\"完成任务\",\"10007100\"]]]'),(10098,'[[[\"npc\",\"呜呜呜~我的爱人被一群娜迦掳走了，该如何是好！\",\"101009\"],[\"finish\",\"完成任务\",\"10007200\"]]]'),(10100,'[[[\"npc\",\"感谢勇者救命之恩！\",\"101010\"],[\"finish\",\"完成任务\",\"10007300\"]]]'),(10102,'[[[\"npc\",\"前路险途，还请勇者多多保重！\",\"101010\"],[\"finish\",\"完成任务\",\"10007400\"]]]'),(10104,'[[[\"npc\",\"吼~那家伙还躲在我们之前的沉船那里吗！真是没用的家伙~这片海域已经被一只怪物霸占了，想要重新出海是不可能的了！\",\"101011\"],[\"finish\",\"完成任务\",\"10007500\"]]]'),(10106,'[[[\"npc\",\"哈哈哈！这怪物在你面前简直不堪一击，我得去叫上那个胆小鬼，怎么样？有兴趣和我一起出海吗！\",\"101011\"],[\"finish\",\"完成任务\",\"10007600\"]]]'),(10108,'[[[\"npc\",\"光芒划破长空……你就是那个寻找着失落宝藏的勇者吗！\",\"101012\"],[\"finish\",\"完成任务\",\"10007700\"]]]'),(10110,'[[[\"npc\",\"经过幻境的试炼有找到答案了吗？辉星石？失落的宝藏原来是辉星石啊！\",\"101012\"],[\"finish\",\"完成任务\",\"10007800\"]]]'),(10112,'[[[\"npc\",\"辉星石会指引我们前往下一个目的地的，我们出发吧！\",\"101012\"],[\"finish\",\"完成任务\",\"10007900\"]]]'),(10114,'[[[\"npc\",\"操控天气的怪物还在山顶，请务必小心！\",\"100705\"],[\"finish\",\"完成任务\",\"10008000\"]]]'),(10116,'[[[\"npc\",\"想不到我们还能再次见面呢~想要怪物情报的话，就先帮我一个忙吧！\",\"100706\"],[\"finish\",\"完成任务\",\"10008100\"]]]'),(10118,'[[[\"npc\",\"好吧~按照约定，我告诉你情报：怪物就在这雪峰的山顶，不过最近都是沉睡的状态~\",\"100706\"],[\"finish\",\"完成任务\",\"10008200\"]]]'),(10120,'[[[\"npc\",\"嘿嘿嘿~站住！要去哪儿呢？再往上走就是可怕的怪物了！\",\"100707\"],[\"finish\",\"完成任务\",\"10008300\"]]]'),(10122,'[[[\"npc\",\"我的天~你居然要去找那个怪物的麻烦~我只能祝你好运了！\",\"100707\"],[\"finish\",\"完成任务\",\"10008400\"]]]'),(10124,'[[[\"npc\",\"您一定就是那位无畏的勇者，我就知道您一定会打败怪物的！\",\"100709\"],[\"finish\",\"完成任务\",\"10008500\"]]]'),(10126,'[[[\"npc\",\"这就是传说中的辉星石？\",\"100709\"],[\"finish\",\"完成任务\",\"10008600\"]]]'),(10127,'[[[\"npc\",\"总算回来了！\",\"0\"],[\"trigger\",\"触发任务\",\"10008700\"]]]'),(10128,'[[[\"npc\",\"时间不等人，马上开始新的征程吧。\",\"0\"],[\"finish\",\"完成任务\",\"10008700\"]]]'),(10129,'[[[\"npc\",\"护民官说找不到你们就要打断我的腿。\",\"0\"],[\"trigger\",\"触发任务\",\"10008800\"]]]'),(10130,'[[[\"npc\",\"好事不出门，坏事传千里。\",\"0\"],[\"finish\",\"完成任务\",\"1008800\"]]]'),(10131,'[[[\"npc\",\"呢哆说她会有办法帮你们摆脱追捕。\",\"0\"],[\"trigger\",\"触发任务\",\"10008900\"]]]'),(10132,'[[[\"npc\",\"她就在老地方等你。\",\"0\"],[\"finish\",\"完成任务\",\"10008900\"]]]'),(10133,'[[[\"npc\",\"你们总算来了，帝国军最近正在疯狂搜索你们的踪迹。\",\"0\"],[\"trigger\",\"触发任务\",\"10009000\"]]]'),(10134,'[[[\"npc\",\"据说是一个女巫泄露了你们的行踪。\",\"0\"],[\"finish\",\"完成任务\",\"10009000\"]]]'),(10135,'[[[\"npc\",\"在此之前，最好先提升一下我们的实力。\",\"0\"],[\"trigger\",\"触发任务\",\"10009100\"]]]'),(10136,'[[[\"npc\",\"你又更上一层楼啦！\",\"0\"],[\"finish\",\"完成任务\",\"10009100\"]]]'),(10137,'[[[\"npc\",\"前面还有更多艰难万险，你准备好了吗？\",\"0\"],[\"trigger\",\"触发任务\",\"10009200\"]]]'),(10138,'[[[\"npc\",\"我果然没有看错你。\",\"0\"],[\"finish\",\"完成任务\",\"10009200\"]]]'),(10139,'[[[\"npc\",\"飞船马上就要起飞了，快！\",\"0\"],[\"trigger\",\"触发任务\",\"10009300\"]]]'),(10140,'[[[\"npc\",\"我总有种不详的预感。\",\"0\"],[\"finish\",\"完成任务\",\"10009300\"]]]'),(10141,'[[[\"npc\",\"我们...我们居然坠机了，帝国的火炮果然厉害。\",\"0\"],[\"trigger\",\"触发任务\",\"10009400\"]]]'),(10142,'[[[\"npc\",\"大家都没事吧？\",\"0\"],[\"finish\",\"完成任务\",\"10009400\"]]]'),(10143,'[[[\"npc\",\"怪兽来啦！我的腿，呜呜呜~\",\"0\"],[\"trigger\",\"触发任务\",\"10009500\"]]]'),(10144,'[[[\"npc\",\"还好有你解围，要不然我真不知道该怎么办才好。\",\"0\"],[\"finish\",\"完成任务\",\"10009500\"]]]'),(10145,'[[[\"npc\",\"谢天谢地，我还活着！\",\"0\"],[\"trigger\",\"触发任务\",\"10009600\"]]]'),(10146,'[[[\"npc\",\"让我们一起行动吧!\",\"0\"],[\"finish\",\"完成任务\",\"10009600\"]]]'),(10147,'[[[\"npc\",\"注意！危险又来了！\",\"0\"],[\"trigger\",\"触发任务\",\"10009700\"]]]'),(10148,'[[[\"npc\",\"刚刚真的好险，你没事吧。\",\"0\"],[\"finish\",\"完成任务\",\"10009700\"]]]'),(10149,'[[[\"npc\",\"我现在还感觉头晕晕的，你还好吗？\",\"0\"],[\"trigger\",\"触发任务\",\"10009800\"]]]'),(10150,'[[[\"npc\",\"接下我们怎么走！\",\"0\"],[\"finish\",\"完成任务\",\"10009800\"]]]'),(10151,'[[[\"npc\",\"我感觉眼前有无数只小鸟在飞来飞去。\",\"0\"],[\"trigger\",\"触发任务\",\"10009900\"]]]'),(10152,'[[[\"npc\",\"谢谢你，我又重新恢复活力啦！\",\"0\"],[\"finish\",\"完成任务\",\"10009900\"]]]'),(10153,'[[[\"npc\",\"听！是狼群的声音，而且很近。\",\"0\"],[\"trigger\",\"触发任务\",\"10010000\"]]]'),(10154,'[[[\"npc\",\"我就知道你一定行的。\",\"0\"],[\"finish\",\"完成任务\",\"10010000\"]]]'),(10155,'[[[\"npc\",\"休息，休息一会。\",\"0\"],[\"trigger\",\"触发任务\",\"10010100\"]]]'),(10156,'[[[\"npc\",\"好了，我们去找海妮薇吧。\",\"0\"],[\"finish\",\"完成任务\",\"10010100\"]]]'),(10157,'[[[\"npc\",\"这是什么声音，我的耳朵快要承受不住啦。\",\"0\"],[\"trigger\",\"触发任务\",\"10010200\"]]]'),(10158,'[[[\"npc\",\"这么大的狼我还是第一次见过。\",\"0\"],[\"finish\",\"完成任务\",\"10010200\"]]]'),(10159,'[[[\"npc\",\"那边有个发光的东西，会是海妮薇落下的吗？\",\"0\"],[\"trigger\",\"触发任务\",\"10010300\"]]]'),(10160,'[[[\"npc\",\"嗯，可以断定她就在前面了。\",\"0\"],[\"finish\",\"完成任务\",\"10010300\"]]]'),(10161,'[[[\"npc\",\"到这来，我发现了坠船的地点啦。\",\"0\"],[\"trigger\",\"触发任务\",\"10010400\"]]]'),(10162,'[[[\"npc\",\"没想到帝国的火炮这么凶残，哆嗦知道了会骂死我的。\",\"0\"],[\"finish\",\"完成任务\",\"10010400\"]]]'),(10163,'[[[\"npc\",\"很接近了，就是这里。\",\"0\"],[\"trigger\",\"触发任务\",\"10010500\"]]]'),(10164,'[[[\"npc\",\"嘘，你听到了，奇怪的声音。\",\"0\"],[\"finish\",\"完成任务\",\"10010500\"]]]'),(10165,'[[[\"npc\",\"身亡的船员都变成了怪物，我们有危险了！\",\"0\"],[\"trigger\",\"触发任务\",\"10010600\"]]]'),(10166,'[[[\"npc\",\"愿他们的灵魂能够安息。\",\"0\"],[\"finish\",\"完成任务\",\"10010600\"]]]'),(10167,'[[[\"npc\",\"船长呢？我刚刚没有在这里找到他。\",\"0\"],[\"trigger\",\"触发任务\",\"10010700\"]]]'),(10168,'[[[\"npc\",\"不！帕尔船长！\",\"0\"],[\"finish\",\"完成任务\",\"10010700\"]]]'),(10169,'[[[\"npc\",\"事到如今我们只能够携手对抗他了。\",\"0\"],[\"trigger\",\"触发任务\",\"10010800\"]]]'),(10170,'[[[\"npc\",\"愿你的灵魂在天堂得到安息。\",\"0\"],[\"finish\",\"完成任务\",\"10010800\"]]]'),(10171,'[[[\"npc\",\"你们来啦！我好害怕，我差点以为我又要离开这个世界了。\",\"0\"],[\"trigger\",\"触发任务\",\"10010900\"]]]'),(10172,'[[[\"npc\",\"呜呜！！大家都怎么都躺在地上不动了。\",\"0\"],[\"finish\",\"完成任务\",\"10010900\"]]]'),(10173,'[[[\"npc\",\"帝国就这么想要我的命吗！我该怎么办！\",\"0\"],[\"trigger\",\"触发任务\",\"10011000\"]]]'),(10174,'[[[\"npc\",\"我该怎么办才好！\",\"0\"],[\"finish\",\"完成任务\",\"10011000\"]]]'),(10175,'[[[\"npc\",\"啊！都是我不好才会害得大家...\",\"0\"],[\"trigger\",\"触发任务\",\"10011100\"]]]'),(10176,'[[[\"npc\",\"谢谢你一直陪在我身边，我会好好的。\",\"0\"],[\"finish\",\"完成任务\",\"10011100\"]]]'),(10177,'[[[\"npc\",\"你们居然还有时间谈情说爱！\",\"0\"],[\"trigger\",\"触发任务\",\"10011200\"]]]'),(10178,'[[[\"npc\",\"真不知道呢哆为什么会喜欢上你们这群家伙。\",\"0\"],[\"finish\",\"完成任务\",\"10011200\"]]]'),(10179,'[[[\"npc\",\"你比看上去厉害一些嘛，可跟我比还差得远呢！\",\"0\"],[\"trigger\",\"触发任务\",\"10011300\"]]]'),(10180,'[[[\"npc\",\"不服我们就继续啊！\",\"0\"],[\"finish\",\"完成任务\",\"10011300\"]]]'),(10181,'[[[\"npc\",\"一个爱哭的倒霉鬼，天啊，我居然会跟你们在一起。\",\"0\"],[\"trigger\",\"触发任务\",\"10011400\"]]]'),(10182,'[[[\"npc\",\"难道我有说错吗？\",\"0\"],[\"finish\",\"完成任务\",\"10011400\"]]]'),(10183,'[[[\"npc\",\"太过分了！我们一定不能输给哆呢！\",\"0\"],[\"trigger\",\"触发任务\",\"10011500\"]]]'),(10184,'[[[\"npc\",\"这个任务就交给你吧！\",\"0\"],[\"finish\",\"完成任务\",\"10011500\"]]]'),(10185,'[[[\"npc\",\"好戏登场了，快看前面！\",\"0\"],[\"trigger\",\"触发任务\",\"10011600\"]]]'),(10186,'[[[\"npc\",\"我才刚刚开始热身呢。\",\"0\"],[\"finish\",\"完成任务\",\"10011600\"]]]'),(10187,'[[[\"npc\",\"其实你也没有看上去这么差劲。\",\"0\"],[\"trigger\",\"触发任务\",\"10011700\"]]]'),(10188,'[[[\"npc\",\"之前是我不好，我向你道歉。\",\"0\"],[\"finish\",\"完成任务\",\"10011700\"]]]'),(10189,'[[[\"npc\",\"我们得赶快离开这个该死的鬼地方！\",\"0\"],[\"trigger\",\"触发任务\",\"10011800\"]]]'),(10190,'[[[\"npc\",\"你准备好了吗！\",\"0\"],[\"finish\",\"完成任务\",\"10011800\"]]]'),(10191,'[[[\"npc\",\"这里的魔法波动很适合召唤传送门。\",\"0\"],[\"trigger\",\"触发任务\",\"10011900\"]]]'),(10192,'[[[\"npc\",\"在此之前请好好保护好我。\",\"0\"],[\"finish\",\"完成任务\",\"10011900\"]]]'),(10193,'[[[\"npc\",\"又有怪我朝我们这边扑过来了。\",\"0\"],[\"trigger\",\"触发任务\",\"10012000\"]]]'),(10194,'[[[\"npc\",\"刚才真是千钧一发。\",\"0\"],[\"finish\",\"完成任务\",\"10012000\"]]]'),(10195,'[[[\"npc\",\"我可是费力九牛二虎之力才赶上你们。\",\"0\"],[\"trigger\",\"触发任务\",\"10012100\"]]]'),(10196,'[[[\"npc\",\"希望这些补给对你有所帮助。\",\"0\"],[\"finish\",\"完成任务\",\"10012100\"]]]'),(10197,'[[[\"npc\",\"你好！陌生人，对你们的我早有耳闻。\",\"0\"],[\"trigger\",\"触发任务\",\"10012200\"]]]'),(10198,'[[[\"npc\",\"我们现在的处境非常危险。\",\"0\"],[\"finish\",\"完成任务\",\"10012200\"]]]'),(10199,'[[[\"npc\",\"纵然千难万险，也阻挡不了我们前进的步伐！\",\"0\"],[\"trigger\",\"触发任务\",\"10012300\"]]]'),(10200,'[[[\"npc\",\"我说的对吗！\",\"0\"],[\"finish\",\"完成任务\",\"10012300\"]]]'),(10201,'[[[\"npc\",\"要是换做普通人怕是早就尿裤子了吧！\",\"0\"],[\"trigger\",\"触发任务\",\"10012400\"]]]'),(10202,'[[[\"npc\",\"能与你并肩作战是我的荣幸\",\"0\"],[\"finish\",\"完成任务\",\"10012400\"]]]'),(10203,'[[[\"npc\",\"这次的怪物比以往的都要强大！\",\"0\"],[\"trigger\",\"触发任务\",\"10012500\"]]]'),(10204,'[[[\"npc\",\"干的漂亮,说好了，下次一定一起喝一杯。\",\"0\"],[\"finish\",\"完成任务\",\"10012500\"]]]'),(10205,'[[[\"npc\",\"什么鬼！究竟是什么可怕的怪物。\",\"0\"],[\"trigger\",\"触发任务\",\"10012600\"]]]'),(10206,'[[[\"npc\",\"真是可喜可贺啊。\",\"0\"],[\"finish\",\"完成任务\",\"10012600\"]]]'),(10207,'[[[\"npc\",\"虽然我们是敌人，但是你们精神依然值得我敬佩。\",\"0\"],[\"trigger\",\"触发任务\",\"10012700\"]]]'),(10208,'[[[\"npc\",\"下次见面我可不会手下留情。\",\"0\"],[\"finish\",\"完成任务\",\"10012700\"]]]'),(10209,'[[[\"npc\",\"又有新的敌人出现了！\",\"0\"],[\"trigger\",\"触发任务\",\"10012800\"]]]'),(10210,'[[[\"npc\",\"刚才好险，我差点就没命了。\",\"0\"],[\"finish\",\"完成任务\",\"10012800\"]]]'),(10211,'[[[\"npc\",\"束手就擒吧！说不定皇帝会开恩的！\",\"0\"],[\"trigger\",\"触发任务\",\"10012900\"]]]'),(10212,'[[[\"npc\",\"真是无畏的抵抗！\",\"0\"],[\"finish\",\"完成任务\",\"10012900\"]]]'),(10213,'[[[\"npc\",\"魔法的能量正在涌动。\",\"0\"],[\"trigger\",\"触发任务\",\"10013000\"]]]'),(10214,'[[[\"npc\",\"你注意到了吗？\",\"0\"],[\"finish\",\"完成任务\",\"10013000\"]]]'),(10215,'[[[\"npc\",\"都这样了，你们还要顽抗吗？\",\"0\"],[\"trigger\",\"触发任务\",\"10013100\"]]]'),(10216,'[[[\"npc\",\"准备好接受新的挑战了吗？\",\"0\"],[\"finish\",\"完成任务\",\"10013100\"]]]'),(10217,'[[[\"npc\",\"这股巨大的魔法波动远远超乎了我们的想象。\",\"0\"],[\"trigger\",\"触发任务\",\"10013200\"]]]'),(10218,'[[[\"npc\",\"我的双腿现在还在发抖。\",\"0\"],[\"finish\",\"完成任务\",\"10013200\"]]]'),(10219,'[[[\"npc\",\"我们一定能行的，坚持住！\",\"0\"],[\"trigger\",\"触发任务\",\"10013300\"]]]'),(10220,'[[[\"npc\",\"在坚持一会传送门就启动啦！\",\"0\"],[\"finish\",\"完成任务\",\"10013300\"]]]'),(10221,'[[[\"npc\",\"我们虽然为各自的势力效力，可你们的精神依旧让我钦佩与感动！\",\"0\"],[\"trigger\",\"触发任务\",\"10013400\"]]]'),(10222,'[[[\"npc\",\"可是派出暗杀这种手段实在是太卑劣了！\",\"0\"],[\"finish\",\"完成任务\",\"10013400\"]]]'),(10223,'[[[\"npc\",\"杀手9号的仇，今天就由我来报。\",\"0\"],[\"trigger\",\"触发任务\",\"10013500\"]]]'),(10224,'[[[\"npc\",\"这...这不可能...\",\"0\"],[\"finish\",\"完成任务\",\"10013500\"]]]'),(10225,'[[[\"npc\",\"我们这算是虎口脱险吗？\",\"0\"],[\"trigger\",\"触发任务\",\"10013600\"]]]'),(10226,'[[[\"npc\",\"传送门已经彻底启动了。\",\"0\"],[\"finish\",\"完成任务\",\"10013600\"]]]'),(10227,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10013700\"]]]'),(10228,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1013700\"]]]'),(10229,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10013800\"]]]'),(10230,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1013800\"]]]'),(10231,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10013900\"]]]'),(10232,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1013900\"]]]'),(10233,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10014000\"]]]'),(10234,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"10140000\"]]]'),(10235,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10014100\"]]]'),(10236,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1014100\"]]]'),(10237,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10014200\"]]]'),(10238,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1014200\"]]]'),(10239,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10014300\"]]]'),(10240,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1014300\"]]]'),(10241,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10014400\"]]]'),(10242,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1014400\"]]]'),(10243,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10014500\"]]]'),(10244,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1014500\"]]]'),(10245,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10014600\"]]]'),(10246,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1014600\"]]]'),(10247,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10014700\"]]]'),(10248,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1014700\"]]]'),(10249,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10014800\"]]]'),(10250,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1014800\"]]]'),(10251,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10014900\"]]]'),(10252,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1014900\"]]]'),(10253,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10015000\"]]]'),(10254,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1015000\"]]]'),(10255,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10015100\"]]]'),(10256,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1015100\"]]]'),(10257,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10015200\"]]]'),(10258,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1015200\"]]]'),(10259,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10015300\"]]]'),(10260,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1015300\"]]]'),(10261,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10015400\"]]]'),(10262,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1015400\"]]]'),(10263,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10015500\"]]]'),(10264,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1015500\"]]]'),(10265,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10015600\"]]]'),(10266,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1015600\"]]]'),(10267,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10015700\"]]]'),(10268,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1015700\"]]]'),(10269,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10015800\"]]]'),(10270,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1015800\"]]]'),(10271,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10015900\"]]]'),(10272,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1015900\"]]]'),(10273,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10016000\"]]]'),(10274,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1016000\"]]]'),(10275,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10016100\"]]]'),(10276,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1016100\"]]]'),(10277,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10016200\"]]]'),(10278,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1016200\"]]]'),(10279,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10016300\"]]]'),(10280,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1016300\"]]]'),(10281,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10016400\"]]]'),(10282,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1016400\"]]]'),(10283,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10016500\"]]]'),(10284,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1016500\"]]]'),(10285,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10016600\"]]]'),(10286,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1016600\"]]]'),(10287,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10016700\"]]]'),(10288,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1016700\"]]]'),(10289,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10016800\"]]]'),(10290,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1016800\"]]]'),(10291,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10016900\"]]]'),(10292,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1016900\"]]]'),(10293,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10017000\"]]]'),(10294,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1001700\"]]]'),(10295,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10017100\"]]]'),(10296,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1017100\"]]]'),(10297,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10017200\"]]]'),(10298,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1017200\"]]]'),(10299,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10017300\"]]]'),(10300,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1017300\"]]]'),(10301,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10017400\"]]]'),(10302,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1017400\"]]]'),(10303,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10017500\"]]]'),(10304,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1017500\"]]]'),(10305,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10017600\"]]]'),(10306,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1017600\"]]]'),(10307,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10017700\"]]]'),(10308,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1017700\"]]]'),(10309,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10017800\"]]]'),(10310,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1017800\"]]]'),(10311,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10017900\"]]]'),(10312,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1017900\"]]]'),(10313,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10018000\"]]]'),(10314,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1018000\"]]]'),(10315,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10018100\"]]]'),(10316,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1018100\"]]]'),(10317,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10018200\"]]]'),(10318,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1018200\"]]]'),(10319,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10018300\"]]]'),(10320,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1018300\"]]]'),(10321,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10018400\"]]]'),(10322,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1018400\"]]]'),(10323,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10018500\"]]]'),(10324,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1018500\"]]]'),(10325,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10018600\"]]]'),(10326,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1018600\"]]]'),(10327,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10018700\"]]]'),(10328,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1018700\"]]]'),(10329,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10018800\"]]]'),(10330,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1018800\"]]]'),(10331,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10018900\"]]]'),(10332,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1018900\"]]]'),(10333,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10019000\"]]]'),(10334,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1019000\"]]]'),(10335,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10019100\"]]]'),(10336,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1019100\"]]]'),(10337,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10019200\"]]]'),(10338,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1019200\"]]]'),(10339,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10019300\"]]]'),(10340,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1019300\"]]]'),(10341,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10019400\"]]]'),(10342,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1019400\"]]]'),(10343,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10019500\"]]]'),(10344,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1019500\"]]]'),(10345,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10019600\"]]]'),(10346,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1019600\"]]]'),(10347,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10019700\"]]]'),(10348,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1019700\"]]]'),(10349,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10019800\"]]]'),(10350,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1019800\"]]]'),(10351,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10019900\"]]]'),(10352,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1019900\"]]]'),(10353,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10020000\"]]]'),(10354,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"10020000\"]]]'),(10355,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10020100\"]]]'),(10356,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1020100\"]]]'),(10357,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10020200\"]]]'),(10358,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1020200\"]]]'),(10359,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10020300\"]]]'),(10360,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1020300\"]]]'),(10361,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10020400\"]]]'),(10362,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1020400\"]]]'),(10363,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10020500\"]]]'),(10364,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1020500\"]]]'),(10365,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10020600\"]]]'),(10366,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1020600\"]]]'),(10367,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10020700\"]]]'),(10368,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1020700\"]]]'),(10369,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10020800\"]]]'),(10370,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1020800\"]]]'),(10371,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10020900\"]]]'),(10372,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1020900\"]]]'),(10373,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10021000\"]]]'),(10374,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1021000\"]]]'),(10375,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10021100\"]]]'),(10376,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1021100\"]]]'),(10377,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10021200\"]]]'),(10378,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1021200\"]]]'),(10379,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10021300\"]]]'),(10380,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1021300\"]]]'),(10381,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10021400\"]]]'),(10382,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1021400\"]]]'),(10383,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10021500\"]]]'),(10384,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1021500\"]]]'),(10385,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10021600\"]]]'),(10386,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1021600\"]]]'),(10387,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10021700\"]]]'),(10388,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1021700\"]]]'),(10389,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10021800\"]]]'),(10390,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1021800\"]]]'),(10391,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10021900\"]]]'),(10392,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1021900\"]]]'),(10393,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10022000\"]]]'),(10394,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1022000\"]]]'),(10395,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10022100\"]]]'),(10396,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1022100\"]]]'),(10397,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10022200\"]]]'),(10398,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1022200\"]]]'),(10399,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10022300\"]]]'),(10400,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1022300\"]]]'),(10401,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10022400\"]]]'),(10402,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1022400\"]]]'),(10403,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10022500\"]]]'),(10404,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1022500\"]]]'),(10405,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10022600\"]]]'),(10406,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1022600\"]]]'),(10407,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10022700\"]]]'),(10408,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1022700\"]]]'),(10409,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10022800\"]]]'),(10410,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1022800\"]]]'),(10411,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10022900\"]]]'),(10412,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1022900\"]]]'),(10413,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"100230\"]]]'),(10414,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1023000\"]]]'),(10415,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10023100\"]]]'),(10416,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1023100\"]]]'),(10417,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10023200\"]]]'),(10418,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1023200\"]]]'),(10419,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10023300\"]]]'),(10420,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1023300\"]]]'),(10421,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10023400\"]]]'),(10422,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1023400\"]]]'),(10423,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10023500\"]]]'),(10424,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1023500\"]]]'),(10425,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10023600\"]]]'),(10426,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1023600\"]]]'),(10427,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10023700\"]]]'),(10428,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1023700\"]]]'),(10429,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10023800\"]]]'),(10430,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1023800\"]]]'),(10431,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10023900\"]]]'),(10432,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1023900\"]]]'),(10433,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10024000\"]]]'),(10434,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1024000\"]]]'),(10435,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10024100\"]]]'),(10436,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1024100\"]]]'),(10437,'[[[\"npc\",\"这是你应得的奖励，请收下。\",\"0\"],[\"trigger\",\"触发任务\",\"10024200\"]]]'),(10438,'[[[\"npc\",\"收下你的奖励吧，这是你应得的。\",\"0\"],[\"finish\",\"完成任务\",\"1024200\"]]]'),(10779,'[[[\"npc\",\"四转任务接取\",\"10006\"],[\"trigger\",\"触发任务\",\"7\"]]]'),(10780,'[[[\"npc\",\"完成四转任务\",\"10006\"],[\"finish\",\"完成任务\",\"7\"]]]'),(10782,'[[[\"npc\",\"嘿嘿！你有能力完成这些挑战吗？\"]]]'),(10783,'[[[\"npc\",\"会长说了，再不好好干活的话就要被拉到最阴森最黑暗的矿井里去挖煤！所以你知道该怎么做了吗？\"]]]'),(10784,'[[[\"\"]]]'),(11078,'[[[\"npc\",\"你再看我！我可是要生气的哟！\"]]]'),(11079,'[[[\"npc\",\"我怎么会这么倒霉呢！\"]]]'),(11080,'[[[\"npc\",\"你都搞定了吗？\"]]]'),(11081,'[[[\"npc\",\"不！我的脸蛋！\"]]]'),(11082,'[[[\"npc\",\"对话内容\",\"0\"],[\"trigger\",\"触发任务\",\"999999\"]]]'),(11083,'[[[\"npc\",\"对话内容\",\"0\"],[\"finish\",\"完成任务\",\"999999\"]]]'),(11900,'[[[\"npc\",\"只要你能出的起价格，我就能给你找来任何你想要的商品！\"]]]'),(11901,'[[[\"\"]]]'),(20000,'[[[\"npc\",\"魔力已逝永不回，往事只能回味。\"]]]'),(20001,'[[[\"npc\",\"小点声，你不怕把对面的强盗引过来吗？\"]]]'),(20002,'[[[\"npc\",\"哈哈哈！我就知道我们一定能够冲破难关。\"]]]'),(20003,'[[[\"npc\",\"以前我总是嘲笑别人笑起来像个300斤的胖子，现在终于总算轮到我了。\"]]]'),(20004,'[[[\"npc\",\"从前有个人，他有一个蛋...\"]]]'),(20005,'[[[\"npc\",\"我才不会把我的蛋交给你的，别想！\"]]]'),(20006,'[[[\"npc\",\"蛋蛋是我的全部，有我便有蛋，无蛋便无我。\"]]]'),(20007,'[[[\"npc\",\"我要让那些不懂礼数的家伙和我一样去守大门！\"]]]'),(20008,'[[[\"npc\",\"虽然老婆让我不要随便生气，可我还是忍不住！\"]]]'),(20009,'[[[\"npc\",\"小点声！这里到处都是帝国的走狗们。\"]]]'),(20010,'[[[\"npc\",\"我的魔法面包已经断货了，你再怎么哄我也没用。\"]]]'),(20011,'[[[\"npc\",\"不知道为什么，每次我坐船的时候肚子总是感觉怪怪的。\"]]]'),(20012,'[[[\"npc\",\"我又忘记我们之前聊到哪了？对了，我其实是晕船的。\"]]]'),(20013,'[[[\"npc\",\"哼！如果下次谁让我做那艘破船的话，我就让他尝尝火球术的厉害。\"]]]'),(20014,'[[[\"npc\",\"我可是星灵神枪手，只要我的枪不走火的话！\"]]]'),(20015,'[[[\"npc\",\"红蘑菇...绿蘑菇...蓝蘑菇...\"]]]'),(20016,'[[[\"npc\",\"我对天发誓，以后绝对不敢随便吃路边的野花...不，野蘑菇了！\"]]]'),(20017,'[[[\"npc\",\"上尉绝对不是我仕途的终点，我的目标是星辰大海！\"]]]'),(20018,'[[[\"npc\",\"此路是开！此树是我栽！想要从此过，留下买路财！\"]]]'),(20019,'[[[\"npc\",\"前辈说了，嚣张的女妖最美丽！\"]]]'),(20020,'[[[\"npc\",\"曾经有位名人说过：失败是成功它妈妈，所以我是不会放弃的。\"]]]'),(20021,'[[[\"npc\",\"别人笑我太疯癫，我笑他们看不穿。\"]]]'),(20022,'[[[\"npc\",\"老夫的老花镜去哪了？让老夫仔细找找。\"]]]'),(20023,'[[[\"npc\",\"用我们树人界有句古话来讲，你就是树途无量啊。\"]]]'),(20024,'[[[\"npc\",\"树老不中用啊，我的老腰差点就闪着了。\"]]]'),(20025,'[[[\"npc\",\"... ...\"]]]'),(20026,'[[[\"npc\",\"你没感觉到吗？这里连空气都是悲凉的。\"]]]'),(20027,'[[[\"npc\",\"我们的祖先也有参与神殿的建设，凭什么现在就流放我们暗精灵部族！\"]]]'),(20028,'[[[\"npc\",\"这地方美得让人窒息，嘬一口烟，就像梦游仙境一般~你也要来一口吗？\"]]]'),(20029,'[[[\"npc\",\"虽然我也是联合部族的一员，但我实在无法认同女王的做法！\"]]]'),(20030,'[[[\"npc\",\"曾几何时，我也是个天真浪漫的少女。\"]]]'),(20031,'[[[\"npc\",\"国破家亡的感觉，没人比我更懂这种感觉。\"]]]'),(20032,'[[[\"npc\",\"关键时候，你总能找到我。\"]]]'),(20033,'[[[\"npc\",\"对我来说，让目标停止呼吸是一种最美的享受。\"]]]'),(20034,'[[[\"npc\",\"这里让我想起来皇家庄园的场景...\"]]]'),(20035,'[[[\"npc\",\"嘿嘿，我就知道区区一个传送门是难不倒我的。\"]]]'),(20036,'[[[\"npc\",\"我也不知道为什么每次护民官大人都要拿我的开刀。\"]]]'),(20037,'[[[\"npc\",\"跟你说句实话吧，我真正的理想是做一名像贝尔一样的冒险家。\"]]]'),(20038,'[[[\"npc\",\"呜坦云堡是我出身的地方，也是久负盛名的奇迹之城。\"]]]'),(20039,'[[[\"npc\",\"嘘！你要是再这么大喊大叫的话，可就要暴露了！\"]]]'),(20040,'[[[\"npc\",\"真没想到，呜坦城居然聘用我做了荣誉守卫。\"]]]'),(20041,'[[[\"npc\",\"有什么不开心的事情，说出来让大叔我开心一下啊。\"]]]'),(20042,'[[[\"npc\",\"维持传送门的工作虽然很枯燥乏味，但是足够一家子人了。\"]]]'),(20043,'[[[\"npc\",\"维持传送门的工作虽然很枯燥乏味，但是足够一家子人了。\"]]]'),(20044,'[[[\"npc\",\"维持传送门的工作虽然很枯燥乏味，但是足够一家子人了。\"]]]'),(20045,'[[[\"npc\",\"每个人的心中都有不可描述的梦魇。\"]]]'),(20046,'[[[\"npc\",\"维持传送门的工作虽然很枯燥乏味，但是足够一家子人了。\"]]]'),(20047,'[[[\"npc\",\"维持传送门的工作虽然很枯燥乏味，但是足够一家子人了。\"]]]'),(20048,'[[[\"npc\",\"维持传送门的工作虽然很枯燥乏味，但是足够一家子人了。\"]]]'),(20049,'[[[\"npc\",\"维持传送门的工作虽然很枯燥乏味，但是足够一家子人了。\"]]]'),(20050,'[[[\"npc\",\"维持传送门的工作虽然很枯燥乏味，但是足够一家子人了。\"]]]'),(20051,'[[[\"npc\",\"我的心里只有一件事，那就是努力工作。\"]]]'),(20052,'[[[\"npc\",\"准备好进入天使护送场景了吗？里面可是危险重重喔！\"]]]'),(20053,'[[[\"npc\",\"小时候我最怕的就是黑灯瞎火的走廊，你永远不知道会有几只大老鼠在那里横冲直撞。\"]]]'),(20054,'[[[\"npc\",\"再次重申，我可不是真的熊。\"]]]'),(20055,'[[[\"npc\",\"上次被一窝蜜蜂围攻的时候，我都没有这样生气。\"]]]'),(20056,'[[[\"npc\",\"没有姐搞不定的人，临死之前你还有什么想要说的吗？\"]]]'),(20057,'[[[\"npc\",\"好戏还在后头，我一定要让那个家伙付出代价。\"]]]'),(20058,'[[[\"npc\",\"谁以后再骗我来这个黑灯瞎火的鬼地方，我就跟她没完！\"]]]'),(20059,'[[[\"npc\",\"谁以后再骗我来这个黑灯瞎火的鬼地方，我就跟她没完！\"]]]'),(20060,'[[[\"npc\",\"谁以后再骗我来这个黑灯瞎火的鬼地方，我就跟她没完！\"]]]'),(20061,'[[[\"npc\",\"该说的，我可都说了，别敬酒不吃吃罚酒。\"]]]'),(20062,'[[[\"npc\",\"该说的，我可都说了，别敬酒不吃吃罚酒。\"]]]'),(20063,'[[[\"npc\",\"该说的，我可都说了，别敬酒不吃吃罚酒。\"]]]'),(20064,'[[[\"npc\",\"女巫就这么想要我领地，我绝不屈服！\"]]]'),(20065,'[[[\"npc\",\"女巫就这么想要我领地，我绝不屈服！\"]]]'),(20066,'[[[\"npc\",\"女巫就这么想要我领地，我绝不屈服！\"]]]'),(20067,'[[[\"npc\",\"女巫就这么想要我领地，我绝不屈服！\"]]]'),(20068,'[[[\"npc\",\"女巫就这么想要我领地，我绝不屈服！\"]]]'),(20069,'[[[\"npc\",\"太好了！我们什么时候离开这个鬼地方？\"]]]'),(20070,'[[[\"npc\",\"太好了！我们什么时候离开这个鬼地方？\"]]]'),(20071,'[[[\"npc\",\"太好了！我们什么时候离开这个鬼地方？\"]]]'),(20072,'[[[\"npc\",\"是时候和女巫算总账了！\"]]]'),(20073,'[[[\"npc\",\"是时候和女巫算总账了！\"]]]'),(20074,'[[[\"npc\",\"是时候和女巫算总账了！\"]]]'),(20075,'[[[\"npc\",\"你可别欺人太甚！\"]]]'),(20076,'[[[\"npc\",\"这一刻，我不知道等了多久！\"]]]'),(20077,'[[[\"npc\",\"太好了！我们什么时候离开这个鬼地方？\"]]]'),(20078,'[[[\"npc\",\"太好了！我们什么时候离开这个鬼地方？\"]]]'),(20079,'[[[\"npc\",\"太好了！我们什么时候离开这个鬼地方？\"]]]'),(20080,'[[[\"npc\",\"太好了！我们什么时候离开这个鬼地方？\"]]]'),(20081,'[[[\"npc\",\"太好了！我们什么时候离开这个鬼地方？\"]]]'),(20082,'[[[\"npc\",\"太好了！我们什么时候离开这个鬼地方？\"]]]'),(20083,'[[[\"npc\",\"太好了！我们什么时候离开这个鬼地方？\"]]]'),(20084,'[[[\"npc\",\"太好了！我们什么时候离开这个鬼地方？\"]]]'),(20085,'[[[\"npc\",\"太好了！我们什么时候离开这个鬼地方？\"]]]'),(20086,'[[[\"npc\",\"太好了！我们什么时候离开这个鬼地方？\"]]]'),(20087,'[[[\"npc\",\"太好了！我们什么时候离开这个鬼地方？\"]]]'),(20088,'[[[\"npc\",\"太好了！我们什么时候离开这个鬼地方？\"]]]'),(20089,'[[[\"npc\",\"太好了！我们什么时候离开这个鬼地方？\"]]]'),(20090,'[[[\"npc\",\"太好了！我们什么时候离开这个鬼地方？\"]]]'),(20091,'[[[\"npc\",\"太好了！我们什么时候离开这个鬼地方？\"]]]'),(20092,'[[[\"npc\",\"太好了！我们什么时候离开这个鬼地方？\"]]]'),(20093,'[[[\"npc\",\"你轻点！我都快变成一座冰雕了。\"]]]'),(20094,'[[[\"npc\",\"你轻点！我都快变成一座冰雕了。\"]]]'),(20095,'[[[\"npc\",\"我感觉附近还有其他元素生物，千万要小心。\"]]]'),(20096,'[[[\"npc\",\"我感觉附近还有其他元素生物，千万要小心。\"]]]'),(20097,'[[[\"npc\",\"我感觉附近还有其他元素生物，千万要小心。\"]]]'),(20098,'[[[\"npc\",\"我感觉附近还有其他元素生物，千万要小心。\"]]]'),(20099,'[[[\"npc\",\"我感觉附近还有其他元素生物，千万要小心。\"]]]'),(20100,'[[[\"npc\",\"圣母在上！我发誓以后再也不敢上黑船了。\"]]]'),(20101,'[[[\"npc\",\"圣母在上！我发誓以后再也不敢上黑船了。\"]]]'),(20102,'[[[\"npc\",\"哼，谁强谁弱只要比一比才知道。\"]]]'),(20103,'[[[\"npc\",\"圣母在上！我发誓以后再也不敢上黑船了。\"]]]'),(20104,'[[[\"npc\",\"哼，谁强谁弱只要比一比才知道。\"]]]'),(20105,'[[[\"npc\",\"哼，谁强谁弱只要比一比才知道。\"]]]'),(20106,'[[[\"npc\",\"你轻点！我都快变成一座冰雕了。\"]]]'),(20107,'[[[\"npc\",\"联合部族，顾名思义就是多个部族构成的联合，一直以来都是以精灵族，哥布林，暗精灵为主，加上其他部落构成。\"]]]'),(20108,'[[[\"npc\",\"这里荒山野岭的，通讯信号都不是特别好~\"]]]'),(20109,'[[[\"npc\",\"嘿嘿，在我这般盛世美颜之下，得来全不费功夫啊~\"]]]'),(20110,'[[[\"npc\",\"没人能够逃脱我的手掌心，没人！\"]]]'),(20111,'[[[\"npc\",\"没人能够逃脱我的手掌心，没人！\"]]]'),(20112,'[[[\"npc\",\"就算战至最后一刻，也不能让污邪染指这片土地！\"]]]'),(20113,'[[[\"npc\",\"就算战至最后一刻，也不能让污邪染指这片土地！\"]]]'),(20114,'[[[\"npc\",\"你再这样明目张胆地走来走去我们可就要被发现了。\"]]]'),(20115,'[[[\"npc\",\"大哥就要有大哥的担当。\"]]]'),(20116,'[[[\"npc\",\"大哥让我好好照顾三弟。\"]]]'),(20117,'[[[\"npc\",\"什么时候我才能摆脱三弟这个头衔。\"]]]'),(20118,'[[[\"npc\",\"送信可不是一件容易的差事。\"]]]'),(20119,'[[[\"npc\",\"你再这样明目张胆地走来走去我们可就要被发现了。\"]]]'),(20120,'[[[\"npc\",\"没时间聊天了，我们还要去拯救世界对不对！\"]]]'),(20121,'[[[\"npc\",\"就算战至最后一刻，也不能让污邪染指这片土地！\"]]]'),(20122,'[[[\"npc\",\"就算战至最后一刻，也不能让污邪染指这片土地！\"]]]'),(20123,'[[[\"npc\",\"让我束手投降，还不如让我去死！\"]]]'),(20124,'[[[\"npc\",\"让我束手投降，还不如让我去死！\"]]]'),(20125,'[[[\"npc\",\"让我束手投降，还不如让我去死！\"]]]'),(20126,'[[[\"npc\",\"让我束手投降，还不如让我去死！\"]]]'),(20127,'[[[\"npc\",\"让我束手投降，还不如让我去死！\"]]]'),(20128,'[[[\"npc\",\"让我束手投降，还不如让我去死！\"]]]'),(20129,'[[[\"npc\",\"让我束手投降，还不如让我去死！\"]]]'),(20130,'[[[\"npc\",\"让我束手投降，还不如让我去死！\"]]]'),(20131,'[[[\"npc\",\"让我束手投降，还不如让我去死！\"]]]'),(20132,'[[[\"npc\",\"让我束手投降，还不如让我去死！\"]]]'),(20133,'[[[\"npc\",\"我一定要第一个找到财宝！\"]]]'),(20134,'[[[\"npc\",\"我不该独自前往这个地方的。\"]]]'),(20135,'[[[\"npc\",\"这里气氛让我感到异常的暴躁。\"]]]'),(20136,'[[[\"npc\",\"我紧张起来的时候，连我自己都感到害怕。\"]]]'),(20137,'[[[\"npc\",\"没时间聊天了，我们还要去拯救世界对不对！\"]]]'),(20138,'[[[\"npc\",\"我说一二三石头人，再不行动就要被扣分。\"]]]'),(20139,'[[[\"npc\",\"这片森林真是祥和地让人想好好地睡一个午觉~\"]]]'),(20140,'[[[\"npc\",\"闲杂人等，不得私闯！\"]]]'),(20141,'[[[\"npc\",\"坚守岗位是每个战士的职责。\"]]]'),(20142,'[[[\"npc\",\"坚守岗位是每个战士的职责。\"]]]'),(20143,'[[[\"npc\",\"生不带来，死不带去。\"]]]'),(30000,'[[[\"npc\",\"试炼就此开始吧~\",\"100602\"],[\"trigger\",\"触发任务\",\"1\"]]]'),(30001,'[[[\"npc\",\"干的不错~年轻人\",\"100602\"],[\"finish\",\"完成任务\",\"1\"]]]'),(30002,'[[[\"npc\",\"接下来的试炼会更加严峻，年轻人可不要逞强哦~\",\"100603\"],[\"trigger\",\"触发任务\",\"2\"]]]'),(30003,'[[[\"npc\",\"可不要掉以轻心哦~\",\"100604\"],[\"finish\",\"完成任务\",\"2\"]]]'),(30004,'[[[\"npc\",\"确实不能太小看你了，但是接下来的试炼如何？\",\"100605\"],[\"trigger\",\"触发任务\",\"3\"]]]'),(30005,'[[[\"npc\",\"我就知道你肯定可以的！\",\"100605\"],[\"finish\",\"完成任务\",\"3\"]]]'),(30006,'[[[\"npc\",\"最后的试炼就在眼前了，给予你最终试炼的人就在前方~\",\"100608\"],[\"trigger\",\"触发任务\",\"4\"]]]'),(30007,'[[[\"npc\",\"还差最后一步了，加油！\",\"100610\"],[\"finish\",\"完成任务\",\"4\"]]]'),(30008,'[[[\"npc\",\"准备好迎接你的最终试炼了麽？\",\"100610\"],[\"trigger\",\"触发任务\",\"5\"]]]'),(30009,'[[[\"npc\",\"充满勇气又不失实力的你，通过试炼是理所应当的事情！\",\"100610\"],[\"finish\",\"完成任务\",\"5\"]]]'),(30010,'[[[\"npc\",\"很高兴能再次见到你，让我见识下你是否准备好接受试炼了~\",\"100704\"],[\"trigger\",\"触发任务\",\"6\"]]]'),(30011,'[[[\"npc\",\"去吧~年轻人！\",\"100704\"],[\"finish\",\"完成任务\",\"6\"]]]'),(30013,'[[[\"npc\",\"你需要得到其他人的认可！\",\"100705\"],[\"finish\",\"完成任务\",\"7\"]]]'),(30014,'[[[\"npc\",\"试着去获取认可吧~\",\"100704\"],[\"trigger\",\"触发任务\",\"8\"]]]'),(30015,'[[[\"npc\",\"哦~年轻人，看来你的实力不错，要加入我的麾下吗？\",\"100705\"],[\"finish\",\"完成任务\",\"8\"]]]'),(30016,'[[[\"npc\",\"或许你可以挑战试炼了！\",\"100706\"],[\"trigger\",\"触发任务\",\"9\"]]]'),(30017,'[[[\"npc\",\"勇者~在得到我的认可之前，我将授予你试炼的资格！要接受吗？\",\"100707\"],[\"finish\",\"完成任务\",\"9\"]]]'),(30019,'[[[\"npc\",\"干得漂亮！勇者~你获得了我的认可！\",\"100708\"],[\"finish\",\"完成任务\",\"10\"]]]'),(30020,'[[[\"npc\",\"这可不是给你游山玩水的地方~\",\"100802\"],[\"trigger\",\"触发任务\",\"11\"]]]'),(30021,'[[[\"npc\",\"弱肉强食是这里的规则，想要得到认可就必须证明你的价值！\",\"100803\"],[\"finish\",\"完成任务\",\"11\"]]]'),(30022,'[[[\"npc\",\"如果你能找到些许线索的话，我或许能告诉你一些秘密~\",\"100803\"],[\"trigger\",\"触发任务\",\"12\"]]]'),(30023,'[[[\"npc\",\"时光易逝，快抓紧时间吧！\",\"100804\"],[\"finish\",\"完成任务\",\"12\"]]]'),(30024,'[[[\"npc\",\"哦哦~有实力的外乡人，看起来你很擅长解决麻烦的样子！\",\"100804\"],[\"trigger\",\"触发任务\",\"13\"]]]'),(30025,'[[[\"npc\",\"如你所愿，我就告诉你真正的试炼要在哪里进行吧~\",\"100805\"],[\"finish\",\"完成任务\",\"13\"]]]'),(30026,'[[[\"npc\",\"给点好处我的话，我说不定就把试炼的情报告诉你了~\",\"100807\"],[\"trigger\",\"触发任务\",\"14\"]]]'),(30027,'[[[\"npc\",\"试炼的秘密就在于你自身的努力呀~\",\"100808\"],[\"finish\",\"完成任务\",\"14\"]]]'),(30028,'[[[\"npc\",\"让我见识下你的真正实力吧！年轻人！\",\"100809\"],[\"trigger\",\"触发任务\",\"15\"]]]'),(30029,'[[[\"npc\",\"真是令我印象深刻，好久没看到这么厉害的勇者了！\",\"100810\"],[\"finish\",\"完成任务\",\"15\"]]]'),(30031,'[[[\"npc\",\"干得漂亮！\",\"100409\"],[\"finish\",\"完成任务\",\"16\"]]]'),(30032,'[[[\"\"]]]'),(30034,'[[[\"npc\",\"最近有一波流匪四处打劫，我们公会的一些生意也受到了影响，你赶快去清理下吧！（公会任务每达10环，会长会给予额外奖励哦！）\",\"0\"],[\"trigger\",\"触发任务\",\"60000100\"]]]'),(30035,'[[[\"npc\",\"干的不错，生意伙伴发来了感谢信，这是会长给你的奖励！\",\"0\"],[\"finish\",\"完成任务\",\"60000100\"]]]'),(30036,'[[[\"npc\",\"东部平原上的粮食最近一直丢失，你过去看看什么情况吧！要是有人作妖捣乱，你顺便收拾下！（公会任务每达10环，会长会给予额外奖励哦！）\",\"0\"],[\"trigger\",\"触发任务\",\"60000200\"]]]'),(30037,'[[[\"npc\",\"原来是这样，幸好你处理的及时！诺，这是会长的奖励，收好啦！\",\"0\"],[\"finish\",\"完成任务\",\"60000200\"]]]'),(30038,'[[[\"npc\",\"公会有成员反馈，很多护送的人到城郊密林就会失踪，你过去看看什么情况！（公会任务每达10环，会长会给予额外奖励哦！）\",\"0\"],[\"trigger\",\"触发任务\",\"60000300\"]]]'),(30039,'[[[\"npc\",\"帝国的军队太可恶，居然随便抓壮丁！接下来情况会由公会上层处理吧，你拿着奖励好好休息下吧！，\",\"0\"],[\"finish\",\"完成任务\",\"60000300\"]]]'),(30040,'[[[\"npc\",\"公会打造急需黎棘晶石，但传闻有怪兽守卫，你看看能不能战胜它！（公会任务每达10环，会长会给予额外奖励哦！）\",\"0\"],[\"trigger\",\"触发任务\",\"60000400\"]]]'),(30041,'[[[\"npc\",\"有了黎棘晶石，公会打造更厉害了！\",\"0\"],[\"finish\",\"完成任务\",\"60000400\"]]]'),(30042,'[[[\"npc\",\"会长夫人被困到罗米尔楼台上，你赶快过去救援！（公会任务每达10环，会长会给予额外奖励哦！）\",\"0\"],[\"trigger\",\"触发任务\",\"60000500\"]]]'),(30043,'[[[\"npc\",\"谢谢你救回夫人，这是会长给你的谢礼！\",\"0\"],[\"finish\",\"完成任务\",\"60000500\"]]]'),(30044,'[[[\"npc\",\"公会回收机急需材料，有多余的赶快来点！（公会任务每达10环，会长会给予额外奖励哦！）\",\"0\"],[\"trigger\",\"触发任务\",\"60000600\"]]]'),(30045,'[[[\"npc\",\"谢天谢地，又能支撑一段时间了！这是你的奖励！\",\"0\"],[\"finish\",\"完成任务\",\"60000600\"]]]'),(30046,'[[[\"npc\",\"公主发来求救信，说被一群蒙面人围攻，你赶快过去支援！（公会任务每达10环，会长会给予额外奖励哦！）\",\"0\"],[\"trigger\",\"触发任务\",\"60000700\"]]]'),(30047,'[[[\"npc\",\"公主非常感谢你，这个给你的谢礼！\",\"0\"],[\"finish\",\"完成任务\",\"60000700\"]]]'),(30048,'[[[\"npc\",\"一个人坐在这里好无聊啊，你能帮我问问有没有人和我一起下棋么！（公会任务每达10环，会长会给予额外奖励哦！）\",\"0\"],[\"trigger\",\"触发任务\",\"60000800\"]]]'),(30049,'[[[\"npc\",\"还想下棋，公会门前的草拔光了没！\",\"0\"],[\"finish\",\"完成任务\",\"60000800\"]]]'),(30050,'[[[\"npc\",\"我撞碎了人家的珐琅盘，我有点事走不开，你能替我把钱送还给他么？（公会任务每达10环，会长会给予额外奖励哦！）\",\"0\"],[\"trigger\",\"触发任务\",\"60000900\"]]]'),(30051,'[[[\"npc\",\"破了没关系，人没伤到就好！\",\"0\"],[\"finish\",\"完成任务\",\"60000900\"]]]'),(30052,'[[[\"npc\",\"听说有人生病了，公会里的兄弟姐妹要相亲相爱，你帮我问候下他吧！（公会任务每达10环，会长会给予额外奖励哦！）\",\"0\"],[\"trigger\",\"触发任务\",\"60001000\"]]]'),(30053,'[[[\"npc\",\"没事没事，我只是吃的撑到了！\",\"0\"],[\"finish\",\"完成任务\",\"60001000\"]]]'),(30054,'[[[\"npc\",\"幽暗密林里听说出现了怪兽样的东西，附近居民很担心你去看看情况！公会任务每达10环，会长会给予额外奖励哦！）\",\"0\"],[\"trigger\",\"触发任务\",\"60001100\"]]]'),(30055,'[[[\"npc\",\"原来是自己跑出来的家畜啊！虚惊一场\",\"0\"],[\"finish\",\"完成任务\",\"60001100\"]]]'),(30056,'[[[\"npc\",\"北部冰原上出现了一个神秘裂缝，听说能看到海盗王的财宝，你去探察下！（公会任务每达10环，会长会给予额外奖励哦！）\",\"0\"],[\"trigger\",\"触发任务\",\"60001200\"]]]'),(30057,'[[[\"npc\",\"原来真有，我们赶快去报告会长！\",\"0\"],[\"finish\",\"完成任务\",\"60001200\"]]]'),(30058,'[[[\"npc\",\"公会要评选最美会员，你四处问问谁想参加？（公会任务每达10环，会长会给予额外奖励哦！）\",\"0\"],[\"trigger\",\"触发任务\",\"60001300\"]]]'),(30059,'[[[\"npc\",\"这还用选，当然是我，无论在哪里我都光芒四射！\",\"0\"],[\"finish\",\"完成任务\",\"60001300\"]]]'),(30726,'[[[\"\"]]]'),(40054,'[[[\"npc\",\"我家作坊中突然闯进一伙坏人，求求你帮我赶走他们？（日常任务每10环有额外奖励哦！）\",\"0\"],[\"trigger\",\"触发任务\",\"70000100\"]]]'),(40055,'[[[\"npc\",\"非常感谢您！请您一定要收下这点谢意！\",\"0\"],[\"finish\",\"完成任务\",\"70000100\"]]]'),(40056,'[[[\"npc\",\"农庄里最近老是丢失东西，麻烦你帮我查看下，找到原因必有重谢！（日常任务每10环有额外奖励哦！）\",\"0\"],[\"trigger\",\"触发任务\",\"70000200\"]]]'),(40057,'[[[\"npc\",\"还好发现的早，要不损失更大了！\",\"0\"],[\"finish\",\"完成任务\",\"70000200\"]]]'),(40058,'[[[\"npc\",\"有人想打劫我的货物，如果你能帮我守住货物，我必有重谢！（日常任务每10环有额外奖励哦！） \",\"0\"],[\"trigger\",\"触发任务\",\"70000300\"]]]'),(40059,'[[[\"npc\",\"还好保住了，我一年的生计都在这里了！\",\"0\"],[\"finish\",\"完成任务\",\"70000300\"]]]'),(40060,'[[[\"npc\",\"暴风健身开张大吉，我们教练各个伸手矫健，不信可以任意挑战，战胜有奖！（日常任务每10环有额外奖励哦！）\",\"0\"],[\"trigger\",\"触发任务\",\"70000400\"]]]'),(40061,'[[[\"npc\",\"中介推荐的教练不靠谱，这次我亏大了！\",\"0\"],[\"finish\",\"完成任务\",\"70000400\"]]]'),(40062,'[[[\"npc\",\"我是一个邮差，但我的脚不小心崴到了，你能帮忙送下么?（日常任务每10环有额外奖励哦！）\",\"0\"],[\"trigger\",\"触发任务\",\"70000500\"]]]'),(40063,'[[[\"npc\",\"谢谢您，给我带来了爱人的书信！\",\"0\"],[\"finish\",\"完成任务\",\"70000500\"]]]'),(40064,'[[[\"npc\",\"作为暴风外送的成员，一秒都不能耽搁，你还不快送！（日常任务每10环有额外奖励哦！）\",\"0\"],[\"trigger\",\"触发任务\",\"70000600\"]]]'),(40065,'[[[\"npc\",\"最爱暴风外送，热腾腾的最好吃了！\",\"0\"],[\"finish\",\"完成任务\",\"70000600\"]]]'),(40066,'[[[\"npc\",\"我的好朋友生日快到了，你能帮我送这个礼物给他么？（日常任务每10环有额外奖励哦！）\",\"0\"],[\"trigger\",\"触发任务\",\"70000700\"]]]'),(40067,'[[[\"npc\",\"哇，礼物很漂亮！谢谢您！\",\"0\"],[\"finish\",\"完成任务\",\"70000700\"]]]'),(40068,'[[[\"npc\",\"偷偷告诉你，我发现了阿里巴巴的宝藏，和我一起去探索下吧！（日常任务每10环有额外奖励哦！）\",\"0\"],[\"trigger\",\"触发任务\",\"70000800\"]]]'),(40069,'[[[\"npc\",\"居然有怪兽，吓死我了，幸好你在！\",\"0\"],[\"finish\",\"完成任务\",\"70000800\"]]]'),(40070,'[[[\"npc\",\"货运铁路最近被堵住了，赶快和我一起去维护修理下！（日常任务每10环有额外奖励哦！）\",\"0\"],[\"trigger\",\"触发任务\",\"70000900\"]]]'),(40071,'[[[\"npc\",\"铁路畅通了，大家生意才好做！\",\"0\"],[\"finish\",\"完成任务\",\"70000900\"]]]'),(40072,'[[[\"npc\",\"每天凌晨4点，作为货商的我们就开始送货了，辛苦点但值得！（日常任务每10环有额外奖励哦！）\",\"0\"],[\"trigger\",\"触发任务\",\"70001000\"]]]'),(40073,'[[[\"npc\",\"出门在外不容易，喝点水休息下吧！\",\"0\"],[\"finish\",\"完成任务\",\"70001000\"]]]'),(40074,'[[[\"npc\",\"传说海盗王的沉船在隆德海被发现了，和我一起去探索下吧！（日常任务每10环有额外奖励哦！）\",\"0\"],[\"trigger\",\"触发任务\",\"70001100\"]]]'),(40075,'[[[\"npc\",\"啥都没有，肯定是艘假船！\",\"0\"],[\"finish\",\"完成任务\",\"70001100\"]]]'),(40076,'[[[\"npc\",\"整天在城里待着无聊，走带你去森林里呼吸下新鲜空气！（日常任务每10环有额外奖励哦！）\",\"0\"],[\"trigger\",\"触发任务\",\"70001200\"]]]'),(40077,'[[[\"npc\",\"吓死我了，以后再也去了！\",\"0\"],[\"finish\",\"完成任务\",\"70001200\"]]]'),(40080,'[[[\"\"]],[[\"\"]]]'),(500200,'[[[\"npc\",\"你居然……带着辉星石，你到底是什么人！？\",\"100710\"],[\"finish\",\"完成任务\",\"10008700\"]]]'),(500400,'[[[\"npc\",\"如果你真是传说中的勇者，那你一定可以拯救这个大陆！\",\"100710\"],[\"finish\",\"完成任务\",\"10008800\"]]]'),(500600,'[[[\"npc\",\"有什么新鲜的事，要和我分享下吗？\",\"100711\"],[\"finish\",\"完成任务\",\"10008900\"]]]'),(500800,'[[[\"npc\",\"勇者，快帮帮我！\",\"100712\"],[\"finish\",\"完成任务\",\"10009000\"]]]'),(501000,'[[[\"npc\",\"我希望这片雪原都一直和平~\",\"100712\"],[\"finish\",\"完成任务\",\"10009100\"]]]'),(501100,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10009200\"]]]'),(501200,'[[[\"npc\",\"我只记得轰隆！轰隆！的炮声，随后眼前一片漆黑！醒来以后就是这片茫茫无际的极寒之地。\",\"0\"],[\"finish\",\"完成任务\",\"10009200\"]]]'),(501300,'[[[\"npc\",\"你要是再不回来的话，我可就要变成一副名副其实的冰雕啦！\",\"0\"],[\"trigger\",\"触发任务\",\"10009300\"]]]'),(501400,'[[[\"npc\",\"你要是再不回来的话，我可要变成一座名副其实的冰雕啦！\",\"0\"],[\"finish\",\"完成任务\",\"10009300\"]]]'),(501500,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10009400\"]]]'),(501600,'[[[\"npc\",\"你听见了吗？这是暴风雪的前奏，稀里哗啦的雪砸在身上可不是闹着玩的！\",\"0\"],[\"finish\",\"完成任务\",\"10009400\"]]]'),(501700,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10009500\"]]]'),(501800,'[[[\"npc\",\"看来大家的判断是对的，我们必须马上寻找走丢的伙伴们，天知道接下来还会发生啥。\",\"0\"],[\"finish\",\"完成任务\",\"10009500\"]]]'),(501900,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10009600\"]]]'),(502000,'[[[\"npc\",\"去找零零哆吧！侦察与渗透可是他的老本行！\",\"0\"],[\"finish\",\"完成任务\",\"10009600\"]]]'),(502100,'[[[\"npc\",\"想要让大家找到我们，就得点亮身边的火堆，可我的打火棒在坠落的时候就不见了。\",\"0\"],[\"trigger\",\"触发任务\",\"10009700\"]]]'),(502200,'[[[\"npc\",\"真是太好了，大家很快就能看见我发出的信号了。\",\"0\"],[\"finish\",\"完成任务\",\"10009700\"]]]'),(502300,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10009800\"]]]'),(502400,'[[[\"npc\",\"我继续留在这里侦察，你赶快回去通知大家吧。\",\"0\"],[\"finish\",\"完成任务\",\"10009800\"]]]'),(502500,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10009900\"]]]'),(502600,'[[[\"npc\",\"这还真是冬天里的一把火啊！\",\"0\"],[\"finish\",\"完成任务\",\"10009900\"]]]'),(502700,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10010000\"]]]'),(502800,'[[[\"npc\",\"火！火！这让我想起了以前乡下冬天烤红薯的时候了...\",\"0\"],[\"finish\",\"完成任务\",\"10010000\"]]]'),(502900,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10010100\"]]]'),(503000,'[[[\"npc\",\"...(眼前这个伤痕累累的帝国士兵已经失去了意识。)\",\"0\"],[\"finish\",\"完成任务\",\"10010100\"]]]'),(503100,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10010200\"]]]'),(503200,'[[[\"npc\",\"你...你们...有本事就来啊！老子的枪可...不长眼...\",\"0\"],[\"finish\",\"完成任务\",\"10010200\"]]]'),(503300,'[[[\"npc\",\"你...你们...有本事就来啊！我的枪可...不长眼...\",\"0\"],[\"trigger\",\"触发任务\",\"10010300\"]]]'),(503400,'[[[\"npc\",\"我没听错吧！你居然想要去救追杀我们的帝国士兵！你简直疯了！\",\"0\"],[\"finish\",\"完成任务\",\"10010300\"]]]'),(503500,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10010400\"]]]'),(503600,'[[[\"npc\",\"啊...啊...(你将士兵扶起，并很不情愿地把急救药塞进了他嘴里，他的意识逐渐地清晰起来。)\",\"0\"],[\"finish\",\"完成任务\",\"10010400\"]]]'),(503700,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10010500\"]]]'),(503800,'[[[\"npc\",\"你...你为什么要救我...我们明明是...敌人\",\"0\"],[\"finish\",\"完成任务\",\"10010500\"]]]'),(503900,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10010600\"]]]'),(504000,'[[[\"npc\",\"我们奉命追击你们，却没想到怪物凶狠的袭击！怕死的军官们一看情况不对就把我们丢在这里送死！\",\"0\"],[\"finish\",\"完成任务\",\"10010600\"]]]'),(504100,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10010700\"]]]'),(504200,'[[[\"npc\",\"是你！船长，我还以为我再也见不到你了！\",\"0\"],[\"finish\",\"完成任务\",\"10010700\"]]]'),(504300,'[[[\"npc\",\"船长！真的是你，没想到你还活着！\",\"0\"],[\"trigger\",\"触发任务\",\"10010800\"]]]'),(504400,'[[[\"npc\",\"嘘！你听,这是怪物发出的脚步声，小心了！\",\"0\"],[\"finish\",\"完成任务\",\"10010800\"]]]'),(504500,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10010900\"]]]'),(504600,'[[[\"npc\",\"怪物的进攻变得越来越凶猛，天知道它们是受了什么鬼东西的影响。\",\"0\"],[\"finish\",\"完成任务\",\"10010900\"]]]'),(504700,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10011000\"]]]'),(504800,'[[[\"npc\",\"多亏了你，我才能带着剩下的兄弟死里逃生。不扯这些没用了，我知道你在找失散的伙伴，你顺着西边路就能找到坠船点了。\",\"0\"],[\"finish\",\"完成任务\",\"10011000\"]]]'),(504900,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10011100\"]]]'),(505000,'[[[\"npc\",\"不行！天知道坠船点那里会有什么鬼东西！我绝对不能让你去送死！\",\"0\"],[\"finish\",\"完成任务\",\"10011100\"]]]'),(505100,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"100112\"]]]'),(505200,'[[[\"npc\",\"哼！我早就猜到你会单独行动了，都是一条绳上的蚂蚱了，我也不能白白看着你去送死啊。\",\"0\"],[\"finish\",\"完成任务\",\"10011200\"]]]'),(505300,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10011300\"]]]'),(505400,'[[[\"npc\",\"哎哟，哎呦！我的尾巴差点就被那些坏家伙咬到了！看来不把这些烦人的家伙清理掉，我们根本无法前进。\",\"0\"],[\"finish\",\"完成任务\",\"10011300\"]]]'),(505500,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10011400\"]]]'),(505600,'[[[\"npc\",\"回来的正好，那个刚刚被你救起了帝国士兵拉着我的衣服说要重要的情报要汇报，事先说明，我可不相信这些土匪。\",\"0\"],[\"finish\",\"完成任务\",\"10011400\"]]]'),(505700,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10011500\"]]]'),(505800,'[[[\"npc\",\"虽然被大叔狠狠地揍了一顿，可我还是有个重要信息要跟你们汇报，其实我们这次前来除了追杀之外，还被委派一个特殊的任务。\",\"0\"],[\"finish\",\"完成任务\",\"10011500\"]]]'),(505900,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10011600\"]]]'),(506000,'[[[\"npc\",\"什么！帝国军队也想要夺取古代遗物，我早该猜到他们的阴谋！\",\"0\"],[\"finish\",\"完成任务\",\"10011600\"]]]'),(506100,'[[[\"npc\",\"怪物们又冲了上来，这回我一定要让他尝尝火焰弹的厉害！\",\"0\"],[\"trigger\",\"触发任务\",\"10011700\"]]]'),(506200,'[[[\"npc\",\"这些变异的怪物很可能是受某种神秘力量影响，这肯定与古代遗物有关。想要搜寻遗物，我就必须修好我的探测仪。\",\"0\"],[\"finish\",\"完成任务\",\"10011700\"]]]'),(506300,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10011800\"]]]'),(506400,'[[[\"npc\",\"古代遗物？也就你们这种小年轻会相信这种鬼话！以后还有这种事，就让那个臭小子自己来，他可欠了我不少工钱。\",\"0\"],[\"finish\",\"完成任务\",\"10011800\"]]]'),(506500,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10011900\"]]]'),(506600,'[[[\"npc\",\"那个糟老头虽然嘴巴挺贱的，不过修理东西可是一流的！我们终于可以继续前进啦！\",\"0\"],[\"finish\",\"完成任务\",\"10011900\"]]]'),(506700,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10012000\"]]]'),(506800,'[[[\"npc\",\"谁！谁在那里！我可警告你啦，我发起火来，连我自己都害...害怕！\",\"0\"],[\"finish\",\"完成任务\",\"10012000\"]]]'),(506900,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10012100\"]]]'),(507000,'[[[\"npc\",\"你找到了艾琳！太好了，我就说这个倒霉鬼没这么容易死掉，赶快把急救药给她吧！\",\"0\"],[\"finish\",\"完成任务\",\"10012100\"]]]'),(507100,'[[[\"npc\",\"我...我这是怎么了...这是哪...\",\"0\"],[\"trigger\",\"触发任务\",\"10012200\"]]]'),(507200,'[[[\"npc\",\"我...我这是怎么了...这是哪...对了，妮哆还被怪物们困在船上，快去救救她！\",\"0\"],[\"finish\",\"完成任务\",\"10012200\"]]]'),(507300,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10012300\"]]]'),(507400,'[[[\"npc\",\"船长大人！你平安无事真是太好了！\",\"0\"],[\"finish\",\"完成任务\",\"10012300\"]]]'),(507500,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10012400\"]]]'),(507600,'[[[\"npc\",\"不好了，不好啦！能量的波动开始变强了，探测仪...探测仪开始不听使唤了！\",\"0\"],[\"finish\",\"完成任务\",\"10012400\"]]]'),(507700,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10012500\"]]]'),(507800,'[[[\"npc\",\"就在你赶来之前，妮哆和我就一直坚守在这里，可是除了变异的怪物之外，却没有任何帝国军的踪迹。\",\"0\"],[\"finish\",\"完成任务\",\"10012500\"]]]'),(507900,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10012600\"]]]'),(508000,'[[[\"npc\",\"古代遗物！难怪我的魔力正在逐渐地衰减，原来都是它搞的鬼。可我们该怎么找到它呢？\",\"0\"],[\"finish\",\"完成任务\",\"10012600\"]]]'),(508100,'[[[\"npc\",\"震动把夹板都震地嘎嘎响，快去找零零哆，赶快让我们转移到安全的地方！\",\"0\"],[\"trigger\",\"触发任务\",\"10012700\"]]]'),(508200,'[[[\"npc\",\"找到啦！就在探测仪波动的最后一刻，我终于定位到了能量波动的坐标。赶快跟我前面汇合！\",\"0\"],[\"finish\",\"完成任务\",\"10012700\"]]]'),(508300,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10012800\"]]]'),(508400,'[[[\"npc\",\"累...累死我了，根据能量的波动的定位，遗物肯定就在这附近。\",\"0\"],[\"finish\",\"完成任务\",\"10012800\"]]]'),(508500,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10012900\"]]]'),(508600,'[[[\"npc\",\"我还依稀记得暴风号和我们一起逃亡、冒险的日子，可是现在却再也不能陪伴我们了！我发誓再也不给大家添乱了，你就带上我吧！\",\"0\"],[\"finish\",\"完成任务\",\"10012900\"]]]'),(508700,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10013000\"]]]'),(508800,'[[[\"npc\",\"这个位置不错！我...我一定会好好保护自己的，你就放手去战斗吧！\",\"0\"],[\"finish\",\"完成任务\",\"10013000\"]]]'),(508900,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10013100\"]]]'),(509000,'[[[\"npc\",\"等我清理完最后一波怪物，就和你们一起汇合！这里还有很多伤员，我不能走！\",\"0\"],[\"finish\",\"完成任务\",\"10013100\"]]]'),(509100,'[[[\"npc\",\"小心，怪物们又要扑过来了！\",\"0\"],[\"trigger\",\"触发任务\",\"10013200\"]]]'),(509200,'[[[\"npc\",\"总算松了口气，可通往神庙的石桥也被炸毁了，我可不像你能像只猴子一样蹦过去！\",\"0\"],[\"finish\",\"完成任务\",\"10013200\"]]]'),(509300,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10013300\"]]]'),(509400,'[[[\"npc\",\"虽然很危险，可我们还是一起克服了困难，这是给你的奖励！\",\"0\"],[\"finish\",\"完成任务\",\"10013300\"]]]'),(509500,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10013400\"]]]'),(509600,'[[[\"npc\",\"虽然很危险，可我们还是一起克服了困难，这是给你的奖励！\",\"0\"],[\"finish\",\"完成任务\",\"10013400\"]]]'),(509700,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10013500\"]]]'),(509800,'[[[\"npc\",\"虽然很危险，可我们还是一起克服了困难，这是给你的奖励！\",\"0\"],[\"finish\",\"完成任务\",\"10013500\"]]]'),(509900,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10013600\"]]]'),(510000,'[[[\"npc\",\"虽然很危险，可我们还是一起克服了困难，这是给你的奖励！\",\"0\"],[\"finish\",\"完成任务\",\"10013600\"]]]'),(510100,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10013700\"]]]'),(510200,'[[[\"npc\",\"虽然很危险，可我们还是一起克服了困难，这是给你的奖励！\",\"0\"],[\"finish\",\"完成任务\",\"10013700\"]]]'),(510300,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10013800\"]]]'),(510400,'[[[\"npc\",\"虽然很危险，可我们还是一起克服了困难，这是给你的奖励！\",\"0\"],[\"finish\",\"完成任务\",\"10013800\"]]]'),(510500,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10013900\"]]]'),(510600,'[[[\"npc\",\"虽然很危险，可我们还是一起克服了困难，这是给你的奖励！\",\"0\"],[\"finish\",\"完成任务\",\"10013900\"]]]'),(510700,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10014000\"]]]'),(510800,'[[[\"npc\",\"虽然很危险，可我们还是一起克服了困难，这是给你的奖励！\",\"0\"],[\"finish\",\"完成任务\",\"10014000\"]]]'),(510900,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10014100\"]]]'),(511000,'[[[\"npc\",\"虽然很危险，可我们还是一起克服了困难，这是给你的奖励！\",\"0\"],[\"finish\",\"完成任务\",\"10014100\"]]]'),(511100,'[[[\"npc\",\"小心，怪物们又要扑过来了！\",\"0\"],[\"trigger\",\"触发任务\",\"10014200\"]]]'),(511200,'[[[\"npc\",\"总算松了口气，可通往神庙的石桥也被炸毁了，我可不像你能像只猴子一样蹦过去！\",\"0\"],[\"finish\",\"完成任务\",\"10014200\"]]]'),(511300,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10014300\"]]]'),(511400,'[[[\"npc\",\"我千算万算，也没算到帝国军会把石桥炸断。\",\"0\"],[\"finish\",\"完成任务\",\"10014300\"]]]'),(511500,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10014400\"]]]'),(511600,'[[[\"npc\",\"这里的怪物也很凶悍，我有好几次差点...差点被吓趴了,怎么样，你想办法带我们通过断桥吗？\",\"0\"],[\"finish\",\"完成任务\",\"10014400\"]]]'),(511700,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10014500\"]]]'),(511800,'[[[\"npc\",\"船长！我这边也抽不出手来帮你，怪物的攻势越来越凶了，我们必须先消灭目前的威胁。\",\"0\"],[\"finish\",\"完成任务\",\"10014500\"]]]'),(511900,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10014600\"]]]'),(512000,'[[[\"npc\",\"嘘！轻点，你这样会把怪物都引过来的，我已经窥探到对面的情况了，好像有点不对劲。\",\"0\"],[\"finish\",\"完成任务\",\"10014600\"]]]'),(512100,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10014700\"]]]'),(512200,'[[[\"npc\",\"太好了，这是最后一批缠人的家伙了！让我们赶快前进吧！\",\"0\"],[\"finish\",\"完成任务\",\"10014700\"]]]'),(512300,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10014800\"]]]'),(512400,'[[[\"npc\",\"妮哆终于脱身了？说不定她的传送法术可以将我们传到断桥的对面。\",\"0\"],[\"finish\",\"完成任务\",\"10014800\"]]]'),(512500,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10014900\"]]]'),(512600,'[[[\"npc\",\"零零哆这个家伙就知道偷懒，关键时刻还得靠我，我这就开始准备传送法术。\",\"0\"],[\"finish\",\"完成任务\",\"10014900\"]]]'),(512700,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10015000\"]]]'),(512800,'[[[\"npc\",\"怎么还有怪物，我们刚刚不是已经把它们击退了吗？\",\"0\"],[\"finish\",\"完成任务\",\"10015000\"]]]'),(512900,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10015100\"]]]'),(513000,'[[[\"npc\",\"传送术？圣母在上，这次我一定可以坚持到妮哆传送术完成的一刻。\",\"0\"],[\"finish\",\"完成任务\",\"10015100\"]]]'),(513100,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10015200\"]]]'),(513200,'[[[\"npc\",\"多凶狠的怪物啊！就连我的火焰弹也那它没办法，还好你及时出现！\",\"0\"],[\"finish\",\"完成任务\",\"10015200\"]]]'),(513300,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10015300\"]]]'),(513400,'[[[\"npc\",\"真为你捏了一把冷汗，不过庆幸地是我已经确定了我们传送过去安全坐标，你快去通知妮哆。\",\"0\"],[\"finish\",\"完成任务\",\"10015300\"]]]'),(513500,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10015400\"]]]'),(513600,'[[[\"npc\",\"魔法充能完毕！船长，我就等你一声令下，我们就能传送到对面了。\",\"0\"],[\"finish\",\"完成任务\",\"10015400\"]]]'),(513700,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10015500\"]]]'),(513800,'[[[\"npc\",\"看来这群畜生也有所察觉开始疯狂反扑了！我们赶紧撤。\",\"0\"],[\"finish\",\"完成任务\",\"10015500\"]]]'),(513900,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10015600\"]]]'),(514000,'[[[\"npc\",\"好紧张啊！不过有你们在，我们一定会组织帝国军的阴谋的！\",\"0\"],[\"finish\",\"完成任务\",\"10015600\"]]]'),(514100,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10015700\"]]]'),(514200,'[[[\"npc\",\"虽然很危险，可我们还是一起克服了困难，这是给你的奖励！\",\"0\"],[\"finish\",\"完成任务\",\"10015700\"]]]'),(514300,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10015800\"]]]'),(514400,'[[[\"npc\",\"虽然很危险，可我们还是一起克服了困难，这是给你的奖励！\",\"0\"],[\"finish\",\"完成任务\",\"10015800\"]]]'),(514500,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10015900\"]]]'),(514600,'[[[\"npc\",\"虽然很危险，可我们还是一起克服了困难，这是给你的奖励！\",\"0\"],[\"finish\",\"完成任务\",\"10015900\"]]]'),(514700,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10016000\"]]]'),(514800,'[[[\"npc\",\"虽然很危险，可我们还是一起克服了困难，这是给你的奖励！\",\"0\"],[\"finish\",\"完成任务\",\"10016000\"]]]'),(514900,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10016100\"]]]'),(515000,'[[[\"npc\",\"虽然很危险，可我们还是一起克服了困难，这是给你的奖励！\",\"0\"],[\"finish\",\"完成任务\",\"10016100\"]]]'),(515100,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10016200\"]]]'),(515200,'[[[\"npc\",\"虽然很危险，可我们还是一起克服了困难，这是给你的奖励！\",\"0\"],[\"finish\",\"完成任务\",\"10016200\"]]]'),(515300,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10016300\"]]]'),(515400,'[[[\"npc\",\"虽然很危险，可我们还是一起克服了困难，这是给你的奖励！\",\"0\"],[\"finish\",\"完成任务\",\"10016300\"]]]'),(515500,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10016400\"]]]'),(515600,'[[[\"npc\",\"虽然很危险，可我们还是一起克服了困难，这是给你的奖励！\",\"0\"],[\"finish\",\"完成任务\",\"10016400\"]]]'),(515700,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10016500\"]]]'),(515800,'[[[\"npc\",\"虽然很危险，可我们还是一起克服了困难，这是给你的奖励！\",\"0\"],[\"finish\",\"完成任务\",\"10016500\"]]]'),(515900,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10016600\"]]]'),(516000,'[[[\"npc\",\"虽然很危险，可我们还是一起克服了困难，这是给你的奖励！\",\"0\"],[\"finish\",\"完成任务\",\"10016600\"]]]'),(516100,'[[[\"npc\",\"传送？成功？\",\"0\"],[\"trigger\",\"触发任务\",\"10016700\"]]]'),(516200,'[[[\"npc\",\"哈哈！我没说错吧！妮哆和我简直就是天生的搭档，当然...仅限于工作。\",\"0\"],[\"finish\",\"完成任务\",\"10016700\"]]]'),(516300,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10016800\"]]]'),(516400,'[[[\"npc\",\"这是多么可怕的力量！古代遗物的力量让所有的帝国先锋军都变成了怪物，还好我们当时不在能量的中心。\",\"0\"],[\"finish\",\"完成任务\",\"10016800\"]]]'),(516500,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10016900\"]]]'),(516600,'[[[\"npc\",\"糟了！我们这回麻烦大了，巨大的魔法波动从这个平台散发，现在...现在整个冰原的怪物再朝这边涌来！\",\"0\"],[\"finish\",\"完成任务\",\"10016900\"]]]'),(516700,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10017000\"]]]'),(516800,'[[[\"npc\",\"快！快告诉我计划是什么，四面八方都是帝国军变的怪物。我们在这里根本就接近不了靠近中心！\",\"0\"],[\"finish\",\"完成任务\",\"10017000\"]]]'),(516900,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10017100\"]]]'),(517000,'[[[\"npc\",\"你可回来了！船长，你不在时候我就一直守在这个哨点，都快冻成孙子了！\",\"0\"],[\"finish\",\"完成任务\",\"10017100\"]]]'),(517100,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10017200\"]]]'),(517200,'[[[\"npc\",\"就放心地交给我们哥俩吧！把这些没脑子的怪物引开，还不跟逗帝国军玩差不多！\",\"0\"],[\"finish\",\"完成任务\",\"10017200\"]]]'),(517300,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10017300\"]]]'),(517400,'[[[\"npc\",\"你居然让船员们把怪物都引开了？你这副鬼脑子，不跟我来情报局混真是太屈才了！\",\"0\"],[\"finish\",\"完成任务\",\"10017300\"]]]'),(517500,'[[[\"npc\",\"船...船长，我们哥俩都已经带着这群家伙绕了一圈了，什么时候才能休息啊！\",\"0\"],[\"trigger\",\"触发任务\",\"10017400\"]]]'),(517600,'[[[\"npc\",\"船...船长，我们哥俩都已经带着这群家伙绕了一圈了，什么时候才能休息啊！\",\"0\"],[\"finish\",\"完成任务\",\"10017400\"]]]'),(517700,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10017500\"]]]'),(517800,'[[[\"npc\",\"好险！被这些家伙摸到了屁股的话，我的下辈子可就要在床上过了。\",\"0\"],[\"finish\",\"完成任务\",\"10017500\"]]]'),(517900,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10017600\"]]]'),(518000,'[[[\"npc\",\"我的法术生效了，现在只要让我们找到能量波动的根源，这群怪物就再也不会对我们紧追不舍啦。\",\"0\"],[\"finish\",\"完成任务\",\"10017600\"]]]'),(518100,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10017700\"]]]'),(518200,'[[[\"npc\",\"怪物们？怪物们的进攻突然停了下来，这是怎么回事？\",\"0\"],[\"finish\",\"完成任务\",\"10017700\"]]]'),(518300,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10017800\"]]]'),(518400,'[[[\"npc\",\"这是最后一波怪物了，船长！我们安全了吗？\",\"0\"],[\"finish\",\"完成任务\",\"10017800\"]]]'),(518500,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10017900\"]]]'),(518600,'[[[\"npc\",\"波动的坐标我已经标好了，小心了！那肯定是一个不得了的家伙。\",\"0\"],[\"finish\",\"完成任务\",\"10017900\"]]]'),(518700,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10018000\"]]]'),(518800,'[[[\"npc\",\"哎呀！哎呀！集结成群的怪物终于停了下来，我们得救了！\",\"0\"],[\"finish\",\"完成任务\",\"10018000\"]]]'),(518900,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10018100\"]]]'),(519000,'[[[\"npc\",\"没错！就是这个！没想到看似平淡不奇的遗物居然会有这么大的能量！\",\"0\"],[\"finish\",\"完成任务\",\"10018100\"]]]'),(519100,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10018200\"]]]'),(519200,'[[[\"npc\",\"虽然很危险，可我们还是一起克服了困难，这是给你的奖励！\",\"0\"],[\"finish\",\"完成任务\",\"10018200\"]]]'),(519300,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10018300\"]]]'),(519400,'[[[\"npc\",\"虽然很危险，可我们还是一起克服了困难，这是给你的奖励！\",\"0\"],[\"finish\",\"完成任务\",\"10018300\"]]]'),(519500,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10018400\"]]]'),(519600,'[[[\"npc\",\"虽然很危险，可我们还是一起克服了困难，这是给你的奖励！\",\"0\"],[\"finish\",\"完成任务\",\"10018400\"]]]'),(519700,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10018500\"]]]'),(519800,'[[[\"npc\",\"虽然很危险，可我们还是一起克服了困难，这是给你的奖励！\",\"0\"],[\"finish\",\"完成任务\",\"10018500\"]]]'),(519900,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10018600\"]]]'),(520000,'[[[\"npc\",\"虽然很危险，可我们还是一起克服了困难，这是给你的奖励！\",\"0\"],[\"finish\",\"完成任务\",\"10018600\"]]]'),(520100,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10018700\"]]]'),(520200,'[[[\"npc\",\"虽然很危险，可我们还是一起克服了困难，这是给你的奖励！\",\"0\"],[\"finish\",\"完成任务\",\"10018700\"]]]'),(520300,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10018800\"]]]'),(520400,'[[[\"npc\",\"虽然很危险，可我们还是一起克服了困难，这是给你的奖励！\",\"0\"],[\"finish\",\"完成任务\",\"10018800\"]]]'),(520500,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10018900\"]]]'),(520600,'[[[\"npc\",\"虽然很危险，可我们还是一起克服了困难，这是给你的奖励！\",\"0\"],[\"finish\",\"完成任务\",\"10018900\"]]]'),(520700,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10019000\"]]]'),(520800,'[[[\"npc\",\"虽然很危险，可我们还是一起克服了困难，这是给你的奖励！\",\"0\"],[\"finish\",\"完成任务\",\"10019000\"]]]'),(520900,'[[[\"npc\",\"准备好跟我一起去战斗了吗？前面的路还有很长？\",\"0\"],[\"trigger\",\"触发任务\",\"10019100\"]]]'),(521000,'[[[\"npc\",\"虽然很危险，可我们还是一起克服了困难，这是给你的奖励！\",\"0\"],[\"finish\",\"完成任务\",\"10019100\"]]]'),(600100,'[[[\"npc\",\"廊桥...铁卫，誓...誓死不退\",\"0\"],[\"trigger\",\"触发任务\",\"10019200\"]]]'),(600200,'[[[\"role\",\"(眼前这名重伤的卫士满是鲜血，看上去极其虚弱，你与伙伴们对他进行了简单的救助之后便离开了...)\",\"0\"],[\"finish\",\"完成任务\",\"10019200\"]]]'),(600300,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10019300\"]]]'),(600400,'[[[\"npc\",\"是谁！谁在那里！再不说明你的身份可别怪我不客气了！\",\"0\"],[\"finish\",\"完成任务\",\"10019300\"]]]'),(600500,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10019400\"]]]'),(600600,'[[[\"npc\",\"你们...你们是谁？我怎么...还没...没死？不行，帝国的暗潮大军还在这片土地上肆虐，我还要去战斗！\",\"0\"],[\"finish\",\"完成任务\",\"10019400\"]]]'),(600700,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10019500\"]]]'),(600800,'[[[\"npc\",\"谢谢你们！陌生人，这里已经被围攻好几个月了，不知道驻守在里面的姐妹还有没有活着，我们的暗号是“枫叶”，你能帮我去打探下里面的情况吗？\",\"0\"],[\"finish\",\"完成任务\",\"10019500\"]]]'),(600900,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10019600\"]]]'),(601000,'[[[\"role\",\"你对着眼前这个神秘人说出了“枫叶”的暗号，她的眼中露出了惊讶而又异样的眼神。\",\"0\"],[\"finish\",\"完成任务\",\"10019600\"]]]'),(601100,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10019700\"]]]'),(601200,'[[[\"npc\",\"女神在上，居然还有姐妹活着！我不该这么悲观的，说不定廊桥中心的据点还有幸存者...\",\"0\"],[\"finish\",\"完成任务\",\"10019700\"]]]'),(601300,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10019800\"]]]'),(601400,'[[[\"npc\",\"你们能留下来帮忙这是太好了！你们往中心平台或许可以找到更多的幸存者。\",\"0\"],[\"finish\",\"完成任务\",\"10019800\"]]]'),(601500,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10019900\"]]]'),(601600,'[[[\"npc\",\"援军？你们是援军吗？\",\"0\"],[\"finish\",\"完成任务\",\"10019900\"]]]'),(601700,'[[[\"npc\",\"援军？你们是援军吗？\",\"0\"],[\"trigger\",\"触发任务\",\"10020000\"]]]'),(601800,'[[[\"npc\",\"贞德团长？她还活着！你赶快把我这里情报都汇报给她吧！\",\"0\"],[\"finish\",\"完成任务\",\"10020000\"]]]'),(601900,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10020100\"]]]'),(602000,'[[[\"role\",\"（你将密探的情报一五一十地告诉了贞德,话还没说完一阵嘶吼声震慑住了每个人的心脏...）\",\"0\"],[\"finish\",\"完成任务\",\"10020100\"]]]'),(602100,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10020200\"]]]'),(602200,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10020200\"]]]'),(602300,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10020300\"]]]'),(602400,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10020300\"]]]'),(602500,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10020400\"]]]'),(602600,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10020400\"]]]'),(602700,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10020500\"]]]'),(602800,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10020500\"]]]'),(602900,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10020600\"]]]'),(603000,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10020600\"]]]'),(603100,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10020700\"]]]'),(603200,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10020700\"]]]'),(603300,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10020800\"]]]'),(603400,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10020800\"]]]'),(603500,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10020900\"]]]'),(603600,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10020900\"]]]'),(603700,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10021000\"]]]'),(603800,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10021000\"]]]'),(603900,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10021100\"]]]'),(604000,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10021100\"]]]'),(604100,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10021200\"]]]'),(604200,'[[[\"npc\",\"刚刚被打退了一波，现在又来一波！我已经不记得这是怪物们第几次冲锋了。通知所有活着的姐妹，做好新一轮的战斗准备！\",\"0\"],[\"finish\",\"完成任务\",\"10021200\"]]]'),(604300,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10021300\"]]]'),(604400,'[[[\"npc\",\"女生在上！就算流干最后一滴血，我也绝不像这些杂碎投降！\",\"0\"],[\"finish\",\"完成任务\",\"10021300\"]]]'),(604500,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10021400\"]]]'),(604600,'[[[\"npc\",\"做为船长大人钦点的侦察兵，我可不敢有什么怨言！脆弱的防线很快就要被击溃了，我负责右路的防守吧！\",\"0\"],[\"finish\",\"完成任务\",\"10021400\"]]]'),(604700,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10021500\"]]]'),(604800,'[[[\"npc\",\"这群怪物一定是被？太可怕了，根据魔能波动仪提供的情报表明，这股力量来自廊桥外侧的占星台，我们必须摧毁那里的魔能发射点！\",\"0\"],[\"finish\",\"完成任务\",\"10021500\"]]]'),(604900,'[[[\"npc\",\"暗潮大军每到夜晚才会放松对占星台的境界，那就是我们行动的最佳时间！\",\"0\"],[\"trigger\",\"触发任务\",\"10021600\"]]]'),(605000,'[[[\"npc\",\"做的好！占星台又归于我们掌控了。\",\"0\"],[\"finish\",\"完成任务\",\"10021600\"]]]'),(605100,'[[[\"npc\",\"我没！我没听错吧？你居然打败了占星台的看守？\",\"0\"],[\"trigger\",\"触发任务\",\"10021700\"]]]'),(605200,'[[[\"npc\",\"右路虽然还剩下不少的怪物，不过失去了占星台的魔能蛊惑，我们肯定可以守住的！\",\"0\"],[\"finish\",\"完成任务\",\"10021700\"]]]'),(605300,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10021800\"]]]'),(605400,'[[[\"npc\",\"现在庆祝是不是有点太早了，就在我们击败占星台护卫的时候，我们的一个侦察小队就被怪物盯上了，到现在还没回来，恐怕又是凶多吉少。\",\"0\"],[\"finish\",\"完成任务\",\"10021800\"]]]'),(605500,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10021900\"]]]'),(605600,'[[[\"role\",\"（侦察小队的斥候为了保护获取的情报全都牺牲了，他们在临死前将情报藏在暗潮军用于运送物资的鹿崽身上...）\",\"0\"],[\"finish\",\"完成任务\",\"10021900\"]]]'),(605700,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10022000\"]]]'),(605800,'[[[\"npc\",\"他们的绝不会白白牺牲！这上面的密语只有我们的密探才能解开，时间紧急，快快行动吧！\",\"0\"],[\"finish\",\"完成任务\",\"10022000\"]]]'),(605900,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10022100\"]]]'),(606000,'[[[\"npc\",\"这是...这是我们转败为胜的最佳机会啊！（你们窃窃私语地的时候，意外地惊动了附近地一处怪物。）\",\"0\"],[\"finish\",\"完成任务\",\"10022100\"]]]'),(606100,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10022200\"]]]'),(606200,'[[[\"npc\",\"这道密语的意思是说，暗潮大军之所以可以源源不断进攻我们的秘密，应该和你打败的占星台怪物有关...\",\"0\"],[\"finish\",\"完成任务\",\"10022200\"]]]'),(606300,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10022300\"]]]'),(606400,'[[[\"npc\",\"魔能波动仪似乎被屏蔽了，现在我丝毫察觉不到魔能的波动！快！快去找妮哆，她肯定知道些什么。\",\"0\"],[\"finish\",\"完成任务\",\"10022300\"]]]'),(606500,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10022400\"]]]'),(606600,'[[[\"npc\",\"操控怪物的魔能突然消失了？真是有趣！事情肯定没有这么简单！我需要所有占星台的位置，这样我才能探测魔法能量的波动。\",\"0\"],[\"finish\",\"完成任务\",\"10022400\"]]]'),(606700,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10022500\"]]]'),(606800,'[[[\"npc\",\"仅存的两个占星台位于廊桥的东面和西面，剩下的已经被帝国军摧毁了！\",\"0\"],[\"finish\",\"完成任务\",\"10022500\"]]]'),(606900,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10022600\"]]]'),(607000,'[[[\"npc\",\"干得好，接下来是时候让我们找到另一个占星台的位置了！\",\"0\"],[\"finish\",\"完成任务\",\"10022600\"]]]'),(607100,'[[[\"npc\",\"我们还是先找军团长商量下下一步的计划。\",\"0\"],[\"trigger\",\"触发任务\",\"10022700\"]]]'),(607200,'[[[\"npc\",\"你来的正好，勇士！你的伙伴们已经跟我大致说明了情况，可通往另外一处的升星台道路已经被毁了，我们必须寻找其他的道路前往。\",\"0\"],[\"finish\",\"完成任务\",\"10022700\"]]]'),(607300,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10022800\"]]]'),(607400,'[[[\"npc\",\"去找东南面的军需官，没人比她跟了解廊桥的各个路线，前提是她还活着的话。\",\"0\"],[\"finish\",\"完成任务\",\"10022800\"]]]'),(607500,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10022900\"]]]'),(607600,'[[[\"npc\",\"女生在上！居然...居然有个活人！\",\"0\"],[\"finish\",\"完成任务\",\"10022900\"]]]'),(607700,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10023000\"]]]'),(607800,'[[[\"npc\",\"谢谢你的帮助，我先介绍一下，我是胆...胆小需官卡特琳娜，不！我就是卡特琳娜！\",\"0\"],[\"finish\",\"完成任务\",\"10023000\"]]]'),(607900,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10023100\"]]]'),(608000,'[[[\"npc\",\"通往西面的占星台被毁了，这...这下糟了！那条路可是唯一的，除此之外别无他路。\",\"0\"],[\"finish\",\"完成任务\",\"10023100\"]]]'),(608100,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10023200\"]]]'),(608200,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10023200\"]]]'),(608300,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10023300\"]]]'),(608400,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10023300\"]]]'),(608500,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10023400\"]]]'),(608600,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10023400\"]]]'),(608700,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10023500\"]]]'),(608800,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10023500\"]]]'),(608900,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10023600\"]]]'),(609000,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10023600\"]]]'),(609100,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10023700\"]]]'),(609200,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10023700\"]]]'),(609300,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10023800\"]]]'),(609400,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10023800\"]]]'),(609500,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10023900\"]]]'),(609600,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10023900\"]]]'),(609700,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10024000\"]]]'),(609800,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10024000\"]]]'),(609900,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10024100\"]]]'),(610000,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10024100\"]]]'),(610100,'[[[\"npc\",\"你来的正是时候，关于占星台我好像遗漏掉了什么...\",\"0\"],[\"trigger\",\"触发任务\",\"10024200\"]]]'),(610200,'[[[\"npc\",\"没错，我们可以使用铁索的东西爬上占星台。\",\"0\"],[\"finish\",\"完成任务\",\"10024200\"]]]'),(610300,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10024300\"]]]'),(610400,'[[[\"npc\",\"果然是个好主意，可是这一时半会儿，我们要去哪里找绳索呢？\",\"0\"],[\"finish\",\"完成任务\",\"10024300\"]]]'),(610500,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10024400\"]]]'),(610600,'[[[\"npc\",\"做绳索！这是特工必备的技能，不过我还需要一些时间！\",\"0\"],[\"finish\",\"完成任务\",\"10024400\"]]]'),(610700,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10024500\"]]]'),(610800,'[[[\"npc\",\"哎呦！我正在努力中呢，你还是先去密探那边汇报了战况吧。\",\"0\"],[\"finish\",\"完成任务\",\"10024500\"]]]'),(610900,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10024600\"]]]'),(611000,'[[[\"npc\",\"你来的正是时候！廊桥的勇士！这是给军团长的密保，请务必亲手交给他。\",\"0\"],[\"finish\",\"完成任务\",\"10024600\"]]]'),(611100,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10024700\"]]]'),(611200,'[[[\"npc\",\"什么！这群该死的杂碎又准备发动新的攻势？赶快建立防御工事！\",\"0\"],[\"finish\",\"完成任务\",\"10024700\"]]]'),(611300,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10024800\"]]]'),(611400,'[[[\"npc\",\"魔能的波动又开始频繁起来了！没错！是敌人来袭！\",\"0\"],[\"finish\",\"完成任务\",\"10024800\"]]]'),(611500,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10024900\"]]]'),(611600,'[[[\"npc\",\"嘻嘻！差点就被这些歹毒的怪物贴身了，多亏那些魔法陷阱，当然还有你。\",\"0\"],[\"finish\",\"完成任务\",\"10024900\"]]]'),(611700,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10025000\"]]]'),(611800,'[[[\"npc\",\"刚刚怪物冲过来的时候我差点以为自己玩完了，真是好险。不说了，我该继续工作了。\",\"0\"],[\"finish\",\"完成任务\",\"10025000\"]]]'),(611900,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10025100\"]]]'),(612000,'[[[\"npc\",\"勇士，我有新的情报要向你汇报！\",\"0\"],[\"finish\",\"完成任务\",\"10025100\"]]]'),(612100,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10025200\"]]]'),(612200,'[[[\"npc\",\"看来敌人又要冲上来了！全体！战斗序列！\",\"0\"],[\"finish\",\"完成任务\",\"10025200\"]]]'),(612300,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10025300\"]]]'),(612400,'[[[\"npc\",\"能与你并肩作战是我等的荣幸，勇士！\",\"0\"],[\"finish\",\"完成任务\",\"10025300\"]]]'),(612500,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10025400\"]]]'),(612600,'[[[\"npc\",\"请你转告军团长，我...我没事，就算那些怪...怪物很可怕，我也会继续战斗的！请你\",\"0\"],[\"finish\",\"完成任务\",\"10025400\"]]]'),(612700,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10025500\"]]]'),(612800,'[[[\"npc\",\"军需官平安无事真是太好了！等我们攻下最后一个占星台，我看那些怪物还敢不敢嚣张下去。\",\"0\"],[\"finish\",\"完成任务\",\"10025500\"]]]'),(612900,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10025600\"]]]'),(613000,'[[[\"npc\",\"棒极了！这将会是我生平之中最精彩的一战，占星台被彻底解放了！\",\"0\"],[\"finish\",\"完成任务\",\"10025600\"]]]'),(613100,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10025700\"]]]'),(613200,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10025700\"]]]'),(613300,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10025800\"]]]'),(613400,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10025800\"]]]'),(613500,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10025900\"]]]'),(613600,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10025900\"]]]'),(613700,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10026000\"]]]'),(613800,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10026000\"]]]'),(613900,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10026100\"]]]'),(614000,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10026100\"]]]'),(614100,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10026200\"]]]'),(614200,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10026200\"]]]'),(614300,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10026300\"]]]'),(614400,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10026300\"]]]'),(614500,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10026400\"]]]'),(614600,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10026400\"]]]'),(614700,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10026500\"]]]'),(614800,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10026500\"]]]'),(614900,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10026600\"]]]'),(615000,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10026600\"]]]'),(615100,'[[[\"npc\",\"赞美女神！我们...我们得救了。\",\"0\"],[\"trigger\",\"触发任务\",\"10026700\"]]]'),(615200,'[[[\"npc\",\"太好了，勇士！自从你打败占星台的怪物之后，他们的进攻明显减弱了，接下来赶快让我把失散的姐妹们集结起来！\",\"0\"],[\"finish\",\"完成任务\",\"10026700\"]]]'),(615300,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10026800\"]]]'),(615400,'[[[\"npc\",\"就把阵地安心地交给我们吧，集结那些失散的伙伴们，我们就有胜利的希望。\",\"0\"],[\"finish\",\"完成任务\",\"10026800\"]]]'),(615500,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10026900\"]]]'),(615600,'[[[\"npc\",\"嘿嘿！我做的绳索派上用场了吧，天才是所以被称为天才就是因为天生的才智。\",\"0\"],[\"finish\",\"完成任务\",\"10026900\"]]]'),(615700,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10027000\"]]]'),(615800,'[[[\"npc\",\"我们...我们这边已经集结了很多伙伴！队伍正在不断壮大，这都得益于你的功劳。\",\"0\"],[\"finish\",\"完成任务\",\"10027000\"]]]'),(615900,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10027100\"]]]'),(616000,'[[[\"npc\",\"怪物们的进攻又被打退了，胜利一定属于我们。##0\"],[\"finish\",\"完成任务\",\"10027100\"]]]'),(616100,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10027200\"]]]'),(616200,'[[[\"npc\",\"看见了吗？廊桥的勇士，敌人正在不断的退败。\",\"0\"],[\"finish\",\"完成任务\",\"10027200\"]]]'),(616300,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10027300\"]]]'),(616400,'[[[\"npc\",\"没想到不可一世的暗潮大军也有今天，我倒要看看他们还能支撑多久，胜利属于黄昏廊桥！\",\"0\"],[\"finish\",\"完成任务\",\"10027300\"]]]'),(616500,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10027400\"]]]'),(616600,'[[[\"npc\",\"勇士，我已经将附近被打散的战士们集结起来，很快我们就可以组织反攻了！\",\"0\"],[\"finish\",\"完成任务\",\"10027400\"]]]'),(616700,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10027500\"]]]'),(616800,'[[[\"npc\",\"敌人毫无费力地就被击退了！姐妹们，团结就是胜利！\",\"0\"],[\"finish\",\"完成任务\",\"10027500\"]]]'),(616900,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10027600\"]]]'),(617000,'[[[\"npc\",\"赞美女神！我已经集结了剩下的姐妹，廊桥的最终胜利一定属于我们！\",\"0\"],[\"finish\",\"完成任务\",\"10027600\"]]]'),(617100,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10027700\"]]]'),(617200,'[[[\"npc\",\"看来我们的反击力量准备完毕了，我们时候开始反攻？\",\"0\"],[\"finish\",\"完成任务\",\"10027700\"]]]'),(617300,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10027800\"]]]'),(617400,'[[[\"npc\",\"勇士！你总算来了，我们...我们又遇到了新的麻烦，集结路途中的敌人设下了埋伏，我们损失惨重...\",\"0\"],[\"finish\",\"完成任务\",\"10027800\"]]]'),(617500,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10027900\"]]]'),(617600,'[[[\"npc\",\"这回我们再也不用担心补给通道的问题了。\",\"0\"],[\"finish\",\"完成任务\",\"10027900\"]]]'),(617700,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10028000\"]]]'),(617800,'[[[\"npc\",\"我们克服了新的困难，没有人能阻挡骑士团的脚步！\",\"0\"],[\"finish\",\"完成任务\",\"10028000\"]]]'),(617900,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10028100\"]]]'),(618000,'[[[\"npc\",\"全体！准备！开始！反攻！\",\"0\"],[\"finish\",\"完成任务\",\"10028100\"]]]'),(618100,'[[[\"npc\",\"勇士！军需官已经集结了还有战斗能力的伙伴，只要一声令下我们就立刻反攻！\",\"0\"],[\"trigger\",\"触发任务\",\"10028200\"]]]'),(618200,'[[[\"npc\",\"就...就等你这句话了。\",\"0\"],[\"finish\",\"完成任务\",\"10028200\"]]]'),(618300,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10028300\"]]]'),(618400,'[[[\"npc\",\"好样的，我们已经成功清理了盘踞在入口处的敌人。\",\"0\"],[\"finish\",\"完成任务\",\"10028300\"]]]'),(618500,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10028400\"]]]'),(618600,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10028400\"]]]'),(618700,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10028500\"]]]'),(618800,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10028500\"]]]'),(618900,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10028600\"]]]'),(619000,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10028600\"]]]'),(619100,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10028700\"]]]'),(619200,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10028700\"]]]'),(619300,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10028800\"]]]'),(619400,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10028800\"]]]'),(619500,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10028900\"]]]'),(619600,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10028900\"]]]'),(619700,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10029000\"]]]'),(619800,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10029000\"]]]'),(619900,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10029100\"]]]'),(620000,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10029100\"]]]'),(620100,'[[[\"npc\",\"反击的时候终于到了！准备进攻！\",\"0\"],[\"trigger\",\"触发任务\",\"10029200\"]]]'),(620200,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10029200\"]]]'),(620300,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10029300\"]]]'),(620400,'[[[\"npc\",\"好样的！我们已经成功干掉了入口处的敌人。\",\"0\"],[\"finish\",\"完成任务\",\"10029300\"]]]'),(620500,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10029400\"]]]'),(620600,'[[[\"npc\",\"奇怪！自从我们集结以后，敌人的攻势就突然停了下来，这不符合常理。\",\"0\"],[\"finish\",\"完成任务\",\"10029400\"]]]'),(620700,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10029500\"]]]'),(620800,'[[[\"npc\",\"敌人的攻势居然真的停了，可我还是有种不祥的预感。直觉告诉我，敌人还有新的阴谋。\",\"0\"],[\"finish\",\"完成任务\",\"10029500\"]]]'),(620900,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10029600\"]]]'),(621000,'[[[\"npc\",\"干得漂亮！我们又除掉了一堆麻烦。\",\"0\"],[\"finish\",\"完成任务\",\"10029600\"]]]'),(621100,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10029700\"]]]'),(621200,'[[[\"npc\",\"干得漂亮！我们又除掉了一堆麻烦。\",\"0\"],[\"finish\",\"完成任务\",\"10029700\"]]]'),(621300,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10029800\"]]]'),(621400,'[[[\"npc\",\"军需官刚刚气急匆匆地样子过来了，说是找你有紧急的情况要向你汇报！\",\"0\"],[\"finish\",\"完成任务\",\"10029800\"]]]'),(621500,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10029900\"]]]'),(621600,'[[[\"npc\",\"勇士！我们已经成功清理了一部分通往西区的怪物，我们很快就要前进了！\",\"0\"],[\"finish\",\"完成任务\",\"10029900\"]]]'),(621700,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10030000\"]]]'),(621800,'[[[\"npc\",\"通往西区的道路总算被打开了，希望这回不会太晚。\",\"0\"],[\"finish\",\"完成任务\",\"10030000\"]]]'),(621900,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10030100\"]]]'),(622000,'[[[\"npc\",\"有我在，怪物们就别想上前一步！团长，赶快前往西区吧。\",\"0\"],[\"finish\",\"完成任务\",\"10030100\"]]]'),(622100,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10030200\"]]]'),(622200,'[[[\"npc\",\"西区是我们固守防御的最后一道防线，在我们撤离之前，先知带领着仅存的亲卫队防守在那里。\",\"0\"],[\"finish\",\"完成任务\",\"10030200\"]]]'),(622300,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10030300\"]]]'),(622400,'[[[\"npc\",\"天佑女神！勇士，你可一定要把这里情况告诉女神，胜利必将属于廊桥禁卫军！\",\"0\"],[\"finish\",\"完成任务\",\"10030300\"]]]'),(622500,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10030400\"]]]'),(622600,'[[[\"npc\",\"这是军团长的密令！得救了！可算把援军盼来了！\",\"0\"],[\"finish\",\"完成任务\",\"10030400\"]]]'),(622700,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10030500\"]]]'),(622800,'[[[\"npc\",\"在后续部队赶来之前，我们可得固守住这据点。你能帮我通知军需官，让他快点派遣援军驻扎吗？\",\"0\"],[\"finish\",\"完成任务\",\"10030500\"]]]'),(622900,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10030600\"]]]'),(623000,'[[[\"npc\",\"没问题，我现在就派守卫过去，让密探一定要坚持住！\",\"0\"],[\"finish\",\"完成任务\",\"10030600\"]]]'),(623100,'[[[\"npc\",\"我们已经准备就绪，马上可以出发。\",\"0\"],[\"trigger\",\"触发任务\",\"10030700\"]]]'),(623200,'[[[\"npc\",\"很好！必须马上建立防御工事。\",\"0\"],[\"finish\",\"完成任务\",\"10030700\"]]]'),(623300,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10030800\"]]]'),(623400,'[[[\"npc\",\"我就知道军团长的派来的救星不会让大家失望！\",\"0\"],[\"finish\",\"完成任务\",\"10030800\"]]]'),(623500,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10030900\"]]]'),(623600,'[[[\"npc\",\"根据派遣回来的斥候报告，我们已经成功在西区建立的阵地。\",\"0\"],[\"finish\",\"完成任务\",\"10030900\"]]]'),(623700,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10031000\"]]]'),(623800,'[[[\"npc\",\"团长，就在返回之前，我们刚刚有了一个重大进展—先知还活着，她就在西区上层平台顶端。\",\"0\"],[\"finish\",\"完成任务\",\"10031000\"]]]'),(623900,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10031100\"]]]'),(624000,'[[[\"npc\",\"天佑女神！我就知道先知会引领我们走向胜利。\",\"0\"],[\"finish\",\"完成任务\",\"10031100\"]]]'),(624100,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10031200\"]]]'),(624200,'[[[\"npc\",\"可别得意哟，这群贼心不死的家伙们又发起新的一轮的攻势了！\",\"0\"],[\"finish\",\"完成任务\",\"10031200\"]]]'),(624300,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10031300\"]]]'),(624400,'[[[\"npc\",\"勇士！敌人的攻势似乎加强了，这显然是有组织的进攻，这意味着暗潮大军被委派了新的指示。\",\"0\"],[\"finish\",\"完成任务\",\"10031300\"]]]'),(624500,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10031400\"]]]'),(624600,'[[[\"npc\",\"先知的气息越来越薄弱了，我们必须尽快找到并解救她！\",\"0\"],[\"finish\",\"完成任务\",\"10031400\"]]]'),(624700,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10031500\"]]]'),(624800,'[[[\"npc\",\"我们在前进的途中遭遇了敌人的强烈的反抗，西区已经有很多姐妹都牺牲了！\",\"0\"],[\"finish\",\"完成任务\",\"10031500\"]]]'),(624900,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10031600\"]]]'),(625000,'[[[\"npc\",\"谢谢你！勇士，又替我们清理了麻烦！\",\"0\"],[\"finish\",\"完成任务\",\"10031600\"]]]'),(625100,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10031700\"]]]'),(625200,'[[[\"npc\",\"援军总算按时到达了，我们的防线又更加巩固了！\",\"0\"],[\"finish\",\"完成任务\",\"10031700\"]]]'),(625300,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10031800\"]]]'),(625400,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10031800\"]]]'),(625500,'[[[\"npc\",\"敌人的进攻好像变得更加猛烈了，我们必须加强防御，你赶快去通知密探。\",\"0\"],[\"trigger\",\"触发任务\",\"10031900\"]]]'),(625600,'[[[\"npc\",\"敌人的进攻好像变得更加猛烈了，我们必须加强防御，你赶快去通知密探。\",\"0\"],[\"finish\",\"完成任务\",\"10031900\"]]]'),(625700,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10032000\"]]]'),(625800,'[[[\"npc\",\"谢谢你带来的补给勇士，我们一定不负众望，坚守到底！\",\"0\"],[\"finish\",\"完成任务\",\"10032000\"]]]'),(625900,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10032100\"]]]'),(626000,'[[[\"npc\",\"看到大家这么努力！团长大人，我们也一定会坚守到底的！艾琳和我们的先锋队伍已经在西区的一个据点等着我们了。\",\"0\"],[\"finish\",\"完成任务\",\"10032100\"]]]'),(626100,'[[[\"role\",\"(眼前的艾琳虽然有些气喘吁吁，不过以前的胆小、慌张早已不复存在了！)\",\"0\"],[\"trigger\",\"触发任务\",\"10032200\"]]]'),(626200,'[[[\"npc\",\"我还以为你在半路上又被邪恶的家伙给缠住了，看来是我多虑了。\",\"0\"],[\"finish\",\"完成任务\",\"10032200\"]]]'),(626300,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10032300\"]]]'),(626400,'[[[\"npc\",\"干得好，我还想多揍几只怪物呢！\",\"0\"],[\"finish\",\"完成任务\",\"10032300\"]]]'),(626500,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10032400\"]]]'),(626600,'[[[\"npc\",\"艾琳阁下的容貌让我想起了某个熟人，可我一时半会想不起来。\",\"0\"],[\"finish\",\"完成任务\",\"10032400\"]]]'),(626700,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10032500\"]]]'),(626800,'[[[\"npc\",\"看来我们距离中心平台已经越来越近了，坚持住！\",\"0\"],[\"finish\",\"完成任务\",\"10032500\"]]]'),(626900,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10032600\"]]]'),(627000,'[[[\"npc\",\"让西区的战士们坚持住，我们很快就到了！\",\"0\"],[\"finish\",\"完成任务\",\"10032600\"]]]'),(627100,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10032700\"]]]'),(627200,'[[[\"npc\",\"干得漂亮，我们的麻烦很快就要被扫清了。\",\"0\"],[\"finish\",\"完成任务\",\"10032700\"]]]'),(627300,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10032800\"]]]'),(627400,'[[[\"npc\",\"勇士！欢迎回来，前方战况如何？还需要什么帮助吗？\",\"0\"],[\"finish\",\"完成任务\",\"10032800\"]]]'),(627500,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10032900\"]]]'),(627600,'[[[\"npc\",\"谢谢你，团长！由于你的努力，我们的压力减少了不少，请再给前方部队一些时间吧！\",\"0\"],[\"finish\",\"完成任务\",\"10032900\"]]]'),(627700,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10033000\"]]]'),(627800,'[[[\"npc\",\"看！道路已经被我们打开了，通往西区的路被彻底打开。\",\"0\"],[\"finish\",\"完成任务\",\"10033000\"]]]'),(627900,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10033100\"]]]'),(628000,'[[[\"npc\",\"我早就说过我们的艾琳已经长大了，早就可以独挡一面。\",\"0\"],[\"finish\",\"完成任务\",\"10033100\"]]]'),(628100,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10033200\"]]]'),(628200,'[[[\"npc\",\"妮哆他们肯定也会没事的，现在我们开始反攻。\",\"0\"],[\"finish\",\"完成任务\",\"10033200\"]]]'),(628300,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10033300\"]]]'),(628400,'[[[\"npc\",\"能与你并肩作战是我的荣幸，勇士！\",\"0\"],[\"finish\",\"完成任务\",\"10033300\"]]]'),(628500,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10033400\"]]]'),(628600,'[[[\"npc\",\"这群不自量力的家伙还试图偷袭我们，简直是自寻死路。\",\"0\"],[\"finish\",\"完成任务\",\"10033400\"]]]'),(628700,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10033500\"]]]'),(628800,'[[[\"npc\",\"团长，我刚刚得到的消息，你肯定会感兴趣。\",\"0\"],[\"finish\",\"完成任务\",\"10033500\"]]]'),(628900,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10033600\"]]]'),(629000,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10033600\"]]]'),(629100,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10033700\"]]]'),(629200,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10033700\"]]]'),(629300,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10033800\"]]]'),(629400,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10033800\"]]]'),(629500,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10033900\"]]]'),(629600,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10033900\"]]]'),(629700,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10034000\"]]]'),(629800,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10034000\"]]]'),(629900,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10034100\"]]]'),(630000,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10034100\"]]]'),(630100,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10034200\"]]]'),(630200,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10034200\"]]]'),(630300,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10034300\"]]]'),(630400,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10034300\"]]]'),(630500,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10034400\"]]]'),(630600,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10034400\"]]]'),(630700,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10034500\"]]]'),(630800,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10034500\"]]]'),(630900,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10034600\"]]]'),(631000,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10034600\"]]]'),(631100,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10034700\"]]]'),(631200,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10034700\"]]]'),(631300,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10034800\"]]]'),(631400,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10034800\"]]]'),(631500,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10034900\"]]]'),(631600,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10034900\"]]]'),(631700,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10035000\"]]]'),(631800,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10035000\"]]]'),(631900,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10035100\"]]]'),(632000,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10035100\"]]]'),(632100,'[[[\"npc\",\"命运中的勇者！我们终于见面了，我在此已经等你很久了。\",\"0\"],[\"trigger\",\"触发任务\",\"10035200\"]]]'),(632200,'[[[\"npc\",\"由于暗潮大军的侵蚀，我的生命即将枯竭...\",\"0\"],[\"finish\",\"完成任务\",\"10035200\"]]]'),(632300,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10035300\"]]]'),(632400,'[[[\"npc\",\"命运中的勇者，你果然不负众望。\",\"0\"],[\"finish\",\"完成任务\",\"10035300\"]]]'),(632500,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10035400\"]]]'),(632600,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10035400\"]]]'),(632700,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10035500\"]]]'),(632800,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10035500\"]]]'),(632900,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10035600\"]]]'),(633000,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10035600\"]]]'),(633100,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10035700\"]]]'),(633200,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10035700\"]]]'),(633300,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10035800\"]]]'),(633400,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10035800\"]]]'),(633500,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10035900\"]]]'),(633600,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10035900\"]]]'),(633700,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10036000\"]]]'),(633800,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10036000\"]]]'),(633900,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10036100\"]]]'),(634000,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10036100\"]]]'),(634100,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10036200\"]]]'),(634200,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10036200\"]]]'),(634300,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10036300\"]]]'),(634400,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10036300\"]]]'),(634500,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10036400\"]]]'),(634600,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10036400\"]]]'),(634700,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10036500\"]]]'),(634800,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10036500\"]]]'),(634900,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10036600\"]]]'),(635000,'[[[\"npc\",\"愿廊桥之光引领你前进的步伐！\",\"0\"],[\"finish\",\"完成任务\",\"10036600\"]]]'),(635100,'[[[\"npc\",\"黄昏廊桥十万火急，我需要你帮助，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10036700\"]]]'),(635200,'[[[\"npc\",\"廊桥之光将照亮你前行的脚步，勇士！\",\"0\"],[\"finish\",\"完成任务\",\"10036700\"]]]'),(700100,'[[[\"npc\",\"团长！我们到了，这里就是我们要来的地方。\",\"0\"],[\"trigger\",\"触发任务\",\"10036800\"]]]'),(700200,'[[[\"npc\",\"可这里的风沙太大了，我们根本无法前进。\",\"0\"],[\"finish\",\"完成任务\",\"10036800\"]]]'),(700300,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10036900\"]]]'),(700400,'[[[\"npc\",\"再大的风沙，也阻挡不了我们寻宝的脚步！\",\"0\"],[\"finish\",\"完成任务\",\"10036900\"]]]'),(700500,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10037000\"]]]'),(700600,'[[[\"npc\",\"没想到这里的怪物这么凶残！咦，金老板怎么不见了？\",\"0\"],[\"finish\",\"完成任务\",\"10037000\"]]]'),(700700,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10037100\"]]]'),(700800,'[[[\"npc\",\"我早按照你的叮嘱吩咐下去让大伙注意安全，可那个仗着自己有钱的中年男子偏偏不听，就知道瞎跑，现在好了！\",\"0\"],[\"finish\",\"完成任务\",\"10037100\"]]]'),(700900,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10037200\"]]]'),(701000,'[[[\"npc\",\"一定要帮我找到金老板！团长大人，要是金老板有个三长两短的话，我和哥哥也得去喝西北风了！\",\"0\"],[\"finish\",\"完成任务\",\"10037200\"]]]'),(701100,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10037300\"]]]'),(701200,'[[[\"npc\",\"我早就看金哆哆这个油腻的中年大叔不顺眼了，一天到晚就仗着自己有钱瞎搞，这次居然还屁颠屁颠的与我们一起行动！\",\"0\"],[\"finish\",\"完成任务\",\"10037300\"]]]'),(701300,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10037400\"]]]'),(701400,'[[[\"npc\",\"团长，我刚刚还询问营地的伙伴，他们谁都没有发现金哆哆最后的踪迹。\",\"0\"],[\"finish\",\"完成任务\",\"10037400\"]]]'),(701500,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10037500\"]]]'),(701600,'[[[\"npc\",\"这下可好了，搜遍了整个平台都没有找到金老板。\",\"0\"],[\"finish\",\"完成任务\",\"10037500\"]]]'),(701700,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10037600\"]]]'),(701800,'[[[\"npc\",\"这就叫咎由自取，金哆哆为了所谓的古墓宝藏连自己的命都不要了，真搞不懂这些有钱人的想法。\",\"0\"],[\"finish\",\"完成任务\",\"10037600\"]]]'),(701900,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10037700\"]]]'),(702000,'[[[\"npc\",\"不好啦！不好啦！平台上面的沙子越来越大了，我们必须转移。\",\"0\"],[\"finish\",\"完成任务\",\"10037700\"]]]'),(702100,'[[[\"npc\",\"根据我多年盗墓...不对！根据我多年寻宝的经验，金老板或许还活着。\",\"0\"],[\"trigger\",\"触发任务\",\"10037800\"]]]'),(702200,'[[[\"npc\",\"团长！我有个重大的发现，这是我们刚刚战斗找到的香水瓶。\",\"0\"],[\"finish\",\"完成任务\",\"10037800\"]]]'),(702300,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10037900\"]]]'),(702400,'[[[\"npc\",\"风沙变得越来越大了，团长。再这样下去，我们恐怕很难继续给队伍提供相应的补给。\",\"0\"],[\"finish\",\"完成任务\",\"10037900\"]]]'),(702500,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10038000\"]]]'),(702600,'[[[\"npc\",\"让我们赶快向下个区域前进吧！说不定金老板就在前面。\",\"0\"],[\"finish\",\"完成任务\",\"10038000\"]]]'),(702700,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10038100\"]]]'),(702800,'[[[\"npc\",\"就在我们前进的同时，越来越多怪物也向这边靠了过来，我总有种不详的预感。\",\"0\"],[\"finish\",\"完成任务\",\"10038100\"]]]'),(702900,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10038200\"]]]'),(703000,'[[[\"npc\",\"也不知道金哆哆这个家伙会不会被眼前这些怪物吓得屁滚尿流，反正我不会。\",\"0\"],[\"finish\",\"完成任务\",\"10038200\"]]]'),(703100,'[[[\"npc\",\"这股沾满了汗臭香水味，没错！就是他...\",\"0\"],[\"trigger\",\"触发任务\",\"10038300\"]]]'),(703200,'[[[\"npc\",\"别走啊！是我，我是金哆哆！\",\"0\"],[\"finish\",\"完成任务\",\"10038300\"]]]'),(703300,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10038400\"]]]'),(703400,'[[[\"npc\",\"我就知道你们不会抛下我不管的！\",\"0\"],[\"finish\",\"完成任务\",\"10038400\"]]]'),(703500,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10038500\"]]]'),(703600,'[[[\"npc\",\"太好了！金老板还活着！这回我和哥哥有活路了！\",\"0\"],[\"finish\",\"完成任务\",\"10038500\"]]]'),(703700,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10038600\"]]]'),(703800,'[[[\"npc\",\"当初为什么要带上这几个唯利是图的盗墓贼，我真想不明白！\",\"0\"],[\"finish\",\"完成任务\",\"10038600\"]]]'),(703900,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10038700\"]]]'),(704000,'[[[\"npc\",\"太好了！听到金哆哆的消息，应该可以让随行的几个财团大佬闭上他们的臭嘴了。\",\"0\"],[\"finish\",\"完成任务\",\"10038700\"]]]'),(704100,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10038800\"]]]'),(704200,'[[[\"npc\",\"消灭了这群怪物，后方总算稳固了，你就安心前进吧。\",\"0\"],[\"finish\",\"完成任务\",\"10038800\"]]]'),(704300,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10038900\"]]]'),(704400,'[[[\"npc\",\"这一阵一阵的风沙真是让人头疼，偏偏这个时候妮哆他们也不知了去向...\",\"0\"],[\"finish\",\"完成任务\",\"10038900\"]]]'),(704500,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10039000\"]]]'),(704600,'[[[\"npc\",\"妮哆？零零哆？我从一开始就没发现他们的踪迹，我关心的只有古董！\",\"0\"],[\"finish\",\"完成任务\",\"10039000\"]]]'),(704700,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10039100\"]]]'),(704800,'[[[\"npc\",\"根据我们最后一期行动的情报来看，剩下的同伴们应该是往古墓的上城区去了。\",\"0\"],[\"finish\",\"完成任务\",\"10039100\"]]]'),(704900,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10039200\"]]]'),(705000,'[[[\"npc\",\"该死的！通往上城区的石梯居然坍塌了，不！\",\"0\"],[\"finish\",\"完成任务\",\"10039200\"]]]'),(705100,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10039300\"]]]'),(705200,'[[[\"npc\",\"石梯的坍塌应该跟我们的活动有关，不过我们在前进的同时必须处理掉剩下的古代陷阱。\",\"0\"],[\"finish\",\"完成任务\",\"10039300\"]]]'),(705300,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10039400\"]]]'),(705400,'[[[\"npc\",\"解除陷阱一直就是我们的老本行，也是金老板雇佣我们兄弟两的重要原因，但老板不开口，我没办法动工啊。\",\"0\"],[\"finish\",\"完成任务\",\"10039400\"]]]'),(705500,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10039500\"]]]'),(705600,'[[[\"npc\",\"我花重金来可不是让那两只废物来旅游的，让他们赶快动手！\",\"0\"],[\"finish\",\"完成任务\",\"10039500\"]]]'),(705700,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10039600\"]]]'),(705800,'[[[\"npc\",\"陷阱区的怪物已经被我们清理干净了，可以安心工作啦。\",\"0\"],[\"finish\",\"完成任务\",\"10039600\"]]]'),(705900,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10039700\"]]]'),(706000,'[[[\"npc\",\"我可是花了好大的功夫才把这些该死的陷阱解除，也不知道老板会不会给我加薪。\",\"0\"],[\"finish\",\"完成任务\",\"10039700\"]]]'),(706100,'[[[\"npc\",\"赶快去通知金老板，陷阱已经全部解除了。\",\"0\"],[\"trigger\",\"触发任务\",\"10039800\"]]]'),(706200,'[[[\"npc\",\"总算解决了一个大麻烦，看来是时候对这些迂腐的员工进行新一轮的感恩教育了。\",\"0\"],[\"finish\",\"完成任务\",\"10039800\"]]]'),(706300,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10039900\"]]]'),(706400,'[[[\"npc\",\"看来金大叔在关键时候还是能派上用场的，护民官让我们带上他看来是个合理的决定。\",\"0\"],[\"finish\",\"完成任务\",\"10039900\"]]]'),(706500,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10040000\"]]]'),(706600,'[[[\"npc\",\"接下来！我们就全力寻找妮哆她们吧。\",\"0\"],[\"finish\",\"完成任务\",\"10040000\"]]]'),(706700,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10040100\"]]]'),(706800,'[[[\"npc\",\"看上去我就只能在这个小平台上寻找宝贝了，但愿白痴二人组的哥哥能够有所发现。\",\"0\"],[\"finish\",\"完成任务\",\"10040100\"]]]'),(706900,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10040200\"]]]'),(707000,'[[[\"npc\",\"在和你汇合之前，我们曾经有个小队就快马加鞭地爬上了石梯，还没等我们确认消息，石梯就塌陷了。\",\"0\"],[\"finish\",\"完成任务\",\"10040200\"]]]'),(707100,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10040300\"]]]'),(707200,'[[[\"npc\",\"说不定...说不定就妮哆他们。\",\"0\"],[\"finish\",\"完成任务\",\"10040300\"]]]'),(707300,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10040400\"]]]'),(707400,'[[[\"npc\",\"我在这里一无所获，看来你们要寻找的东西不在这里。\",\"0\"],[\"finish\",\"完成任务\",\"10040400\"]]]'),(707500,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10040500\"]]]'),(707600,'[[[\"npc\",\"听了他们的鬼话，我才会被落在这里，你可一定要替我找到阿里咚咚。\",\"0\"],[\"finish\",\"完成任务\",\"10040500\"]]]'),(707700,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10040600\"]]]'),(707800,'[[[\"npc\",\"我的哥哥叫阿里咚咚很可能就在上城区，他和我一样都是盗...探险家！\",\"0\"],[\"finish\",\"完成任务\",\"10040600\"]]]'),(707900,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10040700\"]]]'),(708000,'[[[\"npc\",\"团...团长大人！可算等到你了。\",\"0\"],[\"finish\",\"完成任务\",\"10040700\"]]]'),(708100,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10040800\"]]]'),(708200,'[[[\"npc\",\"我和小分队刚刚抵达上城区，石梯就坍塌了，在再后来沙暴就来了...\",\"0\"],[\"finish\",\"完成任务\",\"10040800\"]]]'),(708300,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10040900\"]]]'),(708400,'[[[\"npc\",\"哎呦~是哪个不长眼睛的家伙踩到我的尾巴啦，看我怎么...收拾你！原来是你！\",\"0\"],[\"finish\",\"完成任务\",\"10040900\"]]]'),(708500,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10041000\"]]]'),(708600,'[[[\"npc\",\"我就知道零零哆这个家伙不会这么安分守己等待救援到来的，看来这个古墓要比我们想象得大得多。\",\"0\"],[\"finish\",\"完成任务\",\"10041000\"]]]'),(708700,'[[[\"npc\",\"对了，哥哥之前给了我一张关于古墓的情报，慌乱之中被我不小心弄丢了。\",\"0\"],[\"trigger\",\"触发任务\",\"10041100\"]]]'),(708800,'[[[\"npc\",\"你的表情告诉我，你一定找到了妮哆他们对吗？太好了，我这慌乱的心总算可以消停会儿了。\",\"0\"],[\"finish\",\"完成任务\",\"10041100\"]]]'),(708900,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10041200\"]]]'),(709000,'[[[\"npc\",\"喂！喂~我说团长大人，我来这里可不是度假的，你在上面肯定发现了什么对吗？快告诉我！\",\"0\"],[\"finish\",\"完成任务\",\"10041200\"]]]'),(709100,'[[[\"npc\",\"别~别拿这种质疑的眼神看着我啊，我早说过我来这里是为了寻找阿拉丁来着的，那可是能满足任何愿望的真神！\",\"0\"],[\"trigger\",\"触发任务\",\"10041300\"]]]'),(709200,'[[[\"npc\",\"这就是金哆哆叔叔连命都不要也要跟我们来沙漠的原因吗？真是可笑，简直就是愚昧。\",\"0\"],[\"finish\",\"完成任务\",\"10041300\"]]]'),(709300,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10041400\"]]]'),(709400,'[[[\"npc\",\"你们这些小年轻怎么懂得我们这些中年男子的寻宝梦想呢？阿拉丁！他肯定就在这里。\",\"0\"],[\"finish\",\"完成任务\",\"10041400\"]]]'),(709500,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10041500\"]]]'),(709600,'[[[\"npc\",\"阿拉丁！那不是我小时候和妮哆过家家时扮演的角色吗？这玩意真的...存在？\",\"0\"],[\"finish\",\"完成任务\",\"10041500\"]]]'),(709700,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10041600\"]]]'),(709800,'[[[\"npc\",\"事到如今我也不瞒你们了，我和哥哥正是受金老板托来寻找所谓愿望之神—阿拉丁\",\"0\"],[\"finish\",\"完成任务\",\"10041600\"]]]'),(709900,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10041700\"]]]'),(710000,'[[[\"npc\",\"我们才没时间陪金叔叔瞎搞呢！更多的敌人逼近了，我们必须寻找继续前进的道路！\",\"0\"],[\"finish\",\"完成任务\",\"10041700\"]]]'),(710100,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10041800\"]]]'),(710200,'[[[\"npc\",\"好险啊！那些家伙差点就要窜上我的侦察高地了，多亏你及时赶来。快，我发现了一个有趣的现象。\",\"0\"],[\"finish\",\"完成任务\",\"10041800\"]]]'),(710300,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10041900\"]]]'),(710400,'[[[\"npc\",\"根据我现在位置，没有探索的区域只剩下东北方向两座石桥，可那里怪物是在太多，我们根本无法前进。\",\"0\"],[\"finish\",\"完成任务\",\"10041900\"]]]'),(710500,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10042000\"]]]'),(710600,'[[[\"npc\",\"可算见到你了，我的团长大人！是我！阿里咚咚，阿里耙耙的哥哥。请替我向金老板和弟弟报个平安，晚些我再跟你汇报最新的进展。\",\"0\"],[\"finish\",\"完成任务\",\"10042000\"]]]'),(710700,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10042100\"]]]'),(710800,'[[[\"npc\",\"这家伙没死最好，要不然我付的薪水可都要泡汤了！\",\"0\"],[\"finish\",\"完成任务\",\"10042100\"]]]'),(710900,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10042200\"]]]'),(711000,'[[[\"npc\",\"哥哥没事！太好了，看来找到金老板说的阿拉丁有望了！\",\"0\"],[\"finish\",\"完成任务\",\"10042200\"]]]'),(711100,'[[[\"npc\",\"没错！就是那两座桥，波动仪的能量也来自那里，赶紧让我们想办法冲过去。\",\"0\"],[\"trigger\",\"触发任务\",\"10042300\"]]]'),(711200,'[[[\"npc\",\"别！别冲动，我知道你很想前进，可是事情真的有这么简单吗？我前进的地图也不见了，肯定是刚刚被弄丢了！\",\"0\"],[\"finish\",\"完成任务\",\"10042300\"]]]'),(711300,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10042400\"]]]'),(711400,'[[[\"npc\",\"让阿里咚咚赶快行动！别这么婆婆妈妈的，时间就是金钱，我的团长！\",\"0\"],[\"finish\",\"完成任务\",\"10042400\"]]]'),(711500,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10042500\"]]]'),(711600,'[[[\"npc\",\"你们在下面的争吵声我隔着墙都能听见！就算我们要继续前进，也得先肃清敌人呀！\",\"0\"],[\"finish\",\"完成任务\",\"10042500\"]]]'),(711700,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10042600\"]]]'),(711800,'[[[\"npc\",\"那个唠唠叨叨的油腻大叔什么时候才会消停，怪物都被他引过来了！\",\"0\"],[\"finish\",\"完成任务\",\"10042600\"]]]'),(711900,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10042700\"]]]'),(712000,'[[[\"npc\",\"什么！地图被哥哥弄丢了，那可是我们花了大价钱找到黑市商人买来的！\",\"0\"],[\"finish\",\"完成任务\",\"10042700\"]]]'),(712100,'[[[\"npc\",\"不过别急，根据哥哥之前丢三落四的毛病，你顺着我们前进过的路线应该可以找到。\",\"0\"],[\"trigger\",\"触发任务\",\"10042800\"]]]'),(712200,'[[[\"npc\",\"太...太好了！这是我之前丢掉的地图，谢谢你！团长大人。等等我，我立刻规划行动路线。\",\"0\"],[\"finish\",\"完成任务\",\"10042800\"]]]'),(712300,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10042900\"]]]'),(712400,'[[[\"npc\",\"第二批先遣队到底什么时候才能赶来，赶快去找山姆，跟他确认下先遣队的情况吧！。\",\"0\"],[\"finish\",\"完成任务\",\"10042900\"]]]'),(712500,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10043000\"]]]'),(712600,'[[[\"npc\",\"让卫官大人放心好了，队员们都已经整装待发，新一轮的驻守任务就交给我们吧！\",\"0\"],[\"finish\",\"完成任务\",\"10043000\"]]]'),(712700,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10043100\"]]]'),(712800,'[[[\"npc\",\"我算是见识到金老板那张嘴的厉害了，这样下去不被怪物打死也得被他的泡沫淹死。\",\"0\"],[\"finish\",\"完成任务\",\"10043100\"]]]'),(712900,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10043200\"]]]'),(713000,'[[[\"npc\",\"我可跟你说清楚啦！找不到阿拉丁我哪都不去，别想把我骗回营地，什么大风大浪我么见过。\",\"0\"],[\"finish\",\"完成任务\",\"10043200\"]]]'),(713100,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10043300\"]]]'),(713200,'[[[\"npc\",\"油腻大叔现在的样子让我想起了以前的我，是不是真有些相似之处？\",\"0\"],[\"finish\",\"完成任务\",\"10043300\"]]]'),(713300,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10043400\"]]]'),(713400,'[[[\"npc\",\"队伍集结的怎么样了？再这样下去我的魔力瓶都要枯竭了。\",\"0\"],[\"finish\",\"完成任务\",\"10043400\"]]]'),(713500,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10043500\"]]]'),(713600,'[[[\"npc\",\"没想到那个愣头愣脑的阿里咚咚居然真有一套，我还没见过这么详细的地图呢！\",\"0\"],[\"finish\",\"完成任务\",\"10043500\"]]]'),(713700,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10043600\"]]]'),(713800,'[[[\"npc\",\"我虽然丢三落四，可我做起事来从不含糊，我们进入正题吧！\",\"0\"],[\"finish\",\"完成任务\",\"10043600\"]]]'),(713900,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10043700\"]]]'),(714000,'[[[\"npc\",\"很好！清理掉了距离我们营地最近的这波怪物，后方的营地应该稳固了。\",\"0\"],[\"finish\",\"完成任务\",\"10043700\"]]]'),(714100,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10043800\"]]]'),(714200,'[[[\"npc\",\"这回我们再也不用担心怪物会嗖地一声从后面窜出来了。\",\"0\"],[\"finish\",\"完成任务\",\"10043800\"]]]'),(714300,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10043900\"]]]'),(714400,'[[[\"npc\",\"喂！阿里咚咚这个家伙到底现在搞什么飞机，你们为什么还不行动？\",\"0\"],[\"finish\",\"完成任务\",\"10043900\"]]]'),(714500,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10044000\"]]]'),(714600,'[[[\"npc\",\"看来哥哥这回是动真格的了，我没说错吧！请你相信他。\",\"0\"],[\"finish\",\"完成任务\",\"10044000\"]]]'),(714700,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10044100\"]]]'),(714800,'[[[\"npc\",\"不是说！怪物都已经被隔离在我们的势力范围之外了吗？你们这些骗子！\",\"0\"],[\"finish\",\"完成任务\",\"10044100\"]]]'),(714900,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10044200\"]]]'),(715000,'[[[\"npc\",\"团长！我已经根据怪物活动频率彻底锁定他们的行动，我们的搜寻工作正式展开了。\",\"0\"],[\"finish\",\"完成任务\",\"10044200\"]]]'),(715100,'[[[\"npc\",\"不好！我们的行动似乎激起了一个巨大的能量波动，它冲我们来了！\",\"0\"],[\"trigger\",\"触发任务\",\"10044300\"]]]'),(715200,'[[[\"npc\",\"太可怕！我敢断定，这股能量就是我们要找的大地魔晶。\",\"0\"],[\"finish\",\"完成任务\",\"10044300\"]]]'),(715300,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10044400\"]]]'),(715400,'[[[\"npc\",\"我们明明减少了活动的频率，可是怪物怎么还能察觉到我们的存在？\",\"0\"],[\"finish\",\"完成任务\",\"10044400\"]]]'),(715500,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10044500\"]]]'),(715600,'[[[\"npc\",\"不好啦！不好了！怪物们怎么又朝我们扑过来了，妮哆不是刚刚建好魔法屏障吗？\",\"0\"],[\"finish\",\"完成任务\",\"10044500\"]]]'),(715700,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10044600\"]]]'),(715800,'[[[\"npc\",\"一定是我们的探测活动不小心触动了古墓的自我防御模式，才会让怪物们都涌向我们这里。\",\"0\"],[\"finish\",\"完成任务\",\"10044600\"]]]'),(715900,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10044700\"]]]'),(716000,'[[[\"npc\",\"事到如今，我们也只能硬着头皮上了！\",\"0\"],[\"finish\",\"完成任务\",\"10044700\"]]]'),(716100,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10044800\"]]]'),(716200,'[[[\"npc\",\"团长大人，我没事！你也一定要注意安全。\",\"0\"],[\"finish\",\"完成任务\",\"10044800\"]]]'),(716300,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10044900\"]]]'),(716400,'[[[\"npc\",\"上面厮打声是怎么回事？你们...你们可一定要保护好我的安全。\",\"0\"],[\"finish\",\"完成任务\",\"10044900\"]]]'),(716500,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10045000\"]]]'),(716600,'[[[\"npc\",\"哎呦！吓死我了，不知道他们下一波冲锋会是什么时候。\",\"0\"],[\"finish\",\"完成任务\",\"10045000\"]]]'),(716700,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10045100\"]]]'),(716800,'[[[\"npc\",\"怪物的活动居然变频繁了，我怎么就没想到呢？\",\"0\"],[\"finish\",\"完成任务\",\"10045100\"]]]'),(716900,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10045200\"]]]'),(717000,'[[[\"npc\",\"我现在真的有点后悔赞助你们这些行动了，现在看来真是凶多吉少...\",\"0\"],[\"finish\",\"完成任务\",\"10045200\"]]]'),(717100,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10045300\"]]]'),(717200,'[[[\"npc\",\"金大叔的风凉话我早就听够了，现在的当务之急是弄清楚这些怪物的规律，否则我们根本无法前进。\",\"0\"],[\"finish\",\"完成任务\",\"10045300\"]]]'),(717300,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10045400\"]]]'),(717400,'[[[\"npc\",\"肯定是你们触动了不该触动的神灵才会让我们陷入这个困境的，你...你倒是想想办法啊！\",\"0\"],[\"finish\",\"完成任务\",\"10045400\"]]]'),(717500,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10045500\"]]]'),(717600,'[[[\"npc\",\"神灵？我怎么就没想到呢，金老板这回可棒了大忙。请帮我给妮哆问个话。\",\"0\"],[\"finish\",\"完成任务\",\"10045500\"]]]'),(717700,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10045600\"]]]'),(717800,'[[[\"npc\",\"感受火焰的威力吧！怪物们！\",\"0\"],[\"finish\",\"完成任务\",\"10045600\"]]]'),(717900,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10045700\"]]]'),(718000,'[[[\"npc\",\"古历日期，阿里咚咚为什么会让你来问个问题？\",\"0\"],[\"finish\",\"完成任务\",\"10045700\"]]]'),(718100,'[[[\"npc\",\"作为一名精打细算的商人，我可从来不会忘记日期这样一个重要的东西。今天就是古历的蛇月星日，刚好也是我收租的日子。\",\"0\"],[\"trigger\",\"触发任务\",\"10045800\"]]]'),(718200,'[[[\"npc\",\"蛇月！星日！果然没错，今天就是传说中灯神祭祀的日子。\",\"0\"],[\"finish\",\"完成任务\",\"10045800\"]]]'),(718300,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10045900\"]]]'),(718400,'[[[\"npc\",\"灯神祭祀日，好像是有这么一个特别的纪念日来着。\",\"0\"],[\"finish\",\"完成任务\",\"10045900\"]]]'),(718500,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10046000\"]]]'),(718600,'[[[\"npc\",\"阿里咚咚的意思是说，这些怪物活动频繁的原因完全是因为祭祀日的原因吗？与我们无关。\",\"0\"],[\"finish\",\"完成任务\",\"10046000\"]]]'),(718700,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10046100\"]]]'),(718800,'[[[\"npc\",\"嘿嘿！没想到吧，我就说关键时候你肯定用的上我。\",\"0\"],[\"finish\",\"完成任务\",\"10046100\"]]]'),(718900,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10046200\"]]]'),(719000,'[[[\"npc\",\"按照阿里咚咚和零零哆的最新情报，我们还缺少一直阻拦怪物前进的防御力量。\",\"0\"],[\"finish\",\"完成任务\",\"10046200\"]]]'),(719100,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10046300\"]]]'),(719200,'[[[\"npc\",\"零零哆已经跟我确认过了，能量的波动就是东北方，同时我们会好好守住这里的。\",\"0\"],[\"finish\",\"完成任务\",\"10046300\"]]]'),(719300,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10046400\"]]]'),(719400,'[[[\"npc\",\"真希望这场令人胆战心惊的行动快点结束，拜托你了！团长。\",\"0\"],[\"finish\",\"完成任务\",\"10046400\"]]]'),(719500,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10046500\"]]]'),(719600,'[[[\"npc\",\"艾琳的派出先遣队刚刚通过绳索爬了上来，可以让他们组成第一波防御阵型！\",\"0\"],[\"finish\",\"完成任务\",\"10046500\"]]]'),(719700,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10046600\"]]]'),(719800,'[[[\"npc\",\"先遣队来了！我们终于不用孤军奋战了。\",\"0\"],[\"finish\",\"完成任务\",\"10046600\"]]]'),(719900,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10046700\"]]]'),(720000,'[[[\"npc\",\"说好了，等结束行动，我一定要在飞艇上舒舒服服地泡个热水澡。\",\"0\"],[\"finish\",\"完成任务\",\"10046700\"]]]'),(720100,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10046800\"]]]'),(720200,'[[[\"npc\",\"这个区域的行动马上就要结束了，我们终于可以继续前进啦！\",\"0\"],[\"finish\",\"完成任务\",\"10046800\"]]]'),(720300,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10046900\"]]]'),(720400,'[[[\"npc\",\"这是最后一批先遣队成员了，我已经迫不及待地准备与你行动了，团长！\",\"0\"],[\"finish\",\"完成任务\",\"10046900\"]]]'),(720500,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10047000\"]]]'),(720600,'[[[\"npc\",\"没时间闲谈了团长，艾琳刚刚已经带着队员突破东北石桥怪物的突围，她们现在肯定需要我们的帮助。\",\"0\"],[\"finish\",\"完成任务\",\"10047000\"]]]'),(720700,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10047100\"]]]'),(720800,'[[[\"npc\",\"放心吧！我不会让艾琳受那些怪物的欺负了，他们来多少我揍多少。\",\"0\"],[\"finish\",\"完成任务\",\"10047100\"]]]'),(720900,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10047200\"]]]'),(721000,'[[[\"npc\",\"团长！这里的怪物跟我们之前遭遇的完全不同，可千万要小心。\",\"0\"],[\"finish\",\"完成任务\",\"10047200\"]]]'),(721100,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10047300\"]]]'),(721200,'[[[\"npc\",\"就在你赶往与艾琳汇合的时候，我突然在另外一座桥边侦测到了躁动的身影。\",\"0\"],[\"finish\",\"完成任务\",\"10047300\"]]]'),(721300,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10047400\"]]]'),(721400,'[[[\"npc\",\"谢...谢谢...的帮助，我是...\",\"0\"],[\"finish\",\"完成任务\",\"10047400\"]]]'),(721500,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10047500\"]]]'),(721600,'[[[\"npc\",\"...真是冤家路窄啊，没想到你们这群家伙也会出现这里。我...我要宰了你。\",\"0\"],[\"finish\",\"完成任务\",\"10047500\"]]]'),(721700,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10047600\"]]]'),(721800,'[[[\"npc\",\"古鲁，我对这个名字有印象。难道是你们说的那个要抢我们船的家伙吗？\",\"0\"],[\"finish\",\"完成任务\",\"10047600\"]]]'),(721900,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10047700\"]]]'),(722000,'[[[\"npc\",\"居然是绑架我的坏家伙！团长，这次我们绝对不能饶了他！\",\"0\"],[\"finish\",\"完成任务\",\"10047700\"]]]'),(722100,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10047800\"]]]'),(722200,'[[[\"npc\",\"你...你为什么...为什么要救我，你...你们和帝国军都想要我死，我这就满足你们...\",\"0\"],[\"finish\",\"完成任务\",\"10047800\"]]]'),(722300,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10047900\"]]]'),(722400,'[[[\"npc\",\"这种歹毒的家伙为什么会出现在这里，难道他也是为了水晶而来吗？\",\"0\"],[\"finish\",\"完成任务\",\"10047900\"]]]'),(722500,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10048000\"]]]'),(722600,'[[[\"npc\",\"古鲁的出现绝对没有我们想地这么简单，我们一定要弄清楚才行，先把他救起来再说吧。\",\"0\"],[\"finish\",\"完成任务\",\"10048000\"]]]'),(722700,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10048100\"]]]'),(722800,'[[[\"npc\",\"什么！你居然要救那个曾经想致我们于死地的坏蛋！我抗议，我反对！\",\"0\"],[\"finish\",\"完成任务\",\"10048100\"]]]'),(722900,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10048200\"]]]'),(723000,'[[[\"npc\",\"我知道了...赶快把伤药给他吧。\",\"0\"],[\"finish\",\"完成任务\",\"10048200\"]]]'),(723100,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10048300\"]]]'),(723200,'[[[\"role\",\"(你将伤药递给了古鲁，缓过气来的他的眼中充满了复杂的情绪...)\",\"0\"],[\"finish\",\"完成任务\",\"10048300\"]]]'),(723300,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10048400\"]]]'),(723400,'[[[\"npc\",\"快去问问他都知道些什么吧！\",\"0\"],[\"finish\",\"完成任务\",\"10048400\"]]]'),(723500,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10048500\"]]]'),(723600,'[[[\"npc\",\"自从上次夺船的计划失败之后，我们就被帝国军拘捕了！这次我也是被他们胁迫来到这里的。\",\"0\"],[\"finish\",\"完成任务\",\"10048500\"]]]'),(723700,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10048600\"]]]'),(723800,'[[[\"npc\",\"又是帝国军，我们一定要提高警惕。\",\"0\"],[\"finish\",\"完成任务\",\"10048600\"]]]'),(723900,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10048700\"]]]'),(724000,'[[[\"npc\",\"这个满嘴胡说的家伙是不可相信的，团长！你忘了他差点害死我们。\",\"0\"],[\"finish\",\"完成任务\",\"10048700\"]]]'),(724100,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10048800\"]]]'),(724200,'[[[\"npc\",\"之后帝国军就强迫我们四处寻找魔晶，稍有不从就大开杀戒。我们全都变成了傀儡。\",\"0\"],[\"finish\",\"完成任务\",\"10048800\"]]]'),(724300,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10048900\"]]]'),(724400,'[[[\"npc\",\"地精？据说那些不听话的地精都被帝国军处决了。\",\"0\"],[\"finish\",\"完成任务\",\"10048900\"]]]'),(724500,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10049000\"]]]'),(724600,'[[[\"npc\",\"虽然听起来很可怜，但我才不会同情那些伤害过我的家伙们。\",\"0\"],[\"finish\",\"完成任务\",\"10049000\"]]]'),(724700,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10049100\"]]]'),(724800,'[[[\"npc\",\"你们还在等什么！士可杀不可辱！给我个痛快，我再也不想被羞辱了。\",\"0\"],[\"finish\",\"完成任务\",\"10049100\"]]]'),(724900,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10049200\"]]]'),(725000,'[[[\"npc\",\"你可要想清楚啊！团长，地精天生就是寻宝奇才说不定可以帮助我们寻找水晶。\",\"0\"],[\"finish\",\"完成任务\",\"10049200\"]]]'),(725100,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10049300\"]]]'),(725200,'[[[\"npc\",\"阿里咚咚说的有道理，我们倒不如彻底弄清楚这家伙的目的，反正他现在手无缚鸡之力。\",\"0\"],[\"finish\",\"完成任务\",\"10049300\"]]]'),(725300,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10049400\"]]]'),(725400,'[[[\"npc\",\"你们真不杀我？好，那就让我也出一份力吧。原本帝国军也是派我来找水晶的，没人比地精更擅长寻宝了。\",\"0\"],[\"finish\",\"完成任务\",\"10049400\"]]]'),(725500,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10049500\"]]]'),(725600,'[[[\"npc\",\"我们...我们真的要相信他吗！还要我在高地保护他的安全，你简直疯了！\",\"0\"],[\"finish\",\"完成任务\",\"10049500\"]]]'),(725700,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10049600\"]]]'),(725800,'[[[\"npc\",\"这应该是我们找到阿拉丁的关键了，船长。\",\"0\"],[\"finish\",\"完成任务\",\"10049600\"]]]'),(725900,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10049700\"]]]'),(726000,'[[[\"npc\",\"太好了，我就知道不会将我们抛下的！\",\"0\"],[\"finish\",\"完成任务\",\"10049700\"]]]'),(726100,'[[[\"npc\",\"去找零零哆吧，他好像有一份特殊的情报要汇报！\",\"0\"],[\"trigger\",\"触发任务\",\"10049800\"]]]'),(726200,'[[[\"npc\",\"你来的正好，我刚好要找你。\",\"0\"],[\"finish\",\"完成任务\",\"10049800\"]]]'),(726300,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10049900\"]]]'),(726400,'[[[\"npc\",\"我的魔力感到了一阵寒冷之袭，这是不详的预兆。\",\"0\"],[\"finish\",\"完成任务\",\"10049900\"]]]'),(726500,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10050000\"]]]'),(726600,'[[[\"npc\",\"你可算来了，团长！怪物们都烧到屁股上来了！\",\"0\"],[\"finish\",\"完成任务\",\"10050000\"]]]'),(726700,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10050100\"]]]'),(726800,'[[[\"npc\",\"太好了，我就知道不会将我们抛下的！\",\"0\"],[\"finish\",\"完成任务\",\"10050100\"]]]'),(726900,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10050200\"]]]'),(727000,'[[[\"npc\",\"你真是我们的救星，团长大人。\",\"0\"],[\"finish\",\"完成任务\",\"10050200\"]]]'),(727100,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10050300\"]]]'),(727200,'[[[\"npc\",\"不好了！那个狡猾绿皮看上去有危险！\",\"0\"],[\"finish\",\"完成任务\",\"10050300\"]]]'),(727300,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10050400\"]]]'),(727400,'[[[\"npc\",\"就算你救了我，我也不会感激你们的！人类。\",\"0\"],[\"finish\",\"完成任务\",\"10050400\"]]]'),(727500,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10050500\"]]]'),(727600,'[[[\"npc\",\"就算你救了我，我也不会感激你的，人类！\",\"0\"],[\"finish\",\"完成任务\",\"10050500\"]]]'),(727700,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10050600\"]]]'),(727800,'[[[\"npc\",\"就算你救了我，我也不会感激你的，人类！\",\"0\"],[\"finish\",\"完成任务\",\"10050600\"]]]'),(727900,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10050700\"]]]'),(728000,'[[[\"npc\",\"刚刚好险！多亏了你，团长大人。\",\"0\"],[\"finish\",\"完成任务\",\"10050700\"]]]'),(728100,'[[[\"npc\",\"我劝你还是先返回你营地确定一下你们这些笨蛋的安全再说。\",\"0\"],[\"trigger\",\"触发任务\",\"10050800\"]]]'),(728200,'[[[\"npc\",\"好极了！我已经锁定了新目标。\",\"0\"],[\"finish\",\"完成任务\",\"10050800\"]]]'),(728300,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10050900\"]]]'),(728400,'[[[\"npc\",\"不好了！怪物们又涌了上来，太可怕了。\",\"0\"],[\"finish\",\"完成任务\",\"10050900\"]]]'),(728500,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10051000\"]]]'),(728600,'[[[\"npc\",\"接下来，让我们同心协力一起封印住这些怪物们。\",\"0\"],[\"finish\",\"完成任务\",\"10051000\"]]]'),(728700,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10051100\"]]]'),(728800,'[[[\"npc\",\"我就知道你一定能行了，这回我们距离胜利又更近了。\",\"0\"],[\"finish\",\"完成任务\",\"10051100\"]]]'),(728900,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10051200\"]]]'),(729000,'[[[\"npc\",\"团长，我们成功了！那些怪物们又被击退了。\",\"0\"],[\"finish\",\"完成任务\",\"10051200\"]]]'),(729100,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10051300\"]]]'),(729200,'[[[\"npc\",\"看准了再下手好吗，你差点削到了我的脑袋！\",\"0\"],[\"finish\",\"完成任务\",\"10051300\"]]]'),(729300,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10051400\"]]]'),(729400,'[[[\"npc\",\"没想到，你还真有两下子。\",\"0\"],[\"finish\",\"完成任务\",\"10051400\"]]]'),(729500,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10051500\"]]]'),(729600,'[[[\"npc\",\"迎接魔物们的冲击吧，还愣着干什么！\",\"0\"],[\"finish\",\"完成任务\",\"10051500\"]]]'),(729700,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10051600\"]]]'),(729800,'[[[\"npc\",\"跟你们一起战斗的时光虽然算不上太美好，但也不算糟糕。\",\"0\"],[\"finish\",\"完成任务\",\"10051600\"]]]'),(729900,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10051700\"]]]'),(730000,'[[[\"npc\",\"封印被解除了，我们很快就能找到守护者了！\",\"0\"],[\"finish\",\"完成任务\",\"10051700\"]]]'),(730100,'[[[\"npc\",\"团长，你来的正是时候。\",\"0\"],[\"trigger\",\"触发任务\",\"10051800\"]]]'),(730200,'[[[\"npc\",\"古鲁那个家伙肯定没安好心，我倒要看看他还有什么好说的。\",\"0\"],[\"finish\",\"完成任务\",\"10051800\"]]]'),(730300,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10051900\"]]]'),(730400,'[[[\"npc\",\"我不得不说，虽然我很讨厌你们，但是你们真的很强。\",\"0\"],[\"finish\",\"完成任务\",\"10051900\"]]]'),(730500,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10052000\"]]]'),(730600,'[[[\"npc\",\"刚刚真的好险，差点被魔物们桶出了一个大窟窿。\",\"0\"],[\"finish\",\"完成任务\",\"10052000\"]]]'),(730700,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10052100\"]]]'),(730800,'[[[\"npc\",\"太好了，我就知道不会将我们抛下的！\",\"0\"],[\"finish\",\"完成任务\",\"10052100\"]]]'),(730900,'[[[\"npc\",\"真没想到，我也有披上盔甲驰骋战场的时候。\",\"0\"],[\"trigger\",\"触发任务\",\"10052200\"]]]'),(731000,'[[[\"npc\",\"古墓的守护者就在前面等着我们呢！\",\"0\"],[\"finish\",\"完成任务\",\"10052200\"]]]'),(731100,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10052300\"]]]'),(731200,'[[[\"npc\",\"我在这里等你们很久了，命运的勇士们！\",\"0\"],[\"finish\",\"完成任务\",\"10052300\"]]]'),(731300,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10052400\"]]]'),(731400,'[[[\"npc\",\"我感觉到了一股可怕的力量，没错！是魔物！\",\"0\"],[\"finish\",\"完成任务\",\"10052400\"]]]'),(731500,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10052500\"]]]'),(731600,'[[[\"npc\",\"团长，这里就交给我吧！我已经不再是那个爱哭鬼了。\",\"0\"],[\"finish\",\"完成任务\",\"10052500\"]]]'),(731700,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10052600\"]]]'),(731800,'[[[\"npc\",\"太好了，我就知道不会将我们抛下的！\",\"0\"],[\"finish\",\"完成任务\",\"10052600\"]]]'),(731900,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10052700\"]]]'),(732000,'[[[\"npc\",\"太好了，我就知道不会将我们抛下的！\",\"0\"],[\"finish\",\"完成任务\",\"10052700\"]]]'),(732100,'[[[\"npc\",\"我们团结一致，没有什么可以打倒我们。\",\"0\"],[\"trigger\",\"触发任务\",\"10052800\"]]]'),(732200,'[[[\"npc\",\"艾琳看上去有些支撑不住了，我们必须帮帮她！\",\"0\"],[\"finish\",\"完成任务\",\"10052800\"]]]'),(732300,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10052900\"]]]'),(732400,'[[[\"npc\",\"团长！我挡住了突袭的魔物们，你这里怎么样了？\",\"0\"],[\"finish\",\"完成任务\",\"10052900\"]]]'),(732500,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10053000\"]]]'),(732600,'[[[\"npc\",\"守护水晶的责任就在我们身上，我们必须全力以赴。\",\"0\"],[\"finish\",\"完成任务\",\"10053000\"]]]'),(732700,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10053100\"]]]'),(732800,'[[[\"npc\",\"团长！我就知道你肯定会狠狠教训那些可恶的家伙。\",\"0\"],[\"finish\",\"完成任务\",\"10053100\"]]]'),(732900,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10053200\"]]]'),(733000,'[[[\"npc\",\"事到如今，我们绝对不能放弃，这也是你一直鼓励我们的。\",\"0\"],[\"finish\",\"完成任务\",\"10053200\"]]]'),(733100,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10053300\"]]]'),(733200,'[[[\"npc\",\"我们只差最后一步了，击败邪恶的力量，夺回属于风神的力量。\",\"0\"],[\"finish\",\"完成任务\",\"10053300\"]]]'),(733300,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10053400\"]]]'),(733400,'[[[\"npc\",\"你的勇气值得赞赏，来自大陆的勇者。\",\"0\"],[\"finish\",\"完成任务\",\"10053400\"]]]'),(733500,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10053500\"]]]'),(733600,'[[[\"npc\",\"团长！我们拿到了，我们真的做到了！\",\"0\"],[\"finish\",\"完成任务\",\"10053500\"]]]'),(733700,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10053600\"]]]'),(733800,'[[[\"npc\",\"太好了，我就知道不会将我们抛下的！\",\"0\"],[\"finish\",\"完成任务\",\"10053600\"]]]'),(733900,'[[[\"npc\",\"我们必须找到失散的伙伴们，拜托你了，勇士！\",\"0\"],[\"trigger\",\"触发任务\",\"10053700\"]]]'),(734000,'[[[\"npc\",\"太好了，我就知道不会将我们抛下的！\",\"0\"],[\"finish\",\"完成任务\",\"10053700\"]]]'),(800100,'[[[\"npc\",\"你们肯定就是暴风骑士团的战士们？对吗？\",\"0\"],[\"trigger\",\"触发任务\",\"10053800\"]]]'),(800200,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"finish\",\"完成任务\",\"10053800\"]]]'),(800300,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10053900\"]]]'),(800400,'[[[\"npc\",\"这里...这里很奇怪，我的魔法似乎完全不起作用。\",\"0\"],[\"finish\",\"完成任务\",\"10053900\"]]]'),(800500,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10054000\"]]]'),(800600,'[[[\"npc\",\"你必须爬到塔顶的最高层，那里会有你的答案。\",\"0\"],[\"finish\",\"完成任务\",\"10054000\"]]]'),(800700,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10054100\"]]]'),(800800,'[[[\"npc\",\"抱歉了团长，没有了魔法的我就像一只失去翅膀的小鸟。\",\"0\"],[\"finish\",\"完成任务\",\"10054100\"]]]'),(800900,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10054200\"]]]'),(801000,'[[[\"npc\",\"谢谢你的帮助，团长。赶快前进吧。\",\"0\"],[\"finish\",\"完成任务\",\"10054200\"]]]'),(801100,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10054300\"]]]'),(801200,'[[[\"npc\",\"路还很长，收下这个吧，勇士！\",\"0\"],[\"finish\",\"完成任务\",\"10054300\"]]]'),(801300,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10054400\"]]]'),(801400,'[[[\"npc\",\"总之我们得先找到艾琳，她一定就在附近。\",\"0\"],[\"finish\",\"完成任务\",\"10054400\"]]]'),(801500,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10054500\"]]]'),(801600,'[[[\"npc\",\"你说的是金色头发的女孩吗？我好像看到过。\",\"0\"],[\"finish\",\"完成任务\",\"10054500\"]]]'),(801700,'[[[\"npc\",\"怪物们又冲上来了，团长！\",\"0\"],[\"trigger\",\"触发任务\",\"10054600\"]]]'),(801800,'[[[\"npc\",\"还好有你在，我真怕这些家伙抢走我的法典。\",\"0\"],[\"finish\",\"完成任务\",\"10054600\"]]]'),(801900,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10054700\"]]]'),(802000,'[[[\"npc\",\"勇士你还在这里干嘛！魔塔需要你！向前进准没错。\",\"0\"],[\"finish\",\"完成任务\",\"10054700\"]]]'),(802100,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10054800\"]]]'),(802200,'[[[\"npc\",\"这群怪物的进攻越来越凶了，我快只撑不住了。\",\"0\"],[\"finish\",\"完成任务\",\"10054800\"]]]'),(802300,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10054900\"]]]'),(802400,'[[[\"npc\",\"勇士，你们待在这里越久就越容易受到蒸汽之力的侵蚀，而这股力量我们无法预知，也不知道它接下来会怎么样。\",\"0\"],[\"finish\",\"完成任务\",\"10054900\"]]]'),(802500,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10055000\"]]]'),(802600,'[[[\"npc\",\"看来那个愣头愣脑的机器人没说谎，我们必须前进了。\",\"0\"],[\"finish\",\"完成任务\",\"10055000\"]]]'),(802700,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10055100\"]]]'),(802800,'[[[\"npc\",\"挡在桥路上面的怪物是个威胁，你能帮我去消灭他们吗？\",\"0\"],[\"finish\",\"完成任务\",\"10055100\"]]]'),(802900,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10055200\"]]]'),(803000,'[[[\"npc\",\"勇士，我已经为你们打开了一道闸门，前进吧！\",\"0\"],[\"finish\",\"完成任务\",\"10055200\"]]]'),(803100,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10055300\"]]]'),(803200,'[[[\"npc\",\"你看到骑士团的信号弹了吗？没错，艾琳就在前面。\",\"0\"],[\"finish\",\"完成任务\",\"10055300\"]]]'),(803300,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10055400\"]]]'),(803400,'[[[\"npc\",\"事不宜迟了，那一定就是你们要找的伙伴！\",\"0\"],[\"finish\",\"完成任务\",\"10055400\"]]]'),(803500,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10055500\"]]]'),(803600,'[[[\"npc\",\"控制魔塔的阀门被打开了，我们终于可以离开了。\",\"0\"],[\"finish\",\"完成任务\",\"10055500\"]]]'),(803700,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10055600\"]]]'),(803800,'[[[\"npc\",\"你果然没有辱没先祖的血脉！\",\"0\"],[\"finish\",\"完成任务\",\"10055600\"]]]'),(803900,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10055700\"]]]'),(804000,'[[[\"npc\",\"你果然没有辱没先祖的血脉！\",\"0\"],[\"finish\",\"完成任务\",\"10055700\"]]]'),(804100,'[[[\"npc\",\"总算等到你了！团长，你没来这段时间里发生了好多事，首先我们得平息这场暴乱。\",\"0\"],[\"trigger\",\"触发任务\",\"10055800\"]]]'),(804200,'[[[\"npc\",\"暴动的机械工人总算停息下来了，干得好！\",\"0\"],[\"finish\",\"完成任务\",\"10055800\"]]]'),(804300,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10055900\"]]]'),(804400,'[[[\"npc\",\"果然...事情没这么简单，这一切都跟这场雨有关...\",\"0\"],[\"finish\",\"完成任务\",\"10055900\"]]]'),(804500,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10056000\"]]]'),(804600,'[[[\"npc\",\"有没有能让这场雨停下来的办法呢？或许我们应该往前面会有我们的需要的答案。\",\"0\"],[\"finish\",\"完成任务\",\"10056000\"]]]'),(804700,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10056100\"]]]'),(804800,'[[[\"npc\",\"原来都是这场让人倒霉的阴雨，我们得想想办法让它停掉才行！\",\"0\"],[\"finish\",\"完成任务\",\"10056100\"]]]'),(804900,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10056200\"]]]'),(805000,'[[[\"npc\",\"这些发了疯的机械工人还在纠缠我们，让我们一鼓作气继续前进吧！\",\"0\"],[\"finish\",\"完成任务\",\"10056200\"]]]'),(805100,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10056300\"]]]'),(805200,'[[[\"npc\",\"勇士！魔塔的异动变得越来越强烈了，你感受到了吗？我的意识开始模糊起来了，你们必须前往上层区。\",\"0\"],[\"finish\",\"完成任务\",\"10056300\"]]]'),(805300,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10056400\"]]]'),(805400,'[[[\"npc\",\"团长，我可抽不出身来帮你！我的魔法全都失效了，这回你只能靠艾琳。\",\"0\"],[\"finish\",\"完成任务\",\"10056400\"]]]'),(805500,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10056500\"]]]'),(805600,'[[[\"npc\",\"放心吧！团长，妮哆肯定能好好照顾自己的，让我们前进吧。\",\"0\"],[\"finish\",\"完成任务\",\"10056500\"]]]'),(805700,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10056600\"]]]'),(805800,'[[[\"npc\",\"你果然没有辱没先祖的血脉！\",\"0\"],[\"finish\",\"完成任务\",\"10056600\"]]]'),(805900,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10056700\"]]]'),(806000,'[[[\"npc\",\"你果然没有辱没先祖的血脉！\",\"0\"],[\"finish\",\"完成任务\",\"10056700\"]]]'),(806100,'[[[\"npc\",\"听着！我会用仅存的魔法能量瓶建立一道结界保护营地，在此之前我们必须清理掉附近游荡的工人。\",\"0\"],[\"trigger\",\"触发任务\",\"10056800\"]]]'),(806200,'[[[\"npc\",\"团长，我会这里给你们提供后援的！请相信魔法的力量。\",\"0\"],[\"finish\",\"完成任务\",\"10056800\"]]]'),(806300,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10056900\"]]]'),(806400,'[[[\"npc\",\"在妮哆建立好结界之前，我们必须保护她，事到如今我们不能在失去伙伴了。\",\"0\"],[\"finish\",\"完成任务\",\"10056900\"]]]'),(806500,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10057000\"]]]'),(806600,'[[[\"npc\",\"就差那么一点，我就能建立结界了！我还需要一点点时间。\",\"0\"],[\"finish\",\"完成任务\",\"10057000\"]]]'),(806700,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10057100\"]]]'),(806800,'[[[\"npc\",\"等我们清理完这个区域最后的一波敌人就能行动了！\",\"0\"],[\"finish\",\"完成任务\",\"10057100\"]]]'),(806900,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10057200\"]]]'),(807000,'[[[\"npc\",\"团长！让我们赶快去通知妮哆吧，她肯定也在等我们的消息。\",\"0\"],[\"finish\",\"完成任务\",\"10057200\"]]]'),(807100,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10057300\"]]]'),(807200,'[[[\"npc\",\"怪物全都击退了，结界也完成了，这都是你们的功劳。\",\"0\"],[\"finish\",\"完成任务\",\"10057300\"]]]'),(807300,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10057400\"]]]'),(807400,'[[[\"npc\",\"团长，事不宜迟，我们赶快前进吧！\",\"0\"],[\"finish\",\"完成任务\",\"10057400\"]]]'),(807500,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10057500\"]]]'),(807600,'[[[\"npc\",\"盼星星，盼月亮！大佬们，你们可算来啦，有没有给我带来可口的食物？\",\"0\"],[\"finish\",\"完成任务\",\"10057500\"]]]'),(807700,'[[[\"npc\",\"看见这周围的巨大的发条了吗？没错，这里就是维持魔塔运转的重要区域。\",\"0\"],[\"trigger\",\"触发任务\",\"10057600\"]]]'),(807800,'[[[\"npc\",\"这是这场大雨已经让这里彻底瘫痪了。\",\"0\"],[\"finish\",\"完成任务\",\"10057600\"]]]'),(807900,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10057700\"]]]'),(808000,'[[[\"npc\",\"零零哆以前就喜欢故弄玄虚，不知道接下来我们要怎么办才好？\",\"0\"],[\"finish\",\"完成任务\",\"10057700\"]]]'),(808100,'[[[\"npc\",\"看见这周围的巨大的发条了吗？没错，这里就是维持魔塔运转的重要区域。\",\"0\"],[\"trigger\",\"触发任务\",\"10057800\"]]]'),(808200,'[[[\"npc\",\"这是这场大雨已经让这里彻底瘫痪了，更糟糕的是还有一群发疯的工人。\",\"0\"],[\"finish\",\"完成任务\",\"10057800\"]]]'),(808300,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10057900\"]]]'),(808400,'[[[\"npc\",\"让零零哆有话直说吧，别老是说话说一半，天知道这些特工脑子里整天都想些什么。\",\"0\"],[\"finish\",\"完成任务\",\"10057900\"]]]'),(808500,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10058000\"]]]'),(808600,'[[[\"npc\",\"艾琳这个急脾气还真是一点都没有变，我的意思是说，我们得先让这个区域正常运转起来才能前进。\",\"0\"],[\"finish\",\"完成任务\",\"10058000\"]]]'),(808700,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10058100\"]]]'),(808800,'[[[\"npc\",\"搞了半天，他要说的就是这个，那他有什么好办法吗？\",\"0\"],[\"finish\",\"完成任务\",\"10058100\"]]]'),(808900,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10058200\"]]]'),(809000,'[[[\"npc\",\"没想到这里机械疯子这么令人抓狂，我的盔甲差点都被抓破了！\",\"0\"],[\"finish\",\"完成任务\",\"10058200\"]]]'),(809100,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10058300\"]]]'),(809200,'[[[\"npc\",\"根据机械管家给我的布局图来看，这里应该存在着一个开启齿轮的开关。\",\"0\"],[\"finish\",\"完成任务\",\"10058300\"]]]'),(809300,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10058400\"]]]'),(809400,'[[[\"npc\",\"开关？我转了好几圈也没发现开关这个东西。\",\"0\"],[\"finish\",\"完成任务\",\"10058400\"]]]'),(809500,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10058500\"]]]'),(809600,'[[[\"npc\",\"如果靠艾琳这个驴脑袋都能找到开关的话，还要我这个特工干嘛！\",\"0\"],[\"finish\",\"完成任务\",\"10058500\"]]]'),(809700,'[[[\"npc\",\"这...这是什么声音，整个平台都在摇晃。\",\"0\"],[\"trigger\",\"触发任务\",\"10058600\"]]]'),(809800,'[[[\"npc\",\"怎么回事？刚刚被我们打败的机械怪物又冲了过来！\",\"0\"],[\"finish\",\"完成任务\",\"10058600\"]]]'),(809900,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10058700\"]]]'),(810000,'[[[\"npc\",\"你果然没有辱没先祖的血脉！\",\"0\"],[\"finish\",\"完成任务\",\"10058700\"]]]'),(810100,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10058800\"]]]'),(810200,'[[[\"npc\",\"天啊，这...这是地震吗？整个大地都在颤抖着！\",\"0\"],[\"finish\",\"完成任务\",\"10058800\"]]]'),(810300,'[[[\"npc\",\"刚刚被我们打败的机械怪物又冲了过来了！\",\"0\"],[\"trigger\",\"触发任务\",\"10058900\"]]]'),(810400,'[[[\"npc\",\"刚刚被我们打败的机械怪物又冲了过来了！\",\"0\"],[\"finish\",\"完成任务\",\"10058900\"]]]'),(810500,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10059000\"]]]'),(810600,'[[[\"npc\",\"虚惊一场，看来我们得加快速度寻找开关。\",\"0\"],[\"finish\",\"完成任务\",\"10059000\"]]]'),(810700,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10059100\"]]]'),(810800,'[[[\"npc\",\"零零哆这个胆小鬼这回居然没被吓尿，想起他以前嘲笑我的样子，就来气。\",\"0\"],[\"finish\",\"完成任务\",\"10059100\"]]]'),(810900,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10059200\"]]]'),(811000,'[[[\"npc\",\"团长！拜托，这都什么时候，你们就别拿我开玩笑了，让我们先把手头里的活干完。\",\"0\"],[\"finish\",\"完成任务\",\"10059200\"]]]'),(811100,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10059300\"]]]'),(811200,'[[[\"npc\",\"雨怎么变大了，可我们还是什么都没有发现。\",\"0\"],[\"finish\",\"完成任务\",\"10059300\"]]]'),(811300,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10059400\"]]]'),(811400,'[[[\"npc\",\"这场突如其来的大雨把一切都打断了，我们现在甚至都无法前进！\",\"0\"],[\"finish\",\"完成任务\",\"10059400\"]]]'),(811500,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10059500\"]]]'),(811600,'[[[\"npc\",\"我还以为我得和我的扳手一起锈在这里了，原来是你啊，伙计。\",\"0\"],[\"finish\",\"完成任务\",\"10059500\"]]]'),(811700,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10059600\"]]]'),(811800,'[[[\"npc\",\"你果然没有辱没先祖的血脉！\",\"0\"],[\"finish\",\"完成任务\",\"10059600\"]]]'),(811900,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10059700\"]]]'),(812000,'[[[\"npc\",\"你果然没有辱没先祖的血脉！\",\"0\"],[\"finish\",\"完成任务\",\"10059700\"]]]'),(812100,'[[[\"npc\",\"大雨将这里彻底变成了一个隔离区，我需要你的帮助才能重新让这里开始运转。\",\"0\"],[\"trigger\",\"触发任务\",\"10059800\"]]]'),(812200,'[[[\"npc\",\"当务之急还是得先消灭这些烦人的机械疯子。\",\"0\"],[\"finish\",\"完成任务\",\"10059800\"]]]'),(812300,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10059900\"]]]'),(812400,'[[[\"npc\",\"干得好，你就和我年轻时一样厉害。\",\"0\"],[\"finish\",\"完成任务\",\"10059900\"]]]'),(812500,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10060000\"]]]'),(812600,'[[[\"npc\",\"好！太好了，铁匠大叔肯定能够重新让这个区域开始运作。\",\"0\"],[\"finish\",\"完成任务\",\"10060000\"]]]'),(812700,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10060100\"]]]'),(812800,'[[[\"npc\",\"这个区域的核心开关就在这里，可是大雨早就把这里零件淋成了破烂，真是糟透了。\",\"0\"],[\"finish\",\"完成任务\",\"10060100\"]]]'),(812900,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10060200\"]]]'),(813000,'[[[\"npc\",\"让我好好想想，零件！零件不就不摆在我们面前吗？\",\"0\"],[\"finish\",\"完成任务\",\"10060200\"]]]'),(813100,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10060300\"]]]'),(813200,'[[[\"npc\",\"我可是费了好大力气才把这些家伙的零件拆掉，赶快给大叔送过去吧。\",\"0\"],[\"finish\",\"完成任务\",\"10060300\"]]]'),(813300,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10060400\"]]]'),(813400,'[[[\"npc\",\"真没想到那个贫嘴的家伙也能有派上用场的时候，这些零件刚好可以解我们的燃眉之急。\",\"0\"],[\"finish\",\"完成任务\",\"10060400\"]]]'),(813500,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10060500\"]]]'),(813600,'[[[\"npc\",\"嘘！这是！这可是齿轮转动的声音，大叔他成功了！\",\"0\"],[\"finish\",\"完成任务\",\"10060500\"]]]'),(813700,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10060600\"]]]'),(813800,'[[[\"npc\",\"你果然没有辱没先祖的血脉！\",\"0\"],[\"finish\",\"完成任务\",\"10060600\"]]]'),(813900,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10060700\"]]]'),(814000,'[[[\"npc\",\"你果然没有辱没先祖的血脉！\",\"0\"],[\"finish\",\"完成任务\",\"10060700\"]]]'),(814100,'[[[\"npc\",\"年纪大了，我这幅身子骨比不了你们这些年轻人。还好我们重新让这里运作起来了。\",\"0\"],[\"trigger\",\"触发任务\",\"10060800\"]]]'),(814200,'[[[\"npc\",\"这里的危机总算解除了，但我们绝对不能这么掉以轻心。\",\"0\"],[\"finish\",\"完成任务\",\"10060800\"]]]'),(814300,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10060900\"]]]'),(814400,'[[[\"npc\",\"可我不明白，为什么这些工人还发了疯一般地袭击我们。\",\"0\"],[\"finish\",\"完成任务\",\"10060900\"]]]'),(814500,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10061000\"]]]'),(814600,'[[[\"npc\",\"肯定是我们之前遗忘了什么重要的东西，为什么还没有解除危机。\",\"0\"],[\"finish\",\"完成任务\",\"10061000\"]]]'),(814700,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10061100\"]]]'),(814800,'[[[\"npc\",\"魔能波动仪的振动频率开始越来越高了，这个方向来自大叔的正上方！\",\"0\"],[\"finish\",\"完成任务\",\"10061100\"]]]'),(814900,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10061200\"]]]'),(815000,'[[[\"npc\",\"我没听错吧！那群...家伙冲这里来了吗？\",\"0\"],[\"finish\",\"完成任务\",\"10061200\"]]]'),(815100,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10061300\"]]]'),(815200,'[[[\"npc\",\"真的...好险，要不是我这跟大扳手还有你，我真不知道能不能在刚刚这场突袭中幸存下来。\",\"0\"],[\"finish\",\"完成任务\",\"10061300\"]]]'),(815300,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10061400\"]]]'),(815400,'[[[\"npc\",\"没时间磨蹭了，敌人很快就又要冲过来了，这次的目标还是你！\",\"0\"],[\"finish\",\"完成任务\",\"10061400\"]]]'),(815500,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10061500\"]]]'),(815600,'[[[\"npc\",\"爬梯已经被我拆了，那群惹人烦的家伙别想在靠近我们半步。\",\"0\"],[\"finish\",\"完成任务\",\"10061500\"]]]'),(815700,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10061600\"]]]'),(815800,'[[[\"npc\",\"你果然没有辱没先祖的血脉！\",\"0\"],[\"finish\",\"完成任务\",\"10061600\"]]]'),(815900,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10061700\"]]]'),(816000,'[[[\"npc\",\"你果然没有辱没先祖的血脉！\",\"0\"],[\"finish\",\"完成任务\",\"10061700\"]]]'),(816100,'[[[\"npc\",\"警告！警告！核心过载稳定过高，即将启动和谐模式...\",\"0\"],[\"trigger\",\"触发任务\",\"10061800\"]]]'),(816200,'[[[\"npc\",\"倒计时开始！5、4、3、2、1...\",\"0\"],[\"finish\",\"完成任务\",\"10061800\"]]]'),(816300,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10061900\"]]]'),(816400,'[[[\"npc\",\"清理程序完毕，正在识别目标身份...\",\"0\"],[\"finish\",\"完成任务\",\"10061900\"]]]'),(816500,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10062000\"]]]'),(816600,'[[[\"npc\",\"一个自言自语的女机器人？\",\"0\"],[\"finish\",\"完成任务\",\"10062000\"]]]'),(816700,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10062100\"]]]'),(816800,'[[[\"npc\",\"勇者！请留步！请留步！拿上这个让奥利安娜恢复正常。\",\"0\"],[\"finish\",\"完成任务\",\"10062100\"]]]'),(816900,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10062200\"]]]'),(817000,'[[[\"npc\",\"恢复模式启动中...尝试识别对象...\",\"0\"],[\"finish\",\"完成任务\",\"10062200\"]]]'),(817100,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10062300\"]]]'),(817200,'[[[\"npc\",\"谢谢你的帮助，陌生的客人！请原谅我们的无理与野蛮...\",\"0\"],[\"finish\",\"完成任务\",\"10062300\"]]]'),(817300,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10062400\"]]]'),(817400,'[[[\"npc\",\"正好赶上，勇士！事不宜迟，我们得继续前进。\",\"0\"],[\"finish\",\"完成任务\",\"10062400\"]]]'),(817500,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10062500\"]]]'),(817600,'[[[\"npc\",\"前面的路已经被帝国的机械怪物挡住了，我需要你的帮助！\",\"0\"],[\"finish\",\"完成任务\",\"10062500\"]]]'),(817700,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10062600\"]]]'),(817800,'[[[\"npc\",\"你果然没有辱没先祖的血脉！\",\"0\"],[\"finish\",\"完成任务\",\"10062600\"]]]'),(817900,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10062700\"]]]'),(818000,'[[[\"npc\",\"你果然没有辱没先祖的血脉！\",\"0\"],[\"finish\",\"完成任务\",\"10062700\"]]]'),(818100,'[[[\"npc\",\"可算...我可算爬到了这里,快去和艾琳汇合吧，她就在前面。\",\"0\"],[\"trigger\",\"触发任务\",\"10062800\"]]]'),(818200,'[[[\"npc\",\"团长，我们被包围了！准备战斗吧！\",\"0\"],[\"finish\",\"完成任务\",\"10062800\"]]]'),(818300,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10062900\"]]]'),(818400,'[[[\"npc\",\"能与你并肩作战是我的荣幸，团长！\",\"0\"],[\"finish\",\"完成任务\",\"10062900\"]]]'),(818500,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10063000\"]]]'),(818600,'[[[\"npc\",\"团长大人！听着！我们必须先击败这些搞破坏的帝国坏蛋，不然魔塔...\",\"0\"],[\"finish\",\"完成任务\",\"10063000\"]]]'),(818700,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10063100\"]]]'),(818800,'[[[\"npc\",\"更多的敌人冲了多来，小心！\",\"0\"],[\"finish\",\"完成任务\",\"10063100\"]]]'),(818900,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10063200\"]]]'),(819000,'[[[\"npc\",\"看着驾驶，敌人是要把这里给烧了，决不能让他们得逞。\",\"0\"],[\"finish\",\"完成任务\",\"10063200\"]]]'),(819100,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10063300\"]]]'),(819200,'[[[\"npc\",\"让这些帝国坏蛋都去见鬼吧！\",\"0\"],[\"finish\",\"完成任务\",\"10063300\"]]]'),(819300,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10063400\"]]]'),(819400,'[[[\"npc\",\"该死的！我被困在这里了...\",\"0\"],[\"finish\",\"完成任务\",\"10063400\"]]]'),(819500,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10063500\"]]]'),(819600,'[[[\"npc\",\"老铁匠肯定是在掩护我们的时候受伤的，我不该让他跟着我的...\",\"0\"],[\"finish\",\"完成任务\",\"10063500\"]]]'),(819700,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10063600\"]]]'),(819800,'[[[\"npc\",\"你果然没有辱没先祖的血脉！\",\"0\"],[\"finish\",\"完成任务\",\"10063600\"]]]'),(819900,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10063700\"]]]'),(820000,'[[[\"npc\",\"你果然没有辱没先祖的血脉！\",\"0\"],[\"finish\",\"完成任务\",\"10063700\"]]]'),(820100,'[[[\"npc\",\"放心！那些怪物还要不了我的命，我会自己看自己的！\",\"0\"],[\"trigger\",\"触发任务\",\"10063800\"]]]'),(820200,'[[[\"npc\",\"敌人又派来了新的增援，我需要帮助！\",\"0\"],[\"finish\",\"完成任务\",\"10063800\"]]]'),(820300,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10063900\"]]]'),(820400,'[[[\"npc\",\"好极了，敌人又被打败了！\",\"0\"],[\"finish\",\"完成任务\",\"10063900\"]]]'),(820500,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10064000\"]]]'),(820600,'[[[\"npc\",\"现在还不是休息的时候，我们必须爬上木梯，追上他们才行。\",\"0\"],[\"finish\",\"完成任务\",\"10064000\"]]]'),(820700,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10064100\"]]]'),(820800,'[[[\"npc\",\"想要爬上木梯，我们得先把敌人的头目给解决掉。\",\"0\"],[\"finish\",\"完成任务\",\"10064100\"]]]'),(820900,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10064200\"]]]'),(821000,'[[[\"npc\",\"我会拖住这些喽啰的，你快上吧。\",\"0\"],[\"finish\",\"完成任务\",\"10064200\"]]]'),(821100,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10064300\"]]]'),(821200,'[[[\"npc\",\"你成功了！快，让我们一起爬上去。\",\"0\"],[\"finish\",\"完成任务\",\"10064300\"]]]'),(821300,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10064400\"]]]'),(821400,'[[[\"npc\",\"别磨磨蹭蹭了，我会及时跟上的。\",\"0\"],[\"finish\",\"完成任务\",\"10064400\"]]]'),(821500,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10064500\"]]]'),(821600,'[[[\"npc\",\"准备好了吗？谁都不知道前面有什么。\",\"0\"],[\"finish\",\"完成任务\",\"10064500\"]]]'),(821700,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10064600\"]]]'),(821800,'[[[\"npc\",\"你果然没有辱没先祖的血脉！\",\"0\"],[\"finish\",\"完成任务\",\"10064600\"]]]'),(821900,'[[[\"npc\",\"这座魔塔正饱受黑暗的侵蚀，请救救它！\",\"0\"],[\"trigger\",\"触发任务\",\"10064700\"]]]'),(822000,'[[[\"npc\",\"你果然没有辱没先祖的血脉！\",\"0\"],[\"finish\",\"完成任务\",\"10064700\"]]]'),(900100,'[[[\"npc\",\"你们肯定就是暴风骑士团的战士们？对吗？\",\"0\"],[\"trigger\",\"触发任务\",\"10064600\"]]]'),(900200,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"finish\",\"完成任务\",\"10064600\"]]]'),(900300,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10064700\"]]]'),(900400,'[[[\"npc\",\"这里...这里很奇怪，我的魔法似乎完全不起作用。\",\"0\"],[\"finish\",\"完成任务\",\"10064700\"]]]'),(900500,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10064800\"]]]'),(900600,'[[[\"npc\",\"你必须爬到塔顶的最底层，那里会有你的答案。\",\"0\"],[\"finish\",\"完成任务\",\"10064800\"]]]'),(900700,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"1006490\"]]]'),(900800,'[[[\"npc\",\"抱歉了团长，没有了魔法的我就像一只失去翅膀的小鸟。\",\"0\"],[\"finish\",\"完成任务\",\"1006490\"]]]'),(900900,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10065000\"]]]'),(901000,'[[[\"npc\",\"谢谢你的帮助，团长。赶快前进吧。\",\"0\"],[\"finish\",\"完成任务\",\"10065000\"]]]'),(901100,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10065100\"]]]'),(901200,'[[[\"npc\",\"路还很长，收下这个吧，勇士！\",\"0\"],[\"finish\",\"完成任务\",\"10065100\"]]]'),(901300,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10065200\"]]]'),(901400,'[[[\"npc\",\"总之我们得先找到艾琳，她一定就在附近。\",\"0\"],[\"finish\",\"完成任务\",\"10065200\"]]]'),(901500,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10065300\"]]]'),(901600,'[[[\"npc\",\"你说的是金色头发的女孩吗？我好像看到过。\",\"0\"],[\"finish\",\"完成任务\",\"10065300\"]]]'),(902100,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10065400\"]]]'),(902200,'[[[\"npc\",\"这群怪物的进攻越来越凶了，我快只撑不住了。\",\"0\"],[\"finish\",\"完成任务\",\"10065400\"]]]'),(902300,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10065500\"]]]'),(902400,'[[[\"npc\",\"勇士，你们待在这里越久就越容易受到腐蚀之力的侵蚀，而这股力量我们无法预知，也不知道它接下来会怎么样。\",\"0\"],[\"finish\",\"完成任务\",\"10065500\"]]]'),(902500,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10065600\"]]]'),(902600,'[[[\"npc\",\"看来那个愣头愣脑的原住民没说谎，我们必须前进了。\",\"0\"],[\"finish\",\"完成任务\",\"10065600\"]]]'),(902700,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10065700\"]]]'),(902800,'[[[\"npc\",\"挡在桥路上面的怪物是个威胁，你能帮我去消灭他们吗？\",\"0\"],[\"finish\",\"完成任务\",\"10065700\"]]]'),(902900,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10065800\"]]]'),(903000,'[[[\"npc\",\"勇士，我已经为你们打开了一道结界，前进吧！\",\"0\"],[\"finish\",\"完成任务\",\"10065800\"]]]'),(903100,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10065900\"]]]'),(903200,'[[[\"npc\",\"你看到骑士团的信号弹了吗？没错，艾琳就在前面。\",\"0\"],[\"finish\",\"完成任务\",\"10065900\"]]]'),(903300,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10066000\"]]]'),(903400,'[[[\"npc\",\"事不宜迟了，那一定就是你们要找的伙伴！\",\"0\"],[\"finish\",\"完成任务\",\"10066000\"]]]'),(903500,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10066100\"]]]'),(903600,'[[[\"npc\",\"控制溶洞的封印被打开了，我们终于可以离开了。\",\"0\"],[\"finish\",\"完成任务\",\"10066100\"]]]'),(904100,'[[[\"npc\",\"总算等到你了！团长，你没来这段时间里发生了好多事，首先我们得平息这场暴乱。\",\"0\"],[\"trigger\",\"触发任务\",\"10066200\"]]]'),(904200,'[[[\"npc\",\"暴动的机械原住民总算停息下来了，干得好！\",\"0\"],[\"finish\",\"完成任务\",\"10066200\"]]]'),(904300,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10066300\"]]]'),(904400,'[[[\"npc\",\"果然...事情没这么简单，这一切都跟这场暗潮有关...\",\"0\"],[\"finish\",\"完成任务\",\"10066300\"]]]'),(904500,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10066400\"]]]'),(904600,'[[[\"npc\",\"有没有能让这场暗潮停下来的办法呢？或许我们应该往前面会有我们的需要的答案。\",\"0\"],[\"finish\",\"完成任务\",\"10066400\"]]]'),(904700,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10066500\"]]]'),(904800,'[[[\"npc\",\"原来都是这场让人倒霉的阴暗潮，我们得想想办法让它停掉才行！\",\"0\"],[\"finish\",\"完成任务\",\"10066500\"]]]'),(904900,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10066600\"]]]'),(905000,'[[[\"npc\",\"这些发了疯的机械原住民还在纠缠我们，让我们一鼓作气继续前进吧！\",\"0\"],[\"finish\",\"完成任务\",\"10066600\"]]]'),(905100,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10066700\"]]]'),(905200,'[[[\"npc\",\"勇士！溶洞的异动变得越来越强烈了，你感受到了吗？我的意识开始模糊起来了，你们必须前往上层区。\",\"0\"],[\"finish\",\"完成任务\",\"10066700\"]]]'),(905300,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10066800\"]]]'),(905400,'[[[\"npc\",\"团长，我可抽不出身来帮你！我的魔法全都失效了，这回你只能靠艾琳。\",\"0\"],[\"finish\",\"完成任务\",\"10066800\"]]]'),(905500,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10066900\"]]]'),(905600,'[[[\"npc\",\"放心吧！团长，妮哆肯定能好好照顾自己的，让我们前进吧。\",\"0\"],[\"finish\",\"完成任务\",\"10066900\"]]]'),(906100,'[[[\"npc\",\"听着！我会用仅存的魔法能量瓶建立一道结界保护营地，在此之前我们必须清理掉附近游荡的原住民。\",\"0\"],[\"trigger\",\"触发任务\",\"10067000\"]]]'),(906200,'[[[\"npc\",\"团长，我会这里给你们提供后援的！请相信魔法的力量。\",\"0\"],[\"finish\",\"完成任务\",\"10067000\"]]]'),(906300,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10067100\"]]]'),(906400,'[[[\"npc\",\"在妮哆建立好结界之前，我们必须保护她，事到如今我们不能在失去伙伴了。\",\"0\"],[\"finish\",\"完成任务\",\"10067100\"]]]'),(906500,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10067200\"]]]'),(906600,'[[[\"npc\",\"就差那么一点，我就能建立结界了！我还需要一点点时间。\",\"0\"],[\"finish\",\"完成任务\",\"10067200\"]]]'),(906700,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10067300\"]]]'),(906800,'[[[\"npc\",\"等我们清理完这个区域最后的一波敌人就能行动了！\",\"0\"],[\"finish\",\"完成任务\",\"10067300\"]]]'),(906900,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10067400\"]]]'),(907000,'[[[\"npc\",\"团长！让我们赶快去通知妮哆吧，她肯定也在等我们的消息。\",\"0\"],[\"finish\",\"完成任务\",\"10067400\"]]]'),(907100,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10067500\"]]]'),(907200,'[[[\"npc\",\"怪物全都击退了，结界也完成了，这都是你们的功劳。\",\"0\"],[\"finish\",\"完成任务\",\"10067500\"]]]'),(907300,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10067600\"]]]'),(907400,'[[[\"npc\",\"团长，事不宜迟，我们赶快前进吧！\",\"0\"],[\"finish\",\"完成任务\",\"10067600\"]]]'),(907500,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10067700\"]]]'),(907600,'[[[\"npc\",\"盼星星，盼月亮！大佬们，你们可算来啦，有没有给我带来可口的食物？\",\"0\"],[\"finish\",\"完成任务\",\"10067700\"]]]'),(908100,'[[[\"npc\",\"看见这周围的巨大的发条了吗？没错，这里就是维持溶洞运转的重要区域。\",\"0\"],[\"trigger\",\"触发任务\",\"10067800\"]]]'),(908200,'[[[\"npc\",\"这是这场大暗潮已经让这里彻底瘫痪了，更糟糕的是还有一群发疯的原住民。\",\"0\"],[\"finish\",\"完成任务\",\"10067800\"]]]'),(908300,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10067900\"]]]'),(908400,'[[[\"npc\",\"让零零哆有话直说吧，别老是说话说一半，天知道这些特工脑子里整天都想些什么。\",\"0\"],[\"finish\",\"完成任务\",\"10067900\"]]]'),(908500,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10068000\"]]]'),(908600,'[[[\"npc\",\"艾琳这个急脾气还真是一点都没有变，我的意思是说，我们得先让这个区域正常运转起来才能前进。\",\"0\"],[\"finish\",\"完成任务\",\"10068000\"]]]'),(908700,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10068100\"]]]'),(908800,'[[[\"npc\",\"搞了半天，他要说的就是这个，那他有什么好办法吗？\",\"0\"],[\"finish\",\"完成任务\",\"10068100\"]]]'),(908900,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10068200\"]]]'),(909000,'[[[\"npc\",\"没想到这里魔物这么令人抓狂，我的盔甲差点都被抓破了！\",\"0\"],[\"finish\",\"完成任务\",\"10068200\"]]]'),(909100,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10068300\"]]]'),(909200,'[[[\"npc\",\"根据果冻人给我的布局图来看，这里应该存在着一个开启齿轮的开关。\",\"0\"],[\"finish\",\"完成任务\",\"10068300\"]]]'),(909300,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10068400\"]]]'),(909400,'[[[\"npc\",\"开关？我转了好几圈也没发现开关这个东西。\",\"0\"],[\"finish\",\"完成任务\",\"10068400\"]]]'),(909500,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10068500\"]]]'),(909600,'[[[\"npc\",\"如果靠艾琳这个驴脑袋都能找到开关的话，还要我这个特工干嘛！\",\"0\"],[\"finish\",\"完成任务\",\"10068500\"]]]'),(910100,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10068600\"]]]'),(910200,'[[[\"npc\",\"天啊，这...这是地震吗？整个大地都在颤抖着！\",\"0\"],[\"finish\",\"完成任务\",\"10068600\"]]]'),(910300,'[[[\"npc\",\"刚刚被我们打败的地底魔物又冲了过来了！\",\"0\"],[\"trigger\",\"触发任务\",\"10068700\"]]]'),(910400,'[[[\"npc\",\"刚刚被我们打败的地底魔物又冲了过来了！\",\"0\"],[\"finish\",\"完成任务\",\"10068700\"]]]'),(910500,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10068800\"]]]'),(910600,'[[[\"npc\",\"虚惊一场，看来我们得加快速度寻找开关。\",\"0\"],[\"finish\",\"完成任务\",\"10068800\"]]]'),(910700,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10068900\"]]]'),(910800,'[[[\"npc\",\"零零哆这个胆小鬼这回居然没被吓尿，想起他以前嘲笑我的样子，就来气。\",\"0\"],[\"finish\",\"完成任务\",\"10068900\"]]]'),(910900,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10069000\"]]]'),(911000,'[[[\"npc\",\"团长！拜托，这都什么时候，你们就别拿我开玩笑了，让我们先把手头里的活干完。\",\"0\"],[\"finish\",\"完成任务\",\"10069000\"]]]'),(911100,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10069100\"]]]'),(911200,'[[[\"npc\",\"暗潮怎么变大了，可我们还是什么都没有发现。\",\"0\"],[\"finish\",\"完成任务\",\"10069100\"]]]'),(911300,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10069200\"]]]'),(911400,'[[[\"npc\",\"这场突如其来的大暗潮把一切都打断了，我们现在甚至都无法前进！\",\"0\"],[\"finish\",\"完成任务\",\"10069200\"]]]'),(911500,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10069300\"]]]'),(911600,'[[[\"npc\",\"我还以为我得和我的扳手一起锈在这里了，原来是你啊，伙计。\",\"0\"],[\"finish\",\"完成任务\",\"10069300\"]]]'),(912100,'[[[\"npc\",\"大暗潮将这里彻底变成了一个隔离区，我需要你的帮助才能重新让这里开始运转。\",\"0\"],[\"trigger\",\"触发任务\",\"10069400\"]]]'),(912200,'[[[\"npc\",\"当务之急还是得先消灭这些烦人的魔物。\",\"0\"],[\"finish\",\"完成任务\",\"10069400\"]]]'),(912300,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10069500\"]]]'),(912400,'[[[\"npc\",\"干得好，你就和我年轻时一样厉害。\",\"0\"],[\"finish\",\"完成任务\",\"10069500\"]]]'),(912500,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10069600\"]]]'),(912600,'[[[\"npc\",\"好！太好了，铁卫大叔肯定能够重新让这个区域开始运作。\",\"0\"],[\"finish\",\"完成任务\",\"10069600\"]]]'),(912700,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10069700\"]]]'),(912800,'[[[\"npc\",\"这个区域的核心开关就在这里，可是大暗潮早就把这里材料淋成了破烂，真是糟透了。\",\"0\"],[\"finish\",\"完成任务\",\"10069700\"]]]'),(912900,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10069800\"]]]'),(913000,'[[[\"npc\",\"让我好好想想，材料！材料不就不摆在我们面前吗？\",\"0\"],[\"finish\",\"完成任务\",\"10069800\"]]]'),(913100,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10069900\"]]]'),(913200,'[[[\"npc\",\"我可是费了好大力气才把这些家伙的材料拆掉，赶快给大叔送过去吧。\",\"0\"],[\"finish\",\"完成任务\",\"10069900\"]]]'),(913300,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10070000\"]]]'),(913400,'[[[\"npc\",\"真没想到那个贫嘴的家伙也能有派上用场的时候，这些材料刚好可以解我们的燃眉之急。\",\"0\"],[\"finish\",\"完成任务\",\"10070000\"]]]'),(913500,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10070100\"]]]'),(913600,'[[[\"npc\",\"嘘！这是！这可是齿轮转动的声音，大叔他成功了！\",\"0\"],[\"finish\",\"完成任务\",\"10070100\"]]]'),(914100,'[[[\"npc\",\"我这幅身子骨比不了你们这些家伙。还好我们重新让这里运作起来了。\",\"0\"],[\"trigger\",\"触发任务\",\"10070200\"]]]'),(914200,'[[[\"npc\",\"这里的危机总算解除了，但我们绝对不能这么掉以轻心。\",\"0\"],[\"finish\",\"完成任务\",\"10070200\"]]]'),(914300,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10070300\"]]]'),(914400,'[[[\"npc\",\"可我不明白，为什么这些原住民还发了疯一般地袭击我们。\",\"0\"],[\"finish\",\"完成任务\",\"10070300\"]]]'),(914500,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10070400\"]]]'),(914600,'[[[\"npc\",\"肯定是我们之前遗忘了什么重要的东西，为什么还没有解除危机。\",\"0\"],[\"finish\",\"完成任务\",\"10070400\"]]]'),(914700,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10070500\"]]]'),(914800,'[[[\"npc\",\"魔能波动仪的振动频率开始越来越高了，这个方向来自大叔的正上方！\",\"0\"],[\"finish\",\"完成任务\",\"10070500\"]]]'),(914900,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10070600\"]]]'),(915000,'[[[\"npc\",\"我没听错吧！那群...家伙冲这里来了吗？\",\"0\"],[\"finish\",\"完成任务\",\"10070600\"]]]'),(915100,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10070700\"]]]'),(915200,'[[[\"npc\",\"真的...好险，要不是我这跟大扳手还有你，我真不知道能不能在刚刚这场突袭中幸存下来。\",\"0\"],[\"finish\",\"完成任务\",\"10070700\"]]]'),(915300,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10070800\"]]]'),(915400,'[[[\"npc\",\"没时间磨蹭了，敌人很快就又要冲过来了，这次的目标还是你！\",\"0\"],[\"finish\",\"完成任务\",\"10070800\"]]]'),(915500,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10070900\"]]]'),(915600,'[[[\"npc\",\"爬梯已经被我拆了，那群惹人烦的家伙别想在靠近我们半步。\",\"0\"],[\"finish\",\"完成任务\",\"10070900\"]]]'),(916100,'[[[\"npc\",\"....你是谁...\",\"0\"],[\"trigger\",\"触发任务\",\"10071000\"]]]'),(916200,'[[[\"npc\",\"倒计时开始！5、4、3、2、1...\",\"0\"],[\"finish\",\"完成任务\",\"10071000\"]]]'),(916300,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10071100\"]]]'),(916400,'[[[\"npc\",\"清理程序完毕，正在识别目标身份...\",\"0\"],[\"finish\",\"完成任务\",\"10071100\"]]]'),(916500,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10071200\"]]]'),(916600,'[[[\"npc\",\"一个自言自语的女原住民？\",\"0\"],[\"finish\",\"完成任务\",\"10071200\"]]]'),(916700,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10071300\"]]]'),(916800,'[[[\"npc\",\"勇者！请留步！请留步！拿上这个让大家恢复正常。\",\"0\"],[\"finish\",\"完成任务\",\"10071300\"]]]'),(916900,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10071400\"]]]'),(917000,'[[[\"npc\",\"恢复模式启动中...尝试识别目标...\",\"0\"],[\"finish\",\"完成任务\",\"10071400\"]]]'),(917100,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10071500\"]]]'),(917200,'[[[\"npc\",\"谢谢你的帮助，陌生的客人！请原谅我们的无理与野蛮...\",\"0\"],[\"finish\",\"完成任务\",\"10071500\"]]]'),(917300,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10071600\"]]]'),(917400,'[[[\"npc\",\"正好赶上，勇士！事不宜迟，我们得继续前进。\",\"0\"],[\"finish\",\"完成任务\",\"10071600\"]]]'),(917500,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10071700\"]]]'),(917600,'[[[\"npc\",\"前面的路已经被帝国的地底魔物挡住了，我需要你的帮助！\",\"0\"],[\"finish\",\"完成任务\",\"10071700\"]]]'),(918100,'[[[\"npc\",\"可算...我可算爬到了这里,快去和艾琳汇合吧，她就在前面。\",\"0\"],[\"trigger\",\"触发任务\",\"10071800\"]]]'),(918200,'[[[\"npc\",\"团长，我们被包围了！准备战斗吧！\",\"0\"],[\"finish\",\"完成任务\",\"10071800\"]]]'),(918300,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10071900\"]]]'),(918400,'[[[\"npc\",\"能与你并肩作战是我的荣幸，团长！\",\"0\"],[\"finish\",\"完成任务\",\"10071900\"]]]'),(918500,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10072000\"]]]'),(918600,'[[[\"npc\",\"团长大人！听着！我们必须先击败这些搞破坏的帝国坏蛋，不然溶洞...\",\"0\"],[\"finish\",\"完成任务\",\"10072000\"]]]'),(918700,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10072100\"]]]'),(918800,'[[[\"npc\",\"更多的敌人冲了多来，小心！\",\"0\"],[\"finish\",\"完成任务\",\"10072100\"]]]'),(918900,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10072200\"]]]'),(919000,'[[[\"npc\",\"看着驾驶，敌人是要把这里给烧了，决不能让他们得逞。\",\"0\"],[\"finish\",\"完成任务\",\"10072200\"]]]'),(919100,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10072300\"]]]'),(919200,'[[[\"npc\",\"让这些魔物都去见鬼吧！\",\"0\"],[\"finish\",\"完成任务\",\"10072300\"]]]'),(919300,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10072400\"]]]'),(919400,'[[[\"npc\",\"该死的！我被困在这里了...\",\"0\"],[\"finish\",\"完成任务\",\"10072400\"]]]'),(919500,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10072500\"]]]'),(919600,'[[[\"npc\",\"铁卫肯定是在掩护我们的时候受伤的，我不该让他跟着我的...\",\"0\"],[\"finish\",\"完成任务\",\"10072500\"]]]'),(920100,'[[[\"npc\",\"放心！那些怪物还要不了我的命，我会自己看自己的！\",\"0\"],[\"trigger\",\"触发任务\",\"10072600\"]]]'),(920200,'[[[\"npc\",\"敌人又派来了新的增援，我需要帮助！\",\"0\"],[\"finish\",\"完成任务\",\"10072600\"]]]'),(920300,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10072700\"]]]'),(920400,'[[[\"npc\",\"好极了，敌人又被打败了！\",\"0\"],[\"finish\",\"完成任务\",\"10072700\"]]]'),(920500,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10072800\"]]]'),(920600,'[[[\"npc\",\"现在还不是休息的时候，我们必须夺回水晶，彻底打垮敌人。\",\"0\"],[\"finish\",\"完成任务\",\"10072800\"]]]'),(920700,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10072900\"]]]'),(920800,'[[[\"npc\",\"想要爬夺取水晶，我们得先把敌人的头目给解决掉。\",\"0\"],[\"finish\",\"完成任务\",\"10072900\"]]]'),(920900,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10073000\"]]]'),(921000,'[[[\"npc\",\"我会拖住这些喽啰的，你快上吧。\",\"0\"],[\"finish\",\"完成任务\",\"10073000\"]]]'),(921100,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10073100\"]]]'),(921200,'[[[\"npc\",\"你成功了！快，让我们一起前进。\",\"0\"],[\"finish\",\"完成任务\",\"10073100\"]]]'),(921300,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10073200\"]]]'),(921400,'[[[\"npc\",\"别磨磨蹭蹭了，我会及时跟上的。\",\"0\"],[\"finish\",\"完成任务\",\"10073200\"]]]'),(921500,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10073300\"]]]'),(921600,'[[[\"npc\",\"准备好了吗？谁都不知道前面有什么。\",\"0\"],[\"finish\",\"完成任务\",\"10073300\"]]]'),(921700,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10073400\"]]]'),(921800,'[[[\"npc\",\"你果然没有辱没先祖的血脉！\",\"0\"],[\"finish\",\"完成任务\",\"10073400\"]]]'),(921900,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10073500\"]]]'),(922000,'[[[\"npc\",\"你果然没有辱没先祖的血脉！\",\"0\"],[\"finish\",\"完成任务\",\"10073500\"]]]'),(922100,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10073600\"]]]'),(922200,'[[[\"npc\",\"我会拖住这些喽啰的，你快上吧。\",\"0\"],[\"finish\",\"完成任务\",\"10073600\"]]]'),(922300,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10073700\"]]]'),(922400,'[[[\"npc\",\"你成功了！快，让我们一起前进。\",\"0\"],[\"finish\",\"完成任务\",\"10073700\"]]]'),(922500,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10073800\"]]]'),(922600,'[[[\"npc\",\"别磨磨蹭蹭了，我会及时跟上的。\",\"0\"],[\"finish\",\"完成任务\",\"10073800\"]]]'),(922700,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10073900\"]]]'),(922800,'[[[\"npc\",\"准备好了吗？谁都不知道前面有什么。\",\"0\"],[\"finish\",\"完成任务\",\"10073900\"]]]'),(922900,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10074000\"]]]'),(923000,'[[[\"npc\",\"你果然没有辱没先祖的血脉！\",\"0\"],[\"finish\",\"完成任务\",\"10074000\"]]]'),(923100,'[[[\"npc\",\"古老的地底溶洞正饱受邪恶的侵占，拜托你了，勇士！！\",\"0\"],[\"trigger\",\"触发任务\",\"10074100\"]]]'),(923200,'[[[\"npc\",\"你果然没有辱没先祖的血脉！\",\"0\"],[\"finish\",\"完成任务\",\"10074100\"]]]'),(1011102,'[[[\"npc\",\"欢迎勇者不远千里赶来，我们已等候您多时了~冰霜怪物控制了天气，快帮帮我们！\",\"100701\"],[\"finish\",\"完成任务\",\"10007901\"]]]'),(1011104,'[[[\"npc\",\"多谢勇者出手相助，天气严寒，等下我让同胞带你进村子休息。\",\"100701\"],[\"finish\",\"完成任务\",\"10007902\"]]]'),(1011106,'[[[\"npc\",\"您一定就是那位勇者大人了！太好了~我们的村子有救了！\",\"100702\"],[\"finish\",\"完成任务\",\"10007903\"]]]'),(1011108,'[[[\"npc\",\"过了冰桥就是我们的村子了~\",\"100702\"],[\"finish\",\"完成任务\",\"10007904\"]]]'),(1011110,'[[[\"npc\",\"可恶的怪物，把我刚钓上来的冰鱼都抢走了！\",\"100703\"],[\"finish\",\"完成任务\",\"10007905\"]]]'),(1011112,'[[[\"npc\",\"多谢勇者出手相助！这些冰鱼就当是谢礼了！\",\"100703\"],[\"finish\",\"完成任务\",\"10007906\"]]]'),(1011114,'[[[\"npc\",\"勇者不远千里赶来，俺十分感激，不过这里天气恶劣，还是先采集些柴火取暖吧！\",\"100704\"],[\"finish\",\"完成任务\",\"10007907\"]]]'),(1011116,'[[[\"npc\",\"先让身体暖和些再出发吧~\",\"100704\"],[\"finish\",\"完成任务\",\"10007908\"]]]'),(1011118,'[[[\"npc\",\"是期待已久的勇者大人呢！\",\"100705\"],[\"finish\",\"完成任务\",\"10007909\"]]]'),(1013483,'[[[\"\"]],[[\"\"]],[[\"\"]],[[\"\"]],[[\"\"]],[[\"\"]],[[\"\"]],[[\"\"]],[[\"\"]],[[\"\"]],[[\"\"]],[[\"\"]],[[\"\"]],[[\"\"]],[[\"\"]],[[\"\"]],[[\"\"]],[[\"\"]],[[\"\"]],[[\"\"]],[[\"\"]],[[\"\"]]]'),(1014285,'[[[\"\"]]]'),(1015076,'[[[\"npc\",\"\",\"0\"],[\"trigger\",\"触发任务\",\"2010101\"]]]'),(1015077,'[[[\"npc\",\"林间圣地最近有很多发狂的魔物在肆虐，村民都苦不堪言，请勇士们前往击败这些魔物。\",\"0\"],[\"trigger\",\"触发任务\",\"2020101\"]]]'),(1015078,'[[[\"npc\",\"最近大路上出现了一座符文之塔，勇士有没有兴趣前往探秘？\",\"0\"],[\"trigger\",\"触发任务\",\"2110101\"]]]'),(1015079,'[[[\"npc\",\"每周公会都会组织成员一起去猎杀公会神兽，不想去试试吗？据说经常会发现珍贵的装备呢\",\"0\"],[\"trigger\",\"触发任务\",\"2160101\"]]]'),(1015080,'[[[\"npc\",\"每周会开放3次公会晚宴，有大餐可以吃哦，快加入公会去尝尝吧。\",\"0\"],[\"trigger\",\"触发任务\",\"2160201\"]]]'),(1015081,'[[[\"npc\",\"既然身为公会的一份子，就要和大家一起为守卫公会而努力\",\"0\"],[\"trigger\",\"触发任务\",\"2160301\"]]]'),(1015082,'[[[\"npc\",\"一周一度的公会争霸是验证每个公会实力的决定性战役，加入公会和大家一起战吧！\",\"0\"],[\"trigger\",\"触发任务\",\"2160401\"]]]'),(1015083,'[[[\"npc\",\"公会仓库需要你来一起充盈，捐个装备意思一下吧！\",\"0\"],[\"trigger\",\"触发任务\",\"10039004\"]]]'),(1015084,'[[[\"npc\",\"呜坦之城最近需要一批物资，你也帮忙收集一点吧。\",\"0\"],[\"trigger\",\"触发任务\",\"2190101\"]]]'),(1015085,'[[[\"npc\",\"呜坦之城的市场开启了，市场里有不少宝贝，说不定能淘到便宜的呢。\",\"0\"],[\"trigger\",\"触发任务\",\"2200101\"]]]'),(1015086,'[[[\"\"]]]'),(1018827,'[[[\"\"]]]'),(1020192,'[[[\"\"]]]'),(1021558,'[[[\"\"]]]'),(1022923,'[[[\"\"]]]'),(1024629,'[[[\"\"]]]'),(1033607,'[[[\"\"]]]'),(1035535,'[[[\"npc\",\"\",\"0\"],[\"finish\",\"完成任务\",\"101\"]]]'),(1035536,'[[[\"npc\",\"\",\"0\"],[\"finish\",\"完成任务\",\"102\"]]]'),(1035537,'[[[\"npc\",\"\",\"0\"],[\"finish\",\"完成任务\",\"103\"]]]'),(1035538,'[[[\"npc\",\"\",\"0\"],[\"finish\",\"完成任务\",\"104\"]]]'),(1035539,'[[[\"npc\",\"\",\"0\"],[\"finish\",\"完成任务\",\"105\"]]]'),(1035540,'[[[\"npc\",\"\",\"0\"],[\"finish\",\"完成任务\",\"106\"]]]'),(1047152,'[[[\"\"]]]'),(1049089,'[[[\"\"]]]'),(1900000,'[[[\"npc\",\"万幸万幸，你终于赶到了~\",\"100501\"],[\"trigger\",\"触发任务\",\"10000000\"]]]'),(1900100,'[[[\"npc\",\"你得动作快一点，不然这里就有危险了！\",\"100501\"],[\"finish\",\"完成任务\",\"10000000\"]]]'),(1900300,'[[[\"npc\",\"只要拿回你的武器，应该就没问题了吧？\",\"100502\"],[\"finish\",\"完成任务\",\"10000100\"]]]'),(1900500,'[[[\"npc\",\"啊~你就是那边派来的帮手吗~看起来弱不禁风啊~\",\"100503\"],[\"finish\",\"完成任务\",\"10000101\"]]]'),(1900600,'[[[\"npc\",\"好好听清楚我接下来说的话~\",\"100504\"],[\"trigger\",\"触发任务\",\"10000200\"]]]'),(1900700,'[[[\"npc\",\"这条线索来之不易，我们必须马上动身！\",\"100504\"],[\"finish\",\"完成任务\",\"10000200\"]]]'),(1900900,'[[[\"role\",\"去摘几个蜜果，以备不时之需~\",\"100504\"],[\"finish\",\"完成任务\",\"10000300\"]]]'),(1901100,'[[[\"npc\",\"竟然打败了这里的守卫？我对你刮目相看了~\",\"100505\"],[\"finish\",\"完成任务\",\"10000400\"]]]'),(1901300,'[[[\"npc\",\"去找找艾琳，她可能遇到麻烦了。\",\"100505\"],[\"finish\",\"完成任务\",\"10000500\"]]]'),(1901400,'[[[\"npc\",\"我...我才不会被前面那群小贼吓跑呢！\",\"0\"],[\"trigger\",\"触发任务\",\"10000600\"]]]'),(1901500,'[[[\"npc\",\"帝国的军队肯定还在附近我们绝对不能松懈！\",\"0\"],[\"finish\",\"完成任务\",\"10000600\"]]]'),(1901700,'[[[\"npc\",\"太棒了！你总算来了，牛头人横行霸道，请务必教训一下它们！\",\"100506\"],[\"finish\",\"完成任务\",\"10000700\"]]]'),(1901900,'[[[\"npc\",\"身手不凡~三两下就把牛头人击退了！\",\"100506\"],[\"finish\",\"完成任务\",\"10000800\"]]]'),(1902100,'[[[\"npc\",\"不要松懈，身为勇者就应该时刻保持警惕，北边的山头被一只岩龟占领了！驱逐它吧！\",\"100507\"],[\"finish\",\"完成任务\",\"10000900\"]]]'),(1902300,'[[[\"role\",\"哦哦~辛苦了，这是你的酬劳，按照约定对半分！\",\"100507\"],[\"finish\",\"完成任务\",\"10001000\"]]]'),(1902500,'[[[\"npc\",\"真是太感谢你了，蜥蜴人占据这里已经很长时间了~\",\"100508\"],[\"finish\",\"完成任务\",\"10001100\"]]]'),(1902700,'[[[\"npc\",\"那些可爱的精灵貌似也有一阵子的骚动了，希望你能帮忙平息一下！\",\"100508\"],[\"finish\",\"完成任务\",\"10001200\"]]]'),(1902900,'[[[\"role\",\"北边的山岭生长着一种野花，应该可以平复妖精的情绪~\",\"100508\"],[\"finish\",\"完成任务\",\"10001300\"]]]'),(1903100,'[[[\"role\",\"野花？难道是？\",\"100507\"],[\"finish\",\"完成任务\",\"10001400\"]]]'),(1903302,'[[[\"npc\",\"通往神殿的路就在前往，加油勇者！中途我已经安排了接应你的人！\",\"100509\"],[\"finish\",\"完成任务\",\"10001501\"]]]'),(1903400,'[[[\"npc\",\"太好了！解决了这个区域的事端，我们可以继续前进了！\",\"100508\"],[\"finish\",\"完成任务\",\"10001500\"]]]'),(1903700,'[[[\"role\",\"你问我接应你的人时谁？嗯……总之是美丽而又强大的人！\",\"100509\"],[\"finish\",\"完成任务\",\"10001600\"]]]'),(1907765,'[[[\"\"]],[[\"\"]],[[\"\"]],[[\"\"]],[[\"\"]],[[\"\"]],[[\"\"]],[[\"\"]]]'),(1907768,'[[[\"npc\",\"第三次对话\",\"10059009\"],[\"finish_and_trigger\",\"完成并触发任务\",\"2999991\"]]]'),(1907769,'[[[\"npc\",\"第一次对话\",\"10059009\"],[\"trigger\",\"触发任务\",\"2999990\"]]]'),(1907771,'[[[\"role\",\"我要对你说话啦\",\"0\"],[\"trigger\",\"触发任务\",\"2999991\"]]]'),(1907772,'[[[\"role\",\"我又来了。\",\"0\"],[\"talk_event\",\"触发对话事件\",\"2999991\"]],[[\"npc\",\"拿走你的奖励\",\"0\"],[\"finish_and_trigger\",\"完成并触发任务\",\"2999992\"]]]'),(1907773,'[[[\"npc\",\"你去打怪吧\",\"0\"],[\"fight\",\"马上开战\",\"1006003\"]]]'),(1907774,'[[[\"npc\",\"你去打副本吧\",\"10059020\"],[\"trigger\",\"触发任务\",\"2999992\"]]]'),(1907775,'[[[\"npc\",\"做得好\",\"0\"],[\"finish\",\"完成任务\",\"2999992\"]]]'),(1907776,'[[[\"npc\",\"咳咳咳嗯~欢迎~欢迎来到森民神殿~\"]]]'),(1907777,'[[[\"npc\",\"你不会想要看到我的另一面的。\"]]]'),(1907778,'[[[\"npc\",\"神树的顶端，是离天空最近的地方~\"]]]'),(1907779,'[[[\"npc\",\"吃肉！吃肉！吃肉肉！！\"]]]'),(1907780,'[[[\"npc\",\"只要能够获取材料，我就能炼制出我们特有的药剂。\"]]]'),(1907781,'[[[\"npc\",\"魔法典籍在左边，历史文本在右边，嘘~安静点！\"]]]'),(1907782,'[[[\"npc\",\"真想飞到神树顶上，看看那里的天空啊~可惜我只是个普通的妖精……\"]]]'),(1907783,'[[[\"npc\",\"工欲善其事必先利其器，这把锤子可是祖传多年的宝物！\"]]]'),(1907784,'[[[\"npc\",\"那边的年轻人~过来一下~我给你看看珍藏多年的宝贝！\"]]]'),(1907785,'[[[\"npc\",\"欢迎来到精灵族的国度！外乡人~请报上你的名字和来意~\"]]]'),(1907786,'[[[\"npc\",\"我好像又迷路了~你知道怎么回神殿吗？\"]]]'),(1907787,'[[[\"npc\",\"俺建议你们这些外乡人跟着俺走，别迷路了！\"]]]'),(1907788,'[[[\"npc\",\"当年我出海的时候，你们这些外乡人还没出生呢！\"]]]'),(1907789,'[[[\"npc\",\"手上一条鱼，包里三条鱼，吃掉一条鱼，还剩几条鱼？\"]]]'),(1907790,'[[[\"npc\",\"有朝一日，我也想要到陆地上瞧一瞧啊~\"]]]'),(1907791,'[[[\"npc\",\"考古才不是捡垃圾！！\"]]]'),(1907792,'[[[\"npc\",\"你付钱，我出力！会员打8折哦~\"]]]'),(1907793,'[[[\"npc\",\"只要我吃得够胖，我就能浮起来，离开这个海底！！\"]]]'),(1907794,'[[[\"npc\",\"我那个姐姐就是暴饮暴食才会变成那样的~\"]]]'),(1907795,'[[[\"npc\",\"我和那个两枪才能射倒苹果的所谓神枪手可不一样！我只要一枪就够了，人和苹果一起倒！\"]]]'),(1907796,'[[[\"npc\",\"海里的野兽十分凶猛，务必小心。\"]]]'),(1907797,'[[[\"npc\",\"这里可以随意走动也不会溺水哦~\"]]]'),(1907798,'[[[\"npc\",\"讲钱就伤感情了，不如这样，你帮我一个忙！\"]]]'),(1907799,'[[[\"npc\",\"我又迷路了~\"]]]'),(1907800,'[[[\"npc\",\"雪原寒冷，贸然外出等于送命呀！还是躲在家里舒服~\"]]]'),(1907801,'[[[\"npc\",\"尽管这里极端严寒，我们还是建起了自己的村落！全靠我们兽人族坚韧的意志和健美的肌肉！哈！唔！\"]]]'),(1907803,'[[[\"npc\",\"新鲜冰鱼！新鲜钓上来的冰鱼！一钓上来就被冰住的那种！快来买啊！\"]]]'),(1907804,'[[[\"npc\",\"倘若汝等需要协助，我与部族定当倾力相助！\"]]]'),(1907805,'[[[\"npc\",\"赛利亚虽然不能和你们并肩作战，但我会在后方给予支援的~\"]]]'),(1907806,'[[[\"npc\",\"哼哼~没有问题能够难道机智的帕吉大人，你尽管问吧！\"]]]'),(1907807,'[[[\"npc\",\"离我远点儿！臭小鬼！看你弱不禁风的，可别冻死在我旁边！\"]]]'),(1907808,'[[[\"npc\",\"传说这片冻土峡谷，是上古时期泰坦与巨龙大战后的废墟。\"]]]'),(1907809,'[[[\"npc\",\"脂肪能够保暖，但是那样的话身材就走样了！\"]]]'),(1907810,'[[[\"npc\",\"想要见识一下吗？我那独创的二天一流剑法！\"]]]'),(1907811,'[[[\"npc\",\"这里风大，还好我有防风火柴，你也要来一口吗？\"]]]'),(1907812,'[[[\"npc\",\"身为星灵可不能懈怠锻炼，小白羊看你这样子怕是吃胖了吧！\"]]]'),(1907813,'[[[\"npc\",\"干得漂亮！\",\"100403\"],[\"finish\",\"完成任务\",\"17\"]]]'),(1907814,'[[[\"npc\",\"近来暗裔恶魔频繁出现，连这小岛也愈发不安宁……\",\"100001\"],[\"finish\",\"完成任务\",\"10010\"]]]'),(1907816,'[[[\"npc\",\"最近岛上怪物暴躁，十分怪异，还请小心~\",\"100002\"],[\"finish\",\"完成任务\",\"10030\"]]]'),(1907817,'[[[\"npc\",\"哇哦~你这身行头真是太酷炫了！我们也察觉到了这座岛的怪异之处了。\",\"100003\"],[\"finish\",\"完成任务\",\"10040\"]]]'),(1907819,'[[[\"npc\",\"星灵？！你就是大法师说的那位被盖娅选召的冒险者？哎哎哎~别紧张，抵抗军组织了解一下~\",\"100003\"],[\"finish\",\"完成任务\",\"10050\"]]]'),(1907820,'[[[\"npc\",\"感谢勇者出手相救，不过这里水流湍急，你要到村子里去的话，我让豚豚送你一程~\",\"100004\"],[\"finish\",\"完成任务\",\"10060\"]]]'),(1907821,'[[[\"npc\",\"不……不好了！火鸡骑士部落带着一堆怪物袭击村子了！\",\"100005\"],[\"finish\",\"完成任务\",\"100005\"]]]'),(1907822,'[[[\"npc\",\"冒险者求求你救救村子里的人，快去和朔月海岸的守护者聊一聊吧！\",\"100005\"],[\"finish\",\"完成任务\",\"10080\"]]]'),(1907823,'[[[\"npc\",\"这次真是多亏你的帮助，不过你好像是生面孔，是最近才来的抵抗军新兵吗？\",\"201044\"],[\"finish\",\"完成任务\",\"10090\"]]]'),(1907825,'[[[\"npc\",\"唉！自从山顶那边落下一块陨石，火鸡骑士就变得比以前好斗，经常和强盗一起袭击村子，希望你能驱赶他们！\",\"100006\"],[\"finish\",\"完成任务\",\"10100\"]]]'),(1907826,'[[[\"npc\",\"火鸡骑士是喜欢搞事的家伙，总是成群结队偷盗牲畜，不过他们的坐骑火鸡，做成菜肴还是很美味的喵呜！\",\"100009\"],[\"finish\",\"完成任务\",\"10110\"]]]'),(1907827,'[[[\"npc\",\"如果你想到山顶那边，可以试试搭乘这个，这孩子最喜欢吃火鸡肉了，只要吃到火鸡肉，它就能带你到想去的任何地方~\",\"100009\"],[\"finish\",\"完成任务\",\"10120\"]]]'),(1907828,'[[[\"npc\",\"强盗们的眼光太过狭隘，真男人就应该放眼大海，要抢也是抢大的嘛！啊哈哈哈！\",\"100015\"],[\"finish\",\"完成任务\",\"10130\"]]]'),(1907829,'[[[\"npc\",\"流星那天晚上就跟白天一样亮，然后我就听到砰的一声，比打雷还要可怕的声音~\",\"100008\"],[\"finish\",\"完成任务\",\"10140\"]]]'),(1907830,'[[[\"npc\",\"呼~~在山顶抽烟果然舒服！哪来的小鬼？流星坠落的地方？那边~（用手指了指）\",\"100010\"],[\"finish\",\"完成任务\",\"10160\"]]]'),(1907831,'[[[\"npc\",\"这岛上的异常情况其实我们早就已经察觉了，所以劳伦斯才派遣我们介入调查。\",\"100010\"],[\"finish\",\"完成任务\",\"10170\"]]]'),(1907833,'[[[\"npc\",\"啊哒哒哒哒！你就是我们火鸡骑士一族的宿敌！你竟敢把我心爱的小鸡崽……纳命来！！\",\"100014\"],[\"finish\",\"完成任务\",\"10200\"]]]'),(1907835,'[[[\"npc\",\"搞不懂白羊座为什么会和你订立契约！竟然为了一个凡人变成现在这么屈辱的形态，吾等不能接受！！在吾等光耀之下化为灰烬吧！杂碎！\",\"100012\"],[\"finish\",\"完成任务\",\"10220\"]]]'),(1907836,'[[[\"npc\",\"哼！没想到小白羊能为你做到这种程度，身为她的守护神，我只能遵从她的意愿，月神那家伙会帮我看住你的，不要辜负了小白羊！\",\"100012\"],[\"finish\",\"完成任务\",\"10240\"]]]'),(1907837,'[[[\"npc\",\"情报员预测得没错，你就是我们要找的人，只有与星灵订立羁绊契约的人，才能与降神沟通并且使用其力量，而我们正好需要你这份能力！\",\"100013\"],[\"finish\",\"完成任务\",\"10250\"]]]'),(1907838,'[[[\"npc\",\"前面就是我们的大本营了，不过最近很多难缠的家伙，看来得解决掉它们才能进去啦~\",\"100201\"],[\"finish\",\"完成任务\",\"10260\"]]]'),(1907839,'[[[\"npc\",\"喂~是安娜吗？别跟我废话！快给我开门喵呜！好了，快进去吧！\",\"100202\"],[\"finish\",\"完成任务\",\"10280\"]]]'),(1907840,'[[[\"npc\",\"我倒想看看那只老猫咪又给我们带了个什么货色！算起来我是你长辈，不能直接叫我安娜！\",\"100203\"],[\"finish\",\"完成任务\",\"10290\"]]]'),(1907842,'[[[\"npc\",\"哦~！干得不错，干部们还在等着您呢，快过去吧！\",\"100205\"],[\"finish\",\"完成任务\",\"10310\"]]]'),(1907843,'[[[\"npc\",\"哟~年轻人，来抽一根不？我们当时击败了帝国军之后，夺取了他们的营地，稍作改造就成了我们抵抗军的据点啦~\",\"100206\"],[\"finish\",\"完成任务\",\"10320\"]]]'),(1907844,'[[[\"npc\",\"人不可貌相~你这不是挺强的嘛！\",\"100207\"],[\"finish\",\"完成任务\",\"10330\"]]]'),(1907845,'[[[\"npc\",\"暗裔魔物是帝国军邪恶研究的产物，如果不尽快铲除的话，这片大陆就会生灵涂炭，届时你的小白羊也复活无望了……\",\"100207\"],[\"finish\",\"完成任务\",\"10340\"]]]'),(1907847,'[[[\"npc\",\"开什喵玩笑？司令指派你和我一起前往洛亚王城！？喵呜~既然如此，你得准备好干粮！\",\"100208\"],[\"finish\",\"完成任务\",\"10360\"]]]'),(1907848,'[[[\"npc\",\"想不到你还挺能干的，到达王城之前，需要穿过迷雾沼泽，那里凶险无比，你那三脚猫功夫是顶不住的。\",\"100208\"],[\"finish\",\"完成任务\",\"10380\"]]]'),(1907849,'[[[\"npc\",\"你能帮我找找我的小小羊吗！小小羊被那些讨厌的虫子抢走了。\",\"100209\"],[\"trigger\",\"触发任务\",\"10390\"]]]'),(1907850,'[[[\"npc\",\"没错，小小羊是我抓走的，我接上头的命令想要考验一下你这位新人的综合素质。\",\"100210\"],[\"finish\",\"完成任务\",\"10400\"]]]'),(1907851,'[[[\"npc\",\"看这个小家伙怪可怜的，就当做你通过考察的奖励吧！主要是我不擅长照顾这种东西！\",\"100210\"],[\"finish\",\"完成任务\",\"10410\"]]]'),(1907852,'[[[\"npc\",\"我查阅了很多传说和书籍，星晶石的确是唤醒和复活星灵所需要的能量载体，幸运的是我们有关于星晶石的情报！\",\"100211\"],[\"finish\",\"完成任务\",\"10420\"]]]'),(1907853,'[[[\"npc\",\"星灵和守护能够提供你很多便利，如果收集到其他星灵和守护，务必告诉我哟！\",\"100211\"],[\"finish\",\"完成任务\",\"10430\"]]]'),(1907854,'[[[\"npc\",\"差点忘记说了，星晶石的位置预计是在北面，能不能找到就要看你的运气啦~\",\"100211\"],[\"finish\",\"完成任务\",\"10440\"]]]'),(1907855,'[[[\"npc\",\"干得不错~装备上更好的装备，我们经过迷雾沼泽的时候也能轻松一点喵呜~\",\"100212\"],[\"finish\",\"完成任务\",\"10450\"]]]'),(1907856,'[[[\"npc\",\"根据通讯员的情报，星晶石的能量反应就是在这附近了，不过这里也是暗裔魔物经常出没的地方。\",\"100212\"],[\"finish\",\"完成任务\",\"10460\"]]]'),(1907858,'[[[\"npc\",\"小跟班你干嘛盯着我看呀？我只是暂时变小了而已，快跟上，要去找我的好姐妹们呢！\",\"100216\"],[\"finish\",\"完成任务\",\"10510\"]]]'),(1907859,'[[[\"npc\",\"先拿去吧~这可是我们抵抗军骨干才有的福利待遇，小飞鞋至少能够让你在逃命时跑得快一些~\",\"100301\"],[\"finish\",\"完成任务\",\"10520\"]]]'),(1907860,'[[[\"npc\",\"年轻人，可别逞强哦~有时候量力而行也是战斗的智慧喵~\",\"100301\"],[\"finish\",\"完成任务\",\"10530\"]]]'),(1907861,'[[[\"npc\",\"我对于这里的情况还没有挖掘清楚，不过我还是建议你尽快提升自己的等级！\",\"100302\"],[\"finish\",\"完成任务\",\"10550\"]]]'),(1907862,'[[[\"npc\",\"太好了，只要消灭这些怪物，我们就能继续前进了！\",\"100303\"],[\"finish\",\"完成任务\",\"10560\"]]]'),(1907863,'[[[\"npc\",\"除了打怪升级增强实力，收集高阶装备也能迅速提升实力的说！\",\"100303\"],[\"finish\",\"完成任务\",\"10570\"]]]'),(1907864,'[[[\"npc\",\"我已经好久没用看到像你一样的活人啦！根据我多年史莱姆的经验，你一定实力非凡。\",\"100304\"],[\"finish\",\"完成任务\",\"10580\"]]]'),(1907866,'[[[\"npc\",\"嘿~那边的人类，能不能……借个火？说起来你可能不信，我快要死了……\",\"100305\"],[\"finish\",\"完成任务\",\"10610\"]]]'),(1907867,'[[[\"npc\",\"咕噜噜~活过来了，柴火用完的话我就会死去，这是我受到的诅咒~\",\"100305\"],[\"finish\",\"完成任务\",\"10620\"]]]'),(1907869,'[[[\"npc\",\"多谢冒险者的出手相救，我是来自吉煌的猫又，四处旅行的药贩子喵哈哈~\",\"100311\"],[\"finish\",\"完成任务\",\"10640\"]]]'),(1907870,'[[[\"npc\",\"这年头除了些不怕死的赏金猎人，很少有你这种愣头青踏足这块沼泽了，我很好奇，你在追寻什么吗？\",\"100310\"],[\"finish\",\"完成任务\",\"10660\"]]]'),(1907871,'[[[\"npc\",\"沼泽南边有大量的暗裔潜伏，务必干掉它们，因为你要找的星晶石很可能也在那里！\",\"100306\"],[\"finish\",\"完成任务\",\"10680\"]]]'),(1907873,'[[[\"npc\",\"能够遇到像你这样热心的冒险者，真是我莫大的幸运！\",\"100309\"],[\"finish\",\"完成任务\",\"10720\"]]]'),(1907874,'[[[\"npc\",\"小白羊！你……你怎么变小了？？\",\"100308\"],[\"finish\",\"完成任务\",\"10730\"]]]'),(1907875,'[[[\"npc\",\"怎么~不敢直面自己的欲望而想要逃跑吗？没有人能够拒绝暗裔的邀请的！不是吗？\",\"100312\"],[\"finish\",\"完成任务\",\"10740\"]]]'),(1907876,'[[[\"npc\",\"此地不宜久留，你和小白羊先跑，我稍后就会跟上你们的！\",\"100308\"],[\"finish\",\"完成任务\",\"10750\"]]]'),(1907877,'[[[\"npc\",\"双拳难敌四手，何况这些暗裔恶魔根本不是一只两只的数量，我稍后就到，你们先撤！\",\"100306\"],[\"finish\",\"完成任务\",\"10770\"]]]'),(1907878,'[[[\"npc\",\"我的族人都失去了理智，只有我还能保持意识。我也不知道自己能够坚持多久……\",\"100304\"],[\"finish\",\"完成任务\",\"10590\"]]]'),(1907879,'[[[\"npc\",\"年迈的大法师？嗯……是不是法师我就不太清楚了，不过那人身穿兜帽长袍，看起来很神秘。\",\"100311\"],[\"finish\",\"完成任务\",\"10650\"]]]'),(1907880,'[[[\"npc\",\"嗯，煮咒恶灵那家伙遵守了诺言，很好~看来星灵也顺利回到你身边了。\",\"100306\"],[\"finish\",\"完成任务\",\"10670\"]]]'),(1907881,'[[[\"npc\",\"你怎么才来呀~我都等得快要睡着了！搞快点！\",\"100309\"],[\"finish\",\"完成任务\",\"10710\"]]]'),(1907882,'[[[\"npc\",\"大难临头，小命要紧，抵抗军战斗第一条法则：不要上，就是怂！快跑~~\",\"100309\"],[\"finish\",\"完成任务\",\"10760\"]]]'),(1907883,'[[[\"npc\",\"往西边一直走有个港口，那里会有水手接应我们的！别磨蹭了，快动身吧！\",\"100306\"],[\"finish\",\"完成任务\",\"10780\"]]]'),(1907884,'[[[\"npc\",\"托鲁玛等你们好久了，快！快上船！我带你们到王城去！\",\"100307\"],[\"finish\",\"完成任务\",\"10790\"]]]'),(1907885,'[[[\"npc\",\"亲爱的玩家，想要激活自己的家园吗，快去为本帅清除前面的怪物吧\",\"0\"],[\"trigger\",\"触发任务\",\"40010\"]]]'),(1907886,'[[[\"npc\",\"感谢您\",\"0\"],[\"finish\",\"完成任务\",\"40010\"]]]'),(1907887,'[[[\"npc\",\"这里就是洛亚王城了，怎么样？是个好地方吧~哈哈哈哈哈\",\"100408\"],[\"finish\",\"完成任务\",\"10800\"]]]'),(1907888,'[[[\"npc\",\"我现在要务在身，参观王城这种事儿我就不陪你了，你自个儿去转转吧！\",\"100418\"],[\"finish\",\"完成任务\",\"10810\"]]]'),(1907889,'[[[\"npc\",\"那边儿的小鬼！一看你就是新来的了吧！瞧把你吓得，我第一次来王城也是你这种表情，哈哈！\",\"100415\"],[\"finish\",\"完成任务\",\"10820\"]]]'),(1907890,'[[[\"npc\",\"我为你准备了一个惊喜，不过你得先完成试炼才能知道是什么！\",\"100416\"],[\"finish\",\"完成任务\",\"10830\"]]]'),(1907891,'[[[\"npc\",\"我听说王城有个骁勇善战的将军，这次拜访，必定避不开他给予的挑战！\",\"100416\"],[\"finish\",\"完成任务\",\"10840\"]]]'),(1907892,'[[[\"npc\",\"冒险者请等一下！请到我这里来进行来访登记~\",\"100401\"],[\"finish\",\"完成任务\",\"10850\"]]]'),(1907893,'[[[\"npc\",\"欢迎来到洛亚王城，你通过了圣器试炼，就等同于得到了我的认可！\",\"100407\"],[\"finish\",\"完成任务\",\"10860\"]]]'),(1907894,'[[[\"npc\",\"圣器下落至今还没有线索~祝您好运冒险者！\",\"100409\"],[\"finish\",\"完成任务\",\"10870\"]]]'),(1907895,'[[[\"npc\",\"虽然我们目前有一些圣器在手，但是距离目标还差远了！不要松懈！\",\"100403\"],[\"finish\",\"完成任务\",\"10880\"]]]'),(1907897,'[[[\"npc\",\"想要变强的话，按照书上所说，就要努力找寻试炼并且尝试完成它！\",\"100414\"],[\"finish\",\"完成任务\",\"10900\"]]]'),(1907898,'[[[\"npc\",\"石头剪刀布！你也要来玩吗？不过输了的人要接受我的惩罚哦~\",\"100412\"],[\"finish\",\"完成任务\",\"10920\"]]]'),(1907899,'[[[\"npc\",\"哈哈哈~你输了！你要接受惩罚，你要在迷雾沼泽找到宝藏！\",\"100412\"],[\"finish\",\"完成任务\",\"10930\"]]]'),(1907900,'[[[\"npc\",\"居然因为猜拳接受惩罚，冒险者你真的很有意思~\",\"100303\"],[\"finish\",\"完成任务\",\"10940\"]]]'),(1907901,'[[[\"npc\",\"我的同胞都被暗裔影响了，不知道我什么时候也会变成这样~\",\"100304\"],[\"finish\",\"完成任务\",\"10950\"]]]'),(1907902,'[[[\"npc\",\"沼泽凶险，冒险者你还是好好保重吧！\",\"100304\"],[\"finish\",\"完成任务\",\"10960\"]]]'),(1907903,'[[[\"npc\",\"你运气真好，居然能在这里找到宝藏！\",\"100305\"],[\"finish\",\"完成任务\",\"10970\"]]]'),(1907904,'[[[\"npc\",\"唉~不知道大法师什么时候解除我的煮咒……\",\"100305\"],[\"finish\",\"完成任务\",\"10980\"]]]'),(1907905,'[[[\"npc\",\"出门在外，尤其是冒险者，难免有跌打损伤，来一些万应止痛喵喵丸吧！\",\"100311\"],[\"finish\",\"完成任务\",\"10990\"]]]'),(1907906,'[[[\"npc\",\"既然森林神殿设置了戒备，那我们就强行突破戒备，趁着这段时间好好提升自己的实力吧！\",\"100310\"],[\"finish\",\"完成任务\",\"11000\"]]]'),(1907907,'[[[\"npc\",\"干得不错，随着你的实力提升，就能挑战更为强大的boss了！\",\"100306\"],[\"finish\",\"完成任务\",\"11010\"]]]'),(1907911,'[[[\"npc\",\"工欲善其事必先利其器，自身的实力增强固然重要，更好的装备也能提升实力！\",\"100502\"],[\"finish\",\"完成任务\",\"11050\"]]]'),(1907912,'[[[\"npc\",\"嘻嘻嘻，这些材料可是制作武器的素材哦~\",\"100503\"],[\"finish\",\"完成任务\",\"11060\"]]]'),(1907913,'[[[\"npc\",\"想要变强的话，低级装备已经不能满足你的需求了，你得想法设法打造出更高级的装备！\",\"100504\"],[\"finish\",\"完成任务\",\"11070\"]]]'),(1907914,'[[[\"npc\",\"我从你眼中看出了急切变强的决心，很好，回到主城后我会更进一步教你！\",\"100505\"],[\"finish\",\"完成任务\",\"11080\"]]]'),(1907915,'[[[\"npc\",\"看着你逐步成长，我也感到十分欣慰呀~喵呜\",\"100506\"],[\"finish\",\"完成任务\",\"11090\"]]]'),(1907916,'[[[\"npc\",\"想要变强，先要变帅！\",\"100507\"],[\"finish\",\"完成任务\",\"11100\"]]]'),(1907917,'[[[\"npc\",\"副本和boss是我们变强的重要途径，每天都要持之以恒地进行挑战！\",\"100508\"],[\"finish\",\"完成任务\",\"11110\"]]]'),(1907918,'[[[\"npc\",\"我是退伍的守卫，这里应有尽有，各位走过路过莫错过呀！\",\"100509\"],[\"finish\",\"完成任务\",\"11120\"]]]'),(1907919,'[[[\"npc\",\"路边的蘑菇不要随便采哦~指不定就会当场去世的哦~\",\"100510\"],[\"finish\",\"完成任务\",\"1\"]]]'),(1907921,'[[[\"npc\",\"事不宜迟，我们动身吧~\",\"100510\"],[\"finish\",\"完成任务\",\"11150\"]]]'),(1907922,'[[[\"npc\",\"单枪匹马就想闯入森林神殿，你未免也太自大了吧！？\",\"100511\"],[\"finish\",\"完成任务\",\"11160\"]]]'),(1907924,'[[[\"npc\",\"必要时候我会助你一臂之力的！\",\"100512\"],[\"finish\",\"完成任务\",\"11180\"]]]'),(1907925,'[[[\"npc\",\"蘑菇林奇珍异兽繁多，要是能够收集到精灵之羽，或许能助您一翼之力！\",\"100513\"],[\"finish\",\"完成任务\",\"11190\"]]]'),(1907926,'[[[\"npc\",\"精灵之羽？那种充满魔法的素材可以制成美丽的羽翼！\",\"100514\"],[\"finish\",\"完成任务\",\"11200\"]]]'),(1907927,'[[[\"npc\",\"神殿位于世界树的树冠之上，看到远处那颗参天大树了吗？我们离它不远了~\",\"100514\"],[\"finish\",\"完成任务\",\"11210\"]]]'),(1907928,'[[[\"npc\",\"你就是那个得到森林认可的年轻抵抗军嘛？欢迎来到森林神殿。\",\"100601\"],[\"finish\",\"完成任务\",\"11220\"]]]'),(1907929,'[[[\"npc\",\"黄道十二宫的姐妹很快就能团聚了吧？我也要加把劲才行！\",\"100602\"],[\"finish\",\"完成任务\",\"11230\"]]]'),(1907930,'[[[\"npc\",\"神殿是接近精灵族神明的领域，我们暗精灵是不被认可的存在。\",\"100603\"],[\"finish\",\"完成任务\",\"11240\"]]]'),(1907931,'[[[\"npc\",\"哼~看你还是个门外汉，我就勉为其难稍微指导一下你吧！\",\"100604\"],[\"finish\",\"完成任务\",\"11250\"]]]'),(1907932,'[[[\"npc\",\"以门外汉的水平，对付起来也是有惊无险的程度吧~\",\"100604\"],[\"finish\",\"完成任务\",\"11260\"]]]'),(1907933,'[[[\"npc\",\"踏足这片满溢生命之力的神殿领域，让我看看你够不够资格！\",\"100605\"],[\"finish\",\"完成任务\",\"11270\"]]]'),(1907935,'[[[\"npc\",\"从我们的角度来看，你的实力已经十分不错了！\",\"100605\"],[\"finish\",\"完成任务\",\"11290\"]]]'),(1907936,'[[[\"npc\",\"好吧！你的实力我认可了，但是你的意志力如何，我还要继续观察！\",\"100606\"],[\"finish\",\"完成任务\",\"11300\"]]]'),(1907937,'[[[\"npc\",\"自从遭遇暗裔入侵，各部族之间就一直人心惶惶，为了部族大部分同胞的利益，女王流放了暗精灵……\",\"100606\"],[\"finish\",\"完成任务\",\"11310\"]]]'),(1907938,'[[[\"npc\",\"精灵部族繁多，如今内忧外患，唉~这种麻烦的事情，还是你亲自和女王当面说吧！\",\"100604\"],[\"finish\",\"完成任务\",\"11320\"]]]'),(1907939,'[[[\"npc\",\"即便你们想要同盟，但是精灵族部族繁多，加上我们已是被放逐的部族，希望渺茫……\",\"100603\"],[\"finish\",\"完成任务\",\"11330\"]]]'),(1907940,'[[[\"npc\",\"既然你都证明了自己的实力，也是时候去见见女王大人了~\",\"100601\"],[\"finish\",\"完成任务\",\"11340\"]]]'),(1907941,'[[[\"npc\",\"精灵部族还有许多矛盾纷争需要解决，同盟恐怕并非易事。\",\"100614\"],[\"finish\",\"完成任务\",\"11350\"]]]'),(1907942,'[[[\"npc\",\"同盟之事还需延后，哀家要先解决我们部族内部的矛盾，倘若冒险者可以助我们一臂之力，那就再好不过了。\",\"100610\"],[\"finish\",\"完成任务\",\"11360\"]]]'),(1907943,'[[[\"npc\",\"经过神殿守卫的实力检验，哀家觉得你一定是这次事件的得力助手了！\",\"100610\"],[\"finish\",\"完成任务\",\"11370\"]]]'),(1907944,'[[[\"npc\",\"神殿东部的蜥蜴人部族暴动了，请冒险者快去支援！\",\"100614\"],[\"finish\",\"完成任务\",\"11380\"]]]'),(1907945,'[[[\"npc\",\"听说蜥蜴人部族暴动了，这下可麻烦了！\",\"100607\"],[\"finish\",\"完成任务\",\"11390\"]]]'),(1907947,'[[[\"npc\",\"我之前是小看你了，想不到人类也有如此大的可能性啊~\",\"100609\"],[\"finish\",\"完成任务\",\"11410\"]]]'),(1907949,'[[[\"npc\",\"精灵部族有意向和我们结盟，不过前提是他们部族得先完成联合是吗？\",\"100613\"],[\"finish\",\"完成任务\",\"11430\"]]]'),(1907950,'[[[\"npc\",\"如果可以的话，冒险者可以帮我送一份礼物给精灵族的人吗？算是我们东部部族同意结盟的证明！\",\"100613\"],[\"finish\",\"完成任务\",\"11440\"]]]'),(1907951,'[[[\"npc\",\"噢！看来东部的兽人部族同意结盟了，好样的！赶紧向女王汇报这个好消息！\",\"100609\"],[\"finish\",\"完成任务\",\"11450\"]]]'),(1907952,'[[[\"npc\",\"你们抵抗军还真会折腾，居然能把兽人部族也搞定啦！\",\"100608\"],[\"finish\",\"完成任务\",\"11460\"]]]'),(1907953,'[[[\"npc\",\"此前因为暗裔的入侵，东部区域都被腐化污染，因此资源分配上产生了纠纷，想不到你们能够解决这次的暴乱。\",\"100607\"],[\"finish\",\"完成任务\",\"11470\"]]]'),(1907954,'[[[\"npc\",\"请快速到神殿守护者那里一趟！\",\"100614\"],[\"finish\",\"完成任务\",\"11480\"]]]'),(1907955,'[[[\"npc\",\"暗精灵部族那边出现了冲突，兽人族同盟的消息交给我传达吧！勇者你快去阻止暗精灵！\",\"100614\"],[\"finish\",\"完成任务\",\"11490\"]]]'),(1907956,'[[[\"npc\",\"还有部分蜥蜴人十分顽固，他们下次还会来的！教训下他们，让他们以后都不敢来找茬！\",\"100607\"],[\"finish\",\"完成任务\",\"11500\"]]]'),(1907957,'[[[\"npc\",\"我就知道冲突不可能这么轻易就解决的，加把劲吧！冒险者~\",\"100608\"],[\"finish\",\"完成任务\",\"11510\"]]]'),(1907959,'[[[\"npc\",\"这次暗精灵的冲突，看来是有计划的行动，关键是要知道幕后主使是谁才行！\",\"100609\"],[\"finish\",\"完成任务\",\"11530\"]]]'),(1907960,'[[[\"npc\",\"看什么看？没见过火鸡啊？\",\"100612\"],[\"finish\",\"完成任务\",\"11540\"]]]'),(1907962,'[[[\"npc\",\"哼！我身为骑士可是守口如瓶的，怎么可能告诉你这次冲突的幕后主使就是刺客芙蕾？\",\"100612\"],[\"finish\",\"完成任务\",\"11560\"]]]'),(1907963,'[[[\"npc\",\"我明明知道这样做是不对的，但是凭什么暗精灵就要被驱逐家园呢？我们也只是受害者啊！\",\"100611\"],[\"finish\",\"完成任务\",\"11570\"]]]'),(1907964,'[[[\"npc\",\"既然我们要面对共同的敌人，我代表暗精灵同意结盟！\",\"100611\"],[\"finish\",\"完成任务\",\"11590\"]]]'),(1907966,'[[[\"npc\",\"本天才最近发明了一种新的炼金术，可以合成红装哦！\",\"100503\"],[\"finish\",\"完成任务\",\"11600\"]]]'),(1907967,'[[[\"npc\",\"好想快点和其他星灵姐妹团聚呀！\",\"100504\"],[\"finish\",\"完成任务\",\"11610\"]]]'),(1907969,'[[[\"npc\",\"我接下来打算找到那个叫夜刃的组织领头人！\",\"100507\"],[\"finish\",\"完成任务\",\"11640\"]]]'),(1907970,'[[[\"npc\",\"战斗技艺你已经精进了不少了！\",\"100508\"],[\"finish\",\"完成任务\",\"11650\"]]]'),(1907971,'[[[\"npc\",\"蘑菇林的山珍佳肴，想着就流口水了！\",\"100509\"],[\"finish\",\"完成任务\",\"11660\"]]]'),(1907972,'[[[\"npc\",\"哼哼~让我来为你们做一道拿手菜：酥炸香菇！\",\"100510\"],[\"finish\",\"完成任务\",\"11670\"]]]'),(1907973,'[[[\"npc\",\"时机已到，我们出发吧！\",\"100416\"],[\"finish\",\"完成任务\",\"11680\"]]]'),(1907974,'[[[\"npc\",\"夜刃神出鬼没，想要找到她也不是件容易的事情\",\"100306\"],[\"finish\",\"完成任务\",\"11690\"]]]'),(1907975,'[[[\"npc\",\"夜刃？我可和他们没有关系，不过你如果想套情报的话，帮我做几件事吧！\",\"100310\"],[\"finish\",\"完成任务\",\"11700\"]]]'),(1907976,'[[[\"npc\",\"其实这些暗裔妖精在被侵蚀之前，就是精灵部族的暗精灵\",\"100305\"],[\"finish\",\"完成任务\",\"11710\"]]]'),(1907977,'[[[\"npc\",\"但是她这样做的动机是什么呢？\",\"100305\"],[\"finish\",\"完成任务\",\"11720\"]]]'),(1907978,'[[[\"npc\",\"可……可恶，那个暗精灵！\",\"100309\"],[\"finish\",\"完成任务\",\"11730\"]]]'),(1907979,'[[[\"npc\",\"那个暗精灵想一个人解决掉那个大魔物\",\"100308\"],[\"finish\",\"完成任务\",\"11740\"]]]'),(1907980,'[[[\"npc\",\"她孤身一人等于送死的啊\",\"100308\"],[\"finish\",\"完成任务\",\"11750\"]]]'),(1907981,'[[[\"npc\",\"多谢救命之恩\",\"100310\"],[\"finish\",\"完成任务\",\"11760\"]]]'),(1907982,'[[[\"npc\",\"我要去见精灵女王，不过在那之前，陪我去一趟蘑菇林\",\"100310\"],[\"finish\",\"完成任务\",\"11770\"]]]'),(1907983,'[[[\"npc\",\"啊啦~这不是芙蕾嘛！\",\"100503\"],[\"finish\",\"完成任务\",\"11780\"]]]'),(1907985,'[[[\"npc\",\"你是？芙蕾！是芙蕾吗！\",\"100510\"],[\"finish\",\"完成任务\",\"11800\"]]]'),(1907987,'[[[\"npc\",\"香菇作为调料真的很美味呢~\",\"100512\"],[\"finish\",\"完成任务\",\"11820\"]]]'),(1907988,'[[[\"npc\",\"多亏了抵抗军的协助，蘑菇林才安定下来\",\"100513\"],[\"finish\",\"完成任务\",\"11830\"]]]'),(1907990,'[[[\"npc\",\"毫无疑问，芙蕾是暗精灵部族众望所归的核心人物！\",\"100514\"],[\"finish\",\"完成任务\",\"11850\"]]]'),(1907991,'[[[\"npc\",\"冒险者，快点行动起来！\",\"100602\"],[\"finish\",\"完成任务\",\"11860\"]]]'),(1907992,'[[[\"npc\",\"你平安无事就好了，快去见朵萝丝吧！\",\"100603\"],[\"finish\",\"完成任务\",\"11880\"]]]'),(1907993,'[[[\"npc\",\"不敢相信，你居然还平安无事！？\",\"100604\"],[\"finish\",\"完成任务\",\"11890\"]]]'),(1907994,'[[[\"npc\",\"恭候你多时了，这样部族就算达成统一了，不过按照习俗，战斗切磋是无法避免的。\",\"100605\"],[\"finish\",\"完成任务\",\"11900\"]]]'),(1907995,'[[[\"npc\",\"不错~不愧是被女王认可的冒险者！\",\"100605\"],[\"finish\",\"完成任务\",\"11910\"]]]'),(1907996,'[[[\"npc\",\"不愧是身为夜刃的精灵\",\"100603\"],[\"finish\",\"完成任务\",\"11920\"]]]'),(1907997,'[[[\"npc\",\"再接再厉吧！不要松懈\",\"100602\"],[\"finish\",\"完成任务\",\"11940\"]]]'),(1907998,'[[[\"npc\",\"东部试炼开始啦\",\"100607\"],[\"finish\",\"完成任务\",\"11950\"]]]'),(1907999,'[[[\"npc\",\"虽然你没有我的美貌那么出众，但是战斗力还是值得认可的！\",\"100609\"],[\"finish\",\"完成任务\",\"11960\"]]]'),(1908000,'[[[\"npc\",\"我忘记要说什么了，让我再想想\",\"100609\"],[\"finish\",\"完成任务\",\"11970\"]]]'),(1908001,'[[[\"npc\",\"也许书上说的没错，传说中的冒险者通过了神殿中人马赐予的试炼。\",\"100614\"],[\"finish\",\"完成任务\",\"11980\"]]]'),(1908002,'[[[\"npc\",\"现在的挑战，对于你们来说没有任何负担啊~\",\"100603\"],[\"finish\",\"完成任务\",\"11990\"]]]'),(1908003,'[[[\"npc\",\"最后关头了，继续前进吧！\",\"100605\"],[\"finish\",\"完成任务\",\"12000\"]]]'),(1908004,'[[[\"npc\",\"总算，所有部族都重新归入精灵部族了！\",\"100606\"],[\"finish\",\"完成任务\",\"12020\"]]]'),(1908005,'[[[\"npc\",\"想不到我们部族的统一竟然是你这位人类的功劳~\",\"100604\"],[\"finish\",\"完成任务\",\"12030\"]]]'),(1908006,'[[[\"npc\",\"希望你能去寻找大法师\",\"100305\"],[\"finish\",\"完成任务\",\"10630\"]]]'),(1908007,'[[[\"npc\",\"我是埃罗恩大法师的信使，他让我在这里等您，希望您能去找他~\",\"100305\"],[\"finish\",\"完成任务\",\"10630\"]]]'),(1908008,'[[[\"npc\",\"精灵部族内乱期间，许多暗精灵被迫离开部族，他们也是关键的力量！\",\"100506\"],[\"finish\",\"完成任务\",\"11630\"]]]'),(1908009,'[[[\"npc\",\"伟大的暗裔必将崛起，届时这片大陆将灰飞烟灭，尽管挣扎吧！凡人！\",\"100017\"],[\"finish\",\"完成任务\",\"10150\"]]]'),(1908010,'[[[\"npc\",\"年轻人，我看你是中暑了！没见过会说话的猫吗！？\",\"100011\"],[\"finish\",\"完成任务\",\"10180\"]]]'),(1908013,'[[[\"npc\",\"想要在这片沙漠存活，首先要懂得如何杀戮！\"]]]'),(1908014,'[[[\"npc\",\"适者生存，是这片沙漠的准则。\"]]]'),(1908015,'[[[\"npc\",\"这片沙漠的原住民可是生活在水深火热当中啊~\"]]]'),(1908016,'[[[\"npc\",\"村落水源短缺，不时还会被沙盗们强征食物，我们实在是忍无可忍了！\"]]]'),(1908017,'[[[\"npc\",\"大人们苦点没关系，但是孩子们太受罪了~\"]]]'),(1908018,'[[[\"npc\",\"要是椰子树能再多几个椰子就好了……椰子水真的好好喝呀……\"]]]'),(1908019,'[[[\"npc\",\"哥哥上次为了帮我摘椰子，狠狠地摔了一跤。\"]]]'),(1908020,'[[[\"npc\",\"大不敬！区区凡人竟敢顶撞法老！\"]]]'),(1908021,'[[[\"npc\",\"要是那帮沙盗有点良心，这村子也不至于这么落魄~\"]]]'),(1908022,'[[[\"npc\",\"换做是你，也一定会忍不住出手相助吧！\"]]]'),(1908023,'[[[\"npc\",\"这些沙盗的行为，就跟从猫的嘴里抢走小鱼干一样，恶劣！\"]]]'),(1908024,'[[[\"npc\",\"有机会去我的故乡吉煌之国的话，我就免费当你的向导！\"]]]'),(1908025,'[[[\"npc\",\"情报显示，这里曾是古代王陵的遗迹！\"]]]'),(1908027,'[[[\"npc\",\"祝你好运了，冒险者~\",\"100701\"],[\"finish\",\"完成任务\",\"12040\"]]]'),(1908028,'[[[\"npc\",\"道路被那些怪物占领了，你想见酋长的话也没有办法啊~\",\"100702\"],[\"finish\",\"完成任务\",\"12050\"]]]'),(1908029,'[[[\"npc\",\"其实兽人部族内部出现了两派分歧：保守派和激进派，详细的你还是去问问酋长吧~\",\"100702\"],[\"finish\",\"完成任务\",\"12060\"]]]'),(1908030,'[[[\"npc\",\"给我站住！你身上有我同伴的味道！\",\"100703\"],[\"finish\",\"完成任务\",\"12070\"]]]'),(1908031,'[[[\"npc\",\"你这个谋害我同伴的凶手！我不会让你见大酋长的！\",\"100703\"],[\"finish\",\"完成任务\",\"12080\"]]]'),(1908032,'[[[\"npc\",\"难道你们就是五年前为我们提供军火协助的抵抗军？\",\"100704\"],[\"finish\",\"完成任务\",\"12090\"]]]'),(1908033,'[[[\"npc\",\"与抵抗军结盟我很乐意，但是如今部族内部分成两派，与我敌对的激进派信仰拳头说话，除非你能以武服人~\",\"100704\"],[\"finish\",\"完成任务\",\"12100\"]]]'),(1908034,'[[[\"npc\",\"雪原狼可是我们这里数一数二的猛兽，你竟然能够毫发无损！\",\"100704\"],[\"finish\",\"完成任务\",\"12120\"]]]'),(1908035,'[[[\"npc\",\"啊啦~这里的木柴可不能随便拿的哦~\",\"100705\"],[\"finish\",\"完成任务\",\"12130\"]]]'),(1908036,'[[[\"npc\",\"既然用掉了也没办法了，不如你看看部族里谁需要帮忙吧~这件事就一笔勾销了！\",\"100705\"],[\"finish\",\"完成任务\",\"12140\"]]]'),(1908037,'[[[\"npc\",\"现在的我相当于越级打怪啊~这赏金太诱人了，不能就这样放弃！\",\"100706\"],[\"finish\",\"完成任务\",\"12150\"]]]'),(1908038,'[[[\"npc\",\"按照约定，赏金我们就五五开了~\",\"100706\"],[\"finish\",\"完成任务\",\"12160\"]]]'),(1908039,'[[[\"npc\",\"我只是个无名小卒，我的家族代代相传着一个故事，你想听吗？\",\"100707\"],[\"finish\",\"完成任务\",\"12170\"]]]'),(1908040,'[[[\"npc\",\"前面有两条岔路，一条通往冰霜泰坦，一条则是通往冰霜巨龙，两条路的尽头都是寒冷与死亡~\",\"100707\"],[\"finish\",\"完成任务\",\"12180\"]]]'),(1908041,'[[[\"npc\",\"你从哥布林口中听到的冰霜巨龙，是寒鸦峡谷曾经的霸主，短期内要战胜它还是有点难度的~\",\"100409\"],[\"finish\",\"完成任务\",\"12200\"]]]'),(1908042,'[[[\"npc\",\"根据资料显示，冰霜巨龙的属性可以被火克制，只要我们找到强大的火属性伙伴，一定能够战胜它的！\",\"100417\"],[\"finish\",\"完成任务\",\"12210\"]]]'),(1908043,'[[[\"npc\",\"原来你是去了寒鸦峡谷，想起来我还去过那里，可把我冻坏了，那时我还救了一条小冰龙来着~\",\"100601\"],[\"finish\",\"完成任务\",\"12220\"]]]'),(1908044,'[[[\"npc\",\"其实也不必非要用火来制服它，那个孩子只是比较贪吃罢了，或者森林那边的巫婆可以帮个忙~\",\"100601\"],[\"finish\",\"完成任务\",\"12230\"]]]'),(1908045,'[[[\"npc\",\"你胆子可真大，竟敢独自一人去找巫婆！\",\"100604\"],[\"finish\",\"完成任务\",\"12250\"]]]'),(1908046,'[[[\"npc\",\"你这臭小子上次的事情我还没跟你算账，不过如果你能帮我弄来几片龙鳞，我还是乐意不计前嫌的~\",\"100605\"],[\"finish\",\"完成任务\",\"12260\"]]]'),(1908047,'[[[\"npc\",\"哼哼~很好，材料都备齐了，这瓶药你拿去吧！对付龙类可是十分凑效的！\",\"100605\"],[\"finish\",\"完成任务\",\"12280\"]]]'),(1908048,'[[[\"npc\",\"一路上要小心呀~记得有空多回来看看我们！\",\"100607\"],[\"finish\",\"完成任务\",\"12290\"]]]'),(1908049,'[[[\"npc\",\"唉？我是不是之前在这里见过你，总觉得你像我的孙子~\",\"100609\"],[\"finish\",\"完成任务\",\"12300\"]]]'),(1908050,'[[[\"npc\",\"我就知道你一定有办法的，快走吧！\",\"100613\"],[\"finish\",\"完成任务\",\"12310\"]]]'),(1908051,'[[[\"npc\",\"既然如此，我也不阻拦你了，祝你好运~\",\"100701\"],[\"finish\",\"完成任务\",\"12320\"]]]'),(1908052,'[[[\"npc\",\"验证传说的时候到了，快去吧！冒险者！\",\"100707\"],[\"finish\",\"完成任务\",\"12330\"]]]'),(1908053,'[[[\"npc\",\"呼！可冻死我啦！赶紧解决那条大蜥蜴咱们回去啦！\",\"100713\"],[\"finish\",\"完成任务\",\"12340\"]]]'),(1908054,'[[[\"npc\",\"什么！？你解决完大蜥蜴还要去找酋长？我不管啦！我要回去喝热牛奶了！\",\"100713\"],[\"finish\",\"完成任务\",\"12350\"]]]'),(1908055,'[[[\"npc\",\"我滴个泰坦呀！你竟然击败了传说中的冰霜巨龙！\",\"100709\"],[\"finish\",\"完成任务\",\"12370\"]]]'),(1908056,'[[[\"npc\",\"你是我们雪原的英雄，是两派部族和好的希望呀！\",\"100710\"],[\"finish\",\"完成任务\",\"12380\"]]]'),(1908057,'[[[\"npc\",\"这是我们兽人族的英雄之证，拿着这个去见我们的酋长吧！\",\"100710\"],[\"finish\",\"完成任务\",\"12390\"]]]'),(1908058,'[[[\"npc\",\"所以我讨厌在这种冰天雪地里出勤任务！\",\"100713\"],[\"finish\",\"完成任务\",\"12400\"]]]'),(1908059,'[[[\"npc\",\"原来我们家族代代相传的故事是真的！\",\"100707\"],[\"finish\",\"完成任务\",\"12410\"]]]'),(1908060,'[[[\"npc\",\"听说你打败了冰霜巨龙，现在貌似两派暂时缓和了下来，我觉得是你们进行结盟的好时机！\",\"100701\"],[\"finish\",\"完成任务\",\"12420\"]]]'),(1908061,'[[[\"npc\",\"你击败了冰霜巨龙，其实间接帮助我们部族停止了内乱~\",\"100702\"],[\"finish\",\"完成任务\",\"12430\"]]]'),(1908062,'[[[\"npc\",\"两派的酋长都召集了部族里的男性去召开会议，你现在去的话或许能赶上~\",\"100702\"],[\"finish\",\"完成任务\",\"12440\"]]]'),(1908063,'[[[\"npc\",\"虽然我知道你击败了冰霜巨龙，但是你一个外乡人想参加我们部族的会议，是要买门票的！\",\"100703\"],[\"finish\",\"完成任务\",\"12450\"]]]'),(1908064,'[[[\"npc\",\"勇者你来得正好，容许我向同胞们介绍一下你~\",\"100704\"],[\"finish\",\"完成任务\",\"12460\"]]]'),(1908065,'[[[\"npc\",\"如今帝国军的行径越来越猖獗，甚至还大肆在各地投放暗裔恶魔，若我们不再联合起来，各种族将会被一一击溃！\",\"100704\"],[\"finish\",\"完成任务\",\"12470\"]]]'),(1908066,'[[[\"npc\",\"我会在后方给予你们支援的！\",\"100705\"],[\"finish\",\"完成任务\",\"12480\"]]]'),(1908067,'[[[\"npc\",\"可别小看了我们兽人族，每个人都是不畏严寒的坚强士兵！\",\"100705\"],[\"finish\",\"完成任务\",\"12490\"]]]'),(1908068,'[[[\"npc\",\"哈哈哈，跟抵抗军结盟之后，或许我就能接到更多赏金任务了！什么？你说我就算接了也完成不了？\",\"100706\"],[\"finish\",\"完成任务\",\"12500\"]]]'),(1908069,'[[[\"npc\",\"虽然我们祖传的传说已经得到了证实，但是我想谱写一段新的传说，关于你的传说！\",\"100707\"],[\"finish\",\"完成任务\",\"12520\"]]]'),(1908070,'[[[\"npc\",\"别再让我孤独地等待，请给我一杯热牛奶~\",\"100713\"],[\"finish\",\"完成任务\",\"12530\"]]]'),(1908071,'[[[\"npc\",\"屠龙的少年终为龙，我希望你不是成为那样子的人~\",\"100713\"],[\"finish\",\"完成任务\",\"12540\"]]]'),(1908072,'[[[\"npc\",\"你就是拯救雪原的英雄！\",\"100709\"],[\"finish\",\"完成任务\",\"12550\"]]]'),(1908073,'[[[\"npc\",\"不过我们也不能大意，帝国军战力强盛，即便我们联合也是前途未卜……\",\"100709\"],[\"finish\",\"完成任务\",\"12560\"]]]'),(1908074,'[[[\"npc\",\"让我给你一些旅行的建议吧！\",\"100710\"],[\"finish\",\"完成任务\",\"12570\"]]]'),(1908075,'[[[\"npc\",\"我听说这雪原之外啊~就是炎热的沙漠了！冰火两重天，这谁顶得住哇！\",\"100711\"],[\"finish\",\"完成任务\",\"12580\"]]]'),(1908076,'[[[\"npc\",\"别看大叔我好像不中用，我还是能给你一些作为勇者的建议的~\",\"100711\"],[\"finish\",\"完成任务\",\"12590\"]]]'),(1908077,'[[[\"npc\",\"它们是冰原的守望者，战胜了它们，证明你有能力守护这片雪原~\",\"100712\"],[\"finish\",\"完成任务\",\"12600\"]]]'),(1908078,'[[[\"npc\",\"去到那边的话小心不要中暑了哦~\",\"100712\"],[\"finish\",\"完成任务\",\"12610\"]]]'),(1908079,'[[[\"npc\",\"此路由我开，留下买路财！\",\"100801\"],[\"finish\",\"完成任务\",\"12620\"]]]'),(1908081,'[[[\"npc\",\"沙漠无情，适者生存，别说沙盗了，是个人都会被这里的环境逼疯的~\",\"100802\"],[\"finish\",\"完成任务\",\"12640\"]]]'),(1908083,'[[[\"npc\",\"我在这久候多时了，冒险者，废话不多说，你听说过这里曾经有个繁荣的传说王国吗？\",\"100803\"],[\"finish\",\"完成任务\",\"12660\"]]]'),(1908084,'[[[\"npc\",\"那个覆灭的王朝，据说曾经拥有比肩神力的法老和那珍稀的神器！\",\"100803\"],[\"finish\",\"完成任务\",\"12670\"]]]'),(1908085,'[[[\"npc\",\"多谢勇者出手相救，这些沙盗一直都在欺压我们这些平民，粮食淡水经常被那些恶霸抢走了哇！！\",\"100804\"],[\"finish\",\"完成任务\",\"12680\"]]]'),(1908086,'[[[\"npc\",\"村子里的人半年前就都大部分出走了，剩下的都是老人小孩和妇女，只有少数的男人还坚守在此……\",\"100804\"],[\"finish\",\"完成任务\",\"12690\"]]]'),(1908087,'[[[\"npc\",\"那些没良心的佣兵把我的孩子掳走了，说要把他当成活祭品献祭！求求你们救救我的孩子！！\",\"100805\"],[\"finish\",\"完成任务\",\"12700\"]]]'),(1908088,'[[[\"npc\",\"你是？我在村子里都没见过你呢？请问你有看到我的妈妈嘛？\",\"100806\"],[\"finish\",\"完成任务\",\"12710\"]]]'),(1908089,'[[[\"npc\",\"这些坏蛋抢走了我们的粮食还有淡水，大坏蛋！！\",\"100806\"],[\"finish\",\"完成任务\",\"12720\"]]]'),(1908091,'[[[\"npc\",\"啊~这是之前被抢走的粮食和淡水！这下村子有救了！\",\"100805\"],[\"finish\",\"完成任务\",\"12730\"]]]'),(1908092,'[[[\"npc\",\"没错，你们要找的遗迹的确是在这附近，不过外乡人不熟悉这边，我还是让一个人为你们带路吧！\",\"100805\"],[\"finish\",\"完成任务\",\"12740\"]]]'),(1908093,'[[[\"npc\",\"哈哈~感谢你们救了我们的村子，快跟我来，我带你们去找宝藏！\",\"100807\"],[\"finish\",\"完成任务\",\"12750\"]]]'),(1908094,'[[[\"npc\",\"大胆！见到吾等至高无上的法老，还不跪下！\",\"100808\"],[\"finish\",\"完成任务\",\"12770\"]]]'),(1908095,'[[[\"npc\",\"虽然我是法老，但我不可能告诉你们这些刁民任何关于王陵的消息的！\",\"100808\"],[\"finish\",\"完成任务\",\"12780\"]]]'),(1908096,'[[[\"npc\",\"你手上的东西很别致啊？可以卖给我吗？\",\"100812\"],[\"finish\",\"完成任务\",\"12790\"]]]'),(1908097,'[[[\"npc\",\"唉？你说看到一个身穿法老服饰的少女？怎么可能！法老的王朝在几百年前就覆灭了呀！\",\"100812\"],[\"finish\",\"完成任务\",\"12800\"]]]'),(1908098,'[[[\"npc\",\"如果你说的都是真的话，那么你见到的少女可能是一种幻象或者灵魂。\",\"100409\"],[\"finish\",\"完成任务\",\"12810\"]]]'),(1908099,'[[[\"npc\",\"几百年前确实法老王朝就覆灭殆尽了，据说王室的眷族都和末代法老一同陪葬了，这样说来，你看到的女孩说不定是末代法老的眷族！\",\"100405\"],[\"finish\",\"完成任务\",\"12820\"]]]'),(1908100,'[[[\"npc\",\"真如国王所说的话，说不定那位法老的眷族是有未曾了却的心愿，如果我们能帮助她了却心愿的话……\",\"100407\"],[\"finish\",\"完成任务\",\"12830\"]]]'),(1908101,'[[[\"npc\",\"虽然你是个务实的人，但是这次就要看你能不能取得那位少女的信任了~\",\"100403\"],[\"finish\",\"完成任务\",\"12840\"]]]'),(1908102,'[[[\"npc\",\"勇者饶命啊！我们也只是混口饭吃而已啊！\",\"100801\"],[\"finish\",\"完成任务\",\"12850\"]]]'),(1908103,'[[[\"npc\",\"弥漫的黄沙越来越多，沙尘暴风应该快要来了，抓紧时间！\",\"100803\"],[\"finish\",\"完成任务\",\"12860\"]]]'),(1908104,'[[[\"npc\",\"勇者！那群佣兵不知道为什么突然袭击了村子，沙尘暴又快来了，这该如何是好！\",\"100804\"],[\"finish\",\"完成任务\",\"12870\"]]]'),(1908105,'[[[\"npc\",\"沙尘暴就要来了！勇者快和我们去地下洞窟避难吧！勇者你要去哪儿！！？\",\"100805\"],[\"finish\",\"完成任务\",\"12880\"]]]'),(1908106,'[[[\"npc\",\"勇者你一定要平安无事地回来啊！\",\"100807\"],[\"finish\",\"完成任务\",\"12890\"]]]'),(1908107,'[[[\"npc\",\"你这家伙，到底是什么人，为什么要阻挠我的计划！那些低等的贱民只要乖乖地成为祭品不就好了吗！\",\"100808\"],[\"finish\",\"完成任务\",\"12900\"]]]'),(1908108,'[[[\"npc\",\"我所做的一切都是为了复活梅杰德大人，完成他当初永生的夙愿！但是为什么当初只有我被拒绝进入死亡的轮回呢！？\",\"100808\"],[\"finish\",\"完成任务\",\"12910\"]]]'),(1908109,'[[[\"npc\",\"收集足够的东西就前来遗迹的祭坛这里来吧，这副人类躯体我不会伤害她的，只是代为传话而已！\",\"100812\"],[\"finish\",\"完成任务\",\"12920\"]]]'),(1908110,'[[[\"npc\",\"感觉有一瞬间我的灵魂被掏空了一般……\",\"100812\"],[\"finish\",\"完成任务\",\"12930\"]]]'),(1908111,'[[[\"npc\",\"刚才那场沙尘暴真是吓死我了，还以为要被活埋了！\",\"100809\"],[\"finish\",\"完成任务\",\"12940\"]]]'),(1908112,'[[[\"npc\",\"不好意思，我又犯迷糊了，我们刚才说到哪了？\",\"100810\"],[\"finish\",\"完成任务\",\"12950\"]]]'),(1908113,'[[[\"npc\",\"我刚才已经调查过的了，只要沿着路一直走，就是遗迹的祭坛了，不过我之前去没有发现什么端倪~\",\"100810\"],[\"finish\",\"完成任务\",\"12960\"]]]'),(1908114,'[[[\"npc\",\"根据可靠的情报，前面就是我们要找的祭坛了~\",\"100813\"],[\"finish\",\"完成任务\",\"12970\"]]]'),(1908115,'[[[\"npc\",\"如果你能活着回来的话，请务必告诉我一切关于那位神明的兴趣爱好以及身体数据，开战前记得帮我问下哈！\",\"100813\"],[\"finish\",\"完成任务\",\"12980\"]]]'),(1908116,'[[[\"npc\",\"想不到当初那个乳臭未干的小鬼，也能走到这一步了~\",\"100811\"],[\"finish\",\"完成任务\",\"13000\"]]]'),(1908117,'[[[\"npc\",\"希望我们都能绝处逢生吧~前面就是帝国军进行恶魔实验的地方了！\",\"100811\"],[\"finish\",\"完成任务\",\"13010\"]]]'),(1908118,'[[[\"npc\",\"你该不会是帝国军新造的仿生人吧？好逼真哦！\",\"100901\"],[\"finish\",\"完成任务\",\"13020\"]]]'),(1908119,'[[[\"npc\",\"抵抗军？没听说过，没什么事的话就快走吧，我还得研究我的闪亮杰作！\",\"100901\"],[\"finish\",\"完成任务\",\"13030\"]]]'),(1908120,'[[[\"npc\",\"闪亮和安娜……被囚禁……不开心……\",\"100902\"],[\"finish\",\"完成任务\",\"13040\"]]]'),(1908121,'[[[\"npc\",\"别大声嚷嚷！你这样会把那些铁罐头引过来的！\",\"100903\"],[\"finish\",\"完成任务\",\"13050\"]]]'),(1908122,'[[[\"npc\",\"蛮冲直撞不能解决所有的情况，你要学会隐藏自己的气息，然后观察情况！\",\"100903\"],[\"finish\",\"完成任务\",\"13060\"]]]'),(1908123,'[[[\"npc\",\"刚才那些都是我研制的机械犬，怎么样，酷炫不酷炫？\",\"100904\"],[\"finish\",\"完成任务\",\"13070\"]]]'),(1908124,'[[[\"npc\",\"看来我的机械犬还有很多不足之处，如果能够将犬类的灵活结合机械的杀伤力，哦，那该多么美妙~\",\"100904\"],[\"finish\",\"完成任务\",\"13080\"]]]'),(1908125,'[[[\"npc\",\"这几个破零件就想收买我了吗！？\",\"100905\"],[\"finish\",\"完成任务\",\"13100\"]]]'),(1908126,'[[[\"npc\",\"你这身烂装备就想对付帝国军那些装备精良的钢铁军团吗！？\",\"100905\"],[\"finish\",\"完成任务\",\"13110\"]]]'),(1908127,'[[[\"npc\",\"虽然很吃力，但是你已经做的很不错了！\",\"100906\"],[\"finish\",\"完成任务\",\"13120\"]]]'),(1908128,'[[[\"npc\",\"既然已经来到这一步了，接下来我们就要深入敌营了，这意味着会面临更加危险的敌人！\",\"100906\"],[\"finish\",\"完成任务\",\"13130\"]]]'),(1908129,'[[[\"npc\",\"恶魔！是恶魔！！啊！！不要过来啊！！！\",\"100907\"],[\"finish\",\"完成任务\",\"13140\"]]]'),(1908130,'[[[\"npc\",\"前往为禁区，请出示通行证和验证码！\",\"100908\"],[\"finish\",\"完成任务\",\"13150\"]]]'),(1908131,'[[[\"npc\",\"认证失败！检测到入侵者！认证失败！检测到入侵者！\",\"100908\"],[\"finish\",\"完成任务\",\"13160\"]]]'),(1908132,'[[[\"npc\",\"喵喵喵~大难不死必有后患！\",\"100909\"],[\"finish\",\"完成任务\",\"13170\"]]]'),(1908133,'[[[\"npc\",\"现在的状况有点儿糟糕，我们得赶紧离开才行，这个恶魔不是我们能对付的喵呜！\",\"100909\"],[\"finish\",\"完成任务\",\"13180\"]]]'),(1908134,'[[[\"npc\",\"三十六计走为上计！快把我抱起来，然后撒丫子跑呀喵呜！！\",\"100909\"],[\"finish\",\"完成任务\",\"13200\"]]]'),(1908135,'[[[\"npc\",\"通讯貌似被某些东西屏蔽了，现在无法联络到洛亚王城那边！\",\"100910\"],[\"finish\",\"完成任务\",\"13210\"]]]'),(1908136,'[[[\"npc\",\"嘿！这边儿~快跟我来！\",\"100911\"],[\"finish\",\"完成任务\",\"13220\"]]]'),(1908137,'[[[\"npc\",\"重新介绍一下吧~我是机械师安娜，是被帝国军软禁的技术宅！\",\"100911\"],[\"finish\",\"完成任务\",\"13230\"]]]'),(1908138,'[[[\"npc\",\"现在以你们的情况是没有办法突破质检员的把守的，我把这里的情报传输给你们，你们之后准备好相应的对策再来吧！\",\"100901\"],[\"finish\",\"完成任务\",\"13240\"]]]'),(1908139,'[[[\"npc\",\"这是一张设计图！得快点找到专业人士解读才行！\",\"100417\"],[\"finish\",\"完成任务\",\"13250\"]]]'),(1908140,'[[[\"npc\",\"怎么了，是有什么突发情况吗？这是？快！快拿给巴雷特看看！\",\"100405\"],[\"finish\",\"完成任务\",\"13260\"]]]'),(1908141,'[[[\"npc\",\"哼嗯~这个鬼画符一样的东西，说实话我还是能给看懂一点的，想当年我那个痴迷机械的挚友，可没给我少看他那些设计图~\",\"100406\"],[\"finish\",\"完成任务\",\"13270\"]]]'),(1908142,'[[[\"npc\",\"根据情报，那位大臣的挚友应该也被帝国军软禁在暗裔秘所了，所以只能再冒险一次，找到那位能解读这个设计图的人！\",\"100403\"],[\"finish\",\"完成任务\",\"13280\"]]]'),(1908143,'[[[\"npc\",\"哎？你怎么又带着这个回来了呀！？\",\"100901\"],[\"finish\",\"完成任务\",\"13290\"]]]'),(1908144,'[[[\"npc\",\"你们上次离开之后，帝国军已经加强了防范，还想像上次那样进出自如是不可能的了！\",\"100901\"],[\"finish\",\"完成任务\",\"13300\"]]]'),(1908145,'[[[\"npc\",\"有这些零件的话至少能够做把像样的武器了！\",\"100911\"],[\"finish\",\"完成任务\",\"13310\"]]]'),(1908146,'[[[\"npc\",\"你们动作小一点儿~不要暴露我的行踪！\",\"100912\"],[\"finish\",\"完成任务\",\"13320\"]]]'),(1908147,'[[[\"npc\",\"你们要找的人该不会就是我遇到的那个吧？说话怪怪的，而且对机械的东西十分痴迷的样子~\",\"100912\"],[\"finish\",\"完成任务\",\"13340\"]]]'),(1908148,'[[[\"npc\",\"这样吧~我留守这里，这里的地图数据我已经上传到闪亮杰作的存储器里了，他会为你们带路的！\",\"100911\"],[\"finish\",\"完成任务\",\"13350\"]]]'),(1908149,'[[[\"npc\",\"闪亮~会带你们找到~的！\",\"100902\"],[\"finish\",\"完成任务\",\"13360\"]]]'),(1908150,'[[[\"npc\",\"你的手法还要再精准一些，避免一些无谓的动作，这样可以节省体力！\",\"100903\"],[\"finish\",\"完成任务\",\"13370\"]]]'),(1908151,'[[[\"npc\",\"现在必须争分夺秒，这些铁罐子不久后就会恢复过来的，十分棘手！\",\"100903\"],[\"finish\",\"完成任务\",\"13380\"]]]'),(1908152,'[[[\"npc\",\"哟，几位年轻人，我们又见面了！看来这次我的机械犬还是不能通过测试啊！\",\"100904\"],[\"finish\",\"完成任务\",\"13390\"]]]'),(1908153,'[[[\"npc\",\"哼~我以为那家伙把我忘了，没想到是他让你们来找我的，好吧~我也是时候换个环境了！\",\"100904\"],[\"finish\",\"完成任务\",\"13400\"]]]'),(1908154,'[[[\"npc\",\"我就知道他坐不住的了，既然要走，就在这里大闹一场，留下点纪念吧！呜哈哈哈哈！\",\"100905\"],[\"finish\",\"完成任务\",\"13410\"]]]'),(1908155,'[[[\"npc\",\"让帝国军见识下我们抵抗军的厉害！\",\"100906\"],[\"finish\",\"完成任务\",\"13420\"]]]'),(1908156,'[[[\"npc\",\"这里就交给我，你快去突围！\",\"100906\"],[\"finish\",\"完成任务\",\"13430\"]]]'),(1908157,'[[[\"npc\",\"侦测到入侵者，侦测到入侵者！\",\"100908\"],[\"finish\",\"完成任务\",\"13440\"]]]'),(1908158,'[[[\"npc\",\"无法对入侵者造成可观伤害，即将启动自爆程序！\",\"100908\"],[\"finish\",\"完成任务\",\"13450\"]]]'),(1908159,'[[[\"npc\",\"喵呜~经过我的深思熟虑，我决定我们还是撒丫子跑吧！\",\"100909\"],[\"finish\",\"完成任务\",\"13460\"]]]'),(1908160,'[[[\"npc\",\"很好~战斗数据已经传输完毕，干得漂亮！\",\"100910\"],[\"finish\",\"完成任务\",\"13470\"]]]'),(1908161,'[[[\"npc\",\"闪亮觉得~你很~强！\",\"100913\"],[\"finish\",\"完成任务\",\"13480\"]]]'),(1908162,'[[[\"npc\",\"闪亮~得到安娜以外的人~认可~很开心！很开心！！\",\"100913\"],[\"finish\",\"完成任务\",\"13490\"]]]'),(1908163,'[[[\"npc\",\"一定要赶在帝国军之前，不然这个大陆就没救了~\",\"100914\"],[\"finish\",\"完成任务\",\"13510\"]]]'),(1908164,'[[[\"npc\",\"大家的希望就在我们身上了~尽力而为吧！\",\"100914\"],[\"finish\",\"完成任务\",\"13520\"]]]'),(1908165,'[[[\"npc\",\"你……你没事就好~我……我叫忒缇丝。\",\"101001\"],[\"finish\",\"完成任务\",\"13530\"]]]'),(1908167,'[[[\"npc\",\"暗裔的来袭总是猝不及防的，你要随时做好准备！既然身为抵抗军的一员，也要有相应的觉悟！\",\"100213\"],[\"finish\",\"完成任务\",\"10470\"]]]'),(1908168,'[[[\"npc\",\"年轻人俺看你三两下就搞定那堆破铜烂铁，有点儿能耐~你手上拿的是啥玩意儿，给俺敲敲？\",\"100215\"],[\"finish\",\"完成任务\",\"10490\"]]]'),(1908169,'[[[\"npc\",\"小跟班你终于来了！你一定是凑够了星晶石来救我的是吧！？一定是吧？是吧？\",\"100216\"],[\"trigger\",\"触发任务\",\"10500\"]]]'),(1908171,'[[[\"npc\",\"最近魔化宝藏蟹繁殖太快了，你得清理掉它们才能进去，搞定之后就去找喵队长报道吧！\",\"100201\"],[\"finish\",\"完成任务\",\"10270\"]]]'),(1908172,'[[[\"npc\",\"你虽然没有其他种族的强大力量，但是这份坚持和信念，着实让我倍感敬畏！\",\"100620\"],[\"finish\",\"完成任务\",\"12010\"]]]'),(1908173,'[[[\"npc\",\"纵使王朝倾覆，生死轮回也不会停止，凡人啊~你的道路能走多远呢？\",\"100820\"],[\"finish\",\"完成任务\",\"12990\"]]]'),(1908174,'[[[\"npc\",\"我未能誓守的诺言，就托付给你了~这样一来，也许我的灵魂也能得到救赎！\",\"100920\"],[\"finish\",\"完成任务\",\"13190\"]]]'),(1908175,'[[[\"npc\",\"我已在此沉睡了数千年，你是除了那个傻大个以外第一个敢喊我起床的人！原来你们这些小矮人并非都是些贪生怕死的蝼蚁~\",\"100714\"],[\"finish\",\"完成任务\",\"12360\"]]]'),(1908176,'[[[\"npc\",\"海岛看似平静，实质上已经受到暗裔的侵袭，务必小心~\"]]]'),(1908177,'[[[\"npc\",\"这座海岛形似月牙，因此得名朔月海岸。\"]]]'),(1908178,'[[[\"npc\",\"身为抵抗军的干部，就要随时保持警备状态……哈！谁在那！？呼~吓死我了。\"]]]'),(1908179,'[[[\"npc\",\"海鲜加上朗姆酒！唔哈哈哈哈哈！绝配！\"]]]'),(1908180,'[[[\"npc\",\"这里原本是气候宜人的热带海岛，自从那天……就变得不太安宁。\"]]]'),(1908181,'[[[\"npc\",\"一二三四~二二三四~呼~我的老腰……让我缓缓~\"]]]'),(1908182,'[[[\"npc\",\"今天的鱼很新鲜呐，有没有兴趣来钓一会儿鱼？\"]]]'),(1908183,'[[[\"npc\",\"冒险者这么快就要走了吗？陪我多玩儿一会吧！\"]]]'),(1908184,'[[[\"npc\",\"有什么疑问尽管来问我哦~喵呜！\"]]]'),(1908185,'[[[\"npc\",\"今天的风儿有点喧嚣呢！要抽一口吗？\"]]]'),(1908186,'[[[\"npc\",\"喂？听到请回复！喂喂？该死的，这通讯器又坏了！\"]]]'),(1908187,'[[[\"npc\",\"凡人只有仰望神明的权利，敬畏炽热的太阳吧！\"]]]'),(1908188,'[[[\"npc\",\"这把剑刃愿为您效劳~\"]]]'),(1908189,'[[[\"npc\",\"啊哒！天空一声巨响，老子闪亮登场！\"]]]'),(1908190,'[[[\"npc\",\"我的征途可是星辰大海，小鬼有兴趣跟我一起混吗？\"]]]'),(1908191,'[[[\"npc\",\"小跟班！小跟班！你答应我要带我去找我的好姐妹们的~\"]]]'),(1908192,'[[[\"npc\",\"吾等暗裔即是死亡，是瘟疫，是战乱，是饥荒……是你们的梦魇！\"]]]'),(1908193,'[[[\"npc\",\"劳伦兹司令说要勤俭节约，虽然我对海鲜不过敏，但是天天这么吃……唔呕！\"]]]'),(1908194,'[[[\"npc\",\"抵抗军的三大原则都给我记好了吗？下次我就要考考你这小子！\"]]]'),(1908195,'[[[\"npc\",\"不准直呼我的名字，不许背地里叫我技术宅，不能说我的作品是破铁罐子！\"]]]'),(1908196,'[[[\"npc\",\"抵抗军的成员来自五湖四海，个性各异，不过都是些心地好的年轻人。\"]]]'),(1908197,'[[[\"npc\",\"抵抗军的大部分武器都是我和另外一名工匠设计的，有空我给你露一手！\"]]]'),(1908198,'[[[\"npc\",\"哦哟~来了啊年轻人，我就知道你会加入我们的，来抽一口吗？\"]]]'),(1908199,'[[[\"npc\",\"抵抗军的第一大原则：时刻保持警惕，好好记住啦！\"]]]'),(1908200,'[[[\"npc\",\"你这小鬼就是话多！我现在没空理你，你先自己看着办吧~\"]]]'),(1908201,'[[[\"npc\",\"大家对我都很好，都肯陪我玩儿~\"]]]'),(1908202,'[[[\"npc\",\"抵抗军的三大原则？哼！那种东西太过于形式了，我自有原则！\"]]]'),(1908203,'[[[\"npc\",\"情报也是战斗中十分重要的一环，知己知彼百战百胜嘛！\"]]]'),(1908204,'[[[\"npc\",\"抵抗军的第二大原则是量力而行，像你这样的初学者，就不要贸然去惹那些强大的首领了！\"]]]'),(1908205,'[[[\"npc\",\"各种族必须摒弃前嫌，联合起来，否则这片大陆就没有希望了！\"]]]'),(1908206,'[[[\"npc\",\"吾等暗裔即是黑暗，是恐惧，是这片大陆的主宰！\"]]]'),(1908207,'[[[\"npc\",\"用最热的火，打最热的铁！\"]]]'),(1908208,'[[[\"npc\",\"小跟班！我们要快点找到其他星灵姐妹！\"]]]'),(1908209,'[[[\"npc\",\"喵呜~这地方又臭又恶心，我要崩溃啦喵呜！\"]]]'),(1908210,'[[[\"npc\",\"你问你要挖的是金矿还是银矿？\"]]]'),(1908211,'[[[\"npc\",\"这种陌生地方的情报，就放心交给我吧！\"]]]'),(1908212,'[[[\"npc\",\"热……热到变形~\"]]]'),(1908213,'[[[\"npc\",\"别看我外表是个法师老头，其实我也算是抵抗军的一员~\"]]]'),(1908214,'[[[\"npc\",\"从这个港口出发，就能到达洛亚王城！\"]]]'),(1908215,'[[[\"npc\",\"小白羊说的没错，只要集齐我们星灵姐妹的力量，一定能够战胜暗裔的！\"]]]'),(1908216,'[[[\"npc\",\"身为抵抗军，就要懂得抓住一切机会休息……\"]]]'),(1908217,'[[[\"npc\",\"这些怪物的血，希望不要沾到我的衣服才好~\"]]]'),(1908218,'[[[\"npc\",\"我看您好像病的不轻，要来买药吗？!!!∑(ﾟДﾟノ)ノ我好像又说错话了~\"]]]'),(1908219,'[[[\"npc\",\"吾即欲望，是罪恶，是你们这些低劣种族无法摆脱的恶魔！\"]]]'),(1908220,'[[[\"npc\",\"关于王城的任何事情，都可以随时来问我哦~喵呜~！\"]]]'),(1908221,'[[[\"npc\",\"祝你早日找到心上人，无论是男是女我都祝福你们哦~噗噗！\"]]]'),(1908222,'[[[\"npc\",\"帝国军接下来肯定有所动静，我们必须尽快找到同盟！\"]]]'),(1908223,'[[[\"npc\",\"很高兴为您导航，确认好地点的话就来告诉我吧~\"]]]'),(1908224,'[[[\"npc\",\"不必多礼，你代表抵抗军不远千里来到王城，无非是想谈正事。\"]]]'),(1908225,'[[[\"npc\",\"像您这样的有志之士，大可投靠帝国军，为何要与我等同盟？\"]]]'),(1908226,'[[[\"npc\",\"洛亚王城繁华大气，足够你在这里逛上几天几夜了~\"]]]'),(1908227,'[[[\"npc\",\"王城的商船贸易往来频繁，这可是洛卡斯特大陆最大的贸易集散中心呐！\"]]]'),(1908228,'[[[\"npc\",\"我是掌控五大元素之力的大法师，讨伐暗裔，我们志在必得！\"]]]'),(1908229,'[[[\"npc\",\"哟吼~今天的鱼很新鲜哦~来我这喝杯茶，钓会儿鱼吧！\"]]]'),(1908230,'[[[\"npc\",\"臭小鬼，你身上穿的是什么破烂玩意儿，真是太寒碜啦！\"]]]'),(1908231,'[[[\"npc\",\"石头剪刀布！哎嘿嘿嘿，怎样都是我赢的说！\"]]]'),(1908232,'[[[\"npc\",\"清仓大甩卖了！来瞧一瞧！来看一看！\"]]]'),(1908233,'[[[\"npc\",\"嘘！禁止大声喧哗~你吵着我看书啦！\"]]]'),(1908234,'[[[\"npc\",\"注意看我脸色行事！\"]]]'),(1908235,'[[[\"npc\",\"哎~你说我们抵抗军的据点，要是设在王城该有多好啊！\"]]]'),(1908236,'[[[\"npc\",\"在王城这里和梅斯菲尔姐姐交换情报~有伙伴就是好。\"]]]'),(1908237,'[[[\"npc\",\"热牛奶，沙丁鱼！喵呜~美哉美哉！\"]]]'),(1908238,'[[[\"npc\",\"别忘了每天来我这里领取日常任务哦！\"]]]'),(1908239,'[[[\"npc\",\"公会构建，你我有责，别忘了每天来我这里报到！\"]]]'),(1908240,'[[[\"npc\",\"自然孕育了我们，我们自然也要为了捍卫森林而战斗！\"]]]'),(1908241,'[[[\"npc\",\"没事儿~就算天顶穿了个大洞，我也给你缝起来。\"]]]'),(1908242,'[[[\"npc\",\"有光的地方就有暗影，而我就是猎杀恶魔的夜刃！\"]]]'),(1908243,'[[[\"npc\",\"我只接受这世上一切美的事物~像地精哥布林什么的简直是审美污染！\"]]]'),(1908244,'[[[\"npc\",\"生命在于运动！想要像我一样拥有如此健美的身材吗！？\"]]]'),(1908245,'[[[\"npc\",\"我是神殿的守护者！来者若想进入神殿，就先通过我的试炼！\"]]]'),(1908246,'[[[\"npc\",\"没有热牛奶我怎么抵抗这该死的寒冬！喵呜~~\"]]]'),(1908247,'[[[\"npc\",\"不想死的话离我远点儿，我前不久才被吵醒，现在起床气还没消！\"]]]'),(1908248,'[[[\"npc\",\"杀戮的尽头会是什么呢？我竟然会如此感触……\"]]]'),(1908249,'[[[\"npc\",\"永不放弃，全力以赴，就是我们抵抗军三大原则里的最后一条。\"]]]'),(1908250,'[[[\"npc\",\"生与死轮回不止，就算是我，也无法阻止王朝覆灭的……\"]]]'),(1908251,'[[[\"npc\",\"谁再说我的闪亮杰作是破铁罐子，我就敲爆他的狗头！哼！\"]]]'),(1908252,'[[[\"npc\",\"闪亮~闪亮~破铁罐子~破铁罐子~\"]]]'),(1908253,'[[[\"npc\",\"我们这次是潜入行动，不能太过招摇，记得看我脸色行事！\"]]]'),(1908254,'[[[\"npc\",\"我听说有个长着恶魔手臂的小伙子，有机会我一定要研究研究才行！\"]]]'),(1908255,'[[[\"npc\",\"臭小鬼，你身上穿的是什么破烂玩意儿，真是太寒碜啦！\"]]]'),(1908256,'[[[\"npc\",\"我从心底里现在就想一鼓作气捣毁帝国军的老巢，但是现阶段还是以情报搜集为主！\"]]]'),(1908257,'[[[\"npc\",\"额啊！不要过来！不要过来！\"]]]'),(1908258,'[[[\"npc\",\"请出示身份证明~请出示身份证明！\"]]]'),(1908259,'[[[\"npc\",\"这种不人道的研究……不能再让帝国军为所欲为了！\"]]]'),(1908260,'[[[\"npc\",\"辛苦了~情报我已经上传到闪亮杰作的存储器里了~\"]]]'),(1908261,'[[[\"npc\",\"你这家伙比我想象中还要靠谱~莱克斯和劳伦兹没有看错人。\"]]]'),(1908262,'[[[\"npc\",\"帝国军的设计图啊！太棒了！这里简直是技术宅的天堂~\"]]]'),(1908263,'[[[\"npc\",\"传输完毕~传输完毕~\"]]]'),(1908264,'[[[\"npc\",\"终于走到这一步了，暴风雨前的宁静，好好享受吧！\"]]]'),(1908265,'[[[\"npc\",\"最终我还是未能亲自履行诺言，只能托付给你了……\"]]]'),(1908266,'[[[\"npc\",\"那…那个…我的尾巴天生就是这样的！请不要盯着我看！\"]]]'),(1908267,'[[[\"npc\",\"海拉族的战士骁勇善战，绝不退缩！\"]]]'),(1908268,'[[[\"npc\",\"嘛嘛~看到各位平安，我就安心了呢~\"]]]'),(1908269,'[[[\"npc\",\"你看起来好像很好吃哎嘿嘿嘿~\"]]]'),(1908270,'[[[\"npc\",\"海拉族的勇士誓死保卫家园，绝不退缩！\"]]]'),(1908271,'[[[\"npc\",\"佩菈能睡到世界末日，到时候不要吵醒我~\"]]]'),(1908272,'[[[\"npc\",\"换个角度想，其实我们是在公费旅游呀~\"]]]'),(1908273,'[[[\"npc\",\"哦哦哦！这不就是人们常说的失落的亚特兰蒂斯吗？宝藏！这里一定有数不尽的宝藏！\"]]]'),(1908274,'[[[\"npc\",\"海神大人已经等候你们多时，请快点！\"]]]'),(1908275,'[[[\"npc\",\"能够一睹海底奇观，这是三生有幸！\"]]]'),(1908276,'[[[\"npc\",\"吾即大海的意志，你们前来是有何目的，向我一一道来！\"]]]'),(1908277,'[[[\"npc\",\"希望你们下次再来，我们……我们这算是朋友了吗？\"]]]'),(1908278,'[[[\"npc\",\"不当海盗的话，我的人生就没有意义了呀！\"]]]'),(1908279,'[[[\"npc\",\"是时候启程了，留给我们的时间不多了！\"]]]'),(1908280,'[[[\"npc\",\"抵抗军的路还很长，背负同伴的期望，前进吧！\"]]]'),(1908281,'[[[\"npc\",\"因为我是人鱼，所以我的尾巴……天生就是这样的~很奇怪……是吗？\",\"101001\"],[\"finish\",\"完成任务\",\"13540\"]]]'),(1908282,'[[[\"npc\",\"哪里来的人类？不许再往前走了！\",\"101002\"],[\"finish\",\"完成任务\",\"13550\"]]]'),(1908283,'[[[\"npc\",\"啊啦啊啦~你就是被选召的勇者~和我想象中的不太一样。\",\"101003\"],[\"finish\",\"完成任务\",\"13570\"]]]'),(1908284,'[[[\"npc\",\"只要能够集齐我们星灵姐妹，也就是黄道12宫星灵的力量，相信一定可以和暗裔抗衡的！\",\"101003\"],[\"finish\",\"完成任务\",\"13580\"]]]'),(1908285,'[[[\"npc\",\"虽然是深海，但是却与陆地上没有区别，简直就像是固有的特殊领域一样！\",\"101014\"],[\"finish\",\"完成任务\",\"13600\"]]]'),(1908286,'[[[\"npc\",\"既然已经到了这里，就必须想办法离开才行，否则帝国军会赶在我们前面的！\",\"101014\"],[\"finish\",\"完成任务\",\"13610\"]]]'),(1908287,'[[[\"npc\",\"臭小鬼，把你剁成肉酱应该很好吃吧？\",\"101004\"],[\"finish\",\"完成任务\",\"13620\"]]]'),(1908288,'[[[\"npc\",\"那些直男战士居然还拦不住你这个臭小鬼，看来还是要我们娘子兵出战了！\",\"101005\"],[\"finish\",\"完成任务\",\"13640\"]]]'),(1908289,'[[[\"npc\",\"哈啊啊啊~~嗯~~哎？你是来干嘛的？\",\"101006\"],[\"finish\",\"完成任务\",\"13660\"]]]'),(1908290,'[[[\"npc\",\"这里本来就不是你们这些人该来的地方，波塞冬等下要生气了，你们就没办法离开了！\",\"101006\"],[\"finish\",\"完成任务\",\"13670\"]]]'),(1908291,'[[[\"npc\",\"根据深海石板上的记载，亚特兰蒂斯是由海王统领着，不过具体的谈判还是要靠我们自己了~\",\"101007\"],[\"finish\",\"完成任务\",\"13690\"]]]'),(1908292,'[[[\"npc\",\"据说亚特兰蒂斯曾是大陆上繁荣的王朝，但是因为不知名的原因而沉没到了海底，成了现在这副模样。\",\"101007\"],[\"finish\",\"完成任务\",\"13700\"]]]'),(1908293,'[[[\"npc\",\"我们的征途可是星辰大海啊！呆在这里又让我想起当年老子可是称霸一方的大海盗呐！！\",\"101008\"],[\"finish\",\"完成任务\",\"13710\"]]]'),(1908294,'[[[\"npc\",\"我劝你还是放弃吧，即便你见到了我们的王，他也不会让你们全身而退的！\",\"101009\"],[\"finish\",\"完成任务\",\"13720\"]]]'),(1908295,'[[[\"npc\",\"虽然我不想打击你的自信，但是这里毕竟是人家的地盘，我们只能逆来顺受了。\",\"101010\"],[\"finish\",\"完成任务\",\"13730\"]]]'),(1908296,'[[[\"npc\",\"我原本就不打算亚特兰蒂斯暴露在世人眼前，才决定将我的王国沉没于此，如今你们知晓了秘密，就休想离开！\",\"101011\"],[\"finish\",\"完成任务\",\"13740\"]]]'),(1908297,'[[[\"npc\",\"在亚特兰蒂斯没有例外，除非……除非你能找到那两件物品~\",\"101011\"],[\"finish\",\"完成任务\",\"13750\"]]]'),(1908298,'[[[\"npc\",\"关于海神的传说？我一时半会儿没办法全部整理给你呢~你稍后再来找我吧~\",\"100414\"],[\"finish\",\"完成任务\",\"13760\"]]]'),(1908299,'[[[\"npc\",\"失落之海？会走路的鱼？我的老天~你都去了些什么地方，简直就是钓鱼天堂呐！\",\"100410\"],[\"finish\",\"完成任务\",\"13770\"]]]'),(1908300,'[[[\"npc\",\"海神原本是星界的守护神之一，他降临大陆建立了亚特兰蒂斯王朝，然而人类背叛了他，他舍弃了大陆，也舍弃了对人类的信任。\",\"100414\"],[\"finish\",\"完成任务\",\"13780\"]]]'),(1908301,'[[[\"npc\",\"其实父王他并没有恶意的，只是他不太信任人类而已……请不要怪他。\",\"101001\"],[\"finish\",\"完成任务\",\"13790\"]]]'),(1908302,'[[[\"npc\",\"人类，我很欣赏你的勇气，但是上次交手是我大意了，这次让你见识下我们海拉战士的武艺！\",\"101002\"],[\"finish\",\"完成任务\",\"13800\"]]]'),(1908303,'[[[\"npc\",\"哼，想不到你这个人类可以打败我两次，我承认现在的你的确比较强！\",\"101002\"],[\"finish\",\"完成任务\",\"13810\"]]]'),(1908304,'[[[\"npc\",\"波塞冬的确是遗失了两样东西在这海底当中，其中一样东西在危险的海沟，那里沉睡着海龙王！\",\"101003\"],[\"finish\",\"完成任务\",\"13820\"]]]'),(1908305,'[[[\"npc\",\"希望我们这次能够顺利得到海神的信任，要赶上帝国军的进程，就必须穿过这片海域~\",\"101014\"],[\"finish\",\"完成任务\",\"13830\"]]]'),(1908306,'[[[\"npc\",\"臭小鬼，上次打碎我两个牙还没跟你算账，还敢来？\",\"101004\"],[\"finish\",\"完成任务\",\"13840\"]]]'),(1908307,'[[[\"npc\",\"这些鲨鱼恶霸我很早就看不顺眼了，如果你不是人类的话，或许我还会感谢你做的一切~\",\"101005\"],[\"finish\",\"完成任务\",\"13850\"]]]'),(1908308,'[[[\"npc\",\"竟然两次败于你，看来你与一般的人类不一样，不仅武艺高强，连信念都如此坚定！\",\"101005\"],[\"finish\",\"完成任务\",\"13860\"]]]'),(1908309,'[[[\"npc\",\"哈啊~嗯？你没有被波塞冬赶出去吗？之前闯入的人类，都被他丢到海沟里喂鱼了~\",\"101006\"],[\"finish\",\"完成任务\",\"13870\"]]]'),(1908310,'[[[\"npc\",\"只能祝你好运了，波塞冬发火的话可不好办了，我可不想被打扰到睡懒觉~\",\"101006\"],[\"finish\",\"完成任务\",\"13880\"]]]'),(1908311,'[[[\"npc\",\"只要能够取得海神的信任，我们就能顺利穿过这片海域了~\",\"101007\"],[\"finish\",\"完成任务\",\"13890\"]]]'),(1908312,'[[[\"npc\",\"小鬼~要不要上我的船，一起当海盗麽咯？保你享尽荣华富贵喔！\",\"101008\"],[\"finish\",\"完成任务\",\"13900\"]]]'),(1908313,'[[[\"npc\",\"哎哎哎？先别急着走啊！我现在还差一个副船长，一个水手，最重要的是我还差一条船~唉？人呢！？\",\"101008\"],[\"finish\",\"完成任务\",\"13910\"]]]'),(1908314,'[[[\"npc\",\"我很欣赏你~人类，一而再再而三地出现在海神大殿之前，来吧！交出你的一切！\",\"101009\"],[\"finish\",\"完成任务\",\"13920\"]]]'),(1908315,'[[[\"npc\",\"看你的表情应该是有备而来的，你找到海神遗失的东西了吗？\",\"101010\"],[\"finish\",\"完成任务\",\"13940\"]]]'),(1908316,'[[[\"npc\",\"即便你做到这种地步，你所在乎的同类也还是会再自相残杀，就算如此你也要为之付出生命吗？人类并不值得去拯救！\",\"101011\"],[\"finish\",\"完成任务\",\"13950\"]]]'),(1908317,'[[[\"npc\",\"不是为了拯救人类，而是为了拯救这个星球？哈哈哈哈！好大的口气~你比光辉神还要不自量力吗？我喜欢这个答复！你可以离开了！\",\"101011\"],[\"finish\",\"完成任务\",\"13960\"]]]'),(1908318,'[[[\"npc\",\"太好了！我……我就知道你一定可以说服父王的！\",\"101012\"],[\"finish\",\"完成任务\",\"13970\"]]]'),(1908319,'[[[\"npc\",\"虽然认识……认识不是很久，但是……你也是……我的第二个朋友！请多指教！有空一定要多来亚特兰蒂斯！\",\"101012\"],[\"finish\",\"完成任务\",\"13980\"]]]'),(1908320,'[[[\"npc\",\"臭小鬼，老子等你很久啦！快上船！老子搞到一艘大船啦！哈哈哈哈！\",\"101013\"],[\"finish\",\"完成任务\",\"13990\"]]]'),(1908321,'[[[\"npc\",\"哎呀呀呀呀~看来我是到了一个不得了的地方，希望这里有稀有的宝石！\",\"100302\"],[\"finish\",\"完成任务\",\"10540\"]]]'),(1908322,'[[[\"npc\",\"糟蹋我盆栽的哥布林终于被制裁了！\",\"100503\"],[\"finish\",\"完成任务\",\"11790\"]]]'),(1908323,'[[[\"npc\",\"作为报酬，这个设计图我就送给你了！\",\"100511\"],[\"finish\",\"完成任务\",\"11810\"]]]'),(1908324,'[[[\"npc\",\"芙蕾回归的话，暗夜部族一定会顺应精灵女王的号召的！\",\"100514\"],[\"finish\",\"完成任务\",\"11840\"]]]'),(1908325,'[[[\"npc\",\"勇者饶命，我们再也不敢了！\",\"100801\"],[\"finish\",\"完成任务\",\"12630\"]]]'),(1908326,'[[[\"npc\",\"既然你已经解决掉那些怪物了，作为感谢，我会告诉你村庄的位置。\",\"100802\"],[\"finish\",\"完成任务\",\"12650\"]]]'),(1908327,'[[[\"npc\",\"你还站在这里干什么？快去找劳伦斯，我可没闲工夫管你！\",\"100011\"],[\"finish\",\"完成任务\",\"10190\"]]]'),(1908328,'[[[\"npc\",\"不得不承认，是现在的你比较强……俺火鸡骑士甘拜下风。\",\"100014\"],[\"finish\",\"完成任务\",\"10210\"]]]'),(1908330,'[[[\"npc\",\"想要进入精灵族的领地，就要进行相应的试炼，得到森林的认可！你准备好了吗？\",\"100414\"],[\"finish\",\"完成任务\",\"10890\"]]]'),(1908331,'[[[\"npc\",\"敲敲打打很辛苦的，你们这些冒险者，能不能爱惜一下自己的装备啊！\",\"100411\"],[\"finish\",\"完成任务\",\"10910\"]]]'),(1908332,'[[[\"npc\",\"你比之前更加游刃有余了，这片沼泽有个人也许可以帮你解决精灵部族那边的事端！\",\"100306\"],[\"finish\",\"完成任务\",\"11030\"]]]'),(1908333,'[[[\"npc\",\"好不容易来平息了冲突，不知道还会有什么困难险阻在等着我们。\",\"100603\"],[\"finish\",\"完成任务\",\"11870\"]]]'),(1908334,'[[[\"npc\",\"快准狠！才是刺客的精髓~\"]]]'),(1908335,'[[[\"npc\",\"获取情报是战斗中十分重要的一环！\"]]]'),(1908336,'[[[\"npc\",\"好好看~好好学！\"]]]'),(1908337,'[[[\"npc\",\"真是稀客了，我好久没看到人类了~\",\"100501\"],[\"finish\",\"完成任务\",\"11040\"]]]'),(1908338,'[[[\"npc\",\"为了熔岩，为了火山！\"]]]'),(1908339,'[[[\"npc\",\"这里好热啊，我又开始怀念大海了\"]]]'),(1908340,'[[[\"npc\",\"我我我...我可是很强的！\"]]]'),(1908341,'[[[\"npc\",\"轰！艺术就是爆炸！\"]]]'),(1908342,'[[[\"npc\",\"想不到与世隔绝的焚烬火山也遭到暗裔的侵蚀了\"]]]'),(1908343,'[[[\"npc\",\"轰轰轰！叫我领主大人！\"]]]'),(1908344,'[[[\"npc\",\"族人，我的族人，你们在哪里，你们怎么火山蒸发了！\"]]]'),(1908345,'[[[\"npc\",\"这里好热啊，我又开始怀念大海了\"]]]'),(1908346,'[[[\"npc\",\"这里好热啊，我又开始怀念大海了\"]]]'),(1908347,'[[[\"npc\",\"我我我...我可是很强的！\"]]]'),(1908348,'[[[\"npc\",\"轰！艺术就是爆炸！\"]]]'),(1908349,'[[[\"npc\",\"想不到与世隔绝的火山，也受到了暗裔的侵蚀\"]]]'),(1908350,'[[[\"npc\",\"族人，我的族人，你们在哪里，你们怎么火山蒸发了！\"]]]'),(1908351,'[[[\"npc\",\"吨吨吨，我喝完这桶就就去找船长\"]]]'),(1908352,'[[[\"npc\",\"挖挖挖，挖挖挖......没用的、没用的、没用的、有用的！\"]]]'),(1908353,'[[[\"npc\",\"我只是从虚无的火焰中诞生的圣火之灵\"]]]'),(1908354,'[[[\"npc\",\"用最热的火，打最热的铁！\"]]]'),(1908355,'[[[\"npc\",\"不许再说我技术宅，来到火山的我一点都不宅...呜呜呜，好想回家玩游戏\"]]]'),(1908356,'[[[\"npc\",\"承接龙神意志的我，想要看看整个世界\"]]]'),(1908357,'[[[\"npc\",\"虽然他们称呼我为大人，但是我不认为我更加高“人”一等\"]]]'),(1908358,'[[[\"npc\",\"为了熔岩，为了火山！\"]]]'),(1908359,'[[[\"npc\",\"吃了那么多天的海鲜后，老子终于冲出海底了！不过小子，我们得小心点，我隐隐感觉这里有点不简单......啊！那里有野果！想吃！\",\"0\"],[\"finish\",\"完成任务\",\"14000\"]]]'),(1908360,'[[[\"npc\",\"谢谢你啊小子，终于可以换一个口味......哇，这里的水果怎么都是火辣辣的！\",\"0\"],[\"finish\",\"完成任务\",\"14010\"]]]'),(1908361,'[[[\"npc\",\"小子，我想起来了，这里是传说中的焚烬火山！但是古书里明明写着龙神来到这里后，就把火山关闭了，再也没有人能找到这里了\",\"0\"],[\"finish\",\"完成任务\",\"14020\"]]]'),(1908362,'[[[\"npc\",\"哼！要不是我今天状态不佳，这些弱小的怪物怎么会对我造成伤害！不过......还是要谢谢你！\",\"0\"],[\"finish\",\"完成任务\",\"14030\"]]]'),(1908363,'[[[\"npc\",\"其实我也不知道为什么，自从龙神大人的屏障消失之后，火山里的怪物就变得异常的强大，就好像有一股力量改造了他们\",\"101202\"],[\"trigger\",\"触发任务\",\"14040\"]]]'),(1908364,'[[[\"npc\",\"暗裔的侵蚀？外面居然发生了这样可怕的事情。身为亚龙族的骄傲，我一定要把他们驱逐出去！\",\"101202\"],[\"finish\",\"完成任务\",\"14040\"]]]'),(1908365,'[[[\"npc\",\"小子，你干什么！什么！暗裔的侵蚀！这是什么！？轰！怪不得我觉得我们族人怪怪的，原来是被邪恶力量侵蚀了！\",\"0\"],[\"finish\",\"完成任务\",\"14050\"]]]'),(1908366,'[[[\"npc\",\"小子，你干什么！什么！暗裔的侵蚀！这是什么！？轰！怪不得我觉得我们族人怪怪的，原来是被邪恶力量侵蚀了！\",\"101203\"],[\"finish\",\"完成任务\",\"14050\"]]]'),(1908367,'[[[\"npc\",\"要想我们真正能安静下来，就带来几只熔火流蝶吧！我们最喜欢他它们玩了！\",\"101203\"],[\"trigger\",\"触发任务\",\"14060\"]]]'),(1908368,'[[[\"npc\",\"想不到你真的找到了它们，它们好久都没有来找我们玩了！\",\"101203\"],[\"finish\",\"完成任务\",\"14060\"]]]'),(1908369,'[[[\"npc\",\"轰！虽然我头脑比较简单，但是我知道这片火山不少秘密！哈哈哈，前面就是焚烬领主的地盘，你打败他，我就把秘密都告诉你！\",\"101203\"],[\"finish\",\"完成任务\",\"14070\"]]]'),(1908370,'[[[\"npc\",\"好久不见啊，我们的勇者~看来你成长了不少，但是你的实力还不足以打败前面的焚烬领主，再加把劲吧！\\t\",\"101204\"],[\"finish\",\"完成任务\",\"14080\"]]]'),(1908371,'[[[\"npc\",\"勇者，你成长的速度实在令人羡慕啊！你现在有足够的实力去挑战这片火山的领主了\",\"101204\"],[\"trigger\",\"触发任务\",\"14090\"]]]'),(1908372,'[[[\"npc\",\"小子，真有你的！轰轰轰，以后我就是新的火山领主了！好吧，领主大人我就把这个小秘密告诉你吧！\",\"101205\"],[\"trigger\",\"触发任务\",\"14100\"]]]'),(1908373,'[[[\"npc\",\"其实焚烬领主早就跟恶魔军团达成交易，换取了强大的力量！如果有人能重新继承龙神意志，就可以重新把屏障打开，再次与外界隔绝的火山也就再次安稳了！哈哈哈！\",\"101205\"],[\"finish\",\"完成任务\",\"14100\"]]]'),(1908374,'[[[\"npc\",\"有人类来了？你能从这里过来，证明你已经击败了焚烬领主了。嗯？你想知道火山的秘密，那先把你知道的告诉我\",\"101206\"],[\"trigger\",\"触发任务\",\"14110\"]]]'),(1908375,'[[[\"npc\",\"什么，就那颗头脑简单的蛋蛋也敢称自己为领主，我待会就告诉薇薇安，大姐头就会用勺子敲它的脑壳让他清醒一点\",\"101206\"],[\"finish\",\"完成任务\",\"14110\"]]]'),(1908376,'[[[\"npc\",\"嘿嘿，不急不急。最近我终于找到了我的同族，但是我一靠近他们时，他们就攻击我！哎，液体生物的脑子真不好使\",\"101206\"],[\"trigger\",\"触发任务\",\"14120\"]]]'),(1908377,'[[[\"npc\",\"嘿嘿，你回来了，我的族人也受到暗裔力量的侵蚀吗？\",\"101206\"],[\"finish\",\"完成任务\",\"14120\"]]]'),(1908378,'[[[\"npc\",\"什么，他们只是邪恶的史莱姆，我不信，他们只是把铁锅戴在了头上！我不听我不听！哼，我也没有秘密要告诉你！你自己去找吧\",\"101206\"],[\"finish\",\"完成任务\",\"14130\"]]]'),(1908379,'[[[\"npc\",\"（吨吨吨）哎，冒险者，你看到我们的船长了吗？\",\"101207\"],[\"trigger\",\"触发任务\",\"14140\"]]]'),(1908380,'[[[\"npc\",\"喔，原来船长在那里，那我也告诉你我的情报吧——前面有很多戴着刀刃的能量探测机，看来帝国的邪恶爪牙已经伸到这里了！\",\"101207\"],[\"finish\",\"完成任务\",\"14140\"]]]'),(1908382,'[[[\"npc\",\"噢，原来你是发现了邪恶帝国的能量探测机。哼！他们十台机器也没我一个迪克强！\",\"101208\"],[\"finish\",\"完成任务\",\"14160\"]]]'),(1908383,'[[[\"npc\",\"是的，我在这里找到了大量珍稀的高能量矿，帝国人肯定是想开采来制作武器！当你再强一点的时候，一定要制止他们\",\"101208\"],[\"finish\",\"完成任务\",\"14170\"]]]'),(1908384,'[[[\"npc\",\"专业矿工告诉你，前面有一堆强大的魔晶虫子。如果你能击败他们，并把收集起来的魔晶交给前面的莫里森，他会给你好多好东西喔\",\"101208\"],[\"finish\",\"完成任务\",\"14180\"]]]'),(1908385,'[[[\"npc\",\"你好，冒险者，我是秉承火焰意志的圣灵，焚烬火山是我的故乡。\",\"101209\"],[\"trigger\",\"触发任务\",\"14200\"]]]'),(1908386,'[[[\"npc\",\"现在的焚烬火山，即使没有暗裔涌入，也正在一步一步走入黑暗深渊。因为龙神留下的意志已被时间侵蚀，而被选定的亚龙人族因为太弱小无法继承龙神意志\",\"101209\"],[\"finish\",\"完成任务\",\"14200\"]]]'),(1908387,'[[[\"npc\",\"龙神的意志已被侵蚀，但我感受到承接光明的曙光也向我靠近。冒险者，我愿用我的意志与火焰帮助你们\",\"101209\"],[\"finish\",\"完成任务\",\"14210\"]]]'),(1908390,'[[[\"npc\",\"年轻的冒险者，你已经有足够的力量去寻找龙神的传承。\",\"101209\"],[\"finish\",\"完成任务\",\"14220\"]]]'),(1908391,'[[[\"npc\",\"龙神的传承需要激活火山中心的祭坛。你采集些火焰符文去找那边的铁匠，或许他能帮到你\",\"101209\"],[\"trigger\",\"触发任务\",\"14230\"]]]'),(1908392,'[[[\"npc\",\"嗨，当初穿着破烂玩意的穷酸小鬼居然也有能力来到这里，还想开启火山中央的龙神祭坛！但是你收集的魔晶还不够\",\"101210\"],[\"finish\",\"完成任务\",\"14240\"]]]'),(1908393,'[[[\"npc\",\"挺厉害嘛，这么短时间内就可以收集到那么多魔晶。看来龙神祭坛真的要为你一个外来人而开了\",\"101210\"],[\"finish\",\"完成任务\",\"14250\"]]]'),(1908394,'[[[\"npc\",\"开启龙神祭坛的材料够了，我现在就要开始打造了。对了小鬼，待会你把这个消息告诉圣灵大人吧\",\"101210\"],[\"finish\",\"完成任务\",\"14260\"]]]'),(1908395,'[[[\"npc\",\"既然铁匠已经在打造必要材料了，那么在开启龙神祭坛之前，我们还是要先把火山内残余的暗裔力量清理一下\",\"101209\"],[\"finish\",\"完成任务\",\"14270\"]]]'),(1908396,'[[[\"npc\",\"嗯，你拿着的这些零件让我看看——这些是帝国的负责通讯的机器人。现在帝国军团之间不能通讯了，正是各个击破的好时机！\",\"101211\"],[\"finish\",\"完成任务\",\"14290\"]]]'),(1908397,'[[[\"npc\",\"虽然可以各个击破，但是前面是帝国高级士兵，恐怕很难强行过去，我们再等等吧\",\"101211\"],[\"finish\",\"完成任务\",\"14300\"]]]'),(1908398,'[[[\"npc\",\"我刚才看到一个重伤的亚龙人往龙神祭坛方向冲了过去。勇者，你快过去帮帮他吧\",\"101211\"],[\"finish\",\"完成任务\",\"14310\"]]]'),(1908399,'[[[\"npc\",\"冒险者你来到这里真真真的太好啦！受重伤？噢，圣灵大人已经帮我治好了\",\"101212\"],[\"finish\",\"完成任务\",\"14330\"]]]'),(1908400,'[[[\"npc\",\"冒险者，我们终于要迎来焚烬火山的曙光了。现在就只要等待龙神祭坛中的怒火燃烧起来\",\"101213\"],[\"finish\",\"完成任务\",\"14340\"]]]'),(1908401,'[[[\"npc\",\"那个…我发现…我在冲过来的路上把最重要的祭坛之钥弄丢了…你能帮我找找吗，或许就在那些帝国士兵那里\",\"101012\"],[\"finish\",\"完成任务\",\"14350\"]]]'),(1908402,'[[[\"npc\",\"嗯...没有吗？我知道了！就在那里…啊，你问究竟是哪里？就...就是那里呀\",\"101212\"],[\"finish\",\"完成任务\",\"14360\"]]]'),(1908403,'[[[\"npc\",\"（松了一口气）呼，终于找回来啦，谢谢你！以后我不会那么冒失了，我会努力进步的！那个那个…圣灵大人找你来着！\",\"101212\"],[\"finish\",\"完成任务\",\"1\"]]]'),(1908404,'[[[\"npc\",\"龙神祭坛的火焰逐渐升起，我们要确保祭坛开启时没有东西能打扰我们.......包括你们的意志和实力\",\"101213\"],[\"finish\",\"完成任务\",\"14380\"]]]'),(1908405,'[[[\"npc\",\"祭坛快要开启了，但是那边突然出现了很多熔岩蜥蜴，他们肯定是来破坏祭坛的！\",\"101212\"],[\"trigger\",\"触发任务\",\"14390\"]]]'),(1908406,'[[[\"npc\",\"冒险者大人，我们并不是敌人！我们的族人来到这里只是献出我们的血液……还有生命！\",\"101214\"],[\"finish\",\"完成任务\",\"14390\"]]]'),(1908407,'[[[\"npc\",\"开启龙神祭坛的最后两样材料之一就是龙之血液。我们蜥蜴族虽是龙族的远亲，但血液中仍保留着微弱的龙之血液！\",\"101214\"],[\"trigger\",\"触发任务\",\"14400\"]]]'),(1908408,'[[[\"npc\",\"即使很微弱，但我们的血液汇聚起来，也终是可以达到开启的条件——至于另一个材料，是圣灵大人的圣灵之火…这也是需要大人，献出她的生命！\",\"101214\"],[\"finish\",\"完成任务\",\"14400\"]]]'),(1908409,'[[[\"npc\",\"蜥蜴族人有这样的觉悟，从虚无的火焰中诞生的我同样有这种觉悟。好了，通知薇薇安，一起开启祭坛吧\",\"101213\"],[\"trigger\",\"触发任务\",\"14410\"]]]'),(1908410,'[[[\"npc\",\"圣灵大人她.......呜呜呜，都怪我没有能力守护好这片火山！\",\"101212\"],[\"finish\",\"完成任务\",\"14410\"]]]'),(1908411,'[[[\"npc\",\"（圣灵之焰逐渐微弱）龙神意志觉醒了！我以为只有亚龙人才能继承龙神意志，想不到你以人类的意志也得到了龙神的认可！冒险者，请你替我守护好这片火山\",\"101213\"],[\"finish\",\"完成任务\",\"1\"]]]'),(1908412,'[[[\"npc\",\"我已经得到了龙神意志的传承，也可以重开火山的屏障了.......这也是火山各族最迫切的希望.......但我感觉这样是不对的\",\"101212\"],[\"finish\",\"完成任务\",\"14430\"]]]'),(1908413,'[[[\"npc\",\"（犹豫许久）如果再次闭锁的话，我们只会更加落后！我决定了，我们要把火山开放于世界面前！世界那么大，我们不能畏惧而封闭\",\"101212\"],[\"finish\",\"完成任务\",\"1\"]]]'),(1908414,'[[[\"npc\",\"冒险者，我们发现了一个通往神秘地域的传送门。如果你准备好的话，我们一起去冒险吧~\",\"101212\"],[\"finish\",\"完成任务\",\"14450\"]]]'),(1908415,'[[[\"npc\",\"我感觉到了神社的异样，大蛇的封印在松动！\"]]]'),(1908416,'[[[\"npc\",\"有病的，没病的，都来看下啊~吃了我的药丸，有病的药到病除，没病的清热解毒~\"]]]'),(1908417,'[[[\"npc\",\"远道而来的异乡人，我看你骨骼惊奇，有没有兴趣成为我的剑术继承人？\"]]]'),(1908418,'[[[\"npc\",\"好想和铃音姐姐玩哦~为什么她最近都不理我了……\"]]]'),(1908419,'[[[\"npc\",\"温泉的异样，一定是大蛇的污秽从封印中泄露而影响了。\"]]]'),(1908420,'[[[\"npc\",\"一二三四~二二三四~额……我的老腰儿啊！！\"]]]'),(1908421,'[[[\"npc\",\"哼，没有什么能够难倒博学多才的我！\"]]]'),(1908422,'[[[\"npc\",\"嘿嘿~嘿嘿~真好玩儿！\"]]]'),(1908423,'[[[\"npc\",\"总有一天我会成为钓鱼宗师的！\"]]]'),(1908424,'[[[\"npc\",\"一命二运三风水，快来祈福占卜许下心愿吧！\"]]]'),(1908425,'[[[\"npc\",\"铃音姐的一切，我都知道哦！\"]]]'),(1908426,'[[[\"npc\",\"身为忍者，犹豫就会败北！所谓暗杀，不过就是把目击者全部解决掉就好了！\"]]]'),(1908427,'[[[\"npc\",\"我这套独创的打狗剑法，至今无人能敌，怎么样？想学吗！\"]]]'),(1908428,'[[[\"npc\",\"我感受到了一股邪恶的力量在苏醒，不可掉以轻心！\"]]]'),(1908429,'[[[\"npc\",\"看来终究是要和大蛇有一场恶战了！\"]]]'),(1908430,'[[[\"npc\",\"没有什么传说事迹是我不知晓的！\"]]]'),(1908431,'[[[\"npc\",\"我们已经定位到帝国军将要着陆的地点了，我们赶紧出发吧！\"]]]'),(1908432,'[[[\"npc\",\"啊啦~是拯救世界的外乡人呢~梦境的预言终于要变为现实了！\",\"101101\"],[\"finish\",\"完成任务\",\"14460\"]]]'),(1908433,'[[[\"npc\",\"这里是是该隐神社，不过我这里可没有消除幻觉的药，况且你所看到的也不是幻觉~\",\"101102\"],[\"finish\",\"完成任务\",\"14470\"]]]'),(1908434,'[[[\"npc\",\"这位奇装异服的武士哟，我看你三两下就把那妖精解决了，敢问尊姓大名~\",\"101103\"],[\"finish\",\"完成任务\",\"14480\"]]]'),(1908435,'[[[\"npc\",\"我游历四方，和各种各样的剑士切磋剑术，未尝一败！\",\"101103\"],[\"finish\",\"完成任务\",\"14490\"]]]'),(1908436,'[[[\"npc\",\"是陌生的面孔~你们到底是谁？\",\"101104\"],[\"finish\",\"完成任务\",\"14500\"]]]'),(1908437,'[[[\"npc\",\"最近铃音姐好像很担心大蛇封印松动的事情，一直留守在神社不和我玩儿~\",\"101104\"],[\"finish\",\"完成任务\",\"14510\"]]]'),(1908438,'[[[\"npc\",\"最近大蛇的封印有松动的迹象，附近的妖精也更加活跃了。\",\"101105\"],[\"finish\",\"完成任务\",\"14520\"]]]'),(1908439,'[[[\"npc\",\"咳咳咳，最近不知怎么的？温泉的水源受到了影响，还无故多了许多泡霸王温泉的忍者……\",\"101106\"],[\"finish\",\"完成任务\",\"14530\"]]]'),(1908440,'[[[\"npc\",\"感谢你的出手帮助，虽然温泉水源的污染还没搞清楚情况，至少这些叛忍不会再来了！\",\"101106\"],[\"finish\",\"完成任务\",\"14540\"]]]'),(1908441,'[[[\"npc\",\"没有什么能够难倒我，温泉水源污染，一定是源头有妖怪出现了！\",\"101107\"],[\"finish\",\"完成任务\",\"14550\"]]]'),(1908442,'[[[\"npc\",\"不过你一个人去也未免会有危险，这样吧~我介绍一个壮汉跟你一起去调查~\",\"101107\"],[\"finish\",\"完成任务\",\"14560\"]]]'),(1908443,'[[[\"npc\",\"哎嘿嘿~你就帕吉说的要找我帮忙的人麽！那我们快出发吧！\",\"101108\"],[\"finish\",\"完成任务\",\"14570\"]]]'),(1908444,'[[[\"npc\",\"不单单是温泉的水质受到了影响，我的鱼塘也没法钓鱼了……\",\"101109\"],[\"finish\",\"完成任务\",\"14580\"]]]'),(1908445,'[[[\"npc\",\"怀念平日里闲暇的钓鱼时光啊~快乐而惬意！\",\"101109\"],[\"finish\",\"完成任务\",\"14590\"]]]'),(1908446,'[[[\"npc\",\"如果大蛇的封印真的破解掉，将会给这个世界带来可怕的灾厄！\",\"101105\"],[\"finish\",\"完成任务\",\"14600\"]]]'),(1908447,'[[[\"npc\",\"拿着这些逆鳞，也许在危急时刻能够帮上忙！\",\"101105\"],[\"finish\",\"完成任务\",\"14610\"]]]'),(1908448,'[[[\"npc\",\"你们快走吧！这里我来应付。鳞片有强烈的妖气，妖怪会盯上你的！\",\"101104\"],[\"finish\",\"完成任务\",\"14620\"]]]'),(1908449,'[[[\"npc\",\"别看我这样，我可是这里数一数二的强大妖怪呢~\",\"101104\"],[\"finish\",\"完成任务\",\"14630\"]]]'),(1908450,'[[[\"npc\",\"想不到事态发展到了这个程度，你们赶紧到神社去吧！\",\"101103\"],[\"finish\",\"完成任务\",\"14640\"]]]'),(1908451,'[[[\"npc\",\"神社就在东边，快去吧！不然就来不及了！\",\"101103\"],[\"finish\",\"完成任务\",\"14650\"]]]'),(1908452,'[[[\"npc\",\"甲贺一族的忍者都已经叛变，成为了大蛇的傀儡了！\",\"101112\"],[\"finish\",\"完成任务\",\"14670\"]]]'),(1908453,'[[[\"npc\",\"我已经是被抛弃的领袖，什么甲贺一族的复兴都不复存在了……\",\"101112\"],[\"finish\",\"完成任务\",\"14680\"]]]'),(1908454,'[[[\"npc\",\"白虎丸本来很温顺的，最近不知道为什么就变得如此暴戾。\",\"101111\"],[\"finish\",\"完成任务\",\"14690\"]]]'),(1908455,'[[[\"npc\",\"神社附近的妖气加重了，恐怕是大蛇的封印又更加松动了~\",\"101111\"],[\"finish\",\"完成任务\",\"14700\"]]]'),(1908456,'[[[\"npc\",\"铃音姐姐现在一定很焦急，我们要去帮帮她！\",\"101111\"],[\"finish\",\"完成任务\",\"14710\"]]]'),(1908457,'[[[\"npc\",\"最近妖怪活跃，村民们都十分惊恐，前来祈福的人也比往常多了不少，希望这次的危机能够安然化解吧~\",\"101110\"],[\"finish\",\"完成任务\",\"14720\"]]]'),(1908458,'[[[\"npc\",\"我果然还是不太放心，结果来了之后才发现事态已经如此严重了！\",\"101113\"],[\"finish\",\"完成任务\",\"14740\"]]]'),(1908459,'[[[\"npc\",\"果然我到了这个年纪，游历了四方，也不想再和人比拼剑法了，反倒要开始考虑继承人的问题了！你可不能轻易地狗带啊！\",\"101113\"],[\"finish\",\"完成任务\",\"14750\"]]]'),(1908460,'[[[\"npc\",\"我觉得，你就是那个合适的继承人，这本打狗剑法，你替我保管吧！\",\"101113\"],[\"finish\",\"完成任务\",\"14770\"]]]'),(1908461,'[[[\"npc\",\"嗯……我可不是来旅游观光的，或许我能帮上忙！\",\"101114\"],[\"finish\",\"完成任务\",\"14780\"]]]'),(1908462,'[[[\"npc\",\"按照这个态势发展下去的话，大蛇的封印迟早会被破解，难免会有一战的，做好心理准备吧！\",\"101114\"],[\"finish\",\"完成任务\",\"14790\"]]]'),(1908463,'[[[\"npc\",\"我已经不能再维持封印了，再过不久八岐大蛇就会复活，快带着那几颗辉星石离开这里吧！不能让他染指！\",\"101115\"],[\"finish\",\"完成任务\",\"14800\"]]]'),(1908464,'[[[\"npc\",\"慢着，如果我这次有不测的话，请帮我照顾好诸天童子，拜托了！\",\"101115\"],[\"finish\",\"完成任务\",\"14820\"]]]'),(1908465,'[[[\"npc\",\"我们还要争取一些时间让这里的村民平安撤退才行！\",\"101114\"],[\"finish\",\"完成任务\",\"14830\"]]]'),(1908466,'[[[\"npc\",\"疏散村民的事情就交给我吧！妖怪就交给你来对付了！\",\"101113\"],[\"finish\",\"完成任务\",\"14840\"]]]'),(1908467,'[[[\"npc\",\"多亏你的帮助，附近的村民都安全撤离了~\",\"101113\"],[\"finish\",\"完成任务\",\"14860\"]]]'),(1908468,'[[[\"npc\",\"我衷心希望你们能够迈过这次难关！\",\"101110\"],[\"finish\",\"完成任务\",\"14870\"]]]'),(1908469,'[[[\"npc\",\"铃音姐肯定想着一个人承担，但我不会让她如愿的，既然如此，只有打败八岐大蛇这个方法了！\",\"101111\"],[\"finish\",\"完成任务\",\"14880\"]]]'),(1908470,'[[[\"npc\",\"赌徒和叛徒，两者我都十分讨厌呢！\",\"101116\"],[\"finish\",\"完成任务\",\"14900\"]]]'),(1908471,'[[[\"npc\",\"让我们来清理这些八岐大蛇的傀儡吧！\",\"101116\"],[\"finish\",\"完成任务\",\"14910\"]]]'),(1908472,'[[[\"npc\",\"这将是一场恶战，祝您武运昌隆！\",\"101117\"],[\"finish\",\"完成任务\",\"14930\"]]]'),(1908473,'[[[\"npc\",\"太好了，这次的作战十分成功，不仅消除了八岐大蛇的灾厄，辉星石也完好无损！\",\"101117\"],[\"finish\",\"完成任务\",\"14950\"]]]'),(1908474,'[[[\"npc\",\"我已经没有什么可以教你的了，你自行去发掘魂珠的强大潜力吧~\",\"100306\"],[\"finish\",\"完成任务\",\"10690\"]]]'),(1908475,'[[[\"npc\",\"我只比大郎多了一点~\"]]]'),(1908476,'[[[\"npc\",\"冰冷的机械，其实也是有情感的\"]]]'),(1908477,'[[[\"npc\",\"请尽快前行，如今魔物入侵，这片区域已经很不安全了！\",\"100217\"],[\"finish\",\"完成任务\",\"10350\"]]]');
/*!40000 ALTER TABLE `base_talk` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_task`
--

DROP TABLE IF EXISTS `base_task`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_task` (
  `id` int(11) NOT NULL COMMENT '任务id',
  `name` varchar(30) NOT NULL COMMENT '任务名@lang@',
  `desc` text NOT NULL COMMENT '描述@lang@',
  `tips` text NOT NULL COMMENT '任务提示@lang@',
  `type` int(2) unsigned NOT NULL DEFAULT '0' COMMENT '任务类型',
  `chapter` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '主线章节',
  `kind` int(2) unsigned NOT NULL DEFAULT '0' COMMENT '任务种类',
  `level` int(10) unsigned NOT NULL DEFAULT '1' COMMENT '等级限制',
  `level_max` int(11) NOT NULL COMMENT '最大等级',
  `repeat` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否允许重复做',
  `realm` int(1) NOT NULL DEFAULT '0' COMMENT '阵营',
  `career` tinyint(1) NOT NULL DEFAULT '0' COMMENT '职业限制',
  `turn` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '转生次数',
  `prev` int(11) NOT NULL DEFAULT '0' COMMENT '上一个必须完成的任务id',
  `next` int(11) NOT NULL DEFAULT '0' COMMENT '下个关联任务id，即这个任务完成后触发任务',
  `start_item` text NOT NULL COMMENT '触发是获得物品',
  `end_item` text NOT NULL COMMENT '完成回收物品',
  `start_npc` text NOT NULL COMMENT '开始npc',
  `end_npc` int(11) NOT NULL DEFAULT '0' COMMENT '结束npc',
  `start_talk` int(11) NOT NULL DEFAULT '0' COMMENT '开始npc对话',
  `end_talk` int(11) NOT NULL DEFAULT '0' COMMENT '结束npc对话',
  `unfinished_talk` int(11) NOT NULL DEFAULT '0' COMMENT '未完成对话',
  `condition` text NOT NULL COMMENT '任务触发条件',
  `content` text NOT NULL COMMENT '任务内容',
  `state` int(1) unsigned NOT NULL DEFAULT '0' COMMENT '任务的终结状态',
  `award_list` text NOT NULL,
  `next_cue` int(11) NOT NULL DEFAULT '0' COMMENT '是否提示下一任务',
  `trigger_pathfind` int(1) NOT NULL COMMENT '是否需要寻路触发',
  `finish_pathfind` int(1) NOT NULL COMMENT '是否需要寻路完成',
  `special_goods_list` text NOT NULL COMMENT '固定物品',
  `npc_show` text NOT NULL COMMENT '默认：[] 提示：[{npcId,是否显示(0,1),场景id,x,y},...]',
  `follow_list` text NOT NULL COMMENT '跟随NPC',
  `need_effect` int(1) NOT NULL DEFAULT '0' COMMENT '是否需要特效',
  `dun_id` int(11) NOT NULL DEFAULT '0' COMMENT '副本id',
  `sep` int(11) NOT NULL DEFAULT '0' COMMENT '同类排序',
  `double_cost` int(11) NOT NULL COMMENT '双倍奖励消耗',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='任务数据';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_task`
--

LOCK TABLES `base_task` WRITE;
/*!40000 ALTER TABLE `base_task` DISABLE KEYS */;
INSERT INTO `base_task` VALUES (1,'蠢蠢欲动','完成试炼，是你的职责所在','击败丛林狼',3,0,1,150,0,0,0,0,0,0,2,'null','[]','100602',100602,30000,30001,0,'[]','[[[\"kill\",\"1\",\"10060001\",\"30\",\"1006\",\"0\",\"0\",\"1\"]]]',0,'[{3,36030001,50000}]',1,1,1,'[]','[]','[]',0,0,0,0),(2,'天大秘密','接下来的试炼更为严峻，不能掉以轻心','',3,0,0,150,0,0,0,0,0,1,3,'null','[]','100603',100604,30002,30003,0,'[]','[]',0,'[{3,36030001,60000}]',1,1,1,'[]','[]','[]',0,0,0,0),(3,'飞贼骨干','不负众望地去完成试炼吧！','击败神殿守卫',3,0,1,150,0,0,0,0,0,2,4,'null','[]','100605',100605,30004,30005,0,'[]','[[[\"kill\",\"1\",\"10060004\",\"30\",\"1006\",\"0\",\"0\",\"1\"]]]',0,'[{3,36030001,70000}]',1,1,1,'[]','[]','[]',0,0,0,0),(4,'收集之路','给予你最终试炼的人就在前方~','',3,0,2,150,0,0,0,0,0,3,5,'null','[{38110001,50}]','100608',100610,30006,30007,0,'[]','[[[\"item\",\"3\",\"38110001\",\"50\",\"1006\",\"11493\",\"7595\",\"1\"]]]',0,'[{3,36030001,85000}]',1,1,1,'[]','[]','[]',0,0,0,0),(5,'首领之战','能否通过试炼，就在此一举了！','完成转职试炼',3,0,6,150,0,0,0,0,0,4,0,'null','[]','100610',100610,30008,30009,0,'[]','[[[\"fin_dungeon\",\"11\",\"2301\",\"1\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{3,36030001,100000}]',0,1,1,'[{1,1,19010001,1},{2,1,19010011,1},{4,2,19010031,1}]','[]','[]',1,2301,0,0),(6,'新的谜团','一个新的试炼又出现在了我们面前。','',3,0,1,220,0,0,0,0,1,0,7,'null','[]','100704',100704,30010,30011,0,'[]','[[[\"kill\",\"1\",\"10070003\",\"30\",\"1007\",\"0\",\"0\",\"1\"]]]',0,'[{3,36030001,110000}]',1,1,1,'[]','[]','[]',0,0,0,0),(7,'得到认可','争取获得其他人的认可！','',3,0,0,220,0,0,0,0,1,6,8,'null','[]','0',100705,0,30013,0,'[]','[]',0,'[{3,36030001,120000}]',1,1,1,'[]','[]','[]',0,0,0,0),(8,'再次试炼','击败守卫，展现自己的实力吧~','',3,0,1,220,0,0,0,0,1,7,9,'null','[]','100704',100705,30014,30015,0,'[]','[[[\"kill\",\"1\",\"10070004\",\"30\",\"1007\",\"0\",\"0\",\"1\"]]]',0,'[{3,36030001,130000}]',1,1,1,'[]','[]','[]',0,0,0,0),(9,'收集之路','在得到认可之前，先决定是否接受试炼的资格吧~','',3,0,2,220,0,0,0,0,1,8,10,'null','[{38110002,100}]','100706',100707,30016,30017,0,'[]','[[[\"item\",\"3\",\"38110002\",\"100\",\"1007\",\"9957\",\"7876\",\"1\"]]]',0,'[{3,36030001,140000}]',1,1,1,'[]','[]','[]',0,0,0,0),(10,'首领之战','历经磨难，你终于获得了大家的认可~','完成转职试炼',3,0,6,220,0,0,0,0,1,9,0,'null','[]','0',100708,0,30019,0,'[]','[[[\"fin_dungeon\",\"11\",\"2302\",\"1\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{3,36030001,150000}]',0,1,1,'[{1,1,19010003,1},{2,1,19010013,1},{4,2,19010033,1}]','[]','[]',1,2302,0,0),(11,'晋升之路','初来乍到，一切仿佛要重新开始！','击败机械犬',3,0,1,280,0,0,0,0,2,0,12,'null','[]','100802',100803,30020,30021,0,'[]','[[[\"kill\",\"1\",\"10080002\",\"30\",\"1008\",\"0\",\"0\",\"1\"]]]',0,'[{3,36030001,160000}]',1,1,1,'[]','[]','[]',0,0,0,0),(12,'转职秘密','虽然毫无头绪，但还是要满怀希望地前进！','',3,0,0,280,0,0,0,0,2,11,13,'null','[]','100803',100804,30022,30023,0,'[]','[]',0,'[{3,36030001,170000}]',1,1,1,'[]','[]','[]',0,0,0,0),(13,'出其不意','在得到赏金猎人的提示后，你貌似知道了真正的试炼。','击败恶魔幼体',3,0,1,280,0,0,0,0,2,12,14,'null','[]','100804',100805,30024,30025,0,'[]','[[[\"kill\",\"1\",\"10080003\",\"30\",\"1008\",\"0\",\"0\",\"1\"]]]',0,'[{3,36030001,180000}]',1,1,1,'[]','[]','[]',0,0,0,0),(14,'收集之路','跟随线索，一步步接近试炼的所在地！','',3,0,2,280,0,0,0,0,2,13,15,'null','[{38110003,150}]','100807',100808,30026,30027,0,'[]','[[[\"item\",\"3\",\"38110003\",\"150\",\"1008\",\"10341\",\"8581\",\"1\"]]]',0,'[{3,36030001,200000}]',1,1,1,'[]','[]','[]',0,0,0,0),(15,'首领之战','就差这么一步，击败前面这个强者才能完成最终的试炼。','完成转职试炼',3,0,6,280,0,0,0,0,2,14,0,'null','[]','100809',100810,30028,30029,0,'[]','[[[\"fin_dungeon\",\"11\",\"2303\",\"1\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{3,36030001,250000}]',0,1,1,'[{1,1,19010005,1},{2,1,19010015,1},{4,2,19010035,1}]','[]','[]',1,2303,0,0),(16,'四转觉醒','星界点亮15个星格，玩家达到370级可完成传奇四转。击败230级以上野外怪物有概率掉落<color=\'#71e831\'>源生精魂</color>，也可通过商城或者市场直接购买。','点亮15个星魂',3,0,0,355,0,0,0,0,3,0,0,'null','[]','0',100409,0,30031,0,'[]','[[[\"awakening4\",\"18\",\"0\",\"15\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{3,36030001,300000}]',0,1,1,'[{1,1,19010007,1},{2,1,19010017,1},{4,2,19010037,1}]','[]','[]',0,0,0,0),(17,'五转觉醒','<color=\'#71e831\'>点亮星魂，完成5转</color>','点亮27个星魂',3,0,0,500,0,0,0,0,4,16,0,'null','[]','0',100403,0,1907813,0,'[]','[[[\"awakening5\",\"25\",\"0\",\"27\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{3,36030001,500000}]',0,1,1,'[]','[]','[]',0,0,0,0),(101,'不畏艰险Ⅰ','通关<color=\'#71e831\'>67</color>级主线副本首领','通关67级主线副本首领',4,0,0,999,0,0,0,0,0,10006600,0,'null','[]','0',10079010,0,1035535,0,'[]','[[[\"time_task\",\"22\",\"10007901\",\"0\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[]',0,0,0,'[{1,1,1001010331,1},{1,2,1001020331,1}]','[]','[]',0,0,0,0),(102,'不畏艰险Ⅱ','通关<color=\'#71e831\'>100</color>级主线副本首领','通关100级主线副本首领',4,0,0,999,0,0,0,0,0,10008700,0,'null','[]','0',10079010,0,1035536,0,'[]','[[[\"time_task\",\"22\",\"10012200\",\"0\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[]',0,0,0,'[{1,1,1001010431,1},{1,2,1001020431,1}]','[]','[]',0,0,0,0),(103,'不畏艰险Ⅲ','击杀<color=\'#71e831\'>100</color>级主线首领<color=#62e876>愤怒狼灵</color>','击杀108级主线首领愤怒狼灵',4,0,0,999,0,0,0,0,0,10008500,0,'null','[]','0',10079010,0,1035537,0,'[]','[[[\"time_task\",\"22\",\"10012700\",\"0\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[]',0,0,0,'[{1,1,1001010420,1},{1,2,1001020420,1}]','[]','[]',0,0,0,0),(104,'不畏艰险Ⅳ','击杀<color=\'#71e831\'>110</color>级主线首领<color=#62e877>雪狼沃夫</color>','击杀118主线首领雪狼沃夫',4,0,0,999,0,0,0,0,0,10014200,0,'null','[]','0',10079010,0,1035538,0,'[]','[[[\"time_task\",\"22\",\"10015200\",\"0\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[]',0,0,0,'[{1,1,1003010420,1},{1,2,1003010420,1}]','[]','[]',0,0,0,0),(105,'不畏艰险Ⅴ','击杀<color=\'#71e831\'>130</color>级主线首领','击杀138级主线首领',4,0,0,999,0,0,0,0,0,10019200,0,'null','[]','0',10079010,0,1035539,0,'[]','[[[\"time_task\",\"22\",\"10021600\",\"0\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[]',0,0,0,'[{1,1,1005010420,1},{1,2,1005010420,1}]','[]','[]',0,0,0,0),(106,'不畏艰险Ⅵ','击杀<color=\'#71e831\'>150</color>级主线首领','击杀158级主线首领',4,0,0,999,0,0,0,0,0,10024200,0,'null','[]','0',10079010,0,1035540,0,'[]','[[[\"time_task\",\"22\",\"10025600\",\"0\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[]',0,0,0,'[{1,1,1001010520,1},{1,2,1001020520,1}]','[]','[]',0,0,0,0),(10010,'朔月海岸','近来暗裔恶魔频繁出现，连这小岛也愈发不安宁……','向村民了解情况',1,1,0,1,0,0,0,0,0,0,10020,'null','[]','0',100001,0,1907814,0,'[]','[]',0,'[{5,36060001,810},{3,36030001,2000}]',0,1,1,'[]','[]','[]',1,0,0,0),(10020,'找回武器','取回遗落在沙滩上的武器。','找回你的武器',1,1,3,2,0,0,0,0,0,10010,10030,'null','[]','0',0,0,0,0,'[]','[[[\"collect\",\"4\",\"10000020\",\"1\",\"1000\",\"22102\",\"4246\",\"1\"]]]',0,'[{5,36060001,1000},{3,36030001,2000}]',0,1,1,'[{1,1,1001010100,1},{2,1,1001020100,1},{3,2,1001030100,1},{4,2,1001040100,1}]','[]','[]',1,10000020,0,0),(10030,'习得技能','虽然初次来到这座海岛，还是异样的气息还是引起了你的关注。','消灭藏宝蟹',1,1,1,3,0,0,0,0,0,10020,10040,'null','[]','0',100002,0,1907816,0,'[]','[[[\"kill\",\"1\",\"10000001\",\"3\",\"1000\",\"19519\",\"4305\",\"1\"]]]',0,'[{5,36060001,1500},{3,36030001,2100}]',0,1,1,'[]','[]','[]',1,0,0,0),(10040,'飞来横蟹','貌似已经有其他人开始调查这座岛的怪异之处了。','与抵抗军干部对话',1,1,0,4,0,0,0,0,0,10030,10050,'null','[]','0',100003,0,1907817,0,'[]','[]',0,'[{5,36060001,2500},{3,36030001,2100}]',0,1,1,'[{1,1,1002010100,1},{2,1,1002020100,1},{3,2,1002030100,1},{4,2,1002040100,1}]','[]','[]',1,0,0,0),(10050,'冒险启程','一名自称是抵抗军干部的人向你介绍了自己的来意。','与抵抗军交谈',1,1,0,5,0,0,0,0,0,10040,10060,'null','[]','0',100003,0,1907819,0,'[]','[]',0,'[{5,36060001,4000},{3,36030001,2100}]',0,1,1,'[]','[]','[]',1,0,0,0),(10060,'魔化之蟹','岛上的部分生物貌似受到了某些影响，连体态和习性都变得更具有攻击性。','击败魔化蟹',1,1,1,6,0,0,0,0,0,10050,10070,'null','[]','0',100004,0,1907820,0,'[]','[[[\"kill\",\"1\",\"10000002\",\"4\",\"1000\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,6000},{3,36030001,2200}]',0,1,1,'[{0,0,38130001,5}]','[]','[]',1,0,0,0),(10070,'不祥预兆','不……不好了！火鸡骑士部落带着一堆怪物袭击村子了！','与惊慌的村民对话',1,1,0,7,0,0,0,0,0,10060,10080,'null','[]','0',100005,0,1907821,0,'[]','[]',0,'[{5,36060001,8500},{3,36030001,2200}]',0,1,1,'[]','[]','[]',1,0,0,0),(10080,'村庄遭袭','海岛的村庄正遭受着邪恶魔物的侵袭！','与小女孩对话',1,1,0,8,0,0,0,0,0,10070,10090,'null','[]','0',100005,0,1907822,0,'[]','[]',0,'[{5,36060001,11500},{3,36030001,2200}]',0,1,1,'[]','[]','[]',1,0,0,0),(10090,'守护者狸','狸太郎是朔月海岸的守护者，和他聊一聊吧。','与狸太郎对话',1,1,0,9,0,0,0,0,0,10080,10100,'null','[]','0',201044,0,1907823,0,'[]','[]',0,'[{5,36060001,15000},{3,36030001,2300}]',0,1,1,'[]','[]','[]',1,0,0,0),(10100,'趁虚而入','火鸡骑士就变得比以前好斗，经常和强盗一起袭击村子，希望你能驱赶他们！','与村长对话',1,1,0,10,0,0,0,0,0,10090,10110,'null','[]','0',100006,0,1907825,0,'[]','[]',0,'[{5,36060001,19000},{3,36030001,2300}]',0,1,1,'[{1,1,1010010100,1},{2,1,1010020100,1},{3,2,1010030100,1},{4,2,1010040100,1}]','[]','[]',1,0,0,0),(10110,'火鸡骑士','火鸡骑士是喜欢搞事的家伙，总是成群结队偷盗牲畜，不过他们的坐骑火鸡，做成菜肴还是很美味的喵呜！','击败火鸡',1,1,1,11,0,0,0,0,0,10100,10120,'null','[]','0',100009,0,1907826,0,'[]','[[[\"kill\",\"1\",\"10000004\",\"5\",\"1000\",\"6310\",\"12100\",\"1\"]]]',0,'[{5,36060001,23500},{3,36030001,2300}]',0,1,1,'[{0,0,38130001,5}]','[]','[]',1,0,0,0),(10120,'火鸡鲜肉','为了找寻山顶上的疑似星晶石的线索，你得先设法弄到一些火鸡肉。','与村民对话',1,1,0,12,0,0,0,0,0,10110,10130,'null','[]','0',100009,0,1907827,0,'[]','[]',0,'[{5,36060001,28500},{3,36030001,2400}]',0,1,1,'[]','[]','[]',1,0,0,0),(10130,'强盗入侵','辛苦收集的火鸡肉，眼看就会被这些强盗抢走。','击败强盗',1,1,1,13,0,0,0,0,0,10120,10140,'null','[]','0',100015,0,1907828,0,'[]','[[[\"kill\",\"1\",\"10000005\",\"6\",\"1000\",\"12406\",\"11998\",\"1\"]]]',0,'[{5,36060001,34000},{3,36030001,2400}]',0,1,1,'[]','[]','[]',1,0,0,0),(10140,'飞来横祸','村民口中所说的流星也许就是星晶石的线索。','与村民对话',1,1,0,14,0,0,0,0,0,10130,10150,'null','[]','0',100008,0,1907829,0,'[]','[]',0,'[{5,36060001,40000},{3,36030001,2400}]',0,1,1,'[{1,1,1006010100,1},{2,1,1006020100,1},{3,2,1006030100,1},{4,2,1006040100,1}]','[]','[]',1,0,0,0),(10150,'暗裔来袭','伟大的暗裔必将崛起，届时这片大陆将灰飞烟灭，尽管挣扎吧！凡人！','通关副本',1,1,6,15,0,0,0,0,0,10140,10160,'null','[]','0',100017,0,1908009,0,'[]','[[[\"fin_dungeon\",\"11\",\"10000\",\"1\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{5,36060001,46500},{3,36030001,2500}]',0,1,1,'[{1,1,1004010100,1},{2,1,1004020100,1},{3,2,1004030100,1},{4,2,1004040100,1}]','[]','[]',1,10000,0,0),(10160,'惊慌失措','一位山顶抽烟的大叔看起来十分潇洒，而且还给我们指路。','与村民交谈',1,1,0,16,0,0,0,0,0,10150,10170,'null','[]','0',100010,0,1907830,0,'[]','[]',0,'[{5,36060001,53500},{3,36030001,2500}]',0,1,1,'[]','[]','[]',1,0,0,0),(10170,'察觉异样','这岛上的异常情况其实我们早就已经察觉了，所以劳伦斯才派遣我们介入调查。','和大叔对话',1,1,0,17,0,0,0,0,0,10160,10180,'null','[]','0',100010,0,1907831,0,'[]','[]',0,'[{5,36060001,61000},{3,36030001,2500}]',0,1,1,'[{0,0,1003000100,1}]','[]','[]',1,0,0,0),(10180,'拦路怪物','年轻人，我看你是中暑了！没见过会说话的猫吗！？','与喵队长对话',1,1,1,18,0,0,0,0,0,10170,10190,'null','[]','0',100011,0,1908010,0,'[]','[[[\"kill\",\"1\",\"10000006\",\"6\",\"1000\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,69000},{3,36030001,2600}]',0,1,1,'[]','[]','[]',1,0,0,0),(10190,'暴躁老猫','暴躁的喵队长，似乎对新人不太友好~','与喵队长对话',1,1,0,19,0,0,0,0,0,10180,10200,'null','[]','0',100011,0,1908327,0,'[]','[]',0,'[{5,36060001,77500},{3,36030001,2600}]',0,1,1,'[]','[]','[]',1,0,0,0),(10200,'闪耀石头','啊哒哒哒哒！你就是我们火鸡骑士一族的宿敌！你竟敢把我心爱的小鸡崽……纳命来！！','采集星晶石',1,1,3,20,0,0,0,0,0,10190,10210,'null','[]','0',100014,0,1907833,0,'[]','[[[\"collect\",\"4\",\"10000021\",\"1\",\"1000\",\"8129\",\"19945\",\"1\"]]]',0,'[{5,36060001,86500},{3,36030001,2600}]',0,1,1,'[]','[]','[]',1,10000021,0,0),(10210,'海岛横行','不得不承认，是现在的你比较强……俺火鸡骑士甘拜下风。','与火鸡骑士对话',1,1,0,21,0,0,0,0,0,10200,10220,'null','[]','0',100014,0,1908328,0,'[]','[]',0,'[{5,36060001,96000},{3,36030001,2700}]',0,1,1,'[{1,1,1007010100,1},{2,1,1007020100,1},{3,2,1007030100,1},{4,2,1007040100,1}]','[]','[]',1,0,0,0),(10220,'面对降神','与降神的正面对峙，你发自内心的誓言能否得到他的认可？','与降神交谈',1,1,0,22,0,0,0,0,0,10210,10230,'null','[]','0',100012,0,1907835,0,'[]','[]',0,'[{5,36060001,106000},{3,36030001,2700}]',0,1,1,'[]','[]','[]',1,0,0,0),(10230,'降神试炼','描述','任务提示',1,1,6,23,0,0,0,0,0,10220,10240,'null','[]','0',0,0,0,0,'[]','[[[\"fin_dungeon\",\"11\",\"5405\",\"1\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{5,36060001,116500},{3,36030001,2700}]',0,1,1,'[{1,1,1008010120,1},{2,1,1008020120,1},{3,2,1008030120,1},{4,2,1008040120,1}]','[]','[]',1,5405,0,0),(10240,'试炼结束','虽然与降神的实力还有很大差距，但是至少博得了他的认可！','与降神对话',1,1,0,24,0,0,0,0,0,10230,10250,'null','[]','0',100012,0,1907836,0,'[]','[]',0,'[{5,36060001,127500},{3,36030001,2800}]',0,1,1,'[]','[]','[]',1,0,0,0),(10250,'前往军营','在抵抗军干部的劝诱之下，你决定前往抵抗军组织的大本营。','与抵抗军交谈',1,2,0,25,0,0,0,0,0,10240,10260,'null','[]','0',100013,0,1907837,0,'[]','[]',0,'[{5,36060001,139000},{3,36030001,2800}]',0,1,1,'[{1,1,1010010210,1},{2,1,1010020210,1},{3,2,1010030210,1},{4,2,1010040210,1}]','[]','[]',1,0,0,0),(10260,'营地港口','顺利乘船来到了抵抗军营地的港口。','与抵抗军对话',1,2,0,26,0,0,0,0,0,10250,10270,'null','[]','0',100201,0,1907838,0,'[]','[]',0,'[{5,36060001,151000},{3,36030001,2800}]',0,1,1,'[]','[]','[]',1,0,0,0),(10270,'难缠家伙','魔化藏宝蟹挡住了军营的入口，必须清理掉才能顺利进去。','与莱克斯对话',1,2,0,27,0,0,0,0,0,10260,10280,'null','[]','0',100201,0,1908171,0,'[]','[]',0,'[{5,36060001,163500},{3,36030001,2900}]',0,1,1,'[]','[]','[]',1,0,0,0),(10280,'抵抗军营','终于来到了抵抗军营，准备进去一探究竟。','消灭魔化蟹',1,2,1,28,0,0,0,0,0,10270,10290,'null','[]','0',100202,0,1907839,0,'[]','[[[\"kill\",\"1\",\"10020001\",\"10\",\"1002\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,176500},{3,36030001,2900}]',0,1,1,'[{1,1,1004010210,1},{2,1,1004020210,1},{3,2,1004030210,1},{4,2,1004040210,1}]','[]','[]',1,0,0,0),(10290,'人如其名','安娜的暴脾气让你有点不太自然。','与通讯员对话',1,2,0,29,0,0,0,0,0,10280,10300,'null','[]','0',100203,0,1907840,0,'[]','[]',0,'[{5,36060001,190000},{3,36030001,2900}]',0,1,1,'[]','[]','[]',1,0,0,0),(10300,'专属坐骑','领取你的专属坐骑！','领取专属坐骑！',1,2,3,30,0,0,0,0,0,10290,10310,'null','[]','0',0,0,0,0,'[]','[[[\"collect\",\"4\",\"10020023\",\"1\",\"1002\",\"14909\",\"9210\",\"1\"]]]',0,'[{5,36060001,204000},{3,36030001,3000}]',0,1,1,'[{1,1,1007010210,1},{2,1,1007020210,1},{3,2,1007030210,1},{4,2,1007040210,1}]','[]','[]',1,10020023,0,0),(10310,'打扫城墙','抵抗军的城墙虽然坚固，但是几乎每天都有许多暗裔魔物不停侵袭这里。','消灭魔平民',1,2,1,31,0,0,0,0,0,10300,10320,'null','[]','0',100205,0,1907842,0,'[]','[[[\"kill\",\"1\",\"10020002\",\"10\",\"1002\",\"16555\",\"13727\",\"1\"]]]',0,'[{5,36060001,218500},{3,36030001,3000}]',0,1,1,'[{0,0,38130001,5}]','[]','[]',1,0,0,0),(10320,'形势险峻','干部讲述了抵抗军据点的由来。','与抵抗军交谈',1,2,0,32,0,0,0,0,0,10310,10330,'null','[]','0',100206,0,1907843,0,'[]','[]',0,'[{5,36060001,233500},{3,36030001,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(10330,'暗裔突袭','人不可貌相~你这不是挺强的嘛！','击败蜘蛛女皇',1,2,1,33,0,0,0,0,0,10320,10340,'null','[]','0',100207,0,1907844,0,'[]','[[[\"kill\",\"1\",\"100020001\",\"1\",\"1002\",\"11753\",\"13084\",\"1\"]]]',0,'[{5,36060001,249000},{3,36030001,3100}]',0,1,1,'[{1,1,1001010210,1},{2,1,1001020210,1},{3,2,1001030210,1},{4,2,1001040210,1}]','[]','[]',1,0,0,0),(10340,'艰辛过去','与抵抗军司令的交谈，让你回想起艰辛的过去。','与劳伦兹对话',1,2,0,34,0,0,0,0,0,10330,10350,'null','[]','0',100207,0,1907845,0,'[]','[]',0,'[{5,36060001,265000},{3,36030001,3100}]',0,1,1,'[]','[]','[]',1,0,0,0),(10350,'尽快前行','魔物入侵，这片区域已经很不安全了！','寻找机械狂人',1,2,0,35,0,0,0,0,0,10340,10360,'null','[]','0',100217,0,1908477,0,'[]','[]',0,'[{5,36060001,281500},{3,36030001,3100}]',0,1,1,'[]','[]','[]',1,0,0,0),(10360,'随同前往','喵队长似乎不太情愿。','与喵队长交谈',1,2,0,36,0,0,0,0,0,10350,10370,'null','[]','0',100208,0,1907847,0,'[]','[]',0,'[{5,36060001,298500},{3,36030001,3200}]',0,1,1,'[{0,0,16020001,3}]','[]','[]',1,0,0,0),(10370,'准备干粮','前往王城路途遥远，先准备些干粮吧！','采集木材',1,2,3,37,0,0,0,0,0,10360,10380,'null','[]','0',0,0,0,0,'[]','[[[\"collect\",\"4\",\"10020020\",\"2\",\"1002\",\"10406\",\"8439\",\"1\"]]]',0,'[{5,36060001,316000},{3,36030001,3200}]',0,1,1,'[]','[]','[]',1,10020020,0,0),(10380,'传授技艺','喵队长对你刮目相看，决定传授你几招秘技。','与喵队长对话',1,2,0,38,0,0,0,0,0,10370,10390,'null','[]','0',100208,0,1907848,0,'[]','[]',0,'[{5,36060001,334000},{3,36030001,3200}]',0,1,1,'[]','[]','[]',1,0,0,0),(10390,'外出游玩','这附近的一些虫子，经常会溜进军营偷取东西。','消灭楔形虫',1,2,1,39,0,0,0,0,0,10380,10400,'null','[]','100209',0,1907849,0,0,'[]','[[[\"kill\",\"1\",\"10020004\",\"15\",\"1002\",\"6702\",\"5407\",\"1\"]]]',0,'[{5,36060001,352500},{3,36030001,3300}]',0,1,1,'[]','[]','[]',1,0,0,0),(10400,'新人考察','科哈特接上头的命令想要考验一下你这位新人的综合素质。','与新兵对话',1,2,0,40,0,0,0,0,0,10390,10410,'null','[]','0',100210,0,1907850,0,'[]','[]',0,'[{5,36060001,371500},{3,36030001,3300}]',0,1,1,'[]','[]','[]',1,0,0,0),(10410,'主线副本Ⅰ','看这个小家伙怪可怜的，快带走，我不擅长照顾这种东西！','通关副本',1,2,6,41,0,0,0,0,0,10400,10420,'null','[]','0',100210,0,1907851,0,'[]','[[[\"fin_dungeon\",\"11\",\"1002\",\"1\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{5,36060001,391000},{3,36030001,3300}]',0,1,1,'[{0,0,1011000005,1}]','[]','[]',1,1002,0,0),(10420,'情报分析','情报员有重要的情报分享。','与通讯员对话',1,2,0,42,0,0,0,0,0,10410,10430,'null','[]','0',100211,0,1907852,0,'[]','[]',0,'[{5,36060001,411000},{3,36030001,3400}]',0,1,1,'[]','[]','[]',1,0,0,0),(10430,'守护便利','星灵和守护能够为冒险者提供诸多便利，好好利用吧！','消灭魔化兵',1,2,1,43,0,0,0,0,0,10420,10440,'null','[]','0',100211,0,1907853,0,'[]','[[[\"kill\",\"1\",\"10020005\",\"15\",\"1002\",\"3303\",\"10703\",\"1\"]]]',0,'[{5,36060001,431500},{3,36030001,3400}]',0,1,1,'[]','[]','[]',1,0,0,0),(10440,'晶石下落','情报员有新的情报分享。','与通讯员对话',1,2,0,44,0,0,0,0,0,10430,10450,'null','[]','0',100211,0,1907854,0,'[]','[]',0,'[{5,36060001,452500},{3,36030001,3400}]',0,1,1,'[]','[]','[]',1,0,0,0),(10450,'紫色武器','紫色武器的提升很大，看来前往迷雾沼泽的底气更加足了。','与抵抗军对话',1,2,1,45,0,0,0,0,0,10440,10460,'null','[]','0',100212,0,1907855,0,'[]','[[[\"kill\",\"1\",\"10020006\",\"15\",\"1002\",\"4099\",\"14501\",\"1\"]]]',0,'[{5,36060001,474000},{3,36030001,3500}]',0,1,1,'[]','[]','[]',1,0,0,0),(10460,'深入腹地','为了寻找星晶石，需要更深入暗裔的腹地，这也意味着更大的风险。','与抵抗军对话',1,2,0,46,0,0,0,0,0,10450,10470,'null','[]','0',100212,0,1907856,0,'[]','[]',0,'[{5,36060001,496000},{3,36030001,3500}]',0,1,1,'[{1,1,1002010210,1},{2,1,1002020210,1},{3,2,1002030210,1},{4,2,1002040210,1}]','[]','[]',1,0,0,0),(10470,'猝不及防','暗裔的来袭总是猝不及防的，你要随时做好准备！','与抵抗军干部对话',1,2,0,47,0,0,0,0,0,10460,10480,'null','[]','0',100213,0,1908167,0,'[]','[]',0,'[{5,36060001,518500},{3,36030001,3500}]',0,1,1,'[]','[]','[]',1,0,0,0),(10480,'希望碎片','希望的碎片，星灵伙伴与你的回忆~','采集星晶石',1,2,3,48,0,0,0,0,0,10470,10490,'null','[]','0',0,0,0,0,'[]','[[[\"collect\",\"4\",\"10020021\",\"2\",\"1002\",\"10000\",\"15200\",\"1\"]]]',0,'[{5,36060001,541500},{3,36030001,3600}]',0,1,1,'[{0,0,18020001,5}]','[]','[]',1,10020021,0,0),(10490,'遭遇伏击','年轻人俺看你三两下就搞定那堆破铜烂铁，有点儿能耐~你手上拿的是啥玩意儿，给俺敲敲？','击败魔化机械',1,2,1,49,0,0,0,0,0,10480,10500,'null','[]','0',100215,0,1908168,0,'[]','[[[\"kill\",\"1\",\"10020007\",\"10\",\"1002\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,565000},{3,36030001,3600}]',0,1,1,'[]','[]','[]',1,0,0,0),(10500,'星灵唤醒','小跟班你终于来了！你一定是凑够了星晶石来救我的是吧！？一定是吧？是吧？','通关<color=\'#71e831\'>星灵唤醒副本</color>',1,2,6,50,0,0,0,0,0,10490,10510,'null','[]','100216',0,1908169,0,0,'[]','[[[\"fin_dungeon\",\"11\",\"10030\",\"1\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{5,36060001,589000},{3,36030001,3600}]',0,1,1,'[{1,1,1010010320,1},{2,1,1010020320,1},{3,2,1010030320,1},{4,2,1010040320,1}]','[]','[]',1,10030,0,0),(10510,'探索迷雾','快跟上，要去找我的好姐妹们呢！','与萌羊座对话',1,3,0,51,0,0,0,0,0,10500,10520,'null','[]','0',100216,0,1907858,0,'[]','[]',0,'[{5,36060001,613500},{3,36030001,3700}]',0,1,1,'[]','[]','[]',1,0,0,0),(10520,'贵族之心','VIP限时体验。','与喵队长对话',1,3,0,52,0,0,0,0,0,10510,10530,'null','[]','0',100301,0,1907859,0,'[]','[]',0,'[{5,36060001,638500},{3,36030001,3700}]',0,1,1,'[{0,0,36040004,1}]','[]','[]',1,0,0,0),(10530,'迷雾骷髅','年轻人，可别逞强哦~有时候量力而行也是战斗的智慧喵~','与喵队长对话',1,3,0,53,0,0,0,0,0,10520,10540,'null','[]','0',100301,0,1907860,0,'[]','[]',0,'[{5,36060001,664000},{3,36030001,3700}]',0,1,1,'[]','[]','[]',1,0,0,0),(10540,'沼泽巨狼','一群饥饿的暗影狼张着血盆大口向你袭来。','消灭食人花',1,3,1,54,0,0,0,0,0,10530,10550,'null','[]','0',100302,0,1908321,0,'[]','[[[\"kill\",\"1\",\"10030001\",\"1\",\"1003\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,690000},{3,36030001,3800}]',0,1,1,'[{1,1,1007010320,1},{2,1,1007020320,1},{3,2,1007030320,1},{4,2,1007040320,1}]','[]','[]',1,0,0,0),(10550,'福利冲级','我对于这里的情况还没有挖掘清楚，不过我还是建议你尽快提升自己的等级！','与鼯鼠迪克对话',1,3,0,56,0,0,0,0,0,10540,10560,'null','[]','0',100302,0,1907861,0,'[]','[]',0,'[{5,36060001,743500},{3,36030001,3800}]',0,1,1,'[{1,1,1006010320,1},{2,1,1006020320,1},{3,2,1006030320,1},{4,2,1006040320,1}]','[]','[]',1,0,0,0),(10560,'骷髅士兵','迷雾沼泽不仅地形复杂，而且怪物众多，消灭怪物继续前进吧！','消灭骷髅兵',1,3,1,57,0,0,0,0,0,10550,10570,'null','[]','0',100303,0,1907862,0,'[]','[[[\"kill\",\"1\",\"10030002\",\"20\",\"1003\",\"10913\",\"5487\",\"1\"]]]',0,'[{5,36060001,771000},{3,36030001,3800}]',0,1,1,'[]','[]','[]',1,0,0,0),(10570,'装备收集','除了打怪升级增强实力，收集高阶装备也能迅速提升实力的说！','与通讯员对话',1,3,0,58,0,0,0,0,0,10560,10580,'null','[]','0',100303,0,1907863,0,'[]','[]',0,'[{5,36060001,799000},{3,36030001,3900}]',0,1,1,'[{1,1,1001010320,1},{2,1,1001020320,1},{3,2,1001030320,1},{4,2,1001040320,1}]','[]','[]',1,0,0,0),(10580,'认可实力','史莱姆的一番言论头头是道，你只能半信半疑地点头赞同。','消灭史莱姆',1,3,1,59,0,0,0,0,0,10570,10590,'null','[]','0',100304,0,1907864,0,'[]','[[[\"kill\",\"1\",\"10030003\",\"20\",\"1003\",\"9567\",\"6197\",\"1\"]]]',0,'[{5,36060001,827500},{3,36030001,3900}]',0,1,1,'[]','[]','[]',1,0,0,0),(10590,'沼泽魔物','散发着臭味的粘稠胶状魔物，有点不是很想砍下去！','与史莱姆对话',1,3,0,60,0,0,0,0,0,10580,10600,'null','[]','0',100304,0,1907878,0,'[]','[]',0,'[{5,36060001,856500},{3,36030001,3900}]',0,1,1,'[]','[]','[]',1,0,0,0),(10600,'加入公会','现在这里收集些材料','采集材料',1,3,3,61,0,0,0,0,0,10590,10610,'null','[]','0',0,0,0,0,'[]','[[[\"collect\",\"4\",\"10030020\",\"1\",\"1003\",\"12361\",\"7230\",\"1\"]]]',0,'[{5,36060001,886000},{3,36030001,4000}]',0,1,1,'[]','[]','[]',1,10030020,0,0),(10610,'煮咒恶灵','煮咒恶灵的诅咒会导致他没有柴火的话就会死去。','',1,3,0,62,0,0,0,0,0,10600,10620,'null','[]','0',100305,0,1907866,0,'[]','[]',0,'[{5,36060001,916000},{3,36030001,4000}]',0,1,1,'[]','[]','[]',1,0,0,0),(10620,'活体诅咒','咕噜噜~活过来了，柴火用完的话我就会死去，这是我受到的诅咒~','与煮咒恶灵对话',1,3,0,63,0,0,0,0,0,10610,10630,'null','[]','0',100305,0,1907867,0,'[]','[]',0,'[{5,36060001,946500},{3,36030001,4000}]',0,1,1,'[]','[]','[]',1,0,0,0),(10630,'主线副本Ⅱ','恶灵作为信使，希望你能去寻找大法师。','通关副本',1,3,6,64,0,0,0,0,0,10620,10640,'null','[]','0',100305,0,1908007,0,'[]','[[[\"fin_dungeon\",\"11\",\"1003\",\"1\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{5,36060001,977500},{3,36030001,4100}]',0,1,1,'[]','[]','[]',1,2101,0,0),(10640,'拔刀相助','多谢冒险者的出手相救，我是来自吉煌的猫又，四处旅行的药贩子喵哈哈~','与赏金猎人对话',1,3,0,65,0,0,0,0,0,10630,10650,'null','[]','0',100311,0,1907869,0,'[]','[]',0,'[{5,36060001,1009000},{3,36030001,4100}]',0,1,1,'[{1,1,1002010320,1},{2,1,1002020320,1},{3,2,1002030320,1},{4,2,1002040320,1}]','[]','[]',1,0,0,0),(10650,'打听下落','向猫又药师打听一下法师的下落。','',1,3,1,66,0,0,0,0,0,10640,10660,'null','[]','0',100311,0,1907879,0,'[]','[[[\"kill\",\"1\",\"10030005\",\"25\",\"1003\",\"10389\",\"11019\",\"1\"]]]',0,'[{5,36060001,1041000},{3,36030001,4100}]',0,1,1,'[]','[]','[]',1,0,0,0),(10660,'别来无恙','这位精灵美人好像跟你自来熟。','与刺客芙蕾对话',1,3,0,67,0,0,0,0,0,10650,10670,'null','[]','0',100310,0,1907870,0,'[]','[]',0,'[{5,36060001,1073500},{3,36030001,4200}]',0,1,1,'[{0,0,38320001,1}]','[]','[]',1,0,0,0),(10670,'法师老头','嗯，煮咒恶灵那家伙遵守了诺言，很好~看来星灵也顺利回到你身边了。','与埃罗恩对话',1,3,0,68,0,0,0,0,0,10660,10680,'null','[]','0',100306,0,1907880,0,'[]','[]',0,'[{5,36060001,1106500},{3,36030001,4200}]',0,1,1,'[]','[]','[]',1,0,0,0),(10680,'暗裔线索','大法师提供了暗裔和星晶石的线索。','与埃罗恩对话',1,3,0,69,0,0,0,0,0,10670,10690,'null','[]','0',100306,0,1907871,0,'[]','[]',0,'[{5,36060001,1140000},{3,36030001,4200}]',0,1,1,'[{0,0,37020001,1}]','[]','[]',1,0,0,0),(10690,'魂珠副本','完成魂珠副本','完成魂珠副本',1,3,6,70,0,0,0,0,0,10680,10700,'null','[]','0',100306,0,1908474,0,'[]','[[[\"fin_dungeon\",\"11\",\"5900\",\"1\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{5,36060001,375680},{3,36030001,4300}]',0,1,1,'[]','[]','[]',1,5900,0,0),(10700,'采集晶石','附近有强烈的魔法能量气息。','采集星晶石',1,3,3,70,0,0,0,0,0,10690,10710,'null','[]','0',0,0,0,0,'[]','[[[\"collect\",\"4\",\"10030021\",\"1\",\"1003\",\"7594\",\"9085\",\"1\"]]]',0,'[{5,36060001,387420},{3,36030001,4300}]',0,1,1,'[{0,0,38030001,2}]','[]','[]',1,10030021,0,0),(10710,'落难佣兵','你怎么才来呀~我都等得快要睡着了！搞快点！','与人族佣兵对话',1,3,0,70,0,0,0,0,0,10700,10720,'null','[]','0',100309,0,1907881,0,'[]','[]',0,'[{5,36060001,410900},{3,36030001,4300}]',0,1,1,'[]','[]','[]',1,0,0,0),(10720,'代为清理','能够遇到像你这样热心的冒险者，真是我莫大的幸运！','与人族佣兵对话',1,3,0,71,0,0,0,0,0,10710,10730,'null','[]','0',100309,0,1907873,0,'[]','[]',0,'[{5,36060001,543825},{3,36030001,4400}]',0,1,1,'[]','[]','[]',1,0,0,0),(10730,'星灵姐妹','白羊座与金牛座的重逢。','与白羊座对话',1,3,0,71,0,0,0,0,0,10720,10740,'null','[]','0',100308,0,1907874,0,'[]','[]',0,'[{5,36060001,664675},{3,36030001,4400}]',0,1,1,'[]','[]','[]',1,0,0,0),(10740,'神秘宝具','虽然消灭了头目，但是不能掉以轻心！','与白羊座对话',1,3,6,72,0,0,0,0,0,10730,10750,'null','[]','0',100312,0,1907875,0,'[]','[[[\"fin_dungeon\",\"11\",\"10003\",\"1\",\"1003\",\"2439\",\"1659\",\"1\"]]]',0,'[{5,36060001,559575},{3,36030001,4400}]',0,1,1,'[{0,0,24010001,3}]','[]','[]',1,10003,0,0),(10750,'不宜久留','此地不宜久留，你和小白羊先跑，我稍后就会跟上你们的！','与白羊座对话',1,3,0,72,0,0,0,0,0,10740,10760,'null','[]','0',100308,0,1907876,0,'[]','[]',0,'[{5,36060001,683925},{3,36030001,4500}]',0,1,1,'[]','[]','[]',1,0,0,0),(10760,'小命要紧','大难临头，小命要紧，抵抗军战斗第一条法则：不要上，就是怂！快跑~~','与人族佣兵对话',1,3,0,73,0,0,0,0,0,10750,10770,'null','[]','0',100309,0,1907882,0,'[]','[]',0,'[{5,36060001,575550},{3,36030001,4500}]',0,1,1,'[]','[]','[]',1,0,0,0),(10770,'恶魔围困','双拳难敌四手，何况这些暗裔恶魔根本不是一只两只的数量，我稍后就到，你们先撤！','与大法师对话',1,3,1,73,0,0,0,0,0,10760,10780,'null','[]','0',100306,0,1907877,0,'[]','[[[\"kill\",\"1\",\"10030006\",\"20\",\"1003\",\"6642\",\"7939\",\"1\"]]]',0,'[{5,36060001,703450},{3,36030001,4500}]',0,1,1,'[{0,0,38040102,5}]','[]','[]',1,0,0,0),(10780,'迷雾港口','西边的港口会有同伴接应我们！','与大法师对话',1,3,0,74,0,0,0,0,0,10770,10790,'null','[]','0',100306,0,1907883,0,'[]','[]',0,'[{5,36060001,591750},{3,36030001,4600}]',0,1,1,'[]','[]','[]',1,0,0,0),(10790,'经验副本','经过经验副本的洗礼，你得到了巨大的提升','与水手对话',1,3,6,74,0,0,0,0,0,10780,10800,'null','[]','0',100307,0,1907884,0,'[]','[[[\"fin_dungeon\",\"11\",\"3002\",\"1\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{5,36060001,723250},{3,36030001,4600}]',0,1,1,'[]','[]','[]',1,3002,0,0),(10800,'抵达王城','这里就是洛亚王城了，怎么样？是个好地方吧~哈哈哈哈哈','与水手对话',1,3,0,90,0,0,0,0,0,10790,10810,'null','[]','0',100408,0,1907887,0,'[]','[]',0,'[{5,36060001,819600},{3,36030001,4600}]',0,1,1,'[]','[]','[]',1,0,0,0),(10810,'要务在身','喵队长要务在身，只能自己到处看看王城吧！','与喵队长对话',1,4,0,90,0,0,0,0,0,10800,10820,'null','[]','0',100418,0,1907888,0,'[]','[]',0,'[{5,36060001,922050},{3,36030001,4700}]',0,1,1,'[]','[]','[]',1,0,0,0),(10820,'王城佣兵','瞧把你吓得，我第一次来王城也是你这种表情，哈哈！','与佣兵对话',1,4,0,90,0,0,0,0,0,10810,10830,'null','[]','0',100415,0,1907889,0,'[]','[]',0,'[{5,36060001,952785},{3,36030001,4700}]',0,1,1,'[{0,0,38130001,5}]','[]','[]',1,0,0,0),(10830,'珍稀圣器','我为你准备了一个惊喜，不过你得先完成试炼才能知道是什么！','与抵抗军对话',1,4,0,90,0,0,0,0,0,10820,10840,'null','[]','0',100416,0,1907890,0,'[]','[]',0,'[{5,36060001,983520},{3,36030001,4700}]',0,1,1,'[]','[]','[]',1,0,0,0),(10840,'挑战将至','我听说王城有个骁勇善战的将军，这次拜访，必定避不开他给予的挑战！','与莱克斯对话',1,4,0,90,0,0,0,0,0,10830,10850,'null','[]','0',100416,0,1907891,0,'[]','[]',0,'[{5,36060001,1014255},{3,36030001,4800}]',0,1,1,'[]','[]','[]',1,0,0,0),(10850,'猫娘书记','冒险者请等一下！请到我这里来进行来访登记~','与猫娘对话',1,4,0,90,0,0,0,0,0,10840,10860,'null','[]','0',100401,0,1907892,0,'[]','[]',0,'[{5,36060001,1034745},{3,36030001,4800}]',0,1,1,'[]','[]','[]',1,0,0,0),(10860,'圣器试炼Ⅰ','欢迎来到洛亚王城，你通过了圣器试炼，就等同于得到了我的认可！','与将军对话',1,4,6,90,0,0,0,0,0,10850,10870,'null','[]','0',100407,0,1907893,0,'[]','[[[\"fin_dungeon\",\"11\",\"2201\",\"1\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{5,36060001,1065480},{3,36030001,4800}]',0,1,1,'[]','[]','[]',1,2201,0,0),(10870,'找寻圣器','圣器下落至今还没有线索~祝您好运冒险者！','与大法师对话',1,4,0,90,0,0,0,0,0,10860,10880,'null','[]','0',100409,0,1907894,0,'[]','[]',0,'[{5,36060001,1096215},{3,36030001,4900}]',0,1,1,'[]','[]','[]',1,0,0,0),(10880,'警惕之人','虽然我们目前有一些圣器在手，但是距离目标还差远了！不要松懈！','与劳伦兹对话',1,4,0,90,0,0,0,0,0,10870,10890,'null','[]','0',100403,0,1907895,0,'[]','[]',0,'[{5,36060001,1126950},{3,36030001,4900}]',0,1,1,'[]','[]','[]',1,0,0,0),(10890,'祭祀认可','想要进入精灵族的领地，就要进行相应的试炼，得到森林的认可！你准备好了吗？','与朵萝丝对话',1,4,0,90,0,0,0,0,0,10880,10900,'null','[]','0',100414,0,1908330,0,'[]','[]',0,'[{5,36060001,1229400},{3,36030001,4900}]',0,1,1,'[]','[]','[]',1,0,0,0),(10900,'祭祀指引','想要变强的话，按照书上所说，就要努力找寻试炼并且尝试完成它！','与朵萝丝对话',1,4,0,95,0,0,0,0,0,10890,10910,'null','[]','0',100414,0,1907897,0,'[]','[]',0,'[{5,36060001,912600},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(10910,'暴躁铁匠','敲敲打打很辛苦的，你们这些冒险者，能不能爱惜一下自己的装备啊！','与铁匠对话',1,4,0,95,0,0,0,0,0,10900,10920,'null','[]','0',100411,0,1908331,0,'[]','[]',0,'[{5,36060001,1026675},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(10920,'神秘少女','石头剪刀布！你也要来玩吗？不过输了的人要接受我的惩罚哦~','与异国少女对话',1,4,0,95,0,0,0,0,0,10910,10930,'null','[]','0',100412,0,1907898,0,'[]','[]',0,'[{5,36060001,1060898},{3,36030001,5000}]',0,1,1,'[{0,0,38040010,2}]','[]','[]',1,0,0,0),(10930,'圣器助威','哈哈哈~你输了！你要接受惩罚，你要在迷雾沼泽找到宝藏！','与异国少女对话',1,4,0,95,0,0,0,0,0,10920,10940,'null','[]','0',100412,0,1907899,0,'[]','[]',0,'[{5,36060001,1095120},{3,36030001,5100}]',0,1,1,'[]','[]','[]',1,0,0,0),(10940,'接受惩罚','居然因为猜拳接受惩罚，冒险者你真的很有意思~','与露易丝对话',1,4,0,95,0,0,0,0,0,10930,10950,'null','[]','0',100303,0,1907900,0,'[]','[]',0,'[{5,36060001,1129343},{3,36030001,5100}]',0,1,1,'[]','[]','[]',1,0,0,0),(10950,'忍辱负重','我的同胞都被暗裔影响了，不知道我什么时候也会变成这样~','击杀史莱姆',1,4,1,95,0,0,0,0,0,10940,10960,'null','[]','0',100304,0,1907901,0,'[]','[[[\"kill\",\"1\",\"10030003\",\"30\",\"1003\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,1152158},{3,36030001,5100}]',0,1,1,'[]','[]','[]',1,0,0,0),(10960,'请多保重','沼泽凶险，冒险者你还是好好保重吧！','与史莱姆对话',1,4,0,95,0,0,0,0,0,10950,10970,'null','[]','0',100304,0,1907902,0,'[]','[]',0,'[{5,36060001,1186380},{3,36030001,5200}]',0,1,1,'[]','[]','[]',1,0,0,0),(10970,'沼泽宝物','你运气真好，居然能在这里找到宝藏！','与施法的妮哆对话',1,4,3,95,0,0,0,0,0,10960,10980,'null','[]','0',100305,0,1907903,0,'[]','[[[\"collect\",\"4\",\"10030020\",\"1\",\"1003\",\"12361\",\"7230\",\"1\"]]]',0,'[{5,36060001,1220603},{3,36030001,5200}]',0,1,1,'[{0,0,14010101,1}]','[]','[]',1,10030020,0,0),(10980,'解开煮咒','唉~不知道大法师什么时候解除我的煮咒……','与恶灵对话',1,4,0,95,0,0,0,0,0,10970,10990,'null','[]','0',100305,0,1907904,0,'[]','[]',0,'[{5,36060001,1254825},{3,36030001,5200}]',0,1,1,'[]','[]','[]',1,0,0,0),(10990,'各族关系','出门在外，尤其是冒险者，难免有跌打损伤，来一些万应止痛喵喵丸吧！','与猫又药师对话',1,4,1,95,0,0,0,0,0,10980,11000,'null','[]','0',100311,0,1907905,0,'[]','[[[\"kill\",\"1\",\"10030005\",\"30\",\"1003\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,1368900},{3,36030001,5300}]',0,1,1,'[]','[]','[]',1,0,0,0),(11000,'刺客魅影','既然森林神殿设置了戒备，那我们就强行突破戒备，趁着这段时间好好提升自己的实力吧！','与刺客芙蕾对话',1,4,0,100,0,0,0,0,0,10990,11010,'null','[]','0',100310,0,1907906,0,'[]','[]',0,'[{5,36060001,1263250},{3,36030001,5300}]',0,1,1,'[]','[]','[]',1,0,0,0),(11010,'挑战首领','干得不错，随着你的实力提升，就能挑战更为强大的boss了！','与大法师对话',1,4,0,100,0,0,0,0,0,11000,11020,'null','[]','0',100306,0,1907907,0,'[]','[]',0,'[{5,36060001,1389575},{3,36030001,5300}]',0,1,1,'[]','[]','[]',1,0,0,0),(11020,'肩负责任','此前为了暂避风险，搁置了沼泽的魔物，现在你实力提升，也要肩负责任了','与大法师对话',1,4,1,100,0,0,0,0,0,11010,11030,'null','[]','0',0,0,0,0,'[]','[[[\"kill\",\"1\",\"10030006\",\"30\",\"1003\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,1515900},{3,36030001,5300}]',0,1,1,'[]','[]','[]',1,0,0,0),(11030,'找寻向导','你比之前更加游刃有余了，这片沼泽有个人也许可以帮你解决精灵部族那边的事端！','与大法师对话',1,4,0,100,0,0,0,0,0,11020,11040,'null','[]','0',100306,0,1908332,0,'[]','[]',0,'[{5,36060001,1579063},{3,36030001,5400}]',0,1,1,'[{0,0,38040102,5}]','[]','[]',1,0,0,0),(11040,'奇异菇林','真是稀客了，我好久没看到人类了~','采集星晶石',1,4,0,100,0,0,0,0,0,11030,11050,'null','[]','0',100501,0,1908337,0,'[]','[]',0,'[{5,36060001,1579063},{3,36030001,5400}]',0,1,1,'[]','[]','[]',1,0,0,0),(11050,'变强建议','工欲善其事必先利其器，自身的实力增强固然重要，更好的装备也能提升实力！','与通讯员对话',1,4,0,100,0,0,0,0,0,11040,11060,'null','[]','0',100502,0,1907911,0,'[]','[]',0,'[{5,36060001,1642225},{3,36030001,5400}]',0,1,1,'[]','[]','[]',1,0,0,0),(11060,'狩猎取材','嘻嘻嘻，这些材料可是制作武器的素材哦~','消灭骷髅兵',1,4,1,100,0,0,0,0,0,11050,11070,'null','[]','0',100503,0,1907912,0,'[]','[[[\"kill\",\"1\",\"10050001\",\"36\",\"1005\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,1768550},{3,36030001,5500}]',0,1,1,'[]','[]','[]',1,0,0,0),(11070,'无法强化','想要变强的话，低级装备已经不能满足你的需求了，你得想法设法打造出更高级的装备！','与煮咒恶灵对话',1,4,0,100,0,0,0,0,0,11060,11080,'null','[]','0',100504,0,1907913,0,'[]','[]',0,'[{5,36060001,1894875},{3,36030001,5500}]',0,1,1,'[{0,0,20060001,2}]','[]','[]',1,0,0,0),(11080,'变强心切','我从你眼中看出了急切变强的决心，很好，回到主城后我会更进一步教你！','消灭沼妖精',1,4,0,105,0,0,0,0,0,11070,11090,'null','[]','0',100505,0,1907914,0,'[]','[]',0,'[{5,36060001,1263250},{3,36030001,5500}]',0,1,1,'[]','[]','[]',1,0,0,0),(11090,'拦路地精','看着你逐步成长，我也感到十分欣慰呀~喵呜','与刺客芙蕾对话',1,4,1,105,0,0,0,0,0,11080,11100,'null','[]','0',100506,0,1907915,0,'[]','[[[\"kill\",\"1\",\"10050002\",\"30\",\"1005\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,1389575},{3,36030001,5600}]',0,1,1,'[]','[]','[]',1,0,0,0),(11100,'变强途径','想要变强，先要变帅！','与大法师对话',1,4,0,105,0,0,0,0,0,11090,11110,'null','[]','0',100507,0,1907916,0,'[]','[]',0,'[{5,36060001,1515900},{3,36030001,5600}]',0,1,1,'[{0,0,38030001,1}]','[]','[]',1,0,0,0),(11110,'持之以恒','副本和boss是我们变强的重要途径，每天都要持之以恒地进行挑战！','与劳伦兹对话',1,4,3,105,0,0,0,0,0,11100,11120,'null','[]','0',100508,0,1907917,0,'[]','[[[\"collect\",\"4\",\"10050020\",\"1\",\"1005\",\"5942\",\"15058\",\"1\"]]]',0,'[{5,36060001,1579063},{3,36030001,5600}]',0,1,1,'[]','[]','[]',1,10050020,0,0),(11120,'森林商贩','我是退伍的守卫，这里应有尽有，各位走过路过莫错过呀！','与小男孩对话',1,4,0,105,0,0,0,0,0,11110,11130,'null','[]','0',100509,0,1907918,0,'[]','[]',0,'[{5,36060001,1579063},{3,36030001,5700}]',0,1,1,'[]','[]','[]',1,0,0,0),(11130,'豹猫祭祀','路边的蘑菇不要随便采哦~指不定就会当场去世的哦~','与狸太郎对话',1,4,0,105,0,0,0,0,0,11120,11140,'null','[]','0',100510,0,1907919,0,'[]','[]',0,'[{5,36060001,1642225},{3,36030001,5700}]',0,1,1,'[]','[]','[]',1,0,0,0),(11140,'菇林妖精','打到妖精，收集羽翼的材料~','与精灵对话',1,4,1,105,0,0,0,0,0,11130,11150,'null','[]','0',0,0,0,0,'[]','[[[\"kill\",\"1\",\"10050004\",\"30\",\"1005\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,1768550},{3,36030001,5700}]',0,1,1,'[]','[]','[]',1,0,0,0),(11150,'再次启程','事不宜迟，我们动身吧~','与精灵对话',1,4,0,105,0,0,0,0,0,11140,11160,'null','[]','0',100510,0,1907921,0,'[]','[]',0,'[{5,36060001,1894875},{3,36030001,5800}]',0,1,1,'[{0,0,53020010,2}]','[]','[]',1,0,0,0),(11160,'请来救兵','单枪匹马就想闯入森林神殿，你未免也太自大了吧！？','与加德纳对话',1,4,0,110,0,0,0,0,0,11150,11170,'null','[]','0',100511,0,1907922,0,'[]','[]',0,'[{5,36060001,1263250},{3,36030001,5800}]',0,1,1,'[]','[]','[]',1,0,0,0),(11170,'故技重施','既然不能靠伪装潜入，那就只能光明正大的入侵了！','消灭哥布林',1,4,1,110,0,0,0,0,0,11160,11180,'null','[]','0',0,0,0,0,'[]','[[[\"kill\",\"1\",\"10050005\",\"34\",\"1005\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,1389575},{3,36030001,5800}]',0,1,1,'[]','[]','[]',1,0,0,0),(11180,'重燃希望','必要时候我会助你一臂之力的！','与谜之少女对话',1,4,0,110,0,0,0,0,0,11170,11190,'null','[]','0',100512,0,1907924,0,'[]','[]',0,'[{5,36060001,1515900},{3,36030001,5900}]',0,1,1,'[]','[]','[]',1,0,0,0),(11190,'密林猛兽','蘑菇林奇珍异兽繁多，要是能够收集到精灵之羽，或许能助您一翼之力！','消灭森林狼',1,4,0,110,0,0,0,0,0,11180,11200,'null','[]','0',100513,0,1907925,0,'[]','[]',0,'[{5,36060001,1579063},{3,36030001,5900}]',0,1,1,'[]','[]','[]',1,0,0,0),(11200,'坚如岩龟','精灵之羽？那种充满魔法的素材可以制成美丽的羽翼！','击败森妖精',1,4,1,110,0,0,0,0,0,11190,11210,'null','[]','0',100514,0,1907926,0,'[]','[[[\"kill\",\"1\",\"10050006\",\"40\",\"1005\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,1579063},{3,36030001,5900}]',0,1,1,'[]','[]','[]',1,0,0,0),(11210,'神殿方位','神殿位于世界树的树冠之上，看到远处那颗参天大树了吗？我们离它不远了~','与帝国杀手8号对话',1,4,0,110,0,0,0,0,0,11200,11220,'null','[]','0',100514,0,1907927,0,'[]','[]',0,'[{5,36060001,1642225},{3,36030001,6000}]',0,1,1,'[]','[]','[]',1,0,0,0),(11220,'夕树长老','你就是那个得到森林认可的年轻抵抗军嘛？欢迎来到森林神殿。','与长老对话',1,4,0,110,0,0,0,0,0,11210,11230,'null','[]','0',100601,0,1907928,0,'[]','[]',0,'[{5,36060001,1768550},{3,36030001,6000}]',0,1,1,'[]','[]','[]',1,0,0,0),(11230,'吃惊不已','黄道十二宫的姐妹很快就能团聚了吧？我也要加把劲才行！','与双子座对话',1,4,0,110,0,0,0,0,0,11220,11240,'null','[]','0',100602,0,1907929,0,'[]','[]',0,'[{5,36060001,1894875},{3,36030001,6000}]',0,1,1,'[]','[]','[]',1,0,0,0),(11240,'不被认可','神殿是接近精灵族神明的领域，我们暗精灵是不被认可的存在。','',1,4,0,120,0,0,0,0,0,11230,11250,'null','[]','0',100603,0,1907930,0,'[]','[]',0,'[{5,36060001,1757720},{3,36030001,6100}]',0,1,1,'[{1,1,1007010410,1},{2,1,1007020410,1},{3,2,1007030410,1},{4,2,1007040410,1}]','[]','[]',1,0,0,0),(11250,'森林恶狼','哼~看你还是个门外汉，我就勉为其难稍微指导一下你吧！','消灭岩龟',1,4,1,120,0,0,0,0,0,11240,11260,'null','[]','0',100604,0,1907931,0,'[]','[[[\"kill\",\"1\",\"10060001\",\"30\",\"1006\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,1977435},{3,36030001,6100}]',0,1,1,'[]','[]','[]',1,0,0,0),(11260,'有惊无险','以门外汉的水平，对付起来也是有惊无险的程度吧~','与无畏的艾琳对话',1,4,0,120,0,0,0,0,0,11250,11270,'null','[]','0',100604,0,1907932,0,'[]','[]',0,'[{5,36060001,2043350},{3,36030001,6100}]',0,1,1,'[]','[]','[]',1,0,0,0),(11270,'豹猫翠西','踏足这片满溢生命之力的神殿领域，让我看看你够不够资格！','与树人长老对话',1,5,0,120,0,0,0,0,0,11260,11280,'null','[]','0',100605,0,1907933,0,'[]','[]',0,'[{5,36060001,2109264},{3,36030001,6200}]',0,1,1,'[{0,0,1003000410,1}]','[]','[]',1,0,0,0),(11280,'反叛妖精','区区人类，居然有如此强大的神格潜力！','与长老对话',1,5,1,120,0,0,0,0,0,11270,11290,'null','[]','0',0,0,0,0,'[]','[[[\"kill\",\"1\",\"10060002\",\"30\",\"1006\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,2175179},{3,36030001,6200}]',0,1,1,'[]','[]','[]',1,0,0,0),(11290,'博得认同','从我们的角度来看，你的实力已经十分不错了！','与双子座对话',1,5,0,120,0,0,0,0,0,11280,11300,'null','[]','0',100605,0,1907935,0,'[]','[]',0,'[{5,36060001,2219122},{3,36030001,6200}]',0,1,1,'[]','[]','[]',1,0,0,0),(11300,'继续观察','好吧！你的实力我认可了，但是你的意志力如何，我还要继续观察！','消灭丛林狼',1,5,0,120,0,0,0,0,0,11290,11310,'null','[]','0',100606,0,1907936,0,'[]','[]',0,'[{5,36060001,2285036},{3,36030001,6300}]',0,1,1,'[]','[]','[]',1,0,0,0),(11310,'食人花朵','自从遭遇暗裔入侵，各部族之间就一直人心惶惶，为了部族大部分同胞的利益，女王流放了暗精灵……','与精灵女王对话',1,5,1,120,0,0,0,0,0,11300,11320,'null','[]','0',100606,0,1907937,0,'[]','[[[\"kill\",\"1\",\"10060003\",\"30\",\"1006\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,2350951},{3,36030001,6300}]',0,1,1,'[]','[]','[]',1,0,0,0),(11320,'部族矛盾','精灵部族繁多，如今内忧外患，唉~这种麻烦的事情，还是你亲自和女王当面说吧！','与精灵女王对话',1,5,0,120,0,0,0,0,0,11310,11330,'null','[]','0',100604,0,1907938,0,'[]','[]',0,'[{5,36060001,2416865},{3,36030001,6300}]',0,1,1,'[{0,0,38070001,1}]','[]','[]',1,0,0,0),(11330,'同盟看法','即便你们想要同盟，但是精灵族部族繁多，加上我们已是被放逐的部族，希望渺茫……','与守卫长对话',1,5,0,120,0,0,0,0,0,11320,11340,'null','[]','0',100603,0,1907939,0,'[]','[]',0,'[{5,36060001,2636580},{3,36030001,6400}]',0,1,1,'[]','[]','[]',1,0,0,0),(11340,'长老认可','既然你都证明了自己的实力，也是时候去见见女王大人了~','与克劳尔对话',1,5,0,130,0,0,0,0,0,11330,11350,'null','[]','0',100601,0,1907940,0,'[]','[]',0,'[{5,36060001,2060120},{3,36030001,6400}]',0,1,1,'[]','[]','[]',1,0,0,0),(11350,'内忧外患','精灵部族还有许多矛盾纷争需要解决，同盟恐怕并非易事。','与克劳尔对话',1,5,0,130,0,0,0,0,0,11340,11360,'null','[]','0',100614,0,1907941,0,'[]','[]',0,'[{5,36060001,2317635},{3,36030001,6400}]',0,1,1,'[]','[]','[]',1,0,0,0),(11360,'精灵女王','同盟之事还需延后，哀家要先解决我们部族内部的矛盾，倘若冒险者可以助我们一臂之力，那就再好不过了。','消灭食人花',1,5,0,130,0,0,0,0,0,11350,11370,'null','[]','0',100610,0,1907942,0,'[]','[]',0,'[{5,36060001,2394890},{3,36030001,6500}]',0,1,1,'[]','[]','[]',1,0,0,0),(11370,'神殿守卫','经过神殿守卫的实力检验，哀家觉得你一定是这次事件的得力助手了！','与豹猫对话',1,5,1,130,0,0,0,0,0,11360,11380,'null','[]','0',100610,0,1907943,0,'[]','[[[\"kill\",\"1\",\"10060004\",\"30\",\"1006\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,2472144},{3,36030001,6500}]',0,1,1,'[{0,0,38330003,2}]','[]','[]',1,0,0,0),(11380,'燃眉之急','神殿东部的蜥蜴人部族暴动了，请冒险者快去支援！','与朵萝丝对话',1,5,0,130,0,0,0,0,0,11370,11390,'null','[]','0',100614,0,1907944,0,'[]','[]',0,'[{5,36060001,2549399},{3,36030001,6500}]',0,1,1,'[]','[]','[]',1,0,0,0),(11390,'奔走相告','听说蜥蜴人部族暴动了，这下可麻烦了！','与艾璐对话',1,5,0,130,0,0,0,0,0,11380,11400,'null','[]','0',100607,0,1907945,0,'[]','[]',0,'[{5,36060001,2600902},{3,36030001,6600}]',0,1,1,'[]','[]','[]',1,0,0,0),(11400,'蜥蜴暴乱','蜥蜴部族的暴乱影响了神殿的东部区域。','消灭丛林狼',1,5,1,130,0,0,0,0,0,11390,11410,'null','[]','0',0,0,0,0,'[]','[[[\"kill\",\"1\",\"10060005\",\"30\",\"1006\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,2678156},{3,36030001,6600}]',0,1,1,'[]','[]','[]',1,0,0,0),(11410,'改变认知','我之前是小看你了，想不到人类也有如此大的可能性啊~','与鹿琪儿对话',1,5,0,130,0,0,0,0,0,11400,11420,'null','[]','0',100609,0,1907947,0,'[]','[]',0,'[{5,36060001,2755411},{3,36030001,6600}]',0,1,1,'[{0,0,38040010,2}]','[]','[]',1,0,0,0),(11420,'岩龟躁动','蜥蜴部族的暴动惊动了温顺的岩龟。','击败岩龟',1,5,1,130,0,0,0,0,0,11410,11430,'null','[]','0',0,0,0,0,'[]','[[[\"kill\",\"1\",\"10060006\",\"30\",\"1006\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,2832665},{3,36030001,6700}]',0,1,1,'[]','[]','[]',1,0,0,0),(11430,'健美狼人','精灵部族有意向和我们结盟，不过前提是他们部族得先完成联合是吗？','与劳伦兹对话',1,5,0,130,0,0,0,0,0,11420,11440,'null','[]','0',100613,0,1907949,0,'[]','[]',0,'[{5,36060001,3090180},{3,36030001,6700}]',0,1,1,'[]','[]','[]',1,0,0,0),(11440,'友好礼物','如果可以的话，冒险者可以帮我送一份礼物给精灵族的人吗？算是我们东部部族同意结盟的证明！','与康斯坦将军对话',1,5,0,140,0,0,0,0,0,11430,11450,'null','[]','0',100613,0,1907950,0,'[]','[]',0,'[{5,36060001,1960500},{3,36030001,6700}]',0,1,1,'[]','[]','[]',1,0,0,0),(11450,'逐渐明朗','噢！看来东部的兽人部族同意结盟了，好样的！赶紧向女王汇报这个好消息！','与国王对话',1,5,3,140,0,0,0,0,0,11440,11460,'null','[]','0',100609,0,1907951,0,'[]','[[[\"collect\",\"4\",\"10060021\",\"1\",\"1006\",\"13853\",\"5245\",\"1\"]]]',0,'[{5,36060001,2019315},{3,36030001,6800}]',0,1,1,'[]','[]','[]',1,10060021,0,0),(11460,'喜出望外','你们抵抗军还真会折腾，居然能把兽人部族也搞定啦！','与巴雷特大臣对话',1,5,0,140,0,0,0,0,0,11450,11470,'null','[]','0',100608,0,1907952,0,'[]','[]',0,'[{5,36060001,2078130},{3,36030001,6800}]',0,1,1,'[]','[]','[]',1,0,0,0),(11470,'指日可待','此前因为暗裔的入侵，东部区域都被腐化污染，因此资源分配上产生了纠纷，想不到你们能够解决这次的暴乱。','与艾菲里尔对话',1,5,0,140,0,0,0,0,0,11460,11480,'null','[]','0',100607,0,1907953,0,'[]','[]',0,'[{5,36060001,2136945},{3,36030001,6800}]',0,1,1,'[]','[]','[]',1,0,0,0),(11480,'事发突然','请快速到神殿守护者那里一趟！','与艾菲里尔对话',1,5,0,140,0,0,0,0,0,11470,11490,'null','[]','0',100614,0,1907954,0,'[]','[]',0,'[{5,36060001,2195760},{3,36030001,6900}]',0,1,1,'[]','[]','[]',1,0,0,0),(11490,'人马试炼','暗精灵部族那边出现了冲突，兽人族同盟的消息交给我传达吧！勇者你快去阻止暗精灵！','与妖精艾利对话',1,5,1,140,0,0,0,0,0,11480,11500,'null','[]','0',100614,0,1907955,0,'[]','[[[\"kill\",\"1\",\"10060100\",\"1\",\"1006\",\"9053\",\"14550\",\"1\"]]]',0,'[{5,36060001,2234970},{3,36030001,6900}]',0,1,1,'[]','[]','[]',1,0,0,0),(11500,'于心不忍','还有部分蜥蜴人十分顽固，他们下次还会来的！教训下他们，让他们以后都不敢来找茬！','与妖精对话',1,5,0,140,0,0,0,0,0,11490,11510,'null','[]','0',100607,0,1907956,0,'[]','[]',0,'[{5,36060001,2274180},{3,36030001,6900}]',0,1,1,'[]','[]','[]',1,0,0,0),(11510,'祸不单行','我就知道冲突不可能这么轻易就解决的，加把劲吧！冒险者~','与蘑菇爷爷对话',1,5,0,140,0,0,0,0,0,11500,11520,'null','[]','0',100608,0,1907957,0,'[]','[]',0,'[{5,36060001,2332995},{3,36030001,7000}]',0,1,1,'[]','[]','[]',1,0,0,0),(11520,'再次找茬','阻止蜥蜴人，防止他们再次找茬！','与蘑菇爷爷对话',1,5,1,140,0,0,0,0,0,11510,11530,'null','[]','0',0,0,0,0,'[]','[[[\"kill\",\"1\",\"10060005\",\"30\",\"1006\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,2372205},{3,36030001,7000}]',0,1,1,'[]','[]','[]',1,0,0,0),(11530,'幕后主使','这次暗精灵的冲突，看来是有计划的行动，关键是要知道幕后主使是谁才行！','击败岩龟',1,5,0,150,0,0,0,0,0,11520,11540,'null','[]','0',100609,0,1907959,0,'[]','[]',0,'[{5,36060001,1502020},{3,36030001,7000}]',0,1,1,'[]','[]','[]',1,0,0,0),(11540,'迷途火鸡','看什么看？没见过火鸡啊？','与迷路狐狸对话',1,5,0,150,0,0,0,0,0,11530,11550,'null','[]','0',100612,0,1907960,0,'[]','[]',0,'[{5,36060001,1502020},{3,36030001,7100}]',0,1,1,'[]','[]','[]',1,0,0,0),(11550,'反叛侍卫','曾经侍奉女王的侍卫，为何会以矛头相对呢？','击败葛布林',1,5,1,150,0,0,0,0,0,11540,11560,'null','[]','0',0,0,0,0,'[]','[[[\"kill\",\"1\",\"10060007\",\"30\",\"1006\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,1617560},{3,36030001,7100}]',0,1,1,'[]','[]','[]',1,0,0,0),(11560,'搞事骑士','哼！我身为骑士可是守口如瓶的，怎么可能告诉你这次冲突的幕后主使就是刺客芙蕾？','与牛头战士对话',1,5,0,150,0,0,0,0,0,11550,11570,'null','[]','0',100612,0,1907962,0,'[]','[]',0,'[{5,36060001,1617560},{3,36030001,7100}]',0,1,1,'[]','[]','[]',1,0,0,0),(11570,'两难处境','我明明知道这样做是不对的，但是凭什么暗精灵就要被驱逐家园呢？我们也只是受害者啊！','与牛头战士对话',1,5,0,150,0,0,0,0,0,11560,11580,'null','[]','0',100611,0,1907963,0,'[]','[]',0,'[{5,36060001,1733100},{3,36030001,7200}]',0,1,1,'[]','[]','[]',1,0,0,0),(11580,'平息冲突','平息这次的冲突吧！','击败葛布林',1,5,1,150,0,0,0,0,0,11570,11590,'null','[]','0',0,0,0,0,'[]','[[[\"kill\",\"1\",\"10060008\",\"30\",\"1006\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,1733100},{3,36030001,7200}]',0,1,1,'[]','[]','[]',1,0,0,0),(11590,'摒弃前嫌','既然我们要面对共同的敌人，我代表暗精灵同意结盟！','与芙蕾对话',1,5,0,150,0,0,0,0,0,11580,11600,'null','[]','0',100611,0,1907964,0,'[]','[]',0,'[{5,36060001,1848640},{3,36030001,7200}]',0,1,1,'[]','[]','[]',1,0,0,0),(11600,'红装合成','一种新的炼金术，红装合成摆在你的面前。','与地精科学家对话',1,5,0,160,0,0,0,0,0,11590,11610,'null','[]','0',100503,0,1907966,0,'[]','[]',0,'[{5,36060001,785188},{3,36030001,7300},{0,1002010432,1},{0,1002020432,1},{0,1002040432,1},{0,1002020432,1}]',0,1,1,'[]','[]','[]',1,0,0,0),(11610,'得到赏识','好想快点和其他星灵姐妹团聚呀！','与精灵女王对话',1,5,0,160,0,0,0,0,0,11600,11620,'null','[]','0',100504,0,1907967,0,'[]','[]',0,'[{5,36060001,785188},{3,36030001,7300}]',0,1,1,'[]','[]','[]',1,0,0,0),(11620,'卑鄙地精','卑鄙的地精又来了！','与大法师对话',1,5,1,160,0,0,0,0,0,11610,11630,'null','[]','0',0,0,0,0,'[]','[[[\"kill\",\"1\",\"10050002\",\"30\",\"1005\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,785188},{3,36030001,7300}]',0,1,1,'[]','[]','[]',1,0,0,0),(11630,'夜刃传闻','精灵部族内乱期间，许多暗精灵被迫离开部族，他们也是关键的力量！','与通讯员对话',1,5,0,160,0,0,0,0,0,11620,11640,'null','[]','0',100506,0,1908008,0,'[]','[]',0,'[{5,36060001,785188},{3,36030001,7400}]',0,1,1,'[]','[]','[]',1,0,0,0),(11640,'找回夜刃','我接下来打算找到那个叫夜刃的组织领头人！','与通讯员对话',1,5,0,160,0,0,0,0,0,11630,11650,'null','[]','0',100507,0,1907969,0,'[]','[]',0,'[{5,36060001,785188},{3,36030001,7400}]',0,1,1,'[]','[]','[]',1,0,0,0),(11650,'菇林饿狼','战斗技艺你已经精进了不少了！','与狸太郎对话',1,5,1,160,0,0,0,0,0,11640,11660,'null','[]','0',100508,0,1907970,0,'[]','[[[\"kill\",\"1\",\"10050003\",\"30\",\"1005\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,785188},{3,36030001,7400}]',0,1,1,'[]','[]','[]',1,0,0,0),(11660,'山珍佳肴','蘑菇林的山珍佳肴，想着就流口水了！','与男平民对话',1,5,0,160,0,0,0,0,0,11650,11670,'null','[]','0',100509,0,1907971,0,'[]','[]',0,'[{5,36060001,785188},{3,36030001,7500}]',0,1,1,'[]','[]','[]',1,0,0,0),(11670,'酥炸香菇','哼哼~让我来为你们做一道拿手菜：酥炸香菇！','与女平民对话',1,5,0,160,0,0,0,0,0,11660,11800,'null','[]','0',100510,0,1907972,0,'[]','[]',0,'[{5,36060001,785188},{3,36030001,7500}]',0,1,1,'[]','[]','[]',1,0,0,0),(11680,'时机已到','时机已到，我们出发吧！','与抵抗军对话',1,5,0,9999,0,0,0,0,0,0,0,'null','[]','0',100416,0,1907973,0,'[]','[]',0,'[{5,36060001,9},{3,36030001,2909}]',0,1,1,'[]','[]','[]',1,0,0,0),(11690,'沼泽魔物','夜刃神出鬼没，想要找到她也不是件容易的事情','消灭史莱姆',1,5,1,9999,0,0,0,0,0,0,0,'null','[]','0',100306,0,1907974,0,'[]','[[[\"kill\",\"1\",\"10030006\",\"48\",\"1003\",\"6272\",\"7809\",\"1\"]]]',0,'[{5,36060001,9},{3,36030001,2909}]',0,1,1,'[]','[]','[]',1,0,0,0),(11700,'刺客芙蕾','不过你如果想套情报的话，帮我做几件事吧！','与刺客芙蕾对话',1,5,0,9999,0,0,0,0,0,0,0,'null','[]','0',100310,0,1907975,0,'[]','[]',0,'[{5,36060001,9},{3,36030001,2909}]',0,1,1,'[]','[]','[]',1,0,0,0),(11710,'解除痛苦','其实这些暗裔妖精在被侵蚀之前，就是精灵部族的暗精灵','消灭暗妖精',1,5,1,9999,0,0,0,0,0,0,0,'null','[]','0',100305,0,1907976,0,'[]','[[[\"kill\",\"1\",\"10030005\",\"40\",\"1003\",\"10352\",\"10963\",\"1\"]]]',0,'[{5,36060001,9},{3,36030001,2909}]',0,1,1,'[]','[]','[]',1,0,0,0),(11720,'无法理解','但是她这样做的动机是什么呢？','与煮咒恶灵对话',1,5,0,9999,0,0,0,0,0,0,0,'null','[]','0',100305,0,1907977,0,'[]','[]',0,'[{5,36060001,9},{3,36030001,2909}]',0,1,1,'[]','[]','[]',1,0,0,0),(11730,'狼群突袭','可……可恶，那个暗精灵！','消灭狼群',1,5,1,9999,0,0,0,0,0,0,0,'null','[]','0',100309,0,1907978,0,'[]','[[[\"kill\",\"1\",\"10030001\",\"40\",\"1003\",\"8013\",\"4813\",\"1\"]]]',0,'[{5,36060001,9},{3,36030001,2909}]',0,1,1,'[]','[]','[]',1,0,0,0),(11740,'祸不单行','那个暗精灵想一个人解决掉那个大魔物','消灭蜥蜴人',1,5,1,9999,0,0,0,0,0,0,0,'null','[]','0',100308,0,1907979,0,'[]','[[[\"kill\",\"1\",\"10030007\",\"40\",\"1003\",\"3992\",\"5843\",\"1\"]]]',0,'[{5,36060001,9},{3,36030001,2909}]',0,1,1,'[]','[]','[]',1,0,0,0),(11750,'飞蛾扑火','她孤身一人等于送死的啊','与白羊座对话',1,5,0,9999,0,0,0,0,0,0,0,'null','[]','0',100308,0,1907980,0,'[]','[]',0,'[{5,36060001,9},{3,36030001,2909}]',0,1,1,'[]','[]','[]',1,0,0,0),(11760,'怪异沼泽','多谢救命之恩','击败沼泽史莱姆',1,5,1,9999,0,0,0,0,0,0,0,'null','[]','0',100310,0,1907981,0,'[]','[[[\"kill\",\"1\",\"10030006\",\"30\",\"1003\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,9},{3,36030001,2909}]',0,1,1,'[]','[]','[]',1,0,0,0),(11770,'获得信任','我要去见精灵女王，不过在那之前，陪我去一趟蘑菇林','与刺客芙蕾对话',1,5,0,9999,0,0,0,0,0,0,0,'null','[]','0',100310,0,1907982,0,'[]','[]',0,'[{5,36060001,9},{3,36030001,2909}]',0,1,1,'[]','[]','[]',1,0,0,0),(11780,'苏珊大婶','啊啦~这不是芙蕾嘛！','与苏珊大婶对话',1,5,0,9999,0,0,0,0,0,0,0,'null','[]','0',100503,0,1907983,0,'[]','[]',0,'[{5,36060001,9},{3,36030001,2909}]',0,1,1,'[]','[]','[]',1,0,0,0),(11790,'恼人地精','糟蹋我盆栽的哥布林终于被制裁了！','消灭哥布林',1,5,1,9999,0,0,0,0,0,0,0,'null','[]','0',100503,0,1908322,0,'[]','[[[\"kill\",\"1\",\"10050002\",\"40\",\"1005\",\"2312\",\"4173\",\"1\"]]]',0,'[{5,36060001,9},{3,36030001,2909}]',0,1,1,'[]','[]','[]',1,0,0,0),(11800,'重遇故人','你是？芙蕾！是芙蕾吗！','与神秘少女对话',1,5,0,170,0,0,0,0,0,11670,11810,'null','[]','0',100510,0,1907985,0,'[]','[]',0,'[{5,36060001,1183167},{3,36030001,7900}]',0,1,1,'[]','[]','[]',1,0,0,0),(11810,'举手之劳','作为报酬，这个设计图我就送给你了！','击败丛林狼',1,5,3,170,0,0,0,0,0,11800,11820,'null','[]','0',100511,0,1908323,0,'[]','[[[\"collect\",\"4\",\"10050021\",\"1\",\"1005\",\"11745\",\"10747\",\"1\"]]]',0,'[{5,36060001,1183167},{3,36030001,8000}]',0,1,1,'[]','[]','[]',1,10050021,0,0),(11820,'调味佐料','香菇作为调料真的很美味呢~','与施法的妮哆对话',1,5,0,170,0,0,0,0,0,11810,11830,'null','[]','0',100512,0,1907987,0,'[]','[]',0,'[{5,36060001,1183167},{3,36030001,8000}]',0,1,1,'[]','[]','[]',1,0,0,0),(11830,'坚守情谊','多亏了抵抗军的协助，蘑菇林才安定下来','与坚守的艾琳对话',1,5,0,170,0,0,0,0,0,11820,11840,'null','[]','0',100513,0,1907988,0,'[]','[]',0,'[{5,36060001,1183167},{3,36030001,8000}]',0,1,1,'[]','[]','[]',1,0,0,0),(11840,'暗夜部族','芙蕾回归的话，暗夜部族一定会顺应精灵女王的号召的！','打败精灵侍卫',1,5,1,170,0,0,0,0,0,11830,11850,'null','[]','0',100514,0,1908324,0,'[]','[[[\"kill\",\"1\",\"10050006\",\"40\",\"1005\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,1183167},{3,36030001,8100}]',0,1,1,'[]','[]','[]',1,0,0,0),(11850,'众望所归','毫无疑问，芙蕾是暗精灵部族众望所归的核心人物！','与阿里咚咚对话',1,5,0,170,0,0,0,0,0,11840,11860,'null','[]','0',100514,0,1907990,0,'[]','[]',0,'[{5,36060001,1183167},{3,36030001,8100}]',0,1,1,'[]','[]','[]',1,0,0,0),(11860,'寄予厚望','冒险者，快点行动起来！','与古鲁对话',1,5,0,180,0,0,0,0,0,11850,11870,'null','[]','0',100602,0,1907991,0,'[]','[]',0,'[{5,36060001,1327750},{3,36030001,8100}]',0,1,1,'[]','[]','[]',1,0,0,0),(11870,'最后屏障','好不容易来平息了冲突，不知道还会有什么困难险阻在等着我们。','击败岩龟',1,5,1,180,0,0,0,0,0,11860,11880,'null','[]','0',100603,0,1908333,0,'[]','[[[\"kill\",\"1\",\"10060001\",\"50\",\"1006\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,1327750},{3,36030001,8200}]',0,1,1,'[]','[]','[]',1,0,0,0),(11880,'温顺妖精','你平安无事就好了，快去见朵萝丝吧！','与长老对话',1,5,0,180,0,0,0,0,0,11870,11890,'null','[]','0',100603,0,1907992,0,'[]','[]',0,'[{5,36060001,1327750},{3,36030001,8200}]',0,1,1,'[]','[]','[]',1,0,0,0),(11890,'不敢相信','不敢相信，你居然还平安无事！？','与守卫长对话',1,5,0,180,0,0,0,0,0,11880,11900,'null','[]','0',100604,0,1907993,0,'[]','[]',0,'[{5,36060001,1327750},{3,36030001,8200}]',0,1,1,'[]','[]','[]',1,0,0,0),(11900,'恭候多时','恭候你多时了，这样部族就算达成统一了，不过按照习俗，战斗切磋是无法避免的。','与精灵女王对话',1,5,0,180,0,0,0,0,0,11890,11910,'null','[]','0',100605,0,1907994,0,'[]','[]',0,'[{5,36060001,1327750},{3,36030001,8300}]',0,1,1,'[]','[]','[]',1,0,0,0),(11910,'西部试炼','不错~不愧是被女王认可的冒险者！','击败暗妖精',1,5,1,180,0,0,0,0,0,11900,11920,'null','[]','0',100605,0,1907995,0,'[]','[[[\"kill\",\"1\",\"10060002\",\"50\",\"1006\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,1327750},{3,36030001,8300}]',0,1,1,'[]','[]','[]',1,0,0,0),(11920,'轻而易举','不愧是身为夜刃的精灵','与艾璐对话',1,5,0,190,0,0,0,0,0,11910,11930,'null','[]','0',100603,0,1907996,0,'[]','[]',0,'[{5,36060001,776271},{3,36030001,8300}]',0,1,1,'[]','[]','[]',1,0,0,0),(11930,'试炼证明','采集试炼完成的证明物','采集木材',1,5,3,190,0,0,0,0,0,11920,11940,'null','[]','0',0,0,0,0,'[]','[[[\"collect\",\"4\",\"10060020\",\"1\",\"1006\",\"6459\",\"13539\",\"1\"]]]',0,'[{5,36060001,776271},{3,36030001,8400}]',0,1,1,'[]','[]','[]',1,10060020,0,0),(11940,'再接再厉','再接再厉吧！不要松懈','与鹿琪儿对话',1,5,0,190,0,0,0,0,0,11930,11950,'null','[]','0',100602,0,1907997,0,'[]','[]',0,'[{5,36060001,776271},{3,36030001,8400}]',0,1,1,'[]','[]','[]',1,0,0,0),(11950,'东部试炼','东部试炼开始啦','与妖精艾利对话',1,5,0,190,0,0,0,0,0,11940,11960,'null','[]','0',100607,0,1907998,0,'[]','[]',0,'[{5,36060001,776271},{3,36030001,8400}]',0,1,1,'[]','[]','[]',1,0,0,0),(11960,'蜥蜴把关','虽然你没有我的美貌那么出众，但是战斗力还是值得认可的！','击败侍卫',1,5,1,190,0,0,0,0,0,11950,11970,'null','[]','0',100609,0,1907999,0,'[]','[[[\"kill\",\"1\",\"10060005\",\"50\",\"1006\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,776271},{3,36030001,8500}]',0,1,1,'[]','[]','[]',1,0,0,0),(11970,'健忘老头','我忘记要说什么了，让我再想想','与蘑菇爷爷对话',1,5,0,190,0,0,0,0,0,11960,11980,'null','[]','0',100609,0,1908000,0,'[]','[]',0,'[{5,36060001,776271},{3,36030001,8500}]',0,1,1,'[]','[]','[]',1,0,0,0),(11980,'试炼守卫','也许书上说的没错，传说中的冒险者通过了神殿中人马赐予的试炼。','击败守卫',1,5,1,200,0,0,0,0,0,11970,11990,'null','[]','0',100614,0,1908001,0,'[]','[[[\"kill\",\"1\",\"10060004\",\"50\",\"1006\",\"11350\",\"7340\",\"1\"]]]',0,'[{5,36060001,858771},{3,36030001,8600}]',0,1,1,'[]','[]','[]',1,0,0,0),(11990,'没有压力','现在的挑战，对于你们来说没有任何负担啊~','与妖精艾利对话',1,6,0,200,0,0,0,0,0,11980,12000,'null','[]','0',100603,0,1908002,0,'[]','[]',0,'[{5,36060001,858771},{3,36030001,8800}]',0,1,1,'[]','[]','[]',1,0,0,0),(12000,'最后关头','最后关头了，继续前进吧！','与守卫长对话',1,6,0,200,0,0,0,0,0,11990,12010,'null','[]','0',100605,0,1908003,0,'[]','[]',0,'[{5,36060001,858771},{3,36030001,8900}]',0,1,1,'[]','[]','[]',1,0,0,0),(12010,'神殿人马','你虽然没有其他种族的强大力量，但是这份坚持和信念，着实让我倍感敬畏！','击败神殿人马',1,6,6,200,0,0,0,0,0,12000,12020,'null','[]','0',100620,0,1908172,0,'[]','[[[\"fin_dungeon\",\"11\",\"10006\",\"1\",\"1006\",\"2285\",\"17370\",\"1\"]]]',0,'[{5,36060001,858771},{3,36030001,9100}]',0,1,1,'[]','[]','[]',1,10006,0,0),(12020,'归入部族','总算，所有部族都重新归入精灵部族了！','与精灵女王对话',1,6,0,200,0,0,0,0,0,12010,12030,'null','[]','0',100606,0,1908004,0,'[]','[]',0,'[{5,36060001,858771},{3,36030001,9200}]',0,1,1,'[]','[]','[]',1,0,0,0),(12030,'部族统一','想不到我们部族的统一竟然是你这位人类的功劳~','与精灵女王对话',1,6,0,200,0,0,0,0,0,12020,12040,'null','[]','0',100604,0,1908005,0,'[]','[]',0,'[{5,36060001,858771},{3,36030001,9300}]',0,1,1,'[]','[]','[]',1,0,0,0),(12040,'寒鸦峡谷','这里资源丰富，不过要记得别被冻死就好~','与雪原村民对话',1,6,0,210,0,0,0,0,0,12030,12050,'null','[]','0',100701,0,1908027,0,'[]','[]',0,'[{5,36060001,567263},{3,36030001,9500}]',0,1,1,'[]','[]','[]',1,0,0,0),(12050,'肥美企鹅','道路被那些怪物占领了，你想见酋长的话也没有办法啊~','击败雪原企鹅',1,6,1,210,0,0,0,0,0,12040,12060,'null','[]','0',100702,0,1908028,0,'[]','[[[\"kill\",\"1\",\"10070001\",\"55\",\"1007\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,567263},{3,36030001,9600}]',0,1,1,'[]','[]','[]',1,0,0,0),(12060,'雪原危机','兽人部族内部出现了两派分歧','与雪原村民对话',1,6,0,210,0,0,0,0,0,12050,12070,'null','[]','0',100702,0,1908029,0,'[]','[]',0,'[{5,36060001,567263},{3,36030001,9800}]',0,1,1,'[]','[]','[]',1,0,0,0),(12070,'雪原怪物','被一只企鹅拦住了去路','击败雪岩怪',1,6,1,210,0,0,0,0,0,12060,12080,'null','[]','0',100703,0,1908030,0,'[]','[[[\"kill\",\"1\",\"10070002\",\"55\",\"1007\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,567263},{3,36030001,9900}]',0,1,1,'[]','[]','[]',1,0,0,0),(12080,'拦路企鹅','企鹅不会让你见大酋长的！','与贩鱼企鹅对话',1,6,0,210,0,0,0,0,0,12070,12090,'null','[]','0',100703,0,1908031,0,'[]','[]',0,'[{5,36060001,567263},{3,36030001,10000}]',0,1,1,'[]','[]','[]',1,0,0,0),(12090,'雪原巨蟹','酋长十分激动~','击败雪原蟹',1,6,1,210,0,0,0,0,0,12080,12100,'null','[]','0',100704,0,1908032,0,'[]','[[[\"kill\",\"1\",\"10070003\",\"55\",\"1007\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,567263},{3,36030001,10200}]',0,1,1,'[]','[]','[]',1,0,0,0),(12100,'酋长提议','如今部族内部分成两派，敌对的激进派信仰拳头说话，除非你能以武服人~','与牛头酋长对话',1,6,0,210,0,0,0,0,0,12090,12110,'null','[]','0',100704,0,1908033,0,'[]','[]',0,'[{5,36060001,567263},{3,36030001,10300}]',0,1,1,'[]','[]','[]',1,0,0,0),(12110,'群狼突袭','群狼突袭，以暴制暴吧！','击败雪原狼',1,6,1,210,0,0,0,0,0,12100,12120,'null','[]','0',0,0,0,0,'[]','[[[\"kill\",\"1\",\"10070004\",\"60\",\"1007\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,567263},{3,36030001,10400}]',0,1,1,'[]','[]','[]',1,0,0,0),(12120,'以武服人','雪原狼可是我们这里数一数二的猛兽，你竟然能够毫发无损！','与牛头酋长对话',1,6,0,210,0,0,0,0,0,12110,12130,'null','[]','0',100704,0,1908034,0,'[]','[]',0,'[{5,36060001,567263},{3,36030001,10600}]',0,1,1,'[]','[]','[]',1,0,0,0),(12130,'钻木取火','这里的木柴可不能随便拿的哦~','采集木材',1,6,3,210,0,0,0,0,0,12120,12140,'null','[]','0',100705,0,1908035,0,'[]','[[[\"collect\",\"4\",\"10070020\",\"2\",\"1007\",\"4021\",\"5790\",\"1\"]]]',0,'[{5,36060001,567263},{3,36030001,10700}]',0,1,1,'[]','[]','[]',1,10070020,0,0),(12140,'以劳代偿','不如你看看部族里谁需要帮忙吧~这件事就一笔勾销了！','与雪峰狐狸对话',1,6,0,220,0,0,0,0,0,12130,12150,'null','[]','0',100705,0,1908036,0,'[]','[]',0,'[{5,36060001,621763},{3,36030001,10900}]',0,1,1,'[]','[]','[]',1,0,0,0),(12150,'赏金难题','现在的我相当于越级打怪啊~这赏金太诱人了，不能就这样放弃！','与赏金猎人对话',1,6,0,220,0,0,0,0,0,12140,12160,'null','[]','0',100706,0,1908037,0,'[]','[]',0,'[{5,36060001,621763},{3,36030001,11000}]',0,1,1,'[]','[]','[]',1,0,0,0),(12160,'赏金对半','按照约定，赏金我们就五五开了~','击败冰原企鹅',1,6,1,220,0,0,0,0,0,12150,12170,'null','[]','0',100706,0,1908038,0,'[]','[[[\"kill\",\"1\",\"10070005\",\"60\",\"1007\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,621763},{3,36030001,11100}]',0,1,1,'[]','[]','[]',1,0,0,0),(12170,'无名小卒','我只是个无名小卒，我的家族代代相传着一个故事，你想听吗？','与极地哥布林对话',1,6,0,220,0,0,0,0,0,12160,12180,'null','[]','0',100707,0,1908039,0,'[]','[]',0,'[{5,36060001,621763},{3,36030001,11300}]',0,1,1,'[]','[]','[]',1,0,0,0),(12180,'冰原传说','前面有两条岔路，一条通往冰霜泰坦，一条则是通往冰霜巨龙，两条路的尽头都是寒冷与死亡~','与极地哥布林对话',1,6,0,220,0,0,0,0,0,12170,12190,'null','[]','0',100707,0,1908040,0,'[]','[]',0,'[{5,36060001,621763},{3,36030001,11400}]',0,1,1,'[]','[]','[]',1,0,0,0),(12190,'以身犯险','以身犯险，深入腹地','击败冰岩怪',1,6,1,220,0,0,0,0,0,12180,12200,'null','[]','0',0,0,0,0,'[]','[[[\"kill\",\"1\",\"10070006\",\"60\",\"1007\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,621763},{3,36030001,11600}]',0,1,1,'[]','[]','[]',1,0,0,0),(12200,'束手无策','冰霜巨龙，是寒鸦峡谷曾经的霸主，短期内要战胜它还是有点难度的~','与大法师对话',1,6,0,220,0,0,0,0,0,12190,12210,'null','[]','0',100409,0,1908041,0,'[]','[]',0,'[{5,36060001,621763},{3,36030001,11700}]',0,1,1,'[]','[]','[]',1,0,0,0),(12210,'以火化冰','冰霜巨龙的属性可以被火克制，只要我们找到强大的火属性伙伴，一定能够战胜它的！','与通讯员对话',1,6,0,220,0,0,0,0,0,12200,12220,'null','[]','0',100417,0,1908042,0,'[]','[]',0,'[{5,36060001,621763},{3,36030001,11800}]',0,1,1,'[]','[]','[]',1,0,0,0),(12220,'博学长老','想起来我还去过那里，可把我冻坏了，那时我还救了一条小冰龙来着~','与夕树长老对话',1,6,0,220,0,0,0,0,0,12210,12230,'null','[]','0',100601,0,1908043,0,'[]','[]',0,'[{5,36060001,621763},{3,36030001,12000}]',0,1,1,'[]','[]','[]',1,0,0,0),(12230,'制服冰龙','那个孩子只是比较贪吃罢了，或者森林那边的巫婆可以帮个忙~','与夕树长老对话',1,6,0,220,0,0,0,0,0,12220,12240,'null','[]','0',100601,0,1908044,0,'[]','[]',0,'[{5,36060001,621763},{3,36030001,12100}]',0,1,1,'[]','[]','[]',1,0,0,0),(12240,'乱入狼穴','乱入狼穴，只能被迫出手了！','击败丛林狼',1,6,1,230,0,0,0,0,0,12230,12250,'null','[]','0',0,0,0,0,'[]','[[[\"kill\",\"1\",\"10060001\",\"50\",\"1006\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,1311028},{3,36030001,12300}]',0,1,1,'[]','[]','[]',1,0,0,0),(12250,'丛林岔路','你胆子可真大，竟敢独自一人去找巫婆！','与克劳尔对话',1,6,0,230,0,0,0,0,0,12240,12260,'null','[]','0',100604,0,1908045,0,'[]','[]',0,'[{5,36060001,1311028},{3,36030001,12400}]',0,1,1,'[]','[]','[]',1,0,0,0),(12260,'诡异巫婆','不过如果你能帮我弄来几片龙鳞，我还是乐意不计前嫌的~','与巫婆梅尔对话',1,6,0,230,0,0,0,0,0,12250,12270,'null','[]','0',100605,0,1908046,0,'[]','[]',0,'[{5,36060001,1311028},{3,36030001,12500}]',0,1,1,'[]','[]','[]',1,0,0,0),(12270,'妖精之翼','取得妖精的羽翼','击败暗裔妖精',1,6,1,230,0,0,0,0,0,12260,12280,'null','[]','0',0,0,0,0,'[]','[[[\"kill\",\"1\",\"10060002\",\"50\",\"1006\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,1311028},{3,36030001,12700}]',0,1,1,'[]','[]','[]',1,0,0,0),(12280,'食人花瓣','这瓶药你拿去吧！对付龙类可是十分凑效的！','击败食人花',1,6,1,230,0,0,0,0,0,12270,12290,'null','[]','0',100605,0,1908047,0,'[]','[[[\"kill\",\"1\",\"10060003\",\"50\",\"1006\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,1311028},{3,36030001,12800}]',0,1,1,'[]','[]','[]',1,0,0,0),(12290,'二度前往','一路上要小心呀~记得有空多回来看看我们！','与妖精艾利对话',1,6,0,230,0,0,0,0,0,12280,12300,'null','[]','0',100607,0,1908048,0,'[]','[]',0,'[{5,36060001,1311028},{3,36030001,13000}]',0,1,1,'[]','[]','[]',1,0,0,0),(12300,'无脑蜥蜴','唉？我是不是之前在这里见过你，总觉得你像我的孙子~','击败蜥蜴战士',1,6,1,230,0,0,0,0,0,12290,12310,'null','[]','0',100609,0,1908049,0,'[]','[[[\"kill\",\"1\",\"10060005\",\"40\",\"1006\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,1311028},{3,36030001,13100}]',0,1,1,'[]','[]','[]',1,0,0,0),(12310,'事不宜迟','我就知道你一定有办法的，快走吧！','击败岩背龟',1,6,1,230,0,0,0,0,0,12300,12320,'null','[]','0',100613,0,1908050,0,'[]','[[[\"kill\",\"1\",\"10060006\",\"40\",\"1006\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,1311028},{3,36030001,13200}]',0,1,1,'[]','[]','[]',1,0,0,0),(12320,'再临冰原','既然如此，我也不阻拦你了，祝你好运~','与雪原村民对话',1,6,0,230,0,0,0,0,0,12310,12330,'null','[]','0',100701,0,1908051,0,'[]','[]',0,'[{5,36060001,1311028},{3,36030001,13400}]',0,1,1,'[]','[]','[]',1,0,0,0),(12330,'传说验证','验证传说的时候到了，快去吧！冒险者！','与极地哥布林对话',1,6,0,230,0,0,0,0,0,12320,12340,'null','[]','0',100707,0,1908052,0,'[]','[]',0,'[{5,36060001,1311028},{3,36030001,13500}]',0,1,1,'[]','[]','[]',1,0,0,0),(12340,'以身犯险','赶紧解决那条大蜥蜴咱们回去啦！','击败冰岩怪',1,6,1,240,0,0,0,0,0,12330,12350,'null','[]','0',100713,0,1908053,0,'[]','[[[\"kill\",\"1\",\"10070006\",\"65\",\"1007\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,1538294},{3,36030001,13700}]',0,1,1,'[]','[]','[]',1,0,0,0),(12350,'温热牛奶','什么！？你解决完大蜥蜴还要去找酋长？我不管啦！我要回去喝热牛奶了！','与喵队长对话',1,6,0,240,0,0,0,0,0,12340,12360,'null','[]','0',100713,0,1908054,0,'[]','[]',0,'[{5,36060001,1538294},{3,36030001,13800}]',0,1,1,'[]','[]','[]',1,0,0,0),(12360,'冰霜巨龙','我已在此沉睡了数千年，你是除了那个傻大个以外第一个敢喊我起床的人！原来你们这些小矮人并非都是些贪生怕死的蝼蚁~','通关副本',1,6,6,240,0,0,0,0,0,12350,12370,'null','[]','0',100714,0,1908175,0,'[]','[[[\"fin_dungeon\",\"11\",\"10007\",\"1\",\"1007\",\"13700\",\"10200\",\"1\"]]]',0,'[{5,36060001,1538294},{3,36030001,13900}]',0,1,1,'[]','[]','[]',1,10007,0,0),(12370,'雪原英雄','我滴个泰坦呀！你竟然击败了传说中的冰霜巨龙！','与露露提尔对话',1,6,0,240,0,0,0,0,0,12360,12380,'null','[]','0',100709,0,1908055,0,'[]','[]',0,'[{5,36060001,1538294},{3,36030001,14100}]',0,1,1,'[]','[]','[]',1,0,0,0),(12380,'姐妹消息','你是我们雪原的英雄，是两派部族和好的希望呀！','与娜娜提尔对话',1,6,0,240,0,0,0,0,0,12370,12390,'null','[]','0',100710,0,1908056,0,'[]','[]',0,'[{5,36060001,1538294},{3,36030001,14200}]',0,1,1,'[]','[]','[]',1,0,0,0),(12390,'英雄之证','这是我们兽人族的英雄之证，拿着这个去见我们的酋长吧！','采集辉星石',1,6,3,240,0,0,0,0,0,12380,12400,'null','[]','0',100710,0,1908057,0,'[]','[[[\"collect\",\"4\",\"10070021\",\"1\",\"1007\",\"9318\",\"10758\",\"1\"]]]',0,'[{5,36060001,1538294},{3,36030001,14300}]',0,1,1,'[]','[]','[]',1,10070021,0,0),(12400,'冰天雪地','所以我讨厌在这种冰天雪地里出勤任务！','与喵队长对话',1,6,0,240,0,0,0,0,0,12390,12410,'null','[]','0',100713,0,1908058,0,'[]','[]',0,'[{5,36060001,1538294},{3,36030001,14500}]',0,1,1,'[]','[]','[]',1,0,0,0),(12410,'确有其事','原来我们家族代代相传的故事是真的！','击败冰岩怪',1,6,1,240,0,0,0,0,0,12400,12420,'null','[]','0',100707,0,1908059,0,'[]','[[[\"kill\",\"1\",\"10070006\",\"65\",\"1007\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,1538294},{3,36030001,14600}]',0,1,1,'[]','[]','[]',1,0,0,0),(12420,'部族传闻','现在貌似两派暂时缓和了下来，我觉得是你们进行结盟的好时机！','与雪原村民对话',1,6,0,240,0,0,0,0,0,12410,12430,'null','[]','0',100701,0,1908060,0,'[]','[]',0,'[{5,36060001,1538294},{3,36030001,14800}]',0,1,1,'[]','[]','[]',1,0,0,0),(12430,'雪怪泛滥','你击败了冰霜巨龙，其实间接帮助我们部族停止了内乱~','击败雪岩怪',1,6,1,240,0,0,0,0,0,12420,12440,'null','[]','0',100702,0,1908061,0,'[]','[[[\"kill\",\"1\",\"10070002\",\"60\",\"1007\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,1538294},{3,36030001,14900}]',0,1,1,'[]','[]','[]',1,0,0,0),(12440,'部族会议','两派的酋长都召集了部族里的男性去召开会议，你现在去的话或许能赶上~','与雪原村民对话',1,6,0,250,0,0,0,0,0,12430,12450,'null','[]','0',100702,0,1908062,0,'[]','[]',0,'[{5,36060001,1600294},{3,36030001,15000}]',0,1,1,'[]','[]','[]',1,0,0,0),(12450,'会议门票','但是你一个外乡人想参加我们部族的会议，是要买门票的！','与贩鱼企鹅对话',1,6,0,250,0,0,0,0,0,12440,12460,'null','[]','0',100703,0,1908063,0,'[]','[]',0,'[{5,36060001,1600294},{3,36030001,15200}]',0,1,1,'[]','[]','[]',1,0,0,0),(12460,'会议开始','勇者你来得正好，容许我向同胞们介绍一下你~','击败雪原蟹',1,6,1,250,0,0,0,0,0,12450,12470,'null','[]','0',100704,0,1908064,0,'[]','[[[\"kill\",\"1\",\"10070003\",\"60\",\"1007\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,1600294},{3,36030001,15300}]',0,1,1,'[]','[]','[]',1,0,0,0),(12470,'结盟提议','若我们不再联合起来，各种族将会被一一击溃！','与牛头酋长对话',1,6,0,250,0,0,0,0,0,12460,12480,'null','[]','0',100704,0,1908065,0,'[]','[]',0,'[{5,36060001,1600294},{3,36030001,15500}]',0,1,1,'[]','[]','[]',1,0,0,0),(12480,'证明实力','我会在后方给予你们支援的！','击败雪原狼',1,6,1,250,0,0,0,0,0,12470,12490,'null','[]','0',100705,0,1908066,0,'[]','[[[\"kill\",\"1\",\"10070004\",\"65\",\"1007\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,1600294},{3,36030001,15600}]',0,1,1,'[]','[]','[]',1,0,0,0),(12490,'不畏严寒','可别小看了我们兽人族，每个人都是不畏严寒的坚强士兵！','与雪峰狐狸对话',1,6,0,250,0,0,0,0,0,12480,12500,'null','[]','0',100705,0,1908067,0,'[]','[]',0,'[{5,36060001,1600294},{3,36030001,15700}]',0,1,1,'[]','[]','[]',1,0,0,0),(12500,'高额赏金','跟抵抗军结盟之后，或许我就能接到更多赏金任务了！','与赏金猎人对话',1,6,0,250,0,0,0,0,0,12490,12510,'null','[]','0',100706,0,1908068,0,'[]','[]',0,'[{5,36060001,1600294},{3,36030001,15900}]',0,1,1,'[]','[]','[]',1,0,0,0),(12510,'挡道企鹅','击败冰原企鹅','击败冰原企鹅',1,6,1,250,0,0,0,0,0,12500,12520,'null','[]','0',0,0,0,0,'[]','[[[\"kill\",\"1\",\"10070005\",\"65\",\"1007\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,1600294},{3,36030001,16000}]',0,1,1,'[]','[]','[]',1,0,0,0),(12520,'传说延续','虽然我们祖传的传说已经得到了证实，但是我想谱写一段新的传说，关于你的传说！','与极地哥布林对话',1,6,0,250,0,0,0,0,0,12510,12530,'null','[]','0',100707,0,1908069,0,'[]','[]',0,'[{5,36060001,1600294},{3,36030001,16200}]',0,1,1,'[]','[]','[]',1,0,0,0),(12530,'再闯龙穴','别再让我孤独地等待，请给我一杯热牛奶~','击败冰岩怪',1,6,1,250,0,0,0,0,0,12520,12540,'null','[]','0',100713,0,1908070,0,'[]','[[[\"kill\",\"1\",\"10070006\",\"65\",\"1007\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,1600294},{3,36030001,16300}]',0,1,1,'[]','[]','[]',1,0,0,0),(12540,'屠龙勇士','屠龙的少年终为龙，我希望你不是成为那样子的人~','与喵队长对话',1,6,0,260,0,0,0,0,0,12530,12550,'null','[]','0',100713,0,1908071,0,'[]','[]',0,'[{5,36060001,1664794},{3,36030001,16400}]',0,1,1,'[]','[]','[]',1,0,0,0),(12550,'拯救雪原','你就是拯救雪原的英雄！','与露露提尔对话',1,6,0,260,0,0,0,0,0,12540,12560,'null','[]','0',100709,0,1908072,0,'[]','[]',0,'[{5,36060001,1664794},{3,36030001,16600}]',0,1,1,'[]','[]','[]',1,0,0,0),(12560,'前途未卜','不过我们也不能大意，帝国军战力强盛，即便我们联合也是前途未卜……','与露露提尔对话',1,6,0,260,0,0,0,0,0,12550,12570,'null','[]','0',100709,0,1908073,0,'[]','[]',0,'[{5,36060001,1664794},{3,36030001,16700}]',0,1,1,'[]','[]','[]',1,0,0,0),(12570,'临行建议','让我给你一些旅行的建议吧！','与娜娜提尔对话',1,6,0,260,0,0,0,0,0,12560,12580,'null','[]','0',100710,0,1908074,0,'[]','[]',0,'[{5,36060001,1664794},{3,36030001,16900}]',0,1,1,'[]','[]','[]',1,0,0,0),(12580,'星星之火','我听说这雪原之外啊~就是炎热的沙漠了！','采集星晶石',1,6,3,260,0,0,0,0,0,12570,12590,'null','[]','0',100711,0,1908075,0,'[]','[[[\"collect\",\"4\",\"10070021\",\"2\",\"1007\",\"9318\",\"10758\",\"1\"]]]',0,'[{5,36060001,1664794},{3,36030001,17000}]',0,1,1,'[]','[]','[]',1,10070021,0,0),(12590,'长辈指引','别看大叔我好像不中用，我还是能给你一些作为勇者的建议的~','与邻家大叔对话',1,6,0,260,0,0,0,0,0,12580,12600,'null','[]','0',100711,0,1908076,0,'[]','[]',0,'[{5,36060001,1664794},{3,36030001,17100}]',0,1,1,'[]','[]','[]',1,0,0,0),(12600,'冰原狼群','它们是冰原的守望者，战胜了它们，证明你有能力守护这片雪原~','击败冰原狼',1,6,1,260,0,0,0,0,0,12590,12610,'null','[]','0',100712,0,1908077,0,'[]','[[[\"kill\",\"1\",\"10070007\",\"65\",\"1007\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,1664794},{3,36030001,17300}]',0,1,1,'[]','[]','[]',1,0,0,0),(12610,'前往荒漠','去到那边的话小心不要中暑了哦~','与雪地鹿琪儿对话',1,6,0,260,0,0,0,0,0,12600,12620,'null','[]','0',100712,0,1908078,0,'[]','[]',0,'[{5,36060001,1664794},{3,36030001,17400}]',0,1,1,'[]','[]','[]',1,0,0,0),(12620,'风蚀台地','此路由我开，留下买路财！','与沙盗首领对话',1,7,0,260,0,0,0,0,0,12610,12630,'null','[]','0',100801,0,1908079,0,'[]','[]',0,'[{5,36060001,1664794},{3,36030001,17600}]',0,1,1,'[]','[]','[]',1,0,0,0),(12630,'沙盗劫掠','勇者饶命，我们再也不敢了！','击败骷髅士兵',1,7,1,260,0,0,0,0,0,12620,12640,'null','[]','0',100801,0,1908325,0,'[]','[[[\"kill\",\"1\",\"10080001\",\"60\",\"1008\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,1664794},{3,36030001,17700}]',0,1,1,'[]','[]','[]',1,0,0,0),(12640,'佣兵头目','沙漠无情，适者生存，别说沙盗了，是个人都会被这里的环境逼疯的~','与佣兵头目对话',1,7,0,270,0,0,0,0,0,12630,12650,'null','[]','0',100802,0,1908081,0,'[]','[]',0,'[{5,36060001,2325094},{3,36030001,17800}]',0,1,1,'[]','[]','[]',1,0,0,0),(12650,'荒漠怪物','既然你已经解决掉那些怪物了，作为感谢，我会告诉你村庄的位置。','击败沙布林',1,7,1,270,0,0,0,0,0,12640,12660,'null','[]','0',100802,0,1908326,0,'[]','[[[\"kill\",\"1\",\"10080002\",\"60\",\"1008\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,2325094},{3,36030001,18000}]',0,1,1,'[]','[]','[]',1,0,0,0),(12660,'久候多时','你听说过这里曾经有个繁荣的传说王国吗？','与劳伦兹对话',1,7,0,270,0,0,0,0,0,12650,12670,'null','[]','0',100803,0,1908083,0,'[]','[]',0,'[{5,36060001,2325094},{3,36030001,18100}]',0,1,1,'[]','[]','[]',1,0,0,0),(12670,'王朝覆灭','那个覆灭的王朝，据说曾经拥有比肩神力的法老和那珍稀的神器！','与劳伦兹对话',1,7,0,270,0,0,0,0,0,12660,12680,'null','[]','0',100803,0,1908084,0,'[]','[]',0,'[{5,36060001,2325094},{3,36030001,18200}]',0,1,1,'[]','[]','[]',1,0,0,0),(12680,'沙盗恶霸','多谢勇者出手相救，这些沙盗一直都在欺压我们这些平民，粮食淡水经常被那些恶霸抢走了哇！！','击败沙盗',1,7,1,270,0,0,0,0,0,12670,12690,'null','[]','0',100804,0,1908085,0,'[]','[[[\"kill\",\"1\",\"10080003\",\"60\",\"1008\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,2325094},{3,36030001,18400}]',0,1,1,'[]','[]','[]',1,0,0,0),(12690,'平民诉苦','村子里的人半年前就都大部分出走了，剩下的都是老人小孩和妇女，只有少数的男人还坚守在此……','与男平民对话',1,7,0,270,0,0,0,0,0,12680,12700,'null','[]','0',100804,0,1908086,0,'[]','[]',0,'[{5,36060001,2325094},{3,36030001,18500}]',0,1,1,'[]','[]','[]',1,0,0,0),(12700,'掳掠孩童','那些没良心的佣兵把我的孩子掳走了，求求你们救救我的孩子！！','与女平民对话',1,7,0,270,0,0,0,0,0,12690,12710,'null','[]','0',100805,0,1908087,0,'[]','[]',0,'[{5,36060001,2325094},{3,36030001,18700}]',0,1,1,'[]','[]','[]',1,0,0,0),(12710,'邪恶佣兵','请问你有看到我的妈妈嘛？','击败邪恶佣兵',1,7,1,270,0,0,0,0,0,12700,12720,'null','[]','0',100806,0,1908088,0,'[]','[[[\"kill\",\"1\",\"10080004\",\"60\",\"1008\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,2325094},{3,36030001,18800}]',0,1,1,'[]','[]','[]',1,0,0,0),(12720,'天真孩童','这些坏蛋抢走了我们的粮食还有淡水，大坏蛋！！','与村落男孩对话',1,7,0,270,0,0,0,0,0,12710,12730,'null','[]','0',100806,0,1908089,0,'[]','[]',0,'[{5,36060001,2325094},{3,36030001,18900}]',0,1,1,'[]','[]','[]',1,0,0,0),(12730,'粮食淡水','啊~这是之前被抢走的粮食和淡水！这下村子有救了！','采集粮食',1,7,3,270,0,0,0,0,0,12720,12740,'null','[]','0',100805,0,1908091,0,'[]','[[[\"collect\",\"4\",\"10080020\",\"2\",\"1008\",\"4284\",\"12612\",\"1\"]]]',0,'[{5,36060001,2325094},{3,36030001,19100}]',0,1,1,'[]','[]','[]',1,10080020,0,0),(12740,'失落遗迹','不过外乡人不熟悉这边，我还是让一个人为你们带路吧！','与女平民对话',1,7,0,280,0,0,0,0,0,12730,12750,'null','[]','0',100805,0,1908092,0,'[]','[]',0,'[{5,36060001,2887644},{3,36030001,19200}]',0,1,1,'[]','[]','[]',1,0,0,0),(12750,'带路向导','哈哈~感谢你们救了我们的村子，快跟我来，我带你们去找宝藏！','与村落女孩对话',1,7,0,280,0,0,0,0,0,12740,12760,'null','[]','0',100807,0,1908093,0,'[]','[]',0,'[{5,36060001,2887644},{3,36030001,19400}]',0,1,1,'[]','[]','[]',1,0,0,0),(12760,'拦路毒蝎','拦路毒蝎，最为致命~','击败沙漠蝎子',1,7,1,280,0,0,0,0,0,12750,12770,'null','[]','0',0,0,0,0,'[]','[[[\"kill\",\"1\",\"10080005\",\"70\",\"1008\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,2887644},{3,36030001,19500}]',0,1,1,'[]','[]','[]',1,0,0,0),(12770,'少女法老','大胆！见到吾等至高无上的法老，还不跪下！','与少女法老对话',1,7,0,280,0,0,0,0,0,12760,12780,'null','[]','0',100808,0,1908094,0,'[]','[]',0,'[{5,36060001,2887644},{3,36030001,19600}]',0,1,1,'[]','[]','[]',1,0,0,0),(12780,'高傲灵魂','虽然我是法老，但我不可能告诉你们这些刁民任何关于王陵的消息的！','与少女法老对话',1,7,0,280,0,0,0,0,0,12770,12790,'null','[]','0',100808,0,1908095,0,'[]','[]',0,'[{5,36060001,2887644},{3,36030001,19800}]',0,1,1,'[]','[]','[]',1,0,0,0),(12790,'陵墓线索','你手上的东西很别致啊？可以卖给我吗？','采集辉星石',1,7,3,280,0,0,0,0,0,12780,12800,'null','[]','0',100812,0,1908096,0,'[]','[[[\"collect\",\"4\",\"10080021\",\"2\",\"1008\",\"14631\",\"5821\",\"1\"]]]',0,'[{5,36060001,2887644},{3,36030001,19900}]',0,1,1,'[]','[]','[]',1,10080021,0,0),(12800,'王族轶事','怎么可能！法老的王朝在几百年前就覆灭了呀！','与集市少女对话',1,7,0,280,0,0,0,0,0,12790,12810,'null','[]','0',100812,0,1908097,0,'[]','[]',0,'[{5,36060001,2887644},{3,36030001,20100}]',0,1,1,'[]','[]','[]',1,0,0,0),(12810,'震惊之余','如果你说的都是真的话，那么你见到的少女可能是一种幻象或者灵魂。','与埃罗恩大法师对话',1,7,0,280,0,0,0,0,0,12800,12820,'null','[]','0',100409,0,1908098,0,'[]','[]',0,'[{5,36060001,2887644},{3,36030001,20200}]',0,1,1,'[]','[]','[]',1,0,0,0),(12820,'百年历史','你看到的女孩说不定是末代法老的眷族！','与艾斯特洛国王对话',1,7,0,280,0,0,0,0,0,12810,12830,'null','[]','0',100405,0,1908099,0,'[]','[]',0,'[{5,36060001,2887644},{3,36030001,20300}]',0,1,1,'[]','[]','[]',1,0,0,0),(12830,'皆有可能','如果我们能帮助她了却心愿的话……','与康斯坦将军对话',1,7,0,280,0,0,0,0,0,12820,12840,'null','[]','0',100407,0,1908100,0,'[]','[]',0,'[{5,36060001,2887644},{3,36030001,20500}]',0,1,1,'[]','[]','[]',1,0,0,0),(12840,'众望所归','虽然你是个务实的人，但是这次就要看你能不能取得那位少女的信任了~','与劳伦兹对话',1,7,0,290,0,0,0,0,0,12830,12850,'null','[]','0',100403,0,1908101,0,'[]','[]',0,'[{5,36060001,3652444},{3,36030001,20600}]',0,1,1,'[]','[]','[]',1,0,0,0),(12850,'抢夺路财','勇者饶命啊！我们也只是混口饭吃而已啊！','击败骷髅士兵',1,7,1,290,0,0,0,0,0,12840,12860,'null','[]','0',100801,0,1908102,0,'[]','[[[\"kill\",\"1\",\"10080001\",\"70\",\"1008\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,3652444},{3,36030001,20800}]',0,1,1,'[]','[]','[]',1,0,0,0),(12860,'黄沙漫天','弥漫的黄沙越来越多，沙尘暴风应该快要来了，抓紧时间！','击败沙布林',1,7,1,290,0,0,0,0,0,12850,12870,'null','[]','0',100803,0,1908103,0,'[]','[[[\"kill\",\"1\",\"10080002\",\"70\",\"1008\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,3652444},{3,36030001,20900}]',0,1,1,'[]','[]','[]',1,0,0,0),(12870,'趁乱打劫','勇者！那群佣兵不知道为什么突然袭击了村子，沙尘暴又快来了，这该如何是好！','与男平民对话',1,7,0,290,0,0,0,0,0,12860,12880,'null','[]','0',100804,0,1908104,0,'[]','[]',0,'[{5,36060001,3652444},{3,36030001,21000}]',0,1,1,'[]','[]','[]',1,0,0,0),(12880,'蛊惑人心','沙尘暴就要来了！','击败邪恶佣兵',1,7,1,290,0,0,0,0,0,12870,12890,'null','[]','0',100805,0,1908105,0,'[]','[[[\"kill\",\"1\",\"10080004\",\"70\",\"1008\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,3652444},{3,36030001,21200}]',0,1,1,'[]','[]','[]',1,0,0,0),(12890,'遵守约定','勇者你一定要平安无事地回来啊！','与村落女孩对话',1,7,0,290,0,0,0,0,0,12880,12900,'null','[]','0',100807,0,1908106,0,'[]','[]',0,'[{5,36060001,3652444},{3,36030001,21300}]',0,1,1,'[]','[]','[]',1,0,0,0),(12900,'引诱圈套','你这家伙，到底是什么人，为什么要阻挠我的计划！','击败沙漠蝎子',1,7,1,290,0,0,0,0,0,12890,12910,'null','[]','0',100808,0,1908107,0,'[]','[[[\"kill\",\"1\",\"10080005\",\"70\",\"1008\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,3652444},{3,36030001,21500}]',0,1,1,'[]','[]','[]',1,0,0,0),(12910,'永生执念','我所做的一切都是为了复活梅杰德大人','与少女法老对话',1,7,0,290,0,0,0,0,0,12900,12920,'null','[]','0',100808,0,1908108,0,'[]','[]',0,'[{5,36060001,3652444},{3,36030001,21600}]',0,1,1,'[]','[]','[]',1,0,0,0),(12920,'传达旨意','收集足够的东西就前来遗迹的祭坛这里来吧','与集市少女对话',1,7,0,290,0,0,0,0,0,12910,12930,'null','[]','0',100812,0,1908109,0,'[]','[]',0,'[{5,36060001,3652444},{3,36030001,21700}]',0,1,1,'[]','[]','[]',1,0,0,0),(12930,'神情恍惚','感觉有一瞬间我的灵魂被掏空了一般……','采集辉星石',1,7,3,290,0,0,0,0,0,12920,12940,'null','[]','0',100812,0,1908110,0,'[]','[[[\"collect\",\"4\",\"10080021\",\"2\",\"1008\",\"14631\",\"5821\",\"1\"]]]',0,'[{5,36060001,3652444},{3,36030001,21900}]',0,1,1,'[]','[]','[]',1,10080021,0,0),(12940,'村落大叔','刚才那场沙尘暴真是吓死我了，还以为要被活埋了！','与村落大叔对话',1,7,0,300,0,0,0,0,0,12930,12950,'null','[]','0',100809,0,1908111,0,'[]','[]',0,'[{5,36060001,4658680},{3,36030001,22000}]',0,1,1,'[]','[]','[]',1,0,0,0),(12950,'沙漠巨蜥','不好意思，我又犯迷糊了，我们刚才说到哪了？','击败沙漠蜥蜴',1,7,1,300,0,0,0,0,0,12940,12960,'null','[]','0',100810,0,1908112,0,'[]','[[[\"kill\",\"1\",\"10080006\",\"75\",\"1008\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,4658680},{3,36030001,22100}]',0,1,1,'[]','[]','[]',1,0,0,0),(12960,'前往祭坛','只要沿着路一直走，就是遗迹的祭坛了','与抵抗军干部对话',1,7,0,300,0,0,0,0,0,12950,12970,'null','[]','0',100810,0,1908113,0,'[]','[]',0,'[{5,36060001,4658680},{3,36030001,22300}]',0,1,1,'[]','[]','[]',1,0,0,0),(12970,'祭坛守卫','根据可靠的情报，前面就是我们要找的祭坛了~','击败骷髅守卫',1,7,1,300,0,0,0,0,0,12960,12980,'null','[]','0',100813,0,1908114,0,'[]','[[[\"kill\",\"1\",\"10080007\",\"75\",\"1008\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,4658680},{3,36030001,22400}]',0,1,1,'[]','[]','[]',1,0,0,0),(12980,'额外情报','开战前记得帮我问下哈！','与通讯员对话',1,7,0,300,0,0,0,0,0,12970,12990,'null','[]','0',100813,0,1908115,0,'[]','[]',0,'[{5,36060001,4658680},{3,36030001,22600}]',0,1,1,'[]','[]','[]',1,0,0,0),(12990,'威严死神','纵使王朝倾覆，生死轮回也不会停止，凡人啊~你的道路能走多远呢？','击败阿努比斯',1,7,6,300,0,0,0,0,0,12980,13000,'null','[]','0',100820,0,1908173,0,'[]','[[[\"fin_dungeon\",\"11\",\"10008\",\"1\",\"1008\",\"11247\",\"12750\",\"1\"]]]',0,'[{5,36060001,4658680},{3,36030001,22700}]',0,1,1,'[]','[]','[]',1,10008,0,0),(13000,'台地终点','想不到当初那个乳臭未干的小鬼，也能走到这一步了~','击败蜥蜴战士',1,7,1,300,0,0,0,0,0,12990,13010,'null','[]','0',100811,0,1908116,0,'[]','[[[\"kill\",\"1\",\"10080008\",\"70\",\"1008\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,4658680},{3,36030001,22800}]',0,1,1,'[{0,0,54010001,3}]','[]','[]',1,0,0,0),(13010,'绝处逢生','前面就是帝国军进行恶魔实验的地方了！','与喵队长对话',1,7,0,300,0,0,0,0,0,13000,13020,'null','[]','0',100811,0,1908117,0,'[]','[]',0,'[{5,36060001,4658680},{3,36030001,23000}]',0,1,1,'[]','[]','[]',1,0,0,0),(13020,'暗裔秘所','你该不会是帝国军新造的仿生人吧？好逼真哦！','与机械师安娜对话',1,8,0,310,0,0,0,0,0,13010,13030,'null','[]','0',100901,0,1908118,0,'[]','[]',0,'[{5,36060001,5546244},{3,36030001,23100}]',0,1,1,'[]','[]','[]',1,0,0,0),(13030,'见怪不怪','抵抗军？没听说过','与机械师安娜对话',1,8,0,310,0,0,0,0,0,13020,13040,'null','[]','0',100901,0,1908119,0,'[]','[]',0,'[{5,36060001,5546244},{3,36030001,23300}]',0,1,1,'[]','[]','[]',1,0,0,0),(13040,'闪亮杰作','闪亮和安娜……被囚禁……不开心……','与闪亮杰作对话',1,8,0,310,0,0,0,0,0,13030,13050,'null','[]','0',100902,0,1908120,0,'[]','[]',0,'[{5,36060001,5546244},{3,36030001,23400}]',0,1,1,'[]','[]','[]',1,0,0,0),(13050,'报废机器','别大声嚷嚷！你这样会把那些铁罐头引过来的！','消灭报废机器人',1,8,1,310,0,0,0,0,0,13040,13060,'null','[]','0',100903,0,1908121,0,'[]','[[[\"kill\",\"1\",\"10090001\",\"75\",\"1009\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,5546244},{3,36030001,23500}]',0,1,1,'[]','[]','[]',1,0,0,0),(13060,'隐藏气息','蛮冲直撞不能解决所有的情况，你要学会隐藏自己的气息，然后观察情况！','与科哈特对话',1,8,0,310,0,0,0,0,0,13050,13070,'null','[]','0',100903,0,1908122,0,'[]','[]',0,'[{5,36060001,5546244},{3,36030001,23700}]',0,1,1,'[]','[]','[]',1,0,0,0),(13070,'循声而来','刚才那些都是我研制的机械犬，怎么样，酷炫不酷炫？','击败机械犬',1,8,1,310,0,0,0,0,0,13060,13080,'null','[]','0',100904,0,1908123,0,'[]','[[[\"kill\",\"1\",\"10090002\",\"75\",\"1009\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,5546244},{3,36030001,23800}]',0,1,1,'[]','[]','[]',1,0,0,0),(13080,'疯狂伯爵','如果能够将犬类的灵活结合机械的杀伤力，哦，那该多么美妙~','与比尔德伯爵对话',1,8,0,310,0,0,0,0,0,13070,13090,'null','[]','0',100904,0,1908124,0,'[]','[]',0,'[{5,36060001,5546244},{3,36030001,24000}]',0,1,1,'[]','[]','[]',1,0,0,0),(13090,'机械零件','采集机械零件','采集机械零件',1,8,3,310,0,0,0,0,0,13080,13100,'null','[]','0',0,0,0,0,'[]','[[[\"collect\",\"4\",\"10090020\",\"2\",\"1009\",\"2410\",\"12209\",\"1\"]]]',0,'[{5,36060001,5546244},{3,36030001,24100}]',0,1,1,'[]','[]','[]',1,10090020,0,0),(13100,'刻薄老头','这几个破零件就想收买我了吗！？','与武器匠对话',1,8,0,310,0,0,0,0,0,13090,13110,'null','[]','0',100905,0,1908125,0,'[]','[]',0,'[{5,36060001,5546244},{3,36030001,24200}]',0,1,1,'[]','[]','[]',1,0,0,0),(13110,'要求严格','你这身烂装备就想对付帝国军那些装备精良的钢铁军团吗！？','与武器匠对话',1,8,0,310,0,0,0,0,0,13100,13120,'null','[]','0',100905,0,1908126,0,'[]','[]',0,'[{5,36060001,5546244},{3,36030001,24400}]',0,1,1,'[]','[]','[]',1,0,0,0),(13120,'帝国军团','虽然很吃力，但是你已经做的很不错了！','击败帝国步兵',1,8,1,320,0,0,0,0,0,13110,13130,'null','[]','0',100906,0,1908127,0,'[]','[[[\"kill\",\"1\",\"10090003\",\"75\",\"1009\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,7867794},{3,36030001,24500}]',0,1,1,'[]','[]','[]',1,0,0,0),(13130,'深入敌营','接下来我们就要深入敌营了，这意味着会面临更加危险的敌人！','与抵抗军干部对话',1,8,0,320,0,0,0,0,0,13120,13140,'null','[]','0',100906,0,1908128,0,'[]','[]',0,'[{5,36060001,7867794},{3,36030001,24700}]',0,1,1,'[]','[]','[]',1,0,0,0),(13140,'临阵逃脱','恶魔！是恶魔！！啊！！不要过来啊！！！','与懦弱士兵对话',1,8,0,320,0,0,0,0,0,13130,13150,'null','[]','0',100907,0,1908129,0,'[]','[]',0,'[{5,36060001,7867794},{3,36030001,24800}]',0,1,1,'[]','[]','[]',1,0,0,0),(13150,'巡逻哨兵','前往为禁区，请出示通行证和验证码！','击败机动巡逻兵',1,8,1,320,0,0,0,0,0,13140,13160,'null','[]','0',100908,0,1908130,0,'[]','[[[\"kill\",\"1\",\"10090004\",\"80\",\"1009\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,7867794},{3,36030001,24900}]',0,1,1,'[]','[]','[]',1,0,0,0),(13160,'认证失败','认证失败！检测到入侵者！','与废旧机器人对话',1,8,0,320,0,0,0,0,0,13150,13170,'null','[]','0',100908,0,1908131,0,'[]','[]',0,'[{5,36060001,7867794},{3,36030001,25100}]',0,1,1,'[]','[]','[]',1,0,0,0),(13170,'恶魔实验','喵喵喵~大难不死必有后患！','击败恶魔幼体',1,8,1,320,0,0,0,0,0,13160,13180,'null','[]','0',100909,0,1908132,0,'[]','[[[\"kill\",\"1\",\"10090005\",\"80\",\"1009\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,7867794},{3,36030001,25200}]',0,1,1,'[]','[]','[]',1,0,0,0),(13180,'必有后患','这个恶魔不是我们能对付的喵呜！','与喵队长对话',1,8,0,320,0,0,0,0,0,13170,13190,'null','[]','0',100909,0,1908133,0,'[]','[]',0,'[{5,36060001,7867794},{3,36030001,25400}]',0,1,1,'[]','[]','[]',1,0,0,0),(13190,'恶魔骑士','我未能誓守的诺言，就托付给你了~这样一来，也许我的灵魂也能得到救赎！','击败恶魔骑士',1,8,6,320,0,0,0,0,0,13180,13200,'null','[]','0',100920,0,1908174,0,'[]','[[[\"fin_dungeon\",\"11\",\"10009\",\"1\",\"1009\",\"12450\",\"9150\",\"1\"]]]',0,'[{5,36060001,7867794},{3,36030001,25500}]',0,1,1,'[]','[]','[]',1,10009,0,0),(13200,'走为上计','三十六计走为上计！快把我抱起来，然后撒丫子跑呀喵呜！！','与喵队长对话',1,8,0,320,0,0,0,0,0,13190,13210,'null','[]','0',100909,0,1908134,0,'[]','[]',0,'[{5,36060001,7867794},{3,36030001,25600}]',0,1,1,'[]','[]','[]',1,0,0,0),(13210,'通讯失效','通讯貌似被某些东西屏蔽了，现在无法联络到洛亚王城那边！','与通讯员对话',1,8,0,320,0,0,0,0,0,13200,13220,'null','[]','0',100910,0,1908135,0,'[]','[]',0,'[{5,36060001,7867794},{3,36030001,25800}]',0,1,1,'[]','[]','[]',1,0,0,0),(13220,'破烂机器','嘿！这边儿~快跟我来！','击败破烂机器人',1,8,1,330,0,0,0,0,0,13210,13330,'null','[]','0',100911,0,1908136,0,'[]','[[[\"kill\",\"1\",\"10090006\",\"80\",\"1009\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,8341594},{3,36030001,25900}]',0,1,1,'[]','[]','[]',1,0,0,0),(13230,'伸出援手','重新介绍一下吧~我是机械师安娜，是被帝国军软禁的技术宅！','与机械师安娜对话',1,8,0,330,0,0,0,0,0,13220,13240,'null','[]','0',100911,0,1908137,0,'[]','[]',0,'[{5,36060001,8341594},{3,36030001,26000}]',0,1,1,'[]','[]','[]',1,0,0,0),(13240,'传输情报','你们之后准备好相应的对策再来吧！','与机械师安娜对话',1,8,0,330,0,0,0,0,0,13230,13250,'null','[]','0',100901,0,1908138,0,'[]','[]',0,'[{5,36060001,8341594},{3,36030001,26200}]',0,1,1,'[]','[]','[]',1,0,0,0),(13250,'形势严峻','这是一张设计图！得快点找到专业人士解读才行！','与通讯员对话',1,8,0,330,0,0,0,0,0,13240,13260,'null','[]','0',100417,0,1908139,0,'[]','[]',0,'[{5,36060001,8341594},{3,36030001,26300}]',0,1,1,'[]','[]','[]',1,0,0,0),(13260,'专业人士','快！快拿给巴雷特看看！','与艾斯特洛国王对话',1,8,0,330,0,0,0,0,0,13250,13270,'null','[]','0',100405,0,1908140,0,'[]','[]',0,'[{5,36060001,8341594},{3,36030001,26500}]',0,1,1,'[]','[]','[]',1,0,0,0),(13270,'见多识广','想当年我那个痴迷机械的挚友，可没给我少看他那些设计图~','与巴雷特大臣对话',1,8,0,330,0,0,0,0,0,13260,13280,'null','[]','0',100406,0,1908141,0,'[]','[]',0,'[{5,36060001,8341594},{3,36030001,26600}]',0,1,1,'[]','[]','[]',1,0,0,0),(13280,'再入险境','所以只能再冒险一次，找到那位能解读这个设计图的人！','与劳伦兹对话',1,8,0,330,0,0,0,0,0,13270,13290,'null','[]','0',100403,0,1908142,0,'[]','[]',0,'[{5,36060001,8341594},{3,36030001,26700}]',0,1,1,'[]','[]','[]',1,0,0,0),(13290,'明知危难','哎？你怎么又带着这个回来了呀！？','与机械师安娜对话',1,8,0,330,0,0,0,0,0,13280,13300,'null','[]','0',100901,0,1908143,0,'[]','[]',0,'[{5,36060001,8341594},{3,36030001,26900}]',0,1,1,'[]','[]','[]',1,0,0,0),(13300,'戒备森严','还想像上次那样进出自如是不可能的了！','与机械师安娜对话',1,8,0,330,0,0,0,0,0,13290,13310,'null','[]','0',100901,0,1908144,0,'[]','[]',0,'[{5,36060001,8341594},{3,36030001,27000}]',0,1,1,'[]','[]','[]',1,0,0,0),(13310,'搜集零件','有这些零件的话至少能够做把像样的武器了！','击败破烂机器人',1,8,1,330,0,0,0,0,0,13300,13320,'null','[]','0',100911,0,1908145,0,'[]','[[[\"kill\",\"1\",\"10090006\",\"80\",\"1009\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,8341594},{3,36030001,27200}]',0,1,1,'[]','[]','[]',1,0,0,0),(13320,'暴露行踪','你们动作小一点儿~不要暴露我的行踪！','与科哈特对话',1,8,0,340,0,0,0,0,0,13310,13330,'null','[]','0',100912,0,1908146,0,'[]','[]',0,'[{5,36060001,11167644},{3,36030001,27300}]',0,1,1,'[]','[]','[]',1,0,0,0),(13330,'坏狗挡道','坏狗挡道，祸不单行','击败机械狗',1,8,1,340,0,0,0,0,0,13320,13340,'null','[]','0',0,0,0,0,'[]','[[[\"kill\",\"1\",\"10090007\",\"80\",\"1009\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,11167644},{3,36030001,27400}]',0,1,1,'[]','[]','[]',1,0,0,0),(13340,'寻人启事','你们要找的人该不会就是我遇到的那个吧？','与科哈特对话',1,8,0,340,0,0,0,0,0,13330,13350,'null','[]','0',100912,0,1908147,0,'[]','[]',0,'[{5,36060001,11167644},{3,36030001,27600}]',0,1,1,'[]','[]','[]',1,0,0,0),(13350,'留守阵地','这里的地图数据我已经上传到闪亮杰作的存储器里了，他会为你们带路的！','与机械师安娜对话',1,8,0,340,0,0,0,0,0,13340,13360,'null','[]','0',100911,0,1908148,0,'[]','[]',0,'[{5,36060001,11167644},{3,36030001,27700}]',0,1,1,'[]','[]','[]',1,0,0,0),(13360,'人工智能','闪亮~会带你们找到~的！','与闪亮杰作对话',1,8,0,340,0,0,0,0,0,13350,13370,'null','[]','0',100902,0,1908149,0,'[]','[]',0,'[{5,36060001,11167644},{3,36030001,27900}]',0,1,1,'[]','[]','[]',1,0,0,0),(13370,'蜂拥而至','避免一些无谓的动作，这样可以节省体力！','击败废旧机器人',1,8,1,340,0,0,0,0,0,13360,13380,'null','[]','0',100903,0,1908150,0,'[]','[[[\"kill\",\"1\",\"10090001\",\"80\",\"1009\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,11167644},{3,36030001,28000}]',0,1,1,'[]','[]','[]',1,0,0,0),(13380,'争分夺秒','这些铁罐子不久后就会恢复过来的，十分棘手！','与科哈特对话',1,8,0,340,0,0,0,0,0,13370,13390,'null','[]','0',100903,0,1908151,0,'[]','[]',0,'[{5,36060001,11167644},{3,36030001,28100}]',0,1,1,'[]','[]','[]',1,0,0,0),(13390,'恶犬注意','看来这次我的机械犬还是不能通过测试啊！','击败机械犬',1,8,1,340,0,0,0,0,0,13380,13400,'null','[]','0',100904,0,1908152,0,'[]','[[[\"kill\",\"1\",\"10090002\",\"80\",\"1009\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,11167644},{3,36030001,28300}]',0,1,1,'[]','[]','[]',1,0,0,0),(13400,'所寻之人','哼~我以为那家伙把我忘了，没想到是他让你们来找我的','与比尔德伯爵对话',1,8,0,340,0,0,0,0,0,13390,13410,'null','[]','0',100904,0,1908153,0,'[]','[]',0,'[{5,36060001,11167644},{3,36030001,28400}]',0,1,1,'[]','[]','[]',1,0,0,0),(13410,'火爆脾气','既然要走，就在这里大闹一场，留下点纪念吧！','与武器匠对话',1,8,0,340,0,0,0,0,0,13400,13420,'null','[]','0',100905,0,1908154,0,'[]','[]',0,'[{5,36060001,11167644},{3,36030001,28600}]',0,1,1,'[]','[]','[]',1,0,0,0),(13420,'步兵军团','让帝国军见识下我们抵抗军的厉害！','击败帝国步兵',1,8,1,350,0,0,0,0,0,13410,13430,'null','[]','0',100906,0,1908155,0,'[]','[[[\"kill\",\"1\",\"10090003\",\"80\",\"1009\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,14995944},{3,36030001,28700}]',0,1,1,'[]','[]','[]',1,0,0,0),(13430,'大闹秘所','这里就交给我，你快去突围！','与抵抗军干部对话',1,8,0,350,0,0,0,0,0,13420,13440,'null','[]','0',100906,0,1908156,0,'[]','[]',0,'[{5,36060001,14995944},{3,36030001,28800}]',0,1,1,'[]','[]','[]',1,0,0,0),(13440,'突出重围','侦测到入侵者，侦测到入侵者！','击败机动巡逻兵',1,8,1,350,0,0,0,0,0,13430,13450,'null','[]','0',100908,0,1908157,0,'[]','[[[\"kill\",\"1\",\"10090004\",\"85\",\"1009\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,14995944},{3,36030001,29000}]',0,1,1,'[]','[]','[]',1,0,0,0),(13450,'报废处理','无法对入侵者造成可观伤害，即将启动自爆程序！','与废旧机器人对话',1,8,0,350,0,0,0,0,0,13440,13460,'null','[]','0',100908,0,1908158,0,'[]','[]',0,'[{5,36060001,14995944},{3,36030001,29100}]',0,1,1,'[]','[]','[]',1,0,0,0),(13460,'喵喵作战','喵呜~经过我的深思熟虑，我决定我们还是撒丫子跑吧！','与喵队长对话',1,8,1,350,0,0,0,0,0,13450,13470,'null','[]','0',100909,0,1908159,0,'[]','[[[\"kill\",\"1\",\"10090005\",\"85\",\"1009\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,14995944},{3,36030001,29300}]',0,1,1,'[]','[]','[]',1,0,0,0),(13470,'数据传输','很好~战斗数据已经传输完毕，干得漂亮！','与通讯员对话',1,8,0,350,0,0,0,0,0,13460,13480,'null','[]','0',100910,0,1908160,0,'[]','[]',0,'[{5,36060001,14995944},{3,36030001,29400}]',0,1,1,'[]','[]','[]',1,0,0,0),(13480,'最后防线','闪亮觉得~你很~强！','击败帝国士兵',1,8,1,350,0,0,0,0,0,13470,13490,'null','[]','0',100913,0,1908161,0,'[]','[[[\"kill\",\"1\",\"10090008\",\"85\",\"1009\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,14995944},{3,36030001,29500}]',0,1,1,'[]','[]','[]',1,0,0,0),(13490,'名副其实','闪亮~得到安娜以外的人~认可~很开心！很开心！！','与闪亮杰作对话',1,8,0,350,0,0,0,0,0,13480,13500,'null','[]','0',100913,0,1908162,0,'[]','[]',0,'[{5,36060001,14995944},{3,36030001,29700}]',0,1,1,'[]','[]','[]',1,0,0,0),(13500,'凯旋物品','采集辉星石','采集辉星石',1,8,3,350,0,0,0,0,0,13490,13510,'null','[]','0',0,0,0,0,'[]','[[[\"collect\",\"4\",\"10090021\",\"2\",\"1009\",\"11216\",\"5707\",\"1\"]]]',0,'[{5,36060001,14995944},{3,36030001,29800}]',0,1,1,'[]','[]','[]',1,10090021,0,0),(13510,'前路漫漫','一定要赶在帝国军之前，不然这个大陆就没救了~','与抵抗军干部对话',1,8,0,350,0,0,0,0,0,13500,13520,'null','[]','0',100914,0,1908163,0,'[]','[]',0,'[{5,36060001,14995944},{3,36030001,29900}]',0,1,1,'[]','[]','[]',1,0,0,0),(13520,'孤注一掷','大家的希望就在我们身上了~尽力而为吧！','与抵抗军干部对话',1,8,0,360,0,0,0,0,0,13510,13530,'null','[]','0',100914,0,1908164,0,'[]','[]',0,'[{5,36060001,28785806},{3,36030001,30100}]',0,1,1,'[]','[]','[]',1,0,0,0),(13530,'劫后余生','你……你没事就好~我……我叫忒缇丝。','与酒桶船长对话',1,8,0,360,0,0,0,0,0,13520,13540,'null','[]','0',101001,0,1908165,0,'[]','[]',0,'[{5,36060001,28785806},{3,36030001,30200}]',0,1,1,'[]','[]','[]',1,0,0,0),(13540,'社交恐惧','因为我是人鱼，所以我的尾巴……天生就是这样的~很奇怪……是吗？','与人鱼对话',1,9,0,360,0,0,0,0,0,13530,13550,'null','[]','0',101001,0,1908281,0,'[]','[]',0,'[{5,36060001,28785806},{3,36030001,30400}]',0,1,1,'[]','[]','[]',1,0,0,0),(13550,'海拉一族','哪里来的人类？不许再往前走了！','与海拉战士对话',1,9,0,360,0,0,0,0,0,13540,13560,'null','[]','0',101002,0,1908282,0,'[]','[]',0,'[{5,36060001,28785806},{3,36030001,30500}]',0,1,1,'[]','[]','[]',1,0,0,0),(13560,'海拉战士','击败海拉战士，必须见到亚特兰蒂斯背后的统领。','击败海拉战士',1,9,1,360,0,0,0,0,0,13550,13570,'null','[]','0',0,0,0,0,'[]','[[[\"kill\",\"1\",\"10100001\",\"90\",\"1010\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,28785806},{3,36030001,30600}]',0,1,1,'[]','[]','[]',1,0,0,0),(13570,'选召之人','啊啦啊啦~你就是被选召的勇者~和我想象中的不太一样。','与巨蟹座对话',1,9,0,360,0,0,0,0,0,13560,13580,'null','[]','0',101003,0,1908283,0,'[]','[]',0,'[{5,36060001,28785806},{3,36030001,30800}]',0,1,1,'[]','[]','[]',1,0,0,0),(13580,'黄道之力','只要能够集齐我们星灵姐妹，也就是黄道12宫星灵的力量，相信一定可以和暗裔抗衡的！','与巨蟹座对话',1,9,0,360,0,0,0,0,0,13570,13590,'null','[]','0',101003,0,1908284,0,'[]','[]',0,'[{5,36060001,28785806},{3,36030001,30900}]',0,1,1,'[]','[]','[]',1,0,0,0),(13590,'深海王蟹','深海里也有凶悍的生物，不可掉以轻心！','击败深海蟹',1,9,1,360,0,0,0,0,0,13580,13600,'null','[]','0',0,0,0,0,'[]','[[[\"kill\",\"1\",\"10100002\",\"90\",\"1010\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,28785806},{3,36030001,31100}]',0,1,1,'[]','[]','[]',1,0,0,0),(13600,'深海果实','虽然是深海，但是却与陆地上没有区别，简直就像是固有的特殊领域一样！','采集海蓝果',1,9,3,360,0,0,0,0,0,13590,13610,'null','[]','0',101014,0,1908285,0,'[]','[[[\"collect\",\"4\",\"10100020\",\"1\",\"1010\",\"7075\",\"5835\",\"1\"]]]',0,'[{5,36060001,28785806},{3,36030001,31200}]',0,1,1,'[]','[]','[]',1,10100020,0,0),(13610,'深海探险','既然已经到了这里，就必须想办法离开才行，否则帝国军会赶在我们前面的！','与莱克斯对话',1,9,0,360,0,0,0,0,0,13600,13620,'null','[]','0',101014,0,1908286,0,'[]','[]',0,'[{5,36060001,28785806},{3,36030001,31300}]',0,1,1,'[]','[]','[]',1,0,0,0),(13620,'深海路霸','臭小鬼，把你剁成肉酱应该很好吃吧？','与鲨鱼对话',1,9,0,370,0,0,0,0,0,13610,13630,'null','[]','0',101004,0,1908287,0,'[]','[]',0,'[{5,36060001,42760806},{3,36030001,31500}]',0,1,1,'[]','[]','[]',1,0,0,0),(13630,'嗜血海兽','嗜血的鲨鱼，成群结队，令人生畏！','击败深海鲨鱼',1,9,1,370,0,0,0,0,0,13620,13640,'null','[]','0',0,0,0,0,'[]','[[[\"kill\",\"1\",\"10100003\",\"90\",\"1010\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,42760806},{3,36030001,31600}]',0,1,1,'[]','[]','[]',1,0,0,0),(13640,'深海刺客','那些直男战士居然还拦不住你这个臭小鬼，看来还是要我们娘子兵出战了！','与海拉刺客对话',1,9,0,370,0,0,0,0,0,13630,13650,'null','[]','0',101005,0,1908288,0,'[]','[]',0,'[{5,36060001,42760806},{3,36030001,31800}]',0,1,1,'[]','[]','[]',1,0,0,0),(13650,'海拉刺客','毫不逊色于男性战士的武力，不可大意！','击败海拉刺客',1,9,1,370,0,0,0,0,0,13640,13660,'null','[]','0',0,0,0,0,'[]','[[[\"kill\",\"1\",\"10100004\",\"90\",\"1010\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,42760806},{3,36030001,31900}]',0,1,1,'[]','[]','[]',1,0,0,0),(13660,'水母少女','哈啊啊啊~~嗯~~哎？你是来干嘛的？','与水母少女对话',1,9,0,370,0,0,0,0,0,13650,13670,'null','[]','0',101006,0,1908289,0,'[]','[]',0,'[{5,36060001,42760806},{3,36030001,32000}]',0,1,1,'[]','[]','[]',1,0,0,0),(13670,'失落之海','这里本来就不是你们这些人该来的地方，波塞冬等下要生气了，你们就没办法离开了！','与水母少女对话',1,9,0,370,0,0,0,0,0,13660,13680,'null','[]','0',101006,0,1908290,0,'[]','[]',0,'[{5,36060001,42760806},{3,36030001,32200}]',0,1,1,'[]','[]','[]',1,0,0,0),(13680,'深海蜥蜴','深海潜伏的蜥蜴，危险而致命，不可轻敌！','击败海蜥蜴',1,9,1,370,0,0,0,0,0,13670,13690,'null','[]','0',0,0,0,0,'[]','[[[\"kill\",\"1\",\"10100005\",\"90\",\"1010\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,42760806},{3,36030001,32300}]',0,1,1,'[]','[]','[]',1,0,0,0),(13690,'深海情报','根据深海石板上的记载，亚特兰蒂斯是由海王统领着，不过具体的谈判还是要靠我们自己了~','与露易丝对话',1,9,0,370,0,0,0,0,0,13680,13700,'null','[]','0',101007,0,1908291,0,'[]','[]',0,'[{5,36060001,42760806},{3,36030001,32500}]',0,1,1,'[]','[]','[]',1,0,0,0),(13700,'海底传说','据说亚特兰蒂斯曾是大陆上繁荣的王朝，但是因为不知名的原因而沉没到了海底，成了现在这副模样。','与露易丝对话',1,9,0,370,0,0,0,0,0,13690,13710,'null','[]','0',101007,0,1908292,0,'[]','[]',0,'[{5,36060001,42760806},{3,36030001,32600}]',0,1,1,'[]','[]','[]',1,0,0,0),(13710,'星辰大海','我们的征途可是星辰大海啊！','与船长对话',1,9,0,370,0,0,0,0,0,13700,13720,'null','[]','0',101008,0,1908293,0,'[]','[]',0,'[{5,36060001,42760806},{3,36030001,32700}]',0,1,1,'[]','[]','[]',1,0,0,0),(13720,'徒劳无功','我劝你还是放弃吧，即便你见到了我们的王，他也不会让你们全身而退的！','与海拉战士对话',1,9,0,380,0,0,0,0,0,13710,13730,'null','[]','0',101009,0,1908294,0,'[]','[]',0,'[{5,36060001,45735806},{3,36030001,32900}]',0,1,1,'[]','[]','[]',1,0,0,0),(13730,'极力阻挠','虽然我不想打击你的自信，但是这里毕竟是人家的地盘，我们只能逆来顺受了。','击败海拉战士',1,9,1,380,0,0,0,0,0,13720,13740,'null','[]','0',101010,0,1908295,0,'[]','[[[\"kill\",\"1\",\"10100006\",\"90\",\"1010\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,45735806},{3,36030001,33000}]',0,1,1,'[{0,0,16040101,1}]','[]','[]',1,0,0,0),(13740,'失落海神','如今你们知晓了秘密，就休想离开！','与海王对话',1,9,0,380,0,0,0,0,0,13730,13750,'null','[]','0',101011,0,1908296,0,'[]','[]',0,'[{5,36060001,45735806},{3,36030001,33100}]',0,1,1,'[]','[]','[]',1,0,0,0),(13750,'另辟蹊径','在亚特兰蒂斯没有例外，除非……除非你能找到那两件物品~','与海王对话',1,9,0,380,0,0,0,0,0,13740,13760,'null','[]','0',101011,0,1908297,0,'[]','[]',0,'[{5,36060001,45735806},{3,36030001,33300}]',0,1,1,'[]','[]','[]',1,0,0,0),(13760,'海神起源','关于海神的传说？我一时半会儿没办法全部整理给你呢~你稍后再来找我吧~','与朵萝丝对话',1,9,0,380,0,0,0,0,0,13750,13770,'null','[]','0',100414,0,1908298,0,'[]','[]',0,'[{5,36060001,45735806},{3,36030001,33400}]',0,1,1,'[]','[]','[]',1,0,0,0),(13770,'钓鱼天堂','失落之海？会走路的鱼？我的老天~你都去了些什么地方，简直就是钓鱼天堂呐！','与狸太郎对话',1,9,0,380,0,0,0,0,0,13760,13780,'null','[]','0',100410,0,1908299,0,'[]','[]',0,'[{5,36060001,45735806},{3,36030001,33600}]',0,1,1,'[]','[]','[]',1,0,0,0),(13780,'遗忘之物','海神原本是星界的守护神之一，他降临大陆建立了亚特兰蒂斯王朝。','与朵萝丝对话',1,9,0,380,0,0,0,0,0,13770,13790,'null','[]','0',100414,0,1908300,0,'[]','[]',0,'[{5,36060001,45735806},{3,36030001,33700}]',0,1,1,'[]','[]','[]',1,0,0,0),(13790,'坚定不移','其实父皇他并没有恶意的，只是他不太信任人类而已……请不要怪他。','与人鱼对话',1,9,0,380,0,0,0,0,0,13780,13800,'null','[]','0',101001,0,1908301,0,'[]','[]',0,'[{5,36060001,45735806},{3,36030001,33800}]',0,1,1,'[]','[]','[]',1,0,0,0),(13800,'海拉武艺','人类，我很欣赏你的勇气，但是上次交手是我大意了，这次让你见识下我们海拉战士的武艺！','与海拉战士对话',1,9,0,380,0,0,0,0,0,13790,13810,'null','[]','0',101002,0,1908302,0,'[]','[]',0,'[{5,36060001,45735806},{3,36030001,34000}]',0,1,1,'[]','[]','[]',1,0,0,0),(13810,'鱼群突围','哼，想不到你这个人类可以打败我两次，我承认现在的你的确比较强！','击败海拉战士',1,9,1,380,0,0,0,0,0,13800,13820,'null','[]','0',101002,0,1908303,0,'[]','[[[\"kill\",\"1\",\"10100001\",\"90\",\"1010\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,45735806},{3,36030001,34100}]',0,1,1,'[]','[]','[]',1,0,0,0),(13820,'隐世之物','波塞冬的确是遗失了两样东西在这海底当中，其中一样东西在危险的海沟，那里沉睡着海龙王！','与巨蟹座对话',1,9,0,390,0,0,0,0,0,13810,13830,'null','[]','0',101003,0,1908304,0,'[]','[]',0,'[{5,36060001,50735806},{3,36030001,34300}]',0,1,1,'[]','[]','[]',1,0,0,0),(13830,'海王蟹群','希望我们这次能够顺利得到海神的信任，要赶上帝国军的进程，就必须穿过这片海域~','击败海王蟹',1,9,1,390,0,0,0,0,0,13820,13840,'null','[]','0',101014,0,1908305,0,'[]','[[[\"kill\",\"1\",\"10100002\",\"90\",\"1010\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,50735806},{3,36030001,34400}]',0,1,1,'[]','[]','[]',1,0,0,0),(13840,'海沟遗物','臭小鬼，下次打碎我两个牙还没跟你算账，还敢来？','采集海蓝果',1,9,3,390,0,0,0,0,0,13830,13850,'null','[]','0',101004,0,1908306,0,'[]','[[[\"collect\",\"4\",\"10100020\",\"1\",\"1010\",\"7075\",\"5835\",\"1\"]]]',0,'[{5,36060001,50735806},{3,36030001,34500}]',0,1,1,'[]','[]','[]',1,10100020,0,0),(13850,'鲨鱼围攻','这些鲨鱼恶霸我很早就看不顺眼了，如果你不是人类的话，或许我还会感谢你做的一切~','击败鲨鱼恶霸',1,9,1,390,0,0,0,0,0,13840,13860,'null','[]','0',101005,0,1908307,0,'[]','[[[\"kill\",\"1\",\"10100003\",\"90\",\"1010\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,50735806},{3,36030001,34700}]',0,1,1,'[]','[]','[]',1,0,0,0),(13860,'化敌为友','竟然两次败于你，看来你与一般的人类不一样，不仅武艺高强，连信念都如此坚定！','击败海拉刺客',1,9,1,390,0,0,0,0,0,13850,13870,'null','[]','0',101005,0,1908308,0,'[]','[[[\"kill\",\"1\",\"10100004\",\"90\",\"1010\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,50735806},{3,36030001,34800}]',0,1,1,'[]','[]','[]',1,0,0,0),(13870,'深海宅女','哈啊~嗯？你没有被波塞冬赶出去吗？之前闯入的人类，都被他丢到海沟里喂鱼了~','与水母对话',1,9,0,390,0,0,0,0,0,13860,13880,'null','[]','0',101006,0,1908309,0,'[]','[]',0,'[{5,36060001,50735806},{3,36030001,35000}]',0,1,1,'[]','[]','[]',1,0,0,0),(13880,'海神之怒','只能祝你好运了，波塞冬发火的话可不好办了，我可不想被打扰到睡懒觉~','与水母对话',1,9,0,390,0,0,0,0,0,13870,13890,'null','[]','0',101006,0,1908310,0,'[]','[]',0,'[{5,36060001,50735806},{3,36030001,35100}]',0,1,1,'[]','[]','[]',1,0,0,0),(13890,'鲁莽蜥蜴','只要能够取得海神的信任，我们就能顺利穿过这片海域了~','与露易丝对话',1,9,1,390,0,0,0,0,0,13880,13900,'null','[]','0',101007,0,1908311,0,'[]','[[[\"kill\",\"1\",\"10100005\",\"90\",\"1010\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,50735806},{3,36030001,35200}]',0,1,1,'[]','[]','[]',1,0,0,0),(13900,'拉拢船员','小鬼~要不要上我的船，一起当海盗麽咯？保你享尽荣华富贵喔！','与船长对话',1,9,0,390,0,0,0,0,0,13890,13910,'null','[]','0',101008,0,1908312,0,'[]','[]',0,'[{5,36060001,50735806},{3,36030001,35400}]',0,1,1,'[]','[]','[]',1,0,0,0),(13910,'极力挽留','哎哎哎？先别急着走啊！我现在还差一个副船长，一个水手，最重要的是我还差一条船~唉？人呢！？','与船长对话',1,9,0,390,0,0,0,0,0,13900,13920,'null','[]','0',101008,0,1908313,0,'[]','[]',0,'[{5,36060001,50735806},{3,36030001,35500}]',0,1,1,'[]','[]','[]',1,0,0,0),(13920,'海神大殿','我很欣赏你~人类，一而再再而三地出现在海神大殿之前，来吧！交出你的一切！','与海拉战士对话',1,9,0,400,0,0,0,0,0,13910,13930,'null','[]','0',101009,0,1908314,0,'[]','[]',0,'[{5,36060001,55735806},{3,36030001,35700}]',0,1,1,'[]','[]','[]',1,0,0,0),(13930,'大殿守卫','大殿前聚集了比之前更多的海拉守卫，看来想要再见到海神，很难~','击败海拉战士',1,9,1,400,0,0,0,0,0,13920,13940,'null','[]','0',0,0,0,0,'[]','[[[\"kill\",\"1\",\"10100006\",\"90\",\"1010\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,55735806},{3,36030001,35800}]',0,1,1,'[]','[]','[]',1,0,0,0),(13940,'遗落星尘','看你的表情应该是有备而来的，你找到海神遗失的东西了吗？','采集辉星石',1,9,3,400,0,0,0,0,0,13930,13950,'null','[]','0',101010,0,1908315,0,'[]','[[[\"collect\",\"4\",\"10100021\",\"1\",\"1010\",\"13946\",\"14443\",\"1\"]]]',0,'[{5,36060001,55735806},{3,36030001,35900}]',0,1,1,'[]','[]','[]',1,10100021,0,0),(13950,'海神诘问','即便你做到这种地步，你所在乎的同类也还是会再自相残杀，就算如此你也要为之付出生命吗？人类并不值得去拯救！','与海神对话',1,9,0,400,0,0,0,0,0,13940,13960,'null','[]','0',101011,0,1908316,0,'[]','[]',0,'[{5,36060001,55735806},{3,36030001,36100}]',0,1,1,'[]','[]','[]',1,0,0,0),(13960,'满意答复','我喜欢这个答复！你可以离开了！','与海神对话',1,9,0,400,0,0,0,0,0,13950,13970,'null','[]','0',101011,0,1908317,0,'[]','[]',0,'[{5,36060001,55735806},{3,36030001,36200}]',0,1,1,'[]','[]','[]',1,0,0,0),(13970,'潮起潮落','太好了！我……我就知道你一定可以说服父王的！','与人鱼对话',1,9,1,400,0,0,0,0,0,13960,13980,'null','[]','0',101012,0,1908318,0,'[]','[[[\"kill\",\"1\",\"10100007\",\"90\",\"1010\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,55735806},{3,36030001,36400}]',0,1,1,'[]','[]','[]',1,0,0,0),(13980,'不舍道别','虽然认识……认识不是很久，但是……你也是……我的第二个朋友！请多指教！有空一定要多来亚特兰蒂斯！','与人鱼对话',1,9,0,400,0,0,0,0,0,13970,13990,'null','[]','0',101012,0,1908319,0,'[]','[]',0,'[{5,36060001,55735806},{3,36030001,36500}]',0,1,1,'[]','[]','[]',1,0,0,0),(13990,'重新出航','臭小鬼，老子等你很久啦！快上船！老子搞到一艘大船啦！哈哈哈哈！','与船长对话',1,9,0,400,0,0,0,0,0,13980,14000,'null','[]','0',101013,0,1908320,0,'[]','[]',0,'[{5,36060001,55735806},{3,36030001,36600}]',0,1,1,'[]','[]','[]',1,0,0,0),(14000,'冲出深海','冲出深海的你们，来到了一个奇怪的地方','与霍克船长对话',1,10,0,400,9999,0,0,0,0,13990,14010,'null','[]','0',101201,0,1908359,0,'[]','[]',0,'[{5,36060001,55735806},{3,36030001,36800}]',0,1,1,'[]','[]','[]',1,0,0,0),(14010,'采摘野果','帮助霍克船长采摘野果','采集一箱野果',1,10,3,400,0,0,0,0,0,14000,14020,'null','[]','0',101201,0,1908360,0,'[]','[[[\"collect\",\"4\",\"10120020\",\"1\",\"1012\",\"3906\",\"11089\",\"1\"]]]',0,'[{5,36060001,55735806},{3,36030001,36900}]',0,1,1,'[]','[]','[]',1,10120020,0,0),(14020,'焚烬火山','这个神秘地方原来就是传说中的焚烬火山','于霍克船长对话',1,10,0,410,0,0,0,0,0,14010,14030,'null','[]','0',101201,0,1908361,0,'[]','[]',0,'[{5,36060001,60735806},{3,36030001,37000}]',0,1,1,'[]','[]','[]',1,0,0,0),(14030,'前往问路','遇到了焚烬火山的原住民——亚龙人薇薇安','击败灰烬魔蝎',1,10,0,410,0,0,0,0,0,14020,14040,'null','[]','0',101202,0,1908362,0,'[]','[[[\"kill\",\"1\",\"10120001\",\"30\",\"1012\",\"7150\",\"12994\",\"1\"]]]',0,'[{5,36060001,60735806},{3,36030001,37200}]',0,1,1,'[]','[]','[]',1,0,0,0),(14040,'暗裔危机','结识了亚龙族傲娇少女薇薇安','与薇薇安对话',1,10,0,410,0,0,0,0,0,14030,14050,'null','[]','101202',101202,1908363,1908364,0,'[]','[]',0,'[{5,36060001,60735806},{3,36030001,37300}]',0,1,1,'[]','[]','[]',1,0,0,0),(14050,'制止爆破','小子，你干什么！什么！暗裔的侵蚀！这是什么！？轰！怪不得我觉得我们族人怪怪的，原来是被邪恶力量侵蚀了！','击败熔岩爆弹',1,10,0,410,0,0,0,0,0,14040,14060,'null','[]','0',101203,0,1908366,0,'[]','[[[\"kill\",\"1\",\"10120002\",\"30\",\"1012\",\"5749\",\"17264\",\"1\"]]]',0,'[{5,36060001,60735806},{3,36030001,37500}]',0,1,1,'[]','[]','[]',1,0,0,0),(14060,'熔岩流蝶','为了制止这场骚乱，就要找到珍稀的熔岩流蝶','捕捉熔岩流蝶',1,10,3,410,0,0,0,0,0,14050,14070,'null','[]','101203',101203,1908367,1908368,0,'[]','[[[\"collect\",\"4\",\"10120021\",\"2\",\"1012\",\"4838\",\"19411\",\"1\"]]]',0,'[{5,36060001,60735806},{3,36030001,37600}]',0,1,1,'[]','[]','[]',1,10120021,0,0),(14070,'火山秘闻','轰！虽然我头脑比较简单，但是我知道这片火山不少秘密！哈哈哈，前面就是焚烬领主的底盘，你打败他，我就把秘密都告诉你！','与毁灭爆弹对话',1,10,0,410,0,0,0,0,0,14060,14080,'null','[]','0',101203,0,1908369,0,'[]','[]',0,'[{5,36060001,60735806},{3,36030001,37700}]',0,1,1,'[]','[]','[]',1,0,0,0),(14080,'重遇故人','好久不见啊，我们的勇者~看来你成长了不少，但是你的实力还不足以打败前面的焚烬领主，再加把劲吧！','与莱克斯对话',1,10,0,410,0,0,0,0,0,14070,14090,'null','[]','0',101204,0,1908370,0,'[]','[]',0,'[{5,36060001,60735806},{3,36030001,37900}]',0,1,1,'[]','[]','[]',1,0,0,0),(14090,'挑战领主','勇者，你成长的速度实在令人羡慕啊！你现在有足够的实力去挑战这片火山的领主了','击败焚烬领主',1,10,1,410,0,0,0,0,0,14080,14100,'null','[]','101204',0,1908371,0,0,'[]','[[[\"kill\",\"1\",\"10120100\",\"1\",\"1012\",\"11048\",\"21743\",\"1\"]]]',0,'[{5,36060001,60735806},{3,36030001,38000}]',0,1,1,'[{0,0,18071001,1}]','[]','[]',1,0,0,0),(14100,'恶魔交易','焚烬领主早就跟恶魔军团达成交易，换取了强大的力量！','与毁灭爆弹对话',1,10,0,410,0,0,0,0,0,14090,14110,'null','[]','101205',101205,1908372,1908373,0,'[]','[]',0,'[{5,36060001,60735806},{3,36030001,38200}]',0,1,1,'[]','[]','[]',1,0,0,0),(14110,'液体怪物','在火山遇到了神奇的液体怪物，虽然有些恶心，但还是上前去一问究竟','与煮咒恶灵对话',1,10,0,410,0,0,0,0,0,14100,14120,'null','[]','101206',101206,1908374,1908375,0,'[]','[]',0,'[{5,36060001,60735806},{3,36030001,38300}]',0,1,1,'[]','[]','[]',1,0,0,0),(14120,'同类族人','尝试与熔化史莱姆沟通...武力沟通','击败熔化史莱姆',1,10,1,420,0,0,0,0,0,14110,14130,'null','[]','101206',101206,1908376,1908377,0,'[]','[[[\"kill\",\"1\",\"10120003\",\"30\",\"1012\",\"15544\",\"19571\",\"1\"]]]',0,'[{5,36060001,65735806},{3,36030001,38400}]',0,1,1,'[]','[]','[]',1,0,0,0),(14130,'液体生物','错认同族的煮咒恶灵因为过于恼怒而不再理睬任何人','与煮咒恶灵对话',1,10,0,420,0,0,0,0,0,14120,14140,'null','[]','0',101206,0,1908378,0,'[]','[]',0,'[{5,36060001,65735806},{3,36030001,38600}]',0,1,1,'[]','[]','[]',1,0,0,0),(14140,'继续前行','前面有很多戴着刀刃的能量探测机，看来帝国的邪恶爪牙已经伸到这里了！','与水手托鲁玛对话',1,10,0,420,0,0,0,0,0,14130,14150,'null','[]','101207',101207,1908379,1908380,0,'[]','[]',0,'[{5,36060001,65735806},{3,36030001,38700}]',0,1,1,'[]','[]','[]',1,0,0,0),(14150,'探测机器','击败能量探测机','击败能量探测机',1,10,1,420,0,0,0,0,0,14140,14160,'null','[]','0',0,0,0,0,'[]','[[[\"kill\",\"1\",\"10120004\",\"30\",\"1012\",\"11447\",\"16347\",\"1\"]]]',0,'[{5,36060001,65735806},{3,36030001,38900}]',0,1,1,'[]','[]','[]',1,0,0,0),(14160,'能量矿源','噢，原来你是发现了邪恶帝国的能量探测机。哼！他们十台机器也没我一个迪克强！','与鼯鼠迪克对话',1,10,0,420,0,0,0,0,0,14150,14170,'null','[]','0',101208,0,1908382,0,'[]','[]',0,'[{5,36060001,65735806},{3,36030001,39000}]',0,1,1,'[]','[]','[]',1,0,0,0),(14170,'帝国阴谋','描述这里找到了大量珍稀的高能量矿，帝国人肯定是想开采来制作武器！当你再强一点的时候，一定要制止他们','与鼯鼠迪克对话',1,10,0,420,0,0,0,0,0,14160,14180,'null','[]','0',101208,0,1908383,0,'[]','[]',0,'[{5,36060001,65735806},{3,36030001,39100}]',0,1,1,'[]','[]','[]',1,0,0,0),(14180,'魔晶能源','专业矿工告诉你，前面有一堆强大的魔晶虫子。如果你能击败他们，并把收集起来的魔晶交给前面的莫里森，他会给你好多好东西喔','与鼯鼠迪克对话',1,10,0,420,0,0,0,0,0,14170,14190,'null','[]','0',101208,0,1908384,0,'[]','[]',0,'[{5,36060001,65735806},{3,36030001,39300}]',0,1,1,'[]','[]','[]',1,0,0,0),(14190,'魔晶炯眼','击败魔晶炯眼','击败魔晶炯眼',1,10,1,420,0,0,0,0,0,14180,14200,'null','[]','0',0,0,0,0,'[]','[[[\"kill\",\"1\",\"10120005\",\"30\",\"1012\",\"14187\",\"11424\",\"1\"]]]',0,'[{5,36060001,65735806},{3,36030001,39400}]',0,1,1,'[]','[]','[]',1,0,0,0),(14200,'暴怒之火','现在的焚烬火山，即使没有暗裔涌入，也正在一步一步走入黑暗深渊。因为龙神留下的意志已被时间侵蚀，而被选定的亚龙人族因为太弱小无法继承龙神意志','对暴怒之火对话',1,10,0,420,0,0,0,0,0,14190,14210,'null','[]','101209',101209,1908385,1908386,0,'[]','[]',0,'[{5,36060001,65735806},{3,36030001,39600}]',0,1,1,'[]','[]','[]',1,0,0,0),(14210,'龙神意志','描述龙神的意志已被侵蚀，但我感受到承接光明的曙光也向我靠近。冒险者，我愿用我的意志与火焰帮助你们。','与暴怒之火对话',1,10,0,420,0,0,0,0,0,14200,14220,'null','[]','0',101209,0,1908387,0,'[]','[]',0,'[{5,36060001,65735806},{3,36030001,39700}]',0,1,1,'[]','[]','[]',1,0,0,0),(14220,'意志传承','年轻的冒险者，你已经有足够的力量去寻找龙神的传承。','与暴怒之火对话',1,10,0,430,0,0,0,0,0,14210,14230,'null','[]','0',101209,0,1908390,0,'[]','[]',0,'[{5,36060001,58946505},{3,36030001,39800}]',0,1,1,'[]','[]','[]',1,0,0,0),(14230,'火焰符文','龙神的传承需要激活火山中心的祭坛。你采集些火焰符文去找那边的铁匠，或许他能帮到你','采集火焰符文',1,10,3,430,0,0,0,0,0,14220,14240,'null','[]','101209',0,1908391,0,0,'[]','[[[\"collect\",\"4\",\"10120022\",\"2\",\"1012\",\"16447\",\"10891\",\"1\"]]]',0,'[{5,36060001,58946505},{3,36030001,40000}]',0,1,1,'[]','[]','[]',1,10120022,0,0),(14240,'任务名','嗨，当初穿着破烂玩意的穷酸小鬼居然也有能力来到这里，还想开启火山中央的龙神祭坛！但是你收集的魔晶还不够','与铁匠莫里森对话',1,10,0,430,0,0,0,0,0,14230,14250,'null','[]','0',101210,0,1908392,0,'[]','[]',0,'[{5,36060001,58946505},{3,36030001,40100}]',0,1,1,'[]','[]','[]',1,0,0,0),(14250,'魔晶魔晶','挺厉害嘛，这么短时间内就可以收集到那么多魔晶。看来龙神祭坛真的要为你一个外来人而开了','击败魔晶炯眼',1,10,1,430,0,0,0,0,0,14240,14260,'null','[]','0',101210,0,1908393,0,'[]','[[[\"kill\",\"1\",\"10120005\",\"30\",\"1012\",\"14187\",\"11424\",\"1\"]]]',0,'[{5,36060001,58946505},{3,36030001,40300}]',0,1,1,'[]','[]','[]',1,0,0,0),(14260,'打造时间','开启龙神祭坛的材料够了，我现在就要开始打造了。对了小鬼，待会你把这个消息告诉圣灵大人吧','与铁匠莫里森对话',1,10,0,430,0,0,0,0,0,14250,14270,'null','[]','0',101210,0,1908394,0,'[]','[]',0,'[{5,36060001,58946505},{3,36030001,40400}]',0,1,1,'[]','[]','[]',1,0,0,0),(14270,'圣灵之焰','既然铁匠已经在打造必要材料了，那么在开启龙神祭坛之前，我们还是要先把火山内残余的暗裔力量清理一下','与暴怒之火对话',1,10,0,430,0,0,0,0,0,14260,14280,'null','[]','0',101209,0,1908395,0,'[]','[]',0,'[{5,36060001,58946505},{3,36030001,40500}]',0,1,1,'[]','[]','[]',1,0,0,0),(14280,'信号机器','击败信号机器人，并收集他们身上的零件','击败信号机器人',1,10,1,430,0,0,0,0,0,14270,14290,'null','[]','0',0,0,0,0,'[]','[[[\"kill\",\"1\",\"10120006\",\"30\",\"1012\",\"17413\",\"8963\",\"1\"]]]',0,'[{5,36060001,58946505},{3,36030001,40700}]',0,1,1,'[]','[]','[]',1,0,0,0),(14290,'机器零件','嗯，你拿着的这些零件让我看看——这些是帝国的负责通讯的机器人。现在帝国军团之间不能通讯了，正是各个击破的好时机！','与机械师安娜对话',1,10,0,430,0,0,0,0,0,14280,14300,'null','[]','0',101211,0,1908396,0,'[]','[]',0,'[{5,36060001,58946505},{3,36030001,40800}]',0,1,1,'[]','[]','[]',1,0,0,0),(14300,'高级士兵','虽然可以各个击破，但是前面是帝国高级士兵，经过我的计算，以你的实力肯定打不过他们，你还是锻炼一下再来吧','与机械师安娜对话',1,10,0,430,0,0,0,0,0,14290,14310,'null','[]','0',101211,0,1908397,0,'[]','[]',0,'[{5,36060001,58946505},{3,36030001,40900}]',0,1,1,'[]','[]','[]',1,0,0,0),(14310,'薇薇安','我刚才看到一个重伤的亚龙人往龙神祭坛方向冲了过去。勇者，你快过去帮帮她吧','与接卸是安娜对话',1,10,0,430,0,0,0,0,0,14300,14320,'null','[]','0',101211,0,1908398,0,'[]','[]',0,'[{5,36060001,58946505},{3,36030001,41100}]',0,1,1,'[]','[]','[]',1,0,0,0),(14320,'帝国士兵','击败帝国特种兵','击败帝国特种兵',1,10,1,430,0,0,0,0,0,14310,14320,'null','[]','0',0,0,0,0,'[]','[[[\"kill\",\"1\",\"10120007\",\"30\",\"1012\",\"11840\",\"3945\",\"1\"]]]',0,'[{5,36060001,58946505},{3,36030001,41200}]',0,1,1,'[{0,0,21010101,1}]','[]','[]',1,0,0,0),(14330,'亚龙人族','冒险者你来到这里真真真的太好啦！受重伤？噢，圣灵大人已经帮我治好了','与薇薇安对话',1,10,0,430,0,0,0,0,0,14320,14340,'null','[]','0',101212,0,1908399,0,'[]','[]',0,'[{5,36060001,58946505},{3,36030001,41400}]',0,1,1,'[]','[]','[]',1,0,0,0),(14340,'龙神祭坛','冒险者，我们终于要迎来焚烬火山的曙光了。现在就只要等待龙神祭坛中的怒火燃烧起来','与暴怒之火对话',1,10,0,440,0,0,0,0,0,14330,14350,'null','[]','0',101213,0,1908400,0,'[]','[]',0,'[{5,36060001,83738172},{3,36030001,41500}]',0,1,1,'[]','[]','[]',1,0,0,0),(14350,'祭坛之钥','那个…我发现…我在冲过来的路上把最重要的祭坛之钥弄丢了…你能帮我找找吗，或许就在那些帝国士兵那里','与薇薇安对话',1,10,0,440,0,0,0,0,0,14340,14360,'null','[]','0',101212,0,1908401,0,'[]','[]',0,'[{5,36060001,83738172},{3,36030001,41600}]',0,1,1,'[]','[]','[]',1,0,0,0),(14360,'寻找钥匙','击败帝国特种兵，寻找钥匙','击败帝国特种兵',1,10,1,440,0,0,0,0,0,14350,14370,'null','[]','0',101212,0,1908402,0,'[]','[[[\"kill\",\"1\",\"10120007\",\"30\",\"1012\",\"11840\",\"3945\",\"1\"]]]',0,'[{5,36060001,83738172},{3,36030001,41800}]',0,1,1,'[]','[]','[]',1,0,0,0),(14370,'找回钥匙','（松了一口气）呼，终于找回来啦，谢谢你！以后我不会那么冒失了，我会努力进步的！那个那个…圣灵大人找你来着！','找到祭坛之钥',1,10,3,440,0,0,0,0,0,14360,14380,'null','[]','0',101212,0,1908403,0,'[]','[[[\"collect\",\"4\",\"10120023\",\"1\",\"1012\",\"9063\",\"5139\",\"1\"]]]',0,'[{5,36060001,83738172},{3,36030001,41900}]',0,1,1,'[]','[]','[]',1,0,0,0),(14380,'增强实力','龙神祭坛的火焰逐渐升起，我们要确保祭坛开启时没有东西能打扰我们.......包括你们的意志和实力','与暴怒之火对话',1,10,0,440,0,0,0,0,0,14370,14390,'null','[]','0',101213,0,1908404,0,'[]','[]',0,'[{5,36060001,83738172},{3,36030001,42100}]',0,1,1,'[]','[]','[]',1,0,0,0),(14390,'敌人来袭','冒险者大人，我们并不是敌人！我们的族人来到这里只是献出我们的血液……还有生命！','击败熔岩蜥蜴',1,10,1,440,0,0,0,0,0,14380,14400,'null','[]','101212',101214,1908405,1908406,0,'[]','[[[\"kill\",\"1\",\"10120008\",\"30\",\"1012\",\"7967\",\"8291\",\"1\"]]]',0,'[{5,36060001,83738172},{3,36030001,42200}]',0,1,1,'[]','[]','[]',1,0,0,0),(14400,'祭坛之血','即使很微弱，但我们的血液汇聚起来，也终是可以达到开启的条件——至于另一个材料，是圣灵大人的圣灵之火…这也是需要大人，献出她的生命！','与蜥蜴首领对话',1,0,0,440,0,0,0,0,0,14390,14410,'null','[]','101214',101214,1908407,1908408,0,'[]','[]',0,'[{5,36060001,83738172},{3,36030001,42300}]',0,1,1,'[]','[]','[]',1,0,0,0),(14410,'祭坛之火','蜥蜴族人有这样的觉悟，从虚无的火焰中诞生的我同样有这种觉悟。好了，通知薇薇安，一起开启祭坛吧','与圣灵对话',1,10,0,440,0,0,0,0,0,14400,14420,'null','[]','101213',101212,1908409,1908410,0,'[]','[]',0,'[{5,36060001,83738172},{3,36030001,42500}]',0,1,1,'[]','[]','[]',1,0,0,0),(14420,'开启祭坛','（圣灵身上的火焰逐渐微弱）祭坛已经开启！我原以为只有亚龙族人有资格继承龙神意志，想不到你们二人都得到了龙神意志的认可！年轻的冒险者，我......我很开心！','推动祭坛水晶',1,10,3,440,0,0,0,0,0,14410,14430,'null','[]','0',101213,0,1908411,0,'[]','[[[\"collect\",\"4\",\"10120024\",\"1\",\"1012\",\"9712\",\"7394\",\"1\"]]]',0,'[{5,36060001,83738172},{3,36030001,42600}]',0,1,1,'[]','[]','[]',1,0,0,0),(14430,'重开屏障','我已经得到了龙神意志的传承，也可以重开火山的屏障了.......这也是火山各族最迫切的希望.......但我感觉这样是不对的','与薇薇安对话',1,10,0,440,0,0,0,0,0,14420,14440,'null','[]','0',101212,0,1908412,0,'[]','[]',0,'[{5,36060001,83738172},{3,36030001,42800}]',0,1,1,'[]','[]','[]',1,0,0,0),(14440,'开放火山','（坚定）用封闭自己来保护自己，这个我做不到。我们不应该畏惧别人的强大而承认自己是永远的弱小。只有重新开放火山，火山才能再次强大！','与薇薇安对话',1,10,0,440,0,0,0,0,0,14430,14450,'null','[]','0',101212,0,1908413,0,'[]','[]',0,'[{5,36060001,83738172},{3,36030001,42900}]',0,1,1,'[]','[]','[]',1,0,0,0),(14450,'新的秘境','冒险者，我们发现了一个通往神秘地域的传送门。如果你准备好的话，我们一起去冒险吧~','与薇薇安对话',1,10,0,440,0,0,0,0,0,14440,14460,'null','[]','0',101212,0,1908414,0,'[]','[]',0,'[{5,36060001,83738172},{3,36030001,43000}]',0,1,1,'[]','[]','[]',1,0,0,0),(14460,'远东国度','啊啦~是拯救世界的外乡人呢~梦境的预言终于要变为现实了！','与巫女对话',1,11,0,450,0,0,0,0,0,14450,14470,'null','[]','0',101101,0,1908432,0,'[]','[]',0,'[{5,36060001,130235806},{3,36030001,43200}]',0,1,1,'[]','[]','[]',1,0,0,0),(14470,'该隐神社','这里是是该隐神社，不过我这里可没有消除幻觉的药，况且你所看到的也不是幻觉~','任务提示',1,11,0,450,0,0,0,0,0,14460,14480,'null','[]','0',101102,0,1908433,0,'[]','[]',0,'[{5,36060001,130235806},{3,36030001,43300}]',0,1,1,'[]','[]','[]',1,0,0,0),(14480,'百花女妖','这位奇装异服的武士哟，我看你三两下就把那妖精解决了，敢问尊姓大名~','击败百花妖',1,11,1,450,0,0,0,0,0,14470,14490,'null','[]','0',101103,0,1908434,0,'[]','[[[\"kill\",\"1\",\"10110001\",\"40\",\"1011\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,130235806},{3,36030001,43500}]',0,1,1,'[]','[]','[]',1,0,0,0),(14490,'秋田剑豪','我游历四方，和各种各样的剑士切磋剑术，未尝一败！','与剑豪对话',1,11,0,450,0,0,0,0,0,14480,14500,'null','[]','0',101103,0,1908435,0,'[]','[]',0,'[{5,36060001,130235806},{3,36030001,43600}]',0,1,1,'[]','[]','[]',1,0,0,0),(14500,'诸天童子','是陌生的面孔~你们到底是谁？','与童子对话',1,11,0,450,0,0,0,0,0,14490,14510,'null','[]','0',101104,0,1908436,0,'[]','[]',0,'[{5,36060001,130235806},{3,36030001,43700}]',0,1,1,'[]','[]','[]',1,0,0,0),(14510,'封印松动','最近铃音姐好像很担心大蛇封印松动的事情，一直留守在神社不和我玩儿~','与童子对话',1,11,0,450,0,0,0,0,0,14500,14520,'null','[]','0',101104,0,1908437,0,'[]','[]',0,'[{5,36060001,130235806},{3,36030001,43900}]',0,1,1,'[]','[]','[]',1,0,0,0),(14520,'麻将妖精','最近大蛇的封印有松动的迹象，附近的妖精也更加活跃了。','与巫女对话',1,11,1,450,0,0,0,0,0,14510,14530,'null','[]','0',101105,0,1908438,0,'[]','[[[\"kill\",\"1\",\"10110002\",\"40\",\"1011\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,130235806},{3,36030001,44000}]',0,1,1,'[]','[]','[]',1,0,0,0),(14530,'温泉污染','咳咳咳，最近不知怎么的？温泉的水源受到了影响，还无故多了许多泡霸王温泉的忍者……','与老人对话',1,11,0,450,0,0,0,0,0,14520,14540,'null','[]','0',101106,0,1908439,0,'[]','[]',0,'[{5,36060001,130235806},{3,36030001,44200}]',0,1,1,'[]','[]','[]',1,0,0,0),(14540,'驱逐叛忍','感谢你的出手帮助，虽然温泉水源的污染还没搞清楚情况，至少这些叛忍不会再来了！','击败叛忍',1,11,1,450,0,0,0,0,0,14530,14550,'null','[]','0',101106,0,1908440,0,'[]','[[[\"kill\",\"1\",\"10110003\",\"40\",\"1011\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,130235806},{3,36030001,44300}]',0,1,1,'[]','[]','[]',1,0,0,0),(14550,'松鼠高见','没有什么能够难倒我，温泉水源污染，一定是源头有妖怪出现了！','与松鼠对话',1,11,0,450,0,0,0,0,0,14540,14560,'null','[]','0',101107,0,1908441,0,'[]','[]',0,'[{5,36060001,130235806},{3,36030001,44400}]',0,1,1,'[]','[]','[]',1,0,0,0),(14560,'介绍能人','不过你一个人去也未免会有危险，这样吧~我介绍一个壮汉跟你一起去调查~','与松鼠对话',1,11,0,460,0,0,0,0,0,14550,14570,'null','[]','0',101107,0,1908442,0,'[]','[]',0,'[{5,36060001,135235806},{3,36030001,44600}]',0,1,1,'[]','[]','[]',1,0,0,0),(14570,'条野太郎','哎嘿嘿~你就帕吉说的要找我帮忙的人麽！那我们快出发吧！','与太郎对话',1,11,0,460,0,0,0,0,0,14560,14580,'null','[]','0',101108,0,1908443,0,'[]','[]',0,'[{5,36060001,135235806},{3,36030001,44700}]',0,1,1,'[]','[]','[]',1,0,0,0),(14580,'大名熊霸','不单单是温泉的水质受到了影响，我的鱼塘也没法钓鱼了……','击败熊霸',1,11,1,460,0,0,0,0,0,14570,14590,'null','[]','0',101109,0,1908444,0,'[]','[[[\"kill\",\"1\",\"10110004\",\"40\",\"1011\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,135235806},{3,36030001,44800}]',0,1,1,'[]','[]','[]',1,0,0,0),(14590,'钓鱼时光','怀念平日里闲暇的钓鱼时光啊~快乐而惬意！','与太郎对话',1,11,0,460,0,0,0,0,0,14580,14600,'null','[]','0',101109,0,1908445,0,'[]','[]',0,'[{5,36060001,135235806},{3,36030001,45000}]',0,1,1,'[]','[]','[]',1,0,0,0),(14600,'大蛇灾厄','如果大蛇的封印真的破解掉，将会给这个世界带来可怕的灾厄！','与巫女对话',1,11,0,460,0,0,0,0,0,14590,14610,'null','[]','0',101105,0,1908446,0,'[]','[]',0,'[{5,36060001,135235806},{3,36030001,45100}]',0,1,1,'[]','[]','[]',1,0,0,0),(14610,'大蛇逆鳞','拿着这些逆鳞，也许在危急时刻能够帮上忙！','龙鳞',1,11,3,460,0,0,0,0,0,14600,14620,'null','[]','0',101105,0,1908447,0,'[]','[[[\"collect\",\"4\",\"10110020\",\"1\",\"1011\",\"6150\",\"8342\",\"1\"]]]',0,'[{5,36060001,135235806},{3,36030001,45300}]',0,1,1,'[]','[]','[]',1,10110020,0,0),(14620,'抢夺逆鳞','你们快走吧！这里我来应付。鳞片有强烈的妖气，妖怪会盯上你的！','击败麻将精',1,11,1,460,0,0,0,0,0,14610,14630,'null','[]','0',101104,0,1908448,0,'[]','[[[\"kill\",\"1\",\"10110002\",\"40\",\"1011\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,135235806},{3,36030001,45400}]',0,1,1,'[]','[]','[]',1,0,0,0),(14630,'强大妖力','别看我这样，我可是这里数一数二的强大妖怪呢~','与童子对话',1,11,0,460,0,0,0,0,0,14620,14640,'null','[]','0',101104,0,1908449,0,'[]','[]',0,'[{5,36060001,135235806},{3,36030001,45500}]',0,1,1,'[]','[]','[]',1,0,0,0),(14640,'无言感慨','想不到事态发展到了这个程度，你们赶紧到神社去吧！','与剑豪对话',1,11,0,460,0,0,0,0,0,14630,14650,'null','[]','0',101103,0,1908450,0,'[]','[]',0,'[{5,36060001,135235806},{3,36030001,45700}]',0,1,1,'[]','[]','[]',1,0,0,0),(14650,'剑之所指','神社就在东边，快去吧！不然就来不及了！','与剑豪对话',1,11,0,460,0,0,0,0,0,14640,14660,'null','[]','0',101103,0,1908451,0,'[]','[]',0,'[{5,36060001,135235806},{3,36030001,45800}]',0,1,1,'[]','[]','[]',1,0,0,0),(14660,'花妖缭乱','花妖再次挡在了你的面前，想要夺取你手中的逆鳞。','击败花妖',1,11,1,470,0,0,0,0,0,14650,14670,'null','[]','0',0,0,0,0,'[]','[[[\"kill\",\"1\",\"10110001\",\"40\",\"1011\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,140235806},{3,36030001,46000}]',0,1,1,'[]','[]','[]',1,0,0,0),(14670,'忍者甲贺','甲贺一族的忍者都已经叛变，成为了大蛇的傀儡了！','与忍者对话',1,11,0,470,0,0,0,0,0,14660,14680,'null','[]','0',101112,0,1908452,0,'[]','[]',0,'[{5,36060001,140235806},{3,36030001,46100}]',0,1,1,'[]','[]','[]',1,0,0,0),(14680,'忍者没落','我已经是被抛弃的领袖，什么甲贺一族的复兴都不复存在了……','与忍者对话',1,11,0,470,0,0,0,0,0,14670,14690,'null','[]','0',101112,0,1908453,0,'[]','[]',0,'[{5,36060001,140235806},{3,36030001,46200}]',0,1,1,'[]','[]','[]',1,0,0,0),(14690,'白虎妖怪','白虎丸本来很温顺的，最近不知道为什么就变得如此暴戾。','击败白虎',1,11,1,470,0,0,0,0,0,14680,14700,'null','[]','0',101111,0,1908454,0,'[]','[[[\"kill\",\"1\",\"10110005\",\"40\",\"1011\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,140235806},{3,36030001,46400}]',0,1,1,'[]','[]','[]',1,0,0,0),(14700,'妖怪直觉','神社附近的妖气加重了，恐怕是大蛇的封印又更加松动了~','与童子对话',1,11,0,470,0,0,0,0,0,14690,14710,'null','[]','0',101111,0,1908455,0,'[]','[]',0,'[{5,36060001,140235806},{3,36030001,46500}]',0,1,1,'[]','[]','[]',1,0,0,0),(14710,'姐妹情深','铃音姐姐现在一定很焦急，我们要去帮帮她！','与童子对话',1,11,0,470,0,0,0,0,0,14700,14720,'null','[]','0',101111,0,1908456,0,'[]','[]',0,'[{5,36060001,140235806},{3,36030001,46700}]',0,1,1,'[]','[]','[]',1,0,0,0),(14720,'默默祈祷','最近妖怪活跃，村民们都十分惊恐，前来祈福的人也比往常多了不少，希望这次的危机能够安然化解吧~','与猫娘对话',1,11,0,470,0,0,0,0,0,14710,14730,'null','[]','0',101110,0,1908457,0,'[]','[]',0,'[{5,36060001,140235806},{3,36030001,46800}]',0,1,1,'[]','[]','[]',1,0,0,0),(14730,'万花之妖','妖怪的活跃范围已经扩大到了神社附近！','击败花妖',1,11,1,470,0,0,0,0,0,14720,14740,'null','[]','0',0,0,0,0,'[]','[[[\"kill\",\"1\",\"10110006\",\"40\",\"1011\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,140235806},{3,36030001,46900}]',0,1,1,'[]','[]','[]',1,0,0,0),(14740,'剑豪助阵','我果然还是不太放心，结果来了之后才发现事态已经如此严重了！','与剑豪对话',1,11,0,470,0,0,0,0,0,14730,14750,'null','[]','0',101113,0,1908458,0,'[]','[]',0,'[{5,36060001,140235806},{3,36030001,47100}]',0,1,1,'[]','[]','[]',1,0,0,0),(14750,'轻易狗带','果然我到了这个年纪，游历了四方，也不想再和人比拼剑法了，反倒要开始考虑继承人的问题了！你可不能轻易地狗带啊！','与剑豪对话',1,11,0,470,0,0,0,0,0,14740,14760,'null','[]','0',101113,0,1908459,0,'[]','[]',0,'[{5,36060001,140235806},{3,36030001,47200}]',0,1,1,'[]','[]','[]',1,0,0,0),(14760,'寒冰雪姬','寒风凛冽，被大蛇妖气影响而从沉睡中苏醒的冰雪姬，优雅而危险！','击败冰雪姬',1,11,1,480,0,0,0,0,0,14750,14770,'null','[]','0',0,0,0,0,'[]','[[[\"kill\",\"1\",\"10110100\",\"1\",\"1011\",\"9190\",\"17000\",\"1\"]]]',0,'[{5,36060001,145235806},{3,36030001,47400}]',0,1,1,'[]','[]','[]',1,0,0,0),(14770,'继承剑法','我觉得，你就是那个合适的继承人，这本打狗剑法，你替我保管吧！','与剑豪对话',1,11,0,480,0,0,0,0,0,14760,14780,'null','[]','0',101113,0,1908460,0,'[]','[]',0,'[{5,36060001,145235806},{3,36030001,47500}]',0,1,1,'[]','[]','[]',1,0,0,0),(14780,'资深法师','嗯……我可不是来旅游观光的，或许我能帮上忙！','与法师对话',1,11,0,480,0,0,0,0,0,14770,14790,'null','[]','0',101114,0,1908461,0,'[]','[]',0,'[{5,36060001,145235806},{3,36030001,47600}]',0,1,1,'[]','[]','[]',1,0,0,0),(14790,'蓄势待发','按照这个态势发展下去的话，大蛇的封印迟早会被破解，难免会有一战的，做好心理准备吧！','与法师对话',1,11,0,480,0,0,0,0,0,14780,14800,'null','[]','0',101114,0,1908462,0,'[]','[]',0,'[{5,36060001,145235806},{3,36030001,47800}]',0,1,1,'[]','[]','[]',1,0,0,0),(14800,'虚弱之躯','我已经不能再维持封印了，再过不久八岐大蛇就会复活，快带着那几颗辉星石离开这里吧！不能让他染指！','与巫女对话',1,11,0,480,0,0,0,0,0,14790,14810,'null','[]','0',101115,0,1908463,0,'[]','[]',0,'[{5,36060001,145235806},{3,36030001,47900}]',0,1,1,'[]','[]','[]',1,0,0,0),(14810,'守护之石','快带着辉星石离开，不能让八岐大蛇染指！','采集辉星石',1,11,3,480,0,0,0,0,0,14800,14820,'null','[]','0',0,0,0,0,'[]','[[[\"collect\",\"4\",\"10110021\",\"1\",\"1011\",\"13959\",\"16445\",\"1\"]]]',0,'[{5,36060001,145235806},{3,36030001,48100}]',0,1,1,'[]','[]','[]',1,10110021,0,0),(14820,'最后嘱咐','慢着，如果我这次有不测的话，请帮我照顾好诸天童子，拜托了！','与巫女对话',1,11,0,480,0,0,0,0,0,14810,14830,'null','[]','0',101115,0,1908464,0,'[]','[]',0,'[{5,36060001,145235806},{3,36030001,48200}]',0,1,1,'[]','[]','[]',1,0,0,0),(14830,'战略撤退','我们还要争取一些时间让这里的村民平安撤退才行！','与法师对话',1,11,0,480,0,0,0,0,0,14820,14840,'null','[]','0',101114,0,1908465,0,'[]','[]',0,'[{5,36060001,145235806},{3,36030001,48300}]',0,1,1,'[]','[]','[]',1,0,0,0),(14840,'疏散村民','疏散村民的事情就交给我吧！妖怪就交给你来对付了！','与剑豪对话',1,11,0,480,0,0,0,0,0,14830,14850,'null','[]','0',101113,0,1908466,0,'[]','[]',0,'[{5,36060001,145235806},{3,36030001,48500}]',0,1,1,'[]','[]','[]',1,0,0,0),(14850,'奋勇斩妖','为秋田剑豪疏散平民争取时间，挡住妖怪的侵袭！','击败花妖',1,11,1,480,0,0,0,0,0,14840,14860,'null','[]','0',0,0,0,0,'[]','[[[\"kill\",\"1\",\"10110006\",\"40\",\"1011\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,145235806},{3,36030001,48600}]',0,1,1,'[]','[]','[]',1,0,0,0),(14860,'疏散成功','对亏你的帮助，附近的村民都安全撤离了~','与剑豪对话',1,11,0,490,0,0,0,0,0,14850,14870,'null','[]','0',101113,0,1908467,0,'[]','[]',0,'[{5,36060001,150235806},{3,36030001,48700}]',0,1,1,'[]','[]','[]',1,0,0,0),(14870,'衷心祈愿','我衷心希望你们能够迈过这次难关！','与猫娘对话',1,11,0,490,0,0,0,0,0,14860,14880,'null','[]','0',101110,0,1908468,0,'[]','[]',0,'[{5,36060001,150235806},{3,36030001,48900}]',0,1,1,'[]','[]','[]',1,0,0,0),(14880,'心意相通','铃音姐肯定想着一个人承担，但我不会让她如愿的，既然如此，只有打败八岐大蛇这个方法了！','与童子对话',1,11,0,490,0,0,0,0,0,14870,14890,'null','[]','0',101111,0,1908469,0,'[]','[]',0,'[{5,36060001,150235806},{3,36030001,49000}]',0,1,1,'[]','[]','[]',1,0,0,0),(14890,'战意全开','战意全开的你，势不可挡！','击败白虎',1,11,1,490,0,0,0,0,0,14880,14900,'null','[]','0',0,0,0,0,'[]','[[[\"kill\",\"1\",\"10110005\",\"40\",\"1011\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,150235806},{3,36030001,49200}]',0,1,1,'[]','[]','[]',1,0,0,0),(14900,'赌徒妖怪','赌徒和叛徒，两者我都十分讨厌呢！','击败自摸怪',1,11,1,490,0,0,0,0,0,14890,14910,'null','[]','0',101116,0,1908470,0,'[]','[[[\"kill\",\"1\",\"10110007\",\"40\",\"1011\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,150235806},{3,36030001,49300}]',0,1,1,'[]','[]','[]',1,0,0,0),(14910,'松鼠参谋','让我们来清理这些八岐大蛇的傀儡吧！','与松鼠对话',1,11,0,490,0,0,0,0,0,14900,14920,'null','[]','0',101116,0,1908471,0,'[]','[]',0,'[{5,36060001,150235806},{3,36030001,49400}]',0,1,1,'[]','[]','[]',1,0,0,0),(14920,'叛逃忍者','清理这些叛逃的忍者！','击败忍者',1,11,1,490,0,0,0,0,0,14910,14930,'null','[]','0',0,0,0,0,'[]','[[[\"kill\",\"1\",\"10110008\",\"40\",\"1011\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,150235806},{3,36030001,49600}]',0,1,1,'[]','[]','[]',1,0,0,0),(14930,'大战将即','这将是一场恶战，祝您武运昌隆！','与露易丝对话',1,11,0,490,0,0,0,0,0,14920,14940,'null','[]','0',101117,0,1908472,0,'[]','[]',0,'[{5,36060001,150235806},{3,36030001,49700}]',0,1,1,'[]','[]','[]',1,0,0,0),(14940,'八岐大蛇','直面八岐大蛇！','通关副本',1,11,6,490,0,0,0,0,0,14930,14950,'null','[]','0',0,0,0,0,'[]','[[[\"fin_dungeon\",\"11\",\"2101\",\"1\",\"1011\",\"0\",\"0\",\"0\"]]]',0,'[{5,36060001,150235806},{3,36030001,49900}]',0,1,1,'[]','[]','[]',1,2101,0,0),(14950,'灾厄解除','太好了，这次的作战十分成功，不仅消除了八岐大蛇的灾厄，辉星石也完好无损！','与露易丝对话',1,11,0,490,0,0,0,0,0,14940,0,'null','[]','0',101117,0,1908473,0,'[]','[]',0,'[{5,36060001,150235806},{3,36030001,50000}]',0,1,1,'[]','[]','[]',1,0,0,0),(999999,'测试副本任务','通关测试副本','',2,0,6,9999,9999,0,0,0,0,0,0,'null','[]','0',10019013,11082,11083,0,'[]','[[[\"fin_dungeon\",\"11\",\"2001\",\"1\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[]',0,1,1,'[]','[]','[]',1,2001,0,0),(2010101,'经验副本Ⅰ','经验副本可获得海量经验，伤害越高升级效率越快！','',2,0,10,70,9999,0,0,0,0,0,0,'null','[]','0',0,0,0,0,'[]','[[[\"fun_exp\",\"10\",\"4\",\"150000\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{2,36020001,10}]',1,0,1,'[]','[]','[]',0,0,0,0),(2010102,'经验副本Ⅱ','经验宝库中经验爆表哦，伤害越高经验越高，组队一起打还有30%的经验加成！','',2,0,10,150,9999,0,0,0,0,2010101,0,'null','[]','0',0,0,0,0,'[]','[[[\"fun_exp\",\"10\",\"4\",\"400000\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{0,32010043,1}]',1,0,1,'[]','[]','[]',0,0,0,0),(2020101,'世界首领','林间圣地魔物肆虐，村民们都不堪其苦，请勇士们前往击败这些魔物。','获得<color=\'#71e831\'>1</color>只<color=\'#71e831\'>世界首领</color>的<color=\'#71e831\'>掉落归属</color>',2,0,1,9999,9999,0,0,0,0,0,0,'null','[]','0',10079010,0,0,0,'[]','[[[\"kill_boss\",\"2\",\"1\",\"1\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{0,32010043,1}]',0,0,1,'[]','[]','[]',0,0,0,0),(2020201,'首领之家','首领之家里聚集了大量的魔物，再增加下去就要突破首领之家的限制了，请勇士前往击杀。','获得<color=#71e831>1</color>只<color=#71e831>首领之家</color>的首领归属',2,0,1,9999,9999,0,0,0,0,0,0,'null','[]','0',10079010,0,0,0,'[]','[[[\"kill_boss\",\"2\",\"3\",\"1\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{0,32010044,1}]',0,0,1,'[]','[]','[]',0,0,0,0),(2030101,'降神副本Ⅰ','降神副本第一境界','通关<color=\'#71e831\'>降神副本</color>--<color=\'#71e831\'>简单模式</color>',2,0,6,115,0,0,0,0,0,0,2030102,'null','[]','0',0,0,0,0,'[]','[[[\"fin_dungeon\",\"11\",\"5400\",\"1\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{2,36020001,10}]',0,0,0,'[]','[]','[]',0,5400,4,0),(2030102,'降神副本Ⅱ','降神副本第二境界','通关<color=\'#71e831\'>降神副本</color>--<color=\'#71e832\'>普通模式</color>',2,0,6,200,0,0,0,0,0,2030101,2030103,'null','[]','0',0,0,0,0,'[]','[[[\"fin_dungeon\",\"11\",\"5401\",\"1\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{2,36020001,10}]',0,0,0,'[]','[]','[]',0,5401,4,0),(2030103,'降神副本Ⅲ','降神副本第三境界','通关<color=\'#71e831\'>降神副本</color>--<color=\'#71e833\'>困难模式</color>',2,0,6,300,0,0,0,0,0,2030102,2030104,'null','[]','0',0,0,0,0,'[]','[[[\"fin_dungeon\",\"11\",\"5402\",\"1\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{2,36020001,10}]',0,0,0,'[]','[]','[]',0,5402,4,0),(2030104,'降神副本Ⅳ','降神副本第四境界','通关<color=\'#71e831\'>降神副本</color>--<color=\'#71e834\'>噩梦模式</color>',2,0,6,370,0,0,0,0,0,2030103,2030105,'null','[]','0',0,0,0,0,'[]','[[[\"fin_dungeon\",\"11\",\"5403\",\"1\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{2,36020001,10}]',0,0,0,'[]','[]','[]',0,5403,4,0),(2030105,'降神副本Ⅴ','降神副本第五境界','通关<color=\'#71e831\'>降神副本</color>--<color=\'#71e835\'>炼狱模式</color>',2,0,6,500,0,0,0,0,0,2030104,0,'null','[]','0',0,0,0,0,'[]','[[[\"fin_dungeon\",\"11\",\"5404\",\"1\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{2,36020001,10}]',0,0,0,'[]','[]','[]',0,5404,4,0),(2040101,'装备副本Ⅰ','装备副本第一难度','通关<color=\'#71e831\'>装备副本</color>--<color=\'#71e831\'>新手模式</color>',2,0,9,105,0,0,0,0,0,0,2040102,'null','[]','0',0,0,0,0,'[]','[[[\"rune_dungeon\",\"21\",\"5\",\"3110\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{2,36020001,10}]',0,0,0,'[]','[]','[]',0,0,2,0),(2040102,'装备副本Ⅱ','装备副本第二难度','通关<color=\'#71e831\'>装备副本</color>--<color=\'#71e832\'>基础模式</color>',2,0,9,140,0,0,0,0,0,2040101,2040103,'null','[]','0',0,0,0,0,'[]','[[[\"rune_dungeon\",\"21\",\"5\",\"3111\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{2,36020001,10}]',0,0,0,'[]','[]','[]',0,0,2,0),(2040103,'装备副本Ⅲ','装备副本第三难度','通关<color=\'#71e831\'>装备副本</color>--<color=\'#71e833\'>普通模式</color>',2,0,9,200,0,0,0,0,0,2040102,2040104,'null','[]','0',0,0,0,0,'[]','[[[\"rune_dungeon\",\"21\",\"5\",\"3112\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{2,36020001,10}]',0,0,0,'[]','[]','[]',0,0,2,0),(2040104,'装备副本Ⅳ','装备副本第四难度','通关<color=\'#71e831\'>装备副本</color>--<color=\'#71e834\'>达人模式</color>',2,0,9,240,0,0,0,0,0,2040103,2040105,'null','[]','0',0,0,0,0,'[]','[[[\"rune_dungeon\",\"21\",\"5\",\"3113\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{2,36020001,10}]',0,0,0,'[]','[]','[]',0,0,2,0),(2040105,'装备副本Ⅴ','装备副本第五难度','通关<color=\'#71e831\'>装备副本</color>--<color=\'#71e835\'>老手模式</color>',2,0,9,300,0,0,0,0,0,2040104,0,'null','[]','0',0,0,0,0,'[]','[[[\"rune_dungeon\",\"21\",\"5\",\"3114\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{2,36020001,10}]',0,0,0,'[]','[]','[]',0,0,2,0),(2050101,'星灵副本Ⅰ','星灵副本第一难度','通关<color=\'#71e831\'>星灵副本</color>--<color=\'#71e831\'>简单模式</color>',2,0,6,85,0,0,0,0,0,0,2050102,'null','[]','0',0,0,0,0,'[]','[[[\"fin_dungeon\",\"11\",\"5300\",\"1\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{2,36020001,10}]',0,0,0,'[]','[]','[]',0,5300,3,0),(2050102,'星灵副本Ⅱ','星灵副本第二难度','通关<color=\'#71e831\'>星灵副本</color>--<color=\'#71e832\'>普通模式</color>',2,0,6,230,0,0,0,0,0,2050101,2050103,'null','[]','0',0,0,0,0,'[]','[[[\"fin_dungeon\",\"11\",\"5301\",\"1\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{2,36020001,10}]',0,0,0,'[]','[]','[]',0,5301,3,0),(2050103,'星灵副本Ⅲ','星灵副本第三难度','通关<color=\'#71e831\'>星灵副本</color>--<color=\'#71e833\'>困难模式</color>',2,0,6,320,0,0,0,0,0,2050102,2050104,'null','[]','0',0,0,0,0,'[]','[[[\"fin_dungeon\",\"11\",\"5302\",\"1\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{2,36020001,10}]',0,0,0,'[]','[]','[]',0,5302,3,0),(2050104,'星灵副本Ⅳ','星灵副本第四难度','通关<color=\'#71e831\'>星灵副本</color>--<color=\'#71e834\'>噩梦模式</color>',2,0,6,380,0,0,0,0,0,2050103,2050105,'null','[]','0',0,0,0,0,'[]','[[[\"fin_dungeon\",\"11\",\"5303\",\"1\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{2,36020001,10}]',0,0,0,'[]','[]','[]',0,5303,3,0),(2050105,'星灵副本Ⅴ','星灵副本第五难度','通关<color=\'#71e831\'>星灵副本</color>--<color=\'#71e835\'>炼狱模式</color>',2,0,6,510,0,0,0,0,0,2050104,0,'null','[]','0',0,0,0,0,'[]','[[[\"fin_dungeon\",\"11\",\"5304\",\"1\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{2,36020001,10}]',0,0,0,'[]','[]','[]',0,5304,3,0),(2080101,'装备强化Ⅰ','将<color=\'#71e831\'>2</color>件装备强化至<color=\'#71e831\'>10</color>级','将2件装备强化至10级',2,0,8,59,9999,0,0,0,0,0,2080102,'null','[]','0',0,0,0,0,'[]','[[[\"stren_equip\",\"8\",\"2\",\"10\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{2,36020001,10}]',1,0,0,'[]','[]','[]',0,0,0,0),(2080102,'装备强化Ⅱ','将<color=\'#71e831\'>6</color>件装备强化至<color=\'#71e831\'>10</color>级','将4件装备强化至25级',2,0,8,65,9999,0,0,0,0,2080101,2080103,'null','[]','0',0,0,0,0,'[]','[[[\"stren_equip\",\"8\",\"6\",\"10\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{2,36020001,10}]',1,0,0,'[]','[]','[]',0,0,0,0),(2080103,'装备强化Ⅲ','将<color=\'#71e831\'>6</color>件装备强化至<color=\'#71e831\'>40</color>级','将6件装备强化至40级',2,0,8,200,9999,0,0,0,0,2080102,0,'null','[]','0',0,0,0,0,'[]','[[[\"stren_equip\",\"8\",\"6\",\"15\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{2,36020001,10}]',1,0,0,'[]','[]','[]',0,0,0,0),(2090101,'精灵秘境','完成1次精灵秘境','',2,0,0,9999,9999,0,0,0,0,0,0,'null','[]','0',0,0,0,0,'[]','[[]]',0,'[{0,32010046,1}]',1,0,0,'[]','[]','[]',0,0,0,0),(2090201,'装备副本','完成1次装备副本','',2,0,0,9999,9999,0,0,0,0,0,0,'null','[]','0',10079010,0,0,0,'[]','[[]]',0,'[{0,32010046,1}]',1,0,1,'[]','[]','[]',0,0,0,0),(2110201,'勇者试炼Ⅰ','通关勇者试炼','任务提示',2,0,0,9999,0,0,0,0,0,0,2110202,'null','[]','0',0,0,0,0,'[]','[[[\"fin_dungeon\",\"11\",\"2201\",\"0\",\"1\",\"0\",\"0\",\"0\"]]]',0,'[{0,32010043,1}]',1,0,0,'[]','[]','[]',0,0,0,0),(2110202,'圣器试炼Ⅱ','通关圣器试炼Ⅱ','通关圣器试炼Ⅱ',2,0,0,100,0,0,0,0,0,0,2110203,'null','[]','0',0,0,0,0,'[]','[[[\"fin_dungeon\",\"11\",\"2202\",\"0\",\"1\",\"0\",\"0\",\"0\"]]]',0,'[{0,32010043,1}]',0,0,0,'[]','[]','[]',0,0,0,0),(2110203,'圣器试炼Ⅲ','通关圣器试炼Ⅲ','通关圣器试炼Ⅲ',2,0,0,145,0,0,0,0,0,2110202,2110204,'null','[]','0',0,0,0,0,'[]','[[[\"fin_dungeon\",\"11\",\"2203\",\"0\",\"1\",\"0\",\"0\",\"0\"]]]',0,'[{0,32010043,1}]',1,0,0,'[]','[]','[]',0,0,1,0),(2110204,'圣器试炼Ⅳ','通关圣器试炼Ⅳ','通关圣器试炼Ⅳ',2,0,0,195,0,0,0,0,0,2110203,0,'null','[]','0',0,0,0,0,'[]','[[[\"fin_dungeon\",\"11\",\"2204\",\"0\",\"1\",\"0\",\"0\",\"0\"]]]',0,'[{0,32010043,1}]',1,0,0,'[]','[]','[]',0,0,1,0),(2110205,'勇者试炼Ⅴ','通过勇者试炼Ⅴ','任务提示',2,0,0,9999,0,0,0,0,0,2110204,0,'null','[]','0',0,0,0,0,'[]','[[[\"fin_dungeon\",\"11\",\"2205\",\"0\",\"1\",\"0\",\"0\",\"0\"]]]',0,'[{0,32010043,1}]',0,0,0,'[]','[]','[]',0,0,0,0),(2130101,'广交好友','添加<color=\'#71e831\'>5</color>名好友','添加<color=\'#71e831\'>5</color>名好友',2,0,0,80,0,0,0,0,0,0,0,'null','[]','0',0,0,0,0,'[]','[[[\"add_friend\",\"13\",\"0\",\"5\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{2,36020001,10}]',0,0,1,'[]','[]','[]',0,0,0,0),(2150101,'装备吞噬','吞噬1件1阶紫色及以上装备','吞噬1件1阶紫色及以上装备',2,0,0,100,0,0,0,0,0,0,0,'null','[]','0',0,0,0,0,'[]','[[[\"devour_equip\",\"26\",\"1\",\"2\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{2,36020001,10}]',0,0,0,'[]','[]','[]',0,0,0,0),(2160101,'公会神兽','参加1次<color=\'#71e831\'>公会神兽</color>','任务提示',2,0,0,9999,9999,0,0,0,0,0,0,'null','[]','10039099',10079010,0,0,0,'[]','[[[\"guild_activity\",\"16\",\"1\",\"1\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{0,32010047,1}]',0,0,1,'[]','[]','[]',0,0,0,0),(2160201,'公会篝火','参加1次<color=\'#71e831\'>公会篝火</color>','任务提示',2,0,0,150,0,0,0,0,0,0,0,'null','[]','0',0,0,0,0,'[]','[[[\"guild_activity\",\"16\",\"2\",\"1\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{2,36020001,10}]',0,0,0,'[]','[]','[]',0,0,0,0),(2160301,'公会守卫','参加1次<color=\'#71e831\'>公会守卫</color>','任务提示',2,0,0,150,0,0,0,0,0,0,0,'null','[]','0',0,0,0,0,'[]','[[[\"guild_activity\",\"16\",\"3\",\"1\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{2,36020001,10}]',0,0,0,'[]','[]','[]',0,0,0,0),(2160401,'公会争霸','参加1次<color=\'#71e831\'>公会争霸</color>','任务提示',2,0,0,150,0,0,0,0,0,0,0,'null','[]','0',0,0,0,0,'[]','[[[\"guild_activity\",\"16\",\"4\",\"1\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{2,36020001,10}]',0,0,0,'[]','[]','[]',0,0,0,0),(2170101,'捐献装备','捐献1件装备到公会仓库','任务提示',2,0,0,150,0,0,0,0,0,0,0,'null','[]','0',0,0,0,0,'[]','[[[\"guild_donate\",\"17\",\"0\",\"1\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{2,36020001,10}]',0,0,0,'[]','[]','[]',0,0,0,0),(2190101,'购买商品','在交易市场购买<color=\'#71e831\'>1</color>件商品','任务提示',2,0,0,160,0,0,0,0,0,2200101,0,'null','[]','0',0,0,0,0,'[]','[[[\"buy_from_trading\",\"19\",\"0\",\"1\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{2,36020001,10}]',0,0,0,'[]','[]','[]',0,0,0,0),(2200101,'上架物品','在交易市场上架<color=\'#71e831\'>1</color>件商品','任务提示',2,0,0,160,0,0,0,0,0,0,0,'null','[]','0',0,0,0,0,'[]','[[[\"trading_putaway\",\"20\",\"0\",\"1\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{2,36020001,10}]',0,0,0,'[]','[]','[]',0,0,0,0),(2230101,'合成门票','合成1张经验副本门票','合成1张经验副本门票',2,0,10,9999,9999,0,0,0,0,0,0,'null','[]','0',0,0,0,0,'[]','[[[\"goods_compose\",\"23\",\"38030001\",\"1\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{2,36020001,10}]',1,0,0,'[]','[]','[]',0,0,0,0),(2240101,'游戏活跃','游戏活跃度达到140点','游戏活跃度达到140点',2,0,0,120,0,0,0,0,0,0,0,'null','[]','0',0,0,0,0,'[]','[[[\"day_activity\",\"24\",\"0\",\"140\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{2,36020001,10}]',1,0,0,'[]','[]','[]',0,0,0,0),(2250101,'击杀首领Ⅰ','击杀首领Ⅰ','击杀首领',2,0,1,130,0,0,0,0,0,0,2250102,'null','[]','0',0,0,0,0,'[]','[[[\"kill_boss_id\",\"27\",\"1202003\",\"1\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{2,36020001,10}]',0,0,0,'[]','[]','[]',0,0,0,0),(2250102,'击杀首领Ⅱ','击杀首领Ⅱ','击杀首领Ⅱ',2,0,1,185,0,0,0,0,0,2250101,2250103,'null','[]','0',0,0,0,0,'[]','[[[\"kill_boss_id\",\"27\",\"1202006\",\"1\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{2,36020001,10}]',0,0,0,'[]','[]','[]',0,0,0,0),(2250103,'击杀首领Ⅲ','击杀首领Ⅲ','击杀首领Ⅲ',2,0,1,220,0,0,0,0,0,2250102,0,'null','[]','0',0,0,0,0,'[]','[[[\"kill_boss_id\",\"27\",\"1203002\",\"1\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{2,36020001,10}]',0,0,0,'[]','[]','[]',0,0,0,0),(2260101,'神格挑战Ⅰ','神格挑战Ⅰ','完成神格副本第1层',2,0,9,120,0,0,0,0,0,0,2260102,'null','[]','0',0,0,0,0,'[]','[[[\"rune_dungeon\",\"21\",\"21\",\"56000\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{2,36020001,10}]',0,0,0,'[]','[]','[]',0,0,2,0),(2260102,'神格挑战Ⅱ','神格挑战Ⅱ','神格挑战Ⅱ',2,0,9,120,0,0,0,0,0,2260101,0,'null','[]','0',0,0,0,0,'[]','[[[\"rune_dungeon\",\"21\",\"21\",\"56002\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{2,36020001,10}]',0,0,0,'[]','[]','[]',0,0,2,0),(2270101,'魂珠塔Ⅰ','魂珠塔Ⅰ','通关魂珠塔第一层',2,0,9,110,0,0,0,0,0,0,2270102,'null','[]','0',0,0,0,0,'[]','[[[\"rune_dungeon\",\"21\",\"20\",\"5900\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{2,36020001,10}]',0,0,0,'[]','[]','[]',0,0,1,0),(2270102,'魂珠塔Ⅱ','宝石塔Ⅱ','宝石塔Ⅱ',2,0,9,110,0,0,0,0,0,2270101,2270103,'null','[]','0',0,0,0,0,'[]','[[[\"rune_dungeon\",\"21\",\"20\",\"5903\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{2,36020001,10}]',0,0,0,'[]','[]','[]',0,0,1,0),(2270103,'魂珠塔Ⅲ','宝石塔Ⅲ','宝石塔Ⅲ',2,0,9,110,0,0,0,0,0,2270102,2270104,'null','[]','0',0,0,0,0,'[]','[[[\"rune_dungeon\",\"21\",\"20\",\"5907\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{2,36020001,10}]',0,0,0,'[]','[]','[]',0,0,1,0),(2270104,'魂珠塔Ⅳ','宝石塔Ⅳ','宝石塔Ⅳ',2,0,9,110,0,0,0,0,0,2270103,2270105,'null','[]','0',0,0,0,0,'[]','[[[\"rune_dungeon\",\"21\",\"20\",\"5911\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{2,36020001,10}]',0,0,0,'[]','[]','[]',0,0,1,0),(2270105,'魂珠塔Ⅴ','宝石塔Ⅴ','宝石塔Ⅴ',2,0,9,110,0,0,0,0,0,2270104,2270106,'null','[]','0',0,0,0,0,'[]','[[[\"rune_dungeon\",\"21\",\"20\",\"5915\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{2,36020001,10}]',0,0,0,'[]','[]','[]',0,0,1,0),(2270106,'魂珠塔Ⅵ','宝石塔Ⅵ','宝石塔Ⅵ',2,0,9,110,0,0,0,0,0,2270105,2270107,'null','[]','0',0,0,0,0,'[]','[[[\"rune_dungeon\",\"21\",\"20\",\"5919\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{2,36020001,10}]',0,0,0,'[]','[]','[]',0,0,1,0),(2270107,'魂珠塔Ⅶ','宝石塔Ⅶ','宝石塔Ⅶ',2,0,9,110,0,0,0,0,0,2270106,2270108,'null','[]','0',0,0,0,0,'[]','[[[\"rune_dungeon\",\"21\",\"20\",\"5923\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{2,36020001,10}]',0,0,0,'[]','[]','[]',0,0,1,0),(2270108,'魂珠塔Ⅷ','宝石塔Ⅷ','宝石塔Ⅷ',2,0,9,110,0,0,0,0,0,2270107,2270109,'null','[]','0',0,0,0,0,'[]','[[[\"rune_dungeon\",\"21\",\"20\",\"5927\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{2,36020001,10}]',0,0,0,'[]','[]','[]',0,0,1,0),(2270109,'魂珠塔Ⅸ','宝石塔Ⅸ','宝石塔Ⅸ',2,0,9,110,0,0,0,0,0,2270108,2270110,'null','[]','0',0,0,0,0,'[]','[[[\"rune_dungeon\",\"21\",\"20\",\"5931\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{2,36020001,10}]',0,0,0,'[]','[]','[]',0,0,1,0),(2270110,'魂珠塔Ⅹ','宝石塔Ⅹ','宝石塔Ⅹ',2,0,9,110,0,0,0,0,0,2270109,2270111,'null','[]','0',0,0,0,0,'[]','[[[\"rune_dungeon\",\"21\",\"20\",\"5935\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{2,36020001,10}]',0,0,0,'[]','[]','[]',0,0,1,0),(2270111,'魂珠塔Ⅺ','宝石塔Ⅺ','宝石塔Ⅺ',2,0,9,110,0,0,0,0,0,2270110,0,'null','[]','0',0,0,0,0,'[]','[[[\"rune_dungeon\",\"21\",\"20\",\"5939\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{2,36020001,10}]',0,0,0,'[]','[]','[]',0,0,1,0),(2280101,'钓鱼之路','钓鱼之路开始了，努力成为万中无一的钓鱼王者吧！','进行一次钓鱼活动',2,0,2,170,0,0,0,0,0,0,0,'null','[]','0',0,0,0,0,'[]','[[[\"fish\",\"28\",\"0\",\"1\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{2,36020001,10}]',0,0,0,'[]','[]','[]',0,0,0,0),(2290101,'烹饪之路','烹饪之路开始了，朝着料理大师的目标前进吧！','进行一次烹饪活动',2,0,2,160,0,0,0,0,0,0,0,'null','[]','0',0,0,0,0,'[]','[[[\"cook\",\"29\",\"0\",\"1\",\"0\",\"0\",\"0\",\"0\"]]]',0,'[{2,36020001,10}]',0,0,0,'[]','[]','[]',0,0,0,0),(60010001,'公会任务','最近有一波流匪四处打劫，我们公会的一些生意也受到了影响，你赶快去清理下吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,1,199,0,0,0,0,0,0,'null','[]','10019001',10019002,30034,30035,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,2748409},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60010200,'公会任务','最近有一波流匪四处打劫，我们公会的一些生意也受到了影响，你赶快去清理下吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,200,239,0,0,0,0,0,0,'null','[]','10019001',10019002,30034,30035,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,5339994},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60010240,'公会任务','最近有一波流匪四处打劫，我们公会的一些生意也受到了影响，你赶快去清理下吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,240,279,0,0,0,0,0,0,'null','[]','10019001',10019002,30034,30035,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,7306895},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60010280,'公会任务','最近有一波流匪四处打劫，我们公会的一些生意也受到了影响，你赶快去清理下吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,280,319,0,0,0,0,0,0,'null','[]','10019001',10019002,30034,30035,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,8229784},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60010320,'公会任务','最近有一波流匪四处打劫，我们公会的一些生意也受到了影响，你赶快去清理下吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,320,349,0,0,0,0,0,0,'null','[]','10019001',10019002,30034,30035,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,9343005},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60010350,'公会任务','最近有一波流匪四处打劫，我们公会的一些生意也受到了影响，你赶快去清理下吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,350,374,0,0,0,0,0,0,'null','[]','10019001',10019002,30034,30035,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,9862717},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60010375,'公会任务','最近有一波流匪四处打劫，我们公会的一些生意也受到了影响，你赶快去清理下吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,375,399,0,0,0,0,0,0,'null','[]','10019001',10019002,30034,30035,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,15936624},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60010400,'公会任务','最近有一波流匪四处打劫，我们公会的一些生意也受到了影响，你赶快去清理下吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,400,424,0,0,0,0,0,0,'null','[]','10019001',10019002,30034,30035,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,22692436},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60010425,'公会任务','最近有一波流匪四处打劫，我们公会的一些生意也受到了影响，你赶快去清理下吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,425,449,0,0,0,0,0,0,'null','[]','10019001',10019002,30034,30035,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,26763864},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60010450,'公会任务','最近有一波流匪四处打劫，我们公会的一些生意也受到了影响，你赶快去清理下吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,450,474,0,0,0,0,0,0,'null','[]','10019001',10019002,30034,30035,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,33405484},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60010475,'公会任务','最近有一波流匪四处打劫，我们公会的一些生意也受到了影响，你赶快去清理下吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,475,514,0,0,0,0,0,0,'null','[]','10019001',10019002,30034,30035,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,39967205},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60010515,'公会任务','最近有一波流匪四处打劫，我们公会的一些生意也受到了影响，你赶快去清理下吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,515,549,0,0,0,0,0,0,'null','[]','10019001',10019002,30034,30035,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,42813004},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60010550,'公会任务','最近有一波流匪四处打劫，我们公会的一些生意也受到了影响，你赶快去清理下吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,550,574,0,0,0,0,0,0,'null','[]','10019001',10019002,30034,30035,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,68954239},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60010575,'公会任务','最近有一波流匪四处打劫，我们公会的一些生意也受到了影响，你赶快去清理下吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,575,594,0,0,0,0,0,0,'null','[]','10019001',10019002,30034,30035,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,75019679},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60010595,'公会任务','最近有一波流匪四处打劫，我们公会的一些生意也受到了影响，你赶快去清理下吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,595,609,0,0,0,0,0,0,'null','[]','10019001',10019002,30034,30035,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,81725562},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60010610,'公会任务','最近有一波流匪四处打劫，我们公会的一些生意也受到了影响，你赶快去清理下吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,610,629,0,0,0,0,0,0,'null','[]','10019001',10019002,30034,30035,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,83518586},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60010630,'公会任务','最近有一波流匪四处打劫，我们公会的一些生意也受到了影响，你赶快去清理下吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,630,649,0,0,0,0,0,0,'null','[]','10019001',10019002,30034,30035,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,89851919},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60010650,'公会任务','最近有一波流匪四处打劫，我们公会的一些生意也受到了影响，你赶快去清理下吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,650,669,0,0,0,0,0,0,'null','[]','10019001',10019002,30034,30035,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,91122871},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60010670,'公会任务','最近有一波流匪四处打劫，我们公会的一些生意也受到了影响，你赶快去清理下吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,670,689,0,0,0,0,0,0,'null','[]','10019001',10019002,30034,30035,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,97122871},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60010690,'公会任务','最近有一波流匪四处打劫，我们公会的一些生意也受到了影响，你赶快去清理下吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,690,709,0,0,0,0,0,0,'null','[]','10019001',10019002,30034,30035,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,97966728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60010710,'公会任务','最近有一波流匪四处打劫，我们公会的一些生意也受到了影响，你赶快去清理下吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,710,729,0,0,0,0,0,0,'null','[]','10019001',10019002,30034,30035,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,103666728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60010730,'公会任务','最近有一波流匪四处打劫，我们公会的一些生意也受到了影响，你赶快去清理下吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,730,749,0,0,0,0,0,0,'null','[]','10019001',10019002,30034,30035,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,109366728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60010750,'公会任务','最近有一波流匪四处打劫，我们公会的一些生意也受到了影响，你赶快去清理下吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,750,769,0,0,0,0,0,0,'null','[]','10019001',10019002,30034,30035,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,115066728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60010770,'公会任务','最近有一波流匪四处打劫，我们公会的一些生意也受到了影响，你赶快去清理下吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,770,789,0,0,0,0,0,0,'null','[]','10019001',10019002,30034,30035,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,120766728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60010790,'公会任务','最近有一波流匪四处打劫，我们公会的一些生意也受到了影响，你赶快去清理下吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,790,809,0,0,0,0,0,0,'null','[]','10019001',10019002,30034,30035,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60010810,'公会任务','最近有一波流匪四处打劫，我们公会的一些生意也受到了影响，你赶快去清理下吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,810,829,0,0,0,0,0,0,'null','[]','10019001',10019002,30034,30035,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60010830,'公会任务','最近有一波流匪四处打劫，我们公会的一些生意也受到了影响，你赶快去清理下吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,830,849,0,0,0,0,0,0,'null','[]','10019001',10019002,30034,30035,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60010850,'公会任务','最近有一波流匪四处打劫，我们公会的一些生意也受到了影响，你赶快去清理下吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,850,869,0,0,0,0,0,0,'null','[]','10019001',10019002,30034,30035,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60010870,'公会任务','最近有一波流匪四处打劫，我们公会的一些生意也受到了影响，你赶快去清理下吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,870,889,0,0,0,0,0,0,'null','[]','10019001',10019002,30034,30035,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60010890,'公会任务','最近有一波流匪四处打劫，我们公会的一些生意也受到了影响，你赶快去清理下吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,890,909,0,0,0,0,0,0,'null','[]','10019001',10019002,30034,30035,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60010910,'公会任务','最近有一波流匪四处打劫，我们公会的一些生意也受到了影响，你赶快去清理下吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,910,929,0,0,0,0,0,0,'null','[]','10019001',10019002,30034,30035,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60010930,'公会任务','最近有一波流匪四处打劫，我们公会的一些生意也受到了影响，你赶快去清理下吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,930,949,0,0,0,0,0,0,'null','[]','10019001',10019002,30034,30035,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60010950,'公会任务','最近有一波流匪四处打劫，我们公会的一些生意也受到了影响，你赶快去清理下吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,950,969,0,0,0,0,0,0,'null','[]','10019001',10019002,30034,30035,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60010970,'公会任务','最近有一波流匪四处打劫，我们公会的一些生意也受到了影响，你赶快去清理下吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,970,989,0,0,0,0,0,0,'null','[]','10019001',10019002,30034,30035,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60010990,'公会任务','最近有一波流匪四处打劫，我们公会的一些生意也受到了影响，你赶快去清理下吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,990,1000,0,0,0,0,0,0,'null','[]','10019001',10019002,30034,30035,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60020001,'公会任务','东部平原上的粮食最近一直丢失，你过去看看什么情况吧！要是有人作妖捣乱，你顺便收拾下！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,1,199,0,0,0,0,0,0,'null','[]','10049015',10049016,30036,30037,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"40\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,2748409},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60020200,'公会任务','东部平原上的粮食最近一直丢失，你过去看看什么情况吧！要是有人作妖捣乱，你顺便收拾下！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,200,239,0,0,0,0,0,0,'null','[]','10049015',10049016,30036,30037,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"40\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,5339994},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60020240,'公会任务','东部平原上的粮食最近一直丢失，你过去看看什么情况吧！要是有人作妖捣乱，你顺便收拾下！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,240,279,0,0,0,0,0,0,'null','[]','10049015',10049016,30036,30037,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"40\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,7306895},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60020280,'公会任务','东部平原上的粮食最近一直丢失，你过去看看什么情况吧！要是有人作妖捣乱，你顺便收拾下！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,280,319,0,0,0,0,0,0,'null','[]','10049015',10049016,30036,30037,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"40\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,8229784},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60020320,'公会任务','东部平原上的粮食最近一直丢失，你过去看看什么情况吧！要是有人作妖捣乱，你顺便收拾下！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,320,349,0,0,0,0,0,0,'null','[]','10049015',10049016,30036,30037,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"40\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,9343005},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60020350,'公会任务','东部平原上的粮食最近一直丢失，你过去看看什么情况吧！要是有人作妖捣乱，你顺便收拾下！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,350,374,0,0,0,0,0,0,'null','[]','10049015',10049016,30036,30037,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"40\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,9862717},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60020375,'公会任务','东部平原上的粮食最近一直丢失，你过去看看什么情况吧！要是有人作妖捣乱，你顺便收拾下！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,375,399,0,0,0,0,0,0,'null','[]','10049015',10049016,30036,30037,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"40\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,15936624},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60020400,'公会任务','东部平原上的粮食最近一直丢失，你过去看看什么情况吧！要是有人作妖捣乱，你顺便收拾下！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,400,424,0,0,0,0,0,0,'null','[]','10049015',10049016,30036,30037,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"40\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,22692436},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60020425,'公会任务','东部平原上的粮食最近一直丢失，你过去看看什么情况吧！要是有人作妖捣乱，你顺便收拾下！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,425,449,0,0,0,0,0,0,'null','[]','10049015',10049016,30036,30037,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"40\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,26763864},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60020450,'公会任务','东部平原上的粮食最近一直丢失，你过去看看什么情况吧！要是有人作妖捣乱，你顺便收拾下！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,450,474,0,0,0,0,0,0,'null','[]','10049015',10049016,30036,30037,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"40\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,33405484},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60020475,'公会任务','东部平原上的粮食最近一直丢失，你过去看看什么情况吧！要是有人作妖捣乱，你顺便收拾下！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,475,514,0,0,0,0,0,0,'null','[]','10049015',10049016,30036,30037,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"40\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,39967205},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60020515,'公会任务','东部平原上的粮食最近一直丢失，你过去看看什么情况吧！要是有人作妖捣乱，你顺便收拾下！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,515,549,0,0,0,0,0,0,'null','[]','10049015',10049016,30036,30037,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"40\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,42813004},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60020550,'公会任务','东部平原上的粮食最近一直丢失，你过去看看什么情况吧！要是有人作妖捣乱，你顺便收拾下！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,550,574,0,0,0,0,0,0,'null','[]','10049015',10049016,30036,30037,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"40\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,68954239},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60020575,'公会任务','东部平原上的粮食最近一直丢失，你过去看看什么情况吧！要是有人作妖捣乱，你顺便收拾下！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,575,594,0,0,0,0,0,0,'null','[]','10049015',10049016,30036,30037,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"40\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,75019679},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60020595,'公会任务','东部平原上的粮食最近一直丢失，你过去看看什么情况吧！要是有人作妖捣乱，你顺便收拾下！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,595,609,0,0,0,0,0,0,'null','[]','10049015',10049016,30036,30037,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"40\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,81725562},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60020610,'公会任务','东部平原上的粮食最近一直丢失，你过去看看什么情况吧！要是有人作妖捣乱，你顺便收拾下！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,610,629,0,0,0,0,0,0,'null','[]','10049015',10049016,30036,30037,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"40\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,83518586},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60020630,'公会任务','东部平原上的粮食最近一直丢失，你过去看看什么情况吧！要是有人作妖捣乱，你顺便收拾下！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,630,649,0,0,0,0,0,0,'null','[]','10049015',10049016,30036,30037,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"40\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,89851919},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60020650,'公会任务','东部平原上的粮食最近一直丢失，你过去看看什么情况吧！要是有人作妖捣乱，你顺便收拾下！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,650,669,0,0,0,0,0,0,'null','[]','10049015',10049016,30036,30037,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"40\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,91122871},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60020670,'公会任务','东部平原上的粮食最近一直丢失，你过去看看什么情况吧！要是有人作妖捣乱，你顺便收拾下！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,670,689,0,0,0,0,0,0,'null','[]','10049015',10049016,30036,30037,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"40\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,97122871},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60020690,'公会任务','东部平原上的粮食最近一直丢失，你过去看看什么情况吧！要是有人作妖捣乱，你顺便收拾下！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,690,709,0,0,0,0,0,0,'null','[]','10049015',10049016,30036,30037,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"40\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,97966728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60020710,'公会任务','东部平原上的粮食最近一直丢失，你过去看看什么情况吧！要是有人作妖捣乱，你顺便收拾下！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,710,729,0,0,0,0,0,0,'null','[]','10049015',10049016,30036,30037,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"40\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,103666728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60020730,'公会任务','东部平原上的粮食最近一直丢失，你过去看看什么情况吧！要是有人作妖捣乱，你顺便收拾下！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,730,749,0,0,0,0,0,0,'null','[]','10049015',10049016,30036,30037,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"40\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,109366728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60020750,'公会任务','东部平原上的粮食最近一直丢失，你过去看看什么情况吧！要是有人作妖捣乱，你顺便收拾下！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,750,769,0,0,0,0,0,0,'null','[]','10049015',10049016,30036,30037,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"40\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,115066728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60020770,'公会任务','东部平原上的粮食最近一直丢失，你过去看看什么情况吧！要是有人作妖捣乱，你顺便收拾下！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,770,789,0,0,0,0,0,0,'null','[]','10049015',10049016,30036,30037,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"40\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,120766728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60020790,'公会任务','东部平原上的粮食最近一直丢失，你过去看看什么情况吧！要是有人作妖捣乱，你顺便收拾下！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,790,809,0,0,0,0,0,0,'null','[]','10049015',10049016,30036,30037,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"40\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60020810,'公会任务','东部平原上的粮食最近一直丢失，你过去看看什么情况吧！要是有人作妖捣乱，你顺便收拾下！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,810,829,0,0,0,0,0,0,'null','[]','10049015',10049016,30036,30037,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"40\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60020830,'公会任务','东部平原上的粮食最近一直丢失，你过去看看什么情况吧！要是有人作妖捣乱，你顺便收拾下！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,830,849,0,0,0,0,0,0,'null','[]','10049015',10049016,30036,30037,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"40\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60020850,'公会任务','东部平原上的粮食最近一直丢失，你过去看看什么情况吧！要是有人作妖捣乱，你顺便收拾下！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,850,869,0,0,0,0,0,0,'null','[]','10049015',10049016,30036,30037,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"40\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60020870,'公会任务','东部平原上的粮食最近一直丢失，你过去看看什么情况吧！要是有人作妖捣乱，你顺便收拾下！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,870,889,0,0,0,0,0,0,'null','[]','10049015',10049016,30036,30037,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"40\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60020890,'公会任务','东部平原上的粮食最近一直丢失，你过去看看什么情况吧！要是有人作妖捣乱，你顺便收拾下！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,890,909,0,0,0,0,0,0,'null','[]','10049015',10049016,30036,30037,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"40\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60020910,'公会任务','东部平原上的粮食最近一直丢失，你过去看看什么情况吧！要是有人作妖捣乱，你顺便收拾下！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,910,929,0,0,0,0,0,0,'null','[]','10049015',10049016,30036,30037,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"40\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60020930,'公会任务','东部平原上的粮食最近一直丢失，你过去看看什么情况吧！要是有人作妖捣乱，你顺便收拾下！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,930,949,0,0,0,0,0,0,'null','[]','10049015',10049016,30036,30037,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"40\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60020950,'公会任务','东部平原上的粮食最近一直丢失，你过去看看什么情况吧！要是有人作妖捣乱，你顺便收拾下！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,950,969,0,0,0,0,0,0,'null','[]','10049015',10049016,30036,30037,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"40\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60020970,'公会任务','东部平原上的粮食最近一直丢失，你过去看看什么情况吧！要是有人作妖捣乱，你顺便收拾下！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,970,989,0,0,0,0,0,0,'null','[]','10049015',10049016,30036,30037,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"40\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60020990,'公会任务','东部平原上的粮食最近一直丢失，你过去看看什么情况吧！要是有人作妖捣乱，你顺便收拾下！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,990,1000,0,0,0,0,0,0,'null','[]','10049015',10049016,30036,30037,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"40\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60030001,'公会任务','公会有成员反馈，很多护送的人到城郊密林就会失踪，你过去看看什么情况！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,1,199,0,0,0,0,0,0,'null','[]','10019004',10019005,30038,30039,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,2748409},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60030200,'公会任务','公会有成员反馈，很多护送的人到城郊密林就会失踪，你过去看看什么情况！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,200,239,0,0,0,0,0,0,'null','[]','10019004',10019005,30038,30039,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,5339994},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60030240,'公会任务','公会有成员反馈，很多护送的人到城郊密林就会失踪，你过去看看什么情况！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,240,279,0,0,0,0,0,0,'null','[]','10019004',10019005,30038,30039,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,7306895},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60030280,'公会任务','公会有成员反馈，很多护送的人到城郊密林就会失踪，你过去看看什么情况！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,280,319,0,0,0,0,0,0,'null','[]','10019004',10019005,30038,30039,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,8229784},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60030320,'公会任务','公会有成员反馈，很多护送的人到城郊密林就会失踪，你过去看看什么情况！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,320,349,0,0,0,0,0,0,'null','[]','10019004',10019005,30038,30039,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,9343005},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60030350,'公会任务','公会有成员反馈，很多护送的人到城郊密林就会失踪，你过去看看什么情况！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,350,374,0,0,0,0,0,0,'null','[]','10019004',10019005,30038,30039,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,9862717},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60030375,'公会任务','公会有成员反馈，很多护送的人到城郊密林就会失踪，你过去看看什么情况！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,375,399,0,0,0,0,0,0,'null','[]','10019004',10019005,30038,30039,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,15936624},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60030400,'公会任务','公会有成员反馈，很多护送的人到城郊密林就会失踪，你过去看看什么情况！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,400,424,0,0,0,0,0,0,'null','[]','10019004',10019005,30038,30039,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,22692436},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60030425,'公会任务','公会有成员反馈，很多护送的人到城郊密林就会失踪，你过去看看什么情况！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,425,449,0,0,0,0,0,0,'null','[]','10019004',10019005,30038,30039,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,26763864},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60030450,'公会任务','公会有成员反馈，很多护送的人到城郊密林就会失踪，你过去看看什么情况！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,450,474,0,0,0,0,0,0,'null','[]','10019004',10019005,30038,30039,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,33405484},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60030475,'公会任务','公会有成员反馈，很多护送的人到城郊密林就会失踪，你过去看看什么情况！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,475,514,0,0,0,0,0,0,'null','[]','10019004',10019005,30038,30039,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,39967205},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60030515,'公会任务','公会有成员反馈，很多护送的人到城郊密林就会失踪，你过去看看什么情况！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,515,549,0,0,0,0,0,0,'null','[]','10019004',10019005,30038,30039,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,42813004},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60030550,'公会任务','公会有成员反馈，很多护送的人到城郊密林就会失踪，你过去看看什么情况！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,550,574,0,0,0,0,0,0,'null','[]','10019004',10019005,30038,30039,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,68954239},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60030575,'公会任务','公会有成员反馈，很多护送的人到城郊密林就会失踪，你过去看看什么情况！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,575,594,0,0,0,0,0,0,'null','[]','10019004',10019005,30038,30039,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,75019679},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60030595,'公会任务','公会有成员反馈，很多护送的人到城郊密林就会失踪，你过去看看什么情况！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,595,609,0,0,0,0,0,0,'null','[]','10019004',10019005,30038,30039,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,81725562},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60030610,'公会任务','公会有成员反馈，很多护送的人到城郊密林就会失踪，你过去看看什么情况！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,610,629,0,0,0,0,0,0,'null','[]','10019004',10019005,30038,30039,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,83518586},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60030630,'公会任务','公会有成员反馈，很多护送的人到城郊密林就会失踪，你过去看看什么情况！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,630,649,0,0,0,0,0,0,'null','[]','10019004',10019005,30038,30039,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,89851919},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60030650,'公会任务','公会有成员反馈，很多护送的人到城郊密林就会失踪，你过去看看什么情况！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,650,669,0,0,0,0,0,0,'null','[]','10019004',10019005,30038,30039,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,91122871},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60030670,'公会任务','公会有成员反馈，很多护送的人到城郊密林就会失踪，你过去看看什么情况！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,670,689,0,0,0,0,0,0,'null','[]','10019004',10019005,30038,30039,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,97122871},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60030690,'公会任务','公会有成员反馈，很多护送的人到城郊密林就会失踪，你过去看看什么情况！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,690,709,0,0,0,0,0,0,'null','[]','10019004',10019005,30038,30039,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,97966728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60030710,'公会任务','公会有成员反馈，很多护送的人到城郊密林就会失踪，你过去看看什么情况！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,710,729,0,0,0,0,0,0,'null','[]','10019004',10019005,30038,30039,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,103666728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60030730,'公会任务','公会有成员反馈，很多护送的人到城郊密林就会失踪，你过去看看什么情况！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,730,749,0,0,0,0,0,0,'null','[]','10019004',10019005,30038,30039,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,109366728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60030750,'公会任务','公会有成员反馈，很多护送的人到城郊密林就会失踪，你过去看看什么情况！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,750,769,0,0,0,0,0,0,'null','[]','10019004',10019005,30038,30039,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,115066728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60030770,'公会任务','公会有成员反馈，很多护送的人到城郊密林就会失踪，你过去看看什么情况！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,770,789,0,0,0,0,0,0,'null','[]','10019004',10019005,30038,30039,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,120766728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60030790,'公会任务','公会有成员反馈，很多护送的人到城郊密林就会失踪，你过去看看什么情况！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,790,809,0,0,0,0,0,0,'null','[]','10019004',10019005,30038,30039,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60030810,'公会任务','公会有成员反馈，很多护送的人到城郊密林就会失踪，你过去看看什么情况！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,810,829,0,0,0,0,0,0,'null','[]','10019004',10019005,30038,30039,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60030830,'公会任务','公会有成员反馈，很多护送的人到城郊密林就会失踪，你过去看看什么情况！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,830,849,0,0,0,0,0,0,'null','[]','10019004',10019005,30038,30039,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60030850,'公会任务','公会有成员反馈，很多护送的人到城郊密林就会失踪，你过去看看什么情况！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,850,869,0,0,0,0,0,0,'null','[]','10019004',10019005,30038,30039,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60030870,'公会任务','公会有成员反馈，很多护送的人到城郊密林就会失踪，你过去看看什么情况！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,870,889,0,0,0,0,0,0,'null','[]','10019004',10019005,30038,30039,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60030890,'公会任务','公会有成员反馈，很多护送的人到城郊密林就会失踪，你过去看看什么情况！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,890,909,0,0,0,0,0,0,'null','[]','10019004',10019005,30038,30039,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60030910,'公会任务','公会有成员反馈，很多护送的人到城郊密林就会失踪，你过去看看什么情况！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,910,929,0,0,0,0,0,0,'null','[]','10019004',10019005,30038,30039,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60030930,'公会任务','公会有成员反馈，很多护送的人到城郊密林就会失踪，你过去看看什么情况！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,930,949,0,0,0,0,0,0,'null','[]','10019004',10019005,30038,30039,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60030950,'公会任务','公会有成员反馈，很多护送的人到城郊密林就会失踪，你过去看看什么情况！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,950,969,0,0,0,0,0,0,'null','[]','10019004',10019005,30038,30039,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60030970,'公会任务','公会有成员反馈，很多护送的人到城郊密林就会失踪，你过去看看什么情况！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,970,989,0,0,0,0,0,0,'null','[]','10019004',10019005,30038,30039,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60030990,'公会任务','公会有成员反馈，很多护送的人到城郊密林就会失踪，你过去看看什么情况！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,990,1000,0,0,0,0,0,0,'null','[]','10019004',10019005,30038,30039,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"40\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60040001,'公会任务','公会打造急需黎棘晶石，但传闻有怪兽守卫，你看看能不能战胜它！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,1,199,0,0,0,0,0,0,'null','[]','10039003',10039003,30040,30041,0,'[]','[[[\"fin_dungeon\",\"11\",\"2106\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,2748409},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60040200,'公会任务','公会打造急需黎棘晶石，但传闻有怪兽守卫，你看看能不能战胜它！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,200,239,0,0,0,0,0,0,'null','[]','10039003',10039003,30040,30041,0,'[]','[[[\"fin_dungeon\",\"11\",\"2106\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,5339994},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60040240,'公会任务','公会打造急需黎棘晶石，但传闻有怪兽守卫，你看看能不能战胜它！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,240,279,0,0,0,0,0,0,'null','[]','10039003',10039003,30040,30041,0,'[]','[[[\"fin_dungeon\",\"11\",\"2106\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,7306895},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60040280,'公会任务','公会打造急需黎棘晶石，但传闻有怪兽守卫，你看看能不能战胜它！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,280,319,0,0,0,0,0,0,'null','[]','10039003',10039003,30040,30041,0,'[]','[[[\"fin_dungeon\",\"11\",\"2106\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,8229784},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60040320,'公会任务','公会打造急需黎棘晶石，但传闻有怪兽守卫，你看看能不能战胜它！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,320,349,0,0,0,0,0,0,'null','[]','10039003',10039003,30040,30041,0,'[]','[[[\"fin_dungeon\",\"11\",\"2106\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,9343005},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60040350,'公会任务','公会打造急需黎棘晶石，但传闻有怪兽守卫，你看看能不能战胜它！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,350,374,0,0,0,0,0,0,'null','[]','10039003',10039003,30040,30041,0,'[]','[[[\"fin_dungeon\",\"11\",\"2106\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,9862717},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60040375,'公会任务','公会打造急需黎棘晶石，但传闻有怪兽守卫，你看看能不能战胜它！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,375,399,0,0,0,0,0,0,'null','[]','10039003',10039003,30040,30041,0,'[]','[[[\"fin_dungeon\",\"11\",\"2106\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,15936624},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60040400,'公会任务','公会打造急需黎棘晶石，但传闻有怪兽守卫，你看看能不能战胜它！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,400,424,0,0,0,0,0,0,'null','[]','10039003',10039003,30040,30041,0,'[]','[[[\"fin_dungeon\",\"11\",\"2106\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,22692436},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60040425,'公会任务','公会打造急需黎棘晶石，但传闻有怪兽守卫，你看看能不能战胜它！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,425,449,0,0,0,0,0,0,'null','[]','10039003',10039003,30040,30041,0,'[]','[[[\"fin_dungeon\",\"11\",\"2106\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,26763864},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60040450,'公会任务','公会打造急需黎棘晶石，但传闻有怪兽守卫，你看看能不能战胜它！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,450,474,0,0,0,0,0,0,'null','[]','10039003',10039003,30040,30041,0,'[]','[[[\"fin_dungeon\",\"11\",\"2106\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,33405484},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60040475,'公会任务','公会打造急需黎棘晶石，但传闻有怪兽守卫，你看看能不能战胜它！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,475,514,0,0,0,0,0,0,'null','[]','10039003',10039003,30040,30041,0,'[]','[[[\"fin_dungeon\",\"11\",\"2106\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,39967205},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60040515,'公会任务','公会打造急需黎棘晶石，但传闻有怪兽守卫，你看看能不能战胜它！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,515,549,0,0,0,0,0,0,'null','[]','10039003',10039003,30040,30041,0,'[]','[[[\"fin_dungeon\",\"11\",\"2106\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,42813004},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60040550,'公会任务','公会打造急需黎棘晶石，但传闻有怪兽守卫，你看看能不能战胜它！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,550,574,0,0,0,0,0,0,'null','[]','10039003',10039003,30040,30041,0,'[]','[[[\"fin_dungeon\",\"11\",\"2106\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,68954239},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60040575,'公会任务','公会打造急需黎棘晶石，但传闻有怪兽守卫，你看看能不能战胜它！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,575,594,0,0,0,0,0,0,'null','[]','10039003',10039003,30040,30041,0,'[]','[[[\"fin_dungeon\",\"11\",\"2106\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,75019679},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60040595,'公会任务','公会打造急需黎棘晶石，但传闻有怪兽守卫，你看看能不能战胜它！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,595,609,0,0,0,0,0,0,'null','[]','10039003',10039003,30040,30041,0,'[]','[[[\"fin_dungeon\",\"11\",\"2106\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,81725562},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60040610,'公会任务','公会打造急需黎棘晶石，但传闻有怪兽守卫，你看看能不能战胜它！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,610,629,0,0,0,0,0,0,'null','[]','10039003',10039003,30040,30041,0,'[]','[[[\"fin_dungeon\",\"11\",\"2106\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,83518586},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60040630,'公会任务','公会打造急需黎棘晶石，但传闻有怪兽守卫，你看看能不能战胜它！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,630,649,0,0,0,0,0,0,'null','[]','10039003',10039003,30040,30041,0,'[]','[[[\"fin_dungeon\",\"11\",\"2106\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,89851919},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60040650,'公会任务','公会打造急需黎棘晶石，但传闻有怪兽守卫，你看看能不能战胜它！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,650,669,0,0,0,0,0,0,'null','[]','10039003',10039003,30040,30041,0,'[]','[[[\"fin_dungeon\",\"11\",\"2106\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,91122871},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60040670,'公会任务','公会打造急需黎棘晶石，但传闻有怪兽守卫，你看看能不能战胜它！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,670,689,0,0,0,0,0,0,'null','[]','10039003',10039003,30040,30041,0,'[]','[[[\"fin_dungeon\",\"11\",\"2106\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,97122871},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60040690,'公会任务','公会打造急需黎棘晶石，但传闻有怪兽守卫，你看看能不能战胜它！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,690,709,0,0,0,0,0,0,'null','[]','10039003',10039003,30040,30041,0,'[]','[[[\"fin_dungeon\",\"11\",\"2106\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,97966728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60040710,'公会任务','公会打造急需黎棘晶石，但传闻有怪兽守卫，你看看能不能战胜它！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,710,729,0,0,0,0,0,0,'null','[]','10039003',10039003,30040,30041,0,'[]','[[[\"fin_dungeon\",\"11\",\"2106\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,103666728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60040730,'公会任务','公会打造急需黎棘晶石，但传闻有怪兽守卫，你看看能不能战胜它！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,730,749,0,0,0,0,0,0,'null','[]','10039003',10039003,30040,30041,0,'[]','[[[\"fin_dungeon\",\"11\",\"2106\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,109366728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60040750,'公会任务','公会打造急需黎棘晶石，但传闻有怪兽守卫，你看看能不能战胜它！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,750,769,0,0,0,0,0,0,'null','[]','10039003',10039003,30040,30041,0,'[]','[[[\"fin_dungeon\",\"11\",\"2106\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,115066728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60040770,'公会任务','公会打造急需黎棘晶石，但传闻有怪兽守卫，你看看能不能战胜它！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,770,789,0,0,0,0,0,0,'null','[]','10039003',10039003,30040,30041,0,'[]','[[[\"fin_dungeon\",\"11\",\"2106\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,120766728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60040790,'公会任务','公会打造急需黎棘晶石，但传闻有怪兽守卫，你看看能不能战胜它！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,790,809,0,0,0,0,0,0,'null','[]','10039003',10039003,30040,30041,0,'[]','[[[\"fin_dungeon\",\"11\",\"2106\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60040810,'公会任务','公会打造急需黎棘晶石，但传闻有怪兽守卫，你看看能不能战胜它！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,810,829,0,0,0,0,0,0,'null','[]','10039003',10039003,30040,30041,0,'[]','[[[\"fin_dungeon\",\"11\",\"2106\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60040830,'公会任务','公会打造急需黎棘晶石，但传闻有怪兽守卫，你看看能不能战胜它！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,830,849,0,0,0,0,0,0,'null','[]','10039003',10039003,30040,30041,0,'[]','[[[\"fin_dungeon\",\"11\",\"2106\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60040850,'公会任务','公会打造急需黎棘晶石，但传闻有怪兽守卫，你看看能不能战胜它！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,850,869,0,0,0,0,0,0,'null','[]','10039003',10039003,30040,30041,0,'[]','[[[\"fin_dungeon\",\"11\",\"2106\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60040870,'公会任务','公会打造急需黎棘晶石，但传闻有怪兽守卫，你看看能不能战胜它！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,870,889,0,0,0,0,0,0,'null','[]','10039003',10039003,30040,30041,0,'[]','[[[\"fin_dungeon\",\"11\",\"2106\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60040890,'公会任务','公会打造急需黎棘晶石，但传闻有怪兽守卫，你看看能不能战胜它！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,890,909,0,0,0,0,0,0,'null','[]','10039003',10039003,30040,30041,0,'[]','[[[\"fin_dungeon\",\"11\",\"2106\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60040910,'公会任务','公会打造急需黎棘晶石，但传闻有怪兽守卫，你看看能不能战胜它！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,910,929,0,0,0,0,0,0,'null','[]','10039003',10039003,30040,30041,0,'[]','[[[\"fin_dungeon\",\"11\",\"2106\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60040930,'公会任务','公会打造急需黎棘晶石，但传闻有怪兽守卫，你看看能不能战胜它！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,930,949,0,0,0,0,0,0,'null','[]','10039003',10039003,30040,30041,0,'[]','[[[\"fin_dungeon\",\"11\",\"2106\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60040950,'公会任务','公会打造急需黎棘晶石，但传闻有怪兽守卫，你看看能不能战胜它！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,950,969,0,0,0,0,0,0,'null','[]','10039003',10039003,30040,30041,0,'[]','[[[\"fin_dungeon\",\"11\",\"2106\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60040970,'公会任务','公会打造急需黎棘晶石，但传闻有怪兽守卫，你看看能不能战胜它！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,970,989,0,0,0,0,0,0,'null','[]','10039003',10039003,30040,30041,0,'[]','[[[\"fin_dungeon\",\"11\",\"2106\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60040990,'公会任务','公会打造急需黎棘晶石，但传闻有怪兽守卫，你看看能不能战胜它！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,990,1000,0,0,0,0,0,0,'null','[]','10039003',10039003,30040,30041,0,'[]','[[[\"fin_dungeon\",\"11\",\"2106\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60050001,'公会任务','会长夫人被困到罗米尔楼台上，你赶快过去救援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,1,199,0,0,0,0,0,0,'null','[]','10019002',10019002,30042,30043,0,'[]','[[[\"fin_dungeon\",\"11\",\"2107\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,2748409},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60050200,'公会任务','会长夫人被困到罗米尔楼台上，你赶快过去救援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,200,239,0,0,0,0,0,0,'null','[]','10019002',10019002,30042,30043,0,'[]','[[[\"fin_dungeon\",\"11\",\"2107\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,5339994},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60050240,'公会任务','会长夫人被困到罗米尔楼台上，你赶快过去救援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,240,279,0,0,0,0,0,0,'null','[]','10019002',10019002,30042,30043,0,'[]','[[[\"fin_dungeon\",\"11\",\"2107\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,7306895},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60050280,'公会任务','会长夫人被困到罗米尔楼台上，你赶快过去救援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,280,319,0,0,0,0,0,0,'null','[]','10019002',10019002,30042,30043,0,'[]','[[[\"fin_dungeon\",\"11\",\"2107\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,8229784},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60050320,'公会任务','会长夫人被困到罗米尔楼台上，你赶快过去救援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,320,349,0,0,0,0,0,0,'null','[]','10019002',10019002,30042,30043,0,'[]','[[[\"fin_dungeon\",\"11\",\"2107\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,9343005},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60050350,'公会任务','会长夫人被困到罗米尔楼台上，你赶快过去救援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,350,374,0,0,0,0,0,0,'null','[]','10019002',10019002,30042,30043,0,'[]','[[[\"fin_dungeon\",\"11\",\"2107\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,9862717},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60050375,'公会任务','会长夫人被困到罗米尔楼台上，你赶快过去救援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,375,399,0,0,0,0,0,0,'null','[]','10019002',10019002,30042,30043,0,'[]','[[[\"fin_dungeon\",\"11\",\"2107\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,15936624},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60050400,'公会任务','会长夫人被困到罗米尔楼台上，你赶快过去救援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,400,424,0,0,0,0,0,0,'null','[]','10019002',10019002,30042,30043,0,'[]','[[[\"fin_dungeon\",\"11\",\"2107\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,22692436},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60050425,'公会任务','会长夫人被困到罗米尔楼台上，你赶快过去救援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,425,449,0,0,0,0,0,0,'null','[]','10019002',10019002,30042,30043,0,'[]','[[[\"fin_dungeon\",\"11\",\"2107\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,26763864},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60050450,'公会任务','会长夫人被困到罗米尔楼台上，你赶快过去救援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,450,474,0,0,0,0,0,0,'null','[]','10019002',10019002,30042,30043,0,'[]','[[[\"fin_dungeon\",\"11\",\"2107\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,33405484},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60050475,'公会任务','会长夫人被困到罗米尔楼台上，你赶快过去救援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,475,514,0,0,0,0,0,0,'null','[]','10019002',10019002,30042,30043,0,'[]','[[[\"fin_dungeon\",\"11\",\"2107\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,39967205},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60050515,'公会任务','会长夫人被困到罗米尔楼台上，你赶快过去救援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,515,549,0,0,0,0,0,0,'null','[]','10019002',10019002,30042,30043,0,'[]','[[[\"fin_dungeon\",\"11\",\"2107\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,42813004},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60050550,'公会任务','会长夫人被困到罗米尔楼台上，你赶快过去救援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,550,574,0,0,0,0,0,0,'null','[]','10019002',10019002,30042,30043,0,'[]','[[[\"fin_dungeon\",\"11\",\"2107\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,68954239},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60050575,'公会任务','会长夫人被困到罗米尔楼台上，你赶快过去救援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,575,594,0,0,0,0,0,0,'null','[]','10019002',10019002,30042,30043,0,'[]','[[[\"fin_dungeon\",\"11\",\"2107\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,75019679},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60050595,'公会任务','会长夫人被困到罗米尔楼台上，你赶快过去救援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,595,609,0,0,0,0,0,0,'null','[]','10019002',10019002,30042,30043,0,'[]','[[[\"fin_dungeon\",\"11\",\"2107\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,81725562},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60050610,'公会任务','会长夫人被困到罗米尔楼台上，你赶快过去救援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,610,629,0,0,0,0,0,0,'null','[]','10019002',10019002,30042,30043,0,'[]','[[[\"fin_dungeon\",\"11\",\"2107\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,83518586},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60050630,'公会任务','会长夫人被困到罗米尔楼台上，你赶快过去救援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,630,649,0,0,0,0,0,0,'null','[]','10019002',10019002,30042,30043,0,'[]','[[[\"fin_dungeon\",\"11\",\"2107\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,89851919},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60050650,'公会任务','会长夫人被困到罗米尔楼台上，你赶快过去救援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,650,669,0,0,0,0,0,0,'null','[]','10019002',10019002,30042,30043,0,'[]','[[[\"fin_dungeon\",\"11\",\"2107\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,91122871},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60050670,'公会任务','会长夫人被困到罗米尔楼台上，你赶快过去救援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,670,689,0,0,0,0,0,0,'null','[]','10019002',10019002,30042,30043,0,'[]','[[[\"fin_dungeon\",\"11\",\"2107\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,97122871},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60050690,'公会任务','会长夫人被困到罗米尔楼台上，你赶快过去救援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,690,709,0,0,0,0,0,0,'null','[]','10019002',10019002,30042,30043,0,'[]','[[[\"fin_dungeon\",\"11\",\"2107\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,97966728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60050710,'公会任务','会长夫人被困到罗米尔楼台上，你赶快过去救援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,710,729,0,0,0,0,0,0,'null','[]','10019002',10019002,30042,30043,0,'[]','[[[\"fin_dungeon\",\"11\",\"2107\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,103666728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60050730,'公会任务','会长夫人被困到罗米尔楼台上，你赶快过去救援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,730,749,0,0,0,0,0,0,'null','[]','10019002',10019002,30042,30043,0,'[]','[[[\"fin_dungeon\",\"11\",\"2107\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,109366728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60050750,'公会任务','会长夫人被困到罗米尔楼台上，你赶快过去救援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,750,769,0,0,0,0,0,0,'null','[]','10019002',10019002,30042,30043,0,'[]','[[[\"fin_dungeon\",\"11\",\"2107\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,115066728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60050770,'公会任务','会长夫人被困到罗米尔楼台上，你赶快过去救援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,770,789,0,0,0,0,0,0,'null','[]','10019002',10019002,30042,30043,0,'[]','[[[\"fin_dungeon\",\"11\",\"2107\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,120766728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60050790,'公会任务','会长夫人被困到罗米尔楼台上，你赶快过去救援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,790,809,0,0,0,0,0,0,'null','[]','10019002',10019002,30042,30043,0,'[]','[[[\"fin_dungeon\",\"11\",\"2107\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60050810,'公会任务','会长夫人被困到罗米尔楼台上，你赶快过去救援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,810,829,0,0,0,0,0,0,'null','[]','10019002',10019002,30042,30043,0,'[]','[[[\"fin_dungeon\",\"11\",\"2107\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60050830,'公会任务','会长夫人被困到罗米尔楼台上，你赶快过去救援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,830,849,0,0,0,0,0,0,'null','[]','10019002',10019002,30042,30043,0,'[]','[[[\"fin_dungeon\",\"11\",\"2107\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60050850,'公会任务','会长夫人被困到罗米尔楼台上，你赶快过去救援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,850,869,0,0,0,0,0,0,'null','[]','10019002',10019002,30042,30043,0,'[]','[[[\"fin_dungeon\",\"11\",\"2107\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60050870,'公会任务','会长夫人被困到罗米尔楼台上，你赶快过去救援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,870,889,0,0,0,0,0,0,'null','[]','10019002',10019002,30042,30043,0,'[]','[[[\"fin_dungeon\",\"11\",\"2107\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60050890,'公会任务','会长夫人被困到罗米尔楼台上，你赶快过去救援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,890,909,0,0,0,0,0,0,'null','[]','10019002',10019002,30042,30043,0,'[]','[[[\"fin_dungeon\",\"11\",\"2107\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60050910,'公会任务','会长夫人被困到罗米尔楼台上，你赶快过去救援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,910,929,0,0,0,0,0,0,'null','[]','10019002',10019002,30042,30043,0,'[]','[[[\"fin_dungeon\",\"11\",\"2107\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60050930,'公会任务','会长夫人被困到罗米尔楼台上，你赶快过去救援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,930,949,0,0,0,0,0,0,'null','[]','10019002',10019002,30042,30043,0,'[]','[[[\"fin_dungeon\",\"11\",\"2107\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60050950,'公会任务','会长夫人被困到罗米尔楼台上，你赶快过去救援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,950,969,0,0,0,0,0,0,'null','[]','10019002',10019002,30042,30043,0,'[]','[[[\"fin_dungeon\",\"11\",\"2107\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60050970,'公会任务','会长夫人被困到罗米尔楼台上，你赶快过去救援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,970,989,0,0,0,0,0,0,'null','[]','10019002',10019002,30042,30043,0,'[]','[[[\"fin_dungeon\",\"11\",\"2107\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60050990,'公会任务','会长夫人被困到罗米尔楼台上，你赶快过去救援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,1,990,1000,0,0,0,0,0,0,'null','[]','10019002',10019002,30042,30043,0,'[]','[[[\"fin_dungeon\",\"11\",\"2107\",\"1\",\"0\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60060001,'公会任务','公会回收机急需材料，有多余的赶快来点！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,1,199,0,0,0,0,0,0,'null','[]','10019004',10019004,30044,30045,0,'[]','[[[\"guild_eq_recycle\",\"15\",\"2\",\"1\",\"2\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,2748409},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60060200,'公会任务','公会回收机急需材料，有多余的赶快来点！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,200,239,0,0,0,0,0,0,'null','[]','10019004',10019004,30044,30045,0,'[]','[[[\"guild_eq_recycle\",\"15\",\"2\",\"1\",\"2\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,5339994},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60060240,'公会任务','公会回收机急需材料，有多余的赶快来点！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,240,279,0,0,0,0,0,0,'null','[]','10019004',10019004,30044,30045,0,'[]','[[[\"guild_eq_recycle\",\"15\",\"2\",\"1\",\"2\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,7306895},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60060280,'公会任务','公会回收机急需材料，有多余的赶快来点！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,280,319,0,0,0,0,0,0,'null','[]','10019004',10019004,30044,30045,0,'[]','[[[\"guild_eq_recycle\",\"15\",\"2\",\"1\",\"2\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,8229784},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60060320,'公会任务','公会回收机急需材料，有多余的赶快来点！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,320,349,0,0,0,0,0,0,'null','[]','10019004',10019004,30044,30045,0,'[]','[[[\"guild_eq_recycle\",\"15\",\"2\",\"1\",\"2\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,9343005},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60060350,'公会任务','公会回收机急需材料，有多余的赶快来点！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,350,374,0,0,0,0,0,0,'null','[]','10019004',10019004,30044,30045,0,'[]','[[[\"guild_eq_recycle\",\"15\",\"2\",\"1\",\"2\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,9862717},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60060375,'公会任务','公会回收机急需材料，有多余的赶快来点！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,375,399,0,0,0,0,0,0,'null','[]','10019004',10019004,30044,30045,0,'[]','[[[\"guild_eq_recycle\",\"15\",\"2\",\"1\",\"2\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,15936624},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60060400,'公会任务','公会回收机急需材料，有多余的赶快来点！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,400,424,0,0,0,0,0,0,'null','[]','10019004',10019004,30044,30045,0,'[]','[[[\"guild_eq_recycle\",\"15\",\"2\",\"1\",\"2\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,22692436},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60060425,'公会任务','公会回收机急需材料，有多余的赶快来点！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,425,449,0,0,0,0,0,0,'null','[]','10019004',10019004,30044,30045,0,'[]','[[[\"guild_eq_recycle\",\"15\",\"2\",\"1\",\"2\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,26763864},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60060450,'公会任务','公会回收机急需材料，有多余的赶快来点！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,450,474,0,0,0,0,0,0,'null','[]','10019004',10019004,30044,30045,0,'[]','[[[\"guild_eq_recycle\",\"15\",\"2\",\"1\",\"2\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,33405484},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60060475,'公会任务','公会回收机急需材料，有多余的赶快来点！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,475,514,0,0,0,0,0,0,'null','[]','10019004',10019004,30044,30045,0,'[]','[[[\"guild_eq_recycle\",\"15\",\"2\",\"1\",\"2\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,39967205},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60060515,'公会任务','公会回收机急需材料，有多余的赶快来点！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,515,549,0,0,0,0,0,0,'null','[]','10019004',10019004,30044,30045,0,'[]','[[[\"guild_eq_recycle\",\"15\",\"2\",\"1\",\"2\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,42813004},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60060550,'公会任务','公会回收机急需材料，有多余的赶快来点！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,550,574,0,0,0,0,0,0,'null','[]','10019004',10019004,30044,30045,0,'[]','[[[\"guild_eq_recycle\",\"15\",\"2\",\"1\",\"2\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,68954239},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60060575,'公会任务','公会回收机急需材料，有多余的赶快来点！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,575,594,0,0,0,0,0,0,'null','[]','10019004',10019004,30044,30045,0,'[]','[[[\"guild_eq_recycle\",\"15\",\"2\",\"1\",\"2\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,75019679},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60060595,'公会任务','公会回收机急需材料，有多余的赶快来点！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,595,609,0,0,0,0,0,0,'null','[]','10019004',10019004,30044,30045,0,'[]','[[[\"guild_eq_recycle\",\"15\",\"2\",\"1\",\"2\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,81725562},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60060610,'公会任务','公会回收机急需材料，有多余的赶快来点！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,610,629,0,0,0,0,0,0,'null','[]','10019004',10019004,30044,30045,0,'[]','[[[\"guild_eq_recycle\",\"15\",\"2\",\"1\",\"2\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,83518586},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60060630,'公会任务','公会回收机急需材料，有多余的赶快来点！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,630,649,0,0,0,0,0,0,'null','[]','10019004',10019004,30044,30045,0,'[]','[[[\"guild_eq_recycle\",\"15\",\"2\",\"1\",\"2\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,89851919},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60060650,'公会任务','公会回收机急需材料，有多余的赶快来点！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,650,669,0,0,0,0,0,0,'null','[]','10019004',10019004,30044,30045,0,'[]','[[[\"guild_eq_recycle\",\"15\",\"2\",\"1\",\"2\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,91122871},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60060670,'公会任务','公会回收机急需材料，有多余的赶快来点！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,670,689,0,0,0,0,0,0,'null','[]','10019004',10019004,30044,30045,0,'[]','[[[\"guild_eq_recycle\",\"15\",\"2\",\"1\",\"2\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,97122871},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60060690,'公会任务','公会回收机急需材料，有多余的赶快来点！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,690,709,0,0,0,0,0,0,'null','[]','10019004',10019004,30044,30045,0,'[]','[[[\"guild_eq_recycle\",\"15\",\"2\",\"1\",\"2\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,97966728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60060710,'公会任务','公会回收机急需材料，有多余的赶快来点！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,710,729,0,0,0,0,0,0,'null','[]','10019004',10019004,30044,30045,0,'[]','[[[\"guild_eq_recycle\",\"15\",\"2\",\"1\",\"2\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,103666728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60060730,'公会任务','公会回收机急需材料，有多余的赶快来点！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,730,749,0,0,0,0,0,0,'null','[]','10019004',10019004,30044,30045,0,'[]','[[[\"guild_eq_recycle\",\"15\",\"2\",\"1\",\"2\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,109366728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60060750,'公会任务','公会回收机急需材料，有多余的赶快来点！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,750,769,0,0,0,0,0,0,'null','[]','10019004',10019004,30044,30045,0,'[]','[[[\"guild_eq_recycle\",\"15\",\"2\",\"1\",\"2\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,115066728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60060770,'公会任务','公会回收机急需材料，有多余的赶快来点！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,770,789,0,0,0,0,0,0,'null','[]','10019004',10019004,30044,30045,0,'[]','[[[\"guild_eq_recycle\",\"15\",\"2\",\"1\",\"2\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,120766728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60060790,'公会任务','公会回收机急需材料，有多余的赶快来点！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,790,809,0,0,0,0,0,0,'null','[]','10019004',10019004,30044,30045,0,'[]','[[[\"guild_eq_recycle\",\"15\",\"2\",\"1\",\"2\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60060810,'公会任务','公会回收机急需材料，有多余的赶快来点！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,810,829,0,0,0,0,0,0,'null','[]','10019004',10019004,30044,30045,0,'[]','[[[\"guild_eq_recycle\",\"15\",\"2\",\"1\",\"2\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60060830,'公会任务','公会回收机急需材料，有多余的赶快来点！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,830,849,0,0,0,0,0,0,'null','[]','10019004',10019004,30044,30045,0,'[]','[[[\"guild_eq_recycle\",\"15\",\"2\",\"1\",\"2\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60060850,'公会任务','公会回收机急需材料，有多余的赶快来点！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,850,869,0,0,0,0,0,0,'null','[]','10019004',10019004,30044,30045,0,'[]','[[[\"guild_eq_recycle\",\"15\",\"2\",\"1\",\"2\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60060870,'公会任务','公会回收机急需材料，有多余的赶快来点！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,870,889,0,0,0,0,0,0,'null','[]','10019004',10019004,30044,30045,0,'[]','[[[\"guild_eq_recycle\",\"15\",\"2\",\"1\",\"2\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60060890,'公会任务','公会回收机急需材料，有多余的赶快来点！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,890,909,0,0,0,0,0,0,'null','[]','10019004',10019004,30044,30045,0,'[]','[[[\"guild_eq_recycle\",\"15\",\"2\",\"1\",\"2\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60060910,'公会任务','公会回收机急需材料，有多余的赶快来点！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,910,929,0,0,0,0,0,0,'null','[]','10019004',10019004,30044,30045,0,'[]','[[[\"guild_eq_recycle\",\"15\",\"2\",\"1\",\"2\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60060930,'公会任务','公会回收机急需材料，有多余的赶快来点！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,930,949,0,0,0,0,0,0,'null','[]','10019004',10019004,30044,30045,0,'[]','[[[\"guild_eq_recycle\",\"15\",\"2\",\"1\",\"2\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60060950,'公会任务','公会回收机急需材料，有多余的赶快来点！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,950,969,0,0,0,0,0,0,'null','[]','10019004',10019004,30044,30045,0,'[]','[[[\"guild_eq_recycle\",\"15\",\"2\",\"1\",\"2\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60060970,'公会任务','公会回收机急需材料，有多余的赶快来点！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,970,989,0,0,0,0,0,0,'null','[]','10019004',10019004,30044,30045,0,'[]','[[[\"guild_eq_recycle\",\"15\",\"2\",\"1\",\"2\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60060990,'公会任务','公会回收机急需材料，有多余的赶快来点！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,990,1000,0,0,0,0,0,0,'null','[]','10019004',10019004,30044,30045,0,'[]','[[[\"guild_eq_recycle\",\"15\",\"2\",\"1\",\"2\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60070001,'公会任务','公主发来求救信，说被一群蒙面人围攻，你赶快过去支援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,1,199,0,0,0,0,0,0,'null','[]','10019002',10019002,30046,30047,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"0\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,2748409},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60070200,'公会任务','公主发来求救信，说被一群蒙面人围攻，你赶快过去支援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,200,239,0,0,0,0,0,0,'null','[]','10019002',10019002,30046,30047,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"0\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,5339994},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60070240,'公会任务','公主发来求救信，说被一群蒙面人围攻，你赶快过去支援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,240,279,0,0,0,0,0,0,'null','[]','10019002',10019002,30046,30047,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"0\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,7306895},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60070280,'公会任务','公主发来求救信，说被一群蒙面人围攻，你赶快过去支援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,280,319,0,0,0,0,0,0,'null','[]','10019002',10019002,30046,30047,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"0\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,8229784},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60070320,'公会任务','公主发来求救信，说被一群蒙面人围攻，你赶快过去支援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,320,349,0,0,0,0,0,0,'null','[]','10019002',10019002,30046,30047,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"0\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,9343005},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60070350,'公会任务','公主发来求救信，说被一群蒙面人围攻，你赶快过去支援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,350,374,0,0,0,0,0,0,'null','[]','10019002',10019002,30046,30047,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"0\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,9862717},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60070375,'公会任务','公主发来求救信，说被一群蒙面人围攻，你赶快过去支援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,375,399,0,0,0,0,0,0,'null','[]','10019002',10019002,30046,30047,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"0\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,15936624},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60070400,'公会任务','公主发来求救信，说被一群蒙面人围攻，你赶快过去支援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,400,424,0,0,0,0,0,0,'null','[]','10019002',10019002,30046,30047,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"0\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,22692436},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60070425,'公会任务','公主发来求救信，说被一群蒙面人围攻，你赶快过去支援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,425,449,0,0,0,0,0,0,'null','[]','10019002',10019002,30046,30047,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"0\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,26763864},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60070450,'公会任务','公主发来求救信，说被一群蒙面人围攻，你赶快过去支援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,450,474,0,0,0,0,0,0,'null','[]','10019002',10019002,30046,30047,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"0\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,33405484},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60070475,'公会任务','公主发来求救信，说被一群蒙面人围攻，你赶快过去支援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,475,514,0,0,0,0,0,0,'null','[]','10019002',10019002,30046,30047,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"0\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,39967205},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60070515,'公会任务','公主发来求救信，说被一群蒙面人围攻，你赶快过去支援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,515,549,0,0,0,0,0,0,'null','[]','10019002',10019002,30046,30047,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"0\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,42813004},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60070550,'公会任务','公主发来求救信，说被一群蒙面人围攻，你赶快过去支援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,550,574,0,0,0,0,0,0,'null','[]','10019002',10019002,30046,30047,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"0\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,68954239},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60070575,'公会任务','公主发来求救信，说被一群蒙面人围攻，你赶快过去支援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,575,594,0,0,0,0,0,0,'null','[]','10019002',10019002,30046,30047,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"0\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,75019679},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60070595,'公会任务','公主发来求救信，说被一群蒙面人围攻，你赶快过去支援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,595,609,0,0,0,0,0,0,'null','[]','10019002',10019002,30046,30047,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"0\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,81725562},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60070610,'公会任务','公主发来求救信，说被一群蒙面人围攻，你赶快过去支援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,610,629,0,0,0,0,0,0,'null','[]','10019002',10019002,30046,30047,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"0\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,83518586},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60070630,'公会任务','公主发来求救信，说被一群蒙面人围攻，你赶快过去支援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,630,649,0,0,0,0,0,0,'null','[]','10019002',10019002,30046,30047,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"0\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,89851919},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60070650,'公会任务','公主发来求救信，说被一群蒙面人围攻，你赶快过去支援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,650,669,0,0,0,0,0,0,'null','[]','10019002',10019002,30046,30047,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"0\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,91122871},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60070670,'公会任务','公主发来求救信，说被一群蒙面人围攻，你赶快过去支援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,670,689,0,0,0,0,0,0,'null','[]','10019002',10019002,30046,30047,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"0\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,97122871},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60070690,'公会任务','公主发来求救信，说被一群蒙面人围攻，你赶快过去支援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,690,709,0,0,0,0,0,0,'null','[]','10019002',10019002,30046,30047,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"0\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,97966728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60070710,'公会任务','公主发来求救信，说被一群蒙面人围攻，你赶快过去支援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,710,729,0,0,0,0,0,0,'null','[]','10019002',10019002,30046,30047,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"0\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,103666728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60070730,'公会任务','公主发来求救信，说被一群蒙面人围攻，你赶快过去支援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,730,749,0,0,0,0,0,0,'null','[]','10019002',10019002,30046,30047,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"0\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,109366728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60070750,'公会任务','公主发来求救信，说被一群蒙面人围攻，你赶快过去支援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,750,769,0,0,0,0,0,0,'null','[]','10019002',10019002,30046,30047,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"0\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,115066728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60070770,'公会任务','公主发来求救信，说被一群蒙面人围攻，你赶快过去支援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,770,789,0,0,0,0,0,0,'null','[]','10019002',10019002,30046,30047,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"0\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,120766728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60070790,'公会任务','公主发来求救信，说被一群蒙面人围攻，你赶快过去支援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,790,809,0,0,0,0,0,0,'null','[]','10019002',10019002,30046,30047,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"0\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60070810,'公会任务','公主发来求救信，说被一群蒙面人围攻，你赶快过去支援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,810,829,0,0,0,0,0,0,'null','[]','10019002',10019002,30046,30047,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"0\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60070830,'公会任务','公主发来求救信，说被一群蒙面人围攻，你赶快过去支援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,830,849,0,0,0,0,0,0,'null','[]','10019002',10019002,30046,30047,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"0\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60070850,'公会任务','公主发来求救信，说被一群蒙面人围攻，你赶快过去支援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,850,869,0,0,0,0,0,0,'null','[]','10019002',10019002,30046,30047,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"0\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60070870,'公会任务','公主发来求救信，说被一群蒙面人围攻，你赶快过去支援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,870,889,0,0,0,0,0,0,'null','[]','10019002',10019002,30046,30047,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"0\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60070890,'公会任务','公主发来求救信，说被一群蒙面人围攻，你赶快过去支援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,890,909,0,0,0,0,0,0,'null','[]','10019002',10019002,30046,30047,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"0\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60070910,'公会任务','公主发来求救信，说被一群蒙面人围攻，你赶快过去支援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,910,929,0,0,0,0,0,0,'null','[]','10019002',10019002,30046,30047,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"0\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60070930,'公会任务','公主发来求救信，说被一群蒙面人围攻，你赶快过去支援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,930,949,0,0,0,0,0,0,'null','[]','10019002',10019002,30046,30047,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"0\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60070950,'公会任务','公主发来求救信，说被一群蒙面人围攻，你赶快过去支援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,950,969,0,0,0,0,0,0,'null','[]','10019002',10019002,30046,30047,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"0\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60070970,'公会任务','公主发来求救信，说被一群蒙面人围攻，你赶快过去支援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,970,989,0,0,0,0,0,0,'null','[]','10019002',10019002,30046,30047,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"0\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60070990,'公会任务','公主发来求救信，说被一群蒙面人围攻，你赶快过去支援！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,0,990,1000,0,0,0,0,0,0,'null','[]','10019002',10019002,30046,30047,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"0\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',0,0,0,0),(60080001,'公会任务','一个人坐在这里好无聊啊，你能帮我问问有没有人和我一起下棋么！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,3,1,199,0,0,0,0,0,0,'null','[]','10029009',10029009,30048,30049,0,'[]','[]',0,'[{5,36060001,2748409},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60080200,'公会任务','一个人坐在这里好无聊啊，你能帮我问问有没有人和我一起下棋么！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,3,200,239,0,0,0,0,0,0,'null','[]','10029009',10029009,30048,30049,0,'[]','[]',0,'[{5,36060001,5339994},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60080240,'公会任务','一个人坐在这里好无聊啊，你能帮我问问有没有人和我一起下棋么！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,3,240,279,0,0,0,0,0,0,'null','[]','10029009',10029009,30048,30049,0,'[]','[]',0,'[{5,36060001,7306895},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60080280,'公会任务','一个人坐在这里好无聊啊，你能帮我问问有没有人和我一起下棋么！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,3,280,319,0,0,0,0,0,0,'null','[]','10029009',10029009,30048,30049,0,'[]','[]',0,'[{5,36060001,8229784},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60080320,'公会任务','一个人坐在这里好无聊啊，你能帮我问问有没有人和我一起下棋么！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,3,320,349,0,0,0,0,0,0,'null','[]','10029009',10029009,30048,30049,0,'[]','[]',0,'[{5,36060001,9343005},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60080350,'公会任务','一个人坐在这里好无聊啊，你能帮我问问有没有人和我一起下棋么！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,3,350,374,0,0,0,0,0,0,'null','[]','10029009',10029009,30048,30049,0,'[]','[]',0,'[{5,36060001,9862717},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60080375,'公会任务','一个人坐在这里好无聊啊，你能帮我问问有没有人和我一起下棋么！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,3,375,399,0,0,0,0,0,0,'null','[]','10029009',10029009,30048,30049,0,'[]','[]',0,'[{5,36060001,15936624},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60080400,'公会任务','一个人坐在这里好无聊啊，你能帮我问问有没有人和我一起下棋么！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,3,400,424,0,0,0,0,0,0,'null','[]','10029009',10029009,30048,30049,0,'[]','[]',0,'[{5,36060001,22692436},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60080425,'公会任务','一个人坐在这里好无聊啊，你能帮我问问有没有人和我一起下棋么！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,3,425,449,0,0,0,0,0,0,'null','[]','10029009',10029009,30048,30049,0,'[]','[]',0,'[{5,36060001,26763864},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60080450,'公会任务','一个人坐在这里好无聊啊，你能帮我问问有没有人和我一起下棋么！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,3,450,474,0,0,0,0,0,0,'null','[]','10029009',10029009,30048,30049,0,'[]','[]',0,'[{5,36060001,33405484},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60080475,'公会任务','一个人坐在这里好无聊啊，你能帮我问问有没有人和我一起下棋么！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,3,475,514,0,0,0,0,0,0,'null','[]','10029009',10029009,30048,30049,0,'[]','[]',0,'[{5,36060001,39967205},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60080515,'公会任务','一个人坐在这里好无聊啊，你能帮我问问有没有人和我一起下棋么！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,3,515,549,0,0,0,0,0,0,'null','[]','10029009',10029009,30048,30049,0,'[]','[]',0,'[{5,36060001,42813004},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60080550,'公会任务','一个人坐在这里好无聊啊，你能帮我问问有没有人和我一起下棋么！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,3,550,574,0,0,0,0,0,0,'null','[]','10029009',10029009,30048,30049,0,'[]','[]',0,'[{5,36060001,68954239},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60080575,'公会任务','一个人坐在这里好无聊啊，你能帮我问问有没有人和我一起下棋么！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,3,575,594,0,0,0,0,0,0,'null','[]','10029009',10029009,30048,30049,0,'[]','[]',0,'[{5,36060001,75019679},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60080595,'公会任务','一个人坐在这里好无聊啊，你能帮我问问有没有人和我一起下棋么！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,3,595,609,0,0,0,0,0,0,'null','[]','10029009',10029009,30048,30049,0,'[]','[]',0,'[{5,36060001,81725562},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60080610,'公会任务','一个人坐在这里好无聊啊，你能帮我问问有没有人和我一起下棋么！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,3,610,629,0,0,0,0,0,0,'null','[]','10029009',10029009,30048,30049,0,'[]','[]',0,'[{5,36060001,83518586},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60080630,'公会任务','一个人坐在这里好无聊啊，你能帮我问问有没有人和我一起下棋么！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,3,630,649,0,0,0,0,0,0,'null','[]','10029009',10029009,30048,30049,0,'[]','[]',0,'[{5,36060001,89851919},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60080650,'公会任务','一个人坐在这里好无聊啊，你能帮我问问有没有人和我一起下棋么！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,3,650,669,0,0,0,0,0,0,'null','[]','10029009',10029009,30048,30049,0,'[]','[]',0,'[{5,36060001,91122871},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60080670,'公会任务','一个人坐在这里好无聊啊，你能帮我问问有没有人和我一起下棋么！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,3,670,689,0,0,0,0,0,0,'null','[]','10029009',10029009,30048,30049,0,'[]','[]',0,'[{5,36060001,97122871},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60080690,'公会任务','一个人坐在这里好无聊啊，你能帮我问问有没有人和我一起下棋么！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,3,690,709,0,0,0,0,0,0,'null','[]','10029009',10029009,30048,30049,0,'[]','[]',0,'[{5,36060001,97966728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60080710,'公会任务','一个人坐在这里好无聊啊，你能帮我问问有没有人和我一起下棋么！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,3,710,729,0,0,0,0,0,0,'null','[]','10029009',10029009,30048,30049,0,'[]','[]',0,'[{5,36060001,103666728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60080730,'公会任务','一个人坐在这里好无聊啊，你能帮我问问有没有人和我一起下棋么！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,3,730,749,0,0,0,0,0,0,'null','[]','10029009',10029009,30048,30049,0,'[]','[]',0,'[{5,36060001,109366728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60080750,'公会任务','一个人坐在这里好无聊啊，你能帮我问问有没有人和我一起下棋么！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,3,750,769,0,0,0,0,0,0,'null','[]','10029009',10029009,30048,30049,0,'[]','[]',0,'[{5,36060001,115066728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60080770,'公会任务','一个人坐在这里好无聊啊，你能帮我问问有没有人和我一起下棋么！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,3,770,789,0,0,0,0,0,0,'null','[]','10029009',10029009,30048,30049,0,'[]','[]',0,'[{5,36060001,120766728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60080790,'公会任务','一个人坐在这里好无聊啊，你能帮我问问有没有人和我一起下棋么！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,3,790,809,0,0,0,0,0,0,'null','[]','10029009',10029009,30048,30049,0,'[]','[]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60080810,'公会任务','一个人坐在这里好无聊啊，你能帮我问问有没有人和我一起下棋么！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,3,810,829,0,0,0,0,0,0,'null','[]','10029009',10029009,30048,30049,0,'[]','[]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60080830,'公会任务','一个人坐在这里好无聊啊，你能帮我问问有没有人和我一起下棋么！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,3,830,849,0,0,0,0,0,0,'null','[]','10029009',10029009,30048,30049,0,'[]','[]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60080850,'公会任务','一个人坐在这里好无聊啊，你能帮我问问有没有人和我一起下棋么！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,3,850,869,0,0,0,0,0,0,'null','[]','10029009',10029009,30048,30049,0,'[]','[]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60080870,'公会任务','一个人坐在这里好无聊啊，你能帮我问问有没有人和我一起下棋么！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,3,870,889,0,0,0,0,0,0,'null','[]','10029009',10029009,30048,30049,0,'[]','[]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60080890,'公会任务','一个人坐在这里好无聊啊，你能帮我问问有没有人和我一起下棋么！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,3,890,909,0,0,0,0,0,0,'null','[]','10029009',10029009,30048,30049,0,'[]','[]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60080910,'公会任务','一个人坐在这里好无聊啊，你能帮我问问有没有人和我一起下棋么！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,3,910,929,0,0,0,0,0,0,'null','[]','10029009',10029009,30048,30049,0,'[]','[]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60080930,'公会任务','一个人坐在这里好无聊啊，你能帮我问问有没有人和我一起下棋么！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,3,930,949,0,0,0,0,0,0,'null','[]','10029009',10029009,30048,30049,0,'[]','[]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60080950,'公会任务','一个人坐在这里好无聊啊，你能帮我问问有没有人和我一起下棋么！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,3,950,969,0,0,0,0,0,0,'null','[]','10029009',10029009,30048,30049,0,'[]','[]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60080970,'公会任务','一个人坐在这里好无聊啊，你能帮我问问有没有人和我一起下棋么！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,3,970,989,0,0,0,0,0,0,'null','[]','10029009',10029009,30048,30049,0,'[]','[]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60080990,'公会任务','一个人坐在这里好无聊啊，你能帮我问问有没有人和我一起下棋么！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,3,990,1000,0,0,0,0,0,0,'null','[]','10029009',10029009,30048,30049,0,'[]','[]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60090001,'公会任务','我撞碎了人家的珐琅盘，我有点事走不开，你能替我把钱送还给他么？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,1,199,0,0,0,0,0,0,'null','[]','10049024',10049024,30050,30051,0,'[]','[]',0,'[{5,36060001,2748409},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60090200,'公会任务','我撞碎了人家的珐琅盘，我有点事走不开，你能替我把钱送还给他么？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,200,239,0,0,0,0,0,0,'null','[]','10049024',10049024,30050,30051,0,'[]','[]',0,'[{5,36060001,5339994},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60090240,'公会任务','我撞碎了人家的珐琅盘，我有点事走不开，你能替我把钱送还给他么？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,240,279,0,0,0,0,0,0,'null','[]','10049024',10049024,30050,30051,0,'[]','[]',0,'[{5,36060001,7306895},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60090280,'公会任务','我撞碎了人家的珐琅盘，我有点事走不开，你能替我把钱送还给他么？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,280,319,0,0,0,0,0,0,'null','[]','10049024',10049024,30050,30051,0,'[]','[]',0,'[{5,36060001,8229784},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60090320,'公会任务','我撞碎了人家的珐琅盘，我有点事走不开，你能替我把钱送还给他么？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,320,349,0,0,0,0,0,0,'null','[]','10049024',10049024,30050,30051,0,'[]','[]',0,'[{5,36060001,9343005},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60090350,'公会任务','我撞碎了人家的珐琅盘，我有点事走不开，你能替我把钱送还给他么？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,350,374,0,0,0,0,0,0,'null','[]','10049024',10049024,30050,30051,0,'[]','[]',0,'[{5,36060001,9862717},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60090375,'公会任务','我撞碎了人家的珐琅盘，我有点事走不开，你能替我把钱送还给他么？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,375,399,0,0,0,0,0,0,'null','[]','10049024',10049024,30050,30051,0,'[]','[]',0,'[{5,36060001,15936624},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60090400,'公会任务','我撞碎了人家的珐琅盘，我有点事走不开，你能替我把钱送还给他么？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,400,424,0,0,0,0,0,0,'null','[]','10049024',10049024,30050,30051,0,'[]','[]',0,'[{5,36060001,22692436},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60090425,'公会任务','我撞碎了人家的珐琅盘，我有点事走不开，你能替我把钱送还给他么？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,425,449,0,0,0,0,0,0,'null','[]','10049024',10049024,30050,30051,0,'[]','[]',0,'[{5,36060001,26763864},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60090450,'公会任务','我撞碎了人家的珐琅盘，我有点事走不开，你能替我把钱送还给他么？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,450,474,0,0,0,0,0,0,'null','[]','10049024',10049024,30050,30051,0,'[]','[]',0,'[{5,36060001,33405484},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60090475,'公会任务','我撞碎了人家的珐琅盘，我有点事走不开，你能替我把钱送还给他么？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,475,514,0,0,0,0,0,0,'null','[]','10049024',10049024,30050,30051,0,'[]','[]',0,'[{5,36060001,39967205},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60090515,'公会任务','我撞碎了人家的珐琅盘，我有点事走不开，你能替我把钱送还给他么？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,515,549,0,0,0,0,0,0,'null','[]','10049024',10049024,30050,30051,0,'[]','[]',0,'[{5,36060001,42813004},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60090550,'公会任务','我撞碎了人家的珐琅盘，我有点事走不开，你能替我把钱送还给他么？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,550,574,0,0,0,0,0,0,'null','[]','10049024',10049024,30050,30051,0,'[]','[]',0,'[{5,36060001,68954239},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60090575,'公会任务','我撞碎了人家的珐琅盘，我有点事走不开，你能替我把钱送还给他么？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,575,594,0,0,0,0,0,0,'null','[]','10049024',10049024,30050,30051,0,'[]','[]',0,'[{5,36060001,75019679},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60090595,'公会任务','我撞碎了人家的珐琅盘，我有点事走不开，你能替我把钱送还给他么？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,595,609,0,0,0,0,0,0,'null','[]','10049024',10049024,30050,30051,0,'[]','[]',0,'[{5,36060001,81725562},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60090610,'公会任务','我撞碎了人家的珐琅盘，我有点事走不开，你能替我把钱送还给他么？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,610,629,0,0,0,0,0,0,'null','[]','10049024',10049024,30050,30051,0,'[]','[]',0,'[{5,36060001,83518586},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60090630,'公会任务','我撞碎了人家的珐琅盘，我有点事走不开，你能替我把钱送还给他么？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,630,649,0,0,0,0,0,0,'null','[]','10049024',10049024,30050,30051,0,'[]','[]',0,'[{5,36060001,89851919},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60090650,'公会任务','我撞碎了人家的珐琅盘，我有点事走不开，你能替我把钱送还给他么？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,650,669,0,0,0,0,0,0,'null','[]','10049024',10049024,30050,30051,0,'[]','[]',0,'[{5,36060001,91122871},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60090670,'公会任务','我撞碎了人家的珐琅盘，我有点事走不开，你能替我把钱送还给他么？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,670,689,0,0,0,0,0,0,'null','[]','10049024',10049024,30050,30051,0,'[]','[]',0,'[{5,36060001,97122871},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60090690,'公会任务','我撞碎了人家的珐琅盘，我有点事走不开，你能替我把钱送还给他么？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,690,709,0,0,0,0,0,0,'null','[]','10049024',10049024,30050,30051,0,'[]','[]',0,'[{5,36060001,97966728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60090710,'公会任务','我撞碎了人家的珐琅盘，我有点事走不开，你能替我把钱送还给他么？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,710,729,0,0,0,0,0,0,'null','[]','10049024',10049024,30050,30051,0,'[]','[]',0,'[{5,36060001,103666728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60090730,'公会任务','我撞碎了人家的珐琅盘，我有点事走不开，你能替我把钱送还给他么？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,730,749,0,0,0,0,0,0,'null','[]','10049024',10049024,30050,30051,0,'[]','[]',0,'[{5,36060001,109366728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60090750,'公会任务','我撞碎了人家的珐琅盘，我有点事走不开，你能替我把钱送还给他么？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,750,769,0,0,0,0,0,0,'null','[]','10049024',10049024,30050,30051,0,'[]','[]',0,'[{5,36060001,115066728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60090770,'公会任务','我撞碎了人家的珐琅盘，我有点事走不开，你能替我把钱送还给他么？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,770,789,0,0,0,0,0,0,'null','[]','10049024',10049024,30050,30051,0,'[]','[]',0,'[{5,36060001,120766728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60090790,'公会任务','我撞碎了人家的珐琅盘，我有点事走不开，你能替我把钱送还给他么？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,790,809,0,0,0,0,0,0,'null','[]','10049024',10049024,30050,30051,0,'[]','[]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60090810,'公会任务','我撞碎了人家的珐琅盘，我有点事走不开，你能替我把钱送还给他么？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,810,829,0,0,0,0,0,0,'null','[]','10049024',10049024,30050,30051,0,'[]','[]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60090830,'公会任务','我撞碎了人家的珐琅盘，我有点事走不开，你能替我把钱送还给他么？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,830,849,0,0,0,0,0,0,'null','[]','10049024',10049024,30050,30051,0,'[]','[]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60090850,'公会任务','我撞碎了人家的珐琅盘，我有点事走不开，你能替我把钱送还给他么？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,850,869,0,0,0,0,0,0,'null','[]','10049024',10049024,30050,30051,0,'[]','[]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60090870,'公会任务','我撞碎了人家的珐琅盘，我有点事走不开，你能替我把钱送还给他么？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,870,889,0,0,0,0,0,0,'null','[]','10049024',10049024,30050,30051,0,'[]','[]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60090890,'公会任务','我撞碎了人家的珐琅盘，我有点事走不开，你能替我把钱送还给他么？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,890,909,0,0,0,0,0,0,'null','[]','10049024',10049024,30050,30051,0,'[]','[]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60090910,'公会任务','我撞碎了人家的珐琅盘，我有点事走不开，你能替我把钱送还给他么？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,910,929,0,0,0,0,0,0,'null','[]','10049024',10049024,30050,30051,0,'[]','[]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60090930,'公会任务','我撞碎了人家的珐琅盘，我有点事走不开，你能替我把钱送还给他么？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,930,949,0,0,0,0,0,0,'null','[]','10049024',10049024,30050,30051,0,'[]','[]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60090950,'公会任务','我撞碎了人家的珐琅盘，我有点事走不开，你能替我把钱送还给他么？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,950,969,0,0,0,0,0,0,'null','[]','10049024',10049024,30050,30051,0,'[]','[]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60090970,'公会任务','我撞碎了人家的珐琅盘，我有点事走不开，你能替我把钱送还给他么？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,970,989,0,0,0,0,0,0,'null','[]','10049024',10049024,30050,30051,0,'[]','[]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60090990,'公会任务','我撞碎了人家的珐琅盘，我有点事走不开，你能替我把钱送还给他么？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,990,1000,0,0,0,0,0,0,'null','[]','10049024',10049024,30050,30051,0,'[]','[]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60100001,'公会任务','听说有人生病了，公会里的兄弟姐妹要相亲相爱，你帮我问候下他吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,1,199,0,0,0,0,0,0,'null','[]','10029010',10029010,30052,30053,0,'[]','[]',0,'[{5,36060001,2748409},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60100200,'公会任务','听说有人生病了，公会里的兄弟姐妹要相亲相爱，你帮我问候下他吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,200,239,0,0,0,0,0,0,'null','[]','10029010',10029010,30052,30053,0,'[]','[]',0,'[{5,36060001,5339994},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60100240,'公会任务','听说有人生病了，公会里的兄弟姐妹要相亲相爱，你帮我问候下他吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,240,279,0,0,0,0,0,0,'null','[]','10029010',10029010,30052,30053,0,'[]','[]',0,'[{5,36060001,7306895},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60100280,'公会任务','听说有人生病了，公会里的兄弟姐妹要相亲相爱，你帮我问候下他吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,280,319,0,0,0,0,0,0,'null','[]','10029010',10029010,30052,30053,0,'[]','[]',0,'[{5,36060001,8229784},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60100320,'公会任务','听说有人生病了，公会里的兄弟姐妹要相亲相爱，你帮我问候下他吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,320,349,0,0,0,0,0,0,'null','[]','10029010',10029010,30052,30053,0,'[]','[]',0,'[{5,36060001,9343005},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60100350,'公会任务','听说有人生病了，公会里的兄弟姐妹要相亲相爱，你帮我问候下他吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,350,374,0,0,0,0,0,0,'null','[]','10029010',10029010,30052,30053,0,'[]','[]',0,'[{5,36060001,9862717},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60100375,'公会任务','听说有人生病了，公会里的兄弟姐妹要相亲相爱，你帮我问候下他吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,375,399,0,0,0,0,0,0,'null','[]','10029010',10029010,30052,30053,0,'[]','[]',0,'[{5,36060001,15936624},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60100400,'公会任务','听说有人生病了，公会里的兄弟姐妹要相亲相爱，你帮我问候下他吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,400,424,0,0,0,0,0,0,'null','[]','10029010',10029010,30052,30053,0,'[]','[]',0,'[{5,36060001,22692436},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60100425,'公会任务','听说有人生病了，公会里的兄弟姐妹要相亲相爱，你帮我问候下他吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,425,449,0,0,0,0,0,0,'null','[]','10029010',10029010,30052,30053,0,'[]','[]',0,'[{5,36060001,26763864},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60100450,'公会任务','听说有人生病了，公会里的兄弟姐妹要相亲相爱，你帮我问候下他吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,450,474,0,0,0,0,0,0,'null','[]','10029010',10029010,30052,30053,0,'[]','[]',0,'[{5,36060001,33405484},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60100475,'公会任务','听说有人生病了，公会里的兄弟姐妹要相亲相爱，你帮我问候下他吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,475,514,0,0,0,0,0,0,'null','[]','10029010',10029010,30052,30053,0,'[]','[]',0,'[{5,36060001,39967205},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60100515,'公会任务','听说有人生病了，公会里的兄弟姐妹要相亲相爱，你帮我问候下他吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,515,549,0,0,0,0,0,0,'null','[]','10029010',10029010,30052,30053,0,'[]','[]',0,'[{5,36060001,42813004},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60100550,'公会任务','听说有人生病了，公会里的兄弟姐妹要相亲相爱，你帮我问候下他吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,550,574,0,0,0,0,0,0,'null','[]','10029010',10029010,30052,30053,0,'[]','[]',0,'[{5,36060001,68954239},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60100575,'公会任务','听说有人生病了，公会里的兄弟姐妹要相亲相爱，你帮我问候下他吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,575,594,0,0,0,0,0,0,'null','[]','10029010',10029010,30052,30053,0,'[]','[]',0,'[{5,36060001,75019679},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60100595,'公会任务','听说有人生病了，公会里的兄弟姐妹要相亲相爱，你帮我问候下他吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,595,609,0,0,0,0,0,0,'null','[]','10029010',10029010,30052,30053,0,'[]','[]',0,'[{5,36060001,81725562},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60100610,'公会任务','听说有人生病了，公会里的兄弟姐妹要相亲相爱，你帮我问候下他吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,610,629,0,0,0,0,0,0,'null','[]','10029010',10029010,30052,30053,0,'[]','[]',0,'[{5,36060001,83518586},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60100630,'公会任务','听说有人生病了，公会里的兄弟姐妹要相亲相爱，你帮我问候下他吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,630,649,0,0,0,0,0,0,'null','[]','10029010',10029010,30052,30053,0,'[]','[]',0,'[{5,36060001,89851919},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60100650,'公会任务','听说有人生病了，公会里的兄弟姐妹要相亲相爱，你帮我问候下他吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,650,669,0,0,0,0,0,0,'null','[]','10029010',10029010,30052,30053,0,'[]','[]',0,'[{5,36060001,91122871},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60100670,'公会任务','听说有人生病了，公会里的兄弟姐妹要相亲相爱，你帮我问候下他吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,670,689,0,0,0,0,0,0,'null','[]','10029010',10029010,30052,30053,0,'[]','[]',0,'[{5,36060001,97122871},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60100690,'公会任务','听说有人生病了，公会里的兄弟姐妹要相亲相爱，你帮我问候下他吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,690,709,0,0,0,0,0,0,'null','[]','10029010',10029010,30052,30053,0,'[]','[]',0,'[{5,36060001,97966728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60100710,'公会任务','听说有人生病了，公会里的兄弟姐妹要相亲相爱，你帮我问候下他吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,710,729,0,0,0,0,0,0,'null','[]','10029010',10029010,30052,30053,0,'[]','[]',0,'[{5,36060001,103666728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60100730,'公会任务','听说有人生病了，公会里的兄弟姐妹要相亲相爱，你帮我问候下他吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,730,749,0,0,0,0,0,0,'null','[]','10029010',10029010,30052,30053,0,'[]','[]',0,'[{5,36060001,109366728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60100750,'公会任务','听说有人生病了，公会里的兄弟姐妹要相亲相爱，你帮我问候下他吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,750,769,0,0,0,0,0,0,'null','[]','10029010',10029010,30052,30053,0,'[]','[]',0,'[{5,36060001,115066728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60100770,'公会任务','听说有人生病了，公会里的兄弟姐妹要相亲相爱，你帮我问候下他吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,770,789,0,0,0,0,0,0,'null','[]','10029010',10029010,30052,30053,0,'[]','[]',0,'[{5,36060001,120766728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60100790,'公会任务','听说有人生病了，公会里的兄弟姐妹要相亲相爱，你帮我问候下他吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,790,809,0,0,0,0,0,0,'null','[]','10029010',10029010,30052,30053,0,'[]','[]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60100810,'公会任务','听说有人生病了，公会里的兄弟姐妹要相亲相爱，你帮我问候下他吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,810,829,0,0,0,0,0,0,'null','[]','10029010',10029010,30052,30053,0,'[]','[]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60100830,'公会任务','听说有人生病了，公会里的兄弟姐妹要相亲相爱，你帮我问候下他吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,830,849,0,0,0,0,0,0,'null','[]','10029010',10029010,30052,30053,0,'[]','[]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60100850,'公会任务','听说有人生病了，公会里的兄弟姐妹要相亲相爱，你帮我问候下他吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,850,869,0,0,0,0,0,0,'null','[]','10029010',10029010,30052,30053,0,'[]','[]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60100870,'公会任务','听说有人生病了，公会里的兄弟姐妹要相亲相爱，你帮我问候下他吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,870,889,0,0,0,0,0,0,'null','[]','10029010',10029010,30052,30053,0,'[]','[]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60100890,'公会任务','听说有人生病了，公会里的兄弟姐妹要相亲相爱，你帮我问候下他吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,890,909,0,0,0,0,0,0,'null','[]','10029010',10029010,30052,30053,0,'[]','[]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60100910,'公会任务','听说有人生病了，公会里的兄弟姐妹要相亲相爱，你帮我问候下他吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,910,929,0,0,0,0,0,0,'null','[]','10029010',10029010,30052,30053,0,'[]','[]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60100930,'公会任务','听说有人生病了，公会里的兄弟姐妹要相亲相爱，你帮我问候下他吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,930,949,0,0,0,0,0,0,'null','[]','10029010',10029010,30052,30053,0,'[]','[]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60100950,'公会任务','听说有人生病了，公会里的兄弟姐妹要相亲相爱，你帮我问候下他吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,950,969,0,0,0,0,0,0,'null','[]','10029010',10029010,30052,30053,0,'[]','[]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60100970,'公会任务','听说有人生病了，公会里的兄弟姐妹要相亲相爱，你帮我问候下他吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,970,989,0,0,0,0,0,0,'null','[]','10029010',10029010,30052,30053,0,'[]','[]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60100990,'公会任务','听说有人生病了，公会里的兄弟姐妹要相亲相爱，你帮我问候下他吧！（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,990,1000,0,0,0,0,0,0,'null','[]','10029010',10029010,30052,30053,0,'[]','[]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,0,0,0),(60110001,'公会任务','公会要评选最美会员，你四处问问谁想参加？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,1,199,0,0,0,0,0,0,'null','[]','10019002',10019002,30058,30059,0,'[]','[]',0,'[{5,36060001,2748409},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60110200,'公会任务','公会要评选最美会员，你四处问问谁想参加？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,200,239,0,0,0,0,0,0,'null','[]','10019002',10019002,30058,30059,0,'[]','[]',0,'[{5,36060001,5339994},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60110240,'公会任务','公会要评选最美会员，你四处问问谁想参加？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,240,279,0,0,0,0,0,0,'null','[]','10019002',10019002,30058,30059,0,'[]','[]',0,'[{5,36060001,7306895},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60110280,'公会任务','公会要评选最美会员，你四处问问谁想参加？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,280,319,0,0,0,0,0,0,'null','[]','10019002',10019002,30058,30059,0,'[]','[]',0,'[{5,36060001,8229784},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60110320,'公会任务','公会要评选最美会员，你四处问问谁想参加？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,320,349,0,0,0,0,0,0,'null','[]','10019002',10019002,30058,30059,0,'[]','[]',0,'[{5,36060001,9343005},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60110350,'公会任务','公会要评选最美会员，你四处问问谁想参加？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,350,374,0,0,0,0,0,0,'null','[]','10019002',10019002,30058,30059,0,'[]','[]',0,'[{5,36060001,9862717},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60110375,'公会任务','公会要评选最美会员，你四处问问谁想参加？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,375,399,0,0,0,0,0,0,'null','[]','10019002',10019002,30058,30059,0,'[]','[]',0,'[{5,36060001,15936624},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60110400,'公会任务','公会要评选最美会员，你四处问问谁想参加？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,400,424,0,0,0,0,0,0,'null','[]','10019002',10019002,30058,30059,0,'[]','[]',0,'[{5,36060001,22692436},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60110425,'公会任务','公会要评选最美会员，你四处问问谁想参加？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,425,449,0,0,0,0,0,0,'null','[]','10019002',10019002,30058,30059,0,'[]','[]',0,'[{5,36060001,26763864},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60110450,'公会任务','公会要评选最美会员，你四处问问谁想参加？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,450,474,0,0,0,0,0,0,'null','[]','10019002',10019002,30058,30059,0,'[]','[]',0,'[{5,36060001,33405484},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60110475,'公会任务','公会要评选最美会员，你四处问问谁想参加？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,475,514,0,0,0,0,0,0,'null','[]','10019002',10019002,30058,30059,0,'[]','[]',0,'[{5,36060001,39967205},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60110515,'公会任务','公会要评选最美会员，你四处问问谁想参加？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,515,549,0,0,0,0,0,0,'null','[]','10019002',10019002,30058,30059,0,'[]','[]',0,'[{5,36060001,42813004},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60110550,'公会任务','公会要评选最美会员，你四处问问谁想参加？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,550,574,0,0,0,0,0,0,'null','[]','10019002',10019002,30058,30059,0,'[]','[]',0,'[{5,36060001,68954239},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60110575,'公会任务','公会要评选最美会员，你四处问问谁想参加？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,575,594,0,0,0,0,0,0,'null','[]','10019002',10019002,30058,30059,0,'[]','[]',0,'[{5,36060001,75019679},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60110595,'公会任务','公会要评选最美会员，你四处问问谁想参加？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,595,609,0,0,0,0,0,0,'null','[]','10019002',10019002,30058,30059,0,'[]','[]',0,'[{5,36060001,81725562},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60110610,'公会任务','公会要评选最美会员，你四处问问谁想参加？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,610,629,0,0,0,0,0,0,'null','[]','10019002',10019002,30058,30059,0,'[]','[]',0,'[{5,36060001,83518586},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60110630,'公会任务','公会要评选最美会员，你四处问问谁想参加？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,630,649,0,0,0,0,0,0,'null','[]','10019002',10019002,30058,30059,0,'[]','[]',0,'[{5,36060001,89851919},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60110650,'公会任务','公会要评选最美会员，你四处问问谁想参加？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,650,669,0,0,0,0,0,0,'null','[]','10019002',10019002,30058,30059,0,'[]','[]',0,'[{5,36060001,91122871},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60110670,'公会任务','公会要评选最美会员，你四处问问谁想参加？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,670,689,0,0,0,0,0,0,'null','[]','10019002',10019002,30058,30059,0,'[]','[]',0,'[{5,36060001,97122871},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60110690,'公会任务','公会要评选最美会员，你四处问问谁想参加？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,690,709,0,0,0,0,0,0,'null','[]','10019002',10019002,30058,30059,0,'[]','[]',0,'[{5,36060001,97966728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60110710,'公会任务','公会要评选最美会员，你四处问问谁想参加？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,710,729,0,0,0,0,0,0,'null','[]','10019002',10019002,30058,30059,0,'[]','[]',0,'[{5,36060001,103666728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60110730,'公会任务','公会要评选最美会员，你四处问问谁想参加？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,730,749,0,0,0,0,0,0,'null','[]','10019002',10019002,30058,30059,0,'[]','[]',0,'[{5,36060001,109366728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60110750,'公会任务','公会要评选最美会员，你四处问问谁想参加？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,750,769,0,0,0,0,0,0,'null','[]','10019002',10019002,30058,30059,0,'[]','[]',0,'[{5,36060001,115066728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60110770,'公会任务','公会要评选最美会员，你四处问问谁想参加？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,770,789,0,0,0,0,0,0,'null','[]','10019002',10019002,30058,30059,0,'[]','[]',0,'[{5,36060001,120766728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60110790,'公会任务','公会要评选最美会员，你四处问问谁想参加？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,790,809,0,0,0,0,0,0,'null','[]','10019002',10019002,30058,30059,0,'[]','[]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60110810,'公会任务','公会要评选最美会员，你四处问问谁想参加？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,810,829,0,0,0,0,0,0,'null','[]','10019002',10019002,30058,30059,0,'[]','[]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60110830,'公会任务','公会要评选最美会员，你四处问问谁想参加？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,830,849,0,0,0,0,0,0,'null','[]','10019002',10019002,30058,30059,0,'[]','[]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60110850,'公会任务','公会要评选最美会员，你四处问问谁想参加？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,850,869,0,0,0,0,0,0,'null','[]','10019002',10019002,30058,30059,0,'[]','[]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60110870,'公会任务','公会要评选最美会员，你四处问问谁想参加？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,870,889,0,0,0,0,0,0,'null','[]','10019002',10019002,30058,30059,0,'[]','[]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60110890,'公会任务','公会要评选最美会员，你四处问问谁想参加？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,890,909,0,0,0,0,0,0,'null','[]','10019002',10019002,30058,30059,0,'[]','[]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60110910,'公会任务','公会要评选最美会员，你四处问问谁想参加？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,910,929,0,0,0,0,0,0,'null','[]','10019002',10019002,30058,30059,0,'[]','[]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60110930,'公会任务','公会要评选最美会员，你四处问问谁想参加？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,930,949,0,0,0,0,0,0,'null','[]','10019002',10019002,30058,30059,0,'[]','[]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60110950,'公会任务','公会要评选最美会员，你四处问问谁想参加？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,950,969,0,0,0,0,0,0,'null','[]','10019002',10019002,30058,30059,0,'[]','[]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60110970,'公会任务','公会要评选最美会员，你四处问问谁想参加？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,970,989,0,0,0,0,0,0,'null','[]','10019002',10019002,30058,30059,0,'[]','[]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(60110990,'公会任务','公会要评选最美会员，你四处问问谁想参加？（公会任务每达10环，会长会给予额外奖励哦！）','',6,0,6,990,1000,0,0,0,0,0,0,'null','[]','10019002',10019002,30058,30059,0,'[]','[]',0,'[{5,36060001,126466728},{4,36050001,2000},{8,36050002,3000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(70010001,'日常任务','我是一个邮差，但我的脚不小心崴到了，你能帮忙送下么?（日常任务每10环有额外奖励哦！）','',7,0,1,1,55,0,0,0,0,0,0,'null','[]','10029009',10029009,40062,40063,0,'[]','[]',0,'[{5,36060001,358250},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70010056,'日常任务','我家作坊中突然闯进一伙坏人，求求你帮我赶走他们？（日常任务每10环有额外奖励哦！）','',7,0,1,56,80,0,0,0,0,0,0,'null','[]','10019001',10019002,40054,40055,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,358250},{3,36030001,5000}]',0,1,1,'[]','[]','[]',0,0,0,0),(70010081,'日常任务','我家作坊中突然闯进一伙坏人，求求你帮我赶走他们？（日常任务每10环有额外奖励哦！）','',7,0,1,81,99,0,0,0,0,0,0,'null','[]','10019001',10019002,40054,40055,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',0,0,0,0),(70010095,'日常任务','我家作坊中突然闯进一伙坏人，求求你帮我赶走他们？（日常任务每10环有额外奖励哦！）','',7,0,1,100,119,0,0,0,0,0,0,'null','[]','10019001',10019002,40054,40055,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',0,0,0,0),(70010105,'日常任务','我家作坊中突然闯进一伙坏人，求求你帮我赶走他们？（日常任务每10环有额外奖励哦！）','',7,0,1,120,139,0,0,0,0,0,0,'null','[]','10019001',10019002,40054,40055,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',0,0,0,0),(70010120,'日常任务','我家作坊中突然闯进一伙坏人，求求你帮我赶走他们？（日常任务每10环有额外奖励哦！）','',7,0,1,140,159,0,0,0,0,0,0,'null','[]','10019001',10019002,40054,40055,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',0,0,0,0),(70010155,'日常任务','我家作坊中突然闯进一伙坏人，求求你帮我赶走他们？（日常任务每10环有额外奖励哦！）','',7,0,1,160,179,0,0,0,0,0,0,'null','[]','10019001',10019002,40054,40055,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',0,0,0,0),(70010180,'日常任务','我家作坊中突然闯进一伙坏人，求求你帮我赶走他们？（日常任务每10环有额外奖励哦！）','',7,0,1,180,200,0,0,0,0,0,0,'null','[]','10019001',10019002,40054,40055,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,2654846},{3,36030001,5000}]',0,1,1,'[]','[]','[]',0,0,0,0),(70010201,'日常任务','我家作坊中突然闯进一伙坏人，求求你帮我赶走他们？（日常任务每10环有额外奖励哦！）','',7,0,1,201,239,0,0,0,0,0,0,'null','[]','10019001',10019002,40054,40055,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,2936996},{3,36030001,5000}]',0,1,1,'[]','[]','[]',0,0,0,0),(70010240,'日常任务','我家作坊中突然闯进一伙坏人，求求你帮我赶走他们？（日常任务每10环有额外奖励哦！）','',7,0,1,240,279,0,0,0,0,0,0,'null','[]','10019001',10019002,40054,40055,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,4384137},{3,36030001,5000}]',0,1,1,'[]','[]','[]',0,0,0,0),(70010280,'日常任务','我家作坊中突然闯进一伙坏人，求求你帮我赶走他们？（日常任务每10环有额外奖励哦！）','',7,0,1,280,319,0,0,0,0,0,0,'null','[]','10019001',10019002,40054,40055,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,4937871},{3,36030001,11250}]',0,1,1,'[]','[]','[]',0,0,0,0),(70010320,'日常任务','我家作坊中突然闯进一伙坏人，求求你帮我赶走他们？（日常任务每10环有额外奖励哦！）','',7,0,1,320,349,0,0,0,0,0,0,'null','[]','10019001',10019002,40054,40055,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,5605803},{3,36030001,23000}]',0,1,1,'[]','[]','[]',0,0,0,0),(70010350,'日常任务','我家作坊中突然闯进一伙坏人，求求你帮我赶走他们？（日常任务每10环有额外奖励哦！）','',7,0,1,350,374,0,0,0,0,0,0,'null','[]','10019001',10019002,40054,40055,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,6410766},{3,36030001,25163}]',0,1,1,'[]','[]','[]',0,0,0,0),(70010375,'日常任务','我家作坊中突然闯进一伙坏人，求求你帮我赶走他们？（日常任务每10环有额外奖励哦！）','',7,0,1,375,399,0,0,0,0,0,0,'null','[]','10019001',10019002,40054,40055,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,10358805},{3,36030001,29944}]',0,1,1,'[]','[]','[]',0,0,0,0),(70010400,'日常任务','我家作坊中突然闯进一伙坏人，求求你帮我赶走他们？（日常任务每10环有额外奖励哦！）','',7,0,1,400,424,0,0,0,0,0,0,'null','[]','10019001',10019002,40054,40055,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,15884705},{3,36030001,34781}]',0,1,1,'[]','[]','[]',0,0,0,0),(70010425,'日常任务','我家作坊中突然闯进一伙坏人，求求你帮我赶走他们？（日常任务每10环有额外奖励哦！）','',7,0,1,425,449,0,0,0,0,0,0,'null','[]','10019001',10019002,40054,40055,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,18734705},{3,36030001,41038}]',0,1,1,'[]','[]','[]',0,0,0,0),(70010450,'日常任务','我家作坊中突然闯进一伙坏人，求求你帮我赶走他们？（日常任务每10环有额外奖励哦！）','',7,0,1,450,474,0,0,0,0,0,0,'null','[]','10019001',10019002,40054,40055,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,25054113},{3,36030001,48956}]',0,1,1,'[]','[]','[]',0,0,0,0),(70010475,'日常任务','我家作坊中突然闯进一伙坏人，求求你帮我赶走他们？（日常任务每10环有额外奖励哦！）','',7,0,1,475,514,0,0,0,0,0,0,'null','[]','10019001',10019002,40054,40055,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,29975404},{3,36030001,60219}]',0,1,1,'[]','[]','[]',0,0,0,0),(70010515,'日常任务','我家作坊中突然闯进一伙坏人，求求你帮我赶走他们？（日常任务每10环有额外奖励哦！）','',7,0,1,515,549,0,0,0,0,0,0,'null','[]','10019001',10019002,40054,40055,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,34250404},{3,36030001,81819}]',0,1,1,'[]','[]','[]',0,0,0,0),(70010550,'日常任务','我家作坊中突然闯进一伙坏人，求求你帮我赶走他们？（日常任务每10环有额外奖励哦！）','',7,0,1,550,574,0,0,0,0,0,0,'null','[]','10019001',10019002,40054,40055,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,55163391},{3,36030001,111163}]',0,1,1,'[]','[]','[]',0,0,0,0),(70010575,'日常任务','我家作坊中突然闯进一伙坏人，求求你帮我赶走他们？（日常任务每10环有额外奖励哦！）','',7,0,1,575,594,0,0,0,0,0,0,'null','[]','10019001',10019002,40054,40055,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,63766727},{3,36030001,141144}]',0,1,1,'[]','[]','[]',0,0,0,0),(70010595,'日常任务','我家作坊中突然闯进一伙坏人，求求你帮我赶走他们？（日常任务每10环有额外奖励哦！）','',7,0,1,595,609,0,0,0,0,0,0,'null','[]','10019001',10019002,40054,40055,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,69466727},{3,36030001,167081}]',0,1,1,'[]','[]','[]',0,0,0,0),(70010610,'日常任务','我家作坊中突然闯进一伙坏人，求求你帮我赶走他们？（日常任务每10环有额外奖励哦！）','',7,0,1,610,629,0,0,0,0,0,0,'null','[]','10019001',10019002,40054,40055,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,75166727},{3,36030001,186725}]',0,1,1,'[]','[]','[]',0,0,0,0),(70010630,'日常任务','我家作坊中突然闯进一伙坏人，求求你帮我赶走他们？（日常任务每10环有额外奖励哦！）','',7,0,1,630,649,0,0,0,0,0,0,'null','[]','10019001',10019002,40054,40055,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,80866727},{3,36030001,216913}]',0,1,1,'[]','[]','[]',0,0,0,0),(70010650,'日常任务','我家作坊中突然闯进一伙坏人，求求你帮我赶走他们？（日常任务每10环有额外奖励哦！）','',7,0,1,650,669,0,0,0,0,0,0,'null','[]','10019001',10019002,40054,40055,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,86566727},{3,36030001,249600}]',0,1,1,'[]','[]','[]',0,0,0,0),(70010670,'日常任务','我家作坊中突然闯进一伙坏人，求求你帮我赶走他们？（日常任务每10环有额外奖励哦！）','',7,0,1,670,689,0,0,0,0,0,0,'null','[]','10019001',10019002,40054,40055,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,92266727},{3,36030001,284788}]',0,1,1,'[]','[]','[]',0,0,0,0),(70010690,'日常任务','我家作坊中突然闯进一伙坏人，求求你帮我赶走他们？（日常任务每10环有额外奖励哦！）','',7,0,1,690,709,0,0,0,0,0,0,'null','[]','10019001',10019002,40054,40055,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,97966727},{3,36030001,322475}]',0,1,1,'[]','[]','[]',0,0,0,0),(70010710,'日常任务','我家作坊中突然闯进一伙坏人，求求你帮我赶走他们？（日常任务每10环有额外奖励哦！）','',7,0,1,710,729,0,0,0,0,0,0,'null','[]','10019001',10019002,40054,40055,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,103666727},{3,36030001,362663}]',0,1,1,'[]','[]','[]',0,0,0,0),(70010730,'日常任务','我家作坊中突然闯进一伙坏人，求求你帮我赶走他们？（日常任务每10环有额外奖励哦！）','',7,0,1,730,749,0,0,0,0,0,0,'null','[]','10019001',10019002,40054,40055,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,109366727},{3,36030001,405350}]',0,1,1,'[]','[]','[]',0,0,0,0),(70010750,'日常任务','我家作坊中突然闯进一伙坏人，求求你帮我赶走他们？（日常任务每10环有额外奖励哦！）','',7,0,1,750,769,0,0,0,0,0,0,'null','[]','10019001',10019002,40054,40055,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,115066727},{3,36030001,450538}]',0,1,1,'[]','[]','[]',0,0,0,0),(70010770,'日常任务','我家作坊中突然闯进一伙坏人，求求你帮我赶走他们？（日常任务每10环有额外奖励哦！）','',7,0,1,770,789,0,0,0,0,0,0,'null','[]','10019001',10019002,40054,40055,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,120766727},{3,36030001,498225}]',0,1,1,'[]','[]','[]',0,0,0,0),(70010790,'日常任务','我家作坊中突然闯进一伙坏人，求求你帮我赶走他们？（日常任务每10环有额外奖励哦！）','',7,0,1,790,809,0,0,0,0,0,0,'null','[]','10019001',10019002,40054,40055,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,548413}]',0,1,1,'[]','[]','[]',0,0,0,0),(70010810,'日常任务','我家作坊中突然闯进一伙坏人，求求你帮我赶走他们？（日常任务每10环有额外奖励哦！）','',7,0,1,810,829,0,0,0,0,0,0,'null','[]','10019001',10019002,40054,40055,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',0,0,0,0),(70010830,'日常任务','我家作坊中突然闯进一伙坏人，求求你帮我赶走他们？（日常任务每10环有额外奖励哦！）','',7,0,1,830,849,0,0,0,0,0,0,'null','[]','10019001',10019002,40054,40055,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',0,0,0,0),(70010850,'日常任务','我家作坊中突然闯进一伙坏人，求求你帮我赶走他们？（日常任务每10环有额外奖励哦！）','',7,0,1,850,869,0,0,0,0,0,0,'null','[]','10019001',10019002,40054,40055,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',0,0,0,0),(70010870,'日常任务','我家作坊中突然闯进一伙坏人，求求你帮我赶走他们？（日常任务每10环有额外奖励哦！）','',7,0,1,870,889,0,0,0,0,0,0,'null','[]','10019001',10019002,40054,40055,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',0,0,0,0),(70010890,'日常任务','我家作坊中突然闯进一伙坏人，求求你帮我赶走他们？（日常任务每10环有额外奖励哦！）','',7,0,1,890,909,0,0,0,0,0,0,'null','[]','10019001',10019002,40054,40055,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',0,0,0,0),(70010910,'日常任务','我家作坊中突然闯进一伙坏人，求求你帮我赶走他们？（日常任务每10环有额外奖励哦！）','',7,0,1,910,929,0,0,0,0,0,0,'null','[]','10019001',10019002,40054,40055,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',0,0,0,0),(70010930,'日常任务','我家作坊中突然闯进一伙坏人，求求你帮我赶走他们？（日常任务每10环有额外奖励哦！）','',7,0,1,930,949,0,0,0,0,0,0,'null','[]','10019001',10019002,40054,40055,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',0,0,0,0),(70010950,'日常任务','我家作坊中突然闯进一伙坏人，求求你帮我赶走他们？（日常任务每10环有额外奖励哦！）','',7,0,1,950,969,0,0,0,0,0,0,'null','[]','10019001',10019002,40054,40055,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',0,0,0,0),(70010970,'日常任务','我家作坊中突然闯进一伙坏人，求求你帮我赶走他们？（日常任务每10环有额外奖励哦！）','',7,0,1,970,989,0,0,0,0,0,0,'null','[]','10019001',10019002,40054,40055,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',0,0,0,0),(70010990,'日常任务','我家作坊中突然闯进一伙坏人，求求你帮我赶走他们？（日常任务每10环有额外奖励哦！）','',7,0,1,990,1000,0,0,0,0,0,0,'null','[]','10019001',10019002,40054,40055,0,'[]','[[[\"kill\",\"1\",\"1001001\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',0,0,0,0),(70020001,'日常任务','偷偷告诉你，我发现了阿里巴巴的宝藏，和我一起去探索下吧！（日常任务每10环有额外奖励哦！）','',7,0,6,1,55,0,0,0,0,0,0,'null','[]','10019002',10019002,40068,40069,0,'[]','[[[\"fin_dungeon\",\"11\",\"2101\",\"1\",\"1001\",\"7427\",\"5285\",\"1\"]]]',0,'[{5,36060001,358250},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(70020056,'日常任务','农庄里最近老是丢失东西，麻烦你帮我查看下，找到原因必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,56,80,0,0,0,0,0,0,'null','[]','10019004',10019005,40056,40057,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,358250},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70020081,'日常任务','农庄里最近老是丢失东西，麻烦你帮我查看下，找到原因必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,81,99,0,0,0,0,0,0,'null','[]','10019004',10019005,40056,40057,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70020095,'日常任务','农庄里最近老是丢失东西，麻烦你帮我查看下，找到原因必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,100,119,0,0,0,0,0,0,'null','[]','10019004',10019005,40056,40057,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70020105,'日常任务','农庄里最近老是丢失东西，麻烦你帮我查看下，找到原因必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,120,139,0,0,0,0,0,0,'null','[]','10019004',10019005,40056,40057,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70020120,'日常任务','农庄里最近老是丢失东西，麻烦你帮我查看下，找到原因必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,140,159,0,0,0,0,0,0,'null','[]','10019004',10019005,40056,40057,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70020155,'日常任务','农庄里最近老是丢失东西，麻烦你帮我查看下，找到原因必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,160,179,0,0,0,0,0,0,'null','[]','10019004',10019005,40056,40057,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70020180,'日常任务','农庄里最近老是丢失东西，麻烦你帮我查看下，找到原因必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,180,200,0,0,0,0,0,0,'null','[]','10019004',10019005,40056,40057,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,2654846},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70020201,'日常任务','农庄里最近老是丢失东西，麻烦你帮我查看下，找到原因必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,201,239,0,0,0,0,0,0,'null','[]','10019004',10019005,40056,40057,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,2936996},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70020240,'日常任务','农庄里最近老是丢失东西，麻烦你帮我查看下，找到原因必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,240,279,0,0,0,0,0,0,'null','[]','10019004',10019005,40056,40057,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,4384137},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70020280,'日常任务','农庄里最近老是丢失东西，麻烦你帮我查看下，找到原因必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,280,319,0,0,0,0,0,0,'null','[]','10019004',10019005,40056,40057,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,4937871},{3,36030001,11250}]',0,1,1,'[]','[]','[]',1,0,0,0),(70020320,'日常任务','农庄里最近老是丢失东西，麻烦你帮我查看下，找到原因必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,320,349,0,0,0,0,0,0,'null','[]','10019004',10019005,40056,40057,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,5605803},{3,36030001,23000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70020350,'日常任务','农庄里最近老是丢失东西，麻烦你帮我查看下，找到原因必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,350,374,0,0,0,0,0,0,'null','[]','10019004',10019005,40056,40057,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,6410766},{3,36030001,25163}]',0,1,1,'[]','[]','[]',1,0,0,0),(70020375,'日常任务','农庄里最近老是丢失东西，麻烦你帮我查看下，找到原因必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,375,399,0,0,0,0,0,0,'null','[]','10019004',10019005,40056,40057,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,10358805},{3,36030001,29944}]',0,1,1,'[]','[]','[]',1,0,0,0),(70020400,'日常任务','农庄里最近老是丢失东西，麻烦你帮我查看下，找到原因必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,400,424,0,0,0,0,0,0,'null','[]','10019004',10019005,40056,40057,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,15884705},{3,36030001,34781}]',0,1,1,'[]','[]','[]',1,0,0,0),(70020425,'日常任务','农庄里最近老是丢失东西，麻烦你帮我查看下，找到原因必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,425,449,0,0,0,0,0,0,'null','[]','10019004',10019005,40056,40057,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,18734705},{3,36030001,41038}]',0,1,1,'[]','[]','[]',1,0,0,0),(70020450,'日常任务','农庄里最近老是丢失东西，麻烦你帮我查看下，找到原因必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,450,474,0,0,0,0,0,0,'null','[]','10019004',10019005,40056,40057,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,25054113},{3,36030001,48956}]',0,1,1,'[]','[]','[]',1,0,0,0),(70020475,'日常任务','农庄里最近老是丢失东西，麻烦你帮我查看下，找到原因必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,475,514,0,0,0,0,0,0,'null','[]','10019004',10019005,40056,40057,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,29975404},{3,36030001,60219}]',0,1,1,'[]','[]','[]',1,0,0,0),(70020515,'日常任务','农庄里最近老是丢失东西，麻烦你帮我查看下，找到原因必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,515,549,0,0,0,0,0,0,'null','[]','10019004',10019005,40056,40057,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,34250404},{3,36030001,81819}]',0,1,1,'[]','[]','[]',1,0,0,0),(70020550,'日常任务','农庄里最近老是丢失东西，麻烦你帮我查看下，找到原因必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,550,574,0,0,0,0,0,0,'null','[]','10019004',10019005,40056,40057,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,55163391},{3,36030001,111163}]',0,1,1,'[]','[]','[]',1,0,0,0),(70020575,'日常任务','农庄里最近老是丢失东西，麻烦你帮我查看下，找到原因必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,575,594,0,0,0,0,0,0,'null','[]','10019004',10019005,40056,40057,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,63766727},{3,36030001,141144}]',0,1,1,'[]','[]','[]',1,0,0,0),(70020595,'日常任务','农庄里最近老是丢失东西，麻烦你帮我查看下，找到原因必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,595,609,0,0,0,0,0,0,'null','[]','10019004',10019005,40056,40057,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,69466727},{3,36030001,167081}]',0,1,1,'[]','[]','[]',1,0,0,0),(70020610,'日常任务','农庄里最近老是丢失东西，麻烦你帮我查看下，找到原因必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,610,629,0,0,0,0,0,0,'null','[]','10019004',10019005,40056,40057,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,75166727},{3,36030001,186725}]',0,1,1,'[]','[]','[]',1,0,0,0),(70020630,'日常任务','农庄里最近老是丢失东西，麻烦你帮我查看下，找到原因必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,630,649,0,0,0,0,0,0,'null','[]','10019004',10019005,40056,40057,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,80866727},{3,36030001,216913}]',0,1,1,'[]','[]','[]',1,0,0,0),(70020650,'日常任务','农庄里最近老是丢失东西，麻烦你帮我查看下，找到原因必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,650,669,0,0,0,0,0,0,'null','[]','10019004',10019005,40056,40057,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,86566727},{3,36030001,249600}]',0,1,1,'[]','[]','[]',1,0,0,0),(70020670,'日常任务','农庄里最近老是丢失东西，麻烦你帮我查看下，找到原因必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,670,689,0,0,0,0,0,0,'null','[]','10019004',10019005,40056,40057,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,92266727},{3,36030001,284788}]',0,1,1,'[]','[]','[]',1,0,0,0),(70020690,'日常任务','农庄里最近老是丢失东西，麻烦你帮我查看下，找到原因必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,690,709,0,0,0,0,0,0,'null','[]','10019004',10019005,40056,40057,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,97966727},{3,36030001,322475}]',0,1,1,'[]','[]','[]',1,0,0,0),(70020710,'日常任务','农庄里最近老是丢失东西，麻烦你帮我查看下，找到原因必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,710,729,0,0,0,0,0,0,'null','[]','10019004',10019005,40056,40057,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,103666727},{3,36030001,362663}]',0,1,1,'[]','[]','[]',1,0,0,0),(70020730,'日常任务','农庄里最近老是丢失东西，麻烦你帮我查看下，找到原因必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,730,749,0,0,0,0,0,0,'null','[]','10019004',10019005,40056,40057,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,109366727},{3,36030001,405350}]',0,1,1,'[]','[]','[]',1,0,0,0),(70020750,'日常任务','农庄里最近老是丢失东西，麻烦你帮我查看下，找到原因必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,750,769,0,0,0,0,0,0,'null','[]','10019004',10019005,40056,40057,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,115066727},{3,36030001,450538}]',0,1,1,'[]','[]','[]',1,0,0,0),(70020770,'日常任务','农庄里最近老是丢失东西，麻烦你帮我查看下，找到原因必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,770,789,0,0,0,0,0,0,'null','[]','10019004',10019005,40056,40057,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,120766727},{3,36030001,498225}]',0,1,1,'[]','[]','[]',1,0,0,0),(70020790,'日常任务','农庄里最近老是丢失东西，麻烦你帮我查看下，找到原因必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,790,809,0,0,0,0,0,0,'null','[]','10019004',10019005,40056,40057,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,548413}]',0,1,1,'[]','[]','[]',1,0,0,0),(70020810,'日常任务','农庄里最近老是丢失东西，麻烦你帮我查看下，找到原因必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,810,829,0,0,0,0,0,0,'null','[]','10019004',10019005,40056,40057,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70020830,'日常任务','农庄里最近老是丢失东西，麻烦你帮我查看下，找到原因必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,830,849,0,0,0,0,0,0,'null','[]','10019004',10019005,40056,40057,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70020850,'日常任务','农庄里最近老是丢失东西，麻烦你帮我查看下，找到原因必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,850,869,0,0,0,0,0,0,'null','[]','10019004',10019005,40056,40057,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70020870,'日常任务','农庄里最近老是丢失东西，麻烦你帮我查看下，找到原因必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,870,889,0,0,0,0,0,0,'null','[]','10019004',10019005,40056,40057,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70020890,'日常任务','农庄里最近老是丢失东西，麻烦你帮我查看下，找到原因必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,890,909,0,0,0,0,0,0,'null','[]','10019004',10019005,40056,40057,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70020910,'日常任务','农庄里最近老是丢失东西，麻烦你帮我查看下，找到原因必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,910,929,0,0,0,0,0,0,'null','[]','10019004',10019005,40056,40057,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70020930,'日常任务','农庄里最近老是丢失东西，麻烦你帮我查看下，找到原因必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,930,949,0,0,0,0,0,0,'null','[]','10019004',10019005,40056,40057,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70020950,'日常任务','农庄里最近老是丢失东西，麻烦你帮我查看下，找到原因必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,950,969,0,0,0,0,0,0,'null','[]','10019004',10019005,40056,40057,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70020970,'日常任务','农庄里最近老是丢失东西，麻烦你帮我查看下，找到原因必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,970,989,0,0,0,0,0,0,'null','[]','10019004',10019005,40056,40057,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70020990,'日常任务','农庄里最近老是丢失东西，麻烦你帮我查看下，找到原因必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,990,1000,0,0,0,0,0,0,'null','[]','10019004',10019005,40056,40057,0,'[]','[[[\"kill\",\"1\",\"1001003\",\"15\",\"1001\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70030001,'日常任务','我是一个邮差，但我的脚不小心崴到了，你能帮忙送下么?（日常任务每10环有额外奖励哦！）','',7,0,0,1,55,0,0,0,0,0,0,'null','[]','10029009',10029009,40062,40063,0,'[]','[]',0,'[{5,36060001,358250},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70030056,'日常任务','有人想打劫我的货物，如果你能帮我守住货物，我必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,56,80,0,0,0,0,0,0,'null','[]','10049015',10049016,40058,40059,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"15\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,358250},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70030081,'日常任务','有人想打劫我的货物，如果你能帮我守住货物，我必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,81,99,0,0,0,0,0,0,'null','[]','10049015',10049016,40058,40059,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"15\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70030095,'日常任务','有人想打劫我的货物，如果你能帮我守住货物，我必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,100,119,0,0,0,0,0,0,'null','[]','10049015',10049016,40058,40059,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"15\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70030105,'日常任务','有人想打劫我的货物，如果你能帮我守住货物，我必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,120,139,0,0,0,0,0,0,'null','[]','10049015',10049016,40058,40059,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"15\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70030120,'日常任务','有人想打劫我的货物，如果你能帮我守住货物，我必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,140,159,0,0,0,0,0,0,'null','[]','10049015',10049016,40058,40059,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"15\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70030155,'日常任务','有人想打劫我的货物，如果你能帮我守住货物，我必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,160,179,0,0,0,0,0,0,'null','[]','10049015',10049016,40058,40059,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"15\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70030180,'日常任务','有人想打劫我的货物，如果你能帮我守住货物，我必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,180,200,0,0,0,0,0,0,'null','[]','10049015',10049016,40058,40059,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"15\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,2654846},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70030201,'日常任务','有人想打劫我的货物，如果你能帮我守住货物，我必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,201,239,0,0,0,0,0,0,'null','[]','10049015',10049016,40058,40059,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"15\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,2936996},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70030240,'日常任务','有人想打劫我的货物，如果你能帮我守住货物，我必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,240,279,0,0,0,0,0,0,'null','[]','10049015',10049016,40058,40059,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"15\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,4384137},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70030280,'日常任务','有人想打劫我的货物，如果你能帮我守住货物，我必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,280,319,0,0,0,0,0,0,'null','[]','10049015',10049016,40058,40059,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"15\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,4937871},{3,36030001,11250}]',0,1,1,'[]','[]','[]',1,0,0,0),(70030320,'日常任务','有人想打劫我的货物，如果你能帮我守住货物，我必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,320,349,0,0,0,0,0,0,'null','[]','10049015',10049016,40058,40059,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"15\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,5605803},{3,36030001,23000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70030350,'日常任务','有人想打劫我的货物，如果你能帮我守住货物，我必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,350,374,0,0,0,0,0,0,'null','[]','10049015',10049016,40058,40059,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"15\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,6410766},{3,36030001,25163}]',0,1,1,'[]','[]','[]',1,0,0,0),(70030375,'日常任务','有人想打劫我的货物，如果你能帮我守住货物，我必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,375,399,0,0,0,0,0,0,'null','[]','10049015',10049016,40058,40059,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"15\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,10358805},{3,36030001,29944}]',0,1,1,'[]','[]','[]',1,0,0,0),(70030400,'日常任务','有人想打劫我的货物，如果你能帮我守住货物，我必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,400,424,0,0,0,0,0,0,'null','[]','10049015',10049016,40058,40059,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"15\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,15884705},{3,36030001,34781}]',0,1,1,'[]','[]','[]',1,0,0,0),(70030425,'日常任务','有人想打劫我的货物，如果你能帮我守住货物，我必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,425,449,0,0,0,0,0,0,'null','[]','10049015',10049016,40058,40059,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"15\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,18734705},{3,36030001,41038}]',0,1,1,'[]','[]','[]',1,0,0,0),(70030450,'日常任务','有人想打劫我的货物，如果你能帮我守住货物，我必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,450,474,0,0,0,0,0,0,'null','[]','10049015',10049016,40058,40059,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"15\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,25054113},{3,36030001,48956}]',0,1,1,'[]','[]','[]',1,0,0,0),(70030475,'日常任务','有人想打劫我的货物，如果你能帮我守住货物，我必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,475,514,0,0,0,0,0,0,'null','[]','10049015',10049016,40058,40059,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"15\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,29975404},{3,36030001,60219}]',0,1,1,'[]','[]','[]',1,0,0,0),(70030515,'日常任务','有人想打劫我的货物，如果你能帮我守住货物，我必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,515,549,0,0,0,0,0,0,'null','[]','10049015',10049016,40058,40059,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"15\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,34250404},{3,36030001,81819}]',0,1,1,'[]','[]','[]',1,0,0,0),(70030550,'日常任务','有人想打劫我的货物，如果你能帮我守住货物，我必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,550,574,0,0,0,0,0,0,'null','[]','10049015',10049016,40058,40059,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"15\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,55163391},{3,36030001,111163}]',0,1,1,'[]','[]','[]',1,0,0,0),(70030575,'日常任务','有人想打劫我的货物，如果你能帮我守住货物，我必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,575,594,0,0,0,0,0,0,'null','[]','10049015',10049016,40058,40059,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"15\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,63766727},{3,36030001,141144}]',0,1,1,'[]','[]','[]',1,0,0,0),(70030595,'日常任务','有人想打劫我的货物，如果你能帮我守住货物，我必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,595,609,0,0,0,0,0,0,'null','[]','10049015',10049016,40058,40059,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"15\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,69466727},{3,36030001,167081}]',0,1,1,'[]','[]','[]',1,0,0,0),(70030610,'日常任务','有人想打劫我的货物，如果你能帮我守住货物，我必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,610,629,0,0,0,0,0,0,'null','[]','10049015',10049016,40058,40059,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"15\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,75166727},{3,36030001,186725}]',0,1,1,'[]','[]','[]',1,0,0,0),(70030630,'日常任务','有人想打劫我的货物，如果你能帮我守住货物，我必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,630,649,0,0,0,0,0,0,'null','[]','10049015',10049016,40058,40059,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"15\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,80866727},{3,36030001,216913}]',0,1,1,'[]','[]','[]',1,0,0,0),(70030650,'日常任务','有人想打劫我的货物，如果你能帮我守住货物，我必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,650,669,0,0,0,0,0,0,'null','[]','10049015',10049016,40058,40059,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"15\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,86566727},{3,36030001,249600}]',0,1,1,'[]','[]','[]',1,0,0,0),(70030670,'日常任务','有人想打劫我的货物，如果你能帮我守住货物，我必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,670,689,0,0,0,0,0,0,'null','[]','10049015',10049016,40058,40059,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"15\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,92266727},{3,36030001,284788}]',0,1,1,'[]','[]','[]',1,0,0,0),(70030690,'日常任务','有人想打劫我的货物，如果你能帮我守住货物，我必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,690,709,0,0,0,0,0,0,'null','[]','10049015',10049016,40058,40059,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"15\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,97966727},{3,36030001,322475}]',0,1,1,'[]','[]','[]',1,0,0,0),(70030710,'日常任务','有人想打劫我的货物，如果你能帮我守住货物，我必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,710,729,0,0,0,0,0,0,'null','[]','10049015',10049016,40058,40059,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"15\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,103666727},{3,36030001,362663}]',0,1,1,'[]','[]','[]',1,0,0,0),(70030730,'日常任务','有人想打劫我的货物，如果你能帮我守住货物，我必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,730,749,0,0,0,0,0,0,'null','[]','10049015',10049016,40058,40059,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"15\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,109366727},{3,36030001,405350}]',0,1,1,'[]','[]','[]',1,0,0,0),(70030750,'日常任务','有人想打劫我的货物，如果你能帮我守住货物，我必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,750,769,0,0,0,0,0,0,'null','[]','10049015',10049016,40058,40059,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"15\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,115066727},{3,36030001,450538}]',0,1,1,'[]','[]','[]',1,0,0,0),(70030770,'日常任务','有人想打劫我的货物，如果你能帮我守住货物，我必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,770,789,0,0,0,0,0,0,'null','[]','10049015',10049016,40058,40059,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"15\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,120766727},{3,36030001,498225}]',0,1,1,'[]','[]','[]',1,0,0,0),(70030790,'日常任务','有人想打劫我的货物，如果你能帮我守住货物，我必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,790,809,0,0,0,0,0,0,'null','[]','10049015',10049016,40058,40059,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"15\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,548413}]',0,1,1,'[]','[]','[]',1,0,0,0),(70030810,'日常任务','有人想打劫我的货物，如果你能帮我守住货物，我必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,810,829,0,0,0,0,0,0,'null','[]','10049015',10049016,40058,40059,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"15\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70030830,'日常任务','有人想打劫我的货物，如果你能帮我守住货物，我必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,830,849,0,0,0,0,0,0,'null','[]','10049015',10049016,40058,40059,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"15\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70030850,'日常任务','有人想打劫我的货物，如果你能帮我守住货物，我必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,850,869,0,0,0,0,0,0,'null','[]','10049015',10049016,40058,40059,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"15\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70030870,'日常任务','有人想打劫我的货物，如果你能帮我守住货物，我必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,870,889,0,0,0,0,0,0,'null','[]','10049015',10049016,40058,40059,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"15\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70030890,'日常任务','有人想打劫我的货物，如果你能帮我守住货物，我必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,890,909,0,0,0,0,0,0,'null','[]','10049015',10049016,40058,40059,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"15\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70030910,'日常任务','有人想打劫我的货物，如果你能帮我守住货物，我必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,910,929,0,0,0,0,0,0,'null','[]','10049015',10049016,40058,40059,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"15\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70030930,'日常任务','有人想打劫我的货物，如果你能帮我守住货物，我必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,930,949,0,0,0,0,0,0,'null','[]','10049015',10049016,40058,40059,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"15\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70030950,'日常任务','有人想打劫我的货物，如果你能帮我守住货物，我必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,950,969,0,0,0,0,0,0,'null','[]','10049015',10049016,40058,40059,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"15\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70030970,'日常任务','有人想打劫我的货物，如果你能帮我守住货物，我必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,970,989,0,0,0,0,0,0,'null','[]','10049015',10049016,40058,40059,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"15\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70030990,'日常任务','有人想打劫我的货物，如果你能帮我守住货物，我必有重谢！（日常任务每10环有额外奖励哦！）','',7,0,1,990,1000,0,0,0,0,0,0,'null','[]','10049015',10049016,40058,40059,0,'[]','[[[\"kill\",\"1\",\"1004005\",\"15\",\"1004\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70040056,'日常任务','暴风健身开张大吉，我们教练各个伸手矫健，不信可以任意挑战，战胜有奖！（日常任务每10环有额外奖励哦！）','',7,0,1,56,80,0,0,0,0,0,0,'null','[]','10029010',10029010,40060,40061,0,'[]','[[[\"kill\",\"1\",\"1002004\",\"15\",\"1002\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,358250},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70040081,'日常任务','暴风健身开张大吉，我们教练各个伸手矫健，不信可以任意挑战，战胜有奖！（日常任务每10环有额外奖励哦！）','',7,0,1,81,99,0,0,0,0,0,0,'null','[]','10029010',10029010,40060,40061,0,'[]','[[[\"kill\",\"1\",\"1002004\",\"15\",\"1002\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70040095,'日常任务','暴风健身开张大吉，我们教练各个伸手矫健，不信可以任意挑战，战胜有奖！（日常任务每10环有额外奖励哦！）','',7,0,1,100,119,0,0,0,0,0,0,'null','[]','10029010',10029010,40060,40061,0,'[]','[[[\"kill\",\"1\",\"1002004\",\"15\",\"1002\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70040105,'日常任务','暴风健身开张大吉，我们教练各个伸手矫健，不信可以任意挑战，战胜有奖！（日常任务每10环有额外奖励哦！）','',7,0,1,120,139,0,0,0,0,0,0,'null','[]','10029010',10029010,40060,40061,0,'[]','[[[\"kill\",\"1\",\"1002004\",\"15\",\"1002\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70040120,'日常任务','暴风健身开张大吉，我们教练各个伸手矫健，不信可以任意挑战，战胜有奖！（日常任务每10环有额外奖励哦！）','',7,0,1,140,159,0,0,0,0,0,0,'null','[]','10029010',10029010,40060,40061,0,'[]','[[[\"kill\",\"1\",\"1002004\",\"15\",\"1002\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70040155,'日常任务','暴风健身开张大吉，我们教练各个伸手矫健，不信可以任意挑战，战胜有奖！（日常任务每10环有额外奖励哦！）','',7,0,1,160,179,0,0,0,0,0,0,'null','[]','10029010',10029010,40060,40061,0,'[]','[[[\"kill\",\"1\",\"1002004\",\"15\",\"1002\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70040180,'日常任务','暴风健身开张大吉，我们教练各个伸手矫健，不信可以任意挑战，战胜有奖！（日常任务每10环有额外奖励哦！）','',7,0,1,180,200,0,0,0,0,0,0,'null','[]','10029010',10029010,40060,40061,0,'[]','[[[\"kill\",\"1\",\"1002004\",\"15\",\"1002\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,2654846},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70040201,'日常任务','暴风健身开张大吉，我们教练各个伸手矫健，不信可以任意挑战，战胜有奖！（日常任务每10环有额外奖励哦！）','',7,0,1,201,239,0,0,0,0,0,0,'null','[]','10029010',10029010,40060,40061,0,'[]','[[[\"kill\",\"1\",\"1002004\",\"15\",\"1002\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,2936996},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70040240,'日常任务','暴风健身开张大吉，我们教练各个伸手矫健，不信可以任意挑战，战胜有奖！（日常任务每10环有额外奖励哦！）','',7,0,1,240,279,0,0,0,0,0,0,'null','[]','10029010',10029010,40060,40061,0,'[]','[[[\"kill\",\"1\",\"1002004\",\"15\",\"1002\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,4384137},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70040280,'日常任务','暴风健身开张大吉，我们教练各个伸手矫健，不信可以任意挑战，战胜有奖！（日常任务每10环有额外奖励哦！）','',7,0,1,280,319,0,0,0,0,0,0,'null','[]','10029010',10029010,40060,40061,0,'[]','[[[\"kill\",\"1\",\"1002004\",\"15\",\"1002\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,4937871},{3,36030001,11250}]',0,1,1,'[]','[]','[]',1,0,0,0),(70040320,'日常任务','暴风健身开张大吉，我们教练各个伸手矫健，不信可以任意挑战，战胜有奖！（日常任务每10环有额外奖励哦！）','',7,0,1,320,349,0,0,0,0,0,0,'null','[]','10029010',10029010,40060,40061,0,'[]','[[[\"kill\",\"1\",\"1002004\",\"15\",\"1002\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,5605803},{3,36030001,23000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70040350,'日常任务','暴风健身开张大吉，我们教练各个伸手矫健，不信可以任意挑战，战胜有奖！（日常任务每10环有额外奖励哦！）','',7,0,1,350,374,0,0,0,0,0,0,'null','[]','10029010',10029010,40060,40061,0,'[]','[[[\"kill\",\"1\",\"1002004\",\"15\",\"1002\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,6410766},{3,36030001,25163}]',0,1,1,'[]','[]','[]',1,0,0,0),(70040375,'日常任务','暴风健身开张大吉，我们教练各个伸手矫健，不信可以任意挑战，战胜有奖！（日常任务每10环有额外奖励哦！）','',7,0,1,375,399,0,0,0,0,0,0,'null','[]','10029010',10029010,40060,40061,0,'[]','[[[\"kill\",\"1\",\"1002004\",\"15\",\"1002\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,10358805},{3,36030001,29944}]',0,1,1,'[]','[]','[]',1,0,0,0),(70040400,'日常任务','暴风健身开张大吉，我们教练各个伸手矫健，不信可以任意挑战，战胜有奖！（日常任务每10环有额外奖励哦！）','',7,0,1,400,424,0,0,0,0,0,0,'null','[]','10029010',10029010,40060,40061,0,'[]','[[[\"kill\",\"1\",\"1002004\",\"15\",\"1002\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,15884705},{3,36030001,34781}]',0,1,1,'[]','[]','[]',1,0,0,0),(70040425,'日常任务','暴风健身开张大吉，我们教练各个伸手矫健，不信可以任意挑战，战胜有奖！（日常任务每10环有额外奖励哦！）','',7,0,1,425,449,0,0,0,0,0,0,'null','[]','10029010',10029010,40060,40061,0,'[]','[[[\"kill\",\"1\",\"1002004\",\"15\",\"1002\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,18734705},{3,36030001,41038}]',0,1,1,'[]','[]','[]',1,0,0,0),(70040450,'日常任务','暴风健身开张大吉，我们教练各个伸手矫健，不信可以任意挑战，战胜有奖！（日常任务每10环有额外奖励哦！）','',7,0,1,450,474,0,0,0,0,0,0,'null','[]','10029010',10029010,40060,40061,0,'[]','[[[\"kill\",\"1\",\"1002004\",\"15\",\"1002\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,25054113},{3,36030001,48956}]',0,1,1,'[]','[]','[]',1,0,0,0),(70040475,'日常任务','暴风健身开张大吉，我们教练各个伸手矫健，不信可以任意挑战，战胜有奖！（日常任务每10环有额外奖励哦！）','',7,0,1,475,514,0,0,0,0,0,0,'null','[]','10029010',10029010,40060,40061,0,'[]','[[[\"kill\",\"1\",\"1002004\",\"15\",\"1002\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,29975404},{3,36030001,60219}]',0,1,1,'[]','[]','[]',1,0,0,0),(70040515,'日常任务','暴风健身开张大吉，我们教练各个伸手矫健，不信可以任意挑战，战胜有奖！（日常任务每10环有额外奖励哦！）','',7,0,1,515,549,0,0,0,0,0,0,'null','[]','10029010',10029010,40060,40061,0,'[]','[[[\"kill\",\"1\",\"1002004\",\"15\",\"1002\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,34250404},{3,36030001,81819}]',0,1,1,'[]','[]','[]',1,0,0,0),(70040550,'日常任务','暴风健身开张大吉，我们教练各个伸手矫健，不信可以任意挑战，战胜有奖！（日常任务每10环有额外奖励哦！）','',7,0,1,550,574,0,0,0,0,0,0,'null','[]','10029010',10029010,40060,40061,0,'[]','[[[\"kill\",\"1\",\"1002004\",\"15\",\"1002\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,55163391},{3,36030001,111163}]',0,1,1,'[]','[]','[]',1,0,0,0),(70040575,'日常任务','暴风健身开张大吉，我们教练各个伸手矫健，不信可以任意挑战，战胜有奖！（日常任务每10环有额外奖励哦！）','',7,0,1,575,594,0,0,0,0,0,0,'null','[]','10029010',10029010,40060,40061,0,'[]','[[[\"kill\",\"1\",\"1002004\",\"15\",\"1002\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,63766727},{3,36030001,141144}]',0,1,1,'[]','[]','[]',1,0,0,0),(70040595,'日常任务','暴风健身开张大吉，我们教练各个伸手矫健，不信可以任意挑战，战胜有奖！（日常任务每10环有额外奖励哦！）','',7,0,1,595,609,0,0,0,0,0,0,'null','[]','10029010',10029010,40060,40061,0,'[]','[[[\"kill\",\"1\",\"1002004\",\"15\",\"1002\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,69466727},{3,36030001,167081}]',0,1,1,'[]','[]','[]',1,0,0,0),(70040610,'日常任务','暴风健身开张大吉，我们教练各个伸手矫健，不信可以任意挑战，战胜有奖！（日常任务每10环有额外奖励哦！）','',7,0,1,610,629,0,0,0,0,0,0,'null','[]','10029010',10029010,40060,40061,0,'[]','[[[\"kill\",\"1\",\"1002004\",\"15\",\"1002\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,75166727},{3,36030001,186725}]',0,1,1,'[]','[]','[]',1,0,0,0),(70040630,'日常任务','暴风健身开张大吉，我们教练各个伸手矫健，不信可以任意挑战，战胜有奖！（日常任务每10环有额外奖励哦！）','',7,0,1,630,649,0,0,0,0,0,0,'null','[]','10029010',10029010,40060,40061,0,'[]','[[[\"kill\",\"1\",\"1002004\",\"15\",\"1002\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,80866727},{3,36030001,216913}]',0,1,1,'[]','[]','[]',1,0,0,0),(70040650,'日常任务','暴风健身开张大吉，我们教练各个伸手矫健，不信可以任意挑战，战胜有奖！（日常任务每10环有额外奖励哦！）','',7,0,1,650,669,0,0,0,0,0,0,'null','[]','10029010',10029010,40060,40061,0,'[]','[[[\"kill\",\"1\",\"1002004\",\"15\",\"1002\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,86566727},{3,36030001,249600}]',0,1,1,'[]','[]','[]',1,0,0,0),(70040670,'日常任务','暴风健身开张大吉，我们教练各个伸手矫健，不信可以任意挑战，战胜有奖！（日常任务每10环有额外奖励哦！）','',7,0,1,670,689,0,0,0,0,0,0,'null','[]','10029010',10029010,40060,40061,0,'[]','[[[\"kill\",\"1\",\"1002004\",\"15\",\"1002\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,92266727},{3,36030001,284788}]',0,1,1,'[]','[]','[]',1,0,0,0),(70040690,'日常任务','暴风健身开张大吉，我们教练各个伸手矫健，不信可以任意挑战，战胜有奖！（日常任务每10环有额外奖励哦！）','',7,0,1,690,709,0,0,0,0,0,0,'null','[]','10029010',10029010,40060,40061,0,'[]','[[[\"kill\",\"1\",\"1002004\",\"15\",\"1002\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,97966727},{3,36030001,322475}]',0,1,1,'[]','[]','[]',1,0,0,0),(70040710,'日常任务','暴风健身开张大吉，我们教练各个伸手矫健，不信可以任意挑战，战胜有奖！（日常任务每10环有额外奖励哦！）','',7,0,1,710,729,0,0,0,0,0,0,'null','[]','10029010',10029010,40060,40061,0,'[]','[[[\"kill\",\"1\",\"1002004\",\"15\",\"1002\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,103666727},{3,36030001,362663}]',0,1,1,'[]','[]','[]',1,0,0,0),(70040730,'日常任务','暴风健身开张大吉，我们教练各个伸手矫健，不信可以任意挑战，战胜有奖！（日常任务每10环有额外奖励哦！）','',7,0,1,730,749,0,0,0,0,0,0,'null','[]','10029010',10029010,40060,40061,0,'[]','[[[\"kill\",\"1\",\"1002004\",\"15\",\"1002\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,109366727},{3,36030001,405350}]',0,1,1,'[]','[]','[]',1,0,0,0),(70040750,'日常任务','暴风健身开张大吉，我们教练各个伸手矫健，不信可以任意挑战，战胜有奖！（日常任务每10环有额外奖励哦！）','',7,0,1,750,769,0,0,0,0,0,0,'null','[]','10029010',10029010,40060,40061,0,'[]','[[[\"kill\",\"1\",\"1002004\",\"15\",\"1002\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,115066727},{3,36030001,450538}]',0,1,1,'[]','[]','[]',1,0,0,0),(70040770,'日常任务','暴风健身开张大吉，我们教练各个伸手矫健，不信可以任意挑战，战胜有奖！（日常任务每10环有额外奖励哦！）','',7,0,1,770,789,0,0,0,0,0,0,'null','[]','10029010',10029010,40060,40061,0,'[]','[[[\"kill\",\"1\",\"1002004\",\"15\",\"1002\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,120766727},{3,36030001,498225}]',0,1,1,'[]','[]','[]',1,0,0,0),(70040790,'日常任务','暴风健身开张大吉，我们教练各个伸手矫健，不信可以任意挑战，战胜有奖！（日常任务每10环有额外奖励哦！）','',7,0,1,790,809,0,0,0,0,0,0,'null','[]','10029010',10029010,40060,40061,0,'[]','[[[\"kill\",\"1\",\"1002004\",\"15\",\"1002\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,548413}]',0,1,1,'[]','[]','[]',1,0,0,0),(70040810,'日常任务','暴风健身开张大吉，我们教练各个伸手矫健，不信可以任意挑战，战胜有奖！（日常任务每10环有额外奖励哦！）','',7,0,1,810,829,0,0,0,0,0,0,'null','[]','10029010',10029010,40060,40061,0,'[]','[[[\"kill\",\"1\",\"1002004\",\"15\",\"1002\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70040830,'日常任务','暴风健身开张大吉，我们教练各个伸手矫健，不信可以任意挑战，战胜有奖！（日常任务每10环有额外奖励哦！）','',7,0,1,830,849,0,0,0,0,0,0,'null','[]','10029010',10029010,40060,40061,0,'[]','[[[\"kill\",\"1\",\"1002004\",\"15\",\"1002\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70040850,'日常任务','暴风健身开张大吉，我们教练各个伸手矫健，不信可以任意挑战，战胜有奖！（日常任务每10环有额外奖励哦！）','',7,0,1,850,869,0,0,0,0,0,0,'null','[]','10029010',10029010,40060,40061,0,'[]','[[[\"kill\",\"1\",\"1002004\",\"15\",\"1002\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70040870,'日常任务','暴风健身开张大吉，我们教练各个伸手矫健，不信可以任意挑战，战胜有奖！（日常任务每10环有额外奖励哦！）','',7,0,1,870,889,0,0,0,0,0,0,'null','[]','10029010',10029010,40060,40061,0,'[]','[[[\"kill\",\"1\",\"1002004\",\"15\",\"1002\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70040890,'日常任务','暴风健身开张大吉，我们教练各个伸手矫健，不信可以任意挑战，战胜有奖！（日常任务每10环有额外奖励哦！）','',7,0,1,890,909,0,0,0,0,0,0,'null','[]','10029010',10029010,40060,40061,0,'[]','[[[\"kill\",\"1\",\"1002004\",\"15\",\"1002\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70040910,'日常任务','暴风健身开张大吉，我们教练各个伸手矫健，不信可以任意挑战，战胜有奖！（日常任务每10环有额外奖励哦！）','',7,0,1,910,929,0,0,0,0,0,0,'null','[]','10029010',10029010,40060,40061,0,'[]','[[[\"kill\",\"1\",\"1002004\",\"15\",\"1002\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70040930,'日常任务','暴风健身开张大吉，我们教练各个伸手矫健，不信可以任意挑战，战胜有奖！（日常任务每10环有额外奖励哦！）','',7,0,1,930,949,0,0,0,0,0,0,'null','[]','10029010',10029010,40060,40061,0,'[]','[[[\"kill\",\"1\",\"1002004\",\"15\",\"1002\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70040950,'日常任务','暴风健身开张大吉，我们教练各个伸手矫健，不信可以任意挑战，战胜有奖！（日常任务每10环有额外奖励哦！）','',7,0,1,950,969,0,0,0,0,0,0,'null','[]','10029010',10029010,40060,40061,0,'[]','[[[\"kill\",\"1\",\"1002004\",\"15\",\"1002\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70040970,'日常任务','暴风健身开张大吉，我们教练各个伸手矫健，不信可以任意挑战，战胜有奖！（日常任务每10环有额外奖励哦！）','',7,0,1,970,989,0,0,0,0,0,0,'null','[]','10029010',10029010,40060,40061,0,'[]','[[[\"kill\",\"1\",\"1002004\",\"15\",\"1002\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70040990,'日常任务','暴风健身开张大吉，我们教练各个伸手矫健，不信可以任意挑战，战胜有奖！（日常任务每10环有额外奖励哦！）','',7,0,1,990,1000,0,0,0,0,0,0,'null','[]','10029010',10029010,40060,40061,0,'[]','[[[\"kill\",\"1\",\"1002004\",\"15\",\"1002\",\"0\",\"0\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70050056,'日常任务','我是一个邮差，但我的脚不小心崴到了，你能帮忙送下么?（日常任务每10环有额外奖励哦！）','',7,0,0,56,80,0,0,0,0,0,0,'null','[]','10029009',10029009,40062,40063,0,'[]','[]',0,'[{5,36060001,358250},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70050081,'日常任务','我是一个邮差，但我的脚不小心崴到了，你能帮忙送下么?（日常任务每10环有额外奖励哦！）','',7,0,1,81,99,0,0,0,0,0,0,'null','[]','10029009',10029009,40062,40063,0,'[]','[]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70050095,'日常任务','我是一个邮差，但我的脚不小心崴到了，你能帮忙送下么?（日常任务每10环有额外奖励哦！）','',7,0,0,100,119,0,0,0,0,0,0,'null','[]','10029009',10029009,40062,40063,0,'[]','[]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70050105,'日常任务','我是一个邮差，但我的脚不小心崴到了，你能帮忙送下么?（日常任务每10环有额外奖励哦！）','',7,0,0,120,139,0,0,0,0,0,0,'null','[]','10029009',10029009,40062,40063,0,'[]','[]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70050120,'日常任务','我是一个邮差，但我的脚不小心崴到了，你能帮忙送下么?（日常任务每10环有额外奖励哦！）','',7,0,0,140,159,0,0,0,0,0,0,'null','[]','10029009',10029009,40062,40063,0,'[]','[]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70050155,'日常任务','我是一个邮差，但我的脚不小心崴到了，你能帮忙送下么?（日常任务每10环有额外奖励哦！）','',7,0,0,160,179,0,0,0,0,0,0,'null','[]','10029009',10029009,40062,40063,0,'[]','[]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70050180,'日常任务','我是一个邮差，但我的脚不小心崴到了，你能帮忙送下么?（日常任务每10环有额外奖励哦！）','',7,0,0,180,200,0,0,0,0,0,0,'null','[]','10029009',10029009,40062,40063,0,'[]','[]',0,'[{5,36060001,2654846},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70050201,'日常任务','我是一个邮差，但我的脚不小心崴到了，你能帮忙送下么?（日常任务每10环有额外奖励哦！）','',7,0,0,201,239,0,0,0,0,0,0,'null','[]','10029009',10029009,40062,40063,0,'[]','[]',0,'[{5,36060001,2936996},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70050240,'日常任务','我是一个邮差，但我的脚不小心崴到了，你能帮忙送下么?（日常任务每10环有额外奖励哦！）','',7,0,0,240,279,0,0,0,0,0,0,'null','[]','10029009',10029009,40062,40063,0,'[]','[]',0,'[{5,36060001,4384137},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70050280,'日常任务','我是一个邮差，但我的脚不小心崴到了，你能帮忙送下么?（日常任务每10环有额外奖励哦！）','',7,0,0,280,319,0,0,0,0,0,0,'null','[]','10029009',10029009,40062,40063,0,'[]','[]',0,'[{5,36060001,4937871},{3,36030001,11250}]',0,1,1,'[]','[]','[]',1,0,0,0),(70050320,'日常任务','我是一个邮差，但我的脚不小心崴到了，你能帮忙送下么?（日常任务每10环有额外奖励哦！）','',7,0,0,320,349,0,0,0,0,0,0,'null','[]','10029009',10029009,40062,40063,0,'[]','[]',0,'[{5,36060001,5605803},{3,36030001,23000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70050350,'日常任务','我是一个邮差，但我的脚不小心崴到了，你能帮忙送下么?（日常任务每10环有额外奖励哦！）','',7,0,0,350,374,0,0,0,0,0,0,'null','[]','10029009',10029009,40062,40063,0,'[]','[]',0,'[{5,36060001,6410766},{3,36030001,25163}]',0,1,1,'[]','[]','[]',1,0,0,0),(70050375,'日常任务','我是一个邮差，但我的脚不小心崴到了，你能帮忙送下么?（日常任务每10环有额外奖励哦！）','',7,0,0,375,399,0,0,0,0,0,0,'null','[]','10029009',10029009,40062,40063,0,'[]','[]',0,'[{5,36060001,10358805},{3,36030001,29944}]',0,1,1,'[]','[]','[]',1,0,0,0),(70050400,'日常任务','我是一个邮差，但我的脚不小心崴到了，你能帮忙送下么?（日常任务每10环有额外奖励哦！）','',7,0,0,400,424,0,0,0,0,0,0,'null','[]','10029009',10029009,40062,40063,0,'[]','[]',0,'[{5,36060001,15884705},{3,36030001,34781}]',0,1,1,'[]','[]','[]',1,0,0,0),(70050425,'日常任务','我是一个邮差，但我的脚不小心崴到了，你能帮忙送下么?（日常任务每10环有额外奖励哦！）','',7,0,0,425,449,0,0,0,0,0,0,'null','[]','10029009',10029009,40062,40063,0,'[]','[]',0,'[{5,36060001,18734705},{3,36030001,41038}]',0,1,1,'[]','[]','[]',1,0,0,0),(70050450,'日常任务','我是一个邮差，但我的脚不小心崴到了，你能帮忙送下么?（日常任务每10环有额外奖励哦！）','',7,0,0,450,474,0,0,0,0,0,0,'null','[]','10029009',10029009,40062,40063,0,'[]','[]',0,'[{5,36060001,25054113},{3,36030001,48956}]',0,1,1,'[]','[]','[]',1,0,0,0),(70050475,'日常任务','我是一个邮差，但我的脚不小心崴到了，你能帮忙送下么?（日常任务每10环有额外奖励哦！）','',7,0,0,475,514,0,0,0,0,0,0,'null','[]','10029009',10029009,40062,40063,0,'[]','[]',0,'[{5,36060001,29975404},{3,36030001,60219}]',0,1,1,'[]','[]','[]',1,0,0,0),(70050515,'日常任务','我是一个邮差，但我的脚不小心崴到了，你能帮忙送下么?（日常任务每10环有额外奖励哦！）','',7,0,0,515,549,0,0,0,0,0,0,'null','[]','10029009',10029009,40062,40063,0,'[]','[]',0,'[{5,36060001,34250404},{3,36030001,81819}]',0,1,1,'[]','[]','[]',1,0,0,0),(70050550,'日常任务','我是一个邮差，但我的脚不小心崴到了，你能帮忙送下么?（日常任务每10环有额外奖励哦！）','',7,0,0,550,574,0,0,0,0,0,0,'null','[]','10029009',10029009,40062,40063,0,'[]','[]',0,'[{5,36060001,55163391},{3,36030001,111163}]',0,1,1,'[]','[]','[]',1,0,0,0),(70050575,'日常任务','我是一个邮差，但我的脚不小心崴到了，你能帮忙送下么?（日常任务每10环有额外奖励哦！）','',7,0,0,575,594,0,0,0,0,0,0,'null','[]','10029009',10029009,40062,40063,0,'[]','[]',0,'[{5,36060001,63766727},{3,36030001,141144}]',0,1,1,'[]','[]','[]',1,0,0,0),(70050595,'日常任务','我是一个邮差，但我的脚不小心崴到了，你能帮忙送下么?（日常任务每10环有额外奖励哦！）','',7,0,0,595,609,0,0,0,0,0,0,'null','[]','10029009',10029009,40062,40063,0,'[]','[]',0,'[{5,36060001,69466727},{3,36030001,167081}]',0,1,1,'[]','[]','[]',1,0,0,0),(70050610,'日常任务','我是一个邮差，但我的脚不小心崴到了，你能帮忙送下么?（日常任务每10环有额外奖励哦！）','',7,0,0,610,629,0,0,0,0,0,0,'null','[]','10029009',10029009,40062,40063,0,'[]','[]',0,'[{5,36060001,75166727},{3,36030001,186725}]',0,1,1,'[]','[]','[]',1,0,0,0),(70050630,'日常任务','我是一个邮差，但我的脚不小心崴到了，你能帮忙送下么?（日常任务每10环有额外奖励哦！）','',7,0,0,630,649,0,0,0,0,0,0,'null','[]','10029009',10029009,40062,40063,0,'[]','[]',0,'[{5,36060001,80866727},{3,36030001,216913}]',0,1,1,'[]','[]','[]',1,0,0,0),(70050650,'日常任务','我是一个邮差，但我的脚不小心崴到了，你能帮忙送下么?（日常任务每10环有额外奖励哦！）','',7,0,0,650,669,0,0,0,0,0,0,'null','[]','10029009',10029009,40062,40063,0,'[]','[]',0,'[{5,36060001,86566727},{3,36030001,249600}]',0,1,1,'[]','[]','[]',1,0,0,0),(70050670,'日常任务','我是一个邮差，但我的脚不小心崴到了，你能帮忙送下么?（日常任务每10环有额外奖励哦！）','',7,0,0,670,689,0,0,0,0,0,0,'null','[]','10029009',10029009,40062,40063,0,'[]','[]',0,'[{5,36060001,92266727},{3,36030001,284788}]',0,1,1,'[]','[]','[]',1,0,0,0),(70050690,'日常任务','我是一个邮差，但我的脚不小心崴到了，你能帮忙送下么?（日常任务每10环有额外奖励哦！）','',7,0,0,690,709,0,0,0,0,0,0,'null','[]','10029009',10029009,40062,40063,0,'[]','[]',0,'[{5,36060001,97966727},{3,36030001,322475}]',0,1,1,'[]','[]','[]',1,0,0,0),(70050710,'日常任务','我是一个邮差，但我的脚不小心崴到了，你能帮忙送下么?（日常任务每10环有额外奖励哦！）','',7,0,0,710,729,0,0,0,0,0,0,'null','[]','10029009',10029009,40062,40063,0,'[]','[]',0,'[{5,36060001,103666727},{3,36030001,362663}]',0,1,1,'[]','[]','[]',1,0,0,0),(70050730,'日常任务','我是一个邮差，但我的脚不小心崴到了，你能帮忙送下么?（日常任务每10环有额外奖励哦！）','',7,0,0,730,749,0,0,0,0,0,0,'null','[]','10029009',10029009,40062,40063,0,'[]','[]',0,'[{5,36060001,109366727},{3,36030001,405350}]',0,1,1,'[]','[]','[]',1,0,0,0),(70050750,'日常任务','我是一个邮差，但我的脚不小心崴到了，你能帮忙送下么?（日常任务每10环有额外奖励哦！）','',7,0,0,750,769,0,0,0,0,0,0,'null','[]','10029009',10029009,40062,40063,0,'[]','[]',0,'[{5,36060001,115066727},{3,36030001,450538}]',0,1,1,'[]','[]','[]',1,0,0,0),(70050770,'日常任务','我是一个邮差，但我的脚不小心崴到了，你能帮忙送下么?（日常任务每10环有额外奖励哦！）','',7,0,0,770,789,0,0,0,0,0,0,'null','[]','10029009',10029009,40062,40063,0,'[]','[]',0,'[{5,36060001,120766727},{3,36030001,498225}]',0,1,1,'[]','[]','[]',1,0,0,0),(70050790,'日常任务','我是一个邮差，但我的脚不小心崴到了，你能帮忙送下么?（日常任务每10环有额外奖励哦！）','',7,0,0,790,809,0,0,0,0,0,0,'null','[]','10029009',10029009,40062,40063,0,'[]','[]',0,'[{5,36060001,126466727},{3,36030001,548413}]',0,1,1,'[]','[]','[]',1,0,0,0),(70050810,'日常任务','我是一个邮差，但我的脚不小心崴到了，你能帮忙送下么?（日常任务每10环有额外奖励哦！）','',7,0,0,810,829,0,0,0,0,0,0,'null','[]','10029009',10029009,40062,40063,0,'[]','[]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70050830,'日常任务','我是一个邮差，但我的脚不小心崴到了，你能帮忙送下么?（日常任务每10环有额外奖励哦！）','',7,0,0,830,849,0,0,0,0,0,0,'null','[]','10029009',10029009,40062,40063,0,'[]','[]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70050850,'日常任务','我是一个邮差，但我的脚不小心崴到了，你能帮忙送下么?（日常任务每10环有额外奖励哦！）','',7,0,0,850,869,0,0,0,0,0,0,'null','[]','10029009',10029009,40062,40063,0,'[]','[]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70050870,'日常任务','我是一个邮差，但我的脚不小心崴到了，你能帮忙送下么?（日常任务每10环有额外奖励哦！）','',7,0,0,870,889,0,0,0,0,0,0,'null','[]','10029009',10029009,40062,40063,0,'[]','[]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70050890,'日常任务','我是一个邮差，但我的脚不小心崴到了，你能帮忙送下么?（日常任务每10环有额外奖励哦！）','',7,0,0,890,909,0,0,0,0,0,0,'null','[]','10029009',10029009,40062,40063,0,'[]','[]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70050910,'日常任务','我是一个邮差，但我的脚不小心崴到了，你能帮忙送下么?（日常任务每10环有额外奖励哦！）','',7,0,0,910,929,0,0,0,0,0,0,'null','[]','10029009',10029009,40062,40063,0,'[]','[]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70050930,'日常任务','我是一个邮差，但我的脚不小心崴到了，你能帮忙送下么?（日常任务每10环有额外奖励哦！）','',7,0,0,930,949,0,0,0,0,0,0,'null','[]','10029009',10029009,40062,40063,0,'[]','[]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70050950,'日常任务','我是一个邮差，但我的脚不小心崴到了，你能帮忙送下么?（日常任务每10环有额外奖励哦！）','',7,0,0,950,969,0,0,0,0,0,0,'null','[]','10029009',10029009,40062,40063,0,'[]','[]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70050970,'日常任务','我是一个邮差，但我的脚不小心崴到了，你能帮忙送下么?（日常任务每10环有额外奖励哦！）','',7,0,0,970,989,0,0,0,0,0,0,'null','[]','10029009',10029009,40062,40063,0,'[]','[]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70050990,'日常任务','我是一个邮差，但我的脚不小心崴到了，你能帮忙送下么?（日常任务每10环有额外奖励哦！）','',7,0,0,990,1000,0,0,0,0,0,0,'null','[]','10029009',10029009,40062,40063,0,'[]','[]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70060056,'日常任务','作为暴风外送的成员，一秒都不能耽搁，你还不快送！（日常任务每10环有额外奖励哦！）','',7,0,0,56,80,0,0,0,0,0,0,'null','[]','10049021',10049022,40064,40065,0,'[]','[]',0,'[{5,36060001,358250},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70060081,'日常任务','作为暴风外送的成员，一秒都不能耽搁，你还不快送！（日常任务每10环有额外奖励哦！）','',7,0,0,81,99,0,0,0,0,0,0,'null','[]','10049021',10049022,40064,40065,0,'[]','[]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70060095,'日常任务','作为暴风外送的成员，一秒都不能耽搁，你还不快送！（日常任务每10环有额外奖励哦！）','',7,0,0,100,119,0,0,0,0,0,0,'null','[]','10049021',10049022,40064,40065,0,'[]','[]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70060105,'日常任务','作为暴风外送的成员，一秒都不能耽搁，你还不快送！（日常任务每10环有额外奖励哦！）','',7,0,0,120,139,0,0,0,0,0,0,'null','[]','10049021',10049022,40064,40065,0,'[]','[]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70060120,'日常任务','作为暴风外送的成员，一秒都不能耽搁，你还不快送！（日常任务每10环有额外奖励哦！）','',7,0,0,140,159,0,0,0,0,0,0,'null','[]','10049021',10049022,40064,40065,0,'[]','[]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70060155,'日常任务','作为暴风外送的成员，一秒都不能耽搁，你还不快送！（日常任务每10环有额外奖励哦！）','',7,0,0,160,179,0,0,0,0,0,0,'null','[]','10049021',10049022,40064,40065,0,'[]','[]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70060180,'日常任务','作为暴风外送的成员，一秒都不能耽搁，你还不快送！（日常任务每10环有额外奖励哦！）','',7,0,0,180,200,0,0,0,0,0,0,'null','[]','10049021',10049022,40064,40065,0,'[]','[]',0,'[{5,36060001,2654846},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70060201,'日常任务','作为暴风外送的成员，一秒都不能耽搁，你还不快送！（日常任务每10环有额外奖励哦！）','',7,0,0,201,239,0,0,0,0,0,0,'null','[]','10049021',10049022,40064,40065,0,'[]','[]',0,'[{5,36060001,2936996},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70060240,'日常任务','作为暴风外送的成员，一秒都不能耽搁，你还不快送！（日常任务每10环有额外奖励哦！）','',7,0,0,240,279,0,0,0,0,0,0,'null','[]','10049021',10049022,40064,40065,0,'[]','[]',0,'[{5,36060001,4384137},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70060280,'日常任务','作为暴风外送的成员，一秒都不能耽搁，你还不快送！（日常任务每10环有额外奖励哦！）','',7,0,0,280,319,0,0,0,0,0,0,'null','[]','10049021',10049022,40064,40065,0,'[]','[]',0,'[{5,36060001,4937871},{3,36030001,11250}]',0,1,1,'[]','[]','[]',1,0,0,0),(70060320,'日常任务','作为暴风外送的成员，一秒都不能耽搁，你还不快送！（日常任务每10环有额外奖励哦！）','',7,0,0,320,349,0,0,0,0,0,0,'null','[]','10049021',10049022,40064,40065,0,'[]','[]',0,'[{5,36060001,5605803},{3,36030001,23000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70060350,'日常任务','作为暴风外送的成员，一秒都不能耽搁，你还不快送！（日常任务每10环有额外奖励哦！）','',7,0,0,350,374,0,0,0,0,0,0,'null','[]','10049021',10049022,40064,40065,0,'[]','[]',0,'[{5,36060001,6410766},{3,36030001,25163}]',0,1,1,'[]','[]','[]',1,0,0,0),(70060375,'日常任务','作为暴风外送的成员，一秒都不能耽搁，你还不快送！（日常任务每10环有额外奖励哦！）','',7,0,0,375,399,0,0,0,0,0,0,'null','[]','10049021',10049022,40064,40065,0,'[]','[]',0,'[{5,36060001,10358805},{3,36030001,29944}]',0,1,1,'[]','[]','[]',1,0,0,0),(70060400,'日常任务','作为暴风外送的成员，一秒都不能耽搁，你还不快送！（日常任务每10环有额外奖励哦！）','',7,0,0,400,424,0,0,0,0,0,0,'null','[]','10049021',10049022,40064,40065,0,'[]','[]',0,'[{5,36060001,15884705},{3,36030001,34781}]',0,1,1,'[]','[]','[]',1,0,0,0),(70060425,'日常任务','作为暴风外送的成员，一秒都不能耽搁，你还不快送！（日常任务每10环有额外奖励哦！）','',7,0,0,425,449,0,0,0,0,0,0,'null','[]','10049021',10049022,40064,40065,0,'[]','[]',0,'[{5,36060001,18734705},{3,36030001,41038}]',0,1,1,'[]','[]','[]',1,0,0,0),(70060450,'日常任务','作为暴风外送的成员，一秒都不能耽搁，你还不快送！（日常任务每10环有额外奖励哦！）','',7,0,0,450,474,0,0,0,0,0,0,'null','[]','10049021',10049022,40064,40065,0,'[]','[]',0,'[{5,36060001,25054113},{3,36030001,48956}]',0,1,1,'[]','[]','[]',1,0,0,0),(70060475,'日常任务','作为暴风外送的成员，一秒都不能耽搁，你还不快送！（日常任务每10环有额外奖励哦！）','',7,0,0,475,514,0,0,0,0,0,0,'null','[]','10049021',10049022,40064,40065,0,'[]','[]',0,'[{5,36060001,29975404},{3,36030001,60219}]',0,1,1,'[]','[]','[]',1,0,0,0),(70060515,'日常任务','作为暴风外送的成员，一秒都不能耽搁，你还不快送！（日常任务每10环有额外奖励哦！）','',7,0,0,515,549,0,0,0,0,0,0,'null','[]','10049021',10049022,40064,40065,0,'[]','[]',0,'[{5,36060001,34250404},{3,36030001,81819}]',0,1,1,'[]','[]','[]',1,0,0,0),(70060550,'日常任务','作为暴风外送的成员，一秒都不能耽搁，你还不快送！（日常任务每10环有额外奖励哦！）','',7,0,0,550,574,0,0,0,0,0,0,'null','[]','10049021',10049022,40064,40065,0,'[]','[]',0,'[{5,36060001,55163391},{3,36030001,111163}]',0,1,1,'[]','[]','[]',1,0,0,0),(70060575,'日常任务','作为暴风外送的成员，一秒都不能耽搁，你还不快送！（日常任务每10环有额外奖励哦！）','',7,0,0,575,594,0,0,0,0,0,0,'null','[]','10049021',10049022,40064,40065,0,'[]','[]',0,'[{5,36060001,63766727},{3,36030001,141144}]',0,1,1,'[]','[]','[]',1,0,0,0),(70060595,'日常任务','作为暴风外送的成员，一秒都不能耽搁，你还不快送！（日常任务每10环有额外奖励哦！）','',7,0,0,595,609,0,0,0,0,0,0,'null','[]','10049021',10049022,40064,40065,0,'[]','[]',0,'[{5,36060001,69466727},{3,36030001,167081}]',0,1,1,'[]','[]','[]',1,0,0,0),(70060610,'日常任务','作为暴风外送的成员，一秒都不能耽搁，你还不快送！（日常任务每10环有额外奖励哦！）','',7,0,0,610,629,0,0,0,0,0,0,'null','[]','10049021',10049022,40064,40065,0,'[]','[]',0,'[{5,36060001,75166727},{3,36030001,186725}]',0,1,1,'[]','[]','[]',1,0,0,0),(70060630,'日常任务','作为暴风外送的成员，一秒都不能耽搁，你还不快送！（日常任务每10环有额外奖励哦！）','',7,0,0,630,649,0,0,0,0,0,0,'null','[]','10049021',10049022,40064,40065,0,'[]','[]',0,'[{5,36060001,80866727},{3,36030001,216913}]',0,1,1,'[]','[]','[]',1,0,0,0),(70060650,'日常任务','作为暴风外送的成员，一秒都不能耽搁，你还不快送！（日常任务每10环有额外奖励哦！）','',7,0,0,650,669,0,0,0,0,0,0,'null','[]','10049021',10049022,40064,40065,0,'[]','[]',0,'[{5,36060001,86566727},{3,36030001,249600}]',0,1,1,'[]','[]','[]',1,0,0,0),(70060670,'日常任务','作为暴风外送的成员，一秒都不能耽搁，你还不快送！（日常任务每10环有额外奖励哦！）','',7,0,0,670,689,0,0,0,0,0,0,'null','[]','10049021',10049022,40064,40065,0,'[]','[]',0,'[{5,36060001,92266727},{3,36030001,284788}]',0,1,1,'[]','[]','[]',1,0,0,0),(70060690,'日常任务','作为暴风外送的成员，一秒都不能耽搁，你还不快送！（日常任务每10环有额外奖励哦！）','',7,0,0,690,709,0,0,0,0,0,0,'null','[]','10049021',10049022,40064,40065,0,'[]','[]',0,'[{5,36060001,97966727},{3,36030001,322475}]',0,1,1,'[]','[]','[]',1,0,0,0),(70060710,'日常任务','作为暴风外送的成员，一秒都不能耽搁，你还不快送！（日常任务每10环有额外奖励哦！）','',7,0,0,710,729,0,0,0,0,0,0,'null','[]','10049021',10049022,40064,40065,0,'[]','[]',0,'[{5,36060001,103666727},{3,36030001,362663}]',0,1,1,'[]','[]','[]',1,0,0,0),(70060730,'日常任务','作为暴风外送的成员，一秒都不能耽搁，你还不快送！（日常任务每10环有额外奖励哦！）','',7,0,0,730,749,0,0,0,0,0,0,'null','[]','10049021',10049022,40064,40065,0,'[]','[]',0,'[{5,36060001,109366727},{3,36030001,405350}]',0,1,1,'[]','[]','[]',1,0,0,0),(70060750,'日常任务','作为暴风外送的成员，一秒都不能耽搁，你还不快送！（日常任务每10环有额外奖励哦！）','',7,0,0,750,769,0,0,0,0,0,0,'null','[]','10049021',10049022,40064,40065,0,'[]','[]',0,'[{5,36060001,115066727},{3,36030001,450538}]',0,1,1,'[]','[]','[]',1,0,0,0),(70060770,'日常任务','作为暴风外送的成员，一秒都不能耽搁，你还不快送！（日常任务每10环有额外奖励哦！）','',7,0,0,770,789,0,0,0,0,0,0,'null','[]','10049021',10049022,40064,40065,0,'[]','[]',0,'[{5,36060001,120766727},{3,36030001,498225}]',0,1,1,'[]','[]','[]',1,0,0,0),(70060790,'日常任务','作为暴风外送的成员，一秒都不能耽搁，你还不快送！（日常任务每10环有额外奖励哦！）','',7,0,0,790,809,0,0,0,0,0,0,'null','[]','10049021',10049022,40064,40065,0,'[]','[]',0,'[{5,36060001,126466727},{3,36030001,548413}]',0,1,1,'[]','[]','[]',1,0,0,0),(70060810,'日常任务','作为暴风外送的成员，一秒都不能耽搁，你还不快送！（日常任务每10环有额外奖励哦！）','',7,0,0,810,829,0,0,0,0,0,0,'null','[]','10049021',10049022,40064,40065,0,'[]','[]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70060830,'日常任务','作为暴风外送的成员，一秒都不能耽搁，你还不快送！（日常任务每10环有额外奖励哦！）','',7,0,0,830,849,0,0,0,0,0,0,'null','[]','10049021',10049022,40064,40065,0,'[]','[]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70060850,'日常任务','作为暴风外送的成员，一秒都不能耽搁，你还不快送！（日常任务每10环有额外奖励哦！）','',7,0,0,850,869,0,0,0,0,0,0,'null','[]','10049021',10049022,40064,40065,0,'[]','[]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70060870,'日常任务','作为暴风外送的成员，一秒都不能耽搁，你还不快送！（日常任务每10环有额外奖励哦！）','',7,0,0,870,889,0,0,0,0,0,0,'null','[]','10049021',10049022,40064,40065,0,'[]','[]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70060890,'日常任务','作为暴风外送的成员，一秒都不能耽搁，你还不快送！（日常任务每10环有额外奖励哦！）','',7,0,0,890,909,0,0,0,0,0,0,'null','[]','10049021',10049022,40064,40065,0,'[]','[]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70060910,'日常任务','作为暴风外送的成员，一秒都不能耽搁，你还不快送！（日常任务每10环有额外奖励哦！）','',7,0,0,910,929,0,0,0,0,0,0,'null','[]','10049021',10049022,40064,40065,0,'[]','[]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70060930,'日常任务','作为暴风外送的成员，一秒都不能耽搁，你还不快送！（日常任务每10环有额外奖励哦！）','',7,0,0,930,949,0,0,0,0,0,0,'null','[]','10049021',10049022,40064,40065,0,'[]','[]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70060950,'日常任务','作为暴风外送的成员，一秒都不能耽搁，你还不快送！（日常任务每10环有额外奖励哦！）','',7,0,0,950,969,0,0,0,0,0,0,'null','[]','10049021',10049022,40064,40065,0,'[]','[]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70060970,'日常任务','作为暴风外送的成员，一秒都不能耽搁，你还不快送！（日常任务每10环有额外奖励哦！）','',7,0,0,970,989,0,0,0,0,0,0,'null','[]','10049021',10049022,40064,40065,0,'[]','[]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70060990,'日常任务','作为暴风外送的成员，一秒都不能耽搁，你还不快送！（日常任务每10环有额外奖励哦！）','',7,0,0,990,1000,0,0,0,0,0,0,'null','[]','10049021',10049022,40064,40065,0,'[]','[]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70070056,'日常任务','我的好朋友生日快到了，你能帮我送这个礼物给他么？（日常任务每10环有额外奖励哦！）','',7,0,0,56,80,0,0,0,0,0,0,'null','[]','10049024',10049024,40066,40067,0,'[]','[]',0,'[{5,36060001,358250},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70070081,'日常任务','我的好朋友生日快到了，你能帮我送这个礼物给他么？（日常任务每10环有额外奖励哦！）','',7,0,0,81,99,0,0,0,0,0,0,'null','[]','10049024',10049024,40066,40067,0,'[]','[]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70070095,'日常任务','我的好朋友生日快到了，你能帮我送这个礼物给他么？（日常任务每10环有额外奖励哦！）','',7,0,0,100,119,0,0,0,0,0,0,'null','[]','10049024',10049024,40066,40067,0,'[]','[]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70070105,'日常任务','我的好朋友生日快到了，你能帮我送这个礼物给他么？（日常任务每10环有额外奖励哦！）','',7,0,0,120,139,0,0,0,0,0,0,'null','[]','10049024',10049024,40066,40067,0,'[]','[]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70070120,'日常任务','我的好朋友生日快到了，你能帮我送这个礼物给他么？（日常任务每10环有额外奖励哦！）','',7,0,0,140,159,0,0,0,0,0,0,'null','[]','10049024',10049024,40066,40067,0,'[]','[]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70070155,'日常任务','我的好朋友生日快到了，你能帮我送这个礼物给他么？（日常任务每10环有额外奖励哦！）','',7,0,0,160,179,0,0,0,0,0,0,'null','[]','10049024',10049024,40066,40067,0,'[]','[]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70070180,'日常任务','我的好朋友生日快到了，你能帮我送这个礼物给他么？（日常任务每10环有额外奖励哦！）','',7,0,0,180,200,0,0,0,0,0,0,'null','[]','10049024',10049024,40066,40067,0,'[]','[]',0,'[{5,36060001,2654846},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70070201,'日常任务','我的好朋友生日快到了，你能帮我送这个礼物给他么？（日常任务每10环有额外奖励哦！）','',7,0,0,201,239,0,0,0,0,0,0,'null','[]','10049024',10049024,40066,40067,0,'[]','[]',0,'[{5,36060001,2936996},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70070240,'日常任务','我的好朋友生日快到了，你能帮我送这个礼物给他么？（日常任务每10环有额外奖励哦！）','',7,0,0,240,279,0,0,0,0,0,0,'null','[]','10049024',10049024,40066,40067,0,'[]','[]',0,'[{5,36060001,4384137},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70070280,'日常任务','我的好朋友生日快到了，你能帮我送这个礼物给他么？（日常任务每10环有额外奖励哦！）','',7,0,0,280,319,0,0,0,0,0,0,'null','[]','10049024',10049024,40066,40067,0,'[]','[]',0,'[{5,36060001,4937871},{3,36030001,11250}]',0,1,1,'[]','[]','[]',1,0,0,0),(70070320,'日常任务','我的好朋友生日快到了，你能帮我送这个礼物给他么？（日常任务每10环有额外奖励哦！）','',7,0,0,320,349,0,0,0,0,0,0,'null','[]','10049024',10049024,40066,40067,0,'[]','[]',0,'[{5,36060001,5605803},{3,36030001,23000}]',0,1,1,'[]','[]','[]',1,0,0,0),(70070350,'日常任务','我的好朋友生日快到了，你能帮我送这个礼物给他么？（日常任务每10环有额外奖励哦！）','',7,0,0,350,374,0,0,0,0,0,0,'null','[]','10049024',10049024,40066,40067,0,'[]','[]',0,'[{5,36060001,6410766},{3,36030001,25163}]',0,1,1,'[]','[]','[]',1,0,0,0),(70070375,'日常任务','我的好朋友生日快到了，你能帮我送这个礼物给他么？（日常任务每10环有额外奖励哦！）','',7,0,0,375,399,0,0,0,0,0,0,'null','[]','10049024',10049024,40066,40067,0,'[]','[]',0,'[{5,36060001,10358805},{3,36030001,29944}]',0,1,1,'[]','[]','[]',1,0,0,0),(70070400,'日常任务','我的好朋友生日快到了，你能帮我送这个礼物给他么？（日常任务每10环有额外奖励哦！）','',7,0,0,400,424,0,0,0,0,0,0,'null','[]','10049024',10049024,40066,40067,0,'[]','[]',0,'[{5,36060001,15884705},{3,36030001,34781}]',0,1,1,'[]','[]','[]',1,0,0,0),(70070425,'日常任务','我的好朋友生日快到了，你能帮我送这个礼物给他么？（日常任务每10环有额外奖励哦！）','',7,0,0,425,449,0,0,0,0,0,0,'null','[]','10049024',10049024,40066,40067,0,'[]','[]',0,'[{5,36060001,18734705},{3,36030001,41038}]',0,1,1,'[]','[]','[]',1,0,0,0),(70070450,'日常任务','我的好朋友生日快到了，你能帮我送这个礼物给他么？（日常任务每10环有额外奖励哦！）','',7,0,0,450,474,0,0,0,0,0,0,'null','[]','10049024',10049024,40066,40067,0,'[]','[]',0,'[{5,36060001,25054113},{3,36030001,48956}]',0,1,1,'[]','[]','[]',1,0,0,0),(70070475,'日常任务','我的好朋友生日快到了，你能帮我送这个礼物给他么？（日常任务每10环有额外奖励哦！）','',7,0,0,475,514,0,0,0,0,0,0,'null','[]','10049024',10049024,40066,40067,0,'[]','[]',0,'[{5,36060001,29975404},{3,36030001,60219}]',0,1,1,'[]','[]','[]',1,0,0,0),(70070515,'日常任务','我的好朋友生日快到了，你能帮我送这个礼物给他么？（日常任务每10环有额外奖励哦！）','',7,0,0,515,549,0,0,0,0,0,0,'null','[]','10049024',10049024,40066,40067,0,'[]','[]',0,'[{5,36060001,34250404},{3,36030001,81819}]',0,1,1,'[]','[]','[]',1,0,0,0),(70070550,'日常任务','我的好朋友生日快到了，你能帮我送这个礼物给他么？（日常任务每10环有额外奖励哦！）','',7,0,0,550,574,0,0,0,0,0,0,'null','[]','10049024',10049024,40066,40067,0,'[]','[]',0,'[{5,36060001,55163391},{3,36030001,111163}]',0,1,1,'[]','[]','[]',1,0,0,0),(70070575,'日常任务','我的好朋友生日快到了，你能帮我送这个礼物给他么？（日常任务每10环有额外奖励哦！）','',7,0,0,575,594,0,0,0,0,0,0,'null','[]','10049024',10049024,40066,40067,0,'[]','[]',0,'[{5,36060001,63766727},{3,36030001,141144}]',0,1,1,'[]','[]','[]',1,0,0,0),(70070595,'日常任务','我的好朋友生日快到了，你能帮我送这个礼物给他么？（日常任务每10环有额外奖励哦！）','',7,0,0,595,609,0,0,0,0,0,0,'null','[]','10049024',10049024,40066,40067,0,'[]','[]',0,'[{5,36060001,69466727},{3,36030001,167081}]',0,1,1,'[]','[]','[]',1,0,0,0),(70070610,'日常任务','我的好朋友生日快到了，你能帮我送这个礼物给他么？（日常任务每10环有额外奖励哦！）','',7,0,0,610,629,0,0,0,0,0,0,'null','[]','10049024',10049024,40066,40067,0,'[]','[]',0,'[{5,36060001,75166727},{3,36030001,186725}]',0,1,1,'[]','[]','[]',1,0,0,0),(70070630,'日常任务','我的好朋友生日快到了，你能帮我送这个礼物给他么？（日常任务每10环有额外奖励哦！）','',7,0,0,630,649,0,0,0,0,0,0,'null','[]','10049024',10049024,40066,40067,0,'[]','[]',0,'[{5,36060001,80866727},{3,36030001,216913}]',0,1,1,'[]','[]','[]',1,0,0,0),(70070650,'日常任务','我的好朋友生日快到了，你能帮我送这个礼物给他么？（日常任务每10环有额外奖励哦！）','',7,0,0,650,669,0,0,0,0,0,0,'null','[]','10049024',10049024,40066,40067,0,'[]','[]',0,'[{5,36060001,86566727},{3,36030001,249600}]',0,1,1,'[]','[]','[]',1,0,0,0),(70070670,'日常任务','我的好朋友生日快到了，你能帮我送这个礼物给他么？（日常任务每10环有额外奖励哦！）','',7,0,0,670,689,0,0,0,0,0,0,'null','[]','10049024',10049024,40066,40067,0,'[]','[]',0,'[{5,36060001,92266727},{3,36030001,284788}]',0,1,1,'[]','[]','[]',1,0,0,0),(70070690,'日常任务','我的好朋友生日快到了，你能帮我送这个礼物给他么？（日常任务每10环有额外奖励哦！）','',7,0,0,690,709,0,0,0,0,0,0,'null','[]','10049024',10049024,40066,40067,0,'[]','[]',0,'[{5,36060001,97966727},{3,36030001,322475}]',0,1,1,'[]','[]','[]',1,0,0,0),(70070710,'日常任务','我的好朋友生日快到了，你能帮我送这个礼物给他么？（日常任务每10环有额外奖励哦！）','',7,0,0,710,729,0,0,0,0,0,0,'null','[]','10049024',10049024,40066,40067,0,'[]','[]',0,'[{5,36060001,103666727},{3,36030001,362663}]',0,1,1,'[]','[]','[]',1,0,0,0),(70070730,'日常任务','我的好朋友生日快到了，你能帮我送这个礼物给他么？（日常任务每10环有额外奖励哦！）','',7,0,0,730,749,0,0,0,0,0,0,'null','[]','10049024',10049024,40066,40067,0,'[]','[]',0,'[{5,36060001,109366727},{3,36030001,405350}]',0,1,1,'[]','[]','[]',1,0,0,0),(70070750,'日常任务','我的好朋友生日快到了，你能帮我送这个礼物给他么？（日常任务每10环有额外奖励哦！）','',7,0,0,750,769,0,0,0,0,0,0,'null','[]','10049024',10049024,40066,40067,0,'[]','[]',0,'[{5,36060001,115066727},{3,36030001,450538}]',0,1,1,'[]','[]','[]',1,0,0,0),(70070770,'日常任务','我的好朋友生日快到了，你能帮我送这个礼物给他么？（日常任务每10环有额外奖励哦！）','',7,0,0,770,789,0,0,0,0,0,0,'null','[]','10049024',10049024,40066,40067,0,'[]','[]',0,'[{5,36060001,120766727},{3,36030001,498225}]',0,1,1,'[]','[]','[]',1,0,0,0),(70070790,'日常任务','我的好朋友生日快到了，你能帮我送这个礼物给他么？（日常任务每10环有额外奖励哦！）','',7,0,0,790,809,0,0,0,0,0,0,'null','[]','10049024',10049024,40066,40067,0,'[]','[]',0,'[{5,36060001,126466727},{3,36030001,548413}]',0,1,1,'[]','[]','[]',1,0,0,0),(70070810,'日常任务','我的好朋友生日快到了，你能帮我送这个礼物给他么？（日常任务每10环有额外奖励哦！）','',7,0,0,810,829,0,0,0,0,0,0,'null','[]','10049024',10049024,40066,40067,0,'[]','[]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70070830,'日常任务','我的好朋友生日快到了，你能帮我送这个礼物给他么？（日常任务每10环有额外奖励哦！）','',7,0,0,830,849,0,0,0,0,0,0,'null','[]','10049024',10049024,40066,40067,0,'[]','[]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70070850,'日常任务','我的好朋友生日快到了，你能帮我送这个礼物给他么？（日常任务每10环有额外奖励哦！）','',7,0,0,850,869,0,0,0,0,0,0,'null','[]','10049024',10049024,40066,40067,0,'[]','[]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70070870,'日常任务','我的好朋友生日快到了，你能帮我送这个礼物给他么？（日常任务每10环有额外奖励哦！）','',7,0,0,870,889,0,0,0,0,0,0,'null','[]','10049024',10049024,40066,40067,0,'[]','[]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70070890,'日常任务','我的好朋友生日快到了，你能帮我送这个礼物给他么？（日常任务每10环有额外奖励哦！）','',7,0,0,890,909,0,0,0,0,0,0,'null','[]','10049024',10049024,40066,40067,0,'[]','[]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70070910,'日常任务','我的好朋友生日快到了，你能帮我送这个礼物给他么？（日常任务每10环有额外奖励哦！）','',7,0,0,910,929,0,0,0,0,0,0,'null','[]','10049024',10049024,40066,40067,0,'[]','[]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70070930,'日常任务','我的好朋友生日快到了，你能帮我送这个礼物给他么？（日常任务每10环有额外奖励哦！）','',7,0,0,930,949,0,0,0,0,0,0,'null','[]','10049024',10049024,40066,40067,0,'[]','[]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70070950,'日常任务','我的好朋友生日快到了，你能帮我送这个礼物给他么？（日常任务每10环有额外奖励哦！）','',7,0,0,950,969,0,0,0,0,0,0,'null','[]','10049024',10049024,40066,40067,0,'[]','[]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70070970,'日常任务','我的好朋友生日快到了，你能帮我送这个礼物给他么？（日常任务每10环有额外奖励哦！）','',7,0,0,970,989,0,0,0,0,0,0,'null','[]','10049024',10049024,40066,40067,0,'[]','[]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70070990,'日常任务','我的好朋友生日快到了，你能帮我送这个礼物给他么？（日常任务每10环有额外奖励哦！）','',7,0,0,990,1000,0,0,0,0,0,0,'null','[]','10049024',10049024,40066,40067,0,'[]','[]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,0,0,0),(70080056,'日常任务','偷偷告诉你，我发现了阿里巴巴的宝藏，和我一起去探索下吧！（日常任务每10环有额外奖励哦！）','',7,0,6,56,80,0,0,0,0,0,0,'null','[]','10019002',10019002,40068,40069,0,'[]','[[[\"fin_dungeon\",\"11\",\"2101\",\"1\",\"1001\",\"7427\",\"5285\",\"1\"]]]',0,'[{5,36060001,358250},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(70080081,'日常任务','偷偷告诉你，我发现了阿里巴巴的宝藏，和我一起去探索下吧！（日常任务每10环有额外奖励哦！）','',7,0,0,81,99,0,0,0,0,0,0,'null','[]','10019002',10019002,40068,40069,0,'[]','[[[\"fin_dungeon\",\"11\",\"2101\",\"1\",\"1001\",\"7427\",\"5285\",\"1\"]]]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(70080095,'日常任务','偷偷告诉你，我发现了阿里巴巴的宝藏，和我一起去探索下吧！（日常任务每10环有额外奖励哦！）','',7,0,6,100,119,0,0,0,0,0,0,'null','[]','10019002',10019002,40068,40069,0,'[]','[[[\"fin_dungeon\",\"11\",\"2101\",\"1\",\"1001\",\"7427\",\"5285\",\"1\"]]]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(70080105,'日常任务','偷偷告诉你，我发现了阿里巴巴的宝藏，和我一起去探索下吧！（日常任务每10环有额外奖励哦！）','',7,0,6,120,139,0,0,0,0,0,0,'null','[]','10019002',10019002,40068,40069,0,'[]','[[[\"fin_dungeon\",\"11\",\"2101\",\"1\",\"1001\",\"7427\",\"5285\",\"1\"]]]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(70080120,'日常任务','偷偷告诉你，我发现了阿里巴巴的宝藏，和我一起去探索下吧！（日常任务每10环有额外奖励哦！）','',7,0,6,140,159,0,0,0,0,0,0,'null','[]','10019002',10019002,40068,40069,0,'[]','[[[\"fin_dungeon\",\"11\",\"2101\",\"1\",\"1001\",\"7427\",\"5285\",\"1\"]]]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(70080155,'日常任务','偷偷告诉你，我发现了阿里巴巴的宝藏，和我一起去探索下吧！（日常任务每10环有额外奖励哦！）','',7,0,6,160,179,0,0,0,0,0,0,'null','[]','10019002',10019002,40068,40069,0,'[]','[[[\"fin_dungeon\",\"11\",\"2101\",\"1\",\"1001\",\"7427\",\"5285\",\"1\"]]]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(70080180,'日常任务','偷偷告诉你，我发现了阿里巴巴的宝藏，和我一起去探索下吧！（日常任务每10环有额外奖励哦！）','',7,0,6,180,200,0,0,0,0,0,0,'null','[]','10019002',10019002,40068,40069,0,'[]','[[[\"fin_dungeon\",\"11\",\"2101\",\"1\",\"1001\",\"7427\",\"5285\",\"1\"]]]',0,'[{5,36060001,2654846},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(70080201,'日常任务','偷偷告诉你，我发现了阿里巴巴的宝藏，和我一起去探索下吧！（日常任务每10环有额外奖励哦！）','',7,0,6,201,239,0,0,0,0,0,0,'null','[]','10019002',10019002,40068,40069,0,'[]','[[[\"fin_dungeon\",\"11\",\"2101\",\"1\",\"1001\",\"7427\",\"5285\",\"1\"]]]',0,'[{5,36060001,2936996},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(70080240,'日常任务','偷偷告诉你，我发现了阿里巴巴的宝藏，和我一起去探索下吧！（日常任务每10环有额外奖励哦！）','',7,0,6,240,279,0,0,0,0,0,0,'null','[]','10019002',10019002,40068,40069,0,'[]','[[[\"fin_dungeon\",\"11\",\"2101\",\"1\",\"1001\",\"7427\",\"5285\",\"1\"]]]',0,'[{5,36060001,4384137},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(70080280,'日常任务','偷偷告诉你，我发现了阿里巴巴的宝藏，和我一起去探索下吧！（日常任务每10环有额外奖励哦！）','',7,0,6,280,319,0,0,0,0,0,0,'null','[]','10019002',10019002,40068,40069,0,'[]','[[[\"fin_dungeon\",\"11\",\"2101\",\"1\",\"1001\",\"7427\",\"5285\",\"1\"]]]',0,'[{5,36060001,4937871},{3,36030001,11250}]',0,1,1,'[]','[]','[]',1,2102,0,0),(70080320,'日常任务','偷偷告诉你，我发现了阿里巴巴的宝藏，和我一起去探索下吧！（日常任务每10环有额外奖励哦！）','',7,0,6,320,349,0,0,0,0,0,0,'null','[]','10019002',10019002,40068,40069,0,'[]','[[[\"fin_dungeon\",\"11\",\"2101\",\"1\",\"1001\",\"7427\",\"5285\",\"1\"]]]',0,'[{5,36060001,5605803},{3,36030001,23000}]',0,1,1,'[]','[]','[]',1,2102,0,0),(70080350,'日常任务','偷偷告诉你，我发现了阿里巴巴的宝藏，和我一起去探索下吧！（日常任务每10环有额外奖励哦！）','',7,0,6,350,374,0,0,0,0,0,0,'null','[]','10019002',10019002,40068,40069,0,'[]','[[[\"fin_dungeon\",\"11\",\"2101\",\"1\",\"1001\",\"7427\",\"5285\",\"1\"]]]',0,'[{5,36060001,6410766},{3,36030001,25163}]',0,1,1,'[]','[]','[]',1,2102,0,0),(70080375,'日常任务','偷偷告诉你，我发现了阿里巴巴的宝藏，和我一起去探索下吧！（日常任务每10环有额外奖励哦！）','',7,0,6,375,399,0,0,0,0,0,0,'null','[]','10019002',10019002,40068,40069,0,'[]','[[[\"fin_dungeon\",\"11\",\"2101\",\"1\",\"1001\",\"7427\",\"5285\",\"1\"]]]',0,'[{5,36060001,10358805},{3,36030001,29944}]',0,1,1,'[]','[]','[]',1,2102,0,0),(70080400,'日常任务','偷偷告诉你，我发现了阿里巴巴的宝藏，和我一起去探索下吧！（日常任务每10环有额外奖励哦！）','',7,0,6,400,424,0,0,0,0,0,0,'null','[]','10019002',10019002,40068,40069,0,'[]','[[[\"fin_dungeon\",\"11\",\"2101\",\"1\",\"1001\",\"7427\",\"5285\",\"1\"]]]',0,'[{5,36060001,15884705},{3,36030001,34781}]',0,1,1,'[]','[]','[]',1,2102,0,0),(70080425,'日常任务','偷偷告诉你，我发现了阿里巴巴的宝藏，和我一起去探索下吧！（日常任务每10环有额外奖励哦！）','',7,0,6,425,449,0,0,0,0,0,0,'null','[]','10019002',10019002,40068,40069,0,'[]','[[[\"fin_dungeon\",\"11\",\"2101\",\"1\",\"1001\",\"7427\",\"5285\",\"1\"]]]',0,'[{5,36060001,18734705},{3,36030001,41038}]',0,1,1,'[]','[]','[]',1,2102,0,0),(70080450,'日常任务','偷偷告诉你，我发现了阿里巴巴的宝藏，和我一起去探索下吧！（日常任务每10环有额外奖励哦！）','',7,0,6,450,474,0,0,0,0,0,0,'null','[]','10019002',10019002,40068,40069,0,'[]','[[[\"fin_dungeon\",\"11\",\"2101\",\"1\",\"1001\",\"7427\",\"5285\",\"1\"]]]',0,'[{5,36060001,25054113},{3,36030001,48956}]',0,1,1,'[]','[]','[]',1,2102,0,0),(70080475,'日常任务','偷偷告诉你，我发现了阿里巴巴的宝藏，和我一起去探索下吧！（日常任务每10环有额外奖励哦！）','',7,0,6,475,514,0,0,0,0,0,0,'null','[]','10019002',10019002,40068,40069,0,'[]','[[[\"fin_dungeon\",\"11\",\"2101\",\"1\",\"1001\",\"7427\",\"5285\",\"1\"]]]',0,'[{5,36060001,29975404},{3,36030001,60219}]',0,1,1,'[]','[]','[]',1,2102,0,0),(70080515,'日常任务','偷偷告诉你，我发现了阿里巴巴的宝藏，和我一起去探索下吧！（日常任务每10环有额外奖励哦！）','',7,0,6,515,549,0,0,0,0,0,0,'null','[]','10019002',10019002,40068,40069,0,'[]','[[[\"fin_dungeon\",\"11\",\"2101\",\"1\",\"1001\",\"7427\",\"5285\",\"1\"]]]',0,'[{5,36060001,34250404},{3,36030001,81819}]',0,1,1,'[]','[]','[]',1,2102,0,0),(70080550,'日常任务','偷偷告诉你，我发现了阿里巴巴的宝藏，和我一起去探索下吧！（日常任务每10环有额外奖励哦！）','',7,0,6,550,574,0,0,0,0,0,0,'null','[]','10019002',10019002,40068,40069,0,'[]','[[[\"fin_dungeon\",\"11\",\"2101\",\"1\",\"1001\",\"7427\",\"5285\",\"1\"]]]',0,'[{5,36060001,55163391},{3,36030001,111163}]',0,1,1,'[]','[]','[]',1,2102,0,0),(70080575,'日常任务','偷偷告诉你，我发现了阿里巴巴的宝藏，和我一起去探索下吧！（日常任务每10环有额外奖励哦！）','',7,0,6,575,594,0,0,0,0,0,0,'null','[]','10019002',10019002,40068,40069,0,'[]','[[[\"fin_dungeon\",\"11\",\"2101\",\"1\",\"1001\",\"7427\",\"5285\",\"1\"]]]',0,'[{5,36060001,63766727},{3,36030001,141144}]',0,1,1,'[]','[]','[]',1,2102,0,0),(70080595,'日常任务','偷偷告诉你，我发现了阿里巴巴的宝藏，和我一起去探索下吧！（日常任务每10环有额外奖励哦！）','',7,0,6,595,609,0,0,0,0,0,0,'null','[]','10019002',10019002,40068,40069,0,'[]','[[[\"fin_dungeon\",\"11\",\"2101\",\"1\",\"1001\",\"7427\",\"5285\",\"1\"]]]',0,'[{5,36060001,69466727},{3,36030001,167081}]',0,1,1,'[]','[]','[]',1,2102,0,0),(70080610,'日常任务','偷偷告诉你，我发现了阿里巴巴的宝藏，和我一起去探索下吧！（日常任务每10环有额外奖励哦！）','',7,0,6,610,629,0,0,0,0,0,0,'null','[]','10019002',10019002,40068,40069,0,'[]','[[[\"fin_dungeon\",\"11\",\"2101\",\"1\",\"1001\",\"7427\",\"5285\",\"1\"]]]',0,'[{5,36060001,75166727},{3,36030001,186725}]',0,1,1,'[]','[]','[]',1,2102,0,0),(70080630,'日常任务','偷偷告诉你，我发现了阿里巴巴的宝藏，和我一起去探索下吧！（日常任务每10环有额外奖励哦！）','',7,0,6,630,649,0,0,0,0,0,0,'null','[]','10019002',10019002,40068,40069,0,'[]','[[[\"fin_dungeon\",\"11\",\"2101\",\"1\",\"1001\",\"7427\",\"5285\",\"1\"]]]',0,'[{5,36060001,80866727},{3,36030001,216913}]',0,1,1,'[]','[]','[]',1,2102,0,0),(70080650,'日常任务','偷偷告诉你，我发现了阿里巴巴的宝藏，和我一起去探索下吧！（日常任务每10环有额外奖励哦！）','',7,0,6,650,669,0,0,0,0,0,0,'null','[]','10019002',10019002,40068,40069,0,'[]','[[[\"fin_dungeon\",\"11\",\"2101\",\"1\",\"1001\",\"7427\",\"5285\",\"1\"]]]',0,'[{5,36060001,86566727},{3,36030001,249600}]',0,1,1,'[]','[]','[]',1,2102,0,0),(70080670,'日常任务','偷偷告诉你，我发现了阿里巴巴的宝藏，和我一起去探索下吧！（日常任务每10环有额外奖励哦！）','',7,0,6,670,689,0,0,0,0,0,0,'null','[]','10019002',10019002,40068,40069,0,'[]','[[[\"fin_dungeon\",\"11\",\"2101\",\"1\",\"1001\",\"7427\",\"5285\",\"1\"]]]',0,'[{5,36060001,92266727},{3,36030001,284788}]',0,1,1,'[]','[]','[]',1,2102,0,0),(70080690,'日常任务','偷偷告诉你，我发现了阿里巴巴的宝藏，和我一起去探索下吧！（日常任务每10环有额外奖励哦！）','',7,0,6,690,709,0,0,0,0,0,0,'null','[]','10019002',10019002,40068,40069,0,'[]','[[[\"fin_dungeon\",\"11\",\"2101\",\"1\",\"1001\",\"7427\",\"5285\",\"1\"]]]',0,'[{5,36060001,97966727},{3,36030001,322475}]',0,1,1,'[]','[]','[]',1,2102,0,0),(70080710,'日常任务','偷偷告诉你，我发现了阿里巴巴的宝藏，和我一起去探索下吧！（日常任务每10环有额外奖励哦！）','',7,0,6,710,729,0,0,0,0,0,0,'null','[]','10019002',10019002,40068,40069,0,'[]','[[[\"fin_dungeon\",\"11\",\"2101\",\"1\",\"1001\",\"7427\",\"5285\",\"1\"]]]',0,'[{5,36060001,103666727},{3,36030001,362663}]',0,1,1,'[]','[]','[]',1,2102,0,0),(70080730,'日常任务','偷偷告诉你，我发现了阿里巴巴的宝藏，和我一起去探索下吧！（日常任务每10环有额外奖励哦！）','',7,0,6,730,749,0,0,0,0,0,0,'null','[]','10019002',10019002,40068,40069,0,'[]','[[[\"fin_dungeon\",\"11\",\"2101\",\"1\",\"1001\",\"7427\",\"5285\",\"1\"]]]',0,'[{5,36060001,109366727},{3,36030001,405350}]',0,1,1,'[]','[]','[]',1,2102,0,0),(70080750,'日常任务','偷偷告诉你，我发现了阿里巴巴的宝藏，和我一起去探索下吧！（日常任务每10环有额外奖励哦！）','',7,0,6,750,769,0,0,0,0,0,0,'null','[]','10019002',10019002,40068,40069,0,'[]','[[[\"fin_dungeon\",\"11\",\"2101\",\"1\",\"1001\",\"7427\",\"5285\",\"1\"]]]',0,'[{5,36060001,115066727},{3,36030001,450538}]',0,1,1,'[]','[]','[]',1,2102,0,0),(70080770,'日常任务','偷偷告诉你，我发现了阿里巴巴的宝藏，和我一起去探索下吧！（日常任务每10环有额外奖励哦！）','',7,0,6,770,789,0,0,0,0,0,0,'null','[]','10019002',10019002,40068,40069,0,'[]','[[[\"fin_dungeon\",\"11\",\"2101\",\"1\",\"1001\",\"7427\",\"5285\",\"1\"]]]',0,'[{5,36060001,120766727},{3,36030001,498225}]',0,1,1,'[]','[]','[]',1,2102,0,0),(70080790,'日常任务','偷偷告诉你，我发现了阿里巴巴的宝藏，和我一起去探索下吧！（日常任务每10环有额外奖励哦！）','',7,0,6,790,809,0,0,0,0,0,0,'null','[]','10019002',10019002,40068,40069,0,'[]','[[[\"fin_dungeon\",\"11\",\"2101\",\"1\",\"1001\",\"7427\",\"5285\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,548413}]',0,1,1,'[]','[]','[]',1,2102,0,0),(70080810,'日常任务','偷偷告诉你，我发现了阿里巴巴的宝藏，和我一起去探索下吧！（日常任务每10环有额外奖励哦！）','',7,0,6,810,829,0,0,0,0,0,0,'null','[]','10019002',10019002,40068,40069,0,'[]','[[[\"fin_dungeon\",\"11\",\"2101\",\"1\",\"1001\",\"7427\",\"5285\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,2102,0,0),(70080830,'日常任务','偷偷告诉你，我发现了阿里巴巴的宝藏，和我一起去探索下吧！（日常任务每10环有额外奖励哦！）','',7,0,6,830,849,0,0,0,0,0,0,'null','[]','10019002',10019002,40068,40069,0,'[]','[[[\"fin_dungeon\",\"11\",\"2101\",\"1\",\"1001\",\"7427\",\"5285\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,2102,0,0),(70080850,'日常任务','偷偷告诉你，我发现了阿里巴巴的宝藏，和我一起去探索下吧！（日常任务每10环有额外奖励哦！）','',7,0,6,850,869,0,0,0,0,0,0,'null','[]','10019002',10019002,40068,40069,0,'[]','[[[\"fin_dungeon\",\"11\",\"2101\",\"1\",\"1001\",\"7427\",\"5285\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,2102,0,0),(70080870,'日常任务','偷偷告诉你，我发现了阿里巴巴的宝藏，和我一起去探索下吧！（日常任务每10环有额外奖励哦！）','',7,0,6,870,889,0,0,0,0,0,0,'null','[]','10019002',10019002,40068,40069,0,'[]','[[[\"fin_dungeon\",\"11\",\"2101\",\"1\",\"1001\",\"7427\",\"5285\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,2102,0,0),(70080890,'日常任务','偷偷告诉你，我发现了阿里巴巴的宝藏，和我一起去探索下吧！（日常任务每10环有额外奖励哦！）','',7,0,6,890,909,0,0,0,0,0,0,'null','[]','10019002',10019002,40068,40069,0,'[]','[[[\"fin_dungeon\",\"11\",\"2101\",\"1\",\"1001\",\"7427\",\"5285\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,2102,0,0),(70080910,'日常任务','偷偷告诉你，我发现了阿里巴巴的宝藏，和我一起去探索下吧！（日常任务每10环有额外奖励哦！）','',7,0,6,910,929,0,0,0,0,0,0,'null','[]','10019002',10019002,40068,40069,0,'[]','[[[\"fin_dungeon\",\"11\",\"2101\",\"1\",\"1001\",\"7427\",\"5285\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,2102,0,0),(70080930,'日常任务','偷偷告诉你，我发现了阿里巴巴的宝藏，和我一起去探索下吧！（日常任务每10环有额外奖励哦！）','',7,0,6,930,949,0,0,0,0,0,0,'null','[]','10019002',10019002,40068,40069,0,'[]','[[[\"fin_dungeon\",\"11\",\"2101\",\"1\",\"1001\",\"7427\",\"5285\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,2102,0,0),(70080950,'日常任务','偷偷告诉你，我发现了阿里巴巴的宝藏，和我一起去探索下吧！（日常任务每10环有额外奖励哦！）','',7,0,6,950,969,0,0,0,0,0,0,'null','[]','10019002',10019002,40068,40069,0,'[]','[[[\"fin_dungeon\",\"11\",\"2101\",\"1\",\"1001\",\"7427\",\"5285\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,2102,0,0),(70080970,'日常任务','偷偷告诉你，我发现了阿里巴巴的宝藏，和我一起去探索下吧！（日常任务每10环有额外奖励哦！）','',7,0,6,970,989,0,0,0,0,0,0,'null','[]','10019002',10019002,40068,40069,0,'[]','[[[\"fin_dungeon\",\"11\",\"2101\",\"1\",\"1001\",\"7427\",\"5285\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,2102,0,0),(70080990,'日常任务','偷偷告诉你，我发现了阿里巴巴的宝藏，和我一起去探索下吧！（日常任务每10环有额外奖励哦！）','',7,0,6,990,1000,0,0,0,0,0,0,'null','[]','10019002',10019002,40068,40069,0,'[]','[[[\"fin_dungeon\",\"11\",\"2101\",\"1\",\"1001\",\"7427\",\"5285\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,2102,0,0),(70090056,'日常任务','货运铁路最近被堵住了，赶快和我一起去维护修理下！（日常任务每10环有额外奖励哦！）','',7,0,6,56,80,0,0,0,0,0,0,'null','[]','10039003',10039003,40070,40071,0,'[]','[[[\"fin_dungeon\",\"11\",\"2102\",\"1\",\"1003\",\"4620\",\"4780\",\"1\"]]]',0,'[{5,36060001,358250},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,2115,0,0),(70090081,'日常任务','货运铁路最近被堵住了，赶快和我一起去维护修理下！（日常任务每10环有额外奖励哦！）','',7,0,0,81,99,0,0,0,0,0,0,'null','[]','10039003',10039003,40070,40071,0,'[]','[[[\"fin_dungeon\",\"11\",\"2102\",\"1\",\"1003\",\"4620\",\"4780\",\"1\"]]]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,2115,0,0),(70090095,'日常任务','货运铁路最近被堵住了，赶快和我一起去维护修理下！（日常任务每10环有额外奖励哦！）','',7,0,6,100,119,0,0,0,0,0,0,'null','[]','10039003',10039003,40070,40071,0,'[]','[[[\"fin_dungeon\",\"11\",\"2102\",\"1\",\"1003\",\"4620\",\"4780\",\"1\"]]]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,2115,0,0),(70090105,'日常任务','货运铁路最近被堵住了，赶快和我一起去维护修理下！（日常任务每10环有额外奖励哦！）','',7,0,6,120,139,0,0,0,0,0,0,'null','[]','10039003',10039003,40070,40071,0,'[]','[[[\"fin_dungeon\",\"11\",\"2102\",\"1\",\"1003\",\"4620\",\"4780\",\"1\"]]]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,2115,0,0),(70090120,'日常任务','货运铁路最近被堵住了，赶快和我一起去维护修理下！（日常任务每10环有额外奖励哦！）','',7,0,6,140,159,0,0,0,0,0,0,'null','[]','10039003',10039003,40070,40071,0,'[]','[[[\"fin_dungeon\",\"11\",\"2102\",\"1\",\"1003\",\"4620\",\"4780\",\"1\"]]]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,2115,0,0),(70090155,'日常任务','货运铁路最近被堵住了，赶快和我一起去维护修理下！（日常任务每10环有额外奖励哦！）','',7,0,6,160,179,0,0,0,0,0,0,'null','[]','10039003',10039003,40070,40071,0,'[]','[[[\"fin_dungeon\",\"11\",\"2102\",\"1\",\"1003\",\"4620\",\"4780\",\"1\"]]]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,2115,0,0),(70090180,'日常任务','货运铁路最近被堵住了，赶快和我一起去维护修理下！（日常任务每10环有额外奖励哦！）','',7,0,6,180,200,0,0,0,0,0,0,'null','[]','10039003',10039003,40070,40071,0,'[]','[[[\"fin_dungeon\",\"11\",\"2102\",\"1\",\"1003\",\"4620\",\"4780\",\"1\"]]]',0,'[{5,36060001,2654846},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,2115,0,0),(70090201,'日常任务','货运铁路最近被堵住了，赶快和我一起去维护修理下！（日常任务每10环有额外奖励哦！）','',7,0,6,201,239,0,0,0,0,0,0,'null','[]','10039003',10039003,40070,40071,0,'[]','[[[\"fin_dungeon\",\"11\",\"2102\",\"1\",\"1003\",\"4620\",\"4780\",\"1\"]]]',0,'[{5,36060001,2936996},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,2115,0,0),(70090240,'日常任务','货运铁路最近被堵住了，赶快和我一起去维护修理下！（日常任务每10环有额外奖励哦！）','',7,0,6,240,279,0,0,0,0,0,0,'null','[]','10039003',10039003,40070,40071,0,'[]','[[[\"fin_dungeon\",\"11\",\"2102\",\"1\",\"1003\",\"4620\",\"4780\",\"1\"]]]',0,'[{5,36060001,4384137},{3,36030001,5000}]',0,1,1,'[]','[]','[]',1,2115,0,0),(70090280,'日常任务','货运铁路最近被堵住了，赶快和我一起去维护修理下！（日常任务每10环有额外奖励哦！）','',7,0,6,280,319,0,0,0,0,0,0,'null','[]','10039003',10039003,40070,40071,0,'[]','[[[\"fin_dungeon\",\"11\",\"2102\",\"1\",\"1003\",\"4620\",\"4780\",\"1\"]]]',0,'[{5,36060001,4937871},{3,36030001,11250}]',0,1,1,'[]','[]','[]',1,2115,0,0),(70090320,'日常任务','货运铁路最近被堵住了，赶快和我一起去维护修理下！（日常任务每10环有额外奖励哦！）','',7,0,6,320,349,0,0,0,0,0,0,'null','[]','10039003',10039003,40070,40071,0,'[]','[[[\"fin_dungeon\",\"11\",\"2102\",\"1\",\"1003\",\"4620\",\"4780\",\"1\"]]]',0,'[{5,36060001,5605803},{3,36030001,23000}]',0,1,1,'[]','[]','[]',1,2115,0,0),(70090350,'日常任务','货运铁路最近被堵住了，赶快和我一起去维护修理下！（日常任务每10环有额外奖励哦！）','',7,0,6,350,374,0,0,0,0,0,0,'null','[]','10039003',10039003,40070,40071,0,'[]','[[[\"fin_dungeon\",\"11\",\"2102\",\"1\",\"1003\",\"4620\",\"4780\",\"1\"]]]',0,'[{5,36060001,6410766},{3,36030001,25163}]',0,1,1,'[]','[]','[]',1,2115,0,0),(70090375,'日常任务','货运铁路最近被堵住了，赶快和我一起去维护修理下！（日常任务每10环有额外奖励哦！）','',7,0,6,375,399,0,0,0,0,0,0,'null','[]','10039003',10039003,40070,40071,0,'[]','[[[\"fin_dungeon\",\"11\",\"2102\",\"1\",\"1003\",\"4620\",\"4780\",\"1\"]]]',0,'[{5,36060001,10358805},{3,36030001,29944}]',0,1,1,'[]','[]','[]',1,2115,0,0),(70090400,'日常任务','货运铁路最近被堵住了，赶快和我一起去维护修理下！（日常任务每10环有额外奖励哦！）','',7,0,6,400,424,0,0,0,0,0,0,'null','[]','10039003',10039003,40070,40071,0,'[]','[[[\"fin_dungeon\",\"11\",\"2102\",\"1\",\"1003\",\"4620\",\"4780\",\"1\"]]]',0,'[{5,36060001,15884705},{3,36030001,34781}]',0,1,1,'[]','[]','[]',1,2115,0,0),(70090425,'日常任务','货运铁路最近被堵住了，赶快和我一起去维护修理下！（日常任务每10环有额外奖励哦！）','',7,0,6,425,449,0,0,0,0,0,0,'null','[]','10039003',10039003,40070,40071,0,'[]','[[[\"fin_dungeon\",\"11\",\"2102\",\"1\",\"1003\",\"4620\",\"4780\",\"1\"]]]',0,'[{5,36060001,18734705},{3,36030001,41038}]',0,1,1,'[]','[]','[]',1,2115,0,0),(70090450,'日常任务','货运铁路最近被堵住了，赶快和我一起去维护修理下！（日常任务每10环有额外奖励哦！）','',7,0,6,450,474,0,0,0,0,0,0,'null','[]','10039003',10039003,40070,40071,0,'[]','[[[\"fin_dungeon\",\"11\",\"2102\",\"1\",\"1003\",\"4620\",\"4780\",\"1\"]]]',0,'[{5,36060001,25054113},{3,36030001,48956}]',0,1,1,'[]','[]','[]',1,2115,0,0),(70090475,'日常任务','货运铁路最近被堵住了，赶快和我一起去维护修理下！（日常任务每10环有额外奖励哦！）','',7,0,6,475,514,0,0,0,0,0,0,'null','[]','10039003',10039003,40070,40071,0,'[]','[[[\"fin_dungeon\",\"11\",\"2102\",\"1\",\"1003\",\"4620\",\"4780\",\"1\"]]]',0,'[{5,36060001,29975404},{3,36030001,60219}]',0,1,1,'[]','[]','[]',1,2115,0,0),(70090515,'日常任务','货运铁路最近被堵住了，赶快和我一起去维护修理下！（日常任务每10环有额外奖励哦！）','',7,0,6,515,549,0,0,0,0,0,0,'null','[]','10039003',10039003,40070,40071,0,'[]','[[[\"fin_dungeon\",\"11\",\"2102\",\"1\",\"1003\",\"4620\",\"4780\",\"1\"]]]',0,'[{5,36060001,34250404},{3,36030001,81819}]',0,1,1,'[]','[]','[]',1,2115,0,0),(70090550,'日常任务','货运铁路最近被堵住了，赶快和我一起去维护修理下！（日常任务每10环有额外奖励哦！）','',7,0,6,550,574,0,0,0,0,0,0,'null','[]','10039003',10039003,40070,40071,0,'[]','[[[\"fin_dungeon\",\"11\",\"2102\",\"1\",\"1003\",\"4620\",\"4780\",\"1\"]]]',0,'[{5,36060001,55163391},{3,36030001,111163}]',0,1,1,'[]','[]','[]',1,2115,0,0),(70090575,'日常任务','货运铁路最近被堵住了，赶快和我一起去维护修理下！（日常任务每10环有额外奖励哦！）','',7,0,6,575,594,0,0,0,0,0,0,'null','[]','10039003',10039003,40070,40071,0,'[]','[[[\"fin_dungeon\",\"11\",\"2102\",\"1\",\"1003\",\"4620\",\"4780\",\"1\"]]]',0,'[{5,36060001,63766727},{3,36030001,141144}]',0,1,1,'[]','[]','[]',1,2115,0,0),(70090595,'日常任务','货运铁路最近被堵住了，赶快和我一起去维护修理下！（日常任务每10环有额外奖励哦！）','',7,0,6,595,609,0,0,0,0,0,0,'null','[]','10039003',10039003,40070,40071,0,'[]','[[[\"fin_dungeon\",\"11\",\"2102\",\"1\",\"1003\",\"4620\",\"4780\",\"1\"]]]',0,'[{5,36060001,69466727},{3,36030001,167081}]',0,1,1,'[]','[]','[]',1,2115,0,0),(70090610,'日常任务','货运铁路最近被堵住了，赶快和我一起去维护修理下！（日常任务每10环有额外奖励哦！）','',7,0,6,610,629,0,0,0,0,0,0,'null','[]','10039003',10039003,40070,40071,0,'[]','[[[\"fin_dungeon\",\"11\",\"2102\",\"1\",\"1003\",\"4620\",\"4780\",\"1\"]]]',0,'[{5,36060001,75166727},{3,36030001,186725}]',0,1,1,'[]','[]','[]',1,2115,0,0),(70090630,'日常任务','货运铁路最近被堵住了，赶快和我一起去维护修理下！（日常任务每10环有额外奖励哦！）','',7,0,6,630,649,0,0,0,0,0,0,'null','[]','10039003',10039003,40070,40071,0,'[]','[[[\"fin_dungeon\",\"11\",\"2102\",\"1\",\"1003\",\"4620\",\"4780\",\"1\"]]]',0,'[{5,36060001,80866727},{3,36030001,216913}]',0,1,1,'[]','[]','[]',1,2115,0,0),(70090650,'日常任务','货运铁路最近被堵住了，赶快和我一起去维护修理下！（日常任务每10环有额外奖励哦！）','',7,0,6,650,669,0,0,0,0,0,0,'null','[]','10039003',10039003,40070,40071,0,'[]','[[[\"fin_dungeon\",\"11\",\"2102\",\"1\",\"1003\",\"4620\",\"4780\",\"1\"]]]',0,'[{5,36060001,86566727},{3,36030001,249600}]',0,1,1,'[]','[]','[]',1,2115,0,0),(70090670,'日常任务','货运铁路最近被堵住了，赶快和我一起去维护修理下！（日常任务每10环有额外奖励哦！）','',7,0,6,670,689,0,0,0,0,0,0,'null','[]','10039003',10039003,40070,40071,0,'[]','[[[\"fin_dungeon\",\"11\",\"2102\",\"1\",\"1003\",\"4620\",\"4780\",\"1\"]]]',0,'[{5,36060001,92266727},{3,36030001,284788}]',0,1,1,'[]','[]','[]',1,2115,0,0),(70090690,'日常任务','货运铁路最近被堵住了，赶快和我一起去维护修理下！（日常任务每10环有额外奖励哦！）','',7,0,6,690,709,0,0,0,0,0,0,'null','[]','10039003',10039003,40070,40071,0,'[]','[[[\"fin_dungeon\",\"11\",\"2102\",\"1\",\"1003\",\"4620\",\"4780\",\"1\"]]]',0,'[{5,36060001,97966727},{3,36030001,322475}]',0,1,1,'[]','[]','[]',1,2115,0,0),(70090710,'日常任务','货运铁路最近被堵住了，赶快和我一起去维护修理下！（日常任务每10环有额外奖励哦！）','',7,0,6,710,729,0,0,0,0,0,0,'null','[]','10039003',10039003,40070,40071,0,'[]','[[[\"fin_dungeon\",\"11\",\"2102\",\"1\",\"1003\",\"4620\",\"4780\",\"1\"]]]',0,'[{5,36060001,103666727},{3,36030001,362663}]',0,1,1,'[]','[]','[]',1,2115,0,0),(70090730,'日常任务','货运铁路最近被堵住了，赶快和我一起去维护修理下！（日常任务每10环有额外奖励哦！）','',7,0,6,730,749,0,0,0,0,0,0,'null','[]','10039003',10039003,40070,40071,0,'[]','[[[\"fin_dungeon\",\"11\",\"2102\",\"1\",\"1003\",\"4620\",\"4780\",\"1\"]]]',0,'[{5,36060001,109366727},{3,36030001,405350}]',0,1,1,'[]','[]','[]',1,2115,0,0),(70090750,'日常任务','货运铁路最近被堵住了，赶快和我一起去维护修理下！（日常任务每10环有额外奖励哦！）','',7,0,6,750,769,0,0,0,0,0,0,'null','[]','10039003',10039003,40070,40071,0,'[]','[[[\"fin_dungeon\",\"11\",\"2102\",\"1\",\"1003\",\"4620\",\"4780\",\"1\"]]]',0,'[{5,36060001,115066727},{3,36030001,450538}]',0,1,1,'[]','[]','[]',1,2115,0,0),(70090770,'日常任务','货运铁路最近被堵住了，赶快和我一起去维护修理下！（日常任务每10环有额外奖励哦！）','',7,0,6,770,789,0,0,0,0,0,0,'null','[]','10039003',10039003,40070,40071,0,'[]','[[[\"fin_dungeon\",\"11\",\"2102\",\"1\",\"1003\",\"4620\",\"4780\",\"1\"]]]',0,'[{5,36060001,120766727},{3,36030001,498225}]',0,1,1,'[]','[]','[]',1,2115,0,0),(70090790,'日常任务','货运铁路最近被堵住了，赶快和我一起去维护修理下！（日常任务每10环有额外奖励哦！）','',7,0,6,790,809,0,0,0,0,0,0,'null','[]','10039003',10039003,40070,40071,0,'[]','[[[\"fin_dungeon\",\"11\",\"2102\",\"1\",\"1003\",\"4620\",\"4780\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,548413}]',0,1,1,'[]','[]','[]',1,2115,0,0),(70090810,'日常任务','货运铁路最近被堵住了，赶快和我一起去维护修理下！（日常任务每10环有额外奖励哦！）','',7,0,6,810,829,0,0,0,0,0,0,'null','[]','10039003',10039003,40070,40071,0,'[]','[[[\"fin_dungeon\",\"11\",\"2102\",\"1\",\"1003\",\"4620\",\"4780\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,2115,0,0),(70090830,'日常任务','货运铁路最近被堵住了，赶快和我一起去维护修理下！（日常任务每10环有额外奖励哦！）','',7,0,6,830,849,0,0,0,0,0,0,'null','[]','10039003',10039003,40070,40071,0,'[]','[[[\"fin_dungeon\",\"11\",\"2102\",\"1\",\"1003\",\"4620\",\"4780\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,2115,0,0),(70090850,'日常任务','货运铁路最近被堵住了，赶快和我一起去维护修理下！（日常任务每10环有额外奖励哦！）','',7,0,6,850,869,0,0,0,0,0,0,'null','[]','10039003',10039003,40070,40071,0,'[]','[[[\"fin_dungeon\",\"11\",\"2102\",\"1\",\"1003\",\"4620\",\"4780\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,2115,0,0),(70090870,'日常任务','货运铁路最近被堵住了，赶快和我一起去维护修理下！（日常任务每10环有额外奖励哦！）','',7,0,6,870,889,0,0,0,0,0,0,'null','[]','10039003',10039003,40070,40071,0,'[]','[[[\"fin_dungeon\",\"11\",\"2102\",\"1\",\"1003\",\"4620\",\"4780\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,2115,0,0),(70090890,'日常任务','货运铁路最近被堵住了，赶快和我一起去维护修理下！（日常任务每10环有额外奖励哦！）','',7,0,6,890,909,0,0,0,0,0,0,'null','[]','10039003',10039003,40070,40071,0,'[]','[[[\"fin_dungeon\",\"11\",\"2102\",\"1\",\"1003\",\"4620\",\"4780\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,2115,0,0),(70090910,'日常任务','货运铁路最近被堵住了，赶快和我一起去维护修理下！（日常任务每10环有额外奖励哦！）','',7,0,6,910,929,0,0,0,0,0,0,'null','[]','10039003',10039003,40070,40071,0,'[]','[[[\"fin_dungeon\",\"11\",\"2102\",\"1\",\"1003\",\"4620\",\"4780\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,2115,0,0),(70090930,'日常任务','货运铁路最近被堵住了，赶快和我一起去维护修理下！（日常任务每10环有额外奖励哦！）','',7,0,6,930,949,0,0,0,0,0,0,'null','[]','10039003',10039003,40070,40071,0,'[]','[[[\"fin_dungeon\",\"11\",\"2102\",\"1\",\"1003\",\"4620\",\"4780\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,2115,0,0),(70090950,'日常任务','货运铁路最近被堵住了，赶快和我一起去维护修理下！（日常任务每10环有额外奖励哦！）','',7,0,6,950,969,0,0,0,0,0,0,'null','[]','10039003',10039003,40070,40071,0,'[]','[[[\"fin_dungeon\",\"11\",\"2102\",\"1\",\"1003\",\"4620\",\"4780\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,2115,0,0),(70090970,'日常任务','货运铁路最近被堵住了，赶快和我一起去维护修理下！（日常任务每10环有额外奖励哦！）','',7,0,6,970,989,0,0,0,0,0,0,'null','[]','10039003',10039003,40070,40071,0,'[]','[[[\"fin_dungeon\",\"11\",\"2102\",\"1\",\"1003\",\"4620\",\"4780\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,2115,0,0),(70090990,'日常任务','货运铁路最近被堵住了，赶快和我一起去维护修理下！（日常任务每10环有额外奖励哦！）','',7,0,6,990,1000,0,0,0,0,0,0,'null','[]','10039003',10039003,40070,40071,0,'[]','[[[\"fin_dungeon\",\"11\",\"2102\",\"1\",\"1003\",\"4620\",\"4780\",\"1\"]]]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',1,2115,0,0),(70100056,'日常任务','每天凌晨4点，作为货商的我们就开始送货了，辛苦点但值得！（日常任务每10环有额外奖励哦！）','',7,0,3,56,80,0,0,0,0,0,0,'null','[]','10019002',10019002,40072,40073,0,'[]','[]',0,'[{5,36060001,358250},{3,36030001,5000}]',0,1,1,'[]','[]','[]',0,0,0,0),(70100081,'日常任务','每天凌晨4点，作为货商的我们就开始送货了，辛苦点但值得！（日常任务每10环有额外奖励哦！）','',7,0,0,81,99,0,0,0,0,0,0,'null','[]','10019002',10019002,40072,40073,0,'[]','[]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',0,0,0,0),(70100095,'日常任务','每天凌晨4点，作为货商的我们就开始送货了，辛苦点但值得！（日常任务每10环有额外奖励哦！）','',7,0,3,100,119,0,0,0,0,0,0,'null','[]','10019002',10019002,40072,40073,0,'[]','[]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',0,0,0,0),(70100105,'日常任务','每天凌晨4点，作为货商的我们就开始送货了，辛苦点但值得！（日常任务每10环有额外奖励哦！）','',7,0,3,120,139,0,0,0,0,0,0,'null','[]','10019002',10019002,40072,40073,0,'[]','[]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',0,0,0,0),(70100120,'日常任务','每天凌晨4点，作为货商的我们就开始送货了，辛苦点但值得！（日常任务每10环有额外奖励哦！）','',7,0,3,140,159,0,0,0,0,0,0,'null','[]','10019002',10019002,40072,40073,0,'[]','[]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',0,0,0,0),(70100155,'日常任务','每天凌晨4点，作为货商的我们就开始送货了，辛苦点但值得！（日常任务每10环有额外奖励哦！）','',7,0,3,160,179,0,0,0,0,0,0,'null','[]','10019002',10019002,40072,40073,0,'[]','[]',0,'[{5,36060001,2920118},{3,36030001,5000}]',0,1,1,'[]','[]','[]',0,0,0,0),(70100180,'日常任务','每天凌晨4点，作为货商的我们就开始送货了，辛苦点但值得！（日常任务每10环有额外奖励哦！）','',7,0,3,180,200,0,0,0,0,0,0,'null','[]','10019002',10019002,40072,40073,0,'[]','[]',0,'[{5,36060001,2654846},{3,36030001,5000}]',0,1,1,'[]','[]','[]',0,0,0,0),(70100201,'日常任务','每天凌晨4点，作为货商的我们就开始送货了，辛苦点但值得！（日常任务每10环有额外奖励哦！）','',7,0,3,201,239,0,0,0,0,0,0,'null','[]','10019002',10019002,40072,40073,0,'[]','[]',0,'[{5,36060001,2936996},{3,36030001,5000}]',0,1,1,'[]','[]','[]',0,0,0,0),(70100240,'日常任务','每天凌晨4点，作为货商的我们就开始送货了，辛苦点但值得！（日常任务每10环有额外奖励哦！）','',7,0,3,240,279,0,0,0,0,0,0,'null','[]','10019002',10019002,40072,40073,0,'[]','[]',0,'[{5,36060001,4384137},{3,36030001,5000}]',0,1,1,'[]','[]','[]',0,0,0,0),(70100280,'日常任务','每天凌晨4点，作为货商的我们就开始送货了，辛苦点但值得！（日常任务每10环有额外奖励哦！）','',7,0,3,280,319,0,0,0,0,0,0,'null','[]','10019002',10019002,40072,40073,0,'[]','[]',0,'[{5,36060001,4937871},{3,36030001,11250}]',0,1,1,'[]','[]','[]',0,0,0,0),(70100320,'日常任务','每天凌晨4点，作为货商的我们就开始送货了，辛苦点但值得！（日常任务每10环有额外奖励哦！）','',7,0,3,320,349,0,0,0,0,0,0,'null','[]','10019002',10019002,40072,40073,0,'[]','[]',0,'[{5,36060001,5605803},{3,36030001,23000}]',0,1,1,'[]','[]','[]',0,0,0,0),(70100350,'日常任务','每天凌晨4点，作为货商的我们就开始送货了，辛苦点但值得！（日常任务每10环有额外奖励哦！）','',7,0,3,350,374,0,0,0,0,0,0,'null','[]','10019002',10019002,40072,40073,0,'[]','[]',0,'[{5,36060001,6410766},{3,36030001,25163}]',0,1,1,'[]','[]','[]',0,0,0,0),(70100375,'日常任务','每天凌晨4点，作为货商的我们就开始送货了，辛苦点但值得！（日常任务每10环有额外奖励哦！）','',7,0,3,375,399,0,0,0,0,0,0,'null','[]','10019002',10019002,40072,40073,0,'[]','[]',0,'[{5,36060001,10358805},{3,36030001,29944}]',0,1,1,'[]','[]','[]',0,0,0,0),(70100400,'日常任务','每天凌晨4点，作为货商的我们就开始送货了，辛苦点但值得！（日常任务每10环有额外奖励哦！）','',7,0,3,400,424,0,0,0,0,0,0,'null','[]','10019002',10019002,40072,40073,0,'[]','[]',0,'[{5,36060001,15884705},{3,36030001,34781}]',0,1,1,'[]','[]','[]',0,0,0,0),(70100425,'日常任务','每天凌晨4点，作为货商的我们就开始送货了，辛苦点但值得！（日常任务每10环有额外奖励哦！）','',7,0,3,425,449,0,0,0,0,0,0,'null','[]','10019002',10019002,40072,40073,0,'[]','[]',0,'[{5,36060001,18734705},{3,36030001,41038}]',0,1,1,'[]','[]','[]',0,0,0,0),(70100450,'日常任务','每天凌晨4点，作为货商的我们就开始送货了，辛苦点但值得！（日常任务每10环有额外奖励哦！）','',7,0,3,450,474,0,0,0,0,0,0,'null','[]','10019002',10019002,40072,40073,0,'[]','[]',0,'[{5,36060001,25054113},{3,36030001,48956}]',0,1,1,'[]','[]','[]',0,0,0,0),(70100475,'日常任务','每天凌晨4点，作为货商的我们就开始送货了，辛苦点但值得！（日常任务每10环有额外奖励哦！）','',7,0,3,475,514,0,0,0,0,0,0,'null','[]','10019002',10019002,40072,40073,0,'[]','[]',0,'[{5,36060001,29975404},{3,36030001,60219}]',0,1,1,'[]','[]','[]',0,0,0,0),(70100515,'日常任务','每天凌晨4点，作为货商的我们就开始送货了，辛苦点但值得！（日常任务每10环有额外奖励哦！）','',7,0,3,515,549,0,0,0,0,0,0,'null','[]','10019002',10019002,40072,40073,0,'[]','[]',0,'[{5,36060001,34250404},{3,36030001,81819}]',0,1,1,'[]','[]','[]',0,0,0,0),(70100550,'日常任务','每天凌晨4点，作为货商的我们就开始送货了，辛苦点但值得！（日常任务每10环有额外奖励哦！）','',7,0,3,550,574,0,0,0,0,0,0,'null','[]','10019002',10019002,40072,40073,0,'[]','[]',0,'[{5,36060001,55163391},{3,36030001,111163}]',0,1,1,'[]','[]','[]',0,0,0,0),(70100575,'日常任务','每天凌晨4点，作为货商的我们就开始送货了，辛苦点但值得！（日常任务每10环有额外奖励哦！）','',7,0,3,575,594,0,0,0,0,0,0,'null','[]','10019002',10019002,40072,40073,0,'[]','[]',0,'[{5,36060001,63766727},{3,36030001,141144}]',0,1,1,'[]','[]','[]',0,0,0,0),(70100595,'日常任务','每天凌晨4点，作为货商的我们就开始送货了，辛苦点但值得！（日常任务每10环有额外奖励哦！）','',7,0,3,595,609,0,0,0,0,0,0,'null','[]','10019002',10019002,40072,40073,0,'[]','[]',0,'[{5,36060001,69466727},{3,36030001,167081}]',0,1,1,'[]','[]','[]',0,0,0,0),(70100610,'日常任务','每天凌晨4点，作为货商的我们就开始送货了，辛苦点但值得！（日常任务每10环有额外奖励哦！）','',7,0,3,610,629,0,0,0,0,0,0,'null','[]','10019002',10019002,40072,40073,0,'[]','[]',0,'[{5,36060001,75166727},{3,36030001,186725}]',0,1,1,'[]','[]','[]',0,0,0,0),(70100630,'日常任务','每天凌晨4点，作为货商的我们就开始送货了，辛苦点但值得！（日常任务每10环有额外奖励哦！）','',7,0,3,630,649,0,0,0,0,0,0,'null','[]','10019002',10019002,40072,40073,0,'[]','[]',0,'[{5,36060001,80866727},{3,36030001,216913}]',0,1,1,'[]','[]','[]',0,0,0,0),(70100650,'日常任务','每天凌晨4点，作为货商的我们就开始送货了，辛苦点但值得！（日常任务每10环有额外奖励哦！）','',7,0,3,650,669,0,0,0,0,0,0,'null','[]','10019002',10019002,40072,40073,0,'[]','[]',0,'[{5,36060001,86566727},{3,36030001,249600}]',0,1,1,'[]','[]','[]',0,0,0,0),(70100670,'日常任务','每天凌晨4点，作为货商的我们就开始送货了，辛苦点但值得！（日常任务每10环有额外奖励哦！）','',7,0,3,670,689,0,0,0,0,0,0,'null','[]','10019002',10019002,40072,40073,0,'[]','[]',0,'[{5,36060001,92266727},{3,36030001,284788}]',0,1,1,'[]','[]','[]',0,0,0,0),(70100690,'日常任务','每天凌晨4点，作为货商的我们就开始送货了，辛苦点但值得！（日常任务每10环有额外奖励哦！）','',7,0,3,690,709,0,0,0,0,0,0,'null','[]','10019002',10019002,40072,40073,0,'[]','[]',0,'[{5,36060001,97966727},{3,36030001,322475}]',0,1,1,'[]','[]','[]',0,0,0,0),(70100710,'日常任务','每天凌晨4点，作为货商的我们就开始送货了，辛苦点但值得！（日常任务每10环有额外奖励哦！）','',7,0,3,710,729,0,0,0,0,0,0,'null','[]','10019002',10019002,40072,40073,0,'[]','[]',0,'[{5,36060001,103666727},{3,36030001,362663}]',0,1,1,'[]','[]','[]',0,0,0,0),(70100730,'日常任务','每天凌晨4点，作为货商的我们就开始送货了，辛苦点但值得！（日常任务每10环有额外奖励哦！）','',7,0,3,730,749,0,0,0,0,0,0,'null','[]','10019002',10019002,40072,40073,0,'[]','[]',0,'[{5,36060001,109366727},{3,36030001,405350}]',0,1,1,'[]','[]','[]',0,0,0,0),(70100750,'日常任务','每天凌晨4点，作为货商的我们就开始送货了，辛苦点但值得！（日常任务每10环有额外奖励哦！）','',7,0,3,750,769,0,0,0,0,0,0,'null','[]','10019002',10019002,40072,40073,0,'[]','[]',0,'[{5,36060001,115066727},{3,36030001,450538}]',0,1,1,'[]','[]','[]',0,0,0,0),(70100770,'日常任务','每天凌晨4点，作为货商的我们就开始送货了，辛苦点但值得！（日常任务每10环有额外奖励哦！）','',7,0,3,770,789,0,0,0,0,0,0,'null','[]','10019002',10019002,40072,40073,0,'[]','[]',0,'[{5,36060001,120766727},{3,36030001,498225}]',0,1,1,'[]','[]','[]',0,0,0,0),(70100790,'日常任务','每天凌晨4点，作为货商的我们就开始送货了，辛苦点但值得！（日常任务每10环有额外奖励哦！）','',7,0,3,790,809,0,0,0,0,0,0,'null','[]','10019002',10019002,40072,40073,0,'[]','[]',0,'[{5,36060001,126466727},{3,36030001,548413}]',0,1,1,'[]','[]','[]',0,0,0,0),(70100810,'日常任务','每天凌晨4点，作为货商的我们就开始送货了，辛苦点但值得！（日常任务每10环有额外奖励哦！）','',7,0,3,810,829,0,0,0,0,0,0,'null','[]','10019002',10019002,40072,40073,0,'[]','[]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',0,0,0,0),(70100830,'日常任务','每天凌晨4点，作为货商的我们就开始送货了，辛苦点但值得！（日常任务每10环有额外奖励哦！）','',7,0,3,830,849,0,0,0,0,0,0,'null','[]','10019002',10019002,40072,40073,0,'[]','[]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',0,0,0,0),(70100850,'日常任务','每天凌晨4点，作为货商的我们就开始送货了，辛苦点但值得！（日常任务每10环有额外奖励哦！）','',7,0,3,850,869,0,0,0,0,0,0,'null','[]','10019002',10019002,40072,40073,0,'[]','[]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',0,0,0,0),(70100870,'日常任务','每天凌晨4点，作为货商的我们就开始送货了，辛苦点但值得！（日常任务每10环有额外奖励哦！）','',7,0,3,870,889,0,0,0,0,0,0,'null','[]','10019002',10019002,40072,40073,0,'[]','[]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',0,0,0,0),(70100890,'日常任务','每天凌晨4点，作为货商的我们就开始送货了，辛苦点但值得！（日常任务每10环有额外奖励哦！）','',7,0,3,890,909,0,0,0,0,0,0,'null','[]','10019002',10019002,40072,40073,0,'[]','[]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',0,0,0,0),(70100910,'日常任务','每天凌晨4点，作为货商的我们就开始送货了，辛苦点但值得！（日常任务每10环有额外奖励哦！）','',7,0,3,910,929,0,0,0,0,0,0,'null','[]','10019002',10019002,40072,40073,0,'[]','[]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',0,0,0,0),(70100930,'日常任务','每天凌晨4点，作为货商的我们就开始送货了，辛苦点但值得！（日常任务每10环有额外奖励哦！）','',7,0,3,930,949,0,0,0,0,0,0,'null','[]','10019002',10019002,40072,40073,0,'[]','[]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',0,0,0,0),(70100950,'日常任务','每天凌晨4点，作为货商的我们就开始送货了，辛苦点但值得！（日常任务每10环有额外奖励哦！）','',7,0,3,950,969,0,0,0,0,0,0,'null','[]','10019002',10019002,40072,40073,0,'[]','[]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',0,0,0,0),(70100970,'日常任务','每天凌晨4点，作为货商的我们就开始送货了，辛苦点但值得！（日常任务每10环有额外奖励哦！）','',7,0,3,970,989,0,0,0,0,0,0,'null','[]','10019002',10019002,40072,40073,0,'[]','[]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',0,0,0,0),(70100990,'日常任务','每天凌晨4点，作为货商的我们就开始送货了，辛苦点但值得！（日常任务每10环有额外奖励哦！）','',7,0,3,990,1000,0,0,0,0,0,0,'null','[]','10019002',10019002,40072,40073,0,'[]','[]',0,'[{5,36060001,126466727},{3,36030001,566569}]',0,1,1,'[]','[]','[]',0,0,0,0);
/*!40000 ALTER TABLE `base_task` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_task_exp_module`
--

DROP TABLE IF EXISTS `base_task_exp_module`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_task_exp_module` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能序号id',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '功能名称',
  `icon` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '资源id',
  `jump_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '跳转id',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_task_exp_module`
--

LOCK TABLES `base_task_exp_module` WRITE;
/*!40000 ALTER TABLE `base_task_exp_module` DISABLE KEYS */;
/*!40000 ALTER TABLE `base_task_exp_module` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_task_exp_module_lv`
--

DROP TABLE IF EXISTS `base_task_exp_module_lv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_task_exp_module_lv` (
  `module_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能排序id',
  `min_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家最小等级',
  `max_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家最大等级',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '可得经验值',
  PRIMARY KEY (`module_id`,`min_lv`,`max_lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_task_exp_module_lv`
--

LOCK TABLES `base_task_exp_module_lv` WRITE;
/*!40000 ALTER TABLE `base_task_exp_module_lv` DISABLE KEYS */;
INSERT INTO `base_task_exp_module_lv` VALUES (1,1,190,109733645),(1,191,200,121395845),(1,201,210,133647045),(1,211,220,146487245),(1,221,230,154439062),(1,231,240,181210989),(1,241,250,188514589),(1,251,260,196112689),(1,261,270,205422021),(1,271,280,204098651),(1,281,290,215128929),(1,291,300,219516979),(1,301,310,217782500),(1,311,320,231706522),(1,321,330,245659932),(1,331,340,246665328),(1,341,350,264978324),(1,351,360,282580663),(1,361,370,428163952),(1,371,380,538767796),(1,381,390,597667796),(1,391,400,656567796),(1,401,410,715467796),(1,411,420,774367796),(1,421,430,833267796),(1,431,440,887792097),(1,441,450,1035570012),(1,451,460,1135067930),(1,461,470,1238983347),(1,471,480,1283158347),(1,481,490,1327333347),(1,491,500,1371508347),(1,501,510,1415683347),(1,511,520,1574596639),(1,521,530,1687401398),(1,531,540,2054062258),(1,541,550,2280086828),(1,551,560,2517891398),(1,561,570,2635691398),(1,571,580,2753491398),(1,581,590,2871291398),(1,591,600,2989091398),(1,601,610,3106891398),(1,611,620,3224691398),(1,621,630,3342491398),(1,631,640,3460291398),(1,641,650,3578091398),(1,651,660,3695891398),(1,661,670,3813691398),(1,671,680,3931491398),(1,681,690,4049291398),(1,691,700,4167091398),(1,701,710,4284891398),(1,711,720,4294967295),(1,721,730,4294967295),(1,731,740,4294967295),(1,741,750,4294967295),(1,751,760,4294967295),(1,761,770,4294967295),(1,771,780,4294967295),(1,781,790,4294967295),(2,1,55,358250),(2,56,80,2495250),(2,81,99,2495250),(2,100,119,2495250),(2,120,139,2495250),(2,140,159,2495250),(2,160,179,2495250),(2,180,200,2654846),(2,201,239,2936996),(2,240,279,4384137),(2,280,319,4937871),(2,320,349,5605803),(2,350,374,6410766),(2,375,399,10358805),(2,400,424,15884705),(2,425,449,18734705),(2,450,474,25054113),(2,475,514,29975404),(2,515,549,34250404),(2,550,574,55163391),(2,575,594,63766727),(2,595,609,69466727),(2,610,629,75166727),(2,630,649,80866727),(2,650,669,86566727),(2,670,689,92266727),(2,690,709,97966727),(2,710,729,103666727),(2,730,749,109366727),(2,750,769,115066727),(2,770,789,120766727),(2,790,809,126466727),(2,810,829,126466727),(2,830,849,126466727),(2,850,869,126466727),(2,870,889,126466727),(2,890,909,126466727),(2,910,929,126466727),(2,930,949,126466727),(2,950,969,126466727),(2,970,989,126466727),(2,990,1000,126466727),(3,1,199,2748409),(3,200,239,5339994),(3,240,279,7306895),(3,280,319,8229784),(3,320,349,9343005),(3,350,374,9862717),(3,375,399,15936624),(3,400,424,22692436),(3,425,449,26763864),(3,450,474,33405484),(3,475,514,39967205),(3,515,549,42813004),(3,550,574,68954239),(3,575,594,75019679),(3,595,609,81725562),(3,610,629,83518586),(3,630,649,89851919),(3,650,669,91122871),(3,670,689,97122871),(3,690,709,97966728),(3,710,729,103666728),(3,730,749,109366728),(3,750,769,115066728),(3,770,789,120766728),(3,790,809,126466728),(3,810,829,126466728),(3,830,849,126466728),(3,850,869,126466728),(3,870,889,126466728),(3,890,909,126466728),(3,910,929,126466728),(3,930,949,126466728),(3,950,969,126466728),(3,970,989,126466728),(3,990,1000,126466728),(4,1,190,35397950),(4,191,200,39159950),(4,201,210,43111950),(4,211,220,47253950),(4,221,230,49819052),(4,231,240,58455158),(4,241,250,60811158),(4,251,260,63262158),(4,261,270,66265168),(4,271,280,65838275),(4,281,290,69396429),(4,291,300,70811929),(4,301,310,70252419),(4,311,320,74744039),(4,321,330,79245139),(4,331,340,79569461),(4,341,350,85476879),(4,351,360,91155053),(4,361,370,138117404),(4,371,380,173796063),(4,381,390,192796063),(4,391,400,211796063),(4,401,410,230796063),(4,411,420,249796063),(4,421,430,268796063),(4,431,440,286384547),(4,441,450,334054843),(4,451,460,366150945),(4,461,470,399672047),(4,471,480,413922047),(4,481,490,428172047),(4,491,500,442422047),(4,501,510,456672047),(4,511,520,507934400),(4,521,530,544323032),(4,531,540,662600728),(4,541,550,735511880),(4,551,560,812223032),(4,561,570,850223032),(4,571,580,888223032),(4,581,590,926223032),(4,591,600,964223032),(4,601,610,1002223032),(4,611,620,1040223032),(4,621,630,1078223032),(4,631,640,1116223032),(4,641,650,1154223032),(4,651,660,1192223032),(4,661,670,1230223032),(4,671,680,1268223032),(4,681,690,1306223032),(4,691,700,1344223032),(4,701,710,1382223032),(4,711,720,1420223032),(4,721,730,1458223032),(4,731,740,1496223032),(4,741,750,1534223032),(4,751,760,1572223032),(4,761,770,1610223032),(4,771,780,1648223032),(4,781,790,1686223032),(6,1,190,10619385),(6,191,200,11747985),(6,201,210,12933585),(6,211,220,14176185),(6,221,230,14945716),(6,231,240,17536547),(6,241,250,18243347),(6,251,260,18978647),(6,261,270,19879550),(6,271,280,19751482),(6,281,290,20818929),(6,291,300,21243579),(6,301,310,21075726),(6,311,320,22423212),(6,321,330,23773542),(6,331,340,23870838),(6,341,350,25643064),(6,351,360,27346516),(6,361,370,41435221),(6,371,380,52138819),(6,381,390,57838819),(6,391,400,63538819),(6,401,410,69238819),(6,411,420,74938819),(6,421,430,80638819),(6,431,440,85915364),(6,441,450,100216453),(6,451,460,109845284),(6,461,470,119901614),(6,471,480,124176614),(6,481,490,128451614),(6,491,500,132726614),(6,501,510,137001614),(6,511,520,152380320),(6,521,530,163296909),(6,531,540,198780219),(6,541,550,220653564),(6,551,560,243666909),(6,561,570,255066909),(6,571,580,266466909),(6,581,590,277866909),(6,591,600,289266909),(6,601,610,300666909),(6,611,620,312066909),(6,621,630,323466909),(6,631,640,334866909),(6,641,650,346266909),(6,651,660,357666909),(6,661,670,369066909),(6,671,680,380466909),(6,681,690,391866909),(6,691,700,403266909),(6,701,710,414666909),(6,711,720,426066909),(6,721,730,437466909),(6,731,740,448866909),(6,741,750,460266909),(6,751,760,471666909),(6,761,770,483066909),(6,771,780,494466909),(6,781,790,505866909);
/*!40000 ALTER TABLE `base_task_exp_module_lv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_task_goods`
--

DROP TABLE IF EXISTS `base_task_goods`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_task_goods` (
  `task_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '任务ID',
  `trigger_goods` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '触发任务物品',
  `replace_goods` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '替身令完成任务物品',
  `finish_goods` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '完成任务物品',
  `finish_goods_num` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '完成任务物品数量',
  PRIMARY KEY (`task_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='触发任务物品';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_task_goods`
--

LOCK TABLES `base_task_goods` WRITE;
/*!40000 ALTER TABLE `base_task_goods` DISABLE KEYS */;
/*!40000 ALTER TABLE `base_task_goods` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_task_lv_dynamic_id`
--

DROP TABLE IF EXISTS `base_task_lv_dynamic_id`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_task_lv_dynamic_id` (
  `task_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '任务类型',
  `slv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开始等级',
  `elv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '结束等级',
  `task_ids` varchar(1000) DEFAULT '[]' COMMENT '任务id,纯随机[id1,id2, ...]',
  PRIMARY KEY (`task_type`,`slv`,`elv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_task_lv_dynamic_id`
--

LOCK TABLES `base_task_lv_dynamic_id` WRITE;
/*!40000 ALTER TABLE `base_task_lv_dynamic_id` DISABLE KEYS */;
INSERT INTO `base_task_lv_dynamic_id` VALUES (6,1,199,'[{150,60010001},{150,60020001},{150,60030001},{150,60040001},{150,60050001},{20,60060001},{20,60070001},{20,60080001},{100,60090001},{100,60100001},{20,60110001}]'),(6,200,239,'[{150,60010200},{150,60020200},{150,60030200},{150,60040200},{150,60050200},{20,60060200},{20,60070200},{20,60080200},{100,60090200},{100,60100200},{20,60110200}]'),(6,240,279,'[{150,60010240},{150,60020240},{150,60030240},{150,60040240},{150,60050240},{20,60060240},{20,60070240},{20,60080240},{100,60090240},{100,60100240},{20,60110240}]'),(6,280,319,'[{150,60010280},{150,60020280},{150,60030280},{150,60040280},{150,60050280},{20,60060280},{20,60070280},{20,60080280},{100,60090280},{100,60100280},{20,60110280}]'),(6,320,349,'[{150,60010320},{150,60020320},{150,60030320},{150,60040320},{150,60050320},{20,60060320},{20,60070320},{20,60080320},{100,60090320},{100,60100320},{20,60110320}]'),(6,350,374,'[{150,60010350},{150,60020350},{150,60030350},{150,60040350},{150,60050350},{20,60060350},{20,60070350},{20,60080350},{100,60090350},{100,60100350},{20,60110350}]'),(6,375,399,'[{150,60010375},{150,60020375},{150,60030375},{150,60040375},{150,60050375},{20,60060375},{20,60070375},{20,60080375},{100,60090375},{100,60100375},{20,60110375}]'),(6,400,424,'[{150,60010400},{150,60020400},{150,60030400},{150,60040400},{150,60050400},{20,60060400},{20,60070400},{20,60080400},{100,60090400},{100,60100400},{20,60110400}]'),(6,425,449,'[{150,60010425},{150,60020425},{150,60030425},{150,60040425},{150,60050425},{20,60060425},{20,60070425},{20,60080425},{100,60090425},{100,60100425},{20,60110425}]'),(6,450,474,'[{150,60010450},{150,60020450},{150,60030450},{150,60040450},{150,60050450},{20,60060450},{20,60070450},{20,60080450},{100,60090450},{100,60100450},{20,60110450}]'),(6,475,514,'[{150,60010475},{150,60020475},{150,60030475},{150,60040475},{150,60050475},{20,60060475},{20,60070475},{20,60080475},{100,60090475},{100,60100475},{20,60110475}]'),(6,515,549,'[{150,60010515},{150,60020515},{150,60030515},{150,60040515},{150,60050515},{20,60060515},{20,60070515},{20,60080515},{100,60090515},{100,60100515},{20,60110515}]'),(6,550,574,'[{150,60010550},{150,60020550},{150,60030550},{150,60040550},{20,60050550},{20,60060550},{20,60070550},{20,60080550},{100,60090550},{100,60100550},{20,60110550}]'),(6,575,594,'[{150,60010575},{150,60020575},{150,60030575},{150,60040575},{20,60050575},{20,60060575},{20,60070575},{20,60080575},{100,60090575},{100,60100575},{20,60110575}]'),(6,595,609,'[{150,60010595},{150,60020595},{150,60030595},{150,60040595},{20,60050595},{20,60060595},{20,60070595},{20,60080595},{100,60090595},{100,60100595},{20,60110595}]'),(6,610,629,'[{150,60010610},{150,60020610},{150,60030610},{150,60040610},{20,60050610},{20,60060610},{20,60070610},{20,60080610},{100,60090610},{100,60100610},{20,60110610}]'),(6,630,649,'[{150,60010630},{150,60020630},{150,60030630},{150,60040630},{20,60050630},{20,60060630},{20,60070630},{20,60080630},{100,60090630},{100,60100630},{20,60110630}]'),(6,650,669,'[{150,60010650},{150,60020650},{150,60030650},{150,60040650},{20,60050650},{20,60060650},{20,60070650},{20,60080650},{100,60090650},{100,60100650},{20,60110650}]'),(6,670,689,'[{150,60010670},{150,60020670},{150,60030670},{150,60040670},{20,60050670},{20,60060670},{20,60070670},{20,60080670},{100,60090670},{100,60100670},{20,60110670}]'),(6,690,709,'[{150,60010690},{150,60020690},{150,60030690},{150,60040690},{20,60050690},{20,60060690},{20,60070690},{20,60080690},{100,60090690},{100,60100690},{20,60110690}]'),(6,710,729,'[{150,60010710},{150,60020710},{150,60030710},{150,60040710},{20,60050710},{20,60060710},{20,60070710},{20,60080710},{100,60090710},{100,60100710},{20,60110710}]'),(6,730,749,'[{150,60010730},{150,60020730},{150,60030730},{150,60040730},{20,60050730},{20,60060730},{20,60070730},{100,60080730},{100,60090730},{100,60100730},{20,60110730}]'),(6,750,769,'[{150,60010750},{150,60020750},{150,60030750},{150,60040750},{20,60050750},{20,60060750},{20,60070750},{100,60080750},{100,60090750},{100,60100750},{20,60110750}]'),(6,770,789,'[{150,60010770},{150,60020770},{150,60030770},{150,60040770},{20,60050770},{20,60060770},{20,60070770},{100,60080770},{100,60090770},{100,60100770},{20,60110770}]'),(6,790,809,'[{150,60010790},{150,60020790},{150,60030790},{150,60040790},{20,60050790},{20,60060790},{20,60070790},{100,60080790},{100,60090790},{100,60100790},{20,60110790}]'),(6,810,829,'[{150,60010810},{150,60020810},{150,60030810},{150,60040810},{20,60050810},{20,60060810},{20,60070810},{100,60080810},{100,60090810},{100,60100810},{20,60110810}]'),(6,830,849,'[{150,60010830},{150,60020830},{150,60030830},{150,60040830},{20,60050830},{20,60060830},{20,60070830},{100,60080830},{100,60090830},{100,60100830},{20,60110830}]'),(6,850,869,'[{150,60010850},{150,60020850},{150,60030850},{150,60040850},{20,60050850},{20,60060850},{20,60070850},{100,60080850},{100,60090850},{100,60100850},{20,60110850}]'),(6,870,889,'[{150,60010870},{150,60020870},{150,60030870},{150,60040870},{20,60050870},{20,60060870},{20,60070870},{100,60080870},{100,60090870},{100,60100870},{20,60110870}]'),(6,890,909,'[{150,60010890},{150,60020890},{150,60030890},{150,60040890},{20,60050890},{20,60060890},{20,60070890},{100,60080890},{100,60090890},{100,60100890},{20,60110890}]'),(6,910,929,'[{150,60010910},{150,60020910},{150,60030910},{150,60040910},{20,60050910},{20,60060910},{20,60070910},{100,60080910},{100,60090910},{100,60100910},{20,60110910}]'),(6,930,949,'[{150,60010930},{150,60020930},{150,60030930},{150,60040930},{20,60050930},{20,60060930},{20,60070930},{100,60080930},{100,60090930},{100,60100930},{20,60110930}]'),(6,950,969,'[{150,60010950},{150,60020950},{150,60030950},{150,60040950},{20,60050950},{20,60060950},{20,60070950},{100,60080950},{100,60090950},{100,60100950},{20,60110950}]'),(6,970,989,'[{150,60010970},{150,60020970},{150,60030970},{150,60040970},{20,60050970},{20,60060970},{20,60070970},{100,60080970},{100,60090970},{100,60100970},{20,60110970}]'),(6,990,1000,'[{150,60010990},{150,60020990},{150,60030990},{150,60040990},{20,60050990},{20,60060990},{20,60070990},{100,60080990},{100,60090990},{20,60100990},{20,60110990}]'),(7,1,55,'[{20,70010001},{20,70030001}]'),(7,56,80,'[{150,70010056},{150,70020056},{150,70030056},{150,70040056},{20,70050056},{20,70060056},{20,70070056},{100,70080056},{100,70090056},{20,70100056}]'),(7,81,99,'[{150,70010081},{150,70020081},{150,70030081},{150,70040081},{20,70050081},{20,70060081},{20,70070081},{100,70080081},{100,70090081},{20,70100081}]'),(7,100,119,'[{150,70010095},{150,70020095},{150,70030095},{150,70040095},{20,70050095},{20,70060095},{20,70070095},{100,70080095},{100,70090095},{20,70100095}]'),(7,120,139,'[{150,70010105},{150,70020105},{150,70030105},{150,70040105},{20,70050105},{20,70060105},{20,70070105},{100,70080105},{100,70090105},{20,70100105}]'),(7,140,159,'[{150,70010120},{150,70020120},{150,70030120},{150,70040120},{20,70050120},{20,70060120},{20,70070120},{100,70080120},{100,70090120},{20,70100120}]'),(7,160,179,'[{150,70010155},{150,70020155},{150,70030155},{150,70040155},{20,70050155},{20,70060155},{20,70070155},{100,70080155},{100,70090155},{20,70100155}]'),(7,180,200,'[{150,70010180},{150,70020180},{150,70030180},{150,70040180},{20,70050180},{20,70060180},{20,70070180},{100,70080180},{100,70090180},{20,70100180}]'),(7,201,239,'[{150,70010201},{150,70020201},{150,70030201},{150,70040201},{20,70050201},{20,70060201},{20,70070201},{100,70080201},{100,70090201},{20,70100201}]'),(7,240,279,'[{150,70010240},{150,70020240},{150,70030240},{150,70040240},{20,70050240},{20,70060240},{20,70070240},{100,70080240},{100,70090240},{20,70100240}]'),(7,280,319,'[{150,70010280},{150,70020280},{150,70030280},{150,70040280},{20,70050280},{20,70060280},{20,70070280},{100,70080280},{100,70090280},{20,70100280}]'),(7,320,349,'[{150,70010320},{150,70020320},{150,70030320},{150,70040320},{20,70050320},{20,70060320},{20,70070320},{100,70080320},{100,70090320},{20,70100320}]'),(7,350,374,'[{150,70010350},{150,70020350},{150,70030350},{150,70040350},{20,70050350},{20,70060350},{20,70070350},{100,70080350},{100,70090350}]'),(7,375,399,'[{150,70010375},{150,70020375},{150,70030375},{150,70040375},{20,70050375},{20,70060375},{20,70070375},{100,70080375},{100,70090375}]'),(7,400,424,'[{150,70010400},{150,70020400},{150,70030400},{150,70040400},{20,70050400},{20,70060400},{20,70070400},{100,70080400},{100,70090400}]'),(7,425,449,'[{150,70010425},{150,70020425},{150,70030425},{150,70040425},{20,70050425},{20,70060425},{20,70070425},{100,70080425},{100,70090425}]'),(7,450,474,'[{150,70010450},{150,70020450},{150,70030450},{150,70040450},{20,70050450},{20,70060450},{20,70070450},{100,70080450},{100,70090450}]'),(7,475,514,'[{150,70010475},{150,70020475},{150,70030475},{150,70040475},{20,70050475},{20,70060475},{20,70070475},{100,70080475},{100,70090475}]'),(7,515,549,'[{150,70010515},{150,70020515},{150,70030515},{150,70040515},{20,70050515},{20,70060515},{20,70070515},{100,70080515},{100,70090515}]'),(7,550,574,'[{150,70010550},{150,70020550},{150,70030550},{150,70040550},{20,70050550},{20,70060550},{20,70070550},{100,70080550},{100,70090550}]'),(7,575,594,'[{150,70010575},{150,70020575},{150,70030575},{150,70040575},{20,70050575},{20,70060575},{20,70070575},{100,70080575},{100,70090575}]'),(7,595,609,'[{150,70010595},{150,70020595},{150,70030595},{150,70040595},{20,70050595},{20,70060595},{20,70070595},{100,70080595},{100,70090595}]'),(7,610,629,'[{150,70010610},{150,70020610},{150,70030610},{150,70040610},{20,70050610},{20,70060610},{20,70070610},{100,70080610},{100,70090610}]'),(7,630,649,'[{150,70010630},{150,70020630},{150,70030630},{150,70040630},{20,70050630},{20,70060630},{20,70070630},{100,70080630},{100,70090630}]'),(7,650,669,'[{150,70010650},{150,70020650},{150,70030650},{150,70040650},{20,70050650},{20,70060650},{20,70070650},{100,70080650},{100,70090650}]'),(7,670,689,'[{150,70010670},{150,70020670},{150,70030670},{150,70040670},{20,70050670},{20,70060670},{20,70070670},{100,70080670},{100,70090670}]'),(7,690,709,'[{150,70010690},{150,70020690},{150,70030690},{150,70040690},{20,70050690},{20,70060690},{20,70070690},{100,70080690},{100,70090690}]'),(7,710,729,'[{150,70010710},{150,70020710},{150,70030710},{150,70040710},{20,70050710},{20,70060710},{20,70070710},{100,70080710},{100,70090710}]'),(7,730,749,'[{150,70010730},{150,70020730},{150,70030730},{150,70040730},{20,70050730},{20,70060730},{20,70070730},{100,70080730},{100,70090730}]'),(7,750,769,'[{150,70010750},{150,70020750},{150,70030750},{150,70040750},{20,70050750},{20,70060750},{20,70070750},{100,70080750},{100,70090750}]'),(7,770,789,'[{150,70010770},{150,70020770},{150,70030770},{150,70040770},{20,70050770},{20,70060770},{20,70070770},{100,70080770},{100,70090770}]'),(7,790,809,'[{150,70010790},{150,70020790},{150,70030790},{150,70040790},{20,70050790},{20,70060790},{20,70070790},{100,70080790},{100,70090790}]'),(7,810,829,'[{150,70010810},{150,70020810},{150,70030810},{150,70040810},{20,70050810},{20,70060810},{20,70070810},{100,70080810},{100,70090810}]'),(7,830,849,'[{150,70010830},{150,70020830},{150,70030830},{150,70040830},{20,70050830},{20,70060830},{20,70070830},{100,70080830},{100,70090830}]'),(7,850,869,'[{150,70010850},{150,70020850},{150,70030850},{150,70040850},{20,70050850},{20,70060850},{20,70070850},{100,70080850},{100,70090850}]'),(7,870,889,'[{150,70010870},{150,70020870},{150,70030870},{150,70040870},{20,70050870},{20,70060870},{20,70070870},{100,70080870},{100,70090870}]'),(7,890,909,'[{150,70010890},{150,70020890},{150,70030890},{150,70040890},{20,70050890},{20,70060890},{20,70070890},{100,70080890},{100,70090890}]'),(7,910,929,'[{150,70010910},{150,70020910},{150,70030910},{150,70040910},{20,70050910},{20,70060910},{20,70070910},{100,70080910},{100,70090910}]'),(7,930,949,'[{150,70010930},{150,70020930},{150,70030930},{150,70040930},{20,70050930},{20,70060930},{20,70070930},{100,70080930},{100,70090930}]'),(7,950,969,'[{150,70010950},{150,70020950},{150,70030950},{150,70040950},{20,70050950},{20,70060950},{20,70070950},{100,70080950},{100,70090950}]'),(7,970,989,'[{150,70010970},{150,70020970},{150,70030970},{150,70040970},{20,70050970},{20,70060970},{20,70070970},{100,70080970},{100,70090970}]'),(7,990,1000,'[{150,70010990},{150,70020990},{150,70030990},{150,70040990},{20,70050990},{20,70060990},{20,70070990},{100,70080990},{100,70090990}]');
/*!40000 ALTER TABLE `base_task_lv_dynamic_id` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_task_type`
--

DROP TABLE IF EXISTS `base_task_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_task_type` (
  `type` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '任务类型',
  `count` smallint(3) unsigned NOT NULL DEFAULT '1' COMMENT '任务类系',
  `module_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '模块id',
  `counter_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '次数id',
  `finish_cost` varchar(300) COLLATE utf8_unicode_ci NOT NULL DEFAULT '[]' COMMENT '任务消耗',
  PRIMARY KEY (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_task_type`
--

LOCK TABLES `base_task_type` WRITE;
/*!40000 ALTER TABLE `base_task_type` DISABLE KEYS */;
INSERT INTO `base_task_type` VALUES (6,10,300,2,'[{2,36010001,20}]'),(7,20,300,1,'[{2,36010001,10}]');
/*!40000 ALTER TABLE `base_task_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_team_ui`
--

DROP TABLE IF EXISTS `base_team_ui`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_team_ui` (
  `activity_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '活动大类',
  `activity_name` varchar(255) NOT NULL COMMENT '大类名字',
  `subtype_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '活动小类',
  `subtype_name` varchar(255) NOT NULL COMMENT '子类名字',
  `module_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '模块',
  `sub_module` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '子模块',
  `dun_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '副本id',
  `scene_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '对应的场景id',
  `num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '人数要求',
  `auto_pos` varchar(1000) NOT NULL COMMENT '自动挂机点',
  `default_lv_min` int(10) unsigned NOT NULL COMMENT '最低等级',
  `default_lv_max` int(10) unsigned NOT NULL COMMENT '最高等级',
  `can_set_lv_limit` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '能否设置等级限制',
  `can_set_power_limit` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '否设置战力限制',
  `auto_pair` tinyint(3) unsigned NOT NULL DEFAULT '1' COMMENT '是否能自动匹配##1是 0否',
  `exp_scale_type` tinyint(3) unsigned NOT NULL DEFAULT '1' COMMENT '经验加成类型 0不加成 1同场景加成 2同队伍加成',
  UNIQUE KEY `type` (`activity_id`,`subtype_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='组队大厅配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_team_ui`
--

LOCK TABLES `base_team_ui` WRITE;
/*!40000 ALTER TABLE `base_team_ui` DISABLE KEYS */;
INSERT INTO `base_team_ui` VALUES (0,'全部',0,'全部',0,0,0,0,3,'[]',1,1000,0,0,0,1),(1,'无目标',0,'无目标',0,0,0,0,3,'[]',1,1000,0,0,0,1),(2,'装备副本',1,'装备副本<color=#4eae1a>(新手)</color>',610,1,3110,3115,3,'[]',105,1000,1,1,1,0),(2,'装备副本',2,'装备副本<color=#4eae1a>(基础)</color>',610,1,3111,3115,3,'[]',140,1000,1,1,1,1),(2,'装备副本',3,'装备副本<color=#4eae1a>(普通)</color>',610,1,3112,3115,3,'[]',200,1000,1,1,1,1),(2,'装备副本',4,'装备副本<color=#4eae1a>(达人)</color>',610,1,3113,3115,3,'[]',240,1000,1,1,1,1),(2,'装备副本',5,'装备副本<color=#4eae1a>(老手)</color>',610,1,3114,3115,3,'[]',300,1000,1,1,1,1),(2,'装备副本',6,'装备副本<color=#4eae1a>(困难)</color>',610,1,3115,3115,3,'[]',350,1000,1,1,1,1),(2,'装备副本',7,'装备副本<color=#4eae1a>(精英)</color>',610,1,3116,3115,3,'[]',400,1000,1,1,1,1),(2,'装备副本',8,'装备副本<color=#4eae1a>(英雄)</color>',610,1,3117,3115,3,'[]',450,1000,1,1,1,1),(2,'装备副本',9,'装备副本<color=#4eae1a>(轮回)</color>',610,1,3118,3115,3,'[]',500,1000,1,1,1,1),(2,'装备副本',10,'装备副本<color=#4eae1a>(天命)</color>',610,1,3119,3115,3,'[]',580,1000,1,1,1,1),(2,'装备副本',11,'装备副本<color=#4eae1a>(噩梦)</color>',610,1,3120,3115,3,'[]',620,1000,1,1,1,1),(2,'装备副本',12,'装备副本<color=#4eae1a>(地狱)</color>',610,1,3121,3115,3,'[]',680,1000,1,1,1,1),(2,'装备副本',13,'装备副本<color=#4eae1a>(炼狱)</color>',610,1,3122,3115,3,'[]',750,1000,1,1,1,1),(3,'洗练副本',1,'洗练副本<color=#4eae1a>(简单)</color>',610,1,3300,3300,3,'[]',260,1000,1,1,1,0),(3,'洗练副本',2,'洗练副本<color=#4eae1a>(普通)</color>',610,1,3301,3301,3,'[]',310,1000,1,1,1,0),(3,'洗练副本',3,'洗练副本<color=#4eae1a>(困难)</color>',610,1,3302,3110,3,'[]',350,1000,1,1,1,0),(3,'洗练副本',4,'洗练副本<color=#4eae1a>(噩梦)</color>',610,1,3303,3110,3,'[]',400,1000,1,1,1,0),(3,'洗练副本',5,'洗练副本<color=#4eae1a>(炼狱)</color>',610,1,3304,3110,3,'[]',520,1000,1,1,1,0),(4,'情侣副本',1,'情侣副本<color=#4eae1a>(简单)</color>',610,1,5200,5200,2,'[]',180,1000,1,1,1,0),(4,'情侣副本',2,'情侣副本<color=#4eae1a>(普通)</color>',610,1,5201,5200,2,'[]',280,1000,1,1,1,0),(4,'情侣副本',3,'情侣副本<color=#4eae1a>(困难)</color>',610,1,5202,5200,2,'[]',390,1000,1,1,1,0),(5,'重铸副本',1,'重铸副本<color=#4eae1a>(简单)</color>',610,1,60000,60000,3,'[]',330,1000,1,1,1,0),(5,'重铸副本',2,'重铸副本<color=#4eae1a>(普通)</color>',610,1,60001,60000,3,'[]',375,1000,1,1,1,0),(5,'重铸副本',3,'重铸副本<color=#4eae1a>(困难)</color>',610,1,60002,60000,3,'[]',420,1000,1,1,1,0),(5,'重铸副本',4,'重铸副本<color=#4eae1a>(噩梦)</color>',610,1,60003,60000,3,'[]',540,1000,1,1,1,0),(5,'重铸副本',5,'重铸副本<color=#4eae1a>(炼狱)</color>',610,1,60004,60000,3,'[]',630,1000,1,1,1,0);
/*!40000 ALTER TABLE `base_team_ui` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_teamates_exp_scale`
--

DROP TABLE IF EXISTS `base_teamates_exp_scale`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_teamates_exp_scale` (
  `member_count` smallint(5) unsigned NOT NULL COMMENT '队员人数',
  `exp_scale` smallint(5) unsigned NOT NULL COMMENT '经验加成##千分数',
  PRIMARY KEY (`member_count`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='队伍经验加成配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_teamates_exp_scale`
--

LOCK TABLES `base_teamates_exp_scale` WRITE;
/*!40000 ALTER TABLE `base_teamates_exp_scale` DISABLE KEYS */;
INSERT INTO `base_teamates_exp_scale` VALUES (2,2000),(3,3000);
/*!40000 ALTER TABLE `base_teamates_exp_scale` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_top_pk_fake_man`
--

DROP TABLE IF EXISTS `base_top_pk_fake_man`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_top_pk_fake_man` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '编号',
  `min_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小等级',
  `max_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大等级',
  `fake_star_soul_stage_star` varchar(128) DEFAULT '{0,0}' COMMENT '星灵阶数星级',
  `fake_star_soul_ids` varchar(128) NOT NULL COMMENT '星灵ID列表',
  `fake_star_soul_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '星灵数量',
  `fake_man_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '假人ID',
  `power_range` varchar(128) NOT NULL COMMENT '战力范围',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='巅峰竞技假人配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_top_pk_fake_man`
--

LOCK TABLES `base_top_pk_fake_man` WRITE;
/*!40000 ALTER TABLE `base_top_pk_fake_man` DISABLE KEYS */;
INSERT INTO `base_top_pk_fake_man` VALUES (1,140,160,'{1,3}','[1001,2001,2002,2003,2004,2005]',2,2810001,'{1404052,1372704}'),(2,161,180,'{1,3}','[1001,1002,2001,2002,2003,2004,2006]',2,2810002,'{2731180,1404051}'),(3,181,200,'{1,3}','[1001,1002,2001,2002,2003,2004,2007]',2,2810003,'{4261694,2731179}'),(4,201,220,'{2,1}','[1001,1002,2001,2002,2003,2004,2008]',2,2810004,'{5601921,4261693}'),(5,221,240,'{2,1}','[1001,1002,2001,2002,2003,2004,2009]',2,2810005,'{8057207,5601920}'),(6,241,260,'{2,2}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810006,'{11355793,8057206}'),(7,261,280,'{2,2}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810007,'{14597605,11355792}'),(8,281,300,'{2,3}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810008,'{17865115,14597604}'),(9,301,310,'{3,0}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810009,'{19743261,17865114}'),(10,311,320,'{3,0}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810010,'{21621407,19743260}'),(11,321,330,'{3,1}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810011,'{23499629,21621406}'),(12,331,340,'{3,1}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810012,'{25377875,23499628}'),(13,341,350,'{3,2}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810013,'{27298553,25377874}'),(14,351,360,'{3,2}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810014,'{29601812,27298552}'),(15,361,370,'{3,3}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810015,'{31905096,29601811}'),(16,371,380,'{3,3}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810016,'{34208230,31905095}'),(17,381,390,'{4,0}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810017,'{36511464,34208229}'),(18,391,400,'{4,0}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810018,'{38807708,36511463}'),(19,401,410,'{4,0}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810019,'{41039739,38807707}'),(20,411,420,'{4,1}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810020,'{43271796,41039738}'),(21,421,430,'{4,2}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810021,'{45503928,43271795}'),(22,431,440,'{4,3}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810022,'{47736084,45503927}'),(23,441,450,'{5,0}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810023,'{50066664,47736083}'),(24,451,460,'{5,1}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810024,'{53284270,50066663}'),(25,461,470,'{5,2}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810025,'{56501902,53284269}'),(26,471,480,'{5,3}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810026,'{59719509,56501901}'),(27,481,490,'{6,0}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810027,'{62937040,59719508}'),(28,491,500,'{6,1}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810028,'{66210030,62937039}'),(29,501,510,'{6,2}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810029,'{69981338,66210029}'),(30,511,520,'{6,3}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810030,'{73752646,69981337}'),(31,521,530,'{7,0}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810031,'{77523979,73752645}'),(32,531,540,'{7,1}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810032,'{81295262,77523978}'),(33,541,550,'{7,2}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810033,'{85087885,81295261}'),(34,551,560,'{7,3}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810034,'{89071388,85087884}'),(35,561,570,'{8,0}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810035,'{93054891,89071387}'),(36,571,580,'{8,1}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810036,'{97038344,93054890}'),(37,581,590,'{8,2}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810037,'{101021822,97038343}'),(38,591,600,'{8,3}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810038,'{105046937,101021821}'),(39,601,610,'{9,0}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810039,'{109447132,105046936}'),(40,611,620,'{9,1}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810040,'{113847278,109447131}'),(41,621,630,'{9,2}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810041,'{118247448,113847277}'),(42,631,640,'{9,3}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810042,'{122647594,118247447}'),(43,641,650,'{10,0}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810043,'{127140568,122647593}'),(44,651,660,'{10,1}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810044,'{132468303,127140567}'),(45,661,670,'{10,2}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810045,'{137796137,132468302}'),(46,671,680,'{10,3}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810046,'{143123922,137796136}'),(47,681,690,'{11,0}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810047,'{148451657,143123921}'),(48,691,700,'{11,1}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810048,'{153732813,148451656}'),(49,701,710,'{11,2}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810049,'{158593783,153732812}'),(50,711,720,'{11,3}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810050,'{163454702,158593782}'),(51,721,730,'{12,0}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810051,'{168315622,163454701}'),(52,731,740,'{12,1}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810052,'{173176641,168315621}'),(53,741,750,'{12,2}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810053,'{178079899,173176640}'),(54,751,760,'{12,3}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810054,'{183365352,178079898}'),(55,761,770,'{13,0}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810055,'{188650830,183365351}'),(56,771,780,'{13,1}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810056,'{193936233,188650829}'),(57,781,790,'{13,2}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810057,'{199221685,193936232}'),(58,791,800,'{13,3}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810058,'{203978590,199221684}'),(59,801,810,'{14,0}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810059,'{203978589,203978589}'),(60,811,820,'{14,1}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810060,'{203978589,203978589}'),(61,821,830,'{14,2}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810061,'{203978589,203978589}'),(62,831,840,'{14,3}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810062,'{203978589,203978589}'),(63,841,850,'{15,0}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810063,'{203978589,203978589}'),(64,851,860,'{15,1}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810064,'{203978589,203978589}'),(65,861,870,'{15,2}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810065,'{203978589,203978589}'),(66,871,880,'{15,3}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810066,'{203978589,203978589}'),(67,881,890,'{16,0}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810067,'{203978589,203978589}'),(68,891,900,'{16,1}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810068,'{203978589,203978589}'),(69,901,910,'{16,2}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810069,'{203978589,203978589}'),(70,911,920,'{16,3}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810070,'{203978589,203978589}'),(71,921,930,'{17,0}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810071,'{203978589,203978589}'),(72,931,940,'{17,1}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810072,'{203978589,203978589}'),(73,941,950,'{17,2}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810073,'{203978589,203978589}'),(74,951,960,'{17,3}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810074,'{203978589,203978589}'),(75,961,970,'{18,0}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810075,'{203978589,203978589}'),(76,971,980,'{18,1}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810076,'{203978589,203978589}'),(77,981,990,'{18,2}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810077,'{203978589,203978589}'),(78,991,1000,'{18,3}','[1001,1002,1003,1004,1005,1006,1007,2001,2002,2003,2004,2010]',3,2810078,'{203978589,203978589}');
/*!40000 ALTER TABLE `base_top_pk_fake_man` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_top_pk_grade_detail`
--

DROP TABLE IF EXISTS `base_top_pk_grade_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_top_pk_grade_detail` (
  `grade_num` tinyint(3) unsigned NOT NULL COMMENT '段位##不支持超过32段',
  `star_num` tinyint(3) unsigned NOT NULL COMMENT '星数',
  `win_star` tinyint(3) unsigned NOT NULL COMMENT '胜利增加星数',
  `lose_star` tinyint(3) unsigned NOT NULL COMMENT '失败扣除星数',
  `honor_value` int(10) unsigned NOT NULL COMMENT '本等级荣誉值',
  `rewards` varchar(1000) NOT NULL COMMENT '赛季结算奖励',
  PRIMARY KEY (`grade_num`,`star_num`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='巅峰竞技 段位规则';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_top_pk_grade_detail`
--

LOCK TABLES `base_top_pk_grade_detail` WRITE;
/*!40000 ALTER TABLE `base_top_pk_grade_detail` DISABLE KEYS */;
INSERT INTO `base_top_pk_grade_detail` VALUES (1,0,1,0,100,'[{3,36030001,20000}]'),(1,1,1,0,500,'[{3,36030001,40000}]'),(1,2,1,0,500,'[{0,20020001,1},{3,36030001,60000}]'),(1,3,1,0,500,'[{0,20020001,1},{3,36030001,80000}]'),(1,4,1,0,500,'[{0,20020001,1},{3,36030001,100000}]'),(1,5,1,0,500,'[{0,20020002,1},{0,20020001,1},{3,36030001,100000}]'),(1,6,1,0,500,'[{0,20020002,1},{0,20020001,1},{3,36030001,100000},{2,36020001,50}]'),(2,0,1,1,1000,'[{0,20020002,2},{0,20020001,2},{3,36030001,120000},{2,36020001,55}]'),(2,1,1,1,1000,'[{0,20020002,2},{0,20020001,2},{3,36030001,140000},{2,36020001,60}]'),(2,2,1,1,1000,'[{0,20020002,2},{0,20020001,2},{3,36030001,160000},{2,36020001,65}]'),(2,3,1,1,1000,'[{0,20020002,2},{0,20020001,2},{3,36030001,180000},{2,36020001,70}]'),(2,4,1,1,1000,'[{0,20020002,2},{0,20020001,2},{3,36030001,200000},{2,36020001,75}]'),(2,5,1,1,1000,'[{0,20020002,2},{0,20020001,2},{3,36030001,220000},{2,36020001,80}]'),(2,6,1,1,1000,'[{0,20020002,2},{0,20020001,2},{3,36030001,240000},{2,36020001,90}]'),(3,0,1,1,1500,'[{0,20020002,3},{0,20020001,3},{3,36030001,260000},{2,36020001,105}]'),(3,1,1,1,1500,'[{0,20020002,3},{0,20020001,3},{3,36030001,280000},{2,36020001,120}]'),(3,2,1,1,1500,'[{0,20020002,3},{0,20020001,3},{3,36030001,300000},{2,36020001,135}]'),(3,3,1,1,1500,'[{0,20020002,3},{0,20020001,3},{3,36030001,320000},{2,36020001,150}]'),(3,4,1,1,1500,'[{0,20020002,3},{0,20020001,3},{3,36030001,340000},{2,36020001,165}]'),(3,5,1,1,1500,'[{0,20020002,3},{0,20020001,3},{3,36030001,360000},{2,36020001,180}]'),(3,6,1,1,1500,'[{0,20020002,3},{0,20020001,3},{3,36030001,380000},{2,36020001,200}]'),(4,0,1,1,2000,'[{0,20020002,5},{0,20020001,5},{3,36030001,400000},{2,36020001,220}]'),(4,1,1,1,2000,'[{0,20020002,5},{0,20020001,5},{3,36030001,420000},{2,36020001,240}]'),(4,2,1,1,2000,'[{0,20020002,5},{0,20020001,5},{3,36030001,440000},{2,36020001,260}]'),(4,3,1,1,2000,'[{0,20020002,5},{0,20020001,5},{3,36030001,460000},{2,36020001,280}]'),(4,4,1,1,2000,'[{0,20020002,5},{0,20020001,5},{3,36030001,480000},{2,36020001,300}]'),(4,5,1,1,2000,'[{0,20020002,5},{0,20020001,5},{3,36030001,500000},{2,36020001,320}]'),(4,6,1,1,2000,'[{0,20020002,5},{0,20020001,5},{3,36030001,520000},{2,36020001,350}]'),(5,0,1,1,2500,'[{0,20020003,1},{0,20020002,6},{0,20020001,6},{3,36030001,550000},{2,36020001,380}]'),(5,1,1,1,2500,'[{0,20020003,1},{0,20020002,6},{0,20020001,6},{3,36030001,600000},{2,36020001,410}]'),(5,2,1,1,2500,'[{0,20020003,1},{0,20020002,6},{0,20020001,6},{3,36030001,650000},{2,36020001,440}]'),(5,3,1,1,2500,'[{0,20020003,1},{0,20020002,6},{0,20020001,6},{3,36030001,700000},{2,36020001,470}]'),(5,4,1,1,2500,'[{0,20020003,1},{0,20020002,6},{0,20020001,6},{3,36030001,750000},{2,36020001,500}]'),(5,5,1,1,2500,'[{0,20020003,1},{0,20020002,6},{0,20020001,6},{3,36030001,800000},{2,36020001,530}]'),(5,6,1,1,2500,'[{0,20020003,1},{0,20020002,6},{0,20020001,6},{3,36030001,850000},{2,36020001,580}]'),(6,0,1,1,3000,'[{0,20020003,2},{0,20020002,8},{0,20020001,8},{3,36030001,900000},{2,36020001,630}]'),(6,1,1,1,3000,'[{0,20020003,2},{0,20020002,8},{0,20020001,8},{3,36030001,950000},{2,36020001,680}]'),(6,2,1,1,3000,'[{0,20020003,2},{0,20020002,8},{0,20020001,8},{3,36030001,1000000},{2,36020001,730}]'),(6,3,1,1,3000,'[{0,20020003,2},{0,20020002,8},{0,20020001,8},{3,36030001,1050000},{2,36020001,780}]'),(6,4,1,1,3000,'[{0,20020003,2},{0,20020002,8},{0,20020001,8},{3,36030001,1100000},{2,36020001,830}]'),(6,5,1,1,3000,'[{0,20020003,2},{0,20020002,8},{0,20020001,8},{3,36030001,1150000},{2,36020001,880}]'),(6,6,1,1,3000,'[{0,20020003,3},{0,20020002,8},{0,20020001,8},{3,36030001,1200000},{2,36020001,1000}]');
/*!40000 ALTER TABLE `base_top_pk_grade_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_top_pk_grade_info`
--

DROP TABLE IF EXISTS `base_top_pk_grade_info`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_top_pk_grade_info` (
  `grade_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '段位',
  `stage` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '阶数',
  `name` varchar(128) NOT NULL COMMENT '段位名@lang@',
  `min_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小积分',
  `max_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大积分',
  `win_score` int(11) unsigned DEFAULT '0' COMMENT '胜利积分',
  `lose_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '失败积分',
  PRIMARY KEY (`grade_num`,`stage`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='段位信息配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_top_pk_grade_info`
--

LOCK TABLES `base_top_pk_grade_info` WRITE;
/*!40000 ALTER TABLE `base_top_pk_grade_info` DISABLE KEYS */;
INSERT INTO `base_top_pk_grade_info` VALUES (1,1,'青铜1',1,1014,8,4),(1,2,'青铜2',1015,1029,8,4),(1,3,'青铜3',1030,1044,8,4),(2,1,'白银1',1045,1074,10,4),(2,2,'白银2',1075,1109,10,4),(2,3,'白银3',1110,1139,10,4),(3,1,'黄金1',1140,1174,12,5),(3,2,'黄金2',1175,1209,12,5),(3,3,'黄金3',1210,1244,12,5),(4,1,'铂金1',1245,1289,15,6),(4,2,'铂金2',1290,1334,15,6),(4,3,'铂金3',1335,1379,15,6),(4,4,'铂金4',1380,1424,15,6),(5,1,'钻石1',1425,1499,18,7),(5,2,'钻石2',1500,1574,18,7),(5,3,'钻石3',1575,1639,18,7),(5,4,'钻石4',1640,1714,18,7),(6,1,'王者1',1715,1799,20,8),(6,2,'王者2',1800,1874,20,8),(6,3,'王者3',1875,1954,20,8),(6,4,'王者4',1955,2034,20,8),(6,5,'王者5',2035,99999,25,8);
/*!40000 ALTER TABLE `base_top_pk_grade_info` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_top_pk_grade_reward`
--

DROP TABLE IF EXISTS `base_top_pk_grade_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_top_pk_grade_reward` (
  `min_world_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小世界等级',
  `max_world_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大世界等级',
  `grade_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '段位',
  `reward_list` varchar(512) NOT NULL COMMENT '奖励列表',
  PRIMARY KEY (`min_world_lv`,`max_world_lv`,`grade_num`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='段位奖励配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_top_pk_grade_reward`
--

LOCK TABLES `base_top_pk_grade_reward` WRITE;
/*!40000 ALTER TABLE `base_top_pk_grade_reward` DISABLE KEYS */;
INSERT INTO `base_top_pk_grade_reward` VALUES (1,200,1,'[{2,36020001,20},{0,15020201,8},{3,36030001,100000}]'),(1,200,2,'[{2,36020001,40},{0,15020201,12},{3,36030001,150000}]'),(1,200,3,'[{2,36020001,80},{0,15020201,16},{3,36030001,200000}]'),(1,200,4,'[{2,36020001,120},{0,15020201,21},{3,36030001,250000}]'),(1,200,5,'[{2,36020001,150},{0,15020201,27},{3,36030001,300000}]'),(1,200,6,'[{2,36020001,200},{0,15020201,35},{3,36030001,350000}]'),(201,260,1,'[{2,36020001,20},{0,15020201,8},{3,36030001,150000}]'),(201,260,2,'[{2,36020001,40},{0,15020201,12},{3,36030001,200000}]'),(201,260,3,'[{2,36020001,80},{0,15020201,16},{3,36030001,250000}]'),(201,260,4,'[{2,36020001,120},{0,15020201,21},{3,36030001,300000}]'),(201,260,5,'[{2,36020001,150},{0,15020201,27},{3,36030001,350000}]'),(201,260,6,'[{2,36020001,200},{0,15020201,35},{3,36030001,400000}]'),(261,320,1,'[{2,36020001,20},{0,15020201,8},{3,36030001,200000}]'),(261,320,2,'[{2,36020001,40},{0,15020201,12},{3,36030001,250000}]'),(261,320,3,'[{2,36020001,80},{0,15020201,16},{3,36030001,300000}]'),(261,320,4,'[{2,36020001,120},{0,15020201,21},{3,36030001,350000}]'),(261,320,5,'[{2,36020001,150},{0,15020201,27},{3,36030001,400000}]'),(261,320,6,'[{2,36020001,200},{0,15020201,35},{3,36030001,450000}]'),(321,350,1,'[{2,36020001,20},{0,15020202,4},{3,36030001,250000}]'),(321,350,2,'[{2,36020001,40},{0,15020202,6},{3,36030001,300000}]'),(321,350,3,'[{2,36020001,80},{0,15020202,9},{3,36030001,350000}]'),(321,350,4,'[{2,36020001,120},{0,15020202,12},{3,36030001,400000}]'),(321,350,5,'[{2,36020001,150},{0,15020202,14},{3,36030001,450000}]'),(321,350,6,'[{2,36020001,200},{0,15020202,16},{3,36030001,500000}]'),(351,370,1,'[{2,36020001,20},{0,15020202,4},{3,36030001,300000}]'),(351,370,2,'[{2,36020001,40},{0,15020202,6},{3,36030001,350000}]'),(351,370,3,'[{2,36020001,80},{0,15020202,9},{3,36030001,400000}]'),(351,370,4,'[{2,36020001,120},{0,15020202,12},{3,36030001,450000}]'),(351,370,5,'[{2,36020001,150},{0,15020202,14},{3,36030001,500000}]'),(351,370,6,'[{2,36020001,200},{0,15020202,16},{3,36030001,550000}]'),(371,390,1,'[{2,36020001,20},{0,15020202,4},{3,36030001,350000}]'),(371,390,2,'[{2,36020001,40},{0,15020202,6},{3,36030001,400000}]'),(371,390,3,'[{2,36020001,80},{0,15020202,9},{3,36030001,450000}]'),(371,390,4,'[{2,36020001,120},{0,15020202,12},{3,36030001,500000}]'),(371,390,5,'[{2,36020001,150},{0,15020202,14},{3,36030001,550000}]'),(371,390,6,'[{2,36020001,200},{0,15020202,16},{3,36030001,600000}]'),(391,430,1,'[{2,36020001,20},{0,15020202,4},{3,36030001,400000}]'),(391,430,2,'[{2,36020001,40},{0,15020202,6},{3,36030001,450000}]'),(391,430,3,'[{2,36020001,80},{0,15020202,9},{3,36030001,500000}]'),(391,430,4,'[{2,36020001,120},{0,15020202,12},{3,36030001,550000}]'),(391,430,5,'[{2,36020001,150},{0,15020202,14},{3,36030001,600000}]'),(391,430,6,'[{2,36020001,200},{0,15020202,16},{3,36030001,650000}]'),(431,500,1,'[{2,36020001,20},{0,15020202,4},{3,36030001,450000}]'),(431,500,2,'[{2,36020001,40},{0,15020202,6},{3,36030001,500000}]'),(431,500,3,'[{2,36020001,80},{0,15020202,9},{3,36030001,550000}]'),(431,500,4,'[{2,36020001,120},{0,15020202,12},{3,36030001,600000}]'),(431,500,5,'[{2,36020001,150},{0,15020202,14},{3,36030001,650000}]'),(431,500,6,'[{2,36020001,200},{0,15020202,16},{3,36030001,700000}]'),(501,560,1,'[{2,36020001,20},{0,15020203,2},{3,36030001,500000}]'),(501,560,2,'[{2,36020001,40},{0,15020203,3},{3,36030001,550000}]'),(501,560,3,'[{2,36020001,80},{0,15020203,4},{3,36030001,600000}]'),(501,560,4,'[{2,36020001,120},{0,15020203,5},{3,36030001,650000}]'),(501,560,5,'[{2,36020001,150},{0,15020203,6},{3,36030001,700000}]'),(501,560,6,'[{2,36020001,200},{0,15020203,7},{3,36030001,750000}]'),(561,610,1,'[{2,36020001,20},{0,15020203,2},{3,36030001,550000}]'),(561,610,2,'[{2,36020001,40},{0,15020203,3},{3,36030001,600000}]'),(561,610,3,'[{2,36020001,80},{0,15020203,4},{3,36030001,650000}]'),(561,610,4,'[{2,36020001,120},{0,15020203,5},{3,36030001,700000}]'),(561,610,5,'[{2,36020001,150},{0,15020203,6},{3,36030001,750000}]'),(561,610,6,'[{2,36020001,200},{0,15020203,7},{3,36030001,800000}]'),(611,660,1,'[{2,36020001,20},{0,15020203,2},{3,36030001,600000}]'),(611,660,2,'[{2,36020001,40},{0,15020203,3},{3,36030001,650000}]'),(611,660,3,'[{2,36020001,80},{0,15020203,4},{3,36030001,700000}]'),(611,660,4,'[{2,36020001,120},{0,15020203,5},{3,36030001,750000}]'),(611,660,5,'[{2,36020001,150},{0,15020203,6},{3,36030001,800000}]'),(611,660,6,'[{2,36020001,200},{0,15020203,7},{3,36030001,850000}]'),(661,750,1,'[{2,36020001,20},{0,15020203,2},{3,36030001,650000}]'),(661,750,2,'[{2,36020001,40},{0,15020203,3},{3,36030001,700000}]'),(661,750,3,'[{2,36020001,80},{0,15020203,4},{3,36030001,750000}]'),(661,750,4,'[{2,36020001,120},{0,15020203,5},{3,36030001,800000}]'),(661,750,5,'[{2,36020001,150},{0,15020203,6},{3,36030001,850000}]'),(661,750,6,'[{2,36020001,200},{0,15020203,7},{3,36030001,900000}]'),(751,1000,1,'[{2,36020001,20},{0,15020203,2},{3,36030001,700000}]'),(751,1000,2,'[{2,36020001,40},{0,15020203,3},{3,36030001,750000}]'),(751,1000,3,'[{2,36020001,80},{0,15020203,4},{3,36030001,800000}]'),(751,1000,4,'[{2,36020001,120},{0,15020203,5},{3,36030001,850000}]'),(751,1000,5,'[{2,36020001,150},{0,15020203,6},{3,36030001,900000}]'),(751,1000,6,'[{2,36020001,200},{0,15020203,7},{3,36030001,950000}]');
/*!40000 ALTER TABLE `base_top_pk_grade_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_top_pk_keyvalues`
--

DROP TABLE IF EXISTS `base_top_pk_keyvalues`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_top_pk_keyvalues` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '常量Id',
  `value` varchar(512) NOT NULL COMMENT '常量值',
  `about` varchar(512) NOT NULL COMMENT '常量描述@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='巅峰竞技常量配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_top_pk_keyvalues`
--

LOCK TABLES `base_top_pk_keyvalues` WRITE;
/*!40000 ALTER TABLE `base_top_pk_keyvalues` DISABLE KEYS */;
INSERT INTO `base_top_pk_keyvalues` VALUES (2,'14','赛季时长(天)'),(3,'8','开启跨服竞技需要的开服天数'),(4,'310','开启跨服竞技需要的世界等级'),(5,'4053','本服竞技场景id'),(6,'4054','跨服竞技场景id'),(7,'[{4098,4485},{5501,4505}]','本服战场出生点{X,Y}'),(8,'[{4098,4485},{5501,4505}]','跨服战场出生点{X,Y}'),(9,'90','每场竞技比赛时长(秒)'),(10,'5','每场竞技比赛准备时长(秒)'),(11,'5','开启竞技活动提前多久预告(分钟)'),(12,'3','玩家连续失败多少场匹配一次假人'),(13,'5','每轮匹配时长(s)'),(14,'4','最多匹配几轮，还匹配不到匹配假人'),(15,'100','排行榜最大长度'),(16,'115','功能开启等级'),(17,'1000','赛季玩家初始积分'),(18,'10','玩家每天可以参与匹配次数'),(19,'[{3,5},{7,6},{10,7}]','连胜传闻 格式：[{连胜次数,功能传闻id}]'),(20,'[{2,1,8},{3,1,9},{4,1,10},{5,1,11},{6,1,12}]','段位传闻 格式：[{段位,阶数,功能传闻id}]'),(21,'[{1,10},{2,25},{3,50},{4,100}]','匹配区间列表 格式：[{匹配次数，名次区间}]'),(22,'32','[弃用] ELO天梯算法K参数(通常为32)'),(23,'1','[弃用] ELO天梯算法S参数(通常为1)'),(24,'[{4279,4478},{3978,4640},{3962,4327}]','本服战场我方星灵出生点{X,Y}'),(25,'[{5308,4488},{5588,4643},{5560,4331}]','本服战场对方星灵出生点{X,Y}'),(26,'[{4279,4478},{3978,4640},{3962,4327}]','跨服战场我方星灵出生点{X,Y}'),(27,'[{5308,4488},{5588,4643},{5560,4331}]','跨服战场对方星灵出生点{X,Y}'),(28,'10','赛季排行奖励发放前几名'),(29,'7','发放赛季排行奖励需要的开服天数');
/*!40000 ALTER TABLE `base_top_pk_keyvalues` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_top_pk_match_reward`
--

DROP TABLE IF EXISTS `base_top_pk_match_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_top_pk_match_reward` (
  `min_world_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小世界等级',
  `max_world_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大世界等级',
  `match_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '匹配次数',
  `reward_list` varchar(512) NOT NULL COMMENT '奖励列表',
  PRIMARY KEY (`min_world_lv`,`max_world_lv`,`match_num`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='参与奖励配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_top_pk_match_reward`
--

LOCK TABLES `base_top_pk_match_reward` WRITE;
/*!40000 ALTER TABLE `base_top_pk_match_reward` DISABLE KEYS */;
INSERT INTO `base_top_pk_match_reward` VALUES (1,200,1,'[{0,24010001,4},{0,15020201,5},{0,18020001,5}]'),(1,200,5,'[{0,24010001,4},{0,15020201,5},{0,18020001,5}]'),(1,200,10,'[{0,24010001,4},{0,15020201,5},{0,18020001,5}]'),(201,260,1,'[{0,24010001,4},{0,15020201,5},{0,18020001,5}]'),(201,260,5,'[{0,24010001,4},{0,15020201,5},{0,18020001,5}]'),(201,260,10,'[{0,24010001,4},{0,15020201,5},{0,18020001,5}]'),(261,320,1,'[{0,24010001,6},{0,15020201,6},{0,18020001,6}]'),(261,320,5,'[{0,24010001,6},{0,15020201,6},{0,18020001,6}]'),(261,320,10,'[{0,24010001,6},{0,15020201,6},{0,18020001,6}]'),(321,350,1,'[{0,24010001,6},{0,15020201,6},{0,18020001,6}]'),(321,350,5,'[{0,24010001,6},{0,15020201,6},{0,18020001,6}]'),(321,350,10,'[{0,24010001,6},{0,15020201,6},{0,18020001,6}]'),(351,370,1,'[{0,24010001,8},{0,15020201,8},{0,18020001,8}]'),(351,370,5,'[{0,24010001,8},{0,15020201,8},{0,18020001,8}]'),(351,370,10,'[{0,24010001,8},{0,15020201,8},{0,18020001,8}]'),(371,390,1,'[{0,24010001,8},{0,15020201,8},{0,18020001,10}]'),(371,390,5,'[{0,24010001,8},{0,15020201,8},{0,18020001,10}]'),(371,390,10,'[{0,24010001,8},{0,15020201,8},{0,18020001,10}]'),(391,430,1,'[{0,24010001,10},{0,15020201,10},{0,18020001,12}]'),(391,430,5,'[{0,24010001,10},{0,15020201,10},{0,18020001,12}]'),(391,430,10,'[{0,24010001,10},{0,15020201,10},{0,18020001,12}]'),(431,500,1,'[{0,24010002,5},{0,15020202,5},{0,18020002,5}]'),(431,500,5,'[{0,24010002,5},{0,15020202,5},{0,18020002,5}]'),(431,500,10,'[{0,24010002,5},{0,15020202,5},{0,18020002,5}]'),(501,560,1,'[{0,24010002,5},{0,15020202,5},{0,18020002,6}]'),(501,560,5,'[{0,24010002,5},{0,15020202,5},{0,18020002,6}]'),(501,560,10,'[{0,24010002,5},{0,15020202,5},{0,18020002,6}]'),(561,610,1,'[{0,24010002,5},{0,15020202,5},{0,18020002,6}]'),(561,610,5,'[{0,24010002,5},{0,15020202,5},{0,18020002,6}]'),(561,610,10,'[{0,24010002,5},{0,15020202,5},{0,18020002,6}]'),(611,660,1,'[{0,24010002,6},{0,15020202,6},{0,18020002,8}]'),(611,660,5,'[{0,24010002,6},{0,15020202,6},{0,18020002,8}]'),(611,660,10,'[{0,24010002,6},{0,15020202,6},{0,18020002,8}]'),(661,750,1,'[{0,24010002,6},{0,15020202,6},{0,18020002,8}]'),(661,750,5,'[{0,24010002,6},{0,15020202,6},{0,18020002,8}]'),(661,750,10,'[{0,24010002,6},{0,15020202,6},{0,18020002,8}]'),(751,1000,1,'[{0,24010002,8},{0,15020202,8},{0,18020002,10}]'),(751,1000,5,'[{0,24010002,8},{0,15020202,8},{0,18020002,10}]'),(751,1000,10,'[{0,24010002,8},{0,15020202,8},{0,18020002,10}]');
/*!40000 ALTER TABLE `base_top_pk_match_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_top_pk_rank_reward`
--

DROP TABLE IF EXISTS `base_top_pk_rank_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_top_pk_rank_reward` (
  `min_world_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小世界等级',
  `max_world_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大世界等级',
  `min_rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小排名',
  `max_rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大排名',
  `reward_list` varchar(512) NOT NULL COMMENT '奖励列表',
  PRIMARY KEY (`min_world_lv`,`max_world_lv`,`min_rank`,`max_rank`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='排名奖励配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_top_pk_rank_reward`
--

LOCK TABLES `base_top_pk_rank_reward` WRITE;
/*!40000 ALTER TABLE `base_top_pk_rank_reward` DISABLE KEYS */;
INSERT INTO `base_top_pk_rank_reward` VALUES (0,1000,1,1,'[{0,4913003,1},{2,36020001,500},{0,17020003,3},{0,17020002,6},{0,17020001,10}]'),(0,1000,2,3,'[{0,4913002,1},{2,36020001,400},{0,17020003,3},{0,17020002,5},{0,17020001,9}]'),(0,1000,4,10,'[{0,4913001,1},{2,36020001,300},{0,17020003,2},{0,17020002,5},{0,17020001,8}]'),(0,1000,11,20,'[{2,36020001,225},{0,17020003,1},{0,17020002,4},{0,17020001,6}]'),(0,1000,21,50,'[{2,36020001,150},{0,17020003,1},{0,17020002,2},{0,17020001,4}]');
/*!40000 ALTER TABLE `base_top_pk_rank_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_top_pk_season_rewards`
--

DROP TABLE IF EXISTS `base_top_pk_season_rewards`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_top_pk_season_rewards` (
  `grade_num` tinyint(3) unsigned NOT NULL COMMENT '段位',
  `star` tinyint(3) unsigned NOT NULL COMMENT '星数',
  `rewards` varchar(2000) NOT NULL COMMENT '奖励内容',
  PRIMARY KEY (`grade_num`,`star`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='巅峰竞技 赛季奖励';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_top_pk_season_rewards`
--

LOCK TABLES `base_top_pk_season_rewards` WRITE;
/*!40000 ALTER TABLE `base_top_pk_season_rewards` DISABLE KEYS */;
INSERT INTO `base_top_pk_season_rewards` VALUES (1,1,'[{3,0,5000},{5,0,75000}]');
/*!40000 ALTER TABLE `base_top_pk_season_rewards` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_treasure`
--

DROP TABLE IF EXISTS `base_treasure`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_treasure` (
  `id` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '常量id',
  `value` varchar(255) NOT NULL COMMENT '常量',
  `note` varchar(1024) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '""' COMMENT '常量注解@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='宝藏系统模块配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_treasure`
--

LOCK TABLES `base_treasure` WRITE;
/*!40000 ALTER TABLE `base_treasure` DISABLE KEYS */;
INSERT INTO `base_treasure` VALUES (1,'125','秘境远征开启等级'),(2,'68','金币矿洞等级限制'),(3,'100','经验书馆等级限制'),(4,'0','钻石矿车免费次数'),(5,'1','经验书馆免费次数'),(6,'0','钻石矿车基本次数（移除，放在vip特权配置）'),(7,'0','经验书馆基本次数（移除，放在vip特权配置）'),(8,'3600','免费矿车定时器时间'),(9,'5','金币矿洞在线倍数'),(10,'[38300002]','金币矿洞可以使用的守护'),(11,'[38300004]','经验书馆可以使用的守护'),(12,'[1011000001,1011000003,1011000004,1011000005,1011000002]','秘境远征可以上阵的守护'),(13,'600','多少秒后自动进入在线挂机'),(14,'300','星界试炼等级'),(15,'300','金币矿洞领取时间间隔'),(16,'8600','矿洞开启时送的金币量');
/*!40000 ALTER TABLE `base_treasure` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_treasure_evaluation_main`
--

DROP TABLE IF EXISTS `base_treasure_evaluation_main`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_treasure_evaluation_main` (
  `main_reward_id` int(10) unsigned NOT NULL COMMENT '主奖励id',
  `reward_id` int(10) unsigned NOT NULL COMMENT '大奖id',
  `image_str` varchar(255) NOT NULL COMMENT '形象缩写',
  `power` int(10) unsigned NOT NULL COMMENT '显示战力',
  `kind_id` int(10) unsigned NOT NULL COMMENT '形象类型id',
  `image_id` int(10) unsigned NOT NULL COMMENT '形象id',
  `attr_list` varchar(255) NOT NULL COMMENT '属性列表（显示用）',
  `reward_type` tinyint(1) unsigned NOT NULL COMMENT '奖励格式',
  `goods_list` varchar(100) NOT NULL COMMENT '物品列表',
  `weight` int(10) unsigned NOT NULL COMMENT '大奖权重',
  PRIMARY KEY (`main_reward_id`,`reward_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='幸运鉴宝大奖配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_treasure_evaluation_main`
--

LOCK TABLES `base_treasure_evaluation_main` WRITE;
/*!40000 ALTER TABLE `base_treasure_evaluation_main` DISABLE KEYS */;
INSERT INTO `base_treasure_evaluation_main` VALUES (1,1,'lyzj',15000,5,302002,'[{1,500},{2,10000},{3,250},{4,250},{19,50},{20,50}]',1,'[{0,16030001,1}]',5),(1,2,'wsws',15000,5,302001,'[{1,500},{2,10000},{3,250},{4,250}]',1,'[{0,16030002,1}]',5),(1,3,'wsws',15000,5,302001,'[{1,500},{2,10000},{3,250},{4,250}]',1,'[{0,16030002,1}]',5),(2,1,'wsws',15000,5,302001,'[{1,500},{2,10000},{3,250},{4,250}]',1,'[{0,16030002,1}]',5),(2,2,'clzy',24000,5,301002,'[{1,600},{2,12000},{3,600},{4,600},{21,100}]',1,'[{0,16030003,1}]',5),(3,1,'clzy',24000,5,301002,'[{1,600},{2,12000},{3,600},{4,600},{21,100}]',1,'[{0,16030003,1}]',5),(4,1,'xtsq',15000,5,1610020,'[{1,500},{2,10000},{3,250},{4,250}]',1,'[{0,12010003,1}]',5),(5,1,'hssb',24000,2,240004,'[{1,600},{2,12000},{3,600},{4,600},{22,100}]',1,'[{0,24030003,1}]',5),(6,1,'mwhq',21000,6,400102,'[{1,700},{2,14000},{3,350},{4,350}]',1,'[{0,40030008,1}]',5),(7,1,'slyd',14400,7,183002,'[{1,480},{2,9600},{15,240},{16,240}]',1,'[{0,18070002,1}]',5),(8,1,'mwhq',21000,6,400102,'[{1,700},{2,14000},{3,350},{4,350}]',1,'[{0, 40030008, 1}]',5),(8,2,'lyzj',15000,3,220006,'[{1,500},{2,10000},{3,250},{4,250},{19,50},{20,50}]',1,'[{0,22030005,1}]',5),(8,3,'wsws',15000,4,181001,'[{1,500},{2,10000},{3,250},{4,250}]',1,'[{0,18040002,1}]',5),(9,1,'jlwz',15000,4,181002,'[{1,500},{2,10000},{3,250},{4,250}]',1,'[{0,18040004,1}]',5),(10,1,'mwbt',16500,6,400101,'[{1,550},{2,11000},{3,275},{4,275}]',1,'[{0,40030007,1}]',5),(11,1,'hjbb',21600,7,183003,'[{1,720},{2,14400},{15,360},{16,360}]',1,'[{0,18070003,1}]',5),(12,1,'chfb',15000,5,1610030,'[{1,1050},{2,21000},{3,525},{4,525}]',1,'[{0,16030003,1}]',5),(13,1,'jwzj',15000,3,220007,'[{1,500},{2,10000},{3,250},{4,250},{19,50},{20,50}]',1,'[{0,22030006,1}]',5),(14,1,'lyzy',30000,1,200006,'[{1,1200},{2,24000},{3,300},{4,300},{21,100}]',1,'[{0,20030005,1}]',5),(15,1,'clhz',30000,2,240005,'[{1,1200},{2,24000},{3,300},{4,300},{21,100}]',1,'[{0,24030004,1}]',5);
/*!40000 ALTER TABLE `base_treasure_evaluation_main` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_treasure_evaluation_weight`
--

DROP TABLE IF EXISTS `base_treasure_evaluation_weight`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_treasure_evaluation_weight` (
  `main_reward_id` int(10) unsigned NOT NULL COMMENT '主奖励id',
  `reward_id` int(10) unsigned NOT NULL COMMENT '奖励id',
  `reward_type` tinyint(1) unsigned NOT NULL COMMENT '奖励格式',
  `goods_list` varchar(100) NOT NULL COMMENT '物品列表',
  `weight` int(10) unsigned NOT NULL COMMENT '权重',
  PRIMARY KEY (`main_reward_id`,`reward_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='幸运鉴宝普通奖励配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_treasure_evaluation_weight`
--

LOCK TABLES `base_treasure_evaluation_weight` WRITE;
/*!40000 ALTER TABLE `base_treasure_evaluation_weight` DISABLE KEYS */;
INSERT INTO `base_treasure_evaluation_weight` VALUES (1,4,1,'[{0,20020004,1}]',50),(1,5,1,'[{0,20020002,1}]',50),(1,6,1,'[{0,24020001,1}]',50),(1,7,1,'[{0,24020002,1}]',50),(1,8,1,'[{0,20020001,2}]',200),(1,9,1,'[{0,20020002,2}]',65),(1,10,1,'[{0,24020001,2}]',200),(1,11,1,'[{0,24020002,2}]',65),(1,12,1,'[{0,20020004,2}]',200),(1,13,1,'[{0,20020002,2}]',65),(2,3,1,'[{0,24020001,2}]',50),(2,4,1,'[{0,24020002,2}]',50),(2,5,1,'[{0,20020001,2}]',50),(2,6,1,'[{0,20020002,2}]',50),(2,7,1,'[{0,24020001,2}]',200),(2,8,1,'[{0,24020002,2}]',65),(2,9,1,'[{0,20020001,3}]',135),(2,10,1,'[{0,20020002,3}]',130),(2,11,1,'[{0,24020001,3}]',200),(2,12,1,'[{0,24020004,3}]',65),(3,2,1,'[{0,20020001,3}]',50),(3,3,1,'[{0,20020002,3}]',50),(3,4,1,'[{0,24020001,3}]',50),(3,5,1,'[{0,24020002,3}]',50),(3,6,1,'[{0,20020003,4}]',200),(3,7,1,'[{0,20020002,4}]',65),(3,8,1,'[{0,24020001,4}]',200),(3,9,1,'[{0,24020002,4}]',65),(3,10,1,'[{0,20020001,4}]',200),(3,11,1,'[{0,20020003,4}]',65),(4,2,1,'[{0,24020001,4}]',50),(4,3,1,'[{0,24020002,4}]',50),(4,4,1,'[{0,20020001,5}]',50),(4,5,1,'[{0,20020002,5}]',50),(4,6,1,'[{0,24020001,5}]',200),(4,7,1,'[{0,24020004,5}]',65),(4,8,1,'[{0,20020001,5}]',200),(4,9,1,'[{0,20020002,5}]',65),(4,10,1,'[{0,24020001,5}]',135),(4,11,1,'[{0,24020003,5}]',130),(5,2,1,'[{0,20020001,6}]',50),(5,3,1,'[{0,20020002,6}]',50),(5,4,1,'[{0,24020001,6}]',50),(5,5,1,'[{0,24020002,6}]',50),(5,6,1,'[{0,20020001,6}]',200),(5,7,1,'[{0,20020002,6}]',65),(5,8,1,'[{0,24020001,6}]',200),(5,9,1,'[{0,24020002,6}]',65),(5,10,1,'[{0,20020001,7}]',135),(5,11,1,'[{0,20020002,7}]',130),(6,2,1,'[{0,24020001,7}]',50),(6,3,1,'[{0,24020002,7}]',50),(6,4,1,'[{0,20020001,7}]',50),(6,5,1,'[{0,20020002,7}]',50),(6,6,1,'[{0,24020001,7}]',200),(6,7,1,'[{0,24020002,7}]',65),(6,8,1,'[{0,20020001,8}]',200),(6,9,1,'[{0,20020002,8}]',65),(6,10,1,'[{0,24020001,8}]',200),(6,11,1,'[{0,24020002,8}]',65),(7,2,1,'[{0,20020001,8}]',50),(7,3,1,'[{0,20020002,8}]',50),(7,4,1,'[{0,24020001,8}]',50),(7,5,1,'[{0,24020002,8}]',50),(7,6,1,'[{0,20020001,9}]',200),(7,7,1,'[{0,20020002,9}]',65),(7,8,1,'[{0,24020001,9}]',200),(7,9,1,'[{0,24020002,9}]',65),(7,10,1,'[{0,20020001,9}]',200),(7,11,1,'[{0,20020002,9}]',65),(8,4,1,'[{0,24020001,9}]',80),(8,5,1,'[{0,24020002,9}]',80),(8,6,1,'[{0,20020001,10}]',80),(8,7,1,'[{0,20020002,10}]',80),(8,8,1,'[{0,24020001,10}]',175),(8,9,1,'[{0,24020002,10}]',50),(8,10,1,'[{0,20020001,10}]',175),(8,11,1,'[{0,20020002,10}]',50),(8,12,1,'[{0,24020001,10}]',175),(8,13,1,'[{0,24020002,10}]',50),(9,2,1,'[{0,20020001,11}]',50),(9,3,1,'[{0,20020002,11}]',50),(9,4,1,'[{0,24020001,11}]',50),(9,5,1,'[{0,24020002,11}]',50),(9,6,1,'[{0,20020001,11}]',200),(9,7,1,'[{0,20020002,11}]',65),(9,8,1,'[{0,24020001,11}]',200),(9,9,1,'[{0,24020002,11}]',65),(9,10,1,'[{0,20020001,12}]',200),(9,11,1,'[{0,20020002,12}]',65),(10,2,1,'[{0,24020001,12}]',50),(10,3,1,'[{0,24020002,12}]',50),(10,4,1,'[{0,20020001,12}]',50),(10,5,1,'[{0,20020002,12}]',50),(10,6,1,'[{0,24020001,12}]',200),(10,7,1,'[{0,24020002,12}]',65),(10,8,1,'[{0,20020001,13}]',135),(10,9,1,'[{0,20020002,13}]',130),(10,10,1,'[{0,24020001,13}]',200),(10,11,1,'[{0,24020002,13}]',65),(11,2,1,'[{0,20020001,13}]',50),(11,3,1,'[{0,20020002,13}]',50),(11,4,1,'[{0,24020001,13}]',50),(11,5,1,'[{0,24020002,13}]',50),(11,6,1,'[{0,20020001,14}]',200),(11,7,1,'[{0,20020002,14}]',65),(11,8,1,'[{0,24020001,14}]',200),(11,9,1,'[{0,24020002,14}]',65),(11,10,1,'[{0,20020001,14}]',200),(11,11,1,'[{0,20020002,14}]',65),(12,2,1,'[{0,24020001,14}]',50),(12,3,1,'[{0,24020002,14}]',50),(12,4,1,'[{0,20020001,15}]',50),(12,5,1,'[{0,20020002,15}]',50),(12,6,1,'[{0,24020001,15}]',200),(12,7,1,'[{0,24020002,15}]',65),(12,8,1,'[{0,20020001,15}]',200),(12,9,1,'[{0,20020002,15}]',65),(12,10,1,'[{0,24020001,15}]',135),(12,11,1,'[{0,24020002,15}]',130),(13,2,1,'[{0,20020001,16}]',50),(13,3,1,'[{0,20020002,16}]',50),(13,4,1,'[{0,24020001,16}]',50),(13,5,1,'[{0,24020002,16}]',50),(13,6,1,'[{0,20020001,16}]',200),(13,7,1,'[{0,20020002,16}]',65),(13,8,1,'[{0,24020001,16}]',200),(13,9,1,'[{0,24020002,16}]',65),(13,10,1,'[{0,20020001,17}]',135),(13,11,1,'[{0,20020002,17}]',130),(14,2,1,'[{0,24020001,17}]',50),(14,3,1,'[{0,24020002,17}]',50),(14,4,1,'[{0,20020001,17}]',50),(14,5,1,'[{0,20020002,17}]',50),(14,6,1,'[{0,24020001,17}]',200),(14,7,1,'[{0,24020002,17}]',65),(14,8,1,'[{0,20020001,18}]',200),(14,9,1,'[{0,20020002,18}]',65),(14,10,1,'[{0,24020001,18}]',200),(14,11,1,'[{0,24020002,18}]',65),(15,2,1,'[{0,20020001,18}]',50),(15,3,1,'[{0,20020002,18}]',50),(15,4,1,'[{0,24020001,18}]',50),(15,5,1,'[{0,24020002,18}]',50),(15,6,1,'[{0,20020001,19}]',200),(15,7,1,'[{0,20020002,19}]',65),(15,8,1,'[{0,24020001,19}]',200),(15,9,1,'[{0,24020002,19}]',65),(15,10,1,'[{0,20020001,19}]',200),(15,11,1,'[{0,20020002,19}]',65);
/*!40000 ALTER TABLE `base_treasure_evaluation_weight` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_treasure_goldmine_lv_cfg`
--

DROP TABLE IF EXISTS `base_treasure_goldmine_lv_cfg`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_treasure_goldmine_lv_cfg` (
  `lv` smallint(5) unsigned NOT NULL COMMENT '等级',
  `conditions` varchar(255) NOT NULL COMMENT '条件',
  `cost` varchar(255) NOT NULL COMMENT '消耗',
  `max_storage` int(11) unsigned NOT NULL COMMENT '每次领取金币数',
  `receive_times` tinyint(3) unsigned NOT NULL COMMENT '每日领取次数',
  `interval_time` mediumint(8) unsigned NOT NULL COMMENT '领取时间间隔',
  `uplv_reward` int(11) unsigned NOT NULL COMMENT '升级赠送金币数量',
  PRIMARY KEY (`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='宝藏金币矿洞等级配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_treasure_goldmine_lv_cfg`
--

LOCK TABLES `base_treasure_goldmine_lv_cfg` WRITE;
/*!40000 ALTER TABLE `base_treasure_goldmine_lv_cfg` DISABLE KEYS */;
INSERT INTO `base_treasure_goldmine_lv_cfg` VALUES (0,'[{lv,190}]','[]',25000,6,1200,50000),(1,'[{lv,230}]','[{2,36020001,5}]',43750,6,1200,87500),(2,'[{lv,250}]','[{2,36020001,5}]',76786,6,1200,153571),(3,'[{lv,285}]','[{2,36020001,8}]',165227,6,1200,330455),(4,'[{lv,315}]','[{2,36020001,10}]',224643,6,1200,449286),(5,'[{lv,335}]','[{2,36020001,15}]',243750,6,1200,487500),(6,'[{lv,355}]','[{2,36020001,20}]',258146,6,1200,516292),(7,'[{lv,370}]','[{2,36020001,30}]',281938,6,1200,563875),(8,'[{lv,380}]','[{2,36020001,40}]',308146,6,1200,616292),(9,'[{lv,395}]','[{2,36020001,50}]',339125,6,1200,678250),(10,'[{lv,410}]','[{2,36020001,60}]',372208,6,1200,744417),(11,'[{lv,435}]','[{2,36020001,70}]',437250,6,1200,874500),(12,'[{lv,455}]','[{2,36020001,80}]',508125,6,1200,1016250),(13,'[{lv,475}]','[{2,36020001,90}]',602188,6,1200,1204375),(14,'[{lv,500}]','[{2,36020001,100}]',732875,6,1200,1465750),(15,'[{lv,520}]','[{2,36020001,110}]',849531,6,1200,1699063),(16,'[{lv,540}]','[{2,36020001,120}]',1007594,6,1200,2015188),(17,'[{lv,555}]','[{2,36020001,130}]',1177063,6,1200,2354125),(18,'[{lv,570}]','[{2,36020001,140}]',1344500,6,1200,2689000),(19,'[{lv,585}]','[{2,36020001,150}]',1538000,6,1200,3076000),(20,'[{lv,600}]','[{2,36020001,160}]',1732625,6,1200,3465250),(21,'[{lv,615}]','[{2,36020001,170}]',1955188,6,1200,3910375),(22,'[{lv,630}]','[{2,36020001,180}]',2177000,6,1200,4354000),(23,'[{lv,645}]','[{2,36020001,190}]',2428625,6,1200,4857250),(24,'[{lv,660}]','[{2,36020001,200}]',2677625,6,1200,5355250),(25,'[{lv,675}]','[{2,36020001,210}]',2958313,6,1200,5916625),(26,'[{lv,690}]','[{2,36020001,220}]',3234500,6,1200,6469000),(27,'[{lv,705}]','[{2,36020001,230}]',3544250,6,1200,7088500),(28,'[{lv,720}]','[{2,36020001,240}]',3847625,6,1200,7695250),(29,'[{lv,735}]','[{2,36020001,250}]',4186438,6,1200,8372875),(30,'[{lv,750}]','[{2,36020001,260}]',4517000,6,1200,9034000);
/*!40000 ALTER TABLE `base_treasure_goldmine_lv_cfg` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_treasure_guardian`
--

DROP TABLE IF EXISTS `base_treasure_guardian`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_treasure_guardian` (
  `guardian_id` int(11) unsigned NOT NULL COMMENT '守护id',
  `guardian_describe` varchar(256) NOT NULL COMMENT '守护描述@lang@',
  `guardian_buff` varchar(255) NOT NULL COMMENT '守护buff',
  `guardian_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间限制',
  PRIMARY KEY (`guardian_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_treasure_guardian`
--

LOCK TABLES `base_treasure_guardian` WRITE;
/*!40000 ALTER TABLE `base_treasure_guardian` DISABLE KEYS */;
INSERT INTO `base_treasure_guardian` VALUES (38300002,'金矿加成：矿洞金币产出+50%','[{2,50}]',2592000),(38300003,'道具掉率+50%','[{3,50}]',2592000),(38300004,'书馆加成：书馆经验产出+60%','[{1,60}]',2592000),(1011000001,'远征增益：经验产出+50%','[{1,50}]',2592000),(1011000002,'远征增益：暂无远征增益','[{4,50}]',2592000),(1011000003,'远征增益：经验产出+75%','[{1,75}]',2592000),(1011000004,'远征增益：暂无远征增益','[{4,10}]',2592000),(1011000005,'远征增益：经验产出+50%','[{1,50}]',1800);
/*!40000 ALTER TABLE `base_treasure_guardian` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_treasure_hunt`
--

DROP TABLE IF EXISTS `base_treasure_hunt`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_treasure_hunt` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `key` varchar(255) NOT NULL DEFAULT '' COMMENT 'key',
  `value` varchar(255) NOT NULL DEFAULT '0' COMMENT '值',
  `desc` varchar(255) NOT NULL DEFAULT '' COMMENT '描述',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='寻宝常量配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_treasure_hunt`
--

LOCK TABLES `base_treasure_hunt` WRITE;
/*!40000 ALTER TABLE `base_treasure_hunt` DISABLE KEYS */;
INSERT INTO `base_treasure_hunt` VALUES (1,'free_treasure_hunt_open_lv','45','免费寻宝开启等级'),(2,'equip_treasure_hunt_open_lv','45','装备寻宝开启等级'),(4,'equip_treasure_hunt_cost','38180001','装备寻宝消耗物品类型id'),(10,'person_treasure_hunt_record_len','30','玩家个人抽奖记录长度'),(11,'qf_treasure_hunt_record_len','20','全服抽奖记录长度'),(15,'treasure_hunt_seal_soul_free_time','172800','免费魂珠寻宝间隔，单位秒'),(16,'treasure_hunt_free_time','172800','免费寻宝时间间隔，单位秒'),(29,'free_treasure_hunt_types','[10,20,30]','免费的寻宝类型（后续有免费寻宝的再往列表里面加）'),(30,'first_treasure_cd','5','第一次免费抽奖cd（从开启功能时开始算）'),(31,'first_treasure_reward','[{1,[{50,{0,1010010331,1}}]},{2,[{50,{0,1010020331,1}}]},{3,[{50,{0,1010030331,1}}]},{4,[{50,{0,1010040331,1}}]}]','第一次免费抽奖奖励'),(32,'best_reward_rare','100','稀有度大于等于该值的奖励为绝品奖励');
/*!40000 ALTER TABLE `base_treasure_hunt` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_treasure_hunt_limit`
--

DROP TABLE IF EXISTS `base_treasure_hunt_limit`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_treasure_hunt_limit` (
  `htype` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '寻宝类型',
  `stype` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '宝物分类',
  `lim_obj` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '限制对象',
  `lim_times` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '限制次数',
  `min_times` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '初次抽中最小次数',
  `max_times` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '最大抽中次数',
  `reset_type` tinyint(2) unsigned NOT NULL DEFAULT '1' COMMENT '重置类型',
  `stype_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT '更新抽中次数的类型',
  PRIMARY KEY (`htype`,`stype`,`lim_obj`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='寻宝奖励限制配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_treasure_hunt_limit`
--

LOCK TABLES `base_treasure_hunt_limit` WRITE;
/*!40000 ALTER TABLE `base_treasure_hunt_limit` DISABLE KEYS */;
INSERT INTO `base_treasure_hunt_limit` VALUES (4,2,2,1,150,10000,1,'[2]'),(4,3,2,1,450,500,2,'[3]'),(11,4,2,1,50,300,1,'[4]'),(11,5,2,1,100,500,1,'[5]'),(11,6,1,1,200,3500,1,'[6]'),(11,6,2,1,400,1000,1,'[6]'),(11,7,1,1,200,6000,1,'[7]'),(11,7,2,1,550,800,1,'[7]'),(11,8,2,1,1000,10000,1,'[8]'),(11,9,2,1,1000,10000,1,'[9]'),(11,10,1,1,300,8000,1,'[10]'),(11,10,2,1,300,1500,1,'[10]'),(11,99,2,1,100,100,1,'[99]'),(21,11,2,1,250,1300,1,'[11]'),(21,12,2,1,250,1500,1,'[12]'),(31,11,2,1,250,1300,1,'[11]'),(31,12,2,1,250,1500,1,'[12]');
/*!40000 ALTER TABLE `base_treasure_hunt_limit` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_treasure_hunt_lucky`
--

DROP TABLE IF EXISTS `base_treasure_hunt_lucky`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_treasure_hunt_lucky` (
  `id` tinyint(3) unsigned NOT NULL COMMENT '幸运类型',
  `max_lucky` smallint(5) unsigned NOT NULL COMMENT '幸运值上限',
  `ratio_list` varchar(255) NOT NULL COMMENT '幸运值满提供权重加成',
  `timer_add` varchar(255) NOT NULL COMMENT '定时增加幸运值',
  `free_add` tinyint(3) unsigned NOT NULL COMMENT '免费抽奖幸运值',
  `pay_add` tinyint(3) unsigned NOT NULL COMMENT '付费抽奖幸运值',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='寻宝幸运值配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_treasure_hunt_lucky`
--

LOCK TABLES `base_treasure_hunt_lucky` WRITE;
/*!40000 ALTER TABLE `base_treasure_hunt_lucky` DISABLE KEYS */;
INSERT INTO `base_treasure_hunt_lucky` VALUES (10,500,'[{6,300},{7,300},{8,300}, {9,300},{10,300}]','[300,1]',1,1),(20,500,'[{10,300},{11,300},{12,300}]','[300,1]',1,1),(30,500,'[{10,300},{11,300},{12,300}]','[300,1]',1,1);
/*!40000 ALTER TABLE `base_treasure_hunt_lucky` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_treasure_hunt_reward`
--

DROP TABLE IF EXISTS `base_treasure_hunt_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_treasure_hunt_reward` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `conditions` varchar(512) NOT NULL DEFAULT '[]' COMMENT '条件',
  `htype` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '寻宝类型',
  `stype` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '宝物分类',
  `weight` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '抽中权重',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励物品id',
  `goods_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励物品数量',
  `is_tv` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '传闻',
  `is_rare` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否稀有',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='寻宝奖励配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_treasure_hunt_reward`
--

LOCK TABLES `base_treasure_hunt_reward` WRITE;
/*!40000 ALTER TABLE `base_treasure_hunt_reward` DISABLE KEYS */;
INSERT INTO `base_treasure_hunt_reward` VALUES (4000,'[]',3,1,60,5201012,1,0,0),(4001,'[]',3,1,60,5201022,1,0,0),(4002,'[]',3,1,60,5201032,1,0,0),(4003,'[]',3,1,60,5201042,1,0,0),(4004,'[{stone_dungeon,8}]',3,1,60,5201052,1,0,0),(4005,'[{stone_dungeon,12}]',3,1,60,5201062,1,0,0),(4006,'[{stone_dungeon,16}]',3,1,60,5201072,1,0,0),(4007,'[{stone_dungeon,20}]',3,1,60,5201082,1,0,0),(4008,'[{stone_dungeon,24}]',3,1,60,5201092,1,0,0),(4009,'[{stone_dungeon,28}]',3,1,60,5201102,1,0,0),(4010,'[{stone_dungeon,4}]',3,1,60,5201142,1,0,0),(4011,'[{stone_dungeon,32}]',3,1,60,5201152,1,0,0),(4012,'[{stone_dungeon,42}]',3,1,60,5201162,1,0,0),(4013,'[{stone_dungeon,36}]',3,1,60,5201172,1,0,0),(4014,'[{stone_dungeon,50}]',3,1,60,5201182,1,0,0),(4015,'[{stone_dungeon,60}]',3,1,60,5201192,1,0,0),(4016,'[]',3,1,1,5201013,1,1,0),(4017,'[]',3,1,1,5201023,1,1,0),(4018,'[]',3,1,1,5201033,1,1,0),(4019,'[]',3,1,1,5201043,1,1,0),(4020,'[{stone_dungeon,8}]',3,1,1,5201053,1,1,0),(4021,'[{stone_dungeon,12}]',3,1,1,5201063,1,1,0),(4022,'[{stone_dungeon,16}]',3,1,1,5201073,1,1,0),(4023,'[{stone_dungeon,20}]',3,1,1,5201083,1,1,0),(4024,'[{stone_dungeon,24}]',3,1,1,5201093,1,1,0),(4025,'[{stone_dungeon,28}]',3,1,1,5201103,1,1,0),(4026,'[{stone_dungeon,4}]',3,1,1,5201143,1,1,0),(4027,'[{stone_dungeon,32}]',3,1,1,5201153,1,1,0),(4028,'[{stone_dungeon,42}]',3,1,1,5201163,1,1,0),(4029,'[{stone_dungeon,36}]',3,1,1,5201173,1,1,0),(4030,'[{stone_dungeon,50}]',3,1,1,5201183,1,1,0),(4031,'[{stone_dungeon,60}]',3,1,1,5201193,1,1,0),(4032,'[]',4,1,280,5201012,1,0,0),(4033,'[]',4,1,280,5201022,1,0,0),(4034,'[]',4,1,280,5201032,1,0,0),(4035,'[]',4,1,280,5201042,1,0,0),(4036,'[{stone_dungeon,8}]',4,1,280,5201052,1,0,0),(4037,'[{stone_dungeon,12}]',4,1,280,5201062,1,0,0),(4038,'[{stone_dungeon,16}]',4,1,280,5201072,1,0,0),(4039,'[{stone_dungeon,20}]',4,1,280,5201082,1,0,0),(4040,'[{stone_dungeon,24}]',4,1,280,5201092,1,0,0),(4041,'[{stone_dungeon,28}]',4,1,280,5201102,1,0,0),(4042,'[{stone_dungeon,4}]',4,1,280,5201142,1,0,0),(4043,'[{stone_dungeon,32}]',4,1,280,5201152,1,0,0),(4044,'[{stone_dungeon,42}]',4,1,280,5201162,1,0,0),(4045,'[{stone_dungeon,36}]',4,1,280,5201172,1,0,0),(4046,'[{stone_dungeon,50}]',4,1,280,5201182,1,0,0),(4047,'[{stone_dungeon,60}]',4,1,280,5201192,1,0,0),(4048,'[{is_guarantee,1}]',4,1,30,5201013,1,1,0),(4049,'[{is_guarantee,1}]',4,1,30,5201023,1,1,0),(4050,'[{is_guarantee,1}]',4,1,30,5201033,1,1,0),(4051,'[{is_guarantee,1}]',4,1,30,5201043,1,1,0),(4052,'[{stone_dungeon,8},{is_guarantee,1}]',4,1,30,5201053,1,1,0),(4053,'[{stone_dungeon,12},{is_guarantee,1}]',4,1,30,5201063,1,1,0),(4054,'[{stone_dungeon,16},{is_guarantee,1}]',4,1,30,5201073,1,1,0),(4055,'[{stone_dungeon,20},{is_guarantee,1}]',4,1,30,5201083,1,1,0),(4056,'[{stone_dungeon,24},{is_guarantee,1}]',4,1,30,5201093,1,1,0),(4057,'[{stone_dungeon,28},{is_guarantee,1}]',4,1,30,5201103,1,1,0),(4058,'[{stone_dungeon,4},{is_guarantee,1}]',4,1,30,5201143,1,1,0),(4059,'[{stone_dungeon,32},{is_guarantee,1}]',4,1,30,5201153,1,1,0),(4060,'[{stone_dungeon,42},{is_guarantee,1}]',4,1,30,5201163,1,1,0),(4061,'[{stone_dungeon,36},{is_guarantee,1}]',4,1,30,5201173,1,1,0),(4062,'[{stone_dungeon,50},{is_guarantee,1}]',4,1,30,5201183,1,1,0),(4063,'[{stone_dungeon,60},{is_guarantee,1}]',4,1,30,5201193,1,1,0),(4064,'[]',4,2,3,5201014,1,1,0),(4065,'[]',4,2,3,5201024,1,1,0),(4066,'[]',4,2,3,5201034,1,1,0),(4067,'[]',4,2,3,5201044,1,1,0),(4068,'[{stone_dungeon,8}]',4,2,3,5201054,1,1,0),(4069,'[{stone_dungeon,12}]',4,2,3,5201064,1,1,0),(4070,'[{stone_dungeon,16}]',4,2,3,5201074,1,1,0),(4071,'[{stone_dungeon,20}]',4,2,3,5201084,1,1,0),(4072,'[{stone_dungeon,24}]',4,2,3,5201094,1,1,0),(4073,'[{stone_dungeon,28}]',4,2,3,5201104,1,1,0),(4074,'[{stone_dungeon,4}]',4,2,3,5201144,1,1,0),(4075,'[{stone_dungeon,32}]',4,2,3,5201154,1,1,0),(4076,'[{stone_dungeon,42}]',4,2,3,5201164,1,1,0),(4077,'[{stone_dungeon,36}]',4,2,3,5201174,1,1,0),(4078,'[{stone_dungeon,50}]',4,2,3,5201184,1,1,0),(4079,'[{stone_dungeon,60}]',4,2,3,5201194,1,1,0),(4080,'[]',4,3,2,5202015,1,1,0),(4081,'[]',4,3,2,5202025,1,1,0),(11001,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,1,2100,11020001,1,0,0),(11002,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,1,2100,20060001,1,0,0),(11003,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,1,1600,38260001,1,0,0),(11004,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,1,0,38260001,1,0,0),(11005,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,1,0,38260001,1,0,0),(11006,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,1,0,38260001,1,0,0),(11007,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,1,0,38260001,1,0,0),(11008,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,1,0,38260001,1,0,0),(11009,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,1,0,38260001,1,0,0),(11010,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,3,300,37020002,1,0,0),(11011,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,3,800,32010033,1,0,0),(11012,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,3,100,32010034,1,0,0),(11013,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,3,0,37020002,1,0,0),(11014,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,3,0,37020002,1,0,0),(11015,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,3,0,37020002,1,0,0),(11016,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,3,0,37020002,1,0,0),(11017,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,3,17,14010104,1,0,0),(11018,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,3,17,14020204,1,0,0),(11019,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,3,17,14010304,1,0,0),(11020,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,3,17,14020404,1,0,0),(11021,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,3,0,14010504,1,0,0),(11022,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,3,0,14020604,1,0,0),(11023,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,3,16,14010704,1,0,0),(11024,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,3,16,14020804,1,0,0),(11025,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,3,84,14010102,1,0,0),(11026,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,3,84,14020202,1,0,0),(11027,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,3,83,14010302,1,0,0),(11028,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,3,83,14020402,1,0,0),(11029,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,3,0,14010502,1,0,0),(11030,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,3,0,14020602,1,0,0),(11031,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,3,83,14010702,1,0,0),(11032,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,3,83,14020802,1,0,0),(11033,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,3,234,14010101,1,0,0),(11034,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,3,234,14020201,1,0,0),(11035,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,3,233,14010301,1,0,0),(11036,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,3,233,14020401,1,0,0),(11037,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,3,0,14010501,1,0,0),(11038,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,3,0,14020601,1,0,0),(11039,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,3,233,14010701,1,0,0),(11040,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,3,233,14020801,1,0,0),(11041,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,3,0,14020801,1,0,0),(11042,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,3,0,14020801,1,0,0),(11043,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,3,0,14020801,1,0,0),(11044,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,3,0,14020801,1,0,0),(11045,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,3,0,14020801,1,0,0),(11046,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,3,0,14020801,1,0,0),(11047,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,3,0,14020801,1,0,0),(11048,'[{lv,[1,1000]},{career,1},{is_guarantee,0},{free_can_get,0}]',11,10,10,53010103,1,1,101),(11049,'[{lv,[1,1000]},{career,2},{is_guarantee,0},{free_can_get,0}]',11,10,10,53010203,1,1,101),(11050,'[{lv,[1,1000]},{career,4},{is_guarantee,0},{free_can_get,0}]',11,10,10,53010403,1,1,101),(11051,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,0}]',11,6,15,1005000731,1,1,100),(11052,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,0}]',11,7,15,1009000731,1,1,100),(11053,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,0}]',11,8,1,1005000732,1,1,100),(11054,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,0}]',11,9,1,1009000732,1,1,100),(11055,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,2,120,17020001,1,1,1),(11056,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,2,100,17020002,1,1,1),(11057,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,2,80,17020003,1,1,1),(11058,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,2,50,17020004,1,1,1),(11059,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,2,120,16010001,1,1,1),(11060,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,2,100,16010002,1,1,1),(11061,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,2,80,16010003,1,1,1),(11062,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,2,50,16010004,1,1,1),(11063,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,2,0,16010001,1,1,1),(11064,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',11,2,0,16010002,1,1,1),(11065,'[{lv,[1,2]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002010132,1,1,1),(11066,'[{lv,[1,2]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002020132,1,1,1),(11067,'[{lv,[1,2]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002030132,1,1,1),(11068,'[{lv,[1,2]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002040132,1,1,1),(11069,'[{lv,[1,2]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004010132,1,1,1),(11070,'[{lv,[1,2]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004020132,1,1,1),(11071,'[{lv,[1,2]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004030132,1,1,1),(11072,'[{lv,[1,2]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004040132,1,1,1),(11073,'[{lv,[1,2]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006010132,1,1,1),(11074,'[{lv,[1,2]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006020132,1,1,1),(11075,'[{lv,[1,2]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006030132,1,1,1),(11076,'[{lv,[1,2]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006040132,1,1,1),(11077,'[{lv,[1,2]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008010132,1,1,1),(11078,'[{lv,[1,2]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008020132,1,1,1),(11079,'[{lv,[1,2]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008030132,1,1,1),(11080,'[{lv,[1,2]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008040132,1,1,1),(11081,'[{lv,[1,2]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010010132,1,1,1),(11082,'[{lv,[1,2]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010020132,1,1,1),(11083,'[{lv,[1,2]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010030132,1,1,1),(11084,'[{lv,[1,2]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010040132,1,1,1),(11085,'[{lv,[1,2]},{career,1},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001010132,1,1,1),(11086,'[{lv,[1,2]},{career,2},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001020132,1,1,1),(11087,'[{lv,[1,2]},{career,3},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001030132,1,1,1),(11088,'[{lv,[1,2]},{career,4},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001040132,1,1,1),(11089,'[{lv,[3,4]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002010232,1,1,1),(11090,'[{lv,[3,4]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002020232,1,1,1),(11091,'[{lv,[3,4]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002030232,1,1,1),(11092,'[{lv,[3,4]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002040232,1,1,1),(11093,'[{lv,[3,4]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004010232,1,1,1),(11094,'[{lv,[3,4]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004020232,1,1,1),(11095,'[{lv,[3,4]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004030232,1,1,1),(11096,'[{lv,[3,4]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004040232,1,1,1),(11097,'[{lv,[3,4]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006010232,1,1,1),(11098,'[{lv,[3,4]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006020232,1,1,1),(11099,'[{lv,[3,4]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006030232,1,1,1),(11100,'[{lv,[3,4]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006040232,1,1,1),(11101,'[{lv,[3,4]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008010232,1,1,1),(11102,'[{lv,[3,4]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008020232,1,1,1),(11103,'[{lv,[3,4]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008030232,1,1,1),(11104,'[{lv,[3,4]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008040232,1,1,1),(11105,'[{lv,[3,4]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010010232,1,1,1),(11106,'[{lv,[3,4]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010020232,1,1,1),(11107,'[{lv,[3,4]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010030232,1,1,1),(11108,'[{lv,[3,4]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010040232,1,1,1),(11109,'[{lv,[3,4]},{career,1},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001010232,1,1,1),(11110,'[{lv,[3,4]},{career,2},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001020232,1,1,1),(11111,'[{lv,[3,4]},{career,3},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001030232,1,1,1),(11112,'[{lv,[3,4]},{career,4},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001040232,1,1,1),(11113,'[{lv,[5,6]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002010332,1,1,1),(11114,'[{lv,[5,6]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002020332,1,1,1),(11115,'[{lv,[5,6]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002030332,1,1,1),(11116,'[{lv,[5,6]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002040332,1,1,1),(11117,'[{lv,[5,6]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004010332,1,1,1),(11118,'[{lv,[5,6]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004020332,1,1,1),(11119,'[{lv,[5,6]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004030332,1,1,1),(11120,'[{lv,[5,6]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004040332,1,1,1),(11121,'[{lv,[5,6]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006010332,1,1,1),(11122,'[{lv,[5,6]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006020332,1,1,1),(11123,'[{lv,[5,6]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006030332,1,1,1),(11124,'[{lv,[5,6]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006040332,1,1,1),(11125,'[{lv,[5,6]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008010332,1,1,1),(11126,'[{lv,[5,6]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008020332,1,1,1),(11127,'[{lv,[5,6]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008030332,1,1,1),(11128,'[{lv,[5,6]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008040332,1,1,1),(11129,'[{lv,[5,6]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010010332,1,1,1),(11130,'[{lv,[5,6]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010020332,1,1,1),(11131,'[{lv,[5,6]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010030332,1,1,1),(11132,'[{lv,[5,6]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010040332,1,1,1),(11133,'[{lv,[5,6]},{career,1},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001010332,1,1,1),(11134,'[{lv,[5,6]},{career,2},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001020332,1,1,1),(11135,'[{lv,[5,6]},{career,3},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001030332,1,1,1),(11136,'[{lv,[5,6]},{career,4},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001040332,1,1,1),(11137,'[{lv,[7,179]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002010432,1,1,1),(11138,'[{lv,[7,179]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002020432,1,1,1),(11139,'[{lv,[7,179]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002030432,1,1,1),(11140,'[{lv,[7,179]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002040432,1,1,1),(11141,'[{lv,[7,179]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004010432,1,1,1),(11142,'[{lv,[7,179]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004020432,1,1,1),(11143,'[{lv,[7,179]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004030432,1,1,1),(11144,'[{lv,[7,179]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004040432,1,1,1),(11145,'[{lv,[7,179]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006010432,1,1,1),(11146,'[{lv,[7,179]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006020432,1,1,1),(11147,'[{lv,[7,179]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006030432,1,1,1),(11148,'[{lv,[7,179]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006040432,1,1,1),(11149,'[{lv,[7,179]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008010432,1,1,1),(11150,'[{lv,[7,179]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008020432,1,1,1),(11151,'[{lv,[7,179]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008030432,1,1,1),(11152,'[{lv,[7,179]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008040432,1,1,1),(11153,'[{lv,[7,179]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010010432,1,1,1),(11154,'[{lv,[7,179]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010020432,1,1,1),(11155,'[{lv,[7,179]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010030432,1,1,1),(11156,'[{lv,[7,179]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010040432,1,1,1),(11157,'[{lv,[7,179]},{career,1},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001010432,1,1,1),(11158,'[{lv,[7,179]},{career,2},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001020432,1,1,1),(11159,'[{lv,[7,179]},{career,3},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001030432,1,1,1),(11160,'[{lv,[7,179]},{career,4},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001040432,1,1,1),(11161,'[{lv,[180,219]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002010532,1,1,1),(11162,'[{lv,[180,219]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002020532,1,1,1),(11163,'[{lv,[180,219]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002030532,1,1,1),(11164,'[{lv,[180,219]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002040532,1,1,1),(11165,'[{lv,[180,219]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004010532,1,1,1),(11166,'[{lv,[180,219]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004020532,1,1,1),(11167,'[{lv,[180,219]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004030532,1,1,1),(11168,'[{lv,[180,219]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004040532,1,1,1),(11169,'[{lv,[180,219]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006010532,1,1,1),(11170,'[{lv,[180,219]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006020532,1,1,1),(11171,'[{lv,[180,219]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006030532,1,1,1),(11172,'[{lv,[180,219]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006040532,1,1,1),(11173,'[{lv,[180,219]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008010532,1,1,1),(11174,'[{lv,[180,219]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008020532,1,1,1),(11175,'[{lv,[180,219]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008030532,1,1,1),(11176,'[{lv,[180,219]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008040532,1,1,1),(11177,'[{lv,[180,219]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010010532,1,1,1),(11178,'[{lv,[180,219]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010020532,1,1,1),(11179,'[{lv,[180,219]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010030532,1,1,1),(11180,'[{lv,[180,219]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010040532,1,1,1),(11181,'[{lv,[180,219]},{career,1},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001010532,1,1,1),(11182,'[{lv,[180,219]},{career,2},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001020532,1,1,1),(11183,'[{lv,[180,219]},{career,3},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001030532,1,1,1),(11184,'[{lv,[180,219]},{career,4},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001040532,1,1,1),(11185,'[{lv,[220,259]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002010632,1,1,1),(11186,'[{lv,[220,259]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002020632,1,1,1),(11187,'[{lv,[220,259]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002030632,1,1,1),(11188,'[{lv,[220,259]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002040632,1,1,1),(11189,'[{lv,[220,259]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004010632,1,1,1),(11190,'[{lv,[220,259]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004020632,1,1,1),(11191,'[{lv,[220,259]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004030632,1,1,1),(11192,'[{lv,[220,259]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004040632,1,1,1),(11193,'[{lv,[220,259]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006010632,1,1,1),(11194,'[{lv,[220,259]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006020632,1,1,1),(11195,'[{lv,[220,259]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006030632,1,1,1),(11196,'[{lv,[220,259]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006040632,1,1,1),(11197,'[{lv,[220,259]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008010632,1,1,1),(11198,'[{lv,[220,259]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008020632,1,1,1),(11199,'[{lv,[220,259]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008030632,1,1,1),(11200,'[{lv,[220,259]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008040632,1,1,1),(11201,'[{lv,[220,259]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010010632,1,1,1),(11202,'[{lv,[220,259]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010020632,1,1,1),(11203,'[{lv,[220,259]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010030632,1,1,1),(11204,'[{lv,[220,259]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010040632,1,1,1),(11205,'[{lv,[220,259]},{career,1},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001010632,1,1,1),(11206,'[{lv,[220,259]},{career,2},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001020632,1,1,1),(11207,'[{lv,[220,259]},{career,3},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001030632,1,1,1),(11208,'[{lv,[220,259]},{career,4},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001040632,1,1,1),(11209,'[{lv,[260,299]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002010732,1,1,1),(11210,'[{lv,[260,299]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002020732,1,1,1),(11211,'[{lv,[260,299]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002030732,1,1,1),(11212,'[{lv,[260,299]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002040732,1,1,1),(11213,'[{lv,[260,299]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004010732,1,1,1),(11214,'[{lv,[260,299]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004020732,1,1,1),(11215,'[{lv,[260,299]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004030732,1,1,1),(11216,'[{lv,[260,299]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004040732,1,1,1),(11217,'[{lv,[260,299]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006010732,1,1,1),(11218,'[{lv,[260,299]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006020732,1,1,1),(11219,'[{lv,[260,299]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006030732,1,1,1),(11220,'[{lv,[260,299]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006040732,1,1,1),(11221,'[{lv,[260,299]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008010732,1,1,1),(11222,'[{lv,[260,299]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008020732,1,1,1),(11223,'[{lv,[260,299]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008030732,1,1,1),(11224,'[{lv,[260,299]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008040732,1,1,1),(11225,'[{lv,[260,299]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010010732,1,1,1),(11226,'[{lv,[260,299]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010020732,1,1,1),(11227,'[{lv,[260,299]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010030732,1,1,1),(11228,'[{lv,[260,299]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010040732,1,1,1),(11229,'[{lv,[260,299]},{career,1},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001010732,1,1,1),(11230,'[{lv,[260,299]},{career,2},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001020732,1,1,1),(11231,'[{lv,[260,299]},{career,3},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001030732,1,1,1),(11232,'[{lv,[260,299]},{career,4},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001040732,1,1,1),(11233,'[{lv,[300,354]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002010832,1,1,1),(11234,'[{lv,[300,354]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002020832,1,1,1),(11235,'[{lv,[300,354]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002030832,1,1,1),(11236,'[{lv,[300,354]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002040832,1,1,1),(11237,'[{lv,[300,354]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004010832,1,1,1),(11238,'[{lv,[300,354]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004020832,1,1,1),(11239,'[{lv,[300,354]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004030832,1,1,1),(11240,'[{lv,[300,354]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004040832,1,1,1),(11241,'[{lv,[300,354]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006010832,1,1,1),(11242,'[{lv,[300,354]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006020832,1,1,1),(11243,'[{lv,[300,354]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006030832,1,1,1),(11244,'[{lv,[300,354]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006040832,1,1,1),(11245,'[{lv,[300,354]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008010832,1,1,1),(11246,'[{lv,[300,354]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008020832,1,1,1),(11247,'[{lv,[300,354]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008030832,1,1,1),(11248,'[{lv,[300,354]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008040832,1,1,1),(11249,'[{lv,[300,354]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010010832,1,1,1),(11250,'[{lv,[300,354]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010020832,1,1,1),(11251,'[{lv,[300,354]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010030832,1,1,1),(11252,'[{lv,[300,354]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010040832,1,1,1),(11253,'[{lv,[300,354]},{career,1},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001010832,1,1,1),(11254,'[{lv,[300,354]},{career,2},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001020832,1,1,1),(11255,'[{lv,[300,354]},{career,3},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001030832,1,1,1),(11256,'[{lv,[300,354]},{career,4},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001040832,1,1,1),(11257,'[{lv,[355,399]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002010932,1,1,1),(11258,'[{lv,[355,399]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002020932,1,1,1),(11259,'[{lv,[355,399]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002030932,1,1,1),(11260,'[{lv,[355,399]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002040932,1,1,1),(11261,'[{lv,[355,399]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004010932,1,1,1),(11262,'[{lv,[355,399]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004020932,1,1,1),(11263,'[{lv,[355,399]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004030932,1,1,1),(11264,'[{lv,[355,399]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004040932,1,1,1),(11265,'[{lv,[355,399]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006010932,1,1,1),(11266,'[{lv,[355,399]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006020932,1,1,1),(11267,'[{lv,[355,399]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006030932,1,1,1),(11268,'[{lv,[355,399]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006040932,1,1,1),(11269,'[{lv,[355,399]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008010932,1,1,1),(11270,'[{lv,[355,399]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008020932,1,1,1),(11271,'[{lv,[355,399]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008030932,1,1,1),(11272,'[{lv,[355,399]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008040932,1,1,1),(11273,'[{lv,[355,399]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010010932,1,1,1),(11274,'[{lv,[355,399]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010020932,1,1,1),(11275,'[{lv,[355,399]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010030932,1,1,1),(11276,'[{lv,[355,399]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010040932,1,1,1),(11277,'[{lv,[355,399]},{career,1},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001010932,1,1,1),(11278,'[{lv,[355,399]},{career,2},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001020932,1,1,1),(11279,'[{lv,[355,399]},{career,3},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001030932,1,1,1),(11280,'[{lv,[355,399]},{career,4},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001040932,1,1,1),(11281,'[{lv,[400,499]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002011032,1,1,1),(11282,'[{lv,[400,499]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002021032,1,1,1),(11283,'[{lv,[400,499]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002031032,1,1,1),(11284,'[{lv,[400,499]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002041032,1,1,1),(11285,'[{lv,[400,499]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004011032,1,1,1),(11286,'[{lv,[400,499]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004021032,1,1,1),(11287,'[{lv,[400,499]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004031032,1,1,1),(11288,'[{lv,[400,499]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004041032,1,1,1),(11289,'[{lv,[400,499]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006011032,1,1,1),(11290,'[{lv,[400,499]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006021032,1,1,1),(11291,'[{lv,[400,499]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006031032,1,1,1),(11292,'[{lv,[400,499]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006041032,1,1,1),(11293,'[{lv,[400,499]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008011032,1,1,1),(11294,'[{lv,[400,499]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008021032,1,1,1),(11295,'[{lv,[400,499]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008031032,1,1,1),(11296,'[{lv,[400,499]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008041032,1,1,1),(11297,'[{lv,[400,499]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010011032,1,1,1),(11298,'[{lv,[400,499]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010021032,1,1,1),(11299,'[{lv,[400,499]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010031032,1,1,1),(11300,'[{lv,[400,499]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010041032,1,1,1),(11301,'[{lv,[400,499]},{career,1},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001011032,1,1,1),(11302,'[{lv,[400,499]},{career,2},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001021032,1,1,1),(11303,'[{lv,[400,499]},{career,3},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001031032,1,1,1),(11304,'[{lv,[400,499]},{career,4},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001041032,1,1,1),(11305,'[{lv,[500,519]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002011132,1,1,1),(11306,'[{lv,[500,519]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002021132,1,1,1),(11307,'[{lv,[500,519]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002031132,1,1,1),(11308,'[{lv,[500,519]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002041132,1,1,1),(11309,'[{lv,[500,519]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004011132,1,1,1),(11310,'[{lv,[500,519]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004021132,1,1,1),(11311,'[{lv,[500,519]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004031132,1,1,1),(11312,'[{lv,[500,519]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004041132,1,1,1),(11313,'[{lv,[500,519]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006011132,1,1,1),(11314,'[{lv,[500,519]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006021132,1,1,1),(11315,'[{lv,[500,519]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006031132,1,1,1),(11316,'[{lv,[500,519]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006041132,1,1,1),(11317,'[{lv,[500,519]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008011132,1,1,1),(11318,'[{lv,[500,519]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008021132,1,1,1),(11319,'[{lv,[500,519]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008031132,1,1,1),(11320,'[{lv,[500,519]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008041132,1,1,1),(11321,'[{lv,[500,519]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010011132,1,1,1),(11322,'[{lv,[500,519]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010021132,1,1,1),(11323,'[{lv,[500,519]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010031132,1,1,1),(11324,'[{lv,[500,519]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010041132,1,1,1),(11325,'[{lv,[500,519]},{career,1},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001011132,1,1,1),(11326,'[{lv,[500,519]},{career,2},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001021132,1,1,1),(11327,'[{lv,[500,519]},{career,3},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001031132,1,1,1),(11328,'[{lv,[500,519]},{career,4},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001041132,1,1,1),(11329,'[{lv,[520,619]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002011232,1,1,1),(11330,'[{lv,[520,619]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002021232,1,1,1),(11331,'[{lv,[520,619]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002031232,1,1,1),(11332,'[{lv,[520,619]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002041232,1,1,1),(11333,'[{lv,[520,619]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004011232,1,1,1),(11334,'[{lv,[520,619]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004021232,1,1,1),(11335,'[{lv,[520,619]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004031232,1,1,1),(11336,'[{lv,[520,619]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004041232,1,1,1),(11337,'[{lv,[520,619]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006011232,1,1,1),(11338,'[{lv,[520,619]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006021232,1,1,1),(11339,'[{lv,[520,619]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006031232,1,1,1),(11340,'[{lv,[520,619]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006041232,1,1,1),(11341,'[{lv,[520,619]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008011232,1,1,1),(11342,'[{lv,[520,619]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008021232,1,1,1),(11343,'[{lv,[520,619]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008031232,1,1,1),(11344,'[{lv,[520,619]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008041232,1,1,1),(11345,'[{lv,[520,619]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010011232,1,1,1),(11346,'[{lv,[520,619]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010021232,1,1,1),(11347,'[{lv,[520,619]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010031232,1,1,1),(11348,'[{lv,[520,619]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010041232,1,1,1),(11349,'[{lv,[520,619]},{career,1},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001011232,1,1,1),(11350,'[{lv,[520,619]},{career,2},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001021232,1,1,1),(11351,'[{lv,[520,619]},{career,3},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001031232,1,1,1),(11352,'[{lv,[520,619]},{career,4},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001041232,1,1,1),(11353,'[{lv,[620,649]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002011332,1,1,1),(11354,'[{lv,[620,649]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002021332,1,1,1),(11355,'[{lv,[620,649]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002031332,1,1,1),(11356,'[{lv,[620,649]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002041332,1,1,1),(11357,'[{lv,[620,649]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004011332,1,1,1),(11358,'[{lv,[620,649]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004021332,1,1,1),(11359,'[{lv,[620,649]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004031332,1,1,1),(11360,'[{lv,[620,649]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004041332,1,1,1),(11361,'[{lv,[620,649]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006011332,1,1,1),(11362,'[{lv,[620,649]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006021332,1,1,1),(11363,'[{lv,[620,649]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006031332,1,1,1),(11364,'[{lv,[620,649]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006041332,1,1,1),(11365,'[{lv,[620,649]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008011332,1,1,1),(11366,'[{lv,[620,649]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008021332,1,1,1),(11367,'[{lv,[620,649]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008031332,1,1,1),(11368,'[{lv,[620,649]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008041332,1,1,1),(11369,'[{lv,[620,649]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010011332,1,1,1),(11370,'[{lv,[620,649]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010021332,1,1,1),(11371,'[{lv,[620,649]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010031332,1,1,1),(11372,'[{lv,[620,649]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010041332,1,1,1),(11373,'[{lv,[620,649]},{career,1},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001011332,1,1,1),(11374,'[{lv,[620,649]},{career,2},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001021332,1,1,1),(11375,'[{lv,[620,649]},{career,3},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001031332,1,1,1),(11376,'[{lv,[620,649]},{career,4},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001041332,1,1,1),(11377,'[{lv,[650,699]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002011432,1,1,1),(11378,'[{lv,[650,699]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002021432,1,1,1),(11379,'[{lv,[650,699]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002031432,1,1,1),(11380,'[{lv,[650,699]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002041432,1,1,1),(11381,'[{lv,[650,699]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004011432,1,1,1),(11382,'[{lv,[650,699]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004021432,1,1,1),(11383,'[{lv,[650,699]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004031432,1,1,1),(11384,'[{lv,[650,699]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004041432,1,1,1),(11385,'[{lv,[650,699]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006011432,1,1,1),(11386,'[{lv,[650,699]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006021432,1,1,1),(11387,'[{lv,[650,699]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006031432,1,1,1),(11388,'[{lv,[650,699]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006041432,1,1,1),(11389,'[{lv,[650,699]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008011432,1,1,1),(11390,'[{lv,[650,699]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008021432,1,1,1),(11391,'[{lv,[650,699]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008031432,1,1,1),(11392,'[{lv,[650,699]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008041432,1,1,1),(11393,'[{lv,[650,699]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010011432,1,1,1),(11394,'[{lv,[650,699]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010021432,1,1,1),(11395,'[{lv,[650,699]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010031432,1,1,1),(11396,'[{lv,[650,699]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010041432,1,1,1),(11397,'[{lv,[650,699]},{career,1},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001011432,1,1,1),(11398,'[{lv,[650,699]},{career,2},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001021432,1,1,1),(11399,'[{lv,[650,699]},{career,3},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001031432,1,1,1),(11400,'[{lv,[650,699]},{career,4},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001041432,1,1,1),(11401,'[{lv,[700,749]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002011532,1,1,1),(11402,'[{lv,[700,749]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002021532,1,1,1),(11403,'[{lv,[700,749]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002031532,1,1,1),(11404,'[{lv,[700,749]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002041532,1,1,1),(11405,'[{lv,[700,749]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004011532,1,1,1),(11406,'[{lv,[700,749]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004021532,1,1,1),(11407,'[{lv,[700,749]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004031532,1,1,1),(11408,'[{lv,[700,749]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004041532,1,1,1),(11409,'[{lv,[700,749]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006011532,1,1,1),(11410,'[{lv,[700,749]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006021532,1,1,1),(11411,'[{lv,[700,749]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006031532,1,1,1),(11412,'[{lv,[700,749]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006041532,1,1,1),(11413,'[{lv,[700,749]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008011532,1,1,1),(11414,'[{lv,[700,749]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008021532,1,1,1),(11415,'[{lv,[700,749]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008031532,1,1,1),(11416,'[{lv,[700,749]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008041532,1,1,1),(11417,'[{lv,[700,749]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010011532,1,1,1),(11418,'[{lv,[700,749]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010021532,1,1,1),(11419,'[{lv,[700,749]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010031532,1,1,1),(11420,'[{lv,[700,749]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010041532,1,1,1),(11421,'[{lv,[700,749]},{career,1},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001011532,1,1,1),(11422,'[{lv,[700,749]},{career,2},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001021532,1,1,1),(11423,'[{lv,[700,749]},{career,3},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001031532,1,1,1),(11424,'[{lv,[700,749]},{career,4},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001041532,1,1,1),(11425,'[{lv,[750,1000]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002011632,1,1,1),(11426,'[{lv,[750,1000]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002021632,1,1,1),(11427,'[{lv,[750,1000]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002031632,1,1,1),(11428,'[{lv,[750,1000]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1002041632,1,1,1),(11429,'[{lv,[750,1000]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004011632,1,1,1),(11430,'[{lv,[750,1000]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004021632,1,1,1),(11431,'[{lv,[750,1000]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004031632,1,1,1),(11432,'[{lv,[750,1000]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1004041632,1,1,1),(11433,'[{lv,[750,1000]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006011632,1,1,1),(11434,'[{lv,[750,1000]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006021632,1,1,1),(11435,'[{lv,[750,1000]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006031632,1,1,1),(11436,'[{lv,[750,1000]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1006041632,1,1,1),(11437,'[{lv,[750,1000]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008011632,1,1,1),(11438,'[{lv,[750,1000]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008021632,1,1,1),(11439,'[{lv,[750,1000]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008031632,1,1,1),(11440,'[{lv,[750,1000]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1008041632,1,1,1),(11441,'[{lv,[750,1000]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010011632,1,1,1),(11442,'[{lv,[750,1000]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010021632,1,1,1),(11443,'[{lv,[750,1000]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010031632,1,1,1),(11444,'[{lv,[750,1000]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,4,50,1010041632,1,1,1),(11445,'[{lv,[750,1000]},{career,1},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001011632,1,1,1),(11446,'[{lv,[750,1000]},{career,2},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001021632,1,1,1),(11447,'[{lv,[750,1000]},{career,3},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001031632,1,1,1),(11448,'[{lv,[750,1000]},{career,4},{is_guarantee,0},{free_can_get,0}]',11,5,30,1001041632,1,1,1),(11449,'[{lv,[1,2]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002010132,1,1,1),(11450,'[{lv,[1,2]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002020132,1,1,1),(11451,'[{lv,[1,2]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002030132,1,1,1),(11452,'[{lv,[1,2]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002040132,1,1,1),(11453,'[{lv,[1,2]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004010132,1,1,1),(11454,'[{lv,[1,2]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004020132,1,1,1),(11455,'[{lv,[1,2]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004030132,1,1,1),(11456,'[{lv,[1,2]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004040132,1,1,1),(11457,'[{lv,[1,2]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006010132,1,1,1),(11458,'[{lv,[1,2]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006020132,1,1,1),(11459,'[{lv,[1,2]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006030132,1,1,1),(11460,'[{lv,[1,2]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006040132,1,1,1),(11461,'[{lv,[1,2]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008010132,1,1,1),(11462,'[{lv,[1,2]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008020132,1,1,1),(11463,'[{lv,[1,2]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008030132,1,1,1),(11464,'[{lv,[1,2]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008040132,1,1,1),(11465,'[{lv,[1,2]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010010132,1,1,1),(11466,'[{lv,[1,2]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010020132,1,1,1),(11467,'[{lv,[1,2]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010030132,1,1,1),(11468,'[{lv,[1,2]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010040132,1,1,1),(11469,'[{lv,[1,2]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001010132,1,1,1),(11470,'[{lv,[1,2]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001020132,1,1,1),(11471,'[{lv,[1,2]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001030132,1,1,1),(11472,'[{lv,[1,2]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001040132,1,1,1),(11473,'[{lv,[3,4]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002010232,1,1,1),(11474,'[{lv,[3,4]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002020232,1,1,1),(11475,'[{lv,[3,4]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002030232,1,1,1),(11476,'[{lv,[3,4]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002040232,1,1,1),(11477,'[{lv,[3,4]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004010232,1,1,1),(11478,'[{lv,[3,4]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004020232,1,1,1),(11479,'[{lv,[3,4]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004030232,1,1,1),(11480,'[{lv,[3,4]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004040232,1,1,1),(11481,'[{lv,[3,4]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006010232,1,1,1),(11482,'[{lv,[3,4]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006020232,1,1,1),(11483,'[{lv,[3,4]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006030232,1,1,1),(11484,'[{lv,[3,4]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006040232,1,1,1),(11485,'[{lv,[3,4]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008010232,1,1,1),(11486,'[{lv,[3,4]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008020232,1,1,1),(11487,'[{lv,[3,4]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008030232,1,1,1),(11488,'[{lv,[3,4]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008040232,1,1,1),(11489,'[{lv,[3,4]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010010232,1,1,1),(11490,'[{lv,[3,4]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010020232,1,1,1),(11491,'[{lv,[3,4]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010030232,1,1,1),(11492,'[{lv,[3,4]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010040232,1,1,1),(11493,'[{lv,[3,4]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001010232,1,1,1),(11494,'[{lv,[3,4]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001020232,1,1,1),(11495,'[{lv,[3,4]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001030232,1,1,1),(11496,'[{lv,[3,4]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001040232,1,1,1),(11497,'[{lv,[5,6]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002010332,1,1,1),(11498,'[{lv,[5,6]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002020332,1,1,1),(11499,'[{lv,[5,6]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002030332,1,1,1),(11500,'[{lv,[5,6]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002040332,1,1,1),(11501,'[{lv,[5,6]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004010332,1,1,1),(11502,'[{lv,[5,6]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004020332,1,1,1),(11503,'[{lv,[5,6]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004030332,1,1,1),(11504,'[{lv,[5,6]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004040332,1,1,1),(11505,'[{lv,[5,6]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006010332,1,1,1),(11506,'[{lv,[5,6]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006020332,1,1,1),(11507,'[{lv,[5,6]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006030332,1,1,1),(11508,'[{lv,[5,6]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006040332,1,1,1),(11509,'[{lv,[5,6]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008010332,1,1,1),(11510,'[{lv,[5,6]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008020332,1,1,1),(11511,'[{lv,[5,6]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008030332,1,1,1),(11512,'[{lv,[5,6]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008040332,1,1,1),(11513,'[{lv,[5,6]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010010332,1,1,1),(11514,'[{lv,[5,6]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010020332,1,1,1),(11515,'[{lv,[5,6]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010030332,1,1,1),(11516,'[{lv,[5,6]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010040332,1,1,1),(11517,'[{lv,[5,6]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001010332,1,1,1),(11518,'[{lv,[5,6]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001020332,1,1,1),(11519,'[{lv,[5,6]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001030332,1,1,1),(11520,'[{lv,[5,6]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001040332,1,1,1),(11521,'[{lv,[7,179]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002010432,1,1,1),(11522,'[{lv,[7,179]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002020432,1,1,1),(11523,'[{lv,[7,179]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002030432,1,1,1),(11524,'[{lv,[7,179]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002040432,1,1,1),(11525,'[{lv,[7,179]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004010432,1,1,1),(11526,'[{lv,[7,179]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004020432,1,1,1),(11527,'[{lv,[7,179]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004030432,1,1,1),(11528,'[{lv,[7,179]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004040432,1,1,1),(11529,'[{lv,[7,179]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006010432,1,1,1),(11530,'[{lv,[7,179]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006020432,1,1,1),(11531,'[{lv,[7,179]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006030432,1,1,1),(11532,'[{lv,[7,179]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006040432,1,1,1),(11533,'[{lv,[7,179]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008010432,1,1,1),(11534,'[{lv,[7,179]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008020432,1,1,1),(11535,'[{lv,[7,179]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008030432,1,1,1),(11536,'[{lv,[7,179]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008040432,1,1,1),(11537,'[{lv,[7,179]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010010432,1,1,1),(11538,'[{lv,[7,179]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010020432,1,1,1),(11539,'[{lv,[7,179]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010030432,1,1,1),(11540,'[{lv,[7,179]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010040432,1,1,1),(11541,'[{lv,[7,179]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001010432,1,1,1),(11542,'[{lv,[7,179]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001020432,1,1,1),(11543,'[{lv,[7,179]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001030432,1,1,1),(11544,'[{lv,[7,179]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001040432,1,1,1),(11545,'[{lv,[180,219]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002010532,1,1,1),(11546,'[{lv,[180,219]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002020532,1,1,1),(11547,'[{lv,[180,219]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002030532,1,1,1),(11548,'[{lv,[180,219]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002040532,1,1,1),(11549,'[{lv,[180,219]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004010532,1,1,1),(11550,'[{lv,[180,219]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004020532,1,1,1),(11551,'[{lv,[180,219]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004030532,1,1,1),(11552,'[{lv,[180,219]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004040532,1,1,1),(11553,'[{lv,[180,219]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006010532,1,1,1),(11554,'[{lv,[180,219]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006020532,1,1,1),(11555,'[{lv,[180,219]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006030532,1,1,1),(11556,'[{lv,[180,219]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006040532,1,1,1),(11557,'[{lv,[180,219]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008010532,1,1,1),(11558,'[{lv,[180,219]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008020532,1,1,1),(11559,'[{lv,[180,219]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008030532,1,1,1),(11560,'[{lv,[180,219]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008040532,1,1,1),(11561,'[{lv,[180,219]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010010532,1,1,1),(11562,'[{lv,[180,219]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010020532,1,1,1),(11563,'[{lv,[180,219]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010030532,1,1,1),(11564,'[{lv,[180,219]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010040532,1,1,1),(11565,'[{lv,[180,219]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001010532,1,1,1),(11566,'[{lv,[180,219]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001020532,1,1,1),(11567,'[{lv,[180,219]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001030532,1,1,1),(11568,'[{lv,[180,219]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001040532,1,1,1),(11569,'[{lv,[220,259]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002010632,1,1,1),(11570,'[{lv,[220,259]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002020632,1,1,1),(11571,'[{lv,[220,259]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002030632,1,1,1),(11572,'[{lv,[220,259]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002040632,1,1,1),(11573,'[{lv,[220,259]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004010632,1,1,1),(11574,'[{lv,[220,259]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004020632,1,1,1),(11575,'[{lv,[220,259]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004030632,1,1,1),(11576,'[{lv,[220,259]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004040632,1,1,1),(11577,'[{lv,[220,259]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006010632,1,1,1),(11578,'[{lv,[220,259]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006020632,1,1,1),(11579,'[{lv,[220,259]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006030632,1,1,1),(11580,'[{lv,[220,259]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006040632,1,1,1),(11581,'[{lv,[220,259]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008010632,1,1,1),(11582,'[{lv,[220,259]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008020632,1,1,1),(11583,'[{lv,[220,259]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008030632,1,1,1),(11584,'[{lv,[220,259]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008040632,1,1,1),(11585,'[{lv,[220,259]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010010632,1,1,1),(11586,'[{lv,[220,259]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010020632,1,1,1),(11587,'[{lv,[220,259]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010030632,1,1,1),(11588,'[{lv,[220,259]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010040632,1,1,1),(11589,'[{lv,[220,259]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001010632,1,1,1),(11590,'[{lv,[220,259]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001020632,1,1,1),(11591,'[{lv,[220,259]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001030632,1,1,1),(11592,'[{lv,[220,259]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001040632,1,1,1),(11593,'[{lv,[260,299]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002010732,1,1,1),(11594,'[{lv,[260,299]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002020732,1,1,1),(11595,'[{lv,[260,299]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002030732,1,1,1),(11596,'[{lv,[260,299]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002040732,1,1,1),(11597,'[{lv,[260,299]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004010732,1,1,1),(11598,'[{lv,[260,299]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004020732,1,1,1),(11599,'[{lv,[260,299]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004030732,1,1,1),(11600,'[{lv,[260,299]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004040732,1,1,1),(11601,'[{lv,[260,299]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006010732,1,1,1),(11602,'[{lv,[260,299]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006020732,1,1,1),(11603,'[{lv,[260,299]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006030732,1,1,1),(11604,'[{lv,[260,299]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006040732,1,1,1),(11605,'[{lv,[260,299]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008010732,1,1,1),(11606,'[{lv,[260,299]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008020732,1,1,1),(11607,'[{lv,[260,299]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008030732,1,1,1),(11608,'[{lv,[260,299]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008040732,1,1,1),(11609,'[{lv,[260,299]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010010732,1,1,1),(11610,'[{lv,[260,299]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010020732,1,1,1),(11611,'[{lv,[260,299]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010030732,1,1,1),(11612,'[{lv,[260,299]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010040732,1,1,1),(11613,'[{lv,[260,299]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001010732,1,1,1),(11614,'[{lv,[260,299]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001020732,1,1,1),(11615,'[{lv,[260,299]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001030732,1,1,1),(11616,'[{lv,[260,299]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001040732,1,1,1),(11617,'[{lv,[300,354]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002010832,1,1,1),(11618,'[{lv,[300,354]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002020832,1,1,1),(11619,'[{lv,[300,354]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002030832,1,1,1),(11620,'[{lv,[300,354]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002040832,1,1,1),(11621,'[{lv,[300,354]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004010832,1,1,1),(11622,'[{lv,[300,354]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004020832,1,1,1),(11623,'[{lv,[300,354]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004030832,1,1,1),(11624,'[{lv,[300,354]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004040832,1,1,1),(11625,'[{lv,[300,354]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006010832,1,1,1),(11626,'[{lv,[300,354]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006020832,1,1,1),(11627,'[{lv,[300,354]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006030832,1,1,1),(11628,'[{lv,[300,354]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006040832,1,1,1),(11629,'[{lv,[300,354]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008010832,1,1,1),(11630,'[{lv,[300,354]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008020832,1,1,1),(11631,'[{lv,[300,354]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008030832,1,1,1),(11632,'[{lv,[300,354]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008040832,1,1,1),(11633,'[{lv,[300,354]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010010832,1,1,1),(11634,'[{lv,[300,354]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010020832,1,1,1),(11635,'[{lv,[300,354]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010030832,1,1,1),(11636,'[{lv,[300,354]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010040832,1,1,1),(11637,'[{lv,[300,354]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001010832,1,1,1),(11638,'[{lv,[300,354]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001020832,1,1,1),(11639,'[{lv,[300,354]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001030832,1,1,1),(11640,'[{lv,[300,354]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001040832,1,1,1),(11641,'[{lv,[355,399]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002010932,1,1,1),(11642,'[{lv,[355,399]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002020932,1,1,1),(11643,'[{lv,[355,399]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002030932,1,1,1),(11644,'[{lv,[355,399]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002040932,1,1,1),(11645,'[{lv,[355,399]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004010932,1,1,1),(11646,'[{lv,[355,399]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004020932,1,1,1),(11647,'[{lv,[355,399]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004030932,1,1,1),(11648,'[{lv,[355,399]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004040932,1,1,1),(11649,'[{lv,[355,399]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006010932,1,1,1),(11650,'[{lv,[355,399]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006020932,1,1,1),(11651,'[{lv,[355,399]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006030932,1,1,1),(11652,'[{lv,[355,399]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006040932,1,1,1),(11653,'[{lv,[355,399]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008010932,1,1,1),(11654,'[{lv,[355,399]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008020932,1,1,1),(11655,'[{lv,[355,399]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008030932,1,1,1),(11656,'[{lv,[355,399]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008040932,1,1,1),(11657,'[{lv,[355,399]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010010932,1,1,1),(11658,'[{lv,[355,399]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010020932,1,1,1),(11659,'[{lv,[355,399]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010030932,1,1,1),(11660,'[{lv,[355,399]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010040932,1,1,1),(11661,'[{lv,[355,399]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001010932,1,1,1),(11662,'[{lv,[355,399]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001020932,1,1,1),(11663,'[{lv,[355,399]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001030932,1,1,1),(11664,'[{lv,[355,399]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001040932,1,1,1),(11665,'[{lv,[400,499]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002011032,1,1,1),(11666,'[{lv,[400,499]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002021032,1,1,1),(11667,'[{lv,[400,499]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002031032,1,1,1),(11668,'[{lv,[400,499]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002041032,1,1,1),(11669,'[{lv,[400,499]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004011032,1,1,1),(11670,'[{lv,[400,499]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004021032,1,1,1),(11671,'[{lv,[400,499]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004031032,1,1,1),(11672,'[{lv,[400,499]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004041032,1,1,1),(11673,'[{lv,[400,499]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006011032,1,1,1),(11674,'[{lv,[400,499]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006021032,1,1,1),(11675,'[{lv,[400,499]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006031032,1,1,1),(11676,'[{lv,[400,499]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006041032,1,1,1),(11677,'[{lv,[400,499]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008011032,1,1,1),(11678,'[{lv,[400,499]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008021032,1,1,1),(11679,'[{lv,[400,499]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008031032,1,1,1),(11680,'[{lv,[400,499]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008041032,1,1,1),(11681,'[{lv,[400,499]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010011032,1,1,1),(11682,'[{lv,[400,499]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010021032,1,1,1),(11683,'[{lv,[400,499]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010031032,1,1,1),(11684,'[{lv,[400,499]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010041032,1,1,1),(11685,'[{lv,[400,499]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001011032,1,1,1),(11686,'[{lv,[400,499]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001021032,1,1,1),(11687,'[{lv,[400,499]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001031032,1,1,1),(11688,'[{lv,[400,499]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001041032,1,1,1),(11689,'[{lv,[500,519]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002011132,1,1,1),(11690,'[{lv,[500,519]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002021132,1,1,1),(11691,'[{lv,[500,519]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002031132,1,1,1),(11692,'[{lv,[500,519]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002041132,1,1,1),(11693,'[{lv,[500,519]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004011132,1,1,1),(11694,'[{lv,[500,519]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004021132,1,1,1),(11695,'[{lv,[500,519]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004031132,1,1,1),(11696,'[{lv,[500,519]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004041132,1,1,1),(11697,'[{lv,[500,519]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006011132,1,1,1),(11698,'[{lv,[500,519]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006021132,1,1,1),(11699,'[{lv,[500,519]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006031132,1,1,1),(11700,'[{lv,[500,519]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006041132,1,1,1),(11701,'[{lv,[500,519]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008011132,1,1,1),(11702,'[{lv,[500,519]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008021132,1,1,1),(11703,'[{lv,[500,519]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008031132,1,1,1),(11704,'[{lv,[500,519]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008041132,1,1,1),(11705,'[{lv,[500,519]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010011132,1,1,1),(11706,'[{lv,[500,519]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010021132,1,1,1),(11707,'[{lv,[500,519]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010031132,1,1,1),(11708,'[{lv,[500,519]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010041132,1,1,1),(11709,'[{lv,[500,519]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001011132,1,1,1),(11710,'[{lv,[500,519]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001021132,1,1,1),(11711,'[{lv,[500,519]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001031132,1,1,1),(11712,'[{lv,[500,519]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001041132,1,1,1),(11713,'[{lv,[520,619]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002011232,1,1,1),(11714,'[{lv,[520,619]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002021232,1,1,1),(11715,'[{lv,[520,619]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002031232,1,1,1),(11716,'[{lv,[520,619]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002041232,1,1,1),(11717,'[{lv,[520,619]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004011232,1,1,1),(11718,'[{lv,[520,619]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004021232,1,1,1),(11719,'[{lv,[520,619]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004031232,1,1,1),(11720,'[{lv,[520,619]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004041232,1,1,1),(11721,'[{lv,[520,619]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006011232,1,1,1),(11722,'[{lv,[520,619]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006021232,1,1,1),(11723,'[{lv,[520,619]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006031232,1,1,1),(11724,'[{lv,[520,619]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006041232,1,1,1),(11725,'[{lv,[520,619]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008011232,1,1,1),(11726,'[{lv,[520,619]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008021232,1,1,1),(11727,'[{lv,[520,619]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008031232,1,1,1),(11728,'[{lv,[520,619]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008041232,1,1,1),(11729,'[{lv,[520,619]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010011232,1,1,1),(11730,'[{lv,[520,619]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010021232,1,1,1),(11731,'[{lv,[520,619]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010031232,1,1,1),(11732,'[{lv,[520,619]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010041232,1,1,1),(11733,'[{lv,[520,619]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001011232,1,1,1),(11734,'[{lv,[520,619]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001021232,1,1,1),(11735,'[{lv,[520,619]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001031232,1,1,1),(11736,'[{lv,[520,619]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001041232,1,1,1),(11737,'[{lv,[620,649]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002011332,1,1,1),(11738,'[{lv,[620,649]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002021332,1,1,1),(11739,'[{lv,[620,649]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002031332,1,1,1),(11740,'[{lv,[620,649]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002041332,1,1,1),(11741,'[{lv,[620,649]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004011332,1,1,1),(11742,'[{lv,[620,649]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004021332,1,1,1),(11743,'[{lv,[620,649]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004031332,1,1,1),(11744,'[{lv,[620,649]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004041332,1,1,1),(11745,'[{lv,[620,649]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006011332,1,1,1),(11746,'[{lv,[620,649]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006021332,1,1,1),(11747,'[{lv,[620,649]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006031332,1,1,1),(11748,'[{lv,[620,649]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006041332,1,1,1),(11749,'[{lv,[620,649]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008011332,1,1,1),(11750,'[{lv,[620,649]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008021332,1,1,1),(11751,'[{lv,[620,649]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008031332,1,1,1),(11752,'[{lv,[620,649]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008041332,1,1,1),(11753,'[{lv,[620,649]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010011332,1,1,1),(11754,'[{lv,[620,649]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010021332,1,1,1),(11755,'[{lv,[620,649]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010031332,1,1,1),(11756,'[{lv,[620,649]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010041332,1,1,1),(11757,'[{lv,[620,649]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001011332,1,1,1),(11758,'[{lv,[620,649]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001021332,1,1,1),(11759,'[{lv,[620,649]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001031332,1,1,1),(11760,'[{lv,[620,649]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001041332,1,1,1),(11761,'[{lv,[650,699]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002011432,1,1,1),(11762,'[{lv,[650,699]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002021432,1,1,1),(11763,'[{lv,[650,699]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002031432,1,1,1),(11764,'[{lv,[650,699]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002041432,1,1,1),(11765,'[{lv,[650,699]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004011432,1,1,1),(11766,'[{lv,[650,699]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004021432,1,1,1),(11767,'[{lv,[650,699]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004031432,1,1,1),(11768,'[{lv,[650,699]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004041432,1,1,1),(11769,'[{lv,[650,699]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006011432,1,1,1),(11770,'[{lv,[650,699]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006021432,1,1,1),(11771,'[{lv,[650,699]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006031432,1,1,1),(11772,'[{lv,[650,699]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006041432,1,1,1),(11773,'[{lv,[650,699]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008011432,1,1,1),(11774,'[{lv,[650,699]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008021432,1,1,1),(11775,'[{lv,[650,699]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008031432,1,1,1),(11776,'[{lv,[650,699]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008041432,1,1,1),(11777,'[{lv,[650,699]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010011432,1,1,1),(11778,'[{lv,[650,699]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010021432,1,1,1),(11779,'[{lv,[650,699]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010031432,1,1,1),(11780,'[{lv,[650,699]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010041432,1,1,1),(11781,'[{lv,[650,699]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001011432,1,1,1),(11782,'[{lv,[650,699]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001021432,1,1,1),(11783,'[{lv,[650,699]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001031432,1,1,1),(11784,'[{lv,[650,699]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001041432,1,1,1),(11785,'[{lv,[700,749]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002011532,1,1,1),(11786,'[{lv,[700,749]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002021532,1,1,1),(11787,'[{lv,[700,749]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002031532,1,1,1),(11788,'[{lv,[700,749]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002041532,1,1,1),(11789,'[{lv,[700,749]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004011532,1,1,1),(11790,'[{lv,[700,749]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004021532,1,1,1),(11791,'[{lv,[700,749]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004031532,1,1,1),(11792,'[{lv,[700,749]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004041532,1,1,1),(11793,'[{lv,[700,749]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006011532,1,1,1),(11794,'[{lv,[700,749]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006021532,1,1,1),(11795,'[{lv,[700,749]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006031532,1,1,1),(11796,'[{lv,[700,749]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006041532,1,1,1),(11797,'[{lv,[700,749]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008011532,1,1,1),(11798,'[{lv,[700,749]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008021532,1,1,1),(11799,'[{lv,[700,749]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008031532,1,1,1),(11800,'[{lv,[700,749]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008041532,1,1,1),(11801,'[{lv,[700,749]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010011532,1,1,1),(11802,'[{lv,[700,749]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010021532,1,1,1),(11803,'[{lv,[700,749]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010031532,1,1,1),(11804,'[{lv,[700,749]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010041532,1,1,1),(11805,'[{lv,[700,749]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001011532,1,1,1),(11806,'[{lv,[700,749]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001021532,1,1,1),(11807,'[{lv,[700,749]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001031532,1,1,1),(11808,'[{lv,[700,749]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001041532,1,1,1),(11809,'[{lv,[750,1000]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002011632,1,1,1),(11810,'[{lv,[750,1000]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002021632,1,1,1),(11811,'[{lv,[750,1000]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002031632,1,1,1),(11812,'[{lv,[750,1000]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1002041632,1,1,1),(11813,'[{lv,[750,1000]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004011632,1,1,1),(11814,'[{lv,[750,1000]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004021632,1,1,1),(11815,'[{lv,[750,1000]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004031632,1,1,1),(11816,'[{lv,[750,1000]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1004041632,1,1,1),(11817,'[{lv,[750,1000]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006011632,1,1,1),(11818,'[{lv,[750,1000]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006021632,1,1,1),(11819,'[{lv,[750,1000]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006031632,1,1,1),(11820,'[{lv,[750,1000]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1006041632,1,1,1),(11821,'[{lv,[750,1000]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008011632,1,1,1),(11822,'[{lv,[750,1000]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008021632,1,1,1),(11823,'[{lv,[750,1000]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008031632,1,1,1),(11824,'[{lv,[750,1000]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1008041632,1,1,1),(11825,'[{lv,[750,1000]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010011632,1,1,1),(11826,'[{lv,[750,1000]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010021632,1,1,1),(11827,'[{lv,[750,1000]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010031632,1,1,1),(11828,'[{lv,[750,1000]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1010041632,1,1,1),(11829,'[{lv,[750,1000]},{career,1},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001011632,1,1,1),(11830,'[{lv,[750,1000]},{career,2},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001021632,1,1,1),(11831,'[{lv,[750,1000]},{career,3},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001031632,1,1,1),(11832,'[{lv,[750,1000]},{career,4},{is_guarantee,0},{free_can_get,1}]',11,99,1,1001041632,1,1,1),(21001,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,1,1600,11020001,1,0,0),(21002,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,1,1600,20060001,1,0,0),(21003,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,1,1300,38260001,1,0,0),(21004,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,1,0,38260001,1,0,0),(21005,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,1,0,38260001,1,0,0),(21006,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,1,0,38260001,1,0,0),(21007,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,1,0,38260001,1,0,0),(21008,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,1,0,38260001,1,0,0),(21009,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,1,0,38260001,1,0,0),(21010,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,3,300,37020002,1,0,0),(21011,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,3,800,32010035,1,0,0),(21012,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,3,100,32010037,1,0,0),(21013,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,3,0,37020002,1,0,0),(21014,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,3,0,37020002,1,0,0),(21015,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,3,0,37020002,1,0,0),(21016,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,3,0,37020002,1,0,0),(21017,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,3,9,14010105,1,0,0),(21018,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,3,9,14020205,1,0,0),(21019,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,3,8,14010305,1,0,0),(21020,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,3,8,14020405,1,0,0),(21021,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,3,0,14010505,1,0,0),(21022,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,3,0,14020605,1,0,0),(21023,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,3,8,14010705,1,0,0),(21024,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,3,8,14020805,1,0,0),(21025,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,3,25,14010104,1,0,0),(21026,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,3,25,14020204,1,0,0),(21027,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,3,25,14010304,1,0,0),(21028,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,3,25,14020404,1,0,0),(21029,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,3,0,14010504,1,0,0),(21030,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,3,0,14020604,1,0,0),(21031,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,3,25,14010704,1,0,0),(21032,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,3,25,14020804,1,0,0),(21033,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,3,67,14010103,1,0,0),(21034,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,3,67,14020203,1,0,0),(21035,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,3,67,14010303,1,0,0),(21036,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,3,67,14020403,1,0,0),(21037,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,3,0,14010503,1,0,0),(21038,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,3,0,14020603,1,0,0),(21039,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,3,66,14010703,1,0,0),(21040,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,3,66,14020803,1,0,0),(21041,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,3,167,14010102,1,0,0),(21042,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,3,167,14020202,1,0,0),(21043,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,3,167,14010302,1,0,0),(21044,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,3,167,14020402,1,0,0),(21045,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,3,0,14010502,1,0,0),(21046,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,3,0,14020602,1,0,0),(21047,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,3,166,14010702,1,0,0),(21048,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,3,166,14020802,1,0,0),(21049,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,3,0,14020801,1,0,0),(21050,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,3,0,14020801,1,0,0),(21051,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,3,0,14020801,1,0,0),(21052,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,3,0,14020801,1,0,0),(21053,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,3,0,14020801,1,0,0),(21054,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,3,0,14020801,1,0,0),(21055,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,3,0,14020801,1,0,0),(21056,'[{lv,[1,1000]},{career,1},{is_guarantee,0},{free_can_get,0}]',21,10,10,53010102,1,1,101),(21057,'[{lv,[1,1000]},{career,2},{is_guarantee,0},{free_can_get,0}]',21,10,10,53010202,1,1,101),(21058,'[{lv,[1,1000]},{career,4},{is_guarantee,0},{free_can_get,0}]',21,10,10,53010402,1,1,101),(21059,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,0}]',21,11,10,38040400,1,1,100),(21060,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,0}]',21,12,10,38040401,1,1,100),(21061,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,3,0,14020801,1,0,0),(21062,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,3,0,14020801,1,0,0),(21063,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,2,105,24020001,1,1,1),(21064,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,2,100,24020002,1,1,1),(21065,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,2,80,24020003,1,1,1),(21066,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,2,50,24020004,1,1,1),(21067,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,2,105,20020001,1,1,1),(21068,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,2,100,20020002,1,1,1),(21069,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,2,80,20020003,1,1,1),(21070,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,2,50,20020004,1,1,1),(21071,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,2,0,20020001,1,1,1),(21072,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,2,0,20020002,1,1,1),(21073,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,1,900,18020001,1,0,0),(21074,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,1,900,18060001,1,0,0),(21075,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,1,11,18054801,1,0,0),(21076,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,1,11,18050801,1,0,0),(21077,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,1,11,18050901,1,0,0),(21078,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,1,11,18051001,1,0,0),(21079,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,1,12,18051101,1,0,0),(21080,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,1,12,18051201,1,0,0),(21081,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,1,12,18051301,1,0,0),(21082,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,1,12,18051401,1,0,0),(21083,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,1,12,18051501,1,0,0),(21084,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,1,12,18051601,1,0,0),(21085,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,1,12,18053601,1,0,0),(21086,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,1,12,18053701,1,0,0),(21087,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,1,12,18053801,1,0,0),(21088,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,1,12,18053901,1,0,0),(21089,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,1,12,18054001,1,0,0),(21090,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,1,12,18054101,1,0,0),(21091,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',21,1,12,18054201,1,0,0),(31001,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,1,1600,11020001,1,0,0),(31002,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,1,1600,20060001,1,0,0),(31003,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,1,1300,38260001,1,0,0),(31004,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,1,0,38260001,1,0,0),(31005,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,1,0,38260001,1,0,0),(31006,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,1,0,38260001,1,0,0),(31007,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,1,0,38260001,1,0,0),(31008,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,1,0,38260001,1,0,0),(31009,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,1,0,38260001,1,0,0),(31010,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,300,37020002,1,0,0),(31011,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,800,32010036,1,0,0),(31012,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,100,32010038,1,0,0),(31013,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,0,37020002,1,0,0),(31014,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,0,37020002,1,0,0),(31015,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,0,37020002,1,0,0),(31016,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,0,37020002,1,0,0),(31017,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,2,14010106,1,0,0),(31018,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,2,14020206,1,0,0),(31019,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,2,14010306,1,0,0),(31020,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,2,14020406,1,0,0),(31021,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,0,14010506,1,0,0),(31022,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,0,14020606,1,0,0),(31023,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,1,14010706,1,0,0),(31024,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,1,14020806,1,0,0),(31025,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,14,14010105,1,0,0),(31026,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,14,14020205,1,0,0),(31027,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,13,14010305,1,0,0),(31028,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,13,14020405,1,0,0),(31029,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,0,14010505,1,0,0),(31030,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,0,14020605,1,0,0),(31031,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,13,14010705,1,0,0),(31032,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,13,14020805,1,0,0),(31033,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,34,14010104,1,0,0),(31034,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,34,14020204,1,0,0),(31035,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,33,14010304,1,0,0),(31036,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,33,14020404,1,0,0),(31037,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,0,14010504,1,0,0),(31038,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,0,14020604,1,0,0),(31039,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,33,14010704,1,0,0),(31040,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,33,14020804,1,0,0),(31041,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,84,14010103,1,0,0),(31042,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,84,14020203,1,0,0),(31043,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,83,14010303,1,0,0),(31044,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,83,14020403,1,0,0),(31045,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,0,14010503,1,0,0),(31046,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,0,14020603,1,0,0),(31047,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,83,14010703,1,0,0),(31048,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,83,14020803,1,0,0),(31049,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,167,14010102,1,0,0),(31050,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,167,14020202,1,0,0),(31051,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,167,14010302,1,0,0),(31052,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,167,14020402,1,0,0),(31053,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,0,14010502,1,0,0),(31054,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,0,14020602,1,0,0),(31055,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,166,14010702,1,0,0),(31056,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,166,14020802,1,0,0),(31057,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,0,14020801,1,0,0),(31058,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,0,14020801,1,0,0),(31059,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,0,14020801,1,0,0),(31060,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,0,14020801,1,0,0),(31061,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,0,14020801,1,0,0),(31062,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,0,14020801,1,0,0),(31063,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,0,14020801,1,0,0),(31064,'[{lv,[1,1000]},{career,1},{is_guarantee,0},{free_can_get,0}]',31,10,10,53010105,1,1,101),(31065,'[{lv,[1,1000]},{career,2},{is_guarantee,0},{free_can_get,0}]',31,10,10,53010205,1,1,101),(31066,'[{lv,[1,1000]},{career,4},{is_guarantee,0},{free_can_get,0}]',31,10,10,53010405,1,1,101),(31067,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,0}]',31,11,10,38040402,1,1,100),(31068,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,0}]',31,12,10,38040403,1,1,100),(31069,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,0,14020801,1,0,0),(31070,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,3,0,14020801,1,0,0),(31071,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,2,100,16010001,1,1,1),(31072,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,2,100,16010002,1,1,1),(31073,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,2,80,16010003,1,1,1),(31074,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,2,50,16010004,1,1,1),(31075,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,2,100,20020001,1,1,1),(31076,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,2,100,20020002,1,1,1),(31077,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,2,80,20020003,1,1,1),(31078,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,2,50,20020004,1,1,1),(31079,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,2,0,16010001,1,1,1),(31080,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,2,0,16010002,1,1,1),(31081,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,1,810,18020001,1,0,0),(31082,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,1,810,18060001,1,0,0),(31083,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,1,11,18054801,1,0,0),(31084,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,1,11,18050801,1,0,0),(31085,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,1,11,18050901,1,0,0),(31086,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,1,11,18051001,1,0,0),(31087,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,1,12,18051101,1,0,0),(31088,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,1,12,18051201,1,0,0),(31089,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,1,12,18051301,1,0,0),(31090,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,1,12,18051401,1,0,0),(31091,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,1,12,18051501,1,0,0),(31092,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,1,12,18051601,1,0,0),(31093,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,1,12,18053601,1,0,0),(31094,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,1,12,18053701,1,0,0),(31095,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,1,12,18053801,1,0,0),(31096,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,1,12,18053901,1,0,0),(31097,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,1,12,18054001,1,0,0),(31098,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,1,12,18054101,1,0,0),(31099,'[{lv,[1,1000]},{career,0},{is_guarantee,0},{free_can_get,1}]',31,1,12,18054201,1,0,0);
/*!40000 ALTER TABLE `base_treasure_hunt_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_treasure_hunt_type`
--

DROP TABLE IF EXISTS `base_treasure_hunt_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_treasure_hunt_type` (
  `htype` tinyint(3) unsigned NOT NULL COMMENT '寻宝类型',
  `htype_name` varchar(255) NOT NULL COMMENT '寻宝名字@lang@',
  `goods_id` int(11) unsigned NOT NULL COMMENT '消耗物品id',
  `open_lv` smallint(5) unsigned NOT NULL COMMENT '开启等级',
  `score` varchar(255) NOT NULL COMMENT '增加的积分',
  `bag_loc` tinyint(3) unsigned NOT NULL COMMENT '存放背包',
  `lucky` tinyint(3) unsigned NOT NULL COMMENT '幸运值id',
  `limit_stype` tinyint(3) unsigned NOT NULL COMMENT '寻宝进度对应宝物类型',
  `cost_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT '连抽特殊道具',
  `free_time` int(11) unsigned NOT NULL COMMENT '免费cd',
  PRIMARY KEY (`htype`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='寻宝类型配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_treasure_hunt_type`
--

LOCK TABLES `base_treasure_hunt_type` WRITE;
/*!40000 ALTER TABLE `base_treasure_hunt_type` DISABLE KEYS */;
INSERT INTO `base_treasure_hunt_type` VALUES (3,'魂珠寻宝',0,70,'[{255,36160008, 15, 35}]',29,0,0,'[]',172800),(4,'魂珠寻宝',38180010,70,'[{255,36160008, 15, 35}]',29,0,0,'[{10,38180016}]',0),(11,'装备寻宝',38180001,45,'[{255,36180001, 1}]',16,10,99,'[]',172800),(21,'巅峰秘宝',38180002,371,'[{255,36180001, 2}]',16,20,0,'[]',172800),(31,'至尊寻宝',38180003,480,'[{255,36180001, 2}]',16,30,0,'[]',172800);
/*!40000 ALTER TABLE `base_treasure_hunt_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_treasure_map_config`
--

DROP TABLE IF EXISTS `base_treasure_map_config`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_treasure_map_config` (
  `key` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'key',
  `value` varchar(1024) NOT NULL DEFAULT '[]' COMMENT 'value',
  `about` varchar(1024) NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='藏宝图配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_treasure_map_config`
--

LOCK TABLES `base_treasure_map_config` WRITE;
/*!40000 ALTER TABLE `base_treasure_map_config` DISABLE KEYS */;
INSERT INTO `base_treasure_map_config` VALUES (1,'260101','普通藏宝图物品ID'),(2,'260201','精致藏宝图物品ID'),(3,'260301','神秘藏宝图物品ID'),(4,'600','采集范围600像素'),(5,'21','邀请玩家进入神秘洞穴等级'),(6,'[{9800,3}]','[{采集id,数量}...]，可采集数量上限');
/*!40000 ALTER TABLE `base_treasure_map_config` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_treasure_map_event`
--

DROP TABLE IF EXISTS `base_treasure_map_event`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_treasure_map_event` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `map_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '藏宝图类型',
  `event` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '触发事件',
  `holder_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '持有者等级',
  `holder_reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '持有者奖励',
  `help_reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '帮助者奖励',
  `hole` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '神秘洞穴',
  `mon` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '怪物',
  `holder_mon_reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '持有者杀怪奖励',
  `help_mon_reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '帮助者杀怪奖励',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='藏宝图触发事件';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_treasure_map_event`
--

LOCK TABLES `base_treasure_map_event` WRITE;
/*!40000 ALTER TABLE `base_treasure_map_event` DISABLE KEYS */;
INSERT INTO `base_treasure_map_event` VALUES (1,1,'[{1,90},{2,10}]',10,'[{1,100,[{3,0,2000,150},{3,0,10000,70},{0,260401,1,20},{0,260402,1,20},{0,260403,1,20},{0,260404,1,20},{0,260405,1,20},{0,241001,1,29},{0,241002,1,29},{0,241003,1,29},{0,241006,1,29},{0,241007,1,29},{0,241009,1,29},{0,241011,1,29},{0,241004,1,11},{0,241008,1,11},{0,241010,1,11},{0,241005,1,10},{0,241012,1,10},{0,410144,1,50},{0,400031,1,100},{0,400032,1,40},{0,400033,1,10},{4,0,500,35},{4,0,1000,15},{0,410120,1,80}]}]','[]','[{50,[2180]}]','[]','[]','[]'),(2,1,'[{1,90},{2,10}]',20,'[{1,100,[{3,0,2000,150},{3,0,10000,70},{0,260401,1,20},{0,260402,1,20},{0,260403,1,20},{0,260404,1,20},{0,260405,1,20},{0,241001,1,29},{0,241002,1,29},{0,241003,1,29},{0,241006,1,29},{0,241007,1,29},{0,241009,1,29},{0,241011,1,29},{0,241004,1,11},{0,241008,1,11},{0,241010,1,11},{0,241005,1,10},{0,241012,1,10},{0,410144,1,50},{0,400031,1,100},{0,400032,1,40},{0,400033,1,10},{4,0,500,35},{4,0,1000,15},{0,410120,1,80}]}]','[]','[{50,[2180]}]','[]','[]','[]'),(3,1,'[{1,90},{2,10}]',30,'[{1,100,[{3,0,2000,150},{3,0,10000,70},{0,260401,1,20},{0,260402,1,20},{0,260403,1,20},{0,260404,1,20},{0,260405,1,20},{0,241001,1,29},{0,241002,1,29},{0,241003,1,29},{0,241006,1,29},{0,241007,1,29},{0,241009,1,29},{0,241011,1,29},{0,241004,1,11},{0,241008,1,11},{0,241010,1,11},{0,241005,1,10},{0,241012,1,10},{0,410144,1,50},{0,400031,1,100},{0,400032,1,40},{0,400033,1,10},{4,0,500,35},{4,0,1000,15},{0,410120,1,80}]}]','[]','[{50,[2180]}]','[]','[]','[]'),(4,1,'[{1,90},{2,10}]',40,'[{1,100,[{3,0,2000,150},{3,0,10000,80},{0,260401,1,22},{0,260402,1,22},{0,260403,1,22},{0,260404,1,22},{0,260405,1,22},{0,241001,1,29},{0,241002,1,29},{0,241003,1,29},{0,241006,1,29},{0,241007,1,29},{0,241009,1,29},{0,241011,1,29},{0,241004,1,11},{0,241008,1,11},{0,241010,1,11},{0,241005,1,10},{0,241012,1,10},{0,410144,1,50},{0,400031,1,100},{0,400032,1,40},{0,400033,1,10},{4,0,500,35},{4,0,1000,15},{0,410120,1,80}]}]','[]','[{50,[2180]}]','[]','[]','[]'),(5,1,'[{1,90},{2,10}]',50,'[{1,100,[{3,0,2000,150},{3,0,10000,90},{0,260401,1,22},{0,260402,1,22},{0,260403,1,22},{0,260404,1,22},{0,260405,1,22},{0,241001,1,29},{0,241002,1,29},{0,241003,1,29},{0,241006,1,29},{0,241007,1,29},{0,241009,1,29},{0,241011,1,29},{0,241004,1,11},{0,241008,1,11},{0,241010,1,11},{0,241005,1,10},{0,241012,1,10},{0,410144,1,50},{0,400031,1,100},{0,400032,1,40},{0,400033,1,10},{4,0,500,35},{4,0,1000,15},{0,410120,1,80}]}]','[]','[{50,[2180]}]','[]','[]','[]'),(6,1,'[{1,90},{2,10}]',60,'[{1,100,[{3,0,2000,100},{3,0,10000,100},{0,260401,1,26},{0,260402,1,26},{0,260403,1,26},{0,260404,1,26},{0,260405,1,26},{0,241001,1,24},{0,241002,1,24},{0,241003,1,24},{0,241006,1,24},{0,241007,1,24},{0,241009,1,24},{0,241011,1,24},{0,241004,1,14},{0,241008,1,14},{0,241010,1,14},{0,241005,1,10},{0,241012,1,10},{0,410144,1,50},{0,400031,1,90},{0,400032,1,45},{0,400033,1,15},{4,0,500,30},{4,0,1000,20},{0,410120,1,80}]}]','[]','[{50,[2180]}]','[]','[]','[]'),(7,1,'[{1,90},{2,10}]',70,'[{1,100,[{3,0,2000,90},{3,0,10000,100},{0,260401,1,28},{0,260402,1,28},{0,260403,1,28},{0,260404,1,28},{0,260405,1,28},{0,241001,1,24},{0,241002,1,24},{0,241003,1,24},{0,241006,1,24},{0,241007,1,24},{0,241009,1,24},{0,241011,1,24},{0,241004,1,14},{0,241008,1,14},{0,241010,1,14},{0,241005,1,10},{0,241012,1,10},{0,410144,1,50},{0,400031,1,90},{0,400032,1,45},{0,400033,1,15},{4,0,500,30},{4,0,1000,20},{0,410120,1,80}]}]','[]','[{50,[2180]}]','[]','[]','[]'),(8,1,'[{1,90},{2,10}]',80,'[{1,100,[{3,0,2000,80},{3,0,10000,100},{0,260401,1,30},{0,260402,1,30},{0,260403,1,30},{0,260404,1,30},{0,260405,1,30},{0,241001,1,24},{0,241002,1,24},{0,241003,1,24},{0,241006,1,24},{0,241007,1,24},{0,241009,1,24},{0,241011,1,24},{0,241004,1,14},{0,241008,1,14},{0,241010,1,14},{0,241005,1,10},{0,241012,1,10},{0,410144,1,50},{0,400031,1,90},{0,400032,1,45},{0,400033,1,15},{4,0,500,30},{4,0,1000,20},{0,410120,1,80}]}]','[]','[{50,[2180]}]','[]','[]','[]'),(9,1,'[{1,90},{2,10}]',90,'[{1,100,[{3,0,2000,70},{3,0,10000,100},{0,260401,1,32},{0,260402,1,32},{0,260403,1,32},{0,260404,1,32},{0,260405,1,32},{0,241001,1,24},{0,241002,1,24},{0,241003,1,24},{0,241006,1,24},{0,241007,1,24},{0,241009,1,24},{0,241011,1,24},{0,241004,1,14},{0,241008,1,14},{0,241010,1,14},{0,241005,1,10},{0,241012,1,10},{0,410144,1,50},{0,400031,1,90},{0,400032,1,45},{0,400033,1,15},{4,0,500,30},{4,0,1000,20},{0,410120,1,80}]}]','[]','[{50,[2180]}]','[]','[]','[]'),(12,2,'[{1,90},{3,10}]',40,'[{1,390,[{3,0,40000,39000}]},{2,610,[{0,400004,1,10000},{0,400003,1,15000},{0,111002042,1,1250},{0,111002043,1,250},{0,111004042,1,1250},{0,111004043,1,250},{0,111008042,1,1250},{0,111008043,1,250},{0,111010042,1,1250},{0,111010043,1,250},{0,111003042,1,625},{0,111003043,1,125},{0,111005042,1,625},{0,111005043,1,125},{0,111007042,1,625},{0,111007043,1,125},{0,111009042,1,625},{0,111009043,1,125},{0,111006042,1,500},{0,111006043,1,100},{0,111001042,1,300},{0,111001043,1,100},{0,240301,1,10000},{0,400034,1,8000},{0,400035,1,2000}]}]','[{1,[{3,0,20000,39000}]},{2,[{0,400003,1,10},{0,240301,1,3},{0,110103,1,12}]}]','[]','[{50,8000,5}]','[{1,390,[{3,0,40000,39000}]},{2,610,[{0,400004,1,10000},{0,400003,1,15000},{0,111002042,1,1250},{0,111002043,1,250},{0,111004042,1,1250},{0,111004043,1,250},{0,111008042,1,1250},{0,111008043,1,250},{0,111010042,1,1250},{0,111010043,1,250},{0,111003042,1,625},{0,111003043,1,125},{0,111005042,1,625},{0,111005043,1,125},{0,111007042,1,625},{0,111007043,1,125},{0,111009042,1,625},{0,111009043,1,125},{0,111006042,1,500},{0,111006043,1,100},{0,111001042,1,300},{0,111001043,1,100},{0,240301,1,10000},{0,400034,1,8000},{0,400035,1,2000}]}]','[{1,[{3,0,20000,39000}]},{2,[{0,400003,1,10},{0,240301,1,3},{0,110103,1,12}]}]'),(13,2,'[{1,90},{3,10}]',50,'[{1,349,[{3,0,40000,34900}]},{2,651,[{0,400004,1,10000},{0,400003,1,10000},{0,111002052,1,1000},{0,111002053,1,200},{0,111004052,1,1000},{0,111004053,1,200},{0,111008052,1,1000},{0,111008053,1,200},{0,111010052,1,1000},{0,111010053,1,200},{0,111003052,1,500},{0,111003053,1,100},{0,111005052,1,500},{0,111005053,1,100},{0,111007052,1,500},{0,111007053,1,100},{0,111009052,1,500},{0,111009053,1,100},{0,111006052,1,400},{0,111006053,1,100},{0,111001052,1,300},{0,111001053,1,100},{0,240301,1,8000},{0,240302,1,3000},{0,400034,1,8000},{0,400035,1,2000}]}]','[{1,[{3,0,20000,39000}]},{2,[{0,400003,1,10},{0,240301,1,4},{0,110103,1,12}]}]','[]','[{50,8000,5},{50,8001,5}]','[{1,349,[{3,0,40000,34900}]},{2,651,[{0,400004,1,10000},{0,400003,1,10000},{0,111002052,1,1000},{0,111002053,1,200},{0,111004052,1,1000},{0,111004053,1,200},{0,111008052,1,1000},{0,111008053,1,200},{0,111010052,1,1000},{0,111010053,1,200},{0,111003052,1,500},{0,111003053,1,100},{0,111005052,1,500},{0,111005053,1,100},{0,111007052,1,500},{0,111007053,1,100},{0,111009052,1,500},{0,111009053,1,100},{0,111006052,1,400},{0,111006053,1,100},{0,111001052,1,300},{0,111001053,1,100},{0,240301,1,8000},{0,240302,1,3000},{0,400034,1,8000},{0,400035,1,2000}]}]','[{1,[{3,0,20000,39000}]},{2,[{0,400003,1,10},{0,240301,1,4},{0,110103,1,12}]}]'),(14,2,'[{1,90},{3,10}]',60,'[{1,332,[{3,0,40000,33200}]},{2,668,[{0,400004,1,10000},{0,400003,1,10000},{0,111002062,1,875},{0,111002063,1,175},{0,111004062,1,875},{0,111004063,1,175},{0,111008062,1,875},{0,111008063,1,175},{0,111010062,1,875},{0,111010063,1,175},{0,111003062,1,425},{0,111003063,1,75},{0,111005062,1,425},{0,111005063,1,75},{0,111007062,1,425},{0,111007063,1,75},{0,111009062,1,425},{0,111009063,1,75},{0,111006062,1,300},{0,111001062,1,300},{0,240301,1,6000},{0,240302,1,6000},{0,400034,1,8000},{0,400035,1,2000}]}]','[{1,[{3,0,20000,39000}]},{2,[{0,400003,1,10},{0,240301,1,5},{0,110103,1,12}]}]','[]','[{50,8000,5},{50,8001,5},{50,8002,5}]','[{1,332,[{3,0,40000,33200}]},{2,668,[{0,400004,1,10000},{0,400003,1,10000},{0,111002062,1,875},{0,111002063,1,175},{0,111004062,1,875},{0,111004063,1,175},{0,111008062,1,875},{0,111008063,1,175},{0,111010062,1,875},{0,111010063,1,175},{0,111003062,1,425},{0,111003063,1,75},{0,111005062,1,425},{0,111005063,1,75},{0,111007062,1,425},{0,111007063,1,75},{0,111009062,1,425},{0,111009063,1,75},{0,111006062,1,300},{0,111001062,1,300},{0,240301,1,6000},{0,240302,1,6000},{0,400034,1,8000},{0,400035,1,2000}]}]','[{1,[{3,0,20000,39000}]},{2,[{0,400003,1,10},{0,240301,1,5},{0,110103,1,12}]}]'),(15,2,'[{1,90},{3,10}]',70,'[{1,342,[{3,0,40000,34200}]},{2,658,[{0,400004,1,10000},{0,400003,1,10000},{0,111002072,1,750},{0,111002073,1,150},{0,111004072,1,750},{0,111004073,1,150},{0,111008072,1,750},{0,111008073,1,150},{0,111010072,1,750},{0,111010073,1,150},{0,111003072,1,375},{0,111003073,1,75},{0,111005072,1,375},{0,111005073,1,75},{0,111007072,1,375},{0,111007073,1,75},{0,111009072,1,375},{0,111009073,1,75},{0,111006072,1,200},{0,111001072,1,200},{0,240301,1,4000},{0,240302,1,5000},{0,240303,1,2000},{0,400034,1,8000},{0,400035,1,2000}]}]','[{1,[{3,0,20000,39000}]},{2,[{0,400003,1,10},{0,240301,1,6},{0,110103,1,12}]}]','[]','[{50,8000,5},{50,8001,5},{50,8002,5}]','[{1,342,[{3,0,40000,34200}]},{2,658,[{0,400004,1,10000},{0,400003,1,10000},{0,111002072,1,750},{0,111002073,1,150},{0,111004072,1,750},{0,111004073,1,150},{0,111008072,1,750},{0,111008073,1,150},{0,111010072,1,750},{0,111010073,1,150},{0,111003072,1,375},{0,111003073,1,75},{0,111005072,1,375},{0,111005073,1,75},{0,111007072,1,375},{0,111007073,1,75},{0,111009072,1,375},{0,111009073,1,75},{0,111006072,1,200},{0,111001072,1,200},{0,240301,1,4000},{0,240302,1,5000},{0,240303,1,2000},{0,400034,1,8000},{0,400035,1,2000}]}]','[{1,[{3,0,20000,39000}]},{2,[{0,400003,1,10},{0,240301,1,6},{0,110103,1,12}]}]'),(16,2,'[{1,90},{3,10}]',80,'[{1,354,[{3,0,40000,35400}]},{2,646,[{0,400004,1,10000},{0,400003,1,10000},{0,111002082,1,625},{0,111002083,1,125},{0,111004082,1,625},{0,111004083,1,125},{0,111008082,1,625},{0,111008083,1,125},{0,111010082,1,625},{0,111010083,1,125},{0,111003082,1,300},{0,111003083,1,50},{0,111005082,1,300},{0,111005083,1,50},{0,111007082,1,300},{0,111007083,1,50},{0,111009082,1,300},{0,111009083,1,50},{0,111006082,1,100},{0,111001082,1,100},{0,240301,1,2000},{0,240302,1,4000},{0,240303,1,4000},{0,400034,1,8000},{0,400035,1,2000}]}]','[{1,[{3,0,20000,39000}]},{2,[{0,400003,1,10},{0,240301,1,8},{0,110103,1,12}]}]','[]','[{50,8000,5},{50,8001,5},{50,8002,5}]','[{1,354,[{3,0,40000,35400}]},{2,646,[{0,400004,1,10000},{0,400003,1,10000},{0,111002082,1,625},{0,111002083,1,125},{0,111004082,1,625},{0,111004083,1,125},{0,111008082,1,625},{0,111008083,1,125},{0,111010082,1,625},{0,111010083,1,125},{0,111003082,1,300},{0,111003083,1,50},{0,111005082,1,300},{0,111005083,1,50},{0,111007082,1,300},{0,111007083,1,50},{0,111009082,1,300},{0,111009083,1,50},{0,111006082,1,100},{0,111001082,1,100},{0,240301,1,2000},{0,240302,1,4000},{0,240303,1,4000},{0,400034,1,8000},{0,400035,1,2000}]}]','[{1,[{3,0,20000,39000}]},{2,[{0,400003,1,10},{0,240301,1,8},{0,110103,1,12}]}]'),(17,2,'[{1,90},{3,10}]',90,'[{1,374,[{3,0,40000,37400}]},{2,626,[{0,400004,1,10000},{0,400003,1,10000},{0,111002092,1,500},{0,111002093,1,100},{0,111004092,1,500},{0,111004093,1,100},{0,111008092,1,500},{0,111008093,1,100},{0,111010092,1,500},{0,111010093,1,100},{0,111003092,1,250},{0,111003093,1,50},{0,111005092,1,250},{0,111005093,1,50},{0,111007092,1,250},{0,111007093,1,50},{0,111009092,1,250},{0,111009093,1,50},{0,240302,1,4000},{0,240303,1,4000},{0,400034,1,8000},{0,400035,1,2000}]}]','[{1,[{3,0,20000,39000}]},{2,[{0,400003,1,10},{0,240301,1,8},{0,110103,1,12}]}]','[]','[{50,8000,5},{50,8001,5},{50,8002,5}]','[{1,374,[{3,0,40000,37400}]},{2,626,[{0,400004,1,10000},{0,400003,1,10000},{0,111002092,1,500},{0,111002093,1,100},{0,111004092,1,500},{0,111004093,1,100},{0,111008092,1,500},{0,111008093,1,100},{0,111010092,1,500},{0,111010093,1,100},{0,111003092,1,250},{0,111003093,1,50},{0,111005092,1,250},{0,111005093,1,50},{0,111007092,1,250},{0,111007093,1,50},{0,111009092,1,250},{0,111009093,1,50},{0,240302,1,4000},{0,240303,1,4000},{0,400034,1,8000},{0,400035,1,2000}]}]','[{1,[{3,0,20000,39000}]},{2,[{0,400003,1,10},{0,240301,1,8},{0,110103,1,12}]}]'),(18,3,'[{1,100}]',20,'[{1,50,[{0,110101,1,50},{1,0,1000,50},{3,0,2000,50}]},{2,50,[{0,110101,2,50},{1,0,2000,50},{3,0,3000,50}]}]','[{1,[{0,110101,1,50},{1,0,1000,50},{3,0,2000,50}]},{2,[{0,110101,2,50},{1,0,2000,50},{3,0,3000,50}]}]','[]','[]','[]','[]'),(19,3,'[{1,100}]',30,'[{1,50,[{0,110101,1,50},{1,0,1000,50},{3,0,2000,50}]},{2,50,[{0,110101,2,50},{1,0,2000,50},{3,0,3000,50}]}]','[{1,[{0,110101,1,50},{1,0,1000,50},{3,0,2000,50}]},{2,[{0,110101,2,50},{1,0,2000,50},{3,0,3000,50}]}]','[]','[]','[]','[]'),(20,3,'[{1,100}]',40,'[{1,50,[{0,110101,1,50},{1,0,1000,50},{3,0,2000,50}]},{2,50,[{0,110101,2,50},{1,0,2000,50},{3,0,3000,50}]}]','[{1,[{0,110101,1,50},{1,0,1000,50},{3,0,2000,50}]},{2,[{0,110101,2,50},{1,0,2000,50},{3,0,3000,50}]}]','[]','[]','[]','[]'),(21,3,'[{1,100}]',50,'[{1,50,[{0,110101,1,50},{1,0,1000,50},{3,0,2000,50}]},{2,50,[{0,110101,2,50},{1,0,2000,50},{3,0,3000,50}]}]','[{1,[{0,110101,1,50},{1,0,1000,50},{3,0,2000,50}]},{2,[{0,110101,2,50},{1,0,2000,50},{3,0,3000,50}]}]','[]','[]','[]','[]'),(22,3,'[{1,100}]',60,'[{1,50,[{0,110101,1,50},{1,0,1000,50},{3,0,2000,50}]},{2,50,[{0,110101,2,50},{1,0,2000,50},{3,0,3000,50}]}]','[{1,[{0,110101,1,50},{1,0,1000,50},{3,0,2000,50}]},{2,[{0,110101,2,50},{1,0,2000,50},{3,0,3000,50}]}]','[]','[]','[]','[]'),(23,3,'[{1,100}]',70,'[{1,50,[{0,110101,1,50},{1,0,1000,50},{3,0,2000,50}]},{2,50,[{0,110101,2,50},{1,0,2000,50},{3,0,3000,50}]}]','[{1,[{0,110101,1,50},{1,0,1000,50},{3,0,2000,50}]},{2,[{0,110101,2,50},{1,0,2000,50},{3,0,3000,50}]}]','[]','[]','[]','[]'),(24,3,'[{1,100}]',80,'[{1,50,[{0,110101,1,50},{1,0,1000,50},{3,0,2000,50}]},{2,50,[{0,110101,2,50},{1,0,2000,50},{3,0,3000,50}]}]','[{1,[{0,110101,1,50},{1,0,1000,50},{3,0,2000,50}]},{2,[{0,110101,2,50},{1,0,2000,50},{3,0,3000,50}]}]','[]','[]','[]','[]'),(25,3,'[{1,100}]',90,'[{1,50,[{0,110101,1,50},{1,0,1000,50},{3,0,2000,50}]},{2,50,[{0,110101,2,50},{1,0,2000,50},{3,0,3000,50}]}]','[{1,[{0,110101,1,50},{1,0,1000,50},{3,0,2000,50}]},{2,[{0,110101,2,50},{1,0,2000,50},{3,0,3000,50}]}]','[]','[]','[]','[]');
/*!40000 ALTER TABLE `base_treasure_map_event` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_treasure_miners`
--

DROP TABLE IF EXISTS `base_treasure_miners`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_treasure_miners` (
  `miner_id` tinyint(3) unsigned NOT NULL COMMENT '矿工id',
  `type` tinyint(3) unsigned NOT NULL COMMENT '矿工类型',
  `name` varchar(255) NOT NULL COMMENT '矿工名@lang@',
  `cost` varchar(255) NOT NULL COMMENT '激活消耗',
  `attr` varchar(255) NOT NULL COMMENT '属性',
  `tips` varchar(1024) NOT NULL COMMENT '描述',
  PRIMARY KEY (`miner_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='宝藏系统矿工配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_treasure_miners`
--

LOCK TABLES `base_treasure_miners` WRITE;
/*!40000 ALTER TABLE `base_treasure_miners` DISABLE KEYS */;
INSERT INTO `base_treasure_miners` VALUES (1,1,'矿工1号','[{0,38320001,1}]','[{extra_times,0},{extra_coin,16667}]','每日额外产出10万金币!'),(2,1,'矿工2号','[{0,38320002,1}]','[{extra_times,0},{extra_coin,33333}]','每日额外产出20万金币!'),(3,1,'矿工3号','[{0,38320003,1}]','[{extra_times,0},{extra_coin,50000}]','每日额外产出30万金币!'),(4,1,'矿工4号','[{0,38320004,1}]','[{extra_times,0},{extra_coin,91667}]','每日额外产出55万金币!'),(5,1,'矿工5号','[{0,38320005,1}]','[{extra_times,0},{extra_coin,166667}]','每日额外产出100万金币!');
/*!40000 ALTER TABLE `base_treasure_miners` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_treasure_pay_reward`
--

DROP TABLE IF EXISTS `base_treasure_pay_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_treasure_pay_reward` (
  `id` tinyint(3) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `type` tinyint(3) unsigned NOT NULL COMMENT '领取类型',
  `time` tinyint(3) unsigned NOT NULL COMMENT '领取次数',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `crit` varchar(1024) NOT NULL COMMENT '暴击倍率',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=46 DEFAULT CHARSET=utf8 COMMENT='宝藏系统付费领取配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_treasure_pay_reward`
--

LOCK TABLES `base_treasure_pay_reward` WRITE;
/*!40000 ALTER TABLE `base_treasure_pay_reward` DISABLE KEYS */;
INSERT INTO `base_treasure_pay_reward` VALUES (1,3,1,'{1,0,0}','[{1000,1}]'),(2,3,2,'{1,0,10}','[{1000,1}]'),(3,3,3,'{1,0,15}','[{1000,1}]'),(4,3,4,'{1,0,20}','[{1000,1}]'),(5,3,5,'{1,0,25}','[{1000,1}]'),(6,3,6,'{1,0,30}','[{1000,1}]'),(7,3,7,'{1,0,35}','[{1000,1}]'),(8,3,8,'{1,0,40}','[{1000,1}]'),(9,3,9,'{1,0,45}','[{1000,1}]'),(10,3,10,'{1,0,50}','[{1000,1}]'),(11,3,11,'{1,0,55}','[{1000,1}]'),(12,3,12,'{1,0,60}','[{1000,1}]'),(13,3,13,'{1,0,65}','[{1000,1}]'),(14,3,14,'{1,0,70}','[{1000,1}]'),(15,3,15,'{1,0,75}','[{1000,1}]'),(16,3,16,'{1,0,80}','[{1000,1}]'),(17,3,17,'{1,0,85}','[{1000,1}]'),(18,3,18,'{1,0,90}','[{1000,1}]'),(19,3,19,'{1,0,95}','[{1000,1}]'),(20,3,20,'{1,0,100}','[{1000,1}]'),(21,2,1,'{2,0,30}','[{650,1},{200,2},{150,3}]'),(22,2,2,'{2,0,40}','[{650,1},{200,2},{150,3}]'),(23,2,3,'{2,0,50}','[{650,1},{200,2},{150,3}]'),(24,2,4,'{2,0,50}','[{650,1},{200,2},{150,3}]'),(25,2,5,'{2,0,50}','[{650,1},{200,2},{150,3}]'),(26,2,6,'{2,0,50}','[{650,1},{200,2},{150,3}]'),(27,2,7,'{2,0,50}','[{650,1},{200,2},{150,3}]'),(28,2,8,'{2,0,50}','[{650,1},{200,2},{150,3}]'),(29,2,9,'{2,0,50}','[{650,1},{200,2},{150,3}]'),(30,2,10,'{2,0,60}','[{650,1},{200,2},{150,3}]'),(31,2,11,'{2,0,60}','[{650,1},{200,2},{150,3}]'),(32,2,12,'{2,0,60}','[{650,1},{200,2},{150,3}]'),(33,2,13,'{2,0,60}','[{650,1},{200,2},{150,3}]'),(34,2,14,'{2,0,60}','[{650,1},{200,2},{150,3}]'),(35,2,15,'{2,0,60}','[{650,1},{200,2},{150,3}]'),(36,2,16,'{2,0,70}','[{650,1},{200,2},{150,3}]'),(37,2,17,'{2,0,70}','[{650,1},{200,2},{150,3}]'),(38,2,18,'{2,0,70}','[{650,1},{200,2},{150,3}]'),(39,2,19,'{2,0,70}','[{650,1},{200,2},{150,3}]'),(40,2,20,'{2,0,70}','[{650,1},{200,2},{150,3}]'),(41,2,21,'{2,0,80}','[{650,1},{200,2},{150,3}]'),(42,2,22,'{2,0,80}','[{650,1},{200,2},{150,3}]'),(43,2,23,'{2,0,80}','[{650,1},{200,2},{150,3}]'),(44,2,24,'{2,0,80}','[{650,1},{200,2},{150,3}]'),(45,2,25,'{2,0,80}','[{650,1},{200,2},{150,3}]');
/*!40000 ALTER TABLE `base_treasure_pay_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_treasure_reward`
--

DROP TABLE IF EXISTS `base_treasure_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_treasure_reward` (
  `id` smallint(5) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `type` tinyint(3) unsigned NOT NULL COMMENT '类型（金币/经验）',
  `min_lv` smallint(5) NOT NULL COMMENT '等级下限',
  `max_lv` smallint(5) NOT NULL COMMENT '等级上限',
  `reward` int(11) NOT NULL COMMENT '奖励数量',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=128 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_treasure_reward`
--

LOCK TABLES `base_treasure_reward` WRITE;
/*!40000 ALTER TABLE `base_treasure_reward` DISABLE KEYS */;
INSERT INTO `base_treasure_reward` VALUES (1,3,1,150,2205600),(2,3,151,160,2386970),(3,3,161,170,2555640),(4,3,171,180,2708610),(5,3,181,190,2842880),(6,3,191,200,2955450),(7,3,201,210,3043320),(8,3,211,220,3103490),(9,3,221,230,3726720),(10,3,231,240,4533318),(11,3,241,250,4715943),(12,3,251,260,4906068),(13,3,261,270,6424687),(14,3,271,280,7996677),(15,3,281,290,7239262),(16,3,291,300,7386012),(17,3,301,310,9920126),(18,3,311,320,14096891),(19,3,321,330,14947706),(20,3,331,340,20032571),(21,3,341,350,25425847),(22,3,351,360,28057289),(23,3,361,370,25521483),(24,3,371,380,26091483),(25,3,381,390,29091483),(26,3,391,400,32091483),(27,3,401,410,35091483),(28,3,411,420,38091483),(29,3,421,430,41091483),(30,3,431,440,44091483),(31,3,441,450,76791483),(32,3,451,460,79791483),(33,3,461,470,82791483),(34,3,471,480,85791483),(35,3,481,490,88791483),(36,3,491,500,91791483),(37,3,501,510,94791483),(38,3,511,520,97791483),(39,3,521,530,117891483),(40,3,531,540,227091483),(41,3,541,550,239091483),(42,3,551,560,251091483),(43,3,561,570,263091483),(44,3,571,580,275091483),(45,3,581,590,287091483),(46,3,591,600,299091483),(47,3,601,610,311091483),(48,3,611,620,323091483),(49,3,621,630,335091483),(50,3,631,640,347091483),(51,3,641,650,359091483),(52,3,651,660,371091483),(53,3,661,670,383091483),(54,3,671,680,395091483),(55,3,681,690,407091483),(56,3,691,700,419091483),(57,3,701,710,431091483),(58,3,711,720,443091483),(59,3,721,730,455091483),(60,3,731,740,467091483),(61,3,741,750,479091483),(62,3,751,760,491091483),(63,3,761,770,503091483),(64,3,771,780,515091483),(65,3,781,1000,527091483),(86,2,1,190,70000),(87,2,191,230,80000),(88,2,231,249,90000),(89,2,250,270,135000),(90,2,271,284,195000),(91,2,285,295,231000),(92,2,296,305,255000),(93,2,306,320,276000),(94,2,321,340,295575),(95,2,341,360,315600),(96,2,361,380,369775),(97,2,381,400,419150),(98,2,401,420,476025),(99,2,421,440,540400),(100,2,441,460,636600),(101,2,461,480,748725),(102,2,481,500,879450),(103,2,501,520,1019438),(104,2,521,540,1209113),(105,2,541,560,1473150),(106,2,561,580,1761150),(107,2,581,600,2079150),(108,2,601,620,2427150),(109,2,621,640,2805150),(110,2,641,660,3213150),(111,2,661,680,3651150),(112,2,681,700,4119150),(113,2,701,720,4617150),(114,2,721,740,5145150),(115,2,741,760,5703150),(116,2,761,780,6291150),(117,2,781,800,6879150),(118,2,801,820,6979150),(119,2,821,840,7079150),(120,2,841,860,7179150),(121,2,861,880,7279150),(122,2,881,900,7379150),(123,2,901,920,7479150),(124,2,921,940,7579150),(125,2,941,960,7679150),(126,2,961,980,7779150),(127,2,981,1000,7879150);
/*!40000 ALTER TABLE `base_treasure_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_twing`
--

DROP TABLE IF EXISTS `base_twing`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_twing` (
  `wing_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '翅膀id',
  `grade` int(11) NOT NULL DEFAULT '0' COMMENT '阶数',
  `attr` varchar(512) NOT NULL DEFAULT '[]' COMMENT '属性',
  `career` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '职业',
  `power` int(11) DEFAULT '0' COMMENT '默认战力',
  `description` varchar(255) NOT NULL COMMENT '描述',
  PRIMARY KEY (`wing_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='翅膀配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_twing`
--

LOCK TABLES `base_twing` WRITE;
/*!40000 ALTER TABLE `base_twing` DISABLE KEYS */;
INSERT INTO `base_twing` VALUES (20010011,0,'[{1,70},{2,1400},{48,45}]',1,4150,'抛弃了束缚自身的规则与均衡之道，充满黑暗力量的羽翼'),(20010012,1,'[{1,1050},{2,21000},{48,675}]',1,62250,'破开世间一切束缚自身的法则，信奉黑暗，在黑暗世界前行'),(20010013,2,'[{1,2520},{2,50400},{48,1620},{54,100}]',1,184400,'当你越向前行，越会发现，你对黑暗的力量一无所知'),(20010014,3,'[{1,4480},{2,89600},{48,2880},{54,150}]',1,318100,'当你越向前行，越会发现，你对黑暗的力量一无所知'),(20010015,4,'[{1,12600},{2,252000},{48,8100},{54,300}]',1,852000,'当你越向前行，越会发现，你对黑暗的力量一无所知'),(20010016,5,'[{1,25200},{2,504000},{48,16200},{54,500}]',1,1669000,'当你越向前行，越会发现，你对黑暗的力量一无所知'),(20010021,0,'[{1,70},{2,1400},{48,45}]',2,4150,'信奉这时间的规则与均衡之道，充满光明力量的羽翼'),(20010022,1,'[{1,1050},{2,21000},{48,675}]',2,62250,'守护世间一切正义的法则，信奉光明，在光明中前行'),(20010023,2,'[{1,2520},{2,50400},{48,1620},{54,100}]',2,184400,'当你越向前行，越会发现，光明的的力量也强大无匹'),(20010024,3,'[{1,4480},{2,89600},{48,2880},{54,150}]',2,318100,'当你越向前行，越会发现，光明的的力量也强大无匹'),(20010025,4,'[{1,12600},{2,252000},{48,8100},{54,300}]',2,852000,'当你越向前行，越会发现，光明的的力量也强大无匹'),(20010026,5,'[{1,25200},{2,504000},{48,16200},{54,500}]',2,1669000,'当你越向前行，越会发现，光明的的力量也强大无匹'),(20010031,0,'[{1,70},{2,1400},{48,45}]',3,4150,'大萨达撒大所大所大所大所多撒大所大'),(20010032,1,'[{1,1050},{2,21000},{48,675}]',3,62250,'大萨达撒大所大所大所大所多撒大所大'),(20010033,2,'[{1,2520},{2,50400},{48,1620},{54,100}]',3,184400,'大萨达撒大所大所大所大所多撒大所大'),(20010034,3,'[{1,4480},{2,89600},{48,2880},{54,150}]',3,318100,'大萨达撒大所大所大所大所多撒大所大'),(20010035,4,'[{1,12600},{2,252000},{48,8100},{54,300}]',3,852000,'大萨达撒大所大所大所大所多撒大所大'),(20010036,5,'[{1,25200},{2,504000},{48,16200},{54,500}]',3,1669000,'大萨达撒大所大所大所大所多撒大所大'),(20010041,0,'[{1,70},{2,1400},{48,45}]',4,4150,'不守常规，信奉科技之道，充满科技力量的羽翼'),(20010042,1,'[{1,1050},{2,21000},{48,675}]',4,62250,'蝴蝶扇一扇翅膀，会在这世间引起什么样的风暴呢？'),(20010043,2,'[{1,2520},{2,50400},{48,1620},{54,100}]',4,184400,'红莲业火，焚烧世间。那一抹嫣红，是世间极美的风景'),(20010044,3,'[{1,4480},{2,89600},{48,2880},{54,150}]',4,318100,'红莲业火，焚烧世间。那一抹嫣红，是世间极美的风景'),(20010045,4,'[{1,12600},{2,252000},{48,8100},{54,300}]',4,852000,'红莲业火，焚烧世间。那一抹嫣红，是世间极美的风景'),(20010046,5,'[{1,25200},{2,504000},{48,16200},{54,500}]',4,1669000,'红莲业火，焚烧世间。那一抹嫣红，是世间极美的风景');
/*!40000 ALTER TABLE `base_twing` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_twing_compose`
--

DROP TABLE IF EXISTS `base_twing_compose`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_twing_compose` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '合成id',
  `grade` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '目标阶数',
  `targer_list` varchar(512) NOT NULL DEFAULT '[]' COMMENT '目标翅膀',
  `ratio` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '初始概率',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗材料',
  `cost_wing_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗的翅膀材料',
  `extra_ratio` tinyint(1) NOT NULL DEFAULT '0' COMMENT '幸运商品标志',
  `lv` int(11) NOT NULL DEFAULT '0' COMMENT '开放等级',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='合成配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_twing_compose`
--

LOCK TABLES `base_twing_compose` WRITE;
/*!40000 ALTER TABLE `base_twing_compose` DISABLE KEYS */;
INSERT INTO `base_twing_compose` VALUES (1,1,'[{1,[{20010012,70},{20010022,15},{20010042,15}]},{2,[{20010012,15},{20010022,70},{20010042,15}]},{4,[{20010012,15},{20010022,15},{20010042,70}]}]',100,'[{0,20040001,1}]','[]',0,1),(2,2,'[{1,[{20010013,60},{20010023,20},{20010043,20}]},{2,[{20010013,20},{20010023,60},{20010043,20}]},{4,[{20010013,20},{20010023,20},{20010043,60}]}]',50,'[{0,20040002,1}]','[{0,20010012,1},{0,20010022,1},{0,20010032,1},{0,20010042,1}]',1,1),(3,3,'[{1,[{20010014,50},{20010024,25},{20010044,25}]},{2,[{20010014,25},{20010024,50},{20010044,25}]},{4,[{20010014,25},{20010024,25},{20010044,50}]}]',40,'[{0,20040003,1}]','[{0,20010013,1},{0,20010023,1},{0,20010033,1},{0,20010043,1}]',1,200),(4,4,'[{1,[{20010015,500}]},{2,[{20010015,500}]},{4,[{20010015,500}]}]',20,'[{0,20040004,1}]','[{0,20010014,1},{0,20010024,1},{0,20010034,1},{0,20010044,1}]',1,300),(5,4,'[{1,[{20010025,500}]},{2,[{20010025,500}]},{4,[{20010025,500}]}]',20,'[{0,20040004,1}]','[{0,20010014,1},{0,20010024,1},{0,20010034,1},{0,20010044,1}]',1,300),(6,4,'[{1,[{20010045,500}]},{2,[{20010045,500}]},{4,[{20010045,500}]}]',20,'[{0,20040004,1}]','[{0,20010014,1},{0,20010024,1},{0,20010034,1},{0,20010044,1}]',1,300),(7,5,'[{1,[{20010016,500}]},{2,[{20010016,500}]},{4,[{20010016,500}]}]',10,'[{0,20040005,2},{0,20040000,2}]','[{0,20010015,1},{0,20010025,1},{0,20010035,1},{0,20010045,1}]',1,350),(8,5,'[{1,[{20010026,500}]},{2,[{20010026,500}]},{4,[{20010026,500}]}]',10,'[{0,20040005,2},{0,20040000,2}]','[{0,20010015,1},{0,20010025,1},{0,20010035,1},{0,20010045,1}]',1,350),(9,5,'[{1,[{20010046,500}]},{2,[{20010046,500}]},{4,[{20010046,500}]}]',10,'[{0,20040005,2},{0,20040000,2}]','[{0,20010015,1},{0,20010025,1},{0,20010035,1},{0,20010045,1}]',1,350);
/*!40000 ALTER TABLE `base_twing_compose` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_twing_compose_ratio`
--

DROP TABLE IF EXISTS `base_twing_compose_ratio`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_twing_compose_ratio` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品id',
  `ratio` varchar(255) NOT NULL DEFAULT '[]' COMMENT '增加成功率',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='幸运材料配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_twing_compose_ratio`
--

LOCK TABLES `base_twing_compose_ratio` WRITE;
/*!40000 ALTER TABLE `base_twing_compose_ratio` DISABLE KEYS */;
INSERT INTO `base_twing_compose_ratio` VALUES (1001010142,'[{2,1}]'),(1001010143,'[{2,1}]'),(1001010242,'[{2,1}]'),(1001010243,'[{2,1}]'),(1001010342,'[{2,1}]'),(1001010343,'[{2,1}]'),(1001010442,'[{2,1}]'),(1001010443,'[{2,1}]'),(1001010542,'[{2,1}]'),(1001010543,'[{2,1}]'),(1001010642,'[{2,1}]'),(1001010643,'[{2,2}]'),(1001010742,'[{2,1}]'),(1001010743,'[{2,3},{3,1}]'),(1001010842,'[{2,1}]'),(1001010843,'[{2,4},{3,1}]'),(1001010942,'[{2,2}]'),(1001010943,'[{2,5},{3,1},{4,1}]'),(1001011042,'[{2,2},{3,1}]'),(1001011043,'[{2,7},{3,2},{4,1}]'),(1001011142,'[{2,3},{3,1}]'),(1001011143,'[{2,10},{3,3},{4,1},{5,1},{6,1}]'),(1001011242,'[{2,5},{3,1}]'),(1001011243,'[{2,15},{3,4},{4,1},{5,1},{6,1}]'),(1001011342,'[{2,7},{3,2},{4,1}]'),(1001011343,'[{2,20},{3,5},{4,2},{5,1},{6,1}]'),(1001011442,'[{2,9},{3,2},{4,1},{5,1}]'),(1001011443,'[{2,26},{3,7},{4,3},{5,2},{6,1}]'),(1001011542,'[{2,10},{3,3},{4,1},{5,1},{6,1}]'),(1001011543,'[{2,31},{3,8},{4,3},{5,2},{6,2}]'),(1001011642,'[{2,12},{3,3},{4,1},{5,1},{6,1}]'),(1001011643,'[{2,37},{3,9},{4,4},{5,2},{6,2}]'),(1001020142,'[{2,1}]'),(1001020143,'[{2,1}]'),(1001020242,'[{2,1}]'),(1001020243,'[{2,1}]'),(1001020342,'[{2,1}]'),(1001020343,'[{2,1}]'),(1001020442,'[{2,1}]'),(1001020443,'[{2,1}]'),(1001020542,'[{2,1}]'),(1001020543,'[{2,1}]'),(1001020642,'[{2,1}]'),(1001020643,'[{2,2}]'),(1001020742,'[{2,1}]'),(1001020743,'[{2,3},{3,1}]'),(1001020842,'[{2,1}]'),(1001020843,'[{2,4},{3,1}]'),(1001020942,'[{2,2}]'),(1001020943,'[{2,5},{3,1},{4,1}]'),(1001021042,'[{2,2},{3,1}]'),(1001021043,'[{2,7},{3,2},{4,1}]'),(1001021142,'[{2,3},{3,1}]'),(1001021143,'[{2,10},{3,3},{4,1},{5,1},{6,1}]'),(1001021242,'[{2,5},{3,1}]'),(1001021243,'[{2,15},{3,4},{4,1},{5,1},{6,1}]'),(1001021342,'[{2,7},{3,2},{4,1}]'),(1001021343,'[{2,20},{3,5},{4,2},{5,1},{6,1}]'),(1001021442,'[{2,9},{3,2},{4,1},{5,1}]'),(1001021443,'[{2,26},{3,7},{4,3},{5,2},{6,1}]'),(1001021542,'[{2,10},{3,3},{4,1},{5,1},{6,1}]'),(1001021543,'[{2,31},{3,8},{4,3},{5,2},{6,2}]'),(1001021642,'[{2,12},{3,3},{4,1},{5,1},{6,1}]'),(1001021643,'[{2,37},{3,9},{4,4},{5,2},{6,2}]'),(1001030142,'[{2,1}]'),(1001030143,'[{2,1}]'),(1001030242,'[{2,1}]'),(1001030243,'[{2,1}]'),(1001030342,'[{2,1}]'),(1001030343,'[{2,1}]'),(1001030442,'[{2,1}]'),(1001030443,'[{2,1}]'),(1001030542,'[{2,1}]'),(1001030543,'[{2,1}]'),(1001030642,'[{2,1}]'),(1001030643,'[{2,2}]'),(1001030742,'[{2,1}]'),(1001030743,'[{2,3},{3,1}]'),(1001030842,'[{2,1}]'),(1001030843,'[{2,4},{3,1}]'),(1001030942,'[{2,2}]'),(1001030943,'[{2,5},{3,1},{4,1}]'),(1001031042,'[{2,2},{3,1}]'),(1001031043,'[{2,7},{3,2},{4,1}]'),(1001031142,'[{2,3},{3,1}]'),(1001031143,'[{2,10},{3,3},{4,1},{5,1},{6,1}]'),(1001031242,'[{2,5},{3,1}]'),(1001031243,'[{2,15},{3,4},{4,1},{5,1},{6,1}]'),(1001031342,'[{2,7},{3,2},{4,1}]'),(1001031343,'[{2,20},{3,5},{4,2},{5,1},{6,1}]'),(1001031442,'[{2,9},{3,2},{4,1},{5,1}]'),(1001031443,'[{2,26},{3,7},{4,3},{5,2},{6,1}]'),(1001031542,'[{2,10},{3,3},{4,1},{5,1},{6,1}]'),(1001031543,'[{2,31},{3,8},{4,3},{5,2},{6,2}]'),(1001031642,'[{2,12},{3,3},{4,1},{5,1},{6,1}]'),(1001031643,'[{2,37},{3,9},{4,4},{5,2},{6,2}]'),(1001040142,'[{2,1}]'),(1001040143,'[{2,1}]'),(1001040242,'[{2,1}]'),(1001040243,'[{2,1}]'),(1001040342,'[{2,1}]'),(1001040343,'[{2,1}]'),(1001040442,'[{2,1}]'),(1001040443,'[{2,1}]'),(1001040542,'[{2,1}]'),(1001040543,'[{2,1}]'),(1001040642,'[{2,1}]'),(1001040643,'[{2,2}]'),(1001040742,'[{2,1}]'),(1001040743,'[{2,3},{3,1}]'),(1001040842,'[{2,1}]'),(1001040843,'[{2,4},{3,1}]'),(1001040942,'[{2,2}]'),(1001040943,'[{2,5},{3,1},{4,1}]'),(1001041042,'[{2,2},{3,1}]'),(1001041043,'[{2,7},{3,2},{4,1}]'),(1001041142,'[{2,3},{3,1}]'),(1001041143,'[{2,10},{3,3},{4,1},{5,1},{6,1}]'),(1001041242,'[{2,5},{3,1}]'),(1001041243,'[{2,15},{3,4},{4,1},{5,1},{6,1}]'),(1001041342,'[{2,7},{3,2},{4,1}]'),(1001041343,'[{2,20},{3,5},{4,2},{5,1},{6,1}]'),(1001041442,'[{2,9},{3,2},{4,1},{5,1}]'),(1001041443,'[{2,26},{3,7},{4,3},{5,2},{6,1}]'),(1001041542,'[{2,10},{3,3},{4,1},{5,1},{6,1}]'),(1001041543,'[{2,31},{3,8},{4,3},{5,2},{6,2}]'),(1001041642,'[{2,12},{3,3},{4,1},{5,1},{6,1}]'),(1001041643,'[{2,37},{3,9},{4,4},{5,2},{6,2}]'),(1002010142,'[{2,1}]'),(1002010143,'[{2,1}]'),(1002010242,'[{2,1}]'),(1002010243,'[{2,1}]'),(1002010342,'[{2,1}]'),(1002010343,'[{2,1}]'),(1002010442,'[{2,1}]'),(1002010443,'[{2,1}]'),(1002010542,'[{2,1}]'),(1002010543,'[{2,1}]'),(1002010642,'[{2,1}]'),(1002010643,'[{2,2}]'),(1002010742,'[{2,1}]'),(1002010743,'[{2,2},{3,1}]'),(1002010842,'[{2,1}]'),(1002010843,'[{2,3},{3,1}]'),(1002010942,'[{2,1}]'),(1002010943,'[{2,4},{3,1}]'),(1002011042,'[{2,2}]'),(1002011043,'[{2,6},{3,1},{4,1}]'),(1002011142,'[{2,3},{3,1}]'),(1002011143,'[{2,8},{3,2},{4,1},{5,1}]'),(1002011242,'[{2,4},{3,1}]'),(1002011243,'[{2,12},{3,3},{4,1},{5,1},{6,1}]'),(1002011342,'[{2,6},{3,1},{4,1}]'),(1002011343,'[{2,17},{3,4},{4,2},{5,1},{6,1}]'),(1002011442,'[{2,7},{3,2},{4,1}]'),(1002011443,'[{2,22},{3,5},{4,2},{5,1},{6,1}]'),(1002011542,'[{2,9},{3,2},{4,1},{5,1}]'),(1002011543,'[{2,26},{3,6},{4,3},{5,2},{6,1}]'),(1002011642,'[{2,10},{3,3},{4,1},{5,1},{6,1}]'),(1002011643,'[{2,31},{3,8},{4,3},{5,2},{6,2}]'),(1002020142,'[{2,1}]'),(1002020143,'[{2,1}]'),(1002020242,'[{2,1}]'),(1002020243,'[{2,1}]'),(1002020342,'[{2,1}]'),(1002020343,'[{2,1}]'),(1002020442,'[{2,1}]'),(1002020443,'[{2,1}]'),(1002020542,'[{2,1}]'),(1002020543,'[{2,1}]'),(1002020642,'[{2,1}]'),(1002020643,'[{2,2}]'),(1002020742,'[{2,1}]'),(1002020743,'[{2,2},{3,1}]'),(1002020842,'[{2,1}]'),(1002020843,'[{2,3},{3,1}]'),(1002020942,'[{2,1}]'),(1002020943,'[{2,4},{3,1}]'),(1002021042,'[{2,2}]'),(1002021043,'[{2,6},{3,1},{4,1}]'),(1002021142,'[{2,3},{3,1}]'),(1002021143,'[{2,8},{3,2},{4,1},{5,1}]'),(1002021242,'[{2,4},{3,1}]'),(1002021243,'[{2,12},{3,3},{4,1},{5,1},{6,1}]'),(1002021342,'[{2,6},{3,1},{4,1}]'),(1002021343,'[{2,17},{3,4},{4,2},{5,1},{6,1}]'),(1002021442,'[{2,7},{3,2},{4,1}]'),(1002021443,'[{2,22},{3,5},{4,2},{5,1},{6,1}]'),(1002021542,'[{2,9},{3,2},{4,1},{5,1}]'),(1002021543,'[{2,26},{3,6},{4,3},{5,2},{6,1}]'),(1002021642,'[{2,10},{3,3},{4,1},{5,1},{6,1}]'),(1002021643,'[{2,31},{3,8},{4,3},{5,2},{6,2}]'),(1002030142,'[{2,1}]'),(1002030143,'[{2,1}]'),(1002030242,'[{2,1}]'),(1002030243,'[{2,1}]'),(1002030342,'[{2,1}]'),(1002030343,'[{2,1}]'),(1002030442,'[{2,1}]'),(1002030443,'[{2,1}]'),(1002030542,'[{2,1}]'),(1002030543,'[{2,1}]'),(1002030642,'[{2,1}]'),(1002030643,'[{2,2}]'),(1002030742,'[{2,1}]'),(1002030743,'[{2,2},{3,1}]'),(1002030842,'[{2,1}]'),(1002030843,'[{2,3},{3,1}]'),(1002030942,'[{2,1}]'),(1002030943,'[{2,4},{3,1}]'),(1002031042,'[{2,2}]'),(1002031043,'[{2,6},{3,1},{4,1}]'),(1002031142,'[{2,3},{3,1}]'),(1002031143,'[{2,8},{3,2},{4,1},{5,1}]'),(1002031242,'[{2,4},{3,1}]'),(1002031243,'[{2,12},{3,3},{4,1},{5,1},{6,1}]'),(1002031342,'[{2,6},{3,1},{4,1}]'),(1002031343,'[{2,17},{3,4},{4,2},{5,1},{6,1}]'),(1002031442,'[{2,7},{3,2},{4,1}]'),(1002031443,'[{2,22},{3,5},{4,2},{5,1},{6,1}]'),(1002031542,'[{2,9},{3,2},{4,1},{5,1}]'),(1002031543,'[{2,26},{3,6},{4,3},{5,2},{6,1}]'),(1002031642,'[{2,10},{3,3},{4,1},{5,1},{6,1}]'),(1002031643,'[{2,31},{3,8},{4,3},{5,2},{6,2}]'),(1002040142,'[{2,1}]'),(1002040143,'[{2,1}]'),(1002040242,'[{2,1}]'),(1002040243,'[{2,1}]'),(1002040342,'[{2,1}]'),(1002040343,'[{2,1}]'),(1002040442,'[{2,1}]'),(1002040443,'[{2,1}]'),(1002040542,'[{2,1}]'),(1002040543,'[{2,1}]'),(1002040642,'[{2,1}]'),(1002040643,'[{2,2}]'),(1002040742,'[{2,1}]'),(1002040743,'[{2,2},{3,1}]'),(1002040842,'[{2,1}]'),(1002040843,'[{2,3},{3,1}]'),(1002040942,'[{2,1}]'),(1002040943,'[{2,4},{3,1}]'),(1002041042,'[{2,2}]'),(1002041043,'[{2,6},{3,1},{4,1}]'),(1002041142,'[{2,3},{3,1}]'),(1002041143,'[{2,8},{3,2},{4,1},{5,1}]'),(1002041242,'[{2,4},{3,1}]'),(1002041243,'[{2,12},{3,3},{4,1},{5,1},{6,1}]'),(1002041342,'[{2,6},{3,1},{4,1}]'),(1002041343,'[{2,17},{3,4},{4,2},{5,1},{6,1}]'),(1002041442,'[{2,7},{3,2},{4,1}]'),(1002041443,'[{2,22},{3,5},{4,2},{5,1},{6,1}]'),(1002041542,'[{2,9},{3,2},{4,1},{5,1}]'),(1002041543,'[{2,26},{3,6},{4,3},{5,2},{6,1}]'),(1002041642,'[{2,10},{3,3},{4,1},{5,1},{6,1}]'),(1002041643,'[{2,31},{3,8},{4,3},{5,2},{6,2}]'),(1003000142,'[{2,1}]'),(1003000143,'[{2,1}]'),(1003000242,'[{2,1}]'),(1003000243,'[{2,1}]'),(1003000342,'[{2,1}]'),(1003000343,'[{2,1}]'),(1003000442,'[{2,1}]'),(1003000443,'[{2,1}]'),(1003000542,'[{2,1}]'),(1003000543,'[{2,1}]'),(1003000642,'[{2,1}]'),(1003000643,'[{2,1}]'),(1003000742,'[{2,1}]'),(1003000743,'[{2,2}]'),(1003000842,'[{2,1}]'),(1003000843,'[{2,3},{3,1}]'),(1003000942,'[{2,1}]'),(1003000943,'[{2,4},{3,1}]'),(1003001042,'[{2,2}]'),(1003001043,'[{2,5},{3,1}]'),(1003001142,'[{2,2},{3,1}]'),(1003001143,'[{2,7},{3,2},{4,1}]'),(1003001242,'[{2,3},{3,1}]'),(1003001243,'[{2,10},{3,2},{4,1},{5,1}]'),(1003001342,'[{2,5},{3,1}]'),(1003001343,'[{2,14},{3,3},{4,1},{5,1},{6,1}]'),(1003001442,'[{2,6},{3,1},{4,1}]'),(1003001443,'[{2,18},{3,4},{4,2},{5,1},{6,1}]'),(1003001542,'[{2,7},{3,2},{4,1}]'),(1003001543,'[{2,21},{3,5},{4,2},{5,1},{6,1}]'),(1003001642,'[{2,8},{3,2},{4,1},{5,1}]'),(1003001643,'[{2,25},{3,6},{4,2},{5,2},{6,1}]'),(1004010142,'[{2,1}]'),(1004010143,'[{2,1}]'),(1004010242,'[{2,1}]'),(1004010243,'[{2,1}]'),(1004010342,'[{2,1}]'),(1004010343,'[{2,1}]'),(1004010442,'[{2,1}]'),(1004010443,'[{2,1}]'),(1004010542,'[{2,1}]'),(1004010543,'[{2,1}]'),(1004010642,'[{2,1}]'),(1004010643,'[{2,1}]'),(1004010742,'[{2,1}]'),(1004010743,'[{2,1}]'),(1004010842,'[{2,1}]'),(1004010843,'[{2,2},{3,1}]'),(1004010942,'[{2,1}]'),(1004010943,'[{2,3},{3,1}]'),(1004011042,'[{2,1}]'),(1004011043,'[{2,4},{3,1}]'),(1004011142,'[{2,2}]'),(1004011143,'[{2,5},{3,1},{4,1}]'),(1004011242,'[{2,3},{3,1}]'),(1004011243,'[{2,8},{3,2},{4,1},{5,1}]'),(1004011342,'[{2,4},{3,1}]'),(1004011343,'[{2,11},{3,3},{4,1},{5,1},{6,1}]'),(1004011442,'[{2,5},{3,1}]'),(1004011443,'[{2,14},{3,4},{4,1},{5,1},{6,1}]'),(1004011542,'[{2,6},{3,1},{4,1}]'),(1004011543,'[{2,17},{3,4},{4,2},{5,1},{6,1}]'),(1004011642,'[{2,7},{3,2},{4,1}]'),(1004011643,'[{2,20},{3,5},{4,2},{5,1},{6,1}]'),(1004020142,'[{2,1}]'),(1004020143,'[{2,1}]'),(1004020242,'[{2,1}]'),(1004020243,'[{2,1}]'),(1004020342,'[{2,1}]'),(1004020343,'[{2,1}]'),(1004020442,'[{2,1}]'),(1004020443,'[{2,1}]'),(1004020542,'[{2,1}]'),(1004020543,'[{2,1}]'),(1004020642,'[{2,1}]'),(1004020643,'[{2,1}]'),(1004020742,'[{2,1}]'),(1004020743,'[{2,1}]'),(1004020842,'[{2,1}]'),(1004020843,'[{2,2},{3,1}]'),(1004020942,'[{2,1}]'),(1004020943,'[{2,3},{3,1}]'),(1004021042,'[{2,1}]'),(1004021043,'[{2,4},{3,1}]'),(1004021142,'[{2,2}]'),(1004021143,'[{2,5},{3,1},{4,1}]'),(1004021242,'[{2,3},{3,1}]'),(1004021243,'[{2,8},{3,2},{4,1},{5,1}]'),(1004021342,'[{2,4},{3,1}]'),(1004021343,'[{2,11},{3,3},{4,1},{5,1},{6,1}]'),(1004021442,'[{2,5},{3,1}]'),(1004021443,'[{2,14},{3,4},{4,1},{5,1},{6,1}]'),(1004021542,'[{2,6},{3,1},{4,1}]'),(1004021543,'[{2,17},{3,4},{4,2},{5,1},{6,1}]'),(1004021642,'[{2,7},{3,2},{4,1}]'),(1004021643,'[{2,20},{3,5},{4,2},{5,1},{6,1}]'),(1004030142,'[{2,1}]'),(1004030143,'[{2,1}]'),(1004030242,'[{2,1}]'),(1004030243,'[{2,1}]'),(1004030342,'[{2,1}]'),(1004030343,'[{2,1}]'),(1004030442,'[{2,1}]'),(1004030443,'[{2,1}]'),(1004030542,'[{2,1}]'),(1004030543,'[{2,1}]'),(1004030642,'[{2,1}]'),(1004030643,'[{2,1}]'),(1004030742,'[{2,1}]'),(1004030743,'[{2,1}]'),(1004030842,'[{2,1}]'),(1004030843,'[{2,2},{3,1}]'),(1004030942,'[{2,1}]'),(1004030943,'[{2,3},{3,1}]'),(1004031042,'[{2,1}]'),(1004031043,'[{2,4},{3,1}]'),(1004031142,'[{2,2}]'),(1004031143,'[{2,5},{3,1},{4,1}]'),(1004031242,'[{2,3},{3,1}]'),(1004031243,'[{2,8},{3,2},{4,1},{5,1}]'),(1004031342,'[{2,4},{3,1}]'),(1004031343,'[{2,11},{3,3},{4,1},{5,1},{6,1}]'),(1004031442,'[{2,5},{3,1}]'),(1004031443,'[{2,14},{3,4},{4,1},{5,1},{6,1}]'),(1004031542,'[{2,6},{3,1},{4,1}]'),(1004031543,'[{2,17},{3,4},{4,2},{5,1},{6,1}]'),(1004031642,'[{2,7},{3,2},{4,1}]'),(1004031643,'[{2,20},{3,5},{4,2},{5,1},{6,1}]'),(1004040142,'[{2,1}]'),(1004040143,'[{2,1}]'),(1004040242,'[{2,1}]'),(1004040243,'[{2,1}]'),(1004040342,'[{2,1}]'),(1004040343,'[{2,1}]'),(1004040442,'[{2,1}]'),(1004040443,'[{2,1}]'),(1004040542,'[{2,1}]'),(1004040543,'[{2,1}]'),(1004040642,'[{2,1}]'),(1004040643,'[{2,1}]'),(1004040742,'[{2,1}]'),(1004040743,'[{2,1}]'),(1004040842,'[{2,1}]'),(1004040843,'[{2,2},{3,1}]'),(1004040942,'[{2,1}]'),(1004040943,'[{2,3},{3,1}]'),(1004041042,'[{2,1}]'),(1004041043,'[{2,4},{3,1}]'),(1004041142,'[{2,2}]'),(1004041143,'[{2,5},{3,1},{4,1}]'),(1004041242,'[{2,3},{3,1}]'),(1004041243,'[{2,8},{3,2},{4,1},{5,1}]'),(1004041342,'[{2,4},{3,1}]'),(1004041343,'[{2,11},{3,3},{4,1},{5,1},{6,1}]'),(1004041442,'[{2,5},{3,1}]'),(1004041443,'[{2,14},{3,4},{4,1},{5,1},{6,1}]'),(1004041542,'[{2,6},{3,1},{4,1}]'),(1004041543,'[{2,17},{3,4},{4,2},{5,1},{6,1}]'),(1004041642,'[{2,7},{3,2},{4,1}]'),(1004041643,'[{2,20},{3,5},{4,2},{5,1},{6,1}]'),(1005000142,'[{2,1}]'),(1005000143,'[{2,1}]'),(1005000242,'[{2,1}]'),(1005000243,'[{2,1}]'),(1005000342,'[{2,1}]'),(1005000343,'[{2,1}]'),(1005000442,'[{2,1}]'),(1005000443,'[{2,1}]'),(1005000542,'[{2,1}]'),(1005000543,'[{2,1}]'),(1005000642,'[{2,1}]'),(1005000643,'[{2,1}]'),(1005000742,'[{2,1}]'),(1005000743,'[{2,1}]'),(1005000842,'[{2,1}]'),(1005000843,'[{2,1}]'),(1005000942,'[{2,1}]'),(1005000943,'[{2,2}]'),(1005001042,'[{2,1}]'),(1005001043,'[{2,2},{3,1}]'),(1005001142,'[{2,1}]'),(1005001143,'[{2,3},{3,1}]'),(1005001242,'[{2,2}]'),(1005001243,'[{2,5},{3,1}]'),(1005001342,'[{2,2},{3,1}]'),(1005001343,'[{2,7},{3,2},{4,1}]'),(1005001442,'[{2,3},{3,1}]'),(1005001443,'[{2,9},{3,2},{4,1},{5,1}]'),(1005001542,'[{2,4},{3,1}]'),(1005001543,'[{2,10},{3,3},{4,1},{5,1},{6,1}]'),(1005001642,'[{2,4},{3,1}]'),(1005001643,'[{2,12},{3,3},{4,1},{5,1},{6,1}]'),(1006010142,'[{2,1}]'),(1006010143,'[{2,1}]'),(1006010242,'[{2,1}]'),(1006010243,'[{2,1}]'),(1006010342,'[{2,1}]'),(1006010343,'[{2,1}]'),(1006010442,'[{2,1}]'),(1006010443,'[{2,1}]'),(1006010542,'[{2,1}]'),(1006010543,'[{2,1}]'),(1006010642,'[{2,1}]'),(1006010643,'[{2,1}]'),(1006010742,'[{2,1}]'),(1006010743,'[{2,1}]'),(1006010842,'[{2,1}]'),(1006010843,'[{2,2},{3,1}]'),(1006010942,'[{2,1}]'),(1006010943,'[{2,3},{3,1}]'),(1006011042,'[{2,1}]'),(1006011043,'[{2,4},{3,1}]'),(1006011142,'[{2,2}]'),(1006011143,'[{2,5},{3,1},{4,1}]'),(1006011242,'[{2,3},{3,1}]'),(1006011243,'[{2,8},{3,2},{4,1},{5,1}]'),(1006011342,'[{2,4},{3,1}]'),(1006011343,'[{2,11},{3,3},{4,1},{5,1},{6,1}]'),(1006011442,'[{2,5},{3,1}]'),(1006011443,'[{2,14},{3,4},{4,1},{5,1},{6,1}]'),(1006011542,'[{2,6},{3,1},{4,1}]'),(1006011543,'[{2,17},{3,4},{4,2},{5,1},{6,1}]'),(1006011642,'[{2,7},{3,2},{4,1}]'),(1006011643,'[{2,20},{3,5},{4,2},{5,1},{6,1}]'),(1006020142,'[{2,1}]'),(1006020143,'[{2,1}]'),(1006020242,'[{2,1}]'),(1006020243,'[{2,1}]'),(1006020342,'[{2,1}]'),(1006020343,'[{2,1}]'),(1006020442,'[{2,1}]'),(1006020443,'[{2,1}]'),(1006020542,'[{2,1}]'),(1006020543,'[{2,1}]'),(1006020642,'[{2,1}]'),(1006020643,'[{2,1}]'),(1006020742,'[{2,1}]'),(1006020743,'[{2,1}]'),(1006020842,'[{2,1}]'),(1006020843,'[{2,2},{3,1}]'),(1006020942,'[{2,1}]'),(1006020943,'[{2,3},{3,1}]'),(1006021042,'[{2,1}]'),(1006021043,'[{2,4},{3,1}]'),(1006021142,'[{2,2}]'),(1006021143,'[{2,5},{3,1},{4,1}]'),(1006021242,'[{2,3},{3,1}]'),(1006021243,'[{2,8},{3,2},{4,1},{5,1}]'),(1006021342,'[{2,4},{3,1}]'),(1006021343,'[{2,11},{3,3},{4,1},{5,1},{6,1}]'),(1006021442,'[{2,5},{3,1}]'),(1006021443,'[{2,14},{3,4},{4,1},{5,1},{6,1}]'),(1006021542,'[{2,6},{3,1},{4,1}]'),(1006021543,'[{2,17},{3,4},{4,2},{5,1},{6,1}]'),(1006021642,'[{2,7},{3,2},{4,1}]'),(1006021643,'[{2,20},{3,5},{4,2},{5,1},{6,1}]'),(1006030142,'[{2,1}]'),(1006030143,'[{2,1}]'),(1006030242,'[{2,1}]'),(1006030243,'[{2,1}]'),(1006030342,'[{2,1}]'),(1006030343,'[{2,1}]'),(1006030442,'[{2,1}]'),(1006030443,'[{2,1}]'),(1006030542,'[{2,1}]'),(1006030543,'[{2,1}]'),(1006030642,'[{2,1}]'),(1006030643,'[{2,1}]'),(1006030742,'[{2,1}]'),(1006030743,'[{2,1}]'),(1006030842,'[{2,1}]'),(1006030843,'[{2,2},{3,1}]'),(1006030942,'[{2,1}]'),(1006030943,'[{2,3},{3,1}]'),(1006031042,'[{2,1}]'),(1006031043,'[{2,4},{3,1}]'),(1006031142,'[{2,2}]'),(1006031143,'[{2,5},{3,1},{4,1}]'),(1006031242,'[{2,3},{3,1}]'),(1006031243,'[{2,8},{3,2},{4,1},{5,1}]'),(1006031342,'[{2,4},{3,1}]'),(1006031343,'[{2,11},{3,3},{4,1},{5,1},{6,1}]'),(1006031442,'[{2,5},{3,1}]'),(1006031443,'[{2,14},{3,4},{4,1},{5,1},{6,1}]'),(1006031542,'[{2,6},{3,1},{4,1}]'),(1006031543,'[{2,17},{3,4},{4,2},{5,1},{6,1}]'),(1006031642,'[{2,7},{3,2},{4,1}]'),(1006031643,'[{2,20},{3,5},{4,2},{5,1},{6,1}]'),(1006040142,'[{2,1}]'),(1006040143,'[{2,1}]'),(1006040242,'[{2,1}]'),(1006040243,'[{2,1}]'),(1006040342,'[{2,1}]'),(1006040343,'[{2,1}]'),(1006040442,'[{2,1}]'),(1006040443,'[{2,1}]'),(1006040542,'[{2,1}]'),(1006040543,'[{2,1}]'),(1006040642,'[{2,1}]'),(1006040643,'[{2,1}]'),(1006040742,'[{2,1}]'),(1006040743,'[{2,1}]'),(1006040842,'[{2,1}]'),(1006040843,'[{2,2},{3,1}]'),(1006040942,'[{2,1}]'),(1006040943,'[{2,3},{3,1}]'),(1006041042,'[{2,1}]'),(1006041043,'[{2,4},{3,1}]'),(1006041142,'[{2,2}]'),(1006041143,'[{2,5},{3,1},{4,1}]'),(1006041242,'[{2,3},{3,1}]'),(1006041243,'[{2,8},{3,2},{4,1},{5,1}]'),(1006041342,'[{2,4},{3,1}]'),(1006041343,'[{2,11},{3,3},{4,1},{5,1},{6,1}]'),(1006041442,'[{2,5},{3,1}]'),(1006041443,'[{2,14},{3,4},{4,1},{5,1},{6,1}]'),(1006041542,'[{2,6},{3,1},{4,1}]'),(1006041543,'[{2,17},{3,4},{4,2},{5,1},{6,1}]'),(1006041642,'[{2,7},{3,2},{4,1}]'),(1006041643,'[{2,20},{3,5},{4,2},{5,1},{6,1}]'),(1007010142,'[{2,1}]'),(1007010143,'[{2,1}]'),(1007010242,'[{2,1}]'),(1007010243,'[{2,1}]'),(1007010342,'[{2,1}]'),(1007010343,'[{2,1}]'),(1007010442,'[{2,1}]'),(1007010443,'[{2,1}]'),(1007010542,'[{2,1}]'),(1007010543,'[{2,1}]'),(1007010642,'[{2,1}]'),(1007010643,'[{2,1}]'),(1007010742,'[{2,1}]'),(1007010743,'[{2,2}]'),(1007010842,'[{2,1}]'),(1007010843,'[{2,3},{3,1}]'),(1007010942,'[{2,1}]'),(1007010943,'[{2,4},{3,1}]'),(1007011042,'[{2,2}]'),(1007011043,'[{2,5},{3,1}]'),(1007011142,'[{2,2},{3,1}]'),(1007011143,'[{2,7},{3,2},{4,1}]'),(1007011242,'[{2,3},{3,1}]'),(1007011243,'[{2,10},{3,2},{4,1},{5,1}]'),(1007011342,'[{2,5},{3,1}]'),(1007011343,'[{2,14},{3,3},{4,1},{5,1},{6,1}]'),(1007011442,'[{2,6},{3,1},{4,1}]'),(1007011443,'[{2,18},{3,4},{4,2},{5,1},{6,1}]'),(1007011542,'[{2,7},{3,2},{4,1}]'),(1007011543,'[{2,21},{3,5},{4,2},{5,1},{6,1}]'),(1007011642,'[{2,8},{3,2},{4,1},{5,1}]'),(1007011643,'[{2,25},{3,6},{4,2},{5,2},{6,1}]'),(1007020142,'[{2,1}]'),(1007020143,'[{2,1}]'),(1007020242,'[{2,1}]'),(1007020243,'[{2,1}]'),(1007020342,'[{2,1}]'),(1007020343,'[{2,1}]'),(1007020442,'[{2,1}]'),(1007020443,'[{2,1}]'),(1007020542,'[{2,1}]'),(1007020543,'[{2,1}]'),(1007020642,'[{2,1}]'),(1007020643,'[{2,1}]'),(1007020742,'[{2,1}]'),(1007020743,'[{2,2}]'),(1007020842,'[{2,1}]'),(1007020843,'[{2,3},{3,1}]'),(1007020942,'[{2,1}]'),(1007020943,'[{2,4},{3,1}]'),(1007021042,'[{2,2}]'),(1007021043,'[{2,5},{3,1}]'),(1007021142,'[{2,2},{3,1}]'),(1007021143,'[{2,7},{3,2},{4,1}]'),(1007021242,'[{2,3},{3,1}]'),(1007021243,'[{2,10},{3,2},{4,1},{5,1}]'),(1007021342,'[{2,5},{3,1}]'),(1007021343,'[{2,14},{3,3},{4,1},{5,1},{6,1}]'),(1007021442,'[{2,6},{3,1},{4,1}]'),(1007021443,'[{2,18},{3,4},{4,2},{5,1},{6,1}]'),(1007021542,'[{2,7},{3,2},{4,1}]'),(1007021543,'[{2,21},{3,5},{4,2},{5,1},{6,1}]'),(1007021642,'[{2,8},{3,2},{4,1},{5,1}]'),(1007021643,'[{2,25},{3,6},{4,2},{5,2},{6,1}]'),(1007030142,'[{2,1}]'),(1007030143,'[{2,1}]'),(1007030242,'[{2,1}]'),(1007030243,'[{2,1}]'),(1007030342,'[{2,1}]'),(1007030343,'[{2,1}]'),(1007030442,'[{2,1}]'),(1007030443,'[{2,1}]'),(1007030542,'[{2,1}]'),(1007030543,'[{2,1}]'),(1007030642,'[{2,1}]'),(1007030643,'[{2,1}]'),(1007030742,'[{2,1}]'),(1007030743,'[{2,2}]'),(1007030842,'[{2,1}]'),(1007030843,'[{2,3},{3,1}]'),(1007030942,'[{2,1}]'),(1007030943,'[{2,4},{3,1}]'),(1007031042,'[{2,2}]'),(1007031043,'[{2,5},{3,1}]'),(1007031142,'[{2,2},{3,1}]'),(1007031143,'[{2,7},{3,2},{4,1}]'),(1007031242,'[{2,3},{3,1}]'),(1007031243,'[{2,10},{3,2},{4,1},{5,1}]'),(1007031342,'[{2,5},{3,1}]'),(1007031343,'[{2,14},{3,3},{4,1},{5,1},{6,1}]'),(1007031442,'[{2,6},{3,1},{4,1}]'),(1007031443,'[{2,18},{3,4},{4,2},{5,1},{6,1}]'),(1007031542,'[{2,7},{3,2},{4,1}]'),(1007031543,'[{2,21},{3,5},{4,2},{5,1},{6,1}]'),(1007031642,'[{2,8},{3,2},{4,1},{5,1}]'),(1007031643,'[{2,25},{3,6},{4,2},{5,2},{6,1}]'),(1007040142,'[{2,1}]'),(1007040143,'[{2,1}]'),(1007040242,'[{2,1}]'),(1007040243,'[{2,1}]'),(1007040342,'[{2,1}]'),(1007040343,'[{2,1}]'),(1007040442,'[{2,1}]'),(1007040443,'[{2,1}]'),(1007040542,'[{2,1}]'),(1007040543,'[{2,1}]'),(1007040642,'[{2,1}]'),(1007040643,'[{2,1}]'),(1007040742,'[{2,1}]'),(1007040743,'[{2,2}]'),(1007040842,'[{2,1}]'),(1007040843,'[{2,3},{3,1}]'),(1007040942,'[{2,1}]'),(1007040943,'[{2,4},{3,1}]'),(1007041042,'[{2,2}]'),(1007041043,'[{2,5},{3,1}]'),(1007041142,'[{2,2},{3,1}]'),(1007041143,'[{2,7},{3,2},{4,1}]'),(1007041242,'[{2,3},{3,1}]'),(1007041243,'[{2,10},{3,2},{4,1},{5,1}]'),(1007041342,'[{2,5},{3,1}]'),(1007041343,'[{2,14},{3,3},{4,1},{5,1},{6,1}]'),(1007041442,'[{2,6},{3,1},{4,1}]'),(1007041443,'[{2,18},{3,4},{4,2},{5,1},{6,1}]'),(1007041542,'[{2,7},{3,2},{4,1}]'),(1007041543,'[{2,21},{3,5},{4,2},{5,1},{6,1}]'),(1007041642,'[{2,8},{3,2},{4,1},{5,1}]'),(1007041643,'[{2,25},{3,6},{4,2},{5,2},{6,1}]'),(1008010142,'[{2,1}]'),(1008010143,'[{2,1}]'),(1008010242,'[{2,1}]'),(1008010243,'[{2,1}]'),(1008010342,'[{2,1}]'),(1008010343,'[{2,1}]'),(1008010442,'[{2,1}]'),(1008010443,'[{2,1}]'),(1008010542,'[{2,1}]'),(1008010543,'[{2,1}]'),(1008010642,'[{2,1}]'),(1008010643,'[{2,1}]'),(1008010742,'[{2,1}]'),(1008010743,'[{2,1}]'),(1008010842,'[{2,1}]'),(1008010843,'[{2,2},{3,1}]'),(1008010942,'[{2,1}]'),(1008010943,'[{2,3},{3,1}]'),(1008011042,'[{2,1}]'),(1008011043,'[{2,4},{3,1}]'),(1008011142,'[{2,2}]'),(1008011143,'[{2,5},{3,1},{4,1}]'),(1008011242,'[{2,3},{3,1}]'),(1008011243,'[{2,8},{3,2},{4,1},{5,1}]'),(1008011342,'[{2,4},{3,1}]'),(1008011343,'[{2,11},{3,3},{4,1},{5,1},{6,1}]'),(1008011442,'[{2,5},{3,1}]'),(1008011443,'[{2,14},{3,4},{4,1},{5,1},{6,1}]'),(1008011542,'[{2,6},{3,1},{4,1}]'),(1008011543,'[{2,17},{3,4},{4,2},{5,1},{6,1}]'),(1008011642,'[{2,7},{3,2},{4,1}]'),(1008011643,'[{2,20},{3,5},{4,2},{5,1},{6,1}]'),(1008020142,'[{2,1}]'),(1008020143,'[{2,1}]'),(1008020242,'[{2,1}]'),(1008020243,'[{2,1}]'),(1008020342,'[{2,1}]'),(1008020343,'[{2,1}]'),(1008020442,'[{2,1}]'),(1008020443,'[{2,1}]'),(1008020542,'[{2,1}]'),(1008020543,'[{2,1}]'),(1008020642,'[{2,1}]'),(1008020643,'[{2,1}]'),(1008020742,'[{2,1}]'),(1008020743,'[{2,1}]'),(1008020842,'[{2,1}]'),(1008020843,'[{2,2},{3,1}]'),(1008020942,'[{2,1}]'),(1008020943,'[{2,3},{3,1}]'),(1008021042,'[{2,1}]'),(1008021043,'[{2,4},{3,1}]'),(1008021142,'[{2,2}]'),(1008021143,'[{2,5},{3,1},{4,1}]'),(1008021242,'[{2,3},{3,1}]'),(1008021243,'[{2,8},{3,2},{4,1},{5,1}]'),(1008021342,'[{2,4},{3,1}]'),(1008021343,'[{2,11},{3,3},{4,1},{5,1},{6,1}]'),(1008021442,'[{2,5},{3,1}]'),(1008021443,'[{2,14},{3,4},{4,1},{5,1},{6,1}]'),(1008021542,'[{2,6},{3,1},{4,1}]'),(1008021543,'[{2,17},{3,4},{4,2},{5,1},{6,1}]'),(1008021642,'[{2,7},{3,2},{4,1}]'),(1008021643,'[{2,20},{3,5},{4,2},{5,1},{6,1}]'),(1008030142,'[{2,1}]'),(1008030143,'[{2,1}]'),(1008030242,'[{2,1}]'),(1008030243,'[{2,1}]'),(1008030342,'[{2,1}]'),(1008030343,'[{2,1}]'),(1008030442,'[{2,1}]'),(1008030443,'[{2,1}]'),(1008030542,'[{2,1}]'),(1008030543,'[{2,1}]'),(1008030642,'[{2,1}]'),(1008030643,'[{2,1}]'),(1008030742,'[{2,1}]'),(1008030743,'[{2,1}]'),(1008030842,'[{2,1}]'),(1008030843,'[{2,2},{3,1}]'),(1008030942,'[{2,1}]'),(1008030943,'[{2,3},{3,1}]'),(1008031042,'[{2,1}]'),(1008031043,'[{2,4},{3,1}]'),(1008031142,'[{2,2}]'),(1008031143,'[{2,5},{3,1},{4,1}]'),(1008031242,'[{2,3},{3,1}]'),(1008031243,'[{2,8},{3,2},{4,1},{5,1}]'),(1008031342,'[{2,4},{3,1}]'),(1008031343,'[{2,11},{3,3},{4,1},{5,1},{6,1}]'),(1008031442,'[{2,5},{3,1}]'),(1008031443,'[{2,14},{3,4},{4,1},{5,1},{6,1}]'),(1008031542,'[{2,6},{3,1},{4,1}]'),(1008031543,'[{2,17},{3,4},{4,2},{5,1},{6,1}]'),(1008031642,'[{2,7},{3,2},{4,1}]'),(1008031643,'[{2,20},{3,5},{4,2},{5,1},{6,1}]'),(1008040142,'[{2,1}]'),(1008040143,'[{2,1}]'),(1008040242,'[{2,1}]'),(1008040243,'[{2,1}]'),(1008040342,'[{2,1}]'),(1008040343,'[{2,1}]'),(1008040442,'[{2,1}]'),(1008040443,'[{2,1}]'),(1008040542,'[{2,1}]'),(1008040543,'[{2,1}]'),(1008040642,'[{2,1}]'),(1008040643,'[{2,1}]'),(1008040742,'[{2,1}]'),(1008040743,'[{2,1}]'),(1008040842,'[{2,1}]'),(1008040843,'[{2,2},{3,1}]'),(1008040942,'[{2,1}]'),(1008040943,'[{2,3},{3,1}]'),(1008041042,'[{2,1}]'),(1008041043,'[{2,4},{3,1}]'),(1008041142,'[{2,2}]'),(1008041143,'[{2,5},{3,1},{4,1}]'),(1008041242,'[{2,3},{3,1}]'),(1008041243,'[{2,8},{3,2},{4,1},{5,1}]'),(1008041342,'[{2,4},{3,1}]'),(1008041343,'[{2,11},{3,3},{4,1},{5,1},{6,1}]'),(1008041442,'[{2,5},{3,1}]'),(1008041443,'[{2,14},{3,4},{4,1},{5,1},{6,1}]'),(1008041542,'[{2,6},{3,1},{4,1}]'),(1008041543,'[{2,17},{3,4},{4,2},{5,1},{6,1}]'),(1008041642,'[{2,7},{3,2},{4,1}]'),(1008041643,'[{2,20},{3,5},{4,2},{5,1},{6,1}]'),(1009000142,'[{2,1}]'),(1009000143,'[{2,1}]'),(1009000242,'[{2,1}]'),(1009000243,'[{2,1}]'),(1009000342,'[{2,1}]'),(1009000343,'[{2,1}]'),(1009000442,'[{2,1}]'),(1009000443,'[{2,1}]'),(1009000542,'[{2,1}]'),(1009000543,'[{2,1}]'),(1009000642,'[{2,1}]'),(1009000643,'[{2,1}]'),(1009000742,'[{2,1}]'),(1009000743,'[{2,1}]'),(1009000842,'[{2,1}]'),(1009000843,'[{2,1}]'),(1009000942,'[{2,1}]'),(1009000943,'[{2,2}]'),(1009001042,'[{2,1}]'),(1009001043,'[{2,2},{3,1}]'),(1009001142,'[{2,1}]'),(1009001143,'[{2,3},{3,1}]'),(1009001242,'[{2,2}]'),(1009001243,'[{2,5},{3,1}]'),(1009001342,'[{2,2},{3,1}]'),(1009001343,'[{2,7},{3,2},{4,1}]'),(1009001442,'[{2,3},{3,1}]'),(1009001443,'[{2,9},{3,2},{4,1},{5,1}]'),(1009001542,'[{2,4},{3,1}]'),(1009001543,'[{2,10},{3,3},{4,1},{5,1},{6,1}]'),(1009001642,'[{2,4},{3,1}]'),(1009001643,'[{2,12},{3,3},{4,1},{5,1},{6,1}]'),(1010010142,'[{2,1}]'),(1010010143,'[{2,1}]'),(1010010242,'[{2,1}]'),(1010010243,'[{2,1}]'),(1010010342,'[{2,1}]'),(1010010343,'[{2,1}]'),(1010010442,'[{2,1}]'),(1010010443,'[{2,1}]'),(1010010542,'[{2,1}]'),(1010010543,'[{2,1}]'),(1010010642,'[{2,1}]'),(1010010643,'[{2,1}]'),(1010010742,'[{2,1}]'),(1010010743,'[{2,1}]'),(1010010842,'[{2,1}]'),(1010010843,'[{2,2},{3,1}]'),(1010010942,'[{2,1}]'),(1010010943,'[{2,3},{3,1}]'),(1010011042,'[{2,1}]'),(1010011043,'[{2,4},{3,1}]'),(1010011142,'[{2,2}]'),(1010011143,'[{2,5},{3,1},{4,1}]'),(1010011242,'[{2,3},{3,1}]'),(1010011243,'[{2,8},{3,2},{4,1},{5,1}]'),(1010011342,'[{2,4},{3,1}]'),(1010011343,'[{2,11},{3,3},{4,1},{5,1},{6,1}]'),(1010011442,'[{2,5},{3,1}]'),(1010011443,'[{2,14},{3,4},{4,1},{5,1},{6,1}]'),(1010011542,'[{2,6},{3,1},{4,1}]'),(1010011543,'[{2,17},{3,4},{4,2},{5,1},{6,1}]'),(1010011642,'[{2,7},{3,2},{4,1}]'),(1010011643,'[{2,20},{3,5},{4,2},{5,1},{6,1}]'),(1010020142,'[{2,1}]'),(1010020143,'[{2,1}]'),(1010020242,'[{2,1}]'),(1010020243,'[{2,1}]'),(1010020342,'[{2,1}]'),(1010020343,'[{2,1}]'),(1010020442,'[{2,1}]'),(1010020443,'[{2,1}]'),(1010020542,'[{2,1}]'),(1010020543,'[{2,1}]'),(1010020642,'[{2,1}]'),(1010020643,'[{2,1}]'),(1010020742,'[{2,1}]'),(1010020743,'[{2,1}]'),(1010020842,'[{2,1}]'),(1010020843,'[{2,2},{3,1}]'),(1010020942,'[{2,1}]'),(1010020943,'[{2,3},{3,1}]'),(1010021042,'[{2,1}]'),(1010021043,'[{2,4},{3,1}]'),(1010021142,'[{2,2}]'),(1010021143,'[{2,5},{3,1},{4,1}]'),(1010021242,'[{2,3},{3,1}]'),(1010021243,'[{2,8},{3,2},{4,1},{5,1}]'),(1010021342,'[{2,4},{3,1}]'),(1010021343,'[{2,11},{3,3},{4,1},{5,1},{6,1}]'),(1010021442,'[{2,5},{3,1}]'),(1010021443,'[{2,14},{3,4},{4,1},{5,1},{6,1}]'),(1010021542,'[{2,6},{3,1},{4,1}]'),(1010021543,'[{2,17},{3,4},{4,2},{5,1},{6,1}]'),(1010021642,'[{2,7},{3,2},{4,1}]'),(1010021643,'[{2,20},{3,5},{4,2},{5,1},{6,1}]'),(1010030142,'[{2,1}]'),(1010030143,'[{2,1}]'),(1010030242,'[{2,1}]'),(1010030243,'[{2,1}]'),(1010030342,'[{2,1}]'),(1010030343,'[{2,1}]'),(1010030442,'[{2,1}]'),(1010030443,'[{2,1}]'),(1010030542,'[{2,1}]'),(1010030543,'[{2,1}]'),(1010030642,'[{2,1}]'),(1010030643,'[{2,1}]'),(1010030742,'[{2,1}]'),(1010030743,'[{2,1}]'),(1010030842,'[{2,1}]'),(1010030843,'[{2,2},{3,1}]'),(1010030942,'[{2,1}]'),(1010030943,'[{2,3},{3,1}]'),(1010031042,'[{2,1}]'),(1010031043,'[{2,4},{3,1}]'),(1010031142,'[{2,2}]'),(1010031143,'[{2,5},{3,1},{4,1}]'),(1010031242,'[{2,3},{3,1}]'),(1010031243,'[{2,8},{3,2},{4,1},{5,1}]'),(1010031342,'[{2,4},{3,1}]'),(1010031343,'[{2,11},{3,3},{4,1},{5,1},{6,1}]'),(1010031442,'[{2,5},{3,1}]'),(1010031443,'[{2,14},{3,4},{4,1},{5,1},{6,1}]'),(1010031542,'[{2,6},{3,1},{4,1}]'),(1010031543,'[{2,17},{3,4},{4,2},{5,1},{6,1}]'),(1010031642,'[{2,7},{3,2},{4,1}]'),(1010031643,'[{2,20},{3,5},{4,2},{5,1},{6,1}]'),(1010040142,'[{2,1}]'),(1010040143,'[{2,1}]'),(1010040242,'[{2,1}]'),(1010040243,'[{2,1}]'),(1010040342,'[{2,1}]'),(1010040343,'[{2,1}]'),(1010040442,'[{2,1}]'),(1010040443,'[{2,1}]'),(1010040542,'[{2,1}]'),(1010040543,'[{2,1}]'),(1010040642,'[{2,1}]'),(1010040643,'[{2,1}]'),(1010040742,'[{2,1}]'),(1010040743,'[{2,1}]'),(1010040842,'[{2,1}]'),(1010040843,'[{2,2},{3,1}]'),(1010040942,'[{2,1}]'),(1010040943,'[{2,3},{3,1}]'),(1010041042,'[{2,1}]'),(1010041043,'[{2,4},{3,1}]'),(1010041142,'[{2,2}]'),(1010041143,'[{2,5},{3,1},{4,1}]'),(1010041242,'[{2,3},{3,1}]'),(1010041243,'[{2,8},{3,2},{4,1},{5,1}]'),(1010041342,'[{2,4},{3,1}]'),(1010041343,'[{2,11},{3,3},{4,1},{5,1},{6,1}]'),(1010041442,'[{2,5},{3,1}]'),(1010041443,'[{2,14},{3,4},{4,1},{5,1},{6,1}]'),(1010041542,'[{2,6},{3,1},{4,1}]'),(1010041543,'[{2,17},{3,4},{4,2},{5,1},{6,1}]'),(1010041642,'[{2,7},{3,2},{4,1}]'),(1010041643,'[{2,20},{3,5},{4,2},{5,1},{6,1}]'),(1101010842,'[{2,1}]'),(1101020842,'[{2,1}]'),(1101030842,'[{2,1}]'),(1101040842,'[{2,1}]'),(1102010842,'[{2,1}]'),(1102020842,'[{2,1}]'),(1102030842,'[{2,1}]'),(1102040842,'[{2,1}]'),(1103000842,'[{2,1}]'),(1104010842,'[{2,1}]'),(1104020842,'[{2,1}]'),(1104030842,'[{2,1}]'),(1104040842,'[{2,1}]'),(1105000842,'[{2,1}]'),(1106010842,'[{2,1}]'),(1106020842,'[{2,1}]'),(1106030842,'[{2,1}]'),(1106040842,'[{2,1}]'),(1107010842,'[{2,1}]'),(1107020842,'[{2,1}]'),(1107030842,'[{2,1}]'),(1107040842,'[{2,1}]'),(1108010842,'[{2,1}]'),(1108020842,'[{2,1}]'),(1108030842,'[{2,1}]'),(1108040842,'[{2,1}]'),(1109000842,'[{2,1}]'),(1110010842,'[{2,1}]'),(1110020842,'[{2,1}]'),(1110030842,'[{2,1}]'),(1110040842,'[{2,1}]');
/*!40000 ALTER TABLE `base_twing_compose_ratio` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_twing_figure`
--

DROP TABLE IF EXISTS `base_twing_figure`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_twing_figure` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '幻化id',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '幻化名称',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗内容',
  `career` tinyint(1) NOT NULL DEFAULT '0' COMMENT '职业',
  `figure_id` varchar(50) NOT NULL DEFAULT '0' COMMENT '资源',
  `effect_time` int(11) NOT NULL DEFAULT '0' COMMENT '有效时间',
  `overlap` int(11) NOT NULL DEFAULT '0' COMMENT '是否可叠加',
  `conditions` varchar(255) NOT NULL COMMENT '激活条件(客户端用)@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='幻化配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_twing_figure`
--

LOCK TABLES `base_twing_figure` WRITE;
/*!40000 ALTER TABLE `base_twing_figure` DISABLE KEYS */;
INSERT INTO `base_twing_figure` VALUES (1004,'战争光环','[{0,20030001,1}]',0,'410001',0,0,'运营活动获得'),(1005,'涂鸦浪板','[{0,20030003,1}]',0,'410004',0,0,'运营活动获得'),(1006,'未来浪板','[{0,20030005,1}]',0,'410006',0,0,'运营活动获得'),(1007,'熊猫奇遇','[{0,20030009,1}]',0,'410002',0,0,'运营活动获得'),(1008,'圣月罗盘','[{0,20030010,1}]',0,'410014',0,0,'运营活动获得'),(1009,'长耳兔','[{0,20030011,1}]',0,'410007',0,0,'运营活动获得'),(1010,'魔法黑猫','[{0,20030012,1}]',0,'410009',0,0,'运营活动获得'),(1011,'小熊鼓手','[{0,20030013,1}]',0,'410010',0,0,'运营活动获得'),(1013,'海底世界','[{0,20030007,1}]',0,'410013',0,0,'运营活动获得'),(1014,'雷霆之主','[{0,20030006,1}]',0,'410012',0,0,'运营活动获得'),(1015,'幽影狼幡','[{0,20030008,1}]',0,'410011',0,0,'运营活动获得'),(1016,'马戏团柯基','[{0,20030014,1}]',0,'410008',0,0,'运营活动获得'),(1017,'蜜语花束','[{0,20030015,1}]',0,'410015',0,0,'运营活动获得');
/*!40000 ALTER TABLE `base_twing_figure` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_twing_figure_lv`
--

DROP TABLE IF EXISTS `base_twing_figure_lv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_twing_figure_lv` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '幻化id',
  `grade` int(11) NOT NULL DEFAULT '0' COMMENT '星级',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗内容',
  `attr` varchar(512) NOT NULL DEFAULT '[]' COMMENT '属性',
  PRIMARY KEY (`id`,`grade`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_twing_figure_lv`
--

LOCK TABLES `base_twing_figure_lv` WRITE;
/*!40000 ALTER TABLE `base_twing_figure_lv` DISABLE KEYS */;
INSERT INTO `base_twing_figure_lv` VALUES (1004,0,'[{0,20030001,1}]','[{1,750},{2,15000},{48,188},{60,100},{12,110}]'),(1004,1,'[{0,20030001,2}]','[{1,1352},{2,27040},{48,339},{60,200},{12,145}]'),(1004,2,'[{0,20030001,4}]','[{1,2165},{2,43300},{48,542},{60,300},{12,180}]'),(1004,3,'[{0,20030001,6}]','[{1,3173},{2,63460},{48,794},{60,400},{12,215}]'),(1004,4,'[{0,20030001,8}]','[{1,4392},{2,87840},{48,1099},{60,500},{12,250}]'),(1004,5,'[]','[{1,5837},{2,116740},{48,1460},{60,600},{12,285}]'),(1005,0,'[{0,20030003,1}]','[{1,668},{2,13360},{48,167},{60,60},{14,100}]'),(1005,1,'[{0,20030003,2}]','[{1,1203},{2,24060},{48,301},{60,120},{14,130}]'),(1005,2,'[{0,20030003,4}]','[{1,1925},{2,38500},{48,482},{60,180},{14,160}]'),(1005,3,'[{0,20030003,6}]','[{1,2821},{2,56420},{48,706},{60,240},{14,190}]'),(1005,4,'[{0,20030003,8}]','[{1,3904},{2,78080},{48,977},{60,300},{14,220}]'),(1005,5,'[]','[{1,5187},{2,103740},{48,1298},{60,360},{14,250}]'),(1006,0,'[{0,20030005,1}]','[{1,290},{2,5800},{48,73}]'),(1006,1,'[{0,20030005,2}]','[{1,522},{2,10440},{48,131}]'),(1006,2,'[{0,20030005,4}]','[{1,835},{2,16700},{48,209}]'),(1006,3,'[{0,20030005,6}]','[{1,1223},{2,24460},{48,306}]'),(1006,4,'[{0,20030005,8}]','[{1,1692},{2,33840},{48,423}]'),(1006,5,'[]','[{1,2248},{2,44960},{48,562}]'),(1007,0,'[{0,20030009,1}]','[{1,542},{2,10840},{48,136},{61,80},{11,150}]'),(1007,1,'[{0,20030009,2}]','[{1,976},{2,19520},{48,245},{61,160},{11,190}]'),(1007,2,'[{0,20030009,4}]','[{1,1561},{2,31220},{48,391},{61,240},{11,230}]'),(1007,3,'[{0,20030009,6}]','[{1,2287},{2,45740},{48,573},{61,320},{11,270}]'),(1007,4,'[{0,20030009,8}]','[{1,3165},{2,63300},{48,793},{61,400},{11,310}]'),(1007,5,'[]','[{1,4206},{2,84120},{48,1053},{61,480},{11,350}]'),(1008,0,'[{0,20030010,1}]','[{1,1552},{2,31040},{48,388},{60,0},{232,180}]'),(1008,1,'[{0,20030010,2}]','[{1,2794},{2,55880},{48,699},{60,0},{232,230}]'),(1008,2,'[{0,20030010,4}]','[{1,4470},{2,89400},{48,1118},{60,0},{232,280}]'),(1008,3,'[{0,20030010,6}]','[{1,6550},{2,131000},{48,1638},{60,0},{232,330}]'),(1008,4,'[{0,20030010,8}]','[{1,9065},{2,181300},{48,2267},{60,0},{232,380}]'),(1008,5,'[]','[{1,12045},{2,240900},{48,3012},{60,0},{232,430}]'),(1009,0,'[{0,20030011,1}]','[{1,1569},{2,31380},{48,392},{61,100},{50,250}]'),(1009,1,'[{0,20030011,2}]','[{1,2824},{2,56480},{48,706},{61,200},{50,370}]'),(1009,2,'[{0,20030011,4}]','[{1,4519},{2,90380},{48,1130},{61,300},{50,490}]'),(1009,3,'[{0,20030011,6}]','[{1,6621},{2,132420},{48,1656},{61,400},{50,610}]'),(1009,4,'[{0,20030011,8}]','[{1,9163},{2,183260},{48,2292},{61,500},{50,730}]'),(1009,5,'[]','[{1,12176},{2,243520},{48,3045},{61,600},{50,850}]'),(1010,0,'[{0,20030012,1}]','[{1,1582},{2,31640},{48,396},{61,100},{51,250}]'),(1010,1,'[{0,20030012,2}]','[{1,2847},{2,56940},{48,712},{61,200},{51,370}]'),(1010,2,'[{0,20030012,4}]','[{1,4555},{2,91100},{48,1139},{61,300},{51,490}]'),(1010,3,'[{0,20030012,6}]','[{1,6674},{2,133480},{48,1669},{61,400},{51,610}]'),(1010,4,'[{0,20030012,8}]','[{1,9236},{2,184720},{48,2310},{61,500},{51,730}]'),(1010,5,'[]','[{1,12273},{2,245460},{48,3069},{61,600},{51,850}]'),(1011,0,'[{0,20030013,1}]','[{1,1594},{2,31880},{48,399},{60,100},{232,250}]'),(1011,1,'[{0,20030013,2}]','[{1,2869},{2,57380},{48,718},{60,200},{232,370}]'),(1011,2,'[{0,20030013,4}]','[{1,4591},{2,91820},{48,1149},{60,300},{232,490}]'),(1011,3,'[{0,20030013,6}]','[{1,6727},{2,134540},{48,1683},{60,400},{232,610}]'),(1011,4,'[{0,20030013,8}]','[{1,9310},{2,186200},{48,2329},{60,500},{232,730}]'),(1011,5,'[]','[{1,12371},{2,247420},{48,3094},{60,600},{232,850}]'),(1013,0,'[{0,20030007,1}]','[{1,1384},{2,27680},{48,346},{60,100},{232,180}]'),(1013,1,'[{0,20030007,2}]','[{1,2491},{2,49820},{48,623},{60,200},{232,230}]'),(1013,2,'[{0,20030007,4}]','[{1,3986},{2,79720},{48,997},{60,300},{232,280}]'),(1013,3,'[{0,20030007,6}]','[{1,5840},{2,116800},{48,1461},{60,400},{232,330}]'),(1013,4,'[{0,20030007,8}]','[{1,8082},{2,161640},{48,2022},{60,500},{232,380}]'),(1013,5,'[]','[{1,10739},{2,214780},{48,2686},{60,600},{232,430}]'),(1014,0,'[{0,20030006,1}]','[{1,710},{2,14200},{48,178},{60,60},{12,120}]'),(1014,1,'[{0,20030006,2}]','[{1,1278},{2,25560},{48,320},{60,120},{12,140}]'),(1014,2,'[{0,20030006,4}]','[{1,2045},{2,40900},{48,512},{60,180},{12,160}]'),(1014,3,'[{0,20030006,6}]','[{1,2997},{2,59940},{48,750},{60,240},{12,180}]'),(1014,4,'[{0,20030006,8}]','[{1,4148},{2,82960},{48,1038},{60,300},{12,205}]'),(1014,5,'[]','[{1,5512},{2,110240},{48,1379},{60,360},{12,230}]'),(1015,0,'[{0,20030008,1}]','[{1,710},{2,14200},{48,178},{61,60},{11,120}]'),(1015,1,'[{0,20030008,2}]','[{1,1278},{2,25560},{48,320},{61,120},{11,140}]'),(1015,2,'[{0,20030008,4}]','[{1,2045},{2,40900},{48,512},{61,180},{11,160}]'),(1015,3,'[{0,20030008,6}]','[{1,2997},{2,59940},{48,750},{61,240},{11,180}]'),(1015,4,'[{0,20030008,8}]','[{1,4148},{2,82960},{48,1038},{61,300},{11,205}]'),(1015,5,'[]','[{1,5512},{2,110240},{48,1379},{61,360},{11,230}]'),(1016,0,'[{0,20030014,1}]','[{1,710},{2,14200},{48,178},{61,60},{13,120}]'),(1016,1,'[{0,20030014,2}]','[{1,1278},{2,25560},{48,320},{61,120},{13,140}]'),(1016,2,'[{0,20030014,4}]','[{1,2045},{2,40900},{48,512},{61,180},{13,160}]'),(1016,3,'[{0,20030014,6}]','[{1,2997},{2,59940},{48,750},{61,240},{13,180}]'),(1016,4,'[{0,20030014,8}]','[{1,4148},{2,82960},{48,1038},{61,300},{13,205}]'),(1016,5,'[]','[{1,5512},{2,110240},{48,1379},{61,360},{13,230}]'),(1017,0,'[{0,20030015,1}]','[{1,710},{2,14200},{48,178},{60,60},{14,120}]'),(1017,1,'[{0,20030015,2}]','[{1,1278},{2,25560},{48,320},{60,120},{14,140}]'),(1017,2,'[{0,20030015,4}]','[{1,2045},{2,40900},{48,512},{60,180},{14,160}]'),(1017,3,'[{0,20030015,6}]','[{1,2997},{2,59940},{48,750},{60,240},{14,180}]'),(1017,4,'[{0,20030015,8}]','[{1,4148},{2,82960},{48,1038},{60,300},{14,205}]'),(1017,5,'[]','[{1,5512},{2,110240},{48,1379},{60,360},{14,230}]');
/*!40000 ALTER TABLE `base_twing_figure_lv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_twing_plume`
--

DROP TABLE IF EXISTS `base_twing_plume`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_twing_plume` (
  `grade` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '翅膀星级',
  `rand_attr` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '随机属性',
  `attr_limit` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '属性上限',
  `cost` varchar(512) NOT NULL DEFAULT '[]' COMMENT '消耗内容',
  `plume_ratio` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '星级属性提升百分比',
  `extra_attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '星级额外增加属性',
  PRIMARY KEY (`grade`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_twing_plume`
--

LOCK TABLES `base_twing_plume` WRITE;
/*!40000 ALTER TABLE `base_twing_plume` DISABLE KEYS */;
INSERT INTO `base_twing_plume` VALUES (0,'[{1,558},{2,11167},{48,367}]','[{1,1674},{2,33501},{48,1101}]','[{0,20040001,1},{0,20040001,1},{0,20040001,1},{0,20040001,1},{0,20040001,1}]',0,'[]'),(1,'[{1,1005},{2,20100},{48,660}]','[{1,6699},{2,134001},{48,4401}]','[{0,20040001,1},{0,20040001,1},{0,20040001,1},{0,20040002,1},{0,20040002,1}]',500,'[]'),(2,'[{1,1200},{2,24000},{48,785}]','[{1,15099},{2,302001},{48,9896}]','[{0,20040001,1},{0,20040001,1},{0,20040002,1},{0,20040002,1},{0,20040003,1}]',1500,'[]'),(3,'[{1,1413},{2,28266},{48,928}]','[{1,26403},{2,528129},{48,17320}]','[{0,20040001,1},{0,20040001,1},{0,20040002,1},{0,20040003,1},{0,20040004,1}]',3000,'[{52,2000}]'),(4,'[{1,2338},{2,46760},{48,1535}]','[{1,54459},{2,1089249},{48,35740}]','[{0,20040001,1},{0,20040002,1},{0,20040003,1},{0,20040004,1},{0,20040005,1}]',5000,'[{52,3500},{54,500}]'),(5,'[]','[]','[]',10000,'[{52,5000},{54,1000}]');
/*!40000 ALTER TABLE `base_twing_plume` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_twing_refine`
--

DROP TABLE IF EXISTS `base_twing_refine`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_twing_refine` (
  `grade` int(11) NOT NULL DEFAULT '0' COMMENT '阶数',
  `limit` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上限',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗',
  PRIMARY KEY (`grade`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='精炼配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_twing_refine`
--

LOCK TABLES `base_twing_refine` WRITE;
/*!40000 ALTER TABLE `base_twing_refine` DISABLE KEYS */;
INSERT INTO `base_twing_refine` VALUES (0,350,'[{20060001,10},{20060002,30},{20060003,100}]'),(1,350,'[{20060001,10},{20060002,30},{20060003,100}]'),(2,350,'[{20060001,10},{20060002,30},{20060003,100}]'),(3,400,'[{20060001,10},{20060002,30},{20060003,100}]'),(4,400,'[{20060001,10},{20060002,30},{20060003,100}]'),(5,400,'[{20060001,10},{20060002,30},{20060003,100}]');
/*!40000 ALTER TABLE `base_twing_refine` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_twing_refine_ratio`
--

DROP TABLE IF EXISTS `base_twing_refine_ratio`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_twing_refine_ratio` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '等级',
  `need_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '所需经验值',
  `ratio` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '属性加成比例',
  `attr` varchar(512) NOT NULL DEFAULT '[]' COMMENT '属性',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=401 DEFAULT CHARSET=utf8 COMMENT='精炼增加值';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_twing_refine_ratio`
--

LOCK TABLES `base_twing_refine_ratio` WRITE;
/*!40000 ALTER TABLE `base_twing_refine_ratio` DISABLE KEYS */;
INSERT INTO `base_twing_refine_ratio` VALUES (1,10,0,'[{2,0},{1,0},{3,0},{4,0}]'),(2,13,0,'[{2,180},{1,9},{3,7},{4,7}]'),(3,16,0,'[{2,378},{1,19},{3,15},{4,15}]'),(4,19,0,'[{2,594},{1,30},{3,24},{4,24}]'),(5,22,0,'[{2,828},{1,42},{3,33},{4,33}]'),(6,25,0,'[{2,1080},{1,55},{3,43},{4,43}]'),(7,28,0,'[{2,1350},{1,68},{3,54},{4,54}]'),(8,31,0,'[{2,1638},{1,82},{3,66},{4,66}]'),(9,34,0,'[{2,1944},{1,97},{3,78},{4,78}]'),(10,37,0,'[{2,2268},{1,113},{3,91},{4,91}]'),(11,40,0,'[{2,2610},{1,130},{3,105},{4,105}]'),(12,43,0,'[{2,2970},{1,148},{3,119},{4,119}]'),(13,46,0,'[{2,3348},{1,167},{3,134},{4,134}]'),(14,49,0,'[{2,3744},{1,187},{3,150},{4,150}]'),(15,52,0,'[{2,4158},{1,208},{3,167},{4,167}]'),(16,55,0,'[{2,4590},{1,230},{3,184},{4,184}]'),(17,58,0,'[{2,5040},{1,252},{3,202},{4,202}]'),(18,61,0,'[{2,5508},{1,275},{3,221},{4,221}]'),(19,64,0,'[{2,5994},{1,299},{3,240},{4,240}]'),(20,67,0,'[{2,6498},{1,324},{3,260},{4,260}]'),(21,70,0,'[{2,7020},{1,350},{3,281},{4,281}]'),(22,73,0,'[{2,7560},{1,377},{3,303},{4,303}]'),(23,76,0,'[{2,8118},{1,405},{3,325},{4,325}]'),(24,79,0,'[{2,8694},{1,434},{3,348},{4,348}]'),(25,82,0,'[{2,9288},{1,464},{3,372},{4,372}]'),(26,85,0,'[{2,9900},{1,495},{3,396},{4,396}]'),(27,88,0,'[{2,10530},{1,526},{3,421},{4,421}]'),(28,91,0,'[{2,11178},{1,558},{3,447},{4,447}]'),(29,94,0,'[{2,11844},{1,591},{3,474},{4,474}]'),(30,97,0,'[{2,12528},{1,625},{3,501},{4,501}]'),(31,100,0,'[{2,13230},{1,660},{3,529},{4,529}]'),(32,103,0,'[{2,13950},{1,696},{3,558},{4,558}]'),(33,106,0,'[{2,14687},{1,733},{3,587},{4,587}]'),(34,109,0,'[{2,15442},{1,771},{3,617},{4,617}]'),(35,112,0,'[{2,16215},{1,810},{3,648},{4,648}]'),(36,115,0,'[{2,17006},{1,850},{3,680},{4,680}]'),(37,118,0,'[{2,17815},{1,890},{3,712},{4,712}]'),(38,121,0,'[{2,18642},{1,931},{3,745},{4,745}]'),(39,124,0,'[{2,19487},{1,973},{3,779},{4,779}]'),(40,127,0,'[{2,20350},{1,1016},{3,814},{4,814}]'),(41,130,0,'[{2,21231},{1,1060},{3,849},{4,849}]'),(42,133,0,'[{2,22130},{1,1105},{3,885},{4,885}]'),(43,136,0,'[{2,23047},{1,1151},{3,922},{4,922}]'),(44,139,0,'[{2,23982},{1,1198},{3,959},{4,959}]'),(45,142,0,'[{2,24935},{1,1246},{3,997},{4,997}]'),(46,145,0,'[{2,25906},{1,1295},{3,1036},{4,1036}]'),(47,148,0,'[{2,26895},{1,1344},{3,1076},{4,1076}]'),(48,151,0,'[{2,27902},{1,1394},{3,1116},{4,1116}]'),(49,154,0,'[{2,28927},{1,1445},{3,1157},{4,1157}]'),(50,157,0,'[{2,29970},{1,1497},{3,1199},{4,1199}]'),(51,160,0,'[{2,31031},{1,1550},{3,1241},{4,1241}]'),(52,163,0,'[{2,32110},{1,1604},{3,1284},{4,1284}]'),(53,166,0,'[{2,33207},{1,1659},{3,1328},{4,1328}]'),(54,169,0,'[{2,34322},{1,1715},{3,1373},{4,1373}]'),(55,172,0,'[{2,35455},{1,1772},{3,1418},{4,1418}]'),(56,175,0,'[{2,36606},{1,1830},{3,1464},{4,1464}]'),(57,178,0,'[{2,37775},{1,1888},{3,1511},{4,1511}]'),(58,181,0,'[{2,38962},{1,1947},{3,1558},{4,1558}]'),(59,184,0,'[{2,40167},{1,2007},{3,1606},{4,1606}]'),(60,187,0,'[{2,41390},{1,2068},{3,1655},{4,1655}]'),(61,190,0,'[{2,42631},{1,2130},{3,1705},{4,1705}]'),(62,193,0,'[{2,43890},{1,2193},{3,1755},{4,1755}]'),(63,196,0,'[{2,45167},{1,2257},{3,1806},{4,1806}]'),(64,199,0,'[{2,46462},{1,2322},{3,1858},{4,1858}]'),(65,202,0,'[{2,47775},{1,2388},{3,1911},{4,1911}]'),(66,205,0,'[{2,49106},{1,2455},{3,1964},{4,1964}]'),(67,208,0,'[{2,50455},{1,2522},{3,2018},{4,2018}]'),(68,211,0,'[{2,51822},{1,2590},{3,2073},{4,2073}]'),(69,214,0,'[{2,53207},{1,2659},{3,2128},{4,2128}]'),(70,217,0,'[{2,54610},{1,2729},{3,2184},{4,2184}]'),(71,220,0,'[{2,56031},{1,2800},{3,2241},{4,2241}]'),(72,223,0,'[{2,57470},{1,2872},{3,2299},{4,2299}]'),(73,226,0,'[{2,58927},{1,2945},{3,2357},{4,2357}]'),(74,229,0,'[{2,60402},{1,3019},{3,2416},{4,2416}]'),(75,232,0,'[{2,61895},{1,3094},{3,2476},{4,2476}]'),(76,235,0,'[{2,63406},{1,3170},{3,2536},{4,2536}]'),(77,238,0,'[{2,64935},{1,3246},{3,2597},{4,2597}]'),(78,241,0,'[{2,66482},{1,3323},{3,2659},{4,2659}]'),(79,244,0,'[{2,68047},{1,3401},{3,2722},{4,2722}]'),(80,247,0,'[{2,69630},{1,3480},{3,2785},{4,2785}]'),(81,250,0,'[{2,71231},{1,3560},{3,2849},{4,2849}]'),(82,253,0,'[{2,72850},{1,3641},{3,2914},{4,2914}]'),(83,256,0,'[{2,74487},{1,3723},{3,2979},{4,2979}]'),(84,259,0,'[{2,76142},{1,3806},{3,3045},{4,3045}]'),(85,262,0,'[{2,77815},{1,3890},{3,3112},{4,3112}]'),(86,265,0,'[{2,79506},{1,3975},{3,3180},{4,3180}]'),(87,268,0,'[{2,81215},{1,4060},{3,3248},{4,3248}]'),(88,271,0,'[{2,82942},{1,4146},{3,3317},{4,3317}]'),(89,274,0,'[{2,84687},{1,4233},{3,3387},{4,3387}]'),(90,277,0,'[{2,86450},{1,4321},{3,3458},{4,3458}]'),(91,280,0,'[{2,88231},{1,4410},{3,3529},{4,3529}]'),(92,283,0,'[{2,90030},{1,4500},{3,3601},{4,3601}]'),(93,286,0,'[{2,91847},{1,4591},{3,3674},{4,3674}]'),(94,289,0,'[{2,93682},{1,4683},{3,3747},{4,3747}]'),(95,292,0,'[{2,95535},{1,4776},{3,3821},{4,3821}]'),(96,295,0,'[{2,97406},{1,4870},{3,3896},{4,3896}]'),(97,298,0,'[{2,99295},{1,4964},{3,3972},{4,3972}]'),(98,301,0,'[{2,101202},{1,5059},{3,4048},{4,4048}]'),(99,304,0,'[{2,103127},{1,5155},{3,4125},{4,4125}]'),(100,307,0,'[{2,105070},{1,5252},{3,4203},{4,4203}]'),(101,310,0,'[{2,107031},{1,5350},{3,4281},{4,4281}]'),(102,313,0,'[{2,109010},{1,5449},{3,4360},{4,4360}]'),(103,316,0,'[{2,111007},{1,5549},{3,4440},{4,4440}]'),(104,319,0,'[{2,113022},{1,5650},{3,4521},{4,4521}]'),(105,322,0,'[{2,115055},{1,5752},{3,4602},{4,4602}]'),(106,325,0,'[{2,117106},{1,5855},{3,4684},{4,4684}]'),(107,328,0,'[{2,119175},{1,5958},{3,4767},{4,4767}]'),(108,331,0,'[{2,121262},{1,6062},{3,4850},{4,4850}]'),(109,334,0,'[{2,123367},{1,6167},{3,4934},{4,4934}]'),(110,337,0,'[{2,125490},{1,6273},{3,5019},{4,5019}]'),(111,340,0,'[{2,127631},{1,6380},{3,5105},{4,5105}]'),(112,343,0,'[{2,129790},{1,6488},{3,5191},{4,5191}]'),(113,346,0,'[{2,131966},{1,6597},{3,5278},{4,5278}]'),(114,349,0,'[{2,134160},{1,6707},{3,5366},{4,5366}]'),(115,352,0,'[{2,136372},{1,6818},{3,5454},{4,5454}]'),(116,355,0,'[{2,138602},{1,6930},{3,5543},{4,5543}]'),(117,358,0,'[{2,140850},{1,7042},{3,5633},{4,5633}]'),(118,361,0,'[{2,143116},{1,7155},{3,5724},{4,5724}]'),(119,364,0,'[{2,145400},{1,7269},{3,5815},{4,5815}]'),(120,367,0,'[{2,147702},{1,7384},{3,5907},{4,5907}]'),(121,370,0,'[{2,150022},{1,7500},{3,6000},{4,6000}]'),(122,373,0,'[{2,152360},{1,7617},{3,6094},{4,6094}]'),(123,376,0,'[{2,154716},{1,7735},{3,6188},{4,6188}]'),(124,379,0,'[{2,157090},{1,7854},{3,6283},{4,6283}]'),(125,382,0,'[{2,159482},{1,7974},{3,6379},{4,6379}]'),(126,385,0,'[{2,161892},{1,8095},{3,6475},{4,6475}]'),(127,388,0,'[{2,164320},{1,8216},{3,6572},{4,6572}]'),(128,391,0,'[{2,166766},{1,8338},{3,6670},{4,6670}]'),(129,394,0,'[{2,169230},{1,8461},{3,6769},{4,6769}]'),(130,397,0,'[{2,171712},{1,8585},{3,6868},{4,6868}]'),(131,400,0,'[{2,174212},{1,8710},{3,6968},{4,6968}]'),(132,403,0,'[{2,176730},{1,8836},{3,7069},{4,7069}]'),(133,406,0,'[{2,179266},{1,8963},{3,7170},{4,7170}]'),(134,409,0,'[{2,181820},{1,9091},{3,7272},{4,7272}]'),(135,412,0,'[{2,184392},{1,9220},{3,7375},{4,7375}]'),(136,415,0,'[{2,186982},{1,9350},{3,7479},{4,7479}]'),(137,418,0,'[{2,189590},{1,9480},{3,7583},{4,7583}]'),(138,421,0,'[{2,192216},{1,9611},{3,7688},{4,7688}]'),(139,424,0,'[{2,194860},{1,9743},{3,7794},{4,7794}]'),(140,427,0,'[{2,197522},{1,9876},{3,7900},{4,7900}]'),(141,430,0,'[{2,200202},{1,10010},{3,8007},{4,8007}]'),(142,433,0,'[{2,202900},{1,10145},{3,8115},{4,8115}]'),(143,436,0,'[{2,205616},{1,10281},{3,8224},{4,8224}]'),(144,439,0,'[{2,208350},{1,10418},{3,8333},{4,8333}]'),(145,442,0,'[{2,211102},{1,10556},{3,8443},{4,8443}]'),(146,445,0,'[{2,213872},{1,10695},{3,8554},{4,8554}]'),(147,448,0,'[{2,216660},{1,10834},{3,8666},{4,8666}]'),(148,451,0,'[{2,219466},{1,10974},{3,8778},{4,8778}]'),(149,454,0,'[{2,222290},{1,11115},{3,8891},{4,8891}]'),(150,457,0,'[{2,225132},{1,11257},{3,9005},{4,9005}]'),(151,460,0,'[{2,227992},{1,11400},{3,9119},{4,9119}]'),(152,463,0,'[{2,230870},{1,11544},{3,9234},{4,9234}]'),(153,466,0,'[{2,233766},{1,11689},{3,9350},{4,9350}]'),(154,469,0,'[{2,236680},{1,11835},{3,9467},{4,9467}]'),(155,472,0,'[{2,239612},{1,11982},{3,9584},{4,9584}]'),(156,475,0,'[{2,242562},{1,12129},{3,9702},{4,9702}]'),(157,478,0,'[{2,245530},{1,12277},{3,9821},{4,9821}]'),(158,481,0,'[{2,248516},{1,12426},{3,9940},{4,9940}]'),(159,484,0,'[{2,251520},{1,12576},{3,10060},{4,10060}]'),(160,487,0,'[{2,254542},{1,12727},{3,10181},{4,10181}]'),(161,490,0,'[{2,257582},{1,12879},{3,10303},{4,10303}]'),(162,493,0,'[{2,260640},{1,13032},{3,10425},{4,10425}]'),(163,496,0,'[{2,263716},{1,13186},{3,10548},{4,10548}]'),(164,499,0,'[{2,266810},{1,13341},{3,10672},{4,10672}]'),(165,502,0,'[{2,269922},{1,13497},{3,10796},{4,10796}]'),(166,505,0,'[{2,273052},{1,13653},{3,10921},{4,10921}]'),(167,508,0,'[{2,276200},{1,13810},{3,11047},{4,11047}]'),(168,511,0,'[{2,279366},{1,13968},{3,11174},{4,11174}]'),(169,514,0,'[{2,282550},{1,14127},{3,11301},{4,11301}]'),(170,517,0,'[{2,285752},{1,14287},{3,11429},{4,11429}]'),(171,520,0,'[{2,288972},{1,14448},{3,11558},{4,11558}]'),(172,523,0,'[{2,292210},{1,14610},{3,11688},{4,11688}]'),(173,526,0,'[{2,295466},{1,14773},{3,11818},{4,11818}]'),(174,529,0,'[{2,298740},{1,14937},{3,11949},{4,11949}]'),(175,532,0,'[{2,302032},{1,15102},{3,12081},{4,12081}]'),(176,535,0,'[{2,305342},{1,15267},{3,12213},{4,12213}]'),(177,538,0,'[{2,308670},{1,15433},{3,12346},{4,12346}]'),(178,541,0,'[{2,312016},{1,15600},{3,12480},{4,12480}]'),(179,544,0,'[{2,315380},{1,15768},{3,12615},{4,12615}]'),(180,547,0,'[{2,318762},{1,15937},{3,12750},{4,12750}]'),(181,550,0,'[{2,322162},{1,16107},{3,12886},{4,12886}]'),(182,553,0,'[{2,325580},{1,16278},{3,13023},{4,13023}]'),(183,556,0,'[{2,329016},{1,16450},{3,13160},{4,13160}]'),(184,559,0,'[{2,332470},{1,16623},{3,13298},{4,13298}]'),(185,562,0,'[{2,335942},{1,16797},{3,13437},{4,13437}]'),(186,565,0,'[{2,339432},{1,16971},{3,13577},{4,13577}]'),(187,568,0,'[{2,342940},{1,17146},{3,13717},{4,13717}]'),(188,571,0,'[{2,346466},{1,17322},{3,13858},{4,13858}]'),(189,574,0,'[{2,350010},{1,17499},{3,14000},{4,14000}]'),(190,577,0,'[{2,353572},{1,17677},{3,14142},{4,14142}]'),(191,580,0,'[{2,357152},{1,17856},{3,14285},{4,14285}]'),(192,583,0,'[{2,360750},{1,18036},{3,14429},{4,14429}]'),(193,586,0,'[{2,364365},{1,18217},{3,14574},{4,14574}]'),(194,589,0,'[{2,367998},{1,18399},{3,14719},{4,14719}]'),(195,592,0,'[{2,371649},{1,18582},{3,14865},{4,14865}]'),(196,595,0,'[{2,375318},{1,18765},{3,15012},{4,15012}]'),(197,598,0,'[{2,379005},{1,18949},{3,15159},{4,15159}]'),(198,601,0,'[{2,382710},{1,19134},{3,15307},{4,15307}]'),(199,604,0,'[{2,386433},{1,19320},{3,15456},{4,15456}]'),(200,607,0,'[{2,390174},{1,19507},{3,15606},{4,15606}]'),(201,610,0,'[{2,393933},{1,19695},{3,15756},{4,15756}]'),(202,613,0,'[{2,397710},{1,19884},{3,15907},{4,15907}]'),(203,616,0,'[{2,401505},{1,20074},{3,16059},{4,16059}]'),(204,619,0,'[{2,405318},{1,20265},{3,16212},{4,16212}]'),(205,622,0,'[{2,409149},{1,20457},{3,16365},{4,16365}]'),(206,625,0,'[{2,412998},{1,20649},{3,16519},{4,16519}]'),(207,628,0,'[{2,416865},{1,20842},{3,16674},{4,16674}]'),(208,631,0,'[{2,420750},{1,21036},{3,16829},{4,16829}]'),(209,634,0,'[{2,424653},{1,21231},{3,16985},{4,16985}]'),(210,637,0,'[{2,428574},{1,21427},{3,17142},{4,17142}]'),(211,640,0,'[{2,432513},{1,21624},{3,17300},{4,17300}]'),(212,643,0,'[{2,436470},{1,21822},{3,17458},{4,17458}]'),(213,646,0,'[{2,440445},{1,22021},{3,17617},{4,17617}]'),(214,649,0,'[{2,444438},{1,22221},{3,17777},{4,17777}]'),(215,652,0,'[{2,448449},{1,22422},{3,17937},{4,17937}]'),(216,655,0,'[{2,452478},{1,22623},{3,18098},{4,18098}]'),(217,658,0,'[{2,456525},{1,22825},{3,18260},{4,18260}]'),(218,661,0,'[{2,460590},{1,23028},{3,18423},{4,18423}]'),(219,664,0,'[{2,464673},{1,23232},{3,18586},{4,18586}]'),(220,667,0,'[{2,468774},{1,23437},{3,18750},{4,18750}]'),(221,670,0,'[{2,472893},{1,23643},{3,18915},{4,18915}]'),(222,673,0,'[{2,477030},{1,23850},{3,19080},{4,19080}]'),(223,676,0,'[{2,481185},{1,24058},{3,19246},{4,19246}]'),(224,679,0,'[{2,485358},{1,24267},{3,19413},{4,19413}]'),(225,682,0,'[{2,489549},{1,24477},{3,19581},{4,19581}]'),(226,685,0,'[{2,493758},{1,24687},{3,19749},{4,19749}]'),(227,688,0,'[{2,497985},{1,24898},{3,19918},{4,19918}]'),(228,691,0,'[{2,502230},{1,25110},{3,20088},{4,20088}]'),(229,694,0,'[{2,506493},{1,25323},{3,20259},{4,20259}]'),(230,697,0,'[{2,510774},{1,25537},{3,20430},{4,20430}]'),(231,700,0,'[{2,515073},{1,25752},{3,20602},{4,20602}]'),(232,703,0,'[{2,519390},{1,25968},{3,20775},{4,20775}]'),(233,706,0,'[{2,523725},{1,26185},{3,20948},{4,20948}]'),(234,709,0,'[{2,528078},{1,26403},{3,21122},{4,21122}]'),(235,712,0,'[{2,532449},{1,26622},{3,21297},{4,21297}]'),(236,715,0,'[{2,536838},{1,26841},{3,21473},{4,21473}]'),(237,718,0,'[{2,541245},{1,27061},{3,21649},{4,21649}]'),(238,721,0,'[{2,545670},{1,27282},{3,21826},{4,21826}]'),(239,724,0,'[{2,550113},{1,27504},{3,22004},{4,22004}]'),(240,727,0,'[{2,554574},{1,27727},{3,22182},{4,22182}]'),(241,730,0,'[{2,559053},{1,27951},{3,22361},{4,22361}]'),(242,733,0,'[{2,563550},{1,28176},{3,22541},{4,22541}]'),(243,736,0,'[{2,568065},{1,28402},{3,22722},{4,22722}]'),(244,739,0,'[{2,572598},{1,28629},{3,22903},{4,22903}]'),(245,742,0,'[{2,577149},{1,28857},{3,23085},{4,23085}]'),(246,745,0,'[{2,581718},{1,29085},{3,23268},{4,23268}]'),(247,748,0,'[{2,586305},{1,29314},{3,23451},{4,23451}]'),(248,751,0,'[{2,590910},{1,29544},{3,23635},{4,23635}]'),(249,754,0,'[{2,595533},{1,29775},{3,23820},{4,23820}]'),(250,757,0,'[{2,600174},{1,30007},{3,24006},{4,24006}]'),(251,760,0,'[{2,604833},{1,30240},{3,24192},{4,24192}]'),(252,763,0,'[{2,609510},{1,30474},{3,24379},{4,24379}]'),(253,766,0,'[{2,614205},{1,30709},{3,24567},{4,24567}]'),(254,769,0,'[{2,618918},{1,30945},{3,24756},{4,24756}]'),(255,772,0,'[{2,623649},{1,31182},{3,24945},{4,24945}]'),(256,775,0,'[{2,628398},{1,31419},{3,25135},{4,25135}]'),(257,778,0,'[{2,633165},{1,31657},{3,25326},{4,25326}]'),(258,781,0,'[{2,637950},{1,31896},{3,25517},{4,25517}]'),(259,784,0,'[{2,642753},{1,32136},{3,25709},{4,25709}]'),(260,787,0,'[{2,647574},{1,32377},{3,25902},{4,25902}]'),(261,790,0,'[{2,652413},{1,32619},{3,26096},{4,26096}]'),(262,793,0,'[{2,657270},{1,32862},{3,26290},{4,26290}]'),(263,796,0,'[{2,662145},{1,33106},{3,26485},{4,26485}]'),(264,799,0,'[{2,667038},{1,33351},{3,26681},{4,26681}]'),(265,802,0,'[{2,671949},{1,33597},{3,26877},{4,26877}]'),(266,805,0,'[{2,676878},{1,33843},{3,27074},{4,27074}]'),(267,808,0,'[{2,681825},{1,34090},{3,27272},{4,27272}]'),(268,811,0,'[{2,686790},{1,34338},{3,27471},{4,27471}]'),(269,814,0,'[{2,691773},{1,34587},{3,27670},{4,27670}]'),(270,817,0,'[{2,696774},{1,34837},{3,27870},{4,27870}]'),(271,820,0,'[{2,701793},{1,35088},{3,28071},{4,28071}]'),(272,823,0,'[{2,706830},{1,35340},{3,28272},{4,28272}]'),(273,826,0,'[{2,711885},{1,35593},{3,28474},{4,28474}]'),(274,829,0,'[{2,716957},{1,35847},{3,28677},{4,28677}]'),(275,832,0,'[{2,722047},{1,36102},{3,28881},{4,28881}]'),(276,835,0,'[{2,727155},{1,36357},{3,29085},{4,29085}]'),(277,838,0,'[{2,732281},{1,36613},{3,29290},{4,29290}]'),(278,841,0,'[{2,737425},{1,36870},{3,29496},{4,29496}]'),(279,844,0,'[{2,742587},{1,37128},{3,29702},{4,29702}]'),(280,847,0,'[{2,747767},{1,37387},{3,29909},{4,29909}]'),(281,850,0,'[{2,752965},{1,37647},{3,30117},{4,30117}]'),(282,853,0,'[{2,758181},{1,37908},{3,30326},{4,30326}]'),(283,856,0,'[{2,763415},{1,38170},{3,30535},{4,30535}]'),(284,859,0,'[{2,768667},{1,38433},{3,30745},{4,30745}]'),(285,862,0,'[{2,773937},{1,38697},{3,30956},{4,30956}]'),(286,865,0,'[{2,779225},{1,38961},{3,31168},{4,31168}]'),(287,868,0,'[{2,784531},{1,39226},{3,31380},{4,31380}]'),(288,871,0,'[{2,789855},{1,39492},{3,31593},{4,31593}]'),(289,874,0,'[{2,795197},{1,39759},{3,31807},{4,31807}]'),(290,877,0,'[{2,800557},{1,40027},{3,32021},{4,32021}]'),(291,880,0,'[{2,805935},{1,40296},{3,32236},{4,32236}]'),(292,883,0,'[{2,811331},{1,40566},{3,32452},{4,32452}]'),(293,886,0,'[{2,816745},{1,40837},{3,32669},{4,32669}]'),(294,889,0,'[{2,822177},{1,41109},{3,32886},{4,32886}]'),(295,892,0,'[{2,827627},{1,41382},{3,33104},{4,33104}]'),(296,895,0,'[{2,833095},{1,41655},{3,33323},{4,33323}]'),(297,898,0,'[{2,838581},{1,41929},{3,33542},{4,33542}]'),(298,901,0,'[{2,844085},{1,42204},{3,33762},{4,33762}]'),(299,904,0,'[{2,849607},{1,42480},{3,33983},{4,33983}]'),(300,907,0,'[{2,855147},{1,42757},{3,34205},{4,34205}]'),(301,910,0,'[{2,860705},{1,43035},{3,34427},{4,34427}]'),(302,913,0,'[{2,866281},{1,43314},{3,34650},{4,34650}]'),(303,916,0,'[{2,871875},{1,43594},{3,34874},{4,34874}]'),(304,919,0,'[{2,877487},{1,43875},{3,35098},{4,35098}]'),(305,922,0,'[{2,883117},{1,44157},{3,35323},{4,35323}]'),(306,925,0,'[{2,888765},{1,44439},{3,35549},{4,35549}]'),(307,928,0,'[{2,894431},{1,44722},{3,35776},{4,35776}]'),(308,931,0,'[{2,900115},{1,45006},{3,36003},{4,36003}]'),(309,934,0,'[{2,905817},{1,45291},{3,36231},{4,36231}]'),(310,937,0,'[{2,911537},{1,45577},{3,36460},{4,36460}]'),(311,940,0,'[{2,917275},{1,45864},{3,36690},{4,36690}]'),(312,943,0,'[{2,923031},{1,46152},{3,36920},{4,36920}]'),(313,946,0,'[{2,928805},{1,46441},{3,37151},{4,37151}]'),(314,949,0,'[{2,934597},{1,46731},{3,37383},{4,37383}]'),(315,952,0,'[{2,940407},{1,47021},{3,37615},{4,37615}]'),(316,955,0,'[{2,946235},{1,47312},{3,37848},{4,37848}]'),(317,958,0,'[{2,952081},{1,47604},{3,38082},{4,38082}]'),(318,961,0,'[{2,957945},{1,47897},{3,38317},{4,38317}]'),(319,964,0,'[{2,963827},{1,48191},{3,38552},{4,38552}]'),(320,967,0,'[{2,969727},{1,48486},{3,38788},{4,38788}]'),(321,970,0,'[{2,975645},{1,48782},{3,39025},{4,39025}]'),(322,973,0,'[{2,981581},{1,49079},{3,39262},{4,39262}]'),(323,976,0,'[{2,987535},{1,49377},{3,39500},{4,39500}]'),(324,979,0,'[{2,993507},{1,49676},{3,39739},{4,39739}]'),(325,982,0,'[{2,999497},{1,49975},{3,39979},{4,39979}]'),(326,985,0,'[{2,1005505},{1,50275},{3,40219},{4,40219}]'),(327,988,0,'[{2,1011531},{1,50576},{3,40460},{4,40460}]'),(328,991,0,'[{2,1017575},{1,50878},{3,40702},{4,40702}]'),(329,994,0,'[{2,1023637},{1,51181},{3,40944},{4,40944}]'),(330,997,0,'[{2,1029717},{1,51485},{3,41187},{4,41187}]'),(331,1000,0,'[{2,1035815},{1,51790},{3,41431},{4,41431}]'),(332,1003,0,'[{2,1041931},{1,52096},{3,41676},{4,41676}]'),(333,1006,0,'[{2,1048065},{1,52403},{3,41921},{4,41921}]'),(334,1009,0,'[{2,1054217},{1,52711},{3,42167},{4,42167}]'),(335,1012,0,'[{2,1060387},{1,53019},{3,42414},{4,42414}]'),(336,1015,0,'[{2,1066575},{1,53328},{3,42662},{4,42662}]'),(337,1018,0,'[{2,1072781},{1,53638},{3,42910},{4,42910}]'),(338,1021,0,'[{2,1079005},{1,53949},{3,43159},{4,43159}]'),(339,1024,0,'[{2,1085247},{1,54261},{3,43409},{4,43409}]'),(340,1027,0,'[{2,1091507},{1,54574},{3,43659},{4,43659}]'),(341,1030,0,'[{2,1097785},{1,54888},{3,43910},{4,43910}]'),(342,1033,0,'[{2,1104081},{1,55203},{3,44162},{4,44162}]'),(343,1036,0,'[{2,1110395},{1,55519},{3,44415},{4,44415}]'),(344,1039,0,'[{2,1116727},{1,55836},{3,44668},{4,44668}]'),(345,1042,0,'[{2,1123077},{1,56153},{3,44922},{4,44922}]'),(346,1045,0,'[{2,1129445},{1,56471},{3,45177},{4,45177}]'),(347,1048,0,'[{2,1135831},{1,56790},{3,45432},{4,45432}]'),(348,1051,0,'[{2,1142235},{1,57110},{3,45688},{4,45688}]'),(349,1054,0,'[{2,1148657},{1,57431},{3,45945},{4,45945}]'),(350,1057,0,'[{2,1155097},{1,57753},{3,46203},{4,46203}]'),(351,1060,0,'[{2,1161555},{1,58076},{3,46461},{4,46461}]'),(352,1063,0,'[{2,1168031},{1,58400},{3,46720},{4,46720}]'),(353,1066,0,'[{2,1174525},{1,58725},{3,46980},{4,46980}]'),(354,1069,0,'[{2,1181036},{1,59051},{3,47240},{4,47240}]'),(355,1072,0,'[{2,1187565},{1,59377},{3,47501},{4,47501}]'),(356,1075,0,'[{2,1194112},{1,59704},{3,47763},{4,47763}]'),(357,1078,0,'[{2,1200677},{1,60032},{3,48026},{4,48026}]'),(358,1081,0,'[{2,1207260},{1,60361},{3,48289},{4,48289}]'),(359,1084,0,'[{2,1213861},{1,60691},{3,48553},{4,48553}]'),(360,1087,0,'[{2,1220480},{1,61022},{3,48818},{4,48818}]'),(361,1090,0,'[{2,1227117},{1,61354},{3,49083},{4,49083}]'),(362,1093,0,'[{2,1233772},{1,61687},{3,49349},{4,49349}]'),(363,1096,0,'[{2,1240445},{1,62021},{3,49616},{4,49616}]'),(364,1099,0,'[{2,1247136},{1,62356},{3,49884},{4,49884}]'),(365,1102,0,'[{2,1253845},{1,62691},{3,50152},{4,50152}]'),(366,1105,0,'[{2,1260572},{1,63027},{3,50421},{4,50421}]'),(367,1108,0,'[{2,1267317},{1,63364},{3,50691},{4,50691}]'),(368,1111,0,'[{2,1274080},{1,63702},{3,50962},{4,50962}]'),(369,1114,0,'[{2,1280861},{1,64041},{3,51233},{4,51233}]'),(370,1117,0,'[{2,1287660},{1,64381},{3,51505},{4,51505}]'),(371,1120,0,'[{2,1294477},{1,64722},{3,51778},{4,51778}]'),(372,1123,0,'[{2,1301312},{1,65064},{3,52051},{4,52051}]'),(373,1126,0,'[{2,1308165},{1,65407},{3,52325},{4,52325}]'),(374,1129,0,'[{2,1315036},{1,65751},{3,52600},{4,52600}]'),(375,1132,0,'[{2,1321925},{1,66095},{3,52876},{4,52876}]'),(376,1135,0,'[{2,1328832},{1,66440},{3,53152},{4,53152}]'),(377,1138,0,'[{2,1335757},{1,66786},{3,53429},{4,53429}]'),(378,1141,0,'[{2,1342700},{1,67133},{3,53707},{4,53707}]'),(379,1144,0,'[{2,1349661},{1,67481},{3,53985},{4,53985}]'),(380,1147,0,'[{2,1356640},{1,67830},{3,54264},{4,54264}]'),(381,1150,0,'[{2,1363637},{1,68180},{3,54544},{4,54544}]'),(382,1153,0,'[{2,1370652},{1,68531},{3,54825},{4,54825}]'),(383,1156,0,'[{2,1377685},{1,68883},{3,55106},{4,55106}]'),(384,1159,0,'[{2,1384736},{1,69236},{3,55388},{4,55388}]'),(385,1162,0,'[{2,1391805},{1,69589},{3,55671},{4,55671}]'),(386,1165,0,'[{2,1398892},{1,69943},{3,55954},{4,55954}]'),(387,1168,0,'[{2,1405997},{1,70298},{3,56238},{4,56238}]'),(388,1171,0,'[{2,1413120},{1,70654},{3,56523},{4,56523}]'),(389,1174,0,'[{2,1420261},{1,71011},{3,56809},{4,56809}]'),(390,1177,0,'[{2,1427420},{1,71369},{3,57095},{4,57095}]'),(391,1180,0,'[{2,1434597},{1,71728},{3,57382},{4,57382}]'),(392,1183,0,'[{2,1441792},{1,72088},{3,57670},{4,57670}]'),(393,1186,0,'[{2,1449005},{1,72449},{3,57959},{4,57959}]'),(394,1189,0,'[{2,1456236},{1,72811},{3,58248},{4,58248}]'),(395,1192,0,'[{2,1463485},{1,73173},{3,58538},{4,58538}]'),(396,1195,0,'[{2,1470752},{1,73536},{3,58829},{4,58829}]'),(397,1198,0,'[{2,1478037},{1,73900},{3,59120},{4,59120}]'),(398,1201,0,'[{2,1485340},{1,74265},{3,59412},{4,59412}]'),(399,1204,0,'[{2,1492661},{1,74631},{3,59705},{4,59705}]'),(400,1207,0,'[{2,1500000},{1,75000},{3,60000},{4,60000}]');
/*!40000 ALTER TABLE `base_twing_refine_ratio` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_twing_soul`
--

DROP TABLE IF EXISTS `base_twing_soul`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_twing_soul` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '羽魂id',
  `attr` varchar(512) NOT NULL DEFAULT '[]' COMMENT '属性',
  `limit_list` varchar(512) NOT NULL DEFAULT '[]' COMMENT '使用上限',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='羽魂配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_twing_soul`
--

LOCK TABLES `base_twing_soul` WRITE;
/*!40000 ALTER TABLE `base_twing_soul` DISABLE KEYS */;
INSERT INTO `base_twing_soul` VALUES (20020001,'[{2,1200},{48,25}]','[{1,250,250},{251,400,400},{401,1000,500}]'),(20020002,'[{1,60},{8,16}]','[{1,250,250},{251,400,400},{401,1000,500}]'),(20020003,'[{8,30},{48,50},{61,50}]','[{1,250,100},{251,400,150},{401,1000,200}]'),(20020004,'[{2,3600},{1,180},{48,75},{60,100}]','[{1,250,50},{251,400,80},{401,1000,100}]');
/*!40000 ALTER TABLE `base_twing_soul` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_type_task_dynamic`
--

DROP TABLE IF EXISTS `base_type_task_dynamic`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_type_task_dynamic` (
  `task_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '任务id',
  `slv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开始等级',
  `elv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '结束等级',
  `start_npc` int(11) unsigned DEFAULT '0' COMMENT '开始npc',
  `end_npc` int(11) unsigned DEFAULT '0' COMMENT '结束npc',
  `scene` int(11) unsigned DEFAULT '0' COMMENT '场景id',
  `x` int(11) unsigned DEFAULT '0' COMMENT 'X',
  `y` int(11) unsigned DEFAULT '0' COMMENT 'Y',
  `content_type` int(11) unsigned DEFAULT '0' COMMENT '任务内容类型',
  `id` int(11) unsigned DEFAULT '0' COMMENT 'id(MonId|DunId|GoodId)',
  `num` int(11) unsigned DEFAULT '0' COMMENT '完成次数|采集数|收集数',
  `extra_reward` varchar(512) NOT NULL DEFAULT '[]' COMMENT '环数额外奖励',
  PRIMARY KEY (`task_id`,`slv`,`elv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_type_task_dynamic`
--

LOCK TABLES `base_type_task_dynamic` WRITE;
/*!40000 ALTER TABLE `base_type_task_dynamic` DISABLE KEYS */;
INSERT INTO `base_type_task_dynamic` VALUES (60010001,1,199,100602,100603,1006,4844,12540,1,10060001,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60010200,200,239,100701,100702,1007,12599,2205,1,10070001,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60010240,240,279,100702,100703,1007,10700,1507,1,10070002,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60010280,280,319,100801,100802,1008,3158,3136,1,10080001,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60010320,320,349,100903,100903,1009,2388,8493,1,10090001,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60010350,350,374,101002,101003,1010,6452,1651,1,10100001,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60010375,375,399,101003,101004,1010,8543,5051,1,10100002,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60010400,400,424,101201,101202,1012,7443,13274,1,10120001,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60010425,425,449,101207,101208,1012,11447,16347,1,10120004,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60010450,450,474,101102,101103,1011,10410,6208,1,10110001,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60010475,475,514,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60010515,515,549,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60010550,550,574,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60010575,575,594,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60010595,595,609,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60010610,610,629,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60010630,630,649,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60010650,650,669,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60010670,670,689,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60010690,690,709,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60010710,710,729,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60010730,730,749,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60010750,750,769,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60010770,770,789,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60010790,790,809,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60010810,810,829,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60010830,830,849,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60010850,850,869,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60010870,870,889,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60010890,890,909,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60010910,910,929,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60010930,930,949,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60010950,950,969,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60010970,970,989,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60010990,990,1000,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60020001,1,199,100604,100605,1006,5452,16544,1,10060003,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60020200,200,239,100703,100704,1007,2603,4498,1,10070003,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60020240,240,279,100704,100705,1007,2549,8441,1,10070004,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60020280,280,319,100803,100804,1008,5361,10140,1,10080003,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60020320,320,349,100905,100906,1009,6398,14391,1,10090003,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60020350,350,374,101004,101005,1010,10997,4195,1,10100003,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60020375,375,399,101004,101005,1010,10997,4195,1,10100003,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60020400,400,424,101203,101204,1012,5749,17263,1,10120002,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60020425,425,449,101208,101209,1012,14187,11424,1,10120005,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60020450,450,474,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60020475,475,514,101106,101107,1011,2855,8443,1,10110003,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60020515,515,549,101106,101107,1011,2855,8443,1,10110003,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60020550,550,574,101106,101107,1011,2855,8443,1,10110003,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60020575,575,594,101106,101107,1011,2855,8443,1,10110003,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60020595,595,609,101106,101107,1011,2855,8443,1,10110003,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60020610,610,629,101106,101107,1011,2855,8443,1,10110003,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60020630,630,649,101106,101107,1011,2855,8443,1,10110003,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60020650,650,669,101106,101107,1011,2855,8443,1,10110003,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60020670,670,689,101106,101107,1011,2855,8443,1,10110003,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60020690,690,709,101106,101107,1011,2855,8443,1,10110003,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60020710,710,729,101106,101107,1011,2855,8443,1,10110003,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60020730,730,749,101106,101107,1011,2855,8443,1,10110003,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60020750,750,769,101106,101107,1011,2855,8443,1,10110003,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60020770,770,789,101106,101107,1011,2855,8443,1,10110003,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60020790,790,809,101106,101107,1011,2855,8443,1,10110003,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60020810,810,829,101106,101107,1011,2855,8443,1,10110003,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60020830,830,849,101106,101107,1011,2855,8443,1,10110003,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60020850,850,869,101106,101107,1011,2855,8443,1,10110003,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60020870,870,889,101106,101107,1011,2855,8443,1,10110003,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60020890,890,909,101106,101107,1011,2855,8443,1,10110003,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60020910,910,929,101106,101107,1011,2855,8443,1,10110003,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60020930,930,949,101106,101107,1011,2855,8443,1,10110003,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60020950,950,969,101106,101107,1011,2855,8443,1,10110003,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60020970,970,989,101106,101107,1011,2855,8443,1,10110003,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60020990,990,1000,101106,101107,1011,2855,8443,1,10110003,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60030001,1,199,100608,100609,1006,10855,6540,1,10060005,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60030200,200,239,100706,100707,1007,9745,7736,1,10070005,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60030240,240,279,100706,100707,1007,9745,7736,1,10070005,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60030280,280,319,100807,100808,1008,10663,8351,1,10080005,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60030320,320,349,100908,100909,1009,9959,8241,1,10090005,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60030350,350,374,101006,101007,1010,11697,9102,1,10100005,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60030375,375,399,101005,101006,1010,12856,6349,1,10100004,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60030400,400,424,101206,101207,1012,15544,19571,1,10120003,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60030425,425,449,101210,101210,1012,17413,8963,1,10120006,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60030450,450,474,101105,101106,1011,2855,8443,1,10110003,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60030475,475,514,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60030515,515,549,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60030550,550,574,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60030575,575,594,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60030595,595,609,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60030610,610,629,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60030630,630,649,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60030650,650,669,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60030670,670,689,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60030690,690,709,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60030710,710,729,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60030730,730,749,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60030750,750,769,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60030770,770,789,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60030790,790,809,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60030810,810,829,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60030830,830,849,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60030850,850,869,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60030870,870,889,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60030890,890,909,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60030910,910,929,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60030930,930,949,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60030950,950,969,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60030970,970,989,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60030990,990,1000,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60040001,1,199,100609,100612,1006,13903,7597,1,10060007,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60040200,200,239,100707,100713,1007,12750,7333,1,10070006,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60040240,240,279,100707,100713,1007,12750,7333,1,10070006,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60040280,280,319,100810,100813,1008,13802,9897,1,10080007,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60040320,320,349,100912,100912,1009,5498,1697,1,10090007,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60040350,350,374,101009,101010,1010,14304,13707,1,10100006,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60040375,375,399,101009,101010,1010,14304,13707,1,10100006,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60040400,400,424,101207,101208,1012,11447,16347,1,10120004,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60040425,425,449,101211,101212,1012,11840,3945,1,10120007,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60040450,450,474,101112,101111,1011,13449,8738,1,10110005,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60040475,475,514,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60040515,515,549,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60040550,550,574,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60040575,575,594,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60040595,595,609,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60040610,610,629,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60040630,630,649,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60040650,650,669,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60040670,670,689,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60040690,690,709,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60040710,710,729,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60040730,730,749,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60040750,750,769,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60040770,770,789,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60040790,790,809,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60040810,810,829,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60040830,830,849,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60040850,850,869,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60040870,870,889,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60040890,890,909,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60040910,910,929,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60040930,930,949,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60040950,950,969,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60040970,970,989,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60040990,990,1000,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60050001,1,199,100611,100611,1006,16500,10002,1,10060008,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60050200,200,239,100711,100712,1007,5605,11697,1,10070007,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60050240,240,279,100711,100712,1007,5605,11697,1,10070007,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60050280,280,319,100811,100811,1008,8596,15399,1,10080008,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60050320,320,349,100910,100914,1009,11406,4614,1,10090008,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60050350,350,374,101011,101012,1010,11651,16035,1,10100007,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60050375,375,399,101011,101013,1010,11651,16035,1,10100007,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60050400,400,424,101208,101209,1012,14187,11424,1,10120005,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60050425,425,449,101213,101214,1012,7967,8291,1,10120008,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60050450,450,474,101116,101117,1011,15938,5442,1,10110007,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60050475,475,514,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60050515,515,549,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60050550,550,574,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60050575,575,594,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60050595,595,609,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60050610,610,629,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60050630,630,649,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60050650,650,669,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60050670,670,689,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60050690,690,709,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60050710,710,729,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60050730,730,749,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60050750,750,769,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60050770,770,789,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60050790,790,809,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60050810,810,829,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60050830,830,849,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60050850,850,869,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60050870,870,889,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60050890,890,909,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60050910,910,929,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60050930,930,949,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60050950,950,969,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60050970,970,989,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60050990,990,1000,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60060001,1,199,100602,100604,1006,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60060200,200,239,100705,100706,1007,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60060240,240,279,100708,100709,1007,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60060280,280,319,100805,100806,1008,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60060320,320,349,100901,100902,1009,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60060350,350,374,101008,101009,1010,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60060375,375,399,101007,101008,1010,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60060400,400,424,101205,101206,1012,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60060425,425,449,101207,101208,1012,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60060450,450,474,101101,101102,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60060475,475,514,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60060515,515,549,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60060550,550,574,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60060575,575,594,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60060595,595,609,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60060610,610,629,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60060630,630,649,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60060650,650,669,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60060670,670,689,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60060690,690,709,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60060710,710,729,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60060730,730,749,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60060750,750,769,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60060770,770,789,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60060790,790,809,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60060810,810,829,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60060830,830,849,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60060850,850,869,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60060870,870,889,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60060890,890,909,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60060910,910,929,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60060930,930,949,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60060950,950,969,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60060970,970,989,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60060990,990,1000,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60070001,1,199,100607,100610,1006,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60070200,200,239,100707,100708,1007,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60070240,240,279,100710,100711,1007,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60070280,280,319,100808,100809,1008,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60070320,320,349,100903,100904,1009,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60070350,350,374,101009,101011,1010,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60070375,375,399,101010,101012,1010,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60070400,400,424,101206,101207,1012,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60070425,425,449,101209,101210,1012,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60070450,450,474,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60070475,475,514,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60070515,515,549,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60070550,550,574,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60070575,575,594,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60070595,595,609,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60070610,610,629,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60070630,630,649,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60070650,650,669,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60070670,670,689,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60070690,690,709,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60070710,710,729,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60070730,730,749,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60070750,750,769,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60070770,770,789,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60070790,790,809,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60070810,810,829,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60070830,830,849,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60070850,850,869,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60070870,870,889,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60070890,890,909,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60070910,910,929,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60070930,930,949,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60070950,950,969,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60070970,970,989,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60070990,990,1000,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60080001,1,199,100612,100611,1006,13642,5452,4,10060021,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60080200,200,239,100704,100705,1007,4021,5790,4,10070020,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60080240,240,279,100709,100710,1007,9318,10758,4,10070021,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60080280,280,319,100806,100806,1008,4284,12612,4,10080020,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60080320,320,349,100903,100904,1009,2410,12209,4,10090020,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60080350,350,374,101014,101014,1010,7075,5835,4,10100020,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60080375,375,399,101009,101011,1010,13946,14443,4,10100021,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60080400,400,424,101201,101202,1012,3906,11089,4,10120020,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60080425,425,449,101212,101213,1012,9063,5139,4,10120023,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60080450,450,474,101105,101105,1011,6150,8342,4,10110020,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60080475,475,514,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60080515,515,549,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60080550,550,574,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60080575,575,594,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60080595,595,609,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60080610,610,629,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60080630,630,649,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60080650,650,669,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60080670,670,689,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60080690,690,709,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60080710,710,729,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60080730,730,749,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60080750,750,769,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60080770,770,789,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60080790,790,809,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60080810,810,829,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60080830,830,849,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60080850,850,869,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60080870,870,889,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60080890,890,909,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60080910,910,929,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60080930,930,949,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60080950,950,969,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60080970,970,989,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60080990,990,1000,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60090001,1,199,100608,100610,1006,0,0,11,2101,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60090200,200,239,100702,100702,1007,0,0,11,2101,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60090240,240,279,100708,100708,1007,0,0,11,2101,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60090280,280,319,100805,100805,1008,0,0,11,2101,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60090320,320,349,100907,100907,1009,0,0,11,2101,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60090350,350,374,101008,101008,1010,0,0,11,2101,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60090375,375,399,101002,101002,1010,0,0,11,2101,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60090400,400,424,101207,101208,1012,0,0,11,2101,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60090425,425,449,101212,101213,1012,0,0,11,2101,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60090450,450,474,101106,101107,1011,0,0,11,2101,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60090475,475,514,101110,101111,1011,0,0,11,2101,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60090515,515,549,101110,101111,1011,0,0,11,2101,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60090550,550,574,101110,101111,1011,0,0,11,2101,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60090575,575,594,101110,101111,1011,0,0,11,2101,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60090595,595,609,101110,101111,1011,0,0,11,2101,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60090610,610,629,101110,101111,1011,0,0,11,2101,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60090630,630,649,101110,101111,1011,0,0,11,2101,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60090650,650,669,101110,101111,1011,0,0,11,2101,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60090670,670,689,101110,101111,1011,0,0,11,2101,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60090690,690,709,101110,101111,1011,0,0,11,2101,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60090710,710,729,101110,101111,1011,0,0,11,2101,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60090730,730,749,101110,101111,1011,0,0,11,2101,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60090750,750,769,101110,101111,1011,0,0,11,2101,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60090770,770,789,101110,101111,1011,0,0,11,2101,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60090790,790,809,101110,101111,1011,0,0,11,2101,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60090810,810,829,101110,101111,1011,0,0,11,2101,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60090830,830,849,101110,101111,1011,0,0,11,2101,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60090850,850,869,101110,101111,1011,0,0,11,2101,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60090870,870,889,101110,101111,1011,0,0,11,2101,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60090890,890,909,101110,101111,1011,0,0,11,2101,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60090910,910,929,101110,101111,1011,0,0,11,2101,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60090930,930,949,101110,101111,1011,0,0,11,2101,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60090950,950,969,101110,101111,1011,0,0,11,2101,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60090970,970,989,101110,101111,1011,0,0,11,2101,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60090990,990,1000,101110,101111,1011,0,0,11,2101,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60100001,1,199,100601,100602,1006,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60100200,200,239,100704,100704,1007,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60100240,240,279,100710,100710,1007,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60100280,280,319,100807,100807,1008,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60100320,320,349,100909,100909,1009,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60100350,350,374,101011,101011,1010,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60100375,375,399,101007,101007,1010,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60100400,400,424,101209,101210,1012,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60100425,425,449,101206,101207,1012,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60100450,450,474,101107,101108,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60100475,475,514,101112,101113,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60100515,515,549,101112,101113,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60100550,550,574,101112,101113,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60100575,575,594,101112,101113,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60100595,595,609,101112,101113,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60100610,610,629,101112,101113,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60100630,630,649,101112,101113,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60100650,650,669,101112,101113,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60100670,670,689,101112,101113,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60100690,690,709,101112,101113,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60100710,710,729,101112,101113,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60100730,730,749,101112,101113,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60100750,750,769,101112,101113,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60100770,770,789,101112,101113,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60100790,790,809,101112,101113,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60100810,810,829,101112,101113,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60100830,830,849,101112,101113,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60100850,850,869,101112,101113,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60100870,870,889,101112,101113,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60100890,890,909,101112,101113,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60100910,910,929,101112,101113,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60100930,930,949,101112,101113,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60100950,950,969,101112,101113,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60100970,970,989,101112,101113,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60100990,990,1000,101112,101113,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60110001,1,199,100607,100606,1006,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60110200,200,239,100706,100706,1007,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60110240,240,279,100712,100712,1007,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60110280,280,319,100809,100809,1008,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60110320,320,349,100911,100911,1009,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60110350,350,374,101012,101012,1010,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60110375,375,399,101011,101011,1010,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60110400,400,424,101211,101212,1012,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60110425,425,449,101207,101208,1012,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60110450,450,474,101108,101109,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60110475,475,514,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60110515,515,549,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60110550,550,574,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60110575,575,594,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60110595,595,609,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60110610,610,629,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60110630,630,649,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60110650,650,669,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60110670,670,689,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60110690,690,709,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60110710,710,729,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60110730,730,749,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60110750,750,769,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60110770,770,789,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60110790,790,809,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60110810,810,829,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60110830,830,849,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60110850,850,869,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60110870,870,889,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60110890,890,909,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60110910,910,929,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60110930,930,949,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60110950,950,969,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60110970,970,989,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(60110990,990,1000,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38070002,1}]},{20,[{0,38030001,1}]}]'),(70010001,1,55,100303,100303,1003,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70010056,56,80,100302,100303,1003,7848,4942,1,10030002,30,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70010081,81,99,100413,100413,1004,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70010095,100,119,100503,100503,1005,7502,3996,1,10050001,30,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70010105,120,139,100602,100603,1006,4844,12540,1,10060001,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70010120,140,159,100605,100605,1006,2145,14552,1,10060002,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70010155,160,179,100502,100503,1005,7502,3996,1,10050001,30,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70010180,180,200,100605,100605,1006,2145,14552,1,10060002,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70010201,201,239,100701,100701,1007,12599,2205,1,10070001,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70010240,240,279,100702,100703,1007,10700,1507,1,10070002,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70010280,280,319,100801,100802,1008,3158,3136,1,10080001,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70010320,320,349,100903,100903,1009,2388,8493,1,10090001,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70010350,350,374,101002,101003,1010,6452,1651,1,10100001,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70010375,375,399,101003,101004,1010,8543,5051,1,10100002,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70010400,400,424,101201,101202,1012,7443,13274,1,10120001,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70010425,425,449,101208,101209,1012,14187,11424,1,10120005,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70010450,450,474,101102,101103,1011,10410,6208,1,10110001,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70010475,475,514,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70010515,515,549,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70010550,550,574,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70010575,575,594,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70010595,595,609,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70010610,610,629,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70010630,630,649,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70010650,650,669,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70010670,670,689,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70010690,690,709,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70010710,710,729,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70010730,730,749,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70010750,750,769,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70010770,770,789,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70010790,790,809,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70010810,810,829,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70010830,830,849,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70010850,850,869,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70010870,870,889,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70010890,890,909,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70010910,910,929,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70010930,930,949,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70010950,950,969,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70010970,970,989,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70010990,990,1000,101104,101109,1011,6865,10345,1,10110002,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70020001,1,55,100305,100305,1003,0,0,11,2101,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70020056,56,80,100303,100305,1003,9459,6343,1,10030003,30,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70020081,81,99,100413,100413,1004,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70020095,100,119,100504,100505,1005,4053,8837,1,10050002,30,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70020105,120,139,100604,100605,1006,5452,16544,1,10060003,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70020120,140,159,100606,100606,1006,11444,10242,1,10060004,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70020155,160,179,100504,100505,1005,7744,14842,1,10050003,30,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70020180,180,200,100606,100606,1006,11444,10242,1,10060004,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70020201,201,239,100704,100704,1007,2549,8441,1,10070004,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70020240,240,279,100704,100705,1007,2549,8441,1,10070004,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70020280,280,319,100803,100804,1008,5361,10140,1,10080003,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70020320,320,349,100905,100906,1009,6398,14391,1,10090003,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70020350,350,374,101004,101005,1010,10997,4195,1,10100003,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70020375,375,399,101005,101006,1010,12856,6349,1,10100004,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70020400,400,424,101203,101204,1012,5749,17263,1,10120002,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70020425,425,449,101210,101210,1012,17413,8963,1,10120006,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70020450,450,474,101105,101106,1011,2855,8443,1,10110003,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70020475,475,514,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70020515,515,549,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70020550,550,574,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70020575,575,594,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70020595,595,609,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70020610,610,629,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70020630,630,649,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70020650,650,669,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70020670,670,689,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70020690,690,709,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70020710,710,729,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70020730,730,749,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70020750,750,769,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70020770,770,789,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70020790,790,809,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70020810,810,829,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70020830,830,849,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70020850,850,869,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70020870,870,889,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70020890,890,909,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70020910,910,929,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70020930,930,949,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70020950,950,969,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70020970,970,989,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70020990,990,1000,101108,101109,1011,4639,13003,1,10110004,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70030001,1,55,100304,100304,1003,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70030056,56,80,100305,100311,1003,10397,10898,1,10030005,30,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70030081,81,99,100401,100401,1004,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70030095,100,119,100510,100510,1005,10543,9748,1,10050004,30,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70030105,120,139,100608,100609,1006,10855,6540,1,10060005,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70030120,140,159,100609,100609,1006,12402,3296,1,10060006,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70030155,160,179,100507,100508,1005,14799,10003,1,10050005,30,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70030180,180,200,100609,100609,1006,12402,3296,1,10060006,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70030201,201,239,100707,100713,1007,12750,7333,1,10070006,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70030240,240,279,100707,100713,1007,12750,7333,1,10070006,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70030280,280,319,100807,100808,1008,10663,8351,1,10080005,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70030320,320,349,100908,100909,1009,9959,8241,1,10090005,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70030350,350,374,101006,101007,1010,11697,9102,1,10100005,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70030375,375,399,101009,101010,1010,14304,13707,1,10100006,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70030400,400,424,101206,101207,1012,15544,19571,1,10120003,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70030425,425,449,101211,101212,1012,11840,3945,1,10120007,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70030450,450,474,101112,101111,1011,13449,8738,1,10110005,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70030475,475,514,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70030515,515,549,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70030550,550,574,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70030575,575,594,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70030595,595,609,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70030610,610,629,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70030630,630,649,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70030650,650,669,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70030670,670,689,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70030690,690,709,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70030710,710,729,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70030730,730,749,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70030750,750,769,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70030770,770,789,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70030790,790,809,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70030810,810,829,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70030830,830,849,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70030850,850,869,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70030870,870,889,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70030890,890,909,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70030910,910,929,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70030930,930,949,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70030950,950,969,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70030970,970,989,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70030990,990,1000,101113,101110,1011,8748,11847,1,10110006,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70040056,56,80,100309,100308,1003,3846,6144,1,10030007,30,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70040081,81,99,100401,100401,1004,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70040095,100,119,100513,100514,1005,18803,6106,1,10050006,30,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70040105,120,139,100609,100612,1006,13903,7597,1,10060007,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70040120,140,159,100611,100611,1006,16500,10002,1,10060008,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70040155,160,179,100510,100510,1005,18803,6106,1,10050006,30,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70040180,180,200,100611,100611,1006,16500,10002,1,10060008,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70040201,201,239,100711,100712,1007,5605,11697,1,10070007,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70040240,240,279,100711,100712,1007,5605,11697,1,10070007,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70040280,280,319,100810,100813,1008,13802,9897,1,10080007,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70040320,320,349,100912,100912,1009,5498,1697,1,10090007,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70040350,350,374,101011,101012,1010,11651,16035,1,10100007,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70040375,375,399,101011,101013,1010,11651,16035,1,10100007,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70040400,400,424,101207,101208,1012,11447,16347,1,10120004,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70040425,425,449,101213,101214,1012,7967,8291,1,10120008,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70040450,450,474,101116,101117,1011,15938,5442,1,10110007,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70040475,475,514,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70040515,515,549,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70040550,550,574,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70040575,575,594,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70040595,595,609,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70040610,610,629,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70040630,630,649,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70040650,650,669,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70040670,670,689,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70040690,690,709,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70040710,710,729,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70040730,730,749,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70040750,750,769,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70040770,770,789,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70040790,790,809,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70040810,810,829,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70040830,830,849,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70040850,850,869,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70040870,870,889,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70040890,890,909,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70040910,910,929,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70040930,930,949,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70040950,950,969,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70040970,970,989,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70040990,990,1000,101116,101116,1011,18254,7247,1,10110008,40,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70050056,56,80,100301,100302,1003,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70050081,81,99,100407,100407,1004,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70050095,100,119,100501,100502,1005,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70050105,120,139,100602,100604,1006,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70050120,140,159,100603,100604,1006,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70050155,160,179,100501,100502,1005,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70050180,180,200,100603,100604,1006,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70050201,201,239,100702,100702,1007,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70050240,240,279,100708,100709,1007,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70050280,280,319,100805,100806,1008,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70050320,320,349,100901,100902,1009,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70050350,350,374,101008,101009,1010,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70050375,375,399,101007,101008,1010,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70050400,400,424,101205,101206,1012,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70050425,425,449,101207,101208,1012,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70050450,450,474,101101,101102,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70050475,475,514,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70050515,515,549,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70050550,550,574,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70050575,575,594,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70050595,595,609,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70050610,610,629,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70050630,630,649,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70050650,650,669,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70050670,670,689,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70050690,690,709,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70050710,710,729,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70050730,730,749,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70050750,750,769,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70050770,770,789,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70050790,790,809,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70050810,810,829,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70050830,830,849,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70050850,850,869,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70050870,870,889,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70050890,890,909,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70050910,910,929,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70050930,930,949,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70050950,950,969,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70050970,970,989,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70050990,990,1000,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70060056,56,80,100303,100304,1003,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70060081,81,99,100407,100407,1004,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70060095,100,119,100506,100507,1005,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70060105,120,139,100607,100610,1006,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70060120,140,159,100605,100606,1006,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70060155,160,179,100503,100504,1005,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70060180,180,200,100605,100606,1006,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70060201,201,239,100703,100705,1007,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70060240,240,279,100710,100711,1007,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70060280,280,319,100808,100809,1008,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70060320,320,349,100903,100904,1009,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70060350,350,374,101009,101011,1010,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70060375,375,399,101010,101012,1010,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70060400,400,424,101206,101207,1012,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70060425,425,449,101209,101210,1012,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70060450,450,474,101104,101105,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70060475,475,514,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70060515,515,549,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70060550,550,574,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70060575,575,594,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70060595,595,609,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70060610,610,629,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70060630,630,649,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70060650,650,669,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70060670,670,689,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70060690,690,709,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70060710,710,729,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70060730,730,749,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70060750,750,769,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70060770,770,789,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70060790,790,809,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70060810,810,829,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70060830,830,849,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70060850,850,869,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70060870,870,889,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70060890,890,909,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70060910,910,929,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70060930,930,949,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70060950,950,969,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70060970,970,989,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70060990,990,1000,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70070056,56,80,100305,100306,1003,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70070081,81,99,100409,100409,1004,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70070095,100,119,100508,100509,1005,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70070105,120,139,100612,100611,1006,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70070120,140,159,100607,100608,1006,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70070155,160,179,100505,100506,1005,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70070180,180,200,100607,100608,1006,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70070201,201,239,100707,100708,1007,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70070240,240,279,100709,100710,1007,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70070280,280,319,100809,100809,1008,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70070320,320,349,100907,100907,1009,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70070350,350,374,101009,101010,1010,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70070375,375,399,101002,101002,1010,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70070400,400,424,101207,101208,1012,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70070425,425,449,101212,101213,1012,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70070450,450,474,101106,101107,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70070475,475,514,101110,101111,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70070515,515,549,101110,101111,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70070550,550,574,101110,101111,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70070575,575,594,101110,101111,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70070595,595,609,101110,101111,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70070610,610,629,101110,101111,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70070630,630,649,101110,101111,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70070650,650,669,101110,101111,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70070670,670,689,101110,101111,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70070690,690,709,101110,101111,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70070710,710,729,101110,101111,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70070730,730,749,101110,101111,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70070750,750,769,101110,101111,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70070770,770,789,101110,101111,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70070790,790,809,101110,101111,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70070810,810,829,101110,101111,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70070830,830,849,101110,101111,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70070850,850,869,101110,101111,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70070870,870,889,101110,101111,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70070890,890,909,101110,101111,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70070910,910,929,101110,101111,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70070930,930,949,101110,101111,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70070950,950,969,101110,101111,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70070970,970,989,101110,101111,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70070990,990,1000,101110,101111,1011,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70080056,56,80,100307,100307,1003,0,0,11,2101,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70080081,81,99,100403,100403,1004,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70080095,100,119,100506,100506,1005,0,0,11,2101,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70080105,120,139,100608,100610,1006,0,0,11,2101,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70080120,140,159,100601,100601,1006,0,0,11,2101,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70080155,160,179,100502,100502,1005,0,0,11,2101,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70080180,180,200,100601,100601,1006,0,0,11,2101,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70080201,201,239,100705,100705,1007,0,0,11,2101,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70080240,240,279,100708,100708,1007,0,0,11,2101,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70080280,280,319,100805,100805,1008,0,0,11,2101,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70080320,320,349,100909,100909,1009,0,0,11,2101,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70080350,350,374,101008,101008,1010,0,0,11,2101,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70080375,375,399,101007,101007,1010,0,0,11,2102,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70080400,400,424,101209,101210,1012,0,0,11,2101,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70080425,425,449,101206,101207,1012,0,0,11,2101,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70080450,450,474,101107,101108,1011,0,0,11,2101,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70080475,475,514,101112,101113,1011,0,0,11,2101,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70080515,515,549,101112,101113,1011,0,0,11,2101,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70080550,550,574,101112,101113,1011,0,0,11,2101,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70080575,575,594,101112,101113,1011,0,0,11,2101,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70080595,595,609,101112,101113,1011,0,0,11,2101,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70080610,610,629,101112,101113,1011,0,0,11,2101,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70080630,630,649,101112,101113,1011,0,0,11,2101,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70080650,650,669,101112,101113,1011,0,0,11,2101,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70080670,670,689,101112,101113,1011,0,0,11,2101,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70080690,690,709,101112,101113,1011,0,0,11,2101,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70080710,710,729,101112,101113,1011,0,0,11,2101,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70080730,730,749,101112,101113,1011,0,0,11,2101,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70080750,750,769,101112,101113,1011,0,0,11,2101,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70080770,770,789,101112,101113,1011,0,0,11,2101,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70080790,790,809,101112,101113,1011,0,0,11,2101,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70080810,810,829,101112,101113,1011,0,0,11,2101,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70080830,830,849,101112,101113,1011,0,0,11,2101,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70080850,850,869,101112,101113,1011,0,0,11,2101,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70080870,870,889,101112,101113,1011,0,0,11,2101,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70080890,890,909,101112,101113,1011,0,0,11,2101,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70080910,910,929,101112,101113,1011,0,0,11,2101,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70080930,930,949,101112,101113,1011,0,0,11,2101,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70080950,950,969,101112,101113,1011,0,0,11,2101,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70080970,970,989,101112,101113,1011,0,0,11,2101,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70080990,990,1000,101112,101113,1011,0,0,11,2101,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70090056,56,80,100308,100308,1003,0,0,11,2102,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70090081,81,99,100417,100417,1004,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70090095,100,119,100510,100510,1005,0,0,11,2102,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70090105,120,139,100601,100602,1006,0,0,11,2102,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70090120,140,159,100606,100606,1006,0,0,11,2102,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70090155,160,179,100504,100504,1005,0,0,11,2102,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70090180,180,200,100606,100606,1006,0,0,11,2102,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70090201,201,239,100707,100707,1007,0,0,11,2102,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70090240,240,279,100712,100712,1007,0,0,11,2102,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70090280,280,319,100807,100807,1008,0,0,11,2102,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70090320,320,349,100911,100911,1009,0,0,11,2102,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70090350,350,374,101011,101011,1010,0,0,11,2102,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70090375,375,399,101011,101011,1010,0,0,11,2102,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70090400,400,424,101211,101212,1012,0,0,11,2102,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70090425,425,449,101207,101208,1012,0,0,11,2102,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70090450,450,474,101108,101109,1011,0,0,11,2102,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70090475,475,514,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70090515,515,549,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70090550,550,574,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70090575,575,594,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70090595,595,609,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70090610,610,629,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70090630,630,649,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70090650,650,669,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70090670,670,689,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70090690,690,709,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70090710,710,729,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70090730,730,749,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70090750,750,769,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70090770,770,789,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70090790,790,809,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70090810,810,829,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70090830,830,849,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70090850,850,869,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70090870,870,889,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70090890,890,909,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70090910,910,929,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70090930,930,949,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70090950,950,969,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70090970,970,989,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70090990,990,1000,101114,101115,1011,0,0,11,2102,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70100056,56,80,100304,100304,1003,12361,7230,4,10030020,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70100081,81,99,100414,100414,1004,0,0,5,0,0,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70100095,100,119,100507,100507,1005,5942,15058,4,10050020,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70100105,120,139,100607,100606,1006,6459,13539,4,10060020,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70100120,140,159,100612,100612,1006,13642,5452,4,10060021,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70100155,160,179,100506,100507,1005,12053,10747,4,10050021,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70100180,180,200,100612,100612,1006,13642,5452,4,10060021,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70100201,201,239,100710,100710,1007,9318,10758,4,10070021,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70100240,240,279,100705,100705,1007,4021,5790,4,10070020,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70100280,280,319,100806,100806,1008,4284,12612,4,10080020,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70100320,320,349,100903,100904,1009,2410,12209,4,10090020,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70100350,350,374,101014,101014,1010,7075,5835,4,10100020,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70100375,375,399,101009,101011,1010,13946,14443,4,10100021,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70100400,400,424,101201,101202,1012,3906,11089,4,10120020,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70100425,425,449,101212,101213,1012,9063,5139,4,10120023,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70100450,450,474,101105,101105,1011,6150,8342,4,10110020,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70100475,475,514,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70100515,515,549,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70100550,550,574,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70100575,575,594,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70100595,595,609,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70100610,610,629,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70100630,630,649,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70100650,650,669,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70100670,670,689,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70100690,690,709,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70100710,710,729,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70100730,730,749,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70100750,750,769,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70100770,770,789,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70100790,790,809,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70100810,810,829,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70100830,830,849,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70100850,850,869,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70100870,870,889,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70100890,890,909,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70100910,910,929,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70100930,930,949,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70100950,950,969,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70100970,970,989,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]'),(70100990,990,1000,101115,101115,1011,13959,16445,4,10110021,1,'[{10,[{0,38330001,3}]},{20,[{0,38030001,1}]}]');
/*!40000 ALTER TABLE `base_type_task_dynamic` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_up_combat_power_type`
--

DROP TABLE IF EXISTS `base_up_combat_power_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_up_combat_power_type` (
  `type` varchar(255) NOT NULL COMMENT '操作类型',
  `id` smallint(5) unsigned NOT NULL COMMENT 'id',
  `about` varchar(255) NOT NULL COMMENT '描述@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='战力提升操作类型表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_up_combat_power_type`
--

LOCK TABLES `base_up_combat_power_type` WRITE;
/*!40000 ALTER TABLE `base_up_combat_power_type` DISABLE KEYS */;
INSERT INTO `base_up_combat_power_type` VALUES ('unkown',0,'未知类型'),('up_god',1,'降神提升'),('mount_use_goods',2,'坐骑培养'),('mount_init',3,'坐骑初始化'),('mount_figure_lvup',4,'坐骑幻形阶数增加'),('mount_upgrade_star',5,'坐骑升星'),('mount_active_figure',6,'坐骑幻形激活'),('active_god',7,'降神激活'),('feed_god',8,'降神升阶'),('god_active_pyx',9,'降神激活圣器'),('god_feed_pyx',10,'降神圣器升星'),('feed_seal',11,'降神印记升级'),('stren_rune',12,'降神符文升阶'),('stren_rune_goods',13,'降神符文印记强化'),('active_pic',14,'图鉴激活'),('up_pic',15,'图鉴升级'),('activate_baby',16,'宝宝激活'),('baby_up_stage',17,'宝宝升阶'),('baby_up_grade',18,'宝宝养育'),('active_baby_mount',19,'宝宝坐骑激活'),('baby_mount_upstage',20,'宝宝坐骑升阶'),('activate_baby_fashion',21,'宝宝时装激活'),('baby_fashion_upstar',22,'宝宝时装升星'),('activate_baby_wing',23,'宝宝翅膀激活'),('baby_wing_upstar',24,'宝宝翅膀升星'),('build_up',25,'家园建筑升级'),('guige_change',26,'家园规格变化'),('pic_up',27,'家园图鉴升级'),('active_spirit',28,'圣灵激活'),('active_pyx',29,'圣器激活'),('spirit_up',30,'圣灵升级'),('refine_wing',31,'翅膀精炼'),('wing_soul',32,'翅膀羽魂使用'),('wing_plume',33,'翅膀羽化'),('active_wing_figure',34,'翅膀激活幻化'),('wing_figure_up',35,'翅膀幻化升星'),('active_deity',36,'神格激活'),('deity_devour',37,'神格吞噬'),('active_equip_devour',38,'装备吞噬激活'),('equip_devour',39,'装备吞噬'),('activate_fashion',40,'时装激活'),('fashion_upgrade_pos',41,'时装部位升级'),('fashion_upgrade',42,'时装升级'),('activate_light_weapon_normal',43,'专武激活'),('light_weapon_normal_uplv',44,'专武升级'),('light_weapon_normal_upgrade',45,'专武强化'),('light_weapon_figure_activate',46,'光武激活'),('light_weapon_figure_upstar',47,'光武升星'),('limit_goal',48,'限时目标星魂'),('activate_ring',49,'戒指激活'),('marriage_life',50,'同心结'),('ring_polish',51,'戒指打磨'),('ring_upgrade',52,'戒指提升'),('talisman_init',53,'宝具初始化'),('talisman_use_goods',54,'宝具培养'),('talisman_upgrade_lv',55,'宝具升级'),('talisman_active_figure',56,'宝具激活幻形'),('talisman_upgrade_star',57,'宝具升星'),('star_soul_inc_stage',58,'星灵升阶'),('star_soul_inc_lv',59,'星灵升星'),('star_soul_upgrade_universe',60,'星灵小宇宙突破'),('star_soul_learn_skill',61,'星灵学技能'),('star_soul_upgrade_skill',62,'星灵升级技能'),('star_soul_active',63,'激活星灵'),('star_shadow_ms_upgrade',64,'星痕铸魂强化'),('star_shadow_stren',65,'星痕强化'),('star_shadow_compose',66,'星痕合成'),('fishing_illu_up',67,'钓鱼图鉴升级'),('active_dress_up',68,'激活装扮'),('upgrade_dress_up',69,'升级装扮'),('upgrade_dress_up_illu',70,'升级装扮图鉴'),('active_adventure_book',71,'星之轨迹激活'),('active_dsgt',72,'激活称号'),('wear_star_soul_equip',73,'穿戴星灵装备'),('upgrade_star_soul_equip',74,'星灵装备升级'),('star_soul_equip_through',75,'星灵装备突破'),('equip_upgrade_stage',76,'装备进阶'),('equip_unlock_wash_pos',77,'开启洗炼槽'),('equip_wash',78,'装备洗练'),('equip_upgrade_division',79,'装备神锻'),('make_equip_suit',80,'装备套装打造'),('build_pink_equip',81,'粉装、神装打造'),('upgrade_prefix',82,'装备重铸');
/*!40000 ALTER TABLE `base_up_combat_power_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_version_upgradebag_reward`
--

DROP TABLE IF EXISTS `base_version_upgradebag_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_version_upgradebag_reward` (
  `version_code` bigint(30) NOT NULL COMMENT '编号',
  `color` varchar(512) NOT NULL COMMENT '公告颜色',
  `content` text NOT NULL COMMENT '公告内容@lang@',
  `name` varchar(256) NOT NULL COMMENT '礼包名称@lang@',
  `rewards` varchar(1024) NOT NULL COMMENT '奖励',
  `starttime` datetime NOT NULL COMMENT '开始时间',
  `endtime` datetime NOT NULL COMMENT '结束时间',
  `state` int(8) NOT NULL COMMENT '状态',
  PRIMARY KEY (`version_code`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='版本更新信息';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_version_upgradebag_reward`
--

LOCK TABLES `base_version_upgradebag_reward` WRITE;
/*!40000 ALTER TABLE `base_version_upgradebag_reward` DISABLE KEYS */;
INSERT INTO `base_version_upgradebag_reward` VALUES (1,'0','只要百姓衣食住行的需求都能得到一定程度的满足，帝国才会越来越强大！提升素质，全民齐动手，让我们从穿戴开始：\r\n\r\n<color=\'#00ccff\'>#装备觉醒和唤魔#</color>\r\n1.传奇110级开启装备觉醒和唤魔，可以百分比提高装备所有属性\r\n2.9阶红色2星以上的装备才可觉醒，只有神兵才能承载觉醒带来的强大力量\r\n3.已穿戴部位的基础属性.强化属性和套装属性都会以百分比提高，装备越强，提升越高\r\n4.已觉醒的装备可以进行唤魔，附加强大的唤魔技能\r\n5.唤魔技能为角色提高大量百分比属性，可以自由搭配各种技能，打造最强的自己\r\n6.可消耗材料为唤魔技能升级，装备的觉醒等级越高，唤魔技能的等级上限越高\r\n7.装备唤魔和觉醒材料散落在【觉醒之门】中\r\n\r\n<color=\'#00ccff\'>#觉醒之门#</color>\r\n1.传奇110级开启觉醒之门副本，抵御门中穿越过来的恶魔，可获得珍贵装备觉醒.唤魔材料\r\n2.副本开始时，怪物会从场景左方向右方自动寻路，玩家需要在怪物离开前尽可能的多击杀怪物\r\n3.玩家可以使用，减速，鼓舞，效率等手段提升击杀怪物的能力\r\n4.副本有波数上限，击杀的怪物波数和数量越高，奖励越丰厚\r\n\r\n<color=\'#00ccff\'>#惠民措施#</color>\r\n1.更换诛邪战场场景，邪雾散去后，诛邪战场展现了它真正的面目\r\n2.优化装备无法穿戴时的提示，专用弹窗，信息更清晰\r\n3.修复虚空秘境中，敌方死亡未复活时，不会自动切换目标的BUG\r\n4.优化经验副本刷怪效率，增加副本挑战的流畅度\r\n5.修复未达到贵族4的玩家可以在商城购买个人首领挑战券的问题。\r\n6.新增开服活动-0元豪礼；\r\n7.优化战斗中切换攻击目标的目标选择；\r\n8.修改巅峰竞技界面开启时间显示错误的问题；\r\n9.时装商城新增春暖花开泡泡框和相框；\r\n10.增加450级以上新的公会与日常任务，新的挑战等你来完成\r\n11.增加聊天界面中一键屏蔽语音功能，让你远离噪音污染与伤害\r\n12.钻石投资.至尊投资最高档增加称号奖励\r\n13.开服冲榜坐骑排行，精灵排行新增幻形奖励\r\n14.排位赛增加“直接击败”功能，挑战排名.战力均比自己低的对手可直接击败\r\n15.提高400级以上玩家的每日累充奖励。\r\n16.优化坐骑和精灵界面流畅度，修复部分显示错误。\r\n17.修复个人首领副本复活后卡住的问题。\r\n18.增加从首领刷新提示前往首领副本时的进入条件判断。','更新礼包','[{100, 37010006, 3},{100,37020001,3},{2,36020001,10}]','2018-05-09 00:00:00','2018-05-13 23:59:59',1);
/*!40000 ALTER TABLE `base_version_upgradebag_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_vip_card`
--

DROP TABLE IF EXISTS `base_vip_card`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_vip_card` (
  `vip_card` int(11) NOT NULL COMMENT '卡类型',
  `vip_lv` int(11) NOT NULL COMMENT '可激活的vip类型',
  `vip_duration` int(20) NOT NULL COMMENT '激活vip使用时长(秒)',
  `goods_id` int(20) NOT NULL COMMENT '对应物品id',
  `is_experience_card` int(8) NOT NULL COMMENT '是否为体验卡',
  PRIMARY KEY (`vip_card`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COMMENT='vip卡配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_vip_card`
--

LOCK TABLES `base_vip_card` WRITE;
/*!40000 ALTER TABLE `base_vip_card` DISABLE KEYS */;
INSERT INTO `base_vip_card` VALUES (0,0,1800,36040004,1),(1,1,2592000,36040001,0),(2,2,7776000,36040002,0),(3,4,15552000,36040003,0);
/*!40000 ALTER TABLE `base_vip_card` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_vip_card_new`
--

DROP TABLE IF EXISTS `base_vip_card_new`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_vip_card_new` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'vip卡类型',
  `type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '激活类型',
  `lv` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '激活等级',
  `time` int(20) unsigned NOT NULL DEFAULT '0' COMMENT '激活时长',
  `cost` int(20) unsigned NOT NULL DEFAULT '0' COMMENT '激活消耗',
  `exp` int(20) unsigned NOT NULL DEFAULT '0' COMMENT '转化经验',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='vip卡配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_vip_card_new`
--

LOCK TABLES `base_vip_card_new` WRITE;
/*!40000 ALTER TABLE `base_vip_card_new` DISABLE KEYS */;
INSERT INTO `base_vip_card_new` VALUES (2,2,2,2592000,36040001,0),(3,2,3,7776000,36040002,0),(4,2,4,15552000,36040003,0),(5,3,0,0,36040005,0),(6,1,3,259200,36040006,15),(7,1,5,432000,36040007,25),(8,3,0,259200,36040008,0),(9,1,0,0,36040009,20),(10,1,0,0,36040010,30),(11,1,1,0,36040004,0);
/*!40000 ALTER TABLE `base_vip_card_new` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_vip_effect_desc`
--

DROP TABLE IF EXISTS `base_vip_effect_desc`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_vip_effect_desc` (
  `id` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '自增id',
  `vip_card_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '卡类型',
  `modle_id` int(11) unsigned NOT NULL COMMENT '模型id',
  `effect` varchar(2048) NOT NULL DEFAULT '[]' COMMENT '特权',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='贵族特权说明表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_vip_effect_desc`
--

LOCK TABLES `base_vip_effect_desc` WRITE;
/*!40000 ALTER TABLE `base_vip_effect_desc` DISABLE KEYS */;
INSERT INTO `base_vip_effect_desc` VALUES (1,2,203017,'[{1,无限传送,在世界留足迹,1009,0},{2,市场买卖,税率减少一半,1007,0},{3,专属礼包,每周免费领取,1008,0},{4,经验飙升,打怪经验加10%,1010,0}]'),(2,3,203020,'[{1,双倍奖励,签到奖励翻倍,1006,0},{2,双倍礼包,双份VIP周礼包,1008,0},{3,混乱魔域,增加挑战次数,1004,0},{4,任务加成,日常经验加20%,1003,0}]'),(3,4,203021,'[{1,首领会所,开放权限增加,1005,0},{2,首领狩猎,掉落完美神装,1011,0},{3,吞噬加成,吞噬经验加50%,1002,0},{4,任务加成,日常经验加40%,1003,0}]');
/*!40000 ALTER TABLE `base_vip_effect_desc` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_vip_gift_card_cfg`
--

DROP TABLE IF EXISTS `base_vip_gift_card_cfg`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_vip_gift_card_cfg` (
  `id` tinyint(3) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `goods_id` int(11) unsigned NOT NULL COMMENT '物品id',
  `contact` text NOT NULL COMMENT '联系方式',
  `reward` varchar(255) NOT NULL COMMENT '奖励',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8 COMMENT='vip认证礼包配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_vip_gift_card_cfg`
--

LOCK TABLES `base_vip_gift_card_cfg` WRITE;
/*!40000 ALTER TABLE `base_vip_gift_card_cfg` DISABLE KEYS */;
INSERT INTO `base_vip_gift_card_cfg` VALUES (1,1,'微信号：xxxxx','[]');
/*!40000 ALTER TABLE `base_vip_gift_card_cfg` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_vip_kv`
--

DROP TABLE IF EXISTS `base_vip_kv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_vip_kv` (
  `id` tinyint(3) unsigned NOT NULL AUTO_INCREMENT COMMENT '常量id',
  `value` varchar(255) NOT NULL DEFAULT '0' COMMENT '常量值',
  `desc` varchar(255) NOT NULL COMMENT '常量描述@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8 COMMENT='vip常量配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_vip_kv`
--

LOCK TABLES `base_vip_kv` WRITE;
/*!40000 ALTER TABLE `base_vip_kv` DISABLE KEYS */;
INSERT INTO `base_vip_kv` VALUES (1,'50','签到经验奖励'),(2,'100','激活永久荣耀所需充值'),(3,'7','激活永久荣耀所需累充天数');
/*!40000 ALTER TABLE `base_vip_kv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_vip_level_up`
--

DROP TABLE IF EXISTS `base_vip_level_up`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_vip_level_up` (
  `lv` int(11) NOT NULL COMMENT 'vip等级',
  `exp` bigint(20) NOT NULL COMMENT '到下一级所需经验',
  PRIMARY KEY (`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='vip升级配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_vip_level_up`
--

LOCK TABLES `base_vip_level_up` WRITE;
/*!40000 ALTER TABLE `base_vip_level_up` DISABLE KEYS */;
INSERT INTO `base_vip_level_up` VALUES (1,250),(2,700),(3,1500),(4,3300),(5,7000),(6,13000),(7,23000),(8,40000),(9,80000),(10,200000),(11,400000),(12,400000),(13,400000),(14,400000),(15,3000000);
/*!40000 ALTER TABLE `base_vip_level_up` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_vip_limit_reward_bag`
--

DROP TABLE IF EXISTS `base_vip_limit_reward_bag`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_vip_limit_reward_bag` (
  `id` tinyint(3) unsigned NOT NULL AUTO_INCREMENT COMMENT '礼包id',
  `bag_type` tinyint(3) unsigned NOT NULL DEFAULT '1' COMMENT '礼包类型',
  `name` varchar(255) NOT NULL COMMENT '礼包名@lang@',
  `buy_limit` varchar(255) NOT NULL COMMENT '购买限制',
  `cost` varchar(255) NOT NULL COMMENT '花费',
  `reward` varchar(255) NOT NULL COMMENT '奖励内容',
  `reset` tinyint(3) unsigned NOT NULL COMMENT '重置类型',
  `receive_times` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '领取次数',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=33 DEFAULT CHARSET=utf8 COMMENT='vip限购礼包配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_vip_limit_reward_bag`
--

LOCK TABLES `base_vip_limit_reward_bag` WRITE;
/*!40000 ALTER TABLE `base_vip_limit_reward_bag` DISABLE KEYS */;
INSERT INTO `base_vip_limit_reward_bag` VALUES (1,2,'VIP1特权礼包','[{vip,1}]','[{1,36010001,10}]','[{0,4901001,1},{0,37020001,1},{3,36030001,50000}]',0,1),(2,2,'VIP2特权礼包','[{vip,2}]','[{1,36010001,28}]','[{0,14010103,1},{0,37020002,1},{3,36030001,100000}]',0,1),(3,2,'VIP3特权礼包','[{vip,3}]','[{1,36010001,88}]','[{0,16010003,1},{0,16020001,10},{3,36030001,200000}]',0,1),(4,2,'VIP4特权礼包','[{vip,4}]','[{1,36010001,168}]','[{0,4901002,1},{0,37020003,1},{0,53020010,10}]',0,1),(5,2,'VIP5特权礼包','[{vip,5}]','[{1,36010001,888}]','[{0,11030002,1},{0,11020001,50},{0,11040002,10}]',0,1),(6,2,'VIP6特权礼包','[{vip,6}]','[{1,36010001,1688}]','[{0,20040003,1},{0,20020003,3},{0,20060001,50}]',0,1),(7,2,'VIP7特权礼包','[{vip,7}]','[{1,36010001,2488}]','[{0,4901003,1},{0,11020002,50},{0,11040002,30}]',0,1),(8,2,'VIP8特权礼包','[{vip,8}]','[{1,36010001,3288}]','[{0,20040004,1},{0,20020004,2},{0,20060001,100}]',0,1),(9,2,'VIP9特权礼包','[{vip,9}]','[{1,36010001,4688}]','[{0,4901004,1},{0,14020206,1},{0,14110002,20}]',0,1),(10,2,'VIP10特权礼包','[{vip,10}]','[{1,36010001,8888}]','[{0,5206314,2},{0,5204001,400},{0,5203004,10}]',0,1),(11,2,'VIP11特权礼包','[{vip,11}]','[{1,36010001,10888}]','[{0,4901005,1},{0,14020207,1},{0,14110001,20}]',0,1),(12,2,'VIP12特权礼包','[{vip,12}]','[{1,36010001,10888}]','[{0,20040005,4},{0,20040000,8},{0,20060001,250}]',0,1),(13,2,'VIP13特权礼包','[{vip,13}]','[{1,36010001,12888}]','[{0,4901006,1},{0,24030005,2},{0,24020004,5}]',0,1),(14,2,'VIP14特权礼包','[{vip,14}]','[{1,36010001,13888}]','[{0,4901007,1},{0,14010107,1},{0,14110003,10}]',0,1),(15,2,'VIP15特权礼包','[{vip,15}]','[{1,36010001,14888}]','[{0,4901008,1},{0,20040006,2},{0,20040000,4}]',0,1),(16,1,'VIP每周礼包','[{vip,1}]','[]','[{3,36030001,100000},{255,36160007,500}]',1,0),(17,3,'VIP1专属礼包','[{vip,1}]','[]','[{2,36020001,20},{0,14020202,1}]',0,1),(18,3,'VIP2专属礼包','[{vip,2}]','[]','[{0,38150005,1},{0,14010102,1}]',0,1),(19,3,'VIP3专属礼包','[{vip,3}]','[]','[{0,38140005,1},{0,14010103,1}]',0,1),(20,3,'VIP4专属礼包','[{vip,4}]','[]','[{0,38320003,1},{0,14020203,1}]',0,1),(21,3,'VIP5专属礼包','[{vip,5}]','[]','[{0,11010002,1},{0,14020204,1}]',0,1),(22,3,'VIP6专属礼包','[{vip,6}]','[]','[{0,18040006,1},{0,14010104,1}]',0,1),(23,3,'VIP7专属礼包','[{vip,7}]','[]','[{0,38180001,30},{0,14020205,1}]',0,1),(24,3,'VIP8专属礼包','[{vip,8}]','[]','[{0,38180010,50},{0,14010105,1},{0,11020002,50}]',0,1),(25,3,'VIP9专属礼包','[{vip,9}]','[]','[{0,14140110,1},{0,14010305,1},{0,14020405,1},{0,18020002,50}]',0,1),(26,3,'VIP10专属礼包','[{vip,10}]','[]','[{0,14140510,1},{0,14010705,1},{0,14020805,1},{0,24010002,40}]',0,1),(27,3,'VIP11专属礼包','[{vip,11}]','[]','[{0,5206364,1},{0,38180010,50},{0,20020004,1},{0,16020002,35}]',0,1),(28,3,'VIP12专属礼包','[{vip,12}]','[]','[{0,14020207,1},{0,14110001,8},{0,14110004,4},{0,11020003,60}]',0,1),(29,3,'VIP13专属礼包','[{vip,13}]','[]','[{0,14010107,1},{0,14110002,8},{0,14110003,4},{0,18020003,50}]',0,1),(30,3,'VIP14专属礼包','[{vip,14}]','[]','[{0,14010307,1},{0,14110001,10},{0,14110004,6},{0,24010003,40}]',0,1),(31,3,'VIP15专属礼包','[{vip,15}]','[]','[{0,14020407,1},{0,14110002,10},{0,14110003,6},{0,16020003,70}]',0,1),(32,4,'至尊特权每日礼包','[{vip_type, 3}]','[]','[{0,36020001,20},{22,36160009,20},{0,38180015,10},{0,38040010,1},{0,38040101,1},{0,37020001,1}]',2,1);
/*!40000 ALTER TABLE `base_vip_limit_reward_bag` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_vip_privilege`
--

DROP TABLE IF EXISTS `base_vip_privilege`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_vip_privilege` (
  `lv` int(11) NOT NULL COMMENT 'vip等级',
  `module_id` int(10) NOT NULL COMMENT '功能模块',
  `subclass_id` int(10) NOT NULL COMMENT '特权子类',
  `describe` varchar(255) NOT NULL COMMENT '特权描述@lang@',
  `value` varchar(1024) NOT NULL COMMENT '特权值',
  `can_try` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否可以试用',
  `honor_extra` varchar(1024) NOT NULL DEFAULT '0' COMMENT '荣耀vip额外数据',
  `seq` int(20) NOT NULL COMMENT '序号',
  PRIMARY KEY (`lv`,`module_id`,`subclass_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='vip特权配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_vip_privilege`
--

LOCK TABLES `base_vip_privilege` WRITE;
/*!40000 ALTER TABLE `base_vip_privilege` DISABLE KEYS */;
INSERT INTO `base_vip_privilege` VALUES (0,130,1,'快速升级，杀怪经验+','0',1,'0',2),(0,132,1,'秘境远征经验倍数','0',0,'0',13201),(0,151,1,'市场税率降至','0.2',0,'0',13),(0,151,3,'市场交易次数上限+','30',0,'0',12),(0,178,1,'装备吞噬经验+','0',0,'0.2',178),(0,280,1,'竞技排位赛购买次数+','1',1,'0',25),(0,300,1,'小飞鞋<color=#00ccff>无限免费传送</color>','0',1,'0',4),(0,300,3,'日常任务加成+','0',1,'0',50000),(0,331,18,'幸运之星购买上限','5',0,'0',33118),(0,417,1,'每月补签机会','4',0,'0',37),(0,418,1,'魅力海滩经验值加成','0',1,'0',906),(0,423,1,'金币矿洞领取额外次数','15',1,'0',913),(0,423,2,'经验书馆领取额外次数','10',1,'0',913),(0,432,1,'星界试炼扫荡次数+','3',1,'0',18),(0,450,18,'至尊VIP专属免伤技能','0',0,'0',45018),(0,460,4,'混乱魔域挑战次数上限','0',1,'2',46004),(0,610,1000010,'首领狩猎额外次数上限','0',1,'0',10),(0,610,5000009,'降神塔副本扫荡次数+','1',1,'0',999),(0,610,5000020,'魂珠副本扫荡次数+','0',1,'0',520),(1,110,1,'跨服聊天','2',1,'0',36),(1,130,1,'快速升级，杀怪经验+','1000',1,'0',2),(1,132,1,'秘境远征经验倍数','0',0,'0',13201),(1,151,1,'市场税率降至','0.2',0,'0',13),(1,151,3,'市场交易次数上限+','40',0,'0',12),(1,153,1,'专属贵族特惠商品，商城购买','0',1,'0',21),(1,161,1,'至尊vip增加几率','0',0,'5',901),(1,178,1,'装备吞噬经验+','0',0,'0.2',178),(1,280,1,'竞技排位赛购买次数+','3',1,'0',25),(1,300,1,'小飞鞋<color=#00ccff>无限免费传送</color>','0',1,'0',4),(1,300,3,'日常任务加成+','1000',1,'0',50000),(1,311,1,'每日签到，奖励最高x','0',0,'0',20),(1,331,18,'幸运之星购买上限','10',0,'0',33118),(1,417,1,'签到补签次数','5',0,'0',37),(1,418,1,'魅力海滩经验值加成','0',1,'0',906),(1,423,1,'金币矿洞领取额外次数','17',1,'0',913),(1,423,2,'经验书馆领取额外次数','12',1,'0',913),(1,432,1,'星界试炼扫荡次数+','6',1,'0',18),(1,450,16,'vip周礼包领取次数','1',0,'2',901),(1,450,18,'至尊VIP专属免伤技能','0',0,'0',45018),(1,460,4,'混乱魔域挑战次数上限','0',1,'2',46004),(1,610,1000010,'首领狩猎额外次数上限','0',1,'0',10),(1,610,4000018,'星灵副本购买次数+','0',1,'1',302),(1,610,4000019,'降神副本购买次数+','0',1,'1',301),(1,610,5000009,'降神塔副本扫荡次数+','2',1,'0',1000),(1,610,5000020,'魂珠副本扫荡次数+','0',1,'0',520),(2,110,1,'跨服聊天','4',1,'0',36),(2,130,1,'快速升级，杀怪经验+','1000',1,'0',2),(2,132,1,'秘境远征经验倍数','0',0,'0',13201),(2,151,1,'市场税率降至','0.15',0,'0',13),(2,151,3,'市场交易次数上限+','40',0,'0',12),(2,153,1,'专属贵族特惠商品，商城购买','0',1,'0',21),(2,178,1,'装备吞噬经验+','0',0,'0.2',178),(2,280,1,'竞技排位赛购买次数+','4',1,'0',25),(2,300,1,'小飞鞋<color=#00ccff>无限免费传送</color>','0',1,'0',4),(2,300,3,'日常任务加成+','1000',1,'0',50000),(2,311,1,'每日签到，奖励最高x','0',0,'0',20),(2,331,18,'幸运之星购买上限','15',0,'0',33118),(2,417,1,'签到补签次数','6',0,'0',37),(2,418,1,'魅力海滩经验值加成','1000',1,'0',906),(2,423,1,'金币矿洞领取额外次数','17',1,'0',913),(2,423,2,'经验书馆领取额外次数','12',1,'0',913),(2,432,1,'星界试炼扫荡次数+','6',1,'0',18),(2,450,0,'包含<color=#00ccff>贵族1</color>所有特权','0',0,'0',800),(2,450,16,'vip周礼包领取次数','2',0,'2',901),(2,450,18,'至尊VIP专属免伤技能','0',0,'0',45018),(2,460,4,'混乱魔域挑战次数上限','1',1,'2',46004),(2,610,1000010,'首领狩猎额外次数上限','0',1,'0',10),(2,610,4000004,'经验宝库购买次数+','0',1,'0',7),(2,610,4000018,'星灵副本购买次数+','0',1,'1',302),(2,610,4000019,'降神副本购买次数+','0',1,'1',301),(2,610,5000009,'降神塔副本扫荡次数+','3',1,'0',1001),(2,610,5000020,'魂珠副本扫荡次数+','0',1,'0',520),(3,110,1,'跨服聊天','6',1,'0',36),(3,130,1,'快速升级，杀怪经验+','1000',1,'0',2),(3,132,1,'秘境远征经验倍数','0',0,'0',13201),(3,151,1,'市场税率降至','0.15',0,'0',13),(3,151,3,'市场交易次数上限+','40',0,'0',12),(3,153,1,'专属贵族特惠商品，商城购买','0',1,'0',903),(3,178,1,'装备吞噬经验+','0',0,'0.2',178),(3,280,1,'竞技排位赛购买次数+','5',1,'0',25),(3,300,1,'小飞鞋<color=#00ccff>无限免费传送</color>','0',1,'0',904),(3,300,3,'日常任务加成+','1000',1,'0',50000),(3,311,1,'每日签到，奖励最高x','0',0,'0',20),(3,331,18,'幸运之星购买上限','20',0,'0',33118),(3,417,1,'签到补签次数','7',0,'0',37),(3,418,1,'魅力海滩经验值加成','1000',1,'0',906),(3,423,1,'金币矿洞领取额外次数','17',1,'0',913),(3,423,2,'经验书馆领取额外次数','12',1,'0',913),(3,432,1,'星界试炼扫荡次数+','6',1,'0',18),(3,450,0,'包含<color=#00ccff>贵族1-贵族2</color>所有特权','0',0,'0',800),(3,450,16,'vip周礼包领取次数','3',0,'2',901),(3,450,18,'至尊VIP专属免伤技能','0',0,'0',45018),(3,460,4,'混乱魔域挑战次数上限','1',1,'2',46004),(3,610,1000010,'首领狩猎额外次数上限','0',1,'0',10),(3,610,4000004,'经验宝库购买次数+','0',1,'0',7),(3,610,4000018,'星灵副本购买次数+','0',1,'1',302),(3,610,4000019,'降神副本购买次数+','0',1,'1',301),(3,610,5000009,'降神塔副本扫荡次数+','3',1,'0',1002),(3,610,5000020,'魂珠副本扫荡次数+','0',1,'0',520),(4,110,1,'跨服聊天','8',1,'0',36),(4,130,1,'快速升级，杀怪经验+','2000',1,'0',2),(4,132,1,'秘境远征经验倍数','0',0,'0',13201),(4,151,1,'市场税率降至','0.1',0,'0',13),(4,151,2,'市场使用<color=#00ccff>好友指定交易</color>','0',0,'0',35),(4,151,3,'市场交易次数上限+','50',0,'0',12),(4,152,1,'装备可镶嵌宝石数+','1',1,'0',905),(4,152,2,'至尊vip红装打造概率up','0',1,'5',903),(4,153,1,'专属贵族特惠商品，商城购买','0',1,'0',903),(4,153,2,'至尊vip金币兑换绑钻次数','0',1,'5',903),(4,161,1,'至尊vip增加几率','0',0,'5',901),(4,178,1,'装备吞噬经验+','0.5',0,'0.2',178),(4,280,1,'竞技排位赛购买次数+','5',1,'0',25),(4,281,1,'巅峰竞技购买次数','10',1,'0',27),(4,300,1,'小飞鞋<color=#00ccff>无限免费传送</color>','0',1,'0',904),(4,300,2,'便捷放松，<color=#00ccff>自动进行公会任务</color>','0',1,'0',750),(4,300,3,'日常任务加成+','2000',1,'0',50000),(4,311,1,'每日签到，奖励最高x','2',0,'0',20),(4,331,18,'幸运之星购买上限','30',0,'0',33118),(4,417,1,'签到补签次数','8',0,'0',37),(4,418,1,'魅力海滩经验值加成','1000',1,'0',906),(4,423,1,'金币矿洞领取额外次数','20',1,'0',913),(4,423,2,'经验书馆领取额外次数','15',1,'0',913),(4,432,1,'星界试炼扫荡次数+','10',1,'0',18),(4,450,0,'包含<color=#00ccff>贵族1-贵族3</color>所有特权','0',0,'0',800),(4,450,16,'vip周礼包领取次数','4',0,'2',901),(4,450,18,'至尊VIP专属免伤技能','0',0,'1',45018),(4,460,4,'混乱魔域挑战次数上限','2',1,'2',46004),(4,610,1000010,'首领狩猎额外次数上限','0',1,'0',10),(4,610,4000004,'经验宝库购买次数+','1',1,'0',7),(4,610,4000018,'星灵副本购买次数+','1',1,'1',302),(4,610,4000019,'降神副本购买次数+','1',1,'1',301),(4,610,5000009,'降神塔副本扫荡次数+','4',1,'0',1003),(4,610,5000020,'魂珠副本扫荡次数+','0',1,'0',520),(5,110,1,'跨服聊天','10',1,'0',36),(5,130,1,'快速升级，杀怪经验+','2000',1,'0',2),(5,132,1,'秘境远征经验倍数','1',0,'0',13201),(5,151,1,'市场税率降至','0.1',0,'0',13),(5,151,2,'市场使用<color=#00ccff>好友指定交易</color>','0',0,'0',35),(5,151,3,'市场交易次数上限+','50',0,'0',12),(5,152,1,'装备可镶嵌宝石数+','1',1,'0',6),(5,152,2,'至尊vip红装打造概率up','0',1,'5',903),(5,153,1,'专属贵族特惠商品，商城购买','0',1,'0',903),(5,153,2,'至尊vip金币兑换绑钻次数','0',1,'5',903),(5,161,1,'至尊vip增加几率','0',0,'5',901),(5,178,1,'装备吞噬经验+','0.5',0,'0.2',178),(5,280,1,'竞技排位赛购买次数+','6',1,'0',25),(5,281,1,'巅峰竞技购买次数','10',1,'0',27),(5,300,1,'小飞鞋<color=#00ccff>无限免费传送</color>','0',1,'0',904),(5,300,2,'便捷放松，<color=#00ccff>自动进行公会任务</color>','0',1,'0',750),(5,300,3,'日常任务加成+','2000',1,'0',50000),(5,311,1,'每日签到，奖励最高x','2',0,'0',20),(5,331,18,'幸运之星购买上限','40',0,'0',33118),(5,417,1,'签到补签次数','9',0,'0',37),(5,418,1,'魅力海滩经验值加成','1000',1,'0',906),(5,423,1,'金币矿洞领取额外次数','20',1,'0',913),(5,423,2,'经验书馆领取额外次数','15',1,'0',913),(5,432,1,'星界试炼扫荡次数+','10',1,'0',18),(5,450,0,'包含<color=#00ccff>贵族1-贵族4</color>所有特权','0',0,'0',800),(5,450,16,'vip周礼包领取次数','5',0,'2',901),(5,450,18,'至尊VIP专属免伤技能','0',0,'1',45018),(5,460,4,'混乱魔域挑战次数上限','2',1,'2',46004),(5,610,1000010,'首领狩猎额外次数上限','0',1,'0',10),(5,610,4000004,'经验宝库购买次数+','1',1,'0',7),(5,610,4000018,'星灵副本购买次数+','1',1,'1',302),(5,610,4000019,'降神副本购买次数+','1',1,'1',301),(5,610,5000009,'降神塔副本扫荡次数+','4',1,'0',1004),(5,610,5000020,'魂珠副本扫荡次数+','0',1,'0',520),(6,110,1,'跨服聊天','12',1,'0',36),(6,130,1,'快速升级，杀怪经验+','2000',1,'0',2),(6,132,1,'秘境远征经验倍数','1',0,'0',13201),(6,151,1,'市场税率降至','0.1',0,'0',13),(6,151,2,'市场使用<color=#00ccff>好友指定交易</color>','0',0,'0',35),(6,151,3,'市场交易次数上限+','60',0,'0',12),(6,152,1,'装备可镶嵌宝石数+','1',1,'0',6),(6,152,2,'至尊vip红装打造概率up','0',1,'5',903),(6,153,1,'专属贵族特惠商品，商城购买','0',1,'0',903),(6,153,2,'至尊vip金币兑换绑钻次数','0',1,'5',903),(6,161,1,'至尊vip增加几率','0',0,'5',901),(6,178,1,'装备吞噬经验+','0.5',0,'0.2',178),(6,280,1,'竞技排位赛购买次数+','7',1,'0',25),(6,281,1,'巅峰竞技购买次数','10',1,'0',27),(6,300,1,'小飞鞋<color=#00ccff>无限免费传送</color>','0',1,'0',904),(6,300,2,'便捷放松，<color=#00ccff>自动进行公会任务</color>','0',1,'0',750),(6,300,3,'日常任务加成+','2000',1,'0',50000),(6,311,1,'每日签到，奖励最高x','2',0,'0',20),(6,331,18,'幸运之星购买上限','50',0,'0',33118),(6,417,1,'签到补签次数','10',0,'0',37),(6,418,1,'魅力海滩经验值加成','1000',1,'0',906),(6,423,1,'金币矿洞领取额外次数','20',1,'0',913),(6,423,2,'经验书馆领取额外次数','15',1,'0',913),(6,432,1,'星界试炼扫荡次数+','10',1,'0',18),(6,450,0,'包含<color=#00ccff>贵族1-贵族5</color>所有特权','0',0,'0',800),(6,450,16,'vip周礼包领取次数','6',0,'2',901),(6,450,18,'至尊VIP专属免伤技能','0',0,'1',45018),(6,460,4,'混乱魔域挑战次数上限','3',1,'2',46004),(6,610,1000010,'首领狩猎额外次数上限','0',1,'0',10),(6,610,4000004,'经验宝库购买次数+','1',1,'0',7),(6,610,4000018,'星灵副本购买次数+','1',1,'1',302),(6,610,4000019,'降神副本购买次数+','1',1,'1',301),(6,610,5000009,'降神塔副本扫荡次数+','6',1,'0',1005),(6,610,5000020,'魂珠副本扫荡次数+','0',1,'0',520),(7,110,1,'跨服聊天','14',1,'0',36),(7,130,1,'快速升级，杀怪经验+','2000',1,'0',2),(7,132,1,'秘境远征经验倍数','1',0,'0',13201),(7,151,1,'市场税率降至','0.1',0,'0',13),(7,151,2,'市场使用<color=#00ccff>好友指定交易</color>','0',0,'0',35),(7,151,3,'市场交易次数上限+','60',0,'0',12),(7,152,1,'装备可镶嵌宝石数+','1',1,'0',6),(7,152,2,'至尊vip红装打造概率up','0',1,'5',903),(7,153,1,'专属贵族特惠商品，商城购买','0',1,'0',903),(7,153,2,'至尊vip金币兑换绑钻次数','0',1,'5',903),(7,161,1,'至尊vip增加几率','0',0,'5',901),(7,178,1,'装备吞噬经验+','0.5',0,'0.2',178),(7,280,1,'竞技排位赛购买次数+','8',1,'0',25),(7,281,1,'巅峰竞技购买次数','10',1,'0',27),(7,300,1,'小飞鞋<color=#00ccff>无限免费传送</color>','0',1,'0',904),(7,300,2,'便捷放松，<color=#00ccff>自动进行公会任务</color>','0',1,'0',907),(7,300,3,'日常任务加成+','3000',1,'0',50000),(7,311,1,'每日签到，奖励最高x','2',0,'0',20),(7,331,18,'幸运之星购买上限','60',0,'0',33118),(7,417,1,'签到补签次数','11',0,'0',37),(7,418,1,'魅力海滩经验值加成','1000',1,'0',906),(7,423,1,'金币矿洞领取额外次数','23',1,'0',913),(7,423,2,'经验书馆领取额外次数','18',1,'0',913),(7,432,1,'星界试炼扫荡次数+','10',1,'0',18),(7,450,0,'包含<color=#00ccff>贵族1-贵族6</color>所有特权','0',0,'0',800),(7,450,16,'vip周礼包领取次数','7',0,'2',901),(7,450,18,'至尊VIP专属免伤技能','0',0,'1',45018),(7,460,4,'混乱魔域挑战次数上限','3',1,'2',46004),(7,610,1000010,'首领狩猎额外次数上限','1',1,'0',10),(7,610,4000004,'经验宝库购买次数+','2',1,'0',7),(7,610,4000018,'星灵副本购买次数+','2',1,'1',302),(7,610,4000019,'降神副本购买次数+','2',1,'1',301),(7,610,5000009,'降神塔副本扫荡次数+','6',1,'0',1006),(7,610,5000020,'魂珠副本扫荡次数+','0',1,'0',520),(8,110,1,'跨服聊天','16',1,'0',36),(8,130,1,'快速升级，杀怪经验+','2000',1,'0',2),(8,132,1,'秘境远征经验倍数','1',0,'0',13201),(8,151,1,'市场税率降至','0.1',0,'0',13),(8,151,2,'市场使用<color=#00ccff>好友指定交易</color>','0',0,'0',35),(8,151,3,'市场交易次数上限+','70',0,'0',12),(8,152,1,'装备可镶嵌宝石数+','1',1,'0',6),(8,152,2,'至尊vip红装打造概率up','0',1,'5',903),(8,153,1,'专属贵族特惠商品，商城购买','0',1,'0',903),(8,153,2,'至尊vip金币兑换绑钻次数','0',1,'5',903),(8,161,1,'至尊vip增加几率','0',0,'5',901),(8,178,1,'装备吞噬经验+','0.5',0,'0.2',178),(8,280,1,'竞技排位赛购买次数+','9',1,'0',25),(8,281,1,'巅峰竞技购买次数','10',1,'0',27),(8,300,1,'小飞鞋<color=#00ccff>无限免费传送</color>','0',1,'0',904),(8,300,2,'便捷放松，<color=#00ccff>自动进行公会任务</color>','0',1,'0',907),(8,300,3,'日常任务加成+','3000',1,'0',50000),(8,311,1,'每日签到，奖励最高x','2',0,'0',20),(8,331,18,'幸运之星购买上限','80',0,'0',33118),(8,417,1,'签到补签次数','12',0,'0',37),(8,418,1,'魅力海滩经验值加成','1000',1,'0',906),(8,423,1,'金币矿洞领取额外次数','23',1,'0',913),(8,423,2,'经验书馆领取额外次数','18',1,'0',913),(8,432,1,'星界试炼扫荡次数+','15',1,'0',18),(8,450,0,'包含<color=#00ccff>贵族1-贵族7</color>所有特权','0',0,'0',800),(8,450,16,'vip周礼包领取次数','8',0,'2',901),(8,450,18,'至尊VIP专属免伤技能','0',0,'1',45018),(8,460,4,'混乱魔域挑战次数上限','4',1,'2',46004),(8,610,1000010,'首领狩猎额外次数上限','1',1,'0',10),(8,610,4000004,'经验宝库购买次数+','2',1,'0',7),(8,610,4000018,'星灵副本购买次数+','2',1,'1',302),(8,610,4000019,'降神副本购买次数+','2',1,'1',301),(8,610,5000009,'降神塔副本扫荡次数+','8',1,'0',1007),(8,610,5000020,'魂珠副本扫荡次数+','0',1,'0',520),(9,110,1,'跨服聊天','18',1,'0',36),(9,130,1,'快速升级，杀怪经验+','3000',1,'0',2),(9,132,1,'秘境远征经验倍数','1',0,'0',13201),(9,151,1,'市场税率降至','0.1',0,'0',13),(9,151,2,'市场使用<color=#00ccff>好友指定交易</color>','0',0,'0',35),(9,151,3,'市场交易次数上限+','70',0,'0',12),(9,152,1,'装备可镶嵌宝石数+','1',1,'0',6),(9,152,2,'至尊vip红装打造概率up','0',1,'5',903),(9,153,1,'专属贵族特惠商品，商城购买','0',1,'0',903),(9,153,2,'至尊vip金币兑换绑钻次数','0',1,'5',903),(9,161,1,'至尊vip增加几率','0',0,'5',901),(9,178,1,'装备吞噬经验+','0.5',0,'0.2',178),(9,280,1,'竞技排位赛购买次数+','10',1,'0',25),(9,281,1,'巅峰竞技购买次数','10',1,'0',27),(9,300,1,'小飞鞋<color=#00ccff>无限免费传送</color>','0',1,'0',904),(9,300,2,'便捷放松，<color=#00ccff>自动进行公会任务</color>','0',1,'0',907),(9,300,3,'日常任务加成+','3000',1,'0',50000),(9,311,1,'每日签到，奖励最高x','2',0,'0',20),(9,331,18,'幸运之星购买上限','100',0,'0',33118),(9,417,1,'签到补签次数','13',0,'0',37),(9,418,1,'魅力海滩经验值加成','1000',1,'0',906),(9,423,1,'金币矿洞领取额外次数','23',1,'0',913),(9,423,2,'经验书馆领取额外次数','18',1,'0',913),(9,432,1,'星界试炼扫荡次数+','15',1,'0',18),(9,450,0,'包含<color=#00ccff>贵族1-贵族8</color>所有特权','0',0,'0',800),(9,450,16,'vip周礼包领取次数','9',0,'2',901),(9,450,18,'至尊VIP专属免伤技能','0',0,'1',45018),(9,460,4,'混乱魔域挑战次数上限','4',1,'2',46004),(9,610,1000010,'首领狩猎额外次数上限','1',1,'0',10),(9,610,4000004,'经验宝库购买次数+','2',1,'0',7),(9,610,4000018,'星灵副本购买次数+','2',1,'1',302),(9,610,4000019,'降神副本购买次数+','2',1,'1',301),(9,610,5000009,'降神塔副本扫荡次数+','8',1,'0',1008),(9,610,5000020,'魂珠副本扫荡次数+','0',1,'0',520),(10,110,1,'跨服聊天','20',1,'0',36),(10,130,1,'快速升级，杀怪经验+','3000',1,'0',2),(10,132,1,'秘境远征经验倍数','1',0,'0',13201),(10,151,1,'市场税率降至','0.1',0,'0',13),(10,151,2,'市场使用<color=#00ccff>好友指定交易</color>','0',0,'0',35),(10,151,3,'市场交易次数上限+','80',0,'0',12),(10,152,1,'装备可镶嵌宝石数+','1',1,'0',6),(10,152,2,'至尊vip红装打造概率up','0',1,'5',903),(10,153,1,'专属贵族特惠商品，商城购买','0',1,'0',903),(10,153,2,'至尊vip金币兑换绑钻次数','0',1,'5',903),(10,161,1,'至尊vip增加几率','0',0,'5',901),(10,178,1,'装备吞噬经验+','0.5',0,'0.2',178),(10,280,1,'竞技排位赛购买次数+','11',1,'0',25),(10,281,1,'巅峰竞技购买次数','10',1,'0',27),(10,300,1,'小飞鞋<color=#00ccff>无限免费传送</color>','0',1,'0',904),(10,300,2,'便捷放松，<color=#00ccff>自动进行公会任务</color>','0',1,'0',907),(10,300,3,'日常任务加成+','4000',1,'0',50000),(10,311,1,'每日签到，奖励最高x','2',0,'0',20),(10,331,18,'幸运之星购买上限','120',0,'0',33118),(10,417,1,'签到补签次数','14',0,'0',37),(10,418,1,'魅力海滩经验值加成','1000',1,'0',906),(10,423,1,'金币矿洞领取额外次数','25',1,'0',913),(10,423,2,'经验书馆领取额外次数','20',1,'0',913),(10,432,1,'星界试炼扫荡次数+','15',1,'0',18),(10,450,0,'包含<color=#00ccff>贵族1-贵族9</color>所有特权','0',0,'0',800),(10,450,16,'vip周礼包领取次数','10',0,'2',901),(10,450,18,'至尊VIP专属免伤技能','0',0,'1',45018),(10,460,4,'混乱魔域挑战次数上限','5',1,'2',46004),(10,610,1000010,'首领狩猎额外次数上限','1',1,'0',10),(10,610,4000004,'经验宝库购买次数+','2',1,'0',7),(10,610,4000018,'星灵副本购买次数+','2',1,'1',302),(10,610,4000019,'降神副本购买次数+','2',1,'1',301),(10,610,5000009,'降神塔副本扫荡次数+','10',1,'0',1009),(10,610,5000020,'魂珠副本扫荡次数+','0',1,'0',520),(11,110,1,'跨服聊天','22',1,'0',36),(11,130,1,'快速升级，杀怪经验+','3000',1,'0',2),(11,132,1,'秘境远征经验倍数','1',0,'0',13201),(11,151,1,'市场税率降至','0.1',0,'0',13),(11,151,2,'市场使用<color=#00ccff>好友指定交易</color>','0',0,'0',35),(11,151,3,'市场交易次数上限+','80',0,'0',12),(11,152,1,'装备可镶嵌宝石数+','1',1,'0',6),(11,152,2,'至尊vip红装打造概率up','0',1,'5',903),(11,153,1,'专属贵族特惠商品，商城购买','0',1,'0',903),(11,153,2,'至尊vip金币兑换绑钻次数','0',1,'5',903),(11,161,1,'至尊vip增加几率','0',0,'5',901),(11,178,1,'装备吞噬经验+','0.5',0,'0.2',178),(11,280,1,'竞技排位赛购买次数+','12',1,'0',25),(11,281,1,'巅峰竞技购买次数','10',1,'0',27),(11,300,1,'小飞鞋<color=#00ccff>无限免费传送</color>','0',1,'0',904),(11,300,2,'便捷放松，<color=#00ccff>自动进行公会任务</color>','0',1,'0',907),(11,300,3,'日常任务加成+','4000',1,'0',50000),(11,311,1,'每日签到，奖励最高x','2',0,'0',20),(11,331,18,'幸运之星购买上限','150',0,'0',33118),(11,417,1,'签到补签次数','15',0,'0',37),(11,418,1,'魅力海滩经验值加成','1000',1,'0',906),(11,423,1,'金币矿洞领取额外次数','25',1,'0',913),(11,423,2,'经验书馆领取额外次数','20',1,'0',913),(11,432,1,'星界试炼扫荡次数+','15',1,'0',18),(11,450,0,'包含<color=#00ccff>贵族1-贵族10</color>所有特权','0',0,'0',800),(11,450,16,'vip周礼包领取次数','11',0,'2',901),(11,450,18,'至尊VIP专属免伤技能','0',0,'1',45018),(11,460,4,'混乱魔域挑战次数上限','5',1,'2',46004),(11,610,1000010,'首领狩猎额外次数上限','1',1,'0',10),(11,610,4000004,'经验宝库购买次数+','2',1,'0',7),(11,610,4000018,'星灵副本购买次数+','2',1,'1',302),(11,610,4000019,'降神副本购买次数+','2',1,'1',301),(11,610,5000009,'降神塔副本扫荡次数+','10',1,'0',1010),(11,610,5000020,'魂珠副本扫荡次数+','0',1,'0',520),(12,110,1,'跨服聊天','24',1,'0',36),(12,130,1,'快速升级，杀怪经验+','3000',1,'0',2),(12,132,1,'秘境远征经验倍数','1',0,'0',13201),(12,151,1,'市场税率降至','0.1',0,'0',13),(12,151,2,'市场使用<color=#00ccff>好友指定交易</color>','0',0,'0',35),(12,151,3,'市场交易次数上限+','90',0,'0',12),(12,152,1,'装备可镶嵌宝石数+','1',1,'0',6),(12,152,2,'至尊vip红装打造概率up','0',1,'5',903),(12,153,1,'专属贵族特惠商品，商城购买','0',1,'0',903),(12,153,2,'至尊vip金币兑换绑钻次数','0',1,'5',903),(12,161,1,'至尊vip增加几率','0',0,'5',901),(12,178,1,'装备吞噬经验+','0.5',0,'0.2',178),(12,280,1,'竞技排位赛购买次数+','13',1,'0',25),(12,281,1,'巅峰竞技购买次数','10',1,'0',27),(12,300,1,'小飞鞋<color=#00ccff>无限免费传送</color>','0',1,'0',904),(12,300,2,'便捷放松，<color=#00ccff>自动进行公会任务</color>','0',1,'0',907),(12,300,3,'日常任务加成+','4000',1,'0',50000),(12,311,1,'每日签到，奖励最高x','2',0,'0',20),(12,331,18,'幸运之星购买上限','200',0,'0',33118),(12,417,1,'签到补签次数','16',0,'0',37),(12,418,1,'魅力海滩经验值加成','1000',1,'0',906),(12,423,1,'金币矿洞领取额外次数','25',1,'0',913),(12,423,2,'经验书馆领取额外次数','20',1,'0',913),(12,432,1,'星界试炼扫荡次数+','20',1,'0',18),(12,450,0,'包含<color=#00ccff>贵族1-贵族11</color>所有特权','0',0,'0',800),(12,450,16,'vip周礼包领取次数','12',0,'2',901),(12,450,18,'至尊VIP专属免伤技能','0',0,'1',45018),(12,460,4,'混乱魔域挑战次数上限','6',1,'2',46004),(12,610,1000010,'首领狩猎额外次数上限','1',1,'0',10),(12,610,4000004,'经验宝库购买次数+','2',1,'0',7),(12,610,4000018,'星灵副本购买次数+','2',1,'1',302),(12,610,4000019,'降神副本购买次数+','2',1,'1',301),(12,610,5000009,'降神塔副本扫荡次数+','10',1,'0',1011),(12,610,5000020,'魂珠副本扫荡次数+','0',1,'0',520),(13,110,1,'跨服聊天','26',1,'0',36),(13,130,1,'快速升级，杀怪经验+','3000',1,'0',2),(13,132,1,'秘境远征经验倍数','1',0,'0',13201),(13,151,1,'市场税率降至','0.1',0,'0',13),(13,151,2,'市场使用<color=#00ccff>好友指定交易</color>','0',0,'0',35),(13,151,3,'市场交易次数上限+','90',0,'0',12),(13,152,1,'装备可镶嵌宝石数+','1',1,'0',6),(13,152,2,'至尊vip红装打造概率up','0',1,'5',903),(13,153,1,'专属贵族特惠商品，商城购买','0',1,'0',903),(13,153,2,'至尊vip金币兑换绑钻次数','0',1,'5',903),(13,161,1,'至尊vip增加几率','0',0,'5',901),(13,178,1,'装备吞噬经验+','0.5',0,'0.2',178),(13,280,1,'竞技排位赛购买次数+','14',1,'0',25),(13,281,1,'巅峰竞技购买次数','10',1,'0',27),(13,300,1,'小飞鞋<color=#00ccff>无限免费传送</color>','0',1,'0',904),(13,300,2,'便捷放松，<color=#00ccff>自动进行公会任务</color>','0',1,'0',907),(13,300,3,'日常任务加成+','4000',1,'0',50000),(13,311,1,'每日签到，奖励最高x','2',0,'0',20),(13,331,18,'幸运之星购买上限','250',0,'0',33118),(13,417,1,'签到补签次数','17',0,'0',37),(13,418,1,'魅力海滩经验值加成','1000',1,'0',906),(13,423,1,'金币矿洞领取额外次数','28',1,'0',913),(13,423,2,'经验书馆领取额外次数','24',1,'0',913),(13,432,1,'星界试炼扫荡次数+','20',1,'0',18),(13,450,0,'包含<color=#00ccff>贵族1-贵族12</color>所有特权','0',0,'0',800),(13,450,16,'vip周礼包领取次数','13',0,'2',901),(13,450,18,'至尊VIP专属免伤技能','0',0,'1',45018),(13,460,4,'混乱魔域挑战次数上限','6',1,'2',46004),(13,610,1000010,'首领狩猎额外次数上限','2',1,'0',10),(13,610,4000004,'经验宝库购买次数+','2',1,'0',7),(13,610,4000018,'星灵副本购买次数+','2',1,'1',302),(13,610,4000019,'降神副本购买次数+','2',1,'1',301),(13,610,5000009,'降神塔副本扫荡次数+','10',1,'0',1012),(13,610,5000020,'魂珠副本扫荡次数+','0',1,'0',520),(14,110,1,'跨服聊天','28',1,'0',36),(14,130,1,'快速升级，杀怪经验+','4000',1,'0',2),(14,132,1,'秘境远征经验倍数','1',0,'0',13201),(14,151,1,'市场税率降至','0.1',0,'0',13),(14,151,2,'市场使用<color=#00ccff>好友指定交易</color>','0',0,'0',35),(14,151,3,'市场交易次数上限+','90',0,'0',12),(14,152,1,'装备可镶嵌宝石数+','1',1,'0',6),(14,152,2,'至尊vip红装打造概率up','0',1,'5',903),(14,153,1,'专属贵族特惠商品，商城购买','0',1,'0',903),(14,153,2,'至尊vip金币兑换绑钻次数','0',1,'5',903),(14,161,1,'至尊vip增加几率','0',0,'5',901),(14,178,1,'装备吞噬经验+','0.5',0,'0.2',178),(14,280,1,'竞技排位赛购买次数+','15',1,'0',25),(14,281,1,'巅峰竞技购买次数','10',1,'0',27),(14,300,1,'小飞鞋<color=#00ccff>无限免费传送</color>','0',1,'0',904),(14,300,2,'便捷放松，<color=#00ccff>自动进行公会任务</color>','0',1,'0',907),(14,300,3,'日常任务加成+','4000',1,'0',50000),(14,311,1,'每日签到，奖励最高x','2',0,'0',20),(14,331,18,'幸运之星购买上限','300',0,'0',33118),(14,417,1,'签到补签次数','18',0,'0',37),(14,418,1,'魅力海滩经验值加成','1000',1,'0',906),(14,423,1,'金币矿洞领取额外次数','28',1,'0',913),(14,423,2,'经验书馆领取额外次数','24',1,'0',913),(14,432,1,'星界试炼扫荡次数+','20',1,'0',18),(14,450,0,'包含<color=#00ccff>贵族1-贵族13</color>所有特权','0',0,'0',800),(14,450,16,'vip周礼包领取次数','14',0,'2',901),(14,450,18,'至尊VIP专属免伤技能','0',0,'1',45018),(14,460,4,'混乱魔域挑战次数上限','6',1,'2',46004),(14,610,1000010,'首领狩猎额外次数上限','2',1,'0',10),(14,610,4000004,'经验宝库购买次数+','2',1,'0',7),(14,610,4000018,'星灵副本购买次数+','2',1,'1',302),(14,610,4000019,'降神副本购买次数+','2',1,'1',301),(14,610,5000009,'降神塔副本扫荡次数+','10',1,'0',1013),(14,610,5000020,'魂珠副本扫荡次数+','0',1,'0',520),(15,110,1,'跨服聊天','30',1,'0',36),(15,130,1,'快速升级，杀怪经验+','4000',1,'0',2),(15,132,1,'秘境远征经验倍数','1',0,'0',13201),(15,151,1,'市场税率降至','0.1',0,'0',13),(15,151,2,'市场使用<color=#00ccff>好友指定交易</color>','0',0,'0',35),(15,151,3,'市场交易次数上限+','100',0,'0',12),(15,152,1,'装备可镶嵌宝石数+','1',1,'0',6),(15,152,2,'至尊vip红装打造概率up','0',1,'5',903),(15,153,1,'专属贵族特惠商品，商城购买','0',1,'0',903),(15,153,2,'至尊vip金币兑换绑钻次数','0',1,'5',903),(15,161,1,'至尊vip增加几率','0',0,'5',901),(15,178,1,'装备吞噬经验+','0.5',0,'0.2',178),(15,280,1,'竞技排位赛购买次数+','15',1,'0',25),(15,281,1,'巅峰竞技购买次数','10',1,'0',27),(15,300,1,'小飞鞋<color=#00ccff>无限免费传送</color>','0',1,'0',904),(15,300,2,'便捷放松，<color=#00ccff>自动进行公会任务</color>','0',1,'0',907),(15,300,3,'日常任务加成+','4000',1,'0',50000),(15,311,1,'每日签到，奖励最高x','2',0,'0',20),(15,331,18,'幸运之星购买上限','400',0,'0',33118),(15,417,1,'签到补签次数','19',0,'0',37),(15,418,1,'魅力海滩经验值加成','1000',1,'0',906),(15,423,1,'金币矿洞领取额外次数','30',1,'0',913),(15,423,2,'经验书馆领取额外次数','24',1,'0',913),(15,432,1,'星界试炼扫荡次数+','20',1,'0',18),(15,450,0,'包含<color=#00ccff>贵族1-贵族14</color>所有特权','0',0,'0',800),(15,450,16,'vip周礼包领取次数','15',0,'2',901),(15,450,18,'至尊VIP专属免伤技能','0',0,'1',45018),(15,460,4,'混乱魔域挑战次数上限','6',1,'2',46004),(15,610,1000010,'首领狩猎额外次数上限','2',1,'0',10),(15,610,4000004,'经验宝库购买次数+','2',1,'0',7),(15,610,4000018,'星灵副本购买次数+','2',1,'1',302),(15,610,4000019,'降神副本购买次数+','2',1,'1',301),(15,610,5000009,'降神塔副本扫荡次数+','10',1,'0',1014),(15,610,5000020,'魂珠副本扫荡次数+','0',1,'0',520);
/*!40000 ALTER TABLE `base_vip_privilege` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_vip_task`
--

DROP TABLE IF EXISTS `base_vip_task`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_vip_task` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '任务id',
  `descript` varchar(255) NOT NULL COMMENT '描述@lang@',
  `task_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '任务类型',
  `conditions` varchar(255) NOT NULL DEFAULT '[]' COMMENT '触发条件',
  `progress` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '总进度',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励列表',
  `count_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '每日计数器id',
  `sort_id` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '排序',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=11 DEFAULT CHARSET=utf8 COMMENT='vip任务配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_vip_task`
--

LOCK TABLES `base_vip_task` WRITE;
/*!40000 ALTER TABLE `base_vip_task` DISABLE KEYS */;
INSERT INTO `base_vip_task` VALUES (1,'充值120钻石',1,'[{vip_type, 3}, {jump, [159,1]}]',120,'[{22, 36160009, 40}]',1,1),(2,'消费150钻石',2,'[{vip_type, 3},{jump, [153,2]}]',150,' [{22,36160009,40}]',2,2),(3,'购买1次经验本次数',3,'[{vip_type, 3},{jump, [610,31]}]',1,'[{22,36160009,20}]',3,4),(4,'购买1次星灵本次数',4,'[{vip_type, 3},{jump, [610,35]}]',1,'[{22,36160009,20}]',4,5),(5,'购买1次降神本次数',5,'[{vip_type, 3},{jump, [610,36]}]',1,'[{22,36160009,20}]',5,6),(6,'击杀2次个人boss',6,'[{vip_type, 3},{jump, [460,2]}]',2,'[{22,36160009,20}]',6,10),(7,'进入混乱魔域2次',7,'[{vip_type, 3},{role_lv, 240},{jump, [460,8]}]',2,'[{22,36160009,20}]',7,11),(8,'皇家方舟护送3次',8,'[{vip_type, 3},{jump, [500,0]}]',3,'[{22,36160009,20}]',8,9),(9,'装备寻宝抽奖10次',9,'[{vip_type, 3},{jump, [416,1]}]',10,'[{22,36160009,80}]',9,8),(10,'消费450绑钻',10,'[{vip_type, 3},{jump, [153,3]}]',450,'[{22,36160009,40}]',10,3);
/*!40000 ALTER TABLE `base_vip_task` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_vip_type`
--

DROP TABLE IF EXISTS `base_vip_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_vip_type` (
  `vip_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'vip类型',
  `vip_name` varchar(255) NOT NULL DEFAULT '[]' COMMENT 'vip类型名@lang@',
  PRIMARY KEY (`vip_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='vip类型配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_vip_type`
--

LOCK TABLES `base_vip_type` WRITE;
/*!40000 ALTER TABLE `base_vip_type` DISABLE KEYS */;
INSERT INTO `base_vip_type` VALUES (1,'白银VIP'),(2,'黄金VIP'),(3,'荣耀VIP');
/*!40000 ALTER TABLE `base_vip_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_war_god_boss`
--

DROP TABLE IF EXISTS `base_war_god_boss`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_war_god_boss` (
  `boss_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'bossid',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'boss名称',
  `min_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小世界等级',
  `max_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大世界等级',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励预览',
  `hurt_reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '伤害奖励',
  PRIMARY KEY (`boss_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_war_god_boss`
--

LOCK TABLES `base_war_god_boss` WRITE;
/*!40000 ALTER TABLE `base_war_god_boss` DISABLE KEYS */;
INSERT INTO `base_war_god_boss` VALUES (57000001,'荣耀战神',1,175,'[{0,32080212,1},{0,32080213,1},{0,32080214,1},{0,32080232,1},{0,32080233,1},{0,32080234,1}]','{[{0,32000011,2},{0,4910001,1}],[{0,32000011,1},{0,4910002,1}]}'),(57000002,'荣耀战神',176,275,'[{0,32080312,1},{0,32080313,1},{0,32080314,1},{0,32080332,1},{0,32080333,1},{0,32080334,1}]','{[{0,32000011,2},{0,4910001,1}],[{0,32000011,1},{0,4910002,1}]}'),(57000003,'荣耀战神',276,375,'[{0,32080412,1},{0,32080413,1},{0,32080414,1},{0,32080432,1},{0,32080433,1},{0,32080434,1}]','{[{0,32000011,2},{0,4910001,1}],[{0,32000011,1},{0,4910002,1}]}'),(57000004,'荣耀战神',376,475,'[{0,32080512,1},{0,32080513,1},{0,32080514,1},{0,32080532,1},{0,32080533,1},{0,32080534,1}]','{[{0,32000011,2},{0,4910001,1}],[{0,32000011,1},{0,4910002,1}]}'),(57000005,'荣耀战神',476,540,'[{0,32080612,1},{0,32080613,1},{0,32080614,1},{0,32080632,1},{0,32080633,1},{0,32080634,1}]','{[{0,32000011,2},{0,4910001,1}],[{0,32000011,1},{0,4910002,1}]}'),(57000006,'荣耀战神',541,585,'[{0,32080712,1},{0,32080713,1},{0,32080714,1},{0,32080732,1},{0,32080733,1},{0,32080734,1}]','{[{0,32000011,2},{0,4910001,1}],[{0,32000011,1},{0,4910002,1}]}'),(57000007,'荣耀战神',586,635,'[{0,32080812,1},{0,32080813,1},{0,32080814,1},{0,32080832,1},{0,32080833,1},{0,32080834,1}]','{[{0,32000011,2},{0,4910001,1}],[{0,32000011,1},{0,4910002,1}]}'),(57000008,'荣耀战神',636,685,'[{0,32080912,1},{0,32080913,1},{0,32080914,1},{0,32080932,1},{0,32080933,1},{0,32080934,1}]','{[{0,32000011,2},{0,4910001,1}],[{0,32000011,1},{0,4910002,1}]}'),(57000009,'荣耀战神',686,735,'[{0,32081012,1},{0,32081013,1},{0,32081014,1},{0,32081032,1},{0,32081033,1},{0,32081034,1}]','{[{0,32000011,2},{0,4910001,1}],[{0,32000011,1},{0,4910002,1}]}'),(57000010,'荣耀战神',736,785,'[{0,32081112,1},{0,32081113,1},{0,32081114,1},{0,32081132,1},{0,32081133,1},{0,32081134,1}]','{[{0,32000011,2},{0,4910001,1}],[{0,32000011,1},{0,4910002,1}]}'),(57000011,'荣耀战神',786,835,'[{0,32081212,1},{0,32081213,1},{0,32081214,1},{0,32081232,1},{0,32081233,1},{0,32081234,1}]','{[{0,32000011,2},{0,4910001,1}],[{0,32000011,1},{0,4910002,1}]}'),(57000012,'荣耀战神',836,885,'[{0,32081312,1},{0,32081313,1},{0,32081314,1},{0,32081332,1},{0,32081333,1},{0,32081334,1}]','{[{0,32000011,2},{0,4910001,1}],[{0,32000011,1},{0,4910002,1}]}'),(57000013,'荣耀战神',886,935,'[{0,32081412,1},{0,32081413,1},{0,32081414,1},{0,32081432,1},{0,32081433,1},{0,32081434,1}]','{[{0,32000011,2},{0,4910001,1}],[{0,32000011,1},{0,4910002,1}]}'),(57000014,'荣耀战神',936,1000,'[{0,32081412,1},{0,32081413,1},{0,32081414,1},{0,32081432,1},{0,32081433,1},{0,32081434,1}]','{[{0,32000011,2},{0,4910001,1}],[{0,32000011,1},{0,4910002,1}]}');
/*!40000 ALTER TABLE `base_war_god_boss` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_war_god_hurt_reward`
--

DROP TABLE IF EXISTS `base_war_god_hurt_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_war_god_hurt_reward` (
  `reward_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励id',
  `boss_id` int(11) NOT NULL DEFAULT '0' COMMENT 'bossid',
  `hurt_ratio` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '伤害比',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励内容',
  PRIMARY KEY (`reward_id`,`boss_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_war_god_hurt_reward`
--

LOCK TABLES `base_war_god_hurt_reward` WRITE;
/*!40000 ALTER TABLE `base_war_god_hurt_reward` DISABLE KEYS */;
INSERT INTO `base_war_god_hurt_reward` VALUES (1,57000001,2,'[{0,17010001,2}]'),(2,57000001,4,'[{0,17010001,2}]'),(3,57000001,6,'[{0,17010001,2}]'),(4,57000001,8,'[{0,17010001,2}]'),(5,57000001,10,'[{0,17010001,2}]'),(6,57000001,12,'[{0,17010001,2}]'),(7,57000001,15,'[{0,17010001,2}]'),(8,57000001,18,'[{0,17010001,2}]'),(9,57000001,21,'[{0,17010001,2}]'),(10,57000001,24,'[{0,17010001,2}]'),(11,57000002,2,'[{0,17010001,2}]'),(12,57000002,4,'[{0,17010001,2}]'),(13,57000002,6,'[{0,17010001,2}]'),(14,57000002,8,'[{0,17010001,2}]'),(15,57000002,10,'[{0,17010001,2}]'),(16,57000002,12,'[{0,17010001,2}]'),(17,57000002,15,'[{0,17010001,2}]'),(18,57000002,18,'[{0,17010001,2}]'),(19,57000002,21,'[{0,17010001,2}]'),(20,57000002,24,'[{0,17010001,2}]'),(21,57000003,2,'[{0,17010001,3}]'),(22,57000003,4,'[{0,17010001,3}]'),(23,57000003,6,'[{0,17010001,3}]'),(24,57000003,8,'[{0,17010001,3}]'),(25,57000003,10,'[{0,17010001,3}]'),(26,57000003,12,'[{0,17010001,3}]'),(27,57000003,15,'[{0,17010001,3}]'),(28,57000003,18,'[{0,17010001,3}]'),(29,57000003,21,'[{0,17010001,3}]'),(30,57000003,24,'[{0,17010001,3}]'),(31,57000004,2,'[{0,17010001,4}]'),(32,57000004,4,'[{0,17010001,4}]'),(33,57000004,6,'[{0,17010001,4}]'),(34,57000004,8,'[{0,17010001,4}]'),(35,57000004,10,'[{0,17010001,4}]'),(36,57000004,12,'[{0,17010001,4}]'),(37,57000004,15,'[{0,17010001,4}]'),(38,57000004,18,'[{0,17010001,4}]'),(39,57000004,21,'[{0,17010001,4}]'),(40,57000004,24,'[{0,17010001,4}]'),(41,57000005,2,'[{0,17010001,4}]'),(42,57000005,4,'[{0,17010001,4}]'),(43,57000005,6,'[{0,17010001,4}]'),(44,57000005,8,'[{0,17010001,4}]'),(45,57000005,10,'[{0,17010001,4}]'),(46,57000005,12,'[{0,17010001,4}]'),(47,57000005,15,'[{0,17010001,4}]'),(48,57000005,18,'[{0,17010001,4}]'),(49,57000005,21,'[{0,17010001,4}]'),(50,57000005,24,'[{0,17010001,4}]'),(51,57000006,2,'[{0,17010001,4}]'),(52,57000006,4,'[{0,17010001,4}]'),(53,57000006,6,'[{0,17010001,4}]'),(54,57000006,8,'[{0,17010001,4}]'),(55,57000006,10,'[{0,17010001,4}]'),(56,57000006,12,'[{0,17010001,5}]'),(57,57000006,15,'[{0,17010001,5}]'),(58,57000006,18,'[{0,17010001,5}]'),(59,57000006,21,'[{0,17010001,5}]'),(60,57000006,24,'[{0,17010001,5}]'),(61,57000007,2,'[{0,17010001,5}]'),(62,57000007,4,'[{0,17010001,5}]'),(63,57000007,6,'[{0,17010001,5}]'),(64,57000007,8,'[{0,17010001,5}]'),(65,57000007,10,'[{0,17010001,5}]'),(66,57000007,12,'[{0,17010001,5}]'),(67,57000007,15,'[{0,17010001,5}]'),(68,57000007,18,'[{0,17010001,5}]'),(69,57000007,21,'[{0,17010001,5}]'),(70,57000007,24,'[{0,17010002,1}]'),(71,57000008,2,'[{0,17010001,5}]'),(72,57000008,4,'[{0,17010001,5}]'),(73,57000008,6,'[{0,17010001,5}]'),(74,57000008,8,'[{0,17010001,5}]'),(75,57000008,10,'[{0,17010001,5}]'),(76,57000008,12,'[{0,17010001,6}]'),(77,57000008,15,'[{0,17010001,6}]'),(78,57000008,18,'[{0,17010001,6}]'),(79,57000008,21,'[{0,17010001,6}]'),(80,57000008,24,'[{0,17010002,1}]'),(81,57000009,2,'[{0,17010001,6}]'),(82,57000009,4,'[{0,17010001,6}]'),(83,57000009,6,'[{0,17010001,6}]'),(84,57000009,8,'[{0,17010001,6}]'),(85,57000009,10,'[{0,17010001,6}]'),(86,57000009,12,'[{0,17010001,6}]'),(87,57000009,15,'[{0,17010001,6}]'),(88,57000009,18,'[{0,17010001,6}]'),(89,57000009,21,'[{0,17010002,1}]'),(90,57000009,24,'[{0,17010002,1}]'),(91,57000010,2,'[{0,17010001,6}]'),(92,57000010,4,'[{0,17010001,6}]'),(93,57000010,6,'[{0,17010001,6}]'),(94,57000010,8,'[{0,17010001,6}]'),(95,57000010,10,'[{0,17010001,6}]'),(96,57000010,12,'[{0,17010002,1}]'),(97,57000010,15,'[{0,17010002,1}]'),(98,57000010,18,'[{0,17010002,1}]'),(99,57000010,21,'[{0,17010002,1}]'),(100,57000010,24,'[{0,17010002,1}]'),(101,57000011,2,'[{0,17010002,1}]'),(102,57000011,4,'[{0,17010002,1}]'),(103,57000011,6,'[{0,17010002,1}]'),(104,57000011,8,'[{0,17010002,1}]'),(105,57000011,10,'[{0,17010002,1}]'),(106,57000011,12,'[{0,17010002,1}]'),(107,57000011,15,'[{0,17010002,1}]'),(108,57000011,18,'[{0,17010002,1}]'),(109,57000011,21,'[{0,17010002,1}]'),(110,57000011,24,'[{0,17010002,1}]'),(111,57000012,2,'[{0,17010002,1}]'),(112,57000012,4,'[{0,17010002,1}]'),(113,57000012,6,'[{0,17010002,1}]'),(114,57000012,8,'[{0,17010002,1}]'),(115,57000012,10,'[{0,17010002,1}]'),(116,57000012,12,'[{0,17010002,1}]'),(117,57000012,15,'[{0,17010002,1}]'),(118,57000012,18,'[{0,17010002,2}]'),(119,57000012,21,'[{0,17010002,2}]'),(120,57000012,24,'[{0,17010002,2}]'),(121,57000013,2,'[{0,17010002,1}]'),(122,57000013,4,'[{0,17010002,1}]'),(123,57000013,6,'[{0,17010002,1}]'),(124,57000013,8,'[{0,17010002,1}]'),(125,57000013,10,'[{0,17010002,2}]'),(126,57000013,12,'[{0,17010002,2}]'),(127,57000013,15,'[{0,17010002,2}]'),(128,57000013,18,'[{0,17010002,2}]'),(129,57000013,21,'[{0,17010002,2}]'),(130,57000013,24,'[{0,17010002,2}]'),(131,57000014,2,'[{0,17010002,1}]'),(132,57000014,4,'[{0,17010002,1}]'),(133,57000014,6,'[{0,17010002,1}]'),(134,57000014,8,'[{0,17010002,1}]'),(135,57000014,10,'[{0,17010002,2}]'),(136,57000014,12,'[{0,17010002,2}]'),(137,57000014,15,'[{0,17010002,2}]'),(138,57000014,18,'[{0,17010002,2}]'),(139,57000014,21,'[{0,17010002,2}]'),(140,57000014,24,'[{0,17010002,2}]');
/*!40000 ALTER TABLE `base_war_god_hurt_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_war_god_kv`
--

DROP TABLE IF EXISTS `base_war_god_kv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_war_god_kv` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '键',
  `val` varchar(255) NOT NULL DEFAULT '' COMMENT '值',
  `description` varchar(255) NOT NULL DEFAULT '' COMMENT '描述',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_war_god_kv`
--

LOCK TABLES `base_war_god_kv` WRITE;
/*!40000 ALTER TABLE `base_war_god_kv` DISABLE KEYS */;
INSERT INTO `base_war_god_kv` VALUES (1,'500','本服转跨服世界等级'),(2,'30','准备阶段时间（秒/s）'),(3,'{4886,4514}','boss出生位置'),(4,'5700','本服场景'),(5,'5701','跨服场景'),(6,'150','活动参加等级'),(7,'{21000001,5,[{0,38040102,1}],5,21000002,5,[{0,38040101,1}],10}','鼓舞技能,格式{铜币技能id,铜币上限,消耗,铜币效果值,钻石技能id,钻石上限,消耗,钻石效果值}'),(8,'10','公会排行榜展示上限'),(9,'10','个人排行榜展示上限'),(10,'45','击杀完bossXs退出（秒/s）'),(11,'150','区默认世界等级'),(13,'[]','准备阶段动态区域[{AreaId,EffectId}]'),(14,'[{1,1}]','开始阶段动态区域[{AreaId,EffectId}]'),(15,'{{2788,3680},{6064,6137}}','复活坐标{{x1,x2},{y1,y2}}'),(16,'20','房间上限人数'),(17,'600','荣耀战神持续时间(秒/s)');
/*!40000 ALTER TABLE `base_war_god_kv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_war_god_rank_reward`
--

DROP TABLE IF EXISTS `base_war_god_rank_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_war_god_rank_reward` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `boss_id` int(11) NOT NULL DEFAULT '0' COMMENT 'boosid',
  `rank_min` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最小排名',
  `rank_max` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最大排名',
  `num_weight` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励数量权重',
  `good_weight` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '道具权重',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=66 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_war_god_rank_reward`
--

LOCK TABLES `base_war_god_rank_reward` WRITE;
/*!40000 ALTER TABLE `base_war_god_rank_reward` DISABLE KEYS */;
INSERT INTO `base_war_god_rank_reward` VALUES (1,57000001,1,1,'[{1,[{100,7},{100,8}]},{2,[{100,2},{100,3}]}]','[{1,[{50,32080212},{20,32080213},{30,32080214}]},{2,[{50,32080232},{20,32080233},{30,32080234}]}]'),(2,57000001,2,2,'[{1,[{100,5},{100,6}]},{2,[{100,2},{100,2}]}]','[{1,[{50,32080212},{20,32080213},{30,32080214}]},{2,[{50,32080232},{20,32080233},{30,32080234}]}]'),(3,57000001,3,3,'[{1,[{100,4},{100,5}]},{2,[{100,1},{100,2}]}]','[{1,[{50,32080212},{20,32080213},{30,32080214}]},{2,[{50,32080232},{20,32080233},{30,32080234}]}]'),(4,57000001,4,5,'[{1,[{100,3},{100,4}]},{2,[{100,1},{100,1}]}]','[{1,[{50,32080212},{20,32080213},{30,32080214}]},{2,[{50,32080232},{20,32080233},{30,32080234}]}]'),(5,57000001,6,10,'[{1,[{100,1},{100,2}]},{2,[{100,0},{100,1}]}]','[{1,[{50,32080212},{20,32080213},{30,32080214}]},{2,[{50,32080232},{20,32080233},{30,32080234}]}]'),(6,57000002,1,1,'[{1,[{100,7},{100,8}]},{2,[{100,2},{100,3}]}]','[{1,[{50,32080312},{20,32080313},{30,32080314}]},{2,[{50,32080332},{20,32080333},{30,32080334}]}]'),(7,57000002,2,2,'[{1,[{100,5},{100,6}]},{2,[{100,2},{100,2}]}]','[{1,[{50,32080312},{20,32080313},{30,32080314}]},{2,[{50,32080332},{20,32080333},{30,32080334}]}]'),(8,57000002,3,3,'[{1,[{100,4},{100,5}]},{2,[{100,1},{100,2}]}]','[{1,[{50,32080312},{20,32080313},{30,32080314}]},{2,[{50,32080332},{20,32080333},{30,32080334}]}]'),(9,57000002,4,5,'[{1,[{100,3},{100,4}]},{2,[{100,1},{100,1}]}]','[{1,[{50,32080312},{20,32080313},{30,32080314}]},{2,[{50,32080332},{20,32080333},{30,32080334}]}]'),(10,57000002,6,10,'[{1,[{100,1},{100,2}]},{2,[{100,0},{100,1}]}]','[{1,[{50,32080312},{20,32080313},{30,32080314}]},{2,[{50,32080332},{20,32080333},{30,32080334}]}]'),(11,57000003,1,1,'[{1,[{100,7},{100,8}]},{2,[{100,2},{100,3}]}]','[{1,[{50,32080412},{20,32080413},{30,32080414}]},{2,[{50,32080432},{20,32080433},{30,32080434}]}]'),(12,57000003,2,2,'[{1,[{100,5},{100,6}]},{2,[{100,2},{100,2}]}]','[{1,[{50,32080412},{20,32080413},{30,32080414}]},{2,[{50,32080432},{20,32080433},{30,32080434}]}]'),(13,57000003,3,3,'[{1,[{100,4},{100,5}]},{2,[{100,1},{100,2}]}]','[{1,[{50,32080412},{20,32080413},{30,32080414}]},{2,[{50,32080432},{20,32080433},{30,32080434}]}]'),(14,57000003,4,5,'[{1,[{100,3},{100,4}]},{2,[{100,1},{100,1}]}]','[{1,[{50,32080412},{20,32080413},{30,32080414}]},{2,[{50,32080432},{20,32080433},{30,32080434}]}]'),(15,57000003,6,10,'[{1,[{100,1},{100,2}]},{2,[{100,0},{100,1}]}]','[{1,[{50,32080412},{20,32080413},{30,32080414}]},{2,[{50,32080432},{20,32080433},{30,32080434}]}]'),(16,57000004,1,1,'[{1,[{100,7},{100,8}]},{2,[{100,2},{100,3}]}]','[{1,[{50,32080512},{20,32080513},{30,32080514}]},{2,[{50,32080532},{20,32080533},{30,32080534}]}]'),(17,57000004,2,2,'[{1,[{100,5},{100,6}]},{2,[{100,2},{100,2}]}]','[{1,[{50,32080512},{20,32080513},{30,32080514}]},{2,[{50,32080532},{20,32080533},{30,32080534}]}]'),(18,57000004,3,3,'[{1,[{100,4},{100,5}]},{2,[{100,1},{100,2}]}]','[{1,[{50,32080512},{20,32080513},{30,32080514}]},{2,[{50,32080532},{20,32080533},{30,32080534}]}]'),(19,57000004,4,5,'[{1,[{100,3},{100,4}]},{2,[{100,1},{100,1}]}]','[{1,[{50,32080512},{20,32080513},{30,32080514}]},{2,[{50,32080532},{20,32080533},{30,32080534}]}]'),(20,57000004,6,10,'[{1,[{100,1},{100,2}]},{2,[{100,0},{100,1}]}]','[{1,[{50,32080512},{20,32080513},{30,32080514}]},{2,[{50,32080532},{20,32080533},{30,32080534}]}]'),(21,57000005,1,1,'[{1,[{100,7},{100,8}]},{2,[{100,2},{100,3}]}]','[{1,[{50,32080612},{20,32080613},{30,32080614}]},{2,[{50,32080632},{20,32080633},{30,32080634}]}]'),(22,57000005,2,2,'[{1,[{100,5},{100,6}]},{2,[{100,2},{100,2}]}]','[{1,[{50,32080612},{20,32080613},{30,32080614}]},{2,[{50,32080632},{20,32080633},{30,32080634}]}]'),(23,57000005,3,3,'[{1,[{100,4},{100,5}]},{2,[{100,1},{100,2}]}]','[{1,[{50,32080612},{20,32080613},{30,32080614}]},{2,[{50,32080632},{20,32080633},{30,32080634}]}]'),(24,57000005,4,5,'[{1,[{100,3},{100,4}]},{2,[{100,1},{100,1}]}]','[{1,[{50,32080612},{20,32080613},{30,32080614}]},{2,[{50,32080632},{20,32080633},{30,32080634}]}]'),(25,57000005,6,10,'[{1,[{100,1},{100,2}]},{2,[{100,0},{100,1}]}]','[{1,[{50,32080612},{20,32080613},{30,32080614}]},{2,[{50,32080632},{20,32080633},{30,32080634}]}]'),(26,57000006,1,1,'[{1,[{100,7},{100,8}]},{2,[{100,2},{100,3}]}]','[{1,[{50,32080712},{20,32080713},{30,32080714}]},{2,[{50,32080732},{20,32080733},{30,32080734}]}]'),(27,57000006,2,2,'[{1,[{100,5},{100,6}]},{2,[{100,2},{100,2}]}]','[{1,[{50,32080712},{20,32080713},{30,32080714}]},{2,[{50,32080732},{20,32080733},{30,32080734}]}]'),(28,57000006,3,3,'[{1,[{100,4},{100,5}]},{2,[{100,1},{100,2}]}]','[{1,[{50,32080712},{20,32080713},{30,32080714}]},{2,[{50,32080732},{20,32080733},{30,32080734}]}]'),(29,57000006,4,5,'[{1,[{100,3},{100,4}]},{2,[{100,1},{100,1}]}]','[{1,[{50,32080712},{20,32080713},{30,32080714}]},{2,[{50,32080732},{20,32080733},{30,32080734}]}]'),(30,57000006,6,10,'[{1,[{100,1},{100,2}]},{2,[{100,0},{100,1}]}]','[{1,[{50,32080712},{20,32080713},{30,32080714}]},{2,[{50,32080732},{20,32080733},{30,32080734}]}]'),(31,57000007,1,1,'[{1,[{100,7},{100,8}]},{2,[{100,2},{100,3}]}]','[{1,[{50,32080812},{20,32080813},{30,32080814}]},{2,[{50,32080832},{20,32080833},{30,32080834}]}]'),(32,57000007,2,2,'[{1,[{100,5},{100,6}]},{2,[{100,2},{100,2}]}]','[{1,[{50,32080812},{20,32080813},{30,32080814}]},{2,[{50,32080832},{20,32080833},{30,32080834}]}]'),(33,57000007,3,3,'[{1,[{100,4},{100,5}]},{2,[{100,1},{100,2}]}]','[{1,[{50,32080812},{20,32080813},{30,32080814}]},{2,[{50,32080832},{20,32080833},{30,32080834}]}]'),(34,57000007,4,5,'[{1,[{100,3},{100,4}]},{2,[{100,1},{100,1}]}]','[{1,[{50,32080812},{20,32080813},{30,32080814}]},{2,[{50,32080832},{20,32080833},{30,32080834}]}]'),(35,57000007,6,10,'[{1,[{100,1},{100,2}]},{2,[{100,0},{100,1}]}]','[{1,[{50,32080812},{20,32080813},{30,32080814}]},{2,[{50,32080832},{20,32080833},{30,32080834}]}]'),(36,57000008,1,1,'[{1,[{100,7},{100,8}]},{2,[{100,2},{100,3}]}]','[{1,[{50,32080912},{20,32080913},{30,32080914}]},{2,[{50,32080932},{20,32080933},{30,32080934}]}]'),(37,57000008,2,2,'[{1,[{100,5},{100,6}]},{2,[{100,2},{100,2}]}]','[{1,[{50,32080912},{20,32080913},{30,32080914}]},{2,[{50,32080932},{20,32080933},{30,32080934}]}]'),(38,57000008,3,3,'[{1,[{100,4},{100,5}]},{2,[{100,1},{100,2}]}]','[{1,[{50,32080912},{20,32080913},{30,32080914}]},{2,[{50,32080932},{20,32080933},{30,32080934}]}]'),(39,57000008,4,5,'[{1,[{100,3},{100,4}]},{2,[{100,1},{100,1}]}]','[{1,[{50,32080912},{20,32080913},{30,32080914}]},{2,[{50,32080932},{20,32080933},{30,32080934}]}]'),(40,57000008,6,10,'[{1,[{100,1},{100,2}]},{2,[{100,0},{100,1}]}]','[{1,[{50,32080912},{20,32080913},{30,32080914}]},{2,[{50,32080932},{20,32080933},{30,32080934}]}]'),(41,57000009,1,1,'[{1,[{100,7},{100,8}]},{2,[{100,2},{100,3}]}]','[{1,[{50,32081012},{20,32081013},{30,32081014}]},{2,[{50,32081032},{20,32081033},{30,32081034}]}]'),(42,57000009,2,2,'[{1,[{100,5},{100,6}]},{2,[{100,2},{100,2}]}]','[{1,[{50,32081012},{20,32081013},{30,32081014}]},{2,[{50,32081032},{20,32081033},{30,32081034}]}]'),(43,57000009,3,3,'[{1,[{100,4},{100,5}]},{2,[{100,1},{100,2}]}]','[{1,[{50,32081012},{20,32081013},{30,32081014}]},{2,[{50,32081032},{20,32081033},{30,32081034}]}]'),(44,57000009,4,5,'[{1,[{100,3},{100,4}]},{2,[{100,1},{100,1}]}]','[{1,[{50,32081012},{20,32081013},{30,32081014}]},{2,[{50,32081032},{20,32081033},{30,32081034}]}]'),(45,57000009,6,10,'[{1,[{100,1},{100,2}]},{2,[{100,0},{100,1}]}]','[{1,[{50,32081012},{20,32081013},{30,32081014}]},{2,[{50,32081032},{20,32081033},{30,32081034}]}]'),(46,57000010,1,1,'[{1,[{100,7},{100,8}]},{2,[{100,2},{100,3}]}]','[{1,[{50,32081112},{20,32081113},{30,32081114}]},{2,[{50,32081132},{20,32081133},{30,32081134}]}]'),(47,57000010,2,2,'[{1,[{100,5},{100,6}]},{2,[{100,2},{100,2}]}]','[{1,[{50,32081112},{20,32081113},{30,32081114}]},{2,[{50,32081132},{20,32081133},{30,32081134}]}]'),(48,57000010,3,3,'[{1,[{100,4},{100,5}]},{2,[{100,1},{100,2}]}]','[{1,[{50,32081112},{20,32081113},{30,32081114}]},{2,[{50,32081132},{20,32081133},{30,32081134}]}]'),(49,57000010,4,5,'[{1,[{100,3},{100,4}]},{2,[{100,1},{100,1}]}]','[{1,[{50,32081112},{20,32081113},{30,32081114}]},{2,[{50,32081132},{20,32081133},{30,32081134}]}]'),(50,57000010,6,10,'[{1,[{100,1},{100,2}]},{2,[{100,0},{100,1}]}]','[{1,[{50,32081112},{20,32081113},{30,32081114}]},{2,[{50,32081132},{20,32081133},{30,32081134}]}]'),(51,57000011,1,1,'[{1,[{100,7},{100,8}]},{2,[{100,2},{100,3}]}]','[{1,[{50,32081212},{20,32081213},{30,32081214}]},{2,[{50,32081232},{20,32081233},{30,32081234}]}]'),(52,57000011,2,2,'[{1,[{100,5},{100,6}]},{2,[{100,2},{100,2}]}]','[{1,[{50,32081212},{20,32081213},{30,32081214}]},{2,[{50,32081232},{20,32081233},{30,32081234}]}]'),(53,57000011,3,3,'[{1,[{100,4},{100,5}]},{2,[{100,1},{100,2}]}]','[{1,[{50,32081212},{20,32081213},{30,32081214}]},{2,[{50,32081232},{20,32081233},{30,32081234}]}]'),(54,57000011,4,5,'[{1,[{100,3},{100,4}]},{2,[{100,1},{100,1}]}]','[{1,[{50,32081212},{20,32081213},{30,32081214}]},{2,[{50,32081232},{20,32081233},{30,32081234}]}]'),(55,57000011,6,10,'[{1,[{100,1},{100,2}]},{2,[{100,0},{100,1}]}]','[{1,[{50,32081212},{20,32081213},{30,32081214}]},{2,[{50,32081232},{20,32081233},{30,32081234}]}]'),(56,57000012,1,1,'[{1,[{100,7},{100,8}]},{2,[{100,2},{100,3}]}]','[{1,[{50,32081312},{20,32081313},{30,32081314}]},{2,[{50,32081332},{20,32081333},{30,32081334}]}]'),(57,57000012,2,2,'[{1,[{100,5},{100,6}]},{2,[{100,2},{100,2}]}]','[{1,[{50,32081312},{20,32081313},{30,32081314}]},{2,[{50,32081332},{20,32081333},{30,32081334}]}]'),(58,57000012,3,3,'[{1,[{100,4},{100,5}]},{2,[{100,1},{100,2}]}]','[{1,[{50,32081312},{20,32081313},{30,32081314}]},{2,[{50,32081332},{20,32081333},{30,32081334}]}]'),(59,57000012,4,5,'[{1,[{100,3},{100,4}]},{2,[{100,1},{100,1}]}]','[{1,[{50,32081312},{20,32081313},{30,32081314}]},{2,[{50,32081332},{20,32081333},{30,32081334}]}]'),(60,57000012,6,10,'[{1,[{100,1},{100,2}]},{2,[{100,0},{100,1}]}]','[{1,[{50,32081312},{20,32081313},{30,32081314}]},{2,[{50,32081332},{20,32081333},{30,32081334}]}]'),(61,57000013,1,1,'[{1,[{100,7},{100,8}]},{2,[{100,2},{100,3}]}]','[{1,[{50,32081412},{20,32081413},{30,32081414}]},{2,[{50,32081432},{20,32081433},{30,32081434}]}]'),(62,57000013,2,2,'[{1,[{100,5},{100,6}]},{2,[{100,2},{100,2}]}]','[{1,[{50,32081412},{20,32081413},{30,32081414}]},{2,[{50,32081432},{20,32081433},{30,32081434}]}]'),(63,57000013,3,3,'[{1,[{100,4},{100,5}]},{2,[{100,1},{100,2}]}]','[{1,[{50,32081412},{20,32081413},{30,32081414}]},{2,[{50,32081432},{20,32081433},{30,32081434}]}]'),(64,57000013,4,5,'[{1,[{100,3},{100,4}]},{2,[{100,1},{100,1}]}]','[{1,[{50,32081412},{20,32081413},{30,32081414}]},{2,[{50,32081432},{20,32081433},{30,32081434}]}]'),(65,57000013,6,10,'[{1,[{100,1},{100,2}]},{2,[{100,0},{100,1}]}]','[{1,[{50,32081412},{20,32081413},{30,32081414}]},{2,[{50,32081432},{20,32081433},{30,32081434}]}]');
/*!40000 ALTER TABLE `base_war_god_rank_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_wedding_aura`
--

DROP TABLE IF EXISTS `base_wedding_aura`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_wedding_aura` (
  `aura_id` int(10) unsigned NOT NULL COMMENT '气氛编号',
  `aura_num` int(10) unsigned NOT NULL COMMENT '气氛值',
  `reward_list` varchar(500) NOT NULL COMMENT '奖励',
  `add_exp` int(10) unsigned NOT NULL COMMENT '经验加成',
  PRIMARY KEY (`aura_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='婚姻-婚礼气氛值奖励配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_wedding_aura`
--

LOCK TABLES `base_wedding_aura` WRITE;
/*!40000 ALTER TABLE `base_wedding_aura` DISABLE KEYS */;
INSERT INTO `base_wedding_aura` VALUES (1,188,'[{0,40010001,1},{0,40010011,5},{255,40040001,50}]',1500),(2,588,'[{0,40010001,2},{0,40010011,8},{255,40040001,80}]',3000),(3,988,'[{0,40010001,3},{0,40010011,15},{255,40040001,150}]',5000);
/*!40000 ALTER TABLE `base_wedding_aura` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_wedding_box`
--

DROP TABLE IF EXISTS `base_wedding_box`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_wedding_box` (
  `id` bigint(10) unsigned NOT NULL COMMENT '怪物ID',
  `name_list` varchar(512) NOT NULL COMMENT '名字列表',
  `num_list` varchar(512) NOT NULL COMMENT '生成数量',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='婚礼答题箱子配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_wedding_box`
--

LOCK TABLES `base_wedding_box` WRITE;
/*!40000 ALTER TABLE `base_wedding_box` DISABLE KEYS */;
INSERT INTO `base_wedding_box` VALUES (60000001,'[{1,\"蓝\"},{2,\"啰嗦\"}]','[{0,100,2}]'),(60000002,'[{1,\"白\"},{2,\"没有缺点\"}]','[{0,100,2}]'),(60000003,'[{1,\"红\"},{2,\"不给零花钱\"}]','[{0,100,2}]'),(60000004,'[{1,\"绿\"},{2,\"买化妆品\"}]','[{0,100,2}]'),(60000005,'[{1,\"灰\"},{2,\"作\"}]','[{0,100,2}]');
/*!40000 ALTER TABLE `base_wedding_box` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_wedding_candies`
--

DROP TABLE IF EXISTS `base_wedding_candies`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_wedding_candies` (
  `id` int(10) unsigned NOT NULL COMMENT '编号',
  `candies_id` int(10) unsigned NOT NULL COMMENT '喜糖id',
  `candies_name` varchar(500) NOT NULL COMMENT '喜糖名称@lang@',
  `cost_list` varchar(500) NOT NULL COMMENT '消耗',
  `discount` varchar(255) NOT NULL COMMENT '折扣',
  `candies_num` int(10) unsigned NOT NULL COMMENT '刷出数量',
  `reward_list` varchar(500) NOT NULL COMMENT '奖励',
  `other_reward_list` varchar(512) NOT NULL COMMENT '其他奖励',
  `aura` int(10) unsigned NOT NULL COMMENT '气氛值',
  `limit_num` int(10) unsigned NOT NULL COMMENT '可获得上限',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='婚姻-婚礼喜糖信息配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_wedding_candies`
--

LOCK TABLES `base_wedding_candies` WRITE;
/*!40000 ALTER TABLE `base_wedding_candies` DISABLE KEYS */;
INSERT INTO `base_wedding_candies` VALUES (1,5151002,'普通喜糖','[{2,0,100}]','[{{1,1},0},{{2,3},0.4},{{4,8},0.8},{{9,30},1}]',5,'[{500,[{0,38100001,5}]},{200,[{0,38100009,1}]},{150,[{0,38100008,1}]},{100,[{0,38100007,1}]},{40,[{0,40010012,1}]},{10,[{0,38100010,1}]}]','[{0,40010011,6},{255,40040001,100}]',70,20),(2,5151003,'豪华喜糖','[{1,0,300}]','[{{1,1},0.4},{{2,4},0.8},{{5,10},1}]',15,'[{500,[{0,38100001,5}]},{200,[{0,38100009,1}]},{150,[{0,38100008,1}]},{100,[{0,38100007,1}]},{40,[{0,40010012,1}]},{10,[{0,38100010,1}]}]','[{0,40010011,15},{255,40040001,250}]',240,10);
/*!40000 ALTER TABLE `base_wedding_candies` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_wedding_card`
--

DROP TABLE IF EXISTS `base_wedding_card`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_wedding_card` (
  `goods_type_id` int(10) unsigned NOT NULL COMMENT '物品类型id',
  `goods_name` varchar(500) NOT NULL COMMENT '物品名称@lang@',
  `goods_num` int(10) unsigned NOT NULL COMMENT '物品数量',
  `cost_list` varchar(500) NOT NULL COMMENT '消耗列表',
  `wedding_type` int(10) unsigned NOT NULL COMMENT '婚礼类型',
  `if_reward` int(10) unsigned NOT NULL COMMENT '是否能获得婚礼奖励（0不能 1能）',
  PRIMARY KEY (`goods_type_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='婚姻-婚礼卡配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_wedding_card`
--

LOCK TABLES `base_wedding_card` WRITE;
/*!40000 ALTER TABLE `base_wedding_card` DISABLE KEYS */;
INSERT INTO `base_wedding_card` VALUES (40020001,'简约婚礼预约',1,'[]',1,0),(40020002,'隆重婚礼预约',1,'[]',2,0),(40020003,'豪华婚礼预约',1,'[]',3,0);
/*!40000 ALTER TABLE `base_wedding_card` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_wedding_fires`
--

DROP TABLE IF EXISTS `base_wedding_fires`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_wedding_fires` (
  `fires_id` int(10) unsigned NOT NULL COMMENT '烟花id',
  `fires_name` varchar(255) NOT NULL COMMENT '烟花名字@lang@',
  `cost_list` varchar(255) NOT NULL COMMENT '消耗列表',
  `discount` varchar(255) NOT NULL COMMENT '折扣',
  `charact` varchar(255) NOT NULL COMMENT '特效',
  `reward_list` varchar(255) NOT NULL COMMENT '奖励列表',
  `aura` int(10) unsigned NOT NULL COMMENT '气氛值',
  PRIMARY KEY (`fires_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='婚姻-婚礼烟花信息配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_wedding_fires`
--

LOCK TABLES `base_wedding_fires` WRITE;
/*!40000 ALTER TABLE `base_wedding_fires` DISABLE KEYS */;
INSERT INTO `base_wedding_fires` VALUES (1,'普通烟花','[{2,0,15}]','[{{1,3},0},{{4,10},0.4},{{11,20},0.8},{{21,50},1}]','ui_hunliyanhua02','[{0,40010011,2}]',5),(2,'豪华烟花','[{1,0,100}]','[{{1,1},0},{{2,5},0.4},{{6,15},0.8},{{16,30},1}]','ui_hunliyanhua01','[{0,40010011,10}]',50);
/*!40000 ALTER TABLE `base_wedding_fires` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_wedding_guest_position`
--

DROP TABLE IF EXISTS `base_wedding_guest_position`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_wedding_guest_position` (
  `id` int(10) unsigned NOT NULL COMMENT '序号',
  `x` int(10) unsigned NOT NULL COMMENT 'x坐标',
  `y` int(10) unsigned NOT NULL COMMENT 'y坐标',
  `angle` int(10) unsigned NOT NULL COMMENT '角度',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='婚姻-婚礼宾客位置配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_wedding_guest_position`
--

LOCK TABLES `base_wedding_guest_position` WRITE;
/*!40000 ALTER TABLE `base_wedding_guest_position` DISABLE KEYS */;
INSERT INTO `base_wedding_guest_position` VALUES (1,14328,17500,281),(2,13866,17446,265),(3,13505,17371,279),(4,13308,17126,260),(5,13124,16874,270),(6,13049,16486,270),(7,13104,16058,257),(8,13151,15684,270),(9,13417,15507,329),(10,13655,15677,325),(11,13553,15970,324),(12,13485,16330,360),(13,13512,16650,381),(14,13621,16867,224),(15,13886,17051,270),(16,14165,17180,270),(17,14485,17174,270),(18,14342,16888,270),(19,14049,16691,270),(20,13974,16384,270),(21,13961,16092,270),(22,13961,15820,270),(23,13920,15589,270),(24,13790,15353,270),(25,13556,15074,270),(26,13883,14863,270),(27,14182,14761,270),(28,14529,14775,270),(29,14863,14842,360),(30,15142,15067,360),(31,15448,15373,360),(32,15550,15611,360),(33,15693,15815,360),(34,15788,16101,360),(35,15788,16352,360),(36,15720,16591,360),(37,15400,16652,360),(38,15305,16182,360),(39,15264,15883,360),(40,15203,15591,360),(41,15080,15305,360),(42,14808,15189,360),(43,14522,15081,360),(44,14584,15278,360),(45,14754,15509,360),(46,14897,15720,360),(47,14938,16006,360),(48,14992,16257,360),(49,15053,16421,360),(50,15169,16754,360);
/*!40000 ALTER TABLE `base_wedding_guest_position` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_wedding_info`
--

DROP TABLE IF EXISTS `base_wedding_info`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_wedding_info` (
  `type` int(10) unsigned NOT NULL COMMENT '婚礼类型',
  `name` varchar(500) NOT NULL COMMENT '婚戒名字@lang@',
  `wedding_name` varchar(500) NOT NULL COMMENT '婚礼名字@lang@',
  `cost` varchar(500) NOT NULL COMMENT '消耗',
  `reward` varchar(500) NOT NULL COMMENT '婚礼奖励',
  `wedding_fail_return` varchar(500) NOT NULL COMMENT '婚礼失败返还',
  `designation_id` int(10) unsigned NOT NULL COMMENT '称号id',
  `guest_num` int(10) unsigned NOT NULL COMMENT '宾客默认数量上限',
  `guest_num_max` int(10) unsigned NOT NULL COMMENT '宾客最终数量上限',
  `time` int(10) unsigned NOT NULL COMMENT '婚礼时间',
  `exp_time` int(10) unsigned NOT NULL COMMENT '发经验时间间隔',
  `exp_coefficient` int(10) unsigned NOT NULL COMMENT '基础经验',
  `couple_exp` int(10) unsigned NOT NULL COMMENT '新人经验系数(万分比)',
  `guest_exp` int(10) unsigned NOT NULL COMMENT '宾客经验系数(万分比)',
  `explain` varchar(2000) NOT NULL COMMENT '说明',
  PRIMARY KEY (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='婚姻-婚礼类型数据配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_wedding_info`
--

LOCK TABLES `base_wedding_info` WRITE;
/*!40000 ALTER TABLE `base_wedding_info` DISABLE KEYS */;
INSERT INTO `base_wedding_info` VALUES (1,'普通婚戒','简约婚礼','[{2,0,288}]','[{0,12013001,1},{0,12033001,1},{0,40010001,2},{0,38100002,1}]','[{100, 40020001, 1 }]',4907007,10,15,15,5,20000,100000,30000,'1500'),(2,'精致婚戒','隆重婚礼','[{1,0,588}]','[{0,12011001,1},{0,12031001,1},{0,40010002,2},{0,38100004,1}]','[{100, 40020002, 1 }]',4907008,20,30,15,5,30000,100000,30000,'2400'),(3,'豪华婚戒','豪华婚礼','[{1,0,1314}]','[{0,12010001,1},{0,12030001,1},{0,40010003,2},{0,38100005,1}]','[{100, 40020003, 1 }]',4907009,30,50,15,5,45000,100000,30000,'4500');
/*!40000 ALTER TABLE `base_wedding_info` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_wedding_position`
--

DROP TABLE IF EXISTS `base_wedding_position`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_wedding_position` (
  `pos_id` int(10) unsigned NOT NULL COMMENT '位置id',
  `type` int(10) unsigned NOT NULL COMMENT '类型（1捣蛋鬼 2普通喜糖 3豪华喜糖 4婚宴桌子）',
  `x` int(10) unsigned NOT NULL COMMENT 'x坐标',
  `y` int(10) unsigned NOT NULL COMMENT 'y坐标',
  PRIMARY KEY (`pos_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='婚姻-婚礼随机坐标配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_wedding_position`
--

LOCK TABLES `base_wedding_position` WRITE;
/*!40000 ALTER TABLE `base_wedding_position` DISABLE KEYS */;
INSERT INTO `base_wedding_position` VALUES (1,1,14503,17565),(2,1,14078,17452),(3,1,13580,17244),(4,1,13424,16923),(5,1,13389,16338),(6,1,15895,16839),(7,1,15934,16393),(8,1,15847,16003),(9,1,15691,15738),(10,1,15270,15435),(11,2,15212,17291),(12,2,14828,17199),(13,2,14430,17022),(14,2,14316,16639),(15,2,14327,16263),(16,2,14648,16068),(17,2,15134,16119),(18,2,15651,16231),(19,2,15806,16618),(20,2,15522,16994),(21,2,14567,17540),(22,2,14176,17338),(23,2,13933,16842),(24,2,13852,16448),(25,2,14147,15897),(26,2,14497,15662),(27,2,15235,15709),(28,2,15887,15895),(29,2,16024,16101),(30,2,16046,16713),(31,3,14677,17065),(32,3,14353,16763),(33,3,14375,16398),(34,3,14448,16055),(35,3,14891,16007),(36,3,15318,16313),(37,3,15550,16495),(38,3,15797,16868),(39,3,15539,17291),(40,3,14964,17446),(41,3,16146,16995),(42,3,16120,16380),(43,3,15548,15836),(44,3,15353,16002),(45,3,14959,15773),(46,3,14922,15511),(47,3,14715,15836),(48,3,14276,15568),(49,3,13926,15933),(50,3,14095,16279),(51,3,14104,16576),(52,3,14259,16952),(53,3,14034,17111),(54,3,14490,17229),(55,3,14221,17575),(56,3,13841,17465),(57,3,13624,17078),(58,3,13572,16768),(59,3,13610,16278),(60,3,13695,15928),(61,3,13864,15561),(62,3,14067,15351),(63,3,14564,15226),(64,3,15202,15223),(65,3,15586,15481),(66,3,15881,15621),(67,3,16217,15936),(68,3,16331,16186),(69,3,16402,16489),(70,3,16306,16776),(71,4,14503,17565),(72,4,14078,17452),(73,4,13580,17244),(74,4,13424,16923),(75,4,13389,16338),(76,4,15895,16839),(77,5,14503,17565),(78,5,14078,17452),(79,5,13580,17244),(80,5,13424,16923),(81,5,13389,16338),(82,5,15895,16839),(83,5,15934,16393),(84,5,15847,16003),(85,6,14503,17565),(86,6,14078,17452),(87,6,13580,17244),(88,6,13424,16923),(89,6,13389,16338),(90,6,15895,16839),(91,6,15934,16393),(92,6,15847,16003),(93,6,15691,15738),(94,6,15270,15435),(95,7,14483,16924),(96,8,14483,16924),(97,8,14124,16574),(98,9,14483,16924),(99,9,14124,16574),(100,9,13963,16331);
/*!40000 ALTER TABLE `base_wedding_position` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_wedding_question`
--

DROP TABLE IF EXISTS `base_wedding_question`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_wedding_question` (
  `id` int(10) unsigned NOT NULL COMMENT '题目编号',
  `question_des` varchar(512) NOT NULL COMMENT '题目内容@lang@',
  `correct_des` varchar(512) NOT NULL COMMENT '正确答案描述@lang@',
  `mon_id` bigint(10) unsigned NOT NULL COMMENT '正确怪物ID',
  `reward_list` varchar(255) NOT NULL COMMENT '奖励列表',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='婚礼答题配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_wedding_question`
--

LOCK TABLES `base_wedding_question` WRITE;
/*!40000 ALTER TABLE `base_wedding_question` DISABLE KEYS */;
INSERT INTO `base_wedding_question` VALUES (1,'黑的反义词是？','白',60000002,'[{500,[{0,38100001,5}]},{200,[{0,38100009,1}]},{150,[{0,38100008,1}]},{100,[{0,38100007,1}]},{40,[{0,40010012,1}]},{10,[{0,38100010,1}]}]'),(2,'你认为老婆的缺点是？','没有缺点',60000002,'[{500,[{0,38100001,5}]},{200,[{0,38100009,1}]},{150,[{0,38100008,1}]},{100,[{0,38100007,1}]},{40,[{0,40010012,1}]},{10,[{0,38100010,1}]}]');
/*!40000 ALTER TABLE `base_wedding_question` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_wedding_table`
--

DROP TABLE IF EXISTS `base_wedding_table`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_wedding_table` (
  `table_id` int(10) unsigned NOT NULL COMMENT '餐桌怪物id',
  `table_name` varchar(500) NOT NULL COMMENT '餐桌名字@lang@',
  `wedding_type` int(10) unsigned NOT NULL COMMENT '婚礼类型',
  `type` int(10) unsigned NOT NULL COMMENT '餐桌类型',
  `aura_stage` varchar(255) NOT NULL COMMENT '生成所需气氛值',
  `table_num` int(10) unsigned NOT NULL COMMENT '餐桌数量',
  `reward_list` varchar(255) NOT NULL COMMENT '奖励',
  `aura` int(10) NOT NULL COMMENT '气氛值',
  PRIMARY KEY (`table_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='婚姻-婚礼餐桌信息配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_wedding_table`
--

LOCK TABLES `base_wedding_table` WRITE;
/*!40000 ALTER TABLE `base_wedding_table` DISABLE KEYS */;
INSERT INTO `base_wedding_table` VALUES (5151007,'婚礼宴桌',1,1,'[0,188]',6,'[{80,[{0,38100001,2}]},{10,[{0,40010011,1}]}]',0),(5151008,'婚礼宴桌',1,1,'[189,588]',6,'[{80,[{0,38100001,3}]},{10,[{0,40010011,1}]}]',0),(5151009,'婚礼宴桌',1,1,'[588,9999]',6,'[{80,[{0,38100001,4}]},{10,[{0,40010011,1}]}]',0),(5151010,'婚礼宴桌',2,1,'[0,188]',8,'[{80,[{0,38100001,3}]},{15,[{0,40010011,2}]}]',0),(5151011,'婚礼宴桌',2,1,'[189,588]',8,'[{80,[{0,38100001,4}]},{15,[{0,40010011,2}]}]',0),(5151012,'婚礼宴桌',2,1,'[588,9999]',8,'[{80,[{0,38100001,5}]},{15,[{0,40010011,2}]}]',0),(5151013,'婚礼宴桌',3,1,'[0,188]',10,'[{80,[{0,38100001,4}]},{10,[{0,40010011,3}]}]',0),(5151014,'婚礼宴桌',3,1,'[189,588]',10,'[{80,[{0,38100001,5}]},{10,[{0,40010011,3}]}]',0),(5151015,'婚礼宴桌',3,1,'[588,9999]',10,'[{80,[{0,38100001,6}]},{10,[{0,40010011,3}]}]',0),(5151016,'婚礼宴桌',1,2,'[0,188]',1,'[{80,[{0,38100001,4}]},{10,[{0,40010011,2}]},{10,[{0,40010001,1}]}]',0),(5151017,'婚礼宴桌',1,2,'[189,588]',1,'[{80,[{0,38100001,6}]},{10,[{0,40010011,2}]},{10,[{0,40010001,1}]}]',0),(5151018,'婚礼宴桌',1,2,'[588,9999]',1,'[{80,[{0,38100001,8}]},{10,[{0,40010011,2}]},{10,[{0,40010001,2}]}]',0),(5151019,'婚礼宴桌',2,2,'[0,188]',1,'[{80,[{0,38100001,6}]},{15,[{0,40010011,3}]},{15,[{0,40010001,1}]},{10,[{0,40010002,1}]}]',0),(5151020,'婚礼宴桌',2,2,'[189,588]',1,'[{80,[{0,38100001,8}]},{15,[{0,40010011,3}]},{15,[{0,40010001,1}]},{10,[{0,40010002,1}]}]',0),(5151021,'婚礼宴桌',2,2,'[588,9999]',1,'[{80,[{0,38100001,10}]},{15,[{0,40010011,3}]},{15,[{0,40010001,2}]},{10,[{0,40010002,1}]}]',0),(5151022,'婚礼宴桌',3,2,'[0,188]',1,'[{80,[{0,38100001,8}]},{10,[{0,40010011,4}]},{10,[{0,40010001,1}]},{10,[{0,40010002,1}]},{5,[{0,40010003,1}]}]',0),(5151023,'婚礼宴桌',3,2,'[189,588]',1,'[{80,[{0,38100001,10}]},{10,[{0,40010011,4}]},{10,[{0,40010001,2}]},{10,[{0,40010002,1}]},{5,[{0,40010003,1}]}]',0),(5151024,'婚礼宴桌',3,2,'[588,9999]',1,'[{80,[{0,38100001,12}]},{10,[{0,40010011,4}]},{10,[{0,40010001,3}]},{10,[{0,40010002,2}]},{5,[{0,40010003,1}]}]',0);
/*!40000 ALTER TABLE `base_wedding_table` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_wedding_time`
--

DROP TABLE IF EXISTS `base_wedding_time`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_wedding_time` (
  `time_id` int(10) unsigned NOT NULL COMMENT '时间段序号',
  `begin_time` varchar(500) NOT NULL COMMENT '开始时间',
  `end_time` varchar(500) NOT NULL COMMENT '结束时间',
  PRIMARY KEY (`time_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='婚姻婚礼时间配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_wedding_time`
--

LOCK TABLES `base_wedding_time` WRITE;
/*!40000 ALTER TABLE `base_wedding_time` DISABLE KEYS */;
INSERT INTO `base_wedding_time` VALUES (1,'{8,0}','{8,15}'),(2,'{9,0}','{9,15}'),(3,'{10,0}','{10,15}'),(4,'{11,0}','{11,15}'),(5,'{12,0}','{12,15}'),(6,'{13,0}','{13,15}'),(7,'{14,0}','{14,15}'),(8,'{15,0}','{15,15}'),(9,'{16,0}','{16,15}'),(10,'{17,0}','{17,15}'),(11,'{18,0}','{18,15}'),(12,'{19,0}','{19,15}'),(13,'{20,0}','{20,15}'),(14,'{21,0}','{21,15}'),(15,'{22,0}','{22,15}'),(16,'{23,0}','{23,15}');
/*!40000 ALTER TABLE `base_wedding_time` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_wedding_time_stage`
--

DROP TABLE IF EXISTS `base_wedding_time_stage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_wedding_time_stage` (
  `stage_id` int(10) unsigned NOT NULL COMMENT '阶段序号',
  `stage_name` varchar(500) NOT NULL COMMENT '阶段名',
  `continue_time` int(10) unsigned NOT NULL COMMENT '持续时间',
  `test` varchar(1000) NOT NULL COMMENT '玩法说明',
  PRIMARY KEY (`stage_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='婚姻婚礼时间阶段持续配置表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_wedding_time_stage`
--

LOCK TABLES `base_wedding_time_stage` WRITE;
/*!40000 ALTER TABLE `base_wedding_time_stage` DISABLE KEYS */;
INSERT INTO `base_wedding_time_stage` VALUES (1,'迎宾阶段',300,'安抚小捣蛋'),(2,'活跃阶段',40,'婚礼活跃拿奖励'),(3,'婚礼仪式',90,'见证新人的浪漫故事'),(4,'幸福宴席',300,'大吃大喝，尽情享受');
/*!40000 ALTER TABLE `base_wedding_time_stage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_welfare_cfg`
--

DROP TABLE IF EXISTS `base_welfare_cfg`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_welfare_cfg` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `key` varchar(255) NOT NULL DEFAULT '' COMMENT 'key',
  `val` varchar(255) NOT NULL DEFAULT '0' COMMENT '值',
  `annotion` varchar(1024) NOT NULL DEFAULT '' COMMENT '描述@lang@',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='福利常量配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_welfare_cfg`
--

LOCK TABLES `base_welfare_cfg` WRITE;
/*!40000 ALTER TABLE `base_welfare_cfg` DISABLE KEYS */;
INSERT INTO `base_welfare_cfg` VALUES (1,'night_welfare_open_lv','100','夜间福利开启等级'),(2,'night_welfare_open_time','[{20,0},{24,0}]','领取时间段:[{开始时,开始分},{结束时,结束分}]（时间改了告诉下服务端）'),(3,'download_reward_lv','30','领取下载礼包需要的等级'),(4,'download_reward','[{0,36020001,50},{3,0 ,50000},{0,37020001 ,1}]','下载礼包奖励内容'),(5,'share_reward_lv','10','分享有礼开启等级'),(6,'share_reward','[{0,37020001,2},{3,0,50000},{0,18020001,5}]','分享有礼奖励'),(7,'share_reward_reset_time','30','分享有礼重置时间,单位:时'),(8,'share_gift_title','0','分享有礼标题（填这里不要填值那里）'),(9,'share_gift_content','0','分享有礼内容（填这里不要填值那里）'),(10,'share_gift_address','0','分享有礼链接（填这里不要填值那里）'),(11,'welfare_giftbag_open_lv','35','福利礼包开启等级');
/*!40000 ALTER TABLE `base_welfare_cfg` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_welfare_daily_online`
--

DROP TABLE IF EXISTS `base_welfare_daily_online`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_welfare_daily_online` (
  `id` tinyint(3) unsigned NOT NULL COMMENT 'id',
  `need_online_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '需要在线时间',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='累积在线时长福利（合服直接合并）';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_welfare_daily_online`
--

LOCK TABLES `base_welfare_daily_online` WRITE;
/*!40000 ALTER TABLE `base_welfare_daily_online` DISABLE KEYS */;
INSERT INTO `base_welfare_daily_online` VALUES (1,300,'[{2,36020001,20},{100,16020001,3}]'),(2,600,'[{100,38100001,5},{100,11020001,5}]'),(3,1800,'[{100,37020001,1},{100,38070001,1}]'),(4,3600,'[{100,32030101,1},{100,38040010,1}]'),(5,7200,'[{100,38330003,1},{100,38030001,1}]');
/*!40000 ALTER TABLE `base_welfare_daily_online` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_welfare_giftbag`
--

DROP TABLE IF EXISTS `base_welfare_giftbag`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_welfare_giftbag` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '礼包id',
  `type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '礼包类型',
  `limit_num` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '限定数量',
  `receive_condition` varchar(255) NOT NULL DEFAULT '[]' COMMENT '领取条件',
  `fix_reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '固定奖励',
  `limit_reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '限量奖励',
  `show_reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '显示奖励',
  `reward_tips` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励描述',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='福利礼包';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_welfare_giftbag`
--

LOCK TABLES `base_welfare_giftbag` WRITE;
/*!40000 ALTER TABLE `base_welfare_giftbag` DISABLE KEYS */;
INSERT INTO `base_welfare_giftbag` VALUES (11001,1,0,'[{lv, 35}]','[{1,[{100,4908020,1},{3,36030001,50000}]},{2,[{100,4908020,1},{3,36030001,50000}]},{3,[{100,4908020,1},{3,36030001,50000}]},{4,[{100,4908020,1},{3,36030001,50000}]}]','[]','[{1,[{0,4908020,1}]},{2,[{0,4908020,1}]},{3,[{0,4908020,1}]},{4,[{0,4908020,1}]}]','35级送称号'),(11002,1,0,'[{lv, 65}]','[{1,[{100,1008010320,1},{100,16020001,2},{3,36030001,80000}]},{2,[{100,1008020320,1},{100,16020001,2},{3,36030001,80000}]},{3,[{100,1008030320,1},{100,16020001,2},{3,36030001,80000}]},{4,[{100,1008040320,1},{100,16020001,2},{3,36030001,80000}]}]','[]','[{1,[{0,1008010320,1}]},{2,[{0,1008020320,1}]},{3,[{0,1008030320,1}]},{4,[{0,1008040320,1}]}]','65级送紫装'),(11003,1,0,'[{lv, 85}]','[{1,[{100,11020001,5},{100,37020001,1},{3,36030001,120000}]},{2,[{100,11020001,5},{100,37020001,1},{3,36030001,120000}]},{3,[{100,11020001,5},{100,37020001,1},{3,36030001,120000}]},{4,[{100,11020001,5},{100,37020001,1},{3,36030001,120000}]}]','[]','[{1,[{0,11020001,1}]},{2,[{0,11020001,1}]},{3,[{0,11020001,1}]},{4,[{0,11020001,1}]}]','85级送升阶'),(11004,1,0,'[{lv, 105}]','[{1,[{100,38030001,6},{100,16020001,1},{3,36030001,160000}]},{2,[{100,38030001,6},{100,16020001,1},{3,36030001,160000}]},{3,[{100,38030001,6},{100,16020001,1},{3,36030001,160000}]},{4,[{100,38030001,6},{100,16020001,1},{3,36030001,160000}]}]','[]','[{1,[{0,38030001,1}]},{2,[{0,38030001,1}]},{3,[{0,38030001,1}]},{4,[{0,38030001,1}]}]','105送经验'),(11005,1,0,'[{lv, 135}]','[{1,[{100,12010005,1},{100,16020001,5},{100,32030201,1},{2,36020001,50}]},{2,[{100,12010005,1},{100,16020001,5},{100,32030201,1},{2,36020001,50}]},{3,[{100,12010005,1},{100,16020001,5},{100,32030201,1},{2,36020001,50}]},{4,[{100,12010005,1},{100,16020001,5},{100,32030201,1},{2,36020001,50}]}]','[]','[{1,[{0,12010005,1}]},{2,[{0,12010005,1}]},{3,[{0,12010005,1}]},{4,[{0,12010005,1}]}]','135级抢时装'),(11006,1,0,'[{lv, 165}]','[{1,[{100,1007010531,1},{100,38340001,1},{2,36020001,100},{3,36030001,200000}]},{2,[{100,1007020531,1},{100,38340001,1},{2,36020001,100},{3,36030001,200000}]},{3,[{100,1007030531,1},{100,38340001,1},{2,36020001,100},{3,36030001,200000}]},{4,[{100,1007040531,1},{100,38340001,1},{2,36020001,100},{3,36030001,200000}]}]','[]','[{1,[{0,1007010531,1}]},{2,[{0,1007020531,1}]},{3,[{0,1007030531,1}]},{4,[{0,1007040531,1}]}]','165级送橙装'),(11007,1,0,'[{lv, 185}]','[{1,[{100,12030005,1},{100,38160001,1},{100,24010001,10},{2,36020001,150}]},{2,[{100,12030005,1},{100,38160001,1},{100,24010001,10},{2,36020001,150}]},{3,[{100,12030005,1},{100,38160001,1},{100,24010001,10},{2,36020001,150}]},{4,[{100,12030005,1},{100,38160001,1},{100,24010001,10},{2,36020001,150}]}]','[]','[{1,[{0,12030005,1}]},{2,[{0,12030005,1}]},{3,[{0,12030005,1}]},{4,[{0,12030005,1}]}]','185级抢头饰'),(11008,1,1800,'[{lv, 205}]','[{1,[{100,14010103,1},{100,14020403,1},{100,37020001,1}]},{2,[{100,14010103,1},{100,14020403,1},{100,37020001,1}]},{3,[{100,14010103,1},{100,14020403,1},{100,37020001,1}]},{4,[{100,14010103,1},{100,14020403,1},{100,37020001,1}]}]','[{1,[{100,20040001,1}]},{2,[{100,20040001,1}]},{3,[{100,20040001,1}]},{4,[{100,20040001,1}]}]','[{1,[{0,20040001,1}]},{2,[{0,20040001,1}]},{3,[{0,20040001,1}]},{4,[{0,20040001,1}]}]','205级抢翅膀'),(11009,1,900,'[{lv, 230}]','[{1,[{100,11040003,6},{100,16020001,8},{100,11020001,15},{100,38160001,1}]},{2,[{100,11040003,6},{100,16020001,8},{100,11020001,15},{100,38160001,1}]},{3,[{100,11040003,6},{100,16020001,8},{100,11020001,15},{100,38160001,1}]},{4,[{100,11040003,6},{100,16020001,8},{100,11020001,15},{100,38160001,1}]}]','[{1,[{100,1002010641,1}]},{2,[{100,1002020641,1}]},{3,[{100,1002030641,1}]},{4,[{100,1002040641,1}]}]','[{1,[{0,1002010641,1}]},{2,[{0,1002020641,1}]},{3,[{0,1002030641,1}]},{4,[{0,1002040641,1}]}]','230级抢红装头盔'),(11010,1,350,'[{lv, 250}]','[{1,[{100,32020112,12},{100,38270011,68},{100,38030003,1},{100,38180010,2}]},{2,[{100,32020112,12},{100,38270011,68},{100,38030003,1},{100,38180010,2}]},{3,[{100,32020112,12},{100,38270011,68},{100,38030003,1},{100,38180010,2}]},{4,[{100,32020112,12},{100,38270011,68},{100,38030003,1},{100,38180010,2}]}]','[{1,[{100,1008010642,1}]},{2,[{100,1008020642,1}]},{3,[{100,1008030642,1}]},{4,[{100,1008040642,1}]}]','[{1,[{0,1008010642,1}]},{2,[{0,1008020642,1}]},{3,[{0,1008030642,1}]},{4,[{0,1008040642,1}]}]','250级抢红二护腕'),(12001,1,100,'[{lv, 270}]','[{1,[{100,1002010732,1},{100,38180001,9},{100,20060001,45},{3,36030001,500000}]},{2,[{100,1002020732,1},{100,38180001,9},{100,20060001,45},{3,36030001,500000}]},{3,[{100,1002030732,1},{100,38180001,9},{100,20060001,45},{3,36030001,500000}]},{4,[{100,1002040732,1},{100,38180001,9},{100,20060001,45},{3,36030001,500000}]}]','[{1,[{100,20040002,1}]},{2,[{100,20040002,1}]},{3,[{100,20040002,1}]},{4,[{100,20040002,1}]}]','[{1,[{0,20040002,1}]},{2,[{0,20040002,1}]},{3,[{0,20040002,1}]},{4,[{0,20040002,1}]}]','270级抢2代翅膀'),(12002,1,20,'[{lv, 300}]','[{1,[{0,18040105,1},{100,38040001,6},{100,14010104,1},{100,14020204,1}]},{2,[{0,18040105,1},{100,38040001,6},{100,14010104,1},{100,14020204,1}]},{3,[{0,18040105,1},{100,38040001,6},{100,14010104,1},{100,14020204,1}]},{4,[{0,18040105,1},{100,38040001,6},{100,14010104,1},{100,14020204,1}]}]','[{1,[{100,32020114,8}]},{2,[{100,32020114,8}]},{3,[{100,32020114,8}]},{4,[{100,32020114,8}]}]','[{1,[{0,18040105,1}]},{2,[{0,18040105,1}]},{3,[{0,18040105,1}]},{4,[{0,18040105,1}]}]','300级送暗影忍者'),(12003,1,0,'[{lv, 350}]','[{1,[{100,1008010842,1},{255,36160008,150},{100,38040001,11},{100,38210001,1},{2,36020001,180}]},{2,[{100,1008020842,1},{255,36160008,150},{100,38040001,11},{100,38210001,1},{2,36020001,180}]},{3,[{100,1008030842,1},{255,36160008,150},{100,38040001,11},{100,38210001,1},{2,36020001,180}]},{4,[{100,1008040842,1},{255,36160008,150},{100,38040001,11},{100,38210001,1},{2,36020001,180}]}]','[]','[{1,[{100,1008010842,1}]},{2,[{100,1008020842,1}]},{3,[{100,1008030842,1}]},{4,[{100,1008040842,1}]}]','350级送高阶红装'),(12004,1,0,'[{lv, 400}]','[{1,[{100,1007010842,1},{100,38180002,5},{100,38040001,15},{255,36160008,200},{2,36020001,200}]},{2,[{100,1007020842,1},{100,38180002,5},{100,38040001,15},{255,36160008,200},{2,36020001,200}]},{3,[{100,1007030842,1},{100,38180002,5},{100,38040001,15},{255,36160008,200},{2,36020001,200}]},{4,[{100,1007040842,1},{100,38180002,5},{100,38040001,15},{255,36160008,200},{2,36020001,200}]}]','[]','[{1,[{0,38180002,1}]},{2,[{0,38180002,1}]},{3,[{0,38180002,1}]},{4,[{0,38180002,1}]}]','400级送巅峰秘钥'),(21001,2,0,'[{combat, 200000}]','[{1,[{0,17010001,50},{0,17020001,1},{3,36030001,100000}]},{2,[{0,17010001,50},{0,17020001,1},{3,36030001,100000}]},{3,[{0,17010001,50},{0,17020001,1},{3,36030001,100000}]},{4,[{0,17010001,50},{0,17020001,1},{3,36030001,100000}]}]','[]','[]','[]'),(21002,2,0,'[{combat, 400000}]','[{1,[{0,11020001,5},{0,38040101,2},{2,36020001,80}]},{2,[{0,11020001,5},{0,38040101,2},{2,36020001,80}]},{3,[{0,11020001,5},{0,38040101,2},{2,36020001,80}]},{4,[{0,11020001,5},{0,38040101,2},{2,36020001,80}]}]','[]','[]','[]'),(21003,2,0,'[{combat, 600000}]','[{1,[{0,24010001,5},{0,24020001,1},{3,36030001,150000}]},{2,[{0,24010001,5},{0,24020001,1},{3,36030001,150000}]},{3,[{0,24010001,5},{0,24020001,1},{3,36030001,150000}]},{4,[{0,24010001,5},{0,24020001,1},{3,36030001,150000}]}]','[]','[]','[]'),(21004,2,0,'[{combat, 800000}]','[{1,[{0,15020101,5},{0,15020201,5},{2,36020001,120}]},{2,[{0,15020101,5},{0,15020201,5},{2,36020001,120}]},{3,[{0,15020101,5},{0,15020201,5},{2,36020001,120}]},{4,[{0,15020101,5},{0,15020201,5},{2,36020001,120}]}]','[]','[]','[]'),(21005,2,0,'[{combat, 1000000}]','[{1,[{0,18020001,5},{0,18060001,6},{0,14010301,1},{0,14020401,1}]},{2,[{0,18020001,5},{0,18060001,6},{0,14010301,1},{0,14020401,1}]},{3,[{0,18020001,5},{0,18060001,6},{0,14010301,1},{0,14020401,1}]},{4,[{0,18020001,5},{0,18060001,6},{0,14010301,1},{0,14020401,1}]}]','[]','[]','[]'),(21006,2,0,'[{combat, 1200000}]','[{1,[{0,16020001,5},{0,16010001,1},{0,16010002,1},{3,36030001,300000}]},{2,[{0,16020001,5},{0,16010001,1},{0,16010002,1},{3,36030001,300000}]},{3,[{0,16020001,5},{0,16010001,1},{0,16010002,1},{3,36030001,300000}]},{4,[{0,16020001,5},{0,16010001,1},{0,16010002,1},{3,36030001,300000}]}]','[]','[]','[]'),(21007,2,0,'[{combat, 1500000}]','[{1,[{0,5201012,1},{0,5203001,6},{0,5203002,3},{2,36020001,200}]},{2,[{0,5201012,1},{0,5203001,6},{0,5203002,3},{2,36020001,200}]},{3,[{0,5201012,1},{0,5203001,6},{0,5203002,3},{2,36020001,200}]},{4,[{0,5201012,1},{0,5203001,6},{0,5203002,3},{2,36020001,200}]}]','[]','[]','[]'),(21008,2,0,'[{combat, 2000000}]','[{1,[{0,32030401,1},{0,14010502,1},{0,14020602,1},{0,14120001,20},{3,36030001,400000}]},{2,[{0,32030401,1},{0,14010502,1},{0,14020602,1},{0,14120001,20},{3,36030001,400000}]},{3,[{0,32030401,1},{0,14010502,1},{0,14020602,1},{0,14120001,20},{3,36030001,400000}]},{4,[{0,32030401,1},{0,14010502,1},{0,14020602,1},{0,14120001,20},{3,36030001,400000}]}]','[]','[]','[]'),(21009,2,0,'[{combat, 2500000}]','[{1,[{0,11020002,5},{0,11040003,4},{0,11040004,4},{0,17010001,50},{2,36020001,240}]},{2,[{0,11020002,5},{0,11040003,4},{0,11040004,4},{0,17010001,50},{2,36020001,240}]},{3,[{0,11020002,5},{0,11040003,4},{0,11040004,4},{0,17010001,50},{2,36020001,240}]},{4,[{0,11020002,5},{0,11040003,4},{0,11040004,4},{0,17010001,50},{2,36020001,240}]}]','[]','[]','[]'),(21010,2,0,'[{combat, 3000000}]','[{1,[{0,4902018,1},{0,20020002,1},{0,20020001,1},{0,20060001,5},{2,36020001,300}]},{2,[{0,4902018,1},{0,20020002,1},{0,20020001,1},{0,20060001,5},{2,36020001,300}]},{3,[{0,4902018,1},{0,20020002,1},{0,20020001,1},{0,20060001,5},{2,36020001,300}]},{4,[{0,4902018,1},{0,20020002,1},{0,20020001,1},{0,20060001,5},{2,36020001,300}]}]','[]','[]','[]');
/*!40000 ALTER TABLE `base_welfare_giftbag` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_welfare_night_reward`
--

DROP TABLE IF EXISTS `base_welfare_night_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_welfare_night_reward` (
  `type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '礼包类型',
  `limit_lv` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '限制等级',
  `open_day` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '开启日期（周几）',
  `open_time` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '开启时间',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='夜间福利奖励配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_welfare_night_reward`
--

LOCK TABLES `base_welfare_night_reward` WRITE;
/*!40000 ALTER TABLE `base_welfare_night_reward` DISABLE KEYS */;
INSERT INTO `base_welfare_night_reward` VALUES (1,30,'[1]','[{0,1},{24,0}]','[{2,36020001,50},{0,37020001,2},{0,38330004,1}]'),(2,100,'[1,2,3,4,5,6,7]','[{20,00},{24,00}]','[{2,36020001,20},{0,37020001,2},{0,38040010,2}]');
/*!40000 ALTER TABLE `base_welfare_night_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `base_wing_info`
--

DROP TABLE IF EXISTS `base_wing_info`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `base_wing_info` (
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '外观类型（翅膀；法宝；神兵）',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '名字',
  `figure_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '默认形象id',
  `attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '基础属性',
  `combat` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '基础战力',
  PRIMARY KEY (`figure_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='翅膀基础信息';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `base_wing_info`
--

LOCK TABLES `base_wing_info` WRITE;
/*!40000 ALTER TABLE `base_wing_info` DISABLE KEYS */;
/*!40000 ALTER TABLE `base_wing_info` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `boss`
--

DROP TABLE IF EXISTS `boss`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `boss` (
  `boss_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'bossid',
  `reborn_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '重生时间点',
  PRIMARY KEY (`boss_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='本服boss功能';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `boss`
--

LOCK TABLES `boss` WRITE;
/*!40000 ALTER TABLE `boss` DISABLE KEYS */;
/*!40000 ALTER TABLE `boss` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `boss_first_blood`
--

DROP TABLE IF EXISTS `boss_first_blood`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `boss_first_blood` (
  `sub_type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类',
  `boss_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'BossId',
  `is_killed` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '被击杀状态',
  `bl_ids` varchar(255) NOT NULL DEFAULT '[]' COMMENT '归属玩家id列表',
  `utime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间戳',
  PRIMARY KEY (`sub_type`,`boss_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='boss首杀活动boss信息';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `boss_first_blood`
--

LOCK TABLES `boss_first_blood` WRITE;
/*!40000 ALTER TABLE `boss_first_blood` DISABLE KEYS */;
/*!40000 ALTER TABLE `boss_first_blood` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `boss_first_blood_reward`
--

DROP TABLE IF EXISTS `boss_first_blood_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `boss_first_blood_reward` (
  `sub_type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `boss_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'BossId',
  `bl` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '归属状态',
  `reward_state` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '领取状态',
  `utime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间戳',
  PRIMARY KEY (`sub_type`,`role_id`,`boss_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='boss首杀活动奖励信息';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `boss_first_blood_reward`
--

LOCK TABLES `boss_first_blood_reward` WRITE;
/*!40000 ALTER TABLE `boss_first_blood_reward` DISABLE KEYS */;
/*!40000 ALTER TABLE `boss_first_blood_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `boss_remind`
--

DROP TABLE IF EXISTS `boss_remind`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `boss_remind` (
  `role_id` bigint(20) NOT NULL,
  `boss_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '关注的bossId',
  PRIMARY KEY (`role_id`,`boss_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `boss_remind`
--

LOCK TABLES `boss_remind` WRITE;
/*!40000 ALTER TABLE `boss_remind` DISABLE KEYS */;
/*!40000 ALTER TABLE `boss_remind` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `boss_sp`
--

DROP TABLE IF EXISTS `boss_sp`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `boss_sp` (
  `boss_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'bossid',
  `copy_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分配房间号',
  `reborn_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '重生时间',
  PRIMARY KEY (`boss_id`,`copy_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='原罪boss分房表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `boss_sp`
--

LOCK TABLES `boss_sp` WRITE;
/*!40000 ALTER TABLE `boss_sp` DISABLE KEYS */;
/*!40000 ALTER TABLE `boss_sp` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `buff`
--

DROP TABLE IF EXISTS `buff`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `buff` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `pid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色ID',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT 'BUFF类型',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型ID',
  `effect_list` varchar(1024) NOT NULL DEFAULT '[]' COMMENT 'BUFF效果',
  `end_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '结束时间戳',
  `scene` varchar(255) NOT NULL DEFAULT '[]' COMMENT '场景限制',
  PRIMARY KEY (`id`),
  KEY `pid` (`pid`),
  KEY `type` (`type`),
  KEY `goods_id` (`goods_id`),
  KEY `end_time` (`end_time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家BUFF状态表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `buff`
--

LOCK TABLES `buff` WRITE;
/*!40000 ALTER TABLE `buff` DISABLE KEYS */;
/*!40000 ALTER TABLE `buff` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `charge`
--

DROP TABLE IF EXISTS `charge`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `charge` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `type` int(4) NOT NULL DEFAULT '0' COMMENT '充值类型',
  `pay_no` varchar(100) DEFAULT NULL COMMENT '订单号',
  `accname` varchar(50) DEFAULT NULL COMMENT '账号',
  `player_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '用户ID',
  `nickname` varchar(50) DEFAULT NULL COMMENT '昵称',
  `product_id` int(11) NOT NULL DEFAULT '0' COMMENT '产品id',
  `money` decimal(12,2) DEFAULT '0.00' COMMENT '金额',
  `gold` int(11) NOT NULL DEFAULT '0' COMMENT '元宝',
  `ctime` int(10) NOT NULL COMMENT '订单时间',
  `status` tinyint(1) DEFAULT '0' COMMENT '状态0:未取1：已领取',
  `lv` int(11) DEFAULT '0' COMMENT '等级',
  `sign` varchar(50) DEFAULT NULL COMMENT '平台标志，用于混服区分',
  PRIMARY KEY (`id`),
  UNIQUE KEY `pay_no` (`pay_no`),
  KEY `ctime` (`ctime`),
  KEY `player_id` (`player_id`),
  KEY `type` (`type`),
  KEY `status` (`status`),
  KEY `product_id` (`product_id`),
  KEY `money` (`money`),
  KEY `lv` (`lv`),
  KEY `player_status` (`player_id`,`status`),
  KEY `sign` (`sign`),
  KEY `accname` (`accname`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `charge`
--

LOCK TABLES `charge` WRITE;
/*!40000 ALTER TABLE `charge` DISABLE KEYS */;
/*!40000 ALTER TABLE `charge` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cloud_buy_kf`
--

DROP TABLE IF EXISTS `cloud_buy_kf`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cloud_buy_kf` (
  `order_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '订单id',
  `big_award_id` smallint(5) unsigned NOT NULL COMMENT '大奖id',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `career` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '职业',
  `role_name` varchar(50) NOT NULL COMMENT '玩家名',
  `platform` varchar(50) NOT NULL COMMENT '平台',
  `server_num` smallint(5) unsigned NOT NULL COMMENT '服务器编号',
  `count` smallint(5) unsigned NOT NULL COMMENT '数量',
  `state` tinyint(3) unsigned NOT NULL COMMENT '状态 0未付款 1付款 2中奖 3未中',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  `subtype` int(10) unsigned NOT NULL COMMENT '定制活动子类型',
  PRIMARY KEY (`order_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='众仙云购跨服表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cloud_buy_kf`
--

LOCK TABLES `cloud_buy_kf` WRITE;
/*!40000 ALTER TABLE `cloud_buy_kf` DISABLE KEYS */;
/*!40000 ALTER TABLE `cloud_buy_kf` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `clusters`
--

DROP TABLE IF EXISTS `clusters`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `clusters` (
  `server_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '服id',
  `node` varchar(100) NOT NULL DEFAULT '' COMMENT '节点',
  PRIMARY KEY (`server_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服列表（合服清理）';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `clusters`
--

LOCK TABLES `clusters` WRITE;
/*!40000 ALTER TABLE `clusters` DISABLE KEYS */;
/*!40000 ALTER TABLE `clusters` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `collect_all_num`
--

DROP TABLE IF EXISTS `collect_all_num`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `collect_all_num` (
  `subtype` int(10) unsigned NOT NULL COMMENT '活动子类型',
  `all_point` int(10) unsigned NOT NULL COMMENT '总提交量',
  `exp_end_time` int(10) unsigned NOT NULL COMMENT '多倍经验结束时间戳',
  `drop_end_time` int(10) unsigned NOT NULL COMMENT '多倍掉落结束时间戳',
  PRIMARY KEY (`subtype`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='收集活动全服提交量记录表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `collect_all_num`
--

LOCK TABLES `collect_all_num` WRITE;
/*!40000 ALTER TABLE `collect_all_num` DISABLE KEYS */;
/*!40000 ALTER TABLE `collect_all_num` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `collect_player_info`
--

DROP TABLE IF EXISTS `collect_player_info`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `collect_player_info` (
  `subtype` int(10) unsigned NOT NULL COMMENT '活动子类型',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `player_point` int(10) unsigned NOT NULL COMMENT '玩家提交量',
  `get_reward_id_list` varchar(255) NOT NULL COMMENT '玩家获得的奖励id列表',
  PRIMARY KEY (`subtype`,`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='收集活动玩家个人数据记录表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `collect_player_info`
--

LOCK TABLES `collect_player_info` WRITE;
/*!40000 ALTER TABLE `collect_player_info` DISABLE KEYS */;
/*!40000 ALTER TABLE `collect_player_info` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `comeback`
--

DROP TABLE IF EXISTS `comeback`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `comeback` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `account` varchar(64) NOT NULL COMMENT '账号',
  `source` varchar(50) NOT NULL DEFAULT '' COMMENT '渠道来源',
  `state` tinyint(3) NOT NULL COMMENT '状态(0未返/1已返)',
  `data` text NOT NULL COMMENT '历史数据',
  `old_role` text COMMENT '旧号信息',
  `now_role_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '已返利的角色id',
  PRIMARY KEY (`id`),
  KEY `account` (`account`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='封测玩家回归数据';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `comeback`
--

LOCK TABLES `comeback` WRITE;
/*!40000 ALTER TABLE `comeback` DISABLE KEYS */;
/*!40000 ALTER TABLE `comeback` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `common_rank_guild`
--

DROP TABLE IF EXISTS `common_rank_guild`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `common_rank_guild` (
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会ID',
  `rank_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排行类型',
  `guild_name` varchar(1024) NOT NULL DEFAULT '' COMMENT '工会名字',
  `chairman_id` bigint(20) NOT NULL DEFAULT '0',
  `chairman_name` varchar(1024) NOT NULL DEFAULT '',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '工会等级',
  `members_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '成员数量',
  `value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '值（保留）',
  `second_value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '值（保留）',
  `third_value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '值（保留）',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  UNIQUE KEY `rank` (`guild_id`,`rank_type`),
  KEY `lv` (`lv`),
  KEY `chairman_id` (`chairman_id`),
  KEY `value` (`value`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='排行榜';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `common_rank_guild`
--

LOCK TABLES `common_rank_guild` WRITE;
/*!40000 ALTER TABLE `common_rank_guild` DISABLE KEYS */;
/*!40000 ALTER TABLE `common_rank_guild` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `common_rank_praise`
--

DROP TABLE IF EXISTS `common_rank_praise`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `common_rank_praise` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `praise_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '点赞数量',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='榜单点赞表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `common_rank_praise`
--

LOCK TABLES `common_rank_praise` WRITE;
/*!40000 ALTER TABLE `common_rank_praise` DISABLE KEYS */;
/*!40000 ALTER TABLE `common_rank_praise` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `common_rank_role`
--

DROP TABLE IF EXISTS `common_rank_role`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `common_rank_role` (
  `rank_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排行榜类型',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '值（保留）',
  `second_value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '值（保留）',
  `third_value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '值（保留）',
  `extra_value` varchar(512) NOT NULL DEFAULT '[]' COMMENT '额外值',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  UNIQUE KEY `rank` (`player_id`,`rank_type`),
  KEY `value` (`value`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='排行榜';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `common_rank_role`
--

LOCK TABLES `common_rank_role` WRITE;
/*!40000 ALTER TABLE `common_rank_role` DISABLE KEYS */;
/*!40000 ALTER TABLE `common_rank_role` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `config_word`
--

DROP TABLE IF EXISTS `config_word`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `config_word` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `word` varchar(500) NOT NULL COMMENT '过滤词',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='过滤词配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `config_word`
--

LOCK TABLES `config_word` WRITE;
/*!40000 ALTER TABLE `config_word` DISABLE KEYS */;
/*!40000 ALTER TABLE `config_word` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `consume_rank_act`
--

DROP TABLE IF EXISTS `consume_rank_act`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `consume_rank_act` (
  `rank_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排行榜类型',
  `sub_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动类型',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `is_public` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否公开金额',
  `award_state` varchar(50) NOT NULL DEFAULT '[]' COMMENT '奖励领取状态',
  `value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '值',
  `second_value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '值',
  `third_value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '值',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`rank_type`,`sub_type`,`player_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='充值消费榜';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `consume_rank_act`
--

LOCK TABLES `consume_rank_act` WRITE;
/*!40000 ALTER TABLE `consume_rank_act` DISABLE KEYS */;
/*!40000 ALTER TABLE `consume_rank_act` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `counter`
--

DROP TABLE IF EXISTS `counter`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `counter` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色id',
  `module` int(11) NOT NULL DEFAULT '0' COMMENT '类型',
  `sub_module` int(11) NOT NULL DEFAULT '0' COMMENT '功能子id',
  `type` bigint(20) NOT NULL DEFAULT '0',
  `count` int(11) NOT NULL COMMENT '数量',
  `other` varchar(1024) NOT NULL DEFAULT '' COMMENT '扩展数据',
  `refresh_time` int(11) NOT NULL COMMENT '刷新时间',
  PRIMARY KEY (`role_id`,`module`,`sub_module`,`type`),
  KEY `module` (`module`),
  KEY `sub_module` (`sub_module`),
  KEY `type` (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='终生次数记录';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `counter`
--

LOCK TABLES `counter` WRITE;
/*!40000 ALTER TABLE `counter` DISABLE KEYS */;
/*!40000 ALTER TABLE `counter` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `counter_daily_four`
--

DROP TABLE IF EXISTS `counter_daily_four`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `counter_daily_four` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色id',
  `module` int(11) NOT NULL DEFAULT '0' COMMENT '功能id',
  `sub_module` int(11) NOT NULL DEFAULT '0' COMMENT '功能子id',
  `type` bigint(20) NOT NULL DEFAULT '0',
  `count` int(11) NOT NULL COMMENT '数量',
  `other` varchar(1024) NOT NULL DEFAULT '' COMMENT '扩展数据',
  `refresh_time` int(11) NOT NULL COMMENT '刷新时间',
  PRIMARY KEY (`role_id`,`module`,`sub_module`,`type`),
  KEY `module` (`module`),
  KEY `sub_module` (`sub_module`),
  KEY `type` (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='每日次数记录(凌晨4点)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `counter_daily_four`
--

LOCK TABLES `counter_daily_four` WRITE;
/*!40000 ALTER TABLE `counter_daily_four` DISABLE KEYS */;
/*!40000 ALTER TABLE `counter_daily_four` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `counter_daily_twelve`
--

DROP TABLE IF EXISTS `counter_daily_twelve`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `counter_daily_twelve` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色id',
  `module` int(11) NOT NULL DEFAULT '0' COMMENT '功能id',
  `sub_module` int(11) NOT NULL DEFAULT '0' COMMENT '功能子id',
  `type` bigint(20) NOT NULL DEFAULT '0',
  `count` int(11) NOT NULL COMMENT '数量',
  `other` varchar(1024) NOT NULL DEFAULT '' COMMENT '扩展数据',
  `refresh_time` int(11) NOT NULL COMMENT '刷新时间',
  PRIMARY KEY (`role_id`,`module`,`sub_module`,`type`),
  KEY `module` (`module`),
  KEY `sub_module` (`sub_module`),
  KEY `type` (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='每日次数记录(凌晨12点)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `counter_daily_twelve`
--

LOCK TABLES `counter_daily_twelve` WRITE;
/*!40000 ALTER TABLE `counter_daily_twelve` DISABLE KEYS */;
/*!40000 ALTER TABLE `counter_daily_twelve` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `counter_global`
--

DROP TABLE IF EXISTS `counter_global`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `counter_global` (
  `module` int(11) NOT NULL DEFAULT '0' COMMENT '类型',
  `sub_module` int(11) NOT NULL DEFAULT '0' COMMENT '功能子id',
  `type` bigint(20) NOT NULL DEFAULT '0',
  `count` int(11) NOT NULL COMMENT '数量',
  `other` varchar(1024) NOT NULL DEFAULT '' COMMENT '扩展数据',
  `refresh_time` int(11) unsigned NOT NULL COMMENT '刷新时间',
  `first_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '第一次记录时间',
  PRIMARY KEY (`module`,`sub_module`,`type`),
  KEY `module` (`module`),
  KEY `sub_module` (`sub_module`),
  KEY `type` (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='全服次数记录器';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `counter_global`
--

LOCK TABLES `counter_global` WRITE;
/*!40000 ALTER TABLE `counter_global` DISABLE KEYS */;
/*!40000 ALTER TABLE `counter_global` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `counter_week`
--

DROP TABLE IF EXISTS `counter_week`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `counter_week` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色id',
  `module` int(11) NOT NULL DEFAULT '0' COMMENT '类型',
  `sub_module` int(11) NOT NULL DEFAULT '0' COMMENT '功能子id',
  `type` bigint(20) NOT NULL DEFAULT '0',
  `count` int(11) NOT NULL COMMENT '数量',
  `other` varchar(1024) NOT NULL DEFAULT '' COMMENT '扩展数据',
  `refresh_time` int(11) NOT NULL COMMENT '刷新时间',
  PRIMARY KEY (`role_id`,`module`,`sub_module`,`type`),
  KEY `module` (`module`),
  KEY `sub_module` (`sub_module`),
  KEY `type` (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='每周次数记录';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `counter_week`
--

LOCK TABLES `counter_week` WRITE;
/*!40000 ALTER TABLE `counter_week` DISABLE KEYS */;
/*!40000 ALTER TABLE `counter_week` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `custom_act_growth_score`
--

DROP TABLE IF EXISTS `custom_act_growth_score`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `custom_act_growth_score` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `sub_type` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  PRIMARY KEY (`role_id`,`sub_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='定制活动-成长积分（合服直接清理）';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `custom_act_growth_score`
--

LOCK TABLES `custom_act_growth_score` WRITE;
/*!40000 ALTER TABLE `custom_act_growth_score` DISABLE KEYS */;
/*!40000 ALTER TABLE `custom_act_growth_score` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `custom_act_growth_score_reward`
--

DROP TABLE IF EXISTS `custom_act_growth_score_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `custom_act_growth_score_reward` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `sub_type` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类',
  `reward_state` varchar(255) NOT NULL DEFAULT '[]' COMMENT '已领取的奖励档次',
  PRIMARY KEY (`role_id`,`sub_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='定制活动-成长积分奖励领取情况（合服直接清理）';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `custom_act_growth_score_reward`
--

LOCK TABLES `custom_act_growth_score_reward` WRITE;
/*!40000 ALTER TABLE `custom_act_growth_score_reward` DISABLE KEYS */;
/*!40000 ALTER TABLE `custom_act_growth_score_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `custom_act_gwar`
--

DROP TABLE IF EXISTS `custom_act_gwar`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `custom_act_gwar` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `val` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '值',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会争霸运营活动(合服清空)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `custom_act_gwar`
--

LOCK TABLES `custom_act_gwar` WRITE;
/*!40000 ALTER TABLE `custom_act_gwar` DISABLE KEYS */;
/*!40000 ALTER TABLE `custom_act_gwar` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `custom_act_investment`
--

DROP TABLE IF EXISTS `custom_act_investment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `custom_act_investment` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `subtype` smallint(5) unsigned NOT NULL COMMENT '活动子类型',
  `gear` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '投资档位',
  `invest_time` int(10) unsigned NOT NULL COMMENT '投资时间',
  PRIMARY KEY (`role_id`,`subtype`,`gear`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='运营活动投资（合服合并）';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `custom_act_investment`
--

LOCK TABLES `custom_act_investment` WRITE;
/*!40000 ALTER TABLE `custom_act_investment` DISABLE KEYS */;
/*!40000 ALTER TABLE `custom_act_investment` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `custom_act_joy_wish_times`
--

DROP TABLE IF EXISTS `custom_act_joy_wish_times`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `custom_act_joy_wish_times` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `act_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '活动类型',
  `sub_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类',
  `times` int(11) NOT NULL DEFAULT '0' COMMENT '许愿次数',
  PRIMARY KEY (`role_id`,`act_type`,`sub_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='定制活动许愿次数';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `custom_act_joy_wish_times`
--

LOCK TABLES `custom_act_joy_wish_times` WRITE;
/*!40000 ALTER TABLE `custom_act_joy_wish_times` DISABLE KEYS */;
/*!40000 ALTER TABLE `custom_act_joy_wish_times` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `custom_act_opening`
--

DROP TABLE IF EXISTS `custom_act_opening`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `custom_act_opening` (
  `type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动主类型',
  `subtype` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `wlv` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动开始时的世界等级',
  `stime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动开始时间',
  `etime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动结束时间',
  PRIMARY KEY (`type`,`subtype`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='开启中的定制活动数据(合服清空)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `custom_act_opening`
--

LOCK TABLES `custom_act_opening` WRITE;
/*!40000 ALTER TABLE `custom_act_opening` DISABLE KEYS */;
/*!40000 ALTER TABLE `custom_act_opening` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `custom_act_receive_reward`
--

DROP TABLE IF EXISTS `custom_act_receive_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `custom_act_receive_reward` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动主类型',
  `subtype` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `grade` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '奖励档次',
  `receive_times` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '领取次数',
  `utime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '数据更新时间',
  PRIMARY KEY (`role_id`,`type`,`subtype`,`grade`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='定制活动通用奖励领取数据';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `custom_act_receive_reward`
--

LOCK TABLES `custom_act_receive_reward` WRITE;
/*!40000 ALTER TABLE `custom_act_receive_reward` DISABLE KEYS */;
/*!40000 ALTER TABLE `custom_act_receive_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `custom_act_turntable_record`
--

DROP TABLE IF EXISTS `custom_act_turntable_record`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `custom_act_turntable_record` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `act_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '活动类型',
  `sub_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `role_name` varchar(255) NOT NULL COMMENT '玩家名',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '获得的奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间戳',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='定制活动转盘记录（合服直接合并）';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `custom_act_turntable_record`
--

LOCK TABLES `custom_act_turntable_record` WRITE;
/*!40000 ALTER TABLE `custom_act_turntable_record` DISABLE KEYS */;
/*!40000 ALTER TABLE `custom_act_turntable_record` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `custom_act_turntable_times`
--

DROP TABLE IF EXISTS `custom_act_turntable_times`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `custom_act_turntable_times` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `act_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '活动类型',
  `sub_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类',
  `times` int(11) NOT NULL DEFAULT '0' COMMENT '参与次数',
  PRIMARY KEY (`role_id`,`act_type`,`sub_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='定制活动转盘使用次数（合服直接合并）';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `custom_act_turntable_times`
--

LOCK TABLES `custom_act_turntable_times` WRITE;
/*!40000 ALTER TABLE `custom_act_turntable_times` DISABLE KEYS */;
/*!40000 ALTER TABLE `custom_act_turntable_times` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `custom_act_vip_bag_onsale`
--

DROP TABLE IF EXISTS `custom_act_vip_bag_onsale`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `custom_act_vip_bag_onsale` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `act_type` smallint(3) unsigned NOT NULL DEFAULT '0' COMMENT '活动主类型',
  `sub_type` smallint(3) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `grade` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '礼包档次',
  `price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '特惠价格',
  `percent` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '百分比',
  PRIMARY KEY (`role_id`,`act_type`,`sub_type`,`grade`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='VIP特惠记录表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `custom_act_vip_bag_onsale`
--

LOCK TABLES `custom_act_vip_bag_onsale` WRITE;
/*!40000 ALTER TABLE `custom_act_vip_bag_onsale` DISABLE KEYS */;
/*!40000 ALTER TABLE `custom_act_vip_bag_onsale` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `daily_checkin`
--

DROP TABLE IF EXISTS `daily_checkin`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `daily_checkin` (
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `month` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '月份',
  `total_state` varchar(512) NOT NULL DEFAULT '0' COMMENT '累计签到奖励状态',
  `daily_state` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '累计签到奖励状态',
  `retroactive_times` int(11) NOT NULL COMMENT '当月补签次数',
  `totalcheckinround` tinyint(2) NOT NULL COMMENT '累签奖励到了第几轮',
  `totalcheckindays` smallint(5) NOT NULL COMMENT '从该轮累签奖励开始的累签数量',
  `openday` int(11) NOT NULL COMMENT '开启签到功能的日期',
  PRIMARY KEY (`player_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='月签到';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `daily_checkin`
--

LOCK TABLES `daily_checkin` WRITE;
/*!40000 ALTER TABLE `daily_checkin` DISABLE KEYS */;
/*!40000 ALTER TABLE `daily_checkin` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `daily_online_time`
--

DROP TABLE IF EXISTS `daily_online_time`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `daily_online_time` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `online_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '当日在线时长',
  `update_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='累积在线时长福利（合服直接合并）';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `daily_online_time`
--

LOCK TABLES `daily_online_time` WRITE;
/*!40000 ALTER TABLE `daily_online_time` DISABLE KEYS */;
/*!40000 ALTER TABLE `daily_online_time` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `daily_turntable`
--

DROP TABLE IF EXISTS `daily_turntable`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `daily_turntable` (
  `sub_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `use_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '抽奖次数',
  `utime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
  PRIMARY KEY (`sub_type`,`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='每日转盘使用信息(合服合并)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `daily_turntable`
--

LOCK TABLES `daily_turntable` WRITE;
/*!40000 ALTER TABLE `daily_turntable` DISABLE KEYS */;
/*!40000 ALTER TABLE `daily_turntable` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `daily_turntable_info`
--

DROP TABLE IF EXISTS `daily_turntable_info`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `daily_turntable_info` (
  `sub_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `grade_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励对应id',
  `num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '次数',
  PRIMARY KEY (`sub_type`,`role_id`,`grade_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='每日转盘奖励信息(合服合并)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `daily_turntable_info`
--

LOCK TABLES `daily_turntable_info` WRITE;
/*!40000 ALTER TABLE `daily_turntable_info` DISABLE KEYS */;
/*!40000 ALTER TABLE `daily_turntable_info` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `deity`
--

DROP TABLE IF EXISTS `deity`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `deity` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色id',
  `deity_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '神格id',
  `devour_rule` varchar(1024) NOT NULL DEFAULT '' COMMENT '已吞噬法则',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='神格表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `deity`
--

LOCK TABLES `deity` WRITE;
/*!40000 ALTER TABLE `deity` DISABLE KEYS */;
/*!40000 ALTER TABLE `deity` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `designation`
--

DROP TABLE IF EXISTS `designation`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `designation` (
  `player_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '玩家id',
  `id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '称号id',
  `status` tinyint(2) unsigned NOT NULL DEFAULT '1' COMMENT '称号状态 0未佩戴 1佩戴',
  `active_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '激活时间',
  `endtime` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '结束时间',
  `time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT ' 操作时间',
  `dress_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '����ʱ��',
  `is_replace` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '0������ 1δ������',
  PRIMARY KEY (`player_id`,`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家称号表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `designation`
--

LOCK TABLES `designation` WRITE;
/*!40000 ALTER TABLE `designation` DISABLE KEYS */;
/*!40000 ALTER TABLE `designation` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `diamond_vip_shop_buy_record`
--

DROP TABLE IF EXISTS `diamond_vip_shop_buy_record`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `diamond_vip_shop_buy_record` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `shop_key_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '已购买的商品id',
  PRIMARY KEY (`role_id`,`shop_key_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='至尊vip商城购买记录（合服直接合并）';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `diamond_vip_shop_buy_record`
--

LOCK TABLES `diamond_vip_shop_buy_record` WRITE;
/*!40000 ALTER TABLE `diamond_vip_shop_buy_record` DISABLE KEYS */;
/*!40000 ALTER TABLE `diamond_vip_shop_buy_record` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `draw_record_act_local`
--

DROP TABLE IF EXISTS `draw_record_act_local`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `draw_record_act_local` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号ID',
  `type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动类型',
  `sub_type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `grade_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励档次id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='本服抽奖记录';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `draw_record_act_local`
--

LOCK TABLES `draw_record_act_local` WRITE;
/*!40000 ALTER TABLE `draw_record_act_local` DISABLE KEYS */;
/*!40000 ALTER TABLE `draw_record_act_local` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `draw_record_kf_act`
--

DROP TABLE IF EXISTS `draw_record_kf_act`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `draw_record_kf_act` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号ID',
  `type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动类型',
  `sub_type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器id',
  `platform` varchar(128) NOT NULL DEFAULT '' COMMENT '平台名字',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '所在的服标示',
  `name` varchar(128) NOT NULL DEFAULT '' COMMENT '玩家名字',
  `grade_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励档次id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服抽奖记录';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `draw_record_kf_act`
--

LOCK TABLES `draw_record_kf_act` WRITE;
/*!40000 ALTER TABLE `draw_record_kf_act` DISABLE KEYS */;
/*!40000 ALTER TABLE `draw_record_kf_act` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `draw_record_kf_act_local`
--

DROP TABLE IF EXISTS `draw_record_kf_act_local`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `draw_record_kf_act_local` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号ID',
  `type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动类型',
  `sub_type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `grade_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励档次id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服抽奖记录本服';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `draw_record_kf_act_local`
--

LOCK TABLES `draw_record_kf_act_local` WRITE;
/*!40000 ALTER TABLE `draw_record_kf_act_local` DISABLE KEYS */;
/*!40000 ALTER TABLE `draw_record_kf_act_local` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `dress_up_enabled`
--

DROP TABLE IF EXISTS `dress_up_enabled`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `dress_up_enabled` (
  `player_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '用户id',
  `dress_id` int(11) NOT NULL DEFAULT '0' COMMENT '饰品id',
  `dress_type` smallint(2) NOT NULL DEFAULT '0' COMMENT '饰品类型id',
  `time` int(10) NOT NULL DEFAULT '0' COMMENT '激活时间',
  `is_used` int(2) NOT NULL DEFAULT '0' COMMENT '是否正在使用 0-未使用 1-正使用',
  `dress_exp` int(20) NOT NULL DEFAULT '0' COMMENT '装扮当前的经验值',
  `dress_lv` int(10) NOT NULL DEFAULT '0' COMMENT '装扮当前的等级',
  `dress_seq` int(20) NOT NULL DEFAULT '0' COMMENT '装扮序号(区分同一id不同等级装扮)',
  PRIMARY KEY (`player_id`,`dress_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家激活的饰品';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `dress_up_enabled`
--

LOCK TABLES `dress_up_enabled` WRITE;
/*!40000 ALTER TABLE `dress_up_enabled` DISABLE KEYS */;
/*!40000 ALTER TABLE `dress_up_enabled` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `dress_up_illustration_enable`
--

DROP TABLE IF EXISTS `dress_up_illustration_enable`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `dress_up_illustration_enable` (
  `player_id` bigint(20) NOT NULL COMMENT '�û�id',
  `illu_lv` int(10) NOT NULL DEFAULT '0' COMMENT '��ǰͼ���ȼ�',
  `illu_curr_exp` int(20) NOT NULL DEFAULT '0' COMMENT '��ǰ����ֵ',
  PRIMARY KEY (`player_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `dress_up_illustration_enable`
--

LOCK TABLES `dress_up_illustration_enable` WRITE;
/*!40000 ALTER TABLE `dress_up_illustration_enable` DISABLE KEYS */;
/*!40000 ALTER TABLE `dress_up_illustration_enable` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `drumwar_rank`
--

DROP TABLE IF EXISTS `drumwar_rank`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `drumwar_rank` (
  `drumid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `zone` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战区',
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '玩家名称',
  `gname` varchar(50) NOT NULL DEFAULT '' COMMENT '帮派名称',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器id',
  `platform` varchar(50) NOT NULL DEFAULT '' COMMENT '平台',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '平台id',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '名次',
  `vip` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家VIP',
  `power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家战力',
  `career` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '职业',
  PRIMARY KEY (`drumid`,`zone`,`rid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='擂台赛榜单';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `drumwar_rank`
--

LOCK TABLES `drumwar_rank` WRITE;
/*!40000 ALTER TABLE `drumwar_rank` DISABLE KEYS */;
/*!40000 ALTER TABLE `drumwar_rank` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `drumwar_result`
--

DROP TABLE IF EXISTS `drumwar_result`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `drumwar_result` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增Id',
  `zone` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战区',
  `act` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '轮次',
  `group` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分组',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器id',
  `platform` varchar(50) NOT NULL DEFAULT '[]' COMMENT '平台',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '平台id',
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '玩家名称',
  `picturev` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家上传的头像版本号',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `career` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '职业',
  `pow` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战力',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='擂台赛对战数据';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `drumwar_result`
--

LOCK TABLES `drumwar_result` WRITE;
/*!40000 ALTER TABLE `drumwar_result` DISABLE KEYS */;
/*!40000 ALTER TABLE `drumwar_result` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `drumwar_sign`
--

DROP TABLE IF EXISTS `drumwar_sign`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `drumwar_sign` (
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器id',
  `platform` varchar(50) NOT NULL DEFAULT '[]' COMMENT '平台',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '平台id',
  `drumid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '届id',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '名字',
  `picturev` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '头像版号',
  `turn` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '转生等级',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `career` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '职业',
  `power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战力',
  PRIMARY KEY (`rid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='擂台赛报名数据';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `drumwar_sign`
--

LOCK TABLES `drumwar_sign` WRITE;
/*!40000 ALTER TABLE `drumwar_sign` DISABLE KEYS */;
/*!40000 ALTER TABLE `drumwar_sign` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `dungeon_best_record`
--

DROP TABLE IF EXISTS `dungeon_best_record`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `dungeon_best_record` (
  `player_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `dun_id` int(10) unsigned NOT NULL COMMENT '副本id',
  `data` varchar(1000) NOT NULL COMMENT '数据',
  PRIMARY KEY (`player_id`,`dun_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='副本最佳记录';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `dungeon_best_record`
--

LOCK TABLES `dungeon_best_record` WRITE;
/*!40000 ALTER TABLE `dungeon_best_record` DISABLE KEYS */;
/*!40000 ALTER TABLE `dungeon_best_record` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `dungeon_data`
--

DROP TABLE IF EXISTS `dungeon_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `dungeon_data` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `dun_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本类型',
  `data` text NOT NULL COMMENT '副本数据',
  PRIMARY KEY (`role_id`,`dun_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='副本相关信息记录表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `dungeon_data`
--

LOCK TABLES `dungeon_data` WRITE;
/*!40000 ALTER TABLE `dungeon_data` DISABLE KEYS */;
/*!40000 ALTER TABLE `dungeon_data` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `equip_devour`
--

DROP TABLE IF EXISTS `equip_devour`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `equip_devour` (
  `role_id` bigint(10) unsigned NOT NULL COMMENT '角色ID',
  `lv` int(10) unsigned NOT NULL COMMENT '吃货羊当前等级',
  `exp` int(10) unsigned NOT NULL COMMENT '吃货羊当前经验',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备吞噬-玩家记录';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `equip_devour`
--

LOCK TABLES `equip_devour` WRITE;
/*!40000 ALTER TABLE `equip_devour` DISABLE KEYS */;
/*!40000 ALTER TABLE `equip_devour` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `equip_magic`
--

DROP TABLE IF EXISTS `equip_magic`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `equip_magic` (
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `equip_pos` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '部位',
  `type` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '魔石类型',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '魔石id',
  `end_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '结束时间戳',
  PRIMARY KEY (`player_id`,`equip_pos`,`type`),
  KEY `end_time` (`end_time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备附魔';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `equip_magic`
--

LOCK TABLES `equip_magic` WRITE;
/*!40000 ALTER TABLE `equip_magic` DISABLE KEYS */;
/*!40000 ALTER TABLE `equip_magic` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `equip_prefix`
--

DROP TABLE IF EXISTS `equip_prefix`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `equip_prefix` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `equip_pos` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '装备部位',
  `prefix` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '重铸次数',
  PRIMARY KEY (`role_id`,`equip_pos`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备重铸';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `equip_prefix`
--

LOCK TABLES `equip_prefix` WRITE;
/*!40000 ALTER TABLE `equip_prefix` DISABLE KEYS */;
/*!40000 ALTER TABLE `equip_prefix` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `equip_stone`
--

DROP TABLE IF EXISTS `equip_stone`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `equip_stone` (
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色ID',
  `equip_pos` smallint(5) NOT NULL DEFAULT '0',
  `stone_pos` smallint(5) NOT NULL DEFAULT '0',
  `stone_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '宝石物品类型id',
  `bind` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '宝石的绑定状态',
  `stage` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '双属性宝石的阶数',
  `base_stone` varchar(255) NOT NULL DEFAULT '[]' COMMENT '双属性宝石的基础宝石id',
  `stone_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '宝石类型 0普通宝石 1双属性宝石',
  PRIMARY KEY (`player_id`,`equip_pos`,`stone_pos`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备宝石';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `equip_stone`
--

LOCK TABLES `equip_stone` WRITE;
/*!40000 ALTER TABLE `equip_stone` DISABLE KEYS */;
/*!40000 ALTER TABLE `equip_stone` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `equip_stone_refine`
--

DROP TABLE IF EXISTS `equip_stone_refine`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `equip_stone_refine` (
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `equip_pos` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '装备位置',
  `refine_lv` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '精炼等级',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '经验',
  PRIMARY KEY (`player_id`,`equip_pos`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='宝石精炼';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `equip_stone_refine`
--

LOCK TABLES `equip_stone_refine` WRITE;
/*!40000 ALTER TABLE `equip_stone_refine` DISABLE KEYS */;
/*!40000 ALTER TABLE `equip_stone_refine` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `equip_stren`
--

DROP TABLE IF EXISTS `equip_stren`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `equip_stren` (
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色ID',
  `equip_pos` smallint(5) NOT NULL DEFAULT '0',
  `stren` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '强化等级',
  `proficiency` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '熟练度',
  PRIMARY KEY (`player_id`,`equip_pos`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备强化';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `equip_stren`
--

LOCK TABLES `equip_stren` WRITE;
/*!40000 ALTER TABLE `equip_stren` DISABLE KEYS */;
/*!40000 ALTER TABLE `equip_stren` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `equip_suit`
--

DROP TABLE IF EXISTS `equip_suit`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `equip_suit` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `pos` tinyint(3) unsigned NOT NULL COMMENT '位置',
  `suit_lv` tinyint(3) unsigned NOT NULL COMMENT '套装等级',
  `suit_slv` smallint(5) unsigned NOT NULL COMMENT '套装阶级',
  PRIMARY KEY (`role_id`,`pos`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备套装';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `equip_suit`
--

LOCK TABLES `equip_suit` WRITE;
/*!40000 ALTER TABLE `equip_suit` DISABLE KEYS */;
/*!40000 ALTER TABLE `equip_suit` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `equip_wash`
--

DROP TABLE IF EXISTS `equip_wash`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `equip_wash` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `equip_pos` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '装备部位',
  `division` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '装备段位',
  `attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '洗炼属性',
  `refine_tmp_attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '精炼临时属性',
  PRIMARY KEY (`role_id`,`equip_pos`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备洗炼';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `equip_wash`
--

LOCK TABLES `equip_wash` WRITE;
/*!40000 ALTER TABLE `equip_wash` DISABLE KEYS */;
/*!40000 ALTER TABLE `equip_wash` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `eternal_valley_chapter`
--

DROP TABLE IF EXISTS `eternal_valley_chapter`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `eternal_valley_chapter` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `chapter` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '章节',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '奖励领取状态',
  PRIMARY KEY (`role_id`,`chapter`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='永恒碑谷章节数据';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `eternal_valley_chapter`
--

LOCK TABLES `eternal_valley_chapter` WRITE;
/*!40000 ALTER TABLE `eternal_valley_chapter` DISABLE KEYS */;
/*!40000 ALTER TABLE `eternal_valley_chapter` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `eternal_valley_stage`
--

DROP TABLE IF EXISTS `eternal_valley_stage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `eternal_valley_stage` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `chapter` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '章节id',
  `stage` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '阶段',
  `progress` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '进度',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '奖励领取状态',
  `extra` varchar(255) NOT NULL DEFAULT '[]' COMMENT '附加数据',
  PRIMARY KEY (`role_id`,`chapter`,`stage`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='永恒碑谷章节数据';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `eternal_valley_stage`
--

LOCK TABLES `eternal_valley_stage` WRITE;
/*!40000 ALTER TABLE `eternal_valley_stage` DISABLE KEYS */;
/*!40000 ALTER TABLE `eternal_valley_stage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ets_switch`
--

DROP TABLE IF EXISTS `ets_switch`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ets_switch` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '唯一标志',
  `is_open` tinyint(4) unsigned NOT NULL DEFAULT '0' COMMENT '开关 0关;1开',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='开关';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ets_switch`
--

LOCK TABLES `ets_switch` WRITE;
/*!40000 ALTER TABLE `ets_switch` DISABLE KEYS */;
/*!40000 ALTER TABLE `ets_switch` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `extra_custom_act`
--

DROP TABLE IF EXISTS `extra_custom_act`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `extra_custom_act` (
  `type` smallint(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动主类型',
  `subtype` smallint(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `act_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '活动类型',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '活动名字@lang@',
  `desc` varchar(1024) NOT NULL DEFAULT '' COMMENT '活动描述@lang@',
  `opday_lim` varchar(255) NOT NULL DEFAULT '[]' COMMENT '开服天数限制',
  `merday_lim` varchar(255) NOT NULL DEFAULT '[]' COMMENT '合服天数限制',
  `optype` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '开启类型',
  `opday` varchar(255) NOT NULL DEFAULT '[]' COMMENT '开启日期',
  `optime` varchar(255) NOT NULL DEFAULT '[]' COMMENT '开启时间段',
  `start_time` varchar(255) NOT NULL DEFAULT '0' COMMENT '开始时间',
  `end_time` varchar(255) NOT NULL DEFAULT '0' COMMENT '结束时间',
  `clear_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '清理类型',
  `condition` varchar(255) NOT NULL DEFAULT '[]' COMMENT '条件',
  PRIMARY KEY (`type`,`subtype`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='额外定制活动';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `extra_custom_act`
--

LOCK TABLES `extra_custom_act` WRITE;
/*!40000 ALTER TABLE `extra_custom_act` DISABLE KEYS */;
/*!40000 ALTER TABLE `extra_custom_act` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `extra_custom_act_reward`
--

DROP TABLE IF EXISTS `extra_custom_act_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `extra_custom_act_reward` (
  `type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动主类型',
  `subtype` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `grade` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '奖励档次',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '奖励名称@lang@',
  `desc` varchar(1024) NOT NULL DEFAULT '' COMMENT '奖励描述@lang@',
  `condition` varchar(255) NOT NULL DEFAULT '[]' COMMENT '领取条件',
  `format` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '奖励格式类型',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  PRIMARY KEY (`type`,`subtype`,`grade`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='额外定制活动奖励配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `extra_custom_act_reward`
--

LOCK TABLES `extra_custom_act_reward` WRITE;
/*!40000 ALTER TABLE `extra_custom_act_reward` DISABLE KEYS */;
/*!40000 ALTER TABLE `extra_custom_act_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `extra_custom_act_switch`
--

DROP TABLE IF EXISTS `extra_custom_act_switch`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `extra_custom_act_switch` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `is_open` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '定制活动开关',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='定制活动开关';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `extra_custom_act_switch`
--

LOCK TABLES `extra_custom_act_switch` WRITE;
/*!40000 ALTER TABLE `extra_custom_act_switch` DISABLE KEYS */;
/*!40000 ALTER TABLE `extra_custom_act_switch` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `extra_custom_act_type`
--

DROP TABLE IF EXISTS `extra_custom_act_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `extra_custom_act_type` (
  `type` smallint(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动主类型',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '活动名字@lang@',
  PRIMARY KEY (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='额外定制活动类型';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `extra_custom_act_type`
--

LOCK TABLES `extra_custom_act_type` WRITE;
/*!40000 ALTER TABLE `extra_custom_act_type` DISABLE KEYS */;
/*!40000 ALTER TABLE `extra_custom_act_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `fashion_info`
--

DROP TABLE IF EXISTS `fashion_info`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `fashion_info` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `pos_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '部位',
  `fashion_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '时装id',
  `color_id` int(10) unsigned NOT NULL COMMENT '当前颜色',
  `color_list` varchar(50) NOT NULL COMMENT '激活的颜色列表',
  `fashion_star_lv` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '时装星级',
  `expiry_time` int(10) unsigned NOT NULL COMMENT '过期时间',
  PRIMARY KEY (`role_id`,`pos_id`,`fashion_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='时装信息记录表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `fashion_info`
--

LOCK TABLES `fashion_info` WRITE;
/*!40000 ALTER TABLE `fashion_info` DISABLE KEYS */;
/*!40000 ALTER TABLE `fashion_info` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `fashion_pos`
--

DROP TABLE IF EXISTS `fashion_pos`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `fashion_pos` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '物品id',
  `pos_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `pos_lv` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '部位等级',
  `pos_upgrade_num` int(10) unsigned NOT NULL COMMENT '时装精华',
  `wear_fashion_id` int(10) unsigned NOT NULL COMMENT '穿着时装id',
  `wear_color_id` int(10) unsigned NOT NULL COMMENT '穿着颜色',
  PRIMARY KEY (`role_id`,`pos_id`),
  KEY `player_id` (`pos_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='时装部位数据记录表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `fashion_pos`
--

LOCK TABLES `fashion_pos` WRITE;
/*!40000 ALTER TABLE `fashion_pos` DISABLE KEYS */;
/*!40000 ALTER TABLE `fashion_pos` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `feedback`
--

DROP TABLE IF EXISTS `feedback`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `feedback` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `state` tinyint(1) unsigned DEFAULT '0' COMMENT '状态(已回复1/未回复0)',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `player_name` varchar(100) NOT NULL DEFAULT '' COMMENT '玩家名',
  `content` mediumtext NOT NULL COMMENT '内容',
  `timestamp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'Unix时间戳',
  `ip` varchar(100) NOT NULL DEFAULT '' COMMENT '玩家IP',
  `server` varchar(100) NOT NULL DEFAULT '' COMMENT '服务器',
  `gm` varchar(100) DEFAULT NULL COMMENT '游戏管理员',
  `reply` text COMMENT '回复内容',
  `reply_time` int(11) unsigned DEFAULT '0' COMMENT '回复时间',
  PRIMARY KEY (`id`),
  KEY `state` (`state`),
  KEY `timestamp` (`timestamp`),
  KEY `player_name` (`player_name`) USING BTREE,
  KEY `player_id` (`player_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家反馈';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `feedback`
--

LOCK TABLES `feedback` WRITE;
/*!40000 ALTER TABLE `feedback` DISABLE KEYS */;
/*!40000 ALTER TABLE `feedback` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `fireworks_act`
--

DROP TABLE IF EXISTS `fireworks_act`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `fireworks_act` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `use_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '烟花使用次数',
  `wlv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动开始时世界等级',
  `utime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='烟花使用信息';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `fireworks_act`
--

LOCK TABLES `fireworks_act` WRITE;
/*!40000 ALTER TABLE `fireworks_act` DISABLE KEYS */;
/*!40000 ALTER TABLE `fireworks_act` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `fireworks_reward_info`
--

DROP TABLE IF EXISTS `fireworks_reward_info`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `fireworks_reward_info` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励对应id',
  `num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '获得次数',
  `limit_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '数量上限',
  `utime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
  PRIMARY KEY (`role_id`,`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='烟花奖励信息';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `fireworks_reward_info`
--

LOCK TABLES `fireworks_reward_info` WRITE;
/*!40000 ALTER TABLE `fireworks_reward_info` DISABLE KEYS */;
/*!40000 ALTER TABLE `fireworks_reward_info` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `fish_illustrated`
--

DROP TABLE IF EXISTS `fish_illustrated`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `fish_illustrated` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `illustrate_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '图鉴id',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '图鉴等级',
  PRIMARY KEY (`role_id`,`illustrate_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='鱼类图鉴表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `fish_illustrated`
--

LOCK TABLES `fish_illustrated` WRITE;
/*!40000 ALTER TABLE `fish_illustrated` DISABLE KEYS */;
/*!40000 ALTER TABLE `fish_illustrated` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `flower`
--

DROP TABLE IF EXISTS `flower`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `flower` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `flower_num` int(11) unsigned NOT NULL COMMENT '鲜花数量',
  `charm` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '魅力值',
  `fame` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '名誉',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='鲜花';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `flower`
--

LOCK TABLES `flower` WRITE;
/*!40000 ALTER TABLE `flower` DISABLE KEYS */;
/*!40000 ALTER TABLE `flower` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `flower_gift_record`
--

DROP TABLE IF EXISTS `flower_gift_record`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `flower_gift_record` (
  `id` bigint(20) unsigned NOT NULL,
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `other_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '送礼玩家id',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品id',
  `anonymous` tinyint(1) NOT NULL DEFAULT '0' COMMENT '0: 不匿名 1:匿名',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  `code` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '1:送礼 2:收礼',
  PRIMARY KEY (`id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='鲜花送礼记录';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `flower_gift_record`
--

LOCK TABLES `flower_gift_record` WRITE;
/*!40000 ALTER TABLE `flower_gift_record` DISABLE KEYS */;
/*!40000 ALTER TABLE `flower_gift_record` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `flower_kf_gift_record`
--

DROP TABLE IF EXISTS `flower_kf_gift_record`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `flower_kf_gift_record` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `other_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '送礼玩家id',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品id',
  `anonymous` tinyint(1) NOT NULL DEFAULT '0' COMMENT '0: 不匿名 1:匿名',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服活动鲜花收礼记录';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `flower_kf_gift_record`
--

LOCK TABLES `flower_kf_gift_record` WRITE;
/*!40000 ALTER TABLE `flower_kf_gift_record` DISABLE KEYS */;
/*!40000 ALTER TABLE `flower_kf_gift_record` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `flower_kf_rank_act`
--

DROP TABLE IF EXISTS `flower_kf_rank_act`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `flower_kf_rank_act` (
  `rank_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排行榜类型',
  `sub_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动类型',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '值',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器id',
  `platform` varchar(255) NOT NULL DEFAULT '' COMMENT '平台名字',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '所在的服标示',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '名字',
  `sex` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '性别',
  `career` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '职业',
  `turn` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '转生数',
  `picture` varchar(255) NOT NULL DEFAULT '' COMMENT '头像路径',
  `picture_ver` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '头像版本号',
  `profile_photo_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '头像id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  UNIQUE KEY `rank` (`player_id`,`rank_type`,`sub_type`) USING BTREE,
  KEY `value` (`value`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服魅力榜活动';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `flower_kf_rank_act`
--

LOCK TABLES `flower_kf_rank_act` WRITE;
/*!40000 ALTER TABLE `flower_kf_rank_act` DISABLE KEYS */;
/*!40000 ALTER TABLE `flower_kf_rank_act` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `flower_kf_rank_act_local`
--

DROP TABLE IF EXISTS `flower_kf_rank_act_local`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `flower_kf_rank_act_local` (
  `rank_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排行榜类型',
  `sub_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动类型',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '值',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器id',
  `platform` varchar(255) NOT NULL DEFAULT '' COMMENT '平台名字',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '所在的服标示',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '名字',
  `sex` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '性别',
  `career` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '职业',
  `turn` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '转生数',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  UNIQUE KEY `rank` (`player_id`,`rank_type`,`sub_type`) USING BTREE,
  KEY `value` (`value`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服魅力榜活动本服';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `flower_kf_rank_act_local`
--

LOCK TABLES `flower_kf_rank_act_local` WRITE;
/*!40000 ALTER TABLE `flower_kf_rank_act_local` DISABLE KEYS */;
/*!40000 ALTER TABLE `flower_kf_rank_act_local` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `flower_rank_act_local`
--

DROP TABLE IF EXISTS `flower_rank_act_local`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `flower_rank_act_local` (
  `rank_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排行榜类型',
  `sub_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动类型',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '值',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  UNIQUE KEY `rank` (`player_id`,`rank_type`,`sub_type`) USING BTREE,
  KEY `value` (`value`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='魅力榜活动';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `flower_rank_act_local`
--

LOCK TABLES `flower_rank_act_local` WRITE;
/*!40000 ALTER TABLE `flower_rank_act_local` DISABLE KEYS */;
/*!40000 ALTER TABLE `flower_rank_act_local` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `gift_list`
--

DROP TABLE IF EXISTS `gift_list`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `gift_list` (
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色ID',
  `gift_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '礼包ID',
  `give_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '发送时间',
  `get_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '领取次数',
  `get_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '领取时间',
  `offline_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '下线时间',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '领取状态，0为未领取，1为已领取',
  UNIQUE KEY `player_id` (`player_id`,`gift_id`),
  KEY `status` (`status`),
  KEY `gift_id` (`gift_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='礼包领取表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `gift_list`
--

LOCK TABLES `gift_list` WRITE;
/*!40000 ALTER TABLE `gift_list` DISABLE KEYS */;
/*!40000 ALTER TABLE `gift_list` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `god`
--

DROP TABLE IF EXISTS `god`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `god` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `god_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '降神id',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '星级',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '经验值',
  `grade` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '阶数',
  `pos` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '出战位',
  `up_times` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '当前阶点击升级次数',
  PRIMARY KEY (`role_id`,`god_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='降神表(合服合并)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `god`
--

LOCK TABLES `god` WRITE;
/*!40000 ALTER TABLE `god` DISABLE KEYS */;
/*!40000 ALTER TABLE `god` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `god_pyx`
--

DROP TABLE IF EXISTS `god_pyx`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `god_pyx` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `pyx_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '圣器id',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '圣器等级',
  `seal_list` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '印记列表',
  PRIMARY KEY (`role_id`,`pyx_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='降神圣器表(合服合并)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `god_pyx`
--

LOCK TABLES `god_pyx` WRITE;
/*!40000 ALTER TABLE `god_pyx` DISABLE KEYS */;
/*!40000 ALTER TABLE `god_pyx` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `god_rune`
--

DROP TABLE IF EXISTS `god_rune`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `god_rune` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `rune_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '符文id',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '经验',
  PRIMARY KEY (`role_id`,`rune_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='降神符文表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `god_rune`
--

LOCK TABLES `god_rune` WRITE;
/*!40000 ALTER TABLE `god_rune` DISABLE KEYS */;
/*!40000 ALTER TABLE `god_rune` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `god_rune_pos`
--

DROP TABLE IF EXISTS `god_rune_pos`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `god_rune_pos` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `pos` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '槽位',
  PRIMARY KEY (`role_id`,`pos`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='降神符文槽位表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `god_rune_pos`
--

LOCK TABLES `god_rune_pos` WRITE;
/*!40000 ALTER TABLE `god_rune_pos` DISABLE KEYS */;
/*!40000 ALTER TABLE `god_rune_pos` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `goods`
--

DROP TABLE IF EXISTS `goods`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `goods` (
  `id` bigint(20) NOT NULL DEFAULT '0',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `type` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型',
  `subtype` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '物品子类型',
  `create_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品创建时间',
  `price_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '物品价格类型，1为铜钱',
  `price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品购买价格',
  `suit_id` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '套装ID',
  `skill_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能ID',
  `expire_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '有效期，0为无',
  `lock_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '锁定结束时间戳，0为无',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `type` (`type`,`subtype`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `goods`
--

LOCK TABLES `goods` WRITE;
/*!40000 ALTER TABLE `goods` DISABLE KEYS */;
/*!40000 ALTER TABLE `goods` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `goods_extra`
--

DROP TABLE IF EXISTS `goods_extra`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `goods_extra` (
  `gid` bigint(20) NOT NULL DEFAULT '0',
  `pid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色ID',
  `stren` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '强化等级',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '经验',
  `stage` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '阶数',
  `dstone` varchar(255) NOT NULL DEFAULT '[]' COMMENT '宝石',
  `stren_expend` int(11) NOT NULL DEFAULT '0' COMMENT '强化消耗',
  PRIMARY KEY (`gid`),
  KEY `pid` (`pid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品额外数据表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `goods_extra`
--

LOCK TABLES `goods_extra` WRITE;
/*!40000 ALTER TABLE `goods_extra` DISABLE KEYS */;
/*!40000 ALTER TABLE `goods_extra` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `goods_high`
--

DROP TABLE IF EXISTS `goods_high`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `goods_high` (
  `gid` bigint(20) NOT NULL DEFAULT '0',
  `pid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色ID',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型ID',
  `guild_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '帮派ID',
  `location` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '物品所在位置，1 装备一，2 装备二，3 装备三, 4 背包，5 仓库',
  `cell` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '物品所在格子位置',
  `num` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '物品数量',
  PRIMARY KEY (`gid`),
  KEY `pid` (`pid`,`location`),
  KEY `guild_id` (`guild_id`),
  KEY `goods_id` (`goods_id`),
  KEY `location` (`location`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品高频信息表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `goods_high`
--

LOCK TABLES `goods_high` WRITE;
/*!40000 ALTER TABLE `goods_high` DISABLE KEYS */;
/*!40000 ALTER TABLE `goods_high` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `goods_low`
--

DROP TABLE IF EXISTS `goods_low`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `goods_low` (
  `gid` bigint(20) NOT NULL DEFAULT '0',
  `pid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `gtype_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型编号ID',
  `equip_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '装备类型：0为无，1为武器，2为防具，3为饰品',
  `bind` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '绑定状态，0为不可绑定，1为可绑定还未绑定，2为可绑定已绑定',
  `trade` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '交易状态，0为可交易，1为不可交易',
  `sell` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '出售状态，0为可出售，1为不可出售',
  `level` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '装备等级',
  `color` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '装备颜色',
  `addition` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '附加属性',
  `extra_attr` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '扩展附加属性 支持{属性,值} {属性,基础值,成长间隔,单位成长}',
  `other_data` varchar(255) NOT NULL DEFAULT '[]' COMMENT '额外数据(格式未定，根据类型解析、储存)',
  PRIMARY KEY (`gid`),
  KEY `pid` (`pid`),
  KEY `goods_id` (`gtype_id`),
  KEY `equip_type` (`equip_type`),
  KEY `color` (`color`),
  KEY `level` (`level`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品低频信息表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `goods_low`
--

LOCK TABLES `goods_low` WRITE;
/*!40000 ALTER TABLE `goods_low` DISABLE KEYS */;
/*!40000 ALTER TABLE `goods_low` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `guild`
--

DROP TABLE IF EXISTS `guild`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `guild` (
  `id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '公会名字',
  `tenet` varchar(100) NOT NULL DEFAULT '' COMMENT '公告宣言',
  `announce` varchar(500) NOT NULL DEFAULT '' COMMENT '公会公告',
  `chief_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '会长',
  `chief_name` varchar(50) NOT NULL DEFAULT '' COMMENT '会长名字',
  `lv` smallint(3) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `realm` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '阵营',
  `reputation` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '声望',
  `gfunds` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '公会资金',
  `growth_val` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '成长值',
  `create_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '创建时间',
  `approve_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '申请类型',
  `auto_approve_lv` smallint(3) unsigned NOT NULL DEFAULT '0' COMMENT '自动加入的等级',
  `auto_approve_power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '自动加入的战力',
  `modify_times` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '公告修改次数',
  `disband_warnning_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '解散警告开始时间',
  `c_rename` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '是否可以免费改名',
  `guild_c_rename_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '改名时间',
  `building_king_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '金库等级',
  `building_store_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '仓库等级',
  `building_skill_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能等级',
  `building_shop_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商店等级',
  `building_task_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '任务等级',
  `liveness_list` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '活跃度列表',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `guild`
--

LOCK TABLES `guild` WRITE;
/*!40000 ALTER TABLE `guild` DISABLE KEYS */;
/*!40000 ALTER TABLE `guild` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `guild_apply`
--

DROP TABLE IF EXISTS `guild_apply`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `guild_apply` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `create_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '创建时间',
  PRIMARY KEY (`role_id`,`guild_id`),
  KEY `guild_id` (`guild_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会申请';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `guild_apply`
--

LOCK TABLES `guild_apply` WRITE;
/*!40000 ALTER TABLE `guild_apply` DISABLE KEYS */;
/*!40000 ALTER TABLE `guild_apply` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `guild_create_act_reward`
--

DROP TABLE IF EXISTS `guild_create_act_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `guild_create_act_reward` (
  `act_id` smallint(5) unsigned NOT NULL COMMENT '活动子类型',
  `reward_id` smallint(5) unsigned NOT NULL COMMENT '奖励档次',
  `guild_id` bigint(20) unsigned NOT NULL COMMENT '公会id',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`act_id`,`reward_id`,`guild_id`,`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='勇者盟约奖励领取记录';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `guild_create_act_reward`
--

LOCK TABLES `guild_create_act_reward` WRITE;
/*!40000 ALTER TABLE `guild_create_act_reward` DISABLE KEYS */;
/*!40000 ALTER TABLE `guild_create_act_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `guild_depot_goods`
--

DROP TABLE IF EXISTS `guild_depot_goods`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `guild_depot_goods` (
  `id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '仓库物品id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '帮派id',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型id',
  `num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品数量',
  `color` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '物品颜色',
  `addition` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '附加属性',
  `extra_attr` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '附加属性 支持{属性,值} {属性,基础值,成长间隔,单位成长}',
  `create_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '创建时间',
  PRIMARY KEY (`id`),
  KEY `guild_id` (`guild_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='帮派仓库物品';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `guild_depot_goods`
--

LOCK TABLES `guild_depot_goods` WRITE;
/*!40000 ALTER TABLE `guild_depot_goods` DISABLE KEYS */;
/*!40000 ALTER TABLE `guild_depot_goods` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `guild_donate`
--

DROP TABLE IF EXISTS `guild_donate`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `guild_donate` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `cfg_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '配置id',
  `donate` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '捐献数量',
  `funds` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '增加资金',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会捐献表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `guild_donate`
--

LOCK TABLES `guild_donate` WRITE;
/*!40000 ALTER TABLE `guild_donate` DISABLE KEYS */;
/*!40000 ALTER TABLE `guild_donate` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `guild_guard_dungeon`
--

DROP TABLE IF EXISTS `guild_guard_dungeon`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `guild_guard_dungeon` (
  `guild_id` bigint(20) unsigned NOT NULL COMMENT '公会id',
  `act_id` int(10) unsigned NOT NULL COMMENT '活动子类',
  `start_time` int(10) unsigned NOT NULL COMMENT '副本被开启的时间',
  `is_end` tinyint(3) unsigned NOT NULL COMMENT '是否已经结束 0未结束 1结算结束 2错误结束',
  PRIMARY KEY (`guild_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='守卫公会数据';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `guild_guard_dungeon`
--

LOCK TABLES `guild_guard_dungeon` WRITE;
/*!40000 ALTER TABLE `guild_guard_dungeon` DISABLE KEYS */;
/*!40000 ALTER TABLE `guild_guard_dungeon` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `guild_member`
--

DROP TABLE IF EXISTS `guild_member`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `guild_member` (
  `id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `guild_id` bigint(20) unsigned NOT NULL COMMENT '公会id',
  `guild_name` varchar(50) NOT NULL DEFAULT '' COMMENT '公会名字',
  `position` tinyint(2) unsigned NOT NULL DEFAULT '2' COMMENT '职位',
  `donate` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '贡献值',
  `historical_donate` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '本帮历史贡献',
  `depot_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '仓库积分',
  `create_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '创建时间',
  PRIMARY KEY (`id`),
  KEY `guild_id` (`guild_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会成员';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `guild_member`
--

LOCK TABLES `guild_member` WRITE;
/*!40000 ALTER TABLE `guild_member` DISABLE KEYS */;
/*!40000 ALTER TABLE `guild_member` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `guild_position_name`
--

DROP TABLE IF EXISTS `guild_position_name`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `guild_position_name` (
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `position` tinyint(4) unsigned NOT NULL DEFAULT '0' COMMENT '职位',
  `position_name` varchar(50) NOT NULL DEFAULT '' COMMENT '职位名字',
  PRIMARY KEY (`guild_id`,`position`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会职位名字';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `guild_position_name`
--

LOCK TABLES `guild_position_name` WRITE;
/*!40000 ALTER TABLE `guild_position_name` DISABLE KEYS */;
/*!40000 ALTER TABLE `guild_position_name` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `guild_position_permission`
--

DROP TABLE IF EXISTS `guild_position_permission`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `guild_position_permission` (
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `position` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '职位',
  `permission_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '权限类型',
  `is_allow` tinyint(4) unsigned NOT NULL DEFAULT '0' COMMENT '是否允许',
  PRIMARY KEY (`guild_id`,`position`,`permission_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会职位权限';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `guild_position_permission`
--

LOCK TABLES `guild_position_permission` WRITE;
/*!40000 ALTER TABLE `guild_position_permission` DISABLE KEYS */;
/*!40000 ALTER TABLE `guild_position_permission` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `guild_skill`
--

DROP TABLE IF EXISTS `guild_skill`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `guild_skill` (
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `skill_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能id',
  `lv` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '研究等级',
  PRIMARY KEY (`guild_id`,`skill_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会技能';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `guild_skill`
--

LOCK TABLES `guild_skill` WRITE;
/*!40000 ALTER TABLE `guild_skill` DISABLE KEYS */;
/*!40000 ALTER TABLE `guild_skill` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `guild_war_break_reward`
--

DROP TABLE IF EXISTS `guild_war_break_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `guild_war_break_reward` (
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `allot_times` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '分配次数',
  PRIMARY KEY (`guild_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会争霸终结奖励';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `guild_war_break_reward`
--

LOCK TABLES `guild_war_break_reward` WRITE;
/*!40000 ALTER TABLE `guild_war_break_reward` DISABLE KEYS */;
/*!40000 ALTER TABLE `guild_war_break_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `guild_war_division`
--

DROP TABLE IF EXISTS `guild_war_division`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `guild_war_division` (
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `division` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `ranking` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '同赛区公会排名',
  PRIMARY KEY (`guild_id`),
  KEY `division` (`division`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会争霸赛区排名';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `guild_war_division`
--

LOCK TABLES `guild_war_division` WRITE;
/*!40000 ALTER TABLE `guild_war_division` DISABLE KEYS */;
/*!40000 ALTER TABLE `guild_war_division` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `guild_war_key_val`
--

DROP TABLE IF EXISTS `guild_war_key_val`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `guild_war_key_val` (
  `id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT 'key_id',
  `val` varchar(255) NOT NULL DEFAULT '' COMMENT 'Val',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会争霸Key-Val';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `guild_war_key_val`
--

LOCK TABLES `guild_war_key_val` WRITE;
/*!40000 ALTER TABLE `guild_war_key_val` DISABLE KEYS */;
/*!40000 ALTER TABLE `guild_war_key_val` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `guild_war_reward`
--

DROP TABLE IF EXISTS `guild_war_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `guild_war_reward` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `streak_times` smallint(1) unsigned NOT NULL DEFAULT '0' COMMENT '连胜次数',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '连胜奖励',
  `allot_times` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '奖励分配次数',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '分配的玩家id',
  PRIMARY KEY (`id`,`guild_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会争霸连胜奖励 注：连胜奖励有个的话会记录多条数据';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `guild_war_reward`
--

LOCK TABLES `guild_war_reward` WRITE;
/*!40000 ALTER TABLE `guild_war_reward` DISABLE KEYS */;
/*!40000 ALTER TABLE `guild_war_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `hi_points_act`
--

DROP TABLE IF EXISTS `hi_points_act`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `hi_points_act` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `sub_type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类',
  `mod_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '模块Id',
  `sub_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '子id',
  `count` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '参与次数',
  `is_plus` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '控制重复增加',
  `utime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '数据更新时间',
  PRIMARY KEY (`role_id`,`sub_type`,`mod_id`,`sub_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家嗨点各活动参与次数';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `hi_points_act`
--

LOCK TABLES `hi_points_act` WRITE;
/*!40000 ALTER TABLE `hi_points_act` DISABLE KEYS */;
/*!40000 ALTER TABLE `hi_points_act` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `hi_points_reward`
--

DROP TABLE IF EXISTS `hi_points_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `hi_points_reward` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `sub_type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类',
  `grade` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励档次',
  `reward_state` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '领取状态',
  `utime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
  PRIMARY KEY (`role_id`,`sub_type`,`grade`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='嗨点奖励状态';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `hi_points_reward`
--

LOCK TABLES `hi_points_reward` WRITE;
/*!40000 ALTER TABLE `hi_points_reward` DISABLE KEYS */;
/*!40000 ALTER TABLE `hi_points_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `husong_log`
--

DROP TABLE IF EXISTS `husong_log`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `husong_log` (
  `id` int(20) unsigned NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '角色ID',
  `type` tinyint(4) unsigned NOT NULL COMMENT '护送类型 1.护送 2.抢夺',
  `airship_id` smallint(10) unsigned NOT NULL COMMENT '飞艇ID',
  `result` tinyint(4) unsigned NOT NULL COMMENT '护送结果 1.成功 0.失败',
  `reward_list` varchar(255) NOT NULL COMMENT '奖励列表',
  `date_time` int(20) unsigned NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `husong_log`
--

LOCK TABLES `husong_log` WRITE;
/*!40000 ALTER TABLE `husong_log` DISABLE KEYS */;
/*!40000 ALTER TABLE `husong_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `husong_player`
--

DROP TABLE IF EXISTS `husong_player`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `husong_player` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `airship_id` int(10) unsigned NOT NULL COMMENT '飞艇ID',
  `airship_sid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '飞艇自动生成唯一ID',
  `airship_aid` varchar(50) NOT NULL COMMENT '飞艇aid',
  `scene_pool_id` smallint(2) unsigned NOT NULL COMMENT '飞艇所在pool_id',
  `icon_start_time` int(10) unsigned NOT NULL COMMENT '"劫"字图标开始时间',
  `less_hp` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '剩余血量',
  `stage` int(10) unsigned NOT NULL COMMENT '当前阶段: 0,1,2',
  `reward_stage` int(10) unsigned NOT NULL COMMENT '已发放奖励阶段:0,1,2',
  `start_time` int(10) unsigned NOT NULL COMMENT '护送开始时间',
  `airship_skill` int(10) unsigned NOT NULL COMMENT '飞艇技能(一次护送只能用一次)',
  `help_list` varchar(512) NOT NULL COMMENT '协助',
  `ask_help_time` int(10) unsigned NOT NULL COMMENT '求助时间',
  `out_side` tinyint(3) unsigned NOT NULL COMMENT '是否脱离飞艇启动范围 0:未脱离 1:已脱离',
  `help_id` bigint(10) unsigned NOT NULL COMMENT '协助的护送玩家ID',
  `log` varchar(3072) NOT NULL DEFAULT '[]' COMMENT '护送历史记录',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='护送玩家信息记录表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `husong_player`
--

LOCK TABLES `husong_player` WRITE;
/*!40000 ALTER TABLE `husong_player` DISABLE KEYS */;
/*!40000 ALTER TABLE `husong_player` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `internal_manage`
--

DROP TABLE IF EXISTS `internal_manage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `internal_manage` (
  `id` int(11) NOT NULL COMMENT '角色ID',
  `nickname` varchar(50) NOT NULL COMMENT '角色名称',
  `truename` varchar(50) NOT NULL COMMENT '真实名称',
  `position` varchar(50) NOT NULL COMMENT '职位',
  `sid` int(11) NOT NULL COMMENT '服ID',
  `gold` int(11) NOT NULL COMMENT '总元宝',
  `rights` int(11) NOT NULL COMMENT '新手指导员权限：2：一般3：待定',
  `status` tinyint(4) DEFAULT '0' COMMENT '状态0：未通过1通过',
  `type` tinyint(1) NOT NULL DEFAULT '0' COMMENT '类型0：内部管理员1:指导员',
  `time` int(11) NOT NULL COMMENT '申请时间',
  PRIMARY KEY (`id`,`type`),
  KEY `type` (`type`),
  KEY `status` (`status`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='内部号管理';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `internal_manage`
--

LOCK TABLES `internal_manage` WRITE;
/*!40000 ALTER TABLE `internal_manage` DISABLE KEYS */;
/*!40000 ALTER TABLE `internal_manage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `investment_data`
--

DROP TABLE IF EXISTS `investment_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `investment_data` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `type` tinyint(3) unsigned NOT NULL COMMENT '投资类型',
  `lv` tinyint(3) unsigned NOT NULL COMMENT '投资档次',
  `buy_time` int(10) unsigned NOT NULL COMMENT '购买时间',
  `reward_info` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '回报信息',
  PRIMARY KEY (`role_id`,`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家投资数据';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `investment_data`
--

LOCK TABLES `investment_data` WRITE;
/*!40000 ALTER TABLE `investment_data` DISABLE KEYS */;
/*!40000 ALTER TABLE `investment_data` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `jjc_honour`
--

DROP TABLE IF EXISTS `jjc_honour`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `jjc_honour` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色Id',
  `honour` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '荣誉值',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='竞技荣誉值';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `jjc_honour`
--

LOCK TABLES `jjc_honour` WRITE;
/*!40000 ALTER TABLE `jjc_honour` DISABLE KEYS */;
/*!40000 ALTER TABLE `jjc_honour` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `jjc_real_role`
--

DROP TABLE IF EXISTS `jjc_real_role`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `jjc_real_role` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家排名',
  `history_rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '历史最高排名',
  `is_reward` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '有否奖励',
  `reward_rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励根据的排名',
  `break_reward_state` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '突破礼包领取状态',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='竞技场玩家排名';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `jjc_real_role`
--

LOCK TABLES `jjc_real_role` WRITE;
/*!40000 ALTER TABLE `jjc_real_role` DISABLE KEYS */;
/*!40000 ALTER TABLE `jjc_real_role` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `jjc_record`
--

DROP TABLE IF EXISTS `jjc_record`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `jjc_record` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间戳',
  `rival_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '挑战玩家Id',
  `result` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '挑战结果',
  `rank_change` int(11) NOT NULL DEFAULT '0' COMMENT '排名变化',
  `code` tinyint(2) NOT NULL COMMENT '挑战方\\被挑战方',
  PRIMARY KEY (`role_id`,`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='被挑战记录';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `jjc_record`
--

LOCK TABLES `jjc_record` WRITE;
/*!40000 ALTER TABLE `jjc_record` DISABLE KEYS */;
/*!40000 ALTER TABLE `jjc_record` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `join_log`
--

DROP TABLE IF EXISTS `join_log`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `join_log` (
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `module_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
  PRIMARY KEY (`player_id`,`module_id`),
  KEY `module_id` (`module_id`),
  KEY `guild_id` (`guild_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='功能活动参与表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `join_log`
--

LOCK TABLES `join_log` WRITE;
/*!40000 ALTER TABLE `join_log` DISABLE KEYS */;
/*!40000 ALTER TABLE `join_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `kf_1vn_auction`
--

DROP TABLE IF EXISTS `kf_1vn_auction`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `kf_1vn_auction` (
  `issue` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '第几期',
  `optime` int(1) unsigned NOT NULL DEFAULT '0' COMMENT '开始时间',
  `edtime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '结束时间',
  PRIMARY KEY (`issue`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服1vn拍卖者记录 合服清空';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `kf_1vn_auction`
--

LOCK TABLES `kf_1vn_auction` WRITE;
/*!40000 ALTER TABLE `kf_1vn_auction` DISABLE KEYS */;
/*!40000 ALTER TABLE `kf_1vn_auction` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `kf_1vn_auction_award`
--

DROP TABLE IF EXISTS `kf_1vn_auction_award`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `kf_1vn_auction_award` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `issue` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖期数',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服数',
  `name` varchar(200) NOT NULL DEFAULT '' COMMENT '玩家名字',
  `price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '出价',
  `awards` varchar(200) NOT NULL DEFAULT '[]' COMMENT '奖励物品',
  PRIMARY KEY (`id`),
  KEY `issue` (`issue`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服1vn拍卖者记录 合服清空';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `kf_1vn_auction_award`
--

LOCK TABLES `kf_1vn_auction_award` WRITE;
/*!40000 ALTER TABLE `kf_1vn_auction_award` DISABLE KEYS */;
/*!40000 ALTER TABLE `kf_1vn_auction_award` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `kf_1vn_auction_rank`
--

DROP TABLE IF EXISTS `kf_1vn_auction_rank`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `kf_1vn_auction_rank` (
  `auction_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖配置id',
  `id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服id',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服数',
  `name` varchar(200) NOT NULL DEFAULT '' COMMENT '玩家名字',
  `price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '出价',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  PRIMARY KEY (`auction_id`,`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服1vn拍卖者排行榜 合服清空';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `kf_1vn_auction_rank`
--

LOCK TABLES `kf_1vn_auction_rank` WRITE;
/*!40000 ALTER TABLE `kf_1vn_auction_rank` DISABLE KEYS */;
/*!40000 ALTER TABLE `kf_1vn_auction_rank` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `kf_1vn_bidder`
--

DROP TABLE IF EXISTS `kf_1vn_bidder`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `kf_1vn_bidder` (
  `auction_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖配置id',
  `id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服id',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服数',
  `name` varchar(200) NOT NULL DEFAULT '' COMMENT '玩家名字',
  `price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '出价',
  `voucher` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '代金券数量',
  `payment_refs` text NOT NULL COMMENT '预付款引用',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`auction_id`,`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服1vn拍卖者记录 合服合并';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `kf_1vn_bidder`
--

LOCK TABLES `kf_1vn_bidder` WRITE;
/*!40000 ALTER TABLE `kf_1vn_bidder` DISABLE KEYS */;
/*!40000 ALTER TABLE `kf_1vn_bidder` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `kf_1vn_def_rank`
--

DROP TABLE IF EXISTS `kf_1vn_def_rank`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `kf_1vn_def_rank` (
  `area` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '战区',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服id',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服数',
  `server_name` varchar(50) NOT NULL DEFAULT '' COMMENT '服名',
  `name` varchar(200) NOT NULL DEFAULT '' COMMENT '玩家名字',
  `gname` varchar(200) NOT NULL DEFAULT '' COMMENT '玩家帮派名字',
  `vip` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家vip',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家积分',
  `turn` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家轮次',
  `combat_power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家战力',
  `career` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '玩家职业',
  `survival_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '存活时间',
  `lose` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否已经失败',
  PRIMARY KEY (`player_id`),
  KEY `rank` (`rank`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服1vn擂主排行榜，合服清空';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `kf_1vn_def_rank`
--

LOCK TABLES `kf_1vn_def_rank` WRITE;
/*!40000 ALTER TABLE `kf_1vn_def_rank` DISABLE KEYS */;
/*!40000 ALTER TABLE `kf_1vn_def_rank` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `kf_1vn_sign`
--

DROP TABLE IF EXISTS `kf_1vn_sign`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `kf_1vn_sign` (
  `id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '报名时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服1vn报名列表（本服）合服合并';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `kf_1vn_sign`
--

LOCK TABLES `kf_1vn_sign` WRITE;
/*!40000 ALTER TABLE `kf_1vn_sign` DISABLE KEYS */;
/*!40000 ALTER TABLE `kf_1vn_sign` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `kf_1vn_sign_center`
--

DROP TABLE IF EXISTS `kf_1vn_sign_center`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `kf_1vn_sign_center` (
  `id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服id',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家等级',
  `combat_power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家战斗力',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '玩家名',
  `server_name` varchar(50) NOT NULL DEFAULT '' COMMENT '服名',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '报名时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服1vn报名列表（跨服）合服合并';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `kf_1vn_sign_center`
--

LOCK TABLES `kf_1vn_sign_center` WRITE;
/*!40000 ALTER TABLE `kf_1vn_sign_center` DISABLE KEYS */;
/*!40000 ALTER TABLE `kf_1vn_sign_center` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `kf_3v3_rank`
--

DROP TABLE IF EXISTS `kf_3v3_rank`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `kf_3v3_rank` (
  `rank_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '名次',
  `server_name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '平台',
  `server_num` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '服号',
  `server_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '角色所在的服务器id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `nickname` varchar(50) NOT NULL DEFAULT '[]' COMMENT '昵称',
  `career` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '职业',
  `sex` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '性别',
  `lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '玩家等级',
  `vip_lv` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'VIP等级',
  `power` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '战力',
  `tier` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '段位',
  `star` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '星数',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  `season_pk` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '赛季参与次数',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上榜时间',
  PRIMARY KEY (`rank_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服3v3排行榜 合服保留';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `kf_3v3_rank`
--

LOCK TABLES `kf_3v3_rank` WRITE;
/*!40000 ALTER TABLE `kf_3v3_rank` DISABLE KEYS */;
/*!40000 ALTER TABLE `kf_3v3_rank` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `kf_boss_remind`
--

DROP TABLE IF EXISTS `kf_boss_remind`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `kf_boss_remind` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '所在服务器id',
  `boss_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '关注的boss',
  PRIMARY KEY (`role_id`,`server_id`,`boss_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服boss关注';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `kf_boss_remind`
--

LOCK TABLES `kf_boss_remind` WRITE;
/*!40000 ALTER TABLE `kf_boss_remind` DISABLE KEYS */;
/*!40000 ALTER TABLE `kf_boss_remind` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `kf_boss_revive`
--

DROP TABLE IF EXISTS `kf_boss_revive`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `kf_boss_revive` (
  `boss_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'boss_id',
  `revive_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '复活时间',
  `killer_server_id` int(11) unsigned NOT NULL COMMENT '击杀玩家服务器id',
  `killer_id` bigint(20) unsigned NOT NULL COMMENT '击杀玩家id',
  `killer_name` varchar(255) NOT NULL COMMENT '击杀玩家名',
  `killer_type` tinyint(2) unsigned NOT NULL COMMENT '击杀者类型（组队、单刷）',
  `killer_career` tinyint(2) unsigned NOT NULL COMMENT '击杀者职业',
  `killer_sex` tinyint(2) unsigned NOT NULL COMMENT '击杀者性别',
  `killer_turn` tinyint(2) unsigned NOT NULL COMMENT '击杀者转生次数',
  `killer_pic` varchar(255) NOT NULL COMMENT '击杀者头像地址',
  `killer_picver` int(11) unsigned NOT NULL COMMENT '击杀者头像版本号',
  PRIMARY KEY (`boss_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服boss复活时间';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `kf_boss_revive`
--

LOCK TABLES `kf_boss_revive` WRITE;
/*!40000 ALTER TABLE `kf_boss_revive` DISABLE KEYS */;
/*!40000 ALTER TABLE `kf_boss_revive` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `kf_cloud_buy`
--

DROP TABLE IF EXISTS `kf_cloud_buy`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `kf_cloud_buy` (
  `type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动类型',
  `subtype` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `server_id` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '服务器id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `product_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商品id',
  `buy_num` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '玩家购买份数',
  `win_num` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '中奖次数',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`type`,`subtype`,`role_id`,`product_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服云购(合跨服组清空)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `kf_cloud_buy`
--

LOCK TABLES `kf_cloud_buy` WRITE;
/*!40000 ALTER TABLE `kf_cloud_buy` DISABLE KEYS */;
/*!40000 ALTER TABLE `kf_cloud_buy` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `kf_cloud_buy_draw_record`
--

DROP TABLE IF EXISTS `kf_cloud_buy_draw_record`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `kf_cloud_buy_draw_record` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动主类型',
  `subtype` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `server_id` int(10) unsigned NOT NULL COMMENT '服务器id',
  `server_num` int(10) unsigned NOT NULL COMMENT '服务器标识',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `role_name` varchar(255) NOT NULL DEFAULT '' COMMENT '玩家名字',
  `product_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商品id',
  `reward_lv` varchar(255) NOT NULL COMMENT '奖励类型',
  `reward_list` varchar(255) NOT NULL COMMENT '奖励列表',
  `product_name` varchar(255) NOT NULL DEFAULT '' COMMENT '商品名字',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `type` (`type`),
  KEY `subtype` (`subtype`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服云购开奖记录(合并跨服组清空)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `kf_cloud_buy_draw_record`
--

LOCK TABLES `kf_cloud_buy_draw_record` WRITE;
/*!40000 ALTER TABLE `kf_cloud_buy_draw_record` DISABLE KEYS */;
/*!40000 ALTER TABLE `kf_cloud_buy_draw_record` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `kf_cloud_buy_purchase_record`
--

DROP TABLE IF EXISTS `kf_cloud_buy_purchase_record`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `kf_cloud_buy_purchase_record` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动主类型',
  `subtype` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `server_id` int(10) unsigned NOT NULL COMMENT '服务器id',
  `server_num` int(11) unsigned NOT NULL COMMENT '服务器标识',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `role_name` varchar(255) NOT NULL DEFAULT '' COMMENT '玩家名字',
  `product_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商品id',
  `product_name` varchar(255) NOT NULL DEFAULT '' COMMENT '商品名字',
  `buy_num` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '购买份数',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `type` (`type`),
  KEY `subtype` (`subtype`),
  KEY `time` (`time`),
  KEY `role_id` (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服云购购买记录(合跨服组清空)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `kf_cloud_buy_purchase_record`
--

LOCK TABLES `kf_cloud_buy_purchase_record` WRITE;
/*!40000 ALTER TABLE `kf_cloud_buy_purchase_record` DISABLE KEYS */;
/*!40000 ALTER TABLE `kf_cloud_buy_purchase_record` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `kf_common_rank_praise`
--

DROP TABLE IF EXISTS `kf_common_rank_praise`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `kf_common_rank_praise` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `server_id` int(11) unsigned NOT NULL COMMENT '服务器id',
  `praise_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '点赞数量',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服榜单点赞表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `kf_common_rank_praise`
--

LOCK TABLES `kf_common_rank_praise` WRITE;
/*!40000 ALTER TABLE `kf_common_rank_praise` DISABLE KEYS */;
/*!40000 ALTER TABLE `kf_common_rank_praise` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `kf_common_rank_role`
--

DROP TABLE IF EXISTS `kf_common_rank_role`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `kf_common_rank_role` (
  `rank_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排行榜类型',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `player_name` varchar(255) NOT NULL COMMENT '玩家名字',
  `vip_type` smallint(4) unsigned NOT NULL DEFAULT '0' COMMENT 'vip类型',
  `vip` smallint(4) unsigned NOT NULL DEFAULT '0' COMMENT 'vip等级',
  `guild_name` varchar(255) NOT NULL COMMENT '公会名',
  `career` tinyint(1) unsigned NOT NULL COMMENT '玩家职业',
  `turn` tinyint(1) unsigned NOT NULL COMMENT '转生次数',
  `server_id` int(11) unsigned NOT NULL COMMENT '服务器id',
  `server_num` int(11) unsigned NOT NULL COMMENT '服务器标识',
  `value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '值（保留）',
  `second_value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '值（保留）',
  `third_value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '值（保留）',
  `extra_value` varchar(512) NOT NULL DEFAULT '[]' COMMENT '额外值',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  UNIQUE KEY `rank` (`player_id`,`rank_type`),
  KEY `value` (`value`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服排行榜';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `kf_common_rank_role`
--

LOCK TABLES `kf_common_rank_role` WRITE;
/*!40000 ALTER TABLE `kf_common_rank_role` DISABLE KEYS */;
/*!40000 ALTER TABLE `kf_common_rank_role` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `kf_custom_act_opening`
--

DROP TABLE IF EXISTS `kf_custom_act_opening`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `kf_custom_act_opening` (
  `type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动主类型',
  `subtype` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `wlv` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动开始时的世界等级',
  `stime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动开始时间',
  `etime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动结束时间',
  PRIMARY KEY (`type`,`subtype`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='开启中的跨服定制活动数据(合跨服组清空)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `kf_custom_act_opening`
--

LOCK TABLES `kf_custom_act_opening` WRITE;
/*!40000 ALTER TABLE `kf_custom_act_opening` DISABLE KEYS */;
/*!40000 ALTER TABLE `kf_custom_act_opening` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `kf_invade_server`
--

DROP TABLE IF EXISTS `kf_invade_server`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `kf_invade_server` (
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器id',
  `world_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器等级',
  `score` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  PRIMARY KEY (`server_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服入侵服务器信息';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `kf_invade_server`
--

LOCK TABLES `kf_invade_server` WRITE;
/*!40000 ALTER TABLE `kf_invade_server` DISABLE KEYS */;
/*!40000 ALTER TABLE `kf_invade_server` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `kf_town_war`
--

DROP TABLE IF EXISTS `kf_town_war`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `kf_town_war` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '序号',
  `season_st_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '赛季开始时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服城战赛季表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `kf_town_war`
--

LOCK TABLES `kf_town_war` WRITE;
/*!40000 ALTER TABLE `kf_town_war` DISABLE KEYS */;
/*!40000 ALTER TABLE `kf_town_war` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `kf_town_war_apply`
--

DROP TABLE IF EXISTS `kf_town_war_apply`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `kf_town_war_apply` (
  `building_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '建筑id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `guild_name` varchar(50) NOT NULL DEFAULT '' COMMENT '公会名字',
  `ser_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器id',
  `ser_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器号',
  `chief_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '会长id',
  `assist` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '应援总额',
  PRIMARY KEY (`building_id`,`guild_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服城战宣战表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `kf_town_war_apply`
--

LOCK TABLES `kf_town_war_apply` WRITE;
/*!40000 ALTER TABLE `kf_town_war_apply` DISABLE KEYS */;
/*!40000 ALTER TABLE `kf_town_war_apply` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `kf_town_war_building`
--

DROP TABLE IF EXISTS `kf_town_war_building`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `kf_town_war_building` (
  `building_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '建筑id',
  `own_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '占据公会id',
  `own_name` varchar(50) NOT NULL DEFAULT '' COMMENT '占据公会名字',
  `own_ser_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '占据公会服务器id',
  `own_ser_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '占据公会服务器号',
  `chief_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '会长id',
  `chief_name` varchar(255) NOT NULL DEFAULT '' COMMENT '会长名字',
  `time` int(11) NOT NULL DEFAULT '0' COMMENT '占领时间',
  PRIMARY KEY (`building_id`,`own_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服城战领地占据表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `kf_town_war_building`
--

LOCK TABLES `kf_town_war_building` WRITE;
/*!40000 ALTER TABLE `kf_town_war_building` DISABLE KEYS */;
/*!40000 ALTER TABLE `kf_town_war_building` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `kf_town_war_role`
--

DROP TABLE IF EXISTS `kf_town_war_role`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `kf_town_war_role` (
  `role_id` bigint(20) unsigned NOT NULL,
  `own_reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '每日领取奖励',
  `shop_buy_list` varchar(512) NOT NULL DEFAULT '[]' COMMENT '商店购买列表',
  `assist_list` varchar(512) NOT NULL DEFAULT '[]' COMMENT '应援列表',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服城战玩家表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `kf_town_war_role`
--

LOCK TABLES `kf_town_war_role` WRITE;
/*!40000 ALTER TABLE `kf_town_war_role` DISABLE KEYS */;
/*!40000 ALTER TABLE `kf_town_war_role` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `kf_town_war_shop`
--

DROP TABLE IF EXISTS `kf_town_war_shop`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `kf_town_war_shop` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '序号',
  `goods_list` varchar(512) NOT NULL DEFAULT '[]' COMMENT '商品id列表',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服城战商店';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `kf_town_war_shop`
--

LOCK TABLES `kf_town_war_shop` WRITE;
/*!40000 ALTER TABLE `kf_town_war_shop` DISABLE KEYS */;
/*!40000 ALTER TABLE `kf_town_war_shop` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `light_weapon`
--

DROP TABLE IF EXISTS `light_weapon`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `light_weapon` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `equip_weapon_normal` smallint(5) unsigned NOT NULL COMMENT '专武幻化id',
  `equip_weapon_figure` smallint(5) unsigned NOT NULL COMMENT '光武幻化id',
  `equip_weapon_figure_star` smallint(5) unsigned NOT NULL COMMENT '光武幻化选择星数',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='光武-玩家幻化数据表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `light_weapon`
--

LOCK TABLES `light_weapon` WRITE;
/*!40000 ALTER TABLE `light_weapon` DISABLE KEYS */;
/*!40000 ALTER TABLE `light_weapon` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `light_weapon_figure`
--

DROP TABLE IF EXISTS `light_weapon_figure`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `light_weapon_figure` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '角色id',
  `weapon_id` smallint(5) unsigned NOT NULL COMMENT '光武id',
  `star` smallint(5) unsigned NOT NULL COMMENT '星级',
  PRIMARY KEY (`role_id`,`weapon_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='光武-玩家光武数据表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `light_weapon_figure`
--

LOCK TABLES `light_weapon_figure` WRITE;
/*!40000 ALTER TABLE `light_weapon_figure` DISABLE KEYS */;
/*!40000 ALTER TABLE `light_weapon_figure` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `light_weapon_normal`
--

DROP TABLE IF EXISTS `light_weapon_normal`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `light_weapon_normal` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '角色id',
  `weapon_id` smallint(5) unsigned NOT NULL COMMENT '专武id',
  `lv` int(11) unsigned NOT NULL COMMENT '等级',
  `exp` int(11) unsigned NOT NULL COMMENT '当前经验',
  `upgrade_list` varchar(512) NOT NULL COMMENT '提升列表[{物品id,物品数量},...]',
  PRIMARY KEY (`role_id`,`weapon_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='光武-玩家专武数据表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `light_weapon_normal`
--

LOCK TABLES `light_weapon_normal` WRITE;
/*!40000 ALTER TABLE `light_weapon_normal` DISABLE KEYS */;
/*!40000 ALTER TABLE `light_weapon_normal` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `limit_buy_daily_num`
--

DROP TABLE IF EXISTS `limit_buy_daily_num`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `limit_buy_daily_num` (
  `subtype` int(10) unsigned NOT NULL COMMENT '活动子类型',
  `grade` int(10) unsigned NOT NULL COMMENT '奖励档次',
  `daily_get_num` int(10) unsigned NOT NULL COMMENT '本服日购买数量',
  PRIMARY KEY (`subtype`,`grade`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='特惠商城日购买数量记录表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `limit_buy_daily_num`
--

LOCK TABLES `limit_buy_daily_num` WRITE;
/*!40000 ALTER TABLE `limit_buy_daily_num` DISABLE KEYS */;
/*!40000 ALTER TABLE `limit_buy_daily_num` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `limit_buy_daily_player`
--

DROP TABLE IF EXISTS `limit_buy_daily_player`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `limit_buy_daily_player` (
  `subtype` int(10) unsigned NOT NULL COMMENT '活动子类型',
  `grade` int(10) unsigned NOT NULL COMMENT '奖励档次',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `buy_num` int(10) unsigned NOT NULL COMMENT '次数',
  PRIMARY KEY (`subtype`,`grade`,`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='特惠商城玩家日购买数量记录表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `limit_buy_daily_player`
--

LOCK TABLES `limit_buy_daily_player` WRITE;
/*!40000 ALTER TABLE `limit_buy_daily_player` DISABLE KEYS */;
/*!40000 ALTER TABLE `limit_buy_daily_player` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `limit_goal_main`
--

DROP TABLE IF EXISTS `limit_goal_main`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `limit_goal_main` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `goal_id` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '目标id',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '奖励领取状态',
  `open_time` int(10) unsigned NOT NULL COMMENT '开放时间',
  PRIMARY KEY (`role_id`,`goal_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='限时目标主要目标数据';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `limit_goal_main`
--

LOCK TABLES `limit_goal_main` WRITE;
/*!40000 ALTER TABLE `limit_goal_main` DISABLE KEYS */;
/*!40000 ALTER TABLE `limit_goal_main` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `limit_goal_task`
--

DROP TABLE IF EXISTS `limit_goal_task`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `limit_goal_task` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `goal_id` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '目标id',
  `task_id` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '任务id',
  `progress` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '进度',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '奖励领取状态',
  `extra` varchar(255) NOT NULL DEFAULT '[]' COMMENT '附加数据',
  PRIMARY KEY (`role_id`,`goal_id`,`task_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='限时目标任务完成数据';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `limit_goal_task`
--

LOCK TABLES `limit_goal_task` WRITE;
/*!40000 ALTER TABLE `limit_goal_task` DISABLE KEYS */;
/*!40000 ALTER TABLE `limit_goal_task` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `limit_shop_sell`
--

DROP TABLE IF EXISTS `limit_shop_sell`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `limit_shop_sell` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `sell_id` int(10) unsigned NOT NULL COMMENT '商品id',
  `start_time` int(10) unsigned NOT NULL COMMENT '开始时间戳',
  `buy_num` int(10) unsigned NOT NULL COMMENT '已购买份数',
  PRIMARY KEY (`role_id`,`sell_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='神秘限购商品数据记录表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `limit_shop_sell`
--

LOCK TABLES `limit_shop_sell` WRITE;
/*!40000 ALTER TABLE `limit_shop_sell` DISABLE KEYS */;
/*!40000 ALTER TABLE `limit_shop_sell` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_3v3`
--

DROP TABLE IF EXISTS `log_3v3`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_3v3` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '1：战斗；2：周六继承',
  `old_tier` smallint(1) unsigned NOT NULL DEFAULT '0' COMMENT '战斗前段位',
  `old_star` smallint(1) unsigned NOT NULL DEFAULT '0' COMMENT '战斗前星数',
  `new_tier` smallint(1) unsigned NOT NULL DEFAULT '0' COMMENT '战斗后段位',
  `new_star` smallint(1) unsigned NOT NULL DEFAULT '0' COMMENT '战斗后星数',
  `result` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '1:胜利；2:失败',
  `honor` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '荣誉值',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='3v3日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_3v3`
--

LOCK TABLES `log_3v3` WRITE;
/*!40000 ALTER TABLE `log_3v3` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_3v3` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_3v3_pk_role`
--

DROP TABLE IF EXISTS `log_3v3_pk_role`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_3v3_pk_role` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `pk_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '战斗id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `name` varchar(100) NOT NULL DEFAULT '0' COMMENT '名字',
  `group` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '红蓝方',
  `old_tier` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战斗前段位',
  `old_star` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战斗前星数',
  `old_continued_win` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战斗前连胜',
  `new_tier` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战斗后段位',
  `new_star` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战斗后星数',
  `new_continued_win` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战斗后连胜',
  `kill` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '击杀次数',
  `killed` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '被击杀次数',
  `collect` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '采集神塔次数',
  `assist` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '助攻次数',
  `honor` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '光辉值',
  `is_mvp` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否mvp',
  `result` tinyint(4) unsigned NOT NULL DEFAULT '0' COMMENT '结果',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`),
  KEY `group` (`group`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='3v3战斗个人日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_3v3_pk_role`
--

LOCK TABLES `log_3v3_pk_role` WRITE;
/*!40000 ALTER TABLE `log_3v3_pk_role` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_3v3_pk_role` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_3v3_pk_room`
--

DROP TABLE IF EXISTS `log_3v3_pk_room`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_3v3_pk_room` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `scene_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '场景id',
  `scene_pool_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '场景池id',
  `room_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '房间id',
  `tower_data` varchar(2000) NOT NULL DEFAULT '[]' COMMENT '塔数据##[{怪物id,时间,组别}]',
  `pk_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '战斗id',
  `result` tinyint(1) unsigned DEFAULT '0' COMMENT '结果',
  `blue_name1` varchar(100) NOT NULL DEFAULT '' COMMENT '蓝方名字1',
  `blue_name2` varchar(100) NOT NULL DEFAULT '' COMMENT '蓝方名字2',
  `blue_name3` varchar(100) NOT NULL DEFAULT '' COMMENT '蓝方名字3',
  `blue_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '蓝方积分',
  `blue_tower_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '蓝方占领塔数',
  `red_name1` varchar(100) NOT NULL DEFAULT '' COMMENT '红方名字1',
  `red_name2` varchar(100) NOT NULL DEFAULT '' COMMENT '红方名字2',
  `red_name3` varchar(100) NOT NULL DEFAULT '' COMMENT '红方名字3',
  `red_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '红方积分',
  `red_tower_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '红方占领塔数',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `room_id` (`room_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='3v3战斗房间日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_3v3_pk_room`
--

LOCK TABLES `log_3v3_pk_room` WRITE;
/*!40000 ALTER TABLE `log_3v3_pk_room` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_3v3_pk_room` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_3v3_pk_team`
--

DROP TABLE IF EXISTS `log_3v3_pk_team`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_3v3_pk_team` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `pk_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '战斗id',
  `team_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '队伍id',
  `group` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '红蓝方',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  `kill` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '总击杀数',
  `killed` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '总被击杀数',
  `assist` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '总助攻次数',
  `result` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '结果',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `team_id` (`team_id`),
  KEY `group` (`group`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='3v3战斗队伍日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_3v3_pk_team`
--

LOCK TABLES `log_3v3_pk_team` WRITE;
/*!40000 ALTER TABLE `log_3v3_pk_team` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_3v3_pk_team` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_3v3_rank_reward`
--

DROP TABLE IF EXISTS `log_3v3_rank_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_3v3_rank_reward` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `rank_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `nickname` varchar(50) NOT NULL DEFAULT '[]' COMMENT '昵称',
  `tier` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '段位',
  `star` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '星数',
  `reward` varchar(3000) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='3v3榜单奖励日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_3v3_rank_reward`
--

LOCK TABLES `log_3v3_rank_reward` WRITE;
/*!40000 ALTER TABLE `log_3v3_rank_reward` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_3v3_rank_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_ac_start`
--

DROP TABLE IF EXISTS `log_ac_start`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_ac_start` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `module` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能Id',
  `module_sub` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '子功能Id',
  `ac_sub` int(11) NOT NULL DEFAULT '0' COMMENT '功能子类',
  `state` tinyint(11) NOT NULL DEFAULT '0' COMMENT '活动状态：1日历开启，2活动开启，3活动结束',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `module` (`module`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='活动开启通知';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_ac_start`
--

LOCK TABLES `log_ac_start` WRITE;
/*!40000 ALTER TABLE `log_ac_start` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_ac_start` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_achv`
--

DROP TABLE IF EXISTS `log_achv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_achv` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家等级',
  `achv_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '成就id',
  `time` int(11) NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='成就日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_achv`
--

LOCK TABLES `log_achv` WRITE;
/*!40000 ALTER TABLE `log_achv` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_achv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_act_boss`
--

DROP TABLE IF EXISTS `log_act_boss`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_act_boss` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `platform` varchar(50) NOT NULL DEFAULT '' COMMENT '平台',
  `server_id` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '服务器id',
  `avg_online_num` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '前三天平均在线人数',
  `boss_num` smallint(2) NOT NULL DEFAULT '0' COMMENT 'boss创建数量',
  `kill_num` smallint(2) NOT NULL DEFAULT '0' COMMENT 'boss被击杀数',
  `extra` varchar(255) NOT NULL DEFAULT '' COMMENT '附加信息',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='活动Boss日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_act_boss`
--

LOCK TABLES `log_act_boss` WRITE;
/*!40000 ALTER TABLE `log_act_boss` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_act_boss` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_act_boss_drop`
--

DROP TABLE IF EXISTS `log_act_boss_drop`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_act_boss_drop` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(10) unsigned NOT NULL COMMENT '角色id',
  `scene_id` int(10) unsigned NOT NULL COMMENT '场景id',
  `mon_id` bigint(10) unsigned NOT NULL COMMENT '怪物id',
  `mon_type` tinyint(2) unsigned NOT NULL COMMENT '怪物类型 （1boss 2采集怪）',
  `reward_list` varchar(255) NOT NULL COMMENT '奖励列表',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `mon_id` (`mon_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='活动boss-掉落日志表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_act_boss_drop`
--

LOCK TABLES `log_act_boss_drop` WRITE;
/*!40000 ALTER TABLE `log_act_boss_drop` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_act_boss_drop` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_active_dsgt`
--

DROP TABLE IF EXISTS `log_active_dsgt`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_active_dsgt` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `dsgt_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '称号id',
  `opr` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '操作',
  `time` int(11) NOT NULL DEFAULT '0' COMMENT '操作时间',
  `expire_time` int(11) NOT NULL DEFAULT '0' COMMENT '时效',
  `end_time` int(11) NOT NULL DEFAULT '0' COMMENT '结束时间',
  `return_money` varchar(255) NOT NULL DEFAULT '[]' COMMENT '补偿物品',
  PRIMARY KEY (`id`) USING BTREE,
  KEY `player_id` (`player_id`) USING BTREE,
  KEY `time` (`time`) USING BTREE,
  KEY `dsgt_id` (`dsgt_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='称号日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_active_dsgt`
--

LOCK TABLES `log_active_dsgt` WRITE;
/*!40000 ALTER TABLE `log_active_dsgt` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_active_dsgt` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_activity_live`
--

DROP TABLE IF EXISTS `log_activity_live`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_activity_live` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家等级',
  `power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战力',
  `ac_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动ID',
  `ac_sub` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动子ID',
  `ac_name` varchar(1024) NOT NULL DEFAULT '' COMMENT '活动名称',
  `live` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '获得活跃度',
  `old_live` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '完成前活跃度',
  `new_live` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '完成后活跃度',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `ac_id` (`ac_id`),
  KEY `ac_sub` (`ac_sub`),
  KEY `ac_name` (`ac_name`(255)),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='活跃度日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_activity_live`
--

LOCK TABLES `log_activity_live` WRITE;
/*!40000 ALTER TABLE `log_activity_live` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_activity_live` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_all_online`
--

DROP TABLE IF EXISTS `log_all_online`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_all_online` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色ID',
  `online_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '在线时长',
  `logout_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '退出时间',
  `last_login_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最近登录时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `logout_time` (`logout_time`),
  KEY `last_login_time` (`last_login_time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='在线时间日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_all_online`
--

LOCK TABLES `log_all_online` WRITE;
/*!40000 ALTER TABLE `log_all_online` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_all_online` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_auction_award`
--

DROP TABLE IF EXISTS `log_auction_award`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_auction_award` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `module_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `sub_module_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '子功能id',
  `auction_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖类型',
  `goods_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '竞拍道具id',
  `type_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '道具类型id',
  `goods_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '道具数量',
  `price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最终竞价',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '获得时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `guild_id` (`guild_id`),
  KEY `module_id` (`module_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='拍卖：获得竞拍日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_auction_award`
--

LOCK TABLES `log_auction_award` WRITE;
/*!40000 ALTER TABLE `log_auction_award` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_auction_award` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_auction_bonus`
--

DROP TABLE IF EXISTS `log_auction_bonus`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_auction_bonus` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `module_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `sub_module_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '子功能id',
  `money_list` varchar(128) NOT NULL DEFAULT '0' COMMENT '获得分红',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分红时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `guild_id` (`guild_id`),
  KEY `module_id` (`module_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='拍卖：分红日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_auction_bonus`
--

LOCK TABLES `log_auction_bonus` WRITE;
/*!40000 ALTER TABLE `log_auction_bonus` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_auction_bonus` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_auction_pay`
--

DROP TABLE IF EXISTS `log_auction_pay`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_auction_pay` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `module_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `sub_module_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '子功能id',
  `auction_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖类型',
  `goods_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '竞拍道具id',
  `type_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '道具类型id',
  `goods_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '道具数量',
  `pay_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '竞价类型',
  `price_list` varchar(128) NOT NULL DEFAULT '0' COMMENT '消耗货币',
  `price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '当前竞价',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '竞拍时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `guild_id` (`guild_id`),
  KEY `module_id` (`module_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='拍卖：竞拍日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_auction_pay`
--

LOCK TABLES `log_auction_pay` WRITE;
/*!40000 ALTER TABLE `log_auction_pay` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_auction_pay` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_auction_produce`
--

DROP TABLE IF EXISTS `log_auction_produce`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_auction_produce` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `module_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `sub_module_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '子功能id',
  `auction_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖类型',
  `auction_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖会场次id',
  `goods_list` varchar(2048) NOT NULL DEFAULT '0' COMMENT '产出物品',
  `bonus_tax_rate` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分红税率',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '产出时间',
  PRIMARY KEY (`id`),
  KEY `guild_id` (`guild_id`),
  KEY `module_id` (`module_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='拍卖：产出日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_auction_produce`
--

LOCK TABLES `log_auction_produce` WRITE;
/*!40000 ALTER TABLE `log_auction_produce` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_auction_produce` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_awakening`
--

DROP TABLE IF EXISTS `log_awakening`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_awakening` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `cell_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '命格类型',
  `cell` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '命格id',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星界觉醒日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_awakening`
--

LOCK TABLES `log_awakening` WRITE;
/*!40000 ALTER TABLE `log_awakening` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_awakening` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_baby_figure`
--

DROP TABLE IF EXISTS `log_baby_figure`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_baby_figure` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `figure_type` tinyint(1) unsigned NOT NULL COMMENT '幻化类型',
  `figure_name` varchar(255) NOT NULL COMMENT '幻化名称',
  `type` tinyint(1) unsigned NOT NULL COMMENT '操作类型',
  `expire_time` int(11) unsigned NOT NULL COMMENT '道具时限',
  `old_stage` smallint(5) unsigned NOT NULL COMMENT '之前阶数',
  `old_star` smallint(5) unsigned NOT NULL COMMENT '之前星数',
  `old_exp` int(11) unsigned NOT NULL COMMENT '之前经验值',
  `add_exp` int(11) unsigned NOT NULL COMMENT '增加经验值',
  `new_stage` smallint(5) unsigned NOT NULL COMMENT '当前阶数',
  `new_star` smallint(5) unsigned NOT NULL COMMENT '当前星数',
  `cost` varchar(512) NOT NULL COMMENT '消耗',
  `time` int(11) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `figure_type` (`figure_type`),
  KEY `type` (`type`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='宝宝幻化日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_baby_figure`
--

LOCK TABLES `log_baby_figure` WRITE;
/*!40000 ALTER TABLE `log_baby_figure` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_baby_figure` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_baby_up_grade`
--

DROP TABLE IF EXISTS `log_baby_up_grade`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_baby_up_grade` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `role_lv` smallint(5) unsigned NOT NULL COMMENT '玩家等级',
  `goods_id` bigint(20) unsigned NOT NULL COMMENT '物品id',
  `use_num` smallint(5) unsigned NOT NULL COMMENT '使用个数',
  `less_num` smallint(5) unsigned NOT NULL COMMENT '剩余个数上限',
  `old_attr` varchar(512) NOT NULL COMMENT '培养前属性',
  `new_attr` varchar(512) NOT NULL COMMENT '培养后属性',
  `time` int(11) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='宝宝养育日志表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_baby_up_grade`
--

LOCK TABLES `log_baby_up_grade` WRITE;
/*!40000 ALTER TABLE `log_baby_up_grade` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_baby_up_grade` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_baby_up_stage`
--

DROP TABLE IF EXISTS `log_baby_up_stage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_baby_up_stage` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `old_stage` smallint(5) unsigned NOT NULL COMMENT '之前阶数',
  `old_star` smallint(5) unsigned NOT NULL COMMENT '之前星数',
  `old_exp` int(11) unsigned NOT NULL COMMENT '之前经验值',
  `add_exp` int(11) unsigned NOT NULL COMMENT '增加经验值',
  `new_stage` smallint(5) unsigned NOT NULL COMMENT '当前阶数',
  `new_star` smallint(5) unsigned NOT NULL COMMENT '当前星数',
  `new_exp` int(11) unsigned NOT NULL COMMENT '当前经验',
  `cost` varchar(255) NOT NULL COMMENT '消耗',
  `time` int(11) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='宝宝升阶日志表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_baby_up_stage`
--

LOCK TABLES `log_baby_up_stage` WRITE;
/*!40000 ALTER TABLE `log_baby_up_stage` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_baby_up_stage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_ban`
--

DROP TABLE IF EXISTS `log_ban`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_ban` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `type` tinyint(1) NOT NULL COMMENT '类型：0：封号，1：IP黑名单，3：禁头像/禁言，4：解除禁言，5：删除头像',
  `object` varchar(2000) NOT NULL COMMENT '对象',
  `description` varchar(100) NOT NULL COMMENT '描述',
  `time` int(10) NOT NULL COMMENT '时间',
  `admin` varchar(50) NOT NULL COMMENT '操作管理员',
  PRIMARY KEY (`id`),
  KEY `time` (`time`),
  KEY `type` (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='查封日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_ban`
--

LOCK TABLES `log_ban` WRITE;
/*!40000 ALTER TABLE `log_ban` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_ban` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_bonfire_buy_dinner`
--

DROP TABLE IF EXISTS `log_bonfire_buy_dinner`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_bonfire_buy_dinner` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '购买类型',
  `cost` varchar(50) NOT NULL DEFAULT '[]' COMMENT '消耗内容',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会篝火购买晚宴日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_bonfire_buy_dinner`
--

LOCK TABLES `log_bonfire_buy_dinner` WRITE;
/*!40000 ALTER TABLE `log_bonfire_buy_dinner` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_bonfire_buy_dinner` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_boss`
--

DROP TABLE IF EXISTS `log_boss`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_boss` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `boss_type` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '首领类型',
  `boss_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'bossid',
  `kill_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '击杀玩家id',
  `bl_id` varchar(255) NOT NULL DEFAULT '[]' COMMENT '首领归属',
  `top_hurt_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '伤害最高玩家id',
  `kill_list` text NOT NULL COMMENT '伤害列表',
  `time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `boss_id` (`boss_id`),
  KEY `kill_id` (`kill_id`),
  KEY `time` (`time`),
  KEY `bl_id` (`bl_id`),
  KEY `boss_type` (`boss_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='boss击杀归属日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_boss`
--

LOCK TABLES `log_boss` WRITE;
/*!40000 ALTER TABLE `log_boss` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_boss` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_boss_drop`
--

DROP TABLE IF EXISTS `log_boss_drop`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_boss_drop` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `boss_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'boss_id',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品id',
  `goods_info` varchar(255) NOT NULL DEFAULT '[]' COMMENT '属性',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='boss掉落日志表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_boss_drop`
--

LOCK TABLES `log_boss_drop` WRITE;
/*!40000 ALTER TABLE `log_boss_drop` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_boss_drop` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_boss_enter_type`
--

DROP TABLE IF EXISTS `log_boss_enter_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_boss_enter_type` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `boss_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'boss类型',
  `boss_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'bossid',
  `scene` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '场景id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战力',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='boss进入状态日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_boss_enter_type`
--

LOCK TABLES `log_boss_enter_type` WRITE;
/*!40000 ALTER TABLE `log_boss_enter_type` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_boss_enter_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_boss_rank_reward`
--

DROP TABLE IF EXISTS `log_boss_rank_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_boss_rank_reward` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战力',
  `boss_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'boss类型',
  `boss_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'boss_id',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '奖励内容',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='boss排名日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_boss_rank_reward`
--

LOCK TABLES `log_boss_rank_reward` WRITE;
/*!40000 ALTER TABLE `log_boss_rank_reward` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_boss_rank_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_boss_reborn`
--

DROP TABLE IF EXISTS `log_boss_reborn`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_boss_reborn` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `boss_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'bossid',
  `boss_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'boss类型',
  `scene` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '出生场景',
  `pool_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '进程池id',
  `copy_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '房间id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `boss_id` (`boss_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='boss刷新日志表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_boss_reborn`
--

LOCK TABLES `log_boss_reborn` WRITE;
/*!40000 ALTER TABLE `log_boss_reborn` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_boss_reborn` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_butterfly`
--

DROP TABLE IF EXISTS `log_butterfly`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_butterfly` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `room_id` varchar(255) NOT NULL COMMENT '房间号',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `integration` int(11) unsigned NOT NULL COMMENT '积分',
  `rank` smallint(5) unsigned NOT NULL COMMENT '排名',
  `goods` varchar(255) NOT NULL COMMENT '奖励',
  `time` bigint(20) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='捕蝶日志表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_butterfly`
--

LOCK TABLES `log_butterfly` WRITE;
/*!40000 ALTER TABLE `log_butterfly` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_butterfly` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_butterfly_integeration`
--

DROP TABLE IF EXISTS `log_butterfly_integeration`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_butterfly_integeration` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(10) unsigned NOT NULL COMMENT '角色id',
  `stage_id` int(10) unsigned NOT NULL COMMENT '阶段id',
  `reward` varchar(512) NOT NULL COMMENT '阶段奖励',
  `integeration` int(10) unsigned NOT NULL COMMENT '当前积分',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='捕蝶日志-积分奖励表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_butterfly_integeration`
--

LOCK TABLES `log_butterfly_integeration` WRITE;
/*!40000 ALTER TABLE `log_butterfly_integeration` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_butterfly_integeration` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_butterfly_turntable`
--

DROP TABLE IF EXISTS `log_butterfly_turntable`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_butterfly_turntable` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(10) unsigned NOT NULL COMMENT '角色id',
  `reward` varchar(512) NOT NULL COMMENT '奖励',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='捕蝶日志-转盘奖励';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_butterfly_turntable`
--

LOCK TABLES `log_butterfly_turntable` WRITE;
/*!40000 ALTER TABLE `log_butterfly_turntable` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_butterfly_turntable` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_buy_fishing_gear`
--

DROP TABLE IF EXISTS `log_buy_fishing_gear`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_buy_fishing_gear` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `role_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '角色等级',
  `vip_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '贵族等级',
  `fishing_gear` varchar(128) NOT NULL DEFAULT '[]' COMMENT '渔具',
  `cost` varchar(128) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='购买渔具日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_buy_fishing_gear`
--

LOCK TABLES `log_buy_fishing_gear` WRITE;
/*!40000 ALTER TABLE `log_buy_fishing_gear` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_buy_fishing_gear` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_capsule_toys`
--

DROP TABLE IF EXISTS `log_capsule_toys`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_capsule_toys` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动类型',
  `sub_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '子类型',
  `w_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '世界等级',
  `draw_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '抽奖类型',
  `reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `cost` varchar(256) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='超级扭蛋奖励日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_capsule_toys`
--

LOCK TABLES `log_capsule_toys` WRITE;
/*!40000 ALTER TABLE `log_capsule_toys` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_capsule_toys` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_charm_beach`
--

DROP TABLE IF EXISTS `log_charm_beach`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_charm_beach` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_server_id` int(11) NOT NULL DEFAULT '0' COMMENT '玩家服务器',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '操作类型',
  `cost_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消费列表',
  `num` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '操作次数',
  `other_server_id` int(11) NOT NULL DEFAULT '0' COMMENT '对方玩家服务器',
  `other_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '对方玩家id',
  `other_name` varchar(20) NOT NULL DEFAULT '""' COMMENT '对方玩家名字',
  `old_charm_value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作前对方魅力值',
  `new_charm_value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作后对方魅力值',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `type` (`type`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='海滩消费记录';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_charm_beach`
--

LOCK TABLES `log_charm_beach` WRITE;
/*!40000 ALTER TABLE `log_charm_beach` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_charm_beach` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_charm_beach_charmv`
--

DROP TABLE IF EXISTS `log_charm_beach_charmv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_charm_beach_charmv` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `server_id` int(10) unsigned NOT NULL COMMENT '服务器id',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `role_name` varchar(50) NOT NULL COMMENT '玩家名',
  `charm_v` int(10) unsigned NOT NULL COMMENT '魅力值',
  `rank` smallint(5) unsigned NOT NULL COMMENT '魅力值排名',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='海滩魅力值排名（跨服）';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_charm_beach_charmv`
--

LOCK TABLES `log_charm_beach_charmv` WRITE;
/*!40000 ALTER TABLE `log_charm_beach_charmv` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_charm_beach_charmv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_charm_beach_exp`
--

DROP TABLE IF EXISTS `log_charm_beach_exp`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_charm_beach_exp` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `server_id` int(10) unsigned NOT NULL COMMENT '服务器id',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `role_name` varchar(50) NOT NULL COMMENT '玩家名字',
  `lv` smallint(5) unsigned NOT NULL COMMENT '玩家等级',
  `vip_lv` tinyint(3) unsigned NOT NULL COMMENT 'vip等级',
  `type` tinyint(3) unsigned NOT NULL COMMENT '类型##0海滩经验 其它为送礼id',
  `opp_server_id` int(10) unsigned NOT NULL COMMENT '对象服务器id',
  `opp_id` bigint(20) unsigned NOT NULL COMMENT '对象id',
  `opp_name` varchar(50) NOT NULL COMMENT '对象名称',
  `opp_vip` tinyint(3) unsigned NOT NULL COMMENT '对象vip等级',
  `exp` int(10) unsigned NOT NULL COMMENT '获得经验',
  `acc_exp` bigint(20) unsigned NOT NULL COMMENT '本次累计经验',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='海滩经验日志（跨服）';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_charm_beach_exp`
--

LOCK TABLES `log_charm_beach_exp` WRITE;
/*!40000 ALTER TABLE `log_charm_beach_exp` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_charm_beach_exp` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_cloud_buy_kf`
--

DROP TABLE IF EXISTS `log_cloud_buy_kf`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_cloud_buy_kf` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `order_id` int(10) unsigned NOT NULL COMMENT '订单号',
  `role_uid` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `role_name` varchar(50) NOT NULL COMMENT '玩家名',
  `platform` varchar(50) NOT NULL COMMENT '平台',
  `server_num` smallint(5) unsigned NOT NULL COMMENT '服务器编号',
  `count` smallint(5) unsigned NOT NULL COMMENT '数量',
  `event` tinyint(3) unsigned NOT NULL COMMENT '事件 1创建 2中奖',
  `subtype` int(10) unsigned NOT NULL COMMENT '活动子类型',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='众仙云购日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_cloud_buy_kf`
--

LOCK TABLES `log_cloud_buy_kf` WRITE;
/*!40000 ALTER TABLE `log_cloud_buy_kf` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_cloud_buy_kf` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_collect_put`
--

DROP TABLE IF EXISTS `log_collect_put`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_collect_put` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `subtype` int(10) unsigned NOT NULL COMMENT '活动子类型',
  `all_reward_id` int(10) unsigned NOT NULL COMMENT '全服奖励id',
  `all_reward_type` int(10) unsigned NOT NULL COMMENT '全服奖励类型（0没有 1经验双倍 2副本双倍 3首领重置 4物品奖励）',
  `new_all_point` int(10) unsigned NOT NULL COMMENT '提交后全服提交量',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '触发的玩家id',
  `put_type` int(10) unsigned NOT NULL COMMENT '提交类型（1钻石 2物品）',
  `self_reward_id` int(10) unsigned NOT NULL COMMENT '个人奖励id',
  `self_reward_type` int(10) unsigned NOT NULL COMMENT '个人奖励类型（1普通 2累计）',
  `new_self_point` int(10) unsigned NOT NULL COMMENT '提交后个人提交量',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='收集活动提交信息日志表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_collect_put`
--

LOCK TABLES `log_collect_put` WRITE;
/*!40000 ALTER TABLE `log_collect_put` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_collect_put` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_combat_uplv`
--

DROP TABLE IF EXISTS `log_combat_uplv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_combat_uplv` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `lv` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '玩家等级',
  `career` varchar(50) NOT NULL COMMENT '职业',
  `vip_lv` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'vip等级',
  `combat_power` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '总战力值',
  `module_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `module_power` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '功能战力值',
  `log_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '记录时间',
  PRIMARY KEY (`id`),
  KEY `idx_id_lv` (`role_id`,`lv`),
  KEY `idx_time` (`log_time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='战力构成日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_combat_uplv`
--

LOCK TABLES `log_combat_uplv` WRITE;
/*!40000 ALTER TABLE `log_combat_uplv` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_combat_uplv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_come_back`
--

DROP TABLE IF EXISTS `log_come_back`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_come_back` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `account` varchar(64) NOT NULL COMMENT '渠道账号',
  `source` varchar(50) NOT NULL DEFAULT '' COMMENT '渠道来源',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '返利玩家Id',
  `nickname` varchar(50) NOT NULL DEFAULT '[]' COMMENT '返利玩家名',
  `lv` smallint(2) unsigned NOT NULL DEFAULT '1' COMMENT '返利等级',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器id',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器编号',
  `old_gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '删测充值钻石',
  `return_list` varchar(128) NOT NULL DEFAULT '[]' COMMENT '返利列表',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作时间',
  PRIMARY KEY (`id`),
  KEY `account` (`account`),
  KEY `player_id` (`player_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='删测回归返利日志(合跨服直接合并)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_come_back`
--

LOCK TABLES `log_come_back` WRITE;
/*!40000 ALTER TABLE `log_come_back` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_come_back` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_common_rank_guild`
--

DROP TABLE IF EXISTS `log_common_rank_guild`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_common_rank_guild` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '第一公会ID',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '值',
  `sec_guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '第二公会id',
  `sec_value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '值',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会榜结算日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_common_rank_guild`
--

LOCK TABLES `log_common_rank_guild` WRITE;
/*!40000 ALTER TABLE `log_common_rank_guild` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_common_rank_guild` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_common_rank_role`
--

DROP TABLE IF EXISTS `log_common_rank_role`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_common_rank_role` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '第一名玩家ID',
  `rank_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排行榜类型',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '值',
  `sec_role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '第二名玩家id',
  `sec_value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '第二名的值',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `rank_type` (`rank_type`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='通用榜单结算日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_common_rank_role`
--

LOCK TABLES `log_common_rank_role` WRITE;
/*!40000 ALTER TABLE `log_common_rank_role` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_common_rank_role` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_consume_coin`
--

DROP TABLE IF EXISTS `log_consume_coin`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_consume_coin` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消费时间',
  `consume_type` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '消费类型，1为购买',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色ID',
  `goods_id` bigint(20) unsigned DEFAULT '0' COMMENT '物品id',
  `goods_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品数量',
  `cost_coin` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消耗铜钱',
  `remain_coin` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '铜钱余额',
  `about` text NOT NULL COMMENT '消费内容',
  `lv` smallint(6) unsigned NOT NULL DEFAULT '0' COMMENT '玩家等级',
  `vip_lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'vip等级',
  PRIMARY KEY (`id`),
  KEY `consume_type` (`consume_type`),
  KEY `player_id` (`player_id`),
  KEY `goods_id` (`goods_id`),
  KEY `lv` (`lv`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='铜钱消费日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_consume_coin`
--

LOCK TABLES `log_consume_coin` WRITE;
/*!40000 ALTER TABLE `log_consume_coin` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_consume_coin` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_consume_currency`
--

DROP TABLE IF EXISTS `log_consume_currency`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_consume_currency` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `player_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '角色等级',
  `vip_lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'vip等级',
  `type` smallint(5) unsigned NOT NULL COMMENT '产出类型',
  `currency_id` int(10) unsigned NOT NULL COMMENT '货币id',
  `value` int(10) unsigned NOT NULL COMMENT '消耗数量',
  `remain_value` int(10) unsigned NOT NULL COMMENT '剩余数量',
  `remark` varchar(255) NOT NULL DEFAULT '' COMMENT '备注',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='特殊货币消耗日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_consume_currency`
--

LOCK TABLES `log_consume_currency` WRITE;
/*!40000 ALTER TABLE `log_consume_currency` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_consume_currency` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_consume_exp`
--

DROP TABLE IF EXISTS `log_consume_exp`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_consume_exp` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消费时间',
  `consume_type` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '消费类型',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色ID',
  `lv` smallint(6) unsigned NOT NULL DEFAULT '0' COMMENT '玩家等级',
  `cost_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消耗经验',
  `remain_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '经验余额',
  `about` text NOT NULL COMMENT '消费内容',
  PRIMARY KEY (`id`),
  KEY `consume_type` (`consume_type`),
  KEY `player_id` (`player_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='经验消费日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_consume_exp`
--

LOCK TABLES `log_consume_exp` WRITE;
/*!40000 ALTER TABLE `log_consume_exp` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_consume_exp` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_consume_gdonate`
--

DROP TABLE IF EXISTS `log_consume_gdonate`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_consume_gdonate` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `consume_type` smallint(2) NOT NULL DEFAULT '0' COMMENT '消耗类型',
  `cost_donate` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消耗贡献',
  `remain_donate` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '剩余贡献',
  `extra` varchar(255) NOT NULL DEFAULT '' COMMENT '附加信息',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`),
  KEY `role_id` (`role_id`),
  KEY `consume_type` (`consume_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会贡献消耗日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_consume_gdonate`
--

LOCK TABLES `log_consume_gdonate` WRITE;
/*!40000 ALTER TABLE `log_consume_gdonate` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_consume_gdonate` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_consume_gfunds`
--

DROP TABLE IF EXISTS `log_consume_gfunds`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_consume_gfunds` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `guild_id` bigint(20) unsigned NOT NULL COMMENT '公会id',
  `consume_type` smallint(11) unsigned NOT NULL DEFAULT '0' COMMENT '消耗类型',
  `cost_gfunds` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消耗资金',
  `remain_gfunds` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '剩余资金',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `guild_id` (`guild_id`),
  KEY `time` (`time`),
  KEY `role_id` (`role_id`),
  KEY `consume_type` (`consume_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会资金消耗日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_consume_gfunds`
--

LOCK TABLES `log_consume_gfunds` WRITE;
/*!40000 ALTER TABLE `log_consume_gfunds` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_consume_gfunds` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_consume_gold`
--

DROP TABLE IF EXISTS `log_consume_gold`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_consume_gold` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消费时间',
  `consume_type` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '消费类型，1为购买',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色ID',
  `goods_id` bigint(20) unsigned DEFAULT '0' COMMENT '物品id',
  `goods_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品数量',
  `cost_gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消耗金币',
  `cost_bgold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消耗银两',
  `cost_fgold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消耗粉钻',
  `remain_gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '金币余额',
  `remain_bgold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '银两余额',
  `remain_fgold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '粉钻余额',
  `about` text NOT NULL COMMENT '消费内容',
  `lv` smallint(6) unsigned NOT NULL DEFAULT '0' COMMENT '玩家等级',
  `vip_lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'vip等级',
  PRIMARY KEY (`id`),
  KEY `consume_type` (`consume_type`),
  KEY `player_id` (`player_id`),
  KEY `goods_id` (`goods_id`),
  KEY `time` (`time`),
  KEY `lv` (`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='元宝消费日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_consume_gold`
--

LOCK TABLES `log_consume_gold` WRITE;
/*!40000 ALTER TABLE `log_consume_gold` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_consume_gold` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_consume_growth`
--

DROP TABLE IF EXISTS `log_consume_growth`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_consume_growth` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `consume_type` smallint(2) NOT NULL DEFAULT '0' COMMENT '消耗类型',
  `cost_growth` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消耗公会成长值',
  `remain_growth` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '剩余公会成长值',
  `extra` varchar(255) NOT NULL DEFAULT '' COMMENT '附加信息',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`),
  KEY `role_id` (`role_id`),
  KEY `consume_type` (`consume_type`),
  KEY `guild_id` (`guild_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会成长值消耗日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_consume_growth`
--

LOCK TABLES `log_consume_growth` WRITE;
/*!40000 ALTER TABLE `log_consume_growth` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_consume_growth` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_cost_honour`
--

DROP TABLE IF EXISTS `log_cost_honour`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_cost_honour` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `player_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `type` smallint(5) unsigned NOT NULL COMMENT '产出类型',
  `old_value` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '旧数量',
  `new_value` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '新数量',
  `cost_value` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '消耗数量',
  `remark` varchar(255) NOT NULL DEFAULT '' COMMENT '备注',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `time` (`time`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='荣誉值消耗日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_cost_honour`
--

LOCK TABLES `log_cost_honour` WRITE;
/*!40000 ALTER TABLE `log_cost_honour` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_cost_honour` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_custom_act`
--

DROP TABLE IF EXISTS `log_custom_act`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_custom_act` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动主类型',
  `subtype` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `wlv` smallint(2) unsigned DEFAULT '0' COMMENT '世界等级',
  `stime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动开始时间',
  `etime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动结束时间',
  `state` tinyint(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动状态：0:活动结束，1:活动开启 2:手动关闭活动',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `type` (`type`),
  KEY `subtype` (`subtype`),
  KEY `state` (`state`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='定制活动开启结束日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_custom_act`
--

LOCK TABLES `log_custom_act` WRITE;
/*!40000 ALTER TABLE `log_custom_act` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_custom_act` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_custom_act_hi_point`
--

DROP TABLE IF EXISTS `log_custom_act_hi_point`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_custom_act_hi_point` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `old_score` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '旧的积分',
  `add_score` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '增加的积分',
  `new_score` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '新的积分',
  `module` varchar(255) NOT NULL DEFAULT '' COMMENT '模块名',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='活动积分日志表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_custom_act_hi_point`
--

LOCK TABLES `log_custom_act_hi_point` WRITE;
/*!40000 ALTER TABLE `log_custom_act_hi_point` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_custom_act_hi_point` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_custom_act_reward`
--

DROP TABLE IF EXISTS `log_custom_act_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_custom_act_reward` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `type` smallint(3) unsigned NOT NULL DEFAULT '0' COMMENT '活动主类型',
  `subtype` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `grade` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '奖励档次',
  `wlv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '世界等级',
  `reward` varchar(255) NOT NULL DEFAULT '' COMMENT '奖励',
  `extra` varchar(255) NOT NULL DEFAULT '' COMMENT '附加信息',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `type` (`type`),
  KEY `subtype` (`subtype`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='定制活动通用奖励日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_custom_act_reward`
--

LOCK TABLES `log_custom_act_reward` WRITE;
/*!40000 ALTER TABLE `log_custom_act_reward` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_custom_act_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_daily_checkin`
--

DROP TABLE IF EXISTS `log_daily_checkin`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_daily_checkin` (
  `seq` bigint(20) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `player_id` bigint(20) NOT NULL COMMENT '玩家id',
  `vip_lv` int(11) NOT NULL COMMENT 'vip等级',
  `retro` int(2) NOT NULL COMMENT '是否补签 2-补签 1-签到',
  `day` int(8) NOT NULL COMMENT '每月第几天',
  `rewards_output` varchar(1024) NOT NULL COMMENT '物品产出',
  `time` int(30) NOT NULL COMMENT '时间',
  PRIMARY KEY (`seq`,`player_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='每日签到日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_daily_checkin`
--

LOCK TABLES `log_daily_checkin` WRITE;
/*!40000 ALTER TABLE `log_daily_checkin` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_daily_checkin` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_daily_gift`
--

DROP TABLE IF EXISTS `log_daily_gift`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_daily_gift` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `produce_type` varchar(256) NOT NULL DEFAULT '[]' COMMENT '礼包类型',
  `goods_id` int(11) NOT NULL DEFAULT '0' COMMENT '获得道具id',
  `time` int(11) NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `produce_type` (`produce_type`(255)),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='每日礼包日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_daily_gift`
--

LOCK TABLES `log_daily_gift` WRITE;
/*!40000 ALTER TABLE `log_daily_gift` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_daily_gift` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_deity_up`
--

DROP TABLE IF EXISTS `log_deity_up`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_deity_up` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `player_name` varchar(255) NOT NULL DEFAULT '' COMMENT '玩家名称',
  `before_deity` varchar(255) NOT NULL DEFAULT '' COMMENT '晋升前神格',
  `after_deity` varchar(255) NOT NULL DEFAULT '' COMMENT '晋升后神格',
  `attr` varchar(255) NOT NULL COMMENT '神格属性',
  `cost` varchar(255) NOT NULL DEFAULT '' COMMENT '晋升消耗',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='神格升级日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_deity_up`
--

LOCK TABLES `log_deity_up` WRITE;
/*!40000 ALTER TABLE `log_deity_up` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_deity_up` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_dress_illu_lv`
--

DROP TABLE IF EXISTS `log_dress_illu_lv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_dress_illu_lv` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `pre_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作前等级',
  `pre_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作前经验',
  `after_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作后等级',
  `after_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作后经验',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗材料',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`) USING BTREE,
  KEY `role_id` (`role_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装扮图鉴升级日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_dress_illu_lv`
--

LOCK TABLES `log_dress_illu_lv` WRITE;
/*!40000 ALTER TABLE `log_dress_illu_lv` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_dress_illu_lv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_dress_star`
--

DROP TABLE IF EXISTS `log_dress_star`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_dress_star` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `dress_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '装扮类型(1泡泡, 2相框)',
  `dress_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '装扮id',
  `dress_star` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '装扮星级',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '经验',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗材料',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`) USING BTREE,
  KEY `role_id` (`role_id`) USING BTREE,
  KEY `dress_id` (`dress_id`) USING BTREE,
  KEY `dress_type` (`dress_type`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装扮激活升星日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_dress_star`
--

LOCK TABLES `log_dress_star` WRITE;
/*!40000 ALTER TABLE `log_dress_star` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_dress_star` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_drum_cost`
--

DROP TABLE IF EXISTS `log_drum_cost`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_drum_cost` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `cost` varchar(1024) NOT NULL COMMENT '消耗',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='钻石大战钻石消耗日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_drum_cost`
--

LOCK TABLES `log_drum_cost` WRITE;
/*!40000 ALTER TABLE `log_drum_cost` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_drum_cost` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_drum_refuce`
--

DROP TABLE IF EXISTS `log_drum_refuce`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_drum_refuce` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `node` varchar(512) NOT NULL DEFAULT '' COMMENT '节点名',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `sid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器id',
  `power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战力',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='钻石大战取消资格表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_drum_refuce`
--

LOCK TABLES `log_drum_refuce` WRITE;
/*!40000 ALTER TABLE `log_drum_refuce` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_drum_refuce` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_drum_refuce_mail`
--

DROP TABLE IF EXISTS `log_drum_refuce_mail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_drum_refuce_mail` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='钻石大战邮件发送记录表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_drum_refuce_mail`
--

LOCK TABLES `log_drum_refuce_mail` WRITE;
/*!40000 ALTER TABLE `log_drum_refuce_mail` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_drum_refuce_mail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_drum_sign`
--

DROP TABLE IF EXISTS `log_drum_sign`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_drum_sign` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(512) NOT NULL DEFAULT '' COMMENT '名字',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='钻石大战报名日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_drum_sign`
--

LOCK TABLES `log_drum_sign` WRITE;
/*!40000 ALTER TABLE `log_drum_sign` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_drum_sign` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_drum_war`
--

DROP TABLE IF EXISTS `log_drum_war`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_drum_war` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `drum` int(11) NOT NULL DEFAULT '0' COMMENT '期/届',
  `zone` int(11) NOT NULL DEFAULT '0' COMMENT '战区',
  `war` int(11) NOT NULL DEFAULT '0' COMMENT '场数',
  `wid` bigint(20) NOT NULL DEFAULT '0' COMMENT '胜方',
  `wname` varchar(50) NOT NULL DEFAULT '' COMMENT '名称',
  `wsid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器id',
  `wform` varchar(50) NOT NULL DEFAULT '[]' COMMENT '胜平台',
  `wnum` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '胜服号',
  `wlive` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '胜命数',
  `wpower` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '胜战力',
  `fid` bigint(20) NOT NULL DEFAULT '0' COMMENT '负方',
  `fname` varchar(50) NOT NULL DEFAULT '' COMMENT '名称',
  `fsid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器id',
  `fform` varchar(50) NOT NULL DEFAULT '[]' COMMENT '负平台',
  `fnum` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '负服号',
  `flive` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '负命数',
  `fpower` int(11) unsigned DEFAULT '0' COMMENT '负战力',
  `result` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '胜负类型1胜2负3轮空4超时',
  `time` int(11) unsigned DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`),
  KEY `wid` (`wid`),
  KEY `fid` (`fid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_drum_war`
--

LOCK TABLES `log_drum_war` WRITE;
/*!40000 ALTER TABLE `log_drum_war` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_drum_war` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_dsgt`
--

DROP TABLE IF EXISTS `log_dsgt`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_dsgt` (
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '称号ID',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '激活时间',
  `endtime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '结束时间',
  KEY `player_id` (`player_id`),
  KEY `id` (`id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='称号激活日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_dsgt`
--

LOCK TABLES `log_dsgt` WRITE;
/*!40000 ALTER TABLE `log_dsgt` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_dsgt` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_dstone_uplv`
--

DROP TABLE IF EXISTS `log_dstone_uplv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_dstone_uplv` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `equip_pos` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '装备位置',
  `stone_pos` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '镶嵌位置',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗材料',
  `pre_lv` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '前置等级',
  `now_lv` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '升级后等级',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='双属性宝石升级日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_dstone_uplv`
--

LOCK TABLES `log_dstone_uplv` WRITE;
/*!40000 ALTER TABLE `log_dstone_uplv` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_dstone_uplv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_dstone_upstage`
--

DROP TABLE IF EXISTS `log_dstone_upstage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_dstone_upstage` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `goods_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '宝石id',
  `equip_pos` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '装备位置',
  `stone_pos` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '镶嵌位置',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗材料',
  `pre_stage` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '前置阶数',
  `now_stage` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '升阶后阶数',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='双属性宝石升阶日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_dstone_upstage`
--

LOCK TABLES `log_dstone_upstage` WRITE;
/*!40000 ALTER TABLE `log_dstone_upstage` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_dstone_upstage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_dungeon_seal_soul`
--

DROP TABLE IF EXISTS `log_dungeon_seal_soul`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_dungeon_seal_soul` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `wave_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最高层数',
  `now_wave_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '当前层数',
  `got_reward` text NOT NULL COMMENT '已领取阶段奖励',
  `daily_reward` text NOT NULL COMMENT '已领取每日目标奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='魂珠副本日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_dungeon_seal_soul`
--

LOCK TABLES `log_dungeon_seal_soul` WRITE;
/*!40000 ALTER TABLE `log_dungeon_seal_soul` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_dungeon_seal_soul` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_equip_build_pink`
--

DROP TABLE IF EXISTS `log_equip_build_pink`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_equip_build_pink` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `config_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '合成ID',
  `build_goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '目标装备ID',
  `main_goods_list` varchar(512) NOT NULL DEFAULT '[]' COMMENT '主材料',
  `assist_goods_list` varchar(512) NOT NULL DEFAULT '[]' COMMENT '辅助材料',
  `regular_goods_list` varchar(512) NOT NULL DEFAULT '[]' COMMENT '固定材料',
  `result` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '打造结果',
  `is_swap` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否替换装备',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='神装打造日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_equip_build_pink`
--

LOCK TABLES `log_equip_build_pink` WRITE;
/*!40000 ALTER TABLE `log_equip_build_pink` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_equip_build_pink` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_equip_devour`
--

DROP TABLE IF EXISTS `log_equip_devour`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_equip_devour` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(10) unsigned NOT NULL COMMENT '玩家id',
  `devour_list` varchar(2048) NOT NULL COMMENT '吞噬装备列表',
  `add_exp` int(10) unsigned NOT NULL COMMENT '获得经验值',
  `new_lv` int(10) unsigned NOT NULL COMMENT '吞噬后等级',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备吞噬日志表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_equip_devour`
--

LOCK TABLES `log_equip_devour` WRITE;
/*!40000 ALTER TABLE `log_equip_devour` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_equip_devour` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_equip_magic`
--

DROP TABLE IF EXISTS `log_equip_magic`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_equip_magic` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `part` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '部位',
  `goods_type_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '附魔石id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '附魔时间',
  `end_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '失效时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `part` (`part`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备系统：装备附魔日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_equip_magic`
--

LOCK TABLES `log_equip_magic` WRITE;
/*!40000 ALTER TABLE `log_equip_magic` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_equip_magic` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_equip_prefix`
--

DROP TABLE IF EXISTS `log_equip_prefix`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_equip_prefix` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `ctrl_type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '操作类型',
  `equip_pos` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '装备部位',
  `equip_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '装备唯一id',
  `equip_type_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '装备类型id',
  `old_prefix` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '原重铸次数',
  `prefix` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '新重铸次数',
  `goods_list` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '道具列表',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `equip_pos` (`equip_pos`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备重铸日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_equip_prefix`
--

LOCK TABLES `log_equip_prefix` WRITE;
/*!40000 ALTER TABLE `log_equip_prefix` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_equip_prefix` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_equip_refine`
--

DROP TABLE IF EXISTS `log_equip_refine`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_equip_refine` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `pos` smallint(5) unsigned NOT NULL COMMENT '装备部位',
  `attr_s` varchar(255) NOT NULL COMMENT '精炼前属性',
  `attr_e` varchar(255) NOT NULL COMMENT '精炼后属性',
  `result` varchar(255) NOT NULL DEFAULT '0' COMMENT '精炼结果',
  `cost` varchar(255) NOT NULL COMMENT '精炼消耗',
  `time` int(11) unsigned NOT NULL COMMENT '操作时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备精炼日志表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_equip_refine`
--

LOCK TABLES `log_equip_refine` WRITE;
/*!40000 ALTER TABLE `log_equip_refine` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_equip_refine` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_equip_stone`
--

DROP TABLE IF EXISTS `log_equip_stone`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_equip_stone` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `part` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '装备部位',
  `stone_pos` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '孔槽',
  `stone_type_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '英灵石id',
  `stone_list1` varchar(256) NOT NULL COMMENT '操作前列表',
  `stone_list2` varchar(256) NOT NULL COMMENT '操作后列表',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '操作类型',
  `object_list` varchar(256) NOT NULL COMMENT '消耗',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `part` (`part`),
  KEY `type` (`type`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备系统：英灵石日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_equip_stone`
--

LOCK TABLES `log_equip_stone` WRITE;
/*!40000 ALTER TABLE `log_equip_stone` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_equip_stone` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_equip_stone_compose`
--

DROP TABLE IF EXISTS `log_equip_stone_compose`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_equip_stone_compose` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `goods_type_list` varchar(1024) NOT NULL COMMENT '材料列表',
  `goods_id_list` varchar(1024) NOT NULL COMMENT '材料id列表',
  `stone_type_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '目标英灵石id',
  `object_list` varchar(256) NOT NULL COMMENT '合成消耗',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `stone_type_id` (`stone_type_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备系统：英灵石合成日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_equip_stone_compose`
--

LOCK TABLES `log_equip_stone_compose` WRITE;
/*!40000 ALTER TABLE `log_equip_stone_compose` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_equip_stone_compose` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_equip_stren`
--

DROP TABLE IF EXISTS `log_equip_stren`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_equip_stren` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `equip_pos` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '装备部位',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `pre_lv` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '强化前等级',
  `pre_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '强化前经验',
  `cur_lv` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '强化后等级',
  `cur_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '强化后经验',
  `mul` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '暴击倍率',
  `pre_power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '前战力',
  `af_power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '后战力',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备强化日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_equip_stren`
--

LOCK TABLES `log_equip_stren` WRITE;
/*!40000 ALTER TABLE `log_equip_stren` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_equip_stren` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_equip_stren_break`
--

DROP TABLE IF EXISTS `log_equip_stren_break`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_equip_stren_break` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `part` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '部位',
  `stren` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '突破等级',
  `object_list` varchar(256) NOT NULL COMMENT '强化消耗',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `part` (`part`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备系统：强化突破日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_equip_stren_break`
--

LOCK TABLES `log_equip_stren_break` WRITE;
/*!40000 ALTER TABLE `log_equip_stren_break` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_equip_stren_break` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_equip_suit_operation`
--

DROP TABLE IF EXISTS `log_equip_suit_operation`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_equip_suit_operation` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `player_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `equip_id` bigint(20) unsigned NOT NULL COMMENT '装备唯一id',
  `equip_type_id` int(10) unsigned NOT NULL COMMENT '装备配置id',
  `suit_type` tinyint(3) unsigned NOT NULL COMMENT '套装类别',
  `suit_lv` tinyint(3) unsigned NOT NULL COMMENT '套装类型',
  `suit_slv` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '套装阶数',
  `suit_num` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '套装数量',
  `goods_list` varchar(255) NOT NULL DEFAULT '' COMMENT '道具列表',
  `op` tinyint(3) unsigned NOT NULL COMMENT '状态',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备套装操作日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_equip_suit_operation`
--

LOCK TABLES `log_equip_suit_operation` WRITE;
/*!40000 ALTER TABLE `log_equip_suit_operation` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_equip_suit_operation` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_equip_upgrade_division`
--

DROP TABLE IF EXISTS `log_equip_upgrade_division`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_equip_upgrade_division` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `equip_pos` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '装备部位',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `auto_buy` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '自动购买',
  `pre_division` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '旧段位',
  `cur_division` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '新段位',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备神铸日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_equip_upgrade_division`
--

LOCK TABLES `log_equip_upgrade_division` WRITE;
/*!40000 ALTER TABLE `log_equip_upgrade_division` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_equip_upgrade_division` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_equip_upgrade_stage`
--

DROP TABLE IF EXISTS `log_equip_upgrade_stage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_equip_upgrade_stage` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `goods_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '装备唯一id',
  `ogtype_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '旧的物品类型id',
  `type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `ngtype_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '新的物品类型id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备进阶日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_equip_upgrade_stage`
--

LOCK TABLES `log_equip_upgrade_stage` WRITE;
/*!40000 ALTER TABLE `log_equip_upgrade_stage` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_equip_upgrade_stage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_equip_upgrade_stone`
--

DROP TABLE IF EXISTS `log_equip_upgrade_stone`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_equip_upgrade_stone` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) NOT NULL COMMENT '玩家id',
  `pos` smallint(5) NOT NULL COMMENT '装备部位',
  `stone_s` int(11) NOT NULL COMMENT '操作前宝石id',
  `stone_e` int(11) NOT NULL COMMENT '操作后宝石id',
  `cost` varchar(255) NOT NULL COMMENT '消耗',
  `time` int(11) NOT NULL COMMENT '操作时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备宝石升级日志表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_equip_upgrade_stone`
--

LOCK TABLES `log_equip_upgrade_stone` WRITE;
/*!40000 ALTER TABLE `log_equip_upgrade_stone` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_equip_upgrade_stone` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_equip_wash`
--

DROP TABLE IF EXISTS `log_equip_wash`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_equip_wash` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `equip_pos` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '装备部位',
  `division` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '段位',
  `ctrl_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '操作类型',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '普通消耗',
  `extra_cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '特殊消耗',
  `pre_attr` varchar(512) NOT NULL DEFAULT '[]' COMMENT '洗炼前属性',
  `cur_attr` varchar(512) NOT NULL DEFAULT '[]' COMMENT '洗炼后属性',
  `num` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '锁定条数',
  `extra_select` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '特殊选择',
  `auto_buy` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '自动购买',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备洗炼日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_equip_wash`
--

LOCK TABLES `log_equip_wash` WRITE;
/*!40000 ALTER TABLE `log_equip_wash` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_equip_wash` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_eternal_valley_reward`
--

DROP TABLE IF EXISTS `log_eternal_valley_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_eternal_valley_reward` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `chapter` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '章节',
  `stage` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '阶段',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='永恒碑谷奖励领取日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_eternal_valley_reward`
--

LOCK TABLES `log_eternal_valley_reward` WRITE;
/*!40000 ALTER TABLE `log_eternal_valley_reward` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_eternal_valley_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_eternal_valley_stage`
--

DROP TABLE IF EXISTS `log_eternal_valley_stage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_eternal_valley_stage` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `chapter` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '章节',
  `stage` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '阶段',
  `condition` varchar(255) NOT NULL DEFAULT '[]' COMMENT '达成条件',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `chapter` (`chapter`),
  KEY `stage` (`stage`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='永恒碑谷阶段达成日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_eternal_valley_stage`
--

LOCK TABLES `log_eternal_valley_stage` WRITE;
/*!40000 ALTER TABLE `log_eternal_valley_stage` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_eternal_valley_stage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_everyday_coin`
--

DROP TABLE IF EXISTS `log_everyday_coin`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_everyday_coin` (
  `time` int(10) NOT NULL COMMENT '记录时间',
  `p_total_coin` bigint(20) NOT NULL COMMENT '当天总产出铜币',
  `c_total_coin` bigint(13) NOT NULL COMMENT '当天总消耗铜币',
  `total_coin` bigint(13) NOT NULL COMMENT '当天库存铜币',
  `p_total_bcoin` bigint(13) NOT NULL COMMENT '当天生产总的总绑铜币',
  `c_total_bcoin` bigint(13) NOT NULL COMMENT '当天消耗的总绑铜币',
  `total_bcoin` bigint(13) NOT NULL COMMENT '库存绑铜币',
  PRIMARY KEY (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='每天铜币记录';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_everyday_coin`
--

LOCK TABLES `log_everyday_coin` WRITE;
/*!40000 ALTER TABLE `log_everyday_coin` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_everyday_coin` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_everyday_gold`
--

DROP TABLE IF EXISTS `log_everyday_gold`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_everyday_gold` (
  `time` int(10) NOT NULL COMMENT '记录时间',
  `avg_total` bigint(13) NOT NULL COMMENT '15天来的平均元宝',
  `cost_gold` bigint(13) NOT NULL COMMENT '消耗元宝',
  `cost_gold_admin` bigint(13) NOT NULL COMMENT '内部玩家消耗的元宝',
  `cost_bgold` bigint(13) NOT NULL COMMENT '当天消耗绑定元宝',
  `pay_gold` bigint(13) NOT NULL COMMENT '当日充值元宝',
  `total_gold` bigint(13) NOT NULL COMMENT '元宝',
  `total_gold_admin` bigint(13) DEFAULT '0' COMMENT '内玩库存元宝',
  `total_bgold_admin` bigint(13) DEFAULT '0' COMMENT '内玩绑元宝库存',
  `pay_cost_rate` varchar(10) NOT NULL COMMENT '产出消耗出',
  `remain_gold` bigint(13) DEFAULT '0' COMMENT '元宝结余数',
  PRIMARY KEY (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='每天记录元宝库存数';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_everyday_gold`
--

LOCK TABLES `log_everyday_gold` WRITE;
/*!40000 ALTER TABLE `log_everyday_gold` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_everyday_gold` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_fashion_activate`
--

DROP TABLE IF EXISTS `log_fashion_activate`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_fashion_activate` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(10) unsigned NOT NULL COMMENT '角色id',
  `pos_id` int(10) unsigned NOT NULL COMMENT '位置id',
  `fashion_id` bigint(10) unsigned NOT NULL COMMENT '时装id',
  `type` int(10) unsigned NOT NULL COMMENT '操作类型（1激活 2续时）',
  `cost` varchar(255) NOT NULL COMMENT '激活消耗',
  `old_time` int(10) unsigned NOT NULL COMMENT '使用前时效(s)',
  `new_time` int(10) unsigned NOT NULL COMMENT '使用后时效(s)',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='时装激活日志表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_fashion_activate`
--

LOCK TABLES `log_fashion_activate` WRITE;
/*!40000 ALTER TABLE `log_fashion_activate` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_fashion_activate` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_fashion_color`
--

DROP TABLE IF EXISTS `log_fashion_color`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_fashion_color` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `pos_id` int(10) unsigned NOT NULL COMMENT '位置id',
  `fashion_id` int(10) unsigned NOT NULL COMMENT '时装id',
  `color_id` int(10) unsigned NOT NULL COMMENT '需操作的颜色id',
  `type` int(10) unsigned NOT NULL COMMENT '操作类型（1染色 2解锁）',
  `cost_list` varchar(255) NOT NULL COMMENT '消耗',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='时装染色/解锁颜色日志表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_fashion_color`
--

LOCK TABLES `log_fashion_color` WRITE;
/*!40000 ALTER TABLE `log_fashion_color` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_fashion_color` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_fashion_decompose`
--

DROP TABLE IF EXISTS `log_fashion_decompose`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_fashion_decompose` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(10) unsigned NOT NULL COMMENT '角色id',
  `pos_id` int(10) unsigned NOT NULL COMMENT '部位id',
  `old_num` int(10) unsigned NOT NULL COMMENT '旧时装精华',
  `new_num` int(10) unsigned NOT NULL COMMENT '新时装精华',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='时装分解日志表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_fashion_decompose`
--

LOCK TABLES `log_fashion_decompose` WRITE;
/*!40000 ALTER TABLE `log_fashion_decompose` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_fashion_decompose` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_fashion_pos`
--

DROP TABLE IF EXISTS `log_fashion_pos`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_fashion_pos` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `pos_id` int(11) NOT NULL,
  `old_pos_lv` int(10) unsigned NOT NULL COMMENT '旧部位等级',
  `new_pos_lv` int(10) unsigned NOT NULL COMMENT '新部位等级',
  `cost` int(10) unsigned NOT NULL COMMENT '消耗',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='时装部位升级日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_fashion_pos`
--

LOCK TABLES `log_fashion_pos` WRITE;
/*!40000 ALTER TABLE `log_fashion_pos` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_fashion_pos` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_fashion_star`
--

DROP TABLE IF EXISTS `log_fashion_star`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_fashion_star` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `pos_id` int(10) unsigned NOT NULL COMMENT '部位id',
  `fashion_id` int(10) unsigned NOT NULL COMMENT '时装id',
  `type` int(10) unsigned NOT NULL COMMENT '操作类型（1激活 2升星）',
  `old_star_lv` int(10) unsigned NOT NULL COMMENT '旧时装星数',
  `new_star_lv` int(10) unsigned NOT NULL COMMENT '新时装星数',
  `cost_list` varchar(255) NOT NULL COMMENT '消耗',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='时装激活/升星日志表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_fashion_star`
--

LOCK TABLES `log_fashion_star` WRITE;
/*!40000 ALTER TABLE `log_fashion_star` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_fashion_star` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_fireworks`
--

DROP TABLE IF EXISTS `log_fireworks`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_fireworks` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `use_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '单次使用个数',
  `reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '奖励内容',
  `all_use_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '累计使用个数',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '使用时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`) USING BTREE,
  KEY `role_id` (`role_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='烟花使用日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_fireworks`
--

LOCK TABLES `log_fireworks` WRITE;
/*!40000 ALTER TABLE `log_fireworks` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_fireworks` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_fish_illustrated_lv`
--

DROP TABLE IF EXISTS `log_fish_illustrated_lv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_fish_illustrated_lv` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号ID',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `illu_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '图鉴id',
  `old_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '原来等级',
  `new_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '当前等级',
  `cost` varchar(128) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='钓鱼图鉴升级日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_fish_illustrated_lv`
--

LOCK TABLES `log_fish_illustrated_lv` WRITE;
/*!40000 ALTER TABLE `log_fish_illustrated_lv` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_fish_illustrated_lv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_fishing_harvest`
--

DROP TABLE IF EXISTS `log_fishing_harvest`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_fishing_harvest` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `role_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '角色等级',
  `fishing_scene_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '钓鱼场景ID',
  `fishing_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '钓鱼等级',
  `fishing_water_area` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '水域距离',
  `fishing_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '鱼类ID',
  `fish_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '鱼类品质',
  `maunal_or_auto` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否为自动',
  `rods_usage_cost` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '鱼竿使用次数消耗',
  `energy_cost` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活力值消耗',
  `re_code` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '收杆结果',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='钓鱼收获日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_fishing_harvest`
--

LOCK TABLES `log_fishing_harvest` WRITE;
/*!40000 ALTER TABLE `log_fishing_harvest` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_fishing_harvest` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_flower`
--

DROP TABLE IF EXISTS `log_flower`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_flower` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `sender_id` bigint(20) unsigned NOT NULL COMMENT '送礼者id',
  `receiver_id` bigint(20) unsigned NOT NULL COMMENT '接受者id',
  `goods_id` int(11) unsigned NOT NULL COMMENT '礼物物品id',
  `before_fame` int(11) unsigned NOT NULL COMMENT '前名誉值',
  `after_fame` int(11) unsigned NOT NULL COMMENT '新名誉值',
  `before_charm` int(11) unsigned NOT NULL COMMENT '前魅力值',
  `after_charm` int(11) unsigned NOT NULL COMMENT '后魅力值',
  `time` int(11) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `sender_id` (`sender_id`),
  KEY `receiver_id` (`receiver_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='送花日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_flower`
--

LOCK TABLES `log_flower` WRITE;
/*!40000 ALTER TABLE `log_flower` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_flower` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_flower_rank_kf`
--

DROP TABLE IF EXISTS `log_flower_rank_kf`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_flower_rank_kf` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT '名字',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器id',
  `platform` varchar(255) NOT NULL DEFAULT '' COMMENT '平台名字',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '所在的服标示',
  `sex` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '性别',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '魅力值',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`) USING BTREE,
  KEY `role_id` (`role_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服魅力榜日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_flower_rank_kf`
--

LOCK TABLES `log_flower_rank_kf` WRITE;
/*!40000 ALTER TABLE `log_flower_rank_kf` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_flower_rank_kf` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_flower_rank_local`
--

DROP TABLE IF EXISTS `log_flower_rank_local`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_flower_rank_local` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `sex` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '性别',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '魅力值',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`) USING BTREE,
  KEY `role_id` (`role_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='本服魅力榜日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_flower_rank_local`
--

LOCK TABLES `log_flower_rank_local` WRITE;
/*!40000 ALTER TABLE `log_flower_rank_local` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_flower_rank_local` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_gift`
--

DROP TABLE IF EXISTS `log_gift`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_gift` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `pid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `gid` bigint(20) unsigned DEFAULT '0' COMMENT '物品唯一id',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型ID',
  `gift_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '礼包ID',
  `use_num` int(11) unsigned NOT NULL DEFAULT '1' COMMENT '使用的数量',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开启时间',
  PRIMARY KEY (`id`),
  KEY `pid` (`pid`),
  KEY `gid` (`gid`),
  KEY `goods_id` (`goods_id`),
  KEY `gift_id` (`gift_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='礼包日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_gift`
--

LOCK TABLES `log_gift` WRITE;
/*!40000 ALTER TABLE `log_gift` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_gift` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_gift_about`
--

DROP TABLE IF EXISTS `log_gift_about`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_gift_about` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开启时间',
  `pid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `gift_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '礼包ID',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '获得道具id',
  `goods_num` int(11) unsigned NOT NULL DEFAULT '1' COMMENT '获得数量',
  PRIMARY KEY (`id`),
  KEY `pid` (`pid`),
  KEY `gift_id` (`gift_id`),
  KEY `time` (`time`),
  KEY `goods_id` (`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='礼包日志详情';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_gift_about`
--

LOCK TABLES `log_gift_about` WRITE;
/*!40000 ALTER TABLE `log_gift_about` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_gift_about` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_gift_card_list`
--

DROP TABLE IF EXISTS `log_gift_card_list`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_gift_card_list` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色ID',
  `card_no` char(50) NOT NULL COMMENT '卡号',
  `card_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '礼包卡类型',
  `gift_type` varchar(50) NOT NULL COMMENT '标识符',
  `award_list` varchar(1024) DEFAULT '[]' COMMENT '奖励列表',
  `cost_goods` varchar(255) NOT NULL DEFAULT '[]' COMMENT '扣除道具[{goods_type_id, goods_id}]',
  `is_success` tinyint(3) unsigned NOT NULL DEFAULT '1' COMMENT '是否成功领取',
  `time` int(11) NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='礼包卡领取日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_gift_card_list`
--

LOCK TABLES `log_gift_card_list` WRITE;
/*!40000 ALTER TABLE `log_gift_card_list` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_gift_card_list` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_gm_mail`
--

DROP TABLE IF EXISTS `log_gm_mail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_gm_mail` (
  `mid` int(11) NOT NULL AUTO_INCREMENT,
  `id` int(11) NOT NULL,
  `accid` int(11) NOT NULL,
  `accname` varchar(50) NOT NULL,
  `last_login_time` int(10) NOT NULL,
  `server_id` int(11) NOT NULL,
  `nickname` varchar(2000) NOT NULL COMMENT '昵称',
  `title` varchar(512) NOT NULL,
  `content` varchar(1024) NOT NULL,
  `goods_id` int(11) NOT NULL,
  `goods_num` int(11) NOT NULL,
  `bcoin` int(11) NOT NULL,
  `coin` int(11) NOT NULL,
  `silver` int(11) NOT NULL,
  `gold` int(11) NOT NULL,
  `admin_name` varchar(50) NOT NULL,
  `ctime` int(11) NOT NULL,
  `stren` int(11) NOT NULL,
  `prefix` int(11) NOT NULL,
  `realname` varchar(50) NOT NULL,
  `lv` int(11) NOT NULL,
  `role_gold` int(11) NOT NULL,
  `pass_admin_name` varchar(50) NOT NULL,
  `special_attachment` varchar(1000) DEFAULT '[]' COMMENT '附件',
  PRIMARY KEY (`mid`),
  KEY `nickname` (`nickname`(255))
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_gm_mail`
--

LOCK TABLES `log_gm_mail` WRITE;
/*!40000 ALTER TABLE `log_gm_mail` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_gm_mail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_gm_use`
--

DROP TABLE IF EXISTS `log_gm_use`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_gm_use` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(10) unsigned NOT NULL COMMENT '角色id',
  `lv` smallint(8) unsigned NOT NULL COMMENT '当前等级',
  `scene` int(10) unsigned NOT NULL COMMENT '当前场景',
  `fun_desc` varchar(255) NOT NULL COMMENT '秘籍名称',
  `fun_data` varchar(512) NOT NULL COMMENT '秘籍数据',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='秘籍使用日志表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_gm_use`
--

LOCK TABLES `log_gm_use` WRITE;
/*!40000 ALTER TABLE `log_gm_use` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_gm_use` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_god_active`
--

DROP TABLE IF EXISTS `log_god_active`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_god_active` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `god_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '降神id',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗材料',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='降神激活日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_god_active`
--

LOCK TABLES `log_god_active` WRITE;
/*!40000 ALTER TABLE `log_god_active` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_god_active` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_god_active_pyx`
--

DROP TABLE IF EXISTS `log_god_active_pyx`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_god_active_pyx` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `pyx_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '圣器id',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗材料',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='圣器激活日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_god_active_pyx`
--

LOCK TABLES `log_god_active_pyx` WRITE;
/*!40000 ALTER TABLE `log_god_active_pyx` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_god_active_pyx` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_god_active_rune`
--

DROP TABLE IF EXISTS `log_god_active_rune`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_god_active_rune` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `god_grade` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '降神总结数',
  `rune_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '符文id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='降神符文激活日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_god_active_rune`
--

LOCK TABLES `log_god_active_rune` WRITE;
/*!40000 ALTER TABLE `log_god_active_rune` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_god_active_rune` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_god_active_rune_pos`
--

DROP TABLE IF EXISTS `log_god_active_rune_pos`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_god_active_rune_pos` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `rune_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '对应符文总阶数',
  `pos` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '印记槽位',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='降神符文印记槽位激活日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_god_active_rune_pos`
--

LOCK TABLES `log_god_active_rune_pos` WRITE;
/*!40000 ALTER TABLE `log_god_active_rune_pos` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_god_active_rune_pos` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_god_lv_up`
--

DROP TABLE IF EXISTS `log_god_lv_up`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_god_lv_up` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `god_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '降神id',
  `ograde` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '前阶数',
  `olv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '前星级',
  `ngrade` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '当前阶数',
  `nlv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '当前星级',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '当前经验',
  `add_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '增加的经验',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '升级消耗',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='降神升级日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_god_lv_up`
--

LOCK TABLES `log_god_lv_up` WRITE;
/*!40000 ALTER TABLE `log_god_lv_up` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_god_lv_up` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_god_pyx_lv`
--

DROP TABLE IF EXISTS `log_god_pyx_lv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_god_pyx_lv` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `pyx_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '圣器id',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作前等级',
  `new_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作后等级',
  `cost` varchar(255) NOT NULL DEFAULT '[]',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='降神圣器升星日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_god_pyx_lv`
--

LOCK TABLES `log_god_pyx_lv` WRITE;
/*!40000 ALTER TABLE `log_god_pyx_lv` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_god_pyx_lv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_god_seal_lv_up`
--

DROP TABLE IF EXISTS `log_god_seal_lv_up`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_god_seal_lv_up` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `seal_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '印记id',
  `pyx_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '圣器id',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '前一等级',
  `newlv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '当前等级',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '升级消耗',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='印记升级日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_god_seal_lv_up`
--

LOCK TABLES `log_god_seal_lv_up` WRITE;
/*!40000 ALTER TABLE `log_god_seal_lv_up` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_god_seal_lv_up` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_god_stren_rune`
--

DROP TABLE IF EXISTS `log_god_stren_rune`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_god_stren_rune` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `rune_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '符文id',
  `old_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作前等级',
  `old_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作前经验',
  `new_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作后等级',
  `new_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作后经验',
  `add_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '增加经验',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗内容',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='降神符文升级日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_god_stren_rune`
--

LOCK TABLES `log_god_stren_rune` WRITE;
/*!40000 ALTER TABLE `log_god_stren_rune` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_god_stren_rune` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_god_stren_rune_goods`
--

DROP TABLE IF EXISTS `log_god_stren_rune_goods`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_god_stren_rune_goods` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `goods_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '印记物品唯一id',
  `type_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '印记id',
  `old_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作前等级',
  `new_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作后等级',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗材料(唯一id,物品类型id,阶数)',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='降神符文印记升级日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_god_stren_rune_goods`
--

LOCK TABLES `log_god_stren_rune_goods` WRITE;
/*!40000 ALTER TABLE `log_god_stren_rune_goods` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_god_stren_rune_goods` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_goods`
--

DROP TABLE IF EXISTS `log_goods`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_goods` (
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '产出时间',
  `type` smallint(4) unsigned NOT NULL DEFAULT '0' COMMENT '产出类型，1为怪物掉落',
  `subtype` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '产出子类型',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型ID',
  `goods_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品数量',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色ID',
  `remark` varchar(500) NOT NULL DEFAULT '' COMMENT '备注',
  KEY `time` (`time`),
  KEY `type` (`type`),
  KEY `goods_id` (`goods_id`),
  KEY `subtype` (`subtype`),
  KEY `player_id` (`player_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品产出日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_goods`
--

LOCK TABLES `log_goods` WRITE;
/*!40000 ALTER TABLE `log_goods` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_goods` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_goods_compose`
--

DROP TABLE IF EXISTS `log_goods_compose`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_goods_compose` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `rule_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '合成规则id',
  `specify_material_list` varchar(255) DEFAULT '[]' COMMENT '指定材料',
  `material_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT '材料',
  `cost_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `is_success` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '结果',
  `goods_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT '获得物品',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `rule_id` (`rule_id`),
  KEY `role_id` (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品合成日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_goods_compose`
--

LOCK TABLES `log_goods_compose` WRITE;
/*!40000 ALTER TABLE `log_goods_compose` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_goods_compose` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_goods_exchange`
--

DROP TABLE IF EXISTS `log_goods_exchange`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_goods_exchange` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '兑换类型',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `type` (`type`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='通用兑换日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_goods_exchange`
--

LOCK TABLES `log_goods_exchange` WRITE;
/*!40000 ALTER TABLE `log_goods_exchange` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_goods_exchange` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_goods_sell`
--

DROP TABLE IF EXISTS `log_goods_sell`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_goods_sell` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `goods_type_list` varchar(1024) NOT NULL COMMENT '物品列表',
  `goods_id_list` varchar(1024) NOT NULL COMMENT '物品id列表',
  `object_list` varchar(256) NOT NULL COMMENT '获得货币',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='物品出售日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_goods_sell`
--

LOCK TABLES `log_goods_sell` WRITE;
/*!40000 ALTER TABLE `log_goods_sell` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_goods_sell` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_guild`
--

DROP TABLE IF EXISTS `log_guild`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_guild` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `guild_name` varchar(255) NOT NULL DEFAULT '' COMMENT '公会名字',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `extra` varchar(50) NOT NULL DEFAULT '' COMMENT '附加信息',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `guild_id` (`guild_id`) USING BTREE,
  KEY `type` (`type`) USING BTREE,
  KEY `time` (`time`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会创建解散日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_guild`
--

LOCK TABLES `log_guild` WRITE;
/*!40000 ALTER TABLE `log_guild` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_guild` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_guild_bonfire`
--

DROP TABLE IF EXISTS `log_guild_bonfire`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_guild_bonfire` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `enter_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '参加时玩家等级',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '获得经验',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会篝火玩家参与信息日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_guild_bonfire`
--

LOCK TABLES `log_guild_bonfire` WRITE;
/*!40000 ALTER TABLE `log_guild_bonfire` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_guild_bonfire` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_guild_building_up`
--

DROP TABLE IF EXISTS `log_guild_building_up`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_guild_building_up` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `build_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '建筑类型',
  `old_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '升级前等级',
  `new_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '升级后等级',
  `cost` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消耗资金',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `guild_id` (`guild_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会建筑日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_guild_building_up`
--

LOCK TABLES `log_guild_building_up` WRITE;
/*!40000 ALTER TABLE `log_guild_building_up` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_guild_building_up` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_guild_depot`
--

DROP TABLE IF EXISTS `log_guild_depot`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_guild_depot` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '操作类型',
  `unique_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '仓库物品唯一id',
  `goods_id` int(11) unsigned NOT NULL COMMENT '物品类型id',
  `pre_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作前积分',
  `cur_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作后积分',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `type` (`type`),
  KEY `unique_id` (`unique_id`),
  KEY `goods_id` (`goods_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会仓库日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_guild_depot`
--

LOCK TABLES `log_guild_depot` WRITE;
/*!40000 ALTER TABLE `log_guild_depot` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_guild_depot` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_guild_guard`
--

DROP TABLE IF EXISTS `log_guild_guard`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_guild_guard` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `wave_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '成功守卫波数',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '获得经验',
  `boss_times` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '召唤boss次数',
  `reward` varchar(512) NOT NULL DEFAULT '[]' COMMENT '奖励内容',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会守卫日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_guild_guard`
--

LOCK TABLES `log_guild_guard` WRITE;
/*!40000 ALTER TABLE `log_guild_guard` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_guild_guard` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_guild_liveness`
--

DROP TABLE IF EXISTS `log_guild_liveness`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_guild_liveness` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `member_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '公会人数',
  `old_val` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '今日原活跃度',
  `add_val` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '增加值',
  `new_val` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '今日新活跃度',
  `liveness_list` varchar(512) NOT NULL DEFAULT '[]' COMMENT '公会近7日活跃度',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `guild_id` (`guild_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会活跃度日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_guild_liveness`
--

LOCK TABLES `log_guild_liveness` WRITE;
/*!40000 ALTER TABLE `log_guild_liveness` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_guild_liveness` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_guild_liveness_extra_reward`
--

DROP TABLE IF EXISTS `log_guild_liveness_extra_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_guild_liveness_extra_reward` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `live` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活跃度值',
  `live_rewards` varchar(255) NOT NULL DEFAULT '[]' COMMENT '额外活跃度奖励id',
  `extra_live` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '额外增加活跃度',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='个人公会活跃度日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_guild_liveness_extra_reward`
--

LOCK TABLES `log_guild_liveness_extra_reward` WRITE;
/*!40000 ALTER TABLE `log_guild_liveness_extra_reward` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_guild_liveness_extra_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_guild_member`
--

DROP TABLE IF EXISTS `log_guild_member`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_guild_member` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '唯一id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `guild_name` varchar(100) NOT NULL DEFAULT '' COMMENT '公会名字',
  `event_type` smallint(3) unsigned NOT NULL DEFAULT '0' COMMENT '事件类型',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `event_param` varchar(256) NOT NULL DEFAULT '' COMMENT '事件参数',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `guild_id` (`guild_id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会成员日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_guild_member`
--

LOCK TABLES `log_guild_member` WRITE;
/*!40000 ALTER TABLE `log_guild_member` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_guild_member` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_guild_reply`
--

DROP TABLE IF EXISTS `log_guild_reply`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_guild_reply` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分数',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_guild_reply`
--

LOCK TABLES `log_guild_reply` WRITE;
/*!40000 ALTER TABLE `log_guild_reply` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_guild_reply` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_guild_skill`
--

DROP TABLE IF EXISTS `log_guild_skill`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_guild_skill` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `role_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家等级',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `guild_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '公会等级',
  `build_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '建筑等级',
  `skill_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能id',
  `old_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '升级前等级',
  `new_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '升级后等级',
  `cost` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消耗贡献',
  `old_power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作前战力日志',
  `new_power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作后战力',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会技能日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_guild_skill`
--

LOCK TABLES `log_guild_skill` WRITE;
/*!40000 ALTER TABLE `log_guild_skill` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_guild_skill` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_guild_war_allot_reward`
--

DROP TABLE IF EXISTS `log_guild_war_allot_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_guild_war_allot_reward` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `guild_name` varchar(50) NOT NULL DEFAULT '' COMMENT '公会名字',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '被分配奖励玩家id',
  `allot_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '分配方式',
  `reward_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '奖励类型',
  `reward` varchar(255) NOT NULL DEFAULT '' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `guild_id` (`guild_id`),
  KEY `role_id` (`role_id`),
  KEY `allot_type` (`allot_type`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会争霸奖励日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_guild_war_allot_reward`
--

LOCK TABLES `log_guild_war_allot_reward` WRITE;
/*!40000 ALTER TABLE `log_guild_war_allot_reward` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_guild_war_allot_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_guild_war_battle`
--

DROP TABLE IF EXISTS `log_guild_war_battle`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_guild_war_battle` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `red_guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '红方公会ID',
  `red_guild_name` varchar(255) NOT NULL DEFAULT '[]' COMMENT '红方公会名',
  `blue_guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '蓝方公会ID',
  `blue_guild_name` varchar(255) NOT NULL DEFAULT '[]' COMMENT '蓝方公会名',
  `yellow_guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '黄方公会ID',
  `yellow_guild_name` varchar(255) NOT NULL DEFAULT '[]' COMMENT '黄方公会名',
  `first` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '第一名',
  `first_reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '第一名奖励',
  `second` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '第二名',
  `second_reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '第二名奖励',
  `third` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '第三名',
  `third_reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '第三名奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `red_guild_id` (`red_guild_id`),
  KEY `blue_guild_id` (`blue_guild_id`),
  KEY `yellow_guild_id` (`yellow_guild_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会争霸战斗结果日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_guild_war_battle`
--

LOCK TABLES `log_guild_war_battle` WRITE;
/*!40000 ALTER TABLE `log_guild_war_battle` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_guild_war_battle` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_guild_war_division`
--

DROP TABLE IF EXISTS `log_guild_war_division`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_guild_war_division` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `stage` tinyint(1) NOT NULL DEFAULT '0' COMMENT '阶段',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `guild_name` varchar(50) NOT NULL DEFAULT '' COMMENT '公会名字',
  `division` tinyint(1) NOT NULL DEFAULT '0' COMMENT '赛区',
  `ranking` tinyint(1) NOT NULL DEFAULT '0' COMMENT '排名',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `stage` (`stage`),
  KEY `guild_id` (`guild_id`),
  KEY `division` (`division`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会争霸赛区日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_guild_war_division`
--

LOCK TABLES `log_guild_war_division` WRITE;
/*!40000 ALTER TABLE `log_guild_war_division` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_guild_war_division` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_guild_war_reward`
--

DROP TABLE IF EXISTS `log_guild_war_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_guild_war_reward` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `guild_name` varchar(50) NOT NULL DEFAULT '' COMMENT '公会名字',
  `reward_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '奖励类型',
  `reward` varchar(255) NOT NULL DEFAULT '' COMMENT '奖励',
  `extra` varchar(50) NOT NULL DEFAULT '' COMMENT '附加信息 相关的连胜次数以及被终结次数',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `guild_id` (`guild_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会争霸连胜奖励';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_guild_war_reward`
--

LOCK TABLES `log_guild_war_reward` WRITE;
/*!40000 ALTER TABLE `log_guild_war_reward` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_guild_war_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_guild_war_scene`
--

DROP TABLE IF EXISTS `log_guild_war_scene`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_guild_war_scene` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `extra` varchar(50) NOT NULL DEFAULT '' COMMENT '附加信息',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会争霸玩家进出场景日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_guild_war_scene`
--

LOCK TABLES `log_guild_war_scene` WRITE;
/*!40000 ALTER TABLE `log_guild_war_scene` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_guild_war_scene` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_honor_coin`
--

DROP TABLE IF EXISTS `log_honor_coin`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_honor_coin` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `lv` smallint(5) unsigned NOT NULL COMMENT '等级',
  `vip_lv` tinyint(3) unsigned NOT NULL COMMENT 'vip等级',
  `type` tinyint(3) unsigned NOT NULL COMMENT '类型',
  `sub_type` tinyint(3) unsigned NOT NULL COMMENT '子类型',
  `about` varchar(255) NOT NULL COMMENT '详细记录',
  `change_num` smallint(5) unsigned NOT NULL COMMENT '改变的数量',
  `left_num` mediumint(8) unsigned NOT NULL COMMENT '剩余数量',
  `time` int(11) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `type` (`type`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='至尊币产出消费日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_honor_coin`
--

LOCK TABLES `log_honor_coin` WRITE;
/*!40000 ALTER TABLE `log_honor_coin` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_honor_coin` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_husong_end`
--

DROP TABLE IF EXISTS `log_husong_end`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_husong_end` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `angel_id` int(10) unsigned NOT NULL COMMENT '天使id',
  `start_time` int(10) unsigned NOT NULL COMMENT '开始时间',
  `end_stage` int(10) unsigned NOT NULL COMMENT '结束时的阶段',
  `end_type` int(10) unsigned NOT NULL COMMENT '结束方式（1成功护送 2护送超时 3被杀死）',
  `if_double` int(10) unsigned NOT NULL COMMENT '是否双倍（0否 1是）',
  `goods_list` varchar(100) NOT NULL COMMENT '奖励列表',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='护送结果日志表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_husong_end`
--

LOCK TABLES `log_husong_end` WRITE;
/*!40000 ALTER TABLE `log_husong_end` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_husong_end` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_husong_take`
--

DROP TABLE IF EXISTS `log_husong_take`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_husong_take` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `take_role_id` bigint(20) unsigned NOT NULL COMMENT '拦截玩家id',
  `be_taken_role_id` bigint(20) unsigned NOT NULL COMMENT '被拦截的玩家id',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='护送拦截日志表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_husong_take`
--

LOCK TABLES `log_husong_take` WRITE;
/*!40000 ALTER TABLE `log_husong_take` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_husong_take` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_intimacy`
--

DROP TABLE IF EXISTS `log_intimacy`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_intimacy` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `other_rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '对方玩家id',
  `pre_intimacy` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '之前亲密度',
  `way` smallint(2) NOT NULL DEFAULT '0' COMMENT '添加途径',
  `intimacy` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '当前亲密度',
  `extra` varchar(255) NOT NULL DEFAULT '' COMMENT '附加信息',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `other_rid` (`other_rid`),
  KEY `way` (`way`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='亲密度日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_intimacy`
--

LOCK TABLES `log_intimacy` WRITE;
/*!40000 ALTER TABLE `log_intimacy` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_intimacy` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_jjc`
--

DROP TABLE IF EXISTS `log_jjc`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_jjc` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '结算名次',
  `rival_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '被挑战玩家Id',
  `rival_rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '被挑战玩家排名',
  `result` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '胜负情况',
  `after_rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '挑战后排名',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`) USING BTREE,
  KEY `role_id` (`role_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='竞技排位赛日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_jjc`
--

LOCK TABLES `log_jjc` WRITE;
/*!40000 ALTER TABLE `log_jjc` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_jjc` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_jjc_break_rank`
--

DROP TABLE IF EXISTS `log_jjc_break_rank`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_jjc_break_rank` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `old_rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '旧的历史最高排名',
  `reward` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '领取绑钻数量',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  `new_rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '新的历史最高排名',
  `total_receive` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '总共领取了多少',
  PRIMARY KEY (`id`),
  KEY `time` (`time`) USING BTREE,
  KEY `break_rank` (`old_rank`) USING BTREE,
  KEY `role_id` (`role_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='竞技名次突破日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_jjc_break_rank`
--

LOCK TABLES `log_jjc_break_rank` WRITE;
/*!40000 ALTER TABLE `log_jjc_break_rank` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_jjc_break_rank` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_jjc_buy_times`
--

DROP TABLE IF EXISTS `log_jjc_buy_times`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_jjc_buy_times` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `pre_gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '购买前钻石',
  `pre_bgold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '购买前绑钻',
  `pre_coin` bigint(11) unsigned NOT NULL DEFAULT '0' COMMENT '购买前金币',
  `buy_times` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '购买次数',
  `after_gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '购买后钻石',
  `after_bgold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '购买后绑钻',
  `after_coin` bigint(11) unsigned NOT NULL DEFAULT '0' COMMENT '购买后金币',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '购买次数时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`) USING BTREE,
  KEY `role_id` (`role_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='竞技购买次数日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_jjc_buy_times`
--

LOCK TABLES `log_jjc_buy_times` WRITE;
/*!40000 ALTER TABLE `log_jjc_buy_times` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_jjc_buy_times` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_jjc_clear`
--

DROP TABLE IF EXISTS `log_jjc_clear`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_jjc_clear` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '结算名次',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`) USING BTREE,
  KEY `role_id` (`role_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='竞技结算排名日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_jjc_clear`
--

LOCK TABLES `log_jjc_clear` WRITE;
/*!40000 ALTER TABLE `log_jjc_clear` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_jjc_clear` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_jjc_inspire`
--

DROP TABLE IF EXISTS `log_jjc_inspire`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_jjc_inspire` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `pre_gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '鼓舞前钻石',
  `pre_bgold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '鼓舞前绑钻',
  `pre_coin` bigint(11) unsigned NOT NULL DEFAULT '0' COMMENT '鼓舞前金币',
  `pre_combat` bigint(11) unsigned NOT NULL DEFAULT '0' COMMENT '鼓舞前战力',
  `inspire_times` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '鼓舞次数',
  `after_gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '鼓舞后钻石',
  `after_bgold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '鼓舞后绑钻',
  `after_coin` bigint(11) unsigned NOT NULL DEFAULT '0' COMMENT '鼓舞后金币',
  `after_combat` bigint(11) unsigned NOT NULL DEFAULT '0' COMMENT '鼓舞后战力',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '鼓舞时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`) USING BTREE,
  KEY `role_id` (`role_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='竞技战力鼓舞日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_jjc_inspire`
--

LOCK TABLES `log_jjc_inspire` WRITE;
/*!40000 ALTER TABLE `log_jjc_inspire` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_jjc_inspire` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_join`
--

DROP TABLE IF EXISTS `log_join`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_join` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `module_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `guild_id` (`guild_id`),
  KEY `module_id` (`module_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='功能活动参与日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_join`
--

LOCK TABLES `log_join` WRITE;
/*!40000 ALTER TABLE `log_join` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_join` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_joy_wish`
--

DROP TABLE IF EXISTS `log_joy_wish`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_joy_wish` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动类型',
  `sub_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '子类型',
  `w_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '世界等级',
  `wish_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '抽奖类型',
  `reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `cost` varchar(256) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='欢乐许愿日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_joy_wish`
--

LOCK TABLES `log_joy_wish` WRITE;
/*!40000 ALTER TABLE `log_joy_wish` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_joy_wish` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_kf_1vn_auction`
--

DROP TABLE IF EXISTS `log_kf_1vn_auction`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_kf_1vn_auction` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `auction_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖配置id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服id',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服数',
  `name` varchar(200) NOT NULL DEFAULT '' COMMENT '玩家名字',
  `price_add` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '单次出价',
  `price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '总价',
  `voucher` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消耗代金券数量',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `auction_id` (`auction_id`),
  KEY `role_id` (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服1vn拍卖日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_kf_1vn_auction`
--

LOCK TABLES `log_kf_1vn_auction` WRITE;
/*!40000 ALTER TABLE `log_kf_1vn_auction` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_kf_1vn_auction` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_kf_1vn_bet`
--

DROP TABLE IF EXISTS `log_kf_1vn_bet`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_kf_1vn_bet` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `role_name` varchar(50) NOT NULL COMMENT '玩家名字',
  `turn` tinyint(3) unsigned NOT NULL COMMENT '轮次',
  `battle_id` int(10) unsigned NOT NULL COMMENT '战斗场次',
  `bet_side` tinyint(3) unsigned NOT NULL COMMENT '押注选择',
  `money` int(10) unsigned NOT NULL COMMENT '押注金额',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='1vn押注日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_kf_1vn_bet`
--

LOCK TABLES `log_kf_1vn_bet` WRITE;
/*!40000 ALTER TABLE `log_kf_1vn_bet` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_kf_1vn_bet` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_kf_1vn_race_1`
--

DROP TABLE IF EXISTS `log_kf_1vn_race_1`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_kf_1vn_race_1` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增Id',
  `area` smallint(6) unsigned NOT NULL DEFAULT '0' COMMENT '战区',
  `win_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '胜方id',
  `win_server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '胜方服id',
  `win_server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '胜方服数',
  `win_name` varchar(200) NOT NULL DEFAULT '' COMMENT '胜方名字',
  `win_cp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '胜方战斗力',
  `win_score` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '胜方积分',
  `lose_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '负方id',
  `lose_server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '负方服id',
  `lose_server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '负方服数',
  `lose_name` varchar(200) NOT NULL DEFAULT '' COMMENT '负方名字',
  `lose_cp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '负方战斗力',
  `lose_score` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '负方积分',
  `win_type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '胜利方式',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `win_id` (`win_id`),
  KEY `lose_id` (`lose_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服1vn资格赛日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_kf_1vn_race_1`
--

LOCK TABLES `log_kf_1vn_race_1` WRITE;
/*!40000 ALTER TABLE `log_kf_1vn_race_1` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_kf_1vn_race_1` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_kf_1vn_race_2`
--

DROP TABLE IF EXISTS `log_kf_1vn_race_2`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_kf_1vn_race_2` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增Id',
  `area` smallint(6) unsigned NOT NULL DEFAULT '0' COMMENT '战区',
  `turn` smallint(6) unsigned NOT NULL DEFAULT '0' COMMENT '轮次',
  `battle_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战斗场次',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服id',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服数',
  `name` varchar(200) NOT NULL DEFAULT '' COMMENT '名字',
  `cp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战斗力',
  `def_type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否擂主',
  `win` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '胜负',
  `win_type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '胜负方式',
  `status` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '结算状态',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `battle_id` (`battle_id`),
  KEY `player_id` (`player_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服1vn擂台赛日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_kf_1vn_race_2`
--

LOCK TABLES `log_kf_1vn_race_2` WRITE;
/*!40000 ALTER TABLE `log_kf_1vn_race_2` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_kf_1vn_race_2` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_kf_1vn_sign`
--

DROP TABLE IF EXISTS `log_kf_1vn_sign`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_kf_1vn_sign` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增Id',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `name` varchar(200) NOT NULL DEFAULT '' COMMENT '玩家名字',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服id',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家等级',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服1vn报名日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_kf_1vn_sign`
--

LOCK TABLES `log_kf_1vn_sign` WRITE;
/*!40000 ALTER TABLE `log_kf_1vn_sign` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_kf_1vn_sign` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_kf_boss_drop`
--

DROP TABLE IF EXISTS `log_kf_boss_drop`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_kf_boss_drop` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `boss_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'bossid',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品id',
  `good_info` varchar(255) NOT NULL DEFAULT '[]' COMMENT '属性',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`),
  KEY `boss_id` (`boss_id`),
  KEY `role_id` (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服boss掉落日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_kf_boss_drop`
--

LOCK TABLES `log_kf_boss_drop` WRITE;
/*!40000 ALTER TABLE `log_kf_boss_drop` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_kf_boss_drop` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_kf_boss_killer`
--

DROP TABLE IF EXISTS `log_kf_boss_killer`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_kf_boss_killer` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `boss_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'bossid',
  `killer_server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '击杀者服务器id',
  `killer_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '击杀玩家Id',
  `bl_ids` varchar(255) NOT NULL DEFAULT '[]' COMMENT '归属玩家Id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '击杀时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`),
  KEY `boss_id` (`boss_id`),
  KEY `killer_id` (`killer_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服boss击杀归属日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_kf_boss_killer`
--

LOCK TABLES `log_kf_boss_killer` WRITE;
/*!40000 ALTER TABLE `log_kf_boss_killer` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_kf_boss_killer` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_kf_cloud_buy_draw`
--

DROP TABLE IF EXISTS `log_kf_cloud_buy_draw`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_kf_cloud_buy_draw` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动主类型',
  `subtype` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `server_num` int(10) unsigned NOT NULL COMMENT '服务器标识',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `role_name` varchar(255) NOT NULL DEFAULT '' COMMENT '玩家名字',
  `product_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商品id',
  `reward_lv` varchar(255) NOT NULL COMMENT '奖励类型',
  `product_name` varchar(255) NOT NULL DEFAULT '' COMMENT '商品名字',
  `reward` varchar(255) NOT NULL DEFAULT '' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `type` (`type`),
  KEY `subtype` (`subtype`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服云购开奖日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_kf_cloud_buy_draw`
--

LOCK TABLES `log_kf_cloud_buy_draw` WRITE;
/*!40000 ALTER TABLE `log_kf_cloud_buy_draw` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_kf_cloud_buy_draw` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_kf_cloud_buy_purchase`
--

DROP TABLE IF EXISTS `log_kf_cloud_buy_purchase`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_kf_cloud_buy_purchase` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动主类型',
  `subtype` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `server_num` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '第几服',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `role_name` varchar(255) NOT NULL DEFAULT '' COMMENT '玩家名字',
  `product_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商品id',
  `product_name` varchar(255) NOT NULL DEFAULT '' COMMENT '商品名字',
  `buy_num` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '购买份数',
  `buy_reward` varchar(1024) NOT NULL DEFAULT '' COMMENT '购买奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `type` (`type`),
  KEY `subtype` (`subtype`),
  KEY `time` (`time`),
  KEY `role_id` (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服云购购买日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_kf_cloud_buy_purchase`
--

LOCK TABLES `log_kf_cloud_buy_purchase` WRITE;
/*!40000 ALTER TABLE `log_kf_cloud_buy_purchase` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_kf_cloud_buy_purchase` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_kf_common_rank_role`
--

DROP TABLE IF EXISTS `log_kf_common_rank_role`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_kf_common_rank_role` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '第一名玩家ID',
  `role_name` varchar(255) NOT NULL COMMENT '第一名昵称',
  `server_id` int(11) unsigned NOT NULL COMMENT '第一名服务器id',
  `server_num` int(11) unsigned NOT NULL COMMENT '第一名服务器标识',
  `rank_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排行榜类型',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '值',
  `sec_role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '第二名玩家id',
  `sec_role_name` varchar(255) NOT NULL COMMENT '第二名昵称',
  `sec_server_id` int(11) unsigned NOT NULL COMMENT '第二名服务器id',
  `sec_server_num` int(11) unsigned NOT NULL COMMENT '第二名服务器标识',
  `sec_value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '第二名的值',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `rank_type` (`rank_type`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服榜单结算日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_kf_common_rank_role`
--

LOCK TABLES `log_kf_common_rank_role` WRITE;
/*!40000 ALTER TABLE `log_kf_common_rank_role` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_kf_common_rank_role` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_kf_invade_boss_reward`
--

DROP TABLE IF EXISTS `log_kf_invade_boss_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_kf_invade_boss_reward` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `boss_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'BOSS_ID',
  `rank_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '伤害排名',
  `reward_list` varchar(128) NOT NULL DEFAULT '[]' COMMENT '奖励列表',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服入侵BOSS击杀奖励';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_kf_invade_boss_reward`
--

LOCK TABLES `log_kf_invade_boss_reward` WRITE;
/*!40000 ALTER TABLE `log_kf_invade_boss_reward` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_kf_invade_boss_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_kf_invade_boss_server_reward`
--

DROP TABLE IF EXISTS `log_kf_invade_boss_server_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_kf_invade_boss_server_reward` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `rank_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器伤害排名',
  `reward_list` varchar(128) NOT NULL DEFAULT '[]' COMMENT '奖励列表',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服入侵BOSS服务器排行奖励';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_kf_invade_boss_server_reward`
--

LOCK TABLES `log_kf_invade_boss_server_reward` WRITE;
/*!40000 ALTER TABLE `log_kf_invade_boss_server_reward` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_kf_invade_boss_server_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_kf_invade_count_reward`
--

DROP TABLE IF EXISTS `log_kf_invade_count_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_kf_invade_count_reward` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `count_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '次数类型',
  `reward_list` varchar(128) NOT NULL DEFAULT '[]' COMMENT '奖励列表',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服入侵次数奖励';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_kf_invade_count_reward`
--

LOCK TABLES `log_kf_invade_count_reward` WRITE;
/*!40000 ALTER TABLE `log_kf_invade_count_reward` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_kf_invade_count_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_kf_invade_server_produce`
--

DROP TABLE IF EXISTS `log_kf_invade_server_produce`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_kf_invade_server_produce` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器ID',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '产出类型:1限时资源|2真BOSS',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `server_id` (`server_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服入侵服务器产出日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_kf_invade_server_produce`
--

LOCK TABLES `log_kf_invade_server_produce` WRITE;
/*!40000 ALTER TABLE `log_kf_invade_server_produce` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_kf_invade_server_produce` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_kf_invade_server_rank`
--

DROP TABLE IF EXISTS `log_kf_invade_server_rank`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_kf_invade_server_rank` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器ID',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  `rank_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `server_id` (`server_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服入侵服务器排名';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_kf_invade_server_rank`
--

LOCK TABLES `log_kf_invade_server_rank` WRITE;
/*!40000 ALTER TABLE `log_kf_invade_server_rank` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_kf_invade_server_rank` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_kf_invade_server_rank_reward`
--

DROP TABLE IF EXISTS `log_kf_invade_server_rank_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_kf_invade_server_rank_reward` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器积分',
  `rank_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器排名',
  `reward_list` varchar(128) NOT NULL DEFAULT '[]' COMMENT '奖励列表',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服入侵服务器排名奖励';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_kf_invade_server_rank_reward`
--

LOCK TABLES `log_kf_invade_server_rank_reward` WRITE;
/*!40000 ALTER TABLE `log_kf_invade_server_rank_reward` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_kf_invade_server_rank_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_kf_invade_stage_reward`
--

DROP TABLE IF EXISTS `log_kf_invade_stage_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_kf_invade_stage_reward` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `stage_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '阶段id',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '阶段积分',
  `reward_list` varchar(128) NOT NULL DEFAULT '[]' COMMENT '奖励列表',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '领取时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服入侵阶段奖励';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_kf_invade_stage_reward`
--

LOCK TABLES `log_kf_invade_stage_reward` WRITE;
/*!40000 ALTER TABLE `log_kf_invade_stage_reward` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_kf_invade_stage_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_kf_invade_task_reward`
--

DROP TABLE IF EXISTS `log_kf_invade_task_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_kf_invade_task_reward` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `task_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '任务ID',
  `reward_list` varchar(128) NOT NULL DEFAULT '[]' COMMENT '奖励列表',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '完成时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服入侵任务奖励';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_kf_invade_task_reward`
--

LOCK TABLES `log_kf_invade_task_reward` WRITE;
/*!40000 ALTER TABLE `log_kf_invade_task_reward` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_kf_invade_task_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_kf_town_buy_good`
--

DROP TABLE IF EXISTS `log_kf_town_buy_good`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_kf_town_buy_good` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `auto_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商品唯一id',
  `good_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商品id',
  `num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '数量',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗内容',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服城战商店购买日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_kf_town_buy_good`
--

LOCK TABLES `log_kf_town_buy_good` WRITE;
/*!40000 ALTER TABLE `log_kf_town_buy_good` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_kf_town_buy_good` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_kf_town_daily_own_reward`
--

DROP TABLE IF EXISTS `log_kf_town_daily_own_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_kf_town_daily_own_reward` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `pos` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '公会职位',
  `building_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '建筑id',
  `rewards` varchar(512) NOT NULL DEFAULT '[]' COMMENT '奖励内容',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服城战每日占领奖励日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_kf_town_daily_own_reward`
--

LOCK TABLES `log_kf_town_daily_own_reward` WRITE;
/*!40000 ALTER TABLE `log_kf_town_daily_own_reward` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_kf_town_daily_own_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_kf_town_guild_apply`
--

DROP TABLE IF EXISTS `log_kf_town_guild_apply`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_kf_town_guild_apply` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `zone_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '区id',
  `building_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '建筑id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '玩家名字',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `guild_name` varchar(50) NOT NULL DEFAULT '' COMMENT '公会名字',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `zone_id` (`zone_id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服城战宣战日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_kf_town_guild_apply`
--

LOCK TABLES `log_kf_town_guild_apply` WRITE;
/*!40000 ALTER TABLE `log_kf_town_guild_apply` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_kf_town_guild_apply` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_kf_town_kill_reward`
--

DROP TABLE IF EXISTS `log_kf_town_kill_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_kf_town_kill_reward` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `zone_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '区id',
  `building_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '建筑id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '玩家名字',
  `kill_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '击杀数量',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `rewards` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励内容',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `zone_id` (`zone_id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服城战击杀数排名奖励';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_kf_town_kill_reward`
--

LOCK TABLES `log_kf_town_kill_reward` WRITE;
/*!40000 ALTER TABLE `log_kf_town_kill_reward` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_kf_town_kill_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_kf_town_result`
--

DROP TABLE IF EXISTS `log_kf_town_result`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_kf_town_result` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `zone_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '区id',
  `building_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '建筑id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `guild_name` varchar(50) NOT NULL DEFAULT '' COMMENT '公会名字',
  `ser_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器id',
  `attr_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '阵营',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `result` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '结果',
  `rewards` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励内容',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `zone_id` (`zone_id`),
  KEY `guild_id` (`guild_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服城战结果日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_kf_town_result`
--

LOCK TABLES `log_kf_town_result` WRITE;
/*!40000 ALTER TABLE `log_kf_town_result` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_kf_town_result` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_kf_town_role_reward`
--

DROP TABLE IF EXISTS `log_kf_town_role_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_kf_town_role_reward` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  `rewards` varchar(512) NOT NULL DEFAULT '[]' COMMENT '奖励内容',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服城战个人积分奖励日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_kf_town_role_reward`
--

LOCK TABLES `log_kf_town_role_reward` WRITE;
/*!40000 ALTER TABLE `log_kf_town_role_reward` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_kf_town_role_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_league_war_inner_rank_reward`
--

DROP TABLE IF EXISTS `log_league_war_inner_rank_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_league_war_inner_rank_reward` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `room_id` varchar(50) NOT NULL DEFAULT '' COMMENT '房间id',
  `victory` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '获胜阵营',
  `league_id` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '玩家所属阵营',
  `inner_rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '阵营内部排名',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '全体排名',
  `wlv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '世界等级',
  `rewards` varchar(256) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='三英会战阵营内部排名奖励日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_league_war_inner_rank_reward`
--

LOCK TABLES `log_league_war_inner_rank_reward` WRITE;
/*!40000 ALTER TABLE `log_league_war_inner_rank_reward` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_league_war_inner_rank_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_league_war_role_info`
--

DROP TABLE IF EXISTS `log_league_war_role_info`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_league_war_role_info` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `room_id` varchar(50) NOT NULL DEFAULT '' COMMENT '房间id',
  `league_id` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '所属阵营id',
  `total_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '总积分',
  `inner_rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '阵营内部排名',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '个人排名',
  `kill_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '击杀积分',
  `own_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '据点占领',
  `hurt_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '攻击据点积分',
  `own_add_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '据点提供积分',
  `online_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '在线积分',
  `die_times` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '死亡次数',
  `victory` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '获胜阵营id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='三英会战玩家信息日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_league_war_role_info`
--

LOCK TABLES `log_league_war_role_info` WRITE;
/*!40000 ALTER TABLE `log_league_war_role_info` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_league_war_role_info` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_league_war_role_rank`
--

DROP TABLE IF EXISTS `log_league_war_role_rank`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_league_war_role_rank` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号ID',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `rank` smallint(4) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最终积分',
  `wlv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '世界等级',
  `rewards` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励列表',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='个人排名奖励日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_league_war_role_rank`
--

LOCK TABLES `log_league_war_role_rank` WRITE;
/*!40000 ALTER TABLE `log_league_war_role_rank` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_league_war_role_rank` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_league_war_role_score`
--

DROP TABLE IF EXISTS `log_league_war_role_score`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_league_war_role_score` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号ID',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `stage_id` smallint(4) unsigned NOT NULL DEFAULT '0' COMMENT '阶段id',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '达到积分',
  `wlv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '世界等级',
  `rewards` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励列表',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='个人积分等级奖励日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_league_war_role_score`
--

LOCK TABLES `log_league_war_role_score` WRITE;
/*!40000 ALTER TABLE `log_league_war_role_score` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_league_war_role_score` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_league_war_room_info`
--

DROP TABLE IF EXISTS `log_league_war_room_info`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_league_war_room_info` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号id',
  `room_id` varchar(50) NOT NULL DEFAULT '' COMMENT '房间id',
  `num` smallint(4) unsigned NOT NULL DEFAULT '0' COMMENT '房间总人数',
  `scene_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '场景id',
  `red_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '红方人数',
  `red_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '红方总积分',
  `red_own_num` smallint(4) unsigned DEFAULT '0' COMMENT '红方占领据点数量',
  `blue_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '蓝方人数',
  `blue_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '蓝方总积分',
  `blue_own_num` smallint(4) unsigned DEFAULT '0' COMMENT '蓝方占领据点数量',
  `yellow_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '黄方人数',
  `yellow_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '黄方总积分',
  `yellow_own_num` smallint(4) unsigned DEFAULT '0' COMMENT '黄方占领据点数量',
  `victory` tinyint(1) NOT NULL DEFAULT '0' COMMENT '获胜阵营id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `room_id` (`room_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='三英会战战斗房间日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_league_war_room_info`
--

LOCK TABLES `log_league_war_room_info` WRITE;
/*!40000 ALTER TABLE `log_league_war_room_info` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_league_war_room_info` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_league_war_win_reward`
--

DROP TABLE IF EXISTS `log_league_war_win_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_league_war_win_reward` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `room_id` varchar(50) NOT NULL DEFAULT '' COMMENT '房间id',
  `victory` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '获胜阵营',
  `league_id` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '玩家所属阵营',
  `wlv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '世界等级',
  `rewards` varchar(256) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='三英会战阵营获胜奖励日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_league_war_win_reward`
--

LOCK TABLES `log_league_war_win_reward` WRITE;
/*!40000 ALTER TABLE `log_league_war_win_reward` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_league_war_win_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_level_rate`
--

DROP TABLE IF EXISTS `log_level_rate`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_level_rate` (
  `optiontime` int(10) NOT NULL COMMENT '操作时间',
  `data` text NOT NULL COMMENT '当天数据',
  `r_total` int(11) NOT NULL COMMENT '到当天为止总注册人数',
  `l_total` int(11) NOT NULL COMMENT '至当天为止24小时未登录人数',
  PRIMARY KEY (`optiontime`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='等级流失表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_level_rate`
--

LOCK TABLES `log_level_rate` WRITE;
/*!40000 ALTER TABLE `log_level_rate` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_level_rate` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_light_weapon_upgrade`
--

DROP TABLE IF EXISTS `log_light_weapon_upgrade`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_light_weapon_upgrade` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `role_lv` smallint(5) unsigned NOT NULL COMMENT '玩家等级',
  `weapon_id` int(11) unsigned NOT NULL COMMENT '专武id',
  `cost` varchar(512) NOT NULL COMMENT '消耗列表',
  `old_list` varchar(512) NOT NULL COMMENT '旧强化列表',
  `new_list` varchar(512) NOT NULL COMMENT '新强化列表',
  `time` int(11) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='光武系统-专武强化日志表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_light_weapon_upgrade`
--

LOCK TABLES `log_light_weapon_upgrade` WRITE;
/*!40000 ALTER TABLE `log_light_weapon_upgrade` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_light_weapon_upgrade` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_light_weapon_uplv`
--

DROP TABLE IF EXISTS `log_light_weapon_uplv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_light_weapon_uplv` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `role_lv` smallint(5) unsigned NOT NULL COMMENT '玩家等级',
  `weapon_id` int(11) unsigned NOT NULL COMMENT '专武id',
  `type` tinyint(1) unsigned NOT NULL COMMENT '操作类型',
  `cost` varchar(512) NOT NULL COMMENT '消耗列表',
  `old_lv` smallint(5) unsigned NOT NULL COMMENT '操作前等级',
  `old_exp` smallint(5) unsigned NOT NULL COMMENT '操作前经验',
  `new_lv` smallint(5) unsigned NOT NULL COMMENT '操作后等级',
  `new_exp` smallint(5) unsigned NOT NULL COMMENT '操作后经验',
  `skill_list` varchar(215) NOT NULL COMMENT '已激活技能列表',
  `time` int(11) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='光武系统-专武升级/激活日志表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_light_weapon_uplv`
--

LOCK TABLES `log_light_weapon_uplv` WRITE;
/*!40000 ALTER TABLE `log_light_weapon_uplv` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_light_weapon_uplv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_light_weapon_upstar`
--

DROP TABLE IF EXISTS `log_light_weapon_upstar`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_light_weapon_upstar` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `role_lv` smallint(5) unsigned NOT NULL COMMENT '玩家等级',
  `weapon_id` int(11) unsigned NOT NULL COMMENT '幻化id',
  `type` tinyint(1) unsigned NOT NULL COMMENT '操作类型（1激活 2升星）',
  `cost` varchar(512) NOT NULL COMMENT '消耗列表',
  `old_star` smallint(5) unsigned NOT NULL COMMENT '操作前星级',
  `new_star` smallint(5) unsigned NOT NULL COMMENT '操作后星级',
  `time` int(11) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='光武系统-光武升星日志表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_light_weapon_upstar`
--

LOCK TABLES `log_light_weapon_upstar` WRITE;
/*!40000 ALTER TABLE `log_light_weapon_upstar` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_light_weapon_upstar` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_limit_goal_reward`
--

DROP TABLE IF EXISTS `log_limit_goal_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_limit_goal_reward` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(10) unsigned NOT NULL COMMENT '玩家id',
  `lv` int(10) unsigned NOT NULL COMMENT '玩家等级',
  `vip` tinyint(2) unsigned NOT NULL COMMENT '贵族等级',
  `goal_id` smallint(10) unsigned NOT NULL COMMENT '目标id',
  `task_id` smallint(10) unsigned NOT NULL COMMENT '任务id',
  `reward` varchar(512) NOT NULL COMMENT '奖励',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='限时目标-奖励领取日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_limit_goal_reward`
--

LOCK TABLES `log_limit_goal_reward` WRITE;
/*!40000 ALTER TABLE `log_limit_goal_reward` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_limit_goal_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_limit_goal_task`
--

DROP TABLE IF EXISTS `log_limit_goal_task`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_limit_goal_task` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(10) unsigned NOT NULL COMMENT '玩家id',
  `lv` int(10) unsigned NOT NULL COMMENT '玩家等级',
  `vip` tinyint(2) unsigned NOT NULL COMMENT '贵族等级',
  `goal_id` smallint(10) unsigned NOT NULL COMMENT '目标id',
  `task_id` smallint(10) unsigned NOT NULL COMMENT '任务id',
  `condition` varchar(255) NOT NULL COMMENT '完成条件',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='限时目标-任务完成日志表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_limit_goal_task`
--

LOCK TABLES `log_limit_goal_task` WRITE;
/*!40000 ALTER TABLE `log_limit_goal_task` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_limit_goal_task` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_limit_shop_buy`
--

DROP TABLE IF EXISTS `log_limit_shop_buy`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_limit_shop_buy` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `sell_id` int(10) unsigned NOT NULL COMMENT '商品id',
  `buy_num` int(10) unsigned NOT NULL COMMENT '购买数量',
  `cost_list` varchar(50) NOT NULL COMMENT '消耗列表（打折后）',
  `goods_list` varchar(50) NOT NULL COMMENT '物品列表',
  `discount` int(10) unsigned NOT NULL COMMENT '折扣',
  `start_time` int(10) unsigned NOT NULL COMMENT '该商品开始可购买时间',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='神秘限购购买日志表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_limit_shop_buy`
--

LOCK TABLES `log_limit_shop_buy` WRITE;
/*!40000 ALTER TABLE `log_limit_shop_buy` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_limit_shop_buy` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_live_skill_handle`
--

DROP TABLE IF EXISTS `log_live_skill_handle`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_live_skill_handle` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `skill_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '技能类型',
  `old_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '旧技能等级',
  `add_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '增加成熟度',
  `new_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '新技能等级',
  `cost_live` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '消耗活力',
  `cost` varchar(50) NOT NULL DEFAULT '[]' COMMENT '消耗材料',
  `reward` varchar(50) NOT NULL DEFAULT '[]' COMMENT '获得内容',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='生活技能烹饪/打造日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_live_skill_handle`
--

LOCK TABLES `log_live_skill_handle` WRITE;
/*!40000 ALTER TABLE `log_live_skill_handle` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_live_skill_handle` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_liveness_up`
--

DROP TABLE IF EXISTS `log_liveness_up`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_liveness_up` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `pre_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '升级前外形等级',
  `liveness` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '升级消耗活跃度',
  `after_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '升级后外形等级',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`) USING BTREE,
  KEY `role_id` (`role_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='活跃度外形升级日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_liveness_up`
--

LOCK TABLES `log_liveness_up` WRITE;
/*!40000 ALTER TABLE `log_liveness_up` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_liveness_up` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_local_picture`
--

DROP TABLE IF EXISTS `log_local_picture`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_local_picture` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '主键',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `profile_photo_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '头像id',
  `time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='更改本地头像日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_local_picture`
--

LOCK TABLES `log_local_picture` WRITE;
/*!40000 ALTER TABLE `log_local_picture` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_local_picture` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_login`
--

DROP TABLE IF EXISTS `log_login`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_login` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色ID',
  `ip` varchar(50) NOT NULL DEFAULT '' COMMENT '登录IP',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '登录时间',
  `accid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '平台id',
  `accname` varchar(100) NOT NULL COMMENT '账号',
  `login_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '登录类型(1登录2重连)',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `time` (`time`),
  KEY `accname` (`accname`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='登录日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_login`
--

LOCK TABLES `log_login` WRITE;
/*!40000 ALTER TABLE `log_login` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_login` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_login_logout`
--

DROP TABLE IF EXISTS `log_login_logout`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_login_logout` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '操作类型',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作时间',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家等级',
  `power` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '玩家战力',
  `scene_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '场景Id',
  `ip` varchar(50) NOT NULL DEFAULT '' COMMENT '玩家IP',
  `network_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '网络类型',
  `accid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '平台PID',
  `accname` varchar(100) NOT NULL COMMENT '账号',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `time` (`time`),
  KEY `type` (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='登录登出日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_login_logout`
--

LOCK TABLES `log_login_logout` WRITE;
/*!40000 ALTER TABLE `log_login_logout` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_login_logout` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_login_return_reward`
--

DROP TABLE IF EXISTS `log_login_return_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_login_return_reward` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `subtype` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `grade` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '奖励档次',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '状态',
  `cost` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `subtype` (`subtype`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='0元豪礼日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_login_return_reward`
--

LOCK TABLES `log_login_return_reward` WRITE;
/*!40000 ALTER TABLE `log_login_return_reward` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_login_return_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_login_reward_day`
--

DROP TABLE IF EXISTS `log_login_reward_day`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_login_reward_day` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `day_id` int(10) unsigned NOT NULL COMMENT '天数id',
  `get_date` int(10) unsigned NOT NULL COMMENT '获得的当日0点时间戳',
  `reward_list` varchar(255) NOT NULL COMMENT '奖励列表',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='七天登录奖励日志表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_login_reward_day`
--

LOCK TABLES `log_login_reward_day` WRITE;
/*!40000 ALTER TABLE `log_login_reward_day` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_login_reward_day` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_login_statis`
--

DROP TABLE IF EXISTS `log_login_statis`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_login_statis` (
  `time` int(10) NOT NULL COMMENT '记录时间',
  `source` varchar(50) NOT NULL DEFAULT '' COMMENT '来源',
  `lv_num` int(11) NOT NULL COMMENT '10级以上人数',
  `login_num` int(11) NOT NULL COMMENT '二天登录人数',
  `login_ip_num` int(11) NOT NULL COMMENT '登录IP数',
  `lv_json` text NOT NULL COMMENT '二天登录人数对应等级分布人数',
  PRIMARY KEY (`time`,`source`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='连续登录统计';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_login_statis`
--

LOCK TABLES `log_login_statis` WRITE;
/*!40000 ALTER TABLE `log_login_statis` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_login_statis` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_lucky_flop_draw`
--

DROP TABLE IF EXISTS `log_lucky_flop_draw`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_lucky_flop_draw` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `sub_type` int(11) unsigned NOT NULL COMMENT '活动子类型',
  `cost` varchar(255) NOT NULL COMMENT '消耗列表',
  `reward` varchar(512) NOT NULL COMMENT '奖励列表',
  `now_times` tinyint(1) unsigned NOT NULL COMMENT '抽奖次数',
  `turn` smallint(5) unsigned NOT NULL COMMENT '当前轮数',
  `total_times` smallint(5) unsigned NOT NULL COMMENT '累计抽奖次数',
  `time` int(11) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`),
  KEY `sub_type` (`sub_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='幸运翻牌-抽奖日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_lucky_flop_draw`
--

LOCK TABLES `log_lucky_flop_draw` WRITE;
/*!40000 ALTER TABLE `log_lucky_flop_draw` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_lucky_flop_draw` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_lucky_flop_receive`
--

DROP TABLE IF EXISTS `log_lucky_flop_receive`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_lucky_flop_receive` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `sub_type` int(11) unsigned NOT NULL COMMENT '活动子类型',
  `reward` varchar(512) NOT NULL COMMENT '奖励列表',
  `times` tinyint(1) unsigned NOT NULL COMMENT '奖励档次',
  `time` int(11) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`),
  KEY `sub_type` (`sub_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='幸运翻牌-累计奖励日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_lucky_flop_receive`
--

LOCK TABLES `log_lucky_flop_receive` WRITE;
/*!40000 ALTER TABLE `log_lucky_flop_receive` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_lucky_flop_receive` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_lucky_flop_reset`
--

DROP TABLE IF EXISTS `log_lucky_flop_reset`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_lucky_flop_reset` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `type` tinyint(1) unsigned NOT NULL COMMENT '重置类型(1收费 0免费)',
  `cost_list` varchar(255) NOT NULL COMMENT '重置消耗',
  `turn` int(11) unsigned NOT NULL COMMENT '当前轮数',
  `time` int(11) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='幸运翻牌-重置日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_lucky_flop_reset`
--

LOCK TABLES `log_lucky_flop_reset` WRITE;
/*!40000 ALTER TABLE `log_lucky_flop_reset` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_lucky_flop_reset` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_mail_clear`
--

DROP TABLE IF EXISTS `log_mail_clear`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_mail_clear` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '收件人id',
  `title` varchar(50) NOT NULL DEFAULT '' COMMENT '邮件标题',
  `cm_attachment` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '附件',
  `module_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `sub_module_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '子功能id',
  `state` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '状态',
  `effect_st` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '有效开始时间',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `rid` (`rid`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='邮件后台删除日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_mail_clear`
--

LOCK TABLES `log_mail_clear` WRITE;
/*!40000 ALTER TABLE `log_mail_clear` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_mail_clear` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_mail_get`
--

DROP TABLE IF EXISTS `log_mail_get`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_mail_get` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `mail_id` bigint(20) unsigned NOT NULL COMMENT '邮件id',
  `sid` bigint(20) unsigned NOT NULL COMMENT '发件人id',
  `rid` bigint(20) unsigned NOT NULL COMMENT '收件人id',
  `title` varchar(50) NOT NULL DEFAULT '' COMMENT '邮件标题',
  `module_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `sub_module_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '子功能id',
  `cm_attachment` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '普通附件',
  `timestamp` bigint(21) unsigned NOT NULL DEFAULT '0' COMMENT '时间戳（微秒）',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '插入时间',
  PRIMARY KEY (`id`),
  KEY `sid` (`sid`),
  KEY `timestamp` (`timestamp`),
  KEY `rid` (`rid`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='邮件领取日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_mail_get`
--

LOCK TABLES `log_mail_get` WRITE;
/*!40000 ALTER TABLE `log_mail_get` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_mail_get` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_mail_send`
--

DROP TABLE IF EXISTS `log_mail_send`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_mail_send` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `mail_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '邮件id',
  `sid` bigint(20) unsigned NOT NULL COMMENT '发件人id',
  `rid` bigint(20) unsigned NOT NULL COMMENT '收件人id',
  `title` varchar(50) NOT NULL DEFAULT '' COMMENT '邮件标题',
  `cm_attachment` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '普通附件',
  `module_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `sub_module_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '子功能id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '插入时间',
  PRIMARY KEY (`id`),
  KEY `sid` (`sid`),
  KEY `rid` (`rid`),
  KEY `mail_id` (`mail_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='邮件发送日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_mail_send`
--

LOCK TABLES `log_mail_send` WRITE;
/*!40000 ALTER TABLE `log_mail_send` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_mail_send` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_marriage_answer`
--

DROP TABLE IF EXISTS `log_marriage_answer`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_marriage_answer` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id_1` bigint(20) unsigned NOT NULL COMMENT '求婚玩家id',
  `role_id_2` bigint(20) unsigned NOT NULL COMMENT '被求婚玩家id',
  `type` int(10) unsigned NOT NULL COMMENT '类型（1表白 2求婚）',
  `answer_type` int(10) unsigned NOT NULL COMMENT '回答类型（1答应 2拒绝）',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='婚姻-求婚回应日志表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_marriage_answer`
--

LOCK TABLES `log_marriage_answer` WRITE;
/*!40000 ALTER TABLE `log_marriage_answer` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_marriage_answer` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_marriage_divorse`
--

DROP TABLE IF EXISTS `log_marriage_divorse`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_marriage_divorse` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id_m` bigint(20) unsigned NOT NULL COMMENT '男方玩家id',
  `role_id_w` bigint(20) unsigned NOT NULL COMMENT '女方玩家id',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '发起离婚玩家id',
  `type` int(10) unsigned NOT NULL COMMENT '分手类型（1分手 2离婚）',
  `cost_list` varchar(255) NOT NULL COMMENT '消耗列表',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='婚姻-分手/离婚日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_marriage_divorse`
--

LOCK TABLES `log_marriage_divorse` WRITE;
/*!40000 ALTER TABLE `log_marriage_divorse` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_marriage_divorse` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_marriage_life_train`
--

DROP TABLE IF EXISTS `log_marriage_life_train`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_marriage_life_train` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `old_stage` int(10) unsigned NOT NULL COMMENT '旧阶数',
  `old_heart` int(10) unsigned NOT NULL COMMENT '旧心数',
  `old_love_num` int(10) unsigned NOT NULL COMMENT '旧恩爱值',
  `new_stage` int(10) unsigned NOT NULL COMMENT '新阶数',
  `new_heart` int(10) unsigned NOT NULL COMMENT '新心数',
  `new_love_num` int(10) unsigned NOT NULL COMMENT '新恩爱值',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='婚姻-一生一世培养日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_marriage_life_train`
--

LOCK TABLES `log_marriage_life_train` WRITE;
/*!40000 ALTER TABLE `log_marriage_life_train` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_marriage_life_train` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_marriage_love_box`
--

DROP TABLE IF EXISTS `log_marriage_love_box`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_marriage_love_box` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id_m` bigint(10) unsigned NOT NULL COMMENT '男方角色id',
  `role_id_w` bigint(10) unsigned NOT NULL COMMENT '女方角色id',
  `role_id` bigint(10) unsigned NOT NULL COMMENT '操作角色id',
  `type` tinyint(2) unsigned NOT NULL COMMENT '操作类型',
  `object_list` varchar(255) NOT NULL COMMENT '消耗/奖励列表',
  `timeout` int(10) unsigned NOT NULL COMMENT '过期时间',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id_m` (`role_id_m`),
  KEY `role_id_w` (`role_id_w`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='爱情宝盒日志表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_marriage_love_box`
--

LOCK TABLES `log_marriage_love_box` WRITE;
/*!40000 ALTER TABLE `log_marriage_love_box` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_marriage_love_box` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_marriage_parade_end`
--

DROP TABLE IF EXISTS `log_marriage_parade_end`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_marriage_parade_end` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id_m` bigint(20) unsigned NOT NULL COMMENT '男方玩家id',
  `role_id_w` bigint(20) unsigned NOT NULL COMMENT '女方玩家id',
  `man_in` int(10) unsigned NOT NULL COMMENT '男方是否进场（0否 1是）',
  `woman_in` int(10) unsigned NOT NULL COMMENT '女方是否进场（0否 1是）',
  `end_type` int(10) unsigned NOT NULL COMMENT '结束类型（1正常结束 2服务器维护 3未入场）',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id_m` (`role_id_m`),
  KEY `role_id_w` (`role_id_w`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='巡游-巡游结束日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_marriage_parade_end`
--

LOCK TABLES `log_marriage_parade_end` WRITE;
/*!40000 ALTER TABLE `log_marriage_parade_end` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_marriage_parade_end` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_marriage_parade_order`
--

DROP TABLE IF EXISTS `log_marriage_parade_order`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_marriage_parade_order` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id_m` bigint(20) unsigned NOT NULL COMMENT '男方玩家id',
  `role_id_w` bigint(20) unsigned NOT NULL COMMENT '女方玩家id',
  `order_time` int(10) unsigned NOT NULL COMMENT '预约时间',
  `parade_type` int(10) unsigned NOT NULL COMMENT '婚礼类型',
  `order_type` int(10) unsigned NOT NULL COMMENT '预约类型（1巡游预约 2再次预约 3巡游卡预约）',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id_m` (`role_id_m`),
  KEY `role_id_w` (`role_id_w`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='巡游-巡游预约日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_marriage_parade_order`
--

LOCK TABLES `log_marriage_parade_order` WRITE;
/*!40000 ALTER TABLE `log_marriage_parade_order` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_marriage_parade_order` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_marriage_propose`
--

DROP TABLE IF EXISTS `log_marriage_propose`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_marriage_propose` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id_1` bigint(20) unsigned NOT NULL COMMENT '求婚玩家id',
  `role_id_2` bigint(20) unsigned NOT NULL COMMENT '被求婚玩家id',
  `type` int(10) unsigned NOT NULL COMMENT '类型（1表白 2求婚）',
  `wedding_type` int(10) unsigned NOT NULL COMMENT '婚礼类型',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='婚姻-求婚日志表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_marriage_propose`
--

LOCK TABLES `log_marriage_propose` WRITE;
/*!40000 ALTER TABLE `log_marriage_propose` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_marriage_propose` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_marriage_ring_polish`
--

DROP TABLE IF EXISTS `log_marriage_ring_polish`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_marriage_ring_polish` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT ' 序号',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `old_polish_list` varchar(255) NOT NULL COMMENT '旧打磨列表',
  `new_polish_list` varchar(255) NOT NULL COMMENT '新打磨列表',
  `cost_list` varchar(255) NOT NULL COMMENT '消耗列表',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='婚姻-戒指打磨日志表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_marriage_ring_polish`
--

LOCK TABLES `log_marriage_ring_polish` WRITE;
/*!40000 ALTER TABLE `log_marriage_ring_polish` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_marriage_ring_polish` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_marriage_ring_upgrade`
--

DROP TABLE IF EXISTS `log_marriage_ring_upgrade`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_marriage_ring_upgrade` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(10) unsigned NOT NULL COMMENT '玩家id',
  `old_stage` int(10) unsigned NOT NULL COMMENT '旧阶数',
  `old_star` int(10) unsigned NOT NULL COMMENT '旧星数',
  `old_pray_num` int(10) unsigned NOT NULL COMMENT '旧祝福值',
  `new_stage` int(10) unsigned NOT NULL COMMENT '新阶数',
  `new_star` int(10) unsigned NOT NULL COMMENT '新星数',
  `new_pray_num` int(10) unsigned NOT NULL COMMENT '新祝福值',
  `cost_list` varchar(255) NOT NULL COMMENT '消耗列表',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='婚姻-戒指提升日志表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_marriage_ring_upgrade`
--

LOCK TABLES `log_marriage_ring_upgrade` WRITE;
/*!40000 ALTER TABLE `log_marriage_ring_upgrade` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_marriage_ring_upgrade` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_marriage_wedding_aura`
--

DROP TABLE IF EXISTS `log_marriage_wedding_aura`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_marriage_wedding_aura` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id_m` bigint(20) unsigned NOT NULL COMMENT '男方玩家id',
  `role_id_w` bigint(20) unsigned NOT NULL COMMENT '女方玩家id',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `type` int(10) unsigned NOT NULL COMMENT '操作类型（1消灭捣蛋鬼 2撒喜糖 3放烟花 4吃婚宴 5发弹幕）',
  `old_aura` int(10) unsigned NOT NULL COMMENT '旧气氛值',
  `new_aura` int(10) unsigned NOT NULL COMMENT '新气氛值',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='婚姻-婚礼气氛值日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_marriage_wedding_aura`
--

LOCK TABLES `log_marriage_wedding_aura` WRITE;
/*!40000 ALTER TABLE `log_marriage_wedding_aura` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_marriage_wedding_aura` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_marriage_wedding_end`
--

DROP TABLE IF EXISTS `log_marriage_wedding_end`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_marriage_wedding_end` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id_m` bigint(20) unsigned NOT NULL COMMENT '男方玩家id',
  `role_id_w` bigint(20) unsigned NOT NULL COMMENT '女方玩家id',
  `man_in` int(10) unsigned NOT NULL COMMENT '男方是否进场（0否 1是）',
  `woman_in` int(10) unsigned NOT NULL COMMENT '女方是否进场（0否 1是）',
  `end_type` int(10) unsigned NOT NULL COMMENT '结束类型（1正常结束 2双方没有进入婚礼结婚结束 3婚礼未结束重启）',
  `enter_role_id_list` varchar(1024) NOT NULL COMMENT '进入过场景的玩家id列表',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='婚姻-婚礼结束日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_marriage_wedding_end`
--

LOCK TABLES `log_marriage_wedding_end` WRITE;
/*!40000 ALTER TABLE `log_marriage_wedding_end` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_marriage_wedding_end` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_marriage_wedding_invitation`
--

DROP TABLE IF EXISTS `log_marriage_wedding_invitation`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_marriage_wedding_invitation` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id_m` bigint(10) unsigned NOT NULL COMMENT '男方角色id',
  `role_id_w` bigint(10) unsigned NOT NULL COMMENT '女方角色id',
  `wedding_type` tinyint(2) unsigned NOT NULL COMMENT '婚礼类型',
  `role_id` bigint(10) unsigned NOT NULL COMMENT '邀请玩家id',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id_m` (`role_id_m`),
  KEY `role_id_w` (`role_id_w`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='婚礼日志-宾客邀请表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_marriage_wedding_invitation`
--

LOCK TABLES `log_marriage_wedding_invitation` WRITE;
/*!40000 ALTER TABLE `log_marriage_wedding_invitation` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_marriage_wedding_invitation` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_marriage_wedding_order`
--

DROP TABLE IF EXISTS `log_marriage_wedding_order`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_marriage_wedding_order` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id_m` bigint(20) unsigned NOT NULL COMMENT '男方玩家id',
  `role_id_w` bigint(20) unsigned NOT NULL COMMENT '女方玩家id',
  `order_time` int(10) unsigned NOT NULL COMMENT '预约时间',
  `wedding_type` int(10) unsigned NOT NULL COMMENT '婚礼类型',
  `order_type` int(10) unsigned NOT NULL COMMENT '预约类型（1结婚预约 2结婚卡预约 3再次预约）',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='婚姻-婚礼预约日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_marriage_wedding_order`
--

LOCK TABLES `log_marriage_wedding_order` WRITE;
/*!40000 ALTER TABLE `log_marriage_wedding_order` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_marriage_wedding_order` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_melee_pk_rank_reward`
--

DROP TABLE IF EXISTS `log_melee_pk_rank_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_melee_pk_rank_reward` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `score` int(10) unsigned NOT NULL COMMENT '积分',
  `rank_id` int(10) unsigned NOT NULL COMMENT '排名',
  `world_lv` int(10) unsigned NOT NULL COMMENT '世界等级',
  `reward_list` varchar(512) NOT NULL COMMENT '奖励列表',
  `time` int(10) unsigned DEFAULT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='大乱斗排行奖励日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_melee_pk_rank_reward`
--

LOCK TABLES `log_melee_pk_rank_reward` WRITE;
/*!40000 ALTER TABLE `log_melee_pk_rank_reward` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_melee_pk_rank_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_melee_pk_stage_reward`
--

DROP TABLE IF EXISTS `log_melee_pk_stage_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_melee_pk_stage_reward` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `stage_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '阶段id',
  `score` int(10) unsigned NOT NULL COMMENT '达到积分',
  `world_lv` int(10) unsigned NOT NULL COMMENT '世界等级',
  `reward_list` varchar(512) NOT NULL COMMENT '奖励列表',
  `time` int(10) unsigned DEFAULT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='大乱斗阶段奖励日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_melee_pk_stage_reward`
--

LOCK TABLES `log_melee_pk_stage_reward` WRITE;
/*!40000 ALTER TABLE `log_melee_pk_stage_reward` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_melee_pk_stage_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_mold_soul_upgrade`
--

DROP TABLE IF EXISTS `log_mold_soul_upgrade`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_mold_soul_upgrade` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `mold_soul_id` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '铸魂id',
  `old_lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '强化前等级',
  `new_lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '强化后等级',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '强化消耗',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='铸魂强化日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_mold_soul_upgrade`
--

LOCK TABLES `log_mold_soul_upgrade` WRITE;
/*!40000 ALTER TABLE `log_mold_soul_upgrade` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_mold_soul_upgrade` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_month_check_in`
--

DROP TABLE IF EXISTS `log_month_check_in`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_month_check_in` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `vip_lv` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT 'vip等级',
  `check_day` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '签到天数',
  `check_type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '奖励途径',
  `reward` varchar(256) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='月签到日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_month_check_in`
--

LOCK TABLES `log_month_check_in` WRITE;
/*!40000 ALTER TABLE `log_month_check_in` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_month_check_in` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_mount_equip_make`
--

DROP TABLE IF EXISTS `log_mount_equip_make`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_mount_equip_make` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `goods_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '基础装备id',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗材料',
  `get_goods_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '打造物品id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='坐骑装备打造日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_mount_equip_make`
--

LOCK TABLES `log_mount_equip_make` WRITE;
/*!40000 ALTER TABLE `log_mount_equip_make` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_mount_equip_make` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_mount_equip_stren`
--

DROP TABLE IF EXISTS `log_mount_equip_stren`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_mount_equip_stren` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `pos` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '部位id',
  `lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '操作前等级',
  `now_lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '操作后等级',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '获得经验',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='坐骑装备升级日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_mount_equip_stren`
--

LOCK TABLES `log_mount_equip_stren` WRITE;
/*!40000 ALTER TABLE `log_mount_equip_stren` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_mount_equip_stren` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_mount_figure_upgrade_stage`
--

DROP TABLE IF EXISTS `log_mount_figure_upgrade_stage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_mount_figure_upgrade_stage` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `figure_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '幻形id',
  `type` tinyint(1) NOT NULL DEFAULT '0' COMMENT '操作类型',
  `pre_stage` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '之前阶数',
  `pre_blessing` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '之前祝福值',
  `blessing_plus` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '祝福值增加',
  `cur_stage` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '当前阶数',
  `cur_blessing` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '当前祝福值',
  `cost` varchar(50) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='坐骑幻形升阶日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_mount_figure_upgrade_stage`
--

LOCK TABLES `log_mount_figure_upgrade_stage` WRITE;
/*!40000 ALTER TABLE `log_mount_figure_upgrade_stage` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_mount_figure_upgrade_stage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_mount_goods_use`
--

DROP TABLE IF EXISTS `log_mount_goods_use`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_mount_goods_use` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品id',
  `use_times` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '使用次数',
  `times_lim` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '次数上限',
  `pre_attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '培养前属性',
  `cur_attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '培养后属性',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `goods_id` (`goods_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='坐骑道具培养日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_mount_goods_use`
--

LOCK TABLES `log_mount_goods_use` WRITE;
/*!40000 ALTER TABLE `log_mount_goods_use` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_mount_goods_use` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_mount_limit_figure`
--

DROP TABLE IF EXISTS `log_mount_limit_figure`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_mount_limit_figure` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `figure_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '幻化id',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `cost` varchar(50) NOT NULL DEFAULT '[]' COMMENT '消耗内容',
  `end_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '限时结束时间',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='坐骑限时幻化激活';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_mount_limit_figure`
--

LOCK TABLES `log_mount_limit_figure` WRITE;
/*!40000 ALTER TABLE `log_mount_limit_figure` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_mount_limit_figure` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_mount_upgrade_star`
--

DROP TABLE IF EXISTS `log_mount_upgrade_star`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_mount_upgrade_star` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `pre_stage` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '之前阶数',
  `pre_star` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '之前星级',
  `pre_blessing` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '之前祝福值',
  `blessing_plus` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '祝福值增加',
  `cur_stage` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '当前阶数',
  `cur_star` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '当前星级',
  `cur_blessing` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '当前祝福值',
  `cost` varchar(50) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='坐骑升星日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_mount_upgrade_star`
--

LOCK TABLES `log_mount_upgrade_star` WRITE;
/*!40000 ALTER TABLE `log_mount_upgrade_star` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_mount_upgrade_star` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_multi_dungeon`
--

DROP TABLE IF EXISTS `log_multi_dungeon`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_multi_dungeon` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '唯一编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `combat_power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战力',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `dun_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本id',
  `dun_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本类型',
  `diff_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本难度',
  `team_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '队伍id',
  `help_type` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '是否助战##0:非助战,1:助战',
  `role_id1` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '队友1的id',
  `role_id2` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '队友2的id',
  `role_id3` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '队友3的id',
  `reward_list` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '掉落奖励',
  `grade` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '评级',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分数',
  `level_score_list` varchar(3000) NOT NULL DEFAULT '[]' COMMENT '关卡分数##[{关卡,开始时间,结束时间,关卡结算时间,分数}]',
  `intimacy_score_list` varchar(300) NOT NULL DEFAULT '[]' COMMENT '亲密度分数列表##[{对方id,亲密度,亲密度等级,分数}]',
  `rela_score_list` varchar(300) NOT NULL DEFAULT '[]' COMMENT '好友加分##[{玩家id,好友类型,是否请求加好友,分数}]',
  `guild_score_list` varchar(300) NOT NULL DEFAULT '[]' COMMENT '公会积分##[{玩家id,公会id,是否邀请进入公会,分数}]',
  `time_score_list` varchar(300) NOT NULL DEFAULT '[]' COMMENT '时间分数##[{开始时间,结束时间,通关时间,分数}]',
  `mon_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '怪物积分',
  `result_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '结果',
  `result_subtype` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '子类型',
  `log_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '记录类型',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `dun_id` (`dun_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='多人副本';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_multi_dungeon`
--

LOCK TABLES `log_multi_dungeon` WRITE;
/*!40000 ALTER TABLE `log_multi_dungeon` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_multi_dungeon` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_noon_quiz`
--

DROP TABLE IF EXISTS `log_noon_quiz`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_noon_quiz` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '唯一id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `room_id` varchar(255) NOT NULL DEFAULT '0' COMMENT '房间号',
  `right_num` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '答对数量',
  `wrong_num` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '错误数量',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '答题积分',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分排行',
  `reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '获得奖励',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '获得经验',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间戳',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='中午答题积分排行日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_noon_quiz`
--

LOCK TABLES `log_noon_quiz` WRITE;
/*!40000 ALTER TABLE `log_noon_quiz` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_noon_quiz` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_normal_combat_power`
--

DROP TABLE IF EXISTS `log_normal_combat_power`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_normal_combat_power` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `module_id` int(11) unsigned NOT NULL COMMENT '功能id',
  `type` tinyint(1) unsigned NOT NULL COMMENT '操作类型',
  `old_power` int(11) unsigned NOT NULL COMMENT '操作前战力',
  `new_power` int(11) unsigned NOT NULL COMMENT '操作后战力',
  `remark` varchar(512) NOT NULL COMMENT '备注@lang@',
  `time` int(11) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `module_id` (`module_id`),
  KEY `type` (`type`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='通用战力日志表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_normal_combat_power`
--

LOCK TABLES `log_normal_combat_power` WRITE;
/*!40000 ALTER TABLE `log_normal_combat_power` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_normal_combat_power` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_offline`
--

DROP TABLE IF EXISTS `log_offline`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_offline` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `offline_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '登出类型',
  `power` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '玩家下线时战力',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家登出日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_offline`
--

LOCK TABLES `log_offline` WRITE;
/*!40000 ALTER TABLE `log_offline` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_offline` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_onhook`
--

DROP TABLE IF EXISTS `log_onhook`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_onhook` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '日志类型',
  `onhook_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '剩余挂机时间',
  `goods_list` varchar(128) NOT NULL DEFAULT '[]' COMMENT '消耗离线时间卡',
  `time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `type` (`type`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='离线挂机记录';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_onhook`
--

LOCK TABLES `log_onhook` WRITE;
/*!40000 ALTER TABLE `log_onhook` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_onhook` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_onhook_result`
--

DROP TABLE IF EXISTS `log_onhook_result`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_onhook_result` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `onhook_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '挂机类型',
  `cost_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '离线时长',
  `onhook_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '剩余挂机时间',
  `start_lv` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '玩家开始挂机等级',
  `after_lv` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '玩家结束挂机等级',
  `exp` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家获得经验',
  `exp_ratio` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '经验倍数',
  `reward_equip_list` varchar(4096) NOT NULL DEFAULT '[]' COMMENT '装备奖励列表',
  `reward_goods_list` varchar(4096) NOT NULL DEFAULT '[]' COMMENT '道具奖励列表',
  `devour_list` varchar(4096) NOT NULL DEFAULT '[]' COMMENT '吞噬装备列表',
  `devour_exp` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '吞噬活动经验',
  `sell_list` varchar(4096) NOT NULL DEFAULT '[]' COMMENT '出售装备列表',
  `sell_rewards` varchar(128) NOT NULL DEFAULT '[]' COMMENT '出售获得奖励',
  `time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '日志时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='离线挂机结果日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_onhook_result`
--

LOCK TABLES `log_onhook_result` WRITE;
/*!40000 ALTER TABLE `log_onhook_result` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_onhook_result` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_online`
--

DROP TABLE IF EXISTS `log_online`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_online` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `total` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '总在线',
  `online` varchar(100) NOT NULL COMMENT '各线人数',
  `timestamp` int(11) unsigned NOT NULL COMMENT '时间戳',
  `onhook` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '离线挂机玩家人数',
  PRIMARY KEY (`id`),
  KEY `timestamp` (`timestamp`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='在线人数统计';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_online`
--

LOCK TABLES `log_online` WRITE;
/*!40000 ALTER TABLE `log_online` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_online` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_online_gift`
--

DROP TABLE IF EXISTS `log_online_gift`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_online_gift` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `role_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '角色等级',
  `subtype` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `online_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '累积在线时长',
  `grade_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励档次',
  `reward_list` varchar(256) NOT NULL DEFAULT '[]' COMMENT '在线奖励',
  `reward_multiple` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励倍数',
  `achieve_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励完成时间',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='累积在线奖励日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_online_gift`
--

LOCK TABLES `log_online_gift` WRITE;
/*!40000 ALTER TABLE `log_online_gift` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_online_gift` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_parade_follow`
--

DROP TABLE IF EXISTS `log_parade_follow`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_parade_follow` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id_m` bigint(20) unsigned NOT NULL COMMENT '男方id',
  `role_id_w` bigint(20) unsigned NOT NULL COMMENT '女方id',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `follow_time` int(10) unsigned NOT NULL COMMENT '跟随时长',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id_m` (`role_id_m`),
  KEY `role_id_w` (`role_id_w`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='巡游-巡游跟随日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_parade_follow`
--

LOCK TABLES `log_parade_follow` WRITE;
/*!40000 ALTER TABLE `log_parade_follow` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_parade_follow` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_parade_wedding_aura`
--

DROP TABLE IF EXISTS `log_parade_wedding_aura`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_parade_wedding_aura` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id_m` bigint(20) unsigned NOT NULL COMMENT '男方玩家id',
  `role_id_w` bigint(20) unsigned NOT NULL COMMENT '女方玩家id',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `type` int(10) unsigned NOT NULL COMMENT '操作类型（1撒鲜花 2放烟花 3击杀怪物）',
  `old_aura` int(10) unsigned NOT NULL COMMENT '旧气氛值',
  `new_aura` int(10) unsigned NOT NULL COMMENT '新气氛值',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id_m` (`role_id_m`),
  KEY `role_id_w` (`role_id_w`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='巡游-巡游气氛值日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_parade_wedding_aura`
--

LOCK TABLES `log_parade_wedding_aura` WRITE;
/*!40000 ALTER TABLE `log_parade_wedding_aura` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_parade_wedding_aura` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_partner_add_exp`
--

DROP TABLE IF EXISTS `log_partner_add_exp`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_partner_add_exp` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `partner_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '伙伴id',
  `quality` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '品质',
  `objectlist` varchar(128) NOT NULL DEFAULT '[]' COMMENT '物品消耗',
  `old_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '旧等级',
  `new_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '新等级',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `partner_id` (`partner_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='伙伴经验提升日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_partner_add_exp`
--

LOCK TABLES `log_partner_add_exp` WRITE;
/*!40000 ALTER TABLE `log_partner_add_exp` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_partner_add_exp` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_partner_break`
--

DROP TABLE IF EXISTS `log_partner_break`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_partner_break` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `partner_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '伙伴id',
  `attr_before` varchar(1024) NOT NULL DEFAULT '0' COMMENT '突破前属性',
  `attr_after` varchar(1024) NOT NULL DEFAULT '0' COMMENT '突破后属性',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '突破时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `partner_id` (`partner_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='伙伴突破日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_partner_break`
--

LOCK TABLES `log_partner_break` WRITE;
/*!40000 ALTER TABLE `log_partner_break` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_partner_break` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_partner_disband`
--

DROP TABLE IF EXISTS `log_partner_disband`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_partner_disband` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `partner_info` varchar(256) NOT NULL DEFAULT '[]' COMMENT '伙伴信息',
  `apti_take` varchar(128) NOT NULL DEFAULT '[]' COMMENT '资质丹服用数量',
  `sk_learn` varchar(128) NOT NULL DEFAULT '[]' COMMENT '技能学习',
  `reward` varchar(128) NOT NULL DEFAULT '[]' COMMENT '遣散奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='伙伴遣散日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_partner_disband`
--

LOCK TABLES `log_partner_disband` WRITE;
/*!40000 ALTER TABLE `log_partner_disband` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_partner_disband` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_partner_equip`
--

DROP TABLE IF EXISTS `log_partner_equip`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_partner_equip` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `partner_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '伙伴id',
  `quality` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '品质',
  `objectlist` varchar(128) NOT NULL DEFAULT '0' COMMENT '物品消耗',
  `combat_power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '伙伴战力',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '激活时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `partner_id` (`partner_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='伙伴激活武器日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_partner_equip`
--

LOCK TABLES `log_partner_equip` WRITE;
/*!40000 ALTER TABLE `log_partner_equip` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_partner_equip` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_partner_learn_sk`
--

DROP TABLE IF EXISTS `log_partner_learn_sk`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_partner_learn_sk` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `partner_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '伙伴id',
  `quality` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '品质',
  `skill_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能id',
  `objectlist` varchar(128) NOT NULL DEFAULT '[]' COMMENT '物品消耗',
  `combat_power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战力',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `partner_id` (`partner_id`),
  KEY `skill_id` (`skill_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='伙伴技能学习日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_partner_learn_sk`
--

LOCK TABLES `log_partner_learn_sk` WRITE;
/*!40000 ALTER TABLE `log_partner_learn_sk` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_partner_learn_sk` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_partner_promote`
--

DROP TABLE IF EXISTS `log_partner_promote`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_partner_promote` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `partner_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '伙伴id',
  `quality` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '品质',
  `objectlist` varchar(128) NOT NULL DEFAULT '[]' COMMENT '物品消耗',
  `attr_before` varchar(256) NOT NULL DEFAULT '0' COMMENT '突破前属性',
  `attr_after` varchar(256) NOT NULL DEFAULT '0' COMMENT '突破后属性',
  `combat_power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战力',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `partner_id` (`partner_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='伙伴资质提升日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_partner_promote`
--

LOCK TABLES `log_partner_promote` WRITE;
/*!40000 ALTER TABLE `log_partner_promote` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_partner_promote` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_partner_recruit`
--

DROP TABLE IF EXISTS `log_partner_recruit`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_partner_recruit` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `log_recruit_type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '招募类型',
  `objectlist` varchar(128) NOT NULL DEFAULT '[]' COMMENT '物品消耗',
  `reward` varchar(128) NOT NULL DEFAULT '[]' COMMENT '物品奖励',
  `partner_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '伙伴id',
  `quality` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '品质',
  `combat_power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战力',
  `attr_str` varchar(512) NOT NULL DEFAULT '[]' COMMENT '属性',
  `sk_list` varchar(256) NOT NULL DEFAULT '[]' COMMENT '技能',
  `prodigy` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否奇才',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `partner_id` (`partner_id`),
  KEY `log_recruit_type` (`log_recruit_type`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='伙伴招募日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_partner_recruit`
--

LOCK TABLES `log_partner_recruit` WRITE;
/*!40000 ALTER TABLE `log_partner_recruit` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_partner_recruit` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_partner_wash`
--

DROP TABLE IF EXISTS `log_partner_wash`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_partner_wash` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `partner_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '伙伴id',
  `quality` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '品质',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '伙伴等级',
  `objectlist` varchar(128) NOT NULL DEFAULT '[]' COMMENT '物品消耗',
  `reward` varchar(128) NOT NULL DEFAULT '[]' COMMENT '物品奖励',
  `attr_bf` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '洗髓前属性',
  `attr_af` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '洗髓后属性',
  `power_ch` varchar(128) NOT NULL DEFAULT '[]' COMMENT '战力变化',
  `sk_ch` varchar(512) NOT NULL DEFAULT '[]' COMMENT '技能',
  `prodigy_ch` varchar(128) NOT NULL DEFAULT '[]' COMMENT '是否奇才',
  `is_replace` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否替换',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `partner_id` (`partner_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='伙伴洗髓日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_partner_wash`
--

LOCK TABLES `log_partner_wash` WRITE;
/*!40000 ALTER TABLE `log_partner_wash` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_partner_wash` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_personal_auction`
--

DROP TABLE IF EXISTS `log_personal_auction`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_personal_auction` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `goods_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖物品id',
  `type_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖物品类型id',
  `goods_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品数量',
  `ctrl_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '操作类型:1上架,2结算',
  `auction_status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '拍卖状态',
  `top_player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '获得玩家id',
  `price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '成交价格',
  `close_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '预估结算时间',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `top_player_id` (`top_player_id`),
  KEY `goods_id` (`goods_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='个人拍卖日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_personal_auction`
--

LOCK TABLES `log_personal_auction` WRITE;
/*!40000 ALTER TABLE `log_personal_auction` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_personal_auction` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_pic_lv`
--

DROP TABLE IF EXISTS `log_pic_lv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_pic_lv` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `pic_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '图鉴id',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗内容',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='图鉴日志表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_pic_lv`
--

LOCK TABLES `log_pic_lv` WRITE;
/*!40000 ALTER TABLE `log_pic_lv` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_pic_lv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_picture`
--

DROP TABLE IF EXISTS `log_picture`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_picture` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '主键',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `picture` varchar(200) NOT NULL DEFAULT '[]' COMMENT '头像地址',
  `picture_ver` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '头像版本号',
  `time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='头像上传日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_picture`
--

LOCK TABLES `log_picture` WRITE;
/*!40000 ALTER TABLE `log_picture` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_picture` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_pigeon`
--

DROP TABLE IF EXISTS `log_pigeon`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_pigeon` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `sub_type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `grade_id` smallint(6) unsigned NOT NULL DEFAULT '0' COMMENT '档次id',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `keep_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '持续时间(s)',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '使用时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`),
  KEY `role_id` (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='白鸽传信日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_pigeon`
--

LOCK TABLES `log_pigeon` WRITE;
/*!40000 ALTER TABLE `log_pigeon` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_pigeon` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_pigeon_buy`
--

DROP TABLE IF EXISTS `log_pigeon_buy`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_pigeon_buy` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `sub_type` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `grade_id` smallint(6) unsigned NOT NULL DEFAULT '0' COMMENT '档次id',
  `price` smallint(6) unsigned NOT NULL DEFAULT '0' COMMENT '价格',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`),
  KEY `role_id` (`role_id`),
  KEY `grade_id` (`grade_id`),
  KEY `price` (`price`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='白鸽传信购买日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_pigeon_buy`
--

LOCK TABLES `log_pigeon_buy` WRITE;
/*!40000 ALTER TABLE `log_pigeon_buy` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_pigeon_buy` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_power_live`
--

DROP TABLE IF EXISTS `log_power_live`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_power_live` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `module` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能模块',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `old_live` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '旧活力值',
  `change_live` varchar(50) NOT NULL DEFAULT '0' COMMENT '变化值',
  `new_live` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '新活力值',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='活力变化日志表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_power_live`
--

LOCK TABLES `log_power_live` WRITE;
/*!40000 ALTER TABLE `log_power_live` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_power_live` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_produce_coin`
--

DROP TABLE IF EXISTS `log_produce_coin`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_produce_coin` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '生产时间',
  `produce_type` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '生产类型',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色ID',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '角色等级',
  `vip_lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'vip等级',
  `got_coin` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '生产铜钱',
  `remain_coin` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '铜钱余额',
  `about` text NOT NULL COMMENT '生产内容',
  PRIMARY KEY (`id`),
  KEY `produce_type` (`produce_type`),
  KEY `player_id` (`player_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='铜钱生产日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_produce_coin`
--

LOCK TABLES `log_produce_coin` WRITE;
/*!40000 ALTER TABLE `log_produce_coin` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_produce_coin` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_produce_currency`
--

DROP TABLE IF EXISTS `log_produce_currency`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_produce_currency` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `player_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '角色等级',
  `vip_lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'vip等级',
  `type` smallint(5) unsigned NOT NULL COMMENT '产出类型',
  `currency_id` int(10) unsigned NOT NULL COMMENT '货币id',
  `got_value` int(10) unsigned NOT NULL COMMENT '获得数量',
  `remain_value` int(10) unsigned NOT NULL COMMENT '现有数量',
  `remark` varchar(255) NOT NULL DEFAULT '' COMMENT '备注',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='特殊货币产出日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_produce_currency`
--

LOCK TABLES `log_produce_currency` WRITE;
/*!40000 ALTER TABLE `log_produce_currency` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_produce_currency` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_produce_gdonate`
--

DROP TABLE IF EXISTS `log_produce_gdonate`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_produce_gdonate` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `produce_type` smallint(11) unsigned NOT NULL DEFAULT '0' COMMENT '产出类型',
  `add_donate` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '获得贡献',
  `remain_donate` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '剩余贡献',
  `historical_donate` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '历史最高贡献',
  `extra` varchar(255) NOT NULL DEFAULT '' COMMENT '附加信息',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`) USING BTREE,
  KEY `role_id` (`role_id`) USING BTREE,
  KEY `produce_type` (`produce_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会贡献产出日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_produce_gdonate`
--

LOCK TABLES `log_produce_gdonate` WRITE;
/*!40000 ALTER TABLE `log_produce_gdonate` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_produce_gdonate` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_produce_gfunds`
--

DROP TABLE IF EXISTS `log_produce_gfunds`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_produce_gfunds` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `produce_type` smallint(11) unsigned NOT NULL DEFAULT '0' COMMENT '产出类型',
  `got_gfunds` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '获得资金',
  `remain_gfunds` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '剩余资金',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `guild_id` (`guild_id`) USING BTREE,
  KEY `time` (`time`) USING BTREE,
  KEY `role_id` (`role_id`) USING BTREE,
  KEY `produce_type` (`produce_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会资金产出日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_produce_gfunds`
--

LOCK TABLES `log_produce_gfunds` WRITE;
/*!40000 ALTER TABLE `log_produce_gfunds` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_produce_gfunds` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_produce_gold`
--

DROP TABLE IF EXISTS `log_produce_gold`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_produce_gold` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '生产时间',
  `produce_type` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '生产类型',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色ID',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '角色等级',
  `vip_lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'vip等级',
  `got_gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '生产金币',
  `got_bgold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '生产银两',
  `got_fgold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '生产粉钻',
  `remain_gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '金币余额',
  `remain_bgold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '银两余额',
  `remain_fgold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '粉钻余额',
  `about` text NOT NULL COMMENT '生产内容',
  PRIMARY KEY (`id`),
  KEY `produce_type` (`produce_type`),
  KEY `player_id` (`player_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='元宝生产日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_produce_gold`
--

LOCK TABLES `log_produce_gold` WRITE;
/*!40000 ALTER TABLE `log_produce_gold` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_produce_gold` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_produce_growth`
--

DROP TABLE IF EXISTS `log_produce_growth`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_produce_growth` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `produce_type` smallint(11) unsigned NOT NULL DEFAULT '0' COMMENT '产出类型',
  `add_growth` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '增加成长值',
  `remain_growth` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '剩余成长值',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`) USING BTREE,
  KEY `role_id` (`role_id`) USING BTREE,
  KEY `produce_type` (`produce_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会成长值产出日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_produce_growth`
--

LOCK TABLES `log_produce_growth` WRITE;
/*!40000 ALTER TABLE `log_produce_growth` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_produce_growth` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_produce_honour`
--

DROP TABLE IF EXISTS `log_produce_honour`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_produce_honour` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `player_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `type` smallint(5) unsigned NOT NULL COMMENT '产出类型',
  `old_value` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '旧数量',
  `new_value` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '新数量',
  `got_value` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '获得数量',
  `remark` varchar(255) NOT NULL DEFAULT '' COMMENT '备注',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `time` (`time`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='荣誉值产出日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_produce_honour`
--

LOCK TABLES `log_produce_honour` WRITE;
/*!40000 ALTER TABLE `log_produce_honour` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_produce_honour` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_produce_reputation`
--

DROP TABLE IF EXISTS `log_produce_reputation`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_produce_reputation` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '唯一编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `guild_name` varchar(100) NOT NULL DEFAULT '' COMMENT '公会名字',
  `produce_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '产出类型',
  `got_reputation` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '获得声望',
  `remain_reputation` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '剩余声望',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `guild_id` (`guild_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会声望日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_produce_reputation`
--

LOCK TABLES `log_produce_reputation` WRITE;
/*!40000 ALTER TABLE `log_produce_reputation` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_produce_reputation` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_pyx_lv_up1`
--

DROP TABLE IF EXISTS `log_pyx_lv_up1`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_pyx_lv_up1` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `spirit_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '圣灵id',
  `pyx_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '圣器id',
  `cost` varchar(255) NOT NULL DEFAULT '' COMMENT '激活消耗',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '激活时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='圣器升级日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_pyx_lv_up1`
--

LOCK TABLES `log_pyx_lv_up1` WRITE;
/*!40000 ALTER TABLE `log_pyx_lv_up1` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_pyx_lv_up1` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_quick_buy`
--

DROP TABLE IF EXISTS `log_quick_buy`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_quick_buy` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `before_gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '购买前钻石',
  `before_bgold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '购买前绑钻',
  `before_coin` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '购买前金币',
  `after_gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '购买后钻石',
  `after_bgold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '购买后绑钻',
  `after_coin` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '购买后金币',
  `goods` varchar(255) NOT NULL DEFAULT '[]' COMMENT '购买的物品',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '购买时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='快速购买日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_quick_buy`
--

LOCK TABLES `log_quick_buy` WRITE;
/*!40000 ALTER TABLE `log_quick_buy` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_quick_buy` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_race_act`
--

DROP TABLE IF EXISTS `log_race_act`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_race_act` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器id',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '主类型',
  `subtype` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '次类型',
  `open` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '状态',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`),
  KEY `type` (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='竞榜活动开启日志表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_race_act`
--

LOCK TABLES `log_race_act` WRITE;
/*!40000 ALTER TABLE `log_race_act` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_race_act` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_race_act_produce`
--

DROP TABLE IF EXISTS `log_race_act_produce`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_race_act_produce` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '主类型',
  `subtype` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '次类型',
  `reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `ptype` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '产出类型',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='竞榜活动产出表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_race_act_produce`
--

LOCK TABLES `log_race_act_produce` WRITE;
/*!40000 ALTER TABLE `log_race_act_produce` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_race_act_produce` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_race_act_rank`
--

DROP TABLE IF EXISTS `log_race_act_rank`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_race_act_rank` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `name` varchar(512) NOT NULL DEFAULT '' COMMENT '名字',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '主类型',
  `subtype` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '次类型',
  `act_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动类型',
  `day` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动第X天',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `zone` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '区',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='竞榜活动排名日志表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_race_act_rank`
--

LOCK TABLES `log_race_act_rank` WRITE;
/*!40000 ALTER TABLE `log_race_act_rank` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_race_act_rank` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_receive_smashed_egg_reward`
--

DROP TABLE IF EXISTS `log_receive_smashed_egg_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_receive_smashed_egg_reward` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增ID',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色ID',
  `subtype` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类',
  `reward_list` varchar(2048) NOT NULL DEFAULT '[]' COMMENT '奖励列表',
  `time` int(11) NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='领取砸蛋奖励日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_receive_smashed_egg_reward`
--

LOCK TABLES `log_receive_smashed_egg_reward` WRITE;
/*!40000 ALTER TABLE `log_receive_smashed_egg_reward` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_receive_smashed_egg_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_recharge_consume_rank_act`
--

DROP TABLE IF EXISTS `log_recharge_consume_rank_act`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_recharge_consume_rank_act` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `rank_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动类型',
  `sub_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '值',
  `reward` varchar(128) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `rank_type` (`rank_type`),
  KEY `sub_type` (`sub_type`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='充值消费榜奖励日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_recharge_consume_rank_act`
--

LOCK TABLES `log_recharge_consume_rank_act` WRITE;
/*!40000 ALTER TABLE `log_recharge_consume_rank_act` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_recharge_consume_rank_act` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_recharge_first`
--

DROP TABLE IF EXISTS `log_recharge_first`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_recharge_first` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `log_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '日志类型：1激活日志,2领取日志',
  `day` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '领取第几天奖励',
  `object_list` varchar(512) NOT NULL COMMENT '奖励列表',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='首冲日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_recharge_first`
--

LOCK TABLES `log_recharge_first` WRITE;
/*!40000 ALTER TABLE `log_recharge_first` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_recharge_first` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_recharge_return`
--

DROP TABLE IF EXISTS `log_recharge_return`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_recharge_return` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `product_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商品id',
  `return_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '返利类型',
  `gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '基础钻石',
  `return_gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '返利钻石',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='充值返利日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_recharge_return`
--

LOCK TABLES `log_recharge_return` WRITE;
/*!40000 ALTER TABLE `log_recharge_return` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_recharge_return` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_red_envelopes`
--

DROP TABLE IF EXISTS `log_red_envelopes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_red_envelopes` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `red_envelopes_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '红包id',
  `ownership_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '归属类型',
  `ownership_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '归属id',
  `owner_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '拥有者id',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '红包状态',
  `type` tinyint(2) NOT NULL DEFAULT '0' COMMENT '红包类型',
  `extra` varchar(100) NOT NULL DEFAULT '0' COMMENT '附加信息',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `red_envelopes_id` (`red_envelopes_id`),
  KEY `ownership_id` (`ownership_id`),
  KEY `owner_id` (`owner_id`),
  KEY `type` (`type`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='通用红包日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_red_envelopes`
--

LOCK TABLES `log_red_envelopes` WRITE;
/*!40000 ALTER TABLE `log_red_envelopes` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_red_envelopes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_red_envelopes_recipients`
--

DROP TABLE IF EXISTS `log_red_envelopes_recipients`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_red_envelopes_recipients` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `red_envelopes_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '红包id',
  `reward` varchar(50) NOT NULL DEFAULT '' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `red_envelopes_id` (`red_envelopes_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='红包领取记录日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_red_envelopes_recipients`
--

LOCK TABLES `log_red_envelopes_recipients` WRITE;
/*!40000 ALTER TABLE `log_red_envelopes_recipients` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_red_envelopes_recipients` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_reg_statis`
--

DROP TABLE IF EXISTS `log_reg_statis`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_reg_statis` (
  `time` int(10) NOT NULL COMMENT '统计时间',
  `source` varchar(50) NOT NULL COMMENT '来源',
  `reg_num` int(11) NOT NULL COMMENT '注册数',
  PRIMARY KEY (`time`,`source`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='每小时统计注册数';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_reg_statis`
--

LOCK TABLES `log_reg_statis` WRITE;
/*!40000 ALTER TABLE `log_reg_statis` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_reg_statis` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_reincarnation`
--

DROP TABLE IF EXISTS `log_reincarnation`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_reincarnation` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `turn` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '转生次数',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `turn` (`turn`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='转生日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_reincarnation`
--

LOCK TABLES `log_reincarnation` WRITE;
/*!40000 ALTER TABLE `log_reincarnation` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_reincarnation` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_rela`
--

DROP TABLE IF EXISTS `log_rela`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_rela` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `other_rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '对方玩家id',
  `pre_rela` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '之前关系',
  `ctype` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '操作类型',
  `rela` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '当前关系',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `ctype` (`ctype`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='社交关系变化';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_rela`
--

LOCK TABLES `log_rela` WRITE;
/*!40000 ALTER TABLE `log_rela` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_rela` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_rename`
--

DROP TABLE IF EXISTS `log_rename`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_rename` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `player_id` bigint(20) NOT NULL COMMENT '玩家id',
  `old_name` varchar(50) NOT NULL COMMENT '原角色名',
  `new_name` varchar(50) NOT NULL COMMENT '新角色名',
  `lv` int(11) NOT NULL COMMENT '等级',
  `cost` varchar(255) NOT NULL COMMENT '消耗',
  `time` int(11) NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='角色改名日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_rename`
--

LOCK TABLES `log_rename` WRITE;
/*!40000 ALTER TABLE `log_rename` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_rename` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_rename_guild`
--

DROP TABLE IF EXISTS `log_rename_guild`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_rename_guild` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `guild_id` bigint(20) unsigned DEFAULT NULL COMMENT '公会id',
  `player_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `old_name` varchar(50) NOT NULL COMMENT '原公会名',
  `new_name` varchar(50) NOT NULL COMMENT '新公会名',
  `type` tinyint(3) unsigned NOT NULL COMMENT '类型',
  `time` int(11) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会改名日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_rename_guild`
--

LOCK TABLES `log_rename_guild` WRITE;
/*!40000 ALTER TABLE `log_rename_guild` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_rename_guild` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_resource_back`
--

DROP TABLE IF EXISTS `log_resource_back`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_resource_back` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `act_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '模块id',
  `act_sub` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '模块子类',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `times` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '找回次数',
  `lefttimes` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '剩余次数',
  `reward` varchar(512) NOT NULL DEFAULT '[]' COMMENT '找回奖励',
  `time` int(11) NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='奖励找回日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_resource_back`
--

LOCK TABLES `log_resource_back` WRITE;
/*!40000 ALTER TABLE `log_resource_back` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_resource_back` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_role_home_build`
--

DROP TABLE IF EXISTS `log_role_home_build`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_role_home_build` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增Id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `create_type` tinyint(2) unsigned NOT NULL COMMENT '1创建2扩展',
  `home_id` int(11) unsigned NOT NULL COMMENT '家园规格',
  `costs` varchar(256) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `reward_list` varchar(256) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '日志时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='家园建造日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_role_home_build`
--

LOCK TABLES `log_role_home_build` WRITE;
/*!40000 ALTER TABLE `log_role_home_build` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_role_home_build` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_role_home_build_upgrade`
--

DROP TABLE IF EXISTS `log_role_home_build_upgrade`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_role_home_build_upgrade` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增Id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `uptype` tinyint(2) unsigned NOT NULL COMMENT '1钻石升级(加速)2普通升级',
  `start_end` tinyint(2) unsigned NOT NULL COMMENT '1开始升级2结束升级',
  `build_type` int(11) unsigned NOT NULL COMMENT '建筑类型',
  `build_lv` int(11) unsigned NOT NULL COMMENT '建筑等级',
  `upgrade_endtime` int(11) unsigned NOT NULL COMMENT '升级结束时间戳',
  `res_cost` varchar(256) NOT NULL DEFAULT '[]' COMMENT '资源消耗',
  `costs` varchar(256) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '日志时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='家园建筑升级日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_role_home_build_upgrade`
--

LOCK TABLES `log_role_home_build_upgrade` WRITE;
/*!40000 ALTER TABLE `log_role_home_build_upgrade` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_role_home_build_upgrade` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_role_home_collect_resource`
--

DROP TABLE IF EXISTS `log_role_home_collect_resource`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_role_home_collect_resource` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增Id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `build_type` int(11) unsigned NOT NULL COMMENT '建筑类型',
  `res_get` varchar(256) NOT NULL DEFAULT '[]' COMMENT '获得资源',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '日志时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='家园资源采集日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_role_home_collect_resource`
--

LOCK TABLES `log_role_home_collect_resource` WRITE;
/*!40000 ALTER TABLE `log_role_home_collect_resource` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_role_home_collect_resource` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_role_home_pic`
--

DROP TABLE IF EXISTS `log_role_home_pic`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_role_home_pic` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `pic_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '图鉴id',
  `old_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '原来等级',
  `new_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '当前等级',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗内容',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='家园图鉴日志表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_role_home_pic`
--

LOCK TABLES `log_role_home_pic` WRITE;
/*!40000 ALTER TABLE `log_role_home_pic` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_role_home_pic` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_role_home_wish`
--

DROP TABLE IF EXISTS `log_role_home_wish`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_role_home_wish` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增Id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `wish_id` tinyint(2) unsigned NOT NULL COMMENT '许愿池id',
  `wish_coin_cost` smallint(6) unsigned NOT NULL COMMENT '许愿币消耗',
  `event_id` tinyint(2) unsigned NOT NULL COMMENT '事件id 1：得奖励 2：升品',
  `rewards` varchar(256) NOT NULL DEFAULT '[]' COMMENT '获得奖励',
  `res_rewards` varchar(256) NOT NULL DEFAULT '[]' COMMENT '资源奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '日志时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='家园许愿日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_role_home_wish`
--

LOCK TABLES `log_role_home_wish` WRITE;
/*!40000 ALTER TABLE `log_role_home_wish` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_role_home_wish` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_role_ltv`
--

DROP TABLE IF EXISTS `log_role_ltv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_role_ltv` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自动ID',
  `source` varchar(50) NOT NULL COMMENT '渠道标识',
  `ctime` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '时间',
  `reg_num` int(10) NOT NULL DEFAULT '0' COMMENT '注册人数',
  `one_charge` int(10) NOT NULL DEFAULT '0' COMMENT '1日充值金额',
  `two_charge` int(10) NOT NULL DEFAULT '0' COMMENT '2日充值金额',
  `three_charge` int(10) NOT NULL DEFAULT '0' COMMENT '3日充值金额',
  `four_charge` int(10) NOT NULL DEFAULT '0' COMMENT '4日充值金额',
  `five_charge` int(10) NOT NULL DEFAULT '0' COMMENT '5日充值金额',
  `six_charge` int(10) NOT NULL DEFAULT '0' COMMENT '6日充值金额',
  `seven_charge` int(10) NOT NULL DEFAULT '0' COMMENT '7日充值金额',
  `fourteen_charge` int(10) NOT NULL DEFAULT '0' COMMENT '14日充值金额',
  `thirty_charge` int(10) NOT NULL DEFAULT '0' COMMENT '30日充值金额',
  PRIMARY KEY (`id`),
  KEY `ctime` (`ctime`),
  KEY `source` (`source`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='游戏玩家LifeTimeValue';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_role_ltv`
--

LOCK TABLES `log_role_ltv` WRITE;
/*!40000 ALTER TABLE `log_role_ltv` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_role_ltv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_role_retain`
--

DROP TABLE IF EXISTS `log_role_retain`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_role_retain` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT '自动ID',
  `source` varchar(50) NOT NULL COMMENT '渠道标识',
  `ctime` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '时间',
  `reg_num` int(10) NOT NULL DEFAULT '0' COMMENT '注册人数',
  `one_login` int(10) NOT NULL DEFAULT '0' COMMENT '1日登陆人数',
  `two_login` int(10) NOT NULL DEFAULT '0' COMMENT '2日登陆人数',
  `three_login` int(10) NOT NULL DEFAULT '0' COMMENT '3日登陆人数',
  `four_login` int(10) NOT NULL DEFAULT '0' COMMENT '4日登陆人数',
  `five_login` int(10) NOT NULL DEFAULT '0' COMMENT '5日登陆人数',
  `six_login` int(10) NOT NULL DEFAULT '0' COMMENT '6日登陆人数',
  `seven_login` int(10) NOT NULL DEFAULT '0' COMMENT '7日登陆人数',
  `fourteen_login` int(10) NOT NULL DEFAULT '0' COMMENT '14日登陆人数',
  `thirty_login` int(10) NOT NULL DEFAULT '0' COMMENT '30日登陆人数',
  PRIMARY KEY (`id`),
  KEY `ctime` (`ctime`),
  KEY `source` (`source`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='游戏玩家留存率';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_role_retain`
--

LOCK TABLES `log_role_retain` WRITE;
/*!40000 ALTER TABLE `log_role_retain` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_role_retain` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_rule_devour`
--

DROP TABLE IF EXISTS `log_rule_devour`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_rule_devour` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `player_name` varchar(255) NOT NULL DEFAULT '' COMMENT '玩家名',
  `rule_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '吞噬法则类型',
  `before_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '吞噬前数量',
  `after_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '吞噬后数量',
  `attr` varchar(255) NOT NULL DEFAULT '' COMMENT '增加属性',
  `cost` varchar(255) NOT NULL DEFAULT '' COMMENT '吞噬消耗',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '吞噬时间',
  PRIMARY KEY (`id`,`role_id`,`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='法则吞噬日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_rule_devour`
--

LOCK TABLES `log_rule_devour` WRITE;
/*!40000 ALTER TABLE `log_rule_devour` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_rule_devour` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_rush_giftbag`
--

DROP TABLE IF EXISTS `log_rush_giftbag`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_rush_giftbag` (
  `seq` bigint(20) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号自增',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `bag_id` int(11) NOT NULL DEFAULT '0' COMMENT '礼包id',
  `bag_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '礼包类型',
  `bag_condition` varchar(255) NOT NULL DEFAULT '0' COMMENT '礼包领取条件',
  `player_value` varchar(255) NOT NULL DEFAULT '0' COMMENT '玩家条件属性值',
  `player_career` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '玩家职业',
  `rewards_output` varchar(1024) NOT NULL DEFAULT '0' COMMENT '玩家领取的奖励',
  `time` int(20) unsigned NOT NULL DEFAULT '0' COMMENT '领取时间',
  PRIMARY KEY (`seq`),
  KEY `player_id` (`player_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='冲级礼包日志表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_rush_giftbag`
--

LOCK TABLES `log_rush_giftbag` WRITE;
/*!40000 ALTER TABLE `log_rush_giftbag` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_rush_giftbag` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_rush_goal_reward`
--

DROP TABLE IF EXISTS `log_rush_goal_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_rush_goal_reward` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `rank_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '榜单类型',
  `goal_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '目标奖励id',
  `value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '领取时玩家数值',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`) USING BTREE,
  KEY `role_id` (`role_id`) USING BTREE,
  KEY `rank_type` (`rank_type`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='开服冲榜目标日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_rush_goal_reward`
--

LOCK TABLES `log_rush_goal_reward` WRITE;
/*!40000 ALTER TABLE `log_rush_goal_reward` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_rush_goal_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_rush_rank_reward`
--

DROP TABLE IF EXISTS `log_rush_rank_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_rush_rank_reward` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `rank_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '榜单类型',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家数值',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`) USING BTREE,
  KEY `role_id` (`role_id`) USING BTREE,
  KEY `rank_type` (`rank_type`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='开服冲榜排行日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_rush_rank_reward`
--

LOCK TABLES `log_rush_rank_reward` WRITE;
/*!40000 ALTER TABLE `log_rush_rank_reward` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_rush_rank_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_seal_soul_lv`
--

DROP TABLE IF EXISTS `log_seal_soul_lv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_seal_soul_lv` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `seal_soul_type_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '魂珠id',
  `old_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '提升前等级',
  `new_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '提升后等级',
  `old_combat` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '提升前战斗力',
  `new_combat` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '提升后战斗力',
  `cost` varchar(50) NOT NULL DEFAULT '[]' COMMENT '提升消耗',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='魂珠升级日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_seal_soul_lv`
--

LOCK TABLES `log_seal_soul_lv` WRITE;
/*!40000 ALTER TABLE `log_seal_soul_lv` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_seal_soul_lv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_seal_soul_treasure`
--

DROP TABLE IF EXISTS `log_seal_soul_treasure`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_seal_soul_treasure` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `ctype` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '操作类型',
  `auto_buy` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '自动购买',
  `cost` varchar(128) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `seal_soul_chip` varchar(128) NOT NULL DEFAULT '[]' COMMENT '魂珠碎片',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='魂珠寻宝日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_seal_soul_treasure`
--

LOCK TABLES `log_seal_soul_treasure` WRITE;
/*!40000 ALTER TABLE `log_seal_soul_treasure` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_seal_soul_treasure` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_sell_down`
--

DROP TABLE IF EXISTS `log_sell_down`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_sell_down` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `sell_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '商品id',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型id',
  `goods_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '下架数量',
  `seller_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '出售玩家id',
  `down_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '下架类型 1: 手动 2:自动 3:出售',
  `extra` varchar(255) NOT NULL DEFAULT '' COMMENT '附加信息',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `sell_id` (`sell_id`),
  KEY `goods_id` (`goods_id`),
  KEY `seller_id` (`seller_id`),
  KEY `down_type` (`down_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='市场下架日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_sell_down`
--

LOCK TABLES `log_sell_down` WRITE;
/*!40000 ALTER TABLE `log_sell_down` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_sell_down` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_sell_pay`
--

DROP TABLE IF EXISTS `log_sell_pay`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_sell_pay` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `sell_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '交易类型 1:市场出售 2:指定交易',
  `sell_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '商品id',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型id',
  `goods_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '交易数量',
  `unit_price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '单价',
  `tax` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '交易税',
  `seller_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '出售玩家id',
  `buyer_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '购买玩家id',
  `extra` varchar(255) NOT NULL DEFAULT '' COMMENT '附加信息',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `sell_type` (`sell_type`),
  KEY `sell_id` (`sell_id`),
  KEY `goods_id` (`goods_id`),
  KEY `seller_id` (`seller_id`),
  KEY `buyer_id` (`buyer_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='市场交易日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_sell_pay`
--

LOCK TABLES `log_sell_pay` WRITE;
/*!40000 ALTER TABLE `log_sell_pay` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_sell_pay` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_sell_up`
--

DROP TABLE IF EXISTS `log_sell_up`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_sell_up` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `seller_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '出售玩家id',
  `sell_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '出售类型 1:市场出售 2:指定交易',
  `sell_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '商品id',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型id',
  `goods_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '出售数量',
  `unit_price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '出售单价',
  `specifyer_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '指定购买玩家id',
  `extra` varchar(255) NOT NULL DEFAULT '' COMMENT '附加信息',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `seller_id` (`seller_id`),
  KEY `sell_type` (`sell_type`),
  KEY `sell_id` (`sell_id`),
  KEY `goods_id` (`goods_id`) USING BTREE,
  KEY `specifyer_id` (`specifyer_id`) USING BTREE,
  KEY `time` (`time`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='市场上架日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_sell_up`
--

LOCK TABLES `log_sell_up` WRITE;
/*!40000 ALTER TABLE `log_sell_up` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_sell_up` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_server_daily_clear`
--

DROP TABLE IF EXISTS `log_server_daily_clear`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_server_daily_clear` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `log_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '日志类型',
  `begin_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开始时间',
  `end_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '结束时间',
  `cost_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '用时(s)',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作时间',
  PRIMARY KEY (`id`),
  KEY `log_type` (`log_type`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='服务器日清日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_server_daily_clear`
--

LOCK TABLES `log_server_daily_clear` WRITE;
/*!40000 ALTER TABLE `log_server_daily_clear` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_server_daily_clear` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_server_hot`
--

DROP TABLE IF EXISTS `log_server_hot`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_server_hot` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `module_list` varchar(4096) NOT NULL DEFAULT '' COMMENT '热更模块列表',
  `begin_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开始时间',
  `end_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '结束时间',
  `cost_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '用时(s)',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='服务器热更日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_server_hot`
--

LOCK TABLES `log_server_hot` WRITE;
/*!40000 ALTER TABLE `log_server_hot` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_server_hot` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_server_interface`
--

DROP TABLE IF EXISTS `log_server_interface`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_server_interface` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `mfa` varchar(4096) NOT NULL DEFAULT '' COMMENT '调用模块',
  `begin_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开始时间',
  `end_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '结束时间',
  `cost_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '用时(s)',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='服务器web_interface日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_server_interface`
--

LOCK TABLES `log_server_interface` WRITE;
/*!40000 ALTER TABLE `log_server_interface` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_server_interface` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_server_memory`
--

DROP TABLE IF EXISTS `log_server_memory`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_server_memory` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `memory_total` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '内存total(m)',
  `memory_processes` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '内存processes(m)',
  `memory_atom` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '内存atom(m)',
  `memory_binary` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '内存binary(m)',
  `memory_code` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '内存code(m)',
  `memory_ets` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '内存ets(m)',
  `process_cnt` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '使用数量process',
  `ets_cnt` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '使用数量ets',
  `port_cnt` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '使用数量port',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='服务器内存日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_server_memory`
--

LOCK TABLES `log_server_memory` WRITE;
/*!40000 ALTER TABLE `log_server_memory` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_server_memory` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_server_open`
--

DROP TABLE IF EXISTS `log_server_open`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_server_open` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `server_status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '服务器状态',
  `server_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '服务器类型',
  `node` varchar(128) NOT NULL DEFAULT 'none' COMMENT '服务器节点',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '本服id',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '本服服数',
  `platform` varchar(512) NOT NULL DEFAULT 'none' COMMENT '平台名',
  `begin_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开始时间',
  `end_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '结束时间',
  `cost_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '用时(s)',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='服务器开启日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_server_open`
--

LOCK TABLES `log_server_open` WRITE;
/*!40000 ALTER TABLE `log_server_open` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_server_open` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_server_watchdog`
--

DROP TABLE IF EXISTS `log_server_watchdog`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_server_watchdog` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  `log_list` varchar(4096) NOT NULL DEFAULT '[]' COMMENT '日志列表',
  PRIMARY KEY (`id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='看门狗服务日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_server_watchdog`
--

LOCK TABLES `log_server_watchdog` WRITE;
/*!40000 ALTER TABLE `log_server_watchdog` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_server_watchdog` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_share_times`
--

DROP TABLE IF EXISTS `log_share_times`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_share_times` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `times` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '玩家分享次数',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `times` (`times`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='分享有礼分享日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_share_times`
--

LOCK TABLES `log_share_times` WRITE;
/*!40000 ALTER TABLE `log_share_times` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_share_times` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_shop`
--

DROP TABLE IF EXISTS `log_shop`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_shop` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `role_lv` int(10) NOT NULL DEFAULT '1' COMMENT '角色等级',
  `vip_lv` smallint(10) NOT NULL DEFAULT '0' COMMENT '贵族等级',
  `shop_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商店类型',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '道具ID',
  `num` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '物品获得数量',
  `money_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '货币类型',
  `sum` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '购买总价格',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '购买时间',
  `buy_num` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '购买次数',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `goods_id` (`goods_id`),
  KEY `money_type` (`money_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='商城日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_shop`
--

LOCK TABLES `log_shop` WRITE;
/*!40000 ALTER TABLE `log_shop` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_shop` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_single_dungeon`
--

DROP TABLE IF EXISTS `log_single_dungeon`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_single_dungeon` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家等级',
  `combat_power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战力',
  `dun_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本id',
  `dun_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本类型',
  `reward_list` varchar(2000) NOT NULL DEFAULT '[]' COMMENT '掉落奖励',
  `result_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '结果',
  `result_subtype` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '子类型',
  `log_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '记录类型',
  `remark` text NOT NULL COMMENT '备注',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `dun_id` (`dun_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='单人副本日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_single_dungeon`
--

LOCK TABLES `log_single_dungeon` WRITE;
/*!40000 ALTER TABLE `log_single_dungeon` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_single_dungeon` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_smashed_egg`
--

DROP TABLE IF EXISTS `log_smashed_egg`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_smashed_egg` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '玩家id',
  `smashed_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '砸蛋类型',
  `smashed_num` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '本次砸蛋数量',
  `index` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '金蛋编号',
  `use_free_times` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否使用免费次数',
  `auto_buy` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否自动购买',
  `cost` varchar(100) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='砸蛋日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_smashed_egg`
--

LOCK TABLES `log_smashed_egg` WRITE;
/*!40000 ALTER TABLE `log_smashed_egg` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_smashed_egg` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_sp_shop_buy`
--

DROP TABLE IF EXISTS `log_sp_shop_buy`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_sp_shop_buy` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL,
  `cfg_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商品配置id',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗内容',
  `good_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT '获得内容',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='黑市商店购买日志表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_sp_shop_buy`
--

LOCK TABLES `log_sp_shop_buy` WRITE;
/*!40000 ALTER TABLE `log_sp_shop_buy` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_sp_shop_buy` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_sp_shop_resolve`
--

DROP TABLE IF EXISTS `log_sp_shop_resolve`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_sp_shop_resolve` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `good_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分解物品id',
  `num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '数量',
  `coins` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分解获得币数',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='黑市商店分解日志表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_sp_shop_resolve`
--

LOCK TABLES `log_sp_shop_resolve` WRITE;
/*!40000 ALTER TABLE `log_sp_shop_resolve` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_sp_shop_resolve` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_spirit_lv_up`
--

DROP TABLE IF EXISTS `log_spirit_lv_up`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_spirit_lv_up` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色id',
  `spirit_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '圣灵id',
  `before_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作前等级',
  `before_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作前经验',
  `after_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作后等级',
  `after_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作后经验',
  `cost` varchar(255) NOT NULL DEFAULT '' COMMENT '消耗材料',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='圣灵升级日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_spirit_lv_up`
--

LOCK TABLES `log_spirit_lv_up` WRITE;
/*!40000 ALTER TABLE `log_spirit_lv_up` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_spirit_lv_up` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_star_drum`
--

DROP TABLE IF EXISTS `log_star_drum`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_star_drum` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `drum` int(11) NOT NULL DEFAULT '0' COMMENT '期',
  `zone` int(11) NOT NULL DEFAULT '0' COMMENT '战区',
  `action` int(11) NOT NULL DEFAULT '0' COMMENT '场数',
  `sub_action` int(11) NOT NULL DEFAULT '0' COMMENT '局数',
  `wid` bigint(20) NOT NULL DEFAULT '0' COMMENT '胜方',
  `wname` varchar(50) NOT NULL DEFAULT '' COMMENT '名称',
  `wsid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器id',
  `wnum` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '胜服号',
  `wpower` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '胜战力',
  `wstar_list` varchar(512) NOT NULL DEFAULT '[]' COMMENT '胜出战星灵id',
  `wdie_list` varchar(512) NOT NULL DEFAULT '[]' COMMENT '胜死亡星灵',
  `fid` bigint(20) NOT NULL DEFAULT '0' COMMENT '负方',
  `fname` varchar(50) NOT NULL DEFAULT '' COMMENT '名称',
  `fsid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器id',
  `fnum` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '负服号',
  `fpower` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '负战力',
  `fstar_list` varchar(512) NOT NULL DEFAULT '[]' COMMENT '胜出战星灵id',
  `fdie_list` varchar(512) NOT NULL DEFAULT '[]' COMMENT '负死亡星灵',
  `result` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '1胜2负3轮空4超时5离线6无星灵出阵',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`),
  KEY `wid` (`wid`),
  KEY `fid` (`fid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家星灵争霸战场日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_star_drum`
--

LOCK TABLES `log_star_drum` WRITE;
/*!40000 ALTER TABLE `log_star_drum` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_star_drum` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_star_drum_refuce`
--

DROP TABLE IF EXISTS `log_star_drum_refuce`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_star_drum_refuce` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '名称',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器id',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `power` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '战力',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星灵争霸拒绝参赛日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_star_drum_refuce`
--

LOCK TABLES `log_star_drum_refuce` WRITE;
/*!40000 ALTER TABLE `log_star_drum_refuce` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_star_drum_refuce` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_star_drum_sign`
--

DROP TABLE IF EXISTS `log_star_drum_sign`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_star_drum_sign` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '名称',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星灵争霸报名日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_star_drum_sign`
--

LOCK TABLES `log_star_drum_sign` WRITE;
/*!40000 ALTER TABLE `log_star_drum_sign` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_star_drum_sign` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_star_shadow_compose`
--

DROP TABLE IF EXISTS `log_star_shadow_compose`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_star_shadow_compose` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '合成得到的物品',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '合成消耗的物品',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星痕合成日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_star_shadow_compose`
--

LOCK TABLES `log_star_shadow_compose` WRITE;
/*!40000 ALTER TABLE `log_star_shadow_compose` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_star_shadow_compose` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_star_shadow_decompose`
--

DROP TABLE IF EXISTS `log_star_shadow_decompose`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_star_shadow_decompose` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '分解的物品',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '得到的物品',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星痕分解日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_star_shadow_decompose`
--

LOCK TABLES `log_star_shadow_decompose` WRITE;
/*!40000 ALTER TABLE `log_star_shadow_decompose` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_star_shadow_decompose` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_star_shadow_stren`
--

DROP TABLE IF EXISTS `log_star_shadow_stren`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_star_shadow_stren` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `location` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '装备部位',
  `old_lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '强化前等级',
  `new_lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '强化后等级',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '强化消耗',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星痕强化日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_star_shadow_stren`
--

LOCK TABLES `log_star_shadow_stren` WRITE;
/*!40000 ALTER TABLE `log_star_shadow_stren` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_star_shadow_stren` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_star_soul_active`
--

DROP TABLE IF EXISTS `log_star_soul_active`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_star_soul_active` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `star_soul_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '激活的星灵',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星灵激活日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_star_soul_active`
--

LOCK TABLES `log_star_soul_active` WRITE;
/*!40000 ALTER TABLE `log_star_soul_active` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_star_soul_active` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_star_soul_equip_break_through`
--

DROP TABLE IF EXISTS `log_star_soul_equip_break_through`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_star_soul_equip_break_through` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '突破装备ID',
  `star_soul_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '所属星灵ID',
  `target_goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '突破后装备ID',
  `cost` varchar(128) NOT NULL DEFAULT '[]' COMMENT '突破消耗',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星灵装备突破日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_star_soul_equip_break_through`
--

LOCK TABLES `log_star_soul_equip_break_through` WRITE;
/*!40000 ALTER TABLE `log_star_soul_equip_break_through` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_star_soul_equip_break_through` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_star_soul_equip_resolve`
--

DROP TABLE IF EXISTS `log_star_soul_equip_resolve`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_star_soul_equip_resolve` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `resolve_goods_list` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '分解装备列表',
  `star_soul_power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '星魂之力数量',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星灵装备分解日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_star_soul_equip_resolve`
--

LOCK TABLES `log_star_soul_equip_resolve` WRITE;
/*!40000 ALTER TABLE `log_star_soul_equip_resolve` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_star_soul_equip_resolve` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_star_soul_equip_stren`
--

DROP TABLE IF EXISTS `log_star_soul_equip_stren`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_star_soul_equip_stren` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '装备ID',
  `star_soul_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '所属星灵ID',
  `pre_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '强化前等级',
  `cur_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '强化后等级',
  `cur_attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '当前属性',
  `cost` varchar(128) NOT NULL DEFAULT '[]' COMMENT '强化消耗',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '强化时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星灵装备强化日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_star_soul_equip_stren`
--

LOCK TABLES `log_star_soul_equip_stren` WRITE;
/*!40000 ALTER TABLE `log_star_soul_equip_stren` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_star_soul_equip_stren` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_star_soul_lv`
--

DROP TABLE IF EXISTS `log_star_soul_lv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_star_soul_lv` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `star_soul_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '星灵',
  `pre_lv` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '前星数',
  `now_lv` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '现星数',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星灵升星日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_star_soul_lv`
--

LOCK TABLES `log_star_soul_lv` WRITE;
/*!40000 ALTER TABLE `log_star_soul_lv` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_star_soul_lv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_star_soul_skill`
--

DROP TABLE IF EXISTS `log_star_soul_skill`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_star_soul_skill` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `star_soul_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '星灵id',
  `skill_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能id',
  `pre_skill` varchar(255) NOT NULL DEFAULT '[]' COMMENT '前置技能{skill_id, lv, exp}',
  `after_skill` varchar(255) NOT NULL DEFAULT '[]' COMMENT '后置技能{skill_id, lv, exp}',
  `type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '操作类型1-学习 2-升级',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `return_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT '技能替换返还',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星灵技能日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_star_soul_skill`
--

LOCK TABLES `log_star_soul_skill` WRITE;
/*!40000 ALTER TABLE `log_star_soul_skill` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_star_soul_skill` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_star_soul_stage`
--

DROP TABLE IF EXISTS `log_star_soul_stage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_star_soul_stage` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `star_soul_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '星灵',
  `pre_stage` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '前阶数',
  `pre_star` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '前星数',
  `now_stage` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '现阶数',
  `now_star` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '现星数',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '增加的经验',
  `crit` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '暴击倍率',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星灵升阶日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_star_soul_stage`
--

LOCK TABLES `log_star_soul_stage` WRITE;
/*!40000 ALTER TABLE `log_star_soul_stage` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_star_soul_stage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_star_soul_treasure`
--

DROP TABLE IF EXISTS `log_star_soul_treasure`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_star_soul_treasure` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `lucky_draw_type` tinyint(1) NOT NULL DEFAULT '0' COMMENT '抽奖类型',
  `reward_list` varchar(256) NOT NULL DEFAULT '[]' COMMENT '物品奖励列表',
  `obtain_integral` int(11) NOT NULL DEFAULT '0' COMMENT '获得积分',
  `cost` varchar(128) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星灵宝箱日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_star_soul_treasure`
--

LOCK TABLES `log_star_soul_treasure` WRITE;
/*!40000 ALTER TABLE `log_star_soul_treasure` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_star_soul_treasure` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_star_soul_universe`
--

DROP TABLE IF EXISTS `log_star_soul_universe`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_star_soul_universe` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `pre_universe` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '前置小宇宙',
  `now_universe` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '现小宇宙',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='小宇宙突破日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_star_soul_universe`
--

LOCK TABLES `log_star_soul_universe` WRITE;
/*!40000 ALTER TABLE `log_star_soul_universe` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_star_soul_universe` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_star_soul_war`
--

DROP TABLE IF EXISTS `log_star_soul_war`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_star_soul_war` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `dun_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '副本id',
  `rewards` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励内容',
  `now_times` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '当前周数',
  `pass_times` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家通关累积周次数',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星灵试炼通关日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_star_soul_war`
--

LOCK TABLES `log_star_soul_war` WRITE;
/*!40000 ALTER TABLE `log_star_soul_war` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_star_soul_war` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_star_soul_war_sweep`
--

DROP TABLE IF EXISTS `log_star_soul_war_sweep`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_star_soul_war_sweep` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `vip` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'vip等级',
  `level` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '扫荡关卡',
  `pass_times` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '通关累积周数',
  `times` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '扫荡次数',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励内容',
  `num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '现有星币数量',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星灵试炼扫荡日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_star_soul_war_sweep`
--

LOCK TABLES `log_star_soul_war_sweep` WRITE;
/*!40000 ALTER TABLE `log_star_soul_war_sweep` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_star_soul_war_sweep` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_stone_inlay`
--

DROP TABLE IF EXISTS `log_stone_inlay`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_stone_inlay` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `ctrl_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '操作类型 1:镶嵌宝石 2:卸下宝石 3:替换宝石 4:自动卸下',
  `equip_pos` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '装备位置',
  `cell` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '宝石孔位置',
  `pre_stone` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作前宝石id',
  `af_stone` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作后宝石id',
  `extra` varchar(255) NOT NULL DEFAULT '' COMMENT '备注',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='宝石镶卸日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_stone_inlay`
--

LOCK TABLES `log_stone_inlay` WRITE;
/*!40000 ALTER TABLE `log_stone_inlay` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_stone_inlay` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_stone_refine`
--

DROP TABLE IF EXISTS `log_stone_refine`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_stone_refine` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `equip_pos` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '装备位置',
  `pre_lv` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '精炼前等级',
  `cur_lv` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '精炼后等级',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='宝石精炼日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_stone_refine`
--

LOCK TABLES `log_stone_refine` WRITE;
/*!40000 ALTER TABLE `log_stone_refine` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_stone_refine` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_supplication_reward`
--

DROP TABLE IF EXISTS `log_supplication_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_supplication_reward` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(10) unsigned NOT NULL COMMENT '角色id',
  `count` int(10) unsigned NOT NULL COMMENT '抽取次数',
  `reward_lv` tinyint(2) unsigned NOT NULL COMMENT '奖励等级',
  `cost` varchar(512) NOT NULL COMMENT '物品消耗',
  `reward` varchar(512) NOT NULL COMMENT '奖励',
  `reward_id` int(10) unsigned NOT NULL COMMENT '档次id',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='祈愿-祈愿日志表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_supplication_reward`
--

LOCK TABLES `log_supplication_reward` WRITE;
/*!40000 ALTER TABLE `log_supplication_reward` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_supplication_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_supplication_task_finish`
--

DROP TABLE IF EXISTS `log_supplication_task_finish`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_supplication_task_finish` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(10) unsigned NOT NULL COMMENT '角色id',
  `task_id` tinyint(2) unsigned NOT NULL COMMENT '任务id',
  `condition` varchar(255) NOT NULL COMMENT '完成条件',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='祈愿-任务完成';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_supplication_task_finish`
--

LOCK TABLES `log_supplication_task_finish` WRITE;
/*!40000 ALTER TABLE `log_supplication_task_finish` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_supplication_task_finish` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_supplication_task_reward`
--

DROP TABLE IF EXISTS `log_supplication_task_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_supplication_task_reward` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(10) unsigned NOT NULL COMMENT '角色id',
  `task_id` tinyint(2) unsigned NOT NULL COMMENT '任务id',
  `reward_id` int(10) unsigned NOT NULL COMMENT '奖励id',
  `reward` varchar(512) NOT NULL COMMENT '奖励',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='祈愿-任务奖励领取日志表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_supplication_task_reward`
--

LOCK TABLES `log_supplication_task_reward` WRITE;
/*!40000 ALTER TABLE `log_supplication_task_reward` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_supplication_task_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_talisman_develop`
--

DROP TABLE IF EXISTS `log_talisman_develop`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_talisman_develop` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `good_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '道具id',
  `use_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '已使用数量',
  `max_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '当前上限值',
  `pre_attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '使用前法宝属性',
  `after_attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '使用后法宝属性',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '鼓舞时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`) USING BTREE,
  KEY `role_id` (`role_id`) USING BTREE,
  KEY `good_id` (`good_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='法宝培养道具日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_talisman_develop`
--

LOCK TABLES `log_talisman_develop` WRITE;
/*!40000 ALTER TABLE `log_talisman_develop` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_talisman_develop` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_talisman_illusion`
--

DROP TABLE IF EXISTS `log_talisman_illusion`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_talisman_illusion` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `illusion_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '幻形id',
  `opt` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '操作(0:激活 1:升星)',
  `pre_star` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作前星级',
  `after_star` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作后星级',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗道具',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '鼓舞时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`) USING BTREE,
  KEY `role_id` (`role_id`) USING BTREE,
  KEY `illusion_id` (`illusion_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='法宝幻形日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_talisman_illusion`
--

LOCK TABLES `log_talisman_illusion` WRITE;
/*!40000 ALTER TABLE `log_talisman_illusion` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_talisman_illusion` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_talisman_lv`
--

DROP TABLE IF EXISTS `log_talisman_lv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_talisman_lv` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `pre_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作前等级',
  `pre_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作前经验',
  `after_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作后等级',
  `after_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作后经验',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗道具',
  `skills` varchar(255) NOT NULL DEFAULT '[]' COMMENT '当前已激活技能id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '鼓舞时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`) USING BTREE,
  KEY `role_id` (`role_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='法宝升级日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_talisman_lv`
--

LOCK TABLES `log_talisman_lv` WRITE;
/*!40000 ALTER TABLE `log_talisman_lv` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_talisman_lv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_talk_report`
--

DROP TABLE IF EXISTS `log_talk_report`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_talk_report` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `from_id` bigint(20) unsigned NOT NULL COMMENT '举报者id',
  `to_id` bigint(20) unsigned NOT NULL COMMENT '被举报的玩家id',
  `msg` text NOT NULL COMMENT '聊天信息',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `from_id` (`from_id`),
  KEY `to_id` (`to_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='聊天举报日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_talk_report`
--

LOCK TABLES `log_talk_report` WRITE;
/*!40000 ALTER TABLE `log_talk_report` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_talk_report` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_throw`
--

DROP TABLE IF EXISTS `log_throw`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_throw` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `type` smallint(4) unsigned NOT NULL DEFAULT '0' COMMENT '类型，0销毁，1邮件过期，2时间物品过期',
  `pid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色ID',
  `gid` bigint(20) unsigned DEFAULT '0' COMMENT '物品唯一id',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型ID',
  `goods_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品数量',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `pid` (`pid`),
  KEY `gid` (`gid`),
  KEY `goods_id` (`goods_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='销毁日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_throw`
--

LOCK TABLES `log_throw` WRITE;
/*!40000 ALTER TABLE `log_throw` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_throw` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_throw_dice`
--

DROP TABLE IF EXISTS `log_throw_dice`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_throw_dice` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `move_step` tinyint(2) NOT NULL DEFAULT '0' COMMENT '点数',
  `grid_type` tinyint(2) NOT NULL DEFAULT '0' COMMENT '格子类型',
  `time` int(11) NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='冒险之旅投色子日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_throw_dice`
--

LOCK TABLES `log_throw_dice` WRITE;
/*!40000 ALTER TABLE `log_throw_dice` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_throw_dice` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_top_pk`
--

DROP TABLE IF EXISTS `log_top_pk`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_top_pk` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '我的id',
  `fight_role_id` bigint(20) unsigned NOT NULL COMMENT '对手id',
  `fight_role_name` varchar(50) NOT NULL COMMENT '对手名字',
  `is_fake` tinyint(3) unsigned NOT NULL COMMENT '是否假人##1是0否',
  `platform` varchar(50) NOT NULL COMMENT '对手平台',
  `server_num` smallint(5) unsigned NOT NULL COMMENT '对手服务器',
  `res` tinyint(3) unsigned NOT NULL COMMENT '胜负##1胜0负',
  `score_before` int(10) unsigned NOT NULL COMMENT '挑战前积分',
  `score_after` int(10) unsigned NOT NULL COMMENT '挑战后积分',
  `time` int(10) unsigned DEFAULT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='巅峰竞技挑战日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_top_pk`
--

LOCK TABLES `log_top_pk` WRITE;
/*!40000 ALTER TABLE `log_top_pk` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_top_pk` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_total_checkin`
--

DROP TABLE IF EXISTS `log_total_checkin`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_total_checkin` (
  `seq` bigint(20) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `player_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `days` int(8) NOT NULL COMMENT '累计天数',
  `rewards_output` varchar(1024) NOT NULL COMMENT '物品输出',
  `time` int(30) NOT NULL COMMENT '时间',
  PRIMARY KEY (`seq`,`player_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='累计签到日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_total_checkin`
--

LOCK TABLES `log_total_checkin` WRITE;
/*!40000 ALTER TABLE `log_total_checkin` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_total_checkin` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_transfer`
--

DROP TABLE IF EXISTS `log_transfer`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_transfer` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `old_career` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '旧职业',
  `old_sex` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '旧性别',
  `new_career` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '新职业',
  `new_sex` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '新性别',
  `time` int(1) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='转职日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_transfer`
--

LOCK TABLES `log_transfer` WRITE;
/*!40000 ALTER TABLE `log_transfer` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_transfer` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_treasure`
--

DROP TABLE IF EXISTS `log_treasure`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_treasure` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '玩家等级',
  `mine_lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '矿洞等级',
  `type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '领取类型',
  `receive` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '当天领取次数',
  `crit` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '暴击倍数',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='宝藏系统领取日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_treasure`
--

LOCK TABLES `log_treasure` WRITE;
/*!40000 ALTER TABLE `log_treasure` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_treasure` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_treasure_evaluation`
--

DROP TABLE IF EXISTS `log_treasure_evaluation`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_treasure_evaluation` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `type` int(10) unsigned NOT NULL COMMENT '鉴宝数量类型（1一次 2十次）',
  `old_lucky_num` int(10) unsigned NOT NULL COMMENT '旧幸运值',
  `new_lucky_num` int(10) unsigned NOT NULL COMMENT '新幸运值',
  `cost_list` varchar(200) NOT NULL COMMENT '消耗列表',
  `reward_list` varchar(200) NOT NULL COMMENT '奖励列表',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='幸运鉴宝抽奖日志表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_treasure_evaluation`
--

LOCK TABLES `log_treasure_evaluation` WRITE;
/*!40000 ALTER TABLE `log_treasure_evaluation` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_treasure_evaluation` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_treasure_get_guardian`
--

DROP TABLE IF EXISTS `log_treasure_get_guardian`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_treasure_get_guardian` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `guardian_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '守护id',
  `type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '操作类型',
  `expiration_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '有效期',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `guardian_id` (`guardian_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='宝藏守护日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_treasure_get_guardian`
--

LOCK TABLES `log_treasure_get_guardian` WRITE;
/*!40000 ALTER TABLE `log_treasure_get_guardian` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_treasure_get_guardian` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_treasure_hunt`
--

DROP TABLE IF EXISTS `log_treasure_hunt`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_treasure_hunt` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `htype` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '寻宝类型',
  `ctype` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '操作类型',
  `auto_buy` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '自动购买',
  `cost` varchar(100) NOT NULL DEFAULT '[]' COMMENT '消耗',
  `reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `htype` (`htype`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='装备寻宝日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_treasure_hunt`
--

LOCK TABLES `log_treasure_hunt` WRITE;
/*!40000 ALTER TABLE `log_treasure_hunt` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_treasure_hunt` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_treasure_hunt_limit`
--

DROP TABLE IF EXISTS `log_treasure_hunt_limit`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_treasure_hunt_limit` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `htype` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '寻宝类型',
  `stype` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '宝物类型',
  `obj_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '保底类型',
  `already_get_times` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '已抽到几次',
  `all_times` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '保底进度',
  `is_reset` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '是否被重置',
  `reward_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励列表',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `htype` (`htype`),
  KEY `stype` (`stype`),
  KEY `obj_type` (`obj_type`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='寻宝保底日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_treasure_hunt_limit`
--

LOCK TABLES `log_treasure_hunt_limit` WRITE;
/*!40000 ALTER TABLE `log_treasure_hunt_limit` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_treasure_hunt_limit` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_treasure_hunt_lucky`
--

DROP TABLE IF EXISTS `log_treasure_hunt_lucky`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_treasure_hunt_lucky` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `add_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '操作主体',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `htype` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '寻宝类型',
  `ctype` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '操作类型',
  `lucky_id` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '幸运值Id',
  `old_lucky` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '原有幸运值',
  `new_lucky` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '现有幸运值',
  `clear_lucky` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否清空幸运值',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `add_type` (`add_type`),
  KEY `role_id` (`role_id`),
  KEY `htype` (`htype`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='寻宝幸运值日志（合服直接清理）';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_treasure_hunt_lucky`
--

LOCK TABLES `log_treasure_hunt_lucky` WRITE;
/*!40000 ALTER TABLE `log_treasure_hunt_lucky` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_treasure_hunt_lucky` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_treasure_mine_uplv`
--

DROP TABLE IF EXISTS `log_treasure_mine_uplv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_treasure_mine_uplv` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家等级',
  `mine_lv` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '操作前等级',
  `new_mine_lv` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '操作后等级',
  `reward` varchar(50) NOT NULL DEFAULT '[]' COMMENT '升级获得的奖励',
  `cost` varchar(50) NOT NULL DEFAULT '[]' COMMENT '消耗道具',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='宝藏矿场升级';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_treasure_mine_uplv`
--

LOCK TABLES `log_treasure_mine_uplv` WRITE;
/*!40000 ALTER TABLE `log_treasure_mine_uplv` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_treasure_mine_uplv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_treasure_miner`
--

DROP TABLE IF EXISTS `log_treasure_miner`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_treasure_miner` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `miner_id` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '矿工id',
  `cost` varchar(50) NOT NULL DEFAULT '[]' COMMENT '消耗道具',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='宝藏矿工激活';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_treasure_miner`
--

LOCK TABLES `log_treasure_miner` WRITE;
/*!40000 ALTER TABLE `log_treasure_miner` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_treasure_miner` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_twing_plume`
--

DROP TABLE IF EXISTS `log_twing_plume`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_twing_plume` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `o_grade` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作前星级',
  `o_attr` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '操作前属性',
  `n_grade` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作后星级',
  `n_attr` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '操作后星级',
  `num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '数量',
  `cost` varchar(512) NOT NULL DEFAULT '[]' COMMENT '消耗内容',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='翅膀升星日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_twing_plume`
--

LOCK TABLES `log_twing_plume` WRITE;
/*!40000 ALTER TABLE `log_twing_plume` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_twing_plume` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_unlock_box`
--

DROP TABLE IF EXISTS `log_unlock_box`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_unlock_box` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `type_id` int(11) NOT NULL DEFAULT '0' COMMENT '宝箱id',
  `time` int(11) NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='冒险之旅解锁宝箱日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_unlock_box`
--

LOCK TABLES `log_unlock_box` WRITE;
/*!40000 ALTER TABLE `log_unlock_box` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_unlock_box` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_uplv`
--

DROP TABLE IF EXISTS `log_uplv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_uplv` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `pid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色ID',
  `lv` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `turn` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '转生数',
  `fr` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '来源标识',
  `add_exp` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '升级时添加的经验值（刷经验时查看的依据）',
  `exp_list` varchar(512) NOT NULL DEFAULT '[]' COMMENT '经验列表',
  `lv_max_exp` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '升级需要的经验',
  `power` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '战力',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '升级时间',
  PRIMARY KEY (`id`),
  KEY `pid` (`pid`),
  KEY `lv` (`lv`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家升级日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_uplv`
--

LOCK TABLES `log_uplv` WRITE;
/*!40000 ALTER TABLE `log_uplv` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_uplv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_use_wing_soul`
--

DROP TABLE IF EXISTS `log_use_wing_soul`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_use_wing_soul` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `soul_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '羽魂id',
  `oexp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '原值',
  `nexp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '当前值',
  `attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '增加属性',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='翅膀羽魂日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_use_wing_soul`
--

LOCK TABLES `log_use_wing_soul` WRITE;
/*!40000 ALTER TABLE `log_use_wing_soul` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_use_wing_soul` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_version_upgradebag`
--

DROP TABLE IF EXISTS `log_version_upgradebag`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_version_upgradebag` (
  `seq` bigint(30) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `player_id` bigint(30) NOT NULL COMMENT '玩家id',
  `version_code` bigint(30) NOT NULL COMMENT '版本号',
  `rewards_output` varchar(1024) NOT NULL COMMENT '物品输出',
  `time` int(30) NOT NULL COMMENT '时间',
  PRIMARY KEY (`seq`,`player_id`,`version_code`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='版本更新礼包日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_version_upgradebag`
--

LOCK TABLES `log_version_upgradebag` WRITE;
/*!40000 ALTER TABLE `log_version_upgradebag` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_version_upgradebag` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_vip_giftbag`
--

DROP TABLE IF EXISTS `log_vip_giftbag`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_vip_giftbag` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `vip_type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT 'vip类型',
  `vip_lv` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '贵族等级',
  `bag_id` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '礼包id',
  `send_times` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '领取个数',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '花费',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '礼包内容',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='贵族礼包领取日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_vip_giftbag`
--

LOCK TABLES `log_vip_giftbag` WRITE;
/*!40000 ALTER TABLE `log_vip_giftbag` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_vip_giftbag` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_vip_status`
--

DROP TABLE IF EXISTS `log_vip_status`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_vip_status` (
  `seq` bigint(25) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增主键',
  `player_id` bigint(20) NOT NULL COMMENT '用户id',
  `vip_type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT 'vip类型',
  `vip_lv` int(11) NOT NULL COMMENT 'vip等级',
  `props_id` int(20) NOT NULL COMMENT '使用的物品id（直接用钻石或无道具则为0）',
  `vip_status` int(8) NOT NULL COMMENT 'vip状态（0-激活 1-加时 2-过期）',
  `end_time` bigint(20) NOT NULL COMMENT 'vip过期时间',
  `time` bigint(20) NOT NULL COMMENT '日志时间',
  PRIMARY KEY (`seq`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='vip状态变化日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_vip_status`
--

LOCK TABLES `log_vip_status` WRITE;
/*!40000 ALTER TABLE `log_vip_status` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_vip_status` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_vip_task`
--

DROP TABLE IF EXISTS `log_vip_task`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_vip_task` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `vip_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'vip类型',
  `vip_lv` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'vip等级',
  `task_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '任务id',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '领取时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='vip任务奖励日志(合服直接合并)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_vip_task`
--

LOCK TABLES `log_vip_task` WRITE;
/*!40000 ALTER TABLE `log_vip_task` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_vip_task` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_vip_upgrade`
--

DROP TABLE IF EXISTS `log_vip_upgrade`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_vip_upgrade` (
  `seq` bigint(25) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增主键',
  `player_id` bigint(20) NOT NULL COMMENT '玩家id',
  `vip_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'vip类型',
  `vip_lv` int(11) NOT NULL COMMENT 'vip等级',
  `vip_exp` int(11) NOT NULL COMMENT 'vip总经验',
  `diamond_exp` int(11) NOT NULL COMMENT '期间消耗钻石获得的经验',
  `login_exp` int(11) NOT NULL COMMENT '期间登陆获得的经验',
  `goods_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品经验',
  `time` bigint(20) NOT NULL COMMENT '日志时间',
  PRIMARY KEY (`seq`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='经验增长日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_vip_upgrade`
--

LOCK TABLES `log_vip_upgrade` WRITE;
/*!40000 ALTER TABLE `log_vip_upgrade` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_vip_upgrade` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_war_god_targer_reward`
--

DROP TABLE IF EXISTS `log_war_god_targer_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_war_god_targer_reward` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '公会id',
  `boss_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'bossid',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '奖励类型',
  `reward_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励id',
  `rewards` varchar(512) NOT NULL DEFAULT '[]' COMMENT '奖励内容',
  `hurt` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '伤害',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='荣耀战神目标奖励日志表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_war_god_targer_reward`
--

LOCK TABLES `log_war_god_targer_reward` WRITE;
/*!40000 ALTER TABLE `log_war_god_targer_reward` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_war_god_targer_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_wed_rank`
--

DROP TABLE IF EXISTS `log_wed_rank`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_wed_rank` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `sec_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '伴侣Id',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排名',
  `book_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '预约时间',
  `reward` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `time` (`time`) USING BTREE,
  KEY `role_id` (`role_id`) USING BTREE,
  KEY `sec_id` (`sec_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='婚礼榜日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_wed_rank`
--

LOCK TABLES `log_wed_rank` WRITE;
/*!40000 ALTER TABLE `log_wed_rank` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_wed_rank` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_welfare`
--

DROP TABLE IF EXISTS `log_welfare`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_welfare` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '福利卡类型',
  `num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '钻石数',
  `op` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '操作##1购买2领奖',
  `left_count` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '剩余次数',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `type` (`type`),
  KEY `get_time` (`op`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='福利卡日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_welfare`
--

LOCK TABLES `log_welfare` WRITE;
/*!40000 ALTER TABLE `log_welfare` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_welfare` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_welfare_giftbag`
--

DROP TABLE IF EXISTS `log_welfare_giftbag`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_welfare_giftbag` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号id',
  `player_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `lv` int(11) unsigned NOT NULL COMMENT '玩家等级',
  `type` tinyint(1) unsigned NOT NULL COMMENT '礼包类型 1：周一 2：夜间',
  `reward` varchar(1024) NOT NULL COMMENT '礼包内容',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='夜间、周一礼包日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_welfare_giftbag`
--

LOCK TABLES `log_welfare_giftbag` WRITE;
/*!40000 ALTER TABLE `log_welfare_giftbag` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_welfare_giftbag` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_wing_compose`
--

DROP TABLE IF EXISTS `log_wing_compose`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_wing_compose` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `wing_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '合成翅膀',
  `grade` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '翅膀阶数',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗材料',
  `cost_wing` varchar(255) NOT NULL DEFAULT '[]' COMMENT '材料翅膀',
  `result` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '合成结果',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='翅膀合成日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_wing_compose`
--

LOCK TABLES `log_wing_compose` WRITE;
/*!40000 ALTER TABLE `log_wing_compose` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_wing_compose` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_wing_huanhua`
--

DROP TABLE IF EXISTS `log_wing_huanhua`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_wing_huanhua` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `figure_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '幻化id',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `cost` varchar(50) NOT NULL DEFAULT '[]' COMMENT '消耗内容',
  `end_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '限时结束时间',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='翅膀激活日志表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_wing_huanhua`
--

LOCK TABLES `log_wing_huanhua` WRITE;
/*!40000 ALTER TABLE `log_wing_huanhua` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_wing_huanhua` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_wing_huanhua_up`
--

DROP TABLE IF EXISTS `log_wing_huanhua_up`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_wing_huanhua_up` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `figure_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '幻化id',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '消耗内容',
  `grade` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作前星级',
  `new_grade` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作后星级',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='翅膀幻化升星日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_wing_huanhua_up`
--

LOCK TABLES `log_wing_huanhua_up` WRITE;
/*!40000 ALTER TABLE `log_wing_huanhua_up` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_wing_huanhua_up` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log_wing_refine_wing`
--

DROP TABLE IF EXISTS `log_wing_refine_wing`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log_wing_refine_wing` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `orefine_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '前精炼等级',
  `orefine` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '前精炼值',
  `nrefine_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '后精炼等级',
  `nrefine` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '后精炼值',
  `cost` varchar(255) NOT NULL DEFAULT '[]' COMMENT '精炼消耗',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `role_id` (`role_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='翅膀精炼日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log_wing_refine_wing`
--

LOCK TABLES `log_wing_refine_wing` WRITE;
/*!40000 ALTER TABLE `log_wing_refine_wing` DISABLE KEYS */;
/*!40000 ALTER TABLE `log_wing_refine_wing` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `login_reward_player`
--

DROP TABLE IF EXISTS `login_reward_player`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `login_reward_player` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `day_id` int(10) unsigned NOT NULL COMMENT '天数id',
  `get_date` int(10) unsigned NOT NULL COMMENT '获得的当日0点时间戳',
  `refresh_days_time` int(11) unsigned NOT NULL COMMENT '更新登录天数的时间',
  `login_days` smallint(6) unsigned NOT NULL COMMENT '累计登录天数',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='七天登录玩家数据记录表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `login_reward_player`
--

LOCK TABLES `login_reward_player` WRITE;
/*!40000 ALTER TABLE `login_reward_player` DISABLE KEYS */;
/*!40000 ALTER TABLE `login_reward_player` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `lucky_flop`
--

DROP TABLE IF EXISTS `lucky_flop`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `lucky_flop` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `sub_type` int(11) unsigned NOT NULL COMMENT '活动子类型',
  `now_times` int(11) unsigned NOT NULL COMMENT '当前抽奖次数',
  `total_times` int(11) unsigned NOT NULL COMMENT '累计抽奖次数',
  `turn` int(11) unsigned NOT NULL COMMENT '抽奖轮数',
  `draw_rewards` varchar(255) NOT NULL COMMENT '奖池列表[{奖励档次,是否已获取},...]',
  `receive_rewards` varchar(255) NOT NULL COMMENT '已领取累计奖励列表[奖励档次,...]',
  `time` int(11) unsigned NOT NULL COMMENT '数据更新时间',
  PRIMARY KEY (`role_id`,`sub_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='幸运翻牌玩家数据';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `lucky_flop`
--

LOCK TABLES `lucky_flop` WRITE;
/*!40000 ALTER TABLE `lucky_flop` DISABLE KEYS */;
/*!40000 ALTER TABLE `lucky_flop` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `lucky_wheel_all_limit`
--

DROP TABLE IF EXISTS `lucky_wheel_all_limit`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `lucky_wheel_all_limit` (
  `sub_type` int(10) unsigned NOT NULL COMMENT '活动子类型',
  `roll_id` int(10) unsigned NOT NULL COMMENT '转盘序号',
  `times` int(10) unsigned NOT NULL COMMENT '次数',
  PRIMARY KEY (`sub_type`,`roll_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='幸运转盘奖励全服次数记录表(合服清空)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `lucky_wheel_all_limit`
--

LOCK TABLES `lucky_wheel_all_limit` WRITE;
/*!40000 ALTER TABLE `lucky_wheel_all_limit` DISABLE KEYS */;
/*!40000 ALTER TABLE `lucky_wheel_all_limit` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `lucky_wheel_player_limit`
--

DROP TABLE IF EXISTS `lucky_wheel_player_limit`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `lucky_wheel_player_limit` (
  `sub_type` int(10) unsigned NOT NULL,
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `roll_id` int(10) unsigned NOT NULL COMMENT '转盘序号',
  `times` int(10) unsigned DEFAULT NULL COMMENT '次数',
  PRIMARY KEY (`sub_type`,`role_id`,`roll_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='幸运转盘奖励个人次数记录表(合服清空)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `lucky_wheel_player_limit`
--

LOCK TABLES `lucky_wheel_player_limit` WRITE;
/*!40000 ALTER TABLE `lucky_wheel_player_limit` DISABLE KEYS */;
/*!40000 ALTER TABLE `lucky_wheel_player_limit` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mail_attr`
--

DROP TABLE IF EXISTS `mail_attr`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mail_attr` (
  `id` bigint(20) unsigned NOT NULL COMMENT '邮件id',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '类型（1系统/2私人/3帮派）',
  `state` tinyint(1) unsigned NOT NULL DEFAULT '2' COMMENT '状态（1已读/2未读）',
  `locked` tinyint(1) unsigned NOT NULL DEFAULT '2' COMMENT '锁定状态（1锁定/2未锁定）',
  `sid` bigint(20) unsigned NOT NULL COMMENT '发件人id',
  `rid` bigint(20) unsigned NOT NULL COMMENT '收件人id',
  `title` varchar(50) NOT NULL DEFAULT '' COMMENT '邮件标题',
  `cm_attachment` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '普通附件',
  `module_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `sub_module_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '子功能id',
  `timestamp` bigint(21) unsigned NOT NULL DEFAULT '0' COMMENT '时间戳（微秒）',
  `effect_st` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '有效开始时间',
  PRIMARY KEY (`id`),
  KEY `timestamp` (`timestamp`),
  KEY `sid` (`sid`),
  KEY `rid` (`rid`),
  KEY `effect_st` (`effect_st`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='邮件属性';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mail_attr`
--

LOCK TABLES `mail_attr` WRITE;
/*!40000 ALTER TABLE `mail_attr` DISABLE KEYS */;
/*!40000 ALTER TABLE `mail_attr` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mail_content`
--

DROP TABLE IF EXISTS `mail_content`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mail_content` (
  `id` bigint(20) unsigned NOT NULL COMMENT '邮件id',
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '收件人id',
  `content` varchar(500) NOT NULL COMMENT '邮件正文',
  PRIMARY KEY (`id`),
  KEY `player_id` (`rid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='邮件內容';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mail_content`
--

LOCK TABLES `mail_content` WRITE;
/*!40000 ALTER TABLE `mail_content` DISABLE KEYS */;
/*!40000 ALTER TABLE `mail_content` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mail_no_review`
--

DROP TABLE IF EXISTS `mail_no_review`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mail_no_review` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `ids` text NOT NULL,
  `names` text NOT NULL,
  `title` text NOT NULL,
  `content` text NOT NULL,
  `goods_id` int(11) NOT NULL,
  `goods_num` int(11) NOT NULL,
  `bind` tinyint(1) NOT NULL,
  `bcoin` int(11) NOT NULL,
  `coin` int(11) NOT NULL,
  `silver` int(11) NOT NULL,
  `gold` int(11) NOT NULL,
  `type` tinyint(1) NOT NULL,
  `ctime` int(10) NOT NULL,
  `admin_username` varchar(20) NOT NULL,
  `node` smallint(3) NOT NULL COMMENT '线路',
  `minlv` smallint(3) NOT NULL,
  `maxlv` smallint(3) NOT NULL,
  `acc_name` text NOT NULL,
  `stren` tinyint(3) NOT NULL COMMENT '强化',
  `prefix` tinyint(3) NOT NULL COMMENT '前缀',
  `realname` varchar(20) NOT NULL COMMENT '审核批准的管理员名称',
  `point` int(11) NOT NULL DEFAULT '0' COMMENT '积分',
  `special_attachment` varchar(1000) DEFAULT '[]' COMMENT '邮件附件列表',
  `source` varchar(50) DEFAULT NULL COMMENT '渠道',
  `send_time` int(10) NOT NULL DEFAULT '0' COMMENT '指定发送时间',
  `send_type` int(2) NOT NULL DEFAULT '0' COMMENT '0:无需审核;1:需要审核',
  `send_status` int(2) NOT NULL DEFAULT '0' COMMENT '0:未发送;1:已发送',
  `status` int(2) NOT NULL DEFAULT '0' COMMENT '状态：0：未审1：通过2：拒绝',
  PRIMARY KEY (`id`),
  KEY `ctime` (`ctime`),
  KEY `admin_username` (`admin_username`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='后台需要等待审核的邮件';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mail_no_review`
--

LOCK TABLES `mail_no_review` WRITE;
/*!40000 ALTER TABLE `mail_no_review` DISABLE KEYS */;
/*!40000 ALTER TABLE `mail_no_review` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `marriage_ask_time`
--

DROP TABLE IF EXISTS `marriage_ask_time`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `marriage_ask_time` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `ask_follow_time` int(10) unsigned NOT NULL COMMENT '求关注时间',
  `ask_flower_time` int(10) unsigned NOT NULL COMMENT '求鲜花时间',
  `send_msg_time` int(10) unsigned NOT NULL COMMENT '发布征友信息时间',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='婚姻-求关注鲜花时间记录表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `marriage_ask_time`
--

LOCK TABLES `marriage_ask_time` WRITE;
/*!40000 ALTER TABLE `marriage_ask_time` DISABLE KEYS */;
/*!40000 ALTER TABLE `marriage_ask_time` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `marriage_couple_info`
--

DROP TABLE IF EXISTS `marriage_couple_info`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `marriage_couple_info` (
  `role_id_m` bigint(20) unsigned NOT NULL COMMENT '男方玩家id',
  `role_id_w` bigint(20) unsigned NOT NULL COMMENT '女方玩家id',
  `type` int(10) unsigned NOT NULL COMMENT '类型：1情侣 2夫妻',
  `now_wedding_state` int(10) unsigned NOT NULL COMMENT '当前婚礼预约状态（0结婚预约 1当前无婚礼预约 2再次预约 3已预约）',
  `marriage_time` int(10) unsigned NOT NULL COMMENT '结婚时间',
  `activity_type` int(10) unsigned NOT NULL COMMENT '正在进行的活动',
  `activity_stage` int(10) unsigned NOT NULL COMMENT '当前活动阶段',
  `end_activity` int(10) unsigned NOT NULL COMMENT '已经结束的活动',
  `activity_log` varchar(3072) NOT NULL DEFAULT '[]' COMMENT '纪念日记录',
  `daily_log` varchar(3072) NOT NULL DEFAULT '[]' COMMENT '日常记录',
  PRIMARY KEY (`role_id_m`,`role_id_w`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='婚姻情侣数据表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `marriage_couple_info`
--

LOCK TABLES `marriage_couple_info` WRITE;
/*!40000 ALTER TABLE `marriage_couple_info` DISABLE KEYS */;
/*!40000 ALTER TABLE `marriage_couple_info` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `marriage_couple_propose`
--

DROP TABLE IF EXISTS `marriage_couple_propose`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `marriage_couple_propose` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '被求婚的玩家id',
  `propose_role_id` bigint(20) unsigned NOT NULL COMMENT '求婚的玩家id',
  `type` int(10) unsigned NOT NULL COMMENT '类型：1表白 2求婚',
  `propose_type` int(10) unsigned NOT NULL COMMENT '婚礼类型：0没有（表白用） 1下 2中 3高',
  `msg` varchar(500) NOT NULL COMMENT '信息',
  `cost_list` varchar(500) NOT NULL COMMENT '消耗列表',
  `other_cost_list` varchar(500) NOT NULL COMMENT '对方消耗列表',
  `cost_key` varchar(63) NOT NULL COMMENT '消耗key',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`role_id`,`propose_role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='婚姻-求婚表白数据记录表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `marriage_couple_propose`
--

LOCK TABLES `marriage_couple_propose` WRITE;
/*!40000 ALTER TABLE `marriage_couple_propose` DISABLE KEYS */;
/*!40000 ALTER TABLE `marriage_couple_propose` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `marriage_guidance`
--

DROP TABLE IF EXISTS `marriage_guidance`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `marriage_guidance` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `recommend_id` bigint(20) unsigned NOT NULL COMMENT '推荐玩家id',
  `stage` tinyint(1) unsigned NOT NULL COMMENT '当前引导阶段',
  `lv_rewards` varchar(255) NOT NULL COMMENT '已领取等级目标奖励列表',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='婚姻-结婚引导玩家数据表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `marriage_guidance`
--

LOCK TABLES `marriage_guidance` WRITE;
/*!40000 ALTER TABLE `marriage_guidance` DISABLE KEYS */;
/*!40000 ALTER TABLE `marriage_guidance` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `marriage_guidance_task`
--

DROP TABLE IF EXISTS `marriage_guidance_task`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `marriage_guidance_task` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `task_id` tinyint(1) unsigned NOT NULL COMMENT '任务id',
  `status` tinyint(1) unsigned NOT NULL COMMENT '任务状态',
  `progress` int(11) unsigned NOT NULL COMMENT '任务进度',
  `extra` varchar(512) NOT NULL COMMENT '额外记录',
  PRIMARY KEY (`role_id`,`task_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='婚姻-结婚引导状态表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `marriage_guidance_task`
--

LOCK TABLES `marriage_guidance_task` WRITE;
/*!40000 ALTER TABLE `marriage_guidance_task` DISABLE KEYS */;
/*!40000 ALTER TABLE `marriage_guidance_task` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `marriage_life_player`
--

DROP TABLE IF EXISTS `marriage_life_player`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `marriage_life_player` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `stage` int(10) unsigned NOT NULL COMMENT '阶数',
  `heart` int(10) unsigned NOT NULL COMMENT '心数',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='婚姻一生一世玩家数据记录表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `marriage_life_player`
--

LOCK TABLES `marriage_life_player` WRITE;
/*!40000 ALTER TABLE `marriage_life_player` DISABLE KEYS */;
/*!40000 ALTER TABLE `marriage_life_player` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `marriage_love_box`
--

DROP TABLE IF EXISTS `marriage_love_box`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `marriage_love_box` (
  `role_id` bigint(11) unsigned NOT NULL COMMENT '角色id',
  `buy_times` int(10) unsigned NOT NULL COMMENT '总购买次数',
  `get_times` int(10) unsigned NOT NULL COMMENT '已领取次数',
  `receive_time` int(10) unsigned NOT NULL COMMENT '宝盒每日奖励领取时间',
  `timeout` int(10) unsigned NOT NULL COMMENT '奖励超时时间',
  `receive_message` varchar(255) NOT NULL COMMENT '消息列表',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='婚姻-爱情宝盒数据表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `marriage_love_box`
--

LOCK TABLES `marriage_love_box` WRITE;
/*!40000 ALTER TABLE `marriage_love_box` DISABLE KEYS */;
/*!40000 ALTER TABLE `marriage_love_box` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `marriage_parade_order_info`
--

DROP TABLE IF EXISTS `marriage_parade_order_info`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `marriage_parade_order_info` (
  `role_id_m` bigint(20) unsigned NOT NULL COMMENT '男方ID',
  `role_id_w` bigint(20) unsigned NOT NULL COMMENT '女方id',
  `parade_type` int(10) unsigned NOT NULL COMMENT '巡游类型',
  `order_unix_date` int(10) unsigned NOT NULL COMMENT '预约日期',
  `time_id` int(10) unsigned NOT NULL COMMENT '时间id',
  `propose_role_id` bigint(20) unsigned NOT NULL COMMENT '发送请求者id',
  PRIMARY KEY (`role_id_m`,`role_id_w`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='婚姻-巡游数据表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `marriage_parade_order_info`
--

LOCK TABLES `marriage_parade_order_info` WRITE;
/*!40000 ALTER TABLE `marriage_parade_order_info` DISABLE KEYS */;
/*!40000 ALTER TABLE `marriage_parade_order_info` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `marriage_personals_follow`
--

DROP TABLE IF EXISTS `marriage_personals_follow`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `marriage_personals_follow` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '关注玩家',
  `followed_role_id` bigint(20) unsigned NOT NULL COMMENT '被关注玩家id',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`role_id`,`followed_role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='结婚征友大厅关注信息表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `marriage_personals_follow`
--

LOCK TABLES `marriage_personals_follow` WRITE;
/*!40000 ALTER TABLE `marriage_personals_follow` DISABLE KEYS */;
/*!40000 ALTER TABLE `marriage_personals_follow` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `marriage_personals_player`
--

DROP TABLE IF EXISTS `marriage_personals_player`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `marriage_personals_player` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `name` varchar(50) NOT NULL COMMENT '名字',
  `sex` int(10) unsigned NOT NULL COMMENT '性别',
  `vip` int(10) unsigned NOT NULL COMMENT 'vip',
  `career` int(10) unsigned NOT NULL COMMENT '职业',
  `turn` int(10) unsigned NOT NULL COMMENT '转职次数',
  `msg` varchar(500) NOT NULL COMMENT '信息',
  `picture` varchar(500) NOT NULL COMMENT '头像地址',
  `picture_ver` int(10) unsigned NOT NULL COMMENT '头像版本号',
  `type` int(10) unsigned NOT NULL COMMENT '类型 0普通 1置顶',
  `time` int(10) NOT NULL,
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='结婚征友玩家信息表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `marriage_personals_player`
--

LOCK TABLES `marriage_personals_player` WRITE;
/*!40000 ALTER TABLE `marriage_personals_player` DISABLE KEYS */;
/*!40000 ALTER TABLE `marriage_personals_player` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `marriage_ring_player`
--

DROP TABLE IF EXISTS `marriage_ring_player`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `marriage_ring_player` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `stage` int(10) unsigned NOT NULL COMMENT '阶数',
  `star` int(10) unsigned NOT NULL COMMENT '星数',
  `pray_num` int(10) unsigned NOT NULL COMMENT '祝福值',
  `polish_list` varchar(500) NOT NULL COMMENT '打磨列表',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='婚姻戒指玩家数据记录表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `marriage_ring_player`
--

LOCK TABLES `marriage_ring_player` WRITE;
/*!40000 ALTER TABLE `marriage_ring_player` DISABLE KEYS */;
/*!40000 ALTER TABLE `marriage_ring_player` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `marriage_wedding_guest`
--

DROP TABLE IF EXISTS `marriage_wedding_guest`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `marriage_wedding_guest` (
  `role_id_m` bigint(20) unsigned NOT NULL COMMENT '举办人男方玩家id',
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `answer_type` int(10) unsigned NOT NULL COMMENT '回答类型（0未回答 1答应 2拒绝）',
  PRIMARY KEY (`role_id_m`,`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `marriage_wedding_guest`
--

LOCK TABLES `marriage_wedding_guest` WRITE;
/*!40000 ALTER TABLE `marriage_wedding_guest` DISABLE KEYS */;
/*!40000 ALTER TABLE `marriage_wedding_guest` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `marriage_wedding_order_info`
--

DROP TABLE IF EXISTS `marriage_wedding_order_info`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `marriage_wedding_order_info` (
  `role_id_m` bigint(20) NOT NULL,
  `role_id_w` bigint(20) NOT NULL,
  `wedding_type` int(10) unsigned NOT NULL COMMENT '婚礼类型',
  `order_unix_date` int(10) unsigned NOT NULL COMMENT '当天零点时间戳',
  `time_id` int(10) unsigned NOT NULL COMMENT '时间id',
  `guest_num_max` int(10) unsigned NOT NULL COMMENT '宾客数量上限',
  `propose_role_id` bigint(20) unsigned NOT NULL COMMENT '求婚玩家id（只求婚预约婚礼使用）',
  `invited_num` int(10) unsigned NOT NULL COMMENT '已邀请次数',
  PRIMARY KEY (`role_id_m`,`role_id_w`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='婚姻-婚礼预约数据记录表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `marriage_wedding_order_info`
--

LOCK TABLES `marriage_wedding_order_info` WRITE;
/*!40000 ALTER TABLE `marriage_wedding_order_info` DISABLE KEYS */;
/*!40000 ALTER TABLE `marriage_wedding_order_info` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `marriage_wedding_restart`
--

DROP TABLE IF EXISTS `marriage_wedding_restart`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `marriage_wedding_restart` (
  `role_id_m` bigint(20) unsigned NOT NULL COMMENT '男方玩家id',
  `role_id_w` bigint(20) unsigned NOT NULL COMMENT '女方玩家id',
  `man_in` int(10) unsigned NOT NULL COMMENT '男方是否进入场景（0否 1是）',
  `woman_in` int(10) unsigned NOT NULL COMMENT '女方是否进入场景（0否 1是）',
  `aura` int(10) unsigned NOT NULL COMMENT '气氛值',
  `member_id_list` varchar(2000) NOT NULL COMMENT '进入场景成员玩家id列表',
  PRIMARY KEY (`role_id_m`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='婚姻-婚礼服务器重启专用结算数据表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `marriage_wedding_restart`
--

LOCK TABLES `marriage_wedding_restart` WRITE;
/*!40000 ALTER TABLE `marriage_wedding_restart` DISABLE KEYS */;
/*!40000 ALTER TABLE `marriage_wedding_restart` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `merge_server`
--

DROP TABLE IF EXISTS `merge_server`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `merge_server` (
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '类型（1合服时间）',
  `args` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '参数',
  PRIMARY KEY (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='合服参数表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `merge_server`
--

LOCK TABLES `merge_server` WRITE;
/*!40000 ALTER TABLE `merge_server` DISABLE KEYS */;
/*!40000 ALTER TABLE `merge_server` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `module_advance_reward`
--

DROP TABLE IF EXISTS `module_advance_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `module_advance_reward` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `module_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能id',
  `sub_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '功能子id',
  `state` bigint(1) unsigned NOT NULL DEFAULT '0' COMMENT '奖励状态',
  PRIMARY KEY (`role_id`,`module_id`,`sub_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='功能预告奖励';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `module_advance_reward`
--

LOCK TABLES `module_advance_reward` WRITE;
/*!40000 ALTER TABLE `module_advance_reward` DISABLE KEYS */;
/*!40000 ALTER TABLE `module_advance_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mon_checkin`
--

DROP TABLE IF EXISTS `mon_checkin`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mon_checkin` (
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `months` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '月份',
  `checkin_days` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '累计签到天数',
  `extra_state` varchar(512) NOT NULL DEFAULT '[]' COMMENT '累计签到奖励状态',
  PRIMARY KEY (`player_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='月签到';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mon_checkin`
--

LOCK TABLES `mon_checkin` WRITE;
/*!40000 ALTER TABLE `mon_checkin` DISABLE KEYS */;
/*!40000 ALTER TABLE `mon_checkin` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `node`
--

DROP TABLE IF EXISTS `node`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node` (
  `id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `ip` varchar(50) NOT NULL DEFAULT '' COMMENT 'ip地址',
  `port` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '端口号',
  `node` varchar(100) NOT NULL COMMENT '节点',
  `cookie` varchar(100) DEFAULT '' COMMENT 'cookie',
  `state` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否关闭 0开启 1关闭',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='单服节点列表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node`
--

LOCK TABLES `node` WRITE;
/*!40000 ALTER TABLE `node` DISABLE KEYS */;
/*!40000 ALTER TABLE `node` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `notice`
--

DROP TABLE IF EXISTS `notice`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `notice` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '编号',
  `open_day` varchar(255) NOT NULL DEFAULT '[]' COMMENT '开服天数限制',
  `merge_day` varchar(255) NOT NULL DEFAULT '[]' COMMENT '合服天数限制',
  `source` varchar(1024) NOT NULL DEFAULT '' COMMENT '渠道',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '公告类型，0 中1 左2 右3 中左4 中右5 左右6 左中右',
  `color` varchar(7) NOT NULL DEFAULT '' COMMENT '公告颜色',
  `content` varchar(500) NOT NULL DEFAULT '' COMMENT '公告内容',
  `url` varchar(255) NOT NULL DEFAULT '' COMMENT '内容链接',
  `num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '总发送次数，0为不限',
  `span` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '时间间隔',
  `start_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开始时间',
  `end_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '结束时间',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '状态，0为禁用，1为开启',
  PRIMARY KEY (`id`),
  KEY `status` (`status`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='系统公告表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `notice`
--

LOCK TABLES `notice` WRITE;
/*!40000 ALTER TABLE `notice` DISABLE KEYS */;
/*!40000 ALTER TABLE `notice` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `online_gift`
--

DROP TABLE IF EXISTS `online_gift`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `online_gift` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `gift_list` varchar(512) NOT NULL DEFAULT '[]' COMMENT '在线奖励',
  `online_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '在线时长',
  `last_update_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上次更新时间',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='累积在线';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `online_gift`
--

LOCK TABLES `online_gift` WRITE;
/*!40000 ALTER TABLE `online_gift` DISABLE KEYS */;
/*!40000 ALTER TABLE `online_gift` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `overflow_gift`
--

DROP TABLE IF EXISTS `overflow_gift`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `overflow_gift` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `sub_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '子类型',
  `lv_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '到达配置等级时的时间戳',
  PRIMARY KEY (`role_id`,`sub_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='超值礼包活动信息';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `overflow_gift`
--

LOCK TABLES `overflow_gift` WRITE;
/*!40000 ALTER TABLE `overflow_gift` DISABLE KEYS */;
/*!40000 ALTER TABLE `overflow_gift` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `partner`
--

DROP TABLE IF EXISTS `partner`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `partner` (
  `id` bigint(20) unsigned NOT NULL COMMENT '伙伴唯一id',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `partner_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '伙伴id',
  `lv` int(11) unsigned NOT NULL DEFAULT '1' COMMENT '伙伴等级',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '经验',
  `break_st` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '突破状态',
  `break` varchar(128) NOT NULL COMMENT '已突破的等级列表',
  `state` tinyint(2) unsigned NOT NULL DEFAULT '1' COMMENT '伙伴状态',
  `pos` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '伙伴上阵位置',
  `attr_quality` varchar(128) NOT NULL COMMENT '属性品质',
  `total_attr` varchar(256) NOT NULL COMMENT '属性列表',
  `prodigy` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '奇才',
  `apti_take` varchar(128) NOT NULL COMMENT '服用的资质丹数量',
  `skill_learn` varchar(128) NOT NULL COMMENT '学习过的技能',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='伙伴';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `partner`
--

LOCK TABLES `partner` WRITE;
/*!40000 ALTER TABLE `partner` DISABLE KEYS */;
/*!40000 ALTER TABLE `partner` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `partner_equip`
--

DROP TABLE IF EXISTS `partner_equip`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `partner_equip` (
  `id` bigint(20) unsigned NOT NULL COMMENT '伙伴唯一id',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '装备类型',
  `weapon` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '伙伴武器id',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='伙伴装备';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `partner_equip`
--

LOCK TABLES `partner_equip` WRITE;
/*!40000 ALTER TABLE `partner_equip` DISABLE KEYS */;
/*!40000 ALTER TABLE `partner_equip` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `partner_sk`
--

DROP TABLE IF EXISTS `partner_sk`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `partner_sk` (
  `id` bigint(20) unsigned NOT NULL COMMENT '伙伴唯一id',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `sk_id` int(11) unsigned NOT NULL COMMENT '技能id',
  `lv` tinyint(2) unsigned NOT NULL DEFAULT '1' COMMENT '等级',
  `pos` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '技能位置',
  PRIMARY KEY (`id`,`pos`),
  KEY `player_id` (`player_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='伙伴技能';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `partner_sk`
--

LOCK TABLES `partner_sk` WRITE;
/*!40000 ALTER TABLE `partner_sk` DISABLE KEYS */;
/*!40000 ALTER TABLE `partner_sk` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `perfect_lover_reward`
--

DROP TABLE IF EXISTS `perfect_lover_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `perfect_lover_reward` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色id',
  `reward_state` varchar(255) NOT NULL DEFAULT '[]' COMMENT '奖励领取状态',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='三世恋人奖励领取状态';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `perfect_lover_reward`
--

LOCK TABLES `perfect_lover_reward` WRITE;
/*!40000 ALTER TABLE `perfect_lover_reward` DISABLE KEYS */;
/*!40000 ALTER TABLE `perfect_lover_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `perfect_lover_times`
--

DROP TABLE IF EXISTS `perfect_lover_times`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `perfect_lover_times` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id_m` bigint(20) unsigned NOT NULL COMMENT '男方玩家id',
  `role_id_w` bigint(20) unsigned NOT NULL COMMENT '女方玩家id',
  `wedding_type` int(10) unsigned NOT NULL COMMENT '婚礼类型',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='完美恋人玩家婚礼次数记录表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `perfect_lover_times`
--

LOCK TABLES `perfect_lover_times` WRITE;
/*!40000 ALTER TABLE `perfect_lover_times` DISABLE KEYS */;
/*!40000 ALTER TABLE `perfect_lover_times` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `player_1vn`
--

DROP TABLE IF EXISTS `player_1vn`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `player_1vn` (
  `id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `def_type` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '类型（擂主or挑战者）',
  `turn` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '擂主存活到多少轮',
  `area` tinyint(3) unsigned NOT NULL DEFAULT '1' COMMENT '赛区',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家1vn段位记录，合服合并';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `player_1vn`
--

LOCK TABLES `player_1vn` WRITE;
/*!40000 ALTER TABLE `player_1vn` DISABLE KEYS */;
/*!40000 ALTER TABLE `player_1vn` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `player_attr`
--

DROP TABLE IF EXISTS `player_attr`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `player_attr` (
  `id` bigint(20) unsigned NOT NULL COMMENT 'id',
  `cell_num` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '背包格子数',
  `storage_num` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '仓库格子数',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='用户属性';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `player_attr`
--

LOCK TABLES `player_attr` WRITE;
/*!40000 ALTER TABLE `player_attr` DISABLE KEYS */;
/*!40000 ALTER TABLE `player_attr` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `player_daily_liveness`
--

DROP TABLE IF EXISTS `player_daily_liveness`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `player_daily_liveness` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `create_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  `livess_list` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '活跃度列表',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家每日活跃度记录表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `player_daily_liveness`
--

LOCK TABLES `player_daily_liveness` WRITE;
/*!40000 ALTER TABLE `player_daily_liveness` DISABLE KEYS */;
/*!40000 ALTER TABLE `player_daily_liveness` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `player_date_hightest_power`
--

DROP TABLE IF EXISTS `player_date_hightest_power`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `player_date_hightest_power` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '记录类型',
  `num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '当天0点数据',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
  PRIMARY KEY (`role_id`,`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='当天0点数据（合服直接清理）';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `player_date_hightest_power`
--

LOCK TABLES `player_date_hightest_power` WRITE;
/*!40000 ALTER TABLE `player_date_hightest_power` DISABLE KEYS */;
/*!40000 ALTER TABLE `player_date_hightest_power` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `player_deity`
--

DROP TABLE IF EXISTS `player_deity`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `player_deity` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色id',
  `deity_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '神格id',
  `devour_rule` varchar(1024) NOT NULL DEFAULT '' COMMENT '已吞噬法则',
  PRIMARY KEY (`role_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='神格表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `player_deity`
--

LOCK TABLES `player_deity` WRITE;
/*!40000 ALTER TABLE `player_deity` DISABLE KEYS */;
/*!40000 ALTER TABLE `player_deity` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `player_expedition`
--

DROP TABLE IF EXISTS `player_expedition`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `player_expedition` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `start_online_onhook_time` int(11) unsigned NOT NULL COMMENT '最近一次开始在线远征的时间',
  `expedition_need_calc_guardians` varchar(255) NOT NULL COMMENT '远征奖励需要计算的守护列表',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `player_expedition`
--

LOCK TABLES `player_expedition` WRITE;
/*!40000 ALTER TABLE `player_expedition` DISABLE KEYS */;
/*!40000 ALTER TABLE `player_expedition` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `player_fishing`
--

DROP TABLE IF EXISTS `player_fishing`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `player_fishing` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `lv` int(11) unsigned NOT NULL DEFAULT '1' COMMENT '钓鱼等级',
  `mastery` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '熟练度',
  `fish_rod_usage_count` varchar(512) NOT NULL DEFAULT '[]' COMMENT '{鱼竿id,剩余使用次数}',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='钓鱼';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `player_fishing`
--

LOCK TABLES `player_fishing` WRITE;
/*!40000 ALTER TABLE `player_fishing` DISABLE KEYS */;
/*!40000 ALTER TABLE `player_fishing` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `player_goldmine`
--

DROP TABLE IF EXISTS `player_goldmine`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `player_goldmine` (
  `role_id` bigint(20) NOT NULL,
  `mine_lv` smallint(5) NOT NULL,
  `received_times` tinyint(3) NOT NULL,
  `received_update_time` int(11) NOT NULL,
  `online_time` mediumint(8) NOT NULL,
  `online_update_time` int(11) NOT NULL,
  `miners` varchar(255) NOT NULL,
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家金币矿洞数据（合服直接合并）';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `player_goldmine`
--

LOCK TABLES `player_goldmine` WRITE;
/*!40000 ALTER TABLE `player_goldmine` DISABLE KEYS */;
/*!40000 ALTER TABLE `player_goldmine` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `player_guild`
--

DROP TABLE IF EXISTS `player_guild`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `player_guild` (
  `id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `leave_donate` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '最新离开的公会贡献值',
  `leave_guild_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '最新离开的公会id',
  `receive_salary_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上一次领取工资的时间',
  `leave_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上次退出公会时间',
  `depot_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '仓库积分',
  `red_packet` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '红包抢金额',
  `red_gold_packet` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '钻石红包金额',
  `live_reward_ids` varchar(255) NOT NULL DEFAULT '[]' COMMENT '活跃度额外奖励列表',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家的公会信息';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `player_guild`
--

LOCK TABLES `player_guild` WRITE;
/*!40000 ALTER TABLE `player_guild` DISABLE KEYS */;
/*!40000 ALTER TABLE `player_guild` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `player_guild_shop`
--

DROP TABLE IF EXISTS `player_guild_shop`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `player_guild_shop` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `good_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品id',
  `num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '购买数量',
  PRIMARY KEY (`role_id`,`good_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='公会商店购买表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `player_guild_shop`
--

LOCK TABLES `player_guild_shop` WRITE;
/*!40000 ALTER TABLE `player_guild_shop` DISABLE KEYS */;
/*!40000 ALTER TABLE `player_guild_shop` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `player_guild_skill`
--

DROP TABLE IF EXISTS `player_guild_skill`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `player_guild_skill` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `skill_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能id',
  `lv` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  PRIMARY KEY (`role_id`,`skill_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家公会技能';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `player_guild_skill`
--

LOCK TABLES `player_guild_skill` WRITE;
/*!40000 ALTER TABLE `player_guild_skill` DISABLE KEYS */;
/*!40000 ALTER TABLE `player_guild_skill` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `player_high`
--

DROP TABLE IF EXISTS `player_high`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `player_high` (
  `id` bigint(20) unsigned NOT NULL COMMENT 'id',
  `gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '元宝',
  `bgold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '绑定元宝',
  `fgold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '粉钻',
  `coin` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '铜币',
  `gcoin` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '公会币',
  `exp` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '经验',
  `exp_list` varchar(512) NOT NULL DEFAULT '[]' COMMENT '经验列表',
  `hightest_combat_power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '历史最高战力',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='用户高频数据';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `player_high`
--

LOCK TABLES `player_high` WRITE;
/*!40000 ALTER TABLE `player_high` DISABLE KEYS */;
/*!40000 ALTER TABLE `player_high` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `player_liveness`
--

DROP TABLE IF EXISTS `player_liveness`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `player_liveness` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活跃度等级',
  `liveness` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家活跃度',
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家所选形象',
  `display_status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '隐藏状态 0:隐藏 1:显示',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家活跃度';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `player_liveness`
--

LOCK TABLES `player_liveness` WRITE;
/*!40000 ALTER TABLE `player_liveness` DISABLE KEYS */;
/*!40000 ALTER TABLE `player_liveness` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `player_login`
--

DROP TABLE IF EXISTS `player_login`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `player_login` (
  `id` bigint(20) unsigned NOT NULL COMMENT 'id',
  `server_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '初始服id',
  `accid` int(11) unsigned NOT NULL DEFAULT '0',
  `accname` varchar(50) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '' COMMENT '平台账户',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '玩家状态（0正常1禁止）',
  `reg_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '注册时间',
  `reg_ip` varchar(20) NOT NULL DEFAULT '' COMMENT '注册IP',
  `last_login_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最后登陆时间',
  `last_login_ip` varchar(20) NOT NULL DEFAULT '' COMMENT '最后登陆ip',
  `gm` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT 'GM账号(0普通,1gm)',
  `talk_reported_count` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '聊天被举报的次数',
  `talk_lim_count` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '聊天被禁言的次数',
  `talk_lim` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '禁言(0开放,1禁言)',
  `talk_lim_type` tinyint(1) DEFAULT '0' COMMENT '禁言类型a',
  `talk_lim_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '禁言截止时间',
  `last_logout_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最后退出时间',
  `online_flag` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否在线',
  `talk_lim_right` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '禁言权限 0无权限 1有权限',
  `source` varchar(50) NOT NULL DEFAULT '' COMMENT '渠道来源',
  `logout_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '通用最后退出时间',
  `last_pay_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最后一次充值时间',
  `comeback_state` tinyint(3) NOT NULL DEFAULT '0' COMMENT '封测回归处理状态',
  PRIMARY KEY (`id`),
  KEY `server_id` (`server_id`),
  KEY `reg_time` (`reg_time`),
  KEY `last_login_time` (`last_login_time`),
  KEY `status` (`status`),
  KEY `reg_ip` (`reg_ip`),
  KEY `account` (`accid`,`accname`),
  KEY `accname` (`accname`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='用户登陆信息';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `player_login`
--

LOCK TABLES `player_login` WRITE;
/*!40000 ALTER TABLE `player_login` DISABLE KEYS */;
/*!40000 ALTER TABLE `player_login` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `player_login_return_reward`
--

DROP TABLE IF EXISTS `player_login_return_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `player_login_return_reward` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `subtype` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `grade` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '奖励档次',
  `buy_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '购买时间',
  `receive_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '领取时间',
  `utime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '数据更新时间',
  PRIMARY KEY (`role_id`,`subtype`,`grade`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='0元豪礼';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `player_login_return_reward`
--

LOCK TABLES `player_login_return_reward` WRITE;
/*!40000 ALTER TABLE `player_login_return_reward` DISABLE KEYS */;
/*!40000 ALTER TABLE `player_login_return_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `player_low`
--

DROP TABLE IF EXISTS `player_low`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `player_low` (
  `id` bigint(20) unsigned NOT NULL COMMENT 'id',
  `nickname` varchar(50) NOT NULL COMMENT '角色昵称',
  `sex` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '性别:1男 2女',
  `lv` smallint(2) unsigned NOT NULL DEFAULT '1' COMMENT '等级',
  `onhook_lv` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '离线挂机时等级',
  `career` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '职业',
  `realm` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '阵营',
  `picture` varchar(100) NOT NULL DEFAULT '' COMMENT '玩家上传的头像url',
  `picture_lim` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否禁止头像0：正常1：禁止',
  `picture_ver` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家上传的头像版本号',
  `profile_photo_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家头像id',
  `c_rename` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '改名标记',
  `c_rename_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家名字上一次修改时间',
  `c_recareer_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家转职cd时间',
  PRIMARY KEY (`id`),
  UNIQUE KEY `nickname` (`nickname`),
  KEY `lv` (`lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='用户低频数据';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `player_low`
--

LOCK TABLES `player_low` WRITE;
/*!40000 ALTER TABLE `player_low` DISABLE KEYS */;
/*!40000 ALTER TABLE `player_low` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `player_mount`
--

DROP TABLE IF EXISTS `player_mount`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `player_mount` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `stage` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '坐骑阶数',
  `star` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '坐骑星数',
  `blessing` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '祝福值',
  `base_attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '基础属性',
  `illusion_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '幻化类型 1: 基础类型 2: 幻形类型',
  `illusion_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '幻化的id 基础类型为幻化的等阶 幻形类型为幻形的id',
  `is_ride` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否骑乘 0: 不骑 1: 骑',
  `equip_stren` varchar(255) NOT NULL DEFAULT '[]' COMMENT '装备强化等级经验',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家坐骑';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `player_mount`
--

LOCK TABLES `player_mount` WRITE;
/*!40000 ALTER TABLE `player_mount` DISABLE KEYS */;
/*!40000 ALTER TABLE `player_mount` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `player_mount_figure`
--

DROP TABLE IF EXISTS `player_mount_figure`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `player_mount_figure` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '激活的形象id',
  `stage` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '幻化形象阶数',
  `blessing` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '祝福值',
  `effect_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '有效时间',
  PRIMARY KEY (`role_id`,`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家坐骑幻形数据';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `player_mount_figure`
--

LOCK TABLES `player_mount_figure` WRITE;
/*!40000 ALTER TABLE `player_mount_figure` DISABLE KEYS */;
/*!40000 ALTER TABLE `player_mount_figure` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `player_npc`
--

DROP TABLE IF EXISTS `player_npc`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `player_npc` (
  `id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色id',
  `npc_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'NPCID',
  `is_show` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'NPC状态,0不显示,1显示',
  `scene_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '场景id',
  `x` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'X位置',
  `y` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'Y位置',
  `args` varchar(400) NOT NULL DEFAULT '' COMMENT 'npc模型和动作参数',
  UNIQUE KEY `id` (`id`,`npc_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家NPC动态显示';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `player_npc`
--

LOCK TABLES `player_npc` WRITE;
/*!40000 ALTER TABLE `player_npc` DISABLE KEYS */;
/*!40000 ALTER TABLE `player_npc` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `player_partner`
--

DROP TABLE IF EXISTS `player_partner`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `player_partner` (
  `id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家唯一id',
  `coin_recruit_tms` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '金币招募次数',
  `coin_recruit_et` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '金币招募免费时间戳',
  `gold_recruit_tms` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '元宝招募次数',
  `gold_recruit_et` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '元宝招募免费时间戳',
  `embattle` varchar(256) NOT NULL COMMENT '布阵',
  `recruit_list` varchar(2048) NOT NULL COMMENT '招募列表',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家伙伴状态';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `player_partner`
--

LOCK TABLES `player_partner` WRITE;
/*!40000 ALTER TABLE `player_partner` DISABLE KEYS */;
/*!40000 ALTER TABLE `player_partner` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `player_pic`
--

DROP TABLE IF EXISTS `player_pic`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `player_pic` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `pic_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '图鉴id',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '图鉴等级',
  PRIMARY KEY (`role_id`,`pic_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='图鉴表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `player_pic`
--

LOCK TABLES `player_pic` WRITE;
/*!40000 ALTER TABLE `player_pic` DISABLE KEYS */;
/*!40000 ALTER TABLE `player_pic` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `player_pyx`
--

DROP TABLE IF EXISTS `player_pyx`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `player_pyx` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色id',
  `spirit_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '精灵id',
  `pyx_id_list` varchar(255) NOT NULL DEFAULT '' COMMENT '圣器id列表',
  `exp` int(20) unsigned NOT NULL DEFAULT '0' COMMENT '经验',
  `lv` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  PRIMARY KEY (`role_id`,`spirit_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='圣器表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `player_pyx`
--

LOCK TABLES `player_pyx` WRITE;
/*!40000 ALTER TABLE `player_pyx` DISABLE KEYS */;
/*!40000 ALTER TABLE `player_pyx` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `player_recharge`
--

DROP TABLE IF EXISTS `player_recharge`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `player_recharge` (
  `id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色id',
  `total` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '总充值金额',
  `merge` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '合服后充值',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家充值统计表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `player_recharge`
--

LOCK TABLES `player_recharge` WRITE;
/*!40000 ALTER TABLE `player_recharge` DISABLE KEYS */;
/*!40000 ALTER TABLE `player_recharge` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `player_rename`
--

DROP TABLE IF EXISTS `player_rename`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `player_rename` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `role_id` bigint(20) unsigned NOT NULL COMMENT '角色id',
  `old_name` varchar(50) NOT NULL COMMENT '角色昵称',
  `c_rename_time` int(11) NOT NULL COMMENT '修改名字时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='修改昵称';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `player_rename`
--

LOCK TABLES `player_rename` WRITE;
/*!40000 ALTER TABLE `player_rename` DISABLE KEYS */;
/*!40000 ALTER TABLE `player_rename` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `player_setting`
--

DROP TABLE IF EXISTS `player_setting`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `player_setting` (
  `id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `type` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '设置主类型',
  `subtype` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '设置次类型',
  `is_open` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '是否开关（1:开 0:关）',
  PRIMARY KEY (`id`,`type`,`subtype`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家设置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `player_setting`
--

LOCK TABLES `player_setting` WRITE;
/*!40000 ALTER TABLE `player_setting` DISABLE KEYS */;
/*!40000 ALTER TABLE `player_setting` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `player_smashed_egg`
--

DROP TABLE IF EXISTS `player_smashed_egg`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `player_smashed_egg` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `subtype` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `online_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '累计在线时间',
  `lfree_smashed_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最后免费砸蛋时间戳',
  `add_refresh_times` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '全砸赠送的刷新次数',
  `refresh_times` smallint(2) NOT NULL DEFAULT '0' COMMENT '刷新次数',
  `free_smashed_times` smallint(2) NOT NULL DEFAULT '0' COMMENT '免费砸蛋次数',
  `smashed_times` smallint(2) NOT NULL DEFAULT '0' COMMENT '砸蛋总次数',
  `eggs` varchar(255) NOT NULL DEFAULT '' COMMENT '金蛋列表',
  `cumulate_reward` varchar(100) NOT NULL DEFAULT '0' COMMENT '累计奖励领取状态',
  `show_ids` varchar(50) NOT NULL DEFAULT '' COMMENT '展示id列表',
  `utime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '数据更新时间',
  PRIMARY KEY (`role_id`,`subtype`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='砸蛋';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `player_smashed_egg`
--

LOCK TABLES `player_smashed_egg` WRITE;
/*!40000 ALTER TABLE `player_smashed_egg` DISABLE KEYS */;
/*!40000 ALTER TABLE `player_smashed_egg` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `player_smashed_egg_reward`
--

DROP TABLE IF EXISTS `player_smashed_egg_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `player_smashed_egg_reward` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色ID',
  `subtype` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型ID',
  `num` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '数量',
  PRIMARY KEY (`role_id`,`subtype`,`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='砸蛋奖励列表（合服直接合并）';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `player_smashed_egg_reward`
--

LOCK TABLES `player_smashed_egg_reward` WRITE;
/*!40000 ALTER TABLE `player_smashed_egg_reward` DISABLE KEYS */;
/*!40000 ALTER TABLE `player_smashed_egg_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `player_special_currency`
--

DROP TABLE IF EXISTS `player_special_currency`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `player_special_currency` (
  `player_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `currency_id` int(10) unsigned NOT NULL COMMENT '货币物品id',
  `num` int(10) unsigned NOT NULL COMMENT '数量',
  PRIMARY KEY (`player_id`,`currency_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='特殊货币数据';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `player_special_currency`
--

LOCK TABLES `player_special_currency` WRITE;
/*!40000 ALTER TABLE `player_special_currency` DISABLE KEYS */;
/*!40000 ALTER TABLE `player_special_currency` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `player_star_soul`
--

DROP TABLE IF EXISTS `player_star_soul`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `player_star_soul` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色ID',
  `star_soul_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '星灵id',
  `stage` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '星灵阶数',
  `star` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '星灵星阶',
  `lv` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '星灵星数',
  `exp` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '当前星数的经验',
  `loc` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '出战类型',
  `pos` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '所在战位的格子',
  `upgrade_times` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '星灵星阶的升级次数',
  `passive_skills` varchar(255) NOT NULL DEFAULT '[]' COMMENT '被动技能列表',
  `formation` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '战斗阵型位置',
  PRIMARY KEY (`role_id`,`star_soul_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家星灵表（合服直接合并）';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `player_star_soul`
--

LOCK TABLES `player_star_soul` WRITE;
/*!40000 ALTER TABLE `player_star_soul` DISABLE KEYS */;
/*!40000 ALTER TABLE `player_star_soul` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `player_star_soul_universe`
--

DROP TABLE IF EXISTS `player_star_soul_universe`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `player_star_soul_universe` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色ID',
  `universe_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '小宇宙id',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家星灵小宇宙表（合服直接合并）';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `player_star_soul_universe`
--

LOCK TABLES `player_star_soul_universe` WRITE;
/*!40000 ALTER TABLE `player_star_soul_universe` DISABLE KEYS */;
/*!40000 ALTER TABLE `player_star_soul_universe` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `player_star_soul_war`
--

DROP TABLE IF EXISTS `player_star_soul_war`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `player_star_soul_war` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `level_ids` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '已通过层数列表',
  `pass_times` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '累积周通关次数',
  `last_calc_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最后周结算时间',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家星灵试炼表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `player_star_soul_war`
--

LOCK TABLES `player_star_soul_war` WRITE;
/*!40000 ALTER TABLE `player_star_soul_war` DISABLE KEYS */;
/*!40000 ALTER TABLE `player_star_soul_war` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `player_state`
--

DROP TABLE IF EXISTS `player_state`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `player_state` (
  `id` bigint(20) unsigned NOT NULL COMMENT 'id',
  `scene` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '场景',
  `x` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT 'x坐标',
  `y` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT 'y坐标',
  `hp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '气血',
  `mp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '内力',
  `pk_value` smallint(6) unsigned NOT NULL DEFAULT '0' COMMENT 'pk值',
  `pk_status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT 'pk状态',
  `pk_status_change_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'pk转换时间',
  `guild_quit_lasttime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上次退出帮派时间',
  `anger` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '怒气值',
  `quickbar` varchar(500) NOT NULL DEFAULT '[]' COMMENT '快捷栏',
  `skill_cd` varchar(5000) NOT NULL DEFAULT '[]' COMMENT '技能cd列表',
  `sys_conf` varchar(50) NOT NULL DEFAULT '[]' COMMENT '玩家配置',
  `skill_extra_point` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '额外技能点',
  `last_combat_power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家最后退出游戏时候的战力',
  `pk_value_change_time` int(10) unsigned DEFAULT '0' COMMENT '罪恶值修改时间(间隔12小时)',
  `last_task_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '上一次完成的主线任务id',
  `last_be_kill` varchar(250) NOT NULL DEFAULT '[]' COMMENT '最后击杀自己的玩家信息',
  PRIMARY KEY (`id`),
  KEY `scene` (`scene`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='用户下线时保存信息表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `player_state`
--

LOCK TABLES `player_state` WRITE;
/*!40000 ALTER TABLE `player_state` DISABLE KEYS */;
/*!40000 ALTER TABLE `player_state` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `player_talisman`
--

DROP TABLE IF EXISTS `player_talisman`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `player_talisman` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `lv` int(5) unsigned NOT NULL DEFAULT '0' COMMENT '法宝等级',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '经验',
  `illusion_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '幻化的化形Id',
  `display_status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '显示状态',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家法宝';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `player_talisman`
--

LOCK TABLES `player_talisman` WRITE;
/*!40000 ALTER TABLE `player_talisman` DISABLE KEYS */;
/*!40000 ALTER TABLE `player_talisman` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `player_talisman_figure`
--

DROP TABLE IF EXISTS `player_talisman_figure`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `player_talisman_figure` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '激活的化形id',
  `star` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '化形星数',
  PRIMARY KEY (`role_id`,`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家法宝化形数据';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `player_talisman_figure`
--

LOCK TABLES `player_talisman_figure` WRITE;
/*!40000 ALTER TABLE `player_talisman_figure` DISABLE KEYS */;
/*!40000 ALTER TABLE `player_talisman_figure` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `player_top_pk`
--

DROP TABLE IF EXISTS `player_top_pk`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `player_top_pk` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '赛季积分',
  `grade_reward_list` varchar(128) NOT NULL DEFAULT '[]' COMMENT '已领段位奖励列表',
  `match_reward_list` varchar(128) NOT NULL DEFAULT '[]' COMMENT '已领匹配次数奖励',
  `pk_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上次PK时间',
  `enter_count` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '匹配场数',
  `continued_fail` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '连续失败场次',
  `continued_win` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '连续失败场次',
  PRIMARY KEY (`role_id`),
  KEY `score` (`score`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='巅峰竞技玩家数据';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `player_top_pk`
--

LOCK TABLES `player_top_pk` WRITE;
/*!40000 ALTER TABLE `player_top_pk` DISABLE KEYS */;
/*!40000 ALTER TABLE `player_top_pk` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `player_transfer`
--

DROP TABLE IF EXISTS `player_transfer`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `player_transfer` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `last_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最后一次转职时间',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家转职';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `player_transfer`
--

LOCK TABLES `player_transfer` WRITE;
/*!40000 ALTER TABLE `player_transfer` DISABLE KEYS */;
/*!40000 ALTER TABLE `player_transfer` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `player_treasure_hunt`
--

DROP TABLE IF EXISTS `player_treasure_hunt`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `player_treasure_hunt` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `htype` tinyint(3) unsigned NOT NULL COMMENT '寻宝类型',
  `next_free_time` int(11) unsigned NOT NULL COMMENT '下次免费寻宝时间',
  `first` tinyint(3) unsigned NOT NULL COMMENT '是否是第一次寻宝1是',
  `times` int(11) unsigned NOT NULL COMMENT '寻宝次数',
  PRIMARY KEY (`role_id`,`htype`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家寻宝状态';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `player_treasure_hunt`
--

LOCK TABLES `player_treasure_hunt` WRITE;
/*!40000 ALTER TABLE `player_treasure_hunt` DISABLE KEYS */;
/*!40000 ALTER TABLE `player_treasure_hunt` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `player_twing`
--

DROP TABLE IF EXISTS `player_twing`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `player_twing` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `refine_lv` int(11) unsigned NOT NULL DEFAULT '1' COMMENT '精炼等级',
  `refine_exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '精炼值',
  `figure_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '当前幻化的id',
  `plume_grade` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '翅膀羽化星级',
  `plume_attr` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '翅膀羽化属性',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家翅膀表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `player_twing`
--

LOCK TABLES `player_twing` WRITE;
/*!40000 ALTER TABLE `player_twing` DISABLE KEYS */;
/*!40000 ALTER TABLE `player_twing` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `player_twing_figure`
--

DROP TABLE IF EXISTS `player_twing_figure`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `player_twing_figure` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '幻化id',
  `grade` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '星级',
  `effect_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '有效时间',
  PRIMARY KEY (`role_id`,`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `player_twing_figure`
--

LOCK TABLES `player_twing_figure` WRITE;
/*!40000 ALTER TABLE `player_twing_figure` DISABLE KEYS */;
/*!40000 ALTER TABLE `player_twing_figure` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `player_twing_soul`
--

DROP TABLE IF EXISTS `player_twing_soul`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `player_twing_soul` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `soul_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '羽魂id',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '培养值',
  PRIMARY KEY (`role_id`,`soul_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `player_twing_soul`
--

LOCK TABLES `player_twing_soul` WRITE;
/*!40000 ALTER TABLE `player_twing_soul` DISABLE KEYS */;
/*!40000 ALTER TABLE `player_twing_soul` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `player_vip`
--

DROP TABLE IF EXISTS `player_vip`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `player_vip` (
  `role_id` bigint(32) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `vip_lv` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'vip等级',
  `vip_endtime` int(20) unsigned NOT NULL DEFAULT '0' COMMENT 'vip有效时间',
  PRIMARY KEY (`role_id`,`vip_lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家vip表(合服直接合并)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `player_vip`
--

LOCK TABLES `player_vip` WRITE;
/*!40000 ALTER TABLE `player_vip` DISABLE KEYS */;
/*!40000 ALTER TABLE `player_vip` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `pushmail`
--

DROP TABLE IF EXISTS `pushmail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `pushmail` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `mail` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '历史邮件Id',
  PRIMARY KEY (`role_id`,`mail`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='邮件推送';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `pushmail`
--

LOCK TABLES `pushmail` WRITE;
/*!40000 ALTER TABLE `pushmail` DISABLE KEYS */;
/*!40000 ALTER TABLE `pushmail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `race_act`
--

DROP TABLE IF EXISTS `race_act`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `race_act` (
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '主类型',
  `subtype` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '次类型',
  PRIMARY KEY (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='竞榜开启活动表(合服清空)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `race_act`
--

LOCK TABLES `race_act` WRITE;
/*!40000 ALTER TABLE `race_act` DISABLE KEYS */;
/*!40000 ALTER TABLE `race_act` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `race_act_rank`
--

DROP TABLE IF EXISTS `race_act_rank`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `race_act_rank` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `subtype` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '次类型',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服id',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服数',
  `name` varchar(50) NOT NULL DEFAULT '[]' COMMENT '名字',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分数',
  `act_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动开始时间',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上榜时间',
  PRIMARY KEY (`role_id`,`type`,`subtype`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='竞榜活动榜单表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `race_act_rank`
--

LOCK TABLES `race_act_rank` WRITE;
/*!40000 ALTER TABLE `race_act_rank` DISABLE KEYS */;
/*!40000 ALTER TABLE `race_act_rank` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `race_act_role`
--

DROP TABLE IF EXISTS `race_act_role`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `race_act_role` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `subtype` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '子类型',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  `today_score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '今日积分',
  `times` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '累积次数',
  `reward_list` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '已获奖励',
  `score_reward` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '已领取阶段奖励',
  `other` varchar(2048) NOT NULL DEFAULT '[]' COMMENT '其它数据类型',
  `last_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`role_id`,`type`,`subtype`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='竞榜活动玩家表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `race_act_role`
--

LOCK TABLES `race_act_role` WRITE;
/*!40000 ALTER TABLE `race_act_role` DISABLE KEYS */;
/*!40000 ALTER TABLE `race_act_role` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `recharge_act`
--

DROP TABLE IF EXISTS `recharge_act`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `recharge_act` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `product_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '充值商品ID',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上次领取时间',
  `left_count` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '剩余数量',
  `buy_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '购买时间',
  PRIMARY KEY (`role_id`,`product_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='充值商品';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `recharge_act`
--

LOCK TABLES `recharge_act` WRITE;
/*!40000 ALTER TABLE `recharge_act` DISABLE KEYS */;
/*!40000 ALTER TABLE `recharge_act` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `recharge_cumulation_reward`
--

DROP TABLE IF EXISTS `recharge_cumulation_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `recharge_cumulation_reward` (
  `player_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `subtype` tinyint(3) unsigned NOT NULL COMMENT '活动子类型',
  `id` int(10) unsigned NOT NULL COMMENT '奖励id',
  `time` int(10) unsigned NOT NULL COMMENT '时间，重置用',
  `state` tinyint(3) unsigned NOT NULL COMMENT '是否领取 0否1是',
  `info` varchar(255) NOT NULL COMMENT '信息，发邮件用',
  PRIMARY KEY (`player_id`,`subtype`,`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='累充活动奖励领取状态';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `recharge_cumulation_reward`
--

LOCK TABLES `recharge_cumulation_reward` WRITE;
/*!40000 ALTER TABLE `recharge_cumulation_reward` DISABLE KEYS */;
/*!40000 ALTER TABLE `recharge_cumulation_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `recharge_daily_gift`
--

DROP TABLE IF EXISTS `recharge_daily_gift`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `recharge_daily_gift` (
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `product_id` int(11) NOT NULL DEFAULT '0' COMMENT '商品编号',
  `state` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '礼包状态',
  PRIMARY KEY (`player_id`,`product_id`),
  KEY `player_id` (`player_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='每日礼包';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `recharge_daily_gift`
--

LOCK TABLES `recharge_daily_gift` WRITE;
/*!40000 ALTER TABLE `recharge_daily_gift` DISABLE KEYS */;
/*!40000 ALTER TABLE `recharge_daily_gift` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `recharge_first`
--

DROP TABLE IF EXISTS `recharge_first`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `recharge_first` (
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `award_list` varchar(128) NOT NULL COMMENT '已领奖励列表',
  `login_days` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '首充后累计登陆天数',
  `refresh_days_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '更新login_days时间',
  PRIMARY KEY (`player_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='首充奖励表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `recharge_first`
--

LOCK TABLES `recharge_first` WRITE;
/*!40000 ALTER TABLE `recharge_first` DISABLE KEYS */;
/*!40000 ALTER TABLE `recharge_first` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `recharge_log`
--

DROP TABLE IF EXISTS `recharge_log`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `recharge_log` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `accid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '平台账号id',
  `accname` varchar(50) NOT NULL DEFAULT '[]' COMMENT '平台账号',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色ID',
  `type` int(4) unsigned NOT NULL DEFAULT '0' COMMENT '1:充值 2:钻石卡',
  `product_id` int(11) NOT NULL DEFAULT '0' COMMENT '商品id',
  `money` decimal(12,2) NOT NULL DEFAULT '0.00' COMMENT '金额',
  `gold` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '钻石',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`),
  KEY `product_id` (`product_id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='充值日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `recharge_log`
--

LOCK TABLES `recharge_log` WRITE;
/*!40000 ALTER TABLE `recharge_log` DISABLE KEYS */;
/*!40000 ALTER TABLE `recharge_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `recharge_return`
--

DROP TABLE IF EXISTS `recharge_return`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `recharge_return` (
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色id',
  `product_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商品id',
  `return_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '返利类型',
  `return_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '返利时间',
  PRIMARY KEY (`player_id`,`product_id`,`return_type`),
  KEY `return_time` (`return_time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='充值返利表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `recharge_return`
--

LOCK TABLES `recharge_return` WRITE;
/*!40000 ALTER TABLE `recharge_return` DISABLE KEYS */;
/*!40000 ALTER TABLE `recharge_return` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `red_envelopes`
--

DROP TABLE IF EXISTS `red_envelopes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `red_envelopes` (
  `id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '红包类型',
  `ownership_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '1:公会 2:世界',
  `ownership_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '归属id 公会红包为公会的id',
  `owner_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '拥有者玩家id',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '0: 未发送 1: 已发送 2: 已领完 3: 已过期',
  `money` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '红包额度',
  `money_list` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '金额列表',
  `share_list` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '玩家id',
  `split_num` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '红包拆分数量',
  `extra` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '系统赠送红包为配置id 道具红包为道具id',
  `greet` varchar(255) NOT NULL DEFAULT '' COMMENT '祝福语',
  `stime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '红包发送时间',
  `ctime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '创建时间',
  PRIMARY KEY (`id`),
  KEY `ownership_id` (`ownership_id`),
  KEY `owner_id` (`owner_id`),
  KEY `status` (`status`,`stime`),
  KEY `ownership_id_2` (`ownership_id`,`owner_id`,`status`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='红包';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `red_envelopes`
--

LOCK TABLES `red_envelopes` WRITE;
/*!40000 ALTER TABLE `red_envelopes` DISABLE KEYS */;
/*!40000 ALTER TABLE `red_envelopes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `red_envelopes_recipients_record`
--

DROP TABLE IF EXISTS `red_envelopes_recipients_record`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `red_envelopes_recipients_record` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `red_envelopes_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '红包id',
  `ownership_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '归属id 公会红包为公会的id',
  `money` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '领取到的额度',
  `stime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '红包发送时间(用来批量删除)',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`role_id`,`red_envelopes_id`),
  KEY `ownership_id` (`ownership_id`),
  KEY `stime` (`stime`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='红包领取记录';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `red_envelopes_recipients_record`
--

LOCK TABLES `red_envelopes_recipients_record` WRITE;
/*!40000 ALTER TABLE `red_envelopes_recipients_record` DISABLE KEYS */;
/*!40000 ALTER TABLE `red_envelopes_recipients_record` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `reincarnation`
--

DROP TABLE IF EXISTS `reincarnation`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `reincarnation` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `turn` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '转生次数',
  `stage` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '转生阶段',
  `stage_tasks` varchar(255) NOT NULL DEFAULT '[]' COMMENT '完成的阶段任务id',
  `attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '转生属性奖励',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家转生数据';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `reincarnation`
--

LOCK TABLES `reincarnation` WRITE;
/*!40000 ALTER TABLE `reincarnation` DISABLE KEYS */;
/*!40000 ALTER TABLE `reincarnation` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `rela_friend_ask`
--

DROP TABLE IF EXISTS `rela_friend_ask`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `rela_friend_ask` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '被请求的玩家id',
  `ask_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '请求的玩家id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '请求时间',
  PRIMARY KEY (`role_id`,`ask_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='好友请求';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `rela_friend_ask`
--

LOCK TABLES `rela_friend_ask` WRITE;
/*!40000 ALTER TABLE `rela_friend_ask` DISABLE KEYS */;
/*!40000 ALTER TABLE `rela_friend_ask` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `relationship`
--

DROP TABLE IF EXISTS `relationship`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `relationship` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `other_rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '关系另一方的玩家id',
  `rela_type` int(11) unsigned NOT NULL DEFAULT '0',
  `intimacy` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '亲密度',
  `last_chat_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最后聊天时间',
  `ctime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '关系记录创建时间',
  PRIMARY KEY (`role_id`,`other_rid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='关系列表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `relationship`
--

LOCK TABLES `relationship` WRITE;
/*!40000 ALTER TABLE `relationship` DISABLE KEYS */;
/*!40000 ALTER TABLE `relationship` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `resource_back`
--

DROP TABLE IF EXISTS `resource_back`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `resource_back` (
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `cleartime` int(11) NOT NULL DEFAULT '0' COMMENT '清除时间',
  `daytype` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '日期类型',
  `act_list` varchar(512) NOT NULL DEFAULT '[]' COMMENT '活动列表',
  PRIMARY KEY (`player_id`,`daytype`),
  KEY `player_id` (`player_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='资源找回';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `resource_back`
--

LOCK TABLES `resource_back` WRITE;
/*!40000 ALTER TABLE `resource_back` DISABLE KEYS */;
/*!40000 ALTER TABLE `resource_back` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `role_3v3`
--

DROP TABLE IF EXISTS `role_3v3`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `role_3v3` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `old_tier` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '昨天段位',
  `old_star` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '昨天星数',
  `tier` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '段位',
  `star` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '星数',
  `continued_win` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '连胜次数',
  `daily_win` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '每日胜利场次',
  `daily_pk` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '每日战斗场次',
  `daily_honor` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '每日可得荣誉值',
  `pack_reward` varchar(1000) NOT NULL DEFAULT '[{1, 0}, {2, 0}, {3, 0}]' COMMENT '领取胜利场次奖励字段',
  `pack_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '今日领取荣誉时间',
  `daily_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '日刷新时间',
  `season_pk` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '本赛季战斗次数',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服3v3 玩家信息';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `role_3v3`
--

LOCK TABLES `role_3v3` WRITE;
/*!40000 ALTER TABLE `role_3v3` DISABLE KEYS */;
/*!40000 ALTER TABLE `role_3v3` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `role_drum`
--

DROP TABLE IF EXISTS `role_drum`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `role_drum` (
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `drumid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '届id',
  `one` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '是否冠军',
  `zone` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战区',
  `action` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '场次',
  `deal` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '有效时间',
  `choice` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '竞猜列表',
  `pay_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最后充值时间',
  PRIMARY KEY (`rid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家擂台赛数据';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `role_drum`
--

LOCK TABLES `role_drum` WRITE;
/*!40000 ALTER TABLE `role_drum` DISABLE KEYS */;
/*!40000 ALTER TABLE `role_drum` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `role_home_build`
--

DROP TABLE IF EXISTS `role_home_build`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `role_home_build` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `build_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '建筑类型',
  `build_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '建筑等级',
  `upgrade_endtime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '升级时间戳',
  `collect_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '可采集时间',
  `resource_left` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '可采集数量',
  `refresh_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '计算刷新时间',
  `extra_data` varchar(255) NOT NULL DEFAULT '[]' COMMENT '额外数据',
  PRIMARY KEY (`role_id`,`build_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='家园建筑';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `role_home_build`
--

LOCK TABLES `role_home_build` WRITE;
/*!40000 ALTER TABLE `role_home_build` DISABLE KEYS */;
/*!40000 ALTER TABLE `role_home_build` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `role_home_dispatch_task`
--

DROP TABLE IF EXISTS `role_home_dispatch_task`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `role_home_dispatch_task` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `task_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '任务id',
  `baby_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT '出战宝宝',
  `state` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '任务状态',
  `reward` varchar(512) NOT NULL DEFAULT '[]' COMMENT '奖励内容',
  `end_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '任务结束时间',
  PRIMARY KEY (`role_id`,`task_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='家园派遣任务表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `role_home_dispatch_task`
--

LOCK TABLES `role_home_dispatch_task` WRITE;
/*!40000 ALTER TABLE `role_home_dispatch_task` DISABLE KEYS */;
/*!40000 ALTER TABLE `role_home_dispatch_task` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `role_home_furniture`
--

DROP TABLE IF EXISTS `role_home_furniture`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `role_home_furniture` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '家具唯一id',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '家具id',
  `owner_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '家具拥有者',
  `map_id` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '地图id',
  `scene_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '场景id',
  `x` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'x坐标',
  `y` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'y坐标',
  `face` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '面向',
  `rotate` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '旋转角度',
  PRIMARY KEY (`role_id`,`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='家园家具列表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `role_home_furniture`
--

LOCK TABLES `role_home_furniture` WRITE;
/*!40000 ALTER TABLE `role_home_furniture` DISABLE KEYS */;
/*!40000 ALTER TABLE `role_home_furniture` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `role_home_furniture_num`
--

DROP TABLE IF EXISTS `role_home_furniture_num`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `role_home_furniture_num` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家Id',
  `goods_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '家具id',
  `total` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '家具拥有总数量',
  `left_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '当前剩余数量',
  PRIMARY KEY (`role_id`,`goods_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家拥有的家具数量';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `role_home_furniture_num`
--

LOCK TABLES `role_home_furniture_num` WRITE;
/*!40000 ALTER TABLE `role_home_furniture_num` DISABLE KEYS */;
/*!40000 ALTER TABLE `role_home_furniture_num` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `role_home_info`
--

DROP TABLE IF EXISTS `role_home_info`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `role_home_info` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `home_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '家园id',
  `share_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '家园等级',
  `wood_coin` int(20) unsigned NOT NULL DEFAULT '0' COMMENT '木材数量',
  `iron_coin` int(20) unsigned NOT NULL DEFAULT '0' COMMENT '铁数量',
  `stone_coin` int(20) unsigned NOT NULL DEFAULT '0' COMMENT '石数量',
  `home_coin` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '家园币数量',
  `up_line` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '购买升级队列数',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='家园玩家表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `role_home_info`
--

LOCK TABLES `role_home_info` WRITE;
/*!40000 ALTER TABLE `role_home_info` DISABLE KEYS */;
/*!40000 ALTER TABLE `role_home_info` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `role_home_pic`
--

DROP TABLE IF EXISTS `role_home_pic`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `role_home_pic` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `pic_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '图鉴id',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  PRIMARY KEY (`role_id`,`pic_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='家园图鉴表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `role_home_pic`
--

LOCK TABLES `role_home_pic` WRITE;
/*!40000 ALTER TABLE `role_home_pic` DISABLE KEYS */;
/*!40000 ALTER TABLE `role_home_pic` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `role_home_task`
--

DROP TABLE IF EXISTS `role_home_task`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `role_home_task` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `task_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '任务id',
  `task_state` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '状态',
  `achieve` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '完成数量',
  PRIMARY KEY (`role_id`,`task_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='家园主线任务';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `role_home_task`
--

LOCK TABLES `role_home_task` WRITE;
/*!40000 ALTER TABLE `role_home_task` DISABLE KEYS */;
/*!40000 ALTER TABLE `role_home_task` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `role_home_temp_up_line`
--

DROP TABLE IF EXISTS `role_home_temp_up_line`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `role_home_temp_up_line` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `good_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品id',
  `end_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '结束时间',
  PRIMARY KEY (`role_id`,`good_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='家园临时升级队列表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `role_home_temp_up_line`
--

LOCK TABLES `role_home_temp_up_line` WRITE;
/*!40000 ALTER TABLE `role_home_temp_up_line` DISABLE KEYS */;
/*!40000 ALTER TABLE `role_home_temp_up_line` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `role_kf_invade`
--

DROP TABLE IF EXISTS `role_kf_invade`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `role_kf_invade` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `score` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '积分',
  `act_score_list` varchar(256) NOT NULL DEFAULT '[]' COMMENT '行为积分列表',
  `stage_list` varchar(256) NOT NULL DEFAULT '[]' COMMENT '已领取阶段列表',
  `score_uptime` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '积分改变时间',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服入侵玩家信息';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `role_kf_invade`
--

LOCK TABLES `role_kf_invade` WRITE;
/*!40000 ALTER TABLE `role_kf_invade` DISABLE KEYS */;
/*!40000 ALTER TABLE `role_kf_invade` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `role_kf_invade_task`
--

DROP TABLE IF EXISTS `role_kf_invade_task`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `role_kf_invade_task` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `task_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '任务ID',
  `task_status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '任务状态',
  `finish_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '数量',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '接取时间',
  PRIMARY KEY (`role_id`,`task_id`),
  KEY `task_status` (`task_status`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服入侵玩家任务信息';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `role_kf_invade_task`
--

LOCK TABLES `role_kf_invade_task` WRITE;
/*!40000 ALTER TABLE `role_kf_invade_task` DISABLE KEYS */;
/*!40000 ALTER TABLE `role_kf_invade_task` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `role_live_skill`
--

DROP TABLE IF EXISTS `role_live_skill`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `role_live_skill` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `skill_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能类型',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `exp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '经验',
  PRIMARY KEY (`role_id`,`skill_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='生活技能表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `role_live_skill`
--

LOCK TABLES `role_live_skill` WRITE;
/*!40000 ALTER TABLE `role_live_skill` DISABLE KEYS */;
/*!40000 ALTER TABLE `role_live_skill` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `role_live_skill_info`
--

DROP TABLE IF EXISTS `role_live_skill_info`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `role_live_skill_info` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `cook_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT '激活食谱',
  `equip_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT '打造纸激活类型',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='生活技能记录表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `role_live_skill_info`
--

LOCK TABLES `role_live_skill_info` WRITE;
/*!40000 ALTER TABLE `role_live_skill_info` DISABLE KEYS */;
/*!40000 ALTER TABLE `role_live_skill_info` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `role_onhook`
--

DROP TABLE IF EXISTS `role_onhook`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `role_onhook` (
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `onhook_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '剩余挂机时间',
  `reward_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '待结算的挂机奖励时长(s)',
  `exp_reward_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '待结算的挂机奖励时长(s)',
  `uplv_exp` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '已获得挂机升级累计经验',
  `onhook_setting` varchar(255) NOT NULL DEFAULT '[]' COMMENT '挂机设置[{k,v}]',
  PRIMARY KEY (`player_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家挂机';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `role_onhook`
--

LOCK TABLES `role_onhook` WRITE;
/*!40000 ALTER TABLE `role_onhook` DISABLE KEYS */;
/*!40000 ALTER TABLE `role_onhook` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `role_star_shadow`
--

DROP TABLE IF EXISTS `role_star_shadow`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `role_star_shadow` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `star_shadow` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '装备中的星痕',
  `mold_soul` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '铸魂状态',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家星痕铸魂状态(合服直接合并)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `role_star_shadow`
--

LOCK TABLES `role_star_shadow` WRITE;
/*!40000 ALTER TABLE `role_star_shadow` DISABLE KEYS */;
/*!40000 ALTER TABLE `role_star_shadow` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `rune_skill`
--

DROP TABLE IF EXISTS `rune_skill`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `rune_skill` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `skill_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '技能id',
  `lv` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '技能等级',
  PRIMARY KEY (`role_id`,`skill_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家符文技能';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `rune_skill`
--

LOCK TABLES `rune_skill` WRITE;
/*!40000 ALTER TABLE `rune_skill` DISABLE KEYS */;
/*!40000 ALTER TABLE `rune_skill` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `rush_giftbag`
--

DROP TABLE IF EXISTS `rush_giftbag`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `rush_giftbag` (
  `player_id` bigint(20) NOT NULL COMMENT '用户id',
  `giftbag_state` varchar(1024) NOT NULL COMMENT '礼包状态',
  PRIMARY KEY (`player_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='用户冲级礼包信息';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `rush_giftbag`
--

LOCK TABLES `rush_giftbag` WRITE;
/*!40000 ALTER TABLE `rush_giftbag` DISABLE KEYS */;
/*!40000 ALTER TABLE `rush_giftbag` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `rush_rank_goal`
--

DROP TABLE IF EXISTS `rush_rank_goal`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `rush_rank_goal` (
  `rank_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排行榜类型',
  `sub_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动类型',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `goal_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励Id',
  `state` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '领取状态(1 可领 0 不可领)',
  PRIMARY KEY (`rank_type`,`sub_type`,`player_id`,`goal_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='开服冲榜目标奖励领取状态';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `rush_rank_goal`
--

LOCK TABLES `rush_rank_goal` WRITE;
/*!40000 ALTER TABLE `rush_rank_goal` DISABLE KEYS */;
/*!40000 ALTER TABLE `rush_rank_goal` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `rush_rank_role`
--

DROP TABLE IF EXISTS `rush_rank_role`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `rush_rank_role` (
  `rank_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排行榜类型',
  `sub_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动类型',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '值',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  UNIQUE KEY `rank` (`player_id`,`rank_type`,`sub_type`) USING BTREE,
  KEY `value` (`value`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='开服冲榜活动';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `rush_rank_role`
--

LOCK TABLES `rush_rank_role` WRITE;
/*!40000 ALTER TABLE `rush_rank_role` DISABLE KEYS */;
/*!40000 ALTER TABLE `rush_rank_role` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `seal_soul`
--

DROP TABLE IF EXISTS `seal_soul`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `seal_soul` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `period_times` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '周期内抽奖次数',
  `rewards_state` varchar(128) NOT NULL DEFAULT '[]' COMMENT '奖励状态',
  `progress` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '奖励进度',
  `last_week_time` int(11) NOT NULL DEFAULT '0' COMMENT '上次更新的周一零点',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='魂珠';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `seal_soul`
--

LOCK TABLES `seal_soul` WRITE;
/*!40000 ALTER TABLE `seal_soul` DISABLE KEYS */;
/*!40000 ALTER TABLE `seal_soul` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sell_list`
--

DROP TABLE IF EXISTS `sell_list`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sell_list` (
  `id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '交易id',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '出售玩家id',
  `sell_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '出售类型',
  `specify_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '指定交易玩家id',
  `gtype_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型id',
  `category` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '商品大类',
  `sub_category` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '商品子类',
  `goods_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '出售数量',
  `unit_price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '出售单价',
  `extra_attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '特殊属性',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上架时间戳',
  PRIMARY KEY (`id`),
  KEY `player_id` (`sub_category`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='交易商品信息';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sell_list`
--

LOCK TABLES `sell_list` WRITE;
/*!40000 ALTER TABLE `sell_list` DISABLE KEYS */;
/*!40000 ALTER TABLE `sell_list` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sell_record`
--

DROP TABLE IF EXISTS `sell_record`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sell_record` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '记录id',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '出售玩家id',
  `buyer_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '购买玩家id',
  `sell_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '出售类型',
  `gtype_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '物品类型id',
  `goods_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '出售数量',
  `unit_price` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '出售单价',
  `tax` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '交易税',
  `extra_attr` varchar(255) NOT NULL DEFAULT '[]' COMMENT '特殊属性',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '交易时间戳',
  PRIMARY KEY (`id`),
  KEY `time` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='市场交易记录';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sell_record`
--

LOCK TABLES `sell_record` WRITE;
/*!40000 ALTER TABLE `sell_record` DISABLE KEYS */;
/*!40000 ALTER TABLE `sell_record` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `server`
--

DROP TABLE IF EXISTS `server`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `server` (
  `type` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '类型（1合服时间）',
  `args` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '参数',
  PRIMARY KEY (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='服务器信息表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `server`
--

LOCK TABLES `server` WRITE;
/*!40000 ALTER TABLE `server` DISABLE KEYS */;
/*!40000 ALTER TABLE `server` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `server_info`
--

DROP TABLE IF EXISTS `server_info`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `server_info` (
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器id',
  `platform` varchar(50) NOT NULL COMMENT '平台标识',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '所在的服标示',
  PRIMARY KEY (`server_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='服务器信息';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `server_info`
--

LOCK TABLES `server_info` WRITE;
/*!40000 ALTER TABLE `server_info` DISABLE KEYS */;
/*!40000 ALTER TABLE `server_info` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `server_kv`
--

DROP TABLE IF EXISTS `server_kv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `server_kv` (
  `key` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'KEY',
  `value` varchar(1024) NOT NULL COMMENT 'VALUE',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间戳',
  PRIMARY KEY (`key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='服务器KEY_VALUE表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `server_kv`
--

LOCK TABLES `server_kv` WRITE;
/*!40000 ALTER TABLE `server_kv` DISABLE KEYS */;
/*!40000 ALTER TABLE `server_kv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `server_top_n_processes`
--

DROP TABLE IF EXISTS `server_top_n_processes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `server_top_n_processes` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'Id',
  `top_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT 'top类型',
  `pid` varchar(128) NOT NULL COMMENT '进程pid',
  `attr_value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'Attr值',
  `registered_name` varchar(256) NOT NULL COMMENT '注册名',
  `current_function` varchar(512) NOT NULL COMMENT '当前方法',
  `initial_call` varchar(512) NOT NULL COMMENT '初始化方法',
  PRIMARY KEY (`id`,`top_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='服务器topN进程表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `server_top_n_processes`
--

LOCK TABLES `server_top_n_processes` WRITE;
/*!40000 ALTER TABLE `server_top_n_processes` DISABLE KEYS */;
/*!40000 ALTER TABLE `server_top_n_processes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `server_watchdog`
--

DROP TABLE IF EXISTS `server_watchdog`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `server_watchdog` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '监控ID',
  `value` varchar(1024) NOT NULL COMMENT '监控VALUE',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='看门狗服务表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `server_watchdog`
--

LOCK TABLES `server_watchdog` WRITE;
/*!40000 ALTER TABLE `server_watchdog` DISABLE KEYS */;
/*!40000 ALTER TABLE `server_watchdog` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `server_zone`
--

DROP TABLE IF EXISTS `server_zone`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `server_zone` (
  `zone_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '分区类型',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器id',
  `zone` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '区域id',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '开服时间',
  `world_lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '世界等级',
  `merge_ids` text NOT NULL COMMENT '合服id列表',
  PRIMARY KEY (`zone_type`,`server_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='跨服分区表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `server_zone`
--

LOCK TABLES `server_zone` WRITE;
/*!40000 ALTER TABLE `server_zone` DISABLE KEYS */;
/*!40000 ALTER TABLE `server_zone` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `share_gift`
--

DROP TABLE IF EXISTS `share_gift`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `share_gift` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `times` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '总分享次数',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '状态',
  `last_receive_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最后领取时间',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='分享有礼';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `share_gift`
--

LOCK TABLES `share_gift` WRITE;
/*!40000 ALTER TABLE `share_gift` DISABLE KEYS */;
/*!40000 ALTER TABLE `share_gift` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `skill`
--

DROP TABLE IF EXISTS `skill`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `skill` (
  `id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `skill_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '技能ID',
  `lv` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  UNIQUE KEY `id_2` (`id`,`skill_id`),
  KEY `skill_id` (`skill_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='技能';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `skill`
--

LOCK TABLES `skill` WRITE;
/*!40000 ALTER TABLE `skill` DISABLE KEYS */;
/*!40000 ALTER TABLE `skill` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sp_shop_buy`
--

DROP TABLE IF EXISTS `sp_shop_buy`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sp_shop_buy` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商店类型',
  `sell_list` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '商品列表',
  `buy_list` varchar(255) NOT NULL DEFAULT '[]' COMMENT '已购买列表',
  PRIMARY KEY (`role_id`,`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='黑市商店玩家购买记录表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sp_shop_buy`
--

LOCK TABLES `sp_shop_buy` WRITE;
/*!40000 ALTER TABLE `sp_shop_buy` DISABLE KEYS */;
/*!40000 ALTER TABLE `sp_shop_buy` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sp_shop_goods`
--

DROP TABLE IF EXISTS `sp_shop_goods`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sp_shop_goods` (
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商店类型',
  `career` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '职业',
  `sell_list` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '商品列表',
  `last_sell_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '刷新时间',
  PRIMARY KEY (`type`,`career`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='黑市商店商品表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sp_shop_goods`
--

LOCK TABLES `sp_shop_goods` WRITE;
/*!40000 ALTER TABLE `sp_shop_goods` DISABLE KEYS */;
/*!40000 ALTER TABLE `sp_shop_goods` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sp_shop_role`
--

DROP TABLE IF EXISTS `sp_shop_role`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sp_shop_role` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '商店类型',
  `hit_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '手动刷新次数',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '刷新时间',
  PRIMARY KEY (`role_id`,`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='黑市商店玩家手动刷新表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sp_shop_role`
--

LOCK TABLES `sp_shop_role` WRITE;
/*!40000 ALTER TABLE `sp_shop_role` DISABLE KEYS */;
/*!40000 ALTER TABLE `sp_shop_role` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `spec_sell_act`
--

DROP TABLE IF EXISTS `spec_sell_act`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `spec_sell_act` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `sub_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '子类型',
  `lv_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '到达配置等级时的时间戳',
  PRIMARY KEY (`role_id`,`sub_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='精品特卖活动信息';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `spec_sell_act`
--

LOCK TABLES `spec_sell_act` WRITE;
/*!40000 ALTER TABLE `spec_sell_act` DISABLE KEYS */;
/*!40000 ALTER TABLE `spec_sell_act` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sql_version`
--

DROP TABLE IF EXISTS `sql_version`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sql_version` (
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '版本类型',
  `version` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '版本号',
  PRIMARY KEY (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='数据库版本信息表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sql_version`
--

LOCK TABLES `sql_version` WRITE;
/*!40000 ALTER TABLE `sql_version` DISABLE KEYS */;
/*!40000 ALTER TABLE `sql_version` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `star_soul_drum_rank`
--

DROP TABLE IF EXISTS `star_soul_drum_rank`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `star_soul_drum_rank` (
  `drumid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT 'id',
  `zone` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战区',
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '玩家名称',
  `gname` varchar(50) NOT NULL DEFAULT '' COMMENT '帮派名称',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器id',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '平台id',
  `rank` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '名次',
  `vip` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家VIP',
  `power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '玩家战力',
  `career` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '职业',
  PRIMARY KEY (`drumid`,`zone`,`rid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星灵争霸榜单';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `star_soul_drum_rank`
--

LOCK TABLES `star_soul_drum_rank` WRITE;
/*!40000 ALTER TABLE `star_soul_drum_rank` DISABLE KEYS */;
/*!40000 ALTER TABLE `star_soul_drum_rank` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `star_soul_drum_role`
--

DROP TABLE IF EXISTS `star_soul_drum_role`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `star_soul_drum_role` (
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `drumid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '届id',
  `one` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '是否冠军',
  `zone` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战区',
  `action` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '场次',
  `deal` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '有效时间',
  `choice` varchar(1000) NOT NULL DEFAULT '[]' COMMENT '竞猜列表',
  `pay_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最后充值时间',
  PRIMARY KEY (`rid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家星灵争霸数据';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `star_soul_drum_role`
--

LOCK TABLES `star_soul_drum_role` WRITE;
/*!40000 ALTER TABLE `star_soul_drum_role` DISABLE KEYS */;
/*!40000 ALTER TABLE `star_soul_drum_role` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `star_soul_drum_sign`
--

DROP TABLE IF EXISTS `star_soul_drum_sign`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `star_soul_drum_sign` (
  `rid` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器id',
  `server_num` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '平台id',
  `drumid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '届id',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '名字',
  `picturev` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '头像版号',
  `turn` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '转生等级',
  `lv` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '等级',
  `career` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '职业',
  `power` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '战力',
  PRIMARY KEY (`rid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星灵争霸报名';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `star_soul_drum_sign`
--

LOCK TABLES `star_soul_drum_sign` WRITE;
/*!40000 ALTER TABLE `star_soul_drum_sign` DISABLE KEYS */;
/*!40000 ALTER TABLE `star_soul_drum_sign` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `star_soul_equip`
--

DROP TABLE IF EXISTS `star_soul_equip`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `star_soul_equip` (
  `role_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '玩家id',
  `star_soul_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '星灵id',
  `pos_to_cell` varchar(255) NOT NULL DEFAULT '[]' COMMENT '穿戴装备的格子位置',
  PRIMARY KEY (`role_id`,`star_soul_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星灵装备';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `star_soul_equip`
--

LOCK TABLES `star_soul_equip` WRITE;
/*!40000 ALTER TABLE `star_soul_equip` DISABLE KEYS */;
/*!40000 ALTER TABLE `star_soul_equip` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `star_soul_treasure`
--

DROP TABLE IF EXISTS `star_soul_treasure`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `star_soul_treasure` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `time_stamp` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '免费抽奖时间戳',
  `integral` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '抽奖积分',
  `lucky_draw_times` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '累积抽奖次数',
  `limit_times_list` varchar(1024) NOT NULL DEFAULT '[]' COMMENT '奖励物品的限制抽取记录',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星灵宝箱信息';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `star_soul_treasure`
--

LOCK TABLES `star_soul_treasure` WRITE;
/*!40000 ALTER TABLE `star_soul_treasure` DISABLE KEYS */;
/*!40000 ALTER TABLE `star_soul_treasure` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `star_soul_war`
--

DROP TABLE IF EXISTS `star_soul_war`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `star_soul_war` (
  `id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '序号',
  `level_list` text NOT NULL COMMENT '关卡随机副本',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='星灵试炼随机副本表(合服保留一条数据)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `star_soul_war`
--

LOCK TABLES `star_soul_war` WRITE;
/*!40000 ALTER TABLE `star_soul_war` DISABLE KEYS */;
/*!40000 ALTER TABLE `star_soul_war` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `supplication`
--

DROP TABLE IF EXISTS `supplication`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `supplication` (
  `role_id` bigint(10) unsigned NOT NULL COMMENT '角色id',
  `sub_type` smallint(10) unsigned NOT NULL COMMENT '活动子类型',
  `self_log` varchar(255) NOT NULL COMMENT '抽奖记录[奖励ID]',
  `select_reward` varchar(255) NOT NULL COMMENT '已选择奖励列表[{奖励等级,[奖励ID]}]',
  `count` int(10) unsigned NOT NULL COMMENT '已抽奖次数',
  `counter` varchar(255) NOT NULL DEFAULT '[]' COMMENT '抽奖统计列表',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家祈愿数据表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `supplication`
--

LOCK TABLES `supplication` WRITE;
/*!40000 ALTER TABLE `supplication` DISABLE KEYS */;
/*!40000 ALTER TABLE `supplication` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `supplication_broadcast`
--

DROP TABLE IF EXISTS `supplication_broadcast`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `supplication_broadcast` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(10) unsigned NOT NULL COMMENT '角色id',
  `role_name` varchar(255) NOT NULL COMMENT '角色名字',
  `server_num` smallint(5) unsigned NOT NULL COMMENT '服务器标识',
  `reward_id` smallint(5) unsigned NOT NULL COMMENT '奖励ID',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='祈愿广播数据表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `supplication_broadcast`
--

LOCK TABLES `supplication_broadcast` WRITE;
/*!40000 ALTER TABLE `supplication_broadcast` DISABLE KEYS */;
/*!40000 ALTER TABLE `supplication_broadcast` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `supplication_counter`
--

DROP TABLE IF EXISTS `supplication_counter`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `supplication_counter` (
  `reward_lv` tinyint(2) unsigned NOT NULL COMMENT '奖励等级',
  `count` int(10) unsigned NOT NULL COMMENT '抽到奖励后抽取次数',
  `reward_count` int(10) unsigned NOT NULL COMMENT '获得该奖励等级次数',
  PRIMARY KEY (`reward_lv`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='祈愿-全服玩家抽奖统计';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `supplication_counter`
--

LOCK TABLES `supplication_counter` WRITE;
/*!40000 ALTER TABLE `supplication_counter` DISABLE KEYS */;
/*!40000 ALTER TABLE `supplication_counter` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `supplication_task`
--

DROP TABLE IF EXISTS `supplication_task`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `supplication_task` (
  `role_id` bigint(10) unsigned NOT NULL COMMENT '角色id',
  `task_id` int(10) unsigned NOT NULL COMMENT '任务id',
  `sub_type` smallint(10) unsigned NOT NULL COMMENT '活动子类型',
  `progress` int(10) unsigned NOT NULL COMMENT '任务进度',
  `extra` varchar(512) NOT NULL COMMENT '额外记录',
  `task_status` tinyint(1) unsigned NOT NULL COMMENT '任务状态（0未完成1已完成2已领取）',
  `time` int(10) unsigned NOT NULL COMMENT '任务开始时间',
  PRIMARY KEY (`role_id`,`task_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家祈愿任务完成数据表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `supplication_task`
--

LOCK TABLES `supplication_task` WRITE;
/*!40000 ALTER TABLE `supplication_task` DISABLE KEYS */;
/*!40000 ALTER TABLE `supplication_task` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sync_config_status`
--

DROP TABLE IF EXISTS `sync_config_status`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sync_config_status` (
  `cf_name` varchar(128) NOT NULL DEFAULT '' COMMENT '配置名称',
  `cf_status` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '配置状态',
  PRIMARY KEY (`cf_name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='开发环境配置同步状态表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sync_config_status`
--

LOCK TABLES `sync_config_status` WRITE;
/*!40000 ALTER TABLE `sync_config_status` DISABLE KEYS */;
/*!40000 ALTER TABLE `sync_config_status` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_env`
--

DROP TABLE IF EXISTS `sys_env`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sys_env` (
  `type` varchar(255) NOT NULL COMMENT '键名',
  `value` mediumtext NOT NULL COMMENT '值',
  PRIMARY KEY (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='系统变量数据，合服保留主服';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_env`
--

LOCK TABLES `sys_env` WRITE;
/*!40000 ALTER TABLE `sys_env` DISABLE KEYS */;
/*!40000 ALTER TABLE `sys_env` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `talent_skill`
--

DROP TABLE IF EXISTS `talent_skill`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `talent_skill` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `skill_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '技能id',
  `lv` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '技能等级',
  PRIMARY KEY (`role_id`,`skill_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家天赋技能';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `talent_skill`
--

LOCK TABLES `talent_skill` WRITE;
/*!40000 ALTER TABLE `talent_skill` DISABLE KEYS */;
/*!40000 ALTER TABLE `talent_skill` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `task_bag`
--

DROP TABLE IF EXISTS `task_bag`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `task_bag` (
  `role_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '角色id',
  `task_id` int(11) NOT NULL DEFAULT '0' COMMENT '任务id',
  `trigger_time` int(11) NOT NULL DEFAULT '0' COMMENT '触发时间',
  `state` smallint(5) NOT NULL DEFAULT '0' COMMENT '任务状态',
  `end_state` smallint(5) NOT NULL DEFAULT '0' COMMENT '结束状态',
  `mark` varchar(2000) NOT NULL DEFAULT '[]' COMMENT '任务步骤记录',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `lv` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '玩家等级',
  PRIMARY KEY (`role_id`,`task_id`),
  KEY `task_id` (`task_id`),
  KEY `type` (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='角色任务';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `task_bag`
--

LOCK TABLES `task_bag` WRITE;
/*!40000 ALTER TABLE `task_bag` DISABLE KEYS */;
/*!40000 ALTER TABLE `task_bag` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `task_log`
--

DROP TABLE IF EXISTS `task_log`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `task_log` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色id',
  `task_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '任务id',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `trigger_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '接受时间',
  `finish_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '完成时间',
  PRIMARY KEY (`id`),
  KEY `role_task_id` (`role_id`,`task_id`),
  KEY `task_id` (`task_id`),
  KEY `type` (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='角色任务日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `task_log`
--

LOCK TABLES `task_log` WRITE;
/*!40000 ALTER TABLE `task_log` DISABLE KEYS */;
/*!40000 ALTER TABLE `task_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `task_log_clear`
--

DROP TABLE IF EXISTS `task_log_clear`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `task_log_clear` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '序号',
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '角色id',
  `task_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '任务id',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '类型',
  `trigger_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '接受时间',
  `finish_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '完成时间',
  `count` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '悬赏和公会周任务记录次数',
  PRIMARY KEY (`id`),
  KEY `role_task_id` (`role_id`,`task_id`),
  KEY `task_id` (`task_id`),
  KEY `type` (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='角色可清除任务日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `task_log_clear`
--

LOCK TABLES `task_log_clear` WRITE;
/*!40000 ALTER TABLE `task_log_clear` DISABLE KEYS */;
/*!40000 ALTER TABLE `task_log_clear` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `top_pk_rank_center`
--

DROP TABLE IF EXISTS `top_pk_rank_center`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `top_pk_rank_center` (
  `role_id` bigint(20) unsigned NOT NULL,
  `role_name` varchar(50) NOT NULL COMMENT '玩家名',
  `career` tinyint(3) unsigned NOT NULL COMMENT '职业',
  `power` int(10) unsigned NOT NULL COMMENT '战力',
  `platform` varchar(50) NOT NULL COMMENT '平台',
  `server_num` smallint(5) unsigned NOT NULL COMMENT '服务器编号',
  `server_id` int(10) unsigned NOT NULL COMMENT '服务器id',
  `score` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '赛季积分',
  `pk_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上次PK时间',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='巅峰竞技排行榜（跨服）';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `top_pk_rank_center`
--

LOCK TABLES `top_pk_rank_center` WRITE;
/*!40000 ALTER TABLE `top_pk_rank_center` DISABLE KEYS */;
/*!40000 ALTER TABLE `top_pk_rank_center` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `treasure`
--

DROP TABLE IF EXISTS `treasure`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `treasure` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `expedition_guardian` varchar(255) NOT NULL DEFAULT '[]' COMMENT '秘境远征宝藏守护id',
  `mine_guardian` varchar(255) NOT NULL DEFAULT '[]' COMMENT '金币矿洞宝藏守护id',
  `exp_library_guardian` varchar(255) NOT NULL DEFAULT '[]' COMMENT '经验书馆宝藏守护id',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='宝藏系统';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `treasure`
--

LOCK TABLES `treasure` WRITE;
/*!40000 ALTER TABLE `treasure` DISABLE KEYS */;
/*!40000 ALTER TABLE `treasure` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `treasure_evaluation_lucky_num`
--

DROP TABLE IF EXISTS `treasure_evaluation_lucky_num`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `treasure_evaluation_lucky_num` (
  `role_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `sub_type` int(11) unsigned NOT NULL COMMENT '子类型',
  `choose_big_reward_id` int(11) unsigned NOT NULL COMMENT '选择的大奖id',
  `lucky_num` int(11) unsigned NOT NULL COMMENT '幸运值',
  `time` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`role_id`,`sub_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='幸运鉴宝幸运值记录表（合服合并）';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `treasure_evaluation_lucky_num`
--

LOCK TABLES `treasure_evaluation_lucky_num` WRITE;
/*!40000 ALTER TABLE `treasure_evaluation_lucky_num` DISABLE KEYS */;
/*!40000 ALTER TABLE `treasure_evaluation_lucky_num` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `treasure_guardians`
--

DROP TABLE IF EXISTS `treasure_guardians`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `treasure_guardians` (
  `role_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT COMMENT '玩家id',
  `guardian_id` int(11) NOT NULL DEFAULT '0' COMMENT '守护id',
  `guardian_time` int(11) NOT NULL DEFAULT '0' COMMENT '到期时间',
  `goods_id` bigint(20) NOT NULL DEFAULT '0' COMMENT '物品id',
  PRIMARY KEY (`role_id`,`guardian_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='玩家宝藏守护';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `treasure_guardians`
--

LOCK TABLES `treasure_guardians` WRITE;
/*!40000 ALTER TABLE `treasure_guardians` DISABLE KEYS */;
/*!40000 ALTER TABLE `treasure_guardians` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `treasure_hunt_lucky`
--

DROP TABLE IF EXISTS `treasure_hunt_lucky`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `treasure_hunt_lucky` (
  `id` tinyint(3) unsigned NOT NULL COMMENT '幸运值id',
  `lucky` smallint(5) unsigned NOT NULL COMMENT '已累计幸运值',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='寻宝幸运值（合服时直接清空）';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `treasure_hunt_lucky`
--

LOCK TABLES `treasure_hunt_lucky` WRITE;
/*!40000 ALTER TABLE `treasure_hunt_lucky` DISABLE KEYS */;
/*!40000 ALTER TABLE `treasure_hunt_lucky` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `treasure_hunt_reward`
--

DROP TABLE IF EXISTS `treasure_hunt_reward`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `treasure_hunt_reward` (
  `htype` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '寻宝类型',
  `stype` smallint(2) unsigned NOT NULL DEFAULT '0' COMMENT '宝物类型',
  `obj_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '限制对象id 全服限制为0 玩家限制为玩家id',
  `obtain_times` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '获得次数',
  `all_times` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '总抽取次数',
  PRIMARY KEY (`htype`,`stype`,`obj_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='寻宝奖励统计(合服清理)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `treasure_hunt_reward`
--

LOCK TABLES `treasure_hunt_reward` WRITE;
/*!40000 ALTER TABLE `treasure_hunt_reward` DISABLE KEYS */;
/*!40000 ALTER TABLE `treasure_hunt_reward` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `treasure_hunt_times`
--

DROP TABLE IF EXISTS `treasure_hunt_times`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `treasure_hunt_times` (
  `htype` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '寻宝类型',
  `obj_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '限制对象id 全服限制为0 玩家限制为玩家id',
  `htimes` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '寻宝次数',
  PRIMARY KEY (`htype`,`obj_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='寻宝次数统计(合服清理)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `treasure_hunt_times`
--

LOCK TABLES `treasure_hunt_times` WRITE;
/*!40000 ALTER TABLE `treasure_hunt_times` DISABLE KEYS */;
/*!40000 ALTER TABLE `treasure_hunt_times` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `version_upgradebag`
--

DROP TABLE IF EXISTS `version_upgradebag`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `version_upgradebag` (
  `player_id` bigint(20) unsigned NOT NULL COMMENT '玩家id',
  `version_code` int(10) unsigned NOT NULL COMMENT '版本号',
  `time` int(10) unsigned NOT NULL COMMENT '领取时间',
  PRIMARY KEY (`player_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='版本更新礼包';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `version_upgradebag`
--

LOCK TABLES `version_upgradebag` WRITE;
/*!40000 ALTER TABLE `version_upgradebag` DISABLE KEYS */;
/*!40000 ALTER TABLE `version_upgradebag` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `vip_giftbag_state`
--

DROP TABLE IF EXISTS `vip_giftbag_state`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `vip_giftbag_state` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `giftbag_state` varchar(255) NOT NULL DEFAULT '[]' COMMENT '礼包领取状态',
  `week_giftbag_state` varchar(255) NOT NULL DEFAULT '[]' COMMENT '礼包领取状态',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='贵族礼包领取状态';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `vip_giftbag_state`
--

LOCK TABLES `vip_giftbag_state` WRITE;
/*!40000 ALTER TABLE `vip_giftbag_state` DISABLE KEYS */;
/*!40000 ALTER TABLE `vip_giftbag_state` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `vip_role_record`
--

DROP TABLE IF EXISTS `vip_role_record`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `vip_role_record` (
  `role_id` bigint(32) unsigned NOT NULL COMMENT '玩家角色id',
  `vip_lv` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'vip等级',
  `vip_exp` int(20) unsigned NOT NULL DEFAULT '0' COMMENT 'vip经验',
  `vip_endtime` int(20) NOT NULL DEFAULT '0' COMMENT 'vip过期时间',
  `history_gold_remainder` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '消费换算经验余数',
  `total_cost_gold` int(20) unsigned NOT NULL DEFAULT '0' COMMENT '成为vip期间的消费总数',
  `is_honor` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '是否激活荣耀vip',
  `honor_coin` varchar(255) NOT NULL DEFAULT '{0, 0}' COMMENT '{至尊币, 最后更新时间}',
  `honor_endtime` int(20) unsigned NOT NULL COMMENT '体验荣耀到期时间',
  `honor_recharge` varchar(255) NOT NULL COMMENT '充值激活荣耀进度',
  PRIMARY KEY (`role_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='角色vip信息记录';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `vip_role_record`
--

LOCK TABLES `vip_role_record` WRITE;
/*!40000 ALTER TABLE `vip_role_record` DISABLE KEYS */;
/*!40000 ALTER TABLE `vip_role_record` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `vip_task_progress`
--

DROP TABLE IF EXISTS `vip_task_progress`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `vip_task_progress` (
  `role_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家id',
  `count_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '计数器id',
  `num` varchar(1024) NOT NULL DEFAULT '0' COMMENT '任务进度,count_id为0时记录已领取任务id列表',
  `update_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最后更新时间',
  PRIMARY KEY (`role_id`,`count_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='vip每日任务进度数据（合服直接合并）';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `vip_task_progress`
--

LOCK TABLES `vip_task_progress` WRITE;
/*!40000 ALTER TABLE `vip_task_progress` DISABLE KEYS */;
/*!40000 ALTER TABLE `vip_task_progress` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `wed_rank_act`
--

DROP TABLE IF EXISTS `wed_rank_act`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `wed_rank_act` (
  `rank_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '排行榜类型',
  `sub_type` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '活动子类型',
  `player_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '玩家ID',
  `sec_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT '伴侣id',
  `value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '值',
  `second_value` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '值保留',
  `time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '时间',
  UNIQUE KEY `rank` (`player_id`,`rank_type`,`time`,`sub_type`) USING BTREE,
  KEY `value` (`value`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='结婚榜活动';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `wed_rank_act`
--

LOCK TABLES `wed_rank_act` WRITE;
/*!40000 ALTER TABLE `wed_rank_act` DISABLE KEYS */;
/*!40000 ALTER TABLE `wed_rank_act` ENABLE KEYS */;
UNLOCK TABLES;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2019-09-10 10:48:06
